%------------------------------------------------------------------------------
% File     : HWV124=1 : TPTP v8.1.0. Released v6.1.0.
% Domain   : Hardware Verification
% Problem  : mcu property 1 cone of influence 5_b50
% Version  : Especial.
% English  : Verification of a property of the SPARCT2 RTL hardware design.

% Refs     : [Kha14] Khasidashvili (2014), Email to Geoff Sutcliffe
% Source   : [Kha14]
% Names    : mcu_prop1_cone5_b50 [Kha14]

% Status   : Theorem
% Rating   : 0.88 v7.5.0, 0.90 v7.4.0, 0.88 v7.3.0, 0.83 v7.0.0, 0.71 v6.4.0, 1.00 v6.3.0, 0.86 v6.2.0, 1.00 v6.1.0
% Syntax   : Number of formulae    : 235538 (2304 unt;93271 typ;   0 def)
%            Number of atoms       : 401916 (  51 equ)
%            Maximal formula atoms :  128 (   1 avg)
%            Number of connectives : 295820 (36171   ~;10837   |;47584   &)
%                                         (158563 <=>;38175  =>;   0  <=;4490 <~>)
%            Maximal formula depth :   66 (   4 avg)
%            Maximal term depth    :    1 (   1 avg)
%            Number arithmetic     : 211988 (36846 atm;   0 fun;156719 num;18423 var)
%            Number of types       :    3 (   1 usr;   1 ari)
%            Number of type conns  : 112433 (93218   >;19215   *;   0   +;   0  <<)
%            Number of predicates  : 93223 (93219 usr;   3 prp; 0-2 aty)
%            Number of functors    :  220 (  51 usr; 220 con; 0-0 aty)
%            Number of variables   : 169275 (169275   !;   0   ?;169275   :)
% SPC      : TF0_THM_EQU_ARI

% Comments : Copyright 2013 Moshe Emmer and Zurab Khasidashvili
%            Licensed under the Apache License, Version 2.0 (the "License");
%            you may not use this file except in compliance with the License.
%            You may obtain a copy of the License at
%                http://www.apache.org/licenses/LICENSE-2.0
%            Unless required by applicable law or agreed to in writing,
%            software distributed under the License is distributed on an "AS
%            IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
%            express or implied. See the License for the specific language
%            governing permissions and limitations under the License.
%------------------------------------------------------------------------------
tff(state_type,type,
    state_type: $tType ).

tff(constB0_type,type,
    constB0: state_type ).

tff(constB1_type,type,
    constB1: state_type ).

tff(constB2_type,type,
    constB2: state_type ).

tff(constB3_type,type,
    constB3: state_type ).

tff(constB4_type,type,
    constB4: state_type ).

tff(constB5_type,type,
    constB5: state_type ).

tff(constB6_type,type,
    constB6: state_type ).

tff(constB7_type,type,
    constB7: state_type ).

tff(constB8_type,type,
    constB8: state_type ).

tff(constB9_type,type,
    constB9: state_type ).

tff(constB10_type,type,
    constB10: state_type ).

tff(constB11_type,type,
    constB11: state_type ).

tff(constB12_type,type,
    constB12: state_type ).

tff(constB13_type,type,
    constB13: state_type ).

tff(constB14_type,type,
    constB14: state_type ).

tff(constB15_type,type,
    constB15: state_type ).

tff(constB16_type,type,
    constB16: state_type ).

tff(constB17_type,type,
    constB17: state_type ).

tff(constB18_type,type,
    constB18: state_type ).

tff(constB19_type,type,
    constB19: state_type ).

tff(constB20_type,type,
    constB20: state_type ).

tff(constB21_type,type,
    constB21: state_type ).

tff(constB22_type,type,
    constB22: state_type ).

tff(constB23_type,type,
    constB23: state_type ).

tff(constB24_type,type,
    constB24: state_type ).

tff(constB25_type,type,
    constB25: state_type ).

tff(constB26_type,type,
    constB26: state_type ).

tff(constB27_type,type,
    constB27: state_type ).

tff(constB28_type,type,
    constB28: state_type ).

tff(func_def_198,type,
    constB29: state_type ).

tff(func_def_199,type,
    constB30: state_type ).

tff(func_def_200,type,
    constB31: state_type ).

tff(func_def_201,type,
    constB32: state_type ).

tff(func_def_202,type,
    constB33: state_type ).

tff(func_def_203,type,
    constB34: state_type ).

tff(func_def_204,type,
    constB35: state_type ).

tff(func_def_205,type,
    constB36: state_type ).

tff(func_def_206,type,
    constB37: state_type ).

tff(func_def_207,type,
    constB38: state_type ).

tff(func_def_208,type,
    constB39: state_type ).

tff(func_def_209,type,
    constB40: state_type ).

tff(func_def_210,type,
    constB41: state_type ).

tff(func_def_211,type,
    constB42: state_type ).

tff(func_def_212,type,
    constB43: state_type ).

tff(func_def_213,type,
    constB44: state_type ).

tff(func_def_214,type,
    constB45: state_type ).

tff(func_def_215,type,
    constB46: state_type ).

tff(func_def_216,type,
    constB47: state_type ).

tff(func_def_217,type,
    constB48: state_type ).

tff(func_def_218,type,
    constB49: state_type ).

tff(func_def_219,type,
    constB50: state_type ).

tff(pred_def_1,type,
    v34: state_type > $o ).

tff(pred_def_2,type,
    v36: state_type > $o ).

tff(pred_def_3,type,
    v32: state_type > $o ).

tff(pred_def_4,type,
    v30: state_type > $o ).

tff(pred_def_5,type,
    v28: state_type > $o ).

tff(pred_def_6,type,
    v26: state_type > $o ).

tff(pred_def_7,type,
    v24: state_type > $o ).

tff(pred_def_8,type,
    v22: state_type > $o ).

tff(pred_def_9,type,
    v20: state_type > $o ).

tff(pred_def_10,type,
    v18: state_type > $o ).

tff(pred_def_11,type,
    v16: state_type > $o ).

tff(pred_def_12,type,
    v14: state_type > $o ).

tff(pred_def_13,type,
    v58: state_type > $o ).

tff(pred_def_14,type,
    v60: state_type > $o ).

tff(pred_def_15,type,
    v56: state_type > $o ).

tff(pred_def_16,type,
    v54: state_type > $o ).

tff(pred_def_17,type,
    v52: state_type > $o ).

tff(pred_def_18,type,
    v50: state_type > $o ).

tff(pred_def_19,type,
    v48: state_type > $o ).

tff(pred_def_20,type,
    v46: state_type > $o ).

tff(pred_def_21,type,
    v44: state_type > $o ).

tff(pred_def_22,type,
    v42: state_type > $o ).

tff(pred_def_23,type,
    v40: state_type > $o ).

tff(pred_def_24,type,
    v38: state_type > $o ).

tff(pred_def_25,type,
    v94: state_type > $o ).

tff(pred_def_26,type,
    v92: state_type > $o ).

tff(pred_def_27,type,
    v90: state_type > $o ).

tff(pred_def_28,type,
    v88: state_type > $o ).

tff(pred_def_29,type,
    v102: state_type > $o ).

tff(pred_def_30,type,
    v100: state_type > $o ).

tff(pred_def_31,type,
    v98: state_type > $o ).

tff(pred_def_32,type,
    v96: state_type > $o ).

tff(pred_def_33,type,
    v150: state_type > $o ).

tff(pred_def_34,type,
    v148: state_type > $o ).

tff(pred_def_35,type,
    v146: state_type > $o ).

tff(pred_def_36,type,
    v144: state_type > $o ).

tff(pred_def_37,type,
    v142: state_type > $o ).

tff(pred_def_38,type,
    v160: state_type > $o ).

tff(pred_def_39,type,
    v158: state_type > $o ).

tff(pred_def_40,type,
    v156: state_type > $o ).

tff(pred_def_41,type,
    v154: state_type > $o ).

tff(pred_def_42,type,
    v152: state_type > $o ).

tff(pred_def_43,type,
    v180: state_type > $o ).

tff(pred_def_44,type,
    v178: state_type > $o ).

tff(pred_def_45,type,
    v184: state_type > $o ).

tff(pred_def_46,type,
    v182: state_type > $o ).

tff(pred_def_47,type,
    v202: ( state_type * $int ) > $o ).

tff(pred_def_48,type,
    v204: ( state_type * $int ) > $o ).

tff(pred_def_49,type,
    v200: state_type > $o ).

tff(pred_def_50,type,
    v198: state_type > $o ).

tff(pred_def_51,type,
    v196: state_type > $o ).

tff(pred_def_52,type,
    v194: state_type > $o ).

tff(pred_def_53,type,
    v192: state_type > $o ).

tff(pred_def_54,type,
    v206: state_type > $o ).

tff(pred_def_55,type,
    v205: ( state_type * $int ) > $o ).

tff(pred_def_56,type,
    v207: ( state_type * $int ) > $o ).

tff(pred_def_58,type,
    v190: ( state_type * $int ) > $o ).

tff(pred_def_59,type,
    v188: ( state_type * $int ) > $o ).

tff(pred_def_60,type,
    v186: ( state_type * $int ) > $o ).

tff(pred_def_61,type,
    v286: state_type > $o ).

tff(pred_def_62,type,
    v319: state_type > $o ).

tff(pred_def_63,type,
    v317: state_type > $o ).

tff(pred_def_64,type,
    v315: state_type > $o ).

tff(pred_def_65,type,
    v313: state_type > $o ).

tff(pred_def_66,type,
    v311: state_type > $o ).

tff(pred_def_67,type,
    v309: state_type > $o ).

tff(pred_def_68,type,
    v326: state_type > $o ).

tff(pred_def_69,type,
    v324: state_type > $o ).

tff(pred_def_70,type,
    v322: state_type > $o ).

tff(pred_def_71,type,
    v328: state_type > $o ).

tff(pred_def_72,type,
    v307: state_type > $o ).

tff(pred_def_73,type,
    v305: state_type > $o ).

tff(pred_def_74,type,
    v303: state_type > $o ).

tff(pred_def_75,type,
    v301: state_type > $o ).

tff(pred_def_76,type,
    v299: state_type > $o ).

tff(pred_def_77,type,
    v297: state_type > $o ).

tff(pred_def_78,type,
    v337: state_type > $o ).

tff(pred_def_79,type,
    v339: state_type > $o ).

tff(pred_def_80,type,
    v371: state_type > $o ).

tff(pred_def_81,type,
    v369: state_type > $o ).

tff(pred_def_82,type,
    v367: state_type > $o ).

tff(pred_def_83,type,
    v365: state_type > $o ).

tff(pred_def_84,type,
    v374: state_type > $o ).

tff(pred_def_85,type,
    v376: state_type > $o ).

tff(pred_def_86,type,
    v363: state_type > $o ).

tff(pred_def_87,type,
    v361: state_type > $o ).

tff(pred_def_88,type,
    v359: state_type > $o ).

tff(pred_def_89,type,
    v357: state_type > $o ).

tff(pred_def_90,type,
    v355: state_type > $o ).

tff(pred_def_91,type,
    v353: state_type > $o ).

tff(pred_def_92,type,
    v383: state_type > $o ).

tff(pred_def_93,type,
    v1: state_type > $o ).

tff(pred_def_94,type,
    v381: state_type > $o ).

tff(pred_def_95,type,
    v379: state_type > $o ).

tff(pred_def_96,type,
    v385: state_type > $o ).

tff(pred_def_97,type,
    v351: state_type > $o ).

tff(pred_def_98,type,
    v349: state_type > $o ).

tff(pred_def_99,type,
    v347: state_type > $o ).

tff(pred_def_100,type,
    v345: state_type > $o ).

tff(pred_def_101,type,
    v343: state_type > $o ).

tff(pred_def_102,type,
    v341: state_type > $o ).

tff(pred_def_103,type,
    v388: state_type > $o ).

tff(pred_def_104,type,
    v390: state_type > $o ).

tff(pred_def_105,type,
    v392: state_type > $o ).

tff(pred_def_106,type,
    nextState: ( state_type * state_type ) > $o ).

tff(pred_def_107,type,
    v404: state_type > $o ).

tff(pred_def_108,type,
    v421: state_type > $o ).

tff(pred_def_109,type,
    v423: state_type > $o ).

tff(pred_def_110,type,
    v425: state_type > $o ).

tff(pred_def_111,type,
    v433: state_type > $o ).

tff(pred_def_112,type,
    v435: state_type > $o ).

tff(pred_def_113,type,
    v441: state_type > $o ).

tff(pred_def_114,type,
    v439: state_type > $o ).

tff(pred_def_115,type,
    v437: state_type > $o ).

tff(pred_def_116,type,
    v444: state_type > $o ).

tff(pred_def_117,type,
    v452: state_type > $o ).

tff(pred_def_118,type,
    v450: state_type > $o ).

tff(pred_def_119,type,
    v449: state_type > $o ).

tff(pred_def_120,type,
    v448: state_type > $o ).

tff(pred_def_121,type,
    v460: state_type > $o ).

tff(pred_def_122,type,
    v461: state_type > $o ).

tff(pred_def_123,type,
    v459: state_type > $o ).

tff(pred_def_124,type,
    v456: state_type > $o ).

tff(pred_def_125,type,
    x442: state_type > $o ).

tff(pred_def_126,type,
    v458: state_type > $o ).

tff(pred_def_127,type,
    v431: state_type > $o ).

tff(pred_def_128,type,
    undeclared: $o ).

tff(pred_def_129,type,
    v429: state_type > $o ).

tff(pred_def_130,type,
    v427: state_type > $o ).

tff(pred_def_131,type,
    v468: state_type > $o ).

tff(pred_def_132,type,
    v471: state_type > $o ).

tff(pred_def_133,type,
    v472: state_type > $o ).

tff(pred_def_134,type,
    v470: state_type > $o ).

tff(pred_def_135,type,
    v475: state_type > $o ).

tff(pred_def_136,type,
    v474: state_type > $o ).

tff(pred_def_137,type,
    v476: state_type > $o ).

tff(pred_def_138,type,
    v473: state_type > $o ).

tff(pred_def_139,type,
    v469: state_type > $o ).

tff(pred_def_140,type,
    v467: state_type > $o ).

tff(pred_def_141,type,
    v478: state_type > $o ).

tff(pred_def_142,type,
    x464: state_type > $o ).

tff(pred_def_143,type,
    v477: state_type > $o ).

tff(pred_def_144,type,
    v419: state_type > $o ).

tff(pred_def_145,type,
    v417: state_type > $o ).

tff(pred_def_146,type,
    v415: state_type > $o ).

tff(pred_def_147,type,
    v413: state_type > $o ).

tff(pred_def_148,type,
    v411: state_type > $o ).

tff(pred_def_149,type,
    v409: state_type > $o ).

tff(pred_def_150,type,
    v407: state_type > $o ).

tff(pred_def_151,type,
    v484: state_type > $o ).

tff(pred_def_152,type,
    v486: state_type > $o ).

tff(pred_def_153,type,
    v293: state_type > $o ).

tff(pred_def_154,type,
    v488: state_type > $o ).

tff(pred_def_155,type,
    v489: state_type > $o ).

tff(pred_def_156,type,
    v402: state_type > $o ).

tff(pred_def_157,type,
    v400: state_type > $o ).

tff(pred_def_158,type,
    v398: state_type > $o ).

tff(pred_def_159,type,
    v496: state_type > $o ).

tff(pred_def_160,type,
    v495: state_type > $o ).

tff(pred_def_161,type,
    v494: state_type > $o ).

tff(pred_def_162,type,
    v493: state_type > $o ).

tff(pred_def_163,type,
    v501: state_type > $o ).

tff(pred_def_164,type,
    v500: state_type > $o ).

tff(pred_def_165,type,
    v499: state_type > $o ).

tff(pred_def_166,type,
    v504: state_type > $o ).

tff(pred_def_167,type,
    v503: state_type > $o ).

tff(pred_def_168,type,
    v505: state_type > $o ).

tff(pred_def_169,type,
    v502: state_type > $o ).

tff(pred_def_170,type,
    v498: state_type > $o ).

tff(pred_def_171,type,
    v506: state_type > $o ).

tff(pred_def_172,type,
    v497: state_type > $o ).

tff(pred_def_173,type,
    v492: state_type > $o ).

tff(pred_def_174,type,
    v508: state_type > $o ).

tff(pred_def_175,type,
    v507: state_type > $o ).

tff(pred_def_176,type,
    v335: state_type > $o ).

tff(pred_def_177,type,
    v333: state_type > $o ).

tff(pred_def_178,type,
    v331: state_type > $o ).

tff(pred_def_179,type,
    v514: state_type > $o ).

tff(pred_def_180,type,
    v516: state_type > $o ).

tff(pred_def_181,type,
    v518: state_type > $o ).

tff(pred_def_182,type,
    v519: state_type > $o ).

tff(pred_def_183,type,
    v295: state_type > $o ).

tff(pred_def_184,type,
    v291: state_type > $o ).

tff(pred_def_185,type,
    v289: state_type > $o ).

tff(pred_def_186,type,
    v521: state_type > $o ).

tff(pred_def_187,type,
    v537: state_type > $o ).

tff(pred_def_188,type,
    v539: state_type > $o ).

tff(pred_def_189,type,
    v547: state_type > $o ).

tff(pred_def_190,type,
    v549: state_type > $o ).

tff(pred_def_191,type,
    v555: state_type > $o ).

tff(pred_def_192,type,
    v557: state_type > $o ).

tff(pred_def_193,type,
    v553: state_type > $o ).

tff(pred_def_194,type,
    v551: state_type > $o ).

tff(pred_def_195,type,
    v559: state_type > $o ).

tff(pred_def_196,type,
    v545: state_type > $o ).

tff(pred_def_197,type,
    v566: state_type > $o ).

tff(pred_def_198,type,
    v564: state_type > $o ).

tff(pred_def_199,type,
    v563: state_type > $o ).

tff(pred_def_200,type,
    v562: state_type > $o ).

tff(pred_def_201,type,
    v574: state_type > $o ).

tff(pred_def_202,type,
    v575: state_type > $o ).

tff(pred_def_203,type,
    v573: state_type > $o ).

tff(pred_def_204,type,
    v570: state_type > $o ).

tff(pred_def_205,type,
    v572: state_type > $o ).

tff(pred_def_206,type,
    v543: state_type > $o ).

tff(pred_def_207,type,
    v541: state_type > $o ).

tff(pred_def_208,type,
    v579: state_type > $o ).

tff(pred_def_209,type,
    v535: state_type > $o ).

tff(pred_def_210,type,
    v586: state_type > $o ).

tff(pred_def_211,type,
    v584: state_type > $o ).

tff(pred_def_212,type,
    v583: state_type > $o ).

tff(pred_def_213,type,
    v582: state_type > $o ).

tff(pred_def_214,type,
    v594: state_type > $o ).

tff(pred_def_215,type,
    v595: state_type > $o ).

tff(pred_def_216,type,
    v593: state_type > $o ).

tff(pred_def_217,type,
    v590: state_type > $o ).

tff(pred_def_218,type,
    v592: state_type > $o ).

tff(pred_def_219,type,
    v533: state_type > $o ).

tff(pred_def_220,type,
    v531: state_type > $o ).

tff(pred_def_221,type,
    v529: state_type > $o ).

tff(pred_def_222,type,
    v527: state_type > $o ).

tff(pred_def_223,type,
    v525: state_type > $o ).

tff(pred_def_224,type,
    v523: state_type > $o ).

tff(pred_def_225,type,
    v284: state_type > $o ).

tff(pred_def_226,type,
    v602: state_type > $o ).

tff(pred_def_227,type,
    v605: state_type > $o ).

tff(pred_def_228,type,
    v606: state_type > $o ).

tff(pred_def_229,type,
    v604: state_type > $o ).

tff(pred_def_230,type,
    v609: state_type > $o ).

tff(pred_def_231,type,
    v608: state_type > $o ).

tff(pred_def_232,type,
    v610: state_type > $o ).

tff(pred_def_233,type,
    v607: state_type > $o ).

tff(pred_def_234,type,
    v603: state_type > $o ).

tff(pred_def_235,type,
    v601: state_type > $o ).

tff(pred_def_236,type,
    v612: state_type > $o ).

tff(pred_def_237,type,
    v611: state_type > $o ).

tff(pred_def_238,type,
    v282: state_type > $o ).

tff(pred_def_239,type,
    v280: state_type > $o ).

tff(pred_def_240,type,
    v278: state_type > $o ).

tff(pred_def_241,type,
    v624: state_type > $o ).

tff(pred_def_242,type,
    v626: state_type > $o ).

tff(pred_def_243,type,
    v622: state_type > $o ).

tff(pred_def_244,type,
    v620: state_type > $o ).

tff(pred_def_245,type,
    v618: state_type > $o ).

tff(pred_def_246,type,
    v628: state_type > $o ).

tff(pred_def_247,type,
    v276: state_type > $o ).

tff(pred_def_248,type,
    v274: state_type > $o ).

tff(pred_def_249,type,
    v272: state_type > $o ).

tff(pred_def_250,type,
    v270: state_type > $o ).

tff(pred_def_251,type,
    v268: state_type > $o ).

tff(pred_def_252,type,
    v266: state_type > $o ).

tff(pred_def_253,type,
    v631: state_type > $o ).

tff(pred_def_254,type,
    v633: state_type > $o ).

tff(pred_def_255,type,
    v264: state_type > $o ).

tff(pred_def_256,type,
    v262: state_type > $o ).

tff(pred_def_257,type,
    v260: state_type > $o ).

tff(pred_def_258,type,
    v258: state_type > $o ).

tff(pred_def_259,type,
    v256: state_type > $o ).

tff(pred_def_260,type,
    v254: state_type > $o ).

tff(pred_def_261,type,
    v252: state_type > $o ).

tff(pred_def_262,type,
    v640: state_type > $o ).

tff(pred_def_263,type,
    v638: state_type > $o ).

tff(pred_def_264,type,
    v636: state_type > $o ).

tff(pred_def_265,type,
    v642: state_type > $o ).

tff(pred_def_266,type,
    v250: state_type > $o ).

tff(pred_def_267,type,
    v248: state_type > $o ).

tff(pred_def_268,type,
    v246: state_type > $o ).

tff(pred_def_269,type,
    v244: state_type > $o ).

tff(pred_def_270,type,
    v242: state_type > $o ).

tff(pred_def_271,type,
    v240: state_type > $o ).

tff(pred_def_272,type,
    v238: state_type > $o ).

tff(pred_def_273,type,
    v236: state_type > $o ).

tff(pred_def_274,type,
    v234: state_type > $o ).

tff(pred_def_275,type,
    v649: state_type > $o ).

tff(pred_def_276,type,
    v647: state_type > $o ).

tff(pred_def_277,type,
    v645: state_type > $o ).

tff(pred_def_278,type,
    v656: state_type > $o ).

tff(pred_def_279,type,
    v657: state_type > $o ).

tff(pred_def_280,type,
    v655: state_type > $o ).

tff(pred_def_281,type,
    v658: state_type > $o ).

tff(pred_def_282,type,
    v654: state_type > $o ).

tff(pred_def_283,type,
    v652: state_type > $o ).

tff(pred_def_284,type,
    v232: state_type > $o ).

tff(pred_def_285,type,
    x650: state_type > $o ).

tff(pred_def_286,type,
    v230: state_type > $o ).

tff(pred_def_287,type,
    v228: state_type > $o ).

tff(pred_def_288,type,
    v226: state_type > $o ).

tff(pred_def_289,type,
    v224: state_type > $o ).

tff(pred_def_290,type,
    v664: state_type > $o ).

tff(pred_def_291,type,
    v662: state_type > $o ).

tff(pred_def_292,type,
    v668: state_type > $o ).

tff(pred_def_293,type,
    v666: state_type > $o ).

tff(pred_def_294,type,
    v690: state_type > $o ).

tff(pred_def_295,type,
    v692: state_type > $o ).

tff(pred_def_296,type,
    v688: state_type > $o ).

tff(pred_def_297,type,
    v686: state_type > $o ).

tff(pred_def_298,type,
    v684: state_type > $o ).

tff(pred_def_299,type,
    v682: state_type > $o ).

tff(pred_def_300,type,
    v680: state_type > $o ).

tff(pred_def_301,type,
    v678: state_type > $o ).

tff(pred_def_302,type,
    v676: state_type > $o ).

tff(pred_def_303,type,
    v674: state_type > $o ).

tff(pred_def_304,type,
    v672: state_type > $o ).

tff(pred_def_305,type,
    v670: state_type > $o ).

tff(pred_def_306,type,
    v660: state_type > $o ).

tff(pred_def_307,type,
    v698: state_type > $o ).

tff(pred_def_308,type,
    v700: state_type > $o ).

tff(pred_def_309,type,
    v696: state_type > $o ).

tff(pred_def_310,type,
    v695: state_type > $o ).

tff(pred_def_311,type,
    v706: state_type > $o ).

tff(pred_def_312,type,
    v707: state_type > $o ).

tff(pred_def_313,type,
    v703: state_type > $o ).

tff(pred_def_314,type,
    v705: state_type > $o ).

tff(pred_def_315,type,
    v717: state_type > $o ).

tff(pred_def_316,type,
    v719: state_type > $o ).

tff(pred_def_317,type,
    v715: state_type > $o ).

tff(pred_def_318,type,
    v713: state_type > $o ).

tff(pred_def_319,type,
    v711: state_type > $o ).

tff(pred_def_320,type,
    v721: state_type > $o ).

tff(pred_def_321,type,
    v222: state_type > $o ).

tff(pred_def_322,type,
    v220: state_type > $o ).

tff(pred_def_323,type,
    v218: state_type > $o ).

tff(pred_def_324,type,
    v216: state_type > $o ).

tff(pred_def_325,type,
    v214: state_type > $o ).

tff(pred_def_326,type,
    v212: state_type > $o ).

tff(pred_def_327,type,
    v210: state_type > $o ).

tff(pred_def_328,type,
    v728: state_type > $o ).

tff(pred_def_329,type,
    v726: state_type > $o ).

tff(pred_def_330,type,
    v725: state_type > $o ).

tff(pred_def_331,type,
    v724: state_type > $o ).

tff(pred_def_332,type,
    v736: state_type > $o ).

tff(pred_def_333,type,
    v737: state_type > $o ).

tff(pred_def_334,type,
    v735: state_type > $o ).

tff(pred_def_335,type,
    v732: ( state_type * $int ) > $o ).

tff(pred_def_336,type,
    bxxxxxx: $int > $o ).

tff(pred_def_337,type,
    v734: ( state_type * $int ) > $o ).

tff(pred_def_338,type,
    v723: ( state_type * $int ) > $o ).

tff(pred_def_339,type,
    v176: ( state_type * $int ) > $o ).

tff(pred_def_340,type,
    v174: ( state_type * $int ) > $o ).

tff(pred_def_341,type,
    v172: state_type > $o ).

tff(pred_def_342,type,
    v751: state_type > $o ).

tff(pred_def_343,type,
    v749: state_type > $o ).

tff(pred_def_344,type,
    v755: state_type > $o ).

tff(pred_def_345,type,
    v753: state_type > $o ).

tff(pred_def_346,type,
    v743: ( state_type * $int ) > $o ).

tff(pred_def_347,type,
    v767: state_type > $o ).

tff(pred_def_348,type,
    v765: state_type > $o ).

tff(pred_def_349,type,
    v797: state_type > $o ).

tff(pred_def_350,type,
    v795: state_type > $o ).

tff(pred_def_351,type,
    v793: state_type > $o ).

tff(pred_def_352,type,
    v791: state_type > $o ).

tff(pred_def_353,type,
    v805: state_type > $o ).

tff(pred_def_354,type,
    v803: state_type > $o ).

tff(pred_def_355,type,
    v801: state_type > $o ).

tff(pred_def_356,type,
    v799: state_type > $o ).

tff(pred_def_357,type,
    b10000: $int > $o ).

tff(pred_def_358,type,
    v785: ( state_type * $int ) > $o ).

tff(pred_def_359,type,
    v818: state_type > $o ).

tff(pred_def_360,type,
    v820: state_type > $o ).

tff(pred_def_361,type,
    v819: ( state_type * $int ) > $o ).

tff(pred_def_362,type,
    b00000: $int > $o ).

tff(pred_def_363,type,
    v829: state_type > $o ).

tff(pred_def_364,type,
    v828: state_type > $o ).

tff(pred_def_365,type,
    v827: state_type > $o ).

tff(pred_def_366,type,
    v826: state_type > $o ).

tff(pred_def_367,type,
    v830: state_type > $o ).

tff(pred_def_368,type,
    v825: state_type > $o ).

tff(pred_def_369,type,
    v831: state_type > $o ).

tff(pred_def_370,type,
    v824: state_type > $o ).

tff(pred_def_371,type,
    v834: state_type > $o ).

tff(pred_def_372,type,
    v835: state_type > $o ).

tff(pred_def_373,type,
    v833: state_type > $o ).

tff(pred_def_374,type,
    v836: state_type > $o ).

tff(pred_def_375,type,
    v832: state_type > $o ).

tff(pred_def_376,type,
    v839: state_type > $o ).

tff(pred_def_377,type,
    v840: state_type > $o ).

tff(pred_def_378,type,
    v838: state_type > $o ).

tff(pred_def_379,type,
    v841: state_type > $o ).

tff(pred_def_380,type,
    v837: state_type > $o ).

tff(pred_def_381,type,
    v844: state_type > $o ).

tff(pred_def_382,type,
    v845: state_type > $o ).

tff(pred_def_383,type,
    v843: state_type > $o ).

tff(pred_def_384,type,
    v846: state_type > $o ).

tff(pred_def_385,type,
    v842: state_type > $o ).

tff(pred_def_386,type,
    v822: ( state_type * $int ) > $o ).

tff(pred_def_387,type,
    v821: ( state_type * $int ) > $o ).

tff(pred_def_388,type,
    v817: ( state_type * $int ) > $o ).

tff(pred_def_389,type,
    v813: ( state_type * $int ) > $o ).

tff(pred_def_390,type,
    v811: ( state_type * $int ) > $o ).

tff(pred_def_391,type,
    v850: state_type > $o ).

tff(pred_def_392,type,
    v777: state_type > $o ).

tff(pred_def_393,type,
    v848: state_type > $o ).

tff(pred_def_394,type,
    v854: state_type > $o ).

tff(pred_def_395,type,
    v853: ( state_type * $int ) > $o ).

tff(pred_def_396,type,
    v852: ( state_type * $int ) > $o ).

tff(pred_def_397,type,
    v858: state_type > $o ).

tff(pred_def_398,type,
    v857: ( state_type * $int ) > $o ).

tff(pred_def_399,type,
    v856: ( state_type * $int ) > $o ).

tff(pred_def_400,type,
    v787: ( state_type * $int ) > $o ).

tff(pred_def_401,type,
    v855: ( state_type * $int ) > $o ).

tff(pred_def_402,type,
    v851: ( state_type * $int ) > $o ).

tff(pred_def_403,type,
    v809: ( state_type * $int ) > $o ).

tff(pred_def_404,type,
    v807: ( state_type * $int ) > $o ).

tff(pred_def_405,type,
    v864: state_type > $o ).

tff(pred_def_406,type,
    v862: state_type > $o ).

tff(pred_def_407,type,
    v860: state_type > $o ).

tff(pred_def_408,type,
    v871: state_type > $o ).

tff(pred_def_409,type,
    v869: state_type > $o ).

tff(pred_def_410,type,
    v868: state_type > $o ).

tff(pred_def_411,type,
    v867: state_type > $o ).

tff(pred_def_412,type,
    v879: state_type > $o ).

tff(pred_def_413,type,
    v880: state_type > $o ).

tff(pred_def_414,type,
    v878: state_type > $o ).

tff(pred_def_415,type,
    v875: ( state_type * $int ) > $o ).

tff(pred_def_416,type,
    v877: ( state_type * $int ) > $o ).

tff(pred_def_417,type,
    v866: ( state_type * $int ) > $o ).

tff(pred_def_418,type,
    v789: ( state_type * $int ) > $o ).

tff(pred_def_419,type,
    v892: state_type > $o ).

tff(pred_def_420,type,
    v890: state_type > $o ).

tff(pred_def_421,type,
    v896: state_type > $o ).

tff(pred_def_422,type,
    v894: state_type > $o ).

tff(pred_def_423,type,
    v922: state_type > $o ).

tff(pred_def_424,type,
    v920: state_type > $o ).

tff(pred_def_425,type,
    v918: state_type > $o ).

tff(pred_def_426,type,
    v916: state_type > $o ).

tff(pred_def_427,type,
    v930: state_type > $o ).

tff(pred_def_428,type,
    v928: state_type > $o ).

tff(pred_def_429,type,
    v926: state_type > $o ).

tff(pred_def_430,type,
    v924: state_type > $o ).

tff(pred_def_431,type,
    v948: state_type > $o ).

tff(pred_def_432,type,
    v946: state_type > $o ).

tff(pred_def_433,type,
    v952: state_type > $o ).

tff(pred_def_434,type,
    v950: state_type > $o ).

tff(pred_def_435,type,
    v980: state_type > $o ).

tff(pred_def_436,type,
    v978: state_type > $o ).

tff(pred_def_437,type,
    v976: state_type > $o ).

tff(pred_def_438,type,
    v974: state_type > $o ).

tff(pred_def_439,type,
    v988: state_type > $o ).

tff(pred_def_440,type,
    v986: state_type > $o ).

tff(pred_def_441,type,
    v984: state_type > $o ).

tff(pred_def_442,type,
    v982: state_type > $o ).

tff(pred_def_443,type,
    v1011: state_type > $o ).

tff(pred_def_444,type,
    v1009: state_type > $o ).

tff(pred_def_445,type,
    v1015: state_type > $o ).

tff(pred_def_446,type,
    v1013: state_type > $o ).

tff(pred_def_447,type,
    v1033: state_type > $o ).

tff(pred_def_448,type,
    v1031: state_type > $o ).

tff(pred_def_449,type,
    v1037: state_type > $o ).

tff(pred_def_450,type,
    v1035: state_type > $o ).

tff(pred_def_451,type,
    v1087: state_type > $o ).

tff(pred_def_452,type,
    v1085: state_type > $o ).

tff(pred_def_453,type,
    v1083: state_type > $o ).

tff(pred_def_454,type,
    v1081: state_type > $o ).

tff(pred_def_455,type,
    v1079: state_type > $o ).

tff(pred_def_456,type,
    v1077: state_type > $o ).

tff(pred_def_457,type,
    v1099: state_type > $o ).

tff(pred_def_458,type,
    v1101: state_type > $o ).

tff(pred_def_459,type,
    v1097: state_type > $o ).

tff(pred_def_460,type,
    v1095: state_type > $o ).

tff(pred_def_461,type,
    v1093: state_type > $o ).

tff(pred_def_462,type,
    v1091: state_type > $o ).

tff(pred_def_463,type,
    v1089: state_type > $o ).

tff(pred_def_464,type,
    v1104: state_type > $o ).

tff(pred_def_465,type,
    v1075: state_type > $o ).

tff(pred_def_466,type,
    v1073: state_type > $o ).

tff(pred_def_467,type,
    v1071: state_type > $o ).

tff(pred_def_468,type,
    v1069: state_type > $o ).

tff(pred_def_469,type,
    v1067: state_type > $o ).

tff(pred_def_470,type,
    v1065: state_type > $o ).

tff(pred_def_471,type,
    v1063: state_type > $o ).

tff(pred_def_472,type,
    v1061: state_type > $o ).

tff(pred_def_473,type,
    v1059: state_type > $o ).

tff(pred_def_474,type,
    v1057: state_type > $o ).

tff(pred_def_475,type,
    v1109: state_type > $o ).

tff(pred_def_476,type,
    v1107: state_type > $o ).

tff(pred_def_477,type,
    v1127: state_type > $o ).

tff(pred_def_478,type,
    v1125: state_type > $o ).

tff(pred_def_479,type,
    v1131: state_type > $o ).

tff(pred_def_480,type,
    v1129: state_type > $o ).

tff(pred_def_481,type,
    v1155: state_type > $o ).

tff(pred_def_482,type,
    v1153: state_type > $o ).

tff(pred_def_483,type,
    v1151: state_type > $o ).

tff(pred_def_484,type,
    v1149: state_type > $o ).

tff(pred_def_485,type,
    v1163: state_type > $o ).

tff(pred_def_486,type,
    v1161: state_type > $o ).

tff(pred_def_487,type,
    v1159: state_type > $o ).

tff(pred_def_488,type,
    v1157: state_type > $o ).

tff(pred_def_489,type,
    v1179: state_type > $o ).

tff(pred_def_490,type,
    v1177: state_type > $o ).

tff(pred_def_491,type,
    v1183: state_type > $o ).

tff(pred_def_492,type,
    v1181: state_type > $o ).

tff(pred_def_493,type,
    v1193: ( state_type * $int ) > $o ).

tff(pred_def_494,type,
    v1195: ( state_type * $int ) > $o ).

tff(pred_def_495,type,
    v1191: ( state_type * $int ) > $o ).

tff(pred_def_496,type,
    v1189: ( state_type * $int ) > $o ).

tff(pred_def_497,type,
    v1201: ( state_type * $int ) > $o ).

tff(pred_def_498,type,
    v1203: ( state_type * $int ) > $o ).

tff(pred_def_499,type,
    v1199: state_type > $o ).

tff(pred_def_500,type,
    v1197: state_type > $o ).

tff(pred_def_501,type,
    v1207: state_type > $o ).

tff(pred_def_502,type,
    v1206: ( state_type * $int ) > $o ).

tff(pred_def_503,type,
    v1205: ( state_type * $int ) > $o ).

tff(pred_def_504,type,
    v1211: state_type > $o ).

tff(pred_def_505,type,
    v1210: ( state_type * $int ) > $o ).

tff(pred_def_506,type,
    v1209: ( state_type * $int ) > $o ).

tff(pred_def_507,type,
    v1173: ( state_type * $int ) > $o ).

tff(pred_def_508,type,
    v1208: ( state_type * $int ) > $o ).

tff(pred_def_509,type,
    v1204: ( state_type * $int ) > $o ).

tff(pred_def_510,type,
    v1187: ( state_type * $int ) > $o ).

tff(pred_def_511,type,
    v1185: ( state_type * $int ) > $o ).

tff(pred_def_512,type,
    v1286: state_type > $o ).

tff(pred_def_513,type,
    v1318: state_type > $o ).

tff(pred_def_514,type,
    v1316: state_type > $o ).

tff(pred_def_515,type,
    v1314: state_type > $o ).

tff(pred_def_516,type,
    v1312: state_type > $o ).

tff(pred_def_517,type,
    v1310: state_type > $o ).

tff(pred_def_518,type,
    v1308: state_type > $o ).

tff(pred_def_519,type,
    v1325: state_type > $o ).

tff(pred_def_520,type,
    v1323: state_type > $o ).

tff(pred_def_521,type,
    v1321: state_type > $o ).

tff(pred_def_522,type,
    v1327: state_type > $o ).

tff(pred_def_523,type,
    v1306: state_type > $o ).

tff(pred_def_524,type,
    v1304: state_type > $o ).

tff(pred_def_525,type,
    v1302: state_type > $o ).

tff(pred_def_526,type,
    v1300: state_type > $o ).

tff(pred_def_527,type,
    v1298: state_type > $o ).

tff(pred_def_528,type,
    v1296: state_type > $o ).

tff(pred_def_529,type,
    v1336: state_type > $o ).

tff(pred_def_530,type,
    v1338: state_type > $o ).

tff(pred_def_531,type,
    v1370: state_type > $o ).

tff(pred_def_532,type,
    v1368: state_type > $o ).

tff(pred_def_533,type,
    v1366: state_type > $o ).

tff(pred_def_534,type,
    v1364: state_type > $o ).

tff(pred_def_535,type,
    v1373: state_type > $o ).

tff(pred_def_536,type,
    v1375: state_type > $o ).

tff(pred_def_537,type,
    v1362: state_type > $o ).

tff(pred_def_538,type,
    v1360: state_type > $o ).

tff(pred_def_539,type,
    v1358: state_type > $o ).

tff(pred_def_540,type,
    v1356: state_type > $o ).

tff(pred_def_541,type,
    v1354: state_type > $o ).

tff(pred_def_542,type,
    v1352: state_type > $o ).

tff(pred_def_543,type,
    v1382: state_type > $o ).

tff(pred_def_544,type,
    v1384: state_type > $o ).

tff(pred_def_545,type,
    v1380: state_type > $o ).

tff(pred_def_546,type,
    v1378: state_type > $o ).

tff(pred_def_547,type,
    v1386: state_type > $o ).

tff(pred_def_548,type,
    v1350: state_type > $o ).

tff(pred_def_549,type,
    v1348: state_type > $o ).

tff(pred_def_550,type,
    v1346: state_type > $o ).

tff(pred_def_551,type,
    v1344: state_type > $o ).

tff(pred_def_552,type,
    v1342: state_type > $o ).

tff(pred_def_553,type,
    v1340: state_type > $o ).

tff(pred_def_554,type,
    v1389: state_type > $o ).

tff(pred_def_555,type,
    v1391: state_type > $o ).

tff(pred_def_556,type,
    v1401: state_type > $o ).

tff(pred_def_557,type,
    v1414: state_type > $o ).

tff(pred_def_558,type,
    v1416: state_type > $o ).

tff(pred_def_559,type,
    v1412: state_type > $o ).

tff(pred_def_560,type,
    v1410: state_type > $o ).

tff(pred_def_561,type,
    v1408: state_type > $o ).

tff(pred_def_562,type,
    v1406: state_type > $o ).

tff(pred_def_563,type,
    v1404: state_type > $o ).

tff(pred_def_564,type,
    v1418: state_type > $o ).

tff(pred_def_565,type,
    v1420: state_type > $o ).

tff(pred_def_566,type,
    v1292: state_type > $o ).

tff(pred_def_567,type,
    v1422: state_type > $o ).

tff(pred_def_568,type,
    v1423: state_type > $o ).

tff(pred_def_569,type,
    v1399: state_type > $o ).

tff(pred_def_570,type,
    v1397: state_type > $o ).

tff(pred_def_571,type,
    v1395: state_type > $o ).

tff(pred_def_572,type,
    v1430: state_type > $o ).

tff(pred_def_573,type,
    v1429: state_type > $o ).

tff(pred_def_574,type,
    v1428: state_type > $o ).

tff(pred_def_575,type,
    v1427: state_type > $o ).

tff(pred_def_576,type,
    v1435: state_type > $o ).

tff(pred_def_577,type,
    v1434: state_type > $o ).

tff(pred_def_578,type,
    v1433: state_type > $o ).

tff(pred_def_579,type,
    v1438: state_type > $o ).

tff(pred_def_580,type,
    v1437: state_type > $o ).

tff(pred_def_581,type,
    v1439: state_type > $o ).

tff(pred_def_582,type,
    v1436: state_type > $o ).

tff(pred_def_583,type,
    v1432: state_type > $o ).

tff(pred_def_584,type,
    v1440: state_type > $o ).

tff(pred_def_585,type,
    v1431: state_type > $o ).

tff(pred_def_586,type,
    v1426: state_type > $o ).

tff(pred_def_587,type,
    v1442: state_type > $o ).

tff(pred_def_588,type,
    v1393: state_type > $o ).

tff(pred_def_589,type,
    v1441: state_type > $o ).

tff(pred_def_590,type,
    v1334: state_type > $o ).

tff(pred_def_591,type,
    v1332: state_type > $o ).

tff(pred_def_592,type,
    v1330: state_type > $o ).

tff(pred_def_593,type,
    v1448: state_type > $o ).

tff(pred_def_594,type,
    v1450: state_type > $o ).

tff(pred_def_595,type,
    v1452: state_type > $o ).

tff(pred_def_596,type,
    v1453: state_type > $o ).

tff(pred_def_597,type,
    v1294: state_type > $o ).

tff(pred_def_598,type,
    v1290: state_type > $o ).

tff(pred_def_599,type,
    v1288: state_type > $o ).

tff(pred_def_600,type,
    v1455: state_type > $o ).

tff(pred_def_601,type,
    v1469: state_type > $o ).

tff(pred_def_602,type,
    v1467: state_type > $o ).

tff(pred_def_603,type,
    v1465: state_type > $o ).

tff(pred_def_604,type,
    v1463: state_type > $o ).

tff(pred_def_605,type,
    v1461: state_type > $o ).

tff(pred_def_606,type,
    v1459: state_type > $o ).

tff(pred_def_607,type,
    v1457: state_type > $o ).

tff(pred_def_608,type,
    v1284: state_type > $o ).

tff(pred_def_609,type,
    v1474: state_type > $o ).

tff(pred_def_610,type,
    v1477: state_type > $o ).

tff(pred_def_611,type,
    v1478: state_type > $o ).

tff(pred_def_612,type,
    v1476: state_type > $o ).

tff(pred_def_613,type,
    v1481: state_type > $o ).

tff(pred_def_614,type,
    v1480: state_type > $o ).

tff(pred_def_615,type,
    v1482: state_type > $o ).

tff(pred_def_616,type,
    v1479: state_type > $o ).

tff(pred_def_617,type,
    v1475: state_type > $o ).

tff(pred_def_618,type,
    v1473: state_type > $o ).

tff(pred_def_619,type,
    v1484: state_type > $o ).

tff(pred_def_620,type,
    v1483: state_type > $o ).

tff(pred_def_621,type,
    v1282: state_type > $o ).

tff(pred_def_622,type,
    v1280: state_type > $o ).

tff(pred_def_623,type,
    v1278: state_type > $o ).

tff(pred_def_624,type,
    v1496: state_type > $o ).

tff(pred_def_625,type,
    v1494: state_type > $o ).

tff(pred_def_626,type,
    v1492: state_type > $o ).

tff(pred_def_627,type,
    v1490: state_type > $o ).

tff(pred_def_628,type,
    v1498: state_type > $o ).

tff(pred_def_629,type,
    v1276: state_type > $o ).

tff(pred_def_630,type,
    v1274: state_type > $o ).

tff(pred_def_631,type,
    v1272: state_type > $o ).

tff(pred_def_632,type,
    v1270: state_type > $o ).

tff(pred_def_633,type,
    v1268: state_type > $o ).

tff(pred_def_634,type,
    v1266: state_type > $o ).

tff(pred_def_635,type,
    v1501: state_type > $o ).

tff(pred_def_636,type,
    v1503: state_type > $o ).

tff(pred_def_637,type,
    v1264: state_type > $o ).

tff(pred_def_638,type,
    v1262: state_type > $o ).

tff(pred_def_639,type,
    v1260: state_type > $o ).

tff(pred_def_640,type,
    v1258: state_type > $o ).

tff(pred_def_641,type,
    v1256: state_type > $o ).

tff(pred_def_642,type,
    v1254: state_type > $o ).

tff(pred_def_643,type,
    v1252: state_type > $o ).

tff(pred_def_644,type,
    v1510: state_type > $o ).

tff(pred_def_645,type,
    v1508: state_type > $o ).

tff(pred_def_646,type,
    v1506: state_type > $o ).

tff(pred_def_647,type,
    v1512: state_type > $o ).

tff(pred_def_648,type,
    v1250: state_type > $o ).

tff(pred_def_649,type,
    v1248: state_type > $o ).

tff(pred_def_650,type,
    v1246: state_type > $o ).

tff(pred_def_651,type,
    v1244: state_type > $o ).

tff(pred_def_652,type,
    v1242: state_type > $o ).

tff(pred_def_653,type,
    v1240: state_type > $o ).

tff(pred_def_654,type,
    v1238: state_type > $o ).

tff(pred_def_655,type,
    v1236: state_type > $o ).

tff(pred_def_656,type,
    v1234: state_type > $o ).

tff(pred_def_657,type,
    v1519: state_type > $o ).

tff(pred_def_658,type,
    v1517: state_type > $o ).

tff(pred_def_659,type,
    v1515: state_type > $o ).

tff(pred_def_660,type,
    v1526: state_type > $o ).

tff(pred_def_661,type,
    v1527: state_type > $o ).

tff(pred_def_662,type,
    v1525: state_type > $o ).

tff(pred_def_663,type,
    v1528: state_type > $o ).

tff(pred_def_664,type,
    v1524: state_type > $o ).

tff(pred_def_665,type,
    v1522: state_type > $o ).

tff(pred_def_666,type,
    v1232: state_type > $o ).

tff(pred_def_667,type,
    x1520: state_type > $o ).

tff(pred_def_668,type,
    v1230: state_type > $o ).

tff(pred_def_669,type,
    v1228: state_type > $o ).

tff(pred_def_670,type,
    v1226: state_type > $o ).

tff(pred_def_671,type,
    v1224: state_type > $o ).

tff(pred_def_672,type,
    v1534: state_type > $o ).

tff(pred_def_673,type,
    v1532: state_type > $o ).

tff(pred_def_674,type,
    v1538: state_type > $o ).

tff(pred_def_675,type,
    v1536: state_type > $o ).

tff(pred_def_676,type,
    v1560: state_type > $o ).

tff(pred_def_677,type,
    v1558: state_type > $o ).

tff(pred_def_678,type,
    v1556: state_type > $o ).

tff(pred_def_679,type,
    v1554: state_type > $o ).

tff(pred_def_680,type,
    v1552: state_type > $o ).

tff(pred_def_681,type,
    v1550: state_type > $o ).

tff(pred_def_682,type,
    v1548: state_type > $o ).

tff(pred_def_683,type,
    v1546: state_type > $o ).

tff(pred_def_684,type,
    v1544: state_type > $o ).

tff(pred_def_685,type,
    v1542: state_type > $o ).

tff(pred_def_686,type,
    v1540: state_type > $o ).

tff(pred_def_687,type,
    v1530: state_type > $o ).

tff(pred_def_688,type,
    v1566: state_type > $o ).

tff(pred_def_689,type,
    v1568: state_type > $o ).

tff(pred_def_690,type,
    v1564: state_type > $o ).

tff(pred_def_691,type,
    v1563: state_type > $o ).

tff(pred_def_692,type,
    v1574: state_type > $o ).

tff(pred_def_693,type,
    v1575: state_type > $o ).

tff(pred_def_694,type,
    v1571: state_type > $o ).

tff(pred_def_695,type,
    v1573: state_type > $o ).

tff(pred_def_696,type,
    v1585: state_type > $o ).

tff(pred_def_697,type,
    v1583: state_type > $o ).

tff(pred_def_698,type,
    v1581: state_type > $o ).

tff(pred_def_699,type,
    v1579: state_type > $o ).

tff(pred_def_700,type,
    v1587: state_type > $o ).

tff(pred_def_701,type,
    v1222: state_type > $o ).

tff(pred_def_702,type,
    v1220: state_type > $o ).

tff(pred_def_703,type,
    v1218: state_type > $o ).

tff(pred_def_704,type,
    v1216: state_type > $o ).

tff(pred_def_705,type,
    v1214: state_type > $o ).

tff(pred_def_706,type,
    v1594: state_type > $o ).

tff(pred_def_707,type,
    v1592: state_type > $o ).

tff(pred_def_708,type,
    v1591: state_type > $o ).

tff(pred_def_709,type,
    v1590: state_type > $o ).

tff(pred_def_710,type,
    v1602: state_type > $o ).

tff(pred_def_711,type,
    v1603: state_type > $o ).

tff(pred_def_712,type,
    v1601: state_type > $o ).

tff(pred_def_713,type,
    v1598: ( state_type * $int ) > $o ).

tff(pred_def_714,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_715,type,
    v1600: ( state_type * $int ) > $o ).

tff(pred_def_716,type,
    v1589: ( state_type * $int ) > $o ).

tff(pred_def_717,type,
    v1175: ( state_type * $int ) > $o ).

tff(pred_def_718,type,
    v1171: ( state_type * $int ) > $o ).

tff(pred_def_719,type,
    v1169: ( state_type * $int ) > $o ).

tff(pred_def_720,type,
    v1617: state_type > $o ).

tff(pred_def_721,type,
    v1615: state_type > $o ).

tff(pred_def_722,type,
    v1621: state_type > $o ).

tff(pred_def_723,type,
    v1619: state_type > $o ).

tff(pred_def_724,type,
    v1639: state_type > $o ).

tff(pred_def_725,type,
    v1641: state_type > $o ).

tff(pred_def_726,type,
    v1637: state_type > $o ).

tff(pred_def_727,type,
    v1635: state_type > $o ).

tff(pred_def_728,type,
    v1633: state_type > $o ).

tff(pred_def_729,type,
    v1631: state_type > $o ).

tff(pred_def_730,type,
    v1629: state_type > $o ).

tff(pred_def_731,type,
    v1643: state_type > $o ).

tff(pred_def_732,type,
    v1642: ( state_type * $int ) > $o ).

tff(pred_def_733,type,
    v1627: ( state_type * $int ) > $o ).

tff(pred_def_734,type,
    v1625: ( state_type * $int ) > $o ).

tff(pred_def_735,type,
    v1623: ( state_type * $int ) > $o ).

tff(pred_def_736,type,
    v1648: state_type > $o ).

tff(pred_def_737,type,
    v1646: state_type > $o ).

tff(pred_def_738,type,
    v1655: state_type > $o ).

tff(pred_def_739,type,
    v1653: state_type > $o ).

tff(pred_def_740,type,
    v1652: state_type > $o ).

tff(pred_def_741,type,
    v1651: state_type > $o ).

tff(pred_def_742,type,
    v1663: state_type > $o ).

tff(pred_def_743,type,
    v1664: state_type > $o ).

tff(pred_def_744,type,
    v1662: state_type > $o ).

tff(pred_def_745,type,
    v1659: ( state_type * $int ) > $o ).

tff(pred_def_746,type,
    bxx: $int > $o ).

tff(pred_def_747,type,
    v1661: ( state_type * $int ) > $o ).

tff(pred_def_748,type,
    v1650: ( state_type * $int ) > $o ).

tff(pred_def_749,type,
    v1613: ( state_type * $int ) > $o ).

tff(pred_def_750,type,
    v1611: ( state_type * $int ) > $o ).

tff(pred_def_751,type,
    v1609: state_type > $o ).

tff(pred_def_752,type,
    v1607: state_type > $o ).

tff(pred_def_753,type,
    v1670: state_type > $o ).

tff(pred_def_754,type,
    v1669: ( state_type * $int ) > $o ).

tff(pred_def_755,type,
    v1668: ( state_type * $int ) > $o ).

tff(pred_def_756,type,
    v1674: state_type > $o ).

tff(pred_def_757,type,
    v1673: ( state_type * $int ) > $o ).

tff(pred_def_758,type,
    v1672: ( state_type * $int ) > $o ).

tff(pred_def_759,type,
    v1145: ( state_type * $int ) > $o ).

tff(pred_def_760,type,
    v1671: ( state_type * $int ) > $o ).

tff(pred_def_761,type,
    v1667: ( state_type * $int ) > $o ).

tff(pred_def_762,type,
    v1167: ( state_type * $int ) > $o ).

tff(pred_def_763,type,
    v1165: ( state_type * $int ) > $o ).

tff(pred_def_764,type,
    v1678: state_type > $o ).

tff(pred_def_765,type,
    v1676: state_type > $o ).

tff(pred_def_766,type,
    v1685: state_type > $o ).

tff(pred_def_767,type,
    v1683: state_type > $o ).

tff(pred_def_768,type,
    v1682: state_type > $o ).

tff(pred_def_769,type,
    v1681: state_type > $o ).

tff(pred_def_770,type,
    v1693: state_type > $o ).

tff(pred_def_771,type,
    v1694: state_type > $o ).

tff(pred_def_772,type,
    v1692: state_type > $o ).

tff(pred_def_773,type,
    v1689: ( state_type * $int ) > $o ).

tff(pred_def_774,type,
    v1691: ( state_type * $int ) > $o ).

tff(pred_def_775,type,
    v1680: ( state_type * $int ) > $o ).

tff(pred_def_776,type,
    v1147: ( state_type * $int ) > $o ).

tff(pred_def_777,type,
    v1143: ( state_type * $int ) > $o ).

tff(pred_def_778,type,
    v1141: ( state_type * $int ) > $o ).

tff(pred_def_779,type,
    v1139: ( state_type * $int ) > $o ).

tff(pred_def_780,type,
    v1698: state_type > $o ).

tff(pred_def_781,type,
    v1697: ( state_type * $int ) > $o ).

tff(pred_def_782,type,
    v1699: state_type > $o ).

tff(pred_def_783,type,
    v1700: ( state_type * $int ) > $o ).

tff(pred_def_784,type,
    v1137: ( state_type * $int ) > $o ).

tff(pred_def_785,type,
    v1135: ( state_type * $int ) > $o ).

tff(pred_def_786,type,
    v1133: ( state_type * $int ) > $o ).

tff(pred_def_787,type,
    v1705: state_type > $o ).

tff(pred_def_788,type,
    v1703: state_type > $o ).

tff(pred_def_789,type,
    v1712: state_type > $o ).

tff(pred_def_790,type,
    v1710: state_type > $o ).

tff(pred_def_791,type,
    v1709: state_type > $o ).

tff(pred_def_792,type,
    v1708: state_type > $o ).

tff(pred_def_793,type,
    v1720: state_type > $o ).

tff(pred_def_794,type,
    v1721: state_type > $o ).

tff(pred_def_795,type,
    v1719: state_type > $o ).

tff(pred_def_796,type,
    v1716: ( state_type * $int ) > $o ).

tff(pred_def_797,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_798,type,
    v1718: ( state_type * $int ) > $o ).

tff(pred_def_799,type,
    v1707: ( state_type * $int ) > $o ).

tff(pred_def_800,type,
    v1123: ( state_type * $int ) > $o ).

tff(pred_def_801,type,
    v1121: ( state_type * $int ) > $o ).

tff(pred_def_802,type,
    v1119: ( state_type * $int ) > $o ).

tff(pred_def_803,type,
    v1117: state_type > $o ).

tff(pred_def_804,type,
    v1115: state_type > $o ).

tff(pred_def_805,type,
    v1742: state_type > $o ).

tff(pred_def_806,type,
    v1740: state_type > $o ).

tff(pred_def_807,type,
    v1746: state_type > $o ).

tff(pred_def_808,type,
    v1744: state_type > $o ).

tff(pred_def_809,type,
    v1762: state_type > $o ).

tff(pred_def_810,type,
    v1760: state_type > $o ).

tff(pred_def_811,type,
    v1766: state_type > $o ).

tff(pred_def_812,type,
    v1764: state_type > $o ).

tff(pred_def_813,type,
    v1772: state_type > $o ).

tff(pred_def_814,type,
    v1780: ( state_type * $int ) > $o ).

tff(pred_def_815,type,
    v1782: ( state_type * $int ) > $o ).

tff(pred_def_816,type,
    v1778: state_type > $o ).

tff(pred_def_817,type,
    v1776: state_type > $o ).

tff(pred_def_818,type,
    v1774: state_type > $o ).

tff(pred_def_819,type,
    v1754: state_type > $o ).

tff(pred_def_820,type,
    v1787: state_type > $o ).

tff(pred_def_821,type,
    v1785: state_type > $o ).

tff(pred_def_822,type,
    v1793: state_type > $o ).

tff(pred_def_823,type,
    v1792: state_type > $o ).

tff(pred_def_824,type,
    v1791: state_type > $o ).

tff(pred_def_825,type,
    v1796: state_type > $o ).

tff(pred_def_826,type,
    v1795: state_type > $o ).

tff(pred_def_827,type,
    v1794: state_type > $o ).

tff(pred_def_828,type,
    v1790: state_type > $o ).

tff(pred_def_829,type,
    v1801: state_type > $o ).

tff(pred_def_830,type,
    v1800: state_type > $o ).

tff(pred_def_831,type,
    v1799: state_type > $o ).

tff(pred_def_832,type,
    v1756: state_type > $o ).

tff(pred_def_833,type,
    v1798: state_type > $o ).

tff(pred_def_834,type,
    v1804: state_type > $o ).

tff(pred_def_835,type,
    v1803: state_type > $o ).

tff(pred_def_836,type,
    v1802: state_type > $o ).

tff(pred_def_837,type,
    v1797: state_type > $o ).

tff(pred_def_838,type,
    v1770: state_type > $o ).

tff(pred_def_839,type,
    v1768: state_type > $o ).

tff(pred_def_840,type,
    v1809: state_type > $o ).

tff(pred_def_841,type,
    v1807: state_type > $o ).

tff(pred_def_842,type,
    v1816: state_type > $o ).

tff(pred_def_843,type,
    v1814: state_type > $o ).

tff(pred_def_844,type,
    v1813: state_type > $o ).

tff(pred_def_845,type,
    v1812: state_type > $o ).

tff(pred_def_846,type,
    v1824: state_type > $o ).

tff(pred_def_847,type,
    v1825: state_type > $o ).

tff(pred_def_848,type,
    v1823: state_type > $o ).

tff(pred_def_849,type,
    v1820: state_type > $o ).

tff(pred_def_850,type,
    x1805: state_type > $o ).

tff(pred_def_851,type,
    v1822: state_type > $o ).

tff(pred_def_852,type,
    v1758: state_type > $o ).

tff(pred_def_853,type,
    v1829: state_type > $o ).

tff(pred_def_854,type,
    v1828: ( state_type * $int ) > $o ).

tff(pred_def_855,type,
    v1752: ( state_type * $int ) > $o ).

tff(pred_def_856,type,
    v1831: state_type > $o ).

tff(pred_def_857,type,
    v1835: state_type > $o ).

tff(pred_def_858,type,
    v1834: ( state_type * $int ) > $o ).

tff(pred_def_859,type,
    v1833: ( state_type * $int ) > $o ).

tff(pred_def_860,type,
    v1839: state_type > $o ).

tff(pred_def_861,type,
    v1838: ( state_type * $int ) > $o ).

tff(pred_def_862,type,
    v1837: ( state_type * $int ) > $o ).

tff(pred_def_863,type,
    v1736: ( state_type * $int ) > $o ).

tff(pred_def_864,type,
    v1836: ( state_type * $int ) > $o ).

tff(pred_def_865,type,
    v1832: ( state_type * $int ) > $o ).

tff(pred_def_866,type,
    v1750: ( state_type * $int ) > $o ).

tff(pred_def_867,type,
    v1748: ( state_type * $int ) > $o ).

tff(pred_def_868,type,
    v1843: state_type > $o ).

tff(pred_def_869,type,
    v1841: state_type > $o ).

tff(pred_def_870,type,
    v1850: state_type > $o ).

tff(pred_def_871,type,
    v1848: state_type > $o ).

tff(pred_def_872,type,
    v1847: state_type > $o ).

tff(pred_def_873,type,
    v1846: state_type > $o ).

tff(pred_def_874,type,
    v1858: state_type > $o ).

tff(pred_def_875,type,
    v1859: state_type > $o ).

tff(pred_def_876,type,
    v1857: state_type > $o ).

tff(pred_def_877,type,
    v1854: ( state_type * $int ) > $o ).

tff(pred_def_878,type,
    v1856: ( state_type * $int ) > $o ).

tff(pred_def_879,type,
    v1845: ( state_type * $int ) > $o ).

tff(pred_def_880,type,
    v1738: ( state_type * $int ) > $o ).

tff(pred_def_881,type,
    v1734: state_type > $o ).

tff(pred_def_882,type,
    v1732: state_type > $o ).

tff(pred_def_883,type,
    v1867: state_type > $o ).

tff(pred_def_884,type,
    v1865: state_type > $o ).

tff(pred_def_885,type,
    v1864: state_type > $o ).

tff(pred_def_886,type,
    v1863: ( state_type * $int ) > $o ).

tff(pred_def_887,type,
    v1729: state_type > $o ).

tff(pred_def_888,type,
    v1884: state_type > $o ).

tff(pred_def_889,type,
    v1882: state_type > $o ).

tff(pred_def_890,type,
    v1888: state_type > $o ).

tff(pred_def_891,type,
    v1886: state_type > $o ).

tff(pred_def_892,type,
    v1904: state_type > $o ).

tff(pred_def_893,type,
    v1902: state_type > $o ).

tff(pred_def_894,type,
    v1908: state_type > $o ).

tff(pred_def_895,type,
    v1906: state_type > $o ).

tff(pred_def_896,type,
    v1920: ( state_type * $int ) > $o ).

tff(pred_def_897,type,
    v1918: ( state_type * $int ) > $o ).

tff(pred_def_898,type,
    v1916: ( state_type * $int ) > $o ).

tff(pred_def_899,type,
    v1914: ( state_type * $int ) > $o ).

tff(pred_def_900,type,
    v1928: state_type > $o ).

tff(pred_def_901,type,
    v1926: state_type > $o ).

tff(pred_def_902,type,
    v1924: state_type > $o ).

tff(pred_def_903,type,
    v1922: state_type > $o ).

tff(pred_def_904,type,
    v1934: state_type > $o ).

tff(pred_def_905,type,
    v1933: ( state_type * $int ) > $o ).

tff(pred_def_906,type,
    v1932: ( state_type * $int ) > $o ).

tff(pred_def_907,type,
    v1938: state_type > $o ).

tff(pred_def_908,type,
    v1937: ( state_type * $int ) > $o ).

tff(pred_def_909,type,
    v1936: ( state_type * $int ) > $o ).

tff(pred_def_910,type,
    v1898: ( state_type * $int ) > $o ).

tff(pred_def_911,type,
    v1935: ( state_type * $int ) > $o ).

tff(pred_def_912,type,
    v1912: ( state_type * $int ) > $o ).

tff(pred_def_913,type,
    v1910: ( state_type * $int ) > $o ).

tff(pred_def_914,type,
    v1943: state_type > $o ).

tff(pred_def_915,type,
    v1941: state_type > $o ).

tff(pred_def_916,type,
    v1950: state_type > $o ).

tff(pred_def_917,type,
    v1948: state_type > $o ).

tff(pred_def_918,type,
    v1947: state_type > $o ).

tff(pred_def_919,type,
    v1946: state_type > $o ).

tff(pred_def_920,type,
    v1958: state_type > $o ).

tff(pred_def_921,type,
    v1959: state_type > $o ).

tff(pred_def_922,type,
    v1957: state_type > $o ).

tff(pred_def_923,type,
    v1954: ( state_type * $int ) > $o ).

tff(pred_def_924,type,
    bxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_925,type,
    v1956: ( state_type * $int ) > $o ).

tff(pred_def_926,type,
    v1900: ( state_type * $int ) > $o ).

tff(pred_def_927,type,
    v1896: ( state_type * $int ) > $o ).

tff(pred_def_928,type,
    v1894: ( state_type * $int ) > $o ).

tff(pred_def_929,type,
    v1963: state_type > $o ).

tff(pred_def_930,type,
    v1967: state_type > $o ).

tff(pred_def_931,type,
    v1966: ( state_type * $int ) > $o ).

tff(pred_def_932,type,
    v1965: ( state_type * $int ) > $o ).

tff(pred_def_933,type,
    v1971: state_type > $o ).

tff(pred_def_934,type,
    v1970: ( state_type * $int ) > $o ).

tff(pred_def_935,type,
    v1969: ( state_type * $int ) > $o ).

tff(pred_def_936,type,
    v1878: ( state_type * $int ) > $o ).

tff(pred_def_937,type,
    v1968: ( state_type * $int ) > $o ).

tff(pred_def_938,type,
    v1892: ( state_type * $int ) > $o ).

tff(pred_def_939,type,
    v1890: ( state_type * $int ) > $o ).

tff(pred_def_940,type,
    v1975: state_type > $o ).

tff(pred_def_941,type,
    v1973: state_type > $o ).

tff(pred_def_942,type,
    v1982: state_type > $o ).

tff(pred_def_943,type,
    v1980: state_type > $o ).

tff(pred_def_944,type,
    v1979: state_type > $o ).

tff(pred_def_945,type,
    v1978: state_type > $o ).

tff(pred_def_946,type,
    v1990: state_type > $o ).

tff(pred_def_947,type,
    v1991: state_type > $o ).

tff(pred_def_948,type,
    v1989: state_type > $o ).

tff(pred_def_949,type,
    v1986: ( state_type * $int ) > $o ).

tff(pred_def_950,type,
    v1988: ( state_type * $int ) > $o ).

tff(pred_def_951,type,
    v1880: ( state_type * $int ) > $o ).

tff(pred_def_952,type,
    v1876: ( state_type * $int ) > $o ).

tff(pred_def_953,type,
    v1874: ( state_type * $int ) > $o ).

tff(pred_def_954,type,
    v1999: state_type > $o ).

tff(pred_def_955,type,
    v1997: state_type > $o ).

tff(pred_def_956,type,
    v1996: state_type > $o ).

tff(pred_def_957,type,
    v1995: ( state_type * $int ) > $o ).

tff(pred_def_958,type,
    v1871: ( state_type * $int ) > $o ).

tff(pred_def_959,type,
    b0000101001000: $int > $o ).

tff(pred_def_960,type,
    v2004: state_type > $o ).

tff(pred_def_961,type,
    v1727: state_type > $o ).

tff(pred_def_962,type,
    v1725: state_type > $o ).

tff(pred_def_963,type,
    v2008: state_type > $o ).

tff(pred_def_964,type,
    v2007: state_type > $o ).

tff(pred_def_965,type,
    v2006: state_type > $o ).

tff(pred_def_966,type,
    v2012: state_type > $o ).

tff(pred_def_967,type,
    v2011: state_type > $o ).

tff(pred_def_968,type,
    v2010: state_type > $o ).

tff(pred_def_969,type,
    v1053: state_type > $o ).

tff(pred_def_970,type,
    v2009: state_type > $o ).

tff(pred_def_971,type,
    v1113: state_type > $o ).

tff(pred_def_972,type,
    v1111: state_type > $o ).

tff(pred_def_973,type,
    v2016: state_type > $o ).

tff(pred_def_974,type,
    v2014: state_type > $o ).

tff(pred_def_975,type,
    v2023: state_type > $o ).

tff(pred_def_976,type,
    v2021: state_type > $o ).

tff(pred_def_977,type,
    v2020: state_type > $o ).

tff(pred_def_978,type,
    v2019: state_type > $o ).

tff(pred_def_979,type,
    v2031: state_type > $o ).

tff(pred_def_980,type,
    v2032: state_type > $o ).

tff(pred_def_981,type,
    v2030: state_type > $o ).

tff(pred_def_982,type,
    v2027: state_type > $o ).

tff(pred_def_983,type,
    v2029: state_type > $o ).

tff(pred_def_984,type,
    v1055: state_type > $o ).

tff(pred_def_985,type,
    v1051: state_type > $o ).

tff(pred_def_986,type,
    v1049: state_type > $o ).

tff(pred_def_987,type,
    v1047: state_type > $o ).

tff(pred_def_988,type,
    v2058: state_type > $o ).

tff(pred_def_989,type,
    v2056: state_type > $o ).

tff(pred_def_990,type,
    v2054: state_type > $o ).

tff(pred_def_991,type,
    v2052: state_type > $o ).

tff(pred_def_992,type,
    v2066: state_type > $o ).

tff(pred_def_993,type,
    v2064: state_type > $o ).

tff(pred_def_994,type,
    v2062: state_type > $o ).

tff(pred_def_995,type,
    v2060: state_type > $o ).

tff(pred_def_996,type,
    v2046: ( state_type * $int ) > $o ).

tff(pred_def_997,type,
    v2086: state_type > $o ).

tff(pred_def_998,type,
    v2085: state_type > $o ).

tff(pred_def_999,type,
    v2084: state_type > $o ).

tff(pred_def_1000,type,
    v2083: state_type > $o ).

tff(pred_def_1001,type,
    v2082: state_type > $o ).

tff(pred_def_1002,type,
    v2081: state_type > $o ).

tff(pred_def_1003,type,
    v2080: state_type > $o ).

tff(pred_def_1004,type,
    v2087: state_type > $o ).

tff(pred_def_1005,type,
    v2079: state_type > $o ).

tff(pred_def_1006,type,
    v2088: state_type > $o ).

tff(pred_def_1007,type,
    v2078: state_type > $o ).

tff(pred_def_1008,type,
    v2091: state_type > $o ).

tff(pred_def_1009,type,
    v2092: state_type > $o ).

tff(pred_def_1010,type,
    v2090: state_type > $o ).

tff(pred_def_1011,type,
    v2093: state_type > $o ).

tff(pred_def_1012,type,
    v2089: state_type > $o ).

tff(pred_def_1013,type,
    v2096: state_type > $o ).

tff(pred_def_1014,type,
    v2097: state_type > $o ).

tff(pred_def_1015,type,
    v2095: state_type > $o ).

tff(pred_def_1016,type,
    v2098: state_type > $o ).

tff(pred_def_1017,type,
    v2094: state_type > $o ).

tff(pred_def_1018,type,
    v2101: state_type > $o ).

tff(pred_def_1019,type,
    v2102: state_type > $o ).

tff(pred_def_1020,type,
    v2100: state_type > $o ).

tff(pred_def_1021,type,
    v2103: state_type > $o ).

tff(pred_def_1022,type,
    v2099: state_type > $o ).

tff(pred_def_1023,type,
    v2106: state_type > $o ).

tff(pred_def_1024,type,
    v2107: state_type > $o ).

tff(pred_def_1025,type,
    v2105: state_type > $o ).

tff(pred_def_1026,type,
    v2108: state_type > $o ).

tff(pred_def_1027,type,
    v2104: state_type > $o ).

tff(pred_def_1028,type,
    v2111: state_type > $o ).

tff(pred_def_1029,type,
    v2112: state_type > $o ).

tff(pred_def_1030,type,
    v2110: state_type > $o ).

tff(pred_def_1031,type,
    v2113: state_type > $o ).

tff(pred_def_1032,type,
    v2109: state_type > $o ).

tff(pred_def_1033,type,
    v2116: state_type > $o ).

tff(pred_def_1034,type,
    v2117: state_type > $o ).

tff(pred_def_1035,type,
    v2115: state_type > $o ).

tff(pred_def_1036,type,
    v2118: state_type > $o ).

tff(pred_def_1037,type,
    v2114: state_type > $o ).

tff(pred_def_1038,type,
    v2074: ( state_type * $int ) > $o ).

tff(pred_def_1039,type,
    v2072: ( state_type * $int ) > $o ).

tff(pred_def_1040,type,
    v2070: ( state_type * $int ) > $o ).

tff(pred_def_1041,type,
    v2068: ( state_type * $int ) > $o ).

tff(pred_def_1042,type,
    v2135: state_type > $o ).

tff(pred_def_1043,type,
    v2133: state_type > $o ).

tff(pred_def_1044,type,
    v2131: state_type > $o ).

tff(pred_def_1045,type,
    v2141: state_type > $o ).

tff(pred_def_1046,type,
    v2139: state_type > $o ).

tff(pred_def_1047,type,
    v2145: state_type > $o ).

tff(pred_def_1048,type,
    v2143: state_type > $o ).

tff(pred_def_1049,type,
    v2153: state_type > $o ).

tff(pred_def_1050,type,
    v2151: state_type > $o ).

tff(pred_def_1051,type,
    v2149: state_type > $o ).

tff(pred_def_1052,type,
    v2147: state_type > $o ).

tff(pred_def_1053,type,
    v2137: state_type > $o ).

tff(pred_def_1054,type,
    v2159: state_type > $o ).

tff(pred_def_1055,type,
    v2161: state_type > $o ).

tff(pred_def_1056,type,
    v2157: state_type > $o ).

tff(pred_def_1057,type,
    v2156: state_type > $o ).

tff(pred_def_1058,type,
    v2167: state_type > $o ).

tff(pred_def_1059,type,
    v2168: state_type > $o ).

tff(pred_def_1060,type,
    v2164: state_type > $o ).

tff(pred_def_1061,type,
    v2166: state_type > $o ).

tff(pred_def_1062,type,
    v2178: state_type > $o ).

tff(pred_def_1063,type,
    v2176: state_type > $o ).

tff(pred_def_1064,type,
    v2174: state_type > $o ).

tff(pred_def_1065,type,
    v2172: state_type > $o ).

tff(pred_def_1066,type,
    v2180: state_type > $o ).

tff(pred_def_1067,type,
    v2129: state_type > $o ).

tff(pred_def_1068,type,
    v2127: state_type > $o ).

tff(pred_def_1069,type,
    v2125: state_type > $o ).

tff(pred_def_1070,type,
    v2123: state_type > $o ).

tff(pred_def_1071,type,
    v2121: state_type > $o ).

tff(pred_def_1072,type,
    v2187: state_type > $o ).

tff(pred_def_1073,type,
    v2185: state_type > $o ).

tff(pred_def_1074,type,
    v2184: state_type > $o ).

tff(pred_def_1075,type,
    v2183: state_type > $o ).

tff(pred_def_1076,type,
    v2195: state_type > $o ).

tff(pred_def_1077,type,
    v2196: state_type > $o ).

tff(pred_def_1078,type,
    v2194: state_type > $o ).

tff(pred_def_1079,type,
    v2191: ( state_type * $int ) > $o ).

tff(pred_def_1080,type,
    bxxxxxxxx: $int > $o ).

tff(pred_def_1081,type,
    v2193: ( state_type * $int ) > $o ).

tff(pred_def_1082,type,
    v2050: ( state_type * $int ) > $o ).

tff(pred_def_1083,type,
    v2048: ( state_type * $int ) > $o ).

tff(pred_def_1084,type,
    v2216: state_type > $o ).

tff(pred_def_1085,type,
    v2214: state_type > $o ).

tff(pred_def_1086,type,
    v2212: state_type > $o ).

tff(pred_def_1087,type,
    v2210: state_type > $o ).

tff(pred_def_1088,type,
    v2224: state_type > $o ).

tff(pred_def_1089,type,
    v2222: state_type > $o ).

tff(pred_def_1090,type,
    v2220: state_type > $o ).

tff(pred_def_1091,type,
    v2218: state_type > $o ).

tff(pred_def_1092,type,
    v2204: ( state_type * $int ) > $o ).

tff(pred_def_1093,type,
    v2242: state_type > $o ).

tff(pred_def_1094,type,
    v2241: state_type > $o ).

tff(pred_def_1095,type,
    v2240: state_type > $o ).

tff(pred_def_1096,type,
    v2239: state_type > $o ).

tff(pred_def_1097,type,
    v2238: state_type > $o ).

tff(pred_def_1098,type,
    v2243: state_type > $o ).

tff(pred_def_1099,type,
    v2237: state_type > $o ).

tff(pred_def_1100,type,
    v2244: state_type > $o ).

tff(pred_def_1101,type,
    v2236: state_type > $o ).

tff(pred_def_1102,type,
    v2247: state_type > $o ).

tff(pred_def_1103,type,
    v2248: state_type > $o ).

tff(pred_def_1104,type,
    v2246: state_type > $o ).

tff(pred_def_1105,type,
    v2249: state_type > $o ).

tff(pred_def_1106,type,
    v2245: state_type > $o ).

tff(pred_def_1107,type,
    v2252: state_type > $o ).

tff(pred_def_1108,type,
    v2253: state_type > $o ).

tff(pred_def_1109,type,
    v2251: state_type > $o ).

tff(pred_def_1110,type,
    v2254: state_type > $o ).

tff(pred_def_1111,type,
    v2250: state_type > $o ).

tff(pred_def_1112,type,
    v2257: state_type > $o ).

tff(pred_def_1113,type,
    v2258: state_type > $o ).

tff(pred_def_1114,type,
    v2256: state_type > $o ).

tff(pred_def_1115,type,
    v2259: state_type > $o ).

tff(pred_def_1116,type,
    v2255: state_type > $o ).

tff(pred_def_1117,type,
    v2262: state_type > $o ).

tff(pred_def_1118,type,
    v2263: state_type > $o ).

tff(pred_def_1119,type,
    v2261: state_type > $o ).

tff(pred_def_1120,type,
    v2264: state_type > $o ).

tff(pred_def_1121,type,
    v2260: state_type > $o ).

tff(pred_def_1122,type,
    v2234: ( state_type * $int ) > $o ).

tff(pred_def_1123,type,
    v2232: ( state_type * $int ) > $o ).

tff(pred_def_1124,type,
    v2230: ( state_type * $int ) > $o ).

tff(pred_def_1125,type,
    v2268: state_type > $o ).

tff(pred_def_1126,type,
    v2044: state_type > $o ).

tff(pred_def_1127,type,
    v2266: state_type > $o ).

tff(pred_def_1128,type,
    v2272: state_type > $o ).

tff(pred_def_1129,type,
    v2271: ( state_type * $int ) > $o ).

tff(pred_def_1130,type,
    v2270: ( state_type * $int ) > $o ).

tff(pred_def_1131,type,
    v2276: state_type > $o ).

tff(pred_def_1132,type,
    v2275: ( state_type * $int ) > $o ).

tff(pred_def_1133,type,
    v2274: ( state_type * $int ) > $o ).

tff(pred_def_1134,type,
    v2206: ( state_type * $int ) > $o ).

tff(pred_def_1135,type,
    v2273: ( state_type * $int ) > $o ).

tff(pred_def_1136,type,
    v2269: ( state_type * $int ) > $o ).

tff(pred_def_1137,type,
    v2228: ( state_type * $int ) > $o ).

tff(pred_def_1138,type,
    v2226: ( state_type * $int ) > $o ).

tff(pred_def_1139,type,
    v2282: state_type > $o ).

tff(pred_def_1140,type,
    v2280: state_type > $o ).

tff(pred_def_1141,type,
    v2278: state_type > $o ).

tff(pred_def_1142,type,
    v2289: state_type > $o ).

tff(pred_def_1143,type,
    v2287: state_type > $o ).

tff(pred_def_1144,type,
    v2286: state_type > $o ).

tff(pred_def_1145,type,
    v2285: state_type > $o ).

tff(pred_def_1146,type,
    v2297: state_type > $o ).

tff(pred_def_1147,type,
    v2298: state_type > $o ).

tff(pred_def_1148,type,
    v2296: state_type > $o ).

tff(pred_def_1149,type,
    v2293: ( state_type * $int ) > $o ).

tff(pred_def_1150,type,
    v2295: ( state_type * $int ) > $o ).

tff(pred_def_1151,type,
    v2284: ( state_type * $int ) > $o ).

tff(pred_def_1152,type,
    v2208: ( state_type * $int ) > $o ).

tff(pred_def_1153,type,
    v2310: state_type > $o ).

tff(pred_def_1154,type,
    v2308: state_type > $o ).

tff(pred_def_1155,type,
    v2314: state_type > $o ).

tff(pred_def_1156,type,
    v2312: state_type > $o ).

tff(pred_def_1157,type,
    v2338: state_type > $o ).

tff(pred_def_1158,type,
    v2336: state_type > $o ).

tff(pred_def_1159,type,
    v2334: state_type > $o ).

tff(pred_def_1160,type,
    v2342: state_type > $o ).

tff(pred_def_1161,type,
    v2340: state_type > $o ).

tff(pred_def_1162,type,
    v2356: state_type > $o ).

tff(pred_def_1163,type,
    v2354: state_type > $o ).

tff(pred_def_1164,type,
    v2360: ( state_type * $int ) > $o ).

tff(pred_def_1165,type,
    v2358: ( state_type * $int ) > $o ).

tff(pred_def_1166,type,
    v2365: ( state_type * $int ) > $o ).

tff(pred_def_1167,type,
    v2363: ( state_type * $int ) > $o ).

tff(pred_def_1168,type,
    v2369: ( state_type * $int ) > $o ).

tff(pred_def_1169,type,
    v2371: ( state_type * $int ) > $o ).

tff(pred_def_1170,type,
    v2367: ( state_type * $int ) > $o ).

tff(pred_def_1171,type,
    b0100010111000: $int > $o ).

tff(pred_def_1172,type,
    v2374: state_type > $o ).

tff(pred_def_1173,type,
    v2373: state_type > $o ).

tff(pred_def_1174,type,
    v2372: ( state_type * $int ) > $o ).

tff(pred_def_1175,type,
    v2352: ( state_type * $int ) > $o ).

tff(pred_def_1176,type,
    v2375: ( state_type * $int ) > $o ).

tff(pred_def_1177,type,
    v2350: ( state_type * $int ) > $o ).

tff(pred_def_1178,type,
    v2348: ( state_type * $int ) > $o ).

tff(pred_def_1179,type,
    v2385: ( state_type * $int ) > $o ).

tff(pred_def_1180,type,
    v2383: ( state_type * $int ) > $o ).

tff(pred_def_1181,type,
    v2381: ( state_type * $int ) > $o ).

tff(pred_def_1182,type,
    v2392: ( state_type * $int ) > $o ).

tff(pred_def_1183,type,
    v2390: ( state_type * $int ) > $o ).

tff(pred_def_1184,type,
    v2388: ( state_type * $int ) > $o ).

tff(pred_def_1185,type,
    v2399: ( state_type * $int ) > $o ).

tff(pred_def_1186,type,
    v2397: ( state_type * $int ) > $o ).

tff(pred_def_1187,type,
    v2395: ( state_type * $int ) > $o ).

tff(pred_def_1188,type,
    b10: $int > $o ).

tff(pred_def_1189,type,
    v2403: state_type > $o ).

tff(pred_def_1190,type,
    b000101: $int > $o ).

tff(pred_def_1191,type,
    v2404: state_type > $o ).

tff(pred_def_1192,type,
    v2402: state_type > $o ).

tff(pred_def_1193,type,
    b0000: $int > $o ).

tff(pred_def_1194,type,
    v2405: state_type > $o ).

tff(pred_def_1195,type,
    v2401: state_type > $o ).

tff(pred_def_1196,type,
    v2407: state_type > $o ).

tff(pred_def_1197,type,
    v2406: state_type > $o ).

tff(pred_def_1198,type,
    v2379: state_type > $o ).

tff(pred_def_1199,type,
    v2377: state_type > $o ).

tff(pred_def_1200,type,
    v2411: state_type > $o ).

tff(pred_def_1201,type,
    v2410: ( state_type * $int ) > $o ).

tff(pred_def_1202,type,
    v2409: ( state_type * $int ) > $o ).

tff(pred_def_1203,type,
    v2415: state_type > $o ).

tff(pred_def_1204,type,
    v2414: ( state_type * $int ) > $o ).

tff(pred_def_1205,type,
    v2413: ( state_type * $int ) > $o ).

tff(pred_def_1206,type,
    v2330: ( state_type * $int ) > $o ).

tff(pred_def_1207,type,
    v2412: ( state_type * $int ) > $o ).

tff(pred_def_1208,type,
    v2408: ( state_type * $int ) > $o ).

tff(pred_def_1209,type,
    v2346: ( state_type * $int ) > $o ).

tff(pred_def_1210,type,
    v2344: ( state_type * $int ) > $o ).

tff(pred_def_1211,type,
    v2419: state_type > $o ).

tff(pred_def_1212,type,
    v2417: state_type > $o ).

tff(pred_def_1213,type,
    v2426: state_type > $o ).

tff(pred_def_1214,type,
    v2424: state_type > $o ).

tff(pred_def_1215,type,
    v2423: state_type > $o ).

tff(pred_def_1216,type,
    v2422: state_type > $o ).

tff(pred_def_1217,type,
    v2434: state_type > $o ).

tff(pred_def_1218,type,
    v2435: state_type > $o ).

tff(pred_def_1219,type,
    v2433: state_type > $o ).

tff(pred_def_1220,type,
    v2430: ( state_type * $int ) > $o ).

tff(pred_def_1221,type,
    v2432: ( state_type * $int ) > $o ).

tff(pred_def_1222,type,
    v2421: ( state_type * $int ) > $o ).

tff(pred_def_1223,type,
    v2332: ( state_type * $int ) > $o ).

tff(pred_def_1224,type,
    v2328: ( state_type * $int ) > $o ).

tff(pred_def_1225,type,
    v2438: ( state_type * $int ) > $o ).

tff(pred_def_1226,type,
    v2326: ( state_type * $int ) > $o ).

tff(pred_def_1227,type,
    v2444: state_type > $o ).

tff(pred_def_1228,type,
    v2442: state_type > $o ).

tff(pred_def_1229,type,
    v2441: state_type > $o ).

tff(pred_def_1230,type,
    v2440: ( state_type * $int ) > $o ).

tff(pred_def_1231,type,
    v2452: state_type > $o ).

tff(pred_def_1232,type,
    v2450: state_type > $o ).

tff(pred_def_1233,type,
    v2449: state_type > $o ).

tff(pred_def_1234,type,
    v2448: ( state_type * $int ) > $o ).

tff(pred_def_1235,type,
    v2460: state_type > $o ).

tff(pred_def_1236,type,
    v2458: state_type > $o ).

tff(pred_def_1237,type,
    v2457: state_type > $o ).

tff(pred_def_1238,type,
    v2456: ( state_type * $int ) > $o ).

tff(pred_def_1239,type,
    v2468: state_type > $o ).

tff(pred_def_1240,type,
    v2466: state_type > $o ).

tff(pred_def_1241,type,
    v2465: state_type > $o ).

tff(pred_def_1242,type,
    v2464: ( state_type * $int ) > $o ).

tff(pred_def_1243,type,
    v2476: state_type > $o ).

tff(pred_def_1244,type,
    v2474: state_type > $o ).

tff(pred_def_1245,type,
    v2473: state_type > $o ).

tff(pred_def_1246,type,
    v2472: ( state_type * $int ) > $o ).

tff(pred_def_1247,type,
    v2484: state_type > $o ).

tff(pred_def_1248,type,
    v2482: state_type > $o ).

tff(pred_def_1249,type,
    v2481: state_type > $o ).

tff(pred_def_1250,type,
    v2480: ( state_type * $int ) > $o ).

tff(pred_def_1251,type,
    v2492: state_type > $o ).

tff(pred_def_1252,type,
    v2490: state_type > $o ).

tff(pred_def_1253,type,
    v2489: state_type > $o ).

tff(pred_def_1254,type,
    v2488: ( state_type * $int ) > $o ).

tff(pred_def_1255,type,
    v2500: state_type > $o ).

tff(pred_def_1256,type,
    v2498: state_type > $o ).

tff(pred_def_1257,type,
    v2497: state_type > $o ).

tff(pred_def_1258,type,
    v2496: ( state_type * $int ) > $o ).

tff(pred_def_1259,type,
    v2508: state_type > $o ).

tff(pred_def_1260,type,
    v2506: state_type > $o ).

tff(pred_def_1261,type,
    v2505: state_type > $o ).

tff(pred_def_1262,type,
    v2504: ( state_type * $int ) > $o ).

tff(pred_def_1263,type,
    v2516: state_type > $o ).

tff(pred_def_1264,type,
    v2514: state_type > $o ).

tff(pred_def_1265,type,
    v2513: state_type > $o ).

tff(pred_def_1266,type,
    v2512: ( state_type * $int ) > $o ).

tff(pred_def_1267,type,
    v2524: state_type > $o ).

tff(pred_def_1268,type,
    v2522: state_type > $o ).

tff(pred_def_1269,type,
    v2521: state_type > $o ).

tff(pred_def_1270,type,
    v2520: ( state_type * $int ) > $o ).

tff(pred_def_1271,type,
    v2532: state_type > $o ).

tff(pred_def_1272,type,
    v2530: state_type > $o ).

tff(pred_def_1273,type,
    v2529: state_type > $o ).

tff(pred_def_1274,type,
    v2528: ( state_type * $int ) > $o ).

tff(pred_def_1275,type,
    v2540: state_type > $o ).

tff(pred_def_1276,type,
    v2538: state_type > $o ).

tff(pred_def_1277,type,
    v2537: state_type > $o ).

tff(pred_def_1278,type,
    v2536: ( state_type * $int ) > $o ).

tff(pred_def_1279,type,
    v2548: state_type > $o ).

tff(pred_def_1280,type,
    v2546: state_type > $o ).

tff(pred_def_1281,type,
    v2545: state_type > $o ).

tff(pred_def_1282,type,
    v2544: ( state_type * $int ) > $o ).

tff(pred_def_1283,type,
    v2556: state_type > $o ).

tff(pred_def_1284,type,
    v2554: state_type > $o ).

tff(pred_def_1285,type,
    v2553: state_type > $o ).

tff(pred_def_1286,type,
    v2552: ( state_type * $int ) > $o ).

tff(pred_def_1287,type,
    v2564: state_type > $o ).

tff(pred_def_1288,type,
    v2562: state_type > $o ).

tff(pred_def_1289,type,
    v2561: state_type > $o ).

tff(pred_def_1290,type,
    v2560: ( state_type * $int ) > $o ).

tff(pred_def_1291,type,
    v2572: state_type > $o ).

tff(pred_def_1292,type,
    v2570: state_type > $o ).

tff(pred_def_1293,type,
    v2569: state_type > $o ).

tff(pred_def_1294,type,
    v2568: ( state_type * $int ) > $o ).

tff(pred_def_1295,type,
    v2586: state_type > $o ).

tff(pred_def_1296,type,
    v2584: state_type > $o ).

tff(pred_def_1297,type,
    v2590: state_type > $o ).

tff(pred_def_1298,type,
    v2588: state_type > $o ).

tff(pred_def_1299,type,
    v2596: state_type > $o ).

tff(pred_def_1300,type,
    v2594: state_type > $o ).

tff(pred_def_1301,type,
    v2592: state_type > $o ).

tff(pred_def_1302,type,
    v2600: state_type > $o ).

tff(pred_def_1303,type,
    v2598: state_type > $o ).

tff(pred_def_1304,type,
    v2607: state_type > $o ).

tff(pred_def_1305,type,
    v2605: state_type > $o ).

tff(pred_def_1306,type,
    v2604: state_type > $o ).

tff(pred_def_1307,type,
    v2603: state_type > $o ).

tff(pred_def_1308,type,
    v2615: state_type > $o ).

tff(pred_def_1309,type,
    v2616: state_type > $o ).

tff(pred_def_1310,type,
    v2614: state_type > $o ).

tff(pred_def_1311,type,
    v2611: state_type > $o ).

tff(pred_def_1312,type,
    v2613: state_type > $o ).

tff(pred_def_1313,type,
    v2582: state_type > $o ).

tff(pred_def_1314,type,
    v2580: state_type > $o ).

tff(pred_def_1315,type,
    v2578: state_type > $o ).

tff(pred_def_1316,type,
    v2621: state_type > $o ).

tff(pred_def_1317,type,
    b0000000: $int > $o ).

tff(pred_def_1318,type,
    v2619: ( state_type * $int ) > $o ).

tff(pred_def_1319,type,
    v2576: ( state_type * $int ) > $o ).

tff(pred_def_1320,type,
    v2659: state_type > $o ).

tff(pred_def_1321,type,
    v2662: state_type > $o ).

tff(pred_def_1322,type,
    v2661: state_type > $o ).

tff(pred_def_1323,type,
    v2663: state_type > $o ).

tff(pred_def_1324,type,
    v2660: state_type > $o ).

tff(pred_def_1325,type,
    v2658: state_type > $o ).

tff(pred_def_1326,type,
    v2664: state_type > $o ).

tff(pred_def_1327,type,
    v2657: state_type > $o ).

tff(pred_def_1328,type,
    v2667: state_type > $o ).

tff(pred_def_1329,type,
    v2666: state_type > $o ).

tff(pred_def_1330,type,
    v2668: state_type > $o ).

tff(pred_def_1331,type,
    v2665: state_type > $o ).

tff(pred_def_1332,type,
    v2656: state_type > $o ).

tff(pred_def_1333,type,
    v2669: state_type > $o ).

tff(pred_def_1334,type,
    v2655: state_type > $o ).

tff(pred_def_1335,type,
    v2672: state_type > $o ).

tff(pred_def_1336,type,
    v2671: state_type > $o ).

tff(pred_def_1337,type,
    v2673: state_type > $o ).

tff(pred_def_1338,type,
    v2670: state_type > $o ).

tff(pred_def_1339,type,
    v2654: state_type > $o ).

tff(pred_def_1340,type,
    v2674: state_type > $o ).

tff(pred_def_1341,type,
    v2653: state_type > $o ).

tff(pred_def_1342,type,
    v2677: state_type > $o ).

tff(pred_def_1343,type,
    v2676: state_type > $o ).

tff(pred_def_1344,type,
    v2678: state_type > $o ).

tff(pred_def_1345,type,
    v2675: state_type > $o ).

tff(pred_def_1346,type,
    v2652: state_type > $o ).

tff(pred_def_1347,type,
    v2679: state_type > $o ).

tff(pred_def_1348,type,
    v2651: state_type > $o ).

tff(pred_def_1349,type,
    v2682: state_type > $o ).

tff(pred_def_1350,type,
    v2681: state_type > $o ).

tff(pred_def_1351,type,
    v2683: state_type > $o ).

tff(pred_def_1352,type,
    v2680: state_type > $o ).

tff(pred_def_1353,type,
    v2650: state_type > $o ).

tff(pred_def_1354,type,
    v2684: state_type > $o ).

tff(pred_def_1355,type,
    v2649: state_type > $o ).

tff(pred_def_1356,type,
    v2687: state_type > $o ).

tff(pred_def_1357,type,
    v2686: state_type > $o ).

tff(pred_def_1358,type,
    v2688: state_type > $o ).

tff(pred_def_1359,type,
    v2685: state_type > $o ).

tff(pred_def_1360,type,
    v2648: state_type > $o ).

tff(pred_def_1361,type,
    v2689: state_type > $o ).

tff(pred_def_1362,type,
    v2647: state_type > $o ).

tff(pred_def_1363,type,
    v2646: state_type > $o ).

tff(pred_def_1364,type,
    v2693: state_type > $o ).

tff(pred_def_1365,type,
    v2692: state_type > $o ).

tff(pred_def_1366,type,
    v2694: state_type > $o ).

tff(pred_def_1367,type,
    v2691: state_type > $o ).

tff(pred_def_1368,type,
    v2690: state_type > $o ).

tff(pred_def_1369,type,
    v2645: state_type > $o ).

tff(pred_def_1370,type,
    v2695: state_type > $o ).

tff(pred_def_1371,type,
    v2644: state_type > $o ).

tff(pred_def_1372,type,
    v2698: state_type > $o ).

tff(pred_def_1373,type,
    v2699: state_type > $o ).

tff(pred_def_1374,type,
    v2697: state_type > $o ).

tff(pred_def_1375,type,
    v2700: state_type > $o ).

tff(pred_def_1376,type,
    v2696: state_type > $o ).

tff(pred_def_1377,type,
    v2703: state_type > $o ).

tff(pred_def_1378,type,
    v2704: state_type > $o ).

tff(pred_def_1379,type,
    v2702: state_type > $o ).

tff(pred_def_1380,type,
    v2705: state_type > $o ).

tff(pred_def_1381,type,
    v2701: state_type > $o ).

tff(pred_def_1382,type,
    v2708: state_type > $o ).

tff(pred_def_1383,type,
    v2709: state_type > $o ).

tff(pred_def_1384,type,
    v2707: state_type > $o ).

tff(pred_def_1385,type,
    v2710: state_type > $o ).

tff(pred_def_1386,type,
    v2706: state_type > $o ).

tff(pred_def_1387,type,
    v2713: state_type > $o ).

tff(pred_def_1388,type,
    v2714: state_type > $o ).

tff(pred_def_1389,type,
    v2712: state_type > $o ).

tff(pred_def_1390,type,
    v2715: state_type > $o ).

tff(pred_def_1391,type,
    v2711: state_type > $o ).

tff(pred_def_1392,type,
    v2718: state_type > $o ).

tff(pred_def_1393,type,
    v2719: state_type > $o ).

tff(pred_def_1394,type,
    v2717: state_type > $o ).

tff(pred_def_1395,type,
    v2720: state_type > $o ).

tff(pred_def_1396,type,
    v2716: state_type > $o ).

tff(pred_def_1397,type,
    v2723: state_type > $o ).

tff(pred_def_1398,type,
    v2724: state_type > $o ).

tff(pred_def_1399,type,
    v2722: state_type > $o ).

tff(pred_def_1400,type,
    v2725: state_type > $o ).

tff(pred_def_1401,type,
    v2721: state_type > $o ).

tff(pred_def_1402,type,
    v2728: state_type > $o ).

tff(pred_def_1403,type,
    v2727: state_type > $o ).

tff(pred_def_1404,type,
    v2729: state_type > $o ).

tff(pred_def_1405,type,
    v2726: state_type > $o ).

tff(pred_def_1406,type,
    v2642: ( state_type * $int ) > $o ).

tff(pred_def_1407,type,
    v2641: state_type > $o ).

tff(pred_def_1408,type,
    v2732: state_type > $o ).

tff(pred_def_1409,type,
    v2733: state_type > $o ).

tff(pred_def_1410,type,
    v2731: state_type > $o ).

tff(pred_def_1411,type,
    v2734: state_type > $o ).

tff(pred_def_1412,type,
    v2730: state_type > $o ).

tff(pred_def_1413,type,
    v2640: state_type > $o ).

tff(pred_def_1414,type,
    v2735: state_type > $o ).

tff(pred_def_1415,type,
    v2639: state_type > $o ).

tff(pred_def_1416,type,
    v2738: state_type > $o ).

tff(pred_def_1417,type,
    v2739: state_type > $o ).

tff(pred_def_1418,type,
    v2737: state_type > $o ).

tff(pred_def_1419,type,
    v2740: state_type > $o ).

tff(pred_def_1420,type,
    v2736: state_type > $o ).

tff(pred_def_1421,type,
    v2638: state_type > $o ).

tff(pred_def_1422,type,
    v2741: state_type > $o ).

tff(pred_def_1423,type,
    v2637: state_type > $o ).

tff(pred_def_1424,type,
    v2744: state_type > $o ).

tff(pred_def_1425,type,
    v2745: state_type > $o ).

tff(pred_def_1426,type,
    v2743: state_type > $o ).

tff(pred_def_1427,type,
    v2746: state_type > $o ).

tff(pred_def_1428,type,
    v2742: state_type > $o ).

tff(pred_def_1429,type,
    v2636: state_type > $o ).

tff(pred_def_1430,type,
    v2747: state_type > $o ).

tff(pred_def_1431,type,
    v2635: state_type > $o ).

tff(pred_def_1432,type,
    v2750: state_type > $o ).

tff(pred_def_1433,type,
    v2751: state_type > $o ).

tff(pred_def_1434,type,
    v2749: state_type > $o ).

tff(pred_def_1435,type,
    v2752: state_type > $o ).

tff(pred_def_1436,type,
    v2748: state_type > $o ).

tff(pred_def_1437,type,
    v2634: state_type > $o ).

tff(pred_def_1438,type,
    v2753: state_type > $o ).

tff(pred_def_1439,type,
    v2633: state_type > $o ).

tff(pred_def_1440,type,
    v2756: state_type > $o ).

tff(pred_def_1441,type,
    v2757: state_type > $o ).

tff(pred_def_1442,type,
    v2755: state_type > $o ).

tff(pred_def_1443,type,
    v2758: state_type > $o ).

tff(pred_def_1444,type,
    v2754: state_type > $o ).

tff(pred_def_1445,type,
    v2632: state_type > $o ).

tff(pred_def_1446,type,
    v2759: state_type > $o ).

tff(pred_def_1447,type,
    v2631: state_type > $o ).

tff(pred_def_1448,type,
    v2762: state_type > $o ).

tff(pred_def_1449,type,
    v2763: state_type > $o ).

tff(pred_def_1450,type,
    v2761: state_type > $o ).

tff(pred_def_1451,type,
    v2764: state_type > $o ).

tff(pred_def_1452,type,
    v2760: state_type > $o ).

tff(pred_def_1453,type,
    v2630: state_type > $o ).

tff(pred_def_1454,type,
    v2765: state_type > $o ).

tff(pred_def_1455,type,
    v2629: state_type > $o ).

tff(pred_def_1456,type,
    v2628: state_type > $o ).

tff(pred_def_1457,type,
    v2769: state_type > $o ).

tff(pred_def_1458,type,
    v2770: state_type > $o ).

tff(pred_def_1459,type,
    v2768: state_type > $o ).

tff(pred_def_1460,type,
    v2771: state_type > $o ).

tff(pred_def_1461,type,
    v2767: state_type > $o ).

tff(pred_def_1462,type,
    v2766: state_type > $o ).

tff(pred_def_1463,type,
    v2627: state_type > $o ).

tff(pred_def_1464,type,
    v2772: state_type > $o ).

tff(pred_def_1465,type,
    v2626: state_type > $o ).

tff(pred_def_1466,type,
    v2775: state_type > $o ).

tff(pred_def_1467,type,
    v2776: state_type > $o ).

tff(pred_def_1468,type,
    v2774: state_type > $o ).

tff(pred_def_1469,type,
    v2777: state_type > $o ).

tff(pred_def_1470,type,
    v2773: state_type > $o ).

tff(pred_def_1471,type,
    v2780: state_type > $o ).

tff(pred_def_1472,type,
    v2781: state_type > $o ).

tff(pred_def_1473,type,
    v2779: state_type > $o ).

tff(pred_def_1474,type,
    v2782: state_type > $o ).

tff(pred_def_1475,type,
    v2778: state_type > $o ).

tff(pred_def_1476,type,
    v2785: state_type > $o ).

tff(pred_def_1477,type,
    v2786: state_type > $o ).

tff(pred_def_1478,type,
    v2784: state_type > $o ).

tff(pred_def_1479,type,
    v2787: state_type > $o ).

tff(pred_def_1480,type,
    v2783: state_type > $o ).

tff(pred_def_1481,type,
    v2790: state_type > $o ).

tff(pred_def_1482,type,
    v2791: state_type > $o ).

tff(pred_def_1483,type,
    v2789: state_type > $o ).

tff(pred_def_1484,type,
    v2792: state_type > $o ).

tff(pred_def_1485,type,
    v2788: state_type > $o ).

tff(pred_def_1486,type,
    v2795: state_type > $o ).

tff(pred_def_1487,type,
    v2796: state_type > $o ).

tff(pred_def_1488,type,
    v2794: state_type > $o ).

tff(pred_def_1489,type,
    v2797: state_type > $o ).

tff(pred_def_1490,type,
    v2793: state_type > $o ).

tff(pred_def_1491,type,
    v2800: state_type > $o ).

tff(pred_def_1492,type,
    v2801: state_type > $o ).

tff(pred_def_1493,type,
    v2799: state_type > $o ).

tff(pred_def_1494,type,
    v2802: state_type > $o ).

tff(pred_def_1495,type,
    v2798: state_type > $o ).

tff(pred_def_1496,type,
    v2805: state_type > $o ).

tff(pred_def_1497,type,
    v2806: state_type > $o ).

tff(pred_def_1498,type,
    v2804: state_type > $o ).

tff(pred_def_1499,type,
    v2807: state_type > $o ).

tff(pred_def_1500,type,
    v2803: state_type > $o ).

tff(pred_def_1501,type,
    v2624: ( state_type * $int ) > $o ).

tff(pred_def_1502,type,
    v2623: ( state_type * $int ) > $o ).

tff(pred_def_1503,type,
    v2622: ( state_type * $int ) > $o ).

tff(pred_def_1504,type,
    v2324: ( state_type * $int ) > $o ).

tff(pred_def_1505,type,
    v2322: ( state_type * $int ) > $o ).

tff(pred_def_1506,type,
    v2320: ( state_type * $int ) > $o ).

tff(pred_def_1507,type,
    v2821: state_type > $o ).

tff(pred_def_1508,type,
    v2819: state_type > $o ).

tff(pred_def_1509,type,
    v2825: state_type > $o ).

tff(pred_def_1510,type,
    v2823: state_type > $o ).

tff(pred_def_1511,type,
    v2813: ( state_type * $int ) > $o ).

tff(pred_def_1512,type,
    v2842: state_type > $o ).

tff(pred_def_1513,type,
    v2841: state_type > $o ).

tff(pred_def_1514,type,
    v2840: state_type > $o ).

tff(pred_def_1515,type,
    v2839: state_type > $o ).

tff(pred_def_1516,type,
    v2838: state_type > $o ).

tff(pred_def_1517,type,
    v2843: state_type > $o ).

tff(pred_def_1518,type,
    v2837: state_type > $o ).

tff(pred_def_1519,type,
    v2844: state_type > $o ).

tff(pred_def_1520,type,
    v2836: state_type > $o ).

tff(pred_def_1521,type,
    v2847: state_type > $o ).

tff(pred_def_1522,type,
    v2848: state_type > $o ).

tff(pred_def_1523,type,
    v2846: state_type > $o ).

tff(pred_def_1524,type,
    v2849: state_type > $o ).

tff(pred_def_1525,type,
    v2845: state_type > $o ).

tff(pred_def_1526,type,
    v2852: state_type > $o ).

tff(pred_def_1527,type,
    v2853: state_type > $o ).

tff(pred_def_1528,type,
    v2851: state_type > $o ).

tff(pred_def_1529,type,
    v2854: state_type > $o ).

tff(pred_def_1530,type,
    v2850: state_type > $o ).

tff(pred_def_1531,type,
    v2857: state_type > $o ).

tff(pred_def_1532,type,
    v2858: state_type > $o ).

tff(pred_def_1533,type,
    v2856: state_type > $o ).

tff(pred_def_1534,type,
    v2859: state_type > $o ).

tff(pred_def_1535,type,
    v2855: state_type > $o ).

tff(pred_def_1536,type,
    v2862: state_type > $o ).

tff(pred_def_1537,type,
    v2863: state_type > $o ).

tff(pred_def_1538,type,
    v2861: state_type > $o ).

tff(pred_def_1539,type,
    v2864: state_type > $o ).

tff(pred_def_1540,type,
    v2860: state_type > $o ).

tff(pred_def_1541,type,
    v2834: ( state_type * $int ) > $o ).

tff(pred_def_1542,type,
    v2833: ( state_type * $int ) > $o ).

tff(pred_def_1543,type,
    v2831: ( state_type * $int ) > $o ).

tff(pred_def_1544,type,
    v2886: state_type > $o ).

tff(pred_def_1545,type,
    v2884: state_type > $o ).

tff(pred_def_1546,type,
    v2890: state_type > $o ).

tff(pred_def_1547,type,
    v2888: state_type > $o ).

tff(pred_def_1548,type,
    v2922: state_type > $o ).

tff(pred_def_1549,type,
    v2920: state_type > $o ).

tff(pred_def_1550,type,
    v2918: state_type > $o ).

tff(pred_def_1551,type,
    v2916: state_type > $o ).

tff(pred_def_1552,type,
    v2930: state_type > $o ).

tff(pred_def_1553,type,
    v2928: state_type > $o ).

tff(pred_def_1554,type,
    v2926: state_type > $o ).

tff(pred_def_1555,type,
    v2924: state_type > $o ).

tff(pred_def_1556,type,
    v2950: state_type > $o ).

tff(pred_def_1557,type,
    v2948: state_type > $o ).

tff(pred_def_1558,type,
    v2954: state_type > $o ).

tff(pred_def_1559,type,
    v2952: state_type > $o ).

tff(pred_def_1560,type,
    v2982: state_type > $o ).

tff(pred_def_1561,type,
    v2980: state_type > $o ).

tff(pred_def_1562,type,
    v2978: state_type > $o ).

tff(pred_def_1563,type,
    v2976: state_type > $o ).

tff(pred_def_1564,type,
    v2990: state_type > $o ).

tff(pred_def_1565,type,
    v2988: state_type > $o ).

tff(pred_def_1566,type,
    v2986: state_type > $o ).

tff(pred_def_1567,type,
    v2984: state_type > $o ).

tff(pred_def_1568,type,
    v3008: state_type > $o ).

tff(pred_def_1569,type,
    v3006: state_type > $o ).

tff(pred_def_1570,type,
    v3012: state_type > $o ).

tff(pred_def_1571,type,
    v3010: state_type > $o ).

tff(pred_def_1572,type,
    v3024: ( state_type * $int ) > $o ).

tff(pred_def_1573,type,
    v3026: ( state_type * $int ) > $o ).

tff(pred_def_1574,type,
    v3022: ( state_type * $int ) > $o ).

tff(pred_def_1575,type,
    v3020: state_type > $o ).

tff(pred_def_1576,type,
    v3018: state_type > $o ).

tff(pred_def_1577,type,
    v3035: ( state_type * $int ) > $o ).

tff(pred_def_1578,type,
    v3037: ( state_type * $int ) > $o ).

tff(pred_def_1579,type,
    v3033: state_type > $o ).

tff(pred_def_1580,type,
    v3041: ( state_type * $int ) > $o ).

tff(pred_def_1581,type,
    v3043: ( state_type * $int ) > $o ).

tff(pred_def_1582,type,
    v3039: state_type > $o ).

tff(pred_def_1583,type,
    v3045: state_type > $o ).

tff(pred_def_1584,type,
    v3055: state_type > $o ).

tff(pred_def_1585,type,
    v3053: state_type > $o ).

tff(pred_def_1586,type,
    v3059: state_type > $o ).

tff(pred_def_1587,type,
    v3057: state_type > $o ).

tff(pred_def_1588,type,
    v3077: state_type > $o ).

tff(pred_def_1589,type,
    v3075: state_type > $o ).

tff(pred_def_1590,type,
    v3081: state_type > $o ).

tff(pred_def_1591,type,
    v3079: state_type > $o ).

tff(pred_def_1592,type,
    v3091: state_type > $o ).

tff(pred_def_1593,type,
    v3093: state_type > $o ).

tff(pred_def_1594,type,
    v3089: state_type > $o ).

tff(pred_def_1595,type,
    v3087: state_type > $o ).

tff(pred_def_1596,type,
    v3095: state_type > $o ).

tff(pred_def_1597,type,
    v3097: state_type > $o ).

tff(pred_def_1598,type,
    v2998: state_type > $o ).

tff(pred_def_1599,type,
    v3102: state_type > $o ).

tff(pred_def_1600,type,
    v3101: state_type > $o ).

tff(pred_def_1601,type,
    v3100: state_type > $o ).

tff(pred_def_1602,type,
    v3105: state_type > $o ).

tff(pred_def_1603,type,
    v3104: state_type > $o ).

tff(pred_def_1604,type,
    v3103: state_type > $o ).

tff(pred_def_1605,type,
    v3099: state_type > $o ).

tff(pred_def_1606,type,
    v3110: state_type > $o ).

tff(pred_def_1607,type,
    v3109: state_type > $o ).

tff(pred_def_1608,type,
    v3108: state_type > $o ).

tff(pred_def_1609,type,
    v3071: state_type > $o ).

tff(pred_def_1610,type,
    v3107: state_type > $o ).

tff(pred_def_1611,type,
    v3113: state_type > $o ).

tff(pred_def_1612,type,
    v3112: state_type > $o ).

tff(pred_def_1613,type,
    v3111: state_type > $o ).

tff(pred_def_1614,type,
    v3106: state_type > $o ).

tff(pred_def_1615,type,
    v3085: state_type > $o ).

tff(pred_def_1616,type,
    v3083: state_type > $o ).

tff(pred_def_1617,type,
    v3129: state_type > $o ).

tff(pred_def_1618,type,
    v3127: state_type > $o ).

tff(pred_def_1619,type,
    v3125: state_type > $o ).

tff(pred_def_1620,type,
    v3135: state_type > $o ).

tff(pred_def_1621,type,
    v3133: state_type > $o ).

tff(pred_def_1622,type,
    v3139: state_type > $o ).

tff(pred_def_1623,type,
    v3137: state_type > $o ).

tff(pred_def_1624,type,
    v3147: state_type > $o ).

tff(pred_def_1625,type,
    v3145: state_type > $o ).

tff(pred_def_1626,type,
    v3143: state_type > $o ).

tff(pred_def_1627,type,
    v3141: state_type > $o ).

tff(pred_def_1628,type,
    v3131: state_type > $o ).

tff(pred_def_1629,type,
    v3153: state_type > $o ).

tff(pred_def_1630,type,
    v3155: state_type > $o ).

tff(pred_def_1631,type,
    v3151: state_type > $o ).

tff(pred_def_1632,type,
    v3150: state_type > $o ).

tff(pred_def_1633,type,
    v3161: state_type > $o ).

tff(pred_def_1634,type,
    v3162: state_type > $o ).

tff(pred_def_1635,type,
    v3158: state_type > $o ).

tff(pred_def_1636,type,
    v3160: state_type > $o ).

tff(pred_def_1637,type,
    v3172: state_type > $o ).

tff(pred_def_1638,type,
    v3170: state_type > $o ).

tff(pred_def_1639,type,
    v3168: state_type > $o ).

tff(pred_def_1640,type,
    v3166: state_type > $o ).

tff(pred_def_1641,type,
    v3174: state_type > $o ).

tff(pred_def_1642,type,
    v3123: state_type > $o ).

tff(pred_def_1643,type,
    v3121: state_type > $o ).

tff(pred_def_1644,type,
    v3119: state_type > $o ).

tff(pred_def_1645,type,
    v3117: state_type > $o ).

tff(pred_def_1646,type,
    v3115: state_type > $o ).

tff(pred_def_1647,type,
    v3181: state_type > $o ).

tff(pred_def_1648,type,
    v3179: state_type > $o ).

tff(pred_def_1649,type,
    v3178: state_type > $o ).

tff(pred_def_1650,type,
    v3177: state_type > $o ).

tff(pred_def_1651,type,
    v3189: state_type > $o ).

tff(pred_def_1652,type,
    v3190: state_type > $o ).

tff(pred_def_1653,type,
    v3188: state_type > $o ).

tff(pred_def_1654,type,
    v3185: state_type > $o ).

tff(pred_def_1655,type,
    v3187: state_type > $o ).

tff(pred_def_1656,type,
    v3073: state_type > $o ).

tff(pred_def_1657,type,
    v3069: state_type > $o ).

tff(pred_def_1658,type,
    v3203: state_type > $o ).

tff(pred_def_1659,type,
    v3201: state_type > $o ).

tff(pred_def_1660,type,
    v3207: state_type > $o ).

tff(pred_def_1661,type,
    v3205: state_type > $o ).

tff(pred_def_1662,type,
    v3215: state_type > $o ).

tff(pred_def_1663,type,
    v3213: state_type > $o ).

tff(pred_def_1664,type,
    v3226: state_type > $o ).

tff(pred_def_1665,type,
    v3225: state_type > $o ).

tff(pred_def_1666,type,
    v3227: state_type > $o ).

tff(pred_def_1667,type,
    v3224: state_type > $o ).

tff(pred_def_1668,type,
    b001: $int > $o ).

tff(pred_def_1669,type,
    v3047: ( state_type * $int ) > $o ).

tff(pred_def_1670,type,
    v3228: state_type > $o ).

tff(pred_def_1671,type,
    v3223: state_type > $o ).

tff(pred_def_1672,type,
    v3220: state_type > $o ).

tff(pred_def_1673,type,
    v3218: state_type > $o ).

tff(pred_def_1674,type,
    v3232: state_type > $o ).

tff(pred_def_1675,type,
    v3231: state_type > $o ).

tff(pred_def_1676,type,
    v3230: state_type > $o ).

tff(pred_def_1677,type,
    v3236: state_type > $o ).

tff(pred_def_1678,type,
    v3235: state_type > $o ).

tff(pred_def_1679,type,
    v3234: state_type > $o ).

tff(pred_def_1680,type,
    v3197: state_type > $o ).

tff(pred_def_1681,type,
    v3233: state_type > $o ).

tff(pred_def_1682,type,
    v3211: state_type > $o ).

tff(pred_def_1683,type,
    v3209: state_type > $o ).

tff(pred_def_1684,type,
    v3240: state_type > $o ).

tff(pred_def_1685,type,
    v3238: state_type > $o ).

tff(pred_def_1686,type,
    v3247: state_type > $o ).

tff(pred_def_1687,type,
    v3245: state_type > $o ).

tff(pred_def_1688,type,
    v3244: state_type > $o ).

tff(pred_def_1689,type,
    v3243: state_type > $o ).

tff(pred_def_1690,type,
    v3255: state_type > $o ).

tff(pred_def_1691,type,
    v3256: state_type > $o ).

tff(pred_def_1692,type,
    v3254: state_type > $o ).

tff(pred_def_1693,type,
    v3251: state_type > $o ).

tff(pred_def_1694,type,
    v3253: state_type > $o ).

tff(pred_def_1695,type,
    v3199: state_type > $o ).

tff(pred_def_1696,type,
    v3195: state_type > $o ).

tff(pred_def_1697,type,
    v3269: state_type > $o ).

tff(pred_def_1698,type,
    v3267: state_type > $o ).

tff(pred_def_1699,type,
    v3273: state_type > $o ).

tff(pred_def_1700,type,
    v3271: state_type > $o ).

tff(pred_def_1701,type,
    v3281: state_type > $o ).

tff(pred_def_1702,type,
    v3279: state_type > $o ).

tff(pred_def_1703,type,
    v3292: state_type > $o ).

tff(pred_def_1704,type,
    v3291: state_type > $o ).

tff(pred_def_1705,type,
    v3293: state_type > $o ).

tff(pred_def_1706,type,
    v3290: state_type > $o ).

tff(pred_def_1707,type,
    b010: $int > $o ).

tff(pred_def_1708,type,
    v3294: state_type > $o ).

tff(pred_def_1709,type,
    v3289: state_type > $o ).

tff(pred_def_1710,type,
    v3286: state_type > $o ).

tff(pred_def_1711,type,
    v3284: state_type > $o ).

tff(pred_def_1712,type,
    v3298: state_type > $o ).

tff(pred_def_1713,type,
    v3297: state_type > $o ).

tff(pred_def_1714,type,
    v3296: state_type > $o ).

tff(pred_def_1715,type,
    v3302: state_type > $o ).

tff(pred_def_1716,type,
    v3301: state_type > $o ).

tff(pred_def_1717,type,
    v3300: state_type > $o ).

tff(pred_def_1718,type,
    v3263: state_type > $o ).

tff(pred_def_1719,type,
    v3299: state_type > $o ).

tff(pred_def_1720,type,
    v3277: state_type > $o ).

tff(pred_def_1721,type,
    v3275: state_type > $o ).

tff(pred_def_1722,type,
    v3306: state_type > $o ).

tff(pred_def_1723,type,
    v3304: state_type > $o ).

tff(pred_def_1724,type,
    v3313: state_type > $o ).

tff(pred_def_1725,type,
    v3311: state_type > $o ).

tff(pred_def_1726,type,
    v3310: state_type > $o ).

tff(pred_def_1727,type,
    v3309: state_type > $o ).

tff(pred_def_1728,type,
    v3321: state_type > $o ).

tff(pred_def_1729,type,
    v3322: state_type > $o ).

tff(pred_def_1730,type,
    v3320: state_type > $o ).

tff(pred_def_1731,type,
    v3317: state_type > $o ).

tff(pred_def_1732,type,
    v3319: state_type > $o ).

tff(pred_def_1733,type,
    v3265: state_type > $o ).

tff(pred_def_1734,type,
    v3261: state_type > $o ).

tff(pred_def_1735,type,
    v3335: state_type > $o ).

tff(pred_def_1736,type,
    v3333: state_type > $o ).

tff(pred_def_1737,type,
    v3339: state_type > $o ).

tff(pred_def_1738,type,
    v3337: state_type > $o ).

tff(pred_def_1739,type,
    v3347: state_type > $o ).

tff(pred_def_1740,type,
    v3345: state_type > $o ).

tff(pred_def_1741,type,
    v3358: state_type > $o ).

tff(pred_def_1742,type,
    v3357: state_type > $o ).

tff(pred_def_1743,type,
    v3359: state_type > $o ).

tff(pred_def_1744,type,
    v3356: state_type > $o ).

tff(pred_def_1745,type,
    b011: $int > $o ).

tff(pred_def_1746,type,
    v3360: state_type > $o ).

tff(pred_def_1747,type,
    v3355: state_type > $o ).

tff(pred_def_1748,type,
    v3352: state_type > $o ).

tff(pred_def_1749,type,
    v3350: state_type > $o ).

tff(pred_def_1750,type,
    v3364: state_type > $o ).

tff(pred_def_1751,type,
    v3363: state_type > $o ).

tff(pred_def_1752,type,
    v3362: state_type > $o ).

tff(pred_def_1753,type,
    v3368: state_type > $o ).

tff(pred_def_1754,type,
    v3367: state_type > $o ).

tff(pred_def_1755,type,
    v3366: state_type > $o ).

tff(pred_def_1756,type,
    v3329: state_type > $o ).

tff(pred_def_1757,type,
    v3365: state_type > $o ).

tff(pred_def_1758,type,
    v3343: state_type > $o ).

tff(pred_def_1759,type,
    v3341: state_type > $o ).

tff(pred_def_1760,type,
    v3372: state_type > $o ).

tff(pred_def_1761,type,
    v3370: state_type > $o ).

tff(pred_def_1762,type,
    v3379: state_type > $o ).

tff(pred_def_1763,type,
    v3377: state_type > $o ).

tff(pred_def_1764,type,
    v3376: state_type > $o ).

tff(pred_def_1765,type,
    v3375: state_type > $o ).

tff(pred_def_1766,type,
    v3387: state_type > $o ).

tff(pred_def_1767,type,
    v3388: state_type > $o ).

tff(pred_def_1768,type,
    v3386: state_type > $o ).

tff(pred_def_1769,type,
    v3383: state_type > $o ).

tff(pred_def_1770,type,
    v3385: state_type > $o ).

tff(pred_def_1771,type,
    v3331: state_type > $o ).

tff(pred_def_1772,type,
    v3327: state_type > $o ).

tff(pred_def_1773,type,
    v3401: state_type > $o ).

tff(pred_def_1774,type,
    v3399: state_type > $o ).

tff(pred_def_1775,type,
    v3405: state_type > $o ).

tff(pred_def_1776,type,
    v3403: state_type > $o ).

tff(pred_def_1777,type,
    v3413: state_type > $o ).

tff(pred_def_1778,type,
    v3411: state_type > $o ).

tff(pred_def_1779,type,
    v3424: state_type > $o ).

tff(pred_def_1780,type,
    v3423: state_type > $o ).

tff(pred_def_1781,type,
    v3425: state_type > $o ).

tff(pred_def_1782,type,
    v3422: state_type > $o ).

tff(pred_def_1783,type,
    b100: $int > $o ).

tff(pred_def_1784,type,
    v3426: state_type > $o ).

tff(pred_def_1785,type,
    v3421: state_type > $o ).

tff(pred_def_1786,type,
    v3418: state_type > $o ).

tff(pred_def_1787,type,
    v3416: state_type > $o ).

tff(pred_def_1788,type,
    v3430: state_type > $o ).

tff(pred_def_1789,type,
    v3429: state_type > $o ).

tff(pred_def_1790,type,
    v3428: state_type > $o ).

tff(pred_def_1791,type,
    v3434: state_type > $o ).

tff(pred_def_1792,type,
    v3433: state_type > $o ).

tff(pred_def_1793,type,
    v3432: state_type > $o ).

tff(pred_def_1794,type,
    v3395: state_type > $o ).

tff(pred_def_1795,type,
    v3431: state_type > $o ).

tff(pred_def_1796,type,
    v3409: state_type > $o ).

tff(pred_def_1797,type,
    v3407: state_type > $o ).

tff(pred_def_1798,type,
    v3438: state_type > $o ).

tff(pred_def_1799,type,
    v3436: state_type > $o ).

tff(pred_def_1800,type,
    v3445: state_type > $o ).

tff(pred_def_1801,type,
    v3443: state_type > $o ).

tff(pred_def_1802,type,
    v3442: state_type > $o ).

tff(pred_def_1803,type,
    v3441: state_type > $o ).

tff(pred_def_1804,type,
    v3453: state_type > $o ).

tff(pred_def_1805,type,
    v3454: state_type > $o ).

tff(pred_def_1806,type,
    v3452: state_type > $o ).

tff(pred_def_1807,type,
    v3449: state_type > $o ).

tff(pred_def_1808,type,
    v3451: state_type > $o ).

tff(pred_def_1809,type,
    v3397: state_type > $o ).

tff(pred_def_1810,type,
    v3393: state_type > $o ).

tff(pred_def_1811,type,
    v3467: state_type > $o ).

tff(pred_def_1812,type,
    v3465: state_type > $o ).

tff(pred_def_1813,type,
    v3471: state_type > $o ).

tff(pred_def_1814,type,
    v3469: state_type > $o ).

tff(pred_def_1815,type,
    v3479: state_type > $o ).

tff(pred_def_1816,type,
    v3477: state_type > $o ).

tff(pred_def_1817,type,
    v3490: state_type > $o ).

tff(pred_def_1818,type,
    v3489: state_type > $o ).

tff(pred_def_1819,type,
    v3491: state_type > $o ).

tff(pred_def_1820,type,
    v3488: state_type > $o ).

tff(pred_def_1821,type,
    b101: $int > $o ).

tff(pred_def_1822,type,
    v3492: state_type > $o ).

tff(pred_def_1823,type,
    v3487: state_type > $o ).

tff(pred_def_1824,type,
    v3484: state_type > $o ).

tff(pred_def_1825,type,
    v3482: state_type > $o ).

tff(pred_def_1826,type,
    v3496: state_type > $o ).

tff(pred_def_1827,type,
    v3495: state_type > $o ).

tff(pred_def_1828,type,
    v3494: state_type > $o ).

tff(pred_def_1829,type,
    v3500: state_type > $o ).

tff(pred_def_1830,type,
    v3499: state_type > $o ).

tff(pred_def_1831,type,
    v3498: state_type > $o ).

tff(pred_def_1832,type,
    v3461: state_type > $o ).

tff(pred_def_1833,type,
    v3497: state_type > $o ).

tff(pred_def_1834,type,
    v3475: state_type > $o ).

tff(pred_def_1835,type,
    v3473: state_type > $o ).

tff(pred_def_1836,type,
    v3504: state_type > $o ).

tff(pred_def_1837,type,
    v3502: state_type > $o ).

tff(pred_def_1838,type,
    v3511: state_type > $o ).

tff(pred_def_1839,type,
    v3509: state_type > $o ).

tff(pred_def_1840,type,
    v3508: state_type > $o ).

tff(pred_def_1841,type,
    v3507: state_type > $o ).

tff(pred_def_1842,type,
    v3519: state_type > $o ).

tff(pred_def_1843,type,
    v3520: state_type > $o ).

tff(pred_def_1844,type,
    v3518: state_type > $o ).

tff(pred_def_1845,type,
    v3515: state_type > $o ).

tff(pred_def_1846,type,
    v3517: state_type > $o ).

tff(pred_def_1847,type,
    v3463: state_type > $o ).

tff(pred_def_1848,type,
    v3459: state_type > $o ).

tff(pred_def_1849,type,
    v3533: state_type > $o ).

tff(pred_def_1850,type,
    v3531: state_type > $o ).

tff(pred_def_1851,type,
    v3537: state_type > $o ).

tff(pred_def_1852,type,
    v3535: state_type > $o ).

tff(pred_def_1853,type,
    v3545: state_type > $o ).

tff(pred_def_1854,type,
    v3543: state_type > $o ).

tff(pred_def_1855,type,
    v3556: state_type > $o ).

tff(pred_def_1856,type,
    v3555: state_type > $o ).

tff(pred_def_1857,type,
    v3557: state_type > $o ).

tff(pred_def_1858,type,
    v3554: state_type > $o ).

tff(pred_def_1859,type,
    b110: $int > $o ).

tff(pred_def_1860,type,
    v3558: state_type > $o ).

tff(pred_def_1861,type,
    v3553: state_type > $o ).

tff(pred_def_1862,type,
    v3550: state_type > $o ).

tff(pred_def_1863,type,
    v3548: state_type > $o ).

tff(pred_def_1864,type,
    v3562: state_type > $o ).

tff(pred_def_1865,type,
    v3561: state_type > $o ).

tff(pred_def_1866,type,
    v3560: state_type > $o ).

tff(pred_def_1867,type,
    v3566: state_type > $o ).

tff(pred_def_1868,type,
    v3565: state_type > $o ).

tff(pred_def_1869,type,
    v3564: state_type > $o ).

tff(pred_def_1870,type,
    v3527: state_type > $o ).

tff(pred_def_1871,type,
    v3563: state_type > $o ).

tff(pred_def_1872,type,
    v3541: state_type > $o ).

tff(pred_def_1873,type,
    v3539: state_type > $o ).

tff(pred_def_1874,type,
    v3570: state_type > $o ).

tff(pred_def_1875,type,
    v3568: state_type > $o ).

tff(pred_def_1876,type,
    v3577: state_type > $o ).

tff(pred_def_1877,type,
    v3575: state_type > $o ).

tff(pred_def_1878,type,
    v3574: state_type > $o ).

tff(pred_def_1879,type,
    v3573: state_type > $o ).

tff(pred_def_1880,type,
    v3585: state_type > $o ).

tff(pred_def_1881,type,
    v3586: state_type > $o ).

tff(pred_def_1882,type,
    v3584: state_type > $o ).

tff(pred_def_1883,type,
    v3581: state_type > $o ).

tff(pred_def_1884,type,
    v3583: state_type > $o ).

tff(pred_def_1885,type,
    v3529: state_type > $o ).

tff(pred_def_1886,type,
    v3525: state_type > $o ).

tff(pred_def_1887,type,
    v3599: state_type > $o ).

tff(pred_def_1888,type,
    v3597: state_type > $o ).

tff(pred_def_1889,type,
    v3603: state_type > $o ).

tff(pred_def_1890,type,
    v3601: state_type > $o ).

tff(pred_def_1891,type,
    v3611: state_type > $o ).

tff(pred_def_1892,type,
    v3609: state_type > $o ).

tff(pred_def_1893,type,
    v3622: state_type > $o ).

tff(pred_def_1894,type,
    v3621: state_type > $o ).

tff(pred_def_1895,type,
    v3623: state_type > $o ).

tff(pred_def_1896,type,
    v3620: state_type > $o ).

tff(pred_def_1897,type,
    b111: $int > $o ).

tff(pred_def_1898,type,
    v3624: state_type > $o ).

tff(pred_def_1899,type,
    v3619: state_type > $o ).

tff(pred_def_1900,type,
    v3616: state_type > $o ).

tff(pred_def_1901,type,
    v3614: state_type > $o ).

tff(pred_def_1902,type,
    v3628: state_type > $o ).

tff(pred_def_1903,type,
    v3627: state_type > $o ).

tff(pred_def_1904,type,
    v3626: state_type > $o ).

tff(pred_def_1905,type,
    v3632: state_type > $o ).

tff(pred_def_1906,type,
    v3631: state_type > $o ).

tff(pred_def_1907,type,
    v3630: state_type > $o ).

tff(pred_def_1908,type,
    v3593: state_type > $o ).

tff(pred_def_1909,type,
    v3629: state_type > $o ).

tff(pred_def_1910,type,
    v3607: state_type > $o ).

tff(pred_def_1911,type,
    v3605: state_type > $o ).

tff(pred_def_1912,type,
    v3636: state_type > $o ).

tff(pred_def_1913,type,
    v3634: state_type > $o ).

tff(pred_def_1914,type,
    v3643: state_type > $o ).

tff(pred_def_1915,type,
    v3641: state_type > $o ).

tff(pred_def_1916,type,
    v3640: state_type > $o ).

tff(pred_def_1917,type,
    v3639: state_type > $o ).

tff(pred_def_1918,type,
    v3651: state_type > $o ).

tff(pred_def_1919,type,
    v3652: state_type > $o ).

tff(pred_def_1920,type,
    v3650: state_type > $o ).

tff(pred_def_1921,type,
    v3647: state_type > $o ).

tff(pred_def_1922,type,
    v3649: state_type > $o ).

tff(pred_def_1923,type,
    v3595: state_type > $o ).

tff(pred_def_1924,type,
    v3591: state_type > $o ).

tff(pred_def_1925,type,
    v3665: ( state_type * $int ) > $o ).

tff(pred_def_1926,type,
    b000: $int > $o ).

tff(pred_def_1927,type,
    v3664: ( state_type * $int ) > $o ).

tff(pred_def_1928,type,
    v3663: ( state_type * $int ) > $o ).

tff(pred_def_1929,type,
    v3662: ( state_type * $int ) > $o ).

tff(pred_def_1930,type,
    v3661: ( state_type * $int ) > $o ).

tff(pred_def_1931,type,
    v3660: ( state_type * $int ) > $o ).

tff(pred_def_1932,type,
    v3657: ( state_type * $int ) > $o ).

tff(pred_def_1933,type,
    v3673: state_type > $o ).

tff(pred_def_1934,type,
    v3672: state_type > $o ).

tff(pred_def_1935,type,
    v3674: state_type > $o ).

tff(pred_def_1936,type,
    v3671: state_type > $o ).

tff(pred_def_1937,type,
    v3675: state_type > $o ).

tff(pred_def_1938,type,
    v3670: state_type > $o ).

tff(pred_def_1939,type,
    v3678: state_type > $o ).

tff(pred_def_1940,type,
    v3679: state_type > $o ).

tff(pred_def_1941,type,
    v3677: state_type > $o ).

tff(pred_def_1942,type,
    v3680: state_type > $o ).

tff(pred_def_1943,type,
    v3676: state_type > $o ).

tff(pred_def_1944,type,
    v3668: ( state_type * $int ) > $o ).

tff(pred_def_1945,type,
    v3667: ( state_type * $int ) > $o ).

tff(pred_def_1946,type,
    v3000: state_type > $o ).

tff(pred_def_1947,type,
    v3684: state_type > $o ).

tff(pred_def_1948,type,
    v3685: state_type > $o ).

tff(pred_def_1949,type,
    v3683: state_type > $o ).

tff(pred_def_1950,type,
    v3682: state_type > $o ).

tff(pred_def_1951,type,
    v3689: state_type > $o ).

tff(pred_def_1952,type,
    v3690: state_type > $o ).

tff(pred_def_1953,type,
    v3688: state_type > $o ).

tff(pred_def_1954,type,
    v3687: state_type > $o ).

tff(pred_def_1955,type,
    v3694: state_type > $o ).

tff(pred_def_1956,type,
    v3695: state_type > $o ).

tff(pred_def_1957,type,
    v3693: state_type > $o ).

tff(pred_def_1958,type,
    v3692: state_type > $o ).

tff(pred_def_1959,type,
    v3699: state_type > $o ).

tff(pred_def_1960,type,
    v3700: state_type > $o ).

tff(pred_def_1961,type,
    v3698: state_type > $o ).

tff(pred_def_1962,type,
    v3697: state_type > $o ).

tff(pred_def_1963,type,
    v3704: state_type > $o ).

tff(pred_def_1964,type,
    v3705: state_type > $o ).

tff(pred_def_1965,type,
    v3703: state_type > $o ).

tff(pred_def_1966,type,
    v3702: state_type > $o ).

tff(pred_def_1967,type,
    v3709: state_type > $o ).

tff(pred_def_1968,type,
    v3710: state_type > $o ).

tff(pred_def_1969,type,
    v3708: state_type > $o ).

tff(pred_def_1970,type,
    v3707: state_type > $o ).

tff(pred_def_1971,type,
    v3714: state_type > $o ).

tff(pred_def_1972,type,
    v3715: state_type > $o ).

tff(pred_def_1973,type,
    v3713: state_type > $o ).

tff(pred_def_1974,type,
    v3712: state_type > $o ).

tff(pred_def_1975,type,
    v3719: state_type > $o ).

tff(pred_def_1976,type,
    v3720: state_type > $o ).

tff(pred_def_1977,type,
    v3718: state_type > $o ).

tff(pred_def_1978,type,
    v3717: state_type > $o ).

tff(pred_def_1979,type,
    v3729: state_type > $o ).

tff(pred_def_1980,type,
    v3728: state_type > $o ).

tff(pred_def_1981,type,
    v3727: state_type > $o ).

tff(pred_def_1982,type,
    v3726: state_type > $o ).

tff(pred_def_1983,type,
    v3725: state_type > $o ).

tff(pred_def_1984,type,
    v3724: state_type > $o ).

tff(pred_def_1985,type,
    v3723: state_type > $o ).

tff(pred_def_1986,type,
    v3737: state_type > $o ).

tff(pred_def_1987,type,
    v3736: state_type > $o ).

tff(pred_def_1988,type,
    v3735: state_type > $o ).

tff(pred_def_1989,type,
    v3734: state_type > $o ).

tff(pred_def_1990,type,
    v3733: state_type > $o ).

tff(pred_def_1991,type,
    v3732: state_type > $o ).

tff(pred_def_1992,type,
    v3730: state_type > $o ).

tff(pred_def_1993,type,
    v3722: state_type > $o ).

tff(pred_def_1994,type,
    v3738: ( state_type * $int ) > $o ).

tff(pred_def_1995,type,
    v3721: ( state_type * $int ) > $o ).

tff(pred_def_1996,type,
    b111000: $int > $o ).

tff(pred_def_1997,type,
    v3716: ( state_type * $int ) > $o ).

tff(pred_def_1998,type,
    b110000: $int > $o ).

tff(pred_def_1999,type,
    v3711: ( state_type * $int ) > $o ).

tff(pred_def_2000,type,
    b101000: $int > $o ).

tff(pred_def_2001,type,
    v3706: ( state_type * $int ) > $o ).

tff(pred_def_2002,type,
    b100000: $int > $o ).

tff(pred_def_2003,type,
    v3701: ( state_type * $int ) > $o ).

tff(pred_def_2004,type,
    b011000: $int > $o ).

tff(pred_def_2005,type,
    v3696: ( state_type * $int ) > $o ).

tff(pred_def_2006,type,
    b010000: $int > $o ).

tff(pred_def_2007,type,
    v3691: ( state_type * $int ) > $o ).

tff(pred_def_2008,type,
    b001000: $int > $o ).

tff(pred_def_2009,type,
    v3686: ( state_type * $int ) > $o ).

tff(pred_def_2010,type,
    b000000: $int > $o ).

tff(pred_def_2011,type,
    v3681: ( state_type * $int ) > $o ).

tff(pred_def_2012,type,
    v3666: ( state_type * $int ) > $o ).

tff(pred_def_2013,type,
    v3067: ( state_type * $int ) > $o ).

tff(pred_def_2014,type,
    v3065: ( state_type * $int ) > $o ).

tff(pred_def_2015,type,
    v3063: ( state_type * $int ) > $o ).

tff(pred_def_2016,type,
    v3061: ( state_type * $int ) > $o ).

tff(pred_def_2017,type,
    v3742: state_type > $o ).

tff(pred_def_2018,type,
    v3740: state_type > $o ).

tff(pred_def_2019,type,
    v3749: state_type > $o ).

tff(pred_def_2020,type,
    v3747: state_type > $o ).

tff(pred_def_2021,type,
    v3746: state_type > $o ).

tff(pred_def_2022,type,
    v3745: state_type > $o ).

tff(pred_def_2023,type,
    v3757: state_type > $o ).

tff(pred_def_2024,type,
    v3758: state_type > $o ).

tff(pred_def_2025,type,
    v3756: state_type > $o ).

tff(pred_def_2026,type,
    v3753: ( state_type * $int ) > $o ).

tff(pred_def_2027,type,
    v3755: ( state_type * $int ) > $o ).

tff(pred_def_2028,type,
    v3744: ( state_type * $int ) > $o ).

tff(pred_def_2029,type,
    v3051: ( state_type * $int ) > $o ).

tff(pred_def_2030,type,
    v3049: ( state_type * $int ) > $o ).

tff(pred_def_2031,type,
    v3765: state_type > $o ).

tff(pred_def_2032,type,
    v3764: state_type > $o ).

tff(pred_def_2033,type,
    v3766: state_type > $o ).

tff(pred_def_2034,type,
    v3763: state_type > $o ).

tff(pred_def_2035,type,
    v3767: state_type > $o ).

tff(pred_def_2036,type,
    v3762: state_type > $o ).

tff(pred_def_2037,type,
    v3031: state_type > $o ).

tff(pred_def_2038,type,
    v3029: state_type > $o ).

tff(pred_def_2039,type,
    v3771: state_type > $o ).

tff(pred_def_2040,type,
    v3770: state_type > $o ).

tff(pred_def_2041,type,
    v3769: state_type > $o ).

tff(pred_def_2042,type,
    v3775: state_type > $o ).

tff(pred_def_2043,type,
    v3774: state_type > $o ).

tff(pred_def_2044,type,
    v3773: state_type > $o ).

tff(pred_def_2045,type,
    v3002: state_type > $o ).

tff(pred_def_2046,type,
    v3772: state_type > $o ).

tff(pred_def_2047,type,
    v3016: state_type > $o ).

tff(pred_def_2048,type,
    v3014: state_type > $o ).

tff(pred_def_2049,type,
    v3779: state_type > $o ).

tff(pred_def_2050,type,
    v3777: state_type > $o ).

tff(pred_def_2051,type,
    v3786: state_type > $o ).

tff(pred_def_2052,type,
    v3784: state_type > $o ).

tff(pred_def_2053,type,
    v3783: state_type > $o ).

tff(pred_def_2054,type,
    v3782: state_type > $o ).

tff(pred_def_2055,type,
    v3794: state_type > $o ).

tff(pred_def_2056,type,
    v3795: state_type > $o ).

tff(pred_def_2057,type,
    v3793: state_type > $o ).

tff(pred_def_2058,type,
    v3790: state_type > $o ).

tff(pred_def_2059,type,
    v3792: state_type > $o ).

tff(pred_def_2060,type,
    v3004: state_type > $o ).

tff(pred_def_2061,type,
    v3807: state_type > $o ).

tff(pred_def_2062,type,
    v3805: state_type > $o ).

tff(pred_def_2063,type,
    v3811: state_type > $o ).

tff(pred_def_2064,type,
    v3809: state_type > $o ).

tff(pred_def_2065,type,
    v3819: state_type > $o ).

tff(pred_def_2066,type,
    v3821: state_type > $o ).

tff(pred_def_2067,type,
    v3820: ( state_type * $int ) > $o ).

tff(pred_def_2068,type,
    v3822: state_type > $o ).

tff(pred_def_2069,type,
    v3817: ( state_type * $int ) > $o ).

tff(pred_def_2070,type,
    v3815: ( state_type * $int ) > $o ).

tff(pred_def_2071,type,
    v3813: ( state_type * $int ) > $o ).

tff(pred_def_2072,type,
    v3827: state_type > $o ).

tff(pred_def_2073,type,
    v3825: state_type > $o ).

tff(pred_def_2074,type,
    v3834: state_type > $o ).

tff(pred_def_2075,type,
    v3832: state_type > $o ).

tff(pred_def_2076,type,
    v3831: state_type > $o ).

tff(pred_def_2077,type,
    v3830: state_type > $o ).

tff(pred_def_2078,type,
    v3842: state_type > $o ).

tff(pred_def_2079,type,
    v3843: state_type > $o ).

tff(pred_def_2080,type,
    v3841: state_type > $o ).

tff(pred_def_2081,type,
    v3838: ( state_type * $int ) > $o ).

tff(pred_def_2082,type,
    bxxx: $int > $o ).

tff(pred_def_2083,type,
    v3840: ( state_type * $int ) > $o ).

tff(pred_def_2084,type,
    v3829: ( state_type * $int ) > $o ).

tff(pred_def_2085,type,
    v3803: ( state_type * $int ) > $o ).

tff(pred_def_2086,type,
    v3801: ( state_type * $int ) > $o ).

tff(pred_def_2087,type,
    v3799: state_type > $o ).

tff(pred_def_2088,type,
    v3855: state_type > $o ).

tff(pred_def_2089,type,
    v3854: state_type > $o ).

tff(pred_def_2090,type,
    v3853: state_type > $o ).

tff(pred_def_2091,type,
    v3852: state_type > $o ).

tff(pred_def_2092,type,
    v3851: state_type > $o ).

tff(pred_def_2093,type,
    v3850: state_type > $o ).

tff(pred_def_2094,type,
    v3849: state_type > $o ).

tff(pred_def_2095,type,
    v3848: state_type > $o ).

tff(pred_def_2096,type,
    v3847: state_type > $o ).

tff(pred_def_2097,type,
    v3856: ( state_type * $int ) > $o ).

tff(pred_def_2098,type,
    v3857: state_type > $o ).

tff(pred_def_2099,type,
    v2996: ( state_type * $int ) > $o ).

tff(pred_def_2100,type,
    v3859: state_type > $o ).

tff(pred_def_2101,type,
    v3863: state_type > $o ).

tff(pred_def_2102,type,
    v3862: ( state_type * $int ) > $o ).

tff(pred_def_2103,type,
    v3861: ( state_type * $int ) > $o ).

tff(pred_def_2104,type,
    v3867: state_type > $o ).

tff(pred_def_2105,type,
    v3866: ( state_type * $int ) > $o ).

tff(pred_def_2106,type,
    v3865: ( state_type * $int ) > $o ).

tff(pred_def_2107,type,
    v2972: ( state_type * $int ) > $o ).

tff(pred_def_2108,type,
    v3864: ( state_type * $int ) > $o ).

tff(pred_def_2109,type,
    v3860: ( state_type * $int ) > $o ).

tff(pred_def_2110,type,
    v2994: ( state_type * $int ) > $o ).

tff(pred_def_2111,type,
    v2992: ( state_type * $int ) > $o ).

tff(pred_def_2112,type,
    v3871: state_type > $o ).

tff(pred_def_2113,type,
    v3869: state_type > $o ).

tff(pred_def_2114,type,
    v3878: state_type > $o ).

tff(pred_def_2115,type,
    v3876: state_type > $o ).

tff(pred_def_2116,type,
    v3875: state_type > $o ).

tff(pred_def_2117,type,
    v3874: state_type > $o ).

tff(pred_def_2118,type,
    v3886: state_type > $o ).

tff(pred_def_2119,type,
    v3887: state_type > $o ).

tff(pred_def_2120,type,
    v3885: state_type > $o ).

tff(pred_def_2121,type,
    v3882: ( state_type * $int ) > $o ).

tff(pred_def_2122,type,
    v3884: ( state_type * $int ) > $o ).

tff(pred_def_2123,type,
    v3873: ( state_type * $int ) > $o ).

tff(pred_def_2124,type,
    v2974: ( state_type * $int ) > $o ).

tff(pred_def_2125,type,
    v2970: state_type > $o ).

tff(pred_def_2126,type,
    v2968: state_type > $o ).

tff(pred_def_2127,type,
    v2966: state_type > $o ).

tff(pred_def_2128,type,
    v2964: state_type > $o ).

tff(pred_def_2129,type,
    v2962: state_type > $o ).

tff(pred_def_2130,type,
    v3890: ( state_type * $int ) > $o ).

tff(pred_def_2131,type,
    v3891: state_type > $o ).

tff(pred_def_2132,type,
    v3892: ( state_type * $int ) > $o ).

tff(pred_def_2133,type,
    v2960: ( state_type * $int ) > $o ).

tff(pred_def_2134,type,
    v2958: ( state_type * $int ) > $o ).

tff(pred_def_2135,type,
    v2956: ( state_type * $int ) > $o ).

tff(pred_def_2136,type,
    v3898: state_type > $o ).

tff(pred_def_2137,type,
    v3896: state_type > $o ).

tff(pred_def_2138,type,
    v3894: state_type > $o ).

tff(pred_def_2139,type,
    v3905: state_type > $o ).

tff(pred_def_2140,type,
    v3903: state_type > $o ).

tff(pred_def_2141,type,
    v3902: state_type > $o ).

tff(pred_def_2142,type,
    v3901: state_type > $o ).

tff(pred_def_2143,type,
    v3913: state_type > $o ).

tff(pred_def_2144,type,
    v3914: state_type > $o ).

tff(pred_def_2145,type,
    v3912: state_type > $o ).

tff(pred_def_2146,type,
    v3909: ( state_type * $int ) > $o ).

tff(pred_def_2147,type,
    v3911: ( state_type * $int ) > $o ).

tff(pred_def_2148,type,
    v3900: ( state_type * $int ) > $o ).

tff(pred_def_2149,type,
    v2946: ( state_type * $int ) > $o ).

tff(pred_def_2150,type,
    v2944: ( state_type * $int ) > $o ).

tff(pred_def_2151,type,
    v2942: state_type > $o ).

tff(pred_def_2152,type,
    v3926: state_type > $o ).

tff(pred_def_2153,type,
    v3924: state_type > $o ).

tff(pred_def_2154,type,
    v3930: state_type > $o ).

tff(pred_def_2155,type,
    v3928: state_type > $o ).

tff(pred_def_2156,type,
    v3964: state_type > $o ).

tff(pred_def_2157,type,
    v3962: state_type > $o ).

tff(pred_def_2158,type,
    v3960: state_type > $o ).

tff(pred_def_2159,type,
    v3958: state_type > $o ).

tff(pred_def_2160,type,
    v3956: state_type > $o ).

tff(pred_def_2161,type,
    v3954: state_type > $o ).

tff(pred_def_2162,type,
    v3952: state_type > $o ).

tff(pred_def_2163,type,
    v3978: state_type > $o ).

tff(pred_def_2164,type,
    v3976: state_type > $o ).

tff(pred_def_2165,type,
    v3974: state_type > $o ).

tff(pred_def_2166,type,
    v3972: state_type > $o ).

tff(pred_def_2167,type,
    v3970: state_type > $o ).

tff(pred_def_2168,type,
    v3968: state_type > $o ).

tff(pred_def_2169,type,
    v3966: state_type > $o ).

tff(pred_def_2170,type,
    v3986: state_type > $o ).

tff(pred_def_2171,type,
    v3984: state_type > $o ).

tff(pred_def_2172,type,
    v3988: state_type > $o ).

tff(pred_def_2173,type,
    v3987: ( state_type * $int ) > $o ).

tff(pred_def_2174,type,
    v3989: ( state_type * $int ) > $o ).

tff(pred_def_2175,type,
    v3990: ( state_type * $int ) > $o ).

tff(pred_def_2176,type,
    v3991: state_type > $o ).

tff(pred_def_2177,type,
    v3992: state_type > $o ).

tff(pred_def_2178,type,
    v3993: ( state_type * $int ) > $o ).

tff(pred_def_2179,type,
    v3994: state_type > $o ).

tff(pred_def_2180,type,
    v3995: ( state_type * $int ) > $o ).

tff(pred_def_2181,type,
    v3996: ( state_type * $int ) > $o ).

tff(pred_def_2182,type,
    v3997: state_type > $o ).

tff(pred_def_2183,type,
    v3998: state_type > $o ).

tff(pred_def_2184,type,
    v3999: ( state_type * $int ) > $o ).

tff(pred_def_2185,type,
    v4000: state_type > $o ).

tff(pred_def_2186,type,
    v4001: ( state_type * $int ) > $o ).

tff(pred_def_2187,type,
    v4002: ( state_type * $int ) > $o ).

tff(pred_def_2188,type,
    v4003: state_type > $o ).

tff(pred_def_2189,type,
    v4004: state_type > $o ).

tff(pred_def_2190,type,
    v4005: ( state_type * $int ) > $o ).

tff(pred_def_2191,type,
    v4006: ( state_type * $int ) > $o ).

tff(pred_def_2192,type,
    v4007: state_type > $o ).

tff(pred_def_2193,type,
    v4008: state_type > $o ).

tff(pred_def_2194,type,
    v3982: ( state_type * $int ) > $o ).

tff(pred_def_2195,type,
    v3980: ( state_type * $int ) > $o ).

tff(pred_def_2196,type,
    v4021: state_type > $o ).

tff(pred_def_2197,type,
    v4019: state_type > $o ).

tff(pred_def_2198,type,
    v4017: state_type > $o ).

tff(pred_def_2199,type,
    v4031: state_type > $o ).

tff(pred_def_2200,type,
    v4029: state_type > $o ).

tff(pred_def_2201,type,
    v4027: state_type > $o ).

tff(pred_def_2202,type,
    v4025: state_type > $o ).

tff(pred_def_2203,type,
    v4023: state_type > $o ).

tff(pred_def_2204,type,
    v4033: state_type > $o ).

tff(pred_def_2205,type,
    v4015: state_type > $o ).

tff(pred_def_2206,type,
    v4013: state_type > $o ).

tff(pred_def_2207,type,
    v4011: state_type > $o ).

tff(pred_def_2208,type,
    v4040: state_type > $o ).

tff(pred_def_2209,type,
    v4038: state_type > $o ).

tff(pred_def_2210,type,
    v4037: state_type > $o ).

tff(pred_def_2211,type,
    v4036: state_type > $o ).

tff(pred_def_2212,type,
    v4048: state_type > $o ).

tff(pred_def_2213,type,
    v4049: state_type > $o ).

tff(pred_def_2214,type,
    v4047: state_type > $o ).

tff(pred_def_2215,type,
    v4044: ( state_type * $int ) > $o ).

tff(pred_def_2216,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_2217,type,
    v4046: ( state_type * $int ) > $o ).

tff(pred_def_2218,type,
    v4035: ( state_type * $int ) > $o ).

tff(pred_def_2219,type,
    v3950: ( state_type * $int ) > $o ).

tff(pred_def_2220,type,
    v3948: ( state_type * $int ) > $o ).

tff(pred_def_2221,type,
    v3946: state_type > $o ).

tff(pred_def_2222,type,
    v3944: state_type > $o ).

tff(pred_def_2223,type,
    v3942: state_type > $o ).

tff(pred_def_2224,type,
    v3940: state_type > $o ).

tff(pred_def_2225,type,
    v3938: state_type > $o ).

tff(pred_def_2226,type,
    v4053: state_type > $o ).

tff(pred_def_2227,type,
    v4052: ( state_type * $int ) > $o ).

tff(pred_def_2228,type,
    v4054: state_type > $o ).

tff(pred_def_2229,type,
    v4055: ( state_type * $int ) > $o ).

tff(pred_def_2230,type,
    v4056: ( state_type * $int ) > $o ).

tff(pred_def_2231,type,
    v3936: ( state_type * $int ) > $o ).

tff(pred_def_2232,type,
    v3934: ( state_type * $int ) > $o ).

tff(pred_def_2233,type,
    v3932: ( state_type * $int ) > $o ).

tff(pred_def_2234,type,
    v4061: state_type > $o ).

tff(pred_def_2235,type,
    v4059: state_type > $o ).

tff(pred_def_2236,type,
    v4068: state_type > $o ).

tff(pred_def_2237,type,
    v4066: state_type > $o ).

tff(pred_def_2238,type,
    v4065: state_type > $o ).

tff(pred_def_2239,type,
    v4064: state_type > $o ).

tff(pred_def_2240,type,
    v4076: state_type > $o ).

tff(pred_def_2241,type,
    v4077: state_type > $o ).

tff(pred_def_2242,type,
    v4075: state_type > $o ).

tff(pred_def_2243,type,
    v4072: ( state_type * $int ) > $o ).

tff(pred_def_2244,type,
    bxxxxxxxxx: $int > $o ).

tff(pred_def_2245,type,
    v4074: ( state_type * $int ) > $o ).

tff(pred_def_2246,type,
    v4063: ( state_type * $int ) > $o ).

tff(pred_def_2247,type,
    v3922: ( state_type * $int ) > $o ).

tff(pred_def_2248,type,
    v3920: ( state_type * $int ) > $o ).

tff(pred_def_2249,type,
    v3918: ( state_type * $int ) > $o ).

tff(pred_def_2250,type,
    v2910: ( state_type * $int ) > $o ).

tff(pred_def_2251,type,
    v4082: state_type > $o ).

tff(pred_def_2252,type,
    v4081: state_type > $o ).

tff(pred_def_2253,type,
    v4083: state_type > $o ).

tff(pred_def_2254,type,
    v2940: state_type > $o ).

tff(pred_def_2255,type,
    v4151: state_type > $o ).

tff(pred_def_2256,type,
    v4149: state_type > $o ).

tff(pred_def_2257,type,
    v4147: state_type > $o ).

tff(pred_def_2258,type,
    v4145: state_type > $o ).

tff(pred_def_2259,type,
    v4143: state_type > $o ).

tff(pred_def_2260,type,
    v4141: state_type > $o ).

tff(pred_def_2261,type,
    v4139: state_type > $o ).

tff(pred_def_2262,type,
    v4137: state_type > $o ).

tff(pred_def_2263,type,
    v4167: state_type > $o ).

tff(pred_def_2264,type,
    v4165: state_type > $o ).

tff(pred_def_2265,type,
    v4163: state_type > $o ).

tff(pred_def_2266,type,
    v4161: state_type > $o ).

tff(pred_def_2267,type,
    v4159: state_type > $o ).

tff(pred_def_2268,type,
    v4157: state_type > $o ).

tff(pred_def_2269,type,
    v4155: state_type > $o ).

tff(pred_def_2270,type,
    v4153: state_type > $o ).

tff(pred_def_2271,type,
    v4209: state_type > $o ).

tff(pred_def_2272,type,
    v4207: state_type > $o ).

tff(pred_def_2273,type,
    v4213: state_type > $o ).

tff(pred_def_2274,type,
    v4211: state_type > $o ).

tff(pred_def_2275,type,
    b0100000000000: $int > $o ).

tff(pred_def_2276,type,
    v4226: state_type > $o ).

tff(pred_def_2277,type,
    v4223: state_type > $o ).

tff(pred_def_2278,type,
    v4236: state_type > $o ).

tff(pred_def_2279,type,
    v4234: state_type > $o ).

tff(pred_def_2280,type,
    v4240: state_type > $o ).

tff(pred_def_2281,type,
    v4238: state_type > $o ).

tff(pred_def_2282,type,
    v4201: ( state_type * $int ) > $o ).

tff(pred_def_2283,type,
    v4250: state_type > $o ).

tff(pred_def_2284,type,
    v4259: ( state_type * $int ) > $o ).

tff(pred_def_2285,type,
    v4257: ( state_type * $int ) > $o ).

tff(pred_def_2286,type,
    v4255: ( state_type * $int ) > $o ).

tff(pred_def_2287,type,
    v4253: ( state_type * $int ) > $o ).

tff(pred_def_2288,type,
    v4263: state_type > $o ).

tff(pred_def_2289,type,
    v4273: state_type > $o ).

tff(pred_def_2290,type,
    v4271: state_type > $o ).

tff(pred_def_2291,type,
    v4270: state_type > $o ).

tff(pred_def_2292,type,
    v4269: ( state_type * $int ) > $o ).

tff(pred_def_2293,type,
    b0111010000000: $int > $o ).

tff(pred_def_2294,type,
    v4278: state_type > $o ).

tff(pred_def_2295,type,
    v4277: state_type > $o ).

tff(pred_def_2296,type,
    v4266: state_type > $o ).

tff(pred_def_2297,type,
    v4291: state_type > $o ).

tff(pred_def_2298,type,
    v4289: state_type > $o ).

tff(pred_def_2299,type,
    v4295: state_type > $o ).

tff(pred_def_2300,type,
    v4293: state_type > $o ).

tff(pred_def_2301,type,
    v4285: ( state_type * $int ) > $o ).

tff(pred_def_2302,type,
    v4287: ( state_type * $int ) > $o ).

tff(pred_def_2303,type,
    v4303: state_type > $o ).

tff(pred_def_2304,type,
    v4305: state_type > $o ).

tff(pred_def_2305,type,
    v4304: ( state_type * $int ) > $o ).

tff(pred_def_2306,type,
    v4301: ( state_type * $int ) > $o ).

tff(pred_def_2307,type,
    v4299: ( state_type * $int ) > $o ).

tff(pred_def_2308,type,
    v4297: ( state_type * $int ) > $o ).

tff(pred_def_2309,type,
    v4309: state_type > $o ).

tff(pred_def_2310,type,
    v4307: state_type > $o ).

tff(pred_def_2311,type,
    v4316: state_type > $o ).

tff(pred_def_2312,type,
    v4314: state_type > $o ).

tff(pred_def_2313,type,
    v4313: state_type > $o ).

tff(pred_def_2314,type,
    v4312: state_type > $o ).

tff(pred_def_2315,type,
    v4324: state_type > $o ).

tff(pred_def_2316,type,
    v4325: state_type > $o ).

tff(pred_def_2317,type,
    v4323: state_type > $o ).

tff(pred_def_2318,type,
    v4320: ( state_type * $int ) > $o ).

tff(pred_def_2319,type,
    v4322: ( state_type * $int ) > $o ).

tff(pred_def_2320,type,
    v4311: ( state_type * $int ) > $o ).

tff(pred_def_2321,type,
    v4283: state_type > $o ).

tff(pred_def_2322,type,
    v4337: state_type > $o ).

tff(pred_def_2323,type,
    v4339: state_type > $o ).

tff(pred_def_2324,type,
    v4357: state_type > $o ).

tff(pred_def_2325,type,
    v4361: state_type > $o ).

tff(pred_def_2326,type,
    v4363: state_type > $o ).

tff(pred_def_2327,type,
    v4359: state_type > $o ).

tff(pred_def_2328,type,
    v4355: state_type > $o ).

tff(pred_def_2329,type,
    v4353: state_type > $o ).

tff(pred_def_2330,type,
    v4351: state_type > $o ).

tff(pred_def_2331,type,
    v4372: state_type > $o ).

tff(pred_def_2332,type,
    v4370: state_type > $o ).

tff(pred_def_2333,type,
    v4368: state_type > $o ).

tff(pred_def_2334,type,
    v4366: state_type > $o ).

tff(pred_def_2335,type,
    v4383: ( state_type * $int ) > $o ).

tff(pred_def_2336,type,
    v4394: state_type > $o ).

tff(pred_def_2337,type,
    v4392: state_type > $o ).

tff(pred_def_2338,type,
    v4398: state_type > $o ).

tff(pred_def_2339,type,
    v4396: state_type > $o ).

tff(pred_def_2340,type,
    v4408: ( state_type * $int ) > $o ).

tff(pred_def_2341,type,
    v4406: state_type > $o ).

tff(pred_def_2342,type,
    v4404: state_type > $o ).

tff(pred_def_2343,type,
    b0001000110000: $int > $o ).

tff(pred_def_2344,type,
    v4421: state_type > $o ).

tff(pred_def_2345,type,
    v4418: state_type > $o ).

tff(pred_def_2346,type,
    v4416: state_type > $o ).

tff(pred_def_2347,type,
    v4414: state_type > $o ).

tff(pred_def_2348,type,
    v4412: state_type > $o ).

tff(pred_def_2349,type,
    v4410: state_type > $o ).

tff(pred_def_2350,type,
    v4425: state_type > $o ).

tff(pred_def_2351,type,
    v4424: state_type > $o ).

tff(pred_def_2352,type,
    v4423: state_type > $o ).

tff(pred_def_2353,type,
    v4429: state_type > $o ).

tff(pred_def_2354,type,
    v4428: state_type > $o ).

tff(pred_def_2355,type,
    v4427: state_type > $o ).

tff(pred_def_2356,type,
    v4388: state_type > $o ).

tff(pred_def_2357,type,
    v4426: state_type > $o ).

tff(pred_def_2358,type,
    v4402: state_type > $o ).

tff(pred_def_2359,type,
    v4400: state_type > $o ).

tff(pred_def_2360,type,
    v4445: state_type > $o ).

tff(pred_def_2361,type,
    v4443: state_type > $o ).

tff(pred_def_2362,type,
    v4441: state_type > $o ).

tff(pred_def_2363,type,
    v4451: state_type > $o ).

tff(pred_def_2364,type,
    v4449: state_type > $o ).

tff(pred_def_2365,type,
    v4455: state_type > $o ).

tff(pred_def_2366,type,
    v4453: state_type > $o ).

tff(pred_def_2367,type,
    v4463: state_type > $o ).

tff(pred_def_2368,type,
    v4461: state_type > $o ).

tff(pred_def_2369,type,
    v4459: state_type > $o ).

tff(pred_def_2370,type,
    v4457: state_type > $o ).

tff(pred_def_2371,type,
    v4447: state_type > $o ).

tff(pred_def_2372,type,
    v4469: state_type > $o ).

tff(pred_def_2373,type,
    v4471: state_type > $o ).

tff(pred_def_2374,type,
    v4467: state_type > $o ).

tff(pred_def_2375,type,
    v4466: state_type > $o ).

tff(pred_def_2376,type,
    v4477: state_type > $o ).

tff(pred_def_2377,type,
    v4478: state_type > $o ).

tff(pred_def_2378,type,
    v4474: state_type > $o ).

tff(pred_def_2379,type,
    v4476: state_type > $o ).

tff(pred_def_2380,type,
    v4488: state_type > $o ).

tff(pred_def_2381,type,
    v4486: state_type > $o ).

tff(pred_def_2382,type,
    v4484: state_type > $o ).

tff(pred_def_2383,type,
    v4482: state_type > $o ).

tff(pred_def_2384,type,
    v4491: state_type > $o ).

tff(pred_def_2385,type,
    v4439: state_type > $o ).

tff(pred_def_2386,type,
    v4437: state_type > $o ).

tff(pred_def_2387,type,
    v4435: state_type > $o ).

tff(pred_def_2388,type,
    v4433: state_type > $o ).

tff(pred_def_2389,type,
    v4431: state_type > $o ).

tff(pred_def_2390,type,
    v4498: state_type > $o ).

tff(pred_def_2391,type,
    v4496: state_type > $o ).

tff(pred_def_2392,type,
    v4495: state_type > $o ).

tff(pred_def_2393,type,
    v4494: state_type > $o ).

tff(pred_def_2394,type,
    v4506: state_type > $o ).

tff(pred_def_2395,type,
    v4507: state_type > $o ).

tff(pred_def_2396,type,
    v4505: state_type > $o ).

tff(pred_def_2397,type,
    v4502: state_type > $o ).

tff(pred_def_2398,type,
    v4504: state_type > $o ).

tff(pred_def_2399,type,
    v4390: state_type > $o ).

tff(pred_def_2400,type,
    v4386: state_type > $o ).

tff(pred_def_2401,type,
    v4522: state_type > $o ).

tff(pred_def_2402,type,
    v4524: state_type > $o ).

tff(pred_def_2403,type,
    v4546: state_type > $o ).

tff(pred_def_2404,type,
    v4548: state_type > $o ).

tff(pred_def_2405,type,
    v4544: state_type > $o ).

tff(pred_def_2406,type,
    v4542: state_type > $o ).

tff(pred_def_2407,type,
    v4540: state_type > $o ).

tff(pred_def_2408,type,
    v4557: state_type > $o ).

tff(pred_def_2409,type,
    v4555: state_type > $o ).

tff(pred_def_2410,type,
    v4553: state_type > $o ).

tff(pred_def_2411,type,
    v4551: state_type > $o ).

tff(pred_def_2412,type,
    v4582: state_type > $o ).

tff(pred_def_2413,type,
    v4580: state_type > $o ).

tff(pred_def_2414,type,
    v4586: state_type > $o ).

tff(pred_def_2415,type,
    v4584: state_type > $o ).

tff(pred_def_2416,type,
    v4600: state_type > $o ).

tff(pred_def_2417,type,
    v4601: state_type > $o ).

tff(pred_def_2418,type,
    v4602: state_type > $o ).

tff(pred_def_2419,type,
    v4603: state_type > $o ).

tff(pred_def_2420,type,
    v4604: state_type > $o ).

tff(pred_def_2421,type,
    v4605: state_type > $o ).

tff(pred_def_2422,type,
    v4606: state_type > $o ).

tff(pred_def_2423,type,
    v4607: state_type > $o ).

tff(pred_def_2424,type,
    v4599: ( state_type * $int ) > $o ).

tff(pred_def_2425,type,
    v4598: ( state_type * $int ) > $o ).

tff(pred_def_2426,type,
    v4623: state_type > $o ).

tff(pred_def_2427,type,
    v4621: state_type > $o ).

tff(pred_def_2428,type,
    v4627: state_type > $o ).

tff(pred_def_2429,type,
    v4625: state_type > $o ).

tff(pred_def_2430,type,
    b1011: $int > $o ).

tff(pred_def_2431,type,
    v4615: ( state_type * $int ) > $o ).

tff(pred_def_2432,type,
    v4639: state_type > $o ).

tff(pred_def_2433,type,
    v4646: state_type > $o ).

tff(pred_def_2434,type,
    v4645: state_type > $o ).

tff(pred_def_2435,type,
    v4644: state_type > $o ).

tff(pred_def_2436,type,
    v4647: state_type > $o ).

tff(pred_def_2437,type,
    v4643: state_type > $o ).

tff(pred_def_2438,type,
    v4648: state_type > $o ).

tff(pred_def_2439,type,
    v4642: state_type > $o ).

tff(pred_def_2440,type,
    v4651: state_type > $o ).

tff(pred_def_2441,type,
    v4652: state_type > $o ).

tff(pred_def_2442,type,
    v4650: state_type > $o ).

tff(pred_def_2443,type,
    v4653: state_type > $o ).

tff(pred_def_2444,type,
    v4649: state_type > $o ).

tff(pred_def_2445,type,
    v4656: state_type > $o ).

tff(pred_def_2446,type,
    v4657: state_type > $o ).

tff(pred_def_2447,type,
    v4655: state_type > $o ).

tff(pred_def_2448,type,
    v4658: state_type > $o ).

tff(pred_def_2449,type,
    v4654: state_type > $o ).

tff(pred_def_2450,type,
    v4640: ( state_type * $int ) > $o ).

tff(pred_def_2451,type,
    v4635: ( state_type * $int ) > $o ).

tff(pred_def_2452,type,
    v4633: ( state_type * $int ) > $o ).

tff(pred_def_2453,type,
    v4660: state_type > $o ).

tff(pred_def_2454,type,
    v4613: state_type > $o ).

tff(pred_def_2455,type,
    v4664: state_type > $o ).

tff(pred_def_2456,type,
    v4663: ( state_type * $int ) > $o ).

tff(pred_def_2457,type,
    v4662: ( state_type * $int ) > $o ).

tff(pred_def_2458,type,
    v4668: state_type > $o ).

tff(pred_def_2459,type,
    v4667: ( state_type * $int ) > $o ).

tff(pred_def_2460,type,
    v4666: ( state_type * $int ) > $o ).

tff(pred_def_2461,type,
    v4617: ( state_type * $int ) > $o ).

tff(pred_def_2462,type,
    v4665: ( state_type * $int ) > $o ).

tff(pred_def_2463,type,
    v4631: ( state_type * $int ) > $o ).

tff(pred_def_2464,type,
    v4629: ( state_type * $int ) > $o ).

tff(pred_def_2465,type,
    v4673: state_type > $o ).

tff(pred_def_2466,type,
    v4671: state_type > $o ).

tff(pred_def_2467,type,
    v4680: state_type > $o ).

tff(pred_def_2468,type,
    v4678: state_type > $o ).

tff(pred_def_2469,type,
    v4677: state_type > $o ).

tff(pred_def_2470,type,
    v4676: state_type > $o ).

tff(pred_def_2471,type,
    v4688: state_type > $o ).

tff(pred_def_2472,type,
    v4689: state_type > $o ).

tff(pred_def_2473,type,
    v4687: state_type > $o ).

tff(pred_def_2474,type,
    v4684: ( state_type * $int ) > $o ).

tff(pred_def_2475,type,
    bxxxx: $int > $o ).

tff(pred_def_2476,type,
    v4686: ( state_type * $int ) > $o ).

tff(pred_def_2477,type,
    v4619: ( state_type * $int ) > $o ).

tff(pred_def_2478,type,
    v4695: state_type > $o ).

tff(pred_def_2479,type,
    v4693: state_type > $o ).

tff(pred_def_2480,type,
    v4705: state_type > $o ).

tff(pred_def_2481,type,
    v4703: state_type > $o ).

tff(pred_def_2482,type,
    v4709: state_type > $o ).

tff(pred_def_2483,type,
    v4707: state_type > $o ).

tff(pred_def_2484,type,
    b000111: $int > $o ).

tff(pred_def_2485,type,
    v4697: ( state_type * $int ) > $o ).

tff(pred_def_2486,type,
    v4720: state_type > $o ).

tff(pred_def_2487,type,
    v4729: state_type > $o ).

tff(pred_def_2488,type,
    v4728: state_type > $o ).

tff(pred_def_2489,type,
    v4727: state_type > $o ).

tff(pred_def_2490,type,
    v4726: state_type > $o ).

tff(pred_def_2491,type,
    v4725: state_type > $o ).

tff(pred_def_2492,type,
    v4730: state_type > $o ).

tff(pred_def_2493,type,
    v4724: state_type > $o ).

tff(pred_def_2494,type,
    v4731: state_type > $o ).

tff(pred_def_2495,type,
    v4723: state_type > $o ).

tff(pred_def_2496,type,
    v4734: state_type > $o ).

tff(pred_def_2497,type,
    v4735: state_type > $o ).

tff(pred_def_2498,type,
    v4733: state_type > $o ).

tff(pred_def_2499,type,
    v4736: state_type > $o ).

tff(pred_def_2500,type,
    v4732: state_type > $o ).

tff(pred_def_2501,type,
    v4739: state_type > $o ).

tff(pred_def_2502,type,
    v4740: state_type > $o ).

tff(pred_def_2503,type,
    v4738: state_type > $o ).

tff(pred_def_2504,type,
    v4741: state_type > $o ).

tff(pred_def_2505,type,
    v4737: state_type > $o ).

tff(pred_def_2506,type,
    v4744: state_type > $o ).

tff(pred_def_2507,type,
    v4745: state_type > $o ).

tff(pred_def_2508,type,
    v4743: state_type > $o ).

tff(pred_def_2509,type,
    v4746: state_type > $o ).

tff(pred_def_2510,type,
    v4742: state_type > $o ).

tff(pred_def_2511,type,
    v4749: state_type > $o ).

tff(pred_def_2512,type,
    v4750: state_type > $o ).

tff(pred_def_2513,type,
    v4748: state_type > $o ).

tff(pred_def_2514,type,
    v4751: state_type > $o ).

tff(pred_def_2515,type,
    v4747: state_type > $o ).

tff(pred_def_2516,type,
    v4721: ( state_type * $int ) > $o ).

tff(pred_def_2517,type,
    v4717: ( state_type * $int ) > $o ).

tff(pred_def_2518,type,
    v4715: ( state_type * $int ) > $o ).

tff(pred_def_2519,type,
    v4753: state_type > $o ).

tff(pred_def_2520,type,
    v4611: state_type > $o ).

tff(pred_def_2521,type,
    v4757: state_type > $o ).

tff(pred_def_2522,type,
    v4756: ( state_type * $int ) > $o ).

tff(pred_def_2523,type,
    v4755: ( state_type * $int ) > $o ).

tff(pred_def_2524,type,
    v4761: state_type > $o ).

tff(pred_def_2525,type,
    v4760: ( state_type * $int ) > $o ).

tff(pred_def_2526,type,
    v4759: ( state_type * $int ) > $o ).

tff(pred_def_2527,type,
    v4699: ( state_type * $int ) > $o ).

tff(pred_def_2528,type,
    v4758: ( state_type * $int ) > $o ).

tff(pred_def_2529,type,
    v4713: ( state_type * $int ) > $o ).

tff(pred_def_2530,type,
    v4711: ( state_type * $int ) > $o ).

tff(pred_def_2531,type,
    v4765: state_type > $o ).

tff(pred_def_2532,type,
    v4763: state_type > $o ).

tff(pred_def_2533,type,
    v4772: state_type > $o ).

tff(pred_def_2534,type,
    v4770: state_type > $o ).

tff(pred_def_2535,type,
    v4769: state_type > $o ).

tff(pred_def_2536,type,
    v4768: state_type > $o ).

tff(pred_def_2537,type,
    v4780: state_type > $o ).

tff(pred_def_2538,type,
    v4781: state_type > $o ).

tff(pred_def_2539,type,
    v4779: state_type > $o ).

tff(pred_def_2540,type,
    v4776: ( state_type * $int ) > $o ).

tff(pred_def_2541,type,
    v4778: ( state_type * $int ) > $o ).

tff(pred_def_2542,type,
    v4701: ( state_type * $int ) > $o ).

tff(pred_def_2543,type,
    v4786: state_type > $o ).

tff(pred_def_2544,type,
    v4785: state_type > $o ).

tff(pred_def_2545,type,
    v4791: state_type > $o ).

tff(pred_def_2546,type,
    v4790: state_type > $o ).

tff(pred_def_2547,type,
    v4789: state_type > $o ).

tff(pred_def_2548,type,
    v4787: state_type > $o ).

tff(pred_def_2549,type,
    v4801: state_type > $o ).

tff(pred_def_2550,type,
    v4799: state_type > $o ).

tff(pred_def_2551,type,
    v4805: state_type > $o ).

tff(pred_def_2552,type,
    v4803: state_type > $o ).

tff(pred_def_2553,type,
    v4793: ( state_type * $int ) > $o ).

tff(pred_def_2554,type,
    v4815: state_type > $o ).

tff(pred_def_2555,type,
    v4821: state_type > $o ).

tff(pred_def_2556,type,
    v4820: state_type > $o ).

tff(pred_def_2557,type,
    v4822: state_type > $o ).

tff(pred_def_2558,type,
    v4819: state_type > $o ).

tff(pred_def_2559,type,
    v4823: state_type > $o ).

tff(pred_def_2560,type,
    v4818: state_type > $o ).

tff(pred_def_2561,type,
    v4826: state_type > $o ).

tff(pred_def_2562,type,
    v4827: state_type > $o ).

tff(pred_def_2563,type,
    v4825: state_type > $o ).

tff(pred_def_2564,type,
    v4828: state_type > $o ).

tff(pred_def_2565,type,
    v4824: state_type > $o ).

tff(pred_def_2566,type,
    v4816: ( state_type * $int ) > $o ).

tff(pred_def_2567,type,
    v4813: ( state_type * $int ) > $o ).

tff(pred_def_2568,type,
    v4811: ( state_type * $int ) > $o ).

tff(pred_def_2569,type,
    v4830: state_type > $o ).

tff(pred_def_2570,type,
    v4609: state_type > $o ).

tff(pred_def_2571,type,
    v4834: state_type > $o ).

tff(pred_def_2572,type,
    v4833: ( state_type * $int ) > $o ).

tff(pred_def_2573,type,
    v4832: ( state_type * $int ) > $o ).

tff(pred_def_2574,type,
    v4838: state_type > $o ).

tff(pred_def_2575,type,
    v4837: ( state_type * $int ) > $o ).

tff(pred_def_2576,type,
    v4836: ( state_type * $int ) > $o ).

tff(pred_def_2577,type,
    v4795: ( state_type * $int ) > $o ).

tff(pred_def_2578,type,
    v4835: ( state_type * $int ) > $o ).

tff(pred_def_2579,type,
    v4809: ( state_type * $int ) > $o ).

tff(pred_def_2580,type,
    v4807: ( state_type * $int ) > $o ).

tff(pred_def_2581,type,
    v4842: state_type > $o ).

tff(pred_def_2582,type,
    v4840: state_type > $o ).

tff(pred_def_2583,type,
    v4849: state_type > $o ).

tff(pred_def_2584,type,
    v4847: state_type > $o ).

tff(pred_def_2585,type,
    v4846: state_type > $o ).

tff(pred_def_2586,type,
    v4845: state_type > $o ).

tff(pred_def_2587,type,
    v4857: state_type > $o ).

tff(pred_def_2588,type,
    v4858: state_type > $o ).

tff(pred_def_2589,type,
    v4856: state_type > $o ).

tff(pred_def_2590,type,
    v4853: ( state_type * $int ) > $o ).

tff(pred_def_2591,type,
    v4855: ( state_type * $int ) > $o ).

tff(pred_def_2592,type,
    v4797: ( state_type * $int ) > $o ).

tff(pred_def_2593,type,
    v4863: state_type > $o ).

tff(pred_def_2594,type,
    v4862: state_type > $o ).

tff(pred_def_2595,type,
    v4864: state_type > $o ).

tff(pred_def_2596,type,
    v4875: state_type > $o ).

tff(pred_def_2597,type,
    v4873: state_type > $o ).

tff(pred_def_2598,type,
    v4879: state_type > $o ).

tff(pred_def_2599,type,
    v4877: state_type > $o ).

tff(pred_def_2600,type,
    v4867: ( state_type * $int ) > $o ).

tff(pred_def_2601,type,
    v4889: state_type > $o ).

tff(pred_def_2602,type,
    v4895: state_type > $o ).

tff(pred_def_2603,type,
    v4894: state_type > $o ).

tff(pred_def_2604,type,
    v4896: state_type > $o ).

tff(pred_def_2605,type,
    v4893: state_type > $o ).

tff(pred_def_2606,type,
    v4897: state_type > $o ).

tff(pred_def_2607,type,
    v4892: state_type > $o ).

tff(pred_def_2608,type,
    v4900: state_type > $o ).

tff(pred_def_2609,type,
    v4901: state_type > $o ).

tff(pred_def_2610,type,
    v4899: state_type > $o ).

tff(pred_def_2611,type,
    v4902: state_type > $o ).

tff(pred_def_2612,type,
    v4898: state_type > $o ).

tff(pred_def_2613,type,
    v4890: ( state_type * $int ) > $o ).

tff(pred_def_2614,type,
    v4887: ( state_type * $int ) > $o ).

tff(pred_def_2615,type,
    v4885: ( state_type * $int ) > $o ).

tff(pred_def_2616,type,
    v4904: state_type > $o ).

tff(pred_def_2617,type,
    v4596: state_type > $o ).

tff(pred_def_2618,type,
    v4908: state_type > $o ).

tff(pred_def_2619,type,
    v4907: ( state_type * $int ) > $o ).

tff(pred_def_2620,type,
    v4906: ( state_type * $int ) > $o ).

tff(pred_def_2621,type,
    v4912: state_type > $o ).

tff(pred_def_2622,type,
    v4911: ( state_type * $int ) > $o ).

tff(pred_def_2623,type,
    v4910: ( state_type * $int ) > $o ).

tff(pred_def_2624,type,
    v4869: ( state_type * $int ) > $o ).

tff(pred_def_2625,type,
    v4909: ( state_type * $int ) > $o ).

tff(pred_def_2626,type,
    v4883: ( state_type * $int ) > $o ).

tff(pred_def_2627,type,
    v4881: ( state_type * $int ) > $o ).

tff(pred_def_2628,type,
    v4916: state_type > $o ).

tff(pred_def_2629,type,
    v4914: state_type > $o ).

tff(pred_def_2630,type,
    v4923: state_type > $o ).

tff(pred_def_2631,type,
    v4921: state_type > $o ).

tff(pred_def_2632,type,
    v4920: state_type > $o ).

tff(pred_def_2633,type,
    v4919: state_type > $o ).

tff(pred_def_2634,type,
    v4931: state_type > $o ).

tff(pred_def_2635,type,
    v4932: state_type > $o ).

tff(pred_def_2636,type,
    v4930: state_type > $o ).

tff(pred_def_2637,type,
    v4927: ( state_type * $int ) > $o ).

tff(pred_def_2638,type,
    v4929: ( state_type * $int ) > $o ).

tff(pred_def_2639,type,
    v4871: ( state_type * $int ) > $o ).

tff(pred_def_2640,type,
    v4937: state_type > $o ).

tff(pred_def_2641,type,
    v4936: state_type > $o ).

tff(pred_def_2642,type,
    v4938: state_type > $o ).

tff(pred_def_2643,type,
    v4949: state_type > $o ).

tff(pred_def_2644,type,
    v4947: state_type > $o ).

tff(pred_def_2645,type,
    v4953: state_type > $o ).

tff(pred_def_2646,type,
    v4951: state_type > $o ).

tff(pred_def_2647,type,
    v4963: state_type > $o ).

tff(pred_def_2648,type,
    b11: $int > $o ).

tff(pred_def_2649,type,
    v4967: state_type > $o ).

tff(pred_def_2650,type,
    v4968: state_type > $o ).

tff(pred_def_2651,type,
    v4966: state_type > $o ).

tff(pred_def_2652,type,
    v4941: ( state_type * $int ) > $o ).

tff(pred_def_2653,type,
    v4973: state_type > $o ).

tff(pred_def_2654,type,
    v4974: state_type > $o ).

tff(pred_def_2655,type,
    v4972: state_type > $o ).

tff(pred_def_2656,type,
    v4975: state_type > $o ).

tff(pred_def_2657,type,
    v4971: state_type > $o ).

tff(pred_def_2658,type,
    v4969: state_type > $o ).

tff(pred_def_2659,type,
    v4965: state_type > $o ).

tff(pred_def_2660,type,
    v4982: state_type > $o ).

tff(pred_def_2661,type,
    v4981: state_type > $o ).

tff(pred_def_2662,type,
    v4980: state_type > $o ).

tff(pred_def_2663,type,
    v4979: state_type > $o ).

tff(pred_def_2664,type,
    v4983: state_type > $o ).

tff(pred_def_2665,type,
    v4978: state_type > $o ).

tff(pred_def_2666,type,
    v4985: state_type > $o ).

tff(pred_def_2667,type,
    v4986: state_type > $o ).

tff(pred_def_2668,type,
    v4984: state_type > $o ).

tff(pred_def_2669,type,
    v4976: ( state_type * $int ) > $o ).

tff(pred_def_2670,type,
    v4964: ( state_type * $int ) > $o ).

tff(pred_def_2671,type,
    v4961: ( state_type * $int ) > $o ).

tff(pred_def_2672,type,
    v4959: ( state_type * $int ) > $o ).

tff(pred_def_2673,type,
    v4957: ( state_type * $int ) > $o ).

tff(pred_def_2674,type,
    v4955: ( state_type * $int ) > $o ).

tff(pred_def_2675,type,
    v4990: state_type > $o ).

tff(pred_def_2676,type,
    v4988: state_type > $o ).

tff(pred_def_2677,type,
    v4997: state_type > $o ).

tff(pred_def_2678,type,
    v4995: state_type > $o ).

tff(pred_def_2679,type,
    v4994: state_type > $o ).

tff(pred_def_2680,type,
    v4993: state_type > $o ).

tff(pred_def_2681,type,
    v5005: state_type > $o ).

tff(pred_def_2682,type,
    v5006: state_type > $o ).

tff(pred_def_2683,type,
    v5004: state_type > $o ).

tff(pred_def_2684,type,
    v5001: ( state_type * $int ) > $o ).

tff(pred_def_2685,type,
    v5003: ( state_type * $int ) > $o ).

tff(pred_def_2686,type,
    v4945: ( state_type * $int ) > $o ).

tff(pred_def_2687,type,
    v4943: ( state_type * $int ) > $o ).

tff(pred_def_2688,type,
    v5011: state_type > $o ).

tff(pred_def_2689,type,
    v5012: state_type > $o ).

tff(pred_def_2690,type,
    v5010: state_type > $o ).

tff(pred_def_2691,type,
    v5013: state_type > $o ).

tff(pred_def_2692,type,
    v4594: state_type > $o ).

tff(pred_def_2693,type,
    v4592: state_type > $o ).

tff(pred_def_2694,type,
    v4590: state_type > $o ).

tff(pred_def_2695,type,
    v4588: state_type > $o ).

tff(pred_def_2696,type,
    v5017: state_type > $o ).

tff(pred_def_2697,type,
    v5015: state_type > $o ).

tff(pred_def_2698,type,
    v5024: state_type > $o ).

tff(pred_def_2699,type,
    v5022: state_type > $o ).

tff(pred_def_2700,type,
    v5021: state_type > $o ).

tff(pred_def_2701,type,
    v5020: state_type > $o ).

tff(pred_def_2702,type,
    v5032: state_type > $o ).

tff(pred_def_2703,type,
    v5033: state_type > $o ).

tff(pred_def_2704,type,
    v5031: state_type > $o ).

tff(pred_def_2705,type,
    v5028: state_type > $o ).

tff(pred_def_2706,type,
    v5030: state_type > $o ).

tff(pred_def_2707,type,
    v4578: state_type > $o ).

tff(pred_def_2708,type,
    v4576: state_type > $o ).

tff(pred_def_2709,type,
    v4574: state_type > $o ).

tff(pred_def_2710,type,
    v5037: state_type > $o ).

tff(pred_def_2711,type,
    v4572: state_type > $o ).

tff(pred_def_2712,type,
    v4570: state_type > $o ).

tff(pred_def_2713,type,
    v4568: state_type > $o ).

tff(pred_def_2714,type,
    v4534: ( state_type * $int ) > $o ).

tff(pred_def_2715,type,
    v5040: state_type > $o ).

tff(pred_def_2716,type,
    v5063: state_type > $o ).

tff(pred_def_2717,type,
    v5061: state_type > $o ).

tff(pred_def_2718,type,
    v5067: state_type > $o ).

tff(pred_def_2719,type,
    v5065: state_type > $o ).

tff(pred_def_2720,type,
    b0101010: $int > $o ).

tff(pred_def_2721,type,
    v5077: ( state_type * $int ) > $o ).

tff(pred_def_2722,type,
    v5075: ( state_type * $int ) > $o ).

tff(pred_def_2723,type,
    v5073: ( state_type * $int ) > $o ).

tff(pred_def_2724,type,
    b0100010101000: $int > $o ).

tff(pred_def_2725,type,
    v5084: state_type > $o ).

tff(pred_def_2726,type,
    v5081: state_type > $o ).

tff(pred_def_2727,type,
    v5079: state_type > $o ).

tff(pred_def_2728,type,
    v5088: state_type > $o ).

tff(pred_def_2729,type,
    v5087: ( state_type * $int ) > $o ).

tff(pred_def_2730,type,
    v5086: ( state_type * $int ) > $o ).

tff(pred_def_2731,type,
    v5092: state_type > $o ).

tff(pred_def_2732,type,
    v5091: ( state_type * $int ) > $o ).

tff(pred_def_2733,type,
    v5090: ( state_type * $int ) > $o ).

tff(pred_def_2734,type,
    v5057: ( state_type * $int ) > $o ).

tff(pred_def_2735,type,
    v5089: ( state_type * $int ) > $o ).

tff(pred_def_2736,type,
    v5085: ( state_type * $int ) > $o ).

tff(pred_def_2737,type,
    v5071: ( state_type * $int ) > $o ).

tff(pred_def_2738,type,
    v5069: ( state_type * $int ) > $o ).

tff(pred_def_2739,type,
    v5097: state_type > $o ).

tff(pred_def_2740,type,
    v5095: state_type > $o ).

tff(pred_def_2741,type,
    v5104: state_type > $o ).

tff(pred_def_2742,type,
    v5102: state_type > $o ).

tff(pred_def_2743,type,
    v5101: state_type > $o ).

tff(pred_def_2744,type,
    v5100: state_type > $o ).

tff(pred_def_2745,type,
    v5112: state_type > $o ).

tff(pred_def_2746,type,
    v5113: state_type > $o ).

tff(pred_def_2747,type,
    v5111: state_type > $o ).

tff(pred_def_2748,type,
    v5108: ( state_type * $int ) > $o ).

tff(pred_def_2749,type,
    bxxxxxxx: $int > $o ).

tff(pred_def_2750,type,
    v5110: ( state_type * $int ) > $o ).

tff(pred_def_2751,type,
    v5099: ( state_type * $int ) > $o ).

tff(pred_def_2752,type,
    v5059: ( state_type * $int ) > $o ).

tff(pred_def_2753,type,
    v5055: ( state_type * $int ) > $o ).

tff(pred_def_2754,type,
    v5116: ( state_type * $int ) > $o ).

tff(pred_def_2755,type,
    v5053: ( state_type * $int ) > $o ).

tff(pred_def_2756,type,
    v5051: state_type > $o ).

tff(pred_def_2757,type,
    v5126: state_type > $o ).

tff(pred_def_2758,type,
    v5124: state_type > $o ).

tff(pred_def_2759,type,
    v5130: state_type > $o ).

tff(pred_def_2760,type,
    v5128: state_type > $o ).

tff(pred_def_2761,type,
    v5161: state_type > $o ).

tff(pred_def_2762,type,
    v5160: state_type > $o ).

tff(pred_def_2763,type,
    v5159: state_type > $o ).

tff(pred_def_2764,type,
    v5158: state_type > $o ).

tff(pred_def_2765,type,
    v5157: state_type > $o ).

tff(pred_def_2766,type,
    v5156: state_type > $o ).

tff(pred_def_2767,type,
    v5154: state_type > $o ).

tff(pred_def_2768,type,
    v5152: state_type > $o ).

tff(pred_def_2769,type,
    v5173: state_type > $o ).

tff(pred_def_2770,type,
    v5171: state_type > $o ).

tff(pred_def_2771,type,
    v5177: state_type > $o ).

tff(pred_def_2772,type,
    v5175: state_type > $o ).

tff(pred_def_2773,type,
    v5198: state_type > $o ).

tff(pred_def_2774,type,
    v5196: state_type > $o ).

tff(pred_def_2775,type,
    v5194: state_type > $o ).

tff(pred_def_2776,type,
    v5192: state_type > $o ).

tff(pred_def_2777,type,
    v5204: state_type > $o ).

tff(pred_def_2778,type,
    v5202: state_type > $o ).

tff(pred_def_2779,type,
    v5201: state_type > $o ).

tff(pred_def_2780,type,
    v5200: ( state_type * $int ) > $o ).

tff(pred_def_2781,type,
    v5189: state_type > $o ).

tff(pred_def_2782,type,
    v5165: ( state_type * $int ) > $o ).

tff(pred_def_2783,type,
    v5208: state_type > $o ).

tff(pred_def_2784,type,
    v5187: state_type > $o ).

tff(pred_def_2785,type,
    v886: ( state_type * $int ) > $o ).

tff(pred_def_2786,type,
    v888: ( state_type * $int ) > $o ).

tff(pred_def_2787,type,
    v884: ( state_type * $int ) > $o ).

tff(pred_def_2788,type,
    v5222: ( state_type * $int ) > $o ).

tff(pred_def_2789,type,
    v5224: ( state_type * $int ) > $o ).

tff(pred_def_2790,type,
    v5220: ( state_type * $int ) > $o ).

tff(pred_def_2791,type,
    v5229: ( state_type * $int ) > $o ).

tff(pred_def_2792,type,
    v5231: ( state_type * $int ) > $o ).

tff(pred_def_2793,type,
    v5227: ( state_type * $int ) > $o ).

tff(pred_def_2794,type,
    v5236: ( state_type * $int ) > $o ).

tff(pred_def_2795,type,
    v5238: ( state_type * $int ) > $o ).

tff(pred_def_2796,type,
    v5234: ( state_type * $int ) > $o ).

tff(pred_def_2797,type,
    v5243: ( state_type * $int ) > $o ).

tff(pred_def_2798,type,
    v5245: ( state_type * $int ) > $o ).

tff(pred_def_2799,type,
    v5241: ( state_type * $int ) > $o ).

tff(pred_def_2800,type,
    v5250: ( state_type * $int ) > $o ).

tff(pred_def_2801,type,
    v5252: ( state_type * $int ) > $o ).

tff(pred_def_2802,type,
    v5248: ( state_type * $int ) > $o ).

tff(pred_def_2803,type,
    v5257: ( state_type * $int ) > $o ).

tff(pred_def_2804,type,
    v5259: ( state_type * $int ) > $o ).

tff(pred_def_2805,type,
    v5255: ( state_type * $int ) > $o ).

tff(pred_def_2806,type,
    v5264: ( state_type * $int ) > $o ).

tff(pred_def_2807,type,
    v5266: ( state_type * $int ) > $o ).

tff(pred_def_2808,type,
    v5262: ( state_type * $int ) > $o ).

tff(pred_def_2809,type,
    v5271: ( state_type * $int ) > $o ).

tff(pred_def_2810,type,
    v5273: ( state_type * $int ) > $o ).

tff(pred_def_2811,type,
    v5269: ( state_type * $int ) > $o ).

tff(pred_def_2812,type,
    v5278: ( state_type * $int ) > $o ).

tff(pred_def_2813,type,
    v5280: ( state_type * $int ) > $o ).

tff(pred_def_2814,type,
    v5276: ( state_type * $int ) > $o ).

tff(pred_def_2815,type,
    v5285: ( state_type * $int ) > $o ).

tff(pred_def_2816,type,
    v5287: ( state_type * $int ) > $o ).

tff(pred_def_2817,type,
    v5283: ( state_type * $int ) > $o ).

tff(pred_def_2818,type,
    v5292: ( state_type * $int ) > $o ).

tff(pred_def_2819,type,
    v5294: ( state_type * $int ) > $o ).

tff(pred_def_2820,type,
    v5290: ( state_type * $int ) > $o ).

tff(pred_def_2821,type,
    v5299: ( state_type * $int ) > $o ).

tff(pred_def_2822,type,
    v5301: ( state_type * $int ) > $o ).

tff(pred_def_2823,type,
    v5297: ( state_type * $int ) > $o ).

tff(pred_def_2824,type,
    v5306: ( state_type * $int ) > $o ).

tff(pred_def_2825,type,
    v5308: ( state_type * $int ) > $o ).

tff(pred_def_2826,type,
    v5304: ( state_type * $int ) > $o ).

tff(pred_def_2827,type,
    v5313: ( state_type * $int ) > $o ).

tff(pred_def_2828,type,
    v5315: ( state_type * $int ) > $o ).

tff(pred_def_2829,type,
    v5311: ( state_type * $int ) > $o ).

tff(pred_def_2830,type,
    v5320: ( state_type * $int ) > $o ).

tff(pred_def_2831,type,
    v5322: ( state_type * $int ) > $o ).

tff(pred_def_2832,type,
    v5318: ( state_type * $int ) > $o ).

tff(pred_def_2833,type,
    v5326: ( state_type * $int ) > $o ).

tff(pred_def_2834,type,
    v5328: ( state_type * $int ) > $o ).

tff(pred_def_2835,type,
    v5324: ( state_type * $int ) > $o ).

tff(pred_def_2836,type,
    v5348: state_type > $o ).

tff(pred_def_2837,type,
    v5347: state_type > $o ).

tff(pred_def_2838,type,
    v5346: ( state_type * $int ) > $o ).

tff(pred_def_2839,type,
    v5345: ( state_type * $int ) > $o ).

tff(pred_def_2840,type,
    b00001: $int > $o ).

tff(pred_def_2841,type,
    v5352: state_type > $o ).

tff(pred_def_2842,type,
    v5351: state_type > $o ).

tff(pred_def_2843,type,
    v5350: ( state_type * $int ) > $o ).

tff(pred_def_2844,type,
    v5349: ( state_type * $int ) > $o ).

tff(pred_def_2845,type,
    v5344: ( state_type * $int ) > $o ).

tff(pred_def_2846,type,
    b00010: $int > $o ).

tff(pred_def_2847,type,
    v5356: state_type > $o ).

tff(pred_def_2848,type,
    v5355: state_type > $o ).

tff(pred_def_2849,type,
    v5354: ( state_type * $int ) > $o ).

tff(pred_def_2850,type,
    v5353: ( state_type * $int ) > $o ).

tff(pred_def_2851,type,
    v5343: ( state_type * $int ) > $o ).

tff(pred_def_2852,type,
    b00011: $int > $o ).

tff(pred_def_2853,type,
    v5360: state_type > $o ).

tff(pred_def_2854,type,
    v5359: state_type > $o ).

tff(pred_def_2855,type,
    v5358: ( state_type * $int ) > $o ).

tff(pred_def_2856,type,
    v5357: ( state_type * $int ) > $o ).

tff(pred_def_2857,type,
    v5342: ( state_type * $int ) > $o ).

tff(pred_def_2858,type,
    b00100: $int > $o ).

tff(pred_def_2859,type,
    v5364: state_type > $o ).

tff(pred_def_2860,type,
    v5363: state_type > $o ).

tff(pred_def_2861,type,
    v5362: ( state_type * $int ) > $o ).

tff(pred_def_2862,type,
    v5361: ( state_type * $int ) > $o ).

tff(pred_def_2863,type,
    v5341: ( state_type * $int ) > $o ).

tff(pred_def_2864,type,
    b00101: $int > $o ).

tff(pred_def_2865,type,
    v5368: state_type > $o ).

tff(pred_def_2866,type,
    v5367: state_type > $o ).

tff(pred_def_2867,type,
    v5366: ( state_type * $int ) > $o ).

tff(pred_def_2868,type,
    v5365: ( state_type * $int ) > $o ).

tff(pred_def_2869,type,
    v5340: ( state_type * $int ) > $o ).

tff(pred_def_2870,type,
    b00110: $int > $o ).

tff(pred_def_2871,type,
    v5372: state_type > $o ).

tff(pred_def_2872,type,
    v5371: state_type > $o ).

tff(pred_def_2873,type,
    v5370: ( state_type * $int ) > $o ).

tff(pred_def_2874,type,
    v5369: ( state_type * $int ) > $o ).

tff(pred_def_2875,type,
    v5339: ( state_type * $int ) > $o ).

tff(pred_def_2876,type,
    b00111: $int > $o ).

tff(pred_def_2877,type,
    v5376: state_type > $o ).

tff(pred_def_2878,type,
    v5375: state_type > $o ).

tff(pred_def_2879,type,
    v5374: ( state_type * $int ) > $o ).

tff(pred_def_2880,type,
    v5373: ( state_type * $int ) > $o ).

tff(pred_def_2881,type,
    v5338: ( state_type * $int ) > $o ).

tff(pred_def_2882,type,
    b01000: $int > $o ).

tff(pred_def_2883,type,
    v5380: state_type > $o ).

tff(pred_def_2884,type,
    v5379: state_type > $o ).

tff(pred_def_2885,type,
    v5378: ( state_type * $int ) > $o ).

tff(pred_def_2886,type,
    v5377: ( state_type * $int ) > $o ).

tff(pred_def_2887,type,
    v5337: ( state_type * $int ) > $o ).

tff(pred_def_2888,type,
    b01001: $int > $o ).

tff(pred_def_2889,type,
    v5384: state_type > $o ).

tff(pred_def_2890,type,
    v5383: state_type > $o ).

tff(pred_def_2891,type,
    v5382: ( state_type * $int ) > $o ).

tff(pred_def_2892,type,
    v5381: ( state_type * $int ) > $o ).

tff(pred_def_2893,type,
    v5336: ( state_type * $int ) > $o ).

tff(pred_def_2894,type,
    b01010: $int > $o ).

tff(pred_def_2895,type,
    v5388: state_type > $o ).

tff(pred_def_2896,type,
    v5387: state_type > $o ).

tff(pred_def_2897,type,
    v5386: ( state_type * $int ) > $o ).

tff(pred_def_2898,type,
    v5385: ( state_type * $int ) > $o ).

tff(pred_def_2899,type,
    v5335: ( state_type * $int ) > $o ).

tff(pred_def_2900,type,
    b01011: $int > $o ).

tff(pred_def_2901,type,
    v5392: state_type > $o ).

tff(pred_def_2902,type,
    v5391: state_type > $o ).

tff(pred_def_2903,type,
    v5390: ( state_type * $int ) > $o ).

tff(pred_def_2904,type,
    v5389: ( state_type * $int ) > $o ).

tff(pred_def_2905,type,
    v5334: ( state_type * $int ) > $o ).

tff(pred_def_2906,type,
    b01100: $int > $o ).

tff(pred_def_2907,type,
    v5396: state_type > $o ).

tff(pred_def_2908,type,
    v5395: state_type > $o ).

tff(pred_def_2909,type,
    v5394: ( state_type * $int ) > $o ).

tff(pred_def_2910,type,
    v5393: ( state_type * $int ) > $o ).

tff(pred_def_2911,type,
    v5333: ( state_type * $int ) > $o ).

tff(pred_def_2912,type,
    b01101: $int > $o ).

tff(pred_def_2913,type,
    v5400: state_type > $o ).

tff(pred_def_2914,type,
    v5399: state_type > $o ).

tff(pred_def_2915,type,
    v5398: ( state_type * $int ) > $o ).

tff(pred_def_2916,type,
    v5397: ( state_type * $int ) > $o ).

tff(pred_def_2917,type,
    v5332: ( state_type * $int ) > $o ).

tff(pred_def_2918,type,
    b01110: $int > $o ).

tff(pred_def_2919,type,
    v5404: state_type > $o ).

tff(pred_def_2920,type,
    v5403: state_type > $o ).

tff(pred_def_2921,type,
    v5402: ( state_type * $int ) > $o ).

tff(pred_def_2922,type,
    v5401: ( state_type * $int ) > $o ).

tff(pred_def_2923,type,
    v5331: ( state_type * $int ) > $o ).

tff(pred_def_2924,type,
    b01111: $int > $o ).

tff(pred_def_2925,type,
    v5408: state_type > $o ).

tff(pred_def_2926,type,
    v5407: state_type > $o ).

tff(pred_def_2927,type,
    v5406: ( state_type * $int ) > $o ).

tff(pred_def_2928,type,
    v5405: ( state_type * $int ) > $o ).

tff(pred_def_2929,type,
    v5330: ( state_type * $int ) > $o ).

tff(pred_def_2930,type,
    v5412: state_type > $o ).

tff(pred_def_2931,type,
    v5411: state_type > $o ).

tff(pred_def_2932,type,
    v5410: ( state_type * $int ) > $o ).

tff(pred_def_2933,type,
    v5409: ( state_type * $int ) > $o ).

tff(pred_def_2934,type,
    v5329: ( state_type * $int ) > $o ).

tff(pred_def_2935,type,
    v783: ( state_type * $int ) > $o ).

tff(pred_def_2936,type,
    v781: ( state_type * $int ) > $o ).

tff(pred_def_2937,type,
    v5218: state_type > $o ).

tff(pred_def_2938,type,
    v5420: ( state_type * $int ) > $o ).

tff(pred_def_2939,type,
    v5422: ( state_type * $int ) > $o ).

tff(pred_def_2940,type,
    v5418: ( state_type * $int ) > $o ).

tff(pred_def_2941,type,
    v5426: ( state_type * $int ) > $o ).

tff(pred_def_2942,type,
    v5428: ( state_type * $int ) > $o ).

tff(pred_def_2943,type,
    v5424: ( state_type * $int ) > $o ).

tff(pred_def_2944,type,
    v5433: ( state_type * $int ) > $o ).

tff(pred_def_2945,type,
    v5435: ( state_type * $int ) > $o ).

tff(pred_def_2946,type,
    v5431: ( state_type * $int ) > $o ).

tff(pred_def_2947,type,
    v5440: ( state_type * $int ) > $o ).

tff(pred_def_2948,type,
    v5442: ( state_type * $int ) > $o ).

tff(pred_def_2949,type,
    v5438: ( state_type * $int ) > $o ).

tff(pred_def_2950,type,
    v5447: ( state_type * $int ) > $o ).

tff(pred_def_2951,type,
    v5449: ( state_type * $int ) > $o ).

tff(pred_def_2952,type,
    v5445: ( state_type * $int ) > $o ).

tff(pred_def_2953,type,
    v5454: ( state_type * $int ) > $o ).

tff(pred_def_2954,type,
    v5456: ( state_type * $int ) > $o ).

tff(pred_def_2955,type,
    v5452: ( state_type * $int ) > $o ).

tff(pred_def_2956,type,
    v5461: ( state_type * $int ) > $o ).

tff(pred_def_2957,type,
    v5463: ( state_type * $int ) > $o ).

tff(pred_def_2958,type,
    v5459: ( state_type * $int ) > $o ).

tff(pred_def_2959,type,
    v5468: ( state_type * $int ) > $o ).

tff(pred_def_2960,type,
    v5470: ( state_type * $int ) > $o ).

tff(pred_def_2961,type,
    v5466: ( state_type * $int ) > $o ).

tff(pred_def_2962,type,
    v5475: ( state_type * $int ) > $o ).

tff(pred_def_2963,type,
    v5477: ( state_type * $int ) > $o ).

tff(pred_def_2964,type,
    v5473: ( state_type * $int ) > $o ).

tff(pred_def_2965,type,
    v5482: ( state_type * $int ) > $o ).

tff(pred_def_2966,type,
    v5484: ( state_type * $int ) > $o ).

tff(pred_def_2967,type,
    v5480: ( state_type * $int ) > $o ).

tff(pred_def_2968,type,
    v5489: ( state_type * $int ) > $o ).

tff(pred_def_2969,type,
    v5491: ( state_type * $int ) > $o ).

tff(pred_def_2970,type,
    v5487: ( state_type * $int ) > $o ).

tff(pred_def_2971,type,
    v5495: ( state_type * $int ) > $o ).

tff(pred_def_2972,type,
    v5497: ( state_type * $int ) > $o ).

tff(pred_def_2973,type,
    v5493: ( state_type * $int ) > $o ).

tff(pred_def_2974,type,
    v5502: ( state_type * $int ) > $o ).

tff(pred_def_2975,type,
    v5504: ( state_type * $int ) > $o ).

tff(pred_def_2976,type,
    v5500: ( state_type * $int ) > $o ).

tff(pred_def_2977,type,
    v5509: ( state_type * $int ) > $o ).

tff(pred_def_2978,type,
    v5511: ( state_type * $int ) > $o ).

tff(pred_def_2979,type,
    v5507: ( state_type * $int ) > $o ).

tff(pred_def_2980,type,
    v5516: ( state_type * $int ) > $o ).

tff(pred_def_2981,type,
    v5518: ( state_type * $int ) > $o ).

tff(pred_def_2982,type,
    v5514: ( state_type * $int ) > $o ).

tff(pred_def_2983,type,
    v5523: ( state_type * $int ) > $o ).

tff(pred_def_2984,type,
    v5525: ( state_type * $int ) > $o ).

tff(pred_def_2985,type,
    v5521: ( state_type * $int ) > $o ).

tff(pred_def_2986,type,
    v968: ( state_type * $int ) > $o ).

tff(pred_def_2987,type,
    v5543: state_type > $o ).

tff(pred_def_2988,type,
    v5542: ( state_type * $int ) > $o ).

tff(pred_def_2989,type,
    v5541: ( state_type * $int ) > $o ).

tff(pred_def_2990,type,
    b0001: $int > $o ).

tff(pred_def_2991,type,
    v5546: state_type > $o ).

tff(pred_def_2992,type,
    v5545: ( state_type * $int ) > $o ).

tff(pred_def_2993,type,
    v5544: ( state_type * $int ) > $o ).

tff(pred_def_2994,type,
    v5540: ( state_type * $int ) > $o ).

tff(pred_def_2995,type,
    b0010: $int > $o ).

tff(pred_def_2996,type,
    v5549: state_type > $o ).

tff(pred_def_2997,type,
    v5548: ( state_type * $int ) > $o ).

tff(pred_def_2998,type,
    v5547: ( state_type * $int ) > $o ).

tff(pred_def_2999,type,
    v5539: ( state_type * $int ) > $o ).

tff(pred_def_3000,type,
    b0011: $int > $o ).

tff(pred_def_3001,type,
    v5552: state_type > $o ).

tff(pred_def_3002,type,
    v5551: ( state_type * $int ) > $o ).

tff(pred_def_3003,type,
    v5550: ( state_type * $int ) > $o ).

tff(pred_def_3004,type,
    v5538: ( state_type * $int ) > $o ).

tff(pred_def_3005,type,
    b0100: $int > $o ).

tff(pred_def_3006,type,
    v5555: state_type > $o ).

tff(pred_def_3007,type,
    v5554: ( state_type * $int ) > $o ).

tff(pred_def_3008,type,
    v5553: ( state_type * $int ) > $o ).

tff(pred_def_3009,type,
    v5537: ( state_type * $int ) > $o ).

tff(pred_def_3010,type,
    b0101: $int > $o ).

tff(pred_def_3011,type,
    v5558: state_type > $o ).

tff(pred_def_3012,type,
    v5557: ( state_type * $int ) > $o ).

tff(pred_def_3013,type,
    v5556: ( state_type * $int ) > $o ).

tff(pred_def_3014,type,
    v5536: ( state_type * $int ) > $o ).

tff(pred_def_3015,type,
    b0110: $int > $o ).

tff(pred_def_3016,type,
    v5561: state_type > $o ).

tff(pred_def_3017,type,
    v5560: ( state_type * $int ) > $o ).

tff(pred_def_3018,type,
    v5559: ( state_type * $int ) > $o ).

tff(pred_def_3019,type,
    v5535: ( state_type * $int ) > $o ).

tff(pred_def_3020,type,
    b0111: $int > $o ).

tff(pred_def_3021,type,
    v5564: state_type > $o ).

tff(pred_def_3022,type,
    v5563: ( state_type * $int ) > $o ).

tff(pred_def_3023,type,
    v5562: ( state_type * $int ) > $o ).

tff(pred_def_3024,type,
    v5534: ( state_type * $int ) > $o ).

tff(pred_def_3025,type,
    b1000: $int > $o ).

tff(pred_def_3026,type,
    v5567: state_type > $o ).

tff(pred_def_3027,type,
    v5566: ( state_type * $int ) > $o ).

tff(pred_def_3028,type,
    v5565: ( state_type * $int ) > $o ).

tff(pred_def_3029,type,
    v5533: ( state_type * $int ) > $o ).

tff(pred_def_3030,type,
    b1001: $int > $o ).

tff(pred_def_3031,type,
    v5570: state_type > $o ).

tff(pred_def_3032,type,
    v5569: ( state_type * $int ) > $o ).

tff(pred_def_3033,type,
    v5568: ( state_type * $int ) > $o ).

tff(pred_def_3034,type,
    v5532: ( state_type * $int ) > $o ).

tff(pred_def_3035,type,
    b1010: $int > $o ).

tff(pred_def_3036,type,
    v5573: state_type > $o ).

tff(pred_def_3037,type,
    v5572: ( state_type * $int ) > $o ).

tff(pred_def_3038,type,
    v5571: ( state_type * $int ) > $o ).

tff(pred_def_3039,type,
    v5531: ( state_type * $int ) > $o ).

tff(pred_def_3040,type,
    v5576: state_type > $o ).

tff(pred_def_3041,type,
    v5575: ( state_type * $int ) > $o ).

tff(pred_def_3042,type,
    v5574: ( state_type * $int ) > $o ).

tff(pred_def_3043,type,
    v5530: ( state_type * $int ) > $o ).

tff(pred_def_3044,type,
    b1100: $int > $o ).

tff(pred_def_3045,type,
    v5579: state_type > $o ).

tff(pred_def_3046,type,
    v5578: ( state_type * $int ) > $o ).

tff(pred_def_3047,type,
    v5577: ( state_type * $int ) > $o ).

tff(pred_def_3048,type,
    v5529: ( state_type * $int ) > $o ).

tff(pred_def_3049,type,
    b1101: $int > $o ).

tff(pred_def_3050,type,
    v5582: state_type > $o ).

tff(pred_def_3051,type,
    v5581: ( state_type * $int ) > $o ).

tff(pred_def_3052,type,
    v5580: ( state_type * $int ) > $o ).

tff(pred_def_3053,type,
    v5528: ( state_type * $int ) > $o ).

tff(pred_def_3054,type,
    b1110: $int > $o ).

tff(pred_def_3055,type,
    v5585: state_type > $o ).

tff(pred_def_3056,type,
    v5584: ( state_type * $int ) > $o ).

tff(pred_def_3057,type,
    v5583: ( state_type * $int ) > $o ).

tff(pred_def_3058,type,
    v5527: ( state_type * $int ) > $o ).

tff(pred_def_3059,type,
    b1111: $int > $o ).

tff(pred_def_3060,type,
    v5588: state_type > $o ).

tff(pred_def_3061,type,
    v5587: ( state_type * $int ) > $o ).

tff(pred_def_3062,type,
    v5586: ( state_type * $int ) > $o ).

tff(pred_def_3063,type,
    v5526: ( state_type * $int ) > $o ).

tff(pred_def_3064,type,
    v966: ( state_type * $int ) > $o ).

tff(pred_def_3065,type,
    v964: ( state_type * $int ) > $o ).

tff(pred_def_3066,type,
    v5416: state_type > $o ).

tff(pred_def_3067,type,
    v940: state_type > $o ).

tff(pred_def_3068,type,
    v5589: ( state_type * $int ) > $o ).

tff(pred_def_3069,type,
    v5590: state_type > $o ).

tff(pred_def_3070,type,
    v5591: ( state_type * $int ) > $o ).

tff(pred_def_3071,type,
    v5592: ( state_type * $int ) > $o ).

tff(pred_def_3072,type,
    v5593: state_type > $o ).

tff(pred_def_3073,type,
    v5594: ( state_type * $int ) > $o ).

tff(pred_def_3074,type,
    v5595: state_type > $o ).

tff(pred_def_3075,type,
    v938: ( state_type * $int ) > $o ).

tff(pred_def_3076,type,
    v936: ( state_type * $int ) > $o ).

tff(pred_def_3077,type,
    v5597: state_type > $o ).

tff(pred_def_3078,type,
    v1001: state_type > $o ).

tff(pred_def_3079,type,
    v5601: state_type > $o ).

tff(pred_def_3080,type,
    v5600: ( state_type * $int ) > $o ).

tff(pred_def_3081,type,
    v5599: ( state_type * $int ) > $o ).

tff(pred_def_3082,type,
    v5605: state_type > $o ).

tff(pred_def_3083,type,
    v5604: ( state_type * $int ) > $o ).

tff(pred_def_3084,type,
    v5603: ( state_type * $int ) > $o ).

tff(pred_def_3085,type,
    v912: ( state_type * $int ) > $o ).

tff(pred_def_3086,type,
    v5602: ( state_type * $int ) > $o ).

tff(pred_def_3087,type,
    v5598: ( state_type * $int ) > $o ).

tff(pred_def_3088,type,
    v934: ( state_type * $int ) > $o ).

tff(pred_def_3089,type,
    v932: ( state_type * $int ) > $o ).

tff(pred_def_3090,type,
    v5622: state_type > $o ).

tff(pred_def_3091,type,
    v5620: state_type > $o ).

tff(pred_def_3092,type,
    v5618: state_type > $o ).

tff(pred_def_3093,type,
    v5628: state_type > $o ).

tff(pred_def_3094,type,
    v5626: state_type > $o ).

tff(pred_def_3095,type,
    v5632: state_type > $o ).

tff(pred_def_3096,type,
    v5630: state_type > $o ).

tff(pred_def_3097,type,
    v5640: state_type > $o ).

tff(pred_def_3098,type,
    v5638: state_type > $o ).

tff(pred_def_3099,type,
    v5636: state_type > $o ).

tff(pred_def_3100,type,
    v5634: state_type > $o ).

tff(pred_def_3101,type,
    v5624: state_type > $o ).

tff(pred_def_3102,type,
    v5646: state_type > $o ).

tff(pred_def_3103,type,
    v5648: state_type > $o ).

tff(pred_def_3104,type,
    v5644: state_type > $o ).

tff(pred_def_3105,type,
    v5643: state_type > $o ).

tff(pred_def_3106,type,
    v5654: state_type > $o ).

tff(pred_def_3107,type,
    v5655: state_type > $o ).

tff(pred_def_3108,type,
    v5651: state_type > $o ).

tff(pred_def_3109,type,
    v5653: state_type > $o ).

tff(pred_def_3110,type,
    v5665: state_type > $o ).

tff(pred_def_3111,type,
    v5663: state_type > $o ).

tff(pred_def_3112,type,
    v5661: state_type > $o ).

tff(pred_def_3113,type,
    v5659: state_type > $o ).

tff(pred_def_3114,type,
    v5667: state_type > $o ).

tff(pred_def_3115,type,
    v5616: state_type > $o ).

tff(pred_def_3116,type,
    v5614: state_type > $o ).

tff(pred_def_3117,type,
    v5612: state_type > $o ).

tff(pred_def_3118,type,
    v5610: state_type > $o ).

tff(pred_def_3119,type,
    v5608: state_type > $o ).

tff(pred_def_3120,type,
    v5674: state_type > $o ).

tff(pred_def_3121,type,
    v5672: state_type > $o ).

tff(pred_def_3122,type,
    v5671: state_type > $o ).

tff(pred_def_3123,type,
    v5670: state_type > $o ).

tff(pred_def_3124,type,
    v5682: state_type > $o ).

tff(pred_def_3125,type,
    v5683: state_type > $o ).

tff(pred_def_3126,type,
    v5681: state_type > $o ).

tff(pred_def_3127,type,
    v5678: ( state_type * $int ) > $o ).

tff(pred_def_3128,type,
    bxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_3129,type,
    v5680: ( state_type * $int ) > $o ).

tff(pred_def_3130,type,
    v5669: ( state_type * $int ) > $o ).

tff(pred_def_3131,type,
    v914: ( state_type * $int ) > $o ).

tff(pred_def_3132,type,
    v910: ( state_type * $int ) > $o ).

tff(pred_def_3133,type,
    v908: ( state_type * $int ) > $o ).

tff(pred_def_3134,type,
    v906: ( state_type * $int ) > $o ).

tff(pred_def_3135,type,
    v904: ( state_type * $int ) > $o ).

tff(pred_def_3136,type,
    v902: ( state_type * $int ) > $o ).

tff(pred_def_3137,type,
    v5699: state_type > $o ).

tff(pred_def_3138,type,
    v5697: state_type > $o ).

tff(pred_def_3139,type,
    v5703: state_type > $o ).

tff(pred_def_3140,type,
    v5701: state_type > $o ).

tff(pred_def_3141,type,
    v5691: ( state_type * $int ) > $o ).

tff(pred_def_3142,type,
    v5713: state_type > $o ).

tff(pred_def_3143,type,
    v5715: state_type > $o ).

tff(pred_def_3144,type,
    v5714: ( state_type * $int ) > $o ).

tff(pred_def_3145,type,
    v5724: state_type > $o ).

tff(pred_def_3146,type,
    v5723: state_type > $o ).

tff(pred_def_3147,type,
    v5722: state_type > $o ).

tff(pred_def_3148,type,
    v5721: state_type > $o ).

tff(pred_def_3149,type,
    v5725: state_type > $o ).

tff(pred_def_3150,type,
    v5720: state_type > $o ).

tff(pred_def_3151,type,
    v5726: state_type > $o ).

tff(pred_def_3152,type,
    v5719: state_type > $o ).

tff(pred_def_3153,type,
    v5729: state_type > $o ).

tff(pred_def_3154,type,
    v5730: state_type > $o ).

tff(pred_def_3155,type,
    v5728: state_type > $o ).

tff(pred_def_3156,type,
    v5731: state_type > $o ).

tff(pred_def_3157,type,
    v5727: state_type > $o ).

tff(pred_def_3158,type,
    v5734: state_type > $o ).

tff(pred_def_3159,type,
    v5735: state_type > $o ).

tff(pred_def_3160,type,
    v5733: state_type > $o ).

tff(pred_def_3161,type,
    v5736: state_type > $o ).

tff(pred_def_3162,type,
    v5732: state_type > $o ).

tff(pred_def_3163,type,
    v5739: state_type > $o ).

tff(pred_def_3164,type,
    v5740: state_type > $o ).

tff(pred_def_3165,type,
    v5738: state_type > $o ).

tff(pred_def_3166,type,
    v5741: state_type > $o ).

tff(pred_def_3167,type,
    v5737: state_type > $o ).

tff(pred_def_3168,type,
    v5717: ( state_type * $int ) > $o ).

tff(pred_def_3169,type,
    v5716: ( state_type * $int ) > $o ).

tff(pred_def_3170,type,
    v5712: ( state_type * $int ) > $o ).

tff(pred_def_3171,type,
    v5711: ( state_type * $int ) > $o ).

tff(pred_def_3172,type,
    v5709: ( state_type * $int ) > $o ).

tff(pred_def_3173,type,
    v5761: state_type > $o ).

tff(pred_def_3174,type,
    v5759: state_type > $o ).

tff(pred_def_3175,type,
    v5765: state_type > $o ).

tff(pred_def_3176,type,
    v5763: state_type > $o ).

tff(pred_def_3177,type,
    v5772: ( state_type * $int ) > $o ).

tff(pred_def_3178,type,
    v5773: state_type > $o ).

tff(pred_def_3179,type,
    v5774: state_type > $o ).

tff(pred_def_3180,type,
    v5775: state_type > $o ).

tff(pred_def_3181,type,
    v5776: state_type > $o ).

tff(pred_def_3182,type,
    v5771: ( state_type * $int ) > $o ).

tff(pred_def_3183,type,
    v5769: ( state_type * $int ) > $o ).

tff(pred_def_3184,type,
    v5767: ( state_type * $int ) > $o ).

tff(pred_def_3185,type,
    v5781: state_type > $o ).

tff(pred_def_3186,type,
    v5779: state_type > $o ).

tff(pred_def_3187,type,
    v5788: state_type > $o ).

tff(pred_def_3188,type,
    v5786: state_type > $o ).

tff(pred_def_3189,type,
    v5785: state_type > $o ).

tff(pred_def_3190,type,
    v5784: state_type > $o ).

tff(pred_def_3191,type,
    v5796: state_type > $o ).

tff(pred_def_3192,type,
    v5797: state_type > $o ).

tff(pred_def_3193,type,
    v5795: state_type > $o ).

tff(pred_def_3194,type,
    v5792: ( state_type * $int ) > $o ).

tff(pred_def_3195,type,
    bxxxxx: $int > $o ).

tff(pred_def_3196,type,
    v5794: ( state_type * $int ) > $o ).

tff(pred_def_3197,type,
    v5783: ( state_type * $int ) > $o ).

tff(pred_def_3198,type,
    v5757: ( state_type * $int ) > $o ).

tff(pred_def_3199,type,
    v5755: ( state_type * $int ) > $o ).

tff(pred_def_3200,type,
    v5753: state_type > $o ).

tff(pred_def_3201,type,
    v5825: state_type > $o ).

tff(pred_def_3202,type,
    v5823: state_type > $o ).

tff(pred_def_3203,type,
    v5821: state_type > $o ).

tff(pred_def_3204,type,
    v5819: state_type > $o ).

tff(pred_def_3205,type,
    v5817: state_type > $o ).

tff(pred_def_3206,type,
    v5815: state_type > $o ).

tff(pred_def_3207,type,
    v5813: state_type > $o ).

tff(pred_def_3208,type,
    v5839: state_type > $o ).

tff(pred_def_3209,type,
    v5837: state_type > $o ).

tff(pred_def_3210,type,
    v5835: state_type > $o ).

tff(pred_def_3211,type,
    v5833: state_type > $o ).

tff(pred_def_3212,type,
    v5831: state_type > $o ).

tff(pred_def_3213,type,
    v5829: state_type > $o ).

tff(pred_def_3214,type,
    v5827: state_type > $o ).

tff(pred_def_3215,type,
    v6043: state_type > $o ).

tff(pred_def_3216,type,
    v6041: state_type > $o ).

tff(pred_def_3217,type,
    v6039: state_type > $o ).

tff(pred_def_3218,type,
    v6037: state_type > $o ).

tff(pred_def_3219,type,
    v6035: state_type > $o ).

tff(pred_def_3220,type,
    v6053: state_type > $o ).

tff(pred_def_3221,type,
    v6051: state_type > $o ).

tff(pred_def_3222,type,
    v6049: state_type > $o ).

tff(pred_def_3223,type,
    v6047: state_type > $o ).

tff(pred_def_3224,type,
    v6045: state_type > $o ).

tff(pred_def_3225,type,
    v6089: state_type > $o ).

tff(pred_def_3226,type,
    v2038: state_type > $o ).

tff(pred_def_3227,type,
    v6090: ( state_type * $int ) > $o ).

tff(pred_def_3228,type,
    v6087: ( state_type * $int ) > $o ).

tff(pred_def_3229,type,
    v6085: ( state_type * $int ) > $o ).

tff(pred_def_3230,type,
    v6083: ( state_type * $int ) > $o ).

tff(pred_def_3231,type,
    v6081: ( state_type * $int ) > $o ).

tff(pred_def_3232,type,
    v6079: state_type > $o ).

tff(pred_def_3233,type,
    v6092: state_type > $o ).

tff(pred_def_3234,type,
    v6091: ( state_type * $int ) > $o ).

tff(pred_def_3235,type,
    v6077: ( state_type * $int ) > $o ).

tff(pred_def_3236,type,
    v6075: ( state_type * $int ) > $o ).

tff(pred_def_3237,type,
    v6116: state_type > $o ).

tff(pred_def_3238,type,
    v6118: state_type > $o ).

tff(pred_def_3239,type,
    v6114: state_type > $o ).

tff(pred_def_3240,type,
    v6112: state_type > $o ).

tff(pred_def_3241,type,
    v6110: state_type > $o ).

tff(pred_def_3242,type,
    v6144: state_type > $o ).

tff(pred_def_3243,type,
    v6142: state_type > $o ).

tff(pred_def_3244,type,
    v6148: state_type > $o ).

tff(pred_def_3245,type,
    v6146: state_type > $o ).

tff(pred_def_3246,type,
    v2200: ( state_type * $int ) > $o ).

tff(pred_def_3247,type,
    v6158: state_type > $o ).

tff(pred_def_3248,type,
    v6156: state_type > $o ).

tff(pred_def_3249,type,
    v6159: ( state_type * $int ) > $o ).

tff(pred_def_3250,type,
    v6160: state_type > $o ).

tff(pred_def_3251,type,
    v6161: ( state_type * $int ) > $o ).

tff(pred_def_3252,type,
    v6154: ( state_type * $int ) > $o ).

tff(pred_def_3253,type,
    v6152: ( state_type * $int ) > $o ).

tff(pred_def_3254,type,
    v6150: ( state_type * $int ) > $o ).

tff(pred_def_3255,type,
    v6166: state_type > $o ).

tff(pred_def_3256,type,
    v6164: state_type > $o ).

tff(pred_def_3257,type,
    v6173: state_type > $o ).

tff(pred_def_3258,type,
    v6171: state_type > $o ).

tff(pred_def_3259,type,
    v6170: state_type > $o ).

tff(pred_def_3260,type,
    v6169: state_type > $o ).

tff(pred_def_3261,type,
    v6181: state_type > $o ).

tff(pred_def_3262,type,
    v6182: state_type > $o ).

tff(pred_def_3263,type,
    v6180: state_type > $o ).

tff(pred_def_3264,type,
    v6177: ( state_type * $int ) > $o ).

tff(pred_def_3265,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_3266,type,
    v6179: ( state_type * $int ) > $o ).

tff(pred_def_3267,type,
    v6168: ( state_type * $int ) > $o ).

tff(pred_def_3268,type,
    v6140: ( state_type * $int ) > $o ).

tff(pred_def_3269,type,
    v6138: ( state_type * $int ) > $o ).

tff(pred_def_3270,type,
    v6136: state_type > $o ).

tff(pred_def_3271,type,
    v2040: state_type > $o ).

tff(pred_def_3272,type,
    v6186: state_type > $o ).

tff(pred_def_3273,type,
    v6134: state_type > $o ).

tff(pred_def_3274,type,
    v6132: state_type > $o ).

tff(pred_def_3275,type,
    v6130: state_type > $o ).

tff(pred_def_3276,type,
    v6128: state_type > $o ).

tff(pred_def_3277,type,
    v6126: state_type > $o ).

tff(pred_def_3278,type,
    v6192: state_type > $o ).

tff(pred_def_3279,type,
    v6190: state_type > $o ).

tff(pred_def_3280,type,
    v6188: state_type > $o ).

tff(pred_def_3281,type,
    v6200: state_type > $o ).

tff(pred_def_3282,type,
    v6202: state_type > $o ).

tff(pred_def_3283,type,
    v6198: state_type > $o ).

tff(pred_def_3284,type,
    v6196: state_type > $o ).

tff(pred_def_3285,type,
    v6194: state_type > $o ).

tff(pred_def_3286,type,
    v6205: state_type > $o ).

tff(pred_def_3287,type,
    v6206: state_type > $o ).

tff(pred_def_3288,type,
    v6204: state_type > $o ).

tff(pred_def_3289,type,
    v6124: state_type > $o ).

tff(pred_def_3290,type,
    v6122: state_type > $o ).

tff(pred_def_3291,type,
    v6120: state_type > $o ).

tff(pred_def_3292,type,
    v6214: state_type > $o ).

tff(pred_def_3293,type,
    v6212: state_type > $o ).

tff(pred_def_3294,type,
    v6210: state_type > $o ).

tff(pred_def_3295,type,
    v6208: state_type > $o ).

tff(pred_def_3296,type,
    v6220: state_type > $o ).

tff(pred_def_3297,type,
    v6218: state_type > $o ).

tff(pred_def_3298,type,
    v6216: state_type > $o ).

tff(pred_def_3299,type,
    v6108: ( state_type * $int ) > $o ).

tff(pred_def_3300,type,
    v6226: ( state_type * $int ) > $o ).

tff(pred_def_3301,type,
    b0000000000000000000000000000000000000000000000000000000000000000: $int > $o ).

tff(pred_def_3302,type,
    v6224: ( state_type * $int ) > $o ).

tff(pred_def_3303,type,
    v6270: state_type > $o ).

tff(pred_def_3304,type,
    v6268: state_type > $o ).

tff(pred_def_3305,type,
    v6266: state_type > $o ).

tff(pred_def_3306,type,
    v6264: state_type > $o ).

tff(pred_def_3307,type,
    v6262: state_type > $o ).

tff(pred_def_3308,type,
    v6260: state_type > $o ).

tff(pred_def_3309,type,
    v6258: state_type > $o ).

tff(pred_def_3310,type,
    v6284: state_type > $o ).

tff(pred_def_3311,type,
    v6282: state_type > $o ).

tff(pred_def_3312,type,
    v6280: state_type > $o ).

tff(pred_def_3313,type,
    v6278: state_type > $o ).

tff(pred_def_3314,type,
    v6276: state_type > $o ).

tff(pred_def_3315,type,
    v6274: state_type > $o ).

tff(pred_def_3316,type,
    v6272: state_type > $o ).

tff(pred_def_3317,type,
    v6310: state_type > $o ).

tff(pred_def_3318,type,
    v4195: state_type > $o ).

tff(pred_def_3319,type,
    v6312: state_type > $o ).

tff(pred_def_3320,type,
    v6311: ( state_type * $int ) > $o ).

tff(pred_def_3321,type,
    v6313: state_type > $o ).

tff(pred_def_3322,type,
    v6308: ( state_type * $int ) > $o ).

tff(pred_def_3323,type,
    v6306: ( state_type * $int ) > $o ).

tff(pred_def_3324,type,
    v6314: ( state_type * $int ) > $o ).

tff(pred_def_3325,type,
    v6304: ( state_type * $int ) > $o ).

tff(pred_def_3326,type,
    v6302: ( state_type * $int ) > $o ).

tff(pred_def_3327,type,
    v6300: state_type > $o ).

tff(pred_def_3328,type,
    v6316: state_type > $o ).

tff(pred_def_3329,type,
    v6315: ( state_type * $int ) > $o ).

tff(pred_def_3330,type,
    v6298: ( state_type * $int ) > $o ).

tff(pred_def_3331,type,
    v6296: ( state_type * $int ) > $o ).

tff(pred_def_3332,type,
    v6360: state_type > $o ).

tff(pred_def_3333,type,
    v6358: state_type > $o ).

tff(pred_def_3334,type,
    v6356: state_type > $o ).

tff(pred_def_3335,type,
    v6354: state_type > $o ).

tff(pred_def_3336,type,
    v6352: state_type > $o ).

tff(pred_def_3337,type,
    v6350: state_type > $o ).

tff(pred_def_3338,type,
    v6348: state_type > $o ).

tff(pred_def_3339,type,
    v6346: state_type > $o ).

tff(pred_def_3340,type,
    v6376: state_type > $o ).

tff(pred_def_3341,type,
    v6374: state_type > $o ).

tff(pred_def_3342,type,
    v6372: state_type > $o ).

tff(pred_def_3343,type,
    v6370: state_type > $o ).

tff(pred_def_3344,type,
    v6368: state_type > $o ).

tff(pred_def_3345,type,
    v6366: state_type > $o ).

tff(pred_def_3346,type,
    v6364: state_type > $o ).

tff(pred_def_3347,type,
    v6362: state_type > $o ).

tff(pred_def_3348,type,
    v6390: ( state_type * $int ) > $o ).

tff(pred_def_3349,type,
    v6392: ( state_type * $int ) > $o ).

tff(pred_def_3350,type,
    v6388: ( state_type * $int ) > $o ).

tff(pred_def_3351,type,
    v6386: ( state_type * $int ) > $o ).

tff(pred_def_3352,type,
    v6384: ( state_type * $int ) > $o ).

tff(pred_def_3353,type,
    v6422: ( state_type * $int ) > $o ).

tff(pred_def_3354,type,
    v6424: ( state_type * $int ) > $o ).

tff(pred_def_3355,type,
    v6420: ( state_type * $int ) > $o ).

tff(pred_def_3356,type,
    v6418: ( state_type * $int ) > $o ).

tff(pred_def_3357,type,
    v6416: ( state_type * $int ) > $o ).

tff(pred_def_3358,type,
    v6414: ( state_type * $int ) > $o ).

tff(pred_def_3359,type,
    v6412: state_type > $o ).

tff(pred_def_3360,type,
    v6410: state_type > $o ).

tff(pred_def_3361,type,
    v6428: state_type > $o ).

tff(pred_def_3362,type,
    v6426: state_type > $o ).

tff(pred_def_3363,type,
    v6430: state_type > $o ).

tff(pred_def_3364,type,
    v6408: state_type > $o ).

tff(pred_def_3365,type,
    v6406: state_type > $o ).

tff(pred_def_3366,type,
    v6404: state_type > $o ).

tff(pred_def_3367,type,
    v6402: state_type > $o ).

tff(pred_def_3368,type,
    v6400: state_type > $o ).

tff(pred_def_3369,type,
    v6398: state_type > $o ).

tff(pred_def_3370,type,
    v6396: state_type > $o ).

tff(pred_def_3371,type,
    v6394: state_type > $o ).

tff(pred_def_3372,type,
    v6438: ( state_type * $int ) > $o ).

tff(pred_def_3373,type,
    v6440: ( state_type * $int ) > $o ).

tff(pred_def_3374,type,
    v6436: ( state_type * $int ) > $o ).

tff(pred_def_3375,type,
    v6434: ( state_type * $int ) > $o ).

tff(pred_def_3376,type,
    v6432: ( state_type * $int ) > $o ).

tff(pred_def_3377,type,
    v6470: ( state_type * $int ) > $o ).

tff(pred_def_3378,type,
    v6468: ( state_type * $int ) > $o ).

tff(pred_def_3379,type,
    v6471: ( state_type * $int ) > $o ).

tff(pred_def_3380,type,
    v6466: ( state_type * $int ) > $o ).

tff(pred_def_3381,type,
    v6464: ( state_type * $int ) > $o ).

tff(pred_def_3382,type,
    v6462: ( state_type * $int ) > $o ).

tff(pred_def_3383,type,
    v6460: state_type > $o ).

tff(pred_def_3384,type,
    v6458: state_type > $o ).

tff(pred_def_3385,type,
    v6475: state_type > $o ).

tff(pred_def_3386,type,
    v6473: state_type > $o ).

tff(pred_def_3387,type,
    v6477: state_type > $o ).

tff(pred_def_3388,type,
    v6456: state_type > $o ).

tff(pred_def_3389,type,
    v6454: state_type > $o ).

tff(pred_def_3390,type,
    v6452: state_type > $o ).

tff(pred_def_3391,type,
    v6450: state_type > $o ).

tff(pred_def_3392,type,
    v6448: state_type > $o ).

tff(pred_def_3393,type,
    v6446: state_type > $o ).

tff(pred_def_3394,type,
    v6444: state_type > $o ).

tff(pred_def_3395,type,
    v6442: state_type > $o ).

tff(pred_def_3396,type,
    v6485: ( state_type * $int ) > $o ).

tff(pred_def_3397,type,
    v6487: ( state_type * $int ) > $o ).

tff(pred_def_3398,type,
    v6483: ( state_type * $int ) > $o ).

tff(pred_def_3399,type,
    v6481: ( state_type * $int ) > $o ).

tff(pred_def_3400,type,
    v6479: ( state_type * $int ) > $o ).

tff(pred_def_3401,type,
    v6507: state_type > $o ).

tff(pred_def_3402,type,
    v6505: state_type > $o ).

tff(pred_def_3403,type,
    v6511: state_type > $o ).

tff(pred_def_3404,type,
    v6509: state_type > $o ).

tff(pred_def_3405,type,
    v6513: state_type > $o ).

tff(pred_def_3406,type,
    v6503: state_type > $o ).

tff(pred_def_3407,type,
    v6501: state_type > $o ).

tff(pred_def_3408,type,
    v6499: state_type > $o ).

tff(pred_def_3409,type,
    v6497: state_type > $o ).

tff(pred_def_3410,type,
    v6495: state_type > $o ).

tff(pred_def_3411,type,
    v6493: state_type > $o ).

tff(pred_def_3412,type,
    v6491: state_type > $o ).

tff(pred_def_3413,type,
    v6489: state_type > $o ).

tff(pred_def_3414,type,
    v6521: ( state_type * $int ) > $o ).

tff(pred_def_3415,type,
    v6523: ( state_type * $int ) > $o ).

tff(pred_def_3416,type,
    v6519: ( state_type * $int ) > $o ).

tff(pred_def_3417,type,
    v6517: ( state_type * $int ) > $o ).

tff(pred_def_3418,type,
    v6515: ( state_type * $int ) > $o ).

tff(pred_def_3419,type,
    v6543: state_type > $o ).

tff(pred_def_3420,type,
    v6541: state_type > $o ).

tff(pred_def_3421,type,
    v6547: state_type > $o ).

tff(pred_def_3422,type,
    v6545: state_type > $o ).

tff(pred_def_3423,type,
    v6549: state_type > $o ).

tff(pred_def_3424,type,
    v6539: state_type > $o ).

tff(pred_def_3425,type,
    v6537: state_type > $o ).

tff(pred_def_3426,type,
    v6535: state_type > $o ).

tff(pred_def_3427,type,
    v6533: state_type > $o ).

tff(pred_def_3428,type,
    v6531: state_type > $o ).

tff(pred_def_3429,type,
    v6529: state_type > $o ).

tff(pred_def_3430,type,
    v6527: state_type > $o ).

tff(pred_def_3431,type,
    v6525: state_type > $o ).

tff(pred_def_3432,type,
    v6555: state_type > $o ).

tff(pred_def_3433,type,
    v6554: ( state_type * $int ) > $o ).

tff(pred_def_3434,type,
    v6553: ( state_type * $int ) > $o ).

tff(pred_def_3435,type,
    v6558: state_type > $o ).

tff(pred_def_3436,type,
    v6557: ( state_type * $int ) > $o ).

tff(pred_def_3437,type,
    v6556: ( state_type * $int ) > $o ).

tff(pred_def_3438,type,
    v6552: ( state_type * $int ) > $o ).

tff(pred_def_3439,type,
    v6561: state_type > $o ).

tff(pred_def_3440,type,
    v6560: ( state_type * $int ) > $o ).

tff(pred_def_3441,type,
    v6559: ( state_type * $int ) > $o ).

tff(pred_def_3442,type,
    v6551: ( state_type * $int ) > $o ).

tff(pred_def_3443,type,
    v6564: state_type > $o ).

tff(pred_def_3444,type,
    v6563: ( state_type * $int ) > $o ).

tff(pred_def_3445,type,
    v6562: ( state_type * $int ) > $o ).

tff(pred_def_3446,type,
    v6550: ( state_type * $int ) > $o ).

tff(pred_def_3447,type,
    v6382: ( state_type * $int ) > $o ).

tff(pred_def_3448,type,
    v6380: ( state_type * $int ) > $o ).

tff(pred_def_3449,type,
    v6378: ( state_type * $int ) > $o ).

tff(pred_def_3450,type,
    v6579: state_type > $o ).

tff(pred_def_3451,type,
    v6577: state_type > $o ).

tff(pred_def_3452,type,
    v6575: state_type > $o ).

tff(pred_def_3453,type,
    v6573: state_type > $o ).

tff(pred_def_3454,type,
    v6591: state_type > $o ).

tff(pred_def_3455,type,
    v6589: state_type > $o ).

tff(pred_def_3456,type,
    v6587: state_type > $o ).

tff(pred_def_3457,type,
    v6585: state_type > $o ).

tff(pred_def_3458,type,
    v6583: state_type > $o ).

tff(pred_def_3459,type,
    v6581: state_type > $o ).

tff(pred_def_3460,type,
    v6593: state_type > $o ).

tff(pred_def_3461,type,
    v6571: state_type > $o ).

tff(pred_def_3462,type,
    v6569: state_type > $o ).

tff(pred_def_3463,type,
    v6567: state_type > $o ).

tff(pred_def_3464,type,
    v6600: state_type > $o ).

tff(pred_def_3465,type,
    v6598: state_type > $o ).

tff(pred_def_3466,type,
    v6597: state_type > $o ).

tff(pred_def_3467,type,
    v6596: state_type > $o ).

tff(pred_def_3468,type,
    v6608: state_type > $o ).

tff(pred_def_3469,type,
    v6609: state_type > $o ).

tff(pred_def_3470,type,
    v6607: state_type > $o ).

tff(pred_def_3471,type,
    v6604: ( state_type * $int ) > $o ).

tff(pred_def_3472,type,
    bxxxxxxxxxxxx: $int > $o ).

tff(pred_def_3473,type,
    v6606: ( state_type * $int ) > $o ).

tff(pred_def_3474,type,
    v6595: ( state_type * $int ) > $o ).

tff(pred_def_3475,type,
    v6344: ( state_type * $int ) > $o ).

tff(pred_def_3476,type,
    v6342: ( state_type * $int ) > $o ).

tff(pred_def_3477,type,
    v6340: ( state_type * $int ) > $o ).

tff(pred_def_3478,type,
    v6338: ( state_type * $int ) > $o ).

tff(pred_def_3479,type,
    v6336: ( state_type * $int ) > $o ).

tff(pred_def_3480,type,
    v6334: ( state_type * $int ) > $o ).

tff(pred_def_3481,type,
    v6332: ( state_type * $int ) > $o ).

tff(pred_def_3482,type,
    v6330: ( state_type * $int ) > $o ).

tff(pred_def_3483,type,
    v6635: state_type > $o ).

tff(pred_def_3484,type,
    v6633: state_type > $o ).

tff(pred_def_3485,type,
    v6639: state_type > $o ).

tff(pred_def_3486,type,
    v6637: state_type > $o ).

tff(pred_def_3487,type,
    v6649: ( state_type * $int ) > $o ).

tff(pred_def_3488,type,
    v6650: ( state_type * $int ) > $o ).

tff(pred_def_3489,type,
    v6647: ( state_type * $int ) > $o ).

tff(pred_def_3490,type,
    v6645: ( state_type * $int ) > $o ).

tff(pred_def_3491,type,
    b0100000101000: $int > $o ).

tff(pred_def_3492,type,
    v6657: state_type > $o ).

tff(pred_def_3493,type,
    v6654: state_type > $o ).

tff(pred_def_3494,type,
    v6652: state_type > $o ).

tff(pred_def_3495,type,
    v6661: state_type > $o ).

tff(pred_def_3496,type,
    v6660: ( state_type * $int ) > $o ).

tff(pred_def_3497,type,
    v6659: ( state_type * $int ) > $o ).

tff(pred_def_3498,type,
    v6665: state_type > $o ).

tff(pred_def_3499,type,
    v6664: ( state_type * $int ) > $o ).

tff(pred_def_3500,type,
    v6663: ( state_type * $int ) > $o ).

tff(pred_def_3501,type,
    v6629: ( state_type * $int ) > $o ).

tff(pred_def_3502,type,
    v6662: ( state_type * $int ) > $o ).

tff(pred_def_3503,type,
    v6658: ( state_type * $int ) > $o ).

tff(pred_def_3504,type,
    v6643: ( state_type * $int ) > $o ).

tff(pred_def_3505,type,
    v6641: ( state_type * $int ) > $o ).

tff(pred_def_3506,type,
    v6670: state_type > $o ).

tff(pred_def_3507,type,
    v6668: state_type > $o ).

tff(pred_def_3508,type,
    v6677: state_type > $o ).

tff(pred_def_3509,type,
    v6675: state_type > $o ).

tff(pred_def_3510,type,
    v6674: state_type > $o ).

tff(pred_def_3511,type,
    v6673: state_type > $o ).

tff(pred_def_3512,type,
    v6685: state_type > $o ).

tff(pred_def_3513,type,
    v6686: state_type > $o ).

tff(pred_def_3514,type,
    v6684: state_type > $o ).

tff(pred_def_3515,type,
    v6681: ( state_type * $int ) > $o ).

tff(pred_def_3516,type,
    bxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_3517,type,
    v6683: ( state_type * $int ) > $o ).

tff(pred_def_3518,type,
    v6672: ( state_type * $int ) > $o ).

tff(pred_def_3519,type,
    v6631: ( state_type * $int ) > $o ).

tff(pred_def_3520,type,
    v6627: ( state_type * $int ) > $o ).

tff(pred_def_3521,type,
    v6689: ( state_type * $int ) > $o ).

tff(pred_def_3522,type,
    v6625: ( state_type * $int ) > $o ).

tff(pred_def_3523,type,
    v6697: state_type > $o ).

tff(pred_def_3524,type,
    v6696: state_type > $o ).

tff(pred_def_3525,type,
    v6695: state_type > $o ).

tff(pred_def_3526,type,
    v6694: state_type > $o ).

tff(pred_def_3527,type,
    v6693: state_type > $o ).

tff(pred_def_3528,type,
    v6691: state_type > $o ).

tff(pred_def_3529,type,
    v6700: state_type > $o ).

tff(pred_def_3530,type,
    v6698: state_type > $o ).

tff(pred_def_3531,type,
    v6706: state_type > $o ).

tff(pred_def_3532,type,
    v6707: state_type > $o ).

tff(pred_def_3533,type,
    v6705: state_type > $o ).

tff(pred_def_3534,type,
    v6704: state_type > $o ).

tff(pred_def_3535,type,
    v6703: state_type > $o ).

tff(pred_def_3536,type,
    v6701: state_type > $o ).

tff(pred_def_3537,type,
    v6712: state_type > $o ).

tff(pred_def_3538,type,
    v6711: state_type > $o ).

tff(pred_def_3539,type,
    v6710: state_type > $o ).

tff(pred_def_3540,type,
    v6708: state_type > $o ).

tff(pred_def_3541,type,
    v6717: state_type > $o ).

tff(pred_def_3542,type,
    v6716: state_type > $o ).

tff(pred_def_3543,type,
    v6715: state_type > $o ).

tff(pred_def_3544,type,
    v6713: state_type > $o ).

tff(pred_def_3545,type,
    v6718: state_type > $o ).

tff(pred_def_3546,type,
    v6719: state_type > $o ).

tff(pred_def_3547,type,
    v6724: state_type > $o ).

tff(pred_def_3548,type,
    v6723: state_type > $o ).

tff(pred_def_3549,type,
    v6722: state_type > $o ).

tff(pred_def_3550,type,
    v6720: state_type > $o ).

tff(pred_def_3551,type,
    v6729: state_type > $o ).

tff(pred_def_3552,type,
    v6728: state_type > $o ).

tff(pred_def_3553,type,
    v6727: state_type > $o ).

tff(pred_def_3554,type,
    v6725: state_type > $o ).

tff(pred_def_3555,type,
    v6733: state_type > $o ).

tff(pred_def_3556,type,
    v6732: state_type > $o ).

tff(pred_def_3557,type,
    v6730: state_type > $o ).

tff(pred_def_3558,type,
    v6737: state_type > $o ).

tff(pred_def_3559,type,
    v6736: state_type > $o ).

tff(pred_def_3560,type,
    v6734: state_type > $o ).

tff(pred_def_3561,type,
    v6741: state_type > $o ).

tff(pred_def_3562,type,
    v6740: state_type > $o ).

tff(pred_def_3563,type,
    v6738: state_type > $o ).

tff(pred_def_3564,type,
    v6745: state_type > $o ).

tff(pred_def_3565,type,
    v6744: state_type > $o ).

tff(pred_def_3566,type,
    v6742: state_type > $o ).

tff(pred_def_3567,type,
    v6746: state_type > $o ).

tff(pred_def_3568,type,
    v6690: ( state_type * $int ) > $o ).

tff(pred_def_3569,type,
    v6623: ( state_type * $int ) > $o ).

tff(pred_def_3570,type,
    v6747: ( state_type * $int ) > $o ).

tff(pred_def_3571,type,
    v6621: ( state_type * $int ) > $o ).

tff(pred_def_3572,type,
    v6619: ( state_type * $int ) > $o ).

tff(pred_def_3573,type,
    v6617: ( state_type * $int ) > $o ).

tff(pred_def_3574,type,
    v6615: state_type > $o ).

tff(pred_def_3575,type,
    v6613: state_type > $o ).

tff(pred_def_3576,type,
    v6771: state_type > $o ).

tff(pred_def_3577,type,
    v6769: state_type > $o ).

tff(pred_def_3578,type,
    v6767: state_type > $o ).

tff(pred_def_3579,type,
    v6765: state_type > $o ).

tff(pred_def_3580,type,
    v6763: state_type > $o ).

tff(pred_def_3581,type,
    v6761: state_type > $o ).

tff(pred_def_3582,type,
    v6759: state_type > $o ).

tff(pred_def_3583,type,
    v6785: state_type > $o ).

tff(pred_def_3584,type,
    v6783: state_type > $o ).

tff(pred_def_3585,type,
    v6781: state_type > $o ).

tff(pred_def_3586,type,
    v6779: state_type > $o ).

tff(pred_def_3587,type,
    v6777: state_type > $o ).

tff(pred_def_3588,type,
    v6775: state_type > $o ).

tff(pred_def_3589,type,
    v6773: state_type > $o ).

tff(pred_def_3590,type,
    v6799: ( state_type * $int ) > $o ).

tff(pred_def_3591,type,
    v6801: ( state_type * $int ) > $o ).

tff(pred_def_3592,type,
    v6797: ( state_type * $int ) > $o ).

tff(pred_def_3593,type,
    v6795: ( state_type * $int ) > $o ).

tff(pred_def_3594,type,
    v6793: ( state_type * $int ) > $o ).

tff(pred_def_3595,type,
    v6831: ( state_type * $int ) > $o ).

tff(pred_def_3596,type,
    v6833: ( state_type * $int ) > $o ).

tff(pred_def_3597,type,
    v6829: ( state_type * $int ) > $o ).

tff(pred_def_3598,type,
    v6827: ( state_type * $int ) > $o ).

tff(pred_def_3599,type,
    v6825: ( state_type * $int ) > $o ).

tff(pred_def_3600,type,
    v6823: ( state_type * $int ) > $o ).

tff(pred_def_3601,type,
    v6821: state_type > $o ).

tff(pred_def_3602,type,
    v6819: state_type > $o ).

tff(pred_def_3603,type,
    v6837: state_type > $o ).

tff(pred_def_3604,type,
    v6835: state_type > $o ).

tff(pred_def_3605,type,
    v6839: state_type > $o ).

tff(pred_def_3606,type,
    v6817: state_type > $o ).

tff(pred_def_3607,type,
    v6815: state_type > $o ).

tff(pred_def_3608,type,
    v6813: state_type > $o ).

tff(pred_def_3609,type,
    v6811: state_type > $o ).

tff(pred_def_3610,type,
    v6809: state_type > $o ).

tff(pred_def_3611,type,
    v6807: state_type > $o ).

tff(pred_def_3612,type,
    v6805: state_type > $o ).

tff(pred_def_3613,type,
    v6803: state_type > $o ).

tff(pred_def_3614,type,
    v6847: ( state_type * $int ) > $o ).

tff(pred_def_3615,type,
    v6849: ( state_type * $int ) > $o ).

tff(pred_def_3616,type,
    v6845: ( state_type * $int ) > $o ).

tff(pred_def_3617,type,
    v6843: ( state_type * $int ) > $o ).

tff(pred_def_3618,type,
    v6841: ( state_type * $int ) > $o ).

tff(pred_def_3619,type,
    v6879: ( state_type * $int ) > $o ).

tff(pred_def_3620,type,
    v6877: ( state_type * $int ) > $o ).

tff(pred_def_3621,type,
    v6880: ( state_type * $int ) > $o ).

tff(pred_def_3622,type,
    v6875: ( state_type * $int ) > $o ).

tff(pred_def_3623,type,
    v6873: ( state_type * $int ) > $o ).

tff(pred_def_3624,type,
    v6871: ( state_type * $int ) > $o ).

tff(pred_def_3625,type,
    v6869: state_type > $o ).

tff(pred_def_3626,type,
    v6867: state_type > $o ).

tff(pred_def_3627,type,
    v6884: state_type > $o ).

tff(pred_def_3628,type,
    v6882: state_type > $o ).

tff(pred_def_3629,type,
    v6886: state_type > $o ).

tff(pred_def_3630,type,
    v6865: state_type > $o ).

tff(pred_def_3631,type,
    v6863: state_type > $o ).

tff(pred_def_3632,type,
    v6861: state_type > $o ).

tff(pred_def_3633,type,
    v6859: state_type > $o ).

tff(pred_def_3634,type,
    v6857: state_type > $o ).

tff(pred_def_3635,type,
    v6855: state_type > $o ).

tff(pred_def_3636,type,
    v6853: state_type > $o ).

tff(pred_def_3637,type,
    v6851: state_type > $o ).

tff(pred_def_3638,type,
    v6894: ( state_type * $int ) > $o ).

tff(pred_def_3639,type,
    v6896: ( state_type * $int ) > $o ).

tff(pred_def_3640,type,
    v6892: ( state_type * $int ) > $o ).

tff(pred_def_3641,type,
    v6890: ( state_type * $int ) > $o ).

tff(pred_def_3642,type,
    v6888: ( state_type * $int ) > $o ).

tff(pred_def_3643,type,
    v6916: state_type > $o ).

tff(pred_def_3644,type,
    v6914: state_type > $o ).

tff(pred_def_3645,type,
    v6920: state_type > $o ).

tff(pred_def_3646,type,
    v6918: state_type > $o ).

tff(pred_def_3647,type,
    v6922: state_type > $o ).

tff(pred_def_3648,type,
    v6912: state_type > $o ).

tff(pred_def_3649,type,
    v6910: state_type > $o ).

tff(pred_def_3650,type,
    v6908: state_type > $o ).

tff(pred_def_3651,type,
    v6906: state_type > $o ).

tff(pred_def_3652,type,
    v6904: state_type > $o ).

tff(pred_def_3653,type,
    v6902: state_type > $o ).

tff(pred_def_3654,type,
    v6900: state_type > $o ).

tff(pred_def_3655,type,
    v6898: state_type > $o ).

tff(pred_def_3656,type,
    v6930: ( state_type * $int ) > $o ).

tff(pred_def_3657,type,
    v6932: ( state_type * $int ) > $o ).

tff(pred_def_3658,type,
    v6928: ( state_type * $int ) > $o ).

tff(pred_def_3659,type,
    v6926: ( state_type * $int ) > $o ).

tff(pred_def_3660,type,
    v6924: ( state_type * $int ) > $o ).

tff(pred_def_3661,type,
    v6952: state_type > $o ).

tff(pred_def_3662,type,
    v6950: state_type > $o ).

tff(pred_def_3663,type,
    v6956: state_type > $o ).

tff(pred_def_3664,type,
    v6954: state_type > $o ).

tff(pred_def_3665,type,
    v6958: state_type > $o ).

tff(pred_def_3666,type,
    v6948: state_type > $o ).

tff(pred_def_3667,type,
    v6946: state_type > $o ).

tff(pred_def_3668,type,
    v6944: state_type > $o ).

tff(pred_def_3669,type,
    v6942: state_type > $o ).

tff(pred_def_3670,type,
    v6940: state_type > $o ).

tff(pred_def_3671,type,
    v6938: state_type > $o ).

tff(pred_def_3672,type,
    v6936: state_type > $o ).

tff(pred_def_3673,type,
    v6934: state_type > $o ).

tff(pred_def_3674,type,
    v6964: state_type > $o ).

tff(pred_def_3675,type,
    v6963: ( state_type * $int ) > $o ).

tff(pred_def_3676,type,
    v6962: ( state_type * $int ) > $o ).

tff(pred_def_3677,type,
    v6967: state_type > $o ).

tff(pred_def_3678,type,
    v6966: ( state_type * $int ) > $o ).

tff(pred_def_3679,type,
    v6965: ( state_type * $int ) > $o ).

tff(pred_def_3680,type,
    v6961: ( state_type * $int ) > $o ).

tff(pred_def_3681,type,
    v6970: state_type > $o ).

tff(pred_def_3682,type,
    v6969: ( state_type * $int ) > $o ).

tff(pred_def_3683,type,
    v6968: ( state_type * $int ) > $o ).

tff(pred_def_3684,type,
    v6960: ( state_type * $int ) > $o ).

tff(pred_def_3685,type,
    v6973: state_type > $o ).

tff(pred_def_3686,type,
    v6972: ( state_type * $int ) > $o ).

tff(pred_def_3687,type,
    v6971: ( state_type * $int ) > $o ).

tff(pred_def_3688,type,
    v6959: ( state_type * $int ) > $o ).

tff(pred_def_3689,type,
    v6791: ( state_type * $int ) > $o ).

tff(pred_def_3690,type,
    v6789: ( state_type * $int ) > $o ).

tff(pred_def_3691,type,
    v6787: ( state_type * $int ) > $o ).

tff(pred_def_3692,type,
    v6985: state_type > $o ).

tff(pred_def_3693,type,
    v6983: state_type > $o ).

tff(pred_def_3694,type,
    v6981: state_type > $o ).

tff(pred_def_3695,type,
    v6995: state_type > $o ).

tff(pred_def_3696,type,
    v6993: state_type > $o ).

tff(pred_def_3697,type,
    v6991: state_type > $o ).

tff(pred_def_3698,type,
    v6989: state_type > $o ).

tff(pred_def_3699,type,
    v6987: state_type > $o ).

tff(pred_def_3700,type,
    v6997: state_type > $o ).

tff(pred_def_3701,type,
    v6979: state_type > $o ).

tff(pred_def_3702,type,
    v6977: state_type > $o ).

tff(pred_def_3703,type,
    v6975: state_type > $o ).

tff(pred_def_3704,type,
    v7004: state_type > $o ).

tff(pred_def_3705,type,
    v7002: state_type > $o ).

tff(pred_def_3706,type,
    v7001: state_type > $o ).

tff(pred_def_3707,type,
    v7000: state_type > $o ).

tff(pred_def_3708,type,
    v7012: state_type > $o ).

tff(pred_def_3709,type,
    v7013: state_type > $o ).

tff(pred_def_3710,type,
    v7011: state_type > $o ).

tff(pred_def_3711,type,
    v7008: ( state_type * $int ) > $o ).

tff(pred_def_3712,type,
    v7010: ( state_type * $int ) > $o ).

tff(pred_def_3713,type,
    v6999: ( state_type * $int ) > $o ).

tff(pred_def_3714,type,
    v6757: ( state_type * $int ) > $o ).

tff(pred_def_3715,type,
    v6755: ( state_type * $int ) > $o ).

tff(pred_def_3716,type,
    v6753: ( state_type * $int ) > $o ).

tff(pred_def_3717,type,
    v6751: ( state_type * $int ) > $o ).

tff(pred_def_3718,type,
    v6749: ( state_type * $int ) > $o ).

tff(pred_def_3719,type,
    v7023: ( state_type * $int ) > $o ).

tff(pred_def_3720,type,
    v7021: ( state_type * $int ) > $o ).

tff(pred_def_3721,type,
    v7019: state_type > $o ).

tff(pred_def_3722,type,
    v7017: state_type > $o ).

tff(pred_def_3723,type,
    v7027: state_type > $o ).

tff(pred_def_3724,type,
    v7026: ( state_type * $int ) > $o ).

tff(pred_def_3725,type,
    v7025: ( state_type * $int ) > $o ).

tff(pred_def_3726,type,
    v7030: state_type > $o ).

tff(pred_def_3727,type,
    v7029: ( state_type * $int ) > $o ).

tff(pred_def_3728,type,
    v7028: ( state_type * $int ) > $o ).

tff(pred_def_3729,type,
    v7024: ( state_type * $int ) > $o ).

tff(pred_def_3730,type,
    v6328: ( state_type * $int ) > $o ).

tff(pred_def_3731,type,
    v6326: ( state_type * $int ) > $o ).

tff(pred_def_3732,type,
    v6324: ( state_type * $int ) > $o ).

tff(pred_def_3733,type,
    v6322: ( state_type * $int ) > $o ).

tff(pred_def_3734,type,
    v6320: ( state_type * $int ) > $o ).

tff(pred_def_3735,type,
    v6318: ( state_type * $int ) > $o ).

tff(pred_def_3736,type,
    v7031: ( state_type * $int ) > $o ).

tff(pred_def_3737,type,
    v6294: ( state_type * $int ) > $o ).

tff(pred_def_3738,type,
    v6292: ( state_type * $int ) > $o ).

tff(pred_def_3739,type,
    v6290: ( state_type * $int ) > $o ).

tff(pred_def_3740,type,
    v6288: ( state_type * $int ) > $o ).

tff(pred_def_3741,type,
    v6286: ( state_type * $int ) > $o ).

tff(pred_def_3742,type,
    v7045: state_type > $o ).

tff(pred_def_3743,type,
    v7043: state_type > $o ).

tff(pred_def_3744,type,
    v7041: state_type > $o ).

tff(pred_def_3745,type,
    v7039: state_type > $o ).

tff(pred_def_3746,type,
    v7051: state_type > $o ).

tff(pred_def_3747,type,
    v7049: state_type > $o ).

tff(pred_def_3748,type,
    v7069: ( state_type * $int ) > $o ).

tff(pred_def_3749,type,
    v7071: ( state_type * $int ) > $o ).

tff(pred_def_3750,type,
    v7067: ( state_type * $int ) > $o ).

tff(pred_def_3751,type,
    v7065: state_type > $o ).

tff(pred_def_3752,type,
    v7063: state_type > $o ).

tff(pred_def_3753,type,
    v7075: state_type > $o ).

tff(pred_def_3754,type,
    v7073: state_type > $o ).

tff(pred_def_3755,type,
    v7079: state_type > $o ).

tff(pred_def_3756,type,
    v7077: state_type > $o ).

tff(pred_def_3757,type,
    v7082: state_type > $o ).

tff(pred_def_3758,type,
    v7081: state_type > $o ).

tff(pred_def_3759,type,
    v7061: state_type > $o ).

tff(pred_def_3760,type,
    v7059: state_type > $o ).

tff(pred_def_3761,type,
    v7057: state_type > $o ).

tff(pred_def_3762,type,
    v7055: state_type > $o ).

tff(pred_def_3763,type,
    v7053: state_type > $o ).

tff(pred_def_3764,type,
    v7092: state_type > $o ).

tff(pred_def_3765,type,
    v7090: state_type > $o ).

tff(pred_def_3766,type,
    v7088: state_type > $o ).

tff(pred_def_3767,type,
    v7086: state_type > $o ).

tff(pred_def_3768,type,
    v7084: state_type > $o ).

tff(pred_def_3769,type,
    v7047: state_type > $o ).

tff(pred_def_3770,type,
    v7098: state_type > $o ).

tff(pred_def_3771,type,
    v7100: state_type > $o ).

tff(pred_def_3772,type,
    v7096: state_type > $o ).

tff(pred_def_3773,type,
    v7095: state_type > $o ).

tff(pred_def_3774,type,
    v7106: state_type > $o ).

tff(pred_def_3775,type,
    v7107: state_type > $o ).

tff(pred_def_3776,type,
    v7103: state_type > $o ).

tff(pred_def_3777,type,
    v7105: state_type > $o ).

tff(pred_def_3778,type,
    v7119: state_type > $o ).

tff(pred_def_3779,type,
    v7117: state_type > $o ).

tff(pred_def_3780,type,
    v7115: state_type > $o ).

tff(pred_def_3781,type,
    v7113: state_type > $o ).

tff(pred_def_3782,type,
    v7111: state_type > $o ).

tff(pred_def_3783,type,
    v7121: state_type > $o ).

tff(pred_def_3784,type,
    v7037: state_type > $o ).

tff(pred_def_3785,type,
    v7035: state_type > $o ).

tff(pred_def_3786,type,
    v7033: state_type > $o ).

tff(pred_def_3787,type,
    v7128: state_type > $o ).

tff(pred_def_3788,type,
    v7126: state_type > $o ).

tff(pred_def_3789,type,
    v7125: state_type > $o ).

tff(pred_def_3790,type,
    v7124: state_type > $o ).

tff(pred_def_3791,type,
    v7136: state_type > $o ).

tff(pred_def_3792,type,
    v7137: state_type > $o ).

tff(pred_def_3793,type,
    v7135: state_type > $o ).

tff(pred_def_3794,type,
    v7132: ( state_type * $int ) > $o ).

tff(pred_def_3795,type,
    v7134: ( state_type * $int ) > $o ).

tff(pred_def_3796,type,
    v7123: ( state_type * $int ) > $o ).

tff(pred_def_3797,type,
    v6256: ( state_type * $int ) > $o ).

tff(pred_def_3798,type,
    v6254: ( state_type * $int ) > $o ).

tff(pred_def_3799,type,
    v6252: ( state_type * $int ) > $o ).

tff(pred_def_3800,type,
    v6250: ( state_type * $int ) > $o ).

tff(pred_def_3801,type,
    v6248: ( state_type * $int ) > $o ).

tff(pred_def_3802,type,
    v7175: state_type > $o ).

tff(pred_def_3803,type,
    v7173: state_type > $o ).

tff(pred_def_3804,type,
    v7171: state_type > $o ).

tff(pred_def_3805,type,
    v7169: state_type > $o ).

tff(pred_def_3806,type,
    v7167: state_type > $o ).

tff(pred_def_3807,type,
    v7165: state_type > $o ).

tff(pred_def_3808,type,
    v7163: state_type > $o ).

tff(pred_def_3809,type,
    v7185: state_type > $o ).

tff(pred_def_3810,type,
    v7183: state_type > $o ).

tff(pred_def_3811,type,
    v7181: state_type > $o ).

tff(pred_def_3812,type,
    v7179: state_type > $o ).

tff(pred_def_3813,type,
    v7177: state_type > $o ).

tff(pred_def_3814,type,
    v7212: state_type > $o ).

tff(pred_def_3815,type,
    v7211: ( state_type * $int ) > $o ).

tff(pred_def_3816,type,
    v7210: ( state_type * $int ) > $o ).

tff(pred_def_3817,type,
    v7208: ( state_type * $int ) > $o ).

tff(pred_def_3818,type,
    b101111111110: $int > $o ).

tff(pred_def_3819,type,
    v7250: ( state_type * $int ) > $o ).

tff(pred_def_3820,type,
    v7248: ( state_type * $int ) > $o ).

tff(pred_def_3821,type,
    v7261: state_type > $o ).

tff(pred_def_3822,type,
    v7259: state_type > $o ).

tff(pred_def_3823,type,
    v7258: state_type > $o ).

tff(pred_def_3824,type,
    v7257: ( state_type * $int ) > $o ).

tff(pred_def_3825,type,
    v7269: state_type > $o ).

tff(pred_def_3826,type,
    v7267: state_type > $o ).

tff(pred_def_3827,type,
    v7266: state_type > $o ).

tff(pred_def_3828,type,
    v7265: ( state_type * $int ) > $o ).

tff(pred_def_3829,type,
    v7277: state_type > $o ).

tff(pred_def_3830,type,
    v7275: state_type > $o ).

tff(pred_def_3831,type,
    v7274: state_type > $o ).

tff(pred_def_3832,type,
    v7273: ( state_type * $int ) > $o ).

tff(pred_def_3833,type,
    v7299: state_type > $o ).

tff(pred_def_3834,type,
    v7297: state_type > $o ).

tff(pred_def_3835,type,
    v7295: state_type > $o ).

tff(pred_def_3836,type,
    v7293: state_type > $o ).

tff(pred_def_3837,type,
    v7291: state_type > $o ).

tff(pred_def_3838,type,
    v7309: state_type > $o ).

tff(pred_def_3839,type,
    v7307: state_type > $o ).

tff(pred_def_3840,type,
    v7305: state_type > $o ).

tff(pred_def_3841,type,
    v7303: state_type > $o ).

tff(pred_def_3842,type,
    v7301: state_type > $o ).

tff(pred_def_3843,type,
    v7313: ( state_type * $int ) > $o ).

tff(pred_def_3844,type,
    v7311: ( state_type * $int ) > $o ).

tff(pred_def_3845,type,
    v7323: state_type > $o ).

tff(pred_def_3846,type,
    v7321: state_type > $o ).

tff(pred_def_3847,type,
    v7329: state_type > $o ).

tff(pred_def_3848,type,
    v7327: state_type > $o ).

tff(pred_def_3849,type,
    v7353: ( state_type * $int ) > $o ).

tff(pred_def_3850,type,
    v7351: ( state_type * $int ) > $o ).

tff(pred_def_3851,type,
    v7354: ( state_type * $int ) > $o ).

tff(pred_def_3852,type,
    v7349: ( state_type * $int ) > $o ).

tff(pred_def_3853,type,
    v7347: ( state_type * $int ) > $o ).

tff(pred_def_3854,type,
    v7345: ( state_type * $int ) > $o ).

tff(pred_def_3855,type,
    v7343: state_type > $o ).

tff(pred_def_3856,type,
    v7341: state_type > $o ).

tff(pred_def_3857,type,
    v7358: state_type > $o ).

tff(pred_def_3858,type,
    v7356: state_type > $o ).

tff(pred_def_3859,type,
    v7362: state_type > $o ).

tff(pred_def_3860,type,
    v7360: state_type > $o ).

tff(pred_def_3861,type,
    v7365: state_type > $o ).

tff(pred_def_3862,type,
    v7364: state_type > $o ).

tff(pred_def_3863,type,
    v7339: state_type > $o ).

tff(pred_def_3864,type,
    v7337: state_type > $o ).

tff(pred_def_3865,type,
    v7335: state_type > $o ).

tff(pred_def_3866,type,
    v7333: state_type > $o ).

tff(pred_def_3867,type,
    v7331: state_type > $o ).

tff(pred_def_3868,type,
    v7369: state_type > $o ).

tff(pred_def_3869,type,
    v7367: state_type > $o ).

tff(pred_def_3870,type,
    v7325: state_type > $o ).

tff(pred_def_3871,type,
    v7375: state_type > $o ).

tff(pred_def_3872,type,
    v7377: state_type > $o ).

tff(pred_def_3873,type,
    v7373: state_type > $o ).

tff(pred_def_3874,type,
    v7372: state_type > $o ).

tff(pred_def_3875,type,
    v7383: state_type > $o ).

tff(pred_def_3876,type,
    v7384: state_type > $o ).

tff(pred_def_3877,type,
    v7380: state_type > $o ).

tff(pred_def_3878,type,
    v7382: state_type > $o ).

tff(pred_def_3879,type,
    v7390: state_type > $o ).

tff(pred_def_3880,type,
    v7388: state_type > $o ).

tff(pred_def_3881,type,
    v7392: state_type > $o ).

tff(pred_def_3882,type,
    v7319: state_type > $o ).

tff(pred_def_3883,type,
    v7317: state_type > $o ).

tff(pred_def_3884,type,
    v7315: state_type > $o ).

tff(pred_def_3885,type,
    v7399: state_type > $o ).

tff(pred_def_3886,type,
    v7397: state_type > $o ).

tff(pred_def_3887,type,
    v7396: state_type > $o ).

tff(pred_def_3888,type,
    v7395: state_type > $o ).

tff(pred_def_3889,type,
    v7407: state_type > $o ).

tff(pred_def_3890,type,
    v7408: state_type > $o ).

tff(pred_def_3891,type,
    v7406: state_type > $o ).

tff(pred_def_3892,type,
    v7403: ( state_type * $int ) > $o ).

tff(pred_def_3893,type,
    v7405: ( state_type * $int ) > $o ).

tff(pred_def_3894,type,
    v7394: ( state_type * $int ) > $o ).

tff(pred_def_3895,type,
    v7289: ( state_type * $int ) > $o ).

tff(pred_def_3896,type,
    v7287: ( state_type * $int ) > $o ).

tff(pred_def_3897,type,
    v7285: ( state_type * $int ) > $o ).

tff(pred_def_3898,type,
    v7283: ( state_type * $int ) > $o ).

tff(pred_def_3899,type,
    v7281: ( state_type * $int ) > $o ).

tff(pred_def_3900,type,
    v7440: ( state_type * $int ) > $o ).

tff(pred_def_3901,type,
    v7161: ( state_type * $int ) > $o ).

tff(pred_def_3902,type,
    v7438: ( state_type * $int ) > $o ).

tff(pred_def_3903,type,
    v7441: ( state_type * $int ) > $o ).

tff(pred_def_3904,type,
    v7436: ( state_type * $int ) > $o ).

tff(pred_def_3905,type,
    v7434: ( state_type * $int ) > $o ).

tff(pred_def_3906,type,
    v7432: ( state_type * $int ) > $o ).

tff(pred_def_3907,type,
    v7430: state_type > $o ).

tff(pred_def_3908,type,
    v7428: state_type > $o ).

tff(pred_def_3909,type,
    v7447: state_type > $o ).

tff(pred_def_3910,type,
    v7201: state_type > $o ).

tff(pred_def_3911,type,
    v7446: ( state_type * $int ) > $o ).

tff(pred_def_3912,type,
    v7199: ( state_type * $int ) > $o ).

tff(pred_def_3913,type,
    v7197: ( state_type * $int ) > $o ).

tff(pred_def_3914,type,
    v7462: ( state_type * $int ) > $o ).

tff(pred_def_3915,type,
    v7461: ( state_type * $int ) > $o ).

tff(pred_def_3916,type,
    v7459: ( state_type * $int ) > $o ).

tff(pred_def_3917,type,
    v7466: state_type > $o ).

tff(pred_def_3918,type,
    v7228: state_type > $o ).

tff(pred_def_3919,type,
    v7464: state_type > $o ).

tff(pred_def_3920,type,
    v7477: ( state_type * $int ) > $o ).

tff(pred_def_3921,type,
    v7476: state_type > $o ).

tff(pred_def_3922,type,
    v7480: state_type > $o ).

tff(pred_def_3923,type,
    v7481: state_type > $o ).

tff(pred_def_3924,type,
    v7479: state_type > $o ).

tff(pred_def_3925,type,
    v7482: state_type > $o ).

tff(pred_def_3926,type,
    v7478: state_type > $o ).

tff(pred_def_3927,type,
    v7475: state_type > $o ).

tff(pred_def_3928,type,
    v7483: state_type > $o ).

tff(pred_def_3929,type,
    v7474: state_type > $o ).

tff(pred_def_3930,type,
    v7486: state_type > $o ).

tff(pred_def_3931,type,
    v7487: state_type > $o ).

tff(pred_def_3932,type,
    v7485: state_type > $o ).

tff(pred_def_3933,type,
    v7488: state_type > $o ).

tff(pred_def_3934,type,
    v7484: state_type > $o ).

tff(pred_def_3935,type,
    v7473: state_type > $o ).

tff(pred_def_3936,type,
    v7489: state_type > $o ).

tff(pred_def_3937,type,
    v7472: state_type > $o ).

tff(pred_def_3938,type,
    v7471: state_type > $o ).

tff(pred_def_3939,type,
    v7493: state_type > $o ).

tff(pred_def_3940,type,
    v7494: state_type > $o ).

tff(pred_def_3941,type,
    v7492: state_type > $o ).

tff(pred_def_3942,type,
    v7495: state_type > $o ).

tff(pred_def_3943,type,
    v7491: state_type > $o ).

tff(pred_def_3944,type,
    v7490: state_type > $o ).

tff(pred_def_3945,type,
    v7470: state_type > $o ).

tff(pred_def_3946,type,
    v7496: state_type > $o ).

tff(pred_def_3947,type,
    v7469: state_type > $o ).

tff(pred_def_3948,type,
    v7499: state_type > $o ).

tff(pred_def_3949,type,
    v7500: state_type > $o ).

tff(pred_def_3950,type,
    v7498: state_type > $o ).

tff(pred_def_3951,type,
    v7501: state_type > $o ).

tff(pred_def_3952,type,
    v7497: state_type > $o ).

tff(pred_def_3953,type,
    v7504: state_type > $o ).

tff(pred_def_3954,type,
    v7505: state_type > $o ).

tff(pred_def_3955,type,
    v7503: state_type > $o ).

tff(pred_def_3956,type,
    v7506: state_type > $o ).

tff(pred_def_3957,type,
    v7502: state_type > $o ).

tff(pred_def_3958,type,
    v7509: state_type > $o ).

tff(pred_def_3959,type,
    v7510: state_type > $o ).

tff(pred_def_3960,type,
    v7508: state_type > $o ).

tff(pred_def_3961,type,
    v7511: state_type > $o ).

tff(pred_def_3962,type,
    v7507: state_type > $o ).

tff(pred_def_3963,type,
    v7467: ( state_type * $int ) > $o ).

tff(pred_def_3964,type,
    v7457: ( state_type * $int ) > $o ).

tff(pred_def_3965,type,
    v7455: ( state_type * $int ) > $o ).

tff(pred_def_3966,type,
    v7453: ( state_type * $int ) > $o ).

tff(pred_def_3967,type,
    v7451: ( state_type * $int ) > $o ).

tff(pred_def_3968,type,
    v7449: ( state_type * $int ) > $o ).

tff(pred_def_3969,type,
    v7512: ( state_type * $int ) > $o ).

tff(pred_def_3970,type,
    v7195: ( state_type * $int ) > $o ).

tff(pred_def_3971,type,
    v7193: ( state_type * $int ) > $o ).

tff(pred_def_3972,type,
    v7191: ( state_type * $int ) > $o ).

tff(pred_def_3973,type,
    v7513: ( state_type * $int ) > $o ).

tff(pred_def_3974,type,
    v7514: ( state_type * $int ) > $o ).

tff(pred_def_3975,type,
    v7189: ( state_type * $int ) > $o ).

tff(pred_def_3976,type,
    v7187: ( state_type * $int ) > $o ).

tff(pred_def_3977,type,
    v7524: state_type > $o ).

tff(pred_def_3978,type,
    v7522: state_type > $o ).

tff(pred_def_3979,type,
    v7530: state_type > $o ).

tff(pred_def_3980,type,
    v7528: state_type > $o ).

tff(pred_def_3981,type,
    v7534: state_type > $o ).

tff(pred_def_3982,type,
    v7532: state_type > $o ).

tff(pred_def_3983,type,
    v7538: state_type > $o ).

tff(pred_def_3984,type,
    v7536: state_type > $o ).

tff(pred_def_3985,type,
    v7526: state_type > $o ).

tff(pred_def_3986,type,
    v7544: state_type > $o ).

tff(pred_def_3987,type,
    v7546: state_type > $o ).

tff(pred_def_3988,type,
    v7542: state_type > $o ).

tff(pred_def_3989,type,
    v7541: state_type > $o ).

tff(pred_def_3990,type,
    v7552: state_type > $o ).

tff(pred_def_3991,type,
    v7553: state_type > $o ).

tff(pred_def_3992,type,
    v7549: state_type > $o ).

tff(pred_def_3993,type,
    v7551: state_type > $o ).

tff(pred_def_3994,type,
    v7559: state_type > $o ).

tff(pred_def_3995,type,
    v7557: state_type > $o ).

tff(pred_def_3996,type,
    v7561: state_type > $o ).

tff(pred_def_3997,type,
    v7520: state_type > $o ).

tff(pred_def_3998,type,
    v7518: state_type > $o ).

tff(pred_def_3999,type,
    v7516: state_type > $o ).

tff(pred_def_4000,type,
    v7568: state_type > $o ).

tff(pred_def_4001,type,
    v7566: state_type > $o ).

tff(pred_def_4002,type,
    v7565: state_type > $o ).

tff(pred_def_4003,type,
    v7564: state_type > $o ).

tff(pred_def_4004,type,
    v7576: state_type > $o ).

tff(pred_def_4005,type,
    v7577: state_type > $o ).

tff(pred_def_4006,type,
    v7575: state_type > $o ).

tff(pred_def_4007,type,
    v7572: ( state_type * $int ) > $o ).

tff(pred_def_4008,type,
    v7574: ( state_type * $int ) > $o ).

tff(pred_def_4009,type,
    v7563: ( state_type * $int ) > $o ).

tff(pred_def_4010,type,
    v7445: state_type > $o ).

tff(pred_def_4011,type,
    v7443: state_type > $o ).

tff(pred_def_4012,type,
    v7589: state_type > $o ).

tff(pred_def_4013,type,
    v7587: state_type > $o ).

tff(pred_def_4014,type,
    v7586: state_type > $o ).

tff(pred_def_4015,type,
    v7585: ( state_type * $int ) > $o ).

tff(pred_def_4016,type,
    v7583: state_type > $o ).

tff(pred_def_4017,type,
    v7581: state_type > $o ).

tff(pred_def_4018,type,
    v7594: state_type > $o ).

tff(pred_def_4019,type,
    v7593: state_type > $o ).

tff(pred_def_4020,type,
    v7426: state_type > $o ).

tff(pred_def_4021,type,
    v7424: state_type > $o ).

tff(pred_def_4022,type,
    v7422: state_type > $o ).

tff(pred_def_4023,type,
    v7420: state_type > $o ).

tff(pred_def_4024,type,
    v7418: state_type > $o ).

tff(pred_def_4025,type,
    v7416: state_type > $o ).

tff(pred_def_4026,type,
    v7414: state_type > $o ).

tff(pred_def_4027,type,
    v7412: state_type > $o ).

tff(pred_def_4028,type,
    v7614: state_type > $o ).

tff(pred_def_4029,type,
    v7612: state_type > $o ).

tff(pred_def_4030,type,
    v7610: state_type > $o ).

tff(pred_def_4031,type,
    v7608: state_type > $o ).

tff(pred_def_4032,type,
    v7606: state_type > $o ).

tff(pred_def_4033,type,
    v7624: state_type > $o ).

tff(pred_def_4034,type,
    v7622: state_type > $o ).

tff(pred_def_4035,type,
    v7620: state_type > $o ).

tff(pred_def_4036,type,
    v7618: state_type > $o ).

tff(pred_def_4037,type,
    v7616: state_type > $o ).

tff(pred_def_4038,type,
    v7628: ( state_type * $int ) > $o ).

tff(pred_def_4039,type,
    v7626: ( state_type * $int ) > $o ).

tff(pred_def_4040,type,
    v7638: state_type > $o ).

tff(pred_def_4041,type,
    v7636: state_type > $o ).

tff(pred_def_4042,type,
    v7644: state_type > $o ).

tff(pred_def_4043,type,
    v7642: state_type > $o ).

tff(pred_def_4044,type,
    v7658: state_type > $o ).

tff(pred_def_4045,type,
    v7656: state_type > $o ).

tff(pred_def_4046,type,
    v7662: state_type > $o ).

tff(pred_def_4047,type,
    v7660: state_type > $o ).

tff(pred_def_4048,type,
    v7666: state_type > $o ).

tff(pred_def_4049,type,
    v7664: state_type > $o ).

tff(pred_def_4050,type,
    v7669: state_type > $o ).

tff(pred_def_4051,type,
    v7668: state_type > $o ).

tff(pred_def_4052,type,
    v7654: state_type > $o ).

tff(pred_def_4053,type,
    v7652: state_type > $o ).

tff(pred_def_4054,type,
    v7650: state_type > $o ).

tff(pred_def_4055,type,
    v7648: state_type > $o ).

tff(pred_def_4056,type,
    v7646: state_type > $o ).

tff(pred_def_4057,type,
    v7673: state_type > $o ).

tff(pred_def_4058,type,
    v7671: state_type > $o ).

tff(pred_def_4059,type,
    v7640: state_type > $o ).

tff(pred_def_4060,type,
    v7679: state_type > $o ).

tff(pred_def_4061,type,
    v7681: state_type > $o ).

tff(pred_def_4062,type,
    v7677: state_type > $o ).

tff(pred_def_4063,type,
    v7676: state_type > $o ).

tff(pred_def_4064,type,
    v7687: state_type > $o ).

tff(pred_def_4065,type,
    v7688: state_type > $o ).

tff(pred_def_4066,type,
    v7684: state_type > $o ).

tff(pred_def_4067,type,
    v7686: state_type > $o ).

tff(pred_def_4068,type,
    v7694: state_type > $o ).

tff(pred_def_4069,type,
    v7692: state_type > $o ).

tff(pred_def_4070,type,
    v7696: state_type > $o ).

tff(pred_def_4071,type,
    v7634: state_type > $o ).

tff(pred_def_4072,type,
    v7632: state_type > $o ).

tff(pred_def_4073,type,
    v7630: state_type > $o ).

tff(pred_def_4074,type,
    v7703: state_type > $o ).

tff(pred_def_4075,type,
    v7701: state_type > $o ).

tff(pred_def_4076,type,
    v7700: state_type > $o ).

tff(pred_def_4077,type,
    v7699: state_type > $o ).

tff(pred_def_4078,type,
    v7711: state_type > $o ).

tff(pred_def_4079,type,
    v7712: state_type > $o ).

tff(pred_def_4080,type,
    v7710: state_type > $o ).

tff(pred_def_4081,type,
    v7707: ( state_type * $int ) > $o ).

tff(pred_def_4082,type,
    v7709: ( state_type * $int ) > $o ).

tff(pred_def_4083,type,
    v7698: ( state_type * $int ) > $o ).

tff(pred_def_4084,type,
    v7604: ( state_type * $int ) > $o ).

tff(pred_def_4085,type,
    v7602: ( state_type * $int ) > $o ).

tff(pred_def_4086,type,
    v7600: ( state_type * $int ) > $o ).

tff(pred_def_4087,type,
    v7598: ( state_type * $int ) > $o ).

tff(pred_def_4088,type,
    v7596: ( state_type * $int ) > $o ).

tff(pred_def_4089,type,
    v7734: state_type > $o ).

tff(pred_def_4090,type,
    v7732: state_type > $o ).

tff(pred_def_4091,type,
    v7738: state_type > $o ).

tff(pred_def_4092,type,
    v7736: state_type > $o ).

tff(pred_def_4093,type,
    v7742: state_type > $o ).

tff(pred_def_4094,type,
    v7740: state_type > $o ).

tff(pred_def_4095,type,
    v7745: state_type > $o ).

tff(pred_def_4096,type,
    v7744: state_type > $o ).

tff(pred_def_4097,type,
    v7730: state_type > $o ).

tff(pred_def_4098,type,
    v7728: state_type > $o ).

tff(pred_def_4099,type,
    v7726: state_type > $o ).

tff(pred_def_4100,type,
    v7724: state_type > $o ).

tff(pred_def_4101,type,
    v7722: state_type > $o ).

tff(pred_def_4102,type,
    v7720: state_type > $o ).

tff(pred_def_4103,type,
    v7718: state_type > $o ).

tff(pred_def_4104,type,
    v7716: state_type > $o ).

tff(pred_def_4105,type,
    v7765: state_type > $o ).

tff(pred_def_4106,type,
    v7763: state_type > $o ).

tff(pred_def_4107,type,
    v7761: state_type > $o ).

tff(pred_def_4108,type,
    v7759: state_type > $o ).

tff(pred_def_4109,type,
    v7757: state_type > $o ).

tff(pred_def_4110,type,
    v7775: state_type > $o ).

tff(pred_def_4111,type,
    v7773: state_type > $o ).

tff(pred_def_4112,type,
    v7771: state_type > $o ).

tff(pred_def_4113,type,
    v7769: state_type > $o ).

tff(pred_def_4114,type,
    v7767: state_type > $o ).

tff(pred_def_4115,type,
    v7779: ( state_type * $int ) > $o ).

tff(pred_def_4116,type,
    v7777: ( state_type * $int ) > $o ).

tff(pred_def_4117,type,
    v7789: state_type > $o ).

tff(pred_def_4118,type,
    v7787: state_type > $o ).

tff(pred_def_4119,type,
    v7795: state_type > $o ).

tff(pred_def_4120,type,
    v7793: state_type > $o ).

tff(pred_def_4121,type,
    v7809: state_type > $o ).

tff(pred_def_4122,type,
    v7807: state_type > $o ).

tff(pred_def_4123,type,
    v7813: state_type > $o ).

tff(pred_def_4124,type,
    v7811: state_type > $o ).

tff(pred_def_4125,type,
    v7817: state_type > $o ).

tff(pred_def_4126,type,
    v7815: state_type > $o ).

tff(pred_def_4127,type,
    v7820: state_type > $o ).

tff(pred_def_4128,type,
    v7819: state_type > $o ).

tff(pred_def_4129,type,
    v7805: state_type > $o ).

tff(pred_def_4130,type,
    v7803: state_type > $o ).

tff(pred_def_4131,type,
    v7801: state_type > $o ).

tff(pred_def_4132,type,
    v7799: state_type > $o ).

tff(pred_def_4133,type,
    v7797: state_type > $o ).

tff(pred_def_4134,type,
    v7824: state_type > $o ).

tff(pred_def_4135,type,
    v7822: state_type > $o ).

tff(pred_def_4136,type,
    v7791: state_type > $o ).

tff(pred_def_4137,type,
    v7830: state_type > $o ).

tff(pred_def_4138,type,
    v7832: state_type > $o ).

tff(pred_def_4139,type,
    v7828: state_type > $o ).

tff(pred_def_4140,type,
    v7827: state_type > $o ).

tff(pred_def_4141,type,
    v7838: state_type > $o ).

tff(pred_def_4142,type,
    v7839: state_type > $o ).

tff(pred_def_4143,type,
    v7835: state_type > $o ).

tff(pred_def_4144,type,
    v7837: state_type > $o ).

tff(pred_def_4145,type,
    v7845: state_type > $o ).

tff(pred_def_4146,type,
    v7843: state_type > $o ).

tff(pred_def_4147,type,
    v7847: state_type > $o ).

tff(pred_def_4148,type,
    v7785: state_type > $o ).

tff(pred_def_4149,type,
    v7783: state_type > $o ).

tff(pred_def_4150,type,
    v7781: state_type > $o ).

tff(pred_def_4151,type,
    v7854: state_type > $o ).

tff(pred_def_4152,type,
    v7852: state_type > $o ).

tff(pred_def_4153,type,
    v7851: state_type > $o ).

tff(pred_def_4154,type,
    v7850: state_type > $o ).

tff(pred_def_4155,type,
    v7862: state_type > $o ).

tff(pred_def_4156,type,
    v7863: state_type > $o ).

tff(pred_def_4157,type,
    v7861: state_type > $o ).

tff(pred_def_4158,type,
    v7858: ( state_type * $int ) > $o ).

tff(pred_def_4159,type,
    v7860: ( state_type * $int ) > $o ).

tff(pred_def_4160,type,
    v7849: ( state_type * $int ) > $o ).

tff(pred_def_4161,type,
    v7755: ( state_type * $int ) > $o ).

tff(pred_def_4162,type,
    v7753: ( state_type * $int ) > $o ).

tff(pred_def_4163,type,
    v7751: ( state_type * $int ) > $o ).

tff(pred_def_4164,type,
    v7749: ( state_type * $int ) > $o ).

tff(pred_def_4165,type,
    v7747: ( state_type * $int ) > $o ).

tff(pred_def_4166,type,
    v7885: state_type > $o ).

tff(pred_def_4167,type,
    v7883: state_type > $o ).

tff(pred_def_4168,type,
    v7889: state_type > $o ).

tff(pred_def_4169,type,
    v7887: state_type > $o ).

tff(pred_def_4170,type,
    v7893: state_type > $o ).

tff(pred_def_4171,type,
    v7891: state_type > $o ).

tff(pred_def_4172,type,
    v7896: state_type > $o ).

tff(pred_def_4173,type,
    v7895: state_type > $o ).

tff(pred_def_4174,type,
    v7881: state_type > $o ).

tff(pred_def_4175,type,
    v7879: state_type > $o ).

tff(pred_def_4176,type,
    v7877: state_type > $o ).

tff(pred_def_4177,type,
    v7875: state_type > $o ).

tff(pred_def_4178,type,
    v7873: state_type > $o ).

tff(pred_def_4179,type,
    v7871: state_type > $o ).

tff(pred_def_4180,type,
    v7869: state_type > $o ).

tff(pred_def_4181,type,
    v7867: state_type > $o ).

tff(pred_def_4182,type,
    v7916: state_type > $o ).

tff(pred_def_4183,type,
    v7914: state_type > $o ).

tff(pred_def_4184,type,
    v7912: state_type > $o ).

tff(pred_def_4185,type,
    v7910: state_type > $o ).

tff(pred_def_4186,type,
    v7908: state_type > $o ).

tff(pred_def_4187,type,
    v7926: state_type > $o ).

tff(pred_def_4188,type,
    v7924: state_type > $o ).

tff(pred_def_4189,type,
    v7922: state_type > $o ).

tff(pred_def_4190,type,
    v7920: state_type > $o ).

tff(pred_def_4191,type,
    v7918: state_type > $o ).

tff(pred_def_4192,type,
    v7930: ( state_type * $int ) > $o ).

tff(pred_def_4193,type,
    v7928: ( state_type * $int ) > $o ).

tff(pred_def_4194,type,
    v7940: state_type > $o ).

tff(pred_def_4195,type,
    v7938: state_type > $o ).

tff(pred_def_4196,type,
    v7946: state_type > $o ).

tff(pred_def_4197,type,
    v7944: state_type > $o ).

tff(pred_def_4198,type,
    v7960: state_type > $o ).

tff(pred_def_4199,type,
    v7958: state_type > $o ).

tff(pred_def_4200,type,
    v7964: state_type > $o ).

tff(pred_def_4201,type,
    v7962: state_type > $o ).

tff(pred_def_4202,type,
    v7968: state_type > $o ).

tff(pred_def_4203,type,
    v7966: state_type > $o ).

tff(pred_def_4204,type,
    v7971: state_type > $o ).

tff(pred_def_4205,type,
    v7970: state_type > $o ).

tff(pred_def_4206,type,
    v7956: state_type > $o ).

tff(pred_def_4207,type,
    v7954: state_type > $o ).

tff(pred_def_4208,type,
    v7952: state_type > $o ).

tff(pred_def_4209,type,
    v7950: state_type > $o ).

tff(pred_def_4210,type,
    v7948: state_type > $o ).

tff(pred_def_4211,type,
    v7975: state_type > $o ).

tff(pred_def_4212,type,
    v7973: state_type > $o ).

tff(pred_def_4213,type,
    v7942: state_type > $o ).

tff(pred_def_4214,type,
    v7981: state_type > $o ).

tff(pred_def_4215,type,
    v7983: state_type > $o ).

tff(pred_def_4216,type,
    v7979: state_type > $o ).

tff(pred_def_4217,type,
    v7978: state_type > $o ).

tff(pred_def_4218,type,
    v7989: state_type > $o ).

tff(pred_def_4219,type,
    v7990: state_type > $o ).

tff(pred_def_4220,type,
    v7986: state_type > $o ).

tff(pred_def_4221,type,
    v7988: state_type > $o ).

tff(pred_def_4222,type,
    v7996: state_type > $o ).

tff(pred_def_4223,type,
    v7994: state_type > $o ).

tff(pred_def_4224,type,
    v7998: state_type > $o ).

tff(pred_def_4225,type,
    v7936: state_type > $o ).

tff(pred_def_4226,type,
    v7934: state_type > $o ).

tff(pred_def_4227,type,
    v7932: state_type > $o ).

tff(pred_def_4228,type,
    v8005: state_type > $o ).

tff(pred_def_4229,type,
    v8003: state_type > $o ).

tff(pred_def_4230,type,
    v8002: state_type > $o ).

tff(pred_def_4231,type,
    v8001: state_type > $o ).

tff(pred_def_4232,type,
    v8013: state_type > $o ).

tff(pred_def_4233,type,
    v8014: state_type > $o ).

tff(pred_def_4234,type,
    v8012: state_type > $o ).

tff(pred_def_4235,type,
    v8009: ( state_type * $int ) > $o ).

tff(pred_def_4236,type,
    v8011: ( state_type * $int ) > $o ).

tff(pred_def_4237,type,
    v8000: ( state_type * $int ) > $o ).

tff(pred_def_4238,type,
    v7906: ( state_type * $int ) > $o ).

tff(pred_def_4239,type,
    v7904: ( state_type * $int ) > $o ).

tff(pred_def_4240,type,
    v7902: ( state_type * $int ) > $o ).

tff(pred_def_4241,type,
    v7900: ( state_type * $int ) > $o ).

tff(pred_def_4242,type,
    v7898: ( state_type * $int ) > $o ).

tff(pred_def_4243,type,
    v8036: state_type > $o ).

tff(pred_def_4244,type,
    v8034: state_type > $o ).

tff(pred_def_4245,type,
    v8040: state_type > $o ).

tff(pred_def_4246,type,
    v8038: state_type > $o ).

tff(pred_def_4247,type,
    v8044: state_type > $o ).

tff(pred_def_4248,type,
    v8042: state_type > $o ).

tff(pred_def_4249,type,
    v8047: state_type > $o ).

tff(pred_def_4250,type,
    v8046: state_type > $o ).

tff(pred_def_4251,type,
    v8032: state_type > $o ).

tff(pred_def_4252,type,
    v8030: state_type > $o ).

tff(pred_def_4253,type,
    v8028: state_type > $o ).

tff(pred_def_4254,type,
    v8026: state_type > $o ).

tff(pred_def_4255,type,
    v8024: state_type > $o ).

tff(pred_def_4256,type,
    v8022: state_type > $o ).

tff(pred_def_4257,type,
    v8020: state_type > $o ).

tff(pred_def_4258,type,
    v8018: state_type > $o ).

tff(pred_def_4259,type,
    v8067: state_type > $o ).

tff(pred_def_4260,type,
    v8065: state_type > $o ).

tff(pred_def_4261,type,
    v8063: state_type > $o ).

tff(pred_def_4262,type,
    v8061: state_type > $o ).

tff(pred_def_4263,type,
    v8059: state_type > $o ).

tff(pred_def_4264,type,
    v8077: state_type > $o ).

tff(pred_def_4265,type,
    v8075: state_type > $o ).

tff(pred_def_4266,type,
    v8073: state_type > $o ).

tff(pred_def_4267,type,
    v8071: state_type > $o ).

tff(pred_def_4268,type,
    v8069: state_type > $o ).

tff(pred_def_4269,type,
    v8081: ( state_type * $int ) > $o ).

tff(pred_def_4270,type,
    v8079: ( state_type * $int ) > $o ).

tff(pred_def_4271,type,
    v8091: state_type > $o ).

tff(pred_def_4272,type,
    v8089: state_type > $o ).

tff(pred_def_4273,type,
    v8097: state_type > $o ).

tff(pred_def_4274,type,
    v8095: state_type > $o ).

tff(pred_def_4275,type,
    v8111: state_type > $o ).

tff(pred_def_4276,type,
    v8109: state_type > $o ).

tff(pred_def_4277,type,
    v8115: state_type > $o ).

tff(pred_def_4278,type,
    v8113: state_type > $o ).

tff(pred_def_4279,type,
    v8119: state_type > $o ).

tff(pred_def_4280,type,
    v8117: state_type > $o ).

tff(pred_def_4281,type,
    v8122: state_type > $o ).

tff(pred_def_4282,type,
    v8121: state_type > $o ).

tff(pred_def_4283,type,
    v8107: state_type > $o ).

tff(pred_def_4284,type,
    v8105: state_type > $o ).

tff(pred_def_4285,type,
    v8103: state_type > $o ).

tff(pred_def_4286,type,
    v8101: state_type > $o ).

tff(pred_def_4287,type,
    v8099: state_type > $o ).

tff(pred_def_4288,type,
    v8126: state_type > $o ).

tff(pred_def_4289,type,
    v8124: state_type > $o ).

tff(pred_def_4290,type,
    v8093: state_type > $o ).

tff(pred_def_4291,type,
    v8132: state_type > $o ).

tff(pred_def_4292,type,
    v8134: state_type > $o ).

tff(pred_def_4293,type,
    v8130: state_type > $o ).

tff(pred_def_4294,type,
    v8129: state_type > $o ).

tff(pred_def_4295,type,
    v8140: state_type > $o ).

tff(pred_def_4296,type,
    v8141: state_type > $o ).

tff(pred_def_4297,type,
    v8137: state_type > $o ).

tff(pred_def_4298,type,
    v8139: state_type > $o ).

tff(pred_def_4299,type,
    v8147: state_type > $o ).

tff(pred_def_4300,type,
    v8145: state_type > $o ).

tff(pred_def_4301,type,
    v8149: state_type > $o ).

tff(pred_def_4302,type,
    v8087: state_type > $o ).

tff(pred_def_4303,type,
    v8085: state_type > $o ).

tff(pred_def_4304,type,
    v8083: state_type > $o ).

tff(pred_def_4305,type,
    v8156: state_type > $o ).

tff(pred_def_4306,type,
    v8154: state_type > $o ).

tff(pred_def_4307,type,
    v8153: state_type > $o ).

tff(pred_def_4308,type,
    v8152: state_type > $o ).

tff(pred_def_4309,type,
    v8164: state_type > $o ).

tff(pred_def_4310,type,
    v8165: state_type > $o ).

tff(pred_def_4311,type,
    v8163: state_type > $o ).

tff(pred_def_4312,type,
    v8160: ( state_type * $int ) > $o ).

tff(pred_def_4313,type,
    v8162: ( state_type * $int ) > $o ).

tff(pred_def_4314,type,
    v8151: ( state_type * $int ) > $o ).

tff(pred_def_4315,type,
    v8057: ( state_type * $int ) > $o ).

tff(pred_def_4316,type,
    v8055: ( state_type * $int ) > $o ).

tff(pred_def_4317,type,
    v8053: ( state_type * $int ) > $o ).

tff(pred_def_4318,type,
    v8051: ( state_type * $int ) > $o ).

tff(pred_def_4319,type,
    v8049: ( state_type * $int ) > $o ).

tff(pred_def_4320,type,
    v8187: state_type > $o ).

tff(pred_def_4321,type,
    v8185: state_type > $o ).

tff(pred_def_4322,type,
    v8191: state_type > $o ).

tff(pred_def_4323,type,
    v8189: state_type > $o ).

tff(pred_def_4324,type,
    v8195: state_type > $o ).

tff(pred_def_4325,type,
    v8193: state_type > $o ).

tff(pred_def_4326,type,
    v8198: state_type > $o ).

tff(pred_def_4327,type,
    v8197: state_type > $o ).

tff(pred_def_4328,type,
    v8183: state_type > $o ).

tff(pred_def_4329,type,
    v8181: state_type > $o ).

tff(pred_def_4330,type,
    v8179: state_type > $o ).

tff(pred_def_4331,type,
    v8177: state_type > $o ).

tff(pred_def_4332,type,
    v8175: state_type > $o ).

tff(pred_def_4333,type,
    v8173: state_type > $o ).

tff(pred_def_4334,type,
    v8171: state_type > $o ).

tff(pred_def_4335,type,
    v8169: state_type > $o ).

tff(pred_def_4336,type,
    v8206: state_type > $o ).

tff(pred_def_4337,type,
    v7141: state_type > $o ).

tff(pred_def_4338,type,
    v8205: ( state_type * $int ) > $o ).

tff(pred_def_4339,type,
    v8204: ( state_type * $int ) > $o ).

tff(pred_def_4340,type,
    v8209: state_type > $o ).

tff(pred_def_4341,type,
    v8208: ( state_type * $int ) > $o ).

tff(pred_def_4342,type,
    v8207: ( state_type * $int ) > $o ).

tff(pred_def_4343,type,
    v8203: ( state_type * $int ) > $o ).

tff(pred_def_4344,type,
    v8212: state_type > $o ).

tff(pred_def_4345,type,
    v8211: ( state_type * $int ) > $o ).

tff(pred_def_4346,type,
    v8210: ( state_type * $int ) > $o ).

tff(pred_def_4347,type,
    v8202: ( state_type * $int ) > $o ).

tff(pred_def_4348,type,
    v8215: state_type > $o ).

tff(pred_def_4349,type,
    v8214: ( state_type * $int ) > $o ).

tff(pred_def_4350,type,
    v8213: ( state_type * $int ) > $o ).

tff(pred_def_4351,type,
    v8201: ( state_type * $int ) > $o ).

tff(pred_def_4352,type,
    v8218: state_type > $o ).

tff(pred_def_4353,type,
    v8217: ( state_type * $int ) > $o ).

tff(pred_def_4354,type,
    v8216: ( state_type * $int ) > $o ).

tff(pred_def_4355,type,
    v8200: ( state_type * $int ) > $o ).

tff(pred_def_4356,type,
    v8221: state_type > $o ).

tff(pred_def_4357,type,
    v8220: ( state_type * $int ) > $o ).

tff(pred_def_4358,type,
    v8219: ( state_type * $int ) > $o ).

tff(pred_def_4359,type,
    v8199: ( state_type * $int ) > $o ).

tff(pred_def_4360,type,
    v6246: ( state_type * $int ) > $o ).

tff(pred_def_4361,type,
    v6244: ( state_type * $int ) > $o ).

tff(pred_def_4362,type,
    v8227: state_type > $o ).

tff(pred_def_4363,type,
    v8225: state_type > $o ).

tff(pred_def_4364,type,
    v8224: state_type > $o ).

tff(pred_def_4365,type,
    v8223: ( state_type * $int ) > $o ).

tff(pred_def_4366,type,
    v8235: state_type > $o ).

tff(pred_def_4367,type,
    v8233: state_type > $o ).

tff(pred_def_4368,type,
    v8232: state_type > $o ).

tff(pred_def_4369,type,
    v8231: ( state_type * $int ) > $o ).

tff(pred_def_4370,type,
    v8243: state_type > $o ).

tff(pred_def_4371,type,
    v8241: state_type > $o ).

tff(pred_def_4372,type,
    v8240: state_type > $o ).

tff(pred_def_4373,type,
    v8239: ( state_type * $int ) > $o ).

tff(pred_def_4374,type,
    v8251: state_type > $o ).

tff(pred_def_4375,type,
    v8249: state_type > $o ).

tff(pred_def_4376,type,
    v8248: state_type > $o ).

tff(pred_def_4377,type,
    v8247: ( state_type * $int ) > $o ).

tff(pred_def_4378,type,
    v8259: state_type > $o ).

tff(pred_def_4379,type,
    v8257: state_type > $o ).

tff(pred_def_4380,type,
    v8256: state_type > $o ).

tff(pred_def_4381,type,
    v8255: ( state_type * $int ) > $o ).

tff(pred_def_4382,type,
    v8267: state_type > $o ).

tff(pred_def_4383,type,
    v8265: state_type > $o ).

tff(pred_def_4384,type,
    v8264: state_type > $o ).

tff(pred_def_4385,type,
    v8263: ( state_type * $int ) > $o ).

tff(pred_def_4386,type,
    v8275: state_type > $o ).

tff(pred_def_4387,type,
    v8273: state_type > $o ).

tff(pred_def_4388,type,
    v8272: state_type > $o ).

tff(pred_def_4389,type,
    v8271: ( state_type * $int ) > $o ).

tff(pred_def_4390,type,
    v8283: state_type > $o ).

tff(pred_def_4391,type,
    v8281: state_type > $o ).

tff(pred_def_4392,type,
    v8280: state_type > $o ).

tff(pred_def_4393,type,
    v8279: ( state_type * $int ) > $o ).

tff(pred_def_4394,type,
    v6242: ( state_type * $int ) > $o ).

tff(pred_def_4395,type,
    v7255: ( state_type * $int ) > $o ).

tff(pred_def_4396,type,
    v7253: ( state_type * $int ) > $o ).

tff(pred_def_4397,type,
    v7246: state_type > $o ).

tff(pred_def_4398,type,
    v7244: state_type > $o ).

tff(pred_def_4399,type,
    v7242: state_type > $o ).

tff(pred_def_4400,type,
    v7240: ( state_type * $int ) > $o ).

tff(pred_def_4401,type,
    v7238: ( state_type * $int ) > $o ).

tff(pred_def_4402,type,
    v7236: ( state_type * $int ) > $o ).

tff(pred_def_4403,type,
    v8298: state_type > $o ).

tff(pred_def_4404,type,
    v8296: state_type > $o ).

tff(pred_def_4405,type,
    v8302: state_type > $o ).

tff(pred_def_4406,type,
    v8300: state_type > $o ).

tff(pred_def_4407,type,
    v8322: state_type > $o ).

tff(pred_def_4408,type,
    v8320: state_type > $o ).

tff(pred_def_4409,type,
    v8326: state_type > $o ).

tff(pred_def_4410,type,
    v8324: state_type > $o ).

tff(pred_def_4411,type,
    v8332: state_type > $o ).

tff(pred_def_4412,type,
    v8330: state_type > $o ).

tff(pred_def_4413,type,
    v8328: state_type > $o ).

tff(pred_def_4414,type,
    v8337: state_type > $o ).

tff(pred_def_4415,type,
    v8335: state_type > $o ).

tff(pred_def_4416,type,
    v8344: state_type > $o ).

tff(pred_def_4417,type,
    v8342: state_type > $o ).

tff(pred_def_4418,type,
    v8341: state_type > $o ).

tff(pred_def_4419,type,
    v8340: state_type > $o ).

tff(pred_def_4420,type,
    v8352: state_type > $o ).

tff(pred_def_4421,type,
    v8353: state_type > $o ).

tff(pred_def_4422,type,
    v8351: state_type > $o ).

tff(pred_def_4423,type,
    v8348: state_type > $o ).

tff(pred_def_4424,type,
    x8333: state_type > $o ).

tff(pred_def_4425,type,
    v8350: state_type > $o ).

tff(pred_def_4426,type,
    v8318: state_type > $o ).

tff(pred_def_4427,type,
    v8316: state_type > $o ).

tff(pred_def_4428,type,
    v8314: state_type > $o ).

tff(pred_def_4429,type,
    v8371: state_type > $o ).

tff(pred_def_4430,type,
    v8369: state_type > $o ).

tff(pred_def_4431,type,
    v8367: state_type > $o ).

tff(pred_def_4432,type,
    v8375: state_type > $o ).

tff(pred_def_4433,type,
    v8373: state_type > $o ).

tff(pred_def_4434,type,
    v8385: ( state_type * $int ) > $o ).

tff(pred_def_4435,type,
    v8383: ( state_type * $int ) > $o ).

tff(pred_def_4436,type,
    v8381: ( state_type * $int ) > $o ).

tff(pred_def_4437,type,
    v8389: state_type > $o ).

tff(pred_def_4438,type,
    v8387: state_type > $o ).

tff(pred_def_4439,type,
    v8393: state_type > $o ).

tff(pred_def_4440,type,
    v8392: ( state_type * $int ) > $o ).

tff(pred_def_4441,type,
    v8391: ( state_type * $int ) > $o ).

tff(pred_def_4442,type,
    v8397: state_type > $o ).

tff(pred_def_4443,type,
    v8396: ( state_type * $int ) > $o ).

tff(pred_def_4444,type,
    v8395: ( state_type * $int ) > $o ).

tff(pred_def_4445,type,
    v8363: ( state_type * $int ) > $o ).

tff(pred_def_4446,type,
    v8394: ( state_type * $int ) > $o ).

tff(pred_def_4447,type,
    v8390: ( state_type * $int ) > $o ).

tff(pred_def_4448,type,
    v8379: ( state_type * $int ) > $o ).

tff(pred_def_4449,type,
    v8377: ( state_type * $int ) > $o ).

tff(pred_def_4450,type,
    v8401: state_type > $o ).

tff(pred_def_4451,type,
    v8399: state_type > $o ).

tff(pred_def_4452,type,
    v8408: state_type > $o ).

tff(pred_def_4453,type,
    v8406: state_type > $o ).

tff(pred_def_4454,type,
    v8405: state_type > $o ).

tff(pred_def_4455,type,
    v8404: state_type > $o ).

tff(pred_def_4456,type,
    v8416: state_type > $o ).

tff(pred_def_4457,type,
    v8417: state_type > $o ).

tff(pred_def_4458,type,
    v8415: state_type > $o ).

tff(pred_def_4459,type,
    v8412: ( state_type * $int ) > $o ).

tff(pred_def_4460,type,
    v8414: ( state_type * $int ) > $o ).

tff(pred_def_4461,type,
    v8403: ( state_type * $int ) > $o ).

tff(pred_def_4462,type,
    v8365: ( state_type * $int ) > $o ).

tff(pred_def_4463,type,
    v8361: state_type > $o ).

tff(pred_def_4464,type,
    v8359: state_type > $o ).

tff(pred_def_4465,type,
    v8357: state_type > $o ).

tff(pred_def_4466,type,
    v8312: state_type > $o ).

tff(pred_def_4467,type,
    v8430: state_type > $o ).

tff(pred_def_4468,type,
    v8428: state_type > $o ).

tff(pred_def_4469,type,
    v8434: state_type > $o ).

tff(pred_def_4470,type,
    v8432: state_type > $o ).

tff(pred_def_4471,type,
    v8442: ( state_type * $int ) > $o ).

tff(pred_def_4472,type,
    v8440: ( state_type * $int ) > $o ).

tff(pred_def_4473,type,
    b0100011001000: $int > $o ).

tff(pred_def_4474,type,
    v8449: state_type > $o ).

tff(pred_def_4475,type,
    v8446: state_type > $o ).

tff(pred_def_4476,type,
    v8444: state_type > $o ).

tff(pred_def_4477,type,
    v8453: state_type > $o ).

tff(pred_def_4478,type,
    v8452: ( state_type * $int ) > $o ).

tff(pred_def_4479,type,
    v8451: ( state_type * $int ) > $o ).

tff(pred_def_4480,type,
    v8457: state_type > $o ).

tff(pred_def_4481,type,
    v8456: ( state_type * $int ) > $o ).

tff(pred_def_4482,type,
    v8455: ( state_type * $int ) > $o ).

tff(pred_def_4483,type,
    v8424: ( state_type * $int ) > $o ).

tff(pred_def_4484,type,
    v8454: ( state_type * $int ) > $o ).

tff(pred_def_4485,type,
    v8450: ( state_type * $int ) > $o ).

tff(pred_def_4486,type,
    v8438: ( state_type * $int ) > $o ).

tff(pred_def_4487,type,
    v8436: ( state_type * $int ) > $o ).

tff(pred_def_4488,type,
    v8461: state_type > $o ).

tff(pred_def_4489,type,
    v8459: state_type > $o ).

tff(pred_def_4490,type,
    v8468: state_type > $o ).

tff(pred_def_4491,type,
    v8466: state_type > $o ).

tff(pred_def_4492,type,
    v8465: state_type > $o ).

tff(pred_def_4493,type,
    v8464: state_type > $o ).

tff(pred_def_4494,type,
    v8476: state_type > $o ).

tff(pred_def_4495,type,
    v8477: state_type > $o ).

tff(pred_def_4496,type,
    v8475: state_type > $o ).

tff(pred_def_4497,type,
    v8472: ( state_type * $int ) > $o ).

tff(pred_def_4498,type,
    v8474: ( state_type * $int ) > $o ).

tff(pred_def_4499,type,
    v8463: ( state_type * $int ) > $o ).

tff(pred_def_4500,type,
    v8426: ( state_type * $int ) > $o ).

tff(pred_def_4501,type,
    v8422: ( state_type * $int ) > $o ).

tff(pred_def_4502,type,
    v8489: ( state_type * $int ) > $o ).

tff(pred_def_4503,type,
    v8487: ( state_type * $int ) > $o ).

tff(pred_def_4504,type,
    v4121: ( state_type * $int ) > $o ).

tff(pred_def_4505,type,
    v8493: ( state_type * $int ) > $o ).

tff(pred_def_4506,type,
    v8491: ( state_type * $int ) > $o ).

tff(pred_def_4507,type,
    v8485: state_type > $o ).

tff(pred_def_4508,type,
    v8483: state_type > $o ).

tff(pred_def_4509,type,
    v8481: state_type > $o ).

tff(pred_def_4510,type,
    v8504: ( state_type * $int ) > $o ).

tff(pred_def_4511,type,
    v8502: ( state_type * $int ) > $o ).

tff(pred_def_4512,type,
    v8538: state_type > $o ).

tff(pred_def_4513,type,
    v8536: state_type > $o ).

tff(pred_def_4514,type,
    v8534: state_type > $o ).

tff(pred_def_4515,type,
    v8532: state_type > $o ).

tff(pred_def_4516,type,
    v8530: state_type > $o ).

tff(pred_def_4517,type,
    v8528: state_type > $o ).

tff(pred_def_4518,type,
    v8526: state_type > $o ).

tff(pred_def_4519,type,
    v8552: state_type > $o ).

tff(pred_def_4520,type,
    v8550: state_type > $o ).

tff(pred_def_4521,type,
    v8548: state_type > $o ).

tff(pred_def_4522,type,
    v8546: state_type > $o ).

tff(pred_def_4523,type,
    v8544: state_type > $o ).

tff(pred_def_4524,type,
    v8542: state_type > $o ).

tff(pred_def_4525,type,
    v8540: state_type > $o ).

tff(pred_def_4526,type,
    v8578: state_type > $o ).

tff(pred_def_4527,type,
    v8580: state_type > $o ).

tff(pred_def_4528,type,
    v8579: ( state_type * $int ) > $o ).

tff(pred_def_4529,type,
    v8581: state_type > $o ).

tff(pred_def_4530,type,
    v8576: ( state_type * $int ) > $o ).

tff(pred_def_4531,type,
    v8574: ( state_type * $int ) > $o ).

tff(pred_def_4532,type,
    v8582: ( state_type * $int ) > $o ).

tff(pred_def_4533,type,
    v8572: ( state_type * $int ) > $o ).

tff(pred_def_4534,type,
    v8570: ( state_type * $int ) > $o ).

tff(pred_def_4535,type,
    v8568: state_type > $o ).

tff(pred_def_4536,type,
    v8584: state_type > $o ).

tff(pred_def_4537,type,
    v8566: ( state_type * $int ) > $o ).

tff(pred_def_4538,type,
    v8564: ( state_type * $int ) > $o ).

tff(pred_def_4539,type,
    v8598: ( state_type * $int ) > $o ).

tff(pred_def_4540,type,
    v8596: ( state_type * $int ) > $o ).

tff(pred_def_4541,type,
    v8602: state_type > $o ).

tff(pred_def_4542,type,
    v8600: state_type > $o ).

tff(pred_def_4543,type,
    v8626: state_type > $o ).

tff(pred_def_4544,type,
    v8624: state_type > $o ).

tff(pred_def_4545,type,
    v8622: state_type > $o ).

tff(pred_def_4546,type,
    v8620: state_type > $o ).

tff(pred_def_4547,type,
    v8618: state_type > $o ).

tff(pred_def_4548,type,
    v8616: state_type > $o ).

tff(pred_def_4549,type,
    v8614: state_type > $o ).

tff(pred_def_4550,type,
    v8640: state_type > $o ).

tff(pred_def_4551,type,
    v8638: state_type > $o ).

tff(pred_def_4552,type,
    v8636: state_type > $o ).

tff(pred_def_4553,type,
    v8634: state_type > $o ).

tff(pred_def_4554,type,
    v8632: state_type > $o ).

tff(pred_def_4555,type,
    v8630: state_type > $o ).

tff(pred_def_4556,type,
    v8628: state_type > $o ).

tff(pred_def_4557,type,
    v8656: ( state_type * $int ) > $o ).

tff(pred_def_4558,type,
    v8654: ( state_type * $int ) > $o ).

tff(pred_def_4559,type,
    v8652: ( state_type * $int ) > $o ).

tff(pred_def_4560,type,
    v8650: ( state_type * $int ) > $o ).

tff(pred_def_4561,type,
    v8648: ( state_type * $int ) > $o ).

tff(pred_def_4562,type,
    v8686: ( state_type * $int ) > $o ).

tff(pred_def_4563,type,
    v8688: ( state_type * $int ) > $o ).

tff(pred_def_4564,type,
    v8684: ( state_type * $int ) > $o ).

tff(pred_def_4565,type,
    v8682: ( state_type * $int ) > $o ).

tff(pred_def_4566,type,
    v8680: ( state_type * $int ) > $o ).

tff(pred_def_4567,type,
    v8678: ( state_type * $int ) > $o ).

tff(pred_def_4568,type,
    v8676: state_type > $o ).

tff(pred_def_4569,type,
    v8674: state_type > $o ).

tff(pred_def_4570,type,
    v8692: state_type > $o ).

tff(pred_def_4571,type,
    v8690: state_type > $o ).

tff(pred_def_4572,type,
    v8694: state_type > $o ).

tff(pred_def_4573,type,
    v8672: state_type > $o ).

tff(pred_def_4574,type,
    v8670: state_type > $o ).

tff(pred_def_4575,type,
    v8668: state_type > $o ).

tff(pred_def_4576,type,
    v8666: state_type > $o ).

tff(pred_def_4577,type,
    v8664: state_type > $o ).

tff(pred_def_4578,type,
    v8662: state_type > $o ).

tff(pred_def_4579,type,
    v8660: state_type > $o ).

tff(pred_def_4580,type,
    v8658: state_type > $o ).

tff(pred_def_4581,type,
    v8704: ( state_type * $int ) > $o ).

tff(pred_def_4582,type,
    v8702: ( state_type * $int ) > $o ).

tff(pred_def_4583,type,
    v8700: ( state_type * $int ) > $o ).

tff(pred_def_4584,type,
    v8698: ( state_type * $int ) > $o ).

tff(pred_def_4585,type,
    v8696: ( state_type * $int ) > $o ).

tff(pred_def_4586,type,
    v8734: ( state_type * $int ) > $o ).

tff(pred_def_4587,type,
    v8732: ( state_type * $int ) > $o ).

tff(pred_def_4588,type,
    v8735: ( state_type * $int ) > $o ).

tff(pred_def_4589,type,
    v8730: ( state_type * $int ) > $o ).

tff(pred_def_4590,type,
    v8728: ( state_type * $int ) > $o ).

tff(pred_def_4591,type,
    v8726: ( state_type * $int ) > $o ).

tff(pred_def_4592,type,
    v8724: state_type > $o ).

tff(pred_def_4593,type,
    v8722: state_type > $o ).

tff(pred_def_4594,type,
    v8739: state_type > $o ).

tff(pred_def_4595,type,
    v8737: state_type > $o ).

tff(pred_def_4596,type,
    v8741: state_type > $o ).

tff(pred_def_4597,type,
    v8720: state_type > $o ).

tff(pred_def_4598,type,
    v8718: state_type > $o ).

tff(pred_def_4599,type,
    v8716: state_type > $o ).

tff(pred_def_4600,type,
    v8714: state_type > $o ).

tff(pred_def_4601,type,
    v8712: state_type > $o ).

tff(pred_def_4602,type,
    v8710: state_type > $o ).

tff(pred_def_4603,type,
    v8708: state_type > $o ).

tff(pred_def_4604,type,
    v8706: state_type > $o ).

tff(pred_def_4605,type,
    v8751: ( state_type * $int ) > $o ).

tff(pred_def_4606,type,
    v8749: ( state_type * $int ) > $o ).

tff(pred_def_4607,type,
    v8747: ( state_type * $int ) > $o ).

tff(pred_def_4608,type,
    v8745: ( state_type * $int ) > $o ).

tff(pred_def_4609,type,
    v8743: ( state_type * $int ) > $o ).

tff(pred_def_4610,type,
    v8771: state_type > $o ).

tff(pred_def_4611,type,
    v8769: state_type > $o ).

tff(pred_def_4612,type,
    v8775: state_type > $o ).

tff(pred_def_4613,type,
    v8773: state_type > $o ).

tff(pred_def_4614,type,
    v8777: state_type > $o ).

tff(pred_def_4615,type,
    v8767: state_type > $o ).

tff(pred_def_4616,type,
    v8765: state_type > $o ).

tff(pred_def_4617,type,
    v8763: state_type > $o ).

tff(pred_def_4618,type,
    v8761: state_type > $o ).

tff(pred_def_4619,type,
    v8759: state_type > $o ).

tff(pred_def_4620,type,
    v8757: state_type > $o ).

tff(pred_def_4621,type,
    v8755: state_type > $o ).

tff(pred_def_4622,type,
    v8753: state_type > $o ).

tff(pred_def_4623,type,
    v8787: ( state_type * $int ) > $o ).

tff(pred_def_4624,type,
    v8785: ( state_type * $int ) > $o ).

tff(pred_def_4625,type,
    v8783: ( state_type * $int ) > $o ).

tff(pred_def_4626,type,
    v8781: ( state_type * $int ) > $o ).

tff(pred_def_4627,type,
    v8779: ( state_type * $int ) > $o ).

tff(pred_def_4628,type,
    v8807: state_type > $o ).

tff(pred_def_4629,type,
    v8805: state_type > $o ).

tff(pred_def_4630,type,
    v8811: state_type > $o ).

tff(pred_def_4631,type,
    v8809: state_type > $o ).

tff(pred_def_4632,type,
    v8813: state_type > $o ).

tff(pred_def_4633,type,
    v8803: state_type > $o ).

tff(pred_def_4634,type,
    v8801: state_type > $o ).

tff(pred_def_4635,type,
    v8799: state_type > $o ).

tff(pred_def_4636,type,
    v8797: state_type > $o ).

tff(pred_def_4637,type,
    v8795: state_type > $o ).

tff(pred_def_4638,type,
    v8793: state_type > $o ).

tff(pred_def_4639,type,
    v8791: state_type > $o ).

tff(pred_def_4640,type,
    v8789: state_type > $o ).

tff(pred_def_4641,type,
    v8819: state_type > $o ).

tff(pred_def_4642,type,
    v8818: ( state_type * $int ) > $o ).

tff(pred_def_4643,type,
    v8817: ( state_type * $int ) > $o ).

tff(pred_def_4644,type,
    v8822: state_type > $o ).

tff(pred_def_4645,type,
    v8821: ( state_type * $int ) > $o ).

tff(pred_def_4646,type,
    v8820: ( state_type * $int ) > $o ).

tff(pred_def_4647,type,
    v8816: ( state_type * $int ) > $o ).

tff(pred_def_4648,type,
    v8825: state_type > $o ).

tff(pred_def_4649,type,
    v8824: ( state_type * $int ) > $o ).

tff(pred_def_4650,type,
    v8823: ( state_type * $int ) > $o ).

tff(pred_def_4651,type,
    v8815: ( state_type * $int ) > $o ).

tff(pred_def_4652,type,
    v8828: state_type > $o ).

tff(pred_def_4653,type,
    v8827: ( state_type * $int ) > $o ).

tff(pred_def_4654,type,
    v8826: ( state_type * $int ) > $o ).

tff(pred_def_4655,type,
    v8646: ( state_type * $int ) > $o ).

tff(pred_def_4656,type,
    v8644: ( state_type * $int ) > $o ).

tff(pred_def_4657,type,
    v8642: ( state_type * $int ) > $o ).

tff(pred_def_4658,type,
    v8840: state_type > $o ).

tff(pred_def_4659,type,
    v8838: state_type > $o ).

tff(pred_def_4660,type,
    v8836: state_type > $o ).

tff(pred_def_4661,type,
    v8850: state_type > $o ).

tff(pred_def_4662,type,
    v8848: state_type > $o ).

tff(pred_def_4663,type,
    v8846: state_type > $o ).

tff(pred_def_4664,type,
    v8844: state_type > $o ).

tff(pred_def_4665,type,
    v8842: state_type > $o ).

tff(pred_def_4666,type,
    v8852: state_type > $o ).

tff(pred_def_4667,type,
    v8834: state_type > $o ).

tff(pred_def_4668,type,
    v8832: state_type > $o ).

tff(pred_def_4669,type,
    v8830: state_type > $o ).

tff(pred_def_4670,type,
    v8859: state_type > $o ).

tff(pred_def_4671,type,
    v8857: state_type > $o ).

tff(pred_def_4672,type,
    v8856: state_type > $o ).

tff(pred_def_4673,type,
    v8855: state_type > $o ).

tff(pred_def_4674,type,
    v8867: state_type > $o ).

tff(pred_def_4675,type,
    v8868: state_type > $o ).

tff(pred_def_4676,type,
    v8866: state_type > $o ).

tff(pred_def_4677,type,
    v8863: ( state_type * $int ) > $o ).

tff(pred_def_4678,type,
    v8865: ( state_type * $int ) > $o ).

tff(pred_def_4679,type,
    v8612: ( state_type * $int ) > $o ).

tff(pred_def_4680,type,
    v8610: ( state_type * $int ) > $o ).

tff(pred_def_4681,type,
    v8608: ( state_type * $int ) > $o ).

tff(pred_def_4682,type,
    v8606: ( state_type * $int ) > $o ).

tff(pred_def_4683,type,
    v8604: ( state_type * $int ) > $o ).

tff(pred_def_4684,type,
    v8874: state_type > $o ).

tff(pred_def_4685,type,
    v8872: state_type > $o ).

tff(pred_def_4686,type,
    v8878: state_type > $o ).

tff(pred_def_4687,type,
    v8877: ( state_type * $int ) > $o ).

tff(pred_def_4688,type,
    v8876: ( state_type * $int ) > $o ).

tff(pred_def_4689,type,
    v8881: state_type > $o ).

tff(pred_def_4690,type,
    v8880: ( state_type * $int ) > $o ).

tff(pred_def_4691,type,
    v8879: ( state_type * $int ) > $o ).

tff(pred_def_4692,type,
    v8594: ( state_type * $int ) > $o ).

tff(pred_def_4693,type,
    v8592: ( state_type * $int ) > $o ).

tff(pred_def_4694,type,
    v8590: ( state_type * $int ) > $o ).

tff(pred_def_4695,type,
    v8588: ( state_type * $int ) > $o ).

tff(pred_def_4696,type,
    v8586: ( state_type * $int ) > $o ).

tff(pred_def_4697,type,
    v8562: ( state_type * $int ) > $o ).

tff(pred_def_4698,type,
    v8560: ( state_type * $int ) > $o ).

tff(pred_def_4699,type,
    v8558: ( state_type * $int ) > $o ).

tff(pred_def_4700,type,
    v8556: ( state_type * $int ) > $o ).

tff(pred_def_4701,type,
    v8554: ( state_type * $int ) > $o ).

tff(pred_def_4702,type,
    v8894: state_type > $o ).

tff(pred_def_4703,type,
    v8892: state_type > $o ).

tff(pred_def_4704,type,
    v8890: state_type > $o ).

tff(pred_def_4705,type,
    v8900: state_type > $o ).

tff(pred_def_4706,type,
    v8898: state_type > $o ).

tff(pred_def_4707,type,
    v8918: ( state_type * $int ) > $o ).

tff(pred_def_4708,type,
    v8920: ( state_type * $int ) > $o ).

tff(pred_def_4709,type,
    v8916: ( state_type * $int ) > $o ).

tff(pred_def_4710,type,
    v8914: state_type > $o ).

tff(pred_def_4711,type,
    v8912: state_type > $o ).

tff(pred_def_4712,type,
    v8924: state_type > $o ).

tff(pred_def_4713,type,
    v8922: state_type > $o ).

tff(pred_def_4714,type,
    v8928: state_type > $o ).

tff(pred_def_4715,type,
    v8926: state_type > $o ).

tff(pred_def_4716,type,
    v8931: state_type > $o ).

tff(pred_def_4717,type,
    v8930: state_type > $o ).

tff(pred_def_4718,type,
    v8910: state_type > $o ).

tff(pred_def_4719,type,
    v8908: state_type > $o ).

tff(pred_def_4720,type,
    v8906: state_type > $o ).

tff(pred_def_4721,type,
    v8904: state_type > $o ).

tff(pred_def_4722,type,
    v8902: state_type > $o ).

tff(pred_def_4723,type,
    v8939: state_type > $o ).

tff(pred_def_4724,type,
    v8937: state_type > $o ).

tff(pred_def_4725,type,
    v8935: state_type > $o ).

tff(pred_def_4726,type,
    v8933: state_type > $o ).

tff(pred_def_4727,type,
    v8896: state_type > $o ).

tff(pred_def_4728,type,
    v8945: state_type > $o ).

tff(pred_def_4729,type,
    v8947: state_type > $o ).

tff(pred_def_4730,type,
    v8943: state_type > $o ).

tff(pred_def_4731,type,
    v8942: state_type > $o ).

tff(pred_def_4732,type,
    v8953: state_type > $o ).

tff(pred_def_4733,type,
    v8954: state_type > $o ).

tff(pred_def_4734,type,
    v8950: state_type > $o ).

tff(pred_def_4735,type,
    v8952: state_type > $o ).

tff(pred_def_4736,type,
    v8964: state_type > $o ).

tff(pred_def_4737,type,
    v8962: state_type > $o ).

tff(pred_def_4738,type,
    v8960: state_type > $o ).

tff(pred_def_4739,type,
    v8958: state_type > $o ).

tff(pred_def_4740,type,
    v8966: state_type > $o ).

tff(pred_def_4741,type,
    v8888: state_type > $o ).

tff(pred_def_4742,type,
    v8886: state_type > $o ).

tff(pred_def_4743,type,
    v8884: state_type > $o ).

tff(pred_def_4744,type,
    v8973: state_type > $o ).

tff(pred_def_4745,type,
    v8971: state_type > $o ).

tff(pred_def_4746,type,
    v8970: state_type > $o ).

tff(pred_def_4747,type,
    v8969: state_type > $o ).

tff(pred_def_4748,type,
    v8981: state_type > $o ).

tff(pred_def_4749,type,
    v8982: state_type > $o ).

tff(pred_def_4750,type,
    v8980: state_type > $o ).

tff(pred_def_4751,type,
    v8977: ( state_type * $int ) > $o ).

tff(pred_def_4752,type,
    v8979: ( state_type * $int ) > $o ).

tff(pred_def_4753,type,
    v8524: ( state_type * $int ) > $o ).

tff(pred_def_4754,type,
    v8522: ( state_type * $int ) > $o ).

tff(pred_def_4755,type,
    v8520: ( state_type * $int ) > $o ).

tff(pred_def_4756,type,
    v8518: ( state_type * $int ) > $o ).

tff(pred_def_4757,type,
    v8516: ( state_type * $int ) > $o ).

tff(pred_def_4758,type,
    v9018: state_type > $o ).

tff(pred_def_4759,type,
    v9016: state_type > $o ).

tff(pred_def_4760,type,
    v9014: state_type > $o ).

tff(pred_def_4761,type,
    v9012: state_type > $o ).

tff(pred_def_4762,type,
    v9010: state_type > $o ).

tff(pred_def_4763,type,
    v9008: state_type > $o ).

tff(pred_def_4764,type,
    v9028: state_type > $o ).

tff(pred_def_4765,type,
    v9026: state_type > $o ).

tff(pred_def_4766,type,
    v9024: state_type > $o ).

tff(pred_def_4767,type,
    v9022: state_type > $o ).

tff(pred_def_4768,type,
    v9020: state_type > $o ).

tff(pred_def_4769,type,
    v9055: state_type > $o ).

tff(pred_def_4770,type,
    v9054: ( state_type * $int ) > $o ).

tff(pred_def_4771,type,
    v9053: ( state_type * $int ) > $o ).

tff(pred_def_4772,type,
    v9051: ( state_type * $int ) > $o ).

tff(pred_def_4773,type,
    v9093: ( state_type * $int ) > $o ).

tff(pred_def_4774,type,
    v9091: ( state_type * $int ) > $o ).

tff(pred_def_4775,type,
    v9129: state_type > $o ).

tff(pred_def_4776,type,
    v9127: state_type > $o ).

tff(pred_def_4777,type,
    v9125: state_type > $o ).

tff(pred_def_4778,type,
    v9123: state_type > $o ).

tff(pred_def_4779,type,
    v9121: state_type > $o ).

tff(pred_def_4780,type,
    v9119: state_type > $o ).

tff(pred_def_4781,type,
    v9117: state_type > $o ).

tff(pred_def_4782,type,
    v9115: state_type > $o ).

tff(pred_def_4783,type,
    v9145: state_type > $o ).

tff(pred_def_4784,type,
    v9143: state_type > $o ).

tff(pred_def_4785,type,
    v9141: state_type > $o ).

tff(pred_def_4786,type,
    v9139: state_type > $o ).

tff(pred_def_4787,type,
    v9137: state_type > $o ).

tff(pred_def_4788,type,
    v9135: state_type > $o ).

tff(pred_def_4789,type,
    v9133: state_type > $o ).

tff(pred_def_4790,type,
    v9131: state_type > $o ).

tff(pred_def_4791,type,
    v9181: state_type > $o ).

tff(pred_def_4792,type,
    v9182: state_type > $o ).

tff(pred_def_4793,type,
    v9180: state_type > $o ).

tff(pred_def_4794,type,
    v9183: state_type > $o ).

tff(pred_def_4795,type,
    v9179: state_type > $o ).

tff(pred_def_4796,type,
    v9184: state_type > $o ).

tff(pred_def_4797,type,
    v9177: state_type > $o ).

tff(pred_def_4798,type,
    v9175: state_type > $o ).

tff(pred_def_4799,type,
    v9173: state_type > $o ).

tff(pred_def_4800,type,
    v9171: state_type > $o ).

tff(pred_def_4801,type,
    v9186: state_type > $o ).

tff(pred_def_4802,type,
    v9185: ( state_type * $int ) > $o ).

tff(pred_def_4803,type,
    v9187: state_type > $o ).

tff(pred_def_4804,type,
    v9169: ( state_type * $int ) > $o ).

tff(pred_def_4805,type,
    v9167: ( state_type * $int ) > $o ).

tff(pred_def_4806,type,
    v9188: ( state_type * $int ) > $o ).

tff(pred_def_4807,type,
    v9165: ( state_type * $int ) > $o ).

tff(pred_def_4808,type,
    v9163: ( state_type * $int ) > $o ).

tff(pred_def_4809,type,
    v9161: state_type > $o ).

tff(pred_def_4810,type,
    v9190: state_type > $o ).

tff(pred_def_4811,type,
    v9159: ( state_type * $int ) > $o ).

tff(pred_def_4812,type,
    v9157: ( state_type * $int ) > $o ).

tff(pred_def_4813,type,
    v9234: state_type > $o ).

tff(pred_def_4814,type,
    v9232: state_type > $o ).

tff(pred_def_4815,type,
    v9230: state_type > $o ).

tff(pred_def_4816,type,
    v9228: state_type > $o ).

tff(pred_def_4817,type,
    v9226: state_type > $o ).

tff(pred_def_4818,type,
    v9224: state_type > $o ).

tff(pred_def_4819,type,
    v9222: state_type > $o ).

tff(pred_def_4820,type,
    v9220: state_type > $o ).

tff(pred_def_4821,type,
    v9250: state_type > $o ).

tff(pred_def_4822,type,
    v9248: state_type > $o ).

tff(pred_def_4823,type,
    v9246: state_type > $o ).

tff(pred_def_4824,type,
    v9244: state_type > $o ).

tff(pred_def_4825,type,
    v9242: state_type > $o ).

tff(pred_def_4826,type,
    v9240: state_type > $o ).

tff(pred_def_4827,type,
    v9238: state_type > $o ).

tff(pred_def_4828,type,
    v9236: state_type > $o ).

tff(pred_def_4829,type,
    v9266: ( state_type * $int ) > $o ).

tff(pred_def_4830,type,
    v9264: ( state_type * $int ) > $o ).

tff(pred_def_4831,type,
    v9262: ( state_type * $int ) > $o ).

tff(pred_def_4832,type,
    v9260: ( state_type * $int ) > $o ).

tff(pred_def_4833,type,
    v9258: ( state_type * $int ) > $o ).

tff(pred_def_4834,type,
    v9296: ( state_type * $int ) > $o ).

tff(pred_def_4835,type,
    v9298: ( state_type * $int ) > $o ).

tff(pred_def_4836,type,
    v9294: ( state_type * $int ) > $o ).

tff(pred_def_4837,type,
    v9292: ( state_type * $int ) > $o ).

tff(pred_def_4838,type,
    v9290: ( state_type * $int ) > $o ).

tff(pred_def_4839,type,
    v9288: ( state_type * $int ) > $o ).

tff(pred_def_4840,type,
    v9286: state_type > $o ).

tff(pred_def_4841,type,
    v9284: state_type > $o ).

tff(pred_def_4842,type,
    v9302: state_type > $o ).

tff(pred_def_4843,type,
    v9300: state_type > $o ).

tff(pred_def_4844,type,
    v9304: state_type > $o ).

tff(pred_def_4845,type,
    v9282: state_type > $o ).

tff(pred_def_4846,type,
    v9280: state_type > $o ).

tff(pred_def_4847,type,
    v9278: state_type > $o ).

tff(pred_def_4848,type,
    v9276: state_type > $o ).

tff(pred_def_4849,type,
    v9274: state_type > $o ).

tff(pred_def_4850,type,
    v9272: state_type > $o ).

tff(pred_def_4851,type,
    v9270: state_type > $o ).

tff(pred_def_4852,type,
    v9268: state_type > $o ).

tff(pred_def_4853,type,
    v9314: ( state_type * $int ) > $o ).

tff(pred_def_4854,type,
    v9312: ( state_type * $int ) > $o ).

tff(pred_def_4855,type,
    v9310: ( state_type * $int ) > $o ).

tff(pred_def_4856,type,
    v9308: ( state_type * $int ) > $o ).

tff(pred_def_4857,type,
    v9306: ( state_type * $int ) > $o ).

tff(pred_def_4858,type,
    v9344: ( state_type * $int ) > $o ).

tff(pred_def_4859,type,
    v9342: ( state_type * $int ) > $o ).

tff(pred_def_4860,type,
    v9345: ( state_type * $int ) > $o ).

tff(pred_def_4861,type,
    v9340: ( state_type * $int ) > $o ).

tff(pred_def_4862,type,
    v9338: ( state_type * $int ) > $o ).

tff(pred_def_4863,type,
    v9336: ( state_type * $int ) > $o ).

tff(pred_def_4864,type,
    v9334: state_type > $o ).

tff(pred_def_4865,type,
    v9332: state_type > $o ).

tff(pred_def_4866,type,
    v9349: state_type > $o ).

tff(pred_def_4867,type,
    v9347: state_type > $o ).

tff(pred_def_4868,type,
    v9351: state_type > $o ).

tff(pred_def_4869,type,
    v9330: state_type > $o ).

tff(pred_def_4870,type,
    v9328: state_type > $o ).

tff(pred_def_4871,type,
    v9326: state_type > $o ).

tff(pred_def_4872,type,
    v9324: state_type > $o ).

tff(pred_def_4873,type,
    v9322: state_type > $o ).

tff(pred_def_4874,type,
    v9320: state_type > $o ).

tff(pred_def_4875,type,
    v9318: state_type > $o ).

tff(pred_def_4876,type,
    v9316: state_type > $o ).

tff(pred_def_4877,type,
    v9361: ( state_type * $int ) > $o ).

tff(pred_def_4878,type,
    v9359: ( state_type * $int ) > $o ).

tff(pred_def_4879,type,
    v9357: ( state_type * $int ) > $o ).

tff(pred_def_4880,type,
    v9355: ( state_type * $int ) > $o ).

tff(pred_def_4881,type,
    v9353: ( state_type * $int ) > $o ).

tff(pred_def_4882,type,
    v9381: state_type > $o ).

tff(pred_def_4883,type,
    v9379: state_type > $o ).

tff(pred_def_4884,type,
    v9385: state_type > $o ).

tff(pred_def_4885,type,
    v9383: state_type > $o ).

tff(pred_def_4886,type,
    v9387: state_type > $o ).

tff(pred_def_4887,type,
    v9377: state_type > $o ).

tff(pred_def_4888,type,
    v9375: state_type > $o ).

tff(pred_def_4889,type,
    v9373: state_type > $o ).

tff(pred_def_4890,type,
    v9371: state_type > $o ).

tff(pred_def_4891,type,
    v9369: state_type > $o ).

tff(pred_def_4892,type,
    v9367: state_type > $o ).

tff(pred_def_4893,type,
    v9365: state_type > $o ).

tff(pred_def_4894,type,
    v9363: state_type > $o ).

tff(pred_def_4895,type,
    v9397: ( state_type * $int ) > $o ).

tff(pred_def_4896,type,
    v9395: ( state_type * $int ) > $o ).

tff(pred_def_4897,type,
    v9393: ( state_type * $int ) > $o ).

tff(pred_def_4898,type,
    v9391: ( state_type * $int ) > $o ).

tff(pred_def_4899,type,
    v9389: ( state_type * $int ) > $o ).

tff(pred_def_4900,type,
    v9417: state_type > $o ).

tff(pred_def_4901,type,
    v9415: state_type > $o ).

tff(pred_def_4902,type,
    v9421: state_type > $o ).

tff(pred_def_4903,type,
    v9419: state_type > $o ).

tff(pred_def_4904,type,
    v9423: state_type > $o ).

tff(pred_def_4905,type,
    v9413: state_type > $o ).

tff(pred_def_4906,type,
    v9411: state_type > $o ).

tff(pred_def_4907,type,
    v9409: state_type > $o ).

tff(pred_def_4908,type,
    v9407: state_type > $o ).

tff(pred_def_4909,type,
    v9405: state_type > $o ).

tff(pred_def_4910,type,
    v9403: state_type > $o ).

tff(pred_def_4911,type,
    v9401: state_type > $o ).

tff(pred_def_4912,type,
    v9399: state_type > $o ).

tff(pred_def_4913,type,
    v9429: state_type > $o ).

tff(pred_def_4914,type,
    v9428: ( state_type * $int ) > $o ).

tff(pred_def_4915,type,
    v9427: ( state_type * $int ) > $o ).

tff(pred_def_4916,type,
    v9432: state_type > $o ).

tff(pred_def_4917,type,
    v9431: ( state_type * $int ) > $o ).

tff(pred_def_4918,type,
    v9430: ( state_type * $int ) > $o ).

tff(pred_def_4919,type,
    v9426: ( state_type * $int ) > $o ).

tff(pred_def_4920,type,
    v9435: state_type > $o ).

tff(pred_def_4921,type,
    v9434: ( state_type * $int ) > $o ).

tff(pred_def_4922,type,
    v9433: ( state_type * $int ) > $o ).

tff(pred_def_4923,type,
    v9425: ( state_type * $int ) > $o ).

tff(pred_def_4924,type,
    v9438: state_type > $o ).

tff(pred_def_4925,type,
    v9437: ( state_type * $int ) > $o ).

tff(pred_def_4926,type,
    v9436: ( state_type * $int ) > $o ).

tff(pred_def_4927,type,
    v9256: ( state_type * $int ) > $o ).

tff(pred_def_4928,type,
    v9254: ( state_type * $int ) > $o ).

tff(pred_def_4929,type,
    v9252: ( state_type * $int ) > $o ).

tff(pred_def_4930,type,
    v9452: state_type > $o ).

tff(pred_def_4931,type,
    v9450: state_type > $o ).

tff(pred_def_4932,type,
    v9448: state_type > $o ).

tff(pred_def_4933,type,
    v9446: state_type > $o ).

tff(pred_def_4934,type,
    v9464: state_type > $o ).

tff(pred_def_4935,type,
    v9462: state_type > $o ).

tff(pred_def_4936,type,
    v9460: state_type > $o ).

tff(pred_def_4937,type,
    v9458: state_type > $o ).

tff(pred_def_4938,type,
    v9456: state_type > $o ).

tff(pred_def_4939,type,
    v9454: state_type > $o ).

tff(pred_def_4940,type,
    v9466: state_type > $o ).

tff(pred_def_4941,type,
    v9444: state_type > $o ).

tff(pred_def_4942,type,
    v9442: state_type > $o ).

tff(pred_def_4943,type,
    v9440: state_type > $o ).

tff(pred_def_4944,type,
    v9473: state_type > $o ).

tff(pred_def_4945,type,
    v9471: state_type > $o ).

tff(pred_def_4946,type,
    v9470: state_type > $o ).

tff(pred_def_4947,type,
    v9469: state_type > $o ).

tff(pred_def_4948,type,
    v9481: state_type > $o ).

tff(pred_def_4949,type,
    v9482: state_type > $o ).

tff(pred_def_4950,type,
    v9480: state_type > $o ).

tff(pred_def_4951,type,
    v9477: ( state_type * $int ) > $o ).

tff(pred_def_4952,type,
    v9479: ( state_type * $int ) > $o ).

tff(pred_def_4953,type,
    v9218: ( state_type * $int ) > $o ).

tff(pred_def_4954,type,
    v9216: ( state_type * $int ) > $o ).

tff(pred_def_4955,type,
    v9214: ( state_type * $int ) > $o ).

tff(pred_def_4956,type,
    v9212: ( state_type * $int ) > $o ).

tff(pred_def_4957,type,
    v9210: ( state_type * $int ) > $o ).

tff(pred_def_4958,type,
    v9208: ( state_type * $int ) > $o ).

tff(pred_def_4959,type,
    v9206: ( state_type * $int ) > $o ).

tff(pred_def_4960,type,
    v9204: ( state_type * $int ) > $o ).

tff(pred_def_4961,type,
    v9502: state_type > $o ).

tff(pred_def_4962,type,
    v9500: state_type > $o ).

tff(pred_def_4963,type,
    v9499: state_type > $o ).

tff(pred_def_4964,type,
    v9498: ( state_type * $int ) > $o ).

tff(pred_def_4965,type,
    v9510: state_type > $o ).

tff(pred_def_4966,type,
    v9508: state_type > $o ).

tff(pred_def_4967,type,
    v9507: state_type > $o ).

tff(pred_def_4968,type,
    v9506: ( state_type * $int ) > $o ).

tff(pred_def_4969,type,
    v9520: state_type > $o ).

tff(pred_def_4970,type,
    v9519: state_type > $o ).

tff(pred_def_4971,type,
    v9518: state_type > $o ).

tff(pred_def_4972,type,
    v9517: state_type > $o ).

tff(pred_def_4973,type,
    v9516: state_type > $o ).

tff(pred_def_4974,type,
    v9514: state_type > $o ).

tff(pred_def_4975,type,
    v9523: state_type > $o ).

tff(pred_def_4976,type,
    v9521: state_type > $o ).

tff(pred_def_4977,type,
    v9529: state_type > $o ).

tff(pred_def_4978,type,
    v9530: state_type > $o ).

tff(pred_def_4979,type,
    v9528: state_type > $o ).

tff(pred_def_4980,type,
    v9527: state_type > $o ).

tff(pred_def_4981,type,
    v9526: state_type > $o ).

tff(pred_def_4982,type,
    v9524: state_type > $o ).

tff(pred_def_4983,type,
    v9535: state_type > $o ).

tff(pred_def_4984,type,
    v9534: state_type > $o ).

tff(pred_def_4985,type,
    v9533: state_type > $o ).

tff(pred_def_4986,type,
    v9531: state_type > $o ).

tff(pred_def_4987,type,
    v9540: state_type > $o ).

tff(pred_def_4988,type,
    v9539: state_type > $o ).

tff(pred_def_4989,type,
    v9538: state_type > $o ).

tff(pred_def_4990,type,
    v9536: state_type > $o ).

tff(pred_def_4991,type,
    v9541: state_type > $o ).

tff(pred_def_4992,type,
    v9542: state_type > $o ).

tff(pred_def_4993,type,
    v9547: state_type > $o ).

tff(pred_def_4994,type,
    v9546: state_type > $o ).

tff(pred_def_4995,type,
    v9545: state_type > $o ).

tff(pred_def_4996,type,
    v9543: state_type > $o ).

tff(pred_def_4997,type,
    v9552: state_type > $o ).

tff(pred_def_4998,type,
    v9551: state_type > $o ).

tff(pred_def_4999,type,
    v9550: state_type > $o ).

tff(pred_def_5000,type,
    v9548: state_type > $o ).

tff(pred_def_5001,type,
    v9556: state_type > $o ).

tff(pred_def_5002,type,
    v9555: state_type > $o ).

tff(pred_def_5003,type,
    v9553: state_type > $o ).

tff(pred_def_5004,type,
    v9560: state_type > $o ).

tff(pred_def_5005,type,
    v9559: state_type > $o ).

tff(pred_def_5006,type,
    v9557: state_type > $o ).

tff(pred_def_5007,type,
    v9564: state_type > $o ).

tff(pred_def_5008,type,
    v9563: state_type > $o ).

tff(pred_def_5009,type,
    v9561: state_type > $o ).

tff(pred_def_5010,type,
    v9568: state_type > $o ).

tff(pred_def_5011,type,
    v9567: state_type > $o ).

tff(pred_def_5012,type,
    v9565: state_type > $o ).

tff(pred_def_5013,type,
    v9569: state_type > $o ).

tff(pred_def_5014,type,
    v9513: ( state_type * $int ) > $o ).

tff(pred_def_5015,type,
    v9496: ( state_type * $int ) > $o ).

tff(pred_def_5016,type,
    v9570: ( state_type * $int ) > $o ).

tff(pred_def_5017,type,
    v9494: ( state_type * $int ) > $o ).

tff(pred_def_5018,type,
    v9492: ( state_type * $int ) > $o ).

tff(pred_def_5019,type,
    v9490: ( state_type * $int ) > $o ).

tff(pred_def_5020,type,
    v9488: state_type > $o ).

tff(pred_def_5021,type,
    v9486: state_type > $o ).

tff(pred_def_5022,type,
    v9594: state_type > $o ).

tff(pred_def_5023,type,
    v9592: state_type > $o ).

tff(pred_def_5024,type,
    v9590: state_type > $o ).

tff(pred_def_5025,type,
    v9588: state_type > $o ).

tff(pred_def_5026,type,
    v9586: state_type > $o ).

tff(pred_def_5027,type,
    v9584: state_type > $o ).

tff(pred_def_5028,type,
    v9582: state_type > $o ).

tff(pred_def_5029,type,
    v9608: state_type > $o ).

tff(pred_def_5030,type,
    v9606: state_type > $o ).

tff(pred_def_5031,type,
    v9604: state_type > $o ).

tff(pred_def_5032,type,
    v9602: state_type > $o ).

tff(pred_def_5033,type,
    v9600: state_type > $o ).

tff(pred_def_5034,type,
    v9598: state_type > $o ).

tff(pred_def_5035,type,
    v9596: state_type > $o ).

tff(pred_def_5036,type,
    v9624: ( state_type * $int ) > $o ).

tff(pred_def_5037,type,
    v9622: ( state_type * $int ) > $o ).

tff(pred_def_5038,type,
    v9620: ( state_type * $int ) > $o ).

tff(pred_def_5039,type,
    v9618: ( state_type * $int ) > $o ).

tff(pred_def_5040,type,
    v9616: ( state_type * $int ) > $o ).

tff(pred_def_5041,type,
    v9654: ( state_type * $int ) > $o ).

tff(pred_def_5042,type,
    v9656: ( state_type * $int ) > $o ).

tff(pred_def_5043,type,
    v9652: ( state_type * $int ) > $o ).

tff(pred_def_5044,type,
    v9650: ( state_type * $int ) > $o ).

tff(pred_def_5045,type,
    v9648: ( state_type * $int ) > $o ).

tff(pred_def_5046,type,
    v9646: ( state_type * $int ) > $o ).

tff(pred_def_5047,type,
    v9644: state_type > $o ).

tff(pred_def_5048,type,
    v9642: state_type > $o ).

tff(pred_def_5049,type,
    v9660: state_type > $o ).

tff(pred_def_5050,type,
    v9658: state_type > $o ).

tff(pred_def_5051,type,
    v9662: state_type > $o ).

tff(pred_def_5052,type,
    v9640: state_type > $o ).

tff(pred_def_5053,type,
    v9638: state_type > $o ).

tff(pred_def_5054,type,
    v9636: state_type > $o ).

tff(pred_def_5055,type,
    v9634: state_type > $o ).

tff(pred_def_5056,type,
    v9632: state_type > $o ).

tff(pred_def_5057,type,
    v9630: state_type > $o ).

tff(pred_def_5058,type,
    v9628: state_type > $o ).

tff(pred_def_5059,type,
    v9626: state_type > $o ).

tff(pred_def_5060,type,
    v9672: ( state_type * $int ) > $o ).

tff(pred_def_5061,type,
    v9670: ( state_type * $int ) > $o ).

tff(pred_def_5062,type,
    v9668: ( state_type * $int ) > $o ).

tff(pred_def_5063,type,
    v9666: ( state_type * $int ) > $o ).

tff(pred_def_5064,type,
    v9664: ( state_type * $int ) > $o ).

tff(pred_def_5065,type,
    v9702: ( state_type * $int ) > $o ).

tff(pred_def_5066,type,
    v9700: ( state_type * $int ) > $o ).

tff(pred_def_5067,type,
    v9703: ( state_type * $int ) > $o ).

tff(pred_def_5068,type,
    v9698: ( state_type * $int ) > $o ).

tff(pred_def_5069,type,
    v9696: ( state_type * $int ) > $o ).

tff(pred_def_5070,type,
    v9694: ( state_type * $int ) > $o ).

tff(pred_def_5071,type,
    v9692: state_type > $o ).

tff(pred_def_5072,type,
    v9690: state_type > $o ).

tff(pred_def_5073,type,
    v9707: state_type > $o ).

tff(pred_def_5074,type,
    v9705: state_type > $o ).

tff(pred_def_5075,type,
    v9709: state_type > $o ).

tff(pred_def_5076,type,
    v9688: state_type > $o ).

tff(pred_def_5077,type,
    v9686: state_type > $o ).

tff(pred_def_5078,type,
    v9684: state_type > $o ).

tff(pred_def_5079,type,
    v9682: state_type > $o ).

tff(pred_def_5080,type,
    v9680: state_type > $o ).

tff(pred_def_5081,type,
    v9678: state_type > $o ).

tff(pred_def_5082,type,
    v9676: state_type > $o ).

tff(pred_def_5083,type,
    v9674: state_type > $o ).

tff(pred_def_5084,type,
    v9719: ( state_type * $int ) > $o ).

tff(pred_def_5085,type,
    v9717: ( state_type * $int ) > $o ).

tff(pred_def_5086,type,
    v9715: ( state_type * $int ) > $o ).

tff(pred_def_5087,type,
    v9713: ( state_type * $int ) > $o ).

tff(pred_def_5088,type,
    v9711: ( state_type * $int ) > $o ).

tff(pred_def_5089,type,
    v9739: state_type > $o ).

tff(pred_def_5090,type,
    v9737: state_type > $o ).

tff(pred_def_5091,type,
    v9743: state_type > $o ).

tff(pred_def_5092,type,
    v9741: state_type > $o ).

tff(pred_def_5093,type,
    v9745: state_type > $o ).

tff(pred_def_5094,type,
    v9735: state_type > $o ).

tff(pred_def_5095,type,
    v9733: state_type > $o ).

tff(pred_def_5096,type,
    v9731: state_type > $o ).

tff(pred_def_5097,type,
    v9729: state_type > $o ).

tff(pred_def_5098,type,
    v9727: state_type > $o ).

tff(pred_def_5099,type,
    v9725: state_type > $o ).

tff(pred_def_5100,type,
    v9723: state_type > $o ).

tff(pred_def_5101,type,
    v9721: state_type > $o ).

tff(pred_def_5102,type,
    v9755: ( state_type * $int ) > $o ).

tff(pred_def_5103,type,
    v9753: ( state_type * $int ) > $o ).

tff(pred_def_5104,type,
    v9751: ( state_type * $int ) > $o ).

tff(pred_def_5105,type,
    v9749: ( state_type * $int ) > $o ).

tff(pred_def_5106,type,
    v9747: ( state_type * $int ) > $o ).

tff(pred_def_5107,type,
    v9775: state_type > $o ).

tff(pred_def_5108,type,
    v9773: state_type > $o ).

tff(pred_def_5109,type,
    v9779: state_type > $o ).

tff(pred_def_5110,type,
    v9777: state_type > $o ).

tff(pred_def_5111,type,
    v9781: state_type > $o ).

tff(pred_def_5112,type,
    v9771: state_type > $o ).

tff(pred_def_5113,type,
    v9769: state_type > $o ).

tff(pred_def_5114,type,
    v9767: state_type > $o ).

tff(pred_def_5115,type,
    v9765: state_type > $o ).

tff(pred_def_5116,type,
    v9763: state_type > $o ).

tff(pred_def_5117,type,
    v9761: state_type > $o ).

tff(pred_def_5118,type,
    v9759: state_type > $o ).

tff(pred_def_5119,type,
    v9757: state_type > $o ).

tff(pred_def_5120,type,
    v9787: state_type > $o ).

tff(pred_def_5121,type,
    v9786: ( state_type * $int ) > $o ).

tff(pred_def_5122,type,
    v9785: ( state_type * $int ) > $o ).

tff(pred_def_5123,type,
    v9790: state_type > $o ).

tff(pred_def_5124,type,
    v9789: ( state_type * $int ) > $o ).

tff(pred_def_5125,type,
    v9788: ( state_type * $int ) > $o ).

tff(pred_def_5126,type,
    v9784: ( state_type * $int ) > $o ).

tff(pred_def_5127,type,
    v9793: state_type > $o ).

tff(pred_def_5128,type,
    v9792: ( state_type * $int ) > $o ).

tff(pred_def_5129,type,
    v9791: ( state_type * $int ) > $o ).

tff(pred_def_5130,type,
    v9783: ( state_type * $int ) > $o ).

tff(pred_def_5131,type,
    v9796: state_type > $o ).

tff(pred_def_5132,type,
    v9795: ( state_type * $int ) > $o ).

tff(pred_def_5133,type,
    v9794: ( state_type * $int ) > $o ).

tff(pred_def_5134,type,
    v9614: ( state_type * $int ) > $o ).

tff(pred_def_5135,type,
    v9612: ( state_type * $int ) > $o ).

tff(pred_def_5136,type,
    v9610: ( state_type * $int ) > $o ).

tff(pred_def_5137,type,
    v9808: state_type > $o ).

tff(pred_def_5138,type,
    v9806: state_type > $o ).

tff(pred_def_5139,type,
    v9804: state_type > $o ).

tff(pred_def_5140,type,
    v9818: state_type > $o ).

tff(pred_def_5141,type,
    v9816: state_type > $o ).

tff(pred_def_5142,type,
    v9814: state_type > $o ).

tff(pred_def_5143,type,
    v9812: state_type > $o ).

tff(pred_def_5144,type,
    v9810: state_type > $o ).

tff(pred_def_5145,type,
    v9820: state_type > $o ).

tff(pred_def_5146,type,
    v9802: state_type > $o ).

tff(pred_def_5147,type,
    v9800: state_type > $o ).

tff(pred_def_5148,type,
    v9798: state_type > $o ).

tff(pred_def_5149,type,
    v9827: state_type > $o ).

tff(pred_def_5150,type,
    v9825: state_type > $o ).

tff(pred_def_5151,type,
    v9824: state_type > $o ).

tff(pred_def_5152,type,
    v9823: state_type > $o ).

tff(pred_def_5153,type,
    v9835: state_type > $o ).

tff(pred_def_5154,type,
    v9836: state_type > $o ).

tff(pred_def_5155,type,
    v9834: state_type > $o ).

tff(pred_def_5156,type,
    v9831: ( state_type * $int ) > $o ).

tff(pred_def_5157,type,
    v9833: ( state_type * $int ) > $o ).

tff(pred_def_5158,type,
    v9580: ( state_type * $int ) > $o ).

tff(pred_def_5159,type,
    v9578: ( state_type * $int ) > $o ).

tff(pred_def_5160,type,
    v9576: ( state_type * $int ) > $o ).

tff(pred_def_5161,type,
    v9574: ( state_type * $int ) > $o ).

tff(pred_def_5162,type,
    v9572: ( state_type * $int ) > $o ).

tff(pred_def_5163,type,
    v9846: ( state_type * $int ) > $o ).

tff(pred_def_5164,type,
    v9844: ( state_type * $int ) > $o ).

tff(pred_def_5165,type,
    v9842: state_type > $o ).

tff(pred_def_5166,type,
    v9840: state_type > $o ).

tff(pred_def_5167,type,
    v9850: state_type > $o ).

tff(pred_def_5168,type,
    v9849: ( state_type * $int ) > $o ).

tff(pred_def_5169,type,
    v9848: ( state_type * $int ) > $o ).

tff(pred_def_5170,type,
    v9853: state_type > $o ).

tff(pred_def_5171,type,
    v9852: ( state_type * $int ) > $o ).

tff(pred_def_5172,type,
    v9851: ( state_type * $int ) > $o ).

tff(pred_def_5173,type,
    v9202: ( state_type * $int ) > $o ).

tff(pred_def_5174,type,
    v9200: ( state_type * $int ) > $o ).

tff(pred_def_5175,type,
    v9198: ( state_type * $int ) > $o ).

tff(pred_def_5176,type,
    v9196: ( state_type * $int ) > $o ).

tff(pred_def_5177,type,
    v9194: ( state_type * $int ) > $o ).

tff(pred_def_5178,type,
    v9192: ( state_type * $int ) > $o ).

tff(pred_def_5179,type,
    v9155: ( state_type * $int ) > $o ).

tff(pred_def_5180,type,
    v9153: ( state_type * $int ) > $o ).

tff(pred_def_5181,type,
    v9151: ( state_type * $int ) > $o ).

tff(pred_def_5182,type,
    v9149: ( state_type * $int ) > $o ).

tff(pred_def_5183,type,
    v9147: ( state_type * $int ) > $o ).

tff(pred_def_5184,type,
    v9868: state_type > $o ).

tff(pred_def_5185,type,
    v9866: state_type > $o ).

tff(pred_def_5186,type,
    v9864: state_type > $o ).

tff(pred_def_5187,type,
    v9862: state_type > $o ).

tff(pred_def_5188,type,
    v9874: state_type > $o ).

tff(pred_def_5189,type,
    v9872: state_type > $o ).

tff(pred_def_5190,type,
    v9892: ( state_type * $int ) > $o ).

tff(pred_def_5191,type,
    v9894: ( state_type * $int ) > $o ).

tff(pred_def_5192,type,
    v9890: ( state_type * $int ) > $o ).

tff(pred_def_5193,type,
    v9888: state_type > $o ).

tff(pred_def_5194,type,
    v9886: state_type > $o ).

tff(pred_def_5195,type,
    v9898: state_type > $o ).

tff(pred_def_5196,type,
    v9896: state_type > $o ).

tff(pred_def_5197,type,
    v9902: state_type > $o ).

tff(pred_def_5198,type,
    v9900: state_type > $o ).

tff(pred_def_5199,type,
    v9905: state_type > $o ).

tff(pred_def_5200,type,
    v9904: state_type > $o ).

tff(pred_def_5201,type,
    v9884: state_type > $o ).

tff(pred_def_5202,type,
    v9882: state_type > $o ).

tff(pred_def_5203,type,
    v9880: state_type > $o ).

tff(pred_def_5204,type,
    v9878: state_type > $o ).

tff(pred_def_5205,type,
    v9876: state_type > $o ).

tff(pred_def_5206,type,
    v9915: state_type > $o ).

tff(pred_def_5207,type,
    v9913: state_type > $o ).

tff(pred_def_5208,type,
    v9911: state_type > $o ).

tff(pred_def_5209,type,
    v9909: state_type > $o ).

tff(pred_def_5210,type,
    v9907: state_type > $o ).

tff(pred_def_5211,type,
    v9870: state_type > $o ).

tff(pred_def_5212,type,
    v9921: state_type > $o ).

tff(pred_def_5213,type,
    v9923: state_type > $o ).

tff(pred_def_5214,type,
    v9919: state_type > $o ).

tff(pred_def_5215,type,
    v9918: state_type > $o ).

tff(pred_def_5216,type,
    v9929: state_type > $o ).

tff(pred_def_5217,type,
    v9930: state_type > $o ).

tff(pred_def_5218,type,
    v9926: state_type > $o ).

tff(pred_def_5219,type,
    v9928: state_type > $o ).

tff(pred_def_5220,type,
    v9942: state_type > $o ).

tff(pred_def_5221,type,
    v9940: state_type > $o ).

tff(pred_def_5222,type,
    v9938: state_type > $o ).

tff(pred_def_5223,type,
    v9936: state_type > $o ).

tff(pred_def_5224,type,
    v9934: state_type > $o ).

tff(pred_def_5225,type,
    v9944: state_type > $o ).

tff(pred_def_5226,type,
    v9860: state_type > $o ).

tff(pred_def_5227,type,
    v9858: state_type > $o ).

tff(pred_def_5228,type,
    v9856: state_type > $o ).

tff(pred_def_5229,type,
    v9951: state_type > $o ).

tff(pred_def_5230,type,
    v9949: state_type > $o ).

tff(pred_def_5231,type,
    v9948: state_type > $o ).

tff(pred_def_5232,type,
    v9947: state_type > $o ).

tff(pred_def_5233,type,
    v9959: state_type > $o ).

tff(pred_def_5234,type,
    v9960: state_type > $o ).

tff(pred_def_5235,type,
    v9958: state_type > $o ).

tff(pred_def_5236,type,
    v9955: ( state_type * $int ) > $o ).

tff(pred_def_5237,type,
    v9957: ( state_type * $int ) > $o ).

tff(pred_def_5238,type,
    v9113: ( state_type * $int ) > $o ).

tff(pred_def_5239,type,
    v9111: ( state_type * $int ) > $o ).

tff(pred_def_5240,type,
    v9109: ( state_type * $int ) > $o ).

tff(pred_def_5241,type,
    v9107: ( state_type * $int ) > $o ).

tff(pred_def_5242,type,
    v9105: ( state_type * $int ) > $o ).

tff(pred_def_5243,type,
    v9998: state_type > $o ).

tff(pred_def_5244,type,
    v9996: state_type > $o ).

tff(pred_def_5245,type,
    v9994: state_type > $o ).

tff(pred_def_5246,type,
    v9992: state_type > $o ).

tff(pred_def_5247,type,
    v9990: state_type > $o ).

tff(pred_def_5248,type,
    v9988: state_type > $o ).

tff(pred_def_5249,type,
    v9986: state_type > $o ).

tff(pred_def_5250,type,
    v10008: state_type > $o ).

tff(pred_def_5251,type,
    v10006: state_type > $o ).

tff(pred_def_5252,type,
    v10004: state_type > $o ).

tff(pred_def_5253,type,
    v10002: state_type > $o ).

tff(pred_def_5254,type,
    v10000: state_type > $o ).

tff(pred_def_5255,type,
    v10035: state_type > $o ).

tff(pred_def_5256,type,
    v10034: ( state_type * $int ) > $o ).

tff(pred_def_5257,type,
    v10033: ( state_type * $int ) > $o ).

tff(pred_def_5258,type,
    v10031: ( state_type * $int ) > $o ).

tff(pred_def_5259,type,
    v10059: state_type > $o ).

tff(pred_def_5260,type,
    v10063: ( state_type * $int ) > $o ).

tff(pred_def_5261,type,
    v9079: ( state_type * $int ) > $o ).

tff(pred_def_5262,type,
    v8288: state_type > $o ).

tff(pred_def_5263,type,
    v9073: state_type > $o ).

tff(pred_def_5264,type,
    v10066: state_type > $o ).

tff(pred_def_5265,type,
    v10065: state_type > $o ).

tff(pred_def_5266,type,
    v10064: ( state_type * $int ) > $o ).

tff(pred_def_5267,type,
    v10062: ( state_type * $int ) > $o ).

tff(pred_def_5268,type,
    b00000000000000: $int > $o ).

tff(pred_def_5269,type,
    v10061: ( state_type * $int ) > $o ).

tff(pred_def_5270,type,
    v10057: ( state_type * $int ) > $o ).

tff(pred_def_5271,type,
    v10055: ( state_type * $int ) > $o ).

tff(pred_def_5272,type,
    v10053: ( state_type * $int ) > $o ).

tff(pred_def_5273,type,
    v10051: state_type > $o ).

tff(pred_def_5274,type,
    v10067: ( state_type * $int ) > $o ).

tff(pred_def_5275,type,
    v10068: state_type > $o ).

tff(pred_def_5276,type,
    v10049: ( state_type * $int ) > $o ).

tff(pred_def_5277,type,
    v10047: ( state_type * $int ) > $o ).

tff(pred_def_5278,type,
    v10092: ( state_type * $int ) > $o ).

tff(pred_def_5279,type,
    v9984: ( state_type * $int ) > $o ).

tff(pred_def_5280,type,
    v10090: ( state_type * $int ) > $o ).

tff(pred_def_5281,type,
    v10093: ( state_type * $int ) > $o ).

tff(pred_def_5282,type,
    v10088: ( state_type * $int ) > $o ).

tff(pred_def_5283,type,
    v10086: ( state_type * $int ) > $o ).

tff(pred_def_5284,type,
    v10084: ( state_type * $int ) > $o ).

tff(pred_def_5285,type,
    v10082: state_type > $o ).

tff(pred_def_5286,type,
    v10080: state_type > $o ).

tff(pred_def_5287,type,
    v10099: state_type > $o ).

tff(pred_def_5288,type,
    v10024: state_type > $o ).

tff(pred_def_5289,type,
    v10098: ( state_type * $int ) > $o ).

tff(pred_def_5290,type,
    v10022: ( state_type * $int ) > $o ).

tff(pred_def_5291,type,
    v10020: ( state_type * $int ) > $o ).

tff(pred_def_5292,type,
    v10114: ( state_type * $int ) > $o ).

tff(pred_def_5293,type,
    v10113: ( state_type * $int ) > $o ).

tff(pred_def_5294,type,
    v10111: ( state_type * $int ) > $o ).

tff(pred_def_5295,type,
    v10118: state_type > $o ).

tff(pred_def_5296,type,
    v10116: state_type > $o ).

tff(pred_def_5297,type,
    v10129: ( state_type * $int ) > $o ).

tff(pred_def_5298,type,
    v10128: state_type > $o ).

tff(pred_def_5299,type,
    v10132: state_type > $o ).

tff(pred_def_5300,type,
    v10133: state_type > $o ).

tff(pred_def_5301,type,
    v10131: state_type > $o ).

tff(pred_def_5302,type,
    v10134: state_type > $o ).

tff(pred_def_5303,type,
    v10130: state_type > $o ).

tff(pred_def_5304,type,
    v10127: state_type > $o ).

tff(pred_def_5305,type,
    v10135: state_type > $o ).

tff(pred_def_5306,type,
    v10126: state_type > $o ).

tff(pred_def_5307,type,
    v10138: state_type > $o ).

tff(pred_def_5308,type,
    v10139: state_type > $o ).

tff(pred_def_5309,type,
    v10137: state_type > $o ).

tff(pred_def_5310,type,
    v10140: state_type > $o ).

tff(pred_def_5311,type,
    v10136: state_type > $o ).

tff(pred_def_5312,type,
    v10125: state_type > $o ).

tff(pred_def_5313,type,
    v10141: state_type > $o ).

tff(pred_def_5314,type,
    v10124: state_type > $o ).

tff(pred_def_5315,type,
    v10123: state_type > $o ).

tff(pred_def_5316,type,
    v10145: state_type > $o ).

tff(pred_def_5317,type,
    v10146: state_type > $o ).

tff(pred_def_5318,type,
    v10144: state_type > $o ).

tff(pred_def_5319,type,
    v10147: state_type > $o ).

tff(pred_def_5320,type,
    v10143: state_type > $o ).

tff(pred_def_5321,type,
    v10142: state_type > $o ).

tff(pred_def_5322,type,
    v10122: state_type > $o ).

tff(pred_def_5323,type,
    v10148: state_type > $o ).

tff(pred_def_5324,type,
    v10121: state_type > $o ).

tff(pred_def_5325,type,
    v10151: state_type > $o ).

tff(pred_def_5326,type,
    v10152: state_type > $o ).

tff(pred_def_5327,type,
    v10150: state_type > $o ).

tff(pred_def_5328,type,
    v10153: state_type > $o ).

tff(pred_def_5329,type,
    v10149: state_type > $o ).

tff(pred_def_5330,type,
    v10156: state_type > $o ).

tff(pred_def_5331,type,
    v10157: state_type > $o ).

tff(pred_def_5332,type,
    v10155: state_type > $o ).

tff(pred_def_5333,type,
    v10158: state_type > $o ).

tff(pred_def_5334,type,
    v10154: state_type > $o ).

tff(pred_def_5335,type,
    v10161: state_type > $o ).

tff(pred_def_5336,type,
    v10162: state_type > $o ).

tff(pred_def_5337,type,
    v10160: state_type > $o ).

tff(pred_def_5338,type,
    v10163: state_type > $o ).

tff(pred_def_5339,type,
    v10159: state_type > $o ).

tff(pred_def_5340,type,
    v10119: ( state_type * $int ) > $o ).

tff(pred_def_5341,type,
    v10109: ( state_type * $int ) > $o ).

tff(pred_def_5342,type,
    v10107: ( state_type * $int ) > $o ).

tff(pred_def_5343,type,
    v10105: ( state_type * $int ) > $o ).

tff(pred_def_5344,type,
    v10103: ( state_type * $int ) > $o ).

tff(pred_def_5345,type,
    v10101: ( state_type * $int ) > $o ).

tff(pred_def_5346,type,
    v10164: ( state_type * $int ) > $o ).

tff(pred_def_5347,type,
    v10018: ( state_type * $int ) > $o ).

tff(pred_def_5348,type,
    v10016: ( state_type * $int ) > $o ).

tff(pred_def_5349,type,
    v10014: ( state_type * $int ) > $o ).

tff(pred_def_5350,type,
    v10165: ( state_type * $int ) > $o ).

tff(pred_def_5351,type,
    v10166: ( state_type * $int ) > $o ).

tff(pred_def_5352,type,
    v10012: ( state_type * $int ) > $o ).

tff(pred_def_5353,type,
    v10010: ( state_type * $int ) > $o ).

tff(pred_def_5354,type,
    v10176: state_type > $o ).

tff(pred_def_5355,type,
    v10174: state_type > $o ).

tff(pred_def_5356,type,
    v10182: state_type > $o ).

tff(pred_def_5357,type,
    v10180: state_type > $o ).

tff(pred_def_5358,type,
    v10186: state_type > $o ).

tff(pred_def_5359,type,
    v10184: state_type > $o ).

tff(pred_def_5360,type,
    v10190: state_type > $o ).

tff(pred_def_5361,type,
    v10188: state_type > $o ).

tff(pred_def_5362,type,
    v10178: state_type > $o ).

tff(pred_def_5363,type,
    v10196: state_type > $o ).

tff(pred_def_5364,type,
    v10198: state_type > $o ).

tff(pred_def_5365,type,
    v10194: state_type > $o ).

tff(pred_def_5366,type,
    v10193: state_type > $o ).

tff(pred_def_5367,type,
    v10204: state_type > $o ).

tff(pred_def_5368,type,
    v10205: state_type > $o ).

tff(pred_def_5369,type,
    v10201: state_type > $o ).

tff(pred_def_5370,type,
    v10203: state_type > $o ).

tff(pred_def_5371,type,
    v10211: state_type > $o ).

tff(pred_def_5372,type,
    v10209: state_type > $o ).

tff(pred_def_5373,type,
    v10213: state_type > $o ).

tff(pred_def_5374,type,
    v10172: state_type > $o ).

tff(pred_def_5375,type,
    v10170: state_type > $o ).

tff(pred_def_5376,type,
    v10168: state_type > $o ).

tff(pred_def_5377,type,
    v10220: state_type > $o ).

tff(pred_def_5378,type,
    v10218: state_type > $o ).

tff(pred_def_5379,type,
    v10217: state_type > $o ).

tff(pred_def_5380,type,
    v10216: state_type > $o ).

tff(pred_def_5381,type,
    v10228: state_type > $o ).

tff(pred_def_5382,type,
    v10229: state_type > $o ).

tff(pred_def_5383,type,
    v10227: state_type > $o ).

tff(pred_def_5384,type,
    v10224: ( state_type * $int ) > $o ).

tff(pred_def_5385,type,
    v10226: ( state_type * $int ) > $o ).

tff(pred_def_5386,type,
    v10215: ( state_type * $int ) > $o ).

tff(pred_def_5387,type,
    v10097: state_type > $o ).

tff(pred_def_5388,type,
    v10095: state_type > $o ).

tff(pred_def_5389,type,
    v10241: state_type > $o ).

tff(pred_def_5390,type,
    v10239: state_type > $o ).

tff(pred_def_5391,type,
    v10238: state_type > $o ).

tff(pred_def_5392,type,
    v10237: ( state_type * $int ) > $o ).

tff(pred_def_5393,type,
    v10235: state_type > $o ).

tff(pred_def_5394,type,
    v10233: state_type > $o ).

tff(pred_def_5395,type,
    v10246: state_type > $o ).

tff(pred_def_5396,type,
    v10245: state_type > $o ).

tff(pred_def_5397,type,
    v10078: state_type > $o ).

tff(pred_def_5398,type,
    v10076: state_type > $o ).

tff(pred_def_5399,type,
    v10074: state_type > $o ).

tff(pred_def_5400,type,
    v10247: ( state_type * $int ) > $o ).

tff(pred_def_5401,type,
    v10248: state_type > $o ).

tff(pred_def_5402,type,
    v10072: ( state_type * $int ) > $o ).

tff(pred_def_5403,type,
    v10070: ( state_type * $int ) > $o ).

tff(pred_def_5404,type,
    v10249: ( state_type * $int ) > $o ).

tff(pred_def_5405,type,
    v10045: ( state_type * $int ) > $o ).

tff(pred_def_5406,type,
    v10043: ( state_type * $int ) > $o ).

tff(pred_def_5407,type,
    v10041: state_type > $o ).

tff(pred_def_5408,type,
    v10250: ( state_type * $int ) > $o ).

tff(pred_def_5409,type,
    v10251: state_type > $o ).

tff(pred_def_5410,type,
    v10039: ( state_type * $int ) > $o ).

tff(pred_def_5411,type,
    v10037: ( state_type * $int ) > $o ).

tff(pred_def_5412,type,
    v10252: ( state_type * $int ) > $o ).

tff(pred_def_5413,type,
    v10029: ( state_type * $int ) > $o ).

tff(pred_def_5414,type,
    v10027: ( state_type * $int ) > $o ).

tff(pred_def_5415,type,
    v10258: state_type > $o ).

tff(pred_def_5416,type,
    v10256: state_type > $o ).

tff(pred_def_5417,type,
    v10255: state_type > $o ).

tff(pred_def_5418,type,
    v10254: ( state_type * $int ) > $o ).

tff(pred_def_5419,type,
    v9982: state_type > $o ).

tff(pred_def_5420,type,
    v9980: state_type > $o ).

tff(pred_def_5421,type,
    v10264: state_type > $o ).

tff(pred_def_5422,type,
    v10262: state_type > $o ).

tff(pred_def_5423,type,
    v10268: state_type > $o ).

tff(pred_def_5424,type,
    v10266: state_type > $o ).

tff(pred_def_5425,type,
    v10271: state_type > $o ).

tff(pred_def_5426,type,
    v10270: state_type > $o ).

tff(pred_def_5427,type,
    v9978: state_type > $o ).

tff(pred_def_5428,type,
    v9976: state_type > $o ).

tff(pred_def_5429,type,
    v9974: state_type > $o ).

tff(pred_def_5430,type,
    v9972: state_type > $o ).

tff(pred_def_5431,type,
    v9970: state_type > $o ).

tff(pred_def_5432,type,
    v9968: state_type > $o ).

tff(pred_def_5433,type,
    v9966: state_type > $o ).

tff(pred_def_5434,type,
    v9964: state_type > $o ).

tff(pred_def_5435,type,
    v10291: state_type > $o ).

tff(pred_def_5436,type,
    v10289: state_type > $o ).

tff(pred_def_5437,type,
    v10287: state_type > $o ).

tff(pred_def_5438,type,
    v10285: state_type > $o ).

tff(pred_def_5439,type,
    v10283: state_type > $o ).

tff(pred_def_5440,type,
    v10301: state_type > $o ).

tff(pred_def_5441,type,
    v10299: state_type > $o ).

tff(pred_def_5442,type,
    v10297: state_type > $o ).

tff(pred_def_5443,type,
    v10295: state_type > $o ).

tff(pred_def_5444,type,
    v10293: state_type > $o ).

tff(pred_def_5445,type,
    v10305: ( state_type * $int ) > $o ).

tff(pred_def_5446,type,
    v10303: ( state_type * $int ) > $o ).

tff(pred_def_5447,type,
    v10315: state_type > $o ).

tff(pred_def_5448,type,
    v10313: state_type > $o ).

tff(pred_def_5449,type,
    v10321: state_type > $o ).

tff(pred_def_5450,type,
    v10319: state_type > $o ).

tff(pred_def_5451,type,
    v10345: ( state_type * $int ) > $o ).

tff(pred_def_5452,type,
    v10343: ( state_type * $int ) > $o ).

tff(pred_def_5453,type,
    v10346: ( state_type * $int ) > $o ).

tff(pred_def_5454,type,
    v10341: ( state_type * $int ) > $o ).

tff(pred_def_5455,type,
    v10339: ( state_type * $int ) > $o ).

tff(pred_def_5456,type,
    v10337: ( state_type * $int ) > $o ).

tff(pred_def_5457,type,
    v10335: state_type > $o ).

tff(pred_def_5458,type,
    v10333: state_type > $o ).

tff(pred_def_5459,type,
    v10350: state_type > $o ).

tff(pred_def_5460,type,
    v10348: state_type > $o ).

tff(pred_def_5461,type,
    v10354: state_type > $o ).

tff(pred_def_5462,type,
    v10352: state_type > $o ).

tff(pred_def_5463,type,
    v10357: state_type > $o ).

tff(pred_def_5464,type,
    v10356: state_type > $o ).

tff(pred_def_5465,type,
    v10331: state_type > $o ).

tff(pred_def_5466,type,
    v10329: state_type > $o ).

tff(pred_def_5467,type,
    v10327: state_type > $o ).

tff(pred_def_5468,type,
    v10325: state_type > $o ).

tff(pred_def_5469,type,
    v10323: state_type > $o ).

tff(pred_def_5470,type,
    v10361: state_type > $o ).

tff(pred_def_5471,type,
    v10359: state_type > $o ).

tff(pred_def_5472,type,
    v10317: state_type > $o ).

tff(pred_def_5473,type,
    v10367: state_type > $o ).

tff(pred_def_5474,type,
    v10369: state_type > $o ).

tff(pred_def_5475,type,
    v10365: state_type > $o ).

tff(pred_def_5476,type,
    v10364: state_type > $o ).

tff(pred_def_5477,type,
    v10375: state_type > $o ).

tff(pred_def_5478,type,
    v10376: state_type > $o ).

tff(pred_def_5479,type,
    v10372: state_type > $o ).

tff(pred_def_5480,type,
    v10374: state_type > $o ).

tff(pred_def_5481,type,
    v10382: state_type > $o ).

tff(pred_def_5482,type,
    v10380: state_type > $o ).

tff(pred_def_5483,type,
    v10384: state_type > $o ).

tff(pred_def_5484,type,
    v10311: state_type > $o ).

tff(pred_def_5485,type,
    v10309: state_type > $o ).

tff(pred_def_5486,type,
    v10307: state_type > $o ).

tff(pred_def_5487,type,
    v10391: state_type > $o ).

tff(pred_def_5488,type,
    v10389: state_type > $o ).

tff(pred_def_5489,type,
    v10388: state_type > $o ).

tff(pred_def_5490,type,
    v10387: state_type > $o ).

tff(pred_def_5491,type,
    v10399: state_type > $o ).

tff(pred_def_5492,type,
    v10400: state_type > $o ).

tff(pred_def_5493,type,
    v10398: state_type > $o ).

tff(pred_def_5494,type,
    v10395: ( state_type * $int ) > $o ).

tff(pred_def_5495,type,
    v10397: ( state_type * $int ) > $o ).

tff(pred_def_5496,type,
    v10281: ( state_type * $int ) > $o ).

tff(pred_def_5497,type,
    v10279: ( state_type * $int ) > $o ).

tff(pred_def_5498,type,
    v10277: ( state_type * $int ) > $o ).

tff(pred_def_5499,type,
    v10275: ( state_type * $int ) > $o ).

tff(pred_def_5500,type,
    v10273: ( state_type * $int ) > $o ).

tff(pred_def_5501,type,
    v10422: state_type > $o ).

tff(pred_def_5502,type,
    v10420: state_type > $o ).

tff(pred_def_5503,type,
    v10426: state_type > $o ).

tff(pred_def_5504,type,
    v10424: state_type > $o ).

tff(pred_def_5505,type,
    v10430: state_type > $o ).

tff(pred_def_5506,type,
    v10428: state_type > $o ).

tff(pred_def_5507,type,
    v10433: state_type > $o ).

tff(pred_def_5508,type,
    v10432: state_type > $o ).

tff(pred_def_5509,type,
    v10418: state_type > $o ).

tff(pred_def_5510,type,
    v10416: state_type > $o ).

tff(pred_def_5511,type,
    v10414: state_type > $o ).

tff(pred_def_5512,type,
    v10412: state_type > $o ).

tff(pred_def_5513,type,
    v10410: state_type > $o ).

tff(pred_def_5514,type,
    v10408: state_type > $o ).

tff(pred_def_5515,type,
    v10406: state_type > $o ).

tff(pred_def_5516,type,
    v10404: state_type > $o ).

tff(pred_def_5517,type,
    v10453: state_type > $o ).

tff(pred_def_5518,type,
    v10451: state_type > $o ).

tff(pred_def_5519,type,
    v10449: state_type > $o ).

tff(pred_def_5520,type,
    v10447: state_type > $o ).

tff(pred_def_5521,type,
    v10445: state_type > $o ).

tff(pred_def_5522,type,
    v10463: state_type > $o ).

tff(pred_def_5523,type,
    v10461: state_type > $o ).

tff(pred_def_5524,type,
    v10459: state_type > $o ).

tff(pred_def_5525,type,
    v10457: state_type > $o ).

tff(pred_def_5526,type,
    v10455: state_type > $o ).

tff(pred_def_5527,type,
    v10467: ( state_type * $int ) > $o ).

tff(pred_def_5528,type,
    v10465: ( state_type * $int ) > $o ).

tff(pred_def_5529,type,
    v10477: state_type > $o ).

tff(pred_def_5530,type,
    v10475: state_type > $o ).

tff(pred_def_5531,type,
    v10483: state_type > $o ).

tff(pred_def_5532,type,
    v10481: state_type > $o ).

tff(pred_def_5533,type,
    v10497: state_type > $o ).

tff(pred_def_5534,type,
    v10495: state_type > $o ).

tff(pred_def_5535,type,
    v10501: state_type > $o ).

tff(pred_def_5536,type,
    v10499: state_type > $o ).

tff(pred_def_5537,type,
    v10505: state_type > $o ).

tff(pred_def_5538,type,
    v10503: state_type > $o ).

tff(pred_def_5539,type,
    v10508: state_type > $o ).

tff(pred_def_5540,type,
    v10507: state_type > $o ).

tff(pred_def_5541,type,
    v10493: state_type > $o ).

tff(pred_def_5542,type,
    v10491: state_type > $o ).

tff(pred_def_5543,type,
    v10489: state_type > $o ).

tff(pred_def_5544,type,
    v10487: state_type > $o ).

tff(pred_def_5545,type,
    v10485: state_type > $o ).

tff(pred_def_5546,type,
    v10512: state_type > $o ).

tff(pred_def_5547,type,
    v10510: state_type > $o ).

tff(pred_def_5548,type,
    v10479: state_type > $o ).

tff(pred_def_5549,type,
    v10518: state_type > $o ).

tff(pred_def_5550,type,
    v10520: state_type > $o ).

tff(pred_def_5551,type,
    v10516: state_type > $o ).

tff(pred_def_5552,type,
    v10515: state_type > $o ).

tff(pred_def_5553,type,
    v10526: state_type > $o ).

tff(pred_def_5554,type,
    v10527: state_type > $o ).

tff(pred_def_5555,type,
    v10523: state_type > $o ).

tff(pred_def_5556,type,
    v10525: state_type > $o ).

tff(pred_def_5557,type,
    v10533: state_type > $o ).

tff(pred_def_5558,type,
    v10531: state_type > $o ).

tff(pred_def_5559,type,
    v10535: state_type > $o ).

tff(pred_def_5560,type,
    v10473: state_type > $o ).

tff(pred_def_5561,type,
    v10471: state_type > $o ).

tff(pred_def_5562,type,
    v10469: state_type > $o ).

tff(pred_def_5563,type,
    v10542: state_type > $o ).

tff(pred_def_5564,type,
    v10540: state_type > $o ).

tff(pred_def_5565,type,
    v10539: state_type > $o ).

tff(pred_def_5566,type,
    v10538: state_type > $o ).

tff(pred_def_5567,type,
    v10550: state_type > $o ).

tff(pred_def_5568,type,
    v10551: state_type > $o ).

tff(pred_def_5569,type,
    v10549: state_type > $o ).

tff(pred_def_5570,type,
    v10546: ( state_type * $int ) > $o ).

tff(pred_def_5571,type,
    v10548: ( state_type * $int ) > $o ).

tff(pred_def_5572,type,
    v10443: ( state_type * $int ) > $o ).

tff(pred_def_5573,type,
    v10441: ( state_type * $int ) > $o ).

tff(pred_def_5574,type,
    v10439: ( state_type * $int ) > $o ).

tff(pred_def_5575,type,
    v10437: ( state_type * $int ) > $o ).

tff(pred_def_5576,type,
    v10435: ( state_type * $int ) > $o ).

tff(pred_def_5577,type,
    v10573: state_type > $o ).

tff(pred_def_5578,type,
    v10571: state_type > $o ).

tff(pred_def_5579,type,
    v10577: state_type > $o ).

tff(pred_def_5580,type,
    v10575: state_type > $o ).

tff(pred_def_5581,type,
    v10581: state_type > $o ).

tff(pred_def_5582,type,
    v10579: state_type > $o ).

tff(pred_def_5583,type,
    v10584: state_type > $o ).

tff(pred_def_5584,type,
    v10583: state_type > $o ).

tff(pred_def_5585,type,
    v10569: state_type > $o ).

tff(pred_def_5586,type,
    v10567: state_type > $o ).

tff(pred_def_5587,type,
    v10565: state_type > $o ).

tff(pred_def_5588,type,
    v10563: state_type > $o ).

tff(pred_def_5589,type,
    v10561: state_type > $o ).

tff(pred_def_5590,type,
    v10559: state_type > $o ).

tff(pred_def_5591,type,
    v10557: state_type > $o ).

tff(pred_def_5592,type,
    v10555: state_type > $o ).

tff(pred_def_5593,type,
    v10604: state_type > $o ).

tff(pred_def_5594,type,
    v10602: state_type > $o ).

tff(pred_def_5595,type,
    v10600: state_type > $o ).

tff(pred_def_5596,type,
    v10598: state_type > $o ).

tff(pred_def_5597,type,
    v10596: state_type > $o ).

tff(pred_def_5598,type,
    v10614: state_type > $o ).

tff(pred_def_5599,type,
    v10612: state_type > $o ).

tff(pred_def_5600,type,
    v10610: state_type > $o ).

tff(pred_def_5601,type,
    v10608: state_type > $o ).

tff(pred_def_5602,type,
    v10606: state_type > $o ).

tff(pred_def_5603,type,
    v10618: ( state_type * $int ) > $o ).

tff(pred_def_5604,type,
    v10616: ( state_type * $int ) > $o ).

tff(pred_def_5605,type,
    v10628: state_type > $o ).

tff(pred_def_5606,type,
    v10626: state_type > $o ).

tff(pred_def_5607,type,
    v10634: state_type > $o ).

tff(pred_def_5608,type,
    v10632: state_type > $o ).

tff(pred_def_5609,type,
    v10648: state_type > $o ).

tff(pred_def_5610,type,
    v10646: state_type > $o ).

tff(pred_def_5611,type,
    v10652: state_type > $o ).

tff(pred_def_5612,type,
    v10650: state_type > $o ).

tff(pred_def_5613,type,
    v10656: state_type > $o ).

tff(pred_def_5614,type,
    v10654: state_type > $o ).

tff(pred_def_5615,type,
    v10659: state_type > $o ).

tff(pred_def_5616,type,
    v10658: state_type > $o ).

tff(pred_def_5617,type,
    v10644: state_type > $o ).

tff(pred_def_5618,type,
    v10642: state_type > $o ).

tff(pred_def_5619,type,
    v10640: state_type > $o ).

tff(pred_def_5620,type,
    v10638: state_type > $o ).

tff(pred_def_5621,type,
    v10636: state_type > $o ).

tff(pred_def_5622,type,
    v10663: state_type > $o ).

tff(pred_def_5623,type,
    v10661: state_type > $o ).

tff(pred_def_5624,type,
    v10630: state_type > $o ).

tff(pred_def_5625,type,
    v10669: state_type > $o ).

tff(pred_def_5626,type,
    v10671: state_type > $o ).

tff(pred_def_5627,type,
    v10667: state_type > $o ).

tff(pred_def_5628,type,
    v10666: state_type > $o ).

tff(pred_def_5629,type,
    v10677: state_type > $o ).

tff(pred_def_5630,type,
    v10678: state_type > $o ).

tff(pred_def_5631,type,
    v10674: state_type > $o ).

tff(pred_def_5632,type,
    v10676: state_type > $o ).

tff(pred_def_5633,type,
    v10684: state_type > $o ).

tff(pred_def_5634,type,
    v10682: state_type > $o ).

tff(pred_def_5635,type,
    v10686: state_type > $o ).

tff(pred_def_5636,type,
    v10624: state_type > $o ).

tff(pred_def_5637,type,
    v10622: state_type > $o ).

tff(pred_def_5638,type,
    v10620: state_type > $o ).

tff(pred_def_5639,type,
    v10693: state_type > $o ).

tff(pred_def_5640,type,
    v10691: state_type > $o ).

tff(pred_def_5641,type,
    v10690: state_type > $o ).

tff(pred_def_5642,type,
    v10689: state_type > $o ).

tff(pred_def_5643,type,
    v10701: state_type > $o ).

tff(pred_def_5644,type,
    v10702: state_type > $o ).

tff(pred_def_5645,type,
    v10700: state_type > $o ).

tff(pred_def_5646,type,
    v10697: ( state_type * $int ) > $o ).

tff(pred_def_5647,type,
    v10699: ( state_type * $int ) > $o ).

tff(pred_def_5648,type,
    v10594: ( state_type * $int ) > $o ).

tff(pred_def_5649,type,
    v10592: ( state_type * $int ) > $o ).

tff(pred_def_5650,type,
    v10590: ( state_type * $int ) > $o ).

tff(pred_def_5651,type,
    v10588: ( state_type * $int ) > $o ).

tff(pred_def_5652,type,
    v10586: ( state_type * $int ) > $o ).

tff(pred_def_5653,type,
    v10724: state_type > $o ).

tff(pred_def_5654,type,
    v10722: state_type > $o ).

tff(pred_def_5655,type,
    v10728: state_type > $o ).

tff(pred_def_5656,type,
    v10726: state_type > $o ).

tff(pred_def_5657,type,
    v10732: state_type > $o ).

tff(pred_def_5658,type,
    v10730: state_type > $o ).

tff(pred_def_5659,type,
    v10735: state_type > $o ).

tff(pred_def_5660,type,
    v10734: state_type > $o ).

tff(pred_def_5661,type,
    v10720: state_type > $o ).

tff(pred_def_5662,type,
    v10718: state_type > $o ).

tff(pred_def_5663,type,
    v10716: state_type > $o ).

tff(pred_def_5664,type,
    v10714: state_type > $o ).

tff(pred_def_5665,type,
    v10712: state_type > $o ).

tff(pred_def_5666,type,
    v10710: state_type > $o ).

tff(pred_def_5667,type,
    v10708: state_type > $o ).

tff(pred_def_5668,type,
    v10706: state_type > $o ).

tff(pred_def_5669,type,
    v10755: state_type > $o ).

tff(pred_def_5670,type,
    v10753: state_type > $o ).

tff(pred_def_5671,type,
    v10751: state_type > $o ).

tff(pred_def_5672,type,
    v10749: state_type > $o ).

tff(pred_def_5673,type,
    v10747: state_type > $o ).

tff(pred_def_5674,type,
    v10765: state_type > $o ).

tff(pred_def_5675,type,
    v10763: state_type > $o ).

tff(pred_def_5676,type,
    v10761: state_type > $o ).

tff(pred_def_5677,type,
    v10759: state_type > $o ).

tff(pred_def_5678,type,
    v10757: state_type > $o ).

tff(pred_def_5679,type,
    v10769: ( state_type * $int ) > $o ).

tff(pred_def_5680,type,
    v10767: ( state_type * $int ) > $o ).

tff(pred_def_5681,type,
    v10779: state_type > $o ).

tff(pred_def_5682,type,
    v10777: state_type > $o ).

tff(pred_def_5683,type,
    v10785: state_type > $o ).

tff(pred_def_5684,type,
    v10783: state_type > $o ).

tff(pred_def_5685,type,
    v10799: state_type > $o ).

tff(pred_def_5686,type,
    v10797: state_type > $o ).

tff(pred_def_5687,type,
    v10803: state_type > $o ).

tff(pred_def_5688,type,
    v10801: state_type > $o ).

tff(pred_def_5689,type,
    v10807: state_type > $o ).

tff(pred_def_5690,type,
    v10805: state_type > $o ).

tff(pred_def_5691,type,
    v10810: state_type > $o ).

tff(pred_def_5692,type,
    v10809: state_type > $o ).

tff(pred_def_5693,type,
    v10795: state_type > $o ).

tff(pred_def_5694,type,
    v10793: state_type > $o ).

tff(pred_def_5695,type,
    v10791: state_type > $o ).

tff(pred_def_5696,type,
    v10789: state_type > $o ).

tff(pred_def_5697,type,
    v10787: state_type > $o ).

tff(pred_def_5698,type,
    v10814: state_type > $o ).

tff(pred_def_5699,type,
    v10812: state_type > $o ).

tff(pred_def_5700,type,
    v10781: state_type > $o ).

tff(pred_def_5701,type,
    v10820: state_type > $o ).

tff(pred_def_5702,type,
    v10822: state_type > $o ).

tff(pred_def_5703,type,
    v10818: state_type > $o ).

tff(pred_def_5704,type,
    v10817: state_type > $o ).

tff(pred_def_5705,type,
    v10828: state_type > $o ).

tff(pred_def_5706,type,
    v10829: state_type > $o ).

tff(pred_def_5707,type,
    v10825: state_type > $o ).

tff(pred_def_5708,type,
    v10827: state_type > $o ).

tff(pred_def_5709,type,
    v10835: state_type > $o ).

tff(pred_def_5710,type,
    v10833: state_type > $o ).

tff(pred_def_5711,type,
    v10837: state_type > $o ).

tff(pred_def_5712,type,
    v10775: state_type > $o ).

tff(pred_def_5713,type,
    v10773: state_type > $o ).

tff(pred_def_5714,type,
    v10771: state_type > $o ).

tff(pred_def_5715,type,
    v10844: state_type > $o ).

tff(pred_def_5716,type,
    v10842: state_type > $o ).

tff(pred_def_5717,type,
    v10841: state_type > $o ).

tff(pred_def_5718,type,
    v10840: state_type > $o ).

tff(pred_def_5719,type,
    v10852: state_type > $o ).

tff(pred_def_5720,type,
    v10853: state_type > $o ).

tff(pred_def_5721,type,
    v10851: state_type > $o ).

tff(pred_def_5722,type,
    v10848: ( state_type * $int ) > $o ).

tff(pred_def_5723,type,
    v10850: ( state_type * $int ) > $o ).

tff(pred_def_5724,type,
    v10745: ( state_type * $int ) > $o ).

tff(pred_def_5725,type,
    v10743: ( state_type * $int ) > $o ).

tff(pred_def_5726,type,
    v10741: ( state_type * $int ) > $o ).

tff(pred_def_5727,type,
    v10739: ( state_type * $int ) > $o ).

tff(pred_def_5728,type,
    v10737: ( state_type * $int ) > $o ).

tff(pred_def_5729,type,
    v10875: state_type > $o ).

tff(pred_def_5730,type,
    v10873: state_type > $o ).

tff(pred_def_5731,type,
    v10879: state_type > $o ).

tff(pred_def_5732,type,
    v10877: state_type > $o ).

tff(pred_def_5733,type,
    v10883: state_type > $o ).

tff(pred_def_5734,type,
    v10881: state_type > $o ).

tff(pred_def_5735,type,
    v10886: state_type > $o ).

tff(pred_def_5736,type,
    v10885: state_type > $o ).

tff(pred_def_5737,type,
    v10871: state_type > $o ).

tff(pred_def_5738,type,
    v10869: state_type > $o ).

tff(pred_def_5739,type,
    v10867: state_type > $o ).

tff(pred_def_5740,type,
    v10865: state_type > $o ).

tff(pred_def_5741,type,
    v10863: state_type > $o ).

tff(pred_def_5742,type,
    v10861: state_type > $o ).

tff(pred_def_5743,type,
    v10859: state_type > $o ).

tff(pred_def_5744,type,
    v10857: state_type > $o ).

tff(pred_def_5745,type,
    v10906: state_type > $o ).

tff(pred_def_5746,type,
    v10904: state_type > $o ).

tff(pred_def_5747,type,
    v10902: state_type > $o ).

tff(pred_def_5748,type,
    v10900: state_type > $o ).

tff(pred_def_5749,type,
    v10898: state_type > $o ).

tff(pred_def_5750,type,
    v10916: state_type > $o ).

tff(pred_def_5751,type,
    v10914: state_type > $o ).

tff(pred_def_5752,type,
    v10912: state_type > $o ).

tff(pred_def_5753,type,
    v10910: state_type > $o ).

tff(pred_def_5754,type,
    v10908: state_type > $o ).

tff(pred_def_5755,type,
    v10920: ( state_type * $int ) > $o ).

tff(pred_def_5756,type,
    v10918: ( state_type * $int ) > $o ).

tff(pred_def_5757,type,
    v10930: state_type > $o ).

tff(pred_def_5758,type,
    v10928: state_type > $o ).

tff(pred_def_5759,type,
    v10936: state_type > $o ).

tff(pred_def_5760,type,
    v10934: state_type > $o ).

tff(pred_def_5761,type,
    v10949: state_type > $o ).

tff(pred_def_5762,type,
    v10947: state_type > $o ).

tff(pred_def_5763,type,
    v10953: state_type > $o ).

tff(pred_def_5764,type,
    v10951: state_type > $o ).

tff(pred_def_5765,type,
    v10957: state_type > $o ).

tff(pred_def_5766,type,
    v10955: state_type > $o ).

tff(pred_def_5767,type,
    v10960: state_type > $o ).

tff(pred_def_5768,type,
    v10959: state_type > $o ).

tff(pred_def_5769,type,
    v10945: state_type > $o ).

tff(pred_def_5770,type,
    v10943: state_type > $o ).

tff(pred_def_5771,type,
    v10940: state_type > $o ).

tff(pred_def_5772,type,
    v10938: state_type > $o ).

tff(pred_def_5773,type,
    v10964: state_type > $o ).

tff(pred_def_5774,type,
    v10962: state_type > $o ).

tff(pred_def_5775,type,
    v10932: state_type > $o ).

tff(pred_def_5776,type,
    v10970: state_type > $o ).

tff(pred_def_5777,type,
    v10972: state_type > $o ).

tff(pred_def_5778,type,
    v10968: state_type > $o ).

tff(pred_def_5779,type,
    v10967: state_type > $o ).

tff(pred_def_5780,type,
    v10978: state_type > $o ).

tff(pred_def_5781,type,
    v10979: state_type > $o ).

tff(pred_def_5782,type,
    v10975: state_type > $o ).

tff(pred_def_5783,type,
    v10977: state_type > $o ).

tff(pred_def_5784,type,
    v10985: state_type > $o ).

tff(pred_def_5785,type,
    v10983: state_type > $o ).

tff(pred_def_5786,type,
    v10987: state_type > $o ).

tff(pred_def_5787,type,
    v10926: state_type > $o ).

tff(pred_def_5788,type,
    v10924: state_type > $o ).

tff(pred_def_5789,type,
    v10922: state_type > $o ).

tff(pred_def_5790,type,
    v10994: state_type > $o ).

tff(pred_def_5791,type,
    v10992: state_type > $o ).

tff(pred_def_5792,type,
    v10991: state_type > $o ).

tff(pred_def_5793,type,
    v10990: state_type > $o ).

tff(pred_def_5794,type,
    v11002: state_type > $o ).

tff(pred_def_5795,type,
    v11003: state_type > $o ).

tff(pred_def_5796,type,
    v11001: state_type > $o ).

tff(pred_def_5797,type,
    v10998: ( state_type * $int ) > $o ).

tff(pred_def_5798,type,
    v11000: ( state_type * $int ) > $o ).

tff(pred_def_5799,type,
    v10896: ( state_type * $int ) > $o ).

tff(pred_def_5800,type,
    v10894: ( state_type * $int ) > $o ).

tff(pred_def_5801,type,
    v10892: ( state_type * $int ) > $o ).

tff(pred_def_5802,type,
    v10890: ( state_type * $int ) > $o ).

tff(pred_def_5803,type,
    v10888: ( state_type * $int ) > $o ).

tff(pred_def_5804,type,
    v11015: state_type > $o ).

tff(pred_def_5805,type,
    v11013: state_type > $o ).

tff(pred_def_5806,type,
    v11011: state_type > $o ).

tff(pred_def_5807,type,
    v11009: state_type > $o ).

tff(pred_def_5808,type,
    v11007: state_type > $o ).

tff(pred_def_5809,type,
    v11023: state_type > $o ).

tff(pred_def_5810,type,
    v11022: ( state_type * $int ) > $o ).

tff(pred_def_5811,type,
    v11021: ( state_type * $int ) > $o ).

tff(pred_def_5812,type,
    v11026: state_type > $o ).

tff(pred_def_5813,type,
    v11025: ( state_type * $int ) > $o ).

tff(pred_def_5814,type,
    v11024: ( state_type * $int ) > $o ).

tff(pred_def_5815,type,
    v11020: ( state_type * $int ) > $o ).

tff(pred_def_5816,type,
    v11029: state_type > $o ).

tff(pred_def_5817,type,
    v11028: ( state_type * $int ) > $o ).

tff(pred_def_5818,type,
    v11027: ( state_type * $int ) > $o ).

tff(pred_def_5819,type,
    v11019: ( state_type * $int ) > $o ).

tff(pred_def_5820,type,
    v11032: state_type > $o ).

tff(pred_def_5821,type,
    v11031: ( state_type * $int ) > $o ).

tff(pred_def_5822,type,
    v11030: ( state_type * $int ) > $o ).

tff(pred_def_5823,type,
    v11018: ( state_type * $int ) > $o ).

tff(pred_def_5824,type,
    v11035: state_type > $o ).

tff(pred_def_5825,type,
    v11034: ( state_type * $int ) > $o ).

tff(pred_def_5826,type,
    v11033: ( state_type * $int ) > $o ).

tff(pred_def_5827,type,
    v11017: ( state_type * $int ) > $o ).

tff(pred_def_5828,type,
    v11038: state_type > $o ).

tff(pred_def_5829,type,
    v11037: ( state_type * $int ) > $o ).

tff(pred_def_5830,type,
    v11036: ( state_type * $int ) > $o ).

tff(pred_def_5831,type,
    v9103: ( state_type * $int ) > $o ).

tff(pred_def_5832,type,
    v9101: ( state_type * $int ) > $o ).

tff(pred_def_5833,type,
    v9099: ( state_type * $int ) > $o ).

tff(pred_def_5834,type,
    v9097: ( state_type * $int ) > $o ).

tff(pred_def_5835,type,
    v9095: ( state_type * $int ) > $o ).

tff(pred_def_5836,type,
    v9089: state_type > $o ).

tff(pred_def_5837,type,
    v9087: state_type > $o ).

tff(pred_def_5838,type,
    v9085: state_type > $o ).

tff(pred_def_5839,type,
    v11049: ( state_type * $int ) > $o ).

tff(pred_def_5840,type,
    v11047: ( state_type * $int ) > $o ).

tff(pred_def_5841,type,
    v11083: state_type > $o ).

tff(pred_def_5842,type,
    v11081: state_type > $o ).

tff(pred_def_5843,type,
    v11079: state_type > $o ).

tff(pred_def_5844,type,
    v11077: state_type > $o ).

tff(pred_def_5845,type,
    v11075: state_type > $o ).

tff(pred_def_5846,type,
    v11073: state_type > $o ).

tff(pred_def_5847,type,
    v11071: state_type > $o ).

tff(pred_def_5848,type,
    v11097: state_type > $o ).

tff(pred_def_5849,type,
    v11095: state_type > $o ).

tff(pred_def_5850,type,
    v11093: state_type > $o ).

tff(pred_def_5851,type,
    v11091: state_type > $o ).

tff(pred_def_5852,type,
    v11089: state_type > $o ).

tff(pred_def_5853,type,
    v11087: state_type > $o ).

tff(pred_def_5854,type,
    v11085: state_type > $o ).

tff(pred_def_5855,type,
    v11123: state_type > $o ).

tff(pred_def_5856,type,
    v11125: state_type > $o ).

tff(pred_def_5857,type,
    v11124: ( state_type * $int ) > $o ).

tff(pred_def_5858,type,
    v11126: state_type > $o ).

tff(pred_def_5859,type,
    v11121: ( state_type * $int ) > $o ).

tff(pred_def_5860,type,
    v11119: ( state_type * $int ) > $o ).

tff(pred_def_5861,type,
    v11127: ( state_type * $int ) > $o ).

tff(pred_def_5862,type,
    v11117: ( state_type * $int ) > $o ).

tff(pred_def_5863,type,
    v11115: ( state_type * $int ) > $o ).

tff(pred_def_5864,type,
    v11113: state_type > $o ).

tff(pred_def_5865,type,
    v11129: state_type > $o ).

tff(pred_def_5866,type,
    v11111: ( state_type * $int ) > $o ).

tff(pred_def_5867,type,
    v11109: ( state_type * $int ) > $o ).

tff(pred_def_5868,type,
    v11143: ( state_type * $int ) > $o ).

tff(pred_def_5869,type,
    v11141: ( state_type * $int ) > $o ).

tff(pred_def_5870,type,
    v11147: state_type > $o ).

tff(pred_def_5871,type,
    v11145: state_type > $o ).

tff(pred_def_5872,type,
    v11171: state_type > $o ).

tff(pred_def_5873,type,
    v11169: state_type > $o ).

tff(pred_def_5874,type,
    v11167: state_type > $o ).

tff(pred_def_5875,type,
    v11165: state_type > $o ).

tff(pred_def_5876,type,
    v11163: state_type > $o ).

tff(pred_def_5877,type,
    v11161: state_type > $o ).

tff(pred_def_5878,type,
    v11159: state_type > $o ).

tff(pred_def_5879,type,
    v11185: state_type > $o ).

tff(pred_def_5880,type,
    v11183: state_type > $o ).

tff(pred_def_5881,type,
    v11181: state_type > $o ).

tff(pred_def_5882,type,
    v11179: state_type > $o ).

tff(pred_def_5883,type,
    v11177: state_type > $o ).

tff(pred_def_5884,type,
    v11175: state_type > $o ).

tff(pred_def_5885,type,
    v11173: state_type > $o ).

tff(pred_def_5886,type,
    v11201: ( state_type * $int ) > $o ).

tff(pred_def_5887,type,
    v11199: ( state_type * $int ) > $o ).

tff(pred_def_5888,type,
    v11197: ( state_type * $int ) > $o ).

tff(pred_def_5889,type,
    v11195: ( state_type * $int ) > $o ).

tff(pred_def_5890,type,
    v11193: ( state_type * $int ) > $o ).

tff(pred_def_5891,type,
    v11231: ( state_type * $int ) > $o ).

tff(pred_def_5892,type,
    v11233: ( state_type * $int ) > $o ).

tff(pred_def_5893,type,
    v11229: ( state_type * $int ) > $o ).

tff(pred_def_5894,type,
    v11227: ( state_type * $int ) > $o ).

tff(pred_def_5895,type,
    v11225: ( state_type * $int ) > $o ).

tff(pred_def_5896,type,
    v11223: ( state_type * $int ) > $o ).

tff(pred_def_5897,type,
    v11221: state_type > $o ).

tff(pred_def_5898,type,
    v11219: state_type > $o ).

tff(pred_def_5899,type,
    v11237: state_type > $o ).

tff(pred_def_5900,type,
    v11235: state_type > $o ).

tff(pred_def_5901,type,
    v11239: state_type > $o ).

tff(pred_def_5902,type,
    v11217: state_type > $o ).

tff(pred_def_5903,type,
    v11215: state_type > $o ).

tff(pred_def_5904,type,
    v11213: state_type > $o ).

tff(pred_def_5905,type,
    v11211: state_type > $o ).

tff(pred_def_5906,type,
    v11209: state_type > $o ).

tff(pred_def_5907,type,
    v11207: state_type > $o ).

tff(pred_def_5908,type,
    v11205: state_type > $o ).

tff(pred_def_5909,type,
    v11203: state_type > $o ).

tff(pred_def_5910,type,
    v11249: ( state_type * $int ) > $o ).

tff(pred_def_5911,type,
    v11247: ( state_type * $int ) > $o ).

tff(pred_def_5912,type,
    v11245: ( state_type * $int ) > $o ).

tff(pred_def_5913,type,
    v11243: ( state_type * $int ) > $o ).

tff(pred_def_5914,type,
    v11241: ( state_type * $int ) > $o ).

tff(pred_def_5915,type,
    v11279: ( state_type * $int ) > $o ).

tff(pred_def_5916,type,
    v11277: ( state_type * $int ) > $o ).

tff(pred_def_5917,type,
    v11280: ( state_type * $int ) > $o ).

tff(pred_def_5918,type,
    v11275: ( state_type * $int ) > $o ).

tff(pred_def_5919,type,
    v11273: ( state_type * $int ) > $o ).

tff(pred_def_5920,type,
    v11271: ( state_type * $int ) > $o ).

tff(pred_def_5921,type,
    v11269: state_type > $o ).

tff(pred_def_5922,type,
    v11267: state_type > $o ).

tff(pred_def_5923,type,
    v11284: state_type > $o ).

tff(pred_def_5924,type,
    v11282: state_type > $o ).

tff(pred_def_5925,type,
    v11286: state_type > $o ).

tff(pred_def_5926,type,
    v11265: state_type > $o ).

tff(pred_def_5927,type,
    v11263: state_type > $o ).

tff(pred_def_5928,type,
    v11261: state_type > $o ).

tff(pred_def_5929,type,
    v11259: state_type > $o ).

tff(pred_def_5930,type,
    v11257: state_type > $o ).

tff(pred_def_5931,type,
    v11255: state_type > $o ).

tff(pred_def_5932,type,
    v11253: state_type > $o ).

tff(pred_def_5933,type,
    v11251: state_type > $o ).

tff(pred_def_5934,type,
    v11296: ( state_type * $int ) > $o ).

tff(pred_def_5935,type,
    v11294: ( state_type * $int ) > $o ).

tff(pred_def_5936,type,
    v11292: ( state_type * $int ) > $o ).

tff(pred_def_5937,type,
    v11290: ( state_type * $int ) > $o ).

tff(pred_def_5938,type,
    v11288: ( state_type * $int ) > $o ).

tff(pred_def_5939,type,
    v11316: state_type > $o ).

tff(pred_def_5940,type,
    v11314: state_type > $o ).

tff(pred_def_5941,type,
    v11320: state_type > $o ).

tff(pred_def_5942,type,
    v11318: state_type > $o ).

tff(pred_def_5943,type,
    v11322: state_type > $o ).

tff(pred_def_5944,type,
    v11312: state_type > $o ).

tff(pred_def_5945,type,
    v11310: state_type > $o ).

tff(pred_def_5946,type,
    v11308: state_type > $o ).

tff(pred_def_5947,type,
    v11306: state_type > $o ).

tff(pred_def_5948,type,
    v11304: state_type > $o ).

tff(pred_def_5949,type,
    v11302: state_type > $o ).

tff(pred_def_5950,type,
    v11300: state_type > $o ).

tff(pred_def_5951,type,
    v11298: state_type > $o ).

tff(pred_def_5952,type,
    v11332: ( state_type * $int ) > $o ).

tff(pred_def_5953,type,
    v11330: ( state_type * $int ) > $o ).

tff(pred_def_5954,type,
    v11328: ( state_type * $int ) > $o ).

tff(pred_def_5955,type,
    v11326: ( state_type * $int ) > $o ).

tff(pred_def_5956,type,
    v11324: ( state_type * $int ) > $o ).

tff(pred_def_5957,type,
    v11352: state_type > $o ).

tff(pred_def_5958,type,
    v11350: state_type > $o ).

tff(pred_def_5959,type,
    v11356: state_type > $o ).

tff(pred_def_5960,type,
    v11354: state_type > $o ).

tff(pred_def_5961,type,
    v11358: state_type > $o ).

tff(pred_def_5962,type,
    v11348: state_type > $o ).

tff(pred_def_5963,type,
    v11346: state_type > $o ).

tff(pred_def_5964,type,
    v11344: state_type > $o ).

tff(pred_def_5965,type,
    v11342: state_type > $o ).

tff(pred_def_5966,type,
    v11340: state_type > $o ).

tff(pred_def_5967,type,
    v11338: state_type > $o ).

tff(pred_def_5968,type,
    v11336: state_type > $o ).

tff(pred_def_5969,type,
    v11334: state_type > $o ).

tff(pred_def_5970,type,
    v11364: state_type > $o ).

tff(pred_def_5971,type,
    v11363: ( state_type * $int ) > $o ).

tff(pred_def_5972,type,
    v11362: ( state_type * $int ) > $o ).

tff(pred_def_5973,type,
    v11367: state_type > $o ).

tff(pred_def_5974,type,
    v11366: ( state_type * $int ) > $o ).

tff(pred_def_5975,type,
    v11365: ( state_type * $int ) > $o ).

tff(pred_def_5976,type,
    v11361: ( state_type * $int ) > $o ).

tff(pred_def_5977,type,
    v11370: state_type > $o ).

tff(pred_def_5978,type,
    v11369: ( state_type * $int ) > $o ).

tff(pred_def_5979,type,
    v11368: ( state_type * $int ) > $o ).

tff(pred_def_5980,type,
    v11360: ( state_type * $int ) > $o ).

tff(pred_def_5981,type,
    v11373: state_type > $o ).

tff(pred_def_5982,type,
    v11372: ( state_type * $int ) > $o ).

tff(pred_def_5983,type,
    v11371: ( state_type * $int ) > $o ).

tff(pred_def_5984,type,
    v11191: ( state_type * $int ) > $o ).

tff(pred_def_5985,type,
    v11189: ( state_type * $int ) > $o ).

tff(pred_def_5986,type,
    v11187: ( state_type * $int ) > $o ).

tff(pred_def_5987,type,
    v11385: state_type > $o ).

tff(pred_def_5988,type,
    v11383: state_type > $o ).

tff(pred_def_5989,type,
    v11381: state_type > $o ).

tff(pred_def_5990,type,
    v11395: state_type > $o ).

tff(pred_def_5991,type,
    v11393: state_type > $o ).

tff(pred_def_5992,type,
    v11391: state_type > $o ).

tff(pred_def_5993,type,
    v11389: state_type > $o ).

tff(pred_def_5994,type,
    v11387: state_type > $o ).

tff(pred_def_5995,type,
    v11397: state_type > $o ).

tff(pred_def_5996,type,
    v11379: state_type > $o ).

tff(pred_def_5997,type,
    v11377: state_type > $o ).

tff(pred_def_5998,type,
    v11375: state_type > $o ).

tff(pred_def_5999,type,
    v11404: state_type > $o ).

tff(pred_def_6000,type,
    v11402: state_type > $o ).

tff(pred_def_6001,type,
    v11401: state_type > $o ).

tff(pred_def_6002,type,
    v11400: state_type > $o ).

tff(pred_def_6003,type,
    v11412: state_type > $o ).

tff(pred_def_6004,type,
    v11413: state_type > $o ).

tff(pred_def_6005,type,
    v11411: state_type > $o ).

tff(pred_def_6006,type,
    v11408: ( state_type * $int ) > $o ).

tff(pred_def_6007,type,
    v11410: ( state_type * $int ) > $o ).

tff(pred_def_6008,type,
    v11157: ( state_type * $int ) > $o ).

tff(pred_def_6009,type,
    v11155: ( state_type * $int ) > $o ).

tff(pred_def_6010,type,
    v11153: ( state_type * $int ) > $o ).

tff(pred_def_6011,type,
    v11151: ( state_type * $int ) > $o ).

tff(pred_def_6012,type,
    v11149: ( state_type * $int ) > $o ).

tff(pred_def_6013,type,
    v11419: state_type > $o ).

tff(pred_def_6014,type,
    v11417: state_type > $o ).

tff(pred_def_6015,type,
    v11423: state_type > $o ).

tff(pred_def_6016,type,
    v11422: ( state_type * $int ) > $o ).

tff(pred_def_6017,type,
    v11421: ( state_type * $int ) > $o ).

tff(pred_def_6018,type,
    v11426: state_type > $o ).

tff(pred_def_6019,type,
    v11425: ( state_type * $int ) > $o ).

tff(pred_def_6020,type,
    v11424: ( state_type * $int ) > $o ).

tff(pred_def_6021,type,
    v11139: ( state_type * $int ) > $o ).

tff(pred_def_6022,type,
    v11137: ( state_type * $int ) > $o ).

tff(pred_def_6023,type,
    v11135: ( state_type * $int ) > $o ).

tff(pred_def_6024,type,
    v11133: ( state_type * $int ) > $o ).

tff(pred_def_6025,type,
    v11131: ( state_type * $int ) > $o ).

tff(pred_def_6026,type,
    v11107: ( state_type * $int ) > $o ).

tff(pred_def_6027,type,
    v11105: ( state_type * $int ) > $o ).

tff(pred_def_6028,type,
    v11103: ( state_type * $int ) > $o ).

tff(pred_def_6029,type,
    v11101: ( state_type * $int ) > $o ).

tff(pred_def_6030,type,
    v11099: ( state_type * $int ) > $o ).

tff(pred_def_6031,type,
    v11439: state_type > $o ).

tff(pred_def_6032,type,
    v11437: state_type > $o ).

tff(pred_def_6033,type,
    v11435: state_type > $o ).

tff(pred_def_6034,type,
    v11445: state_type > $o ).

tff(pred_def_6035,type,
    v11443: state_type > $o ).

tff(pred_def_6036,type,
    v11463: ( state_type * $int ) > $o ).

tff(pred_def_6037,type,
    v11465: ( state_type * $int ) > $o ).

tff(pred_def_6038,type,
    v11461: ( state_type * $int ) > $o ).

tff(pred_def_6039,type,
    v11459: state_type > $o ).

tff(pred_def_6040,type,
    v11457: state_type > $o ).

tff(pred_def_6041,type,
    v11469: state_type > $o ).

tff(pred_def_6042,type,
    v11467: state_type > $o ).

tff(pred_def_6043,type,
    v11473: state_type > $o ).

tff(pred_def_6044,type,
    v11471: state_type > $o ).

tff(pred_def_6045,type,
    v11476: state_type > $o ).

tff(pred_def_6046,type,
    v11475: state_type > $o ).

tff(pred_def_6047,type,
    v11455: state_type > $o ).

tff(pred_def_6048,type,
    v11453: state_type > $o ).

tff(pred_def_6049,type,
    v11451: state_type > $o ).

tff(pred_def_6050,type,
    v11449: state_type > $o ).

tff(pred_def_6051,type,
    v11447: state_type > $o ).

tff(pred_def_6052,type,
    v11484: state_type > $o ).

tff(pred_def_6053,type,
    v11482: state_type > $o ).

tff(pred_def_6054,type,
    v11480: state_type > $o ).

tff(pred_def_6055,type,
    v11478: state_type > $o ).

tff(pred_def_6056,type,
    v11441: state_type > $o ).

tff(pred_def_6057,type,
    v11490: state_type > $o ).

tff(pred_def_6058,type,
    v11492: state_type > $o ).

tff(pred_def_6059,type,
    v11488: state_type > $o ).

tff(pred_def_6060,type,
    v11487: state_type > $o ).

tff(pred_def_6061,type,
    v11498: state_type > $o ).

tff(pred_def_6062,type,
    v11499: state_type > $o ).

tff(pred_def_6063,type,
    v11495: state_type > $o ).

tff(pred_def_6064,type,
    v11497: state_type > $o ).

tff(pred_def_6065,type,
    v11509: state_type > $o ).

tff(pred_def_6066,type,
    v11507: state_type > $o ).

tff(pred_def_6067,type,
    v11505: state_type > $o ).

tff(pred_def_6068,type,
    v11503: state_type > $o ).

tff(pred_def_6069,type,
    v11511: state_type > $o ).

tff(pred_def_6070,type,
    v11433: state_type > $o ).

tff(pred_def_6071,type,
    v11431: state_type > $o ).

tff(pred_def_6072,type,
    v11429: state_type > $o ).

tff(pred_def_6073,type,
    v11518: state_type > $o ).

tff(pred_def_6074,type,
    v11516: state_type > $o ).

tff(pred_def_6075,type,
    v11515: state_type > $o ).

tff(pred_def_6076,type,
    v11514: state_type > $o ).

tff(pred_def_6077,type,
    v11526: state_type > $o ).

tff(pred_def_6078,type,
    v11527: state_type > $o ).

tff(pred_def_6079,type,
    v11525: state_type > $o ).

tff(pred_def_6080,type,
    v11522: ( state_type * $int ) > $o ).

tff(pred_def_6081,type,
    v11524: ( state_type * $int ) > $o ).

tff(pred_def_6082,type,
    v11069: ( state_type * $int ) > $o ).

tff(pred_def_6083,type,
    v11067: ( state_type * $int ) > $o ).

tff(pred_def_6084,type,
    v11065: ( state_type * $int ) > $o ).

tff(pred_def_6085,type,
    v11063: ( state_type * $int ) > $o ).

tff(pred_def_6086,type,
    v11061: ( state_type * $int ) > $o ).

tff(pred_def_6087,type,
    v11563: state_type > $o ).

tff(pred_def_6088,type,
    v11561: state_type > $o ).

tff(pred_def_6089,type,
    v11559: state_type > $o ).

tff(pred_def_6090,type,
    v11557: state_type > $o ).

tff(pred_def_6091,type,
    v11555: state_type > $o ).

tff(pred_def_6092,type,
    v11553: state_type > $o ).

tff(pred_def_6093,type,
    v11573: state_type > $o ).

tff(pred_def_6094,type,
    v11571: state_type > $o ).

tff(pred_def_6095,type,
    v11569: state_type > $o ).

tff(pred_def_6096,type,
    v11567: state_type > $o ).

tff(pred_def_6097,type,
    v11565: state_type > $o ).

tff(pred_def_6098,type,
    v11600: state_type > $o ).

tff(pred_def_6099,type,
    v11599: ( state_type * $int ) > $o ).

tff(pred_def_6100,type,
    v11598: ( state_type * $int ) > $o ).

tff(pred_def_6101,type,
    v11596: ( state_type * $int ) > $o ).

tff(pred_def_6102,type,
    v11616: state_type > $o ).

tff(pred_def_6103,type,
    v11617: ( state_type * $int ) > $o ).

tff(pred_def_6104,type,
    v11618: state_type > $o ).

tff(pred_def_6105,type,
    v11614: ( state_type * $int ) > $o ).

tff(pred_def_6106,type,
    v11612: ( state_type * $int ) > $o ).

tff(pred_def_6107,type,
    v11642: ( state_type * $int ) > $o ).

tff(pred_def_6108,type,
    v11551: ( state_type * $int ) > $o ).

tff(pred_def_6109,type,
    v11640: ( state_type * $int ) > $o ).

tff(pred_def_6110,type,
    v11643: ( state_type * $int ) > $o ).

tff(pred_def_6111,type,
    v11638: ( state_type * $int ) > $o ).

tff(pred_def_6112,type,
    v11636: ( state_type * $int ) > $o ).

tff(pred_def_6113,type,
    v11634: ( state_type * $int ) > $o ).

tff(pred_def_6114,type,
    v11632: state_type > $o ).

tff(pred_def_6115,type,
    v11630: state_type > $o ).

tff(pred_def_6116,type,
    v11649: state_type > $o ).

tff(pred_def_6117,type,
    v11589: state_type > $o ).

tff(pred_def_6118,type,
    v11648: ( state_type * $int ) > $o ).

tff(pred_def_6119,type,
    v11587: ( state_type * $int ) > $o ).

tff(pred_def_6120,type,
    v11585: ( state_type * $int ) > $o ).

tff(pred_def_6121,type,
    v11664: ( state_type * $int ) > $o ).

tff(pred_def_6122,type,
    v11663: ( state_type * $int ) > $o ).

tff(pred_def_6123,type,
    v11661: ( state_type * $int ) > $o ).

tff(pred_def_6124,type,
    v11668: state_type > $o ).

tff(pred_def_6125,type,
    v11666: state_type > $o ).

tff(pred_def_6126,type,
    v11679: ( state_type * $int ) > $o ).

tff(pred_def_6127,type,
    v11678: state_type > $o ).

tff(pred_def_6128,type,
    v11682: state_type > $o ).

tff(pred_def_6129,type,
    v11683: state_type > $o ).

tff(pred_def_6130,type,
    v11681: state_type > $o ).

tff(pred_def_6131,type,
    v11684: state_type > $o ).

tff(pred_def_6132,type,
    v11680: state_type > $o ).

tff(pred_def_6133,type,
    v11677: state_type > $o ).

tff(pred_def_6134,type,
    v11685: state_type > $o ).

tff(pred_def_6135,type,
    v11676: state_type > $o ).

tff(pred_def_6136,type,
    v11688: state_type > $o ).

tff(pred_def_6137,type,
    v11689: state_type > $o ).

tff(pred_def_6138,type,
    v11687: state_type > $o ).

tff(pred_def_6139,type,
    v11690: state_type > $o ).

tff(pred_def_6140,type,
    v11686: state_type > $o ).

tff(pred_def_6141,type,
    v11675: state_type > $o ).

tff(pred_def_6142,type,
    v11691: state_type > $o ).

tff(pred_def_6143,type,
    v11674: state_type > $o ).

tff(pred_def_6144,type,
    v11673: state_type > $o ).

tff(pred_def_6145,type,
    v11695: state_type > $o ).

tff(pred_def_6146,type,
    v11696: state_type > $o ).

tff(pred_def_6147,type,
    v11694: state_type > $o ).

tff(pred_def_6148,type,
    v11697: state_type > $o ).

tff(pred_def_6149,type,
    v11693: state_type > $o ).

tff(pred_def_6150,type,
    v11692: state_type > $o ).

tff(pred_def_6151,type,
    v11672: state_type > $o ).

tff(pred_def_6152,type,
    v11698: state_type > $o ).

tff(pred_def_6153,type,
    v11671: state_type > $o ).

tff(pred_def_6154,type,
    v11701: state_type > $o ).

tff(pred_def_6155,type,
    v11702: state_type > $o ).

tff(pred_def_6156,type,
    v11700: state_type > $o ).

tff(pred_def_6157,type,
    v11703: state_type > $o ).

tff(pred_def_6158,type,
    v11699: state_type > $o ).

tff(pred_def_6159,type,
    v11706: state_type > $o ).

tff(pred_def_6160,type,
    v11707: state_type > $o ).

tff(pred_def_6161,type,
    v11705: state_type > $o ).

tff(pred_def_6162,type,
    v11708: state_type > $o ).

tff(pred_def_6163,type,
    v11704: state_type > $o ).

tff(pred_def_6164,type,
    v11711: state_type > $o ).

tff(pred_def_6165,type,
    v11712: state_type > $o ).

tff(pred_def_6166,type,
    v11710: state_type > $o ).

tff(pred_def_6167,type,
    v11713: state_type > $o ).

tff(pred_def_6168,type,
    v11709: state_type > $o ).

tff(pred_def_6169,type,
    v11669: ( state_type * $int ) > $o ).

tff(pred_def_6170,type,
    v11659: ( state_type * $int ) > $o ).

tff(pred_def_6171,type,
    v11657: ( state_type * $int ) > $o ).

tff(pred_def_6172,type,
    v11655: ( state_type * $int ) > $o ).

tff(pred_def_6173,type,
    v11653: ( state_type * $int ) > $o ).

tff(pred_def_6174,type,
    v11651: ( state_type * $int ) > $o ).

tff(pred_def_6175,type,
    v11714: ( state_type * $int ) > $o ).

tff(pred_def_6176,type,
    v11583: ( state_type * $int ) > $o ).

tff(pred_def_6177,type,
    v11581: ( state_type * $int ) > $o ).

tff(pred_def_6178,type,
    v11579: ( state_type * $int ) > $o ).

tff(pred_def_6179,type,
    v11715: ( state_type * $int ) > $o ).

tff(pred_def_6180,type,
    v11716: ( state_type * $int ) > $o ).

tff(pred_def_6181,type,
    v11577: ( state_type * $int ) > $o ).

tff(pred_def_6182,type,
    v11575: ( state_type * $int ) > $o ).

tff(pred_def_6183,type,
    v11726: state_type > $o ).

tff(pred_def_6184,type,
    v11724: state_type > $o ).

tff(pred_def_6185,type,
    v11732: state_type > $o ).

tff(pred_def_6186,type,
    v11730: state_type > $o ).

tff(pred_def_6187,type,
    v11736: state_type > $o ).

tff(pred_def_6188,type,
    v11734: state_type > $o ).

tff(pred_def_6189,type,
    v11740: state_type > $o ).

tff(pred_def_6190,type,
    v11738: state_type > $o ).

tff(pred_def_6191,type,
    v11728: state_type > $o ).

tff(pred_def_6192,type,
    v11746: state_type > $o ).

tff(pred_def_6193,type,
    v11748: state_type > $o ).

tff(pred_def_6194,type,
    v11744: state_type > $o ).

tff(pred_def_6195,type,
    v11743: state_type > $o ).

tff(pred_def_6196,type,
    v11754: state_type > $o ).

tff(pred_def_6197,type,
    v11755: state_type > $o ).

tff(pred_def_6198,type,
    v11751: state_type > $o ).

tff(pred_def_6199,type,
    v11753: state_type > $o ).

tff(pred_def_6200,type,
    v11761: state_type > $o ).

tff(pred_def_6201,type,
    v11759: state_type > $o ).

tff(pred_def_6202,type,
    v11763: state_type > $o ).

tff(pred_def_6203,type,
    v11722: state_type > $o ).

tff(pred_def_6204,type,
    v11720: state_type > $o ).

tff(pred_def_6205,type,
    v11718: state_type > $o ).

tff(pred_def_6206,type,
    v11770: state_type > $o ).

tff(pred_def_6207,type,
    v11768: state_type > $o ).

tff(pred_def_6208,type,
    v11767: state_type > $o ).

tff(pred_def_6209,type,
    v11766: state_type > $o ).

tff(pred_def_6210,type,
    v11778: state_type > $o ).

tff(pred_def_6211,type,
    v11779: state_type > $o ).

tff(pred_def_6212,type,
    v11777: state_type > $o ).

tff(pred_def_6213,type,
    v11774: ( state_type * $int ) > $o ).

tff(pred_def_6214,type,
    v11776: ( state_type * $int ) > $o ).

tff(pred_def_6215,type,
    v11765: ( state_type * $int ) > $o ).

tff(pred_def_6216,type,
    v11647: state_type > $o ).

tff(pred_def_6217,type,
    v11645: state_type > $o ).

tff(pred_def_6218,type,
    v11791: state_type > $o ).

tff(pred_def_6219,type,
    v11789: state_type > $o ).

tff(pred_def_6220,type,
    v11788: state_type > $o ).

tff(pred_def_6221,type,
    v11787: ( state_type * $int ) > $o ).

tff(pred_def_6222,type,
    v11785: state_type > $o ).

tff(pred_def_6223,type,
    v11783: state_type > $o ).

tff(pred_def_6224,type,
    v11796: state_type > $o ).

tff(pred_def_6225,type,
    v11795: state_type > $o ).

tff(pred_def_6226,type,
    v11628: state_type > $o ).

tff(pred_def_6227,type,
    v11626: state_type > $o ).

tff(pred_def_6228,type,
    v11624: state_type > $o ).

tff(pred_def_6229,type,
    v11797: ( state_type * $int ) > $o ).

tff(pred_def_6230,type,
    v11798: state_type > $o ).

tff(pred_def_6231,type,
    v11622: ( state_type * $int ) > $o ).

tff(pred_def_6232,type,
    v11620: ( state_type * $int ) > $o ).

tff(pred_def_6233,type,
    v11799: ( state_type * $int ) > $o ).

tff(pred_def_6234,type,
    v11610: ( state_type * $int ) > $o ).

tff(pred_def_6235,type,
    v11608: ( state_type * $int ) > $o ).

tff(pred_def_6236,type,
    v11606: state_type > $o ).

tff(pred_def_6237,type,
    v11800: ( state_type * $int ) > $o ).

tff(pred_def_6238,type,
    v11801: state_type > $o ).

tff(pred_def_6239,type,
    v11604: ( state_type * $int ) > $o ).

tff(pred_def_6240,type,
    v11602: ( state_type * $int ) > $o ).

tff(pred_def_6241,type,
    v11802: ( state_type * $int ) > $o ).

tff(pred_def_6242,type,
    v11594: ( state_type * $int ) > $o ).

tff(pred_def_6243,type,
    v11592: ( state_type * $int ) > $o ).

tff(pred_def_6244,type,
    v11808: state_type > $o ).

tff(pred_def_6245,type,
    v11806: state_type > $o ).

tff(pred_def_6246,type,
    v11805: state_type > $o ).

tff(pred_def_6247,type,
    v11804: ( state_type * $int ) > $o ).

tff(pred_def_6248,type,
    v11549: state_type > $o ).

tff(pred_def_6249,type,
    v11547: state_type > $o ).

tff(pred_def_6250,type,
    v11814: state_type > $o ).

tff(pred_def_6251,type,
    v11812: state_type > $o ).

tff(pred_def_6252,type,
    v11818: state_type > $o ).

tff(pred_def_6253,type,
    v11816: state_type > $o ).

tff(pred_def_6254,type,
    v11821: state_type > $o ).

tff(pred_def_6255,type,
    v11820: state_type > $o ).

tff(pred_def_6256,type,
    v11545: state_type > $o ).

tff(pred_def_6257,type,
    v11543: state_type > $o ).

tff(pred_def_6258,type,
    v11541: state_type > $o ).

tff(pred_def_6259,type,
    v11539: state_type > $o ).

tff(pred_def_6260,type,
    v11537: state_type > $o ).

tff(pred_def_6261,type,
    v11535: state_type > $o ).

tff(pred_def_6262,type,
    v11533: state_type > $o ).

tff(pred_def_6263,type,
    v11531: state_type > $o ).

tff(pred_def_6264,type,
    v11841: state_type > $o ).

tff(pred_def_6265,type,
    v11839: state_type > $o ).

tff(pred_def_6266,type,
    v11837: state_type > $o ).

tff(pred_def_6267,type,
    v11835: state_type > $o ).

tff(pred_def_6268,type,
    v11833: state_type > $o ).

tff(pred_def_6269,type,
    v11851: state_type > $o ).

tff(pred_def_6270,type,
    v11849: state_type > $o ).

tff(pred_def_6271,type,
    v11847: state_type > $o ).

tff(pred_def_6272,type,
    v11845: state_type > $o ).

tff(pred_def_6273,type,
    v11843: state_type > $o ).

tff(pred_def_6274,type,
    v11855: ( state_type * $int ) > $o ).

tff(pred_def_6275,type,
    v11853: ( state_type * $int ) > $o ).

tff(pred_def_6276,type,
    v11865: state_type > $o ).

tff(pred_def_6277,type,
    v11863: state_type > $o ).

tff(pred_def_6278,type,
    v11871: state_type > $o ).

tff(pred_def_6279,type,
    v11869: state_type > $o ).

tff(pred_def_6280,type,
    v11895: ( state_type * $int ) > $o ).

tff(pred_def_6281,type,
    v11893: ( state_type * $int ) > $o ).

tff(pred_def_6282,type,
    v11896: ( state_type * $int ) > $o ).

tff(pred_def_6283,type,
    v11891: ( state_type * $int ) > $o ).

tff(pred_def_6284,type,
    v11889: ( state_type * $int ) > $o ).

tff(pred_def_6285,type,
    v11887: ( state_type * $int ) > $o ).

tff(pred_def_6286,type,
    v11885: state_type > $o ).

tff(pred_def_6287,type,
    v11883: state_type > $o ).

tff(pred_def_6288,type,
    v11900: state_type > $o ).

tff(pred_def_6289,type,
    v11898: state_type > $o ).

tff(pred_def_6290,type,
    v11904: state_type > $o ).

tff(pred_def_6291,type,
    v11902: state_type > $o ).

tff(pred_def_6292,type,
    v11907: state_type > $o ).

tff(pred_def_6293,type,
    v11906: state_type > $o ).

tff(pred_def_6294,type,
    v11881: state_type > $o ).

tff(pred_def_6295,type,
    v11879: state_type > $o ).

tff(pred_def_6296,type,
    v11877: state_type > $o ).

tff(pred_def_6297,type,
    v11875: state_type > $o ).

tff(pred_def_6298,type,
    v11873: state_type > $o ).

tff(pred_def_6299,type,
    v11911: state_type > $o ).

tff(pred_def_6300,type,
    v11909: state_type > $o ).

tff(pred_def_6301,type,
    v11867: state_type > $o ).

tff(pred_def_6302,type,
    v11917: state_type > $o ).

tff(pred_def_6303,type,
    v11919: state_type > $o ).

tff(pred_def_6304,type,
    v11915: state_type > $o ).

tff(pred_def_6305,type,
    v11914: state_type > $o ).

tff(pred_def_6306,type,
    v11925: state_type > $o ).

tff(pred_def_6307,type,
    v11926: state_type > $o ).

tff(pred_def_6308,type,
    v11922: state_type > $o ).

tff(pred_def_6309,type,
    v11924: state_type > $o ).

tff(pred_def_6310,type,
    v11932: state_type > $o ).

tff(pred_def_6311,type,
    v11930: state_type > $o ).

tff(pred_def_6312,type,
    v11934: state_type > $o ).

tff(pred_def_6313,type,
    v11861: state_type > $o ).

tff(pred_def_6314,type,
    v11859: state_type > $o ).

tff(pred_def_6315,type,
    v11857: state_type > $o ).

tff(pred_def_6316,type,
    v11941: state_type > $o ).

tff(pred_def_6317,type,
    v11939: state_type > $o ).

tff(pred_def_6318,type,
    v11938: state_type > $o ).

tff(pred_def_6319,type,
    v11937: state_type > $o ).

tff(pred_def_6320,type,
    v11949: state_type > $o ).

tff(pred_def_6321,type,
    v11950: state_type > $o ).

tff(pred_def_6322,type,
    v11948: state_type > $o ).

tff(pred_def_6323,type,
    v11945: ( state_type * $int ) > $o ).

tff(pred_def_6324,type,
    v11947: ( state_type * $int ) > $o ).

tff(pred_def_6325,type,
    v11831: ( state_type * $int ) > $o ).

tff(pred_def_6326,type,
    v11829: ( state_type * $int ) > $o ).

tff(pred_def_6327,type,
    v11827: ( state_type * $int ) > $o ).

tff(pred_def_6328,type,
    v11825: ( state_type * $int ) > $o ).

tff(pred_def_6329,type,
    v11823: ( state_type * $int ) > $o ).

tff(pred_def_6330,type,
    v11972: state_type > $o ).

tff(pred_def_6331,type,
    v11970: state_type > $o ).

tff(pred_def_6332,type,
    v11976: state_type > $o ).

tff(pred_def_6333,type,
    v11974: state_type > $o ).

tff(pred_def_6334,type,
    v11980: state_type > $o ).

tff(pred_def_6335,type,
    v11978: state_type > $o ).

tff(pred_def_6336,type,
    v11983: state_type > $o ).

tff(pred_def_6337,type,
    v11982: state_type > $o ).

tff(pred_def_6338,type,
    v11968: state_type > $o ).

tff(pred_def_6339,type,
    v11966: state_type > $o ).

tff(pred_def_6340,type,
    v11964: state_type > $o ).

tff(pred_def_6341,type,
    v11962: state_type > $o ).

tff(pred_def_6342,type,
    v11960: state_type > $o ).

tff(pred_def_6343,type,
    v11958: state_type > $o ).

tff(pred_def_6344,type,
    v11956: state_type > $o ).

tff(pred_def_6345,type,
    v11954: state_type > $o ).

tff(pred_def_6346,type,
    v12003: state_type > $o ).

tff(pred_def_6347,type,
    v12001: state_type > $o ).

tff(pred_def_6348,type,
    v11999: state_type > $o ).

tff(pred_def_6349,type,
    v11997: state_type > $o ).

tff(pred_def_6350,type,
    v11995: state_type > $o ).

tff(pred_def_6351,type,
    v12013: state_type > $o ).

tff(pred_def_6352,type,
    v12011: state_type > $o ).

tff(pred_def_6353,type,
    v12009: state_type > $o ).

tff(pred_def_6354,type,
    v12007: state_type > $o ).

tff(pred_def_6355,type,
    v12005: state_type > $o ).

tff(pred_def_6356,type,
    v12017: ( state_type * $int ) > $o ).

tff(pred_def_6357,type,
    v12015: ( state_type * $int ) > $o ).

tff(pred_def_6358,type,
    v12027: state_type > $o ).

tff(pred_def_6359,type,
    v12025: state_type > $o ).

tff(pred_def_6360,type,
    v12033: state_type > $o ).

tff(pred_def_6361,type,
    v12031: state_type > $o ).

tff(pred_def_6362,type,
    v12047: state_type > $o ).

tff(pred_def_6363,type,
    v12045: state_type > $o ).

tff(pred_def_6364,type,
    v12051: state_type > $o ).

tff(pred_def_6365,type,
    v12049: state_type > $o ).

tff(pred_def_6366,type,
    v12055: state_type > $o ).

tff(pred_def_6367,type,
    v12053: state_type > $o ).

tff(pred_def_6368,type,
    v12058: state_type > $o ).

tff(pred_def_6369,type,
    v12057: state_type > $o ).

tff(pred_def_6370,type,
    v12043: state_type > $o ).

tff(pred_def_6371,type,
    v12041: state_type > $o ).

tff(pred_def_6372,type,
    v12039: state_type > $o ).

tff(pred_def_6373,type,
    v12037: state_type > $o ).

tff(pred_def_6374,type,
    v12035: state_type > $o ).

tff(pred_def_6375,type,
    v12062: state_type > $o ).

tff(pred_def_6376,type,
    v12060: state_type > $o ).

tff(pred_def_6377,type,
    v12029: state_type > $o ).

tff(pred_def_6378,type,
    v12068: state_type > $o ).

tff(pred_def_6379,type,
    v12070: state_type > $o ).

tff(pred_def_6380,type,
    v12066: state_type > $o ).

tff(pred_def_6381,type,
    v12065: state_type > $o ).

tff(pred_def_6382,type,
    v12076: state_type > $o ).

tff(pred_def_6383,type,
    v12077: state_type > $o ).

tff(pred_def_6384,type,
    v12073: state_type > $o ).

tff(pred_def_6385,type,
    v12075: state_type > $o ).

tff(pred_def_6386,type,
    v12083: state_type > $o ).

tff(pred_def_6387,type,
    v12081: state_type > $o ).

tff(pred_def_6388,type,
    v12085: state_type > $o ).

tff(pred_def_6389,type,
    v12023: state_type > $o ).

tff(pred_def_6390,type,
    v12021: state_type > $o ).

tff(pred_def_6391,type,
    v12019: state_type > $o ).

tff(pred_def_6392,type,
    v12092: state_type > $o ).

tff(pred_def_6393,type,
    v12090: state_type > $o ).

tff(pred_def_6394,type,
    v12089: state_type > $o ).

tff(pred_def_6395,type,
    v12088: state_type > $o ).

tff(pred_def_6396,type,
    v12100: state_type > $o ).

tff(pred_def_6397,type,
    v12101: state_type > $o ).

tff(pred_def_6398,type,
    v12099: state_type > $o ).

tff(pred_def_6399,type,
    v12096: ( state_type * $int ) > $o ).

tff(pred_def_6400,type,
    v12098: ( state_type * $int ) > $o ).

tff(pred_def_6401,type,
    v11993: ( state_type * $int ) > $o ).

tff(pred_def_6402,type,
    v11991: ( state_type * $int ) > $o ).

tff(pred_def_6403,type,
    v11989: ( state_type * $int ) > $o ).

tff(pred_def_6404,type,
    v11987: ( state_type * $int ) > $o ).

tff(pred_def_6405,type,
    v11985: ( state_type * $int ) > $o ).

tff(pred_def_6406,type,
    v12123: state_type > $o ).

tff(pred_def_6407,type,
    v12121: state_type > $o ).

tff(pred_def_6408,type,
    v12127: state_type > $o ).

tff(pred_def_6409,type,
    v12125: state_type > $o ).

tff(pred_def_6410,type,
    v12131: state_type > $o ).

tff(pred_def_6411,type,
    v12129: state_type > $o ).

tff(pred_def_6412,type,
    v12134: state_type > $o ).

tff(pred_def_6413,type,
    v12133: state_type > $o ).

tff(pred_def_6414,type,
    v12119: state_type > $o ).

tff(pred_def_6415,type,
    v12117: state_type > $o ).

tff(pred_def_6416,type,
    v12115: state_type > $o ).

tff(pred_def_6417,type,
    v12113: state_type > $o ).

tff(pred_def_6418,type,
    v12111: state_type > $o ).

tff(pred_def_6419,type,
    v12109: state_type > $o ).

tff(pred_def_6420,type,
    v12107: state_type > $o ).

tff(pred_def_6421,type,
    v12105: state_type > $o ).

tff(pred_def_6422,type,
    v12154: state_type > $o ).

tff(pred_def_6423,type,
    v12152: state_type > $o ).

tff(pred_def_6424,type,
    v12150: state_type > $o ).

tff(pred_def_6425,type,
    v12148: state_type > $o ).

tff(pred_def_6426,type,
    v12146: state_type > $o ).

tff(pred_def_6427,type,
    v12164: state_type > $o ).

tff(pred_def_6428,type,
    v12162: state_type > $o ).

tff(pred_def_6429,type,
    v12160: state_type > $o ).

tff(pred_def_6430,type,
    v12158: state_type > $o ).

tff(pred_def_6431,type,
    v12156: state_type > $o ).

tff(pred_def_6432,type,
    v12168: ( state_type * $int ) > $o ).

tff(pred_def_6433,type,
    v12166: ( state_type * $int ) > $o ).

tff(pred_def_6434,type,
    v12178: state_type > $o ).

tff(pred_def_6435,type,
    v12176: state_type > $o ).

tff(pred_def_6436,type,
    v12184: state_type > $o ).

tff(pred_def_6437,type,
    v12182: state_type > $o ).

tff(pred_def_6438,type,
    v12198: state_type > $o ).

tff(pred_def_6439,type,
    v12196: state_type > $o ).

tff(pred_def_6440,type,
    v12202: state_type > $o ).

tff(pred_def_6441,type,
    v12200: state_type > $o ).

tff(pred_def_6442,type,
    v12206: state_type > $o ).

tff(pred_def_6443,type,
    v12204: state_type > $o ).

tff(pred_def_6444,type,
    v12209: state_type > $o ).

tff(pred_def_6445,type,
    v12208: state_type > $o ).

tff(pred_def_6446,type,
    v12194: state_type > $o ).

tff(pred_def_6447,type,
    v12192: state_type > $o ).

tff(pred_def_6448,type,
    v12190: state_type > $o ).

tff(pred_def_6449,type,
    v12188: state_type > $o ).

tff(pred_def_6450,type,
    v12186: state_type > $o ).

tff(pred_def_6451,type,
    v12213: state_type > $o ).

tff(pred_def_6452,type,
    v12211: state_type > $o ).

tff(pred_def_6453,type,
    v12180: state_type > $o ).

tff(pred_def_6454,type,
    v12219: state_type > $o ).

tff(pred_def_6455,type,
    v12221: state_type > $o ).

tff(pred_def_6456,type,
    v12217: state_type > $o ).

tff(pred_def_6457,type,
    v12216: state_type > $o ).

tff(pred_def_6458,type,
    v12227: state_type > $o ).

tff(pred_def_6459,type,
    v12228: state_type > $o ).

tff(pred_def_6460,type,
    v12224: state_type > $o ).

tff(pred_def_6461,type,
    v12226: state_type > $o ).

tff(pred_def_6462,type,
    v12234: state_type > $o ).

tff(pred_def_6463,type,
    v12232: state_type > $o ).

tff(pred_def_6464,type,
    v12236: state_type > $o ).

tff(pred_def_6465,type,
    v12174: state_type > $o ).

tff(pred_def_6466,type,
    v12172: state_type > $o ).

tff(pred_def_6467,type,
    v12170: state_type > $o ).

tff(pred_def_6468,type,
    v12243: state_type > $o ).

tff(pred_def_6469,type,
    v12241: state_type > $o ).

tff(pred_def_6470,type,
    v12240: state_type > $o ).

tff(pred_def_6471,type,
    v12239: state_type > $o ).

tff(pred_def_6472,type,
    v12251: state_type > $o ).

tff(pred_def_6473,type,
    v12252: state_type > $o ).

tff(pred_def_6474,type,
    v12250: state_type > $o ).

tff(pred_def_6475,type,
    v12247: ( state_type * $int ) > $o ).

tff(pred_def_6476,type,
    v12249: ( state_type * $int ) > $o ).

tff(pred_def_6477,type,
    v12144: ( state_type * $int ) > $o ).

tff(pred_def_6478,type,
    v12142: ( state_type * $int ) > $o ).

tff(pred_def_6479,type,
    v12140: ( state_type * $int ) > $o ).

tff(pred_def_6480,type,
    v12138: ( state_type * $int ) > $o ).

tff(pred_def_6481,type,
    v12136: ( state_type * $int ) > $o ).

tff(pred_def_6482,type,
    v12274: state_type > $o ).

tff(pred_def_6483,type,
    v12272: state_type > $o ).

tff(pred_def_6484,type,
    v12278: state_type > $o ).

tff(pred_def_6485,type,
    v12276: state_type > $o ).

tff(pred_def_6486,type,
    v12282: state_type > $o ).

tff(pred_def_6487,type,
    v12280: state_type > $o ).

tff(pred_def_6488,type,
    v12285: state_type > $o ).

tff(pred_def_6489,type,
    v12284: state_type > $o ).

tff(pred_def_6490,type,
    v12270: state_type > $o ).

tff(pred_def_6491,type,
    v12268: state_type > $o ).

tff(pred_def_6492,type,
    v12266: state_type > $o ).

tff(pred_def_6493,type,
    v12264: state_type > $o ).

tff(pred_def_6494,type,
    v12262: state_type > $o ).

tff(pred_def_6495,type,
    v12260: state_type > $o ).

tff(pred_def_6496,type,
    v12258: state_type > $o ).

tff(pred_def_6497,type,
    v12256: state_type > $o ).

tff(pred_def_6498,type,
    v12305: state_type > $o ).

tff(pred_def_6499,type,
    v12303: state_type > $o ).

tff(pred_def_6500,type,
    v12301: state_type > $o ).

tff(pred_def_6501,type,
    v12299: state_type > $o ).

tff(pred_def_6502,type,
    v12297: state_type > $o ).

tff(pred_def_6503,type,
    v12315: state_type > $o ).

tff(pred_def_6504,type,
    v12313: state_type > $o ).

tff(pred_def_6505,type,
    v12311: state_type > $o ).

tff(pred_def_6506,type,
    v12309: state_type > $o ).

tff(pred_def_6507,type,
    v12307: state_type > $o ).

tff(pred_def_6508,type,
    v12319: ( state_type * $int ) > $o ).

tff(pred_def_6509,type,
    v12317: ( state_type * $int ) > $o ).

tff(pred_def_6510,type,
    v12329: state_type > $o ).

tff(pred_def_6511,type,
    v12327: state_type > $o ).

tff(pred_def_6512,type,
    v12335: state_type > $o ).

tff(pred_def_6513,type,
    v12333: state_type > $o ).

tff(pred_def_6514,type,
    v12349: state_type > $o ).

tff(pred_def_6515,type,
    v12347: state_type > $o ).

tff(pred_def_6516,type,
    v12353: state_type > $o ).

tff(pred_def_6517,type,
    v12351: state_type > $o ).

tff(pred_def_6518,type,
    v12357: state_type > $o ).

tff(pred_def_6519,type,
    v12355: state_type > $o ).

tff(pred_def_6520,type,
    v12360: state_type > $o ).

tff(pred_def_6521,type,
    v12359: state_type > $o ).

tff(pred_def_6522,type,
    v12345: state_type > $o ).

tff(pred_def_6523,type,
    v12343: state_type > $o ).

tff(pred_def_6524,type,
    v12341: state_type > $o ).

tff(pred_def_6525,type,
    v12339: state_type > $o ).

tff(pred_def_6526,type,
    v12337: state_type > $o ).

tff(pred_def_6527,type,
    v12364: state_type > $o ).

tff(pred_def_6528,type,
    v12362: state_type > $o ).

tff(pred_def_6529,type,
    v12331: state_type > $o ).

tff(pred_def_6530,type,
    v12370: state_type > $o ).

tff(pred_def_6531,type,
    v12372: state_type > $o ).

tff(pred_def_6532,type,
    v12368: state_type > $o ).

tff(pred_def_6533,type,
    v12367: state_type > $o ).

tff(pred_def_6534,type,
    v12378: state_type > $o ).

tff(pred_def_6535,type,
    v12379: state_type > $o ).

tff(pred_def_6536,type,
    v12375: state_type > $o ).

tff(pred_def_6537,type,
    v12377: state_type > $o ).

tff(pred_def_6538,type,
    v12385: state_type > $o ).

tff(pred_def_6539,type,
    v12383: state_type > $o ).

tff(pred_def_6540,type,
    v12387: state_type > $o ).

tff(pred_def_6541,type,
    v12325: state_type > $o ).

tff(pred_def_6542,type,
    v12323: state_type > $o ).

tff(pred_def_6543,type,
    v12321: state_type > $o ).

tff(pred_def_6544,type,
    v12394: state_type > $o ).

tff(pred_def_6545,type,
    v12392: state_type > $o ).

tff(pred_def_6546,type,
    v12391: state_type > $o ).

tff(pred_def_6547,type,
    v12390: state_type > $o ).

tff(pred_def_6548,type,
    v12402: state_type > $o ).

tff(pred_def_6549,type,
    v12403: state_type > $o ).

tff(pred_def_6550,type,
    v12401: state_type > $o ).

tff(pred_def_6551,type,
    v12398: ( state_type * $int ) > $o ).

tff(pred_def_6552,type,
    v12400: ( state_type * $int ) > $o ).

tff(pred_def_6553,type,
    v12295: ( state_type * $int ) > $o ).

tff(pred_def_6554,type,
    v12293: ( state_type * $int ) > $o ).

tff(pred_def_6555,type,
    v12291: ( state_type * $int ) > $o ).

tff(pred_def_6556,type,
    v12289: ( state_type * $int ) > $o ).

tff(pred_def_6557,type,
    v12287: ( state_type * $int ) > $o ).

tff(pred_def_6558,type,
    v12425: state_type > $o ).

tff(pred_def_6559,type,
    v12423: state_type > $o ).

tff(pred_def_6560,type,
    v12429: state_type > $o ).

tff(pred_def_6561,type,
    v12427: state_type > $o ).

tff(pred_def_6562,type,
    v12433: state_type > $o ).

tff(pred_def_6563,type,
    v12431: state_type > $o ).

tff(pred_def_6564,type,
    v12436: state_type > $o ).

tff(pred_def_6565,type,
    v12435: state_type > $o ).

tff(pred_def_6566,type,
    v12421: state_type > $o ).

tff(pred_def_6567,type,
    v12419: state_type > $o ).

tff(pred_def_6568,type,
    v12417: state_type > $o ).

tff(pred_def_6569,type,
    v12415: state_type > $o ).

tff(pred_def_6570,type,
    v12413: state_type > $o ).

tff(pred_def_6571,type,
    v12411: state_type > $o ).

tff(pred_def_6572,type,
    v12409: state_type > $o ).

tff(pred_def_6573,type,
    v12407: state_type > $o ).

tff(pred_def_6574,type,
    v12456: state_type > $o ).

tff(pred_def_6575,type,
    v12454: state_type > $o ).

tff(pred_def_6576,type,
    v12452: state_type > $o ).

tff(pred_def_6577,type,
    v12450: state_type > $o ).

tff(pred_def_6578,type,
    v12448: state_type > $o ).

tff(pred_def_6579,type,
    v12466: state_type > $o ).

tff(pred_def_6580,type,
    v12464: state_type > $o ).

tff(pred_def_6581,type,
    v12462: state_type > $o ).

tff(pred_def_6582,type,
    v12460: state_type > $o ).

tff(pred_def_6583,type,
    v12458: state_type > $o ).

tff(pred_def_6584,type,
    v12470: ( state_type * $int ) > $o ).

tff(pred_def_6585,type,
    v12468: ( state_type * $int ) > $o ).

tff(pred_def_6586,type,
    v12480: state_type > $o ).

tff(pred_def_6587,type,
    v12478: state_type > $o ).

tff(pred_def_6588,type,
    v12486: state_type > $o ).

tff(pred_def_6589,type,
    v12484: state_type > $o ).

tff(pred_def_6590,type,
    v12499: state_type > $o ).

tff(pred_def_6591,type,
    v12497: state_type > $o ).

tff(pred_def_6592,type,
    v12503: state_type > $o ).

tff(pred_def_6593,type,
    v12501: state_type > $o ).

tff(pred_def_6594,type,
    v12507: state_type > $o ).

tff(pred_def_6595,type,
    v12505: state_type > $o ).

tff(pred_def_6596,type,
    v12510: state_type > $o ).

tff(pred_def_6597,type,
    v12509: state_type > $o ).

tff(pred_def_6598,type,
    v12495: state_type > $o ).

tff(pred_def_6599,type,
    v12493: state_type > $o ).

tff(pred_def_6600,type,
    v12490: state_type > $o ).

tff(pred_def_6601,type,
    v12488: state_type > $o ).

tff(pred_def_6602,type,
    v12514: state_type > $o ).

tff(pred_def_6603,type,
    v12512: state_type > $o ).

tff(pred_def_6604,type,
    v12482: state_type > $o ).

tff(pred_def_6605,type,
    v12520: state_type > $o ).

tff(pred_def_6606,type,
    v12522: state_type > $o ).

tff(pred_def_6607,type,
    v12518: state_type > $o ).

tff(pred_def_6608,type,
    v12517: state_type > $o ).

tff(pred_def_6609,type,
    v12528: state_type > $o ).

tff(pred_def_6610,type,
    v12529: state_type > $o ).

tff(pred_def_6611,type,
    v12525: state_type > $o ).

tff(pred_def_6612,type,
    v12527: state_type > $o ).

tff(pred_def_6613,type,
    v12535: state_type > $o ).

tff(pred_def_6614,type,
    v12533: state_type > $o ).

tff(pred_def_6615,type,
    v12537: state_type > $o ).

tff(pred_def_6616,type,
    v12476: state_type > $o ).

tff(pred_def_6617,type,
    v12474: state_type > $o ).

tff(pred_def_6618,type,
    v12472: state_type > $o ).

tff(pred_def_6619,type,
    v12544: state_type > $o ).

tff(pred_def_6620,type,
    v12542: state_type > $o ).

tff(pred_def_6621,type,
    v12541: state_type > $o ).

tff(pred_def_6622,type,
    v12540: state_type > $o ).

tff(pred_def_6623,type,
    v12552: state_type > $o ).

tff(pred_def_6624,type,
    v12553: state_type > $o ).

tff(pred_def_6625,type,
    v12551: state_type > $o ).

tff(pred_def_6626,type,
    v12548: ( state_type * $int ) > $o ).

tff(pred_def_6627,type,
    v12550: ( state_type * $int ) > $o ).

tff(pred_def_6628,type,
    v12446: ( state_type * $int ) > $o ).

tff(pred_def_6629,type,
    v12444: ( state_type * $int ) > $o ).

tff(pred_def_6630,type,
    v12442: ( state_type * $int ) > $o ).

tff(pred_def_6631,type,
    v12440: ( state_type * $int ) > $o ).

tff(pred_def_6632,type,
    v12438: ( state_type * $int ) > $o ).

tff(pred_def_6633,type,
    v12565: state_type > $o ).

tff(pred_def_6634,type,
    v12563: state_type > $o ).

tff(pred_def_6635,type,
    v12561: state_type > $o ).

tff(pred_def_6636,type,
    v12559: state_type > $o ).

tff(pred_def_6637,type,
    v12557: state_type > $o ).

tff(pred_def_6638,type,
    v12573: state_type > $o ).

tff(pred_def_6639,type,
    v12572: ( state_type * $int ) > $o ).

tff(pred_def_6640,type,
    v12571: ( state_type * $int ) > $o ).

tff(pred_def_6641,type,
    v12576: state_type > $o ).

tff(pred_def_6642,type,
    v12575: ( state_type * $int ) > $o ).

tff(pred_def_6643,type,
    v12574: ( state_type * $int ) > $o ).

tff(pred_def_6644,type,
    v12570: ( state_type * $int ) > $o ).

tff(pred_def_6645,type,
    v12579: state_type > $o ).

tff(pred_def_6646,type,
    v12578: ( state_type * $int ) > $o ).

tff(pred_def_6647,type,
    v12577: ( state_type * $int ) > $o ).

tff(pred_def_6648,type,
    v12569: ( state_type * $int ) > $o ).

tff(pred_def_6649,type,
    v12582: state_type > $o ).

tff(pred_def_6650,type,
    v12581: ( state_type * $int ) > $o ).

tff(pred_def_6651,type,
    v12580: ( state_type * $int ) > $o ).

tff(pred_def_6652,type,
    v12568: ( state_type * $int ) > $o ).

tff(pred_def_6653,type,
    v12585: state_type > $o ).

tff(pred_def_6654,type,
    v12584: ( state_type * $int ) > $o ).

tff(pred_def_6655,type,
    v12583: ( state_type * $int ) > $o ).

tff(pred_def_6656,type,
    v12567: ( state_type * $int ) > $o ).

tff(pred_def_6657,type,
    v12588: state_type > $o ).

tff(pred_def_6658,type,
    v12587: ( state_type * $int ) > $o ).

tff(pred_def_6659,type,
    v12586: ( state_type * $int ) > $o ).

tff(pred_def_6660,type,
    v11059: ( state_type * $int ) > $o ).

tff(pred_def_6661,type,
    v11057: ( state_type * $int ) > $o ).

tff(pred_def_6662,type,
    v11055: ( state_type * $int ) > $o ).

tff(pred_def_6663,type,
    v11053: ( state_type * $int ) > $o ).

tff(pred_def_6664,type,
    v11051: ( state_type * $int ) > $o ).

tff(pred_def_6665,type,
    v11045: state_type > $o ).

tff(pred_def_6666,type,
    v11043: state_type > $o ).

tff(pred_def_6667,type,
    v11041: state_type > $o ).

tff(pred_def_6668,type,
    v12599: ( state_type * $int ) > $o ).

tff(pred_def_6669,type,
    v12597: ( state_type * $int ) > $o ).

tff(pred_def_6670,type,
    v12633: state_type > $o ).

tff(pred_def_6671,type,
    v12631: state_type > $o ).

tff(pred_def_6672,type,
    v12629: state_type > $o ).

tff(pred_def_6673,type,
    v12627: state_type > $o ).

tff(pred_def_6674,type,
    v12625: state_type > $o ).

tff(pred_def_6675,type,
    v12623: state_type > $o ).

tff(pred_def_6676,type,
    v12621: state_type > $o ).

tff(pred_def_6677,type,
    v12647: state_type > $o ).

tff(pred_def_6678,type,
    v12645: state_type > $o ).

tff(pred_def_6679,type,
    v12643: state_type > $o ).

tff(pred_def_6680,type,
    v12641: state_type > $o ).

tff(pred_def_6681,type,
    v12639: state_type > $o ).

tff(pred_def_6682,type,
    v12637: state_type > $o ).

tff(pred_def_6683,type,
    v12635: state_type > $o ).

tff(pred_def_6684,type,
    v12673: state_type > $o ).

tff(pred_def_6685,type,
    v12675: state_type > $o ).

tff(pred_def_6686,type,
    v12674: ( state_type * $int ) > $o ).

tff(pred_def_6687,type,
    v12676: state_type > $o ).

tff(pred_def_6688,type,
    v12671: ( state_type * $int ) > $o ).

tff(pred_def_6689,type,
    v12669: ( state_type * $int ) > $o ).

tff(pred_def_6690,type,
    v12677: ( state_type * $int ) > $o ).

tff(pred_def_6691,type,
    v12667: ( state_type * $int ) > $o ).

tff(pred_def_6692,type,
    v12665: ( state_type * $int ) > $o ).

tff(pred_def_6693,type,
    v12663: state_type > $o ).

tff(pred_def_6694,type,
    v12679: state_type > $o ).

tff(pred_def_6695,type,
    v12661: ( state_type * $int ) > $o ).

tff(pred_def_6696,type,
    v12659: ( state_type * $int ) > $o ).

tff(pred_def_6697,type,
    v12693: ( state_type * $int ) > $o ).

tff(pred_def_6698,type,
    v12691: ( state_type * $int ) > $o ).

tff(pred_def_6699,type,
    v12697: state_type > $o ).

tff(pred_def_6700,type,
    v12695: state_type > $o ).

tff(pred_def_6701,type,
    v12721: state_type > $o ).

tff(pred_def_6702,type,
    v12719: state_type > $o ).

tff(pred_def_6703,type,
    v12717: state_type > $o ).

tff(pred_def_6704,type,
    v12715: state_type > $o ).

tff(pred_def_6705,type,
    v12713: state_type > $o ).

tff(pred_def_6706,type,
    v12711: state_type > $o ).

tff(pred_def_6707,type,
    v12709: state_type > $o ).

tff(pred_def_6708,type,
    v12735: state_type > $o ).

tff(pred_def_6709,type,
    v12733: state_type > $o ).

tff(pred_def_6710,type,
    v12731: state_type > $o ).

tff(pred_def_6711,type,
    v12729: state_type > $o ).

tff(pred_def_6712,type,
    v12727: state_type > $o ).

tff(pred_def_6713,type,
    v12725: state_type > $o ).

tff(pred_def_6714,type,
    v12723: state_type > $o ).

tff(pred_def_6715,type,
    v12751: ( state_type * $int ) > $o ).

tff(pred_def_6716,type,
    v12749: ( state_type * $int ) > $o ).

tff(pred_def_6717,type,
    v12747: ( state_type * $int ) > $o ).

tff(pred_def_6718,type,
    v12745: ( state_type * $int ) > $o ).

tff(pred_def_6719,type,
    v12743: ( state_type * $int ) > $o ).

tff(pred_def_6720,type,
    v12781: ( state_type * $int ) > $o ).

tff(pred_def_6721,type,
    v12783: ( state_type * $int ) > $o ).

tff(pred_def_6722,type,
    v12779: ( state_type * $int ) > $o ).

tff(pred_def_6723,type,
    v12777: ( state_type * $int ) > $o ).

tff(pred_def_6724,type,
    v12775: ( state_type * $int ) > $o ).

tff(pred_def_6725,type,
    v12773: ( state_type * $int ) > $o ).

tff(pred_def_6726,type,
    v12771: state_type > $o ).

tff(pred_def_6727,type,
    v12769: state_type > $o ).

tff(pred_def_6728,type,
    v12787: state_type > $o ).

tff(pred_def_6729,type,
    v12785: state_type > $o ).

tff(pred_def_6730,type,
    v12789: state_type > $o ).

tff(pred_def_6731,type,
    v12767: state_type > $o ).

tff(pred_def_6732,type,
    v12765: state_type > $o ).

tff(pred_def_6733,type,
    v12763: state_type > $o ).

tff(pred_def_6734,type,
    v12761: state_type > $o ).

tff(pred_def_6735,type,
    v12759: state_type > $o ).

tff(pred_def_6736,type,
    v12757: state_type > $o ).

tff(pred_def_6737,type,
    v12755: state_type > $o ).

tff(pred_def_6738,type,
    v12753: state_type > $o ).

tff(pred_def_6739,type,
    v12799: ( state_type * $int ) > $o ).

tff(pred_def_6740,type,
    v12797: ( state_type * $int ) > $o ).

tff(pred_def_6741,type,
    v12795: ( state_type * $int ) > $o ).

tff(pred_def_6742,type,
    v12793: ( state_type * $int ) > $o ).

tff(pred_def_6743,type,
    v12791: ( state_type * $int ) > $o ).

tff(pred_def_6744,type,
    v12829: ( state_type * $int ) > $o ).

tff(pred_def_6745,type,
    v12827: ( state_type * $int ) > $o ).

tff(pred_def_6746,type,
    v12830: ( state_type * $int ) > $o ).

tff(pred_def_6747,type,
    v12825: ( state_type * $int ) > $o ).

tff(pred_def_6748,type,
    v12823: ( state_type * $int ) > $o ).

tff(pred_def_6749,type,
    v12821: ( state_type * $int ) > $o ).

tff(pred_def_6750,type,
    v12819: state_type > $o ).

tff(pred_def_6751,type,
    v12817: state_type > $o ).

tff(pred_def_6752,type,
    v12834: state_type > $o ).

tff(pred_def_6753,type,
    v12832: state_type > $o ).

tff(pred_def_6754,type,
    v12836: state_type > $o ).

tff(pred_def_6755,type,
    v12815: state_type > $o ).

tff(pred_def_6756,type,
    v12813: state_type > $o ).

tff(pred_def_6757,type,
    v12811: state_type > $o ).

tff(pred_def_6758,type,
    v12809: state_type > $o ).

tff(pred_def_6759,type,
    v12807: state_type > $o ).

tff(pred_def_6760,type,
    v12805: state_type > $o ).

tff(pred_def_6761,type,
    v12803: state_type > $o ).

tff(pred_def_6762,type,
    v12801: state_type > $o ).

tff(pred_def_6763,type,
    v12846: ( state_type * $int ) > $o ).

tff(pred_def_6764,type,
    v12844: ( state_type * $int ) > $o ).

tff(pred_def_6765,type,
    v12842: ( state_type * $int ) > $o ).

tff(pred_def_6766,type,
    v12840: ( state_type * $int ) > $o ).

tff(pred_def_6767,type,
    v12838: ( state_type * $int ) > $o ).

tff(pred_def_6768,type,
    v12866: state_type > $o ).

tff(pred_def_6769,type,
    v12864: state_type > $o ).

tff(pred_def_6770,type,
    v12870: state_type > $o ).

tff(pred_def_6771,type,
    v12868: state_type > $o ).

tff(pred_def_6772,type,
    v12872: state_type > $o ).

tff(pred_def_6773,type,
    v12862: state_type > $o ).

tff(pred_def_6774,type,
    v12860: state_type > $o ).

tff(pred_def_6775,type,
    v12858: state_type > $o ).

tff(pred_def_6776,type,
    v12856: state_type > $o ).

tff(pred_def_6777,type,
    v12854: state_type > $o ).

tff(pred_def_6778,type,
    v12852: state_type > $o ).

tff(pred_def_6779,type,
    v12850: state_type > $o ).

tff(pred_def_6780,type,
    v12848: state_type > $o ).

tff(pred_def_6781,type,
    v12882: ( state_type * $int ) > $o ).

tff(pred_def_6782,type,
    v12880: ( state_type * $int ) > $o ).

tff(pred_def_6783,type,
    v12878: ( state_type * $int ) > $o ).

tff(pred_def_6784,type,
    v12876: ( state_type * $int ) > $o ).

tff(pred_def_6785,type,
    v12874: ( state_type * $int ) > $o ).

tff(pred_def_6786,type,
    v12902: state_type > $o ).

tff(pred_def_6787,type,
    v12900: state_type > $o ).

tff(pred_def_6788,type,
    v12906: state_type > $o ).

tff(pred_def_6789,type,
    v12904: state_type > $o ).

tff(pred_def_6790,type,
    v12908: state_type > $o ).

tff(pred_def_6791,type,
    v12898: state_type > $o ).

tff(pred_def_6792,type,
    v12896: state_type > $o ).

tff(pred_def_6793,type,
    v12894: state_type > $o ).

tff(pred_def_6794,type,
    v12892: state_type > $o ).

tff(pred_def_6795,type,
    v12890: state_type > $o ).

tff(pred_def_6796,type,
    v12888: state_type > $o ).

tff(pred_def_6797,type,
    v12886: state_type > $o ).

tff(pred_def_6798,type,
    v12884: state_type > $o ).

tff(pred_def_6799,type,
    v12914: state_type > $o ).

tff(pred_def_6800,type,
    v12913: ( state_type * $int ) > $o ).

tff(pred_def_6801,type,
    v12912: ( state_type * $int ) > $o ).

tff(pred_def_6802,type,
    v12917: state_type > $o ).

tff(pred_def_6803,type,
    v12916: ( state_type * $int ) > $o ).

tff(pred_def_6804,type,
    v12915: ( state_type * $int ) > $o ).

tff(pred_def_6805,type,
    v12911: ( state_type * $int ) > $o ).

tff(pred_def_6806,type,
    v12920: state_type > $o ).

tff(pred_def_6807,type,
    v12919: ( state_type * $int ) > $o ).

tff(pred_def_6808,type,
    v12918: ( state_type * $int ) > $o ).

tff(pred_def_6809,type,
    v12910: ( state_type * $int ) > $o ).

tff(pred_def_6810,type,
    v12923: state_type > $o ).

tff(pred_def_6811,type,
    v12922: ( state_type * $int ) > $o ).

tff(pred_def_6812,type,
    v12921: ( state_type * $int ) > $o ).

tff(pred_def_6813,type,
    v12741: ( state_type * $int ) > $o ).

tff(pred_def_6814,type,
    v12739: ( state_type * $int ) > $o ).

tff(pred_def_6815,type,
    v12737: ( state_type * $int ) > $o ).

tff(pred_def_6816,type,
    v12935: state_type > $o ).

tff(pred_def_6817,type,
    v12933: state_type > $o ).

tff(pred_def_6818,type,
    v12931: state_type > $o ).

tff(pred_def_6819,type,
    v12945: state_type > $o ).

tff(pred_def_6820,type,
    v12943: state_type > $o ).

tff(pred_def_6821,type,
    v12941: state_type > $o ).

tff(pred_def_6822,type,
    v12939: state_type > $o ).

tff(pred_def_6823,type,
    v12937: state_type > $o ).

tff(pred_def_6824,type,
    v12947: state_type > $o ).

tff(pred_def_6825,type,
    v12929: state_type > $o ).

tff(pred_def_6826,type,
    v12927: state_type > $o ).

tff(pred_def_6827,type,
    v12925: state_type > $o ).

tff(pred_def_6828,type,
    v12954: state_type > $o ).

tff(pred_def_6829,type,
    v12952: state_type > $o ).

tff(pred_def_6830,type,
    v12951: state_type > $o ).

tff(pred_def_6831,type,
    v12950: state_type > $o ).

tff(pred_def_6832,type,
    v12962: state_type > $o ).

tff(pred_def_6833,type,
    v12963: state_type > $o ).

tff(pred_def_6834,type,
    v12961: state_type > $o ).

tff(pred_def_6835,type,
    v12958: ( state_type * $int ) > $o ).

tff(pred_def_6836,type,
    v12960: ( state_type * $int ) > $o ).

tff(pred_def_6837,type,
    v12707: ( state_type * $int ) > $o ).

tff(pred_def_6838,type,
    v12705: ( state_type * $int ) > $o ).

tff(pred_def_6839,type,
    v12703: ( state_type * $int ) > $o ).

tff(pred_def_6840,type,
    v12701: ( state_type * $int ) > $o ).

tff(pred_def_6841,type,
    v12699: ( state_type * $int ) > $o ).

tff(pred_def_6842,type,
    v12969: state_type > $o ).

tff(pred_def_6843,type,
    v12967: state_type > $o ).

tff(pred_def_6844,type,
    v12973: state_type > $o ).

tff(pred_def_6845,type,
    v12972: ( state_type * $int ) > $o ).

tff(pred_def_6846,type,
    v12971: ( state_type * $int ) > $o ).

tff(pred_def_6847,type,
    v12976: state_type > $o ).

tff(pred_def_6848,type,
    v12975: ( state_type * $int ) > $o ).

tff(pred_def_6849,type,
    v12974: ( state_type * $int ) > $o ).

tff(pred_def_6850,type,
    v12689: ( state_type * $int ) > $o ).

tff(pred_def_6851,type,
    v12687: ( state_type * $int ) > $o ).

tff(pred_def_6852,type,
    v12685: ( state_type * $int ) > $o ).

tff(pred_def_6853,type,
    v12683: ( state_type * $int ) > $o ).

tff(pred_def_6854,type,
    v12681: ( state_type * $int ) > $o ).

tff(pred_def_6855,type,
    v12657: ( state_type * $int ) > $o ).

tff(pred_def_6856,type,
    v12655: ( state_type * $int ) > $o ).

tff(pred_def_6857,type,
    v12653: ( state_type * $int ) > $o ).

tff(pred_def_6858,type,
    v12651: ( state_type * $int ) > $o ).

tff(pred_def_6859,type,
    v12649: ( state_type * $int ) > $o ).

tff(pred_def_6860,type,
    v12989: state_type > $o ).

tff(pred_def_6861,type,
    v12987: state_type > $o ).

tff(pred_def_6862,type,
    v12985: state_type > $o ).

tff(pred_def_6863,type,
    v12995: state_type > $o ).

tff(pred_def_6864,type,
    v12993: state_type > $o ).

tff(pred_def_6865,type,
    v13013: ( state_type * $int ) > $o ).

tff(pred_def_6866,type,
    v13015: ( state_type * $int ) > $o ).

tff(pred_def_6867,type,
    v13011: ( state_type * $int ) > $o ).

tff(pred_def_6868,type,
    v13009: state_type > $o ).

tff(pred_def_6869,type,
    v13007: state_type > $o ).

tff(pred_def_6870,type,
    v13019: state_type > $o ).

tff(pred_def_6871,type,
    v13017: state_type > $o ).

tff(pred_def_6872,type,
    v13023: state_type > $o ).

tff(pred_def_6873,type,
    v13021: state_type > $o ).

tff(pred_def_6874,type,
    v13026: state_type > $o ).

tff(pred_def_6875,type,
    v13025: state_type > $o ).

tff(pred_def_6876,type,
    v13005: state_type > $o ).

tff(pred_def_6877,type,
    v13003: state_type > $o ).

tff(pred_def_6878,type,
    v13001: state_type > $o ).

tff(pred_def_6879,type,
    v12999: state_type > $o ).

tff(pred_def_6880,type,
    v12997: state_type > $o ).

tff(pred_def_6881,type,
    v13034: state_type > $o ).

tff(pred_def_6882,type,
    v13032: state_type > $o ).

tff(pred_def_6883,type,
    v13030: state_type > $o ).

tff(pred_def_6884,type,
    v13028: state_type > $o ).

tff(pred_def_6885,type,
    v12991: state_type > $o ).

tff(pred_def_6886,type,
    v13040: state_type > $o ).

tff(pred_def_6887,type,
    v13042: state_type > $o ).

tff(pred_def_6888,type,
    v13038: state_type > $o ).

tff(pred_def_6889,type,
    v13037: state_type > $o ).

tff(pred_def_6890,type,
    v13048: state_type > $o ).

tff(pred_def_6891,type,
    v13049: state_type > $o ).

tff(pred_def_6892,type,
    v13045: state_type > $o ).

tff(pred_def_6893,type,
    v13047: state_type > $o ).

tff(pred_def_6894,type,
    v13059: state_type > $o ).

tff(pred_def_6895,type,
    v13057: state_type > $o ).

tff(pred_def_6896,type,
    v13055: state_type > $o ).

tff(pred_def_6897,type,
    v13053: state_type > $o ).

tff(pred_def_6898,type,
    v13061: state_type > $o ).

tff(pred_def_6899,type,
    v12983: state_type > $o ).

tff(pred_def_6900,type,
    v12981: state_type > $o ).

tff(pred_def_6901,type,
    v12979: state_type > $o ).

tff(pred_def_6902,type,
    v13068: state_type > $o ).

tff(pred_def_6903,type,
    v13066: state_type > $o ).

tff(pred_def_6904,type,
    v13065: state_type > $o ).

tff(pred_def_6905,type,
    v13064: state_type > $o ).

tff(pred_def_6906,type,
    v13076: state_type > $o ).

tff(pred_def_6907,type,
    v13077: state_type > $o ).

tff(pred_def_6908,type,
    v13075: state_type > $o ).

tff(pred_def_6909,type,
    v13072: ( state_type * $int ) > $o ).

tff(pred_def_6910,type,
    v13074: ( state_type * $int ) > $o ).

tff(pred_def_6911,type,
    v12619: ( state_type * $int ) > $o ).

tff(pred_def_6912,type,
    v12617: ( state_type * $int ) > $o ).

tff(pred_def_6913,type,
    v12615: ( state_type * $int ) > $o ).

tff(pred_def_6914,type,
    v12613: ( state_type * $int ) > $o ).

tff(pred_def_6915,type,
    v12611: ( state_type * $int ) > $o ).

tff(pred_def_6916,type,
    v13113: state_type > $o ).

tff(pred_def_6917,type,
    v13111: state_type > $o ).

tff(pred_def_6918,type,
    v13109: state_type > $o ).

tff(pred_def_6919,type,
    v13107: state_type > $o ).

tff(pred_def_6920,type,
    v13105: state_type > $o ).

tff(pred_def_6921,type,
    v13103: state_type > $o ).

tff(pred_def_6922,type,
    v13123: state_type > $o ).

tff(pred_def_6923,type,
    v13121: state_type > $o ).

tff(pred_def_6924,type,
    v13119: state_type > $o ).

tff(pred_def_6925,type,
    v13117: state_type > $o ).

tff(pred_def_6926,type,
    v13115: state_type > $o ).

tff(pred_def_6927,type,
    v13150: state_type > $o ).

tff(pred_def_6928,type,
    v13149: ( state_type * $int ) > $o ).

tff(pred_def_6929,type,
    v13148: ( state_type * $int ) > $o ).

tff(pred_def_6930,type,
    v13146: ( state_type * $int ) > $o ).

tff(pred_def_6931,type,
    v13166: state_type > $o ).

tff(pred_def_6932,type,
    v13167: ( state_type * $int ) > $o ).

tff(pred_def_6933,type,
    v13168: state_type > $o ).

tff(pred_def_6934,type,
    v13164: ( state_type * $int ) > $o ).

tff(pred_def_6935,type,
    v13162: ( state_type * $int ) > $o ).

tff(pred_def_6936,type,
    v13192: ( state_type * $int ) > $o ).

tff(pred_def_6937,type,
    v13101: ( state_type * $int ) > $o ).

tff(pred_def_6938,type,
    v13190: ( state_type * $int ) > $o ).

tff(pred_def_6939,type,
    v13193: ( state_type * $int ) > $o ).

tff(pred_def_6940,type,
    v13188: ( state_type * $int ) > $o ).

tff(pred_def_6941,type,
    v13186: ( state_type * $int ) > $o ).

tff(pred_def_6942,type,
    v13184: ( state_type * $int ) > $o ).

tff(pred_def_6943,type,
    v13182: state_type > $o ).

tff(pred_def_6944,type,
    v13180: state_type > $o ).

tff(pred_def_6945,type,
    v13199: state_type > $o ).

tff(pred_def_6946,type,
    v13139: state_type > $o ).

tff(pred_def_6947,type,
    v13198: ( state_type * $int ) > $o ).

tff(pred_def_6948,type,
    v13137: ( state_type * $int ) > $o ).

tff(pred_def_6949,type,
    v13135: ( state_type * $int ) > $o ).

tff(pred_def_6950,type,
    v13214: ( state_type * $int ) > $o ).

tff(pred_def_6951,type,
    v13213: ( state_type * $int ) > $o ).

tff(pred_def_6952,type,
    v13211: ( state_type * $int ) > $o ).

tff(pred_def_6953,type,
    v13218: state_type > $o ).

tff(pred_def_6954,type,
    v13216: state_type > $o ).

tff(pred_def_6955,type,
    v13229: ( state_type * $int ) > $o ).

tff(pred_def_6956,type,
    v13228: state_type > $o ).

tff(pred_def_6957,type,
    v13232: state_type > $o ).

tff(pred_def_6958,type,
    v13233: state_type > $o ).

tff(pred_def_6959,type,
    v13231: state_type > $o ).

tff(pred_def_6960,type,
    v13234: state_type > $o ).

tff(pred_def_6961,type,
    v13230: state_type > $o ).

tff(pred_def_6962,type,
    v13227: state_type > $o ).

tff(pred_def_6963,type,
    v13235: state_type > $o ).

tff(pred_def_6964,type,
    v13226: state_type > $o ).

tff(pred_def_6965,type,
    v13238: state_type > $o ).

tff(pred_def_6966,type,
    v13239: state_type > $o ).

tff(pred_def_6967,type,
    v13237: state_type > $o ).

tff(pred_def_6968,type,
    v13240: state_type > $o ).

tff(pred_def_6969,type,
    v13236: state_type > $o ).

tff(pred_def_6970,type,
    v13225: state_type > $o ).

tff(pred_def_6971,type,
    v13241: state_type > $o ).

tff(pred_def_6972,type,
    v13224: state_type > $o ).

tff(pred_def_6973,type,
    v13223: state_type > $o ).

tff(pred_def_6974,type,
    v13245: state_type > $o ).

tff(pred_def_6975,type,
    v13246: state_type > $o ).

tff(pred_def_6976,type,
    v13244: state_type > $o ).

tff(pred_def_6977,type,
    v13247: state_type > $o ).

tff(pred_def_6978,type,
    v13243: state_type > $o ).

tff(pred_def_6979,type,
    v13242: state_type > $o ).

tff(pred_def_6980,type,
    v13222: state_type > $o ).

tff(pred_def_6981,type,
    v13248: state_type > $o ).

tff(pred_def_6982,type,
    v13221: state_type > $o ).

tff(pred_def_6983,type,
    v13251: state_type > $o ).

tff(pred_def_6984,type,
    v13252: state_type > $o ).

tff(pred_def_6985,type,
    v13250: state_type > $o ).

tff(pred_def_6986,type,
    v13253: state_type > $o ).

tff(pred_def_6987,type,
    v13249: state_type > $o ).

tff(pred_def_6988,type,
    v13256: state_type > $o ).

tff(pred_def_6989,type,
    v13257: state_type > $o ).

tff(pred_def_6990,type,
    v13255: state_type > $o ).

tff(pred_def_6991,type,
    v13258: state_type > $o ).

tff(pred_def_6992,type,
    v13254: state_type > $o ).

tff(pred_def_6993,type,
    v13261: state_type > $o ).

tff(pred_def_6994,type,
    v13262: state_type > $o ).

tff(pred_def_6995,type,
    v13260: state_type > $o ).

tff(pred_def_6996,type,
    v13263: state_type > $o ).

tff(pred_def_6997,type,
    v13259: state_type > $o ).

tff(pred_def_6998,type,
    v13219: ( state_type * $int ) > $o ).

tff(pred_def_6999,type,
    v13209: ( state_type * $int ) > $o ).

tff(pred_def_7000,type,
    v13207: ( state_type * $int ) > $o ).

tff(pred_def_7001,type,
    v13205: ( state_type * $int ) > $o ).

tff(pred_def_7002,type,
    v13203: ( state_type * $int ) > $o ).

tff(pred_def_7003,type,
    v13201: ( state_type * $int ) > $o ).

tff(pred_def_7004,type,
    v13264: ( state_type * $int ) > $o ).

tff(pred_def_7005,type,
    v13133: ( state_type * $int ) > $o ).

tff(pred_def_7006,type,
    v13131: ( state_type * $int ) > $o ).

tff(pred_def_7007,type,
    v13129: ( state_type * $int ) > $o ).

tff(pred_def_7008,type,
    v13265: ( state_type * $int ) > $o ).

tff(pred_def_7009,type,
    v13266: ( state_type * $int ) > $o ).

tff(pred_def_7010,type,
    v13127: ( state_type * $int ) > $o ).

tff(pred_def_7011,type,
    v13125: ( state_type * $int ) > $o ).

tff(pred_def_7012,type,
    v13276: state_type > $o ).

tff(pred_def_7013,type,
    v13274: state_type > $o ).

tff(pred_def_7014,type,
    v13282: state_type > $o ).

tff(pred_def_7015,type,
    v13280: state_type > $o ).

tff(pred_def_7016,type,
    v13286: state_type > $o ).

tff(pred_def_7017,type,
    v13284: state_type > $o ).

tff(pred_def_7018,type,
    v13290: state_type > $o ).

tff(pred_def_7019,type,
    v13288: state_type > $o ).

tff(pred_def_7020,type,
    v13278: state_type > $o ).

tff(pred_def_7021,type,
    v13296: state_type > $o ).

tff(pred_def_7022,type,
    v13298: state_type > $o ).

tff(pred_def_7023,type,
    v13294: state_type > $o ).

tff(pred_def_7024,type,
    v13293: state_type > $o ).

tff(pred_def_7025,type,
    v13304: state_type > $o ).

tff(pred_def_7026,type,
    v13305: state_type > $o ).

tff(pred_def_7027,type,
    v13301: state_type > $o ).

tff(pred_def_7028,type,
    v13303: state_type > $o ).

tff(pred_def_7029,type,
    v13311: state_type > $o ).

tff(pred_def_7030,type,
    v13309: state_type > $o ).

tff(pred_def_7031,type,
    v13313: state_type > $o ).

tff(pred_def_7032,type,
    v13272: state_type > $o ).

tff(pred_def_7033,type,
    v13270: state_type > $o ).

tff(pred_def_7034,type,
    v13268: state_type > $o ).

tff(pred_def_7035,type,
    v13320: state_type > $o ).

tff(pred_def_7036,type,
    v13318: state_type > $o ).

tff(pred_def_7037,type,
    v13317: state_type > $o ).

tff(pred_def_7038,type,
    v13316: state_type > $o ).

tff(pred_def_7039,type,
    v13328: state_type > $o ).

tff(pred_def_7040,type,
    v13329: state_type > $o ).

tff(pred_def_7041,type,
    v13327: state_type > $o ).

tff(pred_def_7042,type,
    v13324: ( state_type * $int ) > $o ).

tff(pred_def_7043,type,
    v13326: ( state_type * $int ) > $o ).

tff(pred_def_7044,type,
    v13315: ( state_type * $int ) > $o ).

tff(pred_def_7045,type,
    v13197: state_type > $o ).

tff(pred_def_7046,type,
    v13195: state_type > $o ).

tff(pred_def_7047,type,
    v13341: state_type > $o ).

tff(pred_def_7048,type,
    v13339: state_type > $o ).

tff(pred_def_7049,type,
    v13338: state_type > $o ).

tff(pred_def_7050,type,
    v13337: ( state_type * $int ) > $o ).

tff(pred_def_7051,type,
    v13335: state_type > $o ).

tff(pred_def_7052,type,
    v13333: state_type > $o ).

tff(pred_def_7053,type,
    v13346: state_type > $o ).

tff(pred_def_7054,type,
    v13345: state_type > $o ).

tff(pred_def_7055,type,
    v13178: state_type > $o ).

tff(pred_def_7056,type,
    v13176: state_type > $o ).

tff(pred_def_7057,type,
    v13174: state_type > $o ).

tff(pred_def_7058,type,
    v13347: ( state_type * $int ) > $o ).

tff(pred_def_7059,type,
    v13348: state_type > $o ).

tff(pred_def_7060,type,
    v13172: ( state_type * $int ) > $o ).

tff(pred_def_7061,type,
    v13170: ( state_type * $int ) > $o ).

tff(pred_def_7062,type,
    v13349: ( state_type * $int ) > $o ).

tff(pred_def_7063,type,
    v13160: ( state_type * $int ) > $o ).

tff(pred_def_7064,type,
    v13158: ( state_type * $int ) > $o ).

tff(pred_def_7065,type,
    v13156: state_type > $o ).

tff(pred_def_7066,type,
    v13350: ( state_type * $int ) > $o ).

tff(pred_def_7067,type,
    v13351: state_type > $o ).

tff(pred_def_7068,type,
    v13154: ( state_type * $int ) > $o ).

tff(pred_def_7069,type,
    v13152: ( state_type * $int ) > $o ).

tff(pred_def_7070,type,
    v13352: ( state_type * $int ) > $o ).

tff(pred_def_7071,type,
    v13144: ( state_type * $int ) > $o ).

tff(pred_def_7072,type,
    v13142: ( state_type * $int ) > $o ).

tff(pred_def_7073,type,
    v13358: state_type > $o ).

tff(pred_def_7074,type,
    v13356: state_type > $o ).

tff(pred_def_7075,type,
    v13355: state_type > $o ).

tff(pred_def_7076,type,
    v13354: ( state_type * $int ) > $o ).

tff(pred_def_7077,type,
    v13099: state_type > $o ).

tff(pred_def_7078,type,
    v13097: state_type > $o ).

tff(pred_def_7079,type,
    v13364: state_type > $o ).

tff(pred_def_7080,type,
    v13362: state_type > $o ).

tff(pred_def_7081,type,
    v13368: state_type > $o ).

tff(pred_def_7082,type,
    v13366: state_type > $o ).

tff(pred_def_7083,type,
    v13371: state_type > $o ).

tff(pred_def_7084,type,
    v13370: state_type > $o ).

tff(pred_def_7085,type,
    v13095: state_type > $o ).

tff(pred_def_7086,type,
    v13093: state_type > $o ).

tff(pred_def_7087,type,
    v13091: state_type > $o ).

tff(pred_def_7088,type,
    v13089: state_type > $o ).

tff(pred_def_7089,type,
    v13087: state_type > $o ).

tff(pred_def_7090,type,
    v13085: state_type > $o ).

tff(pred_def_7091,type,
    v13083: state_type > $o ).

tff(pred_def_7092,type,
    v13081: state_type > $o ).

tff(pred_def_7093,type,
    v13391: state_type > $o ).

tff(pred_def_7094,type,
    v13389: state_type > $o ).

tff(pred_def_7095,type,
    v13387: state_type > $o ).

tff(pred_def_7096,type,
    v13385: state_type > $o ).

tff(pred_def_7097,type,
    v13383: state_type > $o ).

tff(pred_def_7098,type,
    v13401: state_type > $o ).

tff(pred_def_7099,type,
    v13399: state_type > $o ).

tff(pred_def_7100,type,
    v13397: state_type > $o ).

tff(pred_def_7101,type,
    v13395: state_type > $o ).

tff(pred_def_7102,type,
    v13393: state_type > $o ).

tff(pred_def_7103,type,
    v13405: ( state_type * $int ) > $o ).

tff(pred_def_7104,type,
    v13403: ( state_type * $int ) > $o ).

tff(pred_def_7105,type,
    v13415: state_type > $o ).

tff(pred_def_7106,type,
    v13413: state_type > $o ).

tff(pred_def_7107,type,
    v13421: state_type > $o ).

tff(pred_def_7108,type,
    v13419: state_type > $o ).

tff(pred_def_7109,type,
    v13445: ( state_type * $int ) > $o ).

tff(pred_def_7110,type,
    v13443: ( state_type * $int ) > $o ).

tff(pred_def_7111,type,
    v13446: ( state_type * $int ) > $o ).

tff(pred_def_7112,type,
    v13441: ( state_type * $int ) > $o ).

tff(pred_def_7113,type,
    v13439: ( state_type * $int ) > $o ).

tff(pred_def_7114,type,
    v13437: ( state_type * $int ) > $o ).

tff(pred_def_7115,type,
    v13435: state_type > $o ).

tff(pred_def_7116,type,
    v13433: state_type > $o ).

tff(pred_def_7117,type,
    v13450: state_type > $o ).

tff(pred_def_7118,type,
    v13448: state_type > $o ).

tff(pred_def_7119,type,
    v13454: state_type > $o ).

tff(pred_def_7120,type,
    v13452: state_type > $o ).

tff(pred_def_7121,type,
    v13457: state_type > $o ).

tff(pred_def_7122,type,
    v13456: state_type > $o ).

tff(pred_def_7123,type,
    v13431: state_type > $o ).

tff(pred_def_7124,type,
    v13429: state_type > $o ).

tff(pred_def_7125,type,
    v13427: state_type > $o ).

tff(pred_def_7126,type,
    v13425: state_type > $o ).

tff(pred_def_7127,type,
    v13423: state_type > $o ).

tff(pred_def_7128,type,
    v13461: state_type > $o ).

tff(pred_def_7129,type,
    v13459: state_type > $o ).

tff(pred_def_7130,type,
    v13417: state_type > $o ).

tff(pred_def_7131,type,
    v13467: state_type > $o ).

tff(pred_def_7132,type,
    v13469: state_type > $o ).

tff(pred_def_7133,type,
    v13465: state_type > $o ).

tff(pred_def_7134,type,
    v13464: state_type > $o ).

tff(pred_def_7135,type,
    v13475: state_type > $o ).

tff(pred_def_7136,type,
    v13476: state_type > $o ).

tff(pred_def_7137,type,
    v13472: state_type > $o ).

tff(pred_def_7138,type,
    v13474: state_type > $o ).

tff(pred_def_7139,type,
    v13482: state_type > $o ).

tff(pred_def_7140,type,
    v13480: state_type > $o ).

tff(pred_def_7141,type,
    v13484: state_type > $o ).

tff(pred_def_7142,type,
    v13411: state_type > $o ).

tff(pred_def_7143,type,
    v13409: state_type > $o ).

tff(pred_def_7144,type,
    v13407: state_type > $o ).

tff(pred_def_7145,type,
    v13491: state_type > $o ).

tff(pred_def_7146,type,
    v13489: state_type > $o ).

tff(pred_def_7147,type,
    v13488: state_type > $o ).

tff(pred_def_7148,type,
    v13487: state_type > $o ).

tff(pred_def_7149,type,
    v13499: state_type > $o ).

tff(pred_def_7150,type,
    v13500: state_type > $o ).

tff(pred_def_7151,type,
    v13498: state_type > $o ).

tff(pred_def_7152,type,
    v13495: ( state_type * $int ) > $o ).

tff(pred_def_7153,type,
    v13497: ( state_type * $int ) > $o ).

tff(pred_def_7154,type,
    v13381: ( state_type * $int ) > $o ).

tff(pred_def_7155,type,
    v13379: ( state_type * $int ) > $o ).

tff(pred_def_7156,type,
    v13377: ( state_type * $int ) > $o ).

tff(pred_def_7157,type,
    v13375: ( state_type * $int ) > $o ).

tff(pred_def_7158,type,
    v13373: ( state_type * $int ) > $o ).

tff(pred_def_7159,type,
    v13522: state_type > $o ).

tff(pred_def_7160,type,
    v13520: state_type > $o ).

tff(pred_def_7161,type,
    v13526: state_type > $o ).

tff(pred_def_7162,type,
    v13524: state_type > $o ).

tff(pred_def_7163,type,
    v13530: state_type > $o ).

tff(pred_def_7164,type,
    v13528: state_type > $o ).

tff(pred_def_7165,type,
    v13533: state_type > $o ).

tff(pred_def_7166,type,
    v13532: state_type > $o ).

tff(pred_def_7167,type,
    v13518: state_type > $o ).

tff(pred_def_7168,type,
    v13516: state_type > $o ).

tff(pred_def_7169,type,
    v13514: state_type > $o ).

tff(pred_def_7170,type,
    v13512: state_type > $o ).

tff(pred_def_7171,type,
    v13510: state_type > $o ).

tff(pred_def_7172,type,
    v13508: state_type > $o ).

tff(pred_def_7173,type,
    v13506: state_type > $o ).

tff(pred_def_7174,type,
    v13504: state_type > $o ).

tff(pred_def_7175,type,
    v13553: state_type > $o ).

tff(pred_def_7176,type,
    v13551: state_type > $o ).

tff(pred_def_7177,type,
    v13549: state_type > $o ).

tff(pred_def_7178,type,
    v13547: state_type > $o ).

tff(pred_def_7179,type,
    v13545: state_type > $o ).

tff(pred_def_7180,type,
    v13563: state_type > $o ).

tff(pred_def_7181,type,
    v13561: state_type > $o ).

tff(pred_def_7182,type,
    v13559: state_type > $o ).

tff(pred_def_7183,type,
    v13557: state_type > $o ).

tff(pred_def_7184,type,
    v13555: state_type > $o ).

tff(pred_def_7185,type,
    v13567: ( state_type * $int ) > $o ).

tff(pred_def_7186,type,
    v13565: ( state_type * $int ) > $o ).

tff(pred_def_7187,type,
    v13577: state_type > $o ).

tff(pred_def_7188,type,
    v13575: state_type > $o ).

tff(pred_def_7189,type,
    v13583: state_type > $o ).

tff(pred_def_7190,type,
    v13581: state_type > $o ).

tff(pred_def_7191,type,
    v13597: state_type > $o ).

tff(pred_def_7192,type,
    v13595: state_type > $o ).

tff(pred_def_7193,type,
    v13601: state_type > $o ).

tff(pred_def_7194,type,
    v13599: state_type > $o ).

tff(pred_def_7195,type,
    v13605: state_type > $o ).

tff(pred_def_7196,type,
    v13603: state_type > $o ).

tff(pred_def_7197,type,
    v13608: state_type > $o ).

tff(pred_def_7198,type,
    v13607: state_type > $o ).

tff(pred_def_7199,type,
    v13593: state_type > $o ).

tff(pred_def_7200,type,
    v13591: state_type > $o ).

tff(pred_def_7201,type,
    v13589: state_type > $o ).

tff(pred_def_7202,type,
    v13587: state_type > $o ).

tff(pred_def_7203,type,
    v13585: state_type > $o ).

tff(pred_def_7204,type,
    v13612: state_type > $o ).

tff(pred_def_7205,type,
    v13610: state_type > $o ).

tff(pred_def_7206,type,
    v13579: state_type > $o ).

tff(pred_def_7207,type,
    v13618: state_type > $o ).

tff(pred_def_7208,type,
    v13620: state_type > $o ).

tff(pred_def_7209,type,
    v13616: state_type > $o ).

tff(pred_def_7210,type,
    v13615: state_type > $o ).

tff(pred_def_7211,type,
    v13626: state_type > $o ).

tff(pred_def_7212,type,
    v13627: state_type > $o ).

tff(pred_def_7213,type,
    v13623: state_type > $o ).

tff(pred_def_7214,type,
    v13625: state_type > $o ).

tff(pred_def_7215,type,
    v13633: state_type > $o ).

tff(pred_def_7216,type,
    v13631: state_type > $o ).

tff(pred_def_7217,type,
    v13635: state_type > $o ).

tff(pred_def_7218,type,
    v13573: state_type > $o ).

tff(pred_def_7219,type,
    v13571: state_type > $o ).

tff(pred_def_7220,type,
    v13569: state_type > $o ).

tff(pred_def_7221,type,
    v13642: state_type > $o ).

tff(pred_def_7222,type,
    v13640: state_type > $o ).

tff(pred_def_7223,type,
    v13639: state_type > $o ).

tff(pred_def_7224,type,
    v13638: state_type > $o ).

tff(pred_def_7225,type,
    v13650: state_type > $o ).

tff(pred_def_7226,type,
    v13651: state_type > $o ).

tff(pred_def_7227,type,
    v13649: state_type > $o ).

tff(pred_def_7228,type,
    v13646: ( state_type * $int ) > $o ).

tff(pred_def_7229,type,
    v13648: ( state_type * $int ) > $o ).

tff(pred_def_7230,type,
    v13543: ( state_type * $int ) > $o ).

tff(pred_def_7231,type,
    v13541: ( state_type * $int ) > $o ).

tff(pred_def_7232,type,
    v13539: ( state_type * $int ) > $o ).

tff(pred_def_7233,type,
    v13537: ( state_type * $int ) > $o ).

tff(pred_def_7234,type,
    v13535: ( state_type * $int ) > $o ).

tff(pred_def_7235,type,
    v13673: state_type > $o ).

tff(pred_def_7236,type,
    v13671: state_type > $o ).

tff(pred_def_7237,type,
    v13677: state_type > $o ).

tff(pred_def_7238,type,
    v13675: state_type > $o ).

tff(pred_def_7239,type,
    v13681: state_type > $o ).

tff(pred_def_7240,type,
    v13679: state_type > $o ).

tff(pred_def_7241,type,
    v13684: state_type > $o ).

tff(pred_def_7242,type,
    v13683: state_type > $o ).

tff(pred_def_7243,type,
    v13669: state_type > $o ).

tff(pred_def_7244,type,
    v13667: state_type > $o ).

tff(pred_def_7245,type,
    v13665: state_type > $o ).

tff(pred_def_7246,type,
    v13663: state_type > $o ).

tff(pred_def_7247,type,
    v13661: state_type > $o ).

tff(pred_def_7248,type,
    v13659: state_type > $o ).

tff(pred_def_7249,type,
    v13657: state_type > $o ).

tff(pred_def_7250,type,
    v13655: state_type > $o ).

tff(pred_def_7251,type,
    v13704: state_type > $o ).

tff(pred_def_7252,type,
    v13702: state_type > $o ).

tff(pred_def_7253,type,
    v13700: state_type > $o ).

tff(pred_def_7254,type,
    v13698: state_type > $o ).

tff(pred_def_7255,type,
    v13696: state_type > $o ).

tff(pred_def_7256,type,
    v13714: state_type > $o ).

tff(pred_def_7257,type,
    v13712: state_type > $o ).

tff(pred_def_7258,type,
    v13710: state_type > $o ).

tff(pred_def_7259,type,
    v13708: state_type > $o ).

tff(pred_def_7260,type,
    v13706: state_type > $o ).

tff(pred_def_7261,type,
    v13718: ( state_type * $int ) > $o ).

tff(pred_def_7262,type,
    v13716: ( state_type * $int ) > $o ).

tff(pred_def_7263,type,
    v13728: state_type > $o ).

tff(pred_def_7264,type,
    v13726: state_type > $o ).

tff(pred_def_7265,type,
    v13734: state_type > $o ).

tff(pred_def_7266,type,
    v13732: state_type > $o ).

tff(pred_def_7267,type,
    v13748: state_type > $o ).

tff(pred_def_7268,type,
    v13746: state_type > $o ).

tff(pred_def_7269,type,
    v13752: state_type > $o ).

tff(pred_def_7270,type,
    v13750: state_type > $o ).

tff(pred_def_7271,type,
    v13756: state_type > $o ).

tff(pred_def_7272,type,
    v13754: state_type > $o ).

tff(pred_def_7273,type,
    v13759: state_type > $o ).

tff(pred_def_7274,type,
    v13758: state_type > $o ).

tff(pred_def_7275,type,
    v13744: state_type > $o ).

tff(pred_def_7276,type,
    v13742: state_type > $o ).

tff(pred_def_7277,type,
    v13740: state_type > $o ).

tff(pred_def_7278,type,
    v13738: state_type > $o ).

tff(pred_def_7279,type,
    v13736: state_type > $o ).

tff(pred_def_7280,type,
    v13763: state_type > $o ).

tff(pred_def_7281,type,
    v13761: state_type > $o ).

tff(pred_def_7282,type,
    v13730: state_type > $o ).

tff(pred_def_7283,type,
    v13769: state_type > $o ).

tff(pred_def_7284,type,
    v13771: state_type > $o ).

tff(pred_def_7285,type,
    v13767: state_type > $o ).

tff(pred_def_7286,type,
    v13766: state_type > $o ).

tff(pred_def_7287,type,
    v13777: state_type > $o ).

tff(pred_def_7288,type,
    v13778: state_type > $o ).

tff(pred_def_7289,type,
    v13774: state_type > $o ).

tff(pred_def_7290,type,
    v13776: state_type > $o ).

tff(pred_def_7291,type,
    v13784: state_type > $o ).

tff(pred_def_7292,type,
    v13782: state_type > $o ).

tff(pred_def_7293,type,
    v13786: state_type > $o ).

tff(pred_def_7294,type,
    v13724: state_type > $o ).

tff(pred_def_7295,type,
    v13722: state_type > $o ).

tff(pred_def_7296,type,
    v13720: state_type > $o ).

tff(pred_def_7297,type,
    v13793: state_type > $o ).

tff(pred_def_7298,type,
    v13791: state_type > $o ).

tff(pred_def_7299,type,
    v13790: state_type > $o ).

tff(pred_def_7300,type,
    v13789: state_type > $o ).

tff(pred_def_7301,type,
    v13801: state_type > $o ).

tff(pred_def_7302,type,
    v13802: state_type > $o ).

tff(pred_def_7303,type,
    v13800: state_type > $o ).

tff(pred_def_7304,type,
    v13797: ( state_type * $int ) > $o ).

tff(pred_def_7305,type,
    v13799: ( state_type * $int ) > $o ).

tff(pred_def_7306,type,
    v13694: ( state_type * $int ) > $o ).

tff(pred_def_7307,type,
    v13692: ( state_type * $int ) > $o ).

tff(pred_def_7308,type,
    v13690: ( state_type * $int ) > $o ).

tff(pred_def_7309,type,
    v13688: ( state_type * $int ) > $o ).

tff(pred_def_7310,type,
    v13686: ( state_type * $int ) > $o ).

tff(pred_def_7311,type,
    v13824: state_type > $o ).

tff(pred_def_7312,type,
    v13822: state_type > $o ).

tff(pred_def_7313,type,
    v13828: state_type > $o ).

tff(pred_def_7314,type,
    v13826: state_type > $o ).

tff(pred_def_7315,type,
    v13832: state_type > $o ).

tff(pred_def_7316,type,
    v13830: state_type > $o ).

tff(pred_def_7317,type,
    v13835: state_type > $o ).

tff(pred_def_7318,type,
    v13834: state_type > $o ).

tff(pred_def_7319,type,
    v13820: state_type > $o ).

tff(pred_def_7320,type,
    v13818: state_type > $o ).

tff(pred_def_7321,type,
    v13816: state_type > $o ).

tff(pred_def_7322,type,
    v13814: state_type > $o ).

tff(pred_def_7323,type,
    v13812: state_type > $o ).

tff(pred_def_7324,type,
    v13810: state_type > $o ).

tff(pred_def_7325,type,
    v13808: state_type > $o ).

tff(pred_def_7326,type,
    v13806: state_type > $o ).

tff(pred_def_7327,type,
    v13855: state_type > $o ).

tff(pred_def_7328,type,
    v13853: state_type > $o ).

tff(pred_def_7329,type,
    v13851: state_type > $o ).

tff(pred_def_7330,type,
    v13849: state_type > $o ).

tff(pred_def_7331,type,
    v13847: state_type > $o ).

tff(pred_def_7332,type,
    v13865: state_type > $o ).

tff(pred_def_7333,type,
    v13863: state_type > $o ).

tff(pred_def_7334,type,
    v13861: state_type > $o ).

tff(pred_def_7335,type,
    v13859: state_type > $o ).

tff(pred_def_7336,type,
    v13857: state_type > $o ).

tff(pred_def_7337,type,
    v13869: ( state_type * $int ) > $o ).

tff(pred_def_7338,type,
    v13867: ( state_type * $int ) > $o ).

tff(pred_def_7339,type,
    v13879: state_type > $o ).

tff(pred_def_7340,type,
    v13877: state_type > $o ).

tff(pred_def_7341,type,
    v13885: state_type > $o ).

tff(pred_def_7342,type,
    v13883: state_type > $o ).

tff(pred_def_7343,type,
    v13899: state_type > $o ).

tff(pred_def_7344,type,
    v13897: state_type > $o ).

tff(pred_def_7345,type,
    v13903: state_type > $o ).

tff(pred_def_7346,type,
    v13901: state_type > $o ).

tff(pred_def_7347,type,
    v13907: state_type > $o ).

tff(pred_def_7348,type,
    v13905: state_type > $o ).

tff(pred_def_7349,type,
    v13910: state_type > $o ).

tff(pred_def_7350,type,
    v13909: state_type > $o ).

tff(pred_def_7351,type,
    v13895: state_type > $o ).

tff(pred_def_7352,type,
    v13893: state_type > $o ).

tff(pred_def_7353,type,
    v13891: state_type > $o ).

tff(pred_def_7354,type,
    v13889: state_type > $o ).

tff(pred_def_7355,type,
    v13887: state_type > $o ).

tff(pred_def_7356,type,
    v13914: state_type > $o ).

tff(pred_def_7357,type,
    v13912: state_type > $o ).

tff(pred_def_7358,type,
    v13881: state_type > $o ).

tff(pred_def_7359,type,
    v13920: state_type > $o ).

tff(pred_def_7360,type,
    v13922: state_type > $o ).

tff(pred_def_7361,type,
    v13918: state_type > $o ).

tff(pred_def_7362,type,
    v13917: state_type > $o ).

tff(pred_def_7363,type,
    v13928: state_type > $o ).

tff(pred_def_7364,type,
    v13929: state_type > $o ).

tff(pred_def_7365,type,
    v13925: state_type > $o ).

tff(pred_def_7366,type,
    v13927: state_type > $o ).

tff(pred_def_7367,type,
    v13935: state_type > $o ).

tff(pred_def_7368,type,
    v13933: state_type > $o ).

tff(pred_def_7369,type,
    v13937: state_type > $o ).

tff(pred_def_7370,type,
    v13875: state_type > $o ).

tff(pred_def_7371,type,
    v13873: state_type > $o ).

tff(pred_def_7372,type,
    v13871: state_type > $o ).

tff(pred_def_7373,type,
    v13944: state_type > $o ).

tff(pred_def_7374,type,
    v13942: state_type > $o ).

tff(pred_def_7375,type,
    v13941: state_type > $o ).

tff(pred_def_7376,type,
    v13940: state_type > $o ).

tff(pred_def_7377,type,
    v13952: state_type > $o ).

tff(pred_def_7378,type,
    v13953: state_type > $o ).

tff(pred_def_7379,type,
    v13951: state_type > $o ).

tff(pred_def_7380,type,
    v13948: ( state_type * $int ) > $o ).

tff(pred_def_7381,type,
    v13950: ( state_type * $int ) > $o ).

tff(pred_def_7382,type,
    v13845: ( state_type * $int ) > $o ).

tff(pred_def_7383,type,
    v13843: ( state_type * $int ) > $o ).

tff(pred_def_7384,type,
    v13841: ( state_type * $int ) > $o ).

tff(pred_def_7385,type,
    v13839: ( state_type * $int ) > $o ).

tff(pred_def_7386,type,
    v13837: ( state_type * $int ) > $o ).

tff(pred_def_7387,type,
    v13975: state_type > $o ).

tff(pred_def_7388,type,
    v13973: state_type > $o ).

tff(pred_def_7389,type,
    v13979: state_type > $o ).

tff(pred_def_7390,type,
    v13977: state_type > $o ).

tff(pred_def_7391,type,
    v13983: state_type > $o ).

tff(pred_def_7392,type,
    v13981: state_type > $o ).

tff(pred_def_7393,type,
    v13986: state_type > $o ).

tff(pred_def_7394,type,
    v13985: state_type > $o ).

tff(pred_def_7395,type,
    v13971: state_type > $o ).

tff(pred_def_7396,type,
    v13969: state_type > $o ).

tff(pred_def_7397,type,
    v13967: state_type > $o ).

tff(pred_def_7398,type,
    v13965: state_type > $o ).

tff(pred_def_7399,type,
    v13963: state_type > $o ).

tff(pred_def_7400,type,
    v13961: state_type > $o ).

tff(pred_def_7401,type,
    v13959: state_type > $o ).

tff(pred_def_7402,type,
    v13957: state_type > $o ).

tff(pred_def_7403,type,
    v14006: state_type > $o ).

tff(pred_def_7404,type,
    v14004: state_type > $o ).

tff(pred_def_7405,type,
    v14002: state_type > $o ).

tff(pred_def_7406,type,
    v14000: state_type > $o ).

tff(pred_def_7407,type,
    v13998: state_type > $o ).

tff(pred_def_7408,type,
    v14016: state_type > $o ).

tff(pred_def_7409,type,
    v14014: state_type > $o ).

tff(pred_def_7410,type,
    v14012: state_type > $o ).

tff(pred_def_7411,type,
    v14010: state_type > $o ).

tff(pred_def_7412,type,
    v14008: state_type > $o ).

tff(pred_def_7413,type,
    v14020: ( state_type * $int ) > $o ).

tff(pred_def_7414,type,
    v14018: ( state_type * $int ) > $o ).

tff(pred_def_7415,type,
    v14030: state_type > $o ).

tff(pred_def_7416,type,
    v14028: state_type > $o ).

tff(pred_def_7417,type,
    v14036: state_type > $o ).

tff(pred_def_7418,type,
    v14034: state_type > $o ).

tff(pred_def_7419,type,
    v14049: state_type > $o ).

tff(pred_def_7420,type,
    v14047: state_type > $o ).

tff(pred_def_7421,type,
    v14053: state_type > $o ).

tff(pred_def_7422,type,
    v14051: state_type > $o ).

tff(pred_def_7423,type,
    v14057: state_type > $o ).

tff(pred_def_7424,type,
    v14055: state_type > $o ).

tff(pred_def_7425,type,
    v14060: state_type > $o ).

tff(pred_def_7426,type,
    v14059: state_type > $o ).

tff(pred_def_7427,type,
    v14045: state_type > $o ).

tff(pred_def_7428,type,
    v14043: state_type > $o ).

tff(pred_def_7429,type,
    v14040: state_type > $o ).

tff(pred_def_7430,type,
    v14038: state_type > $o ).

tff(pred_def_7431,type,
    v14064: state_type > $o ).

tff(pred_def_7432,type,
    v14062: state_type > $o ).

tff(pred_def_7433,type,
    v14032: state_type > $o ).

tff(pred_def_7434,type,
    v14070: state_type > $o ).

tff(pred_def_7435,type,
    v14072: state_type > $o ).

tff(pred_def_7436,type,
    v14068: state_type > $o ).

tff(pred_def_7437,type,
    v14067: state_type > $o ).

tff(pred_def_7438,type,
    v14078: state_type > $o ).

tff(pred_def_7439,type,
    v14079: state_type > $o ).

tff(pred_def_7440,type,
    v14075: state_type > $o ).

tff(pred_def_7441,type,
    v14077: state_type > $o ).

tff(pred_def_7442,type,
    v14085: state_type > $o ).

tff(pred_def_7443,type,
    v14083: state_type > $o ).

tff(pred_def_7444,type,
    v14087: state_type > $o ).

tff(pred_def_7445,type,
    v14026: state_type > $o ).

tff(pred_def_7446,type,
    v14024: state_type > $o ).

tff(pred_def_7447,type,
    v14022: state_type > $o ).

tff(pred_def_7448,type,
    v14094: state_type > $o ).

tff(pred_def_7449,type,
    v14092: state_type > $o ).

tff(pred_def_7450,type,
    v14091: state_type > $o ).

tff(pred_def_7451,type,
    v14090: state_type > $o ).

tff(pred_def_7452,type,
    v14102: state_type > $o ).

tff(pred_def_7453,type,
    v14103: state_type > $o ).

tff(pred_def_7454,type,
    v14101: state_type > $o ).

tff(pred_def_7455,type,
    v14098: ( state_type * $int ) > $o ).

tff(pred_def_7456,type,
    v14100: ( state_type * $int ) > $o ).

tff(pred_def_7457,type,
    v13996: ( state_type * $int ) > $o ).

tff(pred_def_7458,type,
    v13994: ( state_type * $int ) > $o ).

tff(pred_def_7459,type,
    v13992: ( state_type * $int ) > $o ).

tff(pred_def_7460,type,
    v13990: ( state_type * $int ) > $o ).

tff(pred_def_7461,type,
    v13988: ( state_type * $int ) > $o ).

tff(pred_def_7462,type,
    v14115: state_type > $o ).

tff(pred_def_7463,type,
    v14113: state_type > $o ).

tff(pred_def_7464,type,
    v14111: state_type > $o ).

tff(pred_def_7465,type,
    v14109: state_type > $o ).

tff(pred_def_7466,type,
    v14107: state_type > $o ).

tff(pred_def_7467,type,
    v14123: state_type > $o ).

tff(pred_def_7468,type,
    v14122: ( state_type * $int ) > $o ).

tff(pred_def_7469,type,
    v14121: ( state_type * $int ) > $o ).

tff(pred_def_7470,type,
    v14126: state_type > $o ).

tff(pred_def_7471,type,
    v14125: ( state_type * $int ) > $o ).

tff(pred_def_7472,type,
    v14124: ( state_type * $int ) > $o ).

tff(pred_def_7473,type,
    v14120: ( state_type * $int ) > $o ).

tff(pred_def_7474,type,
    v14129: state_type > $o ).

tff(pred_def_7475,type,
    v14128: ( state_type * $int ) > $o ).

tff(pred_def_7476,type,
    v14127: ( state_type * $int ) > $o ).

tff(pred_def_7477,type,
    v14119: ( state_type * $int ) > $o ).

tff(pred_def_7478,type,
    v14132: state_type > $o ).

tff(pred_def_7479,type,
    v14131: ( state_type * $int ) > $o ).

tff(pred_def_7480,type,
    v14130: ( state_type * $int ) > $o ).

tff(pred_def_7481,type,
    v14118: ( state_type * $int ) > $o ).

tff(pred_def_7482,type,
    v14135: state_type > $o ).

tff(pred_def_7483,type,
    v14134: ( state_type * $int ) > $o ).

tff(pred_def_7484,type,
    v14133: ( state_type * $int ) > $o ).

tff(pred_def_7485,type,
    v14117: ( state_type * $int ) > $o ).

tff(pred_def_7486,type,
    v14138: state_type > $o ).

tff(pred_def_7487,type,
    v14137: ( state_type * $int ) > $o ).

tff(pred_def_7488,type,
    v14136: ( state_type * $int ) > $o ).

tff(pred_def_7489,type,
    v12609: ( state_type * $int ) > $o ).

tff(pred_def_7490,type,
    v12607: ( state_type * $int ) > $o ).

tff(pred_def_7491,type,
    v12605: ( state_type * $int ) > $o ).

tff(pred_def_7492,type,
    v12603: ( state_type * $int ) > $o ).

tff(pred_def_7493,type,
    v12601: ( state_type * $int ) > $o ).

tff(pred_def_7494,type,
    v12595: state_type > $o ).

tff(pred_def_7495,type,
    v12593: state_type > $o ).

tff(pred_def_7496,type,
    v12591: state_type > $o ).

tff(pred_def_7497,type,
    v14149: ( state_type * $int ) > $o ).

tff(pred_def_7498,type,
    v14147: ( state_type * $int ) > $o ).

tff(pred_def_7499,type,
    v14183: state_type > $o ).

tff(pred_def_7500,type,
    v14181: state_type > $o ).

tff(pred_def_7501,type,
    v14179: state_type > $o ).

tff(pred_def_7502,type,
    v14177: state_type > $o ).

tff(pred_def_7503,type,
    v14175: state_type > $o ).

tff(pred_def_7504,type,
    v14173: state_type > $o ).

tff(pred_def_7505,type,
    v14171: state_type > $o ).

tff(pred_def_7506,type,
    v14197: state_type > $o ).

tff(pred_def_7507,type,
    v14195: state_type > $o ).

tff(pred_def_7508,type,
    v14193: state_type > $o ).

tff(pred_def_7509,type,
    v14191: state_type > $o ).

tff(pred_def_7510,type,
    v14189: state_type > $o ).

tff(pred_def_7511,type,
    v14187: state_type > $o ).

tff(pred_def_7512,type,
    v14185: state_type > $o ).

tff(pred_def_7513,type,
    v14223: state_type > $o ).

tff(pred_def_7514,type,
    v14225: state_type > $o ).

tff(pred_def_7515,type,
    v14224: ( state_type * $int ) > $o ).

tff(pred_def_7516,type,
    v14226: state_type > $o ).

tff(pred_def_7517,type,
    v14221: ( state_type * $int ) > $o ).

tff(pred_def_7518,type,
    v14219: ( state_type * $int ) > $o ).

tff(pred_def_7519,type,
    v14227: ( state_type * $int ) > $o ).

tff(pred_def_7520,type,
    v14217: ( state_type * $int ) > $o ).

tff(pred_def_7521,type,
    v14215: ( state_type * $int ) > $o ).

tff(pred_def_7522,type,
    v14213: state_type > $o ).

tff(pred_def_7523,type,
    v14229: state_type > $o ).

tff(pred_def_7524,type,
    v14211: ( state_type * $int ) > $o ).

tff(pred_def_7525,type,
    v14209: ( state_type * $int ) > $o ).

tff(pred_def_7526,type,
    v14243: ( state_type * $int ) > $o ).

tff(pred_def_7527,type,
    v14241: ( state_type * $int ) > $o ).

tff(pred_def_7528,type,
    v14247: state_type > $o ).

tff(pred_def_7529,type,
    v14245: state_type > $o ).

tff(pred_def_7530,type,
    v14271: state_type > $o ).

tff(pred_def_7531,type,
    v14269: state_type > $o ).

tff(pred_def_7532,type,
    v14267: state_type > $o ).

tff(pred_def_7533,type,
    v14265: state_type > $o ).

tff(pred_def_7534,type,
    v14263: state_type > $o ).

tff(pred_def_7535,type,
    v14261: state_type > $o ).

tff(pred_def_7536,type,
    v14259: state_type > $o ).

tff(pred_def_7537,type,
    v14285: state_type > $o ).

tff(pred_def_7538,type,
    v14283: state_type > $o ).

tff(pred_def_7539,type,
    v14281: state_type > $o ).

tff(pred_def_7540,type,
    v14279: state_type > $o ).

tff(pred_def_7541,type,
    v14277: state_type > $o ).

tff(pred_def_7542,type,
    v14275: state_type > $o ).

tff(pred_def_7543,type,
    v14273: state_type > $o ).

tff(pred_def_7544,type,
    v14301: ( state_type * $int ) > $o ).

tff(pred_def_7545,type,
    v14299: ( state_type * $int ) > $o ).

tff(pred_def_7546,type,
    v14297: ( state_type * $int ) > $o ).

tff(pred_def_7547,type,
    v14295: ( state_type * $int ) > $o ).

tff(pred_def_7548,type,
    v14293: ( state_type * $int ) > $o ).

tff(pred_def_7549,type,
    v14331: ( state_type * $int ) > $o ).

tff(pred_def_7550,type,
    v14333: ( state_type * $int ) > $o ).

tff(pred_def_7551,type,
    v14329: ( state_type * $int ) > $o ).

tff(pred_def_7552,type,
    v14327: ( state_type * $int ) > $o ).

tff(pred_def_7553,type,
    v14325: ( state_type * $int ) > $o ).

tff(pred_def_7554,type,
    v14323: ( state_type * $int ) > $o ).

tff(pred_def_7555,type,
    v14321: state_type > $o ).

tff(pred_def_7556,type,
    v14319: state_type > $o ).

tff(pred_def_7557,type,
    v14337: state_type > $o ).

tff(pred_def_7558,type,
    v14335: state_type > $o ).

tff(pred_def_7559,type,
    v14339: state_type > $o ).

tff(pred_def_7560,type,
    v14317: state_type > $o ).

tff(pred_def_7561,type,
    v14315: state_type > $o ).

tff(pred_def_7562,type,
    v14313: state_type > $o ).

tff(pred_def_7563,type,
    v14311: state_type > $o ).

tff(pred_def_7564,type,
    v14309: state_type > $o ).

tff(pred_def_7565,type,
    v14307: state_type > $o ).

tff(pred_def_7566,type,
    v14305: state_type > $o ).

tff(pred_def_7567,type,
    v14303: state_type > $o ).

tff(pred_def_7568,type,
    v14349: ( state_type * $int ) > $o ).

tff(pred_def_7569,type,
    v14347: ( state_type * $int ) > $o ).

tff(pred_def_7570,type,
    v14345: ( state_type * $int ) > $o ).

tff(pred_def_7571,type,
    v14343: ( state_type * $int ) > $o ).

tff(pred_def_7572,type,
    v14341: ( state_type * $int ) > $o ).

tff(pred_def_7573,type,
    v14379: ( state_type * $int ) > $o ).

tff(pred_def_7574,type,
    v14377: ( state_type * $int ) > $o ).

tff(pred_def_7575,type,
    v14380: ( state_type * $int ) > $o ).

tff(pred_def_7576,type,
    v14375: ( state_type * $int ) > $o ).

tff(pred_def_7577,type,
    v14373: ( state_type * $int ) > $o ).

tff(pred_def_7578,type,
    v14371: ( state_type * $int ) > $o ).

tff(pred_def_7579,type,
    v14369: state_type > $o ).

tff(pred_def_7580,type,
    v14367: state_type > $o ).

tff(pred_def_7581,type,
    v14384: state_type > $o ).

tff(pred_def_7582,type,
    v14382: state_type > $o ).

tff(pred_def_7583,type,
    v14386: state_type > $o ).

tff(pred_def_7584,type,
    v14365: state_type > $o ).

tff(pred_def_7585,type,
    v14363: state_type > $o ).

tff(pred_def_7586,type,
    v14361: state_type > $o ).

tff(pred_def_7587,type,
    v14359: state_type > $o ).

tff(pred_def_7588,type,
    v14357: state_type > $o ).

tff(pred_def_7589,type,
    v14355: state_type > $o ).

tff(pred_def_7590,type,
    v14353: state_type > $o ).

tff(pred_def_7591,type,
    v14351: state_type > $o ).

tff(pred_def_7592,type,
    v14396: ( state_type * $int ) > $o ).

tff(pred_def_7593,type,
    v14394: ( state_type * $int ) > $o ).

tff(pred_def_7594,type,
    v14392: ( state_type * $int ) > $o ).

tff(pred_def_7595,type,
    v14390: ( state_type * $int ) > $o ).

tff(pred_def_7596,type,
    v14388: ( state_type * $int ) > $o ).

tff(pred_def_7597,type,
    v14416: state_type > $o ).

tff(pred_def_7598,type,
    v14414: state_type > $o ).

tff(pred_def_7599,type,
    v14420: state_type > $o ).

tff(pred_def_7600,type,
    v14418: state_type > $o ).

tff(pred_def_7601,type,
    v14422: state_type > $o ).

tff(pred_def_7602,type,
    v14412: state_type > $o ).

tff(pred_def_7603,type,
    v14410: state_type > $o ).

tff(pred_def_7604,type,
    v14408: state_type > $o ).

tff(pred_def_7605,type,
    v14406: state_type > $o ).

tff(pred_def_7606,type,
    v14404: state_type > $o ).

tff(pred_def_7607,type,
    v14402: state_type > $o ).

tff(pred_def_7608,type,
    v14400: state_type > $o ).

tff(pred_def_7609,type,
    v14398: state_type > $o ).

tff(pred_def_7610,type,
    v14432: ( state_type * $int ) > $o ).

tff(pred_def_7611,type,
    v14430: ( state_type * $int ) > $o ).

tff(pred_def_7612,type,
    v14428: ( state_type * $int ) > $o ).

tff(pred_def_7613,type,
    v14426: ( state_type * $int ) > $o ).

tff(pred_def_7614,type,
    v14424: ( state_type * $int ) > $o ).

tff(pred_def_7615,type,
    v14452: state_type > $o ).

tff(pred_def_7616,type,
    v14450: state_type > $o ).

tff(pred_def_7617,type,
    v14456: state_type > $o ).

tff(pred_def_7618,type,
    v14454: state_type > $o ).

tff(pred_def_7619,type,
    v14458: state_type > $o ).

tff(pred_def_7620,type,
    v14448: state_type > $o ).

tff(pred_def_7621,type,
    v14446: state_type > $o ).

tff(pred_def_7622,type,
    v14444: state_type > $o ).

tff(pred_def_7623,type,
    v14442: state_type > $o ).

tff(pred_def_7624,type,
    v14440: state_type > $o ).

tff(pred_def_7625,type,
    v14438: state_type > $o ).

tff(pred_def_7626,type,
    v14436: state_type > $o ).

tff(pred_def_7627,type,
    v14434: state_type > $o ).

tff(pred_def_7628,type,
    v14464: state_type > $o ).

tff(pred_def_7629,type,
    v14463: ( state_type * $int ) > $o ).

tff(pred_def_7630,type,
    v14462: ( state_type * $int ) > $o ).

tff(pred_def_7631,type,
    v14467: state_type > $o ).

tff(pred_def_7632,type,
    v14466: ( state_type * $int ) > $o ).

tff(pred_def_7633,type,
    v14465: ( state_type * $int ) > $o ).

tff(pred_def_7634,type,
    v14461: ( state_type * $int ) > $o ).

tff(pred_def_7635,type,
    v14470: state_type > $o ).

tff(pred_def_7636,type,
    v14469: ( state_type * $int ) > $o ).

tff(pred_def_7637,type,
    v14468: ( state_type * $int ) > $o ).

tff(pred_def_7638,type,
    v14460: ( state_type * $int ) > $o ).

tff(pred_def_7639,type,
    v14473: state_type > $o ).

tff(pred_def_7640,type,
    v14472: ( state_type * $int ) > $o ).

tff(pred_def_7641,type,
    v14471: ( state_type * $int ) > $o ).

tff(pred_def_7642,type,
    v14291: ( state_type * $int ) > $o ).

tff(pred_def_7643,type,
    v14289: ( state_type * $int ) > $o ).

tff(pred_def_7644,type,
    v14287: ( state_type * $int ) > $o ).

tff(pred_def_7645,type,
    v14485: state_type > $o ).

tff(pred_def_7646,type,
    v14483: state_type > $o ).

tff(pred_def_7647,type,
    v14481: state_type > $o ).

tff(pred_def_7648,type,
    v14495: state_type > $o ).

tff(pred_def_7649,type,
    v14493: state_type > $o ).

tff(pred_def_7650,type,
    v14491: state_type > $o ).

tff(pred_def_7651,type,
    v14489: state_type > $o ).

tff(pred_def_7652,type,
    v14487: state_type > $o ).

tff(pred_def_7653,type,
    v14497: state_type > $o ).

tff(pred_def_7654,type,
    v14479: state_type > $o ).

tff(pred_def_7655,type,
    v14477: state_type > $o ).

tff(pred_def_7656,type,
    v14475: state_type > $o ).

tff(pred_def_7657,type,
    v14504: state_type > $o ).

tff(pred_def_7658,type,
    v14502: state_type > $o ).

tff(pred_def_7659,type,
    v14501: state_type > $o ).

tff(pred_def_7660,type,
    v14500: state_type > $o ).

tff(pred_def_7661,type,
    v14512: state_type > $o ).

tff(pred_def_7662,type,
    v14513: state_type > $o ).

tff(pred_def_7663,type,
    v14511: state_type > $o ).

tff(pred_def_7664,type,
    v14508: ( state_type * $int ) > $o ).

tff(pred_def_7665,type,
    v14510: ( state_type * $int ) > $o ).

tff(pred_def_7666,type,
    v14257: ( state_type * $int ) > $o ).

tff(pred_def_7667,type,
    v14255: ( state_type * $int ) > $o ).

tff(pred_def_7668,type,
    v14253: ( state_type * $int ) > $o ).

tff(pred_def_7669,type,
    v14251: ( state_type * $int ) > $o ).

tff(pred_def_7670,type,
    v14249: ( state_type * $int ) > $o ).

tff(pred_def_7671,type,
    v14519: state_type > $o ).

tff(pred_def_7672,type,
    v14517: state_type > $o ).

tff(pred_def_7673,type,
    v14523: state_type > $o ).

tff(pred_def_7674,type,
    v14522: ( state_type * $int ) > $o ).

tff(pred_def_7675,type,
    v14521: ( state_type * $int ) > $o ).

tff(pred_def_7676,type,
    v14526: state_type > $o ).

tff(pred_def_7677,type,
    v14525: ( state_type * $int ) > $o ).

tff(pred_def_7678,type,
    v14524: ( state_type * $int ) > $o ).

tff(pred_def_7679,type,
    v14239: ( state_type * $int ) > $o ).

tff(pred_def_7680,type,
    v14237: ( state_type * $int ) > $o ).

tff(pred_def_7681,type,
    v14235: ( state_type * $int ) > $o ).

tff(pred_def_7682,type,
    v14233: ( state_type * $int ) > $o ).

tff(pred_def_7683,type,
    v14231: ( state_type * $int ) > $o ).

tff(pred_def_7684,type,
    v14207: ( state_type * $int ) > $o ).

tff(pred_def_7685,type,
    v14205: ( state_type * $int ) > $o ).

tff(pred_def_7686,type,
    v14203: ( state_type * $int ) > $o ).

tff(pred_def_7687,type,
    v14201: ( state_type * $int ) > $o ).

tff(pred_def_7688,type,
    v14199: ( state_type * $int ) > $o ).

tff(pred_def_7689,type,
    v14539: state_type > $o ).

tff(pred_def_7690,type,
    v14537: state_type > $o ).

tff(pred_def_7691,type,
    v14535: state_type > $o ).

tff(pred_def_7692,type,
    v14545: state_type > $o ).

tff(pred_def_7693,type,
    v14543: state_type > $o ).

tff(pred_def_7694,type,
    v14563: ( state_type * $int ) > $o ).

tff(pred_def_7695,type,
    v14565: ( state_type * $int ) > $o ).

tff(pred_def_7696,type,
    v14561: ( state_type * $int ) > $o ).

tff(pred_def_7697,type,
    v14559: state_type > $o ).

tff(pred_def_7698,type,
    v14557: state_type > $o ).

tff(pred_def_7699,type,
    v14569: state_type > $o ).

tff(pred_def_7700,type,
    v14567: state_type > $o ).

tff(pred_def_7701,type,
    v14573: state_type > $o ).

tff(pred_def_7702,type,
    v14571: state_type > $o ).

tff(pred_def_7703,type,
    v14576: state_type > $o ).

tff(pred_def_7704,type,
    v14575: state_type > $o ).

tff(pred_def_7705,type,
    v14555: state_type > $o ).

tff(pred_def_7706,type,
    v14553: state_type > $o ).

tff(pred_def_7707,type,
    v14551: state_type > $o ).

tff(pred_def_7708,type,
    v14549: state_type > $o ).

tff(pred_def_7709,type,
    v14547: state_type > $o ).

tff(pred_def_7710,type,
    v14584: state_type > $o ).

tff(pred_def_7711,type,
    v14582: state_type > $o ).

tff(pred_def_7712,type,
    v14580: state_type > $o ).

tff(pred_def_7713,type,
    v14578: state_type > $o ).

tff(pred_def_7714,type,
    v14541: state_type > $o ).

tff(pred_def_7715,type,
    v14590: state_type > $o ).

tff(pred_def_7716,type,
    v14592: state_type > $o ).

tff(pred_def_7717,type,
    v14588: state_type > $o ).

tff(pred_def_7718,type,
    v14587: state_type > $o ).

tff(pred_def_7719,type,
    v14598: state_type > $o ).

tff(pred_def_7720,type,
    v14599: state_type > $o ).

tff(pred_def_7721,type,
    v14595: state_type > $o ).

tff(pred_def_7722,type,
    v14597: state_type > $o ).

tff(pred_def_7723,type,
    v14609: state_type > $o ).

tff(pred_def_7724,type,
    v14607: state_type > $o ).

tff(pred_def_7725,type,
    v14605: state_type > $o ).

tff(pred_def_7726,type,
    v14603: state_type > $o ).

tff(pred_def_7727,type,
    v14611: state_type > $o ).

tff(pred_def_7728,type,
    v14533: state_type > $o ).

tff(pred_def_7729,type,
    v14531: state_type > $o ).

tff(pred_def_7730,type,
    v14529: state_type > $o ).

tff(pred_def_7731,type,
    v14618: state_type > $o ).

tff(pred_def_7732,type,
    v14616: state_type > $o ).

tff(pred_def_7733,type,
    v14615: state_type > $o ).

tff(pred_def_7734,type,
    v14614: state_type > $o ).

tff(pred_def_7735,type,
    v14626: state_type > $o ).

tff(pred_def_7736,type,
    v14627: state_type > $o ).

tff(pred_def_7737,type,
    v14625: state_type > $o ).

tff(pred_def_7738,type,
    v14622: ( state_type * $int ) > $o ).

tff(pred_def_7739,type,
    v14624: ( state_type * $int ) > $o ).

tff(pred_def_7740,type,
    v14169: ( state_type * $int ) > $o ).

tff(pred_def_7741,type,
    v14167: ( state_type * $int ) > $o ).

tff(pred_def_7742,type,
    v14165: ( state_type * $int ) > $o ).

tff(pred_def_7743,type,
    v14163: ( state_type * $int ) > $o ).

tff(pred_def_7744,type,
    v14161: ( state_type * $int ) > $o ).

tff(pred_def_7745,type,
    v14663: state_type > $o ).

tff(pred_def_7746,type,
    v14661: state_type > $o ).

tff(pred_def_7747,type,
    v14659: state_type > $o ).

tff(pred_def_7748,type,
    v14657: state_type > $o ).

tff(pred_def_7749,type,
    v14655: state_type > $o ).

tff(pred_def_7750,type,
    v14653: state_type > $o ).

tff(pred_def_7751,type,
    v14673: state_type > $o ).

tff(pred_def_7752,type,
    v14671: state_type > $o ).

tff(pred_def_7753,type,
    v14669: state_type > $o ).

tff(pred_def_7754,type,
    v14667: state_type > $o ).

tff(pred_def_7755,type,
    v14665: state_type > $o ).

tff(pred_def_7756,type,
    v14700: state_type > $o ).

tff(pred_def_7757,type,
    v14699: ( state_type * $int ) > $o ).

tff(pred_def_7758,type,
    v14698: ( state_type * $int ) > $o ).

tff(pred_def_7759,type,
    v14696: ( state_type * $int ) > $o ).

tff(pred_def_7760,type,
    v14716: state_type > $o ).

tff(pred_def_7761,type,
    v14717: ( state_type * $int ) > $o ).

tff(pred_def_7762,type,
    v14718: state_type > $o ).

tff(pred_def_7763,type,
    v14714: ( state_type * $int ) > $o ).

tff(pred_def_7764,type,
    v14712: ( state_type * $int ) > $o ).

tff(pred_def_7765,type,
    v14742: ( state_type * $int ) > $o ).

tff(pred_def_7766,type,
    v14651: ( state_type * $int ) > $o ).

tff(pred_def_7767,type,
    v14740: ( state_type * $int ) > $o ).

tff(pred_def_7768,type,
    v14743: ( state_type * $int ) > $o ).

tff(pred_def_7769,type,
    v14738: ( state_type * $int ) > $o ).

tff(pred_def_7770,type,
    v14736: ( state_type * $int ) > $o ).

tff(pred_def_7771,type,
    v14734: ( state_type * $int ) > $o ).

tff(pred_def_7772,type,
    v14732: state_type > $o ).

tff(pred_def_7773,type,
    v14730: state_type > $o ).

tff(pred_def_7774,type,
    v14749: state_type > $o ).

tff(pred_def_7775,type,
    v14689: state_type > $o ).

tff(pred_def_7776,type,
    v14748: ( state_type * $int ) > $o ).

tff(pred_def_7777,type,
    v14687: ( state_type * $int ) > $o ).

tff(pred_def_7778,type,
    v14685: ( state_type * $int ) > $o ).

tff(pred_def_7779,type,
    v14764: ( state_type * $int ) > $o ).

tff(pred_def_7780,type,
    v14763: ( state_type * $int ) > $o ).

tff(pred_def_7781,type,
    v14761: ( state_type * $int ) > $o ).

tff(pred_def_7782,type,
    v14768: state_type > $o ).

tff(pred_def_7783,type,
    v14766: state_type > $o ).

tff(pred_def_7784,type,
    v14779: ( state_type * $int ) > $o ).

tff(pred_def_7785,type,
    v14778: state_type > $o ).

tff(pred_def_7786,type,
    v14782: state_type > $o ).

tff(pred_def_7787,type,
    v14783: state_type > $o ).

tff(pred_def_7788,type,
    v14781: state_type > $o ).

tff(pred_def_7789,type,
    v14784: state_type > $o ).

tff(pred_def_7790,type,
    v14780: state_type > $o ).

tff(pred_def_7791,type,
    v14777: state_type > $o ).

tff(pred_def_7792,type,
    v14785: state_type > $o ).

tff(pred_def_7793,type,
    v14776: state_type > $o ).

tff(pred_def_7794,type,
    v14788: state_type > $o ).

tff(pred_def_7795,type,
    v14789: state_type > $o ).

tff(pred_def_7796,type,
    v14787: state_type > $o ).

tff(pred_def_7797,type,
    v14790: state_type > $o ).

tff(pred_def_7798,type,
    v14786: state_type > $o ).

tff(pred_def_7799,type,
    v14775: state_type > $o ).

tff(pred_def_7800,type,
    v14791: state_type > $o ).

tff(pred_def_7801,type,
    v14774: state_type > $o ).

tff(pred_def_7802,type,
    v14773: state_type > $o ).

tff(pred_def_7803,type,
    v14795: state_type > $o ).

tff(pred_def_7804,type,
    v14796: state_type > $o ).

tff(pred_def_7805,type,
    v14794: state_type > $o ).

tff(pred_def_7806,type,
    v14797: state_type > $o ).

tff(pred_def_7807,type,
    v14793: state_type > $o ).

tff(pred_def_7808,type,
    v14792: state_type > $o ).

tff(pred_def_7809,type,
    v14772: state_type > $o ).

tff(pred_def_7810,type,
    v14798: state_type > $o ).

tff(pred_def_7811,type,
    v14771: state_type > $o ).

tff(pred_def_7812,type,
    v14801: state_type > $o ).

tff(pred_def_7813,type,
    v14802: state_type > $o ).

tff(pred_def_7814,type,
    v14800: state_type > $o ).

tff(pred_def_7815,type,
    v14803: state_type > $o ).

tff(pred_def_7816,type,
    v14799: state_type > $o ).

tff(pred_def_7817,type,
    v14806: state_type > $o ).

tff(pred_def_7818,type,
    v14807: state_type > $o ).

tff(pred_def_7819,type,
    v14805: state_type > $o ).

tff(pred_def_7820,type,
    v14808: state_type > $o ).

tff(pred_def_7821,type,
    v14804: state_type > $o ).

tff(pred_def_7822,type,
    v14811: state_type > $o ).

tff(pred_def_7823,type,
    v14812: state_type > $o ).

tff(pred_def_7824,type,
    v14810: state_type > $o ).

tff(pred_def_7825,type,
    v14813: state_type > $o ).

tff(pred_def_7826,type,
    v14809: state_type > $o ).

tff(pred_def_7827,type,
    v14769: ( state_type * $int ) > $o ).

tff(pred_def_7828,type,
    v14759: ( state_type * $int ) > $o ).

tff(pred_def_7829,type,
    v14757: ( state_type * $int ) > $o ).

tff(pred_def_7830,type,
    v14755: ( state_type * $int ) > $o ).

tff(pred_def_7831,type,
    v14753: ( state_type * $int ) > $o ).

tff(pred_def_7832,type,
    v14751: ( state_type * $int ) > $o ).

tff(pred_def_7833,type,
    v14814: ( state_type * $int ) > $o ).

tff(pred_def_7834,type,
    v14683: ( state_type * $int ) > $o ).

tff(pred_def_7835,type,
    v14681: ( state_type * $int ) > $o ).

tff(pred_def_7836,type,
    v14679: ( state_type * $int ) > $o ).

tff(pred_def_7837,type,
    v14815: ( state_type * $int ) > $o ).

tff(pred_def_7838,type,
    v14816: ( state_type * $int ) > $o ).

tff(pred_def_7839,type,
    v14677: ( state_type * $int ) > $o ).

tff(pred_def_7840,type,
    v14675: ( state_type * $int ) > $o ).

tff(pred_def_7841,type,
    v14826: state_type > $o ).

tff(pred_def_7842,type,
    v14824: state_type > $o ).

tff(pred_def_7843,type,
    v14832: state_type > $o ).

tff(pred_def_7844,type,
    v14830: state_type > $o ).

tff(pred_def_7845,type,
    v14836: state_type > $o ).

tff(pred_def_7846,type,
    v14834: state_type > $o ).

tff(pred_def_7847,type,
    v14840: state_type > $o ).

tff(pred_def_7848,type,
    v14838: state_type > $o ).

tff(pred_def_7849,type,
    v14828: state_type > $o ).

tff(pred_def_7850,type,
    v14846: state_type > $o ).

tff(pred_def_7851,type,
    v14848: state_type > $o ).

tff(pred_def_7852,type,
    v14844: state_type > $o ).

tff(pred_def_7853,type,
    v14843: state_type > $o ).

tff(pred_def_7854,type,
    v14854: state_type > $o ).

tff(pred_def_7855,type,
    v14855: state_type > $o ).

tff(pred_def_7856,type,
    v14851: state_type > $o ).

tff(pred_def_7857,type,
    v14853: state_type > $o ).

tff(pred_def_7858,type,
    v14861: state_type > $o ).

tff(pred_def_7859,type,
    v14859: state_type > $o ).

tff(pred_def_7860,type,
    v14863: state_type > $o ).

tff(pred_def_7861,type,
    v14822: state_type > $o ).

tff(pred_def_7862,type,
    v14820: state_type > $o ).

tff(pred_def_7863,type,
    v14818: state_type > $o ).

tff(pred_def_7864,type,
    v14870: state_type > $o ).

tff(pred_def_7865,type,
    v14868: state_type > $o ).

tff(pred_def_7866,type,
    v14867: state_type > $o ).

tff(pred_def_7867,type,
    v14866: state_type > $o ).

tff(pred_def_7868,type,
    v14878: state_type > $o ).

tff(pred_def_7869,type,
    v14879: state_type > $o ).

tff(pred_def_7870,type,
    v14877: state_type > $o ).

tff(pred_def_7871,type,
    v14874: ( state_type * $int ) > $o ).

tff(pred_def_7872,type,
    v14876: ( state_type * $int ) > $o ).

tff(pred_def_7873,type,
    v14865: ( state_type * $int ) > $o ).

tff(pred_def_7874,type,
    v14747: state_type > $o ).

tff(pred_def_7875,type,
    v14745: state_type > $o ).

tff(pred_def_7876,type,
    v14891: state_type > $o ).

tff(pred_def_7877,type,
    v14889: state_type > $o ).

tff(pred_def_7878,type,
    v14888: state_type > $o ).

tff(pred_def_7879,type,
    v14887: ( state_type * $int ) > $o ).

tff(pred_def_7880,type,
    v14885: state_type > $o ).

tff(pred_def_7881,type,
    v14883: state_type > $o ).

tff(pred_def_7882,type,
    v14896: state_type > $o ).

tff(pred_def_7883,type,
    v14895: state_type > $o ).

tff(pred_def_7884,type,
    v14728: state_type > $o ).

tff(pred_def_7885,type,
    v14726: state_type > $o ).

tff(pred_def_7886,type,
    v14724: state_type > $o ).

tff(pred_def_7887,type,
    v14897: ( state_type * $int ) > $o ).

tff(pred_def_7888,type,
    v14898: state_type > $o ).

tff(pred_def_7889,type,
    v14722: ( state_type * $int ) > $o ).

tff(pred_def_7890,type,
    v14720: ( state_type * $int ) > $o ).

tff(pred_def_7891,type,
    v14899: ( state_type * $int ) > $o ).

tff(pred_def_7892,type,
    v14710: ( state_type * $int ) > $o ).

tff(pred_def_7893,type,
    v14708: ( state_type * $int ) > $o ).

tff(pred_def_7894,type,
    v14706: state_type > $o ).

tff(pred_def_7895,type,
    v14900: ( state_type * $int ) > $o ).

tff(pred_def_7896,type,
    v14901: state_type > $o ).

tff(pred_def_7897,type,
    v14704: ( state_type * $int ) > $o ).

tff(pred_def_7898,type,
    v14702: ( state_type * $int ) > $o ).

tff(pred_def_7899,type,
    v14902: ( state_type * $int ) > $o ).

tff(pred_def_7900,type,
    v14694: ( state_type * $int ) > $o ).

tff(pred_def_7901,type,
    v14692: ( state_type * $int ) > $o ).

tff(pred_def_7902,type,
    v14908: state_type > $o ).

tff(pred_def_7903,type,
    v14906: state_type > $o ).

tff(pred_def_7904,type,
    v14905: state_type > $o ).

tff(pred_def_7905,type,
    v14904: ( state_type * $int ) > $o ).

tff(pred_def_7906,type,
    v14649: state_type > $o ).

tff(pred_def_7907,type,
    v14647: state_type > $o ).

tff(pred_def_7908,type,
    v14914: state_type > $o ).

tff(pred_def_7909,type,
    v14912: state_type > $o ).

tff(pred_def_7910,type,
    v14918: state_type > $o ).

tff(pred_def_7911,type,
    v14916: state_type > $o ).

tff(pred_def_7912,type,
    v14921: state_type > $o ).

tff(pred_def_7913,type,
    v14920: state_type > $o ).

tff(pred_def_7914,type,
    v14645: state_type > $o ).

tff(pred_def_7915,type,
    v14643: state_type > $o ).

tff(pred_def_7916,type,
    v14641: state_type > $o ).

tff(pred_def_7917,type,
    v14639: state_type > $o ).

tff(pred_def_7918,type,
    v14637: state_type > $o ).

tff(pred_def_7919,type,
    v14635: state_type > $o ).

tff(pred_def_7920,type,
    v14633: state_type > $o ).

tff(pred_def_7921,type,
    v14631: state_type > $o ).

tff(pred_def_7922,type,
    v14941: state_type > $o ).

tff(pred_def_7923,type,
    v14939: state_type > $o ).

tff(pred_def_7924,type,
    v14937: state_type > $o ).

tff(pred_def_7925,type,
    v14935: state_type > $o ).

tff(pred_def_7926,type,
    v14933: state_type > $o ).

tff(pred_def_7927,type,
    v14951: state_type > $o ).

tff(pred_def_7928,type,
    v14949: state_type > $o ).

tff(pred_def_7929,type,
    v14947: state_type > $o ).

tff(pred_def_7930,type,
    v14945: state_type > $o ).

tff(pred_def_7931,type,
    v14943: state_type > $o ).

tff(pred_def_7932,type,
    v14955: ( state_type * $int ) > $o ).

tff(pred_def_7933,type,
    v14953: ( state_type * $int ) > $o ).

tff(pred_def_7934,type,
    v14965: state_type > $o ).

tff(pred_def_7935,type,
    v14963: state_type > $o ).

tff(pred_def_7936,type,
    v14971: state_type > $o ).

tff(pred_def_7937,type,
    v14969: state_type > $o ).

tff(pred_def_7938,type,
    v14995: ( state_type * $int ) > $o ).

tff(pred_def_7939,type,
    v14993: ( state_type * $int ) > $o ).

tff(pred_def_7940,type,
    v14996: ( state_type * $int ) > $o ).

tff(pred_def_7941,type,
    v14991: ( state_type * $int ) > $o ).

tff(pred_def_7942,type,
    v14989: ( state_type * $int ) > $o ).

tff(pred_def_7943,type,
    v14987: ( state_type * $int ) > $o ).

tff(pred_def_7944,type,
    v14985: state_type > $o ).

tff(pred_def_7945,type,
    v14983: state_type > $o ).

tff(pred_def_7946,type,
    v15000: state_type > $o ).

tff(pred_def_7947,type,
    v14998: state_type > $o ).

tff(pred_def_7948,type,
    v15004: state_type > $o ).

tff(pred_def_7949,type,
    v15002: state_type > $o ).

tff(pred_def_7950,type,
    v15007: state_type > $o ).

tff(pred_def_7951,type,
    v15006: state_type > $o ).

tff(pred_def_7952,type,
    v14981: state_type > $o ).

tff(pred_def_7953,type,
    v14979: state_type > $o ).

tff(pred_def_7954,type,
    v14977: state_type > $o ).

tff(pred_def_7955,type,
    v14975: state_type > $o ).

tff(pred_def_7956,type,
    v14973: state_type > $o ).

tff(pred_def_7957,type,
    v15011: state_type > $o ).

tff(pred_def_7958,type,
    v15009: state_type > $o ).

tff(pred_def_7959,type,
    v14967: state_type > $o ).

tff(pred_def_7960,type,
    v15017: state_type > $o ).

tff(pred_def_7961,type,
    v15019: state_type > $o ).

tff(pred_def_7962,type,
    v15015: state_type > $o ).

tff(pred_def_7963,type,
    v15014: state_type > $o ).

tff(pred_def_7964,type,
    v15025: state_type > $o ).

tff(pred_def_7965,type,
    v15026: state_type > $o ).

tff(pred_def_7966,type,
    v15022: state_type > $o ).

tff(pred_def_7967,type,
    v15024: state_type > $o ).

tff(pred_def_7968,type,
    v15032: state_type > $o ).

tff(pred_def_7969,type,
    v15030: state_type > $o ).

tff(pred_def_7970,type,
    v15034: state_type > $o ).

tff(pred_def_7971,type,
    v14961: state_type > $o ).

tff(pred_def_7972,type,
    v14959: state_type > $o ).

tff(pred_def_7973,type,
    v14957: state_type > $o ).

tff(pred_def_7974,type,
    v15041: state_type > $o ).

tff(pred_def_7975,type,
    v15039: state_type > $o ).

tff(pred_def_7976,type,
    v15038: state_type > $o ).

tff(pred_def_7977,type,
    v15037: state_type > $o ).

tff(pred_def_7978,type,
    v15049: state_type > $o ).

tff(pred_def_7979,type,
    v15050: state_type > $o ).

tff(pred_def_7980,type,
    v15048: state_type > $o ).

tff(pred_def_7981,type,
    v15045: ( state_type * $int ) > $o ).

tff(pred_def_7982,type,
    v15047: ( state_type * $int ) > $o ).

tff(pred_def_7983,type,
    v14931: ( state_type * $int ) > $o ).

tff(pred_def_7984,type,
    v14929: ( state_type * $int ) > $o ).

tff(pred_def_7985,type,
    v14927: ( state_type * $int ) > $o ).

tff(pred_def_7986,type,
    v14925: ( state_type * $int ) > $o ).

tff(pred_def_7987,type,
    v14923: ( state_type * $int ) > $o ).

tff(pred_def_7988,type,
    v15072: state_type > $o ).

tff(pred_def_7989,type,
    v15070: state_type > $o ).

tff(pred_def_7990,type,
    v15076: state_type > $o ).

tff(pred_def_7991,type,
    v15074: state_type > $o ).

tff(pred_def_7992,type,
    v15080: state_type > $o ).

tff(pred_def_7993,type,
    v15078: state_type > $o ).

tff(pred_def_7994,type,
    v15083: state_type > $o ).

tff(pred_def_7995,type,
    v15082: state_type > $o ).

tff(pred_def_7996,type,
    v15068: state_type > $o ).

tff(pred_def_7997,type,
    v15066: state_type > $o ).

tff(pred_def_7998,type,
    v15064: state_type > $o ).

tff(pred_def_7999,type,
    v15062: state_type > $o ).

tff(pred_def_8000,type,
    v15060: state_type > $o ).

tff(pred_def_8001,type,
    v15058: state_type > $o ).

tff(pred_def_8002,type,
    v15056: state_type > $o ).

tff(pred_def_8003,type,
    v15054: state_type > $o ).

tff(pred_def_8004,type,
    v15103: state_type > $o ).

tff(pred_def_8005,type,
    v15101: state_type > $o ).

tff(pred_def_8006,type,
    v15099: state_type > $o ).

tff(pred_def_8007,type,
    v15097: state_type > $o ).

tff(pred_def_8008,type,
    v15095: state_type > $o ).

tff(pred_def_8009,type,
    v15113: state_type > $o ).

tff(pred_def_8010,type,
    v15111: state_type > $o ).

tff(pred_def_8011,type,
    v15109: state_type > $o ).

tff(pred_def_8012,type,
    v15107: state_type > $o ).

tff(pred_def_8013,type,
    v15105: state_type > $o ).

tff(pred_def_8014,type,
    v15117: ( state_type * $int ) > $o ).

tff(pred_def_8015,type,
    v15115: ( state_type * $int ) > $o ).

tff(pred_def_8016,type,
    v15127: state_type > $o ).

tff(pred_def_8017,type,
    v15125: state_type > $o ).

tff(pred_def_8018,type,
    v15133: state_type > $o ).

tff(pred_def_8019,type,
    v15131: state_type > $o ).

tff(pred_def_8020,type,
    v15147: state_type > $o ).

tff(pred_def_8021,type,
    v15145: state_type > $o ).

tff(pred_def_8022,type,
    v15151: state_type > $o ).

tff(pred_def_8023,type,
    v15149: state_type > $o ).

tff(pred_def_8024,type,
    v15155: state_type > $o ).

tff(pred_def_8025,type,
    v15153: state_type > $o ).

tff(pred_def_8026,type,
    v15158: state_type > $o ).

tff(pred_def_8027,type,
    v15157: state_type > $o ).

tff(pred_def_8028,type,
    v15143: state_type > $o ).

tff(pred_def_8029,type,
    v15141: state_type > $o ).

tff(pred_def_8030,type,
    v15139: state_type > $o ).

tff(pred_def_8031,type,
    v15137: state_type > $o ).

tff(pred_def_8032,type,
    v15135: state_type > $o ).

tff(pred_def_8033,type,
    v15162: state_type > $o ).

tff(pred_def_8034,type,
    v15160: state_type > $o ).

tff(pred_def_8035,type,
    v15129: state_type > $o ).

tff(pred_def_8036,type,
    v15168: state_type > $o ).

tff(pred_def_8037,type,
    v15170: state_type > $o ).

tff(pred_def_8038,type,
    v15166: state_type > $o ).

tff(pred_def_8039,type,
    v15165: state_type > $o ).

tff(pred_def_8040,type,
    v15176: state_type > $o ).

tff(pred_def_8041,type,
    v15177: state_type > $o ).

tff(pred_def_8042,type,
    v15173: state_type > $o ).

tff(pred_def_8043,type,
    v15175: state_type > $o ).

tff(pred_def_8044,type,
    v15183: state_type > $o ).

tff(pred_def_8045,type,
    v15181: state_type > $o ).

tff(pred_def_8046,type,
    v15185: state_type > $o ).

tff(pred_def_8047,type,
    v15123: state_type > $o ).

tff(pred_def_8048,type,
    v15121: state_type > $o ).

tff(pred_def_8049,type,
    v15119: state_type > $o ).

tff(pred_def_8050,type,
    v15192: state_type > $o ).

tff(pred_def_8051,type,
    v15190: state_type > $o ).

tff(pred_def_8052,type,
    v15189: state_type > $o ).

tff(pred_def_8053,type,
    v15188: state_type > $o ).

tff(pred_def_8054,type,
    v15200: state_type > $o ).

tff(pred_def_8055,type,
    v15201: state_type > $o ).

tff(pred_def_8056,type,
    v15199: state_type > $o ).

tff(pred_def_8057,type,
    v15196: ( state_type * $int ) > $o ).

tff(pred_def_8058,type,
    v15198: ( state_type * $int ) > $o ).

tff(pred_def_8059,type,
    v15093: ( state_type * $int ) > $o ).

tff(pred_def_8060,type,
    v15091: ( state_type * $int ) > $o ).

tff(pred_def_8061,type,
    v15089: ( state_type * $int ) > $o ).

tff(pred_def_8062,type,
    v15087: ( state_type * $int ) > $o ).

tff(pred_def_8063,type,
    v15085: ( state_type * $int ) > $o ).

tff(pred_def_8064,type,
    v15223: state_type > $o ).

tff(pred_def_8065,type,
    v15221: state_type > $o ).

tff(pred_def_8066,type,
    v15227: state_type > $o ).

tff(pred_def_8067,type,
    v15225: state_type > $o ).

tff(pred_def_8068,type,
    v15231: state_type > $o ).

tff(pred_def_8069,type,
    v15229: state_type > $o ).

tff(pred_def_8070,type,
    v15234: state_type > $o ).

tff(pred_def_8071,type,
    v15233: state_type > $o ).

tff(pred_def_8072,type,
    v15219: state_type > $o ).

tff(pred_def_8073,type,
    v15217: state_type > $o ).

tff(pred_def_8074,type,
    v15215: state_type > $o ).

tff(pred_def_8075,type,
    v15213: state_type > $o ).

tff(pred_def_8076,type,
    v15211: state_type > $o ).

tff(pred_def_8077,type,
    v15209: state_type > $o ).

tff(pred_def_8078,type,
    v15207: state_type > $o ).

tff(pred_def_8079,type,
    v15205: state_type > $o ).

tff(pred_def_8080,type,
    v15254: state_type > $o ).

tff(pred_def_8081,type,
    v15252: state_type > $o ).

tff(pred_def_8082,type,
    v15250: state_type > $o ).

tff(pred_def_8083,type,
    v15248: state_type > $o ).

tff(pred_def_8084,type,
    v15246: state_type > $o ).

tff(pred_def_8085,type,
    v15264: state_type > $o ).

tff(pred_def_8086,type,
    v15262: state_type > $o ).

tff(pred_def_8087,type,
    v15260: state_type > $o ).

tff(pred_def_8088,type,
    v15258: state_type > $o ).

tff(pred_def_8089,type,
    v15256: state_type > $o ).

tff(pred_def_8090,type,
    v15268: ( state_type * $int ) > $o ).

tff(pred_def_8091,type,
    v15266: ( state_type * $int ) > $o ).

tff(pred_def_8092,type,
    v15278: state_type > $o ).

tff(pred_def_8093,type,
    v15276: state_type > $o ).

tff(pred_def_8094,type,
    v15284: state_type > $o ).

tff(pred_def_8095,type,
    v15282: state_type > $o ).

tff(pred_def_8096,type,
    v15298: state_type > $o ).

tff(pred_def_8097,type,
    v15296: state_type > $o ).

tff(pred_def_8098,type,
    v15302: state_type > $o ).

tff(pred_def_8099,type,
    v15300: state_type > $o ).

tff(pred_def_8100,type,
    v15306: state_type > $o ).

tff(pred_def_8101,type,
    v15304: state_type > $o ).

tff(pred_def_8102,type,
    v15309: state_type > $o ).

tff(pred_def_8103,type,
    v15308: state_type > $o ).

tff(pred_def_8104,type,
    v15294: state_type > $o ).

tff(pred_def_8105,type,
    v15292: state_type > $o ).

tff(pred_def_8106,type,
    v15290: state_type > $o ).

tff(pred_def_8107,type,
    v15288: state_type > $o ).

tff(pred_def_8108,type,
    v15286: state_type > $o ).

tff(pred_def_8109,type,
    v15313: state_type > $o ).

tff(pred_def_8110,type,
    v15311: state_type > $o ).

tff(pred_def_8111,type,
    v15280: state_type > $o ).

tff(pred_def_8112,type,
    v15319: state_type > $o ).

tff(pred_def_8113,type,
    v15321: state_type > $o ).

tff(pred_def_8114,type,
    v15317: state_type > $o ).

tff(pred_def_8115,type,
    v15316: state_type > $o ).

tff(pred_def_8116,type,
    v15327: state_type > $o ).

tff(pred_def_8117,type,
    v15328: state_type > $o ).

tff(pred_def_8118,type,
    v15324: state_type > $o ).

tff(pred_def_8119,type,
    v15326: state_type > $o ).

tff(pred_def_8120,type,
    v15334: state_type > $o ).

tff(pred_def_8121,type,
    v15332: state_type > $o ).

tff(pred_def_8122,type,
    v15336: state_type > $o ).

tff(pred_def_8123,type,
    v15274: state_type > $o ).

tff(pred_def_8124,type,
    v15272: state_type > $o ).

tff(pred_def_8125,type,
    v15270: state_type > $o ).

tff(pred_def_8126,type,
    v15343: state_type > $o ).

tff(pred_def_8127,type,
    v15341: state_type > $o ).

tff(pred_def_8128,type,
    v15340: state_type > $o ).

tff(pred_def_8129,type,
    v15339: state_type > $o ).

tff(pred_def_8130,type,
    v15351: state_type > $o ).

tff(pred_def_8131,type,
    v15352: state_type > $o ).

tff(pred_def_8132,type,
    v15350: state_type > $o ).

tff(pred_def_8133,type,
    v15347: ( state_type * $int ) > $o ).

tff(pred_def_8134,type,
    v15349: ( state_type * $int ) > $o ).

tff(pred_def_8135,type,
    v15244: ( state_type * $int ) > $o ).

tff(pred_def_8136,type,
    v15242: ( state_type * $int ) > $o ).

tff(pred_def_8137,type,
    v15240: ( state_type * $int ) > $o ).

tff(pred_def_8138,type,
    v15238: ( state_type * $int ) > $o ).

tff(pred_def_8139,type,
    v15236: ( state_type * $int ) > $o ).

tff(pred_def_8140,type,
    v15374: state_type > $o ).

tff(pred_def_8141,type,
    v15372: state_type > $o ).

tff(pred_def_8142,type,
    v15378: state_type > $o ).

tff(pred_def_8143,type,
    v15376: state_type > $o ).

tff(pred_def_8144,type,
    v15382: state_type > $o ).

tff(pred_def_8145,type,
    v15380: state_type > $o ).

tff(pred_def_8146,type,
    v15385: state_type > $o ).

tff(pred_def_8147,type,
    v15384: state_type > $o ).

tff(pred_def_8148,type,
    v15370: state_type > $o ).

tff(pred_def_8149,type,
    v15368: state_type > $o ).

tff(pred_def_8150,type,
    v15366: state_type > $o ).

tff(pred_def_8151,type,
    v15364: state_type > $o ).

tff(pred_def_8152,type,
    v15362: state_type > $o ).

tff(pred_def_8153,type,
    v15360: state_type > $o ).

tff(pred_def_8154,type,
    v15358: state_type > $o ).

tff(pred_def_8155,type,
    v15356: state_type > $o ).

tff(pred_def_8156,type,
    v15405: state_type > $o ).

tff(pred_def_8157,type,
    v15403: state_type > $o ).

tff(pred_def_8158,type,
    v15401: state_type > $o ).

tff(pred_def_8159,type,
    v15399: state_type > $o ).

tff(pred_def_8160,type,
    v15397: state_type > $o ).

tff(pred_def_8161,type,
    v15415: state_type > $o ).

tff(pred_def_8162,type,
    v15413: state_type > $o ).

tff(pred_def_8163,type,
    v15411: state_type > $o ).

tff(pred_def_8164,type,
    v15409: state_type > $o ).

tff(pred_def_8165,type,
    v15407: state_type > $o ).

tff(pred_def_8166,type,
    v15419: ( state_type * $int ) > $o ).

tff(pred_def_8167,type,
    v15417: ( state_type * $int ) > $o ).

tff(pred_def_8168,type,
    v15429: state_type > $o ).

tff(pred_def_8169,type,
    v15427: state_type > $o ).

tff(pred_def_8170,type,
    v15435: state_type > $o ).

tff(pred_def_8171,type,
    v15433: state_type > $o ).

tff(pred_def_8172,type,
    v15449: state_type > $o ).

tff(pred_def_8173,type,
    v15447: state_type > $o ).

tff(pred_def_8174,type,
    v15453: state_type > $o ).

tff(pred_def_8175,type,
    v15451: state_type > $o ).

tff(pred_def_8176,type,
    v15457: state_type > $o ).

tff(pred_def_8177,type,
    v15455: state_type > $o ).

tff(pred_def_8178,type,
    v15460: state_type > $o ).

tff(pred_def_8179,type,
    v15459: state_type > $o ).

tff(pred_def_8180,type,
    v15445: state_type > $o ).

tff(pred_def_8181,type,
    v15443: state_type > $o ).

tff(pred_def_8182,type,
    v15441: state_type > $o ).

tff(pred_def_8183,type,
    v15439: state_type > $o ).

tff(pred_def_8184,type,
    v15437: state_type > $o ).

tff(pred_def_8185,type,
    v15464: state_type > $o ).

tff(pred_def_8186,type,
    v15462: state_type > $o ).

tff(pred_def_8187,type,
    v15431: state_type > $o ).

tff(pred_def_8188,type,
    v15470: state_type > $o ).

tff(pred_def_8189,type,
    v15472: state_type > $o ).

tff(pred_def_8190,type,
    v15468: state_type > $o ).

tff(pred_def_8191,type,
    v15467: state_type > $o ).

tff(pred_def_8192,type,
    v15478: state_type > $o ).

tff(pred_def_8193,type,
    v15479: state_type > $o ).

tff(pred_def_8194,type,
    v15475: state_type > $o ).

tff(pred_def_8195,type,
    v15477: state_type > $o ).

tff(pred_def_8196,type,
    v15485: state_type > $o ).

tff(pred_def_8197,type,
    v15483: state_type > $o ).

tff(pred_def_8198,type,
    v15487: state_type > $o ).

tff(pred_def_8199,type,
    v15425: state_type > $o ).

tff(pred_def_8200,type,
    v15423: state_type > $o ).

tff(pred_def_8201,type,
    v15421: state_type > $o ).

tff(pred_def_8202,type,
    v15494: state_type > $o ).

tff(pred_def_8203,type,
    v15492: state_type > $o ).

tff(pred_def_8204,type,
    v15491: state_type > $o ).

tff(pred_def_8205,type,
    v15490: state_type > $o ).

tff(pred_def_8206,type,
    v15502: state_type > $o ).

tff(pred_def_8207,type,
    v15503: state_type > $o ).

tff(pred_def_8208,type,
    v15501: state_type > $o ).

tff(pred_def_8209,type,
    v15498: ( state_type * $int ) > $o ).

tff(pred_def_8210,type,
    v15500: ( state_type * $int ) > $o ).

tff(pred_def_8211,type,
    v15395: ( state_type * $int ) > $o ).

tff(pred_def_8212,type,
    v15393: ( state_type * $int ) > $o ).

tff(pred_def_8213,type,
    v15391: ( state_type * $int ) > $o ).

tff(pred_def_8214,type,
    v15389: ( state_type * $int ) > $o ).

tff(pred_def_8215,type,
    v15387: ( state_type * $int ) > $o ).

tff(pred_def_8216,type,
    v15525: state_type > $o ).

tff(pred_def_8217,type,
    v15523: state_type > $o ).

tff(pred_def_8218,type,
    v15529: state_type > $o ).

tff(pred_def_8219,type,
    v15527: state_type > $o ).

tff(pred_def_8220,type,
    v15533: state_type > $o ).

tff(pred_def_8221,type,
    v15531: state_type > $o ).

tff(pred_def_8222,type,
    v15536: state_type > $o ).

tff(pred_def_8223,type,
    v15535: state_type > $o ).

tff(pred_def_8224,type,
    v15521: state_type > $o ).

tff(pred_def_8225,type,
    v15519: state_type > $o ).

tff(pred_def_8226,type,
    v15517: state_type > $o ).

tff(pred_def_8227,type,
    v15515: state_type > $o ).

tff(pred_def_8228,type,
    v15513: state_type > $o ).

tff(pred_def_8229,type,
    v15511: state_type > $o ).

tff(pred_def_8230,type,
    v15509: state_type > $o ).

tff(pred_def_8231,type,
    v15507: state_type > $o ).

tff(pred_def_8232,type,
    v15556: state_type > $o ).

tff(pred_def_8233,type,
    v15554: state_type > $o ).

tff(pred_def_8234,type,
    v15552: state_type > $o ).

tff(pred_def_8235,type,
    v15550: state_type > $o ).

tff(pred_def_8236,type,
    v15548: state_type > $o ).

tff(pred_def_8237,type,
    v15566: state_type > $o ).

tff(pred_def_8238,type,
    v15564: state_type > $o ).

tff(pred_def_8239,type,
    v15562: state_type > $o ).

tff(pred_def_8240,type,
    v15560: state_type > $o ).

tff(pred_def_8241,type,
    v15558: state_type > $o ).

tff(pred_def_8242,type,
    v15570: ( state_type * $int ) > $o ).

tff(pred_def_8243,type,
    v15568: ( state_type * $int ) > $o ).

tff(pred_def_8244,type,
    v15580: state_type > $o ).

tff(pred_def_8245,type,
    v15578: state_type > $o ).

tff(pred_def_8246,type,
    v15586: state_type > $o ).

tff(pred_def_8247,type,
    v15584: state_type > $o ).

tff(pred_def_8248,type,
    v15599: state_type > $o ).

tff(pred_def_8249,type,
    v15597: state_type > $o ).

tff(pred_def_8250,type,
    v15603: state_type > $o ).

tff(pred_def_8251,type,
    v15601: state_type > $o ).

tff(pred_def_8252,type,
    v15607: state_type > $o ).

tff(pred_def_8253,type,
    v15605: state_type > $o ).

tff(pred_def_8254,type,
    v15610: state_type > $o ).

tff(pred_def_8255,type,
    v15609: state_type > $o ).

tff(pred_def_8256,type,
    v15595: state_type > $o ).

tff(pred_def_8257,type,
    v15593: state_type > $o ).

tff(pred_def_8258,type,
    v15590: state_type > $o ).

tff(pred_def_8259,type,
    v15588: state_type > $o ).

tff(pred_def_8260,type,
    v15614: state_type > $o ).

tff(pred_def_8261,type,
    v15612: state_type > $o ).

tff(pred_def_8262,type,
    v15582: state_type > $o ).

tff(pred_def_8263,type,
    v15620: state_type > $o ).

tff(pred_def_8264,type,
    v15622: state_type > $o ).

tff(pred_def_8265,type,
    v15618: state_type > $o ).

tff(pred_def_8266,type,
    v15617: state_type > $o ).

tff(pred_def_8267,type,
    v15628: state_type > $o ).

tff(pred_def_8268,type,
    v15629: state_type > $o ).

tff(pred_def_8269,type,
    v15625: state_type > $o ).

tff(pred_def_8270,type,
    v15627: state_type > $o ).

tff(pred_def_8271,type,
    v15635: state_type > $o ).

tff(pred_def_8272,type,
    v15633: state_type > $o ).

tff(pred_def_8273,type,
    v15637: state_type > $o ).

tff(pred_def_8274,type,
    v15576: state_type > $o ).

tff(pred_def_8275,type,
    v15574: state_type > $o ).

tff(pred_def_8276,type,
    v15572: state_type > $o ).

tff(pred_def_8277,type,
    v15644: state_type > $o ).

tff(pred_def_8278,type,
    v15642: state_type > $o ).

tff(pred_def_8279,type,
    v15641: state_type > $o ).

tff(pred_def_8280,type,
    v15640: state_type > $o ).

tff(pred_def_8281,type,
    v15652: state_type > $o ).

tff(pred_def_8282,type,
    v15653: state_type > $o ).

tff(pred_def_8283,type,
    v15651: state_type > $o ).

tff(pred_def_8284,type,
    v15648: ( state_type * $int ) > $o ).

tff(pred_def_8285,type,
    v15650: ( state_type * $int ) > $o ).

tff(pred_def_8286,type,
    v15546: ( state_type * $int ) > $o ).

tff(pred_def_8287,type,
    v15544: ( state_type * $int ) > $o ).

tff(pred_def_8288,type,
    v15542: ( state_type * $int ) > $o ).

tff(pred_def_8289,type,
    v15540: ( state_type * $int ) > $o ).

tff(pred_def_8290,type,
    v15538: ( state_type * $int ) > $o ).

tff(pred_def_8291,type,
    v15665: state_type > $o ).

tff(pred_def_8292,type,
    v15663: state_type > $o ).

tff(pred_def_8293,type,
    v15661: state_type > $o ).

tff(pred_def_8294,type,
    v15659: state_type > $o ).

tff(pred_def_8295,type,
    v15657: state_type > $o ).

tff(pred_def_8296,type,
    v15673: state_type > $o ).

tff(pred_def_8297,type,
    v15672: ( state_type * $int ) > $o ).

tff(pred_def_8298,type,
    v15671: ( state_type * $int ) > $o ).

tff(pred_def_8299,type,
    v15676: state_type > $o ).

tff(pred_def_8300,type,
    v15675: ( state_type * $int ) > $o ).

tff(pred_def_8301,type,
    v15674: ( state_type * $int ) > $o ).

tff(pred_def_8302,type,
    v15670: ( state_type * $int ) > $o ).

tff(pred_def_8303,type,
    v15679: state_type > $o ).

tff(pred_def_8304,type,
    v15678: ( state_type * $int ) > $o ).

tff(pred_def_8305,type,
    v15677: ( state_type * $int ) > $o ).

tff(pred_def_8306,type,
    v15669: ( state_type * $int ) > $o ).

tff(pred_def_8307,type,
    v15682: state_type > $o ).

tff(pred_def_8308,type,
    v15681: ( state_type * $int ) > $o ).

tff(pred_def_8309,type,
    v15680: ( state_type * $int ) > $o ).

tff(pred_def_8310,type,
    v15668: ( state_type * $int ) > $o ).

tff(pred_def_8311,type,
    v15685: state_type > $o ).

tff(pred_def_8312,type,
    v15684: ( state_type * $int ) > $o ).

tff(pred_def_8313,type,
    v15683: ( state_type * $int ) > $o ).

tff(pred_def_8314,type,
    v15667: ( state_type * $int ) > $o ).

tff(pred_def_8315,type,
    v15688: state_type > $o ).

tff(pred_def_8316,type,
    v15687: ( state_type * $int ) > $o ).

tff(pred_def_8317,type,
    v15686: ( state_type * $int ) > $o ).

tff(pred_def_8318,type,
    v14159: ( state_type * $int ) > $o ).

tff(pred_def_8319,type,
    v14157: ( state_type * $int ) > $o ).

tff(pred_def_8320,type,
    v14155: ( state_type * $int ) > $o ).

tff(pred_def_8321,type,
    v14153: ( state_type * $int ) > $o ).

tff(pred_def_8322,type,
    v14151: ( state_type * $int ) > $o ).

tff(pred_def_8323,type,
    v14145: state_type > $o ).

tff(pred_def_8324,type,
    v14143: state_type > $o ).

tff(pred_def_8325,type,
    v14141: state_type > $o ).

tff(pred_def_8326,type,
    v15699: ( state_type * $int ) > $o ).

tff(pred_def_8327,type,
    v15697: ( state_type * $int ) > $o ).

tff(pred_def_8328,type,
    v15733: state_type > $o ).

tff(pred_def_8329,type,
    v15731: state_type > $o ).

tff(pred_def_8330,type,
    v15729: state_type > $o ).

tff(pred_def_8331,type,
    v15727: state_type > $o ).

tff(pred_def_8332,type,
    v15725: state_type > $o ).

tff(pred_def_8333,type,
    v15723: state_type > $o ).

tff(pred_def_8334,type,
    v15721: state_type > $o ).

tff(pred_def_8335,type,
    v15747: state_type > $o ).

tff(pred_def_8336,type,
    v15745: state_type > $o ).

tff(pred_def_8337,type,
    v15743: state_type > $o ).

tff(pred_def_8338,type,
    v15741: state_type > $o ).

tff(pred_def_8339,type,
    v15739: state_type > $o ).

tff(pred_def_8340,type,
    v15737: state_type > $o ).

tff(pred_def_8341,type,
    v15735: state_type > $o ).

tff(pred_def_8342,type,
    v15773: state_type > $o ).

tff(pred_def_8343,type,
    v15775: state_type > $o ).

tff(pred_def_8344,type,
    v15774: ( state_type * $int ) > $o ).

tff(pred_def_8345,type,
    v15776: state_type > $o ).

tff(pred_def_8346,type,
    v15771: ( state_type * $int ) > $o ).

tff(pred_def_8347,type,
    v15769: ( state_type * $int ) > $o ).

tff(pred_def_8348,type,
    v15777: ( state_type * $int ) > $o ).

tff(pred_def_8349,type,
    v15767: ( state_type * $int ) > $o ).

tff(pred_def_8350,type,
    v15765: ( state_type * $int ) > $o ).

tff(pred_def_8351,type,
    v15763: state_type > $o ).

tff(pred_def_8352,type,
    v15779: state_type > $o ).

tff(pred_def_8353,type,
    v15761: ( state_type * $int ) > $o ).

tff(pred_def_8354,type,
    v15759: ( state_type * $int ) > $o ).

tff(pred_def_8355,type,
    v15793: ( state_type * $int ) > $o ).

tff(pred_def_8356,type,
    v15791: ( state_type * $int ) > $o ).

tff(pred_def_8357,type,
    v15797: state_type > $o ).

tff(pred_def_8358,type,
    v15795: state_type > $o ).

tff(pred_def_8359,type,
    v15821: state_type > $o ).

tff(pred_def_8360,type,
    v15819: state_type > $o ).

tff(pred_def_8361,type,
    v15817: state_type > $o ).

tff(pred_def_8362,type,
    v15815: state_type > $o ).

tff(pred_def_8363,type,
    v15813: state_type > $o ).

tff(pred_def_8364,type,
    v15811: state_type > $o ).

tff(pred_def_8365,type,
    v15809: state_type > $o ).

tff(pred_def_8366,type,
    v15835: state_type > $o ).

tff(pred_def_8367,type,
    v15833: state_type > $o ).

tff(pred_def_8368,type,
    v15831: state_type > $o ).

tff(pred_def_8369,type,
    v15829: state_type > $o ).

tff(pred_def_8370,type,
    v15827: state_type > $o ).

tff(pred_def_8371,type,
    v15825: state_type > $o ).

tff(pred_def_8372,type,
    v15823: state_type > $o ).

tff(pred_def_8373,type,
    v15851: ( state_type * $int ) > $o ).

tff(pred_def_8374,type,
    v15849: ( state_type * $int ) > $o ).

tff(pred_def_8375,type,
    v15847: ( state_type * $int ) > $o ).

tff(pred_def_8376,type,
    v15845: ( state_type * $int ) > $o ).

tff(pred_def_8377,type,
    v15843: ( state_type * $int ) > $o ).

tff(pred_def_8378,type,
    v15881: ( state_type * $int ) > $o ).

tff(pred_def_8379,type,
    v15883: ( state_type * $int ) > $o ).

tff(pred_def_8380,type,
    v15879: ( state_type * $int ) > $o ).

tff(pred_def_8381,type,
    v15877: ( state_type * $int ) > $o ).

tff(pred_def_8382,type,
    v15875: ( state_type * $int ) > $o ).

tff(pred_def_8383,type,
    v15873: ( state_type * $int ) > $o ).

tff(pred_def_8384,type,
    v15871: state_type > $o ).

tff(pred_def_8385,type,
    v15869: state_type > $o ).

tff(pred_def_8386,type,
    v15887: state_type > $o ).

tff(pred_def_8387,type,
    v15885: state_type > $o ).

tff(pred_def_8388,type,
    v15889: state_type > $o ).

tff(pred_def_8389,type,
    v15867: state_type > $o ).

tff(pred_def_8390,type,
    v15865: state_type > $o ).

tff(pred_def_8391,type,
    v15863: state_type > $o ).

tff(pred_def_8392,type,
    v15861: state_type > $o ).

tff(pred_def_8393,type,
    v15859: state_type > $o ).

tff(pred_def_8394,type,
    v15857: state_type > $o ).

tff(pred_def_8395,type,
    v15855: state_type > $o ).

tff(pred_def_8396,type,
    v15853: state_type > $o ).

tff(pred_def_8397,type,
    v15899: ( state_type * $int ) > $o ).

tff(pred_def_8398,type,
    v15897: ( state_type * $int ) > $o ).

tff(pred_def_8399,type,
    v15895: ( state_type * $int ) > $o ).

tff(pred_def_8400,type,
    v15893: ( state_type * $int ) > $o ).

tff(pred_def_8401,type,
    v15891: ( state_type * $int ) > $o ).

tff(pred_def_8402,type,
    v15929: ( state_type * $int ) > $o ).

tff(pred_def_8403,type,
    v15927: ( state_type * $int ) > $o ).

tff(pred_def_8404,type,
    v15930: ( state_type * $int ) > $o ).

tff(pred_def_8405,type,
    v15925: ( state_type * $int ) > $o ).

tff(pred_def_8406,type,
    v15923: ( state_type * $int ) > $o ).

tff(pred_def_8407,type,
    v15921: ( state_type * $int ) > $o ).

tff(pred_def_8408,type,
    v15919: state_type > $o ).

tff(pred_def_8409,type,
    v15917: state_type > $o ).

tff(pred_def_8410,type,
    v15934: state_type > $o ).

tff(pred_def_8411,type,
    v15932: state_type > $o ).

tff(pred_def_8412,type,
    v15936: state_type > $o ).

tff(pred_def_8413,type,
    v15915: state_type > $o ).

tff(pred_def_8414,type,
    v15913: state_type > $o ).

tff(pred_def_8415,type,
    v15911: state_type > $o ).

tff(pred_def_8416,type,
    v15909: state_type > $o ).

tff(pred_def_8417,type,
    v15907: state_type > $o ).

tff(pred_def_8418,type,
    v15905: state_type > $o ).

tff(pred_def_8419,type,
    v15903: state_type > $o ).

tff(pred_def_8420,type,
    v15901: state_type > $o ).

tff(pred_def_8421,type,
    v15946: ( state_type * $int ) > $o ).

tff(pred_def_8422,type,
    v15944: ( state_type * $int ) > $o ).

tff(pred_def_8423,type,
    v15942: ( state_type * $int ) > $o ).

tff(pred_def_8424,type,
    v15940: ( state_type * $int ) > $o ).

tff(pred_def_8425,type,
    v15938: ( state_type * $int ) > $o ).

tff(pred_def_8426,type,
    v15966: state_type > $o ).

tff(pred_def_8427,type,
    v15964: state_type > $o ).

tff(pred_def_8428,type,
    v15970: state_type > $o ).

tff(pred_def_8429,type,
    v15968: state_type > $o ).

tff(pred_def_8430,type,
    v15972: state_type > $o ).

tff(pred_def_8431,type,
    v15962: state_type > $o ).

tff(pred_def_8432,type,
    v15960: state_type > $o ).

tff(pred_def_8433,type,
    v15958: state_type > $o ).

tff(pred_def_8434,type,
    v15956: state_type > $o ).

tff(pred_def_8435,type,
    v15954: state_type > $o ).

tff(pred_def_8436,type,
    v15952: state_type > $o ).

tff(pred_def_8437,type,
    v15950: state_type > $o ).

tff(pred_def_8438,type,
    v15948: state_type > $o ).

tff(pred_def_8439,type,
    v15982: ( state_type * $int ) > $o ).

tff(pred_def_8440,type,
    v15980: ( state_type * $int ) > $o ).

tff(pred_def_8441,type,
    v15978: ( state_type * $int ) > $o ).

tff(pred_def_8442,type,
    v15976: ( state_type * $int ) > $o ).

tff(pred_def_8443,type,
    v15974: ( state_type * $int ) > $o ).

tff(pred_def_8444,type,
    v16002: state_type > $o ).

tff(pred_def_8445,type,
    v16000: state_type > $o ).

tff(pred_def_8446,type,
    v16006: state_type > $o ).

tff(pred_def_8447,type,
    v16004: state_type > $o ).

tff(pred_def_8448,type,
    v16008: state_type > $o ).

tff(pred_def_8449,type,
    v15998: state_type > $o ).

tff(pred_def_8450,type,
    v15996: state_type > $o ).

tff(pred_def_8451,type,
    v15994: state_type > $o ).

tff(pred_def_8452,type,
    v15992: state_type > $o ).

tff(pred_def_8453,type,
    v15990: state_type > $o ).

tff(pred_def_8454,type,
    v15988: state_type > $o ).

tff(pred_def_8455,type,
    v15986: state_type > $o ).

tff(pred_def_8456,type,
    v15984: state_type > $o ).

tff(pred_def_8457,type,
    v16014: state_type > $o ).

tff(pred_def_8458,type,
    v16013: ( state_type * $int ) > $o ).

tff(pred_def_8459,type,
    v16012: ( state_type * $int ) > $o ).

tff(pred_def_8460,type,
    v16017: state_type > $o ).

tff(pred_def_8461,type,
    v16016: ( state_type * $int ) > $o ).

tff(pred_def_8462,type,
    v16015: ( state_type * $int ) > $o ).

tff(pred_def_8463,type,
    v16011: ( state_type * $int ) > $o ).

tff(pred_def_8464,type,
    v16020: state_type > $o ).

tff(pred_def_8465,type,
    v16019: ( state_type * $int ) > $o ).

tff(pred_def_8466,type,
    v16018: ( state_type * $int ) > $o ).

tff(pred_def_8467,type,
    v16010: ( state_type * $int ) > $o ).

tff(pred_def_8468,type,
    v16023: state_type > $o ).

tff(pred_def_8469,type,
    v16022: ( state_type * $int ) > $o ).

tff(pred_def_8470,type,
    v16021: ( state_type * $int ) > $o ).

tff(pred_def_8471,type,
    v15841: ( state_type * $int ) > $o ).

tff(pred_def_8472,type,
    v15839: ( state_type * $int ) > $o ).

tff(pred_def_8473,type,
    v15837: ( state_type * $int ) > $o ).

tff(pred_def_8474,type,
    v16035: state_type > $o ).

tff(pred_def_8475,type,
    v16033: state_type > $o ).

tff(pred_def_8476,type,
    v16031: state_type > $o ).

tff(pred_def_8477,type,
    v16045: state_type > $o ).

tff(pred_def_8478,type,
    v16043: state_type > $o ).

tff(pred_def_8479,type,
    v16041: state_type > $o ).

tff(pred_def_8480,type,
    v16039: state_type > $o ).

tff(pred_def_8481,type,
    v16037: state_type > $o ).

tff(pred_def_8482,type,
    v16047: state_type > $o ).

tff(pred_def_8483,type,
    v16029: state_type > $o ).

tff(pred_def_8484,type,
    v16027: state_type > $o ).

tff(pred_def_8485,type,
    v16025: state_type > $o ).

tff(pred_def_8486,type,
    v16054: state_type > $o ).

tff(pred_def_8487,type,
    v16052: state_type > $o ).

tff(pred_def_8488,type,
    v16051: state_type > $o ).

tff(pred_def_8489,type,
    v16050: state_type > $o ).

tff(pred_def_8490,type,
    v16062: state_type > $o ).

tff(pred_def_8491,type,
    v16063: state_type > $o ).

tff(pred_def_8492,type,
    v16061: state_type > $o ).

tff(pred_def_8493,type,
    v16058: ( state_type * $int ) > $o ).

tff(pred_def_8494,type,
    v16060: ( state_type * $int ) > $o ).

tff(pred_def_8495,type,
    v15807: ( state_type * $int ) > $o ).

tff(pred_def_8496,type,
    v15805: ( state_type * $int ) > $o ).

tff(pred_def_8497,type,
    v15803: ( state_type * $int ) > $o ).

tff(pred_def_8498,type,
    v15801: ( state_type * $int ) > $o ).

tff(pred_def_8499,type,
    v15799: ( state_type * $int ) > $o ).

tff(pred_def_8500,type,
    v16069: state_type > $o ).

tff(pred_def_8501,type,
    v16067: state_type > $o ).

tff(pred_def_8502,type,
    v16073: state_type > $o ).

tff(pred_def_8503,type,
    v16072: ( state_type * $int ) > $o ).

tff(pred_def_8504,type,
    v16071: ( state_type * $int ) > $o ).

tff(pred_def_8505,type,
    v16076: state_type > $o ).

tff(pred_def_8506,type,
    v16075: ( state_type * $int ) > $o ).

tff(pred_def_8507,type,
    v16074: ( state_type * $int ) > $o ).

tff(pred_def_8508,type,
    v15789: ( state_type * $int ) > $o ).

tff(pred_def_8509,type,
    v15787: ( state_type * $int ) > $o ).

tff(pred_def_8510,type,
    v15785: ( state_type * $int ) > $o ).

tff(pred_def_8511,type,
    v15783: ( state_type * $int ) > $o ).

tff(pred_def_8512,type,
    v15781: ( state_type * $int ) > $o ).

tff(pred_def_8513,type,
    v15757: ( state_type * $int ) > $o ).

tff(pred_def_8514,type,
    v15755: ( state_type * $int ) > $o ).

tff(pred_def_8515,type,
    v15753: ( state_type * $int ) > $o ).

tff(pred_def_8516,type,
    v15751: ( state_type * $int ) > $o ).

tff(pred_def_8517,type,
    v15749: ( state_type * $int ) > $o ).

tff(pred_def_8518,type,
    v16089: state_type > $o ).

tff(pred_def_8519,type,
    v16087: state_type > $o ).

tff(pred_def_8520,type,
    v16085: state_type > $o ).

tff(pred_def_8521,type,
    v16095: state_type > $o ).

tff(pred_def_8522,type,
    v16093: state_type > $o ).

tff(pred_def_8523,type,
    v16113: ( state_type * $int ) > $o ).

tff(pred_def_8524,type,
    v16115: ( state_type * $int ) > $o ).

tff(pred_def_8525,type,
    v16111: ( state_type * $int ) > $o ).

tff(pred_def_8526,type,
    v16109: state_type > $o ).

tff(pred_def_8527,type,
    v16107: state_type > $o ).

tff(pred_def_8528,type,
    v16119: state_type > $o ).

tff(pred_def_8529,type,
    v16117: state_type > $o ).

tff(pred_def_8530,type,
    v16123: state_type > $o ).

tff(pred_def_8531,type,
    v16121: state_type > $o ).

tff(pred_def_8532,type,
    v16126: state_type > $o ).

tff(pred_def_8533,type,
    v16125: state_type > $o ).

tff(pred_def_8534,type,
    v16105: state_type > $o ).

tff(pred_def_8535,type,
    v16103: state_type > $o ).

tff(pred_def_8536,type,
    v16101: state_type > $o ).

tff(pred_def_8537,type,
    v16099: state_type > $o ).

tff(pred_def_8538,type,
    v16097: state_type > $o ).

tff(pred_def_8539,type,
    v16134: state_type > $o ).

tff(pred_def_8540,type,
    v16132: state_type > $o ).

tff(pred_def_8541,type,
    v16130: state_type > $o ).

tff(pred_def_8542,type,
    v16128: state_type > $o ).

tff(pred_def_8543,type,
    v16091: state_type > $o ).

tff(pred_def_8544,type,
    v16140: state_type > $o ).

tff(pred_def_8545,type,
    v16142: state_type > $o ).

tff(pred_def_8546,type,
    v16138: state_type > $o ).

tff(pred_def_8547,type,
    v16137: state_type > $o ).

tff(pred_def_8548,type,
    v16148: state_type > $o ).

tff(pred_def_8549,type,
    v16149: state_type > $o ).

tff(pred_def_8550,type,
    v16145: state_type > $o ).

tff(pred_def_8551,type,
    v16147: state_type > $o ).

tff(pred_def_8552,type,
    v16159: state_type > $o ).

tff(pred_def_8553,type,
    v16157: state_type > $o ).

tff(pred_def_8554,type,
    v16155: state_type > $o ).

tff(pred_def_8555,type,
    v16153: state_type > $o ).

tff(pred_def_8556,type,
    v16161: state_type > $o ).

tff(pred_def_8557,type,
    v16083: state_type > $o ).

tff(pred_def_8558,type,
    v16081: state_type > $o ).

tff(pred_def_8559,type,
    v16079: state_type > $o ).

tff(pred_def_8560,type,
    v16168: state_type > $o ).

tff(pred_def_8561,type,
    v16166: state_type > $o ).

tff(pred_def_8562,type,
    v16165: state_type > $o ).

tff(pred_def_8563,type,
    v16164: state_type > $o ).

tff(pred_def_8564,type,
    v16176: state_type > $o ).

tff(pred_def_8565,type,
    v16177: state_type > $o ).

tff(pred_def_8566,type,
    v16175: state_type > $o ).

tff(pred_def_8567,type,
    v16172: ( state_type * $int ) > $o ).

tff(pred_def_8568,type,
    v16174: ( state_type * $int ) > $o ).

tff(pred_def_8569,type,
    v15719: ( state_type * $int ) > $o ).

tff(pred_def_8570,type,
    v15717: ( state_type * $int ) > $o ).

tff(pred_def_8571,type,
    v15715: ( state_type * $int ) > $o ).

tff(pred_def_8572,type,
    v15713: ( state_type * $int ) > $o ).

tff(pred_def_8573,type,
    v15711: ( state_type * $int ) > $o ).

tff(pred_def_8574,type,
    v16213: state_type > $o ).

tff(pred_def_8575,type,
    v16211: state_type > $o ).

tff(pred_def_8576,type,
    v16209: state_type > $o ).

tff(pred_def_8577,type,
    v16207: state_type > $o ).

tff(pred_def_8578,type,
    v16205: state_type > $o ).

tff(pred_def_8579,type,
    v16203: state_type > $o ).

tff(pred_def_8580,type,
    v16223: state_type > $o ).

tff(pred_def_8581,type,
    v16221: state_type > $o ).

tff(pred_def_8582,type,
    v16219: state_type > $o ).

tff(pred_def_8583,type,
    v16217: state_type > $o ).

tff(pred_def_8584,type,
    v16215: state_type > $o ).

tff(pred_def_8585,type,
    v16250: state_type > $o ).

tff(pred_def_8586,type,
    v16249: ( state_type * $int ) > $o ).

tff(pred_def_8587,type,
    v16248: ( state_type * $int ) > $o ).

tff(pred_def_8588,type,
    v16246: ( state_type * $int ) > $o ).

tff(pred_def_8589,type,
    v16266: state_type > $o ).

tff(pred_def_8590,type,
    v16267: ( state_type * $int ) > $o ).

tff(pred_def_8591,type,
    v16268: state_type > $o ).

tff(pred_def_8592,type,
    v16264: ( state_type * $int ) > $o ).

tff(pred_def_8593,type,
    v16262: ( state_type * $int ) > $o ).

tff(pred_def_8594,type,
    v16292: ( state_type * $int ) > $o ).

tff(pred_def_8595,type,
    v16201: ( state_type * $int ) > $o ).

tff(pred_def_8596,type,
    v16290: ( state_type * $int ) > $o ).

tff(pred_def_8597,type,
    v16293: ( state_type * $int ) > $o ).

tff(pred_def_8598,type,
    v16288: ( state_type * $int ) > $o ).

tff(pred_def_8599,type,
    v16286: ( state_type * $int ) > $o ).

tff(pred_def_8600,type,
    v16284: ( state_type * $int ) > $o ).

tff(pred_def_8601,type,
    v16282: state_type > $o ).

tff(pred_def_8602,type,
    v16280: state_type > $o ).

tff(pred_def_8603,type,
    v16299: state_type > $o ).

tff(pred_def_8604,type,
    v16239: state_type > $o ).

tff(pred_def_8605,type,
    v16298: ( state_type * $int ) > $o ).

tff(pred_def_8606,type,
    v16237: ( state_type * $int ) > $o ).

tff(pred_def_8607,type,
    v16235: ( state_type * $int ) > $o ).

tff(pred_def_8608,type,
    v16314: ( state_type * $int ) > $o ).

tff(pred_def_8609,type,
    v16313: ( state_type * $int ) > $o ).

tff(pred_def_8610,type,
    v16311: ( state_type * $int ) > $o ).

tff(pred_def_8611,type,
    v16318: state_type > $o ).

tff(pred_def_8612,type,
    v16316: state_type > $o ).

tff(pred_def_8613,type,
    v16329: ( state_type * $int ) > $o ).

tff(pred_def_8614,type,
    v16328: state_type > $o ).

tff(pred_def_8615,type,
    v16332: state_type > $o ).

tff(pred_def_8616,type,
    v16333: state_type > $o ).

tff(pred_def_8617,type,
    v16331: state_type > $o ).

tff(pred_def_8618,type,
    v16334: state_type > $o ).

tff(pred_def_8619,type,
    v16330: state_type > $o ).

tff(pred_def_8620,type,
    v16327: state_type > $o ).

tff(pred_def_8621,type,
    v16335: state_type > $o ).

tff(pred_def_8622,type,
    v16326: state_type > $o ).

tff(pred_def_8623,type,
    v16338: state_type > $o ).

tff(pred_def_8624,type,
    v16339: state_type > $o ).

tff(pred_def_8625,type,
    v16337: state_type > $o ).

tff(pred_def_8626,type,
    v16340: state_type > $o ).

tff(pred_def_8627,type,
    v16336: state_type > $o ).

tff(pred_def_8628,type,
    v16325: state_type > $o ).

tff(pred_def_8629,type,
    v16341: state_type > $o ).

tff(pred_def_8630,type,
    v16324: state_type > $o ).

tff(pred_def_8631,type,
    v16323: state_type > $o ).

tff(pred_def_8632,type,
    v16345: state_type > $o ).

tff(pred_def_8633,type,
    v16346: state_type > $o ).

tff(pred_def_8634,type,
    v16344: state_type > $o ).

tff(pred_def_8635,type,
    v16347: state_type > $o ).

tff(pred_def_8636,type,
    v16343: state_type > $o ).

tff(pred_def_8637,type,
    v16342: state_type > $o ).

tff(pred_def_8638,type,
    v16322: state_type > $o ).

tff(pred_def_8639,type,
    v16348: state_type > $o ).

tff(pred_def_8640,type,
    v16321: state_type > $o ).

tff(pred_def_8641,type,
    v16351: state_type > $o ).

tff(pred_def_8642,type,
    v16352: state_type > $o ).

tff(pred_def_8643,type,
    v16350: state_type > $o ).

tff(pred_def_8644,type,
    v16353: state_type > $o ).

tff(pred_def_8645,type,
    v16349: state_type > $o ).

tff(pred_def_8646,type,
    v16356: state_type > $o ).

tff(pred_def_8647,type,
    v16357: state_type > $o ).

tff(pred_def_8648,type,
    v16355: state_type > $o ).

tff(pred_def_8649,type,
    v16358: state_type > $o ).

tff(pred_def_8650,type,
    v16354: state_type > $o ).

tff(pred_def_8651,type,
    v16361: state_type > $o ).

tff(pred_def_8652,type,
    v16362: state_type > $o ).

tff(pred_def_8653,type,
    v16360: state_type > $o ).

tff(pred_def_8654,type,
    v16363: state_type > $o ).

tff(pred_def_8655,type,
    v16359: state_type > $o ).

tff(pred_def_8656,type,
    v16319: ( state_type * $int ) > $o ).

tff(pred_def_8657,type,
    v16309: ( state_type * $int ) > $o ).

tff(pred_def_8658,type,
    v16307: ( state_type * $int ) > $o ).

tff(pred_def_8659,type,
    v16305: ( state_type * $int ) > $o ).

tff(pred_def_8660,type,
    v16303: ( state_type * $int ) > $o ).

tff(pred_def_8661,type,
    v16301: ( state_type * $int ) > $o ).

tff(pred_def_8662,type,
    v16364: ( state_type * $int ) > $o ).

tff(pred_def_8663,type,
    v16233: ( state_type * $int ) > $o ).

tff(pred_def_8664,type,
    v16231: ( state_type * $int ) > $o ).

tff(pred_def_8665,type,
    v16229: ( state_type * $int ) > $o ).

tff(pred_def_8666,type,
    v16365: ( state_type * $int ) > $o ).

tff(pred_def_8667,type,
    v16366: ( state_type * $int ) > $o ).

tff(pred_def_8668,type,
    v16227: ( state_type * $int ) > $o ).

tff(pred_def_8669,type,
    v16225: ( state_type * $int ) > $o ).

tff(pred_def_8670,type,
    v16376: state_type > $o ).

tff(pred_def_8671,type,
    v16374: state_type > $o ).

tff(pred_def_8672,type,
    v16382: state_type > $o ).

tff(pred_def_8673,type,
    v16380: state_type > $o ).

tff(pred_def_8674,type,
    v16386: state_type > $o ).

tff(pred_def_8675,type,
    v16384: state_type > $o ).

tff(pred_def_8676,type,
    v16390: state_type > $o ).

tff(pred_def_8677,type,
    v16388: state_type > $o ).

tff(pred_def_8678,type,
    v16378: state_type > $o ).

tff(pred_def_8679,type,
    v16396: state_type > $o ).

tff(pred_def_8680,type,
    v16398: state_type > $o ).

tff(pred_def_8681,type,
    v16394: state_type > $o ).

tff(pred_def_8682,type,
    v16393: state_type > $o ).

tff(pred_def_8683,type,
    v16404: state_type > $o ).

tff(pred_def_8684,type,
    v16405: state_type > $o ).

tff(pred_def_8685,type,
    v16401: state_type > $o ).

tff(pred_def_8686,type,
    v16403: state_type > $o ).

tff(pred_def_8687,type,
    v16411: state_type > $o ).

tff(pred_def_8688,type,
    v16409: state_type > $o ).

tff(pred_def_8689,type,
    v16413: state_type > $o ).

tff(pred_def_8690,type,
    v16372: state_type > $o ).

tff(pred_def_8691,type,
    v16370: state_type > $o ).

tff(pred_def_8692,type,
    v16368: state_type > $o ).

tff(pred_def_8693,type,
    v16420: state_type > $o ).

tff(pred_def_8694,type,
    v16418: state_type > $o ).

tff(pred_def_8695,type,
    v16417: state_type > $o ).

tff(pred_def_8696,type,
    v16416: state_type > $o ).

tff(pred_def_8697,type,
    v16428: state_type > $o ).

tff(pred_def_8698,type,
    v16429: state_type > $o ).

tff(pred_def_8699,type,
    v16427: state_type > $o ).

tff(pred_def_8700,type,
    v16424: ( state_type * $int ) > $o ).

tff(pred_def_8701,type,
    v16426: ( state_type * $int ) > $o ).

tff(pred_def_8702,type,
    v16415: ( state_type * $int ) > $o ).

tff(pred_def_8703,type,
    v16297: state_type > $o ).

tff(pred_def_8704,type,
    v16295: state_type > $o ).

tff(pred_def_8705,type,
    v16441: state_type > $o ).

tff(pred_def_8706,type,
    v16439: state_type > $o ).

tff(pred_def_8707,type,
    v16438: state_type > $o ).

tff(pred_def_8708,type,
    v16437: ( state_type * $int ) > $o ).

tff(pred_def_8709,type,
    v16435: state_type > $o ).

tff(pred_def_8710,type,
    v16433: state_type > $o ).

tff(pred_def_8711,type,
    v16446: state_type > $o ).

tff(pred_def_8712,type,
    v16445: state_type > $o ).

tff(pred_def_8713,type,
    v16278: state_type > $o ).

tff(pred_def_8714,type,
    v16276: state_type > $o ).

tff(pred_def_8715,type,
    v16274: state_type > $o ).

tff(pred_def_8716,type,
    v16447: ( state_type * $int ) > $o ).

tff(pred_def_8717,type,
    v16448: state_type > $o ).

tff(pred_def_8718,type,
    v16272: ( state_type * $int ) > $o ).

tff(pred_def_8719,type,
    v16270: ( state_type * $int ) > $o ).

tff(pred_def_8720,type,
    v16449: ( state_type * $int ) > $o ).

tff(pred_def_8721,type,
    v16260: ( state_type * $int ) > $o ).

tff(pred_def_8722,type,
    v16258: ( state_type * $int ) > $o ).

tff(pred_def_8723,type,
    v16256: state_type > $o ).

tff(pred_def_8724,type,
    v16450: ( state_type * $int ) > $o ).

tff(pred_def_8725,type,
    v16451: state_type > $o ).

tff(pred_def_8726,type,
    v16254: ( state_type * $int ) > $o ).

tff(pred_def_8727,type,
    v16252: ( state_type * $int ) > $o ).

tff(pred_def_8728,type,
    v16452: ( state_type * $int ) > $o ).

tff(pred_def_8729,type,
    v16244: ( state_type * $int ) > $o ).

tff(pred_def_8730,type,
    v16242: ( state_type * $int ) > $o ).

tff(pred_def_8731,type,
    v16458: state_type > $o ).

tff(pred_def_8732,type,
    v16456: state_type > $o ).

tff(pred_def_8733,type,
    v16455: state_type > $o ).

tff(pred_def_8734,type,
    v16454: ( state_type * $int ) > $o ).

tff(pred_def_8735,type,
    v16199: state_type > $o ).

tff(pred_def_8736,type,
    v16197: state_type > $o ).

tff(pred_def_8737,type,
    v16464: state_type > $o ).

tff(pred_def_8738,type,
    v16462: state_type > $o ).

tff(pred_def_8739,type,
    v16468: state_type > $o ).

tff(pred_def_8740,type,
    v16466: state_type > $o ).

tff(pred_def_8741,type,
    v16471: state_type > $o ).

tff(pred_def_8742,type,
    v16470: state_type > $o ).

tff(pred_def_8743,type,
    v16195: state_type > $o ).

tff(pred_def_8744,type,
    v16193: state_type > $o ).

tff(pred_def_8745,type,
    v16191: state_type > $o ).

tff(pred_def_8746,type,
    v16189: state_type > $o ).

tff(pred_def_8747,type,
    v16187: state_type > $o ).

tff(pred_def_8748,type,
    v16185: state_type > $o ).

tff(pred_def_8749,type,
    v16183: state_type > $o ).

tff(pred_def_8750,type,
    v16181: state_type > $o ).

tff(pred_def_8751,type,
    v16491: state_type > $o ).

tff(pred_def_8752,type,
    v16489: state_type > $o ).

tff(pred_def_8753,type,
    v16487: state_type > $o ).

tff(pred_def_8754,type,
    v16485: state_type > $o ).

tff(pred_def_8755,type,
    v16483: state_type > $o ).

tff(pred_def_8756,type,
    v16501: state_type > $o ).

tff(pred_def_8757,type,
    v16499: state_type > $o ).

tff(pred_def_8758,type,
    v16497: state_type > $o ).

tff(pred_def_8759,type,
    v16495: state_type > $o ).

tff(pred_def_8760,type,
    v16493: state_type > $o ).

tff(pred_def_8761,type,
    v16505: ( state_type * $int ) > $o ).

tff(pred_def_8762,type,
    v16503: ( state_type * $int ) > $o ).

tff(pred_def_8763,type,
    v16515: state_type > $o ).

tff(pred_def_8764,type,
    v16513: state_type > $o ).

tff(pred_def_8765,type,
    v16521: state_type > $o ).

tff(pred_def_8766,type,
    v16519: state_type > $o ).

tff(pred_def_8767,type,
    v16545: ( state_type * $int ) > $o ).

tff(pred_def_8768,type,
    v16543: ( state_type * $int ) > $o ).

tff(pred_def_8769,type,
    v16546: ( state_type * $int ) > $o ).

tff(pred_def_8770,type,
    v16541: ( state_type * $int ) > $o ).

tff(pred_def_8771,type,
    v16539: ( state_type * $int ) > $o ).

tff(pred_def_8772,type,
    v16537: ( state_type * $int ) > $o ).

tff(pred_def_8773,type,
    v16535: state_type > $o ).

tff(pred_def_8774,type,
    v16533: state_type > $o ).

tff(pred_def_8775,type,
    v16550: state_type > $o ).

tff(pred_def_8776,type,
    v16548: state_type > $o ).

tff(pred_def_8777,type,
    v16554: state_type > $o ).

tff(pred_def_8778,type,
    v16552: state_type > $o ).

tff(pred_def_8779,type,
    v16557: state_type > $o ).

tff(pred_def_8780,type,
    v16556: state_type > $o ).

tff(pred_def_8781,type,
    v16531: state_type > $o ).

tff(pred_def_8782,type,
    v16529: state_type > $o ).

tff(pred_def_8783,type,
    v16527: state_type > $o ).

tff(pred_def_8784,type,
    v16525: state_type > $o ).

tff(pred_def_8785,type,
    v16523: state_type > $o ).

tff(pred_def_8786,type,
    v16561: state_type > $o ).

tff(pred_def_8787,type,
    v16559: state_type > $o ).

tff(pred_def_8788,type,
    v16517: state_type > $o ).

tff(pred_def_8789,type,
    v16567: state_type > $o ).

tff(pred_def_8790,type,
    v16569: state_type > $o ).

tff(pred_def_8791,type,
    v16565: state_type > $o ).

tff(pred_def_8792,type,
    v16564: state_type > $o ).

tff(pred_def_8793,type,
    v16575: state_type > $o ).

tff(pred_def_8794,type,
    v16576: state_type > $o ).

tff(pred_def_8795,type,
    v16572: state_type > $o ).

tff(pred_def_8796,type,
    v16574: state_type > $o ).

tff(pred_def_8797,type,
    v16582: state_type > $o ).

tff(pred_def_8798,type,
    v16580: state_type > $o ).

tff(pred_def_8799,type,
    v16584: state_type > $o ).

tff(pred_def_8800,type,
    v16511: state_type > $o ).

tff(pred_def_8801,type,
    v16509: state_type > $o ).

tff(pred_def_8802,type,
    v16507: state_type > $o ).

tff(pred_def_8803,type,
    v16591: state_type > $o ).

tff(pred_def_8804,type,
    v16589: state_type > $o ).

tff(pred_def_8805,type,
    v16588: state_type > $o ).

tff(pred_def_8806,type,
    v16587: state_type > $o ).

tff(pred_def_8807,type,
    v16599: state_type > $o ).

tff(pred_def_8808,type,
    v16600: state_type > $o ).

tff(pred_def_8809,type,
    v16598: state_type > $o ).

tff(pred_def_8810,type,
    v16595: ( state_type * $int ) > $o ).

tff(pred_def_8811,type,
    v16597: ( state_type * $int ) > $o ).

tff(pred_def_8812,type,
    v16481: ( state_type * $int ) > $o ).

tff(pred_def_8813,type,
    v16479: ( state_type * $int ) > $o ).

tff(pred_def_8814,type,
    v16477: ( state_type * $int ) > $o ).

tff(pred_def_8815,type,
    v16475: ( state_type * $int ) > $o ).

tff(pred_def_8816,type,
    v16473: ( state_type * $int ) > $o ).

tff(pred_def_8817,type,
    v16622: state_type > $o ).

tff(pred_def_8818,type,
    v16620: state_type > $o ).

tff(pred_def_8819,type,
    v16626: state_type > $o ).

tff(pred_def_8820,type,
    v16624: state_type > $o ).

tff(pred_def_8821,type,
    v16630: state_type > $o ).

tff(pred_def_8822,type,
    v16628: state_type > $o ).

tff(pred_def_8823,type,
    v16633: state_type > $o ).

tff(pred_def_8824,type,
    v16632: state_type > $o ).

tff(pred_def_8825,type,
    v16618: state_type > $o ).

tff(pred_def_8826,type,
    v16616: state_type > $o ).

tff(pred_def_8827,type,
    v16614: state_type > $o ).

tff(pred_def_8828,type,
    v16612: state_type > $o ).

tff(pred_def_8829,type,
    v16610: state_type > $o ).

tff(pred_def_8830,type,
    v16608: state_type > $o ).

tff(pred_def_8831,type,
    v16606: state_type > $o ).

tff(pred_def_8832,type,
    v16604: state_type > $o ).

tff(pred_def_8833,type,
    v16653: state_type > $o ).

tff(pred_def_8834,type,
    v16651: state_type > $o ).

tff(pred_def_8835,type,
    v16649: state_type > $o ).

tff(pred_def_8836,type,
    v16647: state_type > $o ).

tff(pred_def_8837,type,
    v16645: state_type > $o ).

tff(pred_def_8838,type,
    v16663: state_type > $o ).

tff(pred_def_8839,type,
    v16661: state_type > $o ).

tff(pred_def_8840,type,
    v16659: state_type > $o ).

tff(pred_def_8841,type,
    v16657: state_type > $o ).

tff(pred_def_8842,type,
    v16655: state_type > $o ).

tff(pred_def_8843,type,
    v16667: ( state_type * $int ) > $o ).

tff(pred_def_8844,type,
    v16665: ( state_type * $int ) > $o ).

tff(pred_def_8845,type,
    v16677: state_type > $o ).

tff(pred_def_8846,type,
    v16675: state_type > $o ).

tff(pred_def_8847,type,
    v16683: state_type > $o ).

tff(pred_def_8848,type,
    v16681: state_type > $o ).

tff(pred_def_8849,type,
    v16697: state_type > $o ).

tff(pred_def_8850,type,
    v16695: state_type > $o ).

tff(pred_def_8851,type,
    v16701: state_type > $o ).

tff(pred_def_8852,type,
    v16699: state_type > $o ).

tff(pred_def_8853,type,
    v16705: state_type > $o ).

tff(pred_def_8854,type,
    v16703: state_type > $o ).

tff(pred_def_8855,type,
    v16708: state_type > $o ).

tff(pred_def_8856,type,
    v16707: state_type > $o ).

tff(pred_def_8857,type,
    v16693: state_type > $o ).

tff(pred_def_8858,type,
    v16691: state_type > $o ).

tff(pred_def_8859,type,
    v16689: state_type > $o ).

tff(pred_def_8860,type,
    v16687: state_type > $o ).

tff(pred_def_8861,type,
    v16685: state_type > $o ).

tff(pred_def_8862,type,
    v16712: state_type > $o ).

tff(pred_def_8863,type,
    v16710: state_type > $o ).

tff(pred_def_8864,type,
    v16679: state_type > $o ).

tff(pred_def_8865,type,
    v16718: state_type > $o ).

tff(pred_def_8866,type,
    v16720: state_type > $o ).

tff(pred_def_8867,type,
    v16716: state_type > $o ).

tff(pred_def_8868,type,
    v16715: state_type > $o ).

tff(pred_def_8869,type,
    v16726: state_type > $o ).

tff(pred_def_8870,type,
    v16727: state_type > $o ).

tff(pred_def_8871,type,
    v16723: state_type > $o ).

tff(pred_def_8872,type,
    v16725: state_type > $o ).

tff(pred_def_8873,type,
    v16733: state_type > $o ).

tff(pred_def_8874,type,
    v16731: state_type > $o ).

tff(pred_def_8875,type,
    v16735: state_type > $o ).

tff(pred_def_8876,type,
    v16673: state_type > $o ).

tff(pred_def_8877,type,
    v16671: state_type > $o ).

tff(pred_def_8878,type,
    v16669: state_type > $o ).

tff(pred_def_8879,type,
    v16742: state_type > $o ).

tff(pred_def_8880,type,
    v16740: state_type > $o ).

tff(pred_def_8881,type,
    v16739: state_type > $o ).

tff(pred_def_8882,type,
    v16738: state_type > $o ).

tff(pred_def_8883,type,
    v16750: state_type > $o ).

tff(pred_def_8884,type,
    v16751: state_type > $o ).

tff(pred_def_8885,type,
    v16749: state_type > $o ).

tff(pred_def_8886,type,
    v16746: ( state_type * $int ) > $o ).

tff(pred_def_8887,type,
    v16748: ( state_type * $int ) > $o ).

tff(pred_def_8888,type,
    v16643: ( state_type * $int ) > $o ).

tff(pred_def_8889,type,
    v16641: ( state_type * $int ) > $o ).

tff(pred_def_8890,type,
    v16639: ( state_type * $int ) > $o ).

tff(pred_def_8891,type,
    v16637: ( state_type * $int ) > $o ).

tff(pred_def_8892,type,
    v16635: ( state_type * $int ) > $o ).

tff(pred_def_8893,type,
    v16773: state_type > $o ).

tff(pred_def_8894,type,
    v16771: state_type > $o ).

tff(pred_def_8895,type,
    v16777: state_type > $o ).

tff(pred_def_8896,type,
    v16775: state_type > $o ).

tff(pred_def_8897,type,
    v16781: state_type > $o ).

tff(pred_def_8898,type,
    v16779: state_type > $o ).

tff(pred_def_8899,type,
    v16784: state_type > $o ).

tff(pred_def_8900,type,
    v16783: state_type > $o ).

tff(pred_def_8901,type,
    v16769: state_type > $o ).

tff(pred_def_8902,type,
    v16767: state_type > $o ).

tff(pred_def_8903,type,
    v16765: state_type > $o ).

tff(pred_def_8904,type,
    v16763: state_type > $o ).

tff(pred_def_8905,type,
    v16761: state_type > $o ).

tff(pred_def_8906,type,
    v16759: state_type > $o ).

tff(pred_def_8907,type,
    v16757: state_type > $o ).

tff(pred_def_8908,type,
    v16755: state_type > $o ).

tff(pred_def_8909,type,
    v16804: state_type > $o ).

tff(pred_def_8910,type,
    v16802: state_type > $o ).

tff(pred_def_8911,type,
    v16800: state_type > $o ).

tff(pred_def_8912,type,
    v16798: state_type > $o ).

tff(pred_def_8913,type,
    v16796: state_type > $o ).

tff(pred_def_8914,type,
    v16814: state_type > $o ).

tff(pred_def_8915,type,
    v16812: state_type > $o ).

tff(pred_def_8916,type,
    v16810: state_type > $o ).

tff(pred_def_8917,type,
    v16808: state_type > $o ).

tff(pred_def_8918,type,
    v16806: state_type > $o ).

tff(pred_def_8919,type,
    v16818: ( state_type * $int ) > $o ).

tff(pred_def_8920,type,
    v16816: ( state_type * $int ) > $o ).

tff(pred_def_8921,type,
    v16828: state_type > $o ).

tff(pred_def_8922,type,
    v16826: state_type > $o ).

tff(pred_def_8923,type,
    v16834: state_type > $o ).

tff(pred_def_8924,type,
    v16832: state_type > $o ).

tff(pred_def_8925,type,
    v16848: state_type > $o ).

tff(pred_def_8926,type,
    v16846: state_type > $o ).

tff(pred_def_8927,type,
    v16852: state_type > $o ).

tff(pred_def_8928,type,
    v16850: state_type > $o ).

tff(pred_def_8929,type,
    v16856: state_type > $o ).

tff(pred_def_8930,type,
    v16854: state_type > $o ).

tff(pred_def_8931,type,
    v16859: state_type > $o ).

tff(pred_def_8932,type,
    v16858: state_type > $o ).

tff(pred_def_8933,type,
    v16844: state_type > $o ).

tff(pred_def_8934,type,
    v16842: state_type > $o ).

tff(pred_def_8935,type,
    v16840: state_type > $o ).

tff(pred_def_8936,type,
    v16838: state_type > $o ).

tff(pred_def_8937,type,
    v16836: state_type > $o ).

tff(pred_def_8938,type,
    v16863: state_type > $o ).

tff(pred_def_8939,type,
    v16861: state_type > $o ).

tff(pred_def_8940,type,
    v16830: state_type > $o ).

tff(pred_def_8941,type,
    v16869: state_type > $o ).

tff(pred_def_8942,type,
    v16871: state_type > $o ).

tff(pred_def_8943,type,
    v16867: state_type > $o ).

tff(pred_def_8944,type,
    v16866: state_type > $o ).

tff(pred_def_8945,type,
    v16877: state_type > $o ).

tff(pred_def_8946,type,
    v16878: state_type > $o ).

tff(pred_def_8947,type,
    v16874: state_type > $o ).

tff(pred_def_8948,type,
    v16876: state_type > $o ).

tff(pred_def_8949,type,
    v16884: state_type > $o ).

tff(pred_def_8950,type,
    v16882: state_type > $o ).

tff(pred_def_8951,type,
    v16886: state_type > $o ).

tff(pred_def_8952,type,
    v16824: state_type > $o ).

tff(pred_def_8953,type,
    v16822: state_type > $o ).

tff(pred_def_8954,type,
    v16820: state_type > $o ).

tff(pred_def_8955,type,
    v16893: state_type > $o ).

tff(pred_def_8956,type,
    v16891: state_type > $o ).

tff(pred_def_8957,type,
    v16890: state_type > $o ).

tff(pred_def_8958,type,
    v16889: state_type > $o ).

tff(pred_def_8959,type,
    v16901: state_type > $o ).

tff(pred_def_8960,type,
    v16902: state_type > $o ).

tff(pred_def_8961,type,
    v16900: state_type > $o ).

tff(pred_def_8962,type,
    v16897: ( state_type * $int ) > $o ).

tff(pred_def_8963,type,
    v16899: ( state_type * $int ) > $o ).

tff(pred_def_8964,type,
    v16794: ( state_type * $int ) > $o ).

tff(pred_def_8965,type,
    v16792: ( state_type * $int ) > $o ).

tff(pred_def_8966,type,
    v16790: ( state_type * $int ) > $o ).

tff(pred_def_8967,type,
    v16788: ( state_type * $int ) > $o ).

tff(pred_def_8968,type,
    v16786: ( state_type * $int ) > $o ).

tff(pred_def_8969,type,
    v16924: state_type > $o ).

tff(pred_def_8970,type,
    v16922: state_type > $o ).

tff(pred_def_8971,type,
    v16928: state_type > $o ).

tff(pred_def_8972,type,
    v16926: state_type > $o ).

tff(pred_def_8973,type,
    v16932: state_type > $o ).

tff(pred_def_8974,type,
    v16930: state_type > $o ).

tff(pred_def_8975,type,
    v16935: state_type > $o ).

tff(pred_def_8976,type,
    v16934: state_type > $o ).

tff(pred_def_8977,type,
    v16920: state_type > $o ).

tff(pred_def_8978,type,
    v16918: state_type > $o ).

tff(pred_def_8979,type,
    v16916: state_type > $o ).

tff(pred_def_8980,type,
    v16914: state_type > $o ).

tff(pred_def_8981,type,
    v16912: state_type > $o ).

tff(pred_def_8982,type,
    v16910: state_type > $o ).

tff(pred_def_8983,type,
    v16908: state_type > $o ).

tff(pred_def_8984,type,
    v16906: state_type > $o ).

tff(pred_def_8985,type,
    v16955: state_type > $o ).

tff(pred_def_8986,type,
    v16953: state_type > $o ).

tff(pred_def_8987,type,
    v16951: state_type > $o ).

tff(pred_def_8988,type,
    v16949: state_type > $o ).

tff(pred_def_8989,type,
    v16947: state_type > $o ).

tff(pred_def_8990,type,
    v16965: state_type > $o ).

tff(pred_def_8991,type,
    v16963: state_type > $o ).

tff(pred_def_8992,type,
    v16961: state_type > $o ).

tff(pred_def_8993,type,
    v16959: state_type > $o ).

tff(pred_def_8994,type,
    v16957: state_type > $o ).

tff(pred_def_8995,type,
    v16969: ( state_type * $int ) > $o ).

tff(pred_def_8996,type,
    v16967: ( state_type * $int ) > $o ).

tff(pred_def_8997,type,
    v16979: state_type > $o ).

tff(pred_def_8998,type,
    v16977: state_type > $o ).

tff(pred_def_8999,type,
    v16985: state_type > $o ).

tff(pred_def_9000,type,
    v16983: state_type > $o ).

tff(pred_def_9001,type,
    v16999: state_type > $o ).

tff(pred_def_9002,type,
    v16997: state_type > $o ).

tff(pred_def_9003,type,
    v17003: state_type > $o ).

tff(pred_def_9004,type,
    v17001: state_type > $o ).

tff(pred_def_9005,type,
    v17007: state_type > $o ).

tff(pred_def_9006,type,
    v17005: state_type > $o ).

tff(pred_def_9007,type,
    v17010: state_type > $o ).

tff(pred_def_9008,type,
    v17009: state_type > $o ).

tff(pred_def_9009,type,
    v16995: state_type > $o ).

tff(pred_def_9010,type,
    v16993: state_type > $o ).

tff(pred_def_9011,type,
    v16991: state_type > $o ).

tff(pred_def_9012,type,
    v16989: state_type > $o ).

tff(pred_def_9013,type,
    v16987: state_type > $o ).

tff(pred_def_9014,type,
    v17014: state_type > $o ).

tff(pred_def_9015,type,
    v17012: state_type > $o ).

tff(pred_def_9016,type,
    v16981: state_type > $o ).

tff(pred_def_9017,type,
    v17020: state_type > $o ).

tff(pred_def_9018,type,
    v17022: state_type > $o ).

tff(pred_def_9019,type,
    v17018: state_type > $o ).

tff(pred_def_9020,type,
    v17017: state_type > $o ).

tff(pred_def_9021,type,
    v17028: state_type > $o ).

tff(pred_def_9022,type,
    v17029: state_type > $o ).

tff(pred_def_9023,type,
    v17025: state_type > $o ).

tff(pred_def_9024,type,
    v17027: state_type > $o ).

tff(pred_def_9025,type,
    v17035: state_type > $o ).

tff(pred_def_9026,type,
    v17033: state_type > $o ).

tff(pred_def_9027,type,
    v17037: state_type > $o ).

tff(pred_def_9028,type,
    v16975: state_type > $o ).

tff(pred_def_9029,type,
    v16973: state_type > $o ).

tff(pred_def_9030,type,
    v16971: state_type > $o ).

tff(pred_def_9031,type,
    v17044: state_type > $o ).

tff(pred_def_9032,type,
    v17042: state_type > $o ).

tff(pred_def_9033,type,
    v17041: state_type > $o ).

tff(pred_def_9034,type,
    v17040: state_type > $o ).

tff(pred_def_9035,type,
    v17052: state_type > $o ).

tff(pred_def_9036,type,
    v17053: state_type > $o ).

tff(pred_def_9037,type,
    v17051: state_type > $o ).

tff(pred_def_9038,type,
    v17048: ( state_type * $int ) > $o ).

tff(pred_def_9039,type,
    v17050: ( state_type * $int ) > $o ).

tff(pred_def_9040,type,
    v16945: ( state_type * $int ) > $o ).

tff(pred_def_9041,type,
    v16943: ( state_type * $int ) > $o ).

tff(pred_def_9042,type,
    v16941: ( state_type * $int ) > $o ).

tff(pred_def_9043,type,
    v16939: ( state_type * $int ) > $o ).

tff(pred_def_9044,type,
    v16937: ( state_type * $int ) > $o ).

tff(pred_def_9045,type,
    v17075: state_type > $o ).

tff(pred_def_9046,type,
    v17073: state_type > $o ).

tff(pred_def_9047,type,
    v17079: state_type > $o ).

tff(pred_def_9048,type,
    v17077: state_type > $o ).

tff(pred_def_9049,type,
    v17083: state_type > $o ).

tff(pred_def_9050,type,
    v17081: state_type > $o ).

tff(pred_def_9051,type,
    v17086: state_type > $o ).

tff(pred_def_9052,type,
    v17085: state_type > $o ).

tff(pred_def_9053,type,
    v17071: state_type > $o ).

tff(pred_def_9054,type,
    v17069: state_type > $o ).

tff(pred_def_9055,type,
    v17067: state_type > $o ).

tff(pred_def_9056,type,
    v17065: state_type > $o ).

tff(pred_def_9057,type,
    v17063: state_type > $o ).

tff(pred_def_9058,type,
    v17061: state_type > $o ).

tff(pred_def_9059,type,
    v17059: state_type > $o ).

tff(pred_def_9060,type,
    v17057: state_type > $o ).

tff(pred_def_9061,type,
    v17106: state_type > $o ).

tff(pred_def_9062,type,
    v17104: state_type > $o ).

tff(pred_def_9063,type,
    v17102: state_type > $o ).

tff(pred_def_9064,type,
    v17100: state_type > $o ).

tff(pred_def_9065,type,
    v17098: state_type > $o ).

tff(pred_def_9066,type,
    v17116: state_type > $o ).

tff(pred_def_9067,type,
    v17114: state_type > $o ).

tff(pred_def_9068,type,
    v17112: state_type > $o ).

tff(pred_def_9069,type,
    v17110: state_type > $o ).

tff(pred_def_9070,type,
    v17108: state_type > $o ).

tff(pred_def_9071,type,
    v17120: ( state_type * $int ) > $o ).

tff(pred_def_9072,type,
    v17118: ( state_type * $int ) > $o ).

tff(pred_def_9073,type,
    v17130: state_type > $o ).

tff(pred_def_9074,type,
    v17128: state_type > $o ).

tff(pred_def_9075,type,
    v17136: state_type > $o ).

tff(pred_def_9076,type,
    v17134: state_type > $o ).

tff(pred_def_9077,type,
    v17149: state_type > $o ).

tff(pred_def_9078,type,
    v17147: state_type > $o ).

tff(pred_def_9079,type,
    v17153: state_type > $o ).

tff(pred_def_9080,type,
    v17151: state_type > $o ).

tff(pred_def_9081,type,
    v17157: state_type > $o ).

tff(pred_def_9082,type,
    v17155: state_type > $o ).

tff(pred_def_9083,type,
    v17160: state_type > $o ).

tff(pred_def_9084,type,
    v17159: state_type > $o ).

tff(pred_def_9085,type,
    v17145: state_type > $o ).

tff(pred_def_9086,type,
    v17143: state_type > $o ).

tff(pred_def_9087,type,
    v17140: state_type > $o ).

tff(pred_def_9088,type,
    v17138: state_type > $o ).

tff(pred_def_9089,type,
    v17164: state_type > $o ).

tff(pred_def_9090,type,
    v17162: state_type > $o ).

tff(pred_def_9091,type,
    v17132: state_type > $o ).

tff(pred_def_9092,type,
    v17170: state_type > $o ).

tff(pred_def_9093,type,
    v17172: state_type > $o ).

tff(pred_def_9094,type,
    v17168: state_type > $o ).

tff(pred_def_9095,type,
    v17167: state_type > $o ).

tff(pred_def_9096,type,
    v17178: state_type > $o ).

tff(pred_def_9097,type,
    v17179: state_type > $o ).

tff(pred_def_9098,type,
    v17175: state_type > $o ).

tff(pred_def_9099,type,
    v17177: state_type > $o ).

tff(pred_def_9100,type,
    v17185: state_type > $o ).

tff(pred_def_9101,type,
    v17183: state_type > $o ).

tff(pred_def_9102,type,
    v17187: state_type > $o ).

tff(pred_def_9103,type,
    v17126: state_type > $o ).

tff(pred_def_9104,type,
    v17124: state_type > $o ).

tff(pred_def_9105,type,
    v17122: state_type > $o ).

tff(pred_def_9106,type,
    v17194: state_type > $o ).

tff(pred_def_9107,type,
    v17192: state_type > $o ).

tff(pred_def_9108,type,
    v17191: state_type > $o ).

tff(pred_def_9109,type,
    v17190: state_type > $o ).

tff(pred_def_9110,type,
    v17202: state_type > $o ).

tff(pred_def_9111,type,
    v17203: state_type > $o ).

tff(pred_def_9112,type,
    v17201: state_type > $o ).

tff(pred_def_9113,type,
    v17198: ( state_type * $int ) > $o ).

tff(pred_def_9114,type,
    v17200: ( state_type * $int ) > $o ).

tff(pred_def_9115,type,
    v17096: ( state_type * $int ) > $o ).

tff(pred_def_9116,type,
    v17094: ( state_type * $int ) > $o ).

tff(pred_def_9117,type,
    v17092: ( state_type * $int ) > $o ).

tff(pred_def_9118,type,
    v17090: ( state_type * $int ) > $o ).

tff(pred_def_9119,type,
    v17088: ( state_type * $int ) > $o ).

tff(pred_def_9120,type,
    v17215: state_type > $o ).

tff(pred_def_9121,type,
    v17213: state_type > $o ).

tff(pred_def_9122,type,
    v17211: state_type > $o ).

tff(pred_def_9123,type,
    v17209: state_type > $o ).

tff(pred_def_9124,type,
    v17207: state_type > $o ).

tff(pred_def_9125,type,
    v17223: state_type > $o ).

tff(pred_def_9126,type,
    v17222: ( state_type * $int ) > $o ).

tff(pred_def_9127,type,
    v17221: ( state_type * $int ) > $o ).

tff(pred_def_9128,type,
    v17226: state_type > $o ).

tff(pred_def_9129,type,
    v17225: ( state_type * $int ) > $o ).

tff(pred_def_9130,type,
    v17224: ( state_type * $int ) > $o ).

tff(pred_def_9131,type,
    v17220: ( state_type * $int ) > $o ).

tff(pred_def_9132,type,
    v17229: state_type > $o ).

tff(pred_def_9133,type,
    v17228: ( state_type * $int ) > $o ).

tff(pred_def_9134,type,
    v17227: ( state_type * $int ) > $o ).

tff(pred_def_9135,type,
    v17219: ( state_type * $int ) > $o ).

tff(pred_def_9136,type,
    v17232: state_type > $o ).

tff(pred_def_9137,type,
    v17231: ( state_type * $int ) > $o ).

tff(pred_def_9138,type,
    v17230: ( state_type * $int ) > $o ).

tff(pred_def_9139,type,
    v17218: ( state_type * $int ) > $o ).

tff(pred_def_9140,type,
    v17235: state_type > $o ).

tff(pred_def_9141,type,
    v17234: ( state_type * $int ) > $o ).

tff(pred_def_9142,type,
    v17233: ( state_type * $int ) > $o ).

tff(pred_def_9143,type,
    v17217: ( state_type * $int ) > $o ).

tff(pred_def_9144,type,
    v17238: state_type > $o ).

tff(pred_def_9145,type,
    v17237: ( state_type * $int ) > $o ).

tff(pred_def_9146,type,
    v17236: ( state_type * $int ) > $o ).

tff(pred_def_9147,type,
    v15709: ( state_type * $int ) > $o ).

tff(pred_def_9148,type,
    v15707: ( state_type * $int ) > $o ).

tff(pred_def_9149,type,
    v15705: ( state_type * $int ) > $o ).

tff(pred_def_9150,type,
    v15703: ( state_type * $int ) > $o ).

tff(pred_def_9151,type,
    v15701: ( state_type * $int ) > $o ).

tff(pred_def_9152,type,
    v15695: state_type > $o ).

tff(pred_def_9153,type,
    v15693: state_type > $o ).

tff(pred_def_9154,type,
    v15691: state_type > $o ).

tff(pred_def_9155,type,
    v17249: ( state_type * $int ) > $o ).

tff(pred_def_9156,type,
    v17247: ( state_type * $int ) > $o ).

tff(pred_def_9157,type,
    v17283: state_type > $o ).

tff(pred_def_9158,type,
    v17281: state_type > $o ).

tff(pred_def_9159,type,
    v17279: state_type > $o ).

tff(pred_def_9160,type,
    v17277: state_type > $o ).

tff(pred_def_9161,type,
    v17275: state_type > $o ).

tff(pred_def_9162,type,
    v17273: state_type > $o ).

tff(pred_def_9163,type,
    v17271: state_type > $o ).

tff(pred_def_9164,type,
    v17297: state_type > $o ).

tff(pred_def_9165,type,
    v17295: state_type > $o ).

tff(pred_def_9166,type,
    v17293: state_type > $o ).

tff(pred_def_9167,type,
    v17291: state_type > $o ).

tff(pred_def_9168,type,
    v17289: state_type > $o ).

tff(pred_def_9169,type,
    v17287: state_type > $o ).

tff(pred_def_9170,type,
    v17285: state_type > $o ).

tff(pred_def_9171,type,
    v17323: state_type > $o ).

tff(pred_def_9172,type,
    v17325: state_type > $o ).

tff(pred_def_9173,type,
    v17324: ( state_type * $int ) > $o ).

tff(pred_def_9174,type,
    v17326: state_type > $o ).

tff(pred_def_9175,type,
    v17321: ( state_type * $int ) > $o ).

tff(pred_def_9176,type,
    v17319: ( state_type * $int ) > $o ).

tff(pred_def_9177,type,
    v17327: ( state_type * $int ) > $o ).

tff(pred_def_9178,type,
    v17317: ( state_type * $int ) > $o ).

tff(pred_def_9179,type,
    v17315: ( state_type * $int ) > $o ).

tff(pred_def_9180,type,
    v17313: state_type > $o ).

tff(pred_def_9181,type,
    v17329: state_type > $o ).

tff(pred_def_9182,type,
    v17311: ( state_type * $int ) > $o ).

tff(pred_def_9183,type,
    v17309: ( state_type * $int ) > $o ).

tff(pred_def_9184,type,
    v17343: ( state_type * $int ) > $o ).

tff(pred_def_9185,type,
    v17341: ( state_type * $int ) > $o ).

tff(pred_def_9186,type,
    v17347: state_type > $o ).

tff(pred_def_9187,type,
    v17345: state_type > $o ).

tff(pred_def_9188,type,
    v17371: state_type > $o ).

tff(pred_def_9189,type,
    v17369: state_type > $o ).

tff(pred_def_9190,type,
    v17367: state_type > $o ).

tff(pred_def_9191,type,
    v17365: state_type > $o ).

tff(pred_def_9192,type,
    v17363: state_type > $o ).

tff(pred_def_9193,type,
    v17361: state_type > $o ).

tff(pred_def_9194,type,
    v17359: state_type > $o ).

tff(pred_def_9195,type,
    v17385: state_type > $o ).

tff(pred_def_9196,type,
    v17383: state_type > $o ).

tff(pred_def_9197,type,
    v17381: state_type > $o ).

tff(pred_def_9198,type,
    v17379: state_type > $o ).

tff(pred_def_9199,type,
    v17377: state_type > $o ).

tff(pred_def_9200,type,
    v17375: state_type > $o ).

tff(pred_def_9201,type,
    v17373: state_type > $o ).

tff(pred_def_9202,type,
    v17401: ( state_type * $int ) > $o ).

tff(pred_def_9203,type,
    v17399: ( state_type * $int ) > $o ).

tff(pred_def_9204,type,
    v17397: ( state_type * $int ) > $o ).

tff(pred_def_9205,type,
    v17395: ( state_type * $int ) > $o ).

tff(pred_def_9206,type,
    v17393: ( state_type * $int ) > $o ).

tff(pred_def_9207,type,
    v17431: ( state_type * $int ) > $o ).

tff(pred_def_9208,type,
    v17433: ( state_type * $int ) > $o ).

tff(pred_def_9209,type,
    v17429: ( state_type * $int ) > $o ).

tff(pred_def_9210,type,
    v17427: ( state_type * $int ) > $o ).

tff(pred_def_9211,type,
    v17425: ( state_type * $int ) > $o ).

tff(pred_def_9212,type,
    v17423: ( state_type * $int ) > $o ).

tff(pred_def_9213,type,
    v17421: state_type > $o ).

tff(pred_def_9214,type,
    v17419: state_type > $o ).

tff(pred_def_9215,type,
    v17437: state_type > $o ).

tff(pred_def_9216,type,
    v17435: state_type > $o ).

tff(pred_def_9217,type,
    v17439: state_type > $o ).

tff(pred_def_9218,type,
    v17417: state_type > $o ).

tff(pred_def_9219,type,
    v17415: state_type > $o ).

tff(pred_def_9220,type,
    v17413: state_type > $o ).

tff(pred_def_9221,type,
    v17411: state_type > $o ).

tff(pred_def_9222,type,
    v17409: state_type > $o ).

tff(pred_def_9223,type,
    v17407: state_type > $o ).

tff(pred_def_9224,type,
    v17405: state_type > $o ).

tff(pred_def_9225,type,
    v17403: state_type > $o ).

tff(pred_def_9226,type,
    v17449: ( state_type * $int ) > $o ).

tff(pred_def_9227,type,
    v17447: ( state_type * $int ) > $o ).

tff(pred_def_9228,type,
    v17445: ( state_type * $int ) > $o ).

tff(pred_def_9229,type,
    v17443: ( state_type * $int ) > $o ).

tff(pred_def_9230,type,
    v17441: ( state_type * $int ) > $o ).

tff(pred_def_9231,type,
    v17479: ( state_type * $int ) > $o ).

tff(pred_def_9232,type,
    v17477: ( state_type * $int ) > $o ).

tff(pred_def_9233,type,
    v17480: ( state_type * $int ) > $o ).

tff(pred_def_9234,type,
    v17475: ( state_type * $int ) > $o ).

tff(pred_def_9235,type,
    v17473: ( state_type * $int ) > $o ).

tff(pred_def_9236,type,
    v17471: ( state_type * $int ) > $o ).

tff(pred_def_9237,type,
    v17469: state_type > $o ).

tff(pred_def_9238,type,
    v17467: state_type > $o ).

tff(pred_def_9239,type,
    v17484: state_type > $o ).

tff(pred_def_9240,type,
    v17482: state_type > $o ).

tff(pred_def_9241,type,
    v17486: state_type > $o ).

tff(pred_def_9242,type,
    v17465: state_type > $o ).

tff(pred_def_9243,type,
    v17463: state_type > $o ).

tff(pred_def_9244,type,
    v17461: state_type > $o ).

tff(pred_def_9245,type,
    v17459: state_type > $o ).

tff(pred_def_9246,type,
    v17457: state_type > $o ).

tff(pred_def_9247,type,
    v17455: state_type > $o ).

tff(pred_def_9248,type,
    v17453: state_type > $o ).

tff(pred_def_9249,type,
    v17451: state_type > $o ).

tff(pred_def_9250,type,
    v17496: ( state_type * $int ) > $o ).

tff(pred_def_9251,type,
    v17494: ( state_type * $int ) > $o ).

tff(pred_def_9252,type,
    v17492: ( state_type * $int ) > $o ).

tff(pred_def_9253,type,
    v17490: ( state_type * $int ) > $o ).

tff(pred_def_9254,type,
    v17488: ( state_type * $int ) > $o ).

tff(pred_def_9255,type,
    v17516: state_type > $o ).

tff(pred_def_9256,type,
    v17514: state_type > $o ).

tff(pred_def_9257,type,
    v17520: state_type > $o ).

tff(pred_def_9258,type,
    v17518: state_type > $o ).

tff(pred_def_9259,type,
    v17522: state_type > $o ).

tff(pred_def_9260,type,
    v17512: state_type > $o ).

tff(pred_def_9261,type,
    v17510: state_type > $o ).

tff(pred_def_9262,type,
    v17508: state_type > $o ).

tff(pred_def_9263,type,
    v17506: state_type > $o ).

tff(pred_def_9264,type,
    v17504: state_type > $o ).

tff(pred_def_9265,type,
    v17502: state_type > $o ).

tff(pred_def_9266,type,
    v17500: state_type > $o ).

tff(pred_def_9267,type,
    v17498: state_type > $o ).

tff(pred_def_9268,type,
    v17532: ( state_type * $int ) > $o ).

tff(pred_def_9269,type,
    v17530: ( state_type * $int ) > $o ).

tff(pred_def_9270,type,
    v17528: ( state_type * $int ) > $o ).

tff(pred_def_9271,type,
    v17526: ( state_type * $int ) > $o ).

tff(pred_def_9272,type,
    v17524: ( state_type * $int ) > $o ).

tff(pred_def_9273,type,
    v17552: state_type > $o ).

tff(pred_def_9274,type,
    v17550: state_type > $o ).

tff(pred_def_9275,type,
    v17556: state_type > $o ).

tff(pred_def_9276,type,
    v17554: state_type > $o ).

tff(pred_def_9277,type,
    v17558: state_type > $o ).

tff(pred_def_9278,type,
    v17548: state_type > $o ).

tff(pred_def_9279,type,
    v17546: state_type > $o ).

tff(pred_def_9280,type,
    v17544: state_type > $o ).

tff(pred_def_9281,type,
    v17542: state_type > $o ).

tff(pred_def_9282,type,
    v17540: state_type > $o ).

tff(pred_def_9283,type,
    v17538: state_type > $o ).

tff(pred_def_9284,type,
    v17536: state_type > $o ).

tff(pred_def_9285,type,
    v17534: state_type > $o ).

tff(pred_def_9286,type,
    v17564: state_type > $o ).

tff(pred_def_9287,type,
    v17563: ( state_type * $int ) > $o ).

tff(pred_def_9288,type,
    v17562: ( state_type * $int ) > $o ).

tff(pred_def_9289,type,
    v17567: state_type > $o ).

tff(pred_def_9290,type,
    v17566: ( state_type * $int ) > $o ).

tff(pred_def_9291,type,
    v17565: ( state_type * $int ) > $o ).

tff(pred_def_9292,type,
    v17561: ( state_type * $int ) > $o ).

tff(pred_def_9293,type,
    v17570: state_type > $o ).

tff(pred_def_9294,type,
    v17569: ( state_type * $int ) > $o ).

tff(pred_def_9295,type,
    v17568: ( state_type * $int ) > $o ).

tff(pred_def_9296,type,
    v17560: ( state_type * $int ) > $o ).

tff(pred_def_9297,type,
    v17573: state_type > $o ).

tff(pred_def_9298,type,
    v17572: ( state_type * $int ) > $o ).

tff(pred_def_9299,type,
    v17571: ( state_type * $int ) > $o ).

tff(pred_def_9300,type,
    v17391: ( state_type * $int ) > $o ).

tff(pred_def_9301,type,
    v17389: ( state_type * $int ) > $o ).

tff(pred_def_9302,type,
    v17387: ( state_type * $int ) > $o ).

tff(pred_def_9303,type,
    v17585: state_type > $o ).

tff(pred_def_9304,type,
    v17583: state_type > $o ).

tff(pred_def_9305,type,
    v17581: state_type > $o ).

tff(pred_def_9306,type,
    v17595: state_type > $o ).

tff(pred_def_9307,type,
    v17593: state_type > $o ).

tff(pred_def_9308,type,
    v17591: state_type > $o ).

tff(pred_def_9309,type,
    v17589: state_type > $o ).

tff(pred_def_9310,type,
    v17587: state_type > $o ).

tff(pred_def_9311,type,
    v17597: state_type > $o ).

tff(pred_def_9312,type,
    v17579: state_type > $o ).

tff(pred_def_9313,type,
    v17577: state_type > $o ).

tff(pred_def_9314,type,
    v17575: state_type > $o ).

tff(pred_def_9315,type,
    v17604: state_type > $o ).

tff(pred_def_9316,type,
    v17602: state_type > $o ).

tff(pred_def_9317,type,
    v17601: state_type > $o ).

tff(pred_def_9318,type,
    v17600: state_type > $o ).

tff(pred_def_9319,type,
    v17612: state_type > $o ).

tff(pred_def_9320,type,
    v17613: state_type > $o ).

tff(pred_def_9321,type,
    v17611: state_type > $o ).

tff(pred_def_9322,type,
    v17608: ( state_type * $int ) > $o ).

tff(pred_def_9323,type,
    v17610: ( state_type * $int ) > $o ).

tff(pred_def_9324,type,
    v17357: ( state_type * $int ) > $o ).

tff(pred_def_9325,type,
    v17355: ( state_type * $int ) > $o ).

tff(pred_def_9326,type,
    v17353: ( state_type * $int ) > $o ).

tff(pred_def_9327,type,
    v17351: ( state_type * $int ) > $o ).

tff(pred_def_9328,type,
    v17349: ( state_type * $int ) > $o ).

tff(pred_def_9329,type,
    v17619: state_type > $o ).

tff(pred_def_9330,type,
    v17617: state_type > $o ).

tff(pred_def_9331,type,
    v17623: state_type > $o ).

tff(pred_def_9332,type,
    v17622: ( state_type * $int ) > $o ).

tff(pred_def_9333,type,
    v17621: ( state_type * $int ) > $o ).

tff(pred_def_9334,type,
    v17626: state_type > $o ).

tff(pred_def_9335,type,
    v17625: ( state_type * $int ) > $o ).

tff(pred_def_9336,type,
    v17624: ( state_type * $int ) > $o ).

tff(pred_def_9337,type,
    v17339: ( state_type * $int ) > $o ).

tff(pred_def_9338,type,
    v17337: ( state_type * $int ) > $o ).

tff(pred_def_9339,type,
    v17335: ( state_type * $int ) > $o ).

tff(pred_def_9340,type,
    v17333: ( state_type * $int ) > $o ).

tff(pred_def_9341,type,
    v17331: ( state_type * $int ) > $o ).

tff(pred_def_9342,type,
    v17307: ( state_type * $int ) > $o ).

tff(pred_def_9343,type,
    v17305: ( state_type * $int ) > $o ).

tff(pred_def_9344,type,
    v17303: ( state_type * $int ) > $o ).

tff(pred_def_9345,type,
    v17301: ( state_type * $int ) > $o ).

tff(pred_def_9346,type,
    v17299: ( state_type * $int ) > $o ).

tff(pred_def_9347,type,
    v17639: state_type > $o ).

tff(pred_def_9348,type,
    v17637: state_type > $o ).

tff(pred_def_9349,type,
    v17635: state_type > $o ).

tff(pred_def_9350,type,
    v17645: state_type > $o ).

tff(pred_def_9351,type,
    v17643: state_type > $o ).

tff(pred_def_9352,type,
    v17663: ( state_type * $int ) > $o ).

tff(pred_def_9353,type,
    v17665: ( state_type * $int ) > $o ).

tff(pred_def_9354,type,
    v17661: ( state_type * $int ) > $o ).

tff(pred_def_9355,type,
    v17659: state_type > $o ).

tff(pred_def_9356,type,
    v17657: state_type > $o ).

tff(pred_def_9357,type,
    v17669: state_type > $o ).

tff(pred_def_9358,type,
    v17667: state_type > $o ).

tff(pred_def_9359,type,
    v17673: state_type > $o ).

tff(pred_def_9360,type,
    v17671: state_type > $o ).

tff(pred_def_9361,type,
    v17676: state_type > $o ).

tff(pred_def_9362,type,
    v17675: state_type > $o ).

tff(pred_def_9363,type,
    v17655: state_type > $o ).

tff(pred_def_9364,type,
    v17653: state_type > $o ).

tff(pred_def_9365,type,
    v17651: state_type > $o ).

tff(pred_def_9366,type,
    v17649: state_type > $o ).

tff(pred_def_9367,type,
    v17647: state_type > $o ).

tff(pred_def_9368,type,
    v17684: state_type > $o ).

tff(pred_def_9369,type,
    v17682: state_type > $o ).

tff(pred_def_9370,type,
    v17680: state_type > $o ).

tff(pred_def_9371,type,
    v17678: state_type > $o ).

tff(pred_def_9372,type,
    v17641: state_type > $o ).

tff(pred_def_9373,type,
    v17690: state_type > $o ).

tff(pred_def_9374,type,
    v17692: state_type > $o ).

tff(pred_def_9375,type,
    v17688: state_type > $o ).

tff(pred_def_9376,type,
    v17687: state_type > $o ).

tff(pred_def_9377,type,
    v17698: state_type > $o ).

tff(pred_def_9378,type,
    v17699: state_type > $o ).

tff(pred_def_9379,type,
    v17695: state_type > $o ).

tff(pred_def_9380,type,
    v17697: state_type > $o ).

tff(pred_def_9381,type,
    v17709: state_type > $o ).

tff(pred_def_9382,type,
    v17707: state_type > $o ).

tff(pred_def_9383,type,
    v17705: state_type > $o ).

tff(pred_def_9384,type,
    v17703: state_type > $o ).

tff(pred_def_9385,type,
    v17711: state_type > $o ).

tff(pred_def_9386,type,
    v17633: state_type > $o ).

tff(pred_def_9387,type,
    v17631: state_type > $o ).

tff(pred_def_9388,type,
    v17629: state_type > $o ).

tff(pred_def_9389,type,
    v17718: state_type > $o ).

tff(pred_def_9390,type,
    v17716: state_type > $o ).

tff(pred_def_9391,type,
    v17715: state_type > $o ).

tff(pred_def_9392,type,
    v17714: state_type > $o ).

tff(pred_def_9393,type,
    v17726: state_type > $o ).

tff(pred_def_9394,type,
    v17727: state_type > $o ).

tff(pred_def_9395,type,
    v17725: state_type > $o ).

tff(pred_def_9396,type,
    v17722: ( state_type * $int ) > $o ).

tff(pred_def_9397,type,
    v17724: ( state_type * $int ) > $o ).

tff(pred_def_9398,type,
    v17269: ( state_type * $int ) > $o ).

tff(pred_def_9399,type,
    v17267: ( state_type * $int ) > $o ).

tff(pred_def_9400,type,
    v17265: ( state_type * $int ) > $o ).

tff(pred_def_9401,type,
    v17263: ( state_type * $int ) > $o ).

tff(pred_def_9402,type,
    v17261: ( state_type * $int ) > $o ).

tff(pred_def_9403,type,
    v17763: state_type > $o ).

tff(pred_def_9404,type,
    v17761: state_type > $o ).

tff(pred_def_9405,type,
    v17759: state_type > $o ).

tff(pred_def_9406,type,
    v17757: state_type > $o ).

tff(pred_def_9407,type,
    v17755: state_type > $o ).

tff(pred_def_9408,type,
    v17753: state_type > $o ).

tff(pred_def_9409,type,
    v17773: state_type > $o ).

tff(pred_def_9410,type,
    v17771: state_type > $o ).

tff(pred_def_9411,type,
    v17769: state_type > $o ).

tff(pred_def_9412,type,
    v17767: state_type > $o ).

tff(pred_def_9413,type,
    v17765: state_type > $o ).

tff(pred_def_9414,type,
    v17800: state_type > $o ).

tff(pred_def_9415,type,
    v17799: ( state_type * $int ) > $o ).

tff(pred_def_9416,type,
    v17798: ( state_type * $int ) > $o ).

tff(pred_def_9417,type,
    v17796: ( state_type * $int ) > $o ).

tff(pred_def_9418,type,
    v17816: state_type > $o ).

tff(pred_def_9419,type,
    v17817: ( state_type * $int ) > $o ).

tff(pred_def_9420,type,
    v17818: state_type > $o ).

tff(pred_def_9421,type,
    v17814: ( state_type * $int ) > $o ).

tff(pred_def_9422,type,
    v17812: ( state_type * $int ) > $o ).

tff(pred_def_9423,type,
    v17842: ( state_type * $int ) > $o ).

tff(pred_def_9424,type,
    v17751: ( state_type * $int ) > $o ).

tff(pred_def_9425,type,
    v17840: ( state_type * $int ) > $o ).

tff(pred_def_9426,type,
    v17843: ( state_type * $int ) > $o ).

tff(pred_def_9427,type,
    v17838: ( state_type * $int ) > $o ).

tff(pred_def_9428,type,
    v17836: ( state_type * $int ) > $o ).

tff(pred_def_9429,type,
    v17834: ( state_type * $int ) > $o ).

tff(pred_def_9430,type,
    v17832: state_type > $o ).

tff(pred_def_9431,type,
    v17830: state_type > $o ).

tff(pred_def_9432,type,
    v17849: state_type > $o ).

tff(pred_def_9433,type,
    v17789: state_type > $o ).

tff(pred_def_9434,type,
    v17848: ( state_type * $int ) > $o ).

tff(pred_def_9435,type,
    v17787: ( state_type * $int ) > $o ).

tff(pred_def_9436,type,
    v17785: ( state_type * $int ) > $o ).

tff(pred_def_9437,type,
    v17864: ( state_type * $int ) > $o ).

tff(pred_def_9438,type,
    v17863: ( state_type * $int ) > $o ).

tff(pred_def_9439,type,
    v17861: ( state_type * $int ) > $o ).

tff(pred_def_9440,type,
    v17868: state_type > $o ).

tff(pred_def_9441,type,
    v17866: state_type > $o ).

tff(pred_def_9442,type,
    v17879: ( state_type * $int ) > $o ).

tff(pred_def_9443,type,
    v17878: state_type > $o ).

tff(pred_def_9444,type,
    v17882: state_type > $o ).

tff(pred_def_9445,type,
    v17883: state_type > $o ).

tff(pred_def_9446,type,
    v17881: state_type > $o ).

tff(pred_def_9447,type,
    v17884: state_type > $o ).

tff(pred_def_9448,type,
    v17880: state_type > $o ).

tff(pred_def_9449,type,
    v17877: state_type > $o ).

tff(pred_def_9450,type,
    v17885: state_type > $o ).

tff(pred_def_9451,type,
    v17876: state_type > $o ).

tff(pred_def_9452,type,
    v17888: state_type > $o ).

tff(pred_def_9453,type,
    v17889: state_type > $o ).

tff(pred_def_9454,type,
    v17887: state_type > $o ).

tff(pred_def_9455,type,
    v17890: state_type > $o ).

tff(pred_def_9456,type,
    v17886: state_type > $o ).

tff(pred_def_9457,type,
    v17875: state_type > $o ).

tff(pred_def_9458,type,
    v17891: state_type > $o ).

tff(pred_def_9459,type,
    v17874: state_type > $o ).

tff(pred_def_9460,type,
    v17873: state_type > $o ).

tff(pred_def_9461,type,
    v17895: state_type > $o ).

tff(pred_def_9462,type,
    v17896: state_type > $o ).

tff(pred_def_9463,type,
    v17894: state_type > $o ).

tff(pred_def_9464,type,
    v17897: state_type > $o ).

tff(pred_def_9465,type,
    v17893: state_type > $o ).

tff(pred_def_9466,type,
    v17892: state_type > $o ).

tff(pred_def_9467,type,
    v17872: state_type > $o ).

tff(pred_def_9468,type,
    v17898: state_type > $o ).

tff(pred_def_9469,type,
    v17871: state_type > $o ).

tff(pred_def_9470,type,
    v17901: state_type > $o ).

tff(pred_def_9471,type,
    v17902: state_type > $o ).

tff(pred_def_9472,type,
    v17900: state_type > $o ).

tff(pred_def_9473,type,
    v17903: state_type > $o ).

tff(pred_def_9474,type,
    v17899: state_type > $o ).

tff(pred_def_9475,type,
    v17906: state_type > $o ).

tff(pred_def_9476,type,
    v17907: state_type > $o ).

tff(pred_def_9477,type,
    v17905: state_type > $o ).

tff(pred_def_9478,type,
    v17908: state_type > $o ).

tff(pred_def_9479,type,
    v17904: state_type > $o ).

tff(pred_def_9480,type,
    v17911: state_type > $o ).

tff(pred_def_9481,type,
    v17912: state_type > $o ).

tff(pred_def_9482,type,
    v17910: state_type > $o ).

tff(pred_def_9483,type,
    v17913: state_type > $o ).

tff(pred_def_9484,type,
    v17909: state_type > $o ).

tff(pred_def_9485,type,
    v17869: ( state_type * $int ) > $o ).

tff(pred_def_9486,type,
    v17859: ( state_type * $int ) > $o ).

tff(pred_def_9487,type,
    v17857: ( state_type * $int ) > $o ).

tff(pred_def_9488,type,
    v17855: ( state_type * $int ) > $o ).

tff(pred_def_9489,type,
    v17853: ( state_type * $int ) > $o ).

tff(pred_def_9490,type,
    v17851: ( state_type * $int ) > $o ).

tff(pred_def_9491,type,
    v17914: ( state_type * $int ) > $o ).

tff(pred_def_9492,type,
    v17783: ( state_type * $int ) > $o ).

tff(pred_def_9493,type,
    v17781: ( state_type * $int ) > $o ).

tff(pred_def_9494,type,
    v17779: ( state_type * $int ) > $o ).

tff(pred_def_9495,type,
    v17915: ( state_type * $int ) > $o ).

tff(pred_def_9496,type,
    v17916: ( state_type * $int ) > $o ).

tff(pred_def_9497,type,
    v17777: ( state_type * $int ) > $o ).

tff(pred_def_9498,type,
    v17775: ( state_type * $int ) > $o ).

tff(pred_def_9499,type,
    v17926: state_type > $o ).

tff(pred_def_9500,type,
    v17924: state_type > $o ).

tff(pred_def_9501,type,
    v17932: state_type > $o ).

tff(pred_def_9502,type,
    v17930: state_type > $o ).

tff(pred_def_9503,type,
    v17936: state_type > $o ).

tff(pred_def_9504,type,
    v17934: state_type > $o ).

tff(pred_def_9505,type,
    v17940: state_type > $o ).

tff(pred_def_9506,type,
    v17938: state_type > $o ).

tff(pred_def_9507,type,
    v17928: state_type > $o ).

tff(pred_def_9508,type,
    v17946: state_type > $o ).

tff(pred_def_9509,type,
    v17948: state_type > $o ).

tff(pred_def_9510,type,
    v17944: state_type > $o ).

tff(pred_def_9511,type,
    v17943: state_type > $o ).

tff(pred_def_9512,type,
    v17954: state_type > $o ).

tff(pred_def_9513,type,
    v17955: state_type > $o ).

tff(pred_def_9514,type,
    v17951: state_type > $o ).

tff(pred_def_9515,type,
    v17953: state_type > $o ).

tff(pred_def_9516,type,
    v17961: state_type > $o ).

tff(pred_def_9517,type,
    v17959: state_type > $o ).

tff(pred_def_9518,type,
    v17963: state_type > $o ).

tff(pred_def_9519,type,
    v17922: state_type > $o ).

tff(pred_def_9520,type,
    v17920: state_type > $o ).

tff(pred_def_9521,type,
    v17918: state_type > $o ).

tff(pred_def_9522,type,
    v17970: state_type > $o ).

tff(pred_def_9523,type,
    v17968: state_type > $o ).

tff(pred_def_9524,type,
    v17967: state_type > $o ).

tff(pred_def_9525,type,
    v17966: state_type > $o ).

tff(pred_def_9526,type,
    v17978: state_type > $o ).

tff(pred_def_9527,type,
    v17979: state_type > $o ).

tff(pred_def_9528,type,
    v17977: state_type > $o ).

tff(pred_def_9529,type,
    v17974: ( state_type * $int ) > $o ).

tff(pred_def_9530,type,
    v17976: ( state_type * $int ) > $o ).

tff(pred_def_9531,type,
    v17965: ( state_type * $int ) > $o ).

tff(pred_def_9532,type,
    v17847: state_type > $o ).

tff(pred_def_9533,type,
    v17845: state_type > $o ).

tff(pred_def_9534,type,
    v17991: state_type > $o ).

tff(pred_def_9535,type,
    v17989: state_type > $o ).

tff(pred_def_9536,type,
    v17988: state_type > $o ).

tff(pred_def_9537,type,
    v17987: ( state_type * $int ) > $o ).

tff(pred_def_9538,type,
    v17985: state_type > $o ).

tff(pred_def_9539,type,
    v17983: state_type > $o ).

tff(pred_def_9540,type,
    v17996: state_type > $o ).

tff(pred_def_9541,type,
    v17995: state_type > $o ).

tff(pred_def_9542,type,
    v17828: state_type > $o ).

tff(pred_def_9543,type,
    v17826: state_type > $o ).

tff(pred_def_9544,type,
    v17824: state_type > $o ).

tff(pred_def_9545,type,
    v17997: ( state_type * $int ) > $o ).

tff(pred_def_9546,type,
    v17998: state_type > $o ).

tff(pred_def_9547,type,
    v17822: ( state_type * $int ) > $o ).

tff(pred_def_9548,type,
    v17820: ( state_type * $int ) > $o ).

tff(pred_def_9549,type,
    v17999: ( state_type * $int ) > $o ).

tff(pred_def_9550,type,
    v17810: ( state_type * $int ) > $o ).

tff(pred_def_9551,type,
    v17808: ( state_type * $int ) > $o ).

tff(pred_def_9552,type,
    v17806: state_type > $o ).

tff(pred_def_9553,type,
    v18000: ( state_type * $int ) > $o ).

tff(pred_def_9554,type,
    v18001: state_type > $o ).

tff(pred_def_9555,type,
    v17804: ( state_type * $int ) > $o ).

tff(pred_def_9556,type,
    v17802: ( state_type * $int ) > $o ).

tff(pred_def_9557,type,
    v18002: ( state_type * $int ) > $o ).

tff(pred_def_9558,type,
    v17794: ( state_type * $int ) > $o ).

tff(pred_def_9559,type,
    v17792: ( state_type * $int ) > $o ).

tff(pred_def_9560,type,
    v18008: state_type > $o ).

tff(pred_def_9561,type,
    v18006: state_type > $o ).

tff(pred_def_9562,type,
    v18005: state_type > $o ).

tff(pred_def_9563,type,
    v18004: ( state_type * $int ) > $o ).

tff(pred_def_9564,type,
    v17749: state_type > $o ).

tff(pred_def_9565,type,
    v17747: state_type > $o ).

tff(pred_def_9566,type,
    v18014: state_type > $o ).

tff(pred_def_9567,type,
    v18012: state_type > $o ).

tff(pred_def_9568,type,
    v18018: state_type > $o ).

tff(pred_def_9569,type,
    v18016: state_type > $o ).

tff(pred_def_9570,type,
    v18021: state_type > $o ).

tff(pred_def_9571,type,
    v18020: state_type > $o ).

tff(pred_def_9572,type,
    v17745: state_type > $o ).

tff(pred_def_9573,type,
    v17743: state_type > $o ).

tff(pred_def_9574,type,
    v17741: state_type > $o ).

tff(pred_def_9575,type,
    v17739: state_type > $o ).

tff(pred_def_9576,type,
    v17737: state_type > $o ).

tff(pred_def_9577,type,
    v17735: state_type > $o ).

tff(pred_def_9578,type,
    v17733: state_type > $o ).

tff(pred_def_9579,type,
    v17731: state_type > $o ).

tff(pred_def_9580,type,
    v18041: state_type > $o ).

tff(pred_def_9581,type,
    v18039: state_type > $o ).

tff(pred_def_9582,type,
    v18037: state_type > $o ).

tff(pred_def_9583,type,
    v18035: state_type > $o ).

tff(pred_def_9584,type,
    v18033: state_type > $o ).

tff(pred_def_9585,type,
    v18051: state_type > $o ).

tff(pred_def_9586,type,
    v18049: state_type > $o ).

tff(pred_def_9587,type,
    v18047: state_type > $o ).

tff(pred_def_9588,type,
    v18045: state_type > $o ).

tff(pred_def_9589,type,
    v18043: state_type > $o ).

tff(pred_def_9590,type,
    v18055: ( state_type * $int ) > $o ).

tff(pred_def_9591,type,
    v18053: ( state_type * $int ) > $o ).

tff(pred_def_9592,type,
    v18065: state_type > $o ).

tff(pred_def_9593,type,
    v18063: state_type > $o ).

tff(pred_def_9594,type,
    v18071: state_type > $o ).

tff(pred_def_9595,type,
    v18069: state_type > $o ).

tff(pred_def_9596,type,
    v18095: ( state_type * $int ) > $o ).

tff(pred_def_9597,type,
    v18093: ( state_type * $int ) > $o ).

tff(pred_def_9598,type,
    v18096: ( state_type * $int ) > $o ).

tff(pred_def_9599,type,
    v18091: ( state_type * $int ) > $o ).

tff(pred_def_9600,type,
    v18089: ( state_type * $int ) > $o ).

tff(pred_def_9601,type,
    v18087: ( state_type * $int ) > $o ).

tff(pred_def_9602,type,
    v18085: state_type > $o ).

tff(pred_def_9603,type,
    v18083: state_type > $o ).

tff(pred_def_9604,type,
    v18100: state_type > $o ).

tff(pred_def_9605,type,
    v18098: state_type > $o ).

tff(pred_def_9606,type,
    v18104: state_type > $o ).

tff(pred_def_9607,type,
    v18102: state_type > $o ).

tff(pred_def_9608,type,
    v18107: state_type > $o ).

tff(pred_def_9609,type,
    v18106: state_type > $o ).

tff(pred_def_9610,type,
    v18081: state_type > $o ).

tff(pred_def_9611,type,
    v18079: state_type > $o ).

tff(pred_def_9612,type,
    v18077: state_type > $o ).

tff(pred_def_9613,type,
    v18075: state_type > $o ).

tff(pred_def_9614,type,
    v18073: state_type > $o ).

tff(pred_def_9615,type,
    v18111: state_type > $o ).

tff(pred_def_9616,type,
    v18109: state_type > $o ).

tff(pred_def_9617,type,
    v18067: state_type > $o ).

tff(pred_def_9618,type,
    v18117: state_type > $o ).

tff(pred_def_9619,type,
    v18119: state_type > $o ).

tff(pred_def_9620,type,
    v18115: state_type > $o ).

tff(pred_def_9621,type,
    v18114: state_type > $o ).

tff(pred_def_9622,type,
    v18125: state_type > $o ).

tff(pred_def_9623,type,
    v18126: state_type > $o ).

tff(pred_def_9624,type,
    v18122: state_type > $o ).

tff(pred_def_9625,type,
    v18124: state_type > $o ).

tff(pred_def_9626,type,
    v18132: state_type > $o ).

tff(pred_def_9627,type,
    v18130: state_type > $o ).

tff(pred_def_9628,type,
    v18134: state_type > $o ).

tff(pred_def_9629,type,
    v18061: state_type > $o ).

tff(pred_def_9630,type,
    v18059: state_type > $o ).

tff(pred_def_9631,type,
    v18057: state_type > $o ).

tff(pred_def_9632,type,
    v18141: state_type > $o ).

tff(pred_def_9633,type,
    v18139: state_type > $o ).

tff(pred_def_9634,type,
    v18138: state_type > $o ).

tff(pred_def_9635,type,
    v18137: state_type > $o ).

tff(pred_def_9636,type,
    v18149: state_type > $o ).

tff(pred_def_9637,type,
    v18150: state_type > $o ).

tff(pred_def_9638,type,
    v18148: state_type > $o ).

tff(pred_def_9639,type,
    v18145: ( state_type * $int ) > $o ).

tff(pred_def_9640,type,
    v18147: ( state_type * $int ) > $o ).

tff(pred_def_9641,type,
    v18031: ( state_type * $int ) > $o ).

tff(pred_def_9642,type,
    v18029: ( state_type * $int ) > $o ).

tff(pred_def_9643,type,
    v18027: ( state_type * $int ) > $o ).

tff(pred_def_9644,type,
    v18025: ( state_type * $int ) > $o ).

tff(pred_def_9645,type,
    v18023: ( state_type * $int ) > $o ).

tff(pred_def_9646,type,
    v18172: state_type > $o ).

tff(pred_def_9647,type,
    v18170: state_type > $o ).

tff(pred_def_9648,type,
    v18176: state_type > $o ).

tff(pred_def_9649,type,
    v18174: state_type > $o ).

tff(pred_def_9650,type,
    v18180: state_type > $o ).

tff(pred_def_9651,type,
    v18178: state_type > $o ).

tff(pred_def_9652,type,
    v18183: state_type > $o ).

tff(pred_def_9653,type,
    v18182: state_type > $o ).

tff(pred_def_9654,type,
    v18168: state_type > $o ).

tff(pred_def_9655,type,
    v18166: state_type > $o ).

tff(pred_def_9656,type,
    v18164: state_type > $o ).

tff(pred_def_9657,type,
    v18162: state_type > $o ).

tff(pred_def_9658,type,
    v18160: state_type > $o ).

tff(pred_def_9659,type,
    v18158: state_type > $o ).

tff(pred_def_9660,type,
    v18156: state_type > $o ).

tff(pred_def_9661,type,
    v18154: state_type > $o ).

tff(pred_def_9662,type,
    v18203: state_type > $o ).

tff(pred_def_9663,type,
    v18201: state_type > $o ).

tff(pred_def_9664,type,
    v18199: state_type > $o ).

tff(pred_def_9665,type,
    v18197: state_type > $o ).

tff(pred_def_9666,type,
    v18195: state_type > $o ).

tff(pred_def_9667,type,
    v18213: state_type > $o ).

tff(pred_def_9668,type,
    v18211: state_type > $o ).

tff(pred_def_9669,type,
    v18209: state_type > $o ).

tff(pred_def_9670,type,
    v18207: state_type > $o ).

tff(pred_def_9671,type,
    v18205: state_type > $o ).

tff(pred_def_9672,type,
    v18217: ( state_type * $int ) > $o ).

tff(pred_def_9673,type,
    v18215: ( state_type * $int ) > $o ).

tff(pred_def_9674,type,
    v18227: state_type > $o ).

tff(pred_def_9675,type,
    v18225: state_type > $o ).

tff(pred_def_9676,type,
    v18233: state_type > $o ).

tff(pred_def_9677,type,
    v18231: state_type > $o ).

tff(pred_def_9678,type,
    v18247: state_type > $o ).

tff(pred_def_9679,type,
    v18245: state_type > $o ).

tff(pred_def_9680,type,
    v18251: state_type > $o ).

tff(pred_def_9681,type,
    v18249: state_type > $o ).

tff(pred_def_9682,type,
    v18255: state_type > $o ).

tff(pred_def_9683,type,
    v18253: state_type > $o ).

tff(pred_def_9684,type,
    v18258: state_type > $o ).

tff(pred_def_9685,type,
    v18257: state_type > $o ).

tff(pred_def_9686,type,
    v18243: state_type > $o ).

tff(pred_def_9687,type,
    v18241: state_type > $o ).

tff(pred_def_9688,type,
    v18239: state_type > $o ).

tff(pred_def_9689,type,
    v18237: state_type > $o ).

tff(pred_def_9690,type,
    v18235: state_type > $o ).

tff(pred_def_9691,type,
    v18262: state_type > $o ).

tff(pred_def_9692,type,
    v18260: state_type > $o ).

tff(pred_def_9693,type,
    v18229: state_type > $o ).

tff(pred_def_9694,type,
    v18268: state_type > $o ).

tff(pred_def_9695,type,
    v18270: state_type > $o ).

tff(pred_def_9696,type,
    v18266: state_type > $o ).

tff(pred_def_9697,type,
    v18265: state_type > $o ).

tff(pred_def_9698,type,
    v18276: state_type > $o ).

tff(pred_def_9699,type,
    v18277: state_type > $o ).

tff(pred_def_9700,type,
    v18273: state_type > $o ).

tff(pred_def_9701,type,
    v18275: state_type > $o ).

tff(pred_def_9702,type,
    v18283: state_type > $o ).

tff(pred_def_9703,type,
    v18281: state_type > $o ).

tff(pred_def_9704,type,
    v18285: state_type > $o ).

tff(pred_def_9705,type,
    v18223: state_type > $o ).

tff(pred_def_9706,type,
    v18221: state_type > $o ).

tff(pred_def_9707,type,
    v18219: state_type > $o ).

tff(pred_def_9708,type,
    v18292: state_type > $o ).

tff(pred_def_9709,type,
    v18290: state_type > $o ).

tff(pred_def_9710,type,
    v18289: state_type > $o ).

tff(pred_def_9711,type,
    v18288: state_type > $o ).

tff(pred_def_9712,type,
    v18300: state_type > $o ).

tff(pred_def_9713,type,
    v18301: state_type > $o ).

tff(pred_def_9714,type,
    v18299: state_type > $o ).

tff(pred_def_9715,type,
    v18296: ( state_type * $int ) > $o ).

tff(pred_def_9716,type,
    v18298: ( state_type * $int ) > $o ).

tff(pred_def_9717,type,
    v18193: ( state_type * $int ) > $o ).

tff(pred_def_9718,type,
    v18191: ( state_type * $int ) > $o ).

tff(pred_def_9719,type,
    v18189: ( state_type * $int ) > $o ).

tff(pred_def_9720,type,
    v18187: ( state_type * $int ) > $o ).

tff(pred_def_9721,type,
    v18185: ( state_type * $int ) > $o ).

tff(pred_def_9722,type,
    v18323: state_type > $o ).

tff(pred_def_9723,type,
    v18321: state_type > $o ).

tff(pred_def_9724,type,
    v18327: state_type > $o ).

tff(pred_def_9725,type,
    v18325: state_type > $o ).

tff(pred_def_9726,type,
    v18331: state_type > $o ).

tff(pred_def_9727,type,
    v18329: state_type > $o ).

tff(pred_def_9728,type,
    v18334: state_type > $o ).

tff(pred_def_9729,type,
    v18333: state_type > $o ).

tff(pred_def_9730,type,
    v18319: state_type > $o ).

tff(pred_def_9731,type,
    v18317: state_type > $o ).

tff(pred_def_9732,type,
    v18315: state_type > $o ).

tff(pred_def_9733,type,
    v18313: state_type > $o ).

tff(pred_def_9734,type,
    v18311: state_type > $o ).

tff(pred_def_9735,type,
    v18309: state_type > $o ).

tff(pred_def_9736,type,
    v18307: state_type > $o ).

tff(pred_def_9737,type,
    v18305: state_type > $o ).

tff(pred_def_9738,type,
    v18354: state_type > $o ).

tff(pred_def_9739,type,
    v18352: state_type > $o ).

tff(pred_def_9740,type,
    v18350: state_type > $o ).

tff(pred_def_9741,type,
    v18348: state_type > $o ).

tff(pred_def_9742,type,
    v18346: state_type > $o ).

tff(pred_def_9743,type,
    v18364: state_type > $o ).

tff(pred_def_9744,type,
    v18362: state_type > $o ).

tff(pred_def_9745,type,
    v18360: state_type > $o ).

tff(pred_def_9746,type,
    v18358: state_type > $o ).

tff(pred_def_9747,type,
    v18356: state_type > $o ).

tff(pred_def_9748,type,
    v18368: ( state_type * $int ) > $o ).

tff(pred_def_9749,type,
    v18366: ( state_type * $int ) > $o ).

tff(pred_def_9750,type,
    v18378: state_type > $o ).

tff(pred_def_9751,type,
    v18376: state_type > $o ).

tff(pred_def_9752,type,
    v18384: state_type > $o ).

tff(pred_def_9753,type,
    v18382: state_type > $o ).

tff(pred_def_9754,type,
    v18398: state_type > $o ).

tff(pred_def_9755,type,
    v18396: state_type > $o ).

tff(pred_def_9756,type,
    v18402: state_type > $o ).

tff(pred_def_9757,type,
    v18400: state_type > $o ).

tff(pred_def_9758,type,
    v18406: state_type > $o ).

tff(pred_def_9759,type,
    v18404: state_type > $o ).

tff(pred_def_9760,type,
    v18409: state_type > $o ).

tff(pred_def_9761,type,
    v18408: state_type > $o ).

tff(pred_def_9762,type,
    v18394: state_type > $o ).

tff(pred_def_9763,type,
    v18392: state_type > $o ).

tff(pred_def_9764,type,
    v18390: state_type > $o ).

tff(pred_def_9765,type,
    v18388: state_type > $o ).

tff(pred_def_9766,type,
    v18386: state_type > $o ).

tff(pred_def_9767,type,
    v18413: state_type > $o ).

tff(pred_def_9768,type,
    v18411: state_type > $o ).

tff(pred_def_9769,type,
    v18380: state_type > $o ).

tff(pred_def_9770,type,
    v18419: state_type > $o ).

tff(pred_def_9771,type,
    v18421: state_type > $o ).

tff(pred_def_9772,type,
    v18417: state_type > $o ).

tff(pred_def_9773,type,
    v18416: state_type > $o ).

tff(pred_def_9774,type,
    v18427: state_type > $o ).

tff(pred_def_9775,type,
    v18428: state_type > $o ).

tff(pred_def_9776,type,
    v18424: state_type > $o ).

tff(pred_def_9777,type,
    v18426: state_type > $o ).

tff(pred_def_9778,type,
    v18434: state_type > $o ).

tff(pred_def_9779,type,
    v18432: state_type > $o ).

tff(pred_def_9780,type,
    v18436: state_type > $o ).

tff(pred_def_9781,type,
    v18374: state_type > $o ).

tff(pred_def_9782,type,
    v18372: state_type > $o ).

tff(pred_def_9783,type,
    v18370: state_type > $o ).

tff(pred_def_9784,type,
    v18443: state_type > $o ).

tff(pred_def_9785,type,
    v18441: state_type > $o ).

tff(pred_def_9786,type,
    v18440: state_type > $o ).

tff(pred_def_9787,type,
    v18439: state_type > $o ).

tff(pred_def_9788,type,
    v18451: state_type > $o ).

tff(pred_def_9789,type,
    v18452: state_type > $o ).

tff(pred_def_9790,type,
    v18450: state_type > $o ).

tff(pred_def_9791,type,
    v18447: ( state_type * $int ) > $o ).

tff(pred_def_9792,type,
    v18449: ( state_type * $int ) > $o ).

tff(pred_def_9793,type,
    v18344: ( state_type * $int ) > $o ).

tff(pred_def_9794,type,
    v18342: ( state_type * $int ) > $o ).

tff(pred_def_9795,type,
    v18340: ( state_type * $int ) > $o ).

tff(pred_def_9796,type,
    v18338: ( state_type * $int ) > $o ).

tff(pred_def_9797,type,
    v18336: ( state_type * $int ) > $o ).

tff(pred_def_9798,type,
    v18474: state_type > $o ).

tff(pred_def_9799,type,
    v18472: state_type > $o ).

tff(pred_def_9800,type,
    v18478: state_type > $o ).

tff(pred_def_9801,type,
    v18476: state_type > $o ).

tff(pred_def_9802,type,
    v18482: state_type > $o ).

tff(pred_def_9803,type,
    v18480: state_type > $o ).

tff(pred_def_9804,type,
    v18485: state_type > $o ).

tff(pred_def_9805,type,
    v18484: state_type > $o ).

tff(pred_def_9806,type,
    v18470: state_type > $o ).

tff(pred_def_9807,type,
    v18468: state_type > $o ).

tff(pred_def_9808,type,
    v18466: state_type > $o ).

tff(pred_def_9809,type,
    v18464: state_type > $o ).

tff(pred_def_9810,type,
    v18462: state_type > $o ).

tff(pred_def_9811,type,
    v18460: state_type > $o ).

tff(pred_def_9812,type,
    v18458: state_type > $o ).

tff(pred_def_9813,type,
    v18456: state_type > $o ).

tff(pred_def_9814,type,
    v18505: state_type > $o ).

tff(pred_def_9815,type,
    v18503: state_type > $o ).

tff(pred_def_9816,type,
    v18501: state_type > $o ).

tff(pred_def_9817,type,
    v18499: state_type > $o ).

tff(pred_def_9818,type,
    v18497: state_type > $o ).

tff(pred_def_9819,type,
    v18515: state_type > $o ).

tff(pred_def_9820,type,
    v18513: state_type > $o ).

tff(pred_def_9821,type,
    v18511: state_type > $o ).

tff(pred_def_9822,type,
    v18509: state_type > $o ).

tff(pred_def_9823,type,
    v18507: state_type > $o ).

tff(pred_def_9824,type,
    v18519: ( state_type * $int ) > $o ).

tff(pred_def_9825,type,
    v18517: ( state_type * $int ) > $o ).

tff(pred_def_9826,type,
    v18529: state_type > $o ).

tff(pred_def_9827,type,
    v18527: state_type > $o ).

tff(pred_def_9828,type,
    v18535: state_type > $o ).

tff(pred_def_9829,type,
    v18533: state_type > $o ).

tff(pred_def_9830,type,
    v18549: state_type > $o ).

tff(pred_def_9831,type,
    v18547: state_type > $o ).

tff(pred_def_9832,type,
    v18553: state_type > $o ).

tff(pred_def_9833,type,
    v18551: state_type > $o ).

tff(pred_def_9834,type,
    v18557: state_type > $o ).

tff(pred_def_9835,type,
    v18555: state_type > $o ).

tff(pred_def_9836,type,
    v18560: state_type > $o ).

tff(pred_def_9837,type,
    v18559: state_type > $o ).

tff(pred_def_9838,type,
    v18545: state_type > $o ).

tff(pred_def_9839,type,
    v18543: state_type > $o ).

tff(pred_def_9840,type,
    v18541: state_type > $o ).

tff(pred_def_9841,type,
    v18539: state_type > $o ).

tff(pred_def_9842,type,
    v18537: state_type > $o ).

tff(pred_def_9843,type,
    v18564: state_type > $o ).

tff(pred_def_9844,type,
    v18562: state_type > $o ).

tff(pred_def_9845,type,
    v18531: state_type > $o ).

tff(pred_def_9846,type,
    v18570: state_type > $o ).

tff(pred_def_9847,type,
    v18572: state_type > $o ).

tff(pred_def_9848,type,
    v18568: state_type > $o ).

tff(pred_def_9849,type,
    v18567: state_type > $o ).

tff(pred_def_9850,type,
    v18578: state_type > $o ).

tff(pred_def_9851,type,
    v18579: state_type > $o ).

tff(pred_def_9852,type,
    v18575: state_type > $o ).

tff(pred_def_9853,type,
    v18577: state_type > $o ).

tff(pred_def_9854,type,
    v18585: state_type > $o ).

tff(pred_def_9855,type,
    v18583: state_type > $o ).

tff(pred_def_9856,type,
    v18587: state_type > $o ).

tff(pred_def_9857,type,
    v18525: state_type > $o ).

tff(pred_def_9858,type,
    v18523: state_type > $o ).

tff(pred_def_9859,type,
    v18521: state_type > $o ).

tff(pred_def_9860,type,
    v18594: state_type > $o ).

tff(pred_def_9861,type,
    v18592: state_type > $o ).

tff(pred_def_9862,type,
    v18591: state_type > $o ).

tff(pred_def_9863,type,
    v18590: state_type > $o ).

tff(pred_def_9864,type,
    v18602: state_type > $o ).

tff(pred_def_9865,type,
    v18603: state_type > $o ).

tff(pred_def_9866,type,
    v18601: state_type > $o ).

tff(pred_def_9867,type,
    v18598: ( state_type * $int ) > $o ).

tff(pred_def_9868,type,
    v18600: ( state_type * $int ) > $o ).

tff(pred_def_9869,type,
    v18495: ( state_type * $int ) > $o ).

tff(pred_def_9870,type,
    v18493: ( state_type * $int ) > $o ).

tff(pred_def_9871,type,
    v18491: ( state_type * $int ) > $o ).

tff(pred_def_9872,type,
    v18489: ( state_type * $int ) > $o ).

tff(pred_def_9873,type,
    v18487: ( state_type * $int ) > $o ).

tff(pred_def_9874,type,
    v18625: state_type > $o ).

tff(pred_def_9875,type,
    v18623: state_type > $o ).

tff(pred_def_9876,type,
    v18629: state_type > $o ).

tff(pred_def_9877,type,
    v18627: state_type > $o ).

tff(pred_def_9878,type,
    v18633: state_type > $o ).

tff(pred_def_9879,type,
    v18631: state_type > $o ).

tff(pred_def_9880,type,
    v18636: state_type > $o ).

tff(pred_def_9881,type,
    v18635: state_type > $o ).

tff(pred_def_9882,type,
    v18621: state_type > $o ).

tff(pred_def_9883,type,
    v18619: state_type > $o ).

tff(pred_def_9884,type,
    v18617: state_type > $o ).

tff(pred_def_9885,type,
    v18615: state_type > $o ).

tff(pred_def_9886,type,
    v18613: state_type > $o ).

tff(pred_def_9887,type,
    v18611: state_type > $o ).

tff(pred_def_9888,type,
    v18609: state_type > $o ).

tff(pred_def_9889,type,
    v18607: state_type > $o ).

tff(pred_def_9890,type,
    v18656: state_type > $o ).

tff(pred_def_9891,type,
    v18654: state_type > $o ).

tff(pred_def_9892,type,
    v18652: state_type > $o ).

tff(pred_def_9893,type,
    v18650: state_type > $o ).

tff(pred_def_9894,type,
    v18648: state_type > $o ).

tff(pred_def_9895,type,
    v18666: state_type > $o ).

tff(pred_def_9896,type,
    v18664: state_type > $o ).

tff(pred_def_9897,type,
    v18662: state_type > $o ).

tff(pred_def_9898,type,
    v18660: state_type > $o ).

tff(pred_def_9899,type,
    v18658: state_type > $o ).

tff(pred_def_9900,type,
    v18670: ( state_type * $int ) > $o ).

tff(pred_def_9901,type,
    v18668: ( state_type * $int ) > $o ).

tff(pred_def_9902,type,
    v18680: state_type > $o ).

tff(pred_def_9903,type,
    v18678: state_type > $o ).

tff(pred_def_9904,type,
    v18686: state_type > $o ).

tff(pred_def_9905,type,
    v18684: state_type > $o ).

tff(pred_def_9906,type,
    v18699: state_type > $o ).

tff(pred_def_9907,type,
    v18697: state_type > $o ).

tff(pred_def_9908,type,
    v18703: state_type > $o ).

tff(pred_def_9909,type,
    v18701: state_type > $o ).

tff(pred_def_9910,type,
    v18707: state_type > $o ).

tff(pred_def_9911,type,
    v18705: state_type > $o ).

tff(pred_def_9912,type,
    v18710: state_type > $o ).

tff(pred_def_9913,type,
    v18709: state_type > $o ).

tff(pred_def_9914,type,
    v18695: state_type > $o ).

tff(pred_def_9915,type,
    v18693: state_type > $o ).

tff(pred_def_9916,type,
    v18690: state_type > $o ).

tff(pred_def_9917,type,
    v18688: state_type > $o ).

tff(pred_def_9918,type,
    v18714: state_type > $o ).

tff(pred_def_9919,type,
    v18712: state_type > $o ).

tff(pred_def_9920,type,
    v18682: state_type > $o ).

tff(pred_def_9921,type,
    v18720: state_type > $o ).

tff(pred_def_9922,type,
    v18722: state_type > $o ).

tff(pred_def_9923,type,
    v18718: state_type > $o ).

tff(pred_def_9924,type,
    v18717: state_type > $o ).

tff(pred_def_9925,type,
    v18728: state_type > $o ).

tff(pred_def_9926,type,
    v18729: state_type > $o ).

tff(pred_def_9927,type,
    v18725: state_type > $o ).

tff(pred_def_9928,type,
    v18727: state_type > $o ).

tff(pred_def_9929,type,
    v18735: state_type > $o ).

tff(pred_def_9930,type,
    v18733: state_type > $o ).

tff(pred_def_9931,type,
    v18737: state_type > $o ).

tff(pred_def_9932,type,
    v18676: state_type > $o ).

tff(pred_def_9933,type,
    v18674: state_type > $o ).

tff(pred_def_9934,type,
    v18672: state_type > $o ).

tff(pred_def_9935,type,
    v18744: state_type > $o ).

tff(pred_def_9936,type,
    v18742: state_type > $o ).

tff(pred_def_9937,type,
    v18741: state_type > $o ).

tff(pred_def_9938,type,
    v18740: state_type > $o ).

tff(pred_def_9939,type,
    v18752: state_type > $o ).

tff(pred_def_9940,type,
    v18753: state_type > $o ).

tff(pred_def_9941,type,
    v18751: state_type > $o ).

tff(pred_def_9942,type,
    v18748: ( state_type * $int ) > $o ).

tff(pred_def_9943,type,
    v18750: ( state_type * $int ) > $o ).

tff(pred_def_9944,type,
    v18646: ( state_type * $int ) > $o ).

tff(pred_def_9945,type,
    v18644: ( state_type * $int ) > $o ).

tff(pred_def_9946,type,
    v18642: ( state_type * $int ) > $o ).

tff(pred_def_9947,type,
    v18640: ( state_type * $int ) > $o ).

tff(pred_def_9948,type,
    v18638: ( state_type * $int ) > $o ).

tff(pred_def_9949,type,
    v18765: state_type > $o ).

tff(pred_def_9950,type,
    v18763: state_type > $o ).

tff(pred_def_9951,type,
    v18761: state_type > $o ).

tff(pred_def_9952,type,
    v18759: state_type > $o ).

tff(pred_def_9953,type,
    v18757: state_type > $o ).

tff(pred_def_9954,type,
    v18773: state_type > $o ).

tff(pred_def_9955,type,
    v18772: ( state_type * $int ) > $o ).

tff(pred_def_9956,type,
    v18771: ( state_type * $int ) > $o ).

tff(pred_def_9957,type,
    v18776: state_type > $o ).

tff(pred_def_9958,type,
    v18775: ( state_type * $int ) > $o ).

tff(pred_def_9959,type,
    v18774: ( state_type * $int ) > $o ).

tff(pred_def_9960,type,
    v18770: ( state_type * $int ) > $o ).

tff(pred_def_9961,type,
    v18779: state_type > $o ).

tff(pred_def_9962,type,
    v18778: ( state_type * $int ) > $o ).

tff(pred_def_9963,type,
    v18777: ( state_type * $int ) > $o ).

tff(pred_def_9964,type,
    v18769: ( state_type * $int ) > $o ).

tff(pred_def_9965,type,
    v18782: state_type > $o ).

tff(pred_def_9966,type,
    v18781: ( state_type * $int ) > $o ).

tff(pred_def_9967,type,
    v18780: ( state_type * $int ) > $o ).

tff(pred_def_9968,type,
    v18768: ( state_type * $int ) > $o ).

tff(pred_def_9969,type,
    v18785: state_type > $o ).

tff(pred_def_9970,type,
    v18784: ( state_type * $int ) > $o ).

tff(pred_def_9971,type,
    v18783: ( state_type * $int ) > $o ).

tff(pred_def_9972,type,
    v18767: ( state_type * $int ) > $o ).

tff(pred_def_9973,type,
    v18788: state_type > $o ).

tff(pred_def_9974,type,
    v18787: ( state_type * $int ) > $o ).

tff(pred_def_9975,type,
    v18786: ( state_type * $int ) > $o ).

tff(pred_def_9976,type,
    v17259: ( state_type * $int ) > $o ).

tff(pred_def_9977,type,
    v17257: ( state_type * $int ) > $o ).

tff(pred_def_9978,type,
    v17255: ( state_type * $int ) > $o ).

tff(pred_def_9979,type,
    v17253: ( state_type * $int ) > $o ).

tff(pred_def_9980,type,
    v17251: ( state_type * $int ) > $o ).

tff(pred_def_9981,type,
    v17245: state_type > $o ).

tff(pred_def_9982,type,
    v17243: state_type > $o ).

tff(pred_def_9983,type,
    v17241: state_type > $o ).

tff(pred_def_9984,type,
    v18799: ( state_type * $int ) > $o ).

tff(pred_def_9985,type,
    v18797: ( state_type * $int ) > $o ).

tff(pred_def_9986,type,
    v18833: state_type > $o ).

tff(pred_def_9987,type,
    v18831: state_type > $o ).

tff(pred_def_9988,type,
    v18829: state_type > $o ).

tff(pred_def_9989,type,
    v18827: state_type > $o ).

tff(pred_def_9990,type,
    v18825: state_type > $o ).

tff(pred_def_9991,type,
    v18823: state_type > $o ).

tff(pred_def_9992,type,
    v18821: state_type > $o ).

tff(pred_def_9993,type,
    v18847: state_type > $o ).

tff(pred_def_9994,type,
    v18845: state_type > $o ).

tff(pred_def_9995,type,
    v18843: state_type > $o ).

tff(pred_def_9996,type,
    v18841: state_type > $o ).

tff(pred_def_9997,type,
    v18839: state_type > $o ).

tff(pred_def_9998,type,
    v18837: state_type > $o ).

tff(pred_def_9999,type,
    v18835: state_type > $o ).

tff(pred_def_10000,type,
    v18873: state_type > $o ).

tff(pred_def_10001,type,
    v18875: state_type > $o ).

tff(pred_def_10002,type,
    v18874: ( state_type * $int ) > $o ).

tff(pred_def_10003,type,
    v18876: state_type > $o ).

tff(pred_def_10004,type,
    v18871: ( state_type * $int ) > $o ).

tff(pred_def_10005,type,
    v18869: ( state_type * $int ) > $o ).

tff(pred_def_10006,type,
    v18877: ( state_type * $int ) > $o ).

tff(pred_def_10007,type,
    v18867: ( state_type * $int ) > $o ).

tff(pred_def_10008,type,
    v18865: ( state_type * $int ) > $o ).

tff(pred_def_10009,type,
    v18863: state_type > $o ).

tff(pred_def_10010,type,
    v18879: state_type > $o ).

tff(pred_def_10011,type,
    v18861: ( state_type * $int ) > $o ).

tff(pred_def_10012,type,
    v18859: ( state_type * $int ) > $o ).

tff(pred_def_10013,type,
    v18893: ( state_type * $int ) > $o ).

tff(pred_def_10014,type,
    v18891: ( state_type * $int ) > $o ).

tff(pred_def_10015,type,
    v18897: state_type > $o ).

tff(pred_def_10016,type,
    v18895: state_type > $o ).

tff(pred_def_10017,type,
    v18921: state_type > $o ).

tff(pred_def_10018,type,
    v18919: state_type > $o ).

tff(pred_def_10019,type,
    v18917: state_type > $o ).

tff(pred_def_10020,type,
    v18915: state_type > $o ).

tff(pred_def_10021,type,
    v18913: state_type > $o ).

tff(pred_def_10022,type,
    v18911: state_type > $o ).

tff(pred_def_10023,type,
    v18909: state_type > $o ).

tff(pred_def_10024,type,
    v18935: state_type > $o ).

tff(pred_def_10025,type,
    v18933: state_type > $o ).

tff(pred_def_10026,type,
    v18931: state_type > $o ).

tff(pred_def_10027,type,
    v18929: state_type > $o ).

tff(pred_def_10028,type,
    v18927: state_type > $o ).

tff(pred_def_10029,type,
    v18925: state_type > $o ).

tff(pred_def_10030,type,
    v18923: state_type > $o ).

tff(pred_def_10031,type,
    v18951: ( state_type * $int ) > $o ).

tff(pred_def_10032,type,
    v18949: ( state_type * $int ) > $o ).

tff(pred_def_10033,type,
    v18947: ( state_type * $int ) > $o ).

tff(pred_def_10034,type,
    v18945: ( state_type * $int ) > $o ).

tff(pred_def_10035,type,
    v18943: ( state_type * $int ) > $o ).

tff(pred_def_10036,type,
    v18981: ( state_type * $int ) > $o ).

tff(pred_def_10037,type,
    v18983: ( state_type * $int ) > $o ).

tff(pred_def_10038,type,
    v18979: ( state_type * $int ) > $o ).

tff(pred_def_10039,type,
    v18977: ( state_type * $int ) > $o ).

tff(pred_def_10040,type,
    v18975: ( state_type * $int ) > $o ).

tff(pred_def_10041,type,
    v18973: ( state_type * $int ) > $o ).

tff(pred_def_10042,type,
    v18971: state_type > $o ).

tff(pred_def_10043,type,
    v18969: state_type > $o ).

tff(pred_def_10044,type,
    v18987: state_type > $o ).

tff(pred_def_10045,type,
    v18985: state_type > $o ).

tff(pred_def_10046,type,
    v18989: state_type > $o ).

tff(pred_def_10047,type,
    v18967: state_type > $o ).

tff(pred_def_10048,type,
    v18965: state_type > $o ).

tff(pred_def_10049,type,
    v18963: state_type > $o ).

tff(pred_def_10050,type,
    v18961: state_type > $o ).

tff(pred_def_10051,type,
    v18959: state_type > $o ).

tff(pred_def_10052,type,
    v18957: state_type > $o ).

tff(pred_def_10053,type,
    v18955: state_type > $o ).

tff(pred_def_10054,type,
    v18953: state_type > $o ).

tff(pred_def_10055,type,
    v18999: ( state_type * $int ) > $o ).

tff(pred_def_10056,type,
    v18997: ( state_type * $int ) > $o ).

tff(pred_def_10057,type,
    v18995: ( state_type * $int ) > $o ).

tff(pred_def_10058,type,
    v18993: ( state_type * $int ) > $o ).

tff(pred_def_10059,type,
    v18991: ( state_type * $int ) > $o ).

tff(pred_def_10060,type,
    v19029: ( state_type * $int ) > $o ).

tff(pred_def_10061,type,
    v19027: ( state_type * $int ) > $o ).

tff(pred_def_10062,type,
    v19030: ( state_type * $int ) > $o ).

tff(pred_def_10063,type,
    v19025: ( state_type * $int ) > $o ).

tff(pred_def_10064,type,
    v19023: ( state_type * $int ) > $o ).

tff(pred_def_10065,type,
    v19021: ( state_type * $int ) > $o ).

tff(pred_def_10066,type,
    v19019: state_type > $o ).

tff(pred_def_10067,type,
    v19017: state_type > $o ).

tff(pred_def_10068,type,
    v19034: state_type > $o ).

tff(pred_def_10069,type,
    v19032: state_type > $o ).

tff(pred_def_10070,type,
    v19036: state_type > $o ).

tff(pred_def_10071,type,
    v19015: state_type > $o ).

tff(pred_def_10072,type,
    v19013: state_type > $o ).

tff(pred_def_10073,type,
    v19011: state_type > $o ).

tff(pred_def_10074,type,
    v19009: state_type > $o ).

tff(pred_def_10075,type,
    v19007: state_type > $o ).

tff(pred_def_10076,type,
    v19005: state_type > $o ).

tff(pred_def_10077,type,
    v19003: state_type > $o ).

tff(pred_def_10078,type,
    v19001: state_type > $o ).

tff(pred_def_10079,type,
    v19046: ( state_type * $int ) > $o ).

tff(pred_def_10080,type,
    v19044: ( state_type * $int ) > $o ).

tff(pred_def_10081,type,
    v19042: ( state_type * $int ) > $o ).

tff(pred_def_10082,type,
    v19040: ( state_type * $int ) > $o ).

tff(pred_def_10083,type,
    v19038: ( state_type * $int ) > $o ).

tff(pred_def_10084,type,
    v19066: state_type > $o ).

tff(pred_def_10085,type,
    v19064: state_type > $o ).

tff(pred_def_10086,type,
    v19070: state_type > $o ).

tff(pred_def_10087,type,
    v19068: state_type > $o ).

tff(pred_def_10088,type,
    v19072: state_type > $o ).

tff(pred_def_10089,type,
    v19062: state_type > $o ).

tff(pred_def_10090,type,
    v19060: state_type > $o ).

tff(pred_def_10091,type,
    v19058: state_type > $o ).

tff(pred_def_10092,type,
    v19056: state_type > $o ).

tff(pred_def_10093,type,
    v19054: state_type > $o ).

tff(pred_def_10094,type,
    v19052: state_type > $o ).

tff(pred_def_10095,type,
    v19050: state_type > $o ).

tff(pred_def_10096,type,
    v19048: state_type > $o ).

tff(pred_def_10097,type,
    v19082: ( state_type * $int ) > $o ).

tff(pred_def_10098,type,
    v19080: ( state_type * $int ) > $o ).

tff(pred_def_10099,type,
    v19078: ( state_type * $int ) > $o ).

tff(pred_def_10100,type,
    v19076: ( state_type * $int ) > $o ).

tff(pred_def_10101,type,
    v19074: ( state_type * $int ) > $o ).

tff(pred_def_10102,type,
    v19102: state_type > $o ).

tff(pred_def_10103,type,
    v19100: state_type > $o ).

tff(pred_def_10104,type,
    v19106: state_type > $o ).

tff(pred_def_10105,type,
    v19104: state_type > $o ).

tff(pred_def_10106,type,
    v19108: state_type > $o ).

tff(pred_def_10107,type,
    v19098: state_type > $o ).

tff(pred_def_10108,type,
    v19096: state_type > $o ).

tff(pred_def_10109,type,
    v19094: state_type > $o ).

tff(pred_def_10110,type,
    v19092: state_type > $o ).

tff(pred_def_10111,type,
    v19090: state_type > $o ).

tff(pred_def_10112,type,
    v19088: state_type > $o ).

tff(pred_def_10113,type,
    v19086: state_type > $o ).

tff(pred_def_10114,type,
    v19084: state_type > $o ).

tff(pred_def_10115,type,
    v19114: state_type > $o ).

tff(pred_def_10116,type,
    v19113: ( state_type * $int ) > $o ).

tff(pred_def_10117,type,
    v19112: ( state_type * $int ) > $o ).

tff(pred_def_10118,type,
    v19117: state_type > $o ).

tff(pred_def_10119,type,
    v19116: ( state_type * $int ) > $o ).

tff(pred_def_10120,type,
    v19115: ( state_type * $int ) > $o ).

tff(pred_def_10121,type,
    v19111: ( state_type * $int ) > $o ).

tff(pred_def_10122,type,
    v19120: state_type > $o ).

tff(pred_def_10123,type,
    v19119: ( state_type * $int ) > $o ).

tff(pred_def_10124,type,
    v19118: ( state_type * $int ) > $o ).

tff(pred_def_10125,type,
    v19110: ( state_type * $int ) > $o ).

tff(pred_def_10126,type,
    v19123: state_type > $o ).

tff(pred_def_10127,type,
    v19122: ( state_type * $int ) > $o ).

tff(pred_def_10128,type,
    v19121: ( state_type * $int ) > $o ).

tff(pred_def_10129,type,
    v18941: ( state_type * $int ) > $o ).

tff(pred_def_10130,type,
    v18939: ( state_type * $int ) > $o ).

tff(pred_def_10131,type,
    v18937: ( state_type * $int ) > $o ).

tff(pred_def_10132,type,
    v19135: state_type > $o ).

tff(pred_def_10133,type,
    v19133: state_type > $o ).

tff(pred_def_10134,type,
    v19131: state_type > $o ).

tff(pred_def_10135,type,
    v19145: state_type > $o ).

tff(pred_def_10136,type,
    v19143: state_type > $o ).

tff(pred_def_10137,type,
    v19141: state_type > $o ).

tff(pred_def_10138,type,
    v19139: state_type > $o ).

tff(pred_def_10139,type,
    v19137: state_type > $o ).

tff(pred_def_10140,type,
    v19147: state_type > $o ).

tff(pred_def_10141,type,
    v19129: state_type > $o ).

tff(pred_def_10142,type,
    v19127: state_type > $o ).

tff(pred_def_10143,type,
    v19125: state_type > $o ).

tff(pred_def_10144,type,
    v19154: state_type > $o ).

tff(pred_def_10145,type,
    v19152: state_type > $o ).

tff(pred_def_10146,type,
    v19151: state_type > $o ).

tff(pred_def_10147,type,
    v19150: state_type > $o ).

tff(pred_def_10148,type,
    v19162: state_type > $o ).

tff(pred_def_10149,type,
    v19163: state_type > $o ).

tff(pred_def_10150,type,
    v19161: state_type > $o ).

tff(pred_def_10151,type,
    v19158: ( state_type * $int ) > $o ).

tff(pred_def_10152,type,
    v19160: ( state_type * $int ) > $o ).

tff(pred_def_10153,type,
    v18907: ( state_type * $int ) > $o ).

tff(pred_def_10154,type,
    v18905: ( state_type * $int ) > $o ).

tff(pred_def_10155,type,
    v18903: ( state_type * $int ) > $o ).

tff(pred_def_10156,type,
    v18901: ( state_type * $int ) > $o ).

tff(pred_def_10157,type,
    v18899: ( state_type * $int ) > $o ).

tff(pred_def_10158,type,
    v19169: state_type > $o ).

tff(pred_def_10159,type,
    v19167: state_type > $o ).

tff(pred_def_10160,type,
    v19173: state_type > $o ).

tff(pred_def_10161,type,
    v19172: ( state_type * $int ) > $o ).

tff(pred_def_10162,type,
    v19171: ( state_type * $int ) > $o ).

tff(pred_def_10163,type,
    v19176: state_type > $o ).

tff(pred_def_10164,type,
    v19175: ( state_type * $int ) > $o ).

tff(pred_def_10165,type,
    v19174: ( state_type * $int ) > $o ).

tff(pred_def_10166,type,
    v18889: ( state_type * $int ) > $o ).

tff(pred_def_10167,type,
    v18887: ( state_type * $int ) > $o ).

tff(pred_def_10168,type,
    v18885: ( state_type * $int ) > $o ).

tff(pred_def_10169,type,
    v18883: ( state_type * $int ) > $o ).

tff(pred_def_10170,type,
    v18881: ( state_type * $int ) > $o ).

tff(pred_def_10171,type,
    v18857: ( state_type * $int ) > $o ).

tff(pred_def_10172,type,
    v18855: ( state_type * $int ) > $o ).

tff(pred_def_10173,type,
    v18853: ( state_type * $int ) > $o ).

tff(pred_def_10174,type,
    v18851: ( state_type * $int ) > $o ).

tff(pred_def_10175,type,
    v18849: ( state_type * $int ) > $o ).

tff(pred_def_10176,type,
    v19189: state_type > $o ).

tff(pred_def_10177,type,
    v19187: state_type > $o ).

tff(pred_def_10178,type,
    v19185: state_type > $o ).

tff(pred_def_10179,type,
    v19195: state_type > $o ).

tff(pred_def_10180,type,
    v19193: state_type > $o ).

tff(pred_def_10181,type,
    v19213: ( state_type * $int ) > $o ).

tff(pred_def_10182,type,
    v19215: ( state_type * $int ) > $o ).

tff(pred_def_10183,type,
    v19211: ( state_type * $int ) > $o ).

tff(pred_def_10184,type,
    v19209: state_type > $o ).

tff(pred_def_10185,type,
    v19207: state_type > $o ).

tff(pred_def_10186,type,
    v19219: state_type > $o ).

tff(pred_def_10187,type,
    v19217: state_type > $o ).

tff(pred_def_10188,type,
    v19223: state_type > $o ).

tff(pred_def_10189,type,
    v19221: state_type > $o ).

tff(pred_def_10190,type,
    v19226: state_type > $o ).

tff(pred_def_10191,type,
    v19225: state_type > $o ).

tff(pred_def_10192,type,
    v19205: state_type > $o ).

tff(pred_def_10193,type,
    v19203: state_type > $o ).

tff(pred_def_10194,type,
    v19201: state_type > $o ).

tff(pred_def_10195,type,
    v19199: state_type > $o ).

tff(pred_def_10196,type,
    v19197: state_type > $o ).

tff(pred_def_10197,type,
    v19234: state_type > $o ).

tff(pred_def_10198,type,
    v19232: state_type > $o ).

tff(pred_def_10199,type,
    v19230: state_type > $o ).

tff(pred_def_10200,type,
    v19228: state_type > $o ).

tff(pred_def_10201,type,
    v19191: state_type > $o ).

tff(pred_def_10202,type,
    v19240: state_type > $o ).

tff(pred_def_10203,type,
    v19242: state_type > $o ).

tff(pred_def_10204,type,
    v19238: state_type > $o ).

tff(pred_def_10205,type,
    v19237: state_type > $o ).

tff(pred_def_10206,type,
    v19248: state_type > $o ).

tff(pred_def_10207,type,
    v19249: state_type > $o ).

tff(pred_def_10208,type,
    v19245: state_type > $o ).

tff(pred_def_10209,type,
    v19247: state_type > $o ).

tff(pred_def_10210,type,
    v19259: state_type > $o ).

tff(pred_def_10211,type,
    v19257: state_type > $o ).

tff(pred_def_10212,type,
    v19255: state_type > $o ).

tff(pred_def_10213,type,
    v19253: state_type > $o ).

tff(pred_def_10214,type,
    v19261: state_type > $o ).

tff(pred_def_10215,type,
    v19183: state_type > $o ).

tff(pred_def_10216,type,
    v19181: state_type > $o ).

tff(pred_def_10217,type,
    v19179: state_type > $o ).

tff(pred_def_10218,type,
    v19268: state_type > $o ).

tff(pred_def_10219,type,
    v19266: state_type > $o ).

tff(pred_def_10220,type,
    v19265: state_type > $o ).

tff(pred_def_10221,type,
    v19264: state_type > $o ).

tff(pred_def_10222,type,
    v19276: state_type > $o ).

tff(pred_def_10223,type,
    v19277: state_type > $o ).

tff(pred_def_10224,type,
    v19275: state_type > $o ).

tff(pred_def_10225,type,
    v19272: ( state_type * $int ) > $o ).

tff(pred_def_10226,type,
    v19274: ( state_type * $int ) > $o ).

tff(pred_def_10227,type,
    v18819: ( state_type * $int ) > $o ).

tff(pred_def_10228,type,
    v18817: ( state_type * $int ) > $o ).

tff(pred_def_10229,type,
    v18815: ( state_type * $int ) > $o ).

tff(pred_def_10230,type,
    v18813: ( state_type * $int ) > $o ).

tff(pred_def_10231,type,
    v18811: ( state_type * $int ) > $o ).

tff(pred_def_10232,type,
    v19313: state_type > $o ).

tff(pred_def_10233,type,
    v19311: state_type > $o ).

tff(pred_def_10234,type,
    v19309: state_type > $o ).

tff(pred_def_10235,type,
    v19307: state_type > $o ).

tff(pred_def_10236,type,
    v19305: state_type > $o ).

tff(pred_def_10237,type,
    v19303: state_type > $o ).

tff(pred_def_10238,type,
    v19323: state_type > $o ).

tff(pred_def_10239,type,
    v19321: state_type > $o ).

tff(pred_def_10240,type,
    v19319: state_type > $o ).

tff(pred_def_10241,type,
    v19317: state_type > $o ).

tff(pred_def_10242,type,
    v19315: state_type > $o ).

tff(pred_def_10243,type,
    v19350: state_type > $o ).

tff(pred_def_10244,type,
    v19349: ( state_type * $int ) > $o ).

tff(pred_def_10245,type,
    v19348: ( state_type * $int ) > $o ).

tff(pred_def_10246,type,
    v19346: ( state_type * $int ) > $o ).

tff(pred_def_10247,type,
    v19366: state_type > $o ).

tff(pred_def_10248,type,
    v19367: ( state_type * $int ) > $o ).

tff(pred_def_10249,type,
    v19368: state_type > $o ).

tff(pred_def_10250,type,
    v19364: ( state_type * $int ) > $o ).

tff(pred_def_10251,type,
    v19362: ( state_type * $int ) > $o ).

tff(pred_def_10252,type,
    v19392: ( state_type * $int ) > $o ).

tff(pred_def_10253,type,
    v19301: ( state_type * $int ) > $o ).

tff(pred_def_10254,type,
    v19390: ( state_type * $int ) > $o ).

tff(pred_def_10255,type,
    v19393: ( state_type * $int ) > $o ).

tff(pred_def_10256,type,
    v19388: ( state_type * $int ) > $o ).

tff(pred_def_10257,type,
    v19386: ( state_type * $int ) > $o ).

tff(pred_def_10258,type,
    v19384: ( state_type * $int ) > $o ).

tff(pred_def_10259,type,
    v19382: state_type > $o ).

tff(pred_def_10260,type,
    v19380: state_type > $o ).

tff(pred_def_10261,type,
    v19399: state_type > $o ).

tff(pred_def_10262,type,
    v19339: state_type > $o ).

tff(pred_def_10263,type,
    v19398: ( state_type * $int ) > $o ).

tff(pred_def_10264,type,
    v19337: ( state_type * $int ) > $o ).

tff(pred_def_10265,type,
    v19335: ( state_type * $int ) > $o ).

tff(pred_def_10266,type,
    v19414: ( state_type * $int ) > $o ).

tff(pred_def_10267,type,
    v19413: ( state_type * $int ) > $o ).

tff(pred_def_10268,type,
    v19411: ( state_type * $int ) > $o ).

tff(pred_def_10269,type,
    v19418: state_type > $o ).

tff(pred_def_10270,type,
    v19416: state_type > $o ).

tff(pred_def_10271,type,
    v19429: ( state_type * $int ) > $o ).

tff(pred_def_10272,type,
    v19428: state_type > $o ).

tff(pred_def_10273,type,
    v19432: state_type > $o ).

tff(pred_def_10274,type,
    v19433: state_type > $o ).

tff(pred_def_10275,type,
    v19431: state_type > $o ).

tff(pred_def_10276,type,
    v19434: state_type > $o ).

tff(pred_def_10277,type,
    v19430: state_type > $o ).

tff(pred_def_10278,type,
    v19427: state_type > $o ).

tff(pred_def_10279,type,
    v19435: state_type > $o ).

tff(pred_def_10280,type,
    v19426: state_type > $o ).

tff(pred_def_10281,type,
    v19438: state_type > $o ).

tff(pred_def_10282,type,
    v19439: state_type > $o ).

tff(pred_def_10283,type,
    v19437: state_type > $o ).

tff(pred_def_10284,type,
    v19440: state_type > $o ).

tff(pred_def_10285,type,
    v19436: state_type > $o ).

tff(pred_def_10286,type,
    v19425: state_type > $o ).

tff(pred_def_10287,type,
    v19441: state_type > $o ).

tff(pred_def_10288,type,
    v19424: state_type > $o ).

tff(pred_def_10289,type,
    v19423: state_type > $o ).

tff(pred_def_10290,type,
    v19445: state_type > $o ).

tff(pred_def_10291,type,
    v19446: state_type > $o ).

tff(pred_def_10292,type,
    v19444: state_type > $o ).

tff(pred_def_10293,type,
    v19447: state_type > $o ).

tff(pred_def_10294,type,
    v19443: state_type > $o ).

tff(pred_def_10295,type,
    v19442: state_type > $o ).

tff(pred_def_10296,type,
    v19422: state_type > $o ).

tff(pred_def_10297,type,
    v19448: state_type > $o ).

tff(pred_def_10298,type,
    v19421: state_type > $o ).

tff(pred_def_10299,type,
    v19451: state_type > $o ).

tff(pred_def_10300,type,
    v19452: state_type > $o ).

tff(pred_def_10301,type,
    v19450: state_type > $o ).

tff(pred_def_10302,type,
    v19453: state_type > $o ).

tff(pred_def_10303,type,
    v19449: state_type > $o ).

tff(pred_def_10304,type,
    v19456: state_type > $o ).

tff(pred_def_10305,type,
    v19457: state_type > $o ).

tff(pred_def_10306,type,
    v19455: state_type > $o ).

tff(pred_def_10307,type,
    v19458: state_type > $o ).

tff(pred_def_10308,type,
    v19454: state_type > $o ).

tff(pred_def_10309,type,
    v19461: state_type > $o ).

tff(pred_def_10310,type,
    v19462: state_type > $o ).

tff(pred_def_10311,type,
    v19460: state_type > $o ).

tff(pred_def_10312,type,
    v19463: state_type > $o ).

tff(pred_def_10313,type,
    v19459: state_type > $o ).

tff(pred_def_10314,type,
    v19419: ( state_type * $int ) > $o ).

tff(pred_def_10315,type,
    v19409: ( state_type * $int ) > $o ).

tff(pred_def_10316,type,
    v19407: ( state_type * $int ) > $o ).

tff(pred_def_10317,type,
    v19405: ( state_type * $int ) > $o ).

tff(pred_def_10318,type,
    v19403: ( state_type * $int ) > $o ).

tff(pred_def_10319,type,
    v19401: ( state_type * $int ) > $o ).

tff(pred_def_10320,type,
    v19464: ( state_type * $int ) > $o ).

tff(pred_def_10321,type,
    v19333: ( state_type * $int ) > $o ).

tff(pred_def_10322,type,
    v19331: ( state_type * $int ) > $o ).

tff(pred_def_10323,type,
    v19329: ( state_type * $int ) > $o ).

tff(pred_def_10324,type,
    v19465: ( state_type * $int ) > $o ).

tff(pred_def_10325,type,
    v19466: ( state_type * $int ) > $o ).

tff(pred_def_10326,type,
    v19327: ( state_type * $int ) > $o ).

tff(pred_def_10327,type,
    v19325: ( state_type * $int ) > $o ).

tff(pred_def_10328,type,
    v19476: state_type > $o ).

tff(pred_def_10329,type,
    v19474: state_type > $o ).

tff(pred_def_10330,type,
    v19482: state_type > $o ).

tff(pred_def_10331,type,
    v19480: state_type > $o ).

tff(pred_def_10332,type,
    v19486: state_type > $o ).

tff(pred_def_10333,type,
    v19484: state_type > $o ).

tff(pred_def_10334,type,
    v19490: state_type > $o ).

tff(pred_def_10335,type,
    v19488: state_type > $o ).

tff(pred_def_10336,type,
    v19478: state_type > $o ).

tff(pred_def_10337,type,
    v19496: state_type > $o ).

tff(pred_def_10338,type,
    v19498: state_type > $o ).

tff(pred_def_10339,type,
    v19494: state_type > $o ).

tff(pred_def_10340,type,
    v19493: state_type > $o ).

tff(pred_def_10341,type,
    v19504: state_type > $o ).

tff(pred_def_10342,type,
    v19505: state_type > $o ).

tff(pred_def_10343,type,
    v19501: state_type > $o ).

tff(pred_def_10344,type,
    v19503: state_type > $o ).

tff(pred_def_10345,type,
    v19511: state_type > $o ).

tff(pred_def_10346,type,
    v19509: state_type > $o ).

tff(pred_def_10347,type,
    v19513: state_type > $o ).

tff(pred_def_10348,type,
    v19472: state_type > $o ).

tff(pred_def_10349,type,
    v19470: state_type > $o ).

tff(pred_def_10350,type,
    v19468: state_type > $o ).

tff(pred_def_10351,type,
    v19520: state_type > $o ).

tff(pred_def_10352,type,
    v19518: state_type > $o ).

tff(pred_def_10353,type,
    v19517: state_type > $o ).

tff(pred_def_10354,type,
    v19516: state_type > $o ).

tff(pred_def_10355,type,
    v19528: state_type > $o ).

tff(pred_def_10356,type,
    v19529: state_type > $o ).

tff(pred_def_10357,type,
    v19527: state_type > $o ).

tff(pred_def_10358,type,
    v19524: ( state_type * $int ) > $o ).

tff(pred_def_10359,type,
    v19526: ( state_type * $int ) > $o ).

tff(pred_def_10360,type,
    v19515: ( state_type * $int ) > $o ).

tff(pred_def_10361,type,
    v19397: state_type > $o ).

tff(pred_def_10362,type,
    v19395: state_type > $o ).

tff(pred_def_10363,type,
    v19541: state_type > $o ).

tff(pred_def_10364,type,
    v19539: state_type > $o ).

tff(pred_def_10365,type,
    v19538: state_type > $o ).

tff(pred_def_10366,type,
    v19537: ( state_type * $int ) > $o ).

tff(pred_def_10367,type,
    v19535: state_type > $o ).

tff(pred_def_10368,type,
    v19533: state_type > $o ).

tff(pred_def_10369,type,
    v19546: state_type > $o ).

tff(pred_def_10370,type,
    v19545: state_type > $o ).

tff(pred_def_10371,type,
    v19378: state_type > $o ).

tff(pred_def_10372,type,
    v19376: state_type > $o ).

tff(pred_def_10373,type,
    v19374: state_type > $o ).

tff(pred_def_10374,type,
    v19547: ( state_type * $int ) > $o ).

tff(pred_def_10375,type,
    v19548: state_type > $o ).

tff(pred_def_10376,type,
    v19372: ( state_type * $int ) > $o ).

tff(pred_def_10377,type,
    v19370: ( state_type * $int ) > $o ).

tff(pred_def_10378,type,
    v19549: ( state_type * $int ) > $o ).

tff(pred_def_10379,type,
    v19360: ( state_type * $int ) > $o ).

tff(pred_def_10380,type,
    v19358: ( state_type * $int ) > $o ).

tff(pred_def_10381,type,
    v19356: state_type > $o ).

tff(pred_def_10382,type,
    v19550: ( state_type * $int ) > $o ).

tff(pred_def_10383,type,
    v19551: state_type > $o ).

tff(pred_def_10384,type,
    v19354: ( state_type * $int ) > $o ).

tff(pred_def_10385,type,
    v19352: ( state_type * $int ) > $o ).

tff(pred_def_10386,type,
    v19552: ( state_type * $int ) > $o ).

tff(pred_def_10387,type,
    v19344: ( state_type * $int ) > $o ).

tff(pred_def_10388,type,
    v19342: ( state_type * $int ) > $o ).

tff(pred_def_10389,type,
    v19558: state_type > $o ).

tff(pred_def_10390,type,
    v19556: state_type > $o ).

tff(pred_def_10391,type,
    v19555: state_type > $o ).

tff(pred_def_10392,type,
    v19554: ( state_type * $int ) > $o ).

tff(pred_def_10393,type,
    v19299: state_type > $o ).

tff(pred_def_10394,type,
    v19297: state_type > $o ).

tff(pred_def_10395,type,
    v19564: state_type > $o ).

tff(pred_def_10396,type,
    v19562: state_type > $o ).

tff(pred_def_10397,type,
    v19568: state_type > $o ).

tff(pred_def_10398,type,
    v19566: state_type > $o ).

tff(pred_def_10399,type,
    v19571: state_type > $o ).

tff(pred_def_10400,type,
    v19570: state_type > $o ).

tff(pred_def_10401,type,
    v19295: state_type > $o ).

tff(pred_def_10402,type,
    v19293: state_type > $o ).

tff(pred_def_10403,type,
    v19291: state_type > $o ).

tff(pred_def_10404,type,
    v19289: state_type > $o ).

tff(pred_def_10405,type,
    v19287: state_type > $o ).

tff(pred_def_10406,type,
    v19285: state_type > $o ).

tff(pred_def_10407,type,
    v19283: state_type > $o ).

tff(pred_def_10408,type,
    v19281: state_type > $o ).

tff(pred_def_10409,type,
    v19591: state_type > $o ).

tff(pred_def_10410,type,
    v19589: state_type > $o ).

tff(pred_def_10411,type,
    v19587: state_type > $o ).

tff(pred_def_10412,type,
    v19585: state_type > $o ).

tff(pred_def_10413,type,
    v19583: state_type > $o ).

tff(pred_def_10414,type,
    v19601: state_type > $o ).

tff(pred_def_10415,type,
    v19599: state_type > $o ).

tff(pred_def_10416,type,
    v19597: state_type > $o ).

tff(pred_def_10417,type,
    v19595: state_type > $o ).

tff(pred_def_10418,type,
    v19593: state_type > $o ).

tff(pred_def_10419,type,
    v19605: ( state_type * $int ) > $o ).

tff(pred_def_10420,type,
    v19603: ( state_type * $int ) > $o ).

tff(pred_def_10421,type,
    v19615: state_type > $o ).

tff(pred_def_10422,type,
    v19613: state_type > $o ).

tff(pred_def_10423,type,
    v19621: state_type > $o ).

tff(pred_def_10424,type,
    v19619: state_type > $o ).

tff(pred_def_10425,type,
    v19645: ( state_type * $int ) > $o ).

tff(pred_def_10426,type,
    v19643: ( state_type * $int ) > $o ).

tff(pred_def_10427,type,
    v19646: ( state_type * $int ) > $o ).

tff(pred_def_10428,type,
    v19641: ( state_type * $int ) > $o ).

tff(pred_def_10429,type,
    v19639: ( state_type * $int ) > $o ).

tff(pred_def_10430,type,
    v19637: ( state_type * $int ) > $o ).

tff(pred_def_10431,type,
    v19635: state_type > $o ).

tff(pred_def_10432,type,
    v19633: state_type > $o ).

tff(pred_def_10433,type,
    v19650: state_type > $o ).

tff(pred_def_10434,type,
    v19648: state_type > $o ).

tff(pred_def_10435,type,
    v19654: state_type > $o ).

tff(pred_def_10436,type,
    v19652: state_type > $o ).

tff(pred_def_10437,type,
    v19657: state_type > $o ).

tff(pred_def_10438,type,
    v19656: state_type > $o ).

tff(pred_def_10439,type,
    v19631: state_type > $o ).

tff(pred_def_10440,type,
    v19629: state_type > $o ).

tff(pred_def_10441,type,
    v19627: state_type > $o ).

tff(pred_def_10442,type,
    v19625: state_type > $o ).

tff(pred_def_10443,type,
    v19623: state_type > $o ).

tff(pred_def_10444,type,
    v19661: state_type > $o ).

tff(pred_def_10445,type,
    v19659: state_type > $o ).

tff(pred_def_10446,type,
    v19617: state_type > $o ).

tff(pred_def_10447,type,
    v19667: state_type > $o ).

tff(pred_def_10448,type,
    v19669: state_type > $o ).

tff(pred_def_10449,type,
    v19665: state_type > $o ).

tff(pred_def_10450,type,
    v19664: state_type > $o ).

tff(pred_def_10451,type,
    v19675: state_type > $o ).

tff(pred_def_10452,type,
    v19676: state_type > $o ).

tff(pred_def_10453,type,
    v19672: state_type > $o ).

tff(pred_def_10454,type,
    v19674: state_type > $o ).

tff(pred_def_10455,type,
    v19682: state_type > $o ).

tff(pred_def_10456,type,
    v19680: state_type > $o ).

tff(pred_def_10457,type,
    v19684: state_type > $o ).

tff(pred_def_10458,type,
    v19611: state_type > $o ).

tff(pred_def_10459,type,
    v19609: state_type > $o ).

tff(pred_def_10460,type,
    v19607: state_type > $o ).

tff(pred_def_10461,type,
    v19691: state_type > $o ).

tff(pred_def_10462,type,
    v19689: state_type > $o ).

tff(pred_def_10463,type,
    v19688: state_type > $o ).

tff(pred_def_10464,type,
    v19687: state_type > $o ).

tff(pred_def_10465,type,
    v19699: state_type > $o ).

tff(pred_def_10466,type,
    v19700: state_type > $o ).

tff(pred_def_10467,type,
    v19698: state_type > $o ).

tff(pred_def_10468,type,
    v19695: ( state_type * $int ) > $o ).

tff(pred_def_10469,type,
    v19697: ( state_type * $int ) > $o ).

tff(pred_def_10470,type,
    v19581: ( state_type * $int ) > $o ).

tff(pred_def_10471,type,
    v19579: ( state_type * $int ) > $o ).

tff(pred_def_10472,type,
    v19577: ( state_type * $int ) > $o ).

tff(pred_def_10473,type,
    v19575: ( state_type * $int ) > $o ).

tff(pred_def_10474,type,
    v19573: ( state_type * $int ) > $o ).

tff(pred_def_10475,type,
    v19722: state_type > $o ).

tff(pred_def_10476,type,
    v19720: state_type > $o ).

tff(pred_def_10477,type,
    v19726: state_type > $o ).

tff(pred_def_10478,type,
    v19724: state_type > $o ).

tff(pred_def_10479,type,
    v19730: state_type > $o ).

tff(pred_def_10480,type,
    v19728: state_type > $o ).

tff(pred_def_10481,type,
    v19733: state_type > $o ).

tff(pred_def_10482,type,
    v19732: state_type > $o ).

tff(pred_def_10483,type,
    v19718: state_type > $o ).

tff(pred_def_10484,type,
    v19716: state_type > $o ).

tff(pred_def_10485,type,
    v19714: state_type > $o ).

tff(pred_def_10486,type,
    v19712: state_type > $o ).

tff(pred_def_10487,type,
    v19710: state_type > $o ).

tff(pred_def_10488,type,
    v19708: state_type > $o ).

tff(pred_def_10489,type,
    v19706: state_type > $o ).

tff(pred_def_10490,type,
    v19704: state_type > $o ).

tff(pred_def_10491,type,
    v19753: state_type > $o ).

tff(pred_def_10492,type,
    v19751: state_type > $o ).

tff(pred_def_10493,type,
    v19749: state_type > $o ).

tff(pred_def_10494,type,
    v19747: state_type > $o ).

tff(pred_def_10495,type,
    v19745: state_type > $o ).

tff(pred_def_10496,type,
    v19763: state_type > $o ).

tff(pred_def_10497,type,
    v19761: state_type > $o ).

tff(pred_def_10498,type,
    v19759: state_type > $o ).

tff(pred_def_10499,type,
    v19757: state_type > $o ).

tff(pred_def_10500,type,
    v19755: state_type > $o ).

tff(pred_def_10501,type,
    v19767: ( state_type * $int ) > $o ).

tff(pred_def_10502,type,
    v19765: ( state_type * $int ) > $o ).

tff(pred_def_10503,type,
    v19777: state_type > $o ).

tff(pred_def_10504,type,
    v19775: state_type > $o ).

tff(pred_def_10505,type,
    v19783: state_type > $o ).

tff(pred_def_10506,type,
    v19781: state_type > $o ).

tff(pred_def_10507,type,
    v19797: state_type > $o ).

tff(pred_def_10508,type,
    v19795: state_type > $o ).

tff(pred_def_10509,type,
    v19801: state_type > $o ).

tff(pred_def_10510,type,
    v19799: state_type > $o ).

tff(pred_def_10511,type,
    v19805: state_type > $o ).

tff(pred_def_10512,type,
    v19803: state_type > $o ).

tff(pred_def_10513,type,
    v19808: state_type > $o ).

tff(pred_def_10514,type,
    v19807: state_type > $o ).

tff(pred_def_10515,type,
    v19793: state_type > $o ).

tff(pred_def_10516,type,
    v19791: state_type > $o ).

tff(pred_def_10517,type,
    v19789: state_type > $o ).

tff(pred_def_10518,type,
    v19787: state_type > $o ).

tff(pred_def_10519,type,
    v19785: state_type > $o ).

tff(pred_def_10520,type,
    v19812: state_type > $o ).

tff(pred_def_10521,type,
    v19810: state_type > $o ).

tff(pred_def_10522,type,
    v19779: state_type > $o ).

tff(pred_def_10523,type,
    v19818: state_type > $o ).

tff(pred_def_10524,type,
    v19820: state_type > $o ).

tff(pred_def_10525,type,
    v19816: state_type > $o ).

tff(pred_def_10526,type,
    v19815: state_type > $o ).

tff(pred_def_10527,type,
    v19826: state_type > $o ).

tff(pred_def_10528,type,
    v19827: state_type > $o ).

tff(pred_def_10529,type,
    v19823: state_type > $o ).

tff(pred_def_10530,type,
    v19825: state_type > $o ).

tff(pred_def_10531,type,
    v19833: state_type > $o ).

tff(pred_def_10532,type,
    v19831: state_type > $o ).

tff(pred_def_10533,type,
    v19835: state_type > $o ).

tff(pred_def_10534,type,
    v19773: state_type > $o ).

tff(pred_def_10535,type,
    v19771: state_type > $o ).

tff(pred_def_10536,type,
    v19769: state_type > $o ).

tff(pred_def_10537,type,
    v19842: state_type > $o ).

tff(pred_def_10538,type,
    v19840: state_type > $o ).

tff(pred_def_10539,type,
    v19839: state_type > $o ).

tff(pred_def_10540,type,
    v19838: state_type > $o ).

tff(pred_def_10541,type,
    v19850: state_type > $o ).

tff(pred_def_10542,type,
    v19851: state_type > $o ).

tff(pred_def_10543,type,
    v19849: state_type > $o ).

tff(pred_def_10544,type,
    v19846: ( state_type * $int ) > $o ).

tff(pred_def_10545,type,
    v19848: ( state_type * $int ) > $o ).

tff(pred_def_10546,type,
    v19743: ( state_type * $int ) > $o ).

tff(pred_def_10547,type,
    v19741: ( state_type * $int ) > $o ).

tff(pred_def_10548,type,
    v19739: ( state_type * $int ) > $o ).

tff(pred_def_10549,type,
    v19737: ( state_type * $int ) > $o ).

tff(pred_def_10550,type,
    v19735: ( state_type * $int ) > $o ).

tff(pred_def_10551,type,
    v19873: state_type > $o ).

tff(pred_def_10552,type,
    v19871: state_type > $o ).

tff(pred_def_10553,type,
    v19877: state_type > $o ).

tff(pred_def_10554,type,
    v19875: state_type > $o ).

tff(pred_def_10555,type,
    v19881: state_type > $o ).

tff(pred_def_10556,type,
    v19879: state_type > $o ).

tff(pred_def_10557,type,
    v19884: state_type > $o ).

tff(pred_def_10558,type,
    v19883: state_type > $o ).

tff(pred_def_10559,type,
    v19869: state_type > $o ).

tff(pred_def_10560,type,
    v19867: state_type > $o ).

tff(pred_def_10561,type,
    v19865: state_type > $o ).

tff(pred_def_10562,type,
    v19863: state_type > $o ).

tff(pred_def_10563,type,
    v19861: state_type > $o ).

tff(pred_def_10564,type,
    v19859: state_type > $o ).

tff(pred_def_10565,type,
    v19857: state_type > $o ).

tff(pred_def_10566,type,
    v19855: state_type > $o ).

tff(pred_def_10567,type,
    v19904: state_type > $o ).

tff(pred_def_10568,type,
    v19902: state_type > $o ).

tff(pred_def_10569,type,
    v19900: state_type > $o ).

tff(pred_def_10570,type,
    v19898: state_type > $o ).

tff(pred_def_10571,type,
    v19896: state_type > $o ).

tff(pred_def_10572,type,
    v19914: state_type > $o ).

tff(pred_def_10573,type,
    v19912: state_type > $o ).

tff(pred_def_10574,type,
    v19910: state_type > $o ).

tff(pred_def_10575,type,
    v19908: state_type > $o ).

tff(pred_def_10576,type,
    v19906: state_type > $o ).

tff(pred_def_10577,type,
    v19918: ( state_type * $int ) > $o ).

tff(pred_def_10578,type,
    v19916: ( state_type * $int ) > $o ).

tff(pred_def_10579,type,
    v19928: state_type > $o ).

tff(pred_def_10580,type,
    v19926: state_type > $o ).

tff(pred_def_10581,type,
    v19934: state_type > $o ).

tff(pred_def_10582,type,
    v19932: state_type > $o ).

tff(pred_def_10583,type,
    v19948: state_type > $o ).

tff(pred_def_10584,type,
    v19946: state_type > $o ).

tff(pred_def_10585,type,
    v19952: state_type > $o ).

tff(pred_def_10586,type,
    v19950: state_type > $o ).

tff(pred_def_10587,type,
    v19956: state_type > $o ).

tff(pred_def_10588,type,
    v19954: state_type > $o ).

tff(pred_def_10589,type,
    v19959: state_type > $o ).

tff(pred_def_10590,type,
    v19958: state_type > $o ).

tff(pred_def_10591,type,
    v19944: state_type > $o ).

tff(pred_def_10592,type,
    v19942: state_type > $o ).

tff(pred_def_10593,type,
    v19940: state_type > $o ).

tff(pred_def_10594,type,
    v19938: state_type > $o ).

tff(pred_def_10595,type,
    v19936: state_type > $o ).

tff(pred_def_10596,type,
    v19963: state_type > $o ).

tff(pred_def_10597,type,
    v19961: state_type > $o ).

tff(pred_def_10598,type,
    v19930: state_type > $o ).

tff(pred_def_10599,type,
    v19969: state_type > $o ).

tff(pred_def_10600,type,
    v19971: state_type > $o ).

tff(pred_def_10601,type,
    v19967: state_type > $o ).

tff(pred_def_10602,type,
    v19966: state_type > $o ).

tff(pred_def_10603,type,
    v19977: state_type > $o ).

tff(pred_def_10604,type,
    v19978: state_type > $o ).

tff(pred_def_10605,type,
    v19974: state_type > $o ).

tff(pred_def_10606,type,
    v19976: state_type > $o ).

tff(pred_def_10607,type,
    v19984: state_type > $o ).

tff(pred_def_10608,type,
    v19982: state_type > $o ).

tff(pred_def_10609,type,
    v19986: state_type > $o ).

tff(pred_def_10610,type,
    v19924: state_type > $o ).

tff(pred_def_10611,type,
    v19922: state_type > $o ).

tff(pred_def_10612,type,
    v19920: state_type > $o ).

tff(pred_def_10613,type,
    v19993: state_type > $o ).

tff(pred_def_10614,type,
    v19991: state_type > $o ).

tff(pred_def_10615,type,
    v19990: state_type > $o ).

tff(pred_def_10616,type,
    v19989: state_type > $o ).

tff(pred_def_10617,type,
    v20001: state_type > $o ).

tff(pred_def_10618,type,
    v20002: state_type > $o ).

tff(pred_def_10619,type,
    v20000: state_type > $o ).

tff(pred_def_10620,type,
    v19997: ( state_type * $int ) > $o ).

tff(pred_def_10621,type,
    v19999: ( state_type * $int ) > $o ).

tff(pred_def_10622,type,
    v19894: ( state_type * $int ) > $o ).

tff(pred_def_10623,type,
    v19892: ( state_type * $int ) > $o ).

tff(pred_def_10624,type,
    v19890: ( state_type * $int ) > $o ).

tff(pred_def_10625,type,
    v19888: ( state_type * $int ) > $o ).

tff(pred_def_10626,type,
    v19886: ( state_type * $int ) > $o ).

tff(pred_def_10627,type,
    v20024: state_type > $o ).

tff(pred_def_10628,type,
    v20022: state_type > $o ).

tff(pred_def_10629,type,
    v20028: state_type > $o ).

tff(pred_def_10630,type,
    v20026: state_type > $o ).

tff(pred_def_10631,type,
    v20032: state_type > $o ).

tff(pred_def_10632,type,
    v20030: state_type > $o ).

tff(pred_def_10633,type,
    v20035: state_type > $o ).

tff(pred_def_10634,type,
    v20034: state_type > $o ).

tff(pred_def_10635,type,
    v20020: state_type > $o ).

tff(pred_def_10636,type,
    v20018: state_type > $o ).

tff(pred_def_10637,type,
    v20016: state_type > $o ).

tff(pred_def_10638,type,
    v20014: state_type > $o ).

tff(pred_def_10639,type,
    v20012: state_type > $o ).

tff(pred_def_10640,type,
    v20010: state_type > $o ).

tff(pred_def_10641,type,
    v20008: state_type > $o ).

tff(pred_def_10642,type,
    v20006: state_type > $o ).

tff(pred_def_10643,type,
    v20055: state_type > $o ).

tff(pred_def_10644,type,
    v20053: state_type > $o ).

tff(pred_def_10645,type,
    v20051: state_type > $o ).

tff(pred_def_10646,type,
    v20049: state_type > $o ).

tff(pred_def_10647,type,
    v20047: state_type > $o ).

tff(pred_def_10648,type,
    v20065: state_type > $o ).

tff(pred_def_10649,type,
    v20063: state_type > $o ).

tff(pred_def_10650,type,
    v20061: state_type > $o ).

tff(pred_def_10651,type,
    v20059: state_type > $o ).

tff(pred_def_10652,type,
    v20057: state_type > $o ).

tff(pred_def_10653,type,
    v20069: ( state_type * $int ) > $o ).

tff(pred_def_10654,type,
    v20067: ( state_type * $int ) > $o ).

tff(pred_def_10655,type,
    v20079: state_type > $o ).

tff(pred_def_10656,type,
    v20077: state_type > $o ).

tff(pred_def_10657,type,
    v20085: state_type > $o ).

tff(pred_def_10658,type,
    v20083: state_type > $o ).

tff(pred_def_10659,type,
    v20099: state_type > $o ).

tff(pred_def_10660,type,
    v20097: state_type > $o ).

tff(pred_def_10661,type,
    v20103: state_type > $o ).

tff(pred_def_10662,type,
    v20101: state_type > $o ).

tff(pred_def_10663,type,
    v20107: state_type > $o ).

tff(pred_def_10664,type,
    v20105: state_type > $o ).

tff(pred_def_10665,type,
    v20110: state_type > $o ).

tff(pred_def_10666,type,
    v20109: state_type > $o ).

tff(pred_def_10667,type,
    v20095: state_type > $o ).

tff(pred_def_10668,type,
    v20093: state_type > $o ).

tff(pred_def_10669,type,
    v20091: state_type > $o ).

tff(pred_def_10670,type,
    v20089: state_type > $o ).

tff(pred_def_10671,type,
    v20087: state_type > $o ).

tff(pred_def_10672,type,
    v20114: state_type > $o ).

tff(pred_def_10673,type,
    v20112: state_type > $o ).

tff(pred_def_10674,type,
    v20081: state_type > $o ).

tff(pred_def_10675,type,
    v20120: state_type > $o ).

tff(pred_def_10676,type,
    v20122: state_type > $o ).

tff(pred_def_10677,type,
    v20118: state_type > $o ).

tff(pred_def_10678,type,
    v20117: state_type > $o ).

tff(pred_def_10679,type,
    v20128: state_type > $o ).

tff(pred_def_10680,type,
    v20129: state_type > $o ).

tff(pred_def_10681,type,
    v20125: state_type > $o ).

tff(pred_def_10682,type,
    v20127: state_type > $o ).

tff(pred_def_10683,type,
    v20135: state_type > $o ).

tff(pred_def_10684,type,
    v20133: state_type > $o ).

tff(pred_def_10685,type,
    v20137: state_type > $o ).

tff(pred_def_10686,type,
    v20075: state_type > $o ).

tff(pred_def_10687,type,
    v20073: state_type > $o ).

tff(pred_def_10688,type,
    v20071: state_type > $o ).

tff(pred_def_10689,type,
    v20144: state_type > $o ).

tff(pred_def_10690,type,
    v20142: state_type > $o ).

tff(pred_def_10691,type,
    v20141: state_type > $o ).

tff(pred_def_10692,type,
    v20140: state_type > $o ).

tff(pred_def_10693,type,
    v20152: state_type > $o ).

tff(pred_def_10694,type,
    v20153: state_type > $o ).

tff(pred_def_10695,type,
    v20151: state_type > $o ).

tff(pred_def_10696,type,
    v20148: ( state_type * $int ) > $o ).

tff(pred_def_10697,type,
    v20150: ( state_type * $int ) > $o ).

tff(pred_def_10698,type,
    v20045: ( state_type * $int ) > $o ).

tff(pred_def_10699,type,
    v20043: ( state_type * $int ) > $o ).

tff(pred_def_10700,type,
    v20041: ( state_type * $int ) > $o ).

tff(pred_def_10701,type,
    v20039: ( state_type * $int ) > $o ).

tff(pred_def_10702,type,
    v20037: ( state_type * $int ) > $o ).

tff(pred_def_10703,type,
    v20175: state_type > $o ).

tff(pred_def_10704,type,
    v20173: state_type > $o ).

tff(pred_def_10705,type,
    v20179: state_type > $o ).

tff(pred_def_10706,type,
    v20177: state_type > $o ).

tff(pred_def_10707,type,
    v20183: state_type > $o ).

tff(pred_def_10708,type,
    v20181: state_type > $o ).

tff(pred_def_10709,type,
    v20186: state_type > $o ).

tff(pred_def_10710,type,
    v20185: state_type > $o ).

tff(pred_def_10711,type,
    v20171: state_type > $o ).

tff(pred_def_10712,type,
    v20169: state_type > $o ).

tff(pred_def_10713,type,
    v20167: state_type > $o ).

tff(pred_def_10714,type,
    v20165: state_type > $o ).

tff(pred_def_10715,type,
    v20163: state_type > $o ).

tff(pred_def_10716,type,
    v20161: state_type > $o ).

tff(pred_def_10717,type,
    v20159: state_type > $o ).

tff(pred_def_10718,type,
    v20157: state_type > $o ).

tff(pred_def_10719,type,
    v20206: state_type > $o ).

tff(pred_def_10720,type,
    v20204: state_type > $o ).

tff(pred_def_10721,type,
    v20202: state_type > $o ).

tff(pred_def_10722,type,
    v20200: state_type > $o ).

tff(pred_def_10723,type,
    v20198: state_type > $o ).

tff(pred_def_10724,type,
    v20216: state_type > $o ).

tff(pred_def_10725,type,
    v20214: state_type > $o ).

tff(pred_def_10726,type,
    v20212: state_type > $o ).

tff(pred_def_10727,type,
    v20210: state_type > $o ).

tff(pred_def_10728,type,
    v20208: state_type > $o ).

tff(pred_def_10729,type,
    v20220: ( state_type * $int ) > $o ).

tff(pred_def_10730,type,
    v20218: ( state_type * $int ) > $o ).

tff(pred_def_10731,type,
    v20230: state_type > $o ).

tff(pred_def_10732,type,
    v20228: state_type > $o ).

tff(pred_def_10733,type,
    v20236: state_type > $o ).

tff(pred_def_10734,type,
    v20234: state_type > $o ).

tff(pred_def_10735,type,
    v20249: state_type > $o ).

tff(pred_def_10736,type,
    v20247: state_type > $o ).

tff(pred_def_10737,type,
    v20253: state_type > $o ).

tff(pred_def_10738,type,
    v20251: state_type > $o ).

tff(pred_def_10739,type,
    v20257: state_type > $o ).

tff(pred_def_10740,type,
    v20255: state_type > $o ).

tff(pred_def_10741,type,
    v20260: state_type > $o ).

tff(pred_def_10742,type,
    v20259: state_type > $o ).

tff(pred_def_10743,type,
    v20245: state_type > $o ).

tff(pred_def_10744,type,
    v20243: state_type > $o ).

tff(pred_def_10745,type,
    v20240: state_type > $o ).

tff(pred_def_10746,type,
    v20238: state_type > $o ).

tff(pred_def_10747,type,
    v20264: state_type > $o ).

tff(pred_def_10748,type,
    v20262: state_type > $o ).

tff(pred_def_10749,type,
    v20232: state_type > $o ).

tff(pred_def_10750,type,
    v20270: state_type > $o ).

tff(pred_def_10751,type,
    v20272: state_type > $o ).

tff(pred_def_10752,type,
    v20268: state_type > $o ).

tff(pred_def_10753,type,
    v20267: state_type > $o ).

tff(pred_def_10754,type,
    v20278: state_type > $o ).

tff(pred_def_10755,type,
    v20279: state_type > $o ).

tff(pred_def_10756,type,
    v20275: state_type > $o ).

tff(pred_def_10757,type,
    v20277: state_type > $o ).

tff(pred_def_10758,type,
    v20285: state_type > $o ).

tff(pred_def_10759,type,
    v20283: state_type > $o ).

tff(pred_def_10760,type,
    v20287: state_type > $o ).

tff(pred_def_10761,type,
    v20226: state_type > $o ).

tff(pred_def_10762,type,
    v20224: state_type > $o ).

tff(pred_def_10763,type,
    v20222: state_type > $o ).

tff(pred_def_10764,type,
    v20294: state_type > $o ).

tff(pred_def_10765,type,
    v20292: state_type > $o ).

tff(pred_def_10766,type,
    v20291: state_type > $o ).

tff(pred_def_10767,type,
    v20290: state_type > $o ).

tff(pred_def_10768,type,
    v20302: state_type > $o ).

tff(pred_def_10769,type,
    v20303: state_type > $o ).

tff(pred_def_10770,type,
    v20301: state_type > $o ).

tff(pred_def_10771,type,
    v20298: ( state_type * $int ) > $o ).

tff(pred_def_10772,type,
    v20300: ( state_type * $int ) > $o ).

tff(pred_def_10773,type,
    v20196: ( state_type * $int ) > $o ).

tff(pred_def_10774,type,
    v20194: ( state_type * $int ) > $o ).

tff(pred_def_10775,type,
    v20192: ( state_type * $int ) > $o ).

tff(pred_def_10776,type,
    v20190: ( state_type * $int ) > $o ).

tff(pred_def_10777,type,
    v20188: ( state_type * $int ) > $o ).

tff(pred_def_10778,type,
    v20315: state_type > $o ).

tff(pred_def_10779,type,
    v20313: state_type > $o ).

tff(pred_def_10780,type,
    v20311: state_type > $o ).

tff(pred_def_10781,type,
    v20309: state_type > $o ).

tff(pred_def_10782,type,
    v20307: state_type > $o ).

tff(pred_def_10783,type,
    v20323: state_type > $o ).

tff(pred_def_10784,type,
    v20322: ( state_type * $int ) > $o ).

tff(pred_def_10785,type,
    v20321: ( state_type * $int ) > $o ).

tff(pred_def_10786,type,
    v20326: state_type > $o ).

tff(pred_def_10787,type,
    v20325: ( state_type * $int ) > $o ).

tff(pred_def_10788,type,
    v20324: ( state_type * $int ) > $o ).

tff(pred_def_10789,type,
    v20320: ( state_type * $int ) > $o ).

tff(pred_def_10790,type,
    v20329: state_type > $o ).

tff(pred_def_10791,type,
    v20328: ( state_type * $int ) > $o ).

tff(pred_def_10792,type,
    v20327: ( state_type * $int ) > $o ).

tff(pred_def_10793,type,
    v20319: ( state_type * $int ) > $o ).

tff(pred_def_10794,type,
    v20332: state_type > $o ).

tff(pred_def_10795,type,
    v20331: ( state_type * $int ) > $o ).

tff(pred_def_10796,type,
    v20330: ( state_type * $int ) > $o ).

tff(pred_def_10797,type,
    v20318: ( state_type * $int ) > $o ).

tff(pred_def_10798,type,
    v20335: state_type > $o ).

tff(pred_def_10799,type,
    v20334: ( state_type * $int ) > $o ).

tff(pred_def_10800,type,
    v20333: ( state_type * $int ) > $o ).

tff(pred_def_10801,type,
    v20317: ( state_type * $int ) > $o ).

tff(pred_def_10802,type,
    v20338: state_type > $o ).

tff(pred_def_10803,type,
    v20337: ( state_type * $int ) > $o ).

tff(pred_def_10804,type,
    v20336: ( state_type * $int ) > $o ).

tff(pred_def_10805,type,
    v18809: ( state_type * $int ) > $o ).

tff(pred_def_10806,type,
    v18807: ( state_type * $int ) > $o ).

tff(pred_def_10807,type,
    v18805: ( state_type * $int ) > $o ).

tff(pred_def_10808,type,
    v18803: ( state_type * $int ) > $o ).

tff(pred_def_10809,type,
    v18801: ( state_type * $int ) > $o ).

tff(pred_def_10810,type,
    v18795: state_type > $o ).

tff(pred_def_10811,type,
    v18793: state_type > $o ).

tff(pred_def_10812,type,
    v18791: state_type > $o ).

tff(pred_def_10813,type,
    v20349: ( state_type * $int ) > $o ).

tff(pred_def_10814,type,
    v20347: ( state_type * $int ) > $o ).

tff(pred_def_10815,type,
    v20383: state_type > $o ).

tff(pred_def_10816,type,
    v20381: state_type > $o ).

tff(pred_def_10817,type,
    v20379: state_type > $o ).

tff(pred_def_10818,type,
    v20377: state_type > $o ).

tff(pred_def_10819,type,
    v20375: state_type > $o ).

tff(pred_def_10820,type,
    v20373: state_type > $o ).

tff(pred_def_10821,type,
    v20371: state_type > $o ).

tff(pred_def_10822,type,
    v20397: state_type > $o ).

tff(pred_def_10823,type,
    v20395: state_type > $o ).

tff(pred_def_10824,type,
    v20393: state_type > $o ).

tff(pred_def_10825,type,
    v20391: state_type > $o ).

tff(pred_def_10826,type,
    v20389: state_type > $o ).

tff(pred_def_10827,type,
    v20387: state_type > $o ).

tff(pred_def_10828,type,
    v20385: state_type > $o ).

tff(pred_def_10829,type,
    v20423: state_type > $o ).

tff(pred_def_10830,type,
    v20425: state_type > $o ).

tff(pred_def_10831,type,
    v20424: ( state_type * $int ) > $o ).

tff(pred_def_10832,type,
    v20426: state_type > $o ).

tff(pred_def_10833,type,
    v20421: ( state_type * $int ) > $o ).

tff(pred_def_10834,type,
    v20419: ( state_type * $int ) > $o ).

tff(pred_def_10835,type,
    v20427: ( state_type * $int ) > $o ).

tff(pred_def_10836,type,
    v20417: ( state_type * $int ) > $o ).

tff(pred_def_10837,type,
    v20415: ( state_type * $int ) > $o ).

tff(pred_def_10838,type,
    v20413: state_type > $o ).

tff(pred_def_10839,type,
    v20429: state_type > $o ).

tff(pred_def_10840,type,
    v20411: ( state_type * $int ) > $o ).

tff(pred_def_10841,type,
    v20409: ( state_type * $int ) > $o ).

tff(pred_def_10842,type,
    v20443: ( state_type * $int ) > $o ).

tff(pred_def_10843,type,
    v20441: ( state_type * $int ) > $o ).

tff(pred_def_10844,type,
    v20447: state_type > $o ).

tff(pred_def_10845,type,
    v20445: state_type > $o ).

tff(pred_def_10846,type,
    v20471: state_type > $o ).

tff(pred_def_10847,type,
    v20469: state_type > $o ).

tff(pred_def_10848,type,
    v20467: state_type > $o ).

tff(pred_def_10849,type,
    v20465: state_type > $o ).

tff(pred_def_10850,type,
    v20463: state_type > $o ).

tff(pred_def_10851,type,
    v20461: state_type > $o ).

tff(pred_def_10852,type,
    v20459: state_type > $o ).

tff(pred_def_10853,type,
    v20485: state_type > $o ).

tff(pred_def_10854,type,
    v20483: state_type > $o ).

tff(pred_def_10855,type,
    v20481: state_type > $o ).

tff(pred_def_10856,type,
    v20479: state_type > $o ).

tff(pred_def_10857,type,
    v20477: state_type > $o ).

tff(pred_def_10858,type,
    v20475: state_type > $o ).

tff(pred_def_10859,type,
    v20473: state_type > $o ).

tff(pred_def_10860,type,
    v20501: ( state_type * $int ) > $o ).

tff(pred_def_10861,type,
    v20499: ( state_type * $int ) > $o ).

tff(pred_def_10862,type,
    v20497: ( state_type * $int ) > $o ).

tff(pred_def_10863,type,
    v20495: ( state_type * $int ) > $o ).

tff(pred_def_10864,type,
    v20493: ( state_type * $int ) > $o ).

tff(pred_def_10865,type,
    v20531: ( state_type * $int ) > $o ).

tff(pred_def_10866,type,
    v20533: ( state_type * $int ) > $o ).

tff(pred_def_10867,type,
    v20529: ( state_type * $int ) > $o ).

tff(pred_def_10868,type,
    v20527: ( state_type * $int ) > $o ).

tff(pred_def_10869,type,
    v20525: ( state_type * $int ) > $o ).

tff(pred_def_10870,type,
    v20523: ( state_type * $int ) > $o ).

tff(pred_def_10871,type,
    v20521: state_type > $o ).

tff(pred_def_10872,type,
    v20519: state_type > $o ).

tff(pred_def_10873,type,
    v20537: state_type > $o ).

tff(pred_def_10874,type,
    v20535: state_type > $o ).

tff(pred_def_10875,type,
    v20539: state_type > $o ).

tff(pred_def_10876,type,
    v20517: state_type > $o ).

tff(pred_def_10877,type,
    v20515: state_type > $o ).

tff(pred_def_10878,type,
    v20513: state_type > $o ).

tff(pred_def_10879,type,
    v20511: state_type > $o ).

tff(pred_def_10880,type,
    v20509: state_type > $o ).

tff(pred_def_10881,type,
    v20507: state_type > $o ).

tff(pred_def_10882,type,
    v20505: state_type > $o ).

tff(pred_def_10883,type,
    v20503: state_type > $o ).

tff(pred_def_10884,type,
    v20549: ( state_type * $int ) > $o ).

tff(pred_def_10885,type,
    v20547: ( state_type * $int ) > $o ).

tff(pred_def_10886,type,
    v20545: ( state_type * $int ) > $o ).

tff(pred_def_10887,type,
    v20543: ( state_type * $int ) > $o ).

tff(pred_def_10888,type,
    v20541: ( state_type * $int ) > $o ).

tff(pred_def_10889,type,
    v20579: ( state_type * $int ) > $o ).

tff(pred_def_10890,type,
    v20577: ( state_type * $int ) > $o ).

tff(pred_def_10891,type,
    v20580: ( state_type * $int ) > $o ).

tff(pred_def_10892,type,
    v20575: ( state_type * $int ) > $o ).

tff(pred_def_10893,type,
    v20573: ( state_type * $int ) > $o ).

tff(pred_def_10894,type,
    v20571: ( state_type * $int ) > $o ).

tff(pred_def_10895,type,
    v20569: state_type > $o ).

tff(pred_def_10896,type,
    v20567: state_type > $o ).

tff(pred_def_10897,type,
    v20584: state_type > $o ).

tff(pred_def_10898,type,
    v20582: state_type > $o ).

tff(pred_def_10899,type,
    v20586: state_type > $o ).

tff(pred_def_10900,type,
    v20565: state_type > $o ).

tff(pred_def_10901,type,
    v20563: state_type > $o ).

tff(pred_def_10902,type,
    v20561: state_type > $o ).

tff(pred_def_10903,type,
    v20559: state_type > $o ).

tff(pred_def_10904,type,
    v20557: state_type > $o ).

tff(pred_def_10905,type,
    v20555: state_type > $o ).

tff(pred_def_10906,type,
    v20553: state_type > $o ).

tff(pred_def_10907,type,
    v20551: state_type > $o ).

tff(pred_def_10908,type,
    v20596: ( state_type * $int ) > $o ).

tff(pred_def_10909,type,
    v20594: ( state_type * $int ) > $o ).

tff(pred_def_10910,type,
    v20592: ( state_type * $int ) > $o ).

tff(pred_def_10911,type,
    v20590: ( state_type * $int ) > $o ).

tff(pred_def_10912,type,
    v20588: ( state_type * $int ) > $o ).

tff(pred_def_10913,type,
    v20616: state_type > $o ).

tff(pred_def_10914,type,
    v20614: state_type > $o ).

tff(pred_def_10915,type,
    v20620: state_type > $o ).

tff(pred_def_10916,type,
    v20618: state_type > $o ).

tff(pred_def_10917,type,
    v20622: state_type > $o ).

tff(pred_def_10918,type,
    v20612: state_type > $o ).

tff(pred_def_10919,type,
    v20610: state_type > $o ).

tff(pred_def_10920,type,
    v20608: state_type > $o ).

tff(pred_def_10921,type,
    v20606: state_type > $o ).

tff(pred_def_10922,type,
    v20604: state_type > $o ).

tff(pred_def_10923,type,
    v20602: state_type > $o ).

tff(pred_def_10924,type,
    v20600: state_type > $o ).

tff(pred_def_10925,type,
    v20598: state_type > $o ).

tff(pred_def_10926,type,
    v20632: ( state_type * $int ) > $o ).

tff(pred_def_10927,type,
    v20630: ( state_type * $int ) > $o ).

tff(pred_def_10928,type,
    v20628: ( state_type * $int ) > $o ).

tff(pred_def_10929,type,
    v20626: ( state_type * $int ) > $o ).

tff(pred_def_10930,type,
    v20624: ( state_type * $int ) > $o ).

tff(pred_def_10931,type,
    v20652: state_type > $o ).

tff(pred_def_10932,type,
    v20650: state_type > $o ).

tff(pred_def_10933,type,
    v20656: state_type > $o ).

tff(pred_def_10934,type,
    v20654: state_type > $o ).

tff(pred_def_10935,type,
    v20658: state_type > $o ).

tff(pred_def_10936,type,
    v20648: state_type > $o ).

tff(pred_def_10937,type,
    v20646: state_type > $o ).

tff(pred_def_10938,type,
    v20644: state_type > $o ).

tff(pred_def_10939,type,
    v20642: state_type > $o ).

tff(pred_def_10940,type,
    v20640: state_type > $o ).

tff(pred_def_10941,type,
    v20638: state_type > $o ).

tff(pred_def_10942,type,
    v20636: state_type > $o ).

tff(pred_def_10943,type,
    v20634: state_type > $o ).

tff(pred_def_10944,type,
    v20664: state_type > $o ).

tff(pred_def_10945,type,
    v20663: ( state_type * $int ) > $o ).

tff(pred_def_10946,type,
    v20662: ( state_type * $int ) > $o ).

tff(pred_def_10947,type,
    v20667: state_type > $o ).

tff(pred_def_10948,type,
    v20666: ( state_type * $int ) > $o ).

tff(pred_def_10949,type,
    v20665: ( state_type * $int ) > $o ).

tff(pred_def_10950,type,
    v20661: ( state_type * $int ) > $o ).

tff(pred_def_10951,type,
    v20670: state_type > $o ).

tff(pred_def_10952,type,
    v20669: ( state_type * $int ) > $o ).

tff(pred_def_10953,type,
    v20668: ( state_type * $int ) > $o ).

tff(pred_def_10954,type,
    v20660: ( state_type * $int ) > $o ).

tff(pred_def_10955,type,
    v20673: state_type > $o ).

tff(pred_def_10956,type,
    v20672: ( state_type * $int ) > $o ).

tff(pred_def_10957,type,
    v20671: ( state_type * $int ) > $o ).

tff(pred_def_10958,type,
    v20491: ( state_type * $int ) > $o ).

tff(pred_def_10959,type,
    v20489: ( state_type * $int ) > $o ).

tff(pred_def_10960,type,
    v20487: ( state_type * $int ) > $o ).

tff(pred_def_10961,type,
    v20685: state_type > $o ).

tff(pred_def_10962,type,
    v20683: state_type > $o ).

tff(pred_def_10963,type,
    v20681: state_type > $o ).

tff(pred_def_10964,type,
    v20695: state_type > $o ).

tff(pred_def_10965,type,
    v20693: state_type > $o ).

tff(pred_def_10966,type,
    v20691: state_type > $o ).

tff(pred_def_10967,type,
    v20689: state_type > $o ).

tff(pred_def_10968,type,
    v20687: state_type > $o ).

tff(pred_def_10969,type,
    v20697: state_type > $o ).

tff(pred_def_10970,type,
    v20679: state_type > $o ).

tff(pred_def_10971,type,
    v20677: state_type > $o ).

tff(pred_def_10972,type,
    v20675: state_type > $o ).

tff(pred_def_10973,type,
    v20704: state_type > $o ).

tff(pred_def_10974,type,
    v20702: state_type > $o ).

tff(pred_def_10975,type,
    v20701: state_type > $o ).

tff(pred_def_10976,type,
    v20700: state_type > $o ).

tff(pred_def_10977,type,
    v20712: state_type > $o ).

tff(pred_def_10978,type,
    v20713: state_type > $o ).

tff(pred_def_10979,type,
    v20711: state_type > $o ).

tff(pred_def_10980,type,
    v20708: ( state_type * $int ) > $o ).

tff(pred_def_10981,type,
    v20710: ( state_type * $int ) > $o ).

tff(pred_def_10982,type,
    v20457: ( state_type * $int ) > $o ).

tff(pred_def_10983,type,
    v20455: ( state_type * $int ) > $o ).

tff(pred_def_10984,type,
    v20453: ( state_type * $int ) > $o ).

tff(pred_def_10985,type,
    v20451: ( state_type * $int ) > $o ).

tff(pred_def_10986,type,
    v20449: ( state_type * $int ) > $o ).

tff(pred_def_10987,type,
    v20719: state_type > $o ).

tff(pred_def_10988,type,
    v20717: state_type > $o ).

tff(pred_def_10989,type,
    v20723: state_type > $o ).

tff(pred_def_10990,type,
    v20722: ( state_type * $int ) > $o ).

tff(pred_def_10991,type,
    v20721: ( state_type * $int ) > $o ).

tff(pred_def_10992,type,
    v20726: state_type > $o ).

tff(pred_def_10993,type,
    v20725: ( state_type * $int ) > $o ).

tff(pred_def_10994,type,
    v20724: ( state_type * $int ) > $o ).

tff(pred_def_10995,type,
    v20439: ( state_type * $int ) > $o ).

tff(pred_def_10996,type,
    v20437: ( state_type * $int ) > $o ).

tff(pred_def_10997,type,
    v20435: ( state_type * $int ) > $o ).

tff(pred_def_10998,type,
    v20433: ( state_type * $int ) > $o ).

tff(pred_def_10999,type,
    v20431: ( state_type * $int ) > $o ).

tff(pred_def_11000,type,
    v20407: ( state_type * $int ) > $o ).

tff(pred_def_11001,type,
    v20405: ( state_type * $int ) > $o ).

tff(pred_def_11002,type,
    v20403: ( state_type * $int ) > $o ).

tff(pred_def_11003,type,
    v20401: ( state_type * $int ) > $o ).

tff(pred_def_11004,type,
    v20399: ( state_type * $int ) > $o ).

tff(pred_def_11005,type,
    v20739: state_type > $o ).

tff(pred_def_11006,type,
    v20737: state_type > $o ).

tff(pred_def_11007,type,
    v20735: state_type > $o ).

tff(pred_def_11008,type,
    v20745: state_type > $o ).

tff(pred_def_11009,type,
    v20743: state_type > $o ).

tff(pred_def_11010,type,
    v20763: ( state_type * $int ) > $o ).

tff(pred_def_11011,type,
    v20765: ( state_type * $int ) > $o ).

tff(pred_def_11012,type,
    v20761: ( state_type * $int ) > $o ).

tff(pred_def_11013,type,
    v20759: state_type > $o ).

tff(pred_def_11014,type,
    v20757: state_type > $o ).

tff(pred_def_11015,type,
    v20769: state_type > $o ).

tff(pred_def_11016,type,
    v20767: state_type > $o ).

tff(pred_def_11017,type,
    v20773: state_type > $o ).

tff(pred_def_11018,type,
    v20771: state_type > $o ).

tff(pred_def_11019,type,
    v20776: state_type > $o ).

tff(pred_def_11020,type,
    v20775: state_type > $o ).

tff(pred_def_11021,type,
    v20755: state_type > $o ).

tff(pred_def_11022,type,
    v20753: state_type > $o ).

tff(pred_def_11023,type,
    v20751: state_type > $o ).

tff(pred_def_11024,type,
    v20749: state_type > $o ).

tff(pred_def_11025,type,
    v20747: state_type > $o ).

tff(pred_def_11026,type,
    v20784: state_type > $o ).

tff(pred_def_11027,type,
    v20782: state_type > $o ).

tff(pred_def_11028,type,
    v20780: state_type > $o ).

tff(pred_def_11029,type,
    v20778: state_type > $o ).

tff(pred_def_11030,type,
    v20741: state_type > $o ).

tff(pred_def_11031,type,
    v20790: state_type > $o ).

tff(pred_def_11032,type,
    v20792: state_type > $o ).

tff(pred_def_11033,type,
    v20788: state_type > $o ).

tff(pred_def_11034,type,
    v20787: state_type > $o ).

tff(pred_def_11035,type,
    v20798: state_type > $o ).

tff(pred_def_11036,type,
    v20799: state_type > $o ).

tff(pred_def_11037,type,
    v20795: state_type > $o ).

tff(pred_def_11038,type,
    v20797: state_type > $o ).

tff(pred_def_11039,type,
    v20809: state_type > $o ).

tff(pred_def_11040,type,
    v20807: state_type > $o ).

tff(pred_def_11041,type,
    v20805: state_type > $o ).

tff(pred_def_11042,type,
    v20803: state_type > $o ).

tff(pred_def_11043,type,
    v20811: state_type > $o ).

tff(pred_def_11044,type,
    v20733: state_type > $o ).

tff(pred_def_11045,type,
    v20731: state_type > $o ).

tff(pred_def_11046,type,
    v20729: state_type > $o ).

tff(pred_def_11047,type,
    v20818: state_type > $o ).

tff(pred_def_11048,type,
    v20816: state_type > $o ).

tff(pred_def_11049,type,
    v20815: state_type > $o ).

tff(pred_def_11050,type,
    v20814: state_type > $o ).

tff(pred_def_11051,type,
    v20826: state_type > $o ).

tff(pred_def_11052,type,
    v20827: state_type > $o ).

tff(pred_def_11053,type,
    v20825: state_type > $o ).

tff(pred_def_11054,type,
    v20822: ( state_type * $int ) > $o ).

tff(pred_def_11055,type,
    v20824: ( state_type * $int ) > $o ).

tff(pred_def_11056,type,
    v20369: ( state_type * $int ) > $o ).

tff(pred_def_11057,type,
    v20367: ( state_type * $int ) > $o ).

tff(pred_def_11058,type,
    v20365: ( state_type * $int ) > $o ).

tff(pred_def_11059,type,
    v20363: ( state_type * $int ) > $o ).

tff(pred_def_11060,type,
    v20361: ( state_type * $int ) > $o ).

tff(pred_def_11061,type,
    v20863: state_type > $o ).

tff(pred_def_11062,type,
    v20861: state_type > $o ).

tff(pred_def_11063,type,
    v20859: state_type > $o ).

tff(pred_def_11064,type,
    v20857: state_type > $o ).

tff(pred_def_11065,type,
    v20855: state_type > $o ).

tff(pred_def_11066,type,
    v20853: state_type > $o ).

tff(pred_def_11067,type,
    v20873: state_type > $o ).

tff(pred_def_11068,type,
    v20871: state_type > $o ).

tff(pred_def_11069,type,
    v20869: state_type > $o ).

tff(pred_def_11070,type,
    v20867: state_type > $o ).

tff(pred_def_11071,type,
    v20865: state_type > $o ).

tff(pred_def_11072,type,
    v20900: state_type > $o ).

tff(pred_def_11073,type,
    v20899: ( state_type * $int ) > $o ).

tff(pred_def_11074,type,
    v20898: ( state_type * $int ) > $o ).

tff(pred_def_11075,type,
    v20896: ( state_type * $int ) > $o ).

tff(pred_def_11076,type,
    v20916: state_type > $o ).

tff(pred_def_11077,type,
    v20917: ( state_type * $int ) > $o ).

tff(pred_def_11078,type,
    v20918: state_type > $o ).

tff(pred_def_11079,type,
    v20914: ( state_type * $int ) > $o ).

tff(pred_def_11080,type,
    v20912: ( state_type * $int ) > $o ).

tff(pred_def_11081,type,
    v20942: ( state_type * $int ) > $o ).

tff(pred_def_11082,type,
    v20851: ( state_type * $int ) > $o ).

tff(pred_def_11083,type,
    v20940: ( state_type * $int ) > $o ).

tff(pred_def_11084,type,
    v20943: ( state_type * $int ) > $o ).

tff(pred_def_11085,type,
    v20938: ( state_type * $int ) > $o ).

tff(pred_def_11086,type,
    v20936: ( state_type * $int ) > $o ).

tff(pred_def_11087,type,
    v20934: ( state_type * $int ) > $o ).

tff(pred_def_11088,type,
    v20932: state_type > $o ).

tff(pred_def_11089,type,
    v20930: state_type > $o ).

tff(pred_def_11090,type,
    v20949: state_type > $o ).

tff(pred_def_11091,type,
    v20889: state_type > $o ).

tff(pred_def_11092,type,
    v20948: ( state_type * $int ) > $o ).

tff(pred_def_11093,type,
    v20887: ( state_type * $int ) > $o ).

tff(pred_def_11094,type,
    v20885: ( state_type * $int ) > $o ).

tff(pred_def_11095,type,
    v20964: ( state_type * $int ) > $o ).

tff(pred_def_11096,type,
    v20963: ( state_type * $int ) > $o ).

tff(pred_def_11097,type,
    v20961: ( state_type * $int ) > $o ).

tff(pred_def_11098,type,
    v20968: state_type > $o ).

tff(pred_def_11099,type,
    v20966: state_type > $o ).

tff(pred_def_11100,type,
    v20979: ( state_type * $int ) > $o ).

tff(pred_def_11101,type,
    v20978: state_type > $o ).

tff(pred_def_11102,type,
    v20982: state_type > $o ).

tff(pred_def_11103,type,
    v20983: state_type > $o ).

tff(pred_def_11104,type,
    v20981: state_type > $o ).

tff(pred_def_11105,type,
    v20984: state_type > $o ).

tff(pred_def_11106,type,
    v20980: state_type > $o ).

tff(pred_def_11107,type,
    v20977: state_type > $o ).

tff(pred_def_11108,type,
    v20985: state_type > $o ).

tff(pred_def_11109,type,
    v20976: state_type > $o ).

tff(pred_def_11110,type,
    v20988: state_type > $o ).

tff(pred_def_11111,type,
    v20989: state_type > $o ).

tff(pred_def_11112,type,
    v20987: state_type > $o ).

tff(pred_def_11113,type,
    v20990: state_type > $o ).

tff(pred_def_11114,type,
    v20986: state_type > $o ).

tff(pred_def_11115,type,
    v20975: state_type > $o ).

tff(pred_def_11116,type,
    v20991: state_type > $o ).

tff(pred_def_11117,type,
    v20974: state_type > $o ).

tff(pred_def_11118,type,
    v20973: state_type > $o ).

tff(pred_def_11119,type,
    v20995: state_type > $o ).

tff(pred_def_11120,type,
    v20996: state_type > $o ).

tff(pred_def_11121,type,
    v20994: state_type > $o ).

tff(pred_def_11122,type,
    v20997: state_type > $o ).

tff(pred_def_11123,type,
    v20993: state_type > $o ).

tff(pred_def_11124,type,
    v20992: state_type > $o ).

tff(pred_def_11125,type,
    v20972: state_type > $o ).

tff(pred_def_11126,type,
    v20998: state_type > $o ).

tff(pred_def_11127,type,
    v20971: state_type > $o ).

tff(pred_def_11128,type,
    v21001: state_type > $o ).

tff(pred_def_11129,type,
    v21002: state_type > $o ).

tff(pred_def_11130,type,
    v21000: state_type > $o ).

tff(pred_def_11131,type,
    v21003: state_type > $o ).

tff(pred_def_11132,type,
    v20999: state_type > $o ).

tff(pred_def_11133,type,
    v21006: state_type > $o ).

tff(pred_def_11134,type,
    v21007: state_type > $o ).

tff(pred_def_11135,type,
    v21005: state_type > $o ).

tff(pred_def_11136,type,
    v21008: state_type > $o ).

tff(pred_def_11137,type,
    v21004: state_type > $o ).

tff(pred_def_11138,type,
    v21011: state_type > $o ).

tff(pred_def_11139,type,
    v21012: state_type > $o ).

tff(pred_def_11140,type,
    v21010: state_type > $o ).

tff(pred_def_11141,type,
    v21013: state_type > $o ).

tff(pred_def_11142,type,
    v21009: state_type > $o ).

tff(pred_def_11143,type,
    v20969: ( state_type * $int ) > $o ).

tff(pred_def_11144,type,
    v20959: ( state_type * $int ) > $o ).

tff(pred_def_11145,type,
    v20957: ( state_type * $int ) > $o ).

tff(pred_def_11146,type,
    v20955: ( state_type * $int ) > $o ).

tff(pred_def_11147,type,
    v20953: ( state_type * $int ) > $o ).

tff(pred_def_11148,type,
    v20951: ( state_type * $int ) > $o ).

tff(pred_def_11149,type,
    v21014: ( state_type * $int ) > $o ).

tff(pred_def_11150,type,
    v20883: ( state_type * $int ) > $o ).

tff(pred_def_11151,type,
    v20881: ( state_type * $int ) > $o ).

tff(pred_def_11152,type,
    v20879: ( state_type * $int ) > $o ).

tff(pred_def_11153,type,
    v21015: ( state_type * $int ) > $o ).

tff(pred_def_11154,type,
    v21016: ( state_type * $int ) > $o ).

tff(pred_def_11155,type,
    v20877: ( state_type * $int ) > $o ).

tff(pred_def_11156,type,
    v20875: ( state_type * $int ) > $o ).

tff(pred_def_11157,type,
    v21026: state_type > $o ).

tff(pred_def_11158,type,
    v21024: state_type > $o ).

tff(pred_def_11159,type,
    v21032: state_type > $o ).

tff(pred_def_11160,type,
    v21030: state_type > $o ).

tff(pred_def_11161,type,
    v21036: state_type > $o ).

tff(pred_def_11162,type,
    v21034: state_type > $o ).

tff(pred_def_11163,type,
    v21040: state_type > $o ).

tff(pred_def_11164,type,
    v21038: state_type > $o ).

tff(pred_def_11165,type,
    v21028: state_type > $o ).

tff(pred_def_11166,type,
    v21046: state_type > $o ).

tff(pred_def_11167,type,
    v21048: state_type > $o ).

tff(pred_def_11168,type,
    v21044: state_type > $o ).

tff(pred_def_11169,type,
    v21043: state_type > $o ).

tff(pred_def_11170,type,
    v21054: state_type > $o ).

tff(pred_def_11171,type,
    v21055: state_type > $o ).

tff(pred_def_11172,type,
    v21051: state_type > $o ).

tff(pred_def_11173,type,
    v21053: state_type > $o ).

tff(pred_def_11174,type,
    v21061: state_type > $o ).

tff(pred_def_11175,type,
    v21059: state_type > $o ).

tff(pred_def_11176,type,
    v21063: state_type > $o ).

tff(pred_def_11177,type,
    v21022: state_type > $o ).

tff(pred_def_11178,type,
    v21020: state_type > $o ).

tff(pred_def_11179,type,
    v21018: state_type > $o ).

tff(pred_def_11180,type,
    v21070: state_type > $o ).

tff(pred_def_11181,type,
    v21068: state_type > $o ).

tff(pred_def_11182,type,
    v21067: state_type > $o ).

tff(pred_def_11183,type,
    v21066: state_type > $o ).

tff(pred_def_11184,type,
    v21078: state_type > $o ).

tff(pred_def_11185,type,
    v21079: state_type > $o ).

tff(pred_def_11186,type,
    v21077: state_type > $o ).

tff(pred_def_11187,type,
    v21074: ( state_type * $int ) > $o ).

tff(pred_def_11188,type,
    v21076: ( state_type * $int ) > $o ).

tff(pred_def_11189,type,
    v21065: ( state_type * $int ) > $o ).

tff(pred_def_11190,type,
    v20947: state_type > $o ).

tff(pred_def_11191,type,
    v20945: state_type > $o ).

tff(pred_def_11192,type,
    v21091: state_type > $o ).

tff(pred_def_11193,type,
    v21089: state_type > $o ).

tff(pred_def_11194,type,
    v21088: state_type > $o ).

tff(pred_def_11195,type,
    v21087: ( state_type * $int ) > $o ).

tff(pred_def_11196,type,
    v21085: state_type > $o ).

tff(pred_def_11197,type,
    v21083: state_type > $o ).

tff(pred_def_11198,type,
    v21096: state_type > $o ).

tff(pred_def_11199,type,
    v21095: state_type > $o ).

tff(pred_def_11200,type,
    v20928: state_type > $o ).

tff(pred_def_11201,type,
    v20926: state_type > $o ).

tff(pred_def_11202,type,
    v20924: state_type > $o ).

tff(pred_def_11203,type,
    v21097: ( state_type * $int ) > $o ).

tff(pred_def_11204,type,
    v21098: state_type > $o ).

tff(pred_def_11205,type,
    v20922: ( state_type * $int ) > $o ).

tff(pred_def_11206,type,
    v20920: ( state_type * $int ) > $o ).

tff(pred_def_11207,type,
    v21099: ( state_type * $int ) > $o ).

tff(pred_def_11208,type,
    v20910: ( state_type * $int ) > $o ).

tff(pred_def_11209,type,
    v20908: ( state_type * $int ) > $o ).

tff(pred_def_11210,type,
    v20906: state_type > $o ).

tff(pred_def_11211,type,
    v21100: ( state_type * $int ) > $o ).

tff(pred_def_11212,type,
    v21101: state_type > $o ).

tff(pred_def_11213,type,
    v20904: ( state_type * $int ) > $o ).

tff(pred_def_11214,type,
    v20902: ( state_type * $int ) > $o ).

tff(pred_def_11215,type,
    v21102: ( state_type * $int ) > $o ).

tff(pred_def_11216,type,
    v20894: ( state_type * $int ) > $o ).

tff(pred_def_11217,type,
    v20892: ( state_type * $int ) > $o ).

tff(pred_def_11218,type,
    v21108: state_type > $o ).

tff(pred_def_11219,type,
    v21106: state_type > $o ).

tff(pred_def_11220,type,
    v21105: state_type > $o ).

tff(pred_def_11221,type,
    v21104: ( state_type * $int ) > $o ).

tff(pred_def_11222,type,
    v20849: state_type > $o ).

tff(pred_def_11223,type,
    v20847: state_type > $o ).

tff(pred_def_11224,type,
    v21114: state_type > $o ).

tff(pred_def_11225,type,
    v21112: state_type > $o ).

tff(pred_def_11226,type,
    v21118: state_type > $o ).

tff(pred_def_11227,type,
    v21116: state_type > $o ).

tff(pred_def_11228,type,
    v21121: state_type > $o ).

tff(pred_def_11229,type,
    v21120: state_type > $o ).

tff(pred_def_11230,type,
    v20845: state_type > $o ).

tff(pred_def_11231,type,
    v20843: state_type > $o ).

tff(pred_def_11232,type,
    v20841: state_type > $o ).

tff(pred_def_11233,type,
    v20839: state_type > $o ).

tff(pred_def_11234,type,
    v20837: state_type > $o ).

tff(pred_def_11235,type,
    v20835: state_type > $o ).

tff(pred_def_11236,type,
    v20833: state_type > $o ).

tff(pred_def_11237,type,
    v20831: state_type > $o ).

tff(pred_def_11238,type,
    v21141: state_type > $o ).

tff(pred_def_11239,type,
    v21139: state_type > $o ).

tff(pred_def_11240,type,
    v21137: state_type > $o ).

tff(pred_def_11241,type,
    v21135: state_type > $o ).

tff(pred_def_11242,type,
    v21133: state_type > $o ).

tff(pred_def_11243,type,
    v21151: state_type > $o ).

tff(pred_def_11244,type,
    v21149: state_type > $o ).

tff(pred_def_11245,type,
    v21147: state_type > $o ).

tff(pred_def_11246,type,
    v21145: state_type > $o ).

tff(pred_def_11247,type,
    v21143: state_type > $o ).

tff(pred_def_11248,type,
    v21155: ( state_type * $int ) > $o ).

tff(pred_def_11249,type,
    v21153: ( state_type * $int ) > $o ).

tff(pred_def_11250,type,
    v21165: state_type > $o ).

tff(pred_def_11251,type,
    v21163: state_type > $o ).

tff(pred_def_11252,type,
    v21171: state_type > $o ).

tff(pred_def_11253,type,
    v21169: state_type > $o ).

tff(pred_def_11254,type,
    v21195: ( state_type * $int ) > $o ).

tff(pred_def_11255,type,
    v21193: ( state_type * $int ) > $o ).

tff(pred_def_11256,type,
    v21196: ( state_type * $int ) > $o ).

tff(pred_def_11257,type,
    v21191: ( state_type * $int ) > $o ).

tff(pred_def_11258,type,
    v21189: ( state_type * $int ) > $o ).

tff(pred_def_11259,type,
    v21187: ( state_type * $int ) > $o ).

tff(pred_def_11260,type,
    v21185: state_type > $o ).

tff(pred_def_11261,type,
    v21183: state_type > $o ).

tff(pred_def_11262,type,
    v21200: state_type > $o ).

tff(pred_def_11263,type,
    v21198: state_type > $o ).

tff(pred_def_11264,type,
    v21204: state_type > $o ).

tff(pred_def_11265,type,
    v21202: state_type > $o ).

tff(pred_def_11266,type,
    v21207: state_type > $o ).

tff(pred_def_11267,type,
    v21206: state_type > $o ).

tff(pred_def_11268,type,
    v21181: state_type > $o ).

tff(pred_def_11269,type,
    v21179: state_type > $o ).

tff(pred_def_11270,type,
    v21177: state_type > $o ).

tff(pred_def_11271,type,
    v21175: state_type > $o ).

tff(pred_def_11272,type,
    v21173: state_type > $o ).

tff(pred_def_11273,type,
    v21211: state_type > $o ).

tff(pred_def_11274,type,
    v21209: state_type > $o ).

tff(pred_def_11275,type,
    v21167: state_type > $o ).

tff(pred_def_11276,type,
    v21217: state_type > $o ).

tff(pred_def_11277,type,
    v21219: state_type > $o ).

tff(pred_def_11278,type,
    v21215: state_type > $o ).

tff(pred_def_11279,type,
    v21214: state_type > $o ).

tff(pred_def_11280,type,
    v21225: state_type > $o ).

tff(pred_def_11281,type,
    v21226: state_type > $o ).

tff(pred_def_11282,type,
    v21222: state_type > $o ).

tff(pred_def_11283,type,
    v21224: state_type > $o ).

tff(pred_def_11284,type,
    v21232: state_type > $o ).

tff(pred_def_11285,type,
    v21230: state_type > $o ).

tff(pred_def_11286,type,
    v21234: state_type > $o ).

tff(pred_def_11287,type,
    v21161: state_type > $o ).

tff(pred_def_11288,type,
    v21159: state_type > $o ).

tff(pred_def_11289,type,
    v21157: state_type > $o ).

tff(pred_def_11290,type,
    v21241: state_type > $o ).

tff(pred_def_11291,type,
    v21239: state_type > $o ).

tff(pred_def_11292,type,
    v21238: state_type > $o ).

tff(pred_def_11293,type,
    v21237: state_type > $o ).

tff(pred_def_11294,type,
    v21249: state_type > $o ).

tff(pred_def_11295,type,
    v21250: state_type > $o ).

tff(pred_def_11296,type,
    v21248: state_type > $o ).

tff(pred_def_11297,type,
    v21245: ( state_type * $int ) > $o ).

tff(pred_def_11298,type,
    v21247: ( state_type * $int ) > $o ).

tff(pred_def_11299,type,
    v21131: ( state_type * $int ) > $o ).

tff(pred_def_11300,type,
    v21129: ( state_type * $int ) > $o ).

tff(pred_def_11301,type,
    v21127: ( state_type * $int ) > $o ).

tff(pred_def_11302,type,
    v21125: ( state_type * $int ) > $o ).

tff(pred_def_11303,type,
    v21123: ( state_type * $int ) > $o ).

tff(pred_def_11304,type,
    v21272: state_type > $o ).

tff(pred_def_11305,type,
    v21270: state_type > $o ).

tff(pred_def_11306,type,
    v21276: state_type > $o ).

tff(pred_def_11307,type,
    v21274: state_type > $o ).

tff(pred_def_11308,type,
    v21280: state_type > $o ).

tff(pred_def_11309,type,
    v21278: state_type > $o ).

tff(pred_def_11310,type,
    v21283: state_type > $o ).

tff(pred_def_11311,type,
    v21282: state_type > $o ).

tff(pred_def_11312,type,
    v21268: state_type > $o ).

tff(pred_def_11313,type,
    v21266: state_type > $o ).

tff(pred_def_11314,type,
    v21264: state_type > $o ).

tff(pred_def_11315,type,
    v21262: state_type > $o ).

tff(pred_def_11316,type,
    v21260: state_type > $o ).

tff(pred_def_11317,type,
    v21258: state_type > $o ).

tff(pred_def_11318,type,
    v21256: state_type > $o ).

tff(pred_def_11319,type,
    v21254: state_type > $o ).

tff(pred_def_11320,type,
    v21303: state_type > $o ).

tff(pred_def_11321,type,
    v21301: state_type > $o ).

tff(pred_def_11322,type,
    v21299: state_type > $o ).

tff(pred_def_11323,type,
    v21297: state_type > $o ).

tff(pred_def_11324,type,
    v21295: state_type > $o ).

tff(pred_def_11325,type,
    v21313: state_type > $o ).

tff(pred_def_11326,type,
    v21311: state_type > $o ).

tff(pred_def_11327,type,
    v21309: state_type > $o ).

tff(pred_def_11328,type,
    v21307: state_type > $o ).

tff(pred_def_11329,type,
    v21305: state_type > $o ).

tff(pred_def_11330,type,
    v21317: ( state_type * $int ) > $o ).

tff(pred_def_11331,type,
    v21315: ( state_type * $int ) > $o ).

tff(pred_def_11332,type,
    v21327: state_type > $o ).

tff(pred_def_11333,type,
    v21325: state_type > $o ).

tff(pred_def_11334,type,
    v21333: state_type > $o ).

tff(pred_def_11335,type,
    v21331: state_type > $o ).

tff(pred_def_11336,type,
    v21347: state_type > $o ).

tff(pred_def_11337,type,
    v21345: state_type > $o ).

tff(pred_def_11338,type,
    v21351: state_type > $o ).

tff(pred_def_11339,type,
    v21349: state_type > $o ).

tff(pred_def_11340,type,
    v21355: state_type > $o ).

tff(pred_def_11341,type,
    v21353: state_type > $o ).

tff(pred_def_11342,type,
    v21358: state_type > $o ).

tff(pred_def_11343,type,
    v21357: state_type > $o ).

tff(pred_def_11344,type,
    v21343: state_type > $o ).

tff(pred_def_11345,type,
    v21341: state_type > $o ).

tff(pred_def_11346,type,
    v21339: state_type > $o ).

tff(pred_def_11347,type,
    v21337: state_type > $o ).

tff(pred_def_11348,type,
    v21335: state_type > $o ).

tff(pred_def_11349,type,
    v21362: state_type > $o ).

tff(pred_def_11350,type,
    v21360: state_type > $o ).

tff(pred_def_11351,type,
    v21329: state_type > $o ).

tff(pred_def_11352,type,
    v21368: state_type > $o ).

tff(pred_def_11353,type,
    v21370: state_type > $o ).

tff(pred_def_11354,type,
    v21366: state_type > $o ).

tff(pred_def_11355,type,
    v21365: state_type > $o ).

tff(pred_def_11356,type,
    v21376: state_type > $o ).

tff(pred_def_11357,type,
    v21377: state_type > $o ).

tff(pred_def_11358,type,
    v21373: state_type > $o ).

tff(pred_def_11359,type,
    v21375: state_type > $o ).

tff(pred_def_11360,type,
    v21383: state_type > $o ).

tff(pred_def_11361,type,
    v21381: state_type > $o ).

tff(pred_def_11362,type,
    v21385: state_type > $o ).

tff(pred_def_11363,type,
    v21323: state_type > $o ).

tff(pred_def_11364,type,
    v21321: state_type > $o ).

tff(pred_def_11365,type,
    v21319: state_type > $o ).

tff(pred_def_11366,type,
    v21392: state_type > $o ).

tff(pred_def_11367,type,
    v21390: state_type > $o ).

tff(pred_def_11368,type,
    v21389: state_type > $o ).

tff(pred_def_11369,type,
    v21388: state_type > $o ).

tff(pred_def_11370,type,
    v21400: state_type > $o ).

tff(pred_def_11371,type,
    v21401: state_type > $o ).

tff(pred_def_11372,type,
    v21399: state_type > $o ).

tff(pred_def_11373,type,
    v21396: ( state_type * $int ) > $o ).

tff(pred_def_11374,type,
    v21398: ( state_type * $int ) > $o ).

tff(pred_def_11375,type,
    v21293: ( state_type * $int ) > $o ).

tff(pred_def_11376,type,
    v21291: ( state_type * $int ) > $o ).

tff(pred_def_11377,type,
    v21289: ( state_type * $int ) > $o ).

tff(pred_def_11378,type,
    v21287: ( state_type * $int ) > $o ).

tff(pred_def_11379,type,
    v21285: ( state_type * $int ) > $o ).

tff(pred_def_11380,type,
    v21423: state_type > $o ).

tff(pred_def_11381,type,
    v21421: state_type > $o ).

tff(pred_def_11382,type,
    v21427: state_type > $o ).

tff(pred_def_11383,type,
    v21425: state_type > $o ).

tff(pred_def_11384,type,
    v21431: state_type > $o ).

tff(pred_def_11385,type,
    v21429: state_type > $o ).

tff(pred_def_11386,type,
    v21434: state_type > $o ).

tff(pred_def_11387,type,
    v21433: state_type > $o ).

tff(pred_def_11388,type,
    v21419: state_type > $o ).

tff(pred_def_11389,type,
    v21417: state_type > $o ).

tff(pred_def_11390,type,
    v21415: state_type > $o ).

tff(pred_def_11391,type,
    v21413: state_type > $o ).

tff(pred_def_11392,type,
    v21411: state_type > $o ).

tff(pred_def_11393,type,
    v21409: state_type > $o ).

tff(pred_def_11394,type,
    v21407: state_type > $o ).

tff(pred_def_11395,type,
    v21405: state_type > $o ).

tff(pred_def_11396,type,
    v21454: state_type > $o ).

tff(pred_def_11397,type,
    v21452: state_type > $o ).

tff(pred_def_11398,type,
    v21450: state_type > $o ).

tff(pred_def_11399,type,
    v21448: state_type > $o ).

tff(pred_def_11400,type,
    v21446: state_type > $o ).

tff(pred_def_11401,type,
    v21464: state_type > $o ).

tff(pred_def_11402,type,
    v21462: state_type > $o ).

tff(pred_def_11403,type,
    v21460: state_type > $o ).

tff(pred_def_11404,type,
    v21458: state_type > $o ).

tff(pred_def_11405,type,
    v21456: state_type > $o ).

tff(pred_def_11406,type,
    v21468: ( state_type * $int ) > $o ).

tff(pred_def_11407,type,
    v21466: ( state_type * $int ) > $o ).

tff(pred_def_11408,type,
    v21478: state_type > $o ).

tff(pred_def_11409,type,
    v21476: state_type > $o ).

tff(pred_def_11410,type,
    v21484: state_type > $o ).

tff(pred_def_11411,type,
    v21482: state_type > $o ).

tff(pred_def_11412,type,
    v21498: state_type > $o ).

tff(pred_def_11413,type,
    v21496: state_type > $o ).

tff(pred_def_11414,type,
    v21502: state_type > $o ).

tff(pred_def_11415,type,
    v21500: state_type > $o ).

tff(pred_def_11416,type,
    v21506: state_type > $o ).

tff(pred_def_11417,type,
    v21504: state_type > $o ).

tff(pred_def_11418,type,
    v21509: state_type > $o ).

tff(pred_def_11419,type,
    v21508: state_type > $o ).

tff(pred_def_11420,type,
    v21494: state_type > $o ).

tff(pred_def_11421,type,
    v21492: state_type > $o ).

tff(pred_def_11422,type,
    v21490: state_type > $o ).

tff(pred_def_11423,type,
    v21488: state_type > $o ).

tff(pred_def_11424,type,
    v21486: state_type > $o ).

tff(pred_def_11425,type,
    v21513: state_type > $o ).

tff(pred_def_11426,type,
    v21511: state_type > $o ).

tff(pred_def_11427,type,
    v21480: state_type > $o ).

tff(pred_def_11428,type,
    v21519: state_type > $o ).

tff(pred_def_11429,type,
    v21521: state_type > $o ).

tff(pred_def_11430,type,
    v21517: state_type > $o ).

tff(pred_def_11431,type,
    v21516: state_type > $o ).

tff(pred_def_11432,type,
    v21527: state_type > $o ).

tff(pred_def_11433,type,
    v21528: state_type > $o ).

tff(pred_def_11434,type,
    v21524: state_type > $o ).

tff(pred_def_11435,type,
    v21526: state_type > $o ).

tff(pred_def_11436,type,
    v21534: state_type > $o ).

tff(pred_def_11437,type,
    v21532: state_type > $o ).

tff(pred_def_11438,type,
    v21536: state_type > $o ).

tff(pred_def_11439,type,
    v21474: state_type > $o ).

tff(pred_def_11440,type,
    v21472: state_type > $o ).

tff(pred_def_11441,type,
    v21470: state_type > $o ).

tff(pred_def_11442,type,
    v21543: state_type > $o ).

tff(pred_def_11443,type,
    v21541: state_type > $o ).

tff(pred_def_11444,type,
    v21540: state_type > $o ).

tff(pred_def_11445,type,
    v21539: state_type > $o ).

tff(pred_def_11446,type,
    v21551: state_type > $o ).

tff(pred_def_11447,type,
    v21552: state_type > $o ).

tff(pred_def_11448,type,
    v21550: state_type > $o ).

tff(pred_def_11449,type,
    v21547: ( state_type * $int ) > $o ).

tff(pred_def_11450,type,
    v21549: ( state_type * $int ) > $o ).

tff(pred_def_11451,type,
    v21444: ( state_type * $int ) > $o ).

tff(pred_def_11452,type,
    v21442: ( state_type * $int ) > $o ).

tff(pred_def_11453,type,
    v21440: ( state_type * $int ) > $o ).

tff(pred_def_11454,type,
    v21438: ( state_type * $int ) > $o ).

tff(pred_def_11455,type,
    v21436: ( state_type * $int ) > $o ).

tff(pred_def_11456,type,
    v21574: state_type > $o ).

tff(pred_def_11457,type,
    v21572: state_type > $o ).

tff(pred_def_11458,type,
    v21578: state_type > $o ).

tff(pred_def_11459,type,
    v21576: state_type > $o ).

tff(pred_def_11460,type,
    v21582: state_type > $o ).

tff(pred_def_11461,type,
    v21580: state_type > $o ).

tff(pred_def_11462,type,
    v21585: state_type > $o ).

tff(pred_def_11463,type,
    v21584: state_type > $o ).

tff(pred_def_11464,type,
    v21570: state_type > $o ).

tff(pred_def_11465,type,
    v21568: state_type > $o ).

tff(pred_def_11466,type,
    v21566: state_type > $o ).

tff(pred_def_11467,type,
    v21564: state_type > $o ).

tff(pred_def_11468,type,
    v21562: state_type > $o ).

tff(pred_def_11469,type,
    v21560: state_type > $o ).

tff(pred_def_11470,type,
    v21558: state_type > $o ).

tff(pred_def_11471,type,
    v21556: state_type > $o ).

tff(pred_def_11472,type,
    v21605: state_type > $o ).

tff(pred_def_11473,type,
    v21603: state_type > $o ).

tff(pred_def_11474,type,
    v21601: state_type > $o ).

tff(pred_def_11475,type,
    v21599: state_type > $o ).

tff(pred_def_11476,type,
    v21597: state_type > $o ).

tff(pred_def_11477,type,
    v21615: state_type > $o ).

tff(pred_def_11478,type,
    v21613: state_type > $o ).

tff(pred_def_11479,type,
    v21611: state_type > $o ).

tff(pred_def_11480,type,
    v21609: state_type > $o ).

tff(pred_def_11481,type,
    v21607: state_type > $o ).

tff(pred_def_11482,type,
    v21619: ( state_type * $int ) > $o ).

tff(pred_def_11483,type,
    v21617: ( state_type * $int ) > $o ).

tff(pred_def_11484,type,
    v21629: state_type > $o ).

tff(pred_def_11485,type,
    v21627: state_type > $o ).

tff(pred_def_11486,type,
    v21635: state_type > $o ).

tff(pred_def_11487,type,
    v21633: state_type > $o ).

tff(pred_def_11488,type,
    v21649: state_type > $o ).

tff(pred_def_11489,type,
    v21647: state_type > $o ).

tff(pred_def_11490,type,
    v21653: state_type > $o ).

tff(pred_def_11491,type,
    v21651: state_type > $o ).

tff(pred_def_11492,type,
    v21657: state_type > $o ).

tff(pred_def_11493,type,
    v21655: state_type > $o ).

tff(pred_def_11494,type,
    v21660: state_type > $o ).

tff(pred_def_11495,type,
    v21659: state_type > $o ).

tff(pred_def_11496,type,
    v21645: state_type > $o ).

tff(pred_def_11497,type,
    v21643: state_type > $o ).

tff(pred_def_11498,type,
    v21641: state_type > $o ).

tff(pred_def_11499,type,
    v21639: state_type > $o ).

tff(pred_def_11500,type,
    v21637: state_type > $o ).

tff(pred_def_11501,type,
    v21664: state_type > $o ).

tff(pred_def_11502,type,
    v21662: state_type > $o ).

tff(pred_def_11503,type,
    v21631: state_type > $o ).

tff(pred_def_11504,type,
    v21670: state_type > $o ).

tff(pred_def_11505,type,
    v21672: state_type > $o ).

tff(pred_def_11506,type,
    v21668: state_type > $o ).

tff(pred_def_11507,type,
    v21667: state_type > $o ).

tff(pred_def_11508,type,
    v21678: state_type > $o ).

tff(pred_def_11509,type,
    v21679: state_type > $o ).

tff(pred_def_11510,type,
    v21675: state_type > $o ).

tff(pred_def_11511,type,
    v21677: state_type > $o ).

tff(pred_def_11512,type,
    v21685: state_type > $o ).

tff(pred_def_11513,type,
    v21683: state_type > $o ).

tff(pred_def_11514,type,
    v21687: state_type > $o ).

tff(pred_def_11515,type,
    v21625: state_type > $o ).

tff(pred_def_11516,type,
    v21623: state_type > $o ).

tff(pred_def_11517,type,
    v21621: state_type > $o ).

tff(pred_def_11518,type,
    v21694: state_type > $o ).

tff(pred_def_11519,type,
    v21692: state_type > $o ).

tff(pred_def_11520,type,
    v21691: state_type > $o ).

tff(pred_def_11521,type,
    v21690: state_type > $o ).

tff(pred_def_11522,type,
    v21702: state_type > $o ).

tff(pred_def_11523,type,
    v21703: state_type > $o ).

tff(pred_def_11524,type,
    v21701: state_type > $o ).

tff(pred_def_11525,type,
    v21698: ( state_type * $int ) > $o ).

tff(pred_def_11526,type,
    v21700: ( state_type * $int ) > $o ).

tff(pred_def_11527,type,
    v21595: ( state_type * $int ) > $o ).

tff(pred_def_11528,type,
    v21593: ( state_type * $int ) > $o ).

tff(pred_def_11529,type,
    v21591: ( state_type * $int ) > $o ).

tff(pred_def_11530,type,
    v21589: ( state_type * $int ) > $o ).

tff(pred_def_11531,type,
    v21587: ( state_type * $int ) > $o ).

tff(pred_def_11532,type,
    v21725: state_type > $o ).

tff(pred_def_11533,type,
    v21723: state_type > $o ).

tff(pred_def_11534,type,
    v21729: state_type > $o ).

tff(pred_def_11535,type,
    v21727: state_type > $o ).

tff(pred_def_11536,type,
    v21733: state_type > $o ).

tff(pred_def_11537,type,
    v21731: state_type > $o ).

tff(pred_def_11538,type,
    v21736: state_type > $o ).

tff(pred_def_11539,type,
    v21735: state_type > $o ).

tff(pred_def_11540,type,
    v21721: state_type > $o ).

tff(pred_def_11541,type,
    v21719: state_type > $o ).

tff(pred_def_11542,type,
    v21717: state_type > $o ).

tff(pred_def_11543,type,
    v21715: state_type > $o ).

tff(pred_def_11544,type,
    v21713: state_type > $o ).

tff(pred_def_11545,type,
    v21711: state_type > $o ).

tff(pred_def_11546,type,
    v21709: state_type > $o ).

tff(pred_def_11547,type,
    v21707: state_type > $o ).

tff(pred_def_11548,type,
    v21756: state_type > $o ).

tff(pred_def_11549,type,
    v21754: state_type > $o ).

tff(pred_def_11550,type,
    v21752: state_type > $o ).

tff(pred_def_11551,type,
    v21750: state_type > $o ).

tff(pred_def_11552,type,
    v21748: state_type > $o ).

tff(pred_def_11553,type,
    v21766: state_type > $o ).

tff(pred_def_11554,type,
    v21764: state_type > $o ).

tff(pred_def_11555,type,
    v21762: state_type > $o ).

tff(pred_def_11556,type,
    v21760: state_type > $o ).

tff(pred_def_11557,type,
    v21758: state_type > $o ).

tff(pred_def_11558,type,
    v21770: ( state_type * $int ) > $o ).

tff(pred_def_11559,type,
    v21768: ( state_type * $int ) > $o ).

tff(pred_def_11560,type,
    v21780: state_type > $o ).

tff(pred_def_11561,type,
    v21778: state_type > $o ).

tff(pred_def_11562,type,
    v21786: state_type > $o ).

tff(pred_def_11563,type,
    v21784: state_type > $o ).

tff(pred_def_11564,type,
    v21799: state_type > $o ).

tff(pred_def_11565,type,
    v21797: state_type > $o ).

tff(pred_def_11566,type,
    v21803: state_type > $o ).

tff(pred_def_11567,type,
    v21801: state_type > $o ).

tff(pred_def_11568,type,
    v21807: state_type > $o ).

tff(pred_def_11569,type,
    v21805: state_type > $o ).

tff(pred_def_11570,type,
    v21810: state_type > $o ).

tff(pred_def_11571,type,
    v21809: state_type > $o ).

tff(pred_def_11572,type,
    v21795: state_type > $o ).

tff(pred_def_11573,type,
    v21793: state_type > $o ).

tff(pred_def_11574,type,
    v21790: state_type > $o ).

tff(pred_def_11575,type,
    v21788: state_type > $o ).

tff(pred_def_11576,type,
    v21814: state_type > $o ).

tff(pred_def_11577,type,
    v21812: state_type > $o ).

tff(pred_def_11578,type,
    v21782: state_type > $o ).

tff(pred_def_11579,type,
    v21820: state_type > $o ).

tff(pred_def_11580,type,
    v21822: state_type > $o ).

tff(pred_def_11581,type,
    v21818: state_type > $o ).

tff(pred_def_11582,type,
    v21817: state_type > $o ).

tff(pred_def_11583,type,
    v21828: state_type > $o ).

tff(pred_def_11584,type,
    v21829: state_type > $o ).

tff(pred_def_11585,type,
    v21825: state_type > $o ).

tff(pred_def_11586,type,
    v21827: state_type > $o ).

tff(pred_def_11587,type,
    v21835: state_type > $o ).

tff(pred_def_11588,type,
    v21833: state_type > $o ).

tff(pred_def_11589,type,
    v21837: state_type > $o ).

tff(pred_def_11590,type,
    v21776: state_type > $o ).

tff(pred_def_11591,type,
    v21774: state_type > $o ).

tff(pred_def_11592,type,
    v21772: state_type > $o ).

tff(pred_def_11593,type,
    v21844: state_type > $o ).

tff(pred_def_11594,type,
    v21842: state_type > $o ).

tff(pred_def_11595,type,
    v21841: state_type > $o ).

tff(pred_def_11596,type,
    v21840: state_type > $o ).

tff(pred_def_11597,type,
    v21852: state_type > $o ).

tff(pred_def_11598,type,
    v21853: state_type > $o ).

tff(pred_def_11599,type,
    v21851: state_type > $o ).

tff(pred_def_11600,type,
    v21848: ( state_type * $int ) > $o ).

tff(pred_def_11601,type,
    v21850: ( state_type * $int ) > $o ).

tff(pred_def_11602,type,
    v21746: ( state_type * $int ) > $o ).

tff(pred_def_11603,type,
    v21744: ( state_type * $int ) > $o ).

tff(pred_def_11604,type,
    v21742: ( state_type * $int ) > $o ).

tff(pred_def_11605,type,
    v21740: ( state_type * $int ) > $o ).

tff(pred_def_11606,type,
    v21738: ( state_type * $int ) > $o ).

tff(pred_def_11607,type,
    v21865: state_type > $o ).

tff(pred_def_11608,type,
    v21863: state_type > $o ).

tff(pred_def_11609,type,
    v21861: state_type > $o ).

tff(pred_def_11610,type,
    v21859: state_type > $o ).

tff(pred_def_11611,type,
    v21857: state_type > $o ).

tff(pred_def_11612,type,
    v21873: state_type > $o ).

tff(pred_def_11613,type,
    v21872: ( state_type * $int ) > $o ).

tff(pred_def_11614,type,
    v21871: ( state_type * $int ) > $o ).

tff(pred_def_11615,type,
    v21876: state_type > $o ).

tff(pred_def_11616,type,
    v21875: ( state_type * $int ) > $o ).

tff(pred_def_11617,type,
    v21874: ( state_type * $int ) > $o ).

tff(pred_def_11618,type,
    v21870: ( state_type * $int ) > $o ).

tff(pred_def_11619,type,
    v21879: state_type > $o ).

tff(pred_def_11620,type,
    v21878: ( state_type * $int ) > $o ).

tff(pred_def_11621,type,
    v21877: ( state_type * $int ) > $o ).

tff(pred_def_11622,type,
    v21869: ( state_type * $int ) > $o ).

tff(pred_def_11623,type,
    v21882: state_type > $o ).

tff(pred_def_11624,type,
    v21881: ( state_type * $int ) > $o ).

tff(pred_def_11625,type,
    v21880: ( state_type * $int ) > $o ).

tff(pred_def_11626,type,
    v21868: ( state_type * $int ) > $o ).

tff(pred_def_11627,type,
    v21885: state_type > $o ).

tff(pred_def_11628,type,
    v21884: ( state_type * $int ) > $o ).

tff(pred_def_11629,type,
    v21883: ( state_type * $int ) > $o ).

tff(pred_def_11630,type,
    v21867: ( state_type * $int ) > $o ).

tff(pred_def_11631,type,
    v21888: state_type > $o ).

tff(pred_def_11632,type,
    v21887: ( state_type * $int ) > $o ).

tff(pred_def_11633,type,
    v21886: ( state_type * $int ) > $o ).

tff(pred_def_11634,type,
    v20359: ( state_type * $int ) > $o ).

tff(pred_def_11635,type,
    v20357: ( state_type * $int ) > $o ).

tff(pred_def_11636,type,
    v20355: ( state_type * $int ) > $o ).

tff(pred_def_11637,type,
    v20353: ( state_type * $int ) > $o ).

tff(pred_def_11638,type,
    v20351: ( state_type * $int ) > $o ).

tff(pred_def_11639,type,
    v20345: state_type > $o ).

tff(pred_def_11640,type,
    v20343: state_type > $o ).

tff(pred_def_11641,type,
    v20341: state_type > $o ).

tff(pred_def_11642,type,
    v21899: ( state_type * $int ) > $o ).

tff(pred_def_11643,type,
    v21897: ( state_type * $int ) > $o ).

tff(pred_def_11644,type,
    v21933: state_type > $o ).

tff(pred_def_11645,type,
    v21931: state_type > $o ).

tff(pred_def_11646,type,
    v21929: state_type > $o ).

tff(pred_def_11647,type,
    v21927: state_type > $o ).

tff(pred_def_11648,type,
    v21925: state_type > $o ).

tff(pred_def_11649,type,
    v21923: state_type > $o ).

tff(pred_def_11650,type,
    v21921: state_type > $o ).

tff(pred_def_11651,type,
    v21947: state_type > $o ).

tff(pred_def_11652,type,
    v21945: state_type > $o ).

tff(pred_def_11653,type,
    v21943: state_type > $o ).

tff(pred_def_11654,type,
    v21941: state_type > $o ).

tff(pred_def_11655,type,
    v21939: state_type > $o ).

tff(pred_def_11656,type,
    v21937: state_type > $o ).

tff(pred_def_11657,type,
    v21935: state_type > $o ).

tff(pred_def_11658,type,
    v21973: state_type > $o ).

tff(pred_def_11659,type,
    v21975: state_type > $o ).

tff(pred_def_11660,type,
    v21974: ( state_type * $int ) > $o ).

tff(pred_def_11661,type,
    v21976: state_type > $o ).

tff(pred_def_11662,type,
    v21971: ( state_type * $int ) > $o ).

tff(pred_def_11663,type,
    v21969: ( state_type * $int ) > $o ).

tff(pred_def_11664,type,
    v21977: ( state_type * $int ) > $o ).

tff(pred_def_11665,type,
    v21967: ( state_type * $int ) > $o ).

tff(pred_def_11666,type,
    v21965: ( state_type * $int ) > $o ).

tff(pred_def_11667,type,
    v21963: state_type > $o ).

tff(pred_def_11668,type,
    v21979: state_type > $o ).

tff(pred_def_11669,type,
    v21961: ( state_type * $int ) > $o ).

tff(pred_def_11670,type,
    v21959: ( state_type * $int ) > $o ).

tff(pred_def_11671,type,
    v21993: ( state_type * $int ) > $o ).

tff(pred_def_11672,type,
    v21991: ( state_type * $int ) > $o ).

tff(pred_def_11673,type,
    v21997: state_type > $o ).

tff(pred_def_11674,type,
    v21995: state_type > $o ).

tff(pred_def_11675,type,
    v22021: state_type > $o ).

tff(pred_def_11676,type,
    v22019: state_type > $o ).

tff(pred_def_11677,type,
    v22017: state_type > $o ).

tff(pred_def_11678,type,
    v22015: state_type > $o ).

tff(pred_def_11679,type,
    v22013: state_type > $o ).

tff(pred_def_11680,type,
    v22011: state_type > $o ).

tff(pred_def_11681,type,
    v22009: state_type > $o ).

tff(pred_def_11682,type,
    v22035: state_type > $o ).

tff(pred_def_11683,type,
    v22033: state_type > $o ).

tff(pred_def_11684,type,
    v22031: state_type > $o ).

tff(pred_def_11685,type,
    v22029: state_type > $o ).

tff(pred_def_11686,type,
    v22027: state_type > $o ).

tff(pred_def_11687,type,
    v22025: state_type > $o ).

tff(pred_def_11688,type,
    v22023: state_type > $o ).

tff(pred_def_11689,type,
    v22051: ( state_type * $int ) > $o ).

tff(pred_def_11690,type,
    v22049: ( state_type * $int ) > $o ).

tff(pred_def_11691,type,
    v22047: ( state_type * $int ) > $o ).

tff(pred_def_11692,type,
    v22045: ( state_type * $int ) > $o ).

tff(pred_def_11693,type,
    v22043: ( state_type * $int ) > $o ).

tff(pred_def_11694,type,
    v22081: ( state_type * $int ) > $o ).

tff(pred_def_11695,type,
    v22083: ( state_type * $int ) > $o ).

tff(pred_def_11696,type,
    v22079: ( state_type * $int ) > $o ).

tff(pred_def_11697,type,
    v22077: ( state_type * $int ) > $o ).

tff(pred_def_11698,type,
    v22075: ( state_type * $int ) > $o ).

tff(pred_def_11699,type,
    v22073: ( state_type * $int ) > $o ).

tff(pred_def_11700,type,
    v22071: state_type > $o ).

tff(pred_def_11701,type,
    v22069: state_type > $o ).

tff(pred_def_11702,type,
    v22087: state_type > $o ).

tff(pred_def_11703,type,
    v22085: state_type > $o ).

tff(pred_def_11704,type,
    v22089: state_type > $o ).

tff(pred_def_11705,type,
    v22067: state_type > $o ).

tff(pred_def_11706,type,
    v22065: state_type > $o ).

tff(pred_def_11707,type,
    v22063: state_type > $o ).

tff(pred_def_11708,type,
    v22061: state_type > $o ).

tff(pred_def_11709,type,
    v22059: state_type > $o ).

tff(pred_def_11710,type,
    v22057: state_type > $o ).

tff(pred_def_11711,type,
    v22055: state_type > $o ).

tff(pred_def_11712,type,
    v22053: state_type > $o ).

tff(pred_def_11713,type,
    v22099: ( state_type * $int ) > $o ).

tff(pred_def_11714,type,
    v22097: ( state_type * $int ) > $o ).

tff(pred_def_11715,type,
    v22095: ( state_type * $int ) > $o ).

tff(pred_def_11716,type,
    v22093: ( state_type * $int ) > $o ).

tff(pred_def_11717,type,
    v22091: ( state_type * $int ) > $o ).

tff(pred_def_11718,type,
    v22129: ( state_type * $int ) > $o ).

tff(pred_def_11719,type,
    v22127: ( state_type * $int ) > $o ).

tff(pred_def_11720,type,
    v22130: ( state_type * $int ) > $o ).

tff(pred_def_11721,type,
    v22125: ( state_type * $int ) > $o ).

tff(pred_def_11722,type,
    v22123: ( state_type * $int ) > $o ).

tff(pred_def_11723,type,
    v22121: ( state_type * $int ) > $o ).

tff(pred_def_11724,type,
    v22119: state_type > $o ).

tff(pred_def_11725,type,
    v22117: state_type > $o ).

tff(pred_def_11726,type,
    v22134: state_type > $o ).

tff(pred_def_11727,type,
    v22132: state_type > $o ).

tff(pred_def_11728,type,
    v22136: state_type > $o ).

tff(pred_def_11729,type,
    v22115: state_type > $o ).

tff(pred_def_11730,type,
    v22113: state_type > $o ).

tff(pred_def_11731,type,
    v22111: state_type > $o ).

tff(pred_def_11732,type,
    v22109: state_type > $o ).

tff(pred_def_11733,type,
    v22107: state_type > $o ).

tff(pred_def_11734,type,
    v22105: state_type > $o ).

tff(pred_def_11735,type,
    v22103: state_type > $o ).

tff(pred_def_11736,type,
    v22101: state_type > $o ).

tff(pred_def_11737,type,
    v22146: ( state_type * $int ) > $o ).

tff(pred_def_11738,type,
    v22144: ( state_type * $int ) > $o ).

tff(pred_def_11739,type,
    v22142: ( state_type * $int ) > $o ).

tff(pred_def_11740,type,
    v22140: ( state_type * $int ) > $o ).

tff(pred_def_11741,type,
    v22138: ( state_type * $int ) > $o ).

tff(pred_def_11742,type,
    v22166: state_type > $o ).

tff(pred_def_11743,type,
    v22164: state_type > $o ).

tff(pred_def_11744,type,
    v22170: state_type > $o ).

tff(pred_def_11745,type,
    v22168: state_type > $o ).

tff(pred_def_11746,type,
    v22172: state_type > $o ).

tff(pred_def_11747,type,
    v22162: state_type > $o ).

tff(pred_def_11748,type,
    v22160: state_type > $o ).

tff(pred_def_11749,type,
    v22158: state_type > $o ).

tff(pred_def_11750,type,
    v22156: state_type > $o ).

tff(pred_def_11751,type,
    v22154: state_type > $o ).

tff(pred_def_11752,type,
    v22152: state_type > $o ).

tff(pred_def_11753,type,
    v22150: state_type > $o ).

tff(pred_def_11754,type,
    v22148: state_type > $o ).

tff(pred_def_11755,type,
    v22182: ( state_type * $int ) > $o ).

tff(pred_def_11756,type,
    v22180: ( state_type * $int ) > $o ).

tff(pred_def_11757,type,
    v22178: ( state_type * $int ) > $o ).

tff(pred_def_11758,type,
    v22176: ( state_type * $int ) > $o ).

tff(pred_def_11759,type,
    v22174: ( state_type * $int ) > $o ).

tff(pred_def_11760,type,
    v22202: state_type > $o ).

tff(pred_def_11761,type,
    v22200: state_type > $o ).

tff(pred_def_11762,type,
    v22206: state_type > $o ).

tff(pred_def_11763,type,
    v22204: state_type > $o ).

tff(pred_def_11764,type,
    v22208: state_type > $o ).

tff(pred_def_11765,type,
    v22198: state_type > $o ).

tff(pred_def_11766,type,
    v22196: state_type > $o ).

tff(pred_def_11767,type,
    v22194: state_type > $o ).

tff(pred_def_11768,type,
    v22192: state_type > $o ).

tff(pred_def_11769,type,
    v22190: state_type > $o ).

tff(pred_def_11770,type,
    v22188: state_type > $o ).

tff(pred_def_11771,type,
    v22186: state_type > $o ).

tff(pred_def_11772,type,
    v22184: state_type > $o ).

tff(pred_def_11773,type,
    v22214: state_type > $o ).

tff(pred_def_11774,type,
    v22213: ( state_type * $int ) > $o ).

tff(pred_def_11775,type,
    v22212: ( state_type * $int ) > $o ).

tff(pred_def_11776,type,
    v22217: state_type > $o ).

tff(pred_def_11777,type,
    v22216: ( state_type * $int ) > $o ).

tff(pred_def_11778,type,
    v22215: ( state_type * $int ) > $o ).

tff(pred_def_11779,type,
    v22211: ( state_type * $int ) > $o ).

tff(pred_def_11780,type,
    v22220: state_type > $o ).

tff(pred_def_11781,type,
    v22219: ( state_type * $int ) > $o ).

tff(pred_def_11782,type,
    v22218: ( state_type * $int ) > $o ).

tff(pred_def_11783,type,
    v22210: ( state_type * $int ) > $o ).

tff(pred_def_11784,type,
    v22223: state_type > $o ).

tff(pred_def_11785,type,
    v22222: ( state_type * $int ) > $o ).

tff(pred_def_11786,type,
    v22221: ( state_type * $int ) > $o ).

tff(pred_def_11787,type,
    v22041: ( state_type * $int ) > $o ).

tff(pred_def_11788,type,
    v22039: ( state_type * $int ) > $o ).

tff(pred_def_11789,type,
    v22037: ( state_type * $int ) > $o ).

tff(pred_def_11790,type,
    v22235: state_type > $o ).

tff(pred_def_11791,type,
    v22233: state_type > $o ).

tff(pred_def_11792,type,
    v22231: state_type > $o ).

tff(pred_def_11793,type,
    v22245: state_type > $o ).

tff(pred_def_11794,type,
    v22243: state_type > $o ).

tff(pred_def_11795,type,
    v22241: state_type > $o ).

tff(pred_def_11796,type,
    v22239: state_type > $o ).

tff(pred_def_11797,type,
    v22237: state_type > $o ).

tff(pred_def_11798,type,
    v22247: state_type > $o ).

tff(pred_def_11799,type,
    v22229: state_type > $o ).

tff(pred_def_11800,type,
    v22227: state_type > $o ).

tff(pred_def_11801,type,
    v22225: state_type > $o ).

tff(pred_def_11802,type,
    v22254: state_type > $o ).

tff(pred_def_11803,type,
    v22252: state_type > $o ).

tff(pred_def_11804,type,
    v22251: state_type > $o ).

tff(pred_def_11805,type,
    v22250: state_type > $o ).

tff(pred_def_11806,type,
    v22262: state_type > $o ).

tff(pred_def_11807,type,
    v22263: state_type > $o ).

tff(pred_def_11808,type,
    v22261: state_type > $o ).

tff(pred_def_11809,type,
    v22258: ( state_type * $int ) > $o ).

tff(pred_def_11810,type,
    v22260: ( state_type * $int ) > $o ).

tff(pred_def_11811,type,
    v22007: ( state_type * $int ) > $o ).

tff(pred_def_11812,type,
    v22005: ( state_type * $int ) > $o ).

tff(pred_def_11813,type,
    v22003: ( state_type * $int ) > $o ).

tff(pred_def_11814,type,
    v22001: ( state_type * $int ) > $o ).

tff(pred_def_11815,type,
    v21999: ( state_type * $int ) > $o ).

tff(pred_def_11816,type,
    v22269: state_type > $o ).

tff(pred_def_11817,type,
    v22267: state_type > $o ).

tff(pred_def_11818,type,
    v22273: state_type > $o ).

tff(pred_def_11819,type,
    v22272: ( state_type * $int ) > $o ).

tff(pred_def_11820,type,
    v22271: ( state_type * $int ) > $o ).

tff(pred_def_11821,type,
    v22276: state_type > $o ).

tff(pred_def_11822,type,
    v22275: ( state_type * $int ) > $o ).

tff(pred_def_11823,type,
    v22274: ( state_type * $int ) > $o ).

tff(pred_def_11824,type,
    v21989: ( state_type * $int ) > $o ).

tff(pred_def_11825,type,
    v21987: ( state_type * $int ) > $o ).

tff(pred_def_11826,type,
    v21985: ( state_type * $int ) > $o ).

tff(pred_def_11827,type,
    v21983: ( state_type * $int ) > $o ).

tff(pred_def_11828,type,
    v21981: ( state_type * $int ) > $o ).

tff(pred_def_11829,type,
    v21957: ( state_type * $int ) > $o ).

tff(pred_def_11830,type,
    v21955: ( state_type * $int ) > $o ).

tff(pred_def_11831,type,
    v21953: ( state_type * $int ) > $o ).

tff(pred_def_11832,type,
    v21951: ( state_type * $int ) > $o ).

tff(pred_def_11833,type,
    v21949: ( state_type * $int ) > $o ).

tff(pred_def_11834,type,
    v22289: state_type > $o ).

tff(pred_def_11835,type,
    v22287: state_type > $o ).

tff(pred_def_11836,type,
    v22285: state_type > $o ).

tff(pred_def_11837,type,
    v22295: state_type > $o ).

tff(pred_def_11838,type,
    v22293: state_type > $o ).

tff(pred_def_11839,type,
    v22313: ( state_type * $int ) > $o ).

tff(pred_def_11840,type,
    v22315: ( state_type * $int ) > $o ).

tff(pred_def_11841,type,
    v22311: ( state_type * $int ) > $o ).

tff(pred_def_11842,type,
    v22309: state_type > $o ).

tff(pred_def_11843,type,
    v22307: state_type > $o ).

tff(pred_def_11844,type,
    v22319: state_type > $o ).

tff(pred_def_11845,type,
    v22317: state_type > $o ).

tff(pred_def_11846,type,
    v22323: state_type > $o ).

tff(pred_def_11847,type,
    v22321: state_type > $o ).

tff(pred_def_11848,type,
    v22326: state_type > $o ).

tff(pred_def_11849,type,
    v22325: state_type > $o ).

tff(pred_def_11850,type,
    v22305: state_type > $o ).

tff(pred_def_11851,type,
    v22303: state_type > $o ).

tff(pred_def_11852,type,
    v22301: state_type > $o ).

tff(pred_def_11853,type,
    v22299: state_type > $o ).

tff(pred_def_11854,type,
    v22297: state_type > $o ).

tff(pred_def_11855,type,
    v22334: state_type > $o ).

tff(pred_def_11856,type,
    v22332: state_type > $o ).

tff(pred_def_11857,type,
    v22330: state_type > $o ).

tff(pred_def_11858,type,
    v22328: state_type > $o ).

tff(pred_def_11859,type,
    v22291: state_type > $o ).

tff(pred_def_11860,type,
    v22340: state_type > $o ).

tff(pred_def_11861,type,
    v22342: state_type > $o ).

tff(pred_def_11862,type,
    v22338: state_type > $o ).

tff(pred_def_11863,type,
    v22337: state_type > $o ).

tff(pred_def_11864,type,
    v22348: state_type > $o ).

tff(pred_def_11865,type,
    v22349: state_type > $o ).

tff(pred_def_11866,type,
    v22345: state_type > $o ).

tff(pred_def_11867,type,
    v22347: state_type > $o ).

tff(pred_def_11868,type,
    v22359: state_type > $o ).

tff(pred_def_11869,type,
    v22357: state_type > $o ).

tff(pred_def_11870,type,
    v22355: state_type > $o ).

tff(pred_def_11871,type,
    v22353: state_type > $o ).

tff(pred_def_11872,type,
    v22361: state_type > $o ).

tff(pred_def_11873,type,
    v22283: state_type > $o ).

tff(pred_def_11874,type,
    v22281: state_type > $o ).

tff(pred_def_11875,type,
    v22279: state_type > $o ).

tff(pred_def_11876,type,
    v22368: state_type > $o ).

tff(pred_def_11877,type,
    v22366: state_type > $o ).

tff(pred_def_11878,type,
    v22365: state_type > $o ).

tff(pred_def_11879,type,
    v22364: state_type > $o ).

tff(pred_def_11880,type,
    v22376: state_type > $o ).

tff(pred_def_11881,type,
    v22377: state_type > $o ).

tff(pred_def_11882,type,
    v22375: state_type > $o ).

tff(pred_def_11883,type,
    v22372: ( state_type * $int ) > $o ).

tff(pred_def_11884,type,
    v22374: ( state_type * $int ) > $o ).

tff(pred_def_11885,type,
    v21919: ( state_type * $int ) > $o ).

tff(pred_def_11886,type,
    v21917: ( state_type * $int ) > $o ).

tff(pred_def_11887,type,
    v21915: ( state_type * $int ) > $o ).

tff(pred_def_11888,type,
    v21913: ( state_type * $int ) > $o ).

tff(pred_def_11889,type,
    v21911: ( state_type * $int ) > $o ).

tff(pred_def_11890,type,
    v22413: state_type > $o ).

tff(pred_def_11891,type,
    v22411: state_type > $o ).

tff(pred_def_11892,type,
    v22409: state_type > $o ).

tff(pred_def_11893,type,
    v22407: state_type > $o ).

tff(pred_def_11894,type,
    v22405: state_type > $o ).

tff(pred_def_11895,type,
    v22403: state_type > $o ).

tff(pred_def_11896,type,
    v22423: state_type > $o ).

tff(pred_def_11897,type,
    v22421: state_type > $o ).

tff(pred_def_11898,type,
    v22419: state_type > $o ).

tff(pred_def_11899,type,
    v22417: state_type > $o ).

tff(pred_def_11900,type,
    v22415: state_type > $o ).

tff(pred_def_11901,type,
    v22450: state_type > $o ).

tff(pred_def_11902,type,
    v22449: ( state_type * $int ) > $o ).

tff(pred_def_11903,type,
    v22448: ( state_type * $int ) > $o ).

tff(pred_def_11904,type,
    v22446: ( state_type * $int ) > $o ).

tff(pred_def_11905,type,
    v22466: state_type > $o ).

tff(pred_def_11906,type,
    v22467: ( state_type * $int ) > $o ).

tff(pred_def_11907,type,
    v22468: state_type > $o ).

tff(pred_def_11908,type,
    v22464: ( state_type * $int ) > $o ).

tff(pred_def_11909,type,
    v22462: ( state_type * $int ) > $o ).

tff(pred_def_11910,type,
    v22492: ( state_type * $int ) > $o ).

tff(pred_def_11911,type,
    v22401: ( state_type * $int ) > $o ).

tff(pred_def_11912,type,
    v22490: ( state_type * $int ) > $o ).

tff(pred_def_11913,type,
    v22493: ( state_type * $int ) > $o ).

tff(pred_def_11914,type,
    v22488: ( state_type * $int ) > $o ).

tff(pred_def_11915,type,
    v22486: ( state_type * $int ) > $o ).

tff(pred_def_11916,type,
    v22484: ( state_type * $int ) > $o ).

tff(pred_def_11917,type,
    v22482: state_type > $o ).

tff(pred_def_11918,type,
    v22480: state_type > $o ).

tff(pred_def_11919,type,
    v22499: state_type > $o ).

tff(pred_def_11920,type,
    v22439: state_type > $o ).

tff(pred_def_11921,type,
    v22498: ( state_type * $int ) > $o ).

tff(pred_def_11922,type,
    v22437: ( state_type * $int ) > $o ).

tff(pred_def_11923,type,
    v22435: ( state_type * $int ) > $o ).

tff(pred_def_11924,type,
    v22514: ( state_type * $int ) > $o ).

tff(pred_def_11925,type,
    v22513: ( state_type * $int ) > $o ).

tff(pred_def_11926,type,
    v22511: ( state_type * $int ) > $o ).

tff(pred_def_11927,type,
    v22518: state_type > $o ).

tff(pred_def_11928,type,
    v22516: state_type > $o ).

tff(pred_def_11929,type,
    v22529: ( state_type * $int ) > $o ).

tff(pred_def_11930,type,
    v22528: state_type > $o ).

tff(pred_def_11931,type,
    v22532: state_type > $o ).

tff(pred_def_11932,type,
    v22533: state_type > $o ).

tff(pred_def_11933,type,
    v22531: state_type > $o ).

tff(pred_def_11934,type,
    v22534: state_type > $o ).

tff(pred_def_11935,type,
    v22530: state_type > $o ).

tff(pred_def_11936,type,
    v22527: state_type > $o ).

tff(pred_def_11937,type,
    v22535: state_type > $o ).

tff(pred_def_11938,type,
    v22526: state_type > $o ).

tff(pred_def_11939,type,
    v22538: state_type > $o ).

tff(pred_def_11940,type,
    v22539: state_type > $o ).

tff(pred_def_11941,type,
    v22537: state_type > $o ).

tff(pred_def_11942,type,
    v22540: state_type > $o ).

tff(pred_def_11943,type,
    v22536: state_type > $o ).

tff(pred_def_11944,type,
    v22525: state_type > $o ).

tff(pred_def_11945,type,
    v22541: state_type > $o ).

tff(pred_def_11946,type,
    v22524: state_type > $o ).

tff(pred_def_11947,type,
    v22523: state_type > $o ).

tff(pred_def_11948,type,
    v22545: state_type > $o ).

tff(pred_def_11949,type,
    v22546: state_type > $o ).

tff(pred_def_11950,type,
    v22544: state_type > $o ).

tff(pred_def_11951,type,
    v22547: state_type > $o ).

tff(pred_def_11952,type,
    v22543: state_type > $o ).

tff(pred_def_11953,type,
    v22542: state_type > $o ).

tff(pred_def_11954,type,
    v22522: state_type > $o ).

tff(pred_def_11955,type,
    v22548: state_type > $o ).

tff(pred_def_11956,type,
    v22521: state_type > $o ).

tff(pred_def_11957,type,
    v22551: state_type > $o ).

tff(pred_def_11958,type,
    v22552: state_type > $o ).

tff(pred_def_11959,type,
    v22550: state_type > $o ).

tff(pred_def_11960,type,
    v22553: state_type > $o ).

tff(pred_def_11961,type,
    v22549: state_type > $o ).

tff(pred_def_11962,type,
    v22556: state_type > $o ).

tff(pred_def_11963,type,
    v22557: state_type > $o ).

tff(pred_def_11964,type,
    v22555: state_type > $o ).

tff(pred_def_11965,type,
    v22558: state_type > $o ).

tff(pred_def_11966,type,
    v22554: state_type > $o ).

tff(pred_def_11967,type,
    v22561: state_type > $o ).

tff(pred_def_11968,type,
    v22562: state_type > $o ).

tff(pred_def_11969,type,
    v22560: state_type > $o ).

tff(pred_def_11970,type,
    v22563: state_type > $o ).

tff(pred_def_11971,type,
    v22559: state_type > $o ).

tff(pred_def_11972,type,
    v22519: ( state_type * $int ) > $o ).

tff(pred_def_11973,type,
    v22509: ( state_type * $int ) > $o ).

tff(pred_def_11974,type,
    v22507: ( state_type * $int ) > $o ).

tff(pred_def_11975,type,
    v22505: ( state_type * $int ) > $o ).

tff(pred_def_11976,type,
    v22503: ( state_type * $int ) > $o ).

tff(pred_def_11977,type,
    v22501: ( state_type * $int ) > $o ).

tff(pred_def_11978,type,
    v22564: ( state_type * $int ) > $o ).

tff(pred_def_11979,type,
    v22433: ( state_type * $int ) > $o ).

tff(pred_def_11980,type,
    v22431: ( state_type * $int ) > $o ).

tff(pred_def_11981,type,
    v22429: ( state_type * $int ) > $o ).

tff(pred_def_11982,type,
    v22565: ( state_type * $int ) > $o ).

tff(pred_def_11983,type,
    v22566: ( state_type * $int ) > $o ).

tff(pred_def_11984,type,
    v22427: ( state_type * $int ) > $o ).

tff(pred_def_11985,type,
    v22425: ( state_type * $int ) > $o ).

tff(pred_def_11986,type,
    v22576: state_type > $o ).

tff(pred_def_11987,type,
    v22574: state_type > $o ).

tff(pred_def_11988,type,
    v22582: state_type > $o ).

tff(pred_def_11989,type,
    v22580: state_type > $o ).

tff(pred_def_11990,type,
    v22586: state_type > $o ).

tff(pred_def_11991,type,
    v22584: state_type > $o ).

tff(pred_def_11992,type,
    v22590: state_type > $o ).

tff(pred_def_11993,type,
    v22588: state_type > $o ).

tff(pred_def_11994,type,
    v22578: state_type > $o ).

tff(pred_def_11995,type,
    v22596: state_type > $o ).

tff(pred_def_11996,type,
    v22598: state_type > $o ).

tff(pred_def_11997,type,
    v22594: state_type > $o ).

tff(pred_def_11998,type,
    v22593: state_type > $o ).

tff(pred_def_11999,type,
    v22604: state_type > $o ).

tff(pred_def_12000,type,
    v22605: state_type > $o ).

tff(pred_def_12001,type,
    v22601: state_type > $o ).

tff(pred_def_12002,type,
    v22603: state_type > $o ).

tff(pred_def_12003,type,
    v22611: state_type > $o ).

tff(pred_def_12004,type,
    v22609: state_type > $o ).

tff(pred_def_12005,type,
    v22613: state_type > $o ).

tff(pred_def_12006,type,
    v22572: state_type > $o ).

tff(pred_def_12007,type,
    v22570: state_type > $o ).

tff(pred_def_12008,type,
    v22568: state_type > $o ).

tff(pred_def_12009,type,
    v22620: state_type > $o ).

tff(pred_def_12010,type,
    v22618: state_type > $o ).

tff(pred_def_12011,type,
    v22617: state_type > $o ).

tff(pred_def_12012,type,
    v22616: state_type > $o ).

tff(pred_def_12013,type,
    v22628: state_type > $o ).

tff(pred_def_12014,type,
    v22629: state_type > $o ).

tff(pred_def_12015,type,
    v22627: state_type > $o ).

tff(pred_def_12016,type,
    v22624: ( state_type * $int ) > $o ).

tff(pred_def_12017,type,
    v22626: ( state_type * $int ) > $o ).

tff(pred_def_12018,type,
    v22615: ( state_type * $int ) > $o ).

tff(pred_def_12019,type,
    v22497: state_type > $o ).

tff(pred_def_12020,type,
    v22495: state_type > $o ).

tff(pred_def_12021,type,
    v22641: state_type > $o ).

tff(pred_def_12022,type,
    v22639: state_type > $o ).

tff(pred_def_12023,type,
    v22638: state_type > $o ).

tff(pred_def_12024,type,
    v22637: ( state_type * $int ) > $o ).

tff(pred_def_12025,type,
    v22635: state_type > $o ).

tff(pred_def_12026,type,
    v22633: state_type > $o ).

tff(pred_def_12027,type,
    v22646: state_type > $o ).

tff(pred_def_12028,type,
    v22645: state_type > $o ).

tff(pred_def_12029,type,
    v22478: state_type > $o ).

tff(pred_def_12030,type,
    v22476: state_type > $o ).

tff(pred_def_12031,type,
    v22474: state_type > $o ).

tff(pred_def_12032,type,
    v22647: ( state_type * $int ) > $o ).

tff(pred_def_12033,type,
    v22648: state_type > $o ).

tff(pred_def_12034,type,
    v22472: ( state_type * $int ) > $o ).

tff(pred_def_12035,type,
    v22470: ( state_type * $int ) > $o ).

tff(pred_def_12036,type,
    v22649: ( state_type * $int ) > $o ).

tff(pred_def_12037,type,
    v22460: ( state_type * $int ) > $o ).

tff(pred_def_12038,type,
    v22458: ( state_type * $int ) > $o ).

tff(pred_def_12039,type,
    v22456: state_type > $o ).

tff(pred_def_12040,type,
    v22650: ( state_type * $int ) > $o ).

tff(pred_def_12041,type,
    v22651: state_type > $o ).

tff(pred_def_12042,type,
    v22454: ( state_type * $int ) > $o ).

tff(pred_def_12043,type,
    v22452: ( state_type * $int ) > $o ).

tff(pred_def_12044,type,
    v22652: ( state_type * $int ) > $o ).

tff(pred_def_12045,type,
    v22444: ( state_type * $int ) > $o ).

tff(pred_def_12046,type,
    v22442: ( state_type * $int ) > $o ).

tff(pred_def_12047,type,
    v22658: state_type > $o ).

tff(pred_def_12048,type,
    v22656: state_type > $o ).

tff(pred_def_12049,type,
    v22655: state_type > $o ).

tff(pred_def_12050,type,
    v22654: ( state_type * $int ) > $o ).

tff(pred_def_12051,type,
    v22399: state_type > $o ).

tff(pred_def_12052,type,
    v22397: state_type > $o ).

tff(pred_def_12053,type,
    v22664: state_type > $o ).

tff(pred_def_12054,type,
    v22662: state_type > $o ).

tff(pred_def_12055,type,
    v22668: state_type > $o ).

tff(pred_def_12056,type,
    v22666: state_type > $o ).

tff(pred_def_12057,type,
    v22671: state_type > $o ).

tff(pred_def_12058,type,
    v22670: state_type > $o ).

tff(pred_def_12059,type,
    v22395: state_type > $o ).

tff(pred_def_12060,type,
    v22393: state_type > $o ).

tff(pred_def_12061,type,
    v22391: state_type > $o ).

tff(pred_def_12062,type,
    v22389: state_type > $o ).

tff(pred_def_12063,type,
    v22387: state_type > $o ).

tff(pred_def_12064,type,
    v22385: state_type > $o ).

tff(pred_def_12065,type,
    v22383: state_type > $o ).

tff(pred_def_12066,type,
    v22381: state_type > $o ).

tff(pred_def_12067,type,
    v22691: state_type > $o ).

tff(pred_def_12068,type,
    v22689: state_type > $o ).

tff(pred_def_12069,type,
    v22687: state_type > $o ).

tff(pred_def_12070,type,
    v22685: state_type > $o ).

tff(pred_def_12071,type,
    v22683: state_type > $o ).

tff(pred_def_12072,type,
    v22701: state_type > $o ).

tff(pred_def_12073,type,
    v22699: state_type > $o ).

tff(pred_def_12074,type,
    v22697: state_type > $o ).

tff(pred_def_12075,type,
    v22695: state_type > $o ).

tff(pred_def_12076,type,
    v22693: state_type > $o ).

tff(pred_def_12077,type,
    v22705: ( state_type * $int ) > $o ).

tff(pred_def_12078,type,
    v22703: ( state_type * $int ) > $o ).

tff(pred_def_12079,type,
    v22715: state_type > $o ).

tff(pred_def_12080,type,
    v22713: state_type > $o ).

tff(pred_def_12081,type,
    v22721: state_type > $o ).

tff(pred_def_12082,type,
    v22719: state_type > $o ).

tff(pred_def_12083,type,
    v22745: ( state_type * $int ) > $o ).

tff(pred_def_12084,type,
    v22743: ( state_type * $int ) > $o ).

tff(pred_def_12085,type,
    v22746: ( state_type * $int ) > $o ).

tff(pred_def_12086,type,
    v22741: ( state_type * $int ) > $o ).

tff(pred_def_12087,type,
    v22739: ( state_type * $int ) > $o ).

tff(pred_def_12088,type,
    v22737: ( state_type * $int ) > $o ).

tff(pred_def_12089,type,
    v22735: state_type > $o ).

tff(pred_def_12090,type,
    v22733: state_type > $o ).

tff(pred_def_12091,type,
    v22750: state_type > $o ).

tff(pred_def_12092,type,
    v22748: state_type > $o ).

tff(pred_def_12093,type,
    v22754: state_type > $o ).

tff(pred_def_12094,type,
    v22752: state_type > $o ).

tff(pred_def_12095,type,
    v22757: state_type > $o ).

tff(pred_def_12096,type,
    v22756: state_type > $o ).

tff(pred_def_12097,type,
    v22731: state_type > $o ).

tff(pred_def_12098,type,
    v22729: state_type > $o ).

tff(pred_def_12099,type,
    v22727: state_type > $o ).

tff(pred_def_12100,type,
    v22725: state_type > $o ).

tff(pred_def_12101,type,
    v22723: state_type > $o ).

tff(pred_def_12102,type,
    v22761: state_type > $o ).

tff(pred_def_12103,type,
    v22759: state_type > $o ).

tff(pred_def_12104,type,
    v22717: state_type > $o ).

tff(pred_def_12105,type,
    v22767: state_type > $o ).

tff(pred_def_12106,type,
    v22769: state_type > $o ).

tff(pred_def_12107,type,
    v22765: state_type > $o ).

tff(pred_def_12108,type,
    v22764: state_type > $o ).

tff(pred_def_12109,type,
    v22775: state_type > $o ).

tff(pred_def_12110,type,
    v22776: state_type > $o ).

tff(pred_def_12111,type,
    v22772: state_type > $o ).

tff(pred_def_12112,type,
    v22774: state_type > $o ).

tff(pred_def_12113,type,
    v22782: state_type > $o ).

tff(pred_def_12114,type,
    v22780: state_type > $o ).

tff(pred_def_12115,type,
    v22784: state_type > $o ).

tff(pred_def_12116,type,
    v22711: state_type > $o ).

tff(pred_def_12117,type,
    v22709: state_type > $o ).

tff(pred_def_12118,type,
    v22707: state_type > $o ).

tff(pred_def_12119,type,
    v22791: state_type > $o ).

tff(pred_def_12120,type,
    v22789: state_type > $o ).

tff(pred_def_12121,type,
    v22788: state_type > $o ).

tff(pred_def_12122,type,
    v22787: state_type > $o ).

tff(pred_def_12123,type,
    v22799: state_type > $o ).

tff(pred_def_12124,type,
    v22800: state_type > $o ).

tff(pred_def_12125,type,
    v22798: state_type > $o ).

tff(pred_def_12126,type,
    v22795: ( state_type * $int ) > $o ).

tff(pred_def_12127,type,
    v22797: ( state_type * $int ) > $o ).

tff(pred_def_12128,type,
    v22681: ( state_type * $int ) > $o ).

tff(pred_def_12129,type,
    v22679: ( state_type * $int ) > $o ).

tff(pred_def_12130,type,
    v22677: ( state_type * $int ) > $o ).

tff(pred_def_12131,type,
    v22675: ( state_type * $int ) > $o ).

tff(pred_def_12132,type,
    v22673: ( state_type * $int ) > $o ).

tff(pred_def_12133,type,
    v22822: state_type > $o ).

tff(pred_def_12134,type,
    v22820: state_type > $o ).

tff(pred_def_12135,type,
    v22826: state_type > $o ).

tff(pred_def_12136,type,
    v22824: state_type > $o ).

tff(pred_def_12137,type,
    v22830: state_type > $o ).

tff(pred_def_12138,type,
    v22828: state_type > $o ).

tff(pred_def_12139,type,
    v22833: state_type > $o ).

tff(pred_def_12140,type,
    v22832: state_type > $o ).

tff(pred_def_12141,type,
    v22818: state_type > $o ).

tff(pred_def_12142,type,
    v22816: state_type > $o ).

tff(pred_def_12143,type,
    v22814: state_type > $o ).

tff(pred_def_12144,type,
    v22812: state_type > $o ).

tff(pred_def_12145,type,
    v22810: state_type > $o ).

tff(pred_def_12146,type,
    v22808: state_type > $o ).

tff(pred_def_12147,type,
    v22806: state_type > $o ).

tff(pred_def_12148,type,
    v22804: state_type > $o ).

tff(pred_def_12149,type,
    v22853: state_type > $o ).

tff(pred_def_12150,type,
    v22851: state_type > $o ).

tff(pred_def_12151,type,
    v22849: state_type > $o ).

tff(pred_def_12152,type,
    v22847: state_type > $o ).

tff(pred_def_12153,type,
    v22845: state_type > $o ).

tff(pred_def_12154,type,
    v22863: state_type > $o ).

tff(pred_def_12155,type,
    v22861: state_type > $o ).

tff(pred_def_12156,type,
    v22859: state_type > $o ).

tff(pred_def_12157,type,
    v22857: state_type > $o ).

tff(pred_def_12158,type,
    v22855: state_type > $o ).

tff(pred_def_12159,type,
    v22867: ( state_type * $int ) > $o ).

tff(pred_def_12160,type,
    v22865: ( state_type * $int ) > $o ).

tff(pred_def_12161,type,
    v22877: state_type > $o ).

tff(pred_def_12162,type,
    v22875: state_type > $o ).

tff(pred_def_12163,type,
    v22883: state_type > $o ).

tff(pred_def_12164,type,
    v22881: state_type > $o ).

tff(pred_def_12165,type,
    v22897: state_type > $o ).

tff(pred_def_12166,type,
    v22895: state_type > $o ).

tff(pred_def_12167,type,
    v22901: state_type > $o ).

tff(pred_def_12168,type,
    v22899: state_type > $o ).

tff(pred_def_12169,type,
    v22905: state_type > $o ).

tff(pred_def_12170,type,
    v22903: state_type > $o ).

tff(pred_def_12171,type,
    v22908: state_type > $o ).

tff(pred_def_12172,type,
    v22907: state_type > $o ).

tff(pred_def_12173,type,
    v22893: state_type > $o ).

tff(pred_def_12174,type,
    v22891: state_type > $o ).

tff(pred_def_12175,type,
    v22889: state_type > $o ).

tff(pred_def_12176,type,
    v22887: state_type > $o ).

tff(pred_def_12177,type,
    v22885: state_type > $o ).

tff(pred_def_12178,type,
    v22912: state_type > $o ).

tff(pred_def_12179,type,
    v22910: state_type > $o ).

tff(pred_def_12180,type,
    v22879: state_type > $o ).

tff(pred_def_12181,type,
    v22918: state_type > $o ).

tff(pred_def_12182,type,
    v22920: state_type > $o ).

tff(pred_def_12183,type,
    v22916: state_type > $o ).

tff(pred_def_12184,type,
    v22915: state_type > $o ).

tff(pred_def_12185,type,
    v22926: state_type > $o ).

tff(pred_def_12186,type,
    v22927: state_type > $o ).

tff(pred_def_12187,type,
    v22923: state_type > $o ).

tff(pred_def_12188,type,
    v22925: state_type > $o ).

tff(pred_def_12189,type,
    v22933: state_type > $o ).

tff(pred_def_12190,type,
    v22931: state_type > $o ).

tff(pred_def_12191,type,
    v22935: state_type > $o ).

tff(pred_def_12192,type,
    v22873: state_type > $o ).

tff(pred_def_12193,type,
    v22871: state_type > $o ).

tff(pred_def_12194,type,
    v22869: state_type > $o ).

tff(pred_def_12195,type,
    v22942: state_type > $o ).

tff(pred_def_12196,type,
    v22940: state_type > $o ).

tff(pred_def_12197,type,
    v22939: state_type > $o ).

tff(pred_def_12198,type,
    v22938: state_type > $o ).

tff(pred_def_12199,type,
    v22950: state_type > $o ).

tff(pred_def_12200,type,
    v22951: state_type > $o ).

tff(pred_def_12201,type,
    v22949: state_type > $o ).

tff(pred_def_12202,type,
    v22946: ( state_type * $int ) > $o ).

tff(pred_def_12203,type,
    v22948: ( state_type * $int ) > $o ).

tff(pred_def_12204,type,
    v22843: ( state_type * $int ) > $o ).

tff(pred_def_12205,type,
    v22841: ( state_type * $int ) > $o ).

tff(pred_def_12206,type,
    v22839: ( state_type * $int ) > $o ).

tff(pred_def_12207,type,
    v22837: ( state_type * $int ) > $o ).

tff(pred_def_12208,type,
    v22835: ( state_type * $int ) > $o ).

tff(pred_def_12209,type,
    v22973: state_type > $o ).

tff(pred_def_12210,type,
    v22971: state_type > $o ).

tff(pred_def_12211,type,
    v22977: state_type > $o ).

tff(pred_def_12212,type,
    v22975: state_type > $o ).

tff(pred_def_12213,type,
    v22981: state_type > $o ).

tff(pred_def_12214,type,
    v22979: state_type > $o ).

tff(pred_def_12215,type,
    v22984: state_type > $o ).

tff(pred_def_12216,type,
    v22983: state_type > $o ).

tff(pred_def_12217,type,
    v22969: state_type > $o ).

tff(pred_def_12218,type,
    v22967: state_type > $o ).

tff(pred_def_12219,type,
    v22965: state_type > $o ).

tff(pred_def_12220,type,
    v22963: state_type > $o ).

tff(pred_def_12221,type,
    v22961: state_type > $o ).

tff(pred_def_12222,type,
    v22959: state_type > $o ).

tff(pred_def_12223,type,
    v22957: state_type > $o ).

tff(pred_def_12224,type,
    v22955: state_type > $o ).

tff(pred_def_12225,type,
    v23004: state_type > $o ).

tff(pred_def_12226,type,
    v23002: state_type > $o ).

tff(pred_def_12227,type,
    v23000: state_type > $o ).

tff(pred_def_12228,type,
    v22998: state_type > $o ).

tff(pred_def_12229,type,
    v22996: state_type > $o ).

tff(pred_def_12230,type,
    v23014: state_type > $o ).

tff(pred_def_12231,type,
    v23012: state_type > $o ).

tff(pred_def_12232,type,
    v23010: state_type > $o ).

tff(pred_def_12233,type,
    v23008: state_type > $o ).

tff(pred_def_12234,type,
    v23006: state_type > $o ).

tff(pred_def_12235,type,
    v23018: ( state_type * $int ) > $o ).

tff(pred_def_12236,type,
    v23016: ( state_type * $int ) > $o ).

tff(pred_def_12237,type,
    v23028: state_type > $o ).

tff(pred_def_12238,type,
    v23026: state_type > $o ).

tff(pred_def_12239,type,
    v23034: state_type > $o ).

tff(pred_def_12240,type,
    v23032: state_type > $o ).

tff(pred_def_12241,type,
    v23048: state_type > $o ).

tff(pred_def_12242,type,
    v23046: state_type > $o ).

tff(pred_def_12243,type,
    v23052: state_type > $o ).

tff(pred_def_12244,type,
    v23050: state_type > $o ).

tff(pred_def_12245,type,
    v23056: state_type > $o ).

tff(pred_def_12246,type,
    v23054: state_type > $o ).

tff(pred_def_12247,type,
    v23059: state_type > $o ).

tff(pred_def_12248,type,
    v23058: state_type > $o ).

tff(pred_def_12249,type,
    v23044: state_type > $o ).

tff(pred_def_12250,type,
    v23042: state_type > $o ).

tff(pred_def_12251,type,
    v23040: state_type > $o ).

tff(pred_def_12252,type,
    v23038: state_type > $o ).

tff(pred_def_12253,type,
    v23036: state_type > $o ).

tff(pred_def_12254,type,
    v23063: state_type > $o ).

tff(pred_def_12255,type,
    v23061: state_type > $o ).

tff(pred_def_12256,type,
    v23030: state_type > $o ).

tff(pred_def_12257,type,
    v23069: state_type > $o ).

tff(pred_def_12258,type,
    v23071: state_type > $o ).

tff(pred_def_12259,type,
    v23067: state_type > $o ).

tff(pred_def_12260,type,
    v23066: state_type > $o ).

tff(pred_def_12261,type,
    v23077: state_type > $o ).

tff(pred_def_12262,type,
    v23078: state_type > $o ).

tff(pred_def_12263,type,
    v23074: state_type > $o ).

tff(pred_def_12264,type,
    v23076: state_type > $o ).

tff(pred_def_12265,type,
    v23084: state_type > $o ).

tff(pred_def_12266,type,
    v23082: state_type > $o ).

tff(pred_def_12267,type,
    v23086: state_type > $o ).

tff(pred_def_12268,type,
    v23024: state_type > $o ).

tff(pred_def_12269,type,
    v23022: state_type > $o ).

tff(pred_def_12270,type,
    v23020: state_type > $o ).

tff(pred_def_12271,type,
    v23093: state_type > $o ).

tff(pred_def_12272,type,
    v23091: state_type > $o ).

tff(pred_def_12273,type,
    v23090: state_type > $o ).

tff(pred_def_12274,type,
    v23089: state_type > $o ).

tff(pred_def_12275,type,
    v23101: state_type > $o ).

tff(pred_def_12276,type,
    v23102: state_type > $o ).

tff(pred_def_12277,type,
    v23100: state_type > $o ).

tff(pred_def_12278,type,
    v23097: ( state_type * $int ) > $o ).

tff(pred_def_12279,type,
    v23099: ( state_type * $int ) > $o ).

tff(pred_def_12280,type,
    v22994: ( state_type * $int ) > $o ).

tff(pred_def_12281,type,
    v22992: ( state_type * $int ) > $o ).

tff(pred_def_12282,type,
    v22990: ( state_type * $int ) > $o ).

tff(pred_def_12283,type,
    v22988: ( state_type * $int ) > $o ).

tff(pred_def_12284,type,
    v22986: ( state_type * $int ) > $o ).

tff(pred_def_12285,type,
    v23124: state_type > $o ).

tff(pred_def_12286,type,
    v23122: state_type > $o ).

tff(pred_def_12287,type,
    v23128: state_type > $o ).

tff(pred_def_12288,type,
    v23126: state_type > $o ).

tff(pred_def_12289,type,
    v23132: state_type > $o ).

tff(pred_def_12290,type,
    v23130: state_type > $o ).

tff(pred_def_12291,type,
    v23135: state_type > $o ).

tff(pred_def_12292,type,
    v23134: state_type > $o ).

tff(pred_def_12293,type,
    v23120: state_type > $o ).

tff(pred_def_12294,type,
    v23118: state_type > $o ).

tff(pred_def_12295,type,
    v23116: state_type > $o ).

tff(pred_def_12296,type,
    v23114: state_type > $o ).

tff(pred_def_12297,type,
    v23112: state_type > $o ).

tff(pred_def_12298,type,
    v23110: state_type > $o ).

tff(pred_def_12299,type,
    v23108: state_type > $o ).

tff(pred_def_12300,type,
    v23106: state_type > $o ).

tff(pred_def_12301,type,
    v23155: state_type > $o ).

tff(pred_def_12302,type,
    v23153: state_type > $o ).

tff(pred_def_12303,type,
    v23151: state_type > $o ).

tff(pred_def_12304,type,
    v23149: state_type > $o ).

tff(pred_def_12305,type,
    v23147: state_type > $o ).

tff(pred_def_12306,type,
    v23165: state_type > $o ).

tff(pred_def_12307,type,
    v23163: state_type > $o ).

tff(pred_def_12308,type,
    v23161: state_type > $o ).

tff(pred_def_12309,type,
    v23159: state_type > $o ).

tff(pred_def_12310,type,
    v23157: state_type > $o ).

tff(pred_def_12311,type,
    v23169: ( state_type * $int ) > $o ).

tff(pred_def_12312,type,
    v23167: ( state_type * $int ) > $o ).

tff(pred_def_12313,type,
    v23179: state_type > $o ).

tff(pred_def_12314,type,
    v23177: state_type > $o ).

tff(pred_def_12315,type,
    v23185: state_type > $o ).

tff(pred_def_12316,type,
    v23183: state_type > $o ).

tff(pred_def_12317,type,
    v23199: state_type > $o ).

tff(pred_def_12318,type,
    v23197: state_type > $o ).

tff(pred_def_12319,type,
    v23203: state_type > $o ).

tff(pred_def_12320,type,
    v23201: state_type > $o ).

tff(pred_def_12321,type,
    v23207: state_type > $o ).

tff(pred_def_12322,type,
    v23205: state_type > $o ).

tff(pred_def_12323,type,
    v23210: state_type > $o ).

tff(pred_def_12324,type,
    v23209: state_type > $o ).

tff(pred_def_12325,type,
    v23195: state_type > $o ).

tff(pred_def_12326,type,
    v23193: state_type > $o ).

tff(pred_def_12327,type,
    v23191: state_type > $o ).

tff(pred_def_12328,type,
    v23189: state_type > $o ).

tff(pred_def_12329,type,
    v23187: state_type > $o ).

tff(pred_def_12330,type,
    v23214: state_type > $o ).

tff(pred_def_12331,type,
    v23212: state_type > $o ).

tff(pred_def_12332,type,
    v23181: state_type > $o ).

tff(pred_def_12333,type,
    v23220: state_type > $o ).

tff(pred_def_12334,type,
    v23222: state_type > $o ).

tff(pred_def_12335,type,
    v23218: state_type > $o ).

tff(pred_def_12336,type,
    v23217: state_type > $o ).

tff(pred_def_12337,type,
    v23228: state_type > $o ).

tff(pred_def_12338,type,
    v23229: state_type > $o ).

tff(pred_def_12339,type,
    v23225: state_type > $o ).

tff(pred_def_12340,type,
    v23227: state_type > $o ).

tff(pred_def_12341,type,
    v23235: state_type > $o ).

tff(pred_def_12342,type,
    v23233: state_type > $o ).

tff(pred_def_12343,type,
    v23237: state_type > $o ).

tff(pred_def_12344,type,
    v23175: state_type > $o ).

tff(pred_def_12345,type,
    v23173: state_type > $o ).

tff(pred_def_12346,type,
    v23171: state_type > $o ).

tff(pred_def_12347,type,
    v23244: state_type > $o ).

tff(pred_def_12348,type,
    v23242: state_type > $o ).

tff(pred_def_12349,type,
    v23241: state_type > $o ).

tff(pred_def_12350,type,
    v23240: state_type > $o ).

tff(pred_def_12351,type,
    v23252: state_type > $o ).

tff(pred_def_12352,type,
    v23253: state_type > $o ).

tff(pred_def_12353,type,
    v23251: state_type > $o ).

tff(pred_def_12354,type,
    v23248: ( state_type * $int ) > $o ).

tff(pred_def_12355,type,
    v23250: ( state_type * $int ) > $o ).

tff(pred_def_12356,type,
    v23145: ( state_type * $int ) > $o ).

tff(pred_def_12357,type,
    v23143: ( state_type * $int ) > $o ).

tff(pred_def_12358,type,
    v23141: ( state_type * $int ) > $o ).

tff(pred_def_12359,type,
    v23139: ( state_type * $int ) > $o ).

tff(pred_def_12360,type,
    v23137: ( state_type * $int ) > $o ).

tff(pred_def_12361,type,
    v23275: state_type > $o ).

tff(pred_def_12362,type,
    v23273: state_type > $o ).

tff(pred_def_12363,type,
    v23279: state_type > $o ).

tff(pred_def_12364,type,
    v23277: state_type > $o ).

tff(pred_def_12365,type,
    v23283: state_type > $o ).

tff(pred_def_12366,type,
    v23281: state_type > $o ).

tff(pred_def_12367,type,
    v23286: state_type > $o ).

tff(pred_def_12368,type,
    v23285: state_type > $o ).

tff(pred_def_12369,type,
    v23271: state_type > $o ).

tff(pred_def_12370,type,
    v23269: state_type > $o ).

tff(pred_def_12371,type,
    v23267: state_type > $o ).

tff(pred_def_12372,type,
    v23265: state_type > $o ).

tff(pred_def_12373,type,
    v23263: state_type > $o ).

tff(pred_def_12374,type,
    v23261: state_type > $o ).

tff(pred_def_12375,type,
    v23259: state_type > $o ).

tff(pred_def_12376,type,
    v23257: state_type > $o ).

tff(pred_def_12377,type,
    v23306: state_type > $o ).

tff(pred_def_12378,type,
    v23304: state_type > $o ).

tff(pred_def_12379,type,
    v23302: state_type > $o ).

tff(pred_def_12380,type,
    v23300: state_type > $o ).

tff(pred_def_12381,type,
    v23298: state_type > $o ).

tff(pred_def_12382,type,
    v23316: state_type > $o ).

tff(pred_def_12383,type,
    v23314: state_type > $o ).

tff(pred_def_12384,type,
    v23312: state_type > $o ).

tff(pred_def_12385,type,
    v23310: state_type > $o ).

tff(pred_def_12386,type,
    v23308: state_type > $o ).

tff(pred_def_12387,type,
    v23320: ( state_type * $int ) > $o ).

tff(pred_def_12388,type,
    v23318: ( state_type * $int ) > $o ).

tff(pred_def_12389,type,
    v23330: state_type > $o ).

tff(pred_def_12390,type,
    v23328: state_type > $o ).

tff(pred_def_12391,type,
    v23336: state_type > $o ).

tff(pred_def_12392,type,
    v23334: state_type > $o ).

tff(pred_def_12393,type,
    v23349: state_type > $o ).

tff(pred_def_12394,type,
    v23347: state_type > $o ).

tff(pred_def_12395,type,
    v23353: state_type > $o ).

tff(pred_def_12396,type,
    v23351: state_type > $o ).

tff(pred_def_12397,type,
    v23357: state_type > $o ).

tff(pred_def_12398,type,
    v23355: state_type > $o ).

tff(pred_def_12399,type,
    v23360: state_type > $o ).

tff(pred_def_12400,type,
    v23359: state_type > $o ).

tff(pred_def_12401,type,
    v23345: state_type > $o ).

tff(pred_def_12402,type,
    v23343: state_type > $o ).

tff(pred_def_12403,type,
    v23340: state_type > $o ).

tff(pred_def_12404,type,
    v23338: state_type > $o ).

tff(pred_def_12405,type,
    v23364: state_type > $o ).

tff(pred_def_12406,type,
    v23362: state_type > $o ).

tff(pred_def_12407,type,
    v23332: state_type > $o ).

tff(pred_def_12408,type,
    v23370: state_type > $o ).

tff(pred_def_12409,type,
    v23372: state_type > $o ).

tff(pred_def_12410,type,
    v23368: state_type > $o ).

tff(pred_def_12411,type,
    v23367: state_type > $o ).

tff(pred_def_12412,type,
    v23378: state_type > $o ).

tff(pred_def_12413,type,
    v23379: state_type > $o ).

tff(pred_def_12414,type,
    v23375: state_type > $o ).

tff(pred_def_12415,type,
    v23377: state_type > $o ).

tff(pred_def_12416,type,
    v23385: state_type > $o ).

tff(pred_def_12417,type,
    v23383: state_type > $o ).

tff(pred_def_12418,type,
    v23387: state_type > $o ).

tff(pred_def_12419,type,
    v23326: state_type > $o ).

tff(pred_def_12420,type,
    v23324: state_type > $o ).

tff(pred_def_12421,type,
    v23322: state_type > $o ).

tff(pred_def_12422,type,
    v23394: state_type > $o ).

tff(pred_def_12423,type,
    v23392: state_type > $o ).

tff(pred_def_12424,type,
    v23391: state_type > $o ).

tff(pred_def_12425,type,
    v23390: state_type > $o ).

tff(pred_def_12426,type,
    v23402: state_type > $o ).

tff(pred_def_12427,type,
    v23403: state_type > $o ).

tff(pred_def_12428,type,
    v23401: state_type > $o ).

tff(pred_def_12429,type,
    v23398: ( state_type * $int ) > $o ).

tff(pred_def_12430,type,
    v23400: ( state_type * $int ) > $o ).

tff(pred_def_12431,type,
    v23296: ( state_type * $int ) > $o ).

tff(pred_def_12432,type,
    v23294: ( state_type * $int ) > $o ).

tff(pred_def_12433,type,
    v23292: ( state_type * $int ) > $o ).

tff(pred_def_12434,type,
    v23290: ( state_type * $int ) > $o ).

tff(pred_def_12435,type,
    v23288: ( state_type * $int ) > $o ).

tff(pred_def_12436,type,
    v23415: state_type > $o ).

tff(pred_def_12437,type,
    v23413: state_type > $o ).

tff(pred_def_12438,type,
    v23411: state_type > $o ).

tff(pred_def_12439,type,
    v23409: state_type > $o ).

tff(pred_def_12440,type,
    v23407: state_type > $o ).

tff(pred_def_12441,type,
    v23423: state_type > $o ).

tff(pred_def_12442,type,
    v23422: ( state_type * $int ) > $o ).

tff(pred_def_12443,type,
    v23421: ( state_type * $int ) > $o ).

tff(pred_def_12444,type,
    v23426: state_type > $o ).

tff(pred_def_12445,type,
    v23425: ( state_type * $int ) > $o ).

tff(pred_def_12446,type,
    v23424: ( state_type * $int ) > $o ).

tff(pred_def_12447,type,
    v23420: ( state_type * $int ) > $o ).

tff(pred_def_12448,type,
    v23429: state_type > $o ).

tff(pred_def_12449,type,
    v23428: ( state_type * $int ) > $o ).

tff(pred_def_12450,type,
    v23427: ( state_type * $int ) > $o ).

tff(pred_def_12451,type,
    v23419: ( state_type * $int ) > $o ).

tff(pred_def_12452,type,
    v23432: state_type > $o ).

tff(pred_def_12453,type,
    v23431: ( state_type * $int ) > $o ).

tff(pred_def_12454,type,
    v23430: ( state_type * $int ) > $o ).

tff(pred_def_12455,type,
    v23418: ( state_type * $int ) > $o ).

tff(pred_def_12456,type,
    v23435: state_type > $o ).

tff(pred_def_12457,type,
    v23434: ( state_type * $int ) > $o ).

tff(pred_def_12458,type,
    v23433: ( state_type * $int ) > $o ).

tff(pred_def_12459,type,
    v23417: ( state_type * $int ) > $o ).

tff(pred_def_12460,type,
    v23438: state_type > $o ).

tff(pred_def_12461,type,
    v23437: ( state_type * $int ) > $o ).

tff(pred_def_12462,type,
    v23436: ( state_type * $int ) > $o ).

tff(pred_def_12463,type,
    v21909: ( state_type * $int ) > $o ).

tff(pred_def_12464,type,
    v21907: ( state_type * $int ) > $o ).

tff(pred_def_12465,type,
    v21905: ( state_type * $int ) > $o ).

tff(pred_def_12466,type,
    v21903: ( state_type * $int ) > $o ).

tff(pred_def_12467,type,
    v21901: ( state_type * $int ) > $o ).

tff(pred_def_12468,type,
    v21895: state_type > $o ).

tff(pred_def_12469,type,
    v21893: state_type > $o ).

tff(pred_def_12470,type,
    v21891: state_type > $o ).

tff(pred_def_12471,type,
    v23449: ( state_type * $int ) > $o ).

tff(pred_def_12472,type,
    v23447: ( state_type * $int ) > $o ).

tff(pred_def_12473,type,
    v23483: state_type > $o ).

tff(pred_def_12474,type,
    v23481: state_type > $o ).

tff(pred_def_12475,type,
    v23479: state_type > $o ).

tff(pred_def_12476,type,
    v23477: state_type > $o ).

tff(pred_def_12477,type,
    v23475: state_type > $o ).

tff(pred_def_12478,type,
    v23473: state_type > $o ).

tff(pred_def_12479,type,
    v23471: state_type > $o ).

tff(pred_def_12480,type,
    v23497: state_type > $o ).

tff(pred_def_12481,type,
    v23495: state_type > $o ).

tff(pred_def_12482,type,
    v23493: state_type > $o ).

tff(pred_def_12483,type,
    v23491: state_type > $o ).

tff(pred_def_12484,type,
    v23489: state_type > $o ).

tff(pred_def_12485,type,
    v23487: state_type > $o ).

tff(pred_def_12486,type,
    v23485: state_type > $o ).

tff(pred_def_12487,type,
    v23523: state_type > $o ).

tff(pred_def_12488,type,
    v23525: state_type > $o ).

tff(pred_def_12489,type,
    v23524: ( state_type * $int ) > $o ).

tff(pred_def_12490,type,
    v23526: state_type > $o ).

tff(pred_def_12491,type,
    v23521: ( state_type * $int ) > $o ).

tff(pred_def_12492,type,
    v23519: ( state_type * $int ) > $o ).

tff(pred_def_12493,type,
    v23527: ( state_type * $int ) > $o ).

tff(pred_def_12494,type,
    v23517: ( state_type * $int ) > $o ).

tff(pred_def_12495,type,
    v23515: ( state_type * $int ) > $o ).

tff(pred_def_12496,type,
    v23513: state_type > $o ).

tff(pred_def_12497,type,
    v23529: state_type > $o ).

tff(pred_def_12498,type,
    v23511: ( state_type * $int ) > $o ).

tff(pred_def_12499,type,
    v23509: ( state_type * $int ) > $o ).

tff(pred_def_12500,type,
    v23543: ( state_type * $int ) > $o ).

tff(pred_def_12501,type,
    v23541: ( state_type * $int ) > $o ).

tff(pred_def_12502,type,
    v23547: state_type > $o ).

tff(pred_def_12503,type,
    v23545: state_type > $o ).

tff(pred_def_12504,type,
    v23571: state_type > $o ).

tff(pred_def_12505,type,
    v23569: state_type > $o ).

tff(pred_def_12506,type,
    v23567: state_type > $o ).

tff(pred_def_12507,type,
    v23565: state_type > $o ).

tff(pred_def_12508,type,
    v23563: state_type > $o ).

tff(pred_def_12509,type,
    v23561: state_type > $o ).

tff(pred_def_12510,type,
    v23559: state_type > $o ).

tff(pred_def_12511,type,
    v23585: state_type > $o ).

tff(pred_def_12512,type,
    v23583: state_type > $o ).

tff(pred_def_12513,type,
    v23581: state_type > $o ).

tff(pred_def_12514,type,
    v23579: state_type > $o ).

tff(pred_def_12515,type,
    v23577: state_type > $o ).

tff(pred_def_12516,type,
    v23575: state_type > $o ).

tff(pred_def_12517,type,
    v23573: state_type > $o ).

tff(pred_def_12518,type,
    v23601: ( state_type * $int ) > $o ).

tff(pred_def_12519,type,
    v23599: ( state_type * $int ) > $o ).

tff(pred_def_12520,type,
    v23597: ( state_type * $int ) > $o ).

tff(pred_def_12521,type,
    v23595: ( state_type * $int ) > $o ).

tff(pred_def_12522,type,
    v23593: ( state_type * $int ) > $o ).

tff(pred_def_12523,type,
    v23631: ( state_type * $int ) > $o ).

tff(pred_def_12524,type,
    v23633: ( state_type * $int ) > $o ).

tff(pred_def_12525,type,
    v23629: ( state_type * $int ) > $o ).

tff(pred_def_12526,type,
    v23627: ( state_type * $int ) > $o ).

tff(pred_def_12527,type,
    v23625: ( state_type * $int ) > $o ).

tff(pred_def_12528,type,
    v23623: ( state_type * $int ) > $o ).

tff(pred_def_12529,type,
    v23621: state_type > $o ).

tff(pred_def_12530,type,
    v23619: state_type > $o ).

tff(pred_def_12531,type,
    v23637: state_type > $o ).

tff(pred_def_12532,type,
    v23635: state_type > $o ).

tff(pred_def_12533,type,
    v23639: state_type > $o ).

tff(pred_def_12534,type,
    v23617: state_type > $o ).

tff(pred_def_12535,type,
    v23615: state_type > $o ).

tff(pred_def_12536,type,
    v23613: state_type > $o ).

tff(pred_def_12537,type,
    v23611: state_type > $o ).

tff(pred_def_12538,type,
    v23609: state_type > $o ).

tff(pred_def_12539,type,
    v23607: state_type > $o ).

tff(pred_def_12540,type,
    v23605: state_type > $o ).

tff(pred_def_12541,type,
    v23603: state_type > $o ).

tff(pred_def_12542,type,
    v23649: ( state_type * $int ) > $o ).

tff(pred_def_12543,type,
    v23647: ( state_type * $int ) > $o ).

tff(pred_def_12544,type,
    v23645: ( state_type * $int ) > $o ).

tff(pred_def_12545,type,
    v23643: ( state_type * $int ) > $o ).

tff(pred_def_12546,type,
    v23641: ( state_type * $int ) > $o ).

tff(pred_def_12547,type,
    v23679: ( state_type * $int ) > $o ).

tff(pred_def_12548,type,
    v23677: ( state_type * $int ) > $o ).

tff(pred_def_12549,type,
    v23680: ( state_type * $int ) > $o ).

tff(pred_def_12550,type,
    v23675: ( state_type * $int ) > $o ).

tff(pred_def_12551,type,
    v23673: ( state_type * $int ) > $o ).

tff(pred_def_12552,type,
    v23671: ( state_type * $int ) > $o ).

tff(pred_def_12553,type,
    v23669: state_type > $o ).

tff(pred_def_12554,type,
    v23667: state_type > $o ).

tff(pred_def_12555,type,
    v23684: state_type > $o ).

tff(pred_def_12556,type,
    v23682: state_type > $o ).

tff(pred_def_12557,type,
    v23686: state_type > $o ).

tff(pred_def_12558,type,
    v23665: state_type > $o ).

tff(pred_def_12559,type,
    v23663: state_type > $o ).

tff(pred_def_12560,type,
    v23661: state_type > $o ).

tff(pred_def_12561,type,
    v23659: state_type > $o ).

tff(pred_def_12562,type,
    v23657: state_type > $o ).

tff(pred_def_12563,type,
    v23655: state_type > $o ).

tff(pred_def_12564,type,
    v23653: state_type > $o ).

tff(pred_def_12565,type,
    v23651: state_type > $o ).

tff(pred_def_12566,type,
    v23696: ( state_type * $int ) > $o ).

tff(pred_def_12567,type,
    v23694: ( state_type * $int ) > $o ).

tff(pred_def_12568,type,
    v23692: ( state_type * $int ) > $o ).

tff(pred_def_12569,type,
    v23690: ( state_type * $int ) > $o ).

tff(pred_def_12570,type,
    v23688: ( state_type * $int ) > $o ).

tff(pred_def_12571,type,
    v23716: state_type > $o ).

tff(pred_def_12572,type,
    v23714: state_type > $o ).

tff(pred_def_12573,type,
    v23720: state_type > $o ).

tff(pred_def_12574,type,
    v23718: state_type > $o ).

tff(pred_def_12575,type,
    v23722: state_type > $o ).

tff(pred_def_12576,type,
    v23712: state_type > $o ).

tff(pred_def_12577,type,
    v23710: state_type > $o ).

tff(pred_def_12578,type,
    v23708: state_type > $o ).

tff(pred_def_12579,type,
    v23706: state_type > $o ).

tff(pred_def_12580,type,
    v23704: state_type > $o ).

tff(pred_def_12581,type,
    v23702: state_type > $o ).

tff(pred_def_12582,type,
    v23700: state_type > $o ).

tff(pred_def_12583,type,
    v23698: state_type > $o ).

tff(pred_def_12584,type,
    v23732: ( state_type * $int ) > $o ).

tff(pred_def_12585,type,
    v23730: ( state_type * $int ) > $o ).

tff(pred_def_12586,type,
    v23728: ( state_type * $int ) > $o ).

tff(pred_def_12587,type,
    v23726: ( state_type * $int ) > $o ).

tff(pred_def_12588,type,
    v23724: ( state_type * $int ) > $o ).

tff(pred_def_12589,type,
    v23752: state_type > $o ).

tff(pred_def_12590,type,
    v23750: state_type > $o ).

tff(pred_def_12591,type,
    v23756: state_type > $o ).

tff(pred_def_12592,type,
    v23754: state_type > $o ).

tff(pred_def_12593,type,
    v23758: state_type > $o ).

tff(pred_def_12594,type,
    v23748: state_type > $o ).

tff(pred_def_12595,type,
    v23746: state_type > $o ).

tff(pred_def_12596,type,
    v23744: state_type > $o ).

tff(pred_def_12597,type,
    v23742: state_type > $o ).

tff(pred_def_12598,type,
    v23740: state_type > $o ).

tff(pred_def_12599,type,
    v23738: state_type > $o ).

tff(pred_def_12600,type,
    v23736: state_type > $o ).

tff(pred_def_12601,type,
    v23734: state_type > $o ).

tff(pred_def_12602,type,
    v23764: state_type > $o ).

tff(pred_def_12603,type,
    v23763: ( state_type * $int ) > $o ).

tff(pred_def_12604,type,
    v23762: ( state_type * $int ) > $o ).

tff(pred_def_12605,type,
    v23767: state_type > $o ).

tff(pred_def_12606,type,
    v23766: ( state_type * $int ) > $o ).

tff(pred_def_12607,type,
    v23765: ( state_type * $int ) > $o ).

tff(pred_def_12608,type,
    v23761: ( state_type * $int ) > $o ).

tff(pred_def_12609,type,
    v23770: state_type > $o ).

tff(pred_def_12610,type,
    v23769: ( state_type * $int ) > $o ).

tff(pred_def_12611,type,
    v23768: ( state_type * $int ) > $o ).

tff(pred_def_12612,type,
    v23760: ( state_type * $int ) > $o ).

tff(pred_def_12613,type,
    v23773: state_type > $o ).

tff(pred_def_12614,type,
    v23772: ( state_type * $int ) > $o ).

tff(pred_def_12615,type,
    v23771: ( state_type * $int ) > $o ).

tff(pred_def_12616,type,
    v23591: ( state_type * $int ) > $o ).

tff(pred_def_12617,type,
    v23589: ( state_type * $int ) > $o ).

tff(pred_def_12618,type,
    v23587: ( state_type * $int ) > $o ).

tff(pred_def_12619,type,
    v23785: state_type > $o ).

tff(pred_def_12620,type,
    v23783: state_type > $o ).

tff(pred_def_12621,type,
    v23781: state_type > $o ).

tff(pred_def_12622,type,
    v23795: state_type > $o ).

tff(pred_def_12623,type,
    v23793: state_type > $o ).

tff(pred_def_12624,type,
    v23791: state_type > $o ).

tff(pred_def_12625,type,
    v23789: state_type > $o ).

tff(pred_def_12626,type,
    v23787: state_type > $o ).

tff(pred_def_12627,type,
    v23797: state_type > $o ).

tff(pred_def_12628,type,
    v23779: state_type > $o ).

tff(pred_def_12629,type,
    v23777: state_type > $o ).

tff(pred_def_12630,type,
    v23775: state_type > $o ).

tff(pred_def_12631,type,
    v23804: state_type > $o ).

tff(pred_def_12632,type,
    v23802: state_type > $o ).

tff(pred_def_12633,type,
    v23801: state_type > $o ).

tff(pred_def_12634,type,
    v23800: state_type > $o ).

tff(pred_def_12635,type,
    v23812: state_type > $o ).

tff(pred_def_12636,type,
    v23813: state_type > $o ).

tff(pred_def_12637,type,
    v23811: state_type > $o ).

tff(pred_def_12638,type,
    v23808: ( state_type * $int ) > $o ).

tff(pred_def_12639,type,
    v23810: ( state_type * $int ) > $o ).

tff(pred_def_12640,type,
    v23557: ( state_type * $int ) > $o ).

tff(pred_def_12641,type,
    v23555: ( state_type * $int ) > $o ).

tff(pred_def_12642,type,
    v23553: ( state_type * $int ) > $o ).

tff(pred_def_12643,type,
    v23551: ( state_type * $int ) > $o ).

tff(pred_def_12644,type,
    v23549: ( state_type * $int ) > $o ).

tff(pred_def_12645,type,
    v23819: state_type > $o ).

tff(pred_def_12646,type,
    v23817: state_type > $o ).

tff(pred_def_12647,type,
    v23823: state_type > $o ).

tff(pred_def_12648,type,
    v23822: ( state_type * $int ) > $o ).

tff(pred_def_12649,type,
    v23821: ( state_type * $int ) > $o ).

tff(pred_def_12650,type,
    v23826: state_type > $o ).

tff(pred_def_12651,type,
    v23825: ( state_type * $int ) > $o ).

tff(pred_def_12652,type,
    v23824: ( state_type * $int ) > $o ).

tff(pred_def_12653,type,
    v23539: ( state_type * $int ) > $o ).

tff(pred_def_12654,type,
    v23537: ( state_type * $int ) > $o ).

tff(pred_def_12655,type,
    v23535: ( state_type * $int ) > $o ).

tff(pred_def_12656,type,
    v23533: ( state_type * $int ) > $o ).

tff(pred_def_12657,type,
    v23531: ( state_type * $int ) > $o ).

tff(pred_def_12658,type,
    v23507: ( state_type * $int ) > $o ).

tff(pred_def_12659,type,
    v23505: ( state_type * $int ) > $o ).

tff(pred_def_12660,type,
    v23503: ( state_type * $int ) > $o ).

tff(pred_def_12661,type,
    v23501: ( state_type * $int ) > $o ).

tff(pred_def_12662,type,
    v23499: ( state_type * $int ) > $o ).

tff(pred_def_12663,type,
    v23839: state_type > $o ).

tff(pred_def_12664,type,
    v23837: state_type > $o ).

tff(pred_def_12665,type,
    v23835: state_type > $o ).

tff(pred_def_12666,type,
    v23845: state_type > $o ).

tff(pred_def_12667,type,
    v23843: state_type > $o ).

tff(pred_def_12668,type,
    v23863: ( state_type * $int ) > $o ).

tff(pred_def_12669,type,
    v23865: ( state_type * $int ) > $o ).

tff(pred_def_12670,type,
    v23861: ( state_type * $int ) > $o ).

tff(pred_def_12671,type,
    v23859: state_type > $o ).

tff(pred_def_12672,type,
    v23857: state_type > $o ).

tff(pred_def_12673,type,
    v23869: state_type > $o ).

tff(pred_def_12674,type,
    v23867: state_type > $o ).

tff(pred_def_12675,type,
    v23873: state_type > $o ).

tff(pred_def_12676,type,
    v23871: state_type > $o ).

tff(pred_def_12677,type,
    v23876: state_type > $o ).

tff(pred_def_12678,type,
    v23875: state_type > $o ).

tff(pred_def_12679,type,
    v23855: state_type > $o ).

tff(pred_def_12680,type,
    v23853: state_type > $o ).

tff(pred_def_12681,type,
    v23851: state_type > $o ).

tff(pred_def_12682,type,
    v23849: state_type > $o ).

tff(pred_def_12683,type,
    v23847: state_type > $o ).

tff(pred_def_12684,type,
    v23884: state_type > $o ).

tff(pred_def_12685,type,
    v23882: state_type > $o ).

tff(pred_def_12686,type,
    v23880: state_type > $o ).

tff(pred_def_12687,type,
    v23878: state_type > $o ).

tff(pred_def_12688,type,
    v23841: state_type > $o ).

tff(pred_def_12689,type,
    v23890: state_type > $o ).

tff(pred_def_12690,type,
    v23892: state_type > $o ).

tff(pred_def_12691,type,
    v23888: state_type > $o ).

tff(pred_def_12692,type,
    v23887: state_type > $o ).

tff(pred_def_12693,type,
    v23898: state_type > $o ).

tff(pred_def_12694,type,
    v23899: state_type > $o ).

tff(pred_def_12695,type,
    v23895: state_type > $o ).

tff(pred_def_12696,type,
    v23897: state_type > $o ).

tff(pred_def_12697,type,
    v23909: state_type > $o ).

tff(pred_def_12698,type,
    v23907: state_type > $o ).

tff(pred_def_12699,type,
    v23905: state_type > $o ).

tff(pred_def_12700,type,
    v23903: state_type > $o ).

tff(pred_def_12701,type,
    v23911: state_type > $o ).

tff(pred_def_12702,type,
    v23833: state_type > $o ).

tff(pred_def_12703,type,
    v23831: state_type > $o ).

tff(pred_def_12704,type,
    v23829: state_type > $o ).

tff(pred_def_12705,type,
    v23918: state_type > $o ).

tff(pred_def_12706,type,
    v23916: state_type > $o ).

tff(pred_def_12707,type,
    v23915: state_type > $o ).

tff(pred_def_12708,type,
    v23914: state_type > $o ).

tff(pred_def_12709,type,
    v23926: state_type > $o ).

tff(pred_def_12710,type,
    v23927: state_type > $o ).

tff(pred_def_12711,type,
    v23925: state_type > $o ).

tff(pred_def_12712,type,
    v23922: ( state_type * $int ) > $o ).

tff(pred_def_12713,type,
    v23924: ( state_type * $int ) > $o ).

tff(pred_def_12714,type,
    v23469: ( state_type * $int ) > $o ).

tff(pred_def_12715,type,
    v23467: ( state_type * $int ) > $o ).

tff(pred_def_12716,type,
    v23465: ( state_type * $int ) > $o ).

tff(pred_def_12717,type,
    v23463: ( state_type * $int ) > $o ).

tff(pred_def_12718,type,
    v23461: ( state_type * $int ) > $o ).

tff(pred_def_12719,type,
    v23963: state_type > $o ).

tff(pred_def_12720,type,
    v23961: state_type > $o ).

tff(pred_def_12721,type,
    v23959: state_type > $o ).

tff(pred_def_12722,type,
    v23957: state_type > $o ).

tff(pred_def_12723,type,
    v23955: state_type > $o ).

tff(pred_def_12724,type,
    v23953: state_type > $o ).

tff(pred_def_12725,type,
    v23973: state_type > $o ).

tff(pred_def_12726,type,
    v23971: state_type > $o ).

tff(pred_def_12727,type,
    v23969: state_type > $o ).

tff(pred_def_12728,type,
    v23967: state_type > $o ).

tff(pred_def_12729,type,
    v23965: state_type > $o ).

tff(pred_def_12730,type,
    v24000: state_type > $o ).

tff(pred_def_12731,type,
    v23999: ( state_type * $int ) > $o ).

tff(pred_def_12732,type,
    v23998: ( state_type * $int ) > $o ).

tff(pred_def_12733,type,
    v23996: ( state_type * $int ) > $o ).

tff(pred_def_12734,type,
    v24016: state_type > $o ).

tff(pred_def_12735,type,
    v24017: ( state_type * $int ) > $o ).

tff(pred_def_12736,type,
    v24018: state_type > $o ).

tff(pred_def_12737,type,
    v24014: ( state_type * $int ) > $o ).

tff(pred_def_12738,type,
    v24012: ( state_type * $int ) > $o ).

tff(pred_def_12739,type,
    v24042: ( state_type * $int ) > $o ).

tff(pred_def_12740,type,
    v23951: ( state_type * $int ) > $o ).

tff(pred_def_12741,type,
    v24040: ( state_type * $int ) > $o ).

tff(pred_def_12742,type,
    v24043: ( state_type * $int ) > $o ).

tff(pred_def_12743,type,
    v24038: ( state_type * $int ) > $o ).

tff(pred_def_12744,type,
    v24036: ( state_type * $int ) > $o ).

tff(pred_def_12745,type,
    v24034: ( state_type * $int ) > $o ).

tff(pred_def_12746,type,
    v24032: state_type > $o ).

tff(pred_def_12747,type,
    v24030: state_type > $o ).

tff(pred_def_12748,type,
    v24049: state_type > $o ).

tff(pred_def_12749,type,
    v23989: state_type > $o ).

tff(pred_def_12750,type,
    v24048: ( state_type * $int ) > $o ).

tff(pred_def_12751,type,
    v23987: ( state_type * $int ) > $o ).

tff(pred_def_12752,type,
    v23985: ( state_type * $int ) > $o ).

tff(pred_def_12753,type,
    v24064: ( state_type * $int ) > $o ).

tff(pred_def_12754,type,
    v24063: ( state_type * $int ) > $o ).

tff(pred_def_12755,type,
    v24061: ( state_type * $int ) > $o ).

tff(pred_def_12756,type,
    v24068: state_type > $o ).

tff(pred_def_12757,type,
    v24066: state_type > $o ).

tff(pred_def_12758,type,
    v24079: ( state_type * $int ) > $o ).

tff(pred_def_12759,type,
    v24078: state_type > $o ).

tff(pred_def_12760,type,
    v24082: state_type > $o ).

tff(pred_def_12761,type,
    v24083: state_type > $o ).

tff(pred_def_12762,type,
    v24081: state_type > $o ).

tff(pred_def_12763,type,
    v24084: state_type > $o ).

tff(pred_def_12764,type,
    v24080: state_type > $o ).

tff(pred_def_12765,type,
    v24077: state_type > $o ).

tff(pred_def_12766,type,
    v24085: state_type > $o ).

tff(pred_def_12767,type,
    v24076: state_type > $o ).

tff(pred_def_12768,type,
    v24088: state_type > $o ).

tff(pred_def_12769,type,
    v24089: state_type > $o ).

tff(pred_def_12770,type,
    v24087: state_type > $o ).

tff(pred_def_12771,type,
    v24090: state_type > $o ).

tff(pred_def_12772,type,
    v24086: state_type > $o ).

tff(pred_def_12773,type,
    v24075: state_type > $o ).

tff(pred_def_12774,type,
    v24091: state_type > $o ).

tff(pred_def_12775,type,
    v24074: state_type > $o ).

tff(pred_def_12776,type,
    v24073: state_type > $o ).

tff(pred_def_12777,type,
    v24095: state_type > $o ).

tff(pred_def_12778,type,
    v24096: state_type > $o ).

tff(pred_def_12779,type,
    v24094: state_type > $o ).

tff(pred_def_12780,type,
    v24097: state_type > $o ).

tff(pred_def_12781,type,
    v24093: state_type > $o ).

tff(pred_def_12782,type,
    v24092: state_type > $o ).

tff(pred_def_12783,type,
    v24072: state_type > $o ).

tff(pred_def_12784,type,
    v24098: state_type > $o ).

tff(pred_def_12785,type,
    v24071: state_type > $o ).

tff(pred_def_12786,type,
    v24101: state_type > $o ).

tff(pred_def_12787,type,
    v24102: state_type > $o ).

tff(pred_def_12788,type,
    v24100: state_type > $o ).

tff(pred_def_12789,type,
    v24103: state_type > $o ).

tff(pred_def_12790,type,
    v24099: state_type > $o ).

tff(pred_def_12791,type,
    v24106: state_type > $o ).

tff(pred_def_12792,type,
    v24107: state_type > $o ).

tff(pred_def_12793,type,
    v24105: state_type > $o ).

tff(pred_def_12794,type,
    v24108: state_type > $o ).

tff(pred_def_12795,type,
    v24104: state_type > $o ).

tff(pred_def_12796,type,
    v24111: state_type > $o ).

tff(pred_def_12797,type,
    v24112: state_type > $o ).

tff(pred_def_12798,type,
    v24110: state_type > $o ).

tff(pred_def_12799,type,
    v24113: state_type > $o ).

tff(pred_def_12800,type,
    v24109: state_type > $o ).

tff(pred_def_12801,type,
    v24069: ( state_type * $int ) > $o ).

tff(pred_def_12802,type,
    v24059: ( state_type * $int ) > $o ).

tff(pred_def_12803,type,
    v24057: ( state_type * $int ) > $o ).

tff(pred_def_12804,type,
    v24055: ( state_type * $int ) > $o ).

tff(pred_def_12805,type,
    v24053: ( state_type * $int ) > $o ).

tff(pred_def_12806,type,
    v24051: ( state_type * $int ) > $o ).

tff(pred_def_12807,type,
    v24114: ( state_type * $int ) > $o ).

tff(pred_def_12808,type,
    v23983: ( state_type * $int ) > $o ).

tff(pred_def_12809,type,
    v23981: ( state_type * $int ) > $o ).

tff(pred_def_12810,type,
    v23979: ( state_type * $int ) > $o ).

tff(pred_def_12811,type,
    v24115: ( state_type * $int ) > $o ).

tff(pred_def_12812,type,
    v24116: ( state_type * $int ) > $o ).

tff(pred_def_12813,type,
    v23977: ( state_type * $int ) > $o ).

tff(pred_def_12814,type,
    v23975: ( state_type * $int ) > $o ).

tff(pred_def_12815,type,
    v24126: state_type > $o ).

tff(pred_def_12816,type,
    v24124: state_type > $o ).

tff(pred_def_12817,type,
    v24132: state_type > $o ).

tff(pred_def_12818,type,
    v24130: state_type > $o ).

tff(pred_def_12819,type,
    v24136: state_type > $o ).

tff(pred_def_12820,type,
    v24134: state_type > $o ).

tff(pred_def_12821,type,
    v24140: state_type > $o ).

tff(pred_def_12822,type,
    v24138: state_type > $o ).

tff(pred_def_12823,type,
    v24128: state_type > $o ).

tff(pred_def_12824,type,
    v24146: state_type > $o ).

tff(pred_def_12825,type,
    v24148: state_type > $o ).

tff(pred_def_12826,type,
    v24144: state_type > $o ).

tff(pred_def_12827,type,
    v24143: state_type > $o ).

tff(pred_def_12828,type,
    v24154: state_type > $o ).

tff(pred_def_12829,type,
    v24155: state_type > $o ).

tff(pred_def_12830,type,
    v24151: state_type > $o ).

tff(pred_def_12831,type,
    v24153: state_type > $o ).

tff(pred_def_12832,type,
    v24161: state_type > $o ).

tff(pred_def_12833,type,
    v24159: state_type > $o ).

tff(pred_def_12834,type,
    v24163: state_type > $o ).

tff(pred_def_12835,type,
    v24122: state_type > $o ).

tff(pred_def_12836,type,
    v24120: state_type > $o ).

tff(pred_def_12837,type,
    v24118: state_type > $o ).

tff(pred_def_12838,type,
    v24170: state_type > $o ).

tff(pred_def_12839,type,
    v24168: state_type > $o ).

tff(pred_def_12840,type,
    v24167: state_type > $o ).

tff(pred_def_12841,type,
    v24166: state_type > $o ).

tff(pred_def_12842,type,
    v24178: state_type > $o ).

tff(pred_def_12843,type,
    v24179: state_type > $o ).

tff(pred_def_12844,type,
    v24177: state_type > $o ).

tff(pred_def_12845,type,
    v24174: ( state_type * $int ) > $o ).

tff(pred_def_12846,type,
    v24176: ( state_type * $int ) > $o ).

tff(pred_def_12847,type,
    v24165: ( state_type * $int ) > $o ).

tff(pred_def_12848,type,
    v24047: state_type > $o ).

tff(pred_def_12849,type,
    v24045: state_type > $o ).

tff(pred_def_12850,type,
    v24191: state_type > $o ).

tff(pred_def_12851,type,
    v24189: state_type > $o ).

tff(pred_def_12852,type,
    v24188: state_type > $o ).

tff(pred_def_12853,type,
    v24187: ( state_type * $int ) > $o ).

tff(pred_def_12854,type,
    v24185: state_type > $o ).

tff(pred_def_12855,type,
    v24183: state_type > $o ).

tff(pred_def_12856,type,
    v24196: state_type > $o ).

tff(pred_def_12857,type,
    v24195: state_type > $o ).

tff(pred_def_12858,type,
    v24028: state_type > $o ).

tff(pred_def_12859,type,
    v24026: state_type > $o ).

tff(pred_def_12860,type,
    v24024: state_type > $o ).

tff(pred_def_12861,type,
    v24197: ( state_type * $int ) > $o ).

tff(pred_def_12862,type,
    v24198: state_type > $o ).

tff(pred_def_12863,type,
    v24022: ( state_type * $int ) > $o ).

tff(pred_def_12864,type,
    v24020: ( state_type * $int ) > $o ).

tff(pred_def_12865,type,
    v24199: ( state_type * $int ) > $o ).

tff(pred_def_12866,type,
    v24010: ( state_type * $int ) > $o ).

tff(pred_def_12867,type,
    v24008: ( state_type * $int ) > $o ).

tff(pred_def_12868,type,
    v24006: state_type > $o ).

tff(pred_def_12869,type,
    v24200: ( state_type * $int ) > $o ).

tff(pred_def_12870,type,
    v24201: state_type > $o ).

tff(pred_def_12871,type,
    v24004: ( state_type * $int ) > $o ).

tff(pred_def_12872,type,
    v24002: ( state_type * $int ) > $o ).

tff(pred_def_12873,type,
    v24202: ( state_type * $int ) > $o ).

tff(pred_def_12874,type,
    v23994: ( state_type * $int ) > $o ).

tff(pred_def_12875,type,
    v23992: ( state_type * $int ) > $o ).

tff(pred_def_12876,type,
    v24208: state_type > $o ).

tff(pred_def_12877,type,
    v24206: state_type > $o ).

tff(pred_def_12878,type,
    v24205: state_type > $o ).

tff(pred_def_12879,type,
    v24204: ( state_type * $int ) > $o ).

tff(pred_def_12880,type,
    v23949: state_type > $o ).

tff(pred_def_12881,type,
    v23947: state_type > $o ).

tff(pred_def_12882,type,
    v24214: state_type > $o ).

tff(pred_def_12883,type,
    v24212: state_type > $o ).

tff(pred_def_12884,type,
    v24218: state_type > $o ).

tff(pred_def_12885,type,
    v24216: state_type > $o ).

tff(pred_def_12886,type,
    v24221: state_type > $o ).

tff(pred_def_12887,type,
    v24220: state_type > $o ).

tff(pred_def_12888,type,
    v23945: state_type > $o ).

tff(pred_def_12889,type,
    v23943: state_type > $o ).

tff(pred_def_12890,type,
    v23941: state_type > $o ).

tff(pred_def_12891,type,
    v23939: state_type > $o ).

tff(pred_def_12892,type,
    v23937: state_type > $o ).

tff(pred_def_12893,type,
    v23935: state_type > $o ).

tff(pred_def_12894,type,
    v23933: state_type > $o ).

tff(pred_def_12895,type,
    v23931: state_type > $o ).

tff(pred_def_12896,type,
    v24241: state_type > $o ).

tff(pred_def_12897,type,
    v24239: state_type > $o ).

tff(pred_def_12898,type,
    v24237: state_type > $o ).

tff(pred_def_12899,type,
    v24235: state_type > $o ).

tff(pred_def_12900,type,
    v24233: state_type > $o ).

tff(pred_def_12901,type,
    v24251: state_type > $o ).

tff(pred_def_12902,type,
    v24249: state_type > $o ).

tff(pred_def_12903,type,
    v24247: state_type > $o ).

tff(pred_def_12904,type,
    v24245: state_type > $o ).

tff(pred_def_12905,type,
    v24243: state_type > $o ).

tff(pred_def_12906,type,
    v24255: ( state_type * $int ) > $o ).

tff(pred_def_12907,type,
    v24253: ( state_type * $int ) > $o ).

tff(pred_def_12908,type,
    v24265: state_type > $o ).

tff(pred_def_12909,type,
    v24263: state_type > $o ).

tff(pred_def_12910,type,
    v24271: state_type > $o ).

tff(pred_def_12911,type,
    v24269: state_type > $o ).

tff(pred_def_12912,type,
    v24295: ( state_type * $int ) > $o ).

tff(pred_def_12913,type,
    v24293: ( state_type * $int ) > $o ).

tff(pred_def_12914,type,
    v24296: ( state_type * $int ) > $o ).

tff(pred_def_12915,type,
    v24291: ( state_type * $int ) > $o ).

tff(pred_def_12916,type,
    v24289: ( state_type * $int ) > $o ).

tff(pred_def_12917,type,
    v24287: ( state_type * $int ) > $o ).

tff(pred_def_12918,type,
    v24285: state_type > $o ).

tff(pred_def_12919,type,
    v24283: state_type > $o ).

tff(pred_def_12920,type,
    v24300: state_type > $o ).

tff(pred_def_12921,type,
    v24298: state_type > $o ).

tff(pred_def_12922,type,
    v24304: state_type > $o ).

tff(pred_def_12923,type,
    v24302: state_type > $o ).

tff(pred_def_12924,type,
    v24307: state_type > $o ).

tff(pred_def_12925,type,
    v24306: state_type > $o ).

tff(pred_def_12926,type,
    v24281: state_type > $o ).

tff(pred_def_12927,type,
    v24279: state_type > $o ).

tff(pred_def_12928,type,
    v24277: state_type > $o ).

tff(pred_def_12929,type,
    v24275: state_type > $o ).

tff(pred_def_12930,type,
    v24273: state_type > $o ).

tff(pred_def_12931,type,
    v24311: state_type > $o ).

tff(pred_def_12932,type,
    v24309: state_type > $o ).

tff(pred_def_12933,type,
    v24267: state_type > $o ).

tff(pred_def_12934,type,
    v24317: state_type > $o ).

tff(pred_def_12935,type,
    v24319: state_type > $o ).

tff(pred_def_12936,type,
    v24315: state_type > $o ).

tff(pred_def_12937,type,
    v24314: state_type > $o ).

tff(pred_def_12938,type,
    v24325: state_type > $o ).

tff(pred_def_12939,type,
    v24326: state_type > $o ).

tff(pred_def_12940,type,
    v24322: state_type > $o ).

tff(pred_def_12941,type,
    v24324: state_type > $o ).

tff(pred_def_12942,type,
    v24332: state_type > $o ).

tff(pred_def_12943,type,
    v24330: state_type > $o ).

tff(pred_def_12944,type,
    v24334: state_type > $o ).

tff(pred_def_12945,type,
    v24261: state_type > $o ).

tff(pred_def_12946,type,
    v24259: state_type > $o ).

tff(pred_def_12947,type,
    v24257: state_type > $o ).

tff(pred_def_12948,type,
    v24341: state_type > $o ).

tff(pred_def_12949,type,
    v24339: state_type > $o ).

tff(pred_def_12950,type,
    v24338: state_type > $o ).

tff(pred_def_12951,type,
    v24337: state_type > $o ).

tff(pred_def_12952,type,
    v24349: state_type > $o ).

tff(pred_def_12953,type,
    v24350: state_type > $o ).

tff(pred_def_12954,type,
    v24348: state_type > $o ).

tff(pred_def_12955,type,
    v24345: ( state_type * $int ) > $o ).

tff(pred_def_12956,type,
    v24347: ( state_type * $int ) > $o ).

tff(pred_def_12957,type,
    v24231: ( state_type * $int ) > $o ).

tff(pred_def_12958,type,
    v24229: ( state_type * $int ) > $o ).

tff(pred_def_12959,type,
    v24227: ( state_type * $int ) > $o ).

tff(pred_def_12960,type,
    v24225: ( state_type * $int ) > $o ).

tff(pred_def_12961,type,
    v24223: ( state_type * $int ) > $o ).

tff(pred_def_12962,type,
    v24372: state_type > $o ).

tff(pred_def_12963,type,
    v24370: state_type > $o ).

tff(pred_def_12964,type,
    v24376: state_type > $o ).

tff(pred_def_12965,type,
    v24374: state_type > $o ).

tff(pred_def_12966,type,
    v24380: state_type > $o ).

tff(pred_def_12967,type,
    v24378: state_type > $o ).

tff(pred_def_12968,type,
    v24383: state_type > $o ).

tff(pred_def_12969,type,
    v24382: state_type > $o ).

tff(pred_def_12970,type,
    v24368: state_type > $o ).

tff(pred_def_12971,type,
    v24366: state_type > $o ).

tff(pred_def_12972,type,
    v24364: state_type > $o ).

tff(pred_def_12973,type,
    v24362: state_type > $o ).

tff(pred_def_12974,type,
    v24360: state_type > $o ).

tff(pred_def_12975,type,
    v24358: state_type > $o ).

tff(pred_def_12976,type,
    v24356: state_type > $o ).

tff(pred_def_12977,type,
    v24354: state_type > $o ).

tff(pred_def_12978,type,
    v24403: state_type > $o ).

tff(pred_def_12979,type,
    v24401: state_type > $o ).

tff(pred_def_12980,type,
    v24399: state_type > $o ).

tff(pred_def_12981,type,
    v24397: state_type > $o ).

tff(pred_def_12982,type,
    v24395: state_type > $o ).

tff(pred_def_12983,type,
    v24413: state_type > $o ).

tff(pred_def_12984,type,
    v24411: state_type > $o ).

tff(pred_def_12985,type,
    v24409: state_type > $o ).

tff(pred_def_12986,type,
    v24407: state_type > $o ).

tff(pred_def_12987,type,
    v24405: state_type > $o ).

tff(pred_def_12988,type,
    v24417: ( state_type * $int ) > $o ).

tff(pred_def_12989,type,
    v24415: ( state_type * $int ) > $o ).

tff(pred_def_12990,type,
    v24427: state_type > $o ).

tff(pred_def_12991,type,
    v24425: state_type > $o ).

tff(pred_def_12992,type,
    v24433: state_type > $o ).

tff(pred_def_12993,type,
    v24431: state_type > $o ).

tff(pred_def_12994,type,
    v24447: state_type > $o ).

tff(pred_def_12995,type,
    v24445: state_type > $o ).

tff(pred_def_12996,type,
    v24451: state_type > $o ).

tff(pred_def_12997,type,
    v24449: state_type > $o ).

tff(pred_def_12998,type,
    v24455: state_type > $o ).

tff(pred_def_12999,type,
    v24453: state_type > $o ).

tff(pred_def_13000,type,
    v24458: state_type > $o ).

tff(pred_def_13001,type,
    v24457: state_type > $o ).

tff(pred_def_13002,type,
    v24443: state_type > $o ).

tff(pred_def_13003,type,
    v24441: state_type > $o ).

tff(pred_def_13004,type,
    v24439: state_type > $o ).

tff(pred_def_13005,type,
    v24437: state_type > $o ).

tff(pred_def_13006,type,
    v24435: state_type > $o ).

tff(pred_def_13007,type,
    v24462: state_type > $o ).

tff(pred_def_13008,type,
    v24460: state_type > $o ).

tff(pred_def_13009,type,
    v24429: state_type > $o ).

tff(pred_def_13010,type,
    v24468: state_type > $o ).

tff(pred_def_13011,type,
    v24470: state_type > $o ).

tff(pred_def_13012,type,
    v24466: state_type > $o ).

tff(pred_def_13013,type,
    v24465: state_type > $o ).

tff(pred_def_13014,type,
    v24476: state_type > $o ).

tff(pred_def_13015,type,
    v24477: state_type > $o ).

tff(pred_def_13016,type,
    v24473: state_type > $o ).

tff(pred_def_13017,type,
    v24475: state_type > $o ).

tff(pred_def_13018,type,
    v24483: state_type > $o ).

tff(pred_def_13019,type,
    v24481: state_type > $o ).

tff(pred_def_13020,type,
    v24485: state_type > $o ).

tff(pred_def_13021,type,
    v24423: state_type > $o ).

tff(pred_def_13022,type,
    v24421: state_type > $o ).

tff(pred_def_13023,type,
    v24419: state_type > $o ).

tff(pred_def_13024,type,
    v24492: state_type > $o ).

tff(pred_def_13025,type,
    v24490: state_type > $o ).

tff(pred_def_13026,type,
    v24489: state_type > $o ).

tff(pred_def_13027,type,
    v24488: state_type > $o ).

tff(pred_def_13028,type,
    v24500: state_type > $o ).

tff(pred_def_13029,type,
    v24501: state_type > $o ).

tff(pred_def_13030,type,
    v24499: state_type > $o ).

tff(pred_def_13031,type,
    v24496: ( state_type * $int ) > $o ).

tff(pred_def_13032,type,
    v24498: ( state_type * $int ) > $o ).

tff(pred_def_13033,type,
    v24393: ( state_type * $int ) > $o ).

tff(pred_def_13034,type,
    v24391: ( state_type * $int ) > $o ).

tff(pred_def_13035,type,
    v24389: ( state_type * $int ) > $o ).

tff(pred_def_13036,type,
    v24387: ( state_type * $int ) > $o ).

tff(pred_def_13037,type,
    v24385: ( state_type * $int ) > $o ).

tff(pred_def_13038,type,
    v24523: state_type > $o ).

tff(pred_def_13039,type,
    v24521: state_type > $o ).

tff(pred_def_13040,type,
    v24527: state_type > $o ).

tff(pred_def_13041,type,
    v24525: state_type > $o ).

tff(pred_def_13042,type,
    v24531: state_type > $o ).

tff(pred_def_13043,type,
    v24529: state_type > $o ).

tff(pred_def_13044,type,
    v24534: state_type > $o ).

tff(pred_def_13045,type,
    v24533: state_type > $o ).

tff(pred_def_13046,type,
    v24519: state_type > $o ).

tff(pred_def_13047,type,
    v24517: state_type > $o ).

tff(pred_def_13048,type,
    v24515: state_type > $o ).

tff(pred_def_13049,type,
    v24513: state_type > $o ).

tff(pred_def_13050,type,
    v24511: state_type > $o ).

tff(pred_def_13051,type,
    v24509: state_type > $o ).

tff(pred_def_13052,type,
    v24507: state_type > $o ).

tff(pred_def_13053,type,
    v24505: state_type > $o ).

tff(pred_def_13054,type,
    v24554: state_type > $o ).

tff(pred_def_13055,type,
    v24552: state_type > $o ).

tff(pred_def_13056,type,
    v24550: state_type > $o ).

tff(pred_def_13057,type,
    v24548: state_type > $o ).

tff(pred_def_13058,type,
    v24546: state_type > $o ).

tff(pred_def_13059,type,
    v24564: state_type > $o ).

tff(pred_def_13060,type,
    v24562: state_type > $o ).

tff(pred_def_13061,type,
    v24560: state_type > $o ).

tff(pred_def_13062,type,
    v24558: state_type > $o ).

tff(pred_def_13063,type,
    v24556: state_type > $o ).

tff(pred_def_13064,type,
    v24568: ( state_type * $int ) > $o ).

tff(pred_def_13065,type,
    v24566: ( state_type * $int ) > $o ).

tff(pred_def_13066,type,
    v24578: state_type > $o ).

tff(pred_def_13067,type,
    v24576: state_type > $o ).

tff(pred_def_13068,type,
    v24584: state_type > $o ).

tff(pred_def_13069,type,
    v24582: state_type > $o ).

tff(pred_def_13070,type,
    v24598: state_type > $o ).

tff(pred_def_13071,type,
    v24596: state_type > $o ).

tff(pred_def_13072,type,
    v24602: state_type > $o ).

tff(pred_def_13073,type,
    v24600: state_type > $o ).

tff(pred_def_13074,type,
    v24606: state_type > $o ).

tff(pred_def_13075,type,
    v24604: state_type > $o ).

tff(pred_def_13076,type,
    v24609: state_type > $o ).

tff(pred_def_13077,type,
    v24608: state_type > $o ).

tff(pred_def_13078,type,
    v24594: state_type > $o ).

tff(pred_def_13079,type,
    v24592: state_type > $o ).

tff(pred_def_13080,type,
    v24590: state_type > $o ).

tff(pred_def_13081,type,
    v24588: state_type > $o ).

tff(pred_def_13082,type,
    v24586: state_type > $o ).

tff(pred_def_13083,type,
    v24613: state_type > $o ).

tff(pred_def_13084,type,
    v24611: state_type > $o ).

tff(pred_def_13085,type,
    v24580: state_type > $o ).

tff(pred_def_13086,type,
    v24619: state_type > $o ).

tff(pred_def_13087,type,
    v24621: state_type > $o ).

tff(pred_def_13088,type,
    v24617: state_type > $o ).

tff(pred_def_13089,type,
    v24616: state_type > $o ).

tff(pred_def_13090,type,
    v24627: state_type > $o ).

tff(pred_def_13091,type,
    v24628: state_type > $o ).

tff(pred_def_13092,type,
    v24624: state_type > $o ).

tff(pred_def_13093,type,
    v24626: state_type > $o ).

tff(pred_def_13094,type,
    v24634: state_type > $o ).

tff(pred_def_13095,type,
    v24632: state_type > $o ).

tff(pred_def_13096,type,
    v24636: state_type > $o ).

tff(pred_def_13097,type,
    v24574: state_type > $o ).

tff(pred_def_13098,type,
    v24572: state_type > $o ).

tff(pred_def_13099,type,
    v24570: state_type > $o ).

tff(pred_def_13100,type,
    v24643: state_type > $o ).

tff(pred_def_13101,type,
    v24641: state_type > $o ).

tff(pred_def_13102,type,
    v24640: state_type > $o ).

tff(pred_def_13103,type,
    v24639: state_type > $o ).

tff(pred_def_13104,type,
    v24651: state_type > $o ).

tff(pred_def_13105,type,
    v24652: state_type > $o ).

tff(pred_def_13106,type,
    v24650: state_type > $o ).

tff(pred_def_13107,type,
    v24647: ( state_type * $int ) > $o ).

tff(pred_def_13108,type,
    v24649: ( state_type * $int ) > $o ).

tff(pred_def_13109,type,
    v24544: ( state_type * $int ) > $o ).

tff(pred_def_13110,type,
    v24542: ( state_type * $int ) > $o ).

tff(pred_def_13111,type,
    v24540: ( state_type * $int ) > $o ).

tff(pred_def_13112,type,
    v24538: ( state_type * $int ) > $o ).

tff(pred_def_13113,type,
    v24536: ( state_type * $int ) > $o ).

tff(pred_def_13114,type,
    v24674: state_type > $o ).

tff(pred_def_13115,type,
    v24672: state_type > $o ).

tff(pred_def_13116,type,
    v24678: state_type > $o ).

tff(pred_def_13117,type,
    v24676: state_type > $o ).

tff(pred_def_13118,type,
    v24682: state_type > $o ).

tff(pred_def_13119,type,
    v24680: state_type > $o ).

tff(pred_def_13120,type,
    v24685: state_type > $o ).

tff(pred_def_13121,type,
    v24684: state_type > $o ).

tff(pred_def_13122,type,
    v24670: state_type > $o ).

tff(pred_def_13123,type,
    v24668: state_type > $o ).

tff(pred_def_13124,type,
    v24666: state_type > $o ).

tff(pred_def_13125,type,
    v24664: state_type > $o ).

tff(pred_def_13126,type,
    v24662: state_type > $o ).

tff(pred_def_13127,type,
    v24660: state_type > $o ).

tff(pred_def_13128,type,
    v24658: state_type > $o ).

tff(pred_def_13129,type,
    v24656: state_type > $o ).

tff(pred_def_13130,type,
    v24705: state_type > $o ).

tff(pred_def_13131,type,
    v24703: state_type > $o ).

tff(pred_def_13132,type,
    v24701: state_type > $o ).

tff(pred_def_13133,type,
    v24699: state_type > $o ).

tff(pred_def_13134,type,
    v24697: state_type > $o ).

tff(pred_def_13135,type,
    v24715: state_type > $o ).

tff(pred_def_13136,type,
    v24713: state_type > $o ).

tff(pred_def_13137,type,
    v24711: state_type > $o ).

tff(pred_def_13138,type,
    v24709: state_type > $o ).

tff(pred_def_13139,type,
    v24707: state_type > $o ).

tff(pred_def_13140,type,
    v24719: ( state_type * $int ) > $o ).

tff(pred_def_13141,type,
    v24717: ( state_type * $int ) > $o ).

tff(pred_def_13142,type,
    v24729: state_type > $o ).

tff(pred_def_13143,type,
    v24727: state_type > $o ).

tff(pred_def_13144,type,
    v24735: state_type > $o ).

tff(pred_def_13145,type,
    v24733: state_type > $o ).

tff(pred_def_13146,type,
    v24749: state_type > $o ).

tff(pred_def_13147,type,
    v24747: state_type > $o ).

tff(pred_def_13148,type,
    v24753: state_type > $o ).

tff(pred_def_13149,type,
    v24751: state_type > $o ).

tff(pred_def_13150,type,
    v24757: state_type > $o ).

tff(pred_def_13151,type,
    v24755: state_type > $o ).

tff(pred_def_13152,type,
    v24760: state_type > $o ).

tff(pred_def_13153,type,
    v24759: state_type > $o ).

tff(pred_def_13154,type,
    v24745: state_type > $o ).

tff(pred_def_13155,type,
    v24743: state_type > $o ).

tff(pred_def_13156,type,
    v24741: state_type > $o ).

tff(pred_def_13157,type,
    v24739: state_type > $o ).

tff(pred_def_13158,type,
    v24737: state_type > $o ).

tff(pred_def_13159,type,
    v24764: state_type > $o ).

tff(pred_def_13160,type,
    v24762: state_type > $o ).

tff(pred_def_13161,type,
    v24731: state_type > $o ).

tff(pred_def_13162,type,
    v24770: state_type > $o ).

tff(pred_def_13163,type,
    v24772: state_type > $o ).

tff(pred_def_13164,type,
    v24768: state_type > $o ).

tff(pred_def_13165,type,
    v24767: state_type > $o ).

tff(pred_def_13166,type,
    v24778: state_type > $o ).

tff(pred_def_13167,type,
    v24779: state_type > $o ).

tff(pred_def_13168,type,
    v24775: state_type > $o ).

tff(pred_def_13169,type,
    v24777: state_type > $o ).

tff(pred_def_13170,type,
    v24785: state_type > $o ).

tff(pred_def_13171,type,
    v24783: state_type > $o ).

tff(pred_def_13172,type,
    v24787: state_type > $o ).

tff(pred_def_13173,type,
    v24725: state_type > $o ).

tff(pred_def_13174,type,
    v24723: state_type > $o ).

tff(pred_def_13175,type,
    v24721: state_type > $o ).

tff(pred_def_13176,type,
    v24794: state_type > $o ).

tff(pred_def_13177,type,
    v24792: state_type > $o ).

tff(pred_def_13178,type,
    v24791: state_type > $o ).

tff(pred_def_13179,type,
    v24790: state_type > $o ).

tff(pred_def_13180,type,
    v24802: state_type > $o ).

tff(pred_def_13181,type,
    v24803: state_type > $o ).

tff(pred_def_13182,type,
    v24801: state_type > $o ).

tff(pred_def_13183,type,
    v24798: ( state_type * $int ) > $o ).

tff(pred_def_13184,type,
    v24800: ( state_type * $int ) > $o ).

tff(pred_def_13185,type,
    v24695: ( state_type * $int ) > $o ).

tff(pred_def_13186,type,
    v24693: ( state_type * $int ) > $o ).

tff(pred_def_13187,type,
    v24691: ( state_type * $int ) > $o ).

tff(pred_def_13188,type,
    v24689: ( state_type * $int ) > $o ).

tff(pred_def_13189,type,
    v24687: ( state_type * $int ) > $o ).

tff(pred_def_13190,type,
    v24825: state_type > $o ).

tff(pred_def_13191,type,
    v24823: state_type > $o ).

tff(pred_def_13192,type,
    v24829: state_type > $o ).

tff(pred_def_13193,type,
    v24827: state_type > $o ).

tff(pred_def_13194,type,
    v24833: state_type > $o ).

tff(pred_def_13195,type,
    v24831: state_type > $o ).

tff(pred_def_13196,type,
    v24836: state_type > $o ).

tff(pred_def_13197,type,
    v24835: state_type > $o ).

tff(pred_def_13198,type,
    v24821: state_type > $o ).

tff(pred_def_13199,type,
    v24819: state_type > $o ).

tff(pred_def_13200,type,
    v24817: state_type > $o ).

tff(pred_def_13201,type,
    v24815: state_type > $o ).

tff(pred_def_13202,type,
    v24813: state_type > $o ).

tff(pred_def_13203,type,
    v24811: state_type > $o ).

tff(pred_def_13204,type,
    v24809: state_type > $o ).

tff(pred_def_13205,type,
    v24807: state_type > $o ).

tff(pred_def_13206,type,
    v24856: state_type > $o ).

tff(pred_def_13207,type,
    v24854: state_type > $o ).

tff(pred_def_13208,type,
    v24852: state_type > $o ).

tff(pred_def_13209,type,
    v24850: state_type > $o ).

tff(pred_def_13210,type,
    v24848: state_type > $o ).

tff(pred_def_13211,type,
    v24866: state_type > $o ).

tff(pred_def_13212,type,
    v24864: state_type > $o ).

tff(pred_def_13213,type,
    v24862: state_type > $o ).

tff(pred_def_13214,type,
    v24860: state_type > $o ).

tff(pred_def_13215,type,
    v24858: state_type > $o ).

tff(pred_def_13216,type,
    v24870: ( state_type * $int ) > $o ).

tff(pred_def_13217,type,
    v24868: ( state_type * $int ) > $o ).

tff(pred_def_13218,type,
    v24880: state_type > $o ).

tff(pred_def_13219,type,
    v24878: state_type > $o ).

tff(pred_def_13220,type,
    v24886: state_type > $o ).

tff(pred_def_13221,type,
    v24884: state_type > $o ).

tff(pred_def_13222,type,
    v24899: state_type > $o ).

tff(pred_def_13223,type,
    v24897: state_type > $o ).

tff(pred_def_13224,type,
    v24903: state_type > $o ).

tff(pred_def_13225,type,
    v24901: state_type > $o ).

tff(pred_def_13226,type,
    v24907: state_type > $o ).

tff(pred_def_13227,type,
    v24905: state_type > $o ).

tff(pred_def_13228,type,
    v24910: state_type > $o ).

tff(pred_def_13229,type,
    v24909: state_type > $o ).

tff(pred_def_13230,type,
    v24895: state_type > $o ).

tff(pred_def_13231,type,
    v24893: state_type > $o ).

tff(pred_def_13232,type,
    v24890: state_type > $o ).

tff(pred_def_13233,type,
    v24888: state_type > $o ).

tff(pred_def_13234,type,
    v24914: state_type > $o ).

tff(pred_def_13235,type,
    v24912: state_type > $o ).

tff(pred_def_13236,type,
    v24882: state_type > $o ).

tff(pred_def_13237,type,
    v24920: state_type > $o ).

tff(pred_def_13238,type,
    v24922: state_type > $o ).

tff(pred_def_13239,type,
    v24918: state_type > $o ).

tff(pred_def_13240,type,
    v24917: state_type > $o ).

tff(pred_def_13241,type,
    v24928: state_type > $o ).

tff(pred_def_13242,type,
    v24929: state_type > $o ).

tff(pred_def_13243,type,
    v24925: state_type > $o ).

tff(pred_def_13244,type,
    v24927: state_type > $o ).

tff(pred_def_13245,type,
    v24935: state_type > $o ).

tff(pred_def_13246,type,
    v24933: state_type > $o ).

tff(pred_def_13247,type,
    v24937: state_type > $o ).

tff(pred_def_13248,type,
    v24876: state_type > $o ).

tff(pred_def_13249,type,
    v24874: state_type > $o ).

tff(pred_def_13250,type,
    v24872: state_type > $o ).

tff(pred_def_13251,type,
    v24944: state_type > $o ).

tff(pred_def_13252,type,
    v24942: state_type > $o ).

tff(pred_def_13253,type,
    v24941: state_type > $o ).

tff(pred_def_13254,type,
    v24940: state_type > $o ).

tff(pred_def_13255,type,
    v24952: state_type > $o ).

tff(pred_def_13256,type,
    v24953: state_type > $o ).

tff(pred_def_13257,type,
    v24951: state_type > $o ).

tff(pred_def_13258,type,
    v24948: ( state_type * $int ) > $o ).

tff(pred_def_13259,type,
    v24950: ( state_type * $int ) > $o ).

tff(pred_def_13260,type,
    v24846: ( state_type * $int ) > $o ).

tff(pred_def_13261,type,
    v24844: ( state_type * $int ) > $o ).

tff(pred_def_13262,type,
    v24842: ( state_type * $int ) > $o ).

tff(pred_def_13263,type,
    v24840: ( state_type * $int ) > $o ).

tff(pred_def_13264,type,
    v24838: ( state_type * $int ) > $o ).

tff(pred_def_13265,type,
    v24965: state_type > $o ).

tff(pred_def_13266,type,
    v24963: state_type > $o ).

tff(pred_def_13267,type,
    v24961: state_type > $o ).

tff(pred_def_13268,type,
    v24959: state_type > $o ).

tff(pred_def_13269,type,
    v24957: state_type > $o ).

tff(pred_def_13270,type,
    v24973: state_type > $o ).

tff(pred_def_13271,type,
    v24972: ( state_type * $int ) > $o ).

tff(pred_def_13272,type,
    v24971: ( state_type * $int ) > $o ).

tff(pred_def_13273,type,
    v24976: state_type > $o ).

tff(pred_def_13274,type,
    v24975: ( state_type * $int ) > $o ).

tff(pred_def_13275,type,
    v24974: ( state_type * $int ) > $o ).

tff(pred_def_13276,type,
    v24970: ( state_type * $int ) > $o ).

tff(pred_def_13277,type,
    v24979: state_type > $o ).

tff(pred_def_13278,type,
    v24978: ( state_type * $int ) > $o ).

tff(pred_def_13279,type,
    v24977: ( state_type * $int ) > $o ).

tff(pred_def_13280,type,
    v24969: ( state_type * $int ) > $o ).

tff(pred_def_13281,type,
    v24982: state_type > $o ).

tff(pred_def_13282,type,
    v24981: ( state_type * $int ) > $o ).

tff(pred_def_13283,type,
    v24980: ( state_type * $int ) > $o ).

tff(pred_def_13284,type,
    v24968: ( state_type * $int ) > $o ).

tff(pred_def_13285,type,
    v24985: state_type > $o ).

tff(pred_def_13286,type,
    v24984: ( state_type * $int ) > $o ).

tff(pred_def_13287,type,
    v24983: ( state_type * $int ) > $o ).

tff(pred_def_13288,type,
    v24967: ( state_type * $int ) > $o ).

tff(pred_def_13289,type,
    v24988: state_type > $o ).

tff(pred_def_13290,type,
    v24987: ( state_type * $int ) > $o ).

tff(pred_def_13291,type,
    v24986: ( state_type * $int ) > $o ).

tff(pred_def_13292,type,
    v23459: ( state_type * $int ) > $o ).

tff(pred_def_13293,type,
    v23457: ( state_type * $int ) > $o ).

tff(pred_def_13294,type,
    v23455: ( state_type * $int ) > $o ).

tff(pred_def_13295,type,
    v23453: ( state_type * $int ) > $o ).

tff(pred_def_13296,type,
    v23451: ( state_type * $int ) > $o ).

tff(pred_def_13297,type,
    v23445: state_type > $o ).

tff(pred_def_13298,type,
    v23443: state_type > $o ).

tff(pred_def_13299,type,
    v23441: state_type > $o ).

tff(pred_def_13300,type,
    v24999: ( state_type * $int ) > $o ).

tff(pred_def_13301,type,
    v24997: ( state_type * $int ) > $o ).

tff(pred_def_13302,type,
    v25033: state_type > $o ).

tff(pred_def_13303,type,
    v25031: state_type > $o ).

tff(pred_def_13304,type,
    v25029: state_type > $o ).

tff(pred_def_13305,type,
    v25027: state_type > $o ).

tff(pred_def_13306,type,
    v25025: state_type > $o ).

tff(pred_def_13307,type,
    v25023: state_type > $o ).

tff(pred_def_13308,type,
    v25021: state_type > $o ).

tff(pred_def_13309,type,
    v25047: state_type > $o ).

tff(pred_def_13310,type,
    v25045: state_type > $o ).

tff(pred_def_13311,type,
    v25043: state_type > $o ).

tff(pred_def_13312,type,
    v25041: state_type > $o ).

tff(pred_def_13313,type,
    v25039: state_type > $o ).

tff(pred_def_13314,type,
    v25037: state_type > $o ).

tff(pred_def_13315,type,
    v25035: state_type > $o ).

tff(pred_def_13316,type,
    v25073: state_type > $o ).

tff(pred_def_13317,type,
    v25075: state_type > $o ).

tff(pred_def_13318,type,
    v25074: ( state_type * $int ) > $o ).

tff(pred_def_13319,type,
    v25076: state_type > $o ).

tff(pred_def_13320,type,
    v25071: ( state_type * $int ) > $o ).

tff(pred_def_13321,type,
    v25069: ( state_type * $int ) > $o ).

tff(pred_def_13322,type,
    v25077: ( state_type * $int ) > $o ).

tff(pred_def_13323,type,
    v25067: ( state_type * $int ) > $o ).

tff(pred_def_13324,type,
    v25065: ( state_type * $int ) > $o ).

tff(pred_def_13325,type,
    v25063: state_type > $o ).

tff(pred_def_13326,type,
    v25079: state_type > $o ).

tff(pred_def_13327,type,
    v25061: ( state_type * $int ) > $o ).

tff(pred_def_13328,type,
    v25059: ( state_type * $int ) > $o ).

tff(pred_def_13329,type,
    v25093: ( state_type * $int ) > $o ).

tff(pred_def_13330,type,
    v25091: ( state_type * $int ) > $o ).

tff(pred_def_13331,type,
    v25097: state_type > $o ).

tff(pred_def_13332,type,
    v25095: state_type > $o ).

tff(pred_def_13333,type,
    v25121: state_type > $o ).

tff(pred_def_13334,type,
    v25119: state_type > $o ).

tff(pred_def_13335,type,
    v25117: state_type > $o ).

tff(pred_def_13336,type,
    v25115: state_type > $o ).

tff(pred_def_13337,type,
    v25113: state_type > $o ).

tff(pred_def_13338,type,
    v25111: state_type > $o ).

tff(pred_def_13339,type,
    v25109: state_type > $o ).

tff(pred_def_13340,type,
    v25135: state_type > $o ).

tff(pred_def_13341,type,
    v25133: state_type > $o ).

tff(pred_def_13342,type,
    v25131: state_type > $o ).

tff(pred_def_13343,type,
    v25129: state_type > $o ).

tff(pred_def_13344,type,
    v25127: state_type > $o ).

tff(pred_def_13345,type,
    v25125: state_type > $o ).

tff(pred_def_13346,type,
    v25123: state_type > $o ).

tff(pred_def_13347,type,
    v25151: ( state_type * $int ) > $o ).

tff(pred_def_13348,type,
    v25149: ( state_type * $int ) > $o ).

tff(pred_def_13349,type,
    v25147: ( state_type * $int ) > $o ).

tff(pred_def_13350,type,
    v25145: ( state_type * $int ) > $o ).

tff(pred_def_13351,type,
    v25143: ( state_type * $int ) > $o ).

tff(pred_def_13352,type,
    v25181: ( state_type * $int ) > $o ).

tff(pred_def_13353,type,
    v25183: ( state_type * $int ) > $o ).

tff(pred_def_13354,type,
    v25179: ( state_type * $int ) > $o ).

tff(pred_def_13355,type,
    v25177: ( state_type * $int ) > $o ).

tff(pred_def_13356,type,
    v25175: ( state_type * $int ) > $o ).

tff(pred_def_13357,type,
    v25173: ( state_type * $int ) > $o ).

tff(pred_def_13358,type,
    v25171: state_type > $o ).

tff(pred_def_13359,type,
    v25169: state_type > $o ).

tff(pred_def_13360,type,
    v25187: state_type > $o ).

tff(pred_def_13361,type,
    v25185: state_type > $o ).

tff(pred_def_13362,type,
    v25189: state_type > $o ).

tff(pred_def_13363,type,
    v25167: state_type > $o ).

tff(pred_def_13364,type,
    v25165: state_type > $o ).

tff(pred_def_13365,type,
    v25163: state_type > $o ).

tff(pred_def_13366,type,
    v25161: state_type > $o ).

tff(pred_def_13367,type,
    v25159: state_type > $o ).

tff(pred_def_13368,type,
    v25157: state_type > $o ).

tff(pred_def_13369,type,
    v25155: state_type > $o ).

tff(pred_def_13370,type,
    v25153: state_type > $o ).

tff(pred_def_13371,type,
    v25199: ( state_type * $int ) > $o ).

tff(pred_def_13372,type,
    v25197: ( state_type * $int ) > $o ).

tff(pred_def_13373,type,
    v25195: ( state_type * $int ) > $o ).

tff(pred_def_13374,type,
    v25193: ( state_type * $int ) > $o ).

tff(pred_def_13375,type,
    v25191: ( state_type * $int ) > $o ).

tff(pred_def_13376,type,
    v25229: ( state_type * $int ) > $o ).

tff(pred_def_13377,type,
    v25227: ( state_type * $int ) > $o ).

tff(pred_def_13378,type,
    v25230: ( state_type * $int ) > $o ).

tff(pred_def_13379,type,
    v25225: ( state_type * $int ) > $o ).

tff(pred_def_13380,type,
    v25223: ( state_type * $int ) > $o ).

tff(pred_def_13381,type,
    v25221: ( state_type * $int ) > $o ).

tff(pred_def_13382,type,
    v25219: state_type > $o ).

tff(pred_def_13383,type,
    v25217: state_type > $o ).

tff(pred_def_13384,type,
    v25234: state_type > $o ).

tff(pred_def_13385,type,
    v25232: state_type > $o ).

tff(pred_def_13386,type,
    v25236: state_type > $o ).

tff(pred_def_13387,type,
    v25215: state_type > $o ).

tff(pred_def_13388,type,
    v25213: state_type > $o ).

tff(pred_def_13389,type,
    v25211: state_type > $o ).

tff(pred_def_13390,type,
    v25209: state_type > $o ).

tff(pred_def_13391,type,
    v25207: state_type > $o ).

tff(pred_def_13392,type,
    v25205: state_type > $o ).

tff(pred_def_13393,type,
    v25203: state_type > $o ).

tff(pred_def_13394,type,
    v25201: state_type > $o ).

tff(pred_def_13395,type,
    v25246: ( state_type * $int ) > $o ).

tff(pred_def_13396,type,
    v25244: ( state_type * $int ) > $o ).

tff(pred_def_13397,type,
    v25242: ( state_type * $int ) > $o ).

tff(pred_def_13398,type,
    v25240: ( state_type * $int ) > $o ).

tff(pred_def_13399,type,
    v25238: ( state_type * $int ) > $o ).

tff(pred_def_13400,type,
    v25266: state_type > $o ).

tff(pred_def_13401,type,
    v25264: state_type > $o ).

tff(pred_def_13402,type,
    v25270: state_type > $o ).

tff(pred_def_13403,type,
    v25268: state_type > $o ).

tff(pred_def_13404,type,
    v25272: state_type > $o ).

tff(pred_def_13405,type,
    v25262: state_type > $o ).

tff(pred_def_13406,type,
    v25260: state_type > $o ).

tff(pred_def_13407,type,
    v25258: state_type > $o ).

tff(pred_def_13408,type,
    v25256: state_type > $o ).

tff(pred_def_13409,type,
    v25254: state_type > $o ).

tff(pred_def_13410,type,
    v25252: state_type > $o ).

tff(pred_def_13411,type,
    v25250: state_type > $o ).

tff(pred_def_13412,type,
    v25248: state_type > $o ).

tff(pred_def_13413,type,
    v25282: ( state_type * $int ) > $o ).

tff(pred_def_13414,type,
    v25280: ( state_type * $int ) > $o ).

tff(pred_def_13415,type,
    v25278: ( state_type * $int ) > $o ).

tff(pred_def_13416,type,
    v25276: ( state_type * $int ) > $o ).

tff(pred_def_13417,type,
    v25274: ( state_type * $int ) > $o ).

tff(pred_def_13418,type,
    v25302: state_type > $o ).

tff(pred_def_13419,type,
    v25300: state_type > $o ).

tff(pred_def_13420,type,
    v25306: state_type > $o ).

tff(pred_def_13421,type,
    v25304: state_type > $o ).

tff(pred_def_13422,type,
    v25308: state_type > $o ).

tff(pred_def_13423,type,
    v25298: state_type > $o ).

tff(pred_def_13424,type,
    v25296: state_type > $o ).

tff(pred_def_13425,type,
    v25294: state_type > $o ).

tff(pred_def_13426,type,
    v25292: state_type > $o ).

tff(pred_def_13427,type,
    v25290: state_type > $o ).

tff(pred_def_13428,type,
    v25288: state_type > $o ).

tff(pred_def_13429,type,
    v25286: state_type > $o ).

tff(pred_def_13430,type,
    v25284: state_type > $o ).

tff(pred_def_13431,type,
    v25314: state_type > $o ).

tff(pred_def_13432,type,
    v25313: ( state_type * $int ) > $o ).

tff(pred_def_13433,type,
    v25312: ( state_type * $int ) > $o ).

tff(pred_def_13434,type,
    v25317: state_type > $o ).

tff(pred_def_13435,type,
    v25316: ( state_type * $int ) > $o ).

tff(pred_def_13436,type,
    v25315: ( state_type * $int ) > $o ).

tff(pred_def_13437,type,
    v25311: ( state_type * $int ) > $o ).

tff(pred_def_13438,type,
    v25320: state_type > $o ).

tff(pred_def_13439,type,
    v25319: ( state_type * $int ) > $o ).

tff(pred_def_13440,type,
    v25318: ( state_type * $int ) > $o ).

tff(pred_def_13441,type,
    v25310: ( state_type * $int ) > $o ).

tff(pred_def_13442,type,
    v25323: state_type > $o ).

tff(pred_def_13443,type,
    v25322: ( state_type * $int ) > $o ).

tff(pred_def_13444,type,
    v25321: ( state_type * $int ) > $o ).

tff(pred_def_13445,type,
    v25141: ( state_type * $int ) > $o ).

tff(pred_def_13446,type,
    v25139: ( state_type * $int ) > $o ).

tff(pred_def_13447,type,
    v25137: ( state_type * $int ) > $o ).

tff(pred_def_13448,type,
    v25335: state_type > $o ).

tff(pred_def_13449,type,
    v25333: state_type > $o ).

tff(pred_def_13450,type,
    v25331: state_type > $o ).

tff(pred_def_13451,type,
    v25345: state_type > $o ).

tff(pred_def_13452,type,
    v25343: state_type > $o ).

tff(pred_def_13453,type,
    v25341: state_type > $o ).

tff(pred_def_13454,type,
    v25339: state_type > $o ).

tff(pred_def_13455,type,
    v25337: state_type > $o ).

tff(pred_def_13456,type,
    v25347: state_type > $o ).

tff(pred_def_13457,type,
    v25329: state_type > $o ).

tff(pred_def_13458,type,
    v25327: state_type > $o ).

tff(pred_def_13459,type,
    v25325: state_type > $o ).

tff(pred_def_13460,type,
    v25354: state_type > $o ).

tff(pred_def_13461,type,
    v25352: state_type > $o ).

tff(pred_def_13462,type,
    v25351: state_type > $o ).

tff(pred_def_13463,type,
    v25350: state_type > $o ).

tff(pred_def_13464,type,
    v25362: state_type > $o ).

tff(pred_def_13465,type,
    v25363: state_type > $o ).

tff(pred_def_13466,type,
    v25361: state_type > $o ).

tff(pred_def_13467,type,
    v25358: ( state_type * $int ) > $o ).

tff(pred_def_13468,type,
    v25360: ( state_type * $int ) > $o ).

tff(pred_def_13469,type,
    v25107: ( state_type * $int ) > $o ).

tff(pred_def_13470,type,
    v25105: ( state_type * $int ) > $o ).

tff(pred_def_13471,type,
    v25103: ( state_type * $int ) > $o ).

tff(pred_def_13472,type,
    v25101: ( state_type * $int ) > $o ).

tff(pred_def_13473,type,
    v25099: ( state_type * $int ) > $o ).

tff(pred_def_13474,type,
    v25369: state_type > $o ).

tff(pred_def_13475,type,
    v25367: state_type > $o ).

tff(pred_def_13476,type,
    v25373: state_type > $o ).

tff(pred_def_13477,type,
    v25372: ( state_type * $int ) > $o ).

tff(pred_def_13478,type,
    v25371: ( state_type * $int ) > $o ).

tff(pred_def_13479,type,
    v25376: state_type > $o ).

tff(pred_def_13480,type,
    v25375: ( state_type * $int ) > $o ).

tff(pred_def_13481,type,
    v25374: ( state_type * $int ) > $o ).

tff(pred_def_13482,type,
    v25089: ( state_type * $int ) > $o ).

tff(pred_def_13483,type,
    v25087: ( state_type * $int ) > $o ).

tff(pred_def_13484,type,
    v25085: ( state_type * $int ) > $o ).

tff(pred_def_13485,type,
    v25083: ( state_type * $int ) > $o ).

tff(pred_def_13486,type,
    v25081: ( state_type * $int ) > $o ).

tff(pred_def_13487,type,
    v25057: ( state_type * $int ) > $o ).

tff(pred_def_13488,type,
    v25055: ( state_type * $int ) > $o ).

tff(pred_def_13489,type,
    v25053: ( state_type * $int ) > $o ).

tff(pred_def_13490,type,
    v25051: ( state_type * $int ) > $o ).

tff(pred_def_13491,type,
    v25049: ( state_type * $int ) > $o ).

tff(pred_def_13492,type,
    v25389: state_type > $o ).

tff(pred_def_13493,type,
    v25387: state_type > $o ).

tff(pred_def_13494,type,
    v25385: state_type > $o ).

tff(pred_def_13495,type,
    v25395: state_type > $o ).

tff(pred_def_13496,type,
    v25393: state_type > $o ).

tff(pred_def_13497,type,
    v25413: ( state_type * $int ) > $o ).

tff(pred_def_13498,type,
    v25415: ( state_type * $int ) > $o ).

tff(pred_def_13499,type,
    v25411: ( state_type * $int ) > $o ).

tff(pred_def_13500,type,
    v25409: state_type > $o ).

tff(pred_def_13501,type,
    v25407: state_type > $o ).

tff(pred_def_13502,type,
    v25419: state_type > $o ).

tff(pred_def_13503,type,
    v25417: state_type > $o ).

tff(pred_def_13504,type,
    v25423: state_type > $o ).

tff(pred_def_13505,type,
    v25421: state_type > $o ).

tff(pred_def_13506,type,
    v25426: state_type > $o ).

tff(pred_def_13507,type,
    v25425: state_type > $o ).

tff(pred_def_13508,type,
    v25405: state_type > $o ).

tff(pred_def_13509,type,
    v25403: state_type > $o ).

tff(pred_def_13510,type,
    v25401: state_type > $o ).

tff(pred_def_13511,type,
    v25399: state_type > $o ).

tff(pred_def_13512,type,
    v25397: state_type > $o ).

tff(pred_def_13513,type,
    v25434: state_type > $o ).

tff(pred_def_13514,type,
    v25432: state_type > $o ).

tff(pred_def_13515,type,
    v25430: state_type > $o ).

tff(pred_def_13516,type,
    v25428: state_type > $o ).

tff(pred_def_13517,type,
    v25391: state_type > $o ).

tff(pred_def_13518,type,
    v25440: state_type > $o ).

tff(pred_def_13519,type,
    v25442: state_type > $o ).

tff(pred_def_13520,type,
    v25438: state_type > $o ).

tff(pred_def_13521,type,
    v25437: state_type > $o ).

tff(pred_def_13522,type,
    v25448: state_type > $o ).

tff(pred_def_13523,type,
    v25449: state_type > $o ).

tff(pred_def_13524,type,
    v25445: state_type > $o ).

tff(pred_def_13525,type,
    v25447: state_type > $o ).

tff(pred_def_13526,type,
    v25459: state_type > $o ).

tff(pred_def_13527,type,
    v25457: state_type > $o ).

tff(pred_def_13528,type,
    v25455: state_type > $o ).

tff(pred_def_13529,type,
    v25453: state_type > $o ).

tff(pred_def_13530,type,
    v25461: state_type > $o ).

tff(pred_def_13531,type,
    v25383: state_type > $o ).

tff(pred_def_13532,type,
    v25381: state_type > $o ).

tff(pred_def_13533,type,
    v25379: state_type > $o ).

tff(pred_def_13534,type,
    v25468: state_type > $o ).

tff(pred_def_13535,type,
    v25466: state_type > $o ).

tff(pred_def_13536,type,
    v25465: state_type > $o ).

tff(pred_def_13537,type,
    v25464: state_type > $o ).

tff(pred_def_13538,type,
    v25476: state_type > $o ).

tff(pred_def_13539,type,
    v25477: state_type > $o ).

tff(pred_def_13540,type,
    v25475: state_type > $o ).

tff(pred_def_13541,type,
    v25472: ( state_type * $int ) > $o ).

tff(pred_def_13542,type,
    v25474: ( state_type * $int ) > $o ).

tff(pred_def_13543,type,
    v25019: ( state_type * $int ) > $o ).

tff(pred_def_13544,type,
    v25017: ( state_type * $int ) > $o ).

tff(pred_def_13545,type,
    v25015: ( state_type * $int ) > $o ).

tff(pred_def_13546,type,
    v25013: ( state_type * $int ) > $o ).

tff(pred_def_13547,type,
    v25011: ( state_type * $int ) > $o ).

tff(pred_def_13548,type,
    v25513: state_type > $o ).

tff(pred_def_13549,type,
    v25511: state_type > $o ).

tff(pred_def_13550,type,
    v25509: state_type > $o ).

tff(pred_def_13551,type,
    v25507: state_type > $o ).

tff(pred_def_13552,type,
    v25505: state_type > $o ).

tff(pred_def_13553,type,
    v25503: state_type > $o ).

tff(pred_def_13554,type,
    v25523: state_type > $o ).

tff(pred_def_13555,type,
    v25521: state_type > $o ).

tff(pred_def_13556,type,
    v25519: state_type > $o ).

tff(pred_def_13557,type,
    v25517: state_type > $o ).

tff(pred_def_13558,type,
    v25515: state_type > $o ).

tff(pred_def_13559,type,
    v25550: state_type > $o ).

tff(pred_def_13560,type,
    v25549: ( state_type * $int ) > $o ).

tff(pred_def_13561,type,
    v25548: ( state_type * $int ) > $o ).

tff(pred_def_13562,type,
    v25546: ( state_type * $int ) > $o ).

tff(pred_def_13563,type,
    v25566: state_type > $o ).

tff(pred_def_13564,type,
    v25567: ( state_type * $int ) > $o ).

tff(pred_def_13565,type,
    v25568: state_type > $o ).

tff(pred_def_13566,type,
    v25564: ( state_type * $int ) > $o ).

tff(pred_def_13567,type,
    v25562: ( state_type * $int ) > $o ).

tff(pred_def_13568,type,
    v25592: ( state_type * $int ) > $o ).

tff(pred_def_13569,type,
    v25501: ( state_type * $int ) > $o ).

tff(pred_def_13570,type,
    v25590: ( state_type * $int ) > $o ).

tff(pred_def_13571,type,
    v25593: ( state_type * $int ) > $o ).

tff(pred_def_13572,type,
    v25588: ( state_type * $int ) > $o ).

tff(pred_def_13573,type,
    v25586: ( state_type * $int ) > $o ).

tff(pred_def_13574,type,
    v25584: ( state_type * $int ) > $o ).

tff(pred_def_13575,type,
    v25582: state_type > $o ).

tff(pred_def_13576,type,
    v25580: state_type > $o ).

tff(pred_def_13577,type,
    v25599: state_type > $o ).

tff(pred_def_13578,type,
    v25539: state_type > $o ).

tff(pred_def_13579,type,
    v25598: ( state_type * $int ) > $o ).

tff(pred_def_13580,type,
    v25537: ( state_type * $int ) > $o ).

tff(pred_def_13581,type,
    v25535: ( state_type * $int ) > $o ).

tff(pred_def_13582,type,
    v25614: ( state_type * $int ) > $o ).

tff(pred_def_13583,type,
    v25613: ( state_type * $int ) > $o ).

tff(pred_def_13584,type,
    v25611: ( state_type * $int ) > $o ).

tff(pred_def_13585,type,
    v25618: state_type > $o ).

tff(pred_def_13586,type,
    v25616: state_type > $o ).

tff(pred_def_13587,type,
    v25629: ( state_type * $int ) > $o ).

tff(pred_def_13588,type,
    v25628: state_type > $o ).

tff(pred_def_13589,type,
    v25632: state_type > $o ).

tff(pred_def_13590,type,
    v25633: state_type > $o ).

tff(pred_def_13591,type,
    v25631: state_type > $o ).

tff(pred_def_13592,type,
    v25634: state_type > $o ).

tff(pred_def_13593,type,
    v25630: state_type > $o ).

tff(pred_def_13594,type,
    v25627: state_type > $o ).

tff(pred_def_13595,type,
    v25635: state_type > $o ).

tff(pred_def_13596,type,
    v25626: state_type > $o ).

tff(pred_def_13597,type,
    v25638: state_type > $o ).

tff(pred_def_13598,type,
    v25639: state_type > $o ).

tff(pred_def_13599,type,
    v25637: state_type > $o ).

tff(pred_def_13600,type,
    v25640: state_type > $o ).

tff(pred_def_13601,type,
    v25636: state_type > $o ).

tff(pred_def_13602,type,
    v25625: state_type > $o ).

tff(pred_def_13603,type,
    v25641: state_type > $o ).

tff(pred_def_13604,type,
    v25624: state_type > $o ).

tff(pred_def_13605,type,
    v25623: state_type > $o ).

tff(pred_def_13606,type,
    v25645: state_type > $o ).

tff(pred_def_13607,type,
    v25646: state_type > $o ).

tff(pred_def_13608,type,
    v25644: state_type > $o ).

tff(pred_def_13609,type,
    v25647: state_type > $o ).

tff(pred_def_13610,type,
    v25643: state_type > $o ).

tff(pred_def_13611,type,
    v25642: state_type > $o ).

tff(pred_def_13612,type,
    v25622: state_type > $o ).

tff(pred_def_13613,type,
    v25648: state_type > $o ).

tff(pred_def_13614,type,
    v25621: state_type > $o ).

tff(pred_def_13615,type,
    v25651: state_type > $o ).

tff(pred_def_13616,type,
    v25652: state_type > $o ).

tff(pred_def_13617,type,
    v25650: state_type > $o ).

tff(pred_def_13618,type,
    v25653: state_type > $o ).

tff(pred_def_13619,type,
    v25649: state_type > $o ).

tff(pred_def_13620,type,
    v25656: state_type > $o ).

tff(pred_def_13621,type,
    v25657: state_type > $o ).

tff(pred_def_13622,type,
    v25655: state_type > $o ).

tff(pred_def_13623,type,
    v25658: state_type > $o ).

tff(pred_def_13624,type,
    v25654: state_type > $o ).

tff(pred_def_13625,type,
    v25661: state_type > $o ).

tff(pred_def_13626,type,
    v25662: state_type > $o ).

tff(pred_def_13627,type,
    v25660: state_type > $o ).

tff(pred_def_13628,type,
    v25663: state_type > $o ).

tff(pred_def_13629,type,
    v25659: state_type > $o ).

tff(pred_def_13630,type,
    v25619: ( state_type * $int ) > $o ).

tff(pred_def_13631,type,
    v25609: ( state_type * $int ) > $o ).

tff(pred_def_13632,type,
    v25607: ( state_type * $int ) > $o ).

tff(pred_def_13633,type,
    v25605: ( state_type * $int ) > $o ).

tff(pred_def_13634,type,
    v25603: ( state_type * $int ) > $o ).

tff(pred_def_13635,type,
    v25601: ( state_type * $int ) > $o ).

tff(pred_def_13636,type,
    v25664: ( state_type * $int ) > $o ).

tff(pred_def_13637,type,
    v25533: ( state_type * $int ) > $o ).

tff(pred_def_13638,type,
    v25531: ( state_type * $int ) > $o ).

tff(pred_def_13639,type,
    v25529: ( state_type * $int ) > $o ).

tff(pred_def_13640,type,
    v25665: ( state_type * $int ) > $o ).

tff(pred_def_13641,type,
    v25666: ( state_type * $int ) > $o ).

tff(pred_def_13642,type,
    v25527: ( state_type * $int ) > $o ).

tff(pred_def_13643,type,
    v25525: ( state_type * $int ) > $o ).

tff(pred_def_13644,type,
    v25676: state_type > $o ).

tff(pred_def_13645,type,
    v25674: state_type > $o ).

tff(pred_def_13646,type,
    v25682: state_type > $o ).

tff(pred_def_13647,type,
    v25680: state_type > $o ).

tff(pred_def_13648,type,
    v25686: state_type > $o ).

tff(pred_def_13649,type,
    v25684: state_type > $o ).

tff(pred_def_13650,type,
    v25690: state_type > $o ).

tff(pred_def_13651,type,
    v25688: state_type > $o ).

tff(pred_def_13652,type,
    v25678: state_type > $o ).

tff(pred_def_13653,type,
    v25696: state_type > $o ).

tff(pred_def_13654,type,
    v25698: state_type > $o ).

tff(pred_def_13655,type,
    v25694: state_type > $o ).

tff(pred_def_13656,type,
    v25693: state_type > $o ).

tff(pred_def_13657,type,
    v25704: state_type > $o ).

tff(pred_def_13658,type,
    v25705: state_type > $o ).

tff(pred_def_13659,type,
    v25701: state_type > $o ).

tff(pred_def_13660,type,
    v25703: state_type > $o ).

tff(pred_def_13661,type,
    v25711: state_type > $o ).

tff(pred_def_13662,type,
    v25709: state_type > $o ).

tff(pred_def_13663,type,
    v25713: state_type > $o ).

tff(pred_def_13664,type,
    v25672: state_type > $o ).

tff(pred_def_13665,type,
    v25670: state_type > $o ).

tff(pred_def_13666,type,
    v25668: state_type > $o ).

tff(pred_def_13667,type,
    v25720: state_type > $o ).

tff(pred_def_13668,type,
    v25718: state_type > $o ).

tff(pred_def_13669,type,
    v25717: state_type > $o ).

tff(pred_def_13670,type,
    v25716: state_type > $o ).

tff(pred_def_13671,type,
    v25728: state_type > $o ).

tff(pred_def_13672,type,
    v25729: state_type > $o ).

tff(pred_def_13673,type,
    v25727: state_type > $o ).

tff(pred_def_13674,type,
    v25724: ( state_type * $int ) > $o ).

tff(pred_def_13675,type,
    v25726: ( state_type * $int ) > $o ).

tff(pred_def_13676,type,
    v25715: ( state_type * $int ) > $o ).

tff(pred_def_13677,type,
    v25597: state_type > $o ).

tff(pred_def_13678,type,
    v25595: state_type > $o ).

tff(pred_def_13679,type,
    v25741: state_type > $o ).

tff(pred_def_13680,type,
    v25739: state_type > $o ).

tff(pred_def_13681,type,
    v25738: state_type > $o ).

tff(pred_def_13682,type,
    v25737: ( state_type * $int ) > $o ).

tff(pred_def_13683,type,
    v25735: state_type > $o ).

tff(pred_def_13684,type,
    v25733: state_type > $o ).

tff(pred_def_13685,type,
    v25746: state_type > $o ).

tff(pred_def_13686,type,
    v25745: state_type > $o ).

tff(pred_def_13687,type,
    v25578: state_type > $o ).

tff(pred_def_13688,type,
    v25576: state_type > $o ).

tff(pred_def_13689,type,
    v25574: state_type > $o ).

tff(pred_def_13690,type,
    v25747: ( state_type * $int ) > $o ).

tff(pred_def_13691,type,
    v25748: state_type > $o ).

tff(pred_def_13692,type,
    v25572: ( state_type * $int ) > $o ).

tff(pred_def_13693,type,
    v25570: ( state_type * $int ) > $o ).

tff(pred_def_13694,type,
    v25749: ( state_type * $int ) > $o ).

tff(pred_def_13695,type,
    v25560: ( state_type * $int ) > $o ).

tff(pred_def_13696,type,
    v25558: ( state_type * $int ) > $o ).

tff(pred_def_13697,type,
    v25556: state_type > $o ).

tff(pred_def_13698,type,
    v25750: ( state_type * $int ) > $o ).

tff(pred_def_13699,type,
    v25751: state_type > $o ).

tff(pred_def_13700,type,
    v25554: ( state_type * $int ) > $o ).

tff(pred_def_13701,type,
    v25552: ( state_type * $int ) > $o ).

tff(pred_def_13702,type,
    v25752: ( state_type * $int ) > $o ).

tff(pred_def_13703,type,
    v25544: ( state_type * $int ) > $o ).

tff(pred_def_13704,type,
    v25542: ( state_type * $int ) > $o ).

tff(pred_def_13705,type,
    v25758: state_type > $o ).

tff(pred_def_13706,type,
    v25756: state_type > $o ).

tff(pred_def_13707,type,
    v25755: state_type > $o ).

tff(pred_def_13708,type,
    v25754: ( state_type * $int ) > $o ).

tff(pred_def_13709,type,
    v25499: state_type > $o ).

tff(pred_def_13710,type,
    v25497: state_type > $o ).

tff(pred_def_13711,type,
    v25764: state_type > $o ).

tff(pred_def_13712,type,
    v25762: state_type > $o ).

tff(pred_def_13713,type,
    v25768: state_type > $o ).

tff(pred_def_13714,type,
    v25766: state_type > $o ).

tff(pred_def_13715,type,
    v25771: state_type > $o ).

tff(pred_def_13716,type,
    v25770: state_type > $o ).

tff(pred_def_13717,type,
    v25495: state_type > $o ).

tff(pred_def_13718,type,
    v25493: state_type > $o ).

tff(pred_def_13719,type,
    v25491: state_type > $o ).

tff(pred_def_13720,type,
    v25489: state_type > $o ).

tff(pred_def_13721,type,
    v25487: state_type > $o ).

tff(pred_def_13722,type,
    v25485: state_type > $o ).

tff(pred_def_13723,type,
    v25483: state_type > $o ).

tff(pred_def_13724,type,
    v25481: state_type > $o ).

tff(pred_def_13725,type,
    v25791: state_type > $o ).

tff(pred_def_13726,type,
    v25789: state_type > $o ).

tff(pred_def_13727,type,
    v25787: state_type > $o ).

tff(pred_def_13728,type,
    v25785: state_type > $o ).

tff(pred_def_13729,type,
    v25783: state_type > $o ).

tff(pred_def_13730,type,
    v25801: state_type > $o ).

tff(pred_def_13731,type,
    v25799: state_type > $o ).

tff(pred_def_13732,type,
    v25797: state_type > $o ).

tff(pred_def_13733,type,
    v25795: state_type > $o ).

tff(pred_def_13734,type,
    v25793: state_type > $o ).

tff(pred_def_13735,type,
    v25805: ( state_type * $int ) > $o ).

tff(pred_def_13736,type,
    v25803: ( state_type * $int ) > $o ).

tff(pred_def_13737,type,
    v25815: state_type > $o ).

tff(pred_def_13738,type,
    v25813: state_type > $o ).

tff(pred_def_13739,type,
    v25821: state_type > $o ).

tff(pred_def_13740,type,
    v25819: state_type > $o ).

tff(pred_def_13741,type,
    v25845: ( state_type * $int ) > $o ).

tff(pred_def_13742,type,
    v25843: ( state_type * $int ) > $o ).

tff(pred_def_13743,type,
    v25846: ( state_type * $int ) > $o ).

tff(pred_def_13744,type,
    v25841: ( state_type * $int ) > $o ).

tff(pred_def_13745,type,
    v25839: ( state_type * $int ) > $o ).

tff(pred_def_13746,type,
    v25837: ( state_type * $int ) > $o ).

tff(pred_def_13747,type,
    v25835: state_type > $o ).

tff(pred_def_13748,type,
    v25833: state_type > $o ).

tff(pred_def_13749,type,
    v25850: state_type > $o ).

tff(pred_def_13750,type,
    v25848: state_type > $o ).

tff(pred_def_13751,type,
    v25854: state_type > $o ).

tff(pred_def_13752,type,
    v25852: state_type > $o ).

tff(pred_def_13753,type,
    v25857: state_type > $o ).

tff(pred_def_13754,type,
    v25856: state_type > $o ).

tff(pred_def_13755,type,
    v25831: state_type > $o ).

tff(pred_def_13756,type,
    v25829: state_type > $o ).

tff(pred_def_13757,type,
    v25827: state_type > $o ).

tff(pred_def_13758,type,
    v25825: state_type > $o ).

tff(pred_def_13759,type,
    v25823: state_type > $o ).

tff(pred_def_13760,type,
    v25861: state_type > $o ).

tff(pred_def_13761,type,
    v25859: state_type > $o ).

tff(pred_def_13762,type,
    v25817: state_type > $o ).

tff(pred_def_13763,type,
    v25867: state_type > $o ).

tff(pred_def_13764,type,
    v25869: state_type > $o ).

tff(pred_def_13765,type,
    v25865: state_type > $o ).

tff(pred_def_13766,type,
    v25864: state_type > $o ).

tff(pred_def_13767,type,
    v25875: state_type > $o ).

tff(pred_def_13768,type,
    v25876: state_type > $o ).

tff(pred_def_13769,type,
    v25872: state_type > $o ).

tff(pred_def_13770,type,
    v25874: state_type > $o ).

tff(pred_def_13771,type,
    v25882: state_type > $o ).

tff(pred_def_13772,type,
    v25880: state_type > $o ).

tff(pred_def_13773,type,
    v25884: state_type > $o ).

tff(pred_def_13774,type,
    v25811: state_type > $o ).

tff(pred_def_13775,type,
    v25809: state_type > $o ).

tff(pred_def_13776,type,
    v25807: state_type > $o ).

tff(pred_def_13777,type,
    v25891: state_type > $o ).

tff(pred_def_13778,type,
    v25889: state_type > $o ).

tff(pred_def_13779,type,
    v25888: state_type > $o ).

tff(pred_def_13780,type,
    v25887: state_type > $o ).

tff(pred_def_13781,type,
    v25899: state_type > $o ).

tff(pred_def_13782,type,
    v25900: state_type > $o ).

tff(pred_def_13783,type,
    v25898: state_type > $o ).

tff(pred_def_13784,type,
    v25895: ( state_type * $int ) > $o ).

tff(pred_def_13785,type,
    v25897: ( state_type * $int ) > $o ).

tff(pred_def_13786,type,
    v25781: ( state_type * $int ) > $o ).

tff(pred_def_13787,type,
    v25779: ( state_type * $int ) > $o ).

tff(pred_def_13788,type,
    v25777: ( state_type * $int ) > $o ).

tff(pred_def_13789,type,
    v25775: ( state_type * $int ) > $o ).

tff(pred_def_13790,type,
    v25773: ( state_type * $int ) > $o ).

tff(pred_def_13791,type,
    v25922: state_type > $o ).

tff(pred_def_13792,type,
    v25920: state_type > $o ).

tff(pred_def_13793,type,
    v25926: state_type > $o ).

tff(pred_def_13794,type,
    v25924: state_type > $o ).

tff(pred_def_13795,type,
    v25930: state_type > $o ).

tff(pred_def_13796,type,
    v25928: state_type > $o ).

tff(pred_def_13797,type,
    v25933: state_type > $o ).

tff(pred_def_13798,type,
    v25932: state_type > $o ).

tff(pred_def_13799,type,
    v25918: state_type > $o ).

tff(pred_def_13800,type,
    v25916: state_type > $o ).

tff(pred_def_13801,type,
    v25914: state_type > $o ).

tff(pred_def_13802,type,
    v25912: state_type > $o ).

tff(pred_def_13803,type,
    v25910: state_type > $o ).

tff(pred_def_13804,type,
    v25908: state_type > $o ).

tff(pred_def_13805,type,
    v25906: state_type > $o ).

tff(pred_def_13806,type,
    v25904: state_type > $o ).

tff(pred_def_13807,type,
    v25953: state_type > $o ).

tff(pred_def_13808,type,
    v25951: state_type > $o ).

tff(pred_def_13809,type,
    v25949: state_type > $o ).

tff(pred_def_13810,type,
    v25947: state_type > $o ).

tff(pred_def_13811,type,
    v25945: state_type > $o ).

tff(pred_def_13812,type,
    v25963: state_type > $o ).

tff(pred_def_13813,type,
    v25961: state_type > $o ).

tff(pred_def_13814,type,
    v25959: state_type > $o ).

tff(pred_def_13815,type,
    v25957: state_type > $o ).

tff(pred_def_13816,type,
    v25955: state_type > $o ).

tff(pred_def_13817,type,
    v25967: ( state_type * $int ) > $o ).

tff(pred_def_13818,type,
    v25965: ( state_type * $int ) > $o ).

tff(pred_def_13819,type,
    v25977: state_type > $o ).

tff(pred_def_13820,type,
    v25975: state_type > $o ).

tff(pred_def_13821,type,
    v25983: state_type > $o ).

tff(pred_def_13822,type,
    v25981: state_type > $o ).

tff(pred_def_13823,type,
    v25997: state_type > $o ).

tff(pred_def_13824,type,
    v25995: state_type > $o ).

tff(pred_def_13825,type,
    v26001: state_type > $o ).

tff(pred_def_13826,type,
    v25999: state_type > $o ).

tff(pred_def_13827,type,
    v26005: state_type > $o ).

tff(pred_def_13828,type,
    v26003: state_type > $o ).

tff(pred_def_13829,type,
    v26008: state_type > $o ).

tff(pred_def_13830,type,
    v26007: state_type > $o ).

tff(pred_def_13831,type,
    v25993: state_type > $o ).

tff(pred_def_13832,type,
    v25991: state_type > $o ).

tff(pred_def_13833,type,
    v25989: state_type > $o ).

tff(pred_def_13834,type,
    v25987: state_type > $o ).

tff(pred_def_13835,type,
    v25985: state_type > $o ).

tff(pred_def_13836,type,
    v26012: state_type > $o ).

tff(pred_def_13837,type,
    v26010: state_type > $o ).

tff(pred_def_13838,type,
    v25979: state_type > $o ).

tff(pred_def_13839,type,
    v26018: state_type > $o ).

tff(pred_def_13840,type,
    v26020: state_type > $o ).

tff(pred_def_13841,type,
    v26016: state_type > $o ).

tff(pred_def_13842,type,
    v26015: state_type > $o ).

tff(pred_def_13843,type,
    v26026: state_type > $o ).

tff(pred_def_13844,type,
    v26027: state_type > $o ).

tff(pred_def_13845,type,
    v26023: state_type > $o ).

tff(pred_def_13846,type,
    v26025: state_type > $o ).

tff(pred_def_13847,type,
    v26033: state_type > $o ).

tff(pred_def_13848,type,
    v26031: state_type > $o ).

tff(pred_def_13849,type,
    v26035: state_type > $o ).

tff(pred_def_13850,type,
    v25973: state_type > $o ).

tff(pred_def_13851,type,
    v25971: state_type > $o ).

tff(pred_def_13852,type,
    v25969: state_type > $o ).

tff(pred_def_13853,type,
    v26042: state_type > $o ).

tff(pred_def_13854,type,
    v26040: state_type > $o ).

tff(pred_def_13855,type,
    v26039: state_type > $o ).

tff(pred_def_13856,type,
    v26038: state_type > $o ).

tff(pred_def_13857,type,
    v26050: state_type > $o ).

tff(pred_def_13858,type,
    v26051: state_type > $o ).

tff(pred_def_13859,type,
    v26049: state_type > $o ).

tff(pred_def_13860,type,
    v26046: ( state_type * $int ) > $o ).

tff(pred_def_13861,type,
    v26048: ( state_type * $int ) > $o ).

tff(pred_def_13862,type,
    v25943: ( state_type * $int ) > $o ).

tff(pred_def_13863,type,
    v25941: ( state_type * $int ) > $o ).

tff(pred_def_13864,type,
    v25939: ( state_type * $int ) > $o ).

tff(pred_def_13865,type,
    v25937: ( state_type * $int ) > $o ).

tff(pred_def_13866,type,
    v25935: ( state_type * $int ) > $o ).

tff(pred_def_13867,type,
    v26073: state_type > $o ).

tff(pred_def_13868,type,
    v26071: state_type > $o ).

tff(pred_def_13869,type,
    v26077: state_type > $o ).

tff(pred_def_13870,type,
    v26075: state_type > $o ).

tff(pred_def_13871,type,
    v26081: state_type > $o ).

tff(pred_def_13872,type,
    v26079: state_type > $o ).

tff(pred_def_13873,type,
    v26084: state_type > $o ).

tff(pred_def_13874,type,
    v26083: state_type > $o ).

tff(pred_def_13875,type,
    v26069: state_type > $o ).

tff(pred_def_13876,type,
    v26067: state_type > $o ).

tff(pred_def_13877,type,
    v26065: state_type > $o ).

tff(pred_def_13878,type,
    v26063: state_type > $o ).

tff(pred_def_13879,type,
    v26061: state_type > $o ).

tff(pred_def_13880,type,
    v26059: state_type > $o ).

tff(pred_def_13881,type,
    v26057: state_type > $o ).

tff(pred_def_13882,type,
    v26055: state_type > $o ).

tff(pred_def_13883,type,
    v26104: state_type > $o ).

tff(pred_def_13884,type,
    v26102: state_type > $o ).

tff(pred_def_13885,type,
    v26100: state_type > $o ).

tff(pred_def_13886,type,
    v26098: state_type > $o ).

tff(pred_def_13887,type,
    v26096: state_type > $o ).

tff(pred_def_13888,type,
    v26114: state_type > $o ).

tff(pred_def_13889,type,
    v26112: state_type > $o ).

tff(pred_def_13890,type,
    v26110: state_type > $o ).

tff(pred_def_13891,type,
    v26108: state_type > $o ).

tff(pred_def_13892,type,
    v26106: state_type > $o ).

tff(pred_def_13893,type,
    v26118: ( state_type * $int ) > $o ).

tff(pred_def_13894,type,
    v26116: ( state_type * $int ) > $o ).

tff(pred_def_13895,type,
    v26128: state_type > $o ).

tff(pred_def_13896,type,
    v26126: state_type > $o ).

tff(pred_def_13897,type,
    v26134: state_type > $o ).

tff(pred_def_13898,type,
    v26132: state_type > $o ).

tff(pred_def_13899,type,
    v26148: state_type > $o ).

tff(pred_def_13900,type,
    v26146: state_type > $o ).

tff(pred_def_13901,type,
    v26152: state_type > $o ).

tff(pred_def_13902,type,
    v26150: state_type > $o ).

tff(pred_def_13903,type,
    v26156: state_type > $o ).

tff(pred_def_13904,type,
    v26154: state_type > $o ).

tff(pred_def_13905,type,
    v26159: state_type > $o ).

tff(pred_def_13906,type,
    v26158: state_type > $o ).

tff(pred_def_13907,type,
    v26144: state_type > $o ).

tff(pred_def_13908,type,
    v26142: state_type > $o ).

tff(pred_def_13909,type,
    v26140: state_type > $o ).

tff(pred_def_13910,type,
    v26138: state_type > $o ).

tff(pred_def_13911,type,
    v26136: state_type > $o ).

tff(pred_def_13912,type,
    v26163: state_type > $o ).

tff(pred_def_13913,type,
    v26161: state_type > $o ).

tff(pred_def_13914,type,
    v26130: state_type > $o ).

tff(pred_def_13915,type,
    v26169: state_type > $o ).

tff(pred_def_13916,type,
    v26171: state_type > $o ).

tff(pred_def_13917,type,
    v26167: state_type > $o ).

tff(pred_def_13918,type,
    v26166: state_type > $o ).

tff(pred_def_13919,type,
    v26177: state_type > $o ).

tff(pred_def_13920,type,
    v26178: state_type > $o ).

tff(pred_def_13921,type,
    v26174: state_type > $o ).

tff(pred_def_13922,type,
    v26176: state_type > $o ).

tff(pred_def_13923,type,
    v26184: state_type > $o ).

tff(pred_def_13924,type,
    v26182: state_type > $o ).

tff(pred_def_13925,type,
    v26186: state_type > $o ).

tff(pred_def_13926,type,
    v26124: state_type > $o ).

tff(pred_def_13927,type,
    v26122: state_type > $o ).

tff(pred_def_13928,type,
    v26120: state_type > $o ).

tff(pred_def_13929,type,
    v26193: state_type > $o ).

tff(pred_def_13930,type,
    v26191: state_type > $o ).

tff(pred_def_13931,type,
    v26190: state_type > $o ).

tff(pred_def_13932,type,
    v26189: state_type > $o ).

tff(pred_def_13933,type,
    v26201: state_type > $o ).

tff(pred_def_13934,type,
    v26202: state_type > $o ).

tff(pred_def_13935,type,
    v26200: state_type > $o ).

tff(pred_def_13936,type,
    v26197: ( state_type * $int ) > $o ).

tff(pred_def_13937,type,
    v26199: ( state_type * $int ) > $o ).

tff(pred_def_13938,type,
    v26094: ( state_type * $int ) > $o ).

tff(pred_def_13939,type,
    v26092: ( state_type * $int ) > $o ).

tff(pred_def_13940,type,
    v26090: ( state_type * $int ) > $o ).

tff(pred_def_13941,type,
    v26088: ( state_type * $int ) > $o ).

tff(pred_def_13942,type,
    v26086: ( state_type * $int ) > $o ).

tff(pred_def_13943,type,
    v26224: state_type > $o ).

tff(pred_def_13944,type,
    v26222: state_type > $o ).

tff(pred_def_13945,type,
    v26228: state_type > $o ).

tff(pred_def_13946,type,
    v26226: state_type > $o ).

tff(pred_def_13947,type,
    v26232: state_type > $o ).

tff(pred_def_13948,type,
    v26230: state_type > $o ).

tff(pred_def_13949,type,
    v26235: state_type > $o ).

tff(pred_def_13950,type,
    v26234: state_type > $o ).

tff(pred_def_13951,type,
    v26220: state_type > $o ).

tff(pred_def_13952,type,
    v26218: state_type > $o ).

tff(pred_def_13953,type,
    v26216: state_type > $o ).

tff(pred_def_13954,type,
    v26214: state_type > $o ).

tff(pred_def_13955,type,
    v26212: state_type > $o ).

tff(pred_def_13956,type,
    v26210: state_type > $o ).

tff(pred_def_13957,type,
    v26208: state_type > $o ).

tff(pred_def_13958,type,
    v26206: state_type > $o ).

tff(pred_def_13959,type,
    v26255: state_type > $o ).

tff(pred_def_13960,type,
    v26253: state_type > $o ).

tff(pred_def_13961,type,
    v26251: state_type > $o ).

tff(pred_def_13962,type,
    v26249: state_type > $o ).

tff(pred_def_13963,type,
    v26247: state_type > $o ).

tff(pred_def_13964,type,
    v26265: state_type > $o ).

tff(pred_def_13965,type,
    v26263: state_type > $o ).

tff(pred_def_13966,type,
    v26261: state_type > $o ).

tff(pred_def_13967,type,
    v26259: state_type > $o ).

tff(pred_def_13968,type,
    v26257: state_type > $o ).

tff(pred_def_13969,type,
    v26269: ( state_type * $int ) > $o ).

tff(pred_def_13970,type,
    v26267: ( state_type * $int ) > $o ).

tff(pred_def_13971,type,
    v26279: state_type > $o ).

tff(pred_def_13972,type,
    v26277: state_type > $o ).

tff(pred_def_13973,type,
    v26285: state_type > $o ).

tff(pred_def_13974,type,
    v26283: state_type > $o ).

tff(pred_def_13975,type,
    v26299: state_type > $o ).

tff(pred_def_13976,type,
    v26297: state_type > $o ).

tff(pred_def_13977,type,
    v26303: state_type > $o ).

tff(pred_def_13978,type,
    v26301: state_type > $o ).

tff(pred_def_13979,type,
    v26307: state_type > $o ).

tff(pred_def_13980,type,
    v26305: state_type > $o ).

tff(pred_def_13981,type,
    v26310: state_type > $o ).

tff(pred_def_13982,type,
    v26309: state_type > $o ).

tff(pred_def_13983,type,
    v26295: state_type > $o ).

tff(pred_def_13984,type,
    v26293: state_type > $o ).

tff(pred_def_13985,type,
    v26291: state_type > $o ).

tff(pred_def_13986,type,
    v26289: state_type > $o ).

tff(pred_def_13987,type,
    v26287: state_type > $o ).

tff(pred_def_13988,type,
    v26314: state_type > $o ).

tff(pred_def_13989,type,
    v26312: state_type > $o ).

tff(pred_def_13990,type,
    v26281: state_type > $o ).

tff(pred_def_13991,type,
    v26320: state_type > $o ).

tff(pred_def_13992,type,
    v26322: state_type > $o ).

tff(pred_def_13993,type,
    v26318: state_type > $o ).

tff(pred_def_13994,type,
    v26317: state_type > $o ).

tff(pred_def_13995,type,
    v26328: state_type > $o ).

tff(pred_def_13996,type,
    v26329: state_type > $o ).

tff(pred_def_13997,type,
    v26325: state_type > $o ).

tff(pred_def_13998,type,
    v26327: state_type > $o ).

tff(pred_def_13999,type,
    v26335: state_type > $o ).

tff(pred_def_14000,type,
    v26333: state_type > $o ).

tff(pred_def_14001,type,
    v26337: state_type > $o ).

tff(pred_def_14002,type,
    v26275: state_type > $o ).

tff(pred_def_14003,type,
    v26273: state_type > $o ).

tff(pred_def_14004,type,
    v26271: state_type > $o ).

tff(pred_def_14005,type,
    v26344: state_type > $o ).

tff(pred_def_14006,type,
    v26342: state_type > $o ).

tff(pred_def_14007,type,
    v26341: state_type > $o ).

tff(pred_def_14008,type,
    v26340: state_type > $o ).

tff(pred_def_14009,type,
    v26352: state_type > $o ).

tff(pred_def_14010,type,
    v26353: state_type > $o ).

tff(pred_def_14011,type,
    v26351: state_type > $o ).

tff(pred_def_14012,type,
    v26348: ( state_type * $int ) > $o ).

tff(pred_def_14013,type,
    v26350: ( state_type * $int ) > $o ).

tff(pred_def_14014,type,
    v26245: ( state_type * $int ) > $o ).

tff(pred_def_14015,type,
    v26243: ( state_type * $int ) > $o ).

tff(pred_def_14016,type,
    v26241: ( state_type * $int ) > $o ).

tff(pred_def_14017,type,
    v26239: ( state_type * $int ) > $o ).

tff(pred_def_14018,type,
    v26237: ( state_type * $int ) > $o ).

tff(pred_def_14019,type,
    v26375: state_type > $o ).

tff(pred_def_14020,type,
    v26373: state_type > $o ).

tff(pred_def_14021,type,
    v26379: state_type > $o ).

tff(pred_def_14022,type,
    v26377: state_type > $o ).

tff(pred_def_14023,type,
    v26383: state_type > $o ).

tff(pred_def_14024,type,
    v26381: state_type > $o ).

tff(pred_def_14025,type,
    v26386: state_type > $o ).

tff(pred_def_14026,type,
    v26385: state_type > $o ).

tff(pred_def_14027,type,
    v26371: state_type > $o ).

tff(pred_def_14028,type,
    v26369: state_type > $o ).

tff(pred_def_14029,type,
    v26367: state_type > $o ).

tff(pred_def_14030,type,
    v26365: state_type > $o ).

tff(pred_def_14031,type,
    v26363: state_type > $o ).

tff(pred_def_14032,type,
    v26361: state_type > $o ).

tff(pred_def_14033,type,
    v26359: state_type > $o ).

tff(pred_def_14034,type,
    v26357: state_type > $o ).

tff(pred_def_14035,type,
    v26406: state_type > $o ).

tff(pred_def_14036,type,
    v26404: state_type > $o ).

tff(pred_def_14037,type,
    v26402: state_type > $o ).

tff(pred_def_14038,type,
    v26400: state_type > $o ).

tff(pred_def_14039,type,
    v26398: state_type > $o ).

tff(pred_def_14040,type,
    v26416: state_type > $o ).

tff(pred_def_14041,type,
    v26414: state_type > $o ).

tff(pred_def_14042,type,
    v26412: state_type > $o ).

tff(pred_def_14043,type,
    v26410: state_type > $o ).

tff(pred_def_14044,type,
    v26408: state_type > $o ).

tff(pred_def_14045,type,
    v26420: ( state_type * $int ) > $o ).

tff(pred_def_14046,type,
    v26418: ( state_type * $int ) > $o ).

tff(pred_def_14047,type,
    v26430: state_type > $o ).

tff(pred_def_14048,type,
    v26428: state_type > $o ).

tff(pred_def_14049,type,
    v26436: state_type > $o ).

tff(pred_def_14050,type,
    v26434: state_type > $o ).

tff(pred_def_14051,type,
    v26449: state_type > $o ).

tff(pred_def_14052,type,
    v26447: state_type > $o ).

tff(pred_def_14053,type,
    v26453: state_type > $o ).

tff(pred_def_14054,type,
    v26451: state_type > $o ).

tff(pred_def_14055,type,
    v26457: state_type > $o ).

tff(pred_def_14056,type,
    v26455: state_type > $o ).

tff(pred_def_14057,type,
    v26460: state_type > $o ).

tff(pred_def_14058,type,
    v26459: state_type > $o ).

tff(pred_def_14059,type,
    v26445: state_type > $o ).

tff(pred_def_14060,type,
    v26443: state_type > $o ).

tff(pred_def_14061,type,
    v26440: state_type > $o ).

tff(pred_def_14062,type,
    v26438: state_type > $o ).

tff(pred_def_14063,type,
    v26464: state_type > $o ).

tff(pred_def_14064,type,
    v26462: state_type > $o ).

tff(pred_def_14065,type,
    v26432: state_type > $o ).

tff(pred_def_14066,type,
    v26470: state_type > $o ).

tff(pred_def_14067,type,
    v26472: state_type > $o ).

tff(pred_def_14068,type,
    v26468: state_type > $o ).

tff(pred_def_14069,type,
    v26467: state_type > $o ).

tff(pred_def_14070,type,
    v26478: state_type > $o ).

tff(pred_def_14071,type,
    v26479: state_type > $o ).

tff(pred_def_14072,type,
    v26475: state_type > $o ).

tff(pred_def_14073,type,
    v26477: state_type > $o ).

tff(pred_def_14074,type,
    v26485: state_type > $o ).

tff(pred_def_14075,type,
    v26483: state_type > $o ).

tff(pred_def_14076,type,
    v26487: state_type > $o ).

tff(pred_def_14077,type,
    v26426: state_type > $o ).

tff(pred_def_14078,type,
    v26424: state_type > $o ).

tff(pred_def_14079,type,
    v26422: state_type > $o ).

tff(pred_def_14080,type,
    v26494: state_type > $o ).

tff(pred_def_14081,type,
    v26492: state_type > $o ).

tff(pred_def_14082,type,
    v26491: state_type > $o ).

tff(pred_def_14083,type,
    v26490: state_type > $o ).

tff(pred_def_14084,type,
    v26502: state_type > $o ).

tff(pred_def_14085,type,
    v26503: state_type > $o ).

tff(pred_def_14086,type,
    v26501: state_type > $o ).

tff(pred_def_14087,type,
    v26498: ( state_type * $int ) > $o ).

tff(pred_def_14088,type,
    v26500: ( state_type * $int ) > $o ).

tff(pred_def_14089,type,
    v26396: ( state_type * $int ) > $o ).

tff(pred_def_14090,type,
    v26394: ( state_type * $int ) > $o ).

tff(pred_def_14091,type,
    v26392: ( state_type * $int ) > $o ).

tff(pred_def_14092,type,
    v26390: ( state_type * $int ) > $o ).

tff(pred_def_14093,type,
    v26388: ( state_type * $int ) > $o ).

tff(pred_def_14094,type,
    v26515: state_type > $o ).

tff(pred_def_14095,type,
    v26513: state_type > $o ).

tff(pred_def_14096,type,
    v26511: state_type > $o ).

tff(pred_def_14097,type,
    v26509: state_type > $o ).

tff(pred_def_14098,type,
    v26507: state_type > $o ).

tff(pred_def_14099,type,
    v26523: state_type > $o ).

tff(pred_def_14100,type,
    v26522: ( state_type * $int ) > $o ).

tff(pred_def_14101,type,
    v26521: ( state_type * $int ) > $o ).

tff(pred_def_14102,type,
    v26526: state_type > $o ).

tff(pred_def_14103,type,
    v26525: ( state_type * $int ) > $o ).

tff(pred_def_14104,type,
    v26524: ( state_type * $int ) > $o ).

tff(pred_def_14105,type,
    v26520: ( state_type * $int ) > $o ).

tff(pred_def_14106,type,
    v26529: state_type > $o ).

tff(pred_def_14107,type,
    v26528: ( state_type * $int ) > $o ).

tff(pred_def_14108,type,
    v26527: ( state_type * $int ) > $o ).

tff(pred_def_14109,type,
    v26519: ( state_type * $int ) > $o ).

tff(pred_def_14110,type,
    v26532: state_type > $o ).

tff(pred_def_14111,type,
    v26531: ( state_type * $int ) > $o ).

tff(pred_def_14112,type,
    v26530: ( state_type * $int ) > $o ).

tff(pred_def_14113,type,
    v26518: ( state_type * $int ) > $o ).

tff(pred_def_14114,type,
    v26535: state_type > $o ).

tff(pred_def_14115,type,
    v26534: ( state_type * $int ) > $o ).

tff(pred_def_14116,type,
    v26533: ( state_type * $int ) > $o ).

tff(pred_def_14117,type,
    v26517: ( state_type * $int ) > $o ).

tff(pred_def_14118,type,
    v26538: state_type > $o ).

tff(pred_def_14119,type,
    v26537: ( state_type * $int ) > $o ).

tff(pred_def_14120,type,
    v26536: ( state_type * $int ) > $o ).

tff(pred_def_14121,type,
    v25009: ( state_type * $int ) > $o ).

tff(pred_def_14122,type,
    v25007: ( state_type * $int ) > $o ).

tff(pred_def_14123,type,
    v25005: ( state_type * $int ) > $o ).

tff(pred_def_14124,type,
    v25003: ( state_type * $int ) > $o ).

tff(pred_def_14125,type,
    v25001: ( state_type * $int ) > $o ).

tff(pred_def_14126,type,
    v24995: state_type > $o ).

tff(pred_def_14127,type,
    v24993: state_type > $o ).

tff(pred_def_14128,type,
    v24991: state_type > $o ).

tff(pred_def_14129,type,
    v26549: ( state_type * $int ) > $o ).

tff(pred_def_14130,type,
    v26547: ( state_type * $int ) > $o ).

tff(pred_def_14131,type,
    v26583: state_type > $o ).

tff(pred_def_14132,type,
    v26581: state_type > $o ).

tff(pred_def_14133,type,
    v26579: state_type > $o ).

tff(pred_def_14134,type,
    v26577: state_type > $o ).

tff(pred_def_14135,type,
    v26575: state_type > $o ).

tff(pred_def_14136,type,
    v26573: state_type > $o ).

tff(pred_def_14137,type,
    v26571: state_type > $o ).

tff(pred_def_14138,type,
    v26597: state_type > $o ).

tff(pred_def_14139,type,
    v26595: state_type > $o ).

tff(pred_def_14140,type,
    v26593: state_type > $o ).

tff(pred_def_14141,type,
    v26591: state_type > $o ).

tff(pred_def_14142,type,
    v26589: state_type > $o ).

tff(pred_def_14143,type,
    v26587: state_type > $o ).

tff(pred_def_14144,type,
    v26585: state_type > $o ).

tff(pred_def_14145,type,
    v26623: state_type > $o ).

tff(pred_def_14146,type,
    v26625: state_type > $o ).

tff(pred_def_14147,type,
    v26624: ( state_type * $int ) > $o ).

tff(pred_def_14148,type,
    v26626: state_type > $o ).

tff(pred_def_14149,type,
    v26621: ( state_type * $int ) > $o ).

tff(pred_def_14150,type,
    v26619: ( state_type * $int ) > $o ).

tff(pred_def_14151,type,
    v26627: ( state_type * $int ) > $o ).

tff(pred_def_14152,type,
    v26617: ( state_type * $int ) > $o ).

tff(pred_def_14153,type,
    v26615: ( state_type * $int ) > $o ).

tff(pred_def_14154,type,
    v26613: state_type > $o ).

tff(pred_def_14155,type,
    v26629: state_type > $o ).

tff(pred_def_14156,type,
    v26611: ( state_type * $int ) > $o ).

tff(pred_def_14157,type,
    v26609: ( state_type * $int ) > $o ).

tff(pred_def_14158,type,
    v26643: ( state_type * $int ) > $o ).

tff(pred_def_14159,type,
    v26641: ( state_type * $int ) > $o ).

tff(pred_def_14160,type,
    v26647: state_type > $o ).

tff(pred_def_14161,type,
    v26645: state_type > $o ).

tff(pred_def_14162,type,
    v26671: state_type > $o ).

tff(pred_def_14163,type,
    v26669: state_type > $o ).

tff(pred_def_14164,type,
    v26667: state_type > $o ).

tff(pred_def_14165,type,
    v26665: state_type > $o ).

tff(pred_def_14166,type,
    v26663: state_type > $o ).

tff(pred_def_14167,type,
    v26661: state_type > $o ).

tff(pred_def_14168,type,
    v26659: state_type > $o ).

tff(pred_def_14169,type,
    v26685: state_type > $o ).

tff(pred_def_14170,type,
    v26683: state_type > $o ).

tff(pred_def_14171,type,
    v26681: state_type > $o ).

tff(pred_def_14172,type,
    v26679: state_type > $o ).

tff(pred_def_14173,type,
    v26677: state_type > $o ).

tff(pred_def_14174,type,
    v26675: state_type > $o ).

tff(pred_def_14175,type,
    v26673: state_type > $o ).

tff(pred_def_14176,type,
    v26701: ( state_type * $int ) > $o ).

tff(pred_def_14177,type,
    v26699: ( state_type * $int ) > $o ).

tff(pred_def_14178,type,
    v26697: ( state_type * $int ) > $o ).

tff(pred_def_14179,type,
    v26695: ( state_type * $int ) > $o ).

tff(pred_def_14180,type,
    v26693: ( state_type * $int ) > $o ).

tff(pred_def_14181,type,
    v26731: ( state_type * $int ) > $o ).

tff(pred_def_14182,type,
    v26733: ( state_type * $int ) > $o ).

tff(pred_def_14183,type,
    v26729: ( state_type * $int ) > $o ).

tff(pred_def_14184,type,
    v26727: ( state_type * $int ) > $o ).

tff(pred_def_14185,type,
    v26725: ( state_type * $int ) > $o ).

tff(pred_def_14186,type,
    v26723: ( state_type * $int ) > $o ).

tff(pred_def_14187,type,
    v26721: state_type > $o ).

tff(pred_def_14188,type,
    v26719: state_type > $o ).

tff(pred_def_14189,type,
    v26737: state_type > $o ).

tff(pred_def_14190,type,
    v26735: state_type > $o ).

tff(pred_def_14191,type,
    v26739: state_type > $o ).

tff(pred_def_14192,type,
    v26717: state_type > $o ).

tff(pred_def_14193,type,
    v26715: state_type > $o ).

tff(pred_def_14194,type,
    v26713: state_type > $o ).

tff(pred_def_14195,type,
    v26711: state_type > $o ).

tff(pred_def_14196,type,
    v26709: state_type > $o ).

tff(pred_def_14197,type,
    v26707: state_type > $o ).

tff(pred_def_14198,type,
    v26705: state_type > $o ).

tff(pred_def_14199,type,
    v26703: state_type > $o ).

tff(pred_def_14200,type,
    v26749: ( state_type * $int ) > $o ).

tff(pred_def_14201,type,
    v26747: ( state_type * $int ) > $o ).

tff(pred_def_14202,type,
    v26745: ( state_type * $int ) > $o ).

tff(pred_def_14203,type,
    v26743: ( state_type * $int ) > $o ).

tff(pred_def_14204,type,
    v26741: ( state_type * $int ) > $o ).

tff(pred_def_14205,type,
    v26779: ( state_type * $int ) > $o ).

tff(pred_def_14206,type,
    v26777: ( state_type * $int ) > $o ).

tff(pred_def_14207,type,
    v26780: ( state_type * $int ) > $o ).

tff(pred_def_14208,type,
    v26775: ( state_type * $int ) > $o ).

tff(pred_def_14209,type,
    v26773: ( state_type * $int ) > $o ).

tff(pred_def_14210,type,
    v26771: ( state_type * $int ) > $o ).

tff(pred_def_14211,type,
    v26769: state_type > $o ).

tff(pred_def_14212,type,
    v26767: state_type > $o ).

tff(pred_def_14213,type,
    v26784: state_type > $o ).

tff(pred_def_14214,type,
    v26782: state_type > $o ).

tff(pred_def_14215,type,
    v26786: state_type > $o ).

tff(pred_def_14216,type,
    v26765: state_type > $o ).

tff(pred_def_14217,type,
    v26763: state_type > $o ).

tff(pred_def_14218,type,
    v26761: state_type > $o ).

tff(pred_def_14219,type,
    v26759: state_type > $o ).

tff(pred_def_14220,type,
    v26757: state_type > $o ).

tff(pred_def_14221,type,
    v26755: state_type > $o ).

tff(pred_def_14222,type,
    v26753: state_type > $o ).

tff(pred_def_14223,type,
    v26751: state_type > $o ).

tff(pred_def_14224,type,
    v26796: ( state_type * $int ) > $o ).

tff(pred_def_14225,type,
    v26794: ( state_type * $int ) > $o ).

tff(pred_def_14226,type,
    v26792: ( state_type * $int ) > $o ).

tff(pred_def_14227,type,
    v26790: ( state_type * $int ) > $o ).

tff(pred_def_14228,type,
    v26788: ( state_type * $int ) > $o ).

tff(pred_def_14229,type,
    v26816: state_type > $o ).

tff(pred_def_14230,type,
    v26814: state_type > $o ).

tff(pred_def_14231,type,
    v26820: state_type > $o ).

tff(pred_def_14232,type,
    v26818: state_type > $o ).

tff(pred_def_14233,type,
    v26822: state_type > $o ).

tff(pred_def_14234,type,
    v26812: state_type > $o ).

tff(pred_def_14235,type,
    v26810: state_type > $o ).

tff(pred_def_14236,type,
    v26808: state_type > $o ).

tff(pred_def_14237,type,
    v26806: state_type > $o ).

tff(pred_def_14238,type,
    v26804: state_type > $o ).

tff(pred_def_14239,type,
    v26802: state_type > $o ).

tff(pred_def_14240,type,
    v26800: state_type > $o ).

tff(pred_def_14241,type,
    v26798: state_type > $o ).

tff(pred_def_14242,type,
    v26832: ( state_type * $int ) > $o ).

tff(pred_def_14243,type,
    v26830: ( state_type * $int ) > $o ).

tff(pred_def_14244,type,
    v26828: ( state_type * $int ) > $o ).

tff(pred_def_14245,type,
    v26826: ( state_type * $int ) > $o ).

tff(pred_def_14246,type,
    v26824: ( state_type * $int ) > $o ).

tff(pred_def_14247,type,
    v26852: state_type > $o ).

tff(pred_def_14248,type,
    v26850: state_type > $o ).

tff(pred_def_14249,type,
    v26856: state_type > $o ).

tff(pred_def_14250,type,
    v26854: state_type > $o ).

tff(pred_def_14251,type,
    v26858: state_type > $o ).

tff(pred_def_14252,type,
    v26848: state_type > $o ).

tff(pred_def_14253,type,
    v26846: state_type > $o ).

tff(pred_def_14254,type,
    v26844: state_type > $o ).

tff(pred_def_14255,type,
    v26842: state_type > $o ).

tff(pred_def_14256,type,
    v26840: state_type > $o ).

tff(pred_def_14257,type,
    v26838: state_type > $o ).

tff(pred_def_14258,type,
    v26836: state_type > $o ).

tff(pred_def_14259,type,
    v26834: state_type > $o ).

tff(pred_def_14260,type,
    v26864: state_type > $o ).

tff(pred_def_14261,type,
    v26863: ( state_type * $int ) > $o ).

tff(pred_def_14262,type,
    v26862: ( state_type * $int ) > $o ).

tff(pred_def_14263,type,
    v26867: state_type > $o ).

tff(pred_def_14264,type,
    v26866: ( state_type * $int ) > $o ).

tff(pred_def_14265,type,
    v26865: ( state_type * $int ) > $o ).

tff(pred_def_14266,type,
    v26861: ( state_type * $int ) > $o ).

tff(pred_def_14267,type,
    v26870: state_type > $o ).

tff(pred_def_14268,type,
    v26869: ( state_type * $int ) > $o ).

tff(pred_def_14269,type,
    v26868: ( state_type * $int ) > $o ).

tff(pred_def_14270,type,
    v26860: ( state_type * $int ) > $o ).

tff(pred_def_14271,type,
    v26873: state_type > $o ).

tff(pred_def_14272,type,
    v26872: ( state_type * $int ) > $o ).

tff(pred_def_14273,type,
    v26871: ( state_type * $int ) > $o ).

tff(pred_def_14274,type,
    v26691: ( state_type * $int ) > $o ).

tff(pred_def_14275,type,
    v26689: ( state_type * $int ) > $o ).

tff(pred_def_14276,type,
    v26687: ( state_type * $int ) > $o ).

tff(pred_def_14277,type,
    v26885: state_type > $o ).

tff(pred_def_14278,type,
    v26883: state_type > $o ).

tff(pred_def_14279,type,
    v26881: state_type > $o ).

tff(pred_def_14280,type,
    v26895: state_type > $o ).

tff(pred_def_14281,type,
    v26893: state_type > $o ).

tff(pred_def_14282,type,
    v26891: state_type > $o ).

tff(pred_def_14283,type,
    v26889: state_type > $o ).

tff(pred_def_14284,type,
    v26887: state_type > $o ).

tff(pred_def_14285,type,
    v26897: state_type > $o ).

tff(pred_def_14286,type,
    v26879: state_type > $o ).

tff(pred_def_14287,type,
    v26877: state_type > $o ).

tff(pred_def_14288,type,
    v26875: state_type > $o ).

tff(pred_def_14289,type,
    v26904: state_type > $o ).

tff(pred_def_14290,type,
    v26902: state_type > $o ).

tff(pred_def_14291,type,
    v26901: state_type > $o ).

tff(pred_def_14292,type,
    v26900: state_type > $o ).

tff(pred_def_14293,type,
    v26912: state_type > $o ).

tff(pred_def_14294,type,
    v26913: state_type > $o ).

tff(pred_def_14295,type,
    v26911: state_type > $o ).

tff(pred_def_14296,type,
    v26908: ( state_type * $int ) > $o ).

tff(pred_def_14297,type,
    v26910: ( state_type * $int ) > $o ).

tff(pred_def_14298,type,
    v26657: ( state_type * $int ) > $o ).

tff(pred_def_14299,type,
    v26655: ( state_type * $int ) > $o ).

tff(pred_def_14300,type,
    v26653: ( state_type * $int ) > $o ).

tff(pred_def_14301,type,
    v26651: ( state_type * $int ) > $o ).

tff(pred_def_14302,type,
    v26649: ( state_type * $int ) > $o ).

tff(pred_def_14303,type,
    v26919: state_type > $o ).

tff(pred_def_14304,type,
    v26917: state_type > $o ).

tff(pred_def_14305,type,
    v26923: state_type > $o ).

tff(pred_def_14306,type,
    v26922: ( state_type * $int ) > $o ).

tff(pred_def_14307,type,
    v26921: ( state_type * $int ) > $o ).

tff(pred_def_14308,type,
    v26926: state_type > $o ).

tff(pred_def_14309,type,
    v26925: ( state_type * $int ) > $o ).

tff(pred_def_14310,type,
    v26924: ( state_type * $int ) > $o ).

tff(pred_def_14311,type,
    v26639: ( state_type * $int ) > $o ).

tff(pred_def_14312,type,
    v26637: ( state_type * $int ) > $o ).

tff(pred_def_14313,type,
    v26635: ( state_type * $int ) > $o ).

tff(pred_def_14314,type,
    v26633: ( state_type * $int ) > $o ).

tff(pred_def_14315,type,
    v26631: ( state_type * $int ) > $o ).

tff(pred_def_14316,type,
    v26607: ( state_type * $int ) > $o ).

tff(pred_def_14317,type,
    v26605: ( state_type * $int ) > $o ).

tff(pred_def_14318,type,
    v26603: ( state_type * $int ) > $o ).

tff(pred_def_14319,type,
    v26601: ( state_type * $int ) > $o ).

tff(pred_def_14320,type,
    v26599: ( state_type * $int ) > $o ).

tff(pred_def_14321,type,
    v26939: state_type > $o ).

tff(pred_def_14322,type,
    v26937: state_type > $o ).

tff(pred_def_14323,type,
    v26935: state_type > $o ).

tff(pred_def_14324,type,
    v26945: state_type > $o ).

tff(pred_def_14325,type,
    v26943: state_type > $o ).

tff(pred_def_14326,type,
    v26963: ( state_type * $int ) > $o ).

tff(pred_def_14327,type,
    v26965: ( state_type * $int ) > $o ).

tff(pred_def_14328,type,
    v26961: ( state_type * $int ) > $o ).

tff(pred_def_14329,type,
    v26959: state_type > $o ).

tff(pred_def_14330,type,
    v26957: state_type > $o ).

tff(pred_def_14331,type,
    v26969: state_type > $o ).

tff(pred_def_14332,type,
    v26967: state_type > $o ).

tff(pred_def_14333,type,
    v26973: state_type > $o ).

tff(pred_def_14334,type,
    v26971: state_type > $o ).

tff(pred_def_14335,type,
    v26976: state_type > $o ).

tff(pred_def_14336,type,
    v26975: state_type > $o ).

tff(pred_def_14337,type,
    v26955: state_type > $o ).

tff(pred_def_14338,type,
    v26953: state_type > $o ).

tff(pred_def_14339,type,
    v26951: state_type > $o ).

tff(pred_def_14340,type,
    v26949: state_type > $o ).

tff(pred_def_14341,type,
    v26947: state_type > $o ).

tff(pred_def_14342,type,
    v26984: state_type > $o ).

tff(pred_def_14343,type,
    v26982: state_type > $o ).

tff(pred_def_14344,type,
    v26980: state_type > $o ).

tff(pred_def_14345,type,
    v26978: state_type > $o ).

tff(pred_def_14346,type,
    v26941: state_type > $o ).

tff(pred_def_14347,type,
    v26990: state_type > $o ).

tff(pred_def_14348,type,
    v26992: state_type > $o ).

tff(pred_def_14349,type,
    v26988: state_type > $o ).

tff(pred_def_14350,type,
    v26987: state_type > $o ).

tff(pred_def_14351,type,
    v26998: state_type > $o ).

tff(pred_def_14352,type,
    v26999: state_type > $o ).

tff(pred_def_14353,type,
    v26995: state_type > $o ).

tff(pred_def_14354,type,
    v26997: state_type > $o ).

tff(pred_def_14355,type,
    v27009: state_type > $o ).

tff(pred_def_14356,type,
    v27007: state_type > $o ).

tff(pred_def_14357,type,
    v27005: state_type > $o ).

tff(pred_def_14358,type,
    v27003: state_type > $o ).

tff(pred_def_14359,type,
    v27011: state_type > $o ).

tff(pred_def_14360,type,
    v26933: state_type > $o ).

tff(pred_def_14361,type,
    v26931: state_type > $o ).

tff(pred_def_14362,type,
    v26929: state_type > $o ).

tff(pred_def_14363,type,
    v27018: state_type > $o ).

tff(pred_def_14364,type,
    v27016: state_type > $o ).

tff(pred_def_14365,type,
    v27015: state_type > $o ).

tff(pred_def_14366,type,
    v27014: state_type > $o ).

tff(pred_def_14367,type,
    v27026: state_type > $o ).

tff(pred_def_14368,type,
    v27027: state_type > $o ).

tff(pred_def_14369,type,
    v27025: state_type > $o ).

tff(pred_def_14370,type,
    v27022: ( state_type * $int ) > $o ).

tff(pred_def_14371,type,
    v27024: ( state_type * $int ) > $o ).

tff(pred_def_14372,type,
    v26569: ( state_type * $int ) > $o ).

tff(pred_def_14373,type,
    v26567: ( state_type * $int ) > $o ).

tff(pred_def_14374,type,
    v26565: ( state_type * $int ) > $o ).

tff(pred_def_14375,type,
    v26563: ( state_type * $int ) > $o ).

tff(pred_def_14376,type,
    v26561: ( state_type * $int ) > $o ).

tff(pred_def_14377,type,
    v27063: state_type > $o ).

tff(pred_def_14378,type,
    v27061: state_type > $o ).

tff(pred_def_14379,type,
    v27059: state_type > $o ).

tff(pred_def_14380,type,
    v27057: state_type > $o ).

tff(pred_def_14381,type,
    v27055: state_type > $o ).

tff(pred_def_14382,type,
    v27053: state_type > $o ).

tff(pred_def_14383,type,
    v27073: state_type > $o ).

tff(pred_def_14384,type,
    v27071: state_type > $o ).

tff(pred_def_14385,type,
    v27069: state_type > $o ).

tff(pred_def_14386,type,
    v27067: state_type > $o ).

tff(pred_def_14387,type,
    v27065: state_type > $o ).

tff(pred_def_14388,type,
    v27100: state_type > $o ).

tff(pred_def_14389,type,
    v27099: ( state_type * $int ) > $o ).

tff(pred_def_14390,type,
    v27098: ( state_type * $int ) > $o ).

tff(pred_def_14391,type,
    v27096: ( state_type * $int ) > $o ).

tff(pred_def_14392,type,
    v27116: state_type > $o ).

tff(pred_def_14393,type,
    v27117: ( state_type * $int ) > $o ).

tff(pred_def_14394,type,
    v27118: state_type > $o ).

tff(pred_def_14395,type,
    v27114: ( state_type * $int ) > $o ).

tff(pred_def_14396,type,
    v27112: ( state_type * $int ) > $o ).

tff(pred_def_14397,type,
    v27142: ( state_type * $int ) > $o ).

tff(pred_def_14398,type,
    v27051: ( state_type * $int ) > $o ).

tff(pred_def_14399,type,
    v27140: ( state_type * $int ) > $o ).

tff(pred_def_14400,type,
    v27143: ( state_type * $int ) > $o ).

tff(pred_def_14401,type,
    v27138: ( state_type * $int ) > $o ).

tff(pred_def_14402,type,
    v27136: ( state_type * $int ) > $o ).

tff(pred_def_14403,type,
    v27134: ( state_type * $int ) > $o ).

tff(pred_def_14404,type,
    v27132: state_type > $o ).

tff(pred_def_14405,type,
    v27130: state_type > $o ).

tff(pred_def_14406,type,
    v27149: state_type > $o ).

tff(pred_def_14407,type,
    v27089: state_type > $o ).

tff(pred_def_14408,type,
    v27148: ( state_type * $int ) > $o ).

tff(pred_def_14409,type,
    v27087: ( state_type * $int ) > $o ).

tff(pred_def_14410,type,
    v27085: ( state_type * $int ) > $o ).

tff(pred_def_14411,type,
    v27164: ( state_type * $int ) > $o ).

tff(pred_def_14412,type,
    v27163: ( state_type * $int ) > $o ).

tff(pred_def_14413,type,
    v27161: ( state_type * $int ) > $o ).

tff(pred_def_14414,type,
    v27168: state_type > $o ).

tff(pred_def_14415,type,
    v27166: state_type > $o ).

tff(pred_def_14416,type,
    v27179: ( state_type * $int ) > $o ).

tff(pred_def_14417,type,
    v27178: state_type > $o ).

tff(pred_def_14418,type,
    v27182: state_type > $o ).

tff(pred_def_14419,type,
    v27183: state_type > $o ).

tff(pred_def_14420,type,
    v27181: state_type > $o ).

tff(pred_def_14421,type,
    v27184: state_type > $o ).

tff(pred_def_14422,type,
    v27180: state_type > $o ).

tff(pred_def_14423,type,
    v27177: state_type > $o ).

tff(pred_def_14424,type,
    v27185: state_type > $o ).

tff(pred_def_14425,type,
    v27176: state_type > $o ).

tff(pred_def_14426,type,
    v27188: state_type > $o ).

tff(pred_def_14427,type,
    v27189: state_type > $o ).

tff(pred_def_14428,type,
    v27187: state_type > $o ).

tff(pred_def_14429,type,
    v27190: state_type > $o ).

tff(pred_def_14430,type,
    v27186: state_type > $o ).

tff(pred_def_14431,type,
    v27175: state_type > $o ).

tff(pred_def_14432,type,
    v27191: state_type > $o ).

tff(pred_def_14433,type,
    v27174: state_type > $o ).

tff(pred_def_14434,type,
    v27173: state_type > $o ).

tff(pred_def_14435,type,
    v27195: state_type > $o ).

tff(pred_def_14436,type,
    v27196: state_type > $o ).

tff(pred_def_14437,type,
    v27194: state_type > $o ).

tff(pred_def_14438,type,
    v27197: state_type > $o ).

tff(pred_def_14439,type,
    v27193: state_type > $o ).

tff(pred_def_14440,type,
    v27192: state_type > $o ).

tff(pred_def_14441,type,
    v27172: state_type > $o ).

tff(pred_def_14442,type,
    v27198: state_type > $o ).

tff(pred_def_14443,type,
    v27171: state_type > $o ).

tff(pred_def_14444,type,
    v27201: state_type > $o ).

tff(pred_def_14445,type,
    v27202: state_type > $o ).

tff(pred_def_14446,type,
    v27200: state_type > $o ).

tff(pred_def_14447,type,
    v27203: state_type > $o ).

tff(pred_def_14448,type,
    v27199: state_type > $o ).

tff(pred_def_14449,type,
    v27206: state_type > $o ).

tff(pred_def_14450,type,
    v27207: state_type > $o ).

tff(pred_def_14451,type,
    v27205: state_type > $o ).

tff(pred_def_14452,type,
    v27208: state_type > $o ).

tff(pred_def_14453,type,
    v27204: state_type > $o ).

tff(pred_def_14454,type,
    v27211: state_type > $o ).

tff(pred_def_14455,type,
    v27212: state_type > $o ).

tff(pred_def_14456,type,
    v27210: state_type > $o ).

tff(pred_def_14457,type,
    v27213: state_type > $o ).

tff(pred_def_14458,type,
    v27209: state_type > $o ).

tff(pred_def_14459,type,
    v27169: ( state_type * $int ) > $o ).

tff(pred_def_14460,type,
    v27159: ( state_type * $int ) > $o ).

tff(pred_def_14461,type,
    v27157: ( state_type * $int ) > $o ).

tff(pred_def_14462,type,
    v27155: ( state_type * $int ) > $o ).

tff(pred_def_14463,type,
    v27153: ( state_type * $int ) > $o ).

tff(pred_def_14464,type,
    v27151: ( state_type * $int ) > $o ).

tff(pred_def_14465,type,
    v27214: ( state_type * $int ) > $o ).

tff(pred_def_14466,type,
    v27083: ( state_type * $int ) > $o ).

tff(pred_def_14467,type,
    v27081: ( state_type * $int ) > $o ).

tff(pred_def_14468,type,
    v27079: ( state_type * $int ) > $o ).

tff(pred_def_14469,type,
    v27215: ( state_type * $int ) > $o ).

tff(pred_def_14470,type,
    v27216: ( state_type * $int ) > $o ).

tff(pred_def_14471,type,
    v27077: ( state_type * $int ) > $o ).

tff(pred_def_14472,type,
    v27075: ( state_type * $int ) > $o ).

tff(pred_def_14473,type,
    v27226: state_type > $o ).

tff(pred_def_14474,type,
    v27224: state_type > $o ).

tff(pred_def_14475,type,
    v27232: state_type > $o ).

tff(pred_def_14476,type,
    v27230: state_type > $o ).

tff(pred_def_14477,type,
    v27236: state_type > $o ).

tff(pred_def_14478,type,
    v27234: state_type > $o ).

tff(pred_def_14479,type,
    v27240: state_type > $o ).

tff(pred_def_14480,type,
    v27238: state_type > $o ).

tff(pred_def_14481,type,
    v27228: state_type > $o ).

tff(pred_def_14482,type,
    v27246: state_type > $o ).

tff(pred_def_14483,type,
    v27248: state_type > $o ).

tff(pred_def_14484,type,
    v27244: state_type > $o ).

tff(pred_def_14485,type,
    v27243: state_type > $o ).

tff(pred_def_14486,type,
    v27254: state_type > $o ).

tff(pred_def_14487,type,
    v27255: state_type > $o ).

tff(pred_def_14488,type,
    v27251: state_type > $o ).

tff(pred_def_14489,type,
    v27253: state_type > $o ).

tff(pred_def_14490,type,
    v27261: state_type > $o ).

tff(pred_def_14491,type,
    v27259: state_type > $o ).

tff(pred_def_14492,type,
    v27263: state_type > $o ).

tff(pred_def_14493,type,
    v27222: state_type > $o ).

tff(pred_def_14494,type,
    v27220: state_type > $o ).

tff(pred_def_14495,type,
    v27218: state_type > $o ).

tff(pred_def_14496,type,
    v27270: state_type > $o ).

tff(pred_def_14497,type,
    v27268: state_type > $o ).

tff(pred_def_14498,type,
    v27267: state_type > $o ).

tff(pred_def_14499,type,
    v27266: state_type > $o ).

tff(pred_def_14500,type,
    v27278: state_type > $o ).

tff(pred_def_14501,type,
    v27279: state_type > $o ).

tff(pred_def_14502,type,
    v27277: state_type > $o ).

tff(pred_def_14503,type,
    v27274: ( state_type * $int ) > $o ).

tff(pred_def_14504,type,
    v27276: ( state_type * $int ) > $o ).

tff(pred_def_14505,type,
    v27265: ( state_type * $int ) > $o ).

tff(pred_def_14506,type,
    v27147: state_type > $o ).

tff(pred_def_14507,type,
    v27145: state_type > $o ).

tff(pred_def_14508,type,
    v27291: state_type > $o ).

tff(pred_def_14509,type,
    v27289: state_type > $o ).

tff(pred_def_14510,type,
    v27288: state_type > $o ).

tff(pred_def_14511,type,
    v27287: ( state_type * $int ) > $o ).

tff(pred_def_14512,type,
    v27285: state_type > $o ).

tff(pred_def_14513,type,
    v27283: state_type > $o ).

tff(pred_def_14514,type,
    v27296: state_type > $o ).

tff(pred_def_14515,type,
    v27295: state_type > $o ).

tff(pred_def_14516,type,
    v27128: state_type > $o ).

tff(pred_def_14517,type,
    v27126: state_type > $o ).

tff(pred_def_14518,type,
    v27124: state_type > $o ).

tff(pred_def_14519,type,
    v27297: ( state_type * $int ) > $o ).

tff(pred_def_14520,type,
    v27298: state_type > $o ).

tff(pred_def_14521,type,
    v27122: ( state_type * $int ) > $o ).

tff(pred_def_14522,type,
    v27120: ( state_type * $int ) > $o ).

tff(pred_def_14523,type,
    v27299: ( state_type * $int ) > $o ).

tff(pred_def_14524,type,
    v27110: ( state_type * $int ) > $o ).

tff(pred_def_14525,type,
    v27108: ( state_type * $int ) > $o ).

tff(pred_def_14526,type,
    v27106: state_type > $o ).

tff(pred_def_14527,type,
    v27300: ( state_type * $int ) > $o ).

tff(pred_def_14528,type,
    v27301: state_type > $o ).

tff(pred_def_14529,type,
    v27104: ( state_type * $int ) > $o ).

tff(pred_def_14530,type,
    v27102: ( state_type * $int ) > $o ).

tff(pred_def_14531,type,
    v27302: ( state_type * $int ) > $o ).

tff(pred_def_14532,type,
    v27094: ( state_type * $int ) > $o ).

tff(pred_def_14533,type,
    v27092: ( state_type * $int ) > $o ).

tff(pred_def_14534,type,
    v27308: state_type > $o ).

tff(pred_def_14535,type,
    v27306: state_type > $o ).

tff(pred_def_14536,type,
    v27305: state_type > $o ).

tff(pred_def_14537,type,
    v27304: ( state_type * $int ) > $o ).

tff(pred_def_14538,type,
    v27049: state_type > $o ).

tff(pred_def_14539,type,
    v27047: state_type > $o ).

tff(pred_def_14540,type,
    v27314: state_type > $o ).

tff(pred_def_14541,type,
    v27312: state_type > $o ).

tff(pred_def_14542,type,
    v27318: state_type > $o ).

tff(pred_def_14543,type,
    v27316: state_type > $o ).

tff(pred_def_14544,type,
    v27321: state_type > $o ).

tff(pred_def_14545,type,
    v27320: state_type > $o ).

tff(pred_def_14546,type,
    v27045: state_type > $o ).

tff(pred_def_14547,type,
    v27043: state_type > $o ).

tff(pred_def_14548,type,
    v27041: state_type > $o ).

tff(pred_def_14549,type,
    v27039: state_type > $o ).

tff(pred_def_14550,type,
    v27037: state_type > $o ).

tff(pred_def_14551,type,
    v27035: state_type > $o ).

tff(pred_def_14552,type,
    v27033: state_type > $o ).

tff(pred_def_14553,type,
    v27031: state_type > $o ).

tff(pred_def_14554,type,
    v27341: state_type > $o ).

tff(pred_def_14555,type,
    v27339: state_type > $o ).

tff(pred_def_14556,type,
    v27337: state_type > $o ).

tff(pred_def_14557,type,
    v27335: state_type > $o ).

tff(pred_def_14558,type,
    v27333: state_type > $o ).

tff(pred_def_14559,type,
    v27351: state_type > $o ).

tff(pred_def_14560,type,
    v27349: state_type > $o ).

tff(pred_def_14561,type,
    v27347: state_type > $o ).

tff(pred_def_14562,type,
    v27345: state_type > $o ).

tff(pred_def_14563,type,
    v27343: state_type > $o ).

tff(pred_def_14564,type,
    v27355: ( state_type * $int ) > $o ).

tff(pred_def_14565,type,
    v27353: ( state_type * $int ) > $o ).

tff(pred_def_14566,type,
    v27365: state_type > $o ).

tff(pred_def_14567,type,
    v27363: state_type > $o ).

tff(pred_def_14568,type,
    v27371: state_type > $o ).

tff(pred_def_14569,type,
    v27369: state_type > $o ).

tff(pred_def_14570,type,
    v27395: ( state_type * $int ) > $o ).

tff(pred_def_14571,type,
    v27393: ( state_type * $int ) > $o ).

tff(pred_def_14572,type,
    v27396: ( state_type * $int ) > $o ).

tff(pred_def_14573,type,
    v27391: ( state_type * $int ) > $o ).

tff(pred_def_14574,type,
    v27389: ( state_type * $int ) > $o ).

tff(pred_def_14575,type,
    v27387: ( state_type * $int ) > $o ).

tff(pred_def_14576,type,
    v27385: state_type > $o ).

tff(pred_def_14577,type,
    v27383: state_type > $o ).

tff(pred_def_14578,type,
    v27400: state_type > $o ).

tff(pred_def_14579,type,
    v27398: state_type > $o ).

tff(pred_def_14580,type,
    v27404: state_type > $o ).

tff(pred_def_14581,type,
    v27402: state_type > $o ).

tff(pred_def_14582,type,
    v27407: state_type > $o ).

tff(pred_def_14583,type,
    v27406: state_type > $o ).

tff(pred_def_14584,type,
    v27381: state_type > $o ).

tff(pred_def_14585,type,
    v27379: state_type > $o ).

tff(pred_def_14586,type,
    v27377: state_type > $o ).

tff(pred_def_14587,type,
    v27375: state_type > $o ).

tff(pred_def_14588,type,
    v27373: state_type > $o ).

tff(pred_def_14589,type,
    v27411: state_type > $o ).

tff(pred_def_14590,type,
    v27409: state_type > $o ).

tff(pred_def_14591,type,
    v27367: state_type > $o ).

tff(pred_def_14592,type,
    v27417: state_type > $o ).

tff(pred_def_14593,type,
    v27419: state_type > $o ).

tff(pred_def_14594,type,
    v27415: state_type > $o ).

tff(pred_def_14595,type,
    v27414: state_type > $o ).

tff(pred_def_14596,type,
    v27425: state_type > $o ).

tff(pred_def_14597,type,
    v27426: state_type > $o ).

tff(pred_def_14598,type,
    v27422: state_type > $o ).

tff(pred_def_14599,type,
    v27424: state_type > $o ).

tff(pred_def_14600,type,
    v27432: state_type > $o ).

tff(pred_def_14601,type,
    v27430: state_type > $o ).

tff(pred_def_14602,type,
    v27434: state_type > $o ).

tff(pred_def_14603,type,
    v27361: state_type > $o ).

tff(pred_def_14604,type,
    v27359: state_type > $o ).

tff(pred_def_14605,type,
    v27357: state_type > $o ).

tff(pred_def_14606,type,
    v27441: state_type > $o ).

tff(pred_def_14607,type,
    v27439: state_type > $o ).

tff(pred_def_14608,type,
    v27438: state_type > $o ).

tff(pred_def_14609,type,
    v27437: state_type > $o ).

tff(pred_def_14610,type,
    v27449: state_type > $o ).

tff(pred_def_14611,type,
    v27450: state_type > $o ).

tff(pred_def_14612,type,
    v27448: state_type > $o ).

tff(pred_def_14613,type,
    v27445: ( state_type * $int ) > $o ).

tff(pred_def_14614,type,
    v27447: ( state_type * $int ) > $o ).

tff(pred_def_14615,type,
    v27331: ( state_type * $int ) > $o ).

tff(pred_def_14616,type,
    v27329: ( state_type * $int ) > $o ).

tff(pred_def_14617,type,
    v27327: ( state_type * $int ) > $o ).

tff(pred_def_14618,type,
    v27325: ( state_type * $int ) > $o ).

tff(pred_def_14619,type,
    v27323: ( state_type * $int ) > $o ).

tff(pred_def_14620,type,
    v27472: state_type > $o ).

tff(pred_def_14621,type,
    v27470: state_type > $o ).

tff(pred_def_14622,type,
    v27476: state_type > $o ).

tff(pred_def_14623,type,
    v27474: state_type > $o ).

tff(pred_def_14624,type,
    v27480: state_type > $o ).

tff(pred_def_14625,type,
    v27478: state_type > $o ).

tff(pred_def_14626,type,
    v27483: state_type > $o ).

tff(pred_def_14627,type,
    v27482: state_type > $o ).

tff(pred_def_14628,type,
    v27468: state_type > $o ).

tff(pred_def_14629,type,
    v27466: state_type > $o ).

tff(pred_def_14630,type,
    v27464: state_type > $o ).

tff(pred_def_14631,type,
    v27462: state_type > $o ).

tff(pred_def_14632,type,
    v27460: state_type > $o ).

tff(pred_def_14633,type,
    v27458: state_type > $o ).

tff(pred_def_14634,type,
    v27456: state_type > $o ).

tff(pred_def_14635,type,
    v27454: state_type > $o ).

tff(pred_def_14636,type,
    v27503: state_type > $o ).

tff(pred_def_14637,type,
    v27501: state_type > $o ).

tff(pred_def_14638,type,
    v27499: state_type > $o ).

tff(pred_def_14639,type,
    v27497: state_type > $o ).

tff(pred_def_14640,type,
    v27495: state_type > $o ).

tff(pred_def_14641,type,
    v27513: state_type > $o ).

tff(pred_def_14642,type,
    v27511: state_type > $o ).

tff(pred_def_14643,type,
    v27509: state_type > $o ).

tff(pred_def_14644,type,
    v27507: state_type > $o ).

tff(pred_def_14645,type,
    v27505: state_type > $o ).

tff(pred_def_14646,type,
    v27517: ( state_type * $int ) > $o ).

tff(pred_def_14647,type,
    v27515: ( state_type * $int ) > $o ).

tff(pred_def_14648,type,
    v27527: state_type > $o ).

tff(pred_def_14649,type,
    v27525: state_type > $o ).

tff(pred_def_14650,type,
    v27533: state_type > $o ).

tff(pred_def_14651,type,
    v27531: state_type > $o ).

tff(pred_def_14652,type,
    v27547: state_type > $o ).

tff(pred_def_14653,type,
    v27545: state_type > $o ).

tff(pred_def_14654,type,
    v27551: state_type > $o ).

tff(pred_def_14655,type,
    v27549: state_type > $o ).

tff(pred_def_14656,type,
    v27555: state_type > $o ).

tff(pred_def_14657,type,
    v27553: state_type > $o ).

tff(pred_def_14658,type,
    v27558: state_type > $o ).

tff(pred_def_14659,type,
    v27557: state_type > $o ).

tff(pred_def_14660,type,
    v27543: state_type > $o ).

tff(pred_def_14661,type,
    v27541: state_type > $o ).

tff(pred_def_14662,type,
    v27539: state_type > $o ).

tff(pred_def_14663,type,
    v27537: state_type > $o ).

tff(pred_def_14664,type,
    v27535: state_type > $o ).

tff(pred_def_14665,type,
    v27562: state_type > $o ).

tff(pred_def_14666,type,
    v27560: state_type > $o ).

tff(pred_def_14667,type,
    v27529: state_type > $o ).

tff(pred_def_14668,type,
    v27568: state_type > $o ).

tff(pred_def_14669,type,
    v27570: state_type > $o ).

tff(pred_def_14670,type,
    v27566: state_type > $o ).

tff(pred_def_14671,type,
    v27565: state_type > $o ).

tff(pred_def_14672,type,
    v27576: state_type > $o ).

tff(pred_def_14673,type,
    v27577: state_type > $o ).

tff(pred_def_14674,type,
    v27573: state_type > $o ).

tff(pred_def_14675,type,
    v27575: state_type > $o ).

tff(pred_def_14676,type,
    v27583: state_type > $o ).

tff(pred_def_14677,type,
    v27581: state_type > $o ).

tff(pred_def_14678,type,
    v27585: state_type > $o ).

tff(pred_def_14679,type,
    v27523: state_type > $o ).

tff(pred_def_14680,type,
    v27521: state_type > $o ).

tff(pred_def_14681,type,
    v27519: state_type > $o ).

tff(pred_def_14682,type,
    v27592: state_type > $o ).

tff(pred_def_14683,type,
    v27590: state_type > $o ).

tff(pred_def_14684,type,
    v27589: state_type > $o ).

tff(pred_def_14685,type,
    v27588: state_type > $o ).

tff(pred_def_14686,type,
    v27600: state_type > $o ).

tff(pred_def_14687,type,
    v27601: state_type > $o ).

tff(pred_def_14688,type,
    v27599: state_type > $o ).

tff(pred_def_14689,type,
    v27596: ( state_type * $int ) > $o ).

tff(pred_def_14690,type,
    v27598: ( state_type * $int ) > $o ).

tff(pred_def_14691,type,
    v27493: ( state_type * $int ) > $o ).

tff(pred_def_14692,type,
    v27491: ( state_type * $int ) > $o ).

tff(pred_def_14693,type,
    v27489: ( state_type * $int ) > $o ).

tff(pred_def_14694,type,
    v27487: ( state_type * $int ) > $o ).

tff(pred_def_14695,type,
    v27485: ( state_type * $int ) > $o ).

tff(pred_def_14696,type,
    v27623: state_type > $o ).

tff(pred_def_14697,type,
    v27621: state_type > $o ).

tff(pred_def_14698,type,
    v27627: state_type > $o ).

tff(pred_def_14699,type,
    v27625: state_type > $o ).

tff(pred_def_14700,type,
    v27631: state_type > $o ).

tff(pred_def_14701,type,
    v27629: state_type > $o ).

tff(pred_def_14702,type,
    v27634: state_type > $o ).

tff(pred_def_14703,type,
    v27633: state_type > $o ).

tff(pred_def_14704,type,
    v27619: state_type > $o ).

tff(pred_def_14705,type,
    v27617: state_type > $o ).

tff(pred_def_14706,type,
    v27615: state_type > $o ).

tff(pred_def_14707,type,
    v27613: state_type > $o ).

tff(pred_def_14708,type,
    v27611: state_type > $o ).

tff(pred_def_14709,type,
    v27609: state_type > $o ).

tff(pred_def_14710,type,
    v27607: state_type > $o ).

tff(pred_def_14711,type,
    v27605: state_type > $o ).

tff(pred_def_14712,type,
    v27654: state_type > $o ).

tff(pred_def_14713,type,
    v27652: state_type > $o ).

tff(pred_def_14714,type,
    v27650: state_type > $o ).

tff(pred_def_14715,type,
    v27648: state_type > $o ).

tff(pred_def_14716,type,
    v27646: state_type > $o ).

tff(pred_def_14717,type,
    v27664: state_type > $o ).

tff(pred_def_14718,type,
    v27662: state_type > $o ).

tff(pred_def_14719,type,
    v27660: state_type > $o ).

tff(pred_def_14720,type,
    v27658: state_type > $o ).

tff(pred_def_14721,type,
    v27656: state_type > $o ).

tff(pred_def_14722,type,
    v27668: ( state_type * $int ) > $o ).

tff(pred_def_14723,type,
    v27666: ( state_type * $int ) > $o ).

tff(pred_def_14724,type,
    v27678: state_type > $o ).

tff(pred_def_14725,type,
    v27676: state_type > $o ).

tff(pred_def_14726,type,
    v27684: state_type > $o ).

tff(pred_def_14727,type,
    v27682: state_type > $o ).

tff(pred_def_14728,type,
    v27698: state_type > $o ).

tff(pred_def_14729,type,
    v27696: state_type > $o ).

tff(pred_def_14730,type,
    v27702: state_type > $o ).

tff(pred_def_14731,type,
    v27700: state_type > $o ).

tff(pred_def_14732,type,
    v27706: state_type > $o ).

tff(pred_def_14733,type,
    v27704: state_type > $o ).

tff(pred_def_14734,type,
    v27709: state_type > $o ).

tff(pred_def_14735,type,
    v27708: state_type > $o ).

tff(pred_def_14736,type,
    v27694: state_type > $o ).

tff(pred_def_14737,type,
    v27692: state_type > $o ).

tff(pred_def_14738,type,
    v27690: state_type > $o ).

tff(pred_def_14739,type,
    v27688: state_type > $o ).

tff(pred_def_14740,type,
    v27686: state_type > $o ).

tff(pred_def_14741,type,
    v27713: state_type > $o ).

tff(pred_def_14742,type,
    v27711: state_type > $o ).

tff(pred_def_14743,type,
    v27680: state_type > $o ).

tff(pred_def_14744,type,
    v27719: state_type > $o ).

tff(pred_def_14745,type,
    v27721: state_type > $o ).

tff(pred_def_14746,type,
    v27717: state_type > $o ).

tff(pred_def_14747,type,
    v27716: state_type > $o ).

tff(pred_def_14748,type,
    v27727: state_type > $o ).

tff(pred_def_14749,type,
    v27728: state_type > $o ).

tff(pred_def_14750,type,
    v27724: state_type > $o ).

tff(pred_def_14751,type,
    v27726: state_type > $o ).

tff(pred_def_14752,type,
    v27734: state_type > $o ).

tff(pred_def_14753,type,
    v27732: state_type > $o ).

tff(pred_def_14754,type,
    v27736: state_type > $o ).

tff(pred_def_14755,type,
    v27674: state_type > $o ).

tff(pred_def_14756,type,
    v27672: state_type > $o ).

tff(pred_def_14757,type,
    v27670: state_type > $o ).

tff(pred_def_14758,type,
    v27743: state_type > $o ).

tff(pred_def_14759,type,
    v27741: state_type > $o ).

tff(pred_def_14760,type,
    v27740: state_type > $o ).

tff(pred_def_14761,type,
    v27739: state_type > $o ).

tff(pred_def_14762,type,
    v27751: state_type > $o ).

tff(pred_def_14763,type,
    v27752: state_type > $o ).

tff(pred_def_14764,type,
    v27750: state_type > $o ).

tff(pred_def_14765,type,
    v27747: ( state_type * $int ) > $o ).

tff(pred_def_14766,type,
    v27749: ( state_type * $int ) > $o ).

tff(pred_def_14767,type,
    v27644: ( state_type * $int ) > $o ).

tff(pred_def_14768,type,
    v27642: ( state_type * $int ) > $o ).

tff(pred_def_14769,type,
    v27640: ( state_type * $int ) > $o ).

tff(pred_def_14770,type,
    v27638: ( state_type * $int ) > $o ).

tff(pred_def_14771,type,
    v27636: ( state_type * $int ) > $o ).

tff(pred_def_14772,type,
    v27774: state_type > $o ).

tff(pred_def_14773,type,
    v27772: state_type > $o ).

tff(pred_def_14774,type,
    v27778: state_type > $o ).

tff(pred_def_14775,type,
    v27776: state_type > $o ).

tff(pred_def_14776,type,
    v27782: state_type > $o ).

tff(pred_def_14777,type,
    v27780: state_type > $o ).

tff(pred_def_14778,type,
    v27785: state_type > $o ).

tff(pred_def_14779,type,
    v27784: state_type > $o ).

tff(pred_def_14780,type,
    v27770: state_type > $o ).

tff(pred_def_14781,type,
    v27768: state_type > $o ).

tff(pred_def_14782,type,
    v27766: state_type > $o ).

tff(pred_def_14783,type,
    v27764: state_type > $o ).

tff(pred_def_14784,type,
    v27762: state_type > $o ).

tff(pred_def_14785,type,
    v27760: state_type > $o ).

tff(pred_def_14786,type,
    v27758: state_type > $o ).

tff(pred_def_14787,type,
    v27756: state_type > $o ).

tff(pred_def_14788,type,
    v27805: state_type > $o ).

tff(pred_def_14789,type,
    v27803: state_type > $o ).

tff(pred_def_14790,type,
    v27801: state_type > $o ).

tff(pred_def_14791,type,
    v27799: state_type > $o ).

tff(pred_def_14792,type,
    v27797: state_type > $o ).

tff(pred_def_14793,type,
    v27815: state_type > $o ).

tff(pred_def_14794,type,
    v27813: state_type > $o ).

tff(pred_def_14795,type,
    v27811: state_type > $o ).

tff(pred_def_14796,type,
    v27809: state_type > $o ).

tff(pred_def_14797,type,
    v27807: state_type > $o ).

tff(pred_def_14798,type,
    v27819: ( state_type * $int ) > $o ).

tff(pred_def_14799,type,
    v27817: ( state_type * $int ) > $o ).

tff(pred_def_14800,type,
    v27829: state_type > $o ).

tff(pred_def_14801,type,
    v27827: state_type > $o ).

tff(pred_def_14802,type,
    v27835: state_type > $o ).

tff(pred_def_14803,type,
    v27833: state_type > $o ).

tff(pred_def_14804,type,
    v27849: state_type > $o ).

tff(pred_def_14805,type,
    v27847: state_type > $o ).

tff(pred_def_14806,type,
    v27853: state_type > $o ).

tff(pred_def_14807,type,
    v27851: state_type > $o ).

tff(pred_def_14808,type,
    v27857: state_type > $o ).

tff(pred_def_14809,type,
    v27855: state_type > $o ).

tff(pred_def_14810,type,
    v27860: state_type > $o ).

tff(pred_def_14811,type,
    v27859: state_type > $o ).

tff(pred_def_14812,type,
    v27845: state_type > $o ).

tff(pred_def_14813,type,
    v27843: state_type > $o ).

tff(pred_def_14814,type,
    v27841: state_type > $o ).

tff(pred_def_14815,type,
    v27839: state_type > $o ).

tff(pred_def_14816,type,
    v27837: state_type > $o ).

tff(pred_def_14817,type,
    v27864: state_type > $o ).

tff(pred_def_14818,type,
    v27862: state_type > $o ).

tff(pred_def_14819,type,
    v27831: state_type > $o ).

tff(pred_def_14820,type,
    v27870: state_type > $o ).

tff(pred_def_14821,type,
    v27872: state_type > $o ).

tff(pred_def_14822,type,
    v27868: state_type > $o ).

tff(pred_def_14823,type,
    v27867: state_type > $o ).

tff(pred_def_14824,type,
    v27878: state_type > $o ).

tff(pred_def_14825,type,
    v27879: state_type > $o ).

tff(pred_def_14826,type,
    v27875: state_type > $o ).

tff(pred_def_14827,type,
    v27877: state_type > $o ).

tff(pred_def_14828,type,
    v27885: state_type > $o ).

tff(pred_def_14829,type,
    v27883: state_type > $o ).

tff(pred_def_14830,type,
    v27887: state_type > $o ).

tff(pred_def_14831,type,
    v27825: state_type > $o ).

tff(pred_def_14832,type,
    v27823: state_type > $o ).

tff(pred_def_14833,type,
    v27821: state_type > $o ).

tff(pred_def_14834,type,
    v27894: state_type > $o ).

tff(pred_def_14835,type,
    v27892: state_type > $o ).

tff(pred_def_14836,type,
    v27891: state_type > $o ).

tff(pred_def_14837,type,
    v27890: state_type > $o ).

tff(pred_def_14838,type,
    v27902: state_type > $o ).

tff(pred_def_14839,type,
    v27903: state_type > $o ).

tff(pred_def_14840,type,
    v27901: state_type > $o ).

tff(pred_def_14841,type,
    v27898: ( state_type * $int ) > $o ).

tff(pred_def_14842,type,
    v27900: ( state_type * $int ) > $o ).

tff(pred_def_14843,type,
    v27795: ( state_type * $int ) > $o ).

tff(pred_def_14844,type,
    v27793: ( state_type * $int ) > $o ).

tff(pred_def_14845,type,
    v27791: ( state_type * $int ) > $o ).

tff(pred_def_14846,type,
    v27789: ( state_type * $int ) > $o ).

tff(pred_def_14847,type,
    v27787: ( state_type * $int ) > $o ).

tff(pred_def_14848,type,
    v27925: state_type > $o ).

tff(pred_def_14849,type,
    v27923: state_type > $o ).

tff(pred_def_14850,type,
    v27929: state_type > $o ).

tff(pred_def_14851,type,
    v27927: state_type > $o ).

tff(pred_def_14852,type,
    v27933: state_type > $o ).

tff(pred_def_14853,type,
    v27931: state_type > $o ).

tff(pred_def_14854,type,
    v27936: state_type > $o ).

tff(pred_def_14855,type,
    v27935: state_type > $o ).

tff(pred_def_14856,type,
    v27921: state_type > $o ).

tff(pred_def_14857,type,
    v27919: state_type > $o ).

tff(pred_def_14858,type,
    v27917: state_type > $o ).

tff(pred_def_14859,type,
    v27915: state_type > $o ).

tff(pred_def_14860,type,
    v27913: state_type > $o ).

tff(pred_def_14861,type,
    v27911: state_type > $o ).

tff(pred_def_14862,type,
    v27909: state_type > $o ).

tff(pred_def_14863,type,
    v27907: state_type > $o ).

tff(pred_def_14864,type,
    v27956: state_type > $o ).

tff(pred_def_14865,type,
    v27954: state_type > $o ).

tff(pred_def_14866,type,
    v27952: state_type > $o ).

tff(pred_def_14867,type,
    v27950: state_type > $o ).

tff(pred_def_14868,type,
    v27948: state_type > $o ).

tff(pred_def_14869,type,
    v27966: state_type > $o ).

tff(pred_def_14870,type,
    v27964: state_type > $o ).

tff(pred_def_14871,type,
    v27962: state_type > $o ).

tff(pred_def_14872,type,
    v27960: state_type > $o ).

tff(pred_def_14873,type,
    v27958: state_type > $o ).

tff(pred_def_14874,type,
    v27970: ( state_type * $int ) > $o ).

tff(pred_def_14875,type,
    v27968: ( state_type * $int ) > $o ).

tff(pred_def_14876,type,
    v27980: state_type > $o ).

tff(pred_def_14877,type,
    v27978: state_type > $o ).

tff(pred_def_14878,type,
    v27986: state_type > $o ).

tff(pred_def_14879,type,
    v27984: state_type > $o ).

tff(pred_def_14880,type,
    v27999: state_type > $o ).

tff(pred_def_14881,type,
    v27997: state_type > $o ).

tff(pred_def_14882,type,
    v28003: state_type > $o ).

tff(pred_def_14883,type,
    v28001: state_type > $o ).

tff(pred_def_14884,type,
    v28007: state_type > $o ).

tff(pred_def_14885,type,
    v28005: state_type > $o ).

tff(pred_def_14886,type,
    v28010: state_type > $o ).

tff(pred_def_14887,type,
    v28009: state_type > $o ).

tff(pred_def_14888,type,
    v27995: state_type > $o ).

tff(pred_def_14889,type,
    v27993: state_type > $o ).

tff(pred_def_14890,type,
    v27990: state_type > $o ).

tff(pred_def_14891,type,
    v27988: state_type > $o ).

tff(pred_def_14892,type,
    v28014: state_type > $o ).

tff(pred_def_14893,type,
    v28012: state_type > $o ).

tff(pred_def_14894,type,
    v27982: state_type > $o ).

tff(pred_def_14895,type,
    v28020: state_type > $o ).

tff(pred_def_14896,type,
    v28022: state_type > $o ).

tff(pred_def_14897,type,
    v28018: state_type > $o ).

tff(pred_def_14898,type,
    v28017: state_type > $o ).

tff(pred_def_14899,type,
    v28028: state_type > $o ).

tff(pred_def_14900,type,
    v28029: state_type > $o ).

tff(pred_def_14901,type,
    v28025: state_type > $o ).

tff(pred_def_14902,type,
    v28027: state_type > $o ).

tff(pred_def_14903,type,
    v28035: state_type > $o ).

tff(pred_def_14904,type,
    v28033: state_type > $o ).

tff(pred_def_14905,type,
    v28037: state_type > $o ).

tff(pred_def_14906,type,
    v27976: state_type > $o ).

tff(pred_def_14907,type,
    v27974: state_type > $o ).

tff(pred_def_14908,type,
    v27972: state_type > $o ).

tff(pred_def_14909,type,
    v28044: state_type > $o ).

tff(pred_def_14910,type,
    v28042: state_type > $o ).

tff(pred_def_14911,type,
    v28041: state_type > $o ).

tff(pred_def_14912,type,
    v28040: state_type > $o ).

tff(pred_def_14913,type,
    v28052: state_type > $o ).

tff(pred_def_14914,type,
    v28053: state_type > $o ).

tff(pred_def_14915,type,
    v28051: state_type > $o ).

tff(pred_def_14916,type,
    v28048: ( state_type * $int ) > $o ).

tff(pred_def_14917,type,
    v28050: ( state_type * $int ) > $o ).

tff(pred_def_14918,type,
    v27946: ( state_type * $int ) > $o ).

tff(pred_def_14919,type,
    v27944: ( state_type * $int ) > $o ).

tff(pred_def_14920,type,
    v27942: ( state_type * $int ) > $o ).

tff(pred_def_14921,type,
    v27940: ( state_type * $int ) > $o ).

tff(pred_def_14922,type,
    v27938: ( state_type * $int ) > $o ).

tff(pred_def_14923,type,
    v28065: state_type > $o ).

tff(pred_def_14924,type,
    v28063: state_type > $o ).

tff(pred_def_14925,type,
    v28061: state_type > $o ).

tff(pred_def_14926,type,
    v28059: state_type > $o ).

tff(pred_def_14927,type,
    v28057: state_type > $o ).

tff(pred_def_14928,type,
    v28073: state_type > $o ).

tff(pred_def_14929,type,
    v28072: ( state_type * $int ) > $o ).

tff(pred_def_14930,type,
    v28071: ( state_type * $int ) > $o ).

tff(pred_def_14931,type,
    v28076: state_type > $o ).

tff(pred_def_14932,type,
    v28075: ( state_type * $int ) > $o ).

tff(pred_def_14933,type,
    v28074: ( state_type * $int ) > $o ).

tff(pred_def_14934,type,
    v28070: ( state_type * $int ) > $o ).

tff(pred_def_14935,type,
    v28079: state_type > $o ).

tff(pred_def_14936,type,
    v28078: ( state_type * $int ) > $o ).

tff(pred_def_14937,type,
    v28077: ( state_type * $int ) > $o ).

tff(pred_def_14938,type,
    v28069: ( state_type * $int ) > $o ).

tff(pred_def_14939,type,
    v28082: state_type > $o ).

tff(pred_def_14940,type,
    v28081: ( state_type * $int ) > $o ).

tff(pred_def_14941,type,
    v28080: ( state_type * $int ) > $o ).

tff(pred_def_14942,type,
    v28068: ( state_type * $int ) > $o ).

tff(pred_def_14943,type,
    v28085: state_type > $o ).

tff(pred_def_14944,type,
    v28084: ( state_type * $int ) > $o ).

tff(pred_def_14945,type,
    v28083: ( state_type * $int ) > $o ).

tff(pred_def_14946,type,
    v28067: ( state_type * $int ) > $o ).

tff(pred_def_14947,type,
    v28088: state_type > $o ).

tff(pred_def_14948,type,
    v28087: ( state_type * $int ) > $o ).

tff(pred_def_14949,type,
    v28086: ( state_type * $int ) > $o ).

tff(pred_def_14950,type,
    v26559: ( state_type * $int ) > $o ).

tff(pred_def_14951,type,
    v26557: ( state_type * $int ) > $o ).

tff(pred_def_14952,type,
    v26555: ( state_type * $int ) > $o ).

tff(pred_def_14953,type,
    v26553: ( state_type * $int ) > $o ).

tff(pred_def_14954,type,
    v26551: ( state_type * $int ) > $o ).

tff(pred_def_14955,type,
    v26545: state_type > $o ).

tff(pred_def_14956,type,
    v26543: state_type > $o ).

tff(pred_def_14957,type,
    v26541: state_type > $o ).

tff(pred_def_14958,type,
    v28099: ( state_type * $int ) > $o ).

tff(pred_def_14959,type,
    v28097: ( state_type * $int ) > $o ).

tff(pred_def_14960,type,
    v28133: state_type > $o ).

tff(pred_def_14961,type,
    v28131: state_type > $o ).

tff(pred_def_14962,type,
    v28129: state_type > $o ).

tff(pred_def_14963,type,
    v28127: state_type > $o ).

tff(pred_def_14964,type,
    v28125: state_type > $o ).

tff(pred_def_14965,type,
    v28123: state_type > $o ).

tff(pred_def_14966,type,
    v28121: state_type > $o ).

tff(pred_def_14967,type,
    v28147: state_type > $o ).

tff(pred_def_14968,type,
    v28145: state_type > $o ).

tff(pred_def_14969,type,
    v28143: state_type > $o ).

tff(pred_def_14970,type,
    v28141: state_type > $o ).

tff(pred_def_14971,type,
    v28139: state_type > $o ).

tff(pred_def_14972,type,
    v28137: state_type > $o ).

tff(pred_def_14973,type,
    v28135: state_type > $o ).

tff(pred_def_14974,type,
    v28173: state_type > $o ).

tff(pred_def_14975,type,
    v28175: state_type > $o ).

tff(pred_def_14976,type,
    v28174: ( state_type * $int ) > $o ).

tff(pred_def_14977,type,
    v28176: state_type > $o ).

tff(pred_def_14978,type,
    v28171: ( state_type * $int ) > $o ).

tff(pred_def_14979,type,
    v28169: ( state_type * $int ) > $o ).

tff(pred_def_14980,type,
    v28177: ( state_type * $int ) > $o ).

tff(pred_def_14981,type,
    v28167: ( state_type * $int ) > $o ).

tff(pred_def_14982,type,
    v28165: ( state_type * $int ) > $o ).

tff(pred_def_14983,type,
    v28163: state_type > $o ).

tff(pred_def_14984,type,
    v28179: state_type > $o ).

tff(pred_def_14985,type,
    v28161: ( state_type * $int ) > $o ).

tff(pred_def_14986,type,
    v28159: ( state_type * $int ) > $o ).

tff(pred_def_14987,type,
    v28193: ( state_type * $int ) > $o ).

tff(pred_def_14988,type,
    v28191: ( state_type * $int ) > $o ).

tff(pred_def_14989,type,
    v28197: state_type > $o ).

tff(pred_def_14990,type,
    v28195: state_type > $o ).

tff(pred_def_14991,type,
    v28221: state_type > $o ).

tff(pred_def_14992,type,
    v28219: state_type > $o ).

tff(pred_def_14993,type,
    v28217: state_type > $o ).

tff(pred_def_14994,type,
    v28215: state_type > $o ).

tff(pred_def_14995,type,
    v28213: state_type > $o ).

tff(pred_def_14996,type,
    v28211: state_type > $o ).

tff(pred_def_14997,type,
    v28209: state_type > $o ).

tff(pred_def_14998,type,
    v28235: state_type > $o ).

tff(pred_def_14999,type,
    v28233: state_type > $o ).

tff(pred_def_15000,type,
    v28231: state_type > $o ).

tff(pred_def_15001,type,
    v28229: state_type > $o ).

tff(pred_def_15002,type,
    v28227: state_type > $o ).

tff(pred_def_15003,type,
    v28225: state_type > $o ).

tff(pred_def_15004,type,
    v28223: state_type > $o ).

tff(pred_def_15005,type,
    v28251: ( state_type * $int ) > $o ).

tff(pred_def_15006,type,
    v28249: ( state_type * $int ) > $o ).

tff(pred_def_15007,type,
    v28247: ( state_type * $int ) > $o ).

tff(pred_def_15008,type,
    v28245: ( state_type * $int ) > $o ).

tff(pred_def_15009,type,
    v28243: ( state_type * $int ) > $o ).

tff(pred_def_15010,type,
    v28281: ( state_type * $int ) > $o ).

tff(pred_def_15011,type,
    v28283: ( state_type * $int ) > $o ).

tff(pred_def_15012,type,
    v28279: ( state_type * $int ) > $o ).

tff(pred_def_15013,type,
    v28277: ( state_type * $int ) > $o ).

tff(pred_def_15014,type,
    v28275: ( state_type * $int ) > $o ).

tff(pred_def_15015,type,
    v28273: ( state_type * $int ) > $o ).

tff(pred_def_15016,type,
    v28271: state_type > $o ).

tff(pred_def_15017,type,
    v28269: state_type > $o ).

tff(pred_def_15018,type,
    v28287: state_type > $o ).

tff(pred_def_15019,type,
    v28285: state_type > $o ).

tff(pred_def_15020,type,
    v28289: state_type > $o ).

tff(pred_def_15021,type,
    v28267: state_type > $o ).

tff(pred_def_15022,type,
    v28265: state_type > $o ).

tff(pred_def_15023,type,
    v28263: state_type > $o ).

tff(pred_def_15024,type,
    v28261: state_type > $o ).

tff(pred_def_15025,type,
    v28259: state_type > $o ).

tff(pred_def_15026,type,
    v28257: state_type > $o ).

tff(pred_def_15027,type,
    v28255: state_type > $o ).

tff(pred_def_15028,type,
    v28253: state_type > $o ).

tff(pred_def_15029,type,
    v28299: ( state_type * $int ) > $o ).

tff(pred_def_15030,type,
    v28297: ( state_type * $int ) > $o ).

tff(pred_def_15031,type,
    v28295: ( state_type * $int ) > $o ).

tff(pred_def_15032,type,
    v28293: ( state_type * $int ) > $o ).

tff(pred_def_15033,type,
    v28291: ( state_type * $int ) > $o ).

tff(pred_def_15034,type,
    v28329: ( state_type * $int ) > $o ).

tff(pred_def_15035,type,
    v28327: ( state_type * $int ) > $o ).

tff(pred_def_15036,type,
    v28330: ( state_type * $int ) > $o ).

tff(pred_def_15037,type,
    v28325: ( state_type * $int ) > $o ).

tff(pred_def_15038,type,
    v28323: ( state_type * $int ) > $o ).

tff(pred_def_15039,type,
    v28321: ( state_type * $int ) > $o ).

tff(pred_def_15040,type,
    v28319: state_type > $o ).

tff(pred_def_15041,type,
    v28317: state_type > $o ).

tff(pred_def_15042,type,
    v28334: state_type > $o ).

tff(pred_def_15043,type,
    v28332: state_type > $o ).

tff(pred_def_15044,type,
    v28336: state_type > $o ).

tff(pred_def_15045,type,
    v28315: state_type > $o ).

tff(pred_def_15046,type,
    v28313: state_type > $o ).

tff(pred_def_15047,type,
    v28311: state_type > $o ).

tff(pred_def_15048,type,
    v28309: state_type > $o ).

tff(pred_def_15049,type,
    v28307: state_type > $o ).

tff(pred_def_15050,type,
    v28305: state_type > $o ).

tff(pred_def_15051,type,
    v28303: state_type > $o ).

tff(pred_def_15052,type,
    v28301: state_type > $o ).

tff(pred_def_15053,type,
    v28346: ( state_type * $int ) > $o ).

tff(pred_def_15054,type,
    v28344: ( state_type * $int ) > $o ).

tff(pred_def_15055,type,
    v28342: ( state_type * $int ) > $o ).

tff(pred_def_15056,type,
    v28340: ( state_type * $int ) > $o ).

tff(pred_def_15057,type,
    v28338: ( state_type * $int ) > $o ).

tff(pred_def_15058,type,
    v28366: state_type > $o ).

tff(pred_def_15059,type,
    v28364: state_type > $o ).

tff(pred_def_15060,type,
    v28370: state_type > $o ).

tff(pred_def_15061,type,
    v28368: state_type > $o ).

tff(pred_def_15062,type,
    v28372: state_type > $o ).

tff(pred_def_15063,type,
    v28362: state_type > $o ).

tff(pred_def_15064,type,
    v28360: state_type > $o ).

tff(pred_def_15065,type,
    v28358: state_type > $o ).

tff(pred_def_15066,type,
    v28356: state_type > $o ).

tff(pred_def_15067,type,
    v28354: state_type > $o ).

tff(pred_def_15068,type,
    v28352: state_type > $o ).

tff(pred_def_15069,type,
    v28350: state_type > $o ).

tff(pred_def_15070,type,
    v28348: state_type > $o ).

tff(pred_def_15071,type,
    v28382: ( state_type * $int ) > $o ).

tff(pred_def_15072,type,
    v28380: ( state_type * $int ) > $o ).

tff(pred_def_15073,type,
    v28378: ( state_type * $int ) > $o ).

tff(pred_def_15074,type,
    v28376: ( state_type * $int ) > $o ).

tff(pred_def_15075,type,
    v28374: ( state_type * $int ) > $o ).

tff(pred_def_15076,type,
    v28402: state_type > $o ).

tff(pred_def_15077,type,
    v28400: state_type > $o ).

tff(pred_def_15078,type,
    v28406: state_type > $o ).

tff(pred_def_15079,type,
    v28404: state_type > $o ).

tff(pred_def_15080,type,
    v28408: state_type > $o ).

tff(pred_def_15081,type,
    v28398: state_type > $o ).

tff(pred_def_15082,type,
    v28396: state_type > $o ).

tff(pred_def_15083,type,
    v28394: state_type > $o ).

tff(pred_def_15084,type,
    v28392: state_type > $o ).

tff(pred_def_15085,type,
    v28390: state_type > $o ).

tff(pred_def_15086,type,
    v28388: state_type > $o ).

tff(pred_def_15087,type,
    v28386: state_type > $o ).

tff(pred_def_15088,type,
    v28384: state_type > $o ).

tff(pred_def_15089,type,
    v28414: state_type > $o ).

tff(pred_def_15090,type,
    v28413: ( state_type * $int ) > $o ).

tff(pred_def_15091,type,
    v28412: ( state_type * $int ) > $o ).

tff(pred_def_15092,type,
    v28417: state_type > $o ).

tff(pred_def_15093,type,
    v28416: ( state_type * $int ) > $o ).

tff(pred_def_15094,type,
    v28415: ( state_type * $int ) > $o ).

tff(pred_def_15095,type,
    v28411: ( state_type * $int ) > $o ).

tff(pred_def_15096,type,
    v28420: state_type > $o ).

tff(pred_def_15097,type,
    v28419: ( state_type * $int ) > $o ).

tff(pred_def_15098,type,
    v28418: ( state_type * $int ) > $o ).

tff(pred_def_15099,type,
    v28410: ( state_type * $int ) > $o ).

tff(pred_def_15100,type,
    v28423: state_type > $o ).

tff(pred_def_15101,type,
    v28422: ( state_type * $int ) > $o ).

tff(pred_def_15102,type,
    v28421: ( state_type * $int ) > $o ).

tff(pred_def_15103,type,
    v28241: ( state_type * $int ) > $o ).

tff(pred_def_15104,type,
    v28239: ( state_type * $int ) > $o ).

tff(pred_def_15105,type,
    v28237: ( state_type * $int ) > $o ).

tff(pred_def_15106,type,
    v28435: state_type > $o ).

tff(pred_def_15107,type,
    v28433: state_type > $o ).

tff(pred_def_15108,type,
    v28431: state_type > $o ).

tff(pred_def_15109,type,
    v28445: state_type > $o ).

tff(pred_def_15110,type,
    v28443: state_type > $o ).

tff(pred_def_15111,type,
    v28441: state_type > $o ).

tff(pred_def_15112,type,
    v28439: state_type > $o ).

tff(pred_def_15113,type,
    v28437: state_type > $o ).

tff(pred_def_15114,type,
    v28447: state_type > $o ).

tff(pred_def_15115,type,
    v28429: state_type > $o ).

tff(pred_def_15116,type,
    v28427: state_type > $o ).

tff(pred_def_15117,type,
    v28425: state_type > $o ).

tff(pred_def_15118,type,
    v28454: state_type > $o ).

tff(pred_def_15119,type,
    v28452: state_type > $o ).

tff(pred_def_15120,type,
    v28451: state_type > $o ).

tff(pred_def_15121,type,
    v28450: state_type > $o ).

tff(pred_def_15122,type,
    v28462: state_type > $o ).

tff(pred_def_15123,type,
    v28463: state_type > $o ).

tff(pred_def_15124,type,
    v28461: state_type > $o ).

tff(pred_def_15125,type,
    v28458: ( state_type * $int ) > $o ).

tff(pred_def_15126,type,
    v28460: ( state_type * $int ) > $o ).

tff(pred_def_15127,type,
    v28207: ( state_type * $int ) > $o ).

tff(pred_def_15128,type,
    v28205: ( state_type * $int ) > $o ).

tff(pred_def_15129,type,
    v28203: ( state_type * $int ) > $o ).

tff(pred_def_15130,type,
    v28201: ( state_type * $int ) > $o ).

tff(pred_def_15131,type,
    v28199: ( state_type * $int ) > $o ).

tff(pred_def_15132,type,
    v28469: state_type > $o ).

tff(pred_def_15133,type,
    v28467: state_type > $o ).

tff(pred_def_15134,type,
    v28473: state_type > $o ).

tff(pred_def_15135,type,
    v28472: ( state_type * $int ) > $o ).

tff(pred_def_15136,type,
    v28471: ( state_type * $int ) > $o ).

tff(pred_def_15137,type,
    v28476: state_type > $o ).

tff(pred_def_15138,type,
    v28475: ( state_type * $int ) > $o ).

tff(pred_def_15139,type,
    v28474: ( state_type * $int ) > $o ).

tff(pred_def_15140,type,
    v28189: ( state_type * $int ) > $o ).

tff(pred_def_15141,type,
    v28187: ( state_type * $int ) > $o ).

tff(pred_def_15142,type,
    v28185: ( state_type * $int ) > $o ).

tff(pred_def_15143,type,
    v28183: ( state_type * $int ) > $o ).

tff(pred_def_15144,type,
    v28181: ( state_type * $int ) > $o ).

tff(pred_def_15145,type,
    v28157: ( state_type * $int ) > $o ).

tff(pred_def_15146,type,
    v28155: ( state_type * $int ) > $o ).

tff(pred_def_15147,type,
    v28153: ( state_type * $int ) > $o ).

tff(pred_def_15148,type,
    v28151: ( state_type * $int ) > $o ).

tff(pred_def_15149,type,
    v28149: ( state_type * $int ) > $o ).

tff(pred_def_15150,type,
    v28489: state_type > $o ).

tff(pred_def_15151,type,
    v28487: state_type > $o ).

tff(pred_def_15152,type,
    v28485: state_type > $o ).

tff(pred_def_15153,type,
    v28495: state_type > $o ).

tff(pred_def_15154,type,
    v28493: state_type > $o ).

tff(pred_def_15155,type,
    v28513: ( state_type * $int ) > $o ).

tff(pred_def_15156,type,
    v28515: ( state_type * $int ) > $o ).

tff(pred_def_15157,type,
    v28511: ( state_type * $int ) > $o ).

tff(pred_def_15158,type,
    v28509: state_type > $o ).

tff(pred_def_15159,type,
    v28507: state_type > $o ).

tff(pred_def_15160,type,
    v28519: state_type > $o ).

tff(pred_def_15161,type,
    v28517: state_type > $o ).

tff(pred_def_15162,type,
    v28523: state_type > $o ).

tff(pred_def_15163,type,
    v28521: state_type > $o ).

tff(pred_def_15164,type,
    v28526: state_type > $o ).

tff(pred_def_15165,type,
    v28525: state_type > $o ).

tff(pred_def_15166,type,
    v28505: state_type > $o ).

tff(pred_def_15167,type,
    v28503: state_type > $o ).

tff(pred_def_15168,type,
    v28501: state_type > $o ).

tff(pred_def_15169,type,
    v28499: state_type > $o ).

tff(pred_def_15170,type,
    v28497: state_type > $o ).

tff(pred_def_15171,type,
    v28534: state_type > $o ).

tff(pred_def_15172,type,
    v28532: state_type > $o ).

tff(pred_def_15173,type,
    v28530: state_type > $o ).

tff(pred_def_15174,type,
    v28528: state_type > $o ).

tff(pred_def_15175,type,
    v28491: state_type > $o ).

tff(pred_def_15176,type,
    v28540: state_type > $o ).

tff(pred_def_15177,type,
    v28542: state_type > $o ).

tff(pred_def_15178,type,
    v28538: state_type > $o ).

tff(pred_def_15179,type,
    v28537: state_type > $o ).

tff(pred_def_15180,type,
    v28548: state_type > $o ).

tff(pred_def_15181,type,
    v28549: state_type > $o ).

tff(pred_def_15182,type,
    v28545: state_type > $o ).

tff(pred_def_15183,type,
    v28547: state_type > $o ).

tff(pred_def_15184,type,
    v28559: state_type > $o ).

tff(pred_def_15185,type,
    v28557: state_type > $o ).

tff(pred_def_15186,type,
    v28555: state_type > $o ).

tff(pred_def_15187,type,
    v28553: state_type > $o ).

tff(pred_def_15188,type,
    v28561: state_type > $o ).

tff(pred_def_15189,type,
    v28483: state_type > $o ).

tff(pred_def_15190,type,
    v28481: state_type > $o ).

tff(pred_def_15191,type,
    v28479: state_type > $o ).

tff(pred_def_15192,type,
    v28568: state_type > $o ).

tff(pred_def_15193,type,
    v28566: state_type > $o ).

tff(pred_def_15194,type,
    v28565: state_type > $o ).

tff(pred_def_15195,type,
    v28564: state_type > $o ).

tff(pred_def_15196,type,
    v28576: state_type > $o ).

tff(pred_def_15197,type,
    v28577: state_type > $o ).

tff(pred_def_15198,type,
    v28575: state_type > $o ).

tff(pred_def_15199,type,
    v28572: ( state_type * $int ) > $o ).

tff(pred_def_15200,type,
    v28574: ( state_type * $int ) > $o ).

tff(pred_def_15201,type,
    v28119: ( state_type * $int ) > $o ).

tff(pred_def_15202,type,
    v28117: ( state_type * $int ) > $o ).

tff(pred_def_15203,type,
    v28115: ( state_type * $int ) > $o ).

tff(pred_def_15204,type,
    v28113: ( state_type * $int ) > $o ).

tff(pred_def_15205,type,
    v28111: ( state_type * $int ) > $o ).

tff(pred_def_15206,type,
    v28613: state_type > $o ).

tff(pred_def_15207,type,
    v28611: state_type > $o ).

tff(pred_def_15208,type,
    v28609: state_type > $o ).

tff(pred_def_15209,type,
    v28607: state_type > $o ).

tff(pred_def_15210,type,
    v28605: state_type > $o ).

tff(pred_def_15211,type,
    v28603: state_type > $o ).

tff(pred_def_15212,type,
    v28623: state_type > $o ).

tff(pred_def_15213,type,
    v28621: state_type > $o ).

tff(pred_def_15214,type,
    v28619: state_type > $o ).

tff(pred_def_15215,type,
    v28617: state_type > $o ).

tff(pred_def_15216,type,
    v28615: state_type > $o ).

tff(pred_def_15217,type,
    v28650: state_type > $o ).

tff(pred_def_15218,type,
    v28649: ( state_type * $int ) > $o ).

tff(pred_def_15219,type,
    v28648: ( state_type * $int ) > $o ).

tff(pred_def_15220,type,
    v28646: ( state_type * $int ) > $o ).

tff(pred_def_15221,type,
    v28666: state_type > $o ).

tff(pred_def_15222,type,
    v28667: ( state_type * $int ) > $o ).

tff(pred_def_15223,type,
    v28668: state_type > $o ).

tff(pred_def_15224,type,
    v28664: ( state_type * $int ) > $o ).

tff(pred_def_15225,type,
    v28662: ( state_type * $int ) > $o ).

tff(pred_def_15226,type,
    v28692: ( state_type * $int ) > $o ).

tff(pred_def_15227,type,
    v28601: ( state_type * $int ) > $o ).

tff(pred_def_15228,type,
    v28690: ( state_type * $int ) > $o ).

tff(pred_def_15229,type,
    v28693: ( state_type * $int ) > $o ).

tff(pred_def_15230,type,
    v28688: ( state_type * $int ) > $o ).

tff(pred_def_15231,type,
    v28686: ( state_type * $int ) > $o ).

tff(pred_def_15232,type,
    v28684: ( state_type * $int ) > $o ).

tff(pred_def_15233,type,
    v28682: state_type > $o ).

tff(pred_def_15234,type,
    v28680: state_type > $o ).

tff(pred_def_15235,type,
    v28699: state_type > $o ).

tff(pred_def_15236,type,
    v28639: state_type > $o ).

tff(pred_def_15237,type,
    v28698: ( state_type * $int ) > $o ).

tff(pred_def_15238,type,
    v28637: ( state_type * $int ) > $o ).

tff(pred_def_15239,type,
    v28635: ( state_type * $int ) > $o ).

tff(pred_def_15240,type,
    v28714: ( state_type * $int ) > $o ).

tff(pred_def_15241,type,
    v28713: ( state_type * $int ) > $o ).

tff(pred_def_15242,type,
    v28711: ( state_type * $int ) > $o ).

tff(pred_def_15243,type,
    v28718: state_type > $o ).

tff(pred_def_15244,type,
    v28716: state_type > $o ).

tff(pred_def_15245,type,
    v28729: ( state_type * $int ) > $o ).

tff(pred_def_15246,type,
    v28728: state_type > $o ).

tff(pred_def_15247,type,
    v28732: state_type > $o ).

tff(pred_def_15248,type,
    v28733: state_type > $o ).

tff(pred_def_15249,type,
    v28731: state_type > $o ).

tff(pred_def_15250,type,
    v28734: state_type > $o ).

tff(pred_def_15251,type,
    v28730: state_type > $o ).

tff(pred_def_15252,type,
    v28727: state_type > $o ).

tff(pred_def_15253,type,
    v28735: state_type > $o ).

tff(pred_def_15254,type,
    v28726: state_type > $o ).

tff(pred_def_15255,type,
    v28738: state_type > $o ).

tff(pred_def_15256,type,
    v28739: state_type > $o ).

tff(pred_def_15257,type,
    v28737: state_type > $o ).

tff(pred_def_15258,type,
    v28740: state_type > $o ).

tff(pred_def_15259,type,
    v28736: state_type > $o ).

tff(pred_def_15260,type,
    v28725: state_type > $o ).

tff(pred_def_15261,type,
    v28741: state_type > $o ).

tff(pred_def_15262,type,
    v28724: state_type > $o ).

tff(pred_def_15263,type,
    v28723: state_type > $o ).

tff(pred_def_15264,type,
    v28745: state_type > $o ).

tff(pred_def_15265,type,
    v28746: state_type > $o ).

tff(pred_def_15266,type,
    v28744: state_type > $o ).

tff(pred_def_15267,type,
    v28747: state_type > $o ).

tff(pred_def_15268,type,
    v28743: state_type > $o ).

tff(pred_def_15269,type,
    v28742: state_type > $o ).

tff(pred_def_15270,type,
    v28722: state_type > $o ).

tff(pred_def_15271,type,
    v28748: state_type > $o ).

tff(pred_def_15272,type,
    v28721: state_type > $o ).

tff(pred_def_15273,type,
    v28751: state_type > $o ).

tff(pred_def_15274,type,
    v28752: state_type > $o ).

tff(pred_def_15275,type,
    v28750: state_type > $o ).

tff(pred_def_15276,type,
    v28753: state_type > $o ).

tff(pred_def_15277,type,
    v28749: state_type > $o ).

tff(pred_def_15278,type,
    v28756: state_type > $o ).

tff(pred_def_15279,type,
    v28757: state_type > $o ).

tff(pred_def_15280,type,
    v28755: state_type > $o ).

tff(pred_def_15281,type,
    v28758: state_type > $o ).

tff(pred_def_15282,type,
    v28754: state_type > $o ).

tff(pred_def_15283,type,
    v28761: state_type > $o ).

tff(pred_def_15284,type,
    v28762: state_type > $o ).

tff(pred_def_15285,type,
    v28760: state_type > $o ).

tff(pred_def_15286,type,
    v28763: state_type > $o ).

tff(pred_def_15287,type,
    v28759: state_type > $o ).

tff(pred_def_15288,type,
    v28719: ( state_type * $int ) > $o ).

tff(pred_def_15289,type,
    v28709: ( state_type * $int ) > $o ).

tff(pred_def_15290,type,
    v28707: ( state_type * $int ) > $o ).

tff(pred_def_15291,type,
    v28705: ( state_type * $int ) > $o ).

tff(pred_def_15292,type,
    v28703: ( state_type * $int ) > $o ).

tff(pred_def_15293,type,
    v28701: ( state_type * $int ) > $o ).

tff(pred_def_15294,type,
    v28764: ( state_type * $int ) > $o ).

tff(pred_def_15295,type,
    v28633: ( state_type * $int ) > $o ).

tff(pred_def_15296,type,
    v28631: ( state_type * $int ) > $o ).

tff(pred_def_15297,type,
    v28629: ( state_type * $int ) > $o ).

tff(pred_def_15298,type,
    v28765: ( state_type * $int ) > $o ).

tff(pred_def_15299,type,
    v28766: ( state_type * $int ) > $o ).

tff(pred_def_15300,type,
    v28627: ( state_type * $int ) > $o ).

tff(pred_def_15301,type,
    v28625: ( state_type * $int ) > $o ).

tff(pred_def_15302,type,
    v28776: state_type > $o ).

tff(pred_def_15303,type,
    v28774: state_type > $o ).

tff(pred_def_15304,type,
    v28782: state_type > $o ).

tff(pred_def_15305,type,
    v28780: state_type > $o ).

tff(pred_def_15306,type,
    v28786: state_type > $o ).

tff(pred_def_15307,type,
    v28784: state_type > $o ).

tff(pred_def_15308,type,
    v28790: state_type > $o ).

tff(pred_def_15309,type,
    v28788: state_type > $o ).

tff(pred_def_15310,type,
    v28778: state_type > $o ).

tff(pred_def_15311,type,
    v28796: state_type > $o ).

tff(pred_def_15312,type,
    v28798: state_type > $o ).

tff(pred_def_15313,type,
    v28794: state_type > $o ).

tff(pred_def_15314,type,
    v28793: state_type > $o ).

tff(pred_def_15315,type,
    v28804: state_type > $o ).

tff(pred_def_15316,type,
    v28805: state_type > $o ).

tff(pred_def_15317,type,
    v28801: state_type > $o ).

tff(pred_def_15318,type,
    v28803: state_type > $o ).

tff(pred_def_15319,type,
    v28811: state_type > $o ).

tff(pred_def_15320,type,
    v28809: state_type > $o ).

tff(pred_def_15321,type,
    v28813: state_type > $o ).

tff(pred_def_15322,type,
    v28772: state_type > $o ).

tff(pred_def_15323,type,
    v28770: state_type > $o ).

tff(pred_def_15324,type,
    v28768: state_type > $o ).

tff(pred_def_15325,type,
    v28820: state_type > $o ).

tff(pred_def_15326,type,
    v28818: state_type > $o ).

tff(pred_def_15327,type,
    v28817: state_type > $o ).

tff(pred_def_15328,type,
    v28816: state_type > $o ).

tff(pred_def_15329,type,
    v28828: state_type > $o ).

tff(pred_def_15330,type,
    v28829: state_type > $o ).

tff(pred_def_15331,type,
    v28827: state_type > $o ).

tff(pred_def_15332,type,
    v28824: ( state_type * $int ) > $o ).

tff(pred_def_15333,type,
    v28826: ( state_type * $int ) > $o ).

tff(pred_def_15334,type,
    v28815: ( state_type * $int ) > $o ).

tff(pred_def_15335,type,
    v28697: state_type > $o ).

tff(pred_def_15336,type,
    v28695: state_type > $o ).

tff(pred_def_15337,type,
    v28841: state_type > $o ).

tff(pred_def_15338,type,
    v28839: state_type > $o ).

tff(pred_def_15339,type,
    v28838: state_type > $o ).

tff(pred_def_15340,type,
    v28837: ( state_type * $int ) > $o ).

tff(pred_def_15341,type,
    v28835: state_type > $o ).

tff(pred_def_15342,type,
    v28833: state_type > $o ).

tff(pred_def_15343,type,
    v28846: state_type > $o ).

tff(pred_def_15344,type,
    v28845: state_type > $o ).

tff(pred_def_15345,type,
    v28678: state_type > $o ).

tff(pred_def_15346,type,
    v28676: state_type > $o ).

tff(pred_def_15347,type,
    v28674: state_type > $o ).

tff(pred_def_15348,type,
    v28847: ( state_type * $int ) > $o ).

tff(pred_def_15349,type,
    v28848: state_type > $o ).

tff(pred_def_15350,type,
    v28672: ( state_type * $int ) > $o ).

tff(pred_def_15351,type,
    v28670: ( state_type * $int ) > $o ).

tff(pred_def_15352,type,
    v28849: ( state_type * $int ) > $o ).

tff(pred_def_15353,type,
    v28660: ( state_type * $int ) > $o ).

tff(pred_def_15354,type,
    v28658: ( state_type * $int ) > $o ).

tff(pred_def_15355,type,
    v28656: state_type > $o ).

tff(pred_def_15356,type,
    v28850: ( state_type * $int ) > $o ).

tff(pred_def_15357,type,
    v28851: state_type > $o ).

tff(pred_def_15358,type,
    v28654: ( state_type * $int ) > $o ).

tff(pred_def_15359,type,
    v28652: ( state_type * $int ) > $o ).

tff(pred_def_15360,type,
    v28852: ( state_type * $int ) > $o ).

tff(pred_def_15361,type,
    v28644: ( state_type * $int ) > $o ).

tff(pred_def_15362,type,
    v28642: ( state_type * $int ) > $o ).

tff(pred_def_15363,type,
    v28858: state_type > $o ).

tff(pred_def_15364,type,
    v28856: state_type > $o ).

tff(pred_def_15365,type,
    v28855: state_type > $o ).

tff(pred_def_15366,type,
    v28854: ( state_type * $int ) > $o ).

tff(pred_def_15367,type,
    v28599: state_type > $o ).

tff(pred_def_15368,type,
    v28597: state_type > $o ).

tff(pred_def_15369,type,
    v28864: state_type > $o ).

tff(pred_def_15370,type,
    v28862: state_type > $o ).

tff(pred_def_15371,type,
    v28868: state_type > $o ).

tff(pred_def_15372,type,
    v28866: state_type > $o ).

tff(pred_def_15373,type,
    v28871: state_type > $o ).

tff(pred_def_15374,type,
    v28870: state_type > $o ).

tff(pred_def_15375,type,
    v28595: state_type > $o ).

tff(pred_def_15376,type,
    v28593: state_type > $o ).

tff(pred_def_15377,type,
    v28591: state_type > $o ).

tff(pred_def_15378,type,
    v28589: state_type > $o ).

tff(pred_def_15379,type,
    v28587: state_type > $o ).

tff(pred_def_15380,type,
    v28585: state_type > $o ).

tff(pred_def_15381,type,
    v28583: state_type > $o ).

tff(pred_def_15382,type,
    v28581: state_type > $o ).

tff(pred_def_15383,type,
    v28891: state_type > $o ).

tff(pred_def_15384,type,
    v28889: state_type > $o ).

tff(pred_def_15385,type,
    v28887: state_type > $o ).

tff(pred_def_15386,type,
    v28885: state_type > $o ).

tff(pred_def_15387,type,
    v28883: state_type > $o ).

tff(pred_def_15388,type,
    v28901: state_type > $o ).

tff(pred_def_15389,type,
    v28899: state_type > $o ).

tff(pred_def_15390,type,
    v28897: state_type > $o ).

tff(pred_def_15391,type,
    v28895: state_type > $o ).

tff(pred_def_15392,type,
    v28893: state_type > $o ).

tff(pred_def_15393,type,
    v28905: ( state_type * $int ) > $o ).

tff(pred_def_15394,type,
    v28903: ( state_type * $int ) > $o ).

tff(pred_def_15395,type,
    v28915: state_type > $o ).

tff(pred_def_15396,type,
    v28913: state_type > $o ).

tff(pred_def_15397,type,
    v28921: state_type > $o ).

tff(pred_def_15398,type,
    v28919: state_type > $o ).

tff(pred_def_15399,type,
    v28945: ( state_type * $int ) > $o ).

tff(pred_def_15400,type,
    v28943: ( state_type * $int ) > $o ).

tff(pred_def_15401,type,
    v28946: ( state_type * $int ) > $o ).

tff(pred_def_15402,type,
    v28941: ( state_type * $int ) > $o ).

tff(pred_def_15403,type,
    v28939: ( state_type * $int ) > $o ).

tff(pred_def_15404,type,
    v28937: ( state_type * $int ) > $o ).

tff(pred_def_15405,type,
    v28935: state_type > $o ).

tff(pred_def_15406,type,
    v28933: state_type > $o ).

tff(pred_def_15407,type,
    v28950: state_type > $o ).

tff(pred_def_15408,type,
    v28948: state_type > $o ).

tff(pred_def_15409,type,
    v28954: state_type > $o ).

tff(pred_def_15410,type,
    v28952: state_type > $o ).

tff(pred_def_15411,type,
    v28957: state_type > $o ).

tff(pred_def_15412,type,
    v28956: state_type > $o ).

tff(pred_def_15413,type,
    v28931: state_type > $o ).

tff(pred_def_15414,type,
    v28929: state_type > $o ).

tff(pred_def_15415,type,
    v28927: state_type > $o ).

tff(pred_def_15416,type,
    v28925: state_type > $o ).

tff(pred_def_15417,type,
    v28923: state_type > $o ).

tff(pred_def_15418,type,
    v28961: state_type > $o ).

tff(pred_def_15419,type,
    v28959: state_type > $o ).

tff(pred_def_15420,type,
    v28917: state_type > $o ).

tff(pred_def_15421,type,
    v28967: state_type > $o ).

tff(pred_def_15422,type,
    v28969: state_type > $o ).

tff(pred_def_15423,type,
    v28965: state_type > $o ).

tff(pred_def_15424,type,
    v28964: state_type > $o ).

tff(pred_def_15425,type,
    v28975: state_type > $o ).

tff(pred_def_15426,type,
    v28976: state_type > $o ).

tff(pred_def_15427,type,
    v28972: state_type > $o ).

tff(pred_def_15428,type,
    v28974: state_type > $o ).

tff(pred_def_15429,type,
    v28982: state_type > $o ).

tff(pred_def_15430,type,
    v28980: state_type > $o ).

tff(pred_def_15431,type,
    v28984: state_type > $o ).

tff(pred_def_15432,type,
    v28911: state_type > $o ).

tff(pred_def_15433,type,
    v28909: state_type > $o ).

tff(pred_def_15434,type,
    v28907: state_type > $o ).

tff(pred_def_15435,type,
    v28991: state_type > $o ).

tff(pred_def_15436,type,
    v28989: state_type > $o ).

tff(pred_def_15437,type,
    v28988: state_type > $o ).

tff(pred_def_15438,type,
    v28987: state_type > $o ).

tff(pred_def_15439,type,
    v28999: state_type > $o ).

tff(pred_def_15440,type,
    v29000: state_type > $o ).

tff(pred_def_15441,type,
    v28998: state_type > $o ).

tff(pred_def_15442,type,
    v28995: ( state_type * $int ) > $o ).

tff(pred_def_15443,type,
    v28997: ( state_type * $int ) > $o ).

tff(pred_def_15444,type,
    v28881: ( state_type * $int ) > $o ).

tff(pred_def_15445,type,
    v28879: ( state_type * $int ) > $o ).

tff(pred_def_15446,type,
    v28877: ( state_type * $int ) > $o ).

tff(pred_def_15447,type,
    v28875: ( state_type * $int ) > $o ).

tff(pred_def_15448,type,
    v28873: ( state_type * $int ) > $o ).

tff(pred_def_15449,type,
    v29022: state_type > $o ).

tff(pred_def_15450,type,
    v29020: state_type > $o ).

tff(pred_def_15451,type,
    v29026: state_type > $o ).

tff(pred_def_15452,type,
    v29024: state_type > $o ).

tff(pred_def_15453,type,
    v29030: state_type > $o ).

tff(pred_def_15454,type,
    v29028: state_type > $o ).

tff(pred_def_15455,type,
    v29033: state_type > $o ).

tff(pred_def_15456,type,
    v29032: state_type > $o ).

tff(pred_def_15457,type,
    v29018: state_type > $o ).

tff(pred_def_15458,type,
    v29016: state_type > $o ).

tff(pred_def_15459,type,
    v29014: state_type > $o ).

tff(pred_def_15460,type,
    v29012: state_type > $o ).

tff(pred_def_15461,type,
    v29010: state_type > $o ).

tff(pred_def_15462,type,
    v29008: state_type > $o ).

tff(pred_def_15463,type,
    v29006: state_type > $o ).

tff(pred_def_15464,type,
    v29004: state_type > $o ).

tff(pred_def_15465,type,
    v29053: state_type > $o ).

tff(pred_def_15466,type,
    v29051: state_type > $o ).

tff(pred_def_15467,type,
    v29049: state_type > $o ).

tff(pred_def_15468,type,
    v29047: state_type > $o ).

tff(pred_def_15469,type,
    v29045: state_type > $o ).

tff(pred_def_15470,type,
    v29063: state_type > $o ).

tff(pred_def_15471,type,
    v29061: state_type > $o ).

tff(pred_def_15472,type,
    v29059: state_type > $o ).

tff(pred_def_15473,type,
    v29057: state_type > $o ).

tff(pred_def_15474,type,
    v29055: state_type > $o ).

tff(pred_def_15475,type,
    v29067: ( state_type * $int ) > $o ).

tff(pred_def_15476,type,
    v29065: ( state_type * $int ) > $o ).

tff(pred_def_15477,type,
    v29077: state_type > $o ).

tff(pred_def_15478,type,
    v29075: state_type > $o ).

tff(pred_def_15479,type,
    v29083: state_type > $o ).

tff(pred_def_15480,type,
    v29081: state_type > $o ).

tff(pred_def_15481,type,
    v29097: state_type > $o ).

tff(pred_def_15482,type,
    v29095: state_type > $o ).

tff(pred_def_15483,type,
    v29101: state_type > $o ).

tff(pred_def_15484,type,
    v29099: state_type > $o ).

tff(pred_def_15485,type,
    v29105: state_type > $o ).

tff(pred_def_15486,type,
    v29103: state_type > $o ).

tff(pred_def_15487,type,
    v29108: state_type > $o ).

tff(pred_def_15488,type,
    v29107: state_type > $o ).

tff(pred_def_15489,type,
    v29093: state_type > $o ).

tff(pred_def_15490,type,
    v29091: state_type > $o ).

tff(pred_def_15491,type,
    v29089: state_type > $o ).

tff(pred_def_15492,type,
    v29087: state_type > $o ).

tff(pred_def_15493,type,
    v29085: state_type > $o ).

tff(pred_def_15494,type,
    v29112: state_type > $o ).

tff(pred_def_15495,type,
    v29110: state_type > $o ).

tff(pred_def_15496,type,
    v29079: state_type > $o ).

tff(pred_def_15497,type,
    v29118: state_type > $o ).

tff(pred_def_15498,type,
    v29120: state_type > $o ).

tff(pred_def_15499,type,
    v29116: state_type > $o ).

tff(pred_def_15500,type,
    v29115: state_type > $o ).

tff(pred_def_15501,type,
    v29126: state_type > $o ).

tff(pred_def_15502,type,
    v29127: state_type > $o ).

tff(pred_def_15503,type,
    v29123: state_type > $o ).

tff(pred_def_15504,type,
    v29125: state_type > $o ).

tff(pred_def_15505,type,
    v29133: state_type > $o ).

tff(pred_def_15506,type,
    v29131: state_type > $o ).

tff(pred_def_15507,type,
    v29135: state_type > $o ).

tff(pred_def_15508,type,
    v29073: state_type > $o ).

tff(pred_def_15509,type,
    v29071: state_type > $o ).

tff(pred_def_15510,type,
    v29069: state_type > $o ).

tff(pred_def_15511,type,
    v29142: state_type > $o ).

tff(pred_def_15512,type,
    v29140: state_type > $o ).

tff(pred_def_15513,type,
    v29139: state_type > $o ).

tff(pred_def_15514,type,
    v29138: state_type > $o ).

tff(pred_def_15515,type,
    v29150: state_type > $o ).

tff(pred_def_15516,type,
    v29151: state_type > $o ).

tff(pred_def_15517,type,
    v29149: state_type > $o ).

tff(pred_def_15518,type,
    v29146: ( state_type * $int ) > $o ).

tff(pred_def_15519,type,
    v29148: ( state_type * $int ) > $o ).

tff(pred_def_15520,type,
    v29043: ( state_type * $int ) > $o ).

tff(pred_def_15521,type,
    v29041: ( state_type * $int ) > $o ).

tff(pred_def_15522,type,
    v29039: ( state_type * $int ) > $o ).

tff(pred_def_15523,type,
    v29037: ( state_type * $int ) > $o ).

tff(pred_def_15524,type,
    v29035: ( state_type * $int ) > $o ).

tff(pred_def_15525,type,
    v29173: state_type > $o ).

tff(pred_def_15526,type,
    v29171: state_type > $o ).

tff(pred_def_15527,type,
    v29177: state_type > $o ).

tff(pred_def_15528,type,
    v29175: state_type > $o ).

tff(pred_def_15529,type,
    v29181: state_type > $o ).

tff(pred_def_15530,type,
    v29179: state_type > $o ).

tff(pred_def_15531,type,
    v29184: state_type > $o ).

tff(pred_def_15532,type,
    v29183: state_type > $o ).

tff(pred_def_15533,type,
    v29169: state_type > $o ).

tff(pred_def_15534,type,
    v29167: state_type > $o ).

tff(pred_def_15535,type,
    v29165: state_type > $o ).

tff(pred_def_15536,type,
    v29163: state_type > $o ).

tff(pred_def_15537,type,
    v29161: state_type > $o ).

tff(pred_def_15538,type,
    v29159: state_type > $o ).

tff(pred_def_15539,type,
    v29157: state_type > $o ).

tff(pred_def_15540,type,
    v29155: state_type > $o ).

tff(pred_def_15541,type,
    v29204: state_type > $o ).

tff(pred_def_15542,type,
    v29202: state_type > $o ).

tff(pred_def_15543,type,
    v29200: state_type > $o ).

tff(pred_def_15544,type,
    v29198: state_type > $o ).

tff(pred_def_15545,type,
    v29196: state_type > $o ).

tff(pred_def_15546,type,
    v29214: state_type > $o ).

tff(pred_def_15547,type,
    v29212: state_type > $o ).

tff(pred_def_15548,type,
    v29210: state_type > $o ).

tff(pred_def_15549,type,
    v29208: state_type > $o ).

tff(pred_def_15550,type,
    v29206: state_type > $o ).

tff(pred_def_15551,type,
    v29218: ( state_type * $int ) > $o ).

tff(pred_def_15552,type,
    v29216: ( state_type * $int ) > $o ).

tff(pred_def_15553,type,
    v29228: state_type > $o ).

tff(pred_def_15554,type,
    v29226: state_type > $o ).

tff(pred_def_15555,type,
    v29234: state_type > $o ).

tff(pred_def_15556,type,
    v29232: state_type > $o ).

tff(pred_def_15557,type,
    v29248: state_type > $o ).

tff(pred_def_15558,type,
    v29246: state_type > $o ).

tff(pred_def_15559,type,
    v29252: state_type > $o ).

tff(pred_def_15560,type,
    v29250: state_type > $o ).

tff(pred_def_15561,type,
    v29256: state_type > $o ).

tff(pred_def_15562,type,
    v29254: state_type > $o ).

tff(pred_def_15563,type,
    v29259: state_type > $o ).

tff(pred_def_15564,type,
    v29258: state_type > $o ).

tff(pred_def_15565,type,
    v29244: state_type > $o ).

tff(pred_def_15566,type,
    v29242: state_type > $o ).

tff(pred_def_15567,type,
    v29240: state_type > $o ).

tff(pred_def_15568,type,
    v29238: state_type > $o ).

tff(pred_def_15569,type,
    v29236: state_type > $o ).

tff(pred_def_15570,type,
    v29263: state_type > $o ).

tff(pred_def_15571,type,
    v29261: state_type > $o ).

tff(pred_def_15572,type,
    v29230: state_type > $o ).

tff(pred_def_15573,type,
    v29269: state_type > $o ).

tff(pred_def_15574,type,
    v29271: state_type > $o ).

tff(pred_def_15575,type,
    v29267: state_type > $o ).

tff(pred_def_15576,type,
    v29266: state_type > $o ).

tff(pred_def_15577,type,
    v29277: state_type > $o ).

tff(pred_def_15578,type,
    v29278: state_type > $o ).

tff(pred_def_15579,type,
    v29274: state_type > $o ).

tff(pred_def_15580,type,
    v29276: state_type > $o ).

tff(pred_def_15581,type,
    v29284: state_type > $o ).

tff(pred_def_15582,type,
    v29282: state_type > $o ).

tff(pred_def_15583,type,
    v29286: state_type > $o ).

tff(pred_def_15584,type,
    v29224: state_type > $o ).

tff(pred_def_15585,type,
    v29222: state_type > $o ).

tff(pred_def_15586,type,
    v29220: state_type > $o ).

tff(pred_def_15587,type,
    v29293: state_type > $o ).

tff(pred_def_15588,type,
    v29291: state_type > $o ).

tff(pred_def_15589,type,
    v29290: state_type > $o ).

tff(pred_def_15590,type,
    v29289: state_type > $o ).

tff(pred_def_15591,type,
    v29301: state_type > $o ).

tff(pred_def_15592,type,
    v29302: state_type > $o ).

tff(pred_def_15593,type,
    v29300: state_type > $o ).

tff(pred_def_15594,type,
    v29297: ( state_type * $int ) > $o ).

tff(pred_def_15595,type,
    v29299: ( state_type * $int ) > $o ).

tff(pred_def_15596,type,
    v29194: ( state_type * $int ) > $o ).

tff(pred_def_15597,type,
    v29192: ( state_type * $int ) > $o ).

tff(pred_def_15598,type,
    v29190: ( state_type * $int ) > $o ).

tff(pred_def_15599,type,
    v29188: ( state_type * $int ) > $o ).

tff(pred_def_15600,type,
    v29186: ( state_type * $int ) > $o ).

tff(pred_def_15601,type,
    v29324: state_type > $o ).

tff(pred_def_15602,type,
    v29322: state_type > $o ).

tff(pred_def_15603,type,
    v29328: state_type > $o ).

tff(pred_def_15604,type,
    v29326: state_type > $o ).

tff(pred_def_15605,type,
    v29332: state_type > $o ).

tff(pred_def_15606,type,
    v29330: state_type > $o ).

tff(pred_def_15607,type,
    v29335: state_type > $o ).

tff(pred_def_15608,type,
    v29334: state_type > $o ).

tff(pred_def_15609,type,
    v29320: state_type > $o ).

tff(pred_def_15610,type,
    v29318: state_type > $o ).

tff(pred_def_15611,type,
    v29316: state_type > $o ).

tff(pred_def_15612,type,
    v29314: state_type > $o ).

tff(pred_def_15613,type,
    v29312: state_type > $o ).

tff(pred_def_15614,type,
    v29310: state_type > $o ).

tff(pred_def_15615,type,
    v29308: state_type > $o ).

tff(pred_def_15616,type,
    v29306: state_type > $o ).

tff(pred_def_15617,type,
    v29355: state_type > $o ).

tff(pred_def_15618,type,
    v29353: state_type > $o ).

tff(pred_def_15619,type,
    v29351: state_type > $o ).

tff(pred_def_15620,type,
    v29349: state_type > $o ).

tff(pred_def_15621,type,
    v29347: state_type > $o ).

tff(pred_def_15622,type,
    v29365: state_type > $o ).

tff(pred_def_15623,type,
    v29363: state_type > $o ).

tff(pred_def_15624,type,
    v29361: state_type > $o ).

tff(pred_def_15625,type,
    v29359: state_type > $o ).

tff(pred_def_15626,type,
    v29357: state_type > $o ).

tff(pred_def_15627,type,
    v29369: ( state_type * $int ) > $o ).

tff(pred_def_15628,type,
    v29367: ( state_type * $int ) > $o ).

tff(pred_def_15629,type,
    v29379: state_type > $o ).

tff(pred_def_15630,type,
    v29377: state_type > $o ).

tff(pred_def_15631,type,
    v29385: state_type > $o ).

tff(pred_def_15632,type,
    v29383: state_type > $o ).

tff(pred_def_15633,type,
    v29399: state_type > $o ).

tff(pred_def_15634,type,
    v29397: state_type > $o ).

tff(pred_def_15635,type,
    v29403: state_type > $o ).

tff(pred_def_15636,type,
    v29401: state_type > $o ).

tff(pred_def_15637,type,
    v29407: state_type > $o ).

tff(pred_def_15638,type,
    v29405: state_type > $o ).

tff(pred_def_15639,type,
    v29410: state_type > $o ).

tff(pred_def_15640,type,
    v29409: state_type > $o ).

tff(pred_def_15641,type,
    v29395: state_type > $o ).

tff(pred_def_15642,type,
    v29393: state_type > $o ).

tff(pred_def_15643,type,
    v29391: state_type > $o ).

tff(pred_def_15644,type,
    v29389: state_type > $o ).

tff(pred_def_15645,type,
    v29387: state_type > $o ).

tff(pred_def_15646,type,
    v29414: state_type > $o ).

tff(pred_def_15647,type,
    v29412: state_type > $o ).

tff(pred_def_15648,type,
    v29381: state_type > $o ).

tff(pred_def_15649,type,
    v29420: state_type > $o ).

tff(pred_def_15650,type,
    v29422: state_type > $o ).

tff(pred_def_15651,type,
    v29418: state_type > $o ).

tff(pred_def_15652,type,
    v29417: state_type > $o ).

tff(pred_def_15653,type,
    v29428: state_type > $o ).

tff(pred_def_15654,type,
    v29429: state_type > $o ).

tff(pred_def_15655,type,
    v29425: state_type > $o ).

tff(pred_def_15656,type,
    v29427: state_type > $o ).

tff(pred_def_15657,type,
    v29435: state_type > $o ).

tff(pred_def_15658,type,
    v29433: state_type > $o ).

tff(pred_def_15659,type,
    v29437: state_type > $o ).

tff(pred_def_15660,type,
    v29375: state_type > $o ).

tff(pred_def_15661,type,
    v29373: state_type > $o ).

tff(pred_def_15662,type,
    v29371: state_type > $o ).

tff(pred_def_15663,type,
    v29444: state_type > $o ).

tff(pred_def_15664,type,
    v29442: state_type > $o ).

tff(pred_def_15665,type,
    v29441: state_type > $o ).

tff(pred_def_15666,type,
    v29440: state_type > $o ).

tff(pred_def_15667,type,
    v29452: state_type > $o ).

tff(pred_def_15668,type,
    v29453: state_type > $o ).

tff(pred_def_15669,type,
    v29451: state_type > $o ).

tff(pred_def_15670,type,
    v29448: ( state_type * $int ) > $o ).

tff(pred_def_15671,type,
    v29450: ( state_type * $int ) > $o ).

tff(pred_def_15672,type,
    v29345: ( state_type * $int ) > $o ).

tff(pred_def_15673,type,
    v29343: ( state_type * $int ) > $o ).

tff(pred_def_15674,type,
    v29341: ( state_type * $int ) > $o ).

tff(pred_def_15675,type,
    v29339: ( state_type * $int ) > $o ).

tff(pred_def_15676,type,
    v29337: ( state_type * $int ) > $o ).

tff(pred_def_15677,type,
    v29475: state_type > $o ).

tff(pred_def_15678,type,
    v29473: state_type > $o ).

tff(pred_def_15679,type,
    v29479: state_type > $o ).

tff(pred_def_15680,type,
    v29477: state_type > $o ).

tff(pred_def_15681,type,
    v29483: state_type > $o ).

tff(pred_def_15682,type,
    v29481: state_type > $o ).

tff(pred_def_15683,type,
    v29486: state_type > $o ).

tff(pred_def_15684,type,
    v29485: state_type > $o ).

tff(pred_def_15685,type,
    v29471: state_type > $o ).

tff(pred_def_15686,type,
    v29469: state_type > $o ).

tff(pred_def_15687,type,
    v29467: state_type > $o ).

tff(pred_def_15688,type,
    v29465: state_type > $o ).

tff(pred_def_15689,type,
    v29463: state_type > $o ).

tff(pred_def_15690,type,
    v29461: state_type > $o ).

tff(pred_def_15691,type,
    v29459: state_type > $o ).

tff(pred_def_15692,type,
    v29457: state_type > $o ).

tff(pred_def_15693,type,
    v29506: state_type > $o ).

tff(pred_def_15694,type,
    v29504: state_type > $o ).

tff(pred_def_15695,type,
    v29502: state_type > $o ).

tff(pred_def_15696,type,
    v29500: state_type > $o ).

tff(pred_def_15697,type,
    v29498: state_type > $o ).

tff(pred_def_15698,type,
    v29516: state_type > $o ).

tff(pred_def_15699,type,
    v29514: state_type > $o ).

tff(pred_def_15700,type,
    v29512: state_type > $o ).

tff(pred_def_15701,type,
    v29510: state_type > $o ).

tff(pred_def_15702,type,
    v29508: state_type > $o ).

tff(pred_def_15703,type,
    v29520: ( state_type * $int ) > $o ).

tff(pred_def_15704,type,
    v29518: ( state_type * $int ) > $o ).

tff(pred_def_15705,type,
    v29530: state_type > $o ).

tff(pred_def_15706,type,
    v29528: state_type > $o ).

tff(pred_def_15707,type,
    v29536: state_type > $o ).

tff(pred_def_15708,type,
    v29534: state_type > $o ).

tff(pred_def_15709,type,
    v29549: state_type > $o ).

tff(pred_def_15710,type,
    v29547: state_type > $o ).

tff(pred_def_15711,type,
    v29553: state_type > $o ).

tff(pred_def_15712,type,
    v29551: state_type > $o ).

tff(pred_def_15713,type,
    v29557: state_type > $o ).

tff(pred_def_15714,type,
    v29555: state_type > $o ).

tff(pred_def_15715,type,
    v29560: state_type > $o ).

tff(pred_def_15716,type,
    v29559: state_type > $o ).

tff(pred_def_15717,type,
    v29545: state_type > $o ).

tff(pred_def_15718,type,
    v29543: state_type > $o ).

tff(pred_def_15719,type,
    v29540: state_type > $o ).

tff(pred_def_15720,type,
    v29538: state_type > $o ).

tff(pred_def_15721,type,
    v29564: state_type > $o ).

tff(pred_def_15722,type,
    v29562: state_type > $o ).

tff(pred_def_15723,type,
    v29532: state_type > $o ).

tff(pred_def_15724,type,
    v29570: state_type > $o ).

tff(pred_def_15725,type,
    v29572: state_type > $o ).

tff(pred_def_15726,type,
    v29568: state_type > $o ).

tff(pred_def_15727,type,
    v29567: state_type > $o ).

tff(pred_def_15728,type,
    v29578: state_type > $o ).

tff(pred_def_15729,type,
    v29579: state_type > $o ).

tff(pred_def_15730,type,
    v29575: state_type > $o ).

tff(pred_def_15731,type,
    v29577: state_type > $o ).

tff(pred_def_15732,type,
    v29585: state_type > $o ).

tff(pred_def_15733,type,
    v29583: state_type > $o ).

tff(pred_def_15734,type,
    v29587: state_type > $o ).

tff(pred_def_15735,type,
    v29526: state_type > $o ).

tff(pred_def_15736,type,
    v29524: state_type > $o ).

tff(pred_def_15737,type,
    v29522: state_type > $o ).

tff(pred_def_15738,type,
    v29594: state_type > $o ).

tff(pred_def_15739,type,
    v29592: state_type > $o ).

tff(pred_def_15740,type,
    v29591: state_type > $o ).

tff(pred_def_15741,type,
    v29590: state_type > $o ).

tff(pred_def_15742,type,
    v29602: state_type > $o ).

tff(pred_def_15743,type,
    v29603: state_type > $o ).

tff(pred_def_15744,type,
    v29601: state_type > $o ).

tff(pred_def_15745,type,
    v29598: ( state_type * $int ) > $o ).

tff(pred_def_15746,type,
    v29600: ( state_type * $int ) > $o ).

tff(pred_def_15747,type,
    v29496: ( state_type * $int ) > $o ).

tff(pred_def_15748,type,
    v29494: ( state_type * $int ) > $o ).

tff(pred_def_15749,type,
    v29492: ( state_type * $int ) > $o ).

tff(pred_def_15750,type,
    v29490: ( state_type * $int ) > $o ).

tff(pred_def_15751,type,
    v29488: ( state_type * $int ) > $o ).

tff(pred_def_15752,type,
    v29615: state_type > $o ).

tff(pred_def_15753,type,
    v29613: state_type > $o ).

tff(pred_def_15754,type,
    v29611: state_type > $o ).

tff(pred_def_15755,type,
    v29609: state_type > $o ).

tff(pred_def_15756,type,
    v29607: state_type > $o ).

tff(pred_def_15757,type,
    v29623: state_type > $o ).

tff(pred_def_15758,type,
    v29622: ( state_type * $int ) > $o ).

tff(pred_def_15759,type,
    v29621: ( state_type * $int ) > $o ).

tff(pred_def_15760,type,
    v29626: state_type > $o ).

tff(pred_def_15761,type,
    v29625: ( state_type * $int ) > $o ).

tff(pred_def_15762,type,
    v29624: ( state_type * $int ) > $o ).

tff(pred_def_15763,type,
    v29620: ( state_type * $int ) > $o ).

tff(pred_def_15764,type,
    v29629: state_type > $o ).

tff(pred_def_15765,type,
    v29628: ( state_type * $int ) > $o ).

tff(pred_def_15766,type,
    v29627: ( state_type * $int ) > $o ).

tff(pred_def_15767,type,
    v29619: ( state_type * $int ) > $o ).

tff(pred_def_15768,type,
    v29632: state_type > $o ).

tff(pred_def_15769,type,
    v29631: ( state_type * $int ) > $o ).

tff(pred_def_15770,type,
    v29630: ( state_type * $int ) > $o ).

tff(pred_def_15771,type,
    v29618: ( state_type * $int ) > $o ).

tff(pred_def_15772,type,
    v29635: state_type > $o ).

tff(pred_def_15773,type,
    v29634: ( state_type * $int ) > $o ).

tff(pred_def_15774,type,
    v29633: ( state_type * $int ) > $o ).

tff(pred_def_15775,type,
    v29617: ( state_type * $int ) > $o ).

tff(pred_def_15776,type,
    v29638: state_type > $o ).

tff(pred_def_15777,type,
    v29637: ( state_type * $int ) > $o ).

tff(pred_def_15778,type,
    v29636: ( state_type * $int ) > $o ).

tff(pred_def_15779,type,
    v28109: ( state_type * $int ) > $o ).

tff(pred_def_15780,type,
    v28107: ( state_type * $int ) > $o ).

tff(pred_def_15781,type,
    v28105: ( state_type * $int ) > $o ).

tff(pred_def_15782,type,
    v28103: ( state_type * $int ) > $o ).

tff(pred_def_15783,type,
    v28101: ( state_type * $int ) > $o ).

tff(pred_def_15784,type,
    v28095: state_type > $o ).

tff(pred_def_15785,type,
    v28093: state_type > $o ).

tff(pred_def_15786,type,
    v28091: state_type > $o ).

tff(pred_def_15787,type,
    v29649: ( state_type * $int ) > $o ).

tff(pred_def_15788,type,
    v29647: ( state_type * $int ) > $o ).

tff(pred_def_15789,type,
    v29683: state_type > $o ).

tff(pred_def_15790,type,
    v29681: state_type > $o ).

tff(pred_def_15791,type,
    v29679: state_type > $o ).

tff(pred_def_15792,type,
    v29677: state_type > $o ).

tff(pred_def_15793,type,
    v29675: state_type > $o ).

tff(pred_def_15794,type,
    v29673: state_type > $o ).

tff(pred_def_15795,type,
    v29671: state_type > $o ).

tff(pred_def_15796,type,
    v29697: state_type > $o ).

tff(pred_def_15797,type,
    v29695: state_type > $o ).

tff(pred_def_15798,type,
    v29693: state_type > $o ).

tff(pred_def_15799,type,
    v29691: state_type > $o ).

tff(pred_def_15800,type,
    v29689: state_type > $o ).

tff(pred_def_15801,type,
    v29687: state_type > $o ).

tff(pred_def_15802,type,
    v29685: state_type > $o ).

tff(pred_def_15803,type,
    v29723: state_type > $o ).

tff(pred_def_15804,type,
    v29725: state_type > $o ).

tff(pred_def_15805,type,
    v29724: ( state_type * $int ) > $o ).

tff(pred_def_15806,type,
    v29726: state_type > $o ).

tff(pred_def_15807,type,
    v29721: ( state_type * $int ) > $o ).

tff(pred_def_15808,type,
    v29719: ( state_type * $int ) > $o ).

tff(pred_def_15809,type,
    v29727: ( state_type * $int ) > $o ).

tff(pred_def_15810,type,
    v29717: ( state_type * $int ) > $o ).

tff(pred_def_15811,type,
    v29715: ( state_type * $int ) > $o ).

tff(pred_def_15812,type,
    v29713: state_type > $o ).

tff(pred_def_15813,type,
    v29729: state_type > $o ).

tff(pred_def_15814,type,
    v29711: ( state_type * $int ) > $o ).

tff(pred_def_15815,type,
    v29709: ( state_type * $int ) > $o ).

tff(pred_def_15816,type,
    v29735: ( state_type * $int ) > $o ).

tff(pred_def_15817,type,
    v29733: ( state_type * $int ) > $o ).

tff(pred_def_15818,type,
    v29731: ( state_type * $int ) > $o ).

tff(pred_def_15819,type,
    v29707: ( state_type * $int ) > $o ).

tff(pred_def_15820,type,
    v29705: ( state_type * $int ) > $o ).

tff(pred_def_15821,type,
    v29703: ( state_type * $int ) > $o ).

tff(pred_def_15822,type,
    v29701: ( state_type * $int ) > $o ).

tff(pred_def_15823,type,
    v29699: ( state_type * $int ) > $o ).

tff(pred_def_15824,type,
    v29748: state_type > $o ).

tff(pred_def_15825,type,
    v29746: state_type > $o ).

tff(pred_def_15826,type,
    v29744: state_type > $o ).

tff(pred_def_15827,type,
    v29754: state_type > $o ).

tff(pred_def_15828,type,
    v29752: state_type > $o ).

tff(pred_def_15829,type,
    v29772: ( state_type * $int ) > $o ).

tff(pred_def_15830,type,
    v29774: ( state_type * $int ) > $o ).

tff(pred_def_15831,type,
    v29770: ( state_type * $int ) > $o ).

tff(pred_def_15832,type,
    v29768: state_type > $o ).

tff(pred_def_15833,type,
    v29766: state_type > $o ).

tff(pred_def_15834,type,
    v29778: state_type > $o ).

tff(pred_def_15835,type,
    v29776: state_type > $o ).

tff(pred_def_15836,type,
    v29782: state_type > $o ).

tff(pred_def_15837,type,
    v29780: state_type > $o ).

tff(pred_def_15838,type,
    v29785: state_type > $o ).

tff(pred_def_15839,type,
    v29784: state_type > $o ).

tff(pred_def_15840,type,
    v29764: state_type > $o ).

tff(pred_def_15841,type,
    v29762: state_type > $o ).

tff(pred_def_15842,type,
    v29760: state_type > $o ).

tff(pred_def_15843,type,
    v29758: state_type > $o ).

tff(pred_def_15844,type,
    v29756: state_type > $o ).

tff(pred_def_15845,type,
    v29793: state_type > $o ).

tff(pred_def_15846,type,
    v29791: state_type > $o ).

tff(pred_def_15847,type,
    v29789: state_type > $o ).

tff(pred_def_15848,type,
    v29787: state_type > $o ).

tff(pred_def_15849,type,
    v29750: state_type > $o ).

tff(pred_def_15850,type,
    v29799: state_type > $o ).

tff(pred_def_15851,type,
    v29801: state_type > $o ).

tff(pred_def_15852,type,
    v29797: state_type > $o ).

tff(pred_def_15853,type,
    v29796: state_type > $o ).

tff(pred_def_15854,type,
    v29807: state_type > $o ).

tff(pred_def_15855,type,
    v29808: state_type > $o ).

tff(pred_def_15856,type,
    v29804: state_type > $o ).

tff(pred_def_15857,type,
    v29806: state_type > $o ).

tff(pred_def_15858,type,
    v29818: state_type > $o ).

tff(pred_def_15859,type,
    v29816: state_type > $o ).

tff(pred_def_15860,type,
    v29814: state_type > $o ).

tff(pred_def_15861,type,
    v29812: state_type > $o ).

tff(pred_def_15862,type,
    v29820: state_type > $o ).

tff(pred_def_15863,type,
    v29742: state_type > $o ).

tff(pred_def_15864,type,
    v29740: state_type > $o ).

tff(pred_def_15865,type,
    v29738: state_type > $o ).

tff(pred_def_15866,type,
    v29827: state_type > $o ).

tff(pred_def_15867,type,
    v29825: state_type > $o ).

tff(pred_def_15868,type,
    v29824: state_type > $o ).

tff(pred_def_15869,type,
    v29823: state_type > $o ).

tff(pred_def_15870,type,
    v29835: state_type > $o ).

tff(pred_def_15871,type,
    v29836: state_type > $o ).

tff(pred_def_15872,type,
    v29834: state_type > $o ).

tff(pred_def_15873,type,
    v29831: ( state_type * $int ) > $o ).

tff(pred_def_15874,type,
    v29833: ( state_type * $int ) > $o ).

tff(pred_def_15875,type,
    v29669: ( state_type * $int ) > $o ).

tff(pred_def_15876,type,
    v29667: ( state_type * $int ) > $o ).

tff(pred_def_15877,type,
    v29665: ( state_type * $int ) > $o ).

tff(pred_def_15878,type,
    v29663: ( state_type * $int ) > $o ).

tff(pred_def_15879,type,
    v29661: ( state_type * $int ) > $o ).

tff(pred_def_15880,type,
    v29872: state_type > $o ).

tff(pred_def_15881,type,
    v29870: state_type > $o ).

tff(pred_def_15882,type,
    v29868: state_type > $o ).

tff(pred_def_15883,type,
    v29866: state_type > $o ).

tff(pred_def_15884,type,
    v29864: state_type > $o ).

tff(pred_def_15885,type,
    v29862: state_type > $o ).

tff(pred_def_15886,type,
    v29882: state_type > $o ).

tff(pred_def_15887,type,
    v29880: state_type > $o ).

tff(pred_def_15888,type,
    v29878: state_type > $o ).

tff(pred_def_15889,type,
    v29876: state_type > $o ).

tff(pred_def_15890,type,
    v29874: state_type > $o ).

tff(pred_def_15891,type,
    v29909: state_type > $o ).

tff(pred_def_15892,type,
    v29908: ( state_type * $int ) > $o ).

tff(pred_def_15893,type,
    v29907: ( state_type * $int ) > $o ).

tff(pred_def_15894,type,
    v29905: ( state_type * $int ) > $o ).

tff(pred_def_15895,type,
    v29925: state_type > $o ).

tff(pred_def_15896,type,
    v29926: ( state_type * $int ) > $o ).

tff(pred_def_15897,type,
    v29927: state_type > $o ).

tff(pred_def_15898,type,
    v29923: ( state_type * $int ) > $o ).

tff(pred_def_15899,type,
    v29921: ( state_type * $int ) > $o ).

tff(pred_def_15900,type,
    v29951: ( state_type * $int ) > $o ).

tff(pred_def_15901,type,
    v29860: ( state_type * $int ) > $o ).

tff(pred_def_15902,type,
    v29949: ( state_type * $int ) > $o ).

tff(pred_def_15903,type,
    v29952: ( state_type * $int ) > $o ).

tff(pred_def_15904,type,
    v29947: ( state_type * $int ) > $o ).

tff(pred_def_15905,type,
    v29945: ( state_type * $int ) > $o ).

tff(pred_def_15906,type,
    v29943: ( state_type * $int ) > $o ).

tff(pred_def_15907,type,
    v29941: state_type > $o ).

tff(pred_def_15908,type,
    v29939: state_type > $o ).

tff(pred_def_15909,type,
    v29958: state_type > $o ).

tff(pred_def_15910,type,
    v29898: state_type > $o ).

tff(pred_def_15911,type,
    v29957: ( state_type * $int ) > $o ).

tff(pred_def_15912,type,
    v29896: ( state_type * $int ) > $o ).

tff(pred_def_15913,type,
    v29894: ( state_type * $int ) > $o ).

tff(pred_def_15914,type,
    v29973: ( state_type * $int ) > $o ).

tff(pred_def_15915,type,
    v29972: ( state_type * $int ) > $o ).

tff(pred_def_15916,type,
    v29970: ( state_type * $int ) > $o ).

tff(pred_def_15917,type,
    v29977: state_type > $o ).

tff(pred_def_15918,type,
    v29975: state_type > $o ).

tff(pred_def_15919,type,
    v29988: ( state_type * $int ) > $o ).

tff(pred_def_15920,type,
    v29987: state_type > $o ).

tff(pred_def_15921,type,
    v29991: state_type > $o ).

tff(pred_def_15922,type,
    v29992: state_type > $o ).

tff(pred_def_15923,type,
    v29990: state_type > $o ).

tff(pred_def_15924,type,
    v29993: state_type > $o ).

tff(pred_def_15925,type,
    v29989: state_type > $o ).

tff(pred_def_15926,type,
    v29986: state_type > $o ).

tff(pred_def_15927,type,
    v29994: state_type > $o ).

tff(pred_def_15928,type,
    v29985: state_type > $o ).

tff(pred_def_15929,type,
    v29997: state_type > $o ).

tff(pred_def_15930,type,
    v29998: state_type > $o ).

tff(pred_def_15931,type,
    v29996: state_type > $o ).

tff(pred_def_15932,type,
    v29999: state_type > $o ).

tff(pred_def_15933,type,
    v29995: state_type > $o ).

tff(pred_def_15934,type,
    v29984: state_type > $o ).

tff(pred_def_15935,type,
    v30000: state_type > $o ).

tff(pred_def_15936,type,
    v29983: state_type > $o ).

tff(pred_def_15937,type,
    v29982: state_type > $o ).

tff(pred_def_15938,type,
    v30004: state_type > $o ).

tff(pred_def_15939,type,
    v30005: state_type > $o ).

tff(pred_def_15940,type,
    v30003: state_type > $o ).

tff(pred_def_15941,type,
    v30006: state_type > $o ).

tff(pred_def_15942,type,
    v30002: state_type > $o ).

tff(pred_def_15943,type,
    v30001: state_type > $o ).

tff(pred_def_15944,type,
    v29981: state_type > $o ).

tff(pred_def_15945,type,
    v30007: state_type > $o ).

tff(pred_def_15946,type,
    v29980: state_type > $o ).

tff(pred_def_15947,type,
    v30010: state_type > $o ).

tff(pred_def_15948,type,
    v30011: state_type > $o ).

tff(pred_def_15949,type,
    v30009: state_type > $o ).

tff(pred_def_15950,type,
    v30012: state_type > $o ).

tff(pred_def_15951,type,
    v30008: state_type > $o ).

tff(pred_def_15952,type,
    v30015: state_type > $o ).

tff(pred_def_15953,type,
    v30016: state_type > $o ).

tff(pred_def_15954,type,
    v30014: state_type > $o ).

tff(pred_def_15955,type,
    v30017: state_type > $o ).

tff(pred_def_15956,type,
    v30013: state_type > $o ).

tff(pred_def_15957,type,
    v30020: state_type > $o ).

tff(pred_def_15958,type,
    v30021: state_type > $o ).

tff(pred_def_15959,type,
    v30019: state_type > $o ).

tff(pred_def_15960,type,
    v30022: state_type > $o ).

tff(pred_def_15961,type,
    v30018: state_type > $o ).

tff(pred_def_15962,type,
    v29978: ( state_type * $int ) > $o ).

tff(pred_def_15963,type,
    v29968: ( state_type * $int ) > $o ).

tff(pred_def_15964,type,
    v29966: ( state_type * $int ) > $o ).

tff(pred_def_15965,type,
    v29964: ( state_type * $int ) > $o ).

tff(pred_def_15966,type,
    v29962: ( state_type * $int ) > $o ).

tff(pred_def_15967,type,
    v29960: ( state_type * $int ) > $o ).

tff(pred_def_15968,type,
    v30023: ( state_type * $int ) > $o ).

tff(pred_def_15969,type,
    v29892: ( state_type * $int ) > $o ).

tff(pred_def_15970,type,
    v29890: ( state_type * $int ) > $o ).

tff(pred_def_15971,type,
    v29888: ( state_type * $int ) > $o ).

tff(pred_def_15972,type,
    v30024: ( state_type * $int ) > $o ).

tff(pred_def_15973,type,
    v30025: ( state_type * $int ) > $o ).

tff(pred_def_15974,type,
    v29886: ( state_type * $int ) > $o ).

tff(pred_def_15975,type,
    v29884: ( state_type * $int ) > $o ).

tff(pred_def_15976,type,
    v30035: state_type > $o ).

tff(pred_def_15977,type,
    v30033: state_type > $o ).

tff(pred_def_15978,type,
    v30041: state_type > $o ).

tff(pred_def_15979,type,
    v30039: state_type > $o ).

tff(pred_def_15980,type,
    v30045: state_type > $o ).

tff(pred_def_15981,type,
    v30043: state_type > $o ).

tff(pred_def_15982,type,
    v30049: state_type > $o ).

tff(pred_def_15983,type,
    v30047: state_type > $o ).

tff(pred_def_15984,type,
    v30037: state_type > $o ).

tff(pred_def_15985,type,
    v30055: state_type > $o ).

tff(pred_def_15986,type,
    v30057: state_type > $o ).

tff(pred_def_15987,type,
    v30053: state_type > $o ).

tff(pred_def_15988,type,
    v30052: state_type > $o ).

tff(pred_def_15989,type,
    v30063: state_type > $o ).

tff(pred_def_15990,type,
    v30064: state_type > $o ).

tff(pred_def_15991,type,
    v30060: state_type > $o ).

tff(pred_def_15992,type,
    v30062: state_type > $o ).

tff(pred_def_15993,type,
    v30070: state_type > $o ).

tff(pred_def_15994,type,
    v30068: state_type > $o ).

tff(pred_def_15995,type,
    v30072: state_type > $o ).

tff(pred_def_15996,type,
    v30031: state_type > $o ).

tff(pred_def_15997,type,
    v30029: state_type > $o ).

tff(pred_def_15998,type,
    v30027: state_type > $o ).

tff(pred_def_15999,type,
    v30079: state_type > $o ).

tff(pred_def_16000,type,
    v30077: state_type > $o ).

tff(pred_def_16001,type,
    v30076: state_type > $o ).

tff(pred_def_16002,type,
    v30075: state_type > $o ).

tff(pred_def_16003,type,
    v30087: state_type > $o ).

tff(pred_def_16004,type,
    v30088: state_type > $o ).

tff(pred_def_16005,type,
    v30086: state_type > $o ).

tff(pred_def_16006,type,
    v30083: ( state_type * $int ) > $o ).

tff(pred_def_16007,type,
    v30085: ( state_type * $int ) > $o ).

tff(pred_def_16008,type,
    v30074: ( state_type * $int ) > $o ).

tff(pred_def_16009,type,
    v29956: state_type > $o ).

tff(pred_def_16010,type,
    v29954: state_type > $o ).

tff(pred_def_16011,type,
    v30100: state_type > $o ).

tff(pred_def_16012,type,
    v30098: state_type > $o ).

tff(pred_def_16013,type,
    v30097: state_type > $o ).

tff(pred_def_16014,type,
    v30096: ( state_type * $int ) > $o ).

tff(pred_def_16015,type,
    v30094: state_type > $o ).

tff(pred_def_16016,type,
    v30092: state_type > $o ).

tff(pred_def_16017,type,
    v30105: state_type > $o ).

tff(pred_def_16018,type,
    v30104: state_type > $o ).

tff(pred_def_16019,type,
    v29937: state_type > $o ).

tff(pred_def_16020,type,
    v29935: state_type > $o ).

tff(pred_def_16021,type,
    v29933: state_type > $o ).

tff(pred_def_16022,type,
    v30106: ( state_type * $int ) > $o ).

tff(pred_def_16023,type,
    v30107: state_type > $o ).

tff(pred_def_16024,type,
    v29931: ( state_type * $int ) > $o ).

tff(pred_def_16025,type,
    v29929: ( state_type * $int ) > $o ).

tff(pred_def_16026,type,
    v30108: ( state_type * $int ) > $o ).

tff(pred_def_16027,type,
    v29919: ( state_type * $int ) > $o ).

tff(pred_def_16028,type,
    v29917: ( state_type * $int ) > $o ).

tff(pred_def_16029,type,
    v29915: state_type > $o ).

tff(pred_def_16030,type,
    v30109: ( state_type * $int ) > $o ).

tff(pred_def_16031,type,
    v30110: state_type > $o ).

tff(pred_def_16032,type,
    v29913: ( state_type * $int ) > $o ).

tff(pred_def_16033,type,
    v29911: ( state_type * $int ) > $o ).

tff(pred_def_16034,type,
    v30111: ( state_type * $int ) > $o ).

tff(pred_def_16035,type,
    v29903: ( state_type * $int ) > $o ).

tff(pred_def_16036,type,
    v29901: ( state_type * $int ) > $o ).

tff(pred_def_16037,type,
    v30117: state_type > $o ).

tff(pred_def_16038,type,
    v30115: state_type > $o ).

tff(pred_def_16039,type,
    v30114: state_type > $o ).

tff(pred_def_16040,type,
    v30113: ( state_type * $int ) > $o ).

tff(pred_def_16041,type,
    v29858: state_type > $o ).

tff(pred_def_16042,type,
    v29856: state_type > $o ).

tff(pred_def_16043,type,
    v30123: state_type > $o ).

tff(pred_def_16044,type,
    v30121: state_type > $o ).

tff(pred_def_16045,type,
    v30127: state_type > $o ).

tff(pred_def_16046,type,
    v30125: state_type > $o ).

tff(pred_def_16047,type,
    v30130: state_type > $o ).

tff(pred_def_16048,type,
    v30129: state_type > $o ).

tff(pred_def_16049,type,
    v29854: state_type > $o ).

tff(pred_def_16050,type,
    v29852: state_type > $o ).

tff(pred_def_16051,type,
    v29850: state_type > $o ).

tff(pred_def_16052,type,
    v29848: state_type > $o ).

tff(pred_def_16053,type,
    v29846: state_type > $o ).

tff(pred_def_16054,type,
    v29844: state_type > $o ).

tff(pred_def_16055,type,
    v29842: state_type > $o ).

tff(pred_def_16056,type,
    v29840: state_type > $o ).

tff(pred_def_16057,type,
    v30150: state_type > $o ).

tff(pred_def_16058,type,
    v30148: state_type > $o ).

tff(pred_def_16059,type,
    v30146: state_type > $o ).

tff(pred_def_16060,type,
    v30144: state_type > $o ).

tff(pred_def_16061,type,
    v30142: state_type > $o ).

tff(pred_def_16062,type,
    v30160: state_type > $o ).

tff(pred_def_16063,type,
    v30158: state_type > $o ).

tff(pred_def_16064,type,
    v30156: state_type > $o ).

tff(pred_def_16065,type,
    v30154: state_type > $o ).

tff(pred_def_16066,type,
    v30152: state_type > $o ).

tff(pred_def_16067,type,
    v30164: ( state_type * $int ) > $o ).

tff(pred_def_16068,type,
    v30162: ( state_type * $int ) > $o ).

tff(pred_def_16069,type,
    v30174: state_type > $o ).

tff(pred_def_16070,type,
    v30172: state_type > $o ).

tff(pred_def_16071,type,
    v30180: state_type > $o ).

tff(pred_def_16072,type,
    v30178: state_type > $o ).

tff(pred_def_16073,type,
    v30204: ( state_type * $int ) > $o ).

tff(pred_def_16074,type,
    v30202: ( state_type * $int ) > $o ).

tff(pred_def_16075,type,
    v30205: ( state_type * $int ) > $o ).

tff(pred_def_16076,type,
    v30200: ( state_type * $int ) > $o ).

tff(pred_def_16077,type,
    v30198: ( state_type * $int ) > $o ).

tff(pred_def_16078,type,
    v30196: ( state_type * $int ) > $o ).

tff(pred_def_16079,type,
    v30194: state_type > $o ).

tff(pred_def_16080,type,
    v30192: state_type > $o ).

tff(pred_def_16081,type,
    v30209: state_type > $o ).

tff(pred_def_16082,type,
    v30207: state_type > $o ).

tff(pred_def_16083,type,
    v30213: state_type > $o ).

tff(pred_def_16084,type,
    v30211: state_type > $o ).

tff(pred_def_16085,type,
    v30216: state_type > $o ).

tff(pred_def_16086,type,
    v30215: state_type > $o ).

tff(pred_def_16087,type,
    v30190: state_type > $o ).

tff(pred_def_16088,type,
    v30188: state_type > $o ).

tff(pred_def_16089,type,
    v30186: state_type > $o ).

tff(pred_def_16090,type,
    v30184: state_type > $o ).

tff(pred_def_16091,type,
    v30182: state_type > $o ).

tff(pred_def_16092,type,
    v30220: state_type > $o ).

tff(pred_def_16093,type,
    v30218: state_type > $o ).

tff(pred_def_16094,type,
    v30176: state_type > $o ).

tff(pred_def_16095,type,
    v30226: state_type > $o ).

tff(pred_def_16096,type,
    v30228: state_type > $o ).

tff(pred_def_16097,type,
    v30224: state_type > $o ).

tff(pred_def_16098,type,
    v30223: state_type > $o ).

tff(pred_def_16099,type,
    v30234: state_type > $o ).

tff(pred_def_16100,type,
    v30235: state_type > $o ).

tff(pred_def_16101,type,
    v30231: state_type > $o ).

tff(pred_def_16102,type,
    v30233: state_type > $o ).

tff(pred_def_16103,type,
    v30241: state_type > $o ).

tff(pred_def_16104,type,
    v30239: state_type > $o ).

tff(pred_def_16105,type,
    v30243: state_type > $o ).

tff(pred_def_16106,type,
    v30170: state_type > $o ).

tff(pred_def_16107,type,
    v30168: state_type > $o ).

tff(pred_def_16108,type,
    v30166: state_type > $o ).

tff(pred_def_16109,type,
    v30250: state_type > $o ).

tff(pred_def_16110,type,
    v30248: state_type > $o ).

tff(pred_def_16111,type,
    v30247: state_type > $o ).

tff(pred_def_16112,type,
    v30246: state_type > $o ).

tff(pred_def_16113,type,
    v30258: state_type > $o ).

tff(pred_def_16114,type,
    v30259: state_type > $o ).

tff(pred_def_16115,type,
    v30257: state_type > $o ).

tff(pred_def_16116,type,
    v30254: ( state_type * $int ) > $o ).

tff(pred_def_16117,type,
    v30256: ( state_type * $int ) > $o ).

tff(pred_def_16118,type,
    v30140: ( state_type * $int ) > $o ).

tff(pred_def_16119,type,
    v30138: ( state_type * $int ) > $o ).

tff(pred_def_16120,type,
    v30136: ( state_type * $int ) > $o ).

tff(pred_def_16121,type,
    v30134: ( state_type * $int ) > $o ).

tff(pred_def_16122,type,
    v30132: ( state_type * $int ) > $o ).

tff(pred_def_16123,type,
    v30281: state_type > $o ).

tff(pred_def_16124,type,
    v30279: state_type > $o ).

tff(pred_def_16125,type,
    v30285: state_type > $o ).

tff(pred_def_16126,type,
    v30283: state_type > $o ).

tff(pred_def_16127,type,
    v30289: state_type > $o ).

tff(pred_def_16128,type,
    v30287: state_type > $o ).

tff(pred_def_16129,type,
    v30292: state_type > $o ).

tff(pred_def_16130,type,
    v30291: state_type > $o ).

tff(pred_def_16131,type,
    v30277: state_type > $o ).

tff(pred_def_16132,type,
    v30275: state_type > $o ).

tff(pred_def_16133,type,
    v30273: state_type > $o ).

tff(pred_def_16134,type,
    v30271: state_type > $o ).

tff(pred_def_16135,type,
    v30269: state_type > $o ).

tff(pred_def_16136,type,
    v30267: state_type > $o ).

tff(pred_def_16137,type,
    v30265: state_type > $o ).

tff(pred_def_16138,type,
    v30263: state_type > $o ).

tff(pred_def_16139,type,
    v30312: state_type > $o ).

tff(pred_def_16140,type,
    v30310: state_type > $o ).

tff(pred_def_16141,type,
    v30308: state_type > $o ).

tff(pred_def_16142,type,
    v30306: state_type > $o ).

tff(pred_def_16143,type,
    v30304: state_type > $o ).

tff(pred_def_16144,type,
    v30322: state_type > $o ).

tff(pred_def_16145,type,
    v30320: state_type > $o ).

tff(pred_def_16146,type,
    v30318: state_type > $o ).

tff(pred_def_16147,type,
    v30316: state_type > $o ).

tff(pred_def_16148,type,
    v30314: state_type > $o ).

tff(pred_def_16149,type,
    v30326: ( state_type * $int ) > $o ).

tff(pred_def_16150,type,
    v30324: ( state_type * $int ) > $o ).

tff(pred_def_16151,type,
    v30336: state_type > $o ).

tff(pred_def_16152,type,
    v30334: state_type > $o ).

tff(pred_def_16153,type,
    v30342: state_type > $o ).

tff(pred_def_16154,type,
    v30340: state_type > $o ).

tff(pred_def_16155,type,
    v30356: state_type > $o ).

tff(pred_def_16156,type,
    v30354: state_type > $o ).

tff(pred_def_16157,type,
    v30360: state_type > $o ).

tff(pred_def_16158,type,
    v30358: state_type > $o ).

tff(pred_def_16159,type,
    v30364: state_type > $o ).

tff(pred_def_16160,type,
    v30362: state_type > $o ).

tff(pred_def_16161,type,
    v30367: state_type > $o ).

tff(pred_def_16162,type,
    v30366: state_type > $o ).

tff(pred_def_16163,type,
    v30352: state_type > $o ).

tff(pred_def_16164,type,
    v30350: state_type > $o ).

tff(pred_def_16165,type,
    v30348: state_type > $o ).

tff(pred_def_16166,type,
    v30346: state_type > $o ).

tff(pred_def_16167,type,
    v30344: state_type > $o ).

tff(pred_def_16168,type,
    v30371: state_type > $o ).

tff(pred_def_16169,type,
    v30369: state_type > $o ).

tff(pred_def_16170,type,
    v30338: state_type > $o ).

tff(pred_def_16171,type,
    v30377: state_type > $o ).

tff(pred_def_16172,type,
    v30379: state_type > $o ).

tff(pred_def_16173,type,
    v30375: state_type > $o ).

tff(pred_def_16174,type,
    v30374: state_type > $o ).

tff(pred_def_16175,type,
    v30385: state_type > $o ).

tff(pred_def_16176,type,
    v30386: state_type > $o ).

tff(pred_def_16177,type,
    v30382: state_type > $o ).

tff(pred_def_16178,type,
    v30384: state_type > $o ).

tff(pred_def_16179,type,
    v30392: state_type > $o ).

tff(pred_def_16180,type,
    v30390: state_type > $o ).

tff(pred_def_16181,type,
    v30394: state_type > $o ).

tff(pred_def_16182,type,
    v30332: state_type > $o ).

tff(pred_def_16183,type,
    v30330: state_type > $o ).

tff(pred_def_16184,type,
    v30328: state_type > $o ).

tff(pred_def_16185,type,
    v30401: state_type > $o ).

tff(pred_def_16186,type,
    v30399: state_type > $o ).

tff(pred_def_16187,type,
    v30398: state_type > $o ).

tff(pred_def_16188,type,
    v30397: state_type > $o ).

tff(pred_def_16189,type,
    v30409: state_type > $o ).

tff(pred_def_16190,type,
    v30410: state_type > $o ).

tff(pred_def_16191,type,
    v30408: state_type > $o ).

tff(pred_def_16192,type,
    v30405: ( state_type * $int ) > $o ).

tff(pred_def_16193,type,
    v30407: ( state_type * $int ) > $o ).

tff(pred_def_16194,type,
    v30302: ( state_type * $int ) > $o ).

tff(pred_def_16195,type,
    v30300: ( state_type * $int ) > $o ).

tff(pred_def_16196,type,
    v30298: ( state_type * $int ) > $o ).

tff(pred_def_16197,type,
    v30296: ( state_type * $int ) > $o ).

tff(pred_def_16198,type,
    v30294: ( state_type * $int ) > $o ).

tff(pred_def_16199,type,
    v30432: state_type > $o ).

tff(pred_def_16200,type,
    v30430: state_type > $o ).

tff(pred_def_16201,type,
    v30436: state_type > $o ).

tff(pred_def_16202,type,
    v30434: state_type > $o ).

tff(pred_def_16203,type,
    v30440: state_type > $o ).

tff(pred_def_16204,type,
    v30438: state_type > $o ).

tff(pred_def_16205,type,
    v30443: state_type > $o ).

tff(pred_def_16206,type,
    v30442: state_type > $o ).

tff(pred_def_16207,type,
    v30428: state_type > $o ).

tff(pred_def_16208,type,
    v30426: state_type > $o ).

tff(pred_def_16209,type,
    v30424: state_type > $o ).

tff(pred_def_16210,type,
    v30422: state_type > $o ).

tff(pred_def_16211,type,
    v30420: state_type > $o ).

tff(pred_def_16212,type,
    v30418: state_type > $o ).

tff(pred_def_16213,type,
    v30416: state_type > $o ).

tff(pred_def_16214,type,
    v30414: state_type > $o ).

tff(pred_def_16215,type,
    v30463: state_type > $o ).

tff(pred_def_16216,type,
    v30461: state_type > $o ).

tff(pred_def_16217,type,
    v30459: state_type > $o ).

tff(pred_def_16218,type,
    v30457: state_type > $o ).

tff(pred_def_16219,type,
    v30455: state_type > $o ).

tff(pred_def_16220,type,
    v30473: state_type > $o ).

tff(pred_def_16221,type,
    v30471: state_type > $o ).

tff(pred_def_16222,type,
    v30469: state_type > $o ).

tff(pred_def_16223,type,
    v30467: state_type > $o ).

tff(pred_def_16224,type,
    v30465: state_type > $o ).

tff(pred_def_16225,type,
    v30477: ( state_type * $int ) > $o ).

tff(pred_def_16226,type,
    v30475: ( state_type * $int ) > $o ).

tff(pred_def_16227,type,
    v30487: state_type > $o ).

tff(pred_def_16228,type,
    v30485: state_type > $o ).

tff(pred_def_16229,type,
    v30493: state_type > $o ).

tff(pred_def_16230,type,
    v30491: state_type > $o ).

tff(pred_def_16231,type,
    v30507: state_type > $o ).

tff(pred_def_16232,type,
    v30505: state_type > $o ).

tff(pred_def_16233,type,
    v30511: state_type > $o ).

tff(pred_def_16234,type,
    v30509: state_type > $o ).

tff(pred_def_16235,type,
    v30515: state_type > $o ).

tff(pred_def_16236,type,
    v30513: state_type > $o ).

tff(pred_def_16237,type,
    v30518: state_type > $o ).

tff(pred_def_16238,type,
    v30517: state_type > $o ).

tff(pred_def_16239,type,
    v30503: state_type > $o ).

tff(pred_def_16240,type,
    v30501: state_type > $o ).

tff(pred_def_16241,type,
    v30499: state_type > $o ).

tff(pred_def_16242,type,
    v30497: state_type > $o ).

tff(pred_def_16243,type,
    v30495: state_type > $o ).

tff(pred_def_16244,type,
    v30522: state_type > $o ).

tff(pred_def_16245,type,
    v30520: state_type > $o ).

tff(pred_def_16246,type,
    v30489: state_type > $o ).

tff(pred_def_16247,type,
    v30528: state_type > $o ).

tff(pred_def_16248,type,
    v30530: state_type > $o ).

tff(pred_def_16249,type,
    v30526: state_type > $o ).

tff(pred_def_16250,type,
    v30525: state_type > $o ).

tff(pred_def_16251,type,
    v30536: state_type > $o ).

tff(pred_def_16252,type,
    v30537: state_type > $o ).

tff(pred_def_16253,type,
    v30533: state_type > $o ).

tff(pred_def_16254,type,
    v30535: state_type > $o ).

tff(pred_def_16255,type,
    v30543: state_type > $o ).

tff(pred_def_16256,type,
    v30541: state_type > $o ).

tff(pred_def_16257,type,
    v30545: state_type > $o ).

tff(pred_def_16258,type,
    v30483: state_type > $o ).

tff(pred_def_16259,type,
    v30481: state_type > $o ).

tff(pred_def_16260,type,
    v30479: state_type > $o ).

tff(pred_def_16261,type,
    v30552: state_type > $o ).

tff(pred_def_16262,type,
    v30550: state_type > $o ).

tff(pred_def_16263,type,
    v30549: state_type > $o ).

tff(pred_def_16264,type,
    v30548: state_type > $o ).

tff(pred_def_16265,type,
    v30560: state_type > $o ).

tff(pred_def_16266,type,
    v30561: state_type > $o ).

tff(pred_def_16267,type,
    v30559: state_type > $o ).

tff(pred_def_16268,type,
    v30556: ( state_type * $int ) > $o ).

tff(pred_def_16269,type,
    v30558: ( state_type * $int ) > $o ).

tff(pred_def_16270,type,
    v30453: ( state_type * $int ) > $o ).

tff(pred_def_16271,type,
    v30451: ( state_type * $int ) > $o ).

tff(pred_def_16272,type,
    v30449: ( state_type * $int ) > $o ).

tff(pred_def_16273,type,
    v30447: ( state_type * $int ) > $o ).

tff(pred_def_16274,type,
    v30445: ( state_type * $int ) > $o ).

tff(pred_def_16275,type,
    v30583: state_type > $o ).

tff(pred_def_16276,type,
    v30581: state_type > $o ).

tff(pred_def_16277,type,
    v30587: state_type > $o ).

tff(pred_def_16278,type,
    v30585: state_type > $o ).

tff(pred_def_16279,type,
    v30591: state_type > $o ).

tff(pred_def_16280,type,
    v30589: state_type > $o ).

tff(pred_def_16281,type,
    v30594: state_type > $o ).

tff(pred_def_16282,type,
    v30593: state_type > $o ).

tff(pred_def_16283,type,
    v30579: state_type > $o ).

tff(pred_def_16284,type,
    v30577: state_type > $o ).

tff(pred_def_16285,type,
    v30575: state_type > $o ).

tff(pred_def_16286,type,
    v30573: state_type > $o ).

tff(pred_def_16287,type,
    v30571: state_type > $o ).

tff(pred_def_16288,type,
    v30569: state_type > $o ).

tff(pred_def_16289,type,
    v30567: state_type > $o ).

tff(pred_def_16290,type,
    v30565: state_type > $o ).

tff(pred_def_16291,type,
    v30614: state_type > $o ).

tff(pred_def_16292,type,
    v30612: state_type > $o ).

tff(pred_def_16293,type,
    v30610: state_type > $o ).

tff(pred_def_16294,type,
    v30608: state_type > $o ).

tff(pred_def_16295,type,
    v30606: state_type > $o ).

tff(pred_def_16296,type,
    v30624: state_type > $o ).

tff(pred_def_16297,type,
    v30622: state_type > $o ).

tff(pred_def_16298,type,
    v30620: state_type > $o ).

tff(pred_def_16299,type,
    v30618: state_type > $o ).

tff(pred_def_16300,type,
    v30616: state_type > $o ).

tff(pred_def_16301,type,
    v30628: ( state_type * $int ) > $o ).

tff(pred_def_16302,type,
    v30626: ( state_type * $int ) > $o ).

tff(pred_def_16303,type,
    v30638: state_type > $o ).

tff(pred_def_16304,type,
    v30636: state_type > $o ).

tff(pred_def_16305,type,
    v30644: state_type > $o ).

tff(pred_def_16306,type,
    v30642: state_type > $o ).

tff(pred_def_16307,type,
    v30658: state_type > $o ).

tff(pred_def_16308,type,
    v30656: state_type > $o ).

tff(pred_def_16309,type,
    v30662: state_type > $o ).

tff(pred_def_16310,type,
    v30660: state_type > $o ).

tff(pred_def_16311,type,
    v30666: state_type > $o ).

tff(pred_def_16312,type,
    v30664: state_type > $o ).

tff(pred_def_16313,type,
    v30669: state_type > $o ).

tff(pred_def_16314,type,
    v30668: state_type > $o ).

tff(pred_def_16315,type,
    v30654: state_type > $o ).

tff(pred_def_16316,type,
    v30652: state_type > $o ).

tff(pred_def_16317,type,
    v30650: state_type > $o ).

tff(pred_def_16318,type,
    v30648: state_type > $o ).

tff(pred_def_16319,type,
    v30646: state_type > $o ).

tff(pred_def_16320,type,
    v30673: state_type > $o ).

tff(pred_def_16321,type,
    v30671: state_type > $o ).

tff(pred_def_16322,type,
    v30640: state_type > $o ).

tff(pred_def_16323,type,
    v30679: state_type > $o ).

tff(pred_def_16324,type,
    v30681: state_type > $o ).

tff(pred_def_16325,type,
    v30677: state_type > $o ).

tff(pred_def_16326,type,
    v30676: state_type > $o ).

tff(pred_def_16327,type,
    v30687: state_type > $o ).

tff(pred_def_16328,type,
    v30688: state_type > $o ).

tff(pred_def_16329,type,
    v30684: state_type > $o ).

tff(pred_def_16330,type,
    v30686: state_type > $o ).

tff(pred_def_16331,type,
    v30694: state_type > $o ).

tff(pred_def_16332,type,
    v30692: state_type > $o ).

tff(pred_def_16333,type,
    v30696: state_type > $o ).

tff(pred_def_16334,type,
    v30634: state_type > $o ).

tff(pred_def_16335,type,
    v30632: state_type > $o ).

tff(pred_def_16336,type,
    v30630: state_type > $o ).

tff(pred_def_16337,type,
    v30703: state_type > $o ).

tff(pred_def_16338,type,
    v30701: state_type > $o ).

tff(pred_def_16339,type,
    v30700: state_type > $o ).

tff(pred_def_16340,type,
    v30699: state_type > $o ).

tff(pred_def_16341,type,
    v30711: state_type > $o ).

tff(pred_def_16342,type,
    v30712: state_type > $o ).

tff(pred_def_16343,type,
    v30710: state_type > $o ).

tff(pred_def_16344,type,
    v30707: ( state_type * $int ) > $o ).

tff(pred_def_16345,type,
    v30709: ( state_type * $int ) > $o ).

tff(pred_def_16346,type,
    v30604: ( state_type * $int ) > $o ).

tff(pred_def_16347,type,
    v30602: ( state_type * $int ) > $o ).

tff(pred_def_16348,type,
    v30600: ( state_type * $int ) > $o ).

tff(pred_def_16349,type,
    v30598: ( state_type * $int ) > $o ).

tff(pred_def_16350,type,
    v30596: ( state_type * $int ) > $o ).

tff(pred_def_16351,type,
    v30734: state_type > $o ).

tff(pred_def_16352,type,
    v30732: state_type > $o ).

tff(pred_def_16353,type,
    v30738: state_type > $o ).

tff(pred_def_16354,type,
    v30736: state_type > $o ).

tff(pred_def_16355,type,
    v30742: state_type > $o ).

tff(pred_def_16356,type,
    v30740: state_type > $o ).

tff(pred_def_16357,type,
    v30745: state_type > $o ).

tff(pred_def_16358,type,
    v30744: state_type > $o ).

tff(pred_def_16359,type,
    v30730: state_type > $o ).

tff(pred_def_16360,type,
    v30728: state_type > $o ).

tff(pred_def_16361,type,
    v30726: state_type > $o ).

tff(pred_def_16362,type,
    v30724: state_type > $o ).

tff(pred_def_16363,type,
    v30722: state_type > $o ).

tff(pred_def_16364,type,
    v30720: state_type > $o ).

tff(pred_def_16365,type,
    v30718: state_type > $o ).

tff(pred_def_16366,type,
    v30716: state_type > $o ).

tff(pred_def_16367,type,
    v30765: state_type > $o ).

tff(pred_def_16368,type,
    v30763: state_type > $o ).

tff(pred_def_16369,type,
    v30761: state_type > $o ).

tff(pred_def_16370,type,
    v30759: state_type > $o ).

tff(pred_def_16371,type,
    v30757: state_type > $o ).

tff(pred_def_16372,type,
    v30775: state_type > $o ).

tff(pred_def_16373,type,
    v30773: state_type > $o ).

tff(pred_def_16374,type,
    v30771: state_type > $o ).

tff(pred_def_16375,type,
    v30769: state_type > $o ).

tff(pred_def_16376,type,
    v30767: state_type > $o ).

tff(pred_def_16377,type,
    v30779: ( state_type * $int ) > $o ).

tff(pred_def_16378,type,
    v30777: ( state_type * $int ) > $o ).

tff(pred_def_16379,type,
    v30789: state_type > $o ).

tff(pred_def_16380,type,
    v30787: state_type > $o ).

tff(pred_def_16381,type,
    v30795: state_type > $o ).

tff(pred_def_16382,type,
    v30793: state_type > $o ).

tff(pred_def_16383,type,
    v30808: state_type > $o ).

tff(pred_def_16384,type,
    v30806: state_type > $o ).

tff(pred_def_16385,type,
    v30812: state_type > $o ).

tff(pred_def_16386,type,
    v30810: state_type > $o ).

tff(pred_def_16387,type,
    v30816: state_type > $o ).

tff(pred_def_16388,type,
    v30814: state_type > $o ).

tff(pred_def_16389,type,
    v30819: state_type > $o ).

tff(pred_def_16390,type,
    v30818: state_type > $o ).

tff(pred_def_16391,type,
    v30804: state_type > $o ).

tff(pred_def_16392,type,
    v30802: state_type > $o ).

tff(pred_def_16393,type,
    v30799: state_type > $o ).

tff(pred_def_16394,type,
    v30797: state_type > $o ).

tff(pred_def_16395,type,
    v30823: state_type > $o ).

tff(pred_def_16396,type,
    v30821: state_type > $o ).

tff(pred_def_16397,type,
    v30791: state_type > $o ).

tff(pred_def_16398,type,
    v30829: state_type > $o ).

tff(pred_def_16399,type,
    v30831: state_type > $o ).

tff(pred_def_16400,type,
    v30827: state_type > $o ).

tff(pred_def_16401,type,
    v30826: state_type > $o ).

tff(pred_def_16402,type,
    v30837: state_type > $o ).

tff(pred_def_16403,type,
    v30838: state_type > $o ).

tff(pred_def_16404,type,
    v30834: state_type > $o ).

tff(pred_def_16405,type,
    v30836: state_type > $o ).

tff(pred_def_16406,type,
    v30844: state_type > $o ).

tff(pred_def_16407,type,
    v30842: state_type > $o ).

tff(pred_def_16408,type,
    v30846: state_type > $o ).

tff(pred_def_16409,type,
    v30785: state_type > $o ).

tff(pred_def_16410,type,
    v30783: state_type > $o ).

tff(pred_def_16411,type,
    v30781: state_type > $o ).

tff(pred_def_16412,type,
    v30853: state_type > $o ).

tff(pred_def_16413,type,
    v30851: state_type > $o ).

tff(pred_def_16414,type,
    v30850: state_type > $o ).

tff(pred_def_16415,type,
    v30849: state_type > $o ).

tff(pred_def_16416,type,
    v30861: state_type > $o ).

tff(pred_def_16417,type,
    v30862: state_type > $o ).

tff(pred_def_16418,type,
    v30860: state_type > $o ).

tff(pred_def_16419,type,
    v30857: ( state_type * $int ) > $o ).

tff(pred_def_16420,type,
    v30859: ( state_type * $int ) > $o ).

tff(pred_def_16421,type,
    v30755: ( state_type * $int ) > $o ).

tff(pred_def_16422,type,
    v30753: ( state_type * $int ) > $o ).

tff(pred_def_16423,type,
    v30751: ( state_type * $int ) > $o ).

tff(pred_def_16424,type,
    v30749: ( state_type * $int ) > $o ).

tff(pred_def_16425,type,
    v30747: ( state_type * $int ) > $o ).

tff(pred_def_16426,type,
    v30874: state_type > $o ).

tff(pred_def_16427,type,
    v30872: state_type > $o ).

tff(pred_def_16428,type,
    v30870: state_type > $o ).

tff(pred_def_16429,type,
    v30868: state_type > $o ).

tff(pred_def_16430,type,
    v30866: state_type > $o ).

tff(pred_def_16431,type,
    v30882: state_type > $o ).

tff(pred_def_16432,type,
    v30881: ( state_type * $int ) > $o ).

tff(pred_def_16433,type,
    v30880: ( state_type * $int ) > $o ).

tff(pred_def_16434,type,
    v30885: state_type > $o ).

tff(pred_def_16435,type,
    v30884: ( state_type * $int ) > $o ).

tff(pred_def_16436,type,
    v30883: ( state_type * $int ) > $o ).

tff(pred_def_16437,type,
    v30879: ( state_type * $int ) > $o ).

tff(pred_def_16438,type,
    v30888: state_type > $o ).

tff(pred_def_16439,type,
    v30887: ( state_type * $int ) > $o ).

tff(pred_def_16440,type,
    v30886: ( state_type * $int ) > $o ).

tff(pred_def_16441,type,
    v30878: ( state_type * $int ) > $o ).

tff(pred_def_16442,type,
    v30891: state_type > $o ).

tff(pred_def_16443,type,
    v30890: ( state_type * $int ) > $o ).

tff(pred_def_16444,type,
    v30889: ( state_type * $int ) > $o ).

tff(pred_def_16445,type,
    v30877: ( state_type * $int ) > $o ).

tff(pred_def_16446,type,
    v30894: state_type > $o ).

tff(pred_def_16447,type,
    v30893: ( state_type * $int ) > $o ).

tff(pred_def_16448,type,
    v30892: ( state_type * $int ) > $o ).

tff(pred_def_16449,type,
    v30876: ( state_type * $int ) > $o ).

tff(pred_def_16450,type,
    v30897: state_type > $o ).

tff(pred_def_16451,type,
    v30896: ( state_type * $int ) > $o ).

tff(pred_def_16452,type,
    v30895: ( state_type * $int ) > $o ).

tff(pred_def_16453,type,
    v29659: ( state_type * $int ) > $o ).

tff(pred_def_16454,type,
    v29657: ( state_type * $int ) > $o ).

tff(pred_def_16455,type,
    v29655: ( state_type * $int ) > $o ).

tff(pred_def_16456,type,
    v29653: ( state_type * $int ) > $o ).

tff(pred_def_16457,type,
    v29651: ( state_type * $int ) > $o ).

tff(pred_def_16458,type,
    v29645: state_type > $o ).

tff(pred_def_16459,type,
    v29643: state_type > $o ).

tff(pred_def_16460,type,
    v29641: state_type > $o ).

tff(pred_def_16461,type,
    v9083: ( state_type * $int ) > $o ).

tff(pred_def_16462,type,
    v9081: ( state_type * $int ) > $o ).

tff(pred_def_16463,type,
    b11111111111110: $int > $o ).

tff(pred_def_16464,type,
    v30928: state_type > $o ).

tff(pred_def_16465,type,
    b11111111111101: $int > $o ).

tff(pred_def_16466,type,
    v30929: state_type > $o ).

tff(pred_def_16467,type,
    v30927: state_type > $o ).

tff(pred_def_16468,type,
    b11111111111011: $int > $o ).

tff(pred_def_16469,type,
    v30930: state_type > $o ).

tff(pred_def_16470,type,
    v30926: state_type > $o ).

tff(pred_def_16471,type,
    b11111111110111: $int > $o ).

tff(pred_def_16472,type,
    v30931: state_type > $o ).

tff(pred_def_16473,type,
    v30925: state_type > $o ).

tff(pred_def_16474,type,
    b11111111101111: $int > $o ).

tff(pred_def_16475,type,
    v30932: state_type > $o ).

tff(pred_def_16476,type,
    v30924: state_type > $o ).

tff(pred_def_16477,type,
    b11111111011111: $int > $o ).

tff(pred_def_16478,type,
    v30933: state_type > $o ).

tff(pred_def_16479,type,
    v30923: state_type > $o ).

tff(pred_def_16480,type,
    b11111110111111: $int > $o ).

tff(pred_def_16481,type,
    v30934: state_type > $o ).

tff(pred_def_16482,type,
    v30922: state_type > $o ).

tff(pred_def_16483,type,
    b11111101111111: $int > $o ).

tff(pred_def_16484,type,
    v30935: state_type > $o ).

tff(pred_def_16485,type,
    v30921: state_type > $o ).

tff(pred_def_16486,type,
    b11111011111111: $int > $o ).

tff(pred_def_16487,type,
    v30936: state_type > $o ).

tff(pred_def_16488,type,
    v30920: state_type > $o ).

tff(pred_def_16489,type,
    b11110111111111: $int > $o ).

tff(pred_def_16490,type,
    v30937: state_type > $o ).

tff(pred_def_16491,type,
    v30919: state_type > $o ).

tff(pred_def_16492,type,
    b11101111111111: $int > $o ).

tff(pred_def_16493,type,
    v30938: state_type > $o ).

tff(pred_def_16494,type,
    v30918: state_type > $o ).

tff(pred_def_16495,type,
    b11011111111111: $int > $o ).

tff(pred_def_16496,type,
    v30939: state_type > $o ).

tff(pred_def_16497,type,
    v30917: state_type > $o ).

tff(pred_def_16498,type,
    b10111111111111: $int > $o ).

tff(pred_def_16499,type,
    v30940: state_type > $o ).

tff(pred_def_16500,type,
    v30916: state_type > $o ).

tff(pred_def_16501,type,
    b01111111111111: $int > $o ).

tff(pred_def_16502,type,
    v30941: state_type > $o ).

tff(pred_def_16503,type,
    v30900: state_type > $o ).

tff(pred_def_16504,type,
    v30951: state_type > $o ).

tff(pred_def_16505,type,
    v30949: state_type > $o ).

tff(pred_def_16506,type,
    v30955: state_type > $o ).

tff(pred_def_16507,type,
    v30953: state_type > $o ).

tff(pred_def_16508,type,
    v30965: state_type > $o ).

tff(pred_def_16509,type,
    v30975: state_type > $o ).

tff(pred_def_16510,type,
    v30973: state_type > $o ).

tff(pred_def_16511,type,
    v30979: state_type > $o ).

tff(pred_def_16512,type,
    v30977: state_type > $o ).

tff(pred_def_16513,type,
    v30999: state_type > $o ).

tff(pred_def_16514,type,
    v30997: state_type > $o ).

tff(pred_def_16515,type,
    v31003: state_type > $o ).

tff(pred_def_16516,type,
    v31001: state_type > $o ).

tff(pred_def_16517,type,
    v31017: state_type > $o ).

tff(pred_def_16518,type,
    v31015: state_type > $o ).

tff(pred_def_16519,type,
    v31014: state_type > $o ).

tff(pred_def_16520,type,
    v31013: ( state_type * $int ) > $o ).

tff(pred_def_16521,type,
    v31011: ( state_type * $int ) > $o ).

tff(pred_def_16522,type,
    v31020: ( state_type * $int ) > $o ).

tff(pred_def_16523,type,
    v31021: ( state_type * $int ) > $o ).

tff(pred_def_16524,type,
    v31009: ( state_type * $int ) > $o ).

tff(pred_def_16525,type,
    b0100001011000: $int > $o ).

tff(pred_def_16526,type,
    v31028: state_type > $o ).

tff(pred_def_16527,type,
    v31025: state_type > $o ).

tff(pred_def_16528,type,
    v31023: state_type > $o ).

tff(pred_def_16529,type,
    v31032: state_type > $o ).

tff(pred_def_16530,type,
    v31031: ( state_type * $int ) > $o ).

tff(pred_def_16531,type,
    v31030: ( state_type * $int ) > $o ).

tff(pred_def_16532,type,
    v31036: state_type > $o ).

tff(pred_def_16533,type,
    v31035: ( state_type * $int ) > $o ).

tff(pred_def_16534,type,
    v31034: ( state_type * $int ) > $o ).

tff(pred_def_16535,type,
    v30993: ( state_type * $int ) > $o ).

tff(pred_def_16536,type,
    v31033: ( state_type * $int ) > $o ).

tff(pred_def_16537,type,
    v31029: ( state_type * $int ) > $o ).

tff(pred_def_16538,type,
    v31007: ( state_type * $int ) > $o ).

tff(pred_def_16539,type,
    v31005: ( state_type * $int ) > $o ).

tff(pred_def_16540,type,
    v31040: state_type > $o ).

tff(pred_def_16541,type,
    v31038: state_type > $o ).

tff(pred_def_16542,type,
    v31047: state_type > $o ).

tff(pred_def_16543,type,
    v31045: state_type > $o ).

tff(pred_def_16544,type,
    v31044: state_type > $o ).

tff(pred_def_16545,type,
    v31043: state_type > $o ).

tff(pred_def_16546,type,
    v31055: state_type > $o ).

tff(pred_def_16547,type,
    v31056: state_type > $o ).

tff(pred_def_16548,type,
    v31054: state_type > $o ).

tff(pred_def_16549,type,
    v31051: ( state_type * $int ) > $o ).

tff(pred_def_16550,type,
    v31053: ( state_type * $int ) > $o ).

tff(pred_def_16551,type,
    v31042: ( state_type * $int ) > $o ).

tff(pred_def_16552,type,
    v30995: ( state_type * $int ) > $o ).

tff(pred_def_16553,type,
    v31068: state_type > $o ).

tff(pred_def_16554,type,
    v31066: state_type > $o ).

tff(pred_def_16555,type,
    v31065: state_type > $o ).

tff(pred_def_16556,type,
    v31064: ( state_type * $int ) > $o ).

tff(pred_def_16557,type,
    v31060: ( state_type * $int ) > $o ).

tff(pred_def_16558,type,
    v30991: ( state_type * $int ) > $o ).

tff(pred_def_16559,type,
    b0000000000000000: $int > $o ).

tff(pred_def_16560,type,
    v30967: ( state_type * $int ) > $o ).

tff(pred_def_16561,type,
    v31074: state_type > $o ).

tff(pred_def_16562,type,
    v31108: state_type > $o ).

tff(pred_def_16563,type,
    v31107: state_type > $o ).

tff(pred_def_16564,type,
    v31106: state_type > $o ).

tff(pred_def_16565,type,
    v31109: state_type > $o ).

tff(pred_def_16566,type,
    v31105: state_type > $o ).

tff(pred_def_16567,type,
    v31104: state_type > $o ).

tff(pred_def_16568,type,
    v31110: state_type > $o ).

tff(pred_def_16569,type,
    v31103: state_type > $o ).

tff(pred_def_16570,type,
    v31102: state_type > $o ).

tff(pred_def_16571,type,
    v31111: state_type > $o ).

tff(pred_def_16572,type,
    v31101: state_type > $o ).

tff(pred_def_16573,type,
    v31100: state_type > $o ).

tff(pred_def_16574,type,
    v31112: state_type > $o ).

tff(pred_def_16575,type,
    v31099: state_type > $o ).

tff(pred_def_16576,type,
    v31098: state_type > $o ).

tff(pred_def_16577,type,
    v31113: state_type > $o ).

tff(pred_def_16578,type,
    v31097: state_type > $o ).

tff(pred_def_16579,type,
    v31096: state_type > $o ).

tff(pred_def_16580,type,
    v31114: state_type > $o ).

tff(pred_def_16581,type,
    v31095: state_type > $o ).

tff(pred_def_16582,type,
    v31094: state_type > $o ).

tff(pred_def_16583,type,
    v31115: state_type > $o ).

tff(pred_def_16584,type,
    v31093: state_type > $o ).

tff(pred_def_16585,type,
    v31092: state_type > $o ).

tff(pred_def_16586,type,
    v31116: state_type > $o ).

tff(pred_def_16587,type,
    v31091: state_type > $o ).

tff(pred_def_16588,type,
    v31090: state_type > $o ).

tff(pred_def_16589,type,
    v31117: state_type > $o ).

tff(pred_def_16590,type,
    v31089: state_type > $o ).

tff(pred_def_16591,type,
    v31088: state_type > $o ).

tff(pred_def_16592,type,
    v31118: state_type > $o ).

tff(pred_def_16593,type,
    v31087: state_type > $o ).

tff(pred_def_16594,type,
    v31086: state_type > $o ).

tff(pred_def_16595,type,
    v31119: state_type > $o ).

tff(pred_def_16596,type,
    v31085: state_type > $o ).

tff(pred_def_16597,type,
    v31084: state_type > $o ).

tff(pred_def_16598,type,
    v31120: state_type > $o ).

tff(pred_def_16599,type,
    v31083: state_type > $o ).

tff(pred_def_16600,type,
    v31082: state_type > $o ).

tff(pred_def_16601,type,
    v31121: state_type > $o ).

tff(pred_def_16602,type,
    v31081: state_type > $o ).

tff(pred_def_16603,type,
    v31080: state_type > $o ).

tff(pred_def_16604,type,
    v31079: state_type > $o ).

tff(pred_def_16605,type,
    v31078: state_type > $o ).

tff(pred_def_16606,type,
    v31123: state_type > $o ).

tff(pred_def_16607,type,
    v31122: state_type > $o ).

tff(pred_def_16608,type,
    v31077: state_type > $o ).

tff(pred_def_16609,type,
    v31126: state_type > $o ).

tff(pred_def_16610,type,
    v31125: state_type > $o ).

tff(pred_def_16611,type,
    v31127: state_type > $o ).

tff(pred_def_16612,type,
    v31124: state_type > $o ).

tff(pred_def_16613,type,
    v31130: state_type > $o ).

tff(pred_def_16614,type,
    v31129: state_type > $o ).

tff(pred_def_16615,type,
    v31131: state_type > $o ).

tff(pred_def_16616,type,
    v31128: state_type > $o ).

tff(pred_def_16617,type,
    v31134: state_type > $o ).

tff(pred_def_16618,type,
    v31133: state_type > $o ).

tff(pred_def_16619,type,
    v31135: state_type > $o ).

tff(pred_def_16620,type,
    v31132: state_type > $o ).

tff(pred_def_16621,type,
    v31138: state_type > $o ).

tff(pred_def_16622,type,
    v31137: state_type > $o ).

tff(pred_def_16623,type,
    v31139: state_type > $o ).

tff(pred_def_16624,type,
    v31136: state_type > $o ).

tff(pred_def_16625,type,
    v31142: state_type > $o ).

tff(pred_def_16626,type,
    v31141: state_type > $o ).

tff(pred_def_16627,type,
    v31143: state_type > $o ).

tff(pred_def_16628,type,
    v31140: state_type > $o ).

tff(pred_def_16629,type,
    v31146: state_type > $o ).

tff(pred_def_16630,type,
    v31145: state_type > $o ).

tff(pred_def_16631,type,
    v31147: state_type > $o ).

tff(pred_def_16632,type,
    v31144: state_type > $o ).

tff(pred_def_16633,type,
    v31150: state_type > $o ).

tff(pred_def_16634,type,
    v31149: state_type > $o ).

tff(pred_def_16635,type,
    v31151: state_type > $o ).

tff(pred_def_16636,type,
    v31148: state_type > $o ).

tff(pred_def_16637,type,
    v31154: state_type > $o ).

tff(pred_def_16638,type,
    v31153: state_type > $o ).

tff(pred_def_16639,type,
    v31155: state_type > $o ).

tff(pred_def_16640,type,
    v31152: state_type > $o ).

tff(pred_def_16641,type,
    v31158: state_type > $o ).

tff(pred_def_16642,type,
    v31157: state_type > $o ).

tff(pred_def_16643,type,
    v31159: state_type > $o ).

tff(pred_def_16644,type,
    v31156: state_type > $o ).

tff(pred_def_16645,type,
    v31162: state_type > $o ).

tff(pred_def_16646,type,
    v31161: state_type > $o ).

tff(pred_def_16647,type,
    v31163: state_type > $o ).

tff(pred_def_16648,type,
    v31160: state_type > $o ).

tff(pred_def_16649,type,
    v31166: state_type > $o ).

tff(pred_def_16650,type,
    v31165: state_type > $o ).

tff(pred_def_16651,type,
    v31167: state_type > $o ).

tff(pred_def_16652,type,
    v31164: state_type > $o ).

tff(pred_def_16653,type,
    v31170: state_type > $o ).

tff(pred_def_16654,type,
    v31169: state_type > $o ).

tff(pred_def_16655,type,
    v31171: state_type > $o ).

tff(pred_def_16656,type,
    v31168: state_type > $o ).

tff(pred_def_16657,type,
    v31174: state_type > $o ).

tff(pred_def_16658,type,
    v31173: state_type > $o ).

tff(pred_def_16659,type,
    v31175: state_type > $o ).

tff(pred_def_16660,type,
    v31172: state_type > $o ).

tff(pred_def_16661,type,
    v31178: state_type > $o ).

tff(pred_def_16662,type,
    v31177: state_type > $o ).

tff(pred_def_16663,type,
    v31179: state_type > $o ).

tff(pred_def_16664,type,
    v31176: state_type > $o ).

tff(pred_def_16665,type,
    v31075: ( state_type * $int ) > $o ).

tff(pred_def_16666,type,
    v31073: ( state_type * $int ) > $o ).

tff(pred_def_16667,type,
    v30987: ( state_type * $int ) > $o ).

tff(pred_def_16668,type,
    v30985: ( state_type * $int ) > $o ).

tff(pred_def_16669,type,
    v30983: ( state_type * $int ) > $o ).

tff(pred_def_16670,type,
    v30981: ( state_type * $int ) > $o ).

tff(pred_def_16671,type,
    v31183: state_type > $o ).

tff(pred_def_16672,type,
    v31181: state_type > $o ).

tff(pred_def_16673,type,
    v31190: state_type > $o ).

tff(pred_def_16674,type,
    v31188: state_type > $o ).

tff(pred_def_16675,type,
    v31187: state_type > $o ).

tff(pred_def_16676,type,
    v31186: state_type > $o ).

tff(pred_def_16677,type,
    v31198: state_type > $o ).

tff(pred_def_16678,type,
    v31199: state_type > $o ).

tff(pred_def_16679,type,
    v31197: state_type > $o ).

tff(pred_def_16680,type,
    v31194: ( state_type * $int ) > $o ).

tff(pred_def_16681,type,
    v31196: ( state_type * $int ) > $o ).

tff(pred_def_16682,type,
    v30971: ( state_type * $int ) > $o ).

tff(pred_def_16683,type,
    v30969: ( state_type * $int ) > $o ).

tff(pred_def_16684,type,
    v31213: state_type > $o ).

tff(pred_def_16685,type,
    v31211: state_type > $o ).

tff(pred_def_16686,type,
    v31217: state_type > $o ).

tff(pred_def_16687,type,
    v31215: state_type > $o ).

tff(pred_def_16688,type,
    v31227: ( state_type * $int ) > $o ).

tff(pred_def_16689,type,
    v31228: ( state_type * $int ) > $o ).

tff(pred_def_16690,type,
    v31225: ( state_type * $int ) > $o ).

tff(pred_def_16691,type,
    v31223: ( state_type * $int ) > $o ).

tff(pred_def_16692,type,
    b0100001101000: $int > $o ).

tff(pred_def_16693,type,
    v31235: state_type > $o ).

tff(pred_def_16694,type,
    v31232: state_type > $o ).

tff(pred_def_16695,type,
    v31230: state_type > $o ).

tff(pred_def_16696,type,
    v31239: state_type > $o ).

tff(pred_def_16697,type,
    v31238: ( state_type * $int ) > $o ).

tff(pred_def_16698,type,
    v31237: ( state_type * $int ) > $o ).

tff(pred_def_16699,type,
    v31243: state_type > $o ).

tff(pred_def_16700,type,
    v31242: ( state_type * $int ) > $o ).

tff(pred_def_16701,type,
    v31241: ( state_type * $int ) > $o ).

tff(pred_def_16702,type,
    v31207: ( state_type * $int ) > $o ).

tff(pred_def_16703,type,
    v31240: ( state_type * $int ) > $o ).

tff(pred_def_16704,type,
    v31236: ( state_type * $int ) > $o ).

tff(pred_def_16705,type,
    v31221: ( state_type * $int ) > $o ).

tff(pred_def_16706,type,
    v31219: ( state_type * $int ) > $o ).

tff(pred_def_16707,type,
    v31247: state_type > $o ).

tff(pred_def_16708,type,
    v31245: state_type > $o ).

tff(pred_def_16709,type,
    v31254: state_type > $o ).

tff(pred_def_16710,type,
    v31252: state_type > $o ).

tff(pred_def_16711,type,
    v31251: state_type > $o ).

tff(pred_def_16712,type,
    v31250: state_type > $o ).

tff(pred_def_16713,type,
    v31262: state_type > $o ).

tff(pred_def_16714,type,
    v31263: state_type > $o ).

tff(pred_def_16715,type,
    v31261: state_type > $o ).

tff(pred_def_16716,type,
    v31258: ( state_type * $int ) > $o ).

tff(pred_def_16717,type,
    v31260: ( state_type * $int ) > $o ).

tff(pred_def_16718,type,
    v31249: ( state_type * $int ) > $o ).

tff(pred_def_16719,type,
    v31209: ( state_type * $int ) > $o ).

tff(pred_def_16720,type,
    v31205: ( state_type * $int ) > $o ).

tff(pred_def_16721,type,
    v31266: ( state_type * $int ) > $o ).

tff(pred_def_16722,type,
    v31203: ( state_type * $int ) > $o ).

tff(pred_def_16723,type,
    v31277: state_type > $o ).

tff(pred_def_16724,type,
    v31275: state_type > $o ).

tff(pred_def_16725,type,
    v31281: state_type > $o ).

tff(pred_def_16726,type,
    v31279: state_type > $o ).

tff(pred_def_16727,type,
    v31301: state_type > $o ).

tff(pred_def_16728,type,
    v31299: state_type > $o ).

tff(pred_def_16729,type,
    v31305: state_type > $o ).

tff(pred_def_16730,type,
    v31303: state_type > $o ).

tff(pred_def_16731,type,
    v31337: state_type > $o ).

tff(pred_def_16732,type,
    v31335: state_type > $o ).

tff(pred_def_16733,type,
    v31333: state_type > $o ).

tff(pred_def_16734,type,
    v31331: state_type > $o ).

tff(pred_def_16735,type,
    v31329: state_type > $o ).

tff(pred_def_16736,type,
    v31347: state_type > $o ).

tff(pred_def_16737,type,
    v31345: state_type > $o ).

tff(pred_def_16738,type,
    v31343: state_type > $o ).

tff(pred_def_16739,type,
    v31341: state_type > $o ).

tff(pred_def_16740,type,
    v31339: state_type > $o ).

tff(pred_def_16741,type,
    v31367: state_type > $o ).

tff(pred_def_16742,type,
    v31365: state_type > $o ).

tff(pred_def_16743,type,
    v31371: state_type > $o ).

tff(pred_def_16744,type,
    v31369: state_type > $o ).

tff(pred_def_16745,type,
    v31383: state_type > $o ).

tff(pred_def_16746,type,
    v31291: state_type > $o ).

tff(pred_def_16747,type,
    v31381: state_type > $o ).

tff(pred_def_16748,type,
    v31395: state_type > $o ).

tff(pred_def_16749,type,
    v31393: state_type > $o ).

tff(pred_def_16750,type,
    v31399: state_type > $o ).

tff(pred_def_16751,type,
    v31397: state_type > $o ).

tff(pred_def_16752,type,
    v31423: state_type > $o ).

tff(pred_def_16753,type,
    v31421: state_type > $o ).

tff(pred_def_16754,type,
    v31427: state_type > $o ).

tff(pred_def_16755,type,
    v31425: state_type > $o ).

tff(pred_def_16756,type,
    v31441: state_type > $o ).

tff(pred_def_16757,type,
    v31439: state_type > $o ).

tff(pred_def_16758,type,
    v31438: state_type > $o ).

tff(pred_def_16759,type,
    v31437: ( state_type * $int ) > $o ).

tff(pred_def_16760,type,
    b00111100000000011110010001111000: $int > $o ).

tff(pred_def_16761,type,
    v31445: ( state_type * $int ) > $o ).

tff(pred_def_16762,type,
    v31447: ( state_type * $int ) > $o ).

tff(pred_def_16763,type,
    v31435: ( state_type * $int ) > $o ).

tff(pred_def_16764,type,
    v31433: ( state_type * $int ) > $o ).

tff(pred_def_16765,type,
    v31453: state_type > $o ).

tff(pred_def_16766,type,
    v31451: state_type > $o ).

tff(pred_def_16767,type,
    v31449: state_type > $o ).

tff(pred_def_16768,type,
    v31457: state_type > $o ).

tff(pred_def_16769,type,
    v31456: ( state_type * $int ) > $o ).

tff(pred_def_16770,type,
    v31455: ( state_type * $int ) > $o ).

tff(pred_def_16771,type,
    v31461: state_type > $o ).

tff(pred_def_16772,type,
    v31460: ( state_type * $int ) > $o ).

tff(pred_def_16773,type,
    v31459: ( state_type * $int ) > $o ).

tff(pred_def_16774,type,
    v31417: ( state_type * $int ) > $o ).

tff(pred_def_16775,type,
    v31458: ( state_type * $int ) > $o ).

tff(pred_def_16776,type,
    v31454: ( state_type * $int ) > $o ).

tff(pred_def_16777,type,
    v31431: ( state_type * $int ) > $o ).

tff(pred_def_16778,type,
    v31429: ( state_type * $int ) > $o ).

tff(pred_def_16779,type,
    v31466: state_type > $o ).

tff(pred_def_16780,type,
    v31464: state_type > $o ).

tff(pred_def_16781,type,
    v31473: state_type > $o ).

tff(pred_def_16782,type,
    v31471: state_type > $o ).

tff(pred_def_16783,type,
    v31470: state_type > $o ).

tff(pred_def_16784,type,
    v31469: state_type > $o ).

tff(pred_def_16785,type,
    v31481: state_type > $o ).

tff(pred_def_16786,type,
    v31482: state_type > $o ).

tff(pred_def_16787,type,
    v31480: state_type > $o ).

tff(pred_def_16788,type,
    v31477: ( state_type * $int ) > $o ).

tff(pred_def_16789,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_16790,type,
    v31479: ( state_type * $int ) > $o ).

tff(pred_def_16791,type,
    v31468: ( state_type * $int ) > $o ).

tff(pred_def_16792,type,
    v31419: ( state_type * $int ) > $o ).

tff(pred_def_16793,type,
    v31415: ( state_type * $int ) > $o ).

tff(pred_def_16794,type,
    v31485: ( state_type * $int ) > $o ).

tff(pred_def_16795,type,
    v31413: ( state_type * $int ) > $o ).

tff(pred_def_16796,type,
    v31411: ( state_type * $int ) > $o ).

tff(pred_def_16797,type,
    v31409: ( state_type * $int ) > $o ).

tff(pred_def_16798,type,
    v31497: state_type > $o ).

tff(pred_def_16799,type,
    v31495: state_type > $o ).

tff(pred_def_16800,type,
    v31501: state_type > $o ).

tff(pred_def_16801,type,
    v31499: state_type > $o ).

tff(pred_def_16802,type,
    v31489: ( state_type * $int ) > $o ).

tff(pred_def_16803,type,
    v31514: state_type > $o ).

tff(pred_def_16804,type,
    v31513: state_type > $o ).

tff(pred_def_16805,type,
    v31515: state_type > $o ).

tff(pred_def_16806,type,
    v31520: state_type > $o ).

tff(pred_def_16807,type,
    v31521: state_type > $o ).

tff(pred_def_16808,type,
    v31519: state_type > $o ).

tff(pred_def_16809,type,
    v31518: state_type > $o ).

tff(pred_def_16810,type,
    v31516: ( state_type * $int ) > $o ).

tff(pred_def_16811,type,
    v31509: ( state_type * $int ) > $o ).

tff(pred_def_16812,type,
    b00: $int > $o ).

tff(pred_def_16813,type,
    v31507: ( state_type * $int ) > $o ).

tff(pred_def_16814,type,
    v31505: ( state_type * $int ) > $o ).

tff(pred_def_16815,type,
    v31503: ( state_type * $int ) > $o ).

tff(pred_def_16816,type,
    v31529: state_type > $o ).

tff(pred_def_16817,type,
    v31527: state_type > $o ).

tff(pred_def_16818,type,
    v31525: state_type > $o ).

tff(pred_def_16819,type,
    v31523: state_type > $o ).

tff(pred_def_16820,type,
    v31536: state_type > $o ).

tff(pred_def_16821,type,
    v31534: state_type > $o ).

tff(pred_def_16822,type,
    v31533: state_type > $o ).

tff(pred_def_16823,type,
    v31532: state_type > $o ).

tff(pred_def_16824,type,
    v31544: state_type > $o ).

tff(pred_def_16825,type,
    v31545: state_type > $o ).

tff(pred_def_16826,type,
    v31543: state_type > $o ).

tff(pred_def_16827,type,
    v31540: ( state_type * $int ) > $o ).

tff(pred_def_16828,type,
    v31542: ( state_type * $int ) > $o ).

tff(pred_def_16829,type,
    v31493: ( state_type * $int ) > $o ).

tff(pred_def_16830,type,
    v31491: ( state_type * $int ) > $o ).

tff(pred_def_16831,type,
    v31557: state_type > $o ).

tff(pred_def_16832,type,
    v31555: state_type > $o ).

tff(pred_def_16833,type,
    v31561: state_type > $o ).

tff(pred_def_16834,type,
    v31559: state_type > $o ).

tff(pred_def_16835,type,
    v31321: ( state_type * $int ) > $o ).

tff(pred_def_16836,type,
    v31571: state_type > $o ).

tff(pred_def_16837,type,
    v31549: state_type > $o ).

tff(pred_def_16838,type,
    v31572: state_type > $o ).

tff(pred_def_16839,type,
    v31569: state_type > $o ).

tff(pred_def_16840,type,
    v31567: state_type > $o ).

tff(pred_def_16841,type,
    v31565: state_type > $o ).

tff(pred_def_16842,type,
    v31563: state_type > $o ).

tff(pred_def_16843,type,
    v31576: state_type > $o ).

tff(pred_def_16844,type,
    v31574: state_type > $o ).

tff(pred_def_16845,type,
    v31583: state_type > $o ).

tff(pred_def_16846,type,
    v31581: state_type > $o ).

tff(pred_def_16847,type,
    v31580: state_type > $o ).

tff(pred_def_16848,type,
    v31579: state_type > $o ).

tff(pred_def_16849,type,
    v31591: state_type > $o ).

tff(pred_def_16850,type,
    v31592: state_type > $o ).

tff(pred_def_16851,type,
    v31590: state_type > $o ).

tff(pred_def_16852,type,
    v31587: state_type > $o ).

tff(pred_def_16853,type,
    v31589: state_type > $o ).

tff(pred_def_16854,type,
    v31553: state_type > $o ).

tff(pred_def_16855,type,
    v31551: state_type > $o ).

tff(pred_def_16856,type,
    v31605: state_type > $o ).

tff(pred_def_16857,type,
    v31603: state_type > $o ).

tff(pred_def_16858,type,
    v31609: state_type > $o ).

tff(pred_def_16859,type,
    v31607: state_type > $o ).

tff(pred_def_16860,type,
    v31623: state_type > $o ).

tff(pred_def_16861,type,
    v31621: state_type > $o ).

tff(pred_def_16862,type,
    v31620: state_type > $o ).

tff(pred_def_16863,type,
    v31619: ( state_type * $int ) > $o ).

tff(pred_def_16864,type,
    v31631: state_type > $o ).

tff(pred_def_16865,type,
    v31642: state_type > $o ).

tff(pred_def_16866,type,
    v31640: state_type > $o ).

tff(pred_def_16867,type,
    v31639: state_type > $o ).

tff(pred_def_16868,type,
    v31638: ( state_type * $int ) > $o ).

tff(pred_def_16869,type,
    v31636: ( state_type * $int ) > $o ).

tff(pred_def_16870,type,
    v31634: state_type > $o ).

tff(pred_def_16871,type,
    v31647: state_type > $o ).

tff(pred_def_16872,type,
    v31650: state_type > $o ).

tff(pred_def_16873,type,
    v31653: state_type > $o ).

tff(pred_def_16874,type,
    v31656: state_type > $o ).

tff(pred_def_16875,type,
    v31665: state_type > $o ).

tff(pred_def_16876,type,
    v31663: state_type > $o ).

tff(pred_def_16877,type,
    v31662: state_type > $o ).

tff(pred_def_16878,type,
    v31661: ( state_type * $int ) > $o ).

tff(pred_def_16879,type,
    v31659: state_type > $o ).

tff(pred_def_16880,type,
    v31670: state_type > $o ).

tff(pred_def_16881,type,
    v31673: state_type > $o ).

tff(pred_def_16882,type,
    v31676: state_type > $o ).

tff(pred_def_16883,type,
    v31681: state_type > $o ).

tff(pred_def_16884,type,
    v31682: state_type > $o ).

tff(pred_def_16885,type,
    v31680: state_type > $o ).

tff(pred_def_16886,type,
    v31684: state_type > $o ).

tff(pred_def_16887,type,
    v31683: state_type > $o ).

tff(pred_def_16888,type,
    v31679: state_type > $o ).

tff(pred_def_16889,type,
    v31685: state_type > $o ).

tff(pred_def_16890,type,
    v31678: state_type > $o ).

tff(pred_def_16891,type,
    v31687: state_type > $o ).

tff(pred_def_16892,type,
    v31686: state_type > $o ).

tff(pred_def_16893,type,
    v31677: state_type > $o ).

tff(pred_def_16894,type,
    v31629: state_type > $o ).

tff(pred_def_16895,type,
    v31701: state_type > $o ).

tff(pred_def_16896,type,
    v31699: state_type > $o ).

tff(pred_def_16897,type,
    v31705: state_type > $o ).

tff(pred_def_16898,type,
    v31703: state_type > $o ).

tff(pred_def_16899,type,
    v31727: state_type > $o ).

tff(pred_def_16900,type,
    v31725: state_type > $o ).

tff(pred_def_16901,type,
    v31731: state_type > $o ).

tff(pred_def_16902,type,
    v31729: state_type > $o ).

tff(pred_def_16903,type,
    v31313: ( state_type * $int ) > $o ).

tff(pred_def_16904,type,
    v31737: ( state_type * $int ) > $o ).

tff(pred_def_16905,type,
    v31743: state_type > $o ).

tff(pred_def_16906,type,
    v31741: state_type > $o ).

tff(pred_def_16907,type,
    v31739: state_type > $o ).

tff(pred_def_16908,type,
    v31747: state_type > $o ).

tff(pred_def_16909,type,
    v31746: ( state_type * $int ) > $o ).

tff(pred_def_16910,type,
    v31745: ( state_type * $int ) > $o ).

tff(pred_def_16911,type,
    v31751: state_type > $o ).

tff(pred_def_16912,type,
    v31750: ( state_type * $int ) > $o ).

tff(pred_def_16913,type,
    v31749: ( state_type * $int ) > $o ).

tff(pred_def_16914,type,
    v31721: ( state_type * $int ) > $o ).

tff(pred_def_16915,type,
    v31748: ( state_type * $int ) > $o ).

tff(pred_def_16916,type,
    v31744: ( state_type * $int ) > $o ).

tff(pred_def_16917,type,
    v31735: ( state_type * $int ) > $o ).

tff(pred_def_16918,type,
    v31733: ( state_type * $int ) > $o ).

tff(pred_def_16919,type,
    v31755: state_type > $o ).

tff(pred_def_16920,type,
    v31753: state_type > $o ).

tff(pred_def_16921,type,
    v31762: state_type > $o ).

tff(pred_def_16922,type,
    v31760: state_type > $o ).

tff(pred_def_16923,type,
    v31759: state_type > $o ).

tff(pred_def_16924,type,
    v31758: state_type > $o ).

tff(pred_def_16925,type,
    v31770: state_type > $o ).

tff(pred_def_16926,type,
    v31771: state_type > $o ).

tff(pred_def_16927,type,
    v31769: state_type > $o ).

tff(pred_def_16928,type,
    v31766: ( state_type * $int ) > $o ).

tff(pred_def_16929,type,
    v31768: ( state_type * $int ) > $o ).

tff(pred_def_16930,type,
    v31757: ( state_type * $int ) > $o ).

tff(pred_def_16931,type,
    v31723: ( state_type * $int ) > $o ).

tff(pred_def_16932,type,
    v31293: ( state_type * $int ) > $o ).

tff(pred_def_16933,type,
    v31719: ( state_type * $int ) > $o ).

tff(pred_def_16934,type,
    v31717: ( state_type * $int ) > $o ).

tff(pred_def_16935,type,
    v31715: state_type > $o ).

tff(pred_def_16936,type,
    v31779: state_type > $o ).

tff(pred_def_16937,type,
    v31777: state_type > $o ).

tff(pred_def_16938,type,
    v31776: state_type > $o ).

tff(pred_def_16939,type,
    v31775: ( state_type * $int ) > $o ).

tff(pred_def_16940,type,
    v31787: state_type > $o ).

tff(pred_def_16941,type,
    v31785: state_type > $o ).

tff(pred_def_16942,type,
    v31784: state_type > $o ).

tff(pred_def_16943,type,
    v31783: ( state_type * $int ) > $o ).

tff(pred_def_16944,type,
    v31795: state_type > $o ).

tff(pred_def_16945,type,
    v31793: state_type > $o ).

tff(pred_def_16946,type,
    v31792: state_type > $o ).

tff(pred_def_16947,type,
    v31791: ( state_type * $int ) > $o ).

tff(pred_def_16948,type,
    v31803: state_type > $o ).

tff(pred_def_16949,type,
    v31801: state_type > $o ).

tff(pred_def_16950,type,
    v31800: state_type > $o ).

tff(pred_def_16951,type,
    v31799: ( state_type * $int ) > $o ).

tff(pred_def_16952,type,
    v31811: state_type > $o ).

tff(pred_def_16953,type,
    v31809: state_type > $o ).

tff(pred_def_16954,type,
    v31808: state_type > $o ).

tff(pred_def_16955,type,
    v31807: ( state_type * $int ) > $o ).

tff(pred_def_16956,type,
    v31819: state_type > $o ).

tff(pred_def_16957,type,
    v31817: state_type > $o ).

tff(pred_def_16958,type,
    v31816: state_type > $o ).

tff(pred_def_16959,type,
    v31815: ( state_type * $int ) > $o ).

tff(pred_def_16960,type,
    v31359: ( state_type * $int ) > $o ).

tff(pred_def_16961,type,
    v31829: state_type > $o ).

tff(pred_def_16962,type,
    v31387: ( state_type * $int ) > $o ).

tff(pred_def_16963,type,
    v31830: state_type > $o ).

tff(pred_def_16964,type,
    v31828: state_type > $o ).

tff(pred_def_16965,type,
    v31597: ( state_type * $int ) > $o ).

tff(pred_def_16966,type,
    v31831: state_type > $o ).

tff(pred_def_16967,type,
    v31827: state_type > $o ).

tff(pred_def_16968,type,
    v31693: ( state_type * $int ) > $o ).

tff(pred_def_16969,type,
    v31832: state_type > $o ).

tff(pred_def_16970,type,
    v31826: state_type > $o ).

tff(pred_def_16971,type,
    v31833: state_type > $o ).

tff(pred_def_16972,type,
    v31825: state_type > $o ).

tff(pred_def_16973,type,
    v31824: state_type > $o ).

tff(pred_def_16974,type,
    v31823: state_type > $o ).

tff(pred_def_16975,type,
    v31847: state_type > $o ).

tff(pred_def_16976,type,
    v31846: state_type > $o ).

tff(pred_def_16977,type,
    v31845: state_type > $o ).

tff(pred_def_16978,type,
    v31848: state_type > $o ).

tff(pred_def_16979,type,
    v31844: state_type > $o ).

tff(pred_def_16980,type,
    v31843: state_type > $o ).

tff(pred_def_16981,type,
    v31849: state_type > $o ).

tff(pred_def_16982,type,
    v31842: state_type > $o ).

tff(pred_def_16983,type,
    v31841: state_type > $o ).

tff(pred_def_16984,type,
    v31850: state_type > $o ).

tff(pred_def_16985,type,
    v31840: state_type > $o ).

tff(pred_def_16986,type,
    v31839: state_type > $o ).

tff(pred_def_16987,type,
    v31838: state_type > $o ).

tff(pred_def_16988,type,
    v31837: state_type > $o ).

tff(pred_def_16989,type,
    v31852: state_type > $o ).

tff(pred_def_16990,type,
    v31851: state_type > $o ).

tff(pred_def_16991,type,
    v31836: state_type > $o ).

tff(pred_def_16992,type,
    v31855: state_type > $o ).

tff(pred_def_16993,type,
    v31854: state_type > $o ).

tff(pred_def_16994,type,
    v31856: state_type > $o ).

tff(pred_def_16995,type,
    v31853: state_type > $o ).

tff(pred_def_16996,type,
    v31859: state_type > $o ).

tff(pred_def_16997,type,
    v31858: state_type > $o ).

tff(pred_def_16998,type,
    v31860: state_type > $o ).

tff(pred_def_16999,type,
    v31857: state_type > $o ).

tff(pred_def_17000,type,
    v31863: state_type > $o ).

tff(pred_def_17001,type,
    v31862: state_type > $o ).

tff(pred_def_17002,type,
    v31864: state_type > $o ).

tff(pred_def_17003,type,
    v31861: state_type > $o ).

tff(pred_def_17004,type,
    v31867: state_type > $o ).

tff(pred_def_17005,type,
    v31866: state_type > $o ).

tff(pred_def_17006,type,
    v31868: state_type > $o ).

tff(pred_def_17007,type,
    v31865: state_type > $o ).

tff(pred_def_17008,type,
    v31834: ( state_type * $int ) > $o ).

tff(pred_def_17009,type,
    v31883: state_type > $o ).

tff(pred_def_17010,type,
    v31882: state_type > $o ).

tff(pred_def_17011,type,
    v31881: state_type > $o ).

tff(pred_def_17012,type,
    v31884: state_type > $o ).

tff(pred_def_17013,type,
    v31880: state_type > $o ).

tff(pred_def_17014,type,
    v31879: state_type > $o ).

tff(pred_def_17015,type,
    v31885: state_type > $o ).

tff(pred_def_17016,type,
    v31878: state_type > $o ).

tff(pred_def_17017,type,
    v31877: state_type > $o ).

tff(pred_def_17018,type,
    v31886: state_type > $o ).

tff(pred_def_17019,type,
    v31876: state_type > $o ).

tff(pred_def_17020,type,
    v31875: state_type > $o ).

tff(pred_def_17021,type,
    v31874: state_type > $o ).

tff(pred_def_17022,type,
    v31873: state_type > $o ).

tff(pred_def_17023,type,
    v31888: state_type > $o ).

tff(pred_def_17024,type,
    v31887: state_type > $o ).

tff(pred_def_17025,type,
    v31872: state_type > $o ).

tff(pred_def_17026,type,
    v31891: state_type > $o ).

tff(pred_def_17027,type,
    v31890: state_type > $o ).

tff(pred_def_17028,type,
    v31892: state_type > $o ).

tff(pred_def_17029,type,
    v31889: state_type > $o ).

tff(pred_def_17030,type,
    v31895: state_type > $o ).

tff(pred_def_17031,type,
    v31894: state_type > $o ).

tff(pred_def_17032,type,
    v31896: state_type > $o ).

tff(pred_def_17033,type,
    v31893: state_type > $o ).

tff(pred_def_17034,type,
    v31899: state_type > $o ).

tff(pred_def_17035,type,
    v31898: state_type > $o ).

tff(pred_def_17036,type,
    v31900: state_type > $o ).

tff(pred_def_17037,type,
    v31897: state_type > $o ).

tff(pred_def_17038,type,
    v31903: state_type > $o ).

tff(pred_def_17039,type,
    v31902: state_type > $o ).

tff(pred_def_17040,type,
    v31904: state_type > $o ).

tff(pred_def_17041,type,
    v31901: state_type > $o ).

tff(pred_def_17042,type,
    v31870: ( state_type * $int ) > $o ).

tff(pred_def_17043,type,
    v31385: state_type > $o ).

tff(pred_def_17044,type,
    v31869: ( state_type * $int ) > $o ).

tff(pred_def_17045,type,
    v31713: ( state_type * $int ) > $o ).

tff(pred_def_17046,type,
    v31711: ( state_type * $int ) > $o ).

tff(pred_def_17047,type,
    v31709: ( state_type * $int ) > $o ).

tff(pred_def_17048,type,
    v31707: ( state_type * $int ) > $o ).

tff(pred_def_17049,type,
    v31908: state_type > $o ).

tff(pred_def_17050,type,
    v31906: state_type > $o ).

tff(pred_def_17051,type,
    v31915: state_type > $o ).

tff(pred_def_17052,type,
    v31913: state_type > $o ).

tff(pred_def_17053,type,
    v31912: state_type > $o ).

tff(pred_def_17054,type,
    v31911: state_type > $o ).

tff(pred_def_17055,type,
    v31923: state_type > $o ).

tff(pred_def_17056,type,
    v31924: state_type > $o ).

tff(pred_def_17057,type,
    v31922: state_type > $o ).

tff(pred_def_17058,type,
    v31919: ( state_type * $int ) > $o ).

tff(pred_def_17059,type,
    v31921: ( state_type * $int ) > $o ).

tff(pred_def_17060,type,
    v31697: ( state_type * $int ) > $o ).

tff(pred_def_17061,type,
    v31695: ( state_type * $int ) > $o ).

tff(pred_def_17062,type,
    v31928: state_type > $o ).

tff(pred_def_17063,type,
    v31929: state_type > $o ).

tff(pred_def_17064,type,
    v31691: state_type > $o ).

tff(pred_def_17065,type,
    v31931: state_type > $o ).

tff(pred_def_17066,type,
    v31938: state_type > $o ).

tff(pred_def_17067,type,
    v31937: state_type > $o ).

tff(pred_def_17068,type,
    v31936: state_type > $o ).

tff(pred_def_17069,type,
    v31941: state_type > $o ).

tff(pred_def_17070,type,
    v31940: state_type > $o ).

tff(pred_def_17071,type,
    v31939: state_type > $o ).

tff(pred_def_17072,type,
    v31935: state_type > $o ).

tff(pred_def_17073,type,
    v31944: state_type > $o ).

tff(pred_def_17074,type,
    v31943: state_type > $o ).

tff(pred_def_17075,type,
    v31942: state_type > $o ).

tff(pred_def_17076,type,
    v31934: state_type > $o ).

tff(pred_def_17077,type,
    v31933: state_type > $o ).

tff(pred_def_17078,type,
    v31945: state_type > $o ).

tff(pred_def_17079,type,
    v31932: state_type > $o ).

tff(pred_def_17080,type,
    v31689: state_type > $o ).

tff(pred_def_17081,type,
    v31949: state_type > $o ).

tff(pred_def_17082,type,
    v31956: state_type > $o ).

tff(pred_def_17083,type,
    v31957: state_type > $o ).

tff(pred_def_17084,type,
    v31955: state_type > $o ).

tff(pred_def_17085,type,
    v31959: state_type > $o ).

tff(pred_def_17086,type,
    v31960: state_type > $o ).

tff(pred_def_17087,type,
    v31958: state_type > $o ).

tff(pred_def_17088,type,
    v31954: state_type > $o ).

tff(pred_def_17089,type,
    v31962: state_type > $o ).

tff(pred_def_17090,type,
    v31961: state_type > $o ).

tff(pred_def_17091,type,
    v31953: state_type > $o ).

tff(pred_def_17092,type,
    v31952: state_type > $o ).

tff(pred_def_17093,type,
    v31963: state_type > $o ).

tff(pred_def_17094,type,
    v31951: state_type > $o ).

tff(pred_def_17095,type,
    v31950: state_type > $o ).

tff(pred_def_17096,type,
    v31947: state_type > $o ).

tff(pred_def_17097,type,
    v31967: state_type > $o ).

tff(pred_def_17098,type,
    v31968: state_type > $o ).

tff(pred_def_17099,type,
    v31965: state_type > $o ).

tff(pred_def_17100,type,
    v31974: state_type > $o ).

tff(pred_def_17101,type,
    v31975: state_type > $o ).

tff(pred_def_17102,type,
    v31973: state_type > $o ).

tff(pred_def_17103,type,
    v31977: state_type > $o ).

tff(pred_def_17104,type,
    v31980: state_type > $o ).

tff(pred_def_17105,type,
    v31979: state_type > $o ).

tff(pred_def_17106,type,
    v31981: state_type > $o ).

tff(pred_def_17107,type,
    v31978: state_type > $o ).

tff(pred_def_17108,type,
    v31976: state_type > $o ).

tff(pred_def_17109,type,
    v31972: state_type > $o ).

tff(pred_def_17110,type,
    v31984: state_type > $o ).

tff(pred_def_17111,type,
    v31983: state_type > $o ).

tff(pred_def_17112,type,
    b0000001: $int > $o ).

tff(pred_def_17113,type,
    v31987: state_type > $o ).

tff(pred_def_17114,type,
    v31986: state_type > $o ).

tff(pred_def_17115,type,
    v31988: state_type > $o ).

tff(pred_def_17116,type,
    v31985: state_type > $o ).

tff(pred_def_17117,type,
    v31982: state_type > $o ).

tff(pred_def_17118,type,
    v31971: state_type > $o ).

tff(pred_def_17119,type,
    v31992: state_type > $o ).

tff(pred_def_17120,type,
    v31991: state_type > $o ).

tff(pred_def_17121,type,
    v31990: state_type > $o ).

tff(pred_def_17122,type,
    v31993: state_type > $o ).

tff(pred_def_17123,type,
    v31989: state_type > $o ).

tff(pred_def_17124,type,
    v31970: state_type > $o ).

tff(pred_def_17125,type,
    v31997: state_type > $o ).

tff(pred_def_17126,type,
    v31996: state_type > $o ).

tff(pred_def_17127,type,
    v31995: state_type > $o ).

tff(pred_def_17128,type,
    v31994: state_type > $o ).

tff(pred_def_17129,type,
    v31357: ( state_type * $int ) > $o ).

tff(pred_def_17130,type,
    v31998: ( state_type * $int ) > $o ).

tff(pred_def_17131,type,
    v31355: ( state_type * $int ) > $o ).

tff(pred_def_17132,type,
    v31353: ( state_type * $int ) > $o ).

tff(pred_def_17133,type,
    v31351: ( state_type * $int ) > $o ).

tff(pred_def_17134,type,
    v31349: ( state_type * $int ) > $o ).

tff(pred_def_17135,type,
    v32002: state_type > $o ).

tff(pred_def_17136,type,
    v32000: state_type > $o ).

tff(pred_def_17137,type,
    v32009: state_type > $o ).

tff(pred_def_17138,type,
    v32007: state_type > $o ).

tff(pred_def_17139,type,
    v32006: state_type > $o ).

tff(pred_def_17140,type,
    v32005: state_type > $o ).

tff(pred_def_17141,type,
    v32017: state_type > $o ).

tff(pred_def_17142,type,
    v32018: state_type > $o ).

tff(pred_def_17143,type,
    v32016: state_type > $o ).

tff(pred_def_17144,type,
    v32013: ( state_type * $int ) > $o ).

tff(pred_def_17145,type,
    v32015: ( state_type * $int ) > $o ).

tff(pred_def_17146,type,
    v32004: ( state_type * $int ) > $o ).

tff(pred_def_17147,type,
    v31327: ( state_type * $int ) > $o ).

tff(pred_def_17148,type,
    v31325: ( state_type * $int ) > $o ).

tff(pred_def_17149,type,
    v31323: ( state_type * $int ) > $o ).

tff(pred_def_17150,type,
    v32021: ( state_type * $int ) > $o ).

tff(pred_def_17151,type,
    v31627: state_type > $o ).

tff(pred_def_17152,type,
    v32024: state_type > $o ).

tff(pred_def_17153,type,
    v32041: state_type > $o ).

tff(pred_def_17154,type,
    v32040: state_type > $o ).

tff(pred_def_17155,type,
    v32039: state_type > $o ).

tff(pred_def_17156,type,
    v32042: state_type > $o ).

tff(pred_def_17157,type,
    v32038: state_type > $o ).

tff(pred_def_17158,type,
    v32037: state_type > $o ).

tff(pred_def_17159,type,
    v32043: state_type > $o ).

tff(pred_def_17160,type,
    v32036: state_type > $o ).

tff(pred_def_17161,type,
    v32035: state_type > $o ).

tff(pred_def_17162,type,
    v32044: state_type > $o ).

tff(pred_def_17163,type,
    v32034: state_type > $o ).

tff(pred_def_17164,type,
    v32033: state_type > $o ).

tff(pred_def_17165,type,
    v32045: state_type > $o ).

tff(pred_def_17166,type,
    v32032: state_type > $o ).

tff(pred_def_17167,type,
    v32031: state_type > $o ).

tff(pred_def_17168,type,
    v32030: state_type > $o ).

tff(pred_def_17169,type,
    v32029: state_type > $o ).

tff(pred_def_17170,type,
    v32047: state_type > $o ).

tff(pred_def_17171,type,
    v32046: state_type > $o ).

tff(pred_def_17172,type,
    v32028: state_type > $o ).

tff(pred_def_17173,type,
    v32050: state_type > $o ).

tff(pred_def_17174,type,
    v32049: state_type > $o ).

tff(pred_def_17175,type,
    v32051: state_type > $o ).

tff(pred_def_17176,type,
    v32048: state_type > $o ).

tff(pred_def_17177,type,
    v32054: state_type > $o ).

tff(pred_def_17178,type,
    v32053: state_type > $o ).

tff(pred_def_17179,type,
    v32055: state_type > $o ).

tff(pred_def_17180,type,
    v32052: state_type > $o ).

tff(pred_def_17181,type,
    v32058: state_type > $o ).

tff(pred_def_17182,type,
    v32057: state_type > $o ).

tff(pred_def_17183,type,
    v32059: state_type > $o ).

tff(pred_def_17184,type,
    v32056: state_type > $o ).

tff(pred_def_17185,type,
    v32062: state_type > $o ).

tff(pred_def_17186,type,
    v32061: state_type > $o ).

tff(pred_def_17187,type,
    v32063: state_type > $o ).

tff(pred_def_17188,type,
    v32060: state_type > $o ).

tff(pred_def_17189,type,
    v32066: state_type > $o ).

tff(pred_def_17190,type,
    v32065: state_type > $o ).

tff(pred_def_17191,type,
    v32067: state_type > $o ).

tff(pred_def_17192,type,
    v32064: state_type > $o ).

tff(pred_def_17193,type,
    v32026: ( state_type * $int ) > $o ).

tff(pred_def_17194,type,
    v32025: ( state_type * $int ) > $o ).

tff(pred_def_17195,type,
    v31617: ( state_type * $int ) > $o ).

tff(pred_def_17196,type,
    v31615: ( state_type * $int ) > $o ).

tff(pred_def_17197,type,
    v31613: ( state_type * $int ) > $o ).

tff(pred_def_17198,type,
    v31611: ( state_type * $int ) > $o ).

tff(pred_def_17199,type,
    v32071: state_type > $o ).

tff(pred_def_17200,type,
    v32069: state_type > $o ).

tff(pred_def_17201,type,
    v32078: state_type > $o ).

tff(pred_def_17202,type,
    v32076: state_type > $o ).

tff(pred_def_17203,type,
    v32075: state_type > $o ).

tff(pred_def_17204,type,
    v32074: state_type > $o ).

tff(pred_def_17205,type,
    v32086: state_type > $o ).

tff(pred_def_17206,type,
    v32087: state_type > $o ).

tff(pred_def_17207,type,
    v32085: state_type > $o ).

tff(pred_def_17208,type,
    v32082: ( state_type * $int ) > $o ).

tff(pred_def_17209,type,
    v32084: ( state_type * $int ) > $o ).

tff(pred_def_17210,type,
    v31601: ( state_type * $int ) > $o ).

tff(pred_def_17211,type,
    v31599: ( state_type * $int ) > $o ).

tff(pred_def_17212,type,
    v32093: state_type > $o ).

tff(pred_def_17213,type,
    v32098: state_type > $o ).

tff(pred_def_17214,type,
    v32100: state_type > $o ).

tff(pred_def_17215,type,
    v32099: state_type > $o ).

tff(pred_def_17216,type,
    v32097: state_type > $o ).

tff(pred_def_17217,type,
    v32101: state_type > $o ).

tff(pred_def_17218,type,
    v32096: state_type > $o ).

tff(pred_def_17219,type,
    v32103: state_type > $o ).

tff(pred_def_17220,type,
    v32102: state_type > $o ).

tff(pred_def_17221,type,
    v32095: state_type > $o ).

tff(pred_def_17222,type,
    v32104: state_type > $o ).

tff(pred_def_17223,type,
    v32094: state_type > $o ).

tff(pred_def_17224,type,
    v32091: state_type > $o ).

tff(pred_def_17225,type,
    v32109: state_type > $o ).

tff(pred_def_17226,type,
    v32108: state_type > $o ).

tff(pred_def_17227,type,
    v32106: state_type > $o ).

tff(pred_def_17228,type,
    v32113: state_type > $o ).

tff(pred_def_17229,type,
    v32118: state_type > $o ).

tff(pred_def_17230,type,
    v32120: state_type > $o ).

tff(pred_def_17231,type,
    v32119: state_type > $o ).

tff(pred_def_17232,type,
    v32117: state_type > $o ).

tff(pred_def_17233,type,
    v32123: state_type > $o ).

tff(pred_def_17234,type,
    v32122: state_type > $o ).

tff(pred_def_17235,type,
    v32121: state_type > $o ).

tff(pred_def_17236,type,
    v32116: state_type > $o ).

tff(pred_def_17237,type,
    v32124: state_type > $o ).

tff(pred_def_17238,type,
    v32115: state_type > $o ).

tff(pred_def_17239,type,
    v32127: state_type > $o ).

tff(pred_def_17240,type,
    v32126: state_type > $o ).

tff(pred_def_17241,type,
    v32125: state_type > $o ).

tff(pred_def_17242,type,
    v32114: state_type > $o ).

tff(pred_def_17243,type,
    v32111: state_type > $o ).

tff(pred_def_17244,type,
    v32131: state_type > $o ).

tff(pred_def_17245,type,
    v32137: state_type > $o ).

tff(pred_def_17246,type,
    v32139: state_type > $o ).

tff(pred_def_17247,type,
    v32140: state_type > $o ).

tff(pred_def_17248,type,
    v32138: state_type > $o ).

tff(pred_def_17249,type,
    v32136: state_type > $o ).

tff(pred_def_17250,type,
    v32135: state_type > $o ).

tff(pred_def_17251,type,
    v32134: state_type > $o ).

tff(pred_def_17252,type,
    v32142: state_type > $o ).

tff(pred_def_17253,type,
    v32143: state_type > $o ).

tff(pred_def_17254,type,
    v32141: state_type > $o ).

tff(pred_def_17255,type,
    v32133: state_type > $o ).

tff(pred_def_17256,type,
    v32145: state_type > $o ).

tff(pred_def_17257,type,
    v32144: state_type > $o ).

tff(pred_def_17258,type,
    v32132: state_type > $o ).

tff(pred_def_17259,type,
    v32129: state_type > $o ).

tff(pred_def_17260,type,
    v32150: state_type > $o ).

tff(pred_def_17261,type,
    v32152: state_type > $o ).

tff(pred_def_17262,type,
    v32151: state_type > $o ).

tff(pred_def_17263,type,
    v32149: state_type > $o ).

tff(pred_def_17264,type,
    v32154: state_type > $o ).

tff(pred_def_17265,type,
    v32155: state_type > $o ).

tff(pred_def_17266,type,
    v32153: state_type > $o ).

tff(pred_def_17267,type,
    v32148: state_type > $o ).

tff(pred_def_17268,type,
    v32158: state_type > $o ).

tff(pred_def_17269,type,
    v32157: state_type > $o ).

tff(pred_def_17270,type,
    v32159: state_type > $o ).

tff(pred_def_17271,type,
    v32156: state_type > $o ).

tff(pred_def_17272,type,
    v32147: state_type > $o ).

tff(pred_def_17273,type,
    v32161: state_type > $o ).

tff(pred_def_17274,type,
    v32160: state_type > $o ).

tff(pred_def_17275,type,
    v32167: state_type > $o ).

tff(pred_def_17276,type,
    v32165: state_type > $o ).

tff(pred_def_17277,type,
    v32164: state_type > $o ).

tff(pred_def_17278,type,
    v32163: ( state_type * $int ) > $o ).

tff(pred_def_17279,type,
    v32173: state_type > $o ).

tff(pred_def_17280,type,
    v32178: state_type > $o ).

tff(pred_def_17281,type,
    v32179: state_type > $o ).

tff(pred_def_17282,type,
    v32177: state_type > $o ).

tff(pred_def_17283,type,
    v32181: state_type > $o ).

tff(pred_def_17284,type,
    v32180: state_type > $o ).

tff(pred_def_17285,type,
    v32176: state_type > $o ).

tff(pred_def_17286,type,
    v32183: state_type > $o ).

tff(pred_def_17287,type,
    v32182: state_type > $o ).

tff(pred_def_17288,type,
    v32175: state_type > $o ).

tff(pred_def_17289,type,
    v32184: state_type > $o ).

tff(pred_def_17290,type,
    v32174: state_type > $o ).

tff(pred_def_17291,type,
    v32171: state_type > $o ).

tff(pred_def_17292,type,
    v32188: state_type > $o ).

tff(pred_def_17293,type,
    v32196: state_type > $o ).

tff(pred_def_17294,type,
    v32195: state_type > $o ).

tff(pred_def_17295,type,
    v32194: state_type > $o ).

tff(pred_def_17296,type,
    v32197: state_type > $o ).

tff(pred_def_17297,type,
    v32193: state_type > $o ).

tff(pred_def_17298,type,
    v32192: state_type > $o ).

tff(pred_def_17299,type,
    v32199: state_type > $o ).

tff(pred_def_17300,type,
    v32198: state_type > $o ).

tff(pred_def_17301,type,
    v32191: state_type > $o ).

tff(pred_def_17302,type,
    v32202: state_type > $o ).

tff(pred_def_17303,type,
    v32201: state_type > $o ).

tff(pred_def_17304,type,
    v32200: state_type > $o ).

tff(pred_def_17305,type,
    v32190: state_type > $o ).

tff(pred_def_17306,type,
    v32189: state_type > $o ).

tff(pred_def_17307,type,
    v32186: state_type > $o ).

tff(pred_def_17308,type,
    v32207: state_type > $o ).

tff(pred_def_17309,type,
    v32206: state_type > $o ).

tff(pred_def_17310,type,
    v32204: state_type > $o ).

tff(pred_def_17311,type,
    v32211: state_type > $o ).

tff(pred_def_17312,type,
    v32216: state_type > $o ).

tff(pred_def_17313,type,
    v32217: state_type > $o ).

tff(pred_def_17314,type,
    v32215: state_type > $o ).

tff(pred_def_17315,type,
    v32219: state_type > $o ).

tff(pred_def_17316,type,
    v32220: state_type > $o ).

tff(pred_def_17317,type,
    v32218: state_type > $o ).

tff(pred_def_17318,type,
    v32214: state_type > $o ).

tff(pred_def_17319,type,
    v32222: state_type > $o ).

tff(pred_def_17320,type,
    v32221: state_type > $o ).

tff(pred_def_17321,type,
    v32213: state_type > $o ).

tff(pred_def_17322,type,
    v32224: state_type > $o ).

tff(pred_def_17323,type,
    v32225: state_type > $o ).

tff(pred_def_17324,type,
    v32223: state_type > $o ).

tff(pred_def_17325,type,
    v32212: state_type > $o ).

tff(pred_def_17326,type,
    v32209: state_type > $o ).

tff(pred_def_17327,type,
    v32230: state_type > $o ).

tff(pred_def_17328,type,
    v32232: state_type > $o ).

tff(pred_def_17329,type,
    v32233: state_type > $o ).

tff(pred_def_17330,type,
    v32231: state_type > $o ).

tff(pred_def_17331,type,
    v32229: state_type > $o ).

tff(pred_def_17332,type,
    v32236: state_type > $o ).

tff(pred_def_17333,type,
    v32235: state_type > $o ).

tff(pred_def_17334,type,
    v32234: state_type > $o ).

tff(pred_def_17335,type,
    v32228: state_type > $o ).

tff(pred_def_17336,type,
    v32239: state_type > $o ).

tff(pred_def_17337,type,
    v32238: state_type > $o ).

tff(pred_def_17338,type,
    v32240: state_type > $o ).

tff(pred_def_17339,type,
    v32237: state_type > $o ).

tff(pred_def_17340,type,
    v32227: state_type > $o ).

tff(pred_def_17341,type,
    v32242: state_type > $o ).

tff(pred_def_17342,type,
    v32241: state_type > $o ).

tff(pred_def_17343,type,
    v32248: state_type > $o ).

tff(pred_def_17344,type,
    v32246: state_type > $o ).

tff(pred_def_17345,type,
    v32245: state_type > $o ).

tff(pred_def_17346,type,
    v32244: ( state_type * $int ) > $o ).

tff(pred_def_17347,type,
    v31487: state_type > $o ).

tff(pred_def_17348,type,
    v32253: state_type > $o ).

tff(pred_def_17349,type,
    v32270: state_type > $o ).

tff(pred_def_17350,type,
    v32269: state_type > $o ).

tff(pred_def_17351,type,
    v32268: state_type > $o ).

tff(pred_def_17352,type,
    v32271: state_type > $o ).

tff(pred_def_17353,type,
    v32267: state_type > $o ).

tff(pred_def_17354,type,
    v32266: state_type > $o ).

tff(pred_def_17355,type,
    v32272: state_type > $o ).

tff(pred_def_17356,type,
    v32265: state_type > $o ).

tff(pred_def_17357,type,
    v32264: state_type > $o ).

tff(pred_def_17358,type,
    v32273: state_type > $o ).

tff(pred_def_17359,type,
    v32263: state_type > $o ).

tff(pred_def_17360,type,
    v32262: state_type > $o ).

tff(pred_def_17361,type,
    v32274: state_type > $o ).

tff(pred_def_17362,type,
    v32261: state_type > $o ).

tff(pred_def_17363,type,
    v32260: state_type > $o ).

tff(pred_def_17364,type,
    v32259: state_type > $o ).

tff(pred_def_17365,type,
    v32258: state_type > $o ).

tff(pred_def_17366,type,
    v32276: state_type > $o ).

tff(pred_def_17367,type,
    v32275: state_type > $o ).

tff(pred_def_17368,type,
    v32257: state_type > $o ).

tff(pred_def_17369,type,
    v32279: state_type > $o ).

tff(pred_def_17370,type,
    v32278: state_type > $o ).

tff(pred_def_17371,type,
    v32280: state_type > $o ).

tff(pred_def_17372,type,
    v32277: state_type > $o ).

tff(pred_def_17373,type,
    v32283: state_type > $o ).

tff(pred_def_17374,type,
    v32282: state_type > $o ).

tff(pred_def_17375,type,
    v32284: state_type > $o ).

tff(pred_def_17376,type,
    v32281: state_type > $o ).

tff(pred_def_17377,type,
    v32287: state_type > $o ).

tff(pred_def_17378,type,
    v32286: state_type > $o ).

tff(pred_def_17379,type,
    v32288: state_type > $o ).

tff(pred_def_17380,type,
    v32285: state_type > $o ).

tff(pred_def_17381,type,
    v32291: state_type > $o ).

tff(pred_def_17382,type,
    v32290: state_type > $o ).

tff(pred_def_17383,type,
    v32292: state_type > $o ).

tff(pred_def_17384,type,
    v32289: state_type > $o ).

tff(pred_def_17385,type,
    v32295: state_type > $o ).

tff(pred_def_17386,type,
    v32294: state_type > $o ).

tff(pred_def_17387,type,
    v32296: state_type > $o ).

tff(pred_def_17388,type,
    v32293: state_type > $o ).

tff(pred_def_17389,type,
    v32255: ( state_type * $int ) > $o ).

tff(pred_def_17390,type,
    v32254: ( state_type * $int ) > $o ).

tff(pred_def_17391,type,
    v31407: ( state_type * $int ) > $o ).

tff(pred_def_17392,type,
    v31405: ( state_type * $int ) > $o ).

tff(pred_def_17393,type,
    v31403: ( state_type * $int ) > $o ).

tff(pred_def_17394,type,
    v31401: ( state_type * $int ) > $o ).

tff(pred_def_17395,type,
    v32300: state_type > $o ).

tff(pred_def_17396,type,
    v32298: state_type > $o ).

tff(pred_def_17397,type,
    v32307: state_type > $o ).

tff(pred_def_17398,type,
    v32305: state_type > $o ).

tff(pred_def_17399,type,
    v32304: state_type > $o ).

tff(pred_def_17400,type,
    v32303: state_type > $o ).

tff(pred_def_17401,type,
    v32315: state_type > $o ).

tff(pred_def_17402,type,
    v32316: state_type > $o ).

tff(pred_def_17403,type,
    v32314: state_type > $o ).

tff(pred_def_17404,type,
    v32311: ( state_type * $int ) > $o ).

tff(pred_def_17405,type,
    v32313: ( state_type * $int ) > $o ).

tff(pred_def_17406,type,
    v31391: ( state_type * $int ) > $o ).

tff(pred_def_17407,type,
    v31389: ( state_type * $int ) > $o ).

tff(pred_def_17408,type,
    v32322: state_type > $o ).

tff(pred_def_17409,type,
    v32323: state_type > $o ).

tff(pred_def_17410,type,
    v32321: state_type > $o ).

tff(pred_def_17411,type,
    v32324: state_type > $o ).

tff(pred_def_17412,type,
    v32320: state_type > $o ).

tff(pred_def_17413,type,
    v32325: state_type > $o ).

tff(pred_def_17414,type,
    v32327: state_type > $o ).

tff(pred_def_17415,type,
    v32330: state_type > $o ).

tff(pred_def_17416,type,
    v32343: state_type > $o ).

tff(pred_def_17417,type,
    v32342: state_type > $o ).

tff(pred_def_17418,type,
    v32341: state_type > $o ).

tff(pred_def_17419,type,
    v32344: state_type > $o ).

tff(pred_def_17420,type,
    v32340: state_type > $o ).

tff(pred_def_17421,type,
    v32339: state_type > $o ).

tff(pred_def_17422,type,
    v32345: state_type > $o ).

tff(pred_def_17423,type,
    v32338: state_type > $o ).

tff(pred_def_17424,type,
    v32337: state_type > $o ).

tff(pred_def_17425,type,
    v32336: state_type > $o ).

tff(pred_def_17426,type,
    v32335: state_type > $o ).

tff(pred_def_17427,type,
    v32347: state_type > $o ).

tff(pred_def_17428,type,
    v32346: state_type > $o ).

tff(pred_def_17429,type,
    v32334: state_type > $o ).

tff(pred_def_17430,type,
    v32350: state_type > $o ).

tff(pred_def_17431,type,
    v32349: state_type > $o ).

tff(pred_def_17432,type,
    v32351: state_type > $o ).

tff(pred_def_17433,type,
    v32348: state_type > $o ).

tff(pred_def_17434,type,
    v32354: state_type > $o ).

tff(pred_def_17435,type,
    v32353: state_type > $o ).

tff(pred_def_17436,type,
    v32355: state_type > $o ).

tff(pred_def_17437,type,
    v32352: state_type > $o ).

tff(pred_def_17438,type,
    v32358: state_type > $o ).

tff(pred_def_17439,type,
    v32357: state_type > $o ).

tff(pred_def_17440,type,
    v32359: state_type > $o ).

tff(pred_def_17441,type,
    v32356: state_type > $o ).

tff(pred_def_17442,type,
    v32332: ( state_type * $int ) > $o ).

tff(pred_def_17443,type,
    v32331: ( state_type * $int ) > $o ).

tff(pred_def_17444,type,
    v31379: ( state_type * $int ) > $o ).

tff(pred_def_17445,type,
    v31377: ( state_type * $int ) > $o ).

tff(pred_def_17446,type,
    v31375: ( state_type * $int ) > $o ).

tff(pred_def_17447,type,
    v31373: ( state_type * $int ) > $o ).

tff(pred_def_17448,type,
    v32363: state_type > $o ).

tff(pred_def_17449,type,
    v32361: state_type > $o ).

tff(pred_def_17450,type,
    v32370: state_type > $o ).

tff(pred_def_17451,type,
    v32368: state_type > $o ).

tff(pred_def_17452,type,
    v32367: state_type > $o ).

tff(pred_def_17453,type,
    v32366: state_type > $o ).

tff(pred_def_17454,type,
    v32378: state_type > $o ).

tff(pred_def_17455,type,
    v32379: state_type > $o ).

tff(pred_def_17456,type,
    v32377: state_type > $o ).

tff(pred_def_17457,type,
    v32374: ( state_type * $int ) > $o ).

tff(pred_def_17458,type,
    v32376: ( state_type * $int ) > $o ).

tff(pred_def_17459,type,
    v31363: ( state_type * $int ) > $o ).

tff(pred_def_17460,type,
    v31361: ( state_type * $int ) > $o ).

tff(pred_def_17461,type,
    v32385: state_type > $o ).

tff(pred_def_17462,type,
    v32389: state_type > $o ).

tff(pred_def_17463,type,
    v32388: state_type > $o ).

tff(pred_def_17464,type,
    v32383: state_type > $o ).

tff(pred_def_17465,type,
    v32399: state_type > $o ).

tff(pred_def_17466,type,
    v32398: state_type > $o ).

tff(pred_def_17467,type,
    v32397: state_type > $o ).

tff(pred_def_17468,type,
    v32400: state_type > $o ).

tff(pred_def_17469,type,
    v32396: state_type > $o ).

tff(pred_def_17470,type,
    v32395: state_type > $o ).

tff(pred_def_17471,type,
    v32401: state_type > $o ).

tff(pred_def_17472,type,
    v32394: state_type > $o ).

tff(pred_def_17473,type,
    v32403: state_type > $o ).

tff(pred_def_17474,type,
    v32402: state_type > $o ).

tff(pred_def_17475,type,
    v32393: state_type > $o ).

tff(pred_def_17476,type,
    v32391: state_type > $o ).

tff(pred_def_17477,type,
    v32412: state_type > $o ).

tff(pred_def_17478,type,
    v32411: state_type > $o ).

tff(pred_def_17479,type,
    v32410: state_type > $o ).

tff(pred_def_17480,type,
    v32414: state_type > $o ).

tff(pred_def_17481,type,
    v32413: state_type > $o ).

tff(pred_def_17482,type,
    v32409: state_type > $o ).

tff(pred_def_17483,type,
    v32416: state_type > $o ).

tff(pred_def_17484,type,
    v32415: state_type > $o ).

tff(pred_def_17485,type,
    v32408: state_type > $o ).

tff(pred_def_17486,type,
    v32417: state_type > $o ).

tff(pred_def_17487,type,
    v32407: state_type > $o ).

tff(pred_def_17488,type,
    v32405: state_type > $o ).

tff(pred_def_17489,type,
    v32427: state_type > $o ).

tff(pred_def_17490,type,
    v32426: state_type > $o ).

tff(pred_def_17491,type,
    v32428: state_type > $o ).

tff(pred_def_17492,type,
    v32425: state_type > $o ).

tff(pred_def_17493,type,
    v32430: state_type > $o ).

tff(pred_def_17494,type,
    v32429: state_type > $o ).

tff(pred_def_17495,type,
    v32424: state_type > $o ).

tff(pred_def_17496,type,
    v32431: state_type > $o ).

tff(pred_def_17497,type,
    v32423: state_type > $o ).

tff(pred_def_17498,type,
    v32422: state_type > $o ).

tff(pred_def_17499,type,
    v32421: state_type > $o ).

tff(pred_def_17500,type,
    v32419: state_type > $o ).

tff(pred_def_17501,type,
    v32436: state_type > $o ).

tff(pred_def_17502,type,
    v32435: state_type > $o ).

tff(pred_def_17503,type,
    v32438: state_type > $o ).

tff(pred_def_17504,type,
    v32439: state_type > $o ).

tff(pred_def_17505,type,
    v32437: state_type > $o ).

tff(pred_def_17506,type,
    v32434: state_type > $o ).

tff(pred_def_17507,type,
    v32442: state_type > $o ).

tff(pred_def_17508,type,
    v32441: state_type > $o ).

tff(pred_def_17509,type,
    v32443: state_type > $o ).

tff(pred_def_17510,type,
    v32440: state_type > $o ).

tff(pred_def_17511,type,
    v32433: state_type > $o ).

tff(pred_def_17512,type,
    v32445: state_type > $o ).

tff(pred_def_17513,type,
    v32444: state_type > $o ).

tff(pred_def_17514,type,
    v32451: state_type > $o ).

tff(pred_def_17515,type,
    v32449: state_type > $o ).

tff(pred_def_17516,type,
    v32448: state_type > $o ).

tff(pred_def_17517,type,
    v32447: ( state_type * $int ) > $o ).

tff(pred_def_17518,type,
    v32455: state_type > $o ).

tff(pred_def_17519,type,
    v31319: state_type > $o ).

tff(pred_def_17520,type,
    v31317: state_type > $o ).

tff(pred_def_17521,type,
    v31315: state_type > $o ).

tff(pred_def_17522,type,
    v31311: state_type > $o ).

tff(pred_def_17523,type,
    v32463: state_type > $o ).

tff(pred_def_17524,type,
    v32462: state_type > $o ).

tff(pred_def_17525,type,
    v32460: state_type > $o ).

tff(pred_def_17526,type,
    v32458: state_type > $o ).

tff(pred_def_17527,type,
    v32467: state_type > $o ).

tff(pred_def_17528,type,
    v32466: state_type > $o ).

tff(pred_def_17529,type,
    v32465: state_type > $o ).

tff(pred_def_17530,type,
    v32471: state_type > $o ).

tff(pred_def_17531,type,
    v32470: state_type > $o ).

tff(pred_def_17532,type,
    v32469: state_type > $o ).

tff(pred_def_17533,type,
    v31295: state_type > $o ).

tff(pred_def_17534,type,
    v32468: state_type > $o ).

tff(pred_def_17535,type,
    v31309: state_type > $o ).

tff(pred_def_17536,type,
    v31307: state_type > $o ).

tff(pred_def_17537,type,
    v32475: state_type > $o ).

tff(pred_def_17538,type,
    v32473: state_type > $o ).

tff(pred_def_17539,type,
    v32482: state_type > $o ).

tff(pred_def_17540,type,
    v32480: state_type > $o ).

tff(pred_def_17541,type,
    v32479: state_type > $o ).

tff(pred_def_17542,type,
    v32478: state_type > $o ).

tff(pred_def_17543,type,
    v32490: state_type > $o ).

tff(pred_def_17544,type,
    v32491: state_type > $o ).

tff(pred_def_17545,type,
    v32489: state_type > $o ).

tff(pred_def_17546,type,
    v32486: state_type > $o ).

tff(pred_def_17547,type,
    v32488: state_type > $o ).

tff(pred_def_17548,type,
    v31297: state_type > $o ).

tff(pred_def_17549,type,
    b000011: $int > $o ).

tff(pred_def_17550,type,
    v32497: state_type > $o ).

tff(pred_def_17551,type,
    v32496: state_type > $o ).

tff(pred_def_17552,type,
    v31269: state_type > $o ).

tff(pred_def_17553,type,
    v32498: state_type > $o ).

tff(pred_def_17554,type,
    v32500: state_type > $o ).

tff(pred_def_17555,type,
    v31289: state_type > $o ).

tff(pred_def_17556,type,
    v31287: state_type > $o ).

tff(pred_def_17557,type,
    v31285: state_type > $o ).

tff(pred_def_17558,type,
    v31283: state_type > $o ).

tff(pred_def_17559,type,
    v32504: state_type > $o ).

tff(pred_def_17560,type,
    v32502: state_type > $o ).

tff(pred_def_17561,type,
    v32511: state_type > $o ).

tff(pred_def_17562,type,
    v32509: state_type > $o ).

tff(pred_def_17563,type,
    v32508: state_type > $o ).

tff(pred_def_17564,type,
    v32507: state_type > $o ).

tff(pred_def_17565,type,
    v32519: state_type > $o ).

tff(pred_def_17566,type,
    v32520: state_type > $o ).

tff(pred_def_17567,type,
    v32518: state_type > $o ).

tff(pred_def_17568,type,
    v32515: state_type > $o ).

tff(pred_def_17569,type,
    v32517: state_type > $o ).

tff(pred_def_17570,type,
    v31273: state_type > $o ).

tff(pred_def_17571,type,
    v31271: state_type > $o ).

tff(pred_def_17572,type,
    v32532: state_type > $o ).

tff(pred_def_17573,type,
    v32530: state_type > $o ).

tff(pred_def_17574,type,
    v32536: state_type > $o ).

tff(pred_def_17575,type,
    v32534: state_type > $o ).

tff(pred_def_17576,type,
    v32556: state_type > $o ).

tff(pred_def_17577,type,
    v32554: state_type > $o ).

tff(pred_def_17578,type,
    v32560: state_type > $o ).

tff(pred_def_17579,type,
    v32558: state_type > $o ).

tff(pred_def_17580,type,
    v32572: state_type > $o ).

tff(pred_def_17581,type,
    v32581: state_type > $o ).

tff(pred_def_17582,type,
    v32591: state_type > $o ).

tff(pred_def_17583,type,
    v32589: state_type > $o ).

tff(pred_def_17584,type,
    v32595: state_type > $o ).

tff(pred_def_17585,type,
    v32593: state_type > $o ).

tff(pred_def_17586,type,
    v32607: state_type > $o ).

tff(pred_def_17587,type,
    v32606: state_type > $o ).

tff(pred_def_17588,type,
    v32605: state_type > $o ).

tff(pred_def_17589,type,
    v32583: state_type > $o ).

tff(pred_def_17590,type,
    v32603: state_type > $o ).

tff(pred_def_17591,type,
    v32601: state_type > $o ).

tff(pred_def_17592,type,
    v32599: state_type > $o ).

tff(pred_def_17593,type,
    v32597: state_type > $o ).

tff(pred_def_17594,type,
    v32611: state_type > $o ).

tff(pred_def_17595,type,
    v32609: state_type > $o ).

tff(pred_def_17596,type,
    v32618: state_type > $o ).

tff(pred_def_17597,type,
    v32616: state_type > $o ).

tff(pred_def_17598,type,
    v32615: state_type > $o ).

tff(pred_def_17599,type,
    v32614: state_type > $o ).

tff(pred_def_17600,type,
    v32626: state_type > $o ).

tff(pred_def_17601,type,
    v32627: state_type > $o ).

tff(pred_def_17602,type,
    v32625: state_type > $o ).

tff(pred_def_17603,type,
    v32622: state_type > $o ).

tff(pred_def_17604,type,
    v32624: state_type > $o ).

tff(pred_def_17605,type,
    v32587: state_type > $o ).

tff(pred_def_17606,type,
    v32585: state_type > $o ).

tff(pred_def_17607,type,
    v32524: ( state_type * $int ) > $o ).

tff(pred_def_17608,type,
    v32631: state_type > $o ).

tff(pred_def_17609,type,
    v32579: state_type > $o ).

tff(pred_def_17610,type,
    v32641: state_type > $o ).

tff(pred_def_17611,type,
    v32639: state_type > $o ).

tff(pred_def_17612,type,
    v32645: state_type > $o ).

tff(pred_def_17613,type,
    v32643: state_type > $o ).

tff(pred_def_17614,type,
    v32659: ( state_type * $int ) > $o ).

tff(pred_def_17615,type,
    v32657: ( state_type * $int ) > $o ).

tff(pred_def_17616,type,
    v32655: ( state_type * $int ) > $o ).

tff(pred_def_17617,type,
    v32633: state_type > $o ).

tff(pred_def_17618,type,
    v32664: state_type > $o ).

tff(pred_def_17619,type,
    v32663: state_type > $o ).

tff(pred_def_17620,type,
    b00000000000000000000: $int > $o ).

tff(pred_def_17621,type,
    v32665: state_type > $o ).

tff(pred_def_17622,type,
    v32662: state_type > $o ).

tff(pred_def_17623,type,
    v4280: state_type > $o ).

tff(pred_def_17624,type,
    v32668: state_type > $o ).

tff(pred_def_17625,type,
    v4221: ( state_type * $int ) > $o ).

tff(pred_def_17626,type,
    v32671: state_type > $o ).

tff(pred_def_17627,type,
    v32577: state_type > $o ).

tff(pred_def_17628,type,
    v32670: state_type > $o ).

tff(pred_def_17629,type,
    v32676: state_type > $o ).

tff(pred_def_17630,type,
    v32675: state_type > $o ).

tff(pred_def_17631,type,
    v32677: state_type > $o ).

tff(pred_def_17632,type,
    v32674: state_type > $o ).

tff(pred_def_17633,type,
    v32672: state_type > $o ).

tff(pred_def_17634,type,
    v32669: state_type > $o ).

tff(pred_def_17635,type,
    v32667: state_type > $o ).

tff(pred_def_17636,type,
    v32666: state_type > $o ).

tff(pred_def_17637,type,
    v32653: state_type > $o ).

tff(pred_def_17638,type,
    v32651: state_type > $o ).

tff(pred_def_17639,type,
    v32689: state_type > $o ).

tff(pred_def_17640,type,
    v32688: state_type > $o ).

tff(pred_def_17641,type,
    v32690: state_type > $o ).

tff(pred_def_17642,type,
    v32687: state_type > $o ).

tff(pred_def_17643,type,
    v32686: state_type > $o ).

tff(pred_def_17644,type,
    v32685: state_type > $o ).

tff(pred_def_17645,type,
    v32693: state_type > $o ).

tff(pred_def_17646,type,
    v32692: state_type > $o ).

tff(pred_def_17647,type,
    v32694: state_type > $o ).

tff(pred_def_17648,type,
    v32691: state_type > $o ).

tff(pred_def_17649,type,
    v32684: state_type > $o ).

tff(pred_def_17650,type,
    b0100001010000: $int > $o ).

tff(pred_def_17651,type,
    v32696: state_type > $o ).

tff(pred_def_17652,type,
    v32695: state_type > $o ).

tff(pred_def_17653,type,
    v32681: state_type > $o ).

tff(pred_def_17654,type,
    v32679: state_type > $o ).

tff(pred_def_17655,type,
    v32700: state_type > $o ).

tff(pred_def_17656,type,
    v32699: state_type > $o ).

tff(pred_def_17657,type,
    v32698: state_type > $o ).

tff(pred_def_17658,type,
    v32704: state_type > $o ).

tff(pred_def_17659,type,
    v32703: state_type > $o ).

tff(pred_def_17660,type,
    v32702: state_type > $o ).

tff(pred_def_17661,type,
    v32635: state_type > $o ).

tff(pred_def_17662,type,
    v32701: state_type > $o ).

tff(pred_def_17663,type,
    v32649: state_type > $o ).

tff(pred_def_17664,type,
    v32647: state_type > $o ).

tff(pred_def_17665,type,
    v32708: state_type > $o ).

tff(pred_def_17666,type,
    v32706: state_type > $o ).

tff(pred_def_17667,type,
    v32715: state_type > $o ).

tff(pred_def_17668,type,
    v32713: state_type > $o ).

tff(pred_def_17669,type,
    v32712: state_type > $o ).

tff(pred_def_17670,type,
    v32711: state_type > $o ).

tff(pred_def_17671,type,
    v32723: state_type > $o ).

tff(pred_def_17672,type,
    v32724: state_type > $o ).

tff(pred_def_17673,type,
    v32722: state_type > $o ).

tff(pred_def_17674,type,
    v32719: state_type > $o ).

tff(pred_def_17675,type,
    v32721: state_type > $o ).

tff(pred_def_17676,type,
    v32637: state_type > $o ).

tff(pred_def_17677,type,
    v32736: state_type > $o ).

tff(pred_def_17678,type,
    v32734: state_type > $o ).

tff(pred_def_17679,type,
    v32740: state_type > $o ).

tff(pred_def_17680,type,
    v32738: state_type > $o ).

tff(pred_def_17681,type,
    v32762: state_type > $o ).

tff(pred_def_17682,type,
    v32760: state_type > $o ).

tff(pred_def_17683,type,
    v32766: state_type > $o ).

tff(pred_def_17684,type,
    v32764: state_type > $o ).

tff(pred_def_17685,type,
    v32778: state_type > $o ).

tff(pred_def_17686,type,
    v32780: state_type > $o ).

tff(pred_def_17687,type,
    v32776: state_type > $o ).

tff(pred_def_17688,type,
    v32783: state_type > $o ).

tff(pred_def_17689,type,
    v32784: state_type > $o ).

tff(pred_def_17690,type,
    v32782: state_type > $o ).

tff(pred_def_17691,type,
    v32788: state_type > $o ).

tff(pred_def_17692,type,
    v32787: state_type > $o ).

tff(pred_def_17693,type,
    v32754: ( state_type * $int ) > $o ).

tff(pred_def_17694,type,
    v32793: state_type > $o ).

tff(pred_def_17695,type,
    v32792: state_type > $o ).

tff(pred_def_17696,type,
    v32791: state_type > $o ).

tff(pred_def_17697,type,
    v32789: state_type > $o ).

tff(pred_def_17698,type,
    v32786: state_type > $o ).

tff(pred_def_17699,type,
    v32798: state_type > $o ).

tff(pred_def_17700,type,
    v32800: state_type > $o ).

tff(pred_def_17701,type,
    v32799: state_type > $o ).

tff(pred_def_17702,type,
    v32797: state_type > $o ).

tff(pred_def_17703,type,
    v32801: state_type > $o ).

tff(pred_def_17704,type,
    v32796: state_type > $o ).

tff(pred_def_17705,type,
    v32804: state_type > $o ).

tff(pred_def_17706,type,
    v32805: state_type > $o ).

tff(pred_def_17707,type,
    v32803: state_type > $o ).

tff(pred_def_17708,type,
    v32806: state_type > $o ).

tff(pred_def_17709,type,
    v32802: state_type > $o ).

tff(pred_def_17710,type,
    v32809: state_type > $o ).

tff(pred_def_17711,type,
    v32810: state_type > $o ).

tff(pred_def_17712,type,
    v32808: state_type > $o ).

tff(pred_def_17713,type,
    v32811: state_type > $o ).

tff(pred_def_17714,type,
    v32807: state_type > $o ).

tff(pred_def_17715,type,
    v32794: ( state_type * $int ) > $o ).

tff(pred_def_17716,type,
    v32785: ( state_type * $int ) > $o ).

tff(pred_def_17717,type,
    v32774: ( state_type * $int ) > $o ).

tff(pred_def_17718,type,
    v32772: ( state_type * $int ) > $o ).

tff(pred_def_17719,type,
    v32813: state_type > $o ).

tff(pred_def_17720,type,
    v32817: state_type > $o ).

tff(pred_def_17721,type,
    v32816: ( state_type * $int ) > $o ).

tff(pred_def_17722,type,
    v32815: ( state_type * $int ) > $o ).

tff(pred_def_17723,type,
    v32770: ( state_type * $int ) > $o ).

tff(pred_def_17724,type,
    v32768: ( state_type * $int ) > $o ).

tff(pred_def_17725,type,
    v32821: state_type > $o ).

tff(pred_def_17726,type,
    v32819: state_type > $o ).

tff(pred_def_17727,type,
    v32828: state_type > $o ).

tff(pred_def_17728,type,
    v32826: state_type > $o ).

tff(pred_def_17729,type,
    v32825: state_type > $o ).

tff(pred_def_17730,type,
    v32824: state_type > $o ).

tff(pred_def_17731,type,
    v32836: state_type > $o ).

tff(pred_def_17732,type,
    v32837: state_type > $o ).

tff(pred_def_17733,type,
    v32835: state_type > $o ).

tff(pred_def_17734,type,
    v32832: ( state_type * $int ) > $o ).

tff(pred_def_17735,type,
    v32834: ( state_type * $int ) > $o ).

tff(pred_def_17736,type,
    v32758: ( state_type * $int ) > $o ).

tff(pred_def_17737,type,
    v32756: ( state_type * $int ) > $o ).

tff(pred_def_17738,type,
    v32728: ( state_type * $int ) > $o ).

tff(pred_def_17739,type,
    v32844: state_type > $o ).

tff(pred_def_17740,type,
    v32843: state_type > $o ).

tff(pred_def_17741,type,
    v32842: state_type > $o ).

tff(pred_def_17742,type,
    v32846: state_type > $o ).

tff(pred_def_17743,type,
    v32841: state_type > $o ).

tff(pred_def_17744,type,
    v32847: state_type > $o ).

tff(pred_def_17745,type,
    v32752: state_type > $o ).

tff(pred_def_17746,type,
    v32859: state_type > $o ).

tff(pred_def_17747,type,
    v32857: state_type > $o ).

tff(pred_def_17748,type,
    v32863: state_type > $o ).

tff(pred_def_17749,type,
    v32861: state_type > $o ).

tff(pred_def_17750,type,
    v32879: ( state_type * $int ) > $o ).

tff(pred_def_17751,type,
    v32881: ( state_type * $int ) > $o ).

tff(pred_def_17752,type,
    v32877: ( state_type * $int ) > $o ).

tff(pred_def_17753,type,
    v32883: ( state_type * $int ) > $o ).

tff(pred_def_17754,type,
    b0011001000000000010100000000100: $int > $o ).

tff(pred_def_17755,type,
    v32885: ( state_type * $int ) > $o ).

tff(pred_def_17756,type,
    v32875: ( state_type * $int ) > $o ).

tff(pred_def_17757,type,
    v32908: state_type > $o ).

tff(pred_def_17758,type,
    v32907: state_type > $o ).

tff(pred_def_17759,type,
    v32906: state_type > $o ).

tff(pred_def_17760,type,
    v32909: state_type > $o ).

tff(pred_def_17761,type,
    v32905: state_type > $o ).

tff(pred_def_17762,type,
    v32904: state_type > $o ).

tff(pred_def_17763,type,
    v32910: state_type > $o ).

tff(pred_def_17764,type,
    v32903: state_type > $o ).

tff(pred_def_17765,type,
    v32902: state_type > $o ).

tff(pred_def_17766,type,
    v32911: state_type > $o ).

tff(pred_def_17767,type,
    v32901: state_type > $o ).

tff(pred_def_17768,type,
    v32900: state_type > $o ).

tff(pred_def_17769,type,
    v32912: state_type > $o ).

tff(pred_def_17770,type,
    v32899: state_type > $o ).

tff(pred_def_17771,type,
    v32898: state_type > $o ).

tff(pred_def_17772,type,
    v32913: state_type > $o ).

tff(pred_def_17773,type,
    v32897: state_type > $o ).

tff(pred_def_17774,type,
    v32896: state_type > $o ).

tff(pred_def_17775,type,
    v32914: state_type > $o ).

tff(pred_def_17776,type,
    v32895: state_type > $o ).

tff(pred_def_17777,type,
    v32894: state_type > $o ).

tff(pred_def_17778,type,
    v32915: state_type > $o ).

tff(pred_def_17779,type,
    v32893: state_type > $o ).

tff(pred_def_17780,type,
    v32892: state_type > $o ).

tff(pred_def_17781,type,
    v32891: state_type > $o ).

tff(pred_def_17782,type,
    v32890: state_type > $o ).

tff(pred_def_17783,type,
    v32917: state_type > $o ).

tff(pred_def_17784,type,
    v32916: state_type > $o ).

tff(pred_def_17785,type,
    v32889: state_type > $o ).

tff(pred_def_17786,type,
    v32920: state_type > $o ).

tff(pred_def_17787,type,
    v32919: state_type > $o ).

tff(pred_def_17788,type,
    v32921: state_type > $o ).

tff(pred_def_17789,type,
    v32918: state_type > $o ).

tff(pred_def_17790,type,
    v32924: state_type > $o ).

tff(pred_def_17791,type,
    v32923: state_type > $o ).

tff(pred_def_17792,type,
    v32925: state_type > $o ).

tff(pred_def_17793,type,
    v32922: state_type > $o ).

tff(pred_def_17794,type,
    v32928: state_type > $o ).

tff(pred_def_17795,type,
    v32927: state_type > $o ).

tff(pred_def_17796,type,
    v32929: state_type > $o ).

tff(pred_def_17797,type,
    v32926: state_type > $o ).

tff(pred_def_17798,type,
    v32932: state_type > $o ).

tff(pred_def_17799,type,
    v32931: state_type > $o ).

tff(pred_def_17800,type,
    v32933: state_type > $o ).

tff(pred_def_17801,type,
    v32930: state_type > $o ).

tff(pred_def_17802,type,
    v32936: state_type > $o ).

tff(pred_def_17803,type,
    v32935: state_type > $o ).

tff(pred_def_17804,type,
    v32937: state_type > $o ).

tff(pred_def_17805,type,
    v32934: state_type > $o ).

tff(pred_def_17806,type,
    v32940: state_type > $o ).

tff(pred_def_17807,type,
    v32939: state_type > $o ).

tff(pred_def_17808,type,
    v32941: state_type > $o ).

tff(pred_def_17809,type,
    v32938: state_type > $o ).

tff(pred_def_17810,type,
    v32944: state_type > $o ).

tff(pred_def_17811,type,
    v32943: state_type > $o ).

tff(pred_def_17812,type,
    v32945: state_type > $o ).

tff(pred_def_17813,type,
    v32942: state_type > $o ).

tff(pred_def_17814,type,
    v32948: state_type > $o ).

tff(pred_def_17815,type,
    v32947: state_type > $o ).

tff(pred_def_17816,type,
    v32949: state_type > $o ).

tff(pred_def_17817,type,
    v32946: state_type > $o ).

tff(pred_def_17818,type,
    v32873: ( state_type * $int ) > $o ).

tff(pred_def_17819,type,
    v32970: state_type > $o ).

tff(pred_def_17820,type,
    v32969: state_type > $o ).

tff(pred_def_17821,type,
    v32968: state_type > $o ).

tff(pred_def_17822,type,
    v32971: state_type > $o ).

tff(pred_def_17823,type,
    v32967: state_type > $o ).

tff(pred_def_17824,type,
    v32966: state_type > $o ).

tff(pred_def_17825,type,
    v32972: state_type > $o ).

tff(pred_def_17826,type,
    v32965: state_type > $o ).

tff(pred_def_17827,type,
    v32964: state_type > $o ).

tff(pred_def_17828,type,
    v32973: state_type > $o ).

tff(pred_def_17829,type,
    v32963: state_type > $o ).

tff(pred_def_17830,type,
    v32962: state_type > $o ).

tff(pred_def_17831,type,
    v32974: state_type > $o ).

tff(pred_def_17832,type,
    v32961: state_type > $o ).

tff(pred_def_17833,type,
    v32960: state_type > $o ).

tff(pred_def_17834,type,
    v32975: state_type > $o ).

tff(pred_def_17835,type,
    v32959: state_type > $o ).

tff(pred_def_17836,type,
    v32958: state_type > $o ).

tff(pred_def_17837,type,
    v32957: state_type > $o ).

tff(pred_def_17838,type,
    v32956: state_type > $o ).

tff(pred_def_17839,type,
    v32977: state_type > $o ).

tff(pred_def_17840,type,
    v32976: state_type > $o ).

tff(pred_def_17841,type,
    v32955: state_type > $o ).

tff(pred_def_17842,type,
    v32980: state_type > $o ).

tff(pred_def_17843,type,
    v32979: state_type > $o ).

tff(pred_def_17844,type,
    v32981: state_type > $o ).

tff(pred_def_17845,type,
    v32978: state_type > $o ).

tff(pred_def_17846,type,
    v32984: state_type > $o ).

tff(pred_def_17847,type,
    v32983: state_type > $o ).

tff(pred_def_17848,type,
    v32985: state_type > $o ).

tff(pred_def_17849,type,
    v32982: state_type > $o ).

tff(pred_def_17850,type,
    v32988: state_type > $o ).

tff(pred_def_17851,type,
    v32987: state_type > $o ).

tff(pred_def_17852,type,
    v32989: state_type > $o ).

tff(pred_def_17853,type,
    v32986: state_type > $o ).

tff(pred_def_17854,type,
    v32992: state_type > $o ).

tff(pred_def_17855,type,
    v32991: state_type > $o ).

tff(pred_def_17856,type,
    v32993: state_type > $o ).

tff(pred_def_17857,type,
    v32990: state_type > $o ).

tff(pred_def_17858,type,
    v32996: state_type > $o ).

tff(pred_def_17859,type,
    v32995: state_type > $o ).

tff(pred_def_17860,type,
    v32997: state_type > $o ).

tff(pred_def_17861,type,
    v32994: state_type > $o ).

tff(pred_def_17862,type,
    v33000: state_type > $o ).

tff(pred_def_17863,type,
    v32999: state_type > $o ).

tff(pred_def_17864,type,
    v33001: state_type > $o ).

tff(pred_def_17865,type,
    v32998: state_type > $o ).

tff(pred_def_17866,type,
    v32953: ( state_type * $int ) > $o ).

tff(pred_def_17867,type,
    v32951: ( state_type * $int ) > $o ).

tff(pred_def_17868,type,
    v33008: state_type > $o ).

tff(pred_def_17869,type,
    v33007: state_type > $o ).

tff(pred_def_17870,type,
    v33009: state_type > $o ).

tff(pred_def_17871,type,
    v33006: state_type > $o ).

tff(pred_def_17872,type,
    v33010: state_type > $o ).

tff(pred_def_17873,type,
    v33004: state_type > $o ).

tff(pred_def_17874,type,
    v33012: state_type > $o ).

tff(pred_def_17875,type,
    v33015: state_type > $o ).

tff(pred_def_17876,type,
    v33014: state_type > $o ).

tff(pred_def_17877,type,
    v33018: state_type > $o ).

tff(pred_def_17878,type,
    v33017: state_type > $o ).

tff(pred_def_17879,type,
    v33021: state_type > $o ).

tff(pred_def_17880,type,
    v33020: state_type > $o ).

tff(pred_def_17881,type,
    b0000000000: $int > $o ).

tff(pred_def_17882,type,
    v32851: ( state_type * $int ) > $o ).

tff(pred_def_17883,type,
    v33023: state_type > $o ).

tff(pred_def_17884,type,
    v33046: state_type > $o ).

tff(pred_def_17885,type,
    v33045: state_type > $o ).

tff(pred_def_17886,type,
    v33044: state_type > $o ).

tff(pred_def_17887,type,
    v33047: state_type > $o ).

tff(pred_def_17888,type,
    v33043: state_type > $o ).

tff(pred_def_17889,type,
    v33042: state_type > $o ).

tff(pred_def_17890,type,
    v33048: state_type > $o ).

tff(pred_def_17891,type,
    v33041: state_type > $o ).

tff(pred_def_17892,type,
    v33040: state_type > $o ).

tff(pred_def_17893,type,
    v33049: state_type > $o ).

tff(pred_def_17894,type,
    v33039: state_type > $o ).

tff(pred_def_17895,type,
    v33038: state_type > $o ).

tff(pred_def_17896,type,
    v33050: state_type > $o ).

tff(pred_def_17897,type,
    v33037: state_type > $o ).

tff(pred_def_17898,type,
    v33036: state_type > $o ).

tff(pred_def_17899,type,
    v33051: state_type > $o ).

tff(pred_def_17900,type,
    v33035: state_type > $o ).

tff(pred_def_17901,type,
    v33034: state_type > $o ).

tff(pred_def_17902,type,
    v33052: state_type > $o ).

tff(pred_def_17903,type,
    v33033: state_type > $o ).

tff(pred_def_17904,type,
    v33032: state_type > $o ).

tff(pred_def_17905,type,
    v33053: state_type > $o ).

tff(pred_def_17906,type,
    v33031: state_type > $o ).

tff(pred_def_17907,type,
    v33030: state_type > $o ).

tff(pred_def_17908,type,
    v33029: state_type > $o ).

tff(pred_def_17909,type,
    v33028: state_type > $o ).

tff(pred_def_17910,type,
    v33055: state_type > $o ).

tff(pred_def_17911,type,
    v33054: state_type > $o ).

tff(pred_def_17912,type,
    v33027: state_type > $o ).

tff(pred_def_17913,type,
    v33058: state_type > $o ).

tff(pred_def_17914,type,
    v33057: state_type > $o ).

tff(pred_def_17915,type,
    v33059: state_type > $o ).

tff(pred_def_17916,type,
    v33056: state_type > $o ).

tff(pred_def_17917,type,
    v33062: state_type > $o ).

tff(pred_def_17918,type,
    v33061: state_type > $o ).

tff(pred_def_17919,type,
    v33063: state_type > $o ).

tff(pred_def_17920,type,
    v33060: state_type > $o ).

tff(pred_def_17921,type,
    v33066: state_type > $o ).

tff(pred_def_17922,type,
    v33065: state_type > $o ).

tff(pred_def_17923,type,
    v33067: state_type > $o ).

tff(pred_def_17924,type,
    v33064: state_type > $o ).

tff(pred_def_17925,type,
    v33070: state_type > $o ).

tff(pred_def_17926,type,
    v33069: state_type > $o ).

tff(pred_def_17927,type,
    v33071: state_type > $o ).

tff(pred_def_17928,type,
    v33068: state_type > $o ).

tff(pred_def_17929,type,
    v33074: state_type > $o ).

tff(pred_def_17930,type,
    v33073: state_type > $o ).

tff(pred_def_17931,type,
    v33075: state_type > $o ).

tff(pred_def_17932,type,
    v33072: state_type > $o ).

tff(pred_def_17933,type,
    v33078: state_type > $o ).

tff(pred_def_17934,type,
    v33077: state_type > $o ).

tff(pred_def_17935,type,
    v33079: state_type > $o ).

tff(pred_def_17936,type,
    v33076: state_type > $o ).

tff(pred_def_17937,type,
    v33082: state_type > $o ).

tff(pred_def_17938,type,
    v33081: state_type > $o ).

tff(pred_def_17939,type,
    v33083: state_type > $o ).

tff(pred_def_17940,type,
    v33080: state_type > $o ).

tff(pred_def_17941,type,
    v33086: state_type > $o ).

tff(pred_def_17942,type,
    v33085: state_type > $o ).

tff(pred_def_17943,type,
    v33087: state_type > $o ).

tff(pred_def_17944,type,
    v33084: state_type > $o ).

tff(pred_def_17945,type,
    v33025: ( state_type * $int ) > $o ).

tff(pred_def_17946,type,
    v33024: ( state_type * $int ) > $o ).

tff(pred_def_17947,type,
    v33022: ( state_type * $int ) > $o ).

tff(pred_def_17948,type,
    b0000001111: $int > $o ).

tff(pred_def_17949,type,
    v33019: ( state_type * $int ) > $o ).

tff(pred_def_17950,type,
    v33016: ( state_type * $int ) > $o ).

tff(pred_def_17951,type,
    v33013: ( state_type * $int ) > $o ).

tff(pred_def_17952,type,
    v32871: ( state_type * $int ) > $o ).

tff(pred_def_17953,type,
    v32869: ( state_type * $int ) > $o ).

tff(pred_def_17954,type,
    v32867: ( state_type * $int ) > $o ).

tff(pred_def_17955,type,
    v32865: ( state_type * $int ) > $o ).

tff(pred_def_17956,type,
    v33092: state_type > $o ).

tff(pred_def_17957,type,
    v33090: state_type > $o ).

tff(pred_def_17958,type,
    v33099: state_type > $o ).

tff(pred_def_17959,type,
    v33097: state_type > $o ).

tff(pred_def_17960,type,
    v33096: state_type > $o ).

tff(pred_def_17961,type,
    v33095: state_type > $o ).

tff(pred_def_17962,type,
    v33107: state_type > $o ).

tff(pred_def_17963,type,
    v33108: state_type > $o ).

tff(pred_def_17964,type,
    v33106: state_type > $o ).

tff(pred_def_17965,type,
    v33103: ( state_type * $int ) > $o ).

tff(pred_def_17966,type,
    bxxxxxxxxxx: $int > $o ).

tff(pred_def_17967,type,
    v33105: ( state_type * $int ) > $o ).

tff(pred_def_17968,type,
    v32855: ( state_type * $int ) > $o ).

tff(pred_def_17969,type,
    v32853: ( state_type * $int ) > $o ).

tff(pred_def_17970,type,
    v33112: state_type > $o ).

tff(pred_def_17971,type,
    v33113: state_type > $o ).

tff(pred_def_17972,type,
    v32849: state_type > $o ).

tff(pred_def_17973,type,
    v33115: state_type > $o ).

tff(pred_def_17974,type,
    v33118: ( state_type * $int ) > $o ).

tff(pred_def_17975,type,
    v33120: state_type > $o ).

tff(pred_def_17976,type,
    b01: $int > $o ).

tff(pred_def_17977,type,
    v33119: ( state_type * $int ) > $o ).

tff(pred_def_17978,type,
    v32575: state_type > $o ).

tff(pred_def_17979,type,
    v33117: ( state_type * $int ) > $o ).

tff(pred_def_17980,type,
    v32750: state_type > $o ).

tff(pred_def_17981,type,
    v33116: ( state_type * $int ) > $o ).

tff(pred_def_17982,type,
    v33114: ( state_type * $int ) > $o ).

tff(pred_def_17983,type,
    v32748: ( state_type * $int ) > $o ).

tff(pred_def_17984,type,
    v32746: ( state_type * $int ) > $o ).

tff(pred_def_17985,type,
    v33131: state_type > $o ).

tff(pred_def_17986,type,
    v33130: state_type > $o ).

tff(pred_def_17987,type,
    v33129: state_type > $o ).

tff(pred_def_17988,type,
    v33128: state_type > $o ).

tff(pred_def_17989,type,
    v33127: state_type > $o ).

tff(pred_def_17990,type,
    b0100001100000: $int > $o ).

tff(pred_def_17991,type,
    v33133: state_type > $o ).

tff(pred_def_17992,type,
    v33132: state_type > $o ).

tff(pred_def_17993,type,
    v33124: state_type > $o ).

tff(pred_def_17994,type,
    v33122: state_type > $o ).

tff(pred_def_17995,type,
    v33137: state_type > $o ).

tff(pred_def_17996,type,
    v33136: ( state_type * $int ) > $o ).

tff(pred_def_17997,type,
    v33135: ( state_type * $int ) > $o ).

tff(pred_def_17998,type,
    v33141: state_type > $o ).

tff(pred_def_17999,type,
    v33140: ( state_type * $int ) > $o ).

tff(pred_def_18000,type,
    v33139: ( state_type * $int ) > $o ).

tff(pred_def_18001,type,
    v32730: ( state_type * $int ) > $o ).

tff(pred_def_18002,type,
    v33138: ( state_type * $int ) > $o ).

tff(pred_def_18003,type,
    v33134: ( state_type * $int ) > $o ).

tff(pred_def_18004,type,
    v32744: ( state_type * $int ) > $o ).

tff(pred_def_18005,type,
    v32742: ( state_type * $int ) > $o ).

tff(pred_def_18006,type,
    v33145: state_type > $o ).

tff(pred_def_18007,type,
    v33143: state_type > $o ).

tff(pred_def_18008,type,
    v33152: state_type > $o ).

tff(pred_def_18009,type,
    v33150: state_type > $o ).

tff(pred_def_18010,type,
    v33149: state_type > $o ).

tff(pred_def_18011,type,
    v33148: state_type > $o ).

tff(pred_def_18012,type,
    v33160: state_type > $o ).

tff(pred_def_18013,type,
    v33161: state_type > $o ).

tff(pred_def_18014,type,
    v33159: state_type > $o ).

tff(pred_def_18015,type,
    v33156: ( state_type * $int ) > $o ).

tff(pred_def_18016,type,
    v33158: ( state_type * $int ) > $o ).

tff(pred_def_18017,type,
    v33147: ( state_type * $int ) > $o ).

tff(pred_def_18018,type,
    v32732: ( state_type * $int ) > $o ).

tff(pred_def_18019,type,
    v33168: state_type > $o ).

tff(pred_def_18020,type,
    v33167: state_type > $o ).

tff(pred_def_18021,type,
    v33166: state_type > $o ).

tff(pred_def_18022,type,
    v33169: state_type > $o ).

tff(pred_def_18023,type,
    v33165: state_type > $o ).

tff(pred_def_18024,type,
    v30943: ( state_type * $int ) > $o ).

tff(pred_def_18025,type,
    v33170: state_type > $o ).

tff(pred_def_18026,type,
    v33176: state_type > $o ).

tff(pred_def_18027,type,
    v33174: state_type > $o ).

tff(pred_def_18028,type,
    v33173: state_type > $o ).

tff(pred_def_18029,type,
    v33172: ( state_type * $int ) > $o ).

tff(pred_def_18030,type,
    v33188: state_type > $o ).

tff(pred_def_18031,type,
    v33186: state_type > $o ).

tff(pred_def_18032,type,
    v33192: state_type > $o ).

tff(pred_def_18033,type,
    v33190: state_type > $o ).

tff(pred_def_18034,type,
    v33204: state_type > $o ).

tff(pred_def_18035,type,
    v33180: ( state_type * $int ) > $o ).

tff(pred_def_18036,type,
    v33211: state_type > $o ).

tff(pred_def_18037,type,
    v33210: state_type > $o ).

tff(pred_def_18038,type,
    v33209: state_type > $o ).

tff(pred_def_18039,type,
    v33213: state_type > $o ).

tff(pred_def_18040,type,
    v33207: state_type > $o ).

tff(pred_def_18041,type,
    v33217: state_type > $o ).

tff(pred_def_18042,type,
    v33218: state_type > $o ).

tff(pred_def_18043,type,
    v33215: state_type > $o ).

tff(pred_def_18044,type,
    v33220: state_type > $o ).

tff(pred_def_18045,type,
    v33223: ( state_type * $int ) > $o ).

tff(pred_def_18046,type,
    v33225: state_type > $o ).

tff(pred_def_18047,type,
    v33224: ( state_type * $int ) > $o ).

tff(pred_def_18048,type,
    v33222: ( state_type * $int ) > $o ).

tff(pred_def_18049,type,
    v33202: state_type > $o ).

tff(pred_def_18050,type,
    v33221: ( state_type * $int ) > $o ).

tff(pred_def_18051,type,
    v33219: ( state_type * $int ) > $o ).

tff(pred_def_18052,type,
    v33200: ( state_type * $int ) > $o ).

tff(pred_def_18053,type,
    v33198: ( state_type * $int ) > $o ).

tff(pred_def_18054,type,
    v33236: state_type > $o ).

tff(pred_def_18055,type,
    v33235: state_type > $o ).

tff(pred_def_18056,type,
    v33234: state_type > $o ).

tff(pred_def_18057,type,
    v33233: state_type > $o ).

tff(pred_def_18058,type,
    v33232: state_type > $o ).

tff(pred_def_18059,type,
    b0100001110000: $int > $o ).

tff(pred_def_18060,type,
    v33238: state_type > $o ).

tff(pred_def_18061,type,
    v33237: state_type > $o ).

tff(pred_def_18062,type,
    v33229: state_type > $o ).

tff(pred_def_18063,type,
    v33227: state_type > $o ).

tff(pred_def_18064,type,
    v33242: state_type > $o ).

tff(pred_def_18065,type,
    v33241: ( state_type * $int ) > $o ).

tff(pred_def_18066,type,
    v33240: ( state_type * $int ) > $o ).

tff(pred_def_18067,type,
    v33246: state_type > $o ).

tff(pred_def_18068,type,
    v33245: ( state_type * $int ) > $o ).

tff(pred_def_18069,type,
    v33244: ( state_type * $int ) > $o ).

tff(pred_def_18070,type,
    v33182: ( state_type * $int ) > $o ).

tff(pred_def_18071,type,
    v33243: ( state_type * $int ) > $o ).

tff(pred_def_18072,type,
    v33239: ( state_type * $int ) > $o ).

tff(pred_def_18073,type,
    v33196: ( state_type * $int ) > $o ).

tff(pred_def_18074,type,
    v33194: ( state_type * $int ) > $o ).

tff(pred_def_18075,type,
    v33250: state_type > $o ).

tff(pred_def_18076,type,
    v33248: state_type > $o ).

tff(pred_def_18077,type,
    v33257: state_type > $o ).

tff(pred_def_18078,type,
    v33255: state_type > $o ).

tff(pred_def_18079,type,
    v33254: state_type > $o ).

tff(pred_def_18080,type,
    v33253: state_type > $o ).

tff(pred_def_18081,type,
    v33265: state_type > $o ).

tff(pred_def_18082,type,
    v33266: state_type > $o ).

tff(pred_def_18083,type,
    v33264: state_type > $o ).

tff(pred_def_18084,type,
    v33261: ( state_type * $int ) > $o ).

tff(pred_def_18085,type,
    v33263: ( state_type * $int ) > $o ).

tff(pred_def_18086,type,
    v33252: ( state_type * $int ) > $o ).

tff(pred_def_18087,type,
    v33184: ( state_type * $int ) > $o ).

tff(pred_def_18088,type,
    v33278: state_type > $o ).

tff(pred_def_18089,type,
    v33276: state_type > $o ).

tff(pred_def_18090,type,
    v33282: state_type > $o ).

tff(pred_def_18091,type,
    v33280: state_type > $o ).

tff(pred_def_18092,type,
    v33302: state_type > $o ).

tff(pred_def_18093,type,
    v33300: state_type > $o ).

tff(pred_def_18094,type,
    v33306: state_type > $o ).

tff(pred_def_18095,type,
    v33304: state_type > $o ).

tff(pred_def_18096,type,
    v33316: ( state_type * $int ) > $o ).

tff(pred_def_18097,type,
    v33314: ( state_type * $int ) > $o ).

tff(pred_def_18098,type,
    v33312: ( state_type * $int ) > $o ).

tff(pred_def_18099,type,
    b0100001111000: $int > $o ).

tff(pred_def_18100,type,
    v33324: state_type > $o ).

tff(pred_def_18101,type,
    v33321: state_type > $o ).

tff(pred_def_18102,type,
    v33319: state_type > $o ).

tff(pred_def_18103,type,
    v33328: state_type > $o ).

tff(pred_def_18104,type,
    v33327: ( state_type * $int ) > $o ).

tff(pred_def_18105,type,
    v33326: ( state_type * $int ) > $o ).

tff(pred_def_18106,type,
    v33332: state_type > $o ).

tff(pred_def_18107,type,
    v33331: ( state_type * $int ) > $o ).

tff(pred_def_18108,type,
    v33330: ( state_type * $int ) > $o ).

tff(pred_def_18109,type,
    v33296: ( state_type * $int ) > $o ).

tff(pred_def_18110,type,
    v33329: ( state_type * $int ) > $o ).

tff(pred_def_18111,type,
    v33310: ( state_type * $int ) > $o ).

tff(pred_def_18112,type,
    v33308: ( state_type * $int ) > $o ).

tff(pred_def_18113,type,
    v33336: state_type > $o ).

tff(pred_def_18114,type,
    v33334: state_type > $o ).

tff(pred_def_18115,type,
    v33343: state_type > $o ).

tff(pred_def_18116,type,
    v33341: state_type > $o ).

tff(pred_def_18117,type,
    v33340: state_type > $o ).

tff(pred_def_18118,type,
    v33339: state_type > $o ).

tff(pred_def_18119,type,
    v33351: state_type > $o ).

tff(pred_def_18120,type,
    v33352: state_type > $o ).

tff(pred_def_18121,type,
    v33350: state_type > $o ).

tff(pred_def_18122,type,
    v33347: ( state_type * $int ) > $o ).

tff(pred_def_18123,type,
    v33349: ( state_type * $int ) > $o ).

tff(pred_def_18124,type,
    v33298: ( state_type * $int ) > $o ).

tff(pred_def_18125,type,
    v33294: ( state_type * $int ) > $o ).

tff(pred_def_18126,type,
    v33292: ( state_type * $int ) > $o ).

tff(pred_def_18127,type,
    b00000000: $int > $o ).

tff(pred_def_18128,type,
    v33270: ( state_type * $int ) > $o ).

tff(pred_def_18129,type,
    v33359: state_type > $o ).

tff(pred_def_18130,type,
    v33377: state_type > $o ).

tff(pred_def_18131,type,
    v33376: state_type > $o ).

tff(pred_def_18132,type,
    v33375: state_type > $o ).

tff(pred_def_18133,type,
    v33378: state_type > $o ).

tff(pred_def_18134,type,
    v33374: state_type > $o ).

tff(pred_def_18135,type,
    v33373: state_type > $o ).

tff(pred_def_18136,type,
    v33379: state_type > $o ).

tff(pred_def_18137,type,
    v33372: state_type > $o ).

tff(pred_def_18138,type,
    v33371: state_type > $o ).

tff(pred_def_18139,type,
    v33380: state_type > $o ).

tff(pred_def_18140,type,
    v33370: state_type > $o ).

tff(pred_def_18141,type,
    v33369: state_type > $o ).

tff(pred_def_18142,type,
    v33381: state_type > $o ).

tff(pred_def_18143,type,
    v33368: state_type > $o ).

tff(pred_def_18144,type,
    v33367: state_type > $o ).

tff(pred_def_18145,type,
    v33382: state_type > $o ).

tff(pred_def_18146,type,
    v33366: state_type > $o ).

tff(pred_def_18147,type,
    v33365: state_type > $o ).

tff(pred_def_18148,type,
    v33364: state_type > $o ).

tff(pred_def_18149,type,
    v33363: state_type > $o ).

tff(pred_def_18150,type,
    v33384: state_type > $o ).

tff(pred_def_18151,type,
    v33383: state_type > $o ).

tff(pred_def_18152,type,
    v33362: state_type > $o ).

tff(pred_def_18153,type,
    v33387: state_type > $o ).

tff(pred_def_18154,type,
    v33386: state_type > $o ).

tff(pred_def_18155,type,
    v33388: state_type > $o ).

tff(pred_def_18156,type,
    v33385: state_type > $o ).

tff(pred_def_18157,type,
    v33391: state_type > $o ).

tff(pred_def_18158,type,
    v33390: state_type > $o ).

tff(pred_def_18159,type,
    v33392: state_type > $o ).

tff(pred_def_18160,type,
    v33389: state_type > $o ).

tff(pred_def_18161,type,
    v33395: state_type > $o ).

tff(pred_def_18162,type,
    v33394: state_type > $o ).

tff(pred_def_18163,type,
    v33396: state_type > $o ).

tff(pred_def_18164,type,
    v33393: state_type > $o ).

tff(pred_def_18165,type,
    v33399: state_type > $o ).

tff(pred_def_18166,type,
    v33398: state_type > $o ).

tff(pred_def_18167,type,
    v33400: state_type > $o ).

tff(pred_def_18168,type,
    v33397: state_type > $o ).

tff(pred_def_18169,type,
    v33403: state_type > $o ).

tff(pred_def_18170,type,
    v33402: state_type > $o ).

tff(pred_def_18171,type,
    v33404: state_type > $o ).

tff(pred_def_18172,type,
    v33401: state_type > $o ).

tff(pred_def_18173,type,
    v33407: state_type > $o ).

tff(pred_def_18174,type,
    v33406: state_type > $o ).

tff(pred_def_18175,type,
    v33408: state_type > $o ).

tff(pred_def_18176,type,
    v33405: state_type > $o ).

tff(pred_def_18177,type,
    v33360: ( state_type * $int ) > $o ).

tff(pred_def_18178,type,
    v33358: ( state_type * $int ) > $o ).

tff(pred_def_18179,type,
    v33357: ( state_type * $int ) > $o ).

tff(pred_def_18180,type,
    v33411: state_type > $o ).

tff(pred_def_18181,type,
    v33410: state_type > $o ).

tff(pred_def_18182,type,
    v33409: ( state_type * $int ) > $o ).

tff(pred_def_18183,type,
    v33290: ( state_type * $int ) > $o ).

tff(pred_def_18184,type,
    v33288: ( state_type * $int ) > $o ).

tff(pred_def_18185,type,
    v33286: ( state_type * $int ) > $o ).

tff(pred_def_18186,type,
    v33284: ( state_type * $int ) > $o ).

tff(pred_def_18187,type,
    v33415: state_type > $o ).

tff(pred_def_18188,type,
    v33413: state_type > $o ).

tff(pred_def_18189,type,
    v33422: state_type > $o ).

tff(pred_def_18190,type,
    v33420: state_type > $o ).

tff(pred_def_18191,type,
    v33419: state_type > $o ).

tff(pred_def_18192,type,
    v33418: state_type > $o ).

tff(pred_def_18193,type,
    v33430: state_type > $o ).

tff(pred_def_18194,type,
    v33431: state_type > $o ).

tff(pred_def_18195,type,
    v33429: state_type > $o ).

tff(pred_def_18196,type,
    v33426: ( state_type * $int ) > $o ).

tff(pred_def_18197,type,
    v33428: ( state_type * $int ) > $o ).

tff(pred_def_18198,type,
    v33274: ( state_type * $int ) > $o ).

tff(pred_def_18199,type,
    v33272: ( state_type * $int ) > $o ).

tff(pred_def_18200,type,
    v33437: state_type > $o ).

tff(pred_def_18201,type,
    v33436: state_type > $o ).

tff(pred_def_18202,type,
    v33435: state_type > $o ).

tff(pred_def_18203,type,
    v33438: state_type > $o ).

tff(pred_def_18204,type,
    v33444: state_type > $o ).

tff(pred_def_18205,type,
    v33442: state_type > $o ).

tff(pred_def_18206,type,
    v33441: state_type > $o ).

tff(pred_def_18207,type,
    v33440: ( state_type * $int ) > $o ).

tff(pred_def_18208,type,
    v33456: state_type > $o ).

tff(pred_def_18209,type,
    v33454: state_type > $o ).

tff(pred_def_18210,type,
    v33460: state_type > $o ).

tff(pred_def_18211,type,
    v33458: state_type > $o ).

tff(pred_def_18212,type,
    v33472: state_type > $o ).

tff(pred_def_18213,type,
    v33448: ( state_type * $int ) > $o ).

tff(pred_def_18214,type,
    v33479: state_type > $o ).

tff(pred_def_18215,type,
    v33478: state_type > $o ).

tff(pred_def_18216,type,
    v33477: state_type > $o ).

tff(pred_def_18217,type,
    v33481: state_type > $o ).

tff(pred_def_18218,type,
    v33475: state_type > $o ).

tff(pred_def_18219,type,
    v33485: state_type > $o ).

tff(pred_def_18220,type,
    v33486: state_type > $o ).

tff(pred_def_18221,type,
    v33483: state_type > $o ).

tff(pred_def_18222,type,
    v33488: state_type > $o ).

tff(pred_def_18223,type,
    v33491: ( state_type * $int ) > $o ).

tff(pred_def_18224,type,
    v33493: state_type > $o ).

tff(pred_def_18225,type,
    v33492: ( state_type * $int ) > $o ).

tff(pred_def_18226,type,
    v33490: ( state_type * $int ) > $o ).

tff(pred_def_18227,type,
    v33470: state_type > $o ).

tff(pred_def_18228,type,
    v33489: ( state_type * $int ) > $o ).

tff(pred_def_18229,type,
    v33487: ( state_type * $int ) > $o ).

tff(pred_def_18230,type,
    v33468: ( state_type * $int ) > $o ).

tff(pred_def_18231,type,
    v33466: ( state_type * $int ) > $o ).

tff(pred_def_18232,type,
    v33503: state_type > $o ).

tff(pred_def_18233,type,
    v33502: state_type > $o ).

tff(pred_def_18234,type,
    v33501: state_type > $o ).

tff(pred_def_18235,type,
    v33500: state_type > $o ).

tff(pred_def_18236,type,
    v33499: state_type > $o ).

tff(pred_def_18237,type,
    v33505: state_type > $o ).

tff(pred_def_18238,type,
    v33504: state_type > $o ).

tff(pred_def_18239,type,
    v33497: state_type > $o ).

tff(pred_def_18240,type,
    v33495: state_type > $o ).

tff(pred_def_18241,type,
    v33509: state_type > $o ).

tff(pred_def_18242,type,
    v33508: ( state_type * $int ) > $o ).

tff(pred_def_18243,type,
    v33507: ( state_type * $int ) > $o ).

tff(pred_def_18244,type,
    v33513: state_type > $o ).

tff(pred_def_18245,type,
    v33512: ( state_type * $int ) > $o ).

tff(pred_def_18246,type,
    v33511: ( state_type * $int ) > $o ).

tff(pred_def_18247,type,
    v33450: ( state_type * $int ) > $o ).

tff(pred_def_18248,type,
    v33510: ( state_type * $int ) > $o ).

tff(pred_def_18249,type,
    v33506: ( state_type * $int ) > $o ).

tff(pred_def_18250,type,
    v33464: ( state_type * $int ) > $o ).

tff(pred_def_18251,type,
    v33462: ( state_type * $int ) > $o ).

tff(pred_def_18252,type,
    v33517: state_type > $o ).

tff(pred_def_18253,type,
    v33515: state_type > $o ).

tff(pred_def_18254,type,
    v33524: state_type > $o ).

tff(pred_def_18255,type,
    v33522: state_type > $o ).

tff(pred_def_18256,type,
    v33521: state_type > $o ).

tff(pred_def_18257,type,
    v33520: state_type > $o ).

tff(pred_def_18258,type,
    v33532: state_type > $o ).

tff(pred_def_18259,type,
    v33533: state_type > $o ).

tff(pred_def_18260,type,
    v33531: state_type > $o ).

tff(pred_def_18261,type,
    v33528: ( state_type * $int ) > $o ).

tff(pred_def_18262,type,
    v33530: ( state_type * $int ) > $o ).

tff(pred_def_18263,type,
    v33519: ( state_type * $int ) > $o ).

tff(pred_def_18264,type,
    v33452: ( state_type * $int ) > $o ).

tff(pred_def_18265,type,
    v33545: state_type > $o ).

tff(pred_def_18266,type,
    v33543: state_type > $o ).

tff(pred_def_18267,type,
    v33549: state_type > $o ).

tff(pred_def_18268,type,
    v33547: state_type > $o ).

tff(pred_def_18269,type,
    v33569: state_type > $o ).

tff(pred_def_18270,type,
    v33567: state_type > $o ).

tff(pred_def_18271,type,
    v33573: state_type > $o ).

tff(pred_def_18272,type,
    v33571: state_type > $o ).

tff(pred_def_18273,type,
    v33583: ( state_type * $int ) > $o ).

tff(pred_def_18274,type,
    v33581: ( state_type * $int ) > $o ).

tff(pred_def_18275,type,
    v33579: ( state_type * $int ) > $o ).

tff(pred_def_18276,type,
    b0100010001000: $int > $o ).

tff(pred_def_18277,type,
    v33591: state_type > $o ).

tff(pred_def_18278,type,
    v33588: state_type > $o ).

tff(pred_def_18279,type,
    v33586: state_type > $o ).

tff(pred_def_18280,type,
    v33595: state_type > $o ).

tff(pred_def_18281,type,
    v33594: ( state_type * $int ) > $o ).

tff(pred_def_18282,type,
    v33593: ( state_type * $int ) > $o ).

tff(pred_def_18283,type,
    v33599: state_type > $o ).

tff(pred_def_18284,type,
    v33598: ( state_type * $int ) > $o ).

tff(pred_def_18285,type,
    v33597: ( state_type * $int ) > $o ).

tff(pred_def_18286,type,
    v33563: ( state_type * $int ) > $o ).

tff(pred_def_18287,type,
    v33596: ( state_type * $int ) > $o ).

tff(pred_def_18288,type,
    v33577: ( state_type * $int ) > $o ).

tff(pred_def_18289,type,
    v33575: ( state_type * $int ) > $o ).

tff(pred_def_18290,type,
    v33603: state_type > $o ).

tff(pred_def_18291,type,
    v33601: state_type > $o ).

tff(pred_def_18292,type,
    v33610: state_type > $o ).

tff(pred_def_18293,type,
    v33608: state_type > $o ).

tff(pred_def_18294,type,
    v33607: state_type > $o ).

tff(pred_def_18295,type,
    v33606: state_type > $o ).

tff(pred_def_18296,type,
    v33618: state_type > $o ).

tff(pred_def_18297,type,
    v33619: state_type > $o ).

tff(pred_def_18298,type,
    v33617: state_type > $o ).

tff(pred_def_18299,type,
    v33614: ( state_type * $int ) > $o ).

tff(pred_def_18300,type,
    v33616: ( state_type * $int ) > $o ).

tff(pred_def_18301,type,
    v33565: ( state_type * $int ) > $o ).

tff(pred_def_18302,type,
    v33561: ( state_type * $int ) > $o ).

tff(pred_def_18303,type,
    v33559: ( state_type * $int ) > $o ).

tff(pred_def_18304,type,
    v33537: ( state_type * $int ) > $o ).

tff(pred_def_18305,type,
    v33626: state_type > $o ).

tff(pred_def_18306,type,
    v33644: state_type > $o ).

tff(pred_def_18307,type,
    v33643: state_type > $o ).

tff(pred_def_18308,type,
    v33642: state_type > $o ).

tff(pred_def_18309,type,
    v33645: state_type > $o ).

tff(pred_def_18310,type,
    v33641: state_type > $o ).

tff(pred_def_18311,type,
    v33640: state_type > $o ).

tff(pred_def_18312,type,
    v33646: state_type > $o ).

tff(pred_def_18313,type,
    v33639: state_type > $o ).

tff(pred_def_18314,type,
    v33638: state_type > $o ).

tff(pred_def_18315,type,
    v33647: state_type > $o ).

tff(pred_def_18316,type,
    v33637: state_type > $o ).

tff(pred_def_18317,type,
    v33636: state_type > $o ).

tff(pred_def_18318,type,
    v33648: state_type > $o ).

tff(pred_def_18319,type,
    v33635: state_type > $o ).

tff(pred_def_18320,type,
    v33634: state_type > $o ).

tff(pred_def_18321,type,
    v33649: state_type > $o ).

tff(pred_def_18322,type,
    v33633: state_type > $o ).

tff(pred_def_18323,type,
    v33632: state_type > $o ).

tff(pred_def_18324,type,
    v33631: state_type > $o ).

tff(pred_def_18325,type,
    v33630: state_type > $o ).

tff(pred_def_18326,type,
    v33651: state_type > $o ).

tff(pred_def_18327,type,
    v33650: state_type > $o ).

tff(pred_def_18328,type,
    v33629: state_type > $o ).

tff(pred_def_18329,type,
    v33654: state_type > $o ).

tff(pred_def_18330,type,
    v33653: state_type > $o ).

tff(pred_def_18331,type,
    v33655: state_type > $o ).

tff(pred_def_18332,type,
    v33652: state_type > $o ).

tff(pred_def_18333,type,
    v33658: state_type > $o ).

tff(pred_def_18334,type,
    v33657: state_type > $o ).

tff(pred_def_18335,type,
    v33659: state_type > $o ).

tff(pred_def_18336,type,
    v33656: state_type > $o ).

tff(pred_def_18337,type,
    v33662: state_type > $o ).

tff(pred_def_18338,type,
    v33661: state_type > $o ).

tff(pred_def_18339,type,
    v33663: state_type > $o ).

tff(pred_def_18340,type,
    v33660: state_type > $o ).

tff(pred_def_18341,type,
    v33666: state_type > $o ).

tff(pred_def_18342,type,
    v33665: state_type > $o ).

tff(pred_def_18343,type,
    v33667: state_type > $o ).

tff(pred_def_18344,type,
    v33664: state_type > $o ).

tff(pred_def_18345,type,
    v33670: state_type > $o ).

tff(pred_def_18346,type,
    v33669: state_type > $o ).

tff(pred_def_18347,type,
    v33671: state_type > $o ).

tff(pred_def_18348,type,
    v33668: state_type > $o ).

tff(pred_def_18349,type,
    v33674: state_type > $o ).

tff(pred_def_18350,type,
    v33673: state_type > $o ).

tff(pred_def_18351,type,
    v33675: state_type > $o ).

tff(pred_def_18352,type,
    v33672: state_type > $o ).

tff(pred_def_18353,type,
    v33627: ( state_type * $int ) > $o ).

tff(pred_def_18354,type,
    v33625: ( state_type * $int ) > $o ).

tff(pred_def_18355,type,
    v33624: ( state_type * $int ) > $o ).

tff(pred_def_18356,type,
    v33677: state_type > $o ).

tff(pred_def_18357,type,
    v33676: ( state_type * $int ) > $o ).

tff(pred_def_18358,type,
    v33557: ( state_type * $int ) > $o ).

tff(pred_def_18359,type,
    v33555: ( state_type * $int ) > $o ).

tff(pred_def_18360,type,
    v33553: ( state_type * $int ) > $o ).

tff(pred_def_18361,type,
    v33551: ( state_type * $int ) > $o ).

tff(pred_def_18362,type,
    v33681: state_type > $o ).

tff(pred_def_18363,type,
    v33679: state_type > $o ).

tff(pred_def_18364,type,
    v33688: state_type > $o ).

tff(pred_def_18365,type,
    v33686: state_type > $o ).

tff(pred_def_18366,type,
    v33685: state_type > $o ).

tff(pred_def_18367,type,
    v33684: state_type > $o ).

tff(pred_def_18368,type,
    v33696: state_type > $o ).

tff(pred_def_18369,type,
    v33697: state_type > $o ).

tff(pred_def_18370,type,
    v33695: state_type > $o ).

tff(pred_def_18371,type,
    v33692: ( state_type * $int ) > $o ).

tff(pred_def_18372,type,
    v33694: ( state_type * $int ) > $o ).

tff(pred_def_18373,type,
    v33541: ( state_type * $int ) > $o ).

tff(pred_def_18374,type,
    v33539: ( state_type * $int ) > $o ).

tff(pred_def_18375,type,
    v33703: state_type > $o ).

tff(pred_def_18376,type,
    v33702: state_type > $o ).

tff(pred_def_18377,type,
    v33701: state_type > $o ).

tff(pred_def_18378,type,
    v33704: state_type > $o ).

tff(pred_def_18379,type,
    v33710: state_type > $o ).

tff(pred_def_18380,type,
    v33708: state_type > $o ).

tff(pred_def_18381,type,
    v33707: state_type > $o ).

tff(pred_def_18382,type,
    v33706: ( state_type * $int ) > $o ).

tff(pred_def_18383,type,
    v33724: state_type > $o ).

tff(pred_def_18384,type,
    v33722: state_type > $o ).

tff(pred_def_18385,type,
    v33728: state_type > $o ).

tff(pred_def_18386,type,
    v33726: state_type > $o ).

tff(pred_def_18387,type,
    v33716: ( state_type * $int ) > $o ).

tff(pred_def_18388,type,
    v33741: state_type > $o ).

tff(pred_def_18389,type,
    v33739: state_type > $o ).

tff(pred_def_18390,type,
    v4516: state_type > $o ).

tff(pred_def_18391,type,
    v33738: state_type > $o ).

tff(pred_def_18392,type,
    v33746: state_type > $o ).

tff(pred_def_18393,type,
    v33748: state_type > $o ).

tff(pred_def_18394,type,
    v33747: state_type > $o ).

tff(pred_def_18395,type,
    v33745: state_type > $o ).

tff(pred_def_18396,type,
    v33749: state_type > $o ).

tff(pred_def_18397,type,
    v33744: state_type > $o ).

tff(pred_def_18398,type,
    v33752: state_type > $o ).

tff(pred_def_18399,type,
    v33753: state_type > $o ).

tff(pred_def_18400,type,
    v33751: state_type > $o ).

tff(pred_def_18401,type,
    v33750: state_type > $o ).

tff(pred_def_18402,type,
    v33742: ( state_type * $int ) > $o ).

tff(pred_def_18403,type,
    v33736: ( state_type * $int ) > $o ).

tff(pred_def_18404,type,
    v33734: ( state_type * $int ) > $o ).

tff(pred_def_18405,type,
    v33732: ( state_type * $int ) > $o ).

tff(pred_def_18406,type,
    v33730: ( state_type * $int ) > $o ).

tff(pred_def_18407,type,
    v33757: state_type > $o ).

tff(pred_def_18408,type,
    v33755: state_type > $o ).

tff(pred_def_18409,type,
    v33764: state_type > $o ).

tff(pred_def_18410,type,
    v33762: state_type > $o ).

tff(pred_def_18411,type,
    v33761: state_type > $o ).

tff(pred_def_18412,type,
    v33760: state_type > $o ).

tff(pred_def_18413,type,
    v33772: state_type > $o ).

tff(pred_def_18414,type,
    v33773: state_type > $o ).

tff(pred_def_18415,type,
    v33771: state_type > $o ).

tff(pred_def_18416,type,
    v33768: ( state_type * $int ) > $o ).

tff(pred_def_18417,type,
    v33770: ( state_type * $int ) > $o ).

tff(pred_def_18418,type,
    v33720: ( state_type * $int ) > $o ).

tff(pred_def_18419,type,
    v33718: ( state_type * $int ) > $o ).

tff(pred_def_18420,type,
    v33714: state_type > $o ).

tff(pred_def_18421,type,
    v33788: state_type > $o ).

tff(pred_def_18422,type,
    v33786: state_type > $o ).

tff(pred_def_18423,type,
    v33792: state_type > $o ).

tff(pred_def_18424,type,
    v33790: state_type > $o ).

tff(pred_def_18425,type,
    v33806: state_type > $o ).

tff(pred_def_18426,type,
    v33807: state_type > $o ).

tff(pred_def_18427,type,
    v33805: state_type > $o ).

tff(pred_def_18428,type,
    v33780: state_type > $o ).

tff(pred_def_18429,type,
    v33808: state_type > $o ).

tff(pred_def_18430,type,
    v33804: state_type > $o ).

tff(pred_def_18431,type,
    v33802: state_type > $o ).

tff(pred_def_18432,type,
    v33820: state_type > $o ).

tff(pred_def_18433,type,
    v33818: state_type > $o ).

tff(pred_def_18434,type,
    v33824: state_type > $o ).

tff(pred_def_18435,type,
    v33822: state_type > $o ).

tff(pred_def_18436,type,
    v6240: ( state_type * $int ) > $o ).

tff(pred_def_18437,type,
    v8510: ( state_type * $int ) > $o ).

tff(pred_def_18438,type,
    v6238: ( state_type * $int ) > $o ).

tff(pred_def_18439,type,
    v33834: ( state_type * $int ) > $o ).

tff(pred_def_18440,type,
    v33841: ( state_type * $int ) > $o ).

tff(pred_def_18441,type,
    v33839: ( state_type * $int ) > $o ).

tff(pred_def_18442,type,
    v33837: ( state_type * $int ) > $o ).

tff(pred_def_18443,type,
    b000000000000000000000000000000000000: $int > $o ).

tff(pred_def_18444,type,
    v33845: state_type > $o ).

tff(pred_def_18445,type,
    v33844: state_type > $o ).

tff(pred_def_18446,type,
    v33846: state_type > $o ).

tff(pred_def_18447,type,
    v33843: state_type > $o ).

tff(pred_def_18448,type,
    v33812: ( state_type * $int ) > $o ).

tff(pred_def_18449,type,
    v33852: state_type > $o ).

tff(pred_def_18450,type,
    v33851: state_type > $o ).

tff(pred_def_18451,type,
    v33853: state_type > $o ).

tff(pred_def_18452,type,
    v33850: state_type > $o ).

tff(pred_def_18453,type,
    v33854: state_type > $o ).

tff(pred_def_18454,type,
    v33849: state_type > $o ).

tff(pred_def_18455,type,
    v33857: state_type > $o ).

tff(pred_def_18456,type,
    v33858: state_type > $o ).

tff(pred_def_18457,type,
    v33856: state_type > $o ).

tff(pred_def_18458,type,
    v33859: state_type > $o ).

tff(pred_def_18459,type,
    v33855: state_type > $o ).

tff(pred_def_18460,type,
    v33847: ( state_type * $int ) > $o ).

tff(pred_def_18461,type,
    v33832: ( state_type * $int ) > $o ).

tff(pred_def_18462,type,
    v33830: ( state_type * $int ) > $o ).

tff(pred_def_18463,type,
    v33828: ( state_type * $int ) > $o ).

tff(pred_def_18464,type,
    v33826: ( state_type * $int ) > $o ).

tff(pred_def_18465,type,
    v33863: state_type > $o ).

tff(pred_def_18466,type,
    v33861: state_type > $o ).

tff(pred_def_18467,type,
    v33870: state_type > $o ).

tff(pred_def_18468,type,
    v33868: state_type > $o ).

tff(pred_def_18469,type,
    v33867: state_type > $o ).

tff(pred_def_18470,type,
    v33866: state_type > $o ).

tff(pred_def_18471,type,
    v33878: state_type > $o ).

tff(pred_def_18472,type,
    v33879: state_type > $o ).

tff(pred_def_18473,type,
    v33877: state_type > $o ).

tff(pred_def_18474,type,
    v33874: ( state_type * $int ) > $o ).

tff(pred_def_18475,type,
    v33876: ( state_type * $int ) > $o ).

tff(pred_def_18476,type,
    v33816: ( state_type * $int ) > $o ).

tff(pred_def_18477,type,
    v33814: ( state_type * $int ) > $o ).

tff(pred_def_18478,type,
    v33883: state_type > $o ).

tff(pred_def_18479,type,
    v33810: state_type > $o ).

tff(pred_def_18480,type,
    v33778: state_type > $o ).

tff(pred_def_18481,type,
    v33886: state_type > $o ).

tff(pred_def_18482,type,
    v33885: state_type > $o ).

tff(pred_def_18483,type,
    v33800: state_type > $o ).

tff(pred_def_18484,type,
    v33798: state_type > $o ).

tff(pred_def_18485,type,
    v33796: state_type > $o ).

tff(pred_def_18486,type,
    v33794: state_type > $o ).

tff(pred_def_18487,type,
    v33890: state_type > $o ).

tff(pred_def_18488,type,
    v33888: state_type > $o ).

tff(pred_def_18489,type,
    v33897: state_type > $o ).

tff(pred_def_18490,type,
    v33895: state_type > $o ).

tff(pred_def_18491,type,
    v33894: state_type > $o ).

tff(pred_def_18492,type,
    v33893: state_type > $o ).

tff(pred_def_18493,type,
    v33905: state_type > $o ).

tff(pred_def_18494,type,
    v33906: state_type > $o ).

tff(pred_def_18495,type,
    v33904: state_type > $o ).

tff(pred_def_18496,type,
    v33901: state_type > $o ).

tff(pred_def_18497,type,
    v33903: state_type > $o ).

tff(pred_def_18498,type,
    v33784: state_type > $o ).

tff(pred_def_18499,type,
    v33782: state_type > $o ).

tff(pred_def_18500,type,
    v33910: state_type > $o ).

tff(pred_def_18501,type,
    v33916: state_type > $o ).

tff(pred_def_18502,type,
    v33917: state_type > $o ).

tff(pred_def_18503,type,
    v33914: state_type > $o ).

tff(pred_def_18504,type,
    v33912: state_type > $o ).

tff(pred_def_18505,type,
    v33933: state_type > $o ).

tff(pred_def_18506,type,
    v33932: state_type > $o ).

tff(pred_def_18507,type,
    v4228: state_type > $o ).

tff(pred_def_18508,type,
    v33931: state_type > $o ).

tff(pred_def_18509,type,
    v33930: state_type > $o ).

tff(pred_def_18510,type,
    v33936: state_type > $o ).

tff(pred_def_18511,type,
    v33935: state_type > $o ).

tff(pred_def_18512,type,
    v33934: state_type > $o ).

tff(pred_def_18513,type,
    v33929: state_type > $o ).

tff(pred_def_18514,type,
    v33939: state_type > $o ).

tff(pred_def_18515,type,
    v33938: state_type > $o ).

tff(pred_def_18516,type,
    v33940: state_type > $o ).

tff(pred_def_18517,type,
    v33937: state_type > $o ).

tff(pred_def_18518,type,
    v33928: state_type > $o ).

tff(pred_def_18519,type,
    v33943: state_type > $o ).

tff(pred_def_18520,type,
    v33942: state_type > $o ).

tff(pred_def_18521,type,
    v33944: state_type > $o ).

tff(pred_def_18522,type,
    v33941: state_type > $o ).

tff(pred_def_18523,type,
    v33927: state_type > $o ).

tff(pred_def_18524,type,
    v33947: state_type > $o ).

tff(pred_def_18525,type,
    v33946: state_type > $o ).

tff(pred_def_18526,type,
    v33948: state_type > $o ).

tff(pred_def_18527,type,
    v33945: state_type > $o ).

tff(pred_def_18528,type,
    v33926: state_type > $o ).

tff(pred_def_18529,type,
    v33951: state_type > $o ).

tff(pred_def_18530,type,
    v33950: state_type > $o ).

tff(pred_def_18531,type,
    v32548: ( state_type * $int ) > $o ).

tff(pred_def_18532,type,
    v32570: state_type > $o ).

tff(pred_def_18533,type,
    v33952: state_type > $o ).

tff(pred_def_18534,type,
    v33949: state_type > $o ).

tff(pred_def_18535,type,
    v33925: state_type > $o ).

tff(pred_def_18536,type,
    v33954: state_type > $o ).

tff(pred_def_18537,type,
    v33953: state_type > $o ).

tff(pred_def_18538,type,
    v33924: state_type > $o ).

tff(pred_def_18539,type,
    v33923: state_type > $o ).

tff(pred_def_18540,type,
    v33922: state_type > $o ).

tff(pred_def_18541,type,
    v33921: state_type > $o ).

tff(pred_def_18542,type,
    v33920: state_type > $o ).

tff(pred_def_18543,type,
    v33919: state_type > $o ).

tff(pred_def_18544,type,
    v33956: state_type > $o ).

tff(pred_def_18545,type,
    v33960: state_type > $o ).

tff(pred_def_18546,type,
    v33961: state_type > $o ).

tff(pred_def_18547,type,
    v33958: state_type > $o ).

tff(pred_def_18548,type,
    v33967: state_type > $o ).

tff(pred_def_18549,type,
    v33966: state_type > $o ).

tff(pred_def_18550,type,
    v33965: state_type > $o ).

tff(pred_def_18551,type,
    v33969: state_type > $o ).

tff(pred_def_18552,type,
    v33963: state_type > $o ).

tff(pred_def_18553,type,
    v33971: state_type > $o ).

tff(pred_def_18554,type,
    v33974: ( state_type * $int ) > $o ).

tff(pred_def_18555,type,
    v33976: state_type > $o ).

tff(pred_def_18556,type,
    v33975: ( state_type * $int ) > $o ).

tff(pred_def_18557,type,
    v33973: ( state_type * $int ) > $o ).

tff(pred_def_18558,type,
    v33972: ( state_type * $int ) > $o ).

tff(pred_def_18559,type,
    v33970: ( state_type * $int ) > $o ).

tff(pred_def_18560,type,
    v32568: ( state_type * $int ) > $o ).

tff(pred_def_18561,type,
    v32566: ( state_type * $int ) > $o ).

tff(pred_def_18562,type,
    v33986: state_type > $o ).

tff(pred_def_18563,type,
    v33985: state_type > $o ).

tff(pred_def_18564,type,
    v33984: state_type > $o ).

tff(pred_def_18565,type,
    v33983: state_type > $o ).

tff(pred_def_18566,type,
    v33982: state_type > $o ).

tff(pred_def_18567,type,
    v33988: state_type > $o ).

tff(pred_def_18568,type,
    v33987: state_type > $o ).

tff(pred_def_18569,type,
    v33980: state_type > $o ).

tff(pred_def_18570,type,
    v33978: state_type > $o ).

tff(pred_def_18571,type,
    v33992: state_type > $o ).

tff(pred_def_18572,type,
    v33991: ( state_type * $int ) > $o ).

tff(pred_def_18573,type,
    v33990: ( state_type * $int ) > $o ).

tff(pred_def_18574,type,
    v33996: state_type > $o ).

tff(pred_def_18575,type,
    v33995: ( state_type * $int ) > $o ).

tff(pred_def_18576,type,
    v33994: ( state_type * $int ) > $o ).

tff(pred_def_18577,type,
    v32550: ( state_type * $int ) > $o ).

tff(pred_def_18578,type,
    v33993: ( state_type * $int ) > $o ).

tff(pred_def_18579,type,
    v33989: ( state_type * $int ) > $o ).

tff(pred_def_18580,type,
    v32564: ( state_type * $int ) > $o ).

tff(pred_def_18581,type,
    v32562: ( state_type * $int ) > $o ).

tff(pred_def_18582,type,
    v34000: state_type > $o ).

tff(pred_def_18583,type,
    v33998: state_type > $o ).

tff(pred_def_18584,type,
    v34007: state_type > $o ).

tff(pred_def_18585,type,
    v34005: state_type > $o ).

tff(pred_def_18586,type,
    v34004: state_type > $o ).

tff(pred_def_18587,type,
    v34003: state_type > $o ).

tff(pred_def_18588,type,
    v34015: state_type > $o ).

tff(pred_def_18589,type,
    v34016: state_type > $o ).

tff(pred_def_18590,type,
    v34014: state_type > $o ).

tff(pred_def_18591,type,
    v34011: ( state_type * $int ) > $o ).

tff(pred_def_18592,type,
    v34013: ( state_type * $int ) > $o ).

tff(pred_def_18593,type,
    v34002: ( state_type * $int ) > $o ).

tff(pred_def_18594,type,
    v32552: ( state_type * $int ) > $o ).

tff(pred_def_18595,type,
    v34028: state_type > $o ).

tff(pred_def_18596,type,
    v34026: state_type > $o ).

tff(pred_def_18597,type,
    v34032: state_type > $o ).

tff(pred_def_18598,type,
    v34030: state_type > $o ).

tff(pred_def_18599,type,
    v34052: state_type > $o ).

tff(pred_def_18600,type,
    v34050: state_type > $o ).

tff(pred_def_18601,type,
    v34056: state_type > $o ).

tff(pred_def_18602,type,
    v34054: state_type > $o ).

tff(pred_def_18603,type,
    v34066: ( state_type * $int ) > $o ).

tff(pred_def_18604,type,
    v34064: ( state_type * $int ) > $o ).

tff(pred_def_18605,type,
    v34062: ( state_type * $int ) > $o ).

tff(pred_def_18606,type,
    b0100010011000: $int > $o ).

tff(pred_def_18607,type,
    v34074: state_type > $o ).

tff(pred_def_18608,type,
    v34071: state_type > $o ).

tff(pred_def_18609,type,
    v34069: state_type > $o ).

tff(pred_def_18610,type,
    v34078: state_type > $o ).

tff(pred_def_18611,type,
    v34077: ( state_type * $int ) > $o ).

tff(pred_def_18612,type,
    v34076: ( state_type * $int ) > $o ).

tff(pred_def_18613,type,
    v34082: state_type > $o ).

tff(pred_def_18614,type,
    v34081: ( state_type * $int ) > $o ).

tff(pred_def_18615,type,
    v34080: ( state_type * $int ) > $o ).

tff(pred_def_18616,type,
    v34046: ( state_type * $int ) > $o ).

tff(pred_def_18617,type,
    v34079: ( state_type * $int ) > $o ).

tff(pred_def_18618,type,
    v34060: ( state_type * $int ) > $o ).

tff(pred_def_18619,type,
    v34058: ( state_type * $int ) > $o ).

tff(pred_def_18620,type,
    v34086: state_type > $o ).

tff(pred_def_18621,type,
    v34084: state_type > $o ).

tff(pred_def_18622,type,
    v34093: state_type > $o ).

tff(pred_def_18623,type,
    v34091: state_type > $o ).

tff(pred_def_18624,type,
    v34090: state_type > $o ).

tff(pred_def_18625,type,
    v34089: state_type > $o ).

tff(pred_def_18626,type,
    v34101: state_type > $o ).

tff(pred_def_18627,type,
    v34102: state_type > $o ).

tff(pred_def_18628,type,
    v34100: state_type > $o ).

tff(pred_def_18629,type,
    v34097: ( state_type * $int ) > $o ).

tff(pred_def_18630,type,
    v34099: ( state_type * $int ) > $o ).

tff(pred_def_18631,type,
    v34048: ( state_type * $int ) > $o ).

tff(pred_def_18632,type,
    v34044: ( state_type * $int ) > $o ).

tff(pred_def_18633,type,
    v34042: ( state_type * $int ) > $o ).

tff(pred_def_18634,type,
    v34020: ( state_type * $int ) > $o ).

tff(pred_def_18635,type,
    v34109: state_type > $o ).

tff(pred_def_18636,type,
    v34127: state_type > $o ).

tff(pred_def_18637,type,
    v34126: state_type > $o ).

tff(pred_def_18638,type,
    v34125: state_type > $o ).

tff(pred_def_18639,type,
    v34128: state_type > $o ).

tff(pred_def_18640,type,
    v34124: state_type > $o ).

tff(pred_def_18641,type,
    v34123: state_type > $o ).

tff(pred_def_18642,type,
    v34129: state_type > $o ).

tff(pred_def_18643,type,
    v34122: state_type > $o ).

tff(pred_def_18644,type,
    v34121: state_type > $o ).

tff(pred_def_18645,type,
    v34130: state_type > $o ).

tff(pred_def_18646,type,
    v34120: state_type > $o ).

tff(pred_def_18647,type,
    v34119: state_type > $o ).

tff(pred_def_18648,type,
    v34131: state_type > $o ).

tff(pred_def_18649,type,
    v34118: state_type > $o ).

tff(pred_def_18650,type,
    v34117: state_type > $o ).

tff(pred_def_18651,type,
    v34132: state_type > $o ).

tff(pred_def_18652,type,
    v34116: state_type > $o ).

tff(pred_def_18653,type,
    v34115: state_type > $o ).

tff(pred_def_18654,type,
    v34114: state_type > $o ).

tff(pred_def_18655,type,
    v34113: state_type > $o ).

tff(pred_def_18656,type,
    v34134: state_type > $o ).

tff(pred_def_18657,type,
    v34133: state_type > $o ).

tff(pred_def_18658,type,
    v34112: state_type > $o ).

tff(pred_def_18659,type,
    v34137: state_type > $o ).

tff(pred_def_18660,type,
    v34136: state_type > $o ).

tff(pred_def_18661,type,
    v34138: state_type > $o ).

tff(pred_def_18662,type,
    v34135: state_type > $o ).

tff(pred_def_18663,type,
    v34141: state_type > $o ).

tff(pred_def_18664,type,
    v34140: state_type > $o ).

tff(pred_def_18665,type,
    v34142: state_type > $o ).

tff(pred_def_18666,type,
    v34139: state_type > $o ).

tff(pred_def_18667,type,
    v34145: state_type > $o ).

tff(pred_def_18668,type,
    v34144: state_type > $o ).

tff(pred_def_18669,type,
    v34146: state_type > $o ).

tff(pred_def_18670,type,
    v34143: state_type > $o ).

tff(pred_def_18671,type,
    v34149: state_type > $o ).

tff(pred_def_18672,type,
    v34148: state_type > $o ).

tff(pred_def_18673,type,
    v34150: state_type > $o ).

tff(pred_def_18674,type,
    v34147: state_type > $o ).

tff(pred_def_18675,type,
    v34153: state_type > $o ).

tff(pred_def_18676,type,
    v34152: state_type > $o ).

tff(pred_def_18677,type,
    v34154: state_type > $o ).

tff(pred_def_18678,type,
    v34151: state_type > $o ).

tff(pred_def_18679,type,
    v34157: state_type > $o ).

tff(pred_def_18680,type,
    v34156: state_type > $o ).

tff(pred_def_18681,type,
    v34158: state_type > $o ).

tff(pred_def_18682,type,
    v34155: state_type > $o ).

tff(pred_def_18683,type,
    v34110: ( state_type * $int ) > $o ).

tff(pred_def_18684,type,
    v34108: ( state_type * $int ) > $o ).

tff(pred_def_18685,type,
    v34107: ( state_type * $int ) > $o ).

tff(pred_def_18686,type,
    v34160: state_type > $o ).

tff(pred_def_18687,type,
    v34159: ( state_type * $int ) > $o ).

tff(pred_def_18688,type,
    v34040: ( state_type * $int ) > $o ).

tff(pred_def_18689,type,
    v34038: ( state_type * $int ) > $o ).

tff(pred_def_18690,type,
    v34036: ( state_type * $int ) > $o ).

tff(pred_def_18691,type,
    v34034: ( state_type * $int ) > $o ).

tff(pred_def_18692,type,
    v34164: state_type > $o ).

tff(pred_def_18693,type,
    v34162: state_type > $o ).

tff(pred_def_18694,type,
    v34171: state_type > $o ).

tff(pred_def_18695,type,
    v34169: state_type > $o ).

tff(pred_def_18696,type,
    v34168: state_type > $o ).

tff(pred_def_18697,type,
    v34167: state_type > $o ).

tff(pred_def_18698,type,
    v34179: state_type > $o ).

tff(pred_def_18699,type,
    v34180: state_type > $o ).

tff(pred_def_18700,type,
    v34178: state_type > $o ).

tff(pred_def_18701,type,
    v34175: ( state_type * $int ) > $o ).

tff(pred_def_18702,type,
    v34177: ( state_type * $int ) > $o ).

tff(pred_def_18703,type,
    v34024: ( state_type * $int ) > $o ).

tff(pred_def_18704,type,
    v34022: ( state_type * $int ) > $o ).

tff(pred_def_18705,type,
    v34186: state_type > $o ).

tff(pred_def_18706,type,
    v34185: state_type > $o ).

tff(pred_def_18707,type,
    v34184: state_type > $o ).

tff(pred_def_18708,type,
    v34187: state_type > $o ).

tff(pred_def_18709,type,
    v34193: state_type > $o ).

tff(pred_def_18710,type,
    v34191: state_type > $o ).

tff(pred_def_18711,type,
    v34190: state_type > $o ).

tff(pred_def_18712,type,
    v34189: ( state_type * $int ) > $o ).

tff(pred_def_18713,type,
    v34200: state_type > $o ).

tff(pred_def_18714,type,
    v34199: state_type > $o ).

tff(pred_def_18715,type,
    v34197: state_type > $o ).

tff(pred_def_18716,type,
    v34204: state_type > $o ).

tff(pred_def_18717,type,
    v34203: state_type > $o ).

tff(pred_def_18718,type,
    v34202: state_type > $o ).

tff(pred_def_18719,type,
    v32546: state_type > $o ).

tff(pred_def_18720,type,
    v34206: ( state_type * $int ) > $o ).

tff(pred_def_18721,type,
    v4329: state_type > $o ).

tff(pred_def_18722,type,
    v34208: state_type > $o ).

tff(pred_def_18723,type,
    v34207: ( state_type * $int ) > $o ).

tff(pred_def_18724,type,
    v34205: ( state_type * $int ) > $o ).

tff(pred_def_18725,type,
    v32544: ( state_type * $int ) > $o ).

tff(pred_def_18726,type,
    v32542: state_type > $o ).

tff(pred_def_18727,type,
    b0100000010000: $int > $o ).

tff(pred_def_18728,type,
    v34217: state_type > $o ).

tff(pred_def_18729,type,
    v34216: state_type > $o ).

tff(pred_def_18730,type,
    v34215: state_type > $o ).

tff(pred_def_18731,type,
    v34214: state_type > $o ).

tff(pred_def_18732,type,
    v34212: state_type > $o ).

tff(pred_def_18733,type,
    v34210: state_type > $o ).

tff(pred_def_18734,type,
    v34221: state_type > $o ).

tff(pred_def_18735,type,
    v34220: state_type > $o ).

tff(pred_def_18736,type,
    v34219: state_type > $o ).

tff(pred_def_18737,type,
    v34225: state_type > $o ).

tff(pred_def_18738,type,
    v34224: state_type > $o ).

tff(pred_def_18739,type,
    v34223: state_type > $o ).

tff(pred_def_18740,type,
    v32526: state_type > $o ).

tff(pred_def_18741,type,
    v34222: state_type > $o ).

tff(pred_def_18742,type,
    v32540: state_type > $o ).

tff(pred_def_18743,type,
    v32538: state_type > $o ).

tff(pred_def_18744,type,
    v34229: state_type > $o ).

tff(pred_def_18745,type,
    v34227: state_type > $o ).

tff(pred_def_18746,type,
    v34236: state_type > $o ).

tff(pred_def_18747,type,
    v34234: state_type > $o ).

tff(pred_def_18748,type,
    v34233: state_type > $o ).

tff(pred_def_18749,type,
    v34232: state_type > $o ).

tff(pred_def_18750,type,
    v34244: state_type > $o ).

tff(pred_def_18751,type,
    v34245: state_type > $o ).

tff(pred_def_18752,type,
    v34243: state_type > $o ).

tff(pred_def_18753,type,
    v34240: state_type > $o ).

tff(pred_def_18754,type,
    v34242: state_type > $o ).

tff(pred_def_18755,type,
    v32528: state_type > $o ).

tff(pred_def_18756,type,
    v34251: state_type > $o ).

tff(pred_def_18757,type,
    v34250: state_type > $o ).

tff(pred_def_18758,type,
    v34253: state_type > $o ).

tff(pred_def_18759,type,
    v34287: state_type > $o ).

tff(pred_def_18760,type,
    v34286: state_type > $o ).

tff(pred_def_18761,type,
    v34285: state_type > $o ).

tff(pred_def_18762,type,
    v34288: state_type > $o ).

tff(pred_def_18763,type,
    v34284: state_type > $o ).

tff(pred_def_18764,type,
    v34283: state_type > $o ).

tff(pred_def_18765,type,
    v34289: state_type > $o ).

tff(pred_def_18766,type,
    v34282: state_type > $o ).

tff(pred_def_18767,type,
    v34281: state_type > $o ).

tff(pred_def_18768,type,
    v34290: state_type > $o ).

tff(pred_def_18769,type,
    v34280: state_type > $o ).

tff(pred_def_18770,type,
    v34279: state_type > $o ).

tff(pred_def_18771,type,
    v34291: state_type > $o ).

tff(pred_def_18772,type,
    v34278: state_type > $o ).

tff(pred_def_18773,type,
    v34277: state_type > $o ).

tff(pred_def_18774,type,
    v34292: state_type > $o ).

tff(pred_def_18775,type,
    v34276: state_type > $o ).

tff(pred_def_18776,type,
    v34275: state_type > $o ).

tff(pred_def_18777,type,
    v34293: state_type > $o ).

tff(pred_def_18778,type,
    v34274: state_type > $o ).

tff(pred_def_18779,type,
    v34273: state_type > $o ).

tff(pred_def_18780,type,
    v34294: state_type > $o ).

tff(pred_def_18781,type,
    v34272: state_type > $o ).

tff(pred_def_18782,type,
    v34271: state_type > $o ).

tff(pred_def_18783,type,
    v34295: state_type > $o ).

tff(pred_def_18784,type,
    v34270: state_type > $o ).

tff(pred_def_18785,type,
    v34269: state_type > $o ).

tff(pred_def_18786,type,
    v34296: state_type > $o ).

tff(pred_def_18787,type,
    v34268: state_type > $o ).

tff(pred_def_18788,type,
    v34267: state_type > $o ).

tff(pred_def_18789,type,
    v34297: state_type > $o ).

tff(pred_def_18790,type,
    v34266: state_type > $o ).

tff(pred_def_18791,type,
    v34265: state_type > $o ).

tff(pred_def_18792,type,
    v34298: state_type > $o ).

tff(pred_def_18793,type,
    v34264: state_type > $o ).

tff(pred_def_18794,type,
    v34263: state_type > $o ).

tff(pred_def_18795,type,
    v34299: state_type > $o ).

tff(pred_def_18796,type,
    v34262: state_type > $o ).

tff(pred_def_18797,type,
    v34261: state_type > $o ).

tff(pred_def_18798,type,
    v34300: state_type > $o ).

tff(pred_def_18799,type,
    v34260: state_type > $o ).

tff(pred_def_18800,type,
    v34259: state_type > $o ).

tff(pred_def_18801,type,
    v34258: state_type > $o ).

tff(pred_def_18802,type,
    v34257: state_type > $o ).

tff(pred_def_18803,type,
    v34302: state_type > $o ).

tff(pred_def_18804,type,
    v34301: state_type > $o ).

tff(pred_def_18805,type,
    v34256: state_type > $o ).

tff(pred_def_18806,type,
    v34305: state_type > $o ).

tff(pred_def_18807,type,
    v34304: state_type > $o ).

tff(pred_def_18808,type,
    v34306: state_type > $o ).

tff(pred_def_18809,type,
    v34303: state_type > $o ).

tff(pred_def_18810,type,
    v34309: state_type > $o ).

tff(pred_def_18811,type,
    v34308: state_type > $o ).

tff(pred_def_18812,type,
    v34310: state_type > $o ).

tff(pred_def_18813,type,
    v34307: state_type > $o ).

tff(pred_def_18814,type,
    v34313: state_type > $o ).

tff(pred_def_18815,type,
    v34312: state_type > $o ).

tff(pred_def_18816,type,
    v34314: state_type > $o ).

tff(pred_def_18817,type,
    v34311: state_type > $o ).

tff(pred_def_18818,type,
    v34317: state_type > $o ).

tff(pred_def_18819,type,
    v34316: state_type > $o ).

tff(pred_def_18820,type,
    v34318: state_type > $o ).

tff(pred_def_18821,type,
    v34315: state_type > $o ).

tff(pred_def_18822,type,
    v34321: state_type > $o ).

tff(pred_def_18823,type,
    v34320: state_type > $o ).

tff(pred_def_18824,type,
    v34322: state_type > $o ).

tff(pred_def_18825,type,
    v34319: state_type > $o ).

tff(pred_def_18826,type,
    v34325: state_type > $o ).

tff(pred_def_18827,type,
    v34324: state_type > $o ).

tff(pred_def_18828,type,
    v34326: state_type > $o ).

tff(pred_def_18829,type,
    v34323: state_type > $o ).

tff(pred_def_18830,type,
    v34329: state_type > $o ).

tff(pred_def_18831,type,
    v34328: state_type > $o ).

tff(pred_def_18832,type,
    v34330: state_type > $o ).

tff(pred_def_18833,type,
    v34327: state_type > $o ).

tff(pred_def_18834,type,
    v34333: state_type > $o ).

tff(pred_def_18835,type,
    v34332: state_type > $o ).

tff(pred_def_18836,type,
    v34334: state_type > $o ).

tff(pred_def_18837,type,
    v34331: state_type > $o ).

tff(pred_def_18838,type,
    v34337: state_type > $o ).

tff(pred_def_18839,type,
    v34336: state_type > $o ).

tff(pred_def_18840,type,
    v34338: state_type > $o ).

tff(pred_def_18841,type,
    v34335: state_type > $o ).

tff(pred_def_18842,type,
    v34341: state_type > $o ).

tff(pred_def_18843,type,
    v34340: state_type > $o ).

tff(pred_def_18844,type,
    v34342: state_type > $o ).

tff(pred_def_18845,type,
    v34339: state_type > $o ).

tff(pred_def_18846,type,
    v34345: state_type > $o ).

tff(pred_def_18847,type,
    v34344: state_type > $o ).

tff(pred_def_18848,type,
    v34346: state_type > $o ).

tff(pred_def_18849,type,
    v34343: state_type > $o ).

tff(pred_def_18850,type,
    v34349: state_type > $o ).

tff(pred_def_18851,type,
    v34348: state_type > $o ).

tff(pred_def_18852,type,
    v34350: state_type > $o ).

tff(pred_def_18853,type,
    v34347: state_type > $o ).

tff(pred_def_18854,type,
    v34353: state_type > $o ).

tff(pred_def_18855,type,
    v34352: state_type > $o ).

tff(pred_def_18856,type,
    v34354: state_type > $o ).

tff(pred_def_18857,type,
    v34351: state_type > $o ).

tff(pred_def_18858,type,
    v34357: state_type > $o ).

tff(pred_def_18859,type,
    v34356: state_type > $o ).

tff(pred_def_18860,type,
    v34358: state_type > $o ).

tff(pred_def_18861,type,
    v34355: state_type > $o ).

tff(pred_def_18862,type,
    v34254: ( state_type * $int ) > $o ).

tff(pred_def_18863,type,
    v34252: ( state_type * $int ) > $o ).

tff(pred_def_18864,type,
    v34249: ( state_type * $int ) > $o ).

tff(pred_def_18865,type,
    v34361: state_type > $o ).

tff(pred_def_18866,type,
    v34360: state_type > $o ).

tff(pred_def_18867,type,
    v34359: ( state_type * $int ) > $o ).

tff(pred_def_18868,type,
    v34248: ( state_type * $int ) > $o ).

tff(pred_def_18869,type,
    v30963: ( state_type * $int ) > $o ).

tff(pred_def_18870,type,
    v30961: ( state_type * $int ) > $o ).

tff(pred_def_18871,type,
    v30959: ( state_type * $int ) > $o ).

tff(pred_def_18872,type,
    v30957: ( state_type * $int ) > $o ).

tff(pred_def_18873,type,
    v34365: state_type > $o ).

tff(pred_def_18874,type,
    v34363: state_type > $o ).

tff(pred_def_18875,type,
    v34372: state_type > $o ).

tff(pred_def_18876,type,
    v34370: state_type > $o ).

tff(pred_def_18877,type,
    v34369: state_type > $o ).

tff(pred_def_18878,type,
    v34368: state_type > $o ).

tff(pred_def_18879,type,
    v34380: state_type > $o ).

tff(pred_def_18880,type,
    v34381: state_type > $o ).

tff(pred_def_18881,type,
    v34379: state_type > $o ).

tff(pred_def_18882,type,
    v34376: ( state_type * $int ) > $o ).

tff(pred_def_18883,type,
    v34378: ( state_type * $int ) > $o ).

tff(pred_def_18884,type,
    v34367: ( state_type * $int ) > $o ).

tff(pred_def_18885,type,
    v30947: ( state_type * $int ) > $o ).

tff(pred_def_18886,type,
    v30945: ( state_type * $int ) > $o ).

tff(pred_def_18887,type,
    v34389: state_type > $o ).

tff(pred_def_18888,type,
    v34387: state_type > $o ).

tff(pred_def_18889,type,
    v34386: state_type > $o ).

tff(pred_def_18890,type,
    v34385: ( state_type * $int ) > $o ).

tff(pred_def_18891,type,
    v34397: state_type > $o ).

tff(pred_def_18892,type,
    v34395: state_type > $o ).

tff(pred_def_18893,type,
    v34394: state_type > $o ).

tff(pred_def_18894,type,
    v34393: ( state_type * $int ) > $o ).

tff(pred_def_18895,type,
    v34406: state_type > $o ).

tff(pred_def_18896,type,
    v34404: state_type > $o ).

tff(pred_def_18897,type,
    v34403: state_type > $o ).

tff(pred_def_18898,type,
    v34402: state_type > $o ).

tff(pred_def_18899,type,
    v34401: state_type > $o ).

tff(pred_def_18900,type,
    v34422: state_type > $o ).

tff(pred_def_18901,type,
    v34421: state_type > $o ).

tff(pred_def_18902,type,
    v34420: state_type > $o ).

tff(pred_def_18903,type,
    v34419: state_type > $o ).

tff(pred_def_18904,type,
    v34418: state_type > $o ).

tff(pred_def_18905,type,
    v34417: state_type > $o ).

tff(pred_def_18906,type,
    v34416: state_type > $o ).

tff(pred_def_18907,type,
    v34415: state_type > $o ).

tff(pred_def_18908,type,
    v34414: state_type > $o ).

tff(pred_def_18909,type,
    v34413: state_type > $o ).

tff(pred_def_18910,type,
    v34412: state_type > $o ).

tff(pred_def_18911,type,
    v34411: state_type > $o ).

tff(pred_def_18912,type,
    v34409: state_type > $o ).

tff(pred_def_18913,type,
    v34430: state_type > $o ).

tff(pred_def_18914,type,
    v34429: state_type > $o ).

tff(pred_def_18915,type,
    v34428: state_type > $o ).

tff(pred_def_18916,type,
    v34427: state_type > $o ).

tff(pred_def_18917,type,
    v34425: state_type > $o ).

tff(pred_def_18918,type,
    v34424: state_type > $o ).

tff(pred_def_18919,type,
    v34423: state_type > $o ).

tff(pred_def_18920,type,
    v34408: state_type > $o ).

tff(pred_def_18921,type,
    v9075: state_type > $o ).

tff(pred_def_18922,type,
    v34407: state_type > $o ).

tff(pred_def_18923,type,
    v9077: state_type > $o ).

tff(pred_def_18924,type,
    v8310: state_type > $o ).

tff(pred_def_18925,type,
    v34431: ( state_type * $int ) > $o ).

tff(pred_def_18926,type,
    v8308: ( state_type * $int ) > $o ).

tff(pred_def_18927,type,
    v8306: ( state_type * $int ) > $o ).

tff(pred_def_18928,type,
    v8304: ( state_type * $int ) > $o ).

tff(pred_def_18929,type,
    v34435: state_type > $o ).

tff(pred_def_18930,type,
    v34433: state_type > $o ).

tff(pred_def_18931,type,
    v34442: state_type > $o ).

tff(pred_def_18932,type,
    v34440: state_type > $o ).

tff(pred_def_18933,type,
    v34439: state_type > $o ).

tff(pred_def_18934,type,
    v34438: state_type > $o ).

tff(pred_def_18935,type,
    v34450: state_type > $o ).

tff(pred_def_18936,type,
    v34451: state_type > $o ).

tff(pred_def_18937,type,
    v34449: state_type > $o ).

tff(pred_def_18938,type,
    v34446: ( state_type * $int ) > $o ).

tff(pred_def_18939,type,
    v34448: ( state_type * $int ) > $o ).

tff(pred_def_18940,type,
    v34437: ( state_type * $int ) > $o ).

tff(pred_def_18941,type,
    v8294: ( state_type * $int ) > $o ).

tff(pred_def_18942,type,
    v8292: ( state_type * $int ) > $o ).

tff(pred_def_18943,type,
    v34456: ( state_type * $int ) > $o ).

tff(pred_def_18944,type,
    v34460: state_type > $o ).

tff(pred_def_18945,type,
    v34459: state_type > $o ).

tff(pred_def_18946,type,
    v34458: state_type > $o ).

tff(pred_def_18947,type,
    v34457: ( state_type * $int ) > $o ).

tff(pred_def_18948,type,
    v34455: ( state_type * $int ) > $o ).

tff(pred_def_18949,type,
    v7234: ( state_type * $int ) > $o ).

tff(pred_def_18950,type,
    v7232: ( state_type * $int ) > $o ).

tff(pred_def_18951,type,
    v7230: ( state_type * $int ) > $o ).

tff(pred_def_18952,type,
    v9071: state_type > $o ).

tff(pred_def_18953,type,
    v34461: ( state_type * $int ) > $o ).

tff(pred_def_18954,type,
    v34462: state_type > $o ).

tff(pred_def_18955,type,
    v9069: ( state_type * $int ) > $o ).

tff(pred_def_18956,type,
    v9067: ( state_type * $int ) > $o ).

tff(pred_def_18957,type,
    v34486: ( state_type * $int ) > $o ).

tff(pred_def_18958,type,
    v9006: ( state_type * $int ) > $o ).

tff(pred_def_18959,type,
    v34484: ( state_type * $int ) > $o ).

tff(pred_def_18960,type,
    v34487: ( state_type * $int ) > $o ).

tff(pred_def_18961,type,
    v34482: ( state_type * $int ) > $o ).

tff(pred_def_18962,type,
    v34480: ( state_type * $int ) > $o ).

tff(pred_def_18963,type,
    v34478: ( state_type * $int ) > $o ).

tff(pred_def_18964,type,
    v34476: state_type > $o ).

tff(pred_def_18965,type,
    v34474: state_type > $o ).

tff(pred_def_18966,type,
    v34493: state_type > $o ).

tff(pred_def_18967,type,
    v9044: state_type > $o ).

tff(pred_def_18968,type,
    v34492: ( state_type * $int ) > $o ).

tff(pred_def_18969,type,
    v9042: ( state_type * $int ) > $o ).

tff(pred_def_18970,type,
    v9040: ( state_type * $int ) > $o ).

tff(pred_def_18971,type,
    v34508: ( state_type * $int ) > $o ).

tff(pred_def_18972,type,
    v34507: ( state_type * $int ) > $o ).

tff(pred_def_18973,type,
    v34505: ( state_type * $int ) > $o ).

tff(pred_def_18974,type,
    v34512: state_type > $o ).

tff(pred_def_18975,type,
    v34510: state_type > $o ).

tff(pred_def_18976,type,
    v34523: ( state_type * $int ) > $o ).

tff(pred_def_18977,type,
    v34522: state_type > $o ).

tff(pred_def_18978,type,
    v34526: state_type > $o ).

tff(pred_def_18979,type,
    v34527: state_type > $o ).

tff(pred_def_18980,type,
    v34525: state_type > $o ).

tff(pred_def_18981,type,
    v34528: state_type > $o ).

tff(pred_def_18982,type,
    v34524: state_type > $o ).

tff(pred_def_18983,type,
    v34521: state_type > $o ).

tff(pred_def_18984,type,
    v34529: state_type > $o ).

tff(pred_def_18985,type,
    v34520: state_type > $o ).

tff(pred_def_18986,type,
    v34532: state_type > $o ).

tff(pred_def_18987,type,
    v34533: state_type > $o ).

tff(pred_def_18988,type,
    v34531: state_type > $o ).

tff(pred_def_18989,type,
    v34534: state_type > $o ).

tff(pred_def_18990,type,
    v34530: state_type > $o ).

tff(pred_def_18991,type,
    v34519: state_type > $o ).

tff(pred_def_18992,type,
    v34535: state_type > $o ).

tff(pred_def_18993,type,
    v34518: state_type > $o ).

tff(pred_def_18994,type,
    v34517: state_type > $o ).

tff(pred_def_18995,type,
    v34539: state_type > $o ).

tff(pred_def_18996,type,
    v34540: state_type > $o ).

tff(pred_def_18997,type,
    v34538: state_type > $o ).

tff(pred_def_18998,type,
    v34541: state_type > $o ).

tff(pred_def_18999,type,
    v34537: state_type > $o ).

tff(pred_def_19000,type,
    v34536: state_type > $o ).

tff(pred_def_19001,type,
    v34516: state_type > $o ).

tff(pred_def_19002,type,
    v34542: state_type > $o ).

tff(pred_def_19003,type,
    v34515: state_type > $o ).

tff(pred_def_19004,type,
    v34545: state_type > $o ).

tff(pred_def_19005,type,
    v34546: state_type > $o ).

tff(pred_def_19006,type,
    v34544: state_type > $o ).

tff(pred_def_19007,type,
    v34547: state_type > $o ).

tff(pred_def_19008,type,
    v34543: state_type > $o ).

tff(pred_def_19009,type,
    v34550: state_type > $o ).

tff(pred_def_19010,type,
    v34551: state_type > $o ).

tff(pred_def_19011,type,
    v34549: state_type > $o ).

tff(pred_def_19012,type,
    v34552: state_type > $o ).

tff(pred_def_19013,type,
    v34548: state_type > $o ).

tff(pred_def_19014,type,
    v34555: state_type > $o ).

tff(pred_def_19015,type,
    v34556: state_type > $o ).

tff(pred_def_19016,type,
    v34554: state_type > $o ).

tff(pred_def_19017,type,
    v34557: state_type > $o ).

tff(pred_def_19018,type,
    v34553: state_type > $o ).

tff(pred_def_19019,type,
    v34513: ( state_type * $int ) > $o ).

tff(pred_def_19020,type,
    v34503: ( state_type * $int ) > $o ).

tff(pred_def_19021,type,
    v34501: ( state_type * $int ) > $o ).

tff(pred_def_19022,type,
    v34499: ( state_type * $int ) > $o ).

tff(pred_def_19023,type,
    v34497: ( state_type * $int ) > $o ).

tff(pred_def_19024,type,
    v34495: ( state_type * $int ) > $o ).

tff(pred_def_19025,type,
    v34558: ( state_type * $int ) > $o ).

tff(pred_def_19026,type,
    v9038: ( state_type * $int ) > $o ).

tff(pred_def_19027,type,
    v9036: ( state_type * $int ) > $o ).

tff(pred_def_19028,type,
    v9034: ( state_type * $int ) > $o ).

tff(pred_def_19029,type,
    v34559: ( state_type * $int ) > $o ).

tff(pred_def_19030,type,
    v34560: ( state_type * $int ) > $o ).

tff(pred_def_19031,type,
    v9032: ( state_type * $int ) > $o ).

tff(pred_def_19032,type,
    v9030: ( state_type * $int ) > $o ).

tff(pred_def_19033,type,
    v34570: state_type > $o ).

tff(pred_def_19034,type,
    v34568: state_type > $o ).

tff(pred_def_19035,type,
    v34576: state_type > $o ).

tff(pred_def_19036,type,
    v34574: state_type > $o ).

tff(pred_def_19037,type,
    v34580: state_type > $o ).

tff(pred_def_19038,type,
    v34578: state_type > $o ).

tff(pred_def_19039,type,
    v34584: state_type > $o ).

tff(pred_def_19040,type,
    v34582: state_type > $o ).

tff(pred_def_19041,type,
    v34572: state_type > $o ).

tff(pred_def_19042,type,
    v34590: state_type > $o ).

tff(pred_def_19043,type,
    v34592: state_type > $o ).

tff(pred_def_19044,type,
    v34588: state_type > $o ).

tff(pred_def_19045,type,
    v34587: state_type > $o ).

tff(pred_def_19046,type,
    v34598: state_type > $o ).

tff(pred_def_19047,type,
    v34599: state_type > $o ).

tff(pred_def_19048,type,
    v34595: state_type > $o ).

tff(pred_def_19049,type,
    v34597: state_type > $o ).

tff(pred_def_19050,type,
    v34605: state_type > $o ).

tff(pred_def_19051,type,
    v34603: state_type > $o ).

tff(pred_def_19052,type,
    v34607: state_type > $o ).

tff(pred_def_19053,type,
    v34566: state_type > $o ).

tff(pred_def_19054,type,
    v34564: state_type > $o ).

tff(pred_def_19055,type,
    v34562: state_type > $o ).

tff(pred_def_19056,type,
    v34614: state_type > $o ).

tff(pred_def_19057,type,
    v34612: state_type > $o ).

tff(pred_def_19058,type,
    v34611: state_type > $o ).

tff(pred_def_19059,type,
    v34610: state_type > $o ).

tff(pred_def_19060,type,
    v34622: state_type > $o ).

tff(pred_def_19061,type,
    v34623: state_type > $o ).

tff(pred_def_19062,type,
    v34621: state_type > $o ).

tff(pred_def_19063,type,
    v34618: ( state_type * $int ) > $o ).

tff(pred_def_19064,type,
    v34620: ( state_type * $int ) > $o ).

tff(pred_def_19065,type,
    v34609: ( state_type * $int ) > $o ).

tff(pred_def_19066,type,
    v34491: state_type > $o ).

tff(pred_def_19067,type,
    v34489: state_type > $o ).

tff(pred_def_19068,type,
    v34635: state_type > $o ).

tff(pred_def_19069,type,
    v34633: state_type > $o ).

tff(pred_def_19070,type,
    v34632: state_type > $o ).

tff(pred_def_19071,type,
    v34631: ( state_type * $int ) > $o ).

tff(pred_def_19072,type,
    v34629: state_type > $o ).

tff(pred_def_19073,type,
    v34627: state_type > $o ).

tff(pred_def_19074,type,
    v34640: state_type > $o ).

tff(pred_def_19075,type,
    v34639: state_type > $o ).

tff(pred_def_19076,type,
    v34472: state_type > $o ).

tff(pred_def_19077,type,
    v34470: state_type > $o ).

tff(pred_def_19078,type,
    v34468: state_type > $o ).

tff(pred_def_19079,type,
    v34641: ( state_type * $int ) > $o ).

tff(pred_def_19080,type,
    v34642: state_type > $o ).

tff(pred_def_19081,type,
    v34466: ( state_type * $int ) > $o ).

tff(pred_def_19082,type,
    v34464: ( state_type * $int ) > $o ).

tff(pred_def_19083,type,
    v34643: ( state_type * $int ) > $o ).

tff(pred_def_19084,type,
    v9065: ( state_type * $int ) > $o ).

tff(pred_def_19085,type,
    v9063: ( state_type * $int ) > $o ).

tff(pred_def_19086,type,
    v9061: state_type > $o ).

tff(pred_def_19087,type,
    v34644: ( state_type * $int ) > $o ).

tff(pred_def_19088,type,
    v34645: state_type > $o ).

tff(pred_def_19089,type,
    v9059: ( state_type * $int ) > $o ).

tff(pred_def_19090,type,
    v9057: ( state_type * $int ) > $o ).

tff(pred_def_19091,type,
    v34646: ( state_type * $int ) > $o ).

tff(pred_def_19092,type,
    v9049: ( state_type * $int ) > $o ).

tff(pred_def_19093,type,
    v9047: ( state_type * $int ) > $o ).

tff(pred_def_19094,type,
    v34652: state_type > $o ).

tff(pred_def_19095,type,
    v34650: state_type > $o ).

tff(pred_def_19096,type,
    v34649: state_type > $o ).

tff(pred_def_19097,type,
    v34648: ( state_type * $int ) > $o ).

tff(pred_def_19098,type,
    v9004: state_type > $o ).

tff(pred_def_19099,type,
    v9002: state_type > $o ).

tff(pred_def_19100,type,
    v34658: state_type > $o ).

tff(pred_def_19101,type,
    v34656: state_type > $o ).

tff(pred_def_19102,type,
    v34662: state_type > $o ).

tff(pred_def_19103,type,
    v34660: state_type > $o ).

tff(pred_def_19104,type,
    v34665: state_type > $o ).

tff(pred_def_19105,type,
    v34664: state_type > $o ).

tff(pred_def_19106,type,
    v9000: state_type > $o ).

tff(pred_def_19107,type,
    v8998: state_type > $o ).

tff(pred_def_19108,type,
    v8996: state_type > $o ).

tff(pred_def_19109,type,
    v8994: state_type > $o ).

tff(pred_def_19110,type,
    v8992: state_type > $o ).

tff(pred_def_19111,type,
    v8990: state_type > $o ).

tff(pred_def_19112,type,
    v8988: state_type > $o ).

tff(pred_def_19113,type,
    v8986: state_type > $o ).

tff(pred_def_19114,type,
    v34685: state_type > $o ).

tff(pred_def_19115,type,
    v34683: state_type > $o ).

tff(pred_def_19116,type,
    v34681: state_type > $o ).

tff(pred_def_19117,type,
    v34679: state_type > $o ).

tff(pred_def_19118,type,
    v34677: state_type > $o ).

tff(pred_def_19119,type,
    v34695: state_type > $o ).

tff(pred_def_19120,type,
    v34693: state_type > $o ).

tff(pred_def_19121,type,
    v34691: state_type > $o ).

tff(pred_def_19122,type,
    v34689: state_type > $o ).

tff(pred_def_19123,type,
    v34687: state_type > $o ).

tff(pred_def_19124,type,
    v34699: ( state_type * $int ) > $o ).

tff(pred_def_19125,type,
    v34697: ( state_type * $int ) > $o ).

tff(pred_def_19126,type,
    v34709: state_type > $o ).

tff(pred_def_19127,type,
    v34707: state_type > $o ).

tff(pred_def_19128,type,
    v34715: state_type > $o ).

tff(pred_def_19129,type,
    v34713: state_type > $o ).

tff(pred_def_19130,type,
    v34739: ( state_type * $int ) > $o ).

tff(pred_def_19131,type,
    v34737: ( state_type * $int ) > $o ).

tff(pred_def_19132,type,
    v34740: ( state_type * $int ) > $o ).

tff(pred_def_19133,type,
    v34735: ( state_type * $int ) > $o ).

tff(pred_def_19134,type,
    v34733: ( state_type * $int ) > $o ).

tff(pred_def_19135,type,
    v34731: ( state_type * $int ) > $o ).

tff(pred_def_19136,type,
    v34729: state_type > $o ).

tff(pred_def_19137,type,
    v34727: state_type > $o ).

tff(pred_def_19138,type,
    v34744: state_type > $o ).

tff(pred_def_19139,type,
    v34742: state_type > $o ).

tff(pred_def_19140,type,
    v34748: state_type > $o ).

tff(pred_def_19141,type,
    v34746: state_type > $o ).

tff(pred_def_19142,type,
    v34751: state_type > $o ).

tff(pred_def_19143,type,
    v34750: state_type > $o ).

tff(pred_def_19144,type,
    v34725: state_type > $o ).

tff(pred_def_19145,type,
    v34723: state_type > $o ).

tff(pred_def_19146,type,
    v34721: state_type > $o ).

tff(pred_def_19147,type,
    v34719: state_type > $o ).

tff(pred_def_19148,type,
    v34717: state_type > $o ).

tff(pred_def_19149,type,
    v34755: state_type > $o ).

tff(pred_def_19150,type,
    v34753: state_type > $o ).

tff(pred_def_19151,type,
    v34711: state_type > $o ).

tff(pred_def_19152,type,
    v34761: state_type > $o ).

tff(pred_def_19153,type,
    v34763: state_type > $o ).

tff(pred_def_19154,type,
    v34759: state_type > $o ).

tff(pred_def_19155,type,
    v34758: state_type > $o ).

tff(pred_def_19156,type,
    v34769: state_type > $o ).

tff(pred_def_19157,type,
    v34770: state_type > $o ).

tff(pred_def_19158,type,
    v34766: state_type > $o ).

tff(pred_def_19159,type,
    v34768: state_type > $o ).

tff(pred_def_19160,type,
    v34776: state_type > $o ).

tff(pred_def_19161,type,
    v34774: state_type > $o ).

tff(pred_def_19162,type,
    v34778: state_type > $o ).

tff(pred_def_19163,type,
    v34705: state_type > $o ).

tff(pred_def_19164,type,
    v34703: state_type > $o ).

tff(pred_def_19165,type,
    v34701: state_type > $o ).

tff(pred_def_19166,type,
    v34785: state_type > $o ).

tff(pred_def_19167,type,
    v34783: state_type > $o ).

tff(pred_def_19168,type,
    v34782: state_type > $o ).

tff(pred_def_19169,type,
    v34781: state_type > $o ).

tff(pred_def_19170,type,
    v34793: state_type > $o ).

tff(pred_def_19171,type,
    v34794: state_type > $o ).

tff(pred_def_19172,type,
    v34792: state_type > $o ).

tff(pred_def_19173,type,
    v34789: ( state_type * $int ) > $o ).

tff(pred_def_19174,type,
    v34791: ( state_type * $int ) > $o ).

tff(pred_def_19175,type,
    v34675: ( state_type * $int ) > $o ).

tff(pred_def_19176,type,
    v34673: ( state_type * $int ) > $o ).

tff(pred_def_19177,type,
    v34671: ( state_type * $int ) > $o ).

tff(pred_def_19178,type,
    v34669: ( state_type * $int ) > $o ).

tff(pred_def_19179,type,
    v34667: ( state_type * $int ) > $o ).

tff(pred_def_19180,type,
    v34816: state_type > $o ).

tff(pred_def_19181,type,
    v34814: state_type > $o ).

tff(pred_def_19182,type,
    v34820: state_type > $o ).

tff(pred_def_19183,type,
    v34818: state_type > $o ).

tff(pred_def_19184,type,
    v34824: state_type > $o ).

tff(pred_def_19185,type,
    v34822: state_type > $o ).

tff(pred_def_19186,type,
    v34827: state_type > $o ).

tff(pred_def_19187,type,
    v34826: state_type > $o ).

tff(pred_def_19188,type,
    v34812: state_type > $o ).

tff(pred_def_19189,type,
    v34810: state_type > $o ).

tff(pred_def_19190,type,
    v34808: state_type > $o ).

tff(pred_def_19191,type,
    v34806: state_type > $o ).

tff(pred_def_19192,type,
    v34804: state_type > $o ).

tff(pred_def_19193,type,
    v34802: state_type > $o ).

tff(pred_def_19194,type,
    v34800: state_type > $o ).

tff(pred_def_19195,type,
    v34798: state_type > $o ).

tff(pred_def_19196,type,
    v34847: state_type > $o ).

tff(pred_def_19197,type,
    v34845: state_type > $o ).

tff(pred_def_19198,type,
    v34843: state_type > $o ).

tff(pred_def_19199,type,
    v34841: state_type > $o ).

tff(pred_def_19200,type,
    v34839: state_type > $o ).

tff(pred_def_19201,type,
    v34857: state_type > $o ).

tff(pred_def_19202,type,
    v34855: state_type > $o ).

tff(pred_def_19203,type,
    v34853: state_type > $o ).

tff(pred_def_19204,type,
    v34851: state_type > $o ).

tff(pred_def_19205,type,
    v34849: state_type > $o ).

tff(pred_def_19206,type,
    v34861: ( state_type * $int ) > $o ).

tff(pred_def_19207,type,
    v34859: ( state_type * $int ) > $o ).

tff(pred_def_19208,type,
    v34871: state_type > $o ).

tff(pred_def_19209,type,
    v34869: state_type > $o ).

tff(pred_def_19210,type,
    v34877: state_type > $o ).

tff(pred_def_19211,type,
    v34875: state_type > $o ).

tff(pred_def_19212,type,
    v34891: state_type > $o ).

tff(pred_def_19213,type,
    v34889: state_type > $o ).

tff(pred_def_19214,type,
    v34895: state_type > $o ).

tff(pred_def_19215,type,
    v34893: state_type > $o ).

tff(pred_def_19216,type,
    v34899: state_type > $o ).

tff(pred_def_19217,type,
    v34897: state_type > $o ).

tff(pred_def_19218,type,
    v34902: state_type > $o ).

tff(pred_def_19219,type,
    v34901: state_type > $o ).

tff(pred_def_19220,type,
    v34887: state_type > $o ).

tff(pred_def_19221,type,
    v34885: state_type > $o ).

tff(pred_def_19222,type,
    v34883: state_type > $o ).

tff(pred_def_19223,type,
    v34881: state_type > $o ).

tff(pred_def_19224,type,
    v34879: state_type > $o ).

tff(pred_def_19225,type,
    v34906: state_type > $o ).

tff(pred_def_19226,type,
    v34904: state_type > $o ).

tff(pred_def_19227,type,
    v34873: state_type > $o ).

tff(pred_def_19228,type,
    v34912: state_type > $o ).

tff(pred_def_19229,type,
    v34914: state_type > $o ).

tff(pred_def_19230,type,
    v34910: state_type > $o ).

tff(pred_def_19231,type,
    v34909: state_type > $o ).

tff(pred_def_19232,type,
    v34920: state_type > $o ).

tff(pred_def_19233,type,
    v34921: state_type > $o ).

tff(pred_def_19234,type,
    v34917: state_type > $o ).

tff(pred_def_19235,type,
    v34919: state_type > $o ).

tff(pred_def_19236,type,
    v34927: state_type > $o ).

tff(pred_def_19237,type,
    v34925: state_type > $o ).

tff(pred_def_19238,type,
    v34929: state_type > $o ).

tff(pred_def_19239,type,
    v34867: state_type > $o ).

tff(pred_def_19240,type,
    v34865: state_type > $o ).

tff(pred_def_19241,type,
    v34863: state_type > $o ).

tff(pred_def_19242,type,
    v34936: state_type > $o ).

tff(pred_def_19243,type,
    v34934: state_type > $o ).

tff(pred_def_19244,type,
    v34933: state_type > $o ).

tff(pred_def_19245,type,
    v34932: state_type > $o ).

tff(pred_def_19246,type,
    v34944: state_type > $o ).

tff(pred_def_19247,type,
    v34945: state_type > $o ).

tff(pred_def_19248,type,
    v34943: state_type > $o ).

tff(pred_def_19249,type,
    v34940: ( state_type * $int ) > $o ).

tff(pred_def_19250,type,
    v34942: ( state_type * $int ) > $o ).

tff(pred_def_19251,type,
    v34837: ( state_type * $int ) > $o ).

tff(pred_def_19252,type,
    v34835: ( state_type * $int ) > $o ).

tff(pred_def_19253,type,
    v34833: ( state_type * $int ) > $o ).

tff(pred_def_19254,type,
    v34831: ( state_type * $int ) > $o ).

tff(pred_def_19255,type,
    v34829: ( state_type * $int ) > $o ).

tff(pred_def_19256,type,
    v34967: state_type > $o ).

tff(pred_def_19257,type,
    v34965: state_type > $o ).

tff(pred_def_19258,type,
    v34971: state_type > $o ).

tff(pred_def_19259,type,
    v34969: state_type > $o ).

tff(pred_def_19260,type,
    v34975: state_type > $o ).

tff(pred_def_19261,type,
    v34973: state_type > $o ).

tff(pred_def_19262,type,
    v34978: state_type > $o ).

tff(pred_def_19263,type,
    v34977: state_type > $o ).

tff(pred_def_19264,type,
    v34963: state_type > $o ).

tff(pred_def_19265,type,
    v34961: state_type > $o ).

tff(pred_def_19266,type,
    v34959: state_type > $o ).

tff(pred_def_19267,type,
    v34957: state_type > $o ).

tff(pred_def_19268,type,
    v34955: state_type > $o ).

tff(pred_def_19269,type,
    v34953: state_type > $o ).

tff(pred_def_19270,type,
    v34951: state_type > $o ).

tff(pred_def_19271,type,
    v34949: state_type > $o ).

tff(pred_def_19272,type,
    v34998: state_type > $o ).

tff(pred_def_19273,type,
    v34996: state_type > $o ).

tff(pred_def_19274,type,
    v34994: state_type > $o ).

tff(pred_def_19275,type,
    v34992: state_type > $o ).

tff(pred_def_19276,type,
    v34990: state_type > $o ).

tff(pred_def_19277,type,
    v35008: state_type > $o ).

tff(pred_def_19278,type,
    v35006: state_type > $o ).

tff(pred_def_19279,type,
    v35004: state_type > $o ).

tff(pred_def_19280,type,
    v35002: state_type > $o ).

tff(pred_def_19281,type,
    v35000: state_type > $o ).

tff(pred_def_19282,type,
    v35012: ( state_type * $int ) > $o ).

tff(pred_def_19283,type,
    v35010: ( state_type * $int ) > $o ).

tff(pred_def_19284,type,
    v35022: state_type > $o ).

tff(pred_def_19285,type,
    v35020: state_type > $o ).

tff(pred_def_19286,type,
    v35028: state_type > $o ).

tff(pred_def_19287,type,
    v35026: state_type > $o ).

tff(pred_def_19288,type,
    v35042: state_type > $o ).

tff(pred_def_19289,type,
    v35040: state_type > $o ).

tff(pred_def_19290,type,
    v35046: state_type > $o ).

tff(pred_def_19291,type,
    v35044: state_type > $o ).

tff(pred_def_19292,type,
    v35050: state_type > $o ).

tff(pred_def_19293,type,
    v35048: state_type > $o ).

tff(pred_def_19294,type,
    v35053: state_type > $o ).

tff(pred_def_19295,type,
    v35052: state_type > $o ).

tff(pred_def_19296,type,
    v35038: state_type > $o ).

tff(pred_def_19297,type,
    v35036: state_type > $o ).

tff(pred_def_19298,type,
    v35034: state_type > $o ).

tff(pred_def_19299,type,
    v35032: state_type > $o ).

tff(pred_def_19300,type,
    v35030: state_type > $o ).

tff(pred_def_19301,type,
    v35057: state_type > $o ).

tff(pred_def_19302,type,
    v35055: state_type > $o ).

tff(pred_def_19303,type,
    v35024: state_type > $o ).

tff(pred_def_19304,type,
    v35063: state_type > $o ).

tff(pred_def_19305,type,
    v35065: state_type > $o ).

tff(pred_def_19306,type,
    v35061: state_type > $o ).

tff(pred_def_19307,type,
    v35060: state_type > $o ).

tff(pred_def_19308,type,
    v35071: state_type > $o ).

tff(pred_def_19309,type,
    v35072: state_type > $o ).

tff(pred_def_19310,type,
    v35068: state_type > $o ).

tff(pred_def_19311,type,
    v35070: state_type > $o ).

tff(pred_def_19312,type,
    v35078: state_type > $o ).

tff(pred_def_19313,type,
    v35076: state_type > $o ).

tff(pred_def_19314,type,
    v35080: state_type > $o ).

tff(pred_def_19315,type,
    v35018: state_type > $o ).

tff(pred_def_19316,type,
    v35016: state_type > $o ).

tff(pred_def_19317,type,
    v35014: state_type > $o ).

tff(pred_def_19318,type,
    v35087: state_type > $o ).

tff(pred_def_19319,type,
    v35085: state_type > $o ).

tff(pred_def_19320,type,
    v35084: state_type > $o ).

tff(pred_def_19321,type,
    v35083: state_type > $o ).

tff(pred_def_19322,type,
    v35095: state_type > $o ).

tff(pred_def_19323,type,
    v35096: state_type > $o ).

tff(pred_def_19324,type,
    v35094: state_type > $o ).

tff(pred_def_19325,type,
    v35091: ( state_type * $int ) > $o ).

tff(pred_def_19326,type,
    v35093: ( state_type * $int ) > $o ).

tff(pred_def_19327,type,
    v34988: ( state_type * $int ) > $o ).

tff(pred_def_19328,type,
    v34986: ( state_type * $int ) > $o ).

tff(pred_def_19329,type,
    v34984: ( state_type * $int ) > $o ).

tff(pred_def_19330,type,
    v34982: ( state_type * $int ) > $o ).

tff(pred_def_19331,type,
    v34980: ( state_type * $int ) > $o ).

tff(pred_def_19332,type,
    v35118: state_type > $o ).

tff(pred_def_19333,type,
    v35116: state_type > $o ).

tff(pred_def_19334,type,
    v35122: state_type > $o ).

tff(pred_def_19335,type,
    v35120: state_type > $o ).

tff(pred_def_19336,type,
    v35126: state_type > $o ).

tff(pred_def_19337,type,
    v35124: state_type > $o ).

tff(pred_def_19338,type,
    v35129: state_type > $o ).

tff(pred_def_19339,type,
    v35128: state_type > $o ).

tff(pred_def_19340,type,
    v35114: state_type > $o ).

tff(pred_def_19341,type,
    v35112: state_type > $o ).

tff(pred_def_19342,type,
    v35110: state_type > $o ).

tff(pred_def_19343,type,
    v35108: state_type > $o ).

tff(pred_def_19344,type,
    v35106: state_type > $o ).

tff(pred_def_19345,type,
    v35104: state_type > $o ).

tff(pred_def_19346,type,
    v35102: state_type > $o ).

tff(pred_def_19347,type,
    v35100: state_type > $o ).

tff(pred_def_19348,type,
    v35149: state_type > $o ).

tff(pred_def_19349,type,
    v35147: state_type > $o ).

tff(pred_def_19350,type,
    v35145: state_type > $o ).

tff(pred_def_19351,type,
    v35143: state_type > $o ).

tff(pred_def_19352,type,
    v35141: state_type > $o ).

tff(pred_def_19353,type,
    v35159: state_type > $o ).

tff(pred_def_19354,type,
    v35157: state_type > $o ).

tff(pred_def_19355,type,
    v35155: state_type > $o ).

tff(pred_def_19356,type,
    v35153: state_type > $o ).

tff(pred_def_19357,type,
    v35151: state_type > $o ).

tff(pred_def_19358,type,
    v35163: ( state_type * $int ) > $o ).

tff(pred_def_19359,type,
    v35161: ( state_type * $int ) > $o ).

tff(pred_def_19360,type,
    v35173: state_type > $o ).

tff(pred_def_19361,type,
    v35171: state_type > $o ).

tff(pred_def_19362,type,
    v35179: state_type > $o ).

tff(pred_def_19363,type,
    v35177: state_type > $o ).

tff(pred_def_19364,type,
    v35193: state_type > $o ).

tff(pred_def_19365,type,
    v35191: state_type > $o ).

tff(pred_def_19366,type,
    v35197: state_type > $o ).

tff(pred_def_19367,type,
    v35195: state_type > $o ).

tff(pred_def_19368,type,
    v35201: state_type > $o ).

tff(pred_def_19369,type,
    v35199: state_type > $o ).

tff(pred_def_19370,type,
    v35204: state_type > $o ).

tff(pred_def_19371,type,
    v35203: state_type > $o ).

tff(pred_def_19372,type,
    v35189: state_type > $o ).

tff(pred_def_19373,type,
    v35187: state_type > $o ).

tff(pred_def_19374,type,
    v35185: state_type > $o ).

tff(pred_def_19375,type,
    v35183: state_type > $o ).

tff(pred_def_19376,type,
    v35181: state_type > $o ).

tff(pred_def_19377,type,
    v35208: state_type > $o ).

tff(pred_def_19378,type,
    v35206: state_type > $o ).

tff(pred_def_19379,type,
    v35175: state_type > $o ).

tff(pred_def_19380,type,
    v35214: state_type > $o ).

tff(pred_def_19381,type,
    v35216: state_type > $o ).

tff(pred_def_19382,type,
    v35212: state_type > $o ).

tff(pred_def_19383,type,
    v35211: state_type > $o ).

tff(pred_def_19384,type,
    v35222: state_type > $o ).

tff(pred_def_19385,type,
    v35223: state_type > $o ).

tff(pred_def_19386,type,
    v35219: state_type > $o ).

tff(pred_def_19387,type,
    v35221: state_type > $o ).

tff(pred_def_19388,type,
    v35229: state_type > $o ).

tff(pred_def_19389,type,
    v35227: state_type > $o ).

tff(pred_def_19390,type,
    v35231: state_type > $o ).

tff(pred_def_19391,type,
    v35169: state_type > $o ).

tff(pred_def_19392,type,
    v35167: state_type > $o ).

tff(pred_def_19393,type,
    v35165: state_type > $o ).

tff(pred_def_19394,type,
    v35238: state_type > $o ).

tff(pred_def_19395,type,
    v35236: state_type > $o ).

tff(pred_def_19396,type,
    v35235: state_type > $o ).

tff(pred_def_19397,type,
    v35234: state_type > $o ).

tff(pred_def_19398,type,
    v35246: state_type > $o ).

tff(pred_def_19399,type,
    v35247: state_type > $o ).

tff(pred_def_19400,type,
    v35245: state_type > $o ).

tff(pred_def_19401,type,
    v35242: ( state_type * $int ) > $o ).

tff(pred_def_19402,type,
    v35244: ( state_type * $int ) > $o ).

tff(pred_def_19403,type,
    v35139: ( state_type * $int ) > $o ).

tff(pred_def_19404,type,
    v35137: ( state_type * $int ) > $o ).

tff(pred_def_19405,type,
    v35135: ( state_type * $int ) > $o ).

tff(pred_def_19406,type,
    v35133: ( state_type * $int ) > $o ).

tff(pred_def_19407,type,
    v35131: ( state_type * $int ) > $o ).

tff(pred_def_19408,type,
    v35269: state_type > $o ).

tff(pred_def_19409,type,
    v35267: state_type > $o ).

tff(pred_def_19410,type,
    v35273: state_type > $o ).

tff(pred_def_19411,type,
    v35271: state_type > $o ).

tff(pred_def_19412,type,
    v35277: state_type > $o ).

tff(pred_def_19413,type,
    v35275: state_type > $o ).

tff(pred_def_19414,type,
    v35280: state_type > $o ).

tff(pred_def_19415,type,
    v35279: state_type > $o ).

tff(pred_def_19416,type,
    v35265: state_type > $o ).

tff(pred_def_19417,type,
    v35263: state_type > $o ).

tff(pred_def_19418,type,
    v35261: state_type > $o ).

tff(pred_def_19419,type,
    v35259: state_type > $o ).

tff(pred_def_19420,type,
    v35257: state_type > $o ).

tff(pred_def_19421,type,
    v35255: state_type > $o ).

tff(pred_def_19422,type,
    v35253: state_type > $o ).

tff(pred_def_19423,type,
    v35251: state_type > $o ).

tff(pred_def_19424,type,
    v35300: state_type > $o ).

tff(pred_def_19425,type,
    v35298: state_type > $o ).

tff(pred_def_19426,type,
    v35296: state_type > $o ).

tff(pred_def_19427,type,
    v35294: state_type > $o ).

tff(pred_def_19428,type,
    v35292: state_type > $o ).

tff(pred_def_19429,type,
    v35310: state_type > $o ).

tff(pred_def_19430,type,
    v35308: state_type > $o ).

tff(pred_def_19431,type,
    v35306: state_type > $o ).

tff(pred_def_19432,type,
    v35304: state_type > $o ).

tff(pred_def_19433,type,
    v35302: state_type > $o ).

tff(pred_def_19434,type,
    v35314: ( state_type * $int ) > $o ).

tff(pred_def_19435,type,
    v35312: ( state_type * $int ) > $o ).

tff(pred_def_19436,type,
    v35324: state_type > $o ).

tff(pred_def_19437,type,
    v35322: state_type > $o ).

tff(pred_def_19438,type,
    v35330: state_type > $o ).

tff(pred_def_19439,type,
    v35328: state_type > $o ).

tff(pred_def_19440,type,
    v35343: state_type > $o ).

tff(pred_def_19441,type,
    v35341: state_type > $o ).

tff(pred_def_19442,type,
    v35347: state_type > $o ).

tff(pred_def_19443,type,
    v35345: state_type > $o ).

tff(pred_def_19444,type,
    v35351: state_type > $o ).

tff(pred_def_19445,type,
    v35349: state_type > $o ).

tff(pred_def_19446,type,
    v35354: state_type > $o ).

tff(pred_def_19447,type,
    v35353: state_type > $o ).

tff(pred_def_19448,type,
    v35339: state_type > $o ).

tff(pred_def_19449,type,
    v35337: state_type > $o ).

tff(pred_def_19450,type,
    v35334: state_type > $o ).

tff(pred_def_19451,type,
    v35332: state_type > $o ).

tff(pred_def_19452,type,
    v35358: state_type > $o ).

tff(pred_def_19453,type,
    v35356: state_type > $o ).

tff(pred_def_19454,type,
    v35326: state_type > $o ).

tff(pred_def_19455,type,
    v35364: state_type > $o ).

tff(pred_def_19456,type,
    v35366: state_type > $o ).

tff(pred_def_19457,type,
    v35362: state_type > $o ).

tff(pred_def_19458,type,
    v35361: state_type > $o ).

tff(pred_def_19459,type,
    v35372: state_type > $o ).

tff(pred_def_19460,type,
    v35373: state_type > $o ).

tff(pred_def_19461,type,
    v35369: state_type > $o ).

tff(pred_def_19462,type,
    v35371: state_type > $o ).

tff(pred_def_19463,type,
    v35379: state_type > $o ).

tff(pred_def_19464,type,
    v35377: state_type > $o ).

tff(pred_def_19465,type,
    v35381: state_type > $o ).

tff(pred_def_19466,type,
    v35320: state_type > $o ).

tff(pred_def_19467,type,
    v35318: state_type > $o ).

tff(pred_def_19468,type,
    v35316: state_type > $o ).

tff(pred_def_19469,type,
    v35388: state_type > $o ).

tff(pred_def_19470,type,
    v35386: state_type > $o ).

tff(pred_def_19471,type,
    v35385: state_type > $o ).

tff(pred_def_19472,type,
    v35384: state_type > $o ).

tff(pred_def_19473,type,
    v35396: state_type > $o ).

tff(pred_def_19474,type,
    v35397: state_type > $o ).

tff(pred_def_19475,type,
    v35395: state_type > $o ).

tff(pred_def_19476,type,
    v35392: ( state_type * $int ) > $o ).

tff(pred_def_19477,type,
    v35394: ( state_type * $int ) > $o ).

tff(pred_def_19478,type,
    v35290: ( state_type * $int ) > $o ).

tff(pred_def_19479,type,
    v35288: ( state_type * $int ) > $o ).

tff(pred_def_19480,type,
    v35286: ( state_type * $int ) > $o ).

tff(pred_def_19481,type,
    v35284: ( state_type * $int ) > $o ).

tff(pred_def_19482,type,
    v35282: ( state_type * $int ) > $o ).

tff(pred_def_19483,type,
    v35409: state_type > $o ).

tff(pred_def_19484,type,
    v35407: state_type > $o ).

tff(pred_def_19485,type,
    v35405: state_type > $o ).

tff(pred_def_19486,type,
    v35403: state_type > $o ).

tff(pred_def_19487,type,
    v35401: state_type > $o ).

tff(pred_def_19488,type,
    v35417: state_type > $o ).

tff(pred_def_19489,type,
    v35416: ( state_type * $int ) > $o ).

tff(pred_def_19490,type,
    v35415: ( state_type * $int ) > $o ).

tff(pred_def_19491,type,
    v35420: state_type > $o ).

tff(pred_def_19492,type,
    v35419: ( state_type * $int ) > $o ).

tff(pred_def_19493,type,
    v35418: ( state_type * $int ) > $o ).

tff(pred_def_19494,type,
    v35414: ( state_type * $int ) > $o ).

tff(pred_def_19495,type,
    v35423: state_type > $o ).

tff(pred_def_19496,type,
    v35422: ( state_type * $int ) > $o ).

tff(pred_def_19497,type,
    v35421: ( state_type * $int ) > $o ).

tff(pred_def_19498,type,
    v35413: ( state_type * $int ) > $o ).

tff(pred_def_19499,type,
    v35426: state_type > $o ).

tff(pred_def_19500,type,
    v35425: ( state_type * $int ) > $o ).

tff(pred_def_19501,type,
    v35424: ( state_type * $int ) > $o ).

tff(pred_def_19502,type,
    v35412: ( state_type * $int ) > $o ).

tff(pred_def_19503,type,
    v35429: state_type > $o ).

tff(pred_def_19504,type,
    v35428: ( state_type * $int ) > $o ).

tff(pred_def_19505,type,
    v35427: ( state_type * $int ) > $o ).

tff(pred_def_19506,type,
    v35411: ( state_type * $int ) > $o ).

tff(pred_def_19507,type,
    v35432: state_type > $o ).

tff(pred_def_19508,type,
    v35431: ( state_type * $int ) > $o ).

tff(pred_def_19509,type,
    v35430: ( state_type * $int ) > $o ).

tff(pred_def_19510,type,
    v8514: ( state_type * $int ) > $o ).

tff(pred_def_19511,type,
    v8512: ( state_type * $int ) > $o ).

tff(pred_def_19512,type,
    v8508: ( state_type * $int ) > $o ).

tff(pred_def_19513,type,
    v8506: ( state_type * $int ) > $o ).

tff(pred_def_19514,type,
    v8500: state_type > $o ).

tff(pred_def_19515,type,
    v8498: state_type > $o ).

tff(pred_def_19516,type,
    v8496: state_type > $o ).

tff(pred_def_19517,type,
    v35443: ( state_type * $int ) > $o ).

tff(pred_def_19518,type,
    v35441: ( state_type * $int ) > $o ).

tff(pred_def_19519,type,
    v35477: state_type > $o ).

tff(pred_def_19520,type,
    v35475: state_type > $o ).

tff(pred_def_19521,type,
    v35473: state_type > $o ).

tff(pred_def_19522,type,
    v35471: state_type > $o ).

tff(pred_def_19523,type,
    v35469: state_type > $o ).

tff(pred_def_19524,type,
    v35467: state_type > $o ).

tff(pred_def_19525,type,
    v35465: state_type > $o ).

tff(pred_def_19526,type,
    v35491: state_type > $o ).

tff(pred_def_19527,type,
    v35489: state_type > $o ).

tff(pred_def_19528,type,
    v35487: state_type > $o ).

tff(pred_def_19529,type,
    v35485: state_type > $o ).

tff(pred_def_19530,type,
    v35483: state_type > $o ).

tff(pred_def_19531,type,
    v35481: state_type > $o ).

tff(pred_def_19532,type,
    v35479: state_type > $o ).

tff(pred_def_19533,type,
    v35517: state_type > $o ).

tff(pred_def_19534,type,
    v35519: state_type > $o ).

tff(pred_def_19535,type,
    v35518: ( state_type * $int ) > $o ).

tff(pred_def_19536,type,
    v35520: state_type > $o ).

tff(pred_def_19537,type,
    v35515: ( state_type * $int ) > $o ).

tff(pred_def_19538,type,
    v35513: ( state_type * $int ) > $o ).

tff(pred_def_19539,type,
    v35521: ( state_type * $int ) > $o ).

tff(pred_def_19540,type,
    v35511: ( state_type * $int ) > $o ).

tff(pred_def_19541,type,
    v35509: ( state_type * $int ) > $o ).

tff(pred_def_19542,type,
    v35507: state_type > $o ).

tff(pred_def_19543,type,
    v35523: state_type > $o ).

tff(pred_def_19544,type,
    v35505: ( state_type * $int ) > $o ).

tff(pred_def_19545,type,
    v35503: ( state_type * $int ) > $o ).

tff(pred_def_19546,type,
    v35537: ( state_type * $int ) > $o ).

tff(pred_def_19547,type,
    v35535: ( state_type * $int ) > $o ).

tff(pred_def_19548,type,
    v35541: state_type > $o ).

tff(pred_def_19549,type,
    v35539: state_type > $o ).

tff(pred_def_19550,type,
    v35565: state_type > $o ).

tff(pred_def_19551,type,
    v35563: state_type > $o ).

tff(pred_def_19552,type,
    v35561: state_type > $o ).

tff(pred_def_19553,type,
    v35559: state_type > $o ).

tff(pred_def_19554,type,
    v35557: state_type > $o ).

tff(pred_def_19555,type,
    v35555: state_type > $o ).

tff(pred_def_19556,type,
    v35553: state_type > $o ).

tff(pred_def_19557,type,
    v35579: state_type > $o ).

tff(pred_def_19558,type,
    v35577: state_type > $o ).

tff(pred_def_19559,type,
    v35575: state_type > $o ).

tff(pred_def_19560,type,
    v35573: state_type > $o ).

tff(pred_def_19561,type,
    v35571: state_type > $o ).

tff(pred_def_19562,type,
    v35569: state_type > $o ).

tff(pred_def_19563,type,
    v35567: state_type > $o ).

tff(pred_def_19564,type,
    v35595: ( state_type * $int ) > $o ).

tff(pred_def_19565,type,
    v35593: ( state_type * $int ) > $o ).

tff(pred_def_19566,type,
    v35591: ( state_type * $int ) > $o ).

tff(pred_def_19567,type,
    v35589: ( state_type * $int ) > $o ).

tff(pred_def_19568,type,
    v35587: ( state_type * $int ) > $o ).

tff(pred_def_19569,type,
    v35625: ( state_type * $int ) > $o ).

tff(pred_def_19570,type,
    v35627: ( state_type * $int ) > $o ).

tff(pred_def_19571,type,
    v35623: ( state_type * $int ) > $o ).

tff(pred_def_19572,type,
    v35621: ( state_type * $int ) > $o ).

tff(pred_def_19573,type,
    v35619: ( state_type * $int ) > $o ).

tff(pred_def_19574,type,
    v35617: ( state_type * $int ) > $o ).

tff(pred_def_19575,type,
    v35615: state_type > $o ).

tff(pred_def_19576,type,
    v35613: state_type > $o ).

tff(pred_def_19577,type,
    v35631: state_type > $o ).

tff(pred_def_19578,type,
    v35629: state_type > $o ).

tff(pred_def_19579,type,
    v35633: state_type > $o ).

tff(pred_def_19580,type,
    v35611: state_type > $o ).

tff(pred_def_19581,type,
    v35609: state_type > $o ).

tff(pred_def_19582,type,
    v35607: state_type > $o ).

tff(pred_def_19583,type,
    v35605: state_type > $o ).

tff(pred_def_19584,type,
    v35603: state_type > $o ).

tff(pred_def_19585,type,
    v35601: state_type > $o ).

tff(pred_def_19586,type,
    v35599: state_type > $o ).

tff(pred_def_19587,type,
    v35597: state_type > $o ).

tff(pred_def_19588,type,
    v35643: ( state_type * $int ) > $o ).

tff(pred_def_19589,type,
    v35641: ( state_type * $int ) > $o ).

tff(pred_def_19590,type,
    v35639: ( state_type * $int ) > $o ).

tff(pred_def_19591,type,
    v35637: ( state_type * $int ) > $o ).

tff(pred_def_19592,type,
    v35635: ( state_type * $int ) > $o ).

tff(pred_def_19593,type,
    v35673: ( state_type * $int ) > $o ).

tff(pred_def_19594,type,
    v35671: ( state_type * $int ) > $o ).

tff(pred_def_19595,type,
    v35674: ( state_type * $int ) > $o ).

tff(pred_def_19596,type,
    v35669: ( state_type * $int ) > $o ).

tff(pred_def_19597,type,
    v35667: ( state_type * $int ) > $o ).

tff(pred_def_19598,type,
    v35665: ( state_type * $int ) > $o ).

tff(pred_def_19599,type,
    v35663: state_type > $o ).

tff(pred_def_19600,type,
    v35661: state_type > $o ).

tff(pred_def_19601,type,
    v35678: state_type > $o ).

tff(pred_def_19602,type,
    v35676: state_type > $o ).

tff(pred_def_19603,type,
    v35680: state_type > $o ).

tff(pred_def_19604,type,
    v35659: state_type > $o ).

tff(pred_def_19605,type,
    v35657: state_type > $o ).

tff(pred_def_19606,type,
    v35655: state_type > $o ).

tff(pred_def_19607,type,
    v35653: state_type > $o ).

tff(pred_def_19608,type,
    v35651: state_type > $o ).

tff(pred_def_19609,type,
    v35649: state_type > $o ).

tff(pred_def_19610,type,
    v35647: state_type > $o ).

tff(pred_def_19611,type,
    v35645: state_type > $o ).

tff(pred_def_19612,type,
    v35690: ( state_type * $int ) > $o ).

tff(pred_def_19613,type,
    v35688: ( state_type * $int ) > $o ).

tff(pred_def_19614,type,
    v35686: ( state_type * $int ) > $o ).

tff(pred_def_19615,type,
    v35684: ( state_type * $int ) > $o ).

tff(pred_def_19616,type,
    v35682: ( state_type * $int ) > $o ).

tff(pred_def_19617,type,
    v35710: state_type > $o ).

tff(pred_def_19618,type,
    v35708: state_type > $o ).

tff(pred_def_19619,type,
    v35714: state_type > $o ).

tff(pred_def_19620,type,
    v35712: state_type > $o ).

tff(pred_def_19621,type,
    v35716: state_type > $o ).

tff(pred_def_19622,type,
    v35706: state_type > $o ).

tff(pred_def_19623,type,
    v35704: state_type > $o ).

tff(pred_def_19624,type,
    v35702: state_type > $o ).

tff(pred_def_19625,type,
    v35700: state_type > $o ).

tff(pred_def_19626,type,
    v35698: state_type > $o ).

tff(pred_def_19627,type,
    v35696: state_type > $o ).

tff(pred_def_19628,type,
    v35694: state_type > $o ).

tff(pred_def_19629,type,
    v35692: state_type > $o ).

tff(pred_def_19630,type,
    v35726: ( state_type * $int ) > $o ).

tff(pred_def_19631,type,
    v35724: ( state_type * $int ) > $o ).

tff(pred_def_19632,type,
    v35722: ( state_type * $int ) > $o ).

tff(pred_def_19633,type,
    v35720: ( state_type * $int ) > $o ).

tff(pred_def_19634,type,
    v35718: ( state_type * $int ) > $o ).

tff(pred_def_19635,type,
    v35746: state_type > $o ).

tff(pred_def_19636,type,
    v35744: state_type > $o ).

tff(pred_def_19637,type,
    v35750: state_type > $o ).

tff(pred_def_19638,type,
    v35748: state_type > $o ).

tff(pred_def_19639,type,
    v35752: state_type > $o ).

tff(pred_def_19640,type,
    v35742: state_type > $o ).

tff(pred_def_19641,type,
    v35740: state_type > $o ).

tff(pred_def_19642,type,
    v35738: state_type > $o ).

tff(pred_def_19643,type,
    v35736: state_type > $o ).

tff(pred_def_19644,type,
    v35734: state_type > $o ).

tff(pred_def_19645,type,
    v35732: state_type > $o ).

tff(pred_def_19646,type,
    v35730: state_type > $o ).

tff(pred_def_19647,type,
    v35728: state_type > $o ).

tff(pred_def_19648,type,
    v35758: state_type > $o ).

tff(pred_def_19649,type,
    v35757: ( state_type * $int ) > $o ).

tff(pred_def_19650,type,
    v35756: ( state_type * $int ) > $o ).

tff(pred_def_19651,type,
    v35761: state_type > $o ).

tff(pred_def_19652,type,
    v35760: ( state_type * $int ) > $o ).

tff(pred_def_19653,type,
    v35759: ( state_type * $int ) > $o ).

tff(pred_def_19654,type,
    v35755: ( state_type * $int ) > $o ).

tff(pred_def_19655,type,
    v35764: state_type > $o ).

tff(pred_def_19656,type,
    v35763: ( state_type * $int ) > $o ).

tff(pred_def_19657,type,
    v35762: ( state_type * $int ) > $o ).

tff(pred_def_19658,type,
    v35754: ( state_type * $int ) > $o ).

tff(pred_def_19659,type,
    v35767: state_type > $o ).

tff(pred_def_19660,type,
    v35766: ( state_type * $int ) > $o ).

tff(pred_def_19661,type,
    v35765: ( state_type * $int ) > $o ).

tff(pred_def_19662,type,
    v35585: ( state_type * $int ) > $o ).

tff(pred_def_19663,type,
    v35583: ( state_type * $int ) > $o ).

tff(pred_def_19664,type,
    v35581: ( state_type * $int ) > $o ).

tff(pred_def_19665,type,
    v35779: state_type > $o ).

tff(pred_def_19666,type,
    v35777: state_type > $o ).

tff(pred_def_19667,type,
    v35775: state_type > $o ).

tff(pred_def_19668,type,
    v35789: state_type > $o ).

tff(pred_def_19669,type,
    v35787: state_type > $o ).

tff(pred_def_19670,type,
    v35785: state_type > $o ).

tff(pred_def_19671,type,
    v35783: state_type > $o ).

tff(pred_def_19672,type,
    v35781: state_type > $o ).

tff(pred_def_19673,type,
    v35791: state_type > $o ).

tff(pred_def_19674,type,
    v35773: state_type > $o ).

tff(pred_def_19675,type,
    v35771: state_type > $o ).

tff(pred_def_19676,type,
    v35769: state_type > $o ).

tff(pred_def_19677,type,
    v35798: state_type > $o ).

tff(pred_def_19678,type,
    v35796: state_type > $o ).

tff(pred_def_19679,type,
    v35795: state_type > $o ).

tff(pred_def_19680,type,
    v35794: state_type > $o ).

tff(pred_def_19681,type,
    v35806: state_type > $o ).

tff(pred_def_19682,type,
    v35807: state_type > $o ).

tff(pred_def_19683,type,
    v35805: state_type > $o ).

tff(pred_def_19684,type,
    v35802: ( state_type * $int ) > $o ).

tff(pred_def_19685,type,
    v35804: ( state_type * $int ) > $o ).

tff(pred_def_19686,type,
    v35551: ( state_type * $int ) > $o ).

tff(pred_def_19687,type,
    v35549: ( state_type * $int ) > $o ).

tff(pred_def_19688,type,
    v35547: ( state_type * $int ) > $o ).

tff(pred_def_19689,type,
    v35545: ( state_type * $int ) > $o ).

tff(pred_def_19690,type,
    v35543: ( state_type * $int ) > $o ).

tff(pred_def_19691,type,
    v35813: state_type > $o ).

tff(pred_def_19692,type,
    v35811: state_type > $o ).

tff(pred_def_19693,type,
    v35817: state_type > $o ).

tff(pred_def_19694,type,
    v35816: ( state_type * $int ) > $o ).

tff(pred_def_19695,type,
    v35815: ( state_type * $int ) > $o ).

tff(pred_def_19696,type,
    v35820: state_type > $o ).

tff(pred_def_19697,type,
    v35819: ( state_type * $int ) > $o ).

tff(pred_def_19698,type,
    v35818: ( state_type * $int ) > $o ).

tff(pred_def_19699,type,
    v35533: ( state_type * $int ) > $o ).

tff(pred_def_19700,type,
    v35531: ( state_type * $int ) > $o ).

tff(pred_def_19701,type,
    v35529: ( state_type * $int ) > $o ).

tff(pred_def_19702,type,
    v35527: ( state_type * $int ) > $o ).

tff(pred_def_19703,type,
    v35525: ( state_type * $int ) > $o ).

tff(pred_def_19704,type,
    v35501: ( state_type * $int ) > $o ).

tff(pred_def_19705,type,
    v35499: ( state_type * $int ) > $o ).

tff(pred_def_19706,type,
    v35497: ( state_type * $int ) > $o ).

tff(pred_def_19707,type,
    v35495: ( state_type * $int ) > $o ).

tff(pred_def_19708,type,
    v35493: ( state_type * $int ) > $o ).

tff(pred_def_19709,type,
    v35833: state_type > $o ).

tff(pred_def_19710,type,
    v35831: state_type > $o ).

tff(pred_def_19711,type,
    v35829: state_type > $o ).

tff(pred_def_19712,type,
    v35839: state_type > $o ).

tff(pred_def_19713,type,
    v35837: state_type > $o ).

tff(pred_def_19714,type,
    v35857: ( state_type * $int ) > $o ).

tff(pred_def_19715,type,
    v35859: ( state_type * $int ) > $o ).

tff(pred_def_19716,type,
    v35855: ( state_type * $int ) > $o ).

tff(pred_def_19717,type,
    v35853: state_type > $o ).

tff(pred_def_19718,type,
    v35851: state_type > $o ).

tff(pred_def_19719,type,
    v35863: state_type > $o ).

tff(pred_def_19720,type,
    v35861: state_type > $o ).

tff(pred_def_19721,type,
    v35867: state_type > $o ).

tff(pred_def_19722,type,
    v35865: state_type > $o ).

tff(pred_def_19723,type,
    v35870: state_type > $o ).

tff(pred_def_19724,type,
    v35869: state_type > $o ).

tff(pred_def_19725,type,
    v35849: state_type > $o ).

tff(pred_def_19726,type,
    v35847: state_type > $o ).

tff(pred_def_19727,type,
    v35845: state_type > $o ).

tff(pred_def_19728,type,
    v35843: state_type > $o ).

tff(pred_def_19729,type,
    v35841: state_type > $o ).

tff(pred_def_19730,type,
    v35878: state_type > $o ).

tff(pred_def_19731,type,
    v35876: state_type > $o ).

tff(pred_def_19732,type,
    v35874: state_type > $o ).

tff(pred_def_19733,type,
    v35872: state_type > $o ).

tff(pred_def_19734,type,
    v35835: state_type > $o ).

tff(pred_def_19735,type,
    v35884: state_type > $o ).

tff(pred_def_19736,type,
    v35886: state_type > $o ).

tff(pred_def_19737,type,
    v35882: state_type > $o ).

tff(pred_def_19738,type,
    v35881: state_type > $o ).

tff(pred_def_19739,type,
    v35892: state_type > $o ).

tff(pred_def_19740,type,
    v35893: state_type > $o ).

tff(pred_def_19741,type,
    v35889: state_type > $o ).

tff(pred_def_19742,type,
    v35891: state_type > $o ).

tff(pred_def_19743,type,
    v35903: state_type > $o ).

tff(pred_def_19744,type,
    v35901: state_type > $o ).

tff(pred_def_19745,type,
    v35899: state_type > $o ).

tff(pred_def_19746,type,
    v35897: state_type > $o ).

tff(pred_def_19747,type,
    v35905: state_type > $o ).

tff(pred_def_19748,type,
    v35827: state_type > $o ).

tff(pred_def_19749,type,
    v35825: state_type > $o ).

tff(pred_def_19750,type,
    v35823: state_type > $o ).

tff(pred_def_19751,type,
    v35912: state_type > $o ).

tff(pred_def_19752,type,
    v35910: state_type > $o ).

tff(pred_def_19753,type,
    v35909: state_type > $o ).

tff(pred_def_19754,type,
    v35908: state_type > $o ).

tff(pred_def_19755,type,
    v35920: state_type > $o ).

tff(pred_def_19756,type,
    v35921: state_type > $o ).

tff(pred_def_19757,type,
    v35919: state_type > $o ).

tff(pred_def_19758,type,
    v35916: ( state_type * $int ) > $o ).

tff(pred_def_19759,type,
    v35918: ( state_type * $int ) > $o ).

tff(pred_def_19760,type,
    v35463: ( state_type * $int ) > $o ).

tff(pred_def_19761,type,
    v35461: ( state_type * $int ) > $o ).

tff(pred_def_19762,type,
    v35459: ( state_type * $int ) > $o ).

tff(pred_def_19763,type,
    v35457: ( state_type * $int ) > $o ).

tff(pred_def_19764,type,
    v35455: ( state_type * $int ) > $o ).

tff(pred_def_19765,type,
    v35957: state_type > $o ).

tff(pred_def_19766,type,
    v35955: state_type > $o ).

tff(pred_def_19767,type,
    v35953: state_type > $o ).

tff(pred_def_19768,type,
    v35951: state_type > $o ).

tff(pred_def_19769,type,
    v35949: state_type > $o ).

tff(pred_def_19770,type,
    v35947: state_type > $o ).

tff(pred_def_19771,type,
    v35967: state_type > $o ).

tff(pred_def_19772,type,
    v35965: state_type > $o ).

tff(pred_def_19773,type,
    v35963: state_type > $o ).

tff(pred_def_19774,type,
    v35961: state_type > $o ).

tff(pred_def_19775,type,
    v35959: state_type > $o ).

tff(pred_def_19776,type,
    v35994: state_type > $o ).

tff(pred_def_19777,type,
    v35993: ( state_type * $int ) > $o ).

tff(pred_def_19778,type,
    v35992: ( state_type * $int ) > $o ).

tff(pred_def_19779,type,
    v35990: ( state_type * $int ) > $o ).

tff(pred_def_19780,type,
    v36010: state_type > $o ).

tff(pred_def_19781,type,
    v36011: ( state_type * $int ) > $o ).

tff(pred_def_19782,type,
    v36012: state_type > $o ).

tff(pred_def_19783,type,
    v36008: ( state_type * $int ) > $o ).

tff(pred_def_19784,type,
    v36006: ( state_type * $int ) > $o ).

tff(pred_def_19785,type,
    v36036: ( state_type * $int ) > $o ).

tff(pred_def_19786,type,
    v35945: ( state_type * $int ) > $o ).

tff(pred_def_19787,type,
    v36034: ( state_type * $int ) > $o ).

tff(pred_def_19788,type,
    v36037: ( state_type * $int ) > $o ).

tff(pred_def_19789,type,
    v36032: ( state_type * $int ) > $o ).

tff(pred_def_19790,type,
    v36030: ( state_type * $int ) > $o ).

tff(pred_def_19791,type,
    v36028: ( state_type * $int ) > $o ).

tff(pred_def_19792,type,
    v36026: state_type > $o ).

tff(pred_def_19793,type,
    v36024: state_type > $o ).

tff(pred_def_19794,type,
    v36043: state_type > $o ).

tff(pred_def_19795,type,
    v35983: state_type > $o ).

tff(pred_def_19796,type,
    v36042: ( state_type * $int ) > $o ).

tff(pred_def_19797,type,
    v35981: ( state_type * $int ) > $o ).

tff(pred_def_19798,type,
    v35979: ( state_type * $int ) > $o ).

tff(pred_def_19799,type,
    v36058: ( state_type * $int ) > $o ).

tff(pred_def_19800,type,
    v36057: ( state_type * $int ) > $o ).

tff(pred_def_19801,type,
    v36055: ( state_type * $int ) > $o ).

tff(pred_def_19802,type,
    v36062: state_type > $o ).

tff(pred_def_19803,type,
    v36060: state_type > $o ).

tff(pred_def_19804,type,
    v36073: ( state_type * $int ) > $o ).

tff(pred_def_19805,type,
    v36072: state_type > $o ).

tff(pred_def_19806,type,
    v36076: state_type > $o ).

tff(pred_def_19807,type,
    v36077: state_type > $o ).

tff(pred_def_19808,type,
    v36075: state_type > $o ).

tff(pred_def_19809,type,
    v36078: state_type > $o ).

tff(pred_def_19810,type,
    v36074: state_type > $o ).

tff(pred_def_19811,type,
    v36071: state_type > $o ).

tff(pred_def_19812,type,
    v36079: state_type > $o ).

tff(pred_def_19813,type,
    v36070: state_type > $o ).

tff(pred_def_19814,type,
    v36082: state_type > $o ).

tff(pred_def_19815,type,
    v36083: state_type > $o ).

tff(pred_def_19816,type,
    v36081: state_type > $o ).

tff(pred_def_19817,type,
    v36084: state_type > $o ).

tff(pred_def_19818,type,
    v36080: state_type > $o ).

tff(pred_def_19819,type,
    v36069: state_type > $o ).

tff(pred_def_19820,type,
    v36085: state_type > $o ).

tff(pred_def_19821,type,
    v36068: state_type > $o ).

tff(pred_def_19822,type,
    v36067: state_type > $o ).

tff(pred_def_19823,type,
    v36089: state_type > $o ).

tff(pred_def_19824,type,
    v36090: state_type > $o ).

tff(pred_def_19825,type,
    v36088: state_type > $o ).

tff(pred_def_19826,type,
    v36091: state_type > $o ).

tff(pred_def_19827,type,
    v36087: state_type > $o ).

tff(pred_def_19828,type,
    v36086: state_type > $o ).

tff(pred_def_19829,type,
    v36066: state_type > $o ).

tff(pred_def_19830,type,
    v36092: state_type > $o ).

tff(pred_def_19831,type,
    v36065: state_type > $o ).

tff(pred_def_19832,type,
    v36095: state_type > $o ).

tff(pred_def_19833,type,
    v36096: state_type > $o ).

tff(pred_def_19834,type,
    v36094: state_type > $o ).

tff(pred_def_19835,type,
    v36097: state_type > $o ).

tff(pred_def_19836,type,
    v36093: state_type > $o ).

tff(pred_def_19837,type,
    v36100: state_type > $o ).

tff(pred_def_19838,type,
    v36101: state_type > $o ).

tff(pred_def_19839,type,
    v36099: state_type > $o ).

tff(pred_def_19840,type,
    v36102: state_type > $o ).

tff(pred_def_19841,type,
    v36098: state_type > $o ).

tff(pred_def_19842,type,
    v36105: state_type > $o ).

tff(pred_def_19843,type,
    v36106: state_type > $o ).

tff(pred_def_19844,type,
    v36104: state_type > $o ).

tff(pred_def_19845,type,
    v36107: state_type > $o ).

tff(pred_def_19846,type,
    v36103: state_type > $o ).

tff(pred_def_19847,type,
    v36063: ( state_type * $int ) > $o ).

tff(pred_def_19848,type,
    v36053: ( state_type * $int ) > $o ).

tff(pred_def_19849,type,
    v36051: ( state_type * $int ) > $o ).

tff(pred_def_19850,type,
    v36049: ( state_type * $int ) > $o ).

tff(pred_def_19851,type,
    v36047: ( state_type * $int ) > $o ).

tff(pred_def_19852,type,
    v36045: ( state_type * $int ) > $o ).

tff(pred_def_19853,type,
    v36108: ( state_type * $int ) > $o ).

tff(pred_def_19854,type,
    v35977: ( state_type * $int ) > $o ).

tff(pred_def_19855,type,
    v35975: ( state_type * $int ) > $o ).

tff(pred_def_19856,type,
    v35973: ( state_type * $int ) > $o ).

tff(pred_def_19857,type,
    v36109: ( state_type * $int ) > $o ).

tff(pred_def_19858,type,
    v36110: ( state_type * $int ) > $o ).

tff(pred_def_19859,type,
    v35971: ( state_type * $int ) > $o ).

tff(pred_def_19860,type,
    v35969: ( state_type * $int ) > $o ).

tff(pred_def_19861,type,
    v36120: state_type > $o ).

tff(pred_def_19862,type,
    v36118: state_type > $o ).

tff(pred_def_19863,type,
    v36126: state_type > $o ).

tff(pred_def_19864,type,
    v36124: state_type > $o ).

tff(pred_def_19865,type,
    v36130: state_type > $o ).

tff(pred_def_19866,type,
    v36128: state_type > $o ).

tff(pred_def_19867,type,
    v36134: state_type > $o ).

tff(pred_def_19868,type,
    v36132: state_type > $o ).

tff(pred_def_19869,type,
    v36122: state_type > $o ).

tff(pred_def_19870,type,
    v36140: state_type > $o ).

tff(pred_def_19871,type,
    v36142: state_type > $o ).

tff(pred_def_19872,type,
    v36138: state_type > $o ).

tff(pred_def_19873,type,
    v36137: state_type > $o ).

tff(pred_def_19874,type,
    v36148: state_type > $o ).

tff(pred_def_19875,type,
    v36149: state_type > $o ).

tff(pred_def_19876,type,
    v36145: state_type > $o ).

tff(pred_def_19877,type,
    v36147: state_type > $o ).

tff(pred_def_19878,type,
    v36155: state_type > $o ).

tff(pred_def_19879,type,
    v36153: state_type > $o ).

tff(pred_def_19880,type,
    v36157: state_type > $o ).

tff(pred_def_19881,type,
    v36116: state_type > $o ).

tff(pred_def_19882,type,
    v36114: state_type > $o ).

tff(pred_def_19883,type,
    v36112: state_type > $o ).

tff(pred_def_19884,type,
    v36164: state_type > $o ).

tff(pred_def_19885,type,
    v36162: state_type > $o ).

tff(pred_def_19886,type,
    v36161: state_type > $o ).

tff(pred_def_19887,type,
    v36160: state_type > $o ).

tff(pred_def_19888,type,
    v36172: state_type > $o ).

tff(pred_def_19889,type,
    v36173: state_type > $o ).

tff(pred_def_19890,type,
    v36171: state_type > $o ).

tff(pred_def_19891,type,
    v36168: ( state_type * $int ) > $o ).

tff(pred_def_19892,type,
    v36170: ( state_type * $int ) > $o ).

tff(pred_def_19893,type,
    v36159: ( state_type * $int ) > $o ).

tff(pred_def_19894,type,
    v36041: state_type > $o ).

tff(pred_def_19895,type,
    v36039: state_type > $o ).

tff(pred_def_19896,type,
    v36185: state_type > $o ).

tff(pred_def_19897,type,
    v36183: state_type > $o ).

tff(pred_def_19898,type,
    v36182: state_type > $o ).

tff(pred_def_19899,type,
    v36181: ( state_type * $int ) > $o ).

tff(pred_def_19900,type,
    v36179: state_type > $o ).

tff(pred_def_19901,type,
    v36177: state_type > $o ).

tff(pred_def_19902,type,
    v36190: state_type > $o ).

tff(pred_def_19903,type,
    v36189: state_type > $o ).

tff(pred_def_19904,type,
    v36022: state_type > $o ).

tff(pred_def_19905,type,
    v36020: state_type > $o ).

tff(pred_def_19906,type,
    v36018: state_type > $o ).

tff(pred_def_19907,type,
    v36191: ( state_type * $int ) > $o ).

tff(pred_def_19908,type,
    v36192: state_type > $o ).

tff(pred_def_19909,type,
    v36016: ( state_type * $int ) > $o ).

tff(pred_def_19910,type,
    v36014: ( state_type * $int ) > $o ).

tff(pred_def_19911,type,
    v36193: ( state_type * $int ) > $o ).

tff(pred_def_19912,type,
    v36004: ( state_type * $int ) > $o ).

tff(pred_def_19913,type,
    v36002: ( state_type * $int ) > $o ).

tff(pred_def_19914,type,
    v36000: state_type > $o ).

tff(pred_def_19915,type,
    v36194: ( state_type * $int ) > $o ).

tff(pred_def_19916,type,
    v36195: state_type > $o ).

tff(pred_def_19917,type,
    v35998: ( state_type * $int ) > $o ).

tff(pred_def_19918,type,
    v35996: ( state_type * $int ) > $o ).

tff(pred_def_19919,type,
    v36196: ( state_type * $int ) > $o ).

tff(pred_def_19920,type,
    v35988: ( state_type * $int ) > $o ).

tff(pred_def_19921,type,
    v35986: ( state_type * $int ) > $o ).

tff(pred_def_19922,type,
    v36202: state_type > $o ).

tff(pred_def_19923,type,
    v36200: state_type > $o ).

tff(pred_def_19924,type,
    v36199: state_type > $o ).

tff(pred_def_19925,type,
    v36198: ( state_type * $int ) > $o ).

tff(pred_def_19926,type,
    v35943: state_type > $o ).

tff(pred_def_19927,type,
    v35941: state_type > $o ).

tff(pred_def_19928,type,
    v36208: state_type > $o ).

tff(pred_def_19929,type,
    v36206: state_type > $o ).

tff(pred_def_19930,type,
    v36212: state_type > $o ).

tff(pred_def_19931,type,
    v36210: state_type > $o ).

tff(pred_def_19932,type,
    v36215: state_type > $o ).

tff(pred_def_19933,type,
    v36214: state_type > $o ).

tff(pred_def_19934,type,
    v35939: state_type > $o ).

tff(pred_def_19935,type,
    v35937: state_type > $o ).

tff(pred_def_19936,type,
    v35935: state_type > $o ).

tff(pred_def_19937,type,
    v35933: state_type > $o ).

tff(pred_def_19938,type,
    v35931: state_type > $o ).

tff(pred_def_19939,type,
    v35929: state_type > $o ).

tff(pred_def_19940,type,
    v35927: state_type > $o ).

tff(pred_def_19941,type,
    v35925: state_type > $o ).

tff(pred_def_19942,type,
    v36235: state_type > $o ).

tff(pred_def_19943,type,
    v36233: state_type > $o ).

tff(pred_def_19944,type,
    v36231: state_type > $o ).

tff(pred_def_19945,type,
    v36229: state_type > $o ).

tff(pred_def_19946,type,
    v36227: state_type > $o ).

tff(pred_def_19947,type,
    v36245: state_type > $o ).

tff(pred_def_19948,type,
    v36243: state_type > $o ).

tff(pred_def_19949,type,
    v36241: state_type > $o ).

tff(pred_def_19950,type,
    v36239: state_type > $o ).

tff(pred_def_19951,type,
    v36237: state_type > $o ).

tff(pred_def_19952,type,
    v36249: ( state_type * $int ) > $o ).

tff(pred_def_19953,type,
    v36247: ( state_type * $int ) > $o ).

tff(pred_def_19954,type,
    v36259: state_type > $o ).

tff(pred_def_19955,type,
    v36257: state_type > $o ).

tff(pred_def_19956,type,
    v36265: state_type > $o ).

tff(pred_def_19957,type,
    v36263: state_type > $o ).

tff(pred_def_19958,type,
    v36289: ( state_type * $int ) > $o ).

tff(pred_def_19959,type,
    v36287: ( state_type * $int ) > $o ).

tff(pred_def_19960,type,
    v36290: ( state_type * $int ) > $o ).

tff(pred_def_19961,type,
    v36285: ( state_type * $int ) > $o ).

tff(pred_def_19962,type,
    v36283: ( state_type * $int ) > $o ).

tff(pred_def_19963,type,
    v36281: ( state_type * $int ) > $o ).

tff(pred_def_19964,type,
    v36279: state_type > $o ).

tff(pred_def_19965,type,
    v36277: state_type > $o ).

tff(pred_def_19966,type,
    v36294: state_type > $o ).

tff(pred_def_19967,type,
    v36292: state_type > $o ).

tff(pred_def_19968,type,
    v36298: state_type > $o ).

tff(pred_def_19969,type,
    v36296: state_type > $o ).

tff(pred_def_19970,type,
    v36301: state_type > $o ).

tff(pred_def_19971,type,
    v36300: state_type > $o ).

tff(pred_def_19972,type,
    v36275: state_type > $o ).

tff(pred_def_19973,type,
    v36273: state_type > $o ).

tff(pred_def_19974,type,
    v36271: state_type > $o ).

tff(pred_def_19975,type,
    v36269: state_type > $o ).

tff(pred_def_19976,type,
    v36267: state_type > $o ).

tff(pred_def_19977,type,
    v36305: state_type > $o ).

tff(pred_def_19978,type,
    v36303: state_type > $o ).

tff(pred_def_19979,type,
    v36261: state_type > $o ).

tff(pred_def_19980,type,
    v36311: state_type > $o ).

tff(pred_def_19981,type,
    v36313: state_type > $o ).

tff(pred_def_19982,type,
    v36309: state_type > $o ).

tff(pred_def_19983,type,
    v36308: state_type > $o ).

tff(pred_def_19984,type,
    v36319: state_type > $o ).

tff(pred_def_19985,type,
    v36320: state_type > $o ).

tff(pred_def_19986,type,
    v36316: state_type > $o ).

tff(pred_def_19987,type,
    v36318: state_type > $o ).

tff(pred_def_19988,type,
    v36326: state_type > $o ).

tff(pred_def_19989,type,
    v36324: state_type > $o ).

tff(pred_def_19990,type,
    v36328: state_type > $o ).

tff(pred_def_19991,type,
    v36255: state_type > $o ).

tff(pred_def_19992,type,
    v36253: state_type > $o ).

tff(pred_def_19993,type,
    v36251: state_type > $o ).

tff(pred_def_19994,type,
    v36335: state_type > $o ).

tff(pred_def_19995,type,
    v36333: state_type > $o ).

tff(pred_def_19996,type,
    v36332: state_type > $o ).

tff(pred_def_19997,type,
    v36331: state_type > $o ).

tff(pred_def_19998,type,
    v36343: state_type > $o ).

tff(pred_def_19999,type,
    v36344: state_type > $o ).

tff(pred_def_20000,type,
    v36342: state_type > $o ).

tff(pred_def_20001,type,
    v36339: ( state_type * $int ) > $o ).

tff(pred_def_20002,type,
    v36341: ( state_type * $int ) > $o ).

tff(pred_def_20003,type,
    v36225: ( state_type * $int ) > $o ).

tff(pred_def_20004,type,
    v36223: ( state_type * $int ) > $o ).

tff(pred_def_20005,type,
    v36221: ( state_type * $int ) > $o ).

tff(pred_def_20006,type,
    v36219: ( state_type * $int ) > $o ).

tff(pred_def_20007,type,
    v36217: ( state_type * $int ) > $o ).

tff(pred_def_20008,type,
    v36366: state_type > $o ).

tff(pred_def_20009,type,
    v36364: state_type > $o ).

tff(pred_def_20010,type,
    v36370: state_type > $o ).

tff(pred_def_20011,type,
    v36368: state_type > $o ).

tff(pred_def_20012,type,
    v36374: state_type > $o ).

tff(pred_def_20013,type,
    v36372: state_type > $o ).

tff(pred_def_20014,type,
    v36377: state_type > $o ).

tff(pred_def_20015,type,
    v36376: state_type > $o ).

tff(pred_def_20016,type,
    v36362: state_type > $o ).

tff(pred_def_20017,type,
    v36360: state_type > $o ).

tff(pred_def_20018,type,
    v36358: state_type > $o ).

tff(pred_def_20019,type,
    v36356: state_type > $o ).

tff(pred_def_20020,type,
    v36354: state_type > $o ).

tff(pred_def_20021,type,
    v36352: state_type > $o ).

tff(pred_def_20022,type,
    v36350: state_type > $o ).

tff(pred_def_20023,type,
    v36348: state_type > $o ).

tff(pred_def_20024,type,
    v36397: state_type > $o ).

tff(pred_def_20025,type,
    v36395: state_type > $o ).

tff(pred_def_20026,type,
    v36393: state_type > $o ).

tff(pred_def_20027,type,
    v36391: state_type > $o ).

tff(pred_def_20028,type,
    v36389: state_type > $o ).

tff(pred_def_20029,type,
    v36407: state_type > $o ).

tff(pred_def_20030,type,
    v36405: state_type > $o ).

tff(pred_def_20031,type,
    v36403: state_type > $o ).

tff(pred_def_20032,type,
    v36401: state_type > $o ).

tff(pred_def_20033,type,
    v36399: state_type > $o ).

tff(pred_def_20034,type,
    v36411: ( state_type * $int ) > $o ).

tff(pred_def_20035,type,
    v36409: ( state_type * $int ) > $o ).

tff(pred_def_20036,type,
    v36421: state_type > $o ).

tff(pred_def_20037,type,
    v36419: state_type > $o ).

tff(pred_def_20038,type,
    v36427: state_type > $o ).

tff(pred_def_20039,type,
    v36425: state_type > $o ).

tff(pred_def_20040,type,
    v36441: state_type > $o ).

tff(pred_def_20041,type,
    v36439: state_type > $o ).

tff(pred_def_20042,type,
    v36445: state_type > $o ).

tff(pred_def_20043,type,
    v36443: state_type > $o ).

tff(pred_def_20044,type,
    v36449: state_type > $o ).

tff(pred_def_20045,type,
    v36447: state_type > $o ).

tff(pred_def_20046,type,
    v36452: state_type > $o ).

tff(pred_def_20047,type,
    v36451: state_type > $o ).

tff(pred_def_20048,type,
    v36437: state_type > $o ).

tff(pred_def_20049,type,
    v36435: state_type > $o ).

tff(pred_def_20050,type,
    v36433: state_type > $o ).

tff(pred_def_20051,type,
    v36431: state_type > $o ).

tff(pred_def_20052,type,
    v36429: state_type > $o ).

tff(pred_def_20053,type,
    v36456: state_type > $o ).

tff(pred_def_20054,type,
    v36454: state_type > $o ).

tff(pred_def_20055,type,
    v36423: state_type > $o ).

tff(pred_def_20056,type,
    v36462: state_type > $o ).

tff(pred_def_20057,type,
    v36464: state_type > $o ).

tff(pred_def_20058,type,
    v36460: state_type > $o ).

tff(pred_def_20059,type,
    v36459: state_type > $o ).

tff(pred_def_20060,type,
    v36470: state_type > $o ).

tff(pred_def_20061,type,
    v36471: state_type > $o ).

tff(pred_def_20062,type,
    v36467: state_type > $o ).

tff(pred_def_20063,type,
    v36469: state_type > $o ).

tff(pred_def_20064,type,
    v36477: state_type > $o ).

tff(pred_def_20065,type,
    v36475: state_type > $o ).

tff(pred_def_20066,type,
    v36479: state_type > $o ).

tff(pred_def_20067,type,
    v36417: state_type > $o ).

tff(pred_def_20068,type,
    v36415: state_type > $o ).

tff(pred_def_20069,type,
    v36413: state_type > $o ).

tff(pred_def_20070,type,
    v36486: state_type > $o ).

tff(pred_def_20071,type,
    v36484: state_type > $o ).

tff(pred_def_20072,type,
    v36483: state_type > $o ).

tff(pred_def_20073,type,
    v36482: state_type > $o ).

tff(pred_def_20074,type,
    v36494: state_type > $o ).

tff(pred_def_20075,type,
    v36495: state_type > $o ).

tff(pred_def_20076,type,
    v36493: state_type > $o ).

tff(pred_def_20077,type,
    v36490: ( state_type * $int ) > $o ).

tff(pred_def_20078,type,
    v36492: ( state_type * $int ) > $o ).

tff(pred_def_20079,type,
    v36387: ( state_type * $int ) > $o ).

tff(pred_def_20080,type,
    v36385: ( state_type * $int ) > $o ).

tff(pred_def_20081,type,
    v36383: ( state_type * $int ) > $o ).

tff(pred_def_20082,type,
    v36381: ( state_type * $int ) > $o ).

tff(pred_def_20083,type,
    v36379: ( state_type * $int ) > $o ).

tff(pred_def_20084,type,
    v36517: state_type > $o ).

tff(pred_def_20085,type,
    v36515: state_type > $o ).

tff(pred_def_20086,type,
    v36521: state_type > $o ).

tff(pred_def_20087,type,
    v36519: state_type > $o ).

tff(pred_def_20088,type,
    v36525: state_type > $o ).

tff(pred_def_20089,type,
    v36523: state_type > $o ).

tff(pred_def_20090,type,
    v36528: state_type > $o ).

tff(pred_def_20091,type,
    v36527: state_type > $o ).

tff(pred_def_20092,type,
    v36513: state_type > $o ).

tff(pred_def_20093,type,
    v36511: state_type > $o ).

tff(pred_def_20094,type,
    v36509: state_type > $o ).

tff(pred_def_20095,type,
    v36507: state_type > $o ).

tff(pred_def_20096,type,
    v36505: state_type > $o ).

tff(pred_def_20097,type,
    v36503: state_type > $o ).

tff(pred_def_20098,type,
    v36501: state_type > $o ).

tff(pred_def_20099,type,
    v36499: state_type > $o ).

tff(pred_def_20100,type,
    v36548: state_type > $o ).

tff(pred_def_20101,type,
    v36546: state_type > $o ).

tff(pred_def_20102,type,
    v36544: state_type > $o ).

tff(pred_def_20103,type,
    v36542: state_type > $o ).

tff(pred_def_20104,type,
    v36540: state_type > $o ).

tff(pred_def_20105,type,
    v36558: state_type > $o ).

tff(pred_def_20106,type,
    v36556: state_type > $o ).

tff(pred_def_20107,type,
    v36554: state_type > $o ).

tff(pred_def_20108,type,
    v36552: state_type > $o ).

tff(pred_def_20109,type,
    v36550: state_type > $o ).

tff(pred_def_20110,type,
    v36562: ( state_type * $int ) > $o ).

tff(pred_def_20111,type,
    v36560: ( state_type * $int ) > $o ).

tff(pred_def_20112,type,
    v36572: state_type > $o ).

tff(pred_def_20113,type,
    v36570: state_type > $o ).

tff(pred_def_20114,type,
    v36578: state_type > $o ).

tff(pred_def_20115,type,
    v36576: state_type > $o ).

tff(pred_def_20116,type,
    v36592: state_type > $o ).

tff(pred_def_20117,type,
    v36590: state_type > $o ).

tff(pred_def_20118,type,
    v36596: state_type > $o ).

tff(pred_def_20119,type,
    v36594: state_type > $o ).

tff(pred_def_20120,type,
    v36600: state_type > $o ).

tff(pred_def_20121,type,
    v36598: state_type > $o ).

tff(pred_def_20122,type,
    v36603: state_type > $o ).

tff(pred_def_20123,type,
    v36602: state_type > $o ).

tff(pred_def_20124,type,
    v36588: state_type > $o ).

tff(pred_def_20125,type,
    v36586: state_type > $o ).

tff(pred_def_20126,type,
    v36584: state_type > $o ).

tff(pred_def_20127,type,
    v36582: state_type > $o ).

tff(pred_def_20128,type,
    v36580: state_type > $o ).

tff(pred_def_20129,type,
    v36607: state_type > $o ).

tff(pred_def_20130,type,
    v36605: state_type > $o ).

tff(pred_def_20131,type,
    v36574: state_type > $o ).

tff(pred_def_20132,type,
    v36613: state_type > $o ).

tff(pred_def_20133,type,
    v36615: state_type > $o ).

tff(pred_def_20134,type,
    v36611: state_type > $o ).

tff(pred_def_20135,type,
    v36610: state_type > $o ).

tff(pred_def_20136,type,
    v36621: state_type > $o ).

tff(pred_def_20137,type,
    v36622: state_type > $o ).

tff(pred_def_20138,type,
    v36618: state_type > $o ).

tff(pred_def_20139,type,
    v36620: state_type > $o ).

tff(pred_def_20140,type,
    v36628: state_type > $o ).

tff(pred_def_20141,type,
    v36626: state_type > $o ).

tff(pred_def_20142,type,
    v36630: state_type > $o ).

tff(pred_def_20143,type,
    v36568: state_type > $o ).

tff(pred_def_20144,type,
    v36566: state_type > $o ).

tff(pred_def_20145,type,
    v36564: state_type > $o ).

tff(pred_def_20146,type,
    v36637: state_type > $o ).

tff(pred_def_20147,type,
    v36635: state_type > $o ).

tff(pred_def_20148,type,
    v36634: state_type > $o ).

tff(pred_def_20149,type,
    v36633: state_type > $o ).

tff(pred_def_20150,type,
    v36645: state_type > $o ).

tff(pred_def_20151,type,
    v36646: state_type > $o ).

tff(pred_def_20152,type,
    v36644: state_type > $o ).

tff(pred_def_20153,type,
    v36641: ( state_type * $int ) > $o ).

tff(pred_def_20154,type,
    v36643: ( state_type * $int ) > $o ).

tff(pred_def_20155,type,
    v36538: ( state_type * $int ) > $o ).

tff(pred_def_20156,type,
    v36536: ( state_type * $int ) > $o ).

tff(pred_def_20157,type,
    v36534: ( state_type * $int ) > $o ).

tff(pred_def_20158,type,
    v36532: ( state_type * $int ) > $o ).

tff(pred_def_20159,type,
    v36530: ( state_type * $int ) > $o ).

tff(pred_def_20160,type,
    v36668: state_type > $o ).

tff(pred_def_20161,type,
    v36666: state_type > $o ).

tff(pred_def_20162,type,
    v36672: state_type > $o ).

tff(pred_def_20163,type,
    v36670: state_type > $o ).

tff(pred_def_20164,type,
    v36676: state_type > $o ).

tff(pred_def_20165,type,
    v36674: state_type > $o ).

tff(pred_def_20166,type,
    v36679: state_type > $o ).

tff(pred_def_20167,type,
    v36678: state_type > $o ).

tff(pred_def_20168,type,
    v36664: state_type > $o ).

tff(pred_def_20169,type,
    v36662: state_type > $o ).

tff(pred_def_20170,type,
    v36660: state_type > $o ).

tff(pred_def_20171,type,
    v36658: state_type > $o ).

tff(pred_def_20172,type,
    v36656: state_type > $o ).

tff(pred_def_20173,type,
    v36654: state_type > $o ).

tff(pred_def_20174,type,
    v36652: state_type > $o ).

tff(pred_def_20175,type,
    v36650: state_type > $o ).

tff(pred_def_20176,type,
    v36699: state_type > $o ).

tff(pred_def_20177,type,
    v36697: state_type > $o ).

tff(pred_def_20178,type,
    v36695: state_type > $o ).

tff(pred_def_20179,type,
    v36693: state_type > $o ).

tff(pred_def_20180,type,
    v36691: state_type > $o ).

tff(pred_def_20181,type,
    v36709: state_type > $o ).

tff(pred_def_20182,type,
    v36707: state_type > $o ).

tff(pred_def_20183,type,
    v36705: state_type > $o ).

tff(pred_def_20184,type,
    v36703: state_type > $o ).

tff(pred_def_20185,type,
    v36701: state_type > $o ).

tff(pred_def_20186,type,
    v36713: ( state_type * $int ) > $o ).

tff(pred_def_20187,type,
    v36711: ( state_type * $int ) > $o ).

tff(pred_def_20188,type,
    v36723: state_type > $o ).

tff(pred_def_20189,type,
    v36721: state_type > $o ).

tff(pred_def_20190,type,
    v36729: state_type > $o ).

tff(pred_def_20191,type,
    v36727: state_type > $o ).

tff(pred_def_20192,type,
    v36743: state_type > $o ).

tff(pred_def_20193,type,
    v36741: state_type > $o ).

tff(pred_def_20194,type,
    v36747: state_type > $o ).

tff(pred_def_20195,type,
    v36745: state_type > $o ).

tff(pred_def_20196,type,
    v36751: state_type > $o ).

tff(pred_def_20197,type,
    v36749: state_type > $o ).

tff(pred_def_20198,type,
    v36754: state_type > $o ).

tff(pred_def_20199,type,
    v36753: state_type > $o ).

tff(pred_def_20200,type,
    v36739: state_type > $o ).

tff(pred_def_20201,type,
    v36737: state_type > $o ).

tff(pred_def_20202,type,
    v36735: state_type > $o ).

tff(pred_def_20203,type,
    v36733: state_type > $o ).

tff(pred_def_20204,type,
    v36731: state_type > $o ).

tff(pred_def_20205,type,
    v36758: state_type > $o ).

tff(pred_def_20206,type,
    v36756: state_type > $o ).

tff(pred_def_20207,type,
    v36725: state_type > $o ).

tff(pred_def_20208,type,
    v36764: state_type > $o ).

tff(pred_def_20209,type,
    v36766: state_type > $o ).

tff(pred_def_20210,type,
    v36762: state_type > $o ).

tff(pred_def_20211,type,
    v36761: state_type > $o ).

tff(pred_def_20212,type,
    v36772: state_type > $o ).

tff(pred_def_20213,type,
    v36773: state_type > $o ).

tff(pred_def_20214,type,
    v36769: state_type > $o ).

tff(pred_def_20215,type,
    v36771: state_type > $o ).

tff(pred_def_20216,type,
    v36779: state_type > $o ).

tff(pred_def_20217,type,
    v36777: state_type > $o ).

tff(pred_def_20218,type,
    v36781: state_type > $o ).

tff(pred_def_20219,type,
    v36719: state_type > $o ).

tff(pred_def_20220,type,
    v36717: state_type > $o ).

tff(pred_def_20221,type,
    v36715: state_type > $o ).

tff(pred_def_20222,type,
    v36788: state_type > $o ).

tff(pred_def_20223,type,
    v36786: state_type > $o ).

tff(pred_def_20224,type,
    v36785: state_type > $o ).

tff(pred_def_20225,type,
    v36784: state_type > $o ).

tff(pred_def_20226,type,
    v36796: state_type > $o ).

tff(pred_def_20227,type,
    v36797: state_type > $o ).

tff(pred_def_20228,type,
    v36795: state_type > $o ).

tff(pred_def_20229,type,
    v36792: ( state_type * $int ) > $o ).

tff(pred_def_20230,type,
    v36794: ( state_type * $int ) > $o ).

tff(pred_def_20231,type,
    v36689: ( state_type * $int ) > $o ).

tff(pred_def_20232,type,
    v36687: ( state_type * $int ) > $o ).

tff(pred_def_20233,type,
    v36685: ( state_type * $int ) > $o ).

tff(pred_def_20234,type,
    v36683: ( state_type * $int ) > $o ).

tff(pred_def_20235,type,
    v36681: ( state_type * $int ) > $o ).

tff(pred_def_20236,type,
    v36819: state_type > $o ).

tff(pred_def_20237,type,
    v36817: state_type > $o ).

tff(pred_def_20238,type,
    v36823: state_type > $o ).

tff(pred_def_20239,type,
    v36821: state_type > $o ).

tff(pred_def_20240,type,
    v36827: state_type > $o ).

tff(pred_def_20241,type,
    v36825: state_type > $o ).

tff(pred_def_20242,type,
    v36830: state_type > $o ).

tff(pred_def_20243,type,
    v36829: state_type > $o ).

tff(pred_def_20244,type,
    v36815: state_type > $o ).

tff(pred_def_20245,type,
    v36813: state_type > $o ).

tff(pred_def_20246,type,
    v36811: state_type > $o ).

tff(pred_def_20247,type,
    v36809: state_type > $o ).

tff(pred_def_20248,type,
    v36807: state_type > $o ).

tff(pred_def_20249,type,
    v36805: state_type > $o ).

tff(pred_def_20250,type,
    v36803: state_type > $o ).

tff(pred_def_20251,type,
    v36801: state_type > $o ).

tff(pred_def_20252,type,
    v36850: state_type > $o ).

tff(pred_def_20253,type,
    v36848: state_type > $o ).

tff(pred_def_20254,type,
    v36846: state_type > $o ).

tff(pred_def_20255,type,
    v36844: state_type > $o ).

tff(pred_def_20256,type,
    v36842: state_type > $o ).

tff(pred_def_20257,type,
    v36860: state_type > $o ).

tff(pred_def_20258,type,
    v36858: state_type > $o ).

tff(pred_def_20259,type,
    v36856: state_type > $o ).

tff(pred_def_20260,type,
    v36854: state_type > $o ).

tff(pred_def_20261,type,
    v36852: state_type > $o ).

tff(pred_def_20262,type,
    v36864: ( state_type * $int ) > $o ).

tff(pred_def_20263,type,
    v36862: ( state_type * $int ) > $o ).

tff(pred_def_20264,type,
    v36874: state_type > $o ).

tff(pred_def_20265,type,
    v36872: state_type > $o ).

tff(pred_def_20266,type,
    v36880: state_type > $o ).

tff(pred_def_20267,type,
    v36878: state_type > $o ).

tff(pred_def_20268,type,
    v36893: state_type > $o ).

tff(pred_def_20269,type,
    v36891: state_type > $o ).

tff(pred_def_20270,type,
    v36897: state_type > $o ).

tff(pred_def_20271,type,
    v36895: state_type > $o ).

tff(pred_def_20272,type,
    v36901: state_type > $o ).

tff(pred_def_20273,type,
    v36899: state_type > $o ).

tff(pred_def_20274,type,
    v36904: state_type > $o ).

tff(pred_def_20275,type,
    v36903: state_type > $o ).

tff(pred_def_20276,type,
    v36889: state_type > $o ).

tff(pred_def_20277,type,
    v36887: state_type > $o ).

tff(pred_def_20278,type,
    v36884: state_type > $o ).

tff(pred_def_20279,type,
    v36882: state_type > $o ).

tff(pred_def_20280,type,
    v36908: state_type > $o ).

tff(pred_def_20281,type,
    v36906: state_type > $o ).

tff(pred_def_20282,type,
    v36876: state_type > $o ).

tff(pred_def_20283,type,
    v36914: state_type > $o ).

tff(pred_def_20284,type,
    v36916: state_type > $o ).

tff(pred_def_20285,type,
    v36912: state_type > $o ).

tff(pred_def_20286,type,
    v36911: state_type > $o ).

tff(pred_def_20287,type,
    v36922: state_type > $o ).

tff(pred_def_20288,type,
    v36923: state_type > $o ).

tff(pred_def_20289,type,
    v36919: state_type > $o ).

tff(pred_def_20290,type,
    v36921: state_type > $o ).

tff(pred_def_20291,type,
    v36929: state_type > $o ).

tff(pred_def_20292,type,
    v36927: state_type > $o ).

tff(pred_def_20293,type,
    v36931: state_type > $o ).

tff(pred_def_20294,type,
    v36870: state_type > $o ).

tff(pred_def_20295,type,
    v36868: state_type > $o ).

tff(pred_def_20296,type,
    v36866: state_type > $o ).

tff(pred_def_20297,type,
    v36938: state_type > $o ).

tff(pred_def_20298,type,
    v36936: state_type > $o ).

tff(pred_def_20299,type,
    v36935: state_type > $o ).

tff(pred_def_20300,type,
    v36934: state_type > $o ).

tff(pred_def_20301,type,
    v36946: state_type > $o ).

tff(pred_def_20302,type,
    v36947: state_type > $o ).

tff(pred_def_20303,type,
    v36945: state_type > $o ).

tff(pred_def_20304,type,
    v36942: ( state_type * $int ) > $o ).

tff(pred_def_20305,type,
    v36944: ( state_type * $int ) > $o ).

tff(pred_def_20306,type,
    v36840: ( state_type * $int ) > $o ).

tff(pred_def_20307,type,
    v36838: ( state_type * $int ) > $o ).

tff(pred_def_20308,type,
    v36836: ( state_type * $int ) > $o ).

tff(pred_def_20309,type,
    v36834: ( state_type * $int ) > $o ).

tff(pred_def_20310,type,
    v36832: ( state_type * $int ) > $o ).

tff(pred_def_20311,type,
    v36959: state_type > $o ).

tff(pred_def_20312,type,
    v36957: state_type > $o ).

tff(pred_def_20313,type,
    v36955: state_type > $o ).

tff(pred_def_20314,type,
    v36953: state_type > $o ).

tff(pred_def_20315,type,
    v36951: state_type > $o ).

tff(pred_def_20316,type,
    v36967: state_type > $o ).

tff(pred_def_20317,type,
    v36966: ( state_type * $int ) > $o ).

tff(pred_def_20318,type,
    v36965: ( state_type * $int ) > $o ).

tff(pred_def_20319,type,
    v36970: state_type > $o ).

tff(pred_def_20320,type,
    v36969: ( state_type * $int ) > $o ).

tff(pred_def_20321,type,
    v36968: ( state_type * $int ) > $o ).

tff(pred_def_20322,type,
    v36964: ( state_type * $int ) > $o ).

tff(pred_def_20323,type,
    v36973: state_type > $o ).

tff(pred_def_20324,type,
    v36972: ( state_type * $int ) > $o ).

tff(pred_def_20325,type,
    v36971: ( state_type * $int ) > $o ).

tff(pred_def_20326,type,
    v36963: ( state_type * $int ) > $o ).

tff(pred_def_20327,type,
    v36976: state_type > $o ).

tff(pred_def_20328,type,
    v36975: ( state_type * $int ) > $o ).

tff(pred_def_20329,type,
    v36974: ( state_type * $int ) > $o ).

tff(pred_def_20330,type,
    v36962: ( state_type * $int ) > $o ).

tff(pred_def_20331,type,
    v36979: state_type > $o ).

tff(pred_def_20332,type,
    v36978: ( state_type * $int ) > $o ).

tff(pred_def_20333,type,
    v36977: ( state_type * $int ) > $o ).

tff(pred_def_20334,type,
    v36961: ( state_type * $int ) > $o ).

tff(pred_def_20335,type,
    v36982: state_type > $o ).

tff(pred_def_20336,type,
    v36981: ( state_type * $int ) > $o ).

tff(pred_def_20337,type,
    v36980: ( state_type * $int ) > $o ).

tff(pred_def_20338,type,
    v35453: ( state_type * $int ) > $o ).

tff(pred_def_20339,type,
    v35451: ( state_type * $int ) > $o ).

tff(pred_def_20340,type,
    v35449: ( state_type * $int ) > $o ).

tff(pred_def_20341,type,
    v35447: ( state_type * $int ) > $o ).

tff(pred_def_20342,type,
    v35445: ( state_type * $int ) > $o ).

tff(pred_def_20343,type,
    v35439: state_type > $o ).

tff(pred_def_20344,type,
    v35437: state_type > $o ).

tff(pred_def_20345,type,
    v35435: state_type > $o ).

tff(pred_def_20346,type,
    v36993: ( state_type * $int ) > $o ).

tff(pred_def_20347,type,
    v36991: ( state_type * $int ) > $o ).

tff(pred_def_20348,type,
    v37027: state_type > $o ).

tff(pred_def_20349,type,
    v37025: state_type > $o ).

tff(pred_def_20350,type,
    v37023: state_type > $o ).

tff(pred_def_20351,type,
    v37021: state_type > $o ).

tff(pred_def_20352,type,
    v37019: state_type > $o ).

tff(pred_def_20353,type,
    v37017: state_type > $o ).

tff(pred_def_20354,type,
    v37015: state_type > $o ).

tff(pred_def_20355,type,
    v37041: state_type > $o ).

tff(pred_def_20356,type,
    v37039: state_type > $o ).

tff(pred_def_20357,type,
    v37037: state_type > $o ).

tff(pred_def_20358,type,
    v37035: state_type > $o ).

tff(pred_def_20359,type,
    v37033: state_type > $o ).

tff(pred_def_20360,type,
    v37031: state_type > $o ).

tff(pred_def_20361,type,
    v37029: state_type > $o ).

tff(pred_def_20362,type,
    v37067: state_type > $o ).

tff(pred_def_20363,type,
    v37069: state_type > $o ).

tff(pred_def_20364,type,
    v37068: ( state_type * $int ) > $o ).

tff(pred_def_20365,type,
    v37070: state_type > $o ).

tff(pred_def_20366,type,
    v37065: ( state_type * $int ) > $o ).

tff(pred_def_20367,type,
    v37063: ( state_type * $int ) > $o ).

tff(pred_def_20368,type,
    v37071: ( state_type * $int ) > $o ).

tff(pred_def_20369,type,
    v37061: ( state_type * $int ) > $o ).

tff(pred_def_20370,type,
    v37059: ( state_type * $int ) > $o ).

tff(pred_def_20371,type,
    v37057: state_type > $o ).

tff(pred_def_20372,type,
    v37073: state_type > $o ).

tff(pred_def_20373,type,
    v37055: ( state_type * $int ) > $o ).

tff(pred_def_20374,type,
    v37053: ( state_type * $int ) > $o ).

tff(pred_def_20375,type,
    v37087: ( state_type * $int ) > $o ).

tff(pred_def_20376,type,
    v37085: ( state_type * $int ) > $o ).

tff(pred_def_20377,type,
    v37091: state_type > $o ).

tff(pred_def_20378,type,
    v37089: state_type > $o ).

tff(pred_def_20379,type,
    v37115: state_type > $o ).

tff(pred_def_20380,type,
    v37113: state_type > $o ).

tff(pred_def_20381,type,
    v37111: state_type > $o ).

tff(pred_def_20382,type,
    v37109: state_type > $o ).

tff(pred_def_20383,type,
    v37107: state_type > $o ).

tff(pred_def_20384,type,
    v37105: state_type > $o ).

tff(pred_def_20385,type,
    v37103: state_type > $o ).

tff(pred_def_20386,type,
    v37129: state_type > $o ).

tff(pred_def_20387,type,
    v37127: state_type > $o ).

tff(pred_def_20388,type,
    v37125: state_type > $o ).

tff(pred_def_20389,type,
    v37123: state_type > $o ).

tff(pred_def_20390,type,
    v37121: state_type > $o ).

tff(pred_def_20391,type,
    v37119: state_type > $o ).

tff(pred_def_20392,type,
    v37117: state_type > $o ).

tff(pred_def_20393,type,
    v37145: ( state_type * $int ) > $o ).

tff(pred_def_20394,type,
    v37143: ( state_type * $int ) > $o ).

tff(pred_def_20395,type,
    v37141: ( state_type * $int ) > $o ).

tff(pred_def_20396,type,
    v37139: ( state_type * $int ) > $o ).

tff(pred_def_20397,type,
    v37137: ( state_type * $int ) > $o ).

tff(pred_def_20398,type,
    v37175: ( state_type * $int ) > $o ).

tff(pred_def_20399,type,
    v37177: ( state_type * $int ) > $o ).

tff(pred_def_20400,type,
    v37173: ( state_type * $int ) > $o ).

tff(pred_def_20401,type,
    v37171: ( state_type * $int ) > $o ).

tff(pred_def_20402,type,
    v37169: ( state_type * $int ) > $o ).

tff(pred_def_20403,type,
    v37167: ( state_type * $int ) > $o ).

tff(pred_def_20404,type,
    v37165: state_type > $o ).

tff(pred_def_20405,type,
    v37163: state_type > $o ).

tff(pred_def_20406,type,
    v37181: state_type > $o ).

tff(pred_def_20407,type,
    v37179: state_type > $o ).

tff(pred_def_20408,type,
    v37183: state_type > $o ).

tff(pred_def_20409,type,
    v37161: state_type > $o ).

tff(pred_def_20410,type,
    v37159: state_type > $o ).

tff(pred_def_20411,type,
    v37157: state_type > $o ).

tff(pred_def_20412,type,
    v37155: state_type > $o ).

tff(pred_def_20413,type,
    v37153: state_type > $o ).

tff(pred_def_20414,type,
    v37151: state_type > $o ).

tff(pred_def_20415,type,
    v37149: state_type > $o ).

tff(pred_def_20416,type,
    v37147: state_type > $o ).

tff(pred_def_20417,type,
    v37193: ( state_type * $int ) > $o ).

tff(pred_def_20418,type,
    v37191: ( state_type * $int ) > $o ).

tff(pred_def_20419,type,
    v37189: ( state_type * $int ) > $o ).

tff(pred_def_20420,type,
    v37187: ( state_type * $int ) > $o ).

tff(pred_def_20421,type,
    v37185: ( state_type * $int ) > $o ).

tff(pred_def_20422,type,
    v37223: ( state_type * $int ) > $o ).

tff(pred_def_20423,type,
    v37221: ( state_type * $int ) > $o ).

tff(pred_def_20424,type,
    v37224: ( state_type * $int ) > $o ).

tff(pred_def_20425,type,
    v37219: ( state_type * $int ) > $o ).

tff(pred_def_20426,type,
    v37217: ( state_type * $int ) > $o ).

tff(pred_def_20427,type,
    v37215: ( state_type * $int ) > $o ).

tff(pred_def_20428,type,
    v37213: state_type > $o ).

tff(pred_def_20429,type,
    v37211: state_type > $o ).

tff(pred_def_20430,type,
    v37228: state_type > $o ).

tff(pred_def_20431,type,
    v37226: state_type > $o ).

tff(pred_def_20432,type,
    v37230: state_type > $o ).

tff(pred_def_20433,type,
    v37209: state_type > $o ).

tff(pred_def_20434,type,
    v37207: state_type > $o ).

tff(pred_def_20435,type,
    v37205: state_type > $o ).

tff(pred_def_20436,type,
    v37203: state_type > $o ).

tff(pred_def_20437,type,
    v37201: state_type > $o ).

tff(pred_def_20438,type,
    v37199: state_type > $o ).

tff(pred_def_20439,type,
    v37197: state_type > $o ).

tff(pred_def_20440,type,
    v37195: state_type > $o ).

tff(pred_def_20441,type,
    v37240: ( state_type * $int ) > $o ).

tff(pred_def_20442,type,
    v37238: ( state_type * $int ) > $o ).

tff(pred_def_20443,type,
    v37236: ( state_type * $int ) > $o ).

tff(pred_def_20444,type,
    v37234: ( state_type * $int ) > $o ).

tff(pred_def_20445,type,
    v37232: ( state_type * $int ) > $o ).

tff(pred_def_20446,type,
    v37260: state_type > $o ).

tff(pred_def_20447,type,
    v37258: state_type > $o ).

tff(pred_def_20448,type,
    v37264: state_type > $o ).

tff(pred_def_20449,type,
    v37262: state_type > $o ).

tff(pred_def_20450,type,
    v37266: state_type > $o ).

tff(pred_def_20451,type,
    v37256: state_type > $o ).

tff(pred_def_20452,type,
    v37254: state_type > $o ).

tff(pred_def_20453,type,
    v37252: state_type > $o ).

tff(pred_def_20454,type,
    v37250: state_type > $o ).

tff(pred_def_20455,type,
    v37248: state_type > $o ).

tff(pred_def_20456,type,
    v37246: state_type > $o ).

tff(pred_def_20457,type,
    v37244: state_type > $o ).

tff(pred_def_20458,type,
    v37242: state_type > $o ).

tff(pred_def_20459,type,
    v37276: ( state_type * $int ) > $o ).

tff(pred_def_20460,type,
    v37274: ( state_type * $int ) > $o ).

tff(pred_def_20461,type,
    v37272: ( state_type * $int ) > $o ).

tff(pred_def_20462,type,
    v37270: ( state_type * $int ) > $o ).

tff(pred_def_20463,type,
    v37268: ( state_type * $int ) > $o ).

tff(pred_def_20464,type,
    v37296: state_type > $o ).

tff(pred_def_20465,type,
    v37294: state_type > $o ).

tff(pred_def_20466,type,
    v37300: state_type > $o ).

tff(pred_def_20467,type,
    v37298: state_type > $o ).

tff(pred_def_20468,type,
    v37302: state_type > $o ).

tff(pred_def_20469,type,
    v37292: state_type > $o ).

tff(pred_def_20470,type,
    v37290: state_type > $o ).

tff(pred_def_20471,type,
    v37288: state_type > $o ).

tff(pred_def_20472,type,
    v37286: state_type > $o ).

tff(pred_def_20473,type,
    v37284: state_type > $o ).

tff(pred_def_20474,type,
    v37282: state_type > $o ).

tff(pred_def_20475,type,
    v37280: state_type > $o ).

tff(pred_def_20476,type,
    v37278: state_type > $o ).

tff(pred_def_20477,type,
    v37308: state_type > $o ).

tff(pred_def_20478,type,
    v37307: ( state_type * $int ) > $o ).

tff(pred_def_20479,type,
    v37306: ( state_type * $int ) > $o ).

tff(pred_def_20480,type,
    v37311: state_type > $o ).

tff(pred_def_20481,type,
    v37310: ( state_type * $int ) > $o ).

tff(pred_def_20482,type,
    v37309: ( state_type * $int ) > $o ).

tff(pred_def_20483,type,
    v37305: ( state_type * $int ) > $o ).

tff(pred_def_20484,type,
    v37314: state_type > $o ).

tff(pred_def_20485,type,
    v37313: ( state_type * $int ) > $o ).

tff(pred_def_20486,type,
    v37312: ( state_type * $int ) > $o ).

tff(pred_def_20487,type,
    v37304: ( state_type * $int ) > $o ).

tff(pred_def_20488,type,
    v37317: state_type > $o ).

tff(pred_def_20489,type,
    v37316: ( state_type * $int ) > $o ).

tff(pred_def_20490,type,
    v37315: ( state_type * $int ) > $o ).

tff(pred_def_20491,type,
    v37135: ( state_type * $int ) > $o ).

tff(pred_def_20492,type,
    v37133: ( state_type * $int ) > $o ).

tff(pred_def_20493,type,
    v37131: ( state_type * $int ) > $o ).

tff(pred_def_20494,type,
    v37329: state_type > $o ).

tff(pred_def_20495,type,
    v37327: state_type > $o ).

tff(pred_def_20496,type,
    v37325: state_type > $o ).

tff(pred_def_20497,type,
    v37339: state_type > $o ).

tff(pred_def_20498,type,
    v37337: state_type > $o ).

tff(pred_def_20499,type,
    v37335: state_type > $o ).

tff(pred_def_20500,type,
    v37333: state_type > $o ).

tff(pred_def_20501,type,
    v37331: state_type > $o ).

tff(pred_def_20502,type,
    v37341: state_type > $o ).

tff(pred_def_20503,type,
    v37323: state_type > $o ).

tff(pred_def_20504,type,
    v37321: state_type > $o ).

tff(pred_def_20505,type,
    v37319: state_type > $o ).

tff(pred_def_20506,type,
    v37348: state_type > $o ).

tff(pred_def_20507,type,
    v37346: state_type > $o ).

tff(pred_def_20508,type,
    v37345: state_type > $o ).

tff(pred_def_20509,type,
    v37344: state_type > $o ).

tff(pred_def_20510,type,
    v37356: state_type > $o ).

tff(pred_def_20511,type,
    v37357: state_type > $o ).

tff(pred_def_20512,type,
    v37355: state_type > $o ).

tff(pred_def_20513,type,
    v37352: ( state_type * $int ) > $o ).

tff(pred_def_20514,type,
    v37354: ( state_type * $int ) > $o ).

tff(pred_def_20515,type,
    v37101: ( state_type * $int ) > $o ).

tff(pred_def_20516,type,
    v37099: ( state_type * $int ) > $o ).

tff(pred_def_20517,type,
    v37097: ( state_type * $int ) > $o ).

tff(pred_def_20518,type,
    v37095: ( state_type * $int ) > $o ).

tff(pred_def_20519,type,
    v37093: ( state_type * $int ) > $o ).

tff(pred_def_20520,type,
    v37363: state_type > $o ).

tff(pred_def_20521,type,
    v37361: state_type > $o ).

tff(pred_def_20522,type,
    v37367: state_type > $o ).

tff(pred_def_20523,type,
    v37366: ( state_type * $int ) > $o ).

tff(pred_def_20524,type,
    v37365: ( state_type * $int ) > $o ).

tff(pred_def_20525,type,
    v37370: state_type > $o ).

tff(pred_def_20526,type,
    v37369: ( state_type * $int ) > $o ).

tff(pred_def_20527,type,
    v37368: ( state_type * $int ) > $o ).

tff(pred_def_20528,type,
    v37083: ( state_type * $int ) > $o ).

tff(pred_def_20529,type,
    v37081: ( state_type * $int ) > $o ).

tff(pred_def_20530,type,
    v37079: ( state_type * $int ) > $o ).

tff(pred_def_20531,type,
    v37077: ( state_type * $int ) > $o ).

tff(pred_def_20532,type,
    v37075: ( state_type * $int ) > $o ).

tff(pred_def_20533,type,
    v37051: ( state_type * $int ) > $o ).

tff(pred_def_20534,type,
    v37049: ( state_type * $int ) > $o ).

tff(pred_def_20535,type,
    v37047: ( state_type * $int ) > $o ).

tff(pred_def_20536,type,
    v37045: ( state_type * $int ) > $o ).

tff(pred_def_20537,type,
    v37043: ( state_type * $int ) > $o ).

tff(pred_def_20538,type,
    v37383: state_type > $o ).

tff(pred_def_20539,type,
    v37381: state_type > $o ).

tff(pred_def_20540,type,
    v37379: state_type > $o ).

tff(pred_def_20541,type,
    v37389: state_type > $o ).

tff(pred_def_20542,type,
    v37387: state_type > $o ).

tff(pred_def_20543,type,
    v37407: ( state_type * $int ) > $o ).

tff(pred_def_20544,type,
    v37409: ( state_type * $int ) > $o ).

tff(pred_def_20545,type,
    v37405: ( state_type * $int ) > $o ).

tff(pred_def_20546,type,
    v37403: state_type > $o ).

tff(pred_def_20547,type,
    v37401: state_type > $o ).

tff(pred_def_20548,type,
    v37413: state_type > $o ).

tff(pred_def_20549,type,
    v37411: state_type > $o ).

tff(pred_def_20550,type,
    v37417: state_type > $o ).

tff(pred_def_20551,type,
    v37415: state_type > $o ).

tff(pred_def_20552,type,
    v37420: state_type > $o ).

tff(pred_def_20553,type,
    v37419: state_type > $o ).

tff(pred_def_20554,type,
    v37399: state_type > $o ).

tff(pred_def_20555,type,
    v37397: state_type > $o ).

tff(pred_def_20556,type,
    v37395: state_type > $o ).

tff(pred_def_20557,type,
    v37393: state_type > $o ).

tff(pred_def_20558,type,
    v37391: state_type > $o ).

tff(pred_def_20559,type,
    v37428: state_type > $o ).

tff(pred_def_20560,type,
    v37426: state_type > $o ).

tff(pred_def_20561,type,
    v37424: state_type > $o ).

tff(pred_def_20562,type,
    v37422: state_type > $o ).

tff(pred_def_20563,type,
    v37385: state_type > $o ).

tff(pred_def_20564,type,
    v37434: state_type > $o ).

tff(pred_def_20565,type,
    v37436: state_type > $o ).

tff(pred_def_20566,type,
    v37432: state_type > $o ).

tff(pred_def_20567,type,
    v37431: state_type > $o ).

tff(pred_def_20568,type,
    v37442: state_type > $o ).

tff(pred_def_20569,type,
    v37443: state_type > $o ).

tff(pred_def_20570,type,
    v37439: state_type > $o ).

tff(pred_def_20571,type,
    v37441: state_type > $o ).

tff(pred_def_20572,type,
    v37453: state_type > $o ).

tff(pred_def_20573,type,
    v37451: state_type > $o ).

tff(pred_def_20574,type,
    v37449: state_type > $o ).

tff(pred_def_20575,type,
    v37447: state_type > $o ).

tff(pred_def_20576,type,
    v37455: state_type > $o ).

tff(pred_def_20577,type,
    v37377: state_type > $o ).

tff(pred_def_20578,type,
    v37375: state_type > $o ).

tff(pred_def_20579,type,
    v37373: state_type > $o ).

tff(pred_def_20580,type,
    v37462: state_type > $o ).

tff(pred_def_20581,type,
    v37460: state_type > $o ).

tff(pred_def_20582,type,
    v37459: state_type > $o ).

tff(pred_def_20583,type,
    v37458: state_type > $o ).

tff(pred_def_20584,type,
    v37470: state_type > $o ).

tff(pred_def_20585,type,
    v37471: state_type > $o ).

tff(pred_def_20586,type,
    v37469: state_type > $o ).

tff(pred_def_20587,type,
    v37466: ( state_type * $int ) > $o ).

tff(pred_def_20588,type,
    v37468: ( state_type * $int ) > $o ).

tff(pred_def_20589,type,
    v37013: ( state_type * $int ) > $o ).

tff(pred_def_20590,type,
    v37011: ( state_type * $int ) > $o ).

tff(pred_def_20591,type,
    v37009: ( state_type * $int ) > $o ).

tff(pred_def_20592,type,
    v37007: ( state_type * $int ) > $o ).

tff(pred_def_20593,type,
    v37005: ( state_type * $int ) > $o ).

tff(pred_def_20594,type,
    v37507: state_type > $o ).

tff(pred_def_20595,type,
    v37505: state_type > $o ).

tff(pred_def_20596,type,
    v37503: state_type > $o ).

tff(pred_def_20597,type,
    v37501: state_type > $o ).

tff(pred_def_20598,type,
    v37499: state_type > $o ).

tff(pred_def_20599,type,
    v37497: state_type > $o ).

tff(pred_def_20600,type,
    v37517: state_type > $o ).

tff(pred_def_20601,type,
    v37515: state_type > $o ).

tff(pred_def_20602,type,
    v37513: state_type > $o ).

tff(pred_def_20603,type,
    v37511: state_type > $o ).

tff(pred_def_20604,type,
    v37509: state_type > $o ).

tff(pred_def_20605,type,
    v37544: state_type > $o ).

tff(pred_def_20606,type,
    v37543: ( state_type * $int ) > $o ).

tff(pred_def_20607,type,
    v37542: ( state_type * $int ) > $o ).

tff(pred_def_20608,type,
    v37540: ( state_type * $int ) > $o ).

tff(pred_def_20609,type,
    v37560: state_type > $o ).

tff(pred_def_20610,type,
    v37561: ( state_type * $int ) > $o ).

tff(pred_def_20611,type,
    v37562: state_type > $o ).

tff(pred_def_20612,type,
    v37558: ( state_type * $int ) > $o ).

tff(pred_def_20613,type,
    v37556: ( state_type * $int ) > $o ).

tff(pred_def_20614,type,
    v37586: ( state_type * $int ) > $o ).

tff(pred_def_20615,type,
    v37495: ( state_type * $int ) > $o ).

tff(pred_def_20616,type,
    v37584: ( state_type * $int ) > $o ).

tff(pred_def_20617,type,
    v37587: ( state_type * $int ) > $o ).

tff(pred_def_20618,type,
    v37582: ( state_type * $int ) > $o ).

tff(pred_def_20619,type,
    v37580: ( state_type * $int ) > $o ).

tff(pred_def_20620,type,
    v37578: ( state_type * $int ) > $o ).

tff(pred_def_20621,type,
    v37576: state_type > $o ).

tff(pred_def_20622,type,
    v37574: state_type > $o ).

tff(pred_def_20623,type,
    v37593: state_type > $o ).

tff(pred_def_20624,type,
    v37533: state_type > $o ).

tff(pred_def_20625,type,
    v37592: ( state_type * $int ) > $o ).

tff(pred_def_20626,type,
    v37531: ( state_type * $int ) > $o ).

tff(pred_def_20627,type,
    v37529: ( state_type * $int ) > $o ).

tff(pred_def_20628,type,
    v37608: ( state_type * $int ) > $o ).

tff(pred_def_20629,type,
    v37607: ( state_type * $int ) > $o ).

tff(pred_def_20630,type,
    v37605: ( state_type * $int ) > $o ).

tff(pred_def_20631,type,
    v37612: state_type > $o ).

tff(pred_def_20632,type,
    v37610: state_type > $o ).

tff(pred_def_20633,type,
    v37623: ( state_type * $int ) > $o ).

tff(pred_def_20634,type,
    v37622: state_type > $o ).

tff(pred_def_20635,type,
    v37626: state_type > $o ).

tff(pred_def_20636,type,
    v37627: state_type > $o ).

tff(pred_def_20637,type,
    v37625: state_type > $o ).

tff(pred_def_20638,type,
    v37628: state_type > $o ).

tff(pred_def_20639,type,
    v37624: state_type > $o ).

tff(pred_def_20640,type,
    v37621: state_type > $o ).

tff(pred_def_20641,type,
    v37629: state_type > $o ).

tff(pred_def_20642,type,
    v37620: state_type > $o ).

tff(pred_def_20643,type,
    v37632: state_type > $o ).

tff(pred_def_20644,type,
    v37633: state_type > $o ).

tff(pred_def_20645,type,
    v37631: state_type > $o ).

tff(pred_def_20646,type,
    v37634: state_type > $o ).

tff(pred_def_20647,type,
    v37630: state_type > $o ).

tff(pred_def_20648,type,
    v37619: state_type > $o ).

tff(pred_def_20649,type,
    v37635: state_type > $o ).

tff(pred_def_20650,type,
    v37618: state_type > $o ).

tff(pred_def_20651,type,
    v37617: state_type > $o ).

tff(pred_def_20652,type,
    v37639: state_type > $o ).

tff(pred_def_20653,type,
    v37640: state_type > $o ).

tff(pred_def_20654,type,
    v37638: state_type > $o ).

tff(pred_def_20655,type,
    v37641: state_type > $o ).

tff(pred_def_20656,type,
    v37637: state_type > $o ).

tff(pred_def_20657,type,
    v37636: state_type > $o ).

tff(pred_def_20658,type,
    v37616: state_type > $o ).

tff(pred_def_20659,type,
    v37642: state_type > $o ).

tff(pred_def_20660,type,
    v37615: state_type > $o ).

tff(pred_def_20661,type,
    v37645: state_type > $o ).

tff(pred_def_20662,type,
    v37646: state_type > $o ).

tff(pred_def_20663,type,
    v37644: state_type > $o ).

tff(pred_def_20664,type,
    v37647: state_type > $o ).

tff(pred_def_20665,type,
    v37643: state_type > $o ).

tff(pred_def_20666,type,
    v37650: state_type > $o ).

tff(pred_def_20667,type,
    v37651: state_type > $o ).

tff(pred_def_20668,type,
    v37649: state_type > $o ).

tff(pred_def_20669,type,
    v37652: state_type > $o ).

tff(pred_def_20670,type,
    v37648: state_type > $o ).

tff(pred_def_20671,type,
    v37655: state_type > $o ).

tff(pred_def_20672,type,
    v37656: state_type > $o ).

tff(pred_def_20673,type,
    v37654: state_type > $o ).

tff(pred_def_20674,type,
    v37657: state_type > $o ).

tff(pred_def_20675,type,
    v37653: state_type > $o ).

tff(pred_def_20676,type,
    v37613: ( state_type * $int ) > $o ).

tff(pred_def_20677,type,
    v37603: ( state_type * $int ) > $o ).

tff(pred_def_20678,type,
    v37601: ( state_type * $int ) > $o ).

tff(pred_def_20679,type,
    v37599: ( state_type * $int ) > $o ).

tff(pred_def_20680,type,
    v37597: ( state_type * $int ) > $o ).

tff(pred_def_20681,type,
    v37595: ( state_type * $int ) > $o ).

tff(pred_def_20682,type,
    v37658: ( state_type * $int ) > $o ).

tff(pred_def_20683,type,
    v37527: ( state_type * $int ) > $o ).

tff(pred_def_20684,type,
    v37525: ( state_type * $int ) > $o ).

tff(pred_def_20685,type,
    v37523: ( state_type * $int ) > $o ).

tff(pred_def_20686,type,
    v37659: ( state_type * $int ) > $o ).

tff(pred_def_20687,type,
    v37660: ( state_type * $int ) > $o ).

tff(pred_def_20688,type,
    v37521: ( state_type * $int ) > $o ).

tff(pred_def_20689,type,
    v37519: ( state_type * $int ) > $o ).

tff(pred_def_20690,type,
    v37670: state_type > $o ).

tff(pred_def_20691,type,
    v37668: state_type > $o ).

tff(pred_def_20692,type,
    v37676: state_type > $o ).

tff(pred_def_20693,type,
    v37674: state_type > $o ).

tff(pred_def_20694,type,
    v37680: state_type > $o ).

tff(pred_def_20695,type,
    v37678: state_type > $o ).

tff(pred_def_20696,type,
    v37684: state_type > $o ).

tff(pred_def_20697,type,
    v37682: state_type > $o ).

tff(pred_def_20698,type,
    v37672: state_type > $o ).

tff(pred_def_20699,type,
    v37690: state_type > $o ).

tff(pred_def_20700,type,
    v37692: state_type > $o ).

tff(pred_def_20701,type,
    v37688: state_type > $o ).

tff(pred_def_20702,type,
    v37687: state_type > $o ).

tff(pred_def_20703,type,
    v37698: state_type > $o ).

tff(pred_def_20704,type,
    v37699: state_type > $o ).

tff(pred_def_20705,type,
    v37695: state_type > $o ).

tff(pred_def_20706,type,
    v37697: state_type > $o ).

tff(pred_def_20707,type,
    v37705: state_type > $o ).

tff(pred_def_20708,type,
    v37703: state_type > $o ).

tff(pred_def_20709,type,
    v37707: state_type > $o ).

tff(pred_def_20710,type,
    v37666: state_type > $o ).

tff(pred_def_20711,type,
    v37664: state_type > $o ).

tff(pred_def_20712,type,
    v37662: state_type > $o ).

tff(pred_def_20713,type,
    v37714: state_type > $o ).

tff(pred_def_20714,type,
    v37712: state_type > $o ).

tff(pred_def_20715,type,
    v37711: state_type > $o ).

tff(pred_def_20716,type,
    v37710: state_type > $o ).

tff(pred_def_20717,type,
    v37722: state_type > $o ).

tff(pred_def_20718,type,
    v37723: state_type > $o ).

tff(pred_def_20719,type,
    v37721: state_type > $o ).

tff(pred_def_20720,type,
    v37718: ( state_type * $int ) > $o ).

tff(pred_def_20721,type,
    v37720: ( state_type * $int ) > $o ).

tff(pred_def_20722,type,
    v37709: ( state_type * $int ) > $o ).

tff(pred_def_20723,type,
    v37591: state_type > $o ).

tff(pred_def_20724,type,
    v37589: state_type > $o ).

tff(pred_def_20725,type,
    v37735: state_type > $o ).

tff(pred_def_20726,type,
    v37733: state_type > $o ).

tff(pred_def_20727,type,
    v37732: state_type > $o ).

tff(pred_def_20728,type,
    v37731: ( state_type * $int ) > $o ).

tff(pred_def_20729,type,
    v37729: state_type > $o ).

tff(pred_def_20730,type,
    v37727: state_type > $o ).

tff(pred_def_20731,type,
    v37740: state_type > $o ).

tff(pred_def_20732,type,
    v37739: state_type > $o ).

tff(pred_def_20733,type,
    v37572: state_type > $o ).

tff(pred_def_20734,type,
    v37570: state_type > $o ).

tff(pred_def_20735,type,
    v37568: state_type > $o ).

tff(pred_def_20736,type,
    v37741: ( state_type * $int ) > $o ).

tff(pred_def_20737,type,
    v37742: state_type > $o ).

tff(pred_def_20738,type,
    v37566: ( state_type * $int ) > $o ).

tff(pred_def_20739,type,
    v37564: ( state_type * $int ) > $o ).

tff(pred_def_20740,type,
    v37743: ( state_type * $int ) > $o ).

tff(pred_def_20741,type,
    v37554: ( state_type * $int ) > $o ).

tff(pred_def_20742,type,
    v37552: ( state_type * $int ) > $o ).

tff(pred_def_20743,type,
    v37550: state_type > $o ).

tff(pred_def_20744,type,
    v37744: ( state_type * $int ) > $o ).

tff(pred_def_20745,type,
    v37745: state_type > $o ).

tff(pred_def_20746,type,
    v37548: ( state_type * $int ) > $o ).

tff(pred_def_20747,type,
    v37546: ( state_type * $int ) > $o ).

tff(pred_def_20748,type,
    v37746: ( state_type * $int ) > $o ).

tff(pred_def_20749,type,
    v37538: ( state_type * $int ) > $o ).

tff(pred_def_20750,type,
    v37536: ( state_type * $int ) > $o ).

tff(pred_def_20751,type,
    v37752: state_type > $o ).

tff(pred_def_20752,type,
    v37750: state_type > $o ).

tff(pred_def_20753,type,
    v37749: state_type > $o ).

tff(pred_def_20754,type,
    v37748: ( state_type * $int ) > $o ).

tff(pred_def_20755,type,
    v37493: state_type > $o ).

tff(pred_def_20756,type,
    v37491: state_type > $o ).

tff(pred_def_20757,type,
    v37758: state_type > $o ).

tff(pred_def_20758,type,
    v37756: state_type > $o ).

tff(pred_def_20759,type,
    v37762: state_type > $o ).

tff(pred_def_20760,type,
    v37760: state_type > $o ).

tff(pred_def_20761,type,
    v37765: state_type > $o ).

tff(pred_def_20762,type,
    v37764: state_type > $o ).

tff(pred_def_20763,type,
    v37489: state_type > $o ).

tff(pred_def_20764,type,
    v37487: state_type > $o ).

tff(pred_def_20765,type,
    v37485: state_type > $o ).

tff(pred_def_20766,type,
    v37483: state_type > $o ).

tff(pred_def_20767,type,
    v37481: state_type > $o ).

tff(pred_def_20768,type,
    v37479: state_type > $o ).

tff(pred_def_20769,type,
    v37477: state_type > $o ).

tff(pred_def_20770,type,
    v37475: state_type > $o ).

tff(pred_def_20771,type,
    v37785: state_type > $o ).

tff(pred_def_20772,type,
    v37783: state_type > $o ).

tff(pred_def_20773,type,
    v37781: state_type > $o ).

tff(pred_def_20774,type,
    v37779: state_type > $o ).

tff(pred_def_20775,type,
    v37777: state_type > $o ).

tff(pred_def_20776,type,
    v37795: state_type > $o ).

tff(pred_def_20777,type,
    v37793: state_type > $o ).

tff(pred_def_20778,type,
    v37791: state_type > $o ).

tff(pred_def_20779,type,
    v37789: state_type > $o ).

tff(pred_def_20780,type,
    v37787: state_type > $o ).

tff(pred_def_20781,type,
    v37799: ( state_type * $int ) > $o ).

tff(pred_def_20782,type,
    v37797: ( state_type * $int ) > $o ).

tff(pred_def_20783,type,
    v37809: state_type > $o ).

tff(pred_def_20784,type,
    v37807: state_type > $o ).

tff(pred_def_20785,type,
    v37815: state_type > $o ).

tff(pred_def_20786,type,
    v37813: state_type > $o ).

tff(pred_def_20787,type,
    v37839: ( state_type * $int ) > $o ).

tff(pred_def_20788,type,
    v37837: ( state_type * $int ) > $o ).

tff(pred_def_20789,type,
    v37840: ( state_type * $int ) > $o ).

tff(pred_def_20790,type,
    v37835: ( state_type * $int ) > $o ).

tff(pred_def_20791,type,
    v37833: ( state_type * $int ) > $o ).

tff(pred_def_20792,type,
    v37831: ( state_type * $int ) > $o ).

tff(pred_def_20793,type,
    v37829: state_type > $o ).

tff(pred_def_20794,type,
    v37827: state_type > $o ).

tff(pred_def_20795,type,
    v37844: state_type > $o ).

tff(pred_def_20796,type,
    v37842: state_type > $o ).

tff(pred_def_20797,type,
    v37848: state_type > $o ).

tff(pred_def_20798,type,
    v37846: state_type > $o ).

tff(pred_def_20799,type,
    v37851: state_type > $o ).

tff(pred_def_20800,type,
    v37850: state_type > $o ).

tff(pred_def_20801,type,
    v37825: state_type > $o ).

tff(pred_def_20802,type,
    v37823: state_type > $o ).

tff(pred_def_20803,type,
    v37821: state_type > $o ).

tff(pred_def_20804,type,
    v37819: state_type > $o ).

tff(pred_def_20805,type,
    v37817: state_type > $o ).

tff(pred_def_20806,type,
    v37855: state_type > $o ).

tff(pred_def_20807,type,
    v37853: state_type > $o ).

tff(pred_def_20808,type,
    v37811: state_type > $o ).

tff(pred_def_20809,type,
    v37861: state_type > $o ).

tff(pred_def_20810,type,
    v37863: state_type > $o ).

tff(pred_def_20811,type,
    v37859: state_type > $o ).

tff(pred_def_20812,type,
    v37858: state_type > $o ).

tff(pred_def_20813,type,
    v37869: state_type > $o ).

tff(pred_def_20814,type,
    v37870: state_type > $o ).

tff(pred_def_20815,type,
    v37866: state_type > $o ).

tff(pred_def_20816,type,
    v37868: state_type > $o ).

tff(pred_def_20817,type,
    v37876: state_type > $o ).

tff(pred_def_20818,type,
    v37874: state_type > $o ).

tff(pred_def_20819,type,
    v37878: state_type > $o ).

tff(pred_def_20820,type,
    v37805: state_type > $o ).

tff(pred_def_20821,type,
    v37803: state_type > $o ).

tff(pred_def_20822,type,
    v37801: state_type > $o ).

tff(pred_def_20823,type,
    v37885: state_type > $o ).

tff(pred_def_20824,type,
    v37883: state_type > $o ).

tff(pred_def_20825,type,
    v37882: state_type > $o ).

tff(pred_def_20826,type,
    v37881: state_type > $o ).

tff(pred_def_20827,type,
    v37893: state_type > $o ).

tff(pred_def_20828,type,
    v37894: state_type > $o ).

tff(pred_def_20829,type,
    v37892: state_type > $o ).

tff(pred_def_20830,type,
    v37889: ( state_type * $int ) > $o ).

tff(pred_def_20831,type,
    v37891: ( state_type * $int ) > $o ).

tff(pred_def_20832,type,
    v37775: ( state_type * $int ) > $o ).

tff(pred_def_20833,type,
    v37773: ( state_type * $int ) > $o ).

tff(pred_def_20834,type,
    v37771: ( state_type * $int ) > $o ).

tff(pred_def_20835,type,
    v37769: ( state_type * $int ) > $o ).

tff(pred_def_20836,type,
    v37767: ( state_type * $int ) > $o ).

tff(pred_def_20837,type,
    v37916: state_type > $o ).

tff(pred_def_20838,type,
    v37914: state_type > $o ).

tff(pred_def_20839,type,
    v37920: state_type > $o ).

tff(pred_def_20840,type,
    v37918: state_type > $o ).

tff(pred_def_20841,type,
    v37924: state_type > $o ).

tff(pred_def_20842,type,
    v37922: state_type > $o ).

tff(pred_def_20843,type,
    v37927: state_type > $o ).

tff(pred_def_20844,type,
    v37926: state_type > $o ).

tff(pred_def_20845,type,
    v37912: state_type > $o ).

tff(pred_def_20846,type,
    v37910: state_type > $o ).

tff(pred_def_20847,type,
    v37908: state_type > $o ).

tff(pred_def_20848,type,
    v37906: state_type > $o ).

tff(pred_def_20849,type,
    v37904: state_type > $o ).

tff(pred_def_20850,type,
    v37902: state_type > $o ).

tff(pred_def_20851,type,
    v37900: state_type > $o ).

tff(pred_def_20852,type,
    v37898: state_type > $o ).

tff(pred_def_20853,type,
    v37947: state_type > $o ).

tff(pred_def_20854,type,
    v37945: state_type > $o ).

tff(pred_def_20855,type,
    v37943: state_type > $o ).

tff(pred_def_20856,type,
    v37941: state_type > $o ).

tff(pred_def_20857,type,
    v37939: state_type > $o ).

tff(pred_def_20858,type,
    v37957: state_type > $o ).

tff(pred_def_20859,type,
    v37955: state_type > $o ).

tff(pred_def_20860,type,
    v37953: state_type > $o ).

tff(pred_def_20861,type,
    v37951: state_type > $o ).

tff(pred_def_20862,type,
    v37949: state_type > $o ).

tff(pred_def_20863,type,
    v37961: ( state_type * $int ) > $o ).

tff(pred_def_20864,type,
    v37959: ( state_type * $int ) > $o ).

tff(pred_def_20865,type,
    v37971: state_type > $o ).

tff(pred_def_20866,type,
    v37969: state_type > $o ).

tff(pred_def_20867,type,
    v37977: state_type > $o ).

tff(pred_def_20868,type,
    v37975: state_type > $o ).

tff(pred_def_20869,type,
    v37991: state_type > $o ).

tff(pred_def_20870,type,
    v37989: state_type > $o ).

tff(pred_def_20871,type,
    v37995: state_type > $o ).

tff(pred_def_20872,type,
    v37993: state_type > $o ).

tff(pred_def_20873,type,
    v37999: state_type > $o ).

tff(pred_def_20874,type,
    v37997: state_type > $o ).

tff(pred_def_20875,type,
    v38002: state_type > $o ).

tff(pred_def_20876,type,
    v38001: state_type > $o ).

tff(pred_def_20877,type,
    v37987: state_type > $o ).

tff(pred_def_20878,type,
    v37985: state_type > $o ).

tff(pred_def_20879,type,
    v37983: state_type > $o ).

tff(pred_def_20880,type,
    v37981: state_type > $o ).

tff(pred_def_20881,type,
    v37979: state_type > $o ).

tff(pred_def_20882,type,
    v38006: state_type > $o ).

tff(pred_def_20883,type,
    v38004: state_type > $o ).

tff(pred_def_20884,type,
    v37973: state_type > $o ).

tff(pred_def_20885,type,
    v38012: state_type > $o ).

tff(pred_def_20886,type,
    v38014: state_type > $o ).

tff(pred_def_20887,type,
    v38010: state_type > $o ).

tff(pred_def_20888,type,
    v38009: state_type > $o ).

tff(pred_def_20889,type,
    v38020: state_type > $o ).

tff(pred_def_20890,type,
    v38021: state_type > $o ).

tff(pred_def_20891,type,
    v38017: state_type > $o ).

tff(pred_def_20892,type,
    v38019: state_type > $o ).

tff(pred_def_20893,type,
    v38027: state_type > $o ).

tff(pred_def_20894,type,
    v38025: state_type > $o ).

tff(pred_def_20895,type,
    v38029: state_type > $o ).

tff(pred_def_20896,type,
    v37967: state_type > $o ).

tff(pred_def_20897,type,
    v37965: state_type > $o ).

tff(pred_def_20898,type,
    v37963: state_type > $o ).

tff(pred_def_20899,type,
    v38036: state_type > $o ).

tff(pred_def_20900,type,
    v38034: state_type > $o ).

tff(pred_def_20901,type,
    v38033: state_type > $o ).

tff(pred_def_20902,type,
    v38032: state_type > $o ).

tff(pred_def_20903,type,
    v38044: state_type > $o ).

tff(pred_def_20904,type,
    v38045: state_type > $o ).

tff(pred_def_20905,type,
    v38043: state_type > $o ).

tff(pred_def_20906,type,
    v38040: ( state_type * $int ) > $o ).

tff(pred_def_20907,type,
    v38042: ( state_type * $int ) > $o ).

tff(pred_def_20908,type,
    v37937: ( state_type * $int ) > $o ).

tff(pred_def_20909,type,
    v37935: ( state_type * $int ) > $o ).

tff(pred_def_20910,type,
    v37933: ( state_type * $int ) > $o ).

tff(pred_def_20911,type,
    v37931: ( state_type * $int ) > $o ).

tff(pred_def_20912,type,
    v37929: ( state_type * $int ) > $o ).

tff(pred_def_20913,type,
    v38067: state_type > $o ).

tff(pred_def_20914,type,
    v38065: state_type > $o ).

tff(pred_def_20915,type,
    v38071: state_type > $o ).

tff(pred_def_20916,type,
    v38069: state_type > $o ).

tff(pred_def_20917,type,
    v38075: state_type > $o ).

tff(pred_def_20918,type,
    v38073: state_type > $o ).

tff(pred_def_20919,type,
    v38078: state_type > $o ).

tff(pred_def_20920,type,
    v38077: state_type > $o ).

tff(pred_def_20921,type,
    v38063: state_type > $o ).

tff(pred_def_20922,type,
    v38061: state_type > $o ).

tff(pred_def_20923,type,
    v38059: state_type > $o ).

tff(pred_def_20924,type,
    v38057: state_type > $o ).

tff(pred_def_20925,type,
    v38055: state_type > $o ).

tff(pred_def_20926,type,
    v38053: state_type > $o ).

tff(pred_def_20927,type,
    v38051: state_type > $o ).

tff(pred_def_20928,type,
    v38049: state_type > $o ).

tff(pred_def_20929,type,
    v38098: state_type > $o ).

tff(pred_def_20930,type,
    v38096: state_type > $o ).

tff(pred_def_20931,type,
    v38094: state_type > $o ).

tff(pred_def_20932,type,
    v38092: state_type > $o ).

tff(pred_def_20933,type,
    v38090: state_type > $o ).

tff(pred_def_20934,type,
    v38108: state_type > $o ).

tff(pred_def_20935,type,
    v38106: state_type > $o ).

tff(pred_def_20936,type,
    v38104: state_type > $o ).

tff(pred_def_20937,type,
    v38102: state_type > $o ).

tff(pred_def_20938,type,
    v38100: state_type > $o ).

tff(pred_def_20939,type,
    v38112: ( state_type * $int ) > $o ).

tff(pred_def_20940,type,
    v38110: ( state_type * $int ) > $o ).

tff(pred_def_20941,type,
    v38122: state_type > $o ).

tff(pred_def_20942,type,
    v38120: state_type > $o ).

tff(pred_def_20943,type,
    v38128: state_type > $o ).

tff(pred_def_20944,type,
    v38126: state_type > $o ).

tff(pred_def_20945,type,
    v38142: state_type > $o ).

tff(pred_def_20946,type,
    v38140: state_type > $o ).

tff(pred_def_20947,type,
    v38146: state_type > $o ).

tff(pred_def_20948,type,
    v38144: state_type > $o ).

tff(pred_def_20949,type,
    v38150: state_type > $o ).

tff(pred_def_20950,type,
    v38148: state_type > $o ).

tff(pred_def_20951,type,
    v38153: state_type > $o ).

tff(pred_def_20952,type,
    v38152: state_type > $o ).

tff(pred_def_20953,type,
    v38138: state_type > $o ).

tff(pred_def_20954,type,
    v38136: state_type > $o ).

tff(pred_def_20955,type,
    v38134: state_type > $o ).

tff(pred_def_20956,type,
    v38132: state_type > $o ).

tff(pred_def_20957,type,
    v38130: state_type > $o ).

tff(pred_def_20958,type,
    v38157: state_type > $o ).

tff(pred_def_20959,type,
    v38155: state_type > $o ).

tff(pred_def_20960,type,
    v38124: state_type > $o ).

tff(pred_def_20961,type,
    v38163: state_type > $o ).

tff(pred_def_20962,type,
    v38165: state_type > $o ).

tff(pred_def_20963,type,
    v38161: state_type > $o ).

tff(pred_def_20964,type,
    v38160: state_type > $o ).

tff(pred_def_20965,type,
    v38171: state_type > $o ).

tff(pred_def_20966,type,
    v38172: state_type > $o ).

tff(pred_def_20967,type,
    v38168: state_type > $o ).

tff(pred_def_20968,type,
    v38170: state_type > $o ).

tff(pred_def_20969,type,
    v38178: state_type > $o ).

tff(pred_def_20970,type,
    v38176: state_type > $o ).

tff(pred_def_20971,type,
    v38180: state_type > $o ).

tff(pred_def_20972,type,
    v38118: state_type > $o ).

tff(pred_def_20973,type,
    v38116: state_type > $o ).

tff(pred_def_20974,type,
    v38114: state_type > $o ).

tff(pred_def_20975,type,
    v38187: state_type > $o ).

tff(pred_def_20976,type,
    v38185: state_type > $o ).

tff(pred_def_20977,type,
    v38184: state_type > $o ).

tff(pred_def_20978,type,
    v38183: state_type > $o ).

tff(pred_def_20979,type,
    v38195: state_type > $o ).

tff(pred_def_20980,type,
    v38196: state_type > $o ).

tff(pred_def_20981,type,
    v38194: state_type > $o ).

tff(pred_def_20982,type,
    v38191: ( state_type * $int ) > $o ).

tff(pred_def_20983,type,
    v38193: ( state_type * $int ) > $o ).

tff(pred_def_20984,type,
    v38088: ( state_type * $int ) > $o ).

tff(pred_def_20985,type,
    v38086: ( state_type * $int ) > $o ).

tff(pred_def_20986,type,
    v38084: ( state_type * $int ) > $o ).

tff(pred_def_20987,type,
    v38082: ( state_type * $int ) > $o ).

tff(pred_def_20988,type,
    v38080: ( state_type * $int ) > $o ).

tff(pred_def_20989,type,
    v38218: state_type > $o ).

tff(pred_def_20990,type,
    v38216: state_type > $o ).

tff(pred_def_20991,type,
    v38222: state_type > $o ).

tff(pred_def_20992,type,
    v38220: state_type > $o ).

tff(pred_def_20993,type,
    v38226: state_type > $o ).

tff(pred_def_20994,type,
    v38224: state_type > $o ).

tff(pred_def_20995,type,
    v38229: state_type > $o ).

tff(pred_def_20996,type,
    v38228: state_type > $o ).

tff(pred_def_20997,type,
    v38214: state_type > $o ).

tff(pred_def_20998,type,
    v38212: state_type > $o ).

tff(pred_def_20999,type,
    v38210: state_type > $o ).

tff(pred_def_21000,type,
    v38208: state_type > $o ).

tff(pred_def_21001,type,
    v38206: state_type > $o ).

tff(pred_def_21002,type,
    v38204: state_type > $o ).

tff(pred_def_21003,type,
    v38202: state_type > $o ).

tff(pred_def_21004,type,
    v38200: state_type > $o ).

tff(pred_def_21005,type,
    v38249: state_type > $o ).

tff(pred_def_21006,type,
    v38247: state_type > $o ).

tff(pred_def_21007,type,
    v38245: state_type > $o ).

tff(pred_def_21008,type,
    v38243: state_type > $o ).

tff(pred_def_21009,type,
    v38241: state_type > $o ).

tff(pred_def_21010,type,
    v38259: state_type > $o ).

tff(pred_def_21011,type,
    v38257: state_type > $o ).

tff(pred_def_21012,type,
    v38255: state_type > $o ).

tff(pred_def_21013,type,
    v38253: state_type > $o ).

tff(pred_def_21014,type,
    v38251: state_type > $o ).

tff(pred_def_21015,type,
    v38263: ( state_type * $int ) > $o ).

tff(pred_def_21016,type,
    v38261: ( state_type * $int ) > $o ).

tff(pred_def_21017,type,
    v38273: state_type > $o ).

tff(pred_def_21018,type,
    v38271: state_type > $o ).

tff(pred_def_21019,type,
    v38279: state_type > $o ).

tff(pred_def_21020,type,
    v38277: state_type > $o ).

tff(pred_def_21021,type,
    v38293: state_type > $o ).

tff(pred_def_21022,type,
    v38291: state_type > $o ).

tff(pred_def_21023,type,
    v38297: state_type > $o ).

tff(pred_def_21024,type,
    v38295: state_type > $o ).

tff(pred_def_21025,type,
    v38301: state_type > $o ).

tff(pred_def_21026,type,
    v38299: state_type > $o ).

tff(pred_def_21027,type,
    v38304: state_type > $o ).

tff(pred_def_21028,type,
    v38303: state_type > $o ).

tff(pred_def_21029,type,
    v38289: state_type > $o ).

tff(pred_def_21030,type,
    v38287: state_type > $o ).

tff(pred_def_21031,type,
    v38285: state_type > $o ).

tff(pred_def_21032,type,
    v38283: state_type > $o ).

tff(pred_def_21033,type,
    v38281: state_type > $o ).

tff(pred_def_21034,type,
    v38308: state_type > $o ).

tff(pred_def_21035,type,
    v38306: state_type > $o ).

tff(pred_def_21036,type,
    v38275: state_type > $o ).

tff(pred_def_21037,type,
    v38314: state_type > $o ).

tff(pred_def_21038,type,
    v38316: state_type > $o ).

tff(pred_def_21039,type,
    v38312: state_type > $o ).

tff(pred_def_21040,type,
    v38311: state_type > $o ).

tff(pred_def_21041,type,
    v38322: state_type > $o ).

tff(pred_def_21042,type,
    v38323: state_type > $o ).

tff(pred_def_21043,type,
    v38319: state_type > $o ).

tff(pred_def_21044,type,
    v38321: state_type > $o ).

tff(pred_def_21045,type,
    v38329: state_type > $o ).

tff(pred_def_21046,type,
    v38327: state_type > $o ).

tff(pred_def_21047,type,
    v38331: state_type > $o ).

tff(pred_def_21048,type,
    v38269: state_type > $o ).

tff(pred_def_21049,type,
    v38267: state_type > $o ).

tff(pred_def_21050,type,
    v38265: state_type > $o ).

tff(pred_def_21051,type,
    v38338: state_type > $o ).

tff(pred_def_21052,type,
    v38336: state_type > $o ).

tff(pred_def_21053,type,
    v38335: state_type > $o ).

tff(pred_def_21054,type,
    v38334: state_type > $o ).

tff(pred_def_21055,type,
    v38346: state_type > $o ).

tff(pred_def_21056,type,
    v38347: state_type > $o ).

tff(pred_def_21057,type,
    v38345: state_type > $o ).

tff(pred_def_21058,type,
    v38342: ( state_type * $int ) > $o ).

tff(pred_def_21059,type,
    v38344: ( state_type * $int ) > $o ).

tff(pred_def_21060,type,
    v38239: ( state_type * $int ) > $o ).

tff(pred_def_21061,type,
    v38237: ( state_type * $int ) > $o ).

tff(pred_def_21062,type,
    v38235: ( state_type * $int ) > $o ).

tff(pred_def_21063,type,
    v38233: ( state_type * $int ) > $o ).

tff(pred_def_21064,type,
    v38231: ( state_type * $int ) > $o ).

tff(pred_def_21065,type,
    v38369: state_type > $o ).

tff(pred_def_21066,type,
    v38367: state_type > $o ).

tff(pred_def_21067,type,
    v38373: state_type > $o ).

tff(pred_def_21068,type,
    v38371: state_type > $o ).

tff(pred_def_21069,type,
    v38377: state_type > $o ).

tff(pred_def_21070,type,
    v38375: state_type > $o ).

tff(pred_def_21071,type,
    v38380: state_type > $o ).

tff(pred_def_21072,type,
    v38379: state_type > $o ).

tff(pred_def_21073,type,
    v38365: state_type > $o ).

tff(pred_def_21074,type,
    v38363: state_type > $o ).

tff(pred_def_21075,type,
    v38361: state_type > $o ).

tff(pred_def_21076,type,
    v38359: state_type > $o ).

tff(pred_def_21077,type,
    v38357: state_type > $o ).

tff(pred_def_21078,type,
    v38355: state_type > $o ).

tff(pred_def_21079,type,
    v38353: state_type > $o ).

tff(pred_def_21080,type,
    v38351: state_type > $o ).

tff(pred_def_21081,type,
    v38400: state_type > $o ).

tff(pred_def_21082,type,
    v38398: state_type > $o ).

tff(pred_def_21083,type,
    v38396: state_type > $o ).

tff(pred_def_21084,type,
    v38394: state_type > $o ).

tff(pred_def_21085,type,
    v38392: state_type > $o ).

tff(pred_def_21086,type,
    v38410: state_type > $o ).

tff(pred_def_21087,type,
    v38408: state_type > $o ).

tff(pred_def_21088,type,
    v38406: state_type > $o ).

tff(pred_def_21089,type,
    v38404: state_type > $o ).

tff(pred_def_21090,type,
    v38402: state_type > $o ).

tff(pred_def_21091,type,
    v38414: ( state_type * $int ) > $o ).

tff(pred_def_21092,type,
    v38412: ( state_type * $int ) > $o ).

tff(pred_def_21093,type,
    v38424: state_type > $o ).

tff(pred_def_21094,type,
    v38422: state_type > $o ).

tff(pred_def_21095,type,
    v38430: state_type > $o ).

tff(pred_def_21096,type,
    v38428: state_type > $o ).

tff(pred_def_21097,type,
    v38443: state_type > $o ).

tff(pred_def_21098,type,
    v38441: state_type > $o ).

tff(pred_def_21099,type,
    v38447: state_type > $o ).

tff(pred_def_21100,type,
    v38445: state_type > $o ).

tff(pred_def_21101,type,
    v38451: state_type > $o ).

tff(pred_def_21102,type,
    v38449: state_type > $o ).

tff(pred_def_21103,type,
    v38454: state_type > $o ).

tff(pred_def_21104,type,
    v38453: state_type > $o ).

tff(pred_def_21105,type,
    v38439: state_type > $o ).

tff(pred_def_21106,type,
    v38437: state_type > $o ).

tff(pred_def_21107,type,
    v38434: state_type > $o ).

tff(pred_def_21108,type,
    v38432: state_type > $o ).

tff(pred_def_21109,type,
    v38458: state_type > $o ).

tff(pred_def_21110,type,
    v38456: state_type > $o ).

tff(pred_def_21111,type,
    v38426: state_type > $o ).

tff(pred_def_21112,type,
    v38464: state_type > $o ).

tff(pred_def_21113,type,
    v38466: state_type > $o ).

tff(pred_def_21114,type,
    v38462: state_type > $o ).

tff(pred_def_21115,type,
    v38461: state_type > $o ).

tff(pred_def_21116,type,
    v38472: state_type > $o ).

tff(pred_def_21117,type,
    v38473: state_type > $o ).

tff(pred_def_21118,type,
    v38469: state_type > $o ).

tff(pred_def_21119,type,
    v38471: state_type > $o ).

tff(pred_def_21120,type,
    v38479: state_type > $o ).

tff(pred_def_21121,type,
    v38477: state_type > $o ).

tff(pred_def_21122,type,
    v38481: state_type > $o ).

tff(pred_def_21123,type,
    v38420: state_type > $o ).

tff(pred_def_21124,type,
    v38418: state_type > $o ).

tff(pred_def_21125,type,
    v38416: state_type > $o ).

tff(pred_def_21126,type,
    v38488: state_type > $o ).

tff(pred_def_21127,type,
    v38486: state_type > $o ).

tff(pred_def_21128,type,
    v38485: state_type > $o ).

tff(pred_def_21129,type,
    v38484: state_type > $o ).

tff(pred_def_21130,type,
    v38496: state_type > $o ).

tff(pred_def_21131,type,
    v38497: state_type > $o ).

tff(pred_def_21132,type,
    v38495: state_type > $o ).

tff(pred_def_21133,type,
    v38492: ( state_type * $int ) > $o ).

tff(pred_def_21134,type,
    v38494: ( state_type * $int ) > $o ).

tff(pred_def_21135,type,
    v38390: ( state_type * $int ) > $o ).

tff(pred_def_21136,type,
    v38388: ( state_type * $int ) > $o ).

tff(pred_def_21137,type,
    v38386: ( state_type * $int ) > $o ).

tff(pred_def_21138,type,
    v38384: ( state_type * $int ) > $o ).

tff(pred_def_21139,type,
    v38382: ( state_type * $int ) > $o ).

tff(pred_def_21140,type,
    v38509: state_type > $o ).

tff(pred_def_21141,type,
    v38507: state_type > $o ).

tff(pred_def_21142,type,
    v38505: state_type > $o ).

tff(pred_def_21143,type,
    v38503: state_type > $o ).

tff(pred_def_21144,type,
    v38501: state_type > $o ).

tff(pred_def_21145,type,
    v38517: state_type > $o ).

tff(pred_def_21146,type,
    v38516: ( state_type * $int ) > $o ).

tff(pred_def_21147,type,
    v38515: ( state_type * $int ) > $o ).

tff(pred_def_21148,type,
    v38520: state_type > $o ).

tff(pred_def_21149,type,
    v38519: ( state_type * $int ) > $o ).

tff(pred_def_21150,type,
    v38518: ( state_type * $int ) > $o ).

tff(pred_def_21151,type,
    v38514: ( state_type * $int ) > $o ).

tff(pred_def_21152,type,
    v38523: state_type > $o ).

tff(pred_def_21153,type,
    v38522: ( state_type * $int ) > $o ).

tff(pred_def_21154,type,
    v38521: ( state_type * $int ) > $o ).

tff(pred_def_21155,type,
    v38513: ( state_type * $int ) > $o ).

tff(pred_def_21156,type,
    v38526: state_type > $o ).

tff(pred_def_21157,type,
    v38525: ( state_type * $int ) > $o ).

tff(pred_def_21158,type,
    v38524: ( state_type * $int ) > $o ).

tff(pred_def_21159,type,
    v38512: ( state_type * $int ) > $o ).

tff(pred_def_21160,type,
    v38529: state_type > $o ).

tff(pred_def_21161,type,
    v38528: ( state_type * $int ) > $o ).

tff(pred_def_21162,type,
    v38527: ( state_type * $int ) > $o ).

tff(pred_def_21163,type,
    v38511: ( state_type * $int ) > $o ).

tff(pred_def_21164,type,
    v38532: state_type > $o ).

tff(pred_def_21165,type,
    v38531: ( state_type * $int ) > $o ).

tff(pred_def_21166,type,
    v38530: ( state_type * $int ) > $o ).

tff(pred_def_21167,type,
    v37003: ( state_type * $int ) > $o ).

tff(pred_def_21168,type,
    v37001: ( state_type * $int ) > $o ).

tff(pred_def_21169,type,
    v36999: ( state_type * $int ) > $o ).

tff(pred_def_21170,type,
    v36997: ( state_type * $int ) > $o ).

tff(pred_def_21171,type,
    v36995: ( state_type * $int ) > $o ).

tff(pred_def_21172,type,
    v36989: state_type > $o ).

tff(pred_def_21173,type,
    v36987: state_type > $o ).

tff(pred_def_21174,type,
    v36985: state_type > $o ).

tff(pred_def_21175,type,
    v38543: ( state_type * $int ) > $o ).

tff(pred_def_21176,type,
    v38541: ( state_type * $int ) > $o ).

tff(pred_def_21177,type,
    v38577: state_type > $o ).

tff(pred_def_21178,type,
    v38575: state_type > $o ).

tff(pred_def_21179,type,
    v38573: state_type > $o ).

tff(pred_def_21180,type,
    v38571: state_type > $o ).

tff(pred_def_21181,type,
    v38569: state_type > $o ).

tff(pred_def_21182,type,
    v38567: state_type > $o ).

tff(pred_def_21183,type,
    v38565: state_type > $o ).

tff(pred_def_21184,type,
    v38591: state_type > $o ).

tff(pred_def_21185,type,
    v38589: state_type > $o ).

tff(pred_def_21186,type,
    v38587: state_type > $o ).

tff(pred_def_21187,type,
    v38585: state_type > $o ).

tff(pred_def_21188,type,
    v38583: state_type > $o ).

tff(pred_def_21189,type,
    v38581: state_type > $o ).

tff(pred_def_21190,type,
    v38579: state_type > $o ).

tff(pred_def_21191,type,
    v38617: state_type > $o ).

tff(pred_def_21192,type,
    v38619: state_type > $o ).

tff(pred_def_21193,type,
    v38618: ( state_type * $int ) > $o ).

tff(pred_def_21194,type,
    v38620: state_type > $o ).

tff(pred_def_21195,type,
    v38615: ( state_type * $int ) > $o ).

tff(pred_def_21196,type,
    v38613: ( state_type * $int ) > $o ).

tff(pred_def_21197,type,
    v38621: ( state_type * $int ) > $o ).

tff(pred_def_21198,type,
    v38611: ( state_type * $int ) > $o ).

tff(pred_def_21199,type,
    v38609: ( state_type * $int ) > $o ).

tff(pred_def_21200,type,
    v38607: state_type > $o ).

tff(pred_def_21201,type,
    v38623: state_type > $o ).

tff(pred_def_21202,type,
    v38605: ( state_type * $int ) > $o ).

tff(pred_def_21203,type,
    v38603: ( state_type * $int ) > $o ).

tff(pred_def_21204,type,
    v38637: ( state_type * $int ) > $o ).

tff(pred_def_21205,type,
    v38635: ( state_type * $int ) > $o ).

tff(pred_def_21206,type,
    v38641: state_type > $o ).

tff(pred_def_21207,type,
    v38639: state_type > $o ).

tff(pred_def_21208,type,
    v38665: state_type > $o ).

tff(pred_def_21209,type,
    v38663: state_type > $o ).

tff(pred_def_21210,type,
    v38661: state_type > $o ).

tff(pred_def_21211,type,
    v38659: state_type > $o ).

tff(pred_def_21212,type,
    v38657: state_type > $o ).

tff(pred_def_21213,type,
    v38655: state_type > $o ).

tff(pred_def_21214,type,
    v38653: state_type > $o ).

tff(pred_def_21215,type,
    v38679: state_type > $o ).

tff(pred_def_21216,type,
    v38677: state_type > $o ).

tff(pred_def_21217,type,
    v38675: state_type > $o ).

tff(pred_def_21218,type,
    v38673: state_type > $o ).

tff(pred_def_21219,type,
    v38671: state_type > $o ).

tff(pred_def_21220,type,
    v38669: state_type > $o ).

tff(pred_def_21221,type,
    v38667: state_type > $o ).

tff(pred_def_21222,type,
    v38695: ( state_type * $int ) > $o ).

tff(pred_def_21223,type,
    v38693: ( state_type * $int ) > $o ).

tff(pred_def_21224,type,
    v38691: ( state_type * $int ) > $o ).

tff(pred_def_21225,type,
    v38689: ( state_type * $int ) > $o ).

tff(pred_def_21226,type,
    v38687: ( state_type * $int ) > $o ).

tff(pred_def_21227,type,
    v38725: ( state_type * $int ) > $o ).

tff(pred_def_21228,type,
    v38727: ( state_type * $int ) > $o ).

tff(pred_def_21229,type,
    v38723: ( state_type * $int ) > $o ).

tff(pred_def_21230,type,
    v38721: ( state_type * $int ) > $o ).

tff(pred_def_21231,type,
    v38719: ( state_type * $int ) > $o ).

tff(pred_def_21232,type,
    v38717: ( state_type * $int ) > $o ).

tff(pred_def_21233,type,
    v38715: state_type > $o ).

tff(pred_def_21234,type,
    v38713: state_type > $o ).

tff(pred_def_21235,type,
    v38731: state_type > $o ).

tff(pred_def_21236,type,
    v38729: state_type > $o ).

tff(pred_def_21237,type,
    v38733: state_type > $o ).

tff(pred_def_21238,type,
    v38711: state_type > $o ).

tff(pred_def_21239,type,
    v38709: state_type > $o ).

tff(pred_def_21240,type,
    v38707: state_type > $o ).

tff(pred_def_21241,type,
    v38705: state_type > $o ).

tff(pred_def_21242,type,
    v38703: state_type > $o ).

tff(pred_def_21243,type,
    v38701: state_type > $o ).

tff(pred_def_21244,type,
    v38699: state_type > $o ).

tff(pred_def_21245,type,
    v38697: state_type > $o ).

tff(pred_def_21246,type,
    v38743: ( state_type * $int ) > $o ).

tff(pred_def_21247,type,
    v38741: ( state_type * $int ) > $o ).

tff(pred_def_21248,type,
    v38739: ( state_type * $int ) > $o ).

tff(pred_def_21249,type,
    v38737: ( state_type * $int ) > $o ).

tff(pred_def_21250,type,
    v38735: ( state_type * $int ) > $o ).

tff(pred_def_21251,type,
    v38773: ( state_type * $int ) > $o ).

tff(pred_def_21252,type,
    v38771: ( state_type * $int ) > $o ).

tff(pred_def_21253,type,
    v38774: ( state_type * $int ) > $o ).

tff(pred_def_21254,type,
    v38769: ( state_type * $int ) > $o ).

tff(pred_def_21255,type,
    v38767: ( state_type * $int ) > $o ).

tff(pred_def_21256,type,
    v38765: ( state_type * $int ) > $o ).

tff(pred_def_21257,type,
    v38763: state_type > $o ).

tff(pred_def_21258,type,
    v38761: state_type > $o ).

tff(pred_def_21259,type,
    v38778: state_type > $o ).

tff(pred_def_21260,type,
    v38776: state_type > $o ).

tff(pred_def_21261,type,
    v38780: state_type > $o ).

tff(pred_def_21262,type,
    v38759: state_type > $o ).

tff(pred_def_21263,type,
    v38757: state_type > $o ).

tff(pred_def_21264,type,
    v38755: state_type > $o ).

tff(pred_def_21265,type,
    v38753: state_type > $o ).

tff(pred_def_21266,type,
    v38751: state_type > $o ).

tff(pred_def_21267,type,
    v38749: state_type > $o ).

tff(pred_def_21268,type,
    v38747: state_type > $o ).

tff(pred_def_21269,type,
    v38745: state_type > $o ).

tff(pred_def_21270,type,
    v38790: ( state_type * $int ) > $o ).

tff(pred_def_21271,type,
    v38788: ( state_type * $int ) > $o ).

tff(pred_def_21272,type,
    v38786: ( state_type * $int ) > $o ).

tff(pred_def_21273,type,
    v38784: ( state_type * $int ) > $o ).

tff(pred_def_21274,type,
    v38782: ( state_type * $int ) > $o ).

tff(pred_def_21275,type,
    v38810: state_type > $o ).

tff(pred_def_21276,type,
    v38808: state_type > $o ).

tff(pred_def_21277,type,
    v38814: state_type > $o ).

tff(pred_def_21278,type,
    v38812: state_type > $o ).

tff(pred_def_21279,type,
    v38816: state_type > $o ).

tff(pred_def_21280,type,
    v38806: state_type > $o ).

tff(pred_def_21281,type,
    v38804: state_type > $o ).

tff(pred_def_21282,type,
    v38802: state_type > $o ).

tff(pred_def_21283,type,
    v38800: state_type > $o ).

tff(pred_def_21284,type,
    v38798: state_type > $o ).

tff(pred_def_21285,type,
    v38796: state_type > $o ).

tff(pred_def_21286,type,
    v38794: state_type > $o ).

tff(pred_def_21287,type,
    v38792: state_type > $o ).

tff(pred_def_21288,type,
    v38826: ( state_type * $int ) > $o ).

tff(pred_def_21289,type,
    v38824: ( state_type * $int ) > $o ).

tff(pred_def_21290,type,
    v38822: ( state_type * $int ) > $o ).

tff(pred_def_21291,type,
    v38820: ( state_type * $int ) > $o ).

tff(pred_def_21292,type,
    v38818: ( state_type * $int ) > $o ).

tff(pred_def_21293,type,
    v38846: state_type > $o ).

tff(pred_def_21294,type,
    v38844: state_type > $o ).

tff(pred_def_21295,type,
    v38850: state_type > $o ).

tff(pred_def_21296,type,
    v38848: state_type > $o ).

tff(pred_def_21297,type,
    v38852: state_type > $o ).

tff(pred_def_21298,type,
    v38842: state_type > $o ).

tff(pred_def_21299,type,
    v38840: state_type > $o ).

tff(pred_def_21300,type,
    v38838: state_type > $o ).

tff(pred_def_21301,type,
    v38836: state_type > $o ).

tff(pred_def_21302,type,
    v38834: state_type > $o ).

tff(pred_def_21303,type,
    v38832: state_type > $o ).

tff(pred_def_21304,type,
    v38830: state_type > $o ).

tff(pred_def_21305,type,
    v38828: state_type > $o ).

tff(pred_def_21306,type,
    v38858: state_type > $o ).

tff(pred_def_21307,type,
    v38857: ( state_type * $int ) > $o ).

tff(pred_def_21308,type,
    v38856: ( state_type * $int ) > $o ).

tff(pred_def_21309,type,
    v38861: state_type > $o ).

tff(pred_def_21310,type,
    v38860: ( state_type * $int ) > $o ).

tff(pred_def_21311,type,
    v38859: ( state_type * $int ) > $o ).

tff(pred_def_21312,type,
    v38855: ( state_type * $int ) > $o ).

tff(pred_def_21313,type,
    v38864: state_type > $o ).

tff(pred_def_21314,type,
    v38863: ( state_type * $int ) > $o ).

tff(pred_def_21315,type,
    v38862: ( state_type * $int ) > $o ).

tff(pred_def_21316,type,
    v38854: ( state_type * $int ) > $o ).

tff(pred_def_21317,type,
    v38867: state_type > $o ).

tff(pred_def_21318,type,
    v38866: ( state_type * $int ) > $o ).

tff(pred_def_21319,type,
    v38865: ( state_type * $int ) > $o ).

tff(pred_def_21320,type,
    v38685: ( state_type * $int ) > $o ).

tff(pred_def_21321,type,
    v38683: ( state_type * $int ) > $o ).

tff(pred_def_21322,type,
    v38681: ( state_type * $int ) > $o ).

tff(pred_def_21323,type,
    v38879: state_type > $o ).

tff(pred_def_21324,type,
    v38877: state_type > $o ).

tff(pred_def_21325,type,
    v38875: state_type > $o ).

tff(pred_def_21326,type,
    v38889: state_type > $o ).

tff(pred_def_21327,type,
    v38887: state_type > $o ).

tff(pred_def_21328,type,
    v38885: state_type > $o ).

tff(pred_def_21329,type,
    v38883: state_type > $o ).

tff(pred_def_21330,type,
    v38881: state_type > $o ).

tff(pred_def_21331,type,
    v38891: state_type > $o ).

tff(pred_def_21332,type,
    v38873: state_type > $o ).

tff(pred_def_21333,type,
    v38871: state_type > $o ).

tff(pred_def_21334,type,
    v38869: state_type > $o ).

tff(pred_def_21335,type,
    v38898: state_type > $o ).

tff(pred_def_21336,type,
    v38896: state_type > $o ).

tff(pred_def_21337,type,
    v38895: state_type > $o ).

tff(pred_def_21338,type,
    v38894: state_type > $o ).

tff(pred_def_21339,type,
    v38906: state_type > $o ).

tff(pred_def_21340,type,
    v38907: state_type > $o ).

tff(pred_def_21341,type,
    v38905: state_type > $o ).

tff(pred_def_21342,type,
    v38902: ( state_type * $int ) > $o ).

tff(pred_def_21343,type,
    v38904: ( state_type * $int ) > $o ).

tff(pred_def_21344,type,
    v38651: ( state_type * $int ) > $o ).

tff(pred_def_21345,type,
    v38649: ( state_type * $int ) > $o ).

tff(pred_def_21346,type,
    v38647: ( state_type * $int ) > $o ).

tff(pred_def_21347,type,
    v38645: ( state_type * $int ) > $o ).

tff(pred_def_21348,type,
    v38643: ( state_type * $int ) > $o ).

tff(pred_def_21349,type,
    v38913: state_type > $o ).

tff(pred_def_21350,type,
    v38911: state_type > $o ).

tff(pred_def_21351,type,
    v38917: state_type > $o ).

tff(pred_def_21352,type,
    v38916: ( state_type * $int ) > $o ).

tff(pred_def_21353,type,
    v38915: ( state_type * $int ) > $o ).

tff(pred_def_21354,type,
    v38920: state_type > $o ).

tff(pred_def_21355,type,
    v38919: ( state_type * $int ) > $o ).

tff(pred_def_21356,type,
    v38918: ( state_type * $int ) > $o ).

tff(pred_def_21357,type,
    v38633: ( state_type * $int ) > $o ).

tff(pred_def_21358,type,
    v38631: ( state_type * $int ) > $o ).

tff(pred_def_21359,type,
    v38629: ( state_type * $int ) > $o ).

tff(pred_def_21360,type,
    v38627: ( state_type * $int ) > $o ).

tff(pred_def_21361,type,
    v38625: ( state_type * $int ) > $o ).

tff(pred_def_21362,type,
    v38601: ( state_type * $int ) > $o ).

tff(pred_def_21363,type,
    v38599: ( state_type * $int ) > $o ).

tff(pred_def_21364,type,
    v38597: ( state_type * $int ) > $o ).

tff(pred_def_21365,type,
    v38595: ( state_type * $int ) > $o ).

tff(pred_def_21366,type,
    v38593: ( state_type * $int ) > $o ).

tff(pred_def_21367,type,
    v38933: state_type > $o ).

tff(pred_def_21368,type,
    v38931: state_type > $o ).

tff(pred_def_21369,type,
    v38929: state_type > $o ).

tff(pred_def_21370,type,
    v38939: state_type > $o ).

tff(pred_def_21371,type,
    v38937: state_type > $o ).

tff(pred_def_21372,type,
    v38957: ( state_type * $int ) > $o ).

tff(pred_def_21373,type,
    v38959: ( state_type * $int ) > $o ).

tff(pred_def_21374,type,
    v38955: ( state_type * $int ) > $o ).

tff(pred_def_21375,type,
    v38953: state_type > $o ).

tff(pred_def_21376,type,
    v38951: state_type > $o ).

tff(pred_def_21377,type,
    v38963: state_type > $o ).

tff(pred_def_21378,type,
    v38961: state_type > $o ).

tff(pred_def_21379,type,
    v38967: state_type > $o ).

tff(pred_def_21380,type,
    v38965: state_type > $o ).

tff(pred_def_21381,type,
    v38970: state_type > $o ).

tff(pred_def_21382,type,
    v38969: state_type > $o ).

tff(pred_def_21383,type,
    v38949: state_type > $o ).

tff(pred_def_21384,type,
    v38947: state_type > $o ).

tff(pred_def_21385,type,
    v38945: state_type > $o ).

tff(pred_def_21386,type,
    v38943: state_type > $o ).

tff(pred_def_21387,type,
    v38941: state_type > $o ).

tff(pred_def_21388,type,
    v38978: state_type > $o ).

tff(pred_def_21389,type,
    v38976: state_type > $o ).

tff(pred_def_21390,type,
    v38974: state_type > $o ).

tff(pred_def_21391,type,
    v38972: state_type > $o ).

tff(pred_def_21392,type,
    v38935: state_type > $o ).

tff(pred_def_21393,type,
    v38984: state_type > $o ).

tff(pred_def_21394,type,
    v38986: state_type > $o ).

tff(pred_def_21395,type,
    v38982: state_type > $o ).

tff(pred_def_21396,type,
    v38981: state_type > $o ).

tff(pred_def_21397,type,
    v38992: state_type > $o ).

tff(pred_def_21398,type,
    v38993: state_type > $o ).

tff(pred_def_21399,type,
    v38989: state_type > $o ).

tff(pred_def_21400,type,
    v38991: state_type > $o ).

tff(pred_def_21401,type,
    v39003: state_type > $o ).

tff(pred_def_21402,type,
    v39001: state_type > $o ).

tff(pred_def_21403,type,
    v38999: state_type > $o ).

tff(pred_def_21404,type,
    v38997: state_type > $o ).

tff(pred_def_21405,type,
    v39005: state_type > $o ).

tff(pred_def_21406,type,
    v38927: state_type > $o ).

tff(pred_def_21407,type,
    v38925: state_type > $o ).

tff(pred_def_21408,type,
    v38923: state_type > $o ).

tff(pred_def_21409,type,
    v39012: state_type > $o ).

tff(pred_def_21410,type,
    v39010: state_type > $o ).

tff(pred_def_21411,type,
    v39009: state_type > $o ).

tff(pred_def_21412,type,
    v39008: state_type > $o ).

tff(pred_def_21413,type,
    v39020: state_type > $o ).

tff(pred_def_21414,type,
    v39021: state_type > $o ).

tff(pred_def_21415,type,
    v39019: state_type > $o ).

tff(pred_def_21416,type,
    v39016: ( state_type * $int ) > $o ).

tff(pred_def_21417,type,
    v39018: ( state_type * $int ) > $o ).

tff(pred_def_21418,type,
    v38563: ( state_type * $int ) > $o ).

tff(pred_def_21419,type,
    v38561: ( state_type * $int ) > $o ).

tff(pred_def_21420,type,
    v38559: ( state_type * $int ) > $o ).

tff(pred_def_21421,type,
    v38557: ( state_type * $int ) > $o ).

tff(pred_def_21422,type,
    v38555: ( state_type * $int ) > $o ).

tff(pred_def_21423,type,
    v39057: state_type > $o ).

tff(pred_def_21424,type,
    v39055: state_type > $o ).

tff(pred_def_21425,type,
    v39053: state_type > $o ).

tff(pred_def_21426,type,
    v39051: state_type > $o ).

tff(pred_def_21427,type,
    v39049: state_type > $o ).

tff(pred_def_21428,type,
    v39047: state_type > $o ).

tff(pred_def_21429,type,
    v39067: state_type > $o ).

tff(pred_def_21430,type,
    v39065: state_type > $o ).

tff(pred_def_21431,type,
    v39063: state_type > $o ).

tff(pred_def_21432,type,
    v39061: state_type > $o ).

tff(pred_def_21433,type,
    v39059: state_type > $o ).

tff(pred_def_21434,type,
    v39094: state_type > $o ).

tff(pred_def_21435,type,
    v39093: ( state_type * $int ) > $o ).

tff(pred_def_21436,type,
    v39092: ( state_type * $int ) > $o ).

tff(pred_def_21437,type,
    v39090: ( state_type * $int ) > $o ).

tff(pred_def_21438,type,
    v39110: state_type > $o ).

tff(pred_def_21439,type,
    v39111: ( state_type * $int ) > $o ).

tff(pred_def_21440,type,
    v39112: state_type > $o ).

tff(pred_def_21441,type,
    v39108: ( state_type * $int ) > $o ).

tff(pred_def_21442,type,
    v39106: ( state_type * $int ) > $o ).

tff(pred_def_21443,type,
    v39136: ( state_type * $int ) > $o ).

tff(pred_def_21444,type,
    v39045: ( state_type * $int ) > $o ).

tff(pred_def_21445,type,
    v39134: ( state_type * $int ) > $o ).

tff(pred_def_21446,type,
    v39137: ( state_type * $int ) > $o ).

tff(pred_def_21447,type,
    v39132: ( state_type * $int ) > $o ).

tff(pred_def_21448,type,
    v39130: ( state_type * $int ) > $o ).

tff(pred_def_21449,type,
    v39128: ( state_type * $int ) > $o ).

tff(pred_def_21450,type,
    v39126: state_type > $o ).

tff(pred_def_21451,type,
    v39124: state_type > $o ).

tff(pred_def_21452,type,
    v39143: state_type > $o ).

tff(pred_def_21453,type,
    v39083: state_type > $o ).

tff(pred_def_21454,type,
    v39142: ( state_type * $int ) > $o ).

tff(pred_def_21455,type,
    v39081: ( state_type * $int ) > $o ).

tff(pred_def_21456,type,
    v39079: ( state_type * $int ) > $o ).

tff(pred_def_21457,type,
    v39158: ( state_type * $int ) > $o ).

tff(pred_def_21458,type,
    v39157: ( state_type * $int ) > $o ).

tff(pred_def_21459,type,
    v39155: ( state_type * $int ) > $o ).

tff(pred_def_21460,type,
    v39162: state_type > $o ).

tff(pred_def_21461,type,
    v39160: state_type > $o ).

tff(pred_def_21462,type,
    v39173: ( state_type * $int ) > $o ).

tff(pred_def_21463,type,
    v39172: state_type > $o ).

tff(pred_def_21464,type,
    v39176: state_type > $o ).

tff(pred_def_21465,type,
    v39177: state_type > $o ).

tff(pred_def_21466,type,
    v39175: state_type > $o ).

tff(pred_def_21467,type,
    v39178: state_type > $o ).

tff(pred_def_21468,type,
    v39174: state_type > $o ).

tff(pred_def_21469,type,
    v39171: state_type > $o ).

tff(pred_def_21470,type,
    v39179: state_type > $o ).

tff(pred_def_21471,type,
    v39170: state_type > $o ).

tff(pred_def_21472,type,
    v39182: state_type > $o ).

tff(pred_def_21473,type,
    v39183: state_type > $o ).

tff(pred_def_21474,type,
    v39181: state_type > $o ).

tff(pred_def_21475,type,
    v39184: state_type > $o ).

tff(pred_def_21476,type,
    v39180: state_type > $o ).

tff(pred_def_21477,type,
    v39169: state_type > $o ).

tff(pred_def_21478,type,
    v39185: state_type > $o ).

tff(pred_def_21479,type,
    v39168: state_type > $o ).

tff(pred_def_21480,type,
    v39167: state_type > $o ).

tff(pred_def_21481,type,
    v39189: state_type > $o ).

tff(pred_def_21482,type,
    v39190: state_type > $o ).

tff(pred_def_21483,type,
    v39188: state_type > $o ).

tff(pred_def_21484,type,
    v39191: state_type > $o ).

tff(pred_def_21485,type,
    v39187: state_type > $o ).

tff(pred_def_21486,type,
    v39186: state_type > $o ).

tff(pred_def_21487,type,
    v39166: state_type > $o ).

tff(pred_def_21488,type,
    v39192: state_type > $o ).

tff(pred_def_21489,type,
    v39165: state_type > $o ).

tff(pred_def_21490,type,
    v39195: state_type > $o ).

tff(pred_def_21491,type,
    v39196: state_type > $o ).

tff(pred_def_21492,type,
    v39194: state_type > $o ).

tff(pred_def_21493,type,
    v39197: state_type > $o ).

tff(pred_def_21494,type,
    v39193: state_type > $o ).

tff(pred_def_21495,type,
    v39200: state_type > $o ).

tff(pred_def_21496,type,
    v39201: state_type > $o ).

tff(pred_def_21497,type,
    v39199: state_type > $o ).

tff(pred_def_21498,type,
    v39202: state_type > $o ).

tff(pred_def_21499,type,
    v39198: state_type > $o ).

tff(pred_def_21500,type,
    v39205: state_type > $o ).

tff(pred_def_21501,type,
    v39206: state_type > $o ).

tff(pred_def_21502,type,
    v39204: state_type > $o ).

tff(pred_def_21503,type,
    v39207: state_type > $o ).

tff(pred_def_21504,type,
    v39203: state_type > $o ).

tff(pred_def_21505,type,
    v39163: ( state_type * $int ) > $o ).

tff(pred_def_21506,type,
    v39153: ( state_type * $int ) > $o ).

tff(pred_def_21507,type,
    v39151: ( state_type * $int ) > $o ).

tff(pred_def_21508,type,
    v39149: ( state_type * $int ) > $o ).

tff(pred_def_21509,type,
    v39147: ( state_type * $int ) > $o ).

tff(pred_def_21510,type,
    v39145: ( state_type * $int ) > $o ).

tff(pred_def_21511,type,
    v39208: ( state_type * $int ) > $o ).

tff(pred_def_21512,type,
    v39077: ( state_type * $int ) > $o ).

tff(pred_def_21513,type,
    v39075: ( state_type * $int ) > $o ).

tff(pred_def_21514,type,
    v39073: ( state_type * $int ) > $o ).

tff(pred_def_21515,type,
    v39209: ( state_type * $int ) > $o ).

tff(pred_def_21516,type,
    v39210: ( state_type * $int ) > $o ).

tff(pred_def_21517,type,
    v39071: ( state_type * $int ) > $o ).

tff(pred_def_21518,type,
    v39069: ( state_type * $int ) > $o ).

tff(pred_def_21519,type,
    v39220: state_type > $o ).

tff(pred_def_21520,type,
    v39218: state_type > $o ).

tff(pred_def_21521,type,
    v39226: state_type > $o ).

tff(pred_def_21522,type,
    v39224: state_type > $o ).

tff(pred_def_21523,type,
    v39230: state_type > $o ).

tff(pred_def_21524,type,
    v39228: state_type > $o ).

tff(pred_def_21525,type,
    v39234: state_type > $o ).

tff(pred_def_21526,type,
    v39232: state_type > $o ).

tff(pred_def_21527,type,
    v39222: state_type > $o ).

tff(pred_def_21528,type,
    v39240: state_type > $o ).

tff(pred_def_21529,type,
    v39242: state_type > $o ).

tff(pred_def_21530,type,
    v39238: state_type > $o ).

tff(pred_def_21531,type,
    v39237: state_type > $o ).

tff(pred_def_21532,type,
    v39248: state_type > $o ).

tff(pred_def_21533,type,
    v39249: state_type > $o ).

tff(pred_def_21534,type,
    v39245: state_type > $o ).

tff(pred_def_21535,type,
    v39247: state_type > $o ).

tff(pred_def_21536,type,
    v39255: state_type > $o ).

tff(pred_def_21537,type,
    v39253: state_type > $o ).

tff(pred_def_21538,type,
    v39257: state_type > $o ).

tff(pred_def_21539,type,
    v39216: state_type > $o ).

tff(pred_def_21540,type,
    v39214: state_type > $o ).

tff(pred_def_21541,type,
    v39212: state_type > $o ).

tff(pred_def_21542,type,
    v39264: state_type > $o ).

tff(pred_def_21543,type,
    v39262: state_type > $o ).

tff(pred_def_21544,type,
    v39261: state_type > $o ).

tff(pred_def_21545,type,
    v39260: state_type > $o ).

tff(pred_def_21546,type,
    v39272: state_type > $o ).

tff(pred_def_21547,type,
    v39273: state_type > $o ).

tff(pred_def_21548,type,
    v39271: state_type > $o ).

tff(pred_def_21549,type,
    v39268: ( state_type * $int ) > $o ).

tff(pred_def_21550,type,
    v39270: ( state_type * $int ) > $o ).

tff(pred_def_21551,type,
    v39259: ( state_type * $int ) > $o ).

tff(pred_def_21552,type,
    v39141: state_type > $o ).

tff(pred_def_21553,type,
    v39139: state_type > $o ).

tff(pred_def_21554,type,
    v39285: state_type > $o ).

tff(pred_def_21555,type,
    v39283: state_type > $o ).

tff(pred_def_21556,type,
    v39282: state_type > $o ).

tff(pred_def_21557,type,
    v39281: ( state_type * $int ) > $o ).

tff(pred_def_21558,type,
    v39279: state_type > $o ).

tff(pred_def_21559,type,
    v39277: state_type > $o ).

tff(pred_def_21560,type,
    v39290: state_type > $o ).

tff(pred_def_21561,type,
    v39289: state_type > $o ).

tff(pred_def_21562,type,
    v39122: state_type > $o ).

tff(pred_def_21563,type,
    v39120: state_type > $o ).

tff(pred_def_21564,type,
    v39118: state_type > $o ).

tff(pred_def_21565,type,
    v39291: ( state_type * $int ) > $o ).

tff(pred_def_21566,type,
    v39292: state_type > $o ).

tff(pred_def_21567,type,
    v39116: ( state_type * $int ) > $o ).

tff(pred_def_21568,type,
    v39114: ( state_type * $int ) > $o ).

tff(pred_def_21569,type,
    v39293: ( state_type * $int ) > $o ).

tff(pred_def_21570,type,
    v39104: ( state_type * $int ) > $o ).

tff(pred_def_21571,type,
    v39102: ( state_type * $int ) > $o ).

tff(pred_def_21572,type,
    v39100: state_type > $o ).

tff(pred_def_21573,type,
    v39294: ( state_type * $int ) > $o ).

tff(pred_def_21574,type,
    v39295: state_type > $o ).

tff(pred_def_21575,type,
    v39098: ( state_type * $int ) > $o ).

tff(pred_def_21576,type,
    v39096: ( state_type * $int ) > $o ).

tff(pred_def_21577,type,
    v39296: ( state_type * $int ) > $o ).

tff(pred_def_21578,type,
    v39088: ( state_type * $int ) > $o ).

tff(pred_def_21579,type,
    v39086: ( state_type * $int ) > $o ).

tff(pred_def_21580,type,
    v39302: state_type > $o ).

tff(pred_def_21581,type,
    v39300: state_type > $o ).

tff(pred_def_21582,type,
    v39299: state_type > $o ).

tff(pred_def_21583,type,
    v39298: ( state_type * $int ) > $o ).

tff(pred_def_21584,type,
    v39043: state_type > $o ).

tff(pred_def_21585,type,
    v39041: state_type > $o ).

tff(pred_def_21586,type,
    v39308: state_type > $o ).

tff(pred_def_21587,type,
    v39306: state_type > $o ).

tff(pred_def_21588,type,
    v39312: state_type > $o ).

tff(pred_def_21589,type,
    v39310: state_type > $o ).

tff(pred_def_21590,type,
    v39315: state_type > $o ).

tff(pred_def_21591,type,
    v39314: state_type > $o ).

tff(pred_def_21592,type,
    v39039: state_type > $o ).

tff(pred_def_21593,type,
    v39037: state_type > $o ).

tff(pred_def_21594,type,
    v39035: state_type > $o ).

tff(pred_def_21595,type,
    v39033: state_type > $o ).

tff(pred_def_21596,type,
    v39031: state_type > $o ).

tff(pred_def_21597,type,
    v39029: state_type > $o ).

tff(pred_def_21598,type,
    v39027: state_type > $o ).

tff(pred_def_21599,type,
    v39025: state_type > $o ).

tff(pred_def_21600,type,
    v39335: state_type > $o ).

tff(pred_def_21601,type,
    v39333: state_type > $o ).

tff(pred_def_21602,type,
    v39331: state_type > $o ).

tff(pred_def_21603,type,
    v39329: state_type > $o ).

tff(pred_def_21604,type,
    v39327: state_type > $o ).

tff(pred_def_21605,type,
    v39345: state_type > $o ).

tff(pred_def_21606,type,
    v39343: state_type > $o ).

tff(pred_def_21607,type,
    v39341: state_type > $o ).

tff(pred_def_21608,type,
    v39339: state_type > $o ).

tff(pred_def_21609,type,
    v39337: state_type > $o ).

tff(pred_def_21610,type,
    v39349: ( state_type * $int ) > $o ).

tff(pred_def_21611,type,
    v39347: ( state_type * $int ) > $o ).

tff(pred_def_21612,type,
    v39359: state_type > $o ).

tff(pred_def_21613,type,
    v39357: state_type > $o ).

tff(pred_def_21614,type,
    v39365: state_type > $o ).

tff(pred_def_21615,type,
    v39363: state_type > $o ).

tff(pred_def_21616,type,
    v39389: ( state_type * $int ) > $o ).

tff(pred_def_21617,type,
    v39387: ( state_type * $int ) > $o ).

tff(pred_def_21618,type,
    v39390: ( state_type * $int ) > $o ).

tff(pred_def_21619,type,
    v39385: ( state_type * $int ) > $o ).

tff(pred_def_21620,type,
    v39383: ( state_type * $int ) > $o ).

tff(pred_def_21621,type,
    v39381: ( state_type * $int ) > $o ).

tff(pred_def_21622,type,
    v39379: state_type > $o ).

tff(pred_def_21623,type,
    v39377: state_type > $o ).

tff(pred_def_21624,type,
    v39394: state_type > $o ).

tff(pred_def_21625,type,
    v39392: state_type > $o ).

tff(pred_def_21626,type,
    v39398: state_type > $o ).

tff(pred_def_21627,type,
    v39396: state_type > $o ).

tff(pred_def_21628,type,
    v39401: state_type > $o ).

tff(pred_def_21629,type,
    v39400: state_type > $o ).

tff(pred_def_21630,type,
    v39375: state_type > $o ).

tff(pred_def_21631,type,
    v39373: state_type > $o ).

tff(pred_def_21632,type,
    v39371: state_type > $o ).

tff(pred_def_21633,type,
    v39369: state_type > $o ).

tff(pred_def_21634,type,
    v39367: state_type > $o ).

tff(pred_def_21635,type,
    v39405: state_type > $o ).

tff(pred_def_21636,type,
    v39403: state_type > $o ).

tff(pred_def_21637,type,
    v39361: state_type > $o ).

tff(pred_def_21638,type,
    v39411: state_type > $o ).

tff(pred_def_21639,type,
    v39413: state_type > $o ).

tff(pred_def_21640,type,
    v39409: state_type > $o ).

tff(pred_def_21641,type,
    v39408: state_type > $o ).

tff(pred_def_21642,type,
    v39419: state_type > $o ).

tff(pred_def_21643,type,
    v39420: state_type > $o ).

tff(pred_def_21644,type,
    v39416: state_type > $o ).

tff(pred_def_21645,type,
    v39418: state_type > $o ).

tff(pred_def_21646,type,
    v39426: state_type > $o ).

tff(pred_def_21647,type,
    v39424: state_type > $o ).

tff(pred_def_21648,type,
    v39428: state_type > $o ).

tff(pred_def_21649,type,
    v39355: state_type > $o ).

tff(pred_def_21650,type,
    v39353: state_type > $o ).

tff(pred_def_21651,type,
    v39351: state_type > $o ).

tff(pred_def_21652,type,
    v39435: state_type > $o ).

tff(pred_def_21653,type,
    v39433: state_type > $o ).

tff(pred_def_21654,type,
    v39432: state_type > $o ).

tff(pred_def_21655,type,
    v39431: state_type > $o ).

tff(pred_def_21656,type,
    v39443: state_type > $o ).

tff(pred_def_21657,type,
    v39444: state_type > $o ).

tff(pred_def_21658,type,
    v39442: state_type > $o ).

tff(pred_def_21659,type,
    v39439: ( state_type * $int ) > $o ).

tff(pred_def_21660,type,
    v39441: ( state_type * $int ) > $o ).

tff(pred_def_21661,type,
    v39325: ( state_type * $int ) > $o ).

tff(pred_def_21662,type,
    v39323: ( state_type * $int ) > $o ).

tff(pred_def_21663,type,
    v39321: ( state_type * $int ) > $o ).

tff(pred_def_21664,type,
    v39319: ( state_type * $int ) > $o ).

tff(pred_def_21665,type,
    v39317: ( state_type * $int ) > $o ).

tff(pred_def_21666,type,
    v39466: state_type > $o ).

tff(pred_def_21667,type,
    v39464: state_type > $o ).

tff(pred_def_21668,type,
    v39470: state_type > $o ).

tff(pred_def_21669,type,
    v39468: state_type > $o ).

tff(pred_def_21670,type,
    v39474: state_type > $o ).

tff(pred_def_21671,type,
    v39472: state_type > $o ).

tff(pred_def_21672,type,
    v39477: state_type > $o ).

tff(pred_def_21673,type,
    v39476: state_type > $o ).

tff(pred_def_21674,type,
    v39462: state_type > $o ).

tff(pred_def_21675,type,
    v39460: state_type > $o ).

tff(pred_def_21676,type,
    v39458: state_type > $o ).

tff(pred_def_21677,type,
    v39456: state_type > $o ).

tff(pred_def_21678,type,
    v39454: state_type > $o ).

tff(pred_def_21679,type,
    v39452: state_type > $o ).

tff(pred_def_21680,type,
    v39450: state_type > $o ).

tff(pred_def_21681,type,
    v39448: state_type > $o ).

tff(pred_def_21682,type,
    v39497: state_type > $o ).

tff(pred_def_21683,type,
    v39495: state_type > $o ).

tff(pred_def_21684,type,
    v39493: state_type > $o ).

tff(pred_def_21685,type,
    v39491: state_type > $o ).

tff(pred_def_21686,type,
    v39489: state_type > $o ).

tff(pred_def_21687,type,
    v39507: state_type > $o ).

tff(pred_def_21688,type,
    v39505: state_type > $o ).

tff(pred_def_21689,type,
    v39503: state_type > $o ).

tff(pred_def_21690,type,
    v39501: state_type > $o ).

tff(pred_def_21691,type,
    v39499: state_type > $o ).

tff(pred_def_21692,type,
    v39511: ( state_type * $int ) > $o ).

tff(pred_def_21693,type,
    v39509: ( state_type * $int ) > $o ).

tff(pred_def_21694,type,
    v39521: state_type > $o ).

tff(pred_def_21695,type,
    v39519: state_type > $o ).

tff(pred_def_21696,type,
    v39527: state_type > $o ).

tff(pred_def_21697,type,
    v39525: state_type > $o ).

tff(pred_def_21698,type,
    v39541: state_type > $o ).

tff(pred_def_21699,type,
    v39539: state_type > $o ).

tff(pred_def_21700,type,
    v39545: state_type > $o ).

tff(pred_def_21701,type,
    v39543: state_type > $o ).

tff(pred_def_21702,type,
    v39549: state_type > $o ).

tff(pred_def_21703,type,
    v39547: state_type > $o ).

tff(pred_def_21704,type,
    v39552: state_type > $o ).

tff(pred_def_21705,type,
    v39551: state_type > $o ).

tff(pred_def_21706,type,
    v39537: state_type > $o ).

tff(pred_def_21707,type,
    v39535: state_type > $o ).

tff(pred_def_21708,type,
    v39533: state_type > $o ).

tff(pred_def_21709,type,
    v39531: state_type > $o ).

tff(pred_def_21710,type,
    v39529: state_type > $o ).

tff(pred_def_21711,type,
    v39556: state_type > $o ).

tff(pred_def_21712,type,
    v39554: state_type > $o ).

tff(pred_def_21713,type,
    v39523: state_type > $o ).

tff(pred_def_21714,type,
    v39562: state_type > $o ).

tff(pred_def_21715,type,
    v39564: state_type > $o ).

tff(pred_def_21716,type,
    v39560: state_type > $o ).

tff(pred_def_21717,type,
    v39559: state_type > $o ).

tff(pred_def_21718,type,
    v39570: state_type > $o ).

tff(pred_def_21719,type,
    v39571: state_type > $o ).

tff(pred_def_21720,type,
    v39567: state_type > $o ).

tff(pred_def_21721,type,
    v39569: state_type > $o ).

tff(pred_def_21722,type,
    v39577: state_type > $o ).

tff(pred_def_21723,type,
    v39575: state_type > $o ).

tff(pred_def_21724,type,
    v39579: state_type > $o ).

tff(pred_def_21725,type,
    v39517: state_type > $o ).

tff(pred_def_21726,type,
    v39515: state_type > $o ).

tff(pred_def_21727,type,
    v39513: state_type > $o ).

tff(pred_def_21728,type,
    v39586: state_type > $o ).

tff(pred_def_21729,type,
    v39584: state_type > $o ).

tff(pred_def_21730,type,
    v39583: state_type > $o ).

tff(pred_def_21731,type,
    v39582: state_type > $o ).

tff(pred_def_21732,type,
    v39594: state_type > $o ).

tff(pred_def_21733,type,
    v39595: state_type > $o ).

tff(pred_def_21734,type,
    v39593: state_type > $o ).

tff(pred_def_21735,type,
    v39590: ( state_type * $int ) > $o ).

tff(pred_def_21736,type,
    v39592: ( state_type * $int ) > $o ).

tff(pred_def_21737,type,
    v39487: ( state_type * $int ) > $o ).

tff(pred_def_21738,type,
    v39485: ( state_type * $int ) > $o ).

tff(pred_def_21739,type,
    v39483: ( state_type * $int ) > $o ).

tff(pred_def_21740,type,
    v39481: ( state_type * $int ) > $o ).

tff(pred_def_21741,type,
    v39479: ( state_type * $int ) > $o ).

tff(pred_def_21742,type,
    v39617: state_type > $o ).

tff(pred_def_21743,type,
    v39615: state_type > $o ).

tff(pred_def_21744,type,
    v39621: state_type > $o ).

tff(pred_def_21745,type,
    v39619: state_type > $o ).

tff(pred_def_21746,type,
    v39625: state_type > $o ).

tff(pred_def_21747,type,
    v39623: state_type > $o ).

tff(pred_def_21748,type,
    v39628: state_type > $o ).

tff(pred_def_21749,type,
    v39627: state_type > $o ).

tff(pred_def_21750,type,
    v39613: state_type > $o ).

tff(pred_def_21751,type,
    v39611: state_type > $o ).

tff(pred_def_21752,type,
    v39609: state_type > $o ).

tff(pred_def_21753,type,
    v39607: state_type > $o ).

tff(pred_def_21754,type,
    v39605: state_type > $o ).

tff(pred_def_21755,type,
    v39603: state_type > $o ).

tff(pred_def_21756,type,
    v39601: state_type > $o ).

tff(pred_def_21757,type,
    v39599: state_type > $o ).

tff(pred_def_21758,type,
    v39648: state_type > $o ).

tff(pred_def_21759,type,
    v39646: state_type > $o ).

tff(pred_def_21760,type,
    v39644: state_type > $o ).

tff(pred_def_21761,type,
    v39642: state_type > $o ).

tff(pred_def_21762,type,
    v39640: state_type > $o ).

tff(pred_def_21763,type,
    v39658: state_type > $o ).

tff(pred_def_21764,type,
    v39656: state_type > $o ).

tff(pred_def_21765,type,
    v39654: state_type > $o ).

tff(pred_def_21766,type,
    v39652: state_type > $o ).

tff(pred_def_21767,type,
    v39650: state_type > $o ).

tff(pred_def_21768,type,
    v39662: ( state_type * $int ) > $o ).

tff(pred_def_21769,type,
    v39660: ( state_type * $int ) > $o ).

tff(pred_def_21770,type,
    v39672: state_type > $o ).

tff(pred_def_21771,type,
    v39670: state_type > $o ).

tff(pred_def_21772,type,
    v39678: state_type > $o ).

tff(pred_def_21773,type,
    v39676: state_type > $o ).

tff(pred_def_21774,type,
    v39692: state_type > $o ).

tff(pred_def_21775,type,
    v39690: state_type > $o ).

tff(pred_def_21776,type,
    v39696: state_type > $o ).

tff(pred_def_21777,type,
    v39694: state_type > $o ).

tff(pred_def_21778,type,
    v39700: state_type > $o ).

tff(pred_def_21779,type,
    v39698: state_type > $o ).

tff(pred_def_21780,type,
    v39703: state_type > $o ).

tff(pred_def_21781,type,
    v39702: state_type > $o ).

tff(pred_def_21782,type,
    v39688: state_type > $o ).

tff(pred_def_21783,type,
    v39686: state_type > $o ).

tff(pred_def_21784,type,
    v39684: state_type > $o ).

tff(pred_def_21785,type,
    v39682: state_type > $o ).

tff(pred_def_21786,type,
    v39680: state_type > $o ).

tff(pred_def_21787,type,
    v39707: state_type > $o ).

tff(pred_def_21788,type,
    v39705: state_type > $o ).

tff(pred_def_21789,type,
    v39674: state_type > $o ).

tff(pred_def_21790,type,
    v39713: state_type > $o ).

tff(pred_def_21791,type,
    v39715: state_type > $o ).

tff(pred_def_21792,type,
    v39711: state_type > $o ).

tff(pred_def_21793,type,
    v39710: state_type > $o ).

tff(pred_def_21794,type,
    v39721: state_type > $o ).

tff(pred_def_21795,type,
    v39722: state_type > $o ).

tff(pred_def_21796,type,
    v39718: state_type > $o ).

tff(pred_def_21797,type,
    v39720: state_type > $o ).

tff(pred_def_21798,type,
    v39728: state_type > $o ).

tff(pred_def_21799,type,
    v39726: state_type > $o ).

tff(pred_def_21800,type,
    v39730: state_type > $o ).

tff(pred_def_21801,type,
    v39668: state_type > $o ).

tff(pred_def_21802,type,
    v39666: state_type > $o ).

tff(pred_def_21803,type,
    v39664: state_type > $o ).

tff(pred_def_21804,type,
    v39737: state_type > $o ).

tff(pred_def_21805,type,
    v39735: state_type > $o ).

tff(pred_def_21806,type,
    v39734: state_type > $o ).

tff(pred_def_21807,type,
    v39733: state_type > $o ).

tff(pred_def_21808,type,
    v39745: state_type > $o ).

tff(pred_def_21809,type,
    v39746: state_type > $o ).

tff(pred_def_21810,type,
    v39744: state_type > $o ).

tff(pred_def_21811,type,
    v39741: ( state_type * $int ) > $o ).

tff(pred_def_21812,type,
    v39743: ( state_type * $int ) > $o ).

tff(pred_def_21813,type,
    v39638: ( state_type * $int ) > $o ).

tff(pred_def_21814,type,
    v39636: ( state_type * $int ) > $o ).

tff(pred_def_21815,type,
    v39634: ( state_type * $int ) > $o ).

tff(pred_def_21816,type,
    v39632: ( state_type * $int ) > $o ).

tff(pred_def_21817,type,
    v39630: ( state_type * $int ) > $o ).

tff(pred_def_21818,type,
    v39768: state_type > $o ).

tff(pred_def_21819,type,
    v39766: state_type > $o ).

tff(pred_def_21820,type,
    v39772: state_type > $o ).

tff(pred_def_21821,type,
    v39770: state_type > $o ).

tff(pred_def_21822,type,
    v39776: state_type > $o ).

tff(pred_def_21823,type,
    v39774: state_type > $o ).

tff(pred_def_21824,type,
    v39779: state_type > $o ).

tff(pred_def_21825,type,
    v39778: state_type > $o ).

tff(pred_def_21826,type,
    v39764: state_type > $o ).

tff(pred_def_21827,type,
    v39762: state_type > $o ).

tff(pred_def_21828,type,
    v39760: state_type > $o ).

tff(pred_def_21829,type,
    v39758: state_type > $o ).

tff(pred_def_21830,type,
    v39756: state_type > $o ).

tff(pred_def_21831,type,
    v39754: state_type > $o ).

tff(pred_def_21832,type,
    v39752: state_type > $o ).

tff(pred_def_21833,type,
    v39750: state_type > $o ).

tff(pred_def_21834,type,
    v39799: state_type > $o ).

tff(pred_def_21835,type,
    v39797: state_type > $o ).

tff(pred_def_21836,type,
    v39795: state_type > $o ).

tff(pred_def_21837,type,
    v39793: state_type > $o ).

tff(pred_def_21838,type,
    v39791: state_type > $o ).

tff(pred_def_21839,type,
    v39809: state_type > $o ).

tff(pred_def_21840,type,
    v39807: state_type > $o ).

tff(pred_def_21841,type,
    v39805: state_type > $o ).

tff(pred_def_21842,type,
    v39803: state_type > $o ).

tff(pred_def_21843,type,
    v39801: state_type > $o ).

tff(pred_def_21844,type,
    v39813: ( state_type * $int ) > $o ).

tff(pred_def_21845,type,
    v39811: ( state_type * $int ) > $o ).

tff(pred_def_21846,type,
    v39823: state_type > $o ).

tff(pred_def_21847,type,
    v39821: state_type > $o ).

tff(pred_def_21848,type,
    v39829: state_type > $o ).

tff(pred_def_21849,type,
    v39827: state_type > $o ).

tff(pred_def_21850,type,
    v39843: state_type > $o ).

tff(pred_def_21851,type,
    v39841: state_type > $o ).

tff(pred_def_21852,type,
    v39847: state_type > $o ).

tff(pred_def_21853,type,
    v39845: state_type > $o ).

tff(pred_def_21854,type,
    v39851: state_type > $o ).

tff(pred_def_21855,type,
    v39849: state_type > $o ).

tff(pred_def_21856,type,
    v39854: state_type > $o ).

tff(pred_def_21857,type,
    v39853: state_type > $o ).

tff(pred_def_21858,type,
    v39839: state_type > $o ).

tff(pred_def_21859,type,
    v39837: state_type > $o ).

tff(pred_def_21860,type,
    v39835: state_type > $o ).

tff(pred_def_21861,type,
    v39833: state_type > $o ).

tff(pred_def_21862,type,
    v39831: state_type > $o ).

tff(pred_def_21863,type,
    v39858: state_type > $o ).

tff(pred_def_21864,type,
    v39856: state_type > $o ).

tff(pred_def_21865,type,
    v39825: state_type > $o ).

tff(pred_def_21866,type,
    v39864: state_type > $o ).

tff(pred_def_21867,type,
    v39866: state_type > $o ).

tff(pred_def_21868,type,
    v39862: state_type > $o ).

tff(pred_def_21869,type,
    v39861: state_type > $o ).

tff(pred_def_21870,type,
    v39872: state_type > $o ).

tff(pred_def_21871,type,
    v39873: state_type > $o ).

tff(pred_def_21872,type,
    v39869: state_type > $o ).

tff(pred_def_21873,type,
    v39871: state_type > $o ).

tff(pred_def_21874,type,
    v39879: state_type > $o ).

tff(pred_def_21875,type,
    v39877: state_type > $o ).

tff(pred_def_21876,type,
    v39881: state_type > $o ).

tff(pred_def_21877,type,
    v39819: state_type > $o ).

tff(pred_def_21878,type,
    v39817: state_type > $o ).

tff(pred_def_21879,type,
    v39815: state_type > $o ).

tff(pred_def_21880,type,
    v39888: state_type > $o ).

tff(pred_def_21881,type,
    v39886: state_type > $o ).

tff(pred_def_21882,type,
    v39885: state_type > $o ).

tff(pred_def_21883,type,
    v39884: state_type > $o ).

tff(pred_def_21884,type,
    v39896: state_type > $o ).

tff(pred_def_21885,type,
    v39897: state_type > $o ).

tff(pred_def_21886,type,
    v39895: state_type > $o ).

tff(pred_def_21887,type,
    v39892: ( state_type * $int ) > $o ).

tff(pred_def_21888,type,
    v39894: ( state_type * $int ) > $o ).

tff(pred_def_21889,type,
    v39789: ( state_type * $int ) > $o ).

tff(pred_def_21890,type,
    v39787: ( state_type * $int ) > $o ).

tff(pred_def_21891,type,
    v39785: ( state_type * $int ) > $o ).

tff(pred_def_21892,type,
    v39783: ( state_type * $int ) > $o ).

tff(pred_def_21893,type,
    v39781: ( state_type * $int ) > $o ).

tff(pred_def_21894,type,
    v39919: state_type > $o ).

tff(pred_def_21895,type,
    v39917: state_type > $o ).

tff(pred_def_21896,type,
    v39923: state_type > $o ).

tff(pred_def_21897,type,
    v39921: state_type > $o ).

tff(pred_def_21898,type,
    v39927: state_type > $o ).

tff(pred_def_21899,type,
    v39925: state_type > $o ).

tff(pred_def_21900,type,
    v39930: state_type > $o ).

tff(pred_def_21901,type,
    v39929: state_type > $o ).

tff(pred_def_21902,type,
    v39915: state_type > $o ).

tff(pred_def_21903,type,
    v39913: state_type > $o ).

tff(pred_def_21904,type,
    v39911: state_type > $o ).

tff(pred_def_21905,type,
    v39909: state_type > $o ).

tff(pred_def_21906,type,
    v39907: state_type > $o ).

tff(pred_def_21907,type,
    v39905: state_type > $o ).

tff(pred_def_21908,type,
    v39903: state_type > $o ).

tff(pred_def_21909,type,
    v39901: state_type > $o ).

tff(pred_def_21910,type,
    v39950: state_type > $o ).

tff(pred_def_21911,type,
    v39948: state_type > $o ).

tff(pred_def_21912,type,
    v39946: state_type > $o ).

tff(pred_def_21913,type,
    v39944: state_type > $o ).

tff(pred_def_21914,type,
    v39942: state_type > $o ).

tff(pred_def_21915,type,
    v39960: state_type > $o ).

tff(pred_def_21916,type,
    v39958: state_type > $o ).

tff(pred_def_21917,type,
    v39956: state_type > $o ).

tff(pred_def_21918,type,
    v39954: state_type > $o ).

tff(pred_def_21919,type,
    v39952: state_type > $o ).

tff(pred_def_21920,type,
    v39964: ( state_type * $int ) > $o ).

tff(pred_def_21921,type,
    v39962: ( state_type * $int ) > $o ).

tff(pred_def_21922,type,
    v39974: state_type > $o ).

tff(pred_def_21923,type,
    v39972: state_type > $o ).

tff(pred_def_21924,type,
    v39980: state_type > $o ).

tff(pred_def_21925,type,
    v39978: state_type > $o ).

tff(pred_def_21926,type,
    v39993: state_type > $o ).

tff(pred_def_21927,type,
    v39991: state_type > $o ).

tff(pred_def_21928,type,
    v39997: state_type > $o ).

tff(pred_def_21929,type,
    v39995: state_type > $o ).

tff(pred_def_21930,type,
    v40001: state_type > $o ).

tff(pred_def_21931,type,
    v39999: state_type > $o ).

tff(pred_def_21932,type,
    v40004: state_type > $o ).

tff(pred_def_21933,type,
    v40003: state_type > $o ).

tff(pred_def_21934,type,
    v39989: state_type > $o ).

tff(pred_def_21935,type,
    v39987: state_type > $o ).

tff(pred_def_21936,type,
    v39984: state_type > $o ).

tff(pred_def_21937,type,
    v39982: state_type > $o ).

tff(pred_def_21938,type,
    v40008: state_type > $o ).

tff(pred_def_21939,type,
    v40006: state_type > $o ).

tff(pred_def_21940,type,
    v39976: state_type > $o ).

tff(pred_def_21941,type,
    v40014: state_type > $o ).

tff(pred_def_21942,type,
    v40016: state_type > $o ).

tff(pred_def_21943,type,
    v40012: state_type > $o ).

tff(pred_def_21944,type,
    v40011: state_type > $o ).

tff(pred_def_21945,type,
    v40022: state_type > $o ).

tff(pred_def_21946,type,
    v40023: state_type > $o ).

tff(pred_def_21947,type,
    v40019: state_type > $o ).

tff(pred_def_21948,type,
    v40021: state_type > $o ).

tff(pred_def_21949,type,
    v40029: state_type > $o ).

tff(pred_def_21950,type,
    v40027: state_type > $o ).

tff(pred_def_21951,type,
    v40031: state_type > $o ).

tff(pred_def_21952,type,
    v39970: state_type > $o ).

tff(pred_def_21953,type,
    v39968: state_type > $o ).

tff(pred_def_21954,type,
    v39966: state_type > $o ).

tff(pred_def_21955,type,
    v40038: state_type > $o ).

tff(pred_def_21956,type,
    v40036: state_type > $o ).

tff(pred_def_21957,type,
    v40035: state_type > $o ).

tff(pred_def_21958,type,
    v40034: state_type > $o ).

tff(pred_def_21959,type,
    v40046: state_type > $o ).

tff(pred_def_21960,type,
    v40047: state_type > $o ).

tff(pred_def_21961,type,
    v40045: state_type > $o ).

tff(pred_def_21962,type,
    v40042: ( state_type * $int ) > $o ).

tff(pred_def_21963,type,
    v40044: ( state_type * $int ) > $o ).

tff(pred_def_21964,type,
    v39940: ( state_type * $int ) > $o ).

tff(pred_def_21965,type,
    v39938: ( state_type * $int ) > $o ).

tff(pred_def_21966,type,
    v39936: ( state_type * $int ) > $o ).

tff(pred_def_21967,type,
    v39934: ( state_type * $int ) > $o ).

tff(pred_def_21968,type,
    v39932: ( state_type * $int ) > $o ).

tff(pred_def_21969,type,
    v40059: state_type > $o ).

tff(pred_def_21970,type,
    v40057: state_type > $o ).

tff(pred_def_21971,type,
    v40055: state_type > $o ).

tff(pred_def_21972,type,
    v40053: state_type > $o ).

tff(pred_def_21973,type,
    v40051: state_type > $o ).

tff(pred_def_21974,type,
    v40067: state_type > $o ).

tff(pred_def_21975,type,
    v40066: ( state_type * $int ) > $o ).

tff(pred_def_21976,type,
    v40065: ( state_type * $int ) > $o ).

tff(pred_def_21977,type,
    v40070: state_type > $o ).

tff(pred_def_21978,type,
    v40069: ( state_type * $int ) > $o ).

tff(pred_def_21979,type,
    v40068: ( state_type * $int ) > $o ).

tff(pred_def_21980,type,
    v40064: ( state_type * $int ) > $o ).

tff(pred_def_21981,type,
    v40073: state_type > $o ).

tff(pred_def_21982,type,
    v40072: ( state_type * $int ) > $o ).

tff(pred_def_21983,type,
    v40071: ( state_type * $int ) > $o ).

tff(pred_def_21984,type,
    v40063: ( state_type * $int ) > $o ).

tff(pred_def_21985,type,
    v40076: state_type > $o ).

tff(pred_def_21986,type,
    v40075: ( state_type * $int ) > $o ).

tff(pred_def_21987,type,
    v40074: ( state_type * $int ) > $o ).

tff(pred_def_21988,type,
    v40062: ( state_type * $int ) > $o ).

tff(pred_def_21989,type,
    v40079: state_type > $o ).

tff(pred_def_21990,type,
    v40078: ( state_type * $int ) > $o ).

tff(pred_def_21991,type,
    v40077: ( state_type * $int ) > $o ).

tff(pred_def_21992,type,
    v40061: ( state_type * $int ) > $o ).

tff(pred_def_21993,type,
    v40082: state_type > $o ).

tff(pred_def_21994,type,
    v40081: ( state_type * $int ) > $o ).

tff(pred_def_21995,type,
    v40080: ( state_type * $int ) > $o ).

tff(pred_def_21996,type,
    v38553: ( state_type * $int ) > $o ).

tff(pred_def_21997,type,
    v38551: ( state_type * $int ) > $o ).

tff(pred_def_21998,type,
    v38549: ( state_type * $int ) > $o ).

tff(pred_def_21999,type,
    v38547: ( state_type * $int ) > $o ).

tff(pred_def_22000,type,
    v38545: ( state_type * $int ) > $o ).

tff(pred_def_22001,type,
    v38539: state_type > $o ).

tff(pred_def_22002,type,
    v38537: state_type > $o ).

tff(pred_def_22003,type,
    v38535: state_type > $o ).

tff(pred_def_22004,type,
    v40093: ( state_type * $int ) > $o ).

tff(pred_def_22005,type,
    v40091: ( state_type * $int ) > $o ).

tff(pred_def_22006,type,
    v40127: state_type > $o ).

tff(pred_def_22007,type,
    v40125: state_type > $o ).

tff(pred_def_22008,type,
    v40123: state_type > $o ).

tff(pred_def_22009,type,
    v40121: state_type > $o ).

tff(pred_def_22010,type,
    v40119: state_type > $o ).

tff(pred_def_22011,type,
    v40117: state_type > $o ).

tff(pred_def_22012,type,
    v40115: state_type > $o ).

tff(pred_def_22013,type,
    v40141: state_type > $o ).

tff(pred_def_22014,type,
    v40139: state_type > $o ).

tff(pred_def_22015,type,
    v40137: state_type > $o ).

tff(pred_def_22016,type,
    v40135: state_type > $o ).

tff(pred_def_22017,type,
    v40133: state_type > $o ).

tff(pred_def_22018,type,
    v40131: state_type > $o ).

tff(pred_def_22019,type,
    v40129: state_type > $o ).

tff(pred_def_22020,type,
    v40167: state_type > $o ).

tff(pred_def_22021,type,
    v40169: state_type > $o ).

tff(pred_def_22022,type,
    v40168: ( state_type * $int ) > $o ).

tff(pred_def_22023,type,
    v40170: state_type > $o ).

tff(pred_def_22024,type,
    v40165: ( state_type * $int ) > $o ).

tff(pred_def_22025,type,
    v40163: ( state_type * $int ) > $o ).

tff(pred_def_22026,type,
    v40171: ( state_type * $int ) > $o ).

tff(pred_def_22027,type,
    v40161: ( state_type * $int ) > $o ).

tff(pred_def_22028,type,
    v40159: ( state_type * $int ) > $o ).

tff(pred_def_22029,type,
    v40157: state_type > $o ).

tff(pred_def_22030,type,
    v40173: state_type > $o ).

tff(pred_def_22031,type,
    v40155: ( state_type * $int ) > $o ).

tff(pred_def_22032,type,
    v40153: ( state_type * $int ) > $o ).

tff(pred_def_22033,type,
    v40187: ( state_type * $int ) > $o ).

tff(pred_def_22034,type,
    v40185: ( state_type * $int ) > $o ).

tff(pred_def_22035,type,
    v40191: state_type > $o ).

tff(pred_def_22036,type,
    v40189: state_type > $o ).

tff(pred_def_22037,type,
    v40215: state_type > $o ).

tff(pred_def_22038,type,
    v40213: state_type > $o ).

tff(pred_def_22039,type,
    v40211: state_type > $o ).

tff(pred_def_22040,type,
    v40209: state_type > $o ).

tff(pred_def_22041,type,
    v40207: state_type > $o ).

tff(pred_def_22042,type,
    v40205: state_type > $o ).

tff(pred_def_22043,type,
    v40203: state_type > $o ).

tff(pred_def_22044,type,
    v40229: state_type > $o ).

tff(pred_def_22045,type,
    v40227: state_type > $o ).

tff(pred_def_22046,type,
    v40225: state_type > $o ).

tff(pred_def_22047,type,
    v40223: state_type > $o ).

tff(pred_def_22048,type,
    v40221: state_type > $o ).

tff(pred_def_22049,type,
    v40219: state_type > $o ).

tff(pred_def_22050,type,
    v40217: state_type > $o ).

tff(pred_def_22051,type,
    v40245: ( state_type * $int ) > $o ).

tff(pred_def_22052,type,
    v40243: ( state_type * $int ) > $o ).

tff(pred_def_22053,type,
    v40241: ( state_type * $int ) > $o ).

tff(pred_def_22054,type,
    v40239: ( state_type * $int ) > $o ).

tff(pred_def_22055,type,
    v40237: ( state_type * $int ) > $o ).

tff(pred_def_22056,type,
    v40275: ( state_type * $int ) > $o ).

tff(pred_def_22057,type,
    v40277: ( state_type * $int ) > $o ).

tff(pred_def_22058,type,
    v40273: ( state_type * $int ) > $o ).

tff(pred_def_22059,type,
    v40271: ( state_type * $int ) > $o ).

tff(pred_def_22060,type,
    v40269: ( state_type * $int ) > $o ).

tff(pred_def_22061,type,
    v40267: ( state_type * $int ) > $o ).

tff(pred_def_22062,type,
    v40265: state_type > $o ).

tff(pred_def_22063,type,
    v40263: state_type > $o ).

tff(pred_def_22064,type,
    v40281: state_type > $o ).

tff(pred_def_22065,type,
    v40279: state_type > $o ).

tff(pred_def_22066,type,
    v40283: state_type > $o ).

tff(pred_def_22067,type,
    v40261: state_type > $o ).

tff(pred_def_22068,type,
    v40259: state_type > $o ).

tff(pred_def_22069,type,
    v40257: state_type > $o ).

tff(pred_def_22070,type,
    v40255: state_type > $o ).

tff(pred_def_22071,type,
    v40253: state_type > $o ).

tff(pred_def_22072,type,
    v40251: state_type > $o ).

tff(pred_def_22073,type,
    v40249: state_type > $o ).

tff(pred_def_22074,type,
    v40247: state_type > $o ).

tff(pred_def_22075,type,
    v40293: ( state_type * $int ) > $o ).

tff(pred_def_22076,type,
    v40291: ( state_type * $int ) > $o ).

tff(pred_def_22077,type,
    v40289: ( state_type * $int ) > $o ).

tff(pred_def_22078,type,
    v40287: ( state_type * $int ) > $o ).

tff(pred_def_22079,type,
    v40285: ( state_type * $int ) > $o ).

tff(pred_def_22080,type,
    v40323: ( state_type * $int ) > $o ).

tff(pred_def_22081,type,
    v40321: ( state_type * $int ) > $o ).

tff(pred_def_22082,type,
    v40324: ( state_type * $int ) > $o ).

tff(pred_def_22083,type,
    v40319: ( state_type * $int ) > $o ).

tff(pred_def_22084,type,
    v40317: ( state_type * $int ) > $o ).

tff(pred_def_22085,type,
    v40315: ( state_type * $int ) > $o ).

tff(pred_def_22086,type,
    v40313: state_type > $o ).

tff(pred_def_22087,type,
    v40311: state_type > $o ).

tff(pred_def_22088,type,
    v40328: state_type > $o ).

tff(pred_def_22089,type,
    v40326: state_type > $o ).

tff(pred_def_22090,type,
    v40330: state_type > $o ).

tff(pred_def_22091,type,
    v40309: state_type > $o ).

tff(pred_def_22092,type,
    v40307: state_type > $o ).

tff(pred_def_22093,type,
    v40305: state_type > $o ).

tff(pred_def_22094,type,
    v40303: state_type > $o ).

tff(pred_def_22095,type,
    v40301: state_type > $o ).

tff(pred_def_22096,type,
    v40299: state_type > $o ).

tff(pred_def_22097,type,
    v40297: state_type > $o ).

tff(pred_def_22098,type,
    v40295: state_type > $o ).

tff(pred_def_22099,type,
    v40340: ( state_type * $int ) > $o ).

tff(pred_def_22100,type,
    v40338: ( state_type * $int ) > $o ).

tff(pred_def_22101,type,
    v40336: ( state_type * $int ) > $o ).

tff(pred_def_22102,type,
    v40334: ( state_type * $int ) > $o ).

tff(pred_def_22103,type,
    v40332: ( state_type * $int ) > $o ).

tff(pred_def_22104,type,
    v40360: state_type > $o ).

tff(pred_def_22105,type,
    v40358: state_type > $o ).

tff(pred_def_22106,type,
    v40364: state_type > $o ).

tff(pred_def_22107,type,
    v40362: state_type > $o ).

tff(pred_def_22108,type,
    v40366: state_type > $o ).

tff(pred_def_22109,type,
    v40356: state_type > $o ).

tff(pred_def_22110,type,
    v40354: state_type > $o ).

tff(pred_def_22111,type,
    v40352: state_type > $o ).

tff(pred_def_22112,type,
    v40350: state_type > $o ).

tff(pred_def_22113,type,
    v40348: state_type > $o ).

tff(pred_def_22114,type,
    v40346: state_type > $o ).

tff(pred_def_22115,type,
    v40344: state_type > $o ).

tff(pred_def_22116,type,
    v40342: state_type > $o ).

tff(pred_def_22117,type,
    v40376: ( state_type * $int ) > $o ).

tff(pred_def_22118,type,
    v40374: ( state_type * $int ) > $o ).

tff(pred_def_22119,type,
    v40372: ( state_type * $int ) > $o ).

tff(pred_def_22120,type,
    v40370: ( state_type * $int ) > $o ).

tff(pred_def_22121,type,
    v40368: ( state_type * $int ) > $o ).

tff(pred_def_22122,type,
    v40396: state_type > $o ).

tff(pred_def_22123,type,
    v40394: state_type > $o ).

tff(pred_def_22124,type,
    v40400: state_type > $o ).

tff(pred_def_22125,type,
    v40398: state_type > $o ).

tff(pred_def_22126,type,
    v40402: state_type > $o ).

tff(pred_def_22127,type,
    v40392: state_type > $o ).

tff(pred_def_22128,type,
    v40390: state_type > $o ).

tff(pred_def_22129,type,
    v40388: state_type > $o ).

tff(pred_def_22130,type,
    v40386: state_type > $o ).

tff(pred_def_22131,type,
    v40384: state_type > $o ).

tff(pred_def_22132,type,
    v40382: state_type > $o ).

tff(pred_def_22133,type,
    v40380: state_type > $o ).

tff(pred_def_22134,type,
    v40378: state_type > $o ).

tff(pred_def_22135,type,
    v40408: state_type > $o ).

tff(pred_def_22136,type,
    v40407: ( state_type * $int ) > $o ).

tff(pred_def_22137,type,
    v40406: ( state_type * $int ) > $o ).

tff(pred_def_22138,type,
    v40411: state_type > $o ).

tff(pred_def_22139,type,
    v40410: ( state_type * $int ) > $o ).

tff(pred_def_22140,type,
    v40409: ( state_type * $int ) > $o ).

tff(pred_def_22141,type,
    v40405: ( state_type * $int ) > $o ).

tff(pred_def_22142,type,
    v40414: state_type > $o ).

tff(pred_def_22143,type,
    v40413: ( state_type * $int ) > $o ).

tff(pred_def_22144,type,
    v40412: ( state_type * $int ) > $o ).

tff(pred_def_22145,type,
    v40404: ( state_type * $int ) > $o ).

tff(pred_def_22146,type,
    v40417: state_type > $o ).

tff(pred_def_22147,type,
    v40416: ( state_type * $int ) > $o ).

tff(pred_def_22148,type,
    v40415: ( state_type * $int ) > $o ).

tff(pred_def_22149,type,
    v40235: ( state_type * $int ) > $o ).

tff(pred_def_22150,type,
    v40233: ( state_type * $int ) > $o ).

tff(pred_def_22151,type,
    v40231: ( state_type * $int ) > $o ).

tff(pred_def_22152,type,
    v40429: state_type > $o ).

tff(pred_def_22153,type,
    v40427: state_type > $o ).

tff(pred_def_22154,type,
    v40425: state_type > $o ).

tff(pred_def_22155,type,
    v40439: state_type > $o ).

tff(pred_def_22156,type,
    v40437: state_type > $o ).

tff(pred_def_22157,type,
    v40435: state_type > $o ).

tff(pred_def_22158,type,
    v40433: state_type > $o ).

tff(pred_def_22159,type,
    v40431: state_type > $o ).

tff(pred_def_22160,type,
    v40441: state_type > $o ).

tff(pred_def_22161,type,
    v40423: state_type > $o ).

tff(pred_def_22162,type,
    v40421: state_type > $o ).

tff(pred_def_22163,type,
    v40419: state_type > $o ).

tff(pred_def_22164,type,
    v40448: state_type > $o ).

tff(pred_def_22165,type,
    v40446: state_type > $o ).

tff(pred_def_22166,type,
    v40445: state_type > $o ).

tff(pred_def_22167,type,
    v40444: state_type > $o ).

tff(pred_def_22168,type,
    v40456: state_type > $o ).

tff(pred_def_22169,type,
    v40457: state_type > $o ).

tff(pred_def_22170,type,
    v40455: state_type > $o ).

tff(pred_def_22171,type,
    v40452: ( state_type * $int ) > $o ).

tff(pred_def_22172,type,
    v40454: ( state_type * $int ) > $o ).

tff(pred_def_22173,type,
    v40201: ( state_type * $int ) > $o ).

tff(pred_def_22174,type,
    v40199: ( state_type * $int ) > $o ).

tff(pred_def_22175,type,
    v40197: ( state_type * $int ) > $o ).

tff(pred_def_22176,type,
    v40195: ( state_type * $int ) > $o ).

tff(pred_def_22177,type,
    v40193: ( state_type * $int ) > $o ).

tff(pred_def_22178,type,
    v40463: state_type > $o ).

tff(pred_def_22179,type,
    v40461: state_type > $o ).

tff(pred_def_22180,type,
    v40467: state_type > $o ).

tff(pred_def_22181,type,
    v40466: ( state_type * $int ) > $o ).

tff(pred_def_22182,type,
    v40465: ( state_type * $int ) > $o ).

tff(pred_def_22183,type,
    v40470: state_type > $o ).

tff(pred_def_22184,type,
    v40469: ( state_type * $int ) > $o ).

tff(pred_def_22185,type,
    v40468: ( state_type * $int ) > $o ).

tff(pred_def_22186,type,
    v40183: ( state_type * $int ) > $o ).

tff(pred_def_22187,type,
    v40181: ( state_type * $int ) > $o ).

tff(pred_def_22188,type,
    v40179: ( state_type * $int ) > $o ).

tff(pred_def_22189,type,
    v40177: ( state_type * $int ) > $o ).

tff(pred_def_22190,type,
    v40175: ( state_type * $int ) > $o ).

tff(pred_def_22191,type,
    v40151: ( state_type * $int ) > $o ).

tff(pred_def_22192,type,
    v40149: ( state_type * $int ) > $o ).

tff(pred_def_22193,type,
    v40147: ( state_type * $int ) > $o ).

tff(pred_def_22194,type,
    v40145: ( state_type * $int ) > $o ).

tff(pred_def_22195,type,
    v40143: ( state_type * $int ) > $o ).

tff(pred_def_22196,type,
    v40483: state_type > $o ).

tff(pred_def_22197,type,
    v40481: state_type > $o ).

tff(pred_def_22198,type,
    v40479: state_type > $o ).

tff(pred_def_22199,type,
    v40489: state_type > $o ).

tff(pred_def_22200,type,
    v40487: state_type > $o ).

tff(pred_def_22201,type,
    v40507: ( state_type * $int ) > $o ).

tff(pred_def_22202,type,
    v40509: ( state_type * $int ) > $o ).

tff(pred_def_22203,type,
    v40505: ( state_type * $int ) > $o ).

tff(pred_def_22204,type,
    v40503: state_type > $o ).

tff(pred_def_22205,type,
    v40501: state_type > $o ).

tff(pred_def_22206,type,
    v40513: state_type > $o ).

tff(pred_def_22207,type,
    v40511: state_type > $o ).

tff(pred_def_22208,type,
    v40517: state_type > $o ).

tff(pred_def_22209,type,
    v40515: state_type > $o ).

tff(pred_def_22210,type,
    v40520: state_type > $o ).

tff(pred_def_22211,type,
    v40519: state_type > $o ).

tff(pred_def_22212,type,
    v40499: state_type > $o ).

tff(pred_def_22213,type,
    v40497: state_type > $o ).

tff(pred_def_22214,type,
    v40495: state_type > $o ).

tff(pred_def_22215,type,
    v40493: state_type > $o ).

tff(pred_def_22216,type,
    v40491: state_type > $o ).

tff(pred_def_22217,type,
    v40528: state_type > $o ).

tff(pred_def_22218,type,
    v40526: state_type > $o ).

tff(pred_def_22219,type,
    v40524: state_type > $o ).

tff(pred_def_22220,type,
    v40522: state_type > $o ).

tff(pred_def_22221,type,
    v40485: state_type > $o ).

tff(pred_def_22222,type,
    v40534: state_type > $o ).

tff(pred_def_22223,type,
    v40536: state_type > $o ).

tff(pred_def_22224,type,
    v40532: state_type > $o ).

tff(pred_def_22225,type,
    v40531: state_type > $o ).

tff(pred_def_22226,type,
    v40542: state_type > $o ).

tff(pred_def_22227,type,
    v40543: state_type > $o ).

tff(pred_def_22228,type,
    v40539: state_type > $o ).

tff(pred_def_22229,type,
    v40541: state_type > $o ).

tff(pred_def_22230,type,
    v40553: state_type > $o ).

tff(pred_def_22231,type,
    v40551: state_type > $o ).

tff(pred_def_22232,type,
    v40549: state_type > $o ).

tff(pred_def_22233,type,
    v40547: state_type > $o ).

tff(pred_def_22234,type,
    v40555: state_type > $o ).

tff(pred_def_22235,type,
    v40477: state_type > $o ).

tff(pred_def_22236,type,
    v40475: state_type > $o ).

tff(pred_def_22237,type,
    v40473: state_type > $o ).

tff(pred_def_22238,type,
    v40562: state_type > $o ).

tff(pred_def_22239,type,
    v40560: state_type > $o ).

tff(pred_def_22240,type,
    v40559: state_type > $o ).

tff(pred_def_22241,type,
    v40558: state_type > $o ).

tff(pred_def_22242,type,
    v40570: state_type > $o ).

tff(pred_def_22243,type,
    v40571: state_type > $o ).

tff(pred_def_22244,type,
    v40569: state_type > $o ).

tff(pred_def_22245,type,
    v40566: ( state_type * $int ) > $o ).

tff(pred_def_22246,type,
    v40568: ( state_type * $int ) > $o ).

tff(pred_def_22247,type,
    v40113: ( state_type * $int ) > $o ).

tff(pred_def_22248,type,
    v40111: ( state_type * $int ) > $o ).

tff(pred_def_22249,type,
    v40109: ( state_type * $int ) > $o ).

tff(pred_def_22250,type,
    v40107: ( state_type * $int ) > $o ).

tff(pred_def_22251,type,
    v40105: ( state_type * $int ) > $o ).

tff(pred_def_22252,type,
    v40607: state_type > $o ).

tff(pred_def_22253,type,
    v40605: state_type > $o ).

tff(pred_def_22254,type,
    v40603: state_type > $o ).

tff(pred_def_22255,type,
    v40601: state_type > $o ).

tff(pred_def_22256,type,
    v40599: state_type > $o ).

tff(pred_def_22257,type,
    v40597: state_type > $o ).

tff(pred_def_22258,type,
    v40617: state_type > $o ).

tff(pred_def_22259,type,
    v40615: state_type > $o ).

tff(pred_def_22260,type,
    v40613: state_type > $o ).

tff(pred_def_22261,type,
    v40611: state_type > $o ).

tff(pred_def_22262,type,
    v40609: state_type > $o ).

tff(pred_def_22263,type,
    v40644: state_type > $o ).

tff(pred_def_22264,type,
    v40643: ( state_type * $int ) > $o ).

tff(pred_def_22265,type,
    v40642: ( state_type * $int ) > $o ).

tff(pred_def_22266,type,
    v40640: ( state_type * $int ) > $o ).

tff(pred_def_22267,type,
    v40660: state_type > $o ).

tff(pred_def_22268,type,
    v40661: ( state_type * $int ) > $o ).

tff(pred_def_22269,type,
    v40662: state_type > $o ).

tff(pred_def_22270,type,
    v40658: ( state_type * $int ) > $o ).

tff(pred_def_22271,type,
    v40656: ( state_type * $int ) > $o ).

tff(pred_def_22272,type,
    v40686: ( state_type * $int ) > $o ).

tff(pred_def_22273,type,
    v40595: ( state_type * $int ) > $o ).

tff(pred_def_22274,type,
    v40684: ( state_type * $int ) > $o ).

tff(pred_def_22275,type,
    v40687: ( state_type * $int ) > $o ).

tff(pred_def_22276,type,
    v40682: ( state_type * $int ) > $o ).

tff(pred_def_22277,type,
    v40680: ( state_type * $int ) > $o ).

tff(pred_def_22278,type,
    v40678: ( state_type * $int ) > $o ).

tff(pred_def_22279,type,
    v40676: state_type > $o ).

tff(pred_def_22280,type,
    v40674: state_type > $o ).

tff(pred_def_22281,type,
    v40693: state_type > $o ).

tff(pred_def_22282,type,
    v40633: state_type > $o ).

tff(pred_def_22283,type,
    v40692: ( state_type * $int ) > $o ).

tff(pred_def_22284,type,
    v40631: ( state_type * $int ) > $o ).

tff(pred_def_22285,type,
    v40629: ( state_type * $int ) > $o ).

tff(pred_def_22286,type,
    v40708: ( state_type * $int ) > $o ).

tff(pred_def_22287,type,
    v40707: ( state_type * $int ) > $o ).

tff(pred_def_22288,type,
    v40705: ( state_type * $int ) > $o ).

tff(pred_def_22289,type,
    v40712: state_type > $o ).

tff(pred_def_22290,type,
    v40710: state_type > $o ).

tff(pred_def_22291,type,
    v40723: ( state_type * $int ) > $o ).

tff(pred_def_22292,type,
    v40722: state_type > $o ).

tff(pred_def_22293,type,
    v40726: state_type > $o ).

tff(pred_def_22294,type,
    v40727: state_type > $o ).

tff(pred_def_22295,type,
    v40725: state_type > $o ).

tff(pred_def_22296,type,
    v40728: state_type > $o ).

tff(pred_def_22297,type,
    v40724: state_type > $o ).

tff(pred_def_22298,type,
    v40721: state_type > $o ).

tff(pred_def_22299,type,
    v40729: state_type > $o ).

tff(pred_def_22300,type,
    v40720: state_type > $o ).

tff(pred_def_22301,type,
    v40732: state_type > $o ).

tff(pred_def_22302,type,
    v40733: state_type > $o ).

tff(pred_def_22303,type,
    v40731: state_type > $o ).

tff(pred_def_22304,type,
    v40734: state_type > $o ).

tff(pred_def_22305,type,
    v40730: state_type > $o ).

tff(pred_def_22306,type,
    v40719: state_type > $o ).

tff(pred_def_22307,type,
    v40735: state_type > $o ).

tff(pred_def_22308,type,
    v40718: state_type > $o ).

tff(pred_def_22309,type,
    v40717: state_type > $o ).

tff(pred_def_22310,type,
    v40739: state_type > $o ).

tff(pred_def_22311,type,
    v40740: state_type > $o ).

tff(pred_def_22312,type,
    v40738: state_type > $o ).

tff(pred_def_22313,type,
    v40741: state_type > $o ).

tff(pred_def_22314,type,
    v40737: state_type > $o ).

tff(pred_def_22315,type,
    v40736: state_type > $o ).

tff(pred_def_22316,type,
    v40716: state_type > $o ).

tff(pred_def_22317,type,
    v40742: state_type > $o ).

tff(pred_def_22318,type,
    v40715: state_type > $o ).

tff(pred_def_22319,type,
    v40745: state_type > $o ).

tff(pred_def_22320,type,
    v40746: state_type > $o ).

tff(pred_def_22321,type,
    v40744: state_type > $o ).

tff(pred_def_22322,type,
    v40747: state_type > $o ).

tff(pred_def_22323,type,
    v40743: state_type > $o ).

tff(pred_def_22324,type,
    v40750: state_type > $o ).

tff(pred_def_22325,type,
    v40751: state_type > $o ).

tff(pred_def_22326,type,
    v40749: state_type > $o ).

tff(pred_def_22327,type,
    v40752: state_type > $o ).

tff(pred_def_22328,type,
    v40748: state_type > $o ).

tff(pred_def_22329,type,
    v40755: state_type > $o ).

tff(pred_def_22330,type,
    v40756: state_type > $o ).

tff(pred_def_22331,type,
    v40754: state_type > $o ).

tff(pred_def_22332,type,
    v40757: state_type > $o ).

tff(pred_def_22333,type,
    v40753: state_type > $o ).

tff(pred_def_22334,type,
    v40713: ( state_type * $int ) > $o ).

tff(pred_def_22335,type,
    v40703: ( state_type * $int ) > $o ).

tff(pred_def_22336,type,
    v40701: ( state_type * $int ) > $o ).

tff(pred_def_22337,type,
    v40699: ( state_type * $int ) > $o ).

tff(pred_def_22338,type,
    v40697: ( state_type * $int ) > $o ).

tff(pred_def_22339,type,
    v40695: ( state_type * $int ) > $o ).

tff(pred_def_22340,type,
    v40758: ( state_type * $int ) > $o ).

tff(pred_def_22341,type,
    v40627: ( state_type * $int ) > $o ).

tff(pred_def_22342,type,
    v40625: ( state_type * $int ) > $o ).

tff(pred_def_22343,type,
    v40623: ( state_type * $int ) > $o ).

tff(pred_def_22344,type,
    v40759: ( state_type * $int ) > $o ).

tff(pred_def_22345,type,
    v40760: ( state_type * $int ) > $o ).

tff(pred_def_22346,type,
    v40621: ( state_type * $int ) > $o ).

tff(pred_def_22347,type,
    v40619: ( state_type * $int ) > $o ).

tff(pred_def_22348,type,
    v40770: state_type > $o ).

tff(pred_def_22349,type,
    v40768: state_type > $o ).

tff(pred_def_22350,type,
    v40776: state_type > $o ).

tff(pred_def_22351,type,
    v40774: state_type > $o ).

tff(pred_def_22352,type,
    v40780: state_type > $o ).

tff(pred_def_22353,type,
    v40778: state_type > $o ).

tff(pred_def_22354,type,
    v40784: state_type > $o ).

tff(pred_def_22355,type,
    v40782: state_type > $o ).

tff(pred_def_22356,type,
    v40772: state_type > $o ).

tff(pred_def_22357,type,
    v40790: state_type > $o ).

tff(pred_def_22358,type,
    v40792: state_type > $o ).

tff(pred_def_22359,type,
    v40788: state_type > $o ).

tff(pred_def_22360,type,
    v40787: state_type > $o ).

tff(pred_def_22361,type,
    v40798: state_type > $o ).

tff(pred_def_22362,type,
    v40799: state_type > $o ).

tff(pred_def_22363,type,
    v40795: state_type > $o ).

tff(pred_def_22364,type,
    v40797: state_type > $o ).

tff(pred_def_22365,type,
    v40805: state_type > $o ).

tff(pred_def_22366,type,
    v40803: state_type > $o ).

tff(pred_def_22367,type,
    v40807: state_type > $o ).

tff(pred_def_22368,type,
    v40766: state_type > $o ).

tff(pred_def_22369,type,
    v40764: state_type > $o ).

tff(pred_def_22370,type,
    v40762: state_type > $o ).

tff(pred_def_22371,type,
    v40814: state_type > $o ).

tff(pred_def_22372,type,
    v40812: state_type > $o ).

tff(pred_def_22373,type,
    v40811: state_type > $o ).

tff(pred_def_22374,type,
    v40810: state_type > $o ).

tff(pred_def_22375,type,
    v40822: state_type > $o ).

tff(pred_def_22376,type,
    v40823: state_type > $o ).

tff(pred_def_22377,type,
    v40821: state_type > $o ).

tff(pred_def_22378,type,
    v40818: ( state_type * $int ) > $o ).

tff(pred_def_22379,type,
    v40820: ( state_type * $int ) > $o ).

tff(pred_def_22380,type,
    v40809: ( state_type * $int ) > $o ).

tff(pred_def_22381,type,
    v40691: state_type > $o ).

tff(pred_def_22382,type,
    v40689: state_type > $o ).

tff(pred_def_22383,type,
    v40835: state_type > $o ).

tff(pred_def_22384,type,
    v40833: state_type > $o ).

tff(pred_def_22385,type,
    v40832: state_type > $o ).

tff(pred_def_22386,type,
    v40831: ( state_type * $int ) > $o ).

tff(pred_def_22387,type,
    v40829: state_type > $o ).

tff(pred_def_22388,type,
    v40827: state_type > $o ).

tff(pred_def_22389,type,
    v40840: state_type > $o ).

tff(pred_def_22390,type,
    v40839: state_type > $o ).

tff(pred_def_22391,type,
    v40672: state_type > $o ).

tff(pred_def_22392,type,
    v40670: state_type > $o ).

tff(pred_def_22393,type,
    v40668: state_type > $o ).

tff(pred_def_22394,type,
    v40841: ( state_type * $int ) > $o ).

tff(pred_def_22395,type,
    v40842: state_type > $o ).

tff(pred_def_22396,type,
    v40666: ( state_type * $int ) > $o ).

tff(pred_def_22397,type,
    v40664: ( state_type * $int ) > $o ).

tff(pred_def_22398,type,
    v40843: ( state_type * $int ) > $o ).

tff(pred_def_22399,type,
    v40654: ( state_type * $int ) > $o ).

tff(pred_def_22400,type,
    v40652: ( state_type * $int ) > $o ).

tff(pred_def_22401,type,
    v40650: state_type > $o ).

tff(pred_def_22402,type,
    v40844: ( state_type * $int ) > $o ).

tff(pred_def_22403,type,
    v40845: state_type > $o ).

tff(pred_def_22404,type,
    v40648: ( state_type * $int ) > $o ).

tff(pred_def_22405,type,
    v40646: ( state_type * $int ) > $o ).

tff(pred_def_22406,type,
    v40846: ( state_type * $int ) > $o ).

tff(pred_def_22407,type,
    v40638: ( state_type * $int ) > $o ).

tff(pred_def_22408,type,
    v40636: ( state_type * $int ) > $o ).

tff(pred_def_22409,type,
    v40852: state_type > $o ).

tff(pred_def_22410,type,
    v40850: state_type > $o ).

tff(pred_def_22411,type,
    v40849: state_type > $o ).

tff(pred_def_22412,type,
    v40848: ( state_type * $int ) > $o ).

tff(pred_def_22413,type,
    v40593: state_type > $o ).

tff(pred_def_22414,type,
    v40591: state_type > $o ).

tff(pred_def_22415,type,
    v40858: state_type > $o ).

tff(pred_def_22416,type,
    v40856: state_type > $o ).

tff(pred_def_22417,type,
    v40862: state_type > $o ).

tff(pred_def_22418,type,
    v40860: state_type > $o ).

tff(pred_def_22419,type,
    v40865: state_type > $o ).

tff(pred_def_22420,type,
    v40864: state_type > $o ).

tff(pred_def_22421,type,
    v40589: state_type > $o ).

tff(pred_def_22422,type,
    v40587: state_type > $o ).

tff(pred_def_22423,type,
    v40585: state_type > $o ).

tff(pred_def_22424,type,
    v40583: state_type > $o ).

tff(pred_def_22425,type,
    v40581: state_type > $o ).

tff(pred_def_22426,type,
    v40579: state_type > $o ).

tff(pred_def_22427,type,
    v40577: state_type > $o ).

tff(pred_def_22428,type,
    v40575: state_type > $o ).

tff(pred_def_22429,type,
    v40885: state_type > $o ).

tff(pred_def_22430,type,
    v40883: state_type > $o ).

tff(pred_def_22431,type,
    v40881: state_type > $o ).

tff(pred_def_22432,type,
    v40879: state_type > $o ).

tff(pred_def_22433,type,
    v40877: state_type > $o ).

tff(pred_def_22434,type,
    v40895: state_type > $o ).

tff(pred_def_22435,type,
    v40893: state_type > $o ).

tff(pred_def_22436,type,
    v40891: state_type > $o ).

tff(pred_def_22437,type,
    v40889: state_type > $o ).

tff(pred_def_22438,type,
    v40887: state_type > $o ).

tff(pred_def_22439,type,
    v40899: ( state_type * $int ) > $o ).

tff(pred_def_22440,type,
    v40897: ( state_type * $int ) > $o ).

tff(pred_def_22441,type,
    v40909: state_type > $o ).

tff(pred_def_22442,type,
    v40907: state_type > $o ).

tff(pred_def_22443,type,
    v40915: state_type > $o ).

tff(pred_def_22444,type,
    v40913: state_type > $o ).

tff(pred_def_22445,type,
    v40939: ( state_type * $int ) > $o ).

tff(pred_def_22446,type,
    v40937: ( state_type * $int ) > $o ).

tff(pred_def_22447,type,
    v40940: ( state_type * $int ) > $o ).

tff(pred_def_22448,type,
    v40935: ( state_type * $int ) > $o ).

tff(pred_def_22449,type,
    v40933: ( state_type * $int ) > $o ).

tff(pred_def_22450,type,
    v40931: ( state_type * $int ) > $o ).

tff(pred_def_22451,type,
    v40929: state_type > $o ).

tff(pred_def_22452,type,
    v40927: state_type > $o ).

tff(pred_def_22453,type,
    v40944: state_type > $o ).

tff(pred_def_22454,type,
    v40942: state_type > $o ).

tff(pred_def_22455,type,
    v40948: state_type > $o ).

tff(pred_def_22456,type,
    v40946: state_type > $o ).

tff(pred_def_22457,type,
    v40951: state_type > $o ).

tff(pred_def_22458,type,
    v40950: state_type > $o ).

tff(pred_def_22459,type,
    v40925: state_type > $o ).

tff(pred_def_22460,type,
    v40923: state_type > $o ).

tff(pred_def_22461,type,
    v40921: state_type > $o ).

tff(pred_def_22462,type,
    v40919: state_type > $o ).

tff(pred_def_22463,type,
    v40917: state_type > $o ).

tff(pred_def_22464,type,
    v40955: state_type > $o ).

tff(pred_def_22465,type,
    v40953: state_type > $o ).

tff(pred_def_22466,type,
    v40911: state_type > $o ).

tff(pred_def_22467,type,
    v40961: state_type > $o ).

tff(pred_def_22468,type,
    v40963: state_type > $o ).

tff(pred_def_22469,type,
    v40959: state_type > $o ).

tff(pred_def_22470,type,
    v40958: state_type > $o ).

tff(pred_def_22471,type,
    v40969: state_type > $o ).

tff(pred_def_22472,type,
    v40970: state_type > $o ).

tff(pred_def_22473,type,
    v40966: state_type > $o ).

tff(pred_def_22474,type,
    v40968: state_type > $o ).

tff(pred_def_22475,type,
    v40976: state_type > $o ).

tff(pred_def_22476,type,
    v40974: state_type > $o ).

tff(pred_def_22477,type,
    v40978: state_type > $o ).

tff(pred_def_22478,type,
    v40905: state_type > $o ).

tff(pred_def_22479,type,
    v40903: state_type > $o ).

tff(pred_def_22480,type,
    v40901: state_type > $o ).

tff(pred_def_22481,type,
    v40985: state_type > $o ).

tff(pred_def_22482,type,
    v40983: state_type > $o ).

tff(pred_def_22483,type,
    v40982: state_type > $o ).

tff(pred_def_22484,type,
    v40981: state_type > $o ).

tff(pred_def_22485,type,
    v40993: state_type > $o ).

tff(pred_def_22486,type,
    v40994: state_type > $o ).

tff(pred_def_22487,type,
    v40992: state_type > $o ).

tff(pred_def_22488,type,
    v40989: ( state_type * $int ) > $o ).

tff(pred_def_22489,type,
    v40991: ( state_type * $int ) > $o ).

tff(pred_def_22490,type,
    v40875: ( state_type * $int ) > $o ).

tff(pred_def_22491,type,
    v40873: ( state_type * $int ) > $o ).

tff(pred_def_22492,type,
    v40871: ( state_type * $int ) > $o ).

tff(pred_def_22493,type,
    v40869: ( state_type * $int ) > $o ).

tff(pred_def_22494,type,
    v40867: ( state_type * $int ) > $o ).

tff(pred_def_22495,type,
    v41016: state_type > $o ).

tff(pred_def_22496,type,
    v41014: state_type > $o ).

tff(pred_def_22497,type,
    v41020: state_type > $o ).

tff(pred_def_22498,type,
    v41018: state_type > $o ).

tff(pred_def_22499,type,
    v41024: state_type > $o ).

tff(pred_def_22500,type,
    v41022: state_type > $o ).

tff(pred_def_22501,type,
    v41027: state_type > $o ).

tff(pred_def_22502,type,
    v41026: state_type > $o ).

tff(pred_def_22503,type,
    v41012: state_type > $o ).

tff(pred_def_22504,type,
    v41010: state_type > $o ).

tff(pred_def_22505,type,
    v41008: state_type > $o ).

tff(pred_def_22506,type,
    v41006: state_type > $o ).

tff(pred_def_22507,type,
    v41004: state_type > $o ).

tff(pred_def_22508,type,
    v41002: state_type > $o ).

tff(pred_def_22509,type,
    v41000: state_type > $o ).

tff(pred_def_22510,type,
    v40998: state_type > $o ).

tff(pred_def_22511,type,
    v41047: state_type > $o ).

tff(pred_def_22512,type,
    v41045: state_type > $o ).

tff(pred_def_22513,type,
    v41043: state_type > $o ).

tff(pred_def_22514,type,
    v41041: state_type > $o ).

tff(pred_def_22515,type,
    v41039: state_type > $o ).

tff(pred_def_22516,type,
    v41057: state_type > $o ).

tff(pred_def_22517,type,
    v41055: state_type > $o ).

tff(pred_def_22518,type,
    v41053: state_type > $o ).

tff(pred_def_22519,type,
    v41051: state_type > $o ).

tff(pred_def_22520,type,
    v41049: state_type > $o ).

tff(pred_def_22521,type,
    v41061: ( state_type * $int ) > $o ).

tff(pred_def_22522,type,
    v41059: ( state_type * $int ) > $o ).

tff(pred_def_22523,type,
    v41071: state_type > $o ).

tff(pred_def_22524,type,
    v41069: state_type > $o ).

tff(pred_def_22525,type,
    v41077: state_type > $o ).

tff(pred_def_22526,type,
    v41075: state_type > $o ).

tff(pred_def_22527,type,
    v41091: state_type > $o ).

tff(pred_def_22528,type,
    v41089: state_type > $o ).

tff(pred_def_22529,type,
    v41095: state_type > $o ).

tff(pred_def_22530,type,
    v41093: state_type > $o ).

tff(pred_def_22531,type,
    v41099: state_type > $o ).

tff(pred_def_22532,type,
    v41097: state_type > $o ).

tff(pred_def_22533,type,
    v41102: state_type > $o ).

tff(pred_def_22534,type,
    v41101: state_type > $o ).

tff(pred_def_22535,type,
    v41087: state_type > $o ).

tff(pred_def_22536,type,
    v41085: state_type > $o ).

tff(pred_def_22537,type,
    v41083: state_type > $o ).

tff(pred_def_22538,type,
    v41081: state_type > $o ).

tff(pred_def_22539,type,
    v41079: state_type > $o ).

tff(pred_def_22540,type,
    v41106: state_type > $o ).

tff(pred_def_22541,type,
    v41104: state_type > $o ).

tff(pred_def_22542,type,
    v41073: state_type > $o ).

tff(pred_def_22543,type,
    v41112: state_type > $o ).

tff(pred_def_22544,type,
    v41114: state_type > $o ).

tff(pred_def_22545,type,
    v41110: state_type > $o ).

tff(pred_def_22546,type,
    v41109: state_type > $o ).

tff(pred_def_22547,type,
    v41120: state_type > $o ).

tff(pred_def_22548,type,
    v41121: state_type > $o ).

tff(pred_def_22549,type,
    v41117: state_type > $o ).

tff(pred_def_22550,type,
    v41119: state_type > $o ).

tff(pred_def_22551,type,
    v41127: state_type > $o ).

tff(pred_def_22552,type,
    v41125: state_type > $o ).

tff(pred_def_22553,type,
    v41129: state_type > $o ).

tff(pred_def_22554,type,
    v41067: state_type > $o ).

tff(pred_def_22555,type,
    v41065: state_type > $o ).

tff(pred_def_22556,type,
    v41063: state_type > $o ).

tff(pred_def_22557,type,
    v41136: state_type > $o ).

tff(pred_def_22558,type,
    v41134: state_type > $o ).

tff(pred_def_22559,type,
    v41133: state_type > $o ).

tff(pred_def_22560,type,
    v41132: state_type > $o ).

tff(pred_def_22561,type,
    v41144: state_type > $o ).

tff(pred_def_22562,type,
    v41145: state_type > $o ).

tff(pred_def_22563,type,
    v41143: state_type > $o ).

tff(pred_def_22564,type,
    v41140: ( state_type * $int ) > $o ).

tff(pred_def_22565,type,
    v41142: ( state_type * $int ) > $o ).

tff(pred_def_22566,type,
    v41037: ( state_type * $int ) > $o ).

tff(pred_def_22567,type,
    v41035: ( state_type * $int ) > $o ).

tff(pred_def_22568,type,
    v41033: ( state_type * $int ) > $o ).

tff(pred_def_22569,type,
    v41031: ( state_type * $int ) > $o ).

tff(pred_def_22570,type,
    v41029: ( state_type * $int ) > $o ).

tff(pred_def_22571,type,
    v41167: state_type > $o ).

tff(pred_def_22572,type,
    v41165: state_type > $o ).

tff(pred_def_22573,type,
    v41171: state_type > $o ).

tff(pred_def_22574,type,
    v41169: state_type > $o ).

tff(pred_def_22575,type,
    v41175: state_type > $o ).

tff(pred_def_22576,type,
    v41173: state_type > $o ).

tff(pred_def_22577,type,
    v41178: state_type > $o ).

tff(pred_def_22578,type,
    v41177: state_type > $o ).

tff(pred_def_22579,type,
    v41163: state_type > $o ).

tff(pred_def_22580,type,
    v41161: state_type > $o ).

tff(pred_def_22581,type,
    v41159: state_type > $o ).

tff(pred_def_22582,type,
    v41157: state_type > $o ).

tff(pred_def_22583,type,
    v41155: state_type > $o ).

tff(pred_def_22584,type,
    v41153: state_type > $o ).

tff(pred_def_22585,type,
    v41151: state_type > $o ).

tff(pred_def_22586,type,
    v41149: state_type > $o ).

tff(pred_def_22587,type,
    v41198: state_type > $o ).

tff(pred_def_22588,type,
    v41196: state_type > $o ).

tff(pred_def_22589,type,
    v41194: state_type > $o ).

tff(pred_def_22590,type,
    v41192: state_type > $o ).

tff(pred_def_22591,type,
    v41190: state_type > $o ).

tff(pred_def_22592,type,
    v41208: state_type > $o ).

tff(pred_def_22593,type,
    v41206: state_type > $o ).

tff(pred_def_22594,type,
    v41204: state_type > $o ).

tff(pred_def_22595,type,
    v41202: state_type > $o ).

tff(pred_def_22596,type,
    v41200: state_type > $o ).

tff(pred_def_22597,type,
    v41212: ( state_type * $int ) > $o ).

tff(pred_def_22598,type,
    v41210: ( state_type * $int ) > $o ).

tff(pred_def_22599,type,
    v41222: state_type > $o ).

tff(pred_def_22600,type,
    v41220: state_type > $o ).

tff(pred_def_22601,type,
    v41228: state_type > $o ).

tff(pred_def_22602,type,
    v41226: state_type > $o ).

tff(pred_def_22603,type,
    v41242: state_type > $o ).

tff(pred_def_22604,type,
    v41240: state_type > $o ).

tff(pred_def_22605,type,
    v41246: state_type > $o ).

tff(pred_def_22606,type,
    v41244: state_type > $o ).

tff(pred_def_22607,type,
    v41250: state_type > $o ).

tff(pred_def_22608,type,
    v41248: state_type > $o ).

tff(pred_def_22609,type,
    v41253: state_type > $o ).

tff(pred_def_22610,type,
    v41252: state_type > $o ).

tff(pred_def_22611,type,
    v41238: state_type > $o ).

tff(pred_def_22612,type,
    v41236: state_type > $o ).

tff(pred_def_22613,type,
    v41234: state_type > $o ).

tff(pred_def_22614,type,
    v41232: state_type > $o ).

tff(pred_def_22615,type,
    v41230: state_type > $o ).

tff(pred_def_22616,type,
    v41257: state_type > $o ).

tff(pred_def_22617,type,
    v41255: state_type > $o ).

tff(pred_def_22618,type,
    v41224: state_type > $o ).

tff(pred_def_22619,type,
    v41263: state_type > $o ).

tff(pred_def_22620,type,
    v41265: state_type > $o ).

tff(pred_def_22621,type,
    v41261: state_type > $o ).

tff(pred_def_22622,type,
    v41260: state_type > $o ).

tff(pred_def_22623,type,
    v41271: state_type > $o ).

tff(pred_def_22624,type,
    v41272: state_type > $o ).

tff(pred_def_22625,type,
    v41268: state_type > $o ).

tff(pred_def_22626,type,
    v41270: state_type > $o ).

tff(pred_def_22627,type,
    v41278: state_type > $o ).

tff(pred_def_22628,type,
    v41276: state_type > $o ).

tff(pred_def_22629,type,
    v41280: state_type > $o ).

tff(pred_def_22630,type,
    v41218: state_type > $o ).

tff(pred_def_22631,type,
    v41216: state_type > $o ).

tff(pred_def_22632,type,
    v41214: state_type > $o ).

tff(pred_def_22633,type,
    v41287: state_type > $o ).

tff(pred_def_22634,type,
    v41285: state_type > $o ).

tff(pred_def_22635,type,
    v41284: state_type > $o ).

tff(pred_def_22636,type,
    v41283: state_type > $o ).

tff(pred_def_22637,type,
    v41295: state_type > $o ).

tff(pred_def_22638,type,
    v41296: state_type > $o ).

tff(pred_def_22639,type,
    v41294: state_type > $o ).

tff(pred_def_22640,type,
    v41291: ( state_type * $int ) > $o ).

tff(pred_def_22641,type,
    v41293: ( state_type * $int ) > $o ).

tff(pred_def_22642,type,
    v41188: ( state_type * $int ) > $o ).

tff(pred_def_22643,type,
    v41186: ( state_type * $int ) > $o ).

tff(pred_def_22644,type,
    v41184: ( state_type * $int ) > $o ).

tff(pred_def_22645,type,
    v41182: ( state_type * $int ) > $o ).

tff(pred_def_22646,type,
    v41180: ( state_type * $int ) > $o ).

tff(pred_def_22647,type,
    v41318: state_type > $o ).

tff(pred_def_22648,type,
    v41316: state_type > $o ).

tff(pred_def_22649,type,
    v41322: state_type > $o ).

tff(pred_def_22650,type,
    v41320: state_type > $o ).

tff(pred_def_22651,type,
    v41326: state_type > $o ).

tff(pred_def_22652,type,
    v41324: state_type > $o ).

tff(pred_def_22653,type,
    v41329: state_type > $o ).

tff(pred_def_22654,type,
    v41328: state_type > $o ).

tff(pred_def_22655,type,
    v41314: state_type > $o ).

tff(pred_def_22656,type,
    v41312: state_type > $o ).

tff(pred_def_22657,type,
    v41310: state_type > $o ).

tff(pred_def_22658,type,
    v41308: state_type > $o ).

tff(pred_def_22659,type,
    v41306: state_type > $o ).

tff(pred_def_22660,type,
    v41304: state_type > $o ).

tff(pred_def_22661,type,
    v41302: state_type > $o ).

tff(pred_def_22662,type,
    v41300: state_type > $o ).

tff(pred_def_22663,type,
    v41349: state_type > $o ).

tff(pred_def_22664,type,
    v41347: state_type > $o ).

tff(pred_def_22665,type,
    v41345: state_type > $o ).

tff(pred_def_22666,type,
    v41343: state_type > $o ).

tff(pred_def_22667,type,
    v41341: state_type > $o ).

tff(pred_def_22668,type,
    v41359: state_type > $o ).

tff(pred_def_22669,type,
    v41357: state_type > $o ).

tff(pred_def_22670,type,
    v41355: state_type > $o ).

tff(pred_def_22671,type,
    v41353: state_type > $o ).

tff(pred_def_22672,type,
    v41351: state_type > $o ).

tff(pred_def_22673,type,
    v41363: ( state_type * $int ) > $o ).

tff(pred_def_22674,type,
    v41361: ( state_type * $int ) > $o ).

tff(pred_def_22675,type,
    v41373: state_type > $o ).

tff(pred_def_22676,type,
    v41371: state_type > $o ).

tff(pred_def_22677,type,
    v41379: state_type > $o ).

tff(pred_def_22678,type,
    v41377: state_type > $o ).

tff(pred_def_22679,type,
    v41393: state_type > $o ).

tff(pred_def_22680,type,
    v41391: state_type > $o ).

tff(pred_def_22681,type,
    v41397: state_type > $o ).

tff(pred_def_22682,type,
    v41395: state_type > $o ).

tff(pred_def_22683,type,
    v41401: state_type > $o ).

tff(pred_def_22684,type,
    v41399: state_type > $o ).

tff(pred_def_22685,type,
    v41404: state_type > $o ).

tff(pred_def_22686,type,
    v41403: state_type > $o ).

tff(pred_def_22687,type,
    v41389: state_type > $o ).

tff(pred_def_22688,type,
    v41387: state_type > $o ).

tff(pred_def_22689,type,
    v41385: state_type > $o ).

tff(pred_def_22690,type,
    v41383: state_type > $o ).

tff(pred_def_22691,type,
    v41381: state_type > $o ).

tff(pred_def_22692,type,
    v41408: state_type > $o ).

tff(pred_def_22693,type,
    v41406: state_type > $o ).

tff(pred_def_22694,type,
    v41375: state_type > $o ).

tff(pred_def_22695,type,
    v41414: state_type > $o ).

tff(pred_def_22696,type,
    v41416: state_type > $o ).

tff(pred_def_22697,type,
    v41412: state_type > $o ).

tff(pred_def_22698,type,
    v41411: state_type > $o ).

tff(pred_def_22699,type,
    v41422: state_type > $o ).

tff(pred_def_22700,type,
    v41423: state_type > $o ).

tff(pred_def_22701,type,
    v41419: state_type > $o ).

tff(pred_def_22702,type,
    v41421: state_type > $o ).

tff(pred_def_22703,type,
    v41429: state_type > $o ).

tff(pred_def_22704,type,
    v41427: state_type > $o ).

tff(pred_def_22705,type,
    v41431: state_type > $o ).

tff(pred_def_22706,type,
    v41369: state_type > $o ).

tff(pred_def_22707,type,
    v41367: state_type > $o ).

tff(pred_def_22708,type,
    v41365: state_type > $o ).

tff(pred_def_22709,type,
    v41438: state_type > $o ).

tff(pred_def_22710,type,
    v41436: state_type > $o ).

tff(pred_def_22711,type,
    v41435: state_type > $o ).

tff(pred_def_22712,type,
    v41434: state_type > $o ).

tff(pred_def_22713,type,
    v41446: state_type > $o ).

tff(pred_def_22714,type,
    v41447: state_type > $o ).

tff(pred_def_22715,type,
    v41445: state_type > $o ).

tff(pred_def_22716,type,
    v41442: ( state_type * $int ) > $o ).

tff(pred_def_22717,type,
    v41444: ( state_type * $int ) > $o ).

tff(pred_def_22718,type,
    v41339: ( state_type * $int ) > $o ).

tff(pred_def_22719,type,
    v41337: ( state_type * $int ) > $o ).

tff(pred_def_22720,type,
    v41335: ( state_type * $int ) > $o ).

tff(pred_def_22721,type,
    v41333: ( state_type * $int ) > $o ).

tff(pred_def_22722,type,
    v41331: ( state_type * $int ) > $o ).

tff(pred_def_22723,type,
    v41469: state_type > $o ).

tff(pred_def_22724,type,
    v41467: state_type > $o ).

tff(pred_def_22725,type,
    v41473: state_type > $o ).

tff(pred_def_22726,type,
    v41471: state_type > $o ).

tff(pred_def_22727,type,
    v41477: state_type > $o ).

tff(pred_def_22728,type,
    v41475: state_type > $o ).

tff(pred_def_22729,type,
    v41480: state_type > $o ).

tff(pred_def_22730,type,
    v41479: state_type > $o ).

tff(pred_def_22731,type,
    v41465: state_type > $o ).

tff(pred_def_22732,type,
    v41463: state_type > $o ).

tff(pred_def_22733,type,
    v41461: state_type > $o ).

tff(pred_def_22734,type,
    v41459: state_type > $o ).

tff(pred_def_22735,type,
    v41457: state_type > $o ).

tff(pred_def_22736,type,
    v41455: state_type > $o ).

tff(pred_def_22737,type,
    v41453: state_type > $o ).

tff(pred_def_22738,type,
    v41451: state_type > $o ).

tff(pred_def_22739,type,
    v41500: state_type > $o ).

tff(pred_def_22740,type,
    v41498: state_type > $o ).

tff(pred_def_22741,type,
    v41496: state_type > $o ).

tff(pred_def_22742,type,
    v41494: state_type > $o ).

tff(pred_def_22743,type,
    v41492: state_type > $o ).

tff(pred_def_22744,type,
    v41510: state_type > $o ).

tff(pred_def_22745,type,
    v41508: state_type > $o ).

tff(pred_def_22746,type,
    v41506: state_type > $o ).

tff(pred_def_22747,type,
    v41504: state_type > $o ).

tff(pred_def_22748,type,
    v41502: state_type > $o ).

tff(pred_def_22749,type,
    v41514: ( state_type * $int ) > $o ).

tff(pred_def_22750,type,
    v41512: ( state_type * $int ) > $o ).

tff(pred_def_22751,type,
    v41524: state_type > $o ).

tff(pred_def_22752,type,
    v41522: state_type > $o ).

tff(pred_def_22753,type,
    v41530: state_type > $o ).

tff(pred_def_22754,type,
    v41528: state_type > $o ).

tff(pred_def_22755,type,
    v41543: state_type > $o ).

tff(pred_def_22756,type,
    v41541: state_type > $o ).

tff(pred_def_22757,type,
    v41547: state_type > $o ).

tff(pred_def_22758,type,
    v41545: state_type > $o ).

tff(pred_def_22759,type,
    v41551: state_type > $o ).

tff(pred_def_22760,type,
    v41549: state_type > $o ).

tff(pred_def_22761,type,
    v41554: state_type > $o ).

tff(pred_def_22762,type,
    v41553: state_type > $o ).

tff(pred_def_22763,type,
    v41539: state_type > $o ).

tff(pred_def_22764,type,
    v41537: state_type > $o ).

tff(pred_def_22765,type,
    v41534: state_type > $o ).

tff(pred_def_22766,type,
    v41532: state_type > $o ).

tff(pred_def_22767,type,
    v41558: state_type > $o ).

tff(pred_def_22768,type,
    v41556: state_type > $o ).

tff(pred_def_22769,type,
    v41526: state_type > $o ).

tff(pred_def_22770,type,
    v41564: state_type > $o ).

tff(pred_def_22771,type,
    v41566: state_type > $o ).

tff(pred_def_22772,type,
    v41562: state_type > $o ).

tff(pred_def_22773,type,
    v41561: state_type > $o ).

tff(pred_def_22774,type,
    v41572: state_type > $o ).

tff(pred_def_22775,type,
    v41573: state_type > $o ).

tff(pred_def_22776,type,
    v41569: state_type > $o ).

tff(pred_def_22777,type,
    v41571: state_type > $o ).

tff(pred_def_22778,type,
    v41579: state_type > $o ).

tff(pred_def_22779,type,
    v41577: state_type > $o ).

tff(pred_def_22780,type,
    v41581: state_type > $o ).

tff(pred_def_22781,type,
    v41520: state_type > $o ).

tff(pred_def_22782,type,
    v41518: state_type > $o ).

tff(pred_def_22783,type,
    v41516: state_type > $o ).

tff(pred_def_22784,type,
    v41588: state_type > $o ).

tff(pred_def_22785,type,
    v41586: state_type > $o ).

tff(pred_def_22786,type,
    v41585: state_type > $o ).

tff(pred_def_22787,type,
    v41584: state_type > $o ).

tff(pred_def_22788,type,
    v41596: state_type > $o ).

tff(pred_def_22789,type,
    v41597: state_type > $o ).

tff(pred_def_22790,type,
    v41595: state_type > $o ).

tff(pred_def_22791,type,
    v41592: ( state_type * $int ) > $o ).

tff(pred_def_22792,type,
    v41594: ( state_type * $int ) > $o ).

tff(pred_def_22793,type,
    v41490: ( state_type * $int ) > $o ).

tff(pred_def_22794,type,
    v41488: ( state_type * $int ) > $o ).

tff(pred_def_22795,type,
    v41486: ( state_type * $int ) > $o ).

tff(pred_def_22796,type,
    v41484: ( state_type * $int ) > $o ).

tff(pred_def_22797,type,
    v41482: ( state_type * $int ) > $o ).

tff(pred_def_22798,type,
    v41609: state_type > $o ).

tff(pred_def_22799,type,
    v41607: state_type > $o ).

tff(pred_def_22800,type,
    v41605: state_type > $o ).

tff(pred_def_22801,type,
    v41603: state_type > $o ).

tff(pred_def_22802,type,
    v41601: state_type > $o ).

tff(pred_def_22803,type,
    v41617: state_type > $o ).

tff(pred_def_22804,type,
    v41616: ( state_type * $int ) > $o ).

tff(pred_def_22805,type,
    v41615: ( state_type * $int ) > $o ).

tff(pred_def_22806,type,
    v41620: state_type > $o ).

tff(pred_def_22807,type,
    v41619: ( state_type * $int ) > $o ).

tff(pred_def_22808,type,
    v41618: ( state_type * $int ) > $o ).

tff(pred_def_22809,type,
    v41614: ( state_type * $int ) > $o ).

tff(pred_def_22810,type,
    v41623: state_type > $o ).

tff(pred_def_22811,type,
    v41622: ( state_type * $int ) > $o ).

tff(pred_def_22812,type,
    v41621: ( state_type * $int ) > $o ).

tff(pred_def_22813,type,
    v41613: ( state_type * $int ) > $o ).

tff(pred_def_22814,type,
    v41626: state_type > $o ).

tff(pred_def_22815,type,
    v41625: ( state_type * $int ) > $o ).

tff(pred_def_22816,type,
    v41624: ( state_type * $int ) > $o ).

tff(pred_def_22817,type,
    v41612: ( state_type * $int ) > $o ).

tff(pred_def_22818,type,
    v41629: state_type > $o ).

tff(pred_def_22819,type,
    v41628: ( state_type * $int ) > $o ).

tff(pred_def_22820,type,
    v41627: ( state_type * $int ) > $o ).

tff(pred_def_22821,type,
    v41611: ( state_type * $int ) > $o ).

tff(pred_def_22822,type,
    v41632: state_type > $o ).

tff(pred_def_22823,type,
    v41631: ( state_type * $int ) > $o ).

tff(pred_def_22824,type,
    v41630: ( state_type * $int ) > $o ).

tff(pred_def_22825,type,
    v40103: ( state_type * $int ) > $o ).

tff(pred_def_22826,type,
    v40101: ( state_type * $int ) > $o ).

tff(pred_def_22827,type,
    v40099: ( state_type * $int ) > $o ).

tff(pred_def_22828,type,
    v40097: ( state_type * $int ) > $o ).

tff(pred_def_22829,type,
    v40095: ( state_type * $int ) > $o ).

tff(pred_def_22830,type,
    v40089: state_type > $o ).

tff(pred_def_22831,type,
    v40087: state_type > $o ).

tff(pred_def_22832,type,
    v40085: state_type > $o ).

tff(pred_def_22833,type,
    v41643: ( state_type * $int ) > $o ).

tff(pred_def_22834,type,
    v41641: ( state_type * $int ) > $o ).

tff(pred_def_22835,type,
    v41677: state_type > $o ).

tff(pred_def_22836,type,
    v41675: state_type > $o ).

tff(pred_def_22837,type,
    v41673: state_type > $o ).

tff(pred_def_22838,type,
    v41671: state_type > $o ).

tff(pred_def_22839,type,
    v41669: state_type > $o ).

tff(pred_def_22840,type,
    v41667: state_type > $o ).

tff(pred_def_22841,type,
    v41665: state_type > $o ).

tff(pred_def_22842,type,
    v41691: state_type > $o ).

tff(pred_def_22843,type,
    v41689: state_type > $o ).

tff(pred_def_22844,type,
    v41687: state_type > $o ).

tff(pred_def_22845,type,
    v41685: state_type > $o ).

tff(pred_def_22846,type,
    v41683: state_type > $o ).

tff(pred_def_22847,type,
    v41681: state_type > $o ).

tff(pred_def_22848,type,
    v41679: state_type > $o ).

tff(pred_def_22849,type,
    v41717: state_type > $o ).

tff(pred_def_22850,type,
    v41719: state_type > $o ).

tff(pred_def_22851,type,
    v41718: ( state_type * $int ) > $o ).

tff(pred_def_22852,type,
    v41720: state_type > $o ).

tff(pred_def_22853,type,
    v41715: ( state_type * $int ) > $o ).

tff(pred_def_22854,type,
    v41713: ( state_type * $int ) > $o ).

tff(pred_def_22855,type,
    v41721: ( state_type * $int ) > $o ).

tff(pred_def_22856,type,
    v41711: ( state_type * $int ) > $o ).

tff(pred_def_22857,type,
    v41709: ( state_type * $int ) > $o ).

tff(pred_def_22858,type,
    v41707: state_type > $o ).

tff(pred_def_22859,type,
    v41723: state_type > $o ).

tff(pred_def_22860,type,
    v41705: ( state_type * $int ) > $o ).

tff(pred_def_22861,type,
    v41703: ( state_type * $int ) > $o ).

tff(pred_def_22862,type,
    v41737: ( state_type * $int ) > $o ).

tff(pred_def_22863,type,
    v41735: ( state_type * $int ) > $o ).

tff(pred_def_22864,type,
    v41741: state_type > $o ).

tff(pred_def_22865,type,
    v41739: state_type > $o ).

tff(pred_def_22866,type,
    v41765: state_type > $o ).

tff(pred_def_22867,type,
    v41763: state_type > $o ).

tff(pred_def_22868,type,
    v41761: state_type > $o ).

tff(pred_def_22869,type,
    v41759: state_type > $o ).

tff(pred_def_22870,type,
    v41757: state_type > $o ).

tff(pred_def_22871,type,
    v41755: state_type > $o ).

tff(pred_def_22872,type,
    v41753: state_type > $o ).

tff(pred_def_22873,type,
    v41779: state_type > $o ).

tff(pred_def_22874,type,
    v41777: state_type > $o ).

tff(pred_def_22875,type,
    v41775: state_type > $o ).

tff(pred_def_22876,type,
    v41773: state_type > $o ).

tff(pred_def_22877,type,
    v41771: state_type > $o ).

tff(pred_def_22878,type,
    v41769: state_type > $o ).

tff(pred_def_22879,type,
    v41767: state_type > $o ).

tff(pred_def_22880,type,
    v41795: ( state_type * $int ) > $o ).

tff(pred_def_22881,type,
    v41793: ( state_type * $int ) > $o ).

tff(pred_def_22882,type,
    v41791: ( state_type * $int ) > $o ).

tff(pred_def_22883,type,
    v41789: ( state_type * $int ) > $o ).

tff(pred_def_22884,type,
    v41787: ( state_type * $int ) > $o ).

tff(pred_def_22885,type,
    v41825: ( state_type * $int ) > $o ).

tff(pred_def_22886,type,
    v41827: ( state_type * $int ) > $o ).

tff(pred_def_22887,type,
    v41823: ( state_type * $int ) > $o ).

tff(pred_def_22888,type,
    v41821: ( state_type * $int ) > $o ).

tff(pred_def_22889,type,
    v41819: ( state_type * $int ) > $o ).

tff(pred_def_22890,type,
    v41817: ( state_type * $int ) > $o ).

tff(pred_def_22891,type,
    v41815: state_type > $o ).

tff(pred_def_22892,type,
    v41813: state_type > $o ).

tff(pred_def_22893,type,
    v41831: state_type > $o ).

tff(pred_def_22894,type,
    v41829: state_type > $o ).

tff(pred_def_22895,type,
    v41833: state_type > $o ).

tff(pred_def_22896,type,
    v41811: state_type > $o ).

tff(pred_def_22897,type,
    v41809: state_type > $o ).

tff(pred_def_22898,type,
    v41807: state_type > $o ).

tff(pred_def_22899,type,
    v41805: state_type > $o ).

tff(pred_def_22900,type,
    v41803: state_type > $o ).

tff(pred_def_22901,type,
    v41801: state_type > $o ).

tff(pred_def_22902,type,
    v41799: state_type > $o ).

tff(pred_def_22903,type,
    v41797: state_type > $o ).

tff(pred_def_22904,type,
    v41843: ( state_type * $int ) > $o ).

tff(pred_def_22905,type,
    v41841: ( state_type * $int ) > $o ).

tff(pred_def_22906,type,
    v41839: ( state_type * $int ) > $o ).

tff(pred_def_22907,type,
    v41837: ( state_type * $int ) > $o ).

tff(pred_def_22908,type,
    v41835: ( state_type * $int ) > $o ).

tff(pred_def_22909,type,
    v41873: ( state_type * $int ) > $o ).

tff(pred_def_22910,type,
    v41871: ( state_type * $int ) > $o ).

tff(pred_def_22911,type,
    v41874: ( state_type * $int ) > $o ).

tff(pred_def_22912,type,
    v41869: ( state_type * $int ) > $o ).

tff(pred_def_22913,type,
    v41867: ( state_type * $int ) > $o ).

tff(pred_def_22914,type,
    v41865: ( state_type * $int ) > $o ).

tff(pred_def_22915,type,
    v41863: state_type > $o ).

tff(pred_def_22916,type,
    v41861: state_type > $o ).

tff(pred_def_22917,type,
    v41878: state_type > $o ).

tff(pred_def_22918,type,
    v41876: state_type > $o ).

tff(pred_def_22919,type,
    v41880: state_type > $o ).

tff(pred_def_22920,type,
    v41859: state_type > $o ).

tff(pred_def_22921,type,
    v41857: state_type > $o ).

tff(pred_def_22922,type,
    v41855: state_type > $o ).

tff(pred_def_22923,type,
    v41853: state_type > $o ).

tff(pred_def_22924,type,
    v41851: state_type > $o ).

tff(pred_def_22925,type,
    v41849: state_type > $o ).

tff(pred_def_22926,type,
    v41847: state_type > $o ).

tff(pred_def_22927,type,
    v41845: state_type > $o ).

tff(pred_def_22928,type,
    v41890: ( state_type * $int ) > $o ).

tff(pred_def_22929,type,
    v41888: ( state_type * $int ) > $o ).

tff(pred_def_22930,type,
    v41886: ( state_type * $int ) > $o ).

tff(pred_def_22931,type,
    v41884: ( state_type * $int ) > $o ).

tff(pred_def_22932,type,
    v41882: ( state_type * $int ) > $o ).

tff(pred_def_22933,type,
    v41910: state_type > $o ).

tff(pred_def_22934,type,
    v41908: state_type > $o ).

tff(pred_def_22935,type,
    v41914: state_type > $o ).

tff(pred_def_22936,type,
    v41912: state_type > $o ).

tff(pred_def_22937,type,
    v41916: state_type > $o ).

tff(pred_def_22938,type,
    v41906: state_type > $o ).

tff(pred_def_22939,type,
    v41904: state_type > $o ).

tff(pred_def_22940,type,
    v41902: state_type > $o ).

tff(pred_def_22941,type,
    v41900: state_type > $o ).

tff(pred_def_22942,type,
    v41898: state_type > $o ).

tff(pred_def_22943,type,
    v41896: state_type > $o ).

tff(pred_def_22944,type,
    v41894: state_type > $o ).

tff(pred_def_22945,type,
    v41892: state_type > $o ).

tff(pred_def_22946,type,
    v41926: ( state_type * $int ) > $o ).

tff(pred_def_22947,type,
    v41924: ( state_type * $int ) > $o ).

tff(pred_def_22948,type,
    v41922: ( state_type * $int ) > $o ).

tff(pred_def_22949,type,
    v41920: ( state_type * $int ) > $o ).

tff(pred_def_22950,type,
    v41918: ( state_type * $int ) > $o ).

tff(pred_def_22951,type,
    v41946: state_type > $o ).

tff(pred_def_22952,type,
    v41944: state_type > $o ).

tff(pred_def_22953,type,
    v41950: state_type > $o ).

tff(pred_def_22954,type,
    v41948: state_type > $o ).

tff(pred_def_22955,type,
    v41952: state_type > $o ).

tff(pred_def_22956,type,
    v41942: state_type > $o ).

tff(pred_def_22957,type,
    v41940: state_type > $o ).

tff(pred_def_22958,type,
    v41938: state_type > $o ).

tff(pred_def_22959,type,
    v41936: state_type > $o ).

tff(pred_def_22960,type,
    v41934: state_type > $o ).

tff(pred_def_22961,type,
    v41932: state_type > $o ).

tff(pred_def_22962,type,
    v41930: state_type > $o ).

tff(pred_def_22963,type,
    v41928: state_type > $o ).

tff(pred_def_22964,type,
    v41958: state_type > $o ).

tff(pred_def_22965,type,
    v41957: ( state_type * $int ) > $o ).

tff(pred_def_22966,type,
    v41956: ( state_type * $int ) > $o ).

tff(pred_def_22967,type,
    v41961: state_type > $o ).

tff(pred_def_22968,type,
    v41960: ( state_type * $int ) > $o ).

tff(pred_def_22969,type,
    v41959: ( state_type * $int ) > $o ).

tff(pred_def_22970,type,
    v41955: ( state_type * $int ) > $o ).

tff(pred_def_22971,type,
    v41964: state_type > $o ).

tff(pred_def_22972,type,
    v41963: ( state_type * $int ) > $o ).

tff(pred_def_22973,type,
    v41962: ( state_type * $int ) > $o ).

tff(pred_def_22974,type,
    v41954: ( state_type * $int ) > $o ).

tff(pred_def_22975,type,
    v41967: state_type > $o ).

tff(pred_def_22976,type,
    v41966: ( state_type * $int ) > $o ).

tff(pred_def_22977,type,
    v41965: ( state_type * $int ) > $o ).

tff(pred_def_22978,type,
    v41785: ( state_type * $int ) > $o ).

tff(pred_def_22979,type,
    v41783: ( state_type * $int ) > $o ).

tff(pred_def_22980,type,
    v41781: ( state_type * $int ) > $o ).

tff(pred_def_22981,type,
    v41979: state_type > $o ).

tff(pred_def_22982,type,
    v41977: state_type > $o ).

tff(pred_def_22983,type,
    v41975: state_type > $o ).

tff(pred_def_22984,type,
    v41989: state_type > $o ).

tff(pred_def_22985,type,
    v41987: state_type > $o ).

tff(pred_def_22986,type,
    v41985: state_type > $o ).

tff(pred_def_22987,type,
    v41983: state_type > $o ).

tff(pred_def_22988,type,
    v41981: state_type > $o ).

tff(pred_def_22989,type,
    v41991: state_type > $o ).

tff(pred_def_22990,type,
    v41973: state_type > $o ).

tff(pred_def_22991,type,
    v41971: state_type > $o ).

tff(pred_def_22992,type,
    v41969: state_type > $o ).

tff(pred_def_22993,type,
    v41998: state_type > $o ).

tff(pred_def_22994,type,
    v41996: state_type > $o ).

tff(pred_def_22995,type,
    v41995: state_type > $o ).

tff(pred_def_22996,type,
    v41994: state_type > $o ).

tff(pred_def_22997,type,
    v42006: state_type > $o ).

tff(pred_def_22998,type,
    v42007: state_type > $o ).

tff(pred_def_22999,type,
    v42005: state_type > $o ).

tff(pred_def_23000,type,
    v42002: ( state_type * $int ) > $o ).

tff(pred_def_23001,type,
    v42004: ( state_type * $int ) > $o ).

tff(pred_def_23002,type,
    v41751: ( state_type * $int ) > $o ).

tff(pred_def_23003,type,
    v41749: ( state_type * $int ) > $o ).

tff(pred_def_23004,type,
    v41747: ( state_type * $int ) > $o ).

tff(pred_def_23005,type,
    v41745: ( state_type * $int ) > $o ).

tff(pred_def_23006,type,
    v41743: ( state_type * $int ) > $o ).

tff(pred_def_23007,type,
    v42013: state_type > $o ).

tff(pred_def_23008,type,
    v42011: state_type > $o ).

tff(pred_def_23009,type,
    v42017: state_type > $o ).

tff(pred_def_23010,type,
    v42016: ( state_type * $int ) > $o ).

tff(pred_def_23011,type,
    v42015: ( state_type * $int ) > $o ).

tff(pred_def_23012,type,
    v42020: state_type > $o ).

tff(pred_def_23013,type,
    v42019: ( state_type * $int ) > $o ).

tff(pred_def_23014,type,
    v42018: ( state_type * $int ) > $o ).

tff(pred_def_23015,type,
    v41733: ( state_type * $int ) > $o ).

tff(pred_def_23016,type,
    v41731: ( state_type * $int ) > $o ).

tff(pred_def_23017,type,
    v41729: ( state_type * $int ) > $o ).

tff(pred_def_23018,type,
    v41727: ( state_type * $int ) > $o ).

tff(pred_def_23019,type,
    v41725: ( state_type * $int ) > $o ).

tff(pred_def_23020,type,
    v41701: ( state_type * $int ) > $o ).

tff(pred_def_23021,type,
    v41699: ( state_type * $int ) > $o ).

tff(pred_def_23022,type,
    v41697: ( state_type * $int ) > $o ).

tff(pred_def_23023,type,
    v41695: ( state_type * $int ) > $o ).

tff(pred_def_23024,type,
    v41693: ( state_type * $int ) > $o ).

tff(pred_def_23025,type,
    v42033: state_type > $o ).

tff(pred_def_23026,type,
    v42031: state_type > $o ).

tff(pred_def_23027,type,
    v42029: state_type > $o ).

tff(pred_def_23028,type,
    v42039: state_type > $o ).

tff(pred_def_23029,type,
    v42037: state_type > $o ).

tff(pred_def_23030,type,
    v42057: ( state_type * $int ) > $o ).

tff(pred_def_23031,type,
    v42059: ( state_type * $int ) > $o ).

tff(pred_def_23032,type,
    v42055: ( state_type * $int ) > $o ).

tff(pred_def_23033,type,
    v42053: state_type > $o ).

tff(pred_def_23034,type,
    v42051: state_type > $o ).

tff(pred_def_23035,type,
    v42063: state_type > $o ).

tff(pred_def_23036,type,
    v42061: state_type > $o ).

tff(pred_def_23037,type,
    v42067: state_type > $o ).

tff(pred_def_23038,type,
    v42065: state_type > $o ).

tff(pred_def_23039,type,
    v42070: state_type > $o ).

tff(pred_def_23040,type,
    v42069: state_type > $o ).

tff(pred_def_23041,type,
    v42049: state_type > $o ).

tff(pred_def_23042,type,
    v42047: state_type > $o ).

tff(pred_def_23043,type,
    v42045: state_type > $o ).

tff(pred_def_23044,type,
    v42043: state_type > $o ).

tff(pred_def_23045,type,
    v42041: state_type > $o ).

tff(pred_def_23046,type,
    v42078: state_type > $o ).

tff(pred_def_23047,type,
    v42076: state_type > $o ).

tff(pred_def_23048,type,
    v42074: state_type > $o ).

tff(pred_def_23049,type,
    v42072: state_type > $o ).

tff(pred_def_23050,type,
    v42035: state_type > $o ).

tff(pred_def_23051,type,
    v42084: state_type > $o ).

tff(pred_def_23052,type,
    v42086: state_type > $o ).

tff(pred_def_23053,type,
    v42082: state_type > $o ).

tff(pred_def_23054,type,
    v42081: state_type > $o ).

tff(pred_def_23055,type,
    v42092: state_type > $o ).

tff(pred_def_23056,type,
    v42093: state_type > $o ).

tff(pred_def_23057,type,
    v42089: state_type > $o ).

tff(pred_def_23058,type,
    v42091: state_type > $o ).

tff(pred_def_23059,type,
    v42103: state_type > $o ).

tff(pred_def_23060,type,
    v42101: state_type > $o ).

tff(pred_def_23061,type,
    v42099: state_type > $o ).

tff(pred_def_23062,type,
    v42097: state_type > $o ).

tff(pred_def_23063,type,
    v42105: state_type > $o ).

tff(pred_def_23064,type,
    v42027: state_type > $o ).

tff(pred_def_23065,type,
    v42025: state_type > $o ).

tff(pred_def_23066,type,
    v42023: state_type > $o ).

tff(pred_def_23067,type,
    v42112: state_type > $o ).

tff(pred_def_23068,type,
    v42110: state_type > $o ).

tff(pred_def_23069,type,
    v42109: state_type > $o ).

tff(pred_def_23070,type,
    v42108: state_type > $o ).

tff(pred_def_23071,type,
    v42120: state_type > $o ).

tff(pred_def_23072,type,
    v42121: state_type > $o ).

tff(pred_def_23073,type,
    v42119: state_type > $o ).

tff(pred_def_23074,type,
    v42116: ( state_type * $int ) > $o ).

tff(pred_def_23075,type,
    v42118: ( state_type * $int ) > $o ).

tff(pred_def_23076,type,
    v41663: ( state_type * $int ) > $o ).

tff(pred_def_23077,type,
    v41661: ( state_type * $int ) > $o ).

tff(pred_def_23078,type,
    v41659: ( state_type * $int ) > $o ).

tff(pred_def_23079,type,
    v41657: ( state_type * $int ) > $o ).

tff(pred_def_23080,type,
    v41655: ( state_type * $int ) > $o ).

tff(pred_def_23081,type,
    v42157: state_type > $o ).

tff(pred_def_23082,type,
    v42155: state_type > $o ).

tff(pred_def_23083,type,
    v42153: state_type > $o ).

tff(pred_def_23084,type,
    v42151: state_type > $o ).

tff(pred_def_23085,type,
    v42149: state_type > $o ).

tff(pred_def_23086,type,
    v42147: state_type > $o ).

tff(pred_def_23087,type,
    v42167: state_type > $o ).

tff(pred_def_23088,type,
    v42165: state_type > $o ).

tff(pred_def_23089,type,
    v42163: state_type > $o ).

tff(pred_def_23090,type,
    v42161: state_type > $o ).

tff(pred_def_23091,type,
    v42159: state_type > $o ).

tff(pred_def_23092,type,
    v42194: state_type > $o ).

tff(pred_def_23093,type,
    v42193: ( state_type * $int ) > $o ).

tff(pred_def_23094,type,
    v42192: ( state_type * $int ) > $o ).

tff(pred_def_23095,type,
    v42190: ( state_type * $int ) > $o ).

tff(pred_def_23096,type,
    v42210: state_type > $o ).

tff(pred_def_23097,type,
    v42211: ( state_type * $int ) > $o ).

tff(pred_def_23098,type,
    v42212: state_type > $o ).

tff(pred_def_23099,type,
    v42208: ( state_type * $int ) > $o ).

tff(pred_def_23100,type,
    v42206: ( state_type * $int ) > $o ).

tff(pred_def_23101,type,
    v42236: ( state_type * $int ) > $o ).

tff(pred_def_23102,type,
    v42145: ( state_type * $int ) > $o ).

tff(pred_def_23103,type,
    v42234: ( state_type * $int ) > $o ).

tff(pred_def_23104,type,
    v42237: ( state_type * $int ) > $o ).

tff(pred_def_23105,type,
    v42232: ( state_type * $int ) > $o ).

tff(pred_def_23106,type,
    v42230: ( state_type * $int ) > $o ).

tff(pred_def_23107,type,
    v42228: ( state_type * $int ) > $o ).

tff(pred_def_23108,type,
    v42226: state_type > $o ).

tff(pred_def_23109,type,
    v42224: state_type > $o ).

tff(pred_def_23110,type,
    v42243: state_type > $o ).

tff(pred_def_23111,type,
    v42183: state_type > $o ).

tff(pred_def_23112,type,
    v42242: ( state_type * $int ) > $o ).

tff(pred_def_23113,type,
    v42181: ( state_type * $int ) > $o ).

tff(pred_def_23114,type,
    v42179: ( state_type * $int ) > $o ).

tff(pred_def_23115,type,
    v42258: ( state_type * $int ) > $o ).

tff(pred_def_23116,type,
    v42257: ( state_type * $int ) > $o ).

tff(pred_def_23117,type,
    v42255: ( state_type * $int ) > $o ).

tff(pred_def_23118,type,
    v42262: state_type > $o ).

tff(pred_def_23119,type,
    v42260: state_type > $o ).

tff(pred_def_23120,type,
    v42273: ( state_type * $int ) > $o ).

tff(pred_def_23121,type,
    v42272: state_type > $o ).

tff(pred_def_23122,type,
    v42276: state_type > $o ).

tff(pred_def_23123,type,
    v42277: state_type > $o ).

tff(pred_def_23124,type,
    v42275: state_type > $o ).

tff(pred_def_23125,type,
    v42278: state_type > $o ).

tff(pred_def_23126,type,
    v42274: state_type > $o ).

tff(pred_def_23127,type,
    v42271: state_type > $o ).

tff(pred_def_23128,type,
    v42279: state_type > $o ).

tff(pred_def_23129,type,
    v42270: state_type > $o ).

tff(pred_def_23130,type,
    v42282: state_type > $o ).

tff(pred_def_23131,type,
    v42283: state_type > $o ).

tff(pred_def_23132,type,
    v42281: state_type > $o ).

tff(pred_def_23133,type,
    v42284: state_type > $o ).

tff(pred_def_23134,type,
    v42280: state_type > $o ).

tff(pred_def_23135,type,
    v42269: state_type > $o ).

tff(pred_def_23136,type,
    v42285: state_type > $o ).

tff(pred_def_23137,type,
    v42268: state_type > $o ).

tff(pred_def_23138,type,
    v42267: state_type > $o ).

tff(pred_def_23139,type,
    v42289: state_type > $o ).

tff(pred_def_23140,type,
    v42290: state_type > $o ).

tff(pred_def_23141,type,
    v42288: state_type > $o ).

tff(pred_def_23142,type,
    v42291: state_type > $o ).

tff(pred_def_23143,type,
    v42287: state_type > $o ).

tff(pred_def_23144,type,
    v42286: state_type > $o ).

tff(pred_def_23145,type,
    v42266: state_type > $o ).

tff(pred_def_23146,type,
    v42292: state_type > $o ).

tff(pred_def_23147,type,
    v42265: state_type > $o ).

tff(pred_def_23148,type,
    v42295: state_type > $o ).

tff(pred_def_23149,type,
    v42296: state_type > $o ).

tff(pred_def_23150,type,
    v42294: state_type > $o ).

tff(pred_def_23151,type,
    v42297: state_type > $o ).

tff(pred_def_23152,type,
    v42293: state_type > $o ).

tff(pred_def_23153,type,
    v42300: state_type > $o ).

tff(pred_def_23154,type,
    v42301: state_type > $o ).

tff(pred_def_23155,type,
    v42299: state_type > $o ).

tff(pred_def_23156,type,
    v42302: state_type > $o ).

tff(pred_def_23157,type,
    v42298: state_type > $o ).

tff(pred_def_23158,type,
    v42305: state_type > $o ).

tff(pred_def_23159,type,
    v42306: state_type > $o ).

tff(pred_def_23160,type,
    v42304: state_type > $o ).

tff(pred_def_23161,type,
    v42307: state_type > $o ).

tff(pred_def_23162,type,
    v42303: state_type > $o ).

tff(pred_def_23163,type,
    v42263: ( state_type * $int ) > $o ).

tff(pred_def_23164,type,
    v42253: ( state_type * $int ) > $o ).

tff(pred_def_23165,type,
    v42251: ( state_type * $int ) > $o ).

tff(pred_def_23166,type,
    v42249: ( state_type * $int ) > $o ).

tff(pred_def_23167,type,
    v42247: ( state_type * $int ) > $o ).

tff(pred_def_23168,type,
    v42245: ( state_type * $int ) > $o ).

tff(pred_def_23169,type,
    v42308: ( state_type * $int ) > $o ).

tff(pred_def_23170,type,
    v42177: ( state_type * $int ) > $o ).

tff(pred_def_23171,type,
    v42175: ( state_type * $int ) > $o ).

tff(pred_def_23172,type,
    v42173: ( state_type * $int ) > $o ).

tff(pred_def_23173,type,
    v42309: ( state_type * $int ) > $o ).

tff(pred_def_23174,type,
    v42310: ( state_type * $int ) > $o ).

tff(pred_def_23175,type,
    v42171: ( state_type * $int ) > $o ).

tff(pred_def_23176,type,
    v42169: ( state_type * $int ) > $o ).

tff(pred_def_23177,type,
    v42320: state_type > $o ).

tff(pred_def_23178,type,
    v42318: state_type > $o ).

tff(pred_def_23179,type,
    v42326: state_type > $o ).

tff(pred_def_23180,type,
    v42324: state_type > $o ).

tff(pred_def_23181,type,
    v42330: state_type > $o ).

tff(pred_def_23182,type,
    v42328: state_type > $o ).

tff(pred_def_23183,type,
    v42334: state_type > $o ).

tff(pred_def_23184,type,
    v42332: state_type > $o ).

tff(pred_def_23185,type,
    v42322: state_type > $o ).

tff(pred_def_23186,type,
    v42340: state_type > $o ).

tff(pred_def_23187,type,
    v42342: state_type > $o ).

tff(pred_def_23188,type,
    v42338: state_type > $o ).

tff(pred_def_23189,type,
    v42337: state_type > $o ).

tff(pred_def_23190,type,
    v42348: state_type > $o ).

tff(pred_def_23191,type,
    v42349: state_type > $o ).

tff(pred_def_23192,type,
    v42345: state_type > $o ).

tff(pred_def_23193,type,
    v42347: state_type > $o ).

tff(pred_def_23194,type,
    v42355: state_type > $o ).

tff(pred_def_23195,type,
    v42353: state_type > $o ).

tff(pred_def_23196,type,
    v42357: state_type > $o ).

tff(pred_def_23197,type,
    v42316: state_type > $o ).

tff(pred_def_23198,type,
    v42314: state_type > $o ).

tff(pred_def_23199,type,
    v42312: state_type > $o ).

tff(pred_def_23200,type,
    v42364: state_type > $o ).

tff(pred_def_23201,type,
    v42362: state_type > $o ).

tff(pred_def_23202,type,
    v42361: state_type > $o ).

tff(pred_def_23203,type,
    v42360: state_type > $o ).

tff(pred_def_23204,type,
    v42372: state_type > $o ).

tff(pred_def_23205,type,
    v42373: state_type > $o ).

tff(pred_def_23206,type,
    v42371: state_type > $o ).

tff(pred_def_23207,type,
    v42368: ( state_type * $int ) > $o ).

tff(pred_def_23208,type,
    v42370: ( state_type * $int ) > $o ).

tff(pred_def_23209,type,
    v42359: ( state_type * $int ) > $o ).

tff(pred_def_23210,type,
    v42241: state_type > $o ).

tff(pred_def_23211,type,
    v42239: state_type > $o ).

tff(pred_def_23212,type,
    v42385: state_type > $o ).

tff(pred_def_23213,type,
    v42383: state_type > $o ).

tff(pred_def_23214,type,
    v42382: state_type > $o ).

tff(pred_def_23215,type,
    v42381: ( state_type * $int ) > $o ).

tff(pred_def_23216,type,
    v42379: state_type > $o ).

tff(pred_def_23217,type,
    v42377: state_type > $o ).

tff(pred_def_23218,type,
    v42390: state_type > $o ).

tff(pred_def_23219,type,
    v42389: state_type > $o ).

tff(pred_def_23220,type,
    v42222: state_type > $o ).

tff(pred_def_23221,type,
    v42220: state_type > $o ).

tff(pred_def_23222,type,
    v42218: state_type > $o ).

tff(pred_def_23223,type,
    v42391: ( state_type * $int ) > $o ).

tff(pred_def_23224,type,
    v42392: state_type > $o ).

tff(pred_def_23225,type,
    v42216: ( state_type * $int ) > $o ).

tff(pred_def_23226,type,
    v42214: ( state_type * $int ) > $o ).

tff(pred_def_23227,type,
    v42393: ( state_type * $int ) > $o ).

tff(pred_def_23228,type,
    v42204: ( state_type * $int ) > $o ).

tff(pred_def_23229,type,
    v42202: ( state_type * $int ) > $o ).

tff(pred_def_23230,type,
    v42200: state_type > $o ).

tff(pred_def_23231,type,
    v42394: ( state_type * $int ) > $o ).

tff(pred_def_23232,type,
    v42395: state_type > $o ).

tff(pred_def_23233,type,
    v42198: ( state_type * $int ) > $o ).

tff(pred_def_23234,type,
    v42196: ( state_type * $int ) > $o ).

tff(pred_def_23235,type,
    v42396: ( state_type * $int ) > $o ).

tff(pred_def_23236,type,
    v42188: ( state_type * $int ) > $o ).

tff(pred_def_23237,type,
    v42186: ( state_type * $int ) > $o ).

tff(pred_def_23238,type,
    v42402: state_type > $o ).

tff(pred_def_23239,type,
    v42400: state_type > $o ).

tff(pred_def_23240,type,
    v42399: state_type > $o ).

tff(pred_def_23241,type,
    v42398: ( state_type * $int ) > $o ).

tff(pred_def_23242,type,
    v42143: state_type > $o ).

tff(pred_def_23243,type,
    v42141: state_type > $o ).

tff(pred_def_23244,type,
    v42408: state_type > $o ).

tff(pred_def_23245,type,
    v42406: state_type > $o ).

tff(pred_def_23246,type,
    v42412: state_type > $o ).

tff(pred_def_23247,type,
    v42410: state_type > $o ).

tff(pred_def_23248,type,
    v42415: state_type > $o ).

tff(pred_def_23249,type,
    v42414: state_type > $o ).

tff(pred_def_23250,type,
    v42139: state_type > $o ).

tff(pred_def_23251,type,
    v42137: state_type > $o ).

tff(pred_def_23252,type,
    v42135: state_type > $o ).

tff(pred_def_23253,type,
    v42133: state_type > $o ).

tff(pred_def_23254,type,
    v42131: state_type > $o ).

tff(pred_def_23255,type,
    v42129: state_type > $o ).

tff(pred_def_23256,type,
    v42127: state_type > $o ).

tff(pred_def_23257,type,
    v42125: state_type > $o ).

tff(pred_def_23258,type,
    v42435: state_type > $o ).

tff(pred_def_23259,type,
    v42433: state_type > $o ).

tff(pred_def_23260,type,
    v42431: state_type > $o ).

tff(pred_def_23261,type,
    v42429: state_type > $o ).

tff(pred_def_23262,type,
    v42427: state_type > $o ).

tff(pred_def_23263,type,
    v42445: state_type > $o ).

tff(pred_def_23264,type,
    v42443: state_type > $o ).

tff(pred_def_23265,type,
    v42441: state_type > $o ).

tff(pred_def_23266,type,
    v42439: state_type > $o ).

tff(pred_def_23267,type,
    v42437: state_type > $o ).

tff(pred_def_23268,type,
    v42449: ( state_type * $int ) > $o ).

tff(pred_def_23269,type,
    v42447: ( state_type * $int ) > $o ).

tff(pred_def_23270,type,
    v42459: state_type > $o ).

tff(pred_def_23271,type,
    v42457: state_type > $o ).

tff(pred_def_23272,type,
    v42465: state_type > $o ).

tff(pred_def_23273,type,
    v42463: state_type > $o ).

tff(pred_def_23274,type,
    v42489: ( state_type * $int ) > $o ).

tff(pred_def_23275,type,
    v42487: ( state_type * $int ) > $o ).

tff(pred_def_23276,type,
    v42490: ( state_type * $int ) > $o ).

tff(pred_def_23277,type,
    v42485: ( state_type * $int ) > $o ).

tff(pred_def_23278,type,
    v42483: ( state_type * $int ) > $o ).

tff(pred_def_23279,type,
    v42481: ( state_type * $int ) > $o ).

tff(pred_def_23280,type,
    v42479: state_type > $o ).

tff(pred_def_23281,type,
    v42477: state_type > $o ).

tff(pred_def_23282,type,
    v42494: state_type > $o ).

tff(pred_def_23283,type,
    v42492: state_type > $o ).

tff(pred_def_23284,type,
    v42498: state_type > $o ).

tff(pred_def_23285,type,
    v42496: state_type > $o ).

tff(pred_def_23286,type,
    v42501: state_type > $o ).

tff(pred_def_23287,type,
    v42500: state_type > $o ).

tff(pred_def_23288,type,
    v42475: state_type > $o ).

tff(pred_def_23289,type,
    v42473: state_type > $o ).

tff(pred_def_23290,type,
    v42471: state_type > $o ).

tff(pred_def_23291,type,
    v42469: state_type > $o ).

tff(pred_def_23292,type,
    v42467: state_type > $o ).

tff(pred_def_23293,type,
    v42505: state_type > $o ).

tff(pred_def_23294,type,
    v42503: state_type > $o ).

tff(pred_def_23295,type,
    v42461: state_type > $o ).

tff(pred_def_23296,type,
    v42511: state_type > $o ).

tff(pred_def_23297,type,
    v42513: state_type > $o ).

tff(pred_def_23298,type,
    v42509: state_type > $o ).

tff(pred_def_23299,type,
    v42508: state_type > $o ).

tff(pred_def_23300,type,
    v42519: state_type > $o ).

tff(pred_def_23301,type,
    v42520: state_type > $o ).

tff(pred_def_23302,type,
    v42516: state_type > $o ).

tff(pred_def_23303,type,
    v42518: state_type > $o ).

tff(pred_def_23304,type,
    v42526: state_type > $o ).

tff(pred_def_23305,type,
    v42524: state_type > $o ).

tff(pred_def_23306,type,
    v42528: state_type > $o ).

tff(pred_def_23307,type,
    v42455: state_type > $o ).

tff(pred_def_23308,type,
    v42453: state_type > $o ).

tff(pred_def_23309,type,
    v42451: state_type > $o ).

tff(pred_def_23310,type,
    v42535: state_type > $o ).

tff(pred_def_23311,type,
    v42533: state_type > $o ).

tff(pred_def_23312,type,
    v42532: state_type > $o ).

tff(pred_def_23313,type,
    v42531: state_type > $o ).

tff(pred_def_23314,type,
    v42543: state_type > $o ).

tff(pred_def_23315,type,
    v42544: state_type > $o ).

tff(pred_def_23316,type,
    v42542: state_type > $o ).

tff(pred_def_23317,type,
    v42539: ( state_type * $int ) > $o ).

tff(pred_def_23318,type,
    v42541: ( state_type * $int ) > $o ).

tff(pred_def_23319,type,
    v42425: ( state_type * $int ) > $o ).

tff(pred_def_23320,type,
    v42423: ( state_type * $int ) > $o ).

tff(pred_def_23321,type,
    v42421: ( state_type * $int ) > $o ).

tff(pred_def_23322,type,
    v42419: ( state_type * $int ) > $o ).

tff(pred_def_23323,type,
    v42417: ( state_type * $int ) > $o ).

tff(pred_def_23324,type,
    v42566: state_type > $o ).

tff(pred_def_23325,type,
    v42564: state_type > $o ).

tff(pred_def_23326,type,
    v42570: state_type > $o ).

tff(pred_def_23327,type,
    v42568: state_type > $o ).

tff(pred_def_23328,type,
    v42574: state_type > $o ).

tff(pred_def_23329,type,
    v42572: state_type > $o ).

tff(pred_def_23330,type,
    v42577: state_type > $o ).

tff(pred_def_23331,type,
    v42576: state_type > $o ).

tff(pred_def_23332,type,
    v42562: state_type > $o ).

tff(pred_def_23333,type,
    v42560: state_type > $o ).

tff(pred_def_23334,type,
    v42558: state_type > $o ).

tff(pred_def_23335,type,
    v42556: state_type > $o ).

tff(pred_def_23336,type,
    v42554: state_type > $o ).

tff(pred_def_23337,type,
    v42552: state_type > $o ).

tff(pred_def_23338,type,
    v42550: state_type > $o ).

tff(pred_def_23339,type,
    v42548: state_type > $o ).

tff(pred_def_23340,type,
    v42597: state_type > $o ).

tff(pred_def_23341,type,
    v42595: state_type > $o ).

tff(pred_def_23342,type,
    v42593: state_type > $o ).

tff(pred_def_23343,type,
    v42591: state_type > $o ).

tff(pred_def_23344,type,
    v42589: state_type > $o ).

tff(pred_def_23345,type,
    v42607: state_type > $o ).

tff(pred_def_23346,type,
    v42605: state_type > $o ).

tff(pred_def_23347,type,
    v42603: state_type > $o ).

tff(pred_def_23348,type,
    v42601: state_type > $o ).

tff(pred_def_23349,type,
    v42599: state_type > $o ).

tff(pred_def_23350,type,
    v42611: ( state_type * $int ) > $o ).

tff(pred_def_23351,type,
    v42609: ( state_type * $int ) > $o ).

tff(pred_def_23352,type,
    v42621: state_type > $o ).

tff(pred_def_23353,type,
    v42619: state_type > $o ).

tff(pred_def_23354,type,
    v42627: state_type > $o ).

tff(pred_def_23355,type,
    v42625: state_type > $o ).

tff(pred_def_23356,type,
    v42641: state_type > $o ).

tff(pred_def_23357,type,
    v42639: state_type > $o ).

tff(pred_def_23358,type,
    v42645: state_type > $o ).

tff(pred_def_23359,type,
    v42643: state_type > $o ).

tff(pred_def_23360,type,
    v42649: state_type > $o ).

tff(pred_def_23361,type,
    v42647: state_type > $o ).

tff(pred_def_23362,type,
    v42652: state_type > $o ).

tff(pred_def_23363,type,
    v42651: state_type > $o ).

tff(pred_def_23364,type,
    v42637: state_type > $o ).

tff(pred_def_23365,type,
    v42635: state_type > $o ).

tff(pred_def_23366,type,
    v42633: state_type > $o ).

tff(pred_def_23367,type,
    v42631: state_type > $o ).

tff(pred_def_23368,type,
    v42629: state_type > $o ).

tff(pred_def_23369,type,
    v42656: state_type > $o ).

tff(pred_def_23370,type,
    v42654: state_type > $o ).

tff(pred_def_23371,type,
    v42623: state_type > $o ).

tff(pred_def_23372,type,
    v42662: state_type > $o ).

tff(pred_def_23373,type,
    v42664: state_type > $o ).

tff(pred_def_23374,type,
    v42660: state_type > $o ).

tff(pred_def_23375,type,
    v42659: state_type > $o ).

tff(pred_def_23376,type,
    v42670: state_type > $o ).

tff(pred_def_23377,type,
    v42671: state_type > $o ).

tff(pred_def_23378,type,
    v42667: state_type > $o ).

tff(pred_def_23379,type,
    v42669: state_type > $o ).

tff(pred_def_23380,type,
    v42677: state_type > $o ).

tff(pred_def_23381,type,
    v42675: state_type > $o ).

tff(pred_def_23382,type,
    v42679: state_type > $o ).

tff(pred_def_23383,type,
    v42617: state_type > $o ).

tff(pred_def_23384,type,
    v42615: state_type > $o ).

tff(pred_def_23385,type,
    v42613: state_type > $o ).

tff(pred_def_23386,type,
    v42686: state_type > $o ).

tff(pred_def_23387,type,
    v42684: state_type > $o ).

tff(pred_def_23388,type,
    v42683: state_type > $o ).

tff(pred_def_23389,type,
    v42682: state_type > $o ).

tff(pred_def_23390,type,
    v42694: state_type > $o ).

tff(pred_def_23391,type,
    v42695: state_type > $o ).

tff(pred_def_23392,type,
    v42693: state_type > $o ).

tff(pred_def_23393,type,
    v42690: ( state_type * $int ) > $o ).

tff(pred_def_23394,type,
    v42692: ( state_type * $int ) > $o ).

tff(pred_def_23395,type,
    v42587: ( state_type * $int ) > $o ).

tff(pred_def_23396,type,
    v42585: ( state_type * $int ) > $o ).

tff(pred_def_23397,type,
    v42583: ( state_type * $int ) > $o ).

tff(pred_def_23398,type,
    v42581: ( state_type * $int ) > $o ).

tff(pred_def_23399,type,
    v42579: ( state_type * $int ) > $o ).

tff(pred_def_23400,type,
    v42717: state_type > $o ).

tff(pred_def_23401,type,
    v42715: state_type > $o ).

tff(pred_def_23402,type,
    v42721: state_type > $o ).

tff(pred_def_23403,type,
    v42719: state_type > $o ).

tff(pred_def_23404,type,
    v42725: state_type > $o ).

tff(pred_def_23405,type,
    v42723: state_type > $o ).

tff(pred_def_23406,type,
    v42728: state_type > $o ).

tff(pred_def_23407,type,
    v42727: state_type > $o ).

tff(pred_def_23408,type,
    v42713: state_type > $o ).

tff(pred_def_23409,type,
    v42711: state_type > $o ).

tff(pred_def_23410,type,
    v42709: state_type > $o ).

tff(pred_def_23411,type,
    v42707: state_type > $o ).

tff(pred_def_23412,type,
    v42705: state_type > $o ).

tff(pred_def_23413,type,
    v42703: state_type > $o ).

tff(pred_def_23414,type,
    v42701: state_type > $o ).

tff(pred_def_23415,type,
    v42699: state_type > $o ).

tff(pred_def_23416,type,
    v42748: state_type > $o ).

tff(pred_def_23417,type,
    v42746: state_type > $o ).

tff(pred_def_23418,type,
    v42744: state_type > $o ).

tff(pred_def_23419,type,
    v42742: state_type > $o ).

tff(pred_def_23420,type,
    v42740: state_type > $o ).

tff(pred_def_23421,type,
    v42758: state_type > $o ).

tff(pred_def_23422,type,
    v42756: state_type > $o ).

tff(pred_def_23423,type,
    v42754: state_type > $o ).

tff(pred_def_23424,type,
    v42752: state_type > $o ).

tff(pred_def_23425,type,
    v42750: state_type > $o ).

tff(pred_def_23426,type,
    v42762: ( state_type * $int ) > $o ).

tff(pred_def_23427,type,
    v42760: ( state_type * $int ) > $o ).

tff(pred_def_23428,type,
    v42772: state_type > $o ).

tff(pred_def_23429,type,
    v42770: state_type > $o ).

tff(pred_def_23430,type,
    v42778: state_type > $o ).

tff(pred_def_23431,type,
    v42776: state_type > $o ).

tff(pred_def_23432,type,
    v42792: state_type > $o ).

tff(pred_def_23433,type,
    v42790: state_type > $o ).

tff(pred_def_23434,type,
    v42796: state_type > $o ).

tff(pred_def_23435,type,
    v42794: state_type > $o ).

tff(pred_def_23436,type,
    v42800: state_type > $o ).

tff(pred_def_23437,type,
    v42798: state_type > $o ).

tff(pred_def_23438,type,
    v42803: state_type > $o ).

tff(pred_def_23439,type,
    v42802: state_type > $o ).

tff(pred_def_23440,type,
    v42788: state_type > $o ).

tff(pred_def_23441,type,
    v42786: state_type > $o ).

tff(pred_def_23442,type,
    v42784: state_type > $o ).

tff(pred_def_23443,type,
    v42782: state_type > $o ).

tff(pred_def_23444,type,
    v42780: state_type > $o ).

tff(pred_def_23445,type,
    v42807: state_type > $o ).

tff(pred_def_23446,type,
    v42805: state_type > $o ).

tff(pred_def_23447,type,
    v42774: state_type > $o ).

tff(pred_def_23448,type,
    v42813: state_type > $o ).

tff(pred_def_23449,type,
    v42815: state_type > $o ).

tff(pred_def_23450,type,
    v42811: state_type > $o ).

tff(pred_def_23451,type,
    v42810: state_type > $o ).

tff(pred_def_23452,type,
    v42821: state_type > $o ).

tff(pred_def_23453,type,
    v42822: state_type > $o ).

tff(pred_def_23454,type,
    v42818: state_type > $o ).

tff(pred_def_23455,type,
    v42820: state_type > $o ).

tff(pred_def_23456,type,
    v42828: state_type > $o ).

tff(pred_def_23457,type,
    v42826: state_type > $o ).

tff(pred_def_23458,type,
    v42830: state_type > $o ).

tff(pred_def_23459,type,
    v42768: state_type > $o ).

tff(pred_def_23460,type,
    v42766: state_type > $o ).

tff(pred_def_23461,type,
    v42764: state_type > $o ).

tff(pred_def_23462,type,
    v42837: state_type > $o ).

tff(pred_def_23463,type,
    v42835: state_type > $o ).

tff(pred_def_23464,type,
    v42834: state_type > $o ).

tff(pred_def_23465,type,
    v42833: state_type > $o ).

tff(pred_def_23466,type,
    v42845: state_type > $o ).

tff(pred_def_23467,type,
    v42846: state_type > $o ).

tff(pred_def_23468,type,
    v42844: state_type > $o ).

tff(pred_def_23469,type,
    v42841: ( state_type * $int ) > $o ).

tff(pred_def_23470,type,
    v42843: ( state_type * $int ) > $o ).

tff(pred_def_23471,type,
    v42738: ( state_type * $int ) > $o ).

tff(pred_def_23472,type,
    v42736: ( state_type * $int ) > $o ).

tff(pred_def_23473,type,
    v42734: ( state_type * $int ) > $o ).

tff(pred_def_23474,type,
    v42732: ( state_type * $int ) > $o ).

tff(pred_def_23475,type,
    v42730: ( state_type * $int ) > $o ).

tff(pred_def_23476,type,
    v42868: state_type > $o ).

tff(pred_def_23477,type,
    v42866: state_type > $o ).

tff(pred_def_23478,type,
    v42872: state_type > $o ).

tff(pred_def_23479,type,
    v42870: state_type > $o ).

tff(pred_def_23480,type,
    v42876: state_type > $o ).

tff(pred_def_23481,type,
    v42874: state_type > $o ).

tff(pred_def_23482,type,
    v42879: state_type > $o ).

tff(pred_def_23483,type,
    v42878: state_type > $o ).

tff(pred_def_23484,type,
    v42864: state_type > $o ).

tff(pred_def_23485,type,
    v42862: state_type > $o ).

tff(pred_def_23486,type,
    v42860: state_type > $o ).

tff(pred_def_23487,type,
    v42858: state_type > $o ).

tff(pred_def_23488,type,
    v42856: state_type > $o ).

tff(pred_def_23489,type,
    v42854: state_type > $o ).

tff(pred_def_23490,type,
    v42852: state_type > $o ).

tff(pred_def_23491,type,
    v42850: state_type > $o ).

tff(pred_def_23492,type,
    v42899: state_type > $o ).

tff(pred_def_23493,type,
    v42897: state_type > $o ).

tff(pred_def_23494,type,
    v42895: state_type > $o ).

tff(pred_def_23495,type,
    v42893: state_type > $o ).

tff(pred_def_23496,type,
    v42891: state_type > $o ).

tff(pred_def_23497,type,
    v42909: state_type > $o ).

tff(pred_def_23498,type,
    v42907: state_type > $o ).

tff(pred_def_23499,type,
    v42905: state_type > $o ).

tff(pred_def_23500,type,
    v42903: state_type > $o ).

tff(pred_def_23501,type,
    v42901: state_type > $o ).

tff(pred_def_23502,type,
    v42913: ( state_type * $int ) > $o ).

tff(pred_def_23503,type,
    v42911: ( state_type * $int ) > $o ).

tff(pred_def_23504,type,
    v42923: state_type > $o ).

tff(pred_def_23505,type,
    v42921: state_type > $o ).

tff(pred_def_23506,type,
    v42929: state_type > $o ).

tff(pred_def_23507,type,
    v42927: state_type > $o ).

tff(pred_def_23508,type,
    v42943: state_type > $o ).

tff(pred_def_23509,type,
    v42941: state_type > $o ).

tff(pred_def_23510,type,
    v42947: state_type > $o ).

tff(pred_def_23511,type,
    v42945: state_type > $o ).

tff(pred_def_23512,type,
    v42951: state_type > $o ).

tff(pred_def_23513,type,
    v42949: state_type > $o ).

tff(pred_def_23514,type,
    v42954: state_type > $o ).

tff(pred_def_23515,type,
    v42953: state_type > $o ).

tff(pred_def_23516,type,
    v42939: state_type > $o ).

tff(pred_def_23517,type,
    v42937: state_type > $o ).

tff(pred_def_23518,type,
    v42935: state_type > $o ).

tff(pred_def_23519,type,
    v42933: state_type > $o ).

tff(pred_def_23520,type,
    v42931: state_type > $o ).

tff(pred_def_23521,type,
    v42958: state_type > $o ).

tff(pred_def_23522,type,
    v42956: state_type > $o ).

tff(pred_def_23523,type,
    v42925: state_type > $o ).

tff(pred_def_23524,type,
    v42964: state_type > $o ).

tff(pred_def_23525,type,
    v42966: state_type > $o ).

tff(pred_def_23526,type,
    v42962: state_type > $o ).

tff(pred_def_23527,type,
    v42961: state_type > $o ).

tff(pred_def_23528,type,
    v42972: state_type > $o ).

tff(pred_def_23529,type,
    v42973: state_type > $o ).

tff(pred_def_23530,type,
    v42969: state_type > $o ).

tff(pred_def_23531,type,
    v42971: state_type > $o ).

tff(pred_def_23532,type,
    v42979: state_type > $o ).

tff(pred_def_23533,type,
    v42977: state_type > $o ).

tff(pred_def_23534,type,
    v42981: state_type > $o ).

tff(pred_def_23535,type,
    v42919: state_type > $o ).

tff(pred_def_23536,type,
    v42917: state_type > $o ).

tff(pred_def_23537,type,
    v42915: state_type > $o ).

tff(pred_def_23538,type,
    v42988: state_type > $o ).

tff(pred_def_23539,type,
    v42986: state_type > $o ).

tff(pred_def_23540,type,
    v42985: state_type > $o ).

tff(pred_def_23541,type,
    v42984: state_type > $o ).

tff(pred_def_23542,type,
    v42996: state_type > $o ).

tff(pred_def_23543,type,
    v42997: state_type > $o ).

tff(pred_def_23544,type,
    v42995: state_type > $o ).

tff(pred_def_23545,type,
    v42992: ( state_type * $int ) > $o ).

tff(pred_def_23546,type,
    v42994: ( state_type * $int ) > $o ).

tff(pred_def_23547,type,
    v42889: ( state_type * $int ) > $o ).

tff(pred_def_23548,type,
    v42887: ( state_type * $int ) > $o ).

tff(pred_def_23549,type,
    v42885: ( state_type * $int ) > $o ).

tff(pred_def_23550,type,
    v42883: ( state_type * $int ) > $o ).

tff(pred_def_23551,type,
    v42881: ( state_type * $int ) > $o ).

tff(pred_def_23552,type,
    v43019: state_type > $o ).

tff(pred_def_23553,type,
    v43017: state_type > $o ).

tff(pred_def_23554,type,
    v43023: state_type > $o ).

tff(pred_def_23555,type,
    v43021: state_type > $o ).

tff(pred_def_23556,type,
    v43027: state_type > $o ).

tff(pred_def_23557,type,
    v43025: state_type > $o ).

tff(pred_def_23558,type,
    v43030: state_type > $o ).

tff(pred_def_23559,type,
    v43029: state_type > $o ).

tff(pred_def_23560,type,
    v43015: state_type > $o ).

tff(pred_def_23561,type,
    v43013: state_type > $o ).

tff(pred_def_23562,type,
    v43011: state_type > $o ).

tff(pred_def_23563,type,
    v43009: state_type > $o ).

tff(pred_def_23564,type,
    v43007: state_type > $o ).

tff(pred_def_23565,type,
    v43005: state_type > $o ).

tff(pred_def_23566,type,
    v43003: state_type > $o ).

tff(pred_def_23567,type,
    v43001: state_type > $o ).

tff(pred_def_23568,type,
    v43050: state_type > $o ).

tff(pred_def_23569,type,
    v43048: state_type > $o ).

tff(pred_def_23570,type,
    v43046: state_type > $o ).

tff(pred_def_23571,type,
    v43044: state_type > $o ).

tff(pred_def_23572,type,
    v43042: state_type > $o ).

tff(pred_def_23573,type,
    v43060: state_type > $o ).

tff(pred_def_23574,type,
    v43058: state_type > $o ).

tff(pred_def_23575,type,
    v43056: state_type > $o ).

tff(pred_def_23576,type,
    v43054: state_type > $o ).

tff(pred_def_23577,type,
    v43052: state_type > $o ).

tff(pred_def_23578,type,
    v43064: ( state_type * $int ) > $o ).

tff(pred_def_23579,type,
    v43062: ( state_type * $int ) > $o ).

tff(pred_def_23580,type,
    v43074: state_type > $o ).

tff(pred_def_23581,type,
    v43072: state_type > $o ).

tff(pred_def_23582,type,
    v43080: state_type > $o ).

tff(pred_def_23583,type,
    v43078: state_type > $o ).

tff(pred_def_23584,type,
    v43093: state_type > $o ).

tff(pred_def_23585,type,
    v43091: state_type > $o ).

tff(pred_def_23586,type,
    v43097: state_type > $o ).

tff(pred_def_23587,type,
    v43095: state_type > $o ).

tff(pred_def_23588,type,
    v43101: state_type > $o ).

tff(pred_def_23589,type,
    v43099: state_type > $o ).

tff(pred_def_23590,type,
    v43104: state_type > $o ).

tff(pred_def_23591,type,
    v43103: state_type > $o ).

tff(pred_def_23592,type,
    v43089: state_type > $o ).

tff(pred_def_23593,type,
    v43087: state_type > $o ).

tff(pred_def_23594,type,
    v43084: state_type > $o ).

tff(pred_def_23595,type,
    v43082: state_type > $o ).

tff(pred_def_23596,type,
    v43108: state_type > $o ).

tff(pred_def_23597,type,
    v43106: state_type > $o ).

tff(pred_def_23598,type,
    v43076: state_type > $o ).

tff(pred_def_23599,type,
    v43114: state_type > $o ).

tff(pred_def_23600,type,
    v43116: state_type > $o ).

tff(pred_def_23601,type,
    v43112: state_type > $o ).

tff(pred_def_23602,type,
    v43111: state_type > $o ).

tff(pred_def_23603,type,
    v43122: state_type > $o ).

tff(pred_def_23604,type,
    v43123: state_type > $o ).

tff(pred_def_23605,type,
    v43119: state_type > $o ).

tff(pred_def_23606,type,
    v43121: state_type > $o ).

tff(pred_def_23607,type,
    v43129: state_type > $o ).

tff(pred_def_23608,type,
    v43127: state_type > $o ).

tff(pred_def_23609,type,
    v43131: state_type > $o ).

tff(pred_def_23610,type,
    v43070: state_type > $o ).

tff(pred_def_23611,type,
    v43068: state_type > $o ).

tff(pred_def_23612,type,
    v43066: state_type > $o ).

tff(pred_def_23613,type,
    v43138: state_type > $o ).

tff(pred_def_23614,type,
    v43136: state_type > $o ).

tff(pred_def_23615,type,
    v43135: state_type > $o ).

tff(pred_def_23616,type,
    v43134: state_type > $o ).

tff(pred_def_23617,type,
    v43146: state_type > $o ).

tff(pred_def_23618,type,
    v43147: state_type > $o ).

tff(pred_def_23619,type,
    v43145: state_type > $o ).

tff(pred_def_23620,type,
    v43142: ( state_type * $int ) > $o ).

tff(pred_def_23621,type,
    v43144: ( state_type * $int ) > $o ).

tff(pred_def_23622,type,
    v43040: ( state_type * $int ) > $o ).

tff(pred_def_23623,type,
    v43038: ( state_type * $int ) > $o ).

tff(pred_def_23624,type,
    v43036: ( state_type * $int ) > $o ).

tff(pred_def_23625,type,
    v43034: ( state_type * $int ) > $o ).

tff(pred_def_23626,type,
    v43032: ( state_type * $int ) > $o ).

tff(pred_def_23627,type,
    v43159: state_type > $o ).

tff(pred_def_23628,type,
    v43157: state_type > $o ).

tff(pred_def_23629,type,
    v43155: state_type > $o ).

tff(pred_def_23630,type,
    v43153: state_type > $o ).

tff(pred_def_23631,type,
    v43151: state_type > $o ).

tff(pred_def_23632,type,
    v43167: state_type > $o ).

tff(pred_def_23633,type,
    v43166: ( state_type * $int ) > $o ).

tff(pred_def_23634,type,
    v43165: ( state_type * $int ) > $o ).

tff(pred_def_23635,type,
    v43170: state_type > $o ).

tff(pred_def_23636,type,
    v43169: ( state_type * $int ) > $o ).

tff(pred_def_23637,type,
    v43168: ( state_type * $int ) > $o ).

tff(pred_def_23638,type,
    v43164: ( state_type * $int ) > $o ).

tff(pred_def_23639,type,
    v43173: state_type > $o ).

tff(pred_def_23640,type,
    v43172: ( state_type * $int ) > $o ).

tff(pred_def_23641,type,
    v43171: ( state_type * $int ) > $o ).

tff(pred_def_23642,type,
    v43163: ( state_type * $int ) > $o ).

tff(pred_def_23643,type,
    v43176: state_type > $o ).

tff(pred_def_23644,type,
    v43175: ( state_type * $int ) > $o ).

tff(pred_def_23645,type,
    v43174: ( state_type * $int ) > $o ).

tff(pred_def_23646,type,
    v43162: ( state_type * $int ) > $o ).

tff(pred_def_23647,type,
    v43179: state_type > $o ).

tff(pred_def_23648,type,
    v43178: ( state_type * $int ) > $o ).

tff(pred_def_23649,type,
    v43177: ( state_type * $int ) > $o ).

tff(pred_def_23650,type,
    v43161: ( state_type * $int ) > $o ).

tff(pred_def_23651,type,
    v43182: state_type > $o ).

tff(pred_def_23652,type,
    v43181: ( state_type * $int ) > $o ).

tff(pred_def_23653,type,
    v43180: ( state_type * $int ) > $o ).

tff(pred_def_23654,type,
    v41653: ( state_type * $int ) > $o ).

tff(pred_def_23655,type,
    v41651: ( state_type * $int ) > $o ).

tff(pred_def_23656,type,
    v41649: ( state_type * $int ) > $o ).

tff(pred_def_23657,type,
    v41647: ( state_type * $int ) > $o ).

tff(pred_def_23658,type,
    v41645: ( state_type * $int ) > $o ).

tff(pred_def_23659,type,
    v41639: state_type > $o ).

tff(pred_def_23660,type,
    v41637: state_type > $o ).

tff(pred_def_23661,type,
    v41635: state_type > $o ).

tff(pred_def_23662,type,
    v43193: ( state_type * $int ) > $o ).

tff(pred_def_23663,type,
    v43191: ( state_type * $int ) > $o ).

tff(pred_def_23664,type,
    v43227: state_type > $o ).

tff(pred_def_23665,type,
    v43225: state_type > $o ).

tff(pred_def_23666,type,
    v43223: state_type > $o ).

tff(pred_def_23667,type,
    v43221: state_type > $o ).

tff(pred_def_23668,type,
    v43219: state_type > $o ).

tff(pred_def_23669,type,
    v43217: state_type > $o ).

tff(pred_def_23670,type,
    v43215: state_type > $o ).

tff(pred_def_23671,type,
    v43241: state_type > $o ).

tff(pred_def_23672,type,
    v43239: state_type > $o ).

tff(pred_def_23673,type,
    v43237: state_type > $o ).

tff(pred_def_23674,type,
    v43235: state_type > $o ).

tff(pred_def_23675,type,
    v43233: state_type > $o ).

tff(pred_def_23676,type,
    v43231: state_type > $o ).

tff(pred_def_23677,type,
    v43229: state_type > $o ).

tff(pred_def_23678,type,
    v43267: state_type > $o ).

tff(pred_def_23679,type,
    v43269: state_type > $o ).

tff(pred_def_23680,type,
    v43268: ( state_type * $int ) > $o ).

tff(pred_def_23681,type,
    v43270: state_type > $o ).

tff(pred_def_23682,type,
    v43265: ( state_type * $int ) > $o ).

tff(pred_def_23683,type,
    v43263: ( state_type * $int ) > $o ).

tff(pred_def_23684,type,
    v43271: ( state_type * $int ) > $o ).

tff(pred_def_23685,type,
    v43261: ( state_type * $int ) > $o ).

tff(pred_def_23686,type,
    v43259: ( state_type * $int ) > $o ).

tff(pred_def_23687,type,
    v43257: state_type > $o ).

tff(pred_def_23688,type,
    v43273: state_type > $o ).

tff(pred_def_23689,type,
    v43255: ( state_type * $int ) > $o ).

tff(pred_def_23690,type,
    v43253: ( state_type * $int ) > $o ).

tff(pred_def_23691,type,
    v43287: ( state_type * $int ) > $o ).

tff(pred_def_23692,type,
    v43285: ( state_type * $int ) > $o ).

tff(pred_def_23693,type,
    v43291: state_type > $o ).

tff(pred_def_23694,type,
    v43289: state_type > $o ).

tff(pred_def_23695,type,
    v43315: state_type > $o ).

tff(pred_def_23696,type,
    v43313: state_type > $o ).

tff(pred_def_23697,type,
    v43311: state_type > $o ).

tff(pred_def_23698,type,
    v43309: state_type > $o ).

tff(pred_def_23699,type,
    v43307: state_type > $o ).

tff(pred_def_23700,type,
    v43305: state_type > $o ).

tff(pred_def_23701,type,
    v43303: state_type > $o ).

tff(pred_def_23702,type,
    v43329: state_type > $o ).

tff(pred_def_23703,type,
    v43327: state_type > $o ).

tff(pred_def_23704,type,
    v43325: state_type > $o ).

tff(pred_def_23705,type,
    v43323: state_type > $o ).

tff(pred_def_23706,type,
    v43321: state_type > $o ).

tff(pred_def_23707,type,
    v43319: state_type > $o ).

tff(pred_def_23708,type,
    v43317: state_type > $o ).

tff(pred_def_23709,type,
    v43345: ( state_type * $int ) > $o ).

tff(pred_def_23710,type,
    v43343: ( state_type * $int ) > $o ).

tff(pred_def_23711,type,
    v43341: ( state_type * $int ) > $o ).

tff(pred_def_23712,type,
    v43339: ( state_type * $int ) > $o ).

tff(pred_def_23713,type,
    v43337: ( state_type * $int ) > $o ).

tff(pred_def_23714,type,
    v43375: ( state_type * $int ) > $o ).

tff(pred_def_23715,type,
    v43377: ( state_type * $int ) > $o ).

tff(pred_def_23716,type,
    v43373: ( state_type * $int ) > $o ).

tff(pred_def_23717,type,
    v43371: ( state_type * $int ) > $o ).

tff(pred_def_23718,type,
    v43369: ( state_type * $int ) > $o ).

tff(pred_def_23719,type,
    v43367: ( state_type * $int ) > $o ).

tff(pred_def_23720,type,
    v43365: state_type > $o ).

tff(pred_def_23721,type,
    v43363: state_type > $o ).

tff(pred_def_23722,type,
    v43381: state_type > $o ).

tff(pred_def_23723,type,
    v43379: state_type > $o ).

tff(pred_def_23724,type,
    v43383: state_type > $o ).

tff(pred_def_23725,type,
    v43361: state_type > $o ).

tff(pred_def_23726,type,
    v43359: state_type > $o ).

tff(pred_def_23727,type,
    v43357: state_type > $o ).

tff(pred_def_23728,type,
    v43355: state_type > $o ).

tff(pred_def_23729,type,
    v43353: state_type > $o ).

tff(pred_def_23730,type,
    v43351: state_type > $o ).

tff(pred_def_23731,type,
    v43349: state_type > $o ).

tff(pred_def_23732,type,
    v43347: state_type > $o ).

tff(pred_def_23733,type,
    v43393: ( state_type * $int ) > $o ).

tff(pred_def_23734,type,
    v43391: ( state_type * $int ) > $o ).

tff(pred_def_23735,type,
    v43389: ( state_type * $int ) > $o ).

tff(pred_def_23736,type,
    v43387: ( state_type * $int ) > $o ).

tff(pred_def_23737,type,
    v43385: ( state_type * $int ) > $o ).

tff(pred_def_23738,type,
    v43423: ( state_type * $int ) > $o ).

tff(pred_def_23739,type,
    v43421: ( state_type * $int ) > $o ).

tff(pred_def_23740,type,
    v43424: ( state_type * $int ) > $o ).

tff(pred_def_23741,type,
    v43419: ( state_type * $int ) > $o ).

tff(pred_def_23742,type,
    v43417: ( state_type * $int ) > $o ).

tff(pred_def_23743,type,
    v43415: ( state_type * $int ) > $o ).

tff(pred_def_23744,type,
    v43413: state_type > $o ).

tff(pred_def_23745,type,
    v43411: state_type > $o ).

tff(pred_def_23746,type,
    v43428: state_type > $o ).

tff(pred_def_23747,type,
    v43426: state_type > $o ).

tff(pred_def_23748,type,
    v43430: state_type > $o ).

tff(pred_def_23749,type,
    v43409: state_type > $o ).

tff(pred_def_23750,type,
    v43407: state_type > $o ).

tff(pred_def_23751,type,
    v43405: state_type > $o ).

tff(pred_def_23752,type,
    v43403: state_type > $o ).

tff(pred_def_23753,type,
    v43401: state_type > $o ).

tff(pred_def_23754,type,
    v43399: state_type > $o ).

tff(pred_def_23755,type,
    v43397: state_type > $o ).

tff(pred_def_23756,type,
    v43395: state_type > $o ).

tff(pred_def_23757,type,
    v43440: ( state_type * $int ) > $o ).

tff(pred_def_23758,type,
    v43438: ( state_type * $int ) > $o ).

tff(pred_def_23759,type,
    v43436: ( state_type * $int ) > $o ).

tff(pred_def_23760,type,
    v43434: ( state_type * $int ) > $o ).

tff(pred_def_23761,type,
    v43432: ( state_type * $int ) > $o ).

tff(pred_def_23762,type,
    v43460: state_type > $o ).

tff(pred_def_23763,type,
    v43458: state_type > $o ).

tff(pred_def_23764,type,
    v43464: state_type > $o ).

tff(pred_def_23765,type,
    v43462: state_type > $o ).

tff(pred_def_23766,type,
    v43466: state_type > $o ).

tff(pred_def_23767,type,
    v43456: state_type > $o ).

tff(pred_def_23768,type,
    v43454: state_type > $o ).

tff(pred_def_23769,type,
    v43452: state_type > $o ).

tff(pred_def_23770,type,
    v43450: state_type > $o ).

tff(pred_def_23771,type,
    v43448: state_type > $o ).

tff(pred_def_23772,type,
    v43446: state_type > $o ).

tff(pred_def_23773,type,
    v43444: state_type > $o ).

tff(pred_def_23774,type,
    v43442: state_type > $o ).

tff(pred_def_23775,type,
    v43476: ( state_type * $int ) > $o ).

tff(pred_def_23776,type,
    v43474: ( state_type * $int ) > $o ).

tff(pred_def_23777,type,
    v43472: ( state_type * $int ) > $o ).

tff(pred_def_23778,type,
    v43470: ( state_type * $int ) > $o ).

tff(pred_def_23779,type,
    v43468: ( state_type * $int ) > $o ).

tff(pred_def_23780,type,
    v43496: state_type > $o ).

tff(pred_def_23781,type,
    v43494: state_type > $o ).

tff(pred_def_23782,type,
    v43500: state_type > $o ).

tff(pred_def_23783,type,
    v43498: state_type > $o ).

tff(pred_def_23784,type,
    v43502: state_type > $o ).

tff(pred_def_23785,type,
    v43492: state_type > $o ).

tff(pred_def_23786,type,
    v43490: state_type > $o ).

tff(pred_def_23787,type,
    v43488: state_type > $o ).

tff(pred_def_23788,type,
    v43486: state_type > $o ).

tff(pred_def_23789,type,
    v43484: state_type > $o ).

tff(pred_def_23790,type,
    v43482: state_type > $o ).

tff(pred_def_23791,type,
    v43480: state_type > $o ).

tff(pred_def_23792,type,
    v43478: state_type > $o ).

tff(pred_def_23793,type,
    v43508: state_type > $o ).

tff(pred_def_23794,type,
    v43507: ( state_type * $int ) > $o ).

tff(pred_def_23795,type,
    v43506: ( state_type * $int ) > $o ).

tff(pred_def_23796,type,
    v43511: state_type > $o ).

tff(pred_def_23797,type,
    v43510: ( state_type * $int ) > $o ).

tff(pred_def_23798,type,
    v43509: ( state_type * $int ) > $o ).

tff(pred_def_23799,type,
    v43505: ( state_type * $int ) > $o ).

tff(pred_def_23800,type,
    v43514: state_type > $o ).

tff(pred_def_23801,type,
    v43513: ( state_type * $int ) > $o ).

tff(pred_def_23802,type,
    v43512: ( state_type * $int ) > $o ).

tff(pred_def_23803,type,
    v43504: ( state_type * $int ) > $o ).

tff(pred_def_23804,type,
    v43517: state_type > $o ).

tff(pred_def_23805,type,
    v43516: ( state_type * $int ) > $o ).

tff(pred_def_23806,type,
    v43515: ( state_type * $int ) > $o ).

tff(pred_def_23807,type,
    v43335: ( state_type * $int ) > $o ).

tff(pred_def_23808,type,
    v43333: ( state_type * $int ) > $o ).

tff(pred_def_23809,type,
    v43331: ( state_type * $int ) > $o ).

tff(pred_def_23810,type,
    v43529: state_type > $o ).

tff(pred_def_23811,type,
    v43527: state_type > $o ).

tff(pred_def_23812,type,
    v43525: state_type > $o ).

tff(pred_def_23813,type,
    v43539: state_type > $o ).

tff(pred_def_23814,type,
    v43537: state_type > $o ).

tff(pred_def_23815,type,
    v43535: state_type > $o ).

tff(pred_def_23816,type,
    v43533: state_type > $o ).

tff(pred_def_23817,type,
    v43531: state_type > $o ).

tff(pred_def_23818,type,
    v43541: state_type > $o ).

tff(pred_def_23819,type,
    v43523: state_type > $o ).

tff(pred_def_23820,type,
    v43521: state_type > $o ).

tff(pred_def_23821,type,
    v43519: state_type > $o ).

tff(pred_def_23822,type,
    v43548: state_type > $o ).

tff(pred_def_23823,type,
    v43546: state_type > $o ).

tff(pred_def_23824,type,
    v43545: state_type > $o ).

tff(pred_def_23825,type,
    v43544: state_type > $o ).

tff(pred_def_23826,type,
    v43556: state_type > $o ).

tff(pred_def_23827,type,
    v43557: state_type > $o ).

tff(pred_def_23828,type,
    v43555: state_type > $o ).

tff(pred_def_23829,type,
    v43552: ( state_type * $int ) > $o ).

tff(pred_def_23830,type,
    v43554: ( state_type * $int ) > $o ).

tff(pred_def_23831,type,
    v43301: ( state_type * $int ) > $o ).

tff(pred_def_23832,type,
    v43299: ( state_type * $int ) > $o ).

tff(pred_def_23833,type,
    v43297: ( state_type * $int ) > $o ).

tff(pred_def_23834,type,
    v43295: ( state_type * $int ) > $o ).

tff(pred_def_23835,type,
    v43293: ( state_type * $int ) > $o ).

tff(pred_def_23836,type,
    v43563: state_type > $o ).

tff(pred_def_23837,type,
    v43561: state_type > $o ).

tff(pred_def_23838,type,
    v43567: state_type > $o ).

tff(pred_def_23839,type,
    v43566: ( state_type * $int ) > $o ).

tff(pred_def_23840,type,
    v43565: ( state_type * $int ) > $o ).

tff(pred_def_23841,type,
    v43570: state_type > $o ).

tff(pred_def_23842,type,
    v43569: ( state_type * $int ) > $o ).

tff(pred_def_23843,type,
    v43568: ( state_type * $int ) > $o ).

tff(pred_def_23844,type,
    v43283: ( state_type * $int ) > $o ).

tff(pred_def_23845,type,
    v43281: ( state_type * $int ) > $o ).

tff(pred_def_23846,type,
    v43279: ( state_type * $int ) > $o ).

tff(pred_def_23847,type,
    v43277: ( state_type * $int ) > $o ).

tff(pred_def_23848,type,
    v43275: ( state_type * $int ) > $o ).

tff(pred_def_23849,type,
    v43251: ( state_type * $int ) > $o ).

tff(pred_def_23850,type,
    v43249: ( state_type * $int ) > $o ).

tff(pred_def_23851,type,
    v43247: ( state_type * $int ) > $o ).

tff(pred_def_23852,type,
    v43245: ( state_type * $int ) > $o ).

tff(pred_def_23853,type,
    v43243: ( state_type * $int ) > $o ).

tff(pred_def_23854,type,
    v43583: state_type > $o ).

tff(pred_def_23855,type,
    v43581: state_type > $o ).

tff(pred_def_23856,type,
    v43579: state_type > $o ).

tff(pred_def_23857,type,
    v43589: state_type > $o ).

tff(pred_def_23858,type,
    v43587: state_type > $o ).

tff(pred_def_23859,type,
    v43607: ( state_type * $int ) > $o ).

tff(pred_def_23860,type,
    v43609: ( state_type * $int ) > $o ).

tff(pred_def_23861,type,
    v43605: ( state_type * $int ) > $o ).

tff(pred_def_23862,type,
    v43603: state_type > $o ).

tff(pred_def_23863,type,
    v43601: state_type > $o ).

tff(pred_def_23864,type,
    v43613: state_type > $o ).

tff(pred_def_23865,type,
    v43611: state_type > $o ).

tff(pred_def_23866,type,
    v43617: state_type > $o ).

tff(pred_def_23867,type,
    v43615: state_type > $o ).

tff(pred_def_23868,type,
    v43620: state_type > $o ).

tff(pred_def_23869,type,
    v43619: state_type > $o ).

tff(pred_def_23870,type,
    v43599: state_type > $o ).

tff(pred_def_23871,type,
    v43597: state_type > $o ).

tff(pred_def_23872,type,
    v43595: state_type > $o ).

tff(pred_def_23873,type,
    v43593: state_type > $o ).

tff(pred_def_23874,type,
    v43591: state_type > $o ).

tff(pred_def_23875,type,
    v43628: state_type > $o ).

tff(pred_def_23876,type,
    v43626: state_type > $o ).

tff(pred_def_23877,type,
    v43624: state_type > $o ).

tff(pred_def_23878,type,
    v43622: state_type > $o ).

tff(pred_def_23879,type,
    v43585: state_type > $o ).

tff(pred_def_23880,type,
    v43634: state_type > $o ).

tff(pred_def_23881,type,
    v43636: state_type > $o ).

tff(pred_def_23882,type,
    v43632: state_type > $o ).

tff(pred_def_23883,type,
    v43631: state_type > $o ).

tff(pred_def_23884,type,
    v43642: state_type > $o ).

tff(pred_def_23885,type,
    v43643: state_type > $o ).

tff(pred_def_23886,type,
    v43639: state_type > $o ).

tff(pred_def_23887,type,
    v43641: state_type > $o ).

tff(pred_def_23888,type,
    v43653: state_type > $o ).

tff(pred_def_23889,type,
    v43651: state_type > $o ).

tff(pred_def_23890,type,
    v43649: state_type > $o ).

tff(pred_def_23891,type,
    v43647: state_type > $o ).

tff(pred_def_23892,type,
    v43655: state_type > $o ).

tff(pred_def_23893,type,
    v43577: state_type > $o ).

tff(pred_def_23894,type,
    v43575: state_type > $o ).

tff(pred_def_23895,type,
    v43573: state_type > $o ).

tff(pred_def_23896,type,
    v43662: state_type > $o ).

tff(pred_def_23897,type,
    v43660: state_type > $o ).

tff(pred_def_23898,type,
    v43659: state_type > $o ).

tff(pred_def_23899,type,
    v43658: state_type > $o ).

tff(pred_def_23900,type,
    v43670: state_type > $o ).

tff(pred_def_23901,type,
    v43671: state_type > $o ).

tff(pred_def_23902,type,
    v43669: state_type > $o ).

tff(pred_def_23903,type,
    v43666: ( state_type * $int ) > $o ).

tff(pred_def_23904,type,
    v43668: ( state_type * $int ) > $o ).

tff(pred_def_23905,type,
    v43213: ( state_type * $int ) > $o ).

tff(pred_def_23906,type,
    v43211: ( state_type * $int ) > $o ).

tff(pred_def_23907,type,
    v43209: ( state_type * $int ) > $o ).

tff(pred_def_23908,type,
    v43207: ( state_type * $int ) > $o ).

tff(pred_def_23909,type,
    v43205: ( state_type * $int ) > $o ).

tff(pred_def_23910,type,
    v43707: state_type > $o ).

tff(pred_def_23911,type,
    v43705: state_type > $o ).

tff(pred_def_23912,type,
    v43703: state_type > $o ).

tff(pred_def_23913,type,
    v43701: state_type > $o ).

tff(pred_def_23914,type,
    v43699: state_type > $o ).

tff(pred_def_23915,type,
    v43697: state_type > $o ).

tff(pred_def_23916,type,
    v43717: state_type > $o ).

tff(pred_def_23917,type,
    v43715: state_type > $o ).

tff(pred_def_23918,type,
    v43713: state_type > $o ).

tff(pred_def_23919,type,
    v43711: state_type > $o ).

tff(pred_def_23920,type,
    v43709: state_type > $o ).

tff(pred_def_23921,type,
    v43744: state_type > $o ).

tff(pred_def_23922,type,
    v43743: ( state_type * $int ) > $o ).

tff(pred_def_23923,type,
    v43742: ( state_type * $int ) > $o ).

tff(pred_def_23924,type,
    v43740: ( state_type * $int ) > $o ).

tff(pred_def_23925,type,
    v43760: state_type > $o ).

tff(pred_def_23926,type,
    v43761: ( state_type * $int ) > $o ).

tff(pred_def_23927,type,
    v43762: state_type > $o ).

tff(pred_def_23928,type,
    v43758: ( state_type * $int ) > $o ).

tff(pred_def_23929,type,
    v43756: ( state_type * $int ) > $o ).

tff(pred_def_23930,type,
    v43786: ( state_type * $int ) > $o ).

tff(pred_def_23931,type,
    v43695: ( state_type * $int ) > $o ).

tff(pred_def_23932,type,
    v43784: ( state_type * $int ) > $o ).

tff(pred_def_23933,type,
    v43787: ( state_type * $int ) > $o ).

tff(pred_def_23934,type,
    v43782: ( state_type * $int ) > $o ).

tff(pred_def_23935,type,
    v43780: ( state_type * $int ) > $o ).

tff(pred_def_23936,type,
    v43778: ( state_type * $int ) > $o ).

tff(pred_def_23937,type,
    v43776: state_type > $o ).

tff(pred_def_23938,type,
    v43774: state_type > $o ).

tff(pred_def_23939,type,
    v43793: state_type > $o ).

tff(pred_def_23940,type,
    v43733: state_type > $o ).

tff(pred_def_23941,type,
    v43792: ( state_type * $int ) > $o ).

tff(pred_def_23942,type,
    v43731: ( state_type * $int ) > $o ).

tff(pred_def_23943,type,
    v43729: ( state_type * $int ) > $o ).

tff(pred_def_23944,type,
    v43808: ( state_type * $int ) > $o ).

tff(pred_def_23945,type,
    v43807: ( state_type * $int ) > $o ).

tff(pred_def_23946,type,
    v43805: ( state_type * $int ) > $o ).

tff(pred_def_23947,type,
    v43812: state_type > $o ).

tff(pred_def_23948,type,
    v43810: state_type > $o ).

tff(pred_def_23949,type,
    v43823: ( state_type * $int ) > $o ).

tff(pred_def_23950,type,
    v43822: state_type > $o ).

tff(pred_def_23951,type,
    v43826: state_type > $o ).

tff(pred_def_23952,type,
    v43827: state_type > $o ).

tff(pred_def_23953,type,
    v43825: state_type > $o ).

tff(pred_def_23954,type,
    v43828: state_type > $o ).

tff(pred_def_23955,type,
    v43824: state_type > $o ).

tff(pred_def_23956,type,
    v43821: state_type > $o ).

tff(pred_def_23957,type,
    v43829: state_type > $o ).

tff(pred_def_23958,type,
    v43820: state_type > $o ).

tff(pred_def_23959,type,
    v43832: state_type > $o ).

tff(pred_def_23960,type,
    v43833: state_type > $o ).

tff(pred_def_23961,type,
    v43831: state_type > $o ).

tff(pred_def_23962,type,
    v43834: state_type > $o ).

tff(pred_def_23963,type,
    v43830: state_type > $o ).

tff(pred_def_23964,type,
    v43819: state_type > $o ).

tff(pred_def_23965,type,
    v43835: state_type > $o ).

tff(pred_def_23966,type,
    v43818: state_type > $o ).

tff(pred_def_23967,type,
    v43817: state_type > $o ).

tff(pred_def_23968,type,
    v43839: state_type > $o ).

tff(pred_def_23969,type,
    v43840: state_type > $o ).

tff(pred_def_23970,type,
    v43838: state_type > $o ).

tff(pred_def_23971,type,
    v43841: state_type > $o ).

tff(pred_def_23972,type,
    v43837: state_type > $o ).

tff(pred_def_23973,type,
    v43836: state_type > $o ).

tff(pred_def_23974,type,
    v43816: state_type > $o ).

tff(pred_def_23975,type,
    v43842: state_type > $o ).

tff(pred_def_23976,type,
    v43815: state_type > $o ).

tff(pred_def_23977,type,
    v43845: state_type > $o ).

tff(pred_def_23978,type,
    v43846: state_type > $o ).

tff(pred_def_23979,type,
    v43844: state_type > $o ).

tff(pred_def_23980,type,
    v43847: state_type > $o ).

tff(pred_def_23981,type,
    v43843: state_type > $o ).

tff(pred_def_23982,type,
    v43850: state_type > $o ).

tff(pred_def_23983,type,
    v43851: state_type > $o ).

tff(pred_def_23984,type,
    v43849: state_type > $o ).

tff(pred_def_23985,type,
    v43852: state_type > $o ).

tff(pred_def_23986,type,
    v43848: state_type > $o ).

tff(pred_def_23987,type,
    v43855: state_type > $o ).

tff(pred_def_23988,type,
    v43856: state_type > $o ).

tff(pred_def_23989,type,
    v43854: state_type > $o ).

tff(pred_def_23990,type,
    v43857: state_type > $o ).

tff(pred_def_23991,type,
    v43853: state_type > $o ).

tff(pred_def_23992,type,
    v43813: ( state_type * $int ) > $o ).

tff(pred_def_23993,type,
    v43803: ( state_type * $int ) > $o ).

tff(pred_def_23994,type,
    v43801: ( state_type * $int ) > $o ).

tff(pred_def_23995,type,
    v43799: ( state_type * $int ) > $o ).

tff(pred_def_23996,type,
    v43797: ( state_type * $int ) > $o ).

tff(pred_def_23997,type,
    v43795: ( state_type * $int ) > $o ).

tff(pred_def_23998,type,
    v43858: ( state_type * $int ) > $o ).

tff(pred_def_23999,type,
    v43727: ( state_type * $int ) > $o ).

tff(pred_def_24000,type,
    v43725: ( state_type * $int ) > $o ).

tff(pred_def_24001,type,
    v43723: ( state_type * $int ) > $o ).

tff(pred_def_24002,type,
    v43859: ( state_type * $int ) > $o ).

tff(pred_def_24003,type,
    v43860: ( state_type * $int ) > $o ).

tff(pred_def_24004,type,
    v43721: ( state_type * $int ) > $o ).

tff(pred_def_24005,type,
    v43719: ( state_type * $int ) > $o ).

tff(pred_def_24006,type,
    v43870: state_type > $o ).

tff(pred_def_24007,type,
    v43868: state_type > $o ).

tff(pred_def_24008,type,
    v43876: state_type > $o ).

tff(pred_def_24009,type,
    v43874: state_type > $o ).

tff(pred_def_24010,type,
    v43880: state_type > $o ).

tff(pred_def_24011,type,
    v43878: state_type > $o ).

tff(pred_def_24012,type,
    v43884: state_type > $o ).

tff(pred_def_24013,type,
    v43882: state_type > $o ).

tff(pred_def_24014,type,
    v43872: state_type > $o ).

tff(pred_def_24015,type,
    v43890: state_type > $o ).

tff(pred_def_24016,type,
    v43892: state_type > $o ).

tff(pred_def_24017,type,
    v43888: state_type > $o ).

tff(pred_def_24018,type,
    v43887: state_type > $o ).

tff(pred_def_24019,type,
    v43898: state_type > $o ).

tff(pred_def_24020,type,
    v43899: state_type > $o ).

tff(pred_def_24021,type,
    v43895: state_type > $o ).

tff(pred_def_24022,type,
    v43897: state_type > $o ).

tff(pred_def_24023,type,
    v43905: state_type > $o ).

tff(pred_def_24024,type,
    v43903: state_type > $o ).

tff(pred_def_24025,type,
    v43907: state_type > $o ).

tff(pred_def_24026,type,
    v43866: state_type > $o ).

tff(pred_def_24027,type,
    v43864: state_type > $o ).

tff(pred_def_24028,type,
    v43862: state_type > $o ).

tff(pred_def_24029,type,
    v43914: state_type > $o ).

tff(pred_def_24030,type,
    v43912: state_type > $o ).

tff(pred_def_24031,type,
    v43911: state_type > $o ).

tff(pred_def_24032,type,
    v43910: state_type > $o ).

tff(pred_def_24033,type,
    v43922: state_type > $o ).

tff(pred_def_24034,type,
    v43923: state_type > $o ).

tff(pred_def_24035,type,
    v43921: state_type > $o ).

tff(pred_def_24036,type,
    v43918: ( state_type * $int ) > $o ).

tff(pred_def_24037,type,
    v43920: ( state_type * $int ) > $o ).

tff(pred_def_24038,type,
    v43909: ( state_type * $int ) > $o ).

tff(pred_def_24039,type,
    v43791: state_type > $o ).

tff(pred_def_24040,type,
    v43789: state_type > $o ).

tff(pred_def_24041,type,
    v43935: state_type > $o ).

tff(pred_def_24042,type,
    v43933: state_type > $o ).

tff(pred_def_24043,type,
    v43932: state_type > $o ).

tff(pred_def_24044,type,
    v43931: ( state_type * $int ) > $o ).

tff(pred_def_24045,type,
    v43929: state_type > $o ).

tff(pred_def_24046,type,
    v43927: state_type > $o ).

tff(pred_def_24047,type,
    v43940: state_type > $o ).

tff(pred_def_24048,type,
    v43939: state_type > $o ).

tff(pred_def_24049,type,
    v43772: state_type > $o ).

tff(pred_def_24050,type,
    v43770: state_type > $o ).

tff(pred_def_24051,type,
    v43768: state_type > $o ).

tff(pred_def_24052,type,
    v43941: ( state_type * $int ) > $o ).

tff(pred_def_24053,type,
    v43942: state_type > $o ).

tff(pred_def_24054,type,
    v43766: ( state_type * $int ) > $o ).

tff(pred_def_24055,type,
    v43764: ( state_type * $int ) > $o ).

tff(pred_def_24056,type,
    v43943: ( state_type * $int ) > $o ).

tff(pred_def_24057,type,
    v43754: ( state_type * $int ) > $o ).

tff(pred_def_24058,type,
    v43752: ( state_type * $int ) > $o ).

tff(pred_def_24059,type,
    v43750: state_type > $o ).

tff(pred_def_24060,type,
    v43944: ( state_type * $int ) > $o ).

tff(pred_def_24061,type,
    v43945: state_type > $o ).

tff(pred_def_24062,type,
    v43748: ( state_type * $int ) > $o ).

tff(pred_def_24063,type,
    v43746: ( state_type * $int ) > $o ).

tff(pred_def_24064,type,
    v43946: ( state_type * $int ) > $o ).

tff(pred_def_24065,type,
    v43738: ( state_type * $int ) > $o ).

tff(pred_def_24066,type,
    v43736: ( state_type * $int ) > $o ).

tff(pred_def_24067,type,
    v43952: state_type > $o ).

tff(pred_def_24068,type,
    v43950: state_type > $o ).

tff(pred_def_24069,type,
    v43949: state_type > $o ).

tff(pred_def_24070,type,
    v43948: ( state_type * $int ) > $o ).

tff(pred_def_24071,type,
    v43693: state_type > $o ).

tff(pred_def_24072,type,
    v43691: state_type > $o ).

tff(pred_def_24073,type,
    v43958: state_type > $o ).

tff(pred_def_24074,type,
    v43956: state_type > $o ).

tff(pred_def_24075,type,
    v43962: state_type > $o ).

tff(pred_def_24076,type,
    v43960: state_type > $o ).

tff(pred_def_24077,type,
    v43965: state_type > $o ).

tff(pred_def_24078,type,
    v43964: state_type > $o ).

tff(pred_def_24079,type,
    v43689: state_type > $o ).

tff(pred_def_24080,type,
    v43687: state_type > $o ).

tff(pred_def_24081,type,
    v43685: state_type > $o ).

tff(pred_def_24082,type,
    v43683: state_type > $o ).

tff(pred_def_24083,type,
    v43681: state_type > $o ).

tff(pred_def_24084,type,
    v43679: state_type > $o ).

tff(pred_def_24085,type,
    v43677: state_type > $o ).

tff(pred_def_24086,type,
    v43675: state_type > $o ).

tff(pred_def_24087,type,
    v43985: state_type > $o ).

tff(pred_def_24088,type,
    v43983: state_type > $o ).

tff(pred_def_24089,type,
    v43981: state_type > $o ).

tff(pred_def_24090,type,
    v43979: state_type > $o ).

tff(pred_def_24091,type,
    v43977: state_type > $o ).

tff(pred_def_24092,type,
    v43995: state_type > $o ).

tff(pred_def_24093,type,
    v43993: state_type > $o ).

tff(pred_def_24094,type,
    v43991: state_type > $o ).

tff(pred_def_24095,type,
    v43989: state_type > $o ).

tff(pred_def_24096,type,
    v43987: state_type > $o ).

tff(pred_def_24097,type,
    v43999: ( state_type * $int ) > $o ).

tff(pred_def_24098,type,
    v43997: ( state_type * $int ) > $o ).

tff(pred_def_24099,type,
    v44009: state_type > $o ).

tff(pred_def_24100,type,
    v44007: state_type > $o ).

tff(pred_def_24101,type,
    v44015: state_type > $o ).

tff(pred_def_24102,type,
    v44013: state_type > $o ).

tff(pred_def_24103,type,
    v44039: ( state_type * $int ) > $o ).

tff(pred_def_24104,type,
    v44037: ( state_type * $int ) > $o ).

tff(pred_def_24105,type,
    v44040: ( state_type * $int ) > $o ).

tff(pred_def_24106,type,
    v44035: ( state_type * $int ) > $o ).

tff(pred_def_24107,type,
    v44033: ( state_type * $int ) > $o ).

tff(pred_def_24108,type,
    v44031: ( state_type * $int ) > $o ).

tff(pred_def_24109,type,
    v44029: state_type > $o ).

tff(pred_def_24110,type,
    v44027: state_type > $o ).

tff(pred_def_24111,type,
    v44044: state_type > $o ).

tff(pred_def_24112,type,
    v44042: state_type > $o ).

tff(pred_def_24113,type,
    v44048: state_type > $o ).

tff(pred_def_24114,type,
    v44046: state_type > $o ).

tff(pred_def_24115,type,
    v44051: state_type > $o ).

tff(pred_def_24116,type,
    v44050: state_type > $o ).

tff(pred_def_24117,type,
    v44025: state_type > $o ).

tff(pred_def_24118,type,
    v44023: state_type > $o ).

tff(pred_def_24119,type,
    v44021: state_type > $o ).

tff(pred_def_24120,type,
    v44019: state_type > $o ).

tff(pred_def_24121,type,
    v44017: state_type > $o ).

tff(pred_def_24122,type,
    v44055: state_type > $o ).

tff(pred_def_24123,type,
    v44053: state_type > $o ).

tff(pred_def_24124,type,
    v44011: state_type > $o ).

tff(pred_def_24125,type,
    v44061: state_type > $o ).

tff(pred_def_24126,type,
    v44063: state_type > $o ).

tff(pred_def_24127,type,
    v44059: state_type > $o ).

tff(pred_def_24128,type,
    v44058: state_type > $o ).

tff(pred_def_24129,type,
    v44069: state_type > $o ).

tff(pred_def_24130,type,
    v44070: state_type > $o ).

tff(pred_def_24131,type,
    v44066: state_type > $o ).

tff(pred_def_24132,type,
    v44068: state_type > $o ).

tff(pred_def_24133,type,
    v44076: state_type > $o ).

tff(pred_def_24134,type,
    v44074: state_type > $o ).

tff(pred_def_24135,type,
    v44078: state_type > $o ).

tff(pred_def_24136,type,
    v44005: state_type > $o ).

tff(pred_def_24137,type,
    v44003: state_type > $o ).

tff(pred_def_24138,type,
    v44001: state_type > $o ).

tff(pred_def_24139,type,
    v44085: state_type > $o ).

tff(pred_def_24140,type,
    v44083: state_type > $o ).

tff(pred_def_24141,type,
    v44082: state_type > $o ).

tff(pred_def_24142,type,
    v44081: state_type > $o ).

tff(pred_def_24143,type,
    v44093: state_type > $o ).

tff(pred_def_24144,type,
    v44094: state_type > $o ).

tff(pred_def_24145,type,
    v44092: state_type > $o ).

tff(pred_def_24146,type,
    v44089: ( state_type * $int ) > $o ).

tff(pred_def_24147,type,
    v44091: ( state_type * $int ) > $o ).

tff(pred_def_24148,type,
    v43975: ( state_type * $int ) > $o ).

tff(pred_def_24149,type,
    v43973: ( state_type * $int ) > $o ).

tff(pred_def_24150,type,
    v43971: ( state_type * $int ) > $o ).

tff(pred_def_24151,type,
    v43969: ( state_type * $int ) > $o ).

tff(pred_def_24152,type,
    v43967: ( state_type * $int ) > $o ).

tff(pred_def_24153,type,
    v44116: state_type > $o ).

tff(pred_def_24154,type,
    v44114: state_type > $o ).

tff(pred_def_24155,type,
    v44120: state_type > $o ).

tff(pred_def_24156,type,
    v44118: state_type > $o ).

tff(pred_def_24157,type,
    v44124: state_type > $o ).

tff(pred_def_24158,type,
    v44122: state_type > $o ).

tff(pred_def_24159,type,
    v44127: state_type > $o ).

tff(pred_def_24160,type,
    v44126: state_type > $o ).

tff(pred_def_24161,type,
    v44112: state_type > $o ).

tff(pred_def_24162,type,
    v44110: state_type > $o ).

tff(pred_def_24163,type,
    v44108: state_type > $o ).

tff(pred_def_24164,type,
    v44106: state_type > $o ).

tff(pred_def_24165,type,
    v44104: state_type > $o ).

tff(pred_def_24166,type,
    v44102: state_type > $o ).

tff(pred_def_24167,type,
    v44100: state_type > $o ).

tff(pred_def_24168,type,
    v44098: state_type > $o ).

tff(pred_def_24169,type,
    v44147: state_type > $o ).

tff(pred_def_24170,type,
    v44145: state_type > $o ).

tff(pred_def_24171,type,
    v44143: state_type > $o ).

tff(pred_def_24172,type,
    v44141: state_type > $o ).

tff(pred_def_24173,type,
    v44139: state_type > $o ).

tff(pred_def_24174,type,
    v44157: state_type > $o ).

tff(pred_def_24175,type,
    v44155: state_type > $o ).

tff(pred_def_24176,type,
    v44153: state_type > $o ).

tff(pred_def_24177,type,
    v44151: state_type > $o ).

tff(pred_def_24178,type,
    v44149: state_type > $o ).

tff(pred_def_24179,type,
    v44161: ( state_type * $int ) > $o ).

tff(pred_def_24180,type,
    v44159: ( state_type * $int ) > $o ).

tff(pred_def_24181,type,
    v44171: state_type > $o ).

tff(pred_def_24182,type,
    v44169: state_type > $o ).

tff(pred_def_24183,type,
    v44177: state_type > $o ).

tff(pred_def_24184,type,
    v44175: state_type > $o ).

tff(pred_def_24185,type,
    v44191: state_type > $o ).

tff(pred_def_24186,type,
    v44189: state_type > $o ).

tff(pred_def_24187,type,
    v44195: state_type > $o ).

tff(pred_def_24188,type,
    v44193: state_type > $o ).

tff(pred_def_24189,type,
    v44199: state_type > $o ).

tff(pred_def_24190,type,
    v44197: state_type > $o ).

tff(pred_def_24191,type,
    v44202: state_type > $o ).

tff(pred_def_24192,type,
    v44201: state_type > $o ).

tff(pred_def_24193,type,
    v44187: state_type > $o ).

tff(pred_def_24194,type,
    v44185: state_type > $o ).

tff(pred_def_24195,type,
    v44183: state_type > $o ).

tff(pred_def_24196,type,
    v44181: state_type > $o ).

tff(pred_def_24197,type,
    v44179: state_type > $o ).

tff(pred_def_24198,type,
    v44206: state_type > $o ).

tff(pred_def_24199,type,
    v44204: state_type > $o ).

tff(pred_def_24200,type,
    v44173: state_type > $o ).

tff(pred_def_24201,type,
    v44212: state_type > $o ).

tff(pred_def_24202,type,
    v44214: state_type > $o ).

tff(pred_def_24203,type,
    v44210: state_type > $o ).

tff(pred_def_24204,type,
    v44209: state_type > $o ).

tff(pred_def_24205,type,
    v44220: state_type > $o ).

tff(pred_def_24206,type,
    v44221: state_type > $o ).

tff(pred_def_24207,type,
    v44217: state_type > $o ).

tff(pred_def_24208,type,
    v44219: state_type > $o ).

tff(pred_def_24209,type,
    v44227: state_type > $o ).

tff(pred_def_24210,type,
    v44225: state_type > $o ).

tff(pred_def_24211,type,
    v44229: state_type > $o ).

tff(pred_def_24212,type,
    v44167: state_type > $o ).

tff(pred_def_24213,type,
    v44165: state_type > $o ).

tff(pred_def_24214,type,
    v44163: state_type > $o ).

tff(pred_def_24215,type,
    v44236: state_type > $o ).

tff(pred_def_24216,type,
    v44234: state_type > $o ).

tff(pred_def_24217,type,
    v44233: state_type > $o ).

tff(pred_def_24218,type,
    v44232: state_type > $o ).

tff(pred_def_24219,type,
    v44244: state_type > $o ).

tff(pred_def_24220,type,
    v44245: state_type > $o ).

tff(pred_def_24221,type,
    v44243: state_type > $o ).

tff(pred_def_24222,type,
    v44240: ( state_type * $int ) > $o ).

tff(pred_def_24223,type,
    v44242: ( state_type * $int ) > $o ).

tff(pred_def_24224,type,
    v44137: ( state_type * $int ) > $o ).

tff(pred_def_24225,type,
    v44135: ( state_type * $int ) > $o ).

tff(pred_def_24226,type,
    v44133: ( state_type * $int ) > $o ).

tff(pred_def_24227,type,
    v44131: ( state_type * $int ) > $o ).

tff(pred_def_24228,type,
    v44129: ( state_type * $int ) > $o ).

tff(pred_def_24229,type,
    v44267: state_type > $o ).

tff(pred_def_24230,type,
    v44265: state_type > $o ).

tff(pred_def_24231,type,
    v44271: state_type > $o ).

tff(pred_def_24232,type,
    v44269: state_type > $o ).

tff(pred_def_24233,type,
    v44275: state_type > $o ).

tff(pred_def_24234,type,
    v44273: state_type > $o ).

tff(pred_def_24235,type,
    v44278: state_type > $o ).

tff(pred_def_24236,type,
    v44277: state_type > $o ).

tff(pred_def_24237,type,
    v44263: state_type > $o ).

tff(pred_def_24238,type,
    v44261: state_type > $o ).

tff(pred_def_24239,type,
    v44259: state_type > $o ).

tff(pred_def_24240,type,
    v44257: state_type > $o ).

tff(pred_def_24241,type,
    v44255: state_type > $o ).

tff(pred_def_24242,type,
    v44253: state_type > $o ).

tff(pred_def_24243,type,
    v44251: state_type > $o ).

tff(pred_def_24244,type,
    v44249: state_type > $o ).

tff(pred_def_24245,type,
    v44298: state_type > $o ).

tff(pred_def_24246,type,
    v44296: state_type > $o ).

tff(pred_def_24247,type,
    v44294: state_type > $o ).

tff(pred_def_24248,type,
    v44292: state_type > $o ).

tff(pred_def_24249,type,
    v44290: state_type > $o ).

tff(pred_def_24250,type,
    v44308: state_type > $o ).

tff(pred_def_24251,type,
    v44306: state_type > $o ).

tff(pred_def_24252,type,
    v44304: state_type > $o ).

tff(pred_def_24253,type,
    v44302: state_type > $o ).

tff(pred_def_24254,type,
    v44300: state_type > $o ).

tff(pred_def_24255,type,
    v44312: ( state_type * $int ) > $o ).

tff(pred_def_24256,type,
    v44310: ( state_type * $int ) > $o ).

tff(pred_def_24257,type,
    v44322: state_type > $o ).

tff(pred_def_24258,type,
    v44320: state_type > $o ).

tff(pred_def_24259,type,
    v44328: state_type > $o ).

tff(pred_def_24260,type,
    v44326: state_type > $o ).

tff(pred_def_24261,type,
    v44342: state_type > $o ).

tff(pred_def_24262,type,
    v44340: state_type > $o ).

tff(pred_def_24263,type,
    v44346: state_type > $o ).

tff(pred_def_24264,type,
    v44344: state_type > $o ).

tff(pred_def_24265,type,
    v44350: state_type > $o ).

tff(pred_def_24266,type,
    v44348: state_type > $o ).

tff(pred_def_24267,type,
    v44353: state_type > $o ).

tff(pred_def_24268,type,
    v44352: state_type > $o ).

tff(pred_def_24269,type,
    v44338: state_type > $o ).

tff(pred_def_24270,type,
    v44336: state_type > $o ).

tff(pred_def_24271,type,
    v44334: state_type > $o ).

tff(pred_def_24272,type,
    v44332: state_type > $o ).

tff(pred_def_24273,type,
    v44330: state_type > $o ).

tff(pred_def_24274,type,
    v44357: state_type > $o ).

tff(pred_def_24275,type,
    v44355: state_type > $o ).

tff(pred_def_24276,type,
    v44324: state_type > $o ).

tff(pred_def_24277,type,
    v44363: state_type > $o ).

tff(pred_def_24278,type,
    v44365: state_type > $o ).

tff(pred_def_24279,type,
    v44361: state_type > $o ).

tff(pred_def_24280,type,
    v44360: state_type > $o ).

tff(pred_def_24281,type,
    v44371: state_type > $o ).

tff(pred_def_24282,type,
    v44372: state_type > $o ).

tff(pred_def_24283,type,
    v44368: state_type > $o ).

tff(pred_def_24284,type,
    v44370: state_type > $o ).

tff(pred_def_24285,type,
    v44378: state_type > $o ).

tff(pred_def_24286,type,
    v44376: state_type > $o ).

tff(pred_def_24287,type,
    v44380: state_type > $o ).

tff(pred_def_24288,type,
    v44318: state_type > $o ).

tff(pred_def_24289,type,
    v44316: state_type > $o ).

tff(pred_def_24290,type,
    v44314: state_type > $o ).

tff(pred_def_24291,type,
    v44387: state_type > $o ).

tff(pred_def_24292,type,
    v44385: state_type > $o ).

tff(pred_def_24293,type,
    v44384: state_type > $o ).

tff(pred_def_24294,type,
    v44383: state_type > $o ).

tff(pred_def_24295,type,
    v44395: state_type > $o ).

tff(pred_def_24296,type,
    v44396: state_type > $o ).

tff(pred_def_24297,type,
    v44394: state_type > $o ).

tff(pred_def_24298,type,
    v44391: ( state_type * $int ) > $o ).

tff(pred_def_24299,type,
    v44393: ( state_type * $int ) > $o ).

tff(pred_def_24300,type,
    v44288: ( state_type * $int ) > $o ).

tff(pred_def_24301,type,
    v44286: ( state_type * $int ) > $o ).

tff(pred_def_24302,type,
    v44284: ( state_type * $int ) > $o ).

tff(pred_def_24303,type,
    v44282: ( state_type * $int ) > $o ).

tff(pred_def_24304,type,
    v44280: ( state_type * $int ) > $o ).

tff(pred_def_24305,type,
    v44418: state_type > $o ).

tff(pred_def_24306,type,
    v44416: state_type > $o ).

tff(pred_def_24307,type,
    v44422: state_type > $o ).

tff(pred_def_24308,type,
    v44420: state_type > $o ).

tff(pred_def_24309,type,
    v44426: state_type > $o ).

tff(pred_def_24310,type,
    v44424: state_type > $o ).

tff(pred_def_24311,type,
    v44429: state_type > $o ).

tff(pred_def_24312,type,
    v44428: state_type > $o ).

tff(pred_def_24313,type,
    v44414: state_type > $o ).

tff(pred_def_24314,type,
    v44412: state_type > $o ).

tff(pred_def_24315,type,
    v44410: state_type > $o ).

tff(pred_def_24316,type,
    v44408: state_type > $o ).

tff(pred_def_24317,type,
    v44406: state_type > $o ).

tff(pred_def_24318,type,
    v44404: state_type > $o ).

tff(pred_def_24319,type,
    v44402: state_type > $o ).

tff(pred_def_24320,type,
    v44400: state_type > $o ).

tff(pred_def_24321,type,
    v44449: state_type > $o ).

tff(pred_def_24322,type,
    v44447: state_type > $o ).

tff(pred_def_24323,type,
    v44445: state_type > $o ).

tff(pred_def_24324,type,
    v44443: state_type > $o ).

tff(pred_def_24325,type,
    v44441: state_type > $o ).

tff(pred_def_24326,type,
    v44459: state_type > $o ).

tff(pred_def_24327,type,
    v44457: state_type > $o ).

tff(pred_def_24328,type,
    v44455: state_type > $o ).

tff(pred_def_24329,type,
    v44453: state_type > $o ).

tff(pred_def_24330,type,
    v44451: state_type > $o ).

tff(pred_def_24331,type,
    v44463: ( state_type * $int ) > $o ).

tff(pred_def_24332,type,
    v44461: ( state_type * $int ) > $o ).

tff(pred_def_24333,type,
    v44473: state_type > $o ).

tff(pred_def_24334,type,
    v44471: state_type > $o ).

tff(pred_def_24335,type,
    v44479: state_type > $o ).

tff(pred_def_24336,type,
    v44477: state_type > $o ).

tff(pred_def_24337,type,
    v44493: state_type > $o ).

tff(pred_def_24338,type,
    v44491: state_type > $o ).

tff(pred_def_24339,type,
    v44497: state_type > $o ).

tff(pred_def_24340,type,
    v44495: state_type > $o ).

tff(pred_def_24341,type,
    v44501: state_type > $o ).

tff(pred_def_24342,type,
    v44499: state_type > $o ).

tff(pred_def_24343,type,
    v44504: state_type > $o ).

tff(pred_def_24344,type,
    v44503: state_type > $o ).

tff(pred_def_24345,type,
    v44489: state_type > $o ).

tff(pred_def_24346,type,
    v44487: state_type > $o ).

tff(pred_def_24347,type,
    v44485: state_type > $o ).

tff(pred_def_24348,type,
    v44483: state_type > $o ).

tff(pred_def_24349,type,
    v44481: state_type > $o ).

tff(pred_def_24350,type,
    v44508: state_type > $o ).

tff(pred_def_24351,type,
    v44506: state_type > $o ).

tff(pred_def_24352,type,
    v44475: state_type > $o ).

tff(pred_def_24353,type,
    v44514: state_type > $o ).

tff(pred_def_24354,type,
    v44516: state_type > $o ).

tff(pred_def_24355,type,
    v44512: state_type > $o ).

tff(pred_def_24356,type,
    v44511: state_type > $o ).

tff(pred_def_24357,type,
    v44522: state_type > $o ).

tff(pred_def_24358,type,
    v44523: state_type > $o ).

tff(pred_def_24359,type,
    v44519: state_type > $o ).

tff(pred_def_24360,type,
    v44521: state_type > $o ).

tff(pred_def_24361,type,
    v44529: state_type > $o ).

tff(pred_def_24362,type,
    v44527: state_type > $o ).

tff(pred_def_24363,type,
    v44531: state_type > $o ).

tff(pred_def_24364,type,
    v44469: state_type > $o ).

tff(pred_def_24365,type,
    v44467: state_type > $o ).

tff(pred_def_24366,type,
    v44465: state_type > $o ).

tff(pred_def_24367,type,
    v44538: state_type > $o ).

tff(pred_def_24368,type,
    v44536: state_type > $o ).

tff(pred_def_24369,type,
    v44535: state_type > $o ).

tff(pred_def_24370,type,
    v44534: state_type > $o ).

tff(pred_def_24371,type,
    v44546: state_type > $o ).

tff(pred_def_24372,type,
    v44547: state_type > $o ).

tff(pred_def_24373,type,
    v44545: state_type > $o ).

tff(pred_def_24374,type,
    v44542: ( state_type * $int ) > $o ).

tff(pred_def_24375,type,
    v44544: ( state_type * $int ) > $o ).

tff(pred_def_24376,type,
    v44439: ( state_type * $int ) > $o ).

tff(pred_def_24377,type,
    v44437: ( state_type * $int ) > $o ).

tff(pred_def_24378,type,
    v44435: ( state_type * $int ) > $o ).

tff(pred_def_24379,type,
    v44433: ( state_type * $int ) > $o ).

tff(pred_def_24380,type,
    v44431: ( state_type * $int ) > $o ).

tff(pred_def_24381,type,
    v44569: state_type > $o ).

tff(pred_def_24382,type,
    v44567: state_type > $o ).

tff(pred_def_24383,type,
    v44573: state_type > $o ).

tff(pred_def_24384,type,
    v44571: state_type > $o ).

tff(pred_def_24385,type,
    v44577: state_type > $o ).

tff(pred_def_24386,type,
    v44575: state_type > $o ).

tff(pred_def_24387,type,
    v44580: state_type > $o ).

tff(pred_def_24388,type,
    v44579: state_type > $o ).

tff(pred_def_24389,type,
    v44565: state_type > $o ).

tff(pred_def_24390,type,
    v44563: state_type > $o ).

tff(pred_def_24391,type,
    v44561: state_type > $o ).

tff(pred_def_24392,type,
    v44559: state_type > $o ).

tff(pred_def_24393,type,
    v44557: state_type > $o ).

tff(pred_def_24394,type,
    v44555: state_type > $o ).

tff(pred_def_24395,type,
    v44553: state_type > $o ).

tff(pred_def_24396,type,
    v44551: state_type > $o ).

tff(pred_def_24397,type,
    v44600: state_type > $o ).

tff(pred_def_24398,type,
    v44598: state_type > $o ).

tff(pred_def_24399,type,
    v44596: state_type > $o ).

tff(pred_def_24400,type,
    v44594: state_type > $o ).

tff(pred_def_24401,type,
    v44592: state_type > $o ).

tff(pred_def_24402,type,
    v44610: state_type > $o ).

tff(pred_def_24403,type,
    v44608: state_type > $o ).

tff(pred_def_24404,type,
    v44606: state_type > $o ).

tff(pred_def_24405,type,
    v44604: state_type > $o ).

tff(pred_def_24406,type,
    v44602: state_type > $o ).

tff(pred_def_24407,type,
    v44614: ( state_type * $int ) > $o ).

tff(pred_def_24408,type,
    v44612: ( state_type * $int ) > $o ).

tff(pred_def_24409,type,
    v44624: state_type > $o ).

tff(pred_def_24410,type,
    v44622: state_type > $o ).

tff(pred_def_24411,type,
    v44630: state_type > $o ).

tff(pred_def_24412,type,
    v44628: state_type > $o ).

tff(pred_def_24413,type,
    v44643: state_type > $o ).

tff(pred_def_24414,type,
    v44641: state_type > $o ).

tff(pred_def_24415,type,
    v44647: state_type > $o ).

tff(pred_def_24416,type,
    v44645: state_type > $o ).

tff(pred_def_24417,type,
    v44651: state_type > $o ).

tff(pred_def_24418,type,
    v44649: state_type > $o ).

tff(pred_def_24419,type,
    v44654: state_type > $o ).

tff(pred_def_24420,type,
    v44653: state_type > $o ).

tff(pred_def_24421,type,
    v44639: state_type > $o ).

tff(pred_def_24422,type,
    v44637: state_type > $o ).

tff(pred_def_24423,type,
    v44634: state_type > $o ).

tff(pred_def_24424,type,
    v44632: state_type > $o ).

tff(pred_def_24425,type,
    v44658: state_type > $o ).

tff(pred_def_24426,type,
    v44656: state_type > $o ).

tff(pred_def_24427,type,
    v44626: state_type > $o ).

tff(pred_def_24428,type,
    v44664: state_type > $o ).

tff(pred_def_24429,type,
    v44666: state_type > $o ).

tff(pred_def_24430,type,
    v44662: state_type > $o ).

tff(pred_def_24431,type,
    v44661: state_type > $o ).

tff(pred_def_24432,type,
    v44672: state_type > $o ).

tff(pred_def_24433,type,
    v44673: state_type > $o ).

tff(pred_def_24434,type,
    v44669: state_type > $o ).

tff(pred_def_24435,type,
    v44671: state_type > $o ).

tff(pred_def_24436,type,
    v44679: state_type > $o ).

tff(pred_def_24437,type,
    v44677: state_type > $o ).

tff(pred_def_24438,type,
    v44681: state_type > $o ).

tff(pred_def_24439,type,
    v44620: state_type > $o ).

tff(pred_def_24440,type,
    v44618: state_type > $o ).

tff(pred_def_24441,type,
    v44616: state_type > $o ).

tff(pred_def_24442,type,
    v44688: state_type > $o ).

tff(pred_def_24443,type,
    v44686: state_type > $o ).

tff(pred_def_24444,type,
    v44685: state_type > $o ).

tff(pred_def_24445,type,
    v44684: state_type > $o ).

tff(pred_def_24446,type,
    v44696: state_type > $o ).

tff(pred_def_24447,type,
    v44697: state_type > $o ).

tff(pred_def_24448,type,
    v44695: state_type > $o ).

tff(pred_def_24449,type,
    v44692: ( state_type * $int ) > $o ).

tff(pred_def_24450,type,
    v44694: ( state_type * $int ) > $o ).

tff(pred_def_24451,type,
    v44590: ( state_type * $int ) > $o ).

tff(pred_def_24452,type,
    v44588: ( state_type * $int ) > $o ).

tff(pred_def_24453,type,
    v44586: ( state_type * $int ) > $o ).

tff(pred_def_24454,type,
    v44584: ( state_type * $int ) > $o ).

tff(pred_def_24455,type,
    v44582: ( state_type * $int ) > $o ).

tff(pred_def_24456,type,
    v44709: state_type > $o ).

tff(pred_def_24457,type,
    v44707: state_type > $o ).

tff(pred_def_24458,type,
    v44705: state_type > $o ).

tff(pred_def_24459,type,
    v44703: state_type > $o ).

tff(pred_def_24460,type,
    v44701: state_type > $o ).

tff(pred_def_24461,type,
    v44717: state_type > $o ).

tff(pred_def_24462,type,
    v44716: ( state_type * $int ) > $o ).

tff(pred_def_24463,type,
    v44715: ( state_type * $int ) > $o ).

tff(pred_def_24464,type,
    v44720: state_type > $o ).

tff(pred_def_24465,type,
    v44719: ( state_type * $int ) > $o ).

tff(pred_def_24466,type,
    v44718: ( state_type * $int ) > $o ).

tff(pred_def_24467,type,
    v44714: ( state_type * $int ) > $o ).

tff(pred_def_24468,type,
    v44723: state_type > $o ).

tff(pred_def_24469,type,
    v44722: ( state_type * $int ) > $o ).

tff(pred_def_24470,type,
    v44721: ( state_type * $int ) > $o ).

tff(pred_def_24471,type,
    v44713: ( state_type * $int ) > $o ).

tff(pred_def_24472,type,
    v44726: state_type > $o ).

tff(pred_def_24473,type,
    v44725: ( state_type * $int ) > $o ).

tff(pred_def_24474,type,
    v44724: ( state_type * $int ) > $o ).

tff(pred_def_24475,type,
    v44712: ( state_type * $int ) > $o ).

tff(pred_def_24476,type,
    v44729: state_type > $o ).

tff(pred_def_24477,type,
    v44728: ( state_type * $int ) > $o ).

tff(pred_def_24478,type,
    v44727: ( state_type * $int ) > $o ).

tff(pred_def_24479,type,
    v44711: ( state_type * $int ) > $o ).

tff(pred_def_24480,type,
    v44732: state_type > $o ).

tff(pred_def_24481,type,
    v44731: ( state_type * $int ) > $o ).

tff(pred_def_24482,type,
    v44730: ( state_type * $int ) > $o ).

tff(pred_def_24483,type,
    v43203: ( state_type * $int ) > $o ).

tff(pred_def_24484,type,
    v43201: ( state_type * $int ) > $o ).

tff(pred_def_24485,type,
    v43199: ( state_type * $int ) > $o ).

tff(pred_def_24486,type,
    v43197: ( state_type * $int ) > $o ).

tff(pred_def_24487,type,
    v43195: ( state_type * $int ) > $o ).

tff(pred_def_24488,type,
    v43189: state_type > $o ).

tff(pred_def_24489,type,
    v43187: state_type > $o ).

tff(pred_def_24490,type,
    v43185: state_type > $o ).

tff(pred_def_24491,type,
    v44743: ( state_type * $int ) > $o ).

tff(pred_def_24492,type,
    v44741: ( state_type * $int ) > $o ).

tff(pred_def_24493,type,
    v44777: state_type > $o ).

tff(pred_def_24494,type,
    v44775: state_type > $o ).

tff(pred_def_24495,type,
    v44773: state_type > $o ).

tff(pred_def_24496,type,
    v44771: state_type > $o ).

tff(pred_def_24497,type,
    v44769: state_type > $o ).

tff(pred_def_24498,type,
    v44767: state_type > $o ).

tff(pred_def_24499,type,
    v44765: state_type > $o ).

tff(pred_def_24500,type,
    v44791: state_type > $o ).

tff(pred_def_24501,type,
    v44789: state_type > $o ).

tff(pred_def_24502,type,
    v44787: state_type > $o ).

tff(pred_def_24503,type,
    v44785: state_type > $o ).

tff(pred_def_24504,type,
    v44783: state_type > $o ).

tff(pred_def_24505,type,
    v44781: state_type > $o ).

tff(pred_def_24506,type,
    v44779: state_type > $o ).

tff(pred_def_24507,type,
    v44817: state_type > $o ).

tff(pred_def_24508,type,
    v44819: state_type > $o ).

tff(pred_def_24509,type,
    v44818: ( state_type * $int ) > $o ).

tff(pred_def_24510,type,
    v44820: state_type > $o ).

tff(pred_def_24511,type,
    v44815: ( state_type * $int ) > $o ).

tff(pred_def_24512,type,
    v44813: ( state_type * $int ) > $o ).

tff(pred_def_24513,type,
    v44821: ( state_type * $int ) > $o ).

tff(pred_def_24514,type,
    v44811: ( state_type * $int ) > $o ).

tff(pred_def_24515,type,
    v44809: ( state_type * $int ) > $o ).

tff(pred_def_24516,type,
    v44807: state_type > $o ).

tff(pred_def_24517,type,
    v44823: state_type > $o ).

tff(pred_def_24518,type,
    v44805: ( state_type * $int ) > $o ).

tff(pred_def_24519,type,
    v44803: ( state_type * $int ) > $o ).

tff(pred_def_24520,type,
    v44837: ( state_type * $int ) > $o ).

tff(pred_def_24521,type,
    v44835: ( state_type * $int ) > $o ).

tff(pred_def_24522,type,
    v44841: state_type > $o ).

tff(pred_def_24523,type,
    v44839: state_type > $o ).

tff(pred_def_24524,type,
    v44865: state_type > $o ).

tff(pred_def_24525,type,
    v44863: state_type > $o ).

tff(pred_def_24526,type,
    v44861: state_type > $o ).

tff(pred_def_24527,type,
    v44859: state_type > $o ).

tff(pred_def_24528,type,
    v44857: state_type > $o ).

tff(pred_def_24529,type,
    v44855: state_type > $o ).

tff(pred_def_24530,type,
    v44853: state_type > $o ).

tff(pred_def_24531,type,
    v44879: state_type > $o ).

tff(pred_def_24532,type,
    v44877: state_type > $o ).

tff(pred_def_24533,type,
    v44875: state_type > $o ).

tff(pred_def_24534,type,
    v44873: state_type > $o ).

tff(pred_def_24535,type,
    v44871: state_type > $o ).

tff(pred_def_24536,type,
    v44869: state_type > $o ).

tff(pred_def_24537,type,
    v44867: state_type > $o ).

tff(pred_def_24538,type,
    v44895: ( state_type * $int ) > $o ).

tff(pred_def_24539,type,
    v44893: ( state_type * $int ) > $o ).

tff(pred_def_24540,type,
    v44891: ( state_type * $int ) > $o ).

tff(pred_def_24541,type,
    v44889: ( state_type * $int ) > $o ).

tff(pred_def_24542,type,
    v44887: ( state_type * $int ) > $o ).

tff(pred_def_24543,type,
    v44925: ( state_type * $int ) > $o ).

tff(pred_def_24544,type,
    v44927: ( state_type * $int ) > $o ).

tff(pred_def_24545,type,
    v44923: ( state_type * $int ) > $o ).

tff(pred_def_24546,type,
    v44921: ( state_type * $int ) > $o ).

tff(pred_def_24547,type,
    v44919: ( state_type * $int ) > $o ).

tff(pred_def_24548,type,
    v44917: ( state_type * $int ) > $o ).

tff(pred_def_24549,type,
    v44915: state_type > $o ).

tff(pred_def_24550,type,
    v44913: state_type > $o ).

tff(pred_def_24551,type,
    v44931: state_type > $o ).

tff(pred_def_24552,type,
    v44929: state_type > $o ).

tff(pred_def_24553,type,
    v44933: state_type > $o ).

tff(pred_def_24554,type,
    v44911: state_type > $o ).

tff(pred_def_24555,type,
    v44909: state_type > $o ).

tff(pred_def_24556,type,
    v44907: state_type > $o ).

tff(pred_def_24557,type,
    v44905: state_type > $o ).

tff(pred_def_24558,type,
    v44903: state_type > $o ).

tff(pred_def_24559,type,
    v44901: state_type > $o ).

tff(pred_def_24560,type,
    v44899: state_type > $o ).

tff(pred_def_24561,type,
    v44897: state_type > $o ).

tff(pred_def_24562,type,
    v44943: ( state_type * $int ) > $o ).

tff(pred_def_24563,type,
    v44941: ( state_type * $int ) > $o ).

tff(pred_def_24564,type,
    v44939: ( state_type * $int ) > $o ).

tff(pred_def_24565,type,
    v44937: ( state_type * $int ) > $o ).

tff(pred_def_24566,type,
    v44935: ( state_type * $int ) > $o ).

tff(pred_def_24567,type,
    v44973: ( state_type * $int ) > $o ).

tff(pred_def_24568,type,
    v44971: ( state_type * $int ) > $o ).

tff(pred_def_24569,type,
    v44974: ( state_type * $int ) > $o ).

tff(pred_def_24570,type,
    v44969: ( state_type * $int ) > $o ).

tff(pred_def_24571,type,
    v44967: ( state_type * $int ) > $o ).

tff(pred_def_24572,type,
    v44965: ( state_type * $int ) > $o ).

tff(pred_def_24573,type,
    v44963: state_type > $o ).

tff(pred_def_24574,type,
    v44961: state_type > $o ).

tff(pred_def_24575,type,
    v44978: state_type > $o ).

tff(pred_def_24576,type,
    v44976: state_type > $o ).

tff(pred_def_24577,type,
    v44980: state_type > $o ).

tff(pred_def_24578,type,
    v44959: state_type > $o ).

tff(pred_def_24579,type,
    v44957: state_type > $o ).

tff(pred_def_24580,type,
    v44955: state_type > $o ).

tff(pred_def_24581,type,
    v44953: state_type > $o ).

tff(pred_def_24582,type,
    v44951: state_type > $o ).

tff(pred_def_24583,type,
    v44949: state_type > $o ).

tff(pred_def_24584,type,
    v44947: state_type > $o ).

tff(pred_def_24585,type,
    v44945: state_type > $o ).

tff(pred_def_24586,type,
    v44990: ( state_type * $int ) > $o ).

tff(pred_def_24587,type,
    v44988: ( state_type * $int ) > $o ).

tff(pred_def_24588,type,
    v44986: ( state_type * $int ) > $o ).

tff(pred_def_24589,type,
    v44984: ( state_type * $int ) > $o ).

tff(pred_def_24590,type,
    v44982: ( state_type * $int ) > $o ).

tff(pred_def_24591,type,
    v45010: state_type > $o ).

tff(pred_def_24592,type,
    v45008: state_type > $o ).

tff(pred_def_24593,type,
    v45014: state_type > $o ).

tff(pred_def_24594,type,
    v45012: state_type > $o ).

tff(pred_def_24595,type,
    v45016: state_type > $o ).

tff(pred_def_24596,type,
    v45006: state_type > $o ).

tff(pred_def_24597,type,
    v45004: state_type > $o ).

tff(pred_def_24598,type,
    v45002: state_type > $o ).

tff(pred_def_24599,type,
    v45000: state_type > $o ).

tff(pred_def_24600,type,
    v44998: state_type > $o ).

tff(pred_def_24601,type,
    v44996: state_type > $o ).

tff(pred_def_24602,type,
    v44994: state_type > $o ).

tff(pred_def_24603,type,
    v44992: state_type > $o ).

tff(pred_def_24604,type,
    v45026: ( state_type * $int ) > $o ).

tff(pred_def_24605,type,
    v45024: ( state_type * $int ) > $o ).

tff(pred_def_24606,type,
    v45022: ( state_type * $int ) > $o ).

tff(pred_def_24607,type,
    v45020: ( state_type * $int ) > $o ).

tff(pred_def_24608,type,
    v45018: ( state_type * $int ) > $o ).

tff(pred_def_24609,type,
    v45046: state_type > $o ).

tff(pred_def_24610,type,
    v45044: state_type > $o ).

tff(pred_def_24611,type,
    v45050: state_type > $o ).

tff(pred_def_24612,type,
    v45048: state_type > $o ).

tff(pred_def_24613,type,
    v45052: state_type > $o ).

tff(pred_def_24614,type,
    v45042: state_type > $o ).

tff(pred_def_24615,type,
    v45040: state_type > $o ).

tff(pred_def_24616,type,
    v45038: state_type > $o ).

tff(pred_def_24617,type,
    v45036: state_type > $o ).

tff(pred_def_24618,type,
    v45034: state_type > $o ).

tff(pred_def_24619,type,
    v45032: state_type > $o ).

tff(pred_def_24620,type,
    v45030: state_type > $o ).

tff(pred_def_24621,type,
    v45028: state_type > $o ).

tff(pred_def_24622,type,
    v45058: state_type > $o ).

tff(pred_def_24623,type,
    v45057: ( state_type * $int ) > $o ).

tff(pred_def_24624,type,
    v45056: ( state_type * $int ) > $o ).

tff(pred_def_24625,type,
    v45061: state_type > $o ).

tff(pred_def_24626,type,
    v45060: ( state_type * $int ) > $o ).

tff(pred_def_24627,type,
    v45059: ( state_type * $int ) > $o ).

tff(pred_def_24628,type,
    v45055: ( state_type * $int ) > $o ).

tff(pred_def_24629,type,
    v45064: state_type > $o ).

tff(pred_def_24630,type,
    v45063: ( state_type * $int ) > $o ).

tff(pred_def_24631,type,
    v45062: ( state_type * $int ) > $o ).

tff(pred_def_24632,type,
    v45054: ( state_type * $int ) > $o ).

tff(pred_def_24633,type,
    v45067: state_type > $o ).

tff(pred_def_24634,type,
    v45066: ( state_type * $int ) > $o ).

tff(pred_def_24635,type,
    v45065: ( state_type * $int ) > $o ).

tff(pred_def_24636,type,
    v44885: ( state_type * $int ) > $o ).

tff(pred_def_24637,type,
    v44883: ( state_type * $int ) > $o ).

tff(pred_def_24638,type,
    v44881: ( state_type * $int ) > $o ).

tff(pred_def_24639,type,
    v45079: state_type > $o ).

tff(pred_def_24640,type,
    v45077: state_type > $o ).

tff(pred_def_24641,type,
    v45075: state_type > $o ).

tff(pred_def_24642,type,
    v45089: state_type > $o ).

tff(pred_def_24643,type,
    v45087: state_type > $o ).

tff(pred_def_24644,type,
    v45085: state_type > $o ).

tff(pred_def_24645,type,
    v45083: state_type > $o ).

tff(pred_def_24646,type,
    v45081: state_type > $o ).

tff(pred_def_24647,type,
    v45091: state_type > $o ).

tff(pred_def_24648,type,
    v45073: state_type > $o ).

tff(pred_def_24649,type,
    v45071: state_type > $o ).

tff(pred_def_24650,type,
    v45069: state_type > $o ).

tff(pred_def_24651,type,
    v45098: state_type > $o ).

tff(pred_def_24652,type,
    v45096: state_type > $o ).

tff(pred_def_24653,type,
    v45095: state_type > $o ).

tff(pred_def_24654,type,
    v45094: state_type > $o ).

tff(pred_def_24655,type,
    v45106: state_type > $o ).

tff(pred_def_24656,type,
    v45107: state_type > $o ).

tff(pred_def_24657,type,
    v45105: state_type > $o ).

tff(pred_def_24658,type,
    v45102: ( state_type * $int ) > $o ).

tff(pred_def_24659,type,
    v45104: ( state_type * $int ) > $o ).

tff(pred_def_24660,type,
    v44851: ( state_type * $int ) > $o ).

tff(pred_def_24661,type,
    v44849: ( state_type * $int ) > $o ).

tff(pred_def_24662,type,
    v44847: ( state_type * $int ) > $o ).

tff(pred_def_24663,type,
    v44845: ( state_type * $int ) > $o ).

tff(pred_def_24664,type,
    v44843: ( state_type * $int ) > $o ).

tff(pred_def_24665,type,
    v45113: state_type > $o ).

tff(pred_def_24666,type,
    v45111: state_type > $o ).

tff(pred_def_24667,type,
    v45117: state_type > $o ).

tff(pred_def_24668,type,
    v45116: ( state_type * $int ) > $o ).

tff(pred_def_24669,type,
    v45115: ( state_type * $int ) > $o ).

tff(pred_def_24670,type,
    v45120: state_type > $o ).

tff(pred_def_24671,type,
    v45119: ( state_type * $int ) > $o ).

tff(pred_def_24672,type,
    v45118: ( state_type * $int ) > $o ).

tff(pred_def_24673,type,
    v44833: ( state_type * $int ) > $o ).

tff(pred_def_24674,type,
    v44831: ( state_type * $int ) > $o ).

tff(pred_def_24675,type,
    v44829: ( state_type * $int ) > $o ).

tff(pred_def_24676,type,
    v44827: ( state_type * $int ) > $o ).

tff(pred_def_24677,type,
    v44825: ( state_type * $int ) > $o ).

tff(pred_def_24678,type,
    v44801: ( state_type * $int ) > $o ).

tff(pred_def_24679,type,
    v44799: ( state_type * $int ) > $o ).

tff(pred_def_24680,type,
    v44797: ( state_type * $int ) > $o ).

tff(pred_def_24681,type,
    v44795: ( state_type * $int ) > $o ).

tff(pred_def_24682,type,
    v44793: ( state_type * $int ) > $o ).

tff(pred_def_24683,type,
    v45133: state_type > $o ).

tff(pred_def_24684,type,
    v45131: state_type > $o ).

tff(pred_def_24685,type,
    v45129: state_type > $o ).

tff(pred_def_24686,type,
    v45139: state_type > $o ).

tff(pred_def_24687,type,
    v45137: state_type > $o ).

tff(pred_def_24688,type,
    v45157: ( state_type * $int ) > $o ).

tff(pred_def_24689,type,
    v45159: ( state_type * $int ) > $o ).

tff(pred_def_24690,type,
    v45155: ( state_type * $int ) > $o ).

tff(pred_def_24691,type,
    v45153: state_type > $o ).

tff(pred_def_24692,type,
    v45151: state_type > $o ).

tff(pred_def_24693,type,
    v45163: state_type > $o ).

tff(pred_def_24694,type,
    v45161: state_type > $o ).

tff(pred_def_24695,type,
    v45167: state_type > $o ).

tff(pred_def_24696,type,
    v45165: state_type > $o ).

tff(pred_def_24697,type,
    v45170: state_type > $o ).

tff(pred_def_24698,type,
    v45169: state_type > $o ).

tff(pred_def_24699,type,
    v45149: state_type > $o ).

tff(pred_def_24700,type,
    v45147: state_type > $o ).

tff(pred_def_24701,type,
    v45145: state_type > $o ).

tff(pred_def_24702,type,
    v45143: state_type > $o ).

tff(pred_def_24703,type,
    v45141: state_type > $o ).

tff(pred_def_24704,type,
    v45178: state_type > $o ).

tff(pred_def_24705,type,
    v45176: state_type > $o ).

tff(pred_def_24706,type,
    v45174: state_type > $o ).

tff(pred_def_24707,type,
    v45172: state_type > $o ).

tff(pred_def_24708,type,
    v45135: state_type > $o ).

tff(pred_def_24709,type,
    v45184: state_type > $o ).

tff(pred_def_24710,type,
    v45186: state_type > $o ).

tff(pred_def_24711,type,
    v45182: state_type > $o ).

tff(pred_def_24712,type,
    v45181: state_type > $o ).

tff(pred_def_24713,type,
    v45192: state_type > $o ).

tff(pred_def_24714,type,
    v45193: state_type > $o ).

tff(pred_def_24715,type,
    v45189: state_type > $o ).

tff(pred_def_24716,type,
    v45191: state_type > $o ).

tff(pred_def_24717,type,
    v45203: state_type > $o ).

tff(pred_def_24718,type,
    v45201: state_type > $o ).

tff(pred_def_24719,type,
    v45199: state_type > $o ).

tff(pred_def_24720,type,
    v45197: state_type > $o ).

tff(pred_def_24721,type,
    v45205: state_type > $o ).

tff(pred_def_24722,type,
    v45127: state_type > $o ).

tff(pred_def_24723,type,
    v45125: state_type > $o ).

tff(pred_def_24724,type,
    v45123: state_type > $o ).

tff(pred_def_24725,type,
    v45212: state_type > $o ).

tff(pred_def_24726,type,
    v45210: state_type > $o ).

tff(pred_def_24727,type,
    v45209: state_type > $o ).

tff(pred_def_24728,type,
    v45208: state_type > $o ).

tff(pred_def_24729,type,
    v45220: state_type > $o ).

tff(pred_def_24730,type,
    v45221: state_type > $o ).

tff(pred_def_24731,type,
    v45219: state_type > $o ).

tff(pred_def_24732,type,
    v45216: ( state_type * $int ) > $o ).

tff(pred_def_24733,type,
    v45218: ( state_type * $int ) > $o ).

tff(pred_def_24734,type,
    v44763: ( state_type * $int ) > $o ).

tff(pred_def_24735,type,
    v44761: ( state_type * $int ) > $o ).

tff(pred_def_24736,type,
    v44759: ( state_type * $int ) > $o ).

tff(pred_def_24737,type,
    v44757: ( state_type * $int ) > $o ).

tff(pred_def_24738,type,
    v44755: ( state_type * $int ) > $o ).

tff(pred_def_24739,type,
    v45257: state_type > $o ).

tff(pred_def_24740,type,
    v45255: state_type > $o ).

tff(pred_def_24741,type,
    v45253: state_type > $o ).

tff(pred_def_24742,type,
    v45251: state_type > $o ).

tff(pred_def_24743,type,
    v45249: state_type > $o ).

tff(pred_def_24744,type,
    v45247: state_type > $o ).

tff(pred_def_24745,type,
    v45267: state_type > $o ).

tff(pred_def_24746,type,
    v45265: state_type > $o ).

tff(pred_def_24747,type,
    v45263: state_type > $o ).

tff(pred_def_24748,type,
    v45261: state_type > $o ).

tff(pred_def_24749,type,
    v45259: state_type > $o ).

tff(pred_def_24750,type,
    v45294: state_type > $o ).

tff(pred_def_24751,type,
    v45293: ( state_type * $int ) > $o ).

tff(pred_def_24752,type,
    v45292: ( state_type * $int ) > $o ).

tff(pred_def_24753,type,
    v45290: ( state_type * $int ) > $o ).

tff(pred_def_24754,type,
    v45310: state_type > $o ).

tff(pred_def_24755,type,
    v45311: ( state_type * $int ) > $o ).

tff(pred_def_24756,type,
    v45312: state_type > $o ).

tff(pred_def_24757,type,
    v45308: ( state_type * $int ) > $o ).

tff(pred_def_24758,type,
    v45306: ( state_type * $int ) > $o ).

tff(pred_def_24759,type,
    v45336: ( state_type * $int ) > $o ).

tff(pred_def_24760,type,
    v45245: ( state_type * $int ) > $o ).

tff(pred_def_24761,type,
    v45334: ( state_type * $int ) > $o ).

tff(pred_def_24762,type,
    v45337: ( state_type * $int ) > $o ).

tff(pred_def_24763,type,
    v45332: ( state_type * $int ) > $o ).

tff(pred_def_24764,type,
    v45330: ( state_type * $int ) > $o ).

tff(pred_def_24765,type,
    v45328: ( state_type * $int ) > $o ).

tff(pred_def_24766,type,
    v45326: state_type > $o ).

tff(pred_def_24767,type,
    v45324: state_type > $o ).

tff(pred_def_24768,type,
    v45343: state_type > $o ).

tff(pred_def_24769,type,
    v45283: state_type > $o ).

tff(pred_def_24770,type,
    v45342: ( state_type * $int ) > $o ).

tff(pred_def_24771,type,
    v45281: ( state_type * $int ) > $o ).

tff(pred_def_24772,type,
    v45279: ( state_type * $int ) > $o ).

tff(pred_def_24773,type,
    v45358: ( state_type * $int ) > $o ).

tff(pred_def_24774,type,
    v45357: ( state_type * $int ) > $o ).

tff(pred_def_24775,type,
    v45355: ( state_type * $int ) > $o ).

tff(pred_def_24776,type,
    v45362: state_type > $o ).

tff(pred_def_24777,type,
    v45360: state_type > $o ).

tff(pred_def_24778,type,
    v45373: ( state_type * $int ) > $o ).

tff(pred_def_24779,type,
    v45372: state_type > $o ).

tff(pred_def_24780,type,
    v45376: state_type > $o ).

tff(pred_def_24781,type,
    v45377: state_type > $o ).

tff(pred_def_24782,type,
    v45375: state_type > $o ).

tff(pred_def_24783,type,
    v45378: state_type > $o ).

tff(pred_def_24784,type,
    v45374: state_type > $o ).

tff(pred_def_24785,type,
    v45371: state_type > $o ).

tff(pred_def_24786,type,
    v45379: state_type > $o ).

tff(pred_def_24787,type,
    v45370: state_type > $o ).

tff(pred_def_24788,type,
    v45382: state_type > $o ).

tff(pred_def_24789,type,
    v45383: state_type > $o ).

tff(pred_def_24790,type,
    v45381: state_type > $o ).

tff(pred_def_24791,type,
    v45384: state_type > $o ).

tff(pred_def_24792,type,
    v45380: state_type > $o ).

tff(pred_def_24793,type,
    v45369: state_type > $o ).

tff(pred_def_24794,type,
    v45385: state_type > $o ).

tff(pred_def_24795,type,
    v45368: state_type > $o ).

tff(pred_def_24796,type,
    v45367: state_type > $o ).

tff(pred_def_24797,type,
    v45389: state_type > $o ).

tff(pred_def_24798,type,
    v45390: state_type > $o ).

tff(pred_def_24799,type,
    v45388: state_type > $o ).

tff(pred_def_24800,type,
    v45391: state_type > $o ).

tff(pred_def_24801,type,
    v45387: state_type > $o ).

tff(pred_def_24802,type,
    v45386: state_type > $o ).

tff(pred_def_24803,type,
    v45366: state_type > $o ).

tff(pred_def_24804,type,
    v45392: state_type > $o ).

tff(pred_def_24805,type,
    v45365: state_type > $o ).

tff(pred_def_24806,type,
    v45395: state_type > $o ).

tff(pred_def_24807,type,
    v45396: state_type > $o ).

tff(pred_def_24808,type,
    v45394: state_type > $o ).

tff(pred_def_24809,type,
    v45397: state_type > $o ).

tff(pred_def_24810,type,
    v45393: state_type > $o ).

tff(pred_def_24811,type,
    v45400: state_type > $o ).

tff(pred_def_24812,type,
    v45401: state_type > $o ).

tff(pred_def_24813,type,
    v45399: state_type > $o ).

tff(pred_def_24814,type,
    v45402: state_type > $o ).

tff(pred_def_24815,type,
    v45398: state_type > $o ).

tff(pred_def_24816,type,
    v45405: state_type > $o ).

tff(pred_def_24817,type,
    v45406: state_type > $o ).

tff(pred_def_24818,type,
    v45404: state_type > $o ).

tff(pred_def_24819,type,
    v45407: state_type > $o ).

tff(pred_def_24820,type,
    v45403: state_type > $o ).

tff(pred_def_24821,type,
    v45363: ( state_type * $int ) > $o ).

tff(pred_def_24822,type,
    v45353: ( state_type * $int ) > $o ).

tff(pred_def_24823,type,
    v45351: ( state_type * $int ) > $o ).

tff(pred_def_24824,type,
    v45349: ( state_type * $int ) > $o ).

tff(pred_def_24825,type,
    v45347: ( state_type * $int ) > $o ).

tff(pred_def_24826,type,
    v45345: ( state_type * $int ) > $o ).

tff(pred_def_24827,type,
    v45408: ( state_type * $int ) > $o ).

tff(pred_def_24828,type,
    v45277: ( state_type * $int ) > $o ).

tff(pred_def_24829,type,
    v45275: ( state_type * $int ) > $o ).

tff(pred_def_24830,type,
    v45273: ( state_type * $int ) > $o ).

tff(pred_def_24831,type,
    v45409: ( state_type * $int ) > $o ).

tff(pred_def_24832,type,
    v45410: ( state_type * $int ) > $o ).

tff(pred_def_24833,type,
    v45271: ( state_type * $int ) > $o ).

tff(pred_def_24834,type,
    v45269: ( state_type * $int ) > $o ).

tff(pred_def_24835,type,
    v45420: state_type > $o ).

tff(pred_def_24836,type,
    v45418: state_type > $o ).

tff(pred_def_24837,type,
    v45426: state_type > $o ).

tff(pred_def_24838,type,
    v45424: state_type > $o ).

tff(pred_def_24839,type,
    v45430: state_type > $o ).

tff(pred_def_24840,type,
    v45428: state_type > $o ).

tff(pred_def_24841,type,
    v45434: state_type > $o ).

tff(pred_def_24842,type,
    v45432: state_type > $o ).

tff(pred_def_24843,type,
    v45422: state_type > $o ).

tff(pred_def_24844,type,
    v45440: state_type > $o ).

tff(pred_def_24845,type,
    v45442: state_type > $o ).

tff(pred_def_24846,type,
    v45438: state_type > $o ).

tff(pred_def_24847,type,
    v45437: state_type > $o ).

tff(pred_def_24848,type,
    v45448: state_type > $o ).

tff(pred_def_24849,type,
    v45449: state_type > $o ).

tff(pred_def_24850,type,
    v45445: state_type > $o ).

tff(pred_def_24851,type,
    v45447: state_type > $o ).

tff(pred_def_24852,type,
    v45455: state_type > $o ).

tff(pred_def_24853,type,
    v45453: state_type > $o ).

tff(pred_def_24854,type,
    v45457: state_type > $o ).

tff(pred_def_24855,type,
    v45416: state_type > $o ).

tff(pred_def_24856,type,
    v45414: state_type > $o ).

tff(pred_def_24857,type,
    v45412: state_type > $o ).

tff(pred_def_24858,type,
    v45464: state_type > $o ).

tff(pred_def_24859,type,
    v45462: state_type > $o ).

tff(pred_def_24860,type,
    v45461: state_type > $o ).

tff(pred_def_24861,type,
    v45460: state_type > $o ).

tff(pred_def_24862,type,
    v45472: state_type > $o ).

tff(pred_def_24863,type,
    v45473: state_type > $o ).

tff(pred_def_24864,type,
    v45471: state_type > $o ).

tff(pred_def_24865,type,
    v45468: ( state_type * $int ) > $o ).

tff(pred_def_24866,type,
    v45470: ( state_type * $int ) > $o ).

tff(pred_def_24867,type,
    v45459: ( state_type * $int ) > $o ).

tff(pred_def_24868,type,
    v45341: state_type > $o ).

tff(pred_def_24869,type,
    v45339: state_type > $o ).

tff(pred_def_24870,type,
    v45485: state_type > $o ).

tff(pred_def_24871,type,
    v45483: state_type > $o ).

tff(pred_def_24872,type,
    v45482: state_type > $o ).

tff(pred_def_24873,type,
    v45481: ( state_type * $int ) > $o ).

tff(pred_def_24874,type,
    v45479: state_type > $o ).

tff(pred_def_24875,type,
    v45477: state_type > $o ).

tff(pred_def_24876,type,
    v45490: state_type > $o ).

tff(pred_def_24877,type,
    v45489: state_type > $o ).

tff(pred_def_24878,type,
    v45322: state_type > $o ).

tff(pred_def_24879,type,
    v45320: state_type > $o ).

tff(pred_def_24880,type,
    v45318: state_type > $o ).

tff(pred_def_24881,type,
    v45491: ( state_type * $int ) > $o ).

tff(pred_def_24882,type,
    v45492: state_type > $o ).

tff(pred_def_24883,type,
    v45316: ( state_type * $int ) > $o ).

tff(pred_def_24884,type,
    v45314: ( state_type * $int ) > $o ).

tff(pred_def_24885,type,
    v45493: ( state_type * $int ) > $o ).

tff(pred_def_24886,type,
    v45304: ( state_type * $int ) > $o ).

tff(pred_def_24887,type,
    v45302: ( state_type * $int ) > $o ).

tff(pred_def_24888,type,
    v45300: state_type > $o ).

tff(pred_def_24889,type,
    v45494: ( state_type * $int ) > $o ).

tff(pred_def_24890,type,
    v45495: state_type > $o ).

tff(pred_def_24891,type,
    v45298: ( state_type * $int ) > $o ).

tff(pred_def_24892,type,
    v45296: ( state_type * $int ) > $o ).

tff(pred_def_24893,type,
    v45496: ( state_type * $int ) > $o ).

tff(pred_def_24894,type,
    v45288: ( state_type * $int ) > $o ).

tff(pred_def_24895,type,
    v45286: ( state_type * $int ) > $o ).

tff(pred_def_24896,type,
    v45502: state_type > $o ).

tff(pred_def_24897,type,
    v45500: state_type > $o ).

tff(pred_def_24898,type,
    v45499: state_type > $o ).

tff(pred_def_24899,type,
    v45498: ( state_type * $int ) > $o ).

tff(pred_def_24900,type,
    v45243: state_type > $o ).

tff(pred_def_24901,type,
    v45241: state_type > $o ).

tff(pred_def_24902,type,
    v45508: state_type > $o ).

tff(pred_def_24903,type,
    v45506: state_type > $o ).

tff(pred_def_24904,type,
    v45512: state_type > $o ).

tff(pred_def_24905,type,
    v45510: state_type > $o ).

tff(pred_def_24906,type,
    v45515: state_type > $o ).

tff(pred_def_24907,type,
    v45514: state_type > $o ).

tff(pred_def_24908,type,
    v45239: state_type > $o ).

tff(pred_def_24909,type,
    v45237: state_type > $o ).

tff(pred_def_24910,type,
    v45235: state_type > $o ).

tff(pred_def_24911,type,
    v45233: state_type > $o ).

tff(pred_def_24912,type,
    v45231: state_type > $o ).

tff(pred_def_24913,type,
    v45229: state_type > $o ).

tff(pred_def_24914,type,
    v45227: state_type > $o ).

tff(pred_def_24915,type,
    v45225: state_type > $o ).

tff(pred_def_24916,type,
    v45535: state_type > $o ).

tff(pred_def_24917,type,
    v45533: state_type > $o ).

tff(pred_def_24918,type,
    v45531: state_type > $o ).

tff(pred_def_24919,type,
    v45529: state_type > $o ).

tff(pred_def_24920,type,
    v45527: state_type > $o ).

tff(pred_def_24921,type,
    v45545: state_type > $o ).

tff(pred_def_24922,type,
    v45543: state_type > $o ).

tff(pred_def_24923,type,
    v45541: state_type > $o ).

tff(pred_def_24924,type,
    v45539: state_type > $o ).

tff(pred_def_24925,type,
    v45537: state_type > $o ).

tff(pred_def_24926,type,
    v45549: ( state_type * $int ) > $o ).

tff(pred_def_24927,type,
    v45547: ( state_type * $int ) > $o ).

tff(pred_def_24928,type,
    v45559: state_type > $o ).

tff(pred_def_24929,type,
    v45557: state_type > $o ).

tff(pred_def_24930,type,
    v45565: state_type > $o ).

tff(pred_def_24931,type,
    v45563: state_type > $o ).

tff(pred_def_24932,type,
    v45589: ( state_type * $int ) > $o ).

tff(pred_def_24933,type,
    v45587: ( state_type * $int ) > $o ).

tff(pred_def_24934,type,
    v45590: ( state_type * $int ) > $o ).

tff(pred_def_24935,type,
    v45585: ( state_type * $int ) > $o ).

tff(pred_def_24936,type,
    v45583: ( state_type * $int ) > $o ).

tff(pred_def_24937,type,
    v45581: ( state_type * $int ) > $o ).

tff(pred_def_24938,type,
    v45579: state_type > $o ).

tff(pred_def_24939,type,
    v45577: state_type > $o ).

tff(pred_def_24940,type,
    v45594: state_type > $o ).

tff(pred_def_24941,type,
    v45592: state_type > $o ).

tff(pred_def_24942,type,
    v45598: state_type > $o ).

tff(pred_def_24943,type,
    v45596: state_type > $o ).

tff(pred_def_24944,type,
    v45601: state_type > $o ).

tff(pred_def_24945,type,
    v45600: state_type > $o ).

tff(pred_def_24946,type,
    v45575: state_type > $o ).

tff(pred_def_24947,type,
    v45573: state_type > $o ).

tff(pred_def_24948,type,
    v45571: state_type > $o ).

tff(pred_def_24949,type,
    v45569: state_type > $o ).

tff(pred_def_24950,type,
    v45567: state_type > $o ).

tff(pred_def_24951,type,
    v45605: state_type > $o ).

tff(pred_def_24952,type,
    v45603: state_type > $o ).

tff(pred_def_24953,type,
    v45561: state_type > $o ).

tff(pred_def_24954,type,
    v45611: state_type > $o ).

tff(pred_def_24955,type,
    v45613: state_type > $o ).

tff(pred_def_24956,type,
    v45609: state_type > $o ).

tff(pred_def_24957,type,
    v45608: state_type > $o ).

tff(pred_def_24958,type,
    v45619: state_type > $o ).

tff(pred_def_24959,type,
    v45620: state_type > $o ).

tff(pred_def_24960,type,
    v45616: state_type > $o ).

tff(pred_def_24961,type,
    v45618: state_type > $o ).

tff(pred_def_24962,type,
    v45626: state_type > $o ).

tff(pred_def_24963,type,
    v45624: state_type > $o ).

tff(pred_def_24964,type,
    v45628: state_type > $o ).

tff(pred_def_24965,type,
    v45555: state_type > $o ).

tff(pred_def_24966,type,
    v45553: state_type > $o ).

tff(pred_def_24967,type,
    v45551: state_type > $o ).

tff(pred_def_24968,type,
    v45635: state_type > $o ).

tff(pred_def_24969,type,
    v45633: state_type > $o ).

tff(pred_def_24970,type,
    v45632: state_type > $o ).

tff(pred_def_24971,type,
    v45631: state_type > $o ).

tff(pred_def_24972,type,
    v45643: state_type > $o ).

tff(pred_def_24973,type,
    v45644: state_type > $o ).

tff(pred_def_24974,type,
    v45642: state_type > $o ).

tff(pred_def_24975,type,
    v45639: ( state_type * $int ) > $o ).

tff(pred_def_24976,type,
    v45641: ( state_type * $int ) > $o ).

tff(pred_def_24977,type,
    v45525: ( state_type * $int ) > $o ).

tff(pred_def_24978,type,
    v45523: ( state_type * $int ) > $o ).

tff(pred_def_24979,type,
    v45521: ( state_type * $int ) > $o ).

tff(pred_def_24980,type,
    v45519: ( state_type * $int ) > $o ).

tff(pred_def_24981,type,
    v45517: ( state_type * $int ) > $o ).

tff(pred_def_24982,type,
    v45666: state_type > $o ).

tff(pred_def_24983,type,
    v45664: state_type > $o ).

tff(pred_def_24984,type,
    v45670: state_type > $o ).

tff(pred_def_24985,type,
    v45668: state_type > $o ).

tff(pred_def_24986,type,
    v45674: state_type > $o ).

tff(pred_def_24987,type,
    v45672: state_type > $o ).

tff(pred_def_24988,type,
    v45677: state_type > $o ).

tff(pred_def_24989,type,
    v45676: state_type > $o ).

tff(pred_def_24990,type,
    v45662: state_type > $o ).

tff(pred_def_24991,type,
    v45660: state_type > $o ).

tff(pred_def_24992,type,
    v45658: state_type > $o ).

tff(pred_def_24993,type,
    v45656: state_type > $o ).

tff(pred_def_24994,type,
    v45654: state_type > $o ).

tff(pred_def_24995,type,
    v45652: state_type > $o ).

tff(pred_def_24996,type,
    v45650: state_type > $o ).

tff(pred_def_24997,type,
    v45648: state_type > $o ).

tff(pred_def_24998,type,
    v45697: state_type > $o ).

tff(pred_def_24999,type,
    v45695: state_type > $o ).

tff(pred_def_25000,type,
    v45693: state_type > $o ).

tff(pred_def_25001,type,
    v45691: state_type > $o ).

tff(pred_def_25002,type,
    v45689: state_type > $o ).

tff(pred_def_25003,type,
    v45707: state_type > $o ).

tff(pred_def_25004,type,
    v45705: state_type > $o ).

tff(pred_def_25005,type,
    v45703: state_type > $o ).

tff(pred_def_25006,type,
    v45701: state_type > $o ).

tff(pred_def_25007,type,
    v45699: state_type > $o ).

tff(pred_def_25008,type,
    v45711: ( state_type * $int ) > $o ).

tff(pred_def_25009,type,
    v45709: ( state_type * $int ) > $o ).

tff(pred_def_25010,type,
    v45721: state_type > $o ).

tff(pred_def_25011,type,
    v45719: state_type > $o ).

tff(pred_def_25012,type,
    v45727: state_type > $o ).

tff(pred_def_25013,type,
    v45725: state_type > $o ).

tff(pred_def_25014,type,
    v45741: state_type > $o ).

tff(pred_def_25015,type,
    v45739: state_type > $o ).

tff(pred_def_25016,type,
    v45745: state_type > $o ).

tff(pred_def_25017,type,
    v45743: state_type > $o ).

tff(pred_def_25018,type,
    v45749: state_type > $o ).

tff(pred_def_25019,type,
    v45747: state_type > $o ).

tff(pred_def_25020,type,
    v45752: state_type > $o ).

tff(pred_def_25021,type,
    v45751: state_type > $o ).

tff(pred_def_25022,type,
    v45737: state_type > $o ).

tff(pred_def_25023,type,
    v45735: state_type > $o ).

tff(pred_def_25024,type,
    v45733: state_type > $o ).

tff(pred_def_25025,type,
    v45731: state_type > $o ).

tff(pred_def_25026,type,
    v45729: state_type > $o ).

tff(pred_def_25027,type,
    v45756: state_type > $o ).

tff(pred_def_25028,type,
    v45754: state_type > $o ).

tff(pred_def_25029,type,
    v45723: state_type > $o ).

tff(pred_def_25030,type,
    v45762: state_type > $o ).

tff(pred_def_25031,type,
    v45764: state_type > $o ).

tff(pred_def_25032,type,
    v45760: state_type > $o ).

tff(pred_def_25033,type,
    v45759: state_type > $o ).

tff(pred_def_25034,type,
    v45770: state_type > $o ).

tff(pred_def_25035,type,
    v45771: state_type > $o ).

tff(pred_def_25036,type,
    v45767: state_type > $o ).

tff(pred_def_25037,type,
    v45769: state_type > $o ).

tff(pred_def_25038,type,
    v45777: state_type > $o ).

tff(pred_def_25039,type,
    v45775: state_type > $o ).

tff(pred_def_25040,type,
    v45779: state_type > $o ).

tff(pred_def_25041,type,
    v45717: state_type > $o ).

tff(pred_def_25042,type,
    v45715: state_type > $o ).

tff(pred_def_25043,type,
    v45713: state_type > $o ).

tff(pred_def_25044,type,
    v45786: state_type > $o ).

tff(pred_def_25045,type,
    v45784: state_type > $o ).

tff(pred_def_25046,type,
    v45783: state_type > $o ).

tff(pred_def_25047,type,
    v45782: state_type > $o ).

tff(pred_def_25048,type,
    v45794: state_type > $o ).

tff(pred_def_25049,type,
    v45795: state_type > $o ).

tff(pred_def_25050,type,
    v45793: state_type > $o ).

tff(pred_def_25051,type,
    v45790: ( state_type * $int ) > $o ).

tff(pred_def_25052,type,
    v45792: ( state_type * $int ) > $o ).

tff(pred_def_25053,type,
    v45687: ( state_type * $int ) > $o ).

tff(pred_def_25054,type,
    v45685: ( state_type * $int ) > $o ).

tff(pred_def_25055,type,
    v45683: ( state_type * $int ) > $o ).

tff(pred_def_25056,type,
    v45681: ( state_type * $int ) > $o ).

tff(pred_def_25057,type,
    v45679: ( state_type * $int ) > $o ).

tff(pred_def_25058,type,
    v45817: state_type > $o ).

tff(pred_def_25059,type,
    v45815: state_type > $o ).

tff(pred_def_25060,type,
    v45821: state_type > $o ).

tff(pred_def_25061,type,
    v45819: state_type > $o ).

tff(pred_def_25062,type,
    v45825: state_type > $o ).

tff(pred_def_25063,type,
    v45823: state_type > $o ).

tff(pred_def_25064,type,
    v45828: state_type > $o ).

tff(pred_def_25065,type,
    v45827: state_type > $o ).

tff(pred_def_25066,type,
    v45813: state_type > $o ).

tff(pred_def_25067,type,
    v45811: state_type > $o ).

tff(pred_def_25068,type,
    v45809: state_type > $o ).

tff(pred_def_25069,type,
    v45807: state_type > $o ).

tff(pred_def_25070,type,
    v45805: state_type > $o ).

tff(pred_def_25071,type,
    v45803: state_type > $o ).

tff(pred_def_25072,type,
    v45801: state_type > $o ).

tff(pred_def_25073,type,
    v45799: state_type > $o ).

tff(pred_def_25074,type,
    v45848: state_type > $o ).

tff(pred_def_25075,type,
    v45846: state_type > $o ).

tff(pred_def_25076,type,
    v45844: state_type > $o ).

tff(pred_def_25077,type,
    v45842: state_type > $o ).

tff(pred_def_25078,type,
    v45840: state_type > $o ).

tff(pred_def_25079,type,
    v45858: state_type > $o ).

tff(pred_def_25080,type,
    v45856: state_type > $o ).

tff(pred_def_25081,type,
    v45854: state_type > $o ).

tff(pred_def_25082,type,
    v45852: state_type > $o ).

tff(pred_def_25083,type,
    v45850: state_type > $o ).

tff(pred_def_25084,type,
    v45862: ( state_type * $int ) > $o ).

tff(pred_def_25085,type,
    v45860: ( state_type * $int ) > $o ).

tff(pred_def_25086,type,
    v45872: state_type > $o ).

tff(pred_def_25087,type,
    v45870: state_type > $o ).

tff(pred_def_25088,type,
    v45878: state_type > $o ).

tff(pred_def_25089,type,
    v45876: state_type > $o ).

tff(pred_def_25090,type,
    v45892: state_type > $o ).

tff(pred_def_25091,type,
    v45890: state_type > $o ).

tff(pred_def_25092,type,
    v45896: state_type > $o ).

tff(pred_def_25093,type,
    v45894: state_type > $o ).

tff(pred_def_25094,type,
    v45900: state_type > $o ).

tff(pred_def_25095,type,
    v45898: state_type > $o ).

tff(pred_def_25096,type,
    v45903: state_type > $o ).

tff(pred_def_25097,type,
    v45902: state_type > $o ).

tff(pred_def_25098,type,
    v45888: state_type > $o ).

tff(pred_def_25099,type,
    v45886: state_type > $o ).

tff(pred_def_25100,type,
    v45884: state_type > $o ).

tff(pred_def_25101,type,
    v45882: state_type > $o ).

tff(pred_def_25102,type,
    v45880: state_type > $o ).

tff(pred_def_25103,type,
    v45907: state_type > $o ).

tff(pred_def_25104,type,
    v45905: state_type > $o ).

tff(pred_def_25105,type,
    v45874: state_type > $o ).

tff(pred_def_25106,type,
    v45913: state_type > $o ).

tff(pred_def_25107,type,
    v45915: state_type > $o ).

tff(pred_def_25108,type,
    v45911: state_type > $o ).

tff(pred_def_25109,type,
    v45910: state_type > $o ).

tff(pred_def_25110,type,
    v45921: state_type > $o ).

tff(pred_def_25111,type,
    v45922: state_type > $o ).

tff(pred_def_25112,type,
    v45918: state_type > $o ).

tff(pred_def_25113,type,
    v45920: state_type > $o ).

tff(pred_def_25114,type,
    v45928: state_type > $o ).

tff(pred_def_25115,type,
    v45926: state_type > $o ).

tff(pred_def_25116,type,
    v45930: state_type > $o ).

tff(pred_def_25117,type,
    v45868: state_type > $o ).

tff(pred_def_25118,type,
    v45866: state_type > $o ).

tff(pred_def_25119,type,
    v45864: state_type > $o ).

tff(pred_def_25120,type,
    v45937: state_type > $o ).

tff(pred_def_25121,type,
    v45935: state_type > $o ).

tff(pred_def_25122,type,
    v45934: state_type > $o ).

tff(pred_def_25123,type,
    v45933: state_type > $o ).

tff(pred_def_25124,type,
    v45945: state_type > $o ).

tff(pred_def_25125,type,
    v45946: state_type > $o ).

tff(pred_def_25126,type,
    v45944: state_type > $o ).

tff(pred_def_25127,type,
    v45941: ( state_type * $int ) > $o ).

tff(pred_def_25128,type,
    v45943: ( state_type * $int ) > $o ).

tff(pred_def_25129,type,
    v45838: ( state_type * $int ) > $o ).

tff(pred_def_25130,type,
    v45836: ( state_type * $int ) > $o ).

tff(pred_def_25131,type,
    v45834: ( state_type * $int ) > $o ).

tff(pred_def_25132,type,
    v45832: ( state_type * $int ) > $o ).

tff(pred_def_25133,type,
    v45830: ( state_type * $int ) > $o ).

tff(pred_def_25134,type,
    v45968: state_type > $o ).

tff(pred_def_25135,type,
    v45966: state_type > $o ).

tff(pred_def_25136,type,
    v45972: state_type > $o ).

tff(pred_def_25137,type,
    v45970: state_type > $o ).

tff(pred_def_25138,type,
    v45976: state_type > $o ).

tff(pred_def_25139,type,
    v45974: state_type > $o ).

tff(pred_def_25140,type,
    v45979: state_type > $o ).

tff(pred_def_25141,type,
    v45978: state_type > $o ).

tff(pred_def_25142,type,
    v45964: state_type > $o ).

tff(pred_def_25143,type,
    v45962: state_type > $o ).

tff(pred_def_25144,type,
    v45960: state_type > $o ).

tff(pred_def_25145,type,
    v45958: state_type > $o ).

tff(pred_def_25146,type,
    v45956: state_type > $o ).

tff(pred_def_25147,type,
    v45954: state_type > $o ).

tff(pred_def_25148,type,
    v45952: state_type > $o ).

tff(pred_def_25149,type,
    v45950: state_type > $o ).

tff(pred_def_25150,type,
    v45999: state_type > $o ).

tff(pred_def_25151,type,
    v45997: state_type > $o ).

tff(pred_def_25152,type,
    v45995: state_type > $o ).

tff(pred_def_25153,type,
    v45993: state_type > $o ).

tff(pred_def_25154,type,
    v45991: state_type > $o ).

tff(pred_def_25155,type,
    v46009: state_type > $o ).

tff(pred_def_25156,type,
    v46007: state_type > $o ).

tff(pred_def_25157,type,
    v46005: state_type > $o ).

tff(pred_def_25158,type,
    v46003: state_type > $o ).

tff(pred_def_25159,type,
    v46001: state_type > $o ).

tff(pred_def_25160,type,
    v46013: ( state_type * $int ) > $o ).

tff(pred_def_25161,type,
    v46011: ( state_type * $int ) > $o ).

tff(pred_def_25162,type,
    v46023: state_type > $o ).

tff(pred_def_25163,type,
    v46021: state_type > $o ).

tff(pred_def_25164,type,
    v46029: state_type > $o ).

tff(pred_def_25165,type,
    v46027: state_type > $o ).

tff(pred_def_25166,type,
    v46043: state_type > $o ).

tff(pred_def_25167,type,
    v46041: state_type > $o ).

tff(pred_def_25168,type,
    v46047: state_type > $o ).

tff(pred_def_25169,type,
    v46045: state_type > $o ).

tff(pred_def_25170,type,
    v46051: state_type > $o ).

tff(pred_def_25171,type,
    v46049: state_type > $o ).

tff(pred_def_25172,type,
    v46054: state_type > $o ).

tff(pred_def_25173,type,
    v46053: state_type > $o ).

tff(pred_def_25174,type,
    v46039: state_type > $o ).

tff(pred_def_25175,type,
    v46037: state_type > $o ).

tff(pred_def_25176,type,
    v46035: state_type > $o ).

tff(pred_def_25177,type,
    v46033: state_type > $o ).

tff(pred_def_25178,type,
    v46031: state_type > $o ).

tff(pred_def_25179,type,
    v46058: state_type > $o ).

tff(pred_def_25180,type,
    v46056: state_type > $o ).

tff(pred_def_25181,type,
    v46025: state_type > $o ).

tff(pred_def_25182,type,
    v46064: state_type > $o ).

tff(pred_def_25183,type,
    v46066: state_type > $o ).

tff(pred_def_25184,type,
    v46062: state_type > $o ).

tff(pred_def_25185,type,
    v46061: state_type > $o ).

tff(pred_def_25186,type,
    v46072: state_type > $o ).

tff(pred_def_25187,type,
    v46073: state_type > $o ).

tff(pred_def_25188,type,
    v46069: state_type > $o ).

tff(pred_def_25189,type,
    v46071: state_type > $o ).

tff(pred_def_25190,type,
    v46079: state_type > $o ).

tff(pred_def_25191,type,
    v46077: state_type > $o ).

tff(pred_def_25192,type,
    v46081: state_type > $o ).

tff(pred_def_25193,type,
    v46019: state_type > $o ).

tff(pred_def_25194,type,
    v46017: state_type > $o ).

tff(pred_def_25195,type,
    v46015: state_type > $o ).

tff(pred_def_25196,type,
    v46088: state_type > $o ).

tff(pred_def_25197,type,
    v46086: state_type > $o ).

tff(pred_def_25198,type,
    v46085: state_type > $o ).

tff(pred_def_25199,type,
    v46084: state_type > $o ).

tff(pred_def_25200,type,
    v46096: state_type > $o ).

tff(pred_def_25201,type,
    v46097: state_type > $o ).

tff(pred_def_25202,type,
    v46095: state_type > $o ).

tff(pred_def_25203,type,
    v46092: ( state_type * $int ) > $o ).

tff(pred_def_25204,type,
    v46094: ( state_type * $int ) > $o ).

tff(pred_def_25205,type,
    v45989: ( state_type * $int ) > $o ).

tff(pred_def_25206,type,
    v45987: ( state_type * $int ) > $o ).

tff(pred_def_25207,type,
    v45985: ( state_type * $int ) > $o ).

tff(pred_def_25208,type,
    v45983: ( state_type * $int ) > $o ).

tff(pred_def_25209,type,
    v45981: ( state_type * $int ) > $o ).

tff(pred_def_25210,type,
    v46119: state_type > $o ).

tff(pred_def_25211,type,
    v46117: state_type > $o ).

tff(pred_def_25212,type,
    v46123: state_type > $o ).

tff(pred_def_25213,type,
    v46121: state_type > $o ).

tff(pred_def_25214,type,
    v46127: state_type > $o ).

tff(pred_def_25215,type,
    v46125: state_type > $o ).

tff(pred_def_25216,type,
    v46130: state_type > $o ).

tff(pred_def_25217,type,
    v46129: state_type > $o ).

tff(pred_def_25218,type,
    v46115: state_type > $o ).

tff(pred_def_25219,type,
    v46113: state_type > $o ).

tff(pred_def_25220,type,
    v46111: state_type > $o ).

tff(pred_def_25221,type,
    v46109: state_type > $o ).

tff(pred_def_25222,type,
    v46107: state_type > $o ).

tff(pred_def_25223,type,
    v46105: state_type > $o ).

tff(pred_def_25224,type,
    v46103: state_type > $o ).

tff(pred_def_25225,type,
    v46101: state_type > $o ).

tff(pred_def_25226,type,
    v46150: state_type > $o ).

tff(pred_def_25227,type,
    v46148: state_type > $o ).

tff(pred_def_25228,type,
    v46146: state_type > $o ).

tff(pred_def_25229,type,
    v46144: state_type > $o ).

tff(pred_def_25230,type,
    v46142: state_type > $o ).

tff(pred_def_25231,type,
    v46160: state_type > $o ).

tff(pred_def_25232,type,
    v46158: state_type > $o ).

tff(pred_def_25233,type,
    v46156: state_type > $o ).

tff(pred_def_25234,type,
    v46154: state_type > $o ).

tff(pred_def_25235,type,
    v46152: state_type > $o ).

tff(pred_def_25236,type,
    v46164: ( state_type * $int ) > $o ).

tff(pred_def_25237,type,
    v46162: ( state_type * $int ) > $o ).

tff(pred_def_25238,type,
    v46174: state_type > $o ).

tff(pred_def_25239,type,
    v46172: state_type > $o ).

tff(pred_def_25240,type,
    v46180: state_type > $o ).

tff(pred_def_25241,type,
    v46178: state_type > $o ).

tff(pred_def_25242,type,
    v46193: state_type > $o ).

tff(pred_def_25243,type,
    v46191: state_type > $o ).

tff(pred_def_25244,type,
    v46197: state_type > $o ).

tff(pred_def_25245,type,
    v46195: state_type > $o ).

tff(pred_def_25246,type,
    v46201: state_type > $o ).

tff(pred_def_25247,type,
    v46199: state_type > $o ).

tff(pred_def_25248,type,
    v46204: state_type > $o ).

tff(pred_def_25249,type,
    v46203: state_type > $o ).

tff(pred_def_25250,type,
    v46189: state_type > $o ).

tff(pred_def_25251,type,
    v46187: state_type > $o ).

tff(pred_def_25252,type,
    v46184: state_type > $o ).

tff(pred_def_25253,type,
    v46182: state_type > $o ).

tff(pred_def_25254,type,
    v46208: state_type > $o ).

tff(pred_def_25255,type,
    v46206: state_type > $o ).

tff(pred_def_25256,type,
    v46176: state_type > $o ).

tff(pred_def_25257,type,
    v46214: state_type > $o ).

tff(pred_def_25258,type,
    v46216: state_type > $o ).

tff(pred_def_25259,type,
    v46212: state_type > $o ).

tff(pred_def_25260,type,
    v46211: state_type > $o ).

tff(pred_def_25261,type,
    v46222: state_type > $o ).

tff(pred_def_25262,type,
    v46223: state_type > $o ).

tff(pred_def_25263,type,
    v46219: state_type > $o ).

tff(pred_def_25264,type,
    v46221: state_type > $o ).

tff(pred_def_25265,type,
    v46229: state_type > $o ).

tff(pred_def_25266,type,
    v46227: state_type > $o ).

tff(pred_def_25267,type,
    v46231: state_type > $o ).

tff(pred_def_25268,type,
    v46170: state_type > $o ).

tff(pred_def_25269,type,
    v46168: state_type > $o ).

tff(pred_def_25270,type,
    v46166: state_type > $o ).

tff(pred_def_25271,type,
    v46238: state_type > $o ).

tff(pred_def_25272,type,
    v46236: state_type > $o ).

tff(pred_def_25273,type,
    v46235: state_type > $o ).

tff(pred_def_25274,type,
    v46234: state_type > $o ).

tff(pred_def_25275,type,
    v46246: state_type > $o ).

tff(pred_def_25276,type,
    v46247: state_type > $o ).

tff(pred_def_25277,type,
    v46245: state_type > $o ).

tff(pred_def_25278,type,
    v46242: ( state_type * $int ) > $o ).

tff(pred_def_25279,type,
    v46244: ( state_type * $int ) > $o ).

tff(pred_def_25280,type,
    v46140: ( state_type * $int ) > $o ).

tff(pred_def_25281,type,
    v46138: ( state_type * $int ) > $o ).

tff(pred_def_25282,type,
    v46136: ( state_type * $int ) > $o ).

tff(pred_def_25283,type,
    v46134: ( state_type * $int ) > $o ).

tff(pred_def_25284,type,
    v46132: ( state_type * $int ) > $o ).

tff(pred_def_25285,type,
    v46259: state_type > $o ).

tff(pred_def_25286,type,
    v46257: state_type > $o ).

tff(pred_def_25287,type,
    v46255: state_type > $o ).

tff(pred_def_25288,type,
    v46253: state_type > $o ).

tff(pred_def_25289,type,
    v46251: state_type > $o ).

tff(pred_def_25290,type,
    v46267: state_type > $o ).

tff(pred_def_25291,type,
    v46266: ( state_type * $int ) > $o ).

tff(pred_def_25292,type,
    v46265: ( state_type * $int ) > $o ).

tff(pred_def_25293,type,
    v46270: state_type > $o ).

tff(pred_def_25294,type,
    v46269: ( state_type * $int ) > $o ).

tff(pred_def_25295,type,
    v46268: ( state_type * $int ) > $o ).

tff(pred_def_25296,type,
    v46264: ( state_type * $int ) > $o ).

tff(pred_def_25297,type,
    v46273: state_type > $o ).

tff(pred_def_25298,type,
    v46272: ( state_type * $int ) > $o ).

tff(pred_def_25299,type,
    v46271: ( state_type * $int ) > $o ).

tff(pred_def_25300,type,
    v46263: ( state_type * $int ) > $o ).

tff(pred_def_25301,type,
    v46276: state_type > $o ).

tff(pred_def_25302,type,
    v46275: ( state_type * $int ) > $o ).

tff(pred_def_25303,type,
    v46274: ( state_type * $int ) > $o ).

tff(pred_def_25304,type,
    v46262: ( state_type * $int ) > $o ).

tff(pred_def_25305,type,
    v46279: state_type > $o ).

tff(pred_def_25306,type,
    v46278: ( state_type * $int ) > $o ).

tff(pred_def_25307,type,
    v46277: ( state_type * $int ) > $o ).

tff(pred_def_25308,type,
    v46261: ( state_type * $int ) > $o ).

tff(pred_def_25309,type,
    v46282: state_type > $o ).

tff(pred_def_25310,type,
    v46281: ( state_type * $int ) > $o ).

tff(pred_def_25311,type,
    v46280: ( state_type * $int ) > $o ).

tff(pred_def_25312,type,
    v44753: ( state_type * $int ) > $o ).

tff(pred_def_25313,type,
    v44751: ( state_type * $int ) > $o ).

tff(pred_def_25314,type,
    v44749: ( state_type * $int ) > $o ).

tff(pred_def_25315,type,
    v44747: ( state_type * $int ) > $o ).

tff(pred_def_25316,type,
    v44745: ( state_type * $int ) > $o ).

tff(pred_def_25317,type,
    v44739: state_type > $o ).

tff(pred_def_25318,type,
    v44737: state_type > $o ).

tff(pred_def_25319,type,
    v44735: state_type > $o ).

tff(pred_def_25320,type,
    v46293: ( state_type * $int ) > $o ).

tff(pred_def_25321,type,
    v46291: ( state_type * $int ) > $o ).

tff(pred_def_25322,type,
    v46327: state_type > $o ).

tff(pred_def_25323,type,
    v46325: state_type > $o ).

tff(pred_def_25324,type,
    v46323: state_type > $o ).

tff(pred_def_25325,type,
    v46321: state_type > $o ).

tff(pred_def_25326,type,
    v46319: state_type > $o ).

tff(pred_def_25327,type,
    v46317: state_type > $o ).

tff(pred_def_25328,type,
    v46315: state_type > $o ).

tff(pred_def_25329,type,
    v46341: state_type > $o ).

tff(pred_def_25330,type,
    v46339: state_type > $o ).

tff(pred_def_25331,type,
    v46337: state_type > $o ).

tff(pred_def_25332,type,
    v46335: state_type > $o ).

tff(pred_def_25333,type,
    v46333: state_type > $o ).

tff(pred_def_25334,type,
    v46331: state_type > $o ).

tff(pred_def_25335,type,
    v46329: state_type > $o ).

tff(pred_def_25336,type,
    v46367: state_type > $o ).

tff(pred_def_25337,type,
    v46369: state_type > $o ).

tff(pred_def_25338,type,
    v46368: ( state_type * $int ) > $o ).

tff(pred_def_25339,type,
    v46370: state_type > $o ).

tff(pred_def_25340,type,
    v46365: ( state_type * $int ) > $o ).

tff(pred_def_25341,type,
    v46363: ( state_type * $int ) > $o ).

tff(pred_def_25342,type,
    v46371: ( state_type * $int ) > $o ).

tff(pred_def_25343,type,
    v46361: ( state_type * $int ) > $o ).

tff(pred_def_25344,type,
    v46359: ( state_type * $int ) > $o ).

tff(pred_def_25345,type,
    v46357: state_type > $o ).

tff(pred_def_25346,type,
    v46373: state_type > $o ).

tff(pred_def_25347,type,
    v46355: ( state_type * $int ) > $o ).

tff(pred_def_25348,type,
    v46353: ( state_type * $int ) > $o ).

tff(pred_def_25349,type,
    v46387: ( state_type * $int ) > $o ).

tff(pred_def_25350,type,
    v46385: ( state_type * $int ) > $o ).

tff(pred_def_25351,type,
    v46391: state_type > $o ).

tff(pred_def_25352,type,
    v46389: state_type > $o ).

tff(pred_def_25353,type,
    v46415: state_type > $o ).

tff(pred_def_25354,type,
    v46413: state_type > $o ).

tff(pred_def_25355,type,
    v46411: state_type > $o ).

tff(pred_def_25356,type,
    v46409: state_type > $o ).

tff(pred_def_25357,type,
    v46407: state_type > $o ).

tff(pred_def_25358,type,
    v46405: state_type > $o ).

tff(pred_def_25359,type,
    v46403: state_type > $o ).

tff(pred_def_25360,type,
    v46429: state_type > $o ).

tff(pred_def_25361,type,
    v46427: state_type > $o ).

tff(pred_def_25362,type,
    v46425: state_type > $o ).

tff(pred_def_25363,type,
    v46423: state_type > $o ).

tff(pred_def_25364,type,
    v46421: state_type > $o ).

tff(pred_def_25365,type,
    v46419: state_type > $o ).

tff(pred_def_25366,type,
    v46417: state_type > $o ).

tff(pred_def_25367,type,
    v46445: ( state_type * $int ) > $o ).

tff(pred_def_25368,type,
    v46443: ( state_type * $int ) > $o ).

tff(pred_def_25369,type,
    v46441: ( state_type * $int ) > $o ).

tff(pred_def_25370,type,
    v46439: ( state_type * $int ) > $o ).

tff(pred_def_25371,type,
    v46437: ( state_type * $int ) > $o ).

tff(pred_def_25372,type,
    v46475: ( state_type * $int ) > $o ).

tff(pred_def_25373,type,
    v46477: ( state_type * $int ) > $o ).

tff(pred_def_25374,type,
    v46473: ( state_type * $int ) > $o ).

tff(pred_def_25375,type,
    v46471: ( state_type * $int ) > $o ).

tff(pred_def_25376,type,
    v46469: ( state_type * $int ) > $o ).

tff(pred_def_25377,type,
    v46467: ( state_type * $int ) > $o ).

tff(pred_def_25378,type,
    v46465: state_type > $o ).

tff(pred_def_25379,type,
    v46463: state_type > $o ).

tff(pred_def_25380,type,
    v46481: state_type > $o ).

tff(pred_def_25381,type,
    v46479: state_type > $o ).

tff(pred_def_25382,type,
    v46483: state_type > $o ).

tff(pred_def_25383,type,
    v46461: state_type > $o ).

tff(pred_def_25384,type,
    v46459: state_type > $o ).

tff(pred_def_25385,type,
    v46457: state_type > $o ).

tff(pred_def_25386,type,
    v46455: state_type > $o ).

tff(pred_def_25387,type,
    v46453: state_type > $o ).

tff(pred_def_25388,type,
    v46451: state_type > $o ).

tff(pred_def_25389,type,
    v46449: state_type > $o ).

tff(pred_def_25390,type,
    v46447: state_type > $o ).

tff(pred_def_25391,type,
    v46493: ( state_type * $int ) > $o ).

tff(pred_def_25392,type,
    v46491: ( state_type * $int ) > $o ).

tff(pred_def_25393,type,
    v46489: ( state_type * $int ) > $o ).

tff(pred_def_25394,type,
    v46487: ( state_type * $int ) > $o ).

tff(pred_def_25395,type,
    v46485: ( state_type * $int ) > $o ).

tff(pred_def_25396,type,
    v46523: ( state_type * $int ) > $o ).

tff(pred_def_25397,type,
    v46521: ( state_type * $int ) > $o ).

tff(pred_def_25398,type,
    v46524: ( state_type * $int ) > $o ).

tff(pred_def_25399,type,
    v46519: ( state_type * $int ) > $o ).

tff(pred_def_25400,type,
    v46517: ( state_type * $int ) > $o ).

tff(pred_def_25401,type,
    v46515: ( state_type * $int ) > $o ).

tff(pred_def_25402,type,
    v46513: state_type > $o ).

tff(pred_def_25403,type,
    v46511: state_type > $o ).

tff(pred_def_25404,type,
    v46528: state_type > $o ).

tff(pred_def_25405,type,
    v46526: state_type > $o ).

tff(pred_def_25406,type,
    v46530: state_type > $o ).

tff(pred_def_25407,type,
    v46509: state_type > $o ).

tff(pred_def_25408,type,
    v46507: state_type > $o ).

tff(pred_def_25409,type,
    v46505: state_type > $o ).

tff(pred_def_25410,type,
    v46503: state_type > $o ).

tff(pred_def_25411,type,
    v46501: state_type > $o ).

tff(pred_def_25412,type,
    v46499: state_type > $o ).

tff(pred_def_25413,type,
    v46497: state_type > $o ).

tff(pred_def_25414,type,
    v46495: state_type > $o ).

tff(pred_def_25415,type,
    v46540: ( state_type * $int ) > $o ).

tff(pred_def_25416,type,
    v46538: ( state_type * $int ) > $o ).

tff(pred_def_25417,type,
    v46536: ( state_type * $int ) > $o ).

tff(pred_def_25418,type,
    v46534: ( state_type * $int ) > $o ).

tff(pred_def_25419,type,
    v46532: ( state_type * $int ) > $o ).

tff(pred_def_25420,type,
    v46560: state_type > $o ).

tff(pred_def_25421,type,
    v46558: state_type > $o ).

tff(pred_def_25422,type,
    v46564: state_type > $o ).

tff(pred_def_25423,type,
    v46562: state_type > $o ).

tff(pred_def_25424,type,
    v46566: state_type > $o ).

tff(pred_def_25425,type,
    v46556: state_type > $o ).

tff(pred_def_25426,type,
    v46554: state_type > $o ).

tff(pred_def_25427,type,
    v46552: state_type > $o ).

tff(pred_def_25428,type,
    v46550: state_type > $o ).

tff(pred_def_25429,type,
    v46548: state_type > $o ).

tff(pred_def_25430,type,
    v46546: state_type > $o ).

tff(pred_def_25431,type,
    v46544: state_type > $o ).

tff(pred_def_25432,type,
    v46542: state_type > $o ).

tff(pred_def_25433,type,
    v46576: ( state_type * $int ) > $o ).

tff(pred_def_25434,type,
    v46574: ( state_type * $int ) > $o ).

tff(pred_def_25435,type,
    v46572: ( state_type * $int ) > $o ).

tff(pred_def_25436,type,
    v46570: ( state_type * $int ) > $o ).

tff(pred_def_25437,type,
    v46568: ( state_type * $int ) > $o ).

tff(pred_def_25438,type,
    v46596: state_type > $o ).

tff(pred_def_25439,type,
    v46594: state_type > $o ).

tff(pred_def_25440,type,
    v46600: state_type > $o ).

tff(pred_def_25441,type,
    v46598: state_type > $o ).

tff(pred_def_25442,type,
    v46602: state_type > $o ).

tff(pred_def_25443,type,
    v46592: state_type > $o ).

tff(pred_def_25444,type,
    v46590: state_type > $o ).

tff(pred_def_25445,type,
    v46588: state_type > $o ).

tff(pred_def_25446,type,
    v46586: state_type > $o ).

tff(pred_def_25447,type,
    v46584: state_type > $o ).

tff(pred_def_25448,type,
    v46582: state_type > $o ).

tff(pred_def_25449,type,
    v46580: state_type > $o ).

tff(pred_def_25450,type,
    v46578: state_type > $o ).

tff(pred_def_25451,type,
    v46608: state_type > $o ).

tff(pred_def_25452,type,
    v46607: ( state_type * $int ) > $o ).

tff(pred_def_25453,type,
    v46606: ( state_type * $int ) > $o ).

tff(pred_def_25454,type,
    v46611: state_type > $o ).

tff(pred_def_25455,type,
    v46610: ( state_type * $int ) > $o ).

tff(pred_def_25456,type,
    v46609: ( state_type * $int ) > $o ).

tff(pred_def_25457,type,
    v46605: ( state_type * $int ) > $o ).

tff(pred_def_25458,type,
    v46614: state_type > $o ).

tff(pred_def_25459,type,
    v46613: ( state_type * $int ) > $o ).

tff(pred_def_25460,type,
    v46612: ( state_type * $int ) > $o ).

tff(pred_def_25461,type,
    v46604: ( state_type * $int ) > $o ).

tff(pred_def_25462,type,
    v46617: state_type > $o ).

tff(pred_def_25463,type,
    v46616: ( state_type * $int ) > $o ).

tff(pred_def_25464,type,
    v46615: ( state_type * $int ) > $o ).

tff(pred_def_25465,type,
    v46435: ( state_type * $int ) > $o ).

tff(pred_def_25466,type,
    v46433: ( state_type * $int ) > $o ).

tff(pred_def_25467,type,
    v46431: ( state_type * $int ) > $o ).

tff(pred_def_25468,type,
    v46629: state_type > $o ).

tff(pred_def_25469,type,
    v46627: state_type > $o ).

tff(pred_def_25470,type,
    v46625: state_type > $o ).

tff(pred_def_25471,type,
    v46639: state_type > $o ).

tff(pred_def_25472,type,
    v46637: state_type > $o ).

tff(pred_def_25473,type,
    v46635: state_type > $o ).

tff(pred_def_25474,type,
    v46633: state_type > $o ).

tff(pred_def_25475,type,
    v46631: state_type > $o ).

tff(pred_def_25476,type,
    v46641: state_type > $o ).

tff(pred_def_25477,type,
    v46623: state_type > $o ).

tff(pred_def_25478,type,
    v46621: state_type > $o ).

tff(pred_def_25479,type,
    v46619: state_type > $o ).

tff(pred_def_25480,type,
    v46648: state_type > $o ).

tff(pred_def_25481,type,
    v46646: state_type > $o ).

tff(pred_def_25482,type,
    v46645: state_type > $o ).

tff(pred_def_25483,type,
    v46644: state_type > $o ).

tff(pred_def_25484,type,
    v46656: state_type > $o ).

tff(pred_def_25485,type,
    v46657: state_type > $o ).

tff(pred_def_25486,type,
    v46655: state_type > $o ).

tff(pred_def_25487,type,
    v46652: ( state_type * $int ) > $o ).

tff(pred_def_25488,type,
    v46654: ( state_type * $int ) > $o ).

tff(pred_def_25489,type,
    v46401: ( state_type * $int ) > $o ).

tff(pred_def_25490,type,
    v46399: ( state_type * $int ) > $o ).

tff(pred_def_25491,type,
    v46397: ( state_type * $int ) > $o ).

tff(pred_def_25492,type,
    v46395: ( state_type * $int ) > $o ).

tff(pred_def_25493,type,
    v46393: ( state_type * $int ) > $o ).

tff(pred_def_25494,type,
    v46663: state_type > $o ).

tff(pred_def_25495,type,
    v46661: state_type > $o ).

tff(pred_def_25496,type,
    v46667: state_type > $o ).

tff(pred_def_25497,type,
    v46666: ( state_type * $int ) > $o ).

tff(pred_def_25498,type,
    v46665: ( state_type * $int ) > $o ).

tff(pred_def_25499,type,
    v46670: state_type > $o ).

tff(pred_def_25500,type,
    v46669: ( state_type * $int ) > $o ).

tff(pred_def_25501,type,
    v46668: ( state_type * $int ) > $o ).

tff(pred_def_25502,type,
    v46383: ( state_type * $int ) > $o ).

tff(pred_def_25503,type,
    v46381: ( state_type * $int ) > $o ).

tff(pred_def_25504,type,
    v46379: ( state_type * $int ) > $o ).

tff(pred_def_25505,type,
    v46377: ( state_type * $int ) > $o ).

tff(pred_def_25506,type,
    v46375: ( state_type * $int ) > $o ).

tff(pred_def_25507,type,
    v46351: ( state_type * $int ) > $o ).

tff(pred_def_25508,type,
    v46349: ( state_type * $int ) > $o ).

tff(pred_def_25509,type,
    v46347: ( state_type * $int ) > $o ).

tff(pred_def_25510,type,
    v46345: ( state_type * $int ) > $o ).

tff(pred_def_25511,type,
    v46343: ( state_type * $int ) > $o ).

tff(pred_def_25512,type,
    v46683: state_type > $o ).

tff(pred_def_25513,type,
    v46681: state_type > $o ).

tff(pred_def_25514,type,
    v46679: state_type > $o ).

tff(pred_def_25515,type,
    v46689: state_type > $o ).

tff(pred_def_25516,type,
    v46687: state_type > $o ).

tff(pred_def_25517,type,
    v46707: ( state_type * $int ) > $o ).

tff(pred_def_25518,type,
    v46709: ( state_type * $int ) > $o ).

tff(pred_def_25519,type,
    v46705: ( state_type * $int ) > $o ).

tff(pred_def_25520,type,
    v46703: state_type > $o ).

tff(pred_def_25521,type,
    v46701: state_type > $o ).

tff(pred_def_25522,type,
    v46713: state_type > $o ).

tff(pred_def_25523,type,
    v46711: state_type > $o ).

tff(pred_def_25524,type,
    v46717: state_type > $o ).

tff(pred_def_25525,type,
    v46715: state_type > $o ).

tff(pred_def_25526,type,
    v46720: state_type > $o ).

tff(pred_def_25527,type,
    v46719: state_type > $o ).

tff(pred_def_25528,type,
    v46699: state_type > $o ).

tff(pred_def_25529,type,
    v46697: state_type > $o ).

tff(pred_def_25530,type,
    v46695: state_type > $o ).

tff(pred_def_25531,type,
    v46693: state_type > $o ).

tff(pred_def_25532,type,
    v46691: state_type > $o ).

tff(pred_def_25533,type,
    v46728: state_type > $o ).

tff(pred_def_25534,type,
    v46726: state_type > $o ).

tff(pred_def_25535,type,
    v46724: state_type > $o ).

tff(pred_def_25536,type,
    v46722: state_type > $o ).

tff(pred_def_25537,type,
    v46685: state_type > $o ).

tff(pred_def_25538,type,
    v46734: state_type > $o ).

tff(pred_def_25539,type,
    v46736: state_type > $o ).

tff(pred_def_25540,type,
    v46732: state_type > $o ).

tff(pred_def_25541,type,
    v46731: state_type > $o ).

tff(pred_def_25542,type,
    v46742: state_type > $o ).

tff(pred_def_25543,type,
    v46743: state_type > $o ).

tff(pred_def_25544,type,
    v46739: state_type > $o ).

tff(pred_def_25545,type,
    v46741: state_type > $o ).

tff(pred_def_25546,type,
    v46753: state_type > $o ).

tff(pred_def_25547,type,
    v46751: state_type > $o ).

tff(pred_def_25548,type,
    v46749: state_type > $o ).

tff(pred_def_25549,type,
    v46747: state_type > $o ).

tff(pred_def_25550,type,
    v46755: state_type > $o ).

tff(pred_def_25551,type,
    v46677: state_type > $o ).

tff(pred_def_25552,type,
    v46675: state_type > $o ).

tff(pred_def_25553,type,
    v46673: state_type > $o ).

tff(pred_def_25554,type,
    v46762: state_type > $o ).

tff(pred_def_25555,type,
    v46760: state_type > $o ).

tff(pred_def_25556,type,
    v46759: state_type > $o ).

tff(pred_def_25557,type,
    v46758: state_type > $o ).

tff(pred_def_25558,type,
    v46770: state_type > $o ).

tff(pred_def_25559,type,
    v46771: state_type > $o ).

tff(pred_def_25560,type,
    v46769: state_type > $o ).

tff(pred_def_25561,type,
    v46766: ( state_type * $int ) > $o ).

tff(pred_def_25562,type,
    v46768: ( state_type * $int ) > $o ).

tff(pred_def_25563,type,
    v46313: ( state_type * $int ) > $o ).

tff(pred_def_25564,type,
    v46311: ( state_type * $int ) > $o ).

tff(pred_def_25565,type,
    v46309: ( state_type * $int ) > $o ).

tff(pred_def_25566,type,
    v46307: ( state_type * $int ) > $o ).

tff(pred_def_25567,type,
    v46305: ( state_type * $int ) > $o ).

tff(pred_def_25568,type,
    v46807: state_type > $o ).

tff(pred_def_25569,type,
    v46805: state_type > $o ).

tff(pred_def_25570,type,
    v46803: state_type > $o ).

tff(pred_def_25571,type,
    v46801: state_type > $o ).

tff(pred_def_25572,type,
    v46799: state_type > $o ).

tff(pred_def_25573,type,
    v46797: state_type > $o ).

tff(pred_def_25574,type,
    v46817: state_type > $o ).

tff(pred_def_25575,type,
    v46815: state_type > $o ).

tff(pred_def_25576,type,
    v46813: state_type > $o ).

tff(pred_def_25577,type,
    v46811: state_type > $o ).

tff(pred_def_25578,type,
    v46809: state_type > $o ).

tff(pred_def_25579,type,
    v46844: state_type > $o ).

tff(pred_def_25580,type,
    v46843: ( state_type * $int ) > $o ).

tff(pred_def_25581,type,
    v46842: ( state_type * $int ) > $o ).

tff(pred_def_25582,type,
    v46840: ( state_type * $int ) > $o ).

tff(pred_def_25583,type,
    v46860: state_type > $o ).

tff(pred_def_25584,type,
    v46861: ( state_type * $int ) > $o ).

tff(pred_def_25585,type,
    v46862: state_type > $o ).

tff(pred_def_25586,type,
    v46858: ( state_type * $int ) > $o ).

tff(pred_def_25587,type,
    v46856: ( state_type * $int ) > $o ).

tff(pred_def_25588,type,
    v46886: ( state_type * $int ) > $o ).

tff(pred_def_25589,type,
    v46795: ( state_type * $int ) > $o ).

tff(pred_def_25590,type,
    v46884: ( state_type * $int ) > $o ).

tff(pred_def_25591,type,
    v46887: ( state_type * $int ) > $o ).

tff(pred_def_25592,type,
    v46882: ( state_type * $int ) > $o ).

tff(pred_def_25593,type,
    v46880: ( state_type * $int ) > $o ).

tff(pred_def_25594,type,
    v46878: ( state_type * $int ) > $o ).

tff(pred_def_25595,type,
    v46876: state_type > $o ).

tff(pred_def_25596,type,
    v46874: state_type > $o ).

tff(pred_def_25597,type,
    v46893: state_type > $o ).

tff(pred_def_25598,type,
    v46833: state_type > $o ).

tff(pred_def_25599,type,
    v46892: ( state_type * $int ) > $o ).

tff(pred_def_25600,type,
    v46831: ( state_type * $int ) > $o ).

tff(pred_def_25601,type,
    v46829: ( state_type * $int ) > $o ).

tff(pred_def_25602,type,
    v46908: ( state_type * $int ) > $o ).

tff(pred_def_25603,type,
    v46907: ( state_type * $int ) > $o ).

tff(pred_def_25604,type,
    v46905: ( state_type * $int ) > $o ).

tff(pred_def_25605,type,
    v46912: state_type > $o ).

tff(pred_def_25606,type,
    v46910: state_type > $o ).

tff(pred_def_25607,type,
    v46923: ( state_type * $int ) > $o ).

tff(pred_def_25608,type,
    v46922: state_type > $o ).

tff(pred_def_25609,type,
    v46926: state_type > $o ).

tff(pred_def_25610,type,
    v46927: state_type > $o ).

tff(pred_def_25611,type,
    v46925: state_type > $o ).

tff(pred_def_25612,type,
    v46928: state_type > $o ).

tff(pred_def_25613,type,
    v46924: state_type > $o ).

tff(pred_def_25614,type,
    v46921: state_type > $o ).

tff(pred_def_25615,type,
    v46929: state_type > $o ).

tff(pred_def_25616,type,
    v46920: state_type > $o ).

tff(pred_def_25617,type,
    v46932: state_type > $o ).

tff(pred_def_25618,type,
    v46933: state_type > $o ).

tff(pred_def_25619,type,
    v46931: state_type > $o ).

tff(pred_def_25620,type,
    v46934: state_type > $o ).

tff(pred_def_25621,type,
    v46930: state_type > $o ).

tff(pred_def_25622,type,
    v46919: state_type > $o ).

tff(pred_def_25623,type,
    v46935: state_type > $o ).

tff(pred_def_25624,type,
    v46918: state_type > $o ).

tff(pred_def_25625,type,
    v46917: state_type > $o ).

tff(pred_def_25626,type,
    v46939: state_type > $o ).

tff(pred_def_25627,type,
    v46940: state_type > $o ).

tff(pred_def_25628,type,
    v46938: state_type > $o ).

tff(pred_def_25629,type,
    v46941: state_type > $o ).

tff(pred_def_25630,type,
    v46937: state_type > $o ).

tff(pred_def_25631,type,
    v46936: state_type > $o ).

tff(pred_def_25632,type,
    v46916: state_type > $o ).

tff(pred_def_25633,type,
    v46942: state_type > $o ).

tff(pred_def_25634,type,
    v46915: state_type > $o ).

tff(pred_def_25635,type,
    v46945: state_type > $o ).

tff(pred_def_25636,type,
    v46946: state_type > $o ).

tff(pred_def_25637,type,
    v46944: state_type > $o ).

tff(pred_def_25638,type,
    v46947: state_type > $o ).

tff(pred_def_25639,type,
    v46943: state_type > $o ).

tff(pred_def_25640,type,
    v46950: state_type > $o ).

tff(pred_def_25641,type,
    v46951: state_type > $o ).

tff(pred_def_25642,type,
    v46949: state_type > $o ).

tff(pred_def_25643,type,
    v46952: state_type > $o ).

tff(pred_def_25644,type,
    v46948: state_type > $o ).

tff(pred_def_25645,type,
    v46955: state_type > $o ).

tff(pred_def_25646,type,
    v46956: state_type > $o ).

tff(pred_def_25647,type,
    v46954: state_type > $o ).

tff(pred_def_25648,type,
    v46957: state_type > $o ).

tff(pred_def_25649,type,
    v46953: state_type > $o ).

tff(pred_def_25650,type,
    v46913: ( state_type * $int ) > $o ).

tff(pred_def_25651,type,
    v46903: ( state_type * $int ) > $o ).

tff(pred_def_25652,type,
    v46901: ( state_type * $int ) > $o ).

tff(pred_def_25653,type,
    v46899: ( state_type * $int ) > $o ).

tff(pred_def_25654,type,
    v46897: ( state_type * $int ) > $o ).

tff(pred_def_25655,type,
    v46895: ( state_type * $int ) > $o ).

tff(pred_def_25656,type,
    v46958: ( state_type * $int ) > $o ).

tff(pred_def_25657,type,
    v46827: ( state_type * $int ) > $o ).

tff(pred_def_25658,type,
    v46825: ( state_type * $int ) > $o ).

tff(pred_def_25659,type,
    v46823: ( state_type * $int ) > $o ).

tff(pred_def_25660,type,
    v46959: ( state_type * $int ) > $o ).

tff(pred_def_25661,type,
    v46960: ( state_type * $int ) > $o ).

tff(pred_def_25662,type,
    v46821: ( state_type * $int ) > $o ).

tff(pred_def_25663,type,
    v46819: ( state_type * $int ) > $o ).

tff(pred_def_25664,type,
    v46970: state_type > $o ).

tff(pred_def_25665,type,
    v46968: state_type > $o ).

tff(pred_def_25666,type,
    v46976: state_type > $o ).

tff(pred_def_25667,type,
    v46974: state_type > $o ).

tff(pred_def_25668,type,
    v46980: state_type > $o ).

tff(pred_def_25669,type,
    v46978: state_type > $o ).

tff(pred_def_25670,type,
    v46984: state_type > $o ).

tff(pred_def_25671,type,
    v46982: state_type > $o ).

tff(pred_def_25672,type,
    v46972: state_type > $o ).

tff(pred_def_25673,type,
    v46990: state_type > $o ).

tff(pred_def_25674,type,
    v46992: state_type > $o ).

tff(pred_def_25675,type,
    v46988: state_type > $o ).

tff(pred_def_25676,type,
    v46987: state_type > $o ).

tff(pred_def_25677,type,
    v46998: state_type > $o ).

tff(pred_def_25678,type,
    v46999: state_type > $o ).

tff(pred_def_25679,type,
    v46995: state_type > $o ).

tff(pred_def_25680,type,
    v46997: state_type > $o ).

tff(pred_def_25681,type,
    v47005: state_type > $o ).

tff(pred_def_25682,type,
    v47003: state_type > $o ).

tff(pred_def_25683,type,
    v47007: state_type > $o ).

tff(pred_def_25684,type,
    v46966: state_type > $o ).

tff(pred_def_25685,type,
    v46964: state_type > $o ).

tff(pred_def_25686,type,
    v46962: state_type > $o ).

tff(pred_def_25687,type,
    v47014: state_type > $o ).

tff(pred_def_25688,type,
    v47012: state_type > $o ).

tff(pred_def_25689,type,
    v47011: state_type > $o ).

tff(pred_def_25690,type,
    v47010: state_type > $o ).

tff(pred_def_25691,type,
    v47022: state_type > $o ).

tff(pred_def_25692,type,
    v47023: state_type > $o ).

tff(pred_def_25693,type,
    v47021: state_type > $o ).

tff(pred_def_25694,type,
    v47018: ( state_type * $int ) > $o ).

tff(pred_def_25695,type,
    v47020: ( state_type * $int ) > $o ).

tff(pred_def_25696,type,
    v47009: ( state_type * $int ) > $o ).

tff(pred_def_25697,type,
    v46891: state_type > $o ).

tff(pred_def_25698,type,
    v46889: state_type > $o ).

tff(pred_def_25699,type,
    v47035: state_type > $o ).

tff(pred_def_25700,type,
    v47033: state_type > $o ).

tff(pred_def_25701,type,
    v47032: state_type > $o ).

tff(pred_def_25702,type,
    v47031: ( state_type * $int ) > $o ).

tff(pred_def_25703,type,
    v47029: state_type > $o ).

tff(pred_def_25704,type,
    v47027: state_type > $o ).

tff(pred_def_25705,type,
    v47040: state_type > $o ).

tff(pred_def_25706,type,
    v47039: state_type > $o ).

tff(pred_def_25707,type,
    v46872: state_type > $o ).

tff(pred_def_25708,type,
    v46870: state_type > $o ).

tff(pred_def_25709,type,
    v46868: state_type > $o ).

tff(pred_def_25710,type,
    v47041: ( state_type * $int ) > $o ).

tff(pred_def_25711,type,
    v47042: state_type > $o ).

tff(pred_def_25712,type,
    v46866: ( state_type * $int ) > $o ).

tff(pred_def_25713,type,
    v46864: ( state_type * $int ) > $o ).

tff(pred_def_25714,type,
    v47043: ( state_type * $int ) > $o ).

tff(pred_def_25715,type,
    v46854: ( state_type * $int ) > $o ).

tff(pred_def_25716,type,
    v46852: ( state_type * $int ) > $o ).

tff(pred_def_25717,type,
    v46850: state_type > $o ).

tff(pred_def_25718,type,
    v47044: ( state_type * $int ) > $o ).

tff(pred_def_25719,type,
    v47045: state_type > $o ).

tff(pred_def_25720,type,
    v46848: ( state_type * $int ) > $o ).

tff(pred_def_25721,type,
    v46846: ( state_type * $int ) > $o ).

tff(pred_def_25722,type,
    v47046: ( state_type * $int ) > $o ).

tff(pred_def_25723,type,
    v46838: ( state_type * $int ) > $o ).

tff(pred_def_25724,type,
    v46836: ( state_type * $int ) > $o ).

tff(pred_def_25725,type,
    v47052: state_type > $o ).

tff(pred_def_25726,type,
    v47050: state_type > $o ).

tff(pred_def_25727,type,
    v47049: state_type > $o ).

tff(pred_def_25728,type,
    v47048: ( state_type * $int ) > $o ).

tff(pred_def_25729,type,
    v46793: state_type > $o ).

tff(pred_def_25730,type,
    v46791: state_type > $o ).

tff(pred_def_25731,type,
    v47058: state_type > $o ).

tff(pred_def_25732,type,
    v47056: state_type > $o ).

tff(pred_def_25733,type,
    v47062: state_type > $o ).

tff(pred_def_25734,type,
    v47060: state_type > $o ).

tff(pred_def_25735,type,
    v47065: state_type > $o ).

tff(pred_def_25736,type,
    v47064: state_type > $o ).

tff(pred_def_25737,type,
    v46789: state_type > $o ).

tff(pred_def_25738,type,
    v46787: state_type > $o ).

tff(pred_def_25739,type,
    v46785: state_type > $o ).

tff(pred_def_25740,type,
    v46783: state_type > $o ).

tff(pred_def_25741,type,
    v46781: state_type > $o ).

tff(pred_def_25742,type,
    v46779: state_type > $o ).

tff(pred_def_25743,type,
    v46777: state_type > $o ).

tff(pred_def_25744,type,
    v46775: state_type > $o ).

tff(pred_def_25745,type,
    v47085: state_type > $o ).

tff(pred_def_25746,type,
    v47083: state_type > $o ).

tff(pred_def_25747,type,
    v47081: state_type > $o ).

tff(pred_def_25748,type,
    v47079: state_type > $o ).

tff(pred_def_25749,type,
    v47077: state_type > $o ).

tff(pred_def_25750,type,
    v47095: state_type > $o ).

tff(pred_def_25751,type,
    v47093: state_type > $o ).

tff(pred_def_25752,type,
    v47091: state_type > $o ).

tff(pred_def_25753,type,
    v47089: state_type > $o ).

tff(pred_def_25754,type,
    v47087: state_type > $o ).

tff(pred_def_25755,type,
    v47099: ( state_type * $int ) > $o ).

tff(pred_def_25756,type,
    v47097: ( state_type * $int ) > $o ).

tff(pred_def_25757,type,
    v47109: state_type > $o ).

tff(pred_def_25758,type,
    v47107: state_type > $o ).

tff(pred_def_25759,type,
    v47115: state_type > $o ).

tff(pred_def_25760,type,
    v47113: state_type > $o ).

tff(pred_def_25761,type,
    v47139: ( state_type * $int ) > $o ).

tff(pred_def_25762,type,
    v47137: ( state_type * $int ) > $o ).

tff(pred_def_25763,type,
    v47140: ( state_type * $int ) > $o ).

tff(pred_def_25764,type,
    v47135: ( state_type * $int ) > $o ).

tff(pred_def_25765,type,
    v47133: ( state_type * $int ) > $o ).

tff(pred_def_25766,type,
    v47131: ( state_type * $int ) > $o ).

tff(pred_def_25767,type,
    v47129: state_type > $o ).

tff(pred_def_25768,type,
    v47127: state_type > $o ).

tff(pred_def_25769,type,
    v47144: state_type > $o ).

tff(pred_def_25770,type,
    v47142: state_type > $o ).

tff(pred_def_25771,type,
    v47148: state_type > $o ).

tff(pred_def_25772,type,
    v47146: state_type > $o ).

tff(pred_def_25773,type,
    v47151: state_type > $o ).

tff(pred_def_25774,type,
    v47150: state_type > $o ).

tff(pred_def_25775,type,
    v47125: state_type > $o ).

tff(pred_def_25776,type,
    v47123: state_type > $o ).

tff(pred_def_25777,type,
    v47121: state_type > $o ).

tff(pred_def_25778,type,
    v47119: state_type > $o ).

tff(pred_def_25779,type,
    v47117: state_type > $o ).

tff(pred_def_25780,type,
    v47155: state_type > $o ).

tff(pred_def_25781,type,
    v47153: state_type > $o ).

tff(pred_def_25782,type,
    v47111: state_type > $o ).

tff(pred_def_25783,type,
    v47161: state_type > $o ).

tff(pred_def_25784,type,
    v47163: state_type > $o ).

tff(pred_def_25785,type,
    v47159: state_type > $o ).

tff(pred_def_25786,type,
    v47158: state_type > $o ).

tff(pred_def_25787,type,
    v47169: state_type > $o ).

tff(pred_def_25788,type,
    v47170: state_type > $o ).

tff(pred_def_25789,type,
    v47166: state_type > $o ).

tff(pred_def_25790,type,
    v47168: state_type > $o ).

tff(pred_def_25791,type,
    v47176: state_type > $o ).

tff(pred_def_25792,type,
    v47174: state_type > $o ).

tff(pred_def_25793,type,
    v47178: state_type > $o ).

tff(pred_def_25794,type,
    v47105: state_type > $o ).

tff(pred_def_25795,type,
    v47103: state_type > $o ).

tff(pred_def_25796,type,
    v47101: state_type > $o ).

tff(pred_def_25797,type,
    v47185: state_type > $o ).

tff(pred_def_25798,type,
    v47183: state_type > $o ).

tff(pred_def_25799,type,
    v47182: state_type > $o ).

tff(pred_def_25800,type,
    v47181: state_type > $o ).

tff(pred_def_25801,type,
    v47193: state_type > $o ).

tff(pred_def_25802,type,
    v47194: state_type > $o ).

tff(pred_def_25803,type,
    v47192: state_type > $o ).

tff(pred_def_25804,type,
    v47189: ( state_type * $int ) > $o ).

tff(pred_def_25805,type,
    v47191: ( state_type * $int ) > $o ).

tff(pred_def_25806,type,
    v47075: ( state_type * $int ) > $o ).

tff(pred_def_25807,type,
    v47073: ( state_type * $int ) > $o ).

tff(pred_def_25808,type,
    v47071: ( state_type * $int ) > $o ).

tff(pred_def_25809,type,
    v47069: ( state_type * $int ) > $o ).

tff(pred_def_25810,type,
    v47067: ( state_type * $int ) > $o ).

tff(pred_def_25811,type,
    v47216: state_type > $o ).

tff(pred_def_25812,type,
    v47214: state_type > $o ).

tff(pred_def_25813,type,
    v47220: state_type > $o ).

tff(pred_def_25814,type,
    v47218: state_type > $o ).

tff(pred_def_25815,type,
    v47224: state_type > $o ).

tff(pred_def_25816,type,
    v47222: state_type > $o ).

tff(pred_def_25817,type,
    v47227: state_type > $o ).

tff(pred_def_25818,type,
    v47226: state_type > $o ).

tff(pred_def_25819,type,
    v47212: state_type > $o ).

tff(pred_def_25820,type,
    v47210: state_type > $o ).

tff(pred_def_25821,type,
    v47208: state_type > $o ).

tff(pred_def_25822,type,
    v47206: state_type > $o ).

tff(pred_def_25823,type,
    v47204: state_type > $o ).

tff(pred_def_25824,type,
    v47202: state_type > $o ).

tff(pred_def_25825,type,
    v47200: state_type > $o ).

tff(pred_def_25826,type,
    v47198: state_type > $o ).

tff(pred_def_25827,type,
    v47247: state_type > $o ).

tff(pred_def_25828,type,
    v47245: state_type > $o ).

tff(pred_def_25829,type,
    v47243: state_type > $o ).

tff(pred_def_25830,type,
    v47241: state_type > $o ).

tff(pred_def_25831,type,
    v47239: state_type > $o ).

tff(pred_def_25832,type,
    v47257: state_type > $o ).

tff(pred_def_25833,type,
    v47255: state_type > $o ).

tff(pred_def_25834,type,
    v47253: state_type > $o ).

tff(pred_def_25835,type,
    v47251: state_type > $o ).

tff(pred_def_25836,type,
    v47249: state_type > $o ).

tff(pred_def_25837,type,
    v47261: ( state_type * $int ) > $o ).

tff(pred_def_25838,type,
    v47259: ( state_type * $int ) > $o ).

tff(pred_def_25839,type,
    v47271: state_type > $o ).

tff(pred_def_25840,type,
    v47269: state_type > $o ).

tff(pred_def_25841,type,
    v47277: state_type > $o ).

tff(pred_def_25842,type,
    v47275: state_type > $o ).

tff(pred_def_25843,type,
    v47291: state_type > $o ).

tff(pred_def_25844,type,
    v47289: state_type > $o ).

tff(pred_def_25845,type,
    v47295: state_type > $o ).

tff(pred_def_25846,type,
    v47293: state_type > $o ).

tff(pred_def_25847,type,
    v47299: state_type > $o ).

tff(pred_def_25848,type,
    v47297: state_type > $o ).

tff(pred_def_25849,type,
    v47302: state_type > $o ).

tff(pred_def_25850,type,
    v47301: state_type > $o ).

tff(pred_def_25851,type,
    v47287: state_type > $o ).

tff(pred_def_25852,type,
    v47285: state_type > $o ).

tff(pred_def_25853,type,
    v47283: state_type > $o ).

tff(pred_def_25854,type,
    v47281: state_type > $o ).

tff(pred_def_25855,type,
    v47279: state_type > $o ).

tff(pred_def_25856,type,
    v47306: state_type > $o ).

tff(pred_def_25857,type,
    v47304: state_type > $o ).

tff(pred_def_25858,type,
    v47273: state_type > $o ).

tff(pred_def_25859,type,
    v47312: state_type > $o ).

tff(pred_def_25860,type,
    v47314: state_type > $o ).

tff(pred_def_25861,type,
    v47310: state_type > $o ).

tff(pred_def_25862,type,
    v47309: state_type > $o ).

tff(pred_def_25863,type,
    v47320: state_type > $o ).

tff(pred_def_25864,type,
    v47321: state_type > $o ).

tff(pred_def_25865,type,
    v47317: state_type > $o ).

tff(pred_def_25866,type,
    v47319: state_type > $o ).

tff(pred_def_25867,type,
    v47327: state_type > $o ).

tff(pred_def_25868,type,
    v47325: state_type > $o ).

tff(pred_def_25869,type,
    v47329: state_type > $o ).

tff(pred_def_25870,type,
    v47267: state_type > $o ).

tff(pred_def_25871,type,
    v47265: state_type > $o ).

tff(pred_def_25872,type,
    v47263: state_type > $o ).

tff(pred_def_25873,type,
    v47336: state_type > $o ).

tff(pred_def_25874,type,
    v47334: state_type > $o ).

tff(pred_def_25875,type,
    v47333: state_type > $o ).

tff(pred_def_25876,type,
    v47332: state_type > $o ).

tff(pred_def_25877,type,
    v47344: state_type > $o ).

tff(pred_def_25878,type,
    v47345: state_type > $o ).

tff(pred_def_25879,type,
    v47343: state_type > $o ).

tff(pred_def_25880,type,
    v47340: ( state_type * $int ) > $o ).

tff(pred_def_25881,type,
    v47342: ( state_type * $int ) > $o ).

tff(pred_def_25882,type,
    v47237: ( state_type * $int ) > $o ).

tff(pred_def_25883,type,
    v47235: ( state_type * $int ) > $o ).

tff(pred_def_25884,type,
    v47233: ( state_type * $int ) > $o ).

tff(pred_def_25885,type,
    v47231: ( state_type * $int ) > $o ).

tff(pred_def_25886,type,
    v47229: ( state_type * $int ) > $o ).

tff(pred_def_25887,type,
    v47367: state_type > $o ).

tff(pred_def_25888,type,
    v47365: state_type > $o ).

tff(pred_def_25889,type,
    v47371: state_type > $o ).

tff(pred_def_25890,type,
    v47369: state_type > $o ).

tff(pred_def_25891,type,
    v47375: state_type > $o ).

tff(pred_def_25892,type,
    v47373: state_type > $o ).

tff(pred_def_25893,type,
    v47378: state_type > $o ).

tff(pred_def_25894,type,
    v47377: state_type > $o ).

tff(pred_def_25895,type,
    v47363: state_type > $o ).

tff(pred_def_25896,type,
    v47361: state_type > $o ).

tff(pred_def_25897,type,
    v47359: state_type > $o ).

tff(pred_def_25898,type,
    v47357: state_type > $o ).

tff(pred_def_25899,type,
    v47355: state_type > $o ).

tff(pred_def_25900,type,
    v47353: state_type > $o ).

tff(pred_def_25901,type,
    v47351: state_type > $o ).

tff(pred_def_25902,type,
    v47349: state_type > $o ).

tff(pred_def_25903,type,
    v47398: state_type > $o ).

tff(pred_def_25904,type,
    v47396: state_type > $o ).

tff(pred_def_25905,type,
    v47394: state_type > $o ).

tff(pred_def_25906,type,
    v47392: state_type > $o ).

tff(pred_def_25907,type,
    v47390: state_type > $o ).

tff(pred_def_25908,type,
    v47408: state_type > $o ).

tff(pred_def_25909,type,
    v47406: state_type > $o ).

tff(pred_def_25910,type,
    v47404: state_type > $o ).

tff(pred_def_25911,type,
    v47402: state_type > $o ).

tff(pred_def_25912,type,
    v47400: state_type > $o ).

tff(pred_def_25913,type,
    v47412: ( state_type * $int ) > $o ).

tff(pred_def_25914,type,
    v47410: ( state_type * $int ) > $o ).

tff(pred_def_25915,type,
    v47422: state_type > $o ).

tff(pred_def_25916,type,
    v47420: state_type > $o ).

tff(pred_def_25917,type,
    v47428: state_type > $o ).

tff(pred_def_25918,type,
    v47426: state_type > $o ).

tff(pred_def_25919,type,
    v47442: state_type > $o ).

tff(pred_def_25920,type,
    v47440: state_type > $o ).

tff(pred_def_25921,type,
    v47446: state_type > $o ).

tff(pred_def_25922,type,
    v47444: state_type > $o ).

tff(pred_def_25923,type,
    v47450: state_type > $o ).

tff(pred_def_25924,type,
    v47448: state_type > $o ).

tff(pred_def_25925,type,
    v47453: state_type > $o ).

tff(pred_def_25926,type,
    v47452: state_type > $o ).

tff(pred_def_25927,type,
    v47438: state_type > $o ).

tff(pred_def_25928,type,
    v47436: state_type > $o ).

tff(pred_def_25929,type,
    v47434: state_type > $o ).

tff(pred_def_25930,type,
    v47432: state_type > $o ).

tff(pred_def_25931,type,
    v47430: state_type > $o ).

tff(pred_def_25932,type,
    v47457: state_type > $o ).

tff(pred_def_25933,type,
    v47455: state_type > $o ).

tff(pred_def_25934,type,
    v47424: state_type > $o ).

tff(pred_def_25935,type,
    v47463: state_type > $o ).

tff(pred_def_25936,type,
    v47465: state_type > $o ).

tff(pred_def_25937,type,
    v47461: state_type > $o ).

tff(pred_def_25938,type,
    v47460: state_type > $o ).

tff(pred_def_25939,type,
    v47471: state_type > $o ).

tff(pred_def_25940,type,
    v47472: state_type > $o ).

tff(pred_def_25941,type,
    v47468: state_type > $o ).

tff(pred_def_25942,type,
    v47470: state_type > $o ).

tff(pred_def_25943,type,
    v47478: state_type > $o ).

tff(pred_def_25944,type,
    v47476: state_type > $o ).

tff(pred_def_25945,type,
    v47480: state_type > $o ).

tff(pred_def_25946,type,
    v47418: state_type > $o ).

tff(pred_def_25947,type,
    v47416: state_type > $o ).

tff(pred_def_25948,type,
    v47414: state_type > $o ).

tff(pred_def_25949,type,
    v47487: state_type > $o ).

tff(pred_def_25950,type,
    v47485: state_type > $o ).

tff(pred_def_25951,type,
    v47484: state_type > $o ).

tff(pred_def_25952,type,
    v47483: state_type > $o ).

tff(pred_def_25953,type,
    v47495: state_type > $o ).

tff(pred_def_25954,type,
    v47496: state_type > $o ).

tff(pred_def_25955,type,
    v47494: state_type > $o ).

tff(pred_def_25956,type,
    v47491: ( state_type * $int ) > $o ).

tff(pred_def_25957,type,
    v47493: ( state_type * $int ) > $o ).

tff(pred_def_25958,type,
    v47388: ( state_type * $int ) > $o ).

tff(pred_def_25959,type,
    v47386: ( state_type * $int ) > $o ).

tff(pred_def_25960,type,
    v47384: ( state_type * $int ) > $o ).

tff(pred_def_25961,type,
    v47382: ( state_type * $int ) > $o ).

tff(pred_def_25962,type,
    v47380: ( state_type * $int ) > $o ).

tff(pred_def_25963,type,
    v47518: state_type > $o ).

tff(pred_def_25964,type,
    v47516: state_type > $o ).

tff(pred_def_25965,type,
    v47522: state_type > $o ).

tff(pred_def_25966,type,
    v47520: state_type > $o ).

tff(pred_def_25967,type,
    v47526: state_type > $o ).

tff(pred_def_25968,type,
    v47524: state_type > $o ).

tff(pred_def_25969,type,
    v47529: state_type > $o ).

tff(pred_def_25970,type,
    v47528: state_type > $o ).

tff(pred_def_25971,type,
    v47514: state_type > $o ).

tff(pred_def_25972,type,
    v47512: state_type > $o ).

tff(pred_def_25973,type,
    v47510: state_type > $o ).

tff(pred_def_25974,type,
    v47508: state_type > $o ).

tff(pred_def_25975,type,
    v47506: state_type > $o ).

tff(pred_def_25976,type,
    v47504: state_type > $o ).

tff(pred_def_25977,type,
    v47502: state_type > $o ).

tff(pred_def_25978,type,
    v47500: state_type > $o ).

tff(pred_def_25979,type,
    v47549: state_type > $o ).

tff(pred_def_25980,type,
    v47547: state_type > $o ).

tff(pred_def_25981,type,
    v47545: state_type > $o ).

tff(pred_def_25982,type,
    v47543: state_type > $o ).

tff(pred_def_25983,type,
    v47541: state_type > $o ).

tff(pred_def_25984,type,
    v47559: state_type > $o ).

tff(pred_def_25985,type,
    v47557: state_type > $o ).

tff(pred_def_25986,type,
    v47555: state_type > $o ).

tff(pred_def_25987,type,
    v47553: state_type > $o ).

tff(pred_def_25988,type,
    v47551: state_type > $o ).

tff(pred_def_25989,type,
    v47563: ( state_type * $int ) > $o ).

tff(pred_def_25990,type,
    v47561: ( state_type * $int ) > $o ).

tff(pred_def_25991,type,
    v47573: state_type > $o ).

tff(pred_def_25992,type,
    v47571: state_type > $o ).

tff(pred_def_25993,type,
    v47579: state_type > $o ).

tff(pred_def_25994,type,
    v47577: state_type > $o ).

tff(pred_def_25995,type,
    v47593: state_type > $o ).

tff(pred_def_25996,type,
    v47591: state_type > $o ).

tff(pred_def_25997,type,
    v47597: state_type > $o ).

tff(pred_def_25998,type,
    v47595: state_type > $o ).

tff(pred_def_25999,type,
    v47601: state_type > $o ).

tff(pred_def_26000,type,
    v47599: state_type > $o ).

tff(pred_def_26001,type,
    v47604: state_type > $o ).

tff(pred_def_26002,type,
    v47603: state_type > $o ).

tff(pred_def_26003,type,
    v47589: state_type > $o ).

tff(pred_def_26004,type,
    v47587: state_type > $o ).

tff(pred_def_26005,type,
    v47585: state_type > $o ).

tff(pred_def_26006,type,
    v47583: state_type > $o ).

tff(pred_def_26007,type,
    v47581: state_type > $o ).

tff(pred_def_26008,type,
    v47608: state_type > $o ).

tff(pred_def_26009,type,
    v47606: state_type > $o ).

tff(pred_def_26010,type,
    v47575: state_type > $o ).

tff(pred_def_26011,type,
    v47614: state_type > $o ).

tff(pred_def_26012,type,
    v47616: state_type > $o ).

tff(pred_def_26013,type,
    v47612: state_type > $o ).

tff(pred_def_26014,type,
    v47611: state_type > $o ).

tff(pred_def_26015,type,
    v47622: state_type > $o ).

tff(pred_def_26016,type,
    v47623: state_type > $o ).

tff(pred_def_26017,type,
    v47619: state_type > $o ).

tff(pred_def_26018,type,
    v47621: state_type > $o ).

tff(pred_def_26019,type,
    v47629: state_type > $o ).

tff(pred_def_26020,type,
    v47627: state_type > $o ).

tff(pred_def_26021,type,
    v47631: state_type > $o ).

tff(pred_def_26022,type,
    v47569: state_type > $o ).

tff(pred_def_26023,type,
    v47567: state_type > $o ).

tff(pred_def_26024,type,
    v47565: state_type > $o ).

tff(pred_def_26025,type,
    v47638: state_type > $o ).

tff(pred_def_26026,type,
    v47636: state_type > $o ).

tff(pred_def_26027,type,
    v47635: state_type > $o ).

tff(pred_def_26028,type,
    v47634: state_type > $o ).

tff(pred_def_26029,type,
    v47646: state_type > $o ).

tff(pred_def_26030,type,
    v47647: state_type > $o ).

tff(pred_def_26031,type,
    v47645: state_type > $o ).

tff(pred_def_26032,type,
    v47642: ( state_type * $int ) > $o ).

tff(pred_def_26033,type,
    v47644: ( state_type * $int ) > $o ).

tff(pred_def_26034,type,
    v47539: ( state_type * $int ) > $o ).

tff(pred_def_26035,type,
    v47537: ( state_type * $int ) > $o ).

tff(pred_def_26036,type,
    v47535: ( state_type * $int ) > $o ).

tff(pred_def_26037,type,
    v47533: ( state_type * $int ) > $o ).

tff(pred_def_26038,type,
    v47531: ( state_type * $int ) > $o ).

tff(pred_def_26039,type,
    v47669: state_type > $o ).

tff(pred_def_26040,type,
    v47667: state_type > $o ).

tff(pred_def_26041,type,
    v47673: state_type > $o ).

tff(pred_def_26042,type,
    v47671: state_type > $o ).

tff(pred_def_26043,type,
    v47677: state_type > $o ).

tff(pred_def_26044,type,
    v47675: state_type > $o ).

tff(pred_def_26045,type,
    v47680: state_type > $o ).

tff(pred_def_26046,type,
    v47679: state_type > $o ).

tff(pred_def_26047,type,
    v47665: state_type > $o ).

tff(pred_def_26048,type,
    v47663: state_type > $o ).

tff(pred_def_26049,type,
    v47661: state_type > $o ).

tff(pred_def_26050,type,
    v47659: state_type > $o ).

tff(pred_def_26051,type,
    v47657: state_type > $o ).

tff(pred_def_26052,type,
    v47655: state_type > $o ).

tff(pred_def_26053,type,
    v47653: state_type > $o ).

tff(pred_def_26054,type,
    v47651: state_type > $o ).

tff(pred_def_26055,type,
    v47700: state_type > $o ).

tff(pred_def_26056,type,
    v47698: state_type > $o ).

tff(pred_def_26057,type,
    v47696: state_type > $o ).

tff(pred_def_26058,type,
    v47694: state_type > $o ).

tff(pred_def_26059,type,
    v47692: state_type > $o ).

tff(pred_def_26060,type,
    v47710: state_type > $o ).

tff(pred_def_26061,type,
    v47708: state_type > $o ).

tff(pred_def_26062,type,
    v47706: state_type > $o ).

tff(pred_def_26063,type,
    v47704: state_type > $o ).

tff(pred_def_26064,type,
    v47702: state_type > $o ).

tff(pred_def_26065,type,
    v47714: ( state_type * $int ) > $o ).

tff(pred_def_26066,type,
    v47712: ( state_type * $int ) > $o ).

tff(pred_def_26067,type,
    v47724: state_type > $o ).

tff(pred_def_26068,type,
    v47722: state_type > $o ).

tff(pred_def_26069,type,
    v47730: state_type > $o ).

tff(pred_def_26070,type,
    v47728: state_type > $o ).

tff(pred_def_26071,type,
    v47743: state_type > $o ).

tff(pred_def_26072,type,
    v47741: state_type > $o ).

tff(pred_def_26073,type,
    v47747: state_type > $o ).

tff(pred_def_26074,type,
    v47745: state_type > $o ).

tff(pred_def_26075,type,
    v47751: state_type > $o ).

tff(pred_def_26076,type,
    v47749: state_type > $o ).

tff(pred_def_26077,type,
    v47754: state_type > $o ).

tff(pred_def_26078,type,
    v47753: state_type > $o ).

tff(pred_def_26079,type,
    v47739: state_type > $o ).

tff(pred_def_26080,type,
    v47737: state_type > $o ).

tff(pred_def_26081,type,
    v47734: state_type > $o ).

tff(pred_def_26082,type,
    v47732: state_type > $o ).

tff(pred_def_26083,type,
    v47758: state_type > $o ).

tff(pred_def_26084,type,
    v47756: state_type > $o ).

tff(pred_def_26085,type,
    v47726: state_type > $o ).

tff(pred_def_26086,type,
    v47764: state_type > $o ).

tff(pred_def_26087,type,
    v47766: state_type > $o ).

tff(pred_def_26088,type,
    v47762: state_type > $o ).

tff(pred_def_26089,type,
    v47761: state_type > $o ).

tff(pred_def_26090,type,
    v47772: state_type > $o ).

tff(pred_def_26091,type,
    v47773: state_type > $o ).

tff(pred_def_26092,type,
    v47769: state_type > $o ).

tff(pred_def_26093,type,
    v47771: state_type > $o ).

tff(pred_def_26094,type,
    v47779: state_type > $o ).

tff(pred_def_26095,type,
    v47777: state_type > $o ).

tff(pred_def_26096,type,
    v47781: state_type > $o ).

tff(pred_def_26097,type,
    v47720: state_type > $o ).

tff(pred_def_26098,type,
    v47718: state_type > $o ).

tff(pred_def_26099,type,
    v47716: state_type > $o ).

tff(pred_def_26100,type,
    v47788: state_type > $o ).

tff(pred_def_26101,type,
    v47786: state_type > $o ).

tff(pred_def_26102,type,
    v47785: state_type > $o ).

tff(pred_def_26103,type,
    v47784: state_type > $o ).

tff(pred_def_26104,type,
    v47796: state_type > $o ).

tff(pred_def_26105,type,
    v47797: state_type > $o ).

tff(pred_def_26106,type,
    v47795: state_type > $o ).

tff(pred_def_26107,type,
    v47792: ( state_type * $int ) > $o ).

tff(pred_def_26108,type,
    v47794: ( state_type * $int ) > $o ).

tff(pred_def_26109,type,
    v47690: ( state_type * $int ) > $o ).

tff(pred_def_26110,type,
    v47688: ( state_type * $int ) > $o ).

tff(pred_def_26111,type,
    v47686: ( state_type * $int ) > $o ).

tff(pred_def_26112,type,
    v47684: ( state_type * $int ) > $o ).

tff(pred_def_26113,type,
    v47682: ( state_type * $int ) > $o ).

tff(pred_def_26114,type,
    v47809: state_type > $o ).

tff(pred_def_26115,type,
    v47807: state_type > $o ).

tff(pred_def_26116,type,
    v47805: state_type > $o ).

tff(pred_def_26117,type,
    v47803: state_type > $o ).

tff(pred_def_26118,type,
    v47801: state_type > $o ).

tff(pred_def_26119,type,
    v47817: state_type > $o ).

tff(pred_def_26120,type,
    v47816: ( state_type * $int ) > $o ).

tff(pred_def_26121,type,
    v47815: ( state_type * $int ) > $o ).

tff(pred_def_26122,type,
    v47820: state_type > $o ).

tff(pred_def_26123,type,
    v47819: ( state_type * $int ) > $o ).

tff(pred_def_26124,type,
    v47818: ( state_type * $int ) > $o ).

tff(pred_def_26125,type,
    v47814: ( state_type * $int ) > $o ).

tff(pred_def_26126,type,
    v47823: state_type > $o ).

tff(pred_def_26127,type,
    v47822: ( state_type * $int ) > $o ).

tff(pred_def_26128,type,
    v47821: ( state_type * $int ) > $o ).

tff(pred_def_26129,type,
    v47813: ( state_type * $int ) > $o ).

tff(pred_def_26130,type,
    v47826: state_type > $o ).

tff(pred_def_26131,type,
    v47825: ( state_type * $int ) > $o ).

tff(pred_def_26132,type,
    v47824: ( state_type * $int ) > $o ).

tff(pred_def_26133,type,
    v47812: ( state_type * $int ) > $o ).

tff(pred_def_26134,type,
    v47829: state_type > $o ).

tff(pred_def_26135,type,
    v47828: ( state_type * $int ) > $o ).

tff(pred_def_26136,type,
    v47827: ( state_type * $int ) > $o ).

tff(pred_def_26137,type,
    v47811: ( state_type * $int ) > $o ).

tff(pred_def_26138,type,
    v47832: state_type > $o ).

tff(pred_def_26139,type,
    v47831: ( state_type * $int ) > $o ).

tff(pred_def_26140,type,
    v47830: ( state_type * $int ) > $o ).

tff(pred_def_26141,type,
    v46303: ( state_type * $int ) > $o ).

tff(pred_def_26142,type,
    v46301: ( state_type * $int ) > $o ).

tff(pred_def_26143,type,
    v46299: ( state_type * $int ) > $o ).

tff(pred_def_26144,type,
    v46297: ( state_type * $int ) > $o ).

tff(pred_def_26145,type,
    v46295: ( state_type * $int ) > $o ).

tff(pred_def_26146,type,
    v46289: state_type > $o ).

tff(pred_def_26147,type,
    v46287: state_type > $o ).

tff(pred_def_26148,type,
    v46285: state_type > $o ).

tff(pred_def_26149,type,
    v47843: ( state_type * $int ) > $o ).

tff(pred_def_26150,type,
    v47841: ( state_type * $int ) > $o ).

tff(pred_def_26151,type,
    v47877: state_type > $o ).

tff(pred_def_26152,type,
    v47875: state_type > $o ).

tff(pred_def_26153,type,
    v47873: state_type > $o ).

tff(pred_def_26154,type,
    v47871: state_type > $o ).

tff(pred_def_26155,type,
    v47869: state_type > $o ).

tff(pred_def_26156,type,
    v47867: state_type > $o ).

tff(pred_def_26157,type,
    v47865: state_type > $o ).

tff(pred_def_26158,type,
    v47891: state_type > $o ).

tff(pred_def_26159,type,
    v47889: state_type > $o ).

tff(pred_def_26160,type,
    v47887: state_type > $o ).

tff(pred_def_26161,type,
    v47885: state_type > $o ).

tff(pred_def_26162,type,
    v47883: state_type > $o ).

tff(pred_def_26163,type,
    v47881: state_type > $o ).

tff(pred_def_26164,type,
    v47879: state_type > $o ).

tff(pred_def_26165,type,
    v47917: state_type > $o ).

tff(pred_def_26166,type,
    v47919: state_type > $o ).

tff(pred_def_26167,type,
    v47918: ( state_type * $int ) > $o ).

tff(pred_def_26168,type,
    v47920: state_type > $o ).

tff(pred_def_26169,type,
    v47915: ( state_type * $int ) > $o ).

tff(pred_def_26170,type,
    v47913: ( state_type * $int ) > $o ).

tff(pred_def_26171,type,
    v47921: ( state_type * $int ) > $o ).

tff(pred_def_26172,type,
    v47911: ( state_type * $int ) > $o ).

tff(pred_def_26173,type,
    v47909: ( state_type * $int ) > $o ).

tff(pred_def_26174,type,
    v47907: state_type > $o ).

tff(pred_def_26175,type,
    v47923: state_type > $o ).

tff(pred_def_26176,type,
    v47905: ( state_type * $int ) > $o ).

tff(pred_def_26177,type,
    v47903: ( state_type * $int ) > $o ).

tff(pred_def_26178,type,
    v47937: ( state_type * $int ) > $o ).

tff(pred_def_26179,type,
    v47935: ( state_type * $int ) > $o ).

tff(pred_def_26180,type,
    v47941: state_type > $o ).

tff(pred_def_26181,type,
    v47939: state_type > $o ).

tff(pred_def_26182,type,
    v47965: state_type > $o ).

tff(pred_def_26183,type,
    v47963: state_type > $o ).

tff(pred_def_26184,type,
    v47961: state_type > $o ).

tff(pred_def_26185,type,
    v47959: state_type > $o ).

tff(pred_def_26186,type,
    v47957: state_type > $o ).

tff(pred_def_26187,type,
    v47955: state_type > $o ).

tff(pred_def_26188,type,
    v47953: state_type > $o ).

tff(pred_def_26189,type,
    v47979: state_type > $o ).

tff(pred_def_26190,type,
    v47977: state_type > $o ).

tff(pred_def_26191,type,
    v47975: state_type > $o ).

tff(pred_def_26192,type,
    v47973: state_type > $o ).

tff(pred_def_26193,type,
    v47971: state_type > $o ).

tff(pred_def_26194,type,
    v47969: state_type > $o ).

tff(pred_def_26195,type,
    v47967: state_type > $o ).

tff(pred_def_26196,type,
    v47995: ( state_type * $int ) > $o ).

tff(pred_def_26197,type,
    v47993: ( state_type * $int ) > $o ).

tff(pred_def_26198,type,
    v47991: ( state_type * $int ) > $o ).

tff(pred_def_26199,type,
    v47989: ( state_type * $int ) > $o ).

tff(pred_def_26200,type,
    v47987: ( state_type * $int ) > $o ).

tff(pred_def_26201,type,
    v48025: ( state_type * $int ) > $o ).

tff(pred_def_26202,type,
    v48027: ( state_type * $int ) > $o ).

tff(pred_def_26203,type,
    v48023: ( state_type * $int ) > $o ).

tff(pred_def_26204,type,
    v48021: ( state_type * $int ) > $o ).

tff(pred_def_26205,type,
    v48019: ( state_type * $int ) > $o ).

tff(pred_def_26206,type,
    v48017: ( state_type * $int ) > $o ).

tff(pred_def_26207,type,
    v48015: state_type > $o ).

tff(pred_def_26208,type,
    v48013: state_type > $o ).

tff(pred_def_26209,type,
    v48031: state_type > $o ).

tff(pred_def_26210,type,
    v48029: state_type > $o ).

tff(pred_def_26211,type,
    v48033: state_type > $o ).

tff(pred_def_26212,type,
    v48011: state_type > $o ).

tff(pred_def_26213,type,
    v48009: state_type > $o ).

tff(pred_def_26214,type,
    v48007: state_type > $o ).

tff(pred_def_26215,type,
    v48005: state_type > $o ).

tff(pred_def_26216,type,
    v48003: state_type > $o ).

tff(pred_def_26217,type,
    v48001: state_type > $o ).

tff(pred_def_26218,type,
    v47999: state_type > $o ).

tff(pred_def_26219,type,
    v47997: state_type > $o ).

tff(pred_def_26220,type,
    v48043: ( state_type * $int ) > $o ).

tff(pred_def_26221,type,
    v48041: ( state_type * $int ) > $o ).

tff(pred_def_26222,type,
    v48039: ( state_type * $int ) > $o ).

tff(pred_def_26223,type,
    v48037: ( state_type * $int ) > $o ).

tff(pred_def_26224,type,
    v48035: ( state_type * $int ) > $o ).

tff(pred_def_26225,type,
    v48073: ( state_type * $int ) > $o ).

tff(pred_def_26226,type,
    v48071: ( state_type * $int ) > $o ).

tff(pred_def_26227,type,
    v48074: ( state_type * $int ) > $o ).

tff(pred_def_26228,type,
    v48069: ( state_type * $int ) > $o ).

tff(pred_def_26229,type,
    v48067: ( state_type * $int ) > $o ).

tff(pred_def_26230,type,
    v48065: ( state_type * $int ) > $o ).

tff(pred_def_26231,type,
    v48063: state_type > $o ).

tff(pred_def_26232,type,
    v48061: state_type > $o ).

tff(pred_def_26233,type,
    v48078: state_type > $o ).

tff(pred_def_26234,type,
    v48076: state_type > $o ).

tff(pred_def_26235,type,
    v48080: state_type > $o ).

tff(pred_def_26236,type,
    v48059: state_type > $o ).

tff(pred_def_26237,type,
    v48057: state_type > $o ).

tff(pred_def_26238,type,
    v48055: state_type > $o ).

tff(pred_def_26239,type,
    v48053: state_type > $o ).

tff(pred_def_26240,type,
    v48051: state_type > $o ).

tff(pred_def_26241,type,
    v48049: state_type > $o ).

tff(pred_def_26242,type,
    v48047: state_type > $o ).

tff(pred_def_26243,type,
    v48045: state_type > $o ).

tff(pred_def_26244,type,
    v48090: ( state_type * $int ) > $o ).

tff(pred_def_26245,type,
    v48088: ( state_type * $int ) > $o ).

tff(pred_def_26246,type,
    v48086: ( state_type * $int ) > $o ).

tff(pred_def_26247,type,
    v48084: ( state_type * $int ) > $o ).

tff(pred_def_26248,type,
    v48082: ( state_type * $int ) > $o ).

tff(pred_def_26249,type,
    v48110: state_type > $o ).

tff(pred_def_26250,type,
    v48108: state_type > $o ).

tff(pred_def_26251,type,
    v48114: state_type > $o ).

tff(pred_def_26252,type,
    v48112: state_type > $o ).

tff(pred_def_26253,type,
    v48116: state_type > $o ).

tff(pred_def_26254,type,
    v48106: state_type > $o ).

tff(pred_def_26255,type,
    v48104: state_type > $o ).

tff(pred_def_26256,type,
    v48102: state_type > $o ).

tff(pred_def_26257,type,
    v48100: state_type > $o ).

tff(pred_def_26258,type,
    v48098: state_type > $o ).

tff(pred_def_26259,type,
    v48096: state_type > $o ).

tff(pred_def_26260,type,
    v48094: state_type > $o ).

tff(pred_def_26261,type,
    v48092: state_type > $o ).

tff(pred_def_26262,type,
    v48126: ( state_type * $int ) > $o ).

tff(pred_def_26263,type,
    v48124: ( state_type * $int ) > $o ).

tff(pred_def_26264,type,
    v48122: ( state_type * $int ) > $o ).

tff(pred_def_26265,type,
    v48120: ( state_type * $int ) > $o ).

tff(pred_def_26266,type,
    v48118: ( state_type * $int ) > $o ).

tff(pred_def_26267,type,
    v48146: state_type > $o ).

tff(pred_def_26268,type,
    v48144: state_type > $o ).

tff(pred_def_26269,type,
    v48150: state_type > $o ).

tff(pred_def_26270,type,
    v48148: state_type > $o ).

tff(pred_def_26271,type,
    v48152: state_type > $o ).

tff(pred_def_26272,type,
    v48142: state_type > $o ).

tff(pred_def_26273,type,
    v48140: state_type > $o ).

tff(pred_def_26274,type,
    v48138: state_type > $o ).

tff(pred_def_26275,type,
    v48136: state_type > $o ).

tff(pred_def_26276,type,
    v48134: state_type > $o ).

tff(pred_def_26277,type,
    v48132: state_type > $o ).

tff(pred_def_26278,type,
    v48130: state_type > $o ).

tff(pred_def_26279,type,
    v48128: state_type > $o ).

tff(pred_def_26280,type,
    v48158: state_type > $o ).

tff(pred_def_26281,type,
    v48157: ( state_type * $int ) > $o ).

tff(pred_def_26282,type,
    v48156: ( state_type * $int ) > $o ).

tff(pred_def_26283,type,
    v48161: state_type > $o ).

tff(pred_def_26284,type,
    v48160: ( state_type * $int ) > $o ).

tff(pred_def_26285,type,
    v48159: ( state_type * $int ) > $o ).

tff(pred_def_26286,type,
    v48155: ( state_type * $int ) > $o ).

tff(pred_def_26287,type,
    v48164: state_type > $o ).

tff(pred_def_26288,type,
    v48163: ( state_type * $int ) > $o ).

tff(pred_def_26289,type,
    v48162: ( state_type * $int ) > $o ).

tff(pred_def_26290,type,
    v48154: ( state_type * $int ) > $o ).

tff(pred_def_26291,type,
    v48167: state_type > $o ).

tff(pred_def_26292,type,
    v48166: ( state_type * $int ) > $o ).

tff(pred_def_26293,type,
    v48165: ( state_type * $int ) > $o ).

tff(pred_def_26294,type,
    v47985: ( state_type * $int ) > $o ).

tff(pred_def_26295,type,
    v47983: ( state_type * $int ) > $o ).

tff(pred_def_26296,type,
    v47981: ( state_type * $int ) > $o ).

tff(pred_def_26297,type,
    v48179: state_type > $o ).

tff(pred_def_26298,type,
    v48177: state_type > $o ).

tff(pred_def_26299,type,
    v48175: state_type > $o ).

tff(pred_def_26300,type,
    v48189: state_type > $o ).

tff(pred_def_26301,type,
    v48187: state_type > $o ).

tff(pred_def_26302,type,
    v48185: state_type > $o ).

tff(pred_def_26303,type,
    v48183: state_type > $o ).

tff(pred_def_26304,type,
    v48181: state_type > $o ).

tff(pred_def_26305,type,
    v48191: state_type > $o ).

tff(pred_def_26306,type,
    v48173: state_type > $o ).

tff(pred_def_26307,type,
    v48171: state_type > $o ).

tff(pred_def_26308,type,
    v48169: state_type > $o ).

tff(pred_def_26309,type,
    v48198: state_type > $o ).

tff(pred_def_26310,type,
    v48196: state_type > $o ).

tff(pred_def_26311,type,
    v48195: state_type > $o ).

tff(pred_def_26312,type,
    v48194: state_type > $o ).

tff(pred_def_26313,type,
    v48206: state_type > $o ).

tff(pred_def_26314,type,
    v48207: state_type > $o ).

tff(pred_def_26315,type,
    v48205: state_type > $o ).

tff(pred_def_26316,type,
    v48202: ( state_type * $int ) > $o ).

tff(pred_def_26317,type,
    v48204: ( state_type * $int ) > $o ).

tff(pred_def_26318,type,
    v47951: ( state_type * $int ) > $o ).

tff(pred_def_26319,type,
    v47949: ( state_type * $int ) > $o ).

tff(pred_def_26320,type,
    v47947: ( state_type * $int ) > $o ).

tff(pred_def_26321,type,
    v47945: ( state_type * $int ) > $o ).

tff(pred_def_26322,type,
    v47943: ( state_type * $int ) > $o ).

tff(pred_def_26323,type,
    v48213: state_type > $o ).

tff(pred_def_26324,type,
    v48211: state_type > $o ).

tff(pred_def_26325,type,
    v48217: state_type > $o ).

tff(pred_def_26326,type,
    v48216: ( state_type * $int ) > $o ).

tff(pred_def_26327,type,
    v48215: ( state_type * $int ) > $o ).

tff(pred_def_26328,type,
    v48220: state_type > $o ).

tff(pred_def_26329,type,
    v48219: ( state_type * $int ) > $o ).

tff(pred_def_26330,type,
    v48218: ( state_type * $int ) > $o ).

tff(pred_def_26331,type,
    v47933: ( state_type * $int ) > $o ).

tff(pred_def_26332,type,
    v47931: ( state_type * $int ) > $o ).

tff(pred_def_26333,type,
    v47929: ( state_type * $int ) > $o ).

tff(pred_def_26334,type,
    v47927: ( state_type * $int ) > $o ).

tff(pred_def_26335,type,
    v47925: ( state_type * $int ) > $o ).

tff(pred_def_26336,type,
    v47901: ( state_type * $int ) > $o ).

tff(pred_def_26337,type,
    v47899: ( state_type * $int ) > $o ).

tff(pred_def_26338,type,
    v47897: ( state_type * $int ) > $o ).

tff(pred_def_26339,type,
    v47895: ( state_type * $int ) > $o ).

tff(pred_def_26340,type,
    v47893: ( state_type * $int ) > $o ).

tff(pred_def_26341,type,
    v48233: state_type > $o ).

tff(pred_def_26342,type,
    v48231: state_type > $o ).

tff(pred_def_26343,type,
    v48229: state_type > $o ).

tff(pred_def_26344,type,
    v48239: state_type > $o ).

tff(pred_def_26345,type,
    v48237: state_type > $o ).

tff(pred_def_26346,type,
    v48257: ( state_type * $int ) > $o ).

tff(pred_def_26347,type,
    v48259: ( state_type * $int ) > $o ).

tff(pred_def_26348,type,
    v48255: ( state_type * $int ) > $o ).

tff(pred_def_26349,type,
    v48253: state_type > $o ).

tff(pred_def_26350,type,
    v48251: state_type > $o ).

tff(pred_def_26351,type,
    v48263: state_type > $o ).

tff(pred_def_26352,type,
    v48261: state_type > $o ).

tff(pred_def_26353,type,
    v48267: state_type > $o ).

tff(pred_def_26354,type,
    v48265: state_type > $o ).

tff(pred_def_26355,type,
    v48270: state_type > $o ).

tff(pred_def_26356,type,
    v48269: state_type > $o ).

tff(pred_def_26357,type,
    v48249: state_type > $o ).

tff(pred_def_26358,type,
    v48247: state_type > $o ).

tff(pred_def_26359,type,
    v48245: state_type > $o ).

tff(pred_def_26360,type,
    v48243: state_type > $o ).

tff(pred_def_26361,type,
    v48241: state_type > $o ).

tff(pred_def_26362,type,
    v48278: state_type > $o ).

tff(pred_def_26363,type,
    v48276: state_type > $o ).

tff(pred_def_26364,type,
    v48274: state_type > $o ).

tff(pred_def_26365,type,
    v48272: state_type > $o ).

tff(pred_def_26366,type,
    v48235: state_type > $o ).

tff(pred_def_26367,type,
    v48284: state_type > $o ).

tff(pred_def_26368,type,
    v48286: state_type > $o ).

tff(pred_def_26369,type,
    v48282: state_type > $o ).

tff(pred_def_26370,type,
    v48281: state_type > $o ).

tff(pred_def_26371,type,
    v48292: state_type > $o ).

tff(pred_def_26372,type,
    v48293: state_type > $o ).

tff(pred_def_26373,type,
    v48289: state_type > $o ).

tff(pred_def_26374,type,
    v48291: state_type > $o ).

tff(pred_def_26375,type,
    v48303: state_type > $o ).

tff(pred_def_26376,type,
    v48301: state_type > $o ).

tff(pred_def_26377,type,
    v48299: state_type > $o ).

tff(pred_def_26378,type,
    v48297: state_type > $o ).

tff(pred_def_26379,type,
    v48305: state_type > $o ).

tff(pred_def_26380,type,
    v48227: state_type > $o ).

tff(pred_def_26381,type,
    v48225: state_type > $o ).

tff(pred_def_26382,type,
    v48223: state_type > $o ).

tff(pred_def_26383,type,
    v48312: state_type > $o ).

tff(pred_def_26384,type,
    v48310: state_type > $o ).

tff(pred_def_26385,type,
    v48309: state_type > $o ).

tff(pred_def_26386,type,
    v48308: state_type > $o ).

tff(pred_def_26387,type,
    v48320: state_type > $o ).

tff(pred_def_26388,type,
    v48321: state_type > $o ).

tff(pred_def_26389,type,
    v48319: state_type > $o ).

tff(pred_def_26390,type,
    v48316: ( state_type * $int ) > $o ).

tff(pred_def_26391,type,
    v48318: ( state_type * $int ) > $o ).

tff(pred_def_26392,type,
    v47863: ( state_type * $int ) > $o ).

tff(pred_def_26393,type,
    v47861: ( state_type * $int ) > $o ).

tff(pred_def_26394,type,
    v47859: ( state_type * $int ) > $o ).

tff(pred_def_26395,type,
    v47857: ( state_type * $int ) > $o ).

tff(pred_def_26396,type,
    v47855: ( state_type * $int ) > $o ).

tff(pred_def_26397,type,
    v48357: state_type > $o ).

tff(pred_def_26398,type,
    v48355: state_type > $o ).

tff(pred_def_26399,type,
    v48353: state_type > $o ).

tff(pred_def_26400,type,
    v48351: state_type > $o ).

tff(pred_def_26401,type,
    v48349: state_type > $o ).

tff(pred_def_26402,type,
    v48347: state_type > $o ).

tff(pred_def_26403,type,
    v48367: state_type > $o ).

tff(pred_def_26404,type,
    v48365: state_type > $o ).

tff(pred_def_26405,type,
    v48363: state_type > $o ).

tff(pred_def_26406,type,
    v48361: state_type > $o ).

tff(pred_def_26407,type,
    v48359: state_type > $o ).

tff(pred_def_26408,type,
    v48394: state_type > $o ).

tff(pred_def_26409,type,
    v48393: ( state_type * $int ) > $o ).

tff(pred_def_26410,type,
    v48392: ( state_type * $int ) > $o ).

tff(pred_def_26411,type,
    v48390: ( state_type * $int ) > $o ).

tff(pred_def_26412,type,
    v48410: state_type > $o ).

tff(pred_def_26413,type,
    v48411: ( state_type * $int ) > $o ).

tff(pred_def_26414,type,
    v48412: state_type > $o ).

tff(pred_def_26415,type,
    v48408: ( state_type * $int ) > $o ).

tff(pred_def_26416,type,
    v48406: ( state_type * $int ) > $o ).

tff(pred_def_26417,type,
    v48436: ( state_type * $int ) > $o ).

tff(pred_def_26418,type,
    v48345: ( state_type * $int ) > $o ).

tff(pred_def_26419,type,
    v48434: ( state_type * $int ) > $o ).

tff(pred_def_26420,type,
    v48437: ( state_type * $int ) > $o ).

tff(pred_def_26421,type,
    v48432: ( state_type * $int ) > $o ).

tff(pred_def_26422,type,
    v48430: ( state_type * $int ) > $o ).

tff(pred_def_26423,type,
    v48428: ( state_type * $int ) > $o ).

tff(pred_def_26424,type,
    v48426: state_type > $o ).

tff(pred_def_26425,type,
    v48424: state_type > $o ).

tff(pred_def_26426,type,
    v48443: state_type > $o ).

tff(pred_def_26427,type,
    v48383: state_type > $o ).

tff(pred_def_26428,type,
    v48442: ( state_type * $int ) > $o ).

tff(pred_def_26429,type,
    v48381: ( state_type * $int ) > $o ).

tff(pred_def_26430,type,
    v48379: ( state_type * $int ) > $o ).

tff(pred_def_26431,type,
    v48458: ( state_type * $int ) > $o ).

tff(pred_def_26432,type,
    v48457: ( state_type * $int ) > $o ).

tff(pred_def_26433,type,
    v48455: ( state_type * $int ) > $o ).

tff(pred_def_26434,type,
    v48462: state_type > $o ).

tff(pred_def_26435,type,
    v48460: state_type > $o ).

tff(pred_def_26436,type,
    v48473: ( state_type * $int ) > $o ).

tff(pred_def_26437,type,
    v48472: state_type > $o ).

tff(pred_def_26438,type,
    v48476: state_type > $o ).

tff(pred_def_26439,type,
    v48477: state_type > $o ).

tff(pred_def_26440,type,
    v48475: state_type > $o ).

tff(pred_def_26441,type,
    v48478: state_type > $o ).

tff(pred_def_26442,type,
    v48474: state_type > $o ).

tff(pred_def_26443,type,
    v48471: state_type > $o ).

tff(pred_def_26444,type,
    v48479: state_type > $o ).

tff(pred_def_26445,type,
    v48470: state_type > $o ).

tff(pred_def_26446,type,
    v48482: state_type > $o ).

tff(pred_def_26447,type,
    v48483: state_type > $o ).

tff(pred_def_26448,type,
    v48481: state_type > $o ).

tff(pred_def_26449,type,
    v48484: state_type > $o ).

tff(pred_def_26450,type,
    v48480: state_type > $o ).

tff(pred_def_26451,type,
    v48469: state_type > $o ).

tff(pred_def_26452,type,
    v48485: state_type > $o ).

tff(pred_def_26453,type,
    v48468: state_type > $o ).

tff(pred_def_26454,type,
    v48467: state_type > $o ).

tff(pred_def_26455,type,
    v48489: state_type > $o ).

tff(pred_def_26456,type,
    v48490: state_type > $o ).

tff(pred_def_26457,type,
    v48488: state_type > $o ).

tff(pred_def_26458,type,
    v48491: state_type > $o ).

tff(pred_def_26459,type,
    v48487: state_type > $o ).

tff(pred_def_26460,type,
    v48486: state_type > $o ).

tff(pred_def_26461,type,
    v48466: state_type > $o ).

tff(pred_def_26462,type,
    v48492: state_type > $o ).

tff(pred_def_26463,type,
    v48465: state_type > $o ).

tff(pred_def_26464,type,
    v48495: state_type > $o ).

tff(pred_def_26465,type,
    v48496: state_type > $o ).

tff(pred_def_26466,type,
    v48494: state_type > $o ).

tff(pred_def_26467,type,
    v48497: state_type > $o ).

tff(pred_def_26468,type,
    v48493: state_type > $o ).

tff(pred_def_26469,type,
    v48500: state_type > $o ).

tff(pred_def_26470,type,
    v48501: state_type > $o ).

tff(pred_def_26471,type,
    v48499: state_type > $o ).

tff(pred_def_26472,type,
    v48502: state_type > $o ).

tff(pred_def_26473,type,
    v48498: state_type > $o ).

tff(pred_def_26474,type,
    v48505: state_type > $o ).

tff(pred_def_26475,type,
    v48506: state_type > $o ).

tff(pred_def_26476,type,
    v48504: state_type > $o ).

tff(pred_def_26477,type,
    v48507: state_type > $o ).

tff(pred_def_26478,type,
    v48503: state_type > $o ).

tff(pred_def_26479,type,
    v48463: ( state_type * $int ) > $o ).

tff(pred_def_26480,type,
    v48453: ( state_type * $int ) > $o ).

tff(pred_def_26481,type,
    v48451: ( state_type * $int ) > $o ).

tff(pred_def_26482,type,
    v48449: ( state_type * $int ) > $o ).

tff(pred_def_26483,type,
    v48447: ( state_type * $int ) > $o ).

tff(pred_def_26484,type,
    v48445: ( state_type * $int ) > $o ).

tff(pred_def_26485,type,
    v48508: ( state_type * $int ) > $o ).

tff(pred_def_26486,type,
    v48377: ( state_type * $int ) > $o ).

tff(pred_def_26487,type,
    v48375: ( state_type * $int ) > $o ).

tff(pred_def_26488,type,
    v48373: ( state_type * $int ) > $o ).

tff(pred_def_26489,type,
    v48509: ( state_type * $int ) > $o ).

tff(pred_def_26490,type,
    v48510: ( state_type * $int ) > $o ).

tff(pred_def_26491,type,
    v48371: ( state_type * $int ) > $o ).

tff(pred_def_26492,type,
    v48369: ( state_type * $int ) > $o ).

tff(pred_def_26493,type,
    v48520: state_type > $o ).

tff(pred_def_26494,type,
    v48518: state_type > $o ).

tff(pred_def_26495,type,
    v48526: state_type > $o ).

tff(pred_def_26496,type,
    v48524: state_type > $o ).

tff(pred_def_26497,type,
    v48530: state_type > $o ).

tff(pred_def_26498,type,
    v48528: state_type > $o ).

tff(pred_def_26499,type,
    v48534: state_type > $o ).

tff(pred_def_26500,type,
    v48532: state_type > $o ).

tff(pred_def_26501,type,
    v48522: state_type > $o ).

tff(pred_def_26502,type,
    v48540: state_type > $o ).

tff(pred_def_26503,type,
    v48542: state_type > $o ).

tff(pred_def_26504,type,
    v48538: state_type > $o ).

tff(pred_def_26505,type,
    v48537: state_type > $o ).

tff(pred_def_26506,type,
    v48548: state_type > $o ).

tff(pred_def_26507,type,
    v48549: state_type > $o ).

tff(pred_def_26508,type,
    v48545: state_type > $o ).

tff(pred_def_26509,type,
    v48547: state_type > $o ).

tff(pred_def_26510,type,
    v48555: state_type > $o ).

tff(pred_def_26511,type,
    v48553: state_type > $o ).

tff(pred_def_26512,type,
    v48557: state_type > $o ).

tff(pred_def_26513,type,
    v48516: state_type > $o ).

tff(pred_def_26514,type,
    v48514: state_type > $o ).

tff(pred_def_26515,type,
    v48512: state_type > $o ).

tff(pred_def_26516,type,
    v48564: state_type > $o ).

tff(pred_def_26517,type,
    v48562: state_type > $o ).

tff(pred_def_26518,type,
    v48561: state_type > $o ).

tff(pred_def_26519,type,
    v48560: state_type > $o ).

tff(pred_def_26520,type,
    v48572: state_type > $o ).

tff(pred_def_26521,type,
    v48573: state_type > $o ).

tff(pred_def_26522,type,
    v48571: state_type > $o ).

tff(pred_def_26523,type,
    v48568: ( state_type * $int ) > $o ).

tff(pred_def_26524,type,
    v48570: ( state_type * $int ) > $o ).

tff(pred_def_26525,type,
    v48559: ( state_type * $int ) > $o ).

tff(pred_def_26526,type,
    v48441: state_type > $o ).

tff(pred_def_26527,type,
    v48439: state_type > $o ).

tff(pred_def_26528,type,
    v48585: state_type > $o ).

tff(pred_def_26529,type,
    v48583: state_type > $o ).

tff(pred_def_26530,type,
    v48582: state_type > $o ).

tff(pred_def_26531,type,
    v48581: ( state_type * $int ) > $o ).

tff(pred_def_26532,type,
    v48579: state_type > $o ).

tff(pred_def_26533,type,
    v48577: state_type > $o ).

tff(pred_def_26534,type,
    v48590: state_type > $o ).

tff(pred_def_26535,type,
    v48589: state_type > $o ).

tff(pred_def_26536,type,
    v48422: state_type > $o ).

tff(pred_def_26537,type,
    v48420: state_type > $o ).

tff(pred_def_26538,type,
    v48418: state_type > $o ).

tff(pred_def_26539,type,
    v48591: ( state_type * $int ) > $o ).

tff(pred_def_26540,type,
    v48592: state_type > $o ).

tff(pred_def_26541,type,
    v48416: ( state_type * $int ) > $o ).

tff(pred_def_26542,type,
    v48414: ( state_type * $int ) > $o ).

tff(pred_def_26543,type,
    v48593: ( state_type * $int ) > $o ).

tff(pred_def_26544,type,
    v48404: ( state_type * $int ) > $o ).

tff(pred_def_26545,type,
    v48402: ( state_type * $int ) > $o ).

tff(pred_def_26546,type,
    v48400: state_type > $o ).

tff(pred_def_26547,type,
    v48594: ( state_type * $int ) > $o ).

tff(pred_def_26548,type,
    v48595: state_type > $o ).

tff(pred_def_26549,type,
    v48398: ( state_type * $int ) > $o ).

tff(pred_def_26550,type,
    v48396: ( state_type * $int ) > $o ).

tff(pred_def_26551,type,
    v48596: ( state_type * $int ) > $o ).

tff(pred_def_26552,type,
    v48388: ( state_type * $int ) > $o ).

tff(pred_def_26553,type,
    v48386: ( state_type * $int ) > $o ).

tff(pred_def_26554,type,
    v48602: state_type > $o ).

tff(pred_def_26555,type,
    v48600: state_type > $o ).

tff(pred_def_26556,type,
    v48599: state_type > $o ).

tff(pred_def_26557,type,
    v48598: ( state_type * $int ) > $o ).

tff(pred_def_26558,type,
    v48343: state_type > $o ).

tff(pred_def_26559,type,
    v48341: state_type > $o ).

tff(pred_def_26560,type,
    v48608: state_type > $o ).

tff(pred_def_26561,type,
    v48606: state_type > $o ).

tff(pred_def_26562,type,
    v48612: state_type > $o ).

tff(pred_def_26563,type,
    v48610: state_type > $o ).

tff(pred_def_26564,type,
    v48615: state_type > $o ).

tff(pred_def_26565,type,
    v48614: state_type > $o ).

tff(pred_def_26566,type,
    v48339: state_type > $o ).

tff(pred_def_26567,type,
    v48337: state_type > $o ).

tff(pred_def_26568,type,
    v48335: state_type > $o ).

tff(pred_def_26569,type,
    v48333: state_type > $o ).

tff(pred_def_26570,type,
    v48331: state_type > $o ).

tff(pred_def_26571,type,
    v48329: state_type > $o ).

tff(pred_def_26572,type,
    v48327: state_type > $o ).

tff(pred_def_26573,type,
    v48325: state_type > $o ).

tff(pred_def_26574,type,
    v48635: state_type > $o ).

tff(pred_def_26575,type,
    v48633: state_type > $o ).

tff(pred_def_26576,type,
    v48631: state_type > $o ).

tff(pred_def_26577,type,
    v48629: state_type > $o ).

tff(pred_def_26578,type,
    v48627: state_type > $o ).

tff(pred_def_26579,type,
    v48645: state_type > $o ).

tff(pred_def_26580,type,
    v48643: state_type > $o ).

tff(pred_def_26581,type,
    v48641: state_type > $o ).

tff(pred_def_26582,type,
    v48639: state_type > $o ).

tff(pred_def_26583,type,
    v48637: state_type > $o ).

tff(pred_def_26584,type,
    v48649: ( state_type * $int ) > $o ).

tff(pred_def_26585,type,
    v48647: ( state_type * $int ) > $o ).

tff(pred_def_26586,type,
    v48659: state_type > $o ).

tff(pred_def_26587,type,
    v48657: state_type > $o ).

tff(pred_def_26588,type,
    v48665: state_type > $o ).

tff(pred_def_26589,type,
    v48663: state_type > $o ).

tff(pred_def_26590,type,
    v48689: ( state_type * $int ) > $o ).

tff(pred_def_26591,type,
    v48687: ( state_type * $int ) > $o ).

tff(pred_def_26592,type,
    v48690: ( state_type * $int ) > $o ).

tff(pred_def_26593,type,
    v48685: ( state_type * $int ) > $o ).

tff(pred_def_26594,type,
    v48683: ( state_type * $int ) > $o ).

tff(pred_def_26595,type,
    v48681: ( state_type * $int ) > $o ).

tff(pred_def_26596,type,
    v48679: state_type > $o ).

tff(pred_def_26597,type,
    v48677: state_type > $o ).

tff(pred_def_26598,type,
    v48694: state_type > $o ).

tff(pred_def_26599,type,
    v48692: state_type > $o ).

tff(pred_def_26600,type,
    v48698: state_type > $o ).

tff(pred_def_26601,type,
    v48696: state_type > $o ).

tff(pred_def_26602,type,
    v48701: state_type > $o ).

tff(pred_def_26603,type,
    v48700: state_type > $o ).

tff(pred_def_26604,type,
    v48675: state_type > $o ).

tff(pred_def_26605,type,
    v48673: state_type > $o ).

tff(pred_def_26606,type,
    v48671: state_type > $o ).

tff(pred_def_26607,type,
    v48669: state_type > $o ).

tff(pred_def_26608,type,
    v48667: state_type > $o ).

tff(pred_def_26609,type,
    v48705: state_type > $o ).

tff(pred_def_26610,type,
    v48703: state_type > $o ).

tff(pred_def_26611,type,
    v48661: state_type > $o ).

tff(pred_def_26612,type,
    v48711: state_type > $o ).

tff(pred_def_26613,type,
    v48713: state_type > $o ).

tff(pred_def_26614,type,
    v48709: state_type > $o ).

tff(pred_def_26615,type,
    v48708: state_type > $o ).

tff(pred_def_26616,type,
    v48719: state_type > $o ).

tff(pred_def_26617,type,
    v48720: state_type > $o ).

tff(pred_def_26618,type,
    v48716: state_type > $o ).

tff(pred_def_26619,type,
    v48718: state_type > $o ).

tff(pred_def_26620,type,
    v48726: state_type > $o ).

tff(pred_def_26621,type,
    v48724: state_type > $o ).

tff(pred_def_26622,type,
    v48728: state_type > $o ).

tff(pred_def_26623,type,
    v48655: state_type > $o ).

tff(pred_def_26624,type,
    v48653: state_type > $o ).

tff(pred_def_26625,type,
    v48651: state_type > $o ).

tff(pred_def_26626,type,
    v48735: state_type > $o ).

tff(pred_def_26627,type,
    v48733: state_type > $o ).

tff(pred_def_26628,type,
    v48732: state_type > $o ).

tff(pred_def_26629,type,
    v48731: state_type > $o ).

tff(pred_def_26630,type,
    v48743: state_type > $o ).

tff(pred_def_26631,type,
    v48744: state_type > $o ).

tff(pred_def_26632,type,
    v48742: state_type > $o ).

tff(pred_def_26633,type,
    v48739: ( state_type * $int ) > $o ).

tff(pred_def_26634,type,
    v48741: ( state_type * $int ) > $o ).

tff(pred_def_26635,type,
    v48625: ( state_type * $int ) > $o ).

tff(pred_def_26636,type,
    v48623: ( state_type * $int ) > $o ).

tff(pred_def_26637,type,
    v48621: ( state_type * $int ) > $o ).

tff(pred_def_26638,type,
    v48619: ( state_type * $int ) > $o ).

tff(pred_def_26639,type,
    v48617: ( state_type * $int ) > $o ).

tff(pred_def_26640,type,
    v48766: state_type > $o ).

tff(pred_def_26641,type,
    v48764: state_type > $o ).

tff(pred_def_26642,type,
    v48770: state_type > $o ).

tff(pred_def_26643,type,
    v48768: state_type > $o ).

tff(pred_def_26644,type,
    v48774: state_type > $o ).

tff(pred_def_26645,type,
    v48772: state_type > $o ).

tff(pred_def_26646,type,
    v48777: state_type > $o ).

tff(pred_def_26647,type,
    v48776: state_type > $o ).

tff(pred_def_26648,type,
    v48762: state_type > $o ).

tff(pred_def_26649,type,
    v48760: state_type > $o ).

tff(pred_def_26650,type,
    v48758: state_type > $o ).

tff(pred_def_26651,type,
    v48756: state_type > $o ).

tff(pred_def_26652,type,
    v48754: state_type > $o ).

tff(pred_def_26653,type,
    v48752: state_type > $o ).

tff(pred_def_26654,type,
    v48750: state_type > $o ).

tff(pred_def_26655,type,
    v48748: state_type > $o ).

tff(pred_def_26656,type,
    v48797: state_type > $o ).

tff(pred_def_26657,type,
    v48795: state_type > $o ).

tff(pred_def_26658,type,
    v48793: state_type > $o ).

tff(pred_def_26659,type,
    v48791: state_type > $o ).

tff(pred_def_26660,type,
    v48789: state_type > $o ).

tff(pred_def_26661,type,
    v48807: state_type > $o ).

tff(pred_def_26662,type,
    v48805: state_type > $o ).

tff(pred_def_26663,type,
    v48803: state_type > $o ).

tff(pred_def_26664,type,
    v48801: state_type > $o ).

tff(pred_def_26665,type,
    v48799: state_type > $o ).

tff(pred_def_26666,type,
    v48811: ( state_type * $int ) > $o ).

tff(pred_def_26667,type,
    v48809: ( state_type * $int ) > $o ).

tff(pred_def_26668,type,
    v48821: state_type > $o ).

tff(pred_def_26669,type,
    v48819: state_type > $o ).

tff(pred_def_26670,type,
    v48827: state_type > $o ).

tff(pred_def_26671,type,
    v48825: state_type > $o ).

tff(pred_def_26672,type,
    v48841: state_type > $o ).

tff(pred_def_26673,type,
    v48839: state_type > $o ).

tff(pred_def_26674,type,
    v48845: state_type > $o ).

tff(pred_def_26675,type,
    v48843: state_type > $o ).

tff(pred_def_26676,type,
    v48849: state_type > $o ).

tff(pred_def_26677,type,
    v48847: state_type > $o ).

tff(pred_def_26678,type,
    v48852: state_type > $o ).

tff(pred_def_26679,type,
    v48851: state_type > $o ).

tff(pred_def_26680,type,
    v48837: state_type > $o ).

tff(pred_def_26681,type,
    v48835: state_type > $o ).

tff(pred_def_26682,type,
    v48833: state_type > $o ).

tff(pred_def_26683,type,
    v48831: state_type > $o ).

tff(pred_def_26684,type,
    v48829: state_type > $o ).

tff(pred_def_26685,type,
    v48856: state_type > $o ).

tff(pred_def_26686,type,
    v48854: state_type > $o ).

tff(pred_def_26687,type,
    v48823: state_type > $o ).

tff(pred_def_26688,type,
    v48862: state_type > $o ).

tff(pred_def_26689,type,
    v48864: state_type > $o ).

tff(pred_def_26690,type,
    v48860: state_type > $o ).

tff(pred_def_26691,type,
    v48859: state_type > $o ).

tff(pred_def_26692,type,
    v48870: state_type > $o ).

tff(pred_def_26693,type,
    v48871: state_type > $o ).

tff(pred_def_26694,type,
    v48867: state_type > $o ).

tff(pred_def_26695,type,
    v48869: state_type > $o ).

tff(pred_def_26696,type,
    v48877: state_type > $o ).

tff(pred_def_26697,type,
    v48875: state_type > $o ).

tff(pred_def_26698,type,
    v48879: state_type > $o ).

tff(pred_def_26699,type,
    v48817: state_type > $o ).

tff(pred_def_26700,type,
    v48815: state_type > $o ).

tff(pred_def_26701,type,
    v48813: state_type > $o ).

tff(pred_def_26702,type,
    v48886: state_type > $o ).

tff(pred_def_26703,type,
    v48884: state_type > $o ).

tff(pred_def_26704,type,
    v48883: state_type > $o ).

tff(pred_def_26705,type,
    v48882: state_type > $o ).

tff(pred_def_26706,type,
    v48894: state_type > $o ).

tff(pred_def_26707,type,
    v48895: state_type > $o ).

tff(pred_def_26708,type,
    v48893: state_type > $o ).

tff(pred_def_26709,type,
    v48890: ( state_type * $int ) > $o ).

tff(pred_def_26710,type,
    v48892: ( state_type * $int ) > $o ).

tff(pred_def_26711,type,
    v48787: ( state_type * $int ) > $o ).

tff(pred_def_26712,type,
    v48785: ( state_type * $int ) > $o ).

tff(pred_def_26713,type,
    v48783: ( state_type * $int ) > $o ).

tff(pred_def_26714,type,
    v48781: ( state_type * $int ) > $o ).

tff(pred_def_26715,type,
    v48779: ( state_type * $int ) > $o ).

tff(pred_def_26716,type,
    v48917: state_type > $o ).

tff(pred_def_26717,type,
    v48915: state_type > $o ).

tff(pred_def_26718,type,
    v48921: state_type > $o ).

tff(pred_def_26719,type,
    v48919: state_type > $o ).

tff(pred_def_26720,type,
    v48925: state_type > $o ).

tff(pred_def_26721,type,
    v48923: state_type > $o ).

tff(pred_def_26722,type,
    v48928: state_type > $o ).

tff(pred_def_26723,type,
    v48927: state_type > $o ).

tff(pred_def_26724,type,
    v48913: state_type > $o ).

tff(pred_def_26725,type,
    v48911: state_type > $o ).

tff(pred_def_26726,type,
    v48909: state_type > $o ).

tff(pred_def_26727,type,
    v48907: state_type > $o ).

tff(pred_def_26728,type,
    v48905: state_type > $o ).

tff(pred_def_26729,type,
    v48903: state_type > $o ).

tff(pred_def_26730,type,
    v48901: state_type > $o ).

tff(pred_def_26731,type,
    v48899: state_type > $o ).

tff(pred_def_26732,type,
    v48948: state_type > $o ).

tff(pred_def_26733,type,
    v48946: state_type > $o ).

tff(pred_def_26734,type,
    v48944: state_type > $o ).

tff(pred_def_26735,type,
    v48942: state_type > $o ).

tff(pred_def_26736,type,
    v48940: state_type > $o ).

tff(pred_def_26737,type,
    v48958: state_type > $o ).

tff(pred_def_26738,type,
    v48956: state_type > $o ).

tff(pred_def_26739,type,
    v48954: state_type > $o ).

tff(pred_def_26740,type,
    v48952: state_type > $o ).

tff(pred_def_26741,type,
    v48950: state_type > $o ).

tff(pred_def_26742,type,
    v48962: ( state_type * $int ) > $o ).

tff(pred_def_26743,type,
    v48960: ( state_type * $int ) > $o ).

tff(pred_def_26744,type,
    v48972: state_type > $o ).

tff(pred_def_26745,type,
    v48970: state_type > $o ).

tff(pred_def_26746,type,
    v48978: state_type > $o ).

tff(pred_def_26747,type,
    v48976: state_type > $o ).

tff(pred_def_26748,type,
    v48992: state_type > $o ).

tff(pred_def_26749,type,
    v48990: state_type > $o ).

tff(pred_def_26750,type,
    v48996: state_type > $o ).

tff(pred_def_26751,type,
    v48994: state_type > $o ).

tff(pred_def_26752,type,
    v49000: state_type > $o ).

tff(pred_def_26753,type,
    v48998: state_type > $o ).

tff(pred_def_26754,type,
    v49003: state_type > $o ).

tff(pred_def_26755,type,
    v49002: state_type > $o ).

tff(pred_def_26756,type,
    v48988: state_type > $o ).

tff(pred_def_26757,type,
    v48986: state_type > $o ).

tff(pred_def_26758,type,
    v48984: state_type > $o ).

tff(pred_def_26759,type,
    v48982: state_type > $o ).

tff(pred_def_26760,type,
    v48980: state_type > $o ).

tff(pred_def_26761,type,
    v49007: state_type > $o ).

tff(pred_def_26762,type,
    v49005: state_type > $o ).

tff(pred_def_26763,type,
    v48974: state_type > $o ).

tff(pred_def_26764,type,
    v49013: state_type > $o ).

tff(pred_def_26765,type,
    v49015: state_type > $o ).

tff(pred_def_26766,type,
    v49011: state_type > $o ).

tff(pred_def_26767,type,
    v49010: state_type > $o ).

tff(pred_def_26768,type,
    v49021: state_type > $o ).

tff(pred_def_26769,type,
    v49022: state_type > $o ).

tff(pred_def_26770,type,
    v49018: state_type > $o ).

tff(pred_def_26771,type,
    v49020: state_type > $o ).

tff(pred_def_26772,type,
    v49028: state_type > $o ).

tff(pred_def_26773,type,
    v49026: state_type > $o ).

tff(pred_def_26774,type,
    v49030: state_type > $o ).

tff(pred_def_26775,type,
    v48968: state_type > $o ).

tff(pred_def_26776,type,
    v48966: state_type > $o ).

tff(pred_def_26777,type,
    v48964: state_type > $o ).

tff(pred_def_26778,type,
    v49037: state_type > $o ).

tff(pred_def_26779,type,
    v49035: state_type > $o ).

tff(pred_def_26780,type,
    v49034: state_type > $o ).

tff(pred_def_26781,type,
    v49033: state_type > $o ).

tff(pred_def_26782,type,
    v49045: state_type > $o ).

tff(pred_def_26783,type,
    v49046: state_type > $o ).

tff(pred_def_26784,type,
    v49044: state_type > $o ).

tff(pred_def_26785,type,
    v49041: ( state_type * $int ) > $o ).

tff(pred_def_26786,type,
    v49043: ( state_type * $int ) > $o ).

tff(pred_def_26787,type,
    v48938: ( state_type * $int ) > $o ).

tff(pred_def_26788,type,
    v48936: ( state_type * $int ) > $o ).

tff(pred_def_26789,type,
    v48934: ( state_type * $int ) > $o ).

tff(pred_def_26790,type,
    v48932: ( state_type * $int ) > $o ).

tff(pred_def_26791,type,
    v48930: ( state_type * $int ) > $o ).

tff(pred_def_26792,type,
    v49068: state_type > $o ).

tff(pred_def_26793,type,
    v49066: state_type > $o ).

tff(pred_def_26794,type,
    v49072: state_type > $o ).

tff(pred_def_26795,type,
    v49070: state_type > $o ).

tff(pred_def_26796,type,
    v49076: state_type > $o ).

tff(pred_def_26797,type,
    v49074: state_type > $o ).

tff(pred_def_26798,type,
    v49079: state_type > $o ).

tff(pred_def_26799,type,
    v49078: state_type > $o ).

tff(pred_def_26800,type,
    v49064: state_type > $o ).

tff(pred_def_26801,type,
    v49062: state_type > $o ).

tff(pred_def_26802,type,
    v49060: state_type > $o ).

tff(pred_def_26803,type,
    v49058: state_type > $o ).

tff(pred_def_26804,type,
    v49056: state_type > $o ).

tff(pred_def_26805,type,
    v49054: state_type > $o ).

tff(pred_def_26806,type,
    v49052: state_type > $o ).

tff(pred_def_26807,type,
    v49050: state_type > $o ).

tff(pred_def_26808,type,
    v49099: state_type > $o ).

tff(pred_def_26809,type,
    v49097: state_type > $o ).

tff(pred_def_26810,type,
    v49095: state_type > $o ).

tff(pred_def_26811,type,
    v49093: state_type > $o ).

tff(pred_def_26812,type,
    v49091: state_type > $o ).

tff(pred_def_26813,type,
    v49109: state_type > $o ).

tff(pred_def_26814,type,
    v49107: state_type > $o ).

tff(pred_def_26815,type,
    v49105: state_type > $o ).

tff(pred_def_26816,type,
    v49103: state_type > $o ).

tff(pred_def_26817,type,
    v49101: state_type > $o ).

tff(pred_def_26818,type,
    v49113: ( state_type * $int ) > $o ).

tff(pred_def_26819,type,
    v49111: ( state_type * $int ) > $o ).

tff(pred_def_26820,type,
    v49123: state_type > $o ).

tff(pred_def_26821,type,
    v49121: state_type > $o ).

tff(pred_def_26822,type,
    v49129: state_type > $o ).

tff(pred_def_26823,type,
    v49127: state_type > $o ).

tff(pred_def_26824,type,
    v49143: state_type > $o ).

tff(pred_def_26825,type,
    v49141: state_type > $o ).

tff(pred_def_26826,type,
    v49147: state_type > $o ).

tff(pred_def_26827,type,
    v49145: state_type > $o ).

tff(pred_def_26828,type,
    v49151: state_type > $o ).

tff(pred_def_26829,type,
    v49149: state_type > $o ).

tff(pred_def_26830,type,
    v49154: state_type > $o ).

tff(pred_def_26831,type,
    v49153: state_type > $o ).

tff(pred_def_26832,type,
    v49139: state_type > $o ).

tff(pred_def_26833,type,
    v49137: state_type > $o ).

tff(pred_def_26834,type,
    v49135: state_type > $o ).

tff(pred_def_26835,type,
    v49133: state_type > $o ).

tff(pred_def_26836,type,
    v49131: state_type > $o ).

tff(pred_def_26837,type,
    v49158: state_type > $o ).

tff(pred_def_26838,type,
    v49156: state_type > $o ).

tff(pred_def_26839,type,
    v49125: state_type > $o ).

tff(pred_def_26840,type,
    v49164: state_type > $o ).

tff(pred_def_26841,type,
    v49166: state_type > $o ).

tff(pred_def_26842,type,
    v49162: state_type > $o ).

tff(pred_def_26843,type,
    v49161: state_type > $o ).

tff(pred_def_26844,type,
    v49172: state_type > $o ).

tff(pred_def_26845,type,
    v49173: state_type > $o ).

tff(pred_def_26846,type,
    v49169: state_type > $o ).

tff(pred_def_26847,type,
    v49171: state_type > $o ).

tff(pred_def_26848,type,
    v49179: state_type > $o ).

tff(pred_def_26849,type,
    v49177: state_type > $o ).

tff(pred_def_26850,type,
    v49181: state_type > $o ).

tff(pred_def_26851,type,
    v49119: state_type > $o ).

tff(pred_def_26852,type,
    v49117: state_type > $o ).

tff(pred_def_26853,type,
    v49115: state_type > $o ).

tff(pred_def_26854,type,
    v49188: state_type > $o ).

tff(pred_def_26855,type,
    v49186: state_type > $o ).

tff(pred_def_26856,type,
    v49185: state_type > $o ).

tff(pred_def_26857,type,
    v49184: state_type > $o ).

tff(pred_def_26858,type,
    v49196: state_type > $o ).

tff(pred_def_26859,type,
    v49197: state_type > $o ).

tff(pred_def_26860,type,
    v49195: state_type > $o ).

tff(pred_def_26861,type,
    v49192: ( state_type * $int ) > $o ).

tff(pred_def_26862,type,
    v49194: ( state_type * $int ) > $o ).

tff(pred_def_26863,type,
    v49089: ( state_type * $int ) > $o ).

tff(pred_def_26864,type,
    v49087: ( state_type * $int ) > $o ).

tff(pred_def_26865,type,
    v49085: ( state_type * $int ) > $o ).

tff(pred_def_26866,type,
    v49083: ( state_type * $int ) > $o ).

tff(pred_def_26867,type,
    v49081: ( state_type * $int ) > $o ).

tff(pred_def_26868,type,
    v49219: state_type > $o ).

tff(pred_def_26869,type,
    v49217: state_type > $o ).

tff(pred_def_26870,type,
    v49223: state_type > $o ).

tff(pred_def_26871,type,
    v49221: state_type > $o ).

tff(pred_def_26872,type,
    v49227: state_type > $o ).

tff(pred_def_26873,type,
    v49225: state_type > $o ).

tff(pred_def_26874,type,
    v49230: state_type > $o ).

tff(pred_def_26875,type,
    v49229: state_type > $o ).

tff(pred_def_26876,type,
    v49215: state_type > $o ).

tff(pred_def_26877,type,
    v49213: state_type > $o ).

tff(pred_def_26878,type,
    v49211: state_type > $o ).

tff(pred_def_26879,type,
    v49209: state_type > $o ).

tff(pred_def_26880,type,
    v49207: state_type > $o ).

tff(pred_def_26881,type,
    v49205: state_type > $o ).

tff(pred_def_26882,type,
    v49203: state_type > $o ).

tff(pred_def_26883,type,
    v49201: state_type > $o ).

tff(pred_def_26884,type,
    v49250: state_type > $o ).

tff(pred_def_26885,type,
    v49248: state_type > $o ).

tff(pred_def_26886,type,
    v49246: state_type > $o ).

tff(pred_def_26887,type,
    v49244: state_type > $o ).

tff(pred_def_26888,type,
    v49242: state_type > $o ).

tff(pred_def_26889,type,
    v49260: state_type > $o ).

tff(pred_def_26890,type,
    v49258: state_type > $o ).

tff(pred_def_26891,type,
    v49256: state_type > $o ).

tff(pred_def_26892,type,
    v49254: state_type > $o ).

tff(pred_def_26893,type,
    v49252: state_type > $o ).

tff(pred_def_26894,type,
    v49264: ( state_type * $int ) > $o ).

tff(pred_def_26895,type,
    v49262: ( state_type * $int ) > $o ).

tff(pred_def_26896,type,
    v49274: state_type > $o ).

tff(pred_def_26897,type,
    v49272: state_type > $o ).

tff(pred_def_26898,type,
    v49280: state_type > $o ).

tff(pred_def_26899,type,
    v49278: state_type > $o ).

tff(pred_def_26900,type,
    v49293: state_type > $o ).

tff(pred_def_26901,type,
    v49291: state_type > $o ).

tff(pred_def_26902,type,
    v49297: state_type > $o ).

tff(pred_def_26903,type,
    v49295: state_type > $o ).

tff(pred_def_26904,type,
    v49301: state_type > $o ).

tff(pred_def_26905,type,
    v49299: state_type > $o ).

tff(pred_def_26906,type,
    v49304: state_type > $o ).

tff(pred_def_26907,type,
    v49303: state_type > $o ).

tff(pred_def_26908,type,
    v49289: state_type > $o ).

tff(pred_def_26909,type,
    v49287: state_type > $o ).

tff(pred_def_26910,type,
    v49284: state_type > $o ).

tff(pred_def_26911,type,
    v49282: state_type > $o ).

tff(pred_def_26912,type,
    v49308: state_type > $o ).

tff(pred_def_26913,type,
    v49306: state_type > $o ).

tff(pred_def_26914,type,
    v49276: state_type > $o ).

tff(pred_def_26915,type,
    v49314: state_type > $o ).

tff(pred_def_26916,type,
    v49316: state_type > $o ).

tff(pred_def_26917,type,
    v49312: state_type > $o ).

tff(pred_def_26918,type,
    v49311: state_type > $o ).

tff(pred_def_26919,type,
    v49322: state_type > $o ).

tff(pred_def_26920,type,
    v49323: state_type > $o ).

tff(pred_def_26921,type,
    v49319: state_type > $o ).

tff(pred_def_26922,type,
    v49321: state_type > $o ).

tff(pred_def_26923,type,
    v49329: state_type > $o ).

tff(pred_def_26924,type,
    v49327: state_type > $o ).

tff(pred_def_26925,type,
    v49331: state_type > $o ).

tff(pred_def_26926,type,
    v49270: state_type > $o ).

tff(pred_def_26927,type,
    v49268: state_type > $o ).

tff(pred_def_26928,type,
    v49266: state_type > $o ).

tff(pred_def_26929,type,
    v49338: state_type > $o ).

tff(pred_def_26930,type,
    v49336: state_type > $o ).

tff(pred_def_26931,type,
    v49335: state_type > $o ).

tff(pred_def_26932,type,
    v49334: state_type > $o ).

tff(pred_def_26933,type,
    v49346: state_type > $o ).

tff(pred_def_26934,type,
    v49347: state_type > $o ).

tff(pred_def_26935,type,
    v49345: state_type > $o ).

tff(pred_def_26936,type,
    v49342: ( state_type * $int ) > $o ).

tff(pred_def_26937,type,
    v49344: ( state_type * $int ) > $o ).

tff(pred_def_26938,type,
    v49240: ( state_type * $int ) > $o ).

tff(pred_def_26939,type,
    v49238: ( state_type * $int ) > $o ).

tff(pred_def_26940,type,
    v49236: ( state_type * $int ) > $o ).

tff(pred_def_26941,type,
    v49234: ( state_type * $int ) > $o ).

tff(pred_def_26942,type,
    v49232: ( state_type * $int ) > $o ).

tff(pred_def_26943,type,
    v49359: state_type > $o ).

tff(pred_def_26944,type,
    v49357: state_type > $o ).

tff(pred_def_26945,type,
    v49355: state_type > $o ).

tff(pred_def_26946,type,
    v49353: state_type > $o ).

tff(pred_def_26947,type,
    v49351: state_type > $o ).

tff(pred_def_26948,type,
    v49367: state_type > $o ).

tff(pred_def_26949,type,
    v49366: ( state_type * $int ) > $o ).

tff(pred_def_26950,type,
    v49365: ( state_type * $int ) > $o ).

tff(pred_def_26951,type,
    v49370: state_type > $o ).

tff(pred_def_26952,type,
    v49369: ( state_type * $int ) > $o ).

tff(pred_def_26953,type,
    v49368: ( state_type * $int ) > $o ).

tff(pred_def_26954,type,
    v49364: ( state_type * $int ) > $o ).

tff(pred_def_26955,type,
    v49373: state_type > $o ).

tff(pred_def_26956,type,
    v49372: ( state_type * $int ) > $o ).

tff(pred_def_26957,type,
    v49371: ( state_type * $int ) > $o ).

tff(pred_def_26958,type,
    v49363: ( state_type * $int ) > $o ).

tff(pred_def_26959,type,
    v49376: state_type > $o ).

tff(pred_def_26960,type,
    v49375: ( state_type * $int ) > $o ).

tff(pred_def_26961,type,
    v49374: ( state_type * $int ) > $o ).

tff(pred_def_26962,type,
    v49362: ( state_type * $int ) > $o ).

tff(pred_def_26963,type,
    v49379: state_type > $o ).

tff(pred_def_26964,type,
    v49378: ( state_type * $int ) > $o ).

tff(pred_def_26965,type,
    v49377: ( state_type * $int ) > $o ).

tff(pred_def_26966,type,
    v49361: ( state_type * $int ) > $o ).

tff(pred_def_26967,type,
    v49382: state_type > $o ).

tff(pred_def_26968,type,
    v49381: ( state_type * $int ) > $o ).

tff(pred_def_26969,type,
    v49380: ( state_type * $int ) > $o ).

tff(pred_def_26970,type,
    v47853: ( state_type * $int ) > $o ).

tff(pred_def_26971,type,
    v47851: ( state_type * $int ) > $o ).

tff(pred_def_26972,type,
    v47849: ( state_type * $int ) > $o ).

tff(pred_def_26973,type,
    v47847: ( state_type * $int ) > $o ).

tff(pred_def_26974,type,
    v47845: ( state_type * $int ) > $o ).

tff(pred_def_26975,type,
    v47839: state_type > $o ).

tff(pred_def_26976,type,
    v47837: state_type > $o ).

tff(pred_def_26977,type,
    v47835: state_type > $o ).

tff(pred_def_26978,type,
    v49393: ( state_type * $int ) > $o ).

tff(pred_def_26979,type,
    v49391: ( state_type * $int ) > $o ).

tff(pred_def_26980,type,
    v49427: state_type > $o ).

tff(pred_def_26981,type,
    v49425: state_type > $o ).

tff(pred_def_26982,type,
    v49423: state_type > $o ).

tff(pred_def_26983,type,
    v49421: state_type > $o ).

tff(pred_def_26984,type,
    v49419: state_type > $o ).

tff(pred_def_26985,type,
    v49417: state_type > $o ).

tff(pred_def_26986,type,
    v49415: state_type > $o ).

tff(pred_def_26987,type,
    v49441: state_type > $o ).

tff(pred_def_26988,type,
    v49439: state_type > $o ).

tff(pred_def_26989,type,
    v49437: state_type > $o ).

tff(pred_def_26990,type,
    v49435: state_type > $o ).

tff(pred_def_26991,type,
    v49433: state_type > $o ).

tff(pred_def_26992,type,
    v49431: state_type > $o ).

tff(pred_def_26993,type,
    v49429: state_type > $o ).

tff(pred_def_26994,type,
    v49467: state_type > $o ).

tff(pred_def_26995,type,
    v49469: state_type > $o ).

tff(pred_def_26996,type,
    v49468: ( state_type * $int ) > $o ).

tff(pred_def_26997,type,
    v49470: state_type > $o ).

tff(pred_def_26998,type,
    v49465: ( state_type * $int ) > $o ).

tff(pred_def_26999,type,
    v49463: ( state_type * $int ) > $o ).

tff(pred_def_27000,type,
    v49471: ( state_type * $int ) > $o ).

tff(pred_def_27001,type,
    v49461: ( state_type * $int ) > $o ).

tff(pred_def_27002,type,
    v49459: ( state_type * $int ) > $o ).

tff(pred_def_27003,type,
    v49457: state_type > $o ).

tff(pred_def_27004,type,
    v49473: state_type > $o ).

tff(pred_def_27005,type,
    v49455: ( state_type * $int ) > $o ).

tff(pred_def_27006,type,
    v49453: ( state_type * $int ) > $o ).

tff(pred_def_27007,type,
    v49487: ( state_type * $int ) > $o ).

tff(pred_def_27008,type,
    v49485: ( state_type * $int ) > $o ).

tff(pred_def_27009,type,
    v49491: state_type > $o ).

tff(pred_def_27010,type,
    v49489: state_type > $o ).

tff(pred_def_27011,type,
    v49515: state_type > $o ).

tff(pred_def_27012,type,
    v49513: state_type > $o ).

tff(pred_def_27013,type,
    v49511: state_type > $o ).

tff(pred_def_27014,type,
    v49509: state_type > $o ).

tff(pred_def_27015,type,
    v49507: state_type > $o ).

tff(pred_def_27016,type,
    v49505: state_type > $o ).

tff(pred_def_27017,type,
    v49503: state_type > $o ).

tff(pred_def_27018,type,
    v49529: state_type > $o ).

tff(pred_def_27019,type,
    v49527: state_type > $o ).

tff(pred_def_27020,type,
    v49525: state_type > $o ).

tff(pred_def_27021,type,
    v49523: state_type > $o ).

tff(pred_def_27022,type,
    v49521: state_type > $o ).

tff(pred_def_27023,type,
    v49519: state_type > $o ).

tff(pred_def_27024,type,
    v49517: state_type > $o ).

tff(pred_def_27025,type,
    v49545: ( state_type * $int ) > $o ).

tff(pred_def_27026,type,
    v49543: ( state_type * $int ) > $o ).

tff(pred_def_27027,type,
    v49541: ( state_type * $int ) > $o ).

tff(pred_def_27028,type,
    v49539: ( state_type * $int ) > $o ).

tff(pred_def_27029,type,
    v49537: ( state_type * $int ) > $o ).

tff(pred_def_27030,type,
    v49575: ( state_type * $int ) > $o ).

tff(pred_def_27031,type,
    v49577: ( state_type * $int ) > $o ).

tff(pred_def_27032,type,
    v49573: ( state_type * $int ) > $o ).

tff(pred_def_27033,type,
    v49571: ( state_type * $int ) > $o ).

tff(pred_def_27034,type,
    v49569: ( state_type * $int ) > $o ).

tff(pred_def_27035,type,
    v49567: ( state_type * $int ) > $o ).

tff(pred_def_27036,type,
    v49565: state_type > $o ).

tff(pred_def_27037,type,
    v49563: state_type > $o ).

tff(pred_def_27038,type,
    v49581: state_type > $o ).

tff(pred_def_27039,type,
    v49579: state_type > $o ).

tff(pred_def_27040,type,
    v49583: state_type > $o ).

tff(pred_def_27041,type,
    v49561: state_type > $o ).

tff(pred_def_27042,type,
    v49559: state_type > $o ).

tff(pred_def_27043,type,
    v49557: state_type > $o ).

tff(pred_def_27044,type,
    v49555: state_type > $o ).

tff(pred_def_27045,type,
    v49553: state_type > $o ).

tff(pred_def_27046,type,
    v49551: state_type > $o ).

tff(pred_def_27047,type,
    v49549: state_type > $o ).

tff(pred_def_27048,type,
    v49547: state_type > $o ).

tff(pred_def_27049,type,
    v49593: ( state_type * $int ) > $o ).

tff(pred_def_27050,type,
    v49591: ( state_type * $int ) > $o ).

tff(pred_def_27051,type,
    v49589: ( state_type * $int ) > $o ).

tff(pred_def_27052,type,
    v49587: ( state_type * $int ) > $o ).

tff(pred_def_27053,type,
    v49585: ( state_type * $int ) > $o ).

tff(pred_def_27054,type,
    v49623: ( state_type * $int ) > $o ).

tff(pred_def_27055,type,
    v49621: ( state_type * $int ) > $o ).

tff(pred_def_27056,type,
    v49624: ( state_type * $int ) > $o ).

tff(pred_def_27057,type,
    v49619: ( state_type * $int ) > $o ).

tff(pred_def_27058,type,
    v49617: ( state_type * $int ) > $o ).

tff(pred_def_27059,type,
    v49615: ( state_type * $int ) > $o ).

tff(pred_def_27060,type,
    v49613: state_type > $o ).

tff(pred_def_27061,type,
    v49611: state_type > $o ).

tff(pred_def_27062,type,
    v49628: state_type > $o ).

tff(pred_def_27063,type,
    v49626: state_type > $o ).

tff(pred_def_27064,type,
    v49630: state_type > $o ).

tff(pred_def_27065,type,
    v49609: state_type > $o ).

tff(pred_def_27066,type,
    v49607: state_type > $o ).

tff(pred_def_27067,type,
    v49605: state_type > $o ).

tff(pred_def_27068,type,
    v49603: state_type > $o ).

tff(pred_def_27069,type,
    v49601: state_type > $o ).

tff(pred_def_27070,type,
    v49599: state_type > $o ).

tff(pred_def_27071,type,
    v49597: state_type > $o ).

tff(pred_def_27072,type,
    v49595: state_type > $o ).

tff(pred_def_27073,type,
    v49640: ( state_type * $int ) > $o ).

tff(pred_def_27074,type,
    v49638: ( state_type * $int ) > $o ).

tff(pred_def_27075,type,
    v49636: ( state_type * $int ) > $o ).

tff(pred_def_27076,type,
    v49634: ( state_type * $int ) > $o ).

tff(pred_def_27077,type,
    v49632: ( state_type * $int ) > $o ).

tff(pred_def_27078,type,
    v49660: state_type > $o ).

tff(pred_def_27079,type,
    v49658: state_type > $o ).

tff(pred_def_27080,type,
    v49664: state_type > $o ).

tff(pred_def_27081,type,
    v49662: state_type > $o ).

tff(pred_def_27082,type,
    v49666: state_type > $o ).

tff(pred_def_27083,type,
    v49656: state_type > $o ).

tff(pred_def_27084,type,
    v49654: state_type > $o ).

tff(pred_def_27085,type,
    v49652: state_type > $o ).

tff(pred_def_27086,type,
    v49650: state_type > $o ).

tff(pred_def_27087,type,
    v49648: state_type > $o ).

tff(pred_def_27088,type,
    v49646: state_type > $o ).

tff(pred_def_27089,type,
    v49644: state_type > $o ).

tff(pred_def_27090,type,
    v49642: state_type > $o ).

tff(pred_def_27091,type,
    v49676: ( state_type * $int ) > $o ).

tff(pred_def_27092,type,
    v49674: ( state_type * $int ) > $o ).

tff(pred_def_27093,type,
    v49672: ( state_type * $int ) > $o ).

tff(pred_def_27094,type,
    v49670: ( state_type * $int ) > $o ).

tff(pred_def_27095,type,
    v49668: ( state_type * $int ) > $o ).

tff(pred_def_27096,type,
    v49696: state_type > $o ).

tff(pred_def_27097,type,
    v49694: state_type > $o ).

tff(pred_def_27098,type,
    v49700: state_type > $o ).

tff(pred_def_27099,type,
    v49698: state_type > $o ).

tff(pred_def_27100,type,
    v49702: state_type > $o ).

tff(pred_def_27101,type,
    v49692: state_type > $o ).

tff(pred_def_27102,type,
    v49690: state_type > $o ).

tff(pred_def_27103,type,
    v49688: state_type > $o ).

tff(pred_def_27104,type,
    v49686: state_type > $o ).

tff(pred_def_27105,type,
    v49684: state_type > $o ).

tff(pred_def_27106,type,
    v49682: state_type > $o ).

tff(pred_def_27107,type,
    v49680: state_type > $o ).

tff(pred_def_27108,type,
    v49678: state_type > $o ).

tff(pred_def_27109,type,
    v49708: state_type > $o ).

tff(pred_def_27110,type,
    v49707: ( state_type * $int ) > $o ).

tff(pred_def_27111,type,
    v49706: ( state_type * $int ) > $o ).

tff(pred_def_27112,type,
    v49711: state_type > $o ).

tff(pred_def_27113,type,
    v49710: ( state_type * $int ) > $o ).

tff(pred_def_27114,type,
    v49709: ( state_type * $int ) > $o ).

tff(pred_def_27115,type,
    v49705: ( state_type * $int ) > $o ).

tff(pred_def_27116,type,
    v49714: state_type > $o ).

tff(pred_def_27117,type,
    v49713: ( state_type * $int ) > $o ).

tff(pred_def_27118,type,
    v49712: ( state_type * $int ) > $o ).

tff(pred_def_27119,type,
    v49704: ( state_type * $int ) > $o ).

tff(pred_def_27120,type,
    v49717: state_type > $o ).

tff(pred_def_27121,type,
    v49716: ( state_type * $int ) > $o ).

tff(pred_def_27122,type,
    v49715: ( state_type * $int ) > $o ).

tff(pred_def_27123,type,
    v49535: ( state_type * $int ) > $o ).

tff(pred_def_27124,type,
    v49533: ( state_type * $int ) > $o ).

tff(pred_def_27125,type,
    v49531: ( state_type * $int ) > $o ).

tff(pred_def_27126,type,
    v49729: state_type > $o ).

tff(pred_def_27127,type,
    v49727: state_type > $o ).

tff(pred_def_27128,type,
    v49725: state_type > $o ).

tff(pred_def_27129,type,
    v49739: state_type > $o ).

tff(pred_def_27130,type,
    v49737: state_type > $o ).

tff(pred_def_27131,type,
    v49735: state_type > $o ).

tff(pred_def_27132,type,
    v49733: state_type > $o ).

tff(pred_def_27133,type,
    v49731: state_type > $o ).

tff(pred_def_27134,type,
    v49741: state_type > $o ).

tff(pred_def_27135,type,
    v49723: state_type > $o ).

tff(pred_def_27136,type,
    v49721: state_type > $o ).

tff(pred_def_27137,type,
    v49719: state_type > $o ).

tff(pred_def_27138,type,
    v49748: state_type > $o ).

tff(pred_def_27139,type,
    v49746: state_type > $o ).

tff(pred_def_27140,type,
    v49745: state_type > $o ).

tff(pred_def_27141,type,
    v49744: state_type > $o ).

tff(pred_def_27142,type,
    v49756: state_type > $o ).

tff(pred_def_27143,type,
    v49757: state_type > $o ).

tff(pred_def_27144,type,
    v49755: state_type > $o ).

tff(pred_def_27145,type,
    v49752: ( state_type * $int ) > $o ).

tff(pred_def_27146,type,
    v49754: ( state_type * $int ) > $o ).

tff(pred_def_27147,type,
    v49501: ( state_type * $int ) > $o ).

tff(pred_def_27148,type,
    v49499: ( state_type * $int ) > $o ).

tff(pred_def_27149,type,
    v49497: ( state_type * $int ) > $o ).

tff(pred_def_27150,type,
    v49495: ( state_type * $int ) > $o ).

tff(pred_def_27151,type,
    v49493: ( state_type * $int ) > $o ).

tff(pred_def_27152,type,
    v49763: state_type > $o ).

tff(pred_def_27153,type,
    v49761: state_type > $o ).

tff(pred_def_27154,type,
    v49767: state_type > $o ).

tff(pred_def_27155,type,
    v49766: ( state_type * $int ) > $o ).

tff(pred_def_27156,type,
    v49765: ( state_type * $int ) > $o ).

tff(pred_def_27157,type,
    v49770: state_type > $o ).

tff(pred_def_27158,type,
    v49769: ( state_type * $int ) > $o ).

tff(pred_def_27159,type,
    v49768: ( state_type * $int ) > $o ).

tff(pred_def_27160,type,
    v49483: ( state_type * $int ) > $o ).

tff(pred_def_27161,type,
    v49481: ( state_type * $int ) > $o ).

tff(pred_def_27162,type,
    v49479: ( state_type * $int ) > $o ).

tff(pred_def_27163,type,
    v49477: ( state_type * $int ) > $o ).

tff(pred_def_27164,type,
    v49475: ( state_type * $int ) > $o ).

tff(pred_def_27165,type,
    v49451: ( state_type * $int ) > $o ).

tff(pred_def_27166,type,
    v49449: ( state_type * $int ) > $o ).

tff(pred_def_27167,type,
    v49447: ( state_type * $int ) > $o ).

tff(pred_def_27168,type,
    v49445: ( state_type * $int ) > $o ).

tff(pred_def_27169,type,
    v49443: ( state_type * $int ) > $o ).

tff(pred_def_27170,type,
    v49783: state_type > $o ).

tff(pred_def_27171,type,
    v49781: state_type > $o ).

tff(pred_def_27172,type,
    v49779: state_type > $o ).

tff(pred_def_27173,type,
    v49789: state_type > $o ).

tff(pred_def_27174,type,
    v49787: state_type > $o ).

tff(pred_def_27175,type,
    v49807: ( state_type * $int ) > $o ).

tff(pred_def_27176,type,
    v49809: ( state_type * $int ) > $o ).

tff(pred_def_27177,type,
    v49805: ( state_type * $int ) > $o ).

tff(pred_def_27178,type,
    v49803: state_type > $o ).

tff(pred_def_27179,type,
    v49801: state_type > $o ).

tff(pred_def_27180,type,
    v49813: state_type > $o ).

tff(pred_def_27181,type,
    v49811: state_type > $o ).

tff(pred_def_27182,type,
    v49817: state_type > $o ).

tff(pred_def_27183,type,
    v49815: state_type > $o ).

tff(pred_def_27184,type,
    v49820: state_type > $o ).

tff(pred_def_27185,type,
    v49819: state_type > $o ).

tff(pred_def_27186,type,
    v49799: state_type > $o ).

tff(pred_def_27187,type,
    v49797: state_type > $o ).

tff(pred_def_27188,type,
    v49795: state_type > $o ).

tff(pred_def_27189,type,
    v49793: state_type > $o ).

tff(pred_def_27190,type,
    v49791: state_type > $o ).

tff(pred_def_27191,type,
    v49828: state_type > $o ).

tff(pred_def_27192,type,
    v49826: state_type > $o ).

tff(pred_def_27193,type,
    v49824: state_type > $o ).

tff(pred_def_27194,type,
    v49822: state_type > $o ).

tff(pred_def_27195,type,
    v49785: state_type > $o ).

tff(pred_def_27196,type,
    v49834: state_type > $o ).

tff(pred_def_27197,type,
    v49836: state_type > $o ).

tff(pred_def_27198,type,
    v49832: state_type > $o ).

tff(pred_def_27199,type,
    v49831: state_type > $o ).

tff(pred_def_27200,type,
    v49842: state_type > $o ).

tff(pred_def_27201,type,
    v49843: state_type > $o ).

tff(pred_def_27202,type,
    v49839: state_type > $o ).

tff(pred_def_27203,type,
    v49841: state_type > $o ).

tff(pred_def_27204,type,
    v49853: state_type > $o ).

tff(pred_def_27205,type,
    v49851: state_type > $o ).

tff(pred_def_27206,type,
    v49849: state_type > $o ).

tff(pred_def_27207,type,
    v49847: state_type > $o ).

tff(pred_def_27208,type,
    v49855: state_type > $o ).

tff(pred_def_27209,type,
    v49777: state_type > $o ).

tff(pred_def_27210,type,
    v49775: state_type > $o ).

tff(pred_def_27211,type,
    v49773: state_type > $o ).

tff(pred_def_27212,type,
    v49862: state_type > $o ).

tff(pred_def_27213,type,
    v49860: state_type > $o ).

tff(pred_def_27214,type,
    v49859: state_type > $o ).

tff(pred_def_27215,type,
    v49858: state_type > $o ).

tff(pred_def_27216,type,
    v49870: state_type > $o ).

tff(pred_def_27217,type,
    v49871: state_type > $o ).

tff(pred_def_27218,type,
    v49869: state_type > $o ).

tff(pred_def_27219,type,
    v49866: ( state_type * $int ) > $o ).

tff(pred_def_27220,type,
    v49868: ( state_type * $int ) > $o ).

tff(pred_def_27221,type,
    v49413: ( state_type * $int ) > $o ).

tff(pred_def_27222,type,
    v49411: ( state_type * $int ) > $o ).

tff(pred_def_27223,type,
    v49409: ( state_type * $int ) > $o ).

tff(pred_def_27224,type,
    v49407: ( state_type * $int ) > $o ).

tff(pred_def_27225,type,
    v49405: ( state_type * $int ) > $o ).

tff(pred_def_27226,type,
    v49907: state_type > $o ).

tff(pred_def_27227,type,
    v49905: state_type > $o ).

tff(pred_def_27228,type,
    v49903: state_type > $o ).

tff(pred_def_27229,type,
    v49901: state_type > $o ).

tff(pred_def_27230,type,
    v49899: state_type > $o ).

tff(pred_def_27231,type,
    v49897: state_type > $o ).

tff(pred_def_27232,type,
    v49917: state_type > $o ).

tff(pred_def_27233,type,
    v49915: state_type > $o ).

tff(pred_def_27234,type,
    v49913: state_type > $o ).

tff(pred_def_27235,type,
    v49911: state_type > $o ).

tff(pred_def_27236,type,
    v49909: state_type > $o ).

tff(pred_def_27237,type,
    v49944: state_type > $o ).

tff(pred_def_27238,type,
    v49943: ( state_type * $int ) > $o ).

tff(pred_def_27239,type,
    v49942: ( state_type * $int ) > $o ).

tff(pred_def_27240,type,
    v49940: ( state_type * $int ) > $o ).

tff(pred_def_27241,type,
    v49960: state_type > $o ).

tff(pred_def_27242,type,
    v49961: ( state_type * $int ) > $o ).

tff(pred_def_27243,type,
    v49962: state_type > $o ).

tff(pred_def_27244,type,
    v49958: ( state_type * $int ) > $o ).

tff(pred_def_27245,type,
    v49956: ( state_type * $int ) > $o ).

tff(pred_def_27246,type,
    v49986: ( state_type * $int ) > $o ).

tff(pred_def_27247,type,
    v49895: ( state_type * $int ) > $o ).

tff(pred_def_27248,type,
    v49984: ( state_type * $int ) > $o ).

tff(pred_def_27249,type,
    v49987: ( state_type * $int ) > $o ).

tff(pred_def_27250,type,
    v49982: ( state_type * $int ) > $o ).

tff(pred_def_27251,type,
    v49980: ( state_type * $int ) > $o ).

tff(pred_def_27252,type,
    v49978: ( state_type * $int ) > $o ).

tff(pred_def_27253,type,
    v49976: state_type > $o ).

tff(pred_def_27254,type,
    v49974: state_type > $o ).

tff(pred_def_27255,type,
    v49993: state_type > $o ).

tff(pred_def_27256,type,
    v49933: state_type > $o ).

tff(pred_def_27257,type,
    v49992: ( state_type * $int ) > $o ).

tff(pred_def_27258,type,
    v49931: ( state_type * $int ) > $o ).

tff(pred_def_27259,type,
    v49929: ( state_type * $int ) > $o ).

tff(pred_def_27260,type,
    v50008: ( state_type * $int ) > $o ).

tff(pred_def_27261,type,
    v50007: ( state_type * $int ) > $o ).

tff(pred_def_27262,type,
    v50005: ( state_type * $int ) > $o ).

tff(pred_def_27263,type,
    v50012: state_type > $o ).

tff(pred_def_27264,type,
    v50010: state_type > $o ).

tff(pred_def_27265,type,
    v50023: ( state_type * $int ) > $o ).

tff(pred_def_27266,type,
    v50022: state_type > $o ).

tff(pred_def_27267,type,
    v50026: state_type > $o ).

tff(pred_def_27268,type,
    v50027: state_type > $o ).

tff(pred_def_27269,type,
    v50025: state_type > $o ).

tff(pred_def_27270,type,
    v50028: state_type > $o ).

tff(pred_def_27271,type,
    v50024: state_type > $o ).

tff(pred_def_27272,type,
    v50021: state_type > $o ).

tff(pred_def_27273,type,
    v50029: state_type > $o ).

tff(pred_def_27274,type,
    v50020: state_type > $o ).

tff(pred_def_27275,type,
    v50032: state_type > $o ).

tff(pred_def_27276,type,
    v50033: state_type > $o ).

tff(pred_def_27277,type,
    v50031: state_type > $o ).

tff(pred_def_27278,type,
    v50034: state_type > $o ).

tff(pred_def_27279,type,
    v50030: state_type > $o ).

tff(pred_def_27280,type,
    v50019: state_type > $o ).

tff(pred_def_27281,type,
    v50035: state_type > $o ).

tff(pred_def_27282,type,
    v50018: state_type > $o ).

tff(pred_def_27283,type,
    v50017: state_type > $o ).

tff(pred_def_27284,type,
    v50039: state_type > $o ).

tff(pred_def_27285,type,
    v50040: state_type > $o ).

tff(pred_def_27286,type,
    v50038: state_type > $o ).

tff(pred_def_27287,type,
    v50041: state_type > $o ).

tff(pred_def_27288,type,
    v50037: state_type > $o ).

tff(pred_def_27289,type,
    v50036: state_type > $o ).

tff(pred_def_27290,type,
    v50016: state_type > $o ).

tff(pred_def_27291,type,
    v50042: state_type > $o ).

tff(pred_def_27292,type,
    v50015: state_type > $o ).

tff(pred_def_27293,type,
    v50045: state_type > $o ).

tff(pred_def_27294,type,
    v50046: state_type > $o ).

tff(pred_def_27295,type,
    v50044: state_type > $o ).

tff(pred_def_27296,type,
    v50047: state_type > $o ).

tff(pred_def_27297,type,
    v50043: state_type > $o ).

tff(pred_def_27298,type,
    v50050: state_type > $o ).

tff(pred_def_27299,type,
    v50051: state_type > $o ).

tff(pred_def_27300,type,
    v50049: state_type > $o ).

tff(pred_def_27301,type,
    v50052: state_type > $o ).

tff(pred_def_27302,type,
    v50048: state_type > $o ).

tff(pred_def_27303,type,
    v50055: state_type > $o ).

tff(pred_def_27304,type,
    v50056: state_type > $o ).

tff(pred_def_27305,type,
    v50054: state_type > $o ).

tff(pred_def_27306,type,
    v50057: state_type > $o ).

tff(pred_def_27307,type,
    v50053: state_type > $o ).

tff(pred_def_27308,type,
    v50013: ( state_type * $int ) > $o ).

tff(pred_def_27309,type,
    v50003: ( state_type * $int ) > $o ).

tff(pred_def_27310,type,
    v50001: ( state_type * $int ) > $o ).

tff(pred_def_27311,type,
    v49999: ( state_type * $int ) > $o ).

tff(pred_def_27312,type,
    v49997: ( state_type * $int ) > $o ).

tff(pred_def_27313,type,
    v49995: ( state_type * $int ) > $o ).

tff(pred_def_27314,type,
    v50058: ( state_type * $int ) > $o ).

tff(pred_def_27315,type,
    v49927: ( state_type * $int ) > $o ).

tff(pred_def_27316,type,
    v49925: ( state_type * $int ) > $o ).

tff(pred_def_27317,type,
    v49923: ( state_type * $int ) > $o ).

tff(pred_def_27318,type,
    v50059: ( state_type * $int ) > $o ).

tff(pred_def_27319,type,
    v50060: ( state_type * $int ) > $o ).

tff(pred_def_27320,type,
    v49921: ( state_type * $int ) > $o ).

tff(pred_def_27321,type,
    v49919: ( state_type * $int ) > $o ).

tff(pred_def_27322,type,
    v50070: state_type > $o ).

tff(pred_def_27323,type,
    v50068: state_type > $o ).

tff(pred_def_27324,type,
    v50076: state_type > $o ).

tff(pred_def_27325,type,
    v50074: state_type > $o ).

tff(pred_def_27326,type,
    v50080: state_type > $o ).

tff(pred_def_27327,type,
    v50078: state_type > $o ).

tff(pred_def_27328,type,
    v50084: state_type > $o ).

tff(pred_def_27329,type,
    v50082: state_type > $o ).

tff(pred_def_27330,type,
    v50072: state_type > $o ).

tff(pred_def_27331,type,
    v50090: state_type > $o ).

tff(pred_def_27332,type,
    v50092: state_type > $o ).

tff(pred_def_27333,type,
    v50088: state_type > $o ).

tff(pred_def_27334,type,
    v50087: state_type > $o ).

tff(pred_def_27335,type,
    v50098: state_type > $o ).

tff(pred_def_27336,type,
    v50099: state_type > $o ).

tff(pred_def_27337,type,
    v50095: state_type > $o ).

tff(pred_def_27338,type,
    v50097: state_type > $o ).

tff(pred_def_27339,type,
    v50105: state_type > $o ).

tff(pred_def_27340,type,
    v50103: state_type > $o ).

tff(pred_def_27341,type,
    v50107: state_type > $o ).

tff(pred_def_27342,type,
    v50066: state_type > $o ).

tff(pred_def_27343,type,
    v50064: state_type > $o ).

tff(pred_def_27344,type,
    v50062: state_type > $o ).

tff(pred_def_27345,type,
    v50114: state_type > $o ).

tff(pred_def_27346,type,
    v50112: state_type > $o ).

tff(pred_def_27347,type,
    v50111: state_type > $o ).

tff(pred_def_27348,type,
    v50110: state_type > $o ).

tff(pred_def_27349,type,
    v50122: state_type > $o ).

tff(pred_def_27350,type,
    v50123: state_type > $o ).

tff(pred_def_27351,type,
    v50121: state_type > $o ).

tff(pred_def_27352,type,
    v50118: ( state_type * $int ) > $o ).

tff(pred_def_27353,type,
    v50120: ( state_type * $int ) > $o ).

tff(pred_def_27354,type,
    v50109: ( state_type * $int ) > $o ).

tff(pred_def_27355,type,
    v49991: state_type > $o ).

tff(pred_def_27356,type,
    v49989: state_type > $o ).

tff(pred_def_27357,type,
    v50135: state_type > $o ).

tff(pred_def_27358,type,
    v50133: state_type > $o ).

tff(pred_def_27359,type,
    v50132: state_type > $o ).

tff(pred_def_27360,type,
    v50131: ( state_type * $int ) > $o ).

tff(pred_def_27361,type,
    v50129: state_type > $o ).

tff(pred_def_27362,type,
    v50127: state_type > $o ).

tff(pred_def_27363,type,
    v50140: state_type > $o ).

tff(pred_def_27364,type,
    v50139: state_type > $o ).

tff(pred_def_27365,type,
    v49972: state_type > $o ).

tff(pred_def_27366,type,
    v49970: state_type > $o ).

tff(pred_def_27367,type,
    v49968: state_type > $o ).

tff(pred_def_27368,type,
    v50141: ( state_type * $int ) > $o ).

tff(pred_def_27369,type,
    v50142: state_type > $o ).

tff(pred_def_27370,type,
    v49966: ( state_type * $int ) > $o ).

tff(pred_def_27371,type,
    v49964: ( state_type * $int ) > $o ).

tff(pred_def_27372,type,
    v50143: ( state_type * $int ) > $o ).

tff(pred_def_27373,type,
    v49954: ( state_type * $int ) > $o ).

tff(pred_def_27374,type,
    v49952: ( state_type * $int ) > $o ).

tff(pred_def_27375,type,
    v49950: state_type > $o ).

tff(pred_def_27376,type,
    v50144: ( state_type * $int ) > $o ).

tff(pred_def_27377,type,
    v50145: state_type > $o ).

tff(pred_def_27378,type,
    v49948: ( state_type * $int ) > $o ).

tff(pred_def_27379,type,
    v49946: ( state_type * $int ) > $o ).

tff(pred_def_27380,type,
    v50146: ( state_type * $int ) > $o ).

tff(pred_def_27381,type,
    v49938: ( state_type * $int ) > $o ).

tff(pred_def_27382,type,
    v49936: ( state_type * $int ) > $o ).

tff(pred_def_27383,type,
    v50152: state_type > $o ).

tff(pred_def_27384,type,
    v50150: state_type > $o ).

tff(pred_def_27385,type,
    v50149: state_type > $o ).

tff(pred_def_27386,type,
    v50148: ( state_type * $int ) > $o ).

tff(pred_def_27387,type,
    v49893: state_type > $o ).

tff(pred_def_27388,type,
    v49891: state_type > $o ).

tff(pred_def_27389,type,
    v50158: state_type > $o ).

tff(pred_def_27390,type,
    v50156: state_type > $o ).

tff(pred_def_27391,type,
    v50162: state_type > $o ).

tff(pred_def_27392,type,
    v50160: state_type > $o ).

tff(pred_def_27393,type,
    v50165: state_type > $o ).

tff(pred_def_27394,type,
    v50164: state_type > $o ).

tff(pred_def_27395,type,
    v49889: state_type > $o ).

tff(pred_def_27396,type,
    v49887: state_type > $o ).

tff(pred_def_27397,type,
    v49885: state_type > $o ).

tff(pred_def_27398,type,
    v49883: state_type > $o ).

tff(pred_def_27399,type,
    v49881: state_type > $o ).

tff(pred_def_27400,type,
    v49879: state_type > $o ).

tff(pred_def_27401,type,
    v49877: state_type > $o ).

tff(pred_def_27402,type,
    v49875: state_type > $o ).

tff(pred_def_27403,type,
    v50185: state_type > $o ).

tff(pred_def_27404,type,
    v50183: state_type > $o ).

tff(pred_def_27405,type,
    v50181: state_type > $o ).

tff(pred_def_27406,type,
    v50179: state_type > $o ).

tff(pred_def_27407,type,
    v50177: state_type > $o ).

tff(pred_def_27408,type,
    v50195: state_type > $o ).

tff(pred_def_27409,type,
    v50193: state_type > $o ).

tff(pred_def_27410,type,
    v50191: state_type > $o ).

tff(pred_def_27411,type,
    v50189: state_type > $o ).

tff(pred_def_27412,type,
    v50187: state_type > $o ).

tff(pred_def_27413,type,
    v50199: ( state_type * $int ) > $o ).

tff(pred_def_27414,type,
    v50197: ( state_type * $int ) > $o ).

tff(pred_def_27415,type,
    v50209: state_type > $o ).

tff(pred_def_27416,type,
    v50207: state_type > $o ).

tff(pred_def_27417,type,
    v50215: state_type > $o ).

tff(pred_def_27418,type,
    v50213: state_type > $o ).

tff(pred_def_27419,type,
    v50239: ( state_type * $int ) > $o ).

tff(pred_def_27420,type,
    v50237: ( state_type * $int ) > $o ).

tff(pred_def_27421,type,
    v50240: ( state_type * $int ) > $o ).

tff(pred_def_27422,type,
    v50235: ( state_type * $int ) > $o ).

tff(pred_def_27423,type,
    v50233: ( state_type * $int ) > $o ).

tff(pred_def_27424,type,
    v50231: ( state_type * $int ) > $o ).

tff(pred_def_27425,type,
    v50229: state_type > $o ).

tff(pred_def_27426,type,
    v50227: state_type > $o ).

tff(pred_def_27427,type,
    v50244: state_type > $o ).

tff(pred_def_27428,type,
    v50242: state_type > $o ).

tff(pred_def_27429,type,
    v50248: state_type > $o ).

tff(pred_def_27430,type,
    v50246: state_type > $o ).

tff(pred_def_27431,type,
    v50251: state_type > $o ).

tff(pred_def_27432,type,
    v50250: state_type > $o ).

tff(pred_def_27433,type,
    v50225: state_type > $o ).

tff(pred_def_27434,type,
    v50223: state_type > $o ).

tff(pred_def_27435,type,
    v50221: state_type > $o ).

tff(pred_def_27436,type,
    v50219: state_type > $o ).

tff(pred_def_27437,type,
    v50217: state_type > $o ).

tff(pred_def_27438,type,
    v50255: state_type > $o ).

tff(pred_def_27439,type,
    v50253: state_type > $o ).

tff(pred_def_27440,type,
    v50211: state_type > $o ).

tff(pred_def_27441,type,
    v50261: state_type > $o ).

tff(pred_def_27442,type,
    v50263: state_type > $o ).

tff(pred_def_27443,type,
    v50259: state_type > $o ).

tff(pred_def_27444,type,
    v50258: state_type > $o ).

tff(pred_def_27445,type,
    v50269: state_type > $o ).

tff(pred_def_27446,type,
    v50270: state_type > $o ).

tff(pred_def_27447,type,
    v50266: state_type > $o ).

tff(pred_def_27448,type,
    v50268: state_type > $o ).

tff(pred_def_27449,type,
    v50276: state_type > $o ).

tff(pred_def_27450,type,
    v50274: state_type > $o ).

tff(pred_def_27451,type,
    v50278: state_type > $o ).

tff(pred_def_27452,type,
    v50205: state_type > $o ).

tff(pred_def_27453,type,
    v50203: state_type > $o ).

tff(pred_def_27454,type,
    v50201: state_type > $o ).

tff(pred_def_27455,type,
    v50285: state_type > $o ).

tff(pred_def_27456,type,
    v50283: state_type > $o ).

tff(pred_def_27457,type,
    v50282: state_type > $o ).

tff(pred_def_27458,type,
    v50281: state_type > $o ).

tff(pred_def_27459,type,
    v50293: state_type > $o ).

tff(pred_def_27460,type,
    v50294: state_type > $o ).

tff(pred_def_27461,type,
    v50292: state_type > $o ).

tff(pred_def_27462,type,
    v50289: ( state_type * $int ) > $o ).

tff(pred_def_27463,type,
    v50291: ( state_type * $int ) > $o ).

tff(pred_def_27464,type,
    v50175: ( state_type * $int ) > $o ).

tff(pred_def_27465,type,
    v50173: ( state_type * $int ) > $o ).

tff(pred_def_27466,type,
    v50171: ( state_type * $int ) > $o ).

tff(pred_def_27467,type,
    v50169: ( state_type * $int ) > $o ).

tff(pred_def_27468,type,
    v50167: ( state_type * $int ) > $o ).

tff(pred_def_27469,type,
    v50316: state_type > $o ).

tff(pred_def_27470,type,
    v50314: state_type > $o ).

tff(pred_def_27471,type,
    v50320: state_type > $o ).

tff(pred_def_27472,type,
    v50318: state_type > $o ).

tff(pred_def_27473,type,
    v50324: state_type > $o ).

tff(pred_def_27474,type,
    v50322: state_type > $o ).

tff(pred_def_27475,type,
    v50327: state_type > $o ).

tff(pred_def_27476,type,
    v50326: state_type > $o ).

tff(pred_def_27477,type,
    v50312: state_type > $o ).

tff(pred_def_27478,type,
    v50310: state_type > $o ).

tff(pred_def_27479,type,
    v50308: state_type > $o ).

tff(pred_def_27480,type,
    v50306: state_type > $o ).

tff(pred_def_27481,type,
    v50304: state_type > $o ).

tff(pred_def_27482,type,
    v50302: state_type > $o ).

tff(pred_def_27483,type,
    v50300: state_type > $o ).

tff(pred_def_27484,type,
    v50298: state_type > $o ).

tff(pred_def_27485,type,
    v50347: state_type > $o ).

tff(pred_def_27486,type,
    v50345: state_type > $o ).

tff(pred_def_27487,type,
    v50343: state_type > $o ).

tff(pred_def_27488,type,
    v50341: state_type > $o ).

tff(pred_def_27489,type,
    v50339: state_type > $o ).

tff(pred_def_27490,type,
    v50357: state_type > $o ).

tff(pred_def_27491,type,
    v50355: state_type > $o ).

tff(pred_def_27492,type,
    v50353: state_type > $o ).

tff(pred_def_27493,type,
    v50351: state_type > $o ).

tff(pred_def_27494,type,
    v50349: state_type > $o ).

tff(pred_def_27495,type,
    v50361: ( state_type * $int ) > $o ).

tff(pred_def_27496,type,
    v50359: ( state_type * $int ) > $o ).

tff(pred_def_27497,type,
    v50371: state_type > $o ).

tff(pred_def_27498,type,
    v50369: state_type > $o ).

tff(pred_def_27499,type,
    v50377: state_type > $o ).

tff(pred_def_27500,type,
    v50375: state_type > $o ).

tff(pred_def_27501,type,
    v50391: state_type > $o ).

tff(pred_def_27502,type,
    v50389: state_type > $o ).

tff(pred_def_27503,type,
    v50395: state_type > $o ).

tff(pred_def_27504,type,
    v50393: state_type > $o ).

tff(pred_def_27505,type,
    v50399: state_type > $o ).

tff(pred_def_27506,type,
    v50397: state_type > $o ).

tff(pred_def_27507,type,
    v50402: state_type > $o ).

tff(pred_def_27508,type,
    v50401: state_type > $o ).

tff(pred_def_27509,type,
    v50387: state_type > $o ).

tff(pred_def_27510,type,
    v50385: state_type > $o ).

tff(pred_def_27511,type,
    v50383: state_type > $o ).

tff(pred_def_27512,type,
    v50381: state_type > $o ).

tff(pred_def_27513,type,
    v50379: state_type > $o ).

tff(pred_def_27514,type,
    v50406: state_type > $o ).

tff(pred_def_27515,type,
    v50404: state_type > $o ).

tff(pred_def_27516,type,
    v50373: state_type > $o ).

tff(pred_def_27517,type,
    v50412: state_type > $o ).

tff(pred_def_27518,type,
    v50414: state_type > $o ).

tff(pred_def_27519,type,
    v50410: state_type > $o ).

tff(pred_def_27520,type,
    v50409: state_type > $o ).

tff(pred_def_27521,type,
    v50420: state_type > $o ).

tff(pred_def_27522,type,
    v50421: state_type > $o ).

tff(pred_def_27523,type,
    v50417: state_type > $o ).

tff(pred_def_27524,type,
    v50419: state_type > $o ).

tff(pred_def_27525,type,
    v50427: state_type > $o ).

tff(pred_def_27526,type,
    v50425: state_type > $o ).

tff(pred_def_27527,type,
    v50429: state_type > $o ).

tff(pred_def_27528,type,
    v50367: state_type > $o ).

tff(pred_def_27529,type,
    v50365: state_type > $o ).

tff(pred_def_27530,type,
    v50363: state_type > $o ).

tff(pred_def_27531,type,
    v50436: state_type > $o ).

tff(pred_def_27532,type,
    v50434: state_type > $o ).

tff(pred_def_27533,type,
    v50433: state_type > $o ).

tff(pred_def_27534,type,
    v50432: state_type > $o ).

tff(pred_def_27535,type,
    v50444: state_type > $o ).

tff(pred_def_27536,type,
    v50445: state_type > $o ).

tff(pred_def_27537,type,
    v50443: state_type > $o ).

tff(pred_def_27538,type,
    v50440: ( state_type * $int ) > $o ).

tff(pred_def_27539,type,
    v50442: ( state_type * $int ) > $o ).

tff(pred_def_27540,type,
    v50337: ( state_type * $int ) > $o ).

tff(pred_def_27541,type,
    v50335: ( state_type * $int ) > $o ).

tff(pred_def_27542,type,
    v50333: ( state_type * $int ) > $o ).

tff(pred_def_27543,type,
    v50331: ( state_type * $int ) > $o ).

tff(pred_def_27544,type,
    v50329: ( state_type * $int ) > $o ).

tff(pred_def_27545,type,
    v50467: state_type > $o ).

tff(pred_def_27546,type,
    v50465: state_type > $o ).

tff(pred_def_27547,type,
    v50471: state_type > $o ).

tff(pred_def_27548,type,
    v50469: state_type > $o ).

tff(pred_def_27549,type,
    v50475: state_type > $o ).

tff(pred_def_27550,type,
    v50473: state_type > $o ).

tff(pred_def_27551,type,
    v50478: state_type > $o ).

tff(pred_def_27552,type,
    v50477: state_type > $o ).

tff(pred_def_27553,type,
    v50463: state_type > $o ).

tff(pred_def_27554,type,
    v50461: state_type > $o ).

tff(pred_def_27555,type,
    v50459: state_type > $o ).

tff(pred_def_27556,type,
    v50457: state_type > $o ).

tff(pred_def_27557,type,
    v50455: state_type > $o ).

tff(pred_def_27558,type,
    v50453: state_type > $o ).

tff(pred_def_27559,type,
    v50451: state_type > $o ).

tff(pred_def_27560,type,
    v50449: state_type > $o ).

tff(pred_def_27561,type,
    v50498: state_type > $o ).

tff(pred_def_27562,type,
    v50496: state_type > $o ).

tff(pred_def_27563,type,
    v50494: state_type > $o ).

tff(pred_def_27564,type,
    v50492: state_type > $o ).

tff(pred_def_27565,type,
    v50490: state_type > $o ).

tff(pred_def_27566,type,
    v50508: state_type > $o ).

tff(pred_def_27567,type,
    v50506: state_type > $o ).

tff(pred_def_27568,type,
    v50504: state_type > $o ).

tff(pred_def_27569,type,
    v50502: state_type > $o ).

tff(pred_def_27570,type,
    v50500: state_type > $o ).

tff(pred_def_27571,type,
    v50512: ( state_type * $int ) > $o ).

tff(pred_def_27572,type,
    v50510: ( state_type * $int ) > $o ).

tff(pred_def_27573,type,
    v50522: state_type > $o ).

tff(pred_def_27574,type,
    v50520: state_type > $o ).

tff(pred_def_27575,type,
    v50528: state_type > $o ).

tff(pred_def_27576,type,
    v50526: state_type > $o ).

tff(pred_def_27577,type,
    v50542: state_type > $o ).

tff(pred_def_27578,type,
    v50540: state_type > $o ).

tff(pred_def_27579,type,
    v50546: state_type > $o ).

tff(pred_def_27580,type,
    v50544: state_type > $o ).

tff(pred_def_27581,type,
    v50550: state_type > $o ).

tff(pred_def_27582,type,
    v50548: state_type > $o ).

tff(pred_def_27583,type,
    v50553: state_type > $o ).

tff(pred_def_27584,type,
    v50552: state_type > $o ).

tff(pred_def_27585,type,
    v50538: state_type > $o ).

tff(pred_def_27586,type,
    v50536: state_type > $o ).

tff(pred_def_27587,type,
    v50534: state_type > $o ).

tff(pred_def_27588,type,
    v50532: state_type > $o ).

tff(pred_def_27589,type,
    v50530: state_type > $o ).

tff(pred_def_27590,type,
    v50557: state_type > $o ).

tff(pred_def_27591,type,
    v50555: state_type > $o ).

tff(pred_def_27592,type,
    v50524: state_type > $o ).

tff(pred_def_27593,type,
    v50563: state_type > $o ).

tff(pred_def_27594,type,
    v50565: state_type > $o ).

tff(pred_def_27595,type,
    v50561: state_type > $o ).

tff(pred_def_27596,type,
    v50560: state_type > $o ).

tff(pred_def_27597,type,
    v50571: state_type > $o ).

tff(pred_def_27598,type,
    v50572: state_type > $o ).

tff(pred_def_27599,type,
    v50568: state_type > $o ).

tff(pred_def_27600,type,
    v50570: state_type > $o ).

tff(pred_def_27601,type,
    v50578: state_type > $o ).

tff(pred_def_27602,type,
    v50576: state_type > $o ).

tff(pred_def_27603,type,
    v50580: state_type > $o ).

tff(pred_def_27604,type,
    v50518: state_type > $o ).

tff(pred_def_27605,type,
    v50516: state_type > $o ).

tff(pred_def_27606,type,
    v50514: state_type > $o ).

tff(pred_def_27607,type,
    v50587: state_type > $o ).

tff(pred_def_27608,type,
    v50585: state_type > $o ).

tff(pred_def_27609,type,
    v50584: state_type > $o ).

tff(pred_def_27610,type,
    v50583: state_type > $o ).

tff(pred_def_27611,type,
    v50595: state_type > $o ).

tff(pred_def_27612,type,
    v50596: state_type > $o ).

tff(pred_def_27613,type,
    v50594: state_type > $o ).

tff(pred_def_27614,type,
    v50591: ( state_type * $int ) > $o ).

tff(pred_def_27615,type,
    v50593: ( state_type * $int ) > $o ).

tff(pred_def_27616,type,
    v50488: ( state_type * $int ) > $o ).

tff(pred_def_27617,type,
    v50486: ( state_type * $int ) > $o ).

tff(pred_def_27618,type,
    v50484: ( state_type * $int ) > $o ).

tff(pred_def_27619,type,
    v50482: ( state_type * $int ) > $o ).

tff(pred_def_27620,type,
    v50480: ( state_type * $int ) > $o ).

tff(pred_def_27621,type,
    v50618: state_type > $o ).

tff(pred_def_27622,type,
    v50616: state_type > $o ).

tff(pred_def_27623,type,
    v50622: state_type > $o ).

tff(pred_def_27624,type,
    v50620: state_type > $o ).

tff(pred_def_27625,type,
    v50626: state_type > $o ).

tff(pred_def_27626,type,
    v50624: state_type > $o ).

tff(pred_def_27627,type,
    v50629: state_type > $o ).

tff(pred_def_27628,type,
    v50628: state_type > $o ).

tff(pred_def_27629,type,
    v50614: state_type > $o ).

tff(pred_def_27630,type,
    v50612: state_type > $o ).

tff(pred_def_27631,type,
    v50610: state_type > $o ).

tff(pred_def_27632,type,
    v50608: state_type > $o ).

tff(pred_def_27633,type,
    v50606: state_type > $o ).

tff(pred_def_27634,type,
    v50604: state_type > $o ).

tff(pred_def_27635,type,
    v50602: state_type > $o ).

tff(pred_def_27636,type,
    v50600: state_type > $o ).

tff(pred_def_27637,type,
    v50649: state_type > $o ).

tff(pred_def_27638,type,
    v50647: state_type > $o ).

tff(pred_def_27639,type,
    v50645: state_type > $o ).

tff(pred_def_27640,type,
    v50643: state_type > $o ).

tff(pred_def_27641,type,
    v50641: state_type > $o ).

tff(pred_def_27642,type,
    v50659: state_type > $o ).

tff(pred_def_27643,type,
    v50657: state_type > $o ).

tff(pred_def_27644,type,
    v50655: state_type > $o ).

tff(pred_def_27645,type,
    v50653: state_type > $o ).

tff(pred_def_27646,type,
    v50651: state_type > $o ).

tff(pred_def_27647,type,
    v50663: ( state_type * $int ) > $o ).

tff(pred_def_27648,type,
    v50661: ( state_type * $int ) > $o ).

tff(pred_def_27649,type,
    v50673: state_type > $o ).

tff(pred_def_27650,type,
    v50671: state_type > $o ).

tff(pred_def_27651,type,
    v50679: state_type > $o ).

tff(pred_def_27652,type,
    v50677: state_type > $o ).

tff(pred_def_27653,type,
    v50693: state_type > $o ).

tff(pred_def_27654,type,
    v50691: state_type > $o ).

tff(pred_def_27655,type,
    v50697: state_type > $o ).

tff(pred_def_27656,type,
    v50695: state_type > $o ).

tff(pred_def_27657,type,
    v50701: state_type > $o ).

tff(pred_def_27658,type,
    v50699: state_type > $o ).

tff(pred_def_27659,type,
    v50704: state_type > $o ).

tff(pred_def_27660,type,
    v50703: state_type > $o ).

tff(pred_def_27661,type,
    v50689: state_type > $o ).

tff(pred_def_27662,type,
    v50687: state_type > $o ).

tff(pred_def_27663,type,
    v50685: state_type > $o ).

tff(pred_def_27664,type,
    v50683: state_type > $o ).

tff(pred_def_27665,type,
    v50681: state_type > $o ).

tff(pred_def_27666,type,
    v50708: state_type > $o ).

tff(pred_def_27667,type,
    v50706: state_type > $o ).

tff(pred_def_27668,type,
    v50675: state_type > $o ).

tff(pred_def_27669,type,
    v50714: state_type > $o ).

tff(pred_def_27670,type,
    v50716: state_type > $o ).

tff(pred_def_27671,type,
    v50712: state_type > $o ).

tff(pred_def_27672,type,
    v50711: state_type > $o ).

tff(pred_def_27673,type,
    v50722: state_type > $o ).

tff(pred_def_27674,type,
    v50723: state_type > $o ).

tff(pred_def_27675,type,
    v50719: state_type > $o ).

tff(pred_def_27676,type,
    v50721: state_type > $o ).

tff(pred_def_27677,type,
    v50729: state_type > $o ).

tff(pred_def_27678,type,
    v50727: state_type > $o ).

tff(pred_def_27679,type,
    v50731: state_type > $o ).

tff(pred_def_27680,type,
    v50669: state_type > $o ).

tff(pred_def_27681,type,
    v50667: state_type > $o ).

tff(pred_def_27682,type,
    v50665: state_type > $o ).

tff(pred_def_27683,type,
    v50738: state_type > $o ).

tff(pred_def_27684,type,
    v50736: state_type > $o ).

tff(pred_def_27685,type,
    v50735: state_type > $o ).

tff(pred_def_27686,type,
    v50734: state_type > $o ).

tff(pred_def_27687,type,
    v50746: state_type > $o ).

tff(pred_def_27688,type,
    v50747: state_type > $o ).

tff(pred_def_27689,type,
    v50745: state_type > $o ).

tff(pred_def_27690,type,
    v50742: ( state_type * $int ) > $o ).

tff(pred_def_27691,type,
    v50744: ( state_type * $int ) > $o ).

tff(pred_def_27692,type,
    v50639: ( state_type * $int ) > $o ).

tff(pred_def_27693,type,
    v50637: ( state_type * $int ) > $o ).

tff(pred_def_27694,type,
    v50635: ( state_type * $int ) > $o ).

tff(pred_def_27695,type,
    v50633: ( state_type * $int ) > $o ).

tff(pred_def_27696,type,
    v50631: ( state_type * $int ) > $o ).

tff(pred_def_27697,type,
    v50769: state_type > $o ).

tff(pred_def_27698,type,
    v50767: state_type > $o ).

tff(pred_def_27699,type,
    v50773: state_type > $o ).

tff(pred_def_27700,type,
    v50771: state_type > $o ).

tff(pred_def_27701,type,
    v50777: state_type > $o ).

tff(pred_def_27702,type,
    v50775: state_type > $o ).

tff(pred_def_27703,type,
    v50780: state_type > $o ).

tff(pred_def_27704,type,
    v50779: state_type > $o ).

tff(pred_def_27705,type,
    v50765: state_type > $o ).

tff(pred_def_27706,type,
    v50763: state_type > $o ).

tff(pred_def_27707,type,
    v50761: state_type > $o ).

tff(pred_def_27708,type,
    v50759: state_type > $o ).

tff(pred_def_27709,type,
    v50757: state_type > $o ).

tff(pred_def_27710,type,
    v50755: state_type > $o ).

tff(pred_def_27711,type,
    v50753: state_type > $o ).

tff(pred_def_27712,type,
    v50751: state_type > $o ).

tff(pred_def_27713,type,
    v50800: state_type > $o ).

tff(pred_def_27714,type,
    v50798: state_type > $o ).

tff(pred_def_27715,type,
    v50796: state_type > $o ).

tff(pred_def_27716,type,
    v50794: state_type > $o ).

tff(pred_def_27717,type,
    v50792: state_type > $o ).

tff(pred_def_27718,type,
    v50810: state_type > $o ).

tff(pred_def_27719,type,
    v50808: state_type > $o ).

tff(pred_def_27720,type,
    v50806: state_type > $o ).

tff(pred_def_27721,type,
    v50804: state_type > $o ).

tff(pred_def_27722,type,
    v50802: state_type > $o ).

tff(pred_def_27723,type,
    v50814: ( state_type * $int ) > $o ).

tff(pred_def_27724,type,
    v50812: ( state_type * $int ) > $o ).

tff(pred_def_27725,type,
    v50824: state_type > $o ).

tff(pred_def_27726,type,
    v50822: state_type > $o ).

tff(pred_def_27727,type,
    v50830: state_type > $o ).

tff(pred_def_27728,type,
    v50828: state_type > $o ).

tff(pred_def_27729,type,
    v50843: state_type > $o ).

tff(pred_def_27730,type,
    v50841: state_type > $o ).

tff(pred_def_27731,type,
    v50847: state_type > $o ).

tff(pred_def_27732,type,
    v50845: state_type > $o ).

tff(pred_def_27733,type,
    v50851: state_type > $o ).

tff(pred_def_27734,type,
    v50849: state_type > $o ).

tff(pred_def_27735,type,
    v50854: state_type > $o ).

tff(pred_def_27736,type,
    v50853: state_type > $o ).

tff(pred_def_27737,type,
    v50839: state_type > $o ).

tff(pred_def_27738,type,
    v50837: state_type > $o ).

tff(pred_def_27739,type,
    v50834: state_type > $o ).

tff(pred_def_27740,type,
    v50832: state_type > $o ).

tff(pred_def_27741,type,
    v50858: state_type > $o ).

tff(pred_def_27742,type,
    v50856: state_type > $o ).

tff(pred_def_27743,type,
    v50826: state_type > $o ).

tff(pred_def_27744,type,
    v50864: state_type > $o ).

tff(pred_def_27745,type,
    v50866: state_type > $o ).

tff(pred_def_27746,type,
    v50862: state_type > $o ).

tff(pred_def_27747,type,
    v50861: state_type > $o ).

tff(pred_def_27748,type,
    v50872: state_type > $o ).

tff(pred_def_27749,type,
    v50873: state_type > $o ).

tff(pred_def_27750,type,
    v50869: state_type > $o ).

tff(pred_def_27751,type,
    v50871: state_type > $o ).

tff(pred_def_27752,type,
    v50879: state_type > $o ).

tff(pred_def_27753,type,
    v50877: state_type > $o ).

tff(pred_def_27754,type,
    v50881: state_type > $o ).

tff(pred_def_27755,type,
    v50820: state_type > $o ).

tff(pred_def_27756,type,
    v50818: state_type > $o ).

tff(pred_def_27757,type,
    v50816: state_type > $o ).

tff(pred_def_27758,type,
    v50888: state_type > $o ).

tff(pred_def_27759,type,
    v50886: state_type > $o ).

tff(pred_def_27760,type,
    v50885: state_type > $o ).

tff(pred_def_27761,type,
    v50884: state_type > $o ).

tff(pred_def_27762,type,
    v50896: state_type > $o ).

tff(pred_def_27763,type,
    v50897: state_type > $o ).

tff(pred_def_27764,type,
    v50895: state_type > $o ).

tff(pred_def_27765,type,
    v50892: ( state_type * $int ) > $o ).

tff(pred_def_27766,type,
    v50894: ( state_type * $int ) > $o ).

tff(pred_def_27767,type,
    v50790: ( state_type * $int ) > $o ).

tff(pred_def_27768,type,
    v50788: ( state_type * $int ) > $o ).

tff(pred_def_27769,type,
    v50786: ( state_type * $int ) > $o ).

tff(pred_def_27770,type,
    v50784: ( state_type * $int ) > $o ).

tff(pred_def_27771,type,
    v50782: ( state_type * $int ) > $o ).

tff(pred_def_27772,type,
    v50909: state_type > $o ).

tff(pred_def_27773,type,
    v50907: state_type > $o ).

tff(pred_def_27774,type,
    v50905: state_type > $o ).

tff(pred_def_27775,type,
    v50903: state_type > $o ).

tff(pred_def_27776,type,
    v50901: state_type > $o ).

tff(pred_def_27777,type,
    v50917: state_type > $o ).

tff(pred_def_27778,type,
    v50916: ( state_type * $int ) > $o ).

tff(pred_def_27779,type,
    v50915: ( state_type * $int ) > $o ).

tff(pred_def_27780,type,
    v50920: state_type > $o ).

tff(pred_def_27781,type,
    v50919: ( state_type * $int ) > $o ).

tff(pred_def_27782,type,
    v50918: ( state_type * $int ) > $o ).

tff(pred_def_27783,type,
    v50914: ( state_type * $int ) > $o ).

tff(pred_def_27784,type,
    v50923: state_type > $o ).

tff(pred_def_27785,type,
    v50922: ( state_type * $int ) > $o ).

tff(pred_def_27786,type,
    v50921: ( state_type * $int ) > $o ).

tff(pred_def_27787,type,
    v50913: ( state_type * $int ) > $o ).

tff(pred_def_27788,type,
    v50926: state_type > $o ).

tff(pred_def_27789,type,
    v50925: ( state_type * $int ) > $o ).

tff(pred_def_27790,type,
    v50924: ( state_type * $int ) > $o ).

tff(pred_def_27791,type,
    v50912: ( state_type * $int ) > $o ).

tff(pred_def_27792,type,
    v50929: state_type > $o ).

tff(pred_def_27793,type,
    v50928: ( state_type * $int ) > $o ).

tff(pred_def_27794,type,
    v50927: ( state_type * $int ) > $o ).

tff(pred_def_27795,type,
    v50911: ( state_type * $int ) > $o ).

tff(pred_def_27796,type,
    v50932: state_type > $o ).

tff(pred_def_27797,type,
    v50931: ( state_type * $int ) > $o ).

tff(pred_def_27798,type,
    v50930: ( state_type * $int ) > $o ).

tff(pred_def_27799,type,
    v49403: ( state_type * $int ) > $o ).

tff(pred_def_27800,type,
    v49401: ( state_type * $int ) > $o ).

tff(pred_def_27801,type,
    v49399: ( state_type * $int ) > $o ).

tff(pred_def_27802,type,
    v49397: ( state_type * $int ) > $o ).

tff(pred_def_27803,type,
    v49395: ( state_type * $int ) > $o ).

tff(pred_def_27804,type,
    v49389: state_type > $o ).

tff(pred_def_27805,type,
    v49387: state_type > $o ).

tff(pred_def_27806,type,
    v49385: state_type > $o ).

tff(pred_def_27807,type,
    v50943: ( state_type * $int ) > $o ).

tff(pred_def_27808,type,
    v50941: ( state_type * $int ) > $o ).

tff(pred_def_27809,type,
    v50977: state_type > $o ).

tff(pred_def_27810,type,
    v50975: state_type > $o ).

tff(pred_def_27811,type,
    v50973: state_type > $o ).

tff(pred_def_27812,type,
    v50971: state_type > $o ).

tff(pred_def_27813,type,
    v50969: state_type > $o ).

tff(pred_def_27814,type,
    v50967: state_type > $o ).

tff(pred_def_27815,type,
    v50965: state_type > $o ).

tff(pred_def_27816,type,
    v50991: state_type > $o ).

tff(pred_def_27817,type,
    v50989: state_type > $o ).

tff(pred_def_27818,type,
    v50987: state_type > $o ).

tff(pred_def_27819,type,
    v50985: state_type > $o ).

tff(pred_def_27820,type,
    v50983: state_type > $o ).

tff(pred_def_27821,type,
    v50981: state_type > $o ).

tff(pred_def_27822,type,
    v50979: state_type > $o ).

tff(pred_def_27823,type,
    v51017: state_type > $o ).

tff(pred_def_27824,type,
    v51019: state_type > $o ).

tff(pred_def_27825,type,
    v51018: ( state_type * $int ) > $o ).

tff(pred_def_27826,type,
    v51020: state_type > $o ).

tff(pred_def_27827,type,
    v51015: ( state_type * $int ) > $o ).

tff(pred_def_27828,type,
    v51013: ( state_type * $int ) > $o ).

tff(pred_def_27829,type,
    v51021: ( state_type * $int ) > $o ).

tff(pred_def_27830,type,
    v51011: ( state_type * $int ) > $o ).

tff(pred_def_27831,type,
    v51009: ( state_type * $int ) > $o ).

tff(pred_def_27832,type,
    v51007: state_type > $o ).

tff(pred_def_27833,type,
    v51023: state_type > $o ).

tff(pred_def_27834,type,
    v51005: ( state_type * $int ) > $o ).

tff(pred_def_27835,type,
    v51003: ( state_type * $int ) > $o ).

tff(pred_def_27836,type,
    v51029: ( state_type * $int ) > $o ).

tff(pred_def_27837,type,
    v51027: ( state_type * $int ) > $o ).

tff(pred_def_27838,type,
    v51025: ( state_type * $int ) > $o ).

tff(pred_def_27839,type,
    v51001: ( state_type * $int ) > $o ).

tff(pred_def_27840,type,
    v50999: ( state_type * $int ) > $o ).

tff(pred_def_27841,type,
    v50997: ( state_type * $int ) > $o ).

tff(pred_def_27842,type,
    v50995: ( state_type * $int ) > $o ).

tff(pred_def_27843,type,
    v50993: ( state_type * $int ) > $o ).

tff(pred_def_27844,type,
    v51042: state_type > $o ).

tff(pred_def_27845,type,
    v51040: state_type > $o ).

tff(pred_def_27846,type,
    v51038: state_type > $o ).

tff(pred_def_27847,type,
    v51048: state_type > $o ).

tff(pred_def_27848,type,
    v51046: state_type > $o ).

tff(pred_def_27849,type,
    v51066: ( state_type * $int ) > $o ).

tff(pred_def_27850,type,
    v51068: ( state_type * $int ) > $o ).

tff(pred_def_27851,type,
    v51064: ( state_type * $int ) > $o ).

tff(pred_def_27852,type,
    v51062: state_type > $o ).

tff(pred_def_27853,type,
    v51060: state_type > $o ).

tff(pred_def_27854,type,
    v51072: state_type > $o ).

tff(pred_def_27855,type,
    v51070: state_type > $o ).

tff(pred_def_27856,type,
    v51076: state_type > $o ).

tff(pred_def_27857,type,
    v51074: state_type > $o ).

tff(pred_def_27858,type,
    v51079: state_type > $o ).

tff(pred_def_27859,type,
    v51078: state_type > $o ).

tff(pred_def_27860,type,
    v51058: state_type > $o ).

tff(pred_def_27861,type,
    v51056: state_type > $o ).

tff(pred_def_27862,type,
    v51054: state_type > $o ).

tff(pred_def_27863,type,
    v51052: state_type > $o ).

tff(pred_def_27864,type,
    v51050: state_type > $o ).

tff(pred_def_27865,type,
    v51087: state_type > $o ).

tff(pred_def_27866,type,
    v51085: state_type > $o ).

tff(pred_def_27867,type,
    v51083: state_type > $o ).

tff(pred_def_27868,type,
    v51081: state_type > $o ).

tff(pred_def_27869,type,
    v51044: state_type > $o ).

tff(pred_def_27870,type,
    v51093: state_type > $o ).

tff(pred_def_27871,type,
    v51095: state_type > $o ).

tff(pred_def_27872,type,
    v51091: state_type > $o ).

tff(pred_def_27873,type,
    v51090: state_type > $o ).

tff(pred_def_27874,type,
    v51101: state_type > $o ).

tff(pred_def_27875,type,
    v51102: state_type > $o ).

tff(pred_def_27876,type,
    v51098: state_type > $o ).

tff(pred_def_27877,type,
    v51100: state_type > $o ).

tff(pred_def_27878,type,
    v51112: state_type > $o ).

tff(pred_def_27879,type,
    v51110: state_type > $o ).

tff(pred_def_27880,type,
    v51108: state_type > $o ).

tff(pred_def_27881,type,
    v51106: state_type > $o ).

tff(pred_def_27882,type,
    v51114: state_type > $o ).

tff(pred_def_27883,type,
    v51036: state_type > $o ).

tff(pred_def_27884,type,
    v51034: state_type > $o ).

tff(pred_def_27885,type,
    v51032: state_type > $o ).

tff(pred_def_27886,type,
    v51121: state_type > $o ).

tff(pred_def_27887,type,
    v51119: state_type > $o ).

tff(pred_def_27888,type,
    v51118: state_type > $o ).

tff(pred_def_27889,type,
    v51117: state_type > $o ).

tff(pred_def_27890,type,
    v51129: state_type > $o ).

tff(pred_def_27891,type,
    v51130: state_type > $o ).

tff(pred_def_27892,type,
    v51128: state_type > $o ).

tff(pred_def_27893,type,
    v51125: ( state_type * $int ) > $o ).

tff(pred_def_27894,type,
    v51127: ( state_type * $int ) > $o ).

tff(pred_def_27895,type,
    v50963: ( state_type * $int ) > $o ).

tff(pred_def_27896,type,
    v50961: ( state_type * $int ) > $o ).

tff(pred_def_27897,type,
    v50959: ( state_type * $int ) > $o ).

tff(pred_def_27898,type,
    v50957: ( state_type * $int ) > $o ).

tff(pred_def_27899,type,
    v50955: ( state_type * $int ) > $o ).

tff(pred_def_27900,type,
    v51166: state_type > $o ).

tff(pred_def_27901,type,
    v51164: state_type > $o ).

tff(pred_def_27902,type,
    v51162: state_type > $o ).

tff(pred_def_27903,type,
    v51160: state_type > $o ).

tff(pred_def_27904,type,
    v51158: state_type > $o ).

tff(pred_def_27905,type,
    v51156: state_type > $o ).

tff(pred_def_27906,type,
    v51176: state_type > $o ).

tff(pred_def_27907,type,
    v51174: state_type > $o ).

tff(pred_def_27908,type,
    v51172: state_type > $o ).

tff(pred_def_27909,type,
    v51170: state_type > $o ).

tff(pred_def_27910,type,
    v51168: state_type > $o ).

tff(pred_def_27911,type,
    v51203: state_type > $o ).

tff(pred_def_27912,type,
    v51202: ( state_type * $int ) > $o ).

tff(pred_def_27913,type,
    v51201: ( state_type * $int ) > $o ).

tff(pred_def_27914,type,
    v51199: ( state_type * $int ) > $o ).

tff(pred_def_27915,type,
    v51219: state_type > $o ).

tff(pred_def_27916,type,
    v51220: ( state_type * $int ) > $o ).

tff(pred_def_27917,type,
    v51221: state_type > $o ).

tff(pred_def_27918,type,
    v51217: ( state_type * $int ) > $o ).

tff(pred_def_27919,type,
    v51215: ( state_type * $int ) > $o ).

tff(pred_def_27920,type,
    v51245: ( state_type * $int ) > $o ).

tff(pred_def_27921,type,
    v51154: ( state_type * $int ) > $o ).

tff(pred_def_27922,type,
    v51243: ( state_type * $int ) > $o ).

tff(pred_def_27923,type,
    v51246: ( state_type * $int ) > $o ).

tff(pred_def_27924,type,
    v51241: ( state_type * $int ) > $o ).

tff(pred_def_27925,type,
    v51239: ( state_type * $int ) > $o ).

tff(pred_def_27926,type,
    v51237: ( state_type * $int ) > $o ).

tff(pred_def_27927,type,
    v51235: state_type > $o ).

tff(pred_def_27928,type,
    v51233: state_type > $o ).

tff(pred_def_27929,type,
    v51252: state_type > $o ).

tff(pred_def_27930,type,
    v51192: state_type > $o ).

tff(pred_def_27931,type,
    v51251: ( state_type * $int ) > $o ).

tff(pred_def_27932,type,
    v51190: ( state_type * $int ) > $o ).

tff(pred_def_27933,type,
    v51188: ( state_type * $int ) > $o ).

tff(pred_def_27934,type,
    v51267: ( state_type * $int ) > $o ).

tff(pred_def_27935,type,
    v51266: ( state_type * $int ) > $o ).

tff(pred_def_27936,type,
    v51264: ( state_type * $int ) > $o ).

tff(pred_def_27937,type,
    v51271: state_type > $o ).

tff(pred_def_27938,type,
    v51269: state_type > $o ).

tff(pred_def_27939,type,
    v51282: ( state_type * $int ) > $o ).

tff(pred_def_27940,type,
    v51281: state_type > $o ).

tff(pred_def_27941,type,
    v51285: state_type > $o ).

tff(pred_def_27942,type,
    v51286: state_type > $o ).

tff(pred_def_27943,type,
    v51284: state_type > $o ).

tff(pred_def_27944,type,
    v51287: state_type > $o ).

tff(pred_def_27945,type,
    v51283: state_type > $o ).

tff(pred_def_27946,type,
    v51280: state_type > $o ).

tff(pred_def_27947,type,
    v51288: state_type > $o ).

tff(pred_def_27948,type,
    v51279: state_type > $o ).

tff(pred_def_27949,type,
    v51291: state_type > $o ).

tff(pred_def_27950,type,
    v51292: state_type > $o ).

tff(pred_def_27951,type,
    v51290: state_type > $o ).

tff(pred_def_27952,type,
    v51293: state_type > $o ).

tff(pred_def_27953,type,
    v51289: state_type > $o ).

tff(pred_def_27954,type,
    v51278: state_type > $o ).

tff(pred_def_27955,type,
    v51294: state_type > $o ).

tff(pred_def_27956,type,
    v51277: state_type > $o ).

tff(pred_def_27957,type,
    v51276: state_type > $o ).

tff(pred_def_27958,type,
    v51298: state_type > $o ).

tff(pred_def_27959,type,
    v51299: state_type > $o ).

tff(pred_def_27960,type,
    v51297: state_type > $o ).

tff(pred_def_27961,type,
    v51300: state_type > $o ).

tff(pred_def_27962,type,
    v51296: state_type > $o ).

tff(pred_def_27963,type,
    v51295: state_type > $o ).

tff(pred_def_27964,type,
    v51275: state_type > $o ).

tff(pred_def_27965,type,
    v51301: state_type > $o ).

tff(pred_def_27966,type,
    v51274: state_type > $o ).

tff(pred_def_27967,type,
    v51304: state_type > $o ).

tff(pred_def_27968,type,
    v51305: state_type > $o ).

tff(pred_def_27969,type,
    v51303: state_type > $o ).

tff(pred_def_27970,type,
    v51306: state_type > $o ).

tff(pred_def_27971,type,
    v51302: state_type > $o ).

tff(pred_def_27972,type,
    v51309: state_type > $o ).

tff(pred_def_27973,type,
    v51310: state_type > $o ).

tff(pred_def_27974,type,
    v51308: state_type > $o ).

tff(pred_def_27975,type,
    v51311: state_type > $o ).

tff(pred_def_27976,type,
    v51307: state_type > $o ).

tff(pred_def_27977,type,
    v51314: state_type > $o ).

tff(pred_def_27978,type,
    v51315: state_type > $o ).

tff(pred_def_27979,type,
    v51313: state_type > $o ).

tff(pred_def_27980,type,
    v51316: state_type > $o ).

tff(pred_def_27981,type,
    v51312: state_type > $o ).

tff(pred_def_27982,type,
    v51272: ( state_type * $int ) > $o ).

tff(pred_def_27983,type,
    v51262: ( state_type * $int ) > $o ).

tff(pred_def_27984,type,
    v51260: ( state_type * $int ) > $o ).

tff(pred_def_27985,type,
    v51258: ( state_type * $int ) > $o ).

tff(pred_def_27986,type,
    v51256: ( state_type * $int ) > $o ).

tff(pred_def_27987,type,
    v51254: ( state_type * $int ) > $o ).

tff(pred_def_27988,type,
    v51317: ( state_type * $int ) > $o ).

tff(pred_def_27989,type,
    v51186: ( state_type * $int ) > $o ).

tff(pred_def_27990,type,
    v51184: ( state_type * $int ) > $o ).

tff(pred_def_27991,type,
    v51182: ( state_type * $int ) > $o ).

tff(pred_def_27992,type,
    v51318: ( state_type * $int ) > $o ).

tff(pred_def_27993,type,
    v51319: ( state_type * $int ) > $o ).

tff(pred_def_27994,type,
    v51180: ( state_type * $int ) > $o ).

tff(pred_def_27995,type,
    v51178: ( state_type * $int ) > $o ).

tff(pred_def_27996,type,
    v51329: state_type > $o ).

tff(pred_def_27997,type,
    v51327: state_type > $o ).

tff(pred_def_27998,type,
    v51335: state_type > $o ).

tff(pred_def_27999,type,
    v51333: state_type > $o ).

tff(pred_def_28000,type,
    v51339: state_type > $o ).

tff(pred_def_28001,type,
    v51337: state_type > $o ).

tff(pred_def_28002,type,
    v51343: state_type > $o ).

tff(pred_def_28003,type,
    v51341: state_type > $o ).

tff(pred_def_28004,type,
    v51331: state_type > $o ).

tff(pred_def_28005,type,
    v51349: state_type > $o ).

tff(pred_def_28006,type,
    v51351: state_type > $o ).

tff(pred_def_28007,type,
    v51347: state_type > $o ).

tff(pred_def_28008,type,
    v51346: state_type > $o ).

tff(pred_def_28009,type,
    v51357: state_type > $o ).

tff(pred_def_28010,type,
    v51358: state_type > $o ).

tff(pred_def_28011,type,
    v51354: state_type > $o ).

tff(pred_def_28012,type,
    v51356: state_type > $o ).

tff(pred_def_28013,type,
    v51364: state_type > $o ).

tff(pred_def_28014,type,
    v51362: state_type > $o ).

tff(pred_def_28015,type,
    v51366: state_type > $o ).

tff(pred_def_28016,type,
    v51325: state_type > $o ).

tff(pred_def_28017,type,
    v51323: state_type > $o ).

tff(pred_def_28018,type,
    v51321: state_type > $o ).

tff(pred_def_28019,type,
    v51373: state_type > $o ).

tff(pred_def_28020,type,
    v51371: state_type > $o ).

tff(pred_def_28021,type,
    v51370: state_type > $o ).

tff(pred_def_28022,type,
    v51369: state_type > $o ).

tff(pred_def_28023,type,
    v51381: state_type > $o ).

tff(pred_def_28024,type,
    v51382: state_type > $o ).

tff(pred_def_28025,type,
    v51380: state_type > $o ).

tff(pred_def_28026,type,
    v51377: ( state_type * $int ) > $o ).

tff(pred_def_28027,type,
    v51379: ( state_type * $int ) > $o ).

tff(pred_def_28028,type,
    v51368: ( state_type * $int ) > $o ).

tff(pred_def_28029,type,
    v51250: state_type > $o ).

tff(pred_def_28030,type,
    v51248: state_type > $o ).

tff(pred_def_28031,type,
    v51394: state_type > $o ).

tff(pred_def_28032,type,
    v51392: state_type > $o ).

tff(pred_def_28033,type,
    v51391: state_type > $o ).

tff(pred_def_28034,type,
    v51390: ( state_type * $int ) > $o ).

tff(pred_def_28035,type,
    v51388: state_type > $o ).

tff(pred_def_28036,type,
    v51386: state_type > $o ).

tff(pred_def_28037,type,
    v51399: state_type > $o ).

tff(pred_def_28038,type,
    v51398: state_type > $o ).

tff(pred_def_28039,type,
    v51231: state_type > $o ).

tff(pred_def_28040,type,
    v51229: state_type > $o ).

tff(pred_def_28041,type,
    v51227: state_type > $o ).

tff(pred_def_28042,type,
    v51400: ( state_type * $int ) > $o ).

tff(pred_def_28043,type,
    v51401: state_type > $o ).

tff(pred_def_28044,type,
    v51225: ( state_type * $int ) > $o ).

tff(pred_def_28045,type,
    v51223: ( state_type * $int ) > $o ).

tff(pred_def_28046,type,
    v51402: ( state_type * $int ) > $o ).

tff(pred_def_28047,type,
    v51213: ( state_type * $int ) > $o ).

tff(pred_def_28048,type,
    v51211: ( state_type * $int ) > $o ).

tff(pred_def_28049,type,
    v51209: state_type > $o ).

tff(pred_def_28050,type,
    v51403: ( state_type * $int ) > $o ).

tff(pred_def_28051,type,
    v51404: state_type > $o ).

tff(pred_def_28052,type,
    v51207: ( state_type * $int ) > $o ).

tff(pred_def_28053,type,
    v51205: ( state_type * $int ) > $o ).

tff(pred_def_28054,type,
    v51405: ( state_type * $int ) > $o ).

tff(pred_def_28055,type,
    v51197: ( state_type * $int ) > $o ).

tff(pred_def_28056,type,
    v51195: ( state_type * $int ) > $o ).

tff(pred_def_28057,type,
    v51411: state_type > $o ).

tff(pred_def_28058,type,
    v51409: state_type > $o ).

tff(pred_def_28059,type,
    v51408: state_type > $o ).

tff(pred_def_28060,type,
    v51407: ( state_type * $int ) > $o ).

tff(pred_def_28061,type,
    v51152: state_type > $o ).

tff(pred_def_28062,type,
    v51150: state_type > $o ).

tff(pred_def_28063,type,
    v51417: state_type > $o ).

tff(pred_def_28064,type,
    v51415: state_type > $o ).

tff(pred_def_28065,type,
    v51421: state_type > $o ).

tff(pred_def_28066,type,
    v51419: state_type > $o ).

tff(pred_def_28067,type,
    v51424: state_type > $o ).

tff(pred_def_28068,type,
    v51423: state_type > $o ).

tff(pred_def_28069,type,
    v51148: state_type > $o ).

tff(pred_def_28070,type,
    v51146: state_type > $o ).

tff(pred_def_28071,type,
    v51144: state_type > $o ).

tff(pred_def_28072,type,
    v51142: state_type > $o ).

tff(pred_def_28073,type,
    v51140: state_type > $o ).

tff(pred_def_28074,type,
    v51138: state_type > $o ).

tff(pred_def_28075,type,
    v51136: state_type > $o ).

tff(pred_def_28076,type,
    v51134: state_type > $o ).

tff(pred_def_28077,type,
    v51444: state_type > $o ).

tff(pred_def_28078,type,
    v51442: state_type > $o ).

tff(pred_def_28079,type,
    v51440: state_type > $o ).

tff(pred_def_28080,type,
    v51438: state_type > $o ).

tff(pred_def_28081,type,
    v51436: state_type > $o ).

tff(pred_def_28082,type,
    v51454: state_type > $o ).

tff(pred_def_28083,type,
    v51452: state_type > $o ).

tff(pred_def_28084,type,
    v51450: state_type > $o ).

tff(pred_def_28085,type,
    v51448: state_type > $o ).

tff(pred_def_28086,type,
    v51446: state_type > $o ).

tff(pred_def_28087,type,
    v51458: ( state_type * $int ) > $o ).

tff(pred_def_28088,type,
    v51456: ( state_type * $int ) > $o ).

tff(pred_def_28089,type,
    v51468: state_type > $o ).

tff(pred_def_28090,type,
    v51466: state_type > $o ).

tff(pred_def_28091,type,
    v51474: state_type > $o ).

tff(pred_def_28092,type,
    v51472: state_type > $o ).

tff(pred_def_28093,type,
    v51498: ( state_type * $int ) > $o ).

tff(pred_def_28094,type,
    v51496: ( state_type * $int ) > $o ).

tff(pred_def_28095,type,
    v51499: ( state_type * $int ) > $o ).

tff(pred_def_28096,type,
    v51494: ( state_type * $int ) > $o ).

tff(pred_def_28097,type,
    v51492: ( state_type * $int ) > $o ).

tff(pred_def_28098,type,
    v51490: ( state_type * $int ) > $o ).

tff(pred_def_28099,type,
    v51488: state_type > $o ).

tff(pred_def_28100,type,
    v51486: state_type > $o ).

tff(pred_def_28101,type,
    v51503: state_type > $o ).

tff(pred_def_28102,type,
    v51501: state_type > $o ).

tff(pred_def_28103,type,
    v51507: state_type > $o ).

tff(pred_def_28104,type,
    v51505: state_type > $o ).

tff(pred_def_28105,type,
    v51510: state_type > $o ).

tff(pred_def_28106,type,
    v51509: state_type > $o ).

tff(pred_def_28107,type,
    v51484: state_type > $o ).

tff(pred_def_28108,type,
    v51482: state_type > $o ).

tff(pred_def_28109,type,
    v51480: state_type > $o ).

tff(pred_def_28110,type,
    v51478: state_type > $o ).

tff(pred_def_28111,type,
    v51476: state_type > $o ).

tff(pred_def_28112,type,
    v51514: state_type > $o ).

tff(pred_def_28113,type,
    v51512: state_type > $o ).

tff(pred_def_28114,type,
    v51470: state_type > $o ).

tff(pred_def_28115,type,
    v51520: state_type > $o ).

tff(pred_def_28116,type,
    v51522: state_type > $o ).

tff(pred_def_28117,type,
    v51518: state_type > $o ).

tff(pred_def_28118,type,
    v51517: state_type > $o ).

tff(pred_def_28119,type,
    v51528: state_type > $o ).

tff(pred_def_28120,type,
    v51529: state_type > $o ).

tff(pred_def_28121,type,
    v51525: state_type > $o ).

tff(pred_def_28122,type,
    v51527: state_type > $o ).

tff(pred_def_28123,type,
    v51535: state_type > $o ).

tff(pred_def_28124,type,
    v51533: state_type > $o ).

tff(pred_def_28125,type,
    v51537: state_type > $o ).

tff(pred_def_28126,type,
    v51464: state_type > $o ).

tff(pred_def_28127,type,
    v51462: state_type > $o ).

tff(pred_def_28128,type,
    v51460: state_type > $o ).

tff(pred_def_28129,type,
    v51544: state_type > $o ).

tff(pred_def_28130,type,
    v51542: state_type > $o ).

tff(pred_def_28131,type,
    v51541: state_type > $o ).

tff(pred_def_28132,type,
    v51540: state_type > $o ).

tff(pred_def_28133,type,
    v51552: state_type > $o ).

tff(pred_def_28134,type,
    v51553: state_type > $o ).

tff(pred_def_28135,type,
    v51551: state_type > $o ).

tff(pred_def_28136,type,
    v51548: ( state_type * $int ) > $o ).

tff(pred_def_28137,type,
    v51550: ( state_type * $int ) > $o ).

tff(pred_def_28138,type,
    v51434: ( state_type * $int ) > $o ).

tff(pred_def_28139,type,
    v51432: ( state_type * $int ) > $o ).

tff(pred_def_28140,type,
    v51430: ( state_type * $int ) > $o ).

tff(pred_def_28141,type,
    v51428: ( state_type * $int ) > $o ).

tff(pred_def_28142,type,
    v51426: ( state_type * $int ) > $o ).

tff(pred_def_28143,type,
    v51575: state_type > $o ).

tff(pred_def_28144,type,
    v51573: state_type > $o ).

tff(pred_def_28145,type,
    v51579: state_type > $o ).

tff(pred_def_28146,type,
    v51577: state_type > $o ).

tff(pred_def_28147,type,
    v51583: state_type > $o ).

tff(pred_def_28148,type,
    v51581: state_type > $o ).

tff(pred_def_28149,type,
    v51586: state_type > $o ).

tff(pred_def_28150,type,
    v51585: state_type > $o ).

tff(pred_def_28151,type,
    v51571: state_type > $o ).

tff(pred_def_28152,type,
    v51569: state_type > $o ).

tff(pred_def_28153,type,
    v51567: state_type > $o ).

tff(pred_def_28154,type,
    v51565: state_type > $o ).

tff(pred_def_28155,type,
    v51563: state_type > $o ).

tff(pred_def_28156,type,
    v51561: state_type > $o ).

tff(pred_def_28157,type,
    v51559: state_type > $o ).

tff(pred_def_28158,type,
    v51557: state_type > $o ).

tff(pred_def_28159,type,
    v51606: state_type > $o ).

tff(pred_def_28160,type,
    v51604: state_type > $o ).

tff(pred_def_28161,type,
    v51602: state_type > $o ).

tff(pred_def_28162,type,
    v51600: state_type > $o ).

tff(pred_def_28163,type,
    v51598: state_type > $o ).

tff(pred_def_28164,type,
    v51616: state_type > $o ).

tff(pred_def_28165,type,
    v51614: state_type > $o ).

tff(pred_def_28166,type,
    v51612: state_type > $o ).

tff(pred_def_28167,type,
    v51610: state_type > $o ).

tff(pred_def_28168,type,
    v51608: state_type > $o ).

tff(pred_def_28169,type,
    v51620: ( state_type * $int ) > $o ).

tff(pred_def_28170,type,
    v51618: ( state_type * $int ) > $o ).

tff(pred_def_28171,type,
    v51630: state_type > $o ).

tff(pred_def_28172,type,
    v51628: state_type > $o ).

tff(pred_def_28173,type,
    v51636: state_type > $o ).

tff(pred_def_28174,type,
    v51634: state_type > $o ).

tff(pred_def_28175,type,
    v51650: state_type > $o ).

tff(pred_def_28176,type,
    v51648: state_type > $o ).

tff(pred_def_28177,type,
    v51654: state_type > $o ).

tff(pred_def_28178,type,
    v51652: state_type > $o ).

tff(pred_def_28179,type,
    v51658: state_type > $o ).

tff(pred_def_28180,type,
    v51656: state_type > $o ).

tff(pred_def_28181,type,
    v51661: state_type > $o ).

tff(pred_def_28182,type,
    v51660: state_type > $o ).

tff(pred_def_28183,type,
    v51646: state_type > $o ).

tff(pred_def_28184,type,
    v51644: state_type > $o ).

tff(pred_def_28185,type,
    v51642: state_type > $o ).

tff(pred_def_28186,type,
    v51640: state_type > $o ).

tff(pred_def_28187,type,
    v51638: state_type > $o ).

tff(pred_def_28188,type,
    v51665: state_type > $o ).

tff(pred_def_28189,type,
    v51663: state_type > $o ).

tff(pred_def_28190,type,
    v51632: state_type > $o ).

tff(pred_def_28191,type,
    v51671: state_type > $o ).

tff(pred_def_28192,type,
    v51673: state_type > $o ).

tff(pred_def_28193,type,
    v51669: state_type > $o ).

tff(pred_def_28194,type,
    v51668: state_type > $o ).

tff(pred_def_28195,type,
    v51679: state_type > $o ).

tff(pred_def_28196,type,
    v51680: state_type > $o ).

tff(pred_def_28197,type,
    v51676: state_type > $o ).

tff(pred_def_28198,type,
    v51678: state_type > $o ).

tff(pred_def_28199,type,
    v51686: state_type > $o ).

tff(pred_def_28200,type,
    v51684: state_type > $o ).

tff(pred_def_28201,type,
    v51688: state_type > $o ).

tff(pred_def_28202,type,
    v51626: state_type > $o ).

tff(pred_def_28203,type,
    v51624: state_type > $o ).

tff(pred_def_28204,type,
    v51622: state_type > $o ).

tff(pred_def_28205,type,
    v51695: state_type > $o ).

tff(pred_def_28206,type,
    v51693: state_type > $o ).

tff(pred_def_28207,type,
    v51692: state_type > $o ).

tff(pred_def_28208,type,
    v51691: state_type > $o ).

tff(pred_def_28209,type,
    v51703: state_type > $o ).

tff(pred_def_28210,type,
    v51704: state_type > $o ).

tff(pred_def_28211,type,
    v51702: state_type > $o ).

tff(pred_def_28212,type,
    v51699: ( state_type * $int ) > $o ).

tff(pred_def_28213,type,
    v51701: ( state_type * $int ) > $o ).

tff(pred_def_28214,type,
    v51596: ( state_type * $int ) > $o ).

tff(pred_def_28215,type,
    v51594: ( state_type * $int ) > $o ).

tff(pred_def_28216,type,
    v51592: ( state_type * $int ) > $o ).

tff(pred_def_28217,type,
    v51590: ( state_type * $int ) > $o ).

tff(pred_def_28218,type,
    v51588: ( state_type * $int ) > $o ).

tff(pred_def_28219,type,
    v51726: state_type > $o ).

tff(pred_def_28220,type,
    v51724: state_type > $o ).

tff(pred_def_28221,type,
    v51730: state_type > $o ).

tff(pred_def_28222,type,
    v51728: state_type > $o ).

tff(pred_def_28223,type,
    v51734: state_type > $o ).

tff(pred_def_28224,type,
    v51732: state_type > $o ).

tff(pred_def_28225,type,
    v51737: state_type > $o ).

tff(pred_def_28226,type,
    v51736: state_type > $o ).

tff(pred_def_28227,type,
    v51722: state_type > $o ).

tff(pred_def_28228,type,
    v51720: state_type > $o ).

tff(pred_def_28229,type,
    v51718: state_type > $o ).

tff(pred_def_28230,type,
    v51716: state_type > $o ).

tff(pred_def_28231,type,
    v51714: state_type > $o ).

tff(pred_def_28232,type,
    v51712: state_type > $o ).

tff(pred_def_28233,type,
    v51710: state_type > $o ).

tff(pred_def_28234,type,
    v51708: state_type > $o ).

tff(pred_def_28235,type,
    v51757: state_type > $o ).

tff(pred_def_28236,type,
    v51755: state_type > $o ).

tff(pred_def_28237,type,
    v51753: state_type > $o ).

tff(pred_def_28238,type,
    v51751: state_type > $o ).

tff(pred_def_28239,type,
    v51749: state_type > $o ).

tff(pred_def_28240,type,
    v51767: state_type > $o ).

tff(pred_def_28241,type,
    v51765: state_type > $o ).

tff(pred_def_28242,type,
    v51763: state_type > $o ).

tff(pred_def_28243,type,
    v51761: state_type > $o ).

tff(pred_def_28244,type,
    v51759: state_type > $o ).

tff(pred_def_28245,type,
    v51771: ( state_type * $int ) > $o ).

tff(pred_def_28246,type,
    v51769: ( state_type * $int ) > $o ).

tff(pred_def_28247,type,
    v51781: state_type > $o ).

tff(pred_def_28248,type,
    v51779: state_type > $o ).

tff(pred_def_28249,type,
    v51787: state_type > $o ).

tff(pred_def_28250,type,
    v51785: state_type > $o ).

tff(pred_def_28251,type,
    v51801: state_type > $o ).

tff(pred_def_28252,type,
    v51799: state_type > $o ).

tff(pred_def_28253,type,
    v51805: state_type > $o ).

tff(pred_def_28254,type,
    v51803: state_type > $o ).

tff(pred_def_28255,type,
    v51809: state_type > $o ).

tff(pred_def_28256,type,
    v51807: state_type > $o ).

tff(pred_def_28257,type,
    v51812: state_type > $o ).

tff(pred_def_28258,type,
    v51811: state_type > $o ).

tff(pred_def_28259,type,
    v51797: state_type > $o ).

tff(pred_def_28260,type,
    v51795: state_type > $o ).

tff(pred_def_28261,type,
    v51793: state_type > $o ).

tff(pred_def_28262,type,
    v51791: state_type > $o ).

tff(pred_def_28263,type,
    v51789: state_type > $o ).

tff(pred_def_28264,type,
    v51816: state_type > $o ).

tff(pred_def_28265,type,
    v51814: state_type > $o ).

tff(pred_def_28266,type,
    v51783: state_type > $o ).

tff(pred_def_28267,type,
    v51822: state_type > $o ).

tff(pred_def_28268,type,
    v51824: state_type > $o ).

tff(pred_def_28269,type,
    v51820: state_type > $o ).

tff(pred_def_28270,type,
    v51819: state_type > $o ).

tff(pred_def_28271,type,
    v51830: state_type > $o ).

tff(pred_def_28272,type,
    v51831: state_type > $o ).

tff(pred_def_28273,type,
    v51827: state_type > $o ).

tff(pred_def_28274,type,
    v51829: state_type > $o ).

tff(pred_def_28275,type,
    v51837: state_type > $o ).

tff(pred_def_28276,type,
    v51835: state_type > $o ).

tff(pred_def_28277,type,
    v51839: state_type > $o ).

tff(pred_def_28278,type,
    v51777: state_type > $o ).

tff(pred_def_28279,type,
    v51775: state_type > $o ).

tff(pred_def_28280,type,
    v51773: state_type > $o ).

tff(pred_def_28281,type,
    v51846: state_type > $o ).

tff(pred_def_28282,type,
    v51844: state_type > $o ).

tff(pred_def_28283,type,
    v51843: state_type > $o ).

tff(pred_def_28284,type,
    v51842: state_type > $o ).

tff(pred_def_28285,type,
    v51854: state_type > $o ).

tff(pred_def_28286,type,
    v51855: state_type > $o ).

tff(pred_def_28287,type,
    v51853: state_type > $o ).

tff(pred_def_28288,type,
    v51850: ( state_type * $int ) > $o ).

tff(pred_def_28289,type,
    v51852: ( state_type * $int ) > $o ).

tff(pred_def_28290,type,
    v51747: ( state_type * $int ) > $o ).

tff(pred_def_28291,type,
    v51745: ( state_type * $int ) > $o ).

tff(pred_def_28292,type,
    v51743: ( state_type * $int ) > $o ).

tff(pred_def_28293,type,
    v51741: ( state_type * $int ) > $o ).

tff(pred_def_28294,type,
    v51739: ( state_type * $int ) > $o ).

tff(pred_def_28295,type,
    v51877: state_type > $o ).

tff(pred_def_28296,type,
    v51875: state_type > $o ).

tff(pred_def_28297,type,
    v51881: state_type > $o ).

tff(pred_def_28298,type,
    v51879: state_type > $o ).

tff(pred_def_28299,type,
    v51885: state_type > $o ).

tff(pred_def_28300,type,
    v51883: state_type > $o ).

tff(pred_def_28301,type,
    v51888: state_type > $o ).

tff(pred_def_28302,type,
    v51887: state_type > $o ).

tff(pred_def_28303,type,
    v51873: state_type > $o ).

tff(pred_def_28304,type,
    v51871: state_type > $o ).

tff(pred_def_28305,type,
    v51869: state_type > $o ).

tff(pred_def_28306,type,
    v51867: state_type > $o ).

tff(pred_def_28307,type,
    v51865: state_type > $o ).

tff(pred_def_28308,type,
    v51863: state_type > $o ).

tff(pred_def_28309,type,
    v51861: state_type > $o ).

tff(pred_def_28310,type,
    v51859: state_type > $o ).

tff(pred_def_28311,type,
    v51908: state_type > $o ).

tff(pred_def_28312,type,
    v51906: state_type > $o ).

tff(pred_def_28313,type,
    v51904: state_type > $o ).

tff(pred_def_28314,type,
    v51902: state_type > $o ).

tff(pred_def_28315,type,
    v51900: state_type > $o ).

tff(pred_def_28316,type,
    v51918: state_type > $o ).

tff(pred_def_28317,type,
    v51916: state_type > $o ).

tff(pred_def_28318,type,
    v51914: state_type > $o ).

tff(pred_def_28319,type,
    v51912: state_type > $o ).

tff(pred_def_28320,type,
    v51910: state_type > $o ).

tff(pred_def_28321,type,
    v51922: ( state_type * $int ) > $o ).

tff(pred_def_28322,type,
    v51920: ( state_type * $int ) > $o ).

tff(pred_def_28323,type,
    v51932: state_type > $o ).

tff(pred_def_28324,type,
    v51930: state_type > $o ).

tff(pred_def_28325,type,
    v51938: state_type > $o ).

tff(pred_def_28326,type,
    v51936: state_type > $o ).

tff(pred_def_28327,type,
    v51952: state_type > $o ).

tff(pred_def_28328,type,
    v51950: state_type > $o ).

tff(pred_def_28329,type,
    v51956: state_type > $o ).

tff(pred_def_28330,type,
    v51954: state_type > $o ).

tff(pred_def_28331,type,
    v51960: state_type > $o ).

tff(pred_def_28332,type,
    v51958: state_type > $o ).

tff(pred_def_28333,type,
    v51963: state_type > $o ).

tff(pred_def_28334,type,
    v51962: state_type > $o ).

tff(pred_def_28335,type,
    v51948: state_type > $o ).

tff(pred_def_28336,type,
    v51946: state_type > $o ).

tff(pred_def_28337,type,
    v51944: state_type > $o ).

tff(pred_def_28338,type,
    v51942: state_type > $o ).

tff(pred_def_28339,type,
    v51940: state_type > $o ).

tff(pred_def_28340,type,
    v51967: state_type > $o ).

tff(pred_def_28341,type,
    v51965: state_type > $o ).

tff(pred_def_28342,type,
    v51934: state_type > $o ).

tff(pred_def_28343,type,
    v51973: state_type > $o ).

tff(pred_def_28344,type,
    v51975: state_type > $o ).

tff(pred_def_28345,type,
    v51971: state_type > $o ).

tff(pred_def_28346,type,
    v51970: state_type > $o ).

tff(pred_def_28347,type,
    v51981: state_type > $o ).

tff(pred_def_28348,type,
    v51982: state_type > $o ).

tff(pred_def_28349,type,
    v51978: state_type > $o ).

tff(pred_def_28350,type,
    v51980: state_type > $o ).

tff(pred_def_28351,type,
    v51988: state_type > $o ).

tff(pred_def_28352,type,
    v51986: state_type > $o ).

tff(pred_def_28353,type,
    v51990: state_type > $o ).

tff(pred_def_28354,type,
    v51928: state_type > $o ).

tff(pred_def_28355,type,
    v51926: state_type > $o ).

tff(pred_def_28356,type,
    v51924: state_type > $o ).

tff(pred_def_28357,type,
    v51997: state_type > $o ).

tff(pred_def_28358,type,
    v51995: state_type > $o ).

tff(pred_def_28359,type,
    v51994: state_type > $o ).

tff(pred_def_28360,type,
    v51993: state_type > $o ).

tff(pred_def_28361,type,
    v52005: state_type > $o ).

tff(pred_def_28362,type,
    v52006: state_type > $o ).

tff(pred_def_28363,type,
    v52004: state_type > $o ).

tff(pred_def_28364,type,
    v52001: ( state_type * $int ) > $o ).

tff(pred_def_28365,type,
    v52003: ( state_type * $int ) > $o ).

tff(pred_def_28366,type,
    v51898: ( state_type * $int ) > $o ).

tff(pred_def_28367,type,
    v51896: ( state_type * $int ) > $o ).

tff(pred_def_28368,type,
    v51894: ( state_type * $int ) > $o ).

tff(pred_def_28369,type,
    v51892: ( state_type * $int ) > $o ).

tff(pred_def_28370,type,
    v51890: ( state_type * $int ) > $o ).

tff(pred_def_28371,type,
    v52028: state_type > $o ).

tff(pred_def_28372,type,
    v52026: state_type > $o ).

tff(pred_def_28373,type,
    v52032: state_type > $o ).

tff(pred_def_28374,type,
    v52030: state_type > $o ).

tff(pred_def_28375,type,
    v52036: state_type > $o ).

tff(pred_def_28376,type,
    v52034: state_type > $o ).

tff(pred_def_28377,type,
    v52039: state_type > $o ).

tff(pred_def_28378,type,
    v52038: state_type > $o ).

tff(pred_def_28379,type,
    v52024: state_type > $o ).

tff(pred_def_28380,type,
    v52022: state_type > $o ).

tff(pred_def_28381,type,
    v52020: state_type > $o ).

tff(pred_def_28382,type,
    v52018: state_type > $o ).

tff(pred_def_28383,type,
    v52016: state_type > $o ).

tff(pred_def_28384,type,
    v52014: state_type > $o ).

tff(pred_def_28385,type,
    v52012: state_type > $o ).

tff(pred_def_28386,type,
    v52010: state_type > $o ).

tff(pred_def_28387,type,
    v52059: state_type > $o ).

tff(pred_def_28388,type,
    v52057: state_type > $o ).

tff(pred_def_28389,type,
    v52055: state_type > $o ).

tff(pred_def_28390,type,
    v52053: state_type > $o ).

tff(pred_def_28391,type,
    v52051: state_type > $o ).

tff(pred_def_28392,type,
    v52069: state_type > $o ).

tff(pred_def_28393,type,
    v52067: state_type > $o ).

tff(pred_def_28394,type,
    v52065: state_type > $o ).

tff(pred_def_28395,type,
    v52063: state_type > $o ).

tff(pred_def_28396,type,
    v52061: state_type > $o ).

tff(pred_def_28397,type,
    v52073: ( state_type * $int ) > $o ).

tff(pred_def_28398,type,
    v52071: ( state_type * $int ) > $o ).

tff(pred_def_28399,type,
    v52083: state_type > $o ).

tff(pred_def_28400,type,
    v52081: state_type > $o ).

tff(pred_def_28401,type,
    v52089: state_type > $o ).

tff(pred_def_28402,type,
    v52087: state_type > $o ).

tff(pred_def_28403,type,
    v52102: state_type > $o ).

tff(pred_def_28404,type,
    v52100: state_type > $o ).

tff(pred_def_28405,type,
    v52106: state_type > $o ).

tff(pred_def_28406,type,
    v52104: state_type > $o ).

tff(pred_def_28407,type,
    v52110: state_type > $o ).

tff(pred_def_28408,type,
    v52108: state_type > $o ).

tff(pred_def_28409,type,
    v52113: state_type > $o ).

tff(pred_def_28410,type,
    v52112: state_type > $o ).

tff(pred_def_28411,type,
    v52098: state_type > $o ).

tff(pred_def_28412,type,
    v52096: state_type > $o ).

tff(pred_def_28413,type,
    v52093: state_type > $o ).

tff(pred_def_28414,type,
    v52091: state_type > $o ).

tff(pred_def_28415,type,
    v52117: state_type > $o ).

tff(pred_def_28416,type,
    v52115: state_type > $o ).

tff(pred_def_28417,type,
    v52085: state_type > $o ).

tff(pred_def_28418,type,
    v52123: state_type > $o ).

tff(pred_def_28419,type,
    v52125: state_type > $o ).

tff(pred_def_28420,type,
    v52121: state_type > $o ).

tff(pred_def_28421,type,
    v52120: state_type > $o ).

tff(pred_def_28422,type,
    v52131: state_type > $o ).

tff(pred_def_28423,type,
    v52132: state_type > $o ).

tff(pred_def_28424,type,
    v52128: state_type > $o ).

tff(pred_def_28425,type,
    v52130: state_type > $o ).

tff(pred_def_28426,type,
    v52138: state_type > $o ).

tff(pred_def_28427,type,
    v52136: state_type > $o ).

tff(pred_def_28428,type,
    v52140: state_type > $o ).

tff(pred_def_28429,type,
    v52079: state_type > $o ).

tff(pred_def_28430,type,
    v52077: state_type > $o ).

tff(pred_def_28431,type,
    v52075: state_type > $o ).

tff(pred_def_28432,type,
    v52147: state_type > $o ).

tff(pred_def_28433,type,
    v52145: state_type > $o ).

tff(pred_def_28434,type,
    v52144: state_type > $o ).

tff(pred_def_28435,type,
    v52143: state_type > $o ).

tff(pred_def_28436,type,
    v52155: state_type > $o ).

tff(pred_def_28437,type,
    v52156: state_type > $o ).

tff(pred_def_28438,type,
    v52154: state_type > $o ).

tff(pred_def_28439,type,
    v52151: ( state_type * $int ) > $o ).

tff(pred_def_28440,type,
    v52153: ( state_type * $int ) > $o ).

tff(pred_def_28441,type,
    v52049: ( state_type * $int ) > $o ).

tff(pred_def_28442,type,
    v52047: ( state_type * $int ) > $o ).

tff(pred_def_28443,type,
    v52045: ( state_type * $int ) > $o ).

tff(pred_def_28444,type,
    v52043: ( state_type * $int ) > $o ).

tff(pred_def_28445,type,
    v52041: ( state_type * $int ) > $o ).

tff(pred_def_28446,type,
    v52168: state_type > $o ).

tff(pred_def_28447,type,
    v52166: state_type > $o ).

tff(pred_def_28448,type,
    v52164: state_type > $o ).

tff(pred_def_28449,type,
    v52162: state_type > $o ).

tff(pred_def_28450,type,
    v52160: state_type > $o ).

tff(pred_def_28451,type,
    v52176: state_type > $o ).

tff(pred_def_28452,type,
    v52175: ( state_type * $int ) > $o ).

tff(pred_def_28453,type,
    v52174: ( state_type * $int ) > $o ).

tff(pred_def_28454,type,
    v52179: state_type > $o ).

tff(pred_def_28455,type,
    v52178: ( state_type * $int ) > $o ).

tff(pred_def_28456,type,
    v52177: ( state_type * $int ) > $o ).

tff(pred_def_28457,type,
    v52173: ( state_type * $int ) > $o ).

tff(pred_def_28458,type,
    v52182: state_type > $o ).

tff(pred_def_28459,type,
    v52181: ( state_type * $int ) > $o ).

tff(pred_def_28460,type,
    v52180: ( state_type * $int ) > $o ).

tff(pred_def_28461,type,
    v52172: ( state_type * $int ) > $o ).

tff(pred_def_28462,type,
    v52185: state_type > $o ).

tff(pred_def_28463,type,
    v52184: ( state_type * $int ) > $o ).

tff(pred_def_28464,type,
    v52183: ( state_type * $int ) > $o ).

tff(pred_def_28465,type,
    v52171: ( state_type * $int ) > $o ).

tff(pred_def_28466,type,
    v52188: state_type > $o ).

tff(pred_def_28467,type,
    v52187: ( state_type * $int ) > $o ).

tff(pred_def_28468,type,
    v52186: ( state_type * $int ) > $o ).

tff(pred_def_28469,type,
    v52170: ( state_type * $int ) > $o ).

tff(pred_def_28470,type,
    v52191: state_type > $o ).

tff(pred_def_28471,type,
    v52190: ( state_type * $int ) > $o ).

tff(pred_def_28472,type,
    v52189: ( state_type * $int ) > $o ).

tff(pred_def_28473,type,
    v50953: ( state_type * $int ) > $o ).

tff(pred_def_28474,type,
    v50951: ( state_type * $int ) > $o ).

tff(pred_def_28475,type,
    v50949: ( state_type * $int ) > $o ).

tff(pred_def_28476,type,
    v50947: ( state_type * $int ) > $o ).

tff(pred_def_28477,type,
    v50945: ( state_type * $int ) > $o ).

tff(pred_def_28478,type,
    v50939: state_type > $o ).

tff(pred_def_28479,type,
    v50937: state_type > $o ).

tff(pred_def_28480,type,
    v50935: state_type > $o ).

tff(pred_def_28481,type,
    v52208: state_type > $o ).

tff(pred_def_28482,type,
    v52209: state_type > $o ).

tff(pred_def_28483,type,
    v52207: state_type > $o ).

tff(pred_def_28484,type,
    v52210: state_type > $o ).

tff(pred_def_28485,type,
    v52206: state_type > $o ).

tff(pred_def_28486,type,
    v52211: state_type > $o ).

tff(pred_def_28487,type,
    v52205: state_type > $o ).

tff(pred_def_28488,type,
    v52212: state_type > $o ).

tff(pred_def_28489,type,
    v52204: state_type > $o ).

tff(pred_def_28490,type,
    v52213: state_type > $o ).

tff(pred_def_28491,type,
    v52203: state_type > $o ).

tff(pred_def_28492,type,
    v52214: state_type > $o ).

tff(pred_def_28493,type,
    v52202: state_type > $o ).

tff(pred_def_28494,type,
    v52215: state_type > $o ).

tff(pred_def_28495,type,
    v52201: state_type > $o ).

tff(pred_def_28496,type,
    v52216: state_type > $o ).

tff(pred_def_28497,type,
    v52200: state_type > $o ).

tff(pred_def_28498,type,
    v52217: state_type > $o ).

tff(pred_def_28499,type,
    v52199: state_type > $o ).

tff(pred_def_28500,type,
    v52218: state_type > $o ).

tff(pred_def_28501,type,
    v52198: state_type > $o ).

tff(pred_def_28502,type,
    v52219: state_type > $o ).

tff(pred_def_28503,type,
    v52197: state_type > $o ).

tff(pred_def_28504,type,
    v52220: state_type > $o ).

tff(pred_def_28505,type,
    v52196: state_type > $o ).

tff(pred_def_28506,type,
    v52221: state_type > $o ).

tff(pred_def_28507,type,
    v52194: state_type > $o ).

tff(pred_def_28508,type,
    v52226: state_type > $o ).

tff(pred_def_28509,type,
    v52225: state_type > $o ).

tff(pred_def_28510,type,
    v52224: state_type > $o ).

tff(pred_def_28511,type,
    v52223: state_type > $o ).

tff(pred_def_28512,type,
    v52242: state_type > $o ).

tff(pred_def_28513,type,
    v52241: state_type > $o ).

tff(pred_def_28514,type,
    v52240: state_type > $o ).

tff(pred_def_28515,type,
    v52239: state_type > $o ).

tff(pred_def_28516,type,
    v52238: state_type > $o ).

tff(pred_def_28517,type,
    v52237: state_type > $o ).

tff(pred_def_28518,type,
    v52236: state_type > $o ).

tff(pred_def_28519,type,
    v52235: state_type > $o ).

tff(pred_def_28520,type,
    v52234: state_type > $o ).

tff(pred_def_28521,type,
    v52233: state_type > $o ).

tff(pred_def_28522,type,
    v52232: state_type > $o ).

tff(pred_def_28523,type,
    v52231: state_type > $o ).

tff(pred_def_28524,type,
    v52229: state_type > $o ).

tff(pred_def_28525,type,
    v52245: state_type > $o ).

tff(pred_def_28526,type,
    v52244: state_type > $o ).

tff(pred_def_28527,type,
    v52243: state_type > $o ).

tff(pred_def_28528,type,
    v52228: state_type > $o ).

tff(pred_def_28529,type,
    v8290: state_type > $o ).

tff(pred_def_28530,type,
    v52227: state_type > $o ).

tff(pred_def_28531,type,
    v52251: state_type > $o ).

tff(pred_def_28532,type,
    v52249: state_type > $o ).

tff(pred_def_28533,type,
    v52248: state_type > $o ).

tff(pred_def_28534,type,
    v52247: ( state_type * $int ) > $o ).

tff(pred_def_28535,type,
    v52255: ( state_type * $int ) > $o ).

tff(pred_def_28536,type,
    v52256: state_type > $o ).

tff(pred_def_28537,type,
    v7226: ( state_type * $int ) > $o ).

tff(pred_def_28538,type,
    v7224: ( state_type * $int ) > $o ).

tff(pred_def_28539,type,
    v52261: ( state_type * $int ) > $o ).

tff(pred_def_28540,type,
    v52260: ( state_type * $int ) > $o ).

tff(pred_def_28541,type,
    v52258: ( state_type * $int ) > $o ).

tff(pred_def_28542,type,
    v52262: ( state_type * $int ) > $o ).

tff(pred_def_28543,type,
    v7222: ( state_type * $int ) > $o ).

tff(pred_def_28544,type,
    v7220: ( state_type * $int ) > $o ).

tff(pred_def_28545,type,
    v7218: state_type > $o ).

tff(pred_def_28546,type,
    v52263: ( state_type * $int ) > $o ).

tff(pred_def_28547,type,
    v52264: state_type > $o ).

tff(pred_def_28548,type,
    v7216: ( state_type * $int ) > $o ).

tff(pred_def_28549,type,
    v7214: ( state_type * $int ) > $o ).

tff(pred_def_28550,type,
    v52265: ( state_type * $int ) > $o ).

tff(pred_def_28551,type,
    v7206: ( state_type * $int ) > $o ).

tff(pred_def_28552,type,
    v7204: ( state_type * $int ) > $o ).

tff(pred_def_28553,type,
    v52271: state_type > $o ).

tff(pred_def_28554,type,
    v52269: state_type > $o ).

tff(pred_def_28555,type,
    v52268: state_type > $o ).

tff(pred_def_28556,type,
    v52267: ( state_type * $int ) > $o ).

tff(pred_def_28557,type,
    v7159: state_type > $o ).

tff(pred_def_28558,type,
    v7157: state_type > $o ).

tff(pred_def_28559,type,
    v52277: state_type > $o ).

tff(pred_def_28560,type,
    v52275: state_type > $o ).

tff(pred_def_28561,type,
    v52281: state_type > $o ).

tff(pred_def_28562,type,
    v52279: state_type > $o ).

tff(pred_def_28563,type,
    v52284: state_type > $o ).

tff(pred_def_28564,type,
    v52283: state_type > $o ).

tff(pred_def_28565,type,
    v7155: state_type > $o ).

tff(pred_def_28566,type,
    v7153: state_type > $o ).

tff(pred_def_28567,type,
    v7151: state_type > $o ).

tff(pred_def_28568,type,
    v7149: state_type > $o ).

tff(pred_def_28569,type,
    v7147: state_type > $o ).

tff(pred_def_28570,type,
    v7145: state_type > $o ).

tff(pred_def_28571,type,
    v7143: state_type > $o ).

tff(pred_def_28572,type,
    v52290: state_type > $o ).

tff(pred_def_28573,type,
    v52288: state_type > $o ).

tff(pred_def_28574,type,
    v52287: state_type > $o ).

tff(pred_def_28575,type,
    v52286: ( state_type * $int ) > $o ).

tff(pred_def_28576,type,
    v52298: state_type > $o ).

tff(pred_def_28577,type,
    v52296: state_type > $o ).

tff(pred_def_28578,type,
    v52295: state_type > $o ).

tff(pred_def_28579,type,
    v52294: ( state_type * $int ) > $o ).

tff(pred_def_28580,type,
    v52306: state_type > $o ).

tff(pred_def_28581,type,
    v52304: state_type > $o ).

tff(pred_def_28582,type,
    v52303: state_type > $o ).

tff(pred_def_28583,type,
    v52302: ( state_type * $int ) > $o ).

tff(pred_def_28584,type,
    v52314: state_type > $o ).

tff(pred_def_28585,type,
    v52312: state_type > $o ).

tff(pred_def_28586,type,
    v52311: state_type > $o ).

tff(pred_def_28587,type,
    v52310: ( state_type * $int ) > $o ).

tff(pred_def_28588,type,
    v52322: state_type > $o ).

tff(pred_def_28589,type,
    v52320: state_type > $o ).

tff(pred_def_28590,type,
    v52319: state_type > $o ).

tff(pred_def_28591,type,
    v52318: ( state_type * $int ) > $o ).

tff(pred_def_28592,type,
    v6236: ( state_type * $int ) > $o ).

tff(pred_def_28593,type,
    v52325: ( state_type * $int ) > $o ).

tff(pred_def_28594,type,
    v6234: ( state_type * $int ) > $o ).

tff(pred_def_28595,type,
    v6232: ( state_type * $int ) > $o ).

tff(pred_def_28596,type,
    v6230: ( state_type * $int ) > $o ).

tff(pred_def_28597,type,
    v52334: ( state_type * $int ) > $o ).

tff(pred_def_28598,type,
    v52335: ( state_type * $int ) > $o ).

tff(pred_def_28599,type,
    v52332: ( state_type * $int ) > $o ).

tff(pred_def_28600,type,
    v52330: ( state_type * $int ) > $o ).

tff(pred_def_28601,type,
    v52328: ( state_type * $int ) > $o ).

tff(pred_def_28602,type,
    v52342: state_type > $o ).

tff(pred_def_28603,type,
    v52341: state_type > $o ).

tff(pred_def_28604,type,
    v52343: state_type > $o ).

tff(pred_def_28605,type,
    v52339: state_type > $o ).

tff(pred_def_28606,type,
    v52347: state_type > $o ).

tff(pred_def_28607,type,
    v52346: state_type > $o ).

tff(pred_def_28608,type,
    v52344: state_type > $o ).

tff(pred_def_28609,type,
    v52350: state_type > $o ).

tff(pred_def_28610,type,
    v52348: state_type > $o ).

tff(pred_def_28611,type,
    v52353: state_type > $o ).

tff(pred_def_28612,type,
    v52354: state_type > $o ).

tff(pred_def_28613,type,
    v52351: state_type > $o ).

tff(pred_def_28614,type,
    v52338: ( state_type * $int ) > $o ).

tff(pred_def_28615,type,
    b1111111111111111111111111111111111111111111111111111111111111111: $int > $o ).

tff(pred_def_28616,type,
    v6106: ( state_type * $int ) > $o ).

tff(pred_def_28617,type,
    v6104: ( state_type * $int ) > $o ).

tff(pred_def_28618,type,
    v6102: ( state_type * $int ) > $o ).

tff(pred_def_28619,type,
    v6100: ( state_type * $int ) > $o ).

tff(pred_def_28620,type,
    v6098: ( state_type * $int ) > $o ).

tff(pred_def_28621,type,
    v6096: ( state_type * $int ) > $o ).

tff(pred_def_28622,type,
    v6094: ( state_type * $int ) > $o ).

tff(pred_def_28623,type,
    v52355: ( state_type * $int ) > $o ).

tff(pred_def_28624,type,
    v6073: ( state_type * $int ) > $o ).

tff(pred_def_28625,type,
    v6071: ( state_type * $int ) > $o ).

tff(pred_def_28626,type,
    v6069: ( state_type * $int ) > $o ).

tff(pred_def_28627,type,
    v6067: ( state_type * $int ) > $o ).

tff(pred_def_28628,type,
    v6065: ( state_type * $int ) > $o ).

tff(pred_def_28629,type,
    v52367: ( state_type * $int ) > $o ).

tff(pred_def_28630,type,
    v52369: ( state_type * $int ) > $o ).

tff(pred_def_28631,type,
    v52365: ( state_type * $int ) > $o ).

tff(pred_def_28632,type,
    v52363: ( state_type * $int ) > $o ).

tff(pred_def_28633,type,
    v52361: ( state_type * $int ) > $o ).

tff(pred_def_28634,type,
    v52359: state_type > $o ).

tff(pred_def_28635,type,
    v52357: state_type > $o ).

tff(pred_def_28636,type,
    v52373: ( state_type * $int ) > $o ).

tff(pred_def_28637,type,
    v52371: ( state_type * $int ) > $o ).

tff(pred_def_28638,type,
    v52384: ( state_type * $int ) > $o ).

tff(pred_def_28639,type,
    v52383: ( state_type * $int ) > $o ).

tff(pred_def_28640,type,
    v52381: ( state_type * $int ) > $o ).

tff(pred_def_28641,type,
    v52379: ( state_type * $int ) > $o ).

tff(pred_def_28642,type,
    v52377: state_type > $o ).

tff(pred_def_28643,type,
    v52375: state_type > $o ).

tff(pred_def_28644,type,
    v52388: state_type > $o ).

tff(pred_def_28645,type,
    v52387: ( state_type * $int ) > $o ).

tff(pred_def_28646,type,
    v52386: ( state_type * $int ) > $o ).

tff(pred_def_28647,type,
    v52391: state_type > $o ).

tff(pred_def_28648,type,
    v52390: ( state_type * $int ) > $o ).

tff(pred_def_28649,type,
    v52389: ( state_type * $int ) > $o ).

tff(pred_def_28650,type,
    v52385: ( state_type * $int ) > $o ).

tff(pred_def_28651,type,
    v6063: ( state_type * $int ) > $o ).

tff(pred_def_28652,type,
    v6061: ( state_type * $int ) > $o ).

tff(pred_def_28653,type,
    v6059: ( state_type * $int ) > $o ).

tff(pred_def_28654,type,
    v6057: ( state_type * $int ) > $o ).

tff(pred_def_28655,type,
    v6055: ( state_type * $int ) > $o ).

tff(pred_def_28656,type,
    v52403: state_type > $o ).

tff(pred_def_28657,type,
    v52401: state_type > $o ).

tff(pred_def_28658,type,
    v52399: state_type > $o ).

tff(pred_def_28659,type,
    v52413: state_type > $o ).

tff(pred_def_28660,type,
    v52411: state_type > $o ).

tff(pred_def_28661,type,
    v52409: state_type > $o ).

tff(pred_def_28662,type,
    v52407: state_type > $o ).

tff(pred_def_28663,type,
    v52405: state_type > $o ).

tff(pred_def_28664,type,
    v52415: state_type > $o ).

tff(pred_def_28665,type,
    v52397: state_type > $o ).

tff(pred_def_28666,type,
    v52395: state_type > $o ).

tff(pred_def_28667,type,
    v52393: state_type > $o ).

tff(pred_def_28668,type,
    v52422: state_type > $o ).

tff(pred_def_28669,type,
    v52420: state_type > $o ).

tff(pred_def_28670,type,
    v52419: state_type > $o ).

tff(pred_def_28671,type,
    v52418: state_type > $o ).

tff(pred_def_28672,type,
    v52430: state_type > $o ).

tff(pred_def_28673,type,
    v52431: state_type > $o ).

tff(pred_def_28674,type,
    v52429: state_type > $o ).

tff(pred_def_28675,type,
    v52426: ( state_type * $int ) > $o ).

tff(pred_def_28676,type,
    v52428: ( state_type * $int ) > $o ).

tff(pred_def_28677,type,
    v52417: ( state_type * $int ) > $o ).

tff(pred_def_28678,type,
    v6033: ( state_type * $int ) > $o ).

tff(pred_def_28679,type,
    v6031: ( state_type * $int ) > $o ).

tff(pred_def_28680,type,
    v6029: ( state_type * $int ) > $o ).

tff(pred_def_28681,type,
    v52435: ( state_type * $int ) > $o ).

tff(pred_def_28682,type,
    v52434: ( state_type * $int ) > $o ).

tff(pred_def_28683,type,
    v52436: ( state_type * $int ) > $o ).

tff(pred_def_28684,type,
    v52437: ( state_type * $int ) > $o ).

tff(pred_def_28685,type,
    v52438: ( state_type * $int ) > $o ).

tff(pred_def_28686,type,
    v52439: ( state_type * $int ) > $o ).

tff(pred_def_28687,type,
    v52440: ( state_type * $int ) > $o ).

tff(pred_def_28688,type,
    v52441: ( state_type * $int ) > $o ).

tff(pred_def_28689,type,
    v52442: ( state_type * $int ) > $o ).

tff(pred_def_28690,type,
    v52443: ( state_type * $int ) > $o ).

tff(pred_def_28691,type,
    v52444: ( state_type * $int ) > $o ).

tff(pred_def_28692,type,
    v52445: ( state_type * $int ) > $o ).

tff(pred_def_28693,type,
    v52446: ( state_type * $int ) > $o ).

tff(pred_def_28694,type,
    v52447: ( state_type * $int ) > $o ).

tff(pred_def_28695,type,
    v52448: ( state_type * $int ) > $o ).

tff(pred_def_28696,type,
    v52449: ( state_type * $int ) > $o ).

tff(pred_def_28697,type,
    v52450: ( state_type * $int ) > $o ).

tff(pred_def_28698,type,
    v52451: ( state_type * $int ) > $o ).

tff(pred_def_28699,type,
    v52452: ( state_type * $int ) > $o ).

tff(pred_def_28700,type,
    v52453: ( state_type * $int ) > $o ).

tff(pred_def_28701,type,
    v52454: ( state_type * $int ) > $o ).

tff(pred_def_28702,type,
    v52455: ( state_type * $int ) > $o ).

tff(pred_def_28703,type,
    v52456: ( state_type * $int ) > $o ).

tff(pred_def_28704,type,
    v52457: ( state_type * $int ) > $o ).

tff(pred_def_28705,type,
    v52458: ( state_type * $int ) > $o ).

tff(pred_def_28706,type,
    v52459: ( state_type * $int ) > $o ).

tff(pred_def_28707,type,
    v52460: ( state_type * $int ) > $o ).

tff(pred_def_28708,type,
    v52461: ( state_type * $int ) > $o ).

tff(pred_def_28709,type,
    v52462: ( state_type * $int ) > $o ).

tff(pred_def_28710,type,
    v52463: ( state_type * $int ) > $o ).

tff(pred_def_28711,type,
    v52464: ( state_type * $int ) > $o ).

tff(pred_def_28712,type,
    v52465: ( state_type * $int ) > $o ).

tff(pred_def_28713,type,
    v6027: ( state_type * $int ) > $o ).

tff(pred_def_28714,type,
    v6025: ( state_type * $int ) > $o ).

tff(pred_def_28715,type,
    v6023: ( state_type * $int ) > $o ).

tff(pred_def_28716,type,
    v6021: ( state_type * $int ) > $o ).

tff(pred_def_28717,type,
    v6019: ( state_type * $int ) > $o ).

tff(pred_def_28718,type,
    v6017: ( state_type * $int ) > $o ).

tff(pred_def_28719,type,
    v6015: state_type > $o ).

tff(pred_def_28720,type,
    v6013: state_type > $o ).

tff(pred_def_28721,type,
    v52478: ( state_type * $int ) > $o ).

tff(pred_def_28722,type,
    v52476: ( state_type * $int ) > $o ).

tff(pred_def_28723,type,
    v52482: state_type > $o ).

tff(pred_def_28724,type,
    v52480: state_type > $o ).

tff(pred_def_28725,type,
    v52486: ( state_type * $int ) > $o ).

tff(pred_def_28726,type,
    v52484: ( state_type * $int ) > $o ).

tff(pred_def_28727,type,
    v52490: state_type > $o ).

tff(pred_def_28728,type,
    v52488: state_type > $o ).

tff(pred_def_28729,type,
    v52494: state_type > $o ).

tff(pred_def_28730,type,
    v52493: ( state_type * $int ) > $o ).

tff(pred_def_28731,type,
    v52492: ( state_type * $int ) > $o ).

tff(pred_def_28732,type,
    v52497: state_type > $o ).

tff(pred_def_28733,type,
    v52496: ( state_type * $int ) > $o ).

tff(pred_def_28734,type,
    v52495: ( state_type * $int ) > $o ).

tff(pred_def_28735,type,
    v52491: ( state_type * $int ) > $o ).

tff(pred_def_28736,type,
    v52474: ( state_type * $int ) > $o ).

tff(pred_def_28737,type,
    v52472: ( state_type * $int ) > $o ).

tff(pred_def_28738,type,
    v52503: state_type > $o ).

tff(pred_def_28739,type,
    v52501: state_type > $o ).

tff(pred_def_28740,type,
    v52500: state_type > $o ).

tff(pred_def_28741,type,
    v52499: ( state_type * $int ) > $o ).

tff(pred_def_28742,type,
    v52469: state_type > $o ).

tff(pred_def_28743,type,
    v52467: state_type > $o ).

tff(pred_def_28744,type,
    v52518: ( state_type * $int ) > $o ).

tff(pred_def_28745,type,
    v52516: ( state_type * $int ) > $o ).

tff(pred_def_28746,type,
    v52522: state_type > $o ).

tff(pred_def_28747,type,
    v52520: state_type > $o ).

tff(pred_def_28748,type,
    v52526: ( state_type * $int ) > $o ).

tff(pred_def_28749,type,
    v52524: ( state_type * $int ) > $o ).

tff(pred_def_28750,type,
    v52530: state_type > $o ).

tff(pred_def_28751,type,
    v52528: state_type > $o ).

tff(pred_def_28752,type,
    v52534: state_type > $o ).

tff(pred_def_28753,type,
    v52533: ( state_type * $int ) > $o ).

tff(pred_def_28754,type,
    v52532: ( state_type * $int ) > $o ).

tff(pred_def_28755,type,
    v52537: state_type > $o ).

tff(pred_def_28756,type,
    v52536: ( state_type * $int ) > $o ).

tff(pred_def_28757,type,
    v52535: ( state_type * $int ) > $o ).

tff(pred_def_28758,type,
    v52531: ( state_type * $int ) > $o ).

tff(pred_def_28759,type,
    v52514: ( state_type * $int ) > $o ).

tff(pred_def_28760,type,
    v52512: ( state_type * $int ) > $o ).

tff(pred_def_28761,type,
    v52543: state_type > $o ).

tff(pred_def_28762,type,
    v52541: state_type > $o ).

tff(pred_def_28763,type,
    v52540: state_type > $o ).

tff(pred_def_28764,type,
    v52539: ( state_type * $int ) > $o ).

tff(pred_def_28765,type,
    v52509: state_type > $o ).

tff(pred_def_28766,type,
    v52507: state_type > $o ).

tff(pred_def_28767,type,
    v52547: state_type > $o ).

tff(pred_def_28768,type,
    v6011: state_type > $o ).

tff(pred_def_28769,type,
    v6009: state_type > $o ).

tff(pred_def_28770,type,
    v6007: state_type > $o ).

tff(pred_def_28771,type,
    v6005: state_type > $o ).

tff(pred_def_28772,type,
    v6003: state_type > $o ).

tff(pred_def_28773,type,
    v52570: ( state_type * $int ) > $o ).

tff(pred_def_28774,type,
    v52568: ( state_type * $int ) > $o ).

tff(pred_def_28775,type,
    v52574: state_type > $o ).

tff(pred_def_28776,type,
    v52572: state_type > $o ).

tff(pred_def_28777,type,
    v52578: ( state_type * $int ) > $o ).

tff(pred_def_28778,type,
    v52576: ( state_type * $int ) > $o ).

tff(pred_def_28779,type,
    v52582: state_type > $o ).

tff(pred_def_28780,type,
    v52580: state_type > $o ).

tff(pred_def_28781,type,
    v52586: state_type > $o ).

tff(pred_def_28782,type,
    v52585: ( state_type * $int ) > $o ).

tff(pred_def_28783,type,
    v52584: ( state_type * $int ) > $o ).

tff(pred_def_28784,type,
    v52589: state_type > $o ).

tff(pred_def_28785,type,
    v52588: ( state_type * $int ) > $o ).

tff(pred_def_28786,type,
    v52587: ( state_type * $int ) > $o ).

tff(pred_def_28787,type,
    v52583: ( state_type * $int ) > $o ).

tff(pred_def_28788,type,
    v52566: ( state_type * $int ) > $o ).

tff(pred_def_28789,type,
    v52564: ( state_type * $int ) > $o ).

tff(pred_def_28790,type,
    v52595: state_type > $o ).

tff(pred_def_28791,type,
    v52593: state_type > $o ).

tff(pred_def_28792,type,
    v52592: state_type > $o ).

tff(pred_def_28793,type,
    v52591: ( state_type * $int ) > $o ).

tff(pred_def_28794,type,
    v52561: state_type > $o ).

tff(pred_def_28795,type,
    v52559: state_type > $o ).

tff(pred_def_28796,type,
    v52610: ( state_type * $int ) > $o ).

tff(pred_def_28797,type,
    v52608: ( state_type * $int ) > $o ).

tff(pred_def_28798,type,
    v52614: state_type > $o ).

tff(pred_def_28799,type,
    v52612: state_type > $o ).

tff(pred_def_28800,type,
    v52618: ( state_type * $int ) > $o ).

tff(pred_def_28801,type,
    v52616: ( state_type * $int ) > $o ).

tff(pred_def_28802,type,
    v52622: state_type > $o ).

tff(pred_def_28803,type,
    v52620: state_type > $o ).

tff(pred_def_28804,type,
    v52626: state_type > $o ).

tff(pred_def_28805,type,
    v52625: ( state_type * $int ) > $o ).

tff(pred_def_28806,type,
    v52624: ( state_type * $int ) > $o ).

tff(pred_def_28807,type,
    v52629: state_type > $o ).

tff(pred_def_28808,type,
    v52628: ( state_type * $int ) > $o ).

tff(pred_def_28809,type,
    v52627: ( state_type * $int ) > $o ).

tff(pred_def_28810,type,
    v52623: ( state_type * $int ) > $o ).

tff(pred_def_28811,type,
    v52606: ( state_type * $int ) > $o ).

tff(pred_def_28812,type,
    v52604: ( state_type * $int ) > $o ).

tff(pred_def_28813,type,
    v52635: state_type > $o ).

tff(pred_def_28814,type,
    v52633: state_type > $o ).

tff(pred_def_28815,type,
    v52632: state_type > $o ).

tff(pred_def_28816,type,
    v52631: ( state_type * $int ) > $o ).

tff(pred_def_28817,type,
    v52601: state_type > $o ).

tff(pred_def_28818,type,
    v52599: state_type > $o ).

tff(pred_def_28819,type,
    v52650: ( state_type * $int ) > $o ).

tff(pred_def_28820,type,
    v52648: ( state_type * $int ) > $o ).

tff(pred_def_28821,type,
    v52654: state_type > $o ).

tff(pred_def_28822,type,
    v52652: state_type > $o ).

tff(pred_def_28823,type,
    v52658: ( state_type * $int ) > $o ).

tff(pred_def_28824,type,
    v52656: ( state_type * $int ) > $o ).

tff(pred_def_28825,type,
    v52662: state_type > $o ).

tff(pred_def_28826,type,
    v52660: state_type > $o ).

tff(pred_def_28827,type,
    v52666: state_type > $o ).

tff(pred_def_28828,type,
    v52665: ( state_type * $int ) > $o ).

tff(pred_def_28829,type,
    v52664: ( state_type * $int ) > $o ).

tff(pred_def_28830,type,
    v52669: state_type > $o ).

tff(pred_def_28831,type,
    v52668: ( state_type * $int ) > $o ).

tff(pred_def_28832,type,
    v52667: ( state_type * $int ) > $o ).

tff(pred_def_28833,type,
    v52663: ( state_type * $int ) > $o ).

tff(pred_def_28834,type,
    v52646: ( state_type * $int ) > $o ).

tff(pred_def_28835,type,
    v52644: ( state_type * $int ) > $o ).

tff(pred_def_28836,type,
    v52675: state_type > $o ).

tff(pred_def_28837,type,
    v52673: state_type > $o ).

tff(pred_def_28838,type,
    v52672: state_type > $o ).

tff(pred_def_28839,type,
    v52671: ( state_type * $int ) > $o ).

tff(pred_def_28840,type,
    v52641: state_type > $o ).

tff(pred_def_28841,type,
    v52639: state_type > $o ).

tff(pred_def_28842,type,
    v52679: state_type > $o ).

tff(pred_def_28843,type,
    v52557: state_type > $o ).

tff(pred_def_28844,type,
    v52555: state_type > $o ).

tff(pred_def_28845,type,
    v52553: state_type > $o ).

tff(pred_def_28846,type,
    v52551: state_type > $o ).

tff(pred_def_28847,type,
    v52549: state_type > $o ).

tff(pred_def_28848,type,
    v52702: ( state_type * $int ) > $o ).

tff(pred_def_28849,type,
    v52700: ( state_type * $int ) > $o ).

tff(pred_def_28850,type,
    v52706: state_type > $o ).

tff(pred_def_28851,type,
    v52704: state_type > $o ).

tff(pred_def_28852,type,
    v52710: ( state_type * $int ) > $o ).

tff(pred_def_28853,type,
    v52708: ( state_type * $int ) > $o ).

tff(pred_def_28854,type,
    v52714: state_type > $o ).

tff(pred_def_28855,type,
    v52712: state_type > $o ).

tff(pred_def_28856,type,
    v52718: state_type > $o ).

tff(pred_def_28857,type,
    v52717: ( state_type * $int ) > $o ).

tff(pred_def_28858,type,
    v52716: ( state_type * $int ) > $o ).

tff(pred_def_28859,type,
    v52721: state_type > $o ).

tff(pred_def_28860,type,
    v52720: ( state_type * $int ) > $o ).

tff(pred_def_28861,type,
    v52719: ( state_type * $int ) > $o ).

tff(pred_def_28862,type,
    v52715: ( state_type * $int ) > $o ).

tff(pred_def_28863,type,
    v52698: ( state_type * $int ) > $o ).

tff(pred_def_28864,type,
    v52696: ( state_type * $int ) > $o ).

tff(pred_def_28865,type,
    v52727: state_type > $o ).

tff(pred_def_28866,type,
    v52725: state_type > $o ).

tff(pred_def_28867,type,
    v52724: state_type > $o ).

tff(pred_def_28868,type,
    v52723: ( state_type * $int ) > $o ).

tff(pred_def_28869,type,
    v52693: state_type > $o ).

tff(pred_def_28870,type,
    v52691: state_type > $o ).

tff(pred_def_28871,type,
    v52742: ( state_type * $int ) > $o ).

tff(pred_def_28872,type,
    v52740: ( state_type * $int ) > $o ).

tff(pred_def_28873,type,
    v52746: state_type > $o ).

tff(pred_def_28874,type,
    v52744: state_type > $o ).

tff(pred_def_28875,type,
    v52750: ( state_type * $int ) > $o ).

tff(pred_def_28876,type,
    v52748: ( state_type * $int ) > $o ).

tff(pred_def_28877,type,
    v52754: state_type > $o ).

tff(pred_def_28878,type,
    v52752: state_type > $o ).

tff(pred_def_28879,type,
    v52758: state_type > $o ).

tff(pred_def_28880,type,
    v52757: ( state_type * $int ) > $o ).

tff(pred_def_28881,type,
    v52756: ( state_type * $int ) > $o ).

tff(pred_def_28882,type,
    v52761: state_type > $o ).

tff(pred_def_28883,type,
    v52760: ( state_type * $int ) > $o ).

tff(pred_def_28884,type,
    v52759: ( state_type * $int ) > $o ).

tff(pred_def_28885,type,
    v52755: ( state_type * $int ) > $o ).

tff(pred_def_28886,type,
    v52738: ( state_type * $int ) > $o ).

tff(pred_def_28887,type,
    v52736: ( state_type * $int ) > $o ).

tff(pred_def_28888,type,
    v52767: state_type > $o ).

tff(pred_def_28889,type,
    v52765: state_type > $o ).

tff(pred_def_28890,type,
    v52764: state_type > $o ).

tff(pred_def_28891,type,
    v52763: ( state_type * $int ) > $o ).

tff(pred_def_28892,type,
    v52733: state_type > $o ).

tff(pred_def_28893,type,
    v52731: state_type > $o ).

tff(pred_def_28894,type,
    v52782: ( state_type * $int ) > $o ).

tff(pred_def_28895,type,
    v52780: ( state_type * $int ) > $o ).

tff(pred_def_28896,type,
    v52786: state_type > $o ).

tff(pred_def_28897,type,
    v52784: state_type > $o ).

tff(pred_def_28898,type,
    v52790: ( state_type * $int ) > $o ).

tff(pred_def_28899,type,
    v52788: ( state_type * $int ) > $o ).

tff(pred_def_28900,type,
    v52794: state_type > $o ).

tff(pred_def_28901,type,
    v52792: state_type > $o ).

tff(pred_def_28902,type,
    v52798: state_type > $o ).

tff(pred_def_28903,type,
    v52797: ( state_type * $int ) > $o ).

tff(pred_def_28904,type,
    v52796: ( state_type * $int ) > $o ).

tff(pred_def_28905,type,
    v52801: state_type > $o ).

tff(pred_def_28906,type,
    v52800: ( state_type * $int ) > $o ).

tff(pred_def_28907,type,
    v52799: ( state_type * $int ) > $o ).

tff(pred_def_28908,type,
    v52795: ( state_type * $int ) > $o ).

tff(pred_def_28909,type,
    v52778: ( state_type * $int ) > $o ).

tff(pred_def_28910,type,
    v52776: ( state_type * $int ) > $o ).

tff(pred_def_28911,type,
    v52807: state_type > $o ).

tff(pred_def_28912,type,
    v52805: state_type > $o ).

tff(pred_def_28913,type,
    v52804: state_type > $o ).

tff(pred_def_28914,type,
    v52803: ( state_type * $int ) > $o ).

tff(pred_def_28915,type,
    v52773: state_type > $o ).

tff(pred_def_28916,type,
    v52771: state_type > $o ).

tff(pred_def_28917,type,
    v52811: state_type > $o ).

tff(pred_def_28918,type,
    v52689: state_type > $o ).

tff(pred_def_28919,type,
    v52687: state_type > $o ).

tff(pred_def_28920,type,
    v52685: state_type > $o ).

tff(pred_def_28921,type,
    v52683: state_type > $o ).

tff(pred_def_28922,type,
    v52681: state_type > $o ).

tff(pred_def_28923,type,
    v52813: state_type > $o ).

tff(pred_def_28924,type,
    v6001: state_type > $o ).

tff(pred_def_28925,type,
    v5999: state_type > $o ).

tff(pred_def_28926,type,
    v5997: state_type > $o ).

tff(pred_def_28927,type,
    v5995: state_type > $o ).

tff(pred_def_28928,type,
    v5993: state_type > $o ).

tff(pred_def_28929,type,
    v52846: ( state_type * $int ) > $o ).

tff(pred_def_28930,type,
    v52844: ( state_type * $int ) > $o ).

tff(pred_def_28931,type,
    v52850: state_type > $o ).

tff(pred_def_28932,type,
    v52848: state_type > $o ).

tff(pred_def_28933,type,
    v52854: ( state_type * $int ) > $o ).

tff(pred_def_28934,type,
    v52852: ( state_type * $int ) > $o ).

tff(pred_def_28935,type,
    v52858: state_type > $o ).

tff(pred_def_28936,type,
    v52856: state_type > $o ).

tff(pred_def_28937,type,
    v52862: state_type > $o ).

tff(pred_def_28938,type,
    v52861: ( state_type * $int ) > $o ).

tff(pred_def_28939,type,
    v52860: ( state_type * $int ) > $o ).

tff(pred_def_28940,type,
    v52865: state_type > $o ).

tff(pred_def_28941,type,
    v52864: ( state_type * $int ) > $o ).

tff(pred_def_28942,type,
    v52863: ( state_type * $int ) > $o ).

tff(pred_def_28943,type,
    v52859: ( state_type * $int ) > $o ).

tff(pred_def_28944,type,
    v52842: ( state_type * $int ) > $o ).

tff(pred_def_28945,type,
    v52840: ( state_type * $int ) > $o ).

tff(pred_def_28946,type,
    v52871: state_type > $o ).

tff(pred_def_28947,type,
    v52869: state_type > $o ).

tff(pred_def_28948,type,
    v52868: state_type > $o ).

tff(pred_def_28949,type,
    v52867: ( state_type * $int ) > $o ).

tff(pred_def_28950,type,
    v52837: state_type > $o ).

tff(pred_def_28951,type,
    v52835: state_type > $o ).

tff(pred_def_28952,type,
    v52886: ( state_type * $int ) > $o ).

tff(pred_def_28953,type,
    v52884: ( state_type * $int ) > $o ).

tff(pred_def_28954,type,
    v52890: state_type > $o ).

tff(pred_def_28955,type,
    v52888: state_type > $o ).

tff(pred_def_28956,type,
    v52894: ( state_type * $int ) > $o ).

tff(pred_def_28957,type,
    v52892: ( state_type * $int ) > $o ).

tff(pred_def_28958,type,
    v52898: state_type > $o ).

tff(pred_def_28959,type,
    v52896: state_type > $o ).

tff(pred_def_28960,type,
    v52902: state_type > $o ).

tff(pred_def_28961,type,
    v52901: ( state_type * $int ) > $o ).

tff(pred_def_28962,type,
    v52900: ( state_type * $int ) > $o ).

tff(pred_def_28963,type,
    v52905: state_type > $o ).

tff(pred_def_28964,type,
    v52904: ( state_type * $int ) > $o ).

tff(pred_def_28965,type,
    v52903: ( state_type * $int ) > $o ).

tff(pred_def_28966,type,
    v52899: ( state_type * $int ) > $o ).

tff(pred_def_28967,type,
    v52882: ( state_type * $int ) > $o ).

tff(pred_def_28968,type,
    v52880: ( state_type * $int ) > $o ).

tff(pred_def_28969,type,
    v52911: state_type > $o ).

tff(pred_def_28970,type,
    v52909: state_type > $o ).

tff(pred_def_28971,type,
    v52908: state_type > $o ).

tff(pred_def_28972,type,
    v52907: ( state_type * $int ) > $o ).

tff(pred_def_28973,type,
    v52877: state_type > $o ).

tff(pred_def_28974,type,
    v52875: state_type > $o ).

tff(pred_def_28975,type,
    v52926: ( state_type * $int ) > $o ).

tff(pred_def_28976,type,
    v52924: ( state_type * $int ) > $o ).

tff(pred_def_28977,type,
    v52930: state_type > $o ).

tff(pred_def_28978,type,
    v52928: state_type > $o ).

tff(pred_def_28979,type,
    v52934: ( state_type * $int ) > $o ).

tff(pred_def_28980,type,
    v52932: ( state_type * $int ) > $o ).

tff(pred_def_28981,type,
    v52938: state_type > $o ).

tff(pred_def_28982,type,
    v52936: state_type > $o ).

tff(pred_def_28983,type,
    v52942: state_type > $o ).

tff(pred_def_28984,type,
    v52941: ( state_type * $int ) > $o ).

tff(pred_def_28985,type,
    v52940: ( state_type * $int ) > $o ).

tff(pred_def_28986,type,
    v52945: state_type > $o ).

tff(pred_def_28987,type,
    v52944: ( state_type * $int ) > $o ).

tff(pred_def_28988,type,
    v52943: ( state_type * $int ) > $o ).

tff(pred_def_28989,type,
    v52939: ( state_type * $int ) > $o ).

tff(pred_def_28990,type,
    v52922: ( state_type * $int ) > $o ).

tff(pred_def_28991,type,
    v52920: ( state_type * $int ) > $o ).

tff(pred_def_28992,type,
    v52951: state_type > $o ).

tff(pred_def_28993,type,
    v52949: state_type > $o ).

tff(pred_def_28994,type,
    v52948: state_type > $o ).

tff(pred_def_28995,type,
    v52947: ( state_type * $int ) > $o ).

tff(pred_def_28996,type,
    v52917: state_type > $o ).

tff(pred_def_28997,type,
    v52915: state_type > $o ).

tff(pred_def_28998,type,
    v52955: state_type > $o ).

tff(pred_def_28999,type,
    v52833: state_type > $o ).

tff(pred_def_29000,type,
    v52831: state_type > $o ).

tff(pred_def_29001,type,
    v52829: state_type > $o ).

tff(pred_def_29002,type,
    v52827: state_type > $o ).

tff(pred_def_29003,type,
    v52825: state_type > $o ).

tff(pred_def_29004,type,
    v52978: ( state_type * $int ) > $o ).

tff(pred_def_29005,type,
    v52976: ( state_type * $int ) > $o ).

tff(pred_def_29006,type,
    v52982: state_type > $o ).

tff(pred_def_29007,type,
    v52980: state_type > $o ).

tff(pred_def_29008,type,
    v52986: ( state_type * $int ) > $o ).

tff(pred_def_29009,type,
    v52984: ( state_type * $int ) > $o ).

tff(pred_def_29010,type,
    v52990: state_type > $o ).

tff(pred_def_29011,type,
    v52988: state_type > $o ).

tff(pred_def_29012,type,
    v52994: state_type > $o ).

tff(pred_def_29013,type,
    v52993: ( state_type * $int ) > $o ).

tff(pred_def_29014,type,
    v52992: ( state_type * $int ) > $o ).

tff(pred_def_29015,type,
    v52997: state_type > $o ).

tff(pred_def_29016,type,
    v52996: ( state_type * $int ) > $o ).

tff(pred_def_29017,type,
    v52995: ( state_type * $int ) > $o ).

tff(pred_def_29018,type,
    v52991: ( state_type * $int ) > $o ).

tff(pred_def_29019,type,
    v52974: ( state_type * $int ) > $o ).

tff(pred_def_29020,type,
    v52972: ( state_type * $int ) > $o ).

tff(pred_def_29021,type,
    v53003: state_type > $o ).

tff(pred_def_29022,type,
    v53001: state_type > $o ).

tff(pred_def_29023,type,
    v53000: state_type > $o ).

tff(pred_def_29024,type,
    v52999: ( state_type * $int ) > $o ).

tff(pred_def_29025,type,
    v52969: state_type > $o ).

tff(pred_def_29026,type,
    v52967: state_type > $o ).

tff(pred_def_29027,type,
    v53018: ( state_type * $int ) > $o ).

tff(pred_def_29028,type,
    v53016: ( state_type * $int ) > $o ).

tff(pred_def_29029,type,
    v53022: state_type > $o ).

tff(pred_def_29030,type,
    v53020: state_type > $o ).

tff(pred_def_29031,type,
    v53026: ( state_type * $int ) > $o ).

tff(pred_def_29032,type,
    v53024: ( state_type * $int ) > $o ).

tff(pred_def_29033,type,
    v53030: state_type > $o ).

tff(pred_def_29034,type,
    v53028: state_type > $o ).

tff(pred_def_29035,type,
    v53034: state_type > $o ).

tff(pred_def_29036,type,
    v53033: ( state_type * $int ) > $o ).

tff(pred_def_29037,type,
    v53032: ( state_type * $int ) > $o ).

tff(pred_def_29038,type,
    v53037: state_type > $o ).

tff(pred_def_29039,type,
    v53036: ( state_type * $int ) > $o ).

tff(pred_def_29040,type,
    v53035: ( state_type * $int ) > $o ).

tff(pred_def_29041,type,
    v53031: ( state_type * $int ) > $o ).

tff(pred_def_29042,type,
    v53014: ( state_type * $int ) > $o ).

tff(pred_def_29043,type,
    v53012: ( state_type * $int ) > $o ).

tff(pred_def_29044,type,
    v53043: state_type > $o ).

tff(pred_def_29045,type,
    v53041: state_type > $o ).

tff(pred_def_29046,type,
    v53040: state_type > $o ).

tff(pred_def_29047,type,
    v53039: ( state_type * $int ) > $o ).

tff(pred_def_29048,type,
    v53009: state_type > $o ).

tff(pred_def_29049,type,
    v53007: state_type > $o ).

tff(pred_def_29050,type,
    v53058: ( state_type * $int ) > $o ).

tff(pred_def_29051,type,
    v53056: ( state_type * $int ) > $o ).

tff(pred_def_29052,type,
    v53062: state_type > $o ).

tff(pred_def_29053,type,
    v53060: state_type > $o ).

tff(pred_def_29054,type,
    v53066: ( state_type * $int ) > $o ).

tff(pred_def_29055,type,
    v53064: ( state_type * $int ) > $o ).

tff(pred_def_29056,type,
    v53070: state_type > $o ).

tff(pred_def_29057,type,
    v53068: state_type > $o ).

tff(pred_def_29058,type,
    v53074: state_type > $o ).

tff(pred_def_29059,type,
    v53073: ( state_type * $int ) > $o ).

tff(pred_def_29060,type,
    v53072: ( state_type * $int ) > $o ).

tff(pred_def_29061,type,
    v53077: state_type > $o ).

tff(pred_def_29062,type,
    v53076: ( state_type * $int ) > $o ).

tff(pred_def_29063,type,
    v53075: ( state_type * $int ) > $o ).

tff(pred_def_29064,type,
    v53071: ( state_type * $int ) > $o ).

tff(pred_def_29065,type,
    v53054: ( state_type * $int ) > $o ).

tff(pred_def_29066,type,
    v53052: ( state_type * $int ) > $o ).

tff(pred_def_29067,type,
    v53083: state_type > $o ).

tff(pred_def_29068,type,
    v53081: state_type > $o ).

tff(pred_def_29069,type,
    v53080: state_type > $o ).

tff(pred_def_29070,type,
    v53079: ( state_type * $int ) > $o ).

tff(pred_def_29071,type,
    v53049: state_type > $o ).

tff(pred_def_29072,type,
    v53047: state_type > $o ).

tff(pred_def_29073,type,
    v53087: state_type > $o ).

tff(pred_def_29074,type,
    v52965: state_type > $o ).

tff(pred_def_29075,type,
    v52963: state_type > $o ).

tff(pred_def_29076,type,
    v52961: state_type > $o ).

tff(pred_def_29077,type,
    v52959: state_type > $o ).

tff(pred_def_29078,type,
    v52957: state_type > $o ).

tff(pred_def_29079,type,
    v53124: state_type > $o ).

tff(pred_def_29080,type,
    v53122: state_type > $o ).

tff(pred_def_29081,type,
    v53120: state_type > $o ).

tff(pred_def_29082,type,
    v53118: state_type > $o ).

tff(pred_def_29083,type,
    v53116: state_type > $o ).

tff(pred_def_29084,type,
    v53134: state_type > $o ).

tff(pred_def_29085,type,
    v53132: state_type > $o ).

tff(pred_def_29086,type,
    v53130: state_type > $o ).

tff(pred_def_29087,type,
    v53128: state_type > $o ).

tff(pred_def_29088,type,
    v53126: state_type > $o ).

tff(pred_def_29089,type,
    v53156: state_type > $o ).

tff(pred_def_29090,type,
    v53155: ( state_type * $int ) > $o ).

tff(pred_def_29091,type,
    v53154: ( state_type * $int ) > $o ).

tff(pred_def_29092,type,
    v53152: ( state_type * $int ) > $o ).

tff(pred_def_29093,type,
    v53170: state_type > $o ).

tff(pred_def_29094,type,
    v53168: state_type > $o ).

tff(pred_def_29095,type,
    v53180: state_type > $o ).

tff(pred_def_29096,type,
    v53178: state_type > $o ).

tff(pred_def_29097,type,
    v53184: state_type > $o ).

tff(pred_def_29098,type,
    v53182: state_type > $o ).

tff(pred_def_29099,type,
    v53188: state_type > $o ).

tff(pred_def_29100,type,
    v53186: state_type > $o ).

tff(pred_def_29101,type,
    v53191: state_type > $o ).

tff(pred_def_29102,type,
    v53192: state_type > $o ).

tff(pred_def_29103,type,
    v53190: state_type > $o ).

tff(pred_def_29104,type,
    v53176: state_type > $o ).

tff(pred_def_29105,type,
    v53174: state_type > $o ).

tff(pred_def_29106,type,
    v53172: state_type > $o ).

tff(pred_def_29107,type,
    v53200: state_type > $o ).

tff(pred_def_29108,type,
    v53198: state_type > $o ).

tff(pred_def_29109,type,
    v53196: state_type > $o ).

tff(pred_def_29110,type,
    v53194: state_type > $o ).

tff(pred_def_29111,type,
    v53206: state_type > $o ).

tff(pred_def_29112,type,
    v53204: state_type > $o ).

tff(pred_def_29113,type,
    v53202: state_type > $o ).

tff(pred_def_29114,type,
    v53166: ( state_type * $int ) > $o ).

tff(pred_def_29115,type,
    v53211: ( state_type * $int ) > $o ).

tff(pred_def_29116,type,
    v53209: ( state_type * $int ) > $o ).

tff(pred_def_29117,type,
    v53218: ( state_type * $int ) > $o ).

tff(pred_def_29118,type,
    v53217: ( state_type * $int ) > $o ).

tff(pred_def_29119,type,
    v53219: ( state_type * $int ) > $o ).

tff(pred_def_29120,type,
    v53215: ( state_type * $int ) > $o ).

tff(pred_def_29121,type,
    v53213: ( state_type * $int ) > $o ).

tff(pred_def_29122,type,
    v53224: ( state_type * $int ) > $o ).

tff(pred_def_29123,type,
    v53223: ( state_type * $int ) > $o ).

tff(pred_def_29124,type,
    v53221: ( state_type * $int ) > $o ).

tff(pred_def_29125,type,
    v53229: state_type > $o ).

tff(pred_def_29126,type,
    v53228: state_type > $o ).

tff(pred_def_29127,type,
    v53230: state_type > $o ).

tff(pred_def_29128,type,
    v53226: state_type > $o ).

tff(pred_def_29129,type,
    v53234: state_type > $o ).

tff(pred_def_29130,type,
    v53233: state_type > $o ).

tff(pred_def_29131,type,
    v53231: state_type > $o ).

tff(pred_def_29132,type,
    v53237: state_type > $o ).

tff(pred_def_29133,type,
    v53235: state_type > $o ).

tff(pred_def_29134,type,
    v53240: state_type > $o ).

tff(pred_def_29135,type,
    v53241: state_type > $o ).

tff(pred_def_29136,type,
    v53238: state_type > $o ).

tff(pred_def_29137,type,
    v53225: ( state_type * $int ) > $o ).

tff(pred_def_29138,type,
    v53164: ( state_type * $int ) > $o ).

tff(pred_def_29139,type,
    v53162: ( state_type * $int ) > $o ).

tff(pred_def_29140,type,
    v53160: ( state_type * $int ) > $o ).

tff(pred_def_29141,type,
    v53158: ( state_type * $int ) > $o ).

tff(pred_def_29142,type,
    v53242: ( state_type * $int ) > $o ).

tff(pred_def_29143,type,
    v53150: ( state_type * $int ) > $o ).

tff(pred_def_29144,type,
    v53148: ( state_type * $int ) > $o ).

tff(pred_def_29145,type,
    v53146: ( state_type * $int ) > $o ).

tff(pred_def_29146,type,
    v53144: ( state_type * $int ) > $o ).

tff(pred_def_29147,type,
    v53246: state_type > $o ).

tff(pred_def_29148,type,
    v53244: state_type > $o ).

tff(pred_def_29149,type,
    v53250: ( state_type * $int ) > $o ).

tff(pred_def_29150,type,
    v53248: ( state_type * $int ) > $o ).

tff(pred_def_29151,type,
    v53254: state_type > $o ).

tff(pred_def_29152,type,
    v53252: state_type > $o ).

tff(pred_def_29153,type,
    v53258: state_type > $o ).

tff(pred_def_29154,type,
    v53257: ( state_type * $int ) > $o ).

tff(pred_def_29155,type,
    v53256: ( state_type * $int ) > $o ).

tff(pred_def_29156,type,
    v53261: state_type > $o ).

tff(pred_def_29157,type,
    v53260: ( state_type * $int ) > $o ).

tff(pred_def_29158,type,
    v53259: ( state_type * $int ) > $o ).

tff(pred_def_29159,type,
    v53255: ( state_type * $int ) > $o ).

tff(pred_def_29160,type,
    v53142: ( state_type * $int ) > $o ).

tff(pred_def_29161,type,
    v53140: ( state_type * $int ) > $o ).

tff(pred_def_29162,type,
    v53138: ( state_type * $int ) > $o ).

tff(pred_def_29163,type,
    v53136: ( state_type * $int ) > $o ).

tff(pred_def_29164,type,
    v53271: state_type > $o ).

tff(pred_def_29165,type,
    v53269: state_type > $o ).

tff(pred_def_29166,type,
    v53277: state_type > $o ).

tff(pred_def_29167,type,
    v53275: state_type > $o ).

tff(pred_def_29168,type,
    v53273: state_type > $o ).

tff(pred_def_29169,type,
    v53279: state_type > $o ).

tff(pred_def_29170,type,
    v53267: state_type > $o ).

tff(pred_def_29171,type,
    v53265: state_type > $o ).

tff(pred_def_29172,type,
    v53263: state_type > $o ).

tff(pred_def_29173,type,
    v53286: state_type > $o ).

tff(pred_def_29174,type,
    v53284: state_type > $o ).

tff(pred_def_29175,type,
    v53283: state_type > $o ).

tff(pred_def_29176,type,
    v53282: state_type > $o ).

tff(pred_def_29177,type,
    v53294: state_type > $o ).

tff(pred_def_29178,type,
    v53295: state_type > $o ).

tff(pred_def_29179,type,
    v53293: state_type > $o ).

tff(pred_def_29180,type,
    v53290: ( state_type * $int ) > $o ).

tff(pred_def_29181,type,
    v53292: ( state_type * $int ) > $o ).

tff(pred_def_29182,type,
    v53281: ( state_type * $int ) > $o ).

tff(pred_def_29183,type,
    v53114: ( state_type * $int ) > $o ).

tff(pred_def_29184,type,
    v53112: ( state_type * $int ) > $o ).

tff(pred_def_29185,type,
    v53109: ( state_type * $int ) > $o ).

tff(pred_def_29186,type,
    v53107: ( state_type * $int ) > $o ).

tff(pred_def_29187,type,
    v53105: ( state_type * $int ) > $o ).

tff(pred_def_29188,type,
    v53103: ( state_type * $int ) > $o ).

tff(pred_def_29189,type,
    v53101: state_type > $o ).

tff(pred_def_29190,type,
    v53099: state_type > $o ).

tff(pred_def_29191,type,
    v53322: state_type > $o ).

tff(pred_def_29192,type,
    v53321: ( state_type * $int ) > $o ).

tff(pred_def_29193,type,
    v53320: ( state_type * $int ) > $o ).

tff(pred_def_29194,type,
    v53318: ( state_type * $int ) > $o ).

tff(pred_def_29195,type,
    v53338: state_type > $o ).

tff(pred_def_29196,type,
    v53336: state_type > $o ).

tff(pred_def_29197,type,
    v53348: state_type > $o ).

tff(pred_def_29198,type,
    v53346: state_type > $o ).

tff(pred_def_29199,type,
    v53352: state_type > $o ).

tff(pred_def_29200,type,
    v53350: state_type > $o ).

tff(pred_def_29201,type,
    v53356: state_type > $o ).

tff(pred_def_29202,type,
    v53354: state_type > $o ).

tff(pred_def_29203,type,
    v53359: state_type > $o ).

tff(pred_def_29204,type,
    v53360: state_type > $o ).

tff(pred_def_29205,type,
    v53358: state_type > $o ).

tff(pred_def_29206,type,
    v53344: state_type > $o ).

tff(pred_def_29207,type,
    v53342: state_type > $o ).

tff(pred_def_29208,type,
    v53340: state_type > $o ).

tff(pred_def_29209,type,
    v53368: state_type > $o ).

tff(pred_def_29210,type,
    v53366: state_type > $o ).

tff(pred_def_29211,type,
    v53364: state_type > $o ).

tff(pred_def_29212,type,
    v53362: state_type > $o ).

tff(pred_def_29213,type,
    v53374: state_type > $o ).

tff(pred_def_29214,type,
    v53372: state_type > $o ).

tff(pred_def_29215,type,
    v53370: state_type > $o ).

tff(pred_def_29216,type,
    v53334: ( state_type * $int ) > $o ).

tff(pred_def_29217,type,
    v53379: ( state_type * $int ) > $o ).

tff(pred_def_29218,type,
    v53377: ( state_type * $int ) > $o ).

tff(pred_def_29219,type,
    v53383: ( state_type * $int ) > $o ).

tff(pred_def_29220,type,
    v53381: ( state_type * $int ) > $o ).

tff(pred_def_29221,type,
    v53387: ( state_type * $int ) > $o ).

tff(pred_def_29222,type,
    v53385: ( state_type * $int ) > $o ).

tff(pred_def_29223,type,
    v53394: state_type > $o ).

tff(pred_def_29224,type,
    v53393: state_type > $o ).

tff(pred_def_29225,type,
    v53395: state_type > $o ).

tff(pred_def_29226,type,
    v53391: state_type > $o ).

tff(pred_def_29227,type,
    v53399: state_type > $o ).

tff(pred_def_29228,type,
    v53398: state_type > $o ).

tff(pred_def_29229,type,
    v53396: state_type > $o ).

tff(pred_def_29230,type,
    v53402: state_type > $o ).

tff(pred_def_29231,type,
    v53400: state_type > $o ).

tff(pred_def_29232,type,
    v53405: state_type > $o ).

tff(pred_def_29233,type,
    v53406: state_type > $o ).

tff(pred_def_29234,type,
    v53403: state_type > $o ).

tff(pred_def_29235,type,
    v53390: ( state_type * $int ) > $o ).

tff(pred_def_29236,type,
    b1111111111111111: $int > $o ).

tff(pred_def_29237,type,
    v53332: ( state_type * $int ) > $o ).

tff(pred_def_29238,type,
    v53330: ( state_type * $int ) > $o ).

tff(pred_def_29239,type,
    v53328: ( state_type * $int ) > $o ).

tff(pred_def_29240,type,
    v53326: ( state_type * $int ) > $o ).

tff(pred_def_29241,type,
    v53324: ( state_type * $int ) > $o ).

tff(pred_def_29242,type,
    v53407: ( state_type * $int ) > $o ).

tff(pred_def_29243,type,
    v53316: ( state_type * $int ) > $o ).

tff(pred_def_29244,type,
    v53314: ( state_type * $int ) > $o ).

tff(pred_def_29245,type,
    v53312: ( state_type * $int ) > $o ).

tff(pred_def_29246,type,
    v53310: ( state_type * $int ) > $o ).

tff(pred_def_29247,type,
    v53308: ( state_type * $int ) > $o ).

tff(pred_def_29248,type,
    v53411: state_type > $o ).

tff(pred_def_29249,type,
    v53409: state_type > $o ).

tff(pred_def_29250,type,
    v53415: ( state_type * $int ) > $o ).

tff(pred_def_29251,type,
    v53413: ( state_type * $int ) > $o ).

tff(pred_def_29252,type,
    v53419: state_type > $o ).

tff(pred_def_29253,type,
    v53417: state_type > $o ).

tff(pred_def_29254,type,
    v53423: state_type > $o ).

tff(pred_def_29255,type,
    v53422: ( state_type * $int ) > $o ).

tff(pred_def_29256,type,
    v53421: ( state_type * $int ) > $o ).

tff(pred_def_29257,type,
    v53426: state_type > $o ).

tff(pred_def_29258,type,
    v53425: ( state_type * $int ) > $o ).

tff(pred_def_29259,type,
    v53424: ( state_type * $int ) > $o ).

tff(pred_def_29260,type,
    v53420: ( state_type * $int ) > $o ).

tff(pred_def_29261,type,
    v53306: ( state_type * $int ) > $o ).

tff(pred_def_29262,type,
    v53304: ( state_type * $int ) > $o ).

tff(pred_def_29263,type,
    v53432: state_type > $o ).

tff(pred_def_29264,type,
    v53430: state_type > $o ).

tff(pred_def_29265,type,
    v53429: state_type > $o ).

tff(pred_def_29266,type,
    v53428: ( state_type * $int ) > $o ).

tff(pred_def_29267,type,
    v53301: state_type > $o ).

tff(pred_def_29268,type,
    v53299: state_type > $o ).

tff(pred_def_29269,type,
    v53466: state_type > $o ).

tff(pred_def_29270,type,
    v53464: state_type > $o ).

tff(pred_def_29271,type,
    v53462: state_type > $o ).

tff(pred_def_29272,type,
    v53460: state_type > $o ).

tff(pred_def_29273,type,
    v53458: state_type > $o ).

tff(pred_def_29274,type,
    v53476: state_type > $o ).

tff(pred_def_29275,type,
    v53474: state_type > $o ).

tff(pred_def_29276,type,
    v53472: state_type > $o ).

tff(pred_def_29277,type,
    v53470: state_type > $o ).

tff(pred_def_29278,type,
    v53468: state_type > $o ).

tff(pred_def_29279,type,
    v53506: state_type > $o ).

tff(pred_def_29280,type,
    v53507: state_type > $o ).

tff(pred_def_29281,type,
    v53505: state_type > $o ).

tff(pred_def_29282,type,
    v53508: state_type > $o ).

tff(pred_def_29283,type,
    v53504: state_type > $o ).

tff(pred_def_29284,type,
    v53509: state_type > $o ).

tff(pred_def_29285,type,
    v53503: state_type > $o ).

tff(pred_def_29286,type,
    v53510: state_type > $o ).

tff(pred_def_29287,type,
    v53502: state_type > $o ).

tff(pred_def_29288,type,
    v53511: state_type > $o ).

tff(pred_def_29289,type,
    v53501: state_type > $o ).

tff(pred_def_29290,type,
    v53512: state_type > $o ).

tff(pred_def_29291,type,
    v53500: state_type > $o ).

tff(pred_def_29292,type,
    v53513: state_type > $o ).

tff(pred_def_29293,type,
    v53499: state_type > $o ).

tff(pred_def_29294,type,
    v53514: state_type > $o ).

tff(pred_def_29295,type,
    v53498: state_type > $o ).

tff(pred_def_29296,type,
    v53515: state_type > $o ).

tff(pred_def_29297,type,
    v53497: state_type > $o ).

tff(pred_def_29298,type,
    v53516: state_type > $o ).

tff(pred_def_29299,type,
    v53496: state_type > $o ).

tff(pred_def_29300,type,
    v53517: state_type > $o ).

tff(pred_def_29301,type,
    v53495: state_type > $o ).

tff(pred_def_29302,type,
    v53518: state_type > $o ).

tff(pred_def_29303,type,
    v53494: state_type > $o ).

tff(pred_def_29304,type,
    v53519: state_type > $o ).

tff(pred_def_29305,type,
    v53493: state_type > $o ).

tff(pred_def_29306,type,
    v53520: state_type > $o ).

tff(pred_def_29307,type,
    v53492: state_type > $o ).

tff(pred_def_29308,type,
    v53521: state_type > $o ).

tff(pred_def_29309,type,
    v53490: state_type > $o ).

tff(pred_def_29310,type,
    v53488: state_type > $o ).

tff(pred_def_29311,type,
    v53524: state_type > $o ).

tff(pred_def_29312,type,
    v2036: state_type > $o ).

tff(pred_def_29313,type,
    v53486: state_type > $o ).

tff(pred_def_29314,type,
    v53484: state_type > $o ).

tff(pred_def_29315,type,
    v53482: state_type > $o ).

tff(pred_def_29316,type,
    v53526: ( state_type * $int ) > $o ).

tff(pred_def_29317,type,
    v53525: ( state_type * $int ) > $o ).

tff(pred_def_29318,type,
    v53480: ( state_type * $int ) > $o ).

tff(pred_def_29319,type,
    v53478: ( state_type * $int ) > $o ).

tff(pred_def_29320,type,
    v53536: state_type > $o ).

tff(pred_def_29321,type,
    v53534: state_type > $o ).

tff(pred_def_29322,type,
    v53542: state_type > $o ).

tff(pred_def_29323,type,
    v53540: state_type > $o ).

tff(pred_def_29324,type,
    v53538: state_type > $o ).

tff(pred_def_29325,type,
    v53544: state_type > $o ).

tff(pred_def_29326,type,
    v53532: state_type > $o ).

tff(pred_def_29327,type,
    v53530: state_type > $o ).

tff(pred_def_29328,type,
    v53528: state_type > $o ).

tff(pred_def_29329,type,
    v53551: state_type > $o ).

tff(pred_def_29330,type,
    v53549: state_type > $o ).

tff(pred_def_29331,type,
    v53548: state_type > $o ).

tff(pred_def_29332,type,
    v53547: state_type > $o ).

tff(pred_def_29333,type,
    v53559: state_type > $o ).

tff(pred_def_29334,type,
    v53560: state_type > $o ).

tff(pred_def_29335,type,
    v53558: state_type > $o ).

tff(pred_def_29336,type,
    v53555: ( state_type * $int ) > $o ).

tff(pred_def_29337,type,
    v53557: ( state_type * $int ) > $o ).

tff(pred_def_29338,type,
    v53546: ( state_type * $int ) > $o ).

tff(pred_def_29339,type,
    v53456: ( state_type * $int ) > $o ).

tff(pred_def_29340,type,
    v53454: ( state_type * $int ) > $o ).

tff(pred_def_29341,type,
    v53452: state_type > $o ).

tff(pred_def_29342,type,
    v53450: state_type > $o ).

tff(pred_def_29343,type,
    v53563: ( state_type * $int ) > $o ).

tff(pred_def_29344,type,
    v53448: ( state_type * $int ) > $o ).

tff(pred_def_29345,type,
    v53446: ( state_type * $int ) > $o ).

tff(pred_def_29346,type,
    v53444: ( state_type * $int ) > $o ).

tff(pred_def_29347,type,
    v53442: ( state_type * $int ) > $o ).

tff(pred_def_29348,type,
    v53440: state_type > $o ).

tff(pred_def_29349,type,
    v53438: state_type > $o ).

tff(pred_def_29350,type,
    v53436: state_type > $o ).

tff(pred_def_29351,type,
    v53565: state_type > $o ).

tff(pred_def_29352,type,
    v53097: state_type > $o ).

tff(pred_def_29353,type,
    v53095: state_type > $o ).

tff(pred_def_29354,type,
    v53093: state_type > $o ).

tff(pred_def_29355,type,
    v53091: state_type > $o ).

tff(pred_def_29356,type,
    v53089: state_type > $o ).

tff(pred_def_29357,type,
    v53567: state_type > $o ).

tff(pred_def_29358,type,
    v52823: state_type > $o ).

tff(pred_def_29359,type,
    v52821: state_type > $o ).

tff(pred_def_29360,type,
    v52819: state_type > $o ).

tff(pred_def_29361,type,
    v52817: state_type > $o ).

tff(pred_def_29362,type,
    v52815: state_type > $o ).

tff(pred_def_29363,type,
    v53589: state_type > $o ).

tff(pred_def_29364,type,
    v53587: state_type > $o ).

tff(pred_def_29365,type,
    v53585: state_type > $o ).

tff(pred_def_29366,type,
    v53583: state_type > $o ).

tff(pred_def_29367,type,
    v53581: state_type > $o ).

tff(pred_def_29368,type,
    v53599: state_type > $o ).

tff(pred_def_29369,type,
    v53597: state_type > $o ).

tff(pred_def_29370,type,
    v53595: state_type > $o ).

tff(pred_def_29371,type,
    v53593: state_type > $o ).

tff(pred_def_29372,type,
    v53591: state_type > $o ).

tff(pred_def_29373,type,
    v53612: ( state_type * $int ) > $o ).

tff(pred_def_29374,type,
    v53610: ( state_type * $int ) > $o ).

tff(pred_def_29375,type,
    v53616: state_type > $o ).

tff(pred_def_29376,type,
    v53614: state_type > $o ).

tff(pred_def_29377,type,
    v53620: ( state_type * $int ) > $o ).

tff(pred_def_29378,type,
    v53618: ( state_type * $int ) > $o ).

tff(pred_def_29379,type,
    v53624: state_type > $o ).

tff(pred_def_29380,type,
    v53622: state_type > $o ).

tff(pred_def_29381,type,
    v53628: state_type > $o ).

tff(pred_def_29382,type,
    v53627: ( state_type * $int ) > $o ).

tff(pred_def_29383,type,
    v53626: ( state_type * $int ) > $o ).

tff(pred_def_29384,type,
    v53631: state_type > $o ).

tff(pred_def_29385,type,
    v53630: ( state_type * $int ) > $o ).

tff(pred_def_29386,type,
    v53629: ( state_type * $int ) > $o ).

tff(pred_def_29387,type,
    v53625: ( state_type * $int ) > $o ).

tff(pred_def_29388,type,
    v53608: ( state_type * $int ) > $o ).

tff(pred_def_29389,type,
    v53606: ( state_type * $int ) > $o ).

tff(pred_def_29390,type,
    v53633: state_type > $o ).

tff(pred_def_29391,type,
    v53632: ( state_type * $int ) > $o ).

tff(pred_def_29392,type,
    v53603: ( state_type * $int ) > $o ).

tff(pred_def_29393,type,
    v53601: ( state_type * $int ) > $o ).

tff(pred_def_29394,type,
    v53643: state_type > $o ).

tff(pred_def_29395,type,
    v53641: state_type > $o ).

tff(pred_def_29396,type,
    v53649: state_type > $o ).

tff(pred_def_29397,type,
    v53647: state_type > $o ).

tff(pred_def_29398,type,
    v53645: state_type > $o ).

tff(pred_def_29399,type,
    v53651: state_type > $o ).

tff(pred_def_29400,type,
    v53639: state_type > $o ).

tff(pred_def_29401,type,
    v53637: state_type > $o ).

tff(pred_def_29402,type,
    v53635: state_type > $o ).

tff(pred_def_29403,type,
    v53658: state_type > $o ).

tff(pred_def_29404,type,
    v53656: state_type > $o ).

tff(pred_def_29405,type,
    v53655: state_type > $o ).

tff(pred_def_29406,type,
    v53654: state_type > $o ).

tff(pred_def_29407,type,
    v53666: state_type > $o ).

tff(pred_def_29408,type,
    v53667: state_type > $o ).

tff(pred_def_29409,type,
    v53665: state_type > $o ).

tff(pred_def_29410,type,
    v53662: ( state_type * $int ) > $o ).

tff(pred_def_29411,type,
    v53664: ( state_type * $int ) > $o ).

tff(pred_def_29412,type,
    v53653: ( state_type * $int ) > $o ).

tff(pred_def_29413,type,
    v53579: ( state_type * $int ) > $o ).

tff(pred_def_29414,type,
    v53577: ( state_type * $int ) > $o ).

tff(pred_def_29415,type,
    v53575: ( state_type * $int ) > $o ).

tff(pred_def_29416,type,
    v53573: ( state_type * $int ) > $o ).

tff(pred_def_29417,type,
    v53571: state_type > $o ).

tff(pred_def_29418,type,
    v53569: state_type > $o ).

tff(pred_def_29419,type,
    v53671: state_type > $o ).

tff(pred_def_29420,type,
    v5991: state_type > $o ).

tff(pred_def_29421,type,
    v5989: state_type > $o ).

tff(pred_def_29422,type,
    v5987: ( state_type * $int ) > $o ).

tff(pred_def_29423,type,
    v53673: ( state_type * $int ) > $o ).

tff(pred_def_29424,type,
    v53672: ( state_type * $int ) > $o ).

tff(pred_def_29425,type,
    v53674: ( state_type * $int ) > $o ).

tff(pred_def_29426,type,
    v53675: ( state_type * $int ) > $o ).

tff(pred_def_29427,type,
    v5985: ( state_type * $int ) > $o ).

tff(pred_def_29428,type,
    v5983: ( state_type * $int ) > $o ).

tff(pred_def_29429,type,
    v5981: ( state_type * $int ) > $o ).

tff(pred_def_29430,type,
    v5979: ( state_type * $int ) > $o ).

tff(pred_def_29431,type,
    v5977: ( state_type * $int ) > $o ).

tff(pred_def_29432,type,
    v5975: ( state_type * $int ) > $o ).

tff(pred_def_29433,type,
    v5973: state_type > $o ).

tff(pred_def_29434,type,
    v5971: state_type > $o ).

tff(pred_def_29435,type,
    v53713: state_type > $o ).

tff(pred_def_29436,type,
    v53711: state_type > $o ).

tff(pred_def_29437,type,
    v53710: state_type > $o ).

tff(pred_def_29438,type,
    v53709: ( state_type * $int ) > $o ).

tff(pred_def_29439,type,
    v53707: state_type > $o ).

tff(pred_def_29440,type,
    v53705: state_type > $o ).

tff(pred_def_29441,type,
    v53725: state_type > $o ).

tff(pred_def_29442,type,
    v53723: state_type > $o ).

tff(pred_def_29443,type,
    v53722: state_type > $o ).

tff(pred_def_29444,type,
    v53721: ( state_type * $int ) > $o ).

tff(pred_def_29445,type,
    v53719: state_type > $o ).

tff(pred_def_29446,type,
    v53717: state_type > $o ).

tff(pred_def_29447,type,
    v53737: state_type > $o ).

tff(pred_def_29448,type,
    v53735: state_type > $o ).

tff(pred_def_29449,type,
    v53734: state_type > $o ).

tff(pred_def_29450,type,
    v53733: ( state_type * $int ) > $o ).

tff(pred_def_29451,type,
    v53731: state_type > $o ).

tff(pred_def_29452,type,
    v53729: state_type > $o ).

tff(pred_def_29453,type,
    v53741: state_type > $o ).

tff(pred_def_29454,type,
    v53703: state_type > $o ).

tff(pred_def_29455,type,
    v53701: state_type > $o ).

tff(pred_def_29456,type,
    v53699: state_type > $o ).

tff(pred_def_29457,type,
    v53697: state_type > $o ).

tff(pred_def_29458,type,
    v53695: state_type > $o ).

tff(pred_def_29459,type,
    v53761: state_type > $o ).

tff(pred_def_29460,type,
    v53759: state_type > $o ).

tff(pred_def_29461,type,
    v53758: state_type > $o ).

tff(pred_def_29462,type,
    v53757: ( state_type * $int ) > $o ).

tff(pred_def_29463,type,
    v53755: state_type > $o ).

tff(pred_def_29464,type,
    v53753: state_type > $o ).

tff(pred_def_29465,type,
    v53773: state_type > $o ).

tff(pred_def_29466,type,
    v53771: state_type > $o ).

tff(pred_def_29467,type,
    v53770: state_type > $o ).

tff(pred_def_29468,type,
    v53769: ( state_type * $int ) > $o ).

tff(pred_def_29469,type,
    v53767: state_type > $o ).

tff(pred_def_29470,type,
    v53765: state_type > $o ).

tff(pred_def_29471,type,
    v53785: state_type > $o ).

tff(pred_def_29472,type,
    v53783: state_type > $o ).

tff(pred_def_29473,type,
    v53782: state_type > $o ).

tff(pred_def_29474,type,
    v53781: ( state_type * $int ) > $o ).

tff(pred_def_29475,type,
    v53779: state_type > $o ).

tff(pred_def_29476,type,
    v53777: state_type > $o ).

tff(pred_def_29477,type,
    v53789: state_type > $o ).

tff(pred_def_29478,type,
    v53751: state_type > $o ).

tff(pred_def_29479,type,
    v53749: state_type > $o ).

tff(pred_def_29480,type,
    v53747: state_type > $o ).

tff(pred_def_29481,type,
    v53745: state_type > $o ).

tff(pred_def_29482,type,
    v53743: state_type > $o ).

tff(pred_def_29483,type,
    v53809: state_type > $o ).

tff(pred_def_29484,type,
    v53807: state_type > $o ).

tff(pred_def_29485,type,
    v53806: state_type > $o ).

tff(pred_def_29486,type,
    v53805: ( state_type * $int ) > $o ).

tff(pred_def_29487,type,
    v53803: state_type > $o ).

tff(pred_def_29488,type,
    v53801: state_type > $o ).

tff(pred_def_29489,type,
    v53821: state_type > $o ).

tff(pred_def_29490,type,
    v53819: state_type > $o ).

tff(pred_def_29491,type,
    v53818: state_type > $o ).

tff(pred_def_29492,type,
    v53817: ( state_type * $int ) > $o ).

tff(pred_def_29493,type,
    v53815: state_type > $o ).

tff(pred_def_29494,type,
    v53813: state_type > $o ).

tff(pred_def_29495,type,
    v53833: state_type > $o ).

tff(pred_def_29496,type,
    v53831: state_type > $o ).

tff(pred_def_29497,type,
    v53830: state_type > $o ).

tff(pred_def_29498,type,
    v53829: ( state_type * $int ) > $o ).

tff(pred_def_29499,type,
    v53827: state_type > $o ).

tff(pred_def_29500,type,
    v53825: state_type > $o ).

tff(pred_def_29501,type,
    v53837: state_type > $o ).

tff(pred_def_29502,type,
    v53799: state_type > $o ).

tff(pred_def_29503,type,
    v53797: state_type > $o ).

tff(pred_def_29504,type,
    v53795: state_type > $o ).

tff(pred_def_29505,type,
    v53793: state_type > $o ).

tff(pred_def_29506,type,
    v53791: state_type > $o ).

tff(pred_def_29507,type,
    v53839: state_type > $o ).

tff(pred_def_29508,type,
    v53693: state_type > $o ).

tff(pred_def_29509,type,
    v53691: state_type > $o ).

tff(pred_def_29510,type,
    v53689: state_type > $o ).

tff(pred_def_29511,type,
    v53687: state_type > $o ).

tff(pred_def_29512,type,
    v53685: state_type > $o ).

tff(pred_def_29513,type,
    v53869: state_type > $o ).

tff(pred_def_29514,type,
    v53867: state_type > $o ).

tff(pred_def_29515,type,
    v53866: state_type > $o ).

tff(pred_def_29516,type,
    v53865: ( state_type * $int ) > $o ).

tff(pred_def_29517,type,
    v53863: state_type > $o ).

tff(pred_def_29518,type,
    v53861: state_type > $o ).

tff(pred_def_29519,type,
    v53881: state_type > $o ).

tff(pred_def_29520,type,
    v53879: state_type > $o ).

tff(pred_def_29521,type,
    v53878: state_type > $o ).

tff(pred_def_29522,type,
    v53877: ( state_type * $int ) > $o ).

tff(pred_def_29523,type,
    v53875: state_type > $o ).

tff(pred_def_29524,type,
    v53873: state_type > $o ).

tff(pred_def_29525,type,
    v53893: state_type > $o ).

tff(pred_def_29526,type,
    v53891: state_type > $o ).

tff(pred_def_29527,type,
    v53890: state_type > $o ).

tff(pred_def_29528,type,
    v53889: ( state_type * $int ) > $o ).

tff(pred_def_29529,type,
    v53887: state_type > $o ).

tff(pred_def_29530,type,
    v53885: state_type > $o ).

tff(pred_def_29531,type,
    v53897: state_type > $o ).

tff(pred_def_29532,type,
    v53859: state_type > $o ).

tff(pred_def_29533,type,
    v53857: state_type > $o ).

tff(pred_def_29534,type,
    v53855: state_type > $o ).

tff(pred_def_29535,type,
    v53853: state_type > $o ).

tff(pred_def_29536,type,
    v53851: state_type > $o ).

tff(pred_def_29537,type,
    v53917: state_type > $o ).

tff(pred_def_29538,type,
    v53915: state_type > $o ).

tff(pred_def_29539,type,
    v53914: state_type > $o ).

tff(pred_def_29540,type,
    v53913: ( state_type * $int ) > $o ).

tff(pred_def_29541,type,
    v53911: state_type > $o ).

tff(pred_def_29542,type,
    v53909: state_type > $o ).

tff(pred_def_29543,type,
    v53929: state_type > $o ).

tff(pred_def_29544,type,
    v53927: state_type > $o ).

tff(pred_def_29545,type,
    v53926: state_type > $o ).

tff(pred_def_29546,type,
    v53925: ( state_type * $int ) > $o ).

tff(pred_def_29547,type,
    v53923: state_type > $o ).

tff(pred_def_29548,type,
    v53921: state_type > $o ).

tff(pred_def_29549,type,
    v53941: state_type > $o ).

tff(pred_def_29550,type,
    v53939: state_type > $o ).

tff(pred_def_29551,type,
    v53938: state_type > $o ).

tff(pred_def_29552,type,
    v53937: ( state_type * $int ) > $o ).

tff(pred_def_29553,type,
    v53935: state_type > $o ).

tff(pred_def_29554,type,
    v53933: state_type > $o ).

tff(pred_def_29555,type,
    v53945: state_type > $o ).

tff(pred_def_29556,type,
    v53907: state_type > $o ).

tff(pred_def_29557,type,
    v53905: state_type > $o ).

tff(pred_def_29558,type,
    v53903: state_type > $o ).

tff(pred_def_29559,type,
    v53901: state_type > $o ).

tff(pred_def_29560,type,
    v53899: state_type > $o ).

tff(pred_def_29561,type,
    v53965: state_type > $o ).

tff(pred_def_29562,type,
    v53963: state_type > $o ).

tff(pred_def_29563,type,
    v53962: state_type > $o ).

tff(pred_def_29564,type,
    v53961: ( state_type * $int ) > $o ).

tff(pred_def_29565,type,
    v53959: state_type > $o ).

tff(pred_def_29566,type,
    v53957: state_type > $o ).

tff(pred_def_29567,type,
    v53977: state_type > $o ).

tff(pred_def_29568,type,
    v53975: state_type > $o ).

tff(pred_def_29569,type,
    v53974: state_type > $o ).

tff(pred_def_29570,type,
    v53973: ( state_type * $int ) > $o ).

tff(pred_def_29571,type,
    v53971: state_type > $o ).

tff(pred_def_29572,type,
    v53969: state_type > $o ).

tff(pred_def_29573,type,
    v53983: state_type > $o ).

tff(pred_def_29574,type,
    v53981: state_type > $o ).

tff(pred_def_29575,type,
    v53985: state_type > $o ).

tff(pred_def_29576,type,
    v53955: state_type > $o ).

tff(pred_def_29577,type,
    v53953: state_type > $o ).

tff(pred_def_29578,type,
    v53951: state_type > $o ).

tff(pred_def_29579,type,
    v53949: state_type > $o ).

tff(pred_def_29580,type,
    v53947: state_type > $o ).

tff(pred_def_29581,type,
    v53987: state_type > $o ).

tff(pred_def_29582,type,
    v53849: state_type > $o ).

tff(pred_def_29583,type,
    v53847: state_type > $o ).

tff(pred_def_29584,type,
    v53845: state_type > $o ).

tff(pred_def_29585,type,
    v53843: state_type > $o ).

tff(pred_def_29586,type,
    v53841: state_type > $o ).

tff(pred_def_29587,type,
    v53997: state_type > $o ).

tff(pred_def_29588,type,
    v53995: state_type > $o ).

tff(pred_def_29589,type,
    v53994: state_type > $o ).

tff(pred_def_29590,type,
    v53993: ( state_type * $int ) > $o ).

tff(pred_def_29591,type,
    v53991: state_type > $o ).

tff(pred_def_29592,type,
    v53989: state_type > $o ).

tff(pred_def_29593,type,
    v54001: state_type > $o ).

tff(pred_def_29594,type,
    v53683: state_type > $o ).

tff(pred_def_29595,type,
    v53681: state_type > $o ).

tff(pred_def_29596,type,
    v53679: state_type > $o ).

tff(pred_def_29597,type,
    v53677: state_type > $o ).

tff(pred_def_29598,type,
    v54003: state_type > $o ).

tff(pred_def_29599,type,
    v5969: state_type > $o ).

tff(pred_def_29600,type,
    v5967: state_type > $o ).

tff(pred_def_29601,type,
    v5965: state_type > $o ).

tff(pred_def_29602,type,
    v5963: state_type > $o ).

tff(pred_def_29603,type,
    v5961: state_type > $o ).

tff(pred_def_29604,type,
    v54051: state_type > $o ).

tff(pred_def_29605,type,
    v54049: state_type > $o ).

tff(pred_def_29606,type,
    v54048: state_type > $o ).

tff(pred_def_29607,type,
    v54047: ( state_type * $int ) > $o ).

tff(pred_def_29608,type,
    v54045: state_type > $o ).

tff(pred_def_29609,type,
    v54043: state_type > $o ).

tff(pred_def_29610,type,
    v54063: state_type > $o ).

tff(pred_def_29611,type,
    v54061: state_type > $o ).

tff(pred_def_29612,type,
    v54060: state_type > $o ).

tff(pred_def_29613,type,
    v54059: ( state_type * $int ) > $o ).

tff(pred_def_29614,type,
    v54057: state_type > $o ).

tff(pred_def_29615,type,
    v54055: state_type > $o ).

tff(pred_def_29616,type,
    v54075: state_type > $o ).

tff(pred_def_29617,type,
    v54073: state_type > $o ).

tff(pred_def_29618,type,
    v54072: state_type > $o ).

tff(pred_def_29619,type,
    v54071: ( state_type * $int ) > $o ).

tff(pred_def_29620,type,
    v54069: state_type > $o ).

tff(pred_def_29621,type,
    v54067: state_type > $o ).

tff(pred_def_29622,type,
    v54079: state_type > $o ).

tff(pred_def_29623,type,
    v54041: state_type > $o ).

tff(pred_def_29624,type,
    v54039: state_type > $o ).

tff(pred_def_29625,type,
    v54037: state_type > $o ).

tff(pred_def_29626,type,
    v54035: state_type > $o ).

tff(pred_def_29627,type,
    v54033: state_type > $o ).

tff(pred_def_29628,type,
    v54099: state_type > $o ).

tff(pred_def_29629,type,
    v54097: state_type > $o ).

tff(pred_def_29630,type,
    v54096: state_type > $o ).

tff(pred_def_29631,type,
    v54095: ( state_type * $int ) > $o ).

tff(pred_def_29632,type,
    v54093: state_type > $o ).

tff(pred_def_29633,type,
    v54091: state_type > $o ).

tff(pred_def_29634,type,
    v54111: state_type > $o ).

tff(pred_def_29635,type,
    v54109: state_type > $o ).

tff(pred_def_29636,type,
    v54108: state_type > $o ).

tff(pred_def_29637,type,
    v54107: ( state_type * $int ) > $o ).

tff(pred_def_29638,type,
    v54105: state_type > $o ).

tff(pred_def_29639,type,
    v54103: state_type > $o ).

tff(pred_def_29640,type,
    v54123: state_type > $o ).

tff(pred_def_29641,type,
    v54121: state_type > $o ).

tff(pred_def_29642,type,
    v54120: state_type > $o ).

tff(pred_def_29643,type,
    v54119: ( state_type * $int ) > $o ).

tff(pred_def_29644,type,
    v54117: state_type > $o ).

tff(pred_def_29645,type,
    v54115: state_type > $o ).

tff(pred_def_29646,type,
    v54127: state_type > $o ).

tff(pred_def_29647,type,
    v54089: state_type > $o ).

tff(pred_def_29648,type,
    v54087: state_type > $o ).

tff(pred_def_29649,type,
    v54085: state_type > $o ).

tff(pred_def_29650,type,
    v54083: state_type > $o ).

tff(pred_def_29651,type,
    v54081: state_type > $o ).

tff(pred_def_29652,type,
    v54147: state_type > $o ).

tff(pred_def_29653,type,
    v54145: state_type > $o ).

tff(pred_def_29654,type,
    v54144: state_type > $o ).

tff(pred_def_29655,type,
    v54143: ( state_type * $int ) > $o ).

tff(pred_def_29656,type,
    v54141: state_type > $o ).

tff(pred_def_29657,type,
    v54139: state_type > $o ).

tff(pred_def_29658,type,
    v54159: state_type > $o ).

tff(pred_def_29659,type,
    v54157: state_type > $o ).

tff(pred_def_29660,type,
    v54156: state_type > $o ).

tff(pred_def_29661,type,
    v54155: ( state_type * $int ) > $o ).

tff(pred_def_29662,type,
    v54153: state_type > $o ).

tff(pred_def_29663,type,
    v54151: state_type > $o ).

tff(pred_def_29664,type,
    v54171: state_type > $o ).

tff(pred_def_29665,type,
    v54169: state_type > $o ).

tff(pred_def_29666,type,
    v54168: state_type > $o ).

tff(pred_def_29667,type,
    v54167: ( state_type * $int ) > $o ).

tff(pred_def_29668,type,
    v54165: state_type > $o ).

tff(pred_def_29669,type,
    v54163: state_type > $o ).

tff(pred_def_29670,type,
    v54175: state_type > $o ).

tff(pred_def_29671,type,
    v54137: state_type > $o ).

tff(pred_def_29672,type,
    v54135: state_type > $o ).

tff(pred_def_29673,type,
    v54133: state_type > $o ).

tff(pred_def_29674,type,
    v54131: state_type > $o ).

tff(pred_def_29675,type,
    v54129: state_type > $o ).

tff(pred_def_29676,type,
    v54177: state_type > $o ).

tff(pred_def_29677,type,
    v54031: state_type > $o ).

tff(pred_def_29678,type,
    v54029: state_type > $o ).

tff(pred_def_29679,type,
    v54027: state_type > $o ).

tff(pred_def_29680,type,
    v54025: state_type > $o ).

tff(pred_def_29681,type,
    v54023: state_type > $o ).

tff(pred_def_29682,type,
    v54207: state_type > $o ).

tff(pred_def_29683,type,
    v54205: state_type > $o ).

tff(pred_def_29684,type,
    v54204: state_type > $o ).

tff(pred_def_29685,type,
    v54203: ( state_type * $int ) > $o ).

tff(pred_def_29686,type,
    v54201: state_type > $o ).

tff(pred_def_29687,type,
    v54199: state_type > $o ).

tff(pred_def_29688,type,
    v54219: state_type > $o ).

tff(pred_def_29689,type,
    v54217: state_type > $o ).

tff(pred_def_29690,type,
    v54216: state_type > $o ).

tff(pred_def_29691,type,
    v54215: ( state_type * $int ) > $o ).

tff(pred_def_29692,type,
    v54213: state_type > $o ).

tff(pred_def_29693,type,
    v54211: state_type > $o ).

tff(pred_def_29694,type,
    v54231: state_type > $o ).

tff(pred_def_29695,type,
    v54229: state_type > $o ).

tff(pred_def_29696,type,
    v54228: state_type > $o ).

tff(pred_def_29697,type,
    v54227: ( state_type * $int ) > $o ).

tff(pred_def_29698,type,
    v54225: state_type > $o ).

tff(pred_def_29699,type,
    v54223: state_type > $o ).

tff(pred_def_29700,type,
    v54235: state_type > $o ).

tff(pred_def_29701,type,
    v54197: state_type > $o ).

tff(pred_def_29702,type,
    v54195: state_type > $o ).

tff(pred_def_29703,type,
    v54193: state_type > $o ).

tff(pred_def_29704,type,
    v54191: state_type > $o ).

tff(pred_def_29705,type,
    v54189: state_type > $o ).

tff(pred_def_29706,type,
    v54255: state_type > $o ).

tff(pred_def_29707,type,
    v54253: state_type > $o ).

tff(pred_def_29708,type,
    v54252: state_type > $o ).

tff(pred_def_29709,type,
    v54251: ( state_type * $int ) > $o ).

tff(pred_def_29710,type,
    v54249: state_type > $o ).

tff(pred_def_29711,type,
    v54247: state_type > $o ).

tff(pred_def_29712,type,
    v54267: state_type > $o ).

tff(pred_def_29713,type,
    v54265: state_type > $o ).

tff(pred_def_29714,type,
    v54264: state_type > $o ).

tff(pred_def_29715,type,
    v54263: ( state_type * $int ) > $o ).

tff(pred_def_29716,type,
    v54261: state_type > $o ).

tff(pred_def_29717,type,
    v54259: state_type > $o ).

tff(pred_def_29718,type,
    v54279: state_type > $o ).

tff(pred_def_29719,type,
    v54277: state_type > $o ).

tff(pred_def_29720,type,
    v54276: state_type > $o ).

tff(pred_def_29721,type,
    v54275: ( state_type * $int ) > $o ).

tff(pred_def_29722,type,
    v54273: state_type > $o ).

tff(pred_def_29723,type,
    v54271: state_type > $o ).

tff(pred_def_29724,type,
    v54283: state_type > $o ).

tff(pred_def_29725,type,
    v54245: state_type > $o ).

tff(pred_def_29726,type,
    v54243: state_type > $o ).

tff(pred_def_29727,type,
    v54241: state_type > $o ).

tff(pred_def_29728,type,
    v54239: state_type > $o ).

tff(pred_def_29729,type,
    v54237: state_type > $o ).

tff(pred_def_29730,type,
    v54303: state_type > $o ).

tff(pred_def_29731,type,
    v54301: state_type > $o ).

tff(pred_def_29732,type,
    v54300: state_type > $o ).

tff(pred_def_29733,type,
    v54299: ( state_type * $int ) > $o ).

tff(pred_def_29734,type,
    v54297: state_type > $o ).

tff(pred_def_29735,type,
    v54295: state_type > $o ).

tff(pred_def_29736,type,
    v54315: state_type > $o ).

tff(pred_def_29737,type,
    v54313: state_type > $o ).

tff(pred_def_29738,type,
    v54312: state_type > $o ).

tff(pred_def_29739,type,
    v54311: ( state_type * $int ) > $o ).

tff(pred_def_29740,type,
    v54309: state_type > $o ).

tff(pred_def_29741,type,
    v54307: state_type > $o ).

tff(pred_def_29742,type,
    v54321: state_type > $o ).

tff(pred_def_29743,type,
    v54319: state_type > $o ).

tff(pred_def_29744,type,
    v54323: state_type > $o ).

tff(pred_def_29745,type,
    v54293: state_type > $o ).

tff(pred_def_29746,type,
    v54291: state_type > $o ).

tff(pred_def_29747,type,
    v54289: state_type > $o ).

tff(pred_def_29748,type,
    v54287: state_type > $o ).

tff(pred_def_29749,type,
    v54285: state_type > $o ).

tff(pred_def_29750,type,
    v54325: state_type > $o ).

tff(pred_def_29751,type,
    v54187: state_type > $o ).

tff(pred_def_29752,type,
    v54185: state_type > $o ).

tff(pred_def_29753,type,
    v54183: state_type > $o ).

tff(pred_def_29754,type,
    v54181: state_type > $o ).

tff(pred_def_29755,type,
    v54179: state_type > $o ).

tff(pred_def_29756,type,
    v54335: state_type > $o ).

tff(pred_def_29757,type,
    v54333: state_type > $o ).

tff(pred_def_29758,type,
    v54332: state_type > $o ).

tff(pred_def_29759,type,
    v54331: ( state_type * $int ) > $o ).

tff(pred_def_29760,type,
    v54329: state_type > $o ).

tff(pred_def_29761,type,
    v54327: state_type > $o ).

tff(pred_def_29762,type,
    v54339: state_type > $o ).

tff(pred_def_29763,type,
    v54021: state_type > $o ).

tff(pred_def_29764,type,
    v54019: state_type > $o ).

tff(pred_def_29765,type,
    v54017: state_type > $o ).

tff(pred_def_29766,type,
    v54015: state_type > $o ).

tff(pred_def_29767,type,
    v54377: state_type > $o ).

tff(pred_def_29768,type,
    v54375: state_type > $o ).

tff(pred_def_29769,type,
    v54374: state_type > $o ).

tff(pred_def_29770,type,
    v54373: ( state_type * $int ) > $o ).

tff(pred_def_29771,type,
    v54371: state_type > $o ).

tff(pred_def_29772,type,
    v54369: state_type > $o ).

tff(pred_def_29773,type,
    v54389: state_type > $o ).

tff(pred_def_29774,type,
    v54387: state_type > $o ).

tff(pred_def_29775,type,
    v54386: state_type > $o ).

tff(pred_def_29776,type,
    v54385: ( state_type * $int ) > $o ).

tff(pred_def_29777,type,
    v54383: state_type > $o ).

tff(pred_def_29778,type,
    v54381: state_type > $o ).

tff(pred_def_29779,type,
    v54401: state_type > $o ).

tff(pred_def_29780,type,
    v54399: state_type > $o ).

tff(pred_def_29781,type,
    v54398: state_type > $o ).

tff(pred_def_29782,type,
    v54397: ( state_type * $int ) > $o ).

tff(pred_def_29783,type,
    v54395: state_type > $o ).

tff(pred_def_29784,type,
    v54393: state_type > $o ).

tff(pred_def_29785,type,
    v54405: state_type > $o ).

tff(pred_def_29786,type,
    v54367: state_type > $o ).

tff(pred_def_29787,type,
    v54365: state_type > $o ).

tff(pred_def_29788,type,
    v54363: state_type > $o ).

tff(pred_def_29789,type,
    v54361: state_type > $o ).

tff(pred_def_29790,type,
    v54359: state_type > $o ).

tff(pred_def_29791,type,
    v54425: state_type > $o ).

tff(pred_def_29792,type,
    v54423: state_type > $o ).

tff(pred_def_29793,type,
    v54422: state_type > $o ).

tff(pred_def_29794,type,
    v54421: ( state_type * $int ) > $o ).

tff(pred_def_29795,type,
    v54419: state_type > $o ).

tff(pred_def_29796,type,
    v54417: state_type > $o ).

tff(pred_def_29797,type,
    v54437: state_type > $o ).

tff(pred_def_29798,type,
    v54435: state_type > $o ).

tff(pred_def_29799,type,
    v54434: state_type > $o ).

tff(pred_def_29800,type,
    v54433: ( state_type * $int ) > $o ).

tff(pred_def_29801,type,
    v54431: state_type > $o ).

tff(pred_def_29802,type,
    v54429: state_type > $o ).

tff(pred_def_29803,type,
    v54449: state_type > $o ).

tff(pred_def_29804,type,
    v54447: state_type > $o ).

tff(pred_def_29805,type,
    v54446: state_type > $o ).

tff(pred_def_29806,type,
    v54445: ( state_type * $int ) > $o ).

tff(pred_def_29807,type,
    v54443: state_type > $o ).

tff(pred_def_29808,type,
    v54441: state_type > $o ).

tff(pred_def_29809,type,
    v54453: state_type > $o ).

tff(pred_def_29810,type,
    v54415: state_type > $o ).

tff(pred_def_29811,type,
    v54413: state_type > $o ).

tff(pred_def_29812,type,
    v54411: state_type > $o ).

tff(pred_def_29813,type,
    v54409: state_type > $o ).

tff(pred_def_29814,type,
    v54407: state_type > $o ).

tff(pred_def_29815,type,
    v54473: state_type > $o ).

tff(pred_def_29816,type,
    v54471: state_type > $o ).

tff(pred_def_29817,type,
    v54470: state_type > $o ).

tff(pred_def_29818,type,
    v54469: ( state_type * $int ) > $o ).

tff(pred_def_29819,type,
    v54467: state_type > $o ).

tff(pred_def_29820,type,
    v54465: state_type > $o ).

tff(pred_def_29821,type,
    v54485: state_type > $o ).

tff(pred_def_29822,type,
    v54483: state_type > $o ).

tff(pred_def_29823,type,
    v54482: state_type > $o ).

tff(pred_def_29824,type,
    v54481: ( state_type * $int ) > $o ).

tff(pred_def_29825,type,
    v54479: state_type > $o ).

tff(pred_def_29826,type,
    v54477: state_type > $o ).

tff(pred_def_29827,type,
    v54497: state_type > $o ).

tff(pred_def_29828,type,
    v54495: state_type > $o ).

tff(pred_def_29829,type,
    v54494: state_type > $o ).

tff(pred_def_29830,type,
    v54493: ( state_type * $int ) > $o ).

tff(pred_def_29831,type,
    v54491: state_type > $o ).

tff(pred_def_29832,type,
    v54489: state_type > $o ).

tff(pred_def_29833,type,
    v54501: state_type > $o ).

tff(pred_def_29834,type,
    v54463: state_type > $o ).

tff(pred_def_29835,type,
    v54461: state_type > $o ).

tff(pred_def_29836,type,
    v54459: state_type > $o ).

tff(pred_def_29837,type,
    v54457: state_type > $o ).

tff(pred_def_29838,type,
    v54455: state_type > $o ).

tff(pred_def_29839,type,
    v54503: state_type > $o ).

tff(pred_def_29840,type,
    v54357: state_type > $o ).

tff(pred_def_29841,type,
    v54355: state_type > $o ).

tff(pred_def_29842,type,
    v54353: state_type > $o ).

tff(pred_def_29843,type,
    v54351: state_type > $o ).

tff(pred_def_29844,type,
    v54349: state_type > $o ).

tff(pred_def_29845,type,
    v54533: state_type > $o ).

tff(pred_def_29846,type,
    v54531: state_type > $o ).

tff(pred_def_29847,type,
    v54530: state_type > $o ).

tff(pred_def_29848,type,
    v54529: ( state_type * $int ) > $o ).

tff(pred_def_29849,type,
    v54527: state_type > $o ).

tff(pred_def_29850,type,
    v54525: state_type > $o ).

tff(pred_def_29851,type,
    v54545: state_type > $o ).

tff(pred_def_29852,type,
    v54543: state_type > $o ).

tff(pred_def_29853,type,
    v54542: state_type > $o ).

tff(pred_def_29854,type,
    v54541: ( state_type * $int ) > $o ).

tff(pred_def_29855,type,
    v54539: state_type > $o ).

tff(pred_def_29856,type,
    v54537: state_type > $o ).

tff(pred_def_29857,type,
    v54557: state_type > $o ).

tff(pred_def_29858,type,
    v54555: state_type > $o ).

tff(pred_def_29859,type,
    v54554: state_type > $o ).

tff(pred_def_29860,type,
    v54553: ( state_type * $int ) > $o ).

tff(pred_def_29861,type,
    v54551: state_type > $o ).

tff(pred_def_29862,type,
    v54549: state_type > $o ).

tff(pred_def_29863,type,
    v54561: state_type > $o ).

tff(pred_def_29864,type,
    v54523: state_type > $o ).

tff(pred_def_29865,type,
    v54521: state_type > $o ).

tff(pred_def_29866,type,
    v54519: state_type > $o ).

tff(pred_def_29867,type,
    v54517: state_type > $o ).

tff(pred_def_29868,type,
    v54515: state_type > $o ).

tff(pred_def_29869,type,
    v54581: state_type > $o ).

tff(pred_def_29870,type,
    v54579: state_type > $o ).

tff(pred_def_29871,type,
    v54578: state_type > $o ).

tff(pred_def_29872,type,
    v54577: ( state_type * $int ) > $o ).

tff(pred_def_29873,type,
    v54575: state_type > $o ).

tff(pred_def_29874,type,
    v54573: state_type > $o ).

tff(pred_def_29875,type,
    v54593: state_type > $o ).

tff(pred_def_29876,type,
    v54591: state_type > $o ).

tff(pred_def_29877,type,
    v54590: state_type > $o ).

tff(pred_def_29878,type,
    v54589: ( state_type * $int ) > $o ).

tff(pred_def_29879,type,
    v54587: state_type > $o ).

tff(pred_def_29880,type,
    v54585: state_type > $o ).

tff(pred_def_29881,type,
    v54605: state_type > $o ).

tff(pred_def_29882,type,
    v54603: state_type > $o ).

tff(pred_def_29883,type,
    v54602: state_type > $o ).

tff(pred_def_29884,type,
    v54601: ( state_type * $int ) > $o ).

tff(pred_def_29885,type,
    v54599: state_type > $o ).

tff(pred_def_29886,type,
    v54597: state_type > $o ).

tff(pred_def_29887,type,
    v54609: state_type > $o ).

tff(pred_def_29888,type,
    v54571: state_type > $o ).

tff(pred_def_29889,type,
    v54569: state_type > $o ).

tff(pred_def_29890,type,
    v54567: state_type > $o ).

tff(pred_def_29891,type,
    v54565: state_type > $o ).

tff(pred_def_29892,type,
    v54563: state_type > $o ).

tff(pred_def_29893,type,
    v54629: state_type > $o ).

tff(pred_def_29894,type,
    v54627: state_type > $o ).

tff(pred_def_29895,type,
    v54626: state_type > $o ).

tff(pred_def_29896,type,
    v54625: ( state_type * $int ) > $o ).

tff(pred_def_29897,type,
    v54623: state_type > $o ).

tff(pred_def_29898,type,
    v54621: state_type > $o ).

tff(pred_def_29899,type,
    v54641: state_type > $o ).

tff(pred_def_29900,type,
    v54639: state_type > $o ).

tff(pred_def_29901,type,
    v54638: state_type > $o ).

tff(pred_def_29902,type,
    v54637: ( state_type * $int ) > $o ).

tff(pred_def_29903,type,
    v54635: state_type > $o ).

tff(pred_def_29904,type,
    v54633: state_type > $o ).

tff(pred_def_29905,type,
    v54647: state_type > $o ).

tff(pred_def_29906,type,
    v54645: state_type > $o ).

tff(pred_def_29907,type,
    v54649: state_type > $o ).

tff(pred_def_29908,type,
    v54619: state_type > $o ).

tff(pred_def_29909,type,
    v54617: state_type > $o ).

tff(pred_def_29910,type,
    v54615: state_type > $o ).

tff(pred_def_29911,type,
    v54613: state_type > $o ).

tff(pred_def_29912,type,
    v54611: state_type > $o ).

tff(pred_def_29913,type,
    v54651: state_type > $o ).

tff(pred_def_29914,type,
    v54513: state_type > $o ).

tff(pred_def_29915,type,
    v54511: state_type > $o ).

tff(pred_def_29916,type,
    v54509: state_type > $o ).

tff(pred_def_29917,type,
    v54507: state_type > $o ).

tff(pred_def_29918,type,
    v54505: state_type > $o ).

tff(pred_def_29919,type,
    v54661: state_type > $o ).

tff(pred_def_29920,type,
    v54659: state_type > $o ).

tff(pred_def_29921,type,
    v54658: state_type > $o ).

tff(pred_def_29922,type,
    v54657: ( state_type * $int ) > $o ).

tff(pred_def_29923,type,
    v54655: state_type > $o ).

tff(pred_def_29924,type,
    v54653: state_type > $o ).

tff(pred_def_29925,type,
    v54665: state_type > $o ).

tff(pred_def_29926,type,
    v54347: state_type > $o ).

tff(pred_def_29927,type,
    v54345: state_type > $o ).

tff(pred_def_29928,type,
    v54343: state_type > $o ).

tff(pred_def_29929,type,
    v54341: state_type > $o ).

tff(pred_def_29930,type,
    v54667: state_type > $o ).

tff(pred_def_29931,type,
    v54013: state_type > $o ).

tff(pred_def_29932,type,
    v54011: state_type > $o ).

tff(pred_def_29933,type,
    v54009: state_type > $o ).

tff(pred_def_29934,type,
    v54007: state_type > $o ).

tff(pred_def_29935,type,
    v54005: state_type > $o ).

tff(pred_def_29936,type,
    v54669: state_type > $o ).

tff(pred_def_29937,type,
    v5959: state_type > $o ).

tff(pred_def_29938,type,
    v5957: state_type > $o ).

tff(pred_def_29939,type,
    v5955: state_type > $o ).

tff(pred_def_29940,type,
    v5953: state_type > $o ).

tff(pred_def_29941,type,
    v5951: state_type > $o ).

tff(pred_def_29942,type,
    v5949: state_type > $o ).

tff(pred_def_29943,type,
    v5947: state_type > $o ).

tff(pred_def_29944,type,
    v5945: state_type > $o ).

tff(pred_def_29945,type,
    v5943: state_type > $o ).

tff(pred_def_29946,type,
    v5941: state_type > $o ).

tff(pred_def_29947,type,
    v54744: ( state_type * $int ) > $o ).

tff(pred_def_29948,type,
    v54742: ( state_type * $int ) > $o ).

tff(pred_def_29949,type,
    v54748: state_type > $o ).

tff(pred_def_29950,type,
    v54746: state_type > $o ).

tff(pred_def_29951,type,
    v54752: ( state_type * $int ) > $o ).

tff(pred_def_29952,type,
    v54750: ( state_type * $int ) > $o ).

tff(pred_def_29953,type,
    v54756: state_type > $o ).

tff(pred_def_29954,type,
    v54754: state_type > $o ).

tff(pred_def_29955,type,
    v54760: state_type > $o ).

tff(pred_def_29956,type,
    v54759: ( state_type * $int ) > $o ).

tff(pred_def_29957,type,
    v54758: ( state_type * $int ) > $o ).

tff(pred_def_29958,type,
    v54763: state_type > $o ).

tff(pred_def_29959,type,
    v54762: ( state_type * $int ) > $o ).

tff(pred_def_29960,type,
    v54761: ( state_type * $int ) > $o ).

tff(pred_def_29961,type,
    v54757: ( state_type * $int ) > $o ).

tff(pred_def_29962,type,
    v54740: ( state_type * $int ) > $o ).

tff(pred_def_29963,type,
    v54738: ( state_type * $int ) > $o ).

tff(pred_def_29964,type,
    v54769: state_type > $o ).

tff(pred_def_29965,type,
    v54767: state_type > $o ).

tff(pred_def_29966,type,
    v54766: state_type > $o ).

tff(pred_def_29967,type,
    v54765: ( state_type * $int ) > $o ).

tff(pred_def_29968,type,
    v54735: state_type > $o ).

tff(pred_def_29969,type,
    v54733: state_type > $o ).

tff(pred_def_29970,type,
    v54784: ( state_type * $int ) > $o ).

tff(pred_def_29971,type,
    v54782: ( state_type * $int ) > $o ).

tff(pred_def_29972,type,
    v54788: state_type > $o ).

tff(pred_def_29973,type,
    v54786: state_type > $o ).

tff(pred_def_29974,type,
    v54792: ( state_type * $int ) > $o ).

tff(pred_def_29975,type,
    v54790: ( state_type * $int ) > $o ).

tff(pred_def_29976,type,
    v54796: state_type > $o ).

tff(pred_def_29977,type,
    v54794: state_type > $o ).

tff(pred_def_29978,type,
    v54800: state_type > $o ).

tff(pred_def_29979,type,
    v54799: ( state_type * $int ) > $o ).

tff(pred_def_29980,type,
    v54798: ( state_type * $int ) > $o ).

tff(pred_def_29981,type,
    v54803: state_type > $o ).

tff(pred_def_29982,type,
    v54802: ( state_type * $int ) > $o ).

tff(pred_def_29983,type,
    v54801: ( state_type * $int ) > $o ).

tff(pred_def_29984,type,
    v54797: ( state_type * $int ) > $o ).

tff(pred_def_29985,type,
    v54780: ( state_type * $int ) > $o ).

tff(pred_def_29986,type,
    v54778: ( state_type * $int ) > $o ).

tff(pred_def_29987,type,
    v54809: state_type > $o ).

tff(pred_def_29988,type,
    v54807: state_type > $o ).

tff(pred_def_29989,type,
    v54806: state_type > $o ).

tff(pred_def_29990,type,
    v54805: ( state_type * $int ) > $o ).

tff(pred_def_29991,type,
    v54775: state_type > $o ).

tff(pred_def_29992,type,
    v54773: state_type > $o ).

tff(pred_def_29993,type,
    v54824: ( state_type * $int ) > $o ).

tff(pred_def_29994,type,
    v54822: ( state_type * $int ) > $o ).

tff(pred_def_29995,type,
    v54828: state_type > $o ).

tff(pred_def_29996,type,
    v54826: state_type > $o ).

tff(pred_def_29997,type,
    v54832: ( state_type * $int ) > $o ).

tff(pred_def_29998,type,
    v54830: ( state_type * $int ) > $o ).

tff(pred_def_29999,type,
    v54836: state_type > $o ).

tff(pred_def_30000,type,
    v54834: state_type > $o ).

tff(pred_def_30001,type,
    v54840: state_type > $o ).

tff(pred_def_30002,type,
    v54839: ( state_type * $int ) > $o ).

tff(pred_def_30003,type,
    v54838: ( state_type * $int ) > $o ).

tff(pred_def_30004,type,
    v54843: state_type > $o ).

tff(pred_def_30005,type,
    v54842: ( state_type * $int ) > $o ).

tff(pred_def_30006,type,
    v54841: ( state_type * $int ) > $o ).

tff(pred_def_30007,type,
    v54837: ( state_type * $int ) > $o ).

tff(pred_def_30008,type,
    v54820: ( state_type * $int ) > $o ).

tff(pred_def_30009,type,
    v54818: ( state_type * $int ) > $o ).

tff(pred_def_30010,type,
    v54849: state_type > $o ).

tff(pred_def_30011,type,
    v54847: state_type > $o ).

tff(pred_def_30012,type,
    v54846: state_type > $o ).

tff(pred_def_30013,type,
    v54845: ( state_type * $int ) > $o ).

tff(pred_def_30014,type,
    v54815: state_type > $o ).

tff(pred_def_30015,type,
    v54813: state_type > $o ).

tff(pred_def_30016,type,
    v54853: state_type > $o ).

tff(pred_def_30017,type,
    v54731: state_type > $o ).

tff(pred_def_30018,type,
    v54729: state_type > $o ).

tff(pred_def_30019,type,
    v54727: state_type > $o ).

tff(pred_def_30020,type,
    v54725: state_type > $o ).

tff(pred_def_30021,type,
    v54723: state_type > $o ).

tff(pred_def_30022,type,
    v54876: ( state_type * $int ) > $o ).

tff(pred_def_30023,type,
    v54874: ( state_type * $int ) > $o ).

tff(pred_def_30024,type,
    v54880: state_type > $o ).

tff(pred_def_30025,type,
    v54878: state_type > $o ).

tff(pred_def_30026,type,
    v54884: ( state_type * $int ) > $o ).

tff(pred_def_30027,type,
    v54882: ( state_type * $int ) > $o ).

tff(pred_def_30028,type,
    v54888: state_type > $o ).

tff(pred_def_30029,type,
    v54886: state_type > $o ).

tff(pred_def_30030,type,
    v54892: state_type > $o ).

tff(pred_def_30031,type,
    v54891: ( state_type * $int ) > $o ).

tff(pred_def_30032,type,
    v54890: ( state_type * $int ) > $o ).

tff(pred_def_30033,type,
    v54895: state_type > $o ).

tff(pred_def_30034,type,
    v54894: ( state_type * $int ) > $o ).

tff(pred_def_30035,type,
    v54893: ( state_type * $int ) > $o ).

tff(pred_def_30036,type,
    v54889: ( state_type * $int ) > $o ).

tff(pred_def_30037,type,
    v54872: ( state_type * $int ) > $o ).

tff(pred_def_30038,type,
    v54870: ( state_type * $int ) > $o ).

tff(pred_def_30039,type,
    v54901: state_type > $o ).

tff(pred_def_30040,type,
    v54899: state_type > $o ).

tff(pred_def_30041,type,
    v54898: state_type > $o ).

tff(pred_def_30042,type,
    v54897: ( state_type * $int ) > $o ).

tff(pred_def_30043,type,
    v54867: state_type > $o ).

tff(pred_def_30044,type,
    v54865: state_type > $o ).

tff(pred_def_30045,type,
    v54916: ( state_type * $int ) > $o ).

tff(pred_def_30046,type,
    v54914: ( state_type * $int ) > $o ).

tff(pred_def_30047,type,
    v54920: state_type > $o ).

tff(pred_def_30048,type,
    v54918: state_type > $o ).

tff(pred_def_30049,type,
    v54924: ( state_type * $int ) > $o ).

tff(pred_def_30050,type,
    v54922: ( state_type * $int ) > $o ).

tff(pred_def_30051,type,
    v54928: state_type > $o ).

tff(pred_def_30052,type,
    v54926: state_type > $o ).

tff(pred_def_30053,type,
    v54932: state_type > $o ).

tff(pred_def_30054,type,
    v54931: ( state_type * $int ) > $o ).

tff(pred_def_30055,type,
    v54930: ( state_type * $int ) > $o ).

tff(pred_def_30056,type,
    v54935: state_type > $o ).

tff(pred_def_30057,type,
    v54934: ( state_type * $int ) > $o ).

tff(pred_def_30058,type,
    v54933: ( state_type * $int ) > $o ).

tff(pred_def_30059,type,
    v54929: ( state_type * $int ) > $o ).

tff(pred_def_30060,type,
    v54912: ( state_type * $int ) > $o ).

tff(pred_def_30061,type,
    v54910: ( state_type * $int ) > $o ).

tff(pred_def_30062,type,
    v54941: state_type > $o ).

tff(pred_def_30063,type,
    v54939: state_type > $o ).

tff(pred_def_30064,type,
    v54938: state_type > $o ).

tff(pred_def_30065,type,
    v54937: ( state_type * $int ) > $o ).

tff(pred_def_30066,type,
    v54907: state_type > $o ).

tff(pred_def_30067,type,
    v54905: state_type > $o ).

tff(pred_def_30068,type,
    v54956: ( state_type * $int ) > $o ).

tff(pred_def_30069,type,
    v54954: ( state_type * $int ) > $o ).

tff(pred_def_30070,type,
    v54960: state_type > $o ).

tff(pred_def_30071,type,
    v54958: state_type > $o ).

tff(pred_def_30072,type,
    v54964: ( state_type * $int ) > $o ).

tff(pred_def_30073,type,
    v54962: ( state_type * $int ) > $o ).

tff(pred_def_30074,type,
    v54968: state_type > $o ).

tff(pred_def_30075,type,
    v54966: state_type > $o ).

tff(pred_def_30076,type,
    v54972: state_type > $o ).

tff(pred_def_30077,type,
    v54971: ( state_type * $int ) > $o ).

tff(pred_def_30078,type,
    v54970: ( state_type * $int ) > $o ).

tff(pred_def_30079,type,
    v54975: state_type > $o ).

tff(pred_def_30080,type,
    v54974: ( state_type * $int ) > $o ).

tff(pred_def_30081,type,
    v54973: ( state_type * $int ) > $o ).

tff(pred_def_30082,type,
    v54969: ( state_type * $int ) > $o ).

tff(pred_def_30083,type,
    v54952: ( state_type * $int ) > $o ).

tff(pred_def_30084,type,
    v54950: ( state_type * $int ) > $o ).

tff(pred_def_30085,type,
    v54981: state_type > $o ).

tff(pred_def_30086,type,
    v54979: state_type > $o ).

tff(pred_def_30087,type,
    v54978: state_type > $o ).

tff(pred_def_30088,type,
    v54977: ( state_type * $int ) > $o ).

tff(pred_def_30089,type,
    v54947: state_type > $o ).

tff(pred_def_30090,type,
    v54945: state_type > $o ).

tff(pred_def_30091,type,
    v54985: state_type > $o ).

tff(pred_def_30092,type,
    v54863: state_type > $o ).

tff(pred_def_30093,type,
    v54861: state_type > $o ).

tff(pred_def_30094,type,
    v54859: state_type > $o ).

tff(pred_def_30095,type,
    v54857: state_type > $o ).

tff(pred_def_30096,type,
    v54855: state_type > $o ).

tff(pred_def_30097,type,
    v55008: ( state_type * $int ) > $o ).

tff(pred_def_30098,type,
    v55006: ( state_type * $int ) > $o ).

tff(pred_def_30099,type,
    v55012: state_type > $o ).

tff(pred_def_30100,type,
    v55010: state_type > $o ).

tff(pred_def_30101,type,
    v55016: ( state_type * $int ) > $o ).

tff(pred_def_30102,type,
    v55014: ( state_type * $int ) > $o ).

tff(pred_def_30103,type,
    v55020: state_type > $o ).

tff(pred_def_30104,type,
    v55018: state_type > $o ).

tff(pred_def_30105,type,
    v55024: state_type > $o ).

tff(pred_def_30106,type,
    v55023: ( state_type * $int ) > $o ).

tff(pred_def_30107,type,
    v55022: ( state_type * $int ) > $o ).

tff(pred_def_30108,type,
    v55027: state_type > $o ).

tff(pred_def_30109,type,
    v55026: ( state_type * $int ) > $o ).

tff(pred_def_30110,type,
    v55025: ( state_type * $int ) > $o ).

tff(pred_def_30111,type,
    v55021: ( state_type * $int ) > $o ).

tff(pred_def_30112,type,
    v55004: ( state_type * $int ) > $o ).

tff(pred_def_30113,type,
    v55002: ( state_type * $int ) > $o ).

tff(pred_def_30114,type,
    v55033: state_type > $o ).

tff(pred_def_30115,type,
    v55031: state_type > $o ).

tff(pred_def_30116,type,
    v55030: state_type > $o ).

tff(pred_def_30117,type,
    v55029: ( state_type * $int ) > $o ).

tff(pred_def_30118,type,
    v54999: state_type > $o ).

tff(pred_def_30119,type,
    v54997: state_type > $o ).

tff(pred_def_30120,type,
    v55048: ( state_type * $int ) > $o ).

tff(pred_def_30121,type,
    v55046: ( state_type * $int ) > $o ).

tff(pred_def_30122,type,
    v55052: state_type > $o ).

tff(pred_def_30123,type,
    v55050: state_type > $o ).

tff(pred_def_30124,type,
    v55056: ( state_type * $int ) > $o ).

tff(pred_def_30125,type,
    v55054: ( state_type * $int ) > $o ).

tff(pred_def_30126,type,
    v55060: state_type > $o ).

tff(pred_def_30127,type,
    v55058: state_type > $o ).

tff(pred_def_30128,type,
    v55064: state_type > $o ).

tff(pred_def_30129,type,
    v55063: ( state_type * $int ) > $o ).

tff(pred_def_30130,type,
    v55062: ( state_type * $int ) > $o ).

tff(pred_def_30131,type,
    v55067: state_type > $o ).

tff(pred_def_30132,type,
    v55066: ( state_type * $int ) > $o ).

tff(pred_def_30133,type,
    v55065: ( state_type * $int ) > $o ).

tff(pred_def_30134,type,
    v55061: ( state_type * $int ) > $o ).

tff(pred_def_30135,type,
    v55044: ( state_type * $int ) > $o ).

tff(pred_def_30136,type,
    v55042: ( state_type * $int ) > $o ).

tff(pred_def_30137,type,
    v55073: state_type > $o ).

tff(pred_def_30138,type,
    v55071: state_type > $o ).

tff(pred_def_30139,type,
    v55070: state_type > $o ).

tff(pred_def_30140,type,
    v55069: ( state_type * $int ) > $o ).

tff(pred_def_30141,type,
    v55039: state_type > $o ).

tff(pred_def_30142,type,
    v55037: state_type > $o ).

tff(pred_def_30143,type,
    v55088: ( state_type * $int ) > $o ).

tff(pred_def_30144,type,
    v55086: ( state_type * $int ) > $o ).

tff(pred_def_30145,type,
    v55092: state_type > $o ).

tff(pred_def_30146,type,
    v55090: state_type > $o ).

tff(pred_def_30147,type,
    v55096: ( state_type * $int ) > $o ).

tff(pred_def_30148,type,
    v55094: ( state_type * $int ) > $o ).

tff(pred_def_30149,type,
    v55100: state_type > $o ).

tff(pred_def_30150,type,
    v55098: state_type > $o ).

tff(pred_def_30151,type,
    v55104: state_type > $o ).

tff(pred_def_30152,type,
    v55103: ( state_type * $int ) > $o ).

tff(pred_def_30153,type,
    v55102: ( state_type * $int ) > $o ).

tff(pred_def_30154,type,
    v55107: state_type > $o ).

tff(pred_def_30155,type,
    v55106: ( state_type * $int ) > $o ).

tff(pred_def_30156,type,
    v55105: ( state_type * $int ) > $o ).

tff(pred_def_30157,type,
    v55101: ( state_type * $int ) > $o ).

tff(pred_def_30158,type,
    v55084: ( state_type * $int ) > $o ).

tff(pred_def_30159,type,
    v55082: ( state_type * $int ) > $o ).

tff(pred_def_30160,type,
    v55113: state_type > $o ).

tff(pred_def_30161,type,
    v55111: state_type > $o ).

tff(pred_def_30162,type,
    v55110: state_type > $o ).

tff(pred_def_30163,type,
    v55109: ( state_type * $int ) > $o ).

tff(pred_def_30164,type,
    v55079: state_type > $o ).

tff(pred_def_30165,type,
    v55077: state_type > $o ).

tff(pred_def_30166,type,
    v55117: state_type > $o ).

tff(pred_def_30167,type,
    v54995: state_type > $o ).

tff(pred_def_30168,type,
    v54993: state_type > $o ).

tff(pred_def_30169,type,
    v54991: state_type > $o ).

tff(pred_def_30170,type,
    v54989: state_type > $o ).

tff(pred_def_30171,type,
    v54987: state_type > $o ).

tff(pred_def_30172,type,
    v55119: state_type > $o ).

tff(pred_def_30173,type,
    v54721: state_type > $o ).

tff(pred_def_30174,type,
    v54719: state_type > $o ).

tff(pred_def_30175,type,
    v54717: state_type > $o ).

tff(pred_def_30176,type,
    v54715: state_type > $o ).

tff(pred_def_30177,type,
    v54713: state_type > $o ).

tff(pred_def_30178,type,
    v55152: ( state_type * $int ) > $o ).

tff(pred_def_30179,type,
    v55150: ( state_type * $int ) > $o ).

tff(pred_def_30180,type,
    v55156: state_type > $o ).

tff(pred_def_30181,type,
    v55154: state_type > $o ).

tff(pred_def_30182,type,
    v55160: ( state_type * $int ) > $o ).

tff(pred_def_30183,type,
    v55158: ( state_type * $int ) > $o ).

tff(pred_def_30184,type,
    v55164: state_type > $o ).

tff(pred_def_30185,type,
    v55162: state_type > $o ).

tff(pred_def_30186,type,
    v55168: state_type > $o ).

tff(pred_def_30187,type,
    v55167: ( state_type * $int ) > $o ).

tff(pred_def_30188,type,
    v55166: ( state_type * $int ) > $o ).

tff(pred_def_30189,type,
    v55171: state_type > $o ).

tff(pred_def_30190,type,
    v55170: ( state_type * $int ) > $o ).

tff(pred_def_30191,type,
    v55169: ( state_type * $int ) > $o ).

tff(pred_def_30192,type,
    v55165: ( state_type * $int ) > $o ).

tff(pred_def_30193,type,
    v55148: ( state_type * $int ) > $o ).

tff(pred_def_30194,type,
    v55146: ( state_type * $int ) > $o ).

tff(pred_def_30195,type,
    v55177: state_type > $o ).

tff(pred_def_30196,type,
    v55175: state_type > $o ).

tff(pred_def_30197,type,
    v55174: state_type > $o ).

tff(pred_def_30198,type,
    v55173: ( state_type * $int ) > $o ).

tff(pred_def_30199,type,
    v55143: state_type > $o ).

tff(pred_def_30200,type,
    v55141: state_type > $o ).

tff(pred_def_30201,type,
    v55192: ( state_type * $int ) > $o ).

tff(pred_def_30202,type,
    v55190: ( state_type * $int ) > $o ).

tff(pred_def_30203,type,
    v55196: state_type > $o ).

tff(pred_def_30204,type,
    v55194: state_type > $o ).

tff(pred_def_30205,type,
    v55200: ( state_type * $int ) > $o ).

tff(pred_def_30206,type,
    v55198: ( state_type * $int ) > $o ).

tff(pred_def_30207,type,
    v55204: state_type > $o ).

tff(pred_def_30208,type,
    v55202: state_type > $o ).

tff(pred_def_30209,type,
    v55208: state_type > $o ).

tff(pred_def_30210,type,
    v55207: ( state_type * $int ) > $o ).

tff(pred_def_30211,type,
    v55206: ( state_type * $int ) > $o ).

tff(pred_def_30212,type,
    v55211: state_type > $o ).

tff(pred_def_30213,type,
    v55210: ( state_type * $int ) > $o ).

tff(pred_def_30214,type,
    v55209: ( state_type * $int ) > $o ).

tff(pred_def_30215,type,
    v55205: ( state_type * $int ) > $o ).

tff(pred_def_30216,type,
    v55188: ( state_type * $int ) > $o ).

tff(pred_def_30217,type,
    v55186: ( state_type * $int ) > $o ).

tff(pred_def_30218,type,
    v55217: state_type > $o ).

tff(pred_def_30219,type,
    v55215: state_type > $o ).

tff(pred_def_30220,type,
    v55214: state_type > $o ).

tff(pred_def_30221,type,
    v55213: ( state_type * $int ) > $o ).

tff(pred_def_30222,type,
    v55183: state_type > $o ).

tff(pred_def_30223,type,
    v55181: state_type > $o ).

tff(pred_def_30224,type,
    v55232: ( state_type * $int ) > $o ).

tff(pred_def_30225,type,
    v55230: ( state_type * $int ) > $o ).

tff(pred_def_30226,type,
    v55236: state_type > $o ).

tff(pred_def_30227,type,
    v55234: state_type > $o ).

tff(pred_def_30228,type,
    v55240: ( state_type * $int ) > $o ).

tff(pred_def_30229,type,
    v55238: ( state_type * $int ) > $o ).

tff(pred_def_30230,type,
    v55244: state_type > $o ).

tff(pred_def_30231,type,
    v55242: state_type > $o ).

tff(pred_def_30232,type,
    v55248: state_type > $o ).

tff(pred_def_30233,type,
    v55247: ( state_type * $int ) > $o ).

tff(pred_def_30234,type,
    v55246: ( state_type * $int ) > $o ).

tff(pred_def_30235,type,
    v55251: state_type > $o ).

tff(pred_def_30236,type,
    v55250: ( state_type * $int ) > $o ).

tff(pred_def_30237,type,
    v55249: ( state_type * $int ) > $o ).

tff(pred_def_30238,type,
    v55245: ( state_type * $int ) > $o ).

tff(pred_def_30239,type,
    v55228: ( state_type * $int ) > $o ).

tff(pred_def_30240,type,
    v55226: ( state_type * $int ) > $o ).

tff(pred_def_30241,type,
    v55257: state_type > $o ).

tff(pred_def_30242,type,
    v55255: state_type > $o ).

tff(pred_def_30243,type,
    v55254: state_type > $o ).

tff(pred_def_30244,type,
    v55253: ( state_type * $int ) > $o ).

tff(pred_def_30245,type,
    v55223: state_type > $o ).

tff(pred_def_30246,type,
    v55221: state_type > $o ).

tff(pred_def_30247,type,
    v55261: state_type > $o ).

tff(pred_def_30248,type,
    v55139: state_type > $o ).

tff(pred_def_30249,type,
    v55137: state_type > $o ).

tff(pred_def_30250,type,
    v55135: state_type > $o ).

tff(pred_def_30251,type,
    v55133: state_type > $o ).

tff(pred_def_30252,type,
    v55131: state_type > $o ).

tff(pred_def_30253,type,
    v55284: ( state_type * $int ) > $o ).

tff(pred_def_30254,type,
    v55282: ( state_type * $int ) > $o ).

tff(pred_def_30255,type,
    v55288: state_type > $o ).

tff(pred_def_30256,type,
    v55286: state_type > $o ).

tff(pred_def_30257,type,
    v55292: ( state_type * $int ) > $o ).

tff(pred_def_30258,type,
    v55290: ( state_type * $int ) > $o ).

tff(pred_def_30259,type,
    v55296: state_type > $o ).

tff(pred_def_30260,type,
    v55294: state_type > $o ).

tff(pred_def_30261,type,
    v55300: state_type > $o ).

tff(pred_def_30262,type,
    v55299: ( state_type * $int ) > $o ).

tff(pred_def_30263,type,
    v55298: ( state_type * $int ) > $o ).

tff(pred_def_30264,type,
    v55303: state_type > $o ).

tff(pred_def_30265,type,
    v55302: ( state_type * $int ) > $o ).

tff(pred_def_30266,type,
    v55301: ( state_type * $int ) > $o ).

tff(pred_def_30267,type,
    v55297: ( state_type * $int ) > $o ).

tff(pred_def_30268,type,
    v55280: ( state_type * $int ) > $o ).

tff(pred_def_30269,type,
    v55278: ( state_type * $int ) > $o ).

tff(pred_def_30270,type,
    v55309: state_type > $o ).

tff(pred_def_30271,type,
    v55307: state_type > $o ).

tff(pred_def_30272,type,
    v55306: state_type > $o ).

tff(pred_def_30273,type,
    v55305: ( state_type * $int ) > $o ).

tff(pred_def_30274,type,
    v55275: state_type > $o ).

tff(pred_def_30275,type,
    v55273: state_type > $o ).

tff(pred_def_30276,type,
    v55324: ( state_type * $int ) > $o ).

tff(pred_def_30277,type,
    v55322: ( state_type * $int ) > $o ).

tff(pred_def_30278,type,
    v55328: state_type > $o ).

tff(pred_def_30279,type,
    v55326: state_type > $o ).

tff(pred_def_30280,type,
    v55332: ( state_type * $int ) > $o ).

tff(pred_def_30281,type,
    v55330: ( state_type * $int ) > $o ).

tff(pred_def_30282,type,
    v55336: state_type > $o ).

tff(pred_def_30283,type,
    v55334: state_type > $o ).

tff(pred_def_30284,type,
    v55340: state_type > $o ).

tff(pred_def_30285,type,
    v55339: ( state_type * $int ) > $o ).

tff(pred_def_30286,type,
    v55338: ( state_type * $int ) > $o ).

tff(pred_def_30287,type,
    v55343: state_type > $o ).

tff(pred_def_30288,type,
    v55342: ( state_type * $int ) > $o ).

tff(pred_def_30289,type,
    v55341: ( state_type * $int ) > $o ).

tff(pred_def_30290,type,
    v55337: ( state_type * $int ) > $o ).

tff(pred_def_30291,type,
    v55320: ( state_type * $int ) > $o ).

tff(pred_def_30292,type,
    v55318: ( state_type * $int ) > $o ).

tff(pred_def_30293,type,
    v55349: state_type > $o ).

tff(pred_def_30294,type,
    v55347: state_type > $o ).

tff(pred_def_30295,type,
    v55346: state_type > $o ).

tff(pred_def_30296,type,
    v55345: ( state_type * $int ) > $o ).

tff(pred_def_30297,type,
    v55315: state_type > $o ).

tff(pred_def_30298,type,
    v55313: state_type > $o ).

tff(pred_def_30299,type,
    v55364: ( state_type * $int ) > $o ).

tff(pred_def_30300,type,
    v55362: ( state_type * $int ) > $o ).

tff(pred_def_30301,type,
    v55368: state_type > $o ).

tff(pred_def_30302,type,
    v55366: state_type > $o ).

tff(pred_def_30303,type,
    v55372: ( state_type * $int ) > $o ).

tff(pred_def_30304,type,
    v55370: ( state_type * $int ) > $o ).

tff(pred_def_30305,type,
    v55376: state_type > $o ).

tff(pred_def_30306,type,
    v55374: state_type > $o ).

tff(pred_def_30307,type,
    v55380: state_type > $o ).

tff(pred_def_30308,type,
    v55379: ( state_type * $int ) > $o ).

tff(pred_def_30309,type,
    v55378: ( state_type * $int ) > $o ).

tff(pred_def_30310,type,
    v55383: state_type > $o ).

tff(pred_def_30311,type,
    v55382: ( state_type * $int ) > $o ).

tff(pred_def_30312,type,
    v55381: ( state_type * $int ) > $o ).

tff(pred_def_30313,type,
    v55377: ( state_type * $int ) > $o ).

tff(pred_def_30314,type,
    v55360: ( state_type * $int ) > $o ).

tff(pred_def_30315,type,
    v55358: ( state_type * $int ) > $o ).

tff(pred_def_30316,type,
    v55389: state_type > $o ).

tff(pred_def_30317,type,
    v55387: state_type > $o ).

tff(pred_def_30318,type,
    v55386: state_type > $o ).

tff(pred_def_30319,type,
    v55385: ( state_type * $int ) > $o ).

tff(pred_def_30320,type,
    v55355: state_type > $o ).

tff(pred_def_30321,type,
    v55353: state_type > $o ).

tff(pred_def_30322,type,
    v55393: state_type > $o ).

tff(pred_def_30323,type,
    v55271: state_type > $o ).

tff(pred_def_30324,type,
    v55269: state_type > $o ).

tff(pred_def_30325,type,
    v55267: state_type > $o ).

tff(pred_def_30326,type,
    v55265: state_type > $o ).

tff(pred_def_30327,type,
    v55263: state_type > $o ).

tff(pred_def_30328,type,
    v55407: state_type > $o ).

tff(pred_def_30329,type,
    v55405: state_type > $o ).

tff(pred_def_30330,type,
    v55411: state_type > $o ).

tff(pred_def_30331,type,
    v55409: state_type > $o ).

tff(pred_def_30332,type,
    v55417: state_type > $o ).

tff(pred_def_30333,type,
    v55415: state_type > $o ).

tff(pred_def_30334,type,
    v55413: state_type > $o ).

tff(pred_def_30335,type,
    v55419: state_type > $o ).

tff(pred_def_30336,type,
    v55403: state_type > $o ).

tff(pred_def_30337,type,
    v55401: state_type > $o ).

tff(pred_def_30338,type,
    v55399: state_type > $o ).

tff(pred_def_30339,type,
    v55397: state_type > $o ).

tff(pred_def_30340,type,
    v55395: state_type > $o ).

tff(pred_def_30341,type,
    v55421: state_type > $o ).

tff(pred_def_30342,type,
    v55129: state_type > $o ).

tff(pred_def_30343,type,
    v55127: state_type > $o ).

tff(pred_def_30344,type,
    v55125: state_type > $o ).

tff(pred_def_30345,type,
    v55123: state_type > $o ).

tff(pred_def_30346,type,
    v55121: state_type > $o ).

tff(pred_def_30347,type,
    v55437: ( state_type * $int ) > $o ).

tff(pred_def_30348,type,
    v55435: ( state_type * $int ) > $o ).

tff(pred_def_30349,type,
    v55441: state_type > $o ).

tff(pred_def_30350,type,
    v55439: state_type > $o ).

tff(pred_def_30351,type,
    v55445: ( state_type * $int ) > $o ).

tff(pred_def_30352,type,
    v55443: ( state_type * $int ) > $o ).

tff(pred_def_30353,type,
    v55449: state_type > $o ).

tff(pred_def_30354,type,
    v55447: state_type > $o ).

tff(pred_def_30355,type,
    v55453: state_type > $o ).

tff(pred_def_30356,type,
    v55452: ( state_type * $int ) > $o ).

tff(pred_def_30357,type,
    v55451: ( state_type * $int ) > $o ).

tff(pred_def_30358,type,
    v55456: state_type > $o ).

tff(pred_def_30359,type,
    v55455: ( state_type * $int ) > $o ).

tff(pred_def_30360,type,
    v55454: ( state_type * $int ) > $o ).

tff(pred_def_30361,type,
    v55450: ( state_type * $int ) > $o ).

tff(pred_def_30362,type,
    v55433: ( state_type * $int ) > $o ).

tff(pred_def_30363,type,
    v55431: ( state_type * $int ) > $o ).

tff(pred_def_30364,type,
    v55462: state_type > $o ).

tff(pred_def_30365,type,
    v55460: state_type > $o ).

tff(pred_def_30366,type,
    v55459: state_type > $o ).

tff(pred_def_30367,type,
    v55458: ( state_type * $int ) > $o ).

tff(pred_def_30368,type,
    v55429: ( state_type * $int ) > $o ).

tff(pred_def_30369,type,
    v55427: ( state_type * $int ) > $o ).

tff(pred_def_30370,type,
    v55425: state_type > $o ).

tff(pred_def_30371,type,
    v55423: state_type > $o ).

tff(pred_def_30372,type,
    v55466: state_type > $o ).

tff(pred_def_30373,type,
    v54711: state_type > $o ).

tff(pred_def_30374,type,
    v54709: state_type > $o ).

tff(pred_def_30375,type,
    v54706: ( state_type * $int ) > $o ).

tff(pred_def_30376,type,
    v54704: state_type > $o ).

tff(pred_def_30377,type,
    v54702: state_type > $o ).

tff(pred_def_30378,type,
    v55504: state_type > $o ).

tff(pred_def_30379,type,
    v55502: state_type > $o ).

tff(pred_def_30380,type,
    v55501: state_type > $o ).

tff(pred_def_30381,type,
    v55500: ( state_type * $int ) > $o ).

tff(pred_def_30382,type,
    v55498: state_type > $o ).

tff(pred_def_30383,type,
    v55496: state_type > $o ).

tff(pred_def_30384,type,
    v55516: state_type > $o ).

tff(pred_def_30385,type,
    v55514: state_type > $o ).

tff(pred_def_30386,type,
    v55513: state_type > $o ).

tff(pred_def_30387,type,
    v55512: ( state_type * $int ) > $o ).

tff(pred_def_30388,type,
    v55510: state_type > $o ).

tff(pred_def_30389,type,
    v55508: state_type > $o ).

tff(pred_def_30390,type,
    v55528: state_type > $o ).

tff(pred_def_30391,type,
    v55526: state_type > $o ).

tff(pred_def_30392,type,
    v55525: state_type > $o ).

tff(pred_def_30393,type,
    v55524: ( state_type * $int ) > $o ).

tff(pred_def_30394,type,
    v55522: state_type > $o ).

tff(pred_def_30395,type,
    v55520: state_type > $o ).

tff(pred_def_30396,type,
    v55532: state_type > $o ).

tff(pred_def_30397,type,
    v55494: state_type > $o ).

tff(pred_def_30398,type,
    v55492: state_type > $o ).

tff(pred_def_30399,type,
    v55490: state_type > $o ).

tff(pred_def_30400,type,
    v55488: state_type > $o ).

tff(pred_def_30401,type,
    v55486: state_type > $o ).

tff(pred_def_30402,type,
    v55552: state_type > $o ).

tff(pred_def_30403,type,
    v55550: state_type > $o ).

tff(pred_def_30404,type,
    v55549: state_type > $o ).

tff(pred_def_30405,type,
    v55548: ( state_type * $int ) > $o ).

tff(pred_def_30406,type,
    v55546: state_type > $o ).

tff(pred_def_30407,type,
    v55544: state_type > $o ).

tff(pred_def_30408,type,
    v55564: state_type > $o ).

tff(pred_def_30409,type,
    v55562: state_type > $o ).

tff(pred_def_30410,type,
    v55561: state_type > $o ).

tff(pred_def_30411,type,
    v55560: ( state_type * $int ) > $o ).

tff(pred_def_30412,type,
    v55558: state_type > $o ).

tff(pred_def_30413,type,
    v55556: state_type > $o ).

tff(pred_def_30414,type,
    v55576: state_type > $o ).

tff(pred_def_30415,type,
    v55574: state_type > $o ).

tff(pred_def_30416,type,
    v55573: state_type > $o ).

tff(pred_def_30417,type,
    v55572: ( state_type * $int ) > $o ).

tff(pred_def_30418,type,
    v55570: state_type > $o ).

tff(pred_def_30419,type,
    v55568: state_type > $o ).

tff(pred_def_30420,type,
    v55580: state_type > $o ).

tff(pred_def_30421,type,
    v55542: state_type > $o ).

tff(pred_def_30422,type,
    v55540: state_type > $o ).

tff(pred_def_30423,type,
    v55538: state_type > $o ).

tff(pred_def_30424,type,
    v55536: state_type > $o ).

tff(pred_def_30425,type,
    v55534: state_type > $o ).

tff(pred_def_30426,type,
    v55600: state_type > $o ).

tff(pred_def_30427,type,
    v55598: state_type > $o ).

tff(pred_def_30428,type,
    v55597: state_type > $o ).

tff(pred_def_30429,type,
    v55596: ( state_type * $int ) > $o ).

tff(pred_def_30430,type,
    v55594: state_type > $o ).

tff(pred_def_30431,type,
    v55592: state_type > $o ).

tff(pred_def_30432,type,
    v55612: state_type > $o ).

tff(pred_def_30433,type,
    v55610: state_type > $o ).

tff(pred_def_30434,type,
    v55609: state_type > $o ).

tff(pred_def_30435,type,
    v55608: ( state_type * $int ) > $o ).

tff(pred_def_30436,type,
    v55606: state_type > $o ).

tff(pred_def_30437,type,
    v55604: state_type > $o ).

tff(pred_def_30438,type,
    v55624: state_type > $o ).

tff(pred_def_30439,type,
    v55622: state_type > $o ).

tff(pred_def_30440,type,
    v55621: state_type > $o ).

tff(pred_def_30441,type,
    v55620: ( state_type * $int ) > $o ).

tff(pred_def_30442,type,
    v55618: state_type > $o ).

tff(pred_def_30443,type,
    v55616: state_type > $o ).

tff(pred_def_30444,type,
    v55628: state_type > $o ).

tff(pred_def_30445,type,
    v55590: state_type > $o ).

tff(pred_def_30446,type,
    v55588: state_type > $o ).

tff(pred_def_30447,type,
    v55586: state_type > $o ).

tff(pred_def_30448,type,
    v55584: state_type > $o ).

tff(pred_def_30449,type,
    v55582: state_type > $o ).

tff(pred_def_30450,type,
    v55630: state_type > $o ).

tff(pred_def_30451,type,
    v55484: state_type > $o ).

tff(pred_def_30452,type,
    v55482: state_type > $o ).

tff(pred_def_30453,type,
    v55480: state_type > $o ).

tff(pred_def_30454,type,
    v55478: state_type > $o ).

tff(pred_def_30455,type,
    v55476: state_type > $o ).

tff(pred_def_30456,type,
    v55660: state_type > $o ).

tff(pred_def_30457,type,
    v55658: state_type > $o ).

tff(pred_def_30458,type,
    v55657: state_type > $o ).

tff(pred_def_30459,type,
    v55656: ( state_type * $int ) > $o ).

tff(pred_def_30460,type,
    v55654: state_type > $o ).

tff(pred_def_30461,type,
    v55652: state_type > $o ).

tff(pred_def_30462,type,
    v55672: state_type > $o ).

tff(pred_def_30463,type,
    v55670: state_type > $o ).

tff(pred_def_30464,type,
    v55669: state_type > $o ).

tff(pred_def_30465,type,
    v55668: ( state_type * $int ) > $o ).

tff(pred_def_30466,type,
    v55666: state_type > $o ).

tff(pred_def_30467,type,
    v55664: state_type > $o ).

tff(pred_def_30468,type,
    v55684: state_type > $o ).

tff(pred_def_30469,type,
    v55682: state_type > $o ).

tff(pred_def_30470,type,
    v55681: state_type > $o ).

tff(pred_def_30471,type,
    v55680: ( state_type * $int ) > $o ).

tff(pred_def_30472,type,
    v55678: state_type > $o ).

tff(pred_def_30473,type,
    v55676: state_type > $o ).

tff(pred_def_30474,type,
    v55688: state_type > $o ).

tff(pred_def_30475,type,
    v55650: state_type > $o ).

tff(pred_def_30476,type,
    v55648: state_type > $o ).

tff(pred_def_30477,type,
    v55646: state_type > $o ).

tff(pred_def_30478,type,
    v55644: state_type > $o ).

tff(pred_def_30479,type,
    v55642: state_type > $o ).

tff(pred_def_30480,type,
    v55708: state_type > $o ).

tff(pred_def_30481,type,
    v55706: state_type > $o ).

tff(pred_def_30482,type,
    v55705: state_type > $o ).

tff(pred_def_30483,type,
    v55704: ( state_type * $int ) > $o ).

tff(pred_def_30484,type,
    v55702: state_type > $o ).

tff(pred_def_30485,type,
    v55700: state_type > $o ).

tff(pred_def_30486,type,
    v55720: state_type > $o ).

tff(pred_def_30487,type,
    v55718: state_type > $o ).

tff(pred_def_30488,type,
    v55717: state_type > $o ).

tff(pred_def_30489,type,
    v55716: ( state_type * $int ) > $o ).

tff(pred_def_30490,type,
    v55714: state_type > $o ).

tff(pred_def_30491,type,
    v55712: state_type > $o ).

tff(pred_def_30492,type,
    v55732: state_type > $o ).

tff(pred_def_30493,type,
    v55730: state_type > $o ).

tff(pred_def_30494,type,
    v55729: state_type > $o ).

tff(pred_def_30495,type,
    v55728: ( state_type * $int ) > $o ).

tff(pred_def_30496,type,
    v55726: state_type > $o ).

tff(pred_def_30497,type,
    v55724: state_type > $o ).

tff(pred_def_30498,type,
    v55736: state_type > $o ).

tff(pred_def_30499,type,
    v55698: state_type > $o ).

tff(pred_def_30500,type,
    v55696: state_type > $o ).

tff(pred_def_30501,type,
    v55694: state_type > $o ).

tff(pred_def_30502,type,
    v55692: state_type > $o ).

tff(pred_def_30503,type,
    v55690: state_type > $o ).

tff(pred_def_30504,type,
    v55750: state_type > $o ).

tff(pred_def_30505,type,
    v55748: state_type > $o ).

tff(pred_def_30506,type,
    v55754: state_type > $o ).

tff(pred_def_30507,type,
    v55752: state_type > $o ).

tff(pred_def_30508,type,
    v55758: state_type > $o ).

tff(pred_def_30509,type,
    v55756: state_type > $o ).

tff(pred_def_30510,type,
    v55760: state_type > $o ).

tff(pred_def_30511,type,
    v55746: state_type > $o ).

tff(pred_def_30512,type,
    v55744: state_type > $o ).

tff(pred_def_30513,type,
    v55742: state_type > $o ).

tff(pred_def_30514,type,
    v55740: state_type > $o ).

tff(pred_def_30515,type,
    v55738: state_type > $o ).

tff(pred_def_30516,type,
    v55762: state_type > $o ).

tff(pred_def_30517,type,
    v55640: state_type > $o ).

tff(pred_def_30518,type,
    v55638: state_type > $o ).

tff(pred_def_30519,type,
    v55636: state_type > $o ).

tff(pred_def_30520,type,
    v55634: state_type > $o ).

tff(pred_def_30521,type,
    v55632: state_type > $o ).

tff(pred_def_30522,type,
    v55772: state_type > $o ).

tff(pred_def_30523,type,
    v55770: state_type > $o ).

tff(pred_def_30524,type,
    v55769: state_type > $o ).

tff(pred_def_30525,type,
    v55768: ( state_type * $int ) > $o ).

tff(pred_def_30526,type,
    v55766: state_type > $o ).

tff(pred_def_30527,type,
    v55764: state_type > $o ).

tff(pred_def_30528,type,
    v55776: state_type > $o ).

tff(pred_def_30529,type,
    v55474: state_type > $o ).

tff(pred_def_30530,type,
    v55472: state_type > $o ).

tff(pred_def_30531,type,
    v55470: state_type > $o ).

tff(pred_def_30532,type,
    v55468: state_type > $o ).

tff(pred_def_30533,type,
    v55778: state_type > $o ).

tff(pred_def_30534,type,
    v54700: state_type > $o ).

tff(pred_def_30535,type,
    v54698: state_type > $o ).

tff(pred_def_30536,type,
    v54696: state_type > $o ).

tff(pred_def_30537,type,
    v54694: state_type > $o ).

tff(pred_def_30538,type,
    v54692: state_type > $o ).

tff(pred_def_30539,type,
    v55826: state_type > $o ).

tff(pred_def_30540,type,
    v55824: state_type > $o ).

tff(pred_def_30541,type,
    v55823: state_type > $o ).

tff(pred_def_30542,type,
    v55822: ( state_type * $int ) > $o ).

tff(pred_def_30543,type,
    v55820: state_type > $o ).

tff(pred_def_30544,type,
    v55818: state_type > $o ).

tff(pred_def_30545,type,
    v55838: state_type > $o ).

tff(pred_def_30546,type,
    v55836: state_type > $o ).

tff(pred_def_30547,type,
    v55835: state_type > $o ).

tff(pred_def_30548,type,
    v55834: ( state_type * $int ) > $o ).

tff(pred_def_30549,type,
    v55832: state_type > $o ).

tff(pred_def_30550,type,
    v55830: state_type > $o ).

tff(pred_def_30551,type,
    v55850: state_type > $o ).

tff(pred_def_30552,type,
    v55848: state_type > $o ).

tff(pred_def_30553,type,
    v55847: state_type > $o ).

tff(pred_def_30554,type,
    v55846: ( state_type * $int ) > $o ).

tff(pred_def_30555,type,
    v55844: state_type > $o ).

tff(pred_def_30556,type,
    v55842: state_type > $o ).

tff(pred_def_30557,type,
    v55854: state_type > $o ).

tff(pred_def_30558,type,
    v55816: state_type > $o ).

tff(pred_def_30559,type,
    v55814: state_type > $o ).

tff(pred_def_30560,type,
    v55812: state_type > $o ).

tff(pred_def_30561,type,
    v55810: state_type > $o ).

tff(pred_def_30562,type,
    v55808: state_type > $o ).

tff(pred_def_30563,type,
    v55874: state_type > $o ).

tff(pred_def_30564,type,
    v55872: state_type > $o ).

tff(pred_def_30565,type,
    v55871: state_type > $o ).

tff(pred_def_30566,type,
    v55870: ( state_type * $int ) > $o ).

tff(pred_def_30567,type,
    v55868: state_type > $o ).

tff(pred_def_30568,type,
    v55866: state_type > $o ).

tff(pred_def_30569,type,
    v55886: state_type > $o ).

tff(pred_def_30570,type,
    v55884: state_type > $o ).

tff(pred_def_30571,type,
    v55883: state_type > $o ).

tff(pred_def_30572,type,
    v55882: ( state_type * $int ) > $o ).

tff(pred_def_30573,type,
    v55880: state_type > $o ).

tff(pred_def_30574,type,
    v55878: state_type > $o ).

tff(pred_def_30575,type,
    v55898: state_type > $o ).

tff(pred_def_30576,type,
    v55896: state_type > $o ).

tff(pred_def_30577,type,
    v55895: state_type > $o ).

tff(pred_def_30578,type,
    v55894: ( state_type * $int ) > $o ).

tff(pred_def_30579,type,
    v55892: state_type > $o ).

tff(pred_def_30580,type,
    v55890: state_type > $o ).

tff(pred_def_30581,type,
    v55902: state_type > $o ).

tff(pred_def_30582,type,
    v55864: state_type > $o ).

tff(pred_def_30583,type,
    v55862: state_type > $o ).

tff(pred_def_30584,type,
    v55860: state_type > $o ).

tff(pred_def_30585,type,
    v55858: state_type > $o ).

tff(pred_def_30586,type,
    v55856: state_type > $o ).

tff(pred_def_30587,type,
    v55922: state_type > $o ).

tff(pred_def_30588,type,
    v55920: state_type > $o ).

tff(pred_def_30589,type,
    v55919: state_type > $o ).

tff(pred_def_30590,type,
    v55918: ( state_type * $int ) > $o ).

tff(pred_def_30591,type,
    v55916: state_type > $o ).

tff(pred_def_30592,type,
    v55914: state_type > $o ).

tff(pred_def_30593,type,
    v55934: state_type > $o ).

tff(pred_def_30594,type,
    v55932: state_type > $o ).

tff(pred_def_30595,type,
    v55931: state_type > $o ).

tff(pred_def_30596,type,
    v55930: ( state_type * $int ) > $o ).

tff(pred_def_30597,type,
    v55928: state_type > $o ).

tff(pred_def_30598,type,
    v55926: state_type > $o ).

tff(pred_def_30599,type,
    v55946: state_type > $o ).

tff(pred_def_30600,type,
    v55944: state_type > $o ).

tff(pred_def_30601,type,
    v55943: state_type > $o ).

tff(pred_def_30602,type,
    v55942: ( state_type * $int ) > $o ).

tff(pred_def_30603,type,
    v55940: state_type > $o ).

tff(pred_def_30604,type,
    v55938: state_type > $o ).

tff(pred_def_30605,type,
    v55950: state_type > $o ).

tff(pred_def_30606,type,
    v55912: state_type > $o ).

tff(pred_def_30607,type,
    v55910: state_type > $o ).

tff(pred_def_30608,type,
    v55908: state_type > $o ).

tff(pred_def_30609,type,
    v55906: state_type > $o ).

tff(pred_def_30610,type,
    v55904: state_type > $o ).

tff(pred_def_30611,type,
    v55952: state_type > $o ).

tff(pred_def_30612,type,
    v55806: state_type > $o ).

tff(pred_def_30613,type,
    v55804: state_type > $o ).

tff(pred_def_30614,type,
    v55802: state_type > $o ).

tff(pred_def_30615,type,
    v55800: state_type > $o ).

tff(pred_def_30616,type,
    v55798: state_type > $o ).

tff(pred_def_30617,type,
    v55982: state_type > $o ).

tff(pred_def_30618,type,
    v55980: state_type > $o ).

tff(pred_def_30619,type,
    v55979: state_type > $o ).

tff(pred_def_30620,type,
    v55978: ( state_type * $int ) > $o ).

tff(pred_def_30621,type,
    v55976: state_type > $o ).

tff(pred_def_30622,type,
    v55974: state_type > $o ).

tff(pred_def_30623,type,
    v55994: state_type > $o ).

tff(pred_def_30624,type,
    v55992: state_type > $o ).

tff(pred_def_30625,type,
    v55991: state_type > $o ).

tff(pred_def_30626,type,
    v55990: ( state_type * $int ) > $o ).

tff(pred_def_30627,type,
    v55988: state_type > $o ).

tff(pred_def_30628,type,
    v55986: state_type > $o ).

tff(pred_def_30629,type,
    v56006: state_type > $o ).

tff(pred_def_30630,type,
    v56004: state_type > $o ).

tff(pred_def_30631,type,
    v56003: state_type > $o ).

tff(pred_def_30632,type,
    v56002: ( state_type * $int ) > $o ).

tff(pred_def_30633,type,
    v56000: state_type > $o ).

tff(pred_def_30634,type,
    v55998: state_type > $o ).

tff(pred_def_30635,type,
    v56010: state_type > $o ).

tff(pred_def_30636,type,
    v55972: state_type > $o ).

tff(pred_def_30637,type,
    v55970: state_type > $o ).

tff(pred_def_30638,type,
    v55968: state_type > $o ).

tff(pred_def_30639,type,
    v55966: state_type > $o ).

tff(pred_def_30640,type,
    v55964: state_type > $o ).

tff(pred_def_30641,type,
    v56030: state_type > $o ).

tff(pred_def_30642,type,
    v56028: state_type > $o ).

tff(pred_def_30643,type,
    v56027: state_type > $o ).

tff(pred_def_30644,type,
    v56026: ( state_type * $int ) > $o ).

tff(pred_def_30645,type,
    v56024: state_type > $o ).

tff(pred_def_30646,type,
    v56022: state_type > $o ).

tff(pred_def_30647,type,
    v56042: state_type > $o ).

tff(pred_def_30648,type,
    v56040: state_type > $o ).

tff(pred_def_30649,type,
    v56039: state_type > $o ).

tff(pred_def_30650,type,
    v56038: ( state_type * $int ) > $o ).

tff(pred_def_30651,type,
    v56036: state_type > $o ).

tff(pred_def_30652,type,
    v56034: state_type > $o ).

tff(pred_def_30653,type,
    v56054: state_type > $o ).

tff(pred_def_30654,type,
    v56052: state_type > $o ).

tff(pred_def_30655,type,
    v56051: state_type > $o ).

tff(pred_def_30656,type,
    v56050: ( state_type * $int ) > $o ).

tff(pred_def_30657,type,
    v56048: state_type > $o ).

tff(pred_def_30658,type,
    v56046: state_type > $o ).

tff(pred_def_30659,type,
    v56058: state_type > $o ).

tff(pred_def_30660,type,
    v56020: state_type > $o ).

tff(pred_def_30661,type,
    v56018: state_type > $o ).

tff(pred_def_30662,type,
    v56016: state_type > $o ).

tff(pred_def_30663,type,
    v56014: state_type > $o ).

tff(pred_def_30664,type,
    v56012: state_type > $o ).

tff(pred_def_30665,type,
    v56072: state_type > $o ).

tff(pred_def_30666,type,
    v56070: state_type > $o ).

tff(pred_def_30667,type,
    v56076: state_type > $o ).

tff(pred_def_30668,type,
    v56074: state_type > $o ).

tff(pred_def_30669,type,
    v56080: state_type > $o ).

tff(pred_def_30670,type,
    v56078: state_type > $o ).

tff(pred_def_30671,type,
    v56082: state_type > $o ).

tff(pred_def_30672,type,
    v56068: state_type > $o ).

tff(pred_def_30673,type,
    v56066: state_type > $o ).

tff(pred_def_30674,type,
    v56064: state_type > $o ).

tff(pred_def_30675,type,
    v56062: state_type > $o ).

tff(pred_def_30676,type,
    v56060: state_type > $o ).

tff(pred_def_30677,type,
    v56084: state_type > $o ).

tff(pred_def_30678,type,
    v55962: state_type > $o ).

tff(pred_def_30679,type,
    v55960: state_type > $o ).

tff(pred_def_30680,type,
    v55958: state_type > $o ).

tff(pred_def_30681,type,
    v55956: state_type > $o ).

tff(pred_def_30682,type,
    v55954: state_type > $o ).

tff(pred_def_30683,type,
    v56094: state_type > $o ).

tff(pred_def_30684,type,
    v56092: state_type > $o ).

tff(pred_def_30685,type,
    v56091: state_type > $o ).

tff(pred_def_30686,type,
    v56090: ( state_type * $int ) > $o ).

tff(pred_def_30687,type,
    v56088: state_type > $o ).

tff(pred_def_30688,type,
    v56086: state_type > $o ).

tff(pred_def_30689,type,
    v56098: state_type > $o ).

tff(pred_def_30690,type,
    v55796: state_type > $o ).

tff(pred_def_30691,type,
    v55794: state_type > $o ).

tff(pred_def_30692,type,
    v55792: state_type > $o ).

tff(pred_def_30693,type,
    v55790: state_type > $o ).

tff(pred_def_30694,type,
    v56136: state_type > $o ).

tff(pred_def_30695,type,
    v56134: state_type > $o ).

tff(pred_def_30696,type,
    v56133: state_type > $o ).

tff(pred_def_30697,type,
    v56132: ( state_type * $int ) > $o ).

tff(pred_def_30698,type,
    v56130: state_type > $o ).

tff(pred_def_30699,type,
    v56128: state_type > $o ).

tff(pred_def_30700,type,
    v56148: state_type > $o ).

tff(pred_def_30701,type,
    v56146: state_type > $o ).

tff(pred_def_30702,type,
    v56145: state_type > $o ).

tff(pred_def_30703,type,
    v56144: ( state_type * $int ) > $o ).

tff(pred_def_30704,type,
    v56142: state_type > $o ).

tff(pred_def_30705,type,
    v56140: state_type > $o ).

tff(pred_def_30706,type,
    v56160: state_type > $o ).

tff(pred_def_30707,type,
    v56158: state_type > $o ).

tff(pred_def_30708,type,
    v56157: state_type > $o ).

tff(pred_def_30709,type,
    v56156: ( state_type * $int ) > $o ).

tff(pred_def_30710,type,
    v56154: state_type > $o ).

tff(pred_def_30711,type,
    v56152: state_type > $o ).

tff(pred_def_30712,type,
    v56164: state_type > $o ).

tff(pred_def_30713,type,
    v56126: state_type > $o ).

tff(pred_def_30714,type,
    v56124: state_type > $o ).

tff(pred_def_30715,type,
    v56122: state_type > $o ).

tff(pred_def_30716,type,
    v56120: state_type > $o ).

tff(pred_def_30717,type,
    v56118: state_type > $o ).

tff(pred_def_30718,type,
    v56184: state_type > $o ).

tff(pred_def_30719,type,
    v56182: state_type > $o ).

tff(pred_def_30720,type,
    v56181: state_type > $o ).

tff(pred_def_30721,type,
    v56180: ( state_type * $int ) > $o ).

tff(pred_def_30722,type,
    v56178: state_type > $o ).

tff(pred_def_30723,type,
    v56176: state_type > $o ).

tff(pred_def_30724,type,
    v56196: state_type > $o ).

tff(pred_def_30725,type,
    v56194: state_type > $o ).

tff(pred_def_30726,type,
    v56193: state_type > $o ).

tff(pred_def_30727,type,
    v56192: ( state_type * $int ) > $o ).

tff(pred_def_30728,type,
    v56190: state_type > $o ).

tff(pred_def_30729,type,
    v56188: state_type > $o ).

tff(pred_def_30730,type,
    v56208: state_type > $o ).

tff(pred_def_30731,type,
    v56206: state_type > $o ).

tff(pred_def_30732,type,
    v56205: state_type > $o ).

tff(pred_def_30733,type,
    v56204: ( state_type * $int ) > $o ).

tff(pred_def_30734,type,
    v56202: state_type > $o ).

tff(pred_def_30735,type,
    v56200: state_type > $o ).

tff(pred_def_30736,type,
    v56212: state_type > $o ).

tff(pred_def_30737,type,
    v56174: state_type > $o ).

tff(pred_def_30738,type,
    v56172: state_type > $o ).

tff(pred_def_30739,type,
    v56170: state_type > $o ).

tff(pred_def_30740,type,
    v56168: state_type > $o ).

tff(pred_def_30741,type,
    v56166: state_type > $o ).

tff(pred_def_30742,type,
    v56232: state_type > $o ).

tff(pred_def_30743,type,
    v56230: state_type > $o ).

tff(pred_def_30744,type,
    v56229: state_type > $o ).

tff(pred_def_30745,type,
    v56228: ( state_type * $int ) > $o ).

tff(pred_def_30746,type,
    v56226: state_type > $o ).

tff(pred_def_30747,type,
    v56224: state_type > $o ).

tff(pred_def_30748,type,
    v56244: state_type > $o ).

tff(pred_def_30749,type,
    v56242: state_type > $o ).

tff(pred_def_30750,type,
    v56241: state_type > $o ).

tff(pred_def_30751,type,
    v56240: ( state_type * $int ) > $o ).

tff(pred_def_30752,type,
    v56238: state_type > $o ).

tff(pred_def_30753,type,
    v56236: state_type > $o ).

tff(pred_def_30754,type,
    v56256: state_type > $o ).

tff(pred_def_30755,type,
    v56254: state_type > $o ).

tff(pred_def_30756,type,
    v56253: state_type > $o ).

tff(pred_def_30757,type,
    v56252: ( state_type * $int ) > $o ).

tff(pred_def_30758,type,
    v56250: state_type > $o ).

tff(pred_def_30759,type,
    v56248: state_type > $o ).

tff(pred_def_30760,type,
    v56260: state_type > $o ).

tff(pred_def_30761,type,
    v56222: state_type > $o ).

tff(pred_def_30762,type,
    v56220: state_type > $o ).

tff(pred_def_30763,type,
    v56218: state_type > $o ).

tff(pred_def_30764,type,
    v56216: state_type > $o ).

tff(pred_def_30765,type,
    v56214: state_type > $o ).

tff(pred_def_30766,type,
    v56262: state_type > $o ).

tff(pred_def_30767,type,
    v56116: state_type > $o ).

tff(pred_def_30768,type,
    v56114: state_type > $o ).

tff(pred_def_30769,type,
    v56112: state_type > $o ).

tff(pred_def_30770,type,
    v56110: state_type > $o ).

tff(pred_def_30771,type,
    v56108: state_type > $o ).

tff(pred_def_30772,type,
    v56292: state_type > $o ).

tff(pred_def_30773,type,
    v56290: state_type > $o ).

tff(pred_def_30774,type,
    v56289: state_type > $o ).

tff(pred_def_30775,type,
    v56288: ( state_type * $int ) > $o ).

tff(pred_def_30776,type,
    v56286: state_type > $o ).

tff(pred_def_30777,type,
    v56284: state_type > $o ).

tff(pred_def_30778,type,
    v56304: state_type > $o ).

tff(pred_def_30779,type,
    v56302: state_type > $o ).

tff(pred_def_30780,type,
    v56301: state_type > $o ).

tff(pred_def_30781,type,
    v56300: ( state_type * $int ) > $o ).

tff(pred_def_30782,type,
    v56298: state_type > $o ).

tff(pred_def_30783,type,
    v56296: state_type > $o ).

tff(pred_def_30784,type,
    v56316: state_type > $o ).

tff(pred_def_30785,type,
    v56314: state_type > $o ).

tff(pred_def_30786,type,
    v56313: state_type > $o ).

tff(pred_def_30787,type,
    v56312: ( state_type * $int ) > $o ).

tff(pred_def_30788,type,
    v56310: state_type > $o ).

tff(pred_def_30789,type,
    v56308: state_type > $o ).

tff(pred_def_30790,type,
    v56320: state_type > $o ).

tff(pred_def_30791,type,
    v56282: state_type > $o ).

tff(pred_def_30792,type,
    v56280: state_type > $o ).

tff(pred_def_30793,type,
    v56278: state_type > $o ).

tff(pred_def_30794,type,
    v56276: state_type > $o ).

tff(pred_def_30795,type,
    v56274: state_type > $o ).

tff(pred_def_30796,type,
    v56340: state_type > $o ).

tff(pred_def_30797,type,
    v56338: state_type > $o ).

tff(pred_def_30798,type,
    v56337: state_type > $o ).

tff(pred_def_30799,type,
    v56336: ( state_type * $int ) > $o ).

tff(pred_def_30800,type,
    v56334: state_type > $o ).

tff(pred_def_30801,type,
    v56332: state_type > $o ).

tff(pred_def_30802,type,
    v56352: state_type > $o ).

tff(pred_def_30803,type,
    v56350: state_type > $o ).

tff(pred_def_30804,type,
    v56349: state_type > $o ).

tff(pred_def_30805,type,
    v56348: ( state_type * $int ) > $o ).

tff(pred_def_30806,type,
    v56346: state_type > $o ).

tff(pred_def_30807,type,
    v56344: state_type > $o ).

tff(pred_def_30808,type,
    v56364: state_type > $o ).

tff(pred_def_30809,type,
    v56362: state_type > $o ).

tff(pred_def_30810,type,
    v56361: state_type > $o ).

tff(pred_def_30811,type,
    v56360: ( state_type * $int ) > $o ).

tff(pred_def_30812,type,
    v56358: state_type > $o ).

tff(pred_def_30813,type,
    v56356: state_type > $o ).

tff(pred_def_30814,type,
    v56368: state_type > $o ).

tff(pred_def_30815,type,
    v56330: state_type > $o ).

tff(pred_def_30816,type,
    v56328: state_type > $o ).

tff(pred_def_30817,type,
    v56326: state_type > $o ).

tff(pred_def_30818,type,
    v56324: state_type > $o ).

tff(pred_def_30819,type,
    v56322: state_type > $o ).

tff(pred_def_30820,type,
    v56382: state_type > $o ).

tff(pred_def_30821,type,
    v56380: state_type > $o ).

tff(pred_def_30822,type,
    v56386: state_type > $o ).

tff(pred_def_30823,type,
    v56384: state_type > $o ).

tff(pred_def_30824,type,
    v56390: state_type > $o ).

tff(pred_def_30825,type,
    v56388: state_type > $o ).

tff(pred_def_30826,type,
    v56392: state_type > $o ).

tff(pred_def_30827,type,
    v56378: state_type > $o ).

tff(pred_def_30828,type,
    v56376: state_type > $o ).

tff(pred_def_30829,type,
    v56374: state_type > $o ).

tff(pred_def_30830,type,
    v56372: state_type > $o ).

tff(pred_def_30831,type,
    v56370: state_type > $o ).

tff(pred_def_30832,type,
    v56394: state_type > $o ).

tff(pred_def_30833,type,
    v56272: state_type > $o ).

tff(pred_def_30834,type,
    v56270: state_type > $o ).

tff(pred_def_30835,type,
    v56268: state_type > $o ).

tff(pred_def_30836,type,
    v56266: state_type > $o ).

tff(pred_def_30837,type,
    v56264: state_type > $o ).

tff(pred_def_30838,type,
    v56404: state_type > $o ).

tff(pred_def_30839,type,
    v56402: state_type > $o ).

tff(pred_def_30840,type,
    v56401: state_type > $o ).

tff(pred_def_30841,type,
    v56400: ( state_type * $int ) > $o ).

tff(pred_def_30842,type,
    v56398: state_type > $o ).

tff(pred_def_30843,type,
    v56396: state_type > $o ).

tff(pred_def_30844,type,
    v56408: state_type > $o ).

tff(pred_def_30845,type,
    v56106: state_type > $o ).

tff(pred_def_30846,type,
    v56104: state_type > $o ).

tff(pred_def_30847,type,
    v56102: state_type > $o ).

tff(pred_def_30848,type,
    v56100: state_type > $o ).

tff(pred_def_30849,type,
    v56410: state_type > $o ).

tff(pred_def_30850,type,
    v55788: state_type > $o ).

tff(pred_def_30851,type,
    v55786: state_type > $o ).

tff(pred_def_30852,type,
    v55784: state_type > $o ).

tff(pred_def_30853,type,
    v55782: state_type > $o ).

tff(pred_def_30854,type,
    v55780: state_type > $o ).

tff(pred_def_30855,type,
    v56412: state_type > $o ).

tff(pred_def_30856,type,
    v54690: state_type > $o ).

tff(pred_def_30857,type,
    v54688: state_type > $o ).

tff(pred_def_30858,type,
    v54686: state_type > $o ).

tff(pred_def_30859,type,
    v54684: state_type > $o ).

tff(pred_def_30860,type,
    v54682: state_type > $o ).

tff(pred_def_30861,type,
    v54680: state_type > $o ).

tff(pred_def_30862,type,
    v54678: state_type > $o ).

tff(pred_def_30863,type,
    v54676: state_type > $o ).

tff(pred_def_30864,type,
    v54674: state_type > $o ).

tff(pred_def_30865,type,
    v54672: state_type > $o ).

tff(pred_def_30866,type,
    v56415: state_type > $o ).

tff(pred_def_30867,type,
    v5939: state_type > $o ).

tff(pred_def_30868,type,
    v5937: state_type > $o ).

tff(pred_def_30869,type,
    v5935: state_type > $o ).

tff(pred_def_30870,type,
    v5933: state_type > $o ).

tff(pred_def_30871,type,
    v5931: state_type > $o ).

tff(pred_def_30872,type,
    v56500: state_type > $o ).

tff(pred_def_30873,type,
    v56498: state_type > $o ).

tff(pred_def_30874,type,
    v56504: state_type > $o ).

tff(pred_def_30875,type,
    v56502: state_type > $o ).

tff(pred_def_30876,type,
    v56508: state_type > $o ).

tff(pred_def_30877,type,
    v56506: state_type > $o ).

tff(pred_def_30878,type,
    v56510: state_type > $o ).

tff(pred_def_30879,type,
    v56496: state_type > $o ).

tff(pred_def_30880,type,
    v56494: state_type > $o ).

tff(pred_def_30881,type,
    v56492: state_type > $o ).

tff(pred_def_30882,type,
    v56490: state_type > $o ).

tff(pred_def_30883,type,
    v56488: state_type > $o ).

tff(pred_def_30884,type,
    v56524: state_type > $o ).

tff(pred_def_30885,type,
    v56522: state_type > $o ).

tff(pred_def_30886,type,
    v56528: state_type > $o ).

tff(pred_def_30887,type,
    v56526: state_type > $o ).

tff(pred_def_30888,type,
    v56532: state_type > $o ).

tff(pred_def_30889,type,
    v56530: state_type > $o ).

tff(pred_def_30890,type,
    v56534: state_type > $o ).

tff(pred_def_30891,type,
    v56520: state_type > $o ).

tff(pred_def_30892,type,
    v56518: state_type > $o ).

tff(pred_def_30893,type,
    v56516: state_type > $o ).

tff(pred_def_30894,type,
    v56514: state_type > $o ).

tff(pred_def_30895,type,
    v56512: state_type > $o ).

tff(pred_def_30896,type,
    v56548: state_type > $o ).

tff(pred_def_30897,type,
    v56546: state_type > $o ).

tff(pred_def_30898,type,
    v56552: state_type > $o ).

tff(pred_def_30899,type,
    v56550: state_type > $o ).

tff(pred_def_30900,type,
    v56556: state_type > $o ).

tff(pred_def_30901,type,
    v56554: state_type > $o ).

tff(pred_def_30902,type,
    v56558: state_type > $o ).

tff(pred_def_30903,type,
    v56544: state_type > $o ).

tff(pred_def_30904,type,
    v56542: state_type > $o ).

tff(pred_def_30905,type,
    v56540: state_type > $o ).

tff(pred_def_30906,type,
    v56538: state_type > $o ).

tff(pred_def_30907,type,
    v56536: state_type > $o ).

tff(pred_def_30908,type,
    v56560: state_type > $o ).

tff(pred_def_30909,type,
    v56486: state_type > $o ).

tff(pred_def_30910,type,
    v56484: state_type > $o ).

tff(pred_def_30911,type,
    v56482: state_type > $o ).

tff(pred_def_30912,type,
    v56480: state_type > $o ).

tff(pred_def_30913,type,
    v56478: state_type > $o ).

tff(pred_def_30914,type,
    v56584: state_type > $o ).

tff(pred_def_30915,type,
    v56582: state_type > $o ).

tff(pred_def_30916,type,
    v56588: state_type > $o ).

tff(pred_def_30917,type,
    v56586: state_type > $o ).

tff(pred_def_30918,type,
    v56592: state_type > $o ).

tff(pred_def_30919,type,
    v56590: state_type > $o ).

tff(pred_def_30920,type,
    v56594: state_type > $o ).

tff(pred_def_30921,type,
    v56580: state_type > $o ).

tff(pred_def_30922,type,
    v56578: state_type > $o ).

tff(pred_def_30923,type,
    v56576: state_type > $o ).

tff(pred_def_30924,type,
    v56574: state_type > $o ).

tff(pred_def_30925,type,
    v56572: state_type > $o ).

tff(pred_def_30926,type,
    v56608: state_type > $o ).

tff(pred_def_30927,type,
    v56606: state_type > $o ).

tff(pred_def_30928,type,
    v56612: state_type > $o ).

tff(pred_def_30929,type,
    v56610: state_type > $o ).

tff(pred_def_30930,type,
    v56616: state_type > $o ).

tff(pred_def_30931,type,
    v56614: state_type > $o ).

tff(pred_def_30932,type,
    v56618: state_type > $o ).

tff(pred_def_30933,type,
    v56604: state_type > $o ).

tff(pred_def_30934,type,
    v56602: state_type > $o ).

tff(pred_def_30935,type,
    v56600: state_type > $o ).

tff(pred_def_30936,type,
    v56598: state_type > $o ).

tff(pred_def_30937,type,
    v56596: state_type > $o ).

tff(pred_def_30938,type,
    v56632: state_type > $o ).

tff(pred_def_30939,type,
    v56630: state_type > $o ).

tff(pred_def_30940,type,
    v56636: state_type > $o ).

tff(pred_def_30941,type,
    v56634: state_type > $o ).

tff(pred_def_30942,type,
    v56640: state_type > $o ).

tff(pred_def_30943,type,
    v56638: state_type > $o ).

tff(pred_def_30944,type,
    v56642: state_type > $o ).

tff(pred_def_30945,type,
    v56628: state_type > $o ).

tff(pred_def_30946,type,
    v56626: state_type > $o ).

tff(pred_def_30947,type,
    v56624: state_type > $o ).

tff(pred_def_30948,type,
    v56622: state_type > $o ).

tff(pred_def_30949,type,
    v56620: state_type > $o ).

tff(pred_def_30950,type,
    v56644: state_type > $o ).

tff(pred_def_30951,type,
    v56570: state_type > $o ).

tff(pred_def_30952,type,
    v56568: state_type > $o ).

tff(pred_def_30953,type,
    v56566: state_type > $o ).

tff(pred_def_30954,type,
    v56564: state_type > $o ).

tff(pred_def_30955,type,
    v56562: state_type > $o ).

tff(pred_def_30956,type,
    v56668: state_type > $o ).

tff(pred_def_30957,type,
    v56666: state_type > $o ).

tff(pred_def_30958,type,
    v56672: state_type > $o ).

tff(pred_def_30959,type,
    v56670: state_type > $o ).

tff(pred_def_30960,type,
    v56676: state_type > $o ).

tff(pred_def_30961,type,
    v56674: state_type > $o ).

tff(pred_def_30962,type,
    v56678: state_type > $o ).

tff(pred_def_30963,type,
    v56664: state_type > $o ).

tff(pred_def_30964,type,
    v56662: state_type > $o ).

tff(pred_def_30965,type,
    v56660: state_type > $o ).

tff(pred_def_30966,type,
    v56658: state_type > $o ).

tff(pred_def_30967,type,
    v56656: state_type > $o ).

tff(pred_def_30968,type,
    v56692: state_type > $o ).

tff(pred_def_30969,type,
    v56690: state_type > $o ).

tff(pred_def_30970,type,
    v56696: state_type > $o ).

tff(pred_def_30971,type,
    v56694: state_type > $o ).

tff(pred_def_30972,type,
    v56700: state_type > $o ).

tff(pred_def_30973,type,
    v56698: state_type > $o ).

tff(pred_def_30974,type,
    v56702: state_type > $o ).

tff(pred_def_30975,type,
    v56688: state_type > $o ).

tff(pred_def_30976,type,
    v56686: state_type > $o ).

tff(pred_def_30977,type,
    v56684: state_type > $o ).

tff(pred_def_30978,type,
    v56682: state_type > $o ).

tff(pred_def_30979,type,
    v56680: state_type > $o ).

tff(pred_def_30980,type,
    v56716: state_type > $o ).

tff(pred_def_30981,type,
    v56714: state_type > $o ).

tff(pred_def_30982,type,
    v56720: state_type > $o ).

tff(pred_def_30983,type,
    v56718: state_type > $o ).

tff(pred_def_30984,type,
    v56724: state_type > $o ).

tff(pred_def_30985,type,
    v56722: state_type > $o ).

tff(pred_def_30986,type,
    v56726: state_type > $o ).

tff(pred_def_30987,type,
    v56712: state_type > $o ).

tff(pred_def_30988,type,
    v56710: state_type > $o ).

tff(pred_def_30989,type,
    v56708: state_type > $o ).

tff(pred_def_30990,type,
    v56706: state_type > $o ).

tff(pred_def_30991,type,
    v56704: state_type > $o ).

tff(pred_def_30992,type,
    v56728: state_type > $o ).

tff(pred_def_30993,type,
    v56654: state_type > $o ).

tff(pred_def_30994,type,
    v56652: state_type > $o ).

tff(pred_def_30995,type,
    v56650: state_type > $o ).

tff(pred_def_30996,type,
    v56648: state_type > $o ).

tff(pred_def_30997,type,
    v56646: state_type > $o ).

tff(pred_def_30998,type,
    v56730: state_type > $o ).

tff(pred_def_30999,type,
    v56476: state_type > $o ).

tff(pred_def_31000,type,
    v56474: state_type > $o ).

tff(pred_def_31001,type,
    v56472: state_type > $o ).

tff(pred_def_31002,type,
    v56470: state_type > $o ).

tff(pred_def_31003,type,
    v56468: state_type > $o ).

tff(pred_def_31004,type,
    v56764: state_type > $o ).

tff(pred_def_31005,type,
    v56762: state_type > $o ).

tff(pred_def_31006,type,
    v56768: state_type > $o ).

tff(pred_def_31007,type,
    v56766: state_type > $o ).

tff(pred_def_31008,type,
    v56772: state_type > $o ).

tff(pred_def_31009,type,
    v56770: state_type > $o ).

tff(pred_def_31010,type,
    v56774: state_type > $o ).

tff(pred_def_31011,type,
    v56760: state_type > $o ).

tff(pred_def_31012,type,
    v56758: state_type > $o ).

tff(pred_def_31013,type,
    v56756: state_type > $o ).

tff(pred_def_31014,type,
    v56754: state_type > $o ).

tff(pred_def_31015,type,
    v56752: state_type > $o ).

tff(pred_def_31016,type,
    v56788: state_type > $o ).

tff(pred_def_31017,type,
    v56786: state_type > $o ).

tff(pred_def_31018,type,
    v56792: state_type > $o ).

tff(pred_def_31019,type,
    v56790: state_type > $o ).

tff(pred_def_31020,type,
    v56796: state_type > $o ).

tff(pred_def_31021,type,
    v56794: state_type > $o ).

tff(pred_def_31022,type,
    v56798: state_type > $o ).

tff(pred_def_31023,type,
    v56784: state_type > $o ).

tff(pred_def_31024,type,
    v56782: state_type > $o ).

tff(pred_def_31025,type,
    v56780: state_type > $o ).

tff(pred_def_31026,type,
    v56778: state_type > $o ).

tff(pred_def_31027,type,
    v56776: state_type > $o ).

tff(pred_def_31028,type,
    v56812: state_type > $o ).

tff(pred_def_31029,type,
    v56810: state_type > $o ).

tff(pred_def_31030,type,
    v56816: state_type > $o ).

tff(pred_def_31031,type,
    v56814: state_type > $o ).

tff(pred_def_31032,type,
    v56820: state_type > $o ).

tff(pred_def_31033,type,
    v56818: state_type > $o ).

tff(pred_def_31034,type,
    v56822: state_type > $o ).

tff(pred_def_31035,type,
    v56808: state_type > $o ).

tff(pred_def_31036,type,
    v56806: state_type > $o ).

tff(pred_def_31037,type,
    v56804: state_type > $o ).

tff(pred_def_31038,type,
    v56802: state_type > $o ).

tff(pred_def_31039,type,
    v56800: state_type > $o ).

tff(pred_def_31040,type,
    v56824: state_type > $o ).

tff(pred_def_31041,type,
    v56750: state_type > $o ).

tff(pred_def_31042,type,
    v56748: state_type > $o ).

tff(pred_def_31043,type,
    v56746: state_type > $o ).

tff(pred_def_31044,type,
    v56744: state_type > $o ).

tff(pred_def_31045,type,
    v56742: state_type > $o ).

tff(pred_def_31046,type,
    v56848: state_type > $o ).

tff(pred_def_31047,type,
    v56846: state_type > $o ).

tff(pred_def_31048,type,
    v56852: state_type > $o ).

tff(pred_def_31049,type,
    v56850: state_type > $o ).

tff(pred_def_31050,type,
    v56856: state_type > $o ).

tff(pred_def_31051,type,
    v56854: state_type > $o ).

tff(pred_def_31052,type,
    v56858: state_type > $o ).

tff(pred_def_31053,type,
    v56844: state_type > $o ).

tff(pred_def_31054,type,
    v56842: state_type > $o ).

tff(pred_def_31055,type,
    v56840: state_type > $o ).

tff(pred_def_31056,type,
    v56838: state_type > $o ).

tff(pred_def_31057,type,
    v56836: state_type > $o ).

tff(pred_def_31058,type,
    v56872: state_type > $o ).

tff(pred_def_31059,type,
    v56870: state_type > $o ).

tff(pred_def_31060,type,
    v56876: state_type > $o ).

tff(pred_def_31061,type,
    v56874: state_type > $o ).

tff(pred_def_31062,type,
    v56880: state_type > $o ).

tff(pred_def_31063,type,
    v56878: state_type > $o ).

tff(pred_def_31064,type,
    v56882: state_type > $o ).

tff(pred_def_31065,type,
    v56868: state_type > $o ).

tff(pred_def_31066,type,
    v56866: state_type > $o ).

tff(pred_def_31067,type,
    v56864: state_type > $o ).

tff(pred_def_31068,type,
    v56862: state_type > $o ).

tff(pred_def_31069,type,
    v56860: state_type > $o ).

tff(pred_def_31070,type,
    v56896: state_type > $o ).

tff(pred_def_31071,type,
    v56894: state_type > $o ).

tff(pred_def_31072,type,
    v56900: state_type > $o ).

tff(pred_def_31073,type,
    v56898: state_type > $o ).

tff(pred_def_31074,type,
    v56904: state_type > $o ).

tff(pred_def_31075,type,
    v56902: state_type > $o ).

tff(pred_def_31076,type,
    v56906: state_type > $o ).

tff(pred_def_31077,type,
    v56892: state_type > $o ).

tff(pred_def_31078,type,
    v56890: state_type > $o ).

tff(pred_def_31079,type,
    v56888: state_type > $o ).

tff(pred_def_31080,type,
    v56886: state_type > $o ).

tff(pred_def_31081,type,
    v56884: state_type > $o ).

tff(pred_def_31082,type,
    v56908: state_type > $o ).

tff(pred_def_31083,type,
    v56834: state_type > $o ).

tff(pred_def_31084,type,
    v56832: state_type > $o ).

tff(pred_def_31085,type,
    v56830: state_type > $o ).

tff(pred_def_31086,type,
    v56828: state_type > $o ).

tff(pred_def_31087,type,
    v56826: state_type > $o ).

tff(pred_def_31088,type,
    v56932: state_type > $o ).

tff(pred_def_31089,type,
    v56930: state_type > $o ).

tff(pred_def_31090,type,
    v56936: state_type > $o ).

tff(pred_def_31091,type,
    v56934: state_type > $o ).

tff(pred_def_31092,type,
    v56940: state_type > $o ).

tff(pred_def_31093,type,
    v56938: state_type > $o ).

tff(pred_def_31094,type,
    v56942: state_type > $o ).

tff(pred_def_31095,type,
    v56928: state_type > $o ).

tff(pred_def_31096,type,
    v56926: state_type > $o ).

tff(pred_def_31097,type,
    v56924: state_type > $o ).

tff(pred_def_31098,type,
    v56922: state_type > $o ).

tff(pred_def_31099,type,
    v56920: state_type > $o ).

tff(pred_def_31100,type,
    v56956: state_type > $o ).

tff(pred_def_31101,type,
    v56954: state_type > $o ).

tff(pred_def_31102,type,
    v56960: state_type > $o ).

tff(pred_def_31103,type,
    v56958: state_type > $o ).

tff(pred_def_31104,type,
    v56964: state_type > $o ).

tff(pred_def_31105,type,
    v56962: state_type > $o ).

tff(pred_def_31106,type,
    v56966: state_type > $o ).

tff(pred_def_31107,type,
    v56952: state_type > $o ).

tff(pred_def_31108,type,
    v56950: state_type > $o ).

tff(pred_def_31109,type,
    v56948: state_type > $o ).

tff(pred_def_31110,type,
    v56946: state_type > $o ).

tff(pred_def_31111,type,
    v56944: state_type > $o ).

tff(pred_def_31112,type,
    v56980: state_type > $o ).

tff(pred_def_31113,type,
    v56978: state_type > $o ).

tff(pred_def_31114,type,
    v56984: state_type > $o ).

tff(pred_def_31115,type,
    v56982: state_type > $o ).

tff(pred_def_31116,type,
    v56988: state_type > $o ).

tff(pred_def_31117,type,
    v56986: state_type > $o ).

tff(pred_def_31118,type,
    v56990: state_type > $o ).

tff(pred_def_31119,type,
    v56976: state_type > $o ).

tff(pred_def_31120,type,
    v56974: state_type > $o ).

tff(pred_def_31121,type,
    v56972: state_type > $o ).

tff(pred_def_31122,type,
    v56970: state_type > $o ).

tff(pred_def_31123,type,
    v56968: state_type > $o ).

tff(pred_def_31124,type,
    v56992: state_type > $o ).

tff(pred_def_31125,type,
    v56918: state_type > $o ).

tff(pred_def_31126,type,
    v56916: state_type > $o ).

tff(pred_def_31127,type,
    v56914: state_type > $o ).

tff(pred_def_31128,type,
    v56912: state_type > $o ).

tff(pred_def_31129,type,
    v56910: state_type > $o ).

tff(pred_def_31130,type,
    v56994: state_type > $o ).

tff(pred_def_31131,type,
    v56740: state_type > $o ).

tff(pred_def_31132,type,
    v56738: state_type > $o ).

tff(pred_def_31133,type,
    v56736: state_type > $o ).

tff(pred_def_31134,type,
    v56734: state_type > $o ).

tff(pred_def_31135,type,
    v56732: state_type > $o ).

tff(pred_def_31136,type,
    v57018: state_type > $o ).

tff(pred_def_31137,type,
    v57016: state_type > $o ).

tff(pred_def_31138,type,
    v57022: state_type > $o ).

tff(pred_def_31139,type,
    v57020: state_type > $o ).

tff(pred_def_31140,type,
    v57026: state_type > $o ).

tff(pred_def_31141,type,
    v57024: state_type > $o ).

tff(pred_def_31142,type,
    v57028: state_type > $o ).

tff(pred_def_31143,type,
    v57014: state_type > $o ).

tff(pred_def_31144,type,
    v57012: state_type > $o ).

tff(pred_def_31145,type,
    v57010: state_type > $o ).

tff(pred_def_31146,type,
    v57008: state_type > $o ).

tff(pred_def_31147,type,
    v57006: state_type > $o ).

tff(pred_def_31148,type,
    v57052: state_type > $o ).

tff(pred_def_31149,type,
    v57050: state_type > $o ).

tff(pred_def_31150,type,
    v57056: state_type > $o ).

tff(pred_def_31151,type,
    v57054: state_type > $o ).

tff(pred_def_31152,type,
    v57060: state_type > $o ).

tff(pred_def_31153,type,
    v57058: state_type > $o ).

tff(pred_def_31154,type,
    v57062: state_type > $o ).

tff(pred_def_31155,type,
    v57048: state_type > $o ).

tff(pred_def_31156,type,
    v57046: state_type > $o ).

tff(pred_def_31157,type,
    v57044: state_type > $o ).

tff(pred_def_31158,type,
    v57042: state_type > $o ).

tff(pred_def_31159,type,
    v57040: state_type > $o ).

tff(pred_def_31160,type,
    v57076: state_type > $o ).

tff(pred_def_31161,type,
    v57074: state_type > $o ).

tff(pred_def_31162,type,
    v57080: state_type > $o ).

tff(pred_def_31163,type,
    v57078: state_type > $o ).

tff(pred_def_31164,type,
    v57084: state_type > $o ).

tff(pred_def_31165,type,
    v57082: state_type > $o ).

tff(pred_def_31166,type,
    v57086: state_type > $o ).

tff(pred_def_31167,type,
    v57072: state_type > $o ).

tff(pred_def_31168,type,
    v57070: state_type > $o ).

tff(pred_def_31169,type,
    v57068: state_type > $o ).

tff(pred_def_31170,type,
    v57066: state_type > $o ).

tff(pred_def_31171,type,
    v57064: state_type > $o ).

tff(pred_def_31172,type,
    v57100: state_type > $o ).

tff(pred_def_31173,type,
    v57098: state_type > $o ).

tff(pred_def_31174,type,
    v57104: state_type > $o ).

tff(pred_def_31175,type,
    v57102: state_type > $o ).

tff(pred_def_31176,type,
    v57108: state_type > $o ).

tff(pred_def_31177,type,
    v57106: state_type > $o ).

tff(pred_def_31178,type,
    v57110: state_type > $o ).

tff(pred_def_31179,type,
    v57096: state_type > $o ).

tff(pred_def_31180,type,
    v57094: state_type > $o ).

tff(pred_def_31181,type,
    v57092: state_type > $o ).

tff(pred_def_31182,type,
    v57090: state_type > $o ).

tff(pred_def_31183,type,
    v57088: state_type > $o ).

tff(pred_def_31184,type,
    v57112: state_type > $o ).

tff(pred_def_31185,type,
    v57038: state_type > $o ).

tff(pred_def_31186,type,
    v57036: state_type > $o ).

tff(pred_def_31187,type,
    v57034: state_type > $o ).

tff(pred_def_31188,type,
    v57032: state_type > $o ).

tff(pred_def_31189,type,
    v57030: state_type > $o ).

tff(pred_def_31190,type,
    v57126: state_type > $o ).

tff(pred_def_31191,type,
    v57124: state_type > $o ).

tff(pred_def_31192,type,
    v57123: state_type > $o ).

tff(pred_def_31193,type,
    v57122: ( state_type * $int ) > $o ).

tff(pred_def_31194,type,
    v57120: ( state_type * $int ) > $o ).

tff(pred_def_31195,type,
    v57118: ( state_type * $int ) > $o ).

tff(pred_def_31196,type,
    v57116: state_type > $o ).

tff(pred_def_31197,type,
    v57114: state_type > $o ).

tff(pred_def_31198,type,
    v57130: state_type > $o ).

tff(pred_def_31199,type,
    v57004: state_type > $o ).

tff(pred_def_31200,type,
    v57002: state_type > $o ).

tff(pred_def_31201,type,
    v57000: state_type > $o ).

tff(pred_def_31202,type,
    v56998: state_type > $o ).

tff(pred_def_31203,type,
    v56996: state_type > $o ).

tff(pred_def_31204,type,
    v57132: state_type > $o ).

tff(pred_def_31205,type,
    v56466: state_type > $o ).

tff(pred_def_31206,type,
    v56464: state_type > $o ).

tff(pred_def_31207,type,
    v56461: ( state_type * $int ) > $o ).

tff(pred_def_31208,type,
    v56459: state_type > $o ).

tff(pred_def_31209,type,
    v56457: state_type > $o ).

tff(pred_def_31210,type,
    v57174: state_type > $o ).

tff(pred_def_31211,type,
    v57172: state_type > $o ).

tff(pred_def_31212,type,
    v57178: state_type > $o ).

tff(pred_def_31213,type,
    v57176: state_type > $o ).

tff(pred_def_31214,type,
    v57182: state_type > $o ).

tff(pred_def_31215,type,
    v57180: state_type > $o ).

tff(pred_def_31216,type,
    v57184: state_type > $o ).

tff(pred_def_31217,type,
    v57170: state_type > $o ).

tff(pred_def_31218,type,
    v57168: state_type > $o ).

tff(pred_def_31219,type,
    v57166: state_type > $o ).

tff(pred_def_31220,type,
    v57164: state_type > $o ).

tff(pred_def_31221,type,
    v57162: state_type > $o ).

tff(pred_def_31222,type,
    v57198: state_type > $o ).

tff(pred_def_31223,type,
    v57196: state_type > $o ).

tff(pred_def_31224,type,
    v57202: state_type > $o ).

tff(pred_def_31225,type,
    v57200: state_type > $o ).

tff(pred_def_31226,type,
    v57206: state_type > $o ).

tff(pred_def_31227,type,
    v57204: state_type > $o ).

tff(pred_def_31228,type,
    v57208: state_type > $o ).

tff(pred_def_31229,type,
    v57194: state_type > $o ).

tff(pred_def_31230,type,
    v57192: state_type > $o ).

tff(pred_def_31231,type,
    v57190: state_type > $o ).

tff(pred_def_31232,type,
    v57188: state_type > $o ).

tff(pred_def_31233,type,
    v57186: state_type > $o ).

tff(pred_def_31234,type,
    v57222: state_type > $o ).

tff(pred_def_31235,type,
    v57220: state_type > $o ).

tff(pred_def_31236,type,
    v57226: state_type > $o ).

tff(pred_def_31237,type,
    v57224: state_type > $o ).

tff(pred_def_31238,type,
    v57230: state_type > $o ).

tff(pred_def_31239,type,
    v57228: state_type > $o ).

tff(pred_def_31240,type,
    v57232: state_type > $o ).

tff(pred_def_31241,type,
    v57218: state_type > $o ).

tff(pred_def_31242,type,
    v57216: state_type > $o ).

tff(pred_def_31243,type,
    v57214: state_type > $o ).

tff(pred_def_31244,type,
    v57212: state_type > $o ).

tff(pred_def_31245,type,
    v57210: state_type > $o ).

tff(pred_def_31246,type,
    v57234: state_type > $o ).

tff(pred_def_31247,type,
    v57160: state_type > $o ).

tff(pred_def_31248,type,
    v57158: state_type > $o ).

tff(pred_def_31249,type,
    v57156: state_type > $o ).

tff(pred_def_31250,type,
    v57154: state_type > $o ).

tff(pred_def_31251,type,
    v57152: state_type > $o ).

tff(pred_def_31252,type,
    v57258: state_type > $o ).

tff(pred_def_31253,type,
    v57256: state_type > $o ).

tff(pred_def_31254,type,
    v57262: state_type > $o ).

tff(pred_def_31255,type,
    v57260: state_type > $o ).

tff(pred_def_31256,type,
    v57266: state_type > $o ).

tff(pred_def_31257,type,
    v57264: state_type > $o ).

tff(pred_def_31258,type,
    v57268: state_type > $o ).

tff(pred_def_31259,type,
    v57254: state_type > $o ).

tff(pred_def_31260,type,
    v57252: state_type > $o ).

tff(pred_def_31261,type,
    v57250: state_type > $o ).

tff(pred_def_31262,type,
    v57248: state_type > $o ).

tff(pred_def_31263,type,
    v57246: state_type > $o ).

tff(pred_def_31264,type,
    v57282: state_type > $o ).

tff(pred_def_31265,type,
    v57280: state_type > $o ).

tff(pred_def_31266,type,
    v57286: state_type > $o ).

tff(pred_def_31267,type,
    v57284: state_type > $o ).

tff(pred_def_31268,type,
    v57290: state_type > $o ).

tff(pred_def_31269,type,
    v57288: state_type > $o ).

tff(pred_def_31270,type,
    v57292: state_type > $o ).

tff(pred_def_31271,type,
    v57278: state_type > $o ).

tff(pred_def_31272,type,
    v57276: state_type > $o ).

tff(pred_def_31273,type,
    v57274: state_type > $o ).

tff(pred_def_31274,type,
    v57272: state_type > $o ).

tff(pred_def_31275,type,
    v57270: state_type > $o ).

tff(pred_def_31276,type,
    v57306: state_type > $o ).

tff(pred_def_31277,type,
    v57304: state_type > $o ).

tff(pred_def_31278,type,
    v57310: state_type > $o ).

tff(pred_def_31279,type,
    v57308: state_type > $o ).

tff(pred_def_31280,type,
    v57314: state_type > $o ).

tff(pred_def_31281,type,
    v57312: state_type > $o ).

tff(pred_def_31282,type,
    v57316: state_type > $o ).

tff(pred_def_31283,type,
    v57302: state_type > $o ).

tff(pred_def_31284,type,
    v57300: state_type > $o ).

tff(pred_def_31285,type,
    v57298: state_type > $o ).

tff(pred_def_31286,type,
    v57296: state_type > $o ).

tff(pred_def_31287,type,
    v57294: state_type > $o ).

tff(pred_def_31288,type,
    v57318: state_type > $o ).

tff(pred_def_31289,type,
    v57244: state_type > $o ).

tff(pred_def_31290,type,
    v57242: state_type > $o ).

tff(pred_def_31291,type,
    v57240: state_type > $o ).

tff(pred_def_31292,type,
    v57238: state_type > $o ).

tff(pred_def_31293,type,
    v57236: state_type > $o ).

tff(pred_def_31294,type,
    v57342: state_type > $o ).

tff(pred_def_31295,type,
    v57340: state_type > $o ).

tff(pred_def_31296,type,
    v57346: state_type > $o ).

tff(pred_def_31297,type,
    v57344: state_type > $o ).

tff(pred_def_31298,type,
    v57350: state_type > $o ).

tff(pred_def_31299,type,
    v57348: state_type > $o ).

tff(pred_def_31300,type,
    v57352: state_type > $o ).

tff(pred_def_31301,type,
    v57338: state_type > $o ).

tff(pred_def_31302,type,
    v57336: state_type > $o ).

tff(pred_def_31303,type,
    v57334: state_type > $o ).

tff(pred_def_31304,type,
    v57332: state_type > $o ).

tff(pred_def_31305,type,
    v57330: state_type > $o ).

tff(pred_def_31306,type,
    v57366: state_type > $o ).

tff(pred_def_31307,type,
    v57364: state_type > $o ).

tff(pred_def_31308,type,
    v57370: state_type > $o ).

tff(pred_def_31309,type,
    v57368: state_type > $o ).

tff(pred_def_31310,type,
    v57374: state_type > $o ).

tff(pred_def_31311,type,
    v57372: state_type > $o ).

tff(pred_def_31312,type,
    v57376: state_type > $o ).

tff(pred_def_31313,type,
    v57362: state_type > $o ).

tff(pred_def_31314,type,
    v57360: state_type > $o ).

tff(pred_def_31315,type,
    v57358: state_type > $o ).

tff(pred_def_31316,type,
    v57356: state_type > $o ).

tff(pred_def_31317,type,
    v57354: state_type > $o ).

tff(pred_def_31318,type,
    v57390: state_type > $o ).

tff(pred_def_31319,type,
    v57388: state_type > $o ).

tff(pred_def_31320,type,
    v57394: state_type > $o ).

tff(pred_def_31321,type,
    v57392: state_type > $o ).

tff(pred_def_31322,type,
    v57398: state_type > $o ).

tff(pred_def_31323,type,
    v57396: state_type > $o ).

tff(pred_def_31324,type,
    v57400: state_type > $o ).

tff(pred_def_31325,type,
    v57386: state_type > $o ).

tff(pred_def_31326,type,
    v57384: state_type > $o ).

tff(pred_def_31327,type,
    v57382: state_type > $o ).

tff(pred_def_31328,type,
    v57380: state_type > $o ).

tff(pred_def_31329,type,
    v57378: state_type > $o ).

tff(pred_def_31330,type,
    v57402: state_type > $o ).

tff(pred_def_31331,type,
    v57328: state_type > $o ).

tff(pred_def_31332,type,
    v57326: state_type > $o ).

tff(pred_def_31333,type,
    v57324: state_type > $o ).

tff(pred_def_31334,type,
    v57322: state_type > $o ).

tff(pred_def_31335,type,
    v57320: state_type > $o ).

tff(pred_def_31336,type,
    v57404: state_type > $o ).

tff(pred_def_31337,type,
    v57150: state_type > $o ).

tff(pred_def_31338,type,
    v57148: state_type > $o ).

tff(pred_def_31339,type,
    v57146: state_type > $o ).

tff(pred_def_31340,type,
    v57144: state_type > $o ).

tff(pred_def_31341,type,
    v57142: state_type > $o ).

tff(pred_def_31342,type,
    v57438: state_type > $o ).

tff(pred_def_31343,type,
    v57436: state_type > $o ).

tff(pred_def_31344,type,
    v57442: state_type > $o ).

tff(pred_def_31345,type,
    v57440: state_type > $o ).

tff(pred_def_31346,type,
    v57446: state_type > $o ).

tff(pred_def_31347,type,
    v57444: state_type > $o ).

tff(pred_def_31348,type,
    v57448: state_type > $o ).

tff(pred_def_31349,type,
    v57434: state_type > $o ).

tff(pred_def_31350,type,
    v57432: state_type > $o ).

tff(pred_def_31351,type,
    v57430: state_type > $o ).

tff(pred_def_31352,type,
    v57428: state_type > $o ).

tff(pred_def_31353,type,
    v57426: state_type > $o ).

tff(pred_def_31354,type,
    v57462: state_type > $o ).

tff(pred_def_31355,type,
    v57460: state_type > $o ).

tff(pred_def_31356,type,
    v57466: state_type > $o ).

tff(pred_def_31357,type,
    v57464: state_type > $o ).

tff(pred_def_31358,type,
    v57470: state_type > $o ).

tff(pred_def_31359,type,
    v57468: state_type > $o ).

tff(pred_def_31360,type,
    v57472: state_type > $o ).

tff(pred_def_31361,type,
    v57458: state_type > $o ).

tff(pred_def_31362,type,
    v57456: state_type > $o ).

tff(pred_def_31363,type,
    v57454: state_type > $o ).

tff(pred_def_31364,type,
    v57452: state_type > $o ).

tff(pred_def_31365,type,
    v57450: state_type > $o ).

tff(pred_def_31366,type,
    v57486: state_type > $o ).

tff(pred_def_31367,type,
    v57484: state_type > $o ).

tff(pred_def_31368,type,
    v57490: state_type > $o ).

tff(pred_def_31369,type,
    v57488: state_type > $o ).

tff(pred_def_31370,type,
    v57494: state_type > $o ).

tff(pred_def_31371,type,
    v57492: state_type > $o ).

tff(pred_def_31372,type,
    v57496: state_type > $o ).

tff(pred_def_31373,type,
    v57482: state_type > $o ).

tff(pred_def_31374,type,
    v57480: state_type > $o ).

tff(pred_def_31375,type,
    v57478: state_type > $o ).

tff(pred_def_31376,type,
    v57476: state_type > $o ).

tff(pred_def_31377,type,
    v57474: state_type > $o ).

tff(pred_def_31378,type,
    v57498: state_type > $o ).

tff(pred_def_31379,type,
    v57424: state_type > $o ).

tff(pred_def_31380,type,
    v57422: state_type > $o ).

tff(pred_def_31381,type,
    v57420: state_type > $o ).

tff(pred_def_31382,type,
    v57418: state_type > $o ).

tff(pred_def_31383,type,
    v57416: state_type > $o ).

tff(pred_def_31384,type,
    v57522: state_type > $o ).

tff(pred_def_31385,type,
    v57520: state_type > $o ).

tff(pred_def_31386,type,
    v57526: state_type > $o ).

tff(pred_def_31387,type,
    v57524: state_type > $o ).

tff(pred_def_31388,type,
    v57530: state_type > $o ).

tff(pred_def_31389,type,
    v57528: state_type > $o ).

tff(pred_def_31390,type,
    v57532: state_type > $o ).

tff(pred_def_31391,type,
    v57518: state_type > $o ).

tff(pred_def_31392,type,
    v57516: state_type > $o ).

tff(pred_def_31393,type,
    v57514: state_type > $o ).

tff(pred_def_31394,type,
    v57512: state_type > $o ).

tff(pred_def_31395,type,
    v57510: state_type > $o ).

tff(pred_def_31396,type,
    v57546: state_type > $o ).

tff(pred_def_31397,type,
    v57544: state_type > $o ).

tff(pred_def_31398,type,
    v57550: state_type > $o ).

tff(pred_def_31399,type,
    v57548: state_type > $o ).

tff(pred_def_31400,type,
    v57554: state_type > $o ).

tff(pred_def_31401,type,
    v57552: state_type > $o ).

tff(pred_def_31402,type,
    v57556: state_type > $o ).

tff(pred_def_31403,type,
    v57542: state_type > $o ).

tff(pred_def_31404,type,
    v57540: state_type > $o ).

tff(pred_def_31405,type,
    v57538: state_type > $o ).

tff(pred_def_31406,type,
    v57536: state_type > $o ).

tff(pred_def_31407,type,
    v57534: state_type > $o ).

tff(pred_def_31408,type,
    v57570: state_type > $o ).

tff(pred_def_31409,type,
    v57568: state_type > $o ).

tff(pred_def_31410,type,
    v57574: state_type > $o ).

tff(pred_def_31411,type,
    v57572: state_type > $o ).

tff(pred_def_31412,type,
    v57578: state_type > $o ).

tff(pred_def_31413,type,
    v57576: state_type > $o ).

tff(pred_def_31414,type,
    v57580: state_type > $o ).

tff(pred_def_31415,type,
    v57566: state_type > $o ).

tff(pred_def_31416,type,
    v57564: state_type > $o ).

tff(pred_def_31417,type,
    v57562: state_type > $o ).

tff(pred_def_31418,type,
    v57560: state_type > $o ).

tff(pred_def_31419,type,
    v57558: state_type > $o ).

tff(pred_def_31420,type,
    v57582: state_type > $o ).

tff(pred_def_31421,type,
    v57508: state_type > $o ).

tff(pred_def_31422,type,
    v57506: state_type > $o ).

tff(pred_def_31423,type,
    v57504: state_type > $o ).

tff(pred_def_31424,type,
    v57502: state_type > $o ).

tff(pred_def_31425,type,
    v57500: state_type > $o ).

tff(pred_def_31426,type,
    v57606: state_type > $o ).

tff(pred_def_31427,type,
    v57604: state_type > $o ).

tff(pred_def_31428,type,
    v57610: state_type > $o ).

tff(pred_def_31429,type,
    v57608: state_type > $o ).

tff(pred_def_31430,type,
    v57614: state_type > $o ).

tff(pred_def_31431,type,
    v57612: state_type > $o ).

tff(pred_def_31432,type,
    v57616: state_type > $o ).

tff(pred_def_31433,type,
    v57602: state_type > $o ).

tff(pred_def_31434,type,
    v57600: state_type > $o ).

tff(pred_def_31435,type,
    v57598: state_type > $o ).

tff(pred_def_31436,type,
    v57596: state_type > $o ).

tff(pred_def_31437,type,
    v57594: state_type > $o ).

tff(pred_def_31438,type,
    v57630: state_type > $o ).

tff(pred_def_31439,type,
    v57628: state_type > $o ).

tff(pred_def_31440,type,
    v57634: state_type > $o ).

tff(pred_def_31441,type,
    v57632: state_type > $o ).

tff(pred_def_31442,type,
    v57638: state_type > $o ).

tff(pred_def_31443,type,
    v57636: state_type > $o ).

tff(pred_def_31444,type,
    v57640: state_type > $o ).

tff(pred_def_31445,type,
    v57626: state_type > $o ).

tff(pred_def_31446,type,
    v57624: state_type > $o ).

tff(pred_def_31447,type,
    v57622: state_type > $o ).

tff(pred_def_31448,type,
    v57620: state_type > $o ).

tff(pred_def_31449,type,
    v57618: state_type > $o ).

tff(pred_def_31450,type,
    v57654: state_type > $o ).

tff(pred_def_31451,type,
    v57652: state_type > $o ).

tff(pred_def_31452,type,
    v57658: state_type > $o ).

tff(pred_def_31453,type,
    v57656: state_type > $o ).

tff(pred_def_31454,type,
    v57662: state_type > $o ).

tff(pred_def_31455,type,
    v57660: state_type > $o ).

tff(pred_def_31456,type,
    v57664: state_type > $o ).

tff(pred_def_31457,type,
    v57650: state_type > $o ).

tff(pred_def_31458,type,
    v57648: state_type > $o ).

tff(pred_def_31459,type,
    v57646: state_type > $o ).

tff(pred_def_31460,type,
    v57644: state_type > $o ).

tff(pred_def_31461,type,
    v57642: state_type > $o ).

tff(pred_def_31462,type,
    v57666: state_type > $o ).

tff(pred_def_31463,type,
    v57592: state_type > $o ).

tff(pred_def_31464,type,
    v57590: state_type > $o ).

tff(pred_def_31465,type,
    v57588: state_type > $o ).

tff(pred_def_31466,type,
    v57586: state_type > $o ).

tff(pred_def_31467,type,
    v57584: state_type > $o ).

tff(pred_def_31468,type,
    v57668: state_type > $o ).

tff(pred_def_31469,type,
    v57414: state_type > $o ).

tff(pred_def_31470,type,
    v57412: state_type > $o ).

tff(pred_def_31471,type,
    v57410: state_type > $o ).

tff(pred_def_31472,type,
    v57408: state_type > $o ).

tff(pred_def_31473,type,
    v57406: state_type > $o ).

tff(pred_def_31474,type,
    v57692: state_type > $o ).

tff(pred_def_31475,type,
    v57690: state_type > $o ).

tff(pred_def_31476,type,
    v57696: state_type > $o ).

tff(pred_def_31477,type,
    v57694: state_type > $o ).

tff(pred_def_31478,type,
    v57700: state_type > $o ).

tff(pred_def_31479,type,
    v57698: state_type > $o ).

tff(pred_def_31480,type,
    v57702: state_type > $o ).

tff(pred_def_31481,type,
    v57688: state_type > $o ).

tff(pred_def_31482,type,
    v57686: state_type > $o ).

tff(pred_def_31483,type,
    v57684: state_type > $o ).

tff(pred_def_31484,type,
    v57682: state_type > $o ).

tff(pred_def_31485,type,
    v57680: state_type > $o ).

tff(pred_def_31486,type,
    v57726: state_type > $o ).

tff(pred_def_31487,type,
    v57724: state_type > $o ).

tff(pred_def_31488,type,
    v57730: state_type > $o ).

tff(pred_def_31489,type,
    v57728: state_type > $o ).

tff(pred_def_31490,type,
    v57734: state_type > $o ).

tff(pred_def_31491,type,
    v57732: state_type > $o ).

tff(pred_def_31492,type,
    v57736: state_type > $o ).

tff(pred_def_31493,type,
    v57722: state_type > $o ).

tff(pred_def_31494,type,
    v57720: state_type > $o ).

tff(pred_def_31495,type,
    v57718: state_type > $o ).

tff(pred_def_31496,type,
    v57716: state_type > $o ).

tff(pred_def_31497,type,
    v57714: state_type > $o ).

tff(pred_def_31498,type,
    v57750: state_type > $o ).

tff(pred_def_31499,type,
    v57748: state_type > $o ).

tff(pred_def_31500,type,
    v57754: state_type > $o ).

tff(pred_def_31501,type,
    v57752: state_type > $o ).

tff(pred_def_31502,type,
    v57758: state_type > $o ).

tff(pred_def_31503,type,
    v57756: state_type > $o ).

tff(pred_def_31504,type,
    v57760: state_type > $o ).

tff(pred_def_31505,type,
    v57746: state_type > $o ).

tff(pred_def_31506,type,
    v57744: state_type > $o ).

tff(pred_def_31507,type,
    v57742: state_type > $o ).

tff(pred_def_31508,type,
    v57740: state_type > $o ).

tff(pred_def_31509,type,
    v57738: state_type > $o ).

tff(pred_def_31510,type,
    v57774: state_type > $o ).

tff(pred_def_31511,type,
    v57772: state_type > $o ).

tff(pred_def_31512,type,
    v57778: state_type > $o ).

tff(pred_def_31513,type,
    v57776: state_type > $o ).

tff(pred_def_31514,type,
    v57782: state_type > $o ).

tff(pred_def_31515,type,
    v57780: state_type > $o ).

tff(pred_def_31516,type,
    v57784: state_type > $o ).

tff(pred_def_31517,type,
    v57770: state_type > $o ).

tff(pred_def_31518,type,
    v57768: state_type > $o ).

tff(pred_def_31519,type,
    v57766: state_type > $o ).

tff(pred_def_31520,type,
    v57764: state_type > $o ).

tff(pred_def_31521,type,
    v57762: state_type > $o ).

tff(pred_def_31522,type,
    v57786: state_type > $o ).

tff(pred_def_31523,type,
    v57712: state_type > $o ).

tff(pred_def_31524,type,
    v57710: state_type > $o ).

tff(pred_def_31525,type,
    v57708: state_type > $o ).

tff(pred_def_31526,type,
    v57706: state_type > $o ).

tff(pred_def_31527,type,
    v57704: state_type > $o ).

tff(pred_def_31528,type,
    v57796: state_type > $o ).

tff(pred_def_31529,type,
    v57794: state_type > $o ).

tff(pred_def_31530,type,
    v57793: state_type > $o ).

tff(pred_def_31531,type,
    v57792: ( state_type * $int ) > $o ).

tff(pred_def_31532,type,
    v57790: state_type > $o ).

tff(pred_def_31533,type,
    v57788: state_type > $o ).

tff(pred_def_31534,type,
    v57800: state_type > $o ).

tff(pred_def_31535,type,
    v57678: state_type > $o ).

tff(pred_def_31536,type,
    v57676: state_type > $o ).

tff(pred_def_31537,type,
    v57674: state_type > $o ).

tff(pred_def_31538,type,
    v57672: state_type > $o ).

tff(pred_def_31539,type,
    v57670: state_type > $o ).

tff(pred_def_31540,type,
    v57802: state_type > $o ).

tff(pred_def_31541,type,
    v57140: state_type > $o ).

tff(pred_def_31542,type,
    v57138: state_type > $o ).

tff(pred_def_31543,type,
    v57136: state_type > $o ).

tff(pred_def_31544,type,
    v57134: state_type > $o ).

tff(pred_def_31545,type,
    v57804: state_type > $o ).

tff(pred_def_31546,type,
    v56455: state_type > $o ).

tff(pred_def_31547,type,
    v56453: state_type > $o ).

tff(pred_def_31548,type,
    v56451: state_type > $o ).

tff(pred_def_31549,type,
    v56449: state_type > $o ).

tff(pred_def_31550,type,
    v56447: state_type > $o ).

tff(pred_def_31551,type,
    v57856: state_type > $o ).

tff(pred_def_31552,type,
    v57854: state_type > $o ).

tff(pred_def_31553,type,
    v57860: state_type > $o ).

tff(pred_def_31554,type,
    v57858: state_type > $o ).

tff(pred_def_31555,type,
    v57864: state_type > $o ).

tff(pred_def_31556,type,
    v57862: state_type > $o ).

tff(pred_def_31557,type,
    v57866: state_type > $o ).

tff(pred_def_31558,type,
    v57852: state_type > $o ).

tff(pred_def_31559,type,
    v57850: state_type > $o ).

tff(pred_def_31560,type,
    v57848: state_type > $o ).

tff(pred_def_31561,type,
    v57846: state_type > $o ).

tff(pred_def_31562,type,
    v57844: state_type > $o ).

tff(pred_def_31563,type,
    v57880: state_type > $o ).

tff(pred_def_31564,type,
    v57878: state_type > $o ).

tff(pred_def_31565,type,
    v57884: state_type > $o ).

tff(pred_def_31566,type,
    v57882: state_type > $o ).

tff(pred_def_31567,type,
    v57888: state_type > $o ).

tff(pred_def_31568,type,
    v57886: state_type > $o ).

tff(pred_def_31569,type,
    v57890: state_type > $o ).

tff(pred_def_31570,type,
    v57876: state_type > $o ).

tff(pred_def_31571,type,
    v57874: state_type > $o ).

tff(pred_def_31572,type,
    v57872: state_type > $o ).

tff(pred_def_31573,type,
    v57870: state_type > $o ).

tff(pred_def_31574,type,
    v57868: state_type > $o ).

tff(pred_def_31575,type,
    v57904: state_type > $o ).

tff(pred_def_31576,type,
    v57902: state_type > $o ).

tff(pred_def_31577,type,
    v57908: state_type > $o ).

tff(pred_def_31578,type,
    v57906: state_type > $o ).

tff(pred_def_31579,type,
    v57912: state_type > $o ).

tff(pred_def_31580,type,
    v57910: state_type > $o ).

tff(pred_def_31581,type,
    v57914: state_type > $o ).

tff(pred_def_31582,type,
    v57900: state_type > $o ).

tff(pred_def_31583,type,
    v57898: state_type > $o ).

tff(pred_def_31584,type,
    v57896: state_type > $o ).

tff(pred_def_31585,type,
    v57894: state_type > $o ).

tff(pred_def_31586,type,
    v57892: state_type > $o ).

tff(pred_def_31587,type,
    v57916: state_type > $o ).

tff(pred_def_31588,type,
    v57842: state_type > $o ).

tff(pred_def_31589,type,
    v57840: state_type > $o ).

tff(pred_def_31590,type,
    v57838: state_type > $o ).

tff(pred_def_31591,type,
    v57836: state_type > $o ).

tff(pred_def_31592,type,
    v57834: state_type > $o ).

tff(pred_def_31593,type,
    v57940: state_type > $o ).

tff(pred_def_31594,type,
    v57938: state_type > $o ).

tff(pred_def_31595,type,
    v57944: state_type > $o ).

tff(pred_def_31596,type,
    v57942: state_type > $o ).

tff(pred_def_31597,type,
    v57948: state_type > $o ).

tff(pred_def_31598,type,
    v57946: state_type > $o ).

tff(pred_def_31599,type,
    v57950: state_type > $o ).

tff(pred_def_31600,type,
    v57936: state_type > $o ).

tff(pred_def_31601,type,
    v57934: state_type > $o ).

tff(pred_def_31602,type,
    v57932: state_type > $o ).

tff(pred_def_31603,type,
    v57930: state_type > $o ).

tff(pred_def_31604,type,
    v57928: state_type > $o ).

tff(pred_def_31605,type,
    v57964: state_type > $o ).

tff(pred_def_31606,type,
    v57962: state_type > $o ).

tff(pred_def_31607,type,
    v57968: state_type > $o ).

tff(pred_def_31608,type,
    v57966: state_type > $o ).

tff(pred_def_31609,type,
    v57972: state_type > $o ).

tff(pred_def_31610,type,
    v57970: state_type > $o ).

tff(pred_def_31611,type,
    v57974: state_type > $o ).

tff(pred_def_31612,type,
    v57960: state_type > $o ).

tff(pred_def_31613,type,
    v57958: state_type > $o ).

tff(pred_def_31614,type,
    v57956: state_type > $o ).

tff(pred_def_31615,type,
    v57954: state_type > $o ).

tff(pred_def_31616,type,
    v57952: state_type > $o ).

tff(pred_def_31617,type,
    v57988: state_type > $o ).

tff(pred_def_31618,type,
    v57986: state_type > $o ).

tff(pred_def_31619,type,
    v57992: state_type > $o ).

tff(pred_def_31620,type,
    v57990: state_type > $o ).

tff(pred_def_31621,type,
    v57996: state_type > $o ).

tff(pred_def_31622,type,
    v57994: state_type > $o ).

tff(pred_def_31623,type,
    v57998: state_type > $o ).

tff(pred_def_31624,type,
    v57984: state_type > $o ).

tff(pred_def_31625,type,
    v57982: state_type > $o ).

tff(pred_def_31626,type,
    v57980: state_type > $o ).

tff(pred_def_31627,type,
    v57978: state_type > $o ).

tff(pred_def_31628,type,
    v57976: state_type > $o ).

tff(pred_def_31629,type,
    v58000: state_type > $o ).

tff(pred_def_31630,type,
    v57926: state_type > $o ).

tff(pred_def_31631,type,
    v57924: state_type > $o ).

tff(pred_def_31632,type,
    v57922: state_type > $o ).

tff(pred_def_31633,type,
    v57920: state_type > $o ).

tff(pred_def_31634,type,
    v57918: state_type > $o ).

tff(pred_def_31635,type,
    v58024: state_type > $o ).

tff(pred_def_31636,type,
    v58022: state_type > $o ).

tff(pred_def_31637,type,
    v58028: state_type > $o ).

tff(pred_def_31638,type,
    v58026: state_type > $o ).

tff(pred_def_31639,type,
    v58032: state_type > $o ).

tff(pred_def_31640,type,
    v58030: state_type > $o ).

tff(pred_def_31641,type,
    v58034: state_type > $o ).

tff(pred_def_31642,type,
    v58020: state_type > $o ).

tff(pred_def_31643,type,
    v58018: state_type > $o ).

tff(pred_def_31644,type,
    v58016: state_type > $o ).

tff(pred_def_31645,type,
    v58014: state_type > $o ).

tff(pred_def_31646,type,
    v58012: state_type > $o ).

tff(pred_def_31647,type,
    v58048: state_type > $o ).

tff(pred_def_31648,type,
    v58046: state_type > $o ).

tff(pred_def_31649,type,
    v58052: state_type > $o ).

tff(pred_def_31650,type,
    v58050: state_type > $o ).

tff(pred_def_31651,type,
    v58056: state_type > $o ).

tff(pred_def_31652,type,
    v58054: state_type > $o ).

tff(pred_def_31653,type,
    v58058: state_type > $o ).

tff(pred_def_31654,type,
    v58044: state_type > $o ).

tff(pred_def_31655,type,
    v58042: state_type > $o ).

tff(pred_def_31656,type,
    v58040: state_type > $o ).

tff(pred_def_31657,type,
    v58038: state_type > $o ).

tff(pred_def_31658,type,
    v58036: state_type > $o ).

tff(pred_def_31659,type,
    v58072: state_type > $o ).

tff(pred_def_31660,type,
    v58070: state_type > $o ).

tff(pred_def_31661,type,
    v58076: state_type > $o ).

tff(pred_def_31662,type,
    v58074: state_type > $o ).

tff(pred_def_31663,type,
    v58080: state_type > $o ).

tff(pred_def_31664,type,
    v58078: state_type > $o ).

tff(pred_def_31665,type,
    v58082: state_type > $o ).

tff(pred_def_31666,type,
    v58068: state_type > $o ).

tff(pred_def_31667,type,
    v58066: state_type > $o ).

tff(pred_def_31668,type,
    v58064: state_type > $o ).

tff(pred_def_31669,type,
    v58062: state_type > $o ).

tff(pred_def_31670,type,
    v58060: state_type > $o ).

tff(pred_def_31671,type,
    v58084: state_type > $o ).

tff(pred_def_31672,type,
    v58010: state_type > $o ).

tff(pred_def_31673,type,
    v58008: state_type > $o ).

tff(pred_def_31674,type,
    v58006: state_type > $o ).

tff(pred_def_31675,type,
    v58004: state_type > $o ).

tff(pred_def_31676,type,
    v58002: state_type > $o ).

tff(pred_def_31677,type,
    v58086: state_type > $o ).

tff(pred_def_31678,type,
    v57832: state_type > $o ).

tff(pred_def_31679,type,
    v57830: state_type > $o ).

tff(pred_def_31680,type,
    v57828: state_type > $o ).

tff(pred_def_31681,type,
    v57826: state_type > $o ).

tff(pred_def_31682,type,
    v57824: state_type > $o ).

tff(pred_def_31683,type,
    v58120: state_type > $o ).

tff(pred_def_31684,type,
    v58118: state_type > $o ).

tff(pred_def_31685,type,
    v58124: state_type > $o ).

tff(pred_def_31686,type,
    v58122: state_type > $o ).

tff(pred_def_31687,type,
    v58128: state_type > $o ).

tff(pred_def_31688,type,
    v58126: state_type > $o ).

tff(pred_def_31689,type,
    v58130: state_type > $o ).

tff(pred_def_31690,type,
    v58116: state_type > $o ).

tff(pred_def_31691,type,
    v58114: state_type > $o ).

tff(pred_def_31692,type,
    v58112: state_type > $o ).

tff(pred_def_31693,type,
    v58110: state_type > $o ).

tff(pred_def_31694,type,
    v58108: state_type > $o ).

tff(pred_def_31695,type,
    v58144: state_type > $o ).

tff(pred_def_31696,type,
    v58142: state_type > $o ).

tff(pred_def_31697,type,
    v58148: state_type > $o ).

tff(pred_def_31698,type,
    v58146: state_type > $o ).

tff(pred_def_31699,type,
    v58152: state_type > $o ).

tff(pred_def_31700,type,
    v58150: state_type > $o ).

tff(pred_def_31701,type,
    v58154: state_type > $o ).

tff(pred_def_31702,type,
    v58140: state_type > $o ).

tff(pred_def_31703,type,
    v58138: state_type > $o ).

tff(pred_def_31704,type,
    v58136: state_type > $o ).

tff(pred_def_31705,type,
    v58134: state_type > $o ).

tff(pred_def_31706,type,
    v58132: state_type > $o ).

tff(pred_def_31707,type,
    v58168: state_type > $o ).

tff(pred_def_31708,type,
    v58166: state_type > $o ).

tff(pred_def_31709,type,
    v58172: state_type > $o ).

tff(pred_def_31710,type,
    v58170: state_type > $o ).

tff(pred_def_31711,type,
    v58176: state_type > $o ).

tff(pred_def_31712,type,
    v58174: state_type > $o ).

tff(pred_def_31713,type,
    v58178: state_type > $o ).

tff(pred_def_31714,type,
    v58164: state_type > $o ).

tff(pred_def_31715,type,
    v58162: state_type > $o ).

tff(pred_def_31716,type,
    v58160: state_type > $o ).

tff(pred_def_31717,type,
    v58158: state_type > $o ).

tff(pred_def_31718,type,
    v58156: state_type > $o ).

tff(pred_def_31719,type,
    v58180: state_type > $o ).

tff(pred_def_31720,type,
    v58106: state_type > $o ).

tff(pred_def_31721,type,
    v58104: state_type > $o ).

tff(pred_def_31722,type,
    v58102: state_type > $o ).

tff(pred_def_31723,type,
    v58100: state_type > $o ).

tff(pred_def_31724,type,
    v58098: state_type > $o ).

tff(pred_def_31725,type,
    v58204: state_type > $o ).

tff(pred_def_31726,type,
    v58202: state_type > $o ).

tff(pred_def_31727,type,
    v58208: state_type > $o ).

tff(pred_def_31728,type,
    v58206: state_type > $o ).

tff(pred_def_31729,type,
    v58212: state_type > $o ).

tff(pred_def_31730,type,
    v58210: state_type > $o ).

tff(pred_def_31731,type,
    v58214: state_type > $o ).

tff(pred_def_31732,type,
    v58200: state_type > $o ).

tff(pred_def_31733,type,
    v58198: state_type > $o ).

tff(pred_def_31734,type,
    v58196: state_type > $o ).

tff(pred_def_31735,type,
    v58194: state_type > $o ).

tff(pred_def_31736,type,
    v58192: state_type > $o ).

tff(pred_def_31737,type,
    v58228: state_type > $o ).

tff(pred_def_31738,type,
    v58226: state_type > $o ).

tff(pred_def_31739,type,
    v58232: state_type > $o ).

tff(pred_def_31740,type,
    v58230: state_type > $o ).

tff(pred_def_31741,type,
    v58236: state_type > $o ).

tff(pred_def_31742,type,
    v58234: state_type > $o ).

tff(pred_def_31743,type,
    v58238: state_type > $o ).

tff(pred_def_31744,type,
    v58224: state_type > $o ).

tff(pred_def_31745,type,
    v58222: state_type > $o ).

tff(pred_def_31746,type,
    v58220: state_type > $o ).

tff(pred_def_31747,type,
    v58218: state_type > $o ).

tff(pred_def_31748,type,
    v58216: state_type > $o ).

tff(pred_def_31749,type,
    v58252: state_type > $o ).

tff(pred_def_31750,type,
    v58250: state_type > $o ).

tff(pred_def_31751,type,
    v58256: state_type > $o ).

tff(pred_def_31752,type,
    v58254: state_type > $o ).

tff(pred_def_31753,type,
    v58260: state_type > $o ).

tff(pred_def_31754,type,
    v58258: state_type > $o ).

tff(pred_def_31755,type,
    v58262: state_type > $o ).

tff(pred_def_31756,type,
    v58248: state_type > $o ).

tff(pred_def_31757,type,
    v58246: state_type > $o ).

tff(pred_def_31758,type,
    v58244: state_type > $o ).

tff(pred_def_31759,type,
    v58242: state_type > $o ).

tff(pred_def_31760,type,
    v58240: state_type > $o ).

tff(pred_def_31761,type,
    v58264: state_type > $o ).

tff(pred_def_31762,type,
    v58190: state_type > $o ).

tff(pred_def_31763,type,
    v58188: state_type > $o ).

tff(pred_def_31764,type,
    v58186: state_type > $o ).

tff(pred_def_31765,type,
    v58184: state_type > $o ).

tff(pred_def_31766,type,
    v58182: state_type > $o ).

tff(pred_def_31767,type,
    v58288: state_type > $o ).

tff(pred_def_31768,type,
    v58286: state_type > $o ).

tff(pred_def_31769,type,
    v58292: state_type > $o ).

tff(pred_def_31770,type,
    v58290: state_type > $o ).

tff(pred_def_31771,type,
    v58296: state_type > $o ).

tff(pred_def_31772,type,
    v58294: state_type > $o ).

tff(pred_def_31773,type,
    v58298: state_type > $o ).

tff(pred_def_31774,type,
    v58284: state_type > $o ).

tff(pred_def_31775,type,
    v58282: state_type > $o ).

tff(pred_def_31776,type,
    v58280: state_type > $o ).

tff(pred_def_31777,type,
    v58278: state_type > $o ).

tff(pred_def_31778,type,
    v58276: state_type > $o ).

tff(pred_def_31779,type,
    v58312: state_type > $o ).

tff(pred_def_31780,type,
    v58310: state_type > $o ).

tff(pred_def_31781,type,
    v58316: state_type > $o ).

tff(pred_def_31782,type,
    v58314: state_type > $o ).

tff(pred_def_31783,type,
    v58320: state_type > $o ).

tff(pred_def_31784,type,
    v58318: state_type > $o ).

tff(pred_def_31785,type,
    v58322: state_type > $o ).

tff(pred_def_31786,type,
    v58308: state_type > $o ).

tff(pred_def_31787,type,
    v58306: state_type > $o ).

tff(pred_def_31788,type,
    v58304: state_type > $o ).

tff(pred_def_31789,type,
    v58302: state_type > $o ).

tff(pred_def_31790,type,
    v58300: state_type > $o ).

tff(pred_def_31791,type,
    v58336: state_type > $o ).

tff(pred_def_31792,type,
    v58334: state_type > $o ).

tff(pred_def_31793,type,
    v58340: state_type > $o ).

tff(pred_def_31794,type,
    v58338: state_type > $o ).

tff(pred_def_31795,type,
    v58344: state_type > $o ).

tff(pred_def_31796,type,
    v58342: state_type > $o ).

tff(pred_def_31797,type,
    v58346: state_type > $o ).

tff(pred_def_31798,type,
    v58332: state_type > $o ).

tff(pred_def_31799,type,
    v58330: state_type > $o ).

tff(pred_def_31800,type,
    v58328: state_type > $o ).

tff(pred_def_31801,type,
    v58326: state_type > $o ).

tff(pred_def_31802,type,
    v58324: state_type > $o ).

tff(pred_def_31803,type,
    v58348: state_type > $o ).

tff(pred_def_31804,type,
    v58274: state_type > $o ).

tff(pred_def_31805,type,
    v58272: state_type > $o ).

tff(pred_def_31806,type,
    v58270: state_type > $o ).

tff(pred_def_31807,type,
    v58268: state_type > $o ).

tff(pred_def_31808,type,
    v58266: state_type > $o ).

tff(pred_def_31809,type,
    v58350: state_type > $o ).

tff(pred_def_31810,type,
    v58096: state_type > $o ).

tff(pred_def_31811,type,
    v58094: state_type > $o ).

tff(pred_def_31812,type,
    v58092: state_type > $o ).

tff(pred_def_31813,type,
    v58090: state_type > $o ).

tff(pred_def_31814,type,
    v58088: state_type > $o ).

tff(pred_def_31815,type,
    v58374: state_type > $o ).

tff(pred_def_31816,type,
    v58372: state_type > $o ).

tff(pred_def_31817,type,
    v58378: state_type > $o ).

tff(pred_def_31818,type,
    v58376: state_type > $o ).

tff(pred_def_31819,type,
    v58382: state_type > $o ).

tff(pred_def_31820,type,
    v58380: state_type > $o ).

tff(pred_def_31821,type,
    v58384: state_type > $o ).

tff(pred_def_31822,type,
    v58370: state_type > $o ).

tff(pred_def_31823,type,
    v58368: state_type > $o ).

tff(pred_def_31824,type,
    v58366: state_type > $o ).

tff(pred_def_31825,type,
    v58364: state_type > $o ).

tff(pred_def_31826,type,
    v58362: state_type > $o ).

tff(pred_def_31827,type,
    v58408: state_type > $o ).

tff(pred_def_31828,type,
    v58406: state_type > $o ).

tff(pred_def_31829,type,
    v58412: state_type > $o ).

tff(pred_def_31830,type,
    v58410: state_type > $o ).

tff(pred_def_31831,type,
    v58416: state_type > $o ).

tff(pred_def_31832,type,
    v58414: state_type > $o ).

tff(pred_def_31833,type,
    v58418: state_type > $o ).

tff(pred_def_31834,type,
    v58404: state_type > $o ).

tff(pred_def_31835,type,
    v58402: state_type > $o ).

tff(pred_def_31836,type,
    v58400: state_type > $o ).

tff(pred_def_31837,type,
    v58398: state_type > $o ).

tff(pred_def_31838,type,
    v58396: state_type > $o ).

tff(pred_def_31839,type,
    v58432: state_type > $o ).

tff(pred_def_31840,type,
    v58430: state_type > $o ).

tff(pred_def_31841,type,
    v58436: state_type > $o ).

tff(pred_def_31842,type,
    v58434: state_type > $o ).

tff(pred_def_31843,type,
    v58440: state_type > $o ).

tff(pred_def_31844,type,
    v58438: state_type > $o ).

tff(pred_def_31845,type,
    v58442: state_type > $o ).

tff(pred_def_31846,type,
    v58428: state_type > $o ).

tff(pred_def_31847,type,
    v58426: state_type > $o ).

tff(pred_def_31848,type,
    v58424: state_type > $o ).

tff(pred_def_31849,type,
    v58422: state_type > $o ).

tff(pred_def_31850,type,
    v58420: state_type > $o ).

tff(pred_def_31851,type,
    v58456: state_type > $o ).

tff(pred_def_31852,type,
    v58454: state_type > $o ).

tff(pred_def_31853,type,
    v58460: state_type > $o ).

tff(pred_def_31854,type,
    v58458: state_type > $o ).

tff(pred_def_31855,type,
    v58464: state_type > $o ).

tff(pred_def_31856,type,
    v58462: state_type > $o ).

tff(pred_def_31857,type,
    v58466: state_type > $o ).

tff(pred_def_31858,type,
    v58452: state_type > $o ).

tff(pred_def_31859,type,
    v58450: state_type > $o ).

tff(pred_def_31860,type,
    v58448: state_type > $o ).

tff(pred_def_31861,type,
    v58446: state_type > $o ).

tff(pred_def_31862,type,
    v58444: state_type > $o ).

tff(pred_def_31863,type,
    v58468: state_type > $o ).

tff(pred_def_31864,type,
    v58394: state_type > $o ).

tff(pred_def_31865,type,
    v58392: state_type > $o ).

tff(pred_def_31866,type,
    v58390: state_type > $o ).

tff(pred_def_31867,type,
    v58388: state_type > $o ).

tff(pred_def_31868,type,
    v58386: state_type > $o ).

tff(pred_def_31869,type,
    v58478: state_type > $o ).

tff(pred_def_31870,type,
    v58476: state_type > $o ).

tff(pred_def_31871,type,
    v58475: state_type > $o ).

tff(pred_def_31872,type,
    v58474: ( state_type * $int ) > $o ).

tff(pred_def_31873,type,
    v58472: state_type > $o ).

tff(pred_def_31874,type,
    v58470: state_type > $o ).

tff(pred_def_31875,type,
    v58482: state_type > $o ).

tff(pred_def_31876,type,
    v58360: state_type > $o ).

tff(pred_def_31877,type,
    v58358: state_type > $o ).

tff(pred_def_31878,type,
    v58356: state_type > $o ).

tff(pred_def_31879,type,
    v58354: state_type > $o ).

tff(pred_def_31880,type,
    v58352: state_type > $o ).

tff(pred_def_31881,type,
    v58484: state_type > $o ).

tff(pred_def_31882,type,
    v57822: state_type > $o ).

tff(pred_def_31883,type,
    v57820: state_type > $o ).

tff(pred_def_31884,type,
    v57818: state_type > $o ).

tff(pred_def_31885,type,
    v57816: state_type > $o ).

tff(pred_def_31886,type,
    v58526: state_type > $o ).

tff(pred_def_31887,type,
    v58524: state_type > $o ).

tff(pred_def_31888,type,
    v58530: state_type > $o ).

tff(pred_def_31889,type,
    v58528: state_type > $o ).

tff(pred_def_31890,type,
    v58534: state_type > $o ).

tff(pred_def_31891,type,
    v58532: state_type > $o ).

tff(pred_def_31892,type,
    v58536: state_type > $o ).

tff(pred_def_31893,type,
    v58522: state_type > $o ).

tff(pred_def_31894,type,
    v58520: state_type > $o ).

tff(pred_def_31895,type,
    v58518: state_type > $o ).

tff(pred_def_31896,type,
    v58516: state_type > $o ).

tff(pred_def_31897,type,
    v58514: state_type > $o ).

tff(pred_def_31898,type,
    v58550: state_type > $o ).

tff(pred_def_31899,type,
    v58548: state_type > $o ).

tff(pred_def_31900,type,
    v58554: state_type > $o ).

tff(pred_def_31901,type,
    v58552: state_type > $o ).

tff(pred_def_31902,type,
    v58558: state_type > $o ).

tff(pred_def_31903,type,
    v58556: state_type > $o ).

tff(pred_def_31904,type,
    v58560: state_type > $o ).

tff(pred_def_31905,type,
    v58546: state_type > $o ).

tff(pred_def_31906,type,
    v58544: state_type > $o ).

tff(pred_def_31907,type,
    v58542: state_type > $o ).

tff(pred_def_31908,type,
    v58540: state_type > $o ).

tff(pred_def_31909,type,
    v58538: state_type > $o ).

tff(pred_def_31910,type,
    v58574: state_type > $o ).

tff(pred_def_31911,type,
    v58572: state_type > $o ).

tff(pred_def_31912,type,
    v58578: state_type > $o ).

tff(pred_def_31913,type,
    v58576: state_type > $o ).

tff(pred_def_31914,type,
    v58582: state_type > $o ).

tff(pred_def_31915,type,
    v58580: state_type > $o ).

tff(pred_def_31916,type,
    v58584: state_type > $o ).

tff(pred_def_31917,type,
    v58570: state_type > $o ).

tff(pred_def_31918,type,
    v58568: state_type > $o ).

tff(pred_def_31919,type,
    v58566: state_type > $o ).

tff(pred_def_31920,type,
    v58564: state_type > $o ).

tff(pred_def_31921,type,
    v58562: state_type > $o ).

tff(pred_def_31922,type,
    v58586: state_type > $o ).

tff(pred_def_31923,type,
    v58512: state_type > $o ).

tff(pred_def_31924,type,
    v58510: state_type > $o ).

tff(pred_def_31925,type,
    v58508: state_type > $o ).

tff(pred_def_31926,type,
    v58506: state_type > $o ).

tff(pred_def_31927,type,
    v58504: state_type > $o ).

tff(pred_def_31928,type,
    v58610: state_type > $o ).

tff(pred_def_31929,type,
    v58608: state_type > $o ).

tff(pred_def_31930,type,
    v58614: state_type > $o ).

tff(pred_def_31931,type,
    v58612: state_type > $o ).

tff(pred_def_31932,type,
    v58618: state_type > $o ).

tff(pred_def_31933,type,
    v58616: state_type > $o ).

tff(pred_def_31934,type,
    v58620: state_type > $o ).

tff(pred_def_31935,type,
    v58606: state_type > $o ).

tff(pred_def_31936,type,
    v58604: state_type > $o ).

tff(pred_def_31937,type,
    v58602: state_type > $o ).

tff(pred_def_31938,type,
    v58600: state_type > $o ).

tff(pred_def_31939,type,
    v58598: state_type > $o ).

tff(pred_def_31940,type,
    v58634: state_type > $o ).

tff(pred_def_31941,type,
    v58632: state_type > $o ).

tff(pred_def_31942,type,
    v58638: state_type > $o ).

tff(pred_def_31943,type,
    v58636: state_type > $o ).

tff(pred_def_31944,type,
    v58642: state_type > $o ).

tff(pred_def_31945,type,
    v58640: state_type > $o ).

tff(pred_def_31946,type,
    v58644: state_type > $o ).

tff(pred_def_31947,type,
    v58630: state_type > $o ).

tff(pred_def_31948,type,
    v58628: state_type > $o ).

tff(pred_def_31949,type,
    v58626: state_type > $o ).

tff(pred_def_31950,type,
    v58624: state_type > $o ).

tff(pred_def_31951,type,
    v58622: state_type > $o ).

tff(pred_def_31952,type,
    v58658: state_type > $o ).

tff(pred_def_31953,type,
    v58656: state_type > $o ).

tff(pred_def_31954,type,
    v58662: state_type > $o ).

tff(pred_def_31955,type,
    v58660: state_type > $o ).

tff(pred_def_31956,type,
    v58666: state_type > $o ).

tff(pred_def_31957,type,
    v58664: state_type > $o ).

tff(pred_def_31958,type,
    v58668: state_type > $o ).

tff(pred_def_31959,type,
    v58654: state_type > $o ).

tff(pred_def_31960,type,
    v58652: state_type > $o ).

tff(pred_def_31961,type,
    v58650: state_type > $o ).

tff(pred_def_31962,type,
    v58648: state_type > $o ).

tff(pred_def_31963,type,
    v58646: state_type > $o ).

tff(pred_def_31964,type,
    v58670: state_type > $o ).

tff(pred_def_31965,type,
    v58596: state_type > $o ).

tff(pred_def_31966,type,
    v58594: state_type > $o ).

tff(pred_def_31967,type,
    v58592: state_type > $o ).

tff(pred_def_31968,type,
    v58590: state_type > $o ).

tff(pred_def_31969,type,
    v58588: state_type > $o ).

tff(pred_def_31970,type,
    v58694: state_type > $o ).

tff(pred_def_31971,type,
    v58692: state_type > $o ).

tff(pred_def_31972,type,
    v58698: state_type > $o ).

tff(pred_def_31973,type,
    v58696: state_type > $o ).

tff(pred_def_31974,type,
    v58702: state_type > $o ).

tff(pred_def_31975,type,
    v58700: state_type > $o ).

tff(pred_def_31976,type,
    v58704: state_type > $o ).

tff(pred_def_31977,type,
    v58690: state_type > $o ).

tff(pred_def_31978,type,
    v58688: state_type > $o ).

tff(pred_def_31979,type,
    v58686: state_type > $o ).

tff(pred_def_31980,type,
    v58684: state_type > $o ).

tff(pred_def_31981,type,
    v58682: state_type > $o ).

tff(pred_def_31982,type,
    v58718: state_type > $o ).

tff(pred_def_31983,type,
    v58716: state_type > $o ).

tff(pred_def_31984,type,
    v58722: state_type > $o ).

tff(pred_def_31985,type,
    v58720: state_type > $o ).

tff(pred_def_31986,type,
    v58726: state_type > $o ).

tff(pred_def_31987,type,
    v58724: state_type > $o ).

tff(pred_def_31988,type,
    v58728: state_type > $o ).

tff(pred_def_31989,type,
    v58714: state_type > $o ).

tff(pred_def_31990,type,
    v58712: state_type > $o ).

tff(pred_def_31991,type,
    v58710: state_type > $o ).

tff(pred_def_31992,type,
    v58708: state_type > $o ).

tff(pred_def_31993,type,
    v58706: state_type > $o ).

tff(pred_def_31994,type,
    v58742: state_type > $o ).

tff(pred_def_31995,type,
    v58740: state_type > $o ).

tff(pred_def_31996,type,
    v58746: state_type > $o ).

tff(pred_def_31997,type,
    v58744: state_type > $o ).

tff(pred_def_31998,type,
    v58750: state_type > $o ).

tff(pred_def_31999,type,
    v58748: state_type > $o ).

tff(pred_def_32000,type,
    v58752: state_type > $o ).

tff(pred_def_32001,type,
    v58738: state_type > $o ).

tff(pred_def_32002,type,
    v58736: state_type > $o ).

tff(pred_def_32003,type,
    v58734: state_type > $o ).

tff(pred_def_32004,type,
    v58732: state_type > $o ).

tff(pred_def_32005,type,
    v58730: state_type > $o ).

tff(pred_def_32006,type,
    v58754: state_type > $o ).

tff(pred_def_32007,type,
    v58680: state_type > $o ).

tff(pred_def_32008,type,
    v58678: state_type > $o ).

tff(pred_def_32009,type,
    v58676: state_type > $o ).

tff(pred_def_32010,type,
    v58674: state_type > $o ).

tff(pred_def_32011,type,
    v58672: state_type > $o ).

tff(pred_def_32012,type,
    v58756: state_type > $o ).

tff(pred_def_32013,type,
    v58502: state_type > $o ).

tff(pred_def_32014,type,
    v58500: state_type > $o ).

tff(pred_def_32015,type,
    v58498: state_type > $o ).

tff(pred_def_32016,type,
    v58496: state_type > $o ).

tff(pred_def_32017,type,
    v58494: state_type > $o ).

tff(pred_def_32018,type,
    v58790: state_type > $o ).

tff(pred_def_32019,type,
    v58788: state_type > $o ).

tff(pred_def_32020,type,
    v58794: state_type > $o ).

tff(pred_def_32021,type,
    v58792: state_type > $o ).

tff(pred_def_32022,type,
    v58798: state_type > $o ).

tff(pred_def_32023,type,
    v58796: state_type > $o ).

tff(pred_def_32024,type,
    v58800: state_type > $o ).

tff(pred_def_32025,type,
    v58786: state_type > $o ).

tff(pred_def_32026,type,
    v58784: state_type > $o ).

tff(pred_def_32027,type,
    v58782: state_type > $o ).

tff(pred_def_32028,type,
    v58780: state_type > $o ).

tff(pred_def_32029,type,
    v58778: state_type > $o ).

tff(pred_def_32030,type,
    v58814: state_type > $o ).

tff(pred_def_32031,type,
    v58812: state_type > $o ).

tff(pred_def_32032,type,
    v58818: state_type > $o ).

tff(pred_def_32033,type,
    v58816: state_type > $o ).

tff(pred_def_32034,type,
    v58822: state_type > $o ).

tff(pred_def_32035,type,
    v58820: state_type > $o ).

tff(pred_def_32036,type,
    v58824: state_type > $o ).

tff(pred_def_32037,type,
    v58810: state_type > $o ).

tff(pred_def_32038,type,
    v58808: state_type > $o ).

tff(pred_def_32039,type,
    v58806: state_type > $o ).

tff(pred_def_32040,type,
    v58804: state_type > $o ).

tff(pred_def_32041,type,
    v58802: state_type > $o ).

tff(pred_def_32042,type,
    v58838: state_type > $o ).

tff(pred_def_32043,type,
    v58836: state_type > $o ).

tff(pred_def_32044,type,
    v58842: state_type > $o ).

tff(pred_def_32045,type,
    v58840: state_type > $o ).

tff(pred_def_32046,type,
    v58846: state_type > $o ).

tff(pred_def_32047,type,
    v58844: state_type > $o ).

tff(pred_def_32048,type,
    v58848: state_type > $o ).

tff(pred_def_32049,type,
    v58834: state_type > $o ).

tff(pred_def_32050,type,
    v58832: state_type > $o ).

tff(pred_def_32051,type,
    v58830: state_type > $o ).

tff(pred_def_32052,type,
    v58828: state_type > $o ).

tff(pred_def_32053,type,
    v58826: state_type > $o ).

tff(pred_def_32054,type,
    v58850: state_type > $o ).

tff(pred_def_32055,type,
    v58776: state_type > $o ).

tff(pred_def_32056,type,
    v58774: state_type > $o ).

tff(pred_def_32057,type,
    v58772: state_type > $o ).

tff(pred_def_32058,type,
    v58770: state_type > $o ).

tff(pred_def_32059,type,
    v58768: state_type > $o ).

tff(pred_def_32060,type,
    v58874: state_type > $o ).

tff(pred_def_32061,type,
    v58872: state_type > $o ).

tff(pred_def_32062,type,
    v58878: state_type > $o ).

tff(pred_def_32063,type,
    v58876: state_type > $o ).

tff(pred_def_32064,type,
    v58882: state_type > $o ).

tff(pred_def_32065,type,
    v58880: state_type > $o ).

tff(pred_def_32066,type,
    v58884: state_type > $o ).

tff(pred_def_32067,type,
    v58870: state_type > $o ).

tff(pred_def_32068,type,
    v58868: state_type > $o ).

tff(pred_def_32069,type,
    v58866: state_type > $o ).

tff(pred_def_32070,type,
    v58864: state_type > $o ).

tff(pred_def_32071,type,
    v58862: state_type > $o ).

tff(pred_def_32072,type,
    v58898: state_type > $o ).

tff(pred_def_32073,type,
    v58896: state_type > $o ).

tff(pred_def_32074,type,
    v58902: state_type > $o ).

tff(pred_def_32075,type,
    v58900: state_type > $o ).

tff(pred_def_32076,type,
    v58906: state_type > $o ).

tff(pred_def_32077,type,
    v58904: state_type > $o ).

tff(pred_def_32078,type,
    v58908: state_type > $o ).

tff(pred_def_32079,type,
    v58894: state_type > $o ).

tff(pred_def_32080,type,
    v58892: state_type > $o ).

tff(pred_def_32081,type,
    v58890: state_type > $o ).

tff(pred_def_32082,type,
    v58888: state_type > $o ).

tff(pred_def_32083,type,
    v58886: state_type > $o ).

tff(pred_def_32084,type,
    v58922: state_type > $o ).

tff(pred_def_32085,type,
    v58920: state_type > $o ).

tff(pred_def_32086,type,
    v58926: state_type > $o ).

tff(pred_def_32087,type,
    v58924: state_type > $o ).

tff(pred_def_32088,type,
    v58930: state_type > $o ).

tff(pred_def_32089,type,
    v58928: state_type > $o ).

tff(pred_def_32090,type,
    v58932: state_type > $o ).

tff(pred_def_32091,type,
    v58918: state_type > $o ).

tff(pred_def_32092,type,
    v58916: state_type > $o ).

tff(pred_def_32093,type,
    v58914: state_type > $o ).

tff(pred_def_32094,type,
    v58912: state_type > $o ).

tff(pred_def_32095,type,
    v58910: state_type > $o ).

tff(pred_def_32096,type,
    v58934: state_type > $o ).

tff(pred_def_32097,type,
    v58860: state_type > $o ).

tff(pred_def_32098,type,
    v58858: state_type > $o ).

tff(pred_def_32099,type,
    v58856: state_type > $o ).

tff(pred_def_32100,type,
    v58854: state_type > $o ).

tff(pred_def_32101,type,
    v58852: state_type > $o ).

tff(pred_def_32102,type,
    v58958: state_type > $o ).

tff(pred_def_32103,type,
    v58956: state_type > $o ).

tff(pred_def_32104,type,
    v58962: state_type > $o ).

tff(pred_def_32105,type,
    v58960: state_type > $o ).

tff(pred_def_32106,type,
    v58966: state_type > $o ).

tff(pred_def_32107,type,
    v58964: state_type > $o ).

tff(pred_def_32108,type,
    v58968: state_type > $o ).

tff(pred_def_32109,type,
    v58954: state_type > $o ).

tff(pred_def_32110,type,
    v58952: state_type > $o ).

tff(pred_def_32111,type,
    v58950: state_type > $o ).

tff(pred_def_32112,type,
    v58948: state_type > $o ).

tff(pred_def_32113,type,
    v58946: state_type > $o ).

tff(pred_def_32114,type,
    v58982: state_type > $o ).

tff(pred_def_32115,type,
    v58980: state_type > $o ).

tff(pred_def_32116,type,
    v58986: state_type > $o ).

tff(pred_def_32117,type,
    v58984: state_type > $o ).

tff(pred_def_32118,type,
    v58990: state_type > $o ).

tff(pred_def_32119,type,
    v58988: state_type > $o ).

tff(pred_def_32120,type,
    v58992: state_type > $o ).

tff(pred_def_32121,type,
    v58978: state_type > $o ).

tff(pred_def_32122,type,
    v58976: state_type > $o ).

tff(pred_def_32123,type,
    v58974: state_type > $o ).

tff(pred_def_32124,type,
    v58972: state_type > $o ).

tff(pred_def_32125,type,
    v58970: state_type > $o ).

tff(pred_def_32126,type,
    v59006: state_type > $o ).

tff(pred_def_32127,type,
    v59004: state_type > $o ).

tff(pred_def_32128,type,
    v59010: state_type > $o ).

tff(pred_def_32129,type,
    v59008: state_type > $o ).

tff(pred_def_32130,type,
    v59014: state_type > $o ).

tff(pred_def_32131,type,
    v59012: state_type > $o ).

tff(pred_def_32132,type,
    v59016: state_type > $o ).

tff(pred_def_32133,type,
    v59002: state_type > $o ).

tff(pred_def_32134,type,
    v59000: state_type > $o ).

tff(pred_def_32135,type,
    v58998: state_type > $o ).

tff(pred_def_32136,type,
    v58996: state_type > $o ).

tff(pred_def_32137,type,
    v58994: state_type > $o ).

tff(pred_def_32138,type,
    v59018: state_type > $o ).

tff(pred_def_32139,type,
    v58944: state_type > $o ).

tff(pred_def_32140,type,
    v58942: state_type > $o ).

tff(pred_def_32141,type,
    v58940: state_type > $o ).

tff(pred_def_32142,type,
    v58938: state_type > $o ).

tff(pred_def_32143,type,
    v58936: state_type > $o ).

tff(pred_def_32144,type,
    v59020: state_type > $o ).

tff(pred_def_32145,type,
    v58766: state_type > $o ).

tff(pred_def_32146,type,
    v58764: state_type > $o ).

tff(pred_def_32147,type,
    v58762: state_type > $o ).

tff(pred_def_32148,type,
    v58760: state_type > $o ).

tff(pred_def_32149,type,
    v58758: state_type > $o ).

tff(pred_def_32150,type,
    v59044: state_type > $o ).

tff(pred_def_32151,type,
    v59042: state_type > $o ).

tff(pred_def_32152,type,
    v59048: state_type > $o ).

tff(pred_def_32153,type,
    v59046: state_type > $o ).

tff(pred_def_32154,type,
    v59052: state_type > $o ).

tff(pred_def_32155,type,
    v59050: state_type > $o ).

tff(pred_def_32156,type,
    v59054: state_type > $o ).

tff(pred_def_32157,type,
    v59040: state_type > $o ).

tff(pred_def_32158,type,
    v59038: state_type > $o ).

tff(pred_def_32159,type,
    v59036: state_type > $o ).

tff(pred_def_32160,type,
    v59034: state_type > $o ).

tff(pred_def_32161,type,
    v59032: state_type > $o ).

tff(pred_def_32162,type,
    v59078: state_type > $o ).

tff(pred_def_32163,type,
    v59076: state_type > $o ).

tff(pred_def_32164,type,
    v59082: state_type > $o ).

tff(pred_def_32165,type,
    v59080: state_type > $o ).

tff(pred_def_32166,type,
    v59086: state_type > $o ).

tff(pred_def_32167,type,
    v59084: state_type > $o ).

tff(pred_def_32168,type,
    v59088: state_type > $o ).

tff(pred_def_32169,type,
    v59074: state_type > $o ).

tff(pred_def_32170,type,
    v59072: state_type > $o ).

tff(pred_def_32171,type,
    v59070: state_type > $o ).

tff(pred_def_32172,type,
    v59068: state_type > $o ).

tff(pred_def_32173,type,
    v59066: state_type > $o ).

tff(pred_def_32174,type,
    v59102: state_type > $o ).

tff(pred_def_32175,type,
    v59100: state_type > $o ).

tff(pred_def_32176,type,
    v59106: state_type > $o ).

tff(pred_def_32177,type,
    v59104: state_type > $o ).

tff(pred_def_32178,type,
    v59110: state_type > $o ).

tff(pred_def_32179,type,
    v59108: state_type > $o ).

tff(pred_def_32180,type,
    v59112: state_type > $o ).

tff(pred_def_32181,type,
    v59098: state_type > $o ).

tff(pred_def_32182,type,
    v59096: state_type > $o ).

tff(pred_def_32183,type,
    v59094: state_type > $o ).

tff(pred_def_32184,type,
    v59092: state_type > $o ).

tff(pred_def_32185,type,
    v59090: state_type > $o ).

tff(pred_def_32186,type,
    v59126: state_type > $o ).

tff(pred_def_32187,type,
    v59124: state_type > $o ).

tff(pred_def_32188,type,
    v59130: state_type > $o ).

tff(pred_def_32189,type,
    v59128: state_type > $o ).

tff(pred_def_32190,type,
    v59134: state_type > $o ).

tff(pred_def_32191,type,
    v59132: state_type > $o ).

tff(pred_def_32192,type,
    v59136: state_type > $o ).

tff(pred_def_32193,type,
    v59122: state_type > $o ).

tff(pred_def_32194,type,
    v59120: state_type > $o ).

tff(pred_def_32195,type,
    v59118: state_type > $o ).

tff(pred_def_32196,type,
    v59116: state_type > $o ).

tff(pred_def_32197,type,
    v59114: state_type > $o ).

tff(pred_def_32198,type,
    v59138: state_type > $o ).

tff(pred_def_32199,type,
    v59064: state_type > $o ).

tff(pred_def_32200,type,
    v59062: state_type > $o ).

tff(pred_def_32201,type,
    v59060: state_type > $o ).

tff(pred_def_32202,type,
    v59058: state_type > $o ).

tff(pred_def_32203,type,
    v59056: state_type > $o ).

tff(pred_def_32204,type,
    v59148: state_type > $o ).

tff(pred_def_32205,type,
    v59146: state_type > $o ).

tff(pred_def_32206,type,
    v59145: state_type > $o ).

tff(pred_def_32207,type,
    v59144: ( state_type * $int ) > $o ).

tff(pred_def_32208,type,
    v59142: state_type > $o ).

tff(pred_def_32209,type,
    v59140: state_type > $o ).

tff(pred_def_32210,type,
    v59152: state_type > $o ).

tff(pred_def_32211,type,
    v59030: state_type > $o ).

tff(pred_def_32212,type,
    v59028: state_type > $o ).

tff(pred_def_32213,type,
    v59026: state_type > $o ).

tff(pred_def_32214,type,
    v59024: state_type > $o ).

tff(pred_def_32215,type,
    v59022: state_type > $o ).

tff(pred_def_32216,type,
    v59154: state_type > $o ).

tff(pred_def_32217,type,
    v58492: state_type > $o ).

tff(pred_def_32218,type,
    v58490: state_type > $o ).

tff(pred_def_32219,type,
    v58488: state_type > $o ).

tff(pred_def_32220,type,
    v58486: state_type > $o ).

tff(pred_def_32221,type,
    v59156: state_type > $o ).

tff(pred_def_32222,type,
    v57814: state_type > $o ).

tff(pred_def_32223,type,
    v57812: state_type > $o ).

tff(pred_def_32224,type,
    v57810: state_type > $o ).

tff(pred_def_32225,type,
    v57808: state_type > $o ).

tff(pred_def_32226,type,
    v57806: state_type > $o ).

tff(pred_def_32227,type,
    v59158: state_type > $o ).

tff(pred_def_32228,type,
    v56445: state_type > $o ).

tff(pred_def_32229,type,
    v56443: state_type > $o ).

tff(pred_def_32230,type,
    v56441: state_type > $o ).

tff(pred_def_32231,type,
    v56439: state_type > $o ).

tff(pred_def_32232,type,
    v56437: state_type > $o ).

tff(pred_def_32233,type,
    v59176: state_type > $o ).

tff(pred_def_32234,type,
    v59174: state_type > $o ).

tff(pred_def_32235,type,
    v59180: state_type > $o ).

tff(pred_def_32236,type,
    v59178: state_type > $o ).

tff(pred_def_32237,type,
    v59188: state_type > $o ).

tff(pred_def_32238,type,
    v59186: state_type > $o ).

tff(pred_def_32239,type,
    b0001000100000: $int > $o ).

tff(pred_def_32240,type,
    v59195: state_type > $o ).

tff(pred_def_32241,type,
    v59192: state_type > $o ).

tff(pred_def_32242,type,
    v59190: state_type > $o ).

tff(pred_def_32243,type,
    v59199: state_type > $o ).

tff(pred_def_32244,type,
    v59198: state_type > $o ).

tff(pred_def_32245,type,
    v59197: state_type > $o ).

tff(pred_def_32246,type,
    v59203: state_type > $o ).

tff(pred_def_32247,type,
    v59202: state_type > $o ).

tff(pred_def_32248,type,
    v59201: state_type > $o ).

tff(pred_def_32249,type,
    v59170: state_type > $o ).

tff(pred_def_32250,type,
    v59200: state_type > $o ).

tff(pred_def_32251,type,
    v59184: state_type > $o ).

tff(pred_def_32252,type,
    v59182: state_type > $o ).

tff(pred_def_32253,type,
    v59207: state_type > $o ).

tff(pred_def_32254,type,
    v59205: state_type > $o ).

tff(pred_def_32255,type,
    v59214: state_type > $o ).

tff(pred_def_32256,type,
    v59212: state_type > $o ).

tff(pred_def_32257,type,
    v59211: state_type > $o ).

tff(pred_def_32258,type,
    v59210: state_type > $o ).

tff(pred_def_32259,type,
    v59222: state_type > $o ).

tff(pred_def_32260,type,
    v59223: state_type > $o ).

tff(pred_def_32261,type,
    v59221: state_type > $o ).

tff(pred_def_32262,type,
    v59218: state_type > $o ).

tff(pred_def_32263,type,
    v59220: state_type > $o ).

tff(pred_def_32264,type,
    v59172: state_type > $o ).

tff(pred_def_32265,type,
    v59168: state_type > $o ).

tff(pred_def_32266,type,
    v59166: state_type > $o ).

tff(pred_def_32267,type,
    v59164: state_type > $o ).

tff(pred_def_32268,type,
    v59162: state_type > $o ).

tff(pred_def_32269,type,
    v59160: state_type > $o ).

tff(pred_def_32270,type,
    v59227: state_type > $o ).

tff(pred_def_32271,type,
    v56435: state_type > $o ).

tff(pred_def_32272,type,
    v56433: state_type > $o ).

tff(pred_def_32273,type,
    v56431: state_type > $o ).

tff(pred_def_32274,type,
    v56429: state_type > $o ).

tff(pred_def_32275,type,
    v56427: state_type > $o ).

tff(pred_def_32276,type,
    v59231: state_type > $o ).

tff(pred_def_32277,type,
    v59229: state_type > $o ).

tff(pred_def_32278,type,
    v59233: state_type > $o ).

tff(pred_def_32279,type,
    v56425: state_type > $o ).

tff(pred_def_32280,type,
    v56423: state_type > $o ).

tff(pred_def_32281,type,
    v56421: state_type > $o ).

tff(pred_def_32282,type,
    v56419: state_type > $o ).

tff(pred_def_32283,type,
    v56417: state_type > $o ).

tff(pred_def_32284,type,
    v5929: state_type > $o ).

tff(pred_def_32285,type,
    v5927: state_type > $o ).

tff(pred_def_32286,type,
    v5925: state_type > $o ).

tff(pred_def_32287,type,
    v59236: state_type > $o ).

tff(pred_def_32288,type,
    v59235: ( state_type * $int ) > $o ).

tff(pred_def_32289,type,
    v5923: ( state_type * $int ) > $o ).

tff(pred_def_32290,type,
    v5921: ( state_type * $int ) > $o ).

tff(pred_def_32291,type,
    v59281: state_type > $o ).

tff(pred_def_32292,type,
    v59279: state_type > $o ).

tff(pred_def_32293,type,
    v59285: state_type > $o ).

tff(pred_def_32294,type,
    v59283: state_type > $o ).

tff(pred_def_32295,type,
    v59289: state_type > $o ).

tff(pred_def_32296,type,
    v59287: state_type > $o ).

tff(pred_def_32297,type,
    v59291: state_type > $o ).

tff(pred_def_32298,type,
    v59277: state_type > $o ).

tff(pred_def_32299,type,
    v59275: state_type > $o ).

tff(pred_def_32300,type,
    v59273: state_type > $o ).

tff(pred_def_32301,type,
    v59271: state_type > $o ).

tff(pred_def_32302,type,
    v59269: state_type > $o ).

tff(pred_def_32303,type,
    v59305: state_type > $o ).

tff(pred_def_32304,type,
    v59303: state_type > $o ).

tff(pred_def_32305,type,
    v59309: state_type > $o ).

tff(pred_def_32306,type,
    v59307: state_type > $o ).

tff(pred_def_32307,type,
    v59313: state_type > $o ).

tff(pred_def_32308,type,
    v59311: state_type > $o ).

tff(pred_def_32309,type,
    v59315: state_type > $o ).

tff(pred_def_32310,type,
    v59301: state_type > $o ).

tff(pred_def_32311,type,
    v59299: state_type > $o ).

tff(pred_def_32312,type,
    v59297: state_type > $o ).

tff(pred_def_32313,type,
    v59295: state_type > $o ).

tff(pred_def_32314,type,
    v59293: state_type > $o ).

tff(pred_def_32315,type,
    v59329: state_type > $o ).

tff(pred_def_32316,type,
    v59327: state_type > $o ).

tff(pred_def_32317,type,
    v59333: state_type > $o ).

tff(pred_def_32318,type,
    v59331: state_type > $o ).

tff(pred_def_32319,type,
    v59337: state_type > $o ).

tff(pred_def_32320,type,
    v59335: state_type > $o ).

tff(pred_def_32321,type,
    v59339: state_type > $o ).

tff(pred_def_32322,type,
    v59325: state_type > $o ).

tff(pred_def_32323,type,
    v59323: state_type > $o ).

tff(pred_def_32324,type,
    v59321: state_type > $o ).

tff(pred_def_32325,type,
    v59319: state_type > $o ).

tff(pred_def_32326,type,
    v59317: state_type > $o ).

tff(pred_def_32327,type,
    v59341: state_type > $o ).

tff(pred_def_32328,type,
    v59267: state_type > $o ).

tff(pred_def_32329,type,
    v59265: state_type > $o ).

tff(pred_def_32330,type,
    v59263: state_type > $o ).

tff(pred_def_32331,type,
    v59261: state_type > $o ).

tff(pred_def_32332,type,
    v59259: state_type > $o ).

tff(pred_def_32333,type,
    v59365: state_type > $o ).

tff(pred_def_32334,type,
    v59363: state_type > $o ).

tff(pred_def_32335,type,
    v59369: state_type > $o ).

tff(pred_def_32336,type,
    v59367: state_type > $o ).

tff(pred_def_32337,type,
    v59373: state_type > $o ).

tff(pred_def_32338,type,
    v59371: state_type > $o ).

tff(pred_def_32339,type,
    v59375: state_type > $o ).

tff(pred_def_32340,type,
    v59361: state_type > $o ).

tff(pred_def_32341,type,
    v59359: state_type > $o ).

tff(pred_def_32342,type,
    v59357: state_type > $o ).

tff(pred_def_32343,type,
    v59355: state_type > $o ).

tff(pred_def_32344,type,
    v59353: state_type > $o ).

tff(pred_def_32345,type,
    v59389: state_type > $o ).

tff(pred_def_32346,type,
    v59387: state_type > $o ).

tff(pred_def_32347,type,
    v59393: state_type > $o ).

tff(pred_def_32348,type,
    v59391: state_type > $o ).

tff(pred_def_32349,type,
    v59397: state_type > $o ).

tff(pred_def_32350,type,
    v59395: state_type > $o ).

tff(pred_def_32351,type,
    v59399: state_type > $o ).

tff(pred_def_32352,type,
    v59385: state_type > $o ).

tff(pred_def_32353,type,
    v59383: state_type > $o ).

tff(pred_def_32354,type,
    v59381: state_type > $o ).

tff(pred_def_32355,type,
    v59379: state_type > $o ).

tff(pred_def_32356,type,
    v59377: state_type > $o ).

tff(pred_def_32357,type,
    v59413: state_type > $o ).

tff(pred_def_32358,type,
    v59411: state_type > $o ).

tff(pred_def_32359,type,
    v59417: state_type > $o ).

tff(pred_def_32360,type,
    v59415: state_type > $o ).

tff(pred_def_32361,type,
    v59421: state_type > $o ).

tff(pred_def_32362,type,
    v59419: state_type > $o ).

tff(pred_def_32363,type,
    v59423: state_type > $o ).

tff(pred_def_32364,type,
    v59409: state_type > $o ).

tff(pred_def_32365,type,
    v59407: state_type > $o ).

tff(pred_def_32366,type,
    v59405: state_type > $o ).

tff(pred_def_32367,type,
    v59403: state_type > $o ).

tff(pred_def_32368,type,
    v59401: state_type > $o ).

tff(pred_def_32369,type,
    v59425: state_type > $o ).

tff(pred_def_32370,type,
    v59351: state_type > $o ).

tff(pred_def_32371,type,
    v59349: state_type > $o ).

tff(pred_def_32372,type,
    v59347: state_type > $o ).

tff(pred_def_32373,type,
    v59345: state_type > $o ).

tff(pred_def_32374,type,
    v59343: state_type > $o ).

tff(pred_def_32375,type,
    v59449: state_type > $o ).

tff(pred_def_32376,type,
    v59447: state_type > $o ).

tff(pred_def_32377,type,
    v59453: state_type > $o ).

tff(pred_def_32378,type,
    v59451: state_type > $o ).

tff(pred_def_32379,type,
    v59457: state_type > $o ).

tff(pred_def_32380,type,
    v59455: state_type > $o ).

tff(pred_def_32381,type,
    v59459: state_type > $o ).

tff(pred_def_32382,type,
    v59445: state_type > $o ).

tff(pred_def_32383,type,
    v59443: state_type > $o ).

tff(pred_def_32384,type,
    v59441: state_type > $o ).

tff(pred_def_32385,type,
    v59439: state_type > $o ).

tff(pred_def_32386,type,
    v59437: state_type > $o ).

tff(pred_def_32387,type,
    v59473: state_type > $o ).

tff(pred_def_32388,type,
    v59471: state_type > $o ).

tff(pred_def_32389,type,
    v59477: state_type > $o ).

tff(pred_def_32390,type,
    v59475: state_type > $o ).

tff(pred_def_32391,type,
    v59481: state_type > $o ).

tff(pred_def_32392,type,
    v59479: state_type > $o ).

tff(pred_def_32393,type,
    v59483: state_type > $o ).

tff(pred_def_32394,type,
    v59469: state_type > $o ).

tff(pred_def_32395,type,
    v59467: state_type > $o ).

tff(pred_def_32396,type,
    v59465: state_type > $o ).

tff(pred_def_32397,type,
    v59463: state_type > $o ).

tff(pred_def_32398,type,
    v59461: state_type > $o ).

tff(pred_def_32399,type,
    v59497: state_type > $o ).

tff(pred_def_32400,type,
    v59495: state_type > $o ).

tff(pred_def_32401,type,
    v59501: state_type > $o ).

tff(pred_def_32402,type,
    v59499: state_type > $o ).

tff(pred_def_32403,type,
    v59505: state_type > $o ).

tff(pred_def_32404,type,
    v59503: state_type > $o ).

tff(pred_def_32405,type,
    v59507: state_type > $o ).

tff(pred_def_32406,type,
    v59493: state_type > $o ).

tff(pred_def_32407,type,
    v59491: state_type > $o ).

tff(pred_def_32408,type,
    v59489: state_type > $o ).

tff(pred_def_32409,type,
    v59487: state_type > $o ).

tff(pred_def_32410,type,
    v59485: state_type > $o ).

tff(pred_def_32411,type,
    v59509: state_type > $o ).

tff(pred_def_32412,type,
    v59435: state_type > $o ).

tff(pred_def_32413,type,
    v59433: state_type > $o ).

tff(pred_def_32414,type,
    v59431: state_type > $o ).

tff(pred_def_32415,type,
    v59429: state_type > $o ).

tff(pred_def_32416,type,
    v59427: state_type > $o ).

tff(pred_def_32417,type,
    v59511: state_type > $o ).

tff(pred_def_32418,type,
    v59257: state_type > $o ).

tff(pred_def_32419,type,
    v59255: state_type > $o ).

tff(pred_def_32420,type,
    v59253: state_type > $o ).

tff(pred_def_32421,type,
    v59251: state_type > $o ).

tff(pred_def_32422,type,
    v59249: state_type > $o ).

tff(pred_def_32423,type,
    v59545: state_type > $o ).

tff(pred_def_32424,type,
    v59543: state_type > $o ).

tff(pred_def_32425,type,
    v59549: state_type > $o ).

tff(pred_def_32426,type,
    v59547: state_type > $o ).

tff(pred_def_32427,type,
    v59553: state_type > $o ).

tff(pred_def_32428,type,
    v59551: state_type > $o ).

tff(pred_def_32429,type,
    v59555: state_type > $o ).

tff(pred_def_32430,type,
    v59541: state_type > $o ).

tff(pred_def_32431,type,
    v59539: state_type > $o ).

tff(pred_def_32432,type,
    v59537: state_type > $o ).

tff(pred_def_32433,type,
    v59535: state_type > $o ).

tff(pred_def_32434,type,
    v59533: state_type > $o ).

tff(pred_def_32435,type,
    v59569: state_type > $o ).

tff(pred_def_32436,type,
    v59567: state_type > $o ).

tff(pred_def_32437,type,
    v59573: state_type > $o ).

tff(pred_def_32438,type,
    v59571: state_type > $o ).

tff(pred_def_32439,type,
    v59577: state_type > $o ).

tff(pred_def_32440,type,
    v59575: state_type > $o ).

tff(pred_def_32441,type,
    v59579: state_type > $o ).

tff(pred_def_32442,type,
    v59565: state_type > $o ).

tff(pred_def_32443,type,
    v59563: state_type > $o ).

tff(pred_def_32444,type,
    v59561: state_type > $o ).

tff(pred_def_32445,type,
    v59559: state_type > $o ).

tff(pred_def_32446,type,
    v59557: state_type > $o ).

tff(pred_def_32447,type,
    v59593: state_type > $o ).

tff(pred_def_32448,type,
    v59591: state_type > $o ).

tff(pred_def_32449,type,
    v59597: state_type > $o ).

tff(pred_def_32450,type,
    v59595: state_type > $o ).

tff(pred_def_32451,type,
    v59601: state_type > $o ).

tff(pred_def_32452,type,
    v59599: state_type > $o ).

tff(pred_def_32453,type,
    v59603: state_type > $o ).

tff(pred_def_32454,type,
    v59589: state_type > $o ).

tff(pred_def_32455,type,
    v59587: state_type > $o ).

tff(pred_def_32456,type,
    v59585: state_type > $o ).

tff(pred_def_32457,type,
    v59583: state_type > $o ).

tff(pred_def_32458,type,
    v59581: state_type > $o ).

tff(pred_def_32459,type,
    v59605: state_type > $o ).

tff(pred_def_32460,type,
    v59531: state_type > $o ).

tff(pred_def_32461,type,
    v59529: state_type > $o ).

tff(pred_def_32462,type,
    v59527: state_type > $o ).

tff(pred_def_32463,type,
    v59525: state_type > $o ).

tff(pred_def_32464,type,
    v59523: state_type > $o ).

tff(pred_def_32465,type,
    v59629: state_type > $o ).

tff(pred_def_32466,type,
    v59627: state_type > $o ).

tff(pred_def_32467,type,
    v59633: state_type > $o ).

tff(pred_def_32468,type,
    v59631: state_type > $o ).

tff(pred_def_32469,type,
    v59637: state_type > $o ).

tff(pred_def_32470,type,
    v59635: state_type > $o ).

tff(pred_def_32471,type,
    v59639: state_type > $o ).

tff(pred_def_32472,type,
    v59625: state_type > $o ).

tff(pred_def_32473,type,
    v59623: state_type > $o ).

tff(pred_def_32474,type,
    v59621: state_type > $o ).

tff(pred_def_32475,type,
    v59619: state_type > $o ).

tff(pred_def_32476,type,
    v59617: state_type > $o ).

tff(pred_def_32477,type,
    v59653: state_type > $o ).

tff(pred_def_32478,type,
    v59651: state_type > $o ).

tff(pred_def_32479,type,
    v59657: state_type > $o ).

tff(pred_def_32480,type,
    v59655: state_type > $o ).

tff(pred_def_32481,type,
    v59661: state_type > $o ).

tff(pred_def_32482,type,
    v59659: state_type > $o ).

tff(pred_def_32483,type,
    v59663: state_type > $o ).

tff(pred_def_32484,type,
    v59649: state_type > $o ).

tff(pred_def_32485,type,
    v59647: state_type > $o ).

tff(pred_def_32486,type,
    v59645: state_type > $o ).

tff(pred_def_32487,type,
    v59643: state_type > $o ).

tff(pred_def_32488,type,
    v59641: state_type > $o ).

tff(pred_def_32489,type,
    v59677: state_type > $o ).

tff(pred_def_32490,type,
    v59675: state_type > $o ).

tff(pred_def_32491,type,
    v59681: state_type > $o ).

tff(pred_def_32492,type,
    v59679: state_type > $o ).

tff(pred_def_32493,type,
    v59685: state_type > $o ).

tff(pred_def_32494,type,
    v59683: state_type > $o ).

tff(pred_def_32495,type,
    v59687: state_type > $o ).

tff(pred_def_32496,type,
    v59673: state_type > $o ).

tff(pred_def_32497,type,
    v59671: state_type > $o ).

tff(pred_def_32498,type,
    v59669: state_type > $o ).

tff(pred_def_32499,type,
    v59667: state_type > $o ).

tff(pred_def_32500,type,
    v59665: state_type > $o ).

tff(pred_def_32501,type,
    v59689: state_type > $o ).

tff(pred_def_32502,type,
    v59615: state_type > $o ).

tff(pred_def_32503,type,
    v59613: state_type > $o ).

tff(pred_def_32504,type,
    v59611: state_type > $o ).

tff(pred_def_32505,type,
    v59609: state_type > $o ).

tff(pred_def_32506,type,
    v59607: state_type > $o ).

tff(pred_def_32507,type,
    v59713: state_type > $o ).

tff(pred_def_32508,type,
    v59711: state_type > $o ).

tff(pred_def_32509,type,
    v59717: state_type > $o ).

tff(pred_def_32510,type,
    v59715: state_type > $o ).

tff(pred_def_32511,type,
    v59721: state_type > $o ).

tff(pred_def_32512,type,
    v59719: state_type > $o ).

tff(pred_def_32513,type,
    v59723: state_type > $o ).

tff(pred_def_32514,type,
    v59709: state_type > $o ).

tff(pred_def_32515,type,
    v59707: state_type > $o ).

tff(pred_def_32516,type,
    v59705: state_type > $o ).

tff(pred_def_32517,type,
    v59703: state_type > $o ).

tff(pred_def_32518,type,
    v59701: state_type > $o ).

tff(pred_def_32519,type,
    v59737: state_type > $o ).

tff(pred_def_32520,type,
    v59735: state_type > $o ).

tff(pred_def_32521,type,
    v59741: state_type > $o ).

tff(pred_def_32522,type,
    v59739: state_type > $o ).

tff(pred_def_32523,type,
    v59745: state_type > $o ).

tff(pred_def_32524,type,
    v59743: state_type > $o ).

tff(pred_def_32525,type,
    v59747: state_type > $o ).

tff(pred_def_32526,type,
    v59733: state_type > $o ).

tff(pred_def_32527,type,
    v59731: state_type > $o ).

tff(pred_def_32528,type,
    v59729: state_type > $o ).

tff(pred_def_32529,type,
    v59727: state_type > $o ).

tff(pred_def_32530,type,
    v59725: state_type > $o ).

tff(pred_def_32531,type,
    v59761: state_type > $o ).

tff(pred_def_32532,type,
    v59759: state_type > $o ).

tff(pred_def_32533,type,
    v59765: state_type > $o ).

tff(pred_def_32534,type,
    v59763: state_type > $o ).

tff(pred_def_32535,type,
    v59769: state_type > $o ).

tff(pred_def_32536,type,
    v59767: state_type > $o ).

tff(pred_def_32537,type,
    v59771: state_type > $o ).

tff(pred_def_32538,type,
    v59757: state_type > $o ).

tff(pred_def_32539,type,
    v59755: state_type > $o ).

tff(pred_def_32540,type,
    v59753: state_type > $o ).

tff(pred_def_32541,type,
    v59751: state_type > $o ).

tff(pred_def_32542,type,
    v59749: state_type > $o ).

tff(pred_def_32543,type,
    v59773: state_type > $o ).

tff(pred_def_32544,type,
    v59699: state_type > $o ).

tff(pred_def_32545,type,
    v59697: state_type > $o ).

tff(pred_def_32546,type,
    v59695: state_type > $o ).

tff(pred_def_32547,type,
    v59693: state_type > $o ).

tff(pred_def_32548,type,
    v59691: state_type > $o ).

tff(pred_def_32549,type,
    v59775: state_type > $o ).

tff(pred_def_32550,type,
    v59521: state_type > $o ).

tff(pred_def_32551,type,
    v59519: state_type > $o ).

tff(pred_def_32552,type,
    v59517: state_type > $o ).

tff(pred_def_32553,type,
    v59515: state_type > $o ).

tff(pred_def_32554,type,
    v59513: state_type > $o ).

tff(pred_def_32555,type,
    v59799: state_type > $o ).

tff(pred_def_32556,type,
    v59797: state_type > $o ).

tff(pred_def_32557,type,
    v59803: state_type > $o ).

tff(pred_def_32558,type,
    v59801: state_type > $o ).

tff(pred_def_32559,type,
    v59807: state_type > $o ).

tff(pred_def_32560,type,
    v59805: state_type > $o ).

tff(pred_def_32561,type,
    v59809: state_type > $o ).

tff(pred_def_32562,type,
    v59795: state_type > $o ).

tff(pred_def_32563,type,
    v59793: state_type > $o ).

tff(pred_def_32564,type,
    v59791: state_type > $o ).

tff(pred_def_32565,type,
    v59789: state_type > $o ).

tff(pred_def_32566,type,
    v59787: state_type > $o ).

tff(pred_def_32567,type,
    v59833: state_type > $o ).

tff(pred_def_32568,type,
    v59831: state_type > $o ).

tff(pred_def_32569,type,
    v59837: state_type > $o ).

tff(pred_def_32570,type,
    v59835: state_type > $o ).

tff(pred_def_32571,type,
    v59841: state_type > $o ).

tff(pred_def_32572,type,
    v59839: state_type > $o ).

tff(pred_def_32573,type,
    v59843: state_type > $o ).

tff(pred_def_32574,type,
    v59829: state_type > $o ).

tff(pred_def_32575,type,
    v59827: state_type > $o ).

tff(pred_def_32576,type,
    v59825: state_type > $o ).

tff(pred_def_32577,type,
    v59823: state_type > $o ).

tff(pred_def_32578,type,
    v59821: state_type > $o ).

tff(pred_def_32579,type,
    v59857: state_type > $o ).

tff(pred_def_32580,type,
    v59855: state_type > $o ).

tff(pred_def_32581,type,
    v59861: state_type > $o ).

tff(pred_def_32582,type,
    v59859: state_type > $o ).

tff(pred_def_32583,type,
    v59865: state_type > $o ).

tff(pred_def_32584,type,
    v59863: state_type > $o ).

tff(pred_def_32585,type,
    v59867: state_type > $o ).

tff(pred_def_32586,type,
    v59853: state_type > $o ).

tff(pred_def_32587,type,
    v59851: state_type > $o ).

tff(pred_def_32588,type,
    v59849: state_type > $o ).

tff(pred_def_32589,type,
    v59847: state_type > $o ).

tff(pred_def_32590,type,
    v59845: state_type > $o ).

tff(pred_def_32591,type,
    v59881: state_type > $o ).

tff(pred_def_32592,type,
    v59879: state_type > $o ).

tff(pred_def_32593,type,
    v59885: state_type > $o ).

tff(pred_def_32594,type,
    v59883: state_type > $o ).

tff(pred_def_32595,type,
    v59889: state_type > $o ).

tff(pred_def_32596,type,
    v59887: state_type > $o ).

tff(pred_def_32597,type,
    v59891: state_type > $o ).

tff(pred_def_32598,type,
    v59877: state_type > $o ).

tff(pred_def_32599,type,
    v59875: state_type > $o ).

tff(pred_def_32600,type,
    v59873: state_type > $o ).

tff(pred_def_32601,type,
    v59871: state_type > $o ).

tff(pred_def_32602,type,
    v59869: state_type > $o ).

tff(pred_def_32603,type,
    v59893: state_type > $o ).

tff(pred_def_32604,type,
    v59819: state_type > $o ).

tff(pred_def_32605,type,
    v59817: state_type > $o ).

tff(pred_def_32606,type,
    v59815: state_type > $o ).

tff(pred_def_32607,type,
    v59813: state_type > $o ).

tff(pred_def_32608,type,
    v59811: state_type > $o ).

tff(pred_def_32609,type,
    v59918: ( state_type * $int ) > $o ).

tff(pred_def_32610,type,
    v59916: ( state_type * $int ) > $o ).

tff(pred_def_32611,type,
    v59922: state_type > $o ).

tff(pred_def_32612,type,
    v59920: state_type > $o ).

tff(pred_def_32613,type,
    v59926: ( state_type * $int ) > $o ).

tff(pred_def_32614,type,
    v59924: ( state_type * $int ) > $o ).

tff(pred_def_32615,type,
    v59930: state_type > $o ).

tff(pred_def_32616,type,
    v59928: state_type > $o ).

tff(pred_def_32617,type,
    v59934: state_type > $o ).

tff(pred_def_32618,type,
    v59933: ( state_type * $int ) > $o ).

tff(pred_def_32619,type,
    v59932: ( state_type * $int ) > $o ).

tff(pred_def_32620,type,
    v59937: state_type > $o ).

tff(pred_def_32621,type,
    v59936: ( state_type * $int ) > $o ).

tff(pred_def_32622,type,
    v59935: ( state_type * $int ) > $o ).

tff(pred_def_32623,type,
    v59931: ( state_type * $int ) > $o ).

tff(pred_def_32624,type,
    v59914: ( state_type * $int ) > $o ).

tff(pred_def_32625,type,
    v59912: ( state_type * $int ) > $o ).

tff(pred_def_32626,type,
    v59910: state_type > $o ).

tff(pred_def_32627,type,
    v59908: state_type > $o ).

tff(pred_def_32628,type,
    v59951: state_type > $o ).

tff(pred_def_32629,type,
    v59953: state_type > $o ).

tff(pred_def_32630,type,
    v59949: state_type > $o ).

tff(pred_def_32631,type,
    v59963: state_type > $o ).

tff(pred_def_32632,type,
    v59961: state_type > $o ).

tff(pred_def_32633,type,
    v59967: state_type > $o ).

tff(pred_def_32634,type,
    v59965: state_type > $o ).

tff(pred_def_32635,type,
    v59955: ( state_type * $int ) > $o ).

tff(pred_def_32636,type,
    v59981: state_type > $o ).

tff(pred_def_32637,type,
    v59982: state_type > $o ).

tff(pred_def_32638,type,
    v59980: state_type > $o ).

tff(pred_def_32639,type,
    v59983: state_type > $o ).

tff(pred_def_32640,type,
    v59979: state_type > $o ).

tff(pred_def_32641,type,
    v59977: ( state_type * $int ) > $o ).

tff(pred_def_32642,type,
    v59985: state_type > $o ).

tff(pred_def_32643,type,
    v59984: ( state_type * $int ) > $o ).

tff(pred_def_32644,type,
    v59976: ( state_type * $int ) > $o ).

tff(pred_def_32645,type,
    v59975: ( state_type * $int ) > $o ).

tff(pred_def_32646,type,
    v59973: ( state_type * $int ) > $o ).

tff(pred_def_32647,type,
    v59987: state_type > $o ).

tff(pred_def_32648,type,
    v59991: state_type > $o ).

tff(pred_def_32649,type,
    v59990: ( state_type * $int ) > $o ).

tff(pred_def_32650,type,
    v59989: ( state_type * $int ) > $o ).

tff(pred_def_32651,type,
    v59995: state_type > $o ).

tff(pred_def_32652,type,
    v59994: ( state_type * $int ) > $o ).

tff(pred_def_32653,type,
    v59993: ( state_type * $int ) > $o ).

tff(pred_def_32654,type,
    v59957: ( state_type * $int ) > $o ).

tff(pred_def_32655,type,
    v59992: ( state_type * $int ) > $o ).

tff(pred_def_32656,type,
    v59988: ( state_type * $int ) > $o ).

tff(pred_def_32657,type,
    v59971: ( state_type * $int ) > $o ).

tff(pred_def_32658,type,
    v59969: ( state_type * $int ) > $o ).

tff(pred_def_32659,type,
    v59999: state_type > $o ).

tff(pred_def_32660,type,
    v59997: state_type > $o ).

tff(pred_def_32661,type,
    v60006: state_type > $o ).

tff(pred_def_32662,type,
    v60004: state_type > $o ).

tff(pred_def_32663,type,
    v60003: state_type > $o ).

tff(pred_def_32664,type,
    v60002: state_type > $o ).

tff(pred_def_32665,type,
    v60014: state_type > $o ).

tff(pred_def_32666,type,
    v60015: state_type > $o ).

tff(pred_def_32667,type,
    v60013: state_type > $o ).

tff(pred_def_32668,type,
    v60010: ( state_type * $int ) > $o ).

tff(pred_def_32669,type,
    v60012: ( state_type * $int ) > $o ).

tff(pred_def_32670,type,
    v60001: ( state_type * $int ) > $o ).

tff(pred_def_32671,type,
    v59959: ( state_type * $int ) > $o ).

tff(pred_def_32672,type,
    v60020: state_type > $o ).

tff(pred_def_32673,type,
    v60019: state_type > $o ).

tff(pred_def_32674,type,
    v59947: state_type > $o ).

tff(pred_def_32675,type,
    v59945: state_type > $o ).

tff(pred_def_32676,type,
    v59943: state_type > $o ).

tff(pred_def_32677,type,
    v59941: state_type > $o ).

tff(pred_def_32678,type,
    v59939: state_type > $o ).

tff(pred_def_32679,type,
    v59906: state_type > $o ).

tff(pred_def_32680,type,
    v59904: state_type > $o ).

tff(pred_def_32681,type,
    v60027: state_type > $o ).

tff(pred_def_32682,type,
    v60025: state_type > $o ).

tff(pred_def_32683,type,
    v60024: state_type > $o ).

tff(pred_def_32684,type,
    v60023: ( state_type * $int ) > $o ).

tff(pred_def_32685,type,
    v59901: ( state_type * $int ) > $o ).

tff(pred_def_32686,type,
    v59899: ( state_type * $int ) > $o ).

tff(pred_def_32687,type,
    v59897: state_type > $o ).

tff(pred_def_32688,type,
    v59895: state_type > $o ).

tff(pred_def_32689,type,
    v60031: state_type > $o ).

tff(pred_def_32690,type,
    v59785: state_type > $o ).

tff(pred_def_32691,type,
    v59783: state_type > $o ).

tff(pred_def_32692,type,
    v59781: state_type > $o ).

tff(pred_def_32693,type,
    v59779: state_type > $o ).

tff(pred_def_32694,type,
    v59777: state_type > $o ).

tff(pred_def_32695,type,
    v60033: state_type > $o ).

tff(pred_def_32696,type,
    v59247: state_type > $o ).

tff(pred_def_32697,type,
    v59245: state_type > $o ).

tff(pred_def_32698,type,
    v59242: ( state_type * $int ) > $o ).

tff(pred_def_32699,type,
    v59240: ( state_type * $int ) > $o ).

tff(pred_def_32700,type,
    v59238: ( state_type * $int ) > $o ).

tff(pred_def_32701,type,
    v60034: ( state_type * $int ) > $o ).

tff(pred_def_32702,type,
    v5919: ( state_type * $int ) > $o ).

tff(pred_def_32703,type,
    v5917: ( state_type * $int ) > $o ).

tff(pred_def_32704,type,
    v5915: ( state_type * $int ) > $o ).

tff(pred_def_32705,type,
    v5913: state_type > $o ).

tff(pred_def_32706,type,
    v5911: state_type > $o ).

tff(pred_def_32707,type,
    v60076: state_type > $o ).

tff(pred_def_32708,type,
    v60074: state_type > $o ).

tff(pred_def_32709,type,
    v60080: state_type > $o ).

tff(pred_def_32710,type,
    v60078: state_type > $o ).

tff(pred_def_32711,type,
    v60084: state_type > $o ).

tff(pred_def_32712,type,
    v60082: state_type > $o ).

tff(pred_def_32713,type,
    v60086: state_type > $o ).

tff(pred_def_32714,type,
    v60072: state_type > $o ).

tff(pred_def_32715,type,
    v60070: state_type > $o ).

tff(pred_def_32716,type,
    v60068: state_type > $o ).

tff(pred_def_32717,type,
    v60066: state_type > $o ).

tff(pred_def_32718,type,
    v60064: state_type > $o ).

tff(pred_def_32719,type,
    v60100: state_type > $o ).

tff(pred_def_32720,type,
    v60098: state_type > $o ).

tff(pred_def_32721,type,
    v60104: state_type > $o ).

tff(pred_def_32722,type,
    v60102: state_type > $o ).

tff(pred_def_32723,type,
    v60108: state_type > $o ).

tff(pred_def_32724,type,
    v60106: state_type > $o ).

tff(pred_def_32725,type,
    v60110: state_type > $o ).

tff(pred_def_32726,type,
    v60096: state_type > $o ).

tff(pred_def_32727,type,
    v60094: state_type > $o ).

tff(pred_def_32728,type,
    v60092: state_type > $o ).

tff(pred_def_32729,type,
    v60090: state_type > $o ).

tff(pred_def_32730,type,
    v60088: state_type > $o ).

tff(pred_def_32731,type,
    v60124: state_type > $o ).

tff(pred_def_32732,type,
    v60122: state_type > $o ).

tff(pred_def_32733,type,
    v60128: state_type > $o ).

tff(pred_def_32734,type,
    v60126: state_type > $o ).

tff(pred_def_32735,type,
    v60132: state_type > $o ).

tff(pred_def_32736,type,
    v60130: state_type > $o ).

tff(pred_def_32737,type,
    v60134: state_type > $o ).

tff(pred_def_32738,type,
    v60120: state_type > $o ).

tff(pred_def_32739,type,
    v60118: state_type > $o ).

tff(pred_def_32740,type,
    v60116: state_type > $o ).

tff(pred_def_32741,type,
    v60114: state_type > $o ).

tff(pred_def_32742,type,
    v60112: state_type > $o ).

tff(pred_def_32743,type,
    v60136: state_type > $o ).

tff(pred_def_32744,type,
    v60062: state_type > $o ).

tff(pred_def_32745,type,
    v60060: state_type > $o ).

tff(pred_def_32746,type,
    v60058: state_type > $o ).

tff(pred_def_32747,type,
    v60056: state_type > $o ).

tff(pred_def_32748,type,
    v60054: state_type > $o ).

tff(pred_def_32749,type,
    v60160: state_type > $o ).

tff(pred_def_32750,type,
    v60158: state_type > $o ).

tff(pred_def_32751,type,
    v60164: state_type > $o ).

tff(pred_def_32752,type,
    v60162: state_type > $o ).

tff(pred_def_32753,type,
    v60168: state_type > $o ).

tff(pred_def_32754,type,
    v60166: state_type > $o ).

tff(pred_def_32755,type,
    v60170: state_type > $o ).

tff(pred_def_32756,type,
    v60156: state_type > $o ).

tff(pred_def_32757,type,
    v60154: state_type > $o ).

tff(pred_def_32758,type,
    v60152: state_type > $o ).

tff(pred_def_32759,type,
    v60150: state_type > $o ).

tff(pred_def_32760,type,
    v60148: state_type > $o ).

tff(pred_def_32761,type,
    v60184: state_type > $o ).

tff(pred_def_32762,type,
    v60182: state_type > $o ).

tff(pred_def_32763,type,
    v60188: state_type > $o ).

tff(pred_def_32764,type,
    v60186: state_type > $o ).

tff(pred_def_32765,type,
    v60192: state_type > $o ).

tff(pred_def_32766,type,
    v60190: state_type > $o ).

tff(pred_def_32767,type,
    v60194: state_type > $o ).

tff(pred_def_32768,type,
    v60180: state_type > $o ).

tff(pred_def_32769,type,
    v60178: state_type > $o ).

tff(pred_def_32770,type,
    v60176: state_type > $o ).

tff(pred_def_32771,type,
    v60174: state_type > $o ).

tff(pred_def_32772,type,
    v60172: state_type > $o ).

tff(pred_def_32773,type,
    v60208: state_type > $o ).

tff(pred_def_32774,type,
    v60206: state_type > $o ).

tff(pred_def_32775,type,
    v60212: state_type > $o ).

tff(pred_def_32776,type,
    v60210: state_type > $o ).

tff(pred_def_32777,type,
    v60216: state_type > $o ).

tff(pred_def_32778,type,
    v60214: state_type > $o ).

tff(pred_def_32779,type,
    v60218: state_type > $o ).

tff(pred_def_32780,type,
    v60204: state_type > $o ).

tff(pred_def_32781,type,
    v60202: state_type > $o ).

tff(pred_def_32782,type,
    v60200: state_type > $o ).

tff(pred_def_32783,type,
    v60198: state_type > $o ).

tff(pred_def_32784,type,
    v60196: state_type > $o ).

tff(pred_def_32785,type,
    v60220: state_type > $o ).

tff(pred_def_32786,type,
    v60146: state_type > $o ).

tff(pred_def_32787,type,
    v60144: state_type > $o ).

tff(pred_def_32788,type,
    v60142: state_type > $o ).

tff(pred_def_32789,type,
    v60140: state_type > $o ).

tff(pred_def_32790,type,
    v60138: state_type > $o ).

tff(pred_def_32791,type,
    v60244: state_type > $o ).

tff(pred_def_32792,type,
    v60242: state_type > $o ).

tff(pred_def_32793,type,
    v60248: state_type > $o ).

tff(pred_def_32794,type,
    v60246: state_type > $o ).

tff(pred_def_32795,type,
    v60252: state_type > $o ).

tff(pred_def_32796,type,
    v60250: state_type > $o ).

tff(pred_def_32797,type,
    v60254: state_type > $o ).

tff(pred_def_32798,type,
    v60240: state_type > $o ).

tff(pred_def_32799,type,
    v60238: state_type > $o ).

tff(pred_def_32800,type,
    v60236: state_type > $o ).

tff(pred_def_32801,type,
    v60234: state_type > $o ).

tff(pred_def_32802,type,
    v60232: state_type > $o ).

tff(pred_def_32803,type,
    v60268: state_type > $o ).

tff(pred_def_32804,type,
    v60266: state_type > $o ).

tff(pred_def_32805,type,
    v60272: state_type > $o ).

tff(pred_def_32806,type,
    v60270: state_type > $o ).

tff(pred_def_32807,type,
    v60276: state_type > $o ).

tff(pred_def_32808,type,
    v60274: state_type > $o ).

tff(pred_def_32809,type,
    v60278: state_type > $o ).

tff(pred_def_32810,type,
    v60264: state_type > $o ).

tff(pred_def_32811,type,
    v60262: state_type > $o ).

tff(pred_def_32812,type,
    v60260: state_type > $o ).

tff(pred_def_32813,type,
    v60258: state_type > $o ).

tff(pred_def_32814,type,
    v60256: state_type > $o ).

tff(pred_def_32815,type,
    v60292: state_type > $o ).

tff(pred_def_32816,type,
    v60290: state_type > $o ).

tff(pred_def_32817,type,
    v60296: state_type > $o ).

tff(pred_def_32818,type,
    v60294: state_type > $o ).

tff(pred_def_32819,type,
    v60300: state_type > $o ).

tff(pred_def_32820,type,
    v60298: state_type > $o ).

tff(pred_def_32821,type,
    v60302: state_type > $o ).

tff(pred_def_32822,type,
    v60288: state_type > $o ).

tff(pred_def_32823,type,
    v60286: state_type > $o ).

tff(pred_def_32824,type,
    v60284: state_type > $o ).

tff(pred_def_32825,type,
    v60282: state_type > $o ).

tff(pred_def_32826,type,
    v60280: state_type > $o ).

tff(pred_def_32827,type,
    v60304: state_type > $o ).

tff(pred_def_32828,type,
    v60230: state_type > $o ).

tff(pred_def_32829,type,
    v60228: state_type > $o ).

tff(pred_def_32830,type,
    v60226: state_type > $o ).

tff(pred_def_32831,type,
    v60224: state_type > $o ).

tff(pred_def_32832,type,
    v60222: state_type > $o ).

tff(pred_def_32833,type,
    v60306: state_type > $o ).

tff(pred_def_32834,type,
    v60052: state_type > $o ).

tff(pred_def_32835,type,
    v60050: state_type > $o ).

tff(pred_def_32836,type,
    v60048: state_type > $o ).

tff(pred_def_32837,type,
    v60046: state_type > $o ).

tff(pred_def_32838,type,
    v60044: state_type > $o ).

tff(pred_def_32839,type,
    v60340: state_type > $o ).

tff(pred_def_32840,type,
    v60338: state_type > $o ).

tff(pred_def_32841,type,
    v60344: state_type > $o ).

tff(pred_def_32842,type,
    v60342: state_type > $o ).

tff(pred_def_32843,type,
    v60348: state_type > $o ).

tff(pred_def_32844,type,
    v60346: state_type > $o ).

tff(pred_def_32845,type,
    v60350: state_type > $o ).

tff(pred_def_32846,type,
    v60336: state_type > $o ).

tff(pred_def_32847,type,
    v60334: state_type > $o ).

tff(pred_def_32848,type,
    v60332: state_type > $o ).

tff(pred_def_32849,type,
    v60330: state_type > $o ).

tff(pred_def_32850,type,
    v60328: state_type > $o ).

tff(pred_def_32851,type,
    v60364: state_type > $o ).

tff(pred_def_32852,type,
    v60362: state_type > $o ).

tff(pred_def_32853,type,
    v60368: state_type > $o ).

tff(pred_def_32854,type,
    v60366: state_type > $o ).

tff(pred_def_32855,type,
    v60372: state_type > $o ).

tff(pred_def_32856,type,
    v60370: state_type > $o ).

tff(pred_def_32857,type,
    v60374: state_type > $o ).

tff(pred_def_32858,type,
    v60360: state_type > $o ).

tff(pred_def_32859,type,
    v60358: state_type > $o ).

tff(pred_def_32860,type,
    v60356: state_type > $o ).

tff(pred_def_32861,type,
    v60354: state_type > $o ).

tff(pred_def_32862,type,
    v60352: state_type > $o ).

tff(pred_def_32863,type,
    v60388: state_type > $o ).

tff(pred_def_32864,type,
    v60386: state_type > $o ).

tff(pred_def_32865,type,
    v60392: state_type > $o ).

tff(pred_def_32866,type,
    v60390: state_type > $o ).

tff(pred_def_32867,type,
    v60396: state_type > $o ).

tff(pred_def_32868,type,
    v60394: state_type > $o ).

tff(pred_def_32869,type,
    v60398: state_type > $o ).

tff(pred_def_32870,type,
    v60384: state_type > $o ).

tff(pred_def_32871,type,
    v60382: state_type > $o ).

tff(pred_def_32872,type,
    v60380: state_type > $o ).

tff(pred_def_32873,type,
    v60378: state_type > $o ).

tff(pred_def_32874,type,
    v60376: state_type > $o ).

tff(pred_def_32875,type,
    v60400: state_type > $o ).

tff(pred_def_32876,type,
    v60326: state_type > $o ).

tff(pred_def_32877,type,
    v60324: state_type > $o ).

tff(pred_def_32878,type,
    v60322: state_type > $o ).

tff(pred_def_32879,type,
    v60320: state_type > $o ).

tff(pred_def_32880,type,
    v60318: state_type > $o ).

tff(pred_def_32881,type,
    v60424: state_type > $o ).

tff(pred_def_32882,type,
    v60422: state_type > $o ).

tff(pred_def_32883,type,
    v60428: state_type > $o ).

tff(pred_def_32884,type,
    v60426: state_type > $o ).

tff(pred_def_32885,type,
    v60432: state_type > $o ).

tff(pred_def_32886,type,
    v60430: state_type > $o ).

tff(pred_def_32887,type,
    v60434: state_type > $o ).

tff(pred_def_32888,type,
    v60420: state_type > $o ).

tff(pred_def_32889,type,
    v60418: state_type > $o ).

tff(pred_def_32890,type,
    v60416: state_type > $o ).

tff(pred_def_32891,type,
    v60414: state_type > $o ).

tff(pred_def_32892,type,
    v60412: state_type > $o ).

tff(pred_def_32893,type,
    v60448: state_type > $o ).

tff(pred_def_32894,type,
    v60446: state_type > $o ).

tff(pred_def_32895,type,
    v60452: state_type > $o ).

tff(pred_def_32896,type,
    v60450: state_type > $o ).

tff(pred_def_32897,type,
    v60456: state_type > $o ).

tff(pred_def_32898,type,
    v60454: state_type > $o ).

tff(pred_def_32899,type,
    v60458: state_type > $o ).

tff(pred_def_32900,type,
    v60444: state_type > $o ).

tff(pred_def_32901,type,
    v60442: state_type > $o ).

tff(pred_def_32902,type,
    v60440: state_type > $o ).

tff(pred_def_32903,type,
    v60438: state_type > $o ).

tff(pred_def_32904,type,
    v60436: state_type > $o ).

tff(pred_def_32905,type,
    v60472: state_type > $o ).

tff(pred_def_32906,type,
    v60470: state_type > $o ).

tff(pred_def_32907,type,
    v60476: state_type > $o ).

tff(pred_def_32908,type,
    v60474: state_type > $o ).

tff(pred_def_32909,type,
    v60480: state_type > $o ).

tff(pred_def_32910,type,
    v60478: state_type > $o ).

tff(pred_def_32911,type,
    v60482: state_type > $o ).

tff(pred_def_32912,type,
    v60468: state_type > $o ).

tff(pred_def_32913,type,
    v60466: state_type > $o ).

tff(pred_def_32914,type,
    v60464: state_type > $o ).

tff(pred_def_32915,type,
    v60462: state_type > $o ).

tff(pred_def_32916,type,
    v60460: state_type > $o ).

tff(pred_def_32917,type,
    v60484: state_type > $o ).

tff(pred_def_32918,type,
    v60410: state_type > $o ).

tff(pred_def_32919,type,
    v60408: state_type > $o ).

tff(pred_def_32920,type,
    v60406: state_type > $o ).

tff(pred_def_32921,type,
    v60404: state_type > $o ).

tff(pred_def_32922,type,
    v60402: state_type > $o ).

tff(pred_def_32923,type,
    v60508: state_type > $o ).

tff(pred_def_32924,type,
    v60506: state_type > $o ).

tff(pred_def_32925,type,
    v60512: state_type > $o ).

tff(pred_def_32926,type,
    v60510: state_type > $o ).

tff(pred_def_32927,type,
    v60516: state_type > $o ).

tff(pred_def_32928,type,
    v60514: state_type > $o ).

tff(pred_def_32929,type,
    v60518: state_type > $o ).

tff(pred_def_32930,type,
    v60504: state_type > $o ).

tff(pred_def_32931,type,
    v60502: state_type > $o ).

tff(pred_def_32932,type,
    v60500: state_type > $o ).

tff(pred_def_32933,type,
    v60498: state_type > $o ).

tff(pred_def_32934,type,
    v60496: state_type > $o ).

tff(pred_def_32935,type,
    v60532: state_type > $o ).

tff(pred_def_32936,type,
    v60530: state_type > $o ).

tff(pred_def_32937,type,
    v60536: state_type > $o ).

tff(pred_def_32938,type,
    v60534: state_type > $o ).

tff(pred_def_32939,type,
    v60540: state_type > $o ).

tff(pred_def_32940,type,
    v60538: state_type > $o ).

tff(pred_def_32941,type,
    v60542: state_type > $o ).

tff(pred_def_32942,type,
    v60528: state_type > $o ).

tff(pred_def_32943,type,
    v60526: state_type > $o ).

tff(pred_def_32944,type,
    v60524: state_type > $o ).

tff(pred_def_32945,type,
    v60522: state_type > $o ).

tff(pred_def_32946,type,
    v60520: state_type > $o ).

tff(pred_def_32947,type,
    v60556: state_type > $o ).

tff(pred_def_32948,type,
    v60554: state_type > $o ).

tff(pred_def_32949,type,
    v60560: state_type > $o ).

tff(pred_def_32950,type,
    v60558: state_type > $o ).

tff(pred_def_32951,type,
    v60564: state_type > $o ).

tff(pred_def_32952,type,
    v60562: state_type > $o ).

tff(pred_def_32953,type,
    v60566: state_type > $o ).

tff(pred_def_32954,type,
    v60552: state_type > $o ).

tff(pred_def_32955,type,
    v60550: state_type > $o ).

tff(pred_def_32956,type,
    v60548: state_type > $o ).

tff(pred_def_32957,type,
    v60546: state_type > $o ).

tff(pred_def_32958,type,
    v60544: state_type > $o ).

tff(pred_def_32959,type,
    v60568: state_type > $o ).

tff(pred_def_32960,type,
    v60494: state_type > $o ).

tff(pred_def_32961,type,
    v60492: state_type > $o ).

tff(pred_def_32962,type,
    v60490: state_type > $o ).

tff(pred_def_32963,type,
    v60488: state_type > $o ).

tff(pred_def_32964,type,
    v60486: state_type > $o ).

tff(pred_def_32965,type,
    v60570: state_type > $o ).

tff(pred_def_32966,type,
    v60316: state_type > $o ).

tff(pred_def_32967,type,
    v60314: state_type > $o ).

tff(pred_def_32968,type,
    v60312: state_type > $o ).

tff(pred_def_32969,type,
    v60310: state_type > $o ).

tff(pred_def_32970,type,
    v60308: state_type > $o ).

tff(pred_def_32971,type,
    v60594: state_type > $o ).

tff(pred_def_32972,type,
    v60592: state_type > $o ).

tff(pred_def_32973,type,
    v60598: state_type > $o ).

tff(pred_def_32974,type,
    v60596: state_type > $o ).

tff(pred_def_32975,type,
    v60602: state_type > $o ).

tff(pred_def_32976,type,
    v60600: state_type > $o ).

tff(pred_def_32977,type,
    v60604: state_type > $o ).

tff(pred_def_32978,type,
    v60590: state_type > $o ).

tff(pred_def_32979,type,
    v60588: state_type > $o ).

tff(pred_def_32980,type,
    v60586: state_type > $o ).

tff(pred_def_32981,type,
    v60584: state_type > $o ).

tff(pred_def_32982,type,
    v60582: state_type > $o ).

tff(pred_def_32983,type,
    v60628: state_type > $o ).

tff(pred_def_32984,type,
    v60626: state_type > $o ).

tff(pred_def_32985,type,
    v60632: state_type > $o ).

tff(pred_def_32986,type,
    v60630: state_type > $o ).

tff(pred_def_32987,type,
    v60636: state_type > $o ).

tff(pred_def_32988,type,
    v60634: state_type > $o ).

tff(pred_def_32989,type,
    v60638: state_type > $o ).

tff(pred_def_32990,type,
    v60624: state_type > $o ).

tff(pred_def_32991,type,
    v60622: state_type > $o ).

tff(pred_def_32992,type,
    v60620: state_type > $o ).

tff(pred_def_32993,type,
    v60618: state_type > $o ).

tff(pred_def_32994,type,
    v60616: state_type > $o ).

tff(pred_def_32995,type,
    v60652: state_type > $o ).

tff(pred_def_32996,type,
    v60650: state_type > $o ).

tff(pred_def_32997,type,
    v60656: state_type > $o ).

tff(pred_def_32998,type,
    v60654: state_type > $o ).

tff(pred_def_32999,type,
    v60660: state_type > $o ).

tff(pred_def_33000,type,
    v60658: state_type > $o ).

tff(pred_def_33001,type,
    v60662: state_type > $o ).

tff(pred_def_33002,type,
    v60648: state_type > $o ).

tff(pred_def_33003,type,
    v60646: state_type > $o ).

tff(pred_def_33004,type,
    v60644: state_type > $o ).

tff(pred_def_33005,type,
    v60642: state_type > $o ).

tff(pred_def_33006,type,
    v60640: state_type > $o ).

tff(pred_def_33007,type,
    v60676: state_type > $o ).

tff(pred_def_33008,type,
    v60674: state_type > $o ).

tff(pred_def_33009,type,
    v60680: state_type > $o ).

tff(pred_def_33010,type,
    v60678: state_type > $o ).

tff(pred_def_33011,type,
    v60684: state_type > $o ).

tff(pred_def_33012,type,
    v60682: state_type > $o ).

tff(pred_def_33013,type,
    v60686: state_type > $o ).

tff(pred_def_33014,type,
    v60672: state_type > $o ).

tff(pred_def_33015,type,
    v60670: state_type > $o ).

tff(pred_def_33016,type,
    v60668: state_type > $o ).

tff(pred_def_33017,type,
    v60666: state_type > $o ).

tff(pred_def_33018,type,
    v60664: state_type > $o ).

tff(pred_def_33019,type,
    v60688: state_type > $o ).

tff(pred_def_33020,type,
    v60614: state_type > $o ).

tff(pred_def_33021,type,
    v60612: state_type > $o ).

tff(pred_def_33022,type,
    v60610: state_type > $o ).

tff(pred_def_33023,type,
    v60608: state_type > $o ).

tff(pred_def_33024,type,
    v60606: state_type > $o ).

tff(pred_def_33025,type,
    v60698: state_type > $o ).

tff(pred_def_33026,type,
    v60696: state_type > $o ).

tff(pred_def_33027,type,
    v60695: state_type > $o ).

tff(pred_def_33028,type,
    v60694: ( state_type * $int ) > $o ).

tff(pred_def_33029,type,
    v60692: state_type > $o ).

tff(pred_def_33030,type,
    v60690: state_type > $o ).

tff(pred_def_33031,type,
    v60702: state_type > $o ).

tff(pred_def_33032,type,
    v60580: state_type > $o ).

tff(pred_def_33033,type,
    v60578: state_type > $o ).

tff(pred_def_33034,type,
    v60576: state_type > $o ).

tff(pred_def_33035,type,
    v60574: state_type > $o ).

tff(pred_def_33036,type,
    v60572: state_type > $o ).

tff(pred_def_33037,type,
    v60704: state_type > $o ).

tff(pred_def_33038,type,
    v60042: state_type > $o ).

tff(pred_def_33039,type,
    v60040: state_type > $o ).

tff(pred_def_33040,type,
    v60038: state_type > $o ).

tff(pred_def_33041,type,
    v60036: state_type > $o ).

tff(pred_def_33042,type,
    v60706: state_type > $o ).

tff(pred_def_33043,type,
    v5909: state_type > $o ).

tff(pred_def_33044,type,
    v5907: state_type > $o ).

tff(pred_def_33045,type,
    v5905: state_type > $o ).

tff(pred_def_33046,type,
    v5903: state_type > $o ).

tff(pred_def_33047,type,
    v5901: state_type > $o ).

tff(pred_def_33048,type,
    v60758: state_type > $o ).

tff(pred_def_33049,type,
    v60756: state_type > $o ).

tff(pred_def_33050,type,
    v60762: state_type > $o ).

tff(pred_def_33051,type,
    v60760: state_type > $o ).

tff(pred_def_33052,type,
    v60766: state_type > $o ).

tff(pred_def_33053,type,
    v60764: state_type > $o ).

tff(pred_def_33054,type,
    v60768: state_type > $o ).

tff(pred_def_33055,type,
    v60754: state_type > $o ).

tff(pred_def_33056,type,
    v60752: state_type > $o ).

tff(pred_def_33057,type,
    v60750: state_type > $o ).

tff(pred_def_33058,type,
    v60748: state_type > $o ).

tff(pred_def_33059,type,
    v60746: state_type > $o ).

tff(pred_def_33060,type,
    v60782: state_type > $o ).

tff(pred_def_33061,type,
    v60780: state_type > $o ).

tff(pred_def_33062,type,
    v60786: state_type > $o ).

tff(pred_def_33063,type,
    v60784: state_type > $o ).

tff(pred_def_33064,type,
    v60790: state_type > $o ).

tff(pred_def_33065,type,
    v60788: state_type > $o ).

tff(pred_def_33066,type,
    v60792: state_type > $o ).

tff(pred_def_33067,type,
    v60778: state_type > $o ).

tff(pred_def_33068,type,
    v60776: state_type > $o ).

tff(pred_def_33069,type,
    v60774: state_type > $o ).

tff(pred_def_33070,type,
    v60772: state_type > $o ).

tff(pred_def_33071,type,
    v60770: state_type > $o ).

tff(pred_def_33072,type,
    v60806: state_type > $o ).

tff(pred_def_33073,type,
    v60804: state_type > $o ).

tff(pred_def_33074,type,
    v60810: state_type > $o ).

tff(pred_def_33075,type,
    v60808: state_type > $o ).

tff(pred_def_33076,type,
    v60814: state_type > $o ).

tff(pred_def_33077,type,
    v60812: state_type > $o ).

tff(pred_def_33078,type,
    v60816: state_type > $o ).

tff(pred_def_33079,type,
    v60802: state_type > $o ).

tff(pred_def_33080,type,
    v60800: state_type > $o ).

tff(pred_def_33081,type,
    v60798: state_type > $o ).

tff(pred_def_33082,type,
    v60796: state_type > $o ).

tff(pred_def_33083,type,
    v60794: state_type > $o ).

tff(pred_def_33084,type,
    v60818: state_type > $o ).

tff(pred_def_33085,type,
    v60744: state_type > $o ).

tff(pred_def_33086,type,
    v60742: state_type > $o ).

tff(pred_def_33087,type,
    v60740: state_type > $o ).

tff(pred_def_33088,type,
    v60738: state_type > $o ).

tff(pred_def_33089,type,
    v60736: state_type > $o ).

tff(pred_def_33090,type,
    v60842: state_type > $o ).

tff(pred_def_33091,type,
    v60840: state_type > $o ).

tff(pred_def_33092,type,
    v60846: state_type > $o ).

tff(pred_def_33093,type,
    v60844: state_type > $o ).

tff(pred_def_33094,type,
    v60850: state_type > $o ).

tff(pred_def_33095,type,
    v60848: state_type > $o ).

tff(pred_def_33096,type,
    v60852: state_type > $o ).

tff(pred_def_33097,type,
    v60838: state_type > $o ).

tff(pred_def_33098,type,
    v60836: state_type > $o ).

tff(pred_def_33099,type,
    v60834: state_type > $o ).

tff(pred_def_33100,type,
    v60832: state_type > $o ).

tff(pred_def_33101,type,
    v60830: state_type > $o ).

tff(pred_def_33102,type,
    v60866: state_type > $o ).

tff(pred_def_33103,type,
    v60864: state_type > $o ).

tff(pred_def_33104,type,
    v60870: state_type > $o ).

tff(pred_def_33105,type,
    v60868: state_type > $o ).

tff(pred_def_33106,type,
    v60874: state_type > $o ).

tff(pred_def_33107,type,
    v60872: state_type > $o ).

tff(pred_def_33108,type,
    v60876: state_type > $o ).

tff(pred_def_33109,type,
    v60862: state_type > $o ).

tff(pred_def_33110,type,
    v60860: state_type > $o ).

tff(pred_def_33111,type,
    v60858: state_type > $o ).

tff(pred_def_33112,type,
    v60856: state_type > $o ).

tff(pred_def_33113,type,
    v60854: state_type > $o ).

tff(pred_def_33114,type,
    v60890: state_type > $o ).

tff(pred_def_33115,type,
    v60888: state_type > $o ).

tff(pred_def_33116,type,
    v60894: state_type > $o ).

tff(pred_def_33117,type,
    v60892: state_type > $o ).

tff(pred_def_33118,type,
    v60898: state_type > $o ).

tff(pred_def_33119,type,
    v60896: state_type > $o ).

tff(pred_def_33120,type,
    v60900: state_type > $o ).

tff(pred_def_33121,type,
    v60886: state_type > $o ).

tff(pred_def_33122,type,
    v60884: state_type > $o ).

tff(pred_def_33123,type,
    v60882: state_type > $o ).

tff(pred_def_33124,type,
    v60880: state_type > $o ).

tff(pred_def_33125,type,
    v60878: state_type > $o ).

tff(pred_def_33126,type,
    v60902: state_type > $o ).

tff(pred_def_33127,type,
    v60828: state_type > $o ).

tff(pred_def_33128,type,
    v60826: state_type > $o ).

tff(pred_def_33129,type,
    v60824: state_type > $o ).

tff(pred_def_33130,type,
    v60822: state_type > $o ).

tff(pred_def_33131,type,
    v60820: state_type > $o ).

tff(pred_def_33132,type,
    v60926: state_type > $o ).

tff(pred_def_33133,type,
    v60924: state_type > $o ).

tff(pred_def_33134,type,
    v60930: state_type > $o ).

tff(pred_def_33135,type,
    v60928: state_type > $o ).

tff(pred_def_33136,type,
    v60934: state_type > $o ).

tff(pred_def_33137,type,
    v60932: state_type > $o ).

tff(pred_def_33138,type,
    v60936: state_type > $o ).

tff(pred_def_33139,type,
    v60922: state_type > $o ).

tff(pred_def_33140,type,
    v60920: state_type > $o ).

tff(pred_def_33141,type,
    v60918: state_type > $o ).

tff(pred_def_33142,type,
    v60916: state_type > $o ).

tff(pred_def_33143,type,
    v60914: state_type > $o ).

tff(pred_def_33144,type,
    v60950: state_type > $o ).

tff(pred_def_33145,type,
    v60948: state_type > $o ).

tff(pred_def_33146,type,
    v60954: state_type > $o ).

tff(pred_def_33147,type,
    v60952: state_type > $o ).

tff(pred_def_33148,type,
    v60958: state_type > $o ).

tff(pred_def_33149,type,
    v60956: state_type > $o ).

tff(pred_def_33150,type,
    v60960: state_type > $o ).

tff(pred_def_33151,type,
    v60946: state_type > $o ).

tff(pred_def_33152,type,
    v60944: state_type > $o ).

tff(pred_def_33153,type,
    v60942: state_type > $o ).

tff(pred_def_33154,type,
    v60940: state_type > $o ).

tff(pred_def_33155,type,
    v60938: state_type > $o ).

tff(pred_def_33156,type,
    v60974: state_type > $o ).

tff(pred_def_33157,type,
    v60972: state_type > $o ).

tff(pred_def_33158,type,
    v60978: state_type > $o ).

tff(pred_def_33159,type,
    v60976: state_type > $o ).

tff(pred_def_33160,type,
    v60982: state_type > $o ).

tff(pred_def_33161,type,
    v60980: state_type > $o ).

tff(pred_def_33162,type,
    v60984: state_type > $o ).

tff(pred_def_33163,type,
    v60970: state_type > $o ).

tff(pred_def_33164,type,
    v60968: state_type > $o ).

tff(pred_def_33165,type,
    v60966: state_type > $o ).

tff(pred_def_33166,type,
    v60964: state_type > $o ).

tff(pred_def_33167,type,
    v60962: state_type > $o ).

tff(pred_def_33168,type,
    v60986: state_type > $o ).

tff(pred_def_33169,type,
    v60912: state_type > $o ).

tff(pred_def_33170,type,
    v60910: state_type > $o ).

tff(pred_def_33171,type,
    v60908: state_type > $o ).

tff(pred_def_33172,type,
    v60906: state_type > $o ).

tff(pred_def_33173,type,
    v60904: state_type > $o ).

tff(pred_def_33174,type,
    v60988: state_type > $o ).

tff(pred_def_33175,type,
    v60734: state_type > $o ).

tff(pred_def_33176,type,
    v60732: state_type > $o ).

tff(pred_def_33177,type,
    v60730: state_type > $o ).

tff(pred_def_33178,type,
    v60728: state_type > $o ).

tff(pred_def_33179,type,
    v60726: state_type > $o ).

tff(pred_def_33180,type,
    v61022: state_type > $o ).

tff(pred_def_33181,type,
    v61020: state_type > $o ).

tff(pred_def_33182,type,
    v61026: state_type > $o ).

tff(pred_def_33183,type,
    v61024: state_type > $o ).

tff(pred_def_33184,type,
    v61030: state_type > $o ).

tff(pred_def_33185,type,
    v61028: state_type > $o ).

tff(pred_def_33186,type,
    v61032: state_type > $o ).

tff(pred_def_33187,type,
    v61018: state_type > $o ).

tff(pred_def_33188,type,
    v61016: state_type > $o ).

tff(pred_def_33189,type,
    v61014: state_type > $o ).

tff(pred_def_33190,type,
    v61012: state_type > $o ).

tff(pred_def_33191,type,
    v61010: state_type > $o ).

tff(pred_def_33192,type,
    v61046: state_type > $o ).

tff(pred_def_33193,type,
    v61044: state_type > $o ).

tff(pred_def_33194,type,
    v61050: state_type > $o ).

tff(pred_def_33195,type,
    v61048: state_type > $o ).

tff(pred_def_33196,type,
    v61054: state_type > $o ).

tff(pred_def_33197,type,
    v61052: state_type > $o ).

tff(pred_def_33198,type,
    v61056: state_type > $o ).

tff(pred_def_33199,type,
    v61042: state_type > $o ).

tff(pred_def_33200,type,
    v61040: state_type > $o ).

tff(pred_def_33201,type,
    v61038: state_type > $o ).

tff(pred_def_33202,type,
    v61036: state_type > $o ).

tff(pred_def_33203,type,
    v61034: state_type > $o ).

tff(pred_def_33204,type,
    v61070: state_type > $o ).

tff(pred_def_33205,type,
    v61068: state_type > $o ).

tff(pred_def_33206,type,
    v61074: state_type > $o ).

tff(pred_def_33207,type,
    v61072: state_type > $o ).

tff(pred_def_33208,type,
    v61078: state_type > $o ).

tff(pred_def_33209,type,
    v61076: state_type > $o ).

tff(pred_def_33210,type,
    v61080: state_type > $o ).

tff(pred_def_33211,type,
    v61066: state_type > $o ).

tff(pred_def_33212,type,
    v61064: state_type > $o ).

tff(pred_def_33213,type,
    v61062: state_type > $o ).

tff(pred_def_33214,type,
    v61060: state_type > $o ).

tff(pred_def_33215,type,
    v61058: state_type > $o ).

tff(pred_def_33216,type,
    v61082: state_type > $o ).

tff(pred_def_33217,type,
    v61008: state_type > $o ).

tff(pred_def_33218,type,
    v61006: state_type > $o ).

tff(pred_def_33219,type,
    v61004: state_type > $o ).

tff(pred_def_33220,type,
    v61002: state_type > $o ).

tff(pred_def_33221,type,
    v61000: state_type > $o ).

tff(pred_def_33222,type,
    v61106: state_type > $o ).

tff(pred_def_33223,type,
    v61104: state_type > $o ).

tff(pred_def_33224,type,
    v61110: state_type > $o ).

tff(pred_def_33225,type,
    v61108: state_type > $o ).

tff(pred_def_33226,type,
    v61114: state_type > $o ).

tff(pred_def_33227,type,
    v61112: state_type > $o ).

tff(pred_def_33228,type,
    v61116: state_type > $o ).

tff(pred_def_33229,type,
    v61102: state_type > $o ).

tff(pred_def_33230,type,
    v61100: state_type > $o ).

tff(pred_def_33231,type,
    v61098: state_type > $o ).

tff(pred_def_33232,type,
    v61096: state_type > $o ).

tff(pred_def_33233,type,
    v61094: state_type > $o ).

tff(pred_def_33234,type,
    v61130: state_type > $o ).

tff(pred_def_33235,type,
    v61128: state_type > $o ).

tff(pred_def_33236,type,
    v61134: state_type > $o ).

tff(pred_def_33237,type,
    v61132: state_type > $o ).

tff(pred_def_33238,type,
    v61138: state_type > $o ).

tff(pred_def_33239,type,
    v61136: state_type > $o ).

tff(pred_def_33240,type,
    v61140: state_type > $o ).

tff(pred_def_33241,type,
    v61126: state_type > $o ).

tff(pred_def_33242,type,
    v61124: state_type > $o ).

tff(pred_def_33243,type,
    v61122: state_type > $o ).

tff(pred_def_33244,type,
    v61120: state_type > $o ).

tff(pred_def_33245,type,
    v61118: state_type > $o ).

tff(pred_def_33246,type,
    v61154: state_type > $o ).

tff(pred_def_33247,type,
    v61152: state_type > $o ).

tff(pred_def_33248,type,
    v61158: state_type > $o ).

tff(pred_def_33249,type,
    v61156: state_type > $o ).

tff(pred_def_33250,type,
    v61162: state_type > $o ).

tff(pred_def_33251,type,
    v61160: state_type > $o ).

tff(pred_def_33252,type,
    v61164: state_type > $o ).

tff(pred_def_33253,type,
    v61150: state_type > $o ).

tff(pred_def_33254,type,
    v61148: state_type > $o ).

tff(pred_def_33255,type,
    v61146: state_type > $o ).

tff(pred_def_33256,type,
    v61144: state_type > $o ).

tff(pred_def_33257,type,
    v61142: state_type > $o ).

tff(pred_def_33258,type,
    v61166: state_type > $o ).

tff(pred_def_33259,type,
    v61092: state_type > $o ).

tff(pred_def_33260,type,
    v61090: state_type > $o ).

tff(pred_def_33261,type,
    v61088: state_type > $o ).

tff(pred_def_33262,type,
    v61086: state_type > $o ).

tff(pred_def_33263,type,
    v61084: state_type > $o ).

tff(pred_def_33264,type,
    v61190: state_type > $o ).

tff(pred_def_33265,type,
    v61188: state_type > $o ).

tff(pred_def_33266,type,
    v61194: state_type > $o ).

tff(pred_def_33267,type,
    v61192: state_type > $o ).

tff(pred_def_33268,type,
    v61198: state_type > $o ).

tff(pred_def_33269,type,
    v61196: state_type > $o ).

tff(pred_def_33270,type,
    v61200: state_type > $o ).

tff(pred_def_33271,type,
    v61186: state_type > $o ).

tff(pred_def_33272,type,
    v61184: state_type > $o ).

tff(pred_def_33273,type,
    v61182: state_type > $o ).

tff(pred_def_33274,type,
    v61180: state_type > $o ).

tff(pred_def_33275,type,
    v61178: state_type > $o ).

tff(pred_def_33276,type,
    v61214: state_type > $o ).

tff(pred_def_33277,type,
    v61212: state_type > $o ).

tff(pred_def_33278,type,
    v61218: state_type > $o ).

tff(pred_def_33279,type,
    v61216: state_type > $o ).

tff(pred_def_33280,type,
    v61222: state_type > $o ).

tff(pred_def_33281,type,
    v61220: state_type > $o ).

tff(pred_def_33282,type,
    v61224: state_type > $o ).

tff(pred_def_33283,type,
    v61210: state_type > $o ).

tff(pred_def_33284,type,
    v61208: state_type > $o ).

tff(pred_def_33285,type,
    v61206: state_type > $o ).

tff(pred_def_33286,type,
    v61204: state_type > $o ).

tff(pred_def_33287,type,
    v61202: state_type > $o ).

tff(pred_def_33288,type,
    v61238: state_type > $o ).

tff(pred_def_33289,type,
    v61236: state_type > $o ).

tff(pred_def_33290,type,
    v61242: state_type > $o ).

tff(pred_def_33291,type,
    v61240: state_type > $o ).

tff(pred_def_33292,type,
    v61246: state_type > $o ).

tff(pred_def_33293,type,
    v61244: state_type > $o ).

tff(pred_def_33294,type,
    v61248: state_type > $o ).

tff(pred_def_33295,type,
    v61234: state_type > $o ).

tff(pred_def_33296,type,
    v61232: state_type > $o ).

tff(pred_def_33297,type,
    v61230: state_type > $o ).

tff(pred_def_33298,type,
    v61228: state_type > $o ).

tff(pred_def_33299,type,
    v61226: state_type > $o ).

tff(pred_def_33300,type,
    v61250: state_type > $o ).

tff(pred_def_33301,type,
    v61176: state_type > $o ).

tff(pred_def_33302,type,
    v61174: state_type > $o ).

tff(pred_def_33303,type,
    v61172: state_type > $o ).

tff(pred_def_33304,type,
    v61170: state_type > $o ).

tff(pred_def_33305,type,
    v61168: state_type > $o ).

tff(pred_def_33306,type,
    v61252: state_type > $o ).

tff(pred_def_33307,type,
    v60998: state_type > $o ).

tff(pred_def_33308,type,
    v60996: state_type > $o ).

tff(pred_def_33309,type,
    v60994: state_type > $o ).

tff(pred_def_33310,type,
    v60992: state_type > $o ).

tff(pred_def_33311,type,
    v60990: state_type > $o ).

tff(pred_def_33312,type,
    v61276: state_type > $o ).

tff(pred_def_33313,type,
    v61274: state_type > $o ).

tff(pred_def_33314,type,
    v61280: state_type > $o ).

tff(pred_def_33315,type,
    v61278: state_type > $o ).

tff(pred_def_33316,type,
    v61284: state_type > $o ).

tff(pred_def_33317,type,
    v61282: state_type > $o ).

tff(pred_def_33318,type,
    v61286: state_type > $o ).

tff(pred_def_33319,type,
    v61272: state_type > $o ).

tff(pred_def_33320,type,
    v61270: state_type > $o ).

tff(pred_def_33321,type,
    v61268: state_type > $o ).

tff(pred_def_33322,type,
    v61266: state_type > $o ).

tff(pred_def_33323,type,
    v61264: state_type > $o ).

tff(pred_def_33324,type,
    v61310: state_type > $o ).

tff(pred_def_33325,type,
    v61308: state_type > $o ).

tff(pred_def_33326,type,
    v61314: state_type > $o ).

tff(pred_def_33327,type,
    v61312: state_type > $o ).

tff(pred_def_33328,type,
    v61318: state_type > $o ).

tff(pred_def_33329,type,
    v61316: state_type > $o ).

tff(pred_def_33330,type,
    v61320: state_type > $o ).

tff(pred_def_33331,type,
    v61306: state_type > $o ).

tff(pred_def_33332,type,
    v61304: state_type > $o ).

tff(pred_def_33333,type,
    v61302: state_type > $o ).

tff(pred_def_33334,type,
    v61300: state_type > $o ).

tff(pred_def_33335,type,
    v61298: state_type > $o ).

tff(pred_def_33336,type,
    v61334: state_type > $o ).

tff(pred_def_33337,type,
    v61332: state_type > $o ).

tff(pred_def_33338,type,
    v61338: state_type > $o ).

tff(pred_def_33339,type,
    v61336: state_type > $o ).

tff(pred_def_33340,type,
    v61342: state_type > $o ).

tff(pred_def_33341,type,
    v61340: state_type > $o ).

tff(pred_def_33342,type,
    v61344: state_type > $o ).

tff(pred_def_33343,type,
    v61330: state_type > $o ).

tff(pred_def_33344,type,
    v61328: state_type > $o ).

tff(pred_def_33345,type,
    v61326: state_type > $o ).

tff(pred_def_33346,type,
    v61324: state_type > $o ).

tff(pred_def_33347,type,
    v61322: state_type > $o ).

tff(pred_def_33348,type,
    v61358: state_type > $o ).

tff(pred_def_33349,type,
    v61356: state_type > $o ).

tff(pred_def_33350,type,
    v61362: state_type > $o ).

tff(pred_def_33351,type,
    v61360: state_type > $o ).

tff(pred_def_33352,type,
    v61366: state_type > $o ).

tff(pred_def_33353,type,
    v61364: state_type > $o ).

tff(pred_def_33354,type,
    v61368: state_type > $o ).

tff(pred_def_33355,type,
    v61354: state_type > $o ).

tff(pred_def_33356,type,
    v61352: state_type > $o ).

tff(pred_def_33357,type,
    v61350: state_type > $o ).

tff(pred_def_33358,type,
    v61348: state_type > $o ).

tff(pred_def_33359,type,
    v61346: state_type > $o ).

tff(pred_def_33360,type,
    v61370: state_type > $o ).

tff(pred_def_33361,type,
    v61296: state_type > $o ).

tff(pred_def_33362,type,
    v61294: state_type > $o ).

tff(pred_def_33363,type,
    v61292: state_type > $o ).

tff(pred_def_33364,type,
    v61290: state_type > $o ).

tff(pred_def_33365,type,
    v61288: state_type > $o ).

tff(pred_def_33366,type,
    v61380: state_type > $o ).

tff(pred_def_33367,type,
    v61378: state_type > $o ).

tff(pred_def_33368,type,
    v61377: state_type > $o ).

tff(pred_def_33369,type,
    v61376: ( state_type * $int ) > $o ).

tff(pred_def_33370,type,
    v61374: state_type > $o ).

tff(pred_def_33371,type,
    v61372: state_type > $o ).

tff(pred_def_33372,type,
    v61384: state_type > $o ).

tff(pred_def_33373,type,
    v61262: state_type > $o ).

tff(pred_def_33374,type,
    v61260: state_type > $o ).

tff(pred_def_33375,type,
    v61258: state_type > $o ).

tff(pred_def_33376,type,
    v61256: state_type > $o ).

tff(pred_def_33377,type,
    v61254: state_type > $o ).

tff(pred_def_33378,type,
    v61386: state_type > $o ).

tff(pred_def_33379,type,
    v60724: state_type > $o ).

tff(pred_def_33380,type,
    v60722: state_type > $o ).

tff(pred_def_33381,type,
    v60720: state_type > $o ).

tff(pred_def_33382,type,
    v60718: state_type > $o ).

tff(pred_def_33383,type,
    v61428: state_type > $o ).

tff(pred_def_33384,type,
    v61426: state_type > $o ).

tff(pred_def_33385,type,
    v61432: state_type > $o ).

tff(pred_def_33386,type,
    v61430: state_type > $o ).

tff(pred_def_33387,type,
    v61436: state_type > $o ).

tff(pred_def_33388,type,
    v61434: state_type > $o ).

tff(pred_def_33389,type,
    v61438: state_type > $o ).

tff(pred_def_33390,type,
    v61424: state_type > $o ).

tff(pred_def_33391,type,
    v61422: state_type > $o ).

tff(pred_def_33392,type,
    v61420: state_type > $o ).

tff(pred_def_33393,type,
    v61418: state_type > $o ).

tff(pred_def_33394,type,
    v61416: state_type > $o ).

tff(pred_def_33395,type,
    v61452: state_type > $o ).

tff(pred_def_33396,type,
    v61450: state_type > $o ).

tff(pred_def_33397,type,
    v61456: state_type > $o ).

tff(pred_def_33398,type,
    v61454: state_type > $o ).

tff(pred_def_33399,type,
    v61460: state_type > $o ).

tff(pred_def_33400,type,
    v61458: state_type > $o ).

tff(pred_def_33401,type,
    v61462: state_type > $o ).

tff(pred_def_33402,type,
    v61448: state_type > $o ).

tff(pred_def_33403,type,
    v61446: state_type > $o ).

tff(pred_def_33404,type,
    v61444: state_type > $o ).

tff(pred_def_33405,type,
    v61442: state_type > $o ).

tff(pred_def_33406,type,
    v61440: state_type > $o ).

tff(pred_def_33407,type,
    v61476: state_type > $o ).

tff(pred_def_33408,type,
    v61474: state_type > $o ).

tff(pred_def_33409,type,
    v61480: state_type > $o ).

tff(pred_def_33410,type,
    v61478: state_type > $o ).

tff(pred_def_33411,type,
    v61484: state_type > $o ).

tff(pred_def_33412,type,
    v61482: state_type > $o ).

tff(pred_def_33413,type,
    v61486: state_type > $o ).

tff(pred_def_33414,type,
    v61472: state_type > $o ).

tff(pred_def_33415,type,
    v61470: state_type > $o ).

tff(pred_def_33416,type,
    v61468: state_type > $o ).

tff(pred_def_33417,type,
    v61466: state_type > $o ).

tff(pred_def_33418,type,
    v61464: state_type > $o ).

tff(pred_def_33419,type,
    v61488: state_type > $o ).

tff(pred_def_33420,type,
    v61414: state_type > $o ).

tff(pred_def_33421,type,
    v61412: state_type > $o ).

tff(pred_def_33422,type,
    v61410: state_type > $o ).

tff(pred_def_33423,type,
    v61408: state_type > $o ).

tff(pred_def_33424,type,
    v61406: state_type > $o ).

tff(pred_def_33425,type,
    v61512: state_type > $o ).

tff(pred_def_33426,type,
    v61510: state_type > $o ).

tff(pred_def_33427,type,
    v61516: state_type > $o ).

tff(pred_def_33428,type,
    v61514: state_type > $o ).

tff(pred_def_33429,type,
    v61520: state_type > $o ).

tff(pred_def_33430,type,
    v61518: state_type > $o ).

tff(pred_def_33431,type,
    v61522: state_type > $o ).

tff(pred_def_33432,type,
    v61508: state_type > $o ).

tff(pred_def_33433,type,
    v61506: state_type > $o ).

tff(pred_def_33434,type,
    v61504: state_type > $o ).

tff(pred_def_33435,type,
    v61502: state_type > $o ).

tff(pred_def_33436,type,
    v61500: state_type > $o ).

tff(pred_def_33437,type,
    v61536: state_type > $o ).

tff(pred_def_33438,type,
    v61534: state_type > $o ).

tff(pred_def_33439,type,
    v61540: state_type > $o ).

tff(pred_def_33440,type,
    v61538: state_type > $o ).

tff(pred_def_33441,type,
    v61544: state_type > $o ).

tff(pred_def_33442,type,
    v61542: state_type > $o ).

tff(pred_def_33443,type,
    v61546: state_type > $o ).

tff(pred_def_33444,type,
    v61532: state_type > $o ).

tff(pred_def_33445,type,
    v61530: state_type > $o ).

tff(pred_def_33446,type,
    v61528: state_type > $o ).

tff(pred_def_33447,type,
    v61526: state_type > $o ).

tff(pred_def_33448,type,
    v61524: state_type > $o ).

tff(pred_def_33449,type,
    v61560: state_type > $o ).

tff(pred_def_33450,type,
    v61558: state_type > $o ).

tff(pred_def_33451,type,
    v61564: state_type > $o ).

tff(pred_def_33452,type,
    v61562: state_type > $o ).

tff(pred_def_33453,type,
    v61568: state_type > $o ).

tff(pred_def_33454,type,
    v61566: state_type > $o ).

tff(pred_def_33455,type,
    v61570: state_type > $o ).

tff(pred_def_33456,type,
    v61556: state_type > $o ).

tff(pred_def_33457,type,
    v61554: state_type > $o ).

tff(pred_def_33458,type,
    v61552: state_type > $o ).

tff(pred_def_33459,type,
    v61550: state_type > $o ).

tff(pred_def_33460,type,
    v61548: state_type > $o ).

tff(pred_def_33461,type,
    v61572: state_type > $o ).

tff(pred_def_33462,type,
    v61498: state_type > $o ).

tff(pred_def_33463,type,
    v61496: state_type > $o ).

tff(pred_def_33464,type,
    v61494: state_type > $o ).

tff(pred_def_33465,type,
    v61492: state_type > $o ).

tff(pred_def_33466,type,
    v61490: state_type > $o ).

tff(pred_def_33467,type,
    v61596: state_type > $o ).

tff(pred_def_33468,type,
    v61594: state_type > $o ).

tff(pred_def_33469,type,
    v61600: state_type > $o ).

tff(pred_def_33470,type,
    v61598: state_type > $o ).

tff(pred_def_33471,type,
    v61604: state_type > $o ).

tff(pred_def_33472,type,
    v61602: state_type > $o ).

tff(pred_def_33473,type,
    v61606: state_type > $o ).

tff(pred_def_33474,type,
    v61592: state_type > $o ).

tff(pred_def_33475,type,
    v61590: state_type > $o ).

tff(pred_def_33476,type,
    v61588: state_type > $o ).

tff(pred_def_33477,type,
    v61586: state_type > $o ).

tff(pred_def_33478,type,
    v61584: state_type > $o ).

tff(pred_def_33479,type,
    v61620: state_type > $o ).

tff(pred_def_33480,type,
    v61618: state_type > $o ).

tff(pred_def_33481,type,
    v61624: state_type > $o ).

tff(pred_def_33482,type,
    v61622: state_type > $o ).

tff(pred_def_33483,type,
    v61628: state_type > $o ).

tff(pred_def_33484,type,
    v61626: state_type > $o ).

tff(pred_def_33485,type,
    v61630: state_type > $o ).

tff(pred_def_33486,type,
    v61616: state_type > $o ).

tff(pred_def_33487,type,
    v61614: state_type > $o ).

tff(pred_def_33488,type,
    v61612: state_type > $o ).

tff(pred_def_33489,type,
    v61610: state_type > $o ).

tff(pred_def_33490,type,
    v61608: state_type > $o ).

tff(pred_def_33491,type,
    v61644: state_type > $o ).

tff(pred_def_33492,type,
    v61642: state_type > $o ).

tff(pred_def_33493,type,
    v61648: state_type > $o ).

tff(pred_def_33494,type,
    v61646: state_type > $o ).

tff(pred_def_33495,type,
    v61652: state_type > $o ).

tff(pred_def_33496,type,
    v61650: state_type > $o ).

tff(pred_def_33497,type,
    v61654: state_type > $o ).

tff(pred_def_33498,type,
    v61640: state_type > $o ).

tff(pred_def_33499,type,
    v61638: state_type > $o ).

tff(pred_def_33500,type,
    v61636: state_type > $o ).

tff(pred_def_33501,type,
    v61634: state_type > $o ).

tff(pred_def_33502,type,
    v61632: state_type > $o ).

tff(pred_def_33503,type,
    v61656: state_type > $o ).

tff(pred_def_33504,type,
    v61582: state_type > $o ).

tff(pred_def_33505,type,
    v61580: state_type > $o ).

tff(pred_def_33506,type,
    v61578: state_type > $o ).

tff(pred_def_33507,type,
    v61576: state_type > $o ).

tff(pred_def_33508,type,
    v61574: state_type > $o ).

tff(pred_def_33509,type,
    v61658: state_type > $o ).

tff(pred_def_33510,type,
    v61404: state_type > $o ).

tff(pred_def_33511,type,
    v61402: state_type > $o ).

tff(pred_def_33512,type,
    v61400: state_type > $o ).

tff(pred_def_33513,type,
    v61398: state_type > $o ).

tff(pred_def_33514,type,
    v61396: state_type > $o ).

tff(pred_def_33515,type,
    v61692: state_type > $o ).

tff(pred_def_33516,type,
    v61690: state_type > $o ).

tff(pred_def_33517,type,
    v61696: state_type > $o ).

tff(pred_def_33518,type,
    v61694: state_type > $o ).

tff(pred_def_33519,type,
    v61700: state_type > $o ).

tff(pred_def_33520,type,
    v61698: state_type > $o ).

tff(pred_def_33521,type,
    v61702: state_type > $o ).

tff(pred_def_33522,type,
    v61688: state_type > $o ).

tff(pred_def_33523,type,
    v61686: state_type > $o ).

tff(pred_def_33524,type,
    v61684: state_type > $o ).

tff(pred_def_33525,type,
    v61682: state_type > $o ).

tff(pred_def_33526,type,
    v61680: state_type > $o ).

tff(pred_def_33527,type,
    v61716: state_type > $o ).

tff(pred_def_33528,type,
    v61714: state_type > $o ).

tff(pred_def_33529,type,
    v61720: state_type > $o ).

tff(pred_def_33530,type,
    v61718: state_type > $o ).

tff(pred_def_33531,type,
    v61724: state_type > $o ).

tff(pred_def_33532,type,
    v61722: state_type > $o ).

tff(pred_def_33533,type,
    v61726: state_type > $o ).

tff(pred_def_33534,type,
    v61712: state_type > $o ).

tff(pred_def_33535,type,
    v61710: state_type > $o ).

tff(pred_def_33536,type,
    v61708: state_type > $o ).

tff(pred_def_33537,type,
    v61706: state_type > $o ).

tff(pred_def_33538,type,
    v61704: state_type > $o ).

tff(pred_def_33539,type,
    v61740: state_type > $o ).

tff(pred_def_33540,type,
    v61738: state_type > $o ).

tff(pred_def_33541,type,
    v61744: state_type > $o ).

tff(pred_def_33542,type,
    v61742: state_type > $o ).

tff(pred_def_33543,type,
    v61748: state_type > $o ).

tff(pred_def_33544,type,
    v61746: state_type > $o ).

tff(pred_def_33545,type,
    v61750: state_type > $o ).

tff(pred_def_33546,type,
    v61736: state_type > $o ).

tff(pred_def_33547,type,
    v61734: state_type > $o ).

tff(pred_def_33548,type,
    v61732: state_type > $o ).

tff(pred_def_33549,type,
    v61730: state_type > $o ).

tff(pred_def_33550,type,
    v61728: state_type > $o ).

tff(pred_def_33551,type,
    v61752: state_type > $o ).

tff(pred_def_33552,type,
    v61678: state_type > $o ).

tff(pred_def_33553,type,
    v61676: state_type > $o ).

tff(pred_def_33554,type,
    v61674: state_type > $o ).

tff(pred_def_33555,type,
    v61672: state_type > $o ).

tff(pred_def_33556,type,
    v61670: state_type > $o ).

tff(pred_def_33557,type,
    v61776: state_type > $o ).

tff(pred_def_33558,type,
    v61774: state_type > $o ).

tff(pred_def_33559,type,
    v61780: state_type > $o ).

tff(pred_def_33560,type,
    v61778: state_type > $o ).

tff(pred_def_33561,type,
    v61784: state_type > $o ).

tff(pred_def_33562,type,
    v61782: state_type > $o ).

tff(pred_def_33563,type,
    v61786: state_type > $o ).

tff(pred_def_33564,type,
    v61772: state_type > $o ).

tff(pred_def_33565,type,
    v61770: state_type > $o ).

tff(pred_def_33566,type,
    v61768: state_type > $o ).

tff(pred_def_33567,type,
    v61766: state_type > $o ).

tff(pred_def_33568,type,
    v61764: state_type > $o ).

tff(pred_def_33569,type,
    v61800: state_type > $o ).

tff(pred_def_33570,type,
    v61798: state_type > $o ).

tff(pred_def_33571,type,
    v61804: state_type > $o ).

tff(pred_def_33572,type,
    v61802: state_type > $o ).

tff(pred_def_33573,type,
    v61808: state_type > $o ).

tff(pred_def_33574,type,
    v61806: state_type > $o ).

tff(pred_def_33575,type,
    v61810: state_type > $o ).

tff(pred_def_33576,type,
    v61796: state_type > $o ).

tff(pred_def_33577,type,
    v61794: state_type > $o ).

tff(pred_def_33578,type,
    v61792: state_type > $o ).

tff(pred_def_33579,type,
    v61790: state_type > $o ).

tff(pred_def_33580,type,
    v61788: state_type > $o ).

tff(pred_def_33581,type,
    v61824: state_type > $o ).

tff(pred_def_33582,type,
    v61822: state_type > $o ).

tff(pred_def_33583,type,
    v61828: state_type > $o ).

tff(pred_def_33584,type,
    v61826: state_type > $o ).

tff(pred_def_33585,type,
    v61832: state_type > $o ).

tff(pred_def_33586,type,
    v61830: state_type > $o ).

tff(pred_def_33587,type,
    v61834: state_type > $o ).

tff(pred_def_33588,type,
    v61820: state_type > $o ).

tff(pred_def_33589,type,
    v61818: state_type > $o ).

tff(pred_def_33590,type,
    v61816: state_type > $o ).

tff(pred_def_33591,type,
    v61814: state_type > $o ).

tff(pred_def_33592,type,
    v61812: state_type > $o ).

tff(pred_def_33593,type,
    v61836: state_type > $o ).

tff(pred_def_33594,type,
    v61762: state_type > $o ).

tff(pred_def_33595,type,
    v61760: state_type > $o ).

tff(pred_def_33596,type,
    v61758: state_type > $o ).

tff(pred_def_33597,type,
    v61756: state_type > $o ).

tff(pred_def_33598,type,
    v61754: state_type > $o ).

tff(pred_def_33599,type,
    v61860: state_type > $o ).

tff(pred_def_33600,type,
    v61858: state_type > $o ).

tff(pred_def_33601,type,
    v61864: state_type > $o ).

tff(pred_def_33602,type,
    v61862: state_type > $o ).

tff(pred_def_33603,type,
    v61868: state_type > $o ).

tff(pred_def_33604,type,
    v61866: state_type > $o ).

tff(pred_def_33605,type,
    v61870: state_type > $o ).

tff(pred_def_33606,type,
    v61856: state_type > $o ).

tff(pred_def_33607,type,
    v61854: state_type > $o ).

tff(pred_def_33608,type,
    v61852: state_type > $o ).

tff(pred_def_33609,type,
    v61850: state_type > $o ).

tff(pred_def_33610,type,
    v61848: state_type > $o ).

tff(pred_def_33611,type,
    v61884: state_type > $o ).

tff(pred_def_33612,type,
    v61882: state_type > $o ).

tff(pred_def_33613,type,
    v61888: state_type > $o ).

tff(pred_def_33614,type,
    v61886: state_type > $o ).

tff(pred_def_33615,type,
    v61892: state_type > $o ).

tff(pred_def_33616,type,
    v61890: state_type > $o ).

tff(pred_def_33617,type,
    v61894: state_type > $o ).

tff(pred_def_33618,type,
    v61880: state_type > $o ).

tff(pred_def_33619,type,
    v61878: state_type > $o ).

tff(pred_def_33620,type,
    v61876: state_type > $o ).

tff(pred_def_33621,type,
    v61874: state_type > $o ).

tff(pred_def_33622,type,
    v61872: state_type > $o ).

tff(pred_def_33623,type,
    v61908: state_type > $o ).

tff(pred_def_33624,type,
    v61906: state_type > $o ).

tff(pred_def_33625,type,
    v61912: state_type > $o ).

tff(pred_def_33626,type,
    v61910: state_type > $o ).

tff(pred_def_33627,type,
    v61916: state_type > $o ).

tff(pred_def_33628,type,
    v61914: state_type > $o ).

tff(pred_def_33629,type,
    v61918: state_type > $o ).

tff(pred_def_33630,type,
    v61904: state_type > $o ).

tff(pred_def_33631,type,
    v61902: state_type > $o ).

tff(pred_def_33632,type,
    v61900: state_type > $o ).

tff(pred_def_33633,type,
    v61898: state_type > $o ).

tff(pred_def_33634,type,
    v61896: state_type > $o ).

tff(pred_def_33635,type,
    v61920: state_type > $o ).

tff(pred_def_33636,type,
    v61846: state_type > $o ).

tff(pred_def_33637,type,
    v61844: state_type > $o ).

tff(pred_def_33638,type,
    v61842: state_type > $o ).

tff(pred_def_33639,type,
    v61840: state_type > $o ).

tff(pred_def_33640,type,
    v61838: state_type > $o ).

tff(pred_def_33641,type,
    v61922: state_type > $o ).

tff(pred_def_33642,type,
    v61668: state_type > $o ).

tff(pred_def_33643,type,
    v61666: state_type > $o ).

tff(pred_def_33644,type,
    v61664: state_type > $o ).

tff(pred_def_33645,type,
    v61662: state_type > $o ).

tff(pred_def_33646,type,
    v61660: state_type > $o ).

tff(pred_def_33647,type,
    v61946: state_type > $o ).

tff(pred_def_33648,type,
    v61944: state_type > $o ).

tff(pred_def_33649,type,
    v61950: state_type > $o ).

tff(pred_def_33650,type,
    v61948: state_type > $o ).

tff(pred_def_33651,type,
    v61954: state_type > $o ).

tff(pred_def_33652,type,
    v61952: state_type > $o ).

tff(pred_def_33653,type,
    v61956: state_type > $o ).

tff(pred_def_33654,type,
    v61942: state_type > $o ).

tff(pred_def_33655,type,
    v61940: state_type > $o ).

tff(pred_def_33656,type,
    v61938: state_type > $o ).

tff(pred_def_33657,type,
    v61936: state_type > $o ).

tff(pred_def_33658,type,
    v61934: state_type > $o ).

tff(pred_def_33659,type,
    v61980: state_type > $o ).

tff(pred_def_33660,type,
    v61978: state_type > $o ).

tff(pred_def_33661,type,
    v61984: state_type > $o ).

tff(pred_def_33662,type,
    v61982: state_type > $o ).

tff(pred_def_33663,type,
    v61988: state_type > $o ).

tff(pred_def_33664,type,
    v61986: state_type > $o ).

tff(pred_def_33665,type,
    v61990: state_type > $o ).

tff(pred_def_33666,type,
    v61976: state_type > $o ).

tff(pred_def_33667,type,
    v61974: state_type > $o ).

tff(pred_def_33668,type,
    v61972: state_type > $o ).

tff(pred_def_33669,type,
    v61970: state_type > $o ).

tff(pred_def_33670,type,
    v61968: state_type > $o ).

tff(pred_def_33671,type,
    v62004: state_type > $o ).

tff(pred_def_33672,type,
    v62002: state_type > $o ).

tff(pred_def_33673,type,
    v62008: state_type > $o ).

tff(pred_def_33674,type,
    v62006: state_type > $o ).

tff(pred_def_33675,type,
    v62012: state_type > $o ).

tff(pred_def_33676,type,
    v62010: state_type > $o ).

tff(pred_def_33677,type,
    v62014: state_type > $o ).

tff(pred_def_33678,type,
    v62000: state_type > $o ).

tff(pred_def_33679,type,
    v61998: state_type > $o ).

tff(pred_def_33680,type,
    v61996: state_type > $o ).

tff(pred_def_33681,type,
    v61994: state_type > $o ).

tff(pred_def_33682,type,
    v61992: state_type > $o ).

tff(pred_def_33683,type,
    v62028: state_type > $o ).

tff(pred_def_33684,type,
    v62026: state_type > $o ).

tff(pred_def_33685,type,
    v62032: state_type > $o ).

tff(pred_def_33686,type,
    v62030: state_type > $o ).

tff(pred_def_33687,type,
    v62036: state_type > $o ).

tff(pred_def_33688,type,
    v62034: state_type > $o ).

tff(pred_def_33689,type,
    v62038: state_type > $o ).

tff(pred_def_33690,type,
    v62024: state_type > $o ).

tff(pred_def_33691,type,
    v62022: state_type > $o ).

tff(pred_def_33692,type,
    v62020: state_type > $o ).

tff(pred_def_33693,type,
    v62018: state_type > $o ).

tff(pred_def_33694,type,
    v62016: state_type > $o ).

tff(pred_def_33695,type,
    v62040: state_type > $o ).

tff(pred_def_33696,type,
    v61966: state_type > $o ).

tff(pred_def_33697,type,
    v61964: state_type > $o ).

tff(pred_def_33698,type,
    v61962: state_type > $o ).

tff(pred_def_33699,type,
    v61960: state_type > $o ).

tff(pred_def_33700,type,
    v61958: state_type > $o ).

tff(pred_def_33701,type,
    v62050: state_type > $o ).

tff(pred_def_33702,type,
    v62048: state_type > $o ).

tff(pred_def_33703,type,
    v62047: state_type > $o ).

tff(pred_def_33704,type,
    v62046: ( state_type * $int ) > $o ).

tff(pred_def_33705,type,
    v62044: state_type > $o ).

tff(pred_def_33706,type,
    v62042: state_type > $o ).

tff(pred_def_33707,type,
    v62054: state_type > $o ).

tff(pred_def_33708,type,
    v61932: state_type > $o ).

tff(pred_def_33709,type,
    v61930: state_type > $o ).

tff(pred_def_33710,type,
    v61928: state_type > $o ).

tff(pred_def_33711,type,
    v61926: state_type > $o ).

tff(pred_def_33712,type,
    v61924: state_type > $o ).

tff(pred_def_33713,type,
    v62056: state_type > $o ).

tff(pred_def_33714,type,
    v61394: state_type > $o ).

tff(pred_def_33715,type,
    v61392: state_type > $o ).

tff(pred_def_33716,type,
    v61390: state_type > $o ).

tff(pred_def_33717,type,
    v61388: state_type > $o ).

tff(pred_def_33718,type,
    v62058: state_type > $o ).

tff(pred_def_33719,type,
    v60716: state_type > $o ).

tff(pred_def_33720,type,
    v60714: state_type > $o ).

tff(pred_def_33721,type,
    v60712: state_type > $o ).

tff(pred_def_33722,type,
    v60710: state_type > $o ).

tff(pred_def_33723,type,
    v60708: state_type > $o ).

tff(pred_def_33724,type,
    v62060: state_type > $o ).

tff(pred_def_33725,type,
    v5899: state_type > $o ).

tff(pred_def_33726,type,
    v5897: state_type > $o ).

tff(pred_def_33727,type,
    v5895: state_type > $o ).

tff(pred_def_33728,type,
    v5893: state_type > $o ).

tff(pred_def_33729,type,
    v5891: state_type > $o ).

tff(pred_def_33730,type,
    v5889: state_type > $o ).

tff(pred_def_33731,type,
    v5887: state_type > $o ).

tff(pred_def_33732,type,
    v5885: state_type > $o ).

tff(pred_def_33733,type,
    v5883: state_type > $o ).

tff(pred_def_33734,type,
    v5881: state_type > $o ).

tff(pred_def_33735,type,
    v62155: state_type > $o ).

tff(pred_def_33736,type,
    v62153: state_type > $o ).

tff(pred_def_33737,type,
    v62159: state_type > $o ).

tff(pred_def_33738,type,
    v62157: state_type > $o ).

tff(pred_def_33739,type,
    v62161: state_type > $o ).

tff(pred_def_33740,type,
    v62151: state_type > $o ).

tff(pred_def_33741,type,
    v62149: state_type > $o ).

tff(pred_def_33742,type,
    v62147: state_type > $o ).

tff(pred_def_33743,type,
    v62145: state_type > $o ).

tff(pred_def_33744,type,
    v62143: state_type > $o ).

tff(pred_def_33745,type,
    v62175: state_type > $o ).

tff(pred_def_33746,type,
    v62173: state_type > $o ).

tff(pred_def_33747,type,
    v62179: state_type > $o ).

tff(pred_def_33748,type,
    v62177: state_type > $o ).

tff(pred_def_33749,type,
    v62181: state_type > $o ).

tff(pred_def_33750,type,
    v62171: state_type > $o ).

tff(pred_def_33751,type,
    v62169: state_type > $o ).

tff(pred_def_33752,type,
    v62167: state_type > $o ).

tff(pred_def_33753,type,
    v62165: state_type > $o ).

tff(pred_def_33754,type,
    v62163: state_type > $o ).

tff(pred_def_33755,type,
    v62183: state_type > $o ).

tff(pred_def_33756,type,
    v62141: state_type > $o ).

tff(pred_def_33757,type,
    v62139: state_type > $o ).

tff(pred_def_33758,type,
    v62137: state_type > $o ).

tff(pred_def_33759,type,
    v62135: state_type > $o ).

tff(pred_def_33760,type,
    v62133: state_type > $o ).

tff(pred_def_33761,type,
    v62131: state_type > $o ).

tff(pred_def_33762,type,
    v62129: state_type > $o ).

tff(pred_def_33763,type,
    v62127: state_type > $o ).

tff(pred_def_33764,type,
    v62125: state_type > $o ).

tff(pred_def_33765,type,
    v62123: state_type > $o ).

tff(pred_def_33766,type,
    v62188: state_type > $o ).

tff(pred_def_33767,type,
    v62186: state_type > $o ).

tff(pred_def_33768,type,
    v62190: state_type > $o ).

tff(pred_def_33769,type,
    v62121: state_type > $o ).

tff(pred_def_33770,type,
    v62119: state_type > $o ).

tff(pred_def_33771,type,
    v62117: state_type > $o ).

tff(pred_def_33772,type,
    v62115: state_type > $o ).

tff(pred_def_33773,type,
    v62113: state_type > $o ).

tff(pred_def_33774,type,
    v62194: state_type > $o ).

tff(pred_def_33775,type,
    v62192: state_type > $o ).

tff(pred_def_33776,type,
    v62111: state_type > $o ).

tff(pred_def_33777,type,
    v62109: state_type > $o ).

tff(pred_def_33778,type,
    v62107: state_type > $o ).

tff(pred_def_33779,type,
    v62197: state_type > $o ).

tff(pred_def_33780,type,
    v62196: ( state_type * $int ) > $o ).

tff(pred_def_33781,type,
    v62105: ( state_type * $int ) > $o ).

tff(pred_def_33782,type,
    v62103: ( state_type * $int ) > $o ).

tff(pred_def_33783,type,
    v62201: ( state_type * $int ) > $o ).

tff(pred_def_33784,type,
    v62199: ( state_type * $int ) > $o ).

tff(pred_def_33785,type,
    v62202: ( state_type * $int ) > $o ).

tff(pred_def_33786,type,
    v62101: ( state_type * $int ) > $o ).

tff(pred_def_33787,type,
    v62099: ( state_type * $int ) > $o ).

tff(pred_def_33788,type,
    v62097: ( state_type * $int ) > $o ).

tff(pred_def_33789,type,
    v62095: state_type > $o ).

tff(pred_def_33790,type,
    v62093: state_type > $o ).

tff(pred_def_33791,type,
    v62206: state_type > $o ).

tff(pred_def_33792,type,
    v62204: state_type > $o ).

tff(pred_def_33793,type,
    v62208: state_type > $o ).

tff(pred_def_33794,type,
    v62091: state_type > $o ).

tff(pred_def_33795,type,
    v62089: state_type > $o ).

tff(pred_def_33796,type,
    v62087: state_type > $o ).

tff(pred_def_33797,type,
    v62085: state_type > $o ).

tff(pred_def_33798,type,
    v62083: state_type > $o ).

tff(pred_def_33799,type,
    v62222: state_type > $o ).

tff(pred_def_33800,type,
    v62220: state_type > $o ).

tff(pred_def_33801,type,
    v62226: state_type > $o ).

tff(pred_def_33802,type,
    v62224: state_type > $o ).

tff(pred_def_33803,type,
    v62228: state_type > $o ).

tff(pred_def_33804,type,
    v62218: state_type > $o ).

tff(pred_def_33805,type,
    v62216: state_type > $o ).

tff(pred_def_33806,type,
    v62214: state_type > $o ).

tff(pred_def_33807,type,
    v62212: state_type > $o ).

tff(pred_def_33808,type,
    v62210: state_type > $o ).

tff(pred_def_33809,type,
    v62230: state_type > $o ).

tff(pred_def_33810,type,
    v62081: state_type > $o ).

tff(pred_def_33811,type,
    v62079: state_type > $o ).

tff(pred_def_33812,type,
    v62077: state_type > $o ).

tff(pred_def_33813,type,
    v62075: state_type > $o ).

tff(pred_def_33814,type,
    v62073: state_type > $o ).

tff(pred_def_33815,type,
    v62071: state_type > $o ).

tff(pred_def_33816,type,
    v62069: state_type > $o ).

tff(pred_def_33817,type,
    v62067: state_type > $o ).

tff(pred_def_33818,type,
    v62065: state_type > $o ).

tff(pred_def_33819,type,
    v62063: state_type > $o ).

tff(pred_def_33820,type,
    v62285: state_type > $o ).

tff(pred_def_33821,type,
    v62283: state_type > $o ).

tff(pred_def_33822,type,
    v62289: state_type > $o ).

tff(pred_def_33823,type,
    v62287: state_type > $o ).

tff(pred_def_33824,type,
    v62291: state_type > $o ).

tff(pred_def_33825,type,
    v62281: state_type > $o ).

tff(pred_def_33826,type,
    v62279: state_type > $o ).

tff(pred_def_33827,type,
    v62277: state_type > $o ).

tff(pred_def_33828,type,
    v62275: state_type > $o ).

tff(pred_def_33829,type,
    v62273: state_type > $o ).

tff(pred_def_33830,type,
    v62295: state_type > $o ).

tff(pred_def_33831,type,
    v62293: state_type > $o ).

tff(pred_def_33832,type,
    v62271: state_type > $o ).

tff(pred_def_33833,type,
    v62269: state_type > $o ).

tff(pred_def_33834,type,
    v62267: state_type > $o ).

tff(pred_def_33835,type,
    v62298: state_type > $o ).

tff(pred_def_33836,type,
    v62297: ( state_type * $int ) > $o ).

tff(pred_def_33837,type,
    v62265: ( state_type * $int ) > $o ).

tff(pred_def_33838,type,
    v62263: ( state_type * $int ) > $o ).

tff(pred_def_33839,type,
    v62302: ( state_type * $int ) > $o ).

tff(pred_def_33840,type,
    v62300: ( state_type * $int ) > $o ).

tff(pred_def_33841,type,
    v62303: ( state_type * $int ) > $o ).

tff(pred_def_33842,type,
    v62261: ( state_type * $int ) > $o ).

tff(pred_def_33843,type,
    v62259: ( state_type * $int ) > $o ).

tff(pred_def_33844,type,
    v62257: ( state_type * $int ) > $o ).

tff(pred_def_33845,type,
    v62255: state_type > $o ).

tff(pred_def_33846,type,
    v62253: state_type > $o ).

tff(pred_def_33847,type,
    v62307: state_type > $o ).

tff(pred_def_33848,type,
    v62305: state_type > $o ).

tff(pred_def_33849,type,
    v62309: state_type > $o ).

tff(pred_def_33850,type,
    v62251: state_type > $o ).

tff(pred_def_33851,type,
    v62249: state_type > $o ).

tff(pred_def_33852,type,
    v62247: state_type > $o ).

tff(pred_def_33853,type,
    v62245: state_type > $o ).

tff(pred_def_33854,type,
    v62243: state_type > $o ).

tff(pred_def_33855,type,
    v62323: state_type > $o ).

tff(pred_def_33856,type,
    v62321: state_type > $o ).

tff(pred_def_33857,type,
    v62327: state_type > $o ).

tff(pred_def_33858,type,
    v62325: state_type > $o ).

tff(pred_def_33859,type,
    v62329: state_type > $o ).

tff(pred_def_33860,type,
    v62319: state_type > $o ).

tff(pred_def_33861,type,
    v62317: state_type > $o ).

tff(pred_def_33862,type,
    v62315: state_type > $o ).

tff(pred_def_33863,type,
    v62313: state_type > $o ).

tff(pred_def_33864,type,
    v62311: state_type > $o ).

tff(pred_def_33865,type,
    v62331: state_type > $o ).

tff(pred_def_33866,type,
    v62241: state_type > $o ).

tff(pred_def_33867,type,
    v62239: state_type > $o ).

tff(pred_def_33868,type,
    v62237: state_type > $o ).

tff(pred_def_33869,type,
    v62235: state_type > $o ).

tff(pred_def_33870,type,
    v62233: state_type > $o ).

tff(pred_def_33871,type,
    v62375: state_type > $o ).

tff(pred_def_33872,type,
    v62373: state_type > $o ).

tff(pred_def_33873,type,
    v62379: state_type > $o ).

tff(pred_def_33874,type,
    v62377: state_type > $o ).

tff(pred_def_33875,type,
    v62383: state_type > $o ).

tff(pred_def_33876,type,
    v62381: state_type > $o ).

tff(pred_def_33877,type,
    v62386: state_type > $o ).

tff(pred_def_33878,type,
    v62385: state_type > $o ).

tff(pred_def_33879,type,
    v62371: state_type > $o ).

tff(pred_def_33880,type,
    v62369: state_type > $o ).

tff(pred_def_33881,type,
    v62367: state_type > $o ).

tff(pred_def_33882,type,
    v62388: state_type > $o ).

tff(pred_def_33883,type,
    v62387: ( state_type * $int ) > $o ).

tff(pred_def_33884,type,
    v62365: ( state_type * $int ) > $o ).

tff(pred_def_33885,type,
    v62363: ( state_type * $int ) > $o ).

tff(pred_def_33886,type,
    v62392: ( state_type * $int ) > $o ).

tff(pred_def_33887,type,
    v62390: ( state_type * $int ) > $o ).

tff(pred_def_33888,type,
    v62393: ( state_type * $int ) > $o ).

tff(pred_def_33889,type,
    v62361: ( state_type * $int ) > $o ).

tff(pred_def_33890,type,
    v62359: ( state_type * $int ) > $o ).

tff(pred_def_33891,type,
    v62357: ( state_type * $int ) > $o ).

tff(pred_def_33892,type,
    v62355: state_type > $o ).

tff(pred_def_33893,type,
    v62353: state_type > $o ).

tff(pred_def_33894,type,
    v62397: state_type > $o ).

tff(pred_def_33895,type,
    v62395: state_type > $o ).

tff(pred_def_33896,type,
    v62399: state_type > $o ).

tff(pred_def_33897,type,
    v62351: state_type > $o ).

tff(pred_def_33898,type,
    v62349: state_type > $o ).

tff(pred_def_33899,type,
    v62347: state_type > $o ).

tff(pred_def_33900,type,
    v62345: state_type > $o ).

tff(pred_def_33901,type,
    v62343: state_type > $o ).

tff(pred_def_33902,type,
    v62413: state_type > $o ).

tff(pred_def_33903,type,
    v62411: state_type > $o ).

tff(pred_def_33904,type,
    v62417: state_type > $o ).

tff(pred_def_33905,type,
    v62415: state_type > $o ).

tff(pred_def_33906,type,
    v62419: state_type > $o ).

tff(pred_def_33907,type,
    v62409: state_type > $o ).

tff(pred_def_33908,type,
    v62407: state_type > $o ).

tff(pred_def_33909,type,
    v62405: state_type > $o ).

tff(pred_def_33910,type,
    v62403: state_type > $o ).

tff(pred_def_33911,type,
    v62401: state_type > $o ).

tff(pred_def_33912,type,
    v62421: state_type > $o ).

tff(pred_def_33913,type,
    v62341: state_type > $o ).

tff(pred_def_33914,type,
    v62339: state_type > $o ).

tff(pred_def_33915,type,
    v62337: state_type > $o ).

tff(pred_def_33916,type,
    v62335: state_type > $o ).

tff(pred_def_33917,type,
    v62333: state_type > $o ).

tff(pred_def_33918,type,
    v62425: state_type > $o ).

tff(pred_def_33919,type,
    v62424: state_type > $o ).

tff(pred_def_33920,type,
    v62423: state_type > $o ).

tff(pred_def_33921,type,
    v5879: state_type > $o ).

tff(pred_def_33922,type,
    v5877: state_type > $o ).

tff(pred_def_33923,type,
    v5875: ( state_type * $int ) > $o ).

tff(pred_def_33924,type,
    v5873: state_type > $o ).

tff(pred_def_33925,type,
    v5871: state_type > $o ).

tff(pred_def_33926,type,
    v62429: state_type > $o ).

tff(pred_def_33927,type,
    v62427: state_type > $o ).

tff(pred_def_33928,type,
    v62431: state_type > $o ).

tff(pred_def_33929,type,
    v5869: state_type > $o ).

tff(pred_def_33930,type,
    v5867: state_type > $o ).

tff(pred_def_33931,type,
    v5865: ( state_type * $int ) > $o ).

tff(pred_def_33932,type,
    v5863: state_type > $o ).

tff(pred_def_33933,type,
    v5861: state_type > $o ).

tff(pred_def_33934,type,
    v62451: state_type > $o ).

tff(pred_def_33935,type,
    v62449: state_type > $o ).

tff(pred_def_33936,type,
    v62455: state_type > $o ).

tff(pred_def_33937,type,
    v62453: state_type > $o ).

tff(pred_def_33938,type,
    v62469: state_type > $o ).

tff(pred_def_33939,type,
    v62467: state_type > $o ).

tff(pred_def_33940,type,
    v62465: state_type > $o ).

tff(pred_def_33941,type,
    v62463: state_type > $o ).

tff(pred_def_33942,type,
    v62461: state_type > $o ).

tff(pred_def_33943,type,
    v62459: state_type > $o ).

tff(pred_def_33944,type,
    v62457: state_type > $o ).

tff(pred_def_33945,type,
    v62484: state_type > $o ).

tff(pred_def_33946,type,
    v62482: state_type > $o ).

tff(pred_def_33947,type,
    v62480: state_type > $o ).

tff(pred_def_33948,type,
    v62478: state_type > $o ).

tff(pred_def_33949,type,
    v62476: state_type > $o ).

tff(pred_def_33950,type,
    v62474: state_type > $o ).

tff(pred_def_33951,type,
    v62472: state_type > $o ).

tff(pred_def_33952,type,
    v62489: state_type > $o ).

tff(pred_def_33953,type,
    v62488: state_type > $o ).

tff(pred_def_33954,type,
    v62487: state_type > $o ).

tff(pred_def_33955,type,
    v62447: state_type > $o ).

tff(pred_def_33956,type,
    v62445: state_type > $o ).

tff(pred_def_33957,type,
    v62443: state_type > $o ).

tff(pred_def_33958,type,
    v62441: state_type > $o ).

tff(pred_def_33959,type,
    v62493: state_type > $o ).

tff(pred_def_33960,type,
    v62491: state_type > $o ).

tff(pred_def_33961,type,
    v62495: state_type > $o ).

tff(pred_def_33962,type,
    v62439: state_type > $o ).

tff(pred_def_33963,type,
    v62437: state_type > $o ).

tff(pred_def_33964,type,
    v62435: state_type > $o ).

tff(pred_def_33965,type,
    v62433: state_type > $o ).

tff(pred_def_33966,type,
    v62515: state_type > $o ).

tff(pred_def_33967,type,
    v62513: state_type > $o ).

tff(pred_def_33968,type,
    v62519: state_type > $o ).

tff(pred_def_33969,type,
    v62517: state_type > $o ).

tff(pred_def_33970,type,
    v62523: state_type > $o ).

tff(pred_def_33971,type,
    v62521: state_type > $o ).

tff(pred_def_33972,type,
    v62527: state_type > $o ).

tff(pred_def_33973,type,
    v62525: state_type > $o ).

tff(pred_def_33974,type,
    v62531: state_type > $o ).

tff(pred_def_33975,type,
    v62530: state_type > $o ).

tff(pred_def_33976,type,
    v62529: state_type > $o ).

tff(pred_def_33977,type,
    v62511: state_type > $o ).

tff(pred_def_33978,type,
    v62509: state_type > $o ).

tff(pred_def_33979,type,
    v62507: state_type > $o ).

tff(pred_def_33980,type,
    v62505: state_type > $o ).

tff(pred_def_33981,type,
    v62535: state_type > $o ).

tff(pred_def_33982,type,
    v62533: state_type > $o ).

tff(pred_def_33983,type,
    v62537: state_type > $o ).

tff(pred_def_33984,type,
    v62503: state_type > $o ).

tff(pred_def_33985,type,
    v62501: state_type > $o ).

tff(pred_def_33986,type,
    v62499: state_type > $o ).

tff(pred_def_33987,type,
    v62497: state_type > $o ).

tff(pred_def_33988,type,
    v62540: state_type > $o ).

tff(pred_def_33989,type,
    v62539: state_type > $o ).

tff(pred_def_33990,type,
    v5859: state_type > $o ).

tff(pred_def_33991,type,
    v5857: state_type > $o ).

tff(pred_def_33992,type,
    v5855: state_type > $o ).

tff(pred_def_33993,type,
    v5853: state_type > $o ).

tff(pred_def_33994,type,
    v5851: state_type > $o ).

tff(pred_def_33995,type,
    v62570: state_type > $o ).

tff(pred_def_33996,type,
    v62568: state_type > $o ).

tff(pred_def_33997,type,
    v62574: state_type > $o ).

tff(pred_def_33998,type,
    v62572: state_type > $o ).

tff(pred_def_33999,type,
    v62578: state_type > $o ).

tff(pred_def_34000,type,
    v62576: state_type > $o ).

tff(pred_def_34001,type,
    v62582: state_type > $o ).

tff(pred_def_34002,type,
    v62580: state_type > $o ).

tff(pred_def_34003,type,
    v62586: state_type > $o ).

tff(pred_def_34004,type,
    v62585: state_type > $o ).

tff(pred_def_34005,type,
    v62584: state_type > $o ).

tff(pred_def_34006,type,
    v62566: state_type > $o ).

tff(pred_def_34007,type,
    v62564: state_type > $o ).

tff(pred_def_34008,type,
    v62562: state_type > $o ).

tff(pred_def_34009,type,
    v62560: state_type > $o ).

tff(pred_def_34010,type,
    v62590: state_type > $o ).

tff(pred_def_34011,type,
    v62588: state_type > $o ).

tff(pred_def_34012,type,
    v62592: state_type > $o ).

tff(pred_def_34013,type,
    v62558: state_type > $o ).

tff(pred_def_34014,type,
    v62556: state_type > $o ).

tff(pred_def_34015,type,
    v62554: state_type > $o ).

tff(pred_def_34016,type,
    v62552: state_type > $o ).

tff(pred_def_34017,type,
    v62612: state_type > $o ).

tff(pred_def_34018,type,
    v62610: state_type > $o ).

tff(pred_def_34019,type,
    v62616: state_type > $o ).

tff(pred_def_34020,type,
    v62614: state_type > $o ).

tff(pred_def_34021,type,
    v62620: state_type > $o ).

tff(pred_def_34022,type,
    v62618: state_type > $o ).

tff(pred_def_34023,type,
    v62624: state_type > $o ).

tff(pred_def_34024,type,
    v62622: state_type > $o ).

tff(pred_def_34025,type,
    v62628: state_type > $o ).

tff(pred_def_34026,type,
    v62627: state_type > $o ).

tff(pred_def_34027,type,
    v62626: state_type > $o ).

tff(pred_def_34028,type,
    v62608: state_type > $o ).

tff(pred_def_34029,type,
    v62606: state_type > $o ).

tff(pred_def_34030,type,
    v62604: state_type > $o ).

tff(pred_def_34031,type,
    v62602: state_type > $o ).

tff(pred_def_34032,type,
    v62632: state_type > $o ).

tff(pred_def_34033,type,
    v62630: state_type > $o ).

tff(pred_def_34034,type,
    v62634: state_type > $o ).

tff(pred_def_34035,type,
    v62600: state_type > $o ).

tff(pred_def_34036,type,
    v62598: state_type > $o ).

tff(pred_def_34037,type,
    v62596: state_type > $o ).

tff(pred_def_34038,type,
    v62594: state_type > $o ).

tff(pred_def_34039,type,
    v62654: state_type > $o ).

tff(pred_def_34040,type,
    v62652: state_type > $o ).

tff(pred_def_34041,type,
    v62658: state_type > $o ).

tff(pred_def_34042,type,
    v62656: state_type > $o ).

tff(pred_def_34043,type,
    v62662: state_type > $o ).

tff(pred_def_34044,type,
    v62660: state_type > $o ).

tff(pred_def_34045,type,
    v62666: state_type > $o ).

tff(pred_def_34046,type,
    v62664: state_type > $o ).

tff(pred_def_34047,type,
    v62670: state_type > $o ).

tff(pred_def_34048,type,
    v62669: state_type > $o ).

tff(pred_def_34049,type,
    v62668: state_type > $o ).

tff(pred_def_34050,type,
    v62650: state_type > $o ).

tff(pred_def_34051,type,
    v62648: state_type > $o ).

tff(pred_def_34052,type,
    v62646: state_type > $o ).

tff(pred_def_34053,type,
    v62644: state_type > $o ).

tff(pred_def_34054,type,
    v62674: state_type > $o ).

tff(pred_def_34055,type,
    v62672: state_type > $o ).

tff(pred_def_34056,type,
    v62676: state_type > $o ).

tff(pred_def_34057,type,
    v62642: state_type > $o ).

tff(pred_def_34058,type,
    v62640: state_type > $o ).

tff(pred_def_34059,type,
    v62638: state_type > $o ).

tff(pred_def_34060,type,
    v62636: state_type > $o ).

tff(pred_def_34061,type,
    v62679: state_type > $o ).

tff(pred_def_34062,type,
    v62678: state_type > $o ).

tff(pred_def_34063,type,
    v62550: state_type > $o ).

tff(pred_def_34064,type,
    v62548: state_type > $o ).

tff(pred_def_34065,type,
    v62546: state_type > $o ).

tff(pred_def_34066,type,
    v62544: state_type > $o ).

tff(pred_def_34067,type,
    v62542: state_type > $o ).

tff(pred_def_34068,type,
    v62709: state_type > $o ).

tff(pred_def_34069,type,
    v62707: state_type > $o ).

tff(pred_def_34070,type,
    v62713: state_type > $o ).

tff(pred_def_34071,type,
    v62711: state_type > $o ).

tff(pred_def_34072,type,
    v62717: state_type > $o ).

tff(pred_def_34073,type,
    v62715: state_type > $o ).

tff(pred_def_34074,type,
    v62721: state_type > $o ).

tff(pred_def_34075,type,
    v62719: state_type > $o ).

tff(pred_def_34076,type,
    v62725: state_type > $o ).

tff(pred_def_34077,type,
    v62724: state_type > $o ).

tff(pred_def_34078,type,
    v62723: state_type > $o ).

tff(pred_def_34079,type,
    v62705: state_type > $o ).

tff(pred_def_34080,type,
    v62703: state_type > $o ).

tff(pred_def_34081,type,
    v62701: state_type > $o ).

tff(pred_def_34082,type,
    v62699: state_type > $o ).

tff(pred_def_34083,type,
    v62729: state_type > $o ).

tff(pred_def_34084,type,
    v62727: state_type > $o ).

tff(pred_def_34085,type,
    v62731: state_type > $o ).

tff(pred_def_34086,type,
    v62697: state_type > $o ).

tff(pred_def_34087,type,
    v62695: state_type > $o ).

tff(pred_def_34088,type,
    v62693: state_type > $o ).

tff(pred_def_34089,type,
    v62691: state_type > $o ).

tff(pred_def_34090,type,
    v62761: state_type > $o ).

tff(pred_def_34091,type,
    v62759: state_type > $o ).

tff(pred_def_34092,type,
    v62765: state_type > $o ).

tff(pred_def_34093,type,
    v62763: state_type > $o ).

tff(pred_def_34094,type,
    v62769: state_type > $o ).

tff(pred_def_34095,type,
    v62767: state_type > $o ).

tff(pred_def_34096,type,
    v62773: state_type > $o ).

tff(pred_def_34097,type,
    v62771: state_type > $o ).

tff(pred_def_34098,type,
    v62777: state_type > $o ).

tff(pred_def_34099,type,
    v62776: state_type > $o ).

tff(pred_def_34100,type,
    v62775: state_type > $o ).

tff(pred_def_34101,type,
    v62757: state_type > $o ).

tff(pred_def_34102,type,
    v62755: state_type > $o ).

tff(pred_def_34103,type,
    v62753: state_type > $o ).

tff(pred_def_34104,type,
    v62751: state_type > $o ).

tff(pred_def_34105,type,
    v62781: state_type > $o ).

tff(pred_def_34106,type,
    v62779: state_type > $o ).

tff(pred_def_34107,type,
    v62783: state_type > $o ).

tff(pred_def_34108,type,
    v62749: state_type > $o ).

tff(pred_def_34109,type,
    v62747: state_type > $o ).

tff(pred_def_34110,type,
    v62745: state_type > $o ).

tff(pred_def_34111,type,
    v62743: state_type > $o ).

tff(pred_def_34112,type,
    v62829: state_type > $o ).

tff(pred_def_34113,type,
    v62827: state_type > $o ).

tff(pred_def_34114,type,
    v62833: state_type > $o ).

tff(pred_def_34115,type,
    v62831: state_type > $o ).

tff(pred_def_34116,type,
    v62825: state_type > $o ).

tff(pred_def_34117,type,
    v62823: state_type > $o ).

tff(pred_def_34118,type,
    v62821: state_type > $o ).

tff(pred_def_34119,type,
    v62819: state_type > $o ).

tff(pred_def_34120,type,
    v62817: state_type > $o ).

tff(pred_def_34121,type,
    v62848: ( state_type * $int ) > $o ).

tff(pred_def_34122,type,
    v62846: ( state_type * $int ) > $o ).

tff(pred_def_34123,type,
    v62914: state_type > $o ).

tff(pred_def_34124,type,
    v62912: state_type > $o ).

tff(pred_def_34125,type,
    v62910: state_type > $o ).

tff(pred_def_34126,type,
    v62908: state_type > $o ).

tff(pred_def_34127,type,
    v62906: state_type > $o ).

tff(pred_def_34128,type,
    v62904: state_type > $o ).

tff(pred_def_34129,type,
    v62921: ( state_type * $int ) > $o ).

tff(pred_def_34130,type,
    v62919: ( state_type * $int ) > $o ).

tff(pred_def_34131,type,
    v62917: ( state_type * $int ) > $o ).

tff(pred_def_34132,type,
    v62927: ( state_type * $int ) > $o ).

tff(pred_def_34133,type,
    v62925: ( state_type * $int ) > $o ).

tff(pred_def_34134,type,
    v62923: ( state_type * $int ) > $o ).

tff(pred_def_34135,type,
    v62930: state_type > $o ).

tff(pred_def_34136,type,
    v62931: state_type > $o ).

tff(pred_def_34137,type,
    v62929: ( state_type * $int ) > $o ).

tff(pred_def_34138,type,
    v62902: ( state_type * $int ) > $o ).

tff(pred_def_34139,type,
    v62900: ( state_type * $int ) > $o ).

tff(pred_def_34140,type,
    v62898: ( state_type * $int ) > $o ).

tff(pred_def_34141,type,
    v62896: state_type > $o ).

tff(pred_def_34142,type,
    v62894: state_type > $o ).

tff(pred_def_34143,type,
    v62892: state_type > $o ).

tff(pred_def_34144,type,
    v62890: state_type > $o ).

tff(pred_def_34145,type,
    v62888: state_type > $o ).

tff(pred_def_34146,type,
    v62886: state_type > $o ).

tff(pred_def_34147,type,
    v62884: state_type > $o ).

tff(pred_def_34148,type,
    v62882: state_type > $o ).

tff(pred_def_34149,type,
    v62880: state_type > $o ).

tff(pred_def_34150,type,
    v62878: state_type > $o ).

tff(pred_def_34151,type,
    v62937: state_type > $o ).

tff(pred_def_34152,type,
    v62936: ( state_type * $int ) > $o ).

tff(pred_def_34153,type,
    v62938: state_type > $o ).

tff(pred_def_34154,type,
    v62939: state_type > $o ).

tff(pred_def_34155,type,
    v62940: state_type > $o ).

tff(pred_def_34156,type,
    v62935: ( state_type * $int ) > $o ).

tff(pred_def_34157,type,
    v62943: state_type > $o ).

tff(pred_def_34158,type,
    v62942: ( state_type * $int ) > $o ).

tff(pred_def_34159,type,
    v62944: state_type > $o ).

tff(pred_def_34160,type,
    v62945: state_type > $o ).

tff(pred_def_34161,type,
    v62946: state_type > $o ).

tff(pred_def_34162,type,
    v62941: ( state_type * $int ) > $o ).

tff(pred_def_34163,type,
    v62949: state_type > $o ).

tff(pred_def_34164,type,
    v62948: ( state_type * $int ) > $o ).

tff(pred_def_34165,type,
    v62950: state_type > $o ).

tff(pred_def_34166,type,
    v62951: state_type > $o ).

tff(pred_def_34167,type,
    v62952: state_type > $o ).

tff(pred_def_34168,type,
    v62947: ( state_type * $int ) > $o ).

tff(pred_def_34169,type,
    v62955: state_type > $o ).

tff(pred_def_34170,type,
    v62954: ( state_type * $int ) > $o ).

tff(pred_def_34171,type,
    v62956: state_type > $o ).

tff(pred_def_34172,type,
    v62957: state_type > $o ).

tff(pred_def_34173,type,
    v62958: state_type > $o ).

tff(pred_def_34174,type,
    v62953: ( state_type * $int ) > $o ).

tff(pred_def_34175,type,
    v62961: state_type > $o ).

tff(pred_def_34176,type,
    v62960: ( state_type * $int ) > $o ).

tff(pred_def_34177,type,
    v62962: state_type > $o ).

tff(pred_def_34178,type,
    v62963: state_type > $o ).

tff(pred_def_34179,type,
    v62959: ( state_type * $int ) > $o ).

tff(pred_def_34180,type,
    v62966: state_type > $o ).

tff(pred_def_34181,type,
    v62965: ( state_type * $int ) > $o ).

tff(pred_def_34182,type,
    v62967: state_type > $o ).

tff(pred_def_34183,type,
    v62968: state_type > $o ).

tff(pred_def_34184,type,
    v62969: state_type > $o ).

tff(pred_def_34185,type,
    v62964: ( state_type * $int ) > $o ).

tff(pred_def_34186,type,
    v62972: state_type > $o ).

tff(pred_def_34187,type,
    v62971: ( state_type * $int ) > $o ).

tff(pred_def_34188,type,
    v62973: state_type > $o ).

tff(pred_def_34189,type,
    v62974: state_type > $o ).

tff(pred_def_34190,type,
    v62975: state_type > $o ).

tff(pred_def_34191,type,
    v62970: ( state_type * $int ) > $o ).

tff(pred_def_34192,type,
    v62978: state_type > $o ).

tff(pred_def_34193,type,
    v62977: ( state_type * $int ) > $o ).

tff(pred_def_34194,type,
    v62979: state_type > $o ).

tff(pred_def_34195,type,
    v62980: state_type > $o ).

tff(pred_def_34196,type,
    v62981: state_type > $o ).

tff(pred_def_34197,type,
    v62976: ( state_type * $int ) > $o ).

tff(pred_def_34198,type,
    v62934: ( state_type * $int ) > $o ).

tff(pred_def_34199,type,
    v62876: ( state_type * $int ) > $o ).

tff(pred_def_34200,type,
    v62874: state_type > $o ).

tff(pred_def_34201,type,
    v62872: state_type > $o ).

tff(pred_def_34202,type,
    v63004: state_type > $o ).

tff(pred_def_34203,type,
    v63002: state_type > $o ).

tff(pred_def_34204,type,
    v63000: state_type > $o ).

tff(pred_def_34205,type,
    v62998: state_type > $o ).

tff(pred_def_34206,type,
    v62996: state_type > $o ).

tff(pred_def_34207,type,
    v62994: state_type > $o ).

tff(pred_def_34208,type,
    v62992: state_type > $o ).

tff(pred_def_34209,type,
    v62990: state_type > $o ).

tff(pred_def_34210,type,
    v62988: state_type > $o ).

tff(pred_def_34211,type,
    v62985: state_type > $o ).

tff(pred_def_34212,type,
    v62983: state_type > $o ).

tff(pred_def_34213,type,
    v63029: state_type > $o ).

tff(pred_def_34214,type,
    v63027: state_type > $o ).

tff(pred_def_34215,type,
    v63025: state_type > $o ).

tff(pred_def_34216,type,
    v63023: state_type > $o ).

tff(pred_def_34217,type,
    v63021: state_type > $o ).

tff(pred_def_34218,type,
    v63019: state_type > $o ).

tff(pred_def_34219,type,
    v63017: state_type > $o ).

tff(pred_def_34220,type,
    v63015: state_type > $o ).

tff(pred_def_34221,type,
    v63013: state_type > $o ).

tff(pred_def_34222,type,
    v63010: state_type > $o ).

tff(pred_def_34223,type,
    v63008: state_type > $o ).

tff(pred_def_34224,type,
    v63033: state_type > $o ).

tff(pred_def_34225,type,
    v62870: state_type > $o ).

tff(pred_def_34226,type,
    v62868: state_type > $o ).

tff(pred_def_34227,type,
    v63041: state_type > $o ).

tff(pred_def_34228,type,
    v63039: state_type > $o ).

tff(pred_def_34229,type,
    v63045: state_type > $o ).

tff(pred_def_34230,type,
    v63043: state_type > $o ).

tff(pred_def_34231,type,
    v63037: state_type > $o ).

tff(pred_def_34232,type,
    v63035: state_type > $o ).

tff(pred_def_34233,type,
    v63054: state_type > $o ).

tff(pred_def_34234,type,
    v63052: state_type > $o ).

tff(pred_def_34235,type,
    v63050: state_type > $o ).

tff(pred_def_34236,type,
    v63048: state_type > $o ).

tff(pred_def_34237,type,
    v63072: state_type > $o ).

tff(pred_def_34238,type,
    v63070: state_type > $o ).

tff(pred_def_34239,type,
    v63076: state_type > $o ).

tff(pred_def_34240,type,
    v63074: state_type > $o ).

tff(pred_def_34241,type,
    v63080: state_type > $o ).

tff(pred_def_34242,type,
    v63078: state_type > $o ).

tff(pred_def_34243,type,
    v63082: state_type > $o ).

tff(pred_def_34244,type,
    v63068: state_type > $o ).

tff(pred_def_34245,type,
    v63066: state_type > $o ).

tff(pred_def_34246,type,
    v63064: state_type > $o ).

tff(pred_def_34247,type,
    v63062: state_type > $o ).

tff(pred_def_34248,type,
    v63060: state_type > $o ).

tff(pred_def_34249,type,
    v63105: state_type > $o ).

tff(pred_def_34250,type,
    v63103: state_type > $o ).

tff(pred_def_34251,type,
    v63101: state_type > $o ).

tff(pred_def_34252,type,
    v63099: state_type > $o ).

tff(pred_def_34253,type,
    v63097: state_type > $o ).

tff(pred_def_34254,type,
    v63095: state_type > $o ).

tff(pred_def_34255,type,
    v63093: state_type > $o ).

tff(pred_def_34256,type,
    v63091: state_type > $o ).

tff(pred_def_34257,type,
    v63089: state_type > $o ).

tff(pred_def_34258,type,
    v63086: state_type > $o ).

tff(pred_def_34259,type,
    v63084: state_type > $o ).

tff(pred_def_34260,type,
    v63058: state_type > $o ).

tff(pred_def_34261,type,
    v63056: state_type > $o ).

tff(pred_def_34262,type,
    v62866: ( state_type * $int ) > $o ).

tff(pred_def_34263,type,
    v63109: ( state_type * $int ) > $o ).

tff(pred_def_34264,type,
    v63110: ( state_type * $int ) > $o ).

tff(pred_def_34265,type,
    v63111: ( state_type * $int ) > $o ).

tff(pred_def_34266,type,
    v63112: ( state_type * $int ) > $o ).

tff(pred_def_34267,type,
    v63113: ( state_type * $int ) > $o ).

tff(pred_def_34268,type,
    v63114: ( state_type * $int ) > $o ).

tff(pred_def_34269,type,
    v63115: ( state_type * $int ) > $o ).

tff(pred_def_34270,type,
    v63116: ( state_type * $int ) > $o ).

tff(pred_def_34271,type,
    v63117: ( state_type * $int ) > $o ).

tff(pred_def_34272,type,
    v63118: ( state_type * $int ) > $o ).

tff(pred_def_34273,type,
    v63119: ( state_type * $int ) > $o ).

tff(pred_def_34274,type,
    v63120: ( state_type * $int ) > $o ).

tff(pred_def_34275,type,
    v63121: ( state_type * $int ) > $o ).

tff(pred_def_34276,type,
    v63122: ( state_type * $int ) > $o ).

tff(pred_def_34277,type,
    v62864: ( state_type * $int ) > $o ).

tff(pred_def_34278,type,
    v62862: ( state_type * $int ) > $o ).

tff(pred_def_34279,type,
    v62860: ( state_type * $int ) > $o ).

tff(pred_def_34280,type,
    v62858: ( state_type * $int ) > $o ).

tff(pred_def_34281,type,
    v62856: ( state_type * $int ) > $o ).

tff(pred_def_34282,type,
    v62854: ( state_type * $int ) > $o ).

tff(pred_def_34283,type,
    v62852: ( state_type * $int ) > $o ).

tff(pred_def_34284,type,
    v62850: ( state_type * $int ) > $o ).

tff(pred_def_34285,type,
    v62844: state_type > $o ).

tff(pred_def_34286,type,
    v62842: state_type > $o ).

tff(pred_def_34287,type,
    v62840: state_type > $o ).

tff(pred_def_34288,type,
    v62838: state_type > $o ).

tff(pred_def_34289,type,
    v62836: state_type > $o ).

tff(pred_def_34290,type,
    v62815: state_type > $o ).

tff(pred_def_34291,type,
    v62813: state_type > $o ).

tff(pred_def_34292,type,
    v62811: state_type > $o ).

tff(pred_def_34293,type,
    v63134: state_type > $o ).

tff(pred_def_34294,type,
    v63132: state_type > $o ).

tff(pred_def_34295,type,
    v63148: ( state_type * $int ) > $o ).

tff(pred_def_34296,type,
    v63146: ( state_type * $int ) > $o ).

tff(pred_def_34297,type,
    v63173: state_type > $o ).

tff(pred_def_34298,type,
    v63171: state_type > $o ).

tff(pred_def_34299,type,
    v63177: state_type > $o ).

tff(pred_def_34300,type,
    v63175: state_type > $o ).

tff(pred_def_34301,type,
    v63181: state_type > $o ).

tff(pred_def_34302,type,
    v63179: state_type > $o ).

tff(pred_def_34303,type,
    v63183: state_type > $o ).

tff(pred_def_34304,type,
    v63169: state_type > $o ).

tff(pred_def_34305,type,
    v63167: state_type > $o ).

tff(pred_def_34306,type,
    v63165: state_type > $o ).

tff(pred_def_34307,type,
    v63163: state_type > $o ).

tff(pred_def_34308,type,
    v63161: state_type > $o ).

tff(pred_def_34309,type,
    v63187: state_type > $o ).

tff(pred_def_34310,type,
    v63185: state_type > $o ).

tff(pred_def_34311,type,
    v63159: state_type > $o ).

tff(pred_def_34312,type,
    v63157: state_type > $o ).

tff(pred_def_34313,type,
    v63196: state_type > $o ).

tff(pred_def_34314,type,
    v63194: state_type > $o ).

tff(pred_def_34315,type,
    v63200: state_type > $o ).

tff(pred_def_34316,type,
    v63198: state_type > $o ).

tff(pred_def_34317,type,
    v63204: state_type > $o ).

tff(pred_def_34318,type,
    v63202: state_type > $o ).

tff(pred_def_34319,type,
    v63206: state_type > $o ).

tff(pred_def_34320,type,
    v63192: state_type > $o ).

tff(pred_def_34321,type,
    v63190: state_type > $o ).

tff(pred_def_34322,type,
    v63214: state_type > $o ).

tff(pred_def_34323,type,
    v63212: state_type > $o ).

tff(pred_def_34324,type,
    v63218: state_type > $o ).

tff(pred_def_34325,type,
    v63216: state_type > $o ).

tff(pred_def_34326,type,
    v63210: state_type > $o ).

tff(pred_def_34327,type,
    v63208: state_type > $o ).

tff(pred_def_34328,type,
    v63227: state_type > $o ).

tff(pred_def_34329,type,
    v63225: state_type > $o ).

tff(pred_def_34330,type,
    v63231: state_type > $o ).

tff(pred_def_34331,type,
    v63229: state_type > $o ).

tff(pred_def_34332,type,
    v63235: state_type > $o ).

tff(pred_def_34333,type,
    v63233: state_type > $o ).

tff(pred_def_34334,type,
    v63237: state_type > $o ).

tff(pred_def_34335,type,
    v63223: state_type > $o ).

tff(pred_def_34336,type,
    v63221: state_type > $o ).

tff(pred_def_34337,type,
    v63154: ( state_type * $int ) > $o ).

tff(pred_def_34338,type,
    v63152: ( state_type * $int ) > $o ).

tff(pred_def_34339,type,
    v63150: ( state_type * $int ) > $o ).

tff(pred_def_34340,type,
    v63144: state_type > $o ).

tff(pred_def_34341,type,
    v63142: state_type > $o ).

tff(pred_def_34342,type,
    v63140: state_type > $o ).

tff(pred_def_34343,type,
    v63138: state_type > $o ).

tff(pred_def_34344,type,
    v63136: state_type > $o ).

tff(pred_def_34345,type,
    v63130: state_type > $o ).

tff(pred_def_34346,type,
    v63128: state_type > $o ).

tff(pred_def_34347,type,
    v63126: state_type > $o ).

tff(pred_def_34348,type,
    v63249: state_type > $o ).

tff(pred_def_34349,type,
    v63247: state_type > $o ).

tff(pred_def_34350,type,
    v63263: ( state_type * $int ) > $o ).

tff(pred_def_34351,type,
    v63261: ( state_type * $int ) > $o ).

tff(pred_def_34352,type,
    v63278: state_type > $o ).

tff(pred_def_34353,type,
    v63276: state_type > $o ).

tff(pred_def_34354,type,
    v63282: state_type > $o ).

tff(pred_def_34355,type,
    v63280: state_type > $o ).

tff(pred_def_34356,type,
    v63274: state_type > $o ).

tff(pred_def_34357,type,
    v63272: state_type > $o ).

tff(pred_def_34358,type,
    v63291: state_type > $o ).

tff(pred_def_34359,type,
    v63289: state_type > $o ).

tff(pred_def_34360,type,
    v63287: state_type > $o ).

tff(pred_def_34361,type,
    v63285: state_type > $o ).

tff(pred_def_34362,type,
    v63299: state_type > $o ).

tff(pred_def_34363,type,
    v63297: state_type > $o ).

tff(pred_def_34364,type,
    v63295: state_type > $o ).

tff(pred_def_34365,type,
    v63293: state_type > $o ).

tff(pred_def_34366,type,
    v63307: state_type > $o ).

tff(pred_def_34367,type,
    v63305: state_type > $o ).

tff(pred_def_34368,type,
    v63311: state_type > $o ).

tff(pred_def_34369,type,
    v63309: state_type > $o ).

tff(pred_def_34370,type,
    v63315: state_type > $o ).

tff(pred_def_34371,type,
    v63313: state_type > $o ).

tff(pred_def_34372,type,
    v63317: state_type > $o ).

tff(pred_def_34373,type,
    v63303: state_type > $o ).

tff(pred_def_34374,type,
    v63301: state_type > $o ).

tff(pred_def_34375,type,
    v63269: ( state_type * $int ) > $o ).

tff(pred_def_34376,type,
    v63267: ( state_type * $int ) > $o ).

tff(pred_def_34377,type,
    v63265: ( state_type * $int ) > $o ).

tff(pred_def_34378,type,
    v63259: state_type > $o ).

tff(pred_def_34379,type,
    v63257: state_type > $o ).

tff(pred_def_34380,type,
    v63255: state_type > $o ).

tff(pred_def_34381,type,
    v63253: state_type > $o ).

tff(pred_def_34382,type,
    v63251: state_type > $o ).

tff(pred_def_34383,type,
    v63245: state_type > $o ).

tff(pred_def_34384,type,
    v63243: state_type > $o ).

tff(pred_def_34385,type,
    v63241: state_type > $o ).

tff(pred_def_34386,type,
    v63329: state_type > $o ).

tff(pred_def_34387,type,
    v63327: state_type > $o ).

tff(pred_def_34388,type,
    v63343: ( state_type * $int ) > $o ).

tff(pred_def_34389,type,
    v63341: ( state_type * $int ) > $o ).

tff(pred_def_34390,type,
    v63367: state_type > $o ).

tff(pred_def_34391,type,
    v63365: state_type > $o ).

tff(pred_def_34392,type,
    v63363: state_type > $o ).

tff(pred_def_34393,type,
    v63361: state_type > $o ).

tff(pred_def_34394,type,
    v63358: state_type > $o ).

tff(pred_def_34395,type,
    v63356: state_type > $o ).

tff(pred_def_34396,type,
    v63381: state_type > $o ).

tff(pred_def_34397,type,
    v63379: state_type > $o ).

tff(pred_def_34398,type,
    v63377: state_type > $o ).

tff(pred_def_34399,type,
    v63375: state_type > $o ).

tff(pred_def_34400,type,
    v63372: state_type > $o ).

tff(pred_def_34401,type,
    v63370: state_type > $o ).

tff(pred_def_34402,type,
    v63395: state_type > $o ).

tff(pred_def_34403,type,
    v63393: state_type > $o ).

tff(pred_def_34404,type,
    v63391: state_type > $o ).

tff(pred_def_34405,type,
    v63389: state_type > $o ).

tff(pred_def_34406,type,
    v63386: state_type > $o ).

tff(pred_def_34407,type,
    v63384: state_type > $o ).

tff(pred_def_34408,type,
    v63398: state_type > $o ).

tff(pred_def_34409,type,
    v63354: state_type > $o ).

tff(pred_def_34410,type,
    v63352: state_type > $o ).

tff(pred_def_34411,type,
    v63406: state_type > $o ).

tff(pred_def_34412,type,
    v63404: state_type > $o ).

tff(pred_def_34413,type,
    v63419: state_type > $o ).

tff(pred_def_34414,type,
    v63417: state_type > $o ).

tff(pred_def_34415,type,
    v63415: state_type > $o ).

tff(pred_def_34416,type,
    v63413: state_type > $o ).

tff(pred_def_34417,type,
    v63410: state_type > $o ).

tff(pred_def_34418,type,
    v63408: state_type > $o ).

tff(pred_def_34419,type,
    v63402: state_type > $o ).

tff(pred_def_34420,type,
    v63400: state_type > $o ).

tff(pred_def_34421,type,
    v63429: state_type > $o ).

tff(pred_def_34422,type,
    v63427: state_type > $o ).

tff(pred_def_34423,type,
    v63433: state_type > $o ).

tff(pred_def_34424,type,
    v63431: state_type > $o ).

tff(pred_def_34425,type,
    v63425: state_type > $o ).

tff(pred_def_34426,type,
    v63423: state_type > $o ).

tff(pred_def_34427,type,
    v63442: state_type > $o ).

tff(pred_def_34428,type,
    v63440: state_type > $o ).

tff(pred_def_34429,type,
    v63446: state_type > $o ).

tff(pred_def_34430,type,
    v63444: state_type > $o ).

tff(pred_def_34431,type,
    v63438: state_type > $o ).

tff(pred_def_34432,type,
    v63436: state_type > $o ).

tff(pred_def_34433,type,
    v63349: ( state_type * $int ) > $o ).

tff(pred_def_34434,type,
    v63347: ( state_type * $int ) > $o ).

tff(pred_def_34435,type,
    v63345: ( state_type * $int ) > $o ).

tff(pred_def_34436,type,
    v63339: state_type > $o ).

tff(pred_def_34437,type,
    v63337: state_type > $o ).

tff(pred_def_34438,type,
    v63335: state_type > $o ).

tff(pred_def_34439,type,
    v63333: state_type > $o ).

tff(pred_def_34440,type,
    v63331: state_type > $o ).

tff(pred_def_34441,type,
    v63325: state_type > $o ).

tff(pred_def_34442,type,
    v63323: state_type > $o ).

tff(pred_def_34443,type,
    v63321: state_type > $o ).

tff(pred_def_34444,type,
    v63459: state_type > $o ).

tff(pred_def_34445,type,
    v63457: state_type > $o ).

tff(pred_def_34446,type,
    v63473: ( state_type * $int ) > $o ).

tff(pred_def_34447,type,
    v63471: ( state_type * $int ) > $o ).

tff(pred_def_34448,type,
    v63488: state_type > $o ).

tff(pred_def_34449,type,
    v63486: state_type > $o ).

tff(pred_def_34450,type,
    v63492: state_type > $o ).

tff(pred_def_34451,type,
    v63490: state_type > $o ).

tff(pred_def_34452,type,
    v63484: state_type > $o ).

tff(pred_def_34453,type,
    v63482: state_type > $o ).

tff(pred_def_34454,type,
    v63501: state_type > $o ).

tff(pred_def_34455,type,
    v63499: state_type > $o ).

tff(pred_def_34456,type,
    v63505: state_type > $o ).

tff(pred_def_34457,type,
    v63503: state_type > $o ).

tff(pred_def_34458,type,
    v63497: state_type > $o ).

tff(pred_def_34459,type,
    v63495: state_type > $o ).

tff(pred_def_34460,type,
    v63514: state_type > $o ).

tff(pred_def_34461,type,
    v63512: state_type > $o ).

tff(pred_def_34462,type,
    v63518: state_type > $o ).

tff(pred_def_34463,type,
    v63516: state_type > $o ).

tff(pred_def_34464,type,
    v63522: state_type > $o ).

tff(pred_def_34465,type,
    v63520: state_type > $o ).

tff(pred_def_34466,type,
    v63524: state_type > $o ).

tff(pred_def_34467,type,
    v63510: state_type > $o ).

tff(pred_def_34468,type,
    v63508: state_type > $o ).

tff(pred_def_34469,type,
    v63532: state_type > $o ).

tff(pred_def_34470,type,
    v63530: state_type > $o ).

tff(pred_def_34471,type,
    v63536: state_type > $o ).

tff(pred_def_34472,type,
    v63534: state_type > $o ).

tff(pred_def_34473,type,
    v63540: state_type > $o ).

tff(pred_def_34474,type,
    v63538: state_type > $o ).

tff(pred_def_34475,type,
    v63542: state_type > $o ).

tff(pred_def_34476,type,
    v63528: state_type > $o ).

tff(pred_def_34477,type,
    v63526: state_type > $o ).

tff(pred_def_34478,type,
    v63479: ( state_type * $int ) > $o ).

tff(pred_def_34479,type,
    v63477: ( state_type * $int ) > $o ).

tff(pred_def_34480,type,
    v63475: ( state_type * $int ) > $o ).

tff(pred_def_34481,type,
    v63469: state_type > $o ).

tff(pred_def_34482,type,
    v63467: state_type > $o ).

tff(pred_def_34483,type,
    v63465: state_type > $o ).

tff(pred_def_34484,type,
    v63463: state_type > $o ).

tff(pred_def_34485,type,
    v63461: state_type > $o ).

tff(pred_def_34486,type,
    v63455: state_type > $o ).

tff(pred_def_34487,type,
    v63453: state_type > $o ).

tff(pred_def_34488,type,
    v63451: state_type > $o ).

tff(pred_def_34489,type,
    v63554: state_type > $o ).

tff(pred_def_34490,type,
    v63552: state_type > $o ).

tff(pred_def_34491,type,
    v63568: ( state_type * $int ) > $o ).

tff(pred_def_34492,type,
    v63566: ( state_type * $int ) > $o ).

tff(pred_def_34493,type,
    v63583: state_type > $o ).

tff(pred_def_34494,type,
    v63581: state_type > $o ).

tff(pred_def_34495,type,
    v63587: state_type > $o ).

tff(pred_def_34496,type,
    v63585: state_type > $o ).

tff(pred_def_34497,type,
    v63591: state_type > $o ).

tff(pred_def_34498,type,
    v63589: state_type > $o ).

tff(pred_def_34499,type,
    v63593: state_type > $o ).

tff(pred_def_34500,type,
    v63579: state_type > $o ).

tff(pred_def_34501,type,
    v63577: state_type > $o ).

tff(pred_def_34502,type,
    v63601: state_type > $o ).

tff(pred_def_34503,type,
    v63599: state_type > $o ).

tff(pred_def_34504,type,
    v63605: state_type > $o ).

tff(pred_def_34505,type,
    v63603: state_type > $o ).

tff(pred_def_34506,type,
    v63609: state_type > $o ).

tff(pred_def_34507,type,
    v63607: state_type > $o ).

tff(pred_def_34508,type,
    v63611: state_type > $o ).

tff(pred_def_34509,type,
    v63597: state_type > $o ).

tff(pred_def_34510,type,
    v63595: state_type > $o ).

tff(pred_def_34511,type,
    v63629: state_type > $o ).

tff(pred_def_34512,type,
    v63627: state_type > $o ).

tff(pred_def_34513,type,
    v63633: state_type > $o ).

tff(pred_def_34514,type,
    v63631: state_type > $o ).

tff(pred_def_34515,type,
    v63637: state_type > $o ).

tff(pred_def_34516,type,
    v63635: state_type > $o ).

tff(pred_def_34517,type,
    v63639: state_type > $o ).

tff(pred_def_34518,type,
    v63625: state_type > $o ).

tff(pred_def_34519,type,
    v63623: state_type > $o ).

tff(pred_def_34520,type,
    v63621: state_type > $o ).

tff(pred_def_34521,type,
    v63619: state_type > $o ).

tff(pred_def_34522,type,
    v63617: state_type > $o ).

tff(pred_def_34523,type,
    v63643: state_type > $o ).

tff(pred_def_34524,type,
    v63641: state_type > $o ).

tff(pred_def_34525,type,
    v63615: state_type > $o ).

tff(pred_def_34526,type,
    v63613: state_type > $o ).

tff(pred_def_34527,type,
    v63652: state_type > $o ).

tff(pred_def_34528,type,
    v63650: state_type > $o ).

tff(pred_def_34529,type,
    v63656: state_type > $o ).

tff(pred_def_34530,type,
    v63654: state_type > $o ).

tff(pred_def_34531,type,
    v63648: state_type > $o ).

tff(pred_def_34532,type,
    v63646: state_type > $o ).

tff(pred_def_34533,type,
    v63574: ( state_type * $int ) > $o ).

tff(pred_def_34534,type,
    v63572: ( state_type * $int ) > $o ).

tff(pred_def_34535,type,
    v63570: ( state_type * $int ) > $o ).

tff(pred_def_34536,type,
    v63564: state_type > $o ).

tff(pred_def_34537,type,
    v63562: state_type > $o ).

tff(pred_def_34538,type,
    v63560: state_type > $o ).

tff(pred_def_34539,type,
    v63558: state_type > $o ).

tff(pred_def_34540,type,
    v63556: state_type > $o ).

tff(pred_def_34541,type,
    v63550: state_type > $o ).

tff(pred_def_34542,type,
    v63548: state_type > $o ).

tff(pred_def_34543,type,
    v63546: state_type > $o ).

tff(pred_def_34544,type,
    v63669: state_type > $o ).

tff(pred_def_34545,type,
    v63667: state_type > $o ).

tff(pred_def_34546,type,
    v63683: ( state_type * $int ) > $o ).

tff(pred_def_34547,type,
    v63681: ( state_type * $int ) > $o ).

tff(pred_def_34548,type,
    v63698: state_type > $o ).

tff(pred_def_34549,type,
    v63696: state_type > $o ).

tff(pred_def_34550,type,
    v63694: state_type > $o ).

tff(pred_def_34551,type,
    v63692: state_type > $o ).

tff(pred_def_34552,type,
    v63706: state_type > $o ).

tff(pred_def_34553,type,
    v63704: state_type > $o ).

tff(pred_def_34554,type,
    v63702: state_type > $o ).

tff(pred_def_34555,type,
    v63700: state_type > $o ).

tff(pred_def_34556,type,
    v63714: state_type > $o ).

tff(pred_def_34557,type,
    v63712: state_type > $o ).

tff(pred_def_34558,type,
    v63710: state_type > $o ).

tff(pred_def_34559,type,
    v63708: state_type > $o ).

tff(pred_def_34560,type,
    v63722: state_type > $o ).

tff(pred_def_34561,type,
    v63720: state_type > $o ).

tff(pred_def_34562,type,
    v63726: state_type > $o ).

tff(pred_def_34563,type,
    v63724: state_type > $o ).

tff(pred_def_34564,type,
    v63718: state_type > $o ).

tff(pred_def_34565,type,
    v63716: state_type > $o ).

tff(pred_def_34566,type,
    v63689: ( state_type * $int ) > $o ).

tff(pred_def_34567,type,
    v63687: ( state_type * $int ) > $o ).

tff(pred_def_34568,type,
    v63685: ( state_type * $int ) > $o ).

tff(pred_def_34569,type,
    v63679: state_type > $o ).

tff(pred_def_34570,type,
    v63677: state_type > $o ).

tff(pred_def_34571,type,
    v63675: state_type > $o ).

tff(pred_def_34572,type,
    v63673: state_type > $o ).

tff(pred_def_34573,type,
    v63671: state_type > $o ).

tff(pred_def_34574,type,
    v63665: state_type > $o ).

tff(pred_def_34575,type,
    v63663: state_type > $o ).

tff(pred_def_34576,type,
    v63661: state_type > $o ).

tff(pred_def_34577,type,
    v63739: state_type > $o ).

tff(pred_def_34578,type,
    v63737: state_type > $o ).

tff(pred_def_34579,type,
    v63753: ( state_type * $int ) > $o ).

tff(pred_def_34580,type,
    v63751: ( state_type * $int ) > $o ).

tff(pred_def_34581,type,
    v63777: state_type > $o ).

tff(pred_def_34582,type,
    v63775: state_type > $o ).

tff(pred_def_34583,type,
    v63773: state_type > $o ).

tff(pred_def_34584,type,
    v63771: state_type > $o ).

tff(pred_def_34585,type,
    v63768: state_type > $o ).

tff(pred_def_34586,type,
    v63766: state_type > $o ).

tff(pred_def_34587,type,
    v63791: state_type > $o ).

tff(pred_def_34588,type,
    v63789: state_type > $o ).

tff(pred_def_34589,type,
    v63787: state_type > $o ).

tff(pred_def_34590,type,
    v63785: state_type > $o ).

tff(pred_def_34591,type,
    v63782: state_type > $o ).

tff(pred_def_34592,type,
    v63780: state_type > $o ).

tff(pred_def_34593,type,
    v63764: state_type > $o ).

tff(pred_def_34594,type,
    v63762: state_type > $o ).

tff(pred_def_34595,type,
    v63801: state_type > $o ).

tff(pred_def_34596,type,
    v63799: state_type > $o ).

tff(pred_def_34597,type,
    v63814: state_type > $o ).

tff(pred_def_34598,type,
    v63812: state_type > $o ).

tff(pred_def_34599,type,
    v63810: state_type > $o ).

tff(pred_def_34600,type,
    v63808: state_type > $o ).

tff(pred_def_34601,type,
    v63805: state_type > $o ).

tff(pred_def_34602,type,
    v63803: state_type > $o ).

tff(pred_def_34603,type,
    v63797: state_type > $o ).

tff(pred_def_34604,type,
    v63795: state_type > $o ).

tff(pred_def_34605,type,
    v63824: state_type > $o ).

tff(pred_def_34606,type,
    v63822: state_type > $o ).

tff(pred_def_34607,type,
    v63837: state_type > $o ).

tff(pred_def_34608,type,
    v63835: state_type > $o ).

tff(pred_def_34609,type,
    v63833: state_type > $o ).

tff(pred_def_34610,type,
    v63831: state_type > $o ).

tff(pred_def_34611,type,
    v63828: state_type > $o ).

tff(pred_def_34612,type,
    v63826: state_type > $o ).

tff(pred_def_34613,type,
    v63820: state_type > $o ).

tff(pred_def_34614,type,
    v63818: state_type > $o ).

tff(pred_def_34615,type,
    v63847: state_type > $o ).

tff(pred_def_34616,type,
    v63845: state_type > $o ).

tff(pred_def_34617,type,
    v63843: state_type > $o ).

tff(pred_def_34618,type,
    v63841: state_type > $o ).

tff(pred_def_34619,type,
    v63759: ( state_type * $int ) > $o ).

tff(pred_def_34620,type,
    v63757: ( state_type * $int ) > $o ).

tff(pred_def_34621,type,
    v63755: ( state_type * $int ) > $o ).

tff(pred_def_34622,type,
    v63749: state_type > $o ).

tff(pred_def_34623,type,
    v63747: state_type > $o ).

tff(pred_def_34624,type,
    v63745: state_type > $o ).

tff(pred_def_34625,type,
    v63743: state_type > $o ).

tff(pred_def_34626,type,
    v63741: state_type > $o ).

tff(pred_def_34627,type,
    v63735: state_type > $o ).

tff(pred_def_34628,type,
    v63733: state_type > $o ).

tff(pred_def_34629,type,
    v63731: state_type > $o ).

tff(pred_def_34630,type,
    v63859: state_type > $o ).

tff(pred_def_34631,type,
    v63857: state_type > $o ).

tff(pred_def_34632,type,
    v63873: ( state_type * $int ) > $o ).

tff(pred_def_34633,type,
    v63871: ( state_type * $int ) > $o ).

tff(pred_def_34634,type,
    v63888: state_type > $o ).

tff(pred_def_34635,type,
    v63886: state_type > $o ).

tff(pred_def_34636,type,
    v63892: state_type > $o ).

tff(pred_def_34637,type,
    v63890: state_type > $o ).

tff(pred_def_34638,type,
    v63896: state_type > $o ).

tff(pred_def_34639,type,
    v63894: state_type > $o ).

tff(pred_def_34640,type,
    v63898: state_type > $o ).

tff(pred_def_34641,type,
    v63884: state_type > $o ).

tff(pred_def_34642,type,
    v63882: state_type > $o ).

tff(pred_def_34643,type,
    v63916: state_type > $o ).

tff(pred_def_34644,type,
    v63914: state_type > $o ).

tff(pred_def_34645,type,
    v63920: state_type > $o ).

tff(pred_def_34646,type,
    v63918: state_type > $o ).

tff(pred_def_34647,type,
    v63924: state_type > $o ).

tff(pred_def_34648,type,
    v63922: state_type > $o ).

tff(pred_def_34649,type,
    v63926: state_type > $o ).

tff(pred_def_34650,type,
    v63912: state_type > $o ).

tff(pred_def_34651,type,
    v63910: state_type > $o ).

tff(pred_def_34652,type,
    v63908: state_type > $o ).

tff(pred_def_34653,type,
    v63906: state_type > $o ).

tff(pred_def_34654,type,
    v63904: state_type > $o ).

tff(pred_def_34655,type,
    v63930: state_type > $o ).

tff(pred_def_34656,type,
    v63928: state_type > $o ).

tff(pred_def_34657,type,
    v63902: state_type > $o ).

tff(pred_def_34658,type,
    v63900: state_type > $o ).

tff(pred_def_34659,type,
    v63939: state_type > $o ).

tff(pred_def_34660,type,
    v63937: state_type > $o ).

tff(pred_def_34661,type,
    v63943: state_type > $o ).

tff(pred_def_34662,type,
    v63941: state_type > $o ).

tff(pred_def_34663,type,
    v63947: state_type > $o ).

tff(pred_def_34664,type,
    v63945: state_type > $o ).

tff(pred_def_34665,type,
    v63949: state_type > $o ).

tff(pred_def_34666,type,
    v63935: state_type > $o ).

tff(pred_def_34667,type,
    v63933: state_type > $o ).

tff(pred_def_34668,type,
    v63957: state_type > $o ).

tff(pred_def_34669,type,
    v63955: state_type > $o ).

tff(pred_def_34670,type,
    v63961: state_type > $o ).

tff(pred_def_34671,type,
    v63959: state_type > $o ).

tff(pred_def_34672,type,
    v63965: state_type > $o ).

tff(pred_def_34673,type,
    v63963: state_type > $o ).

tff(pred_def_34674,type,
    v63967: state_type > $o ).

tff(pred_def_34675,type,
    v63953: state_type > $o ).

tff(pred_def_34676,type,
    v63951: state_type > $o ).

tff(pred_def_34677,type,
    v63879: ( state_type * $int ) > $o ).

tff(pred_def_34678,type,
    v63877: ( state_type * $int ) > $o ).

tff(pred_def_34679,type,
    v63875: ( state_type * $int ) > $o ).

tff(pred_def_34680,type,
    v63869: state_type > $o ).

tff(pred_def_34681,type,
    v63867: state_type > $o ).

tff(pred_def_34682,type,
    v63865: state_type > $o ).

tff(pred_def_34683,type,
    v63863: state_type > $o ).

tff(pred_def_34684,type,
    v63861: state_type > $o ).

tff(pred_def_34685,type,
    v63855: state_type > $o ).

tff(pred_def_34686,type,
    v63853: state_type > $o ).

tff(pred_def_34687,type,
    v63851: state_type > $o ).

tff(pred_def_34688,type,
    v63979: state_type > $o ).

tff(pred_def_34689,type,
    v63977: state_type > $o ).

tff(pred_def_34690,type,
    v63993: ( state_type * $int ) > $o ).

tff(pred_def_34691,type,
    v63991: ( state_type * $int ) > $o ).

tff(pred_def_34692,type,
    v64008: state_type > $o ).

tff(pred_def_34693,type,
    v64006: state_type > $o ).

tff(pred_def_34694,type,
    v64012: state_type > $o ).

tff(pred_def_34695,type,
    v64010: state_type > $o ).

tff(pred_def_34696,type,
    v64004: state_type > $o ).

tff(pred_def_34697,type,
    v64002: state_type > $o ).

tff(pred_def_34698,type,
    v64021: state_type > $o ).

tff(pred_def_34699,type,
    v64019: state_type > $o ).

tff(pred_def_34700,type,
    v64025: state_type > $o ).

tff(pred_def_34701,type,
    v64023: state_type > $o ).

tff(pred_def_34702,type,
    v64029: state_type > $o ).

tff(pred_def_34703,type,
    v64027: state_type > $o ).

tff(pred_def_34704,type,
    v64031: state_type > $o ).

tff(pred_def_34705,type,
    v64017: state_type > $o ).

tff(pred_def_34706,type,
    v64015: state_type > $o ).

tff(pred_def_34707,type,
    v64039: state_type > $o ).

tff(pred_def_34708,type,
    v64037: state_type > $o ).

tff(pred_def_34709,type,
    v64043: state_type > $o ).

tff(pred_def_34710,type,
    v64041: state_type > $o ).

tff(pred_def_34711,type,
    v64035: state_type > $o ).

tff(pred_def_34712,type,
    v64033: state_type > $o ).

tff(pred_def_34713,type,
    v64052: state_type > $o ).

tff(pred_def_34714,type,
    v64050: state_type > $o ).

tff(pred_def_34715,type,
    v64056: state_type > $o ).

tff(pred_def_34716,type,
    v64054: state_type > $o ).

tff(pred_def_34717,type,
    v64048: state_type > $o ).

tff(pred_def_34718,type,
    v64046: state_type > $o ).

tff(pred_def_34719,type,
    v63999: ( state_type * $int ) > $o ).

tff(pred_def_34720,type,
    v63997: ( state_type * $int ) > $o ).

tff(pred_def_34721,type,
    v63995: ( state_type * $int ) > $o ).

tff(pred_def_34722,type,
    v63989: state_type > $o ).

tff(pred_def_34723,type,
    v63987: state_type > $o ).

tff(pred_def_34724,type,
    v63985: state_type > $o ).

tff(pred_def_34725,type,
    v63983: state_type > $o ).

tff(pred_def_34726,type,
    v63981: state_type > $o ).

tff(pred_def_34727,type,
    v63975: state_type > $o ).

tff(pred_def_34728,type,
    v63973: state_type > $o ).

tff(pred_def_34729,type,
    v63971: state_type > $o ).

tff(pred_def_34730,type,
    v64069: state_type > $o ).

tff(pred_def_34731,type,
    v64067: state_type > $o ).

tff(pred_def_34732,type,
    v64083: ( state_type * $int ) > $o ).

tff(pred_def_34733,type,
    v64081: ( state_type * $int ) > $o ).

tff(pred_def_34734,type,
    v64098: state_type > $o ).

tff(pred_def_34735,type,
    v64096: state_type > $o ).

tff(pred_def_34736,type,
    v64102: state_type > $o ).

tff(pred_def_34737,type,
    v64100: state_type > $o ).

tff(pred_def_34738,type,
    v64094: state_type > $o ).

tff(pred_def_34739,type,
    v64092: state_type > $o ).

tff(pred_def_34740,type,
    v64111: state_type > $o ).

tff(pred_def_34741,type,
    v64109: state_type > $o ).

tff(pred_def_34742,type,
    v64115: state_type > $o ).

tff(pred_def_34743,type,
    v64113: state_type > $o ).

tff(pred_def_34744,type,
    v64119: state_type > $o ).

tff(pred_def_34745,type,
    v64117: state_type > $o ).

tff(pred_def_34746,type,
    v64121: state_type > $o ).

tff(pred_def_34747,type,
    v64107: state_type > $o ).

tff(pred_def_34748,type,
    v64105: state_type > $o ).

tff(pred_def_34749,type,
    v64129: state_type > $o ).

tff(pred_def_34750,type,
    v64127: state_type > $o ).

tff(pred_def_34751,type,
    v64133: state_type > $o ).

tff(pred_def_34752,type,
    v64131: state_type > $o ).

tff(pred_def_34753,type,
    v64137: state_type > $o ).

tff(pred_def_34754,type,
    v64135: state_type > $o ).

tff(pred_def_34755,type,
    v64139: state_type > $o ).

tff(pred_def_34756,type,
    v64125: state_type > $o ).

tff(pred_def_34757,type,
    v64123: state_type > $o ).

tff(pred_def_34758,type,
    v64147: state_type > $o ).

tff(pred_def_34759,type,
    v64145: state_type > $o ).

tff(pred_def_34760,type,
    v64151: state_type > $o ).

tff(pred_def_34761,type,
    v64149: state_type > $o ).

tff(pred_def_34762,type,
    v64143: state_type > $o ).

tff(pred_def_34763,type,
    v64141: state_type > $o ).

tff(pred_def_34764,type,
    v64089: ( state_type * $int ) > $o ).

tff(pred_def_34765,type,
    v64087: ( state_type * $int ) > $o ).

tff(pred_def_34766,type,
    v64085: ( state_type * $int ) > $o ).

tff(pred_def_34767,type,
    v64079: state_type > $o ).

tff(pred_def_34768,type,
    v64077: state_type > $o ).

tff(pred_def_34769,type,
    v64075: state_type > $o ).

tff(pred_def_34770,type,
    v64073: state_type > $o ).

tff(pred_def_34771,type,
    v64071: state_type > $o ).

tff(pred_def_34772,type,
    v64065: state_type > $o ).

tff(pred_def_34773,type,
    v64063: state_type > $o ).

tff(pred_def_34774,type,
    v64061: state_type > $o ).

tff(pred_def_34775,type,
    v64164: state_type > $o ).

tff(pred_def_34776,type,
    v64162: state_type > $o ).

tff(pred_def_34777,type,
    v64178: ( state_type * $int ) > $o ).

tff(pred_def_34778,type,
    v64176: ( state_type * $int ) > $o ).

tff(pred_def_34779,type,
    v64202: state_type > $o ).

tff(pred_def_34780,type,
    v64200: state_type > $o ).

tff(pred_def_34781,type,
    v64198: state_type > $o ).

tff(pred_def_34782,type,
    v64196: state_type > $o ).

tff(pred_def_34783,type,
    v64193: state_type > $o ).

tff(pred_def_34784,type,
    v64191: state_type > $o ).

tff(pred_def_34785,type,
    v64189: state_type > $o ).

tff(pred_def_34786,type,
    v64187: state_type > $o ).

tff(pred_def_34787,type,
    v64220: state_type > $o ).

tff(pred_def_34788,type,
    v64218: state_type > $o ).

tff(pred_def_34789,type,
    v64216: state_type > $o ).

tff(pred_def_34790,type,
    v64214: state_type > $o ).

tff(pred_def_34791,type,
    v64211: state_type > $o ).

tff(pred_def_34792,type,
    v64209: state_type > $o ).

tff(pred_def_34793,type,
    v64234: state_type > $o ).

tff(pred_def_34794,type,
    v64232: state_type > $o ).

tff(pred_def_34795,type,
    v64230: state_type > $o ).

tff(pred_def_34796,type,
    v64228: state_type > $o ).

tff(pred_def_34797,type,
    v64225: state_type > $o ).

tff(pred_def_34798,type,
    v64223: state_type > $o ).

tff(pred_def_34799,type,
    v64207: state_type > $o ).

tff(pred_def_34800,type,
    v64205: state_type > $o ).

tff(pred_def_34801,type,
    v64244: state_type > $o ).

tff(pred_def_34802,type,
    v64242: state_type > $o ).

tff(pred_def_34803,type,
    v64257: state_type > $o ).

tff(pred_def_34804,type,
    v64255: state_type > $o ).

tff(pred_def_34805,type,
    v64253: state_type > $o ).

tff(pred_def_34806,type,
    v64251: state_type > $o ).

tff(pred_def_34807,type,
    v64248: state_type > $o ).

tff(pred_def_34808,type,
    v64246: state_type > $o ).

tff(pred_def_34809,type,
    v64240: state_type > $o ).

tff(pred_def_34810,type,
    v64238: state_type > $o ).

tff(pred_def_34811,type,
    v64267: state_type > $o ).

tff(pred_def_34812,type,
    v64265: state_type > $o ).

tff(pred_def_34813,type,
    v64263: state_type > $o ).

tff(pred_def_34814,type,
    v64261: state_type > $o ).

tff(pred_def_34815,type,
    v64184: ( state_type * $int ) > $o ).

tff(pred_def_34816,type,
    v64182: ( state_type * $int ) > $o ).

tff(pred_def_34817,type,
    v64180: ( state_type * $int ) > $o ).

tff(pred_def_34818,type,
    v64174: state_type > $o ).

tff(pred_def_34819,type,
    v64172: state_type > $o ).

tff(pred_def_34820,type,
    v64170: state_type > $o ).

tff(pred_def_34821,type,
    v64168: state_type > $o ).

tff(pred_def_34822,type,
    v64166: state_type > $o ).

tff(pred_def_34823,type,
    v64160: state_type > $o ).

tff(pred_def_34824,type,
    v64158: state_type > $o ).

tff(pred_def_34825,type,
    v64156: state_type > $o ).

tff(pred_def_34826,type,
    v64279: state_type > $o ).

tff(pred_def_34827,type,
    v64277: state_type > $o ).

tff(pred_def_34828,type,
    v64293: ( state_type * $int ) > $o ).

tff(pred_def_34829,type,
    v64291: ( state_type * $int ) > $o ).

tff(pred_def_34830,type,
    v64308: state_type > $o ).

tff(pred_def_34831,type,
    v64306: state_type > $o ).

tff(pred_def_34832,type,
    v64312: state_type > $o ).

tff(pred_def_34833,type,
    v64310: state_type > $o ).

tff(pred_def_34834,type,
    v64304: state_type > $o ).

tff(pred_def_34835,type,
    v64302: state_type > $o ).

tff(pred_def_34836,type,
    v64321: state_type > $o ).

tff(pred_def_34837,type,
    v64319: state_type > $o ).

tff(pred_def_34838,type,
    v64325: state_type > $o ).

tff(pred_def_34839,type,
    v64323: state_type > $o ).

tff(pred_def_34840,type,
    v64317: state_type > $o ).

tff(pred_def_34841,type,
    v64315: state_type > $o ).

tff(pred_def_34842,type,
    v64334: state_type > $o ).

tff(pred_def_34843,type,
    v64332: state_type > $o ).

tff(pred_def_34844,type,
    v64338: state_type > $o ).

tff(pred_def_34845,type,
    v64336: state_type > $o ).

tff(pred_def_34846,type,
    v64342: state_type > $o ).

tff(pred_def_34847,type,
    v64340: state_type > $o ).

tff(pred_def_34848,type,
    v64344: state_type > $o ).

tff(pred_def_34849,type,
    v64330: state_type > $o ).

tff(pred_def_34850,type,
    v64328: state_type > $o ).

tff(pred_def_34851,type,
    v64352: state_type > $o ).

tff(pred_def_34852,type,
    v64350: state_type > $o ).

tff(pred_def_34853,type,
    v64356: state_type > $o ).

tff(pred_def_34854,type,
    v64354: state_type > $o ).

tff(pred_def_34855,type,
    v64348: state_type > $o ).

tff(pred_def_34856,type,
    v64346: state_type > $o ).

tff(pred_def_34857,type,
    v64299: ( state_type * $int ) > $o ).

tff(pred_def_34858,type,
    v64297: ( state_type * $int ) > $o ).

tff(pred_def_34859,type,
    v64295: ( state_type * $int ) > $o ).

tff(pred_def_34860,type,
    v64289: state_type > $o ).

tff(pred_def_34861,type,
    v64287: state_type > $o ).

tff(pred_def_34862,type,
    v64285: state_type > $o ).

tff(pred_def_34863,type,
    v64283: state_type > $o ).

tff(pred_def_34864,type,
    v64281: state_type > $o ).

tff(pred_def_34865,type,
    v64275: state_type > $o ).

tff(pred_def_34866,type,
    v64273: state_type > $o ).

tff(pred_def_34867,type,
    v64271: state_type > $o ).

tff(pred_def_34868,type,
    v64369: state_type > $o ).

tff(pred_def_34869,type,
    v64367: state_type > $o ).

tff(pred_def_34870,type,
    v64383: ( state_type * $int ) > $o ).

tff(pred_def_34871,type,
    v64381: ( state_type * $int ) > $o ).

tff(pred_def_34872,type,
    v64398: state_type > $o ).

tff(pred_def_34873,type,
    v64396: state_type > $o ).

tff(pred_def_34874,type,
    v64394: state_type > $o ).

tff(pred_def_34875,type,
    v64392: state_type > $o ).

tff(pred_def_34876,type,
    v64406: state_type > $o ).

tff(pred_def_34877,type,
    v64404: state_type > $o ).

tff(pred_def_34878,type,
    v64402: state_type > $o ).

tff(pred_def_34879,type,
    v64400: state_type > $o ).

tff(pred_def_34880,type,
    v64414: state_type > $o ).

tff(pred_def_34881,type,
    v64412: state_type > $o ).

tff(pred_def_34882,type,
    v64418: state_type > $o ).

tff(pred_def_34883,type,
    v64416: state_type > $o ).

tff(pred_def_34884,type,
    v64410: state_type > $o ).

tff(pred_def_34885,type,
    v64408: state_type > $o ).

tff(pred_def_34886,type,
    v64427: state_type > $o ).

tff(pred_def_34887,type,
    v64425: state_type > $o ).

tff(pred_def_34888,type,
    v64423: state_type > $o ).

tff(pred_def_34889,type,
    v64421: state_type > $o ).

tff(pred_def_34890,type,
    v64389: ( state_type * $int ) > $o ).

tff(pred_def_34891,type,
    v64387: ( state_type * $int ) > $o ).

tff(pred_def_34892,type,
    v64385: ( state_type * $int ) > $o ).

tff(pred_def_34893,type,
    v64379: state_type > $o ).

tff(pred_def_34894,type,
    v64377: state_type > $o ).

tff(pred_def_34895,type,
    v64375: state_type > $o ).

tff(pred_def_34896,type,
    v64373: state_type > $o ).

tff(pred_def_34897,type,
    v64371: state_type > $o ).

tff(pred_def_34898,type,
    v64365: state_type > $o ).

tff(pred_def_34899,type,
    v64363: state_type > $o ).

tff(pred_def_34900,type,
    v64361: state_type > $o ).

tff(pred_def_34901,type,
    v64439: state_type > $o ).

tff(pred_def_34902,type,
    v64437: state_type > $o ).

tff(pred_def_34903,type,
    v64453: ( state_type * $int ) > $o ).

tff(pred_def_34904,type,
    v64451: ( state_type * $int ) > $o ).

tff(pred_def_34905,type,
    v64457: ( state_type * $int ) > $o ).

tff(pred_def_34906,type,
    v64455: ( state_type * $int ) > $o ).

tff(pred_def_34907,type,
    v64449: state_type > $o ).

tff(pred_def_34908,type,
    v64447: state_type > $o ).

tff(pred_def_34909,type,
    v64445: state_type > $o ).

tff(pred_def_34910,type,
    v64443: state_type > $o ).

tff(pred_def_34911,type,
    v64441: state_type > $o ).

tff(pred_def_34912,type,
    v64435: state_type > $o ).

tff(pred_def_34913,type,
    v64433: state_type > $o ).

tff(pred_def_34914,type,
    v64431: state_type > $o ).

tff(pred_def_34915,type,
    v64461: ( state_type * $int ) > $o ).

tff(pred_def_34916,type,
    v64460: ( state_type * $int ) > $o ).

tff(pred_def_34917,type,
    v64462: state_type > $o ).

tff(pred_def_34918,type,
    v64463: state_type > $o ).

tff(pred_def_34919,type,
    v64464: state_type > $o ).

tff(pred_def_34920,type,
    v64465: state_type > $o ).

tff(pred_def_34921,type,
    v64466: state_type > $o ).

tff(pred_def_34922,type,
    v64467: state_type > $o ).

tff(pred_def_34923,type,
    v64468: state_type > $o ).

tff(pred_def_34924,type,
    v64469: state_type > $o ).

tff(pred_def_34925,type,
    v64470: state_type > $o ).

tff(pred_def_34926,type,
    v64471: state_type > $o ).

tff(pred_def_34927,type,
    v64472: state_type > $o ).

tff(pred_def_34928,type,
    v64473: state_type > $o ).

tff(pred_def_34929,type,
    v64474: state_type > $o ).

tff(pred_def_34930,type,
    v64475: state_type > $o ).

tff(pred_def_34931,type,
    v64476: state_type > $o ).

tff(pred_def_34932,type,
    v64477: state_type > $o ).

tff(pred_def_34933,type,
    v64478: state_type > $o ).

tff(pred_def_34934,type,
    v62809: ( state_type * $int ) > $o ).

tff(pred_def_34935,type,
    v62807: ( state_type * $int ) > $o ).

tff(pred_def_34936,type,
    v62805: ( state_type * $int ) > $o ).

tff(pred_def_34937,type,
    v64505: state_type > $o ).

tff(pred_def_34938,type,
    v64503: state_type > $o ).

tff(pred_def_34939,type,
    v64509: state_type > $o ).

tff(pred_def_34940,type,
    v64507: state_type > $o ).

tff(pred_def_34941,type,
    v64501: state_type > $o ).

tff(pred_def_34942,type,
    v64499: state_type > $o ).

tff(pred_def_34943,type,
    v64497: state_type > $o ).

tff(pred_def_34944,type,
    v64495: state_type > $o ).

tff(pred_def_34945,type,
    v64493: state_type > $o ).

tff(pred_def_34946,type,
    v64524: ( state_type * $int ) > $o ).

tff(pred_def_34947,type,
    v64522: ( state_type * $int ) > $o ).

tff(pred_def_34948,type,
    v64528: ( state_type * $int ) > $o ).

tff(pred_def_34949,type,
    v64526: ( state_type * $int ) > $o ).

tff(pred_def_34950,type,
    v64520: state_type > $o ).

tff(pred_def_34951,type,
    v64518: state_type > $o ).

tff(pred_def_34952,type,
    v64516: state_type > $o ).

tff(pred_def_34953,type,
    v64514: state_type > $o ).

tff(pred_def_34954,type,
    v64512: state_type > $o ).

tff(pred_def_34955,type,
    v64491: state_type > $o ).

tff(pred_def_34956,type,
    v64489: state_type > $o ).

tff(pred_def_34957,type,
    v64487: state_type > $o ).

tff(pred_def_34958,type,
    v64540: state_type > $o ).

tff(pred_def_34959,type,
    v64538: state_type > $o ).

tff(pred_def_34960,type,
    v64554: ( state_type * $int ) > $o ).

tff(pred_def_34961,type,
    v64552: ( state_type * $int ) > $o ).

tff(pred_def_34962,type,
    v64558: ( state_type * $int ) > $o ).

tff(pred_def_34963,type,
    v64556: ( state_type * $int ) > $o ).

tff(pred_def_34964,type,
    v64550: state_type > $o ).

tff(pred_def_34965,type,
    v64548: state_type > $o ).

tff(pred_def_34966,type,
    v64546: state_type > $o ).

tff(pred_def_34967,type,
    v64544: state_type > $o ).

tff(pred_def_34968,type,
    v64542: state_type > $o ).

tff(pred_def_34969,type,
    v64536: state_type > $o ).

tff(pred_def_34970,type,
    v64534: state_type > $o ).

tff(pred_def_34971,type,
    v64532: state_type > $o ).

tff(pred_def_34972,type,
    v64570: state_type > $o ).

tff(pred_def_34973,type,
    v64568: state_type > $o ).

tff(pred_def_34974,type,
    v64584: ( state_type * $int ) > $o ).

tff(pred_def_34975,type,
    v64582: ( state_type * $int ) > $o ).

tff(pred_def_34976,type,
    v64588: ( state_type * $int ) > $o ).

tff(pred_def_34977,type,
    v64586: ( state_type * $int ) > $o ).

tff(pred_def_34978,type,
    v64580: state_type > $o ).

tff(pred_def_34979,type,
    v64578: state_type > $o ).

tff(pred_def_34980,type,
    v64576: state_type > $o ).

tff(pred_def_34981,type,
    v64574: state_type > $o ).

tff(pred_def_34982,type,
    v64572: state_type > $o ).

tff(pred_def_34983,type,
    v64566: state_type > $o ).

tff(pred_def_34984,type,
    v64564: state_type > $o ).

tff(pred_def_34985,type,
    v64562: state_type > $o ).

tff(pred_def_34986,type,
    v64600: state_type > $o ).

tff(pred_def_34987,type,
    v64598: state_type > $o ).

tff(pred_def_34988,type,
    v64614: ( state_type * $int ) > $o ).

tff(pred_def_34989,type,
    v64612: ( state_type * $int ) > $o ).

tff(pred_def_34990,type,
    v64618: ( state_type * $int ) > $o ).

tff(pred_def_34991,type,
    v64616: ( state_type * $int ) > $o ).

tff(pred_def_34992,type,
    v64610: state_type > $o ).

tff(pred_def_34993,type,
    v64608: state_type > $o ).

tff(pred_def_34994,type,
    v64606: state_type > $o ).

tff(pred_def_34995,type,
    v64604: state_type > $o ).

tff(pred_def_34996,type,
    v64602: state_type > $o ).

tff(pred_def_34997,type,
    v64596: state_type > $o ).

tff(pred_def_34998,type,
    v64594: state_type > $o ).

tff(pred_def_34999,type,
    v64592: state_type > $o ).

tff(pred_def_35000,type,
    v64630: state_type > $o ).

tff(pred_def_35001,type,
    v64628: state_type > $o ).

tff(pred_def_35002,type,
    v64644: ( state_type * $int ) > $o ).

tff(pred_def_35003,type,
    v64642: ( state_type * $int ) > $o ).

tff(pred_def_35004,type,
    v64648: ( state_type * $int ) > $o ).

tff(pred_def_35005,type,
    v64646: ( state_type * $int ) > $o ).

tff(pred_def_35006,type,
    v64640: state_type > $o ).

tff(pred_def_35007,type,
    v64638: state_type > $o ).

tff(pred_def_35008,type,
    v64636: state_type > $o ).

tff(pred_def_35009,type,
    v64634: state_type > $o ).

tff(pred_def_35010,type,
    v64632: state_type > $o ).

tff(pred_def_35011,type,
    v64626: state_type > $o ).

tff(pred_def_35012,type,
    v64624: state_type > $o ).

tff(pred_def_35013,type,
    v64622: state_type > $o ).

tff(pred_def_35014,type,
    v64660: state_type > $o ).

tff(pred_def_35015,type,
    v64658: state_type > $o ).

tff(pred_def_35016,type,
    v64674: ( state_type * $int ) > $o ).

tff(pred_def_35017,type,
    v64672: ( state_type * $int ) > $o ).

tff(pred_def_35018,type,
    v64678: ( state_type * $int ) > $o ).

tff(pred_def_35019,type,
    v64676: ( state_type * $int ) > $o ).

tff(pred_def_35020,type,
    v64670: state_type > $o ).

tff(pred_def_35021,type,
    v64668: state_type > $o ).

tff(pred_def_35022,type,
    v64666: state_type > $o ).

tff(pred_def_35023,type,
    v64664: state_type > $o ).

tff(pred_def_35024,type,
    v64662: state_type > $o ).

tff(pred_def_35025,type,
    v64656: state_type > $o ).

tff(pred_def_35026,type,
    v64654: state_type > $o ).

tff(pred_def_35027,type,
    v64652: state_type > $o ).

tff(pred_def_35028,type,
    v64690: state_type > $o ).

tff(pred_def_35029,type,
    v64688: state_type > $o ).

tff(pred_def_35030,type,
    v64704: ( state_type * $int ) > $o ).

tff(pred_def_35031,type,
    v64702: ( state_type * $int ) > $o ).

tff(pred_def_35032,type,
    v64708: ( state_type * $int ) > $o ).

tff(pred_def_35033,type,
    v64706: ( state_type * $int ) > $o ).

tff(pred_def_35034,type,
    v64700: state_type > $o ).

tff(pred_def_35035,type,
    v64698: state_type > $o ).

tff(pred_def_35036,type,
    v64696: state_type > $o ).

tff(pred_def_35037,type,
    v64694: state_type > $o ).

tff(pred_def_35038,type,
    v64692: state_type > $o ).

tff(pred_def_35039,type,
    v64686: state_type > $o ).

tff(pred_def_35040,type,
    v64684: state_type > $o ).

tff(pred_def_35041,type,
    v64682: state_type > $o ).

tff(pred_def_35042,type,
    v64720: state_type > $o ).

tff(pred_def_35043,type,
    v64718: state_type > $o ).

tff(pred_def_35044,type,
    v64734: ( state_type * $int ) > $o ).

tff(pred_def_35045,type,
    v64732: ( state_type * $int ) > $o ).

tff(pred_def_35046,type,
    v64738: ( state_type * $int ) > $o ).

tff(pred_def_35047,type,
    v64736: ( state_type * $int ) > $o ).

tff(pred_def_35048,type,
    v64730: state_type > $o ).

tff(pred_def_35049,type,
    v64728: state_type > $o ).

tff(pred_def_35050,type,
    v64726: state_type > $o ).

tff(pred_def_35051,type,
    v64724: state_type > $o ).

tff(pred_def_35052,type,
    v64722: state_type > $o ).

tff(pred_def_35053,type,
    v64716: state_type > $o ).

tff(pred_def_35054,type,
    v64714: state_type > $o ).

tff(pred_def_35055,type,
    v64712: state_type > $o ).

tff(pred_def_35056,type,
    v64750: state_type > $o ).

tff(pred_def_35057,type,
    v64748: state_type > $o ).

tff(pred_def_35058,type,
    v64764: ( state_type * $int ) > $o ).

tff(pred_def_35059,type,
    v64762: ( state_type * $int ) > $o ).

tff(pred_def_35060,type,
    v64768: ( state_type * $int ) > $o ).

tff(pred_def_35061,type,
    v64766: ( state_type * $int ) > $o ).

tff(pred_def_35062,type,
    v64760: state_type > $o ).

tff(pred_def_35063,type,
    v64758: state_type > $o ).

tff(pred_def_35064,type,
    v64756: state_type > $o ).

tff(pred_def_35065,type,
    v64754: state_type > $o ).

tff(pred_def_35066,type,
    v64752: state_type > $o ).

tff(pred_def_35067,type,
    v64746: state_type > $o ).

tff(pred_def_35068,type,
    v64744: state_type > $o ).

tff(pred_def_35069,type,
    v64742: state_type > $o ).

tff(pred_def_35070,type,
    v64780: state_type > $o ).

tff(pred_def_35071,type,
    v64778: state_type > $o ).

tff(pred_def_35072,type,
    v64794: ( state_type * $int ) > $o ).

tff(pred_def_35073,type,
    v64792: ( state_type * $int ) > $o ).

tff(pred_def_35074,type,
    v64798: ( state_type * $int ) > $o ).

tff(pred_def_35075,type,
    v64796: ( state_type * $int ) > $o ).

tff(pred_def_35076,type,
    v64790: state_type > $o ).

tff(pred_def_35077,type,
    v64788: state_type > $o ).

tff(pred_def_35078,type,
    v64786: state_type > $o ).

tff(pred_def_35079,type,
    v64784: state_type > $o ).

tff(pred_def_35080,type,
    v64782: state_type > $o ).

tff(pred_def_35081,type,
    v64776: state_type > $o ).

tff(pred_def_35082,type,
    v64774: state_type > $o ).

tff(pred_def_35083,type,
    v64772: state_type > $o ).

tff(pred_def_35084,type,
    v64810: state_type > $o ).

tff(pred_def_35085,type,
    v64808: state_type > $o ).

tff(pred_def_35086,type,
    v64824: ( state_type * $int ) > $o ).

tff(pred_def_35087,type,
    v64822: ( state_type * $int ) > $o ).

tff(pred_def_35088,type,
    v64828: ( state_type * $int ) > $o ).

tff(pred_def_35089,type,
    v64826: ( state_type * $int ) > $o ).

tff(pred_def_35090,type,
    v64820: state_type > $o ).

tff(pred_def_35091,type,
    v64818: state_type > $o ).

tff(pred_def_35092,type,
    v64816: state_type > $o ).

tff(pred_def_35093,type,
    v64814: state_type > $o ).

tff(pred_def_35094,type,
    v64812: state_type > $o ).

tff(pred_def_35095,type,
    v64806: state_type > $o ).

tff(pred_def_35096,type,
    v64804: state_type > $o ).

tff(pred_def_35097,type,
    v64802: state_type > $o ).

tff(pred_def_35098,type,
    v64840: state_type > $o ).

tff(pred_def_35099,type,
    v64838: state_type > $o ).

tff(pred_def_35100,type,
    v64854: ( state_type * $int ) > $o ).

tff(pred_def_35101,type,
    v64852: ( state_type * $int ) > $o ).

tff(pred_def_35102,type,
    v64858: ( state_type * $int ) > $o ).

tff(pred_def_35103,type,
    v64856: ( state_type * $int ) > $o ).

tff(pred_def_35104,type,
    v64850: state_type > $o ).

tff(pred_def_35105,type,
    v64848: state_type > $o ).

tff(pred_def_35106,type,
    v64846: state_type > $o ).

tff(pred_def_35107,type,
    v64844: state_type > $o ).

tff(pred_def_35108,type,
    v64842: state_type > $o ).

tff(pred_def_35109,type,
    v64836: state_type > $o ).

tff(pred_def_35110,type,
    v64834: state_type > $o ).

tff(pred_def_35111,type,
    v64832: state_type > $o ).

tff(pred_def_35112,type,
    v64870: state_type > $o ).

tff(pred_def_35113,type,
    v64868: state_type > $o ).

tff(pred_def_35114,type,
    v64884: ( state_type * $int ) > $o ).

tff(pred_def_35115,type,
    v64882: ( state_type * $int ) > $o ).

tff(pred_def_35116,type,
    v64888: ( state_type * $int ) > $o ).

tff(pred_def_35117,type,
    v64886: ( state_type * $int ) > $o ).

tff(pred_def_35118,type,
    v64880: state_type > $o ).

tff(pred_def_35119,type,
    v64878: state_type > $o ).

tff(pred_def_35120,type,
    v64876: state_type > $o ).

tff(pred_def_35121,type,
    v64874: state_type > $o ).

tff(pred_def_35122,type,
    v64872: state_type > $o ).

tff(pred_def_35123,type,
    v64866: state_type > $o ).

tff(pred_def_35124,type,
    v64864: state_type > $o ).

tff(pred_def_35125,type,
    v64862: state_type > $o ).

tff(pred_def_35126,type,
    v64900: state_type > $o ).

tff(pred_def_35127,type,
    v64898: state_type > $o ).

tff(pred_def_35128,type,
    v64914: ( state_type * $int ) > $o ).

tff(pred_def_35129,type,
    v64912: ( state_type * $int ) > $o ).

tff(pred_def_35130,type,
    v64918: ( state_type * $int ) > $o ).

tff(pred_def_35131,type,
    v64916: ( state_type * $int ) > $o ).

tff(pred_def_35132,type,
    v64910: state_type > $o ).

tff(pred_def_35133,type,
    v64908: state_type > $o ).

tff(pred_def_35134,type,
    v64906: state_type > $o ).

tff(pred_def_35135,type,
    v64904: state_type > $o ).

tff(pred_def_35136,type,
    v64902: state_type > $o ).

tff(pred_def_35137,type,
    v64896: state_type > $o ).

tff(pred_def_35138,type,
    v64894: state_type > $o ).

tff(pred_def_35139,type,
    v64892: state_type > $o ).

tff(pred_def_35140,type,
    v64930: state_type > $o ).

tff(pred_def_35141,type,
    v64928: state_type > $o ).

tff(pred_def_35142,type,
    v64944: ( state_type * $int ) > $o ).

tff(pred_def_35143,type,
    v64942: ( state_type * $int ) > $o ).

tff(pred_def_35144,type,
    v64948: ( state_type * $int ) > $o ).

tff(pred_def_35145,type,
    v64946: ( state_type * $int ) > $o ).

tff(pred_def_35146,type,
    v64940: state_type > $o ).

tff(pred_def_35147,type,
    v64938: state_type > $o ).

tff(pred_def_35148,type,
    v64936: state_type > $o ).

tff(pred_def_35149,type,
    v64934: state_type > $o ).

tff(pred_def_35150,type,
    v64932: state_type > $o ).

tff(pred_def_35151,type,
    v64926: state_type > $o ).

tff(pred_def_35152,type,
    v64924: state_type > $o ).

tff(pred_def_35153,type,
    v64922: state_type > $o ).

tff(pred_def_35154,type,
    v64485: ( state_type * $int ) > $o ).

tff(pred_def_35155,type,
    v64483: ( state_type * $int ) > $o ).

tff(pred_def_35156,type,
    v64481: ( state_type * $int ) > $o ).

tff(pred_def_35157,type,
    v62803: state_type > $o ).

tff(pred_def_35158,type,
    v62801: state_type > $o ).

tff(pred_def_35159,type,
    v62799: state_type > $o ).

tff(pred_def_35160,type,
    v62797: state_type > $o ).

tff(pred_def_35161,type,
    v62795: state_type > $o ).

tff(pred_def_35162,type,
    v62793: state_type > $o ).

tff(pred_def_35163,type,
    v62791: state_type > $o ).

tff(pred_def_35164,type,
    v62789: state_type > $o ).

tff(pred_def_35165,type,
    v62787: state_type > $o ).

tff(pred_def_35166,type,
    v62785: state_type > $o ).

tff(pred_def_35167,type,
    v62741: state_type > $o ).

tff(pred_def_35168,type,
    v62739: state_type > $o ).

tff(pred_def_35169,type,
    v62737: state_type > $o ).

tff(pred_def_35170,type,
    v62735: state_type > $o ).

tff(pred_def_35171,type,
    v62733: state_type > $o ).

tff(pred_def_35172,type,
    v64985: state_type > $o ).

tff(pred_def_35173,type,
    v64983: state_type > $o ).

tff(pred_def_35174,type,
    v64989: state_type > $o ).

tff(pred_def_35175,type,
    v64987: state_type > $o ).

tff(pred_def_35176,type,
    v64993: state_type > $o ).

tff(pred_def_35177,type,
    v64991: state_type > $o ).

tff(pred_def_35178,type,
    v64997: state_type > $o ).

tff(pred_def_35179,type,
    v64995: state_type > $o ).

tff(pred_def_35180,type,
    v65001: state_type > $o ).

tff(pred_def_35181,type,
    v65000: state_type > $o ).

tff(pred_def_35182,type,
    v64999: state_type > $o ).

tff(pred_def_35183,type,
    v64981: state_type > $o ).

tff(pred_def_35184,type,
    v64979: state_type > $o ).

tff(pred_def_35185,type,
    v64977: state_type > $o ).

tff(pred_def_35186,type,
    v64975: state_type > $o ).

tff(pred_def_35187,type,
    v65005: state_type > $o ).

tff(pred_def_35188,type,
    v65003: state_type > $o ).

tff(pred_def_35189,type,
    v65007: state_type > $o ).

tff(pred_def_35190,type,
    v64973: state_type > $o ).

tff(pred_def_35191,type,
    v64971: state_type > $o ).

tff(pred_def_35192,type,
    v64969: state_type > $o ).

tff(pred_def_35193,type,
    v64967: state_type > $o ).

tff(pred_def_35194,type,
    v65050: state_type > $o ).

tff(pred_def_35195,type,
    v65048: state_type > $o ).

tff(pred_def_35196,type,
    v65054: state_type > $o ).

tff(pred_def_35197,type,
    v65052: state_type > $o ).

tff(pred_def_35198,type,
    v65046: state_type > $o ).

tff(pred_def_35199,type,
    v65044: state_type > $o ).

tff(pred_def_35200,type,
    v65042: state_type > $o ).

tff(pred_def_35201,type,
    v65040: state_type > $o ).

tff(pred_def_35202,type,
    v65038: state_type > $o ).

tff(pred_def_35203,type,
    v65069: ( state_type * $int ) > $o ).

tff(pred_def_35204,type,
    v65067: ( state_type * $int ) > $o ).

tff(pred_def_35205,type,
    v65112: state_type > $o ).

tff(pred_def_35206,type,
    v65110: state_type > $o ).

tff(pred_def_35207,type,
    v65108: state_type > $o ).

tff(pred_def_35208,type,
    v65106: state_type > $o ).

tff(pred_def_35209,type,
    v65104: state_type > $o ).

tff(pred_def_35210,type,
    v65102: state_type > $o ).

tff(pred_def_35211,type,
    v65100: state_type > $o ).

tff(pred_def_35212,type,
    v65098: state_type > $o ).

tff(pred_def_35213,type,
    v65096: state_type > $o ).

tff(pred_def_35214,type,
    v65093: state_type > $o ).

tff(pred_def_35215,type,
    v65091: state_type > $o ).

tff(pred_def_35216,type,
    v65137: state_type > $o ).

tff(pred_def_35217,type,
    v65135: state_type > $o ).

tff(pred_def_35218,type,
    v65133: state_type > $o ).

tff(pred_def_35219,type,
    v65131: state_type > $o ).

tff(pred_def_35220,type,
    v65129: state_type > $o ).

tff(pred_def_35221,type,
    v65127: state_type > $o ).

tff(pred_def_35222,type,
    v65125: state_type > $o ).

tff(pred_def_35223,type,
    v65123: state_type > $o ).

tff(pred_def_35224,type,
    v65121: state_type > $o ).

tff(pred_def_35225,type,
    v65118: state_type > $o ).

tff(pred_def_35226,type,
    v65116: state_type > $o ).

tff(pred_def_35227,type,
    v65162: state_type > $o ).

tff(pred_def_35228,type,
    v65160: state_type > $o ).

tff(pred_def_35229,type,
    v65158: state_type > $o ).

tff(pred_def_35230,type,
    v65156: state_type > $o ).

tff(pred_def_35231,type,
    v65154: state_type > $o ).

tff(pred_def_35232,type,
    v65152: state_type > $o ).

tff(pred_def_35233,type,
    v65150: state_type > $o ).

tff(pred_def_35234,type,
    v65148: state_type > $o ).

tff(pred_def_35235,type,
    v65146: state_type > $o ).

tff(pred_def_35236,type,
    v65143: state_type > $o ).

tff(pred_def_35237,type,
    v65141: state_type > $o ).

tff(pred_def_35238,type,
    v65166: state_type > $o ).

tff(pred_def_35239,type,
    v65089: state_type > $o ).

tff(pred_def_35240,type,
    v65087: state_type > $o ).

tff(pred_def_35241,type,
    v65174: state_type > $o ).

tff(pred_def_35242,type,
    v65172: state_type > $o ).

tff(pred_def_35243,type,
    v65178: state_type > $o ).

tff(pred_def_35244,type,
    v65176: state_type > $o ).

tff(pred_def_35245,type,
    v65170: state_type > $o ).

tff(pred_def_35246,type,
    v65168: state_type > $o ).

tff(pred_def_35247,type,
    v65187: state_type > $o ).

tff(pred_def_35248,type,
    v65185: state_type > $o ).

tff(pred_def_35249,type,
    v65183: state_type > $o ).

tff(pred_def_35250,type,
    v65181: state_type > $o ).

tff(pred_def_35251,type,
    v65205: state_type > $o ).

tff(pred_def_35252,type,
    v65203: state_type > $o ).

tff(pred_def_35253,type,
    v65209: state_type > $o ).

tff(pred_def_35254,type,
    v65207: state_type > $o ).

tff(pred_def_35255,type,
    v65213: state_type > $o ).

tff(pred_def_35256,type,
    v65211: state_type > $o ).

tff(pred_def_35257,type,
    v65215: state_type > $o ).

tff(pred_def_35258,type,
    v65201: state_type > $o ).

tff(pred_def_35259,type,
    v65199: state_type > $o ).

tff(pred_def_35260,type,
    v65197: state_type > $o ).

tff(pred_def_35261,type,
    v65195: state_type > $o ).

tff(pred_def_35262,type,
    v65193: state_type > $o ).

tff(pred_def_35263,type,
    v65238: state_type > $o ).

tff(pred_def_35264,type,
    v65236: state_type > $o ).

tff(pred_def_35265,type,
    v65234: state_type > $o ).

tff(pred_def_35266,type,
    v65232: state_type > $o ).

tff(pred_def_35267,type,
    v65230: state_type > $o ).

tff(pred_def_35268,type,
    v65228: state_type > $o ).

tff(pred_def_35269,type,
    v65226: state_type > $o ).

tff(pred_def_35270,type,
    v65224: state_type > $o ).

tff(pred_def_35271,type,
    v65222: state_type > $o ).

tff(pred_def_35272,type,
    v65219: state_type > $o ).

tff(pred_def_35273,type,
    v65217: state_type > $o ).

tff(pred_def_35274,type,
    v65191: state_type > $o ).

tff(pred_def_35275,type,
    v65189: state_type > $o ).

tff(pred_def_35276,type,
    v65085: ( state_type * $int ) > $o ).

tff(pred_def_35277,type,
    v65242: ( state_type * $int ) > $o ).

tff(pred_def_35278,type,
    v65243: ( state_type * $int ) > $o ).

tff(pred_def_35279,type,
    v65244: ( state_type * $int ) > $o ).

tff(pred_def_35280,type,
    v65245: ( state_type * $int ) > $o ).

tff(pred_def_35281,type,
    v65246: ( state_type * $int ) > $o ).

tff(pred_def_35282,type,
    v65247: ( state_type * $int ) > $o ).

tff(pred_def_35283,type,
    v65248: ( state_type * $int ) > $o ).

tff(pred_def_35284,type,
    v65249: ( state_type * $int ) > $o ).

tff(pred_def_35285,type,
    v65250: ( state_type * $int ) > $o ).

tff(pred_def_35286,type,
    v65251: ( state_type * $int ) > $o ).

tff(pred_def_35287,type,
    v65252: ( state_type * $int ) > $o ).

tff(pred_def_35288,type,
    v65253: ( state_type * $int ) > $o ).

tff(pred_def_35289,type,
    v65254: ( state_type * $int ) > $o ).

tff(pred_def_35290,type,
    v65255: ( state_type * $int ) > $o ).

tff(pred_def_35291,type,
    v65083: ( state_type * $int ) > $o ).

tff(pred_def_35292,type,
    v65081: ( state_type * $int ) > $o ).

tff(pred_def_35293,type,
    v65079: ( state_type * $int ) > $o ).

tff(pred_def_35294,type,
    v65077: ( state_type * $int ) > $o ).

tff(pred_def_35295,type,
    v65075: ( state_type * $int ) > $o ).

tff(pred_def_35296,type,
    v65073: ( state_type * $int ) > $o ).

tff(pred_def_35297,type,
    v65071: ( state_type * $int ) > $o ).

tff(pred_def_35298,type,
    v65065: state_type > $o ).

tff(pred_def_35299,type,
    v65063: state_type > $o ).

tff(pred_def_35300,type,
    v65061: state_type > $o ).

tff(pred_def_35301,type,
    v65059: state_type > $o ).

tff(pred_def_35302,type,
    v65057: state_type > $o ).

tff(pred_def_35303,type,
    v65036: state_type > $o ).

tff(pred_def_35304,type,
    v65034: state_type > $o ).

tff(pred_def_35305,type,
    v65266: state_type > $o ).

tff(pred_def_35306,type,
    v65264: state_type > $o ).

tff(pred_def_35307,type,
    v65280: ( state_type * $int ) > $o ).

tff(pred_def_35308,type,
    v65278: ( state_type * $int ) > $o ).

tff(pred_def_35309,type,
    v65305: state_type > $o ).

tff(pred_def_35310,type,
    v65303: state_type > $o ).

tff(pred_def_35311,type,
    v65309: state_type > $o ).

tff(pred_def_35312,type,
    v65307: state_type > $o ).

tff(pred_def_35313,type,
    v65313: state_type > $o ).

tff(pred_def_35314,type,
    v65311: state_type > $o ).

tff(pred_def_35315,type,
    v65315: state_type > $o ).

tff(pred_def_35316,type,
    v65301: state_type > $o ).

tff(pred_def_35317,type,
    v65299: state_type > $o ).

tff(pred_def_35318,type,
    v65297: state_type > $o ).

tff(pred_def_35319,type,
    v65295: state_type > $o ).

tff(pred_def_35320,type,
    v65293: state_type > $o ).

tff(pred_def_35321,type,
    v65319: state_type > $o ).

tff(pred_def_35322,type,
    v65317: state_type > $o ).

tff(pred_def_35323,type,
    v65291: state_type > $o ).

tff(pred_def_35324,type,
    v65289: state_type > $o ).

tff(pred_def_35325,type,
    v65328: state_type > $o ).

tff(pred_def_35326,type,
    v65326: state_type > $o ).

tff(pred_def_35327,type,
    v65332: state_type > $o ).

tff(pred_def_35328,type,
    v65330: state_type > $o ).

tff(pred_def_35329,type,
    v65336: state_type > $o ).

tff(pred_def_35330,type,
    v65334: state_type > $o ).

tff(pred_def_35331,type,
    v65338: state_type > $o ).

tff(pred_def_35332,type,
    v65324: state_type > $o ).

tff(pred_def_35333,type,
    v65322: state_type > $o ).

tff(pred_def_35334,type,
    v65346: state_type > $o ).

tff(pred_def_35335,type,
    v65344: state_type > $o ).

tff(pred_def_35336,type,
    v65350: state_type > $o ).

tff(pred_def_35337,type,
    v65348: state_type > $o ).

tff(pred_def_35338,type,
    v65342: state_type > $o ).

tff(pred_def_35339,type,
    v65340: state_type > $o ).

tff(pred_def_35340,type,
    v65359: state_type > $o ).

tff(pred_def_35341,type,
    v65357: state_type > $o ).

tff(pred_def_35342,type,
    v65363: state_type > $o ).

tff(pred_def_35343,type,
    v65361: state_type > $o ).

tff(pred_def_35344,type,
    v65367: state_type > $o ).

tff(pred_def_35345,type,
    v65365: state_type > $o ).

tff(pred_def_35346,type,
    v65369: state_type > $o ).

tff(pred_def_35347,type,
    v65355: state_type > $o ).

tff(pred_def_35348,type,
    v65353: state_type > $o ).

tff(pred_def_35349,type,
    v65286: ( state_type * $int ) > $o ).

tff(pred_def_35350,type,
    v65284: ( state_type * $int ) > $o ).

tff(pred_def_35351,type,
    v65282: ( state_type * $int ) > $o ).

tff(pred_def_35352,type,
    v65276: state_type > $o ).

tff(pred_def_35353,type,
    v65274: state_type > $o ).

tff(pred_def_35354,type,
    v65272: state_type > $o ).

tff(pred_def_35355,type,
    v65270: state_type > $o ).

tff(pred_def_35356,type,
    v65268: state_type > $o ).

tff(pred_def_35357,type,
    v65262: state_type > $o ).

tff(pred_def_35358,type,
    v65260: state_type > $o ).

tff(pred_def_35359,type,
    v65380: state_type > $o ).

tff(pred_def_35360,type,
    v65378: state_type > $o ).

tff(pred_def_35361,type,
    v65394: ( state_type * $int ) > $o ).

tff(pred_def_35362,type,
    v65392: ( state_type * $int ) > $o ).

tff(pred_def_35363,type,
    v65418: state_type > $o ).

tff(pred_def_35364,type,
    v65416: state_type > $o ).

tff(pred_def_35365,type,
    v65414: state_type > $o ).

tff(pred_def_35366,type,
    v65412: state_type > $o ).

tff(pred_def_35367,type,
    v65409: state_type > $o ).

tff(pred_def_35368,type,
    v65407: state_type > $o ).

tff(pred_def_35369,type,
    v65432: state_type > $o ).

tff(pred_def_35370,type,
    v65430: state_type > $o ).

tff(pred_def_35371,type,
    v65428: state_type > $o ).

tff(pred_def_35372,type,
    v65426: state_type > $o ).

tff(pred_def_35373,type,
    v65423: state_type > $o ).

tff(pred_def_35374,type,
    v65421: state_type > $o ).

tff(pred_def_35375,type,
    v65405: state_type > $o ).

tff(pred_def_35376,type,
    v65403: state_type > $o ).

tff(pred_def_35377,type,
    v65442: state_type > $o ).

tff(pred_def_35378,type,
    v65440: state_type > $o ).

tff(pred_def_35379,type,
    v65438: state_type > $o ).

tff(pred_def_35380,type,
    v65436: state_type > $o ).

tff(pred_def_35381,type,
    v65459: state_type > $o ).

tff(pred_def_35382,type,
    v65457: state_type > $o ).

tff(pred_def_35383,type,
    v65455: state_type > $o ).

tff(pred_def_35384,type,
    v65453: state_type > $o ).

tff(pred_def_35385,type,
    v65450: state_type > $o ).

tff(pred_def_35386,type,
    v65448: state_type > $o ).

tff(pred_def_35387,type,
    v65446: state_type > $o ).

tff(pred_def_35388,type,
    v65444: state_type > $o ).

tff(pred_def_35389,type,
    v65468: state_type > $o ).

tff(pred_def_35390,type,
    v65466: state_type > $o ).

tff(pred_def_35391,type,
    v65472: state_type > $o ).

tff(pred_def_35392,type,
    v65470: state_type > $o ).

tff(pred_def_35393,type,
    v65485: state_type > $o ).

tff(pred_def_35394,type,
    v65483: state_type > $o ).

tff(pred_def_35395,type,
    v65481: state_type > $o ).

tff(pred_def_35396,type,
    v65479: state_type > $o ).

tff(pred_def_35397,type,
    v65476: state_type > $o ).

tff(pred_def_35398,type,
    v65474: state_type > $o ).

tff(pred_def_35399,type,
    v65488: state_type > $o ).

tff(pred_def_35400,type,
    v65464: state_type > $o ).

tff(pred_def_35401,type,
    v65462: state_type > $o ).

tff(pred_def_35402,type,
    v65400: ( state_type * $int ) > $o ).

tff(pred_def_35403,type,
    v65398: ( state_type * $int ) > $o ).

tff(pred_def_35404,type,
    v65396: ( state_type * $int ) > $o ).

tff(pred_def_35405,type,
    v65390: state_type > $o ).

tff(pred_def_35406,type,
    v65388: state_type > $o ).

tff(pred_def_35407,type,
    v65386: state_type > $o ).

tff(pred_def_35408,type,
    v65384: state_type > $o ).

tff(pred_def_35409,type,
    v65382: state_type > $o ).

tff(pred_def_35410,type,
    v65376: state_type > $o ).

tff(pred_def_35411,type,
    v65374: state_type > $o ).

tff(pred_def_35412,type,
    v65499: state_type > $o ).

tff(pred_def_35413,type,
    v65497: state_type > $o ).

tff(pred_def_35414,type,
    v65513: ( state_type * $int ) > $o ).

tff(pred_def_35415,type,
    v65511: ( state_type * $int ) > $o ).

tff(pred_def_35416,type,
    v65528: state_type > $o ).

tff(pred_def_35417,type,
    v65526: state_type > $o ).

tff(pred_def_35418,type,
    v65532: state_type > $o ).

tff(pred_def_35419,type,
    v65530: state_type > $o ).

tff(pred_def_35420,type,
    v65536: state_type > $o ).

tff(pred_def_35421,type,
    v65534: state_type > $o ).

tff(pred_def_35422,type,
    v65538: state_type > $o ).

tff(pred_def_35423,type,
    v65524: state_type > $o ).

tff(pred_def_35424,type,
    v65522: state_type > $o ).

tff(pred_def_35425,type,
    v65546: state_type > $o ).

tff(pred_def_35426,type,
    v65544: state_type > $o ).

tff(pred_def_35427,type,
    v65550: state_type > $o ).

tff(pred_def_35428,type,
    v65548: state_type > $o ).

tff(pred_def_35429,type,
    v65542: state_type > $o ).

tff(pred_def_35430,type,
    v65540: state_type > $o ).

tff(pred_def_35431,type,
    v65559: state_type > $o ).

tff(pred_def_35432,type,
    v65557: state_type > $o ).

tff(pred_def_35433,type,
    v65563: state_type > $o ).

tff(pred_def_35434,type,
    v65561: state_type > $o ).

tff(pred_def_35435,type,
    v65555: state_type > $o ).

tff(pred_def_35436,type,
    v65553: state_type > $o ).

tff(pred_def_35437,type,
    v65572: state_type > $o ).

tff(pred_def_35438,type,
    v65570: state_type > $o ).

tff(pred_def_35439,type,
    v65576: state_type > $o ).

tff(pred_def_35440,type,
    v65574: state_type > $o ).

tff(pred_def_35441,type,
    v65568: state_type > $o ).

tff(pred_def_35442,type,
    v65566: state_type > $o ).

tff(pred_def_35443,type,
    v65519: ( state_type * $int ) > $o ).

tff(pred_def_35444,type,
    v65517: ( state_type * $int ) > $o ).

tff(pred_def_35445,type,
    v65515: ( state_type * $int ) > $o ).

tff(pred_def_35446,type,
    v65509: state_type > $o ).

tff(pred_def_35447,type,
    v65507: state_type > $o ).

tff(pred_def_35448,type,
    v65505: state_type > $o ).

tff(pred_def_35449,type,
    v65503: state_type > $o ).

tff(pred_def_35450,type,
    v65501: state_type > $o ).

tff(pred_def_35451,type,
    v65495: state_type > $o ).

tff(pred_def_35452,type,
    v65493: state_type > $o ).

tff(pred_def_35453,type,
    v65588: state_type > $o ).

tff(pred_def_35454,type,
    v65586: state_type > $o ).

tff(pred_def_35455,type,
    v65602: ( state_type * $int ) > $o ).

tff(pred_def_35456,type,
    v65600: ( state_type * $int ) > $o ).

tff(pred_def_35457,type,
    v65617: state_type > $o ).

tff(pred_def_35458,type,
    v65615: state_type > $o ).

tff(pred_def_35459,type,
    v65621: state_type > $o ).

tff(pred_def_35460,type,
    v65619: state_type > $o ).

tff(pred_def_35461,type,
    v65613: state_type > $o ).

tff(pred_def_35462,type,
    v65611: state_type > $o ).

tff(pred_def_35463,type,
    v65630: state_type > $o ).

tff(pred_def_35464,type,
    v65628: state_type > $o ).

tff(pred_def_35465,type,
    v65634: state_type > $o ).

tff(pred_def_35466,type,
    v65632: state_type > $o ).

tff(pred_def_35467,type,
    v65626: state_type > $o ).

tff(pred_def_35468,type,
    v65624: state_type > $o ).

tff(pred_def_35469,type,
    v65643: state_type > $o ).

tff(pred_def_35470,type,
    v65641: state_type > $o ).

tff(pred_def_35471,type,
    v65647: state_type > $o ).

tff(pred_def_35472,type,
    v65645: state_type > $o ).

tff(pred_def_35473,type,
    v65651: state_type > $o ).

tff(pred_def_35474,type,
    v65649: state_type > $o ).

tff(pred_def_35475,type,
    v65653: state_type > $o ).

tff(pred_def_35476,type,
    v65639: state_type > $o ).

tff(pred_def_35477,type,
    v65637: state_type > $o ).

tff(pred_def_35478,type,
    v65661: state_type > $o ).

tff(pred_def_35479,type,
    v65659: state_type > $o ).

tff(pred_def_35480,type,
    v65665: state_type > $o ).

tff(pred_def_35481,type,
    v65663: state_type > $o ).

tff(pred_def_35482,type,
    v65669: state_type > $o ).

tff(pred_def_35483,type,
    v65667: state_type > $o ).

tff(pred_def_35484,type,
    v65671: state_type > $o ).

tff(pred_def_35485,type,
    v65657: state_type > $o ).

tff(pred_def_35486,type,
    v65655: state_type > $o ).

tff(pred_def_35487,type,
    v65608: ( state_type * $int ) > $o ).

tff(pred_def_35488,type,
    v65606: ( state_type * $int ) > $o ).

tff(pred_def_35489,type,
    v65604: ( state_type * $int ) > $o ).

tff(pred_def_35490,type,
    v65598: state_type > $o ).

tff(pred_def_35491,type,
    v65596: state_type > $o ).

tff(pred_def_35492,type,
    v65594: state_type > $o ).

tff(pred_def_35493,type,
    v65592: state_type > $o ).

tff(pred_def_35494,type,
    v65590: state_type > $o ).

tff(pred_def_35495,type,
    v65584: state_type > $o ).

tff(pred_def_35496,type,
    v65582: state_type > $o ).

tff(pred_def_35497,type,
    v65682: state_type > $o ).

tff(pred_def_35498,type,
    v65680: state_type > $o ).

tff(pred_def_35499,type,
    v65696: ( state_type * $int ) > $o ).

tff(pred_def_35500,type,
    v65694: ( state_type * $int ) > $o ).

tff(pred_def_35501,type,
    v65711: state_type > $o ).

tff(pred_def_35502,type,
    v65709: state_type > $o ).

tff(pred_def_35503,type,
    v65715: state_type > $o ).

tff(pred_def_35504,type,
    v65713: state_type > $o ).

tff(pred_def_35505,type,
    v65719: state_type > $o ).

tff(pred_def_35506,type,
    v65717: state_type > $o ).

tff(pred_def_35507,type,
    v65721: state_type > $o ).

tff(pred_def_35508,type,
    v65707: state_type > $o ).

tff(pred_def_35509,type,
    v65705: state_type > $o ).

tff(pred_def_35510,type,
    v65729: state_type > $o ).

tff(pred_def_35511,type,
    v65727: state_type > $o ).

tff(pred_def_35512,type,
    v65733: state_type > $o ).

tff(pred_def_35513,type,
    v65731: state_type > $o ).

tff(pred_def_35514,type,
    v65737: state_type > $o ).

tff(pred_def_35515,type,
    v65735: state_type > $o ).

tff(pred_def_35516,type,
    v65739: state_type > $o ).

tff(pred_def_35517,type,
    v65725: state_type > $o ).

tff(pred_def_35518,type,
    v65723: state_type > $o ).

tff(pred_def_35519,type,
    v65757: state_type > $o ).

tff(pred_def_35520,type,
    v65755: state_type > $o ).

tff(pred_def_35521,type,
    v65761: state_type > $o ).

tff(pred_def_35522,type,
    v65759: state_type > $o ).

tff(pred_def_35523,type,
    v65765: state_type > $o ).

tff(pred_def_35524,type,
    v65763: state_type > $o ).

tff(pred_def_35525,type,
    v65767: state_type > $o ).

tff(pred_def_35526,type,
    v65753: state_type > $o ).

tff(pred_def_35527,type,
    v65751: state_type > $o ).

tff(pred_def_35528,type,
    v65749: state_type > $o ).

tff(pred_def_35529,type,
    v65747: state_type > $o ).

tff(pred_def_35530,type,
    v65745: state_type > $o ).

tff(pred_def_35531,type,
    v65771: state_type > $o ).

tff(pred_def_35532,type,
    v65769: state_type > $o ).

tff(pred_def_35533,type,
    v65743: state_type > $o ).

tff(pred_def_35534,type,
    v65741: state_type > $o ).

tff(pred_def_35535,type,
    v65780: state_type > $o ).

tff(pred_def_35536,type,
    v65778: state_type > $o ).

tff(pred_def_35537,type,
    v65784: state_type > $o ).

tff(pred_def_35538,type,
    v65782: state_type > $o ).

tff(pred_def_35539,type,
    v65776: state_type > $o ).

tff(pred_def_35540,type,
    v65774: state_type > $o ).

tff(pred_def_35541,type,
    v65702: ( state_type * $int ) > $o ).

tff(pred_def_35542,type,
    v65700: ( state_type * $int ) > $o ).

tff(pred_def_35543,type,
    v65698: ( state_type * $int ) > $o ).

tff(pred_def_35544,type,
    v65692: state_type > $o ).

tff(pred_def_35545,type,
    v65690: state_type > $o ).

tff(pred_def_35546,type,
    v65688: state_type > $o ).

tff(pred_def_35547,type,
    v65686: state_type > $o ).

tff(pred_def_35548,type,
    v65684: state_type > $o ).

tff(pred_def_35549,type,
    v65678: state_type > $o ).

tff(pred_def_35550,type,
    v65676: state_type > $o ).

tff(pred_def_35551,type,
    v65796: state_type > $o ).

tff(pred_def_35552,type,
    v65794: state_type > $o ).

tff(pred_def_35553,type,
    v65810: ( state_type * $int ) > $o ).

tff(pred_def_35554,type,
    v65808: ( state_type * $int ) > $o ).

tff(pred_def_35555,type,
    v65834: state_type > $o ).

tff(pred_def_35556,type,
    v65832: state_type > $o ).

tff(pred_def_35557,type,
    v65830: state_type > $o ).

tff(pred_def_35558,type,
    v65828: state_type > $o ).

tff(pred_def_35559,type,
    v65825: state_type > $o ).

tff(pred_def_35560,type,
    v65823: state_type > $o ).

tff(pred_def_35561,type,
    v65821: state_type > $o ).

tff(pred_def_35562,type,
    v65819: state_type > $o ).

tff(pred_def_35563,type,
    v65852: state_type > $o ).

tff(pred_def_35564,type,
    v65850: state_type > $o ).

tff(pred_def_35565,type,
    v65848: state_type > $o ).

tff(pred_def_35566,type,
    v65846: state_type > $o ).

tff(pred_def_35567,type,
    v65843: state_type > $o ).

tff(pred_def_35568,type,
    v65841: state_type > $o ).

tff(pred_def_35569,type,
    v65839: state_type > $o ).

tff(pred_def_35570,type,
    v65837: state_type > $o ).

tff(pred_def_35571,type,
    v65870: state_type > $o ).

tff(pred_def_35572,type,
    v65868: state_type > $o ).

tff(pred_def_35573,type,
    v65866: state_type > $o ).

tff(pred_def_35574,type,
    v65864: state_type > $o ).

tff(pred_def_35575,type,
    v65861: state_type > $o ).

tff(pred_def_35576,type,
    v65859: state_type > $o ).

tff(pred_def_35577,type,
    v65857: state_type > $o ).

tff(pred_def_35578,type,
    v65855: state_type > $o ).

tff(pred_def_35579,type,
    v65879: state_type > $o ).

tff(pred_def_35580,type,
    v65877: state_type > $o ).

tff(pred_def_35581,type,
    v65892: state_type > $o ).

tff(pred_def_35582,type,
    v65890: state_type > $o ).

tff(pred_def_35583,type,
    v65888: state_type > $o ).

tff(pred_def_35584,type,
    v65886: state_type > $o ).

tff(pred_def_35585,type,
    v65883: state_type > $o ).

tff(pred_def_35586,type,
    v65881: state_type > $o ).

tff(pred_def_35587,type,
    v65875: state_type > $o ).

tff(pred_def_35588,type,
    v65873: state_type > $o ).

tff(pred_def_35589,type,
    v65816: ( state_type * $int ) > $o ).

tff(pred_def_35590,type,
    v65814: ( state_type * $int ) > $o ).

tff(pred_def_35591,type,
    v65812: ( state_type * $int ) > $o ).

tff(pred_def_35592,type,
    v65806: state_type > $o ).

tff(pred_def_35593,type,
    v65804: state_type > $o ).

tff(pred_def_35594,type,
    v65802: state_type > $o ).

tff(pred_def_35595,type,
    v65800: state_type > $o ).

tff(pred_def_35596,type,
    v65798: state_type > $o ).

tff(pred_def_35597,type,
    v65792: state_type > $o ).

tff(pred_def_35598,type,
    v65790: state_type > $o ).

tff(pred_def_35599,type,
    v65905: state_type > $o ).

tff(pred_def_35600,type,
    v65903: state_type > $o ).

tff(pred_def_35601,type,
    v65919: ( state_type * $int ) > $o ).

tff(pred_def_35602,type,
    v65917: ( state_type * $int ) > $o ).

tff(pred_def_35603,type,
    v65934: state_type > $o ).

tff(pred_def_35604,type,
    v65932: state_type > $o ).

tff(pred_def_35605,type,
    v65938: state_type > $o ).

tff(pred_def_35606,type,
    v65936: state_type > $o ).

tff(pred_def_35607,type,
    v65930: state_type > $o ).

tff(pred_def_35608,type,
    v65928: state_type > $o ).

tff(pred_def_35609,type,
    v65947: state_type > $o ).

tff(pred_def_35610,type,
    v65945: state_type > $o ).

tff(pred_def_35611,type,
    v65951: state_type > $o ).

tff(pred_def_35612,type,
    v65949: state_type > $o ).

tff(pred_def_35613,type,
    v65943: state_type > $o ).

tff(pred_def_35614,type,
    v65941: state_type > $o ).

tff(pred_def_35615,type,
    v65960: state_type > $o ).

tff(pred_def_35616,type,
    v65958: state_type > $o ).

tff(pred_def_35617,type,
    v65964: state_type > $o ).

tff(pred_def_35618,type,
    v65962: state_type > $o ).

tff(pred_def_35619,type,
    v65956: state_type > $o ).

tff(pred_def_35620,type,
    v65954: state_type > $o ).

tff(pred_def_35621,type,
    v65973: state_type > $o ).

tff(pred_def_35622,type,
    v65971: state_type > $o ).

tff(pred_def_35623,type,
    v65969: state_type > $o ).

tff(pred_def_35624,type,
    v65967: state_type > $o ).

tff(pred_def_35625,type,
    v65925: ( state_type * $int ) > $o ).

tff(pred_def_35626,type,
    v65923: ( state_type * $int ) > $o ).

tff(pred_def_35627,type,
    v65921: ( state_type * $int ) > $o ).

tff(pred_def_35628,type,
    v65915: state_type > $o ).

tff(pred_def_35629,type,
    v65913: state_type > $o ).

tff(pred_def_35630,type,
    v65911: state_type > $o ).

tff(pred_def_35631,type,
    v65909: state_type > $o ).

tff(pred_def_35632,type,
    v65907: state_type > $o ).

tff(pred_def_35633,type,
    v65901: state_type > $o ).

tff(pred_def_35634,type,
    v65899: state_type > $o ).

tff(pred_def_35635,type,
    v65984: state_type > $o ).

tff(pred_def_35636,type,
    v65982: state_type > $o ).

tff(pred_def_35637,type,
    v65998: ( state_type * $int ) > $o ).

tff(pred_def_35638,type,
    v65996: ( state_type * $int ) > $o ).

tff(pred_def_35639,type,
    v66013: state_type > $o ).

tff(pred_def_35640,type,
    v66011: state_type > $o ).

tff(pred_def_35641,type,
    v66017: state_type > $o ).

tff(pred_def_35642,type,
    v66015: state_type > $o ).

tff(pred_def_35643,type,
    v66021: state_type > $o ).

tff(pred_def_35644,type,
    v66019: state_type > $o ).

tff(pred_def_35645,type,
    v66023: state_type > $o ).

tff(pred_def_35646,type,
    v66009: state_type > $o ).

tff(pred_def_35647,type,
    v66007: state_type > $o ).

tff(pred_def_35648,type,
    v66041: state_type > $o ).

tff(pred_def_35649,type,
    v66039: state_type > $o ).

tff(pred_def_35650,type,
    v66045: state_type > $o ).

tff(pred_def_35651,type,
    v66043: state_type > $o ).

tff(pred_def_35652,type,
    v66049: state_type > $o ).

tff(pred_def_35653,type,
    v66047: state_type > $o ).

tff(pred_def_35654,type,
    v66051: state_type > $o ).

tff(pred_def_35655,type,
    v66037: state_type > $o ).

tff(pred_def_35656,type,
    v66035: state_type > $o ).

tff(pred_def_35657,type,
    v66033: state_type > $o ).

tff(pred_def_35658,type,
    v66031: state_type > $o ).

tff(pred_def_35659,type,
    v66029: state_type > $o ).

tff(pred_def_35660,type,
    v66055: state_type > $o ).

tff(pred_def_35661,type,
    v66053: state_type > $o ).

tff(pred_def_35662,type,
    v66027: state_type > $o ).

tff(pred_def_35663,type,
    v66025: state_type > $o ).

tff(pred_def_35664,type,
    v66064: state_type > $o ).

tff(pred_def_35665,type,
    v66062: state_type > $o ).

tff(pred_def_35666,type,
    v66068: state_type > $o ).

tff(pred_def_35667,type,
    v66066: state_type > $o ).

tff(pred_def_35668,type,
    v66072: state_type > $o ).

tff(pred_def_35669,type,
    v66070: state_type > $o ).

tff(pred_def_35670,type,
    v66074: state_type > $o ).

tff(pred_def_35671,type,
    v66060: state_type > $o ).

tff(pred_def_35672,type,
    v66058: state_type > $o ).

tff(pred_def_35673,type,
    v66082: state_type > $o ).

tff(pred_def_35674,type,
    v66080: state_type > $o ).

tff(pred_def_35675,type,
    v66086: state_type > $o ).

tff(pred_def_35676,type,
    v66084: state_type > $o ).

tff(pred_def_35677,type,
    v66090: state_type > $o ).

tff(pred_def_35678,type,
    v66088: state_type > $o ).

tff(pred_def_35679,type,
    v66092: state_type > $o ).

tff(pred_def_35680,type,
    v66078: state_type > $o ).

tff(pred_def_35681,type,
    v66076: state_type > $o ).

tff(pred_def_35682,type,
    v66004: ( state_type * $int ) > $o ).

tff(pred_def_35683,type,
    v66002: ( state_type * $int ) > $o ).

tff(pred_def_35684,type,
    v66000: ( state_type * $int ) > $o ).

tff(pred_def_35685,type,
    v65994: state_type > $o ).

tff(pred_def_35686,type,
    v65992: state_type > $o ).

tff(pred_def_35687,type,
    v65990: state_type > $o ).

tff(pred_def_35688,type,
    v65988: state_type > $o ).

tff(pred_def_35689,type,
    v65986: state_type > $o ).

tff(pred_def_35690,type,
    v65980: state_type > $o ).

tff(pred_def_35691,type,
    v65978: state_type > $o ).

tff(pred_def_35692,type,
    v66103: state_type > $o ).

tff(pred_def_35693,type,
    v66101: state_type > $o ).

tff(pred_def_35694,type,
    v66117: ( state_type * $int ) > $o ).

tff(pred_def_35695,type,
    v66115: ( state_type * $int ) > $o ).

tff(pred_def_35696,type,
    v66132: state_type > $o ).

tff(pred_def_35697,type,
    v66130: state_type > $o ).

tff(pred_def_35698,type,
    v66136: state_type > $o ).

tff(pred_def_35699,type,
    v66134: state_type > $o ).

tff(pred_def_35700,type,
    v66128: state_type > $o ).

tff(pred_def_35701,type,
    v66126: state_type > $o ).

tff(pred_def_35702,type,
    v66145: state_type > $o ).

tff(pred_def_35703,type,
    v66143: state_type > $o ).

tff(pred_def_35704,type,
    v66149: state_type > $o ).

tff(pred_def_35705,type,
    v66147: state_type > $o ).

tff(pred_def_35706,type,
    v66153: state_type > $o ).

tff(pred_def_35707,type,
    v66151: state_type > $o ).

tff(pred_def_35708,type,
    v66155: state_type > $o ).

tff(pred_def_35709,type,
    v66141: state_type > $o ).

tff(pred_def_35710,type,
    v66139: state_type > $o ).

tff(pred_def_35711,type,
    v66163: state_type > $o ).

tff(pred_def_35712,type,
    v66161: state_type > $o ).

tff(pred_def_35713,type,
    v66167: state_type > $o ).

tff(pred_def_35714,type,
    v66165: state_type > $o ).

tff(pred_def_35715,type,
    v66159: state_type > $o ).

tff(pred_def_35716,type,
    v66157: state_type > $o ).

tff(pred_def_35717,type,
    v66176: state_type > $o ).

tff(pred_def_35718,type,
    v66174: state_type > $o ).

tff(pred_def_35719,type,
    v66180: state_type > $o ).

tff(pred_def_35720,type,
    v66178: state_type > $o ).

tff(pred_def_35721,type,
    v66172: state_type > $o ).

tff(pred_def_35722,type,
    v66170: state_type > $o ).

tff(pred_def_35723,type,
    v66123: ( state_type * $int ) > $o ).

tff(pred_def_35724,type,
    v66121: ( state_type * $int ) > $o ).

tff(pred_def_35725,type,
    v66119: ( state_type * $int ) > $o ).

tff(pred_def_35726,type,
    v66113: state_type > $o ).

tff(pred_def_35727,type,
    v66111: state_type > $o ).

tff(pred_def_35728,type,
    v66109: state_type > $o ).

tff(pred_def_35729,type,
    v66107: state_type > $o ).

tff(pred_def_35730,type,
    v66105: state_type > $o ).

tff(pred_def_35731,type,
    v66099: state_type > $o ).

tff(pred_def_35732,type,
    v66097: state_type > $o ).

tff(pred_def_35733,type,
    v66192: state_type > $o ).

tff(pred_def_35734,type,
    v66190: state_type > $o ).

tff(pred_def_35735,type,
    v66206: ( state_type * $int ) > $o ).

tff(pred_def_35736,type,
    v66204: ( state_type * $int ) > $o ).

tff(pred_def_35737,type,
    v66230: state_type > $o ).

tff(pred_def_35738,type,
    v66228: state_type > $o ).

tff(pred_def_35739,type,
    v66226: state_type > $o ).

tff(pred_def_35740,type,
    v66224: state_type > $o ).

tff(pred_def_35741,type,
    v66221: state_type > $o ).

tff(pred_def_35742,type,
    v66219: state_type > $o ).

tff(pred_def_35743,type,
    v66244: state_type > $o ).

tff(pred_def_35744,type,
    v66242: state_type > $o ).

tff(pred_def_35745,type,
    v66240: state_type > $o ).

tff(pred_def_35746,type,
    v66238: state_type > $o ).

tff(pred_def_35747,type,
    v66235: state_type > $o ).

tff(pred_def_35748,type,
    v66233: state_type > $o ).

tff(pred_def_35749,type,
    v66217: state_type > $o ).

tff(pred_def_35750,type,
    v66215: state_type > $o ).

tff(pred_def_35751,type,
    v66263: state_type > $o ).

tff(pred_def_35752,type,
    v66261: state_type > $o ).

tff(pred_def_35753,type,
    v66259: state_type > $o ).

tff(pred_def_35754,type,
    v66257: state_type > $o ).

tff(pred_def_35755,type,
    v66254: state_type > $o ).

tff(pred_def_35756,type,
    v66252: state_type > $o ).

tff(pred_def_35757,type,
    v66277: state_type > $o ).

tff(pred_def_35758,type,
    v66275: state_type > $o ).

tff(pred_def_35759,type,
    v66273: state_type > $o ).

tff(pred_def_35760,type,
    v66271: state_type > $o ).

tff(pred_def_35761,type,
    v66268: state_type > $o ).

tff(pred_def_35762,type,
    v66266: state_type > $o ).

tff(pred_def_35763,type,
    v66282: state_type > $o ).

tff(pred_def_35764,type,
    v66280: state_type > $o ).

tff(pred_def_35765,type,
    v66284: state_type > $o ).

tff(pred_def_35766,type,
    v66250: state_type > $o ).

tff(pred_def_35767,type,
    v66248: state_type > $o ).

tff(pred_def_35768,type,
    v66292: state_type > $o ).

tff(pred_def_35769,type,
    v66290: state_type > $o ).

tff(pred_def_35770,type,
    v66296: state_type > $o ).

tff(pred_def_35771,type,
    v66294: state_type > $o ).

tff(pred_def_35772,type,
    v66300: state_type > $o ).

tff(pred_def_35773,type,
    v66298: state_type > $o ).

tff(pred_def_35774,type,
    v66302: state_type > $o ).

tff(pred_def_35775,type,
    v66288: state_type > $o ).

tff(pred_def_35776,type,
    v66286: state_type > $o ).

tff(pred_def_35777,type,
    v66310: state_type > $o ).

tff(pred_def_35778,type,
    v66308: state_type > $o ).

tff(pred_def_35779,type,
    v66314: state_type > $o ).

tff(pred_def_35780,type,
    v66312: state_type > $o ).

tff(pred_def_35781,type,
    v66306: state_type > $o ).

tff(pred_def_35782,type,
    v66304: state_type > $o ).

tff(pred_def_35783,type,
    v66212: ( state_type * $int ) > $o ).

tff(pred_def_35784,type,
    v66210: ( state_type * $int ) > $o ).

tff(pred_def_35785,type,
    v66208: ( state_type * $int ) > $o ).

tff(pred_def_35786,type,
    v66202: state_type > $o ).

tff(pred_def_35787,type,
    v66200: state_type > $o ).

tff(pred_def_35788,type,
    v66198: state_type > $o ).

tff(pred_def_35789,type,
    v66196: state_type > $o ).

tff(pred_def_35790,type,
    v66194: state_type > $o ).

tff(pred_def_35791,type,
    v66188: state_type > $o ).

tff(pred_def_35792,type,
    v66186: state_type > $o ).

tff(pred_def_35793,type,
    v66326: state_type > $o ).

tff(pred_def_35794,type,
    v66324: state_type > $o ).

tff(pred_def_35795,type,
    v66340: ( state_type * $int ) > $o ).

tff(pred_def_35796,type,
    v66338: ( state_type * $int ) > $o ).

tff(pred_def_35797,type,
    v66355: state_type > $o ).

tff(pred_def_35798,type,
    v66353: state_type > $o ).

tff(pred_def_35799,type,
    v66351: state_type > $o ).

tff(pred_def_35800,type,
    v66349: state_type > $o ).

tff(pred_def_35801,type,
    v66363: state_type > $o ).

tff(pred_def_35802,type,
    v66361: state_type > $o ).

tff(pred_def_35803,type,
    v66367: state_type > $o ).

tff(pred_def_35804,type,
    v66365: state_type > $o ).

tff(pred_def_35805,type,
    v66359: state_type > $o ).

tff(pred_def_35806,type,
    v66357: state_type > $o ).

tff(pred_def_35807,type,
    v66376: state_type > $o ).

tff(pred_def_35808,type,
    v66374: state_type > $o ).

tff(pred_def_35809,type,
    v66380: state_type > $o ).

tff(pred_def_35810,type,
    v66378: state_type > $o ).

tff(pred_def_35811,type,
    v66372: state_type > $o ).

tff(pred_def_35812,type,
    v66370: state_type > $o ).

tff(pred_def_35813,type,
    v66389: state_type > $o ).

tff(pred_def_35814,type,
    v66387: state_type > $o ).

tff(pred_def_35815,type,
    v66385: state_type > $o ).

tff(pred_def_35816,type,
    v66383: state_type > $o ).

tff(pred_def_35817,type,
    v66346: ( state_type * $int ) > $o ).

tff(pred_def_35818,type,
    v66344: ( state_type * $int ) > $o ).

tff(pred_def_35819,type,
    v66342: ( state_type * $int ) > $o ).

tff(pred_def_35820,type,
    v66336: state_type > $o ).

tff(pred_def_35821,type,
    v66334: state_type > $o ).

tff(pred_def_35822,type,
    v66332: state_type > $o ).

tff(pred_def_35823,type,
    v66330: state_type > $o ).

tff(pred_def_35824,type,
    v66328: state_type > $o ).

tff(pred_def_35825,type,
    v66322: state_type > $o ).

tff(pred_def_35826,type,
    v66320: state_type > $o ).

tff(pred_def_35827,type,
    v66400: state_type > $o ).

tff(pred_def_35828,type,
    v66398: state_type > $o ).

tff(pred_def_35829,type,
    v66414: ( state_type * $int ) > $o ).

tff(pred_def_35830,type,
    v66412: ( state_type * $int ) > $o ).

tff(pred_def_35831,type,
    v66429: state_type > $o ).

tff(pred_def_35832,type,
    v66427: state_type > $o ).

tff(pred_def_35833,type,
    v66433: state_type > $o ).

tff(pred_def_35834,type,
    v66431: state_type > $o ).

tff(pred_def_35835,type,
    v66425: state_type > $o ).

tff(pred_def_35836,type,
    v66423: state_type > $o ).

tff(pred_def_35837,type,
    v66442: state_type > $o ).

tff(pred_def_35838,type,
    v66440: state_type > $o ).

tff(pred_def_35839,type,
    v66446: state_type > $o ).

tff(pred_def_35840,type,
    v66444: state_type > $o ).

tff(pred_def_35841,type,
    v66438: state_type > $o ).

tff(pred_def_35842,type,
    v66436: state_type > $o ).

tff(pred_def_35843,type,
    v66455: state_type > $o ).

tff(pred_def_35844,type,
    v66453: state_type > $o ).

tff(pred_def_35845,type,
    v66459: state_type > $o ).

tff(pred_def_35846,type,
    v66457: state_type > $o ).

tff(pred_def_35847,type,
    v66463: state_type > $o ).

tff(pred_def_35848,type,
    v66461: state_type > $o ).

tff(pred_def_35849,type,
    v66465: state_type > $o ).

tff(pred_def_35850,type,
    v66451: state_type > $o ).

tff(pred_def_35851,type,
    v66449: state_type > $o ).

tff(pred_def_35852,type,
    v66473: state_type > $o ).

tff(pred_def_35853,type,
    v66471: state_type > $o ).

tff(pred_def_35854,type,
    v66477: state_type > $o ).

tff(pred_def_35855,type,
    v66475: state_type > $o ).

tff(pred_def_35856,type,
    v66469: state_type > $o ).

tff(pred_def_35857,type,
    v66467: state_type > $o ).

tff(pred_def_35858,type,
    v66420: ( state_type * $int ) > $o ).

tff(pred_def_35859,type,
    v66418: ( state_type * $int ) > $o ).

tff(pred_def_35860,type,
    v66416: ( state_type * $int ) > $o ).

tff(pred_def_35861,type,
    v66410: state_type > $o ).

tff(pred_def_35862,type,
    v66408: state_type > $o ).

tff(pred_def_35863,type,
    v66406: state_type > $o ).

tff(pred_def_35864,type,
    v66404: state_type > $o ).

tff(pred_def_35865,type,
    v66402: state_type > $o ).

tff(pred_def_35866,type,
    v66396: state_type > $o ).

tff(pred_def_35867,type,
    v66394: state_type > $o ).

tff(pred_def_35868,type,
    v66489: state_type > $o ).

tff(pred_def_35869,type,
    v66487: state_type > $o ).

tff(pred_def_35870,type,
    v66503: ( state_type * $int ) > $o ).

tff(pred_def_35871,type,
    v66501: ( state_type * $int ) > $o ).

tff(pred_def_35872,type,
    v66518: state_type > $o ).

tff(pred_def_35873,type,
    v66516: state_type > $o ).

tff(pred_def_35874,type,
    v66514: state_type > $o ).

tff(pred_def_35875,type,
    v66512: state_type > $o ).

tff(pred_def_35876,type,
    v66526: state_type > $o ).

tff(pred_def_35877,type,
    v66524: state_type > $o ).

tff(pred_def_35878,type,
    v66522: state_type > $o ).

tff(pred_def_35879,type,
    v66520: state_type > $o ).

tff(pred_def_35880,type,
    v66534: state_type > $o ).

tff(pred_def_35881,type,
    v66532: state_type > $o ).

tff(pred_def_35882,type,
    v66538: state_type > $o ).

tff(pred_def_35883,type,
    v66536: state_type > $o ).

tff(pred_def_35884,type,
    v66530: state_type > $o ).

tff(pred_def_35885,type,
    v66528: state_type > $o ).

tff(pred_def_35886,type,
    v66547: state_type > $o ).

tff(pred_def_35887,type,
    v66545: state_type > $o ).

tff(pred_def_35888,type,
    v66543: state_type > $o ).

tff(pred_def_35889,type,
    v66541: state_type > $o ).

tff(pred_def_35890,type,
    v66509: ( state_type * $int ) > $o ).

tff(pred_def_35891,type,
    v66507: ( state_type * $int ) > $o ).

tff(pred_def_35892,type,
    v66505: ( state_type * $int ) > $o ).

tff(pred_def_35893,type,
    v66499: state_type > $o ).

tff(pred_def_35894,type,
    v66497: state_type > $o ).

tff(pred_def_35895,type,
    v66495: state_type > $o ).

tff(pred_def_35896,type,
    v66493: state_type > $o ).

tff(pred_def_35897,type,
    v66491: state_type > $o ).

tff(pred_def_35898,type,
    v66485: state_type > $o ).

tff(pred_def_35899,type,
    v66483: state_type > $o ).

tff(pred_def_35900,type,
    v66558: state_type > $o ).

tff(pred_def_35901,type,
    v66556: state_type > $o ).

tff(pred_def_35902,type,
    v66572: ( state_type * $int ) > $o ).

tff(pred_def_35903,type,
    v66570: ( state_type * $int ) > $o ).

tff(pred_def_35904,type,
    v66576: ( state_type * $int ) > $o ).

tff(pred_def_35905,type,
    v66574: ( state_type * $int ) > $o ).

tff(pred_def_35906,type,
    v66568: state_type > $o ).

tff(pred_def_35907,type,
    v66566: state_type > $o ).

tff(pred_def_35908,type,
    v66564: state_type > $o ).

tff(pred_def_35909,type,
    v66562: state_type > $o ).

tff(pred_def_35910,type,
    v66560: state_type > $o ).

tff(pred_def_35911,type,
    v66554: state_type > $o ).

tff(pred_def_35912,type,
    v66552: state_type > $o ).

tff(pred_def_35913,type,
    v65031: ( state_type * $int ) > $o ).

tff(pred_def_35914,type,
    v65029: ( state_type * $int ) > $o ).

tff(pred_def_35915,type,
    v66605: state_type > $o ).

tff(pred_def_35916,type,
    v66603: state_type > $o ).

tff(pred_def_35917,type,
    v66609: state_type > $o ).

tff(pred_def_35918,type,
    v66607: state_type > $o ).

tff(pred_def_35919,type,
    v66601: state_type > $o ).

tff(pred_def_35920,type,
    v66599: state_type > $o ).

tff(pred_def_35921,type,
    v66597: state_type > $o ).

tff(pred_def_35922,type,
    v66595: state_type > $o ).

tff(pred_def_35923,type,
    v66593: state_type > $o ).

tff(pred_def_35924,type,
    v66614: state_type > $o ).

tff(pred_def_35925,type,
    v66612: state_type > $o ).

tff(pred_def_35926,type,
    v66591: state_type > $o ).

tff(pred_def_35927,type,
    v66589: state_type > $o ).

tff(pred_def_35928,type,
    v66587: state_type > $o ).

tff(pred_def_35929,type,
    v66625: state_type > $o ).

tff(pred_def_35930,type,
    v66623: state_type > $o ).

tff(pred_def_35931,type,
    v66629: state_type > $o ).

tff(pred_def_35932,type,
    v66627: state_type > $o ).

tff(pred_def_35933,type,
    v66621: state_type > $o ).

tff(pred_def_35934,type,
    v66619: state_type > $o ).

tff(pred_def_35935,type,
    v66617: state_type > $o ).

tff(pred_def_35936,type,
    v66640: state_type > $o ).

tff(pred_def_35937,type,
    v66638: state_type > $o ).

tff(pred_def_35938,type,
    v66644: state_type > $o ).

tff(pred_def_35939,type,
    v66642: state_type > $o ).

tff(pred_def_35940,type,
    v66636: state_type > $o ).

tff(pred_def_35941,type,
    v66634: state_type > $o ).

tff(pred_def_35942,type,
    v66632: state_type > $o ).

tff(pred_def_35943,type,
    v66655: state_type > $o ).

tff(pred_def_35944,type,
    v66653: state_type > $o ).

tff(pred_def_35945,type,
    v66659: state_type > $o ).

tff(pred_def_35946,type,
    v66657: state_type > $o ).

tff(pred_def_35947,type,
    v66651: state_type > $o ).

tff(pred_def_35948,type,
    v66649: state_type > $o ).

tff(pred_def_35949,type,
    v66647: state_type > $o ).

tff(pred_def_35950,type,
    v66670: state_type > $o ).

tff(pred_def_35951,type,
    v66668: state_type > $o ).

tff(pred_def_35952,type,
    v66674: state_type > $o ).

tff(pred_def_35953,type,
    v66672: state_type > $o ).

tff(pred_def_35954,type,
    v66666: state_type > $o ).

tff(pred_def_35955,type,
    v66664: state_type > $o ).

tff(pred_def_35956,type,
    v66662: state_type > $o ).

tff(pred_def_35957,type,
    v66685: state_type > $o ).

tff(pred_def_35958,type,
    v66683: state_type > $o ).

tff(pred_def_35959,type,
    v66689: state_type > $o ).

tff(pred_def_35960,type,
    v66687: state_type > $o ).

tff(pred_def_35961,type,
    v66681: state_type > $o ).

tff(pred_def_35962,type,
    v66679: state_type > $o ).

tff(pred_def_35963,type,
    v66677: state_type > $o ).

tff(pred_def_35964,type,
    v66700: state_type > $o ).

tff(pred_def_35965,type,
    v66698: state_type > $o ).

tff(pred_def_35966,type,
    v66704: state_type > $o ).

tff(pred_def_35967,type,
    v66702: state_type > $o ).

tff(pred_def_35968,type,
    v66696: state_type > $o ).

tff(pred_def_35969,type,
    v66694: state_type > $o ).

tff(pred_def_35970,type,
    v66692: state_type > $o ).

tff(pred_def_35971,type,
    v66715: state_type > $o ).

tff(pred_def_35972,type,
    v66713: state_type > $o ).

tff(pred_def_35973,type,
    v66719: state_type > $o ).

tff(pred_def_35974,type,
    v66717: state_type > $o ).

tff(pred_def_35975,type,
    v66711: state_type > $o ).

tff(pred_def_35976,type,
    v66709: state_type > $o ).

tff(pred_def_35977,type,
    v66707: state_type > $o ).

tff(pred_def_35978,type,
    v66730: state_type > $o ).

tff(pred_def_35979,type,
    v66728: state_type > $o ).

tff(pred_def_35980,type,
    v66734: state_type > $o ).

tff(pred_def_35981,type,
    v66732: state_type > $o ).

tff(pred_def_35982,type,
    v66726: state_type > $o ).

tff(pred_def_35983,type,
    v66724: state_type > $o ).

tff(pred_def_35984,type,
    v66722: state_type > $o ).

tff(pred_def_35985,type,
    v66745: state_type > $o ).

tff(pred_def_35986,type,
    v66743: state_type > $o ).

tff(pred_def_35987,type,
    v66749: state_type > $o ).

tff(pred_def_35988,type,
    v66747: state_type > $o ).

tff(pred_def_35989,type,
    v66741: state_type > $o ).

tff(pred_def_35990,type,
    v66739: state_type > $o ).

tff(pred_def_35991,type,
    v66737: state_type > $o ).

tff(pred_def_35992,type,
    v66760: state_type > $o ).

tff(pred_def_35993,type,
    v66758: state_type > $o ).

tff(pred_def_35994,type,
    v66764: state_type > $o ).

tff(pred_def_35995,type,
    v66762: state_type > $o ).

tff(pred_def_35996,type,
    v66756: state_type > $o ).

tff(pred_def_35997,type,
    v66754: state_type > $o ).

tff(pred_def_35998,type,
    v66752: state_type > $o ).

tff(pred_def_35999,type,
    v66775: state_type > $o ).

tff(pred_def_36000,type,
    v66773: state_type > $o ).

tff(pred_def_36001,type,
    v66779: state_type > $o ).

tff(pred_def_36002,type,
    v66777: state_type > $o ).

tff(pred_def_36003,type,
    v66771: state_type > $o ).

tff(pred_def_36004,type,
    v66769: state_type > $o ).

tff(pred_def_36005,type,
    v66767: state_type > $o ).

tff(pred_def_36006,type,
    v66790: state_type > $o ).

tff(pred_def_36007,type,
    v66788: state_type > $o ).

tff(pred_def_36008,type,
    v66794: state_type > $o ).

tff(pred_def_36009,type,
    v66792: state_type > $o ).

tff(pred_def_36010,type,
    v66786: state_type > $o ).

tff(pred_def_36011,type,
    v66784: state_type > $o ).

tff(pred_def_36012,type,
    v66782: state_type > $o ).

tff(pred_def_36013,type,
    v66805: state_type > $o ).

tff(pred_def_36014,type,
    v66803: state_type > $o ).

tff(pred_def_36015,type,
    v66809: state_type > $o ).

tff(pred_def_36016,type,
    v66807: state_type > $o ).

tff(pred_def_36017,type,
    v66801: state_type > $o ).

tff(pred_def_36018,type,
    v66799: state_type > $o ).

tff(pred_def_36019,type,
    v66797: state_type > $o ).

tff(pred_def_36020,type,
    v66820: state_type > $o ).

tff(pred_def_36021,type,
    v66818: state_type > $o ).

tff(pred_def_36022,type,
    v66834: ( state_type * $int ) > $o ).

tff(pred_def_36023,type,
    v66832: ( state_type * $int ) > $o ).

tff(pred_def_36024,type,
    v66838: ( state_type * $int ) > $o ).

tff(pred_def_36025,type,
    v66836: ( state_type * $int ) > $o ).

tff(pred_def_36026,type,
    v66830: state_type > $o ).

tff(pred_def_36027,type,
    v66828: state_type > $o ).

tff(pred_def_36028,type,
    v66826: state_type > $o ).

tff(pred_def_36029,type,
    v66824: state_type > $o ).

tff(pred_def_36030,type,
    v66822: state_type > $o ).

tff(pred_def_36031,type,
    v66816: state_type > $o ).

tff(pred_def_36032,type,
    v66814: state_type > $o ).

tff(pred_def_36033,type,
    v66812: state_type > $o ).

tff(pred_def_36034,type,
    v66585: ( state_type * $int ) > $o ).

tff(pred_def_36035,type,
    v66583: ( state_type * $int ) > $o ).

tff(pred_def_36036,type,
    v66581: ( state_type * $int ) > $o ).

tff(pred_def_36037,type,
    v65027: state_type > $o ).

tff(pred_def_36038,type,
    v65025: state_type > $o ).

tff(pred_def_36039,type,
    v65023: state_type > $o ).

tff(pred_def_36040,type,
    v65021: state_type > $o ).

tff(pred_def_36041,type,
    v65019: state_type > $o ).

tff(pred_def_36042,type,
    v65017: state_type > $o ).

tff(pred_def_36043,type,
    v65015: state_type > $o ).

tff(pred_def_36044,type,
    v65013: state_type > $o ).

tff(pred_def_36045,type,
    v65011: state_type > $o ).

tff(pred_def_36046,type,
    v65009: state_type > $o ).

tff(pred_def_36047,type,
    v64965: state_type > $o ).

tff(pred_def_36048,type,
    v64963: state_type > $o ).

tff(pred_def_36049,type,
    v64961: state_type > $o ).

tff(pred_def_36050,type,
    v64959: state_type > $o ).

tff(pred_def_36051,type,
    v64957: state_type > $o ).

tff(pred_def_36052,type,
    v66848: state_type > $o ).

tff(pred_def_36053,type,
    v66847: state_type > $o ).

tff(pred_def_36054,type,
    v62689: state_type > $o ).

tff(pred_def_36055,type,
    v62687: state_type > $o ).

tff(pred_def_36056,type,
    v62685: state_type > $o ).

tff(pred_def_36057,type,
    v62683: state_type > $o ).

tff(pred_def_36058,type,
    v62681: state_type > $o ).

tff(pred_def_36059,type,
    v66888: state_type > $o ).

tff(pred_def_36060,type,
    v66886: state_type > $o ).

tff(pred_def_36061,type,
    v66892: state_type > $o ).

tff(pred_def_36062,type,
    v66890: state_type > $o ).

tff(pred_def_36063,type,
    v66896: state_type > $o ).

tff(pred_def_36064,type,
    v66894: state_type > $o ).

tff(pred_def_36065,type,
    v66900: state_type > $o ).

tff(pred_def_36066,type,
    v66898: state_type > $o ).

tff(pred_def_36067,type,
    v66904: state_type > $o ).

tff(pred_def_36068,type,
    v66903: state_type > $o ).

tff(pred_def_36069,type,
    v66902: state_type > $o ).

tff(pred_def_36070,type,
    v66884: state_type > $o ).

tff(pred_def_36071,type,
    v66882: state_type > $o ).

tff(pred_def_36072,type,
    v66880: state_type > $o ).

tff(pred_def_36073,type,
    v66878: state_type > $o ).

tff(pred_def_36074,type,
    v66908: state_type > $o ).

tff(pred_def_36075,type,
    v66906: state_type > $o ).

tff(pred_def_36076,type,
    v66910: state_type > $o ).

tff(pred_def_36077,type,
    v66876: state_type > $o ).

tff(pred_def_36078,type,
    v66874: state_type > $o ).

tff(pred_def_36079,type,
    v66872: state_type > $o ).

tff(pred_def_36080,type,
    v66870: state_type > $o ).

tff(pred_def_36081,type,
    v66934: state_type > $o ).

tff(pred_def_36082,type,
    v66932: state_type > $o ).

tff(pred_def_36083,type,
    v66930: state_type > $o ).

tff(pred_def_36084,type,
    v66928: state_type > $o ).

tff(pred_def_36085,type,
    v66926: state_type > $o ).

tff(pred_def_36086,type,
    v66924: state_type > $o ).

tff(pred_def_36087,type,
    v66922: state_type > $o ).

tff(pred_def_36088,type,
    v66959: ( state_type * $int ) > $o ).

tff(pred_def_36089,type,
    v66957: ( state_type * $int ) > $o ).

tff(pred_def_36090,type,
    v66963: ( state_type * $int ) > $o ).

tff(pred_def_36091,type,
    v66961: ( state_type * $int ) > $o ).

tff(pred_def_36092,type,
    v66955: state_type > $o ).

tff(pred_def_36093,type,
    v66953: state_type > $o ).

tff(pred_def_36094,type,
    v66951: state_type > $o ).

tff(pred_def_36095,type,
    v66949: state_type > $o ).

tff(pred_def_36096,type,
    v66947: state_type > $o ).

tff(pred_def_36097,type,
    v66945: state_type > $o ).

tff(pred_def_36098,type,
    v66943: state_type > $o ).

tff(pred_def_36099,type,
    v66941: state_type > $o ).

tff(pred_def_36100,type,
    v66939: state_type > $o ).

tff(pred_def_36101,type,
    v66937: state_type > $o ).

tff(pred_def_36102,type,
    v66920: state_type > $o ).

tff(pred_def_36103,type,
    v66918: state_type > $o ).

tff(pred_def_36104,type,
    v66916: state_type > $o ).

tff(pred_def_36105,type,
    v66914: state_type > $o ).

tff(pred_def_36106,type,
    v66912: state_type > $o ).

tff(pred_def_36107,type,
    v66868: state_type > $o ).

tff(pred_def_36108,type,
    v66866: state_type > $o ).

tff(pred_def_36109,type,
    v66864: state_type > $o ).

tff(pred_def_36110,type,
    v66862: state_type > $o ).

tff(pred_def_36111,type,
    v66860: state_type > $o ).

tff(pred_def_36112,type,
    v66997: state_type > $o ).

tff(pred_def_36113,type,
    v66995: state_type > $o ).

tff(pred_def_36114,type,
    v67001: state_type > $o ).

tff(pred_def_36115,type,
    v66999: state_type > $o ).

tff(pred_def_36116,type,
    v67005: state_type > $o ).

tff(pred_def_36117,type,
    v67003: state_type > $o ).

tff(pred_def_36118,type,
    v67009: state_type > $o ).

tff(pred_def_36119,type,
    v67007: state_type > $o ).

tff(pred_def_36120,type,
    v67013: state_type > $o ).

tff(pred_def_36121,type,
    v67012: state_type > $o ).

tff(pred_def_36122,type,
    v67011: state_type > $o ).

tff(pred_def_36123,type,
    v66993: state_type > $o ).

tff(pred_def_36124,type,
    v66991: state_type > $o ).

tff(pred_def_36125,type,
    v66989: state_type > $o ).

tff(pred_def_36126,type,
    v66987: state_type > $o ).

tff(pred_def_36127,type,
    v67017: state_type > $o ).

tff(pred_def_36128,type,
    v67015: state_type > $o ).

tff(pred_def_36129,type,
    v67019: state_type > $o ).

tff(pred_def_36130,type,
    v66985: state_type > $o ).

tff(pred_def_36131,type,
    v66983: state_type > $o ).

tff(pred_def_36132,type,
    v66981: state_type > $o ).

tff(pred_def_36133,type,
    v66979: state_type > $o ).

tff(pred_def_36134,type,
    v67033: state_type > $o ).

tff(pred_def_36135,type,
    v67031: state_type > $o ).

tff(pred_def_36136,type,
    v67047: state_type > $o ).

tff(pred_def_36137,type,
    v67045: state_type > $o ).

tff(pred_def_36138,type,
    v67043: state_type > $o ).

tff(pred_def_36139,type,
    v67041: state_type > $o ).

tff(pred_def_36140,type,
    v67039: state_type > $o ).

tff(pred_def_36141,type,
    v67037: state_type > $o ).

tff(pred_def_36142,type,
    v67035: state_type > $o ).

tff(pred_def_36143,type,
    v67029: state_type > $o ).

tff(pred_def_36144,type,
    v67027: state_type > $o ).

tff(pred_def_36145,type,
    v67025: state_type > $o ).

tff(pred_def_36146,type,
    v67023: state_type > $o ).

tff(pred_def_36147,type,
    v67021: state_type > $o ).

tff(pred_def_36148,type,
    v66977: state_type > $o ).

tff(pred_def_36149,type,
    v66975: state_type > $o ).

tff(pred_def_36150,type,
    v66973: state_type > $o ).

tff(pred_def_36151,type,
    v66971: state_type > $o ).

tff(pred_def_36152,type,
    v66969: state_type > $o ).

tff(pred_def_36153,type,
    v67052: state_type > $o ).

tff(pred_def_36154,type,
    v66858: state_type > $o ).

tff(pred_def_36155,type,
    v66856: state_type > $o ).

tff(pred_def_36156,type,
    v66854: state_type > $o ).

tff(pred_def_36157,type,
    v66852: state_type > $o ).

tff(pred_def_36158,type,
    v66850: state_type > $o ).

tff(pred_def_36159,type,
    v67056: state_type > $o ).

tff(pred_def_36160,type,
    v67055: state_type > $o ).

tff(pred_def_36161,type,
    v67054: state_type > $o ).

tff(pred_def_36162,type,
    v5849: state_type > $o ).

tff(pred_def_36163,type,
    v5847: state_type > $o ).

tff(pred_def_36164,type,
    v5845: state_type > $o ).

tff(pred_def_36165,type,
    v67058: ( state_type * $int ) > $o ).

tff(pred_def_36166,type,
    v67057: ( state_type * $int ) > $o ).

tff(pred_def_36167,type,
    v5843: ( state_type * $int ) > $o ).

tff(pred_def_36168,type,
    v5841: ( state_type * $int ) > $o ).

tff(pred_def_36169,type,
    v67069: state_type > $o ).

tff(pred_def_36170,type,
    v67067: state_type > $o ).

tff(pred_def_36171,type,
    v67075: state_type > $o ).

tff(pred_def_36172,type,
    v67073: state_type > $o ).

tff(pred_def_36173,type,
    v67087: state_type > $o ).

tff(pred_def_36174,type,
    v67085: ( state_type * $int ) > $o ).

tff(pred_def_36175,type,
    v67083: ( state_type * $int ) > $o ).

tff(pred_def_36176,type,
    v67088: ( state_type * $int ) > $o ).

tff(pred_def_36177,type,
    v67081: ( state_type * $int ) > $o ).

tff(pred_def_36178,type,
    v67079: state_type > $o ).

tff(pred_def_36179,type,
    v67077: state_type > $o ).

tff(pred_def_36180,type,
    v67096: state_type > $o ).

tff(pred_def_36181,type,
    v67094: state_type > $o ).

tff(pred_def_36182,type,
    v67092: state_type > $o ).

tff(pred_def_36183,type,
    v67090: state_type > $o ).

tff(pred_def_36184,type,
    v67071: state_type > $o ).

tff(pred_def_36185,type,
    v67102: state_type > $o ).

tff(pred_def_36186,type,
    v67104: state_type > $o ).

tff(pred_def_36187,type,
    v67100: state_type > $o ).

tff(pred_def_36188,type,
    v67099: state_type > $o ).

tff(pred_def_36189,type,
    v67110: state_type > $o ).

tff(pred_def_36190,type,
    v67111: state_type > $o ).

tff(pred_def_36191,type,
    v67107: state_type > $o ).

tff(pred_def_36192,type,
    v67109: state_type > $o ).

tff(pred_def_36193,type,
    v67117: state_type > $o ).

tff(pred_def_36194,type,
    v67115: state_type > $o ).

tff(pred_def_36195,type,
    v67119: state_type > $o ).

tff(pred_def_36196,type,
    v67065: state_type > $o ).

tff(pred_def_36197,type,
    v67063: state_type > $o ).

tff(pred_def_36198,type,
    v67061: state_type > $o ).

tff(pred_def_36199,type,
    v67126: state_type > $o ).

tff(pred_def_36200,type,
    v67124: state_type > $o ).

tff(pred_def_36201,type,
    v67123: state_type > $o ).

tff(pred_def_36202,type,
    v67122: state_type > $o ).

tff(pred_def_36203,type,
    v67134: state_type > $o ).

tff(pred_def_36204,type,
    v67135: state_type > $o ).

tff(pred_def_36205,type,
    v67133: state_type > $o ).

tff(pred_def_36206,type,
    v67130: ( state_type * $int ) > $o ).

tff(pred_def_36207,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_36208,type,
    v67132: ( state_type * $int ) > $o ).

tff(pred_def_36209,type,
    v67121: ( state_type * $int ) > $o ).

tff(pred_def_36210,type,
    v5811: ( state_type * $int ) > $o ).

tff(pred_def_36211,type,
    v5809: ( state_type * $int ) > $o ).

tff(pred_def_36212,type,
    v5807: state_type > $o ).

tff(pred_def_36213,type,
    v67157: state_type > $o ).

tff(pred_def_36214,type,
    v67155: state_type > $o ).

tff(pred_def_36215,type,
    v67153: state_type > $o ).

tff(pred_def_36216,type,
    v67151: state_type > $o ).

tff(pred_def_36217,type,
    v67149: state_type > $o ).

tff(pred_def_36218,type,
    v67147: state_type > $o ).

tff(pred_def_36219,type,
    v67145: state_type > $o ).

tff(pred_def_36220,type,
    v67171: state_type > $o ).

tff(pred_def_36221,type,
    v67169: state_type > $o ).

tff(pred_def_36222,type,
    v67167: state_type > $o ).

tff(pred_def_36223,type,
    v67165: state_type > $o ).

tff(pred_def_36224,type,
    v67163: state_type > $o ).

tff(pred_def_36225,type,
    v67161: state_type > $o ).

tff(pred_def_36226,type,
    v67159: state_type > $o ).

tff(pred_def_36227,type,
    v67375: state_type > $o ).

tff(pred_def_36228,type,
    v67373: state_type > $o ).

tff(pred_def_36229,type,
    v67371: state_type > $o ).

tff(pred_def_36230,type,
    v67369: state_type > $o ).

tff(pred_def_36231,type,
    v67367: state_type > $o ).

tff(pred_def_36232,type,
    v67385: state_type > $o ).

tff(pred_def_36233,type,
    v67383: state_type > $o ).

tff(pred_def_36234,type,
    v67381: state_type > $o ).

tff(pred_def_36235,type,
    v67379: state_type > $o ).

tff(pred_def_36236,type,
    v67377: state_type > $o ).

tff(pred_def_36237,type,
    v67421: state_type > $o ).

tff(pred_def_36238,type,
    v67422: ( state_type * $int ) > $o ).

tff(pred_def_36239,type,
    v67419: ( state_type * $int ) > $o ).

tff(pred_def_36240,type,
    v67417: ( state_type * $int ) > $o ).

tff(pred_def_36241,type,
    v67415: ( state_type * $int ) > $o ).

tff(pred_def_36242,type,
    v67413: ( state_type * $int ) > $o ).

tff(pred_def_36243,type,
    v67411: state_type > $o ).

tff(pred_def_36244,type,
    v67424: state_type > $o ).

tff(pred_def_36245,type,
    v67423: ( state_type * $int ) > $o ).

tff(pred_def_36246,type,
    v67409: ( state_type * $int ) > $o ).

tff(pred_def_36247,type,
    v67407: ( state_type * $int ) > $o ).

tff(pred_def_36248,type,
    v67444: state_type > $o ).

tff(pred_def_36249,type,
    v67442: state_type > $o ).

tff(pred_def_36250,type,
    v67454: state_type > $o ).

tff(pred_def_36251,type,
    v67452: state_type > $o ).

tff(pred_def_36252,type,
    v67458: state_type > $o ).

tff(pred_def_36253,type,
    v67456: state_type > $o ).

tff(pred_def_36254,type,
    v67462: state_type > $o ).

tff(pred_def_36255,type,
    v67460: state_type > $o ).

tff(pred_def_36256,type,
    v67465: state_type > $o ).

tff(pred_def_36257,type,
    v67466: state_type > $o ).

tff(pred_def_36258,type,
    v67464: state_type > $o ).

tff(pred_def_36259,type,
    v67450: state_type > $o ).

tff(pred_def_36260,type,
    v67448: state_type > $o ).

tff(pred_def_36261,type,
    v67446: state_type > $o ).

tff(pred_def_36262,type,
    v67474: state_type > $o ).

tff(pred_def_36263,type,
    v67472: state_type > $o ).

tff(pred_def_36264,type,
    v67470: state_type > $o ).

tff(pred_def_36265,type,
    v67468: state_type > $o ).

tff(pred_def_36266,type,
    v67480: state_type > $o ).

tff(pred_def_36267,type,
    v67478: state_type > $o ).

tff(pred_def_36268,type,
    v67476: state_type > $o ).

tff(pred_def_36269,type,
    v67440: ( state_type * $int ) > $o ).

tff(pred_def_36270,type,
    v67485: ( state_type * $int ) > $o ).

tff(pred_def_36271,type,
    v67483: ( state_type * $int ) > $o ).

tff(pred_def_36272,type,
    v67489: ( state_type * $int ) > $o ).

tff(pred_def_36273,type,
    v67487: ( state_type * $int ) > $o ).

tff(pred_def_36274,type,
    v67496: ( state_type * $int ) > $o ).

tff(pred_def_36275,type,
    v67495: ( state_type * $int ) > $o ).

tff(pred_def_36276,type,
    v67493: ( state_type * $int ) > $o ).

tff(pred_def_36277,type,
    v67491: ( state_type * $int ) > $o ).

tff(pred_def_36278,type,
    v67501: state_type > $o ).

tff(pred_def_36279,type,
    v67500: state_type > $o ).

tff(pred_def_36280,type,
    v67502: state_type > $o ).

tff(pred_def_36281,type,
    v67498: state_type > $o ).

tff(pred_def_36282,type,
    v67506: state_type > $o ).

tff(pred_def_36283,type,
    v67505: state_type > $o ).

tff(pred_def_36284,type,
    v67503: state_type > $o ).

tff(pred_def_36285,type,
    v67509: state_type > $o ).

tff(pred_def_36286,type,
    v67507: state_type > $o ).

tff(pred_def_36287,type,
    v67512: state_type > $o ).

tff(pred_def_36288,type,
    v67513: state_type > $o ).

tff(pred_def_36289,type,
    v67510: state_type > $o ).

tff(pred_def_36290,type,
    v67497: ( state_type * $int ) > $o ).

tff(pred_def_36291,type,
    v67438: ( state_type * $int ) > $o ).

tff(pred_def_36292,type,
    v67436: ( state_type * $int ) > $o ).

tff(pred_def_36293,type,
    v67434: ( state_type * $int ) > $o ).

tff(pred_def_36294,type,
    v67432: ( state_type * $int ) > $o ).

tff(pred_def_36295,type,
    v67430: ( state_type * $int ) > $o ).

tff(pred_def_36296,type,
    v67428: ( state_type * $int ) > $o ).

tff(pred_def_36297,type,
    v67426: ( state_type * $int ) > $o ).

tff(pred_def_36298,type,
    v67514: ( state_type * $int ) > $o ).

tff(pred_def_36299,type,
    v67405: ( state_type * $int ) > $o ).

tff(pred_def_36300,type,
    v67403: ( state_type * $int ) > $o ).

tff(pred_def_36301,type,
    v67401: ( state_type * $int ) > $o ).

tff(pred_def_36302,type,
    v67399: ( state_type * $int ) > $o ).

tff(pred_def_36303,type,
    v67397: ( state_type * $int ) > $o ).

tff(pred_def_36304,type,
    v67520: ( state_type * $int ) > $o ).

tff(pred_def_36305,type,
    v67518: state_type > $o ).

tff(pred_def_36306,type,
    v67516: state_type > $o ).

tff(pred_def_36307,type,
    v67524: ( state_type * $int ) > $o ).

tff(pred_def_36308,type,
    v67522: ( state_type * $int ) > $o ).

tff(pred_def_36309,type,
    v67530: ( state_type * $int ) > $o ).

tff(pred_def_36310,type,
    v67528: state_type > $o ).

tff(pred_def_36311,type,
    v67526: state_type > $o ).

tff(pred_def_36312,type,
    v67534: state_type > $o ).

tff(pred_def_36313,type,
    v67533: ( state_type * $int ) > $o ).

tff(pred_def_36314,type,
    v67532: ( state_type * $int ) > $o ).

tff(pred_def_36315,type,
    v67537: state_type > $o ).

tff(pred_def_36316,type,
    v67536: ( state_type * $int ) > $o ).

tff(pred_def_36317,type,
    v67535: ( state_type * $int ) > $o ).

tff(pred_def_36318,type,
    v67531: ( state_type * $int ) > $o ).

tff(pred_def_36319,type,
    v67395: ( state_type * $int ) > $o ).

tff(pred_def_36320,type,
    v67393: ( state_type * $int ) > $o ).

tff(pred_def_36321,type,
    v67391: ( state_type * $int ) > $o ).

tff(pred_def_36322,type,
    v67389: ( state_type * $int ) > $o ).

tff(pred_def_36323,type,
    v67387: ( state_type * $int ) > $o ).

tff(pred_def_36324,type,
    v67549: state_type > $o ).

tff(pred_def_36325,type,
    v67547: state_type > $o ).

tff(pred_def_36326,type,
    v67545: state_type > $o ).

tff(pred_def_36327,type,
    v67559: state_type > $o ).

tff(pred_def_36328,type,
    v67557: state_type > $o ).

tff(pred_def_36329,type,
    v67555: state_type > $o ).

tff(pred_def_36330,type,
    v67553: state_type > $o ).

tff(pred_def_36331,type,
    v67551: state_type > $o ).

tff(pred_def_36332,type,
    v67561: state_type > $o ).

tff(pred_def_36333,type,
    v67543: state_type > $o ).

tff(pred_def_36334,type,
    v67541: state_type > $o ).

tff(pred_def_36335,type,
    v67539: state_type > $o ).

tff(pred_def_36336,type,
    v67568: state_type > $o ).

tff(pred_def_36337,type,
    v67566: state_type > $o ).

tff(pred_def_36338,type,
    v67565: state_type > $o ).

tff(pred_def_36339,type,
    v67564: state_type > $o ).

tff(pred_def_36340,type,
    v67576: state_type > $o ).

tff(pred_def_36341,type,
    v67577: state_type > $o ).

tff(pred_def_36342,type,
    v67575: state_type > $o ).

tff(pred_def_36343,type,
    v67572: ( state_type * $int ) > $o ).

tff(pred_def_36344,type,
    v67574: ( state_type * $int ) > $o ).

tff(pred_def_36345,type,
    v67563: ( state_type * $int ) > $o ).

tff(pred_def_36346,type,
    v67365: ( state_type * $int ) > $o ).

tff(pred_def_36347,type,
    v67363: ( state_type * $int ) > $o ).

tff(pred_def_36348,type,
    v67361: ( state_type * $int ) > $o ).

tff(pred_def_36349,type,
    v67581: ( state_type * $int ) > $o ).

tff(pred_def_36350,type,
    v67580: ( state_type * $int ) > $o ).

tff(pred_def_36351,type,
    v67582: ( state_type * $int ) > $o ).

tff(pred_def_36352,type,
    v67583: ( state_type * $int ) > $o ).

tff(pred_def_36353,type,
    v67584: ( state_type * $int ) > $o ).

tff(pred_def_36354,type,
    v67585: ( state_type * $int ) > $o ).

tff(pred_def_36355,type,
    v67586: ( state_type * $int ) > $o ).

tff(pred_def_36356,type,
    v67587: ( state_type * $int ) > $o ).

tff(pred_def_36357,type,
    v67588: ( state_type * $int ) > $o ).

tff(pred_def_36358,type,
    v67589: ( state_type * $int ) > $o ).

tff(pred_def_36359,type,
    v67590: ( state_type * $int ) > $o ).

tff(pred_def_36360,type,
    v67591: ( state_type * $int ) > $o ).

tff(pred_def_36361,type,
    v67592: ( state_type * $int ) > $o ).

tff(pred_def_36362,type,
    v67593: ( state_type * $int ) > $o ).

tff(pred_def_36363,type,
    v67594: ( state_type * $int ) > $o ).

tff(pred_def_36364,type,
    v67595: ( state_type * $int ) > $o ).

tff(pred_def_36365,type,
    v67596: ( state_type * $int ) > $o ).

tff(pred_def_36366,type,
    v67597: ( state_type * $int ) > $o ).

tff(pred_def_36367,type,
    v67598: ( state_type * $int ) > $o ).

tff(pred_def_36368,type,
    v67599: ( state_type * $int ) > $o ).

tff(pred_def_36369,type,
    v67600: ( state_type * $int ) > $o ).

tff(pred_def_36370,type,
    v67601: ( state_type * $int ) > $o ).

tff(pred_def_36371,type,
    v67602: ( state_type * $int ) > $o ).

tff(pred_def_36372,type,
    v67603: ( state_type * $int ) > $o ).

tff(pred_def_36373,type,
    v67604: ( state_type * $int ) > $o ).

tff(pred_def_36374,type,
    v67605: ( state_type * $int ) > $o ).

tff(pred_def_36375,type,
    v67606: ( state_type * $int ) > $o ).

tff(pred_def_36376,type,
    v67607: ( state_type * $int ) > $o ).

tff(pred_def_36377,type,
    v67608: ( state_type * $int ) > $o ).

tff(pred_def_36378,type,
    v67609: ( state_type * $int ) > $o ).

tff(pred_def_36379,type,
    v67610: ( state_type * $int ) > $o ).

tff(pred_def_36380,type,
    v67611: ( state_type * $int ) > $o ).

tff(pred_def_36381,type,
    v67359: ( state_type * $int ) > $o ).

tff(pred_def_36382,type,
    v67357: ( state_type * $int ) > $o ).

tff(pred_def_36383,type,
    v67355: ( state_type * $int ) > $o ).

tff(pred_def_36384,type,
    v67353: ( state_type * $int ) > $o ).

tff(pred_def_36385,type,
    v67351: ( state_type * $int ) > $o ).

tff(pred_def_36386,type,
    v67349: ( state_type * $int ) > $o ).

tff(pred_def_36387,type,
    v67347: state_type > $o ).

tff(pred_def_36388,type,
    v67345: state_type > $o ).

tff(pred_def_36389,type,
    v67624: ( state_type * $int ) > $o ).

tff(pred_def_36390,type,
    v67622: ( state_type * $int ) > $o ).

tff(pred_def_36391,type,
    v67628: state_type > $o ).

tff(pred_def_36392,type,
    v67626: state_type > $o ).

tff(pred_def_36393,type,
    v67632: ( state_type * $int ) > $o ).

tff(pred_def_36394,type,
    v67630: ( state_type * $int ) > $o ).

tff(pred_def_36395,type,
    v67636: state_type > $o ).

tff(pred_def_36396,type,
    v67634: state_type > $o ).

tff(pred_def_36397,type,
    v67640: state_type > $o ).

tff(pred_def_36398,type,
    v67639: ( state_type * $int ) > $o ).

tff(pred_def_36399,type,
    v67638: ( state_type * $int ) > $o ).

tff(pred_def_36400,type,
    v67643: state_type > $o ).

tff(pred_def_36401,type,
    v67642: ( state_type * $int ) > $o ).

tff(pred_def_36402,type,
    v67641: ( state_type * $int ) > $o ).

tff(pred_def_36403,type,
    v67637: ( state_type * $int ) > $o ).

tff(pred_def_36404,type,
    v67620: ( state_type * $int ) > $o ).

tff(pred_def_36405,type,
    v67618: ( state_type * $int ) > $o ).

tff(pred_def_36406,type,
    v67649: state_type > $o ).

tff(pred_def_36407,type,
    v67647: state_type > $o ).

tff(pred_def_36408,type,
    v67646: state_type > $o ).

tff(pred_def_36409,type,
    v67645: ( state_type * $int ) > $o ).

tff(pred_def_36410,type,
    v67615: state_type > $o ).

tff(pred_def_36411,type,
    v67613: state_type > $o ).

tff(pred_def_36412,type,
    v67664: ( state_type * $int ) > $o ).

tff(pred_def_36413,type,
    v67662: ( state_type * $int ) > $o ).

tff(pred_def_36414,type,
    v67668: state_type > $o ).

tff(pred_def_36415,type,
    v67666: state_type > $o ).

tff(pred_def_36416,type,
    v67672: ( state_type * $int ) > $o ).

tff(pred_def_36417,type,
    v67670: ( state_type * $int ) > $o ).

tff(pred_def_36418,type,
    v67676: state_type > $o ).

tff(pred_def_36419,type,
    v67674: state_type > $o ).

tff(pred_def_36420,type,
    v67680: state_type > $o ).

tff(pred_def_36421,type,
    v67679: ( state_type * $int ) > $o ).

tff(pred_def_36422,type,
    v67678: ( state_type * $int ) > $o ).

tff(pred_def_36423,type,
    v67683: state_type > $o ).

tff(pred_def_36424,type,
    v67682: ( state_type * $int ) > $o ).

tff(pred_def_36425,type,
    v67681: ( state_type * $int ) > $o ).

tff(pred_def_36426,type,
    v67677: ( state_type * $int ) > $o ).

tff(pred_def_36427,type,
    v67660: ( state_type * $int ) > $o ).

tff(pred_def_36428,type,
    v67658: ( state_type * $int ) > $o ).

tff(pred_def_36429,type,
    v67689: state_type > $o ).

tff(pred_def_36430,type,
    v67687: state_type > $o ).

tff(pred_def_36431,type,
    v67686: state_type > $o ).

tff(pred_def_36432,type,
    v67685: ( state_type * $int ) > $o ).

tff(pred_def_36433,type,
    v67655: state_type > $o ).

tff(pred_def_36434,type,
    v67653: state_type > $o ).

tff(pred_def_36435,type,
    v67693: state_type > $o ).

tff(pred_def_36436,type,
    v67343: state_type > $o ).

tff(pred_def_36437,type,
    v67341: state_type > $o ).

tff(pred_def_36438,type,
    v67339: state_type > $o ).

tff(pred_def_36439,type,
    v67337: state_type > $o ).

tff(pred_def_36440,type,
    v67335: state_type > $o ).

tff(pred_def_36441,type,
    v67716: ( state_type * $int ) > $o ).

tff(pred_def_36442,type,
    v67714: ( state_type * $int ) > $o ).

tff(pred_def_36443,type,
    v67720: state_type > $o ).

tff(pred_def_36444,type,
    v67718: state_type > $o ).

tff(pred_def_36445,type,
    v67724: ( state_type * $int ) > $o ).

tff(pred_def_36446,type,
    v67722: ( state_type * $int ) > $o ).

tff(pred_def_36447,type,
    v67728: state_type > $o ).

tff(pred_def_36448,type,
    v67726: state_type > $o ).

tff(pred_def_36449,type,
    v67732: state_type > $o ).

tff(pred_def_36450,type,
    v67731: ( state_type * $int ) > $o ).

tff(pred_def_36451,type,
    v67730: ( state_type * $int ) > $o ).

tff(pred_def_36452,type,
    v67735: state_type > $o ).

tff(pred_def_36453,type,
    v67734: ( state_type * $int ) > $o ).

tff(pred_def_36454,type,
    v67733: ( state_type * $int ) > $o ).

tff(pred_def_36455,type,
    v67729: ( state_type * $int ) > $o ).

tff(pred_def_36456,type,
    v67712: ( state_type * $int ) > $o ).

tff(pred_def_36457,type,
    v67710: ( state_type * $int ) > $o ).

tff(pred_def_36458,type,
    v67741: state_type > $o ).

tff(pred_def_36459,type,
    v67739: state_type > $o ).

tff(pred_def_36460,type,
    v67738: state_type > $o ).

tff(pred_def_36461,type,
    v67737: ( state_type * $int ) > $o ).

tff(pred_def_36462,type,
    v67707: state_type > $o ).

tff(pred_def_36463,type,
    v67705: state_type > $o ).

tff(pred_def_36464,type,
    v67756: ( state_type * $int ) > $o ).

tff(pred_def_36465,type,
    v67754: ( state_type * $int ) > $o ).

tff(pred_def_36466,type,
    v67760: state_type > $o ).

tff(pred_def_36467,type,
    v67758: state_type > $o ).

tff(pred_def_36468,type,
    v67764: ( state_type * $int ) > $o ).

tff(pred_def_36469,type,
    v67762: ( state_type * $int ) > $o ).

tff(pred_def_36470,type,
    v67768: state_type > $o ).

tff(pred_def_36471,type,
    v67766: state_type > $o ).

tff(pred_def_36472,type,
    v67772: state_type > $o ).

tff(pred_def_36473,type,
    v67771: ( state_type * $int ) > $o ).

tff(pred_def_36474,type,
    v67770: ( state_type * $int ) > $o ).

tff(pred_def_36475,type,
    v67775: state_type > $o ).

tff(pred_def_36476,type,
    v67774: ( state_type * $int ) > $o ).

tff(pred_def_36477,type,
    v67773: ( state_type * $int ) > $o ).

tff(pred_def_36478,type,
    v67769: ( state_type * $int ) > $o ).

tff(pred_def_36479,type,
    v67752: ( state_type * $int ) > $o ).

tff(pred_def_36480,type,
    v67750: ( state_type * $int ) > $o ).

tff(pred_def_36481,type,
    v67781: state_type > $o ).

tff(pred_def_36482,type,
    v67779: state_type > $o ).

tff(pred_def_36483,type,
    v67778: state_type > $o ).

tff(pred_def_36484,type,
    v67777: ( state_type * $int ) > $o ).

tff(pred_def_36485,type,
    v67747: state_type > $o ).

tff(pred_def_36486,type,
    v67745: state_type > $o ).

tff(pred_def_36487,type,
    v67796: ( state_type * $int ) > $o ).

tff(pred_def_36488,type,
    v67794: ( state_type * $int ) > $o ).

tff(pred_def_36489,type,
    v67800: state_type > $o ).

tff(pred_def_36490,type,
    v67798: state_type > $o ).

tff(pred_def_36491,type,
    v67804: ( state_type * $int ) > $o ).

tff(pred_def_36492,type,
    v67802: ( state_type * $int ) > $o ).

tff(pred_def_36493,type,
    v67808: state_type > $o ).

tff(pred_def_36494,type,
    v67806: state_type > $o ).

tff(pred_def_36495,type,
    v67812: state_type > $o ).

tff(pred_def_36496,type,
    v67811: ( state_type * $int ) > $o ).

tff(pred_def_36497,type,
    v67810: ( state_type * $int ) > $o ).

tff(pred_def_36498,type,
    v67815: state_type > $o ).

tff(pred_def_36499,type,
    v67814: ( state_type * $int ) > $o ).

tff(pred_def_36500,type,
    v67813: ( state_type * $int ) > $o ).

tff(pred_def_36501,type,
    v67809: ( state_type * $int ) > $o ).

tff(pred_def_36502,type,
    v67792: ( state_type * $int ) > $o ).

tff(pred_def_36503,type,
    v67790: ( state_type * $int ) > $o ).

tff(pred_def_36504,type,
    v67821: state_type > $o ).

tff(pred_def_36505,type,
    v67819: state_type > $o ).

tff(pred_def_36506,type,
    v67818: state_type > $o ).

tff(pred_def_36507,type,
    v67817: ( state_type * $int ) > $o ).

tff(pred_def_36508,type,
    v67787: state_type > $o ).

tff(pred_def_36509,type,
    v67785: state_type > $o ).

tff(pred_def_36510,type,
    v67825: state_type > $o ).

tff(pred_def_36511,type,
    v67703: state_type > $o ).

tff(pred_def_36512,type,
    v67701: state_type > $o ).

tff(pred_def_36513,type,
    v67699: state_type > $o ).

tff(pred_def_36514,type,
    v67697: state_type > $o ).

tff(pred_def_36515,type,
    v67695: state_type > $o ).

tff(pred_def_36516,type,
    v67848: ( state_type * $int ) > $o ).

tff(pred_def_36517,type,
    v67846: ( state_type * $int ) > $o ).

tff(pred_def_36518,type,
    v67852: state_type > $o ).

tff(pred_def_36519,type,
    v67850: state_type > $o ).

tff(pred_def_36520,type,
    v67856: ( state_type * $int ) > $o ).

tff(pred_def_36521,type,
    v67854: ( state_type * $int ) > $o ).

tff(pred_def_36522,type,
    v67860: state_type > $o ).

tff(pred_def_36523,type,
    v67858: state_type > $o ).

tff(pred_def_36524,type,
    v67864: state_type > $o ).

tff(pred_def_36525,type,
    v67863: ( state_type * $int ) > $o ).

tff(pred_def_36526,type,
    v67862: ( state_type * $int ) > $o ).

tff(pred_def_36527,type,
    v67867: state_type > $o ).

tff(pred_def_36528,type,
    v67866: ( state_type * $int ) > $o ).

tff(pred_def_36529,type,
    v67865: ( state_type * $int ) > $o ).

tff(pred_def_36530,type,
    v67861: ( state_type * $int ) > $o ).

tff(pred_def_36531,type,
    v67844: ( state_type * $int ) > $o ).

tff(pred_def_36532,type,
    v67842: ( state_type * $int ) > $o ).

tff(pred_def_36533,type,
    v67873: state_type > $o ).

tff(pred_def_36534,type,
    v67871: state_type > $o ).

tff(pred_def_36535,type,
    v67870: state_type > $o ).

tff(pred_def_36536,type,
    v67869: ( state_type * $int ) > $o ).

tff(pred_def_36537,type,
    v67839: state_type > $o ).

tff(pred_def_36538,type,
    v67837: state_type > $o ).

tff(pred_def_36539,type,
    v67888: ( state_type * $int ) > $o ).

tff(pred_def_36540,type,
    v67886: ( state_type * $int ) > $o ).

tff(pred_def_36541,type,
    v67892: state_type > $o ).

tff(pred_def_36542,type,
    v67890: state_type > $o ).

tff(pred_def_36543,type,
    v67896: ( state_type * $int ) > $o ).

tff(pred_def_36544,type,
    v67894: ( state_type * $int ) > $o ).

tff(pred_def_36545,type,
    v67900: state_type > $o ).

tff(pred_def_36546,type,
    v67898: state_type > $o ).

tff(pred_def_36547,type,
    v67904: state_type > $o ).

tff(pred_def_36548,type,
    v67903: ( state_type * $int ) > $o ).

tff(pred_def_36549,type,
    v67902: ( state_type * $int ) > $o ).

tff(pred_def_36550,type,
    v67907: state_type > $o ).

tff(pred_def_36551,type,
    v67906: ( state_type * $int ) > $o ).

tff(pred_def_36552,type,
    v67905: ( state_type * $int ) > $o ).

tff(pred_def_36553,type,
    v67901: ( state_type * $int ) > $o ).

tff(pred_def_36554,type,
    v67884: ( state_type * $int ) > $o ).

tff(pred_def_36555,type,
    v67882: ( state_type * $int ) > $o ).

tff(pred_def_36556,type,
    v67913: state_type > $o ).

tff(pred_def_36557,type,
    v67911: state_type > $o ).

tff(pred_def_36558,type,
    v67910: state_type > $o ).

tff(pred_def_36559,type,
    v67909: ( state_type * $int ) > $o ).

tff(pred_def_36560,type,
    v67879: state_type > $o ).

tff(pred_def_36561,type,
    v67877: state_type > $o ).

tff(pred_def_36562,type,
    v67928: ( state_type * $int ) > $o ).

tff(pred_def_36563,type,
    v67926: ( state_type * $int ) > $o ).

tff(pred_def_36564,type,
    v67932: state_type > $o ).

tff(pred_def_36565,type,
    v67930: state_type > $o ).

tff(pred_def_36566,type,
    v67936: ( state_type * $int ) > $o ).

tff(pred_def_36567,type,
    v67934: ( state_type * $int ) > $o ).

tff(pred_def_36568,type,
    v67940: state_type > $o ).

tff(pred_def_36569,type,
    v67938: state_type > $o ).

tff(pred_def_36570,type,
    v67944: state_type > $o ).

tff(pred_def_36571,type,
    v67943: ( state_type * $int ) > $o ).

tff(pred_def_36572,type,
    v67942: ( state_type * $int ) > $o ).

tff(pred_def_36573,type,
    v67947: state_type > $o ).

tff(pred_def_36574,type,
    v67946: ( state_type * $int ) > $o ).

tff(pred_def_36575,type,
    v67945: ( state_type * $int ) > $o ).

tff(pred_def_36576,type,
    v67941: ( state_type * $int ) > $o ).

tff(pred_def_36577,type,
    v67924: ( state_type * $int ) > $o ).

tff(pred_def_36578,type,
    v67922: ( state_type * $int ) > $o ).

tff(pred_def_36579,type,
    v67953: state_type > $o ).

tff(pred_def_36580,type,
    v67951: state_type > $o ).

tff(pred_def_36581,type,
    v67950: state_type > $o ).

tff(pred_def_36582,type,
    v67949: ( state_type * $int ) > $o ).

tff(pred_def_36583,type,
    v67919: state_type > $o ).

tff(pred_def_36584,type,
    v67917: state_type > $o ).

tff(pred_def_36585,type,
    v67957: state_type > $o ).

tff(pred_def_36586,type,
    v67835: state_type > $o ).

tff(pred_def_36587,type,
    v67833: state_type > $o ).

tff(pred_def_36588,type,
    v67831: state_type > $o ).

tff(pred_def_36589,type,
    v67829: state_type > $o ).

tff(pred_def_36590,type,
    v67827: state_type > $o ).

tff(pred_def_36591,type,
    v67959: state_type > $o ).

tff(pred_def_36592,type,
    v67333: state_type > $o ).

tff(pred_def_36593,type,
    v67331: state_type > $o ).

tff(pred_def_36594,type,
    v67329: state_type > $o ).

tff(pred_def_36595,type,
    v67327: state_type > $o ).

tff(pred_def_36596,type,
    v67325: state_type > $o ).

tff(pred_def_36597,type,
    v67992: ( state_type * $int ) > $o ).

tff(pred_def_36598,type,
    v67990: ( state_type * $int ) > $o ).

tff(pred_def_36599,type,
    v67996: state_type > $o ).

tff(pred_def_36600,type,
    v67994: state_type > $o ).

tff(pred_def_36601,type,
    v68000: ( state_type * $int ) > $o ).

tff(pred_def_36602,type,
    v67998: ( state_type * $int ) > $o ).

tff(pred_def_36603,type,
    v68004: state_type > $o ).

tff(pred_def_36604,type,
    v68002: state_type > $o ).

tff(pred_def_36605,type,
    v68008: state_type > $o ).

tff(pred_def_36606,type,
    v68007: ( state_type * $int ) > $o ).

tff(pred_def_36607,type,
    v68006: ( state_type * $int ) > $o ).

tff(pred_def_36608,type,
    v68011: state_type > $o ).

tff(pred_def_36609,type,
    v68010: ( state_type * $int ) > $o ).

tff(pred_def_36610,type,
    v68009: ( state_type * $int ) > $o ).

tff(pred_def_36611,type,
    v68005: ( state_type * $int ) > $o ).

tff(pred_def_36612,type,
    v67988: ( state_type * $int ) > $o ).

tff(pred_def_36613,type,
    v67986: ( state_type * $int ) > $o ).

tff(pred_def_36614,type,
    v68017: state_type > $o ).

tff(pred_def_36615,type,
    v68015: state_type > $o ).

tff(pred_def_36616,type,
    v68014: state_type > $o ).

tff(pred_def_36617,type,
    v68013: ( state_type * $int ) > $o ).

tff(pred_def_36618,type,
    v67983: state_type > $o ).

tff(pred_def_36619,type,
    v67981: state_type > $o ).

tff(pred_def_36620,type,
    v68032: ( state_type * $int ) > $o ).

tff(pred_def_36621,type,
    v68030: ( state_type * $int ) > $o ).

tff(pred_def_36622,type,
    v68036: state_type > $o ).

tff(pred_def_36623,type,
    v68034: state_type > $o ).

tff(pred_def_36624,type,
    v68040: ( state_type * $int ) > $o ).

tff(pred_def_36625,type,
    v68038: ( state_type * $int ) > $o ).

tff(pred_def_36626,type,
    v68044: state_type > $o ).

tff(pred_def_36627,type,
    v68042: state_type > $o ).

tff(pred_def_36628,type,
    v68048: state_type > $o ).

tff(pred_def_36629,type,
    v68047: ( state_type * $int ) > $o ).

tff(pred_def_36630,type,
    v68046: ( state_type * $int ) > $o ).

tff(pred_def_36631,type,
    v68051: state_type > $o ).

tff(pred_def_36632,type,
    v68050: ( state_type * $int ) > $o ).

tff(pred_def_36633,type,
    v68049: ( state_type * $int ) > $o ).

tff(pred_def_36634,type,
    v68045: ( state_type * $int ) > $o ).

tff(pred_def_36635,type,
    v68028: ( state_type * $int ) > $o ).

tff(pred_def_36636,type,
    v68026: ( state_type * $int ) > $o ).

tff(pred_def_36637,type,
    v68057: state_type > $o ).

tff(pred_def_36638,type,
    v68055: state_type > $o ).

tff(pred_def_36639,type,
    v68054: state_type > $o ).

tff(pred_def_36640,type,
    v68053: ( state_type * $int ) > $o ).

tff(pred_def_36641,type,
    v68023: state_type > $o ).

tff(pred_def_36642,type,
    v68021: state_type > $o ).

tff(pred_def_36643,type,
    v68072: ( state_type * $int ) > $o ).

tff(pred_def_36644,type,
    v68070: ( state_type * $int ) > $o ).

tff(pred_def_36645,type,
    v68076: state_type > $o ).

tff(pred_def_36646,type,
    v68074: state_type > $o ).

tff(pred_def_36647,type,
    v68080: ( state_type * $int ) > $o ).

tff(pred_def_36648,type,
    v68078: ( state_type * $int ) > $o ).

tff(pred_def_36649,type,
    v68084: state_type > $o ).

tff(pred_def_36650,type,
    v68082: state_type > $o ).

tff(pred_def_36651,type,
    v68088: state_type > $o ).

tff(pred_def_36652,type,
    v68087: ( state_type * $int ) > $o ).

tff(pred_def_36653,type,
    v68086: ( state_type * $int ) > $o ).

tff(pred_def_36654,type,
    v68091: state_type > $o ).

tff(pred_def_36655,type,
    v68090: ( state_type * $int ) > $o ).

tff(pred_def_36656,type,
    v68089: ( state_type * $int ) > $o ).

tff(pred_def_36657,type,
    v68085: ( state_type * $int ) > $o ).

tff(pred_def_36658,type,
    v68068: ( state_type * $int ) > $o ).

tff(pred_def_36659,type,
    v68066: ( state_type * $int ) > $o ).

tff(pred_def_36660,type,
    v68097: state_type > $o ).

tff(pred_def_36661,type,
    v68095: state_type > $o ).

tff(pred_def_36662,type,
    v68094: state_type > $o ).

tff(pred_def_36663,type,
    v68093: ( state_type * $int ) > $o ).

tff(pred_def_36664,type,
    v68063: state_type > $o ).

tff(pred_def_36665,type,
    v68061: state_type > $o ).

tff(pred_def_36666,type,
    v68101: state_type > $o ).

tff(pred_def_36667,type,
    v67979: state_type > $o ).

tff(pred_def_36668,type,
    v67977: state_type > $o ).

tff(pred_def_36669,type,
    v67975: state_type > $o ).

tff(pred_def_36670,type,
    v67973: state_type > $o ).

tff(pred_def_36671,type,
    v67971: state_type > $o ).

tff(pred_def_36672,type,
    v68124: ( state_type * $int ) > $o ).

tff(pred_def_36673,type,
    v68122: ( state_type * $int ) > $o ).

tff(pred_def_36674,type,
    v68128: state_type > $o ).

tff(pred_def_36675,type,
    v68126: state_type > $o ).

tff(pred_def_36676,type,
    v68132: ( state_type * $int ) > $o ).

tff(pred_def_36677,type,
    v68130: ( state_type * $int ) > $o ).

tff(pred_def_36678,type,
    v68136: state_type > $o ).

tff(pred_def_36679,type,
    v68134: state_type > $o ).

tff(pred_def_36680,type,
    v68140: state_type > $o ).

tff(pred_def_36681,type,
    v68139: ( state_type * $int ) > $o ).

tff(pred_def_36682,type,
    v68138: ( state_type * $int ) > $o ).

tff(pred_def_36683,type,
    v68143: state_type > $o ).

tff(pred_def_36684,type,
    v68142: ( state_type * $int ) > $o ).

tff(pred_def_36685,type,
    v68141: ( state_type * $int ) > $o ).

tff(pred_def_36686,type,
    v68137: ( state_type * $int ) > $o ).

tff(pred_def_36687,type,
    v68120: ( state_type * $int ) > $o ).

tff(pred_def_36688,type,
    v68118: ( state_type * $int ) > $o ).

tff(pred_def_36689,type,
    v68149: state_type > $o ).

tff(pred_def_36690,type,
    v68147: state_type > $o ).

tff(pred_def_36691,type,
    v68146: state_type > $o ).

tff(pred_def_36692,type,
    v68145: ( state_type * $int ) > $o ).

tff(pred_def_36693,type,
    v68115: state_type > $o ).

tff(pred_def_36694,type,
    v68113: state_type > $o ).

tff(pred_def_36695,type,
    v68164: ( state_type * $int ) > $o ).

tff(pred_def_36696,type,
    v68162: ( state_type * $int ) > $o ).

tff(pred_def_36697,type,
    v68168: state_type > $o ).

tff(pred_def_36698,type,
    v68166: state_type > $o ).

tff(pred_def_36699,type,
    v68172: ( state_type * $int ) > $o ).

tff(pred_def_36700,type,
    v68170: ( state_type * $int ) > $o ).

tff(pred_def_36701,type,
    v68176: state_type > $o ).

tff(pred_def_36702,type,
    v68174: state_type > $o ).

tff(pred_def_36703,type,
    v68180: state_type > $o ).

tff(pred_def_36704,type,
    v68179: ( state_type * $int ) > $o ).

tff(pred_def_36705,type,
    v68178: ( state_type * $int ) > $o ).

tff(pred_def_36706,type,
    v68183: state_type > $o ).

tff(pred_def_36707,type,
    v68182: ( state_type * $int ) > $o ).

tff(pred_def_36708,type,
    v68181: ( state_type * $int ) > $o ).

tff(pred_def_36709,type,
    v68177: ( state_type * $int ) > $o ).

tff(pred_def_36710,type,
    v68160: ( state_type * $int ) > $o ).

tff(pred_def_36711,type,
    v68158: ( state_type * $int ) > $o ).

tff(pred_def_36712,type,
    v68189: state_type > $o ).

tff(pred_def_36713,type,
    v68187: state_type > $o ).

tff(pred_def_36714,type,
    v68186: state_type > $o ).

tff(pred_def_36715,type,
    v68185: ( state_type * $int ) > $o ).

tff(pred_def_36716,type,
    v68155: state_type > $o ).

tff(pred_def_36717,type,
    v68153: state_type > $o ).

tff(pred_def_36718,type,
    v68204: ( state_type * $int ) > $o ).

tff(pred_def_36719,type,
    v68202: ( state_type * $int ) > $o ).

tff(pred_def_36720,type,
    v68208: state_type > $o ).

tff(pred_def_36721,type,
    v68206: state_type > $o ).

tff(pred_def_36722,type,
    v68212: ( state_type * $int ) > $o ).

tff(pred_def_36723,type,
    v68210: ( state_type * $int ) > $o ).

tff(pred_def_36724,type,
    v68216: state_type > $o ).

tff(pred_def_36725,type,
    v68214: state_type > $o ).

tff(pred_def_36726,type,
    v68220: state_type > $o ).

tff(pred_def_36727,type,
    v68219: ( state_type * $int ) > $o ).

tff(pred_def_36728,type,
    v68218: ( state_type * $int ) > $o ).

tff(pred_def_36729,type,
    v68223: state_type > $o ).

tff(pred_def_36730,type,
    v68222: ( state_type * $int ) > $o ).

tff(pred_def_36731,type,
    v68221: ( state_type * $int ) > $o ).

tff(pred_def_36732,type,
    v68217: ( state_type * $int ) > $o ).

tff(pred_def_36733,type,
    v68200: ( state_type * $int ) > $o ).

tff(pred_def_36734,type,
    v68198: ( state_type * $int ) > $o ).

tff(pred_def_36735,type,
    v68229: state_type > $o ).

tff(pred_def_36736,type,
    v68227: state_type > $o ).

tff(pred_def_36737,type,
    v68226: state_type > $o ).

tff(pred_def_36738,type,
    v68225: ( state_type * $int ) > $o ).

tff(pred_def_36739,type,
    v68195: state_type > $o ).

tff(pred_def_36740,type,
    v68193: state_type > $o ).

tff(pred_def_36741,type,
    v68233: state_type > $o ).

tff(pred_def_36742,type,
    v68111: state_type > $o ).

tff(pred_def_36743,type,
    v68109: state_type > $o ).

tff(pred_def_36744,type,
    v68107: state_type > $o ).

tff(pred_def_36745,type,
    v68105: state_type > $o ).

tff(pred_def_36746,type,
    v68103: state_type > $o ).

tff(pred_def_36747,type,
    v68270: state_type > $o ).

tff(pred_def_36748,type,
    v68268: state_type > $o ).

tff(pred_def_36749,type,
    v68266: state_type > $o ).

tff(pred_def_36750,type,
    v68264: state_type > $o ).

tff(pred_def_36751,type,
    v68262: state_type > $o ).

tff(pred_def_36752,type,
    v68280: state_type > $o ).

tff(pred_def_36753,type,
    v68278: state_type > $o ).

tff(pred_def_36754,type,
    v68276: state_type > $o ).

tff(pred_def_36755,type,
    v68274: state_type > $o ).

tff(pred_def_36756,type,
    v68272: state_type > $o ).

tff(pred_def_36757,type,
    v68302: state_type > $o ).

tff(pred_def_36758,type,
    v68301: ( state_type * $int ) > $o ).

tff(pred_def_36759,type,
    v68300: ( state_type * $int ) > $o ).

tff(pred_def_36760,type,
    v68298: ( state_type * $int ) > $o ).

tff(pred_def_36761,type,
    v68316: state_type > $o ).

tff(pred_def_36762,type,
    v68314: state_type > $o ).

tff(pred_def_36763,type,
    v68326: state_type > $o ).

tff(pred_def_36764,type,
    v68324: state_type > $o ).

tff(pred_def_36765,type,
    v68330: state_type > $o ).

tff(pred_def_36766,type,
    v68328: state_type > $o ).

tff(pred_def_36767,type,
    v68334: state_type > $o ).

tff(pred_def_36768,type,
    v68332: state_type > $o ).

tff(pred_def_36769,type,
    v68337: state_type > $o ).

tff(pred_def_36770,type,
    v68338: state_type > $o ).

tff(pred_def_36771,type,
    v68336: state_type > $o ).

tff(pred_def_36772,type,
    v68322: state_type > $o ).

tff(pred_def_36773,type,
    v68320: state_type > $o ).

tff(pred_def_36774,type,
    v68318: state_type > $o ).

tff(pred_def_36775,type,
    v68346: state_type > $o ).

tff(pred_def_36776,type,
    v68344: state_type > $o ).

tff(pred_def_36777,type,
    v68342: state_type > $o ).

tff(pred_def_36778,type,
    v68340: state_type > $o ).

tff(pred_def_36779,type,
    v68352: state_type > $o ).

tff(pred_def_36780,type,
    v68350: state_type > $o ).

tff(pred_def_36781,type,
    v68348: state_type > $o ).

tff(pred_def_36782,type,
    v68312: ( state_type * $int ) > $o ).

tff(pred_def_36783,type,
    v68357: ( state_type * $int ) > $o ).

tff(pred_def_36784,type,
    v68355: ( state_type * $int ) > $o ).

tff(pred_def_36785,type,
    v68362: ( state_type * $int ) > $o ).

tff(pred_def_36786,type,
    v68361: ( state_type * $int ) > $o ).

tff(pred_def_36787,type,
    v68359: ( state_type * $int ) > $o ).

tff(pred_def_36788,type,
    v68367: ( state_type * $int ) > $o ).

tff(pred_def_36789,type,
    v68366: ( state_type * $int ) > $o ).

tff(pred_def_36790,type,
    v68364: ( state_type * $int ) > $o ).

tff(pred_def_36791,type,
    v68372: state_type > $o ).

tff(pred_def_36792,type,
    v68371: state_type > $o ).

tff(pred_def_36793,type,
    v68373: state_type > $o ).

tff(pred_def_36794,type,
    v68369: state_type > $o ).

tff(pred_def_36795,type,
    v68377: state_type > $o ).

tff(pred_def_36796,type,
    v68376: state_type > $o ).

tff(pred_def_36797,type,
    v68374: state_type > $o ).

tff(pred_def_36798,type,
    v68380: state_type > $o ).

tff(pred_def_36799,type,
    v68378: state_type > $o ).

tff(pred_def_36800,type,
    v68383: state_type > $o ).

tff(pred_def_36801,type,
    v68384: state_type > $o ).

tff(pred_def_36802,type,
    v68381: state_type > $o ).

tff(pred_def_36803,type,
    v68368: ( state_type * $int ) > $o ).

tff(pred_def_36804,type,
    v68310: ( state_type * $int ) > $o ).

tff(pred_def_36805,type,
    v68308: ( state_type * $int ) > $o ).

tff(pred_def_36806,type,
    v68306: ( state_type * $int ) > $o ).

tff(pred_def_36807,type,
    v68304: ( state_type * $int ) > $o ).

tff(pred_def_36808,type,
    v68385: ( state_type * $int ) > $o ).

tff(pred_def_36809,type,
    v68296: ( state_type * $int ) > $o ).

tff(pred_def_36810,type,
    v68294: ( state_type * $int ) > $o ).

tff(pred_def_36811,type,
    v68292: ( state_type * $int ) > $o ).

tff(pred_def_36812,type,
    v68290: ( state_type * $int ) > $o ).

tff(pred_def_36813,type,
    v68389: state_type > $o ).

tff(pred_def_36814,type,
    v68387: state_type > $o ).

tff(pred_def_36815,type,
    v68393: ( state_type * $int ) > $o ).

tff(pred_def_36816,type,
    v68391: ( state_type * $int ) > $o ).

tff(pred_def_36817,type,
    v68397: state_type > $o ).

tff(pred_def_36818,type,
    v68395: state_type > $o ).

tff(pred_def_36819,type,
    v68401: state_type > $o ).

tff(pred_def_36820,type,
    v68400: ( state_type * $int ) > $o ).

tff(pred_def_36821,type,
    v68399: ( state_type * $int ) > $o ).

tff(pred_def_36822,type,
    v68404: state_type > $o ).

tff(pred_def_36823,type,
    v68403: ( state_type * $int ) > $o ).

tff(pred_def_36824,type,
    v68402: ( state_type * $int ) > $o ).

tff(pred_def_36825,type,
    v68398: ( state_type * $int ) > $o ).

tff(pred_def_36826,type,
    v68288: ( state_type * $int ) > $o ).

tff(pred_def_36827,type,
    v68286: ( state_type * $int ) > $o ).

tff(pred_def_36828,type,
    v68284: ( state_type * $int ) > $o ).

tff(pred_def_36829,type,
    v68282: ( state_type * $int ) > $o ).

tff(pred_def_36830,type,
    v68414: state_type > $o ).

tff(pred_def_36831,type,
    v68412: state_type > $o ).

tff(pred_def_36832,type,
    v68420: state_type > $o ).

tff(pred_def_36833,type,
    v68418: state_type > $o ).

tff(pred_def_36834,type,
    v68416: state_type > $o ).

tff(pred_def_36835,type,
    v68422: state_type > $o ).

tff(pred_def_36836,type,
    v68410: state_type > $o ).

tff(pred_def_36837,type,
    v68408: state_type > $o ).

tff(pred_def_36838,type,
    v68406: state_type > $o ).

tff(pred_def_36839,type,
    v68429: state_type > $o ).

tff(pred_def_36840,type,
    v68427: state_type > $o ).

tff(pred_def_36841,type,
    v68426: state_type > $o ).

tff(pred_def_36842,type,
    v68425: state_type > $o ).

tff(pred_def_36843,type,
    v68437: state_type > $o ).

tff(pred_def_36844,type,
    v68438: state_type > $o ).

tff(pred_def_36845,type,
    v68436: state_type > $o ).

tff(pred_def_36846,type,
    v68433: ( state_type * $int ) > $o ).

tff(pred_def_36847,type,
    v68435: ( state_type * $int ) > $o ).

tff(pred_def_36848,type,
    v68424: ( state_type * $int ) > $o ).

tff(pred_def_36849,type,
    v68260: ( state_type * $int ) > $o ).

tff(pred_def_36850,type,
    v68258: ( state_type * $int ) > $o ).

tff(pred_def_36851,type,
    v68255: ( state_type * $int ) > $o ).

tff(pred_def_36852,type,
    v68253: ( state_type * $int ) > $o ).

tff(pred_def_36853,type,
    v68251: ( state_type * $int ) > $o ).

tff(pred_def_36854,type,
    v68249: ( state_type * $int ) > $o ).

tff(pred_def_36855,type,
    v68247: state_type > $o ).

tff(pred_def_36856,type,
    v68245: state_type > $o ).

tff(pred_def_36857,type,
    v68465: state_type > $o ).

tff(pred_def_36858,type,
    v68464: ( state_type * $int ) > $o ).

tff(pred_def_36859,type,
    v68463: ( state_type * $int ) > $o ).

tff(pred_def_36860,type,
    v68461: ( state_type * $int ) > $o ).

tff(pred_def_36861,type,
    v68481: state_type > $o ).

tff(pred_def_36862,type,
    v68479: state_type > $o ).

tff(pred_def_36863,type,
    v68491: state_type > $o ).

tff(pred_def_36864,type,
    v68489: state_type > $o ).

tff(pred_def_36865,type,
    v68495: state_type > $o ).

tff(pred_def_36866,type,
    v68493: state_type > $o ).

tff(pred_def_36867,type,
    v68499: state_type > $o ).

tff(pred_def_36868,type,
    v68497: state_type > $o ).

tff(pred_def_36869,type,
    v68502: state_type > $o ).

tff(pred_def_36870,type,
    v68503: state_type > $o ).

tff(pred_def_36871,type,
    v68501: state_type > $o ).

tff(pred_def_36872,type,
    v68487: state_type > $o ).

tff(pred_def_36873,type,
    v68485: state_type > $o ).

tff(pred_def_36874,type,
    v68483: state_type > $o ).

tff(pred_def_36875,type,
    v68511: state_type > $o ).

tff(pred_def_36876,type,
    v68509: state_type > $o ).

tff(pred_def_36877,type,
    v68507: state_type > $o ).

tff(pred_def_36878,type,
    v68505: state_type > $o ).

tff(pred_def_36879,type,
    v68517: state_type > $o ).

tff(pred_def_36880,type,
    v68515: state_type > $o ).

tff(pred_def_36881,type,
    v68513: state_type > $o ).

tff(pred_def_36882,type,
    v68477: ( state_type * $int ) > $o ).

tff(pred_def_36883,type,
    v68522: ( state_type * $int ) > $o ).

tff(pred_def_36884,type,
    v68520: ( state_type * $int ) > $o ).

tff(pred_def_36885,type,
    v68526: ( state_type * $int ) > $o ).

tff(pred_def_36886,type,
    v68524: ( state_type * $int ) > $o ).

tff(pred_def_36887,type,
    v68530: ( state_type * $int ) > $o ).

tff(pred_def_36888,type,
    v68528: ( state_type * $int ) > $o ).

tff(pred_def_36889,type,
    v68535: state_type > $o ).

tff(pred_def_36890,type,
    v68534: state_type > $o ).

tff(pred_def_36891,type,
    v68536: state_type > $o ).

tff(pred_def_36892,type,
    v68532: state_type > $o ).

tff(pred_def_36893,type,
    v68540: state_type > $o ).

tff(pred_def_36894,type,
    v68539: state_type > $o ).

tff(pred_def_36895,type,
    v68537: state_type > $o ).

tff(pred_def_36896,type,
    v68543: state_type > $o ).

tff(pred_def_36897,type,
    v68541: state_type > $o ).

tff(pred_def_36898,type,
    v68546: state_type > $o ).

tff(pred_def_36899,type,
    v68547: state_type > $o ).

tff(pred_def_36900,type,
    v68544: state_type > $o ).

tff(pred_def_36901,type,
    v68531: ( state_type * $int ) > $o ).

tff(pred_def_36902,type,
    v68475: ( state_type * $int ) > $o ).

tff(pred_def_36903,type,
    v68473: ( state_type * $int ) > $o ).

tff(pred_def_36904,type,
    v68471: ( state_type * $int ) > $o ).

tff(pred_def_36905,type,
    v68469: ( state_type * $int ) > $o ).

tff(pred_def_36906,type,
    v68467: ( state_type * $int ) > $o ).

tff(pred_def_36907,type,
    v68548: ( state_type * $int ) > $o ).

tff(pred_def_36908,type,
    v68459: ( state_type * $int ) > $o ).

tff(pred_def_36909,type,
    v68457: ( state_type * $int ) > $o ).

tff(pred_def_36910,type,
    v68455: ( state_type * $int ) > $o ).

tff(pred_def_36911,type,
    v68453: ( state_type * $int ) > $o ).

tff(pred_def_36912,type,
    v68451: ( state_type * $int ) > $o ).

tff(pred_def_36913,type,
    v68552: state_type > $o ).

tff(pred_def_36914,type,
    v68550: state_type > $o ).

tff(pred_def_36915,type,
    v68556: ( state_type * $int ) > $o ).

tff(pred_def_36916,type,
    v68554: ( state_type * $int ) > $o ).

tff(pred_def_36917,type,
    v68560: state_type > $o ).

tff(pred_def_36918,type,
    v68558: state_type > $o ).

tff(pred_def_36919,type,
    v68564: state_type > $o ).

tff(pred_def_36920,type,
    v68563: ( state_type * $int ) > $o ).

tff(pred_def_36921,type,
    v68562: ( state_type * $int ) > $o ).

tff(pred_def_36922,type,
    v68567: state_type > $o ).

tff(pred_def_36923,type,
    v68566: ( state_type * $int ) > $o ).

tff(pred_def_36924,type,
    v68565: ( state_type * $int ) > $o ).

tff(pred_def_36925,type,
    v68561: ( state_type * $int ) > $o ).

tff(pred_def_36926,type,
    v68449: ( state_type * $int ) > $o ).

tff(pred_def_36927,type,
    v68447: ( state_type * $int ) > $o ).

tff(pred_def_36928,type,
    v68573: state_type > $o ).

tff(pred_def_36929,type,
    v68571: state_type > $o ).

tff(pred_def_36930,type,
    v68570: state_type > $o ).

tff(pred_def_36931,type,
    v68569: ( state_type * $int ) > $o ).

tff(pred_def_36932,type,
    v68444: state_type > $o ).

tff(pred_def_36933,type,
    v68442: state_type > $o ).

tff(pred_def_36934,type,
    v68607: state_type > $o ).

tff(pred_def_36935,type,
    v68605: state_type > $o ).

tff(pred_def_36936,type,
    v68603: state_type > $o ).

tff(pred_def_36937,type,
    v68601: state_type > $o ).

tff(pred_def_36938,type,
    v68599: state_type > $o ).

tff(pred_def_36939,type,
    v68617: state_type > $o ).

tff(pred_def_36940,type,
    v68615: state_type > $o ).

tff(pred_def_36941,type,
    v68613: state_type > $o ).

tff(pred_def_36942,type,
    v68611: state_type > $o ).

tff(pred_def_36943,type,
    v68609: state_type > $o ).

tff(pred_def_36944,type,
    v68623: state_type > $o ).

tff(pred_def_36945,type,
    v68625: ( state_type * $int ) > $o ).

tff(pred_def_36946,type,
    v68624: ( state_type * $int ) > $o ).

tff(pred_def_36947,type,
    v68621: ( state_type * $int ) > $o ).

tff(pred_def_36948,type,
    v68619: ( state_type * $int ) > $o ).

tff(pred_def_36949,type,
    v68635: state_type > $o ).

tff(pred_def_36950,type,
    v68633: state_type > $o ).

tff(pred_def_36951,type,
    v68641: state_type > $o ).

tff(pred_def_36952,type,
    v68639: state_type > $o ).

tff(pred_def_36953,type,
    v68637: state_type > $o ).

tff(pred_def_36954,type,
    v68643: state_type > $o ).

tff(pred_def_36955,type,
    v68631: state_type > $o ).

tff(pred_def_36956,type,
    v68629: state_type > $o ).

tff(pred_def_36957,type,
    v68627: state_type > $o ).

tff(pred_def_36958,type,
    v68650: state_type > $o ).

tff(pred_def_36959,type,
    v68648: state_type > $o ).

tff(pred_def_36960,type,
    v68647: state_type > $o ).

tff(pred_def_36961,type,
    v68646: state_type > $o ).

tff(pred_def_36962,type,
    v68658: state_type > $o ).

tff(pred_def_36963,type,
    v68659: state_type > $o ).

tff(pred_def_36964,type,
    v68657: state_type > $o ).

tff(pred_def_36965,type,
    v68654: ( state_type * $int ) > $o ).

tff(pred_def_36966,type,
    v68656: ( state_type * $int ) > $o ).

tff(pred_def_36967,type,
    v68645: ( state_type * $int ) > $o ).

tff(pred_def_36968,type,
    v68597: ( state_type * $int ) > $o ).

tff(pred_def_36969,type,
    v68595: ( state_type * $int ) > $o ).

tff(pred_def_36970,type,
    v68593: state_type > $o ).

tff(pred_def_36971,type,
    v68591: state_type > $o ).

tff(pred_def_36972,type,
    v68662: ( state_type * $int ) > $o ).

tff(pred_def_36973,type,
    v68589: ( state_type * $int ) > $o ).

tff(pred_def_36974,type,
    v68587: ( state_type * $int ) > $o ).

tff(pred_def_36975,type,
    v68585: ( state_type * $int ) > $o ).

tff(pred_def_36976,type,
    v68583: ( state_type * $int ) > $o ).

tff(pred_def_36977,type,
    v68581: state_type > $o ).

tff(pred_def_36978,type,
    v68579: state_type > $o ).

tff(pred_def_36979,type,
    v68577: state_type > $o ).

tff(pred_def_36980,type,
    v68664: state_type > $o ).

tff(pred_def_36981,type,
    v68243: state_type > $o ).

tff(pred_def_36982,type,
    v68241: state_type > $o ).

tff(pred_def_36983,type,
    v68239: state_type > $o ).

tff(pred_def_36984,type,
    v68237: state_type > $o ).

tff(pred_def_36985,type,
    v68235: state_type > $o ).

tff(pred_def_36986,type,
    v68666: state_type > $o ).

tff(pred_def_36987,type,
    v67969: state_type > $o ).

tff(pred_def_36988,type,
    v67967: state_type > $o ).

tff(pred_def_36989,type,
    v67965: state_type > $o ).

tff(pred_def_36990,type,
    v67963: state_type > $o ).

tff(pred_def_36991,type,
    v67961: state_type > $o ).

tff(pred_def_36992,type,
    v68688: state_type > $o ).

tff(pred_def_36993,type,
    v68686: state_type > $o ).

tff(pred_def_36994,type,
    v68684: state_type > $o ).

tff(pred_def_36995,type,
    v68682: state_type > $o ).

tff(pred_def_36996,type,
    v68680: state_type > $o ).

tff(pred_def_36997,type,
    v68698: state_type > $o ).

tff(pred_def_36998,type,
    v68696: state_type > $o ).

tff(pred_def_36999,type,
    v68694: state_type > $o ).

tff(pred_def_37000,type,
    v68692: state_type > $o ).

tff(pred_def_37001,type,
    v68690: state_type > $o ).

tff(pred_def_37002,type,
    v68711: ( state_type * $int ) > $o ).

tff(pred_def_37003,type,
    v68709: ( state_type * $int ) > $o ).

tff(pred_def_37004,type,
    v68715: state_type > $o ).

tff(pred_def_37005,type,
    v68713: state_type > $o ).

tff(pred_def_37006,type,
    v68719: ( state_type * $int ) > $o ).

tff(pred_def_37007,type,
    v68717: ( state_type * $int ) > $o ).

tff(pred_def_37008,type,
    v68723: state_type > $o ).

tff(pred_def_37009,type,
    v68721: state_type > $o ).

tff(pred_def_37010,type,
    v68727: state_type > $o ).

tff(pred_def_37011,type,
    v68726: ( state_type * $int ) > $o ).

tff(pred_def_37012,type,
    v68725: ( state_type * $int ) > $o ).

tff(pred_def_37013,type,
    v68730: state_type > $o ).

tff(pred_def_37014,type,
    v68729: ( state_type * $int ) > $o ).

tff(pred_def_37015,type,
    v68728: ( state_type * $int ) > $o ).

tff(pred_def_37016,type,
    v68724: ( state_type * $int ) > $o ).

tff(pred_def_37017,type,
    v68707: ( state_type * $int ) > $o ).

tff(pred_def_37018,type,
    v68705: ( state_type * $int ) > $o ).

tff(pred_def_37019,type,
    v68732: state_type > $o ).

tff(pred_def_37020,type,
    v68731: ( state_type * $int ) > $o ).

tff(pred_def_37021,type,
    v68702: ( state_type * $int ) > $o ).

tff(pred_def_37022,type,
    v68700: ( state_type * $int ) > $o ).

tff(pred_def_37023,type,
    v68742: state_type > $o ).

tff(pred_def_37024,type,
    v68740: state_type > $o ).

tff(pred_def_37025,type,
    v68748: state_type > $o ).

tff(pred_def_37026,type,
    v68746: state_type > $o ).

tff(pred_def_37027,type,
    v68744: state_type > $o ).

tff(pred_def_37028,type,
    v68750: state_type > $o ).

tff(pred_def_37029,type,
    v68738: state_type > $o ).

tff(pred_def_37030,type,
    v68736: state_type > $o ).

tff(pred_def_37031,type,
    v68734: state_type > $o ).

tff(pred_def_37032,type,
    v68757: state_type > $o ).

tff(pred_def_37033,type,
    v68755: state_type > $o ).

tff(pred_def_37034,type,
    v68754: state_type > $o ).

tff(pred_def_37035,type,
    v68753: state_type > $o ).

tff(pred_def_37036,type,
    v68765: state_type > $o ).

tff(pred_def_37037,type,
    v68766: state_type > $o ).

tff(pred_def_37038,type,
    v68764: state_type > $o ).

tff(pred_def_37039,type,
    v68761: ( state_type * $int ) > $o ).

tff(pred_def_37040,type,
    v68763: ( state_type * $int ) > $o ).

tff(pred_def_37041,type,
    v68752: ( state_type * $int ) > $o ).

tff(pred_def_37042,type,
    v68678: ( state_type * $int ) > $o ).

tff(pred_def_37043,type,
    v68676: ( state_type * $int ) > $o ).

tff(pred_def_37044,type,
    v68674: ( state_type * $int ) > $o ).

tff(pred_def_37045,type,
    v68672: ( state_type * $int ) > $o ).

tff(pred_def_37046,type,
    v68670: state_type > $o ).

tff(pred_def_37047,type,
    v68668: state_type > $o ).

tff(pred_def_37048,type,
    v68770: state_type > $o ).

tff(pred_def_37049,type,
    v67323: state_type > $o ).

tff(pred_def_37050,type,
    v67321: state_type > $o ).

tff(pred_def_37051,type,
    v67319: ( state_type * $int ) > $o ).

tff(pred_def_37052,type,
    v68772: ( state_type * $int ) > $o ).

tff(pred_def_37053,type,
    v68771: ( state_type * $int ) > $o ).

tff(pred_def_37054,type,
    v68773: ( state_type * $int ) > $o ).

tff(pred_def_37055,type,
    v68774: ( state_type * $int ) > $o ).

tff(pred_def_37056,type,
    v67317: ( state_type * $int ) > $o ).

tff(pred_def_37057,type,
    v67315: ( state_type * $int ) > $o ).

tff(pred_def_37058,type,
    v67313: ( state_type * $int ) > $o ).

tff(pred_def_37059,type,
    v67311: ( state_type * $int ) > $o ).

tff(pred_def_37060,type,
    v67309: ( state_type * $int ) > $o ).

tff(pred_def_37061,type,
    v67307: ( state_type * $int ) > $o ).

tff(pred_def_37062,type,
    v67305: state_type > $o ).

tff(pred_def_37063,type,
    v67303: state_type > $o ).

tff(pred_def_37064,type,
    v68812: state_type > $o ).

tff(pred_def_37065,type,
    v68810: state_type > $o ).

tff(pred_def_37066,type,
    v68809: state_type > $o ).

tff(pred_def_37067,type,
    v68808: ( state_type * $int ) > $o ).

tff(pred_def_37068,type,
    v68806: state_type > $o ).

tff(pred_def_37069,type,
    v68804: state_type > $o ).

tff(pred_def_37070,type,
    v68824: state_type > $o ).

tff(pred_def_37071,type,
    v68822: state_type > $o ).

tff(pred_def_37072,type,
    v68821: state_type > $o ).

tff(pred_def_37073,type,
    v68820: ( state_type * $int ) > $o ).

tff(pred_def_37074,type,
    v68818: state_type > $o ).

tff(pred_def_37075,type,
    v68816: state_type > $o ).

tff(pred_def_37076,type,
    v68836: state_type > $o ).

tff(pred_def_37077,type,
    v68834: state_type > $o ).

tff(pred_def_37078,type,
    v68833: state_type > $o ).

tff(pred_def_37079,type,
    v68832: ( state_type * $int ) > $o ).

tff(pred_def_37080,type,
    v68830: state_type > $o ).

tff(pred_def_37081,type,
    v68828: state_type > $o ).

tff(pred_def_37082,type,
    v68840: state_type > $o ).

tff(pred_def_37083,type,
    v68802: state_type > $o ).

tff(pred_def_37084,type,
    v68800: state_type > $o ).

tff(pred_def_37085,type,
    v68798: state_type > $o ).

tff(pred_def_37086,type,
    v68796: state_type > $o ).

tff(pred_def_37087,type,
    v68794: state_type > $o ).

tff(pred_def_37088,type,
    v68860: state_type > $o ).

tff(pred_def_37089,type,
    v68858: state_type > $o ).

tff(pred_def_37090,type,
    v68857: state_type > $o ).

tff(pred_def_37091,type,
    v68856: ( state_type * $int ) > $o ).

tff(pred_def_37092,type,
    v68854: state_type > $o ).

tff(pred_def_37093,type,
    v68852: state_type > $o ).

tff(pred_def_37094,type,
    v68872: state_type > $o ).

tff(pred_def_37095,type,
    v68870: state_type > $o ).

tff(pred_def_37096,type,
    v68869: state_type > $o ).

tff(pred_def_37097,type,
    v68868: ( state_type * $int ) > $o ).

tff(pred_def_37098,type,
    v68866: state_type > $o ).

tff(pred_def_37099,type,
    v68864: state_type > $o ).

tff(pred_def_37100,type,
    v68884: state_type > $o ).

tff(pred_def_37101,type,
    v68882: state_type > $o ).

tff(pred_def_37102,type,
    v68881: state_type > $o ).

tff(pred_def_37103,type,
    v68880: ( state_type * $int ) > $o ).

tff(pred_def_37104,type,
    v68878: state_type > $o ).

tff(pred_def_37105,type,
    v68876: state_type > $o ).

tff(pred_def_37106,type,
    v68888: state_type > $o ).

tff(pred_def_37107,type,
    v68850: state_type > $o ).

tff(pred_def_37108,type,
    v68848: state_type > $o ).

tff(pred_def_37109,type,
    v68846: state_type > $o ).

tff(pred_def_37110,type,
    v68844: state_type > $o ).

tff(pred_def_37111,type,
    v68842: state_type > $o ).

tff(pred_def_37112,type,
    v68908: state_type > $o ).

tff(pred_def_37113,type,
    v68906: state_type > $o ).

tff(pred_def_37114,type,
    v68905: state_type > $o ).

tff(pred_def_37115,type,
    v68904: ( state_type * $int ) > $o ).

tff(pred_def_37116,type,
    v68902: state_type > $o ).

tff(pred_def_37117,type,
    v68900: state_type > $o ).

tff(pred_def_37118,type,
    v68920: state_type > $o ).

tff(pred_def_37119,type,
    v68918: state_type > $o ).

tff(pred_def_37120,type,
    v68917: state_type > $o ).

tff(pred_def_37121,type,
    v68916: ( state_type * $int ) > $o ).

tff(pred_def_37122,type,
    v68914: state_type > $o ).

tff(pred_def_37123,type,
    v68912: state_type > $o ).

tff(pred_def_37124,type,
    v68932: state_type > $o ).

tff(pred_def_37125,type,
    v68930: state_type > $o ).

tff(pred_def_37126,type,
    v68929: state_type > $o ).

tff(pred_def_37127,type,
    v68928: ( state_type * $int ) > $o ).

tff(pred_def_37128,type,
    v68926: state_type > $o ).

tff(pred_def_37129,type,
    v68924: state_type > $o ).

tff(pred_def_37130,type,
    v68936: state_type > $o ).

tff(pred_def_37131,type,
    v68898: state_type > $o ).

tff(pred_def_37132,type,
    v68896: state_type > $o ).

tff(pred_def_37133,type,
    v68894: state_type > $o ).

tff(pred_def_37134,type,
    v68892: state_type > $o ).

tff(pred_def_37135,type,
    v68890: state_type > $o ).

tff(pred_def_37136,type,
    v68938: state_type > $o ).

tff(pred_def_37137,type,
    v68792: state_type > $o ).

tff(pred_def_37138,type,
    v68790: state_type > $o ).

tff(pred_def_37139,type,
    v68788: state_type > $o ).

tff(pred_def_37140,type,
    v68786: state_type > $o ).

tff(pred_def_37141,type,
    v68784: state_type > $o ).

tff(pred_def_37142,type,
    v68968: state_type > $o ).

tff(pred_def_37143,type,
    v68966: state_type > $o ).

tff(pred_def_37144,type,
    v68965: state_type > $o ).

tff(pred_def_37145,type,
    v68964: ( state_type * $int ) > $o ).

tff(pred_def_37146,type,
    v68962: state_type > $o ).

tff(pred_def_37147,type,
    v68960: state_type > $o ).

tff(pred_def_37148,type,
    v68980: state_type > $o ).

tff(pred_def_37149,type,
    v68978: state_type > $o ).

tff(pred_def_37150,type,
    v68977: state_type > $o ).

tff(pred_def_37151,type,
    v68976: ( state_type * $int ) > $o ).

tff(pred_def_37152,type,
    v68974: state_type > $o ).

tff(pred_def_37153,type,
    v68972: state_type > $o ).

tff(pred_def_37154,type,
    v68992: state_type > $o ).

tff(pred_def_37155,type,
    v68990: state_type > $o ).

tff(pred_def_37156,type,
    v68989: state_type > $o ).

tff(pred_def_37157,type,
    v68988: ( state_type * $int ) > $o ).

tff(pred_def_37158,type,
    v68986: state_type > $o ).

tff(pred_def_37159,type,
    v68984: state_type > $o ).

tff(pred_def_37160,type,
    v68996: state_type > $o ).

tff(pred_def_37161,type,
    v68958: state_type > $o ).

tff(pred_def_37162,type,
    v68956: state_type > $o ).

tff(pred_def_37163,type,
    v68954: state_type > $o ).

tff(pred_def_37164,type,
    v68952: state_type > $o ).

tff(pred_def_37165,type,
    v68950: state_type > $o ).

tff(pred_def_37166,type,
    v69016: state_type > $o ).

tff(pred_def_37167,type,
    v69014: state_type > $o ).

tff(pred_def_37168,type,
    v69013: state_type > $o ).

tff(pred_def_37169,type,
    v69012: ( state_type * $int ) > $o ).

tff(pred_def_37170,type,
    v69010: state_type > $o ).

tff(pred_def_37171,type,
    v69008: state_type > $o ).

tff(pred_def_37172,type,
    v69028: state_type > $o ).

tff(pred_def_37173,type,
    v69026: state_type > $o ).

tff(pred_def_37174,type,
    v69025: state_type > $o ).

tff(pred_def_37175,type,
    v69024: ( state_type * $int ) > $o ).

tff(pred_def_37176,type,
    v69022: state_type > $o ).

tff(pred_def_37177,type,
    v69020: state_type > $o ).

tff(pred_def_37178,type,
    v69040: state_type > $o ).

tff(pred_def_37179,type,
    v69038: state_type > $o ).

tff(pred_def_37180,type,
    v69037: state_type > $o ).

tff(pred_def_37181,type,
    v69036: ( state_type * $int ) > $o ).

tff(pred_def_37182,type,
    v69034: state_type > $o ).

tff(pred_def_37183,type,
    v69032: state_type > $o ).

tff(pred_def_37184,type,
    v69044: state_type > $o ).

tff(pred_def_37185,type,
    v69006: state_type > $o ).

tff(pred_def_37186,type,
    v69004: state_type > $o ).

tff(pred_def_37187,type,
    v69002: state_type > $o ).

tff(pred_def_37188,type,
    v69000: state_type > $o ).

tff(pred_def_37189,type,
    v68998: state_type > $o ).

tff(pred_def_37190,type,
    v69064: state_type > $o ).

tff(pred_def_37191,type,
    v69062: state_type > $o ).

tff(pred_def_37192,type,
    v69061: state_type > $o ).

tff(pred_def_37193,type,
    v69060: ( state_type * $int ) > $o ).

tff(pred_def_37194,type,
    v69058: state_type > $o ).

tff(pred_def_37195,type,
    v69056: state_type > $o ).

tff(pred_def_37196,type,
    v69076: state_type > $o ).

tff(pred_def_37197,type,
    v69074: state_type > $o ).

tff(pred_def_37198,type,
    v69073: state_type > $o ).

tff(pred_def_37199,type,
    v69072: ( state_type * $int ) > $o ).

tff(pred_def_37200,type,
    v69070: state_type > $o ).

tff(pred_def_37201,type,
    v69068: state_type > $o ).

tff(pred_def_37202,type,
    v69082: state_type > $o ).

tff(pred_def_37203,type,
    v69080: state_type > $o ).

tff(pred_def_37204,type,
    v69084: state_type > $o ).

tff(pred_def_37205,type,
    v69054: state_type > $o ).

tff(pred_def_37206,type,
    v69052: state_type > $o ).

tff(pred_def_37207,type,
    v69050: state_type > $o ).

tff(pred_def_37208,type,
    v69048: state_type > $o ).

tff(pred_def_37209,type,
    v69046: state_type > $o ).

tff(pred_def_37210,type,
    v69086: state_type > $o ).

tff(pred_def_37211,type,
    v68948: state_type > $o ).

tff(pred_def_37212,type,
    v68946: state_type > $o ).

tff(pred_def_37213,type,
    v68944: state_type > $o ).

tff(pred_def_37214,type,
    v68942: state_type > $o ).

tff(pred_def_37215,type,
    v68940: state_type > $o ).

tff(pred_def_37216,type,
    v69096: state_type > $o ).

tff(pred_def_37217,type,
    v69094: state_type > $o ).

tff(pred_def_37218,type,
    v69093: state_type > $o ).

tff(pred_def_37219,type,
    v69092: ( state_type * $int ) > $o ).

tff(pred_def_37220,type,
    v69090: state_type > $o ).

tff(pred_def_37221,type,
    v69088: state_type > $o ).

tff(pred_def_37222,type,
    v69100: state_type > $o ).

tff(pred_def_37223,type,
    v68782: state_type > $o ).

tff(pred_def_37224,type,
    v68780: state_type > $o ).

tff(pred_def_37225,type,
    v68778: state_type > $o ).

tff(pred_def_37226,type,
    v68776: state_type > $o ).

tff(pred_def_37227,type,
    v69102: state_type > $o ).

tff(pred_def_37228,type,
    v67301: state_type > $o ).

tff(pred_def_37229,type,
    v67299: state_type > $o ).

tff(pred_def_37230,type,
    v67297: state_type > $o ).

tff(pred_def_37231,type,
    v67295: state_type > $o ).

tff(pred_def_37232,type,
    v67293: state_type > $o ).

tff(pred_def_37233,type,
    v69150: state_type > $o ).

tff(pred_def_37234,type,
    v69148: state_type > $o ).

tff(pred_def_37235,type,
    v69147: state_type > $o ).

tff(pred_def_37236,type,
    v69146: ( state_type * $int ) > $o ).

tff(pred_def_37237,type,
    v69144: state_type > $o ).

tff(pred_def_37238,type,
    v69142: state_type > $o ).

tff(pred_def_37239,type,
    v69162: state_type > $o ).

tff(pred_def_37240,type,
    v69160: state_type > $o ).

tff(pred_def_37241,type,
    v69159: state_type > $o ).

tff(pred_def_37242,type,
    v69158: ( state_type * $int ) > $o ).

tff(pred_def_37243,type,
    v69156: state_type > $o ).

tff(pred_def_37244,type,
    v69154: state_type > $o ).

tff(pred_def_37245,type,
    v69174: state_type > $o ).

tff(pred_def_37246,type,
    v69172: state_type > $o ).

tff(pred_def_37247,type,
    v69171: state_type > $o ).

tff(pred_def_37248,type,
    v69170: ( state_type * $int ) > $o ).

tff(pred_def_37249,type,
    v69168: state_type > $o ).

tff(pred_def_37250,type,
    v69166: state_type > $o ).

tff(pred_def_37251,type,
    v69178: state_type > $o ).

tff(pred_def_37252,type,
    v69140: state_type > $o ).

tff(pred_def_37253,type,
    v69138: state_type > $o ).

tff(pred_def_37254,type,
    v69136: state_type > $o ).

tff(pred_def_37255,type,
    v69134: state_type > $o ).

tff(pred_def_37256,type,
    v69132: state_type > $o ).

tff(pred_def_37257,type,
    v69198: state_type > $o ).

tff(pred_def_37258,type,
    v69196: state_type > $o ).

tff(pred_def_37259,type,
    v69195: state_type > $o ).

tff(pred_def_37260,type,
    v69194: ( state_type * $int ) > $o ).

tff(pred_def_37261,type,
    v69192: state_type > $o ).

tff(pred_def_37262,type,
    v69190: state_type > $o ).

tff(pred_def_37263,type,
    v69210: state_type > $o ).

tff(pred_def_37264,type,
    v69208: state_type > $o ).

tff(pred_def_37265,type,
    v69207: state_type > $o ).

tff(pred_def_37266,type,
    v69206: ( state_type * $int ) > $o ).

tff(pred_def_37267,type,
    v69204: state_type > $o ).

tff(pred_def_37268,type,
    v69202: state_type > $o ).

tff(pred_def_37269,type,
    v69222: state_type > $o ).

tff(pred_def_37270,type,
    v69220: state_type > $o ).

tff(pred_def_37271,type,
    v69219: state_type > $o ).

tff(pred_def_37272,type,
    v69218: ( state_type * $int ) > $o ).

tff(pred_def_37273,type,
    v69216: state_type > $o ).

tff(pred_def_37274,type,
    v69214: state_type > $o ).

tff(pred_def_37275,type,
    v69226: state_type > $o ).

tff(pred_def_37276,type,
    v69188: state_type > $o ).

tff(pred_def_37277,type,
    v69186: state_type > $o ).

tff(pred_def_37278,type,
    v69184: state_type > $o ).

tff(pred_def_37279,type,
    v69182: state_type > $o ).

tff(pred_def_37280,type,
    v69180: state_type > $o ).

tff(pred_def_37281,type,
    v69246: state_type > $o ).

tff(pred_def_37282,type,
    v69244: state_type > $o ).

tff(pred_def_37283,type,
    v69243: state_type > $o ).

tff(pred_def_37284,type,
    v69242: ( state_type * $int ) > $o ).

tff(pred_def_37285,type,
    v69240: state_type > $o ).

tff(pred_def_37286,type,
    v69238: state_type > $o ).

tff(pred_def_37287,type,
    v69258: state_type > $o ).

tff(pred_def_37288,type,
    v69256: state_type > $o ).

tff(pred_def_37289,type,
    v69255: state_type > $o ).

tff(pred_def_37290,type,
    v69254: ( state_type * $int ) > $o ).

tff(pred_def_37291,type,
    v69252: state_type > $o ).

tff(pred_def_37292,type,
    v69250: state_type > $o ).

tff(pred_def_37293,type,
    v69270: state_type > $o ).

tff(pred_def_37294,type,
    v69268: state_type > $o ).

tff(pred_def_37295,type,
    v69267: state_type > $o ).

tff(pred_def_37296,type,
    v69266: ( state_type * $int ) > $o ).

tff(pred_def_37297,type,
    v69264: state_type > $o ).

tff(pred_def_37298,type,
    v69262: state_type > $o ).

tff(pred_def_37299,type,
    v69274: state_type > $o ).

tff(pred_def_37300,type,
    v69236: state_type > $o ).

tff(pred_def_37301,type,
    v69234: state_type > $o ).

tff(pred_def_37302,type,
    v69232: state_type > $o ).

tff(pred_def_37303,type,
    v69230: state_type > $o ).

tff(pred_def_37304,type,
    v69228: state_type > $o ).

tff(pred_def_37305,type,
    v69276: state_type > $o ).

tff(pred_def_37306,type,
    v69130: state_type > $o ).

tff(pred_def_37307,type,
    v69128: state_type > $o ).

tff(pred_def_37308,type,
    v69126: state_type > $o ).

tff(pred_def_37309,type,
    v69124: state_type > $o ).

tff(pred_def_37310,type,
    v69122: state_type > $o ).

tff(pred_def_37311,type,
    v69306: state_type > $o ).

tff(pred_def_37312,type,
    v69304: state_type > $o ).

tff(pred_def_37313,type,
    v69303: state_type > $o ).

tff(pred_def_37314,type,
    v69302: ( state_type * $int ) > $o ).

tff(pred_def_37315,type,
    v69300: state_type > $o ).

tff(pred_def_37316,type,
    v69298: state_type > $o ).

tff(pred_def_37317,type,
    v69318: state_type > $o ).

tff(pred_def_37318,type,
    v69316: state_type > $o ).

tff(pred_def_37319,type,
    v69315: state_type > $o ).

tff(pred_def_37320,type,
    v69314: ( state_type * $int ) > $o ).

tff(pred_def_37321,type,
    v69312: state_type > $o ).

tff(pred_def_37322,type,
    v69310: state_type > $o ).

tff(pred_def_37323,type,
    v69330: state_type > $o ).

tff(pred_def_37324,type,
    v69328: state_type > $o ).

tff(pred_def_37325,type,
    v69327: state_type > $o ).

tff(pred_def_37326,type,
    v69326: ( state_type * $int ) > $o ).

tff(pred_def_37327,type,
    v69324: state_type > $o ).

tff(pred_def_37328,type,
    v69322: state_type > $o ).

tff(pred_def_37329,type,
    v69334: state_type > $o ).

tff(pred_def_37330,type,
    v69296: state_type > $o ).

tff(pred_def_37331,type,
    v69294: state_type > $o ).

tff(pred_def_37332,type,
    v69292: state_type > $o ).

tff(pred_def_37333,type,
    v69290: state_type > $o ).

tff(pred_def_37334,type,
    v69288: state_type > $o ).

tff(pred_def_37335,type,
    v69354: state_type > $o ).

tff(pred_def_37336,type,
    v69352: state_type > $o ).

tff(pred_def_37337,type,
    v69351: state_type > $o ).

tff(pred_def_37338,type,
    v69350: ( state_type * $int ) > $o ).

tff(pred_def_37339,type,
    v69348: state_type > $o ).

tff(pred_def_37340,type,
    v69346: state_type > $o ).

tff(pred_def_37341,type,
    v69366: state_type > $o ).

tff(pred_def_37342,type,
    v69364: state_type > $o ).

tff(pred_def_37343,type,
    v69363: state_type > $o ).

tff(pred_def_37344,type,
    v69362: ( state_type * $int ) > $o ).

tff(pred_def_37345,type,
    v69360: state_type > $o ).

tff(pred_def_37346,type,
    v69358: state_type > $o ).

tff(pred_def_37347,type,
    v69378: state_type > $o ).

tff(pred_def_37348,type,
    v69376: state_type > $o ).

tff(pred_def_37349,type,
    v69375: state_type > $o ).

tff(pred_def_37350,type,
    v69374: ( state_type * $int ) > $o ).

tff(pred_def_37351,type,
    v69372: state_type > $o ).

tff(pred_def_37352,type,
    v69370: state_type > $o ).

tff(pred_def_37353,type,
    v69382: state_type > $o ).

tff(pred_def_37354,type,
    v69344: state_type > $o ).

tff(pred_def_37355,type,
    v69342: state_type > $o ).

tff(pred_def_37356,type,
    v69340: state_type > $o ).

tff(pred_def_37357,type,
    v69338: state_type > $o ).

tff(pred_def_37358,type,
    v69336: state_type > $o ).

tff(pred_def_37359,type,
    v69402: state_type > $o ).

tff(pred_def_37360,type,
    v69400: state_type > $o ).

tff(pred_def_37361,type,
    v69399: state_type > $o ).

tff(pred_def_37362,type,
    v69398: ( state_type * $int ) > $o ).

tff(pred_def_37363,type,
    v69396: state_type > $o ).

tff(pred_def_37364,type,
    v69394: state_type > $o ).

tff(pred_def_37365,type,
    v69414: state_type > $o ).

tff(pred_def_37366,type,
    v69412: state_type > $o ).

tff(pred_def_37367,type,
    v69411: state_type > $o ).

tff(pred_def_37368,type,
    v69410: ( state_type * $int ) > $o ).

tff(pred_def_37369,type,
    v69408: state_type > $o ).

tff(pred_def_37370,type,
    v69406: state_type > $o ).

tff(pred_def_37371,type,
    v69420: state_type > $o ).

tff(pred_def_37372,type,
    v69418: state_type > $o ).

tff(pred_def_37373,type,
    v69422: state_type > $o ).

tff(pred_def_37374,type,
    v69392: state_type > $o ).

tff(pred_def_37375,type,
    v69390: state_type > $o ).

tff(pred_def_37376,type,
    v69388: state_type > $o ).

tff(pred_def_37377,type,
    v69386: state_type > $o ).

tff(pred_def_37378,type,
    v69384: state_type > $o ).

tff(pred_def_37379,type,
    v69424: state_type > $o ).

tff(pred_def_37380,type,
    v69286: state_type > $o ).

tff(pred_def_37381,type,
    v69284: state_type > $o ).

tff(pred_def_37382,type,
    v69282: state_type > $o ).

tff(pred_def_37383,type,
    v69280: state_type > $o ).

tff(pred_def_37384,type,
    v69278: state_type > $o ).

tff(pred_def_37385,type,
    v69434: state_type > $o ).

tff(pred_def_37386,type,
    v69432: state_type > $o ).

tff(pred_def_37387,type,
    v69431: state_type > $o ).

tff(pred_def_37388,type,
    v69430: ( state_type * $int ) > $o ).

tff(pred_def_37389,type,
    v69428: state_type > $o ).

tff(pred_def_37390,type,
    v69426: state_type > $o ).

tff(pred_def_37391,type,
    v69438: state_type > $o ).

tff(pred_def_37392,type,
    v69120: state_type > $o ).

tff(pred_def_37393,type,
    v69118: state_type > $o ).

tff(pred_def_37394,type,
    v69116: state_type > $o ).

tff(pred_def_37395,type,
    v69114: state_type > $o ).

tff(pred_def_37396,type,
    v69476: state_type > $o ).

tff(pred_def_37397,type,
    v69474: state_type > $o ).

tff(pred_def_37398,type,
    v69473: state_type > $o ).

tff(pred_def_37399,type,
    v69472: ( state_type * $int ) > $o ).

tff(pred_def_37400,type,
    v69470: state_type > $o ).

tff(pred_def_37401,type,
    v69468: state_type > $o ).

tff(pred_def_37402,type,
    v69488: state_type > $o ).

tff(pred_def_37403,type,
    v69486: state_type > $o ).

tff(pred_def_37404,type,
    v69485: state_type > $o ).

tff(pred_def_37405,type,
    v69484: ( state_type * $int ) > $o ).

tff(pred_def_37406,type,
    v69482: state_type > $o ).

tff(pred_def_37407,type,
    v69480: state_type > $o ).

tff(pred_def_37408,type,
    v69500: state_type > $o ).

tff(pred_def_37409,type,
    v69498: state_type > $o ).

tff(pred_def_37410,type,
    v69497: state_type > $o ).

tff(pred_def_37411,type,
    v69496: ( state_type * $int ) > $o ).

tff(pred_def_37412,type,
    v69494: state_type > $o ).

tff(pred_def_37413,type,
    v69492: state_type > $o ).

tff(pred_def_37414,type,
    v69504: state_type > $o ).

tff(pred_def_37415,type,
    v69466: state_type > $o ).

tff(pred_def_37416,type,
    v69464: state_type > $o ).

tff(pred_def_37417,type,
    v69462: state_type > $o ).

tff(pred_def_37418,type,
    v69460: state_type > $o ).

tff(pred_def_37419,type,
    v69458: state_type > $o ).

tff(pred_def_37420,type,
    v69524: state_type > $o ).

tff(pred_def_37421,type,
    v69522: state_type > $o ).

tff(pred_def_37422,type,
    v69521: state_type > $o ).

tff(pred_def_37423,type,
    v69520: ( state_type * $int ) > $o ).

tff(pred_def_37424,type,
    v69518: state_type > $o ).

tff(pred_def_37425,type,
    v69516: state_type > $o ).

tff(pred_def_37426,type,
    v69536: state_type > $o ).

tff(pred_def_37427,type,
    v69534: state_type > $o ).

tff(pred_def_37428,type,
    v69533: state_type > $o ).

tff(pred_def_37429,type,
    v69532: ( state_type * $int ) > $o ).

tff(pred_def_37430,type,
    v69530: state_type > $o ).

tff(pred_def_37431,type,
    v69528: state_type > $o ).

tff(pred_def_37432,type,
    v69548: state_type > $o ).

tff(pred_def_37433,type,
    v69546: state_type > $o ).

tff(pred_def_37434,type,
    v69545: state_type > $o ).

tff(pred_def_37435,type,
    v69544: ( state_type * $int ) > $o ).

tff(pred_def_37436,type,
    v69542: state_type > $o ).

tff(pred_def_37437,type,
    v69540: state_type > $o ).

tff(pred_def_37438,type,
    v69552: state_type > $o ).

tff(pred_def_37439,type,
    v69514: state_type > $o ).

tff(pred_def_37440,type,
    v69512: state_type > $o ).

tff(pred_def_37441,type,
    v69510: state_type > $o ).

tff(pred_def_37442,type,
    v69508: state_type > $o ).

tff(pred_def_37443,type,
    v69506: state_type > $o ).

tff(pred_def_37444,type,
    v69572: state_type > $o ).

tff(pred_def_37445,type,
    v69570: state_type > $o ).

tff(pred_def_37446,type,
    v69569: state_type > $o ).

tff(pred_def_37447,type,
    v69568: ( state_type * $int ) > $o ).

tff(pred_def_37448,type,
    v69566: state_type > $o ).

tff(pred_def_37449,type,
    v69564: state_type > $o ).

tff(pred_def_37450,type,
    v69584: state_type > $o ).

tff(pred_def_37451,type,
    v69582: state_type > $o ).

tff(pred_def_37452,type,
    v69581: state_type > $o ).

tff(pred_def_37453,type,
    v69580: ( state_type * $int ) > $o ).

tff(pred_def_37454,type,
    v69578: state_type > $o ).

tff(pred_def_37455,type,
    v69576: state_type > $o ).

tff(pred_def_37456,type,
    v69596: state_type > $o ).

tff(pred_def_37457,type,
    v69594: state_type > $o ).

tff(pred_def_37458,type,
    v69593: state_type > $o ).

tff(pred_def_37459,type,
    v69592: ( state_type * $int ) > $o ).

tff(pred_def_37460,type,
    v69590: state_type > $o ).

tff(pred_def_37461,type,
    v69588: state_type > $o ).

tff(pred_def_37462,type,
    v69600: state_type > $o ).

tff(pred_def_37463,type,
    v69562: state_type > $o ).

tff(pred_def_37464,type,
    v69560: state_type > $o ).

tff(pred_def_37465,type,
    v69558: state_type > $o ).

tff(pred_def_37466,type,
    v69556: state_type > $o ).

tff(pred_def_37467,type,
    v69554: state_type > $o ).

tff(pred_def_37468,type,
    v69602: state_type > $o ).

tff(pred_def_37469,type,
    v69456: state_type > $o ).

tff(pred_def_37470,type,
    v69454: state_type > $o ).

tff(pred_def_37471,type,
    v69452: state_type > $o ).

tff(pred_def_37472,type,
    v69450: state_type > $o ).

tff(pred_def_37473,type,
    v69448: state_type > $o ).

tff(pred_def_37474,type,
    v69632: state_type > $o ).

tff(pred_def_37475,type,
    v69630: state_type > $o ).

tff(pred_def_37476,type,
    v69629: state_type > $o ).

tff(pred_def_37477,type,
    v69628: ( state_type * $int ) > $o ).

tff(pred_def_37478,type,
    v69626: state_type > $o ).

tff(pred_def_37479,type,
    v69624: state_type > $o ).

tff(pred_def_37480,type,
    v69644: state_type > $o ).

tff(pred_def_37481,type,
    v69642: state_type > $o ).

tff(pred_def_37482,type,
    v69641: state_type > $o ).

tff(pred_def_37483,type,
    v69640: ( state_type * $int ) > $o ).

tff(pred_def_37484,type,
    v69638: state_type > $o ).

tff(pred_def_37485,type,
    v69636: state_type > $o ).

tff(pred_def_37486,type,
    v69656: state_type > $o ).

tff(pred_def_37487,type,
    v69654: state_type > $o ).

tff(pred_def_37488,type,
    v69653: state_type > $o ).

tff(pred_def_37489,type,
    v69652: ( state_type * $int ) > $o ).

tff(pred_def_37490,type,
    v69650: state_type > $o ).

tff(pred_def_37491,type,
    v69648: state_type > $o ).

tff(pred_def_37492,type,
    v69660: state_type > $o ).

tff(pred_def_37493,type,
    v69622: state_type > $o ).

tff(pred_def_37494,type,
    v69620: state_type > $o ).

tff(pred_def_37495,type,
    v69618: state_type > $o ).

tff(pred_def_37496,type,
    v69616: state_type > $o ).

tff(pred_def_37497,type,
    v69614: state_type > $o ).

tff(pred_def_37498,type,
    v69680: state_type > $o ).

tff(pred_def_37499,type,
    v69678: state_type > $o ).

tff(pred_def_37500,type,
    v69677: state_type > $o ).

tff(pred_def_37501,type,
    v69676: ( state_type * $int ) > $o ).

tff(pred_def_37502,type,
    v69674: state_type > $o ).

tff(pred_def_37503,type,
    v69672: state_type > $o ).

tff(pred_def_37504,type,
    v69692: state_type > $o ).

tff(pred_def_37505,type,
    v69690: state_type > $o ).

tff(pred_def_37506,type,
    v69689: state_type > $o ).

tff(pred_def_37507,type,
    v69688: ( state_type * $int ) > $o ).

tff(pred_def_37508,type,
    v69686: state_type > $o ).

tff(pred_def_37509,type,
    v69684: state_type > $o ).

tff(pred_def_37510,type,
    v69704: state_type > $o ).

tff(pred_def_37511,type,
    v69702: state_type > $o ).

tff(pred_def_37512,type,
    v69701: state_type > $o ).

tff(pred_def_37513,type,
    v69700: ( state_type * $int ) > $o ).

tff(pred_def_37514,type,
    v69698: state_type > $o ).

tff(pred_def_37515,type,
    v69696: state_type > $o ).

tff(pred_def_37516,type,
    v69708: state_type > $o ).

tff(pred_def_37517,type,
    v69670: state_type > $o ).

tff(pred_def_37518,type,
    v69668: state_type > $o ).

tff(pred_def_37519,type,
    v69666: state_type > $o ).

tff(pred_def_37520,type,
    v69664: state_type > $o ).

tff(pred_def_37521,type,
    v69662: state_type > $o ).

tff(pred_def_37522,type,
    v69728: state_type > $o ).

tff(pred_def_37523,type,
    v69726: state_type > $o ).

tff(pred_def_37524,type,
    v69725: state_type > $o ).

tff(pred_def_37525,type,
    v69724: ( state_type * $int ) > $o ).

tff(pred_def_37526,type,
    v69722: state_type > $o ).

tff(pred_def_37527,type,
    v69720: state_type > $o ).

tff(pred_def_37528,type,
    v69740: state_type > $o ).

tff(pred_def_37529,type,
    v69738: state_type > $o ).

tff(pred_def_37530,type,
    v69737: state_type > $o ).

tff(pred_def_37531,type,
    v69736: ( state_type * $int ) > $o ).

tff(pred_def_37532,type,
    v69734: state_type > $o ).

tff(pred_def_37533,type,
    v69732: state_type > $o ).

tff(pred_def_37534,type,
    v69746: state_type > $o ).

tff(pred_def_37535,type,
    v69744: state_type > $o ).

tff(pred_def_37536,type,
    v69748: state_type > $o ).

tff(pred_def_37537,type,
    v69718: state_type > $o ).

tff(pred_def_37538,type,
    v69716: state_type > $o ).

tff(pred_def_37539,type,
    v69714: state_type > $o ).

tff(pred_def_37540,type,
    v69712: state_type > $o ).

tff(pred_def_37541,type,
    v69710: state_type > $o ).

tff(pred_def_37542,type,
    v69750: state_type > $o ).

tff(pred_def_37543,type,
    v69612: state_type > $o ).

tff(pred_def_37544,type,
    v69610: state_type > $o ).

tff(pred_def_37545,type,
    v69608: state_type > $o ).

tff(pred_def_37546,type,
    v69606: state_type > $o ).

tff(pred_def_37547,type,
    v69604: state_type > $o ).

tff(pred_def_37548,type,
    v69760: state_type > $o ).

tff(pred_def_37549,type,
    v69758: state_type > $o ).

tff(pred_def_37550,type,
    v69757: state_type > $o ).

tff(pred_def_37551,type,
    v69756: ( state_type * $int ) > $o ).

tff(pred_def_37552,type,
    v69754: state_type > $o ).

tff(pred_def_37553,type,
    v69752: state_type > $o ).

tff(pred_def_37554,type,
    v69764: state_type > $o ).

tff(pred_def_37555,type,
    v69446: state_type > $o ).

tff(pred_def_37556,type,
    v69444: state_type > $o ).

tff(pred_def_37557,type,
    v69442: state_type > $o ).

tff(pred_def_37558,type,
    v69440: state_type > $o ).

tff(pred_def_37559,type,
    v69766: state_type > $o ).

tff(pred_def_37560,type,
    v69112: state_type > $o ).

tff(pred_def_37561,type,
    v69110: state_type > $o ).

tff(pred_def_37562,type,
    v69108: state_type > $o ).

tff(pred_def_37563,type,
    v69106: state_type > $o ).

tff(pred_def_37564,type,
    v69104: state_type > $o ).

tff(pred_def_37565,type,
    v69768: state_type > $o ).

tff(pred_def_37566,type,
    v67291: state_type > $o ).

tff(pred_def_37567,type,
    v67289: state_type > $o ).

tff(pred_def_37568,type,
    v67287: state_type > $o ).

tff(pred_def_37569,type,
    v67285: state_type > $o ).

tff(pred_def_37570,type,
    v67283: state_type > $o ).

tff(pred_def_37571,type,
    v67281: state_type > $o ).

tff(pred_def_37572,type,
    v67279: state_type > $o ).

tff(pred_def_37573,type,
    v67277: state_type > $o ).

tff(pred_def_37574,type,
    v67275: state_type > $o ).

tff(pred_def_37575,type,
    v67273: state_type > $o ).

tff(pred_def_37576,type,
    v69843: ( state_type * $int ) > $o ).

tff(pred_def_37577,type,
    v69841: ( state_type * $int ) > $o ).

tff(pred_def_37578,type,
    v69847: state_type > $o ).

tff(pred_def_37579,type,
    v69845: state_type > $o ).

tff(pred_def_37580,type,
    v69851: ( state_type * $int ) > $o ).

tff(pred_def_37581,type,
    v69849: ( state_type * $int ) > $o ).

tff(pred_def_37582,type,
    v69855: state_type > $o ).

tff(pred_def_37583,type,
    v69853: state_type > $o ).

tff(pred_def_37584,type,
    v69859: state_type > $o ).

tff(pred_def_37585,type,
    v69858: ( state_type * $int ) > $o ).

tff(pred_def_37586,type,
    v69857: ( state_type * $int ) > $o ).

tff(pred_def_37587,type,
    v69862: state_type > $o ).

tff(pred_def_37588,type,
    v69861: ( state_type * $int ) > $o ).

tff(pred_def_37589,type,
    v69860: ( state_type * $int ) > $o ).

tff(pred_def_37590,type,
    v69856: ( state_type * $int ) > $o ).

tff(pred_def_37591,type,
    v69839: ( state_type * $int ) > $o ).

tff(pred_def_37592,type,
    v69837: ( state_type * $int ) > $o ).

tff(pred_def_37593,type,
    v69868: state_type > $o ).

tff(pred_def_37594,type,
    v69866: state_type > $o ).

tff(pred_def_37595,type,
    v69865: state_type > $o ).

tff(pred_def_37596,type,
    v69864: ( state_type * $int ) > $o ).

tff(pred_def_37597,type,
    v69834: state_type > $o ).

tff(pred_def_37598,type,
    v69832: state_type > $o ).

tff(pred_def_37599,type,
    v69883: ( state_type * $int ) > $o ).

tff(pred_def_37600,type,
    v69881: ( state_type * $int ) > $o ).

tff(pred_def_37601,type,
    v69887: state_type > $o ).

tff(pred_def_37602,type,
    v69885: state_type > $o ).

tff(pred_def_37603,type,
    v69891: ( state_type * $int ) > $o ).

tff(pred_def_37604,type,
    v69889: ( state_type * $int ) > $o ).

tff(pred_def_37605,type,
    v69895: state_type > $o ).

tff(pred_def_37606,type,
    v69893: state_type > $o ).

tff(pred_def_37607,type,
    v69899: state_type > $o ).

tff(pred_def_37608,type,
    v69898: ( state_type * $int ) > $o ).

tff(pred_def_37609,type,
    v69897: ( state_type * $int ) > $o ).

tff(pred_def_37610,type,
    v69902: state_type > $o ).

tff(pred_def_37611,type,
    v69901: ( state_type * $int ) > $o ).

tff(pred_def_37612,type,
    v69900: ( state_type * $int ) > $o ).

tff(pred_def_37613,type,
    v69896: ( state_type * $int ) > $o ).

tff(pred_def_37614,type,
    v69879: ( state_type * $int ) > $o ).

tff(pred_def_37615,type,
    v69877: ( state_type * $int ) > $o ).

tff(pred_def_37616,type,
    v69908: state_type > $o ).

tff(pred_def_37617,type,
    v69906: state_type > $o ).

tff(pred_def_37618,type,
    v69905: state_type > $o ).

tff(pred_def_37619,type,
    v69904: ( state_type * $int ) > $o ).

tff(pred_def_37620,type,
    v69874: state_type > $o ).

tff(pred_def_37621,type,
    v69872: state_type > $o ).

tff(pred_def_37622,type,
    v69923: ( state_type * $int ) > $o ).

tff(pred_def_37623,type,
    v69921: ( state_type * $int ) > $o ).

tff(pred_def_37624,type,
    v69927: state_type > $o ).

tff(pred_def_37625,type,
    v69925: state_type > $o ).

tff(pred_def_37626,type,
    v69931: ( state_type * $int ) > $o ).

tff(pred_def_37627,type,
    v69929: ( state_type * $int ) > $o ).

tff(pred_def_37628,type,
    v69935: state_type > $o ).

tff(pred_def_37629,type,
    v69933: state_type > $o ).

tff(pred_def_37630,type,
    v69939: state_type > $o ).

tff(pred_def_37631,type,
    v69938: ( state_type * $int ) > $o ).

tff(pred_def_37632,type,
    v69937: ( state_type * $int ) > $o ).

tff(pred_def_37633,type,
    v69942: state_type > $o ).

tff(pred_def_37634,type,
    v69941: ( state_type * $int ) > $o ).

tff(pred_def_37635,type,
    v69940: ( state_type * $int ) > $o ).

tff(pred_def_37636,type,
    v69936: ( state_type * $int ) > $o ).

tff(pred_def_37637,type,
    v69919: ( state_type * $int ) > $o ).

tff(pred_def_37638,type,
    v69917: ( state_type * $int ) > $o ).

tff(pred_def_37639,type,
    v69948: state_type > $o ).

tff(pred_def_37640,type,
    v69946: state_type > $o ).

tff(pred_def_37641,type,
    v69945: state_type > $o ).

tff(pred_def_37642,type,
    v69944: ( state_type * $int ) > $o ).

tff(pred_def_37643,type,
    v69914: state_type > $o ).

tff(pred_def_37644,type,
    v69912: state_type > $o ).

tff(pred_def_37645,type,
    v69952: state_type > $o ).

tff(pred_def_37646,type,
    v69830: state_type > $o ).

tff(pred_def_37647,type,
    v69828: state_type > $o ).

tff(pred_def_37648,type,
    v69826: state_type > $o ).

tff(pred_def_37649,type,
    v69824: state_type > $o ).

tff(pred_def_37650,type,
    v69822: state_type > $o ).

tff(pred_def_37651,type,
    v69975: ( state_type * $int ) > $o ).

tff(pred_def_37652,type,
    v69973: ( state_type * $int ) > $o ).

tff(pred_def_37653,type,
    v69979: state_type > $o ).

tff(pred_def_37654,type,
    v69977: state_type > $o ).

tff(pred_def_37655,type,
    v69983: ( state_type * $int ) > $o ).

tff(pred_def_37656,type,
    v69981: ( state_type * $int ) > $o ).

tff(pred_def_37657,type,
    v69987: state_type > $o ).

tff(pred_def_37658,type,
    v69985: state_type > $o ).

tff(pred_def_37659,type,
    v69991: state_type > $o ).

tff(pred_def_37660,type,
    v69990: ( state_type * $int ) > $o ).

tff(pred_def_37661,type,
    v69989: ( state_type * $int ) > $o ).

tff(pred_def_37662,type,
    v69994: state_type > $o ).

tff(pred_def_37663,type,
    v69993: ( state_type * $int ) > $o ).

tff(pred_def_37664,type,
    v69992: ( state_type * $int ) > $o ).

tff(pred_def_37665,type,
    v69988: ( state_type * $int ) > $o ).

tff(pred_def_37666,type,
    v69971: ( state_type * $int ) > $o ).

tff(pred_def_37667,type,
    v69969: ( state_type * $int ) > $o ).

tff(pred_def_37668,type,
    v70000: state_type > $o ).

tff(pred_def_37669,type,
    v69998: state_type > $o ).

tff(pred_def_37670,type,
    v69997: state_type > $o ).

tff(pred_def_37671,type,
    v69996: ( state_type * $int ) > $o ).

tff(pred_def_37672,type,
    v69966: state_type > $o ).

tff(pred_def_37673,type,
    v69964: state_type > $o ).

tff(pred_def_37674,type,
    v70015: ( state_type * $int ) > $o ).

tff(pred_def_37675,type,
    v70013: ( state_type * $int ) > $o ).

tff(pred_def_37676,type,
    v70019: state_type > $o ).

tff(pred_def_37677,type,
    v70017: state_type > $o ).

tff(pred_def_37678,type,
    v70023: ( state_type * $int ) > $o ).

tff(pred_def_37679,type,
    v70021: ( state_type * $int ) > $o ).

tff(pred_def_37680,type,
    v70027: state_type > $o ).

tff(pred_def_37681,type,
    v70025: state_type > $o ).

tff(pred_def_37682,type,
    v70031: state_type > $o ).

tff(pred_def_37683,type,
    v70030: ( state_type * $int ) > $o ).

tff(pred_def_37684,type,
    v70029: ( state_type * $int ) > $o ).

tff(pred_def_37685,type,
    v70034: state_type > $o ).

tff(pred_def_37686,type,
    v70033: ( state_type * $int ) > $o ).

tff(pred_def_37687,type,
    v70032: ( state_type * $int ) > $o ).

tff(pred_def_37688,type,
    v70028: ( state_type * $int ) > $o ).

tff(pred_def_37689,type,
    v70011: ( state_type * $int ) > $o ).

tff(pred_def_37690,type,
    v70009: ( state_type * $int ) > $o ).

tff(pred_def_37691,type,
    v70040: state_type > $o ).

tff(pred_def_37692,type,
    v70038: state_type > $o ).

tff(pred_def_37693,type,
    v70037: state_type > $o ).

tff(pred_def_37694,type,
    v70036: ( state_type * $int ) > $o ).

tff(pred_def_37695,type,
    v70006: state_type > $o ).

tff(pred_def_37696,type,
    v70004: state_type > $o ).

tff(pred_def_37697,type,
    v70055: ( state_type * $int ) > $o ).

tff(pred_def_37698,type,
    v70053: ( state_type * $int ) > $o ).

tff(pred_def_37699,type,
    v70059: state_type > $o ).

tff(pred_def_37700,type,
    v70057: state_type > $o ).

tff(pred_def_37701,type,
    v70063: ( state_type * $int ) > $o ).

tff(pred_def_37702,type,
    v70061: ( state_type * $int ) > $o ).

tff(pred_def_37703,type,
    v70067: state_type > $o ).

tff(pred_def_37704,type,
    v70065: state_type > $o ).

tff(pred_def_37705,type,
    v70071: state_type > $o ).

tff(pred_def_37706,type,
    v70070: ( state_type * $int ) > $o ).

tff(pred_def_37707,type,
    v70069: ( state_type * $int ) > $o ).

tff(pred_def_37708,type,
    v70074: state_type > $o ).

tff(pred_def_37709,type,
    v70073: ( state_type * $int ) > $o ).

tff(pred_def_37710,type,
    v70072: ( state_type * $int ) > $o ).

tff(pred_def_37711,type,
    v70068: ( state_type * $int ) > $o ).

tff(pred_def_37712,type,
    v70051: ( state_type * $int ) > $o ).

tff(pred_def_37713,type,
    v70049: ( state_type * $int ) > $o ).

tff(pred_def_37714,type,
    v70080: state_type > $o ).

tff(pred_def_37715,type,
    v70078: state_type > $o ).

tff(pred_def_37716,type,
    v70077: state_type > $o ).

tff(pred_def_37717,type,
    v70076: ( state_type * $int ) > $o ).

tff(pred_def_37718,type,
    v70046: state_type > $o ).

tff(pred_def_37719,type,
    v70044: state_type > $o ).

tff(pred_def_37720,type,
    v70084: state_type > $o ).

tff(pred_def_37721,type,
    v69962: state_type > $o ).

tff(pred_def_37722,type,
    v69960: state_type > $o ).

tff(pred_def_37723,type,
    v69958: state_type > $o ).

tff(pred_def_37724,type,
    v69956: state_type > $o ).

tff(pred_def_37725,type,
    v69954: state_type > $o ).

tff(pred_def_37726,type,
    v70107: ( state_type * $int ) > $o ).

tff(pred_def_37727,type,
    v70105: ( state_type * $int ) > $o ).

tff(pred_def_37728,type,
    v70111: state_type > $o ).

tff(pred_def_37729,type,
    v70109: state_type > $o ).

tff(pred_def_37730,type,
    v70115: ( state_type * $int ) > $o ).

tff(pred_def_37731,type,
    v70113: ( state_type * $int ) > $o ).

tff(pred_def_37732,type,
    v70119: state_type > $o ).

tff(pred_def_37733,type,
    v70117: state_type > $o ).

tff(pred_def_37734,type,
    v70123: state_type > $o ).

tff(pred_def_37735,type,
    v70122: ( state_type * $int ) > $o ).

tff(pred_def_37736,type,
    v70121: ( state_type * $int ) > $o ).

tff(pred_def_37737,type,
    v70126: state_type > $o ).

tff(pred_def_37738,type,
    v70125: ( state_type * $int ) > $o ).

tff(pred_def_37739,type,
    v70124: ( state_type * $int ) > $o ).

tff(pred_def_37740,type,
    v70120: ( state_type * $int ) > $o ).

tff(pred_def_37741,type,
    v70103: ( state_type * $int ) > $o ).

tff(pred_def_37742,type,
    v70101: ( state_type * $int ) > $o ).

tff(pred_def_37743,type,
    v70132: state_type > $o ).

tff(pred_def_37744,type,
    v70130: state_type > $o ).

tff(pred_def_37745,type,
    v70129: state_type > $o ).

tff(pred_def_37746,type,
    v70128: ( state_type * $int ) > $o ).

tff(pred_def_37747,type,
    v70098: state_type > $o ).

tff(pred_def_37748,type,
    v70096: state_type > $o ).

tff(pred_def_37749,type,
    v70147: ( state_type * $int ) > $o ).

tff(pred_def_37750,type,
    v70145: ( state_type * $int ) > $o ).

tff(pred_def_37751,type,
    v70151: state_type > $o ).

tff(pred_def_37752,type,
    v70149: state_type > $o ).

tff(pred_def_37753,type,
    v70155: ( state_type * $int ) > $o ).

tff(pred_def_37754,type,
    v70153: ( state_type * $int ) > $o ).

tff(pred_def_37755,type,
    v70159: state_type > $o ).

tff(pred_def_37756,type,
    v70157: state_type > $o ).

tff(pred_def_37757,type,
    v70163: state_type > $o ).

tff(pred_def_37758,type,
    v70162: ( state_type * $int ) > $o ).

tff(pred_def_37759,type,
    v70161: ( state_type * $int ) > $o ).

tff(pred_def_37760,type,
    v70166: state_type > $o ).

tff(pred_def_37761,type,
    v70165: ( state_type * $int ) > $o ).

tff(pred_def_37762,type,
    v70164: ( state_type * $int ) > $o ).

tff(pred_def_37763,type,
    v70160: ( state_type * $int ) > $o ).

tff(pred_def_37764,type,
    v70143: ( state_type * $int ) > $o ).

tff(pred_def_37765,type,
    v70141: ( state_type * $int ) > $o ).

tff(pred_def_37766,type,
    v70172: state_type > $o ).

tff(pred_def_37767,type,
    v70170: state_type > $o ).

tff(pred_def_37768,type,
    v70169: state_type > $o ).

tff(pred_def_37769,type,
    v70168: ( state_type * $int ) > $o ).

tff(pred_def_37770,type,
    v70138: state_type > $o ).

tff(pred_def_37771,type,
    v70136: state_type > $o ).

tff(pred_def_37772,type,
    v70187: ( state_type * $int ) > $o ).

tff(pred_def_37773,type,
    v70185: ( state_type * $int ) > $o ).

tff(pred_def_37774,type,
    v70191: state_type > $o ).

tff(pred_def_37775,type,
    v70189: state_type > $o ).

tff(pred_def_37776,type,
    v70195: ( state_type * $int ) > $o ).

tff(pred_def_37777,type,
    v70193: ( state_type * $int ) > $o ).

tff(pred_def_37778,type,
    v70199: state_type > $o ).

tff(pred_def_37779,type,
    v70197: state_type > $o ).

tff(pred_def_37780,type,
    v70203: state_type > $o ).

tff(pred_def_37781,type,
    v70202: ( state_type * $int ) > $o ).

tff(pred_def_37782,type,
    v70201: ( state_type * $int ) > $o ).

tff(pred_def_37783,type,
    v70206: state_type > $o ).

tff(pred_def_37784,type,
    v70205: ( state_type * $int ) > $o ).

tff(pred_def_37785,type,
    v70204: ( state_type * $int ) > $o ).

tff(pred_def_37786,type,
    v70200: ( state_type * $int ) > $o ).

tff(pred_def_37787,type,
    v70183: ( state_type * $int ) > $o ).

tff(pred_def_37788,type,
    v70181: ( state_type * $int ) > $o ).

tff(pred_def_37789,type,
    v70212: state_type > $o ).

tff(pred_def_37790,type,
    v70210: state_type > $o ).

tff(pred_def_37791,type,
    v70209: state_type > $o ).

tff(pred_def_37792,type,
    v70208: ( state_type * $int ) > $o ).

tff(pred_def_37793,type,
    v70178: state_type > $o ).

tff(pred_def_37794,type,
    v70176: state_type > $o ).

tff(pred_def_37795,type,
    v70216: state_type > $o ).

tff(pred_def_37796,type,
    v70094: state_type > $o ).

tff(pred_def_37797,type,
    v70092: state_type > $o ).

tff(pred_def_37798,type,
    v70090: state_type > $o ).

tff(pred_def_37799,type,
    v70088: state_type > $o ).

tff(pred_def_37800,type,
    v70086: state_type > $o ).

tff(pred_def_37801,type,
    v70218: state_type > $o ).

tff(pred_def_37802,type,
    v69820: state_type > $o ).

tff(pred_def_37803,type,
    v69818: state_type > $o ).

tff(pred_def_37804,type,
    v69816: state_type > $o ).

tff(pred_def_37805,type,
    v69814: state_type > $o ).

tff(pred_def_37806,type,
    v69812: state_type > $o ).

tff(pred_def_37807,type,
    v70251: ( state_type * $int ) > $o ).

tff(pred_def_37808,type,
    v70249: ( state_type * $int ) > $o ).

tff(pred_def_37809,type,
    v70255: state_type > $o ).

tff(pred_def_37810,type,
    v70253: state_type > $o ).

tff(pred_def_37811,type,
    v70259: ( state_type * $int ) > $o ).

tff(pred_def_37812,type,
    v70257: ( state_type * $int ) > $o ).

tff(pred_def_37813,type,
    v70263: state_type > $o ).

tff(pred_def_37814,type,
    v70261: state_type > $o ).

tff(pred_def_37815,type,
    v70267: state_type > $o ).

tff(pred_def_37816,type,
    v70266: ( state_type * $int ) > $o ).

tff(pred_def_37817,type,
    v70265: ( state_type * $int ) > $o ).

tff(pred_def_37818,type,
    v70270: state_type > $o ).

tff(pred_def_37819,type,
    v70269: ( state_type * $int ) > $o ).

tff(pred_def_37820,type,
    v70268: ( state_type * $int ) > $o ).

tff(pred_def_37821,type,
    v70264: ( state_type * $int ) > $o ).

tff(pred_def_37822,type,
    v70247: ( state_type * $int ) > $o ).

tff(pred_def_37823,type,
    v70245: ( state_type * $int ) > $o ).

tff(pred_def_37824,type,
    v70276: state_type > $o ).

tff(pred_def_37825,type,
    v70274: state_type > $o ).

tff(pred_def_37826,type,
    v70273: state_type > $o ).

tff(pred_def_37827,type,
    v70272: ( state_type * $int ) > $o ).

tff(pred_def_37828,type,
    v70242: state_type > $o ).

tff(pred_def_37829,type,
    v70240: state_type > $o ).

tff(pred_def_37830,type,
    v70291: ( state_type * $int ) > $o ).

tff(pred_def_37831,type,
    v70289: ( state_type * $int ) > $o ).

tff(pred_def_37832,type,
    v70295: state_type > $o ).

tff(pred_def_37833,type,
    v70293: state_type > $o ).

tff(pred_def_37834,type,
    v70299: ( state_type * $int ) > $o ).

tff(pred_def_37835,type,
    v70297: ( state_type * $int ) > $o ).

tff(pred_def_37836,type,
    v70303: state_type > $o ).

tff(pred_def_37837,type,
    v70301: state_type > $o ).

tff(pred_def_37838,type,
    v70307: state_type > $o ).

tff(pred_def_37839,type,
    v70306: ( state_type * $int ) > $o ).

tff(pred_def_37840,type,
    v70305: ( state_type * $int ) > $o ).

tff(pred_def_37841,type,
    v70310: state_type > $o ).

tff(pred_def_37842,type,
    v70309: ( state_type * $int ) > $o ).

tff(pred_def_37843,type,
    v70308: ( state_type * $int ) > $o ).

tff(pred_def_37844,type,
    v70304: ( state_type * $int ) > $o ).

tff(pred_def_37845,type,
    v70287: ( state_type * $int ) > $o ).

tff(pred_def_37846,type,
    v70285: ( state_type * $int ) > $o ).

tff(pred_def_37847,type,
    v70316: state_type > $o ).

tff(pred_def_37848,type,
    v70314: state_type > $o ).

tff(pred_def_37849,type,
    v70313: state_type > $o ).

tff(pred_def_37850,type,
    v70312: ( state_type * $int ) > $o ).

tff(pred_def_37851,type,
    v70282: state_type > $o ).

tff(pred_def_37852,type,
    v70280: state_type > $o ).

tff(pred_def_37853,type,
    v70331: ( state_type * $int ) > $o ).

tff(pred_def_37854,type,
    v70329: ( state_type * $int ) > $o ).

tff(pred_def_37855,type,
    v70335: state_type > $o ).

tff(pred_def_37856,type,
    v70333: state_type > $o ).

tff(pred_def_37857,type,
    v70339: ( state_type * $int ) > $o ).

tff(pred_def_37858,type,
    v70337: ( state_type * $int ) > $o ).

tff(pred_def_37859,type,
    v70343: state_type > $o ).

tff(pred_def_37860,type,
    v70341: state_type > $o ).

tff(pred_def_37861,type,
    v70347: state_type > $o ).

tff(pred_def_37862,type,
    v70346: ( state_type * $int ) > $o ).

tff(pred_def_37863,type,
    v70345: ( state_type * $int ) > $o ).

tff(pred_def_37864,type,
    v70350: state_type > $o ).

tff(pred_def_37865,type,
    v70349: ( state_type * $int ) > $o ).

tff(pred_def_37866,type,
    v70348: ( state_type * $int ) > $o ).

tff(pred_def_37867,type,
    v70344: ( state_type * $int ) > $o ).

tff(pred_def_37868,type,
    v70327: ( state_type * $int ) > $o ).

tff(pred_def_37869,type,
    v70325: ( state_type * $int ) > $o ).

tff(pred_def_37870,type,
    v70356: state_type > $o ).

tff(pred_def_37871,type,
    v70354: state_type > $o ).

tff(pred_def_37872,type,
    v70353: state_type > $o ).

tff(pred_def_37873,type,
    v70352: ( state_type * $int ) > $o ).

tff(pred_def_37874,type,
    v70322: state_type > $o ).

tff(pred_def_37875,type,
    v70320: state_type > $o ).

tff(pred_def_37876,type,
    v70360: state_type > $o ).

tff(pred_def_37877,type,
    v70238: state_type > $o ).

tff(pred_def_37878,type,
    v70236: state_type > $o ).

tff(pred_def_37879,type,
    v70234: state_type > $o ).

tff(pred_def_37880,type,
    v70232: state_type > $o ).

tff(pred_def_37881,type,
    v70230: state_type > $o ).

tff(pred_def_37882,type,
    v70383: ( state_type * $int ) > $o ).

tff(pred_def_37883,type,
    v70381: ( state_type * $int ) > $o ).

tff(pred_def_37884,type,
    v70387: state_type > $o ).

tff(pred_def_37885,type,
    v70385: state_type > $o ).

tff(pred_def_37886,type,
    v70391: ( state_type * $int ) > $o ).

tff(pred_def_37887,type,
    v70389: ( state_type * $int ) > $o ).

tff(pred_def_37888,type,
    v70395: state_type > $o ).

tff(pred_def_37889,type,
    v70393: state_type > $o ).

tff(pred_def_37890,type,
    v70399: state_type > $o ).

tff(pred_def_37891,type,
    v70398: ( state_type * $int ) > $o ).

tff(pred_def_37892,type,
    v70397: ( state_type * $int ) > $o ).

tff(pred_def_37893,type,
    v70402: state_type > $o ).

tff(pred_def_37894,type,
    v70401: ( state_type * $int ) > $o ).

tff(pred_def_37895,type,
    v70400: ( state_type * $int ) > $o ).

tff(pred_def_37896,type,
    v70396: ( state_type * $int ) > $o ).

tff(pred_def_37897,type,
    v70379: ( state_type * $int ) > $o ).

tff(pred_def_37898,type,
    v70377: ( state_type * $int ) > $o ).

tff(pred_def_37899,type,
    v70408: state_type > $o ).

tff(pred_def_37900,type,
    v70406: state_type > $o ).

tff(pred_def_37901,type,
    v70405: state_type > $o ).

tff(pred_def_37902,type,
    v70404: ( state_type * $int ) > $o ).

tff(pred_def_37903,type,
    v70374: state_type > $o ).

tff(pred_def_37904,type,
    v70372: state_type > $o ).

tff(pred_def_37905,type,
    v70423: ( state_type * $int ) > $o ).

tff(pred_def_37906,type,
    v70421: ( state_type * $int ) > $o ).

tff(pred_def_37907,type,
    v70427: state_type > $o ).

tff(pred_def_37908,type,
    v70425: state_type > $o ).

tff(pred_def_37909,type,
    v70431: ( state_type * $int ) > $o ).

tff(pred_def_37910,type,
    v70429: ( state_type * $int ) > $o ).

tff(pred_def_37911,type,
    v70435: state_type > $o ).

tff(pred_def_37912,type,
    v70433: state_type > $o ).

tff(pred_def_37913,type,
    v70439: state_type > $o ).

tff(pred_def_37914,type,
    v70438: ( state_type * $int ) > $o ).

tff(pred_def_37915,type,
    v70437: ( state_type * $int ) > $o ).

tff(pred_def_37916,type,
    v70442: state_type > $o ).

tff(pred_def_37917,type,
    v70441: ( state_type * $int ) > $o ).

tff(pred_def_37918,type,
    v70440: ( state_type * $int ) > $o ).

tff(pred_def_37919,type,
    v70436: ( state_type * $int ) > $o ).

tff(pred_def_37920,type,
    v70419: ( state_type * $int ) > $o ).

tff(pred_def_37921,type,
    v70417: ( state_type * $int ) > $o ).

tff(pred_def_37922,type,
    v70448: state_type > $o ).

tff(pred_def_37923,type,
    v70446: state_type > $o ).

tff(pred_def_37924,type,
    v70445: state_type > $o ).

tff(pred_def_37925,type,
    v70444: ( state_type * $int ) > $o ).

tff(pred_def_37926,type,
    v70414: state_type > $o ).

tff(pred_def_37927,type,
    v70412: state_type > $o ).

tff(pred_def_37928,type,
    v70463: ( state_type * $int ) > $o ).

tff(pred_def_37929,type,
    v70461: ( state_type * $int ) > $o ).

tff(pred_def_37930,type,
    v70467: state_type > $o ).

tff(pred_def_37931,type,
    v70465: state_type > $o ).

tff(pred_def_37932,type,
    v70471: ( state_type * $int ) > $o ).

tff(pred_def_37933,type,
    v70469: ( state_type * $int ) > $o ).

tff(pred_def_37934,type,
    v70475: state_type > $o ).

tff(pred_def_37935,type,
    v70473: state_type > $o ).

tff(pred_def_37936,type,
    v70479: state_type > $o ).

tff(pred_def_37937,type,
    v70478: ( state_type * $int ) > $o ).

tff(pred_def_37938,type,
    v70477: ( state_type * $int ) > $o ).

tff(pred_def_37939,type,
    v70482: state_type > $o ).

tff(pred_def_37940,type,
    v70481: ( state_type * $int ) > $o ).

tff(pred_def_37941,type,
    v70480: ( state_type * $int ) > $o ).

tff(pred_def_37942,type,
    v70476: ( state_type * $int ) > $o ).

tff(pred_def_37943,type,
    v70459: ( state_type * $int ) > $o ).

tff(pred_def_37944,type,
    v70457: ( state_type * $int ) > $o ).

tff(pred_def_37945,type,
    v70488: state_type > $o ).

tff(pred_def_37946,type,
    v70486: state_type > $o ).

tff(pred_def_37947,type,
    v70485: state_type > $o ).

tff(pred_def_37948,type,
    v70484: ( state_type * $int ) > $o ).

tff(pred_def_37949,type,
    v70454: state_type > $o ).

tff(pred_def_37950,type,
    v70452: state_type > $o ).

tff(pred_def_37951,type,
    v70492: state_type > $o ).

tff(pred_def_37952,type,
    v70370: state_type > $o ).

tff(pred_def_37953,type,
    v70368: state_type > $o ).

tff(pred_def_37954,type,
    v70366: state_type > $o ).

tff(pred_def_37955,type,
    v70364: state_type > $o ).

tff(pred_def_37956,type,
    v70362: state_type > $o ).

tff(pred_def_37957,type,
    v70506: state_type > $o ).

tff(pred_def_37958,type,
    v70504: state_type > $o ).

tff(pred_def_37959,type,
    v70510: state_type > $o ).

tff(pred_def_37960,type,
    v70508: state_type > $o ).

tff(pred_def_37961,type,
    v70516: state_type > $o ).

tff(pred_def_37962,type,
    v70514: state_type > $o ).

tff(pred_def_37963,type,
    v70512: state_type > $o ).

tff(pred_def_37964,type,
    v70518: state_type > $o ).

tff(pred_def_37965,type,
    v70502: state_type > $o ).

tff(pred_def_37966,type,
    v70500: state_type > $o ).

tff(pred_def_37967,type,
    v70498: state_type > $o ).

tff(pred_def_37968,type,
    v70496: state_type > $o ).

tff(pred_def_37969,type,
    v70494: state_type > $o ).

tff(pred_def_37970,type,
    v70520: state_type > $o ).

tff(pred_def_37971,type,
    v70228: state_type > $o ).

tff(pred_def_37972,type,
    v70226: state_type > $o ).

tff(pred_def_37973,type,
    v70224: state_type > $o ).

tff(pred_def_37974,type,
    v70222: state_type > $o ).

tff(pred_def_37975,type,
    v70220: state_type > $o ).

tff(pred_def_37976,type,
    v70536: ( state_type * $int ) > $o ).

tff(pred_def_37977,type,
    v70534: ( state_type * $int ) > $o ).

tff(pred_def_37978,type,
    v70540: state_type > $o ).

tff(pred_def_37979,type,
    v70538: state_type > $o ).

tff(pred_def_37980,type,
    v70544: ( state_type * $int ) > $o ).

tff(pred_def_37981,type,
    v70542: ( state_type * $int ) > $o ).

tff(pred_def_37982,type,
    v70548: state_type > $o ).

tff(pred_def_37983,type,
    v70546: state_type > $o ).

tff(pred_def_37984,type,
    v70552: state_type > $o ).

tff(pred_def_37985,type,
    v70551: ( state_type * $int ) > $o ).

tff(pred_def_37986,type,
    v70550: ( state_type * $int ) > $o ).

tff(pred_def_37987,type,
    v70555: state_type > $o ).

tff(pred_def_37988,type,
    v70554: ( state_type * $int ) > $o ).

tff(pred_def_37989,type,
    v70553: ( state_type * $int ) > $o ).

tff(pred_def_37990,type,
    v70549: ( state_type * $int ) > $o ).

tff(pred_def_37991,type,
    v70532: ( state_type * $int ) > $o ).

tff(pred_def_37992,type,
    v70530: ( state_type * $int ) > $o ).

tff(pred_def_37993,type,
    v70561: state_type > $o ).

tff(pred_def_37994,type,
    v70559: state_type > $o ).

tff(pred_def_37995,type,
    v70558: state_type > $o ).

tff(pred_def_37996,type,
    v70557: ( state_type * $int ) > $o ).

tff(pred_def_37997,type,
    v70528: ( state_type * $int ) > $o ).

tff(pred_def_37998,type,
    v70526: ( state_type * $int ) > $o ).

tff(pred_def_37999,type,
    v70524: state_type > $o ).

tff(pred_def_38000,type,
    v70522: state_type > $o ).

tff(pred_def_38001,type,
    v70565: state_type > $o ).

tff(pred_def_38002,type,
    v69810: state_type > $o ).

tff(pred_def_38003,type,
    v69808: state_type > $o ).

tff(pred_def_38004,type,
    v69805: ( state_type * $int ) > $o ).

tff(pred_def_38005,type,
    v69803: state_type > $o ).

tff(pred_def_38006,type,
    v69801: state_type > $o ).

tff(pred_def_38007,type,
    v70603: state_type > $o ).

tff(pred_def_38008,type,
    v70601: state_type > $o ).

tff(pred_def_38009,type,
    v70600: state_type > $o ).

tff(pred_def_38010,type,
    v70599: ( state_type * $int ) > $o ).

tff(pred_def_38011,type,
    v70597: state_type > $o ).

tff(pred_def_38012,type,
    v70595: state_type > $o ).

tff(pred_def_38013,type,
    v70615: state_type > $o ).

tff(pred_def_38014,type,
    v70613: state_type > $o ).

tff(pred_def_38015,type,
    v70612: state_type > $o ).

tff(pred_def_38016,type,
    v70611: ( state_type * $int ) > $o ).

tff(pred_def_38017,type,
    v70609: state_type > $o ).

tff(pred_def_38018,type,
    v70607: state_type > $o ).

tff(pred_def_38019,type,
    v70627: state_type > $o ).

tff(pred_def_38020,type,
    v70625: state_type > $o ).

tff(pred_def_38021,type,
    v70624: state_type > $o ).

tff(pred_def_38022,type,
    v70623: ( state_type * $int ) > $o ).

tff(pred_def_38023,type,
    v70621: state_type > $o ).

tff(pred_def_38024,type,
    v70619: state_type > $o ).

tff(pred_def_38025,type,
    v70631: state_type > $o ).

tff(pred_def_38026,type,
    v70593: state_type > $o ).

tff(pred_def_38027,type,
    v70591: state_type > $o ).

tff(pred_def_38028,type,
    v70589: state_type > $o ).

tff(pred_def_38029,type,
    v70587: state_type > $o ).

tff(pred_def_38030,type,
    v70585: state_type > $o ).

tff(pred_def_38031,type,
    v70651: state_type > $o ).

tff(pred_def_38032,type,
    v70649: state_type > $o ).

tff(pred_def_38033,type,
    v70648: state_type > $o ).

tff(pred_def_38034,type,
    v70647: ( state_type * $int ) > $o ).

tff(pred_def_38035,type,
    v70645: state_type > $o ).

tff(pred_def_38036,type,
    v70643: state_type > $o ).

tff(pred_def_38037,type,
    v70663: state_type > $o ).

tff(pred_def_38038,type,
    v70661: state_type > $o ).

tff(pred_def_38039,type,
    v70660: state_type > $o ).

tff(pred_def_38040,type,
    v70659: ( state_type * $int ) > $o ).

tff(pred_def_38041,type,
    v70657: state_type > $o ).

tff(pred_def_38042,type,
    v70655: state_type > $o ).

tff(pred_def_38043,type,
    v70675: state_type > $o ).

tff(pred_def_38044,type,
    v70673: state_type > $o ).

tff(pred_def_38045,type,
    v70672: state_type > $o ).

tff(pred_def_38046,type,
    v70671: ( state_type * $int ) > $o ).

tff(pred_def_38047,type,
    v70669: state_type > $o ).

tff(pred_def_38048,type,
    v70667: state_type > $o ).

tff(pred_def_38049,type,
    v70679: state_type > $o ).

tff(pred_def_38050,type,
    v70641: state_type > $o ).

tff(pred_def_38051,type,
    v70639: state_type > $o ).

tff(pred_def_38052,type,
    v70637: state_type > $o ).

tff(pred_def_38053,type,
    v70635: state_type > $o ).

tff(pred_def_38054,type,
    v70633: state_type > $o ).

tff(pred_def_38055,type,
    v70699: state_type > $o ).

tff(pred_def_38056,type,
    v70697: state_type > $o ).

tff(pred_def_38057,type,
    v70696: state_type > $o ).

tff(pred_def_38058,type,
    v70695: ( state_type * $int ) > $o ).

tff(pred_def_38059,type,
    v70693: state_type > $o ).

tff(pred_def_38060,type,
    v70691: state_type > $o ).

tff(pred_def_38061,type,
    v70711: state_type > $o ).

tff(pred_def_38062,type,
    v70709: state_type > $o ).

tff(pred_def_38063,type,
    v70708: state_type > $o ).

tff(pred_def_38064,type,
    v70707: ( state_type * $int ) > $o ).

tff(pred_def_38065,type,
    v70705: state_type > $o ).

tff(pred_def_38066,type,
    v70703: state_type > $o ).

tff(pred_def_38067,type,
    v70723: state_type > $o ).

tff(pred_def_38068,type,
    v70721: state_type > $o ).

tff(pred_def_38069,type,
    v70720: state_type > $o ).

tff(pred_def_38070,type,
    v70719: ( state_type * $int ) > $o ).

tff(pred_def_38071,type,
    v70717: state_type > $o ).

tff(pred_def_38072,type,
    v70715: state_type > $o ).

tff(pred_def_38073,type,
    v70727: state_type > $o ).

tff(pred_def_38074,type,
    v70689: state_type > $o ).

tff(pred_def_38075,type,
    v70687: state_type > $o ).

tff(pred_def_38076,type,
    v70685: state_type > $o ).

tff(pred_def_38077,type,
    v70683: state_type > $o ).

tff(pred_def_38078,type,
    v70681: state_type > $o ).

tff(pred_def_38079,type,
    v70729: state_type > $o ).

tff(pred_def_38080,type,
    v70583: state_type > $o ).

tff(pred_def_38081,type,
    v70581: state_type > $o ).

tff(pred_def_38082,type,
    v70579: state_type > $o ).

tff(pred_def_38083,type,
    v70577: state_type > $o ).

tff(pred_def_38084,type,
    v70575: state_type > $o ).

tff(pred_def_38085,type,
    v70759: state_type > $o ).

tff(pred_def_38086,type,
    v70757: state_type > $o ).

tff(pred_def_38087,type,
    v70756: state_type > $o ).

tff(pred_def_38088,type,
    v70755: ( state_type * $int ) > $o ).

tff(pred_def_38089,type,
    v70753: state_type > $o ).

tff(pred_def_38090,type,
    v70751: state_type > $o ).

tff(pred_def_38091,type,
    v70771: state_type > $o ).

tff(pred_def_38092,type,
    v70769: state_type > $o ).

tff(pred_def_38093,type,
    v70768: state_type > $o ).

tff(pred_def_38094,type,
    v70767: ( state_type * $int ) > $o ).

tff(pred_def_38095,type,
    v70765: state_type > $o ).

tff(pred_def_38096,type,
    v70763: state_type > $o ).

tff(pred_def_38097,type,
    v70783: state_type > $o ).

tff(pred_def_38098,type,
    v70781: state_type > $o ).

tff(pred_def_38099,type,
    v70780: state_type > $o ).

tff(pred_def_38100,type,
    v70779: ( state_type * $int ) > $o ).

tff(pred_def_38101,type,
    v70777: state_type > $o ).

tff(pred_def_38102,type,
    v70775: state_type > $o ).

tff(pred_def_38103,type,
    v70787: state_type > $o ).

tff(pred_def_38104,type,
    v70749: state_type > $o ).

tff(pred_def_38105,type,
    v70747: state_type > $o ).

tff(pred_def_38106,type,
    v70745: state_type > $o ).

tff(pred_def_38107,type,
    v70743: state_type > $o ).

tff(pred_def_38108,type,
    v70741: state_type > $o ).

tff(pred_def_38109,type,
    v70807: state_type > $o ).

tff(pred_def_38110,type,
    v70805: state_type > $o ).

tff(pred_def_38111,type,
    v70804: state_type > $o ).

tff(pred_def_38112,type,
    v70803: ( state_type * $int ) > $o ).

tff(pred_def_38113,type,
    v70801: state_type > $o ).

tff(pred_def_38114,type,
    v70799: state_type > $o ).

tff(pred_def_38115,type,
    v70819: state_type > $o ).

tff(pred_def_38116,type,
    v70817: state_type > $o ).

tff(pred_def_38117,type,
    v70816: state_type > $o ).

tff(pred_def_38118,type,
    v70815: ( state_type * $int ) > $o ).

tff(pred_def_38119,type,
    v70813: state_type > $o ).

tff(pred_def_38120,type,
    v70811: state_type > $o ).

tff(pred_def_38121,type,
    v70831: state_type > $o ).

tff(pred_def_38122,type,
    v70829: state_type > $o ).

tff(pred_def_38123,type,
    v70828: state_type > $o ).

tff(pred_def_38124,type,
    v70827: ( state_type * $int ) > $o ).

tff(pred_def_38125,type,
    v70825: state_type > $o ).

tff(pred_def_38126,type,
    v70823: state_type > $o ).

tff(pred_def_38127,type,
    v70835: state_type > $o ).

tff(pred_def_38128,type,
    v70797: state_type > $o ).

tff(pred_def_38129,type,
    v70795: state_type > $o ).

tff(pred_def_38130,type,
    v70793: state_type > $o ).

tff(pred_def_38131,type,
    v70791: state_type > $o ).

tff(pred_def_38132,type,
    v70789: state_type > $o ).

tff(pred_def_38133,type,
    v70849: state_type > $o ).

tff(pred_def_38134,type,
    v70847: state_type > $o ).

tff(pred_def_38135,type,
    v70853: state_type > $o ).

tff(pred_def_38136,type,
    v70851: state_type > $o ).

tff(pred_def_38137,type,
    v70857: state_type > $o ).

tff(pred_def_38138,type,
    v70855: state_type > $o ).

tff(pred_def_38139,type,
    v70859: state_type > $o ).

tff(pred_def_38140,type,
    v70845: state_type > $o ).

tff(pred_def_38141,type,
    v70843: state_type > $o ).

tff(pred_def_38142,type,
    v70841: state_type > $o ).

tff(pred_def_38143,type,
    v70839: state_type > $o ).

tff(pred_def_38144,type,
    v70837: state_type > $o ).

tff(pred_def_38145,type,
    v70861: state_type > $o ).

tff(pred_def_38146,type,
    v70739: state_type > $o ).

tff(pred_def_38147,type,
    v70737: state_type > $o ).

tff(pred_def_38148,type,
    v70735: state_type > $o ).

tff(pred_def_38149,type,
    v70733: state_type > $o ).

tff(pred_def_38150,type,
    v70731: state_type > $o ).

tff(pred_def_38151,type,
    v70871: state_type > $o ).

tff(pred_def_38152,type,
    v70869: state_type > $o ).

tff(pred_def_38153,type,
    v70868: state_type > $o ).

tff(pred_def_38154,type,
    v70867: ( state_type * $int ) > $o ).

tff(pred_def_38155,type,
    v70865: state_type > $o ).

tff(pred_def_38156,type,
    v70863: state_type > $o ).

tff(pred_def_38157,type,
    v70875: state_type > $o ).

tff(pred_def_38158,type,
    v70573: state_type > $o ).

tff(pred_def_38159,type,
    v70571: state_type > $o ).

tff(pred_def_38160,type,
    v70569: state_type > $o ).

tff(pred_def_38161,type,
    v70567: state_type > $o ).

tff(pred_def_38162,type,
    v70877: state_type > $o ).

tff(pred_def_38163,type,
    v69799: state_type > $o ).

tff(pred_def_38164,type,
    v69797: state_type > $o ).

tff(pred_def_38165,type,
    v69795: state_type > $o ).

tff(pred_def_38166,type,
    v69793: state_type > $o ).

tff(pred_def_38167,type,
    v69791: state_type > $o ).

tff(pred_def_38168,type,
    v70925: state_type > $o ).

tff(pred_def_38169,type,
    v70923: state_type > $o ).

tff(pred_def_38170,type,
    v70922: state_type > $o ).

tff(pred_def_38171,type,
    v70921: ( state_type * $int ) > $o ).

tff(pred_def_38172,type,
    v70919: state_type > $o ).

tff(pred_def_38173,type,
    v70917: state_type > $o ).

tff(pred_def_38174,type,
    v70937: state_type > $o ).

tff(pred_def_38175,type,
    v70935: state_type > $o ).

tff(pred_def_38176,type,
    v70934: state_type > $o ).

tff(pred_def_38177,type,
    v70933: ( state_type * $int ) > $o ).

tff(pred_def_38178,type,
    v70931: state_type > $o ).

tff(pred_def_38179,type,
    v70929: state_type > $o ).

tff(pred_def_38180,type,
    v70949: state_type > $o ).

tff(pred_def_38181,type,
    v70947: state_type > $o ).

tff(pred_def_38182,type,
    v70946: state_type > $o ).

tff(pred_def_38183,type,
    v70945: ( state_type * $int ) > $o ).

tff(pred_def_38184,type,
    v70943: state_type > $o ).

tff(pred_def_38185,type,
    v70941: state_type > $o ).

tff(pred_def_38186,type,
    v70953: state_type > $o ).

tff(pred_def_38187,type,
    v70915: state_type > $o ).

tff(pred_def_38188,type,
    v70913: state_type > $o ).

tff(pred_def_38189,type,
    v70911: state_type > $o ).

tff(pred_def_38190,type,
    v70909: state_type > $o ).

tff(pred_def_38191,type,
    v70907: state_type > $o ).

tff(pred_def_38192,type,
    v70973: state_type > $o ).

tff(pred_def_38193,type,
    v70971: state_type > $o ).

tff(pred_def_38194,type,
    v70970: state_type > $o ).

tff(pred_def_38195,type,
    v70969: ( state_type * $int ) > $o ).

tff(pred_def_38196,type,
    v70967: state_type > $o ).

tff(pred_def_38197,type,
    v70965: state_type > $o ).

tff(pred_def_38198,type,
    v70985: state_type > $o ).

tff(pred_def_38199,type,
    v70983: state_type > $o ).

tff(pred_def_38200,type,
    v70982: state_type > $o ).

tff(pred_def_38201,type,
    v70981: ( state_type * $int ) > $o ).

tff(pred_def_38202,type,
    v70979: state_type > $o ).

tff(pred_def_38203,type,
    v70977: state_type > $o ).

tff(pred_def_38204,type,
    v70997: state_type > $o ).

tff(pred_def_38205,type,
    v70995: state_type > $o ).

tff(pred_def_38206,type,
    v70994: state_type > $o ).

tff(pred_def_38207,type,
    v70993: ( state_type * $int ) > $o ).

tff(pred_def_38208,type,
    v70991: state_type > $o ).

tff(pred_def_38209,type,
    v70989: state_type > $o ).

tff(pred_def_38210,type,
    v71001: state_type > $o ).

tff(pred_def_38211,type,
    v70963: state_type > $o ).

tff(pred_def_38212,type,
    v70961: state_type > $o ).

tff(pred_def_38213,type,
    v70959: state_type > $o ).

tff(pred_def_38214,type,
    v70957: state_type > $o ).

tff(pred_def_38215,type,
    v70955: state_type > $o ).

tff(pred_def_38216,type,
    v71021: state_type > $o ).

tff(pred_def_38217,type,
    v71019: state_type > $o ).

tff(pred_def_38218,type,
    v71018: state_type > $o ).

tff(pred_def_38219,type,
    v71017: ( state_type * $int ) > $o ).

tff(pred_def_38220,type,
    v71015: state_type > $o ).

tff(pred_def_38221,type,
    v71013: state_type > $o ).

tff(pred_def_38222,type,
    v71033: state_type > $o ).

tff(pred_def_38223,type,
    v71031: state_type > $o ).

tff(pred_def_38224,type,
    v71030: state_type > $o ).

tff(pred_def_38225,type,
    v71029: ( state_type * $int ) > $o ).

tff(pred_def_38226,type,
    v71027: state_type > $o ).

tff(pred_def_38227,type,
    v71025: state_type > $o ).

tff(pred_def_38228,type,
    v71045: state_type > $o ).

tff(pred_def_38229,type,
    v71043: state_type > $o ).

tff(pred_def_38230,type,
    v71042: state_type > $o ).

tff(pred_def_38231,type,
    v71041: ( state_type * $int ) > $o ).

tff(pred_def_38232,type,
    v71039: state_type > $o ).

tff(pred_def_38233,type,
    v71037: state_type > $o ).

tff(pred_def_38234,type,
    v71049: state_type > $o ).

tff(pred_def_38235,type,
    v71011: state_type > $o ).

tff(pred_def_38236,type,
    v71009: state_type > $o ).

tff(pred_def_38237,type,
    v71007: state_type > $o ).

tff(pred_def_38238,type,
    v71005: state_type > $o ).

tff(pred_def_38239,type,
    v71003: state_type > $o ).

tff(pred_def_38240,type,
    v71051: state_type > $o ).

tff(pred_def_38241,type,
    v70905: state_type > $o ).

tff(pred_def_38242,type,
    v70903: state_type > $o ).

tff(pred_def_38243,type,
    v70901: state_type > $o ).

tff(pred_def_38244,type,
    v70899: state_type > $o ).

tff(pred_def_38245,type,
    v70897: state_type > $o ).

tff(pred_def_38246,type,
    v71081: state_type > $o ).

tff(pred_def_38247,type,
    v71079: state_type > $o ).

tff(pred_def_38248,type,
    v71078: state_type > $o ).

tff(pred_def_38249,type,
    v71077: ( state_type * $int ) > $o ).

tff(pred_def_38250,type,
    v71075: state_type > $o ).

tff(pred_def_38251,type,
    v71073: state_type > $o ).

tff(pred_def_38252,type,
    v71093: state_type > $o ).

tff(pred_def_38253,type,
    v71091: state_type > $o ).

tff(pred_def_38254,type,
    v71090: state_type > $o ).

tff(pred_def_38255,type,
    v71089: ( state_type * $int ) > $o ).

tff(pred_def_38256,type,
    v71087: state_type > $o ).

tff(pred_def_38257,type,
    v71085: state_type > $o ).

tff(pred_def_38258,type,
    v71105: state_type > $o ).

tff(pred_def_38259,type,
    v71103: state_type > $o ).

tff(pred_def_38260,type,
    v71102: state_type > $o ).

tff(pred_def_38261,type,
    v71101: ( state_type * $int ) > $o ).

tff(pred_def_38262,type,
    v71099: state_type > $o ).

tff(pred_def_38263,type,
    v71097: state_type > $o ).

tff(pred_def_38264,type,
    v71109: state_type > $o ).

tff(pred_def_38265,type,
    v71071: state_type > $o ).

tff(pred_def_38266,type,
    v71069: state_type > $o ).

tff(pred_def_38267,type,
    v71067: state_type > $o ).

tff(pred_def_38268,type,
    v71065: state_type > $o ).

tff(pred_def_38269,type,
    v71063: state_type > $o ).

tff(pred_def_38270,type,
    v71129: state_type > $o ).

tff(pred_def_38271,type,
    v71127: state_type > $o ).

tff(pred_def_38272,type,
    v71126: state_type > $o ).

tff(pred_def_38273,type,
    v71125: ( state_type * $int ) > $o ).

tff(pred_def_38274,type,
    v71123: state_type > $o ).

tff(pred_def_38275,type,
    v71121: state_type > $o ).

tff(pred_def_38276,type,
    v71141: state_type > $o ).

tff(pred_def_38277,type,
    v71139: state_type > $o ).

tff(pred_def_38278,type,
    v71138: state_type > $o ).

tff(pred_def_38279,type,
    v71137: ( state_type * $int ) > $o ).

tff(pred_def_38280,type,
    v71135: state_type > $o ).

tff(pred_def_38281,type,
    v71133: state_type > $o ).

tff(pred_def_38282,type,
    v71153: state_type > $o ).

tff(pred_def_38283,type,
    v71151: state_type > $o ).

tff(pred_def_38284,type,
    v71150: state_type > $o ).

tff(pred_def_38285,type,
    v71149: ( state_type * $int ) > $o ).

tff(pred_def_38286,type,
    v71147: state_type > $o ).

tff(pred_def_38287,type,
    v71145: state_type > $o ).

tff(pred_def_38288,type,
    v71157: state_type > $o ).

tff(pred_def_38289,type,
    v71119: state_type > $o ).

tff(pred_def_38290,type,
    v71117: state_type > $o ).

tff(pred_def_38291,type,
    v71115: state_type > $o ).

tff(pred_def_38292,type,
    v71113: state_type > $o ).

tff(pred_def_38293,type,
    v71111: state_type > $o ).

tff(pred_def_38294,type,
    v71171: state_type > $o ).

tff(pred_def_38295,type,
    v71169: state_type > $o ).

tff(pred_def_38296,type,
    v71175: state_type > $o ).

tff(pred_def_38297,type,
    v71173: state_type > $o ).

tff(pred_def_38298,type,
    v71179: state_type > $o ).

tff(pred_def_38299,type,
    v71177: state_type > $o ).

tff(pred_def_38300,type,
    v71181: state_type > $o ).

tff(pred_def_38301,type,
    v71167: state_type > $o ).

tff(pred_def_38302,type,
    v71165: state_type > $o ).

tff(pred_def_38303,type,
    v71163: state_type > $o ).

tff(pred_def_38304,type,
    v71161: state_type > $o ).

tff(pred_def_38305,type,
    v71159: state_type > $o ).

tff(pred_def_38306,type,
    v71183: state_type > $o ).

tff(pred_def_38307,type,
    v71061: state_type > $o ).

tff(pred_def_38308,type,
    v71059: state_type > $o ).

tff(pred_def_38309,type,
    v71057: state_type > $o ).

tff(pred_def_38310,type,
    v71055: state_type > $o ).

tff(pred_def_38311,type,
    v71053: state_type > $o ).

tff(pred_def_38312,type,
    v71193: state_type > $o ).

tff(pred_def_38313,type,
    v71191: state_type > $o ).

tff(pred_def_38314,type,
    v71190: state_type > $o ).

tff(pred_def_38315,type,
    v71189: ( state_type * $int ) > $o ).

tff(pred_def_38316,type,
    v71187: state_type > $o ).

tff(pred_def_38317,type,
    v71185: state_type > $o ).

tff(pred_def_38318,type,
    v71197: state_type > $o ).

tff(pred_def_38319,type,
    v70895: state_type > $o ).

tff(pred_def_38320,type,
    v70893: state_type > $o ).

tff(pred_def_38321,type,
    v70891: state_type > $o ).

tff(pred_def_38322,type,
    v70889: state_type > $o ).

tff(pred_def_38323,type,
    v71235: state_type > $o ).

tff(pred_def_38324,type,
    v71233: state_type > $o ).

tff(pred_def_38325,type,
    v71232: state_type > $o ).

tff(pred_def_38326,type,
    v71231: ( state_type * $int ) > $o ).

tff(pred_def_38327,type,
    v71229: state_type > $o ).

tff(pred_def_38328,type,
    v71227: state_type > $o ).

tff(pred_def_38329,type,
    v71247: state_type > $o ).

tff(pred_def_38330,type,
    v71245: state_type > $o ).

tff(pred_def_38331,type,
    v71244: state_type > $o ).

tff(pred_def_38332,type,
    v71243: ( state_type * $int ) > $o ).

tff(pred_def_38333,type,
    v71241: state_type > $o ).

tff(pred_def_38334,type,
    v71239: state_type > $o ).

tff(pred_def_38335,type,
    v71259: state_type > $o ).

tff(pred_def_38336,type,
    v71257: state_type > $o ).

tff(pred_def_38337,type,
    v71256: state_type > $o ).

tff(pred_def_38338,type,
    v71255: ( state_type * $int ) > $o ).

tff(pred_def_38339,type,
    v71253: state_type > $o ).

tff(pred_def_38340,type,
    v71251: state_type > $o ).

tff(pred_def_38341,type,
    v71263: state_type > $o ).

tff(pred_def_38342,type,
    v71225: state_type > $o ).

tff(pred_def_38343,type,
    v71223: state_type > $o ).

tff(pred_def_38344,type,
    v71221: state_type > $o ).

tff(pred_def_38345,type,
    v71219: state_type > $o ).

tff(pred_def_38346,type,
    v71217: state_type > $o ).

tff(pred_def_38347,type,
    v71283: state_type > $o ).

tff(pred_def_38348,type,
    v71281: state_type > $o ).

tff(pred_def_38349,type,
    v71280: state_type > $o ).

tff(pred_def_38350,type,
    v71279: ( state_type * $int ) > $o ).

tff(pred_def_38351,type,
    v71277: state_type > $o ).

tff(pred_def_38352,type,
    v71275: state_type > $o ).

tff(pred_def_38353,type,
    v71295: state_type > $o ).

tff(pred_def_38354,type,
    v71293: state_type > $o ).

tff(pred_def_38355,type,
    v71292: state_type > $o ).

tff(pred_def_38356,type,
    v71291: ( state_type * $int ) > $o ).

tff(pred_def_38357,type,
    v71289: state_type > $o ).

tff(pred_def_38358,type,
    v71287: state_type > $o ).

tff(pred_def_38359,type,
    v71307: state_type > $o ).

tff(pred_def_38360,type,
    v71305: state_type > $o ).

tff(pred_def_38361,type,
    v71304: state_type > $o ).

tff(pred_def_38362,type,
    v71303: ( state_type * $int ) > $o ).

tff(pred_def_38363,type,
    v71301: state_type > $o ).

tff(pred_def_38364,type,
    v71299: state_type > $o ).

tff(pred_def_38365,type,
    v71311: state_type > $o ).

tff(pred_def_38366,type,
    v71273: state_type > $o ).

tff(pred_def_38367,type,
    v71271: state_type > $o ).

tff(pred_def_38368,type,
    v71269: state_type > $o ).

tff(pred_def_38369,type,
    v71267: state_type > $o ).

tff(pred_def_38370,type,
    v71265: state_type > $o ).

tff(pred_def_38371,type,
    v71331: state_type > $o ).

tff(pred_def_38372,type,
    v71329: state_type > $o ).

tff(pred_def_38373,type,
    v71328: state_type > $o ).

tff(pred_def_38374,type,
    v71327: ( state_type * $int ) > $o ).

tff(pred_def_38375,type,
    v71325: state_type > $o ).

tff(pred_def_38376,type,
    v71323: state_type > $o ).

tff(pred_def_38377,type,
    v71343: state_type > $o ).

tff(pred_def_38378,type,
    v71341: state_type > $o ).

tff(pred_def_38379,type,
    v71340: state_type > $o ).

tff(pred_def_38380,type,
    v71339: ( state_type * $int ) > $o ).

tff(pred_def_38381,type,
    v71337: state_type > $o ).

tff(pred_def_38382,type,
    v71335: state_type > $o ).

tff(pred_def_38383,type,
    v71355: state_type > $o ).

tff(pred_def_38384,type,
    v71353: state_type > $o ).

tff(pred_def_38385,type,
    v71352: state_type > $o ).

tff(pred_def_38386,type,
    v71351: ( state_type * $int ) > $o ).

tff(pred_def_38387,type,
    v71349: state_type > $o ).

tff(pred_def_38388,type,
    v71347: state_type > $o ).

tff(pred_def_38389,type,
    v71359: state_type > $o ).

tff(pred_def_38390,type,
    v71321: state_type > $o ).

tff(pred_def_38391,type,
    v71319: state_type > $o ).

tff(pred_def_38392,type,
    v71317: state_type > $o ).

tff(pred_def_38393,type,
    v71315: state_type > $o ).

tff(pred_def_38394,type,
    v71313: state_type > $o ).

tff(pred_def_38395,type,
    v71361: state_type > $o ).

tff(pred_def_38396,type,
    v71215: state_type > $o ).

tff(pred_def_38397,type,
    v71213: state_type > $o ).

tff(pred_def_38398,type,
    v71211: state_type > $o ).

tff(pred_def_38399,type,
    v71209: state_type > $o ).

tff(pred_def_38400,type,
    v71207: state_type > $o ).

tff(pred_def_38401,type,
    v71391: state_type > $o ).

tff(pred_def_38402,type,
    v71389: state_type > $o ).

tff(pred_def_38403,type,
    v71388: state_type > $o ).

tff(pred_def_38404,type,
    v71387: ( state_type * $int ) > $o ).

tff(pred_def_38405,type,
    v71385: state_type > $o ).

tff(pred_def_38406,type,
    v71383: state_type > $o ).

tff(pred_def_38407,type,
    v71403: state_type > $o ).

tff(pred_def_38408,type,
    v71401: state_type > $o ).

tff(pred_def_38409,type,
    v71400: state_type > $o ).

tff(pred_def_38410,type,
    v71399: ( state_type * $int ) > $o ).

tff(pred_def_38411,type,
    v71397: state_type > $o ).

tff(pred_def_38412,type,
    v71395: state_type > $o ).

tff(pred_def_38413,type,
    v71415: state_type > $o ).

tff(pred_def_38414,type,
    v71413: state_type > $o ).

tff(pred_def_38415,type,
    v71412: state_type > $o ).

tff(pred_def_38416,type,
    v71411: ( state_type * $int ) > $o ).

tff(pred_def_38417,type,
    v71409: state_type > $o ).

tff(pred_def_38418,type,
    v71407: state_type > $o ).

tff(pred_def_38419,type,
    v71419: state_type > $o ).

tff(pred_def_38420,type,
    v71381: state_type > $o ).

tff(pred_def_38421,type,
    v71379: state_type > $o ).

tff(pred_def_38422,type,
    v71377: state_type > $o ).

tff(pred_def_38423,type,
    v71375: state_type > $o ).

tff(pred_def_38424,type,
    v71373: state_type > $o ).

tff(pred_def_38425,type,
    v71439: state_type > $o ).

tff(pred_def_38426,type,
    v71437: state_type > $o ).

tff(pred_def_38427,type,
    v71436: state_type > $o ).

tff(pred_def_38428,type,
    v71435: ( state_type * $int ) > $o ).

tff(pred_def_38429,type,
    v71433: state_type > $o ).

tff(pred_def_38430,type,
    v71431: state_type > $o ).

tff(pred_def_38431,type,
    v71451: state_type > $o ).

tff(pred_def_38432,type,
    v71449: state_type > $o ).

tff(pred_def_38433,type,
    v71448: state_type > $o ).

tff(pred_def_38434,type,
    v71447: ( state_type * $int ) > $o ).

tff(pred_def_38435,type,
    v71445: state_type > $o ).

tff(pred_def_38436,type,
    v71443: state_type > $o ).

tff(pred_def_38437,type,
    v71463: state_type > $o ).

tff(pred_def_38438,type,
    v71461: state_type > $o ).

tff(pred_def_38439,type,
    v71460: state_type > $o ).

tff(pred_def_38440,type,
    v71459: ( state_type * $int ) > $o ).

tff(pred_def_38441,type,
    v71457: state_type > $o ).

tff(pred_def_38442,type,
    v71455: state_type > $o ).

tff(pred_def_38443,type,
    v71467: state_type > $o ).

tff(pred_def_38444,type,
    v71429: state_type > $o ).

tff(pred_def_38445,type,
    v71427: state_type > $o ).

tff(pred_def_38446,type,
    v71425: state_type > $o ).

tff(pred_def_38447,type,
    v71423: state_type > $o ).

tff(pred_def_38448,type,
    v71421: state_type > $o ).

tff(pred_def_38449,type,
    v71481: state_type > $o ).

tff(pred_def_38450,type,
    v71479: state_type > $o ).

tff(pred_def_38451,type,
    v71485: state_type > $o ).

tff(pred_def_38452,type,
    v71483: state_type > $o ).

tff(pred_def_38453,type,
    v71489: state_type > $o ).

tff(pred_def_38454,type,
    v71487: state_type > $o ).

tff(pred_def_38455,type,
    v71491: state_type > $o ).

tff(pred_def_38456,type,
    v71477: state_type > $o ).

tff(pred_def_38457,type,
    v71475: state_type > $o ).

tff(pred_def_38458,type,
    v71473: state_type > $o ).

tff(pred_def_38459,type,
    v71471: state_type > $o ).

tff(pred_def_38460,type,
    v71469: state_type > $o ).

tff(pred_def_38461,type,
    v71493: state_type > $o ).

tff(pred_def_38462,type,
    v71371: state_type > $o ).

tff(pred_def_38463,type,
    v71369: state_type > $o ).

tff(pred_def_38464,type,
    v71367: state_type > $o ).

tff(pred_def_38465,type,
    v71365: state_type > $o ).

tff(pred_def_38466,type,
    v71363: state_type > $o ).

tff(pred_def_38467,type,
    v71503: state_type > $o ).

tff(pred_def_38468,type,
    v71501: state_type > $o ).

tff(pred_def_38469,type,
    v71500: state_type > $o ).

tff(pred_def_38470,type,
    v71499: ( state_type * $int ) > $o ).

tff(pred_def_38471,type,
    v71497: state_type > $o ).

tff(pred_def_38472,type,
    v71495: state_type > $o ).

tff(pred_def_38473,type,
    v71507: state_type > $o ).

tff(pred_def_38474,type,
    v71205: state_type > $o ).

tff(pred_def_38475,type,
    v71203: state_type > $o ).

tff(pred_def_38476,type,
    v71201: state_type > $o ).

tff(pred_def_38477,type,
    v71199: state_type > $o ).

tff(pred_def_38478,type,
    v71509: state_type > $o ).

tff(pred_def_38479,type,
    v70887: state_type > $o ).

tff(pred_def_38480,type,
    v70885: state_type > $o ).

tff(pred_def_38481,type,
    v70883: state_type > $o ).

tff(pred_def_38482,type,
    v70881: state_type > $o ).

tff(pred_def_38483,type,
    v70879: state_type > $o ).

tff(pred_def_38484,type,
    v71511: state_type > $o ).

tff(pred_def_38485,type,
    v69789: state_type > $o ).

tff(pred_def_38486,type,
    v69787: state_type > $o ).

tff(pred_def_38487,type,
    v69785: state_type > $o ).

tff(pred_def_38488,type,
    v69783: state_type > $o ).

tff(pred_def_38489,type,
    v69781: state_type > $o ).

tff(pred_def_38490,type,
    v69779: state_type > $o ).

tff(pred_def_38491,type,
    v69777: state_type > $o ).

tff(pred_def_38492,type,
    v69775: state_type > $o ).

tff(pred_def_38493,type,
    v69773: state_type > $o ).

tff(pred_def_38494,type,
    v69771: state_type > $o ).

tff(pred_def_38495,type,
    v71514: state_type > $o ).

tff(pred_def_38496,type,
    v67271: state_type > $o ).

tff(pred_def_38497,type,
    v67269: state_type > $o ).

tff(pred_def_38498,type,
    v67267: state_type > $o ).

tff(pred_def_38499,type,
    v67265: state_type > $o ).

tff(pred_def_38500,type,
    v67263: state_type > $o ).

tff(pred_def_38501,type,
    v71599: state_type > $o ).

tff(pred_def_38502,type,
    v71597: state_type > $o ).

tff(pred_def_38503,type,
    v71603: state_type > $o ).

tff(pred_def_38504,type,
    v71601: state_type > $o ).

tff(pred_def_38505,type,
    v71607: state_type > $o ).

tff(pred_def_38506,type,
    v71605: state_type > $o ).

tff(pred_def_38507,type,
    v71609: state_type > $o ).

tff(pred_def_38508,type,
    v71595: state_type > $o ).

tff(pred_def_38509,type,
    v71593: state_type > $o ).

tff(pred_def_38510,type,
    v71591: state_type > $o ).

tff(pred_def_38511,type,
    v71589: state_type > $o ).

tff(pred_def_38512,type,
    v71587: state_type > $o ).

tff(pred_def_38513,type,
    v71623: state_type > $o ).

tff(pred_def_38514,type,
    v71621: state_type > $o ).

tff(pred_def_38515,type,
    v71627: state_type > $o ).

tff(pred_def_38516,type,
    v71625: state_type > $o ).

tff(pred_def_38517,type,
    v71631: state_type > $o ).

tff(pred_def_38518,type,
    v71629: state_type > $o ).

tff(pred_def_38519,type,
    v71633: state_type > $o ).

tff(pred_def_38520,type,
    v71619: state_type > $o ).

tff(pred_def_38521,type,
    v71617: state_type > $o ).

tff(pred_def_38522,type,
    v71615: state_type > $o ).

tff(pred_def_38523,type,
    v71613: state_type > $o ).

tff(pred_def_38524,type,
    v71611: state_type > $o ).

tff(pred_def_38525,type,
    v71647: state_type > $o ).

tff(pred_def_38526,type,
    v71645: state_type > $o ).

tff(pred_def_38527,type,
    v71651: state_type > $o ).

tff(pred_def_38528,type,
    v71649: state_type > $o ).

tff(pred_def_38529,type,
    v71655: state_type > $o ).

tff(pred_def_38530,type,
    v71653: state_type > $o ).

tff(pred_def_38531,type,
    v71657: state_type > $o ).

tff(pred_def_38532,type,
    v71643: state_type > $o ).

tff(pred_def_38533,type,
    v71641: state_type > $o ).

tff(pred_def_38534,type,
    v71639: state_type > $o ).

tff(pred_def_38535,type,
    v71637: state_type > $o ).

tff(pred_def_38536,type,
    v71635: state_type > $o ).

tff(pred_def_38537,type,
    v71659: state_type > $o ).

tff(pred_def_38538,type,
    v71585: state_type > $o ).

tff(pred_def_38539,type,
    v71583: state_type > $o ).

tff(pred_def_38540,type,
    v71581: state_type > $o ).

tff(pred_def_38541,type,
    v71579: state_type > $o ).

tff(pred_def_38542,type,
    v71577: state_type > $o ).

tff(pred_def_38543,type,
    v71683: state_type > $o ).

tff(pred_def_38544,type,
    v71681: state_type > $o ).

tff(pred_def_38545,type,
    v71687: state_type > $o ).

tff(pred_def_38546,type,
    v71685: state_type > $o ).

tff(pred_def_38547,type,
    v71691: state_type > $o ).

tff(pred_def_38548,type,
    v71689: state_type > $o ).

tff(pred_def_38549,type,
    v71693: state_type > $o ).

tff(pred_def_38550,type,
    v71679: state_type > $o ).

tff(pred_def_38551,type,
    v71677: state_type > $o ).

tff(pred_def_38552,type,
    v71675: state_type > $o ).

tff(pred_def_38553,type,
    v71673: state_type > $o ).

tff(pred_def_38554,type,
    v71671: state_type > $o ).

tff(pred_def_38555,type,
    v71707: state_type > $o ).

tff(pred_def_38556,type,
    v71705: state_type > $o ).

tff(pred_def_38557,type,
    v71711: state_type > $o ).

tff(pred_def_38558,type,
    v71709: state_type > $o ).

tff(pred_def_38559,type,
    v71715: state_type > $o ).

tff(pred_def_38560,type,
    v71713: state_type > $o ).

tff(pred_def_38561,type,
    v71717: state_type > $o ).

tff(pred_def_38562,type,
    v71703: state_type > $o ).

tff(pred_def_38563,type,
    v71701: state_type > $o ).

tff(pred_def_38564,type,
    v71699: state_type > $o ).

tff(pred_def_38565,type,
    v71697: state_type > $o ).

tff(pred_def_38566,type,
    v71695: state_type > $o ).

tff(pred_def_38567,type,
    v71731: state_type > $o ).

tff(pred_def_38568,type,
    v71729: state_type > $o ).

tff(pred_def_38569,type,
    v71735: state_type > $o ).

tff(pred_def_38570,type,
    v71733: state_type > $o ).

tff(pred_def_38571,type,
    v71739: state_type > $o ).

tff(pred_def_38572,type,
    v71737: state_type > $o ).

tff(pred_def_38573,type,
    v71741: state_type > $o ).

tff(pred_def_38574,type,
    v71727: state_type > $o ).

tff(pred_def_38575,type,
    v71725: state_type > $o ).

tff(pred_def_38576,type,
    v71723: state_type > $o ).

tff(pred_def_38577,type,
    v71721: state_type > $o ).

tff(pred_def_38578,type,
    v71719: state_type > $o ).

tff(pred_def_38579,type,
    v71743: state_type > $o ).

tff(pred_def_38580,type,
    v71669: state_type > $o ).

tff(pred_def_38581,type,
    v71667: state_type > $o ).

tff(pred_def_38582,type,
    v71665: state_type > $o ).

tff(pred_def_38583,type,
    v71663: state_type > $o ).

tff(pred_def_38584,type,
    v71661: state_type > $o ).

tff(pred_def_38585,type,
    v71767: state_type > $o ).

tff(pred_def_38586,type,
    v71765: state_type > $o ).

tff(pred_def_38587,type,
    v71771: state_type > $o ).

tff(pred_def_38588,type,
    v71769: state_type > $o ).

tff(pred_def_38589,type,
    v71775: state_type > $o ).

tff(pred_def_38590,type,
    v71773: state_type > $o ).

tff(pred_def_38591,type,
    v71777: state_type > $o ).

tff(pred_def_38592,type,
    v71763: state_type > $o ).

tff(pred_def_38593,type,
    v71761: state_type > $o ).

tff(pred_def_38594,type,
    v71759: state_type > $o ).

tff(pred_def_38595,type,
    v71757: state_type > $o ).

tff(pred_def_38596,type,
    v71755: state_type > $o ).

tff(pred_def_38597,type,
    v71791: state_type > $o ).

tff(pred_def_38598,type,
    v71789: state_type > $o ).

tff(pred_def_38599,type,
    v71795: state_type > $o ).

tff(pred_def_38600,type,
    v71793: state_type > $o ).

tff(pred_def_38601,type,
    v71799: state_type > $o ).

tff(pred_def_38602,type,
    v71797: state_type > $o ).

tff(pred_def_38603,type,
    v71801: state_type > $o ).

tff(pred_def_38604,type,
    v71787: state_type > $o ).

tff(pred_def_38605,type,
    v71785: state_type > $o ).

tff(pred_def_38606,type,
    v71783: state_type > $o ).

tff(pred_def_38607,type,
    v71781: state_type > $o ).

tff(pred_def_38608,type,
    v71779: state_type > $o ).

tff(pred_def_38609,type,
    v71815: state_type > $o ).

tff(pred_def_38610,type,
    v71813: state_type > $o ).

tff(pred_def_38611,type,
    v71819: state_type > $o ).

tff(pred_def_38612,type,
    v71817: state_type > $o ).

tff(pred_def_38613,type,
    v71823: state_type > $o ).

tff(pred_def_38614,type,
    v71821: state_type > $o ).

tff(pred_def_38615,type,
    v71825: state_type > $o ).

tff(pred_def_38616,type,
    v71811: state_type > $o ).

tff(pred_def_38617,type,
    v71809: state_type > $o ).

tff(pred_def_38618,type,
    v71807: state_type > $o ).

tff(pred_def_38619,type,
    v71805: state_type > $o ).

tff(pred_def_38620,type,
    v71803: state_type > $o ).

tff(pred_def_38621,type,
    v71827: state_type > $o ).

tff(pred_def_38622,type,
    v71753: state_type > $o ).

tff(pred_def_38623,type,
    v71751: state_type > $o ).

tff(pred_def_38624,type,
    v71749: state_type > $o ).

tff(pred_def_38625,type,
    v71747: state_type > $o ).

tff(pred_def_38626,type,
    v71745: state_type > $o ).

tff(pred_def_38627,type,
    v71829: state_type > $o ).

tff(pred_def_38628,type,
    v71575: state_type > $o ).

tff(pred_def_38629,type,
    v71573: state_type > $o ).

tff(pred_def_38630,type,
    v71571: state_type > $o ).

tff(pred_def_38631,type,
    v71569: state_type > $o ).

tff(pred_def_38632,type,
    v71567: state_type > $o ).

tff(pred_def_38633,type,
    v71863: state_type > $o ).

tff(pred_def_38634,type,
    v71861: state_type > $o ).

tff(pred_def_38635,type,
    v71867: state_type > $o ).

tff(pred_def_38636,type,
    v71865: state_type > $o ).

tff(pred_def_38637,type,
    v71871: state_type > $o ).

tff(pred_def_38638,type,
    v71869: state_type > $o ).

tff(pred_def_38639,type,
    v71873: state_type > $o ).

tff(pred_def_38640,type,
    v71859: state_type > $o ).

tff(pred_def_38641,type,
    v71857: state_type > $o ).

tff(pred_def_38642,type,
    v71855: state_type > $o ).

tff(pred_def_38643,type,
    v71853: state_type > $o ).

tff(pred_def_38644,type,
    v71851: state_type > $o ).

tff(pred_def_38645,type,
    v71887: state_type > $o ).

tff(pred_def_38646,type,
    v71885: state_type > $o ).

tff(pred_def_38647,type,
    v71891: state_type > $o ).

tff(pred_def_38648,type,
    v71889: state_type > $o ).

tff(pred_def_38649,type,
    v71895: state_type > $o ).

tff(pred_def_38650,type,
    v71893: state_type > $o ).

tff(pred_def_38651,type,
    v71897: state_type > $o ).

tff(pred_def_38652,type,
    v71883: state_type > $o ).

tff(pred_def_38653,type,
    v71881: state_type > $o ).

tff(pred_def_38654,type,
    v71879: state_type > $o ).

tff(pred_def_38655,type,
    v71877: state_type > $o ).

tff(pred_def_38656,type,
    v71875: state_type > $o ).

tff(pred_def_38657,type,
    v71911: state_type > $o ).

tff(pred_def_38658,type,
    v71909: state_type > $o ).

tff(pred_def_38659,type,
    v71915: state_type > $o ).

tff(pred_def_38660,type,
    v71913: state_type > $o ).

tff(pred_def_38661,type,
    v71919: state_type > $o ).

tff(pred_def_38662,type,
    v71917: state_type > $o ).

tff(pred_def_38663,type,
    v71921: state_type > $o ).

tff(pred_def_38664,type,
    v71907: state_type > $o ).

tff(pred_def_38665,type,
    v71905: state_type > $o ).

tff(pred_def_38666,type,
    v71903: state_type > $o ).

tff(pred_def_38667,type,
    v71901: state_type > $o ).

tff(pred_def_38668,type,
    v71899: state_type > $o ).

tff(pred_def_38669,type,
    v71923: state_type > $o ).

tff(pred_def_38670,type,
    v71849: state_type > $o ).

tff(pred_def_38671,type,
    v71847: state_type > $o ).

tff(pred_def_38672,type,
    v71845: state_type > $o ).

tff(pred_def_38673,type,
    v71843: state_type > $o ).

tff(pred_def_38674,type,
    v71841: state_type > $o ).

tff(pred_def_38675,type,
    v71947: state_type > $o ).

tff(pred_def_38676,type,
    v71945: state_type > $o ).

tff(pred_def_38677,type,
    v71951: state_type > $o ).

tff(pred_def_38678,type,
    v71949: state_type > $o ).

tff(pred_def_38679,type,
    v71955: state_type > $o ).

tff(pred_def_38680,type,
    v71953: state_type > $o ).

tff(pred_def_38681,type,
    v71957: state_type > $o ).

tff(pred_def_38682,type,
    v71943: state_type > $o ).

tff(pred_def_38683,type,
    v71941: state_type > $o ).

tff(pred_def_38684,type,
    v71939: state_type > $o ).

tff(pred_def_38685,type,
    v71937: state_type > $o ).

tff(pred_def_38686,type,
    v71935: state_type > $o ).

tff(pred_def_38687,type,
    v71971: state_type > $o ).

tff(pred_def_38688,type,
    v71969: state_type > $o ).

tff(pred_def_38689,type,
    v71975: state_type > $o ).

tff(pred_def_38690,type,
    v71973: state_type > $o ).

tff(pred_def_38691,type,
    v71979: state_type > $o ).

tff(pred_def_38692,type,
    v71977: state_type > $o ).

tff(pred_def_38693,type,
    v71981: state_type > $o ).

tff(pred_def_38694,type,
    v71967: state_type > $o ).

tff(pred_def_38695,type,
    v71965: state_type > $o ).

tff(pred_def_38696,type,
    v71963: state_type > $o ).

tff(pred_def_38697,type,
    v71961: state_type > $o ).

tff(pred_def_38698,type,
    v71959: state_type > $o ).

tff(pred_def_38699,type,
    v71995: state_type > $o ).

tff(pred_def_38700,type,
    v71993: state_type > $o ).

tff(pred_def_38701,type,
    v71999: state_type > $o ).

tff(pred_def_38702,type,
    v71997: state_type > $o ).

tff(pred_def_38703,type,
    v72003: state_type > $o ).

tff(pred_def_38704,type,
    v72001: state_type > $o ).

tff(pred_def_38705,type,
    v72005: state_type > $o ).

tff(pred_def_38706,type,
    v71991: state_type > $o ).

tff(pred_def_38707,type,
    v71989: state_type > $o ).

tff(pred_def_38708,type,
    v71987: state_type > $o ).

tff(pred_def_38709,type,
    v71985: state_type > $o ).

tff(pred_def_38710,type,
    v71983: state_type > $o ).

tff(pred_def_38711,type,
    v72007: state_type > $o ).

tff(pred_def_38712,type,
    v71933: state_type > $o ).

tff(pred_def_38713,type,
    v71931: state_type > $o ).

tff(pred_def_38714,type,
    v71929: state_type > $o ).

tff(pred_def_38715,type,
    v71927: state_type > $o ).

tff(pred_def_38716,type,
    v71925: state_type > $o ).

tff(pred_def_38717,type,
    v72031: state_type > $o ).

tff(pred_def_38718,type,
    v72029: state_type > $o ).

tff(pred_def_38719,type,
    v72035: state_type > $o ).

tff(pred_def_38720,type,
    v72033: state_type > $o ).

tff(pred_def_38721,type,
    v72039: state_type > $o ).

tff(pred_def_38722,type,
    v72037: state_type > $o ).

tff(pred_def_38723,type,
    v72041: state_type > $o ).

tff(pred_def_38724,type,
    v72027: state_type > $o ).

tff(pred_def_38725,type,
    v72025: state_type > $o ).

tff(pred_def_38726,type,
    v72023: state_type > $o ).

tff(pred_def_38727,type,
    v72021: state_type > $o ).

tff(pred_def_38728,type,
    v72019: state_type > $o ).

tff(pred_def_38729,type,
    v72055: state_type > $o ).

tff(pred_def_38730,type,
    v72053: state_type > $o ).

tff(pred_def_38731,type,
    v72059: state_type > $o ).

tff(pred_def_38732,type,
    v72057: state_type > $o ).

tff(pred_def_38733,type,
    v72063: state_type > $o ).

tff(pred_def_38734,type,
    v72061: state_type > $o ).

tff(pred_def_38735,type,
    v72065: state_type > $o ).

tff(pred_def_38736,type,
    v72051: state_type > $o ).

tff(pred_def_38737,type,
    v72049: state_type > $o ).

tff(pred_def_38738,type,
    v72047: state_type > $o ).

tff(pred_def_38739,type,
    v72045: state_type > $o ).

tff(pred_def_38740,type,
    v72043: state_type > $o ).

tff(pred_def_38741,type,
    v72079: state_type > $o ).

tff(pred_def_38742,type,
    v72077: state_type > $o ).

tff(pred_def_38743,type,
    v72083: state_type > $o ).

tff(pred_def_38744,type,
    v72081: state_type > $o ).

tff(pred_def_38745,type,
    v72087: state_type > $o ).

tff(pred_def_38746,type,
    v72085: state_type > $o ).

tff(pred_def_38747,type,
    v72089: state_type > $o ).

tff(pred_def_38748,type,
    v72075: state_type > $o ).

tff(pred_def_38749,type,
    v72073: state_type > $o ).

tff(pred_def_38750,type,
    v72071: state_type > $o ).

tff(pred_def_38751,type,
    v72069: state_type > $o ).

tff(pred_def_38752,type,
    v72067: state_type > $o ).

tff(pred_def_38753,type,
    v72091: state_type > $o ).

tff(pred_def_38754,type,
    v72017: state_type > $o ).

tff(pred_def_38755,type,
    v72015: state_type > $o ).

tff(pred_def_38756,type,
    v72013: state_type > $o ).

tff(pred_def_38757,type,
    v72011: state_type > $o ).

tff(pred_def_38758,type,
    v72009: state_type > $o ).

tff(pred_def_38759,type,
    v72093: state_type > $o ).

tff(pred_def_38760,type,
    v71839: state_type > $o ).

tff(pred_def_38761,type,
    v71837: state_type > $o ).

tff(pred_def_38762,type,
    v71835: state_type > $o ).

tff(pred_def_38763,type,
    v71833: state_type > $o ).

tff(pred_def_38764,type,
    v71831: state_type > $o ).

tff(pred_def_38765,type,
    v72117: state_type > $o ).

tff(pred_def_38766,type,
    v72115: state_type > $o ).

tff(pred_def_38767,type,
    v72121: state_type > $o ).

tff(pred_def_38768,type,
    v72119: state_type > $o ).

tff(pred_def_38769,type,
    v72125: state_type > $o ).

tff(pred_def_38770,type,
    v72123: state_type > $o ).

tff(pred_def_38771,type,
    v72127: state_type > $o ).

tff(pred_def_38772,type,
    v72113: state_type > $o ).

tff(pred_def_38773,type,
    v72111: state_type > $o ).

tff(pred_def_38774,type,
    v72109: state_type > $o ).

tff(pred_def_38775,type,
    v72107: state_type > $o ).

tff(pred_def_38776,type,
    v72105: state_type > $o ).

tff(pred_def_38777,type,
    v72151: state_type > $o ).

tff(pred_def_38778,type,
    v72149: state_type > $o ).

tff(pred_def_38779,type,
    v72155: state_type > $o ).

tff(pred_def_38780,type,
    v72153: state_type > $o ).

tff(pred_def_38781,type,
    v72159: state_type > $o ).

tff(pred_def_38782,type,
    v72157: state_type > $o ).

tff(pred_def_38783,type,
    v72161: state_type > $o ).

tff(pred_def_38784,type,
    v72147: state_type > $o ).

tff(pred_def_38785,type,
    v72145: state_type > $o ).

tff(pred_def_38786,type,
    v72143: state_type > $o ).

tff(pred_def_38787,type,
    v72141: state_type > $o ).

tff(pred_def_38788,type,
    v72139: state_type > $o ).

tff(pred_def_38789,type,
    v72175: state_type > $o ).

tff(pred_def_38790,type,
    v72173: state_type > $o ).

tff(pred_def_38791,type,
    v72179: state_type > $o ).

tff(pred_def_38792,type,
    v72177: state_type > $o ).

tff(pred_def_38793,type,
    v72183: state_type > $o ).

tff(pred_def_38794,type,
    v72181: state_type > $o ).

tff(pred_def_38795,type,
    v72185: state_type > $o ).

tff(pred_def_38796,type,
    v72171: state_type > $o ).

tff(pred_def_38797,type,
    v72169: state_type > $o ).

tff(pred_def_38798,type,
    v72167: state_type > $o ).

tff(pred_def_38799,type,
    v72165: state_type > $o ).

tff(pred_def_38800,type,
    v72163: state_type > $o ).

tff(pred_def_38801,type,
    v72199: state_type > $o ).

tff(pred_def_38802,type,
    v72197: state_type > $o ).

tff(pred_def_38803,type,
    v72203: state_type > $o ).

tff(pred_def_38804,type,
    v72201: state_type > $o ).

tff(pred_def_38805,type,
    v72207: state_type > $o ).

tff(pred_def_38806,type,
    v72205: state_type > $o ).

tff(pred_def_38807,type,
    v72209: state_type > $o ).

tff(pred_def_38808,type,
    v72195: state_type > $o ).

tff(pred_def_38809,type,
    v72193: state_type > $o ).

tff(pred_def_38810,type,
    v72191: state_type > $o ).

tff(pred_def_38811,type,
    v72189: state_type > $o ).

tff(pred_def_38812,type,
    v72187: state_type > $o ).

tff(pred_def_38813,type,
    v72211: state_type > $o ).

tff(pred_def_38814,type,
    v72137: state_type > $o ).

tff(pred_def_38815,type,
    v72135: state_type > $o ).

tff(pred_def_38816,type,
    v72133: state_type > $o ).

tff(pred_def_38817,type,
    v72131: state_type > $o ).

tff(pred_def_38818,type,
    v72129: state_type > $o ).

tff(pred_def_38819,type,
    v72225: state_type > $o ).

tff(pred_def_38820,type,
    v72223: state_type > $o ).

tff(pred_def_38821,type,
    v72222: state_type > $o ).

tff(pred_def_38822,type,
    v72221: ( state_type * $int ) > $o ).

tff(pred_def_38823,type,
    v72219: ( state_type * $int ) > $o ).

tff(pred_def_38824,type,
    v72217: ( state_type * $int ) > $o ).

tff(pred_def_38825,type,
    v72215: state_type > $o ).

tff(pred_def_38826,type,
    v72213: state_type > $o ).

tff(pred_def_38827,type,
    v72229: state_type > $o ).

tff(pred_def_38828,type,
    v72103: state_type > $o ).

tff(pred_def_38829,type,
    v72101: state_type > $o ).

tff(pred_def_38830,type,
    v72099: state_type > $o ).

tff(pred_def_38831,type,
    v72097: state_type > $o ).

tff(pred_def_38832,type,
    v72095: state_type > $o ).

tff(pred_def_38833,type,
    v72231: state_type > $o ).

tff(pred_def_38834,type,
    v71565: state_type > $o ).

tff(pred_def_38835,type,
    v71563: state_type > $o ).

tff(pred_def_38836,type,
    v71560: ( state_type * $int ) > $o ).

tff(pred_def_38837,type,
    v71558: state_type > $o ).

tff(pred_def_38838,type,
    v71556: state_type > $o ).

tff(pred_def_38839,type,
    v72273: state_type > $o ).

tff(pred_def_38840,type,
    v72271: state_type > $o ).

tff(pred_def_38841,type,
    v72277: state_type > $o ).

tff(pred_def_38842,type,
    v72275: state_type > $o ).

tff(pred_def_38843,type,
    v72281: state_type > $o ).

tff(pred_def_38844,type,
    v72279: state_type > $o ).

tff(pred_def_38845,type,
    v72283: state_type > $o ).

tff(pred_def_38846,type,
    v72269: state_type > $o ).

tff(pred_def_38847,type,
    v72267: state_type > $o ).

tff(pred_def_38848,type,
    v72265: state_type > $o ).

tff(pred_def_38849,type,
    v72263: state_type > $o ).

tff(pred_def_38850,type,
    v72261: state_type > $o ).

tff(pred_def_38851,type,
    v72297: state_type > $o ).

tff(pred_def_38852,type,
    v72295: state_type > $o ).

tff(pred_def_38853,type,
    v72301: state_type > $o ).

tff(pred_def_38854,type,
    v72299: state_type > $o ).

tff(pred_def_38855,type,
    v72305: state_type > $o ).

tff(pred_def_38856,type,
    v72303: state_type > $o ).

tff(pred_def_38857,type,
    v72307: state_type > $o ).

tff(pred_def_38858,type,
    v72293: state_type > $o ).

tff(pred_def_38859,type,
    v72291: state_type > $o ).

tff(pred_def_38860,type,
    v72289: state_type > $o ).

tff(pred_def_38861,type,
    v72287: state_type > $o ).

tff(pred_def_38862,type,
    v72285: state_type > $o ).

tff(pred_def_38863,type,
    v72321: state_type > $o ).

tff(pred_def_38864,type,
    v72319: state_type > $o ).

tff(pred_def_38865,type,
    v72325: state_type > $o ).

tff(pred_def_38866,type,
    v72323: state_type > $o ).

tff(pred_def_38867,type,
    v72329: state_type > $o ).

tff(pred_def_38868,type,
    v72327: state_type > $o ).

tff(pred_def_38869,type,
    v72331: state_type > $o ).

tff(pred_def_38870,type,
    v72317: state_type > $o ).

tff(pred_def_38871,type,
    v72315: state_type > $o ).

tff(pred_def_38872,type,
    v72313: state_type > $o ).

tff(pred_def_38873,type,
    v72311: state_type > $o ).

tff(pred_def_38874,type,
    v72309: state_type > $o ).

tff(pred_def_38875,type,
    v72333: state_type > $o ).

tff(pred_def_38876,type,
    v72259: state_type > $o ).

tff(pred_def_38877,type,
    v72257: state_type > $o ).

tff(pred_def_38878,type,
    v72255: state_type > $o ).

tff(pred_def_38879,type,
    v72253: state_type > $o ).

tff(pred_def_38880,type,
    v72251: state_type > $o ).

tff(pred_def_38881,type,
    v72357: state_type > $o ).

tff(pred_def_38882,type,
    v72355: state_type > $o ).

tff(pred_def_38883,type,
    v72361: state_type > $o ).

tff(pred_def_38884,type,
    v72359: state_type > $o ).

tff(pred_def_38885,type,
    v72365: state_type > $o ).

tff(pred_def_38886,type,
    v72363: state_type > $o ).

tff(pred_def_38887,type,
    v72367: state_type > $o ).

tff(pred_def_38888,type,
    v72353: state_type > $o ).

tff(pred_def_38889,type,
    v72351: state_type > $o ).

tff(pred_def_38890,type,
    v72349: state_type > $o ).

tff(pred_def_38891,type,
    v72347: state_type > $o ).

tff(pred_def_38892,type,
    v72345: state_type > $o ).

tff(pred_def_38893,type,
    v72381: state_type > $o ).

tff(pred_def_38894,type,
    v72379: state_type > $o ).

tff(pred_def_38895,type,
    v72385: state_type > $o ).

tff(pred_def_38896,type,
    v72383: state_type > $o ).

tff(pred_def_38897,type,
    v72389: state_type > $o ).

tff(pred_def_38898,type,
    v72387: state_type > $o ).

tff(pred_def_38899,type,
    v72391: state_type > $o ).

tff(pred_def_38900,type,
    v72377: state_type > $o ).

tff(pred_def_38901,type,
    v72375: state_type > $o ).

tff(pred_def_38902,type,
    v72373: state_type > $o ).

tff(pred_def_38903,type,
    v72371: state_type > $o ).

tff(pred_def_38904,type,
    v72369: state_type > $o ).

tff(pred_def_38905,type,
    v72405: state_type > $o ).

tff(pred_def_38906,type,
    v72403: state_type > $o ).

tff(pred_def_38907,type,
    v72409: state_type > $o ).

tff(pred_def_38908,type,
    v72407: state_type > $o ).

tff(pred_def_38909,type,
    v72413: state_type > $o ).

tff(pred_def_38910,type,
    v72411: state_type > $o ).

tff(pred_def_38911,type,
    v72415: state_type > $o ).

tff(pred_def_38912,type,
    v72401: state_type > $o ).

tff(pred_def_38913,type,
    v72399: state_type > $o ).

tff(pred_def_38914,type,
    v72397: state_type > $o ).

tff(pred_def_38915,type,
    v72395: state_type > $o ).

tff(pred_def_38916,type,
    v72393: state_type > $o ).

tff(pred_def_38917,type,
    v72417: state_type > $o ).

tff(pred_def_38918,type,
    v72343: state_type > $o ).

tff(pred_def_38919,type,
    v72341: state_type > $o ).

tff(pred_def_38920,type,
    v72339: state_type > $o ).

tff(pred_def_38921,type,
    v72337: state_type > $o ).

tff(pred_def_38922,type,
    v72335: state_type > $o ).

tff(pred_def_38923,type,
    v72441: state_type > $o ).

tff(pred_def_38924,type,
    v72439: state_type > $o ).

tff(pred_def_38925,type,
    v72445: state_type > $o ).

tff(pred_def_38926,type,
    v72443: state_type > $o ).

tff(pred_def_38927,type,
    v72449: state_type > $o ).

tff(pred_def_38928,type,
    v72447: state_type > $o ).

tff(pred_def_38929,type,
    v72451: state_type > $o ).

tff(pred_def_38930,type,
    v72437: state_type > $o ).

tff(pred_def_38931,type,
    v72435: state_type > $o ).

tff(pred_def_38932,type,
    v72433: state_type > $o ).

tff(pred_def_38933,type,
    v72431: state_type > $o ).

tff(pred_def_38934,type,
    v72429: state_type > $o ).

tff(pred_def_38935,type,
    v72465: state_type > $o ).

tff(pred_def_38936,type,
    v72463: state_type > $o ).

tff(pred_def_38937,type,
    v72469: state_type > $o ).

tff(pred_def_38938,type,
    v72467: state_type > $o ).

tff(pred_def_38939,type,
    v72473: state_type > $o ).

tff(pred_def_38940,type,
    v72471: state_type > $o ).

tff(pred_def_38941,type,
    v72475: state_type > $o ).

tff(pred_def_38942,type,
    v72461: state_type > $o ).

tff(pred_def_38943,type,
    v72459: state_type > $o ).

tff(pred_def_38944,type,
    v72457: state_type > $o ).

tff(pred_def_38945,type,
    v72455: state_type > $o ).

tff(pred_def_38946,type,
    v72453: state_type > $o ).

tff(pred_def_38947,type,
    v72489: state_type > $o ).

tff(pred_def_38948,type,
    v72487: state_type > $o ).

tff(pred_def_38949,type,
    v72493: state_type > $o ).

tff(pred_def_38950,type,
    v72491: state_type > $o ).

tff(pred_def_38951,type,
    v72497: state_type > $o ).

tff(pred_def_38952,type,
    v72495: state_type > $o ).

tff(pred_def_38953,type,
    v72499: state_type > $o ).

tff(pred_def_38954,type,
    v72485: state_type > $o ).

tff(pred_def_38955,type,
    v72483: state_type > $o ).

tff(pred_def_38956,type,
    v72481: state_type > $o ).

tff(pred_def_38957,type,
    v72479: state_type > $o ).

tff(pred_def_38958,type,
    v72477: state_type > $o ).

tff(pred_def_38959,type,
    v72501: state_type > $o ).

tff(pred_def_38960,type,
    v72427: state_type > $o ).

tff(pred_def_38961,type,
    v72425: state_type > $o ).

tff(pred_def_38962,type,
    v72423: state_type > $o ).

tff(pred_def_38963,type,
    v72421: state_type > $o ).

tff(pred_def_38964,type,
    v72419: state_type > $o ).

tff(pred_def_38965,type,
    v72503: state_type > $o ).

tff(pred_def_38966,type,
    v72249: state_type > $o ).

tff(pred_def_38967,type,
    v72247: state_type > $o ).

tff(pred_def_38968,type,
    v72245: state_type > $o ).

tff(pred_def_38969,type,
    v72243: state_type > $o ).

tff(pred_def_38970,type,
    v72241: state_type > $o ).

tff(pred_def_38971,type,
    v72537: state_type > $o ).

tff(pred_def_38972,type,
    v72535: state_type > $o ).

tff(pred_def_38973,type,
    v72541: state_type > $o ).

tff(pred_def_38974,type,
    v72539: state_type > $o ).

tff(pred_def_38975,type,
    v72545: state_type > $o ).

tff(pred_def_38976,type,
    v72543: state_type > $o ).

tff(pred_def_38977,type,
    v72547: state_type > $o ).

tff(pred_def_38978,type,
    v72533: state_type > $o ).

tff(pred_def_38979,type,
    v72531: state_type > $o ).

tff(pred_def_38980,type,
    v72529: state_type > $o ).

tff(pred_def_38981,type,
    v72527: state_type > $o ).

tff(pred_def_38982,type,
    v72525: state_type > $o ).

tff(pred_def_38983,type,
    v72561: state_type > $o ).

tff(pred_def_38984,type,
    v72559: state_type > $o ).

tff(pred_def_38985,type,
    v72565: state_type > $o ).

tff(pred_def_38986,type,
    v72563: state_type > $o ).

tff(pred_def_38987,type,
    v72569: state_type > $o ).

tff(pred_def_38988,type,
    v72567: state_type > $o ).

tff(pred_def_38989,type,
    v72571: state_type > $o ).

tff(pred_def_38990,type,
    v72557: state_type > $o ).

tff(pred_def_38991,type,
    v72555: state_type > $o ).

tff(pred_def_38992,type,
    v72553: state_type > $o ).

tff(pred_def_38993,type,
    v72551: state_type > $o ).

tff(pred_def_38994,type,
    v72549: state_type > $o ).

tff(pred_def_38995,type,
    v72585: state_type > $o ).

tff(pred_def_38996,type,
    v72583: state_type > $o ).

tff(pred_def_38997,type,
    v72589: state_type > $o ).

tff(pred_def_38998,type,
    v72587: state_type > $o ).

tff(pred_def_38999,type,
    v72593: state_type > $o ).

tff(pred_def_39000,type,
    v72591: state_type > $o ).

tff(pred_def_39001,type,
    v72595: state_type > $o ).

tff(pred_def_39002,type,
    v72581: state_type > $o ).

tff(pred_def_39003,type,
    v72579: state_type > $o ).

tff(pred_def_39004,type,
    v72577: state_type > $o ).

tff(pred_def_39005,type,
    v72575: state_type > $o ).

tff(pred_def_39006,type,
    v72573: state_type > $o ).

tff(pred_def_39007,type,
    v72597: state_type > $o ).

tff(pred_def_39008,type,
    v72523: state_type > $o ).

tff(pred_def_39009,type,
    v72521: state_type > $o ).

tff(pred_def_39010,type,
    v72519: state_type > $o ).

tff(pred_def_39011,type,
    v72517: state_type > $o ).

tff(pred_def_39012,type,
    v72515: state_type > $o ).

tff(pred_def_39013,type,
    v72621: state_type > $o ).

tff(pred_def_39014,type,
    v72619: state_type > $o ).

tff(pred_def_39015,type,
    v72625: state_type > $o ).

tff(pred_def_39016,type,
    v72623: state_type > $o ).

tff(pred_def_39017,type,
    v72629: state_type > $o ).

tff(pred_def_39018,type,
    v72627: state_type > $o ).

tff(pred_def_39019,type,
    v72631: state_type > $o ).

tff(pred_def_39020,type,
    v72617: state_type > $o ).

tff(pred_def_39021,type,
    v72615: state_type > $o ).

tff(pred_def_39022,type,
    v72613: state_type > $o ).

tff(pred_def_39023,type,
    v72611: state_type > $o ).

tff(pred_def_39024,type,
    v72609: state_type > $o ).

tff(pred_def_39025,type,
    v72645: state_type > $o ).

tff(pred_def_39026,type,
    v72643: state_type > $o ).

tff(pred_def_39027,type,
    v72649: state_type > $o ).

tff(pred_def_39028,type,
    v72647: state_type > $o ).

tff(pred_def_39029,type,
    v72653: state_type > $o ).

tff(pred_def_39030,type,
    v72651: state_type > $o ).

tff(pred_def_39031,type,
    v72655: state_type > $o ).

tff(pred_def_39032,type,
    v72641: state_type > $o ).

tff(pred_def_39033,type,
    v72639: state_type > $o ).

tff(pred_def_39034,type,
    v72637: state_type > $o ).

tff(pred_def_39035,type,
    v72635: state_type > $o ).

tff(pred_def_39036,type,
    v72633: state_type > $o ).

tff(pred_def_39037,type,
    v72669: state_type > $o ).

tff(pred_def_39038,type,
    v72667: state_type > $o ).

tff(pred_def_39039,type,
    v72673: state_type > $o ).

tff(pred_def_39040,type,
    v72671: state_type > $o ).

tff(pred_def_39041,type,
    v72677: state_type > $o ).

tff(pred_def_39042,type,
    v72675: state_type > $o ).

tff(pred_def_39043,type,
    v72679: state_type > $o ).

tff(pred_def_39044,type,
    v72665: state_type > $o ).

tff(pred_def_39045,type,
    v72663: state_type > $o ).

tff(pred_def_39046,type,
    v72661: state_type > $o ).

tff(pred_def_39047,type,
    v72659: state_type > $o ).

tff(pred_def_39048,type,
    v72657: state_type > $o ).

tff(pred_def_39049,type,
    v72681: state_type > $o ).

tff(pred_def_39050,type,
    v72607: state_type > $o ).

tff(pred_def_39051,type,
    v72605: state_type > $o ).

tff(pred_def_39052,type,
    v72603: state_type > $o ).

tff(pred_def_39053,type,
    v72601: state_type > $o ).

tff(pred_def_39054,type,
    v72599: state_type > $o ).

tff(pred_def_39055,type,
    v72705: state_type > $o ).

tff(pred_def_39056,type,
    v72703: state_type > $o ).

tff(pred_def_39057,type,
    v72709: state_type > $o ).

tff(pred_def_39058,type,
    v72707: state_type > $o ).

tff(pred_def_39059,type,
    v72713: state_type > $o ).

tff(pred_def_39060,type,
    v72711: state_type > $o ).

tff(pred_def_39061,type,
    v72715: state_type > $o ).

tff(pred_def_39062,type,
    v72701: state_type > $o ).

tff(pred_def_39063,type,
    v72699: state_type > $o ).

tff(pred_def_39064,type,
    v72697: state_type > $o ).

tff(pred_def_39065,type,
    v72695: state_type > $o ).

tff(pred_def_39066,type,
    v72693: state_type > $o ).

tff(pred_def_39067,type,
    v72729: state_type > $o ).

tff(pred_def_39068,type,
    v72727: state_type > $o ).

tff(pred_def_39069,type,
    v72733: state_type > $o ).

tff(pred_def_39070,type,
    v72731: state_type > $o ).

tff(pred_def_39071,type,
    v72737: state_type > $o ).

tff(pred_def_39072,type,
    v72735: state_type > $o ).

tff(pred_def_39073,type,
    v72739: state_type > $o ).

tff(pred_def_39074,type,
    v72725: state_type > $o ).

tff(pred_def_39075,type,
    v72723: state_type > $o ).

tff(pred_def_39076,type,
    v72721: state_type > $o ).

tff(pred_def_39077,type,
    v72719: state_type > $o ).

tff(pred_def_39078,type,
    v72717: state_type > $o ).

tff(pred_def_39079,type,
    v72753: state_type > $o ).

tff(pred_def_39080,type,
    v72751: state_type > $o ).

tff(pred_def_39081,type,
    v72757: state_type > $o ).

tff(pred_def_39082,type,
    v72755: state_type > $o ).

tff(pred_def_39083,type,
    v72761: state_type > $o ).

tff(pred_def_39084,type,
    v72759: state_type > $o ).

tff(pred_def_39085,type,
    v72763: state_type > $o ).

tff(pred_def_39086,type,
    v72749: state_type > $o ).

tff(pred_def_39087,type,
    v72747: state_type > $o ).

tff(pred_def_39088,type,
    v72745: state_type > $o ).

tff(pred_def_39089,type,
    v72743: state_type > $o ).

tff(pred_def_39090,type,
    v72741: state_type > $o ).

tff(pred_def_39091,type,
    v72765: state_type > $o ).

tff(pred_def_39092,type,
    v72691: state_type > $o ).

tff(pred_def_39093,type,
    v72689: state_type > $o ).

tff(pred_def_39094,type,
    v72687: state_type > $o ).

tff(pred_def_39095,type,
    v72685: state_type > $o ).

tff(pred_def_39096,type,
    v72683: state_type > $o ).

tff(pred_def_39097,type,
    v72767: state_type > $o ).

tff(pred_def_39098,type,
    v72513: state_type > $o ).

tff(pred_def_39099,type,
    v72511: state_type > $o ).

tff(pred_def_39100,type,
    v72509: state_type > $o ).

tff(pred_def_39101,type,
    v72507: state_type > $o ).

tff(pred_def_39102,type,
    v72505: state_type > $o ).

tff(pred_def_39103,type,
    v72791: state_type > $o ).

tff(pred_def_39104,type,
    v72789: state_type > $o ).

tff(pred_def_39105,type,
    v72795: state_type > $o ).

tff(pred_def_39106,type,
    v72793: state_type > $o ).

tff(pred_def_39107,type,
    v72799: state_type > $o ).

tff(pred_def_39108,type,
    v72797: state_type > $o ).

tff(pred_def_39109,type,
    v72801: state_type > $o ).

tff(pred_def_39110,type,
    v72787: state_type > $o ).

tff(pred_def_39111,type,
    v72785: state_type > $o ).

tff(pred_def_39112,type,
    v72783: state_type > $o ).

tff(pred_def_39113,type,
    v72781: state_type > $o ).

tff(pred_def_39114,type,
    v72779: state_type > $o ).

tff(pred_def_39115,type,
    v72825: state_type > $o ).

tff(pred_def_39116,type,
    v72823: state_type > $o ).

tff(pred_def_39117,type,
    v72829: state_type > $o ).

tff(pred_def_39118,type,
    v72827: state_type > $o ).

tff(pred_def_39119,type,
    v72833: state_type > $o ).

tff(pred_def_39120,type,
    v72831: state_type > $o ).

tff(pred_def_39121,type,
    v72835: state_type > $o ).

tff(pred_def_39122,type,
    v72821: state_type > $o ).

tff(pred_def_39123,type,
    v72819: state_type > $o ).

tff(pred_def_39124,type,
    v72817: state_type > $o ).

tff(pred_def_39125,type,
    v72815: state_type > $o ).

tff(pred_def_39126,type,
    v72813: state_type > $o ).

tff(pred_def_39127,type,
    v72849: state_type > $o ).

tff(pred_def_39128,type,
    v72847: state_type > $o ).

tff(pred_def_39129,type,
    v72853: state_type > $o ).

tff(pred_def_39130,type,
    v72851: state_type > $o ).

tff(pred_def_39131,type,
    v72857: state_type > $o ).

tff(pred_def_39132,type,
    v72855: state_type > $o ).

tff(pred_def_39133,type,
    v72859: state_type > $o ).

tff(pred_def_39134,type,
    v72845: state_type > $o ).

tff(pred_def_39135,type,
    v72843: state_type > $o ).

tff(pred_def_39136,type,
    v72841: state_type > $o ).

tff(pred_def_39137,type,
    v72839: state_type > $o ).

tff(pred_def_39138,type,
    v72837: state_type > $o ).

tff(pred_def_39139,type,
    v72873: state_type > $o ).

tff(pred_def_39140,type,
    v72871: state_type > $o ).

tff(pred_def_39141,type,
    v72877: state_type > $o ).

tff(pred_def_39142,type,
    v72875: state_type > $o ).

tff(pred_def_39143,type,
    v72881: state_type > $o ).

tff(pred_def_39144,type,
    v72879: state_type > $o ).

tff(pred_def_39145,type,
    v72883: state_type > $o ).

tff(pred_def_39146,type,
    v72869: state_type > $o ).

tff(pred_def_39147,type,
    v72867: state_type > $o ).

tff(pred_def_39148,type,
    v72865: state_type > $o ).

tff(pred_def_39149,type,
    v72863: state_type > $o ).

tff(pred_def_39150,type,
    v72861: state_type > $o ).

tff(pred_def_39151,type,
    v72885: state_type > $o ).

tff(pred_def_39152,type,
    v72811: state_type > $o ).

tff(pred_def_39153,type,
    v72809: state_type > $o ).

tff(pred_def_39154,type,
    v72807: state_type > $o ).

tff(pred_def_39155,type,
    v72805: state_type > $o ).

tff(pred_def_39156,type,
    v72803: state_type > $o ).

tff(pred_def_39157,type,
    v72895: state_type > $o ).

tff(pred_def_39158,type,
    v72893: state_type > $o ).

tff(pred_def_39159,type,
    v72892: state_type > $o ).

tff(pred_def_39160,type,
    v72891: ( state_type * $int ) > $o ).

tff(pred_def_39161,type,
    v72889: state_type > $o ).

tff(pred_def_39162,type,
    v72887: state_type > $o ).

tff(pred_def_39163,type,
    v72899: state_type > $o ).

tff(pred_def_39164,type,
    v72777: state_type > $o ).

tff(pred_def_39165,type,
    v72775: state_type > $o ).

tff(pred_def_39166,type,
    v72773: state_type > $o ).

tff(pred_def_39167,type,
    v72771: state_type > $o ).

tff(pred_def_39168,type,
    v72769: state_type > $o ).

tff(pred_def_39169,type,
    v72901: state_type > $o ).

tff(pred_def_39170,type,
    v72239: state_type > $o ).

tff(pred_def_39171,type,
    v72237: state_type > $o ).

tff(pred_def_39172,type,
    v72235: state_type > $o ).

tff(pred_def_39173,type,
    v72233: state_type > $o ).

tff(pred_def_39174,type,
    v72903: state_type > $o ).

tff(pred_def_39175,type,
    v71554: state_type > $o ).

tff(pred_def_39176,type,
    v71552: state_type > $o ).

tff(pred_def_39177,type,
    v71550: state_type > $o ).

tff(pred_def_39178,type,
    v71548: state_type > $o ).

tff(pred_def_39179,type,
    v71546: state_type > $o ).

tff(pred_def_39180,type,
    v72955: state_type > $o ).

tff(pred_def_39181,type,
    v72953: state_type > $o ).

tff(pred_def_39182,type,
    v72959: state_type > $o ).

tff(pred_def_39183,type,
    v72957: state_type > $o ).

tff(pred_def_39184,type,
    v72963: state_type > $o ).

tff(pred_def_39185,type,
    v72961: state_type > $o ).

tff(pred_def_39186,type,
    v72965: state_type > $o ).

tff(pred_def_39187,type,
    v72951: state_type > $o ).

tff(pred_def_39188,type,
    v72949: state_type > $o ).

tff(pred_def_39189,type,
    v72947: state_type > $o ).

tff(pred_def_39190,type,
    v72945: state_type > $o ).

tff(pred_def_39191,type,
    v72943: state_type > $o ).

tff(pred_def_39192,type,
    v72979: state_type > $o ).

tff(pred_def_39193,type,
    v72977: state_type > $o ).

tff(pred_def_39194,type,
    v72983: state_type > $o ).

tff(pred_def_39195,type,
    v72981: state_type > $o ).

tff(pred_def_39196,type,
    v72987: state_type > $o ).

tff(pred_def_39197,type,
    v72985: state_type > $o ).

tff(pred_def_39198,type,
    v72989: state_type > $o ).

tff(pred_def_39199,type,
    v72975: state_type > $o ).

tff(pred_def_39200,type,
    v72973: state_type > $o ).

tff(pred_def_39201,type,
    v72971: state_type > $o ).

tff(pred_def_39202,type,
    v72969: state_type > $o ).

tff(pred_def_39203,type,
    v72967: state_type > $o ).

tff(pred_def_39204,type,
    v73003: state_type > $o ).

tff(pred_def_39205,type,
    v73001: state_type > $o ).

tff(pred_def_39206,type,
    v73007: state_type > $o ).

tff(pred_def_39207,type,
    v73005: state_type > $o ).

tff(pred_def_39208,type,
    v73011: state_type > $o ).

tff(pred_def_39209,type,
    v73009: state_type > $o ).

tff(pred_def_39210,type,
    v73013: state_type > $o ).

tff(pred_def_39211,type,
    v72999: state_type > $o ).

tff(pred_def_39212,type,
    v72997: state_type > $o ).

tff(pred_def_39213,type,
    v72995: state_type > $o ).

tff(pred_def_39214,type,
    v72993: state_type > $o ).

tff(pred_def_39215,type,
    v72991: state_type > $o ).

tff(pred_def_39216,type,
    v73015: state_type > $o ).

tff(pred_def_39217,type,
    v72941: state_type > $o ).

tff(pred_def_39218,type,
    v72939: state_type > $o ).

tff(pred_def_39219,type,
    v72937: state_type > $o ).

tff(pred_def_39220,type,
    v72935: state_type > $o ).

tff(pred_def_39221,type,
    v72933: state_type > $o ).

tff(pred_def_39222,type,
    v73039: state_type > $o ).

tff(pred_def_39223,type,
    v73037: state_type > $o ).

tff(pred_def_39224,type,
    v73043: state_type > $o ).

tff(pred_def_39225,type,
    v73041: state_type > $o ).

tff(pred_def_39226,type,
    v73047: state_type > $o ).

tff(pred_def_39227,type,
    v73045: state_type > $o ).

tff(pred_def_39228,type,
    v73049: state_type > $o ).

tff(pred_def_39229,type,
    v73035: state_type > $o ).

tff(pred_def_39230,type,
    v73033: state_type > $o ).

tff(pred_def_39231,type,
    v73031: state_type > $o ).

tff(pred_def_39232,type,
    v73029: state_type > $o ).

tff(pred_def_39233,type,
    v73027: state_type > $o ).

tff(pred_def_39234,type,
    v73063: state_type > $o ).

tff(pred_def_39235,type,
    v73061: state_type > $o ).

tff(pred_def_39236,type,
    v73067: state_type > $o ).

tff(pred_def_39237,type,
    v73065: state_type > $o ).

tff(pred_def_39238,type,
    v73071: state_type > $o ).

tff(pred_def_39239,type,
    v73069: state_type > $o ).

tff(pred_def_39240,type,
    v73073: state_type > $o ).

tff(pred_def_39241,type,
    v73059: state_type > $o ).

tff(pred_def_39242,type,
    v73057: state_type > $o ).

tff(pred_def_39243,type,
    v73055: state_type > $o ).

tff(pred_def_39244,type,
    v73053: state_type > $o ).

tff(pred_def_39245,type,
    v73051: state_type > $o ).

tff(pred_def_39246,type,
    v73087: state_type > $o ).

tff(pred_def_39247,type,
    v73085: state_type > $o ).

tff(pred_def_39248,type,
    v73091: state_type > $o ).

tff(pred_def_39249,type,
    v73089: state_type > $o ).

tff(pred_def_39250,type,
    v73095: state_type > $o ).

tff(pred_def_39251,type,
    v73093: state_type > $o ).

tff(pred_def_39252,type,
    v73097: state_type > $o ).

tff(pred_def_39253,type,
    v73083: state_type > $o ).

tff(pred_def_39254,type,
    v73081: state_type > $o ).

tff(pred_def_39255,type,
    v73079: state_type > $o ).

tff(pred_def_39256,type,
    v73077: state_type > $o ).

tff(pred_def_39257,type,
    v73075: state_type > $o ).

tff(pred_def_39258,type,
    v73099: state_type > $o ).

tff(pred_def_39259,type,
    v73025: state_type > $o ).

tff(pred_def_39260,type,
    v73023: state_type > $o ).

tff(pred_def_39261,type,
    v73021: state_type > $o ).

tff(pred_def_39262,type,
    v73019: state_type > $o ).

tff(pred_def_39263,type,
    v73017: state_type > $o ).

tff(pred_def_39264,type,
    v73123: state_type > $o ).

tff(pred_def_39265,type,
    v73121: state_type > $o ).

tff(pred_def_39266,type,
    v73127: state_type > $o ).

tff(pred_def_39267,type,
    v73125: state_type > $o ).

tff(pred_def_39268,type,
    v73131: state_type > $o ).

tff(pred_def_39269,type,
    v73129: state_type > $o ).

tff(pred_def_39270,type,
    v73133: state_type > $o ).

tff(pred_def_39271,type,
    v73119: state_type > $o ).

tff(pred_def_39272,type,
    v73117: state_type > $o ).

tff(pred_def_39273,type,
    v73115: state_type > $o ).

tff(pred_def_39274,type,
    v73113: state_type > $o ).

tff(pred_def_39275,type,
    v73111: state_type > $o ).

tff(pred_def_39276,type,
    v73147: state_type > $o ).

tff(pred_def_39277,type,
    v73145: state_type > $o ).

tff(pred_def_39278,type,
    v73151: state_type > $o ).

tff(pred_def_39279,type,
    v73149: state_type > $o ).

tff(pred_def_39280,type,
    v73155: state_type > $o ).

tff(pred_def_39281,type,
    v73153: state_type > $o ).

tff(pred_def_39282,type,
    v73157: state_type > $o ).

tff(pred_def_39283,type,
    v73143: state_type > $o ).

tff(pred_def_39284,type,
    v73141: state_type > $o ).

tff(pred_def_39285,type,
    v73139: state_type > $o ).

tff(pred_def_39286,type,
    v73137: state_type > $o ).

tff(pred_def_39287,type,
    v73135: state_type > $o ).

tff(pred_def_39288,type,
    v73171: state_type > $o ).

tff(pred_def_39289,type,
    v73169: state_type > $o ).

tff(pred_def_39290,type,
    v73175: state_type > $o ).

tff(pred_def_39291,type,
    v73173: state_type > $o ).

tff(pred_def_39292,type,
    v73179: state_type > $o ).

tff(pred_def_39293,type,
    v73177: state_type > $o ).

tff(pred_def_39294,type,
    v73181: state_type > $o ).

tff(pred_def_39295,type,
    v73167: state_type > $o ).

tff(pred_def_39296,type,
    v73165: state_type > $o ).

tff(pred_def_39297,type,
    v73163: state_type > $o ).

tff(pred_def_39298,type,
    v73161: state_type > $o ).

tff(pred_def_39299,type,
    v73159: state_type > $o ).

tff(pred_def_39300,type,
    v73183: state_type > $o ).

tff(pred_def_39301,type,
    v73109: state_type > $o ).

tff(pred_def_39302,type,
    v73107: state_type > $o ).

tff(pred_def_39303,type,
    v73105: state_type > $o ).

tff(pred_def_39304,type,
    v73103: state_type > $o ).

tff(pred_def_39305,type,
    v73101: state_type > $o ).

tff(pred_def_39306,type,
    v73185: state_type > $o ).

tff(pred_def_39307,type,
    v72931: state_type > $o ).

tff(pred_def_39308,type,
    v72929: state_type > $o ).

tff(pred_def_39309,type,
    v72927: state_type > $o ).

tff(pred_def_39310,type,
    v72925: state_type > $o ).

tff(pred_def_39311,type,
    v72923: state_type > $o ).

tff(pred_def_39312,type,
    v73219: state_type > $o ).

tff(pred_def_39313,type,
    v73217: state_type > $o ).

tff(pred_def_39314,type,
    v73223: state_type > $o ).

tff(pred_def_39315,type,
    v73221: state_type > $o ).

tff(pred_def_39316,type,
    v73227: state_type > $o ).

tff(pred_def_39317,type,
    v73225: state_type > $o ).

tff(pred_def_39318,type,
    v73229: state_type > $o ).

tff(pred_def_39319,type,
    v73215: state_type > $o ).

tff(pred_def_39320,type,
    v73213: state_type > $o ).

tff(pred_def_39321,type,
    v73211: state_type > $o ).

tff(pred_def_39322,type,
    v73209: state_type > $o ).

tff(pred_def_39323,type,
    v73207: state_type > $o ).

tff(pred_def_39324,type,
    v73243: state_type > $o ).

tff(pred_def_39325,type,
    v73241: state_type > $o ).

tff(pred_def_39326,type,
    v73247: state_type > $o ).

tff(pred_def_39327,type,
    v73245: state_type > $o ).

tff(pred_def_39328,type,
    v73251: state_type > $o ).

tff(pred_def_39329,type,
    v73249: state_type > $o ).

tff(pred_def_39330,type,
    v73253: state_type > $o ).

tff(pred_def_39331,type,
    v73239: state_type > $o ).

tff(pred_def_39332,type,
    v73237: state_type > $o ).

tff(pred_def_39333,type,
    v73235: state_type > $o ).

tff(pred_def_39334,type,
    v73233: state_type > $o ).

tff(pred_def_39335,type,
    v73231: state_type > $o ).

tff(pred_def_39336,type,
    v73267: state_type > $o ).

tff(pred_def_39337,type,
    v73265: state_type > $o ).

tff(pred_def_39338,type,
    v73271: state_type > $o ).

tff(pred_def_39339,type,
    v73269: state_type > $o ).

tff(pred_def_39340,type,
    v73275: state_type > $o ).

tff(pred_def_39341,type,
    v73273: state_type > $o ).

tff(pred_def_39342,type,
    v73277: state_type > $o ).

tff(pred_def_39343,type,
    v73263: state_type > $o ).

tff(pred_def_39344,type,
    v73261: state_type > $o ).

tff(pred_def_39345,type,
    v73259: state_type > $o ).

tff(pred_def_39346,type,
    v73257: state_type > $o ).

tff(pred_def_39347,type,
    v73255: state_type > $o ).

tff(pred_def_39348,type,
    v73279: state_type > $o ).

tff(pred_def_39349,type,
    v73205: state_type > $o ).

tff(pred_def_39350,type,
    v73203: state_type > $o ).

tff(pred_def_39351,type,
    v73201: state_type > $o ).

tff(pred_def_39352,type,
    v73199: state_type > $o ).

tff(pred_def_39353,type,
    v73197: state_type > $o ).

tff(pred_def_39354,type,
    v73303: state_type > $o ).

tff(pred_def_39355,type,
    v73301: state_type > $o ).

tff(pred_def_39356,type,
    v73307: state_type > $o ).

tff(pred_def_39357,type,
    v73305: state_type > $o ).

tff(pred_def_39358,type,
    v73311: state_type > $o ).

tff(pred_def_39359,type,
    v73309: state_type > $o ).

tff(pred_def_39360,type,
    v73313: state_type > $o ).

tff(pred_def_39361,type,
    v73299: state_type > $o ).

tff(pred_def_39362,type,
    v73297: state_type > $o ).

tff(pred_def_39363,type,
    v73295: state_type > $o ).

tff(pred_def_39364,type,
    v73293: state_type > $o ).

tff(pred_def_39365,type,
    v73291: state_type > $o ).

tff(pred_def_39366,type,
    v73327: state_type > $o ).

tff(pred_def_39367,type,
    v73325: state_type > $o ).

tff(pred_def_39368,type,
    v73331: state_type > $o ).

tff(pred_def_39369,type,
    v73329: state_type > $o ).

tff(pred_def_39370,type,
    v73335: state_type > $o ).

tff(pred_def_39371,type,
    v73333: state_type > $o ).

tff(pred_def_39372,type,
    v73337: state_type > $o ).

tff(pred_def_39373,type,
    v73323: state_type > $o ).

tff(pred_def_39374,type,
    v73321: state_type > $o ).

tff(pred_def_39375,type,
    v73319: state_type > $o ).

tff(pred_def_39376,type,
    v73317: state_type > $o ).

tff(pred_def_39377,type,
    v73315: state_type > $o ).

tff(pred_def_39378,type,
    v73351: state_type > $o ).

tff(pred_def_39379,type,
    v73349: state_type > $o ).

tff(pred_def_39380,type,
    v73355: state_type > $o ).

tff(pred_def_39381,type,
    v73353: state_type > $o ).

tff(pred_def_39382,type,
    v73359: state_type > $o ).

tff(pred_def_39383,type,
    v73357: state_type > $o ).

tff(pred_def_39384,type,
    v73361: state_type > $o ).

tff(pred_def_39385,type,
    v73347: state_type > $o ).

tff(pred_def_39386,type,
    v73345: state_type > $o ).

tff(pred_def_39387,type,
    v73343: state_type > $o ).

tff(pred_def_39388,type,
    v73341: state_type > $o ).

tff(pred_def_39389,type,
    v73339: state_type > $o ).

tff(pred_def_39390,type,
    v73363: state_type > $o ).

tff(pred_def_39391,type,
    v73289: state_type > $o ).

tff(pred_def_39392,type,
    v73287: state_type > $o ).

tff(pred_def_39393,type,
    v73285: state_type > $o ).

tff(pred_def_39394,type,
    v73283: state_type > $o ).

tff(pred_def_39395,type,
    v73281: state_type > $o ).

tff(pred_def_39396,type,
    v73387: state_type > $o ).

tff(pred_def_39397,type,
    v73385: state_type > $o ).

tff(pred_def_39398,type,
    v73391: state_type > $o ).

tff(pred_def_39399,type,
    v73389: state_type > $o ).

tff(pred_def_39400,type,
    v73395: state_type > $o ).

tff(pred_def_39401,type,
    v73393: state_type > $o ).

tff(pred_def_39402,type,
    v73397: state_type > $o ).

tff(pred_def_39403,type,
    v73383: state_type > $o ).

tff(pred_def_39404,type,
    v73381: state_type > $o ).

tff(pred_def_39405,type,
    v73379: state_type > $o ).

tff(pred_def_39406,type,
    v73377: state_type > $o ).

tff(pred_def_39407,type,
    v73375: state_type > $o ).

tff(pred_def_39408,type,
    v73411: state_type > $o ).

tff(pred_def_39409,type,
    v73409: state_type > $o ).

tff(pred_def_39410,type,
    v73415: state_type > $o ).

tff(pred_def_39411,type,
    v73413: state_type > $o ).

tff(pred_def_39412,type,
    v73419: state_type > $o ).

tff(pred_def_39413,type,
    v73417: state_type > $o ).

tff(pred_def_39414,type,
    v73421: state_type > $o ).

tff(pred_def_39415,type,
    v73407: state_type > $o ).

tff(pred_def_39416,type,
    v73405: state_type > $o ).

tff(pred_def_39417,type,
    v73403: state_type > $o ).

tff(pred_def_39418,type,
    v73401: state_type > $o ).

tff(pred_def_39419,type,
    v73399: state_type > $o ).

tff(pred_def_39420,type,
    v73435: state_type > $o ).

tff(pred_def_39421,type,
    v73433: state_type > $o ).

tff(pred_def_39422,type,
    v73439: state_type > $o ).

tff(pred_def_39423,type,
    v73437: state_type > $o ).

tff(pred_def_39424,type,
    v73443: state_type > $o ).

tff(pred_def_39425,type,
    v73441: state_type > $o ).

tff(pred_def_39426,type,
    v73445: state_type > $o ).

tff(pred_def_39427,type,
    v73431: state_type > $o ).

tff(pred_def_39428,type,
    v73429: state_type > $o ).

tff(pred_def_39429,type,
    v73427: state_type > $o ).

tff(pred_def_39430,type,
    v73425: state_type > $o ).

tff(pred_def_39431,type,
    v73423: state_type > $o ).

tff(pred_def_39432,type,
    v73447: state_type > $o ).

tff(pred_def_39433,type,
    v73373: state_type > $o ).

tff(pred_def_39434,type,
    v73371: state_type > $o ).

tff(pred_def_39435,type,
    v73369: state_type > $o ).

tff(pred_def_39436,type,
    v73367: state_type > $o ).

tff(pred_def_39437,type,
    v73365: state_type > $o ).

tff(pred_def_39438,type,
    v73449: state_type > $o ).

tff(pred_def_39439,type,
    v73195: state_type > $o ).

tff(pred_def_39440,type,
    v73193: state_type > $o ).

tff(pred_def_39441,type,
    v73191: state_type > $o ).

tff(pred_def_39442,type,
    v73189: state_type > $o ).

tff(pred_def_39443,type,
    v73187: state_type > $o ).

tff(pred_def_39444,type,
    v73473: state_type > $o ).

tff(pred_def_39445,type,
    v73471: state_type > $o ).

tff(pred_def_39446,type,
    v73477: state_type > $o ).

tff(pred_def_39447,type,
    v73475: state_type > $o ).

tff(pred_def_39448,type,
    v73481: state_type > $o ).

tff(pred_def_39449,type,
    v73479: state_type > $o ).

tff(pred_def_39450,type,
    v73483: state_type > $o ).

tff(pred_def_39451,type,
    v73469: state_type > $o ).

tff(pred_def_39452,type,
    v73467: state_type > $o ).

tff(pred_def_39453,type,
    v73465: state_type > $o ).

tff(pred_def_39454,type,
    v73463: state_type > $o ).

tff(pred_def_39455,type,
    v73461: state_type > $o ).

tff(pred_def_39456,type,
    v73507: state_type > $o ).

tff(pred_def_39457,type,
    v73505: state_type > $o ).

tff(pred_def_39458,type,
    v73511: state_type > $o ).

tff(pred_def_39459,type,
    v73509: state_type > $o ).

tff(pred_def_39460,type,
    v73515: state_type > $o ).

tff(pred_def_39461,type,
    v73513: state_type > $o ).

tff(pred_def_39462,type,
    v73517: state_type > $o ).

tff(pred_def_39463,type,
    v73503: state_type > $o ).

tff(pred_def_39464,type,
    v73501: state_type > $o ).

tff(pred_def_39465,type,
    v73499: state_type > $o ).

tff(pred_def_39466,type,
    v73497: state_type > $o ).

tff(pred_def_39467,type,
    v73495: state_type > $o ).

tff(pred_def_39468,type,
    v73531: state_type > $o ).

tff(pred_def_39469,type,
    v73529: state_type > $o ).

tff(pred_def_39470,type,
    v73535: state_type > $o ).

tff(pred_def_39471,type,
    v73533: state_type > $o ).

tff(pred_def_39472,type,
    v73539: state_type > $o ).

tff(pred_def_39473,type,
    v73537: state_type > $o ).

tff(pred_def_39474,type,
    v73541: state_type > $o ).

tff(pred_def_39475,type,
    v73527: state_type > $o ).

tff(pred_def_39476,type,
    v73525: state_type > $o ).

tff(pred_def_39477,type,
    v73523: state_type > $o ).

tff(pred_def_39478,type,
    v73521: state_type > $o ).

tff(pred_def_39479,type,
    v73519: state_type > $o ).

tff(pred_def_39480,type,
    v73555: state_type > $o ).

tff(pred_def_39481,type,
    v73553: state_type > $o ).

tff(pred_def_39482,type,
    v73559: state_type > $o ).

tff(pred_def_39483,type,
    v73557: state_type > $o ).

tff(pred_def_39484,type,
    v73563: state_type > $o ).

tff(pred_def_39485,type,
    v73561: state_type > $o ).

tff(pred_def_39486,type,
    v73565: state_type > $o ).

tff(pred_def_39487,type,
    v73551: state_type > $o ).

tff(pred_def_39488,type,
    v73549: state_type > $o ).

tff(pred_def_39489,type,
    v73547: state_type > $o ).

tff(pred_def_39490,type,
    v73545: state_type > $o ).

tff(pred_def_39491,type,
    v73543: state_type > $o ).

tff(pred_def_39492,type,
    v73567: state_type > $o ).

tff(pred_def_39493,type,
    v73493: state_type > $o ).

tff(pred_def_39494,type,
    v73491: state_type > $o ).

tff(pred_def_39495,type,
    v73489: state_type > $o ).

tff(pred_def_39496,type,
    v73487: state_type > $o ).

tff(pred_def_39497,type,
    v73485: state_type > $o ).

tff(pred_def_39498,type,
    v73577: state_type > $o ).

tff(pred_def_39499,type,
    v73575: state_type > $o ).

tff(pred_def_39500,type,
    v73574: state_type > $o ).

tff(pred_def_39501,type,
    v73573: ( state_type * $int ) > $o ).

tff(pred_def_39502,type,
    v73571: state_type > $o ).

tff(pred_def_39503,type,
    v73569: state_type > $o ).

tff(pred_def_39504,type,
    v73581: state_type > $o ).

tff(pred_def_39505,type,
    v73459: state_type > $o ).

tff(pred_def_39506,type,
    v73457: state_type > $o ).

tff(pred_def_39507,type,
    v73455: state_type > $o ).

tff(pred_def_39508,type,
    v73453: state_type > $o ).

tff(pred_def_39509,type,
    v73451: state_type > $o ).

tff(pred_def_39510,type,
    v73583: state_type > $o ).

tff(pred_def_39511,type,
    v72921: state_type > $o ).

tff(pred_def_39512,type,
    v72919: state_type > $o ).

tff(pred_def_39513,type,
    v72917: state_type > $o ).

tff(pred_def_39514,type,
    v72915: state_type > $o ).

tff(pred_def_39515,type,
    v73625: state_type > $o ).

tff(pred_def_39516,type,
    v73623: state_type > $o ).

tff(pred_def_39517,type,
    v73629: state_type > $o ).

tff(pred_def_39518,type,
    v73627: state_type > $o ).

tff(pred_def_39519,type,
    v73633: state_type > $o ).

tff(pred_def_39520,type,
    v73631: state_type > $o ).

tff(pred_def_39521,type,
    v73635: state_type > $o ).

tff(pred_def_39522,type,
    v73621: state_type > $o ).

tff(pred_def_39523,type,
    v73619: state_type > $o ).

tff(pred_def_39524,type,
    v73617: state_type > $o ).

tff(pred_def_39525,type,
    v73615: state_type > $o ).

tff(pred_def_39526,type,
    v73613: state_type > $o ).

tff(pred_def_39527,type,
    v73649: state_type > $o ).

tff(pred_def_39528,type,
    v73647: state_type > $o ).

tff(pred_def_39529,type,
    v73653: state_type > $o ).

tff(pred_def_39530,type,
    v73651: state_type > $o ).

tff(pred_def_39531,type,
    v73657: state_type > $o ).

tff(pred_def_39532,type,
    v73655: state_type > $o ).

tff(pred_def_39533,type,
    v73659: state_type > $o ).

tff(pred_def_39534,type,
    v73645: state_type > $o ).

tff(pred_def_39535,type,
    v73643: state_type > $o ).

tff(pred_def_39536,type,
    v73641: state_type > $o ).

tff(pred_def_39537,type,
    v73639: state_type > $o ).

tff(pred_def_39538,type,
    v73637: state_type > $o ).

tff(pred_def_39539,type,
    v73673: state_type > $o ).

tff(pred_def_39540,type,
    v73671: state_type > $o ).

tff(pred_def_39541,type,
    v73677: state_type > $o ).

tff(pred_def_39542,type,
    v73675: state_type > $o ).

tff(pred_def_39543,type,
    v73681: state_type > $o ).

tff(pred_def_39544,type,
    v73679: state_type > $o ).

tff(pred_def_39545,type,
    v73683: state_type > $o ).

tff(pred_def_39546,type,
    v73669: state_type > $o ).

tff(pred_def_39547,type,
    v73667: state_type > $o ).

tff(pred_def_39548,type,
    v73665: state_type > $o ).

tff(pred_def_39549,type,
    v73663: state_type > $o ).

tff(pred_def_39550,type,
    v73661: state_type > $o ).

tff(pred_def_39551,type,
    v73685: state_type > $o ).

tff(pred_def_39552,type,
    v73611: state_type > $o ).

tff(pred_def_39553,type,
    v73609: state_type > $o ).

tff(pred_def_39554,type,
    v73607: state_type > $o ).

tff(pred_def_39555,type,
    v73605: state_type > $o ).

tff(pred_def_39556,type,
    v73603: state_type > $o ).

tff(pred_def_39557,type,
    v73709: state_type > $o ).

tff(pred_def_39558,type,
    v73707: state_type > $o ).

tff(pred_def_39559,type,
    v73713: state_type > $o ).

tff(pred_def_39560,type,
    v73711: state_type > $o ).

tff(pred_def_39561,type,
    v73717: state_type > $o ).

tff(pred_def_39562,type,
    v73715: state_type > $o ).

tff(pred_def_39563,type,
    v73719: state_type > $o ).

tff(pred_def_39564,type,
    v73705: state_type > $o ).

tff(pred_def_39565,type,
    v73703: state_type > $o ).

tff(pred_def_39566,type,
    v73701: state_type > $o ).

tff(pred_def_39567,type,
    v73699: state_type > $o ).

tff(pred_def_39568,type,
    v73697: state_type > $o ).

tff(pred_def_39569,type,
    v73733: state_type > $o ).

tff(pred_def_39570,type,
    v73731: state_type > $o ).

tff(pred_def_39571,type,
    v73737: state_type > $o ).

tff(pred_def_39572,type,
    v73735: state_type > $o ).

tff(pred_def_39573,type,
    v73741: state_type > $o ).

tff(pred_def_39574,type,
    v73739: state_type > $o ).

tff(pred_def_39575,type,
    v73743: state_type > $o ).

tff(pred_def_39576,type,
    v73729: state_type > $o ).

tff(pred_def_39577,type,
    v73727: state_type > $o ).

tff(pred_def_39578,type,
    v73725: state_type > $o ).

tff(pred_def_39579,type,
    v73723: state_type > $o ).

tff(pred_def_39580,type,
    v73721: state_type > $o ).

tff(pred_def_39581,type,
    v73757: state_type > $o ).

tff(pred_def_39582,type,
    v73755: state_type > $o ).

tff(pred_def_39583,type,
    v73761: state_type > $o ).

tff(pred_def_39584,type,
    v73759: state_type > $o ).

tff(pred_def_39585,type,
    v73765: state_type > $o ).

tff(pred_def_39586,type,
    v73763: state_type > $o ).

tff(pred_def_39587,type,
    v73767: state_type > $o ).

tff(pred_def_39588,type,
    v73753: state_type > $o ).

tff(pred_def_39589,type,
    v73751: state_type > $o ).

tff(pred_def_39590,type,
    v73749: state_type > $o ).

tff(pred_def_39591,type,
    v73747: state_type > $o ).

tff(pred_def_39592,type,
    v73745: state_type > $o ).

tff(pred_def_39593,type,
    v73769: state_type > $o ).

tff(pred_def_39594,type,
    v73695: state_type > $o ).

tff(pred_def_39595,type,
    v73693: state_type > $o ).

tff(pred_def_39596,type,
    v73691: state_type > $o ).

tff(pred_def_39597,type,
    v73689: state_type > $o ).

tff(pred_def_39598,type,
    v73687: state_type > $o ).

tff(pred_def_39599,type,
    v73793: state_type > $o ).

tff(pred_def_39600,type,
    v73791: state_type > $o ).

tff(pred_def_39601,type,
    v73797: state_type > $o ).

tff(pred_def_39602,type,
    v73795: state_type > $o ).

tff(pred_def_39603,type,
    v73801: state_type > $o ).

tff(pred_def_39604,type,
    v73799: state_type > $o ).

tff(pred_def_39605,type,
    v73803: state_type > $o ).

tff(pred_def_39606,type,
    v73789: state_type > $o ).

tff(pred_def_39607,type,
    v73787: state_type > $o ).

tff(pred_def_39608,type,
    v73785: state_type > $o ).

tff(pred_def_39609,type,
    v73783: state_type > $o ).

tff(pred_def_39610,type,
    v73781: state_type > $o ).

tff(pred_def_39611,type,
    v73817: state_type > $o ).

tff(pred_def_39612,type,
    v73815: state_type > $o ).

tff(pred_def_39613,type,
    v73821: state_type > $o ).

tff(pred_def_39614,type,
    v73819: state_type > $o ).

tff(pred_def_39615,type,
    v73825: state_type > $o ).

tff(pred_def_39616,type,
    v73823: state_type > $o ).

tff(pred_def_39617,type,
    v73827: state_type > $o ).

tff(pred_def_39618,type,
    v73813: state_type > $o ).

tff(pred_def_39619,type,
    v73811: state_type > $o ).

tff(pred_def_39620,type,
    v73809: state_type > $o ).

tff(pred_def_39621,type,
    v73807: state_type > $o ).

tff(pred_def_39622,type,
    v73805: state_type > $o ).

tff(pred_def_39623,type,
    v73841: state_type > $o ).

tff(pred_def_39624,type,
    v73839: state_type > $o ).

tff(pred_def_39625,type,
    v73845: state_type > $o ).

tff(pred_def_39626,type,
    v73843: state_type > $o ).

tff(pred_def_39627,type,
    v73849: state_type > $o ).

tff(pred_def_39628,type,
    v73847: state_type > $o ).

tff(pred_def_39629,type,
    v73851: state_type > $o ).

tff(pred_def_39630,type,
    v73837: state_type > $o ).

tff(pred_def_39631,type,
    v73835: state_type > $o ).

tff(pred_def_39632,type,
    v73833: state_type > $o ).

tff(pred_def_39633,type,
    v73831: state_type > $o ).

tff(pred_def_39634,type,
    v73829: state_type > $o ).

tff(pred_def_39635,type,
    v73853: state_type > $o ).

tff(pred_def_39636,type,
    v73779: state_type > $o ).

tff(pred_def_39637,type,
    v73777: state_type > $o ).

tff(pred_def_39638,type,
    v73775: state_type > $o ).

tff(pred_def_39639,type,
    v73773: state_type > $o ).

tff(pred_def_39640,type,
    v73771: state_type > $o ).

tff(pred_def_39641,type,
    v73855: state_type > $o ).

tff(pred_def_39642,type,
    v73601: state_type > $o ).

tff(pred_def_39643,type,
    v73599: state_type > $o ).

tff(pred_def_39644,type,
    v73597: state_type > $o ).

tff(pred_def_39645,type,
    v73595: state_type > $o ).

tff(pred_def_39646,type,
    v73593: state_type > $o ).

tff(pred_def_39647,type,
    v73889: state_type > $o ).

tff(pred_def_39648,type,
    v73887: state_type > $o ).

tff(pred_def_39649,type,
    v73893: state_type > $o ).

tff(pred_def_39650,type,
    v73891: state_type > $o ).

tff(pred_def_39651,type,
    v73897: state_type > $o ).

tff(pred_def_39652,type,
    v73895: state_type > $o ).

tff(pred_def_39653,type,
    v73899: state_type > $o ).

tff(pred_def_39654,type,
    v73885: state_type > $o ).

tff(pred_def_39655,type,
    v73883: state_type > $o ).

tff(pred_def_39656,type,
    v73881: state_type > $o ).

tff(pred_def_39657,type,
    v73879: state_type > $o ).

tff(pred_def_39658,type,
    v73877: state_type > $o ).

tff(pred_def_39659,type,
    v73913: state_type > $o ).

tff(pred_def_39660,type,
    v73911: state_type > $o ).

tff(pred_def_39661,type,
    v73917: state_type > $o ).

tff(pred_def_39662,type,
    v73915: state_type > $o ).

tff(pred_def_39663,type,
    v73921: state_type > $o ).

tff(pred_def_39664,type,
    v73919: state_type > $o ).

tff(pred_def_39665,type,
    v73923: state_type > $o ).

tff(pred_def_39666,type,
    v73909: state_type > $o ).

tff(pred_def_39667,type,
    v73907: state_type > $o ).

tff(pred_def_39668,type,
    v73905: state_type > $o ).

tff(pred_def_39669,type,
    v73903: state_type > $o ).

tff(pred_def_39670,type,
    v73901: state_type > $o ).

tff(pred_def_39671,type,
    v73937: state_type > $o ).

tff(pred_def_39672,type,
    v73935: state_type > $o ).

tff(pred_def_39673,type,
    v73941: state_type > $o ).

tff(pred_def_39674,type,
    v73939: state_type > $o ).

tff(pred_def_39675,type,
    v73945: state_type > $o ).

tff(pred_def_39676,type,
    v73943: state_type > $o ).

tff(pred_def_39677,type,
    v73947: state_type > $o ).

tff(pred_def_39678,type,
    v73933: state_type > $o ).

tff(pred_def_39679,type,
    v73931: state_type > $o ).

tff(pred_def_39680,type,
    v73929: state_type > $o ).

tff(pred_def_39681,type,
    v73927: state_type > $o ).

tff(pred_def_39682,type,
    v73925: state_type > $o ).

tff(pred_def_39683,type,
    v73949: state_type > $o ).

tff(pred_def_39684,type,
    v73875: state_type > $o ).

tff(pred_def_39685,type,
    v73873: state_type > $o ).

tff(pred_def_39686,type,
    v73871: state_type > $o ).

tff(pred_def_39687,type,
    v73869: state_type > $o ).

tff(pred_def_39688,type,
    v73867: state_type > $o ).

tff(pred_def_39689,type,
    v73973: state_type > $o ).

tff(pred_def_39690,type,
    v73971: state_type > $o ).

tff(pred_def_39691,type,
    v73977: state_type > $o ).

tff(pred_def_39692,type,
    v73975: state_type > $o ).

tff(pred_def_39693,type,
    v73981: state_type > $o ).

tff(pred_def_39694,type,
    v73979: state_type > $o ).

tff(pred_def_39695,type,
    v73983: state_type > $o ).

tff(pred_def_39696,type,
    v73969: state_type > $o ).

tff(pred_def_39697,type,
    v73967: state_type > $o ).

tff(pred_def_39698,type,
    v73965: state_type > $o ).

tff(pred_def_39699,type,
    v73963: state_type > $o ).

tff(pred_def_39700,type,
    v73961: state_type > $o ).

tff(pred_def_39701,type,
    v73997: state_type > $o ).

tff(pred_def_39702,type,
    v73995: state_type > $o ).

tff(pred_def_39703,type,
    v74001: state_type > $o ).

tff(pred_def_39704,type,
    v73999: state_type > $o ).

tff(pred_def_39705,type,
    v74005: state_type > $o ).

tff(pred_def_39706,type,
    v74003: state_type > $o ).

tff(pred_def_39707,type,
    v74007: state_type > $o ).

tff(pred_def_39708,type,
    v73993: state_type > $o ).

tff(pred_def_39709,type,
    v73991: state_type > $o ).

tff(pred_def_39710,type,
    v73989: state_type > $o ).

tff(pred_def_39711,type,
    v73987: state_type > $o ).

tff(pred_def_39712,type,
    v73985: state_type > $o ).

tff(pred_def_39713,type,
    v74021: state_type > $o ).

tff(pred_def_39714,type,
    v74019: state_type > $o ).

tff(pred_def_39715,type,
    v74025: state_type > $o ).

tff(pred_def_39716,type,
    v74023: state_type > $o ).

tff(pred_def_39717,type,
    v74029: state_type > $o ).

tff(pred_def_39718,type,
    v74027: state_type > $o ).

tff(pred_def_39719,type,
    v74031: state_type > $o ).

tff(pred_def_39720,type,
    v74017: state_type > $o ).

tff(pred_def_39721,type,
    v74015: state_type > $o ).

tff(pred_def_39722,type,
    v74013: state_type > $o ).

tff(pred_def_39723,type,
    v74011: state_type > $o ).

tff(pred_def_39724,type,
    v74009: state_type > $o ).

tff(pred_def_39725,type,
    v74033: state_type > $o ).

tff(pred_def_39726,type,
    v73959: state_type > $o ).

tff(pred_def_39727,type,
    v73957: state_type > $o ).

tff(pred_def_39728,type,
    v73955: state_type > $o ).

tff(pred_def_39729,type,
    v73953: state_type > $o ).

tff(pred_def_39730,type,
    v73951: state_type > $o ).

tff(pred_def_39731,type,
    v74057: state_type > $o ).

tff(pred_def_39732,type,
    v74055: state_type > $o ).

tff(pred_def_39733,type,
    v74061: state_type > $o ).

tff(pred_def_39734,type,
    v74059: state_type > $o ).

tff(pred_def_39735,type,
    v74065: state_type > $o ).

tff(pred_def_39736,type,
    v74063: state_type > $o ).

tff(pred_def_39737,type,
    v74067: state_type > $o ).

tff(pred_def_39738,type,
    v74053: state_type > $o ).

tff(pred_def_39739,type,
    v74051: state_type > $o ).

tff(pred_def_39740,type,
    v74049: state_type > $o ).

tff(pred_def_39741,type,
    v74047: state_type > $o ).

tff(pred_def_39742,type,
    v74045: state_type > $o ).

tff(pred_def_39743,type,
    v74081: state_type > $o ).

tff(pred_def_39744,type,
    v74079: state_type > $o ).

tff(pred_def_39745,type,
    v74085: state_type > $o ).

tff(pred_def_39746,type,
    v74083: state_type > $o ).

tff(pred_def_39747,type,
    v74089: state_type > $o ).

tff(pred_def_39748,type,
    v74087: state_type > $o ).

tff(pred_def_39749,type,
    v74091: state_type > $o ).

tff(pred_def_39750,type,
    v74077: state_type > $o ).

tff(pred_def_39751,type,
    v74075: state_type > $o ).

tff(pred_def_39752,type,
    v74073: state_type > $o ).

tff(pred_def_39753,type,
    v74071: state_type > $o ).

tff(pred_def_39754,type,
    v74069: state_type > $o ).

tff(pred_def_39755,type,
    v74105: state_type > $o ).

tff(pred_def_39756,type,
    v74103: state_type > $o ).

tff(pred_def_39757,type,
    v74109: state_type > $o ).

tff(pred_def_39758,type,
    v74107: state_type > $o ).

tff(pred_def_39759,type,
    v74113: state_type > $o ).

tff(pred_def_39760,type,
    v74111: state_type > $o ).

tff(pred_def_39761,type,
    v74115: state_type > $o ).

tff(pred_def_39762,type,
    v74101: state_type > $o ).

tff(pred_def_39763,type,
    v74099: state_type > $o ).

tff(pred_def_39764,type,
    v74097: state_type > $o ).

tff(pred_def_39765,type,
    v74095: state_type > $o ).

tff(pred_def_39766,type,
    v74093: state_type > $o ).

tff(pred_def_39767,type,
    v74117: state_type > $o ).

tff(pred_def_39768,type,
    v74043: state_type > $o ).

tff(pred_def_39769,type,
    v74041: state_type > $o ).

tff(pred_def_39770,type,
    v74039: state_type > $o ).

tff(pred_def_39771,type,
    v74037: state_type > $o ).

tff(pred_def_39772,type,
    v74035: state_type > $o ).

tff(pred_def_39773,type,
    v74119: state_type > $o ).

tff(pred_def_39774,type,
    v73865: state_type > $o ).

tff(pred_def_39775,type,
    v73863: state_type > $o ).

tff(pred_def_39776,type,
    v73861: state_type > $o ).

tff(pred_def_39777,type,
    v73859: state_type > $o ).

tff(pred_def_39778,type,
    v73857: state_type > $o ).

tff(pred_def_39779,type,
    v74143: state_type > $o ).

tff(pred_def_39780,type,
    v74141: state_type > $o ).

tff(pred_def_39781,type,
    v74147: state_type > $o ).

tff(pred_def_39782,type,
    v74145: state_type > $o ).

tff(pred_def_39783,type,
    v74151: state_type > $o ).

tff(pred_def_39784,type,
    v74149: state_type > $o ).

tff(pred_def_39785,type,
    v74153: state_type > $o ).

tff(pred_def_39786,type,
    v74139: state_type > $o ).

tff(pred_def_39787,type,
    v74137: state_type > $o ).

tff(pred_def_39788,type,
    v74135: state_type > $o ).

tff(pred_def_39789,type,
    v74133: state_type > $o ).

tff(pred_def_39790,type,
    v74131: state_type > $o ).

tff(pred_def_39791,type,
    v74177: state_type > $o ).

tff(pred_def_39792,type,
    v74175: state_type > $o ).

tff(pred_def_39793,type,
    v74181: state_type > $o ).

tff(pred_def_39794,type,
    v74179: state_type > $o ).

tff(pred_def_39795,type,
    v74185: state_type > $o ).

tff(pred_def_39796,type,
    v74183: state_type > $o ).

tff(pred_def_39797,type,
    v74187: state_type > $o ).

tff(pred_def_39798,type,
    v74173: state_type > $o ).

tff(pred_def_39799,type,
    v74171: state_type > $o ).

tff(pred_def_39800,type,
    v74169: state_type > $o ).

tff(pred_def_39801,type,
    v74167: state_type > $o ).

tff(pred_def_39802,type,
    v74165: state_type > $o ).

tff(pred_def_39803,type,
    v74201: state_type > $o ).

tff(pred_def_39804,type,
    v74199: state_type > $o ).

tff(pred_def_39805,type,
    v74205: state_type > $o ).

tff(pred_def_39806,type,
    v74203: state_type > $o ).

tff(pred_def_39807,type,
    v74209: state_type > $o ).

tff(pred_def_39808,type,
    v74207: state_type > $o ).

tff(pred_def_39809,type,
    v74211: state_type > $o ).

tff(pred_def_39810,type,
    v74197: state_type > $o ).

tff(pred_def_39811,type,
    v74195: state_type > $o ).

tff(pred_def_39812,type,
    v74193: state_type > $o ).

tff(pred_def_39813,type,
    v74191: state_type > $o ).

tff(pred_def_39814,type,
    v74189: state_type > $o ).

tff(pred_def_39815,type,
    v74225: state_type > $o ).

tff(pred_def_39816,type,
    v74223: state_type > $o ).

tff(pred_def_39817,type,
    v74229: state_type > $o ).

tff(pred_def_39818,type,
    v74227: state_type > $o ).

tff(pred_def_39819,type,
    v74233: state_type > $o ).

tff(pred_def_39820,type,
    v74231: state_type > $o ).

tff(pred_def_39821,type,
    v74235: state_type > $o ).

tff(pred_def_39822,type,
    v74221: state_type > $o ).

tff(pred_def_39823,type,
    v74219: state_type > $o ).

tff(pred_def_39824,type,
    v74217: state_type > $o ).

tff(pred_def_39825,type,
    v74215: state_type > $o ).

tff(pred_def_39826,type,
    v74213: state_type > $o ).

tff(pred_def_39827,type,
    v74237: state_type > $o ).

tff(pred_def_39828,type,
    v74163: state_type > $o ).

tff(pred_def_39829,type,
    v74161: state_type > $o ).

tff(pred_def_39830,type,
    v74159: state_type > $o ).

tff(pred_def_39831,type,
    v74157: state_type > $o ).

tff(pred_def_39832,type,
    v74155: state_type > $o ).

tff(pred_def_39833,type,
    v74247: state_type > $o ).

tff(pred_def_39834,type,
    v74245: state_type > $o ).

tff(pred_def_39835,type,
    v74244: state_type > $o ).

tff(pred_def_39836,type,
    v74243: ( state_type * $int ) > $o ).

tff(pred_def_39837,type,
    v74241: state_type > $o ).

tff(pred_def_39838,type,
    v74239: state_type > $o ).

tff(pred_def_39839,type,
    v74251: state_type > $o ).

tff(pred_def_39840,type,
    v74129: state_type > $o ).

tff(pred_def_39841,type,
    v74127: state_type > $o ).

tff(pred_def_39842,type,
    v74125: state_type > $o ).

tff(pred_def_39843,type,
    v74123: state_type > $o ).

tff(pred_def_39844,type,
    v74121: state_type > $o ).

tff(pred_def_39845,type,
    v74253: state_type > $o ).

tff(pred_def_39846,type,
    v73591: state_type > $o ).

tff(pred_def_39847,type,
    v73589: state_type > $o ).

tff(pred_def_39848,type,
    v73587: state_type > $o ).

tff(pred_def_39849,type,
    v73585: state_type > $o ).

tff(pred_def_39850,type,
    v74255: state_type > $o ).

tff(pred_def_39851,type,
    v72913: state_type > $o ).

tff(pred_def_39852,type,
    v72911: state_type > $o ).

tff(pred_def_39853,type,
    v72909: state_type > $o ).

tff(pred_def_39854,type,
    v72907: state_type > $o ).

tff(pred_def_39855,type,
    v72905: state_type > $o ).

tff(pred_def_39856,type,
    v74257: state_type > $o ).

tff(pred_def_39857,type,
    v71544: state_type > $o ).

tff(pred_def_39858,type,
    v71542: state_type > $o ).

tff(pred_def_39859,type,
    v71540: state_type > $o ).

tff(pred_def_39860,type,
    v71538: state_type > $o ).

tff(pred_def_39861,type,
    v71536: state_type > $o ).

tff(pred_def_39862,type,
    v74263: state_type > $o ).

tff(pred_def_39863,type,
    v74261: state_type > $o ).

tff(pred_def_39864,type,
    v74259: state_type > $o ).

tff(pred_def_39865,type,
    v74265: state_type > $o ).

tff(pred_def_39866,type,
    v71534: state_type > $o ).

tff(pred_def_39867,type,
    v71532: state_type > $o ).

tff(pred_def_39868,type,
    v71530: state_type > $o ).

tff(pred_def_39869,type,
    v71528: state_type > $o ).

tff(pred_def_39870,type,
    v71526: state_type > $o ).

tff(pred_def_39871,type,
    v74269: state_type > $o ).

tff(pred_def_39872,type,
    v74267: state_type > $o ).

tff(pred_def_39873,type,
    v74271: state_type > $o ).

tff(pred_def_39874,type,
    v71524: state_type > $o ).

tff(pred_def_39875,type,
    v71522: state_type > $o ).

tff(pred_def_39876,type,
    v71520: state_type > $o ).

tff(pred_def_39877,type,
    v71518: state_type > $o ).

tff(pred_def_39878,type,
    v71516: state_type > $o ).

tff(pred_def_39879,type,
    v67261: state_type > $o ).

tff(pred_def_39880,type,
    v67259: state_type > $o ).

tff(pred_def_39881,type,
    v67257: state_type > $o ).

tff(pred_def_39882,type,
    v74274: state_type > $o ).

tff(pred_def_39883,type,
    v74273: ( state_type * $int ) > $o ).

tff(pred_def_39884,type,
    v67255: ( state_type * $int ) > $o ).

tff(pred_def_39885,type,
    v67253: ( state_type * $int ) > $o ).

tff(pred_def_39886,type,
    v74319: state_type > $o ).

tff(pred_def_39887,type,
    v74317: state_type > $o ).

tff(pred_def_39888,type,
    v74323: state_type > $o ).

tff(pred_def_39889,type,
    v74321: state_type > $o ).

tff(pred_def_39890,type,
    v74327: state_type > $o ).

tff(pred_def_39891,type,
    v74325: state_type > $o ).

tff(pred_def_39892,type,
    v74329: state_type > $o ).

tff(pred_def_39893,type,
    v74315: state_type > $o ).

tff(pred_def_39894,type,
    v74313: state_type > $o ).

tff(pred_def_39895,type,
    v74311: state_type > $o ).

tff(pred_def_39896,type,
    v74309: state_type > $o ).

tff(pred_def_39897,type,
    v74307: state_type > $o ).

tff(pred_def_39898,type,
    v74343: state_type > $o ).

tff(pred_def_39899,type,
    v74341: state_type > $o ).

tff(pred_def_39900,type,
    v74347: state_type > $o ).

tff(pred_def_39901,type,
    v74345: state_type > $o ).

tff(pred_def_39902,type,
    v74351: state_type > $o ).

tff(pred_def_39903,type,
    v74349: state_type > $o ).

tff(pred_def_39904,type,
    v74353: state_type > $o ).

tff(pred_def_39905,type,
    v74339: state_type > $o ).

tff(pred_def_39906,type,
    v74337: state_type > $o ).

tff(pred_def_39907,type,
    v74335: state_type > $o ).

tff(pred_def_39908,type,
    v74333: state_type > $o ).

tff(pred_def_39909,type,
    v74331: state_type > $o ).

tff(pred_def_39910,type,
    v74367: state_type > $o ).

tff(pred_def_39911,type,
    v74365: state_type > $o ).

tff(pred_def_39912,type,
    v74371: state_type > $o ).

tff(pred_def_39913,type,
    v74369: state_type > $o ).

tff(pred_def_39914,type,
    v74375: state_type > $o ).

tff(pred_def_39915,type,
    v74373: state_type > $o ).

tff(pred_def_39916,type,
    v74377: state_type > $o ).

tff(pred_def_39917,type,
    v74363: state_type > $o ).

tff(pred_def_39918,type,
    v74361: state_type > $o ).

tff(pred_def_39919,type,
    v74359: state_type > $o ).

tff(pred_def_39920,type,
    v74357: state_type > $o ).

tff(pred_def_39921,type,
    v74355: state_type > $o ).

tff(pred_def_39922,type,
    v74379: state_type > $o ).

tff(pred_def_39923,type,
    v74305: state_type > $o ).

tff(pred_def_39924,type,
    v74303: state_type > $o ).

tff(pred_def_39925,type,
    v74301: state_type > $o ).

tff(pred_def_39926,type,
    v74299: state_type > $o ).

tff(pred_def_39927,type,
    v74297: state_type > $o ).

tff(pred_def_39928,type,
    v74403: state_type > $o ).

tff(pred_def_39929,type,
    v74401: state_type > $o ).

tff(pred_def_39930,type,
    v74407: state_type > $o ).

tff(pred_def_39931,type,
    v74405: state_type > $o ).

tff(pred_def_39932,type,
    v74411: state_type > $o ).

tff(pred_def_39933,type,
    v74409: state_type > $o ).

tff(pred_def_39934,type,
    v74413: state_type > $o ).

tff(pred_def_39935,type,
    v74399: state_type > $o ).

tff(pred_def_39936,type,
    v74397: state_type > $o ).

tff(pred_def_39937,type,
    v74395: state_type > $o ).

tff(pred_def_39938,type,
    v74393: state_type > $o ).

tff(pred_def_39939,type,
    v74391: state_type > $o ).

tff(pred_def_39940,type,
    v74427: state_type > $o ).

tff(pred_def_39941,type,
    v74425: state_type > $o ).

tff(pred_def_39942,type,
    v74431: state_type > $o ).

tff(pred_def_39943,type,
    v74429: state_type > $o ).

tff(pred_def_39944,type,
    v74435: state_type > $o ).

tff(pred_def_39945,type,
    v74433: state_type > $o ).

tff(pred_def_39946,type,
    v74437: state_type > $o ).

tff(pred_def_39947,type,
    v74423: state_type > $o ).

tff(pred_def_39948,type,
    v74421: state_type > $o ).

tff(pred_def_39949,type,
    v74419: state_type > $o ).

tff(pred_def_39950,type,
    v74417: state_type > $o ).

tff(pred_def_39951,type,
    v74415: state_type > $o ).

tff(pred_def_39952,type,
    v74451: state_type > $o ).

tff(pred_def_39953,type,
    v74449: state_type > $o ).

tff(pred_def_39954,type,
    v74455: state_type > $o ).

tff(pred_def_39955,type,
    v74453: state_type > $o ).

tff(pred_def_39956,type,
    v74459: state_type > $o ).

tff(pred_def_39957,type,
    v74457: state_type > $o ).

tff(pred_def_39958,type,
    v74461: state_type > $o ).

tff(pred_def_39959,type,
    v74447: state_type > $o ).

tff(pred_def_39960,type,
    v74445: state_type > $o ).

tff(pred_def_39961,type,
    v74443: state_type > $o ).

tff(pred_def_39962,type,
    v74441: state_type > $o ).

tff(pred_def_39963,type,
    v74439: state_type > $o ).

tff(pred_def_39964,type,
    v74463: state_type > $o ).

tff(pred_def_39965,type,
    v74389: state_type > $o ).

tff(pred_def_39966,type,
    v74387: state_type > $o ).

tff(pred_def_39967,type,
    v74385: state_type > $o ).

tff(pred_def_39968,type,
    v74383: state_type > $o ).

tff(pred_def_39969,type,
    v74381: state_type > $o ).

tff(pred_def_39970,type,
    v74487: state_type > $o ).

tff(pred_def_39971,type,
    v74485: state_type > $o ).

tff(pred_def_39972,type,
    v74491: state_type > $o ).

tff(pred_def_39973,type,
    v74489: state_type > $o ).

tff(pred_def_39974,type,
    v74495: state_type > $o ).

tff(pred_def_39975,type,
    v74493: state_type > $o ).

tff(pred_def_39976,type,
    v74497: state_type > $o ).

tff(pred_def_39977,type,
    v74483: state_type > $o ).

tff(pred_def_39978,type,
    v74481: state_type > $o ).

tff(pred_def_39979,type,
    v74479: state_type > $o ).

tff(pred_def_39980,type,
    v74477: state_type > $o ).

tff(pred_def_39981,type,
    v74475: state_type > $o ).

tff(pred_def_39982,type,
    v74511: state_type > $o ).

tff(pred_def_39983,type,
    v74509: state_type > $o ).

tff(pred_def_39984,type,
    v74515: state_type > $o ).

tff(pred_def_39985,type,
    v74513: state_type > $o ).

tff(pred_def_39986,type,
    v74519: state_type > $o ).

tff(pred_def_39987,type,
    v74517: state_type > $o ).

tff(pred_def_39988,type,
    v74521: state_type > $o ).

tff(pred_def_39989,type,
    v74507: state_type > $o ).

tff(pred_def_39990,type,
    v74505: state_type > $o ).

tff(pred_def_39991,type,
    v74503: state_type > $o ).

tff(pred_def_39992,type,
    v74501: state_type > $o ).

tff(pred_def_39993,type,
    v74499: state_type > $o ).

tff(pred_def_39994,type,
    v74535: state_type > $o ).

tff(pred_def_39995,type,
    v74533: state_type > $o ).

tff(pred_def_39996,type,
    v74539: state_type > $o ).

tff(pred_def_39997,type,
    v74537: state_type > $o ).

tff(pred_def_39998,type,
    v74543: state_type > $o ).

tff(pred_def_39999,type,
    v74541: state_type > $o ).

tff(pred_def_40000,type,
    v74545: state_type > $o ).

tff(pred_def_40001,type,
    v74531: state_type > $o ).

tff(pred_def_40002,type,
    v74529: state_type > $o ).

tff(pred_def_40003,type,
    v74527: state_type > $o ).

tff(pred_def_40004,type,
    v74525: state_type > $o ).

tff(pred_def_40005,type,
    v74523: state_type > $o ).

tff(pred_def_40006,type,
    v74547: state_type > $o ).

tff(pred_def_40007,type,
    v74473: state_type > $o ).

tff(pred_def_40008,type,
    v74471: state_type > $o ).

tff(pred_def_40009,type,
    v74469: state_type > $o ).

tff(pred_def_40010,type,
    v74467: state_type > $o ).

tff(pred_def_40011,type,
    v74465: state_type > $o ).

tff(pred_def_40012,type,
    v74549: state_type > $o ).

tff(pred_def_40013,type,
    v74295: state_type > $o ).

tff(pred_def_40014,type,
    v74293: state_type > $o ).

tff(pred_def_40015,type,
    v74291: state_type > $o ).

tff(pred_def_40016,type,
    v74289: state_type > $o ).

tff(pred_def_40017,type,
    v74287: state_type > $o ).

tff(pred_def_40018,type,
    v74583: state_type > $o ).

tff(pred_def_40019,type,
    v74581: state_type > $o ).

tff(pred_def_40020,type,
    v74587: state_type > $o ).

tff(pred_def_40021,type,
    v74585: state_type > $o ).

tff(pred_def_40022,type,
    v74591: state_type > $o ).

tff(pred_def_40023,type,
    v74589: state_type > $o ).

tff(pred_def_40024,type,
    v74593: state_type > $o ).

tff(pred_def_40025,type,
    v74579: state_type > $o ).

tff(pred_def_40026,type,
    v74577: state_type > $o ).

tff(pred_def_40027,type,
    v74575: state_type > $o ).

tff(pred_def_40028,type,
    v74573: state_type > $o ).

tff(pred_def_40029,type,
    v74571: state_type > $o ).

tff(pred_def_40030,type,
    v74607: state_type > $o ).

tff(pred_def_40031,type,
    v74605: state_type > $o ).

tff(pred_def_40032,type,
    v74611: state_type > $o ).

tff(pred_def_40033,type,
    v74609: state_type > $o ).

tff(pred_def_40034,type,
    v74615: state_type > $o ).

tff(pred_def_40035,type,
    v74613: state_type > $o ).

tff(pred_def_40036,type,
    v74617: state_type > $o ).

tff(pred_def_40037,type,
    v74603: state_type > $o ).

tff(pred_def_40038,type,
    v74601: state_type > $o ).

tff(pred_def_40039,type,
    v74599: state_type > $o ).

tff(pred_def_40040,type,
    v74597: state_type > $o ).

tff(pred_def_40041,type,
    v74595: state_type > $o ).

tff(pred_def_40042,type,
    v74631: state_type > $o ).

tff(pred_def_40043,type,
    v74629: state_type > $o ).

tff(pred_def_40044,type,
    v74635: state_type > $o ).

tff(pred_def_40045,type,
    v74633: state_type > $o ).

tff(pred_def_40046,type,
    v74639: state_type > $o ).

tff(pred_def_40047,type,
    v74637: state_type > $o ).

tff(pred_def_40048,type,
    v74641: state_type > $o ).

tff(pred_def_40049,type,
    v74627: state_type > $o ).

tff(pred_def_40050,type,
    v74625: state_type > $o ).

tff(pred_def_40051,type,
    v74623: state_type > $o ).

tff(pred_def_40052,type,
    v74621: state_type > $o ).

tff(pred_def_40053,type,
    v74619: state_type > $o ).

tff(pred_def_40054,type,
    v74643: state_type > $o ).

tff(pred_def_40055,type,
    v74569: state_type > $o ).

tff(pred_def_40056,type,
    v74567: state_type > $o ).

tff(pred_def_40057,type,
    v74565: state_type > $o ).

tff(pred_def_40058,type,
    v74563: state_type > $o ).

tff(pred_def_40059,type,
    v74561: state_type > $o ).

tff(pred_def_40060,type,
    v74667: state_type > $o ).

tff(pred_def_40061,type,
    v74665: state_type > $o ).

tff(pred_def_40062,type,
    v74671: state_type > $o ).

tff(pred_def_40063,type,
    v74669: state_type > $o ).

tff(pred_def_40064,type,
    v74675: state_type > $o ).

tff(pred_def_40065,type,
    v74673: state_type > $o ).

tff(pred_def_40066,type,
    v74677: state_type > $o ).

tff(pred_def_40067,type,
    v74663: state_type > $o ).

tff(pred_def_40068,type,
    v74661: state_type > $o ).

tff(pred_def_40069,type,
    v74659: state_type > $o ).

tff(pred_def_40070,type,
    v74657: state_type > $o ).

tff(pred_def_40071,type,
    v74655: state_type > $o ).

tff(pred_def_40072,type,
    v74691: state_type > $o ).

tff(pred_def_40073,type,
    v74689: state_type > $o ).

tff(pred_def_40074,type,
    v74695: state_type > $o ).

tff(pred_def_40075,type,
    v74693: state_type > $o ).

tff(pred_def_40076,type,
    v74699: state_type > $o ).

tff(pred_def_40077,type,
    v74697: state_type > $o ).

tff(pred_def_40078,type,
    v74701: state_type > $o ).

tff(pred_def_40079,type,
    v74687: state_type > $o ).

tff(pred_def_40080,type,
    v74685: state_type > $o ).

tff(pred_def_40081,type,
    v74683: state_type > $o ).

tff(pred_def_40082,type,
    v74681: state_type > $o ).

tff(pred_def_40083,type,
    v74679: state_type > $o ).

tff(pred_def_40084,type,
    v74715: state_type > $o ).

tff(pred_def_40085,type,
    v74713: state_type > $o ).

tff(pred_def_40086,type,
    v74719: state_type > $o ).

tff(pred_def_40087,type,
    v74717: state_type > $o ).

tff(pred_def_40088,type,
    v74723: state_type > $o ).

tff(pred_def_40089,type,
    v74721: state_type > $o ).

tff(pred_def_40090,type,
    v74725: state_type > $o ).

tff(pred_def_40091,type,
    v74711: state_type > $o ).

tff(pred_def_40092,type,
    v74709: state_type > $o ).

tff(pred_def_40093,type,
    v74707: state_type > $o ).

tff(pred_def_40094,type,
    v74705: state_type > $o ).

tff(pred_def_40095,type,
    v74703: state_type > $o ).

tff(pred_def_40096,type,
    v74727: state_type > $o ).

tff(pred_def_40097,type,
    v74653: state_type > $o ).

tff(pred_def_40098,type,
    v74651: state_type > $o ).

tff(pred_def_40099,type,
    v74649: state_type > $o ).

tff(pred_def_40100,type,
    v74647: state_type > $o ).

tff(pred_def_40101,type,
    v74645: state_type > $o ).

tff(pred_def_40102,type,
    v74751: state_type > $o ).

tff(pred_def_40103,type,
    v74749: state_type > $o ).

tff(pred_def_40104,type,
    v74755: state_type > $o ).

tff(pred_def_40105,type,
    v74753: state_type > $o ).

tff(pred_def_40106,type,
    v74759: state_type > $o ).

tff(pred_def_40107,type,
    v74757: state_type > $o ).

tff(pred_def_40108,type,
    v74761: state_type > $o ).

tff(pred_def_40109,type,
    v74747: state_type > $o ).

tff(pred_def_40110,type,
    v74745: state_type > $o ).

tff(pred_def_40111,type,
    v74743: state_type > $o ).

tff(pred_def_40112,type,
    v74741: state_type > $o ).

tff(pred_def_40113,type,
    v74739: state_type > $o ).

tff(pred_def_40114,type,
    v74775: state_type > $o ).

tff(pred_def_40115,type,
    v74773: state_type > $o ).

tff(pred_def_40116,type,
    v74779: state_type > $o ).

tff(pred_def_40117,type,
    v74777: state_type > $o ).

tff(pred_def_40118,type,
    v74783: state_type > $o ).

tff(pred_def_40119,type,
    v74781: state_type > $o ).

tff(pred_def_40120,type,
    v74785: state_type > $o ).

tff(pred_def_40121,type,
    v74771: state_type > $o ).

tff(pred_def_40122,type,
    v74769: state_type > $o ).

tff(pred_def_40123,type,
    v74767: state_type > $o ).

tff(pred_def_40124,type,
    v74765: state_type > $o ).

tff(pred_def_40125,type,
    v74763: state_type > $o ).

tff(pred_def_40126,type,
    v74799: state_type > $o ).

tff(pred_def_40127,type,
    v74797: state_type > $o ).

tff(pred_def_40128,type,
    v74803: state_type > $o ).

tff(pred_def_40129,type,
    v74801: state_type > $o ).

tff(pred_def_40130,type,
    v74807: state_type > $o ).

tff(pred_def_40131,type,
    v74805: state_type > $o ).

tff(pred_def_40132,type,
    v74809: state_type > $o ).

tff(pred_def_40133,type,
    v74795: state_type > $o ).

tff(pred_def_40134,type,
    v74793: state_type > $o ).

tff(pred_def_40135,type,
    v74791: state_type > $o ).

tff(pred_def_40136,type,
    v74789: state_type > $o ).

tff(pred_def_40137,type,
    v74787: state_type > $o ).

tff(pred_def_40138,type,
    v74811: state_type > $o ).

tff(pred_def_40139,type,
    v74737: state_type > $o ).

tff(pred_def_40140,type,
    v74735: state_type > $o ).

tff(pred_def_40141,type,
    v74733: state_type > $o ).

tff(pred_def_40142,type,
    v74731: state_type > $o ).

tff(pred_def_40143,type,
    v74729: state_type > $o ).

tff(pred_def_40144,type,
    v74813: state_type > $o ).

tff(pred_def_40145,type,
    v74559: state_type > $o ).

tff(pred_def_40146,type,
    v74557: state_type > $o ).

tff(pred_def_40147,type,
    v74555: state_type > $o ).

tff(pred_def_40148,type,
    v74553: state_type > $o ).

tff(pred_def_40149,type,
    v74551: state_type > $o ).

tff(pred_def_40150,type,
    v74837: state_type > $o ).

tff(pred_def_40151,type,
    v74835: state_type > $o ).

tff(pred_def_40152,type,
    v74841: state_type > $o ).

tff(pred_def_40153,type,
    v74839: state_type > $o ).

tff(pred_def_40154,type,
    v74845: state_type > $o ).

tff(pred_def_40155,type,
    v74843: state_type > $o ).

tff(pred_def_40156,type,
    v74847: state_type > $o ).

tff(pred_def_40157,type,
    v74833: state_type > $o ).

tff(pred_def_40158,type,
    v74831: state_type > $o ).

tff(pred_def_40159,type,
    v74829: state_type > $o ).

tff(pred_def_40160,type,
    v74827: state_type > $o ).

tff(pred_def_40161,type,
    v74825: state_type > $o ).

tff(pred_def_40162,type,
    v74871: state_type > $o ).

tff(pred_def_40163,type,
    v74869: state_type > $o ).

tff(pred_def_40164,type,
    v74875: state_type > $o ).

tff(pred_def_40165,type,
    v74873: state_type > $o ).

tff(pred_def_40166,type,
    v74879: state_type > $o ).

tff(pred_def_40167,type,
    v74877: state_type > $o ).

tff(pred_def_40168,type,
    v74881: state_type > $o ).

tff(pred_def_40169,type,
    v74867: state_type > $o ).

tff(pred_def_40170,type,
    v74865: state_type > $o ).

tff(pred_def_40171,type,
    v74863: state_type > $o ).

tff(pred_def_40172,type,
    v74861: state_type > $o ).

tff(pred_def_40173,type,
    v74859: state_type > $o ).

tff(pred_def_40174,type,
    v74895: state_type > $o ).

tff(pred_def_40175,type,
    v74893: state_type > $o ).

tff(pred_def_40176,type,
    v74899: state_type > $o ).

tff(pred_def_40177,type,
    v74897: state_type > $o ).

tff(pred_def_40178,type,
    v74903: state_type > $o ).

tff(pred_def_40179,type,
    v74901: state_type > $o ).

tff(pred_def_40180,type,
    v74905: state_type > $o ).

tff(pred_def_40181,type,
    v74891: state_type > $o ).

tff(pred_def_40182,type,
    v74889: state_type > $o ).

tff(pred_def_40183,type,
    v74887: state_type > $o ).

tff(pred_def_40184,type,
    v74885: state_type > $o ).

tff(pred_def_40185,type,
    v74883: state_type > $o ).

tff(pred_def_40186,type,
    v74919: state_type > $o ).

tff(pred_def_40187,type,
    v74917: state_type > $o ).

tff(pred_def_40188,type,
    v74923: state_type > $o ).

tff(pred_def_40189,type,
    v74921: state_type > $o ).

tff(pred_def_40190,type,
    v74927: state_type > $o ).

tff(pred_def_40191,type,
    v74925: state_type > $o ).

tff(pred_def_40192,type,
    v74929: state_type > $o ).

tff(pred_def_40193,type,
    v74915: state_type > $o ).

tff(pred_def_40194,type,
    v74913: state_type > $o ).

tff(pred_def_40195,type,
    v74911: state_type > $o ).

tff(pred_def_40196,type,
    v74909: state_type > $o ).

tff(pred_def_40197,type,
    v74907: state_type > $o ).

tff(pred_def_40198,type,
    v74931: state_type > $o ).

tff(pred_def_40199,type,
    v74857: state_type > $o ).

tff(pred_def_40200,type,
    v74855: state_type > $o ).

tff(pred_def_40201,type,
    v74853: state_type > $o ).

tff(pred_def_40202,type,
    v74851: state_type > $o ).

tff(pred_def_40203,type,
    v74849: state_type > $o ).

tff(pred_def_40204,type,
    v74956: ( state_type * $int ) > $o ).

tff(pred_def_40205,type,
    v74954: ( state_type * $int ) > $o ).

tff(pred_def_40206,type,
    v74960: state_type > $o ).

tff(pred_def_40207,type,
    v74958: state_type > $o ).

tff(pred_def_40208,type,
    v74964: ( state_type * $int ) > $o ).

tff(pred_def_40209,type,
    v74962: ( state_type * $int ) > $o ).

tff(pred_def_40210,type,
    v74968: state_type > $o ).

tff(pred_def_40211,type,
    v74966: state_type > $o ).

tff(pred_def_40212,type,
    v74972: state_type > $o ).

tff(pred_def_40213,type,
    v74971: ( state_type * $int ) > $o ).

tff(pred_def_40214,type,
    v74970: ( state_type * $int ) > $o ).

tff(pred_def_40215,type,
    v74975: state_type > $o ).

tff(pred_def_40216,type,
    v74974: ( state_type * $int ) > $o ).

tff(pred_def_40217,type,
    v74973: ( state_type * $int ) > $o ).

tff(pred_def_40218,type,
    v74969: ( state_type * $int ) > $o ).

tff(pred_def_40219,type,
    v74952: ( state_type * $int ) > $o ).

tff(pred_def_40220,type,
    v74950: ( state_type * $int ) > $o ).

tff(pred_def_40221,type,
    v74948: state_type > $o ).

tff(pred_def_40222,type,
    v74946: state_type > $o ).

tff(pred_def_40223,type,
    v74981: state_type > $o ).

tff(pred_def_40224,type,
    v74979: state_type > $o ).

tff(pred_def_40225,type,
    v74977: state_type > $o ).

tff(pred_def_40226,type,
    v74944: state_type > $o ).

tff(pred_def_40227,type,
    v74942: state_type > $o ).

tff(pred_def_40228,type,
    v74988: state_type > $o ).

tff(pred_def_40229,type,
    v74986: state_type > $o ).

tff(pred_def_40230,type,
    v74985: state_type > $o ).

tff(pred_def_40231,type,
    v74984: ( state_type * $int ) > $o ).

tff(pred_def_40232,type,
    v74939: ( state_type * $int ) > $o ).

tff(pred_def_40233,type,
    v74937: ( state_type * $int ) > $o ).

tff(pred_def_40234,type,
    v74935: state_type > $o ).

tff(pred_def_40235,type,
    v74933: state_type > $o ).

tff(pred_def_40236,type,
    v74992: state_type > $o ).

tff(pred_def_40237,type,
    v74823: state_type > $o ).

tff(pred_def_40238,type,
    v74821: state_type > $o ).

tff(pred_def_40239,type,
    v74819: state_type > $o ).

tff(pred_def_40240,type,
    v74817: state_type > $o ).

tff(pred_def_40241,type,
    v74815: state_type > $o ).

tff(pred_def_40242,type,
    v74994: state_type > $o ).

tff(pred_def_40243,type,
    v74285: state_type > $o ).

tff(pred_def_40244,type,
    v74283: state_type > $o ).

tff(pred_def_40245,type,
    v74280: ( state_type * $int ) > $o ).

tff(pred_def_40246,type,
    v74278: ( state_type * $int ) > $o ).

tff(pred_def_40247,type,
    v74276: ( state_type * $int ) > $o ).

tff(pred_def_40248,type,
    v74995: ( state_type * $int ) > $o ).

tff(pred_def_40249,type,
    v67251: ( state_type * $int ) > $o ).

tff(pred_def_40250,type,
    v67249: ( state_type * $int ) > $o ).

tff(pred_def_40251,type,
    v67247: ( state_type * $int ) > $o ).

tff(pred_def_40252,type,
    v67245: state_type > $o ).

tff(pred_def_40253,type,
    v67243: state_type > $o ).

tff(pred_def_40254,type,
    v75037: state_type > $o ).

tff(pred_def_40255,type,
    v75035: state_type > $o ).

tff(pred_def_40256,type,
    v75041: state_type > $o ).

tff(pred_def_40257,type,
    v75039: state_type > $o ).

tff(pred_def_40258,type,
    v75045: state_type > $o ).

tff(pred_def_40259,type,
    v75043: state_type > $o ).

tff(pred_def_40260,type,
    v75047: state_type > $o ).

tff(pred_def_40261,type,
    v75033: state_type > $o ).

tff(pred_def_40262,type,
    v75031: state_type > $o ).

tff(pred_def_40263,type,
    v75029: state_type > $o ).

tff(pred_def_40264,type,
    v75027: state_type > $o ).

tff(pred_def_40265,type,
    v75025: state_type > $o ).

tff(pred_def_40266,type,
    v75061: state_type > $o ).

tff(pred_def_40267,type,
    v75059: state_type > $o ).

tff(pred_def_40268,type,
    v75065: state_type > $o ).

tff(pred_def_40269,type,
    v75063: state_type > $o ).

tff(pred_def_40270,type,
    v75069: state_type > $o ).

tff(pred_def_40271,type,
    v75067: state_type > $o ).

tff(pred_def_40272,type,
    v75071: state_type > $o ).

tff(pred_def_40273,type,
    v75057: state_type > $o ).

tff(pred_def_40274,type,
    v75055: state_type > $o ).

tff(pred_def_40275,type,
    v75053: state_type > $o ).

tff(pred_def_40276,type,
    v75051: state_type > $o ).

tff(pred_def_40277,type,
    v75049: state_type > $o ).

tff(pred_def_40278,type,
    v75085: state_type > $o ).

tff(pred_def_40279,type,
    v75083: state_type > $o ).

tff(pred_def_40280,type,
    v75089: state_type > $o ).

tff(pred_def_40281,type,
    v75087: state_type > $o ).

tff(pred_def_40282,type,
    v75093: state_type > $o ).

tff(pred_def_40283,type,
    v75091: state_type > $o ).

tff(pred_def_40284,type,
    v75095: state_type > $o ).

tff(pred_def_40285,type,
    v75081: state_type > $o ).

tff(pred_def_40286,type,
    v75079: state_type > $o ).

tff(pred_def_40287,type,
    v75077: state_type > $o ).

tff(pred_def_40288,type,
    v75075: state_type > $o ).

tff(pred_def_40289,type,
    v75073: state_type > $o ).

tff(pred_def_40290,type,
    v75097: state_type > $o ).

tff(pred_def_40291,type,
    v75023: state_type > $o ).

tff(pred_def_40292,type,
    v75021: state_type > $o ).

tff(pred_def_40293,type,
    v75019: state_type > $o ).

tff(pred_def_40294,type,
    v75017: state_type > $o ).

tff(pred_def_40295,type,
    v75015: state_type > $o ).

tff(pred_def_40296,type,
    v75121: state_type > $o ).

tff(pred_def_40297,type,
    v75119: state_type > $o ).

tff(pred_def_40298,type,
    v75125: state_type > $o ).

tff(pred_def_40299,type,
    v75123: state_type > $o ).

tff(pred_def_40300,type,
    v75129: state_type > $o ).

tff(pred_def_40301,type,
    v75127: state_type > $o ).

tff(pred_def_40302,type,
    v75131: state_type > $o ).

tff(pred_def_40303,type,
    v75117: state_type > $o ).

tff(pred_def_40304,type,
    v75115: state_type > $o ).

tff(pred_def_40305,type,
    v75113: state_type > $o ).

tff(pred_def_40306,type,
    v75111: state_type > $o ).

tff(pred_def_40307,type,
    v75109: state_type > $o ).

tff(pred_def_40308,type,
    v75145: state_type > $o ).

tff(pred_def_40309,type,
    v75143: state_type > $o ).

tff(pred_def_40310,type,
    v75149: state_type > $o ).

tff(pred_def_40311,type,
    v75147: state_type > $o ).

tff(pred_def_40312,type,
    v75153: state_type > $o ).

tff(pred_def_40313,type,
    v75151: state_type > $o ).

tff(pred_def_40314,type,
    v75155: state_type > $o ).

tff(pred_def_40315,type,
    v75141: state_type > $o ).

tff(pred_def_40316,type,
    v75139: state_type > $o ).

tff(pred_def_40317,type,
    v75137: state_type > $o ).

tff(pred_def_40318,type,
    v75135: state_type > $o ).

tff(pred_def_40319,type,
    v75133: state_type > $o ).

tff(pred_def_40320,type,
    v75169: state_type > $o ).

tff(pred_def_40321,type,
    v75167: state_type > $o ).

tff(pred_def_40322,type,
    v75173: state_type > $o ).

tff(pred_def_40323,type,
    v75171: state_type > $o ).

tff(pred_def_40324,type,
    v75177: state_type > $o ).

tff(pred_def_40325,type,
    v75175: state_type > $o ).

tff(pred_def_40326,type,
    v75179: state_type > $o ).

tff(pred_def_40327,type,
    v75165: state_type > $o ).

tff(pred_def_40328,type,
    v75163: state_type > $o ).

tff(pred_def_40329,type,
    v75161: state_type > $o ).

tff(pred_def_40330,type,
    v75159: state_type > $o ).

tff(pred_def_40331,type,
    v75157: state_type > $o ).

tff(pred_def_40332,type,
    v75181: state_type > $o ).

tff(pred_def_40333,type,
    v75107: state_type > $o ).

tff(pred_def_40334,type,
    v75105: state_type > $o ).

tff(pred_def_40335,type,
    v75103: state_type > $o ).

tff(pred_def_40336,type,
    v75101: state_type > $o ).

tff(pred_def_40337,type,
    v75099: state_type > $o ).

tff(pred_def_40338,type,
    v75205: state_type > $o ).

tff(pred_def_40339,type,
    v75203: state_type > $o ).

tff(pred_def_40340,type,
    v75209: state_type > $o ).

tff(pred_def_40341,type,
    v75207: state_type > $o ).

tff(pred_def_40342,type,
    v75213: state_type > $o ).

tff(pred_def_40343,type,
    v75211: state_type > $o ).

tff(pred_def_40344,type,
    v75215: state_type > $o ).

tff(pred_def_40345,type,
    v75201: state_type > $o ).

tff(pred_def_40346,type,
    v75199: state_type > $o ).

tff(pred_def_40347,type,
    v75197: state_type > $o ).

tff(pred_def_40348,type,
    v75195: state_type > $o ).

tff(pred_def_40349,type,
    v75193: state_type > $o ).

tff(pred_def_40350,type,
    v75229: state_type > $o ).

tff(pred_def_40351,type,
    v75227: state_type > $o ).

tff(pred_def_40352,type,
    v75233: state_type > $o ).

tff(pred_def_40353,type,
    v75231: state_type > $o ).

tff(pred_def_40354,type,
    v75237: state_type > $o ).

tff(pred_def_40355,type,
    v75235: state_type > $o ).

tff(pred_def_40356,type,
    v75239: state_type > $o ).

tff(pred_def_40357,type,
    v75225: state_type > $o ).

tff(pred_def_40358,type,
    v75223: state_type > $o ).

tff(pred_def_40359,type,
    v75221: state_type > $o ).

tff(pred_def_40360,type,
    v75219: state_type > $o ).

tff(pred_def_40361,type,
    v75217: state_type > $o ).

tff(pred_def_40362,type,
    v75253: state_type > $o ).

tff(pred_def_40363,type,
    v75251: state_type > $o ).

tff(pred_def_40364,type,
    v75257: state_type > $o ).

tff(pred_def_40365,type,
    v75255: state_type > $o ).

tff(pred_def_40366,type,
    v75261: state_type > $o ).

tff(pred_def_40367,type,
    v75259: state_type > $o ).

tff(pred_def_40368,type,
    v75263: state_type > $o ).

tff(pred_def_40369,type,
    v75249: state_type > $o ).

tff(pred_def_40370,type,
    v75247: state_type > $o ).

tff(pred_def_40371,type,
    v75245: state_type > $o ).

tff(pred_def_40372,type,
    v75243: state_type > $o ).

tff(pred_def_40373,type,
    v75241: state_type > $o ).

tff(pred_def_40374,type,
    v75265: state_type > $o ).

tff(pred_def_40375,type,
    v75191: state_type > $o ).

tff(pred_def_40376,type,
    v75189: state_type > $o ).

tff(pred_def_40377,type,
    v75187: state_type > $o ).

tff(pred_def_40378,type,
    v75185: state_type > $o ).

tff(pred_def_40379,type,
    v75183: state_type > $o ).

tff(pred_def_40380,type,
    v75267: state_type > $o ).

tff(pred_def_40381,type,
    v75013: state_type > $o ).

tff(pred_def_40382,type,
    v75011: state_type > $o ).

tff(pred_def_40383,type,
    v75009: state_type > $o ).

tff(pred_def_40384,type,
    v75007: state_type > $o ).

tff(pred_def_40385,type,
    v75005: state_type > $o ).

tff(pred_def_40386,type,
    v75301: state_type > $o ).

tff(pred_def_40387,type,
    v75299: state_type > $o ).

tff(pred_def_40388,type,
    v75305: state_type > $o ).

tff(pred_def_40389,type,
    v75303: state_type > $o ).

tff(pred_def_40390,type,
    v75309: state_type > $o ).

tff(pred_def_40391,type,
    v75307: state_type > $o ).

tff(pred_def_40392,type,
    v75311: state_type > $o ).

tff(pred_def_40393,type,
    v75297: state_type > $o ).

tff(pred_def_40394,type,
    v75295: state_type > $o ).

tff(pred_def_40395,type,
    v75293: state_type > $o ).

tff(pred_def_40396,type,
    v75291: state_type > $o ).

tff(pred_def_40397,type,
    v75289: state_type > $o ).

tff(pred_def_40398,type,
    v75325: state_type > $o ).

tff(pred_def_40399,type,
    v75323: state_type > $o ).

tff(pred_def_40400,type,
    v75329: state_type > $o ).

tff(pred_def_40401,type,
    v75327: state_type > $o ).

tff(pred_def_40402,type,
    v75333: state_type > $o ).

tff(pred_def_40403,type,
    v75331: state_type > $o ).

tff(pred_def_40404,type,
    v75335: state_type > $o ).

tff(pred_def_40405,type,
    v75321: state_type > $o ).

tff(pred_def_40406,type,
    v75319: state_type > $o ).

tff(pred_def_40407,type,
    v75317: state_type > $o ).

tff(pred_def_40408,type,
    v75315: state_type > $o ).

tff(pred_def_40409,type,
    v75313: state_type > $o ).

tff(pred_def_40410,type,
    v75349: state_type > $o ).

tff(pred_def_40411,type,
    v75347: state_type > $o ).

tff(pred_def_40412,type,
    v75353: state_type > $o ).

tff(pred_def_40413,type,
    v75351: state_type > $o ).

tff(pred_def_40414,type,
    v75357: state_type > $o ).

tff(pred_def_40415,type,
    v75355: state_type > $o ).

tff(pred_def_40416,type,
    v75359: state_type > $o ).

tff(pred_def_40417,type,
    v75345: state_type > $o ).

tff(pred_def_40418,type,
    v75343: state_type > $o ).

tff(pred_def_40419,type,
    v75341: state_type > $o ).

tff(pred_def_40420,type,
    v75339: state_type > $o ).

tff(pred_def_40421,type,
    v75337: state_type > $o ).

tff(pred_def_40422,type,
    v75361: state_type > $o ).

tff(pred_def_40423,type,
    v75287: state_type > $o ).

tff(pred_def_40424,type,
    v75285: state_type > $o ).

tff(pred_def_40425,type,
    v75283: state_type > $o ).

tff(pred_def_40426,type,
    v75281: state_type > $o ).

tff(pred_def_40427,type,
    v75279: state_type > $o ).

tff(pred_def_40428,type,
    v75385: state_type > $o ).

tff(pred_def_40429,type,
    v75383: state_type > $o ).

tff(pred_def_40430,type,
    v75389: state_type > $o ).

tff(pred_def_40431,type,
    v75387: state_type > $o ).

tff(pred_def_40432,type,
    v75393: state_type > $o ).

tff(pred_def_40433,type,
    v75391: state_type > $o ).

tff(pred_def_40434,type,
    v75395: state_type > $o ).

tff(pred_def_40435,type,
    v75381: state_type > $o ).

tff(pred_def_40436,type,
    v75379: state_type > $o ).

tff(pred_def_40437,type,
    v75377: state_type > $o ).

tff(pred_def_40438,type,
    v75375: state_type > $o ).

tff(pred_def_40439,type,
    v75373: state_type > $o ).

tff(pred_def_40440,type,
    v75409: state_type > $o ).

tff(pred_def_40441,type,
    v75407: state_type > $o ).

tff(pred_def_40442,type,
    v75413: state_type > $o ).

tff(pred_def_40443,type,
    v75411: state_type > $o ).

tff(pred_def_40444,type,
    v75417: state_type > $o ).

tff(pred_def_40445,type,
    v75415: state_type > $o ).

tff(pred_def_40446,type,
    v75419: state_type > $o ).

tff(pred_def_40447,type,
    v75405: state_type > $o ).

tff(pred_def_40448,type,
    v75403: state_type > $o ).

tff(pred_def_40449,type,
    v75401: state_type > $o ).

tff(pred_def_40450,type,
    v75399: state_type > $o ).

tff(pred_def_40451,type,
    v75397: state_type > $o ).

tff(pred_def_40452,type,
    v75433: state_type > $o ).

tff(pred_def_40453,type,
    v75431: state_type > $o ).

tff(pred_def_40454,type,
    v75437: state_type > $o ).

tff(pred_def_40455,type,
    v75435: state_type > $o ).

tff(pred_def_40456,type,
    v75441: state_type > $o ).

tff(pred_def_40457,type,
    v75439: state_type > $o ).

tff(pred_def_40458,type,
    v75443: state_type > $o ).

tff(pred_def_40459,type,
    v75429: state_type > $o ).

tff(pred_def_40460,type,
    v75427: state_type > $o ).

tff(pred_def_40461,type,
    v75425: state_type > $o ).

tff(pred_def_40462,type,
    v75423: state_type > $o ).

tff(pred_def_40463,type,
    v75421: state_type > $o ).

tff(pred_def_40464,type,
    v75445: state_type > $o ).

tff(pred_def_40465,type,
    v75371: state_type > $o ).

tff(pred_def_40466,type,
    v75369: state_type > $o ).

tff(pred_def_40467,type,
    v75367: state_type > $o ).

tff(pred_def_40468,type,
    v75365: state_type > $o ).

tff(pred_def_40469,type,
    v75363: state_type > $o ).

tff(pred_def_40470,type,
    v75469: state_type > $o ).

tff(pred_def_40471,type,
    v75467: state_type > $o ).

tff(pred_def_40472,type,
    v75473: state_type > $o ).

tff(pred_def_40473,type,
    v75471: state_type > $o ).

tff(pred_def_40474,type,
    v75477: state_type > $o ).

tff(pred_def_40475,type,
    v75475: state_type > $o ).

tff(pred_def_40476,type,
    v75479: state_type > $o ).

tff(pred_def_40477,type,
    v75465: state_type > $o ).

tff(pred_def_40478,type,
    v75463: state_type > $o ).

tff(pred_def_40479,type,
    v75461: state_type > $o ).

tff(pred_def_40480,type,
    v75459: state_type > $o ).

tff(pred_def_40481,type,
    v75457: state_type > $o ).

tff(pred_def_40482,type,
    v75493: state_type > $o ).

tff(pred_def_40483,type,
    v75491: state_type > $o ).

tff(pred_def_40484,type,
    v75497: state_type > $o ).

tff(pred_def_40485,type,
    v75495: state_type > $o ).

tff(pred_def_40486,type,
    v75501: state_type > $o ).

tff(pred_def_40487,type,
    v75499: state_type > $o ).

tff(pred_def_40488,type,
    v75503: state_type > $o ).

tff(pred_def_40489,type,
    v75489: state_type > $o ).

tff(pred_def_40490,type,
    v75487: state_type > $o ).

tff(pred_def_40491,type,
    v75485: state_type > $o ).

tff(pred_def_40492,type,
    v75483: state_type > $o ).

tff(pred_def_40493,type,
    v75481: state_type > $o ).

tff(pred_def_40494,type,
    v75517: state_type > $o ).

tff(pred_def_40495,type,
    v75515: state_type > $o ).

tff(pred_def_40496,type,
    v75521: state_type > $o ).

tff(pred_def_40497,type,
    v75519: state_type > $o ).

tff(pred_def_40498,type,
    v75525: state_type > $o ).

tff(pred_def_40499,type,
    v75523: state_type > $o ).

tff(pred_def_40500,type,
    v75527: state_type > $o ).

tff(pred_def_40501,type,
    v75513: state_type > $o ).

tff(pred_def_40502,type,
    v75511: state_type > $o ).

tff(pred_def_40503,type,
    v75509: state_type > $o ).

tff(pred_def_40504,type,
    v75507: state_type > $o ).

tff(pred_def_40505,type,
    v75505: state_type > $o ).

tff(pred_def_40506,type,
    v75529: state_type > $o ).

tff(pred_def_40507,type,
    v75455: state_type > $o ).

tff(pred_def_40508,type,
    v75453: state_type > $o ).

tff(pred_def_40509,type,
    v75451: state_type > $o ).

tff(pred_def_40510,type,
    v75449: state_type > $o ).

tff(pred_def_40511,type,
    v75447: state_type > $o ).

tff(pred_def_40512,type,
    v75531: state_type > $o ).

tff(pred_def_40513,type,
    v75277: state_type > $o ).

tff(pred_def_40514,type,
    v75275: state_type > $o ).

tff(pred_def_40515,type,
    v75273: state_type > $o ).

tff(pred_def_40516,type,
    v75271: state_type > $o ).

tff(pred_def_40517,type,
    v75269: state_type > $o ).

tff(pred_def_40518,type,
    v75555: state_type > $o ).

tff(pred_def_40519,type,
    v75553: state_type > $o ).

tff(pred_def_40520,type,
    v75559: state_type > $o ).

tff(pred_def_40521,type,
    v75557: state_type > $o ).

tff(pred_def_40522,type,
    v75563: state_type > $o ).

tff(pred_def_40523,type,
    v75561: state_type > $o ).

tff(pred_def_40524,type,
    v75565: state_type > $o ).

tff(pred_def_40525,type,
    v75551: state_type > $o ).

tff(pred_def_40526,type,
    v75549: state_type > $o ).

tff(pred_def_40527,type,
    v75547: state_type > $o ).

tff(pred_def_40528,type,
    v75545: state_type > $o ).

tff(pred_def_40529,type,
    v75543: state_type > $o ).

tff(pred_def_40530,type,
    v75589: state_type > $o ).

tff(pred_def_40531,type,
    v75587: state_type > $o ).

tff(pred_def_40532,type,
    v75593: state_type > $o ).

tff(pred_def_40533,type,
    v75591: state_type > $o ).

tff(pred_def_40534,type,
    v75597: state_type > $o ).

tff(pred_def_40535,type,
    v75595: state_type > $o ).

tff(pred_def_40536,type,
    v75599: state_type > $o ).

tff(pred_def_40537,type,
    v75585: state_type > $o ).

tff(pred_def_40538,type,
    v75583: state_type > $o ).

tff(pred_def_40539,type,
    v75581: state_type > $o ).

tff(pred_def_40540,type,
    v75579: state_type > $o ).

tff(pred_def_40541,type,
    v75577: state_type > $o ).

tff(pred_def_40542,type,
    v75613: state_type > $o ).

tff(pred_def_40543,type,
    v75611: state_type > $o ).

tff(pred_def_40544,type,
    v75617: state_type > $o ).

tff(pred_def_40545,type,
    v75615: state_type > $o ).

tff(pred_def_40546,type,
    v75621: state_type > $o ).

tff(pred_def_40547,type,
    v75619: state_type > $o ).

tff(pred_def_40548,type,
    v75623: state_type > $o ).

tff(pred_def_40549,type,
    v75609: state_type > $o ).

tff(pred_def_40550,type,
    v75607: state_type > $o ).

tff(pred_def_40551,type,
    v75605: state_type > $o ).

tff(pred_def_40552,type,
    v75603: state_type > $o ).

tff(pred_def_40553,type,
    v75601: state_type > $o ).

tff(pred_def_40554,type,
    v75637: state_type > $o ).

tff(pred_def_40555,type,
    v75635: state_type > $o ).

tff(pred_def_40556,type,
    v75641: state_type > $o ).

tff(pred_def_40557,type,
    v75639: state_type > $o ).

tff(pred_def_40558,type,
    v75645: state_type > $o ).

tff(pred_def_40559,type,
    v75643: state_type > $o ).

tff(pred_def_40560,type,
    v75647: state_type > $o ).

tff(pred_def_40561,type,
    v75633: state_type > $o ).

tff(pred_def_40562,type,
    v75631: state_type > $o ).

tff(pred_def_40563,type,
    v75629: state_type > $o ).

tff(pred_def_40564,type,
    v75627: state_type > $o ).

tff(pred_def_40565,type,
    v75625: state_type > $o ).

tff(pred_def_40566,type,
    v75649: state_type > $o ).

tff(pred_def_40567,type,
    v75575: state_type > $o ).

tff(pred_def_40568,type,
    v75573: state_type > $o ).

tff(pred_def_40569,type,
    v75571: state_type > $o ).

tff(pred_def_40570,type,
    v75569: state_type > $o ).

tff(pred_def_40571,type,
    v75567: state_type > $o ).

tff(pred_def_40572,type,
    v75659: state_type > $o ).

tff(pred_def_40573,type,
    v75657: state_type > $o ).

tff(pred_def_40574,type,
    v75656: state_type > $o ).

tff(pred_def_40575,type,
    v75655: ( state_type * $int ) > $o ).

tff(pred_def_40576,type,
    v75653: state_type > $o ).

tff(pred_def_40577,type,
    v75651: state_type > $o ).

tff(pred_def_40578,type,
    v75663: state_type > $o ).

tff(pred_def_40579,type,
    v75541: state_type > $o ).

tff(pred_def_40580,type,
    v75539: state_type > $o ).

tff(pred_def_40581,type,
    v75537: state_type > $o ).

tff(pred_def_40582,type,
    v75535: state_type > $o ).

tff(pred_def_40583,type,
    v75533: state_type > $o ).

tff(pred_def_40584,type,
    v75665: state_type > $o ).

tff(pred_def_40585,type,
    v75003: state_type > $o ).

tff(pred_def_40586,type,
    v75001: state_type > $o ).

tff(pred_def_40587,type,
    v74999: state_type > $o ).

tff(pred_def_40588,type,
    v74997: state_type > $o ).

tff(pred_def_40589,type,
    v75667: state_type > $o ).

tff(pred_def_40590,type,
    v67241: state_type > $o ).

tff(pred_def_40591,type,
    v67239: state_type > $o ).

tff(pred_def_40592,type,
    v67237: state_type > $o ).

tff(pred_def_40593,type,
    v67235: state_type > $o ).

tff(pred_def_40594,type,
    v67233: state_type > $o ).

tff(pred_def_40595,type,
    v75719: state_type > $o ).

tff(pred_def_40596,type,
    v75717: state_type > $o ).

tff(pred_def_40597,type,
    v75723: state_type > $o ).

tff(pred_def_40598,type,
    v75721: state_type > $o ).

tff(pred_def_40599,type,
    v75727: state_type > $o ).

tff(pred_def_40600,type,
    v75725: state_type > $o ).

tff(pred_def_40601,type,
    v75729: state_type > $o ).

tff(pred_def_40602,type,
    v75715: state_type > $o ).

tff(pred_def_40603,type,
    v75713: state_type > $o ).

tff(pred_def_40604,type,
    v75711: state_type > $o ).

tff(pred_def_40605,type,
    v75709: state_type > $o ).

tff(pred_def_40606,type,
    v75707: state_type > $o ).

tff(pred_def_40607,type,
    v75743: state_type > $o ).

tff(pred_def_40608,type,
    v75741: state_type > $o ).

tff(pred_def_40609,type,
    v75747: state_type > $o ).

tff(pred_def_40610,type,
    v75745: state_type > $o ).

tff(pred_def_40611,type,
    v75751: state_type > $o ).

tff(pred_def_40612,type,
    v75749: state_type > $o ).

tff(pred_def_40613,type,
    v75753: state_type > $o ).

tff(pred_def_40614,type,
    v75739: state_type > $o ).

tff(pred_def_40615,type,
    v75737: state_type > $o ).

tff(pred_def_40616,type,
    v75735: state_type > $o ).

tff(pred_def_40617,type,
    v75733: state_type > $o ).

tff(pred_def_40618,type,
    v75731: state_type > $o ).

tff(pred_def_40619,type,
    v75767: state_type > $o ).

tff(pred_def_40620,type,
    v75765: state_type > $o ).

tff(pred_def_40621,type,
    v75771: state_type > $o ).

tff(pred_def_40622,type,
    v75769: state_type > $o ).

tff(pred_def_40623,type,
    v75775: state_type > $o ).

tff(pred_def_40624,type,
    v75773: state_type > $o ).

tff(pred_def_40625,type,
    v75777: state_type > $o ).

tff(pred_def_40626,type,
    v75763: state_type > $o ).

tff(pred_def_40627,type,
    v75761: state_type > $o ).

tff(pred_def_40628,type,
    v75759: state_type > $o ).

tff(pred_def_40629,type,
    v75757: state_type > $o ).

tff(pred_def_40630,type,
    v75755: state_type > $o ).

tff(pred_def_40631,type,
    v75779: state_type > $o ).

tff(pred_def_40632,type,
    v75705: state_type > $o ).

tff(pred_def_40633,type,
    v75703: state_type > $o ).

tff(pred_def_40634,type,
    v75701: state_type > $o ).

tff(pred_def_40635,type,
    v75699: state_type > $o ).

tff(pred_def_40636,type,
    v75697: state_type > $o ).

tff(pred_def_40637,type,
    v75803: state_type > $o ).

tff(pred_def_40638,type,
    v75801: state_type > $o ).

tff(pred_def_40639,type,
    v75807: state_type > $o ).

tff(pred_def_40640,type,
    v75805: state_type > $o ).

tff(pred_def_40641,type,
    v75811: state_type > $o ).

tff(pred_def_40642,type,
    v75809: state_type > $o ).

tff(pred_def_40643,type,
    v75813: state_type > $o ).

tff(pred_def_40644,type,
    v75799: state_type > $o ).

tff(pred_def_40645,type,
    v75797: state_type > $o ).

tff(pred_def_40646,type,
    v75795: state_type > $o ).

tff(pred_def_40647,type,
    v75793: state_type > $o ).

tff(pred_def_40648,type,
    v75791: state_type > $o ).

tff(pred_def_40649,type,
    v75827: state_type > $o ).

tff(pred_def_40650,type,
    v75825: state_type > $o ).

tff(pred_def_40651,type,
    v75831: state_type > $o ).

tff(pred_def_40652,type,
    v75829: state_type > $o ).

tff(pred_def_40653,type,
    v75835: state_type > $o ).

tff(pred_def_40654,type,
    v75833: state_type > $o ).

tff(pred_def_40655,type,
    v75837: state_type > $o ).

tff(pred_def_40656,type,
    v75823: state_type > $o ).

tff(pred_def_40657,type,
    v75821: state_type > $o ).

tff(pred_def_40658,type,
    v75819: state_type > $o ).

tff(pred_def_40659,type,
    v75817: state_type > $o ).

tff(pred_def_40660,type,
    v75815: state_type > $o ).

tff(pred_def_40661,type,
    v75851: state_type > $o ).

tff(pred_def_40662,type,
    v75849: state_type > $o ).

tff(pred_def_40663,type,
    v75855: state_type > $o ).

tff(pred_def_40664,type,
    v75853: state_type > $o ).

tff(pred_def_40665,type,
    v75859: state_type > $o ).

tff(pred_def_40666,type,
    v75857: state_type > $o ).

tff(pred_def_40667,type,
    v75861: state_type > $o ).

tff(pred_def_40668,type,
    v75847: state_type > $o ).

tff(pred_def_40669,type,
    v75845: state_type > $o ).

tff(pred_def_40670,type,
    v75843: state_type > $o ).

tff(pred_def_40671,type,
    v75841: state_type > $o ).

tff(pred_def_40672,type,
    v75839: state_type > $o ).

tff(pred_def_40673,type,
    v75863: state_type > $o ).

tff(pred_def_40674,type,
    v75789: state_type > $o ).

tff(pred_def_40675,type,
    v75787: state_type > $o ).

tff(pred_def_40676,type,
    v75785: state_type > $o ).

tff(pred_def_40677,type,
    v75783: state_type > $o ).

tff(pred_def_40678,type,
    v75781: state_type > $o ).

tff(pred_def_40679,type,
    v75887: state_type > $o ).

tff(pred_def_40680,type,
    v75885: state_type > $o ).

tff(pred_def_40681,type,
    v75891: state_type > $o ).

tff(pred_def_40682,type,
    v75889: state_type > $o ).

tff(pred_def_40683,type,
    v75895: state_type > $o ).

tff(pred_def_40684,type,
    v75893: state_type > $o ).

tff(pred_def_40685,type,
    v75897: state_type > $o ).

tff(pred_def_40686,type,
    v75883: state_type > $o ).

tff(pred_def_40687,type,
    v75881: state_type > $o ).

tff(pred_def_40688,type,
    v75879: state_type > $o ).

tff(pred_def_40689,type,
    v75877: state_type > $o ).

tff(pred_def_40690,type,
    v75875: state_type > $o ).

tff(pred_def_40691,type,
    v75911: state_type > $o ).

tff(pred_def_40692,type,
    v75909: state_type > $o ).

tff(pred_def_40693,type,
    v75915: state_type > $o ).

tff(pred_def_40694,type,
    v75913: state_type > $o ).

tff(pred_def_40695,type,
    v75919: state_type > $o ).

tff(pred_def_40696,type,
    v75917: state_type > $o ).

tff(pred_def_40697,type,
    v75921: state_type > $o ).

tff(pred_def_40698,type,
    v75907: state_type > $o ).

tff(pred_def_40699,type,
    v75905: state_type > $o ).

tff(pred_def_40700,type,
    v75903: state_type > $o ).

tff(pred_def_40701,type,
    v75901: state_type > $o ).

tff(pred_def_40702,type,
    v75899: state_type > $o ).

tff(pred_def_40703,type,
    v75935: state_type > $o ).

tff(pred_def_40704,type,
    v75933: state_type > $o ).

tff(pred_def_40705,type,
    v75939: state_type > $o ).

tff(pred_def_40706,type,
    v75937: state_type > $o ).

tff(pred_def_40707,type,
    v75943: state_type > $o ).

tff(pred_def_40708,type,
    v75941: state_type > $o ).

tff(pred_def_40709,type,
    v75945: state_type > $o ).

tff(pred_def_40710,type,
    v75931: state_type > $o ).

tff(pred_def_40711,type,
    v75929: state_type > $o ).

tff(pred_def_40712,type,
    v75927: state_type > $o ).

tff(pred_def_40713,type,
    v75925: state_type > $o ).

tff(pred_def_40714,type,
    v75923: state_type > $o ).

tff(pred_def_40715,type,
    v75947: state_type > $o ).

tff(pred_def_40716,type,
    v75873: state_type > $o ).

tff(pred_def_40717,type,
    v75871: state_type > $o ).

tff(pred_def_40718,type,
    v75869: state_type > $o ).

tff(pred_def_40719,type,
    v75867: state_type > $o ).

tff(pred_def_40720,type,
    v75865: state_type > $o ).

tff(pred_def_40721,type,
    v75949: state_type > $o ).

tff(pred_def_40722,type,
    v75695: state_type > $o ).

tff(pred_def_40723,type,
    v75693: state_type > $o ).

tff(pred_def_40724,type,
    v75691: state_type > $o ).

tff(pred_def_40725,type,
    v75689: state_type > $o ).

tff(pred_def_40726,type,
    v75687: state_type > $o ).

tff(pred_def_40727,type,
    v75983: state_type > $o ).

tff(pred_def_40728,type,
    v75981: state_type > $o ).

tff(pred_def_40729,type,
    v75987: state_type > $o ).

tff(pred_def_40730,type,
    v75985: state_type > $o ).

tff(pred_def_40731,type,
    v75991: state_type > $o ).

tff(pred_def_40732,type,
    v75989: state_type > $o ).

tff(pred_def_40733,type,
    v75993: state_type > $o ).

tff(pred_def_40734,type,
    v75979: state_type > $o ).

tff(pred_def_40735,type,
    v75977: state_type > $o ).

tff(pred_def_40736,type,
    v75975: state_type > $o ).

tff(pred_def_40737,type,
    v75973: state_type > $o ).

tff(pred_def_40738,type,
    v75971: state_type > $o ).

tff(pred_def_40739,type,
    v76007: state_type > $o ).

tff(pred_def_40740,type,
    v76005: state_type > $o ).

tff(pred_def_40741,type,
    v76011: state_type > $o ).

tff(pred_def_40742,type,
    v76009: state_type > $o ).

tff(pred_def_40743,type,
    v76015: state_type > $o ).

tff(pred_def_40744,type,
    v76013: state_type > $o ).

tff(pred_def_40745,type,
    v76017: state_type > $o ).

tff(pred_def_40746,type,
    v76003: state_type > $o ).

tff(pred_def_40747,type,
    v76001: state_type > $o ).

tff(pred_def_40748,type,
    v75999: state_type > $o ).

tff(pred_def_40749,type,
    v75997: state_type > $o ).

tff(pred_def_40750,type,
    v75995: state_type > $o ).

tff(pred_def_40751,type,
    v76031: state_type > $o ).

tff(pred_def_40752,type,
    v76029: state_type > $o ).

tff(pred_def_40753,type,
    v76035: state_type > $o ).

tff(pred_def_40754,type,
    v76033: state_type > $o ).

tff(pred_def_40755,type,
    v76039: state_type > $o ).

tff(pred_def_40756,type,
    v76037: state_type > $o ).

tff(pred_def_40757,type,
    v76041: state_type > $o ).

tff(pred_def_40758,type,
    v76027: state_type > $o ).

tff(pred_def_40759,type,
    v76025: state_type > $o ).

tff(pred_def_40760,type,
    v76023: state_type > $o ).

tff(pred_def_40761,type,
    v76021: state_type > $o ).

tff(pred_def_40762,type,
    v76019: state_type > $o ).

tff(pred_def_40763,type,
    v76043: state_type > $o ).

tff(pred_def_40764,type,
    v75969: state_type > $o ).

tff(pred_def_40765,type,
    v75967: state_type > $o ).

tff(pred_def_40766,type,
    v75965: state_type > $o ).

tff(pred_def_40767,type,
    v75963: state_type > $o ).

tff(pred_def_40768,type,
    v75961: state_type > $o ).

tff(pred_def_40769,type,
    v76067: state_type > $o ).

tff(pred_def_40770,type,
    v76065: state_type > $o ).

tff(pred_def_40771,type,
    v76071: state_type > $o ).

tff(pred_def_40772,type,
    v76069: state_type > $o ).

tff(pred_def_40773,type,
    v76075: state_type > $o ).

tff(pred_def_40774,type,
    v76073: state_type > $o ).

tff(pred_def_40775,type,
    v76077: state_type > $o ).

tff(pred_def_40776,type,
    v76063: state_type > $o ).

tff(pred_def_40777,type,
    v76061: state_type > $o ).

tff(pred_def_40778,type,
    v76059: state_type > $o ).

tff(pred_def_40779,type,
    v76057: state_type > $o ).

tff(pred_def_40780,type,
    v76055: state_type > $o ).

tff(pred_def_40781,type,
    v76091: state_type > $o ).

tff(pred_def_40782,type,
    v76089: state_type > $o ).

tff(pred_def_40783,type,
    v76095: state_type > $o ).

tff(pred_def_40784,type,
    v76093: state_type > $o ).

tff(pred_def_40785,type,
    v76099: state_type > $o ).

tff(pred_def_40786,type,
    v76097: state_type > $o ).

tff(pred_def_40787,type,
    v76101: state_type > $o ).

tff(pred_def_40788,type,
    v76087: state_type > $o ).

tff(pred_def_40789,type,
    v76085: state_type > $o ).

tff(pred_def_40790,type,
    v76083: state_type > $o ).

tff(pred_def_40791,type,
    v76081: state_type > $o ).

tff(pred_def_40792,type,
    v76079: state_type > $o ).

tff(pred_def_40793,type,
    v76115: state_type > $o ).

tff(pred_def_40794,type,
    v76113: state_type > $o ).

tff(pred_def_40795,type,
    v76119: state_type > $o ).

tff(pred_def_40796,type,
    v76117: state_type > $o ).

tff(pred_def_40797,type,
    v76123: state_type > $o ).

tff(pred_def_40798,type,
    v76121: state_type > $o ).

tff(pred_def_40799,type,
    v76125: state_type > $o ).

tff(pred_def_40800,type,
    v76111: state_type > $o ).

tff(pred_def_40801,type,
    v76109: state_type > $o ).

tff(pred_def_40802,type,
    v76107: state_type > $o ).

tff(pred_def_40803,type,
    v76105: state_type > $o ).

tff(pred_def_40804,type,
    v76103: state_type > $o ).

tff(pred_def_40805,type,
    v76127: state_type > $o ).

tff(pred_def_40806,type,
    v76053: state_type > $o ).

tff(pred_def_40807,type,
    v76051: state_type > $o ).

tff(pred_def_40808,type,
    v76049: state_type > $o ).

tff(pred_def_40809,type,
    v76047: state_type > $o ).

tff(pred_def_40810,type,
    v76045: state_type > $o ).

tff(pred_def_40811,type,
    v76151: state_type > $o ).

tff(pred_def_40812,type,
    v76149: state_type > $o ).

tff(pred_def_40813,type,
    v76155: state_type > $o ).

tff(pred_def_40814,type,
    v76153: state_type > $o ).

tff(pred_def_40815,type,
    v76159: state_type > $o ).

tff(pred_def_40816,type,
    v76157: state_type > $o ).

tff(pred_def_40817,type,
    v76161: state_type > $o ).

tff(pred_def_40818,type,
    v76147: state_type > $o ).

tff(pred_def_40819,type,
    v76145: state_type > $o ).

tff(pred_def_40820,type,
    v76143: state_type > $o ).

tff(pred_def_40821,type,
    v76141: state_type > $o ).

tff(pred_def_40822,type,
    v76139: state_type > $o ).

tff(pred_def_40823,type,
    v76175: state_type > $o ).

tff(pred_def_40824,type,
    v76173: state_type > $o ).

tff(pred_def_40825,type,
    v76179: state_type > $o ).

tff(pred_def_40826,type,
    v76177: state_type > $o ).

tff(pred_def_40827,type,
    v76183: state_type > $o ).

tff(pred_def_40828,type,
    v76181: state_type > $o ).

tff(pred_def_40829,type,
    v76185: state_type > $o ).

tff(pred_def_40830,type,
    v76171: state_type > $o ).

tff(pred_def_40831,type,
    v76169: state_type > $o ).

tff(pred_def_40832,type,
    v76167: state_type > $o ).

tff(pred_def_40833,type,
    v76165: state_type > $o ).

tff(pred_def_40834,type,
    v76163: state_type > $o ).

tff(pred_def_40835,type,
    v76199: state_type > $o ).

tff(pred_def_40836,type,
    v76197: state_type > $o ).

tff(pred_def_40837,type,
    v76203: state_type > $o ).

tff(pred_def_40838,type,
    v76201: state_type > $o ).

tff(pred_def_40839,type,
    v76207: state_type > $o ).

tff(pred_def_40840,type,
    v76205: state_type > $o ).

tff(pred_def_40841,type,
    v76209: state_type > $o ).

tff(pred_def_40842,type,
    v76195: state_type > $o ).

tff(pred_def_40843,type,
    v76193: state_type > $o ).

tff(pred_def_40844,type,
    v76191: state_type > $o ).

tff(pred_def_40845,type,
    v76189: state_type > $o ).

tff(pred_def_40846,type,
    v76187: state_type > $o ).

tff(pred_def_40847,type,
    v76211: state_type > $o ).

tff(pred_def_40848,type,
    v76137: state_type > $o ).

tff(pred_def_40849,type,
    v76135: state_type > $o ).

tff(pred_def_40850,type,
    v76133: state_type > $o ).

tff(pred_def_40851,type,
    v76131: state_type > $o ).

tff(pred_def_40852,type,
    v76129: state_type > $o ).

tff(pred_def_40853,type,
    v76213: state_type > $o ).

tff(pred_def_40854,type,
    v75959: state_type > $o ).

tff(pred_def_40855,type,
    v75957: state_type > $o ).

tff(pred_def_40856,type,
    v75955: state_type > $o ).

tff(pred_def_40857,type,
    v75953: state_type > $o ).

tff(pred_def_40858,type,
    v75951: state_type > $o ).

tff(pred_def_40859,type,
    v76237: state_type > $o ).

tff(pred_def_40860,type,
    v76235: state_type > $o ).

tff(pred_def_40861,type,
    v76241: state_type > $o ).

tff(pred_def_40862,type,
    v76239: state_type > $o ).

tff(pred_def_40863,type,
    v76245: state_type > $o ).

tff(pred_def_40864,type,
    v76243: state_type > $o ).

tff(pred_def_40865,type,
    v76247: state_type > $o ).

tff(pred_def_40866,type,
    v76233: state_type > $o ).

tff(pred_def_40867,type,
    v76231: state_type > $o ).

tff(pred_def_40868,type,
    v76229: state_type > $o ).

tff(pred_def_40869,type,
    v76227: state_type > $o ).

tff(pred_def_40870,type,
    v76225: state_type > $o ).

tff(pred_def_40871,type,
    v76271: state_type > $o ).

tff(pred_def_40872,type,
    v76269: state_type > $o ).

tff(pred_def_40873,type,
    v76275: state_type > $o ).

tff(pred_def_40874,type,
    v76273: state_type > $o ).

tff(pred_def_40875,type,
    v76279: state_type > $o ).

tff(pred_def_40876,type,
    v76277: state_type > $o ).

tff(pred_def_40877,type,
    v76281: state_type > $o ).

tff(pred_def_40878,type,
    v76267: state_type > $o ).

tff(pred_def_40879,type,
    v76265: state_type > $o ).

tff(pred_def_40880,type,
    v76263: state_type > $o ).

tff(pred_def_40881,type,
    v76261: state_type > $o ).

tff(pred_def_40882,type,
    v76259: state_type > $o ).

tff(pred_def_40883,type,
    v76295: state_type > $o ).

tff(pred_def_40884,type,
    v76293: state_type > $o ).

tff(pred_def_40885,type,
    v76299: state_type > $o ).

tff(pred_def_40886,type,
    v76297: state_type > $o ).

tff(pred_def_40887,type,
    v76303: state_type > $o ).

tff(pred_def_40888,type,
    v76301: state_type > $o ).

tff(pred_def_40889,type,
    v76305: state_type > $o ).

tff(pred_def_40890,type,
    v76291: state_type > $o ).

tff(pred_def_40891,type,
    v76289: state_type > $o ).

tff(pred_def_40892,type,
    v76287: state_type > $o ).

tff(pred_def_40893,type,
    v76285: state_type > $o ).

tff(pred_def_40894,type,
    v76283: state_type > $o ).

tff(pred_def_40895,type,
    v76319: state_type > $o ).

tff(pred_def_40896,type,
    v76317: state_type > $o ).

tff(pred_def_40897,type,
    v76323: state_type > $o ).

tff(pred_def_40898,type,
    v76321: state_type > $o ).

tff(pred_def_40899,type,
    v76327: state_type > $o ).

tff(pred_def_40900,type,
    v76325: state_type > $o ).

tff(pred_def_40901,type,
    v76329: state_type > $o ).

tff(pred_def_40902,type,
    v76315: state_type > $o ).

tff(pred_def_40903,type,
    v76313: state_type > $o ).

tff(pred_def_40904,type,
    v76311: state_type > $o ).

tff(pred_def_40905,type,
    v76309: state_type > $o ).

tff(pred_def_40906,type,
    v76307: state_type > $o ).

tff(pred_def_40907,type,
    v76331: state_type > $o ).

tff(pred_def_40908,type,
    v76257: state_type > $o ).

tff(pred_def_40909,type,
    v76255: state_type > $o ).

tff(pred_def_40910,type,
    v76253: state_type > $o ).

tff(pred_def_40911,type,
    v76251: state_type > $o ).

tff(pred_def_40912,type,
    v76249: state_type > $o ).

tff(pred_def_40913,type,
    v76341: state_type > $o ).

tff(pred_def_40914,type,
    v76339: state_type > $o ).

tff(pred_def_40915,type,
    v76338: state_type > $o ).

tff(pred_def_40916,type,
    v76337: ( state_type * $int ) > $o ).

tff(pred_def_40917,type,
    v76335: state_type > $o ).

tff(pred_def_40918,type,
    v76333: state_type > $o ).

tff(pred_def_40919,type,
    v76345: state_type > $o ).

tff(pred_def_40920,type,
    v76223: state_type > $o ).

tff(pred_def_40921,type,
    v76221: state_type > $o ).

tff(pred_def_40922,type,
    v76219: state_type > $o ).

tff(pred_def_40923,type,
    v76217: state_type > $o ).

tff(pred_def_40924,type,
    v76215: state_type > $o ).

tff(pred_def_40925,type,
    v76347: state_type > $o ).

tff(pred_def_40926,type,
    v75685: state_type > $o ).

tff(pred_def_40927,type,
    v75683: state_type > $o ).

tff(pred_def_40928,type,
    v75681: state_type > $o ).

tff(pred_def_40929,type,
    v75679: state_type > $o ).

tff(pred_def_40930,type,
    v76389: state_type > $o ).

tff(pred_def_40931,type,
    v76387: state_type > $o ).

tff(pred_def_40932,type,
    v76393: state_type > $o ).

tff(pred_def_40933,type,
    v76391: state_type > $o ).

tff(pred_def_40934,type,
    v76397: state_type > $o ).

tff(pred_def_40935,type,
    v76395: state_type > $o ).

tff(pred_def_40936,type,
    v76399: state_type > $o ).

tff(pred_def_40937,type,
    v76385: state_type > $o ).

tff(pred_def_40938,type,
    v76383: state_type > $o ).

tff(pred_def_40939,type,
    v76381: state_type > $o ).

tff(pred_def_40940,type,
    v76379: state_type > $o ).

tff(pred_def_40941,type,
    v76377: state_type > $o ).

tff(pred_def_40942,type,
    v76413: state_type > $o ).

tff(pred_def_40943,type,
    v76411: state_type > $o ).

tff(pred_def_40944,type,
    v76417: state_type > $o ).

tff(pred_def_40945,type,
    v76415: state_type > $o ).

tff(pred_def_40946,type,
    v76421: state_type > $o ).

tff(pred_def_40947,type,
    v76419: state_type > $o ).

tff(pred_def_40948,type,
    v76423: state_type > $o ).

tff(pred_def_40949,type,
    v76409: state_type > $o ).

tff(pred_def_40950,type,
    v76407: state_type > $o ).

tff(pred_def_40951,type,
    v76405: state_type > $o ).

tff(pred_def_40952,type,
    v76403: state_type > $o ).

tff(pred_def_40953,type,
    v76401: state_type > $o ).

tff(pred_def_40954,type,
    v76437: state_type > $o ).

tff(pred_def_40955,type,
    v76435: state_type > $o ).

tff(pred_def_40956,type,
    v76441: state_type > $o ).

tff(pred_def_40957,type,
    v76439: state_type > $o ).

tff(pred_def_40958,type,
    v76445: state_type > $o ).

tff(pred_def_40959,type,
    v76443: state_type > $o ).

tff(pred_def_40960,type,
    v76447: state_type > $o ).

tff(pred_def_40961,type,
    v76433: state_type > $o ).

tff(pred_def_40962,type,
    v76431: state_type > $o ).

tff(pred_def_40963,type,
    v76429: state_type > $o ).

tff(pred_def_40964,type,
    v76427: state_type > $o ).

tff(pred_def_40965,type,
    v76425: state_type > $o ).

tff(pred_def_40966,type,
    v76449: state_type > $o ).

tff(pred_def_40967,type,
    v76375: state_type > $o ).

tff(pred_def_40968,type,
    v76373: state_type > $o ).

tff(pred_def_40969,type,
    v76371: state_type > $o ).

tff(pred_def_40970,type,
    v76369: state_type > $o ).

tff(pred_def_40971,type,
    v76367: state_type > $o ).

tff(pred_def_40972,type,
    v76473: state_type > $o ).

tff(pred_def_40973,type,
    v76471: state_type > $o ).

tff(pred_def_40974,type,
    v76477: state_type > $o ).

tff(pred_def_40975,type,
    v76475: state_type > $o ).

tff(pred_def_40976,type,
    v76481: state_type > $o ).

tff(pred_def_40977,type,
    v76479: state_type > $o ).

tff(pred_def_40978,type,
    v76483: state_type > $o ).

tff(pred_def_40979,type,
    v76469: state_type > $o ).

tff(pred_def_40980,type,
    v76467: state_type > $o ).

tff(pred_def_40981,type,
    v76465: state_type > $o ).

tff(pred_def_40982,type,
    v76463: state_type > $o ).

tff(pred_def_40983,type,
    v76461: state_type > $o ).

tff(pred_def_40984,type,
    v76497: state_type > $o ).

tff(pred_def_40985,type,
    v76495: state_type > $o ).

tff(pred_def_40986,type,
    v76501: state_type > $o ).

tff(pred_def_40987,type,
    v76499: state_type > $o ).

tff(pred_def_40988,type,
    v76505: state_type > $o ).

tff(pred_def_40989,type,
    v76503: state_type > $o ).

tff(pred_def_40990,type,
    v76507: state_type > $o ).

tff(pred_def_40991,type,
    v76493: state_type > $o ).

tff(pred_def_40992,type,
    v76491: state_type > $o ).

tff(pred_def_40993,type,
    v76489: state_type > $o ).

tff(pred_def_40994,type,
    v76487: state_type > $o ).

tff(pred_def_40995,type,
    v76485: state_type > $o ).

tff(pred_def_40996,type,
    v76521: state_type > $o ).

tff(pred_def_40997,type,
    v76519: state_type > $o ).

tff(pred_def_40998,type,
    v76525: state_type > $o ).

tff(pred_def_40999,type,
    v76523: state_type > $o ).

tff(pred_def_41000,type,
    v76529: state_type > $o ).

tff(pred_def_41001,type,
    v76527: state_type > $o ).

tff(pred_def_41002,type,
    v76531: state_type > $o ).

tff(pred_def_41003,type,
    v76517: state_type > $o ).

tff(pred_def_41004,type,
    v76515: state_type > $o ).

tff(pred_def_41005,type,
    v76513: state_type > $o ).

tff(pred_def_41006,type,
    v76511: state_type > $o ).

tff(pred_def_41007,type,
    v76509: state_type > $o ).

tff(pred_def_41008,type,
    v76533: state_type > $o ).

tff(pred_def_41009,type,
    v76459: state_type > $o ).

tff(pred_def_41010,type,
    v76457: state_type > $o ).

tff(pred_def_41011,type,
    v76455: state_type > $o ).

tff(pred_def_41012,type,
    v76453: state_type > $o ).

tff(pred_def_41013,type,
    v76451: state_type > $o ).

tff(pred_def_41014,type,
    v76557: state_type > $o ).

tff(pred_def_41015,type,
    v76555: state_type > $o ).

tff(pred_def_41016,type,
    v76561: state_type > $o ).

tff(pred_def_41017,type,
    v76559: state_type > $o ).

tff(pred_def_41018,type,
    v76565: state_type > $o ).

tff(pred_def_41019,type,
    v76563: state_type > $o ).

tff(pred_def_41020,type,
    v76567: state_type > $o ).

tff(pred_def_41021,type,
    v76553: state_type > $o ).

tff(pred_def_41022,type,
    v76551: state_type > $o ).

tff(pred_def_41023,type,
    v76549: state_type > $o ).

tff(pred_def_41024,type,
    v76547: state_type > $o ).

tff(pred_def_41025,type,
    v76545: state_type > $o ).

tff(pred_def_41026,type,
    v76581: state_type > $o ).

tff(pred_def_41027,type,
    v76579: state_type > $o ).

tff(pred_def_41028,type,
    v76585: state_type > $o ).

tff(pred_def_41029,type,
    v76583: state_type > $o ).

tff(pred_def_41030,type,
    v76589: state_type > $o ).

tff(pred_def_41031,type,
    v76587: state_type > $o ).

tff(pred_def_41032,type,
    v76591: state_type > $o ).

tff(pred_def_41033,type,
    v76577: state_type > $o ).

tff(pred_def_41034,type,
    v76575: state_type > $o ).

tff(pred_def_41035,type,
    v76573: state_type > $o ).

tff(pred_def_41036,type,
    v76571: state_type > $o ).

tff(pred_def_41037,type,
    v76569: state_type > $o ).

tff(pred_def_41038,type,
    v76605: state_type > $o ).

tff(pred_def_41039,type,
    v76603: state_type > $o ).

tff(pred_def_41040,type,
    v76609: state_type > $o ).

tff(pred_def_41041,type,
    v76607: state_type > $o ).

tff(pred_def_41042,type,
    v76613: state_type > $o ).

tff(pred_def_41043,type,
    v76611: state_type > $o ).

tff(pred_def_41044,type,
    v76615: state_type > $o ).

tff(pred_def_41045,type,
    v76601: state_type > $o ).

tff(pred_def_41046,type,
    v76599: state_type > $o ).

tff(pred_def_41047,type,
    v76597: state_type > $o ).

tff(pred_def_41048,type,
    v76595: state_type > $o ).

tff(pred_def_41049,type,
    v76593: state_type > $o ).

tff(pred_def_41050,type,
    v76617: state_type > $o ).

tff(pred_def_41051,type,
    v76543: state_type > $o ).

tff(pred_def_41052,type,
    v76541: state_type > $o ).

tff(pred_def_41053,type,
    v76539: state_type > $o ).

tff(pred_def_41054,type,
    v76537: state_type > $o ).

tff(pred_def_41055,type,
    v76535: state_type > $o ).

tff(pred_def_41056,type,
    v76619: state_type > $o ).

tff(pred_def_41057,type,
    v76365: state_type > $o ).

tff(pred_def_41058,type,
    v76363: state_type > $o ).

tff(pred_def_41059,type,
    v76361: state_type > $o ).

tff(pred_def_41060,type,
    v76359: state_type > $o ).

tff(pred_def_41061,type,
    v76357: state_type > $o ).

tff(pred_def_41062,type,
    v76653: state_type > $o ).

tff(pred_def_41063,type,
    v76651: state_type > $o ).

tff(pred_def_41064,type,
    v76657: state_type > $o ).

tff(pred_def_41065,type,
    v76655: state_type > $o ).

tff(pred_def_41066,type,
    v76661: state_type > $o ).

tff(pred_def_41067,type,
    v76659: state_type > $o ).

tff(pred_def_41068,type,
    v76663: state_type > $o ).

tff(pred_def_41069,type,
    v76649: state_type > $o ).

tff(pred_def_41070,type,
    v76647: state_type > $o ).

tff(pred_def_41071,type,
    v76645: state_type > $o ).

tff(pred_def_41072,type,
    v76643: state_type > $o ).

tff(pred_def_41073,type,
    v76641: state_type > $o ).

tff(pred_def_41074,type,
    v76677: state_type > $o ).

tff(pred_def_41075,type,
    v76675: state_type > $o ).

tff(pred_def_41076,type,
    v76681: state_type > $o ).

tff(pred_def_41077,type,
    v76679: state_type > $o ).

tff(pred_def_41078,type,
    v76685: state_type > $o ).

tff(pred_def_41079,type,
    v76683: state_type > $o ).

tff(pred_def_41080,type,
    v76687: state_type > $o ).

tff(pred_def_41081,type,
    v76673: state_type > $o ).

tff(pred_def_41082,type,
    v76671: state_type > $o ).

tff(pred_def_41083,type,
    v76669: state_type > $o ).

tff(pred_def_41084,type,
    v76667: state_type > $o ).

tff(pred_def_41085,type,
    v76665: state_type > $o ).

tff(pred_def_41086,type,
    v76701: state_type > $o ).

tff(pred_def_41087,type,
    v76699: state_type > $o ).

tff(pred_def_41088,type,
    v76705: state_type > $o ).

tff(pred_def_41089,type,
    v76703: state_type > $o ).

tff(pred_def_41090,type,
    v76709: state_type > $o ).

tff(pred_def_41091,type,
    v76707: state_type > $o ).

tff(pred_def_41092,type,
    v76711: state_type > $o ).

tff(pred_def_41093,type,
    v76697: state_type > $o ).

tff(pred_def_41094,type,
    v76695: state_type > $o ).

tff(pred_def_41095,type,
    v76693: state_type > $o ).

tff(pred_def_41096,type,
    v76691: state_type > $o ).

tff(pred_def_41097,type,
    v76689: state_type > $o ).

tff(pred_def_41098,type,
    v76713: state_type > $o ).

tff(pred_def_41099,type,
    v76639: state_type > $o ).

tff(pred_def_41100,type,
    v76637: state_type > $o ).

tff(pred_def_41101,type,
    v76635: state_type > $o ).

tff(pred_def_41102,type,
    v76633: state_type > $o ).

tff(pred_def_41103,type,
    v76631: state_type > $o ).

tff(pred_def_41104,type,
    v76737: state_type > $o ).

tff(pred_def_41105,type,
    v76735: state_type > $o ).

tff(pred_def_41106,type,
    v76741: state_type > $o ).

tff(pred_def_41107,type,
    v76739: state_type > $o ).

tff(pred_def_41108,type,
    v76745: state_type > $o ).

tff(pred_def_41109,type,
    v76743: state_type > $o ).

tff(pred_def_41110,type,
    v76747: state_type > $o ).

tff(pred_def_41111,type,
    v76733: state_type > $o ).

tff(pred_def_41112,type,
    v76731: state_type > $o ).

tff(pred_def_41113,type,
    v76729: state_type > $o ).

tff(pred_def_41114,type,
    v76727: state_type > $o ).

tff(pred_def_41115,type,
    v76725: state_type > $o ).

tff(pred_def_41116,type,
    v76761: state_type > $o ).

tff(pred_def_41117,type,
    v76759: state_type > $o ).

tff(pred_def_41118,type,
    v76765: state_type > $o ).

tff(pred_def_41119,type,
    v76763: state_type > $o ).

tff(pred_def_41120,type,
    v76769: state_type > $o ).

tff(pred_def_41121,type,
    v76767: state_type > $o ).

tff(pred_def_41122,type,
    v76771: state_type > $o ).

tff(pred_def_41123,type,
    v76757: state_type > $o ).

tff(pred_def_41124,type,
    v76755: state_type > $o ).

tff(pred_def_41125,type,
    v76753: state_type > $o ).

tff(pred_def_41126,type,
    v76751: state_type > $o ).

tff(pred_def_41127,type,
    v76749: state_type > $o ).

tff(pred_def_41128,type,
    v76785: state_type > $o ).

tff(pred_def_41129,type,
    v76783: state_type > $o ).

tff(pred_def_41130,type,
    v76789: state_type > $o ).

tff(pred_def_41131,type,
    v76787: state_type > $o ).

tff(pred_def_41132,type,
    v76793: state_type > $o ).

tff(pred_def_41133,type,
    v76791: state_type > $o ).

tff(pred_def_41134,type,
    v76795: state_type > $o ).

tff(pred_def_41135,type,
    v76781: state_type > $o ).

tff(pred_def_41136,type,
    v76779: state_type > $o ).

tff(pred_def_41137,type,
    v76777: state_type > $o ).

tff(pred_def_41138,type,
    v76775: state_type > $o ).

tff(pred_def_41139,type,
    v76773: state_type > $o ).

tff(pred_def_41140,type,
    v76797: state_type > $o ).

tff(pred_def_41141,type,
    v76723: state_type > $o ).

tff(pred_def_41142,type,
    v76721: state_type > $o ).

tff(pred_def_41143,type,
    v76719: state_type > $o ).

tff(pred_def_41144,type,
    v76717: state_type > $o ).

tff(pred_def_41145,type,
    v76715: state_type > $o ).

tff(pred_def_41146,type,
    v76821: state_type > $o ).

tff(pred_def_41147,type,
    v76819: state_type > $o ).

tff(pred_def_41148,type,
    v76825: state_type > $o ).

tff(pred_def_41149,type,
    v76823: state_type > $o ).

tff(pred_def_41150,type,
    v76829: state_type > $o ).

tff(pred_def_41151,type,
    v76827: state_type > $o ).

tff(pred_def_41152,type,
    v76831: state_type > $o ).

tff(pred_def_41153,type,
    v76817: state_type > $o ).

tff(pred_def_41154,type,
    v76815: state_type > $o ).

tff(pred_def_41155,type,
    v76813: state_type > $o ).

tff(pred_def_41156,type,
    v76811: state_type > $o ).

tff(pred_def_41157,type,
    v76809: state_type > $o ).

tff(pred_def_41158,type,
    v76845: state_type > $o ).

tff(pred_def_41159,type,
    v76843: state_type > $o ).

tff(pred_def_41160,type,
    v76849: state_type > $o ).

tff(pred_def_41161,type,
    v76847: state_type > $o ).

tff(pred_def_41162,type,
    v76853: state_type > $o ).

tff(pred_def_41163,type,
    v76851: state_type > $o ).

tff(pred_def_41164,type,
    v76855: state_type > $o ).

tff(pred_def_41165,type,
    v76841: state_type > $o ).

tff(pred_def_41166,type,
    v76839: state_type > $o ).

tff(pred_def_41167,type,
    v76837: state_type > $o ).

tff(pred_def_41168,type,
    v76835: state_type > $o ).

tff(pred_def_41169,type,
    v76833: state_type > $o ).

tff(pred_def_41170,type,
    v76869: state_type > $o ).

tff(pred_def_41171,type,
    v76867: state_type > $o ).

tff(pred_def_41172,type,
    v76873: state_type > $o ).

tff(pred_def_41173,type,
    v76871: state_type > $o ).

tff(pred_def_41174,type,
    v76877: state_type > $o ).

tff(pred_def_41175,type,
    v76875: state_type > $o ).

tff(pred_def_41176,type,
    v76879: state_type > $o ).

tff(pred_def_41177,type,
    v76865: state_type > $o ).

tff(pred_def_41178,type,
    v76863: state_type > $o ).

tff(pred_def_41179,type,
    v76861: state_type > $o ).

tff(pred_def_41180,type,
    v76859: state_type > $o ).

tff(pred_def_41181,type,
    v76857: state_type > $o ).

tff(pred_def_41182,type,
    v76881: state_type > $o ).

tff(pred_def_41183,type,
    v76807: state_type > $o ).

tff(pred_def_41184,type,
    v76805: state_type > $o ).

tff(pred_def_41185,type,
    v76803: state_type > $o ).

tff(pred_def_41186,type,
    v76801: state_type > $o ).

tff(pred_def_41187,type,
    v76799: state_type > $o ).

tff(pred_def_41188,type,
    v76883: state_type > $o ).

tff(pred_def_41189,type,
    v76629: state_type > $o ).

tff(pred_def_41190,type,
    v76627: state_type > $o ).

tff(pred_def_41191,type,
    v76625: state_type > $o ).

tff(pred_def_41192,type,
    v76623: state_type > $o ).

tff(pred_def_41193,type,
    v76621: state_type > $o ).

tff(pred_def_41194,type,
    v76907: state_type > $o ).

tff(pred_def_41195,type,
    v76905: state_type > $o ).

tff(pred_def_41196,type,
    v76911: state_type > $o ).

tff(pred_def_41197,type,
    v76909: state_type > $o ).

tff(pred_def_41198,type,
    v76915: state_type > $o ).

tff(pred_def_41199,type,
    v76913: state_type > $o ).

tff(pred_def_41200,type,
    v76917: state_type > $o ).

tff(pred_def_41201,type,
    v76903: state_type > $o ).

tff(pred_def_41202,type,
    v76901: state_type > $o ).

tff(pred_def_41203,type,
    v76899: state_type > $o ).

tff(pred_def_41204,type,
    v76897: state_type > $o ).

tff(pred_def_41205,type,
    v76895: state_type > $o ).

tff(pred_def_41206,type,
    v76941: state_type > $o ).

tff(pred_def_41207,type,
    v76939: state_type > $o ).

tff(pred_def_41208,type,
    v76945: state_type > $o ).

tff(pred_def_41209,type,
    v76943: state_type > $o ).

tff(pred_def_41210,type,
    v76949: state_type > $o ).

tff(pred_def_41211,type,
    v76947: state_type > $o ).

tff(pred_def_41212,type,
    v76951: state_type > $o ).

tff(pred_def_41213,type,
    v76937: state_type > $o ).

tff(pred_def_41214,type,
    v76935: state_type > $o ).

tff(pred_def_41215,type,
    v76933: state_type > $o ).

tff(pred_def_41216,type,
    v76931: state_type > $o ).

tff(pred_def_41217,type,
    v76929: state_type > $o ).

tff(pred_def_41218,type,
    v76965: state_type > $o ).

tff(pred_def_41219,type,
    v76963: state_type > $o ).

tff(pred_def_41220,type,
    v76969: state_type > $o ).

tff(pred_def_41221,type,
    v76967: state_type > $o ).

tff(pred_def_41222,type,
    v76973: state_type > $o ).

tff(pred_def_41223,type,
    v76971: state_type > $o ).

tff(pred_def_41224,type,
    v76975: state_type > $o ).

tff(pred_def_41225,type,
    v76961: state_type > $o ).

tff(pred_def_41226,type,
    v76959: state_type > $o ).

tff(pred_def_41227,type,
    v76957: state_type > $o ).

tff(pred_def_41228,type,
    v76955: state_type > $o ).

tff(pred_def_41229,type,
    v76953: state_type > $o ).

tff(pred_def_41230,type,
    v76989: state_type > $o ).

tff(pred_def_41231,type,
    v76987: state_type > $o ).

tff(pred_def_41232,type,
    v76993: state_type > $o ).

tff(pred_def_41233,type,
    v76991: state_type > $o ).

tff(pred_def_41234,type,
    v76997: state_type > $o ).

tff(pred_def_41235,type,
    v76995: state_type > $o ).

tff(pred_def_41236,type,
    v76999: state_type > $o ).

tff(pred_def_41237,type,
    v76985: state_type > $o ).

tff(pred_def_41238,type,
    v76983: state_type > $o ).

tff(pred_def_41239,type,
    v76981: state_type > $o ).

tff(pred_def_41240,type,
    v76979: state_type > $o ).

tff(pred_def_41241,type,
    v76977: state_type > $o ).

tff(pred_def_41242,type,
    v77001: state_type > $o ).

tff(pred_def_41243,type,
    v76927: state_type > $o ).

tff(pred_def_41244,type,
    v76925: state_type > $o ).

tff(pred_def_41245,type,
    v76923: state_type > $o ).

tff(pred_def_41246,type,
    v76921: state_type > $o ).

tff(pred_def_41247,type,
    v76919: state_type > $o ).

tff(pred_def_41248,type,
    v77011: state_type > $o ).

tff(pred_def_41249,type,
    v77009: state_type > $o ).

tff(pred_def_41250,type,
    v77008: state_type > $o ).

tff(pred_def_41251,type,
    v77007: ( state_type * $int ) > $o ).

tff(pred_def_41252,type,
    v77005: state_type > $o ).

tff(pred_def_41253,type,
    v77003: state_type > $o ).

tff(pred_def_41254,type,
    v77015: state_type > $o ).

tff(pred_def_41255,type,
    v76893: state_type > $o ).

tff(pred_def_41256,type,
    v76891: state_type > $o ).

tff(pred_def_41257,type,
    v76889: state_type > $o ).

tff(pred_def_41258,type,
    v76887: state_type > $o ).

tff(pred_def_41259,type,
    v76885: state_type > $o ).

tff(pred_def_41260,type,
    v77017: state_type > $o ).

tff(pred_def_41261,type,
    v76355: state_type > $o ).

tff(pred_def_41262,type,
    v76353: state_type > $o ).

tff(pred_def_41263,type,
    v76351: state_type > $o ).

tff(pred_def_41264,type,
    v76349: state_type > $o ).

tff(pred_def_41265,type,
    v77019: state_type > $o ).

tff(pred_def_41266,type,
    v75677: state_type > $o ).

tff(pred_def_41267,type,
    v75675: state_type > $o ).

tff(pred_def_41268,type,
    v75673: state_type > $o ).

tff(pred_def_41269,type,
    v75671: state_type > $o ).

tff(pred_def_41270,type,
    v75669: state_type > $o ).

tff(pred_def_41271,type,
    v77021: state_type > $o ).

tff(pred_def_41272,type,
    v67231: state_type > $o ).

tff(pred_def_41273,type,
    v67229: state_type > $o ).

tff(pred_def_41274,type,
    v67227: state_type > $o ).

tff(pred_def_41275,type,
    v67225: state_type > $o ).

tff(pred_def_41276,type,
    v67223: state_type > $o ).

tff(pred_def_41277,type,
    v67221: state_type > $o ).

tff(pred_def_41278,type,
    v67219: state_type > $o ).

tff(pred_def_41279,type,
    v67217: state_type > $o ).

tff(pred_def_41280,type,
    v67215: state_type > $o ).

tff(pred_def_41281,type,
    v67213: state_type > $o ).

tff(pred_def_41282,type,
    v77116: state_type > $o ).

tff(pred_def_41283,type,
    v77114: state_type > $o ).

tff(pred_def_41284,type,
    v77120: state_type > $o ).

tff(pred_def_41285,type,
    v77118: state_type > $o ).

tff(pred_def_41286,type,
    v77122: state_type > $o ).

tff(pred_def_41287,type,
    v77112: state_type > $o ).

tff(pred_def_41288,type,
    v77110: state_type > $o ).

tff(pred_def_41289,type,
    v77108: state_type > $o ).

tff(pred_def_41290,type,
    v77106: state_type > $o ).

tff(pred_def_41291,type,
    v77104: state_type > $o ).

tff(pred_def_41292,type,
    v77136: state_type > $o ).

tff(pred_def_41293,type,
    v77134: state_type > $o ).

tff(pred_def_41294,type,
    v77140: state_type > $o ).

tff(pred_def_41295,type,
    v77138: state_type > $o ).

tff(pred_def_41296,type,
    v77142: state_type > $o ).

tff(pred_def_41297,type,
    v77132: state_type > $o ).

tff(pred_def_41298,type,
    v77130: state_type > $o ).

tff(pred_def_41299,type,
    v77128: state_type > $o ).

tff(pred_def_41300,type,
    v77126: state_type > $o ).

tff(pred_def_41301,type,
    v77124: state_type > $o ).

tff(pred_def_41302,type,
    v77144: state_type > $o ).

tff(pred_def_41303,type,
    v77102: state_type > $o ).

tff(pred_def_41304,type,
    v77100: state_type > $o ).

tff(pred_def_41305,type,
    v77098: state_type > $o ).

tff(pred_def_41306,type,
    v77096: state_type > $o ).

tff(pred_def_41307,type,
    v77094: state_type > $o ).

tff(pred_def_41308,type,
    v77092: state_type > $o ).

tff(pred_def_41309,type,
    v77090: state_type > $o ).

tff(pred_def_41310,type,
    v77088: state_type > $o ).

tff(pred_def_41311,type,
    v77086: state_type > $o ).

tff(pred_def_41312,type,
    v77084: state_type > $o ).

tff(pred_def_41313,type,
    v77149: state_type > $o ).

tff(pred_def_41314,type,
    v77147: state_type > $o ).

tff(pred_def_41315,type,
    v77151: state_type > $o ).

tff(pred_def_41316,type,
    v77082: state_type > $o ).

tff(pred_def_41317,type,
    v77080: state_type > $o ).

tff(pred_def_41318,type,
    v77078: state_type > $o ).

tff(pred_def_41319,type,
    v77076: state_type > $o ).

tff(pred_def_41320,type,
    v77074: state_type > $o ).

tff(pred_def_41321,type,
    v77155: state_type > $o ).

tff(pred_def_41322,type,
    v77153: state_type > $o ).

tff(pred_def_41323,type,
    v77072: state_type > $o ).

tff(pred_def_41324,type,
    v77070: state_type > $o ).

tff(pred_def_41325,type,
    v77068: state_type > $o ).

tff(pred_def_41326,type,
    v77158: state_type > $o ).

tff(pred_def_41327,type,
    v77157: ( state_type * $int ) > $o ).

tff(pred_def_41328,type,
    v77066: ( state_type * $int ) > $o ).

tff(pred_def_41329,type,
    v77064: ( state_type * $int ) > $o ).

tff(pred_def_41330,type,
    v77162: ( state_type * $int ) > $o ).

tff(pred_def_41331,type,
    v77160: ( state_type * $int ) > $o ).

tff(pred_def_41332,type,
    v77163: ( state_type * $int ) > $o ).

tff(pred_def_41333,type,
    v77062: ( state_type * $int ) > $o ).

tff(pred_def_41334,type,
    v77060: ( state_type * $int ) > $o ).

tff(pred_def_41335,type,
    v77058: ( state_type * $int ) > $o ).

tff(pred_def_41336,type,
    v77056: state_type > $o ).

tff(pred_def_41337,type,
    v77054: state_type > $o ).

tff(pred_def_41338,type,
    v77167: state_type > $o ).

tff(pred_def_41339,type,
    v77165: state_type > $o ).

tff(pred_def_41340,type,
    v77169: state_type > $o ).

tff(pred_def_41341,type,
    v77052: state_type > $o ).

tff(pred_def_41342,type,
    v77050: state_type > $o ).

tff(pred_def_41343,type,
    v77048: state_type > $o ).

tff(pred_def_41344,type,
    v77046: state_type > $o ).

tff(pred_def_41345,type,
    v77044: state_type > $o ).

tff(pred_def_41346,type,
    v77183: state_type > $o ).

tff(pred_def_41347,type,
    v77181: state_type > $o ).

tff(pred_def_41348,type,
    v77187: state_type > $o ).

tff(pred_def_41349,type,
    v77185: state_type > $o ).

tff(pred_def_41350,type,
    v77189: state_type > $o ).

tff(pred_def_41351,type,
    v77179: state_type > $o ).

tff(pred_def_41352,type,
    v77177: state_type > $o ).

tff(pred_def_41353,type,
    v77175: state_type > $o ).

tff(pred_def_41354,type,
    v77173: state_type > $o ).

tff(pred_def_41355,type,
    v77171: state_type > $o ).

tff(pred_def_41356,type,
    v77191: state_type > $o ).

tff(pred_def_41357,type,
    v77042: state_type > $o ).

tff(pred_def_41358,type,
    v77040: state_type > $o ).

tff(pred_def_41359,type,
    v77038: state_type > $o ).

tff(pred_def_41360,type,
    v77036: state_type > $o ).

tff(pred_def_41361,type,
    v77034: state_type > $o ).

tff(pred_def_41362,type,
    v77032: state_type > $o ).

tff(pred_def_41363,type,
    v77030: state_type > $o ).

tff(pred_def_41364,type,
    v77028: state_type > $o ).

tff(pred_def_41365,type,
    v77026: state_type > $o ).

tff(pred_def_41366,type,
    v77024: state_type > $o ).

tff(pred_def_41367,type,
    v77246: state_type > $o ).

tff(pred_def_41368,type,
    v77244: state_type > $o ).

tff(pred_def_41369,type,
    v77250: state_type > $o ).

tff(pred_def_41370,type,
    v77248: state_type > $o ).

tff(pred_def_41371,type,
    v77252: state_type > $o ).

tff(pred_def_41372,type,
    v77242: state_type > $o ).

tff(pred_def_41373,type,
    v77240: state_type > $o ).

tff(pred_def_41374,type,
    v77238: state_type > $o ).

tff(pred_def_41375,type,
    v77236: state_type > $o ).

tff(pred_def_41376,type,
    v77234: state_type > $o ).

tff(pred_def_41377,type,
    v77256: state_type > $o ).

tff(pred_def_41378,type,
    v77254: state_type > $o ).

tff(pred_def_41379,type,
    v77232: state_type > $o ).

tff(pred_def_41380,type,
    v77230: state_type > $o ).

tff(pred_def_41381,type,
    v77228: state_type > $o ).

tff(pred_def_41382,type,
    v77259: state_type > $o ).

tff(pred_def_41383,type,
    v77258: ( state_type * $int ) > $o ).

tff(pred_def_41384,type,
    v77226: ( state_type * $int ) > $o ).

tff(pred_def_41385,type,
    v77224: ( state_type * $int ) > $o ).

tff(pred_def_41386,type,
    v77263: ( state_type * $int ) > $o ).

tff(pred_def_41387,type,
    v77261: ( state_type * $int ) > $o ).

tff(pred_def_41388,type,
    v77264: ( state_type * $int ) > $o ).

tff(pred_def_41389,type,
    v77222: ( state_type * $int ) > $o ).

tff(pred_def_41390,type,
    v77220: ( state_type * $int ) > $o ).

tff(pred_def_41391,type,
    v77218: ( state_type * $int ) > $o ).

tff(pred_def_41392,type,
    v77216: state_type > $o ).

tff(pred_def_41393,type,
    v77214: state_type > $o ).

tff(pred_def_41394,type,
    v77268: state_type > $o ).

tff(pred_def_41395,type,
    v77266: state_type > $o ).

tff(pred_def_41396,type,
    v77270: state_type > $o ).

tff(pred_def_41397,type,
    v77212: state_type > $o ).

tff(pred_def_41398,type,
    v77210: state_type > $o ).

tff(pred_def_41399,type,
    v77208: state_type > $o ).

tff(pred_def_41400,type,
    v77206: state_type > $o ).

tff(pred_def_41401,type,
    v77204: state_type > $o ).

tff(pred_def_41402,type,
    v77284: state_type > $o ).

tff(pred_def_41403,type,
    v77282: state_type > $o ).

tff(pred_def_41404,type,
    v77288: state_type > $o ).

tff(pred_def_41405,type,
    v77286: state_type > $o ).

tff(pred_def_41406,type,
    v77290: state_type > $o ).

tff(pred_def_41407,type,
    v77280: state_type > $o ).

tff(pred_def_41408,type,
    v77278: state_type > $o ).

tff(pred_def_41409,type,
    v77276: state_type > $o ).

tff(pred_def_41410,type,
    v77274: state_type > $o ).

tff(pred_def_41411,type,
    v77272: state_type > $o ).

tff(pred_def_41412,type,
    v77292: state_type > $o ).

tff(pred_def_41413,type,
    v77202: state_type > $o ).

tff(pred_def_41414,type,
    v77200: state_type > $o ).

tff(pred_def_41415,type,
    v77198: state_type > $o ).

tff(pred_def_41416,type,
    v77196: state_type > $o ).

tff(pred_def_41417,type,
    v77194: state_type > $o ).

tff(pred_def_41418,type,
    v77336: state_type > $o ).

tff(pred_def_41419,type,
    v77334: state_type > $o ).

tff(pred_def_41420,type,
    v77340: state_type > $o ).

tff(pred_def_41421,type,
    v77338: state_type > $o ).

tff(pred_def_41422,type,
    v77344: state_type > $o ).

tff(pred_def_41423,type,
    v77342: state_type > $o ).

tff(pred_def_41424,type,
    v77347: state_type > $o ).

tff(pred_def_41425,type,
    v77346: state_type > $o ).

tff(pred_def_41426,type,
    v77332: state_type > $o ).

tff(pred_def_41427,type,
    v77330: state_type > $o ).

tff(pred_def_41428,type,
    v77328: state_type > $o ).

tff(pred_def_41429,type,
    v77349: state_type > $o ).

tff(pred_def_41430,type,
    v77348: ( state_type * $int ) > $o ).

tff(pred_def_41431,type,
    v77326: ( state_type * $int ) > $o ).

tff(pred_def_41432,type,
    v77324: ( state_type * $int ) > $o ).

tff(pred_def_41433,type,
    v77353: ( state_type * $int ) > $o ).

tff(pred_def_41434,type,
    v77351: ( state_type * $int ) > $o ).

tff(pred_def_41435,type,
    v77354: ( state_type * $int ) > $o ).

tff(pred_def_41436,type,
    v77322: ( state_type * $int ) > $o ).

tff(pred_def_41437,type,
    v77320: ( state_type * $int ) > $o ).

tff(pred_def_41438,type,
    v77318: ( state_type * $int ) > $o ).

tff(pred_def_41439,type,
    v77316: state_type > $o ).

tff(pred_def_41440,type,
    v77314: state_type > $o ).

tff(pred_def_41441,type,
    v77358: state_type > $o ).

tff(pred_def_41442,type,
    v77356: state_type > $o ).

tff(pred_def_41443,type,
    v77360: state_type > $o ).

tff(pred_def_41444,type,
    v77312: state_type > $o ).

tff(pred_def_41445,type,
    v77310: state_type > $o ).

tff(pred_def_41446,type,
    v77308: state_type > $o ).

tff(pred_def_41447,type,
    v77306: state_type > $o ).

tff(pred_def_41448,type,
    v77304: state_type > $o ).

tff(pred_def_41449,type,
    v77374: state_type > $o ).

tff(pred_def_41450,type,
    v77372: state_type > $o ).

tff(pred_def_41451,type,
    v77378: state_type > $o ).

tff(pred_def_41452,type,
    v77376: state_type > $o ).

tff(pred_def_41453,type,
    v77380: state_type > $o ).

tff(pred_def_41454,type,
    v77370: state_type > $o ).

tff(pred_def_41455,type,
    v77368: state_type > $o ).

tff(pred_def_41456,type,
    v77366: state_type > $o ).

tff(pred_def_41457,type,
    v77364: state_type > $o ).

tff(pred_def_41458,type,
    v77362: state_type > $o ).

tff(pred_def_41459,type,
    v77382: state_type > $o ).

tff(pred_def_41460,type,
    v77302: state_type > $o ).

tff(pred_def_41461,type,
    v77300: state_type > $o ).

tff(pred_def_41462,type,
    v77298: state_type > $o ).

tff(pred_def_41463,type,
    v77296: state_type > $o ).

tff(pred_def_41464,type,
    v77294: state_type > $o ).

tff(pred_def_41465,type,
    v77386: state_type > $o ).

tff(pred_def_41466,type,
    v77385: state_type > $o ).

tff(pred_def_41467,type,
    v77384: state_type > $o ).

tff(pred_def_41468,type,
    v67211: state_type > $o ).

tff(pred_def_41469,type,
    v67209: state_type > $o ).

tff(pred_def_41470,type,
    v67207: ( state_type * $int ) > $o ).

tff(pred_def_41471,type,
    v67205: state_type > $o ).

tff(pred_def_41472,type,
    v67203: state_type > $o ).

tff(pred_def_41473,type,
    v77390: state_type > $o ).

tff(pred_def_41474,type,
    v77388: state_type > $o ).

tff(pred_def_41475,type,
    v77392: state_type > $o ).

tff(pred_def_41476,type,
    v67201: state_type > $o ).

tff(pred_def_41477,type,
    v67199: state_type > $o ).

tff(pred_def_41478,type,
    v67197: ( state_type * $int ) > $o ).

tff(pred_def_41479,type,
    v67195: state_type > $o ).

tff(pred_def_41480,type,
    v67193: state_type > $o ).

tff(pred_def_41481,type,
    v77412: state_type > $o ).

tff(pred_def_41482,type,
    v77410: state_type > $o ).

tff(pred_def_41483,type,
    v77416: state_type > $o ).

tff(pred_def_41484,type,
    v77414: state_type > $o ).

tff(pred_def_41485,type,
    v77430: state_type > $o ).

tff(pred_def_41486,type,
    v77428: state_type > $o ).

tff(pred_def_41487,type,
    v77426: state_type > $o ).

tff(pred_def_41488,type,
    v77424: state_type > $o ).

tff(pred_def_41489,type,
    v77422: state_type > $o ).

tff(pred_def_41490,type,
    v77420: state_type > $o ).

tff(pred_def_41491,type,
    v77418: state_type > $o ).

tff(pred_def_41492,type,
    v77445: state_type > $o ).

tff(pred_def_41493,type,
    v77443: state_type > $o ).

tff(pred_def_41494,type,
    v77441: state_type > $o ).

tff(pred_def_41495,type,
    v77439: state_type > $o ).

tff(pred_def_41496,type,
    v77437: state_type > $o ).

tff(pred_def_41497,type,
    v77435: state_type > $o ).

tff(pred_def_41498,type,
    v77433: state_type > $o ).

tff(pred_def_41499,type,
    v77450: state_type > $o ).

tff(pred_def_41500,type,
    v77449: state_type > $o ).

tff(pred_def_41501,type,
    v77448: state_type > $o ).

tff(pred_def_41502,type,
    v77408: state_type > $o ).

tff(pred_def_41503,type,
    v77406: state_type > $o ).

tff(pred_def_41504,type,
    v77404: state_type > $o ).

tff(pred_def_41505,type,
    v77402: state_type > $o ).

tff(pred_def_41506,type,
    v77454: state_type > $o ).

tff(pred_def_41507,type,
    v77452: state_type > $o ).

tff(pred_def_41508,type,
    v77456: state_type > $o ).

tff(pred_def_41509,type,
    v77400: state_type > $o ).

tff(pred_def_41510,type,
    v77398: state_type > $o ).

tff(pred_def_41511,type,
    v77396: state_type > $o ).

tff(pred_def_41512,type,
    v77394: state_type > $o ).

tff(pred_def_41513,type,
    v77476: state_type > $o ).

tff(pred_def_41514,type,
    v77474: state_type > $o ).

tff(pred_def_41515,type,
    v77480: state_type > $o ).

tff(pred_def_41516,type,
    v77478: state_type > $o ).

tff(pred_def_41517,type,
    v77484: state_type > $o ).

tff(pred_def_41518,type,
    v77482: state_type > $o ).

tff(pred_def_41519,type,
    v77488: state_type > $o ).

tff(pred_def_41520,type,
    v77486: state_type > $o ).

tff(pred_def_41521,type,
    v77492: state_type > $o ).

tff(pred_def_41522,type,
    v77491: state_type > $o ).

tff(pred_def_41523,type,
    v77490: state_type > $o ).

tff(pred_def_41524,type,
    v77472: state_type > $o ).

tff(pred_def_41525,type,
    v77470: state_type > $o ).

tff(pred_def_41526,type,
    v77468: state_type > $o ).

tff(pred_def_41527,type,
    v77466: state_type > $o ).

tff(pred_def_41528,type,
    v77496: state_type > $o ).

tff(pred_def_41529,type,
    v77494: state_type > $o ).

tff(pred_def_41530,type,
    v77498: state_type > $o ).

tff(pred_def_41531,type,
    v77464: state_type > $o ).

tff(pred_def_41532,type,
    v77462: state_type > $o ).

tff(pred_def_41533,type,
    v77460: state_type > $o ).

tff(pred_def_41534,type,
    v77458: state_type > $o ).

tff(pred_def_41535,type,
    v77501: state_type > $o ).

tff(pred_def_41536,type,
    v77500: state_type > $o ).

tff(pred_def_41537,type,
    v67191: state_type > $o ).

tff(pred_def_41538,type,
    v67189: state_type > $o ).

tff(pred_def_41539,type,
    v67187: state_type > $o ).

tff(pred_def_41540,type,
    v67185: state_type > $o ).

tff(pred_def_41541,type,
    v67183: state_type > $o ).

tff(pred_def_41542,type,
    v77531: state_type > $o ).

tff(pred_def_41543,type,
    v77529: state_type > $o ).

tff(pred_def_41544,type,
    v77535: state_type > $o ).

tff(pred_def_41545,type,
    v77533: state_type > $o ).

tff(pred_def_41546,type,
    v77539: state_type > $o ).

tff(pred_def_41547,type,
    v77537: state_type > $o ).

tff(pred_def_41548,type,
    v77543: state_type > $o ).

tff(pred_def_41549,type,
    v77541: state_type > $o ).

tff(pred_def_41550,type,
    v77547: state_type > $o ).

tff(pred_def_41551,type,
    v77546: state_type > $o ).

tff(pred_def_41552,type,
    v77545: state_type > $o ).

tff(pred_def_41553,type,
    v77527: state_type > $o ).

tff(pred_def_41554,type,
    v77525: state_type > $o ).

tff(pred_def_41555,type,
    v77523: state_type > $o ).

tff(pred_def_41556,type,
    v77521: state_type > $o ).

tff(pred_def_41557,type,
    v77551: state_type > $o ).

tff(pred_def_41558,type,
    v77549: state_type > $o ).

tff(pred_def_41559,type,
    v77553: state_type > $o ).

tff(pred_def_41560,type,
    v77519: state_type > $o ).

tff(pred_def_41561,type,
    v77517: state_type > $o ).

tff(pred_def_41562,type,
    v77515: state_type > $o ).

tff(pred_def_41563,type,
    v77513: state_type > $o ).

tff(pred_def_41564,type,
    v77573: state_type > $o ).

tff(pred_def_41565,type,
    v77571: state_type > $o ).

tff(pred_def_41566,type,
    v77577: state_type > $o ).

tff(pred_def_41567,type,
    v77575: state_type > $o ).

tff(pred_def_41568,type,
    v77581: state_type > $o ).

tff(pred_def_41569,type,
    v77579: state_type > $o ).

tff(pred_def_41570,type,
    v77585: state_type > $o ).

tff(pred_def_41571,type,
    v77583: state_type > $o ).

tff(pred_def_41572,type,
    v77589: state_type > $o ).

tff(pred_def_41573,type,
    v77588: state_type > $o ).

tff(pred_def_41574,type,
    v77587: state_type > $o ).

tff(pred_def_41575,type,
    v77569: state_type > $o ).

tff(pred_def_41576,type,
    v77567: state_type > $o ).

tff(pred_def_41577,type,
    v77565: state_type > $o ).

tff(pred_def_41578,type,
    v77563: state_type > $o ).

tff(pred_def_41579,type,
    v77593: state_type > $o ).

tff(pred_def_41580,type,
    v77591: state_type > $o ).

tff(pred_def_41581,type,
    v77595: state_type > $o ).

tff(pred_def_41582,type,
    v77561: state_type > $o ).

tff(pred_def_41583,type,
    v77559: state_type > $o ).

tff(pred_def_41584,type,
    v77557: state_type > $o ).

tff(pred_def_41585,type,
    v77555: state_type > $o ).

tff(pred_def_41586,type,
    v77615: state_type > $o ).

tff(pred_def_41587,type,
    v77613: state_type > $o ).

tff(pred_def_41588,type,
    v77619: state_type > $o ).

tff(pred_def_41589,type,
    v77617: state_type > $o ).

tff(pred_def_41590,type,
    v77623: state_type > $o ).

tff(pred_def_41591,type,
    v77621: state_type > $o ).

tff(pred_def_41592,type,
    v77627: state_type > $o ).

tff(pred_def_41593,type,
    v77625: state_type > $o ).

tff(pred_def_41594,type,
    v77631: state_type > $o ).

tff(pred_def_41595,type,
    v77630: state_type > $o ).

tff(pred_def_41596,type,
    v77629: state_type > $o ).

tff(pred_def_41597,type,
    v77611: state_type > $o ).

tff(pred_def_41598,type,
    v77609: state_type > $o ).

tff(pred_def_41599,type,
    v77607: state_type > $o ).

tff(pred_def_41600,type,
    v77605: state_type > $o ).

tff(pred_def_41601,type,
    v77635: state_type > $o ).

tff(pred_def_41602,type,
    v77633: state_type > $o ).

tff(pred_def_41603,type,
    v77637: state_type > $o ).

tff(pred_def_41604,type,
    v77603: state_type > $o ).

tff(pred_def_41605,type,
    v77601: state_type > $o ).

tff(pred_def_41606,type,
    v77599: state_type > $o ).

tff(pred_def_41607,type,
    v77597: state_type > $o ).

tff(pred_def_41608,type,
    v77640: state_type > $o ).

tff(pred_def_41609,type,
    v77639: state_type > $o ).

tff(pred_def_41610,type,
    v77511: state_type > $o ).

tff(pred_def_41611,type,
    v77509: state_type > $o ).

tff(pred_def_41612,type,
    v77507: state_type > $o ).

tff(pred_def_41613,type,
    v77505: state_type > $o ).

tff(pred_def_41614,type,
    v77503: state_type > $o ).

tff(pred_def_41615,type,
    v77670: state_type > $o ).

tff(pred_def_41616,type,
    v77668: state_type > $o ).

tff(pred_def_41617,type,
    v77674: state_type > $o ).

tff(pred_def_41618,type,
    v77672: state_type > $o ).

tff(pred_def_41619,type,
    v77678: state_type > $o ).

tff(pred_def_41620,type,
    v77676: state_type > $o ).

tff(pred_def_41621,type,
    v77682: state_type > $o ).

tff(pred_def_41622,type,
    v77680: state_type > $o ).

tff(pred_def_41623,type,
    v77686: state_type > $o ).

tff(pred_def_41624,type,
    v77685: state_type > $o ).

tff(pred_def_41625,type,
    v77684: state_type > $o ).

tff(pred_def_41626,type,
    v77666: state_type > $o ).

tff(pred_def_41627,type,
    v77664: state_type > $o ).

tff(pred_def_41628,type,
    v77662: state_type > $o ).

tff(pred_def_41629,type,
    v77660: state_type > $o ).

tff(pred_def_41630,type,
    v77690: state_type > $o ).

tff(pred_def_41631,type,
    v77688: state_type > $o ).

tff(pred_def_41632,type,
    v77692: state_type > $o ).

tff(pred_def_41633,type,
    v77658: state_type > $o ).

tff(pred_def_41634,type,
    v77656: state_type > $o ).

tff(pred_def_41635,type,
    v77654: state_type > $o ).

tff(pred_def_41636,type,
    v77652: state_type > $o ).

tff(pred_def_41637,type,
    v77722: state_type > $o ).

tff(pred_def_41638,type,
    v77720: state_type > $o ).

tff(pred_def_41639,type,
    v77726: state_type > $o ).

tff(pred_def_41640,type,
    v77724: state_type > $o ).

tff(pred_def_41641,type,
    v77730: state_type > $o ).

tff(pred_def_41642,type,
    v77728: state_type > $o ).

tff(pred_def_41643,type,
    v77734: state_type > $o ).

tff(pred_def_41644,type,
    v77732: state_type > $o ).

tff(pred_def_41645,type,
    v77738: state_type > $o ).

tff(pred_def_41646,type,
    v77737: state_type > $o ).

tff(pred_def_41647,type,
    v77736: state_type > $o ).

tff(pred_def_41648,type,
    v77718: state_type > $o ).

tff(pred_def_41649,type,
    v77716: state_type > $o ).

tff(pred_def_41650,type,
    v77714: state_type > $o ).

tff(pred_def_41651,type,
    v77712: state_type > $o ).

tff(pred_def_41652,type,
    v77742: state_type > $o ).

tff(pred_def_41653,type,
    v77740: state_type > $o ).

tff(pred_def_41654,type,
    v77744: state_type > $o ).

tff(pred_def_41655,type,
    v77710: state_type > $o ).

tff(pred_def_41656,type,
    v77708: state_type > $o ).

tff(pred_def_41657,type,
    v77706: state_type > $o ).

tff(pred_def_41658,type,
    v77704: state_type > $o ).

tff(pred_def_41659,type,
    v77790: state_type > $o ).

tff(pred_def_41660,type,
    v77788: state_type > $o ).

tff(pred_def_41661,type,
    v77794: state_type > $o ).

tff(pred_def_41662,type,
    v77792: state_type > $o ).

tff(pred_def_41663,type,
    v77786: state_type > $o ).

tff(pred_def_41664,type,
    v77784: state_type > $o ).

tff(pred_def_41665,type,
    v77782: state_type > $o ).

tff(pred_def_41666,type,
    v77780: state_type > $o ).

tff(pred_def_41667,type,
    v77778: state_type > $o ).

tff(pred_def_41668,type,
    v77809: ( state_type * $int ) > $o ).

tff(pred_def_41669,type,
    v77807: ( state_type * $int ) > $o ).

tff(pred_def_41670,type,
    v77875: state_type > $o ).

tff(pred_def_41671,type,
    v77873: state_type > $o ).

tff(pred_def_41672,type,
    v77871: state_type > $o ).

tff(pred_def_41673,type,
    v77869: state_type > $o ).

tff(pred_def_41674,type,
    v77867: state_type > $o ).

tff(pred_def_41675,type,
    v77865: state_type > $o ).

tff(pred_def_41676,type,
    v77882: ( state_type * $int ) > $o ).

tff(pred_def_41677,type,
    v77880: ( state_type * $int ) > $o ).

tff(pred_def_41678,type,
    v77878: ( state_type * $int ) > $o ).

tff(pred_def_41679,type,
    v77888: ( state_type * $int ) > $o ).

tff(pred_def_41680,type,
    v77886: ( state_type * $int ) > $o ).

tff(pred_def_41681,type,
    v77884: ( state_type * $int ) > $o ).

tff(pred_def_41682,type,
    v77890: state_type > $o ).

tff(pred_def_41683,type,
    v77891: state_type > $o ).

tff(pred_def_41684,type,
    v77889: ( state_type * $int ) > $o ).

tff(pred_def_41685,type,
    v77863: ( state_type * $int ) > $o ).

tff(pred_def_41686,type,
    v77861: ( state_type * $int ) > $o ).

tff(pred_def_41687,type,
    v77859: ( state_type * $int ) > $o ).

tff(pred_def_41688,type,
    v77857: state_type > $o ).

tff(pred_def_41689,type,
    v77855: state_type > $o ).

tff(pred_def_41690,type,
    v77853: state_type > $o ).

tff(pred_def_41691,type,
    v77851: state_type > $o ).

tff(pred_def_41692,type,
    v77849: state_type > $o ).

tff(pred_def_41693,type,
    v77847: state_type > $o ).

tff(pred_def_41694,type,
    v77845: state_type > $o ).

tff(pred_def_41695,type,
    v77843: state_type > $o ).

tff(pred_def_41696,type,
    v77841: state_type > $o ).

tff(pred_def_41697,type,
    v77839: state_type > $o ).

tff(pred_def_41698,type,
    v77897: state_type > $o ).

tff(pred_def_41699,type,
    v77896: ( state_type * $int ) > $o ).

tff(pred_def_41700,type,
    v77898: state_type > $o ).

tff(pred_def_41701,type,
    v77899: state_type > $o ).

tff(pred_def_41702,type,
    v77900: state_type > $o ).

tff(pred_def_41703,type,
    v77895: ( state_type * $int ) > $o ).

tff(pred_def_41704,type,
    v77903: state_type > $o ).

tff(pred_def_41705,type,
    v77902: ( state_type * $int ) > $o ).

tff(pred_def_41706,type,
    v77904: state_type > $o ).

tff(pred_def_41707,type,
    v77905: state_type > $o ).

tff(pred_def_41708,type,
    v77906: state_type > $o ).

tff(pred_def_41709,type,
    v77901: ( state_type * $int ) > $o ).

tff(pred_def_41710,type,
    v77909: state_type > $o ).

tff(pred_def_41711,type,
    v77908: ( state_type * $int ) > $o ).

tff(pred_def_41712,type,
    v77910: state_type > $o ).

tff(pred_def_41713,type,
    v77911: state_type > $o ).

tff(pred_def_41714,type,
    v77912: state_type > $o ).

tff(pred_def_41715,type,
    v77907: ( state_type * $int ) > $o ).

tff(pred_def_41716,type,
    v77915: state_type > $o ).

tff(pred_def_41717,type,
    v77914: ( state_type * $int ) > $o ).

tff(pred_def_41718,type,
    v77916: state_type > $o ).

tff(pred_def_41719,type,
    v77917: state_type > $o ).

tff(pred_def_41720,type,
    v77918: state_type > $o ).

tff(pred_def_41721,type,
    v77913: ( state_type * $int ) > $o ).

tff(pred_def_41722,type,
    v77921: state_type > $o ).

tff(pred_def_41723,type,
    v77920: ( state_type * $int ) > $o ).

tff(pred_def_41724,type,
    v77922: state_type > $o ).

tff(pred_def_41725,type,
    v77923: state_type > $o ).

tff(pred_def_41726,type,
    v77919: ( state_type * $int ) > $o ).

tff(pred_def_41727,type,
    v77926: state_type > $o ).

tff(pred_def_41728,type,
    v77925: ( state_type * $int ) > $o ).

tff(pred_def_41729,type,
    v77927: state_type > $o ).

tff(pred_def_41730,type,
    v77928: state_type > $o ).

tff(pred_def_41731,type,
    v77929: state_type > $o ).

tff(pred_def_41732,type,
    v77924: ( state_type * $int ) > $o ).

tff(pred_def_41733,type,
    v77932: state_type > $o ).

tff(pred_def_41734,type,
    v77931: ( state_type * $int ) > $o ).

tff(pred_def_41735,type,
    v77933: state_type > $o ).

tff(pred_def_41736,type,
    v77934: state_type > $o ).

tff(pred_def_41737,type,
    v77935: state_type > $o ).

tff(pred_def_41738,type,
    v77930: ( state_type * $int ) > $o ).

tff(pred_def_41739,type,
    v77938: state_type > $o ).

tff(pred_def_41740,type,
    v77937: ( state_type * $int ) > $o ).

tff(pred_def_41741,type,
    v77939: state_type > $o ).

tff(pred_def_41742,type,
    v77940: state_type > $o ).

tff(pred_def_41743,type,
    v77941: state_type > $o ).

tff(pred_def_41744,type,
    v77936: ( state_type * $int ) > $o ).

tff(pred_def_41745,type,
    v77894: ( state_type * $int ) > $o ).

tff(pred_def_41746,type,
    v77837: ( state_type * $int ) > $o ).

tff(pred_def_41747,type,
    v77835: state_type > $o ).

tff(pred_def_41748,type,
    v77833: state_type > $o ).

tff(pred_def_41749,type,
    v77964: state_type > $o ).

tff(pred_def_41750,type,
    v77962: state_type > $o ).

tff(pred_def_41751,type,
    v77960: state_type > $o ).

tff(pred_def_41752,type,
    v77958: state_type > $o ).

tff(pred_def_41753,type,
    v77956: state_type > $o ).

tff(pred_def_41754,type,
    v77954: state_type > $o ).

tff(pred_def_41755,type,
    v77952: state_type > $o ).

tff(pred_def_41756,type,
    v77950: state_type > $o ).

tff(pred_def_41757,type,
    v77948: state_type > $o ).

tff(pred_def_41758,type,
    v77945: state_type > $o ).

tff(pred_def_41759,type,
    v77943: state_type > $o ).

tff(pred_def_41760,type,
    v77989: state_type > $o ).

tff(pred_def_41761,type,
    v77987: state_type > $o ).

tff(pred_def_41762,type,
    v77985: state_type > $o ).

tff(pred_def_41763,type,
    v77983: state_type > $o ).

tff(pred_def_41764,type,
    v77981: state_type > $o ).

tff(pred_def_41765,type,
    v77979: state_type > $o ).

tff(pred_def_41766,type,
    v77977: state_type > $o ).

tff(pred_def_41767,type,
    v77975: state_type > $o ).

tff(pred_def_41768,type,
    v77973: state_type > $o ).

tff(pred_def_41769,type,
    v77970: state_type > $o ).

tff(pred_def_41770,type,
    v77968: state_type > $o ).

tff(pred_def_41771,type,
    v77993: state_type > $o ).

tff(pred_def_41772,type,
    v77831: state_type > $o ).

tff(pred_def_41773,type,
    v77829: state_type > $o ).

tff(pred_def_41774,type,
    v78001: state_type > $o ).

tff(pred_def_41775,type,
    v77999: state_type > $o ).

tff(pred_def_41776,type,
    v78005: state_type > $o ).

tff(pred_def_41777,type,
    v78003: state_type > $o ).

tff(pred_def_41778,type,
    v77997: state_type > $o ).

tff(pred_def_41779,type,
    v77995: state_type > $o ).

tff(pred_def_41780,type,
    v78014: state_type > $o ).

tff(pred_def_41781,type,
    v78012: state_type > $o ).

tff(pred_def_41782,type,
    v78010: state_type > $o ).

tff(pred_def_41783,type,
    v78008: state_type > $o ).

tff(pred_def_41784,type,
    v78032: state_type > $o ).

tff(pred_def_41785,type,
    v78030: state_type > $o ).

tff(pred_def_41786,type,
    v78036: state_type > $o ).

tff(pred_def_41787,type,
    v78034: state_type > $o ).

tff(pred_def_41788,type,
    v78040: state_type > $o ).

tff(pred_def_41789,type,
    v78038: state_type > $o ).

tff(pred_def_41790,type,
    v78042: state_type > $o ).

tff(pred_def_41791,type,
    v78028: state_type > $o ).

tff(pred_def_41792,type,
    v78026: state_type > $o ).

tff(pred_def_41793,type,
    v78024: state_type > $o ).

tff(pred_def_41794,type,
    v78022: state_type > $o ).

tff(pred_def_41795,type,
    v78020: state_type > $o ).

tff(pred_def_41796,type,
    v78065: state_type > $o ).

tff(pred_def_41797,type,
    v78063: state_type > $o ).

tff(pred_def_41798,type,
    v78061: state_type > $o ).

tff(pred_def_41799,type,
    v78059: state_type > $o ).

tff(pred_def_41800,type,
    v78057: state_type > $o ).

tff(pred_def_41801,type,
    v78055: state_type > $o ).

tff(pred_def_41802,type,
    v78053: state_type > $o ).

tff(pred_def_41803,type,
    v78051: state_type > $o ).

tff(pred_def_41804,type,
    v78049: state_type > $o ).

tff(pred_def_41805,type,
    v78046: state_type > $o ).

tff(pred_def_41806,type,
    v78044: state_type > $o ).

tff(pred_def_41807,type,
    v78018: state_type > $o ).

tff(pred_def_41808,type,
    v78016: state_type > $o ).

tff(pred_def_41809,type,
    v77827: ( state_type * $int ) > $o ).

tff(pred_def_41810,type,
    v78069: ( state_type * $int ) > $o ).

tff(pred_def_41811,type,
    v78070: ( state_type * $int ) > $o ).

tff(pred_def_41812,type,
    v78071: ( state_type * $int ) > $o ).

tff(pred_def_41813,type,
    v78072: ( state_type * $int ) > $o ).

tff(pred_def_41814,type,
    v78073: ( state_type * $int ) > $o ).

tff(pred_def_41815,type,
    v78074: ( state_type * $int ) > $o ).

tff(pred_def_41816,type,
    v78075: ( state_type * $int ) > $o ).

tff(pred_def_41817,type,
    v78076: ( state_type * $int ) > $o ).

tff(pred_def_41818,type,
    v78077: ( state_type * $int ) > $o ).

tff(pred_def_41819,type,
    v78078: ( state_type * $int ) > $o ).

tff(pred_def_41820,type,
    v78079: ( state_type * $int ) > $o ).

tff(pred_def_41821,type,
    v78080: ( state_type * $int ) > $o ).

tff(pred_def_41822,type,
    v78081: ( state_type * $int ) > $o ).

tff(pred_def_41823,type,
    v78082: ( state_type * $int ) > $o ).

tff(pred_def_41824,type,
    v77825: ( state_type * $int ) > $o ).

tff(pred_def_41825,type,
    v77823: ( state_type * $int ) > $o ).

tff(pred_def_41826,type,
    v77821: ( state_type * $int ) > $o ).

tff(pred_def_41827,type,
    v77819: ( state_type * $int ) > $o ).

tff(pred_def_41828,type,
    v77817: ( state_type * $int ) > $o ).

tff(pred_def_41829,type,
    v77815: ( state_type * $int ) > $o ).

tff(pred_def_41830,type,
    v77813: ( state_type * $int ) > $o ).

tff(pred_def_41831,type,
    v77811: ( state_type * $int ) > $o ).

tff(pred_def_41832,type,
    v77805: state_type > $o ).

tff(pred_def_41833,type,
    v77803: state_type > $o ).

tff(pred_def_41834,type,
    v77801: state_type > $o ).

tff(pred_def_41835,type,
    v77799: state_type > $o ).

tff(pred_def_41836,type,
    v77797: state_type > $o ).

tff(pred_def_41837,type,
    v77776: state_type > $o ).

tff(pred_def_41838,type,
    v77774: state_type > $o ).

tff(pred_def_41839,type,
    v77772: state_type > $o ).

tff(pred_def_41840,type,
    v78094: state_type > $o ).

tff(pred_def_41841,type,
    v78092: state_type > $o ).

tff(pred_def_41842,type,
    v78108: ( state_type * $int ) > $o ).

tff(pred_def_41843,type,
    v78106: ( state_type * $int ) > $o ).

tff(pred_def_41844,type,
    v78133: state_type > $o ).

tff(pred_def_41845,type,
    v78131: state_type > $o ).

tff(pred_def_41846,type,
    v78137: state_type > $o ).

tff(pred_def_41847,type,
    v78135: state_type > $o ).

tff(pred_def_41848,type,
    v78141: state_type > $o ).

tff(pred_def_41849,type,
    v78139: state_type > $o ).

tff(pred_def_41850,type,
    v78143: state_type > $o ).

tff(pred_def_41851,type,
    v78129: state_type > $o ).

tff(pred_def_41852,type,
    v78127: state_type > $o ).

tff(pred_def_41853,type,
    v78125: state_type > $o ).

tff(pred_def_41854,type,
    v78123: state_type > $o ).

tff(pred_def_41855,type,
    v78121: state_type > $o ).

tff(pred_def_41856,type,
    v78147: state_type > $o ).

tff(pred_def_41857,type,
    v78145: state_type > $o ).

tff(pred_def_41858,type,
    v78119: state_type > $o ).

tff(pred_def_41859,type,
    v78117: state_type > $o ).

tff(pred_def_41860,type,
    v78156: state_type > $o ).

tff(pred_def_41861,type,
    v78154: state_type > $o ).

tff(pred_def_41862,type,
    v78160: state_type > $o ).

tff(pred_def_41863,type,
    v78158: state_type > $o ).

tff(pred_def_41864,type,
    v78164: state_type > $o ).

tff(pred_def_41865,type,
    v78162: state_type > $o ).

tff(pred_def_41866,type,
    v78166: state_type > $o ).

tff(pred_def_41867,type,
    v78152: state_type > $o ).

tff(pred_def_41868,type,
    v78150: state_type > $o ).

tff(pred_def_41869,type,
    v78174: state_type > $o ).

tff(pred_def_41870,type,
    v78172: state_type > $o ).

tff(pred_def_41871,type,
    v78178: state_type > $o ).

tff(pred_def_41872,type,
    v78176: state_type > $o ).

tff(pred_def_41873,type,
    v78170: state_type > $o ).

tff(pred_def_41874,type,
    v78168: state_type > $o ).

tff(pred_def_41875,type,
    v78187: state_type > $o ).

tff(pred_def_41876,type,
    v78185: state_type > $o ).

tff(pred_def_41877,type,
    v78191: state_type > $o ).

tff(pred_def_41878,type,
    v78189: state_type > $o ).

tff(pred_def_41879,type,
    v78195: state_type > $o ).

tff(pred_def_41880,type,
    v78193: state_type > $o ).

tff(pred_def_41881,type,
    v78197: state_type > $o ).

tff(pred_def_41882,type,
    v78183: state_type > $o ).

tff(pred_def_41883,type,
    v78181: state_type > $o ).

tff(pred_def_41884,type,
    v78114: ( state_type * $int ) > $o ).

tff(pred_def_41885,type,
    v78112: ( state_type * $int ) > $o ).

tff(pred_def_41886,type,
    v78110: ( state_type * $int ) > $o ).

tff(pred_def_41887,type,
    v78104: state_type > $o ).

tff(pred_def_41888,type,
    v78102: state_type > $o ).

tff(pred_def_41889,type,
    v78100: state_type > $o ).

tff(pred_def_41890,type,
    v78098: state_type > $o ).

tff(pred_def_41891,type,
    v78096: state_type > $o ).

tff(pred_def_41892,type,
    v78090: state_type > $o ).

tff(pred_def_41893,type,
    v78088: state_type > $o ).

tff(pred_def_41894,type,
    v78086: state_type > $o ).

tff(pred_def_41895,type,
    v78209: state_type > $o ).

tff(pred_def_41896,type,
    v78207: state_type > $o ).

tff(pred_def_41897,type,
    v78223: ( state_type * $int ) > $o ).

tff(pred_def_41898,type,
    v78221: ( state_type * $int ) > $o ).

tff(pred_def_41899,type,
    v78238: state_type > $o ).

tff(pred_def_41900,type,
    v78236: state_type > $o ).

tff(pred_def_41901,type,
    v78242: state_type > $o ).

tff(pred_def_41902,type,
    v78240: state_type > $o ).

tff(pred_def_41903,type,
    v78234: state_type > $o ).

tff(pred_def_41904,type,
    v78232: state_type > $o ).

tff(pred_def_41905,type,
    v78251: state_type > $o ).

tff(pred_def_41906,type,
    v78249: state_type > $o ).

tff(pred_def_41907,type,
    v78247: state_type > $o ).

tff(pred_def_41908,type,
    v78245: state_type > $o ).

tff(pred_def_41909,type,
    v78259: state_type > $o ).

tff(pred_def_41910,type,
    v78257: state_type > $o ).

tff(pred_def_41911,type,
    v78255: state_type > $o ).

tff(pred_def_41912,type,
    v78253: state_type > $o ).

tff(pred_def_41913,type,
    v78267: state_type > $o ).

tff(pred_def_41914,type,
    v78265: state_type > $o ).

tff(pred_def_41915,type,
    v78271: state_type > $o ).

tff(pred_def_41916,type,
    v78269: state_type > $o ).

tff(pred_def_41917,type,
    v78275: state_type > $o ).

tff(pred_def_41918,type,
    v78273: state_type > $o ).

tff(pred_def_41919,type,
    v78277: state_type > $o ).

tff(pred_def_41920,type,
    v78263: state_type > $o ).

tff(pred_def_41921,type,
    v78261: state_type > $o ).

tff(pred_def_41922,type,
    v78229: ( state_type * $int ) > $o ).

tff(pred_def_41923,type,
    v78227: ( state_type * $int ) > $o ).

tff(pred_def_41924,type,
    v78225: ( state_type * $int ) > $o ).

tff(pred_def_41925,type,
    v78219: state_type > $o ).

tff(pred_def_41926,type,
    v78217: state_type > $o ).

tff(pred_def_41927,type,
    v78215: state_type > $o ).

tff(pred_def_41928,type,
    v78213: state_type > $o ).

tff(pred_def_41929,type,
    v78211: state_type > $o ).

tff(pred_def_41930,type,
    v78205: state_type > $o ).

tff(pred_def_41931,type,
    v78203: state_type > $o ).

tff(pred_def_41932,type,
    v78201: state_type > $o ).

tff(pred_def_41933,type,
    v78289: state_type > $o ).

tff(pred_def_41934,type,
    v78287: state_type > $o ).

tff(pred_def_41935,type,
    v78303: ( state_type * $int ) > $o ).

tff(pred_def_41936,type,
    v78301: ( state_type * $int ) > $o ).

tff(pred_def_41937,type,
    v78327: state_type > $o ).

tff(pred_def_41938,type,
    v78325: state_type > $o ).

tff(pred_def_41939,type,
    v78323: state_type > $o ).

tff(pred_def_41940,type,
    v78321: state_type > $o ).

tff(pred_def_41941,type,
    v78318: state_type > $o ).

tff(pred_def_41942,type,
    v78316: state_type > $o ).

tff(pred_def_41943,type,
    v78341: state_type > $o ).

tff(pred_def_41944,type,
    v78339: state_type > $o ).

tff(pred_def_41945,type,
    v78337: state_type > $o ).

tff(pred_def_41946,type,
    v78335: state_type > $o ).

tff(pred_def_41947,type,
    v78332: state_type > $o ).

tff(pred_def_41948,type,
    v78330: state_type > $o ).

tff(pred_def_41949,type,
    v78355: state_type > $o ).

tff(pred_def_41950,type,
    v78353: state_type > $o ).

tff(pred_def_41951,type,
    v78351: state_type > $o ).

tff(pred_def_41952,type,
    v78349: state_type > $o ).

tff(pred_def_41953,type,
    v78346: state_type > $o ).

tff(pred_def_41954,type,
    v78344: state_type > $o ).

tff(pred_def_41955,type,
    v78358: state_type > $o ).

tff(pred_def_41956,type,
    v78314: state_type > $o ).

tff(pred_def_41957,type,
    v78312: state_type > $o ).

tff(pred_def_41958,type,
    v78366: state_type > $o ).

tff(pred_def_41959,type,
    v78364: state_type > $o ).

tff(pred_def_41960,type,
    v78379: state_type > $o ).

tff(pred_def_41961,type,
    v78377: state_type > $o ).

tff(pred_def_41962,type,
    v78375: state_type > $o ).

tff(pred_def_41963,type,
    v78373: state_type > $o ).

tff(pred_def_41964,type,
    v78370: state_type > $o ).

tff(pred_def_41965,type,
    v78368: state_type > $o ).

tff(pred_def_41966,type,
    v78362: state_type > $o ).

tff(pred_def_41967,type,
    v78360: state_type > $o ).

tff(pred_def_41968,type,
    v78389: state_type > $o ).

tff(pred_def_41969,type,
    v78387: state_type > $o ).

tff(pred_def_41970,type,
    v78393: state_type > $o ).

tff(pred_def_41971,type,
    v78391: state_type > $o ).

tff(pred_def_41972,type,
    v78385: state_type > $o ).

tff(pred_def_41973,type,
    v78383: state_type > $o ).

tff(pred_def_41974,type,
    v78402: state_type > $o ).

tff(pred_def_41975,type,
    v78400: state_type > $o ).

tff(pred_def_41976,type,
    v78406: state_type > $o ).

tff(pred_def_41977,type,
    v78404: state_type > $o ).

tff(pred_def_41978,type,
    v78398: state_type > $o ).

tff(pred_def_41979,type,
    v78396: state_type > $o ).

tff(pred_def_41980,type,
    v78309: ( state_type * $int ) > $o ).

tff(pred_def_41981,type,
    v78307: ( state_type * $int ) > $o ).

tff(pred_def_41982,type,
    v78305: ( state_type * $int ) > $o ).

tff(pred_def_41983,type,
    v78299: state_type > $o ).

tff(pred_def_41984,type,
    v78297: state_type > $o ).

tff(pred_def_41985,type,
    v78295: state_type > $o ).

tff(pred_def_41986,type,
    v78293: state_type > $o ).

tff(pred_def_41987,type,
    v78291: state_type > $o ).

tff(pred_def_41988,type,
    v78285: state_type > $o ).

tff(pred_def_41989,type,
    v78283: state_type > $o ).

tff(pred_def_41990,type,
    v78281: state_type > $o ).

tff(pred_def_41991,type,
    v78419: state_type > $o ).

tff(pred_def_41992,type,
    v78417: state_type > $o ).

tff(pred_def_41993,type,
    v78433: ( state_type * $int ) > $o ).

tff(pred_def_41994,type,
    v78431: ( state_type * $int ) > $o ).

tff(pred_def_41995,type,
    v78448: state_type > $o ).

tff(pred_def_41996,type,
    v78446: state_type > $o ).

tff(pred_def_41997,type,
    v78452: state_type > $o ).

tff(pred_def_41998,type,
    v78450: state_type > $o ).

tff(pred_def_41999,type,
    v78444: state_type > $o ).

tff(pred_def_42000,type,
    v78442: state_type > $o ).

tff(pred_def_42001,type,
    v78461: state_type > $o ).

tff(pred_def_42002,type,
    v78459: state_type > $o ).

tff(pred_def_42003,type,
    v78465: state_type > $o ).

tff(pred_def_42004,type,
    v78463: state_type > $o ).

tff(pred_def_42005,type,
    v78457: state_type > $o ).

tff(pred_def_42006,type,
    v78455: state_type > $o ).

tff(pred_def_42007,type,
    v78474: state_type > $o ).

tff(pred_def_42008,type,
    v78472: state_type > $o ).

tff(pred_def_42009,type,
    v78478: state_type > $o ).

tff(pred_def_42010,type,
    v78476: state_type > $o ).

tff(pred_def_42011,type,
    v78482: state_type > $o ).

tff(pred_def_42012,type,
    v78480: state_type > $o ).

tff(pred_def_42013,type,
    v78484: state_type > $o ).

tff(pred_def_42014,type,
    v78470: state_type > $o ).

tff(pred_def_42015,type,
    v78468: state_type > $o ).

tff(pred_def_42016,type,
    v78492: state_type > $o ).

tff(pred_def_42017,type,
    v78490: state_type > $o ).

tff(pred_def_42018,type,
    v78496: state_type > $o ).

tff(pred_def_42019,type,
    v78494: state_type > $o ).

tff(pred_def_42020,type,
    v78500: state_type > $o ).

tff(pred_def_42021,type,
    v78498: state_type > $o ).

tff(pred_def_42022,type,
    v78502: state_type > $o ).

tff(pred_def_42023,type,
    v78488: state_type > $o ).

tff(pred_def_42024,type,
    v78486: state_type > $o ).

tff(pred_def_42025,type,
    v78439: ( state_type * $int ) > $o ).

tff(pred_def_42026,type,
    v78437: ( state_type * $int ) > $o ).

tff(pred_def_42027,type,
    v78435: ( state_type * $int ) > $o ).

tff(pred_def_42028,type,
    v78429: state_type > $o ).

tff(pred_def_42029,type,
    v78427: state_type > $o ).

tff(pred_def_42030,type,
    v78425: state_type > $o ).

tff(pred_def_42031,type,
    v78423: state_type > $o ).

tff(pred_def_42032,type,
    v78421: state_type > $o ).

tff(pred_def_42033,type,
    v78415: state_type > $o ).

tff(pred_def_42034,type,
    v78413: state_type > $o ).

tff(pred_def_42035,type,
    v78411: state_type > $o ).

tff(pred_def_42036,type,
    v78514: state_type > $o ).

tff(pred_def_42037,type,
    v78512: state_type > $o ).

tff(pred_def_42038,type,
    v78528: ( state_type * $int ) > $o ).

tff(pred_def_42039,type,
    v78526: ( state_type * $int ) > $o ).

tff(pred_def_42040,type,
    v78543: state_type > $o ).

tff(pred_def_42041,type,
    v78541: state_type > $o ).

tff(pred_def_42042,type,
    v78547: state_type > $o ).

tff(pred_def_42043,type,
    v78545: state_type > $o ).

tff(pred_def_42044,type,
    v78551: state_type > $o ).

tff(pred_def_42045,type,
    v78549: state_type > $o ).

tff(pred_def_42046,type,
    v78553: state_type > $o ).

tff(pred_def_42047,type,
    v78539: state_type > $o ).

tff(pred_def_42048,type,
    v78537: state_type > $o ).

tff(pred_def_42049,type,
    v78561: state_type > $o ).

tff(pred_def_42050,type,
    v78559: state_type > $o ).

tff(pred_def_42051,type,
    v78565: state_type > $o ).

tff(pred_def_42052,type,
    v78563: state_type > $o ).

tff(pred_def_42053,type,
    v78569: state_type > $o ).

tff(pred_def_42054,type,
    v78567: state_type > $o ).

tff(pred_def_42055,type,
    v78571: state_type > $o ).

tff(pred_def_42056,type,
    v78557: state_type > $o ).

tff(pred_def_42057,type,
    v78555: state_type > $o ).

tff(pred_def_42058,type,
    v78589: state_type > $o ).

tff(pred_def_42059,type,
    v78587: state_type > $o ).

tff(pred_def_42060,type,
    v78593: state_type > $o ).

tff(pred_def_42061,type,
    v78591: state_type > $o ).

tff(pred_def_42062,type,
    v78597: state_type > $o ).

tff(pred_def_42063,type,
    v78595: state_type > $o ).

tff(pred_def_42064,type,
    v78599: state_type > $o ).

tff(pred_def_42065,type,
    v78585: state_type > $o ).

tff(pred_def_42066,type,
    v78583: state_type > $o ).

tff(pred_def_42067,type,
    v78581: state_type > $o ).

tff(pred_def_42068,type,
    v78579: state_type > $o ).

tff(pred_def_42069,type,
    v78577: state_type > $o ).

tff(pred_def_42070,type,
    v78603: state_type > $o ).

tff(pred_def_42071,type,
    v78601: state_type > $o ).

tff(pred_def_42072,type,
    v78575: state_type > $o ).

tff(pred_def_42073,type,
    v78573: state_type > $o ).

tff(pred_def_42074,type,
    v78612: state_type > $o ).

tff(pred_def_42075,type,
    v78610: state_type > $o ).

tff(pred_def_42076,type,
    v78616: state_type > $o ).

tff(pred_def_42077,type,
    v78614: state_type > $o ).

tff(pred_def_42078,type,
    v78608: state_type > $o ).

tff(pred_def_42079,type,
    v78606: state_type > $o ).

tff(pred_def_42080,type,
    v78534: ( state_type * $int ) > $o ).

tff(pred_def_42081,type,
    v78532: ( state_type * $int ) > $o ).

tff(pred_def_42082,type,
    v78530: ( state_type * $int ) > $o ).

tff(pred_def_42083,type,
    v78524: state_type > $o ).

tff(pred_def_42084,type,
    v78522: state_type > $o ).

tff(pred_def_42085,type,
    v78520: state_type > $o ).

tff(pred_def_42086,type,
    v78518: state_type > $o ).

tff(pred_def_42087,type,
    v78516: state_type > $o ).

tff(pred_def_42088,type,
    v78510: state_type > $o ).

tff(pred_def_42089,type,
    v78508: state_type > $o ).

tff(pred_def_42090,type,
    v78506: state_type > $o ).

tff(pred_def_42091,type,
    v78629: state_type > $o ).

tff(pred_def_42092,type,
    v78627: state_type > $o ).

tff(pred_def_42093,type,
    v78643: ( state_type * $int ) > $o ).

tff(pred_def_42094,type,
    v78641: ( state_type * $int ) > $o ).

tff(pred_def_42095,type,
    v78658: state_type > $o ).

tff(pred_def_42096,type,
    v78656: state_type > $o ).

tff(pred_def_42097,type,
    v78654: state_type > $o ).

tff(pred_def_42098,type,
    v78652: state_type > $o ).

tff(pred_def_42099,type,
    v78666: state_type > $o ).

tff(pred_def_42100,type,
    v78664: state_type > $o ).

tff(pred_def_42101,type,
    v78662: state_type > $o ).

tff(pred_def_42102,type,
    v78660: state_type > $o ).

tff(pred_def_42103,type,
    v78674: state_type > $o ).

tff(pred_def_42104,type,
    v78672: state_type > $o ).

tff(pred_def_42105,type,
    v78670: state_type > $o ).

tff(pred_def_42106,type,
    v78668: state_type > $o ).

tff(pred_def_42107,type,
    v78682: state_type > $o ).

tff(pred_def_42108,type,
    v78680: state_type > $o ).

tff(pred_def_42109,type,
    v78686: state_type > $o ).

tff(pred_def_42110,type,
    v78684: state_type > $o ).

tff(pred_def_42111,type,
    v78678: state_type > $o ).

tff(pred_def_42112,type,
    v78676: state_type > $o ).

tff(pred_def_42113,type,
    v78649: ( state_type * $int ) > $o ).

tff(pred_def_42114,type,
    v78647: ( state_type * $int ) > $o ).

tff(pred_def_42115,type,
    v78645: ( state_type * $int ) > $o ).

tff(pred_def_42116,type,
    v78639: state_type > $o ).

tff(pred_def_42117,type,
    v78637: state_type > $o ).

tff(pred_def_42118,type,
    v78635: state_type > $o ).

tff(pred_def_42119,type,
    v78633: state_type > $o ).

tff(pred_def_42120,type,
    v78631: state_type > $o ).

tff(pred_def_42121,type,
    v78625: state_type > $o ).

tff(pred_def_42122,type,
    v78623: state_type > $o ).

tff(pred_def_42123,type,
    v78621: state_type > $o ).

tff(pred_def_42124,type,
    v78699: state_type > $o ).

tff(pred_def_42125,type,
    v78697: state_type > $o ).

tff(pred_def_42126,type,
    v78713: ( state_type * $int ) > $o ).

tff(pred_def_42127,type,
    v78711: ( state_type * $int ) > $o ).

tff(pred_def_42128,type,
    v78737: state_type > $o ).

tff(pred_def_42129,type,
    v78735: state_type > $o ).

tff(pred_def_42130,type,
    v78733: state_type > $o ).

tff(pred_def_42131,type,
    v78731: state_type > $o ).

tff(pred_def_42132,type,
    v78728: state_type > $o ).

tff(pred_def_42133,type,
    v78726: state_type > $o ).

tff(pred_def_42134,type,
    v78751: state_type > $o ).

tff(pred_def_42135,type,
    v78749: state_type > $o ).

tff(pred_def_42136,type,
    v78747: state_type > $o ).

tff(pred_def_42137,type,
    v78745: state_type > $o ).

tff(pred_def_42138,type,
    v78742: state_type > $o ).

tff(pred_def_42139,type,
    v78740: state_type > $o ).

tff(pred_def_42140,type,
    v78724: state_type > $o ).

tff(pred_def_42141,type,
    v78722: state_type > $o ).

tff(pred_def_42142,type,
    v78761: state_type > $o ).

tff(pred_def_42143,type,
    v78759: state_type > $o ).

tff(pred_def_42144,type,
    v78774: state_type > $o ).

tff(pred_def_42145,type,
    v78772: state_type > $o ).

tff(pred_def_42146,type,
    v78770: state_type > $o ).

tff(pred_def_42147,type,
    v78768: state_type > $o ).

tff(pred_def_42148,type,
    v78765: state_type > $o ).

tff(pred_def_42149,type,
    v78763: state_type > $o ).

tff(pred_def_42150,type,
    v78757: state_type > $o ).

tff(pred_def_42151,type,
    v78755: state_type > $o ).

tff(pred_def_42152,type,
    v78784: state_type > $o ).

tff(pred_def_42153,type,
    v78782: state_type > $o ).

tff(pred_def_42154,type,
    v78797: state_type > $o ).

tff(pred_def_42155,type,
    v78795: state_type > $o ).

tff(pred_def_42156,type,
    v78793: state_type > $o ).

tff(pred_def_42157,type,
    v78791: state_type > $o ).

tff(pred_def_42158,type,
    v78788: state_type > $o ).

tff(pred_def_42159,type,
    v78786: state_type > $o ).

tff(pred_def_42160,type,
    v78780: state_type > $o ).

tff(pred_def_42161,type,
    v78778: state_type > $o ).

tff(pred_def_42162,type,
    v78807: state_type > $o ).

tff(pred_def_42163,type,
    v78805: state_type > $o ).

tff(pred_def_42164,type,
    v78803: state_type > $o ).

tff(pred_def_42165,type,
    v78801: state_type > $o ).

tff(pred_def_42166,type,
    v78719: ( state_type * $int ) > $o ).

tff(pred_def_42167,type,
    v78717: ( state_type * $int ) > $o ).

tff(pred_def_42168,type,
    v78715: ( state_type * $int ) > $o ).

tff(pred_def_42169,type,
    v78709: state_type > $o ).

tff(pred_def_42170,type,
    v78707: state_type > $o ).

tff(pred_def_42171,type,
    v78705: state_type > $o ).

tff(pred_def_42172,type,
    v78703: state_type > $o ).

tff(pred_def_42173,type,
    v78701: state_type > $o ).

tff(pred_def_42174,type,
    v78695: state_type > $o ).

tff(pred_def_42175,type,
    v78693: state_type > $o ).

tff(pred_def_42176,type,
    v78691: state_type > $o ).

tff(pred_def_42177,type,
    v78819: state_type > $o ).

tff(pred_def_42178,type,
    v78817: state_type > $o ).

tff(pred_def_42179,type,
    v78833: ( state_type * $int ) > $o ).

tff(pred_def_42180,type,
    v78831: ( state_type * $int ) > $o ).

tff(pred_def_42181,type,
    v78848: state_type > $o ).

tff(pred_def_42182,type,
    v78846: state_type > $o ).

tff(pred_def_42183,type,
    v78852: state_type > $o ).

tff(pred_def_42184,type,
    v78850: state_type > $o ).

tff(pred_def_42185,type,
    v78856: state_type > $o ).

tff(pred_def_42186,type,
    v78854: state_type > $o ).

tff(pred_def_42187,type,
    v78858: state_type > $o ).

tff(pred_def_42188,type,
    v78844: state_type > $o ).

tff(pred_def_42189,type,
    v78842: state_type > $o ).

tff(pred_def_42190,type,
    v78876: state_type > $o ).

tff(pred_def_42191,type,
    v78874: state_type > $o ).

tff(pred_def_42192,type,
    v78880: state_type > $o ).

tff(pred_def_42193,type,
    v78878: state_type > $o ).

tff(pred_def_42194,type,
    v78884: state_type > $o ).

tff(pred_def_42195,type,
    v78882: state_type > $o ).

tff(pred_def_42196,type,
    v78886: state_type > $o ).

tff(pred_def_42197,type,
    v78872: state_type > $o ).

tff(pred_def_42198,type,
    v78870: state_type > $o ).

tff(pred_def_42199,type,
    v78868: state_type > $o ).

tff(pred_def_42200,type,
    v78866: state_type > $o ).

tff(pred_def_42201,type,
    v78864: state_type > $o ).

tff(pred_def_42202,type,
    v78890: state_type > $o ).

tff(pred_def_42203,type,
    v78888: state_type > $o ).

tff(pred_def_42204,type,
    v78862: state_type > $o ).

tff(pred_def_42205,type,
    v78860: state_type > $o ).

tff(pred_def_42206,type,
    v78899: state_type > $o ).

tff(pred_def_42207,type,
    v78897: state_type > $o ).

tff(pred_def_42208,type,
    v78903: state_type > $o ).

tff(pred_def_42209,type,
    v78901: state_type > $o ).

tff(pred_def_42210,type,
    v78907: state_type > $o ).

tff(pred_def_42211,type,
    v78905: state_type > $o ).

tff(pred_def_42212,type,
    v78909: state_type > $o ).

tff(pred_def_42213,type,
    v78895: state_type > $o ).

tff(pred_def_42214,type,
    v78893: state_type > $o ).

tff(pred_def_42215,type,
    v78917: state_type > $o ).

tff(pred_def_42216,type,
    v78915: state_type > $o ).

tff(pred_def_42217,type,
    v78921: state_type > $o ).

tff(pred_def_42218,type,
    v78919: state_type > $o ).

tff(pred_def_42219,type,
    v78925: state_type > $o ).

tff(pred_def_42220,type,
    v78923: state_type > $o ).

tff(pred_def_42221,type,
    v78927: state_type > $o ).

tff(pred_def_42222,type,
    v78913: state_type > $o ).

tff(pred_def_42223,type,
    v78911: state_type > $o ).

tff(pred_def_42224,type,
    v78839: ( state_type * $int ) > $o ).

tff(pred_def_42225,type,
    v78837: ( state_type * $int ) > $o ).

tff(pred_def_42226,type,
    v78835: ( state_type * $int ) > $o ).

tff(pred_def_42227,type,
    v78829: state_type > $o ).

tff(pred_def_42228,type,
    v78827: state_type > $o ).

tff(pred_def_42229,type,
    v78825: state_type > $o ).

tff(pred_def_42230,type,
    v78823: state_type > $o ).

tff(pred_def_42231,type,
    v78821: state_type > $o ).

tff(pred_def_42232,type,
    v78815: state_type > $o ).

tff(pred_def_42233,type,
    v78813: state_type > $o ).

tff(pred_def_42234,type,
    v78811: state_type > $o ).

tff(pred_def_42235,type,
    v78939: state_type > $o ).

tff(pred_def_42236,type,
    v78937: state_type > $o ).

tff(pred_def_42237,type,
    v78953: ( state_type * $int ) > $o ).

tff(pred_def_42238,type,
    v78951: ( state_type * $int ) > $o ).

tff(pred_def_42239,type,
    v78968: state_type > $o ).

tff(pred_def_42240,type,
    v78966: state_type > $o ).

tff(pred_def_42241,type,
    v78972: state_type > $o ).

tff(pred_def_42242,type,
    v78970: state_type > $o ).

tff(pred_def_42243,type,
    v78964: state_type > $o ).

tff(pred_def_42244,type,
    v78962: state_type > $o ).

tff(pred_def_42245,type,
    v78981: state_type > $o ).

tff(pred_def_42246,type,
    v78979: state_type > $o ).

tff(pred_def_42247,type,
    v78985: state_type > $o ).

tff(pred_def_42248,type,
    v78983: state_type > $o ).

tff(pred_def_42249,type,
    v78989: state_type > $o ).

tff(pred_def_42250,type,
    v78987: state_type > $o ).

tff(pred_def_42251,type,
    v78991: state_type > $o ).

tff(pred_def_42252,type,
    v78977: state_type > $o ).

tff(pred_def_42253,type,
    v78975: state_type > $o ).

tff(pred_def_42254,type,
    v78999: state_type > $o ).

tff(pred_def_42255,type,
    v78997: state_type > $o ).

tff(pred_def_42256,type,
    v79003: state_type > $o ).

tff(pred_def_42257,type,
    v79001: state_type > $o ).

tff(pred_def_42258,type,
    v78995: state_type > $o ).

tff(pred_def_42259,type,
    v78993: state_type > $o ).

tff(pred_def_42260,type,
    v79012: state_type > $o ).

tff(pred_def_42261,type,
    v79010: state_type > $o ).

tff(pred_def_42262,type,
    v79016: state_type > $o ).

tff(pred_def_42263,type,
    v79014: state_type > $o ).

tff(pred_def_42264,type,
    v79008: state_type > $o ).

tff(pred_def_42265,type,
    v79006: state_type > $o ).

tff(pred_def_42266,type,
    v78959: ( state_type * $int ) > $o ).

tff(pred_def_42267,type,
    v78957: ( state_type * $int ) > $o ).

tff(pred_def_42268,type,
    v78955: ( state_type * $int ) > $o ).

tff(pred_def_42269,type,
    v78949: state_type > $o ).

tff(pred_def_42270,type,
    v78947: state_type > $o ).

tff(pred_def_42271,type,
    v78945: state_type > $o ).

tff(pred_def_42272,type,
    v78943: state_type > $o ).

tff(pred_def_42273,type,
    v78941: state_type > $o ).

tff(pred_def_42274,type,
    v78935: state_type > $o ).

tff(pred_def_42275,type,
    v78933: state_type > $o ).

tff(pred_def_42276,type,
    v78931: state_type > $o ).

tff(pred_def_42277,type,
    v79029: state_type > $o ).

tff(pred_def_42278,type,
    v79027: state_type > $o ).

tff(pred_def_42279,type,
    v79043: ( state_type * $int ) > $o ).

tff(pred_def_42280,type,
    v79041: ( state_type * $int ) > $o ).

tff(pred_def_42281,type,
    v79058: state_type > $o ).

tff(pred_def_42282,type,
    v79056: state_type > $o ).

tff(pred_def_42283,type,
    v79062: state_type > $o ).

tff(pred_def_42284,type,
    v79060: state_type > $o ).

tff(pred_def_42285,type,
    v79054: state_type > $o ).

tff(pred_def_42286,type,
    v79052: state_type > $o ).

tff(pred_def_42287,type,
    v79071: state_type > $o ).

tff(pred_def_42288,type,
    v79069: state_type > $o ).

tff(pred_def_42289,type,
    v79075: state_type > $o ).

tff(pred_def_42290,type,
    v79073: state_type > $o ).

tff(pred_def_42291,type,
    v79079: state_type > $o ).

tff(pred_def_42292,type,
    v79077: state_type > $o ).

tff(pred_def_42293,type,
    v79081: state_type > $o ).

tff(pred_def_42294,type,
    v79067: state_type > $o ).

tff(pred_def_42295,type,
    v79065: state_type > $o ).

tff(pred_def_42296,type,
    v79089: state_type > $o ).

tff(pred_def_42297,type,
    v79087: state_type > $o ).

tff(pred_def_42298,type,
    v79093: state_type > $o ).

tff(pred_def_42299,type,
    v79091: state_type > $o ).

tff(pred_def_42300,type,
    v79097: state_type > $o ).

tff(pred_def_42301,type,
    v79095: state_type > $o ).

tff(pred_def_42302,type,
    v79099: state_type > $o ).

tff(pred_def_42303,type,
    v79085: state_type > $o ).

tff(pred_def_42304,type,
    v79083: state_type > $o ).

tff(pred_def_42305,type,
    v79107: state_type > $o ).

tff(pred_def_42306,type,
    v79105: state_type > $o ).

tff(pred_def_42307,type,
    v79111: state_type > $o ).

tff(pred_def_42308,type,
    v79109: state_type > $o ).

tff(pred_def_42309,type,
    v79103: state_type > $o ).

tff(pred_def_42310,type,
    v79101: state_type > $o ).

tff(pred_def_42311,type,
    v79049: ( state_type * $int ) > $o ).

tff(pred_def_42312,type,
    v79047: ( state_type * $int ) > $o ).

tff(pred_def_42313,type,
    v79045: ( state_type * $int ) > $o ).

tff(pred_def_42314,type,
    v79039: state_type > $o ).

tff(pred_def_42315,type,
    v79037: state_type > $o ).

tff(pred_def_42316,type,
    v79035: state_type > $o ).

tff(pred_def_42317,type,
    v79033: state_type > $o ).

tff(pred_def_42318,type,
    v79031: state_type > $o ).

tff(pred_def_42319,type,
    v79025: state_type > $o ).

tff(pred_def_42320,type,
    v79023: state_type > $o ).

tff(pred_def_42321,type,
    v79021: state_type > $o ).

tff(pred_def_42322,type,
    v79124: state_type > $o ).

tff(pred_def_42323,type,
    v79122: state_type > $o ).

tff(pred_def_42324,type,
    v79138: ( state_type * $int ) > $o ).

tff(pred_def_42325,type,
    v79136: ( state_type * $int ) > $o ).

tff(pred_def_42326,type,
    v79162: state_type > $o ).

tff(pred_def_42327,type,
    v79160: state_type > $o ).

tff(pred_def_42328,type,
    v79158: state_type > $o ).

tff(pred_def_42329,type,
    v79156: state_type > $o ).

tff(pred_def_42330,type,
    v79153: state_type > $o ).

tff(pred_def_42331,type,
    v79151: state_type > $o ).

tff(pred_def_42332,type,
    v79149: state_type > $o ).

tff(pred_def_42333,type,
    v79147: state_type > $o ).

tff(pred_def_42334,type,
    v79180: state_type > $o ).

tff(pred_def_42335,type,
    v79178: state_type > $o ).

tff(pred_def_42336,type,
    v79176: state_type > $o ).

tff(pred_def_42337,type,
    v79174: state_type > $o ).

tff(pred_def_42338,type,
    v79171: state_type > $o ).

tff(pred_def_42339,type,
    v79169: state_type > $o ).

tff(pred_def_42340,type,
    v79194: state_type > $o ).

tff(pred_def_42341,type,
    v79192: state_type > $o ).

tff(pred_def_42342,type,
    v79190: state_type > $o ).

tff(pred_def_42343,type,
    v79188: state_type > $o ).

tff(pred_def_42344,type,
    v79185: state_type > $o ).

tff(pred_def_42345,type,
    v79183: state_type > $o ).

tff(pred_def_42346,type,
    v79167: state_type > $o ).

tff(pred_def_42347,type,
    v79165: state_type > $o ).

tff(pred_def_42348,type,
    v79204: state_type > $o ).

tff(pred_def_42349,type,
    v79202: state_type > $o ).

tff(pred_def_42350,type,
    v79217: state_type > $o ).

tff(pred_def_42351,type,
    v79215: state_type > $o ).

tff(pred_def_42352,type,
    v79213: state_type > $o ).

tff(pred_def_42353,type,
    v79211: state_type > $o ).

tff(pred_def_42354,type,
    v79208: state_type > $o ).

tff(pred_def_42355,type,
    v79206: state_type > $o ).

tff(pred_def_42356,type,
    v79200: state_type > $o ).

tff(pred_def_42357,type,
    v79198: state_type > $o ).

tff(pred_def_42358,type,
    v79227: state_type > $o ).

tff(pred_def_42359,type,
    v79225: state_type > $o ).

tff(pred_def_42360,type,
    v79223: state_type > $o ).

tff(pred_def_42361,type,
    v79221: state_type > $o ).

tff(pred_def_42362,type,
    v79144: ( state_type * $int ) > $o ).

tff(pred_def_42363,type,
    v79142: ( state_type * $int ) > $o ).

tff(pred_def_42364,type,
    v79140: ( state_type * $int ) > $o ).

tff(pred_def_42365,type,
    v79134: state_type > $o ).

tff(pred_def_42366,type,
    v79132: state_type > $o ).

tff(pred_def_42367,type,
    v79130: state_type > $o ).

tff(pred_def_42368,type,
    v79128: state_type > $o ).

tff(pred_def_42369,type,
    v79126: state_type > $o ).

tff(pred_def_42370,type,
    v79120: state_type > $o ).

tff(pred_def_42371,type,
    v79118: state_type > $o ).

tff(pred_def_42372,type,
    v79116: state_type > $o ).

tff(pred_def_42373,type,
    v79239: state_type > $o ).

tff(pred_def_42374,type,
    v79237: state_type > $o ).

tff(pred_def_42375,type,
    v79253: ( state_type * $int ) > $o ).

tff(pred_def_42376,type,
    v79251: ( state_type * $int ) > $o ).

tff(pred_def_42377,type,
    v79268: state_type > $o ).

tff(pred_def_42378,type,
    v79266: state_type > $o ).

tff(pred_def_42379,type,
    v79272: state_type > $o ).

tff(pred_def_42380,type,
    v79270: state_type > $o ).

tff(pred_def_42381,type,
    v79264: state_type > $o ).

tff(pred_def_42382,type,
    v79262: state_type > $o ).

tff(pred_def_42383,type,
    v79281: state_type > $o ).

tff(pred_def_42384,type,
    v79279: state_type > $o ).

tff(pred_def_42385,type,
    v79285: state_type > $o ).

tff(pred_def_42386,type,
    v79283: state_type > $o ).

tff(pred_def_42387,type,
    v79277: state_type > $o ).

tff(pred_def_42388,type,
    v79275: state_type > $o ).

tff(pred_def_42389,type,
    v79294: state_type > $o ).

tff(pred_def_42390,type,
    v79292: state_type > $o ).

tff(pred_def_42391,type,
    v79298: state_type > $o ).

tff(pred_def_42392,type,
    v79296: state_type > $o ).

tff(pred_def_42393,type,
    v79302: state_type > $o ).

tff(pred_def_42394,type,
    v79300: state_type > $o ).

tff(pred_def_42395,type,
    v79304: state_type > $o ).

tff(pred_def_42396,type,
    v79290: state_type > $o ).

tff(pred_def_42397,type,
    v79288: state_type > $o ).

tff(pred_def_42398,type,
    v79312: state_type > $o ).

tff(pred_def_42399,type,
    v79310: state_type > $o ).

tff(pred_def_42400,type,
    v79316: state_type > $o ).

tff(pred_def_42401,type,
    v79314: state_type > $o ).

tff(pred_def_42402,type,
    v79308: state_type > $o ).

tff(pred_def_42403,type,
    v79306: state_type > $o ).

tff(pred_def_42404,type,
    v79259: ( state_type * $int ) > $o ).

tff(pred_def_42405,type,
    v79257: ( state_type * $int ) > $o ).

tff(pred_def_42406,type,
    v79255: ( state_type * $int ) > $o ).

tff(pred_def_42407,type,
    v79249: state_type > $o ).

tff(pred_def_42408,type,
    v79247: state_type > $o ).

tff(pred_def_42409,type,
    v79245: state_type > $o ).

tff(pred_def_42410,type,
    v79243: state_type > $o ).

tff(pred_def_42411,type,
    v79241: state_type > $o ).

tff(pred_def_42412,type,
    v79235: state_type > $o ).

tff(pred_def_42413,type,
    v79233: state_type > $o ).

tff(pred_def_42414,type,
    v79231: state_type > $o ).

tff(pred_def_42415,type,
    v79329: state_type > $o ).

tff(pred_def_42416,type,
    v79327: state_type > $o ).

tff(pred_def_42417,type,
    v79343: ( state_type * $int ) > $o ).

tff(pred_def_42418,type,
    v79341: ( state_type * $int ) > $o ).

tff(pred_def_42419,type,
    v79358: state_type > $o ).

tff(pred_def_42420,type,
    v79356: state_type > $o ).

tff(pred_def_42421,type,
    v79354: state_type > $o ).

tff(pred_def_42422,type,
    v79352: state_type > $o ).

tff(pred_def_42423,type,
    v79366: state_type > $o ).

tff(pred_def_42424,type,
    v79364: state_type > $o ).

tff(pred_def_42425,type,
    v79362: state_type > $o ).

tff(pred_def_42426,type,
    v79360: state_type > $o ).

tff(pred_def_42427,type,
    v79374: state_type > $o ).

tff(pred_def_42428,type,
    v79372: state_type > $o ).

tff(pred_def_42429,type,
    v79378: state_type > $o ).

tff(pred_def_42430,type,
    v79376: state_type > $o ).

tff(pred_def_42431,type,
    v79370: state_type > $o ).

tff(pred_def_42432,type,
    v79368: state_type > $o ).

tff(pred_def_42433,type,
    v79387: state_type > $o ).

tff(pred_def_42434,type,
    v79385: state_type > $o ).

tff(pred_def_42435,type,
    v79383: state_type > $o ).

tff(pred_def_42436,type,
    v79381: state_type > $o ).

tff(pred_def_42437,type,
    v79349: ( state_type * $int ) > $o ).

tff(pred_def_42438,type,
    v79347: ( state_type * $int ) > $o ).

tff(pred_def_42439,type,
    v79345: ( state_type * $int ) > $o ).

tff(pred_def_42440,type,
    v79339: state_type > $o ).

tff(pred_def_42441,type,
    v79337: state_type > $o ).

tff(pred_def_42442,type,
    v79335: state_type > $o ).

tff(pred_def_42443,type,
    v79333: state_type > $o ).

tff(pred_def_42444,type,
    v79331: state_type > $o ).

tff(pred_def_42445,type,
    v79325: state_type > $o ).

tff(pred_def_42446,type,
    v79323: state_type > $o ).

tff(pred_def_42447,type,
    v79321: state_type > $o ).

tff(pred_def_42448,type,
    v79399: state_type > $o ).

tff(pred_def_42449,type,
    v79397: state_type > $o ).

tff(pred_def_42450,type,
    v79413: ( state_type * $int ) > $o ).

tff(pred_def_42451,type,
    v79411: ( state_type * $int ) > $o ).

tff(pred_def_42452,type,
    v79417: ( state_type * $int ) > $o ).

tff(pred_def_42453,type,
    v79415: ( state_type * $int ) > $o ).

tff(pred_def_42454,type,
    v79409: state_type > $o ).

tff(pred_def_42455,type,
    v79407: state_type > $o ).

tff(pred_def_42456,type,
    v79405: state_type > $o ).

tff(pred_def_42457,type,
    v79403: state_type > $o ).

tff(pred_def_42458,type,
    v79401: state_type > $o ).

tff(pred_def_42459,type,
    v79395: state_type > $o ).

tff(pred_def_42460,type,
    v79393: state_type > $o ).

tff(pred_def_42461,type,
    v79391: state_type > $o ).

tff(pred_def_42462,type,
    v79421: ( state_type * $int ) > $o ).

tff(pred_def_42463,type,
    v79420: ( state_type * $int ) > $o ).

tff(pred_def_42464,type,
    v79422: state_type > $o ).

tff(pred_def_42465,type,
    v79423: state_type > $o ).

tff(pred_def_42466,type,
    v79424: state_type > $o ).

tff(pred_def_42467,type,
    v79425: state_type > $o ).

tff(pred_def_42468,type,
    v79426: state_type > $o ).

tff(pred_def_42469,type,
    v79427: state_type > $o ).

tff(pred_def_42470,type,
    v79428: state_type > $o ).

tff(pred_def_42471,type,
    v79429: state_type > $o ).

tff(pred_def_42472,type,
    v79430: state_type > $o ).

tff(pred_def_42473,type,
    v79431: state_type > $o ).

tff(pred_def_42474,type,
    v79432: state_type > $o ).

tff(pred_def_42475,type,
    v79433: state_type > $o ).

tff(pred_def_42476,type,
    v79434: state_type > $o ).

tff(pred_def_42477,type,
    v79435: state_type > $o ).

tff(pred_def_42478,type,
    v79436: state_type > $o ).

tff(pred_def_42479,type,
    v79437: state_type > $o ).

tff(pred_def_42480,type,
    v79438: state_type > $o ).

tff(pred_def_42481,type,
    v77770: ( state_type * $int ) > $o ).

tff(pred_def_42482,type,
    v77768: ( state_type * $int ) > $o ).

tff(pred_def_42483,type,
    v77766: ( state_type * $int ) > $o ).

tff(pred_def_42484,type,
    v79465: state_type > $o ).

tff(pred_def_42485,type,
    v79463: state_type > $o ).

tff(pred_def_42486,type,
    v79469: state_type > $o ).

tff(pred_def_42487,type,
    v79467: state_type > $o ).

tff(pred_def_42488,type,
    v79461: state_type > $o ).

tff(pred_def_42489,type,
    v79459: state_type > $o ).

tff(pred_def_42490,type,
    v79457: state_type > $o ).

tff(pred_def_42491,type,
    v79455: state_type > $o ).

tff(pred_def_42492,type,
    v79453: state_type > $o ).

tff(pred_def_42493,type,
    v79484: ( state_type * $int ) > $o ).

tff(pred_def_42494,type,
    v79482: ( state_type * $int ) > $o ).

tff(pred_def_42495,type,
    v79488: ( state_type * $int ) > $o ).

tff(pred_def_42496,type,
    v79486: ( state_type * $int ) > $o ).

tff(pred_def_42497,type,
    v79480: state_type > $o ).

tff(pred_def_42498,type,
    v79478: state_type > $o ).

tff(pred_def_42499,type,
    v79476: state_type > $o ).

tff(pred_def_42500,type,
    v79474: state_type > $o ).

tff(pred_def_42501,type,
    v79472: state_type > $o ).

tff(pred_def_42502,type,
    v79451: state_type > $o ).

tff(pred_def_42503,type,
    v79449: state_type > $o ).

tff(pred_def_42504,type,
    v79447: state_type > $o ).

tff(pred_def_42505,type,
    v79500: state_type > $o ).

tff(pred_def_42506,type,
    v79498: state_type > $o ).

tff(pred_def_42507,type,
    v79514: ( state_type * $int ) > $o ).

tff(pred_def_42508,type,
    v79512: ( state_type * $int ) > $o ).

tff(pred_def_42509,type,
    v79518: ( state_type * $int ) > $o ).

tff(pred_def_42510,type,
    v79516: ( state_type * $int ) > $o ).

tff(pred_def_42511,type,
    v79510: state_type > $o ).

tff(pred_def_42512,type,
    v79508: state_type > $o ).

tff(pred_def_42513,type,
    v79506: state_type > $o ).

tff(pred_def_42514,type,
    v79504: state_type > $o ).

tff(pred_def_42515,type,
    v79502: state_type > $o ).

tff(pred_def_42516,type,
    v79496: state_type > $o ).

tff(pred_def_42517,type,
    v79494: state_type > $o ).

tff(pred_def_42518,type,
    v79492: state_type > $o ).

tff(pred_def_42519,type,
    v79530: state_type > $o ).

tff(pred_def_42520,type,
    v79528: state_type > $o ).

tff(pred_def_42521,type,
    v79544: ( state_type * $int ) > $o ).

tff(pred_def_42522,type,
    v79542: ( state_type * $int ) > $o ).

tff(pred_def_42523,type,
    v79548: ( state_type * $int ) > $o ).

tff(pred_def_42524,type,
    v79546: ( state_type * $int ) > $o ).

tff(pred_def_42525,type,
    v79540: state_type > $o ).

tff(pred_def_42526,type,
    v79538: state_type > $o ).

tff(pred_def_42527,type,
    v79536: state_type > $o ).

tff(pred_def_42528,type,
    v79534: state_type > $o ).

tff(pred_def_42529,type,
    v79532: state_type > $o ).

tff(pred_def_42530,type,
    v79526: state_type > $o ).

tff(pred_def_42531,type,
    v79524: state_type > $o ).

tff(pred_def_42532,type,
    v79522: state_type > $o ).

tff(pred_def_42533,type,
    v79560: state_type > $o ).

tff(pred_def_42534,type,
    v79558: state_type > $o ).

tff(pred_def_42535,type,
    v79574: ( state_type * $int ) > $o ).

tff(pred_def_42536,type,
    v79572: ( state_type * $int ) > $o ).

tff(pred_def_42537,type,
    v79578: ( state_type * $int ) > $o ).

tff(pred_def_42538,type,
    v79576: ( state_type * $int ) > $o ).

tff(pred_def_42539,type,
    v79570: state_type > $o ).

tff(pred_def_42540,type,
    v79568: state_type > $o ).

tff(pred_def_42541,type,
    v79566: state_type > $o ).

tff(pred_def_42542,type,
    v79564: state_type > $o ).

tff(pred_def_42543,type,
    v79562: state_type > $o ).

tff(pred_def_42544,type,
    v79556: state_type > $o ).

tff(pred_def_42545,type,
    v79554: state_type > $o ).

tff(pred_def_42546,type,
    v79552: state_type > $o ).

tff(pred_def_42547,type,
    v79590: state_type > $o ).

tff(pred_def_42548,type,
    v79588: state_type > $o ).

tff(pred_def_42549,type,
    v79604: ( state_type * $int ) > $o ).

tff(pred_def_42550,type,
    v79602: ( state_type * $int ) > $o ).

tff(pred_def_42551,type,
    v79608: ( state_type * $int ) > $o ).

tff(pred_def_42552,type,
    v79606: ( state_type * $int ) > $o ).

tff(pred_def_42553,type,
    v79600: state_type > $o ).

tff(pred_def_42554,type,
    v79598: state_type > $o ).

tff(pred_def_42555,type,
    v79596: state_type > $o ).

tff(pred_def_42556,type,
    v79594: state_type > $o ).

tff(pred_def_42557,type,
    v79592: state_type > $o ).

tff(pred_def_42558,type,
    v79586: state_type > $o ).

tff(pred_def_42559,type,
    v79584: state_type > $o ).

tff(pred_def_42560,type,
    v79582: state_type > $o ).

tff(pred_def_42561,type,
    v79620: state_type > $o ).

tff(pred_def_42562,type,
    v79618: state_type > $o ).

tff(pred_def_42563,type,
    v79634: ( state_type * $int ) > $o ).

tff(pred_def_42564,type,
    v79632: ( state_type * $int ) > $o ).

tff(pred_def_42565,type,
    v79638: ( state_type * $int ) > $o ).

tff(pred_def_42566,type,
    v79636: ( state_type * $int ) > $o ).

tff(pred_def_42567,type,
    v79630: state_type > $o ).

tff(pred_def_42568,type,
    v79628: state_type > $o ).

tff(pred_def_42569,type,
    v79626: state_type > $o ).

tff(pred_def_42570,type,
    v79624: state_type > $o ).

tff(pred_def_42571,type,
    v79622: state_type > $o ).

tff(pred_def_42572,type,
    v79616: state_type > $o ).

tff(pred_def_42573,type,
    v79614: state_type > $o ).

tff(pred_def_42574,type,
    v79612: state_type > $o ).

tff(pred_def_42575,type,
    v79650: state_type > $o ).

tff(pred_def_42576,type,
    v79648: state_type > $o ).

tff(pred_def_42577,type,
    v79664: ( state_type * $int ) > $o ).

tff(pred_def_42578,type,
    v79662: ( state_type * $int ) > $o ).

tff(pred_def_42579,type,
    v79668: ( state_type * $int ) > $o ).

tff(pred_def_42580,type,
    v79666: ( state_type * $int ) > $o ).

tff(pred_def_42581,type,
    v79660: state_type > $o ).

tff(pred_def_42582,type,
    v79658: state_type > $o ).

tff(pred_def_42583,type,
    v79656: state_type > $o ).

tff(pred_def_42584,type,
    v79654: state_type > $o ).

tff(pred_def_42585,type,
    v79652: state_type > $o ).

tff(pred_def_42586,type,
    v79646: state_type > $o ).

tff(pred_def_42587,type,
    v79644: state_type > $o ).

tff(pred_def_42588,type,
    v79642: state_type > $o ).

tff(pred_def_42589,type,
    v79680: state_type > $o ).

tff(pred_def_42590,type,
    v79678: state_type > $o ).

tff(pred_def_42591,type,
    v79694: ( state_type * $int ) > $o ).

tff(pred_def_42592,type,
    v79692: ( state_type * $int ) > $o ).

tff(pred_def_42593,type,
    v79698: ( state_type * $int ) > $o ).

tff(pred_def_42594,type,
    v79696: ( state_type * $int ) > $o ).

tff(pred_def_42595,type,
    v79690: state_type > $o ).

tff(pred_def_42596,type,
    v79688: state_type > $o ).

tff(pred_def_42597,type,
    v79686: state_type > $o ).

tff(pred_def_42598,type,
    v79684: state_type > $o ).

tff(pred_def_42599,type,
    v79682: state_type > $o ).

tff(pred_def_42600,type,
    v79676: state_type > $o ).

tff(pred_def_42601,type,
    v79674: state_type > $o ).

tff(pred_def_42602,type,
    v79672: state_type > $o ).

tff(pred_def_42603,type,
    v79710: state_type > $o ).

tff(pred_def_42604,type,
    v79708: state_type > $o ).

tff(pred_def_42605,type,
    v79724: ( state_type * $int ) > $o ).

tff(pred_def_42606,type,
    v79722: ( state_type * $int ) > $o ).

tff(pred_def_42607,type,
    v79728: ( state_type * $int ) > $o ).

tff(pred_def_42608,type,
    v79726: ( state_type * $int ) > $o ).

tff(pred_def_42609,type,
    v79720: state_type > $o ).

tff(pred_def_42610,type,
    v79718: state_type > $o ).

tff(pred_def_42611,type,
    v79716: state_type > $o ).

tff(pred_def_42612,type,
    v79714: state_type > $o ).

tff(pred_def_42613,type,
    v79712: state_type > $o ).

tff(pred_def_42614,type,
    v79706: state_type > $o ).

tff(pred_def_42615,type,
    v79704: state_type > $o ).

tff(pred_def_42616,type,
    v79702: state_type > $o ).

tff(pred_def_42617,type,
    v79740: state_type > $o ).

tff(pred_def_42618,type,
    v79738: state_type > $o ).

tff(pred_def_42619,type,
    v79754: ( state_type * $int ) > $o ).

tff(pred_def_42620,type,
    v79752: ( state_type * $int ) > $o ).

tff(pred_def_42621,type,
    v79758: ( state_type * $int ) > $o ).

tff(pred_def_42622,type,
    v79756: ( state_type * $int ) > $o ).

tff(pred_def_42623,type,
    v79750: state_type > $o ).

tff(pred_def_42624,type,
    v79748: state_type > $o ).

tff(pred_def_42625,type,
    v79746: state_type > $o ).

tff(pred_def_42626,type,
    v79744: state_type > $o ).

tff(pred_def_42627,type,
    v79742: state_type > $o ).

tff(pred_def_42628,type,
    v79736: state_type > $o ).

tff(pred_def_42629,type,
    v79734: state_type > $o ).

tff(pred_def_42630,type,
    v79732: state_type > $o ).

tff(pred_def_42631,type,
    v79770: state_type > $o ).

tff(pred_def_42632,type,
    v79768: state_type > $o ).

tff(pred_def_42633,type,
    v79784: ( state_type * $int ) > $o ).

tff(pred_def_42634,type,
    v79782: ( state_type * $int ) > $o ).

tff(pred_def_42635,type,
    v79788: ( state_type * $int ) > $o ).

tff(pred_def_42636,type,
    v79786: ( state_type * $int ) > $o ).

tff(pred_def_42637,type,
    v79780: state_type > $o ).

tff(pred_def_42638,type,
    v79778: state_type > $o ).

tff(pred_def_42639,type,
    v79776: state_type > $o ).

tff(pred_def_42640,type,
    v79774: state_type > $o ).

tff(pred_def_42641,type,
    v79772: state_type > $o ).

tff(pred_def_42642,type,
    v79766: state_type > $o ).

tff(pred_def_42643,type,
    v79764: state_type > $o ).

tff(pred_def_42644,type,
    v79762: state_type > $o ).

tff(pred_def_42645,type,
    v79800: state_type > $o ).

tff(pred_def_42646,type,
    v79798: state_type > $o ).

tff(pred_def_42647,type,
    v79814: ( state_type * $int ) > $o ).

tff(pred_def_42648,type,
    v79812: ( state_type * $int ) > $o ).

tff(pred_def_42649,type,
    v79818: ( state_type * $int ) > $o ).

tff(pred_def_42650,type,
    v79816: ( state_type * $int ) > $o ).

tff(pred_def_42651,type,
    v79810: state_type > $o ).

tff(pred_def_42652,type,
    v79808: state_type > $o ).

tff(pred_def_42653,type,
    v79806: state_type > $o ).

tff(pred_def_42654,type,
    v79804: state_type > $o ).

tff(pred_def_42655,type,
    v79802: state_type > $o ).

tff(pred_def_42656,type,
    v79796: state_type > $o ).

tff(pred_def_42657,type,
    v79794: state_type > $o ).

tff(pred_def_42658,type,
    v79792: state_type > $o ).

tff(pred_def_42659,type,
    v79830: state_type > $o ).

tff(pred_def_42660,type,
    v79828: state_type > $o ).

tff(pred_def_42661,type,
    v79844: ( state_type * $int ) > $o ).

tff(pred_def_42662,type,
    v79842: ( state_type * $int ) > $o ).

tff(pred_def_42663,type,
    v79848: ( state_type * $int ) > $o ).

tff(pred_def_42664,type,
    v79846: ( state_type * $int ) > $o ).

tff(pred_def_42665,type,
    v79840: state_type > $o ).

tff(pred_def_42666,type,
    v79838: state_type > $o ).

tff(pred_def_42667,type,
    v79836: state_type > $o ).

tff(pred_def_42668,type,
    v79834: state_type > $o ).

tff(pred_def_42669,type,
    v79832: state_type > $o ).

tff(pred_def_42670,type,
    v79826: state_type > $o ).

tff(pred_def_42671,type,
    v79824: state_type > $o ).

tff(pred_def_42672,type,
    v79822: state_type > $o ).

tff(pred_def_42673,type,
    v79860: state_type > $o ).

tff(pred_def_42674,type,
    v79858: state_type > $o ).

tff(pred_def_42675,type,
    v79874: ( state_type * $int ) > $o ).

tff(pred_def_42676,type,
    v79872: ( state_type * $int ) > $o ).

tff(pred_def_42677,type,
    v79878: ( state_type * $int ) > $o ).

tff(pred_def_42678,type,
    v79876: ( state_type * $int ) > $o ).

tff(pred_def_42679,type,
    v79870: state_type > $o ).

tff(pred_def_42680,type,
    v79868: state_type > $o ).

tff(pred_def_42681,type,
    v79866: state_type > $o ).

tff(pred_def_42682,type,
    v79864: state_type > $o ).

tff(pred_def_42683,type,
    v79862: state_type > $o ).

tff(pred_def_42684,type,
    v79856: state_type > $o ).

tff(pred_def_42685,type,
    v79854: state_type > $o ).

tff(pred_def_42686,type,
    v79852: state_type > $o ).

tff(pred_def_42687,type,
    v79890: state_type > $o ).

tff(pred_def_42688,type,
    v79888: state_type > $o ).

tff(pred_def_42689,type,
    v79904: ( state_type * $int ) > $o ).

tff(pred_def_42690,type,
    v79902: ( state_type * $int ) > $o ).

tff(pred_def_42691,type,
    v79908: ( state_type * $int ) > $o ).

tff(pred_def_42692,type,
    v79906: ( state_type * $int ) > $o ).

tff(pred_def_42693,type,
    v79900: state_type > $o ).

tff(pred_def_42694,type,
    v79898: state_type > $o ).

tff(pred_def_42695,type,
    v79896: state_type > $o ).

tff(pred_def_42696,type,
    v79894: state_type > $o ).

tff(pred_def_42697,type,
    v79892: state_type > $o ).

tff(pred_def_42698,type,
    v79886: state_type > $o ).

tff(pred_def_42699,type,
    v79884: state_type > $o ).

tff(pred_def_42700,type,
    v79882: state_type > $o ).

tff(pred_def_42701,type,
    v79445: ( state_type * $int ) > $o ).

tff(pred_def_42702,type,
    v79443: ( state_type * $int ) > $o ).

tff(pred_def_42703,type,
    v79441: ( state_type * $int ) > $o ).

tff(pred_def_42704,type,
    v77764: state_type > $o ).

tff(pred_def_42705,type,
    v77762: state_type > $o ).

tff(pred_def_42706,type,
    v77760: state_type > $o ).

tff(pred_def_42707,type,
    v77758: state_type > $o ).

tff(pred_def_42708,type,
    v77756: state_type > $o ).

tff(pred_def_42709,type,
    v77754: state_type > $o ).

tff(pred_def_42710,type,
    v77752: state_type > $o ).

tff(pred_def_42711,type,
    v77750: state_type > $o ).

tff(pred_def_42712,type,
    v77748: state_type > $o ).

tff(pred_def_42713,type,
    v77746: state_type > $o ).

tff(pred_def_42714,type,
    v77702: state_type > $o ).

tff(pred_def_42715,type,
    v77700: state_type > $o ).

tff(pred_def_42716,type,
    v77698: state_type > $o ).

tff(pred_def_42717,type,
    v77696: state_type > $o ).

tff(pred_def_42718,type,
    v77694: state_type > $o ).

tff(pred_def_42719,type,
    v79945: state_type > $o ).

tff(pred_def_42720,type,
    v79943: state_type > $o ).

tff(pred_def_42721,type,
    v79949: state_type > $o ).

tff(pred_def_42722,type,
    v79947: state_type > $o ).

tff(pred_def_42723,type,
    v79953: state_type > $o ).

tff(pred_def_42724,type,
    v79951: state_type > $o ).

tff(pred_def_42725,type,
    v79957: state_type > $o ).

tff(pred_def_42726,type,
    v79955: state_type > $o ).

tff(pred_def_42727,type,
    v79961: state_type > $o ).

tff(pred_def_42728,type,
    v79960: state_type > $o ).

tff(pred_def_42729,type,
    v79959: state_type > $o ).

tff(pred_def_42730,type,
    v79941: state_type > $o ).

tff(pred_def_42731,type,
    v79939: state_type > $o ).

tff(pred_def_42732,type,
    v79937: state_type > $o ).

tff(pred_def_42733,type,
    v79935: state_type > $o ).

tff(pred_def_42734,type,
    v79965: state_type > $o ).

tff(pred_def_42735,type,
    v79963: state_type > $o ).

tff(pred_def_42736,type,
    v79967: state_type > $o ).

tff(pred_def_42737,type,
    v79933: state_type > $o ).

tff(pred_def_42738,type,
    v79931: state_type > $o ).

tff(pred_def_42739,type,
    v79929: state_type > $o ).

tff(pred_def_42740,type,
    v79927: state_type > $o ).

tff(pred_def_42741,type,
    v80010: state_type > $o ).

tff(pred_def_42742,type,
    v80008: state_type > $o ).

tff(pred_def_42743,type,
    v80014: state_type > $o ).

tff(pred_def_42744,type,
    v80012: state_type > $o ).

tff(pred_def_42745,type,
    v80006: state_type > $o ).

tff(pred_def_42746,type,
    v80004: state_type > $o ).

tff(pred_def_42747,type,
    v80002: state_type > $o ).

tff(pred_def_42748,type,
    v80000: state_type > $o ).

tff(pred_def_42749,type,
    v79998: state_type > $o ).

tff(pred_def_42750,type,
    v80029: ( state_type * $int ) > $o ).

tff(pred_def_42751,type,
    v80027: ( state_type * $int ) > $o ).

tff(pred_def_42752,type,
    v80072: state_type > $o ).

tff(pred_def_42753,type,
    v80070: state_type > $o ).

tff(pred_def_42754,type,
    v80068: state_type > $o ).

tff(pred_def_42755,type,
    v80066: state_type > $o ).

tff(pred_def_42756,type,
    v80064: state_type > $o ).

tff(pred_def_42757,type,
    v80062: state_type > $o ).

tff(pred_def_42758,type,
    v80060: state_type > $o ).

tff(pred_def_42759,type,
    v80058: state_type > $o ).

tff(pred_def_42760,type,
    v80056: state_type > $o ).

tff(pred_def_42761,type,
    v80053: state_type > $o ).

tff(pred_def_42762,type,
    v80051: state_type > $o ).

tff(pred_def_42763,type,
    v80097: state_type > $o ).

tff(pred_def_42764,type,
    v80095: state_type > $o ).

tff(pred_def_42765,type,
    v80093: state_type > $o ).

tff(pred_def_42766,type,
    v80091: state_type > $o ).

tff(pred_def_42767,type,
    v80089: state_type > $o ).

tff(pred_def_42768,type,
    v80087: state_type > $o ).

tff(pred_def_42769,type,
    v80085: state_type > $o ).

tff(pred_def_42770,type,
    v80083: state_type > $o ).

tff(pred_def_42771,type,
    v80081: state_type > $o ).

tff(pred_def_42772,type,
    v80078: state_type > $o ).

tff(pred_def_42773,type,
    v80076: state_type > $o ).

tff(pred_def_42774,type,
    v80122: state_type > $o ).

tff(pred_def_42775,type,
    v80120: state_type > $o ).

tff(pred_def_42776,type,
    v80118: state_type > $o ).

tff(pred_def_42777,type,
    v80116: state_type > $o ).

tff(pred_def_42778,type,
    v80114: state_type > $o ).

tff(pred_def_42779,type,
    v80112: state_type > $o ).

tff(pred_def_42780,type,
    v80110: state_type > $o ).

tff(pred_def_42781,type,
    v80108: state_type > $o ).

tff(pred_def_42782,type,
    v80106: state_type > $o ).

tff(pred_def_42783,type,
    v80103: state_type > $o ).

tff(pred_def_42784,type,
    v80101: state_type > $o ).

tff(pred_def_42785,type,
    v80126: state_type > $o ).

tff(pred_def_42786,type,
    v80049: state_type > $o ).

tff(pred_def_42787,type,
    v80047: state_type > $o ).

tff(pred_def_42788,type,
    v80134: state_type > $o ).

tff(pred_def_42789,type,
    v80132: state_type > $o ).

tff(pred_def_42790,type,
    v80138: state_type > $o ).

tff(pred_def_42791,type,
    v80136: state_type > $o ).

tff(pred_def_42792,type,
    v80130: state_type > $o ).

tff(pred_def_42793,type,
    v80128: state_type > $o ).

tff(pred_def_42794,type,
    v80147: state_type > $o ).

tff(pred_def_42795,type,
    v80145: state_type > $o ).

tff(pred_def_42796,type,
    v80143: state_type > $o ).

tff(pred_def_42797,type,
    v80141: state_type > $o ).

tff(pred_def_42798,type,
    v80165: state_type > $o ).

tff(pred_def_42799,type,
    v80163: state_type > $o ).

tff(pred_def_42800,type,
    v80169: state_type > $o ).

tff(pred_def_42801,type,
    v80167: state_type > $o ).

tff(pred_def_42802,type,
    v80173: state_type > $o ).

tff(pred_def_42803,type,
    v80171: state_type > $o ).

tff(pred_def_42804,type,
    v80175: state_type > $o ).

tff(pred_def_42805,type,
    v80161: state_type > $o ).

tff(pred_def_42806,type,
    v80159: state_type > $o ).

tff(pred_def_42807,type,
    v80157: state_type > $o ).

tff(pred_def_42808,type,
    v80155: state_type > $o ).

tff(pred_def_42809,type,
    v80153: state_type > $o ).

tff(pred_def_42810,type,
    v80198: state_type > $o ).

tff(pred_def_42811,type,
    v80196: state_type > $o ).

tff(pred_def_42812,type,
    v80194: state_type > $o ).

tff(pred_def_42813,type,
    v80192: state_type > $o ).

tff(pred_def_42814,type,
    v80190: state_type > $o ).

tff(pred_def_42815,type,
    v80188: state_type > $o ).

tff(pred_def_42816,type,
    v80186: state_type > $o ).

tff(pred_def_42817,type,
    v80184: state_type > $o ).

tff(pred_def_42818,type,
    v80182: state_type > $o ).

tff(pred_def_42819,type,
    v80179: state_type > $o ).

tff(pred_def_42820,type,
    v80177: state_type > $o ).

tff(pred_def_42821,type,
    v80151: state_type > $o ).

tff(pred_def_42822,type,
    v80149: state_type > $o ).

tff(pred_def_42823,type,
    v80045: ( state_type * $int ) > $o ).

tff(pred_def_42824,type,
    v80202: ( state_type * $int ) > $o ).

tff(pred_def_42825,type,
    v80203: ( state_type * $int ) > $o ).

tff(pred_def_42826,type,
    v80204: ( state_type * $int ) > $o ).

tff(pred_def_42827,type,
    v80205: ( state_type * $int ) > $o ).

tff(pred_def_42828,type,
    v80206: ( state_type * $int ) > $o ).

tff(pred_def_42829,type,
    v80207: ( state_type * $int ) > $o ).

tff(pred_def_42830,type,
    v80208: ( state_type * $int ) > $o ).

tff(pred_def_42831,type,
    v80209: ( state_type * $int ) > $o ).

tff(pred_def_42832,type,
    v80210: ( state_type * $int ) > $o ).

tff(pred_def_42833,type,
    v80211: ( state_type * $int ) > $o ).

tff(pred_def_42834,type,
    v80212: ( state_type * $int ) > $o ).

tff(pred_def_42835,type,
    v80213: ( state_type * $int ) > $o ).

tff(pred_def_42836,type,
    v80214: ( state_type * $int ) > $o ).

tff(pred_def_42837,type,
    v80215: ( state_type * $int ) > $o ).

tff(pred_def_42838,type,
    v80043: ( state_type * $int ) > $o ).

tff(pred_def_42839,type,
    v80041: ( state_type * $int ) > $o ).

tff(pred_def_42840,type,
    v80039: ( state_type * $int ) > $o ).

tff(pred_def_42841,type,
    v80037: ( state_type * $int ) > $o ).

tff(pred_def_42842,type,
    v80035: ( state_type * $int ) > $o ).

tff(pred_def_42843,type,
    v80033: ( state_type * $int ) > $o ).

tff(pred_def_42844,type,
    v80031: ( state_type * $int ) > $o ).

tff(pred_def_42845,type,
    v80025: state_type > $o ).

tff(pred_def_42846,type,
    v80023: state_type > $o ).

tff(pred_def_42847,type,
    v80021: state_type > $o ).

tff(pred_def_42848,type,
    v80019: state_type > $o ).

tff(pred_def_42849,type,
    v80017: state_type > $o ).

tff(pred_def_42850,type,
    v79996: state_type > $o ).

tff(pred_def_42851,type,
    v79994: state_type > $o ).

tff(pred_def_42852,type,
    v80226: state_type > $o ).

tff(pred_def_42853,type,
    v80224: state_type > $o ).

tff(pred_def_42854,type,
    v80240: ( state_type * $int ) > $o ).

tff(pred_def_42855,type,
    v80238: ( state_type * $int ) > $o ).

tff(pred_def_42856,type,
    v80265: state_type > $o ).

tff(pred_def_42857,type,
    v80263: state_type > $o ).

tff(pred_def_42858,type,
    v80269: state_type > $o ).

tff(pred_def_42859,type,
    v80267: state_type > $o ).

tff(pred_def_42860,type,
    v80273: state_type > $o ).

tff(pred_def_42861,type,
    v80271: state_type > $o ).

tff(pred_def_42862,type,
    v80275: state_type > $o ).

tff(pred_def_42863,type,
    v80261: state_type > $o ).

tff(pred_def_42864,type,
    v80259: state_type > $o ).

tff(pred_def_42865,type,
    v80257: state_type > $o ).

tff(pred_def_42866,type,
    v80255: state_type > $o ).

tff(pred_def_42867,type,
    v80253: state_type > $o ).

tff(pred_def_42868,type,
    v80279: state_type > $o ).

tff(pred_def_42869,type,
    v80277: state_type > $o ).

tff(pred_def_42870,type,
    v80251: state_type > $o ).

tff(pred_def_42871,type,
    v80249: state_type > $o ).

tff(pred_def_42872,type,
    v80288: state_type > $o ).

tff(pred_def_42873,type,
    v80286: state_type > $o ).

tff(pred_def_42874,type,
    v80292: state_type > $o ).

tff(pred_def_42875,type,
    v80290: state_type > $o ).

tff(pred_def_42876,type,
    v80296: state_type > $o ).

tff(pred_def_42877,type,
    v80294: state_type > $o ).

tff(pred_def_42878,type,
    v80298: state_type > $o ).

tff(pred_def_42879,type,
    v80284: state_type > $o ).

tff(pred_def_42880,type,
    v80282: state_type > $o ).

tff(pred_def_42881,type,
    v80306: state_type > $o ).

tff(pred_def_42882,type,
    v80304: state_type > $o ).

tff(pred_def_42883,type,
    v80310: state_type > $o ).

tff(pred_def_42884,type,
    v80308: state_type > $o ).

tff(pred_def_42885,type,
    v80302: state_type > $o ).

tff(pred_def_42886,type,
    v80300: state_type > $o ).

tff(pred_def_42887,type,
    v80319: state_type > $o ).

tff(pred_def_42888,type,
    v80317: state_type > $o ).

tff(pred_def_42889,type,
    v80323: state_type > $o ).

tff(pred_def_42890,type,
    v80321: state_type > $o ).

tff(pred_def_42891,type,
    v80327: state_type > $o ).

tff(pred_def_42892,type,
    v80325: state_type > $o ).

tff(pred_def_42893,type,
    v80329: state_type > $o ).

tff(pred_def_42894,type,
    v80315: state_type > $o ).

tff(pred_def_42895,type,
    v80313: state_type > $o ).

tff(pred_def_42896,type,
    v80246: ( state_type * $int ) > $o ).

tff(pred_def_42897,type,
    v80244: ( state_type * $int ) > $o ).

tff(pred_def_42898,type,
    v80242: ( state_type * $int ) > $o ).

tff(pred_def_42899,type,
    v80236: state_type > $o ).

tff(pred_def_42900,type,
    v80234: state_type > $o ).

tff(pred_def_42901,type,
    v80232: state_type > $o ).

tff(pred_def_42902,type,
    v80230: state_type > $o ).

tff(pred_def_42903,type,
    v80228: state_type > $o ).

tff(pred_def_42904,type,
    v80222: state_type > $o ).

tff(pred_def_42905,type,
    v80220: state_type > $o ).

tff(pred_def_42906,type,
    v80340: state_type > $o ).

tff(pred_def_42907,type,
    v80338: state_type > $o ).

tff(pred_def_42908,type,
    v80354: ( state_type * $int ) > $o ).

tff(pred_def_42909,type,
    v80352: ( state_type * $int ) > $o ).

tff(pred_def_42910,type,
    v80378: state_type > $o ).

tff(pred_def_42911,type,
    v80376: state_type > $o ).

tff(pred_def_42912,type,
    v80374: state_type > $o ).

tff(pred_def_42913,type,
    v80372: state_type > $o ).

tff(pred_def_42914,type,
    v80369: state_type > $o ).

tff(pred_def_42915,type,
    v80367: state_type > $o ).

tff(pred_def_42916,type,
    v80392: state_type > $o ).

tff(pred_def_42917,type,
    v80390: state_type > $o ).

tff(pred_def_42918,type,
    v80388: state_type > $o ).

tff(pred_def_42919,type,
    v80386: state_type > $o ).

tff(pred_def_42920,type,
    v80383: state_type > $o ).

tff(pred_def_42921,type,
    v80381: state_type > $o ).

tff(pred_def_42922,type,
    v80365: state_type > $o ).

tff(pred_def_42923,type,
    v80363: state_type > $o ).

tff(pred_def_42924,type,
    v80402: state_type > $o ).

tff(pred_def_42925,type,
    v80400: state_type > $o ).

tff(pred_def_42926,type,
    v80398: state_type > $o ).

tff(pred_def_42927,type,
    v80396: state_type > $o ).

tff(pred_def_42928,type,
    v80419: state_type > $o ).

tff(pred_def_42929,type,
    v80417: state_type > $o ).

tff(pred_def_42930,type,
    v80415: state_type > $o ).

tff(pred_def_42931,type,
    v80413: state_type > $o ).

tff(pred_def_42932,type,
    v80410: state_type > $o ).

tff(pred_def_42933,type,
    v80408: state_type > $o ).

tff(pred_def_42934,type,
    v80406: state_type > $o ).

tff(pred_def_42935,type,
    v80404: state_type > $o ).

tff(pred_def_42936,type,
    v80428: state_type > $o ).

tff(pred_def_42937,type,
    v80426: state_type > $o ).

tff(pred_def_42938,type,
    v80432: state_type > $o ).

tff(pred_def_42939,type,
    v80430: state_type > $o ).

tff(pred_def_42940,type,
    v80445: state_type > $o ).

tff(pred_def_42941,type,
    v80443: state_type > $o ).

tff(pred_def_42942,type,
    v80441: state_type > $o ).

tff(pred_def_42943,type,
    v80439: state_type > $o ).

tff(pred_def_42944,type,
    v80436: state_type > $o ).

tff(pred_def_42945,type,
    v80434: state_type > $o ).

tff(pred_def_42946,type,
    v80448: state_type > $o ).

tff(pred_def_42947,type,
    v80424: state_type > $o ).

tff(pred_def_42948,type,
    v80422: state_type > $o ).

tff(pred_def_42949,type,
    v80360: ( state_type * $int ) > $o ).

tff(pred_def_42950,type,
    v80358: ( state_type * $int ) > $o ).

tff(pred_def_42951,type,
    v80356: ( state_type * $int ) > $o ).

tff(pred_def_42952,type,
    v80350: state_type > $o ).

tff(pred_def_42953,type,
    v80348: state_type > $o ).

tff(pred_def_42954,type,
    v80346: state_type > $o ).

tff(pred_def_42955,type,
    v80344: state_type > $o ).

tff(pred_def_42956,type,
    v80342: state_type > $o ).

tff(pred_def_42957,type,
    v80336: state_type > $o ).

tff(pred_def_42958,type,
    v80334: state_type > $o ).

tff(pred_def_42959,type,
    v80459: state_type > $o ).

tff(pred_def_42960,type,
    v80457: state_type > $o ).

tff(pred_def_42961,type,
    v80473: ( state_type * $int ) > $o ).

tff(pred_def_42962,type,
    v80471: ( state_type * $int ) > $o ).

tff(pred_def_42963,type,
    v80488: state_type > $o ).

tff(pred_def_42964,type,
    v80486: state_type > $o ).

tff(pred_def_42965,type,
    v80492: state_type > $o ).

tff(pred_def_42966,type,
    v80490: state_type > $o ).

tff(pred_def_42967,type,
    v80496: state_type > $o ).

tff(pred_def_42968,type,
    v80494: state_type > $o ).

tff(pred_def_42969,type,
    v80498: state_type > $o ).

tff(pred_def_42970,type,
    v80484: state_type > $o ).

tff(pred_def_42971,type,
    v80482: state_type > $o ).

tff(pred_def_42972,type,
    v80506: state_type > $o ).

tff(pred_def_42973,type,
    v80504: state_type > $o ).

tff(pred_def_42974,type,
    v80510: state_type > $o ).

tff(pred_def_42975,type,
    v80508: state_type > $o ).

tff(pred_def_42976,type,
    v80502: state_type > $o ).

tff(pred_def_42977,type,
    v80500: state_type > $o ).

tff(pred_def_42978,type,
    v80519: state_type > $o ).

tff(pred_def_42979,type,
    v80517: state_type > $o ).

tff(pred_def_42980,type,
    v80523: state_type > $o ).

tff(pred_def_42981,type,
    v80521: state_type > $o ).

tff(pred_def_42982,type,
    v80515: state_type > $o ).

tff(pred_def_42983,type,
    v80513: state_type > $o ).

tff(pred_def_42984,type,
    v80532: state_type > $o ).

tff(pred_def_42985,type,
    v80530: state_type > $o ).

tff(pred_def_42986,type,
    v80536: state_type > $o ).

tff(pred_def_42987,type,
    v80534: state_type > $o ).

tff(pred_def_42988,type,
    v80528: state_type > $o ).

tff(pred_def_42989,type,
    v80526: state_type > $o ).

tff(pred_def_42990,type,
    v80479: ( state_type * $int ) > $o ).

tff(pred_def_42991,type,
    v80477: ( state_type * $int ) > $o ).

tff(pred_def_42992,type,
    v80475: ( state_type * $int ) > $o ).

tff(pred_def_42993,type,
    v80469: state_type > $o ).

tff(pred_def_42994,type,
    v80467: state_type > $o ).

tff(pred_def_42995,type,
    v80465: state_type > $o ).

tff(pred_def_42996,type,
    v80463: state_type > $o ).

tff(pred_def_42997,type,
    v80461: state_type > $o ).

tff(pred_def_42998,type,
    v80455: state_type > $o ).

tff(pred_def_42999,type,
    v80453: state_type > $o ).

tff(pred_def_43000,type,
    v80548: state_type > $o ).

tff(pred_def_43001,type,
    v80546: state_type > $o ).

tff(pred_def_43002,type,
    v80562: ( state_type * $int ) > $o ).

tff(pred_def_43003,type,
    v80560: ( state_type * $int ) > $o ).

tff(pred_def_43004,type,
    v80577: state_type > $o ).

tff(pred_def_43005,type,
    v80575: state_type > $o ).

tff(pred_def_43006,type,
    v80581: state_type > $o ).

tff(pred_def_43007,type,
    v80579: state_type > $o ).

tff(pred_def_43008,type,
    v80573: state_type > $o ).

tff(pred_def_43009,type,
    v80571: state_type > $o ).

tff(pred_def_43010,type,
    v80590: state_type > $o ).

tff(pred_def_43011,type,
    v80588: state_type > $o ).

tff(pred_def_43012,type,
    v80594: state_type > $o ).

tff(pred_def_43013,type,
    v80592: state_type > $o ).

tff(pred_def_43014,type,
    v80586: state_type > $o ).

tff(pred_def_43015,type,
    v80584: state_type > $o ).

tff(pred_def_43016,type,
    v80603: state_type > $o ).

tff(pred_def_43017,type,
    v80601: state_type > $o ).

tff(pred_def_43018,type,
    v80607: state_type > $o ).

tff(pred_def_43019,type,
    v80605: state_type > $o ).

tff(pred_def_43020,type,
    v80611: state_type > $o ).

tff(pred_def_43021,type,
    v80609: state_type > $o ).

tff(pred_def_43022,type,
    v80613: state_type > $o ).

tff(pred_def_43023,type,
    v80599: state_type > $o ).

tff(pred_def_43024,type,
    v80597: state_type > $o ).

tff(pred_def_43025,type,
    v80621: state_type > $o ).

tff(pred_def_43026,type,
    v80619: state_type > $o ).

tff(pred_def_43027,type,
    v80625: state_type > $o ).

tff(pred_def_43028,type,
    v80623: state_type > $o ).

tff(pred_def_43029,type,
    v80629: state_type > $o ).

tff(pred_def_43030,type,
    v80627: state_type > $o ).

tff(pred_def_43031,type,
    v80631: state_type > $o ).

tff(pred_def_43032,type,
    v80617: state_type > $o ).

tff(pred_def_43033,type,
    v80615: state_type > $o ).

tff(pred_def_43034,type,
    v80568: ( state_type * $int ) > $o ).

tff(pred_def_43035,type,
    v80566: ( state_type * $int ) > $o ).

tff(pred_def_43036,type,
    v80564: ( state_type * $int ) > $o ).

tff(pred_def_43037,type,
    v80558: state_type > $o ).

tff(pred_def_43038,type,
    v80556: state_type > $o ).

tff(pred_def_43039,type,
    v80554: state_type > $o ).

tff(pred_def_43040,type,
    v80552: state_type > $o ).

tff(pred_def_43041,type,
    v80550: state_type > $o ).

tff(pred_def_43042,type,
    v80544: state_type > $o ).

tff(pred_def_43043,type,
    v80542: state_type > $o ).

tff(pred_def_43044,type,
    v80642: state_type > $o ).

tff(pred_def_43045,type,
    v80640: state_type > $o ).

tff(pred_def_43046,type,
    v80656: ( state_type * $int ) > $o ).

tff(pred_def_43047,type,
    v80654: ( state_type * $int ) > $o ).

tff(pred_def_43048,type,
    v80671: state_type > $o ).

tff(pred_def_43049,type,
    v80669: state_type > $o ).

tff(pred_def_43050,type,
    v80675: state_type > $o ).

tff(pred_def_43051,type,
    v80673: state_type > $o ).

tff(pred_def_43052,type,
    v80679: state_type > $o ).

tff(pred_def_43053,type,
    v80677: state_type > $o ).

tff(pred_def_43054,type,
    v80681: state_type > $o ).

tff(pred_def_43055,type,
    v80667: state_type > $o ).

tff(pred_def_43056,type,
    v80665: state_type > $o ).

tff(pred_def_43057,type,
    v80689: state_type > $o ).

tff(pred_def_43058,type,
    v80687: state_type > $o ).

tff(pred_def_43059,type,
    v80693: state_type > $o ).

tff(pred_def_43060,type,
    v80691: state_type > $o ).

tff(pred_def_43061,type,
    v80697: state_type > $o ).

tff(pred_def_43062,type,
    v80695: state_type > $o ).

tff(pred_def_43063,type,
    v80699: state_type > $o ).

tff(pred_def_43064,type,
    v80685: state_type > $o ).

tff(pred_def_43065,type,
    v80683: state_type > $o ).

tff(pred_def_43066,type,
    v80717: state_type > $o ).

tff(pred_def_43067,type,
    v80715: state_type > $o ).

tff(pred_def_43068,type,
    v80721: state_type > $o ).

tff(pred_def_43069,type,
    v80719: state_type > $o ).

tff(pred_def_43070,type,
    v80725: state_type > $o ).

tff(pred_def_43071,type,
    v80723: state_type > $o ).

tff(pred_def_43072,type,
    v80727: state_type > $o ).

tff(pred_def_43073,type,
    v80713: state_type > $o ).

tff(pred_def_43074,type,
    v80711: state_type > $o ).

tff(pred_def_43075,type,
    v80709: state_type > $o ).

tff(pred_def_43076,type,
    v80707: state_type > $o ).

tff(pred_def_43077,type,
    v80705: state_type > $o ).

tff(pred_def_43078,type,
    v80731: state_type > $o ).

tff(pred_def_43079,type,
    v80729: state_type > $o ).

tff(pred_def_43080,type,
    v80703: state_type > $o ).

tff(pred_def_43081,type,
    v80701: state_type > $o ).

tff(pred_def_43082,type,
    v80740: state_type > $o ).

tff(pred_def_43083,type,
    v80738: state_type > $o ).

tff(pred_def_43084,type,
    v80744: state_type > $o ).

tff(pred_def_43085,type,
    v80742: state_type > $o ).

tff(pred_def_43086,type,
    v80736: state_type > $o ).

tff(pred_def_43087,type,
    v80734: state_type > $o ).

tff(pred_def_43088,type,
    v80662: ( state_type * $int ) > $o ).

tff(pred_def_43089,type,
    v80660: ( state_type * $int ) > $o ).

tff(pred_def_43090,type,
    v80658: ( state_type * $int ) > $o ).

tff(pred_def_43091,type,
    v80652: state_type > $o ).

tff(pred_def_43092,type,
    v80650: state_type > $o ).

tff(pred_def_43093,type,
    v80648: state_type > $o ).

tff(pred_def_43094,type,
    v80646: state_type > $o ).

tff(pred_def_43095,type,
    v80644: state_type > $o ).

tff(pred_def_43096,type,
    v80638: state_type > $o ).

tff(pred_def_43097,type,
    v80636: state_type > $o ).

tff(pred_def_43098,type,
    v80756: state_type > $o ).

tff(pred_def_43099,type,
    v80754: state_type > $o ).

tff(pred_def_43100,type,
    v80770: ( state_type * $int ) > $o ).

tff(pred_def_43101,type,
    v80768: ( state_type * $int ) > $o ).

tff(pred_def_43102,type,
    v80794: state_type > $o ).

tff(pred_def_43103,type,
    v80792: state_type > $o ).

tff(pred_def_43104,type,
    v80790: state_type > $o ).

tff(pred_def_43105,type,
    v80788: state_type > $o ).

tff(pred_def_43106,type,
    v80785: state_type > $o ).

tff(pred_def_43107,type,
    v80783: state_type > $o ).

tff(pred_def_43108,type,
    v80781: state_type > $o ).

tff(pred_def_43109,type,
    v80779: state_type > $o ).

tff(pred_def_43110,type,
    v80812: state_type > $o ).

tff(pred_def_43111,type,
    v80810: state_type > $o ).

tff(pred_def_43112,type,
    v80808: state_type > $o ).

tff(pred_def_43113,type,
    v80806: state_type > $o ).

tff(pred_def_43114,type,
    v80803: state_type > $o ).

tff(pred_def_43115,type,
    v80801: state_type > $o ).

tff(pred_def_43116,type,
    v80799: state_type > $o ).

tff(pred_def_43117,type,
    v80797: state_type > $o ).

tff(pred_def_43118,type,
    v80830: state_type > $o ).

tff(pred_def_43119,type,
    v80828: state_type > $o ).

tff(pred_def_43120,type,
    v80826: state_type > $o ).

tff(pred_def_43121,type,
    v80824: state_type > $o ).

tff(pred_def_43122,type,
    v80821: state_type > $o ).

tff(pred_def_43123,type,
    v80819: state_type > $o ).

tff(pred_def_43124,type,
    v80817: state_type > $o ).

tff(pred_def_43125,type,
    v80815: state_type > $o ).

tff(pred_def_43126,type,
    v80839: state_type > $o ).

tff(pred_def_43127,type,
    v80837: state_type > $o ).

tff(pred_def_43128,type,
    v80852: state_type > $o ).

tff(pred_def_43129,type,
    v80850: state_type > $o ).

tff(pred_def_43130,type,
    v80848: state_type > $o ).

tff(pred_def_43131,type,
    v80846: state_type > $o ).

tff(pred_def_43132,type,
    v80843: state_type > $o ).

tff(pred_def_43133,type,
    v80841: state_type > $o ).

tff(pred_def_43134,type,
    v80835: state_type > $o ).

tff(pred_def_43135,type,
    v80833: state_type > $o ).

tff(pred_def_43136,type,
    v80776: ( state_type * $int ) > $o ).

tff(pred_def_43137,type,
    v80774: ( state_type * $int ) > $o ).

tff(pred_def_43138,type,
    v80772: ( state_type * $int ) > $o ).

tff(pred_def_43139,type,
    v80766: state_type > $o ).

tff(pred_def_43140,type,
    v80764: state_type > $o ).

tff(pred_def_43141,type,
    v80762: state_type > $o ).

tff(pred_def_43142,type,
    v80760: state_type > $o ).

tff(pred_def_43143,type,
    v80758: state_type > $o ).

tff(pred_def_43144,type,
    v80752: state_type > $o ).

tff(pred_def_43145,type,
    v80750: state_type > $o ).

tff(pred_def_43146,type,
    v80865: state_type > $o ).

tff(pred_def_43147,type,
    v80863: state_type > $o ).

tff(pred_def_43148,type,
    v80879: ( state_type * $int ) > $o ).

tff(pred_def_43149,type,
    v80877: ( state_type * $int ) > $o ).

tff(pred_def_43150,type,
    v80894: state_type > $o ).

tff(pred_def_43151,type,
    v80892: state_type > $o ).

tff(pred_def_43152,type,
    v80898: state_type > $o ).

tff(pred_def_43153,type,
    v80896: state_type > $o ).

tff(pred_def_43154,type,
    v80890: state_type > $o ).

tff(pred_def_43155,type,
    v80888: state_type > $o ).

tff(pred_def_43156,type,
    v80907: state_type > $o ).

tff(pred_def_43157,type,
    v80905: state_type > $o ).

tff(pred_def_43158,type,
    v80911: state_type > $o ).

tff(pred_def_43159,type,
    v80909: state_type > $o ).

tff(pred_def_43160,type,
    v80903: state_type > $o ).

tff(pred_def_43161,type,
    v80901: state_type > $o ).

tff(pred_def_43162,type,
    v80920: state_type > $o ).

tff(pred_def_43163,type,
    v80918: state_type > $o ).

tff(pred_def_43164,type,
    v80924: state_type > $o ).

tff(pred_def_43165,type,
    v80922: state_type > $o ).

tff(pred_def_43166,type,
    v80916: state_type > $o ).

tff(pred_def_43167,type,
    v80914: state_type > $o ).

tff(pred_def_43168,type,
    v80933: state_type > $o ).

tff(pred_def_43169,type,
    v80931: state_type > $o ).

tff(pred_def_43170,type,
    v80929: state_type > $o ).

tff(pred_def_43171,type,
    v80927: state_type > $o ).

tff(pred_def_43172,type,
    v80885: ( state_type * $int ) > $o ).

tff(pred_def_43173,type,
    v80883: ( state_type * $int ) > $o ).

tff(pred_def_43174,type,
    v80881: ( state_type * $int ) > $o ).

tff(pred_def_43175,type,
    v80875: state_type > $o ).

tff(pred_def_43176,type,
    v80873: state_type > $o ).

tff(pred_def_43177,type,
    v80871: state_type > $o ).

tff(pred_def_43178,type,
    v80869: state_type > $o ).

tff(pred_def_43179,type,
    v80867: state_type > $o ).

tff(pred_def_43180,type,
    v80861: state_type > $o ).

tff(pred_def_43181,type,
    v80859: state_type > $o ).

tff(pred_def_43182,type,
    v80944: state_type > $o ).

tff(pred_def_43183,type,
    v80942: state_type > $o ).

tff(pred_def_43184,type,
    v80958: ( state_type * $int ) > $o ).

tff(pred_def_43185,type,
    v80956: ( state_type * $int ) > $o ).

tff(pred_def_43186,type,
    v80973: state_type > $o ).

tff(pred_def_43187,type,
    v80971: state_type > $o ).

tff(pred_def_43188,type,
    v80977: state_type > $o ).

tff(pred_def_43189,type,
    v80975: state_type > $o ).

tff(pred_def_43190,type,
    v80981: state_type > $o ).

tff(pred_def_43191,type,
    v80979: state_type > $o ).

tff(pred_def_43192,type,
    v80983: state_type > $o ).

tff(pred_def_43193,type,
    v80969: state_type > $o ).

tff(pred_def_43194,type,
    v80967: state_type > $o ).

tff(pred_def_43195,type,
    v81001: state_type > $o ).

tff(pred_def_43196,type,
    v80999: state_type > $o ).

tff(pred_def_43197,type,
    v81005: state_type > $o ).

tff(pred_def_43198,type,
    v81003: state_type > $o ).

tff(pred_def_43199,type,
    v81009: state_type > $o ).

tff(pred_def_43200,type,
    v81007: state_type > $o ).

tff(pred_def_43201,type,
    v81011: state_type > $o ).

tff(pred_def_43202,type,
    v80997: state_type > $o ).

tff(pred_def_43203,type,
    v80995: state_type > $o ).

tff(pred_def_43204,type,
    v80993: state_type > $o ).

tff(pred_def_43205,type,
    v80991: state_type > $o ).

tff(pred_def_43206,type,
    v80989: state_type > $o ).

tff(pred_def_43207,type,
    v81015: state_type > $o ).

tff(pred_def_43208,type,
    v81013: state_type > $o ).

tff(pred_def_43209,type,
    v80987: state_type > $o ).

tff(pred_def_43210,type,
    v80985: state_type > $o ).

tff(pred_def_43211,type,
    v81024: state_type > $o ).

tff(pred_def_43212,type,
    v81022: state_type > $o ).

tff(pred_def_43213,type,
    v81028: state_type > $o ).

tff(pred_def_43214,type,
    v81026: state_type > $o ).

tff(pred_def_43215,type,
    v81032: state_type > $o ).

tff(pred_def_43216,type,
    v81030: state_type > $o ).

tff(pred_def_43217,type,
    v81034: state_type > $o ).

tff(pred_def_43218,type,
    v81020: state_type > $o ).

tff(pred_def_43219,type,
    v81018: state_type > $o ).

tff(pred_def_43220,type,
    v81042: state_type > $o ).

tff(pred_def_43221,type,
    v81040: state_type > $o ).

tff(pred_def_43222,type,
    v81046: state_type > $o ).

tff(pred_def_43223,type,
    v81044: state_type > $o ).

tff(pred_def_43224,type,
    v81050: state_type > $o ).

tff(pred_def_43225,type,
    v81048: state_type > $o ).

tff(pred_def_43226,type,
    v81052: state_type > $o ).

tff(pred_def_43227,type,
    v81038: state_type > $o ).

tff(pred_def_43228,type,
    v81036: state_type > $o ).

tff(pred_def_43229,type,
    v80964: ( state_type * $int ) > $o ).

tff(pred_def_43230,type,
    v80962: ( state_type * $int ) > $o ).

tff(pred_def_43231,type,
    v80960: ( state_type * $int ) > $o ).

tff(pred_def_43232,type,
    v80954: state_type > $o ).

tff(pred_def_43233,type,
    v80952: state_type > $o ).

tff(pred_def_43234,type,
    v80950: state_type > $o ).

tff(pred_def_43235,type,
    v80948: state_type > $o ).

tff(pred_def_43236,type,
    v80946: state_type > $o ).

tff(pred_def_43237,type,
    v80940: state_type > $o ).

tff(pred_def_43238,type,
    v80938: state_type > $o ).

tff(pred_def_43239,type,
    v81063: state_type > $o ).

tff(pred_def_43240,type,
    v81061: state_type > $o ).

tff(pred_def_43241,type,
    v81077: ( state_type * $int ) > $o ).

tff(pred_def_43242,type,
    v81075: ( state_type * $int ) > $o ).

tff(pred_def_43243,type,
    v81092: state_type > $o ).

tff(pred_def_43244,type,
    v81090: state_type > $o ).

tff(pred_def_43245,type,
    v81096: state_type > $o ).

tff(pred_def_43246,type,
    v81094: state_type > $o ).

tff(pred_def_43247,type,
    v81088: state_type > $o ).

tff(pred_def_43248,type,
    v81086: state_type > $o ).

tff(pred_def_43249,type,
    v81105: state_type > $o ).

tff(pred_def_43250,type,
    v81103: state_type > $o ).

tff(pred_def_43251,type,
    v81109: state_type > $o ).

tff(pred_def_43252,type,
    v81107: state_type > $o ).

tff(pred_def_43253,type,
    v81113: state_type > $o ).

tff(pred_def_43254,type,
    v81111: state_type > $o ).

tff(pred_def_43255,type,
    v81115: state_type > $o ).

tff(pred_def_43256,type,
    v81101: state_type > $o ).

tff(pred_def_43257,type,
    v81099: state_type > $o ).

tff(pred_def_43258,type,
    v81123: state_type > $o ).

tff(pred_def_43259,type,
    v81121: state_type > $o ).

tff(pred_def_43260,type,
    v81127: state_type > $o ).

tff(pred_def_43261,type,
    v81125: state_type > $o ).

tff(pred_def_43262,type,
    v81119: state_type > $o ).

tff(pred_def_43263,type,
    v81117: state_type > $o ).

tff(pred_def_43264,type,
    v81136: state_type > $o ).

tff(pred_def_43265,type,
    v81134: state_type > $o ).

tff(pred_def_43266,type,
    v81140: state_type > $o ).

tff(pred_def_43267,type,
    v81138: state_type > $o ).

tff(pred_def_43268,type,
    v81132: state_type > $o ).

tff(pred_def_43269,type,
    v81130: state_type > $o ).

tff(pred_def_43270,type,
    v81083: ( state_type * $int ) > $o ).

tff(pred_def_43271,type,
    v81081: ( state_type * $int ) > $o ).

tff(pred_def_43272,type,
    v81079: ( state_type * $int ) > $o ).

tff(pred_def_43273,type,
    v81073: state_type > $o ).

tff(pred_def_43274,type,
    v81071: state_type > $o ).

tff(pred_def_43275,type,
    v81069: state_type > $o ).

tff(pred_def_43276,type,
    v81067: state_type > $o ).

tff(pred_def_43277,type,
    v81065: state_type > $o ).

tff(pred_def_43278,type,
    v81059: state_type > $o ).

tff(pred_def_43279,type,
    v81057: state_type > $o ).

tff(pred_def_43280,type,
    v81152: state_type > $o ).

tff(pred_def_43281,type,
    v81150: state_type > $o ).

tff(pred_def_43282,type,
    v81166: ( state_type * $int ) > $o ).

tff(pred_def_43283,type,
    v81164: ( state_type * $int ) > $o ).

tff(pred_def_43284,type,
    v81190: state_type > $o ).

tff(pred_def_43285,type,
    v81188: state_type > $o ).

tff(pred_def_43286,type,
    v81186: state_type > $o ).

tff(pred_def_43287,type,
    v81184: state_type > $o ).

tff(pred_def_43288,type,
    v81181: state_type > $o ).

tff(pred_def_43289,type,
    v81179: state_type > $o ).

tff(pred_def_43290,type,
    v81204: state_type > $o ).

tff(pred_def_43291,type,
    v81202: state_type > $o ).

tff(pred_def_43292,type,
    v81200: state_type > $o ).

tff(pred_def_43293,type,
    v81198: state_type > $o ).

tff(pred_def_43294,type,
    v81195: state_type > $o ).

tff(pred_def_43295,type,
    v81193: state_type > $o ).

tff(pred_def_43296,type,
    v81177: state_type > $o ).

tff(pred_def_43297,type,
    v81175: state_type > $o ).

tff(pred_def_43298,type,
    v81223: state_type > $o ).

tff(pred_def_43299,type,
    v81221: state_type > $o ).

tff(pred_def_43300,type,
    v81219: state_type > $o ).

tff(pred_def_43301,type,
    v81217: state_type > $o ).

tff(pred_def_43302,type,
    v81214: state_type > $o ).

tff(pred_def_43303,type,
    v81212: state_type > $o ).

tff(pred_def_43304,type,
    v81237: state_type > $o ).

tff(pred_def_43305,type,
    v81235: state_type > $o ).

tff(pred_def_43306,type,
    v81233: state_type > $o ).

tff(pred_def_43307,type,
    v81231: state_type > $o ).

tff(pred_def_43308,type,
    v81228: state_type > $o ).

tff(pred_def_43309,type,
    v81226: state_type > $o ).

tff(pred_def_43310,type,
    v81242: state_type > $o ).

tff(pred_def_43311,type,
    v81240: state_type > $o ).

tff(pred_def_43312,type,
    v81244: state_type > $o ).

tff(pred_def_43313,type,
    v81210: state_type > $o ).

tff(pred_def_43314,type,
    v81208: state_type > $o ).

tff(pred_def_43315,type,
    v81252: state_type > $o ).

tff(pred_def_43316,type,
    v81250: state_type > $o ).

tff(pred_def_43317,type,
    v81256: state_type > $o ).

tff(pred_def_43318,type,
    v81254: state_type > $o ).

tff(pred_def_43319,type,
    v81260: state_type > $o ).

tff(pred_def_43320,type,
    v81258: state_type > $o ).

tff(pred_def_43321,type,
    v81262: state_type > $o ).

tff(pred_def_43322,type,
    v81248: state_type > $o ).

tff(pred_def_43323,type,
    v81246: state_type > $o ).

tff(pred_def_43324,type,
    v81270: state_type > $o ).

tff(pred_def_43325,type,
    v81268: state_type > $o ).

tff(pred_def_43326,type,
    v81274: state_type > $o ).

tff(pred_def_43327,type,
    v81272: state_type > $o ).

tff(pred_def_43328,type,
    v81266: state_type > $o ).

tff(pred_def_43329,type,
    v81264: state_type > $o ).

tff(pred_def_43330,type,
    v81172: ( state_type * $int ) > $o ).

tff(pred_def_43331,type,
    v81170: ( state_type * $int ) > $o ).

tff(pred_def_43332,type,
    v81168: ( state_type * $int ) > $o ).

tff(pred_def_43333,type,
    v81162: state_type > $o ).

tff(pred_def_43334,type,
    v81160: state_type > $o ).

tff(pred_def_43335,type,
    v81158: state_type > $o ).

tff(pred_def_43336,type,
    v81156: state_type > $o ).

tff(pred_def_43337,type,
    v81154: state_type > $o ).

tff(pred_def_43338,type,
    v81148: state_type > $o ).

tff(pred_def_43339,type,
    v81146: state_type > $o ).

tff(pred_def_43340,type,
    v81286: state_type > $o ).

tff(pred_def_43341,type,
    v81284: state_type > $o ).

tff(pred_def_43342,type,
    v81300: ( state_type * $int ) > $o ).

tff(pred_def_43343,type,
    v81298: ( state_type * $int ) > $o ).

tff(pred_def_43344,type,
    v81315: state_type > $o ).

tff(pred_def_43345,type,
    v81313: state_type > $o ).

tff(pred_def_43346,type,
    v81311: state_type > $o ).

tff(pred_def_43347,type,
    v81309: state_type > $o ).

tff(pred_def_43348,type,
    v81323: state_type > $o ).

tff(pred_def_43349,type,
    v81321: state_type > $o ).

tff(pred_def_43350,type,
    v81327: state_type > $o ).

tff(pred_def_43351,type,
    v81325: state_type > $o ).

tff(pred_def_43352,type,
    v81319: state_type > $o ).

tff(pred_def_43353,type,
    v81317: state_type > $o ).

tff(pred_def_43354,type,
    v81336: state_type > $o ).

tff(pred_def_43355,type,
    v81334: state_type > $o ).

tff(pred_def_43356,type,
    v81340: state_type > $o ).

tff(pred_def_43357,type,
    v81338: state_type > $o ).

tff(pred_def_43358,type,
    v81332: state_type > $o ).

tff(pred_def_43359,type,
    v81330: state_type > $o ).

tff(pred_def_43360,type,
    v81349: state_type > $o ).

tff(pred_def_43361,type,
    v81347: state_type > $o ).

tff(pred_def_43362,type,
    v81345: state_type > $o ).

tff(pred_def_43363,type,
    v81343: state_type > $o ).

tff(pred_def_43364,type,
    v81306: ( state_type * $int ) > $o ).

tff(pred_def_43365,type,
    v81304: ( state_type * $int ) > $o ).

tff(pred_def_43366,type,
    v81302: ( state_type * $int ) > $o ).

tff(pred_def_43367,type,
    v81296: state_type > $o ).

tff(pred_def_43368,type,
    v81294: state_type > $o ).

tff(pred_def_43369,type,
    v81292: state_type > $o ).

tff(pred_def_43370,type,
    v81290: state_type > $o ).

tff(pred_def_43371,type,
    v81288: state_type > $o ).

tff(pred_def_43372,type,
    v81282: state_type > $o ).

tff(pred_def_43373,type,
    v81280: state_type > $o ).

tff(pred_def_43374,type,
    v81360: state_type > $o ).

tff(pred_def_43375,type,
    v81358: state_type > $o ).

tff(pred_def_43376,type,
    v81374: ( state_type * $int ) > $o ).

tff(pred_def_43377,type,
    v81372: ( state_type * $int ) > $o ).

tff(pred_def_43378,type,
    v81389: state_type > $o ).

tff(pred_def_43379,type,
    v81387: state_type > $o ).

tff(pred_def_43380,type,
    v81393: state_type > $o ).

tff(pred_def_43381,type,
    v81391: state_type > $o ).

tff(pred_def_43382,type,
    v81385: state_type > $o ).

tff(pred_def_43383,type,
    v81383: state_type > $o ).

tff(pred_def_43384,type,
    v81402: state_type > $o ).

tff(pred_def_43385,type,
    v81400: state_type > $o ).

tff(pred_def_43386,type,
    v81406: state_type > $o ).

tff(pred_def_43387,type,
    v81404: state_type > $o ).

tff(pred_def_43388,type,
    v81398: state_type > $o ).

tff(pred_def_43389,type,
    v81396: state_type > $o ).

tff(pred_def_43390,type,
    v81415: state_type > $o ).

tff(pred_def_43391,type,
    v81413: state_type > $o ).

tff(pred_def_43392,type,
    v81419: state_type > $o ).

tff(pred_def_43393,type,
    v81417: state_type > $o ).

tff(pred_def_43394,type,
    v81423: state_type > $o ).

tff(pred_def_43395,type,
    v81421: state_type > $o ).

tff(pred_def_43396,type,
    v81425: state_type > $o ).

tff(pred_def_43397,type,
    v81411: state_type > $o ).

tff(pred_def_43398,type,
    v81409: state_type > $o ).

tff(pred_def_43399,type,
    v81433: state_type > $o ).

tff(pred_def_43400,type,
    v81431: state_type > $o ).

tff(pred_def_43401,type,
    v81437: state_type > $o ).

tff(pred_def_43402,type,
    v81435: state_type > $o ).

tff(pred_def_43403,type,
    v81429: state_type > $o ).

tff(pred_def_43404,type,
    v81427: state_type > $o ).

tff(pred_def_43405,type,
    v81380: ( state_type * $int ) > $o ).

tff(pred_def_43406,type,
    v81378: ( state_type * $int ) > $o ).

tff(pred_def_43407,type,
    v81376: ( state_type * $int ) > $o ).

tff(pred_def_43408,type,
    v81370: state_type > $o ).

tff(pred_def_43409,type,
    v81368: state_type > $o ).

tff(pred_def_43410,type,
    v81366: state_type > $o ).

tff(pred_def_43411,type,
    v81364: state_type > $o ).

tff(pred_def_43412,type,
    v81362: state_type > $o ).

tff(pred_def_43413,type,
    v81356: state_type > $o ).

tff(pred_def_43414,type,
    v81354: state_type > $o ).

tff(pred_def_43415,type,
    v81449: state_type > $o ).

tff(pred_def_43416,type,
    v81447: state_type > $o ).

tff(pred_def_43417,type,
    v81463: ( state_type * $int ) > $o ).

tff(pred_def_43418,type,
    v81461: ( state_type * $int ) > $o ).

tff(pred_def_43419,type,
    v81478: state_type > $o ).

tff(pred_def_43420,type,
    v81476: state_type > $o ).

tff(pred_def_43421,type,
    v81474: state_type > $o ).

tff(pred_def_43422,type,
    v81472: state_type > $o ).

tff(pred_def_43423,type,
    v81486: state_type > $o ).

tff(pred_def_43424,type,
    v81484: state_type > $o ).

tff(pred_def_43425,type,
    v81482: state_type > $o ).

tff(pred_def_43426,type,
    v81480: state_type > $o ).

tff(pred_def_43427,type,
    v81494: state_type > $o ).

tff(pred_def_43428,type,
    v81492: state_type > $o ).

tff(pred_def_43429,type,
    v81498: state_type > $o ).

tff(pred_def_43430,type,
    v81496: state_type > $o ).

tff(pred_def_43431,type,
    v81490: state_type > $o ).

tff(pred_def_43432,type,
    v81488: state_type > $o ).

tff(pred_def_43433,type,
    v81507: state_type > $o ).

tff(pred_def_43434,type,
    v81505: state_type > $o ).

tff(pred_def_43435,type,
    v81503: state_type > $o ).

tff(pred_def_43436,type,
    v81501: state_type > $o ).

tff(pred_def_43437,type,
    v81469: ( state_type * $int ) > $o ).

tff(pred_def_43438,type,
    v81467: ( state_type * $int ) > $o ).

tff(pred_def_43439,type,
    v81465: ( state_type * $int ) > $o ).

tff(pred_def_43440,type,
    v81459: state_type > $o ).

tff(pred_def_43441,type,
    v81457: state_type > $o ).

tff(pred_def_43442,type,
    v81455: state_type > $o ).

tff(pred_def_43443,type,
    v81453: state_type > $o ).

tff(pred_def_43444,type,
    v81451: state_type > $o ).

tff(pred_def_43445,type,
    v81445: state_type > $o ).

tff(pred_def_43446,type,
    v81443: state_type > $o ).

tff(pred_def_43447,type,
    v81518: state_type > $o ).

tff(pred_def_43448,type,
    v81516: state_type > $o ).

tff(pred_def_43449,type,
    v81532: ( state_type * $int ) > $o ).

tff(pred_def_43450,type,
    v81530: ( state_type * $int ) > $o ).

tff(pred_def_43451,type,
    v81536: ( state_type * $int ) > $o ).

tff(pred_def_43452,type,
    v81534: ( state_type * $int ) > $o ).

tff(pred_def_43453,type,
    v81528: state_type > $o ).

tff(pred_def_43454,type,
    v81526: state_type > $o ).

tff(pred_def_43455,type,
    v81524: state_type > $o ).

tff(pred_def_43456,type,
    v81522: state_type > $o ).

tff(pred_def_43457,type,
    v81520: state_type > $o ).

tff(pred_def_43458,type,
    v81514: state_type > $o ).

tff(pred_def_43459,type,
    v81512: state_type > $o ).

tff(pred_def_43460,type,
    v79991: ( state_type * $int ) > $o ).

tff(pred_def_43461,type,
    v79989: ( state_type * $int ) > $o ).

tff(pred_def_43462,type,
    v81565: state_type > $o ).

tff(pred_def_43463,type,
    v81563: state_type > $o ).

tff(pred_def_43464,type,
    v81569: state_type > $o ).

tff(pred_def_43465,type,
    v81567: state_type > $o ).

tff(pred_def_43466,type,
    v81561: state_type > $o ).

tff(pred_def_43467,type,
    v81559: state_type > $o ).

tff(pred_def_43468,type,
    v81557: state_type > $o ).

tff(pred_def_43469,type,
    v81555: state_type > $o ).

tff(pred_def_43470,type,
    v81553: state_type > $o ).

tff(pred_def_43471,type,
    v81574: state_type > $o ).

tff(pred_def_43472,type,
    v81572: state_type > $o ).

tff(pred_def_43473,type,
    v81551: state_type > $o ).

tff(pred_def_43474,type,
    v81549: state_type > $o ).

tff(pred_def_43475,type,
    v81547: state_type > $o ).

tff(pred_def_43476,type,
    v81585: state_type > $o ).

tff(pred_def_43477,type,
    v81583: state_type > $o ).

tff(pred_def_43478,type,
    v81589: state_type > $o ).

tff(pred_def_43479,type,
    v81587: state_type > $o ).

tff(pred_def_43480,type,
    v81581: state_type > $o ).

tff(pred_def_43481,type,
    v81579: state_type > $o ).

tff(pred_def_43482,type,
    v81577: state_type > $o ).

tff(pred_def_43483,type,
    v81600: state_type > $o ).

tff(pred_def_43484,type,
    v81598: state_type > $o ).

tff(pred_def_43485,type,
    v81604: state_type > $o ).

tff(pred_def_43486,type,
    v81602: state_type > $o ).

tff(pred_def_43487,type,
    v81596: state_type > $o ).

tff(pred_def_43488,type,
    v81594: state_type > $o ).

tff(pred_def_43489,type,
    v81592: state_type > $o ).

tff(pred_def_43490,type,
    v81615: state_type > $o ).

tff(pred_def_43491,type,
    v81613: state_type > $o ).

tff(pred_def_43492,type,
    v81619: state_type > $o ).

tff(pred_def_43493,type,
    v81617: state_type > $o ).

tff(pred_def_43494,type,
    v81611: state_type > $o ).

tff(pred_def_43495,type,
    v81609: state_type > $o ).

tff(pred_def_43496,type,
    v81607: state_type > $o ).

tff(pred_def_43497,type,
    v81630: state_type > $o ).

tff(pred_def_43498,type,
    v81628: state_type > $o ).

tff(pred_def_43499,type,
    v81634: state_type > $o ).

tff(pred_def_43500,type,
    v81632: state_type > $o ).

tff(pred_def_43501,type,
    v81626: state_type > $o ).

tff(pred_def_43502,type,
    v81624: state_type > $o ).

tff(pred_def_43503,type,
    v81622: state_type > $o ).

tff(pred_def_43504,type,
    v81645: state_type > $o ).

tff(pred_def_43505,type,
    v81643: state_type > $o ).

tff(pred_def_43506,type,
    v81649: state_type > $o ).

tff(pred_def_43507,type,
    v81647: state_type > $o ).

tff(pred_def_43508,type,
    v81641: state_type > $o ).

tff(pred_def_43509,type,
    v81639: state_type > $o ).

tff(pred_def_43510,type,
    v81637: state_type > $o ).

tff(pred_def_43511,type,
    v81660: state_type > $o ).

tff(pred_def_43512,type,
    v81658: state_type > $o ).

tff(pred_def_43513,type,
    v81664: state_type > $o ).

tff(pred_def_43514,type,
    v81662: state_type > $o ).

tff(pred_def_43515,type,
    v81656: state_type > $o ).

tff(pred_def_43516,type,
    v81654: state_type > $o ).

tff(pred_def_43517,type,
    v81652: state_type > $o ).

tff(pred_def_43518,type,
    v81675: state_type > $o ).

tff(pred_def_43519,type,
    v81673: state_type > $o ).

tff(pred_def_43520,type,
    v81679: state_type > $o ).

tff(pred_def_43521,type,
    v81677: state_type > $o ).

tff(pred_def_43522,type,
    v81671: state_type > $o ).

tff(pred_def_43523,type,
    v81669: state_type > $o ).

tff(pred_def_43524,type,
    v81667: state_type > $o ).

tff(pred_def_43525,type,
    v81690: state_type > $o ).

tff(pred_def_43526,type,
    v81688: state_type > $o ).

tff(pred_def_43527,type,
    v81694: state_type > $o ).

tff(pred_def_43528,type,
    v81692: state_type > $o ).

tff(pred_def_43529,type,
    v81686: state_type > $o ).

tff(pred_def_43530,type,
    v81684: state_type > $o ).

tff(pred_def_43531,type,
    v81682: state_type > $o ).

tff(pred_def_43532,type,
    v81705: state_type > $o ).

tff(pred_def_43533,type,
    v81703: state_type > $o ).

tff(pred_def_43534,type,
    v81709: state_type > $o ).

tff(pred_def_43535,type,
    v81707: state_type > $o ).

tff(pred_def_43536,type,
    v81701: state_type > $o ).

tff(pred_def_43537,type,
    v81699: state_type > $o ).

tff(pred_def_43538,type,
    v81697: state_type > $o ).

tff(pred_def_43539,type,
    v81720: state_type > $o ).

tff(pred_def_43540,type,
    v81718: state_type > $o ).

tff(pred_def_43541,type,
    v81724: state_type > $o ).

tff(pred_def_43542,type,
    v81722: state_type > $o ).

tff(pred_def_43543,type,
    v81716: state_type > $o ).

tff(pred_def_43544,type,
    v81714: state_type > $o ).

tff(pred_def_43545,type,
    v81712: state_type > $o ).

tff(pred_def_43546,type,
    v81735: state_type > $o ).

tff(pred_def_43547,type,
    v81733: state_type > $o ).

tff(pred_def_43548,type,
    v81739: state_type > $o ).

tff(pred_def_43549,type,
    v81737: state_type > $o ).

tff(pred_def_43550,type,
    v81731: state_type > $o ).

tff(pred_def_43551,type,
    v81729: state_type > $o ).

tff(pred_def_43552,type,
    v81727: state_type > $o ).

tff(pred_def_43553,type,
    v81750: state_type > $o ).

tff(pred_def_43554,type,
    v81748: state_type > $o ).

tff(pred_def_43555,type,
    v81754: state_type > $o ).

tff(pred_def_43556,type,
    v81752: state_type > $o ).

tff(pred_def_43557,type,
    v81746: state_type > $o ).

tff(pred_def_43558,type,
    v81744: state_type > $o ).

tff(pred_def_43559,type,
    v81742: state_type > $o ).

tff(pred_def_43560,type,
    v81765: state_type > $o ).

tff(pred_def_43561,type,
    v81763: state_type > $o ).

tff(pred_def_43562,type,
    v81769: state_type > $o ).

tff(pred_def_43563,type,
    v81767: state_type > $o ).

tff(pred_def_43564,type,
    v81761: state_type > $o ).

tff(pred_def_43565,type,
    v81759: state_type > $o ).

tff(pred_def_43566,type,
    v81757: state_type > $o ).

tff(pred_def_43567,type,
    v81780: state_type > $o ).

tff(pred_def_43568,type,
    v81778: state_type > $o ).

tff(pred_def_43569,type,
    v81794: ( state_type * $int ) > $o ).

tff(pred_def_43570,type,
    v81792: ( state_type * $int ) > $o ).

tff(pred_def_43571,type,
    v81798: ( state_type * $int ) > $o ).

tff(pred_def_43572,type,
    v81796: ( state_type * $int ) > $o ).

tff(pred_def_43573,type,
    v81790: state_type > $o ).

tff(pred_def_43574,type,
    v81788: state_type > $o ).

tff(pred_def_43575,type,
    v81786: state_type > $o ).

tff(pred_def_43576,type,
    v81784: state_type > $o ).

tff(pred_def_43577,type,
    v81782: state_type > $o ).

tff(pred_def_43578,type,
    v81776: state_type > $o ).

tff(pred_def_43579,type,
    v81774: state_type > $o ).

tff(pred_def_43580,type,
    v81772: state_type > $o ).

tff(pred_def_43581,type,
    v81545: ( state_type * $int ) > $o ).

tff(pred_def_43582,type,
    v81543: ( state_type * $int ) > $o ).

tff(pred_def_43583,type,
    v81541: ( state_type * $int ) > $o ).

tff(pred_def_43584,type,
    v79987: state_type > $o ).

tff(pred_def_43585,type,
    v79985: state_type > $o ).

tff(pred_def_43586,type,
    v79983: state_type > $o ).

tff(pred_def_43587,type,
    v79981: state_type > $o ).

tff(pred_def_43588,type,
    v79979: state_type > $o ).

tff(pred_def_43589,type,
    v79977: state_type > $o ).

tff(pred_def_43590,type,
    v79975: state_type > $o ).

tff(pred_def_43591,type,
    v79973: state_type > $o ).

tff(pred_def_43592,type,
    v79971: state_type > $o ).

tff(pred_def_43593,type,
    v79969: state_type > $o ).

tff(pred_def_43594,type,
    v79925: state_type > $o ).

tff(pred_def_43595,type,
    v79923: state_type > $o ).

tff(pred_def_43596,type,
    v79921: state_type > $o ).

tff(pred_def_43597,type,
    v79919: state_type > $o ).

tff(pred_def_43598,type,
    v79917: state_type > $o ).

tff(pred_def_43599,type,
    v81808: state_type > $o ).

tff(pred_def_43600,type,
    v81807: state_type > $o ).

tff(pred_def_43601,type,
    v77650: state_type > $o ).

tff(pred_def_43602,type,
    v77648: state_type > $o ).

tff(pred_def_43603,type,
    v77646: state_type > $o ).

tff(pred_def_43604,type,
    v77644: state_type > $o ).

tff(pred_def_43605,type,
    v77642: state_type > $o ).

tff(pred_def_43606,type,
    v81848: state_type > $o ).

tff(pred_def_43607,type,
    v81846: state_type > $o ).

tff(pred_def_43608,type,
    v81852: state_type > $o ).

tff(pred_def_43609,type,
    v81850: state_type > $o ).

tff(pred_def_43610,type,
    v81856: state_type > $o ).

tff(pred_def_43611,type,
    v81854: state_type > $o ).

tff(pred_def_43612,type,
    v81860: state_type > $o ).

tff(pred_def_43613,type,
    v81858: state_type > $o ).

tff(pred_def_43614,type,
    v81864: state_type > $o ).

tff(pred_def_43615,type,
    v81863: state_type > $o ).

tff(pred_def_43616,type,
    v81862: state_type > $o ).

tff(pred_def_43617,type,
    v81844: state_type > $o ).

tff(pred_def_43618,type,
    v81842: state_type > $o ).

tff(pred_def_43619,type,
    v81840: state_type > $o ).

tff(pred_def_43620,type,
    v81838: state_type > $o ).

tff(pred_def_43621,type,
    v81868: state_type > $o ).

tff(pred_def_43622,type,
    v81866: state_type > $o ).

tff(pred_def_43623,type,
    v81870: state_type > $o ).

tff(pred_def_43624,type,
    v81836: state_type > $o ).

tff(pred_def_43625,type,
    v81834: state_type > $o ).

tff(pred_def_43626,type,
    v81832: state_type > $o ).

tff(pred_def_43627,type,
    v81830: state_type > $o ).

tff(pred_def_43628,type,
    v81894: state_type > $o ).

tff(pred_def_43629,type,
    v81892: state_type > $o ).

tff(pred_def_43630,type,
    v81890: state_type > $o ).

tff(pred_def_43631,type,
    v81888: state_type > $o ).

tff(pred_def_43632,type,
    v81886: state_type > $o ).

tff(pred_def_43633,type,
    v81884: state_type > $o ).

tff(pred_def_43634,type,
    v81882: state_type > $o ).

tff(pred_def_43635,type,
    v81919: ( state_type * $int ) > $o ).

tff(pred_def_43636,type,
    v81917: ( state_type * $int ) > $o ).

tff(pred_def_43637,type,
    v81923: ( state_type * $int ) > $o ).

tff(pred_def_43638,type,
    v81921: ( state_type * $int ) > $o ).

tff(pred_def_43639,type,
    v81915: state_type > $o ).

tff(pred_def_43640,type,
    v81913: state_type > $o ).

tff(pred_def_43641,type,
    v81911: state_type > $o ).

tff(pred_def_43642,type,
    v81909: state_type > $o ).

tff(pred_def_43643,type,
    v81907: state_type > $o ).

tff(pred_def_43644,type,
    v81905: state_type > $o ).

tff(pred_def_43645,type,
    v81903: state_type > $o ).

tff(pred_def_43646,type,
    v81901: state_type > $o ).

tff(pred_def_43647,type,
    v81899: state_type > $o ).

tff(pred_def_43648,type,
    v81897: state_type > $o ).

tff(pred_def_43649,type,
    v81880: state_type > $o ).

tff(pred_def_43650,type,
    v81878: state_type > $o ).

tff(pred_def_43651,type,
    v81876: state_type > $o ).

tff(pred_def_43652,type,
    v81874: state_type > $o ).

tff(pred_def_43653,type,
    v81872: state_type > $o ).

tff(pred_def_43654,type,
    v81828: state_type > $o ).

tff(pred_def_43655,type,
    v81826: state_type > $o ).

tff(pred_def_43656,type,
    v81824: state_type > $o ).

tff(pred_def_43657,type,
    v81822: state_type > $o ).

tff(pred_def_43658,type,
    v81820: state_type > $o ).

tff(pred_def_43659,type,
    v81957: state_type > $o ).

tff(pred_def_43660,type,
    v81955: state_type > $o ).

tff(pred_def_43661,type,
    v81961: state_type > $o ).

tff(pred_def_43662,type,
    v81959: state_type > $o ).

tff(pred_def_43663,type,
    v81965: state_type > $o ).

tff(pred_def_43664,type,
    v81963: state_type > $o ).

tff(pred_def_43665,type,
    v81969: state_type > $o ).

tff(pred_def_43666,type,
    v81967: state_type > $o ).

tff(pred_def_43667,type,
    v81973: state_type > $o ).

tff(pred_def_43668,type,
    v81972: state_type > $o ).

tff(pred_def_43669,type,
    v81971: state_type > $o ).

tff(pred_def_43670,type,
    v81953: state_type > $o ).

tff(pred_def_43671,type,
    v81951: state_type > $o ).

tff(pred_def_43672,type,
    v81949: state_type > $o ).

tff(pred_def_43673,type,
    v81947: state_type > $o ).

tff(pred_def_43674,type,
    v81977: state_type > $o ).

tff(pred_def_43675,type,
    v81975: state_type > $o ).

tff(pred_def_43676,type,
    v81979: state_type > $o ).

tff(pred_def_43677,type,
    v81945: state_type > $o ).

tff(pred_def_43678,type,
    v81943: state_type > $o ).

tff(pred_def_43679,type,
    v81941: state_type > $o ).

tff(pred_def_43680,type,
    v81939: state_type > $o ).

tff(pred_def_43681,type,
    v81993: state_type > $o ).

tff(pred_def_43682,type,
    v81991: state_type > $o ).

tff(pred_def_43683,type,
    v82007: state_type > $o ).

tff(pred_def_43684,type,
    v82005: state_type > $o ).

tff(pred_def_43685,type,
    v82003: state_type > $o ).

tff(pred_def_43686,type,
    v82001: state_type > $o ).

tff(pred_def_43687,type,
    v81999: state_type > $o ).

tff(pred_def_43688,type,
    v81997: state_type > $o ).

tff(pred_def_43689,type,
    v81995: state_type > $o ).

tff(pred_def_43690,type,
    v81989: state_type > $o ).

tff(pred_def_43691,type,
    v81987: state_type > $o ).

tff(pred_def_43692,type,
    v81985: state_type > $o ).

tff(pred_def_43693,type,
    v81983: state_type > $o ).

tff(pred_def_43694,type,
    v81981: state_type > $o ).

tff(pred_def_43695,type,
    v81937: state_type > $o ).

tff(pred_def_43696,type,
    v81935: state_type > $o ).

tff(pred_def_43697,type,
    v81933: state_type > $o ).

tff(pred_def_43698,type,
    v81931: state_type > $o ).

tff(pred_def_43699,type,
    v81929: state_type > $o ).

tff(pred_def_43700,type,
    v82012: state_type > $o ).

tff(pred_def_43701,type,
    v81818: state_type > $o ).

tff(pred_def_43702,type,
    v81816: state_type > $o ).

tff(pred_def_43703,type,
    v81814: state_type > $o ).

tff(pred_def_43704,type,
    v81812: state_type > $o ).

tff(pred_def_43705,type,
    v81810: state_type > $o ).

tff(pred_def_43706,type,
    v82016: state_type > $o ).

tff(pred_def_43707,type,
    v82015: state_type > $o ).

tff(pred_def_43708,type,
    v82014: state_type > $o ).

tff(pred_def_43709,type,
    v67181: state_type > $o ).

tff(pred_def_43710,type,
    v67179: state_type > $o ).

tff(pred_def_43711,type,
    v67177: state_type > $o ).

tff(pred_def_43712,type,
    v82018: ( state_type * $int ) > $o ).

tff(pred_def_43713,type,
    v82017: ( state_type * $int ) > $o ).

tff(pred_def_43714,type,
    v67175: ( state_type * $int ) > $o ).

tff(pred_def_43715,type,
    v67173: ( state_type * $int ) > $o ).

tff(pred_def_43716,type,
    v82028: state_type > $o ).

tff(pred_def_43717,type,
    v82026: state_type > $o ).

tff(pred_def_43718,type,
    v82034: state_type > $o ).

tff(pred_def_43719,type,
    v82032: state_type > $o ).

tff(pred_def_43720,type,
    v82040: ( state_type * $int ) > $o ).

tff(pred_def_43721,type,
    v82038: state_type > $o ).

tff(pred_def_43722,type,
    v82036: state_type > $o ).

tff(pred_def_43723,type,
    v82048: state_type > $o ).

tff(pred_def_43724,type,
    v82046: state_type > $o ).

tff(pred_def_43725,type,
    v82044: state_type > $o ).

tff(pred_def_43726,type,
    v82042: state_type > $o ).

tff(pred_def_43727,type,
    v82030: state_type > $o ).

tff(pred_def_43728,type,
    v82054: state_type > $o ).

tff(pred_def_43729,type,
    v82056: state_type > $o ).

tff(pred_def_43730,type,
    v82052: state_type > $o ).

tff(pred_def_43731,type,
    v82051: state_type > $o ).

tff(pred_def_43732,type,
    v82062: state_type > $o ).

tff(pred_def_43733,type,
    v82063: state_type > $o ).

tff(pred_def_43734,type,
    v82059: state_type > $o ).

tff(pred_def_43735,type,
    v82061: state_type > $o ).

tff(pred_def_43736,type,
    v82069: state_type > $o ).

tff(pred_def_43737,type,
    v82067: state_type > $o ).

tff(pred_def_43738,type,
    v82071: state_type > $o ).

tff(pred_def_43739,type,
    v82024: state_type > $o ).

tff(pred_def_43740,type,
    v82022: state_type > $o ).

tff(pred_def_43741,type,
    v82020: state_type > $o ).

tff(pred_def_43742,type,
    v82078: state_type > $o ).

tff(pred_def_43743,type,
    v82076: state_type > $o ).

tff(pred_def_43744,type,
    v82075: state_type > $o ).

tff(pred_def_43745,type,
    v82074: state_type > $o ).

tff(pred_def_43746,type,
    v82086: state_type > $o ).

tff(pred_def_43747,type,
    v82087: state_type > $o ).

tff(pred_def_43748,type,
    v82085: state_type > $o ).

tff(pred_def_43749,type,
    v82082: ( state_type * $int ) > $o ).

tff(pred_def_43750,type,
    v82084: ( state_type * $int ) > $o ).

tff(pred_def_43751,type,
    v82073: ( state_type * $int ) > $o ).

tff(pred_def_43752,type,
    v67143: ( state_type * $int ) > $o ).

tff(pred_def_43753,type,
    v67141: ( state_type * $int ) > $o ).

tff(pred_def_43754,type,
    v67139: state_type > $o ).

tff(pred_def_43755,type,
    v5805: ( state_type * $int ) > $o ).

tff(pred_def_43756,type,
    v5803: ( state_type * $int ) > $o ).

tff(pred_def_43757,type,
    v82099: state_type > $o ).

tff(pred_def_43758,type,
    v82097: state_type > $o ).

tff(pred_def_43759,type,
    v82103: state_type > $o ).

tff(pred_def_43760,type,
    v82101: state_type > $o ).

tff(pred_def_43761,type,
    v82111: ( state_type * $int ) > $o ).

tff(pred_def_43762,type,
    v82110: ( state_type * $int ) > $o ).

tff(pred_def_43763,type,
    v82112: ( state_type * $int ) > $o ).

tff(pred_def_43764,type,
    v82113: ( state_type * $int ) > $o ).

tff(pred_def_43765,type,
    v82109: ( state_type * $int ) > $o ).

tff(pred_def_43766,type,
    v82115: state_type > $o ).

tff(pred_def_43767,type,
    v82119: state_type > $o ).

tff(pred_def_43768,type,
    v82118: ( state_type * $int ) > $o ).

tff(pred_def_43769,type,
    v82117: ( state_type * $int ) > $o ).

tff(pred_def_43770,type,
    v82123: state_type > $o ).

tff(pred_def_43771,type,
    v82122: ( state_type * $int ) > $o ).

tff(pred_def_43772,type,
    v82121: ( state_type * $int ) > $o ).

tff(pred_def_43773,type,
    v82093: ( state_type * $int ) > $o ).

tff(pred_def_43774,type,
    v82120: ( state_type * $int ) > $o ).

tff(pred_def_43775,type,
    v82116: ( state_type * $int ) > $o ).

tff(pred_def_43776,type,
    v82107: ( state_type * $int ) > $o ).

tff(pred_def_43777,type,
    v82105: ( state_type * $int ) > $o ).

tff(pred_def_43778,type,
    v82128: state_type > $o ).

tff(pred_def_43779,type,
    v82126: state_type > $o ).

tff(pred_def_43780,type,
    v82135: state_type > $o ).

tff(pred_def_43781,type,
    v82133: state_type > $o ).

tff(pred_def_43782,type,
    v82132: state_type > $o ).

tff(pred_def_43783,type,
    v82131: state_type > $o ).

tff(pred_def_43784,type,
    v82143: state_type > $o ).

tff(pred_def_43785,type,
    v82144: state_type > $o ).

tff(pred_def_43786,type,
    v82142: state_type > $o ).

tff(pred_def_43787,type,
    v82139: ( state_type * $int ) > $o ).

tff(pred_def_43788,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_43789,type,
    v82141: ( state_type * $int ) > $o ).

tff(pred_def_43790,type,
    v82130: ( state_type * $int ) > $o ).

tff(pred_def_43791,type,
    v82095: ( state_type * $int ) > $o ).

tff(pred_def_43792,type,
    v82091: ( state_type * $int ) > $o ).

tff(pred_def_43793,type,
    v82148: state_type > $o ).

tff(pred_def_43794,type,
    v82150: state_type > $o ).

tff(pred_def_43795,type,
    v5801: state_type > $o ).

tff(pred_def_43796,type,
    v82172: state_type > $o ).

tff(pred_def_43797,type,
    v82170: state_type > $o ).

tff(pred_def_43798,type,
    v82168: state_type > $o ).

tff(pred_def_43799,type,
    v82166: state_type > $o ).

tff(pred_def_43800,type,
    v82164: state_type > $o ).

tff(pred_def_43801,type,
    v82182: state_type > $o ).

tff(pred_def_43802,type,
    v82180: state_type > $o ).

tff(pred_def_43803,type,
    v82178: state_type > $o ).

tff(pred_def_43804,type,
    v82176: state_type > $o ).

tff(pred_def_43805,type,
    v82174: state_type > $o ).

tff(pred_def_43806,type,
    v82226: state_type > $o ).

tff(pred_def_43807,type,
    v82224: state_type > $o ).

tff(pred_def_43808,type,
    v82230: state_type > $o ).

tff(pred_def_43809,type,
    v82228: state_type > $o ).

tff(pred_def_43810,type,
    v82234: state_type > $o ).

tff(pred_def_43811,type,
    v82232: state_type > $o ).

tff(pred_def_43812,type,
    v82236: state_type > $o ).

tff(pred_def_43813,type,
    v82222: state_type > $o ).

tff(pred_def_43814,type,
    v82220: state_type > $o ).

tff(pred_def_43815,type,
    v82218: state_type > $o ).

tff(pred_def_43816,type,
    v82216: state_type > $o ).

tff(pred_def_43817,type,
    v82214: state_type > $o ).

tff(pred_def_43818,type,
    v82250: state_type > $o ).

tff(pred_def_43819,type,
    v82248: state_type > $o ).

tff(pred_def_43820,type,
    v82254: state_type > $o ).

tff(pred_def_43821,type,
    v82252: state_type > $o ).

tff(pred_def_43822,type,
    v82258: state_type > $o ).

tff(pred_def_43823,type,
    v82256: state_type > $o ).

tff(pred_def_43824,type,
    v82260: state_type > $o ).

tff(pred_def_43825,type,
    v82246: state_type > $o ).

tff(pred_def_43826,type,
    v82244: state_type > $o ).

tff(pred_def_43827,type,
    v82242: state_type > $o ).

tff(pred_def_43828,type,
    v82240: state_type > $o ).

tff(pred_def_43829,type,
    v82238: state_type > $o ).

tff(pred_def_43830,type,
    v82274: state_type > $o ).

tff(pred_def_43831,type,
    v82272: state_type > $o ).

tff(pred_def_43832,type,
    v82278: state_type > $o ).

tff(pred_def_43833,type,
    v82276: state_type > $o ).

tff(pred_def_43834,type,
    v82282: state_type > $o ).

tff(pred_def_43835,type,
    v82280: state_type > $o ).

tff(pred_def_43836,type,
    v82284: state_type > $o ).

tff(pred_def_43837,type,
    v82270: state_type > $o ).

tff(pred_def_43838,type,
    v82268: state_type > $o ).

tff(pred_def_43839,type,
    v82266: state_type > $o ).

tff(pred_def_43840,type,
    v82264: state_type > $o ).

tff(pred_def_43841,type,
    v82262: state_type > $o ).

tff(pred_def_43842,type,
    v82287: state_type > $o ).

tff(pred_def_43843,type,
    v82286: state_type > $o ).

tff(pred_def_43844,type,
    v82212: state_type > $o ).

tff(pred_def_43845,type,
    v82210: state_type > $o ).

tff(pred_def_43846,type,
    v82208: state_type > $o ).

tff(pred_def_43847,type,
    v82206: state_type > $o ).

tff(pred_def_43848,type,
    v82204: state_type > $o ).

tff(pred_def_43849,type,
    v82311: state_type > $o ).

tff(pred_def_43850,type,
    v82309: state_type > $o ).

tff(pred_def_43851,type,
    v82315: state_type > $o ).

tff(pred_def_43852,type,
    v82313: state_type > $o ).

tff(pred_def_43853,type,
    v82319: state_type > $o ).

tff(pred_def_43854,type,
    v82317: state_type > $o ).

tff(pred_def_43855,type,
    v82321: state_type > $o ).

tff(pred_def_43856,type,
    v82307: state_type > $o ).

tff(pred_def_43857,type,
    v82305: state_type > $o ).

tff(pred_def_43858,type,
    v82303: state_type > $o ).

tff(pred_def_43859,type,
    v82301: state_type > $o ).

tff(pred_def_43860,type,
    v82299: state_type > $o ).

tff(pred_def_43861,type,
    v82334: state_type > $o ).

tff(pred_def_43862,type,
    v82332: state_type > $o ).

tff(pred_def_43863,type,
    v82358: state_type > $o ).

tff(pred_def_43864,type,
    v82356: state_type > $o ).

tff(pred_def_43865,type,
    v82354: state_type > $o ).

tff(pred_def_43866,type,
    v82352: state_type > $o ).

tff(pred_def_43867,type,
    v82350: state_type > $o ).

tff(pred_def_43868,type,
    v82348: state_type > $o ).

tff(pred_def_43869,type,
    v82346: state_type > $o ).

tff(pred_def_43870,type,
    v82363: state_type > $o ).

tff(pred_def_43871,type,
    v82361: state_type > $o ).

tff(pred_def_43872,type,
    v82344: state_type > $o ).

tff(pred_def_43873,type,
    v82342: state_type > $o ).

tff(pred_def_43874,type,
    v82340: state_type > $o ).

tff(pred_def_43875,type,
    v82338: state_type > $o ).

tff(pred_def_43876,type,
    v82336: state_type > $o ).

tff(pred_def_43877,type,
    v82366: state_type > $o ).

tff(pred_def_43878,type,
    v82330: state_type > $o ).

tff(pred_def_43879,type,
    v82328: state_type > $o ).

tff(pred_def_43880,type,
    v82325: state_type > $o ).

tff(pred_def_43881,type,
    v82323: state_type > $o ).

tff(pred_def_43882,type,
    v82378: state_type > $o ).

tff(pred_def_43883,type,
    v82376: state_type > $o ).

tff(pred_def_43884,type,
    v82382: state_type > $o ).

tff(pred_def_43885,type,
    v82380: state_type > $o ).

tff(pred_def_43886,type,
    v82386: state_type > $o ).

tff(pred_def_43887,type,
    v82384: state_type > $o ).

tff(pred_def_43888,type,
    v82389: state_type > $o ).

tff(pred_def_43889,type,
    v82388: state_type > $o ).

tff(pred_def_43890,type,
    v82374: state_type > $o ).

tff(pred_def_43891,type,
    v82372: state_type > $o ).

tff(pred_def_43892,type,
    v82370: state_type > $o ).

tff(pred_def_43893,type,
    v82368: state_type > $o ).

tff(pred_def_43894,type,
    v82392: state_type > $o ).

tff(pred_def_43895,type,
    v82391: state_type > $o ).

tff(pred_def_43896,type,
    v82297: state_type > $o ).

tff(pred_def_43897,type,
    v82295: state_type > $o ).

tff(pred_def_43898,type,
    v82293: state_type > $o ).

tff(pred_def_43899,type,
    v82291: state_type > $o ).

tff(pred_def_43900,type,
    v82289: state_type > $o ).

tff(pred_def_43901,type,
    v82414: state_type > $o ).

tff(pred_def_43902,type,
    v82412: state_type > $o ).

tff(pred_def_43903,type,
    v82418: state_type > $o ).

tff(pred_def_43904,type,
    v82416: state_type > $o ).

tff(pred_def_43905,type,
    v82422: state_type > $o ).

tff(pred_def_43906,type,
    v82420: state_type > $o ).

tff(pred_def_43907,type,
    v82425: state_type > $o ).

tff(pred_def_43908,type,
    v82424: state_type > $o ).

tff(pred_def_43909,type,
    v82410: state_type > $o ).

tff(pred_def_43910,type,
    v82408: state_type > $o ).

tff(pred_def_43911,type,
    v82406: state_type > $o ).

tff(pred_def_43912,type,
    v82404: state_type > $o ).

tff(pred_def_43913,type,
    v82437: state_type > $o ).

tff(pred_def_43914,type,
    v82435: state_type > $o ).

tff(pred_def_43915,type,
    v82441: state_type > $o ).

tff(pred_def_43916,type,
    v82439: state_type > $o ).

tff(pred_def_43917,type,
    v82445: state_type > $o ).

tff(pred_def_43918,type,
    v82443: state_type > $o ).

tff(pred_def_43919,type,
    v82448: state_type > $o ).

tff(pred_def_43920,type,
    v82447: state_type > $o ).

tff(pred_def_43921,type,
    v82433: state_type > $o ).

tff(pred_def_43922,type,
    v82431: state_type > $o ).

tff(pred_def_43923,type,
    v82429: state_type > $o ).

tff(pred_def_43924,type,
    v82427: state_type > $o ).

tff(pred_def_43925,type,
    v82450: state_type > $o ).

tff(pred_def_43926,type,
    v82402: state_type > $o ).

tff(pred_def_43927,type,
    v82400: state_type > $o ).

tff(pred_def_43928,type,
    v82398: state_type > $o ).

tff(pred_def_43929,type,
    v82396: state_type > $o ).

tff(pred_def_43930,type,
    v82394: state_type > $o ).

tff(pred_def_43931,type,
    v82452: state_type > $o ).

tff(pred_def_43932,type,
    v82202: state_type > $o ).

tff(pred_def_43933,type,
    v82200: state_type > $o ).

tff(pred_def_43934,type,
    v82198: state_type > $o ).

tff(pred_def_43935,type,
    v82196: state_type > $o ).

tff(pred_def_43936,type,
    v82194: state_type > $o ).

tff(pred_def_43937,type,
    v82456: state_type > $o ).

tff(pred_def_43938,type,
    v82454: state_type > $o ).

tff(pred_def_43939,type,
    v82458: state_type > $o ).

tff(pred_def_43940,type,
    v82192: state_type > $o ).

tff(pred_def_43941,type,
    v82190: state_type > $o ).

tff(pred_def_43942,type,
    v82188: state_type > $o ).

tff(pred_def_43943,type,
    v82459: ( state_type * $int ) > $o ).

tff(pred_def_43944,type,
    v82186: ( state_type * $int ) > $o ).

tff(pred_def_43945,type,
    v82184: ( state_type * $int ) > $o ).

tff(pred_def_43946,type,
    v82469: state_type > $o ).

tff(pred_def_43947,type,
    v82467: state_type > $o ).

tff(pred_def_43948,type,
    v82475: state_type > $o ).

tff(pred_def_43949,type,
    v82473: state_type > $o ).

tff(pred_def_43950,type,
    v82479: state_type > $o ).

tff(pred_def_43951,type,
    v82477: state_type > $o ).

tff(pred_def_43952,type,
    v82483: state_type > $o ).

tff(pred_def_43953,type,
    v82481: state_type > $o ).

tff(pred_def_43954,type,
    v82471: state_type > $o ).

tff(pred_def_43955,type,
    v82489: state_type > $o ).

tff(pred_def_43956,type,
    v82491: state_type > $o ).

tff(pred_def_43957,type,
    v82487: state_type > $o ).

tff(pred_def_43958,type,
    v82486: state_type > $o ).

tff(pred_def_43959,type,
    v82497: state_type > $o ).

tff(pred_def_43960,type,
    v82498: state_type > $o ).

tff(pred_def_43961,type,
    v82494: state_type > $o ).

tff(pred_def_43962,type,
    v82496: state_type > $o ).

tff(pred_def_43963,type,
    v82504: state_type > $o ).

tff(pred_def_43964,type,
    v82502: state_type > $o ).

tff(pred_def_43965,type,
    v82506: state_type > $o ).

tff(pred_def_43966,type,
    v82465: state_type > $o ).

tff(pred_def_43967,type,
    v82463: state_type > $o ).

tff(pred_def_43968,type,
    v82461: state_type > $o ).

tff(pred_def_43969,type,
    v82513: state_type > $o ).

tff(pred_def_43970,type,
    v82511: state_type > $o ).

tff(pred_def_43971,type,
    v82510: state_type > $o ).

tff(pred_def_43972,type,
    v82509: state_type > $o ).

tff(pred_def_43973,type,
    v82521: state_type > $o ).

tff(pred_def_43974,type,
    v82522: state_type > $o ).

tff(pred_def_43975,type,
    v82520: state_type > $o ).

tff(pred_def_43976,type,
    v82517: ( state_type * $int ) > $o ).

tff(pred_def_43977,type,
    v82519: ( state_type * $int ) > $o ).

tff(pred_def_43978,type,
    v82508: ( state_type * $int ) > $o ).

tff(pred_def_43979,type,
    v82162: ( state_type * $int ) > $o ).

tff(pred_def_43980,type,
    v82160: ( state_type * $int ) > $o ).

tff(pred_def_43981,type,
    v82158: state_type > $o ).

tff(pred_def_43982,type,
    v82540: state_type > $o ).

tff(pred_def_43983,type,
    v82538: state_type > $o ).

tff(pred_def_43984,type,
    v82536: state_type > $o ).

tff(pred_def_43985,type,
    v82534: state_type > $o ).

tff(pred_def_43986,type,
    v82532: state_type > $o ).

tff(pred_def_43987,type,
    v82550: state_type > $o ).

tff(pred_def_43988,type,
    v82548: state_type > $o ).

tff(pred_def_43989,type,
    v82546: state_type > $o ).

tff(pred_def_43990,type,
    v82544: state_type > $o ).

tff(pred_def_43991,type,
    v82542: state_type > $o ).

tff(pred_def_43992,type,
    v82594: state_type > $o ).

tff(pred_def_43993,type,
    v82592: state_type > $o ).

tff(pred_def_43994,type,
    v82598: state_type > $o ).

tff(pred_def_43995,type,
    v82596: state_type > $o ).

tff(pred_def_43996,type,
    v82602: state_type > $o ).

tff(pred_def_43997,type,
    v82600: state_type > $o ).

tff(pred_def_43998,type,
    v82604: state_type > $o ).

tff(pred_def_43999,type,
    v82590: state_type > $o ).

tff(pred_def_44000,type,
    v82588: state_type > $o ).

tff(pred_def_44001,type,
    v82586: state_type > $o ).

tff(pred_def_44002,type,
    v82584: state_type > $o ).

tff(pred_def_44003,type,
    v82582: state_type > $o ).

tff(pred_def_44004,type,
    v82618: state_type > $o ).

tff(pred_def_44005,type,
    v82616: state_type > $o ).

tff(pred_def_44006,type,
    v82622: state_type > $o ).

tff(pred_def_44007,type,
    v82620: state_type > $o ).

tff(pred_def_44008,type,
    v82626: state_type > $o ).

tff(pred_def_44009,type,
    v82624: state_type > $o ).

tff(pred_def_44010,type,
    v82628: state_type > $o ).

tff(pred_def_44011,type,
    v82614: state_type > $o ).

tff(pred_def_44012,type,
    v82612: state_type > $o ).

tff(pred_def_44013,type,
    v82610: state_type > $o ).

tff(pred_def_44014,type,
    v82608: state_type > $o ).

tff(pred_def_44015,type,
    v82606: state_type > $o ).

tff(pred_def_44016,type,
    v82642: state_type > $o ).

tff(pred_def_44017,type,
    v82640: state_type > $o ).

tff(pred_def_44018,type,
    v82646: state_type > $o ).

tff(pred_def_44019,type,
    v82644: state_type > $o ).

tff(pred_def_44020,type,
    v82650: state_type > $o ).

tff(pred_def_44021,type,
    v82648: state_type > $o ).

tff(pred_def_44022,type,
    v82652: state_type > $o ).

tff(pred_def_44023,type,
    v82638: state_type > $o ).

tff(pred_def_44024,type,
    v82636: state_type > $o ).

tff(pred_def_44025,type,
    v82634: state_type > $o ).

tff(pred_def_44026,type,
    v82632: state_type > $o ).

tff(pred_def_44027,type,
    v82630: state_type > $o ).

tff(pred_def_44028,type,
    v82655: state_type > $o ).

tff(pred_def_44029,type,
    v82654: state_type > $o ).

tff(pred_def_44030,type,
    v82580: state_type > $o ).

tff(pred_def_44031,type,
    v82578: state_type > $o ).

tff(pred_def_44032,type,
    v82576: state_type > $o ).

tff(pred_def_44033,type,
    v82574: state_type > $o ).

tff(pred_def_44034,type,
    v82572: state_type > $o ).

tff(pred_def_44035,type,
    v82679: state_type > $o ).

tff(pred_def_44036,type,
    v82677: state_type > $o ).

tff(pred_def_44037,type,
    v82683: state_type > $o ).

tff(pred_def_44038,type,
    v82681: state_type > $o ).

tff(pred_def_44039,type,
    v82687: state_type > $o ).

tff(pred_def_44040,type,
    v82685: state_type > $o ).

tff(pred_def_44041,type,
    v82689: state_type > $o ).

tff(pred_def_44042,type,
    v82675: state_type > $o ).

tff(pred_def_44043,type,
    v82673: state_type > $o ).

tff(pred_def_44044,type,
    v82671: state_type > $o ).

tff(pred_def_44045,type,
    v82669: state_type > $o ).

tff(pred_def_44046,type,
    v82667: state_type > $o ).

tff(pred_def_44047,type,
    v82702: state_type > $o ).

tff(pred_def_44048,type,
    v82700: state_type > $o ).

tff(pred_def_44049,type,
    v82726: state_type > $o ).

tff(pred_def_44050,type,
    v82724: state_type > $o ).

tff(pred_def_44051,type,
    v82722: state_type > $o ).

tff(pred_def_44052,type,
    v82720: state_type > $o ).

tff(pred_def_44053,type,
    v82718: state_type > $o ).

tff(pred_def_44054,type,
    v82716: state_type > $o ).

tff(pred_def_44055,type,
    v82714: state_type > $o ).

tff(pred_def_44056,type,
    v82731: state_type > $o ).

tff(pred_def_44057,type,
    v82729: state_type > $o ).

tff(pred_def_44058,type,
    v82712: state_type > $o ).

tff(pred_def_44059,type,
    v82710: state_type > $o ).

tff(pred_def_44060,type,
    v82708: state_type > $o ).

tff(pred_def_44061,type,
    v82706: state_type > $o ).

tff(pred_def_44062,type,
    v82704: state_type > $o ).

tff(pred_def_44063,type,
    v82734: state_type > $o ).

tff(pred_def_44064,type,
    v82698: state_type > $o ).

tff(pred_def_44065,type,
    v82696: state_type > $o ).

tff(pred_def_44066,type,
    v82693: state_type > $o ).

tff(pred_def_44067,type,
    v82691: state_type > $o ).

tff(pred_def_44068,type,
    v82746: state_type > $o ).

tff(pred_def_44069,type,
    v82744: state_type > $o ).

tff(pred_def_44070,type,
    v82750: state_type > $o ).

tff(pred_def_44071,type,
    v82748: state_type > $o ).

tff(pred_def_44072,type,
    v82754: state_type > $o ).

tff(pred_def_44073,type,
    v82752: state_type > $o ).

tff(pred_def_44074,type,
    v82757: state_type > $o ).

tff(pred_def_44075,type,
    v82756: state_type > $o ).

tff(pred_def_44076,type,
    v82742: state_type > $o ).

tff(pred_def_44077,type,
    v82740: state_type > $o ).

tff(pred_def_44078,type,
    v82738: state_type > $o ).

tff(pred_def_44079,type,
    v82736: state_type > $o ).

tff(pred_def_44080,type,
    v82760: state_type > $o ).

tff(pred_def_44081,type,
    v82759: state_type > $o ).

tff(pred_def_44082,type,
    v82665: state_type > $o ).

tff(pred_def_44083,type,
    v82663: state_type > $o ).

tff(pred_def_44084,type,
    v82661: state_type > $o ).

tff(pred_def_44085,type,
    v82659: state_type > $o ).

tff(pred_def_44086,type,
    v82657: state_type > $o ).

tff(pred_def_44087,type,
    v82782: state_type > $o ).

tff(pred_def_44088,type,
    v82780: state_type > $o ).

tff(pred_def_44089,type,
    v82786: state_type > $o ).

tff(pred_def_44090,type,
    v82784: state_type > $o ).

tff(pred_def_44091,type,
    v82790: state_type > $o ).

tff(pred_def_44092,type,
    v82788: state_type > $o ).

tff(pred_def_44093,type,
    v82793: state_type > $o ).

tff(pred_def_44094,type,
    v82792: state_type > $o ).

tff(pred_def_44095,type,
    v82778: state_type > $o ).

tff(pred_def_44096,type,
    v82776: state_type > $o ).

tff(pred_def_44097,type,
    v82774: state_type > $o ).

tff(pred_def_44098,type,
    v82772: state_type > $o ).

tff(pred_def_44099,type,
    v82805: state_type > $o ).

tff(pred_def_44100,type,
    v82803: state_type > $o ).

tff(pred_def_44101,type,
    v82809: state_type > $o ).

tff(pred_def_44102,type,
    v82807: state_type > $o ).

tff(pred_def_44103,type,
    v82813: state_type > $o ).

tff(pred_def_44104,type,
    v82811: state_type > $o ).

tff(pred_def_44105,type,
    v82816: state_type > $o ).

tff(pred_def_44106,type,
    v82815: state_type > $o ).

tff(pred_def_44107,type,
    v82801: state_type > $o ).

tff(pred_def_44108,type,
    v82799: state_type > $o ).

tff(pred_def_44109,type,
    v82797: state_type > $o ).

tff(pred_def_44110,type,
    v82795: state_type > $o ).

tff(pred_def_44111,type,
    v82818: state_type > $o ).

tff(pred_def_44112,type,
    v82770: state_type > $o ).

tff(pred_def_44113,type,
    v82768: state_type > $o ).

tff(pred_def_44114,type,
    v82766: state_type > $o ).

tff(pred_def_44115,type,
    v82764: state_type > $o ).

tff(pred_def_44116,type,
    v82762: state_type > $o ).

tff(pred_def_44117,type,
    v82820: state_type > $o ).

tff(pred_def_44118,type,
    v82570: state_type > $o ).

tff(pred_def_44119,type,
    v82568: state_type > $o ).

tff(pred_def_44120,type,
    v82566: state_type > $o ).

tff(pred_def_44121,type,
    v82564: state_type > $o ).

tff(pred_def_44122,type,
    v82562: state_type > $o ).

tff(pred_def_44123,type,
    v82824: state_type > $o ).

tff(pred_def_44124,type,
    v82822: state_type > $o ).

tff(pred_def_44125,type,
    v82826: state_type > $o ).

tff(pred_def_44126,type,
    v82560: state_type > $o ).

tff(pred_def_44127,type,
    v82558: state_type > $o ).

tff(pred_def_44128,type,
    v82556: state_type > $o ).

tff(pred_def_44129,type,
    v82827: ( state_type * $int ) > $o ).

tff(pred_def_44130,type,
    v82554: ( state_type * $int ) > $o ).

tff(pred_def_44131,type,
    v82552: ( state_type * $int ) > $o ).

tff(pred_def_44132,type,
    v82837: state_type > $o ).

tff(pred_def_44133,type,
    v82835: state_type > $o ).

tff(pred_def_44134,type,
    v82843: state_type > $o ).

tff(pred_def_44135,type,
    v82841: state_type > $o ).

tff(pred_def_44136,type,
    v82847: state_type > $o ).

tff(pred_def_44137,type,
    v82845: state_type > $o ).

tff(pred_def_44138,type,
    v82851: state_type > $o ).

tff(pred_def_44139,type,
    v82849: state_type > $o ).

tff(pred_def_44140,type,
    v82839: state_type > $o ).

tff(pred_def_44141,type,
    v82857: state_type > $o ).

tff(pred_def_44142,type,
    v82859: state_type > $o ).

tff(pred_def_44143,type,
    v82855: state_type > $o ).

tff(pred_def_44144,type,
    v82854: state_type > $o ).

tff(pred_def_44145,type,
    v82865: state_type > $o ).

tff(pred_def_44146,type,
    v82866: state_type > $o ).

tff(pred_def_44147,type,
    v82862: state_type > $o ).

tff(pred_def_44148,type,
    v82864: state_type > $o ).

tff(pred_def_44149,type,
    v82872: state_type > $o ).

tff(pred_def_44150,type,
    v82870: state_type > $o ).

tff(pred_def_44151,type,
    v82874: state_type > $o ).

tff(pred_def_44152,type,
    v82833: state_type > $o ).

tff(pred_def_44153,type,
    v82831: state_type > $o ).

tff(pred_def_44154,type,
    v82829: state_type > $o ).

tff(pred_def_44155,type,
    v82881: state_type > $o ).

tff(pred_def_44156,type,
    v82879: state_type > $o ).

tff(pred_def_44157,type,
    v82878: state_type > $o ).

tff(pred_def_44158,type,
    v82877: state_type > $o ).

tff(pred_def_44159,type,
    v82889: state_type > $o ).

tff(pred_def_44160,type,
    v82890: state_type > $o ).

tff(pred_def_44161,type,
    v82888: state_type > $o ).

tff(pred_def_44162,type,
    v82885: ( state_type * $int ) > $o ).

tff(pred_def_44163,type,
    v82887: ( state_type * $int ) > $o ).

tff(pred_def_44164,type,
    v82876: ( state_type * $int ) > $o ).

tff(pred_def_44165,type,
    v82530: ( state_type * $int ) > $o ).

tff(pred_def_44166,type,
    v82528: ( state_type * $int ) > $o ).

tff(pred_def_44167,type,
    v82526: state_type > $o ).

tff(pred_def_44168,type,
    v82156: ( state_type * $int ) > $o ).

tff(pred_def_44169,type,
    v82900: state_type > $o ).

tff(pred_def_44170,type,
    v82898: state_type > $o ).

tff(pred_def_44171,type,
    v82897: state_type > $o ).

tff(pred_def_44172,type,
    v82896: ( state_type * $int ) > $o ).

tff(pred_def_44173,type,
    v82894: ( state_type * $int ) > $o ).

tff(pred_def_44174,type,
    v82904: state_type > $o ).

tff(pred_def_44175,type,
    v82906: state_type > $o ).

tff(pred_def_44176,type,
    v82153: state_type > $o ).

tff(pred_def_44177,type,
    v82914: state_type > $o ).

tff(pred_def_44178,type,
    v82912: state_type > $o ).

tff(pred_def_44179,type,
    v82918: state_type > $o ).

tff(pred_def_44180,type,
    v82916: state_type > $o ).

tff(pred_def_44181,type,
    v82942: state_type > $o ).

tff(pred_def_44182,type,
    v82940: state_type > $o ).

tff(pred_def_44183,type,
    v82946: state_type > $o ).

tff(pred_def_44184,type,
    v82944: state_type > $o ).

tff(pred_def_44185,type,
    v82973: state_type > $o ).

tff(pred_def_44186,type,
    v82971: state_type > $o ).

tff(pred_def_44187,type,
    v82977: state_type > $o ).

tff(pred_def_44188,type,
    v82975: state_type > $o ).

tff(pred_def_44189,type,
    v779: state_type > $o ).

tff(pred_def_44190,type,
    v82984: ( state_type * $int ) > $o ).

tff(pred_def_44191,type,
    v82985: ( state_type * $int ) > $o ).

tff(pred_def_44192,type,
    v82983: ( state_type * $int ) > $o ).

tff(pred_def_44193,type,
    v82981: ( state_type * $int ) > $o ).

tff(pred_def_44194,type,
    v82979: ( state_type * $int ) > $o ).

tff(pred_def_44195,type,
    v82989: state_type > $o ).

tff(pred_def_44196,type,
    v82987: state_type > $o ).

tff(pred_def_44197,type,
    v82996: state_type > $o ).

tff(pred_def_44198,type,
    v82994: state_type > $o ).

tff(pred_def_44199,type,
    v82993: state_type > $o ).

tff(pred_def_44200,type,
    v82992: state_type > $o ).

tff(pred_def_44201,type,
    v83004: state_type > $o ).

tff(pred_def_44202,type,
    v83005: state_type > $o ).

tff(pred_def_44203,type,
    v83003: state_type > $o ).

tff(pred_def_44204,type,
    v83000: ( state_type * $int ) > $o ).

tff(pred_def_44205,type,
    v83002: ( state_type * $int ) > $o ).

tff(pred_def_44206,type,
    v82991: ( state_type * $int ) > $o ).

tff(pred_def_44207,type,
    v82969: ( state_type * $int ) > $o ).

tff(pred_def_44208,type,
    v82967: ( state_type * $int ) > $o ).

tff(pred_def_44209,type,
    v82965: state_type > $o ).

tff(pred_def_44210,type,
    v82934: state_type > $o ).

tff(pred_def_44211,type,
    v83009: state_type > $o ).

tff(pred_def_44212,type,
    v83011: state_type > $o ).

tff(pred_def_44213,type,
    v83010: state_type > $o ).

tff(pred_def_44214,type,
    v83014: ( state_type * $int ) > $o ).

tff(pred_def_44215,type,
    v83015: ( state_type * $int ) > $o ).

tff(pred_def_44216,type,
    v83016: ( state_type * $int ) > $o ).

tff(pred_def_44217,type,
    v83019: state_type > $o ).

tff(pred_def_44218,type,
    v83018: state_type > $o ).

tff(pred_def_44219,type,
    v83017: state_type > $o ).

tff(pred_def_44220,type,
    v83020: state_type > $o ).

tff(pred_def_44221,type,
    v83021: state_type > $o ).

tff(pred_def_44222,type,
    v83023: state_type > $o ).

tff(pred_def_44223,type,
    v5414: state_type > $o ).

tff(pred_def_44224,type,
    v83024: state_type > $o ).

tff(pred_def_44225,type,
    v83026: ( state_type * $int ) > $o ).

tff(pred_def_44226,type,
    v83025: ( state_type * $int ) > $o ).

tff(pred_def_44227,type,
    v83027: ( state_type * $int ) > $o ).

tff(pred_def_44228,type,
    v83030: state_type > $o ).

tff(pred_def_44229,type,
    v83029: state_type > $o ).

tff(pred_def_44230,type,
    v83031: ( state_type * $int ) > $o ).

tff(pred_def_44231,type,
    v8: ( state_type * $int ) > $o ).

tff(pred_def_44232,type,
    v83028: ( state_type * $int ) > $o ).

tff(pred_def_44233,type,
    v83032: ( state_type * $int ) > $o ).

tff(pred_def_44234,type,
    v83034: ( state_type * $int ) > $o ).

tff(pred_def_44235,type,
    v83033: state_type > $o ).

tff(pred_def_44236,type,
    v83035: state_type > $o ).

tff(pred_def_44237,type,
    v83036: state_type > $o ).

tff(pred_def_44238,type,
    v83008: ( state_type * $int ) > $o ).

tff(pred_def_44239,type,
    v83012: state_type > $o ).

tff(pred_def_44240,type,
    v83013: ( state_type * $int ) > $o ).

tff(pred_def_44241,type,
    v83022: state_type > $o ).

tff(pred_def_44242,type,
    v82932: ( state_type * $int ) > $o ).

tff(pred_def_44243,type,
    v82930: ( state_type * $int ) > $o ).

tff(pred_def_44244,type,
    v82928: ( state_type * $int ) > $o ).

tff(pred_def_44245,type,
    v82926: ( state_type * $int ) > $o ).

tff(pred_def_44246,type,
    v82924: ( state_type * $int ) > $o ).

tff(pred_def_44247,type,
    v83050: state_type > $o ).

tff(pred_def_44248,type,
    v83048: state_type > $o ).

tff(pred_def_44249,type,
    v83054: state_type > $o ).

tff(pred_def_44250,type,
    v83052: state_type > $o ).

tff(pred_def_44251,type,
    v83082: state_type > $o ).

tff(pred_def_44252,type,
    v83080: state_type > $o ).

tff(pred_def_44253,type,
    v83086: state_type > $o ).

tff(pred_def_44254,type,
    v83084: state_type > $o ).

tff(pred_def_44255,type,
    v83108: state_type > $o ).

tff(pred_def_44256,type,
    v83106: state_type > $o ).

tff(pred_def_44257,type,
    v83112: state_type > $o ).

tff(pred_def_44258,type,
    v83110: state_type > $o ).

tff(pred_def_44259,type,
    v83130: state_type > $o ).

tff(pred_def_44260,type,
    v83128: state_type > $o ).

tff(pred_def_44261,type,
    v83134: state_type > $o ).

tff(pred_def_44262,type,
    v83132: state_type > $o ).

tff(pred_def_44263,type,
    v83122: ( state_type * $int ) > $o ).

tff(pred_def_44264,type,
    v83145: state_type > $o ).

tff(pred_def_44265,type,
    v83146: state_type > $o ).

tff(pred_def_44266,type,
    v83144: state_type > $o ).

tff(pred_def_44267,type,
    v83152: state_type > $o ).

tff(pred_def_44268,type,
    v83151: state_type > $o ).

tff(pred_def_44269,type,
    v83153: state_type > $o ).

tff(pred_def_44270,type,
    v83150: state_type > $o ).

tff(pred_def_44271,type,
    v83154: state_type > $o ).

tff(pred_def_44272,type,
    v83149: state_type > $o ).

tff(pred_def_44273,type,
    v83157: state_type > $o ).

tff(pred_def_44274,type,
    v83158: state_type > $o ).

tff(pred_def_44275,type,
    v83156: state_type > $o ).

tff(pred_def_44276,type,
    v83159: state_type > $o ).

tff(pred_def_44277,type,
    v83155: state_type > $o ).

tff(pred_def_44278,type,
    v83147: ( state_type * $int ) > $o ).

tff(pred_def_44279,type,
    v83143: ( state_type * $int ) > $o ).

tff(pred_def_44280,type,
    v83142: ( state_type * $int ) > $o ).

tff(pred_def_44281,type,
    v83140: ( state_type * $int ) > $o ).

tff(pred_def_44282,type,
    v83175: state_type > $o ).

tff(pred_def_44283,type,
    v83173: state_type > $o ).

tff(pred_def_44284,type,
    v83179: state_type > $o ).

tff(pred_def_44285,type,
    v83177: state_type > $o ).

tff(pred_def_44286,type,
    v83197: state_type > $o ).

tff(pred_def_44287,type,
    v83195: state_type > $o ).

tff(pred_def_44288,type,
    v83201: state_type > $o ).

tff(pred_def_44289,type,
    v83199: state_type > $o ).

tff(pred_def_44290,type,
    v83227: state_type > $o ).

tff(pred_def_44291,type,
    v83225: state_type > $o ).

tff(pred_def_44292,type,
    v83231: state_type > $o ).

tff(pred_def_44293,type,
    v83229: state_type > $o ).

tff(pred_def_44294,type,
    v83243: ( state_type * $int ) > $o ).

tff(pred_def_44295,type,
    v83245: ( state_type * $int ) > $o ).

tff(pred_def_44296,type,
    v83249: state_type > $o ).

tff(pred_def_44297,type,
    v83038: state_type > $o ).

tff(pred_def_44298,type,
    v83248: ( state_type * $int ) > $o ).

tff(pred_def_44299,type,
    v83247: ( state_type * $int ) > $o ).

tff(pred_def_44300,type,
    v83253: state_type > $o ).

tff(pred_def_44301,type,
    v83252: ( state_type * $int ) > $o ).

tff(pred_def_44302,type,
    v83251: ( state_type * $int ) > $o ).

tff(pred_def_44303,type,
    v83250: ( state_type * $int ) > $o ).

tff(pred_def_44304,type,
    v83246: ( state_type * $int ) > $o ).

tff(pred_def_44305,type,
    v82922: ( state_type * $int ) > $o ).

tff(pred_def_44306,type,
    v82920: ( state_type * $int ) > $o ).

tff(pred_def_44307,type,
    v83260: state_type > $o ).

tff(pred_def_44308,type,
    v83258: state_type > $o ).

tff(pred_def_44309,type,
    v83256: state_type > $o ).

tff(pred_def_44310,type,
    v83267: state_type > $o ).

tff(pred_def_44311,type,
    v83265: state_type > $o ).

tff(pred_def_44312,type,
    v83264: state_type > $o ).

tff(pred_def_44313,type,
    v83263: state_type > $o ).

tff(pred_def_44314,type,
    v83275: state_type > $o ).

tff(pred_def_44315,type,
    v83276: state_type > $o ).

tff(pred_def_44316,type,
    v83274: state_type > $o ).

tff(pred_def_44317,type,
    v83271: ( state_type * $int ) > $o ).

tff(pred_def_44318,type,
    bxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_44319,type,
    v83273: ( state_type * $int ) > $o ).

tff(pred_def_44320,type,
    v83262: ( state_type * $int ) > $o ).

tff(pred_def_44321,type,
    v83282: state_type > $o ).

tff(pred_def_44322,type,
    v83280: state_type > $o ).

tff(pred_def_44323,type,
    v83286: state_type > $o ).

tff(pred_def_44324,type,
    v83284: state_type > $o ).

tff(pred_def_44325,type,
    v83292: ( state_type * $int ) > $o ).

tff(pred_def_44326,type,
    v83042: ( state_type * $int ) > $o ).

tff(pred_def_44327,type,
    v83298: state_type > $o ).

tff(pred_def_44328,type,
    v83064: state_type > $o ).

tff(pred_def_44329,type,
    v83296: state_type > $o ).

tff(pred_def_44330,type,
    v83294: state_type > $o ).

tff(pred_def_44331,type,
    v83302: state_type > $o ).

tff(pred_def_44332,type,
    v83301: ( state_type * $int ) > $o ).

tff(pred_def_44333,type,
    v83300: ( state_type * $int ) > $o ).

tff(pred_def_44334,type,
    v83306: state_type > $o ).

tff(pred_def_44335,type,
    v83305: ( state_type * $int ) > $o ).

tff(pred_def_44336,type,
    v83304: ( state_type * $int ) > $o ).

tff(pred_def_44337,type,
    v83303: ( state_type * $int ) > $o ).

tff(pred_def_44338,type,
    v83299: ( state_type * $int ) > $o ).

tff(pred_def_44339,type,
    v83290: ( state_type * $int ) > $o ).

tff(pred_def_44340,type,
    v83288: ( state_type * $int ) > $o ).

tff(pred_def_44341,type,
    v83310: state_type > $o ).

tff(pred_def_44342,type,
    v83308: state_type > $o ).

tff(pred_def_44343,type,
    v83317: state_type > $o ).

tff(pred_def_44344,type,
    v83315: state_type > $o ).

tff(pred_def_44345,type,
    v83314: state_type > $o ).

tff(pred_def_44346,type,
    v83313: state_type > $o ).

tff(pred_def_44347,type,
    v83325: state_type > $o ).

tff(pred_def_44348,type,
    v83326: state_type > $o ).

tff(pred_def_44349,type,
    v83324: state_type > $o ).

tff(pred_def_44350,type,
    v83321: ( state_type * $int ) > $o ).

tff(pred_def_44351,type,
    v83323: ( state_type * $int ) > $o ).

tff(pred_def_44352,type,
    v83312: ( state_type * $int ) > $o ).

tff(pred_def_44353,type,
    v83332: state_type > $o ).

tff(pred_def_44354,type,
    v83330: state_type > $o ).

tff(pred_def_44355,type,
    v83336: state_type > $o ).

tff(pred_def_44356,type,
    v83334: state_type > $o ).

tff(pred_def_44357,type,
    v83342: ( state_type * $int ) > $o ).

tff(pred_def_44358,type,
    v83348: state_type > $o ).

tff(pred_def_44359,type,
    v83346: state_type > $o ).

tff(pred_def_44360,type,
    v83344: state_type > $o ).

tff(pred_def_44361,type,
    v83352: state_type > $o ).

tff(pred_def_44362,type,
    v83351: ( state_type * $int ) > $o ).

tff(pred_def_44363,type,
    v83350: ( state_type * $int ) > $o ).

tff(pred_def_44364,type,
    v83356: state_type > $o ).

tff(pred_def_44365,type,
    v83355: ( state_type * $int ) > $o ).

tff(pred_def_44366,type,
    v83354: ( state_type * $int ) > $o ).

tff(pred_def_44367,type,
    v83353: ( state_type * $int ) > $o ).

tff(pred_def_44368,type,
    v83349: ( state_type * $int ) > $o ).

tff(pred_def_44369,type,
    v83340: ( state_type * $int ) > $o ).

tff(pred_def_44370,type,
    v83338: ( state_type * $int ) > $o ).

tff(pred_def_44371,type,
    v83360: state_type > $o ).

tff(pred_def_44372,type,
    v83358: state_type > $o ).

tff(pred_def_44373,type,
    v83367: state_type > $o ).

tff(pred_def_44374,type,
    v83365: state_type > $o ).

tff(pred_def_44375,type,
    v83364: state_type > $o ).

tff(pred_def_44376,type,
    v83363: state_type > $o ).

tff(pred_def_44377,type,
    v83375: state_type > $o ).

tff(pred_def_44378,type,
    v83376: state_type > $o ).

tff(pred_def_44379,type,
    v83374: state_type > $o ).

tff(pred_def_44380,type,
    v83371: ( state_type * $int ) > $o ).

tff(pred_def_44381,type,
    v83373: ( state_type * $int ) > $o ).

tff(pred_def_44382,type,
    v83362: ( state_type * $int ) > $o ).

tff(pred_def_44383,type,
    v83382: state_type > $o ).

tff(pred_def_44384,type,
    v83380: state_type > $o ).

tff(pred_def_44385,type,
    v83386: state_type > $o ).

tff(pred_def_44386,type,
    v83384: state_type > $o ).

tff(pred_def_44387,type,
    v83392: ( state_type * $int ) > $o ).

tff(pred_def_44388,type,
    v83398: state_type > $o ).

tff(pred_def_44389,type,
    v83396: state_type > $o ).

tff(pred_def_44390,type,
    v83394: state_type > $o ).

tff(pred_def_44391,type,
    v83402: state_type > $o ).

tff(pred_def_44392,type,
    v83401: ( state_type * $int ) > $o ).

tff(pred_def_44393,type,
    v83400: ( state_type * $int ) > $o ).

tff(pred_def_44394,type,
    v83406: state_type > $o ).

tff(pred_def_44395,type,
    v83405: ( state_type * $int ) > $o ).

tff(pred_def_44396,type,
    v83404: ( state_type * $int ) > $o ).

tff(pred_def_44397,type,
    v83403: ( state_type * $int ) > $o ).

tff(pred_def_44398,type,
    v83399: ( state_type * $int ) > $o ).

tff(pred_def_44399,type,
    v83390: ( state_type * $int ) > $o ).

tff(pred_def_44400,type,
    v83388: ( state_type * $int ) > $o ).

tff(pred_def_44401,type,
    v83410: state_type > $o ).

tff(pred_def_44402,type,
    v83408: state_type > $o ).

tff(pred_def_44403,type,
    v83417: state_type > $o ).

tff(pred_def_44404,type,
    v83415: state_type > $o ).

tff(pred_def_44405,type,
    v83414: state_type > $o ).

tff(pred_def_44406,type,
    v83413: state_type > $o ).

tff(pred_def_44407,type,
    v83425: state_type > $o ).

tff(pred_def_44408,type,
    v83426: state_type > $o ).

tff(pred_def_44409,type,
    v83424: state_type > $o ).

tff(pred_def_44410,type,
    v83421: ( state_type * $int ) > $o ).

tff(pred_def_44411,type,
    v83423: ( state_type * $int ) > $o ).

tff(pred_def_44412,type,
    v83412: ( state_type * $int ) > $o ).

tff(pred_def_44413,type,
    v83432: state_type > $o ).

tff(pred_def_44414,type,
    v83430: state_type > $o ).

tff(pred_def_44415,type,
    v83436: state_type > $o ).

tff(pred_def_44416,type,
    v83434: state_type > $o ).

tff(pred_def_44417,type,
    v83442: ( state_type * $int ) > $o ).

tff(pred_def_44418,type,
    v83448: state_type > $o ).

tff(pred_def_44419,type,
    v83446: state_type > $o ).

tff(pred_def_44420,type,
    v83444: state_type > $o ).

tff(pred_def_44421,type,
    v83452: state_type > $o ).

tff(pred_def_44422,type,
    v83451: ( state_type * $int ) > $o ).

tff(pred_def_44423,type,
    v83450: ( state_type * $int ) > $o ).

tff(pred_def_44424,type,
    v83456: state_type > $o ).

tff(pred_def_44425,type,
    v83455: ( state_type * $int ) > $o ).

tff(pred_def_44426,type,
    v83454: ( state_type * $int ) > $o ).

tff(pred_def_44427,type,
    v83453: ( state_type * $int ) > $o ).

tff(pred_def_44428,type,
    v83449: ( state_type * $int ) > $o ).

tff(pred_def_44429,type,
    v83440: ( state_type * $int ) > $o ).

tff(pred_def_44430,type,
    v83438: ( state_type * $int ) > $o ).

tff(pred_def_44431,type,
    v83460: state_type > $o ).

tff(pred_def_44432,type,
    v83458: state_type > $o ).

tff(pred_def_44433,type,
    v83467: state_type > $o ).

tff(pred_def_44434,type,
    v83465: state_type > $o ).

tff(pred_def_44435,type,
    v83464: state_type > $o ).

tff(pred_def_44436,type,
    v83463: state_type > $o ).

tff(pred_def_44437,type,
    v83475: state_type > $o ).

tff(pred_def_44438,type,
    v83476: state_type > $o ).

tff(pred_def_44439,type,
    v83474: state_type > $o ).

tff(pred_def_44440,type,
    v83471: ( state_type * $int ) > $o ).

tff(pred_def_44441,type,
    v83473: ( state_type * $int ) > $o ).

tff(pred_def_44442,type,
    v83462: ( state_type * $int ) > $o ).

tff(pred_def_44443,type,
    v83482: state_type > $o ).

tff(pred_def_44444,type,
    v83480: state_type > $o ).

tff(pred_def_44445,type,
    v83486: state_type > $o ).

tff(pred_def_44446,type,
    v83484: state_type > $o ).

tff(pred_def_44447,type,
    v83492: ( state_type * $int ) > $o ).

tff(pred_def_44448,type,
    v83498: state_type > $o ).

tff(pred_def_44449,type,
    v83496: state_type > $o ).

tff(pred_def_44450,type,
    v83494: state_type > $o ).

tff(pred_def_44451,type,
    v83502: state_type > $o ).

tff(pred_def_44452,type,
    v83501: ( state_type * $int ) > $o ).

tff(pred_def_44453,type,
    v83500: ( state_type * $int ) > $o ).

tff(pred_def_44454,type,
    v83506: state_type > $o ).

tff(pred_def_44455,type,
    v83505: ( state_type * $int ) > $o ).

tff(pred_def_44456,type,
    v83504: ( state_type * $int ) > $o ).

tff(pred_def_44457,type,
    v83503: ( state_type * $int ) > $o ).

tff(pred_def_44458,type,
    v83499: ( state_type * $int ) > $o ).

tff(pred_def_44459,type,
    v83490: ( state_type * $int ) > $o ).

tff(pred_def_44460,type,
    v83488: ( state_type * $int ) > $o ).

tff(pred_def_44461,type,
    v83510: state_type > $o ).

tff(pred_def_44462,type,
    v83508: state_type > $o ).

tff(pred_def_44463,type,
    v83517: state_type > $o ).

tff(pred_def_44464,type,
    v83515: state_type > $o ).

tff(pred_def_44465,type,
    v83514: state_type > $o ).

tff(pred_def_44466,type,
    v83513: state_type > $o ).

tff(pred_def_44467,type,
    v83525: state_type > $o ).

tff(pred_def_44468,type,
    v83526: state_type > $o ).

tff(pred_def_44469,type,
    v83524: state_type > $o ).

tff(pred_def_44470,type,
    v83521: ( state_type * $int ) > $o ).

tff(pred_def_44471,type,
    v83523: ( state_type * $int ) > $o ).

tff(pred_def_44472,type,
    v83512: ( state_type * $int ) > $o ).

tff(pred_def_44473,type,
    v83532: state_type > $o ).

tff(pred_def_44474,type,
    v83530: state_type > $o ).

tff(pred_def_44475,type,
    v83536: state_type > $o ).

tff(pred_def_44476,type,
    v83534: state_type > $o ).

tff(pred_def_44477,type,
    v83542: ( state_type * $int ) > $o ).

tff(pred_def_44478,type,
    v83548: state_type > $o ).

tff(pred_def_44479,type,
    v83546: state_type > $o ).

tff(pred_def_44480,type,
    v83544: state_type > $o ).

tff(pred_def_44481,type,
    v83552: state_type > $o ).

tff(pred_def_44482,type,
    v83551: ( state_type * $int ) > $o ).

tff(pred_def_44483,type,
    v83550: ( state_type * $int ) > $o ).

tff(pred_def_44484,type,
    v83556: state_type > $o ).

tff(pred_def_44485,type,
    v83555: ( state_type * $int ) > $o ).

tff(pred_def_44486,type,
    v83554: ( state_type * $int ) > $o ).

tff(pred_def_44487,type,
    v83553: ( state_type * $int ) > $o ).

tff(pred_def_44488,type,
    v83549: ( state_type * $int ) > $o ).

tff(pred_def_44489,type,
    v83540: ( state_type * $int ) > $o ).

tff(pred_def_44490,type,
    v83538: ( state_type * $int ) > $o ).

tff(pred_def_44491,type,
    v83560: state_type > $o ).

tff(pred_def_44492,type,
    v83558: state_type > $o ).

tff(pred_def_44493,type,
    v83567: state_type > $o ).

tff(pred_def_44494,type,
    v83565: state_type > $o ).

tff(pred_def_44495,type,
    v83564: state_type > $o ).

tff(pred_def_44496,type,
    v83563: state_type > $o ).

tff(pred_def_44497,type,
    v83575: state_type > $o ).

tff(pred_def_44498,type,
    v83576: state_type > $o ).

tff(pred_def_44499,type,
    v83574: state_type > $o ).

tff(pred_def_44500,type,
    v83571: ( state_type * $int ) > $o ).

tff(pred_def_44501,type,
    v83573: ( state_type * $int ) > $o ).

tff(pred_def_44502,type,
    v83562: ( state_type * $int ) > $o ).

tff(pred_def_44503,type,
    v83582: state_type > $o ).

tff(pred_def_44504,type,
    v83580: state_type > $o ).

tff(pred_def_44505,type,
    v83586: state_type > $o ).

tff(pred_def_44506,type,
    v83584: state_type > $o ).

tff(pred_def_44507,type,
    v83592: ( state_type * $int ) > $o ).

tff(pred_def_44508,type,
    v83598: state_type > $o ).

tff(pred_def_44509,type,
    v83596: state_type > $o ).

tff(pred_def_44510,type,
    v83594: state_type > $o ).

tff(pred_def_44511,type,
    v83602: state_type > $o ).

tff(pred_def_44512,type,
    v83601: ( state_type * $int ) > $o ).

tff(pred_def_44513,type,
    v83600: ( state_type * $int ) > $o ).

tff(pred_def_44514,type,
    v83606: state_type > $o ).

tff(pred_def_44515,type,
    v83605: ( state_type * $int ) > $o ).

tff(pred_def_44516,type,
    v83604: ( state_type * $int ) > $o ).

tff(pred_def_44517,type,
    v83603: ( state_type * $int ) > $o ).

tff(pred_def_44518,type,
    v83599: ( state_type * $int ) > $o ).

tff(pred_def_44519,type,
    v83590: ( state_type * $int ) > $o ).

tff(pred_def_44520,type,
    v83588: ( state_type * $int ) > $o ).

tff(pred_def_44521,type,
    v83610: state_type > $o ).

tff(pred_def_44522,type,
    v83608: state_type > $o ).

tff(pred_def_44523,type,
    v83617: state_type > $o ).

tff(pred_def_44524,type,
    v83615: state_type > $o ).

tff(pred_def_44525,type,
    v83614: state_type > $o ).

tff(pred_def_44526,type,
    v83613: state_type > $o ).

tff(pred_def_44527,type,
    v83625: state_type > $o ).

tff(pred_def_44528,type,
    v83626: state_type > $o ).

tff(pred_def_44529,type,
    v83624: state_type > $o ).

tff(pred_def_44530,type,
    v83621: ( state_type * $int ) > $o ).

tff(pred_def_44531,type,
    v83623: ( state_type * $int ) > $o ).

tff(pred_def_44532,type,
    v83612: ( state_type * $int ) > $o ).

tff(pred_def_44533,type,
    v83632: state_type > $o ).

tff(pred_def_44534,type,
    v83630: state_type > $o ).

tff(pred_def_44535,type,
    v83636: state_type > $o ).

tff(pred_def_44536,type,
    v83634: state_type > $o ).

tff(pred_def_44537,type,
    v83642: ( state_type * $int ) > $o ).

tff(pred_def_44538,type,
    v83648: state_type > $o ).

tff(pred_def_44539,type,
    v83646: state_type > $o ).

tff(pred_def_44540,type,
    v83644: state_type > $o ).

tff(pred_def_44541,type,
    v83652: state_type > $o ).

tff(pred_def_44542,type,
    v83651: ( state_type * $int ) > $o ).

tff(pred_def_44543,type,
    v83650: ( state_type * $int ) > $o ).

tff(pred_def_44544,type,
    v83656: state_type > $o ).

tff(pred_def_44545,type,
    v83655: ( state_type * $int ) > $o ).

tff(pred_def_44546,type,
    v83654: ( state_type * $int ) > $o ).

tff(pred_def_44547,type,
    v83653: ( state_type * $int ) > $o ).

tff(pred_def_44548,type,
    v83649: ( state_type * $int ) > $o ).

tff(pred_def_44549,type,
    v83640: ( state_type * $int ) > $o ).

tff(pred_def_44550,type,
    v83638: ( state_type * $int ) > $o ).

tff(pred_def_44551,type,
    v83660: state_type > $o ).

tff(pred_def_44552,type,
    v83658: state_type > $o ).

tff(pred_def_44553,type,
    v83667: state_type > $o ).

tff(pred_def_44554,type,
    v83665: state_type > $o ).

tff(pred_def_44555,type,
    v83664: state_type > $o ).

tff(pred_def_44556,type,
    v83663: state_type > $o ).

tff(pred_def_44557,type,
    v83675: state_type > $o ).

tff(pred_def_44558,type,
    v83676: state_type > $o ).

tff(pred_def_44559,type,
    v83674: state_type > $o ).

tff(pred_def_44560,type,
    v83671: ( state_type * $int ) > $o ).

tff(pred_def_44561,type,
    v83673: ( state_type * $int ) > $o ).

tff(pred_def_44562,type,
    v83662: ( state_type * $int ) > $o ).

tff(pred_def_44563,type,
    v83682: state_type > $o ).

tff(pred_def_44564,type,
    v83680: state_type > $o ).

tff(pred_def_44565,type,
    v83686: state_type > $o ).

tff(pred_def_44566,type,
    v83684: state_type > $o ).

tff(pred_def_44567,type,
    v83692: ( state_type * $int ) > $o ).

tff(pred_def_44568,type,
    v83698: state_type > $o ).

tff(pred_def_44569,type,
    v83696: state_type > $o ).

tff(pred_def_44570,type,
    v83694: state_type > $o ).

tff(pred_def_44571,type,
    v83702: state_type > $o ).

tff(pred_def_44572,type,
    v83701: ( state_type * $int ) > $o ).

tff(pred_def_44573,type,
    v83700: ( state_type * $int ) > $o ).

tff(pred_def_44574,type,
    v83706: state_type > $o ).

tff(pred_def_44575,type,
    v83705: ( state_type * $int ) > $o ).

tff(pred_def_44576,type,
    v83704: ( state_type * $int ) > $o ).

tff(pred_def_44577,type,
    v83703: ( state_type * $int ) > $o ).

tff(pred_def_44578,type,
    v83699: ( state_type * $int ) > $o ).

tff(pred_def_44579,type,
    v83690: ( state_type * $int ) > $o ).

tff(pred_def_44580,type,
    v83688: ( state_type * $int ) > $o ).

tff(pred_def_44581,type,
    v83710: state_type > $o ).

tff(pred_def_44582,type,
    v83708: state_type > $o ).

tff(pred_def_44583,type,
    v83717: state_type > $o ).

tff(pred_def_44584,type,
    v83715: state_type > $o ).

tff(pred_def_44585,type,
    v83714: state_type > $o ).

tff(pred_def_44586,type,
    v83713: state_type > $o ).

tff(pred_def_44587,type,
    v83725: state_type > $o ).

tff(pred_def_44588,type,
    v83726: state_type > $o ).

tff(pred_def_44589,type,
    v83724: state_type > $o ).

tff(pred_def_44590,type,
    v83721: ( state_type * $int ) > $o ).

tff(pred_def_44591,type,
    v83723: ( state_type * $int ) > $o ).

tff(pred_def_44592,type,
    v83712: ( state_type * $int ) > $o ).

tff(pred_def_44593,type,
    v83732: state_type > $o ).

tff(pred_def_44594,type,
    v83730: state_type > $o ).

tff(pred_def_44595,type,
    v83736: state_type > $o ).

tff(pred_def_44596,type,
    v83734: state_type > $o ).

tff(pred_def_44597,type,
    v83742: ( state_type * $int ) > $o ).

tff(pred_def_44598,type,
    v83748: state_type > $o ).

tff(pred_def_44599,type,
    v83746: state_type > $o ).

tff(pred_def_44600,type,
    v83744: state_type > $o ).

tff(pred_def_44601,type,
    v83752: state_type > $o ).

tff(pred_def_44602,type,
    v83751: ( state_type * $int ) > $o ).

tff(pred_def_44603,type,
    v83750: ( state_type * $int ) > $o ).

tff(pred_def_44604,type,
    v83756: state_type > $o ).

tff(pred_def_44605,type,
    v83755: ( state_type * $int ) > $o ).

tff(pred_def_44606,type,
    v83754: ( state_type * $int ) > $o ).

tff(pred_def_44607,type,
    v83753: ( state_type * $int ) > $o ).

tff(pred_def_44608,type,
    v83749: ( state_type * $int ) > $o ).

tff(pred_def_44609,type,
    v83740: ( state_type * $int ) > $o ).

tff(pred_def_44610,type,
    v83738: ( state_type * $int ) > $o ).

tff(pred_def_44611,type,
    v83760: state_type > $o ).

tff(pred_def_44612,type,
    v83758: state_type > $o ).

tff(pred_def_44613,type,
    v83767: state_type > $o ).

tff(pred_def_44614,type,
    v83765: state_type > $o ).

tff(pred_def_44615,type,
    v83764: state_type > $o ).

tff(pred_def_44616,type,
    v83763: state_type > $o ).

tff(pred_def_44617,type,
    v83775: state_type > $o ).

tff(pred_def_44618,type,
    v83776: state_type > $o ).

tff(pred_def_44619,type,
    v83774: state_type > $o ).

tff(pred_def_44620,type,
    v83771: ( state_type * $int ) > $o ).

tff(pred_def_44621,type,
    v83773: ( state_type * $int ) > $o ).

tff(pred_def_44622,type,
    v83762: ( state_type * $int ) > $o ).

tff(pred_def_44623,type,
    v83782: state_type > $o ).

tff(pred_def_44624,type,
    v83780: state_type > $o ).

tff(pred_def_44625,type,
    v83786: state_type > $o ).

tff(pred_def_44626,type,
    v83784: state_type > $o ).

tff(pred_def_44627,type,
    v83792: ( state_type * $int ) > $o ).

tff(pred_def_44628,type,
    v83798: state_type > $o ).

tff(pred_def_44629,type,
    v83796: state_type > $o ).

tff(pred_def_44630,type,
    v83794: state_type > $o ).

tff(pred_def_44631,type,
    v83802: state_type > $o ).

tff(pred_def_44632,type,
    v83801: ( state_type * $int ) > $o ).

tff(pred_def_44633,type,
    v83800: ( state_type * $int ) > $o ).

tff(pred_def_44634,type,
    v83806: state_type > $o ).

tff(pred_def_44635,type,
    v83805: ( state_type * $int ) > $o ).

tff(pred_def_44636,type,
    v83804: ( state_type * $int ) > $o ).

tff(pred_def_44637,type,
    v83803: ( state_type * $int ) > $o ).

tff(pred_def_44638,type,
    v83799: ( state_type * $int ) > $o ).

tff(pred_def_44639,type,
    v83790: ( state_type * $int ) > $o ).

tff(pred_def_44640,type,
    v83788: ( state_type * $int ) > $o ).

tff(pred_def_44641,type,
    v83810: state_type > $o ).

tff(pred_def_44642,type,
    v83808: state_type > $o ).

tff(pred_def_44643,type,
    v83817: state_type > $o ).

tff(pred_def_44644,type,
    v83815: state_type > $o ).

tff(pred_def_44645,type,
    v83814: state_type > $o ).

tff(pred_def_44646,type,
    v83813: state_type > $o ).

tff(pred_def_44647,type,
    v83825: state_type > $o ).

tff(pred_def_44648,type,
    v83826: state_type > $o ).

tff(pred_def_44649,type,
    v83824: state_type > $o ).

tff(pred_def_44650,type,
    v83821: ( state_type * $int ) > $o ).

tff(pred_def_44651,type,
    v83823: ( state_type * $int ) > $o ).

tff(pred_def_44652,type,
    v83812: ( state_type * $int ) > $o ).

tff(pred_def_44653,type,
    v83832: state_type > $o ).

tff(pred_def_44654,type,
    v83830: state_type > $o ).

tff(pred_def_44655,type,
    v83836: state_type > $o ).

tff(pred_def_44656,type,
    v83834: state_type > $o ).

tff(pred_def_44657,type,
    v83842: ( state_type * $int ) > $o ).

tff(pred_def_44658,type,
    v83848: state_type > $o ).

tff(pred_def_44659,type,
    v83846: state_type > $o ).

tff(pred_def_44660,type,
    v83844: state_type > $o ).

tff(pred_def_44661,type,
    v83852: state_type > $o ).

tff(pred_def_44662,type,
    v83851: ( state_type * $int ) > $o ).

tff(pred_def_44663,type,
    v83850: ( state_type * $int ) > $o ).

tff(pred_def_44664,type,
    v83856: state_type > $o ).

tff(pred_def_44665,type,
    v83855: ( state_type * $int ) > $o ).

tff(pred_def_44666,type,
    v83854: ( state_type * $int ) > $o ).

tff(pred_def_44667,type,
    v83853: ( state_type * $int ) > $o ).

tff(pred_def_44668,type,
    v83849: ( state_type * $int ) > $o ).

tff(pred_def_44669,type,
    v83840: ( state_type * $int ) > $o ).

tff(pred_def_44670,type,
    v83838: ( state_type * $int ) > $o ).

tff(pred_def_44671,type,
    v83860: state_type > $o ).

tff(pred_def_44672,type,
    v83858: state_type > $o ).

tff(pred_def_44673,type,
    v83867: state_type > $o ).

tff(pred_def_44674,type,
    v83865: state_type > $o ).

tff(pred_def_44675,type,
    v83864: state_type > $o ).

tff(pred_def_44676,type,
    v83863: state_type > $o ).

tff(pred_def_44677,type,
    v83875: state_type > $o ).

tff(pred_def_44678,type,
    v83876: state_type > $o ).

tff(pred_def_44679,type,
    v83874: state_type > $o ).

tff(pred_def_44680,type,
    v83871: ( state_type * $int ) > $o ).

tff(pred_def_44681,type,
    v83873: ( state_type * $int ) > $o ).

tff(pred_def_44682,type,
    v83862: ( state_type * $int ) > $o ).

tff(pred_def_44683,type,
    v83882: state_type > $o ).

tff(pred_def_44684,type,
    v83880: state_type > $o ).

tff(pred_def_44685,type,
    v83886: state_type > $o ).

tff(pred_def_44686,type,
    v83884: state_type > $o ).

tff(pred_def_44687,type,
    v83892: ( state_type * $int ) > $o ).

tff(pred_def_44688,type,
    v83898: state_type > $o ).

tff(pred_def_44689,type,
    v83896: state_type > $o ).

tff(pred_def_44690,type,
    v83894: state_type > $o ).

tff(pred_def_44691,type,
    v83902: state_type > $o ).

tff(pred_def_44692,type,
    v83901: ( state_type * $int ) > $o ).

tff(pred_def_44693,type,
    v83900: ( state_type * $int ) > $o ).

tff(pred_def_44694,type,
    v83906: state_type > $o ).

tff(pred_def_44695,type,
    v83905: ( state_type * $int ) > $o ).

tff(pred_def_44696,type,
    v83904: ( state_type * $int ) > $o ).

tff(pred_def_44697,type,
    v83903: ( state_type * $int ) > $o ).

tff(pred_def_44698,type,
    v83899: ( state_type * $int ) > $o ).

tff(pred_def_44699,type,
    v83890: ( state_type * $int ) > $o ).

tff(pred_def_44700,type,
    v83888: ( state_type * $int ) > $o ).

tff(pred_def_44701,type,
    v83910: state_type > $o ).

tff(pred_def_44702,type,
    v83908: state_type > $o ).

tff(pred_def_44703,type,
    v83917: state_type > $o ).

tff(pred_def_44704,type,
    v83915: state_type > $o ).

tff(pred_def_44705,type,
    v83914: state_type > $o ).

tff(pred_def_44706,type,
    v83913: state_type > $o ).

tff(pred_def_44707,type,
    v83925: state_type > $o ).

tff(pred_def_44708,type,
    v83926: state_type > $o ).

tff(pred_def_44709,type,
    v83924: state_type > $o ).

tff(pred_def_44710,type,
    v83921: ( state_type * $int ) > $o ).

tff(pred_def_44711,type,
    v83923: ( state_type * $int ) > $o ).

tff(pred_def_44712,type,
    v83912: ( state_type * $int ) > $o ).

tff(pred_def_44713,type,
    v83932: state_type > $o ).

tff(pred_def_44714,type,
    v83930: state_type > $o ).

tff(pred_def_44715,type,
    v83936: state_type > $o ).

tff(pred_def_44716,type,
    v83934: state_type > $o ).

tff(pred_def_44717,type,
    v83942: ( state_type * $int ) > $o ).

tff(pred_def_44718,type,
    v83948: state_type > $o ).

tff(pred_def_44719,type,
    v83946: state_type > $o ).

tff(pred_def_44720,type,
    v83944: state_type > $o ).

tff(pred_def_44721,type,
    v83952: state_type > $o ).

tff(pred_def_44722,type,
    v83951: ( state_type * $int ) > $o ).

tff(pred_def_44723,type,
    v83950: ( state_type * $int ) > $o ).

tff(pred_def_44724,type,
    v83956: state_type > $o ).

tff(pred_def_44725,type,
    v83955: ( state_type * $int ) > $o ).

tff(pred_def_44726,type,
    v83954: ( state_type * $int ) > $o ).

tff(pred_def_44727,type,
    v83953: ( state_type * $int ) > $o ).

tff(pred_def_44728,type,
    v83949: ( state_type * $int ) > $o ).

tff(pred_def_44729,type,
    v83940: ( state_type * $int ) > $o ).

tff(pred_def_44730,type,
    v83938: ( state_type * $int ) > $o ).

tff(pred_def_44731,type,
    v83960: state_type > $o ).

tff(pred_def_44732,type,
    v83958: state_type > $o ).

tff(pred_def_44733,type,
    v83967: state_type > $o ).

tff(pred_def_44734,type,
    v83965: state_type > $o ).

tff(pred_def_44735,type,
    v83964: state_type > $o ).

tff(pred_def_44736,type,
    v83963: state_type > $o ).

tff(pred_def_44737,type,
    v83975: state_type > $o ).

tff(pred_def_44738,type,
    v83976: state_type > $o ).

tff(pred_def_44739,type,
    v83974: state_type > $o ).

tff(pred_def_44740,type,
    v83971: ( state_type * $int ) > $o ).

tff(pred_def_44741,type,
    v83973: ( state_type * $int ) > $o ).

tff(pred_def_44742,type,
    v83962: ( state_type * $int ) > $o ).

tff(pred_def_44743,type,
    v83982: state_type > $o ).

tff(pred_def_44744,type,
    v83980: state_type > $o ).

tff(pred_def_44745,type,
    v83986: state_type > $o ).

tff(pred_def_44746,type,
    v83984: state_type > $o ).

tff(pred_def_44747,type,
    v83992: ( state_type * $int ) > $o ).

tff(pred_def_44748,type,
    v83998: state_type > $o ).

tff(pred_def_44749,type,
    v83996: state_type > $o ).

tff(pred_def_44750,type,
    v83994: state_type > $o ).

tff(pred_def_44751,type,
    v84002: state_type > $o ).

tff(pred_def_44752,type,
    v84001: ( state_type * $int ) > $o ).

tff(pred_def_44753,type,
    v84000: ( state_type * $int ) > $o ).

tff(pred_def_44754,type,
    v84006: state_type > $o ).

tff(pred_def_44755,type,
    v84005: ( state_type * $int ) > $o ).

tff(pred_def_44756,type,
    v84004: ( state_type * $int ) > $o ).

tff(pred_def_44757,type,
    v84003: ( state_type * $int ) > $o ).

tff(pred_def_44758,type,
    v83999: ( state_type * $int ) > $o ).

tff(pred_def_44759,type,
    v83990: ( state_type * $int ) > $o ).

tff(pred_def_44760,type,
    v83988: ( state_type * $int ) > $o ).

tff(pred_def_44761,type,
    v84010: state_type > $o ).

tff(pred_def_44762,type,
    v84008: state_type > $o ).

tff(pred_def_44763,type,
    v84017: state_type > $o ).

tff(pred_def_44764,type,
    v84015: state_type > $o ).

tff(pred_def_44765,type,
    v84014: state_type > $o ).

tff(pred_def_44766,type,
    v84013: state_type > $o ).

tff(pred_def_44767,type,
    v84025: state_type > $o ).

tff(pred_def_44768,type,
    v84026: state_type > $o ).

tff(pred_def_44769,type,
    v84024: state_type > $o ).

tff(pred_def_44770,type,
    v84021: ( state_type * $int ) > $o ).

tff(pred_def_44771,type,
    v84023: ( state_type * $int ) > $o ).

tff(pred_def_44772,type,
    v84012: ( state_type * $int ) > $o ).

tff(pred_def_44773,type,
    v84032: state_type > $o ).

tff(pred_def_44774,type,
    v84031: state_type > $o ).

tff(pred_def_44775,type,
    v84030: state_type > $o ).

tff(pred_def_44776,type,
    v83239: state_type > $o ).

tff(pred_def_44777,type,
    v83237: state_type > $o ).

tff(pred_def_44778,type,
    v83235: state_type > $o ).

tff(pred_def_44779,type,
    v83233: state_type > $o ).

tff(pred_def_44780,type,
    v84036: state_type > $o ).

tff(pred_def_44781,type,
    v84034: state_type > $o ).

tff(pred_def_44782,type,
    v84043: state_type > $o ).

tff(pred_def_44783,type,
    v84041: state_type > $o ).

tff(pred_def_44784,type,
    v84040: state_type > $o ).

tff(pred_def_44785,type,
    v84039: state_type > $o ).

tff(pred_def_44786,type,
    v84051: state_type > $o ).

tff(pred_def_44787,type,
    v84052: state_type > $o ).

tff(pred_def_44788,type,
    v84050: state_type > $o ).

tff(pred_def_44789,type,
    v84047: state_type > $o ).

tff(pred_def_44790,type,
    v84049: state_type > $o ).

tff(pred_def_44791,type,
    v83223: state_type > $o ).

tff(pred_def_44792,type,
    v83221: state_type > $o ).

tff(pred_def_44793,type,
    v83219: state_type > $o ).

tff(pred_def_44794,type,
    v84058: state_type > $o ).

tff(pred_def_44795,type,
    v84057: state_type > $o ).

tff(pred_def_44796,type,
    v1025: state_type > $o ).

tff(pred_def_44797,type,
    v84056: state_type > $o ).

tff(pred_def_44798,type,
    v83217: state_type > $o ).

tff(pred_def_44799,type,
    v83215: state_type > $o ).

tff(pred_def_44800,type,
    v83213: state_type > $o ).

tff(pred_def_44801,type,
    v84059: ( state_type * $int ) > $o ).

tff(pred_def_44802,type,
    v83211: state_type > $o ).

tff(pred_def_44803,type,
    v83209: state_type > $o ).

tff(pred_def_44804,type,
    v83207: ( state_type * $int ) > $o ).

tff(pred_def_44805,type,
    v83205: ( state_type * $int ) > $o ).

tff(pred_def_44806,type,
    v83203: ( state_type * $int ) > $o ).

tff(pred_def_44807,type,
    v84063: state_type > $o ).

tff(pred_def_44808,type,
    v84061: state_type > $o ).

tff(pred_def_44809,type,
    v84070: state_type > $o ).

tff(pred_def_44810,type,
    v84068: state_type > $o ).

tff(pred_def_44811,type,
    v84067: state_type > $o ).

tff(pred_def_44812,type,
    v84066: state_type > $o ).

tff(pred_def_44813,type,
    v84078: state_type > $o ).

tff(pred_def_44814,type,
    v84079: state_type > $o ).

tff(pred_def_44815,type,
    v84077: state_type > $o ).

tff(pred_def_44816,type,
    v84074: ( state_type * $int ) > $o ).

tff(pred_def_44817,type,
    v84076: ( state_type * $int ) > $o ).

tff(pred_def_44818,type,
    v84065: ( state_type * $int ) > $o ).

tff(pred_def_44819,type,
    v83193: ( state_type * $int ) > $o ).

tff(pred_def_44820,type,
    v83191: ( state_type * $int ) > $o ).

tff(pred_def_44821,type,
    v84087: state_type > $o ).

tff(pred_def_44822,type,
    v84085: state_type > $o ).

tff(pred_def_44823,type,
    v84084: state_type > $o ).

tff(pred_def_44824,type,
    v84083: ( state_type * $int ) > $o ).

tff(pred_def_44825,type,
    v84095: state_type > $o ).

tff(pred_def_44826,type,
    v84093: state_type > $o ).

tff(pred_def_44827,type,
    v84092: state_type > $o ).

tff(pred_def_44828,type,
    v84091: ( state_type * $int ) > $o ).

tff(pred_def_44829,type,
    v83189: state_type > $o ).

tff(pred_def_44830,type,
    v84107: state_type > $o ).

tff(pred_def_44831,type,
    v84105: state_type > $o ).

tff(pred_def_44832,type,
    v84111: state_type > $o ).

tff(pred_def_44833,type,
    v84109: state_type > $o ).

tff(pred_def_44834,type,
    v84121: ( state_type * $int ) > $o ).

tff(pred_def_44835,type,
    v84124: state_type > $o ).

tff(pred_def_44836,type,
    v84123: state_type > $o ).

tff(pred_def_44837,type,
    v83165: state_type > $o ).

tff(pred_def_44838,type,
    v84099: state_type > $o ).

tff(pred_def_44839,type,
    v84127: state_type > $o ).

tff(pred_def_44840,type,
    v84126: state_type > $o ).

tff(pred_def_44841,type,
    v84119: state_type > $o ).

tff(pred_def_44842,type,
    v84117: state_type > $o ).

tff(pred_def_44843,type,
    v84115: state_type > $o ).

tff(pred_def_44844,type,
    v84113: state_type > $o ).

tff(pred_def_44845,type,
    v84131: state_type > $o ).

tff(pred_def_44846,type,
    v84129: state_type > $o ).

tff(pred_def_44847,type,
    v84138: state_type > $o ).

tff(pred_def_44848,type,
    v84136: state_type > $o ).

tff(pred_def_44849,type,
    v84135: state_type > $o ).

tff(pred_def_44850,type,
    v84134: state_type > $o ).

tff(pred_def_44851,type,
    v84146: state_type > $o ).

tff(pred_def_44852,type,
    v84147: state_type > $o ).

tff(pred_def_44853,type,
    v84145: state_type > $o ).

tff(pred_def_44854,type,
    v84142: state_type > $o ).

tff(pred_def_44855,type,
    v84144: state_type > $o ).

tff(pred_def_44856,type,
    v84103: state_type > $o ).

tff(pred_def_44857,type,
    v84101: state_type > $o ).

tff(pred_def_44858,type,
    v83167: ( state_type * $int ) > $o ).

tff(pred_def_44859,type,
    v84155: state_type > $o ).

tff(pred_def_44860,type,
    v84156: state_type > $o ).

tff(pred_def_44861,type,
    v84154: state_type > $o ).

tff(pred_def_44862,type,
    v84157: state_type > $o ).

tff(pred_def_44863,type,
    v84153: state_type > $o ).

tff(pred_def_44864,type,
    v84151: ( state_type * $int ) > $o ).

tff(pred_def_44865,type,
    v84160: state_type > $o ).

tff(pred_def_44866,type,
    v83163: state_type > $o ).

tff(pred_def_44867,type,
    v84159: state_type > $o ).

tff(pred_def_44868,type,
    v84158: ( state_type * $int ) > $o ).

tff(pred_def_44869,type,
    v83187: ( state_type * $int ) > $o ).

tff(pred_def_44870,type,
    v83185: ( state_type * $int ) > $o ).

tff(pred_def_44871,type,
    v83183: ( state_type * $int ) > $o ).

tff(pred_def_44872,type,
    v83181: ( state_type * $int ) > $o ).

tff(pred_def_44873,type,
    v84164: state_type > $o ).

tff(pred_def_44874,type,
    v84162: state_type > $o ).

tff(pred_def_44875,type,
    v84171: state_type > $o ).

tff(pred_def_44876,type,
    v84169: state_type > $o ).

tff(pred_def_44877,type,
    v84168: state_type > $o ).

tff(pred_def_44878,type,
    v84167: state_type > $o ).

tff(pred_def_44879,type,
    v84179: state_type > $o ).

tff(pred_def_44880,type,
    v84180: state_type > $o ).

tff(pred_def_44881,type,
    v84178: state_type > $o ).

tff(pred_def_44882,type,
    v84175: ( state_type * $int ) > $o ).

tff(pred_def_44883,type,
    v84177: ( state_type * $int ) > $o ).

tff(pred_def_44884,type,
    v83171: ( state_type * $int ) > $o ).

tff(pred_def_44885,type,
    v83169: ( state_type * $int ) > $o ).

tff(pred_def_44886,type,
    v84199: state_type > $o ).

tff(pred_def_44887,type,
    v84197: state_type > $o ).

tff(pred_def_44888,type,
    v84203: state_type > $o ).

tff(pred_def_44889,type,
    v84201: state_type > $o ).

tff(pred_def_44890,type,
    v84221: state_type > $o ).

tff(pred_def_44891,type,
    v84223: state_type > $o ).

tff(pred_def_44892,type,
    b000100: $int > $o ).

tff(pred_def_44893,type,
    v4530: ( state_type * $int ) > $o ).

tff(pred_def_44894,type,
    v84227: state_type > $o ).

tff(pred_def_44895,type,
    v84225: state_type > $o ).

tff(pred_def_44896,type,
    v84232: state_type > $o ).

tff(pred_def_44897,type,
    v84219: state_type > $o ).

tff(pred_def_44898,type,
    v84239: state_type > $o ).

tff(pred_def_44899,type,
    v84237: state_type > $o ).

tff(pred_def_44900,type,
    v84236: state_type > $o ).

tff(pred_def_44901,type,
    v84235: state_type > $o ).

tff(pred_def_44902,type,
    v84247: state_type > $o ).

tff(pred_def_44903,type,
    v84248: state_type > $o ).

tff(pred_def_44904,type,
    v84246: state_type > $o ).

tff(pred_def_44905,type,
    v84243: state_type > $o ).

tff(pred_def_44906,type,
    x84230: state_type > $o ).

tff(pred_def_44907,type,
    v84245: state_type > $o ).

tff(pred_def_44908,type,
    v84217: state_type > $o ).

tff(pred_def_44909,type,
    v84251: ( state_type * $int ) > $o ).

tff(pred_def_44910,type,
    v84213: state_type > $o ).

tff(pred_def_44911,type,
    v84211: state_type > $o ).

tff(pred_def_44912,type,
    v84209: ( state_type * $int ) > $o ).

tff(pred_def_44913,type,
    v84207: ( state_type * $int ) > $o ).

tff(pred_def_44914,type,
    v84205: ( state_type * $int ) > $o ).

tff(pred_def_44915,type,
    v84255: state_type > $o ).

tff(pred_def_44916,type,
    v84253: state_type > $o ).

tff(pred_def_44917,type,
    v84262: state_type > $o ).

tff(pred_def_44918,type,
    v84260: state_type > $o ).

tff(pred_def_44919,type,
    v84259: state_type > $o ).

tff(pred_def_44920,type,
    v84258: state_type > $o ).

tff(pred_def_44921,type,
    v84270: state_type > $o ).

tff(pred_def_44922,type,
    v84271: state_type > $o ).

tff(pred_def_44923,type,
    v84269: state_type > $o ).

tff(pred_def_44924,type,
    v84266: ( state_type * $int ) > $o ).

tff(pred_def_44925,type,
    v84268: ( state_type * $int ) > $o ).

tff(pred_def_44926,type,
    v84257: ( state_type * $int ) > $o ).

tff(pred_def_44927,type,
    v84195: ( state_type * $int ) > $o ).

tff(pred_def_44928,type,
    v84193: ( state_type * $int ) > $o ).

tff(pred_def_44929,type,
    v84215: state_type > $o ).

tff(pred_def_44930,type,
    v84275: state_type > $o ).

tff(pred_def_44931,type,
    v84276: state_type > $o ).

tff(pred_def_44932,type,
    v84282: state_type > $o ).

tff(pred_def_44933,type,
    v84280: state_type > $o ).

tff(pred_def_44934,type,
    v84279: state_type > $o ).

tff(pred_def_44935,type,
    v84278: ( state_type * $int ) > $o ).

tff(pred_def_44936,type,
    v84290: state_type > $o ).

tff(pred_def_44937,type,
    v84288: state_type > $o ).

tff(pred_def_44938,type,
    v84287: state_type > $o ).

tff(pred_def_44939,type,
    v84286: ( state_type * $int ) > $o ).

tff(pred_def_44940,type,
    v84191: state_type > $o ).

tff(pred_def_44941,type,
    v84189: state_type > $o ).

tff(pred_def_44942,type,
    v84187: state_type > $o ).

tff(pred_def_44943,type,
    v84185: state_type > $o ).

tff(pred_def_44944,type,
    v84307: state_type > $o ).

tff(pred_def_44945,type,
    v84305: state_type > $o ).

tff(pred_def_44946,type,
    v84311: state_type > $o ).

tff(pred_def_44947,type,
    v84309: state_type > $o ).

tff(pred_def_44948,type,
    v84329: state_type > $o ).

tff(pred_def_44949,type,
    v84327: state_type > $o ).

tff(pred_def_44950,type,
    v84333: state_type > $o ).

tff(pred_def_44951,type,
    v84331: state_type > $o ).

tff(pred_def_44952,type,
    v84353: state_type > $o ).

tff(pred_def_44953,type,
    v84351: state_type > $o ).

tff(pred_def_44954,type,
    v84357: state_type > $o ).

tff(pred_def_44955,type,
    v84355: state_type > $o ).

tff(pred_def_44956,type,
    v84373: state_type > $o ).

tff(pred_def_44957,type,
    v84371: state_type > $o ).

tff(pred_def_44958,type,
    v84377: state_type > $o ).

tff(pred_def_44959,type,
    v84375: state_type > $o ).

tff(pred_def_44960,type,
    v84391: state_type > $o ).

tff(pred_def_44961,type,
    v84393: state_type > $o ).

tff(pred_def_44962,type,
    v84389: state_type > $o ).

tff(pred_def_44963,type,
    v84387: state_type > $o ).

tff(pred_def_44964,type,
    v84385: state_type > $o ).

tff(pred_def_44965,type,
    v84383: state_type > $o ).

tff(pred_def_44966,type,
    v84399: ( state_type * $int ) > $o ).

tff(pred_def_44967,type,
    v84401: ( state_type * $int ) > $o ).

tff(pred_def_44968,type,
    v84397: state_type > $o ).

tff(pred_def_44969,type,
    v84395: state_type > $o ).

tff(pred_def_44970,type,
    v84405: state_type > $o ).

tff(pred_def_44971,type,
    v84404: state_type > $o ).

tff(pred_def_44972,type,
    v84403: state_type > $o ).

tff(pred_def_44973,type,
    v84409: state_type > $o ).

tff(pred_def_44974,type,
    v84408: state_type > $o ).

tff(pred_def_44975,type,
    v84407: state_type > $o ).

tff(pred_def_44976,type,
    v84367: state_type > $o ).

tff(pred_def_44977,type,
    v84406: state_type > $o ).

tff(pred_def_44978,type,
    v84381: state_type > $o ).

tff(pred_def_44979,type,
    v84379: state_type > $o ).

tff(pred_def_44980,type,
    v84413: state_type > $o ).

tff(pred_def_44981,type,
    v84411: state_type > $o ).

tff(pred_def_44982,type,
    v84420: state_type > $o ).

tff(pred_def_44983,type,
    v84418: state_type > $o ).

tff(pred_def_44984,type,
    v84417: state_type > $o ).

tff(pred_def_44985,type,
    v84416: state_type > $o ).

tff(pred_def_44986,type,
    v84428: state_type > $o ).

tff(pred_def_44987,type,
    v84429: state_type > $o ).

tff(pred_def_44988,type,
    v84427: state_type > $o ).

tff(pred_def_44989,type,
    v84424: state_type > $o ).

tff(pred_def_44990,type,
    v84426: state_type > $o ).

tff(pred_def_44991,type,
    v84369: state_type > $o ).

tff(pred_def_44992,type,
    v84365: state_type > $o ).

tff(pred_def_44993,type,
    v84363: state_type > $o ).

tff(pred_def_44994,type,
    v84434: state_type > $o ).

tff(pred_def_44995,type,
    v84438: state_type > $o ).

tff(pred_def_44996,type,
    v84437: state_type > $o ).

tff(pred_def_44997,type,
    v84436: state_type > $o ).

tff(pred_def_44998,type,
    v84442: state_type > $o ).

tff(pred_def_44999,type,
    v84441: state_type > $o ).

tff(pred_def_45000,type,
    v84440: state_type > $o ).

tff(pred_def_45001,type,
    v84347: state_type > $o ).

tff(pred_def_45002,type,
    v84439: state_type > $o ).

tff(pred_def_45003,type,
    v84361: state_type > $o ).

tff(pred_def_45004,type,
    v84359: state_type > $o ).

tff(pred_def_45005,type,
    v84446: state_type > $o ).

tff(pred_def_45006,type,
    v84444: state_type > $o ).

tff(pred_def_45007,type,
    v84453: state_type > $o ).

tff(pred_def_45008,type,
    v84451: state_type > $o ).

tff(pred_def_45009,type,
    v84450: state_type > $o ).

tff(pred_def_45010,type,
    v84449: state_type > $o ).

tff(pred_def_45011,type,
    v84461: state_type > $o ).

tff(pred_def_45012,type,
    v84462: state_type > $o ).

tff(pred_def_45013,type,
    v84460: state_type > $o ).

tff(pred_def_45014,type,
    v84457: state_type > $o ).

tff(pred_def_45015,type,
    v84459: state_type > $o ).

tff(pred_def_45016,type,
    v84349: state_type > $o ).

tff(pred_def_45017,type,
    v84345: state_type > $o ).

tff(pred_def_45018,type,
    v84343: state_type > $o ).

tff(pred_def_45019,type,
    v84341: state_type > $o ).

tff(pred_def_45020,type,
    v84339: state_type > $o ).

tff(pred_def_45021,type,
    v84337: state_type > $o ).

tff(pred_def_45022,type,
    v84335: state_type > $o ).

tff(pred_def_45023,type,
    v84468: state_type > $o ).

tff(pred_def_45024,type,
    v84466: state_type > $o ).

tff(pred_def_45025,type,
    v84475: state_type > $o ).

tff(pred_def_45026,type,
    v84473: state_type > $o ).

tff(pred_def_45027,type,
    v84472: state_type > $o ).

tff(pred_def_45028,type,
    v84471: state_type > $o ).

tff(pred_def_45029,type,
    v84483: state_type > $o ).

tff(pred_def_45030,type,
    v84484: state_type > $o ).

tff(pred_def_45031,type,
    v84482: state_type > $o ).

tff(pred_def_45032,type,
    v84479: state_type > $o ).

tff(pred_def_45033,type,
    v84481: state_type > $o ).

tff(pred_def_45034,type,
    v84325: state_type > $o ).

tff(pred_def_45035,type,
    v84323: state_type > $o ).

tff(pred_def_45036,type,
    v84321: state_type > $o ).

tff(pred_def_45037,type,
    v84498: state_type > $o ).

tff(pred_def_45038,type,
    v84496: state_type > $o ).

tff(pred_def_45039,type,
    v84502: state_type > $o ).

tff(pred_def_45040,type,
    v84500: state_type > $o ).

tff(pred_def_45041,type,
    v84512: state_type > $o ).

tff(pred_def_45042,type,
    v84510: state_type > $o ).

tff(pred_def_45043,type,
    v84508: state_type > $o ).

tff(pred_def_45044,type,
    b0000110100000: $int > $o ).

tff(pred_def_45045,type,
    v84520: state_type > $o ).

tff(pred_def_45046,type,
    v84517: state_type > $o ).

tff(pred_def_45047,type,
    v84515: state_type > $o ).

tff(pred_def_45048,type,
    v84524: state_type > $o ).

tff(pred_def_45049,type,
    v84523: state_type > $o ).

tff(pred_def_45050,type,
    v84522: state_type > $o ).

tff(pred_def_45051,type,
    v84528: state_type > $o ).

tff(pred_def_45052,type,
    v84527: state_type > $o ).

tff(pred_def_45053,type,
    v84526: state_type > $o ).

tff(pred_def_45054,type,
    v84492: state_type > $o ).

tff(pred_def_45055,type,
    v84525: state_type > $o ).

tff(pred_def_45056,type,
    v84506: state_type > $o ).

tff(pred_def_45057,type,
    v84504: state_type > $o ).

tff(pred_def_45058,type,
    v84532: state_type > $o ).

tff(pred_def_45059,type,
    v84530: state_type > $o ).

tff(pred_def_45060,type,
    v84539: state_type > $o ).

tff(pred_def_45061,type,
    v84537: state_type > $o ).

tff(pred_def_45062,type,
    v84536: state_type > $o ).

tff(pred_def_45063,type,
    v84535: state_type > $o ).

tff(pred_def_45064,type,
    v84547: state_type > $o ).

tff(pred_def_45065,type,
    v84548: state_type > $o ).

tff(pred_def_45066,type,
    v84546: state_type > $o ).

tff(pred_def_45067,type,
    v84543: state_type > $o ).

tff(pred_def_45068,type,
    v84545: state_type > $o ).

tff(pred_def_45069,type,
    v84494: state_type > $o ).

tff(pred_def_45070,type,
    v84490: state_type > $o ).

tff(pred_def_45071,type,
    v84488: state_type > $o ).

tff(pred_def_45072,type,
    v84563: state_type > $o ).

tff(pred_def_45073,type,
    v84561: state_type > $o ).

tff(pred_def_45074,type,
    v84567: state_type > $o ).

tff(pred_def_45075,type,
    v84565: state_type > $o ).

tff(pred_def_45076,type,
    b0000000100000: $int > $o ).

tff(pred_def_45077,type,
    v84581: state_type > $o ).

tff(pred_def_45078,type,
    v84578: state_type > $o ).

tff(pred_def_45079,type,
    v84585: state_type > $o ).

tff(pred_def_45080,type,
    v84583: state_type > $o ).

tff(pred_def_45081,type,
    b0000000111000: $int > $o ).

tff(pred_def_45082,type,
    v84590: state_type > $o ).

tff(pred_def_45083,type,
    v84589: state_type > $o ).

tff(pred_def_45084,type,
    v84553: state_type > $o ).

tff(pred_def_45085,type,
    v84594: state_type > $o ).

tff(pred_def_45086,type,
    v84595: state_type > $o ).

tff(pred_def_45087,type,
    v84593: state_type > $o ).

tff(pred_def_45088,type,
    v84592: state_type > $o ).

tff(pred_def_45089,type,
    v84555: ( state_type * $int ) > $o ).

tff(pred_def_45090,type,
    v84611: state_type > $o ).

tff(pred_def_45091,type,
    v84610: state_type > $o ).

tff(pred_def_45092,type,
    v84609: state_type > $o ).

tff(pred_def_45093,type,
    v84608: state_type > $o ).

tff(pred_def_45094,type,
    v84607: state_type > $o ).

tff(pred_def_45095,type,
    v84606: state_type > $o ).

tff(pred_def_45096,type,
    v84605: state_type > $o ).

tff(pred_def_45097,type,
    v84604: state_type > $o ).

tff(pred_def_45098,type,
    v84603: state_type > $o ).

tff(pred_def_45099,type,
    v84602: state_type > $o ).

tff(pred_def_45100,type,
    v84601: state_type > $o ).

tff(pred_def_45101,type,
    v84600: state_type > $o ).

tff(pred_def_45102,type,
    v84612: state_type > $o ).

tff(pred_def_45103,type,
    v84599: state_type > $o ).

tff(pred_def_45104,type,
    v84613: state_type > $o ).

tff(pred_def_45105,type,
    v84598: state_type > $o ).

tff(pred_def_45106,type,
    v84616: state_type > $o ).

tff(pred_def_45107,type,
    v84617: state_type > $o ).

tff(pred_def_45108,type,
    v84615: state_type > $o ).

tff(pred_def_45109,type,
    v84618: state_type > $o ).

tff(pred_def_45110,type,
    v84614: state_type > $o ).

tff(pred_def_45111,type,
    v84621: state_type > $o ).

tff(pred_def_45112,type,
    v84622: state_type > $o ).

tff(pred_def_45113,type,
    v84620: state_type > $o ).

tff(pred_def_45114,type,
    v84623: state_type > $o ).

tff(pred_def_45115,type,
    v84619: state_type > $o ).

tff(pred_def_45116,type,
    v84626: state_type > $o ).

tff(pred_def_45117,type,
    v84627: state_type > $o ).

tff(pred_def_45118,type,
    v84625: state_type > $o ).

tff(pred_def_45119,type,
    v84628: state_type > $o ).

tff(pred_def_45120,type,
    v84624: state_type > $o ).

tff(pred_def_45121,type,
    v84631: state_type > $o ).

tff(pred_def_45122,type,
    v84632: state_type > $o ).

tff(pred_def_45123,type,
    v84630: state_type > $o ).

tff(pred_def_45124,type,
    v84633: state_type > $o ).

tff(pred_def_45125,type,
    v84629: state_type > $o ).

tff(pred_def_45126,type,
    v84636: state_type > $o ).

tff(pred_def_45127,type,
    v84637: state_type > $o ).

tff(pred_def_45128,type,
    v84635: state_type > $o ).

tff(pred_def_45129,type,
    v84638: state_type > $o ).

tff(pred_def_45130,type,
    v84634: state_type > $o ).

tff(pred_def_45131,type,
    v84641: state_type > $o ).

tff(pred_def_45132,type,
    v84642: state_type > $o ).

tff(pred_def_45133,type,
    v84640: state_type > $o ).

tff(pred_def_45134,type,
    v84643: state_type > $o ).

tff(pred_def_45135,type,
    v84639: state_type > $o ).

tff(pred_def_45136,type,
    v84646: state_type > $o ).

tff(pred_def_45137,type,
    v84647: state_type > $o ).

tff(pred_def_45138,type,
    v84645: state_type > $o ).

tff(pred_def_45139,type,
    v84648: state_type > $o ).

tff(pred_def_45140,type,
    v84644: state_type > $o ).

tff(pred_def_45141,type,
    v84651: state_type > $o ).

tff(pred_def_45142,type,
    v84652: state_type > $o ).

tff(pred_def_45143,type,
    v84650: state_type > $o ).

tff(pred_def_45144,type,
    v84653: state_type > $o ).

tff(pred_def_45145,type,
    v84649: state_type > $o ).

tff(pred_def_45146,type,
    v84656: state_type > $o ).

tff(pred_def_45147,type,
    v84657: state_type > $o ).

tff(pred_def_45148,type,
    v84655: state_type > $o ).

tff(pred_def_45149,type,
    v84658: state_type > $o ).

tff(pred_def_45150,type,
    v84654: state_type > $o ).

tff(pred_def_45151,type,
    v84661: state_type > $o ).

tff(pred_def_45152,type,
    v84662: state_type > $o ).

tff(pred_def_45153,type,
    v84660: state_type > $o ).

tff(pred_def_45154,type,
    v84663: state_type > $o ).

tff(pred_def_45155,type,
    v84659: state_type > $o ).

tff(pred_def_45156,type,
    v84666: state_type > $o ).

tff(pred_def_45157,type,
    v84667: state_type > $o ).

tff(pred_def_45158,type,
    v84665: state_type > $o ).

tff(pred_def_45159,type,
    v84668: state_type > $o ).

tff(pred_def_45160,type,
    v84664: state_type > $o ).

tff(pred_def_45161,type,
    v84596: ( state_type * $int ) > $o ).

tff(pred_def_45162,type,
    b0000000000000: $int > $o ).

tff(pred_def_45163,type,
    v84591: ( state_type * $int ) > $o ).

tff(pred_def_45164,type,
    v84575: ( state_type * $int ) > $o ).

tff(pred_def_45165,type,
    v84573: ( state_type * $int ) > $o ).

tff(pred_def_45166,type,
    v84571: ( state_type * $int ) > $o ).

tff(pred_def_45167,type,
    v84569: ( state_type * $int ) > $o ).

tff(pred_def_45168,type,
    v84672: state_type > $o ).

tff(pred_def_45169,type,
    v84670: state_type > $o ).

tff(pred_def_45170,type,
    v84679: state_type > $o ).

tff(pred_def_45171,type,
    v84677: state_type > $o ).

tff(pred_def_45172,type,
    v84676: state_type > $o ).

tff(pred_def_45173,type,
    v84675: state_type > $o ).

tff(pred_def_45174,type,
    v84687: state_type > $o ).

tff(pred_def_45175,type,
    v84688: state_type > $o ).

tff(pred_def_45176,type,
    v84686: state_type > $o ).

tff(pred_def_45177,type,
    v84683: ( state_type * $int ) > $o ).

tff(pred_def_45178,type,
    v84685: ( state_type * $int ) > $o ).

tff(pred_def_45179,type,
    v84559: ( state_type * $int ) > $o ).

tff(pred_def_45180,type,
    v84557: ( state_type * $int ) > $o ).

tff(pred_def_45181,type,
    v84702: state_type > $o ).

tff(pred_def_45182,type,
    v84700: state_type > $o ).

tff(pred_def_45183,type,
    v84706: state_type > $o ).

tff(pred_def_45184,type,
    v84704: state_type > $o ).

tff(pred_def_45185,type,
    b0100000100000: $int > $o ).

tff(pred_def_45186,type,
    v84716: ( state_type * $int ) > $o ).

tff(pred_def_45187,type,
    v84714: ( state_type * $int ) > $o ).

tff(pred_def_45188,type,
    v84712: ( state_type * $int ) > $o ).

tff(pred_def_45189,type,
    v84720: state_type > $o ).

tff(pred_def_45190,type,
    v84724: state_type > $o ).

tff(pred_def_45191,type,
    v84723: ( state_type * $int ) > $o ).

tff(pred_def_45192,type,
    v84722: ( state_type * $int ) > $o ).

tff(pred_def_45193,type,
    v84728: state_type > $o ).

tff(pred_def_45194,type,
    v84727: ( state_type * $int ) > $o ).

tff(pred_def_45195,type,
    v84726: ( state_type * $int ) > $o ).

tff(pred_def_45196,type,
    v84696: ( state_type * $int ) > $o ).

tff(pred_def_45197,type,
    v84725: ( state_type * $int ) > $o ).

tff(pred_def_45198,type,
    v84710: ( state_type * $int ) > $o ).

tff(pred_def_45199,type,
    v84708: ( state_type * $int ) > $o ).

tff(pred_def_45200,type,
    v84732: state_type > $o ).

tff(pred_def_45201,type,
    v84730: state_type > $o ).

tff(pred_def_45202,type,
    v84739: state_type > $o ).

tff(pred_def_45203,type,
    v84737: state_type > $o ).

tff(pred_def_45204,type,
    v84736: state_type > $o ).

tff(pred_def_45205,type,
    v84735: state_type > $o ).

tff(pred_def_45206,type,
    v84747: state_type > $o ).

tff(pred_def_45207,type,
    v84748: state_type > $o ).

tff(pred_def_45208,type,
    v84746: state_type > $o ).

tff(pred_def_45209,type,
    v84743: ( state_type * $int ) > $o ).

tff(pred_def_45210,type,
    v84745: ( state_type * $int ) > $o ).

tff(pred_def_45211,type,
    v84698: ( state_type * $int ) > $o ).

tff(pred_def_45212,type,
    v84694: ( state_type * $int ) > $o ).

tff(pred_def_45213,type,
    v84692: ( state_type * $int ) > $o ).

tff(pred_def_45214,type,
    v84761: state_type > $o ).

tff(pred_def_45215,type,
    v84759: state_type > $o ).

tff(pred_def_45216,type,
    v84765: state_type > $o ).

tff(pred_def_45217,type,
    v84763: state_type > $o ).

tff(pred_def_45218,type,
    v84771: state_type > $o ).

tff(pred_def_45219,type,
    v84769: state_type > $o ).

tff(pred_def_45220,type,
    v84767: state_type > $o ).

tff(pred_def_45221,type,
    v84775: state_type > $o ).

tff(pred_def_45222,type,
    v84773: state_type > $o ).

tff(pred_def_45223,type,
    v84782: state_type > $o ).

tff(pred_def_45224,type,
    v84780: state_type > $o ).

tff(pred_def_45225,type,
    v84779: state_type > $o ).

tff(pred_def_45226,type,
    v84778: state_type > $o ).

tff(pred_def_45227,type,
    v84790: state_type > $o ).

tff(pred_def_45228,type,
    v84791: state_type > $o ).

tff(pred_def_45229,type,
    v84789: state_type > $o ).

tff(pred_def_45230,type,
    v84786: state_type > $o ).

tff(pred_def_45231,type,
    v84788: state_type > $o ).

tff(pred_def_45232,type,
    v84757: state_type > $o ).

tff(pred_def_45233,type,
    v84755: state_type > $o ).

tff(pred_def_45234,type,
    v84753: state_type > $o ).

tff(pred_def_45235,type,
    v84821: state_type > $o ).

tff(pred_def_45236,type,
    v84825: state_type > $o ).

tff(pred_def_45237,type,
    v84824: state_type > $o ).

tff(pred_def_45238,type,
    v84826: state_type > $o ).

tff(pred_def_45239,type,
    v84823: state_type > $o ).

tff(pred_def_45240,type,
    v84822: state_type > $o ).

tff(pred_def_45241,type,
    v84820: state_type > $o ).

tff(pred_def_45242,type,
    v84827: state_type > $o ).

tff(pred_def_45243,type,
    v84819: state_type > $o ).

tff(pred_def_45244,type,
    v84831: state_type > $o ).

tff(pred_def_45245,type,
    v84830: state_type > $o ).

tff(pred_def_45246,type,
    v84832: state_type > $o ).

tff(pred_def_45247,type,
    v84829: state_type > $o ).

tff(pred_def_45248,type,
    v84828: state_type > $o ).

tff(pred_def_45249,type,
    v84818: state_type > $o ).

tff(pred_def_45250,type,
    v84833: state_type > $o ).

tff(pred_def_45251,type,
    v84817: state_type > $o ).

tff(pred_def_45252,type,
    v84837: state_type > $o ).

tff(pred_def_45253,type,
    v84836: state_type > $o ).

tff(pred_def_45254,type,
    v84838: state_type > $o ).

tff(pred_def_45255,type,
    v84835: state_type > $o ).

tff(pred_def_45256,type,
    v84834: state_type > $o ).

tff(pred_def_45257,type,
    v84816: state_type > $o ).

tff(pred_def_45258,type,
    v84839: state_type > $o ).

tff(pred_def_45259,type,
    v84815: state_type > $o ).

tff(pred_def_45260,type,
    v84843: state_type > $o ).

tff(pred_def_45261,type,
    v84842: state_type > $o ).

tff(pred_def_45262,type,
    v84844: state_type > $o ).

tff(pred_def_45263,type,
    v84841: state_type > $o ).

tff(pred_def_45264,type,
    v84840: state_type > $o ).

tff(pred_def_45265,type,
    v84814: state_type > $o ).

tff(pred_def_45266,type,
    v84845: state_type > $o ).

tff(pred_def_45267,type,
    v84813: state_type > $o ).

tff(pred_def_45268,type,
    v84849: state_type > $o ).

tff(pred_def_45269,type,
    v84848: state_type > $o ).

tff(pred_def_45270,type,
    v84850: state_type > $o ).

tff(pred_def_45271,type,
    v84847: state_type > $o ).

tff(pred_def_45272,type,
    v84846: state_type > $o ).

tff(pred_def_45273,type,
    v84812: state_type > $o ).

tff(pred_def_45274,type,
    v84851: state_type > $o ).

tff(pred_def_45275,type,
    v84811: state_type > $o ).

tff(pred_def_45276,type,
    v84855: state_type > $o ).

tff(pred_def_45277,type,
    v84854: state_type > $o ).

tff(pred_def_45278,type,
    v84856: state_type > $o ).

tff(pred_def_45279,type,
    v84853: state_type > $o ).

tff(pred_def_45280,type,
    v84852: state_type > $o ).

tff(pred_def_45281,type,
    v84810: state_type > $o ).

tff(pred_def_45282,type,
    v84857: state_type > $o ).

tff(pred_def_45283,type,
    v84809: state_type > $o ).

tff(pred_def_45284,type,
    v84861: state_type > $o ).

tff(pred_def_45285,type,
    v84860: state_type > $o ).

tff(pred_def_45286,type,
    v84862: state_type > $o ).

tff(pred_def_45287,type,
    v84859: state_type > $o ).

tff(pred_def_45288,type,
    v84858: state_type > $o ).

tff(pred_def_45289,type,
    v84808: state_type > $o ).

tff(pred_def_45290,type,
    v84863: state_type > $o ).

tff(pred_def_45291,type,
    v84807: state_type > $o ).

tff(pred_def_45292,type,
    v84867: state_type > $o ).

tff(pred_def_45293,type,
    v84866: state_type > $o ).

tff(pred_def_45294,type,
    v84868: state_type > $o ).

tff(pred_def_45295,type,
    v84865: state_type > $o ).

tff(pred_def_45296,type,
    v84864: state_type > $o ).

tff(pred_def_45297,type,
    v84806: state_type > $o ).

tff(pred_def_45298,type,
    v84869: state_type > $o ).

tff(pred_def_45299,type,
    v84805: state_type > $o ).

tff(pred_def_45300,type,
    v84873: state_type > $o ).

tff(pred_def_45301,type,
    v84872: state_type > $o ).

tff(pred_def_45302,type,
    v84874: state_type > $o ).

tff(pred_def_45303,type,
    v84871: state_type > $o ).

tff(pred_def_45304,type,
    v84870: state_type > $o ).

tff(pred_def_45305,type,
    v84804: state_type > $o ).

tff(pred_def_45306,type,
    v84875: state_type > $o ).

tff(pred_def_45307,type,
    v84803: state_type > $o ).

tff(pred_def_45308,type,
    v84879: state_type > $o ).

tff(pred_def_45309,type,
    v84878: state_type > $o ).

tff(pred_def_45310,type,
    v84880: state_type > $o ).

tff(pred_def_45311,type,
    v84877: state_type > $o ).

tff(pred_def_45312,type,
    v84876: state_type > $o ).

tff(pred_def_45313,type,
    v84802: state_type > $o ).

tff(pred_def_45314,type,
    v84881: state_type > $o ).

tff(pred_def_45315,type,
    v84801: state_type > $o ).

tff(pred_def_45316,type,
    v84885: state_type > $o ).

tff(pred_def_45317,type,
    v84884: state_type > $o ).

tff(pred_def_45318,type,
    v84886: state_type > $o ).

tff(pred_def_45319,type,
    v84883: state_type > $o ).

tff(pred_def_45320,type,
    v84882: state_type > $o ).

tff(pred_def_45321,type,
    v84800: state_type > $o ).

tff(pred_def_45322,type,
    v84887: state_type > $o ).

tff(pred_def_45323,type,
    v84799: state_type > $o ).

tff(pred_def_45324,type,
    v84891: state_type > $o ).

tff(pred_def_45325,type,
    v84890: state_type > $o ).

tff(pred_def_45326,type,
    v84892: state_type > $o ).

tff(pred_def_45327,type,
    v84889: state_type > $o ).

tff(pred_def_45328,type,
    v84888: state_type > $o ).

tff(pred_def_45329,type,
    v84798: state_type > $o ).

tff(pred_def_45330,type,
    v84893: state_type > $o ).

tff(pred_def_45331,type,
    v84797: state_type > $o ).

tff(pred_def_45332,type,
    v84795: state_type > $o ).

tff(pred_def_45333,type,
    v84895: state_type > $o ).

tff(pred_def_45334,type,
    v84894: state_type > $o ).

tff(pred_def_45335,type,
    v84925: state_type > $o ).

tff(pred_def_45336,type,
    v84923: state_type > $o ).

tff(pred_def_45337,type,
    v84929: state_type > $o ).

tff(pred_def_45338,type,
    v84927: state_type > $o ).

tff(pred_def_45339,type,
    v84949: state_type > $o ).

tff(pred_def_45340,type,
    v84948: state_type > $o ).

tff(pred_def_45341,type,
    v84947: state_type > $o ).

tff(pred_def_45342,type,
    v84946: state_type > $o ).

tff(pred_def_45343,type,
    v84945: state_type > $o ).

tff(pred_def_45344,type,
    v84944: state_type > $o ).

tff(pred_def_45345,type,
    v84941: state_type > $o ).

tff(pred_def_45346,type,
    v84951: state_type > $o ).

tff(pred_def_45347,type,
    v84939: state_type > $o ).

tff(pred_def_45348,type,
    v84961: state_type > $o ).

tff(pred_def_45349,type,
    v84959: state_type > $o ).

tff(pred_def_45350,type,
    v84965: state_type > $o ).

tff(pred_def_45351,type,
    v84963: state_type > $o ).

tff(pred_def_45352,type,
    v120: ( state_type * $int ) > $o ).

tff(pred_def_45353,type,
    v84977: ( state_type * $int ) > $o ).

tff(pred_def_45354,type,
    v84975: ( state_type * $int ) > $o ).

tff(pred_def_45355,type,
    v84981: state_type > $o ).

tff(pred_def_45356,type,
    v2900: state_type > $o ).

tff(pred_def_45357,type,
    v84979: state_type > $o ).

tff(pred_def_45358,type,
    v84985: state_type > $o ).

tff(pred_def_45359,type,
    v84984: state_type > $o ).

tff(pred_def_45360,type,
    v84983: ( state_type * $int ) > $o ).

tff(pred_def_45361,type,
    v84973: ( state_type * $int ) > $o ).

tff(pred_def_45362,type,
    v84971: ( state_type * $int ) > $o ).

tff(pred_def_45363,type,
    v84969: ( state_type * $int ) > $o ).

tff(pred_def_45364,type,
    v84967: ( state_type * $int ) > $o ).

tff(pred_def_45365,type,
    v84989: state_type > $o ).

tff(pred_def_45366,type,
    v84987: state_type > $o ).

tff(pred_def_45367,type,
    v84996: state_type > $o ).

tff(pred_def_45368,type,
    v84994: state_type > $o ).

tff(pred_def_45369,type,
    v84993: state_type > $o ).

tff(pred_def_45370,type,
    v84992: state_type > $o ).

tff(pred_def_45371,type,
    v85004: state_type > $o ).

tff(pred_def_45372,type,
    v85005: state_type > $o ).

tff(pred_def_45373,type,
    v85003: state_type > $o ).

tff(pred_def_45374,type,
    v85000: ( state_type * $int ) > $o ).

tff(pred_def_45375,type,
    v85002: ( state_type * $int ) > $o ).

tff(pred_def_45376,type,
    v84957: ( state_type * $int ) > $o ).

tff(pred_def_45377,type,
    v84955: ( state_type * $int ) > $o ).

tff(pred_def_45378,type,
    v84953: ( state_type * $int ) > $o ).

tff(pred_def_45379,type,
    v85018: state_type > $o ).

tff(pred_def_45380,type,
    v85017: state_type > $o ).

tff(pred_def_45381,type,
    v85016: state_type > $o ).

tff(pred_def_45382,type,
    v85015: state_type > $o ).

tff(pred_def_45383,type,
    v85014: state_type > $o ).

tff(pred_def_45384,type,
    v85013: state_type > $o ).

tff(pred_def_45385,type,
    v85011: state_type > $o ).

tff(pred_def_45386,type,
    v85010: state_type > $o ).

tff(pred_def_45387,type,
    v85009: state_type > $o ).

tff(pred_def_45388,type,
    v84917: ( state_type * $int ) > $o ).

tff(pred_def_45389,type,
    v85025: state_type > $o ).

tff(pred_def_45390,type,
    v85024: state_type > $o ).

tff(pred_def_45391,type,
    v85023: state_type > $o ).

tff(pred_def_45392,type,
    v85026: state_type > $o ).

tff(pred_def_45393,type,
    v85022: state_type > $o ).

tff(pred_def_45394,type,
    v85027: state_type > $o ).

tff(pred_def_45395,type,
    v85021: state_type > $o ).

tff(pred_def_45396,type,
    v85030: state_type > $o ).

tff(pred_def_45397,type,
    v85031: state_type > $o ).

tff(pred_def_45398,type,
    v85029: state_type > $o ).

tff(pred_def_45399,type,
    v85032: state_type > $o ).

tff(pred_def_45400,type,
    v85028: state_type > $o ).

tff(pred_def_45401,type,
    v85035: state_type > $o ).

tff(pred_def_45402,type,
    v85036: state_type > $o ).

tff(pred_def_45403,type,
    v85034: state_type > $o ).

tff(pred_def_45404,type,
    v85037: state_type > $o ).

tff(pred_def_45405,type,
    v85033: state_type > $o ).

tff(pred_def_45406,type,
    v85019: ( state_type * $int ) > $o ).

tff(pred_def_45407,type,
    v85040: state_type > $o ).

tff(pred_def_45408,type,
    v85041: state_type > $o ).

tff(pred_def_45409,type,
    v85039: state_type > $o ).

tff(pred_def_45410,type,
    v85050: state_type > $o ).

tff(pred_def_45411,type,
    v85049: state_type > $o ).

tff(pred_def_45412,type,
    v85048: state_type > $o ).

tff(pred_def_45413,type,
    v85047: state_type > $o ).

tff(pred_def_45414,type,
    v85046: state_type > $o ).

tff(pred_def_45415,type,
    v85045: state_type > $o ).

tff(pred_def_45416,type,
    v85051: state_type > $o ).

tff(pred_def_45417,type,
    v85044: state_type > $o ).

tff(pred_def_45418,type,
    v85054: state_type > $o ).

tff(pred_def_45419,type,
    v85053: state_type > $o ).

tff(pred_def_45420,type,
    v85055: state_type > $o ).

tff(pred_def_45421,type,
    v85052: state_type > $o ).

tff(pred_def_45422,type,
    v85057: state_type > $o ).

tff(pred_def_45423,type,
    v85058: state_type > $o ).

tff(pred_def_45424,type,
    v85056: state_type > $o ).

tff(pred_def_45425,type,
    v85042: ( state_type * $int ) > $o ).

tff(pred_def_45426,type,
    v85038: ( state_type * $int ) > $o ).

tff(pred_def_45427,type,
    v84937: ( state_type * $int ) > $o ).

tff(pred_def_45428,type,
    v84935: ( state_type * $int ) > $o ).

tff(pred_def_45429,type,
    v84933: ( state_type * $int ) > $o ).

tff(pred_def_45430,type,
    v84931: ( state_type * $int ) > $o ).

tff(pred_def_45431,type,
    v85062: state_type > $o ).

tff(pred_def_45432,type,
    v85060: state_type > $o ).

tff(pred_def_45433,type,
    v85069: state_type > $o ).

tff(pred_def_45434,type,
    v85067: state_type > $o ).

tff(pred_def_45435,type,
    v85066: state_type > $o ).

tff(pred_def_45436,type,
    v85065: state_type > $o ).

tff(pred_def_45437,type,
    v85077: state_type > $o ).

tff(pred_def_45438,type,
    v85078: state_type > $o ).

tff(pred_def_45439,type,
    v85076: state_type > $o ).

tff(pred_def_45440,type,
    v85073: ( state_type * $int ) > $o ).

tff(pred_def_45441,type,
    v85075: ( state_type * $int ) > $o ).

tff(pred_def_45442,type,
    v84921: ( state_type * $int ) > $o ).

tff(pred_def_45443,type,
    v84919: ( state_type * $int ) > $o ).

tff(pred_def_45444,type,
    v85095: state_type > $o ).

tff(pred_def_45445,type,
    v85094: ( state_type * $int ) > $o ).

tff(pred_def_45446,type,
    v85093: ( state_type * $int ) > $o ).

tff(pred_def_45447,type,
    v85099: state_type > $o ).

tff(pred_def_45448,type,
    v85098: state_type > $o ).

tff(pred_def_45449,type,
    v85097: ( state_type * $int ) > $o ).

tff(pred_def_45450,type,
    v85096: ( state_type * $int ) > $o ).

tff(pred_def_45451,type,
    v85092: ( state_type * $int ) > $o ).

tff(pred_def_45452,type,
    v85091: ( state_type * $int ) > $o ).

tff(pred_def_45453,type,
    v85103: state_type > $o ).

tff(pred_def_45454,type,
    v85102: state_type > $o ).

tff(pred_def_45455,type,
    v85101: ( state_type * $int ) > $o ).

tff(pred_def_45456,type,
    v85100: ( state_type * $int ) > $o ).

tff(pred_def_45457,type,
    v85090: ( state_type * $int ) > $o ).

tff(pred_def_45458,type,
    v85089: ( state_type * $int ) > $o ).

tff(pred_def_45459,type,
    v85107: state_type > $o ).

tff(pred_def_45460,type,
    v85106: state_type > $o ).

tff(pred_def_45461,type,
    v85105: ( state_type * $int ) > $o ).

tff(pred_def_45462,type,
    v85104: ( state_type * $int ) > $o ).

tff(pred_def_45463,type,
    v85088: ( state_type * $int ) > $o ).

tff(pred_def_45464,type,
    v85087: ( state_type * $int ) > $o ).

tff(pred_def_45465,type,
    v85111: state_type > $o ).

tff(pred_def_45466,type,
    v85110: state_type > $o ).

tff(pred_def_45467,type,
    v85109: ( state_type * $int ) > $o ).

tff(pred_def_45468,type,
    v85108: ( state_type * $int ) > $o ).

tff(pred_def_45469,type,
    v85086: ( state_type * $int ) > $o ).

tff(pred_def_45470,type,
    v85085: ( state_type * $int ) > $o ).

tff(pred_def_45471,type,
    v85115: state_type > $o ).

tff(pred_def_45472,type,
    v85114: state_type > $o ).

tff(pred_def_45473,type,
    v85113: ( state_type * $int ) > $o ).

tff(pred_def_45474,type,
    v85112: ( state_type * $int ) > $o ).

tff(pred_def_45475,type,
    v85084: ( state_type * $int ) > $o ).

tff(pred_def_45476,type,
    v85083: ( state_type * $int ) > $o ).

tff(pred_def_45477,type,
    v85119: state_type > $o ).

tff(pred_def_45478,type,
    v85118: state_type > $o ).

tff(pred_def_45479,type,
    v85117: ( state_type * $int ) > $o ).

tff(pred_def_45480,type,
    v85116: ( state_type * $int ) > $o ).

tff(pred_def_45481,type,
    v85082: ( state_type * $int ) > $o ).

tff(pred_def_45482,type,
    v85122: state_type > $o ).

tff(pred_def_45483,type,
    v85121: state_type > $o ).

tff(pred_def_45484,type,
    v85120: ( state_type * $int ) > $o ).

tff(pred_def_45485,type,
    v85081: ( state_type * $int ) > $o ).

tff(pred_def_45486,type,
    v84915: ( state_type * $int ) > $o ).

tff(pred_def_45487,type,
    v85136: state_type > $o ).

tff(pred_def_45488,type,
    v85134: state_type > $o ).

tff(pred_def_45489,type,
    v85140: state_type > $o ).

tff(pred_def_45490,type,
    v85138: state_type > $o ).

tff(pred_def_45491,type,
    v85158: state_type > $o ).

tff(pred_def_45492,type,
    v85156: state_type > $o ).

tff(pred_def_45493,type,
    v85162: state_type > $o ).

tff(pred_def_45494,type,
    v85160: state_type > $o ).

tff(pred_def_45495,type,
    v85180: state_type > $o ).

tff(pred_def_45496,type,
    v85178: state_type > $o ).

tff(pred_def_45497,type,
    v85184: state_type > $o ).

tff(pred_def_45498,type,
    v85182: state_type > $o ).

tff(pred_def_45499,type,
    v85202: state_type > $o ).

tff(pred_def_45500,type,
    v85200: state_type > $o ).

tff(pred_def_45501,type,
    v85206: state_type > $o ).

tff(pred_def_45502,type,
    v85204: state_type > $o ).

tff(pred_def_45503,type,
    v85224: state_type > $o ).

tff(pred_def_45504,type,
    v85222: state_type > $o ).

tff(pred_def_45505,type,
    v85228: state_type > $o ).

tff(pred_def_45506,type,
    v85226: state_type > $o ).

tff(pred_def_45507,type,
    v85246: state_type > $o ).

tff(pred_def_45508,type,
    v85244: state_type > $o ).

tff(pred_def_45509,type,
    v85250: state_type > $o ).

tff(pred_def_45510,type,
    v85248: state_type > $o ).

tff(pred_def_45511,type,
    v85268: state_type > $o ).

tff(pred_def_45512,type,
    v85266: state_type > $o ).

tff(pred_def_45513,type,
    v85272: state_type > $o ).

tff(pred_def_45514,type,
    v85270: state_type > $o ).

tff(pred_def_45515,type,
    v85290: state_type > $o ).

tff(pred_def_45516,type,
    v85288: state_type > $o ).

tff(pred_def_45517,type,
    v85294: state_type > $o ).

tff(pred_def_45518,type,
    v85292: state_type > $o ).

tff(pred_def_45519,type,
    v85314: state_type > $o ).

tff(pred_def_45520,type,
    v85312: state_type > $o ).

tff(pred_def_45521,type,
    v85318: state_type > $o ).

tff(pred_def_45522,type,
    v85316: state_type > $o ).

tff(pred_def_45523,type,
    v85334: state_type > $o ).

tff(pred_def_45524,type,
    v85332: state_type > $o ).

tff(pred_def_45525,type,
    v85330: state_type > $o ).

tff(pred_def_45526,type,
    v85328: state_type > $o ).

tff(pred_def_45527,type,
    v85326: state_type > $o ).

tff(pred_def_45528,type,
    v85344: ( state_type * $int ) > $o ).

tff(pred_def_45529,type,
    v85342: ( state_type * $int ) > $o ).

tff(pred_def_45530,type,
    v85340: ( state_type * $int ) > $o ).

tff(pred_def_45531,type,
    v85338: ( state_type * $int ) > $o ).

tff(pred_def_45532,type,
    v85336: ( state_type * $int ) > $o ).

tff(pred_def_45533,type,
    v85346: state_type > $o ).

tff(pred_def_45534,type,
    v85345: ( state_type * $int ) > $o ).

tff(pred_def_45535,type,
    v85347: state_type > $o ).

tff(pred_def_45536,type,
    v85348: ( state_type * $int ) > $o ).

tff(pred_def_45537,type,
    v85324: ( state_type * $int ) > $o ).

tff(pred_def_45538,type,
    v85322: ( state_type * $int ) > $o ).

tff(pred_def_45539,type,
    v85320: ( state_type * $int ) > $o ).

tff(pred_def_45540,type,
    v85352: state_type > $o ).

tff(pred_def_45541,type,
    v85350: state_type > $o ).

tff(pred_def_45542,type,
    v85359: state_type > $o ).

tff(pred_def_45543,type,
    v85357: state_type > $o ).

tff(pred_def_45544,type,
    v85356: state_type > $o ).

tff(pred_def_45545,type,
    v85355: state_type > $o ).

tff(pred_def_45546,type,
    v85367: state_type > $o ).

tff(pred_def_45547,type,
    v85368: state_type > $o ).

tff(pred_def_45548,type,
    v85366: state_type > $o ).

tff(pred_def_45549,type,
    v85363: ( state_type * $int ) > $o ).

tff(pred_def_45550,type,
    v85365: ( state_type * $int ) > $o ).

tff(pred_def_45551,type,
    v85354: ( state_type * $int ) > $o ).

tff(pred_def_45552,type,
    v85310: ( state_type * $int ) > $o ).

tff(pred_def_45553,type,
    v85308: ( state_type * $int ) > $o ).

tff(pred_def_45554,type,
    v85306: ( state_type * $int ) > $o ).

tff(pred_def_45555,type,
    v85372: ( state_type * $int ) > $o ).

tff(pred_def_45556,type,
    v85371: ( state_type * $int ) > $o ).

tff(pred_def_45557,type,
    v85373: state_type > $o ).

tff(pred_def_45558,type,
    v85304: ( state_type * $int ) > $o ).

tff(pred_def_45559,type,
    v85302: ( state_type * $int ) > $o ).

tff(pred_def_45560,type,
    v85300: ( state_type * $int ) > $o ).

tff(pred_def_45561,type,
    v85380: state_type > $o ).

tff(pred_def_45562,type,
    v85379: state_type > $o ).

tff(pred_def_45563,type,
    v85381: state_type > $o ).

tff(pred_def_45564,type,
    v85377: state_type > $o ).

tff(pred_def_45565,type,
    v85375: state_type > $o ).

tff(pred_def_45566,type,
    v85385: state_type > $o ).

tff(pred_def_45567,type,
    v85384: ( state_type * $int ) > $o ).

tff(pred_def_45568,type,
    v85383: ( state_type * $int ) > $o ).

tff(pred_def_45569,type,
    v85389: state_type > $o ).

tff(pred_def_45570,type,
    v85388: ( state_type * $int ) > $o ).

tff(pred_def_45571,type,
    v85387: ( state_type * $int ) > $o ).

tff(pred_def_45572,type,
    v85284: ( state_type * $int ) > $o ).

tff(pred_def_45573,type,
    v85386: ( state_type * $int ) > $o ).

tff(pred_def_45574,type,
    v85382: ( state_type * $int ) > $o ).

tff(pred_def_45575,type,
    v85298: ( state_type * $int ) > $o ).

tff(pred_def_45576,type,
    v85296: ( state_type * $int ) > $o ).

tff(pred_def_45577,type,
    v85393: state_type > $o ).

tff(pred_def_45578,type,
    v85391: state_type > $o ).

tff(pred_def_45579,type,
    v85400: state_type > $o ).

tff(pred_def_45580,type,
    v85398: state_type > $o ).

tff(pred_def_45581,type,
    v85397: state_type > $o ).

tff(pred_def_45582,type,
    v85396: state_type > $o ).

tff(pred_def_45583,type,
    v85408: state_type > $o ).

tff(pred_def_45584,type,
    v85409: state_type > $o ).

tff(pred_def_45585,type,
    v85407: state_type > $o ).

tff(pred_def_45586,type,
    v85404: ( state_type * $int ) > $o ).

tff(pred_def_45587,type,
    v85406: ( state_type * $int ) > $o ).

tff(pred_def_45588,type,
    v85395: ( state_type * $int ) > $o ).

tff(pred_def_45589,type,
    v85286: ( state_type * $int ) > $o ).

tff(pred_def_45590,type,
    v85282: ( state_type * $int ) > $o ).

tff(pred_def_45591,type,
    v85412: ( state_type * $int ) > $o ).

tff(pred_def_45592,type,
    v85280: ( state_type * $int ) > $o ).

tff(pred_def_45593,type,
    v85278: ( state_type * $int ) > $o ).

tff(pred_def_45594,type,
    v85419: state_type > $o ).

tff(pred_def_45595,type,
    v85418: state_type > $o ).

tff(pred_def_45596,type,
    v85420: state_type > $o ).

tff(pred_def_45597,type,
    v85416: state_type > $o ).

tff(pred_def_45598,type,
    v85414: state_type > $o ).

tff(pred_def_45599,type,
    v85424: state_type > $o ).

tff(pred_def_45600,type,
    v85423: ( state_type * $int ) > $o ).

tff(pred_def_45601,type,
    v85422: ( state_type * $int ) > $o ).

tff(pred_def_45602,type,
    v85428: state_type > $o ).

tff(pred_def_45603,type,
    v85427: ( state_type * $int ) > $o ).

tff(pred_def_45604,type,
    v85426: ( state_type * $int ) > $o ).

tff(pred_def_45605,type,
    v85262: ( state_type * $int ) > $o ).

tff(pred_def_45606,type,
    v85425: ( state_type * $int ) > $o ).

tff(pred_def_45607,type,
    v85421: ( state_type * $int ) > $o ).

tff(pred_def_45608,type,
    v85276: ( state_type * $int ) > $o ).

tff(pred_def_45609,type,
    v85274: ( state_type * $int ) > $o ).

tff(pred_def_45610,type,
    v85432: state_type > $o ).

tff(pred_def_45611,type,
    v85430: state_type > $o ).

tff(pred_def_45612,type,
    v85439: state_type > $o ).

tff(pred_def_45613,type,
    v85437: state_type > $o ).

tff(pred_def_45614,type,
    v85436: state_type > $o ).

tff(pred_def_45615,type,
    v85435: state_type > $o ).

tff(pred_def_45616,type,
    v85447: state_type > $o ).

tff(pred_def_45617,type,
    v85448: state_type > $o ).

tff(pred_def_45618,type,
    v85446: state_type > $o ).

tff(pred_def_45619,type,
    v85443: ( state_type * $int ) > $o ).

tff(pred_def_45620,type,
    v85445: ( state_type * $int ) > $o ).

tff(pred_def_45621,type,
    v85434: ( state_type * $int ) > $o ).

tff(pred_def_45622,type,
    v85264: ( state_type * $int ) > $o ).

tff(pred_def_45623,type,
    v85260: ( state_type * $int ) > $o ).

tff(pred_def_45624,type,
    v85451: ( state_type * $int ) > $o ).

tff(pred_def_45625,type,
    v85258: ( state_type * $int ) > $o ).

tff(pred_def_45626,type,
    v85256: ( state_type * $int ) > $o ).

tff(pred_def_45627,type,
    v85458: state_type > $o ).

tff(pred_def_45628,type,
    v85457: state_type > $o ).

tff(pred_def_45629,type,
    v85459: state_type > $o ).

tff(pred_def_45630,type,
    v85455: state_type > $o ).

tff(pred_def_45631,type,
    v85453: state_type > $o ).

tff(pred_def_45632,type,
    v85463: state_type > $o ).

tff(pred_def_45633,type,
    v85462: ( state_type * $int ) > $o ).

tff(pred_def_45634,type,
    v85461: ( state_type * $int ) > $o ).

tff(pred_def_45635,type,
    v85467: state_type > $o ).

tff(pred_def_45636,type,
    v85466: ( state_type * $int ) > $o ).

tff(pred_def_45637,type,
    v85465: ( state_type * $int ) > $o ).

tff(pred_def_45638,type,
    v85240: ( state_type * $int ) > $o ).

tff(pred_def_45639,type,
    v85464: ( state_type * $int ) > $o ).

tff(pred_def_45640,type,
    v85460: ( state_type * $int ) > $o ).

tff(pred_def_45641,type,
    v85254: ( state_type * $int ) > $o ).

tff(pred_def_45642,type,
    v85252: ( state_type * $int ) > $o ).

tff(pred_def_45643,type,
    v85471: state_type > $o ).

tff(pred_def_45644,type,
    v85469: state_type > $o ).

tff(pred_def_45645,type,
    v85478: state_type > $o ).

tff(pred_def_45646,type,
    v85476: state_type > $o ).

tff(pred_def_45647,type,
    v85475: state_type > $o ).

tff(pred_def_45648,type,
    v85474: state_type > $o ).

tff(pred_def_45649,type,
    v85486: state_type > $o ).

tff(pred_def_45650,type,
    v85487: state_type > $o ).

tff(pred_def_45651,type,
    v85485: state_type > $o ).

tff(pred_def_45652,type,
    v85482: ( state_type * $int ) > $o ).

tff(pred_def_45653,type,
    v85484: ( state_type * $int ) > $o ).

tff(pred_def_45654,type,
    v85473: ( state_type * $int ) > $o ).

tff(pred_def_45655,type,
    v85242: ( state_type * $int ) > $o ).

tff(pred_def_45656,type,
    v85238: ( state_type * $int ) > $o ).

tff(pred_def_45657,type,
    v85490: ( state_type * $int ) > $o ).

tff(pred_def_45658,type,
    v85236: ( state_type * $int ) > $o ).

tff(pred_def_45659,type,
    v85234: ( state_type * $int ) > $o ).

tff(pred_def_45660,type,
    v85497: state_type > $o ).

tff(pred_def_45661,type,
    v85496: state_type > $o ).

tff(pred_def_45662,type,
    v85498: state_type > $o ).

tff(pred_def_45663,type,
    v85494: state_type > $o ).

tff(pred_def_45664,type,
    v85492: state_type > $o ).

tff(pred_def_45665,type,
    v85502: state_type > $o ).

tff(pred_def_45666,type,
    v85501: ( state_type * $int ) > $o ).

tff(pred_def_45667,type,
    v85500: ( state_type * $int ) > $o ).

tff(pred_def_45668,type,
    v85506: state_type > $o ).

tff(pred_def_45669,type,
    v85505: ( state_type * $int ) > $o ).

tff(pred_def_45670,type,
    v85504: ( state_type * $int ) > $o ).

tff(pred_def_45671,type,
    v85218: ( state_type * $int ) > $o ).

tff(pred_def_45672,type,
    v85503: ( state_type * $int ) > $o ).

tff(pred_def_45673,type,
    v85499: ( state_type * $int ) > $o ).

tff(pred_def_45674,type,
    v85232: ( state_type * $int ) > $o ).

tff(pred_def_45675,type,
    v85230: ( state_type * $int ) > $o ).

tff(pred_def_45676,type,
    v85510: state_type > $o ).

tff(pred_def_45677,type,
    v85508: state_type > $o ).

tff(pred_def_45678,type,
    v85517: state_type > $o ).

tff(pred_def_45679,type,
    v85515: state_type > $o ).

tff(pred_def_45680,type,
    v85514: state_type > $o ).

tff(pred_def_45681,type,
    v85513: state_type > $o ).

tff(pred_def_45682,type,
    v85525: state_type > $o ).

tff(pred_def_45683,type,
    v85526: state_type > $o ).

tff(pred_def_45684,type,
    v85524: state_type > $o ).

tff(pred_def_45685,type,
    v85521: ( state_type * $int ) > $o ).

tff(pred_def_45686,type,
    v85523: ( state_type * $int ) > $o ).

tff(pred_def_45687,type,
    v85512: ( state_type * $int ) > $o ).

tff(pred_def_45688,type,
    v85220: ( state_type * $int ) > $o ).

tff(pred_def_45689,type,
    v85216: ( state_type * $int ) > $o ).

tff(pred_def_45690,type,
    v85529: ( state_type * $int ) > $o ).

tff(pred_def_45691,type,
    v85214: ( state_type * $int ) > $o ).

tff(pred_def_45692,type,
    v85212: ( state_type * $int ) > $o ).

tff(pred_def_45693,type,
    v85536: state_type > $o ).

tff(pred_def_45694,type,
    v85535: state_type > $o ).

tff(pred_def_45695,type,
    v85537: state_type > $o ).

tff(pred_def_45696,type,
    v85533: state_type > $o ).

tff(pred_def_45697,type,
    v85531: state_type > $o ).

tff(pred_def_45698,type,
    v85541: state_type > $o ).

tff(pred_def_45699,type,
    v85540: ( state_type * $int ) > $o ).

tff(pred_def_45700,type,
    v85539: ( state_type * $int ) > $o ).

tff(pred_def_45701,type,
    v85545: state_type > $o ).

tff(pred_def_45702,type,
    v85544: ( state_type * $int ) > $o ).

tff(pred_def_45703,type,
    v85543: ( state_type * $int ) > $o ).

tff(pred_def_45704,type,
    v85196: ( state_type * $int ) > $o ).

tff(pred_def_45705,type,
    v85542: ( state_type * $int ) > $o ).

tff(pred_def_45706,type,
    v85538: ( state_type * $int ) > $o ).

tff(pred_def_45707,type,
    v85210: ( state_type * $int ) > $o ).

tff(pred_def_45708,type,
    v85208: ( state_type * $int ) > $o ).

tff(pred_def_45709,type,
    v85549: state_type > $o ).

tff(pred_def_45710,type,
    v85547: state_type > $o ).

tff(pred_def_45711,type,
    v85556: state_type > $o ).

tff(pred_def_45712,type,
    v85554: state_type > $o ).

tff(pred_def_45713,type,
    v85553: state_type > $o ).

tff(pred_def_45714,type,
    v85552: state_type > $o ).

tff(pred_def_45715,type,
    v85564: state_type > $o ).

tff(pred_def_45716,type,
    v85565: state_type > $o ).

tff(pred_def_45717,type,
    v85563: state_type > $o ).

tff(pred_def_45718,type,
    v85560: ( state_type * $int ) > $o ).

tff(pred_def_45719,type,
    v85562: ( state_type * $int ) > $o ).

tff(pred_def_45720,type,
    v85551: ( state_type * $int ) > $o ).

tff(pred_def_45721,type,
    v85198: ( state_type * $int ) > $o ).

tff(pred_def_45722,type,
    v85194: ( state_type * $int ) > $o ).

tff(pred_def_45723,type,
    v85568: ( state_type * $int ) > $o ).

tff(pred_def_45724,type,
    v85192: ( state_type * $int ) > $o ).

tff(pred_def_45725,type,
    v85190: ( state_type * $int ) > $o ).

tff(pred_def_45726,type,
    v85575: state_type > $o ).

tff(pred_def_45727,type,
    v85574: state_type > $o ).

tff(pred_def_45728,type,
    v85576: state_type > $o ).

tff(pred_def_45729,type,
    v85572: state_type > $o ).

tff(pred_def_45730,type,
    v85570: state_type > $o ).

tff(pred_def_45731,type,
    v85580: state_type > $o ).

tff(pred_def_45732,type,
    v85579: ( state_type * $int ) > $o ).

tff(pred_def_45733,type,
    v85578: ( state_type * $int ) > $o ).

tff(pred_def_45734,type,
    v85584: state_type > $o ).

tff(pred_def_45735,type,
    v85583: ( state_type * $int ) > $o ).

tff(pred_def_45736,type,
    v85582: ( state_type * $int ) > $o ).

tff(pred_def_45737,type,
    v85174: ( state_type * $int ) > $o ).

tff(pred_def_45738,type,
    v85581: ( state_type * $int ) > $o ).

tff(pred_def_45739,type,
    v85577: ( state_type * $int ) > $o ).

tff(pred_def_45740,type,
    v85188: ( state_type * $int ) > $o ).

tff(pred_def_45741,type,
    v85186: ( state_type * $int ) > $o ).

tff(pred_def_45742,type,
    v85588: state_type > $o ).

tff(pred_def_45743,type,
    v85586: state_type > $o ).

tff(pred_def_45744,type,
    v85595: state_type > $o ).

tff(pred_def_45745,type,
    v85593: state_type > $o ).

tff(pred_def_45746,type,
    v85592: state_type > $o ).

tff(pred_def_45747,type,
    v85591: state_type > $o ).

tff(pred_def_45748,type,
    v85603: state_type > $o ).

tff(pred_def_45749,type,
    v85604: state_type > $o ).

tff(pred_def_45750,type,
    v85602: state_type > $o ).

tff(pred_def_45751,type,
    v85599: ( state_type * $int ) > $o ).

tff(pred_def_45752,type,
    v85601: ( state_type * $int ) > $o ).

tff(pred_def_45753,type,
    v85590: ( state_type * $int ) > $o ).

tff(pred_def_45754,type,
    v85176: ( state_type * $int ) > $o ).

tff(pred_def_45755,type,
    v85172: ( state_type * $int ) > $o ).

tff(pred_def_45756,type,
    v85607: ( state_type * $int ) > $o ).

tff(pred_def_45757,type,
    v85170: ( state_type * $int ) > $o ).

tff(pred_def_45758,type,
    v85168: ( state_type * $int ) > $o ).

tff(pred_def_45759,type,
    v85614: state_type > $o ).

tff(pred_def_45760,type,
    v85613: state_type > $o ).

tff(pred_def_45761,type,
    v85615: state_type > $o ).

tff(pred_def_45762,type,
    v85611: state_type > $o ).

tff(pred_def_45763,type,
    v85609: state_type > $o ).

tff(pred_def_45764,type,
    v85619: state_type > $o ).

tff(pred_def_45765,type,
    v85618: ( state_type * $int ) > $o ).

tff(pred_def_45766,type,
    v85617: ( state_type * $int ) > $o ).

tff(pred_def_45767,type,
    v85623: state_type > $o ).

tff(pred_def_45768,type,
    v85622: ( state_type * $int ) > $o ).

tff(pred_def_45769,type,
    v85621: ( state_type * $int ) > $o ).

tff(pred_def_45770,type,
    v85152: ( state_type * $int ) > $o ).

tff(pred_def_45771,type,
    v85620: ( state_type * $int ) > $o ).

tff(pred_def_45772,type,
    v85616: ( state_type * $int ) > $o ).

tff(pred_def_45773,type,
    v85166: ( state_type * $int ) > $o ).

tff(pred_def_45774,type,
    v85164: ( state_type * $int ) > $o ).

tff(pred_def_45775,type,
    v85627: state_type > $o ).

tff(pred_def_45776,type,
    v85625: state_type > $o ).

tff(pred_def_45777,type,
    v85634: state_type > $o ).

tff(pred_def_45778,type,
    v85632: state_type > $o ).

tff(pred_def_45779,type,
    v85631: state_type > $o ).

tff(pred_def_45780,type,
    v85630: state_type > $o ).

tff(pred_def_45781,type,
    v85642: state_type > $o ).

tff(pred_def_45782,type,
    v85643: state_type > $o ).

tff(pred_def_45783,type,
    v85641: state_type > $o ).

tff(pred_def_45784,type,
    v85638: ( state_type * $int ) > $o ).

tff(pred_def_45785,type,
    v85640: ( state_type * $int ) > $o ).

tff(pred_def_45786,type,
    v85629: ( state_type * $int ) > $o ).

tff(pred_def_45787,type,
    v85154: ( state_type * $int ) > $o ).

tff(pred_def_45788,type,
    v85150: ( state_type * $int ) > $o ).

tff(pred_def_45789,type,
    v85646: ( state_type * $int ) > $o ).

tff(pred_def_45790,type,
    v85148: ( state_type * $int ) > $o ).

tff(pred_def_45791,type,
    v85146: ( state_type * $int ) > $o ).

tff(pred_def_45792,type,
    v85653: state_type > $o ).

tff(pred_def_45793,type,
    v85652: state_type > $o ).

tff(pred_def_45794,type,
    v85650: state_type > $o ).

tff(pred_def_45795,type,
    v85648: state_type > $o ).

tff(pred_def_45796,type,
    v85657: state_type > $o ).

tff(pred_def_45797,type,
    v85656: ( state_type * $int ) > $o ).

tff(pred_def_45798,type,
    v85655: ( state_type * $int ) > $o ).

tff(pred_def_45799,type,
    v85661: state_type > $o ).

tff(pred_def_45800,type,
    v85660: ( state_type * $int ) > $o ).

tff(pred_def_45801,type,
    v85659: ( state_type * $int ) > $o ).

tff(pred_def_45802,type,
    v85130: ( state_type * $int ) > $o ).

tff(pred_def_45803,type,
    v85658: ( state_type * $int ) > $o ).

tff(pred_def_45804,type,
    v85654: ( state_type * $int ) > $o ).

tff(pred_def_45805,type,
    v85144: ( state_type * $int ) > $o ).

tff(pred_def_45806,type,
    v85142: ( state_type * $int ) > $o ).

tff(pred_def_45807,type,
    v85665: state_type > $o ).

tff(pred_def_45808,type,
    v85663: state_type > $o ).

tff(pred_def_45809,type,
    v85672: state_type > $o ).

tff(pred_def_45810,type,
    v85670: state_type > $o ).

tff(pred_def_45811,type,
    v85669: state_type > $o ).

tff(pred_def_45812,type,
    v85668: state_type > $o ).

tff(pred_def_45813,type,
    v85680: state_type > $o ).

tff(pred_def_45814,type,
    v85681: state_type > $o ).

tff(pred_def_45815,type,
    v85679: state_type > $o ).

tff(pred_def_45816,type,
    v85676: ( state_type * $int ) > $o ).

tff(pred_def_45817,type,
    v85678: ( state_type * $int ) > $o ).

tff(pred_def_45818,type,
    v85667: ( state_type * $int ) > $o ).

tff(pred_def_45819,type,
    v85132: ( state_type * $int ) > $o ).

tff(pred_def_45820,type,
    v85128: ( state_type * $int ) > $o ).

tff(pred_def_45821,type,
    v85685: state_type > $o ).

tff(pred_def_45822,type,
    v85686: state_type > $o ).

tff(pred_def_45823,type,
    v85687: state_type > $o ).

tff(pred_def_45824,type,
    v85688: state_type > $o ).

tff(pred_def_45825,type,
    v85689: state_type > $o ).

tff(pred_def_45826,type,
    v85690: state_type > $o ).

tff(pred_def_45827,type,
    v85691: state_type > $o ).

tff(pred_def_45828,type,
    v85692: state_type > $o ).

tff(pred_def_45829,type,
    v85693: state_type > $o ).

tff(pred_def_45830,type,
    v85694: state_type > $o ).

tff(pred_def_45831,type,
    v85695: state_type > $o ).

tff(pred_def_45832,type,
    v85696: state_type > $o ).

tff(pred_def_45833,type,
    v85697: state_type > $o ).

tff(pred_def_45834,type,
    v85698: state_type > $o ).

tff(pred_def_45835,type,
    v85699: state_type > $o ).

tff(pred_def_45836,type,
    v85700: state_type > $o ).

tff(pred_def_45837,type,
    v85126: ( state_type * $int ) > $o ).

tff(pred_def_45838,type,
    v85728: state_type > $o ).

tff(pred_def_45839,type,
    v85726: state_type > $o ).

tff(pred_def_45840,type,
    v85724: state_type > $o ).

tff(pred_def_45841,type,
    v85722: state_type > $o ).

tff(pred_def_45842,type,
    v85736: state_type > $o ).

tff(pred_def_45843,type,
    v85734: state_type > $o ).

tff(pred_def_45844,type,
    v85732: state_type > $o ).

tff(pred_def_45845,type,
    v85730: state_type > $o ).

tff(pred_def_45846,type,
    v85758: state_type > $o ).

tff(pred_def_45847,type,
    v85756: state_type > $o ).

tff(pred_def_45848,type,
    v85762: state_type > $o ).

tff(pred_def_45849,type,
    v85760: state_type > $o ).

tff(pred_def_45850,type,
    v85780: state_type > $o ).

tff(pred_def_45851,type,
    v85778: state_type > $o ).

tff(pred_def_45852,type,
    v85784: state_type > $o ).

tff(pred_def_45853,type,
    v85782: state_type > $o ).

tff(pred_def_45854,type,
    v85788: state_type > $o ).

tff(pred_def_45855,type,
    v85786: state_type > $o ).

tff(pred_def_45856,type,
    v85811: state_type > $o ).

tff(pred_def_45857,type,
    v85809: state_type > $o ).

tff(pred_def_45858,type,
    v85807: state_type > $o ).

tff(pred_def_45859,type,
    v85805: state_type > $o ).

tff(pred_def_45860,type,
    v85819: state_type > $o ).

tff(pred_def_45861,type,
    v85817: state_type > $o ).

tff(pred_def_45862,type,
    v85815: state_type > $o ).

tff(pred_def_45863,type,
    v85813: state_type > $o ).

tff(pred_def_45864,type,
    v85837: state_type > $o ).

tff(pred_def_45865,type,
    v85835: state_type > $o ).

tff(pred_def_45866,type,
    v85841: state_type > $o ).

tff(pred_def_45867,type,
    v85839: state_type > $o ).

tff(pred_def_45868,type,
    v85853: ( state_type * $int ) > $o ).

tff(pred_def_45869,type,
    v85855: ( state_type * $int ) > $o ).

tff(pred_def_45870,type,
    v85851: ( state_type * $int ) > $o ).

tff(pred_def_45871,type,
    v85849: state_type > $o ).

tff(pred_def_45872,type,
    v85847: state_type > $o ).

tff(pred_def_45873,type,
    v85864: ( state_type * $int ) > $o ).

tff(pred_def_45874,type,
    v85866: ( state_type * $int ) > $o ).

tff(pred_def_45875,type,
    v85862: state_type > $o ).

tff(pred_def_45876,type,
    v85870: ( state_type * $int ) > $o ).

tff(pred_def_45877,type,
    v85872: ( state_type * $int ) > $o ).

tff(pred_def_45878,type,
    v85868: state_type > $o ).

tff(pred_def_45879,type,
    v85874: state_type > $o ).

tff(pred_def_45880,type,
    v85884: state_type > $o ).

tff(pred_def_45881,type,
    v85882: state_type > $o ).

tff(pred_def_45882,type,
    v85888: state_type > $o ).

tff(pred_def_45883,type,
    v85886: state_type > $o ).

tff(pred_def_45884,type,
    v85906: state_type > $o ).

tff(pred_def_45885,type,
    v85904: state_type > $o ).

tff(pred_def_45886,type,
    v85910: state_type > $o ).

tff(pred_def_45887,type,
    v85908: state_type > $o ).

tff(pred_def_45888,type,
    v85920: state_type > $o ).

tff(pred_def_45889,type,
    v85922: state_type > $o ).

tff(pred_def_45890,type,
    v85918: state_type > $o ).

tff(pred_def_45891,type,
    v85916: state_type > $o ).

tff(pred_def_45892,type,
    v85924: state_type > $o ).

tff(pred_def_45893,type,
    v85926: state_type > $o ).

tff(pred_def_45894,type,
    v85827: state_type > $o ).

tff(pred_def_45895,type,
    v85931: state_type > $o ).

tff(pred_def_45896,type,
    v85930: state_type > $o ).

tff(pred_def_45897,type,
    v85929: state_type > $o ).

tff(pred_def_45898,type,
    v85934: state_type > $o ).

tff(pred_def_45899,type,
    v85933: state_type > $o ).

tff(pred_def_45900,type,
    v85932: state_type > $o ).

tff(pred_def_45901,type,
    v85928: state_type > $o ).

tff(pred_def_45902,type,
    v85939: state_type > $o ).

tff(pred_def_45903,type,
    v85938: state_type > $o ).

tff(pred_def_45904,type,
    v85937: state_type > $o ).

tff(pred_def_45905,type,
    v85900: state_type > $o ).

tff(pred_def_45906,type,
    v85936: state_type > $o ).

tff(pred_def_45907,type,
    v85942: state_type > $o ).

tff(pred_def_45908,type,
    v85941: state_type > $o ).

tff(pred_def_45909,type,
    v85940: state_type > $o ).

tff(pred_def_45910,type,
    v85935: state_type > $o ).

tff(pred_def_45911,type,
    v85914: state_type > $o ).

tff(pred_def_45912,type,
    v85912: state_type > $o ).

tff(pred_def_45913,type,
    v85958: state_type > $o ).

tff(pred_def_45914,type,
    v85956: state_type > $o ).

tff(pred_def_45915,type,
    v85954: state_type > $o ).

tff(pred_def_45916,type,
    v85964: state_type > $o ).

tff(pred_def_45917,type,
    v85962: state_type > $o ).

tff(pred_def_45918,type,
    v85968: state_type > $o ).

tff(pred_def_45919,type,
    v85966: state_type > $o ).

tff(pred_def_45920,type,
    v85976: state_type > $o ).

tff(pred_def_45921,type,
    v85974: state_type > $o ).

tff(pred_def_45922,type,
    v85972: state_type > $o ).

tff(pred_def_45923,type,
    v85970: state_type > $o ).

tff(pred_def_45924,type,
    v85960: state_type > $o ).

tff(pred_def_45925,type,
    v85982: state_type > $o ).

tff(pred_def_45926,type,
    v85984: state_type > $o ).

tff(pred_def_45927,type,
    v85980: state_type > $o ).

tff(pred_def_45928,type,
    v85979: state_type > $o ).

tff(pred_def_45929,type,
    v85990: state_type > $o ).

tff(pred_def_45930,type,
    v85991: state_type > $o ).

tff(pred_def_45931,type,
    v85987: state_type > $o ).

tff(pred_def_45932,type,
    v85989: state_type > $o ).

tff(pred_def_45933,type,
    v86001: state_type > $o ).

tff(pred_def_45934,type,
    v85999: state_type > $o ).

tff(pred_def_45935,type,
    v85997: state_type > $o ).

tff(pred_def_45936,type,
    v85995: state_type > $o ).

tff(pred_def_45937,type,
    v86003: state_type > $o ).

tff(pred_def_45938,type,
    v85952: state_type > $o ).

tff(pred_def_45939,type,
    v85950: state_type > $o ).

tff(pred_def_45940,type,
    v85948: state_type > $o ).

tff(pred_def_45941,type,
    v85946: state_type > $o ).

tff(pred_def_45942,type,
    v85944: state_type > $o ).

tff(pred_def_45943,type,
    v86010: state_type > $o ).

tff(pred_def_45944,type,
    v86008: state_type > $o ).

tff(pred_def_45945,type,
    v86007: state_type > $o ).

tff(pred_def_45946,type,
    v86006: state_type > $o ).

tff(pred_def_45947,type,
    v86018: state_type > $o ).

tff(pred_def_45948,type,
    v86019: state_type > $o ).

tff(pred_def_45949,type,
    v86017: state_type > $o ).

tff(pred_def_45950,type,
    v86014: state_type > $o ).

tff(pred_def_45951,type,
    v86016: state_type > $o ).

tff(pred_def_45952,type,
    v85902: state_type > $o ).

tff(pred_def_45953,type,
    v85898: state_type > $o ).

tff(pred_def_45954,type,
    v86031: state_type > $o ).

tff(pred_def_45955,type,
    v86029: state_type > $o ).

tff(pred_def_45956,type,
    v86035: state_type > $o ).

tff(pred_def_45957,type,
    v86033: state_type > $o ).

tff(pred_def_45958,type,
    v86043: state_type > $o ).

tff(pred_def_45959,type,
    v86041: state_type > $o ).

tff(pred_def_45960,type,
    v86053: state_type > $o ).

tff(pred_def_45961,type,
    v86052: state_type > $o ).

tff(pred_def_45962,type,
    v86054: state_type > $o ).

tff(pred_def_45963,type,
    v86051: state_type > $o ).

tff(pred_def_45964,type,
    v85876: ( state_type * $int ) > $o ).

tff(pred_def_45965,type,
    v86055: state_type > $o ).

tff(pred_def_45966,type,
    v86050: state_type > $o ).

tff(pred_def_45967,type,
    v86048: state_type > $o ).

tff(pred_def_45968,type,
    v86046: state_type > $o ).

tff(pred_def_45969,type,
    v86059: state_type > $o ).

tff(pred_def_45970,type,
    v86058: state_type > $o ).

tff(pred_def_45971,type,
    v86057: state_type > $o ).

tff(pred_def_45972,type,
    v86063: state_type > $o ).

tff(pred_def_45973,type,
    v86062: state_type > $o ).

tff(pred_def_45974,type,
    v86061: state_type > $o ).

tff(pred_def_45975,type,
    v86025: state_type > $o ).

tff(pred_def_45976,type,
    v86060: state_type > $o ).

tff(pred_def_45977,type,
    v86039: state_type > $o ).

tff(pred_def_45978,type,
    v86037: state_type > $o ).

tff(pred_def_45979,type,
    v86067: state_type > $o ).

tff(pred_def_45980,type,
    v86065: state_type > $o ).

tff(pred_def_45981,type,
    v86074: state_type > $o ).

tff(pred_def_45982,type,
    v86072: state_type > $o ).

tff(pred_def_45983,type,
    v86071: state_type > $o ).

tff(pred_def_45984,type,
    v86070: state_type > $o ).

tff(pred_def_45985,type,
    v86082: state_type > $o ).

tff(pred_def_45986,type,
    v86083: state_type > $o ).

tff(pred_def_45987,type,
    v86081: state_type > $o ).

tff(pred_def_45988,type,
    v86078: state_type > $o ).

tff(pred_def_45989,type,
    v86080: state_type > $o ).

tff(pred_def_45990,type,
    v86027: state_type > $o ).

tff(pred_def_45991,type,
    v86023: state_type > $o ).

tff(pred_def_45992,type,
    v86095: state_type > $o ).

tff(pred_def_45993,type,
    v86093: state_type > $o ).

tff(pred_def_45994,type,
    v86099: state_type > $o ).

tff(pred_def_45995,type,
    v86097: state_type > $o ).

tff(pred_def_45996,type,
    v86107: state_type > $o ).

tff(pred_def_45997,type,
    v86105: state_type > $o ).

tff(pred_def_45998,type,
    v86117: state_type > $o ).

tff(pred_def_45999,type,
    v86116: state_type > $o ).

tff(pred_def_46000,type,
    v86118: state_type > $o ).

tff(pred_def_46001,type,
    v86115: state_type > $o ).

tff(pred_def_46002,type,
    v86119: state_type > $o ).

tff(pred_def_46003,type,
    v86114: state_type > $o ).

tff(pred_def_46004,type,
    v86112: state_type > $o ).

tff(pred_def_46005,type,
    v86110: state_type > $o ).

tff(pred_def_46006,type,
    v86123: state_type > $o ).

tff(pred_def_46007,type,
    v86122: state_type > $o ).

tff(pred_def_46008,type,
    v86121: state_type > $o ).

tff(pred_def_46009,type,
    v86127: state_type > $o ).

tff(pred_def_46010,type,
    v86126: state_type > $o ).

tff(pred_def_46011,type,
    v86125: state_type > $o ).

tff(pred_def_46012,type,
    v86089: state_type > $o ).

tff(pred_def_46013,type,
    v86124: state_type > $o ).

tff(pred_def_46014,type,
    v86103: state_type > $o ).

tff(pred_def_46015,type,
    v86101: state_type > $o ).

tff(pred_def_46016,type,
    v86131: state_type > $o ).

tff(pred_def_46017,type,
    v86129: state_type > $o ).

tff(pred_def_46018,type,
    v86138: state_type > $o ).

tff(pred_def_46019,type,
    v86136: state_type > $o ).

tff(pred_def_46020,type,
    v86135: state_type > $o ).

tff(pred_def_46021,type,
    v86134: state_type > $o ).

tff(pred_def_46022,type,
    v86146: state_type > $o ).

tff(pred_def_46023,type,
    v86147: state_type > $o ).

tff(pred_def_46024,type,
    v86145: state_type > $o ).

tff(pred_def_46025,type,
    v86142: state_type > $o ).

tff(pred_def_46026,type,
    v86144: state_type > $o ).

tff(pred_def_46027,type,
    v86091: state_type > $o ).

tff(pred_def_46028,type,
    v86087: state_type > $o ).

tff(pred_def_46029,type,
    v86159: state_type > $o ).

tff(pred_def_46030,type,
    v86157: state_type > $o ).

tff(pred_def_46031,type,
    v86163: state_type > $o ).

tff(pred_def_46032,type,
    v86161: state_type > $o ).

tff(pred_def_46033,type,
    v86171: state_type > $o ).

tff(pred_def_46034,type,
    v86169: state_type > $o ).

tff(pred_def_46035,type,
    v86181: state_type > $o ).

tff(pred_def_46036,type,
    v86180: state_type > $o ).

tff(pred_def_46037,type,
    v86182: state_type > $o ).

tff(pred_def_46038,type,
    v86179: state_type > $o ).

tff(pred_def_46039,type,
    v86183: state_type > $o ).

tff(pred_def_46040,type,
    v86178: state_type > $o ).

tff(pred_def_46041,type,
    v86176: state_type > $o ).

tff(pred_def_46042,type,
    v86174: state_type > $o ).

tff(pred_def_46043,type,
    v86187: state_type > $o ).

tff(pred_def_46044,type,
    v86186: state_type > $o ).

tff(pred_def_46045,type,
    v86185: state_type > $o ).

tff(pred_def_46046,type,
    v86191: state_type > $o ).

tff(pred_def_46047,type,
    v86190: state_type > $o ).

tff(pred_def_46048,type,
    v86189: state_type > $o ).

tff(pred_def_46049,type,
    v86153: state_type > $o ).

tff(pred_def_46050,type,
    v86188: state_type > $o ).

tff(pred_def_46051,type,
    v86167: state_type > $o ).

tff(pred_def_46052,type,
    v86165: state_type > $o ).

tff(pred_def_46053,type,
    v86195: state_type > $o ).

tff(pred_def_46054,type,
    v86193: state_type > $o ).

tff(pred_def_46055,type,
    v86202: state_type > $o ).

tff(pred_def_46056,type,
    v86200: state_type > $o ).

tff(pred_def_46057,type,
    v86199: state_type > $o ).

tff(pred_def_46058,type,
    v86198: state_type > $o ).

tff(pred_def_46059,type,
    v86210: state_type > $o ).

tff(pred_def_46060,type,
    v86211: state_type > $o ).

tff(pred_def_46061,type,
    v86209: state_type > $o ).

tff(pred_def_46062,type,
    v86206: state_type > $o ).

tff(pred_def_46063,type,
    v86208: state_type > $o ).

tff(pred_def_46064,type,
    v86155: state_type > $o ).

tff(pred_def_46065,type,
    v86151: state_type > $o ).

tff(pred_def_46066,type,
    v86223: state_type > $o ).

tff(pred_def_46067,type,
    v86221: state_type > $o ).

tff(pred_def_46068,type,
    v86227: state_type > $o ).

tff(pred_def_46069,type,
    v86225: state_type > $o ).

tff(pred_def_46070,type,
    v86235: state_type > $o ).

tff(pred_def_46071,type,
    v86233: state_type > $o ).

tff(pred_def_46072,type,
    v86245: state_type > $o ).

tff(pred_def_46073,type,
    v86244: state_type > $o ).

tff(pred_def_46074,type,
    v86246: state_type > $o ).

tff(pred_def_46075,type,
    v86243: state_type > $o ).

tff(pred_def_46076,type,
    v86247: state_type > $o ).

tff(pred_def_46077,type,
    v86242: state_type > $o ).

tff(pred_def_46078,type,
    v86240: state_type > $o ).

tff(pred_def_46079,type,
    v86238: state_type > $o ).

tff(pred_def_46080,type,
    v86251: state_type > $o ).

tff(pred_def_46081,type,
    v86250: state_type > $o ).

tff(pred_def_46082,type,
    v86249: state_type > $o ).

tff(pred_def_46083,type,
    v86255: state_type > $o ).

tff(pred_def_46084,type,
    v86254: state_type > $o ).

tff(pred_def_46085,type,
    v86253: state_type > $o ).

tff(pred_def_46086,type,
    v86217: state_type > $o ).

tff(pred_def_46087,type,
    v86252: state_type > $o ).

tff(pred_def_46088,type,
    v86231: state_type > $o ).

tff(pred_def_46089,type,
    v86229: state_type > $o ).

tff(pred_def_46090,type,
    v86259: state_type > $o ).

tff(pred_def_46091,type,
    v86257: state_type > $o ).

tff(pred_def_46092,type,
    v86266: state_type > $o ).

tff(pred_def_46093,type,
    v86264: state_type > $o ).

tff(pred_def_46094,type,
    v86263: state_type > $o ).

tff(pred_def_46095,type,
    v86262: state_type > $o ).

tff(pred_def_46096,type,
    v86274: state_type > $o ).

tff(pred_def_46097,type,
    v86275: state_type > $o ).

tff(pred_def_46098,type,
    v86273: state_type > $o ).

tff(pred_def_46099,type,
    v86270: state_type > $o ).

tff(pred_def_46100,type,
    v86272: state_type > $o ).

tff(pred_def_46101,type,
    v86219: state_type > $o ).

tff(pred_def_46102,type,
    v86215: state_type > $o ).

tff(pred_def_46103,type,
    v86287: state_type > $o ).

tff(pred_def_46104,type,
    v86285: state_type > $o ).

tff(pred_def_46105,type,
    v86291: state_type > $o ).

tff(pred_def_46106,type,
    v86289: state_type > $o ).

tff(pred_def_46107,type,
    v86299: state_type > $o ).

tff(pred_def_46108,type,
    v86297: state_type > $o ).

tff(pred_def_46109,type,
    v86309: state_type > $o ).

tff(pred_def_46110,type,
    v86308: state_type > $o ).

tff(pred_def_46111,type,
    v86310: state_type > $o ).

tff(pred_def_46112,type,
    v86307: state_type > $o ).

tff(pred_def_46113,type,
    v86311: state_type > $o ).

tff(pred_def_46114,type,
    v86306: state_type > $o ).

tff(pred_def_46115,type,
    v86304: state_type > $o ).

tff(pred_def_46116,type,
    v86302: state_type > $o ).

tff(pred_def_46117,type,
    v86315: state_type > $o ).

tff(pred_def_46118,type,
    v86314: state_type > $o ).

tff(pred_def_46119,type,
    v86313: state_type > $o ).

tff(pred_def_46120,type,
    v86319: state_type > $o ).

tff(pred_def_46121,type,
    v86318: state_type > $o ).

tff(pred_def_46122,type,
    v86317: state_type > $o ).

tff(pred_def_46123,type,
    v86281: state_type > $o ).

tff(pred_def_46124,type,
    v86316: state_type > $o ).

tff(pred_def_46125,type,
    v86295: state_type > $o ).

tff(pred_def_46126,type,
    v86293: state_type > $o ).

tff(pred_def_46127,type,
    v86323: state_type > $o ).

tff(pred_def_46128,type,
    v86321: state_type > $o ).

tff(pred_def_46129,type,
    v86330: state_type > $o ).

tff(pred_def_46130,type,
    v86328: state_type > $o ).

tff(pred_def_46131,type,
    v86327: state_type > $o ).

tff(pred_def_46132,type,
    v86326: state_type > $o ).

tff(pred_def_46133,type,
    v86338: state_type > $o ).

tff(pred_def_46134,type,
    v86339: state_type > $o ).

tff(pred_def_46135,type,
    v86337: state_type > $o ).

tff(pred_def_46136,type,
    v86334: state_type > $o ).

tff(pred_def_46137,type,
    v86336: state_type > $o ).

tff(pred_def_46138,type,
    v86283: state_type > $o ).

tff(pred_def_46139,type,
    v86279: state_type > $o ).

tff(pred_def_46140,type,
    v86351: state_type > $o ).

tff(pred_def_46141,type,
    v86349: state_type > $o ).

tff(pred_def_46142,type,
    v86355: state_type > $o ).

tff(pred_def_46143,type,
    v86353: state_type > $o ).

tff(pred_def_46144,type,
    v86363: state_type > $o ).

tff(pred_def_46145,type,
    v86361: state_type > $o ).

tff(pred_def_46146,type,
    v86373: state_type > $o ).

tff(pred_def_46147,type,
    v86372: state_type > $o ).

tff(pred_def_46148,type,
    v86374: state_type > $o ).

tff(pred_def_46149,type,
    v86371: state_type > $o ).

tff(pred_def_46150,type,
    v86375: state_type > $o ).

tff(pred_def_46151,type,
    v86370: state_type > $o ).

tff(pred_def_46152,type,
    v86368: state_type > $o ).

tff(pred_def_46153,type,
    v86366: state_type > $o ).

tff(pred_def_46154,type,
    v86379: state_type > $o ).

tff(pred_def_46155,type,
    v86378: state_type > $o ).

tff(pred_def_46156,type,
    v86377: state_type > $o ).

tff(pred_def_46157,type,
    v86383: state_type > $o ).

tff(pred_def_46158,type,
    v86382: state_type > $o ).

tff(pred_def_46159,type,
    v86381: state_type > $o ).

tff(pred_def_46160,type,
    v86345: state_type > $o ).

tff(pred_def_46161,type,
    v86380: state_type > $o ).

tff(pred_def_46162,type,
    v86359: state_type > $o ).

tff(pred_def_46163,type,
    v86357: state_type > $o ).

tff(pred_def_46164,type,
    v86387: state_type > $o ).

tff(pred_def_46165,type,
    v86385: state_type > $o ).

tff(pred_def_46166,type,
    v86394: state_type > $o ).

tff(pred_def_46167,type,
    v86392: state_type > $o ).

tff(pred_def_46168,type,
    v86391: state_type > $o ).

tff(pred_def_46169,type,
    v86390: state_type > $o ).

tff(pred_def_46170,type,
    v86402: state_type > $o ).

tff(pred_def_46171,type,
    v86403: state_type > $o ).

tff(pred_def_46172,type,
    v86401: state_type > $o ).

tff(pred_def_46173,type,
    v86398: state_type > $o ).

tff(pred_def_46174,type,
    v86400: state_type > $o ).

tff(pred_def_46175,type,
    v86347: state_type > $o ).

tff(pred_def_46176,type,
    v86343: state_type > $o ).

tff(pred_def_46177,type,
    v86415: state_type > $o ).

tff(pred_def_46178,type,
    v86413: state_type > $o ).

tff(pred_def_46179,type,
    v86419: state_type > $o ).

tff(pred_def_46180,type,
    v86417: state_type > $o ).

tff(pred_def_46181,type,
    v86427: state_type > $o ).

tff(pred_def_46182,type,
    v86425: state_type > $o ).

tff(pred_def_46183,type,
    v86437: state_type > $o ).

tff(pred_def_46184,type,
    v86436: state_type > $o ).

tff(pred_def_46185,type,
    v86438: state_type > $o ).

tff(pred_def_46186,type,
    v86435: state_type > $o ).

tff(pred_def_46187,type,
    v86439: state_type > $o ).

tff(pred_def_46188,type,
    v86434: state_type > $o ).

tff(pred_def_46189,type,
    v86432: state_type > $o ).

tff(pred_def_46190,type,
    v86430: state_type > $o ).

tff(pred_def_46191,type,
    v86443: state_type > $o ).

tff(pred_def_46192,type,
    v86442: state_type > $o ).

tff(pred_def_46193,type,
    v86441: state_type > $o ).

tff(pred_def_46194,type,
    v86447: state_type > $o ).

tff(pred_def_46195,type,
    v86446: state_type > $o ).

tff(pred_def_46196,type,
    v86445: state_type > $o ).

tff(pred_def_46197,type,
    v86409: state_type > $o ).

tff(pred_def_46198,type,
    v86444: state_type > $o ).

tff(pred_def_46199,type,
    v86423: state_type > $o ).

tff(pred_def_46200,type,
    v86421: state_type > $o ).

tff(pred_def_46201,type,
    v86451: state_type > $o ).

tff(pred_def_46202,type,
    v86449: state_type > $o ).

tff(pred_def_46203,type,
    v86458: state_type > $o ).

tff(pred_def_46204,type,
    v86456: state_type > $o ).

tff(pred_def_46205,type,
    v86455: state_type > $o ).

tff(pred_def_46206,type,
    v86454: state_type > $o ).

tff(pred_def_46207,type,
    v86466: state_type > $o ).

tff(pred_def_46208,type,
    v86467: state_type > $o ).

tff(pred_def_46209,type,
    v86465: state_type > $o ).

tff(pred_def_46210,type,
    v86462: state_type > $o ).

tff(pred_def_46211,type,
    v86464: state_type > $o ).

tff(pred_def_46212,type,
    v86411: state_type > $o ).

tff(pred_def_46213,type,
    v86407: state_type > $o ).

tff(pred_def_46214,type,
    v86478: ( state_type * $int ) > $o ).

tff(pred_def_46215,type,
    v86477: ( state_type * $int ) > $o ).

tff(pred_def_46216,type,
    v86476: ( state_type * $int ) > $o ).

tff(pred_def_46217,type,
    v86475: ( state_type * $int ) > $o ).

tff(pred_def_46218,type,
    v86474: ( state_type * $int ) > $o ).

tff(pred_def_46219,type,
    v86473: ( state_type * $int ) > $o ).

tff(pred_def_46220,type,
    v86471: ( state_type * $int ) > $o ).

tff(pred_def_46221,type,
    v86486: state_type > $o ).

tff(pred_def_46222,type,
    v86485: state_type > $o ).

tff(pred_def_46223,type,
    v86487: state_type > $o ).

tff(pred_def_46224,type,
    v86484: state_type > $o ).

tff(pred_def_46225,type,
    v86488: state_type > $o ).

tff(pred_def_46226,type,
    v86483: state_type > $o ).

tff(pred_def_46227,type,
    v86491: state_type > $o ).

tff(pred_def_46228,type,
    v86492: state_type > $o ).

tff(pred_def_46229,type,
    v86490: state_type > $o ).

tff(pred_def_46230,type,
    v86493: state_type > $o ).

tff(pred_def_46231,type,
    v86489: state_type > $o ).

tff(pred_def_46232,type,
    v86481: ( state_type * $int ) > $o ).

tff(pred_def_46233,type,
    v86480: ( state_type * $int ) > $o ).

tff(pred_def_46234,type,
    v85829: state_type > $o ).

tff(pred_def_46235,type,
    v86497: state_type > $o ).

tff(pred_def_46236,type,
    v86498: state_type > $o ).

tff(pred_def_46237,type,
    v86496: state_type > $o ).

tff(pred_def_46238,type,
    v86495: state_type > $o ).

tff(pred_def_46239,type,
    v86502: state_type > $o ).

tff(pred_def_46240,type,
    v86503: state_type > $o ).

tff(pred_def_46241,type,
    v86501: state_type > $o ).

tff(pred_def_46242,type,
    v86500: state_type > $o ).

tff(pred_def_46243,type,
    v86507: state_type > $o ).

tff(pred_def_46244,type,
    v86508: state_type > $o ).

tff(pred_def_46245,type,
    v86506: state_type > $o ).

tff(pred_def_46246,type,
    v86505: state_type > $o ).

tff(pred_def_46247,type,
    v86512: state_type > $o ).

tff(pred_def_46248,type,
    v86513: state_type > $o ).

tff(pred_def_46249,type,
    v86511: state_type > $o ).

tff(pred_def_46250,type,
    v86510: state_type > $o ).

tff(pred_def_46251,type,
    v86517: state_type > $o ).

tff(pred_def_46252,type,
    v86518: state_type > $o ).

tff(pred_def_46253,type,
    v86516: state_type > $o ).

tff(pred_def_46254,type,
    v86515: state_type > $o ).

tff(pred_def_46255,type,
    v86522: state_type > $o ).

tff(pred_def_46256,type,
    v86523: state_type > $o ).

tff(pred_def_46257,type,
    v86521: state_type > $o ).

tff(pred_def_46258,type,
    v86520: state_type > $o ).

tff(pred_def_46259,type,
    v86527: state_type > $o ).

tff(pred_def_46260,type,
    v86528: state_type > $o ).

tff(pred_def_46261,type,
    v86526: state_type > $o ).

tff(pred_def_46262,type,
    v86525: state_type > $o ).

tff(pred_def_46263,type,
    v86532: state_type > $o ).

tff(pred_def_46264,type,
    v86533: state_type > $o ).

tff(pred_def_46265,type,
    v86531: state_type > $o ).

tff(pred_def_46266,type,
    v86530: state_type > $o ).

tff(pred_def_46267,type,
    v86542: state_type > $o ).

tff(pred_def_46268,type,
    v86541: state_type > $o ).

tff(pred_def_46269,type,
    v86540: state_type > $o ).

tff(pred_def_46270,type,
    v86539: state_type > $o ).

tff(pred_def_46271,type,
    v86538: state_type > $o ).

tff(pred_def_46272,type,
    v86537: state_type > $o ).

tff(pred_def_46273,type,
    v86536: state_type > $o ).

tff(pred_def_46274,type,
    v86550: state_type > $o ).

tff(pred_def_46275,type,
    v86549: state_type > $o ).

tff(pred_def_46276,type,
    v86548: state_type > $o ).

tff(pred_def_46277,type,
    v86547: state_type > $o ).

tff(pred_def_46278,type,
    v86546: state_type > $o ).

tff(pred_def_46279,type,
    v86545: state_type > $o ).

tff(pred_def_46280,type,
    v86543: state_type > $o ).

tff(pred_def_46281,type,
    v86535: state_type > $o ).

tff(pred_def_46282,type,
    v86551: ( state_type * $int ) > $o ).

tff(pred_def_46283,type,
    v86534: ( state_type * $int ) > $o ).

tff(pred_def_46284,type,
    v86529: ( state_type * $int ) > $o ).

tff(pred_def_46285,type,
    v86524: ( state_type * $int ) > $o ).

tff(pred_def_46286,type,
    v86519: ( state_type * $int ) > $o ).

tff(pred_def_46287,type,
    v86514: ( state_type * $int ) > $o ).

tff(pred_def_46288,type,
    v86509: ( state_type * $int ) > $o ).

tff(pred_def_46289,type,
    v86504: ( state_type * $int ) > $o ).

tff(pred_def_46290,type,
    v86499: ( state_type * $int ) > $o ).

tff(pred_def_46291,type,
    v86494: ( state_type * $int ) > $o ).

tff(pred_def_46292,type,
    v86479: ( state_type * $int ) > $o ).

tff(pred_def_46293,type,
    v85896: ( state_type * $int ) > $o ).

tff(pred_def_46294,type,
    v85894: ( state_type * $int ) > $o ).

tff(pred_def_46295,type,
    v85892: ( state_type * $int ) > $o ).

tff(pred_def_46296,type,
    v85890: ( state_type * $int ) > $o ).

tff(pred_def_46297,type,
    v86555: state_type > $o ).

tff(pred_def_46298,type,
    v86553: state_type > $o ).

tff(pred_def_46299,type,
    v86562: state_type > $o ).

tff(pred_def_46300,type,
    v86560: state_type > $o ).

tff(pred_def_46301,type,
    v86559: state_type > $o ).

tff(pred_def_46302,type,
    v86558: state_type > $o ).

tff(pred_def_46303,type,
    v86570: state_type > $o ).

tff(pred_def_46304,type,
    v86571: state_type > $o ).

tff(pred_def_46305,type,
    v86569: state_type > $o ).

tff(pred_def_46306,type,
    v86566: ( state_type * $int ) > $o ).

tff(pred_def_46307,type,
    v86568: ( state_type * $int ) > $o ).

tff(pred_def_46308,type,
    v86557: ( state_type * $int ) > $o ).

tff(pred_def_46309,type,
    v85880: ( state_type * $int ) > $o ).

tff(pred_def_46310,type,
    v85878: ( state_type * $int ) > $o ).

tff(pred_def_46311,type,
    v86578: state_type > $o ).

tff(pred_def_46312,type,
    v86577: state_type > $o ).

tff(pred_def_46313,type,
    v86579: state_type > $o ).

tff(pred_def_46314,type,
    v86576: state_type > $o ).

tff(pred_def_46315,type,
    v86580: state_type > $o ).

tff(pred_def_46316,type,
    v86575: state_type > $o ).

tff(pred_def_46317,type,
    v85860: state_type > $o ).

tff(pred_def_46318,type,
    v85858: state_type > $o ).

tff(pred_def_46319,type,
    v86584: state_type > $o ).

tff(pred_def_46320,type,
    v86583: state_type > $o ).

tff(pred_def_46321,type,
    v86582: state_type > $o ).

tff(pred_def_46322,type,
    v86588: state_type > $o ).

tff(pred_def_46323,type,
    v86587: state_type > $o ).

tff(pred_def_46324,type,
    v86586: state_type > $o ).

tff(pred_def_46325,type,
    v85831: state_type > $o ).

tff(pred_def_46326,type,
    v86585: state_type > $o ).

tff(pred_def_46327,type,
    v85845: state_type > $o ).

tff(pred_def_46328,type,
    v85843: state_type > $o ).

tff(pred_def_46329,type,
    v86592: state_type > $o ).

tff(pred_def_46330,type,
    v86590: state_type > $o ).

tff(pred_def_46331,type,
    v86599: state_type > $o ).

tff(pred_def_46332,type,
    v86597: state_type > $o ).

tff(pred_def_46333,type,
    v86596: state_type > $o ).

tff(pred_def_46334,type,
    v86595: state_type > $o ).

tff(pred_def_46335,type,
    v86607: state_type > $o ).

tff(pred_def_46336,type,
    v86608: state_type > $o ).

tff(pred_def_46337,type,
    v86606: state_type > $o ).

tff(pred_def_46338,type,
    v86603: state_type > $o ).

tff(pred_def_46339,type,
    v86605: state_type > $o ).

tff(pred_def_46340,type,
    v85833: state_type > $o ).

tff(pred_def_46341,type,
    v86620: state_type > $o ).

tff(pred_def_46342,type,
    v86618: state_type > $o ).

tff(pred_def_46343,type,
    v86624: state_type > $o ).

tff(pred_def_46344,type,
    v86622: state_type > $o ).

tff(pred_def_46345,type,
    v86632: state_type > $o ).

tff(pred_def_46346,type,
    v86634: state_type > $o ).

tff(pred_def_46347,type,
    v86633: ( state_type * $int ) > $o ).

tff(pred_def_46348,type,
    v86635: state_type > $o ).

tff(pred_def_46349,type,
    v86630: ( state_type * $int ) > $o ).

tff(pred_def_46350,type,
    v86628: ( state_type * $int ) > $o ).

tff(pred_def_46351,type,
    v86626: ( state_type * $int ) > $o ).

tff(pred_def_46352,type,
    v86639: state_type > $o ).

tff(pred_def_46353,type,
    v86637: state_type > $o ).

tff(pred_def_46354,type,
    v86646: state_type > $o ).

tff(pred_def_46355,type,
    v86644: state_type > $o ).

tff(pred_def_46356,type,
    v86643: state_type > $o ).

tff(pred_def_46357,type,
    v86642: state_type > $o ).

tff(pred_def_46358,type,
    v86654: state_type > $o ).

tff(pred_def_46359,type,
    v86655: state_type > $o ).

tff(pred_def_46360,type,
    v86653: state_type > $o ).

tff(pred_def_46361,type,
    v86650: ( state_type * $int ) > $o ).

tff(pred_def_46362,type,
    v86652: ( state_type * $int ) > $o ).

tff(pred_def_46363,type,
    v86641: ( state_type * $int ) > $o ).

tff(pred_def_46364,type,
    v86616: ( state_type * $int ) > $o ).

tff(pred_def_46365,type,
    v86614: ( state_type * $int ) > $o ).

tff(pred_def_46366,type,
    v86612: state_type > $o ).

tff(pred_def_46367,type,
    v86667: state_type > $o ).

tff(pred_def_46368,type,
    v86666: state_type > $o ).

tff(pred_def_46369,type,
    v86665: state_type > $o ).

tff(pred_def_46370,type,
    v86664: state_type > $o ).

tff(pred_def_46371,type,
    v86663: state_type > $o ).

tff(pred_def_46372,type,
    v86662: state_type > $o ).

tff(pred_def_46373,type,
    v86661: state_type > $o ).

tff(pred_def_46374,type,
    v86660: state_type > $o ).

tff(pred_def_46375,type,
    v86659: state_type > $o ).

tff(pred_def_46376,type,
    v86668: ( state_type * $int ) > $o ).

tff(pred_def_46377,type,
    v86669: state_type > $o ).

tff(pred_def_46378,type,
    v85825: ( state_type * $int ) > $o ).

tff(pred_def_46379,type,
    v86671: state_type > $o ).

tff(pred_def_46380,type,
    v86675: state_type > $o ).

tff(pred_def_46381,type,
    v86674: ( state_type * $int ) > $o ).

tff(pred_def_46382,type,
    v86673: ( state_type * $int ) > $o ).

tff(pred_def_46383,type,
    v86679: state_type > $o ).

tff(pred_def_46384,type,
    v86678: ( state_type * $int ) > $o ).

tff(pred_def_46385,type,
    v86677: ( state_type * $int ) > $o ).

tff(pred_def_46386,type,
    v86676: ( state_type * $int ) > $o ).

tff(pred_def_46387,type,
    v86672: ( state_type * $int ) > $o ).

tff(pred_def_46388,type,
    v85823: ( state_type * $int ) > $o ).

tff(pred_def_46389,type,
    v85821: ( state_type * $int ) > $o ).

tff(pred_def_46390,type,
    v86683: state_type > $o ).

tff(pred_def_46391,type,
    v86681: state_type > $o ).

tff(pred_def_46392,type,
    v86690: state_type > $o ).

tff(pred_def_46393,type,
    v86688: state_type > $o ).

tff(pred_def_46394,type,
    v86687: state_type > $o ).

tff(pred_def_46395,type,
    v86686: state_type > $o ).

tff(pred_def_46396,type,
    v86698: state_type > $o ).

tff(pred_def_46397,type,
    v86699: state_type > $o ).

tff(pred_def_46398,type,
    v86697: state_type > $o ).

tff(pred_def_46399,type,
    v86694: ( state_type * $int ) > $o ).

tff(pred_def_46400,type,
    v86696: ( state_type * $int ) > $o ).

tff(pred_def_46401,type,
    v86685: ( state_type * $int ) > $o ).

tff(pred_def_46402,type,
    v85803: state_type > $o ).

tff(pred_def_46403,type,
    v85801: state_type > $o ).

tff(pred_def_46404,type,
    v85799: state_type > $o ).

tff(pred_def_46405,type,
    v85797: state_type > $o ).

tff(pred_def_46406,type,
    v86707: state_type > $o ).

tff(pred_def_46407,type,
    v86705: state_type > $o ).

tff(pred_def_46408,type,
    v86704: state_type > $o ).

tff(pred_def_46409,type,
    v86703: ( state_type * $int ) > $o ).

tff(pred_def_46410,type,
    v85794: state_type > $o ).

tff(pred_def_46411,type,
    v85792: state_type > $o ).

tff(pred_def_46412,type,
    v85790: state_type > $o ).

tff(pred_def_46413,type,
    v86725: state_type > $o ).

tff(pred_def_46414,type,
    v86723: state_type > $o ).

tff(pred_def_46415,type,
    v86729: state_type > $o ).

tff(pred_def_46416,type,
    v86727: state_type > $o ).

tff(pred_def_46417,type,
    v86717: ( state_type * $int ) > $o ).

tff(pred_def_46418,type,
    v86753: state_type > $o ).

tff(pred_def_46419,type,
    v86752: state_type > $o ).

tff(pred_def_46420,type,
    v86751: state_type > $o ).

tff(pred_def_46421,type,
    v86750: state_type > $o ).

tff(pred_def_46422,type,
    v86749: state_type > $o ).

tff(pred_def_46423,type,
    v86748: state_type > $o ).

tff(pred_def_46424,type,
    v86747: state_type > $o ).

tff(pred_def_46425,type,
    v86746: state_type > $o ).

tff(pred_def_46426,type,
    v86745: state_type > $o ).

tff(pred_def_46427,type,
    v86744: state_type > $o ).

tff(pred_def_46428,type,
    v86743: state_type > $o ).

tff(pred_def_46429,type,
    v86754: state_type > $o ).

tff(pred_def_46430,type,
    v86742: state_type > $o ).

tff(pred_def_46431,type,
    v86755: state_type > $o ).

tff(pred_def_46432,type,
    v86741: state_type > $o ).

tff(pred_def_46433,type,
    v86758: state_type > $o ).

tff(pred_def_46434,type,
    v86759: state_type > $o ).

tff(pred_def_46435,type,
    v86757: state_type > $o ).

tff(pred_def_46436,type,
    v86760: state_type > $o ).

tff(pred_def_46437,type,
    v86756: state_type > $o ).

tff(pred_def_46438,type,
    v86763: state_type > $o ).

tff(pred_def_46439,type,
    v86764: state_type > $o ).

tff(pred_def_46440,type,
    v86762: state_type > $o ).

tff(pred_def_46441,type,
    v86765: state_type > $o ).

tff(pred_def_46442,type,
    v86761: state_type > $o ).

tff(pred_def_46443,type,
    v86768: state_type > $o ).

tff(pred_def_46444,type,
    v86769: state_type > $o ).

tff(pred_def_46445,type,
    v86767: state_type > $o ).

tff(pred_def_46446,type,
    v86770: state_type > $o ).

tff(pred_def_46447,type,
    v86766: state_type > $o ).

tff(pred_def_46448,type,
    v86773: state_type > $o ).

tff(pred_def_46449,type,
    v86774: state_type > $o ).

tff(pred_def_46450,type,
    v86772: state_type > $o ).

tff(pred_def_46451,type,
    v86775: state_type > $o ).

tff(pred_def_46452,type,
    v86771: state_type > $o ).

tff(pred_def_46453,type,
    v86778: state_type > $o ).

tff(pred_def_46454,type,
    v86779: state_type > $o ).

tff(pred_def_46455,type,
    v86777: state_type > $o ).

tff(pred_def_46456,type,
    v86780: state_type > $o ).

tff(pred_def_46457,type,
    v86776: state_type > $o ).

tff(pred_def_46458,type,
    v86783: state_type > $o ).

tff(pred_def_46459,type,
    v86784: state_type > $o ).

tff(pred_def_46460,type,
    v86782: state_type > $o ).

tff(pred_def_46461,type,
    v86785: state_type > $o ).

tff(pred_def_46462,type,
    v86781: state_type > $o ).

tff(pred_def_46463,type,
    v86788: state_type > $o ).

tff(pred_def_46464,type,
    v86789: state_type > $o ).

tff(pred_def_46465,type,
    v86787: state_type > $o ).

tff(pred_def_46466,type,
    v86790: state_type > $o ).

tff(pred_def_46467,type,
    v86786: state_type > $o ).

tff(pred_def_46468,type,
    v86793: state_type > $o ).

tff(pred_def_46469,type,
    v86794: state_type > $o ).

tff(pred_def_46470,type,
    v86792: state_type > $o ).

tff(pred_def_46471,type,
    v86795: state_type > $o ).

tff(pred_def_46472,type,
    v86791: state_type > $o ).

tff(pred_def_46473,type,
    v86798: state_type > $o ).

tff(pred_def_46474,type,
    v86799: state_type > $o ).

tff(pred_def_46475,type,
    v86797: state_type > $o ).

tff(pred_def_46476,type,
    v86800: state_type > $o ).

tff(pred_def_46477,type,
    v86796: state_type > $o ).

tff(pred_def_46478,type,
    v86803: state_type > $o ).

tff(pred_def_46479,type,
    v86804: state_type > $o ).

tff(pred_def_46480,type,
    v86802: state_type > $o ).

tff(pred_def_46481,type,
    v86805: state_type > $o ).

tff(pred_def_46482,type,
    v86801: state_type > $o ).

tff(pred_def_46483,type,
    v86737: ( state_type * $int ) > $o ).

tff(pred_def_46484,type,
    v86735: ( state_type * $int ) > $o ).

tff(pred_def_46485,type,
    v86819: state_type > $o ).

tff(pred_def_46486,type,
    v86817: state_type > $o ).

tff(pred_def_46487,type,
    v86823: state_type > $o ).

tff(pred_def_46488,type,
    v86821: state_type > $o ).

tff(pred_def_46489,type,
    v86831: state_type > $o ).

tff(pred_def_46490,type,
    v86829: state_type > $o ).

tff(pred_def_46491,type,
    b0000001000000: $int > $o ).

tff(pred_def_46492,type,
    v86838: state_type > $o ).

tff(pred_def_46493,type,
    v86835: state_type > $o ).

tff(pred_def_46494,type,
    v86833: state_type > $o ).

tff(pred_def_46495,type,
    v86842: state_type > $o ).

tff(pred_def_46496,type,
    v86841: state_type > $o ).

tff(pred_def_46497,type,
    v86840: state_type > $o ).

tff(pred_def_46498,type,
    v86846: state_type > $o ).

tff(pred_def_46499,type,
    v86845: state_type > $o ).

tff(pred_def_46500,type,
    v86844: state_type > $o ).

tff(pred_def_46501,type,
    v86813: state_type > $o ).

tff(pred_def_46502,type,
    v86843: state_type > $o ).

tff(pred_def_46503,type,
    v86827: state_type > $o ).

tff(pred_def_46504,type,
    v86825: state_type > $o ).

tff(pred_def_46505,type,
    v86850: state_type > $o ).

tff(pred_def_46506,type,
    v86848: state_type > $o ).

tff(pred_def_46507,type,
    v86857: state_type > $o ).

tff(pred_def_46508,type,
    v86855: state_type > $o ).

tff(pred_def_46509,type,
    v86854: state_type > $o ).

tff(pred_def_46510,type,
    v86853: state_type > $o ).

tff(pred_def_46511,type,
    v86865: state_type > $o ).

tff(pred_def_46512,type,
    v86866: state_type > $o ).

tff(pred_def_46513,type,
    v86864: state_type > $o ).

tff(pred_def_46514,type,
    v86861: state_type > $o ).

tff(pred_def_46515,type,
    v86863: state_type > $o ).

tff(pred_def_46516,type,
    v86815: state_type > $o ).

tff(pred_def_46517,type,
    v86811: state_type > $o ).

tff(pred_def_46518,type,
    v86870: state_type > $o ).

tff(pred_def_46519,type,
    v86871: state_type > $o ).

tff(pred_def_46520,type,
    v86809: state_type > $o ).

tff(pred_def_46521,type,
    v86807: state_type > $o ).

tff(pred_def_46522,type,
    v86893: state_type > $o ).

tff(pred_def_46523,type,
    v86891: state_type > $o ).

tff(pred_def_46524,type,
    v86897: state_type > $o ).

tff(pred_def_46525,type,
    v86895: state_type > $o ).

tff(pred_def_46526,type,
    v86903: state_type > $o ).

tff(pred_def_46527,type,
    v86715: state_type > $o ).

tff(pred_def_46528,type,
    v86905: state_type > $o ).

tff(pred_def_46529,type,
    v86713: state_type > $o ).

tff(pred_def_46530,type,
    v86885: state_type > $o ).

tff(pred_def_46531,type,
    v86877: state_type > $o ).

tff(pred_def_46532,type,
    v86909: state_type > $o ).

tff(pred_def_46533,type,
    v86907: state_type > $o ).

tff(pred_def_46534,type,
    v86915: state_type > $o ).

tff(pred_def_46535,type,
    v86914: state_type > $o ).

tff(pred_def_46536,type,
    v86913: state_type > $o ).

tff(pred_def_46537,type,
    v86918: state_type > $o ).

tff(pred_def_46538,type,
    v86917: state_type > $o ).

tff(pred_def_46539,type,
    v86916: state_type > $o ).

tff(pred_def_46540,type,
    v86912: state_type > $o ).

tff(pred_def_46541,type,
    v86923: state_type > $o ).

tff(pred_def_46542,type,
    v86922: state_type > $o ).

tff(pred_def_46543,type,
    v86921: state_type > $o ).

tff(pred_def_46544,type,
    v86887: state_type > $o ).

tff(pred_def_46545,type,
    v86920: state_type > $o ).

tff(pred_def_46546,type,
    v86926: state_type > $o ).

tff(pred_def_46547,type,
    v86925: state_type > $o ).

tff(pred_def_46548,type,
    v86924: state_type > $o ).

tff(pred_def_46549,type,
    v86919: state_type > $o ).

tff(pred_def_46550,type,
    v86901: state_type > $o ).

tff(pred_def_46551,type,
    v86899: state_type > $o ).

tff(pred_def_46552,type,
    v86930: state_type > $o ).

tff(pred_def_46553,type,
    v86928: state_type > $o ).

tff(pred_def_46554,type,
    v86937: state_type > $o ).

tff(pred_def_46555,type,
    v86935: state_type > $o ).

tff(pred_def_46556,type,
    v86934: state_type > $o ).

tff(pred_def_46557,type,
    v86933: state_type > $o ).

tff(pred_def_46558,type,
    v86945: state_type > $o ).

tff(pred_def_46559,type,
    v86946: state_type > $o ).

tff(pred_def_46560,type,
    v86944: state_type > $o ).

tff(pred_def_46561,type,
    v86941: state_type > $o ).

tff(pred_def_46562,type,
    v86943: state_type > $o ).

tff(pred_def_46563,type,
    v86889: state_type > $o ).

tff(pred_def_46564,type,
    v86966: state_type > $o ).

tff(pred_def_46565,type,
    v86964: state_type > $o ).

tff(pred_def_46566,type,
    v86970: state_type > $o ).

tff(pred_def_46567,type,
    v86968: state_type > $o ).

tff(pred_def_46568,type,
    v86958: ( state_type * $int ) > $o ).

tff(pred_def_46569,type,
    v87014: state_type > $o ).

tff(pred_def_46570,type,
    v87013: state_type > $o ).

tff(pred_def_46571,type,
    v87012: state_type > $o ).

tff(pred_def_46572,type,
    v87011: state_type > $o ).

tff(pred_def_46573,type,
    v87010: state_type > $o ).

tff(pred_def_46574,type,
    v87009: state_type > $o ).

tff(pred_def_46575,type,
    v87008: state_type > $o ).

tff(pred_def_46576,type,
    v87007: state_type > $o ).

tff(pred_def_46577,type,
    v87006: state_type > $o ).

tff(pred_def_46578,type,
    v87005: state_type > $o ).

tff(pred_def_46579,type,
    v87004: state_type > $o ).

tff(pred_def_46580,type,
    v87003: state_type > $o ).

tff(pred_def_46581,type,
    v87002: state_type > $o ).

tff(pred_def_46582,type,
    v87001: state_type > $o ).

tff(pred_def_46583,type,
    v87000: state_type > $o ).

tff(pred_def_46584,type,
    v86999: state_type > $o ).

tff(pred_def_46585,type,
    v86998: state_type > $o ).

tff(pred_def_46586,type,
    v86997: state_type > $o ).

tff(pred_def_46587,type,
    v86996: state_type > $o ).

tff(pred_def_46588,type,
    v86995: state_type > $o ).

tff(pred_def_46589,type,
    v86994: state_type > $o ).

tff(pred_def_46590,type,
    v86993: state_type > $o ).

tff(pred_def_46591,type,
    v86992: state_type > $o ).

tff(pred_def_46592,type,
    v86991: state_type > $o ).

tff(pred_def_46593,type,
    v86990: state_type > $o ).

tff(pred_def_46594,type,
    v86989: state_type > $o ).

tff(pred_def_46595,type,
    v86988: state_type > $o ).

tff(pred_def_46596,type,
    v86987: state_type > $o ).

tff(pred_def_46597,type,
    v86986: state_type > $o ).

tff(pred_def_46598,type,
    v86985: state_type > $o ).

tff(pred_def_46599,type,
    v86984: state_type > $o ).

tff(pred_def_46600,type,
    v87015: state_type > $o ).

tff(pred_def_46601,type,
    v86983: state_type > $o ).

tff(pred_def_46602,type,
    v87016: state_type > $o ).

tff(pred_def_46603,type,
    v86982: state_type > $o ).

tff(pred_def_46604,type,
    v87019: state_type > $o ).

tff(pred_def_46605,type,
    v87020: state_type > $o ).

tff(pred_def_46606,type,
    v87018: state_type > $o ).

tff(pred_def_46607,type,
    v87021: state_type > $o ).

tff(pred_def_46608,type,
    v87017: state_type > $o ).

tff(pred_def_46609,type,
    v87024: state_type > $o ).

tff(pred_def_46610,type,
    v87025: state_type > $o ).

tff(pred_def_46611,type,
    v87023: state_type > $o ).

tff(pred_def_46612,type,
    v87026: state_type > $o ).

tff(pred_def_46613,type,
    v87022: state_type > $o ).

tff(pred_def_46614,type,
    v87029: state_type > $o ).

tff(pred_def_46615,type,
    v87030: state_type > $o ).

tff(pred_def_46616,type,
    v87028: state_type > $o ).

tff(pred_def_46617,type,
    v87031: state_type > $o ).

tff(pred_def_46618,type,
    v87027: state_type > $o ).

tff(pred_def_46619,type,
    v87034: state_type > $o ).

tff(pred_def_46620,type,
    v87035: state_type > $o ).

tff(pred_def_46621,type,
    v87033: state_type > $o ).

tff(pred_def_46622,type,
    v87036: state_type > $o ).

tff(pred_def_46623,type,
    v87032: state_type > $o ).

tff(pred_def_46624,type,
    v87039: state_type > $o ).

tff(pred_def_46625,type,
    v87040: state_type > $o ).

tff(pred_def_46626,type,
    v87038: state_type > $o ).

tff(pred_def_46627,type,
    v87041: state_type > $o ).

tff(pred_def_46628,type,
    v87037: state_type > $o ).

tff(pred_def_46629,type,
    v87044: state_type > $o ).

tff(pred_def_46630,type,
    v87045: state_type > $o ).

tff(pred_def_46631,type,
    v87043: state_type > $o ).

tff(pred_def_46632,type,
    v87046: state_type > $o ).

tff(pred_def_46633,type,
    v87042: state_type > $o ).

tff(pred_def_46634,type,
    v87049: state_type > $o ).

tff(pred_def_46635,type,
    v87050: state_type > $o ).

tff(pred_def_46636,type,
    v87048: state_type > $o ).

tff(pred_def_46637,type,
    v87051: state_type > $o ).

tff(pred_def_46638,type,
    v87047: state_type > $o ).

tff(pred_def_46639,type,
    v87054: state_type > $o ).

tff(pred_def_46640,type,
    v87055: state_type > $o ).

tff(pred_def_46641,type,
    v87053: state_type > $o ).

tff(pred_def_46642,type,
    v87056: state_type > $o ).

tff(pred_def_46643,type,
    v87052: state_type > $o ).

tff(pred_def_46644,type,
    v87059: state_type > $o ).

tff(pred_def_46645,type,
    v87060: state_type > $o ).

tff(pred_def_46646,type,
    v87058: state_type > $o ).

tff(pred_def_46647,type,
    v87061: state_type > $o ).

tff(pred_def_46648,type,
    v87057: state_type > $o ).

tff(pred_def_46649,type,
    v87064: state_type > $o ).

tff(pred_def_46650,type,
    v87065: state_type > $o ).

tff(pred_def_46651,type,
    v87063: state_type > $o ).

tff(pred_def_46652,type,
    v87066: state_type > $o ).

tff(pred_def_46653,type,
    v87062: state_type > $o ).

tff(pred_def_46654,type,
    v87069: state_type > $o ).

tff(pred_def_46655,type,
    v87070: state_type > $o ).

tff(pred_def_46656,type,
    v87068: state_type > $o ).

tff(pred_def_46657,type,
    v87071: state_type > $o ).

tff(pred_def_46658,type,
    v87067: state_type > $o ).

tff(pred_def_46659,type,
    v87074: state_type > $o ).

tff(pred_def_46660,type,
    v87075: state_type > $o ).

tff(pred_def_46661,type,
    v87073: state_type > $o ).

tff(pred_def_46662,type,
    v87076: state_type > $o ).

tff(pred_def_46663,type,
    v87072: state_type > $o ).

tff(pred_def_46664,type,
    v87079: state_type > $o ).

tff(pred_def_46665,type,
    v87080: state_type > $o ).

tff(pred_def_46666,type,
    v87078: state_type > $o ).

tff(pred_def_46667,type,
    v87081: state_type > $o ).

tff(pred_def_46668,type,
    v87077: state_type > $o ).

tff(pred_def_46669,type,
    v87084: state_type > $o ).

tff(pred_def_46670,type,
    v87085: state_type > $o ).

tff(pred_def_46671,type,
    v87083: state_type > $o ).

tff(pred_def_46672,type,
    v87086: state_type > $o ).

tff(pred_def_46673,type,
    v87082: state_type > $o ).

tff(pred_def_46674,type,
    v87089: state_type > $o ).

tff(pred_def_46675,type,
    v87090: state_type > $o ).

tff(pred_def_46676,type,
    v87088: state_type > $o ).

tff(pred_def_46677,type,
    v87091: state_type > $o ).

tff(pred_def_46678,type,
    v87087: state_type > $o ).

tff(pred_def_46679,type,
    v87094: state_type > $o ).

tff(pred_def_46680,type,
    v87095: state_type > $o ).

tff(pred_def_46681,type,
    v87093: state_type > $o ).

tff(pred_def_46682,type,
    v87096: state_type > $o ).

tff(pred_def_46683,type,
    v87092: state_type > $o ).

tff(pred_def_46684,type,
    v87099: state_type > $o ).

tff(pred_def_46685,type,
    v87100: state_type > $o ).

tff(pred_def_46686,type,
    v87098: state_type > $o ).

tff(pred_def_46687,type,
    v87101: state_type > $o ).

tff(pred_def_46688,type,
    v87097: state_type > $o ).

tff(pred_def_46689,type,
    v87104: state_type > $o ).

tff(pred_def_46690,type,
    v87105: state_type > $o ).

tff(pred_def_46691,type,
    v87103: state_type > $o ).

tff(pred_def_46692,type,
    v87106: state_type > $o ).

tff(pred_def_46693,type,
    v87102: state_type > $o ).

tff(pred_def_46694,type,
    v87109: state_type > $o ).

tff(pred_def_46695,type,
    v87110: state_type > $o ).

tff(pred_def_46696,type,
    v87108: state_type > $o ).

tff(pred_def_46697,type,
    v87111: state_type > $o ).

tff(pred_def_46698,type,
    v87107: state_type > $o ).

tff(pred_def_46699,type,
    v87114: state_type > $o ).

tff(pred_def_46700,type,
    v87115: state_type > $o ).

tff(pred_def_46701,type,
    v87113: state_type > $o ).

tff(pred_def_46702,type,
    v87116: state_type > $o ).

tff(pred_def_46703,type,
    v87112: state_type > $o ).

tff(pred_def_46704,type,
    v87119: state_type > $o ).

tff(pred_def_46705,type,
    v87120: state_type > $o ).

tff(pred_def_46706,type,
    v87118: state_type > $o ).

tff(pred_def_46707,type,
    v87121: state_type > $o ).

tff(pred_def_46708,type,
    v87117: state_type > $o ).

tff(pred_def_46709,type,
    v87124: state_type > $o ).

tff(pred_def_46710,type,
    v87125: state_type > $o ).

tff(pred_def_46711,type,
    v87123: state_type > $o ).

tff(pred_def_46712,type,
    v87126: state_type > $o ).

tff(pred_def_46713,type,
    v87122: state_type > $o ).

tff(pred_def_46714,type,
    v87129: state_type > $o ).

tff(pred_def_46715,type,
    v87130: state_type > $o ).

tff(pred_def_46716,type,
    v87128: state_type > $o ).

tff(pred_def_46717,type,
    v87131: state_type > $o ).

tff(pred_def_46718,type,
    v87127: state_type > $o ).

tff(pred_def_46719,type,
    v87134: state_type > $o ).

tff(pred_def_46720,type,
    v87135: state_type > $o ).

tff(pred_def_46721,type,
    v87133: state_type > $o ).

tff(pred_def_46722,type,
    v87136: state_type > $o ).

tff(pred_def_46723,type,
    v87132: state_type > $o ).

tff(pred_def_46724,type,
    v87139: state_type > $o ).

tff(pred_def_46725,type,
    v87140: state_type > $o ).

tff(pred_def_46726,type,
    v87138: state_type > $o ).

tff(pred_def_46727,type,
    v87141: state_type > $o ).

tff(pred_def_46728,type,
    v87137: state_type > $o ).

tff(pred_def_46729,type,
    v87144: state_type > $o ).

tff(pred_def_46730,type,
    v87145: state_type > $o ).

tff(pred_def_46731,type,
    v87143: state_type > $o ).

tff(pred_def_46732,type,
    v87146: state_type > $o ).

tff(pred_def_46733,type,
    v87142: state_type > $o ).

tff(pred_def_46734,type,
    v87149: state_type > $o ).

tff(pred_def_46735,type,
    v87150: state_type > $o ).

tff(pred_def_46736,type,
    v87148: state_type > $o ).

tff(pred_def_46737,type,
    v87151: state_type > $o ).

tff(pred_def_46738,type,
    v87147: state_type > $o ).

tff(pred_def_46739,type,
    v87154: state_type > $o ).

tff(pred_def_46740,type,
    v87155: state_type > $o ).

tff(pred_def_46741,type,
    v87153: state_type > $o ).

tff(pred_def_46742,type,
    v87156: state_type > $o ).

tff(pred_def_46743,type,
    v87152: state_type > $o ).

tff(pred_def_46744,type,
    v87159: state_type > $o ).

tff(pred_def_46745,type,
    v87160: state_type > $o ).

tff(pred_def_46746,type,
    v87158: state_type > $o ).

tff(pred_def_46747,type,
    v87161: state_type > $o ).

tff(pred_def_46748,type,
    v87157: state_type > $o ).

tff(pred_def_46749,type,
    v87164: state_type > $o ).

tff(pred_def_46750,type,
    v87165: state_type > $o ).

tff(pred_def_46751,type,
    v87163: state_type > $o ).

tff(pred_def_46752,type,
    v87166: state_type > $o ).

tff(pred_def_46753,type,
    v87162: state_type > $o ).

tff(pred_def_46754,type,
    v86980: ( state_type * $int ) > $o ).

tff(pred_def_46755,type,
    v86978: ( state_type * $int ) > $o ).

tff(pred_def_46756,type,
    v86976: ( state_type * $int ) > $o ).

tff(pred_def_46757,type,
    v87178: state_type > $o ).

tff(pred_def_46758,type,
    v87180: state_type > $o ).

tff(pred_def_46759,type,
    v87184: state_type > $o ).

tff(pred_def_46760,type,
    v87185: state_type > $o ).

tff(pred_def_46761,type,
    v87183: state_type > $o ).

tff(pred_def_46762,type,
    v82909: state_type > $o ).

tff(pred_def_46763,type,
    v87186: state_type > $o ).

tff(pred_def_46764,type,
    v87176: state_type > $o ).

tff(pred_def_46765,type,
    v87174: state_type > $o ).

tff(pred_def_46766,type,
    v87172: state_type > $o ).

tff(pred_def_46767,type,
    v87191: state_type > $o ).

tff(pred_def_46768,type,
    v87190: state_type > $o ).

tff(pred_def_46769,type,
    v87188: state_type > $o ).

tff(pred_def_46770,type,
    v87170: state_type > $o ).

tff(pred_def_46771,type,
    v87168: state_type > $o ).

tff(pred_def_46772,type,
    v87206: state_type > $o ).

tff(pred_def_46773,type,
    v87211: state_type > $o ).

tff(pred_def_46774,type,
    v87210: ( state_type * $int ) > $o ).

tff(pred_def_46775,type,
    v87209: ( state_type * $int ) > $o ).

tff(pred_def_46776,type,
    v87214: state_type > $o ).

tff(pred_def_46777,type,
    v87194: state_type > $o ).

tff(pred_def_46778,type,
    v87213: ( state_type * $int ) > $o ).

tff(pred_def_46779,type,
    v87212: ( state_type * $int ) > $o ).

tff(pred_def_46780,type,
    v87208: ( state_type * $int ) > $o ).

tff(pred_def_46781,type,
    v87219: state_type > $o ).

tff(pred_def_46782,type,
    v87218: ( state_type * $int ) > $o ).

tff(pred_def_46783,type,
    v87217: ( state_type * $int ) > $o ).

tff(pred_def_46784,type,
    v86960: ( state_type * $int ) > $o ).

tff(pred_def_46785,type,
    v87216: ( state_type * $int ) > $o ).

tff(pred_def_46786,type,
    v87222: state_type > $o ).

tff(pred_def_46787,type,
    v87221: ( state_type * $int ) > $o ).

tff(pred_def_46788,type,
    v87220: ( state_type * $int ) > $o ).

tff(pred_def_46789,type,
    v87215: ( state_type * $int ) > $o ).

tff(pred_def_46790,type,
    v87207: ( state_type * $int ) > $o ).

tff(pred_def_46791,type,
    v86974: ( state_type * $int ) > $o ).

tff(pred_def_46792,type,
    v86972: ( state_type * $int ) > $o ).

tff(pred_def_46793,type,
    v87226: state_type > $o ).

tff(pred_def_46794,type,
    v87224: state_type > $o ).

tff(pred_def_46795,type,
    v87233: state_type > $o ).

tff(pred_def_46796,type,
    v87231: state_type > $o ).

tff(pred_def_46797,type,
    v87230: state_type > $o ).

tff(pred_def_46798,type,
    v87229: state_type > $o ).

tff(pred_def_46799,type,
    v87241: state_type > $o ).

tff(pred_def_46800,type,
    v87242: state_type > $o ).

tff(pred_def_46801,type,
    v87240: state_type > $o ).

tff(pred_def_46802,type,
    v87237: ( state_type * $int ) > $o ).

tff(pred_def_46803,type,
    v87239: ( state_type * $int ) > $o ).

tff(pred_def_46804,type,
    v87228: ( state_type * $int ) > $o ).

tff(pred_def_46805,type,
    v86962: ( state_type * $int ) > $o ).

tff(pred_def_46806,type,
    v87250: state_type > $o ).

tff(pred_def_46807,type,
    v87248: state_type > $o ).

tff(pred_def_46808,type,
    v87247: state_type > $o ).

tff(pred_def_46809,type,
    v87246: ( state_type * $int ) > $o ).

tff(pred_def_46810,type,
    v86956: ( state_type * $int ) > $o ).

tff(pred_def_46811,type,
    v87258: state_type > $o ).

tff(pred_def_46812,type,
    v87256: state_type > $o ).

tff(pred_def_46813,type,
    v87255: state_type > $o ).

tff(pred_def_46814,type,
    v87254: ( state_type * $int ) > $o ).

tff(pred_def_46815,type,
    v87262: ( state_type * $int ) > $o ).

tff(pred_def_46816,type,
    v87263: ( state_type * $int ) > $o ).

tff(pred_def_46817,type,
    v87261: ( state_type * $int ) > $o ).

tff(pred_def_46818,type,
    v87204: ( state_type * $int ) > $o ).

tff(pred_def_46819,type,
    v87277: state_type > $o ).

tff(pred_def_46820,type,
    v87275: state_type > $o ).

tff(pred_def_46821,type,
    v87273: state_type > $o ).

tff(pred_def_46822,type,
    v87271: state_type > $o ).

tff(pred_def_46823,type,
    v87285: state_type > $o ).

tff(pred_def_46824,type,
    v87283: state_type > $o ).

tff(pred_def_46825,type,
    v87281: state_type > $o ).

tff(pred_def_46826,type,
    v87279: state_type > $o ).

tff(pred_def_46827,type,
    v87307: state_type > $o ).

tff(pred_def_46828,type,
    v87305: state_type > $o ).

tff(pred_def_46829,type,
    v87311: state_type > $o ).

tff(pred_def_46830,type,
    v87309: state_type > $o ).

tff(pred_def_46831,type,
    v87331: state_type > $o ).

tff(pred_def_46832,type,
    v87329: state_type > $o ).

tff(pred_def_46833,type,
    v87335: state_type > $o ).

tff(pred_def_46834,type,
    v87333: state_type > $o ).

tff(pred_def_46835,type,
    v87355: state_type > $o ).

tff(pred_def_46836,type,
    v87353: state_type > $o ).

tff(pred_def_46837,type,
    v87359: state_type > $o ).

tff(pred_def_46838,type,
    v87357: state_type > $o ).

tff(pred_def_46839,type,
    v87369: ( state_type * $int ) > $o ).

tff(pred_def_46840,type,
    v87367: ( state_type * $int ) > $o ).

tff(pred_def_46841,type,
    v87365: ( state_type * $int ) > $o ).

tff(pred_def_46842,type,
    b0000000001000: $int > $o ).

tff(pred_def_46843,type,
    v87377: state_type > $o ).

tff(pred_def_46844,type,
    v87374: state_type > $o ).

tff(pred_def_46845,type,
    v87372: state_type > $o ).

tff(pred_def_46846,type,
    v87381: state_type > $o ).

tff(pred_def_46847,type,
    v87380: ( state_type * $int ) > $o ).

tff(pred_def_46848,type,
    v87379: ( state_type * $int ) > $o ).

tff(pred_def_46849,type,
    v87385: state_type > $o ).

tff(pred_def_46850,type,
    v87384: ( state_type * $int ) > $o ).

tff(pred_def_46851,type,
    v87383: ( state_type * $int ) > $o ).

tff(pred_def_46852,type,
    v87349: ( state_type * $int ) > $o ).

tff(pred_def_46853,type,
    v87382: ( state_type * $int ) > $o ).

tff(pred_def_46854,type,
    v87363: ( state_type * $int ) > $o ).

tff(pred_def_46855,type,
    v87361: ( state_type * $int ) > $o ).

tff(pred_def_46856,type,
    v87389: state_type > $o ).

tff(pred_def_46857,type,
    v87387: state_type > $o ).

tff(pred_def_46858,type,
    v87396: state_type > $o ).

tff(pred_def_46859,type,
    v87394: state_type > $o ).

tff(pred_def_46860,type,
    v87393: state_type > $o ).

tff(pred_def_46861,type,
    v87392: state_type > $o ).

tff(pred_def_46862,type,
    v87404: state_type > $o ).

tff(pred_def_46863,type,
    v87405: state_type > $o ).

tff(pred_def_46864,type,
    v87403: state_type > $o ).

tff(pred_def_46865,type,
    v87400: ( state_type * $int ) > $o ).

tff(pred_def_46866,type,
    v87402: ( state_type * $int ) > $o ).

tff(pred_def_46867,type,
    v87351: ( state_type * $int ) > $o ).

tff(pred_def_46868,type,
    v87347: ( state_type * $int ) > $o ).

tff(pred_def_46869,type,
    v87345: ( state_type * $int ) > $o ).

tff(pred_def_46870,type,
    v87422: state_type > $o ).

tff(pred_def_46871,type,
    v87420: state_type > $o ).

tff(pred_def_46872,type,
    v87426: state_type > $o ).

tff(pred_def_46873,type,
    v87424: state_type > $o ).

tff(pred_def_46874,type,
    v87436: state_type > $o ).

tff(pred_def_46875,type,
    v87434: state_type > $o ).

tff(pred_def_46876,type,
    v87432: state_type > $o ).

tff(pred_def_46877,type,
    b0000100101000: $int > $o ).

tff(pred_def_46878,type,
    v87444: state_type > $o ).

tff(pred_def_46879,type,
    v87441: state_type > $o ).

tff(pred_def_46880,type,
    v87439: state_type > $o ).

tff(pred_def_46881,type,
    v87448: state_type > $o ).

tff(pred_def_46882,type,
    v87447: state_type > $o ).

tff(pred_def_46883,type,
    v87446: state_type > $o ).

tff(pred_def_46884,type,
    v87452: state_type > $o ).

tff(pred_def_46885,type,
    v87451: state_type > $o ).

tff(pred_def_46886,type,
    v87450: state_type > $o ).

tff(pred_def_46887,type,
    v87416: state_type > $o ).

tff(pred_def_46888,type,
    v87449: state_type > $o ).

tff(pred_def_46889,type,
    v87430: state_type > $o ).

tff(pred_def_46890,type,
    v87428: state_type > $o ).

tff(pred_def_46891,type,
    v87456: state_type > $o ).

tff(pred_def_46892,type,
    v87454: state_type > $o ).

tff(pred_def_46893,type,
    v87463: state_type > $o ).

tff(pred_def_46894,type,
    v87461: state_type > $o ).

tff(pred_def_46895,type,
    v87460: state_type > $o ).

tff(pred_def_46896,type,
    v87459: state_type > $o ).

tff(pred_def_46897,type,
    v87471: state_type > $o ).

tff(pred_def_46898,type,
    v87472: state_type > $o ).

tff(pred_def_46899,type,
    v87470: state_type > $o ).

tff(pred_def_46900,type,
    v87467: state_type > $o ).

tff(pred_def_46901,type,
    v87469: state_type > $o ).

tff(pred_def_46902,type,
    v87418: state_type > $o ).

tff(pred_def_46903,type,
    v87414: state_type > $o ).

tff(pred_def_46904,type,
    v87412: state_type > $o ).

tff(pred_def_46905,type,
    v87410: state_type > $o ).

tff(pred_def_46906,type,
    v87478: state_type > $o ).

tff(pred_def_46907,type,
    v87479: state_type > $o ).

tff(pred_def_46908,type,
    v87477: state_type > $o ).

tff(pred_def_46909,type,
    v87482: state_type > $o ).

tff(pred_def_46910,type,
    v87481: state_type > $o ).

tff(pred_def_46911,type,
    v87484: state_type > $o ).

tff(pred_def_46912,type,
    v87483: ( state_type * $int ) > $o ).

tff(pred_def_46913,type,
    v87480: ( state_type * $int ) > $o ).

tff(pred_def_46914,type,
    v87476: ( state_type * $int ) > $o ).

tff(pred_def_46915,type,
    v87343: ( state_type * $int ) > $o ).

tff(pred_def_46916,type,
    v87341: ( state_type * $int ) > $o ).

tff(pred_def_46917,type,
    v87339: ( state_type * $int ) > $o ).

tff(pred_def_46918,type,
    v87337: ( state_type * $int ) > $o ).

tff(pred_def_46919,type,
    v87488: state_type > $o ).

tff(pred_def_46920,type,
    v87486: state_type > $o ).

tff(pred_def_46921,type,
    v87495: state_type > $o ).

tff(pred_def_46922,type,
    v87493: state_type > $o ).

tff(pred_def_46923,type,
    v87492: state_type > $o ).

tff(pred_def_46924,type,
    v87491: state_type > $o ).

tff(pred_def_46925,type,
    v87503: state_type > $o ).

tff(pred_def_46926,type,
    v87504: state_type > $o ).

tff(pred_def_46927,type,
    v87502: state_type > $o ).

tff(pred_def_46928,type,
    v87499: ( state_type * $int ) > $o ).

tff(pred_def_46929,type,
    v87501: ( state_type * $int ) > $o ).

tff(pred_def_46930,type,
    v87490: ( state_type * $int ) > $o ).

tff(pred_def_46931,type,
    v87327: ( state_type * $int ) > $o ).

tff(pred_def_46932,type,
    v87325: ( state_type * $int ) > $o ).

tff(pred_def_46933,type,
    v87323: ( state_type * $int ) > $o ).

tff(pred_def_46934,type,
    v87321: ( state_type * $int ) > $o ).

tff(pred_def_46935,type,
    v87512: state_type > $o ).

tff(pred_def_46936,type,
    v87510: state_type > $o ).

tff(pred_def_46937,type,
    v87509: state_type > $o ).

tff(pred_def_46938,type,
    v87508: ( state_type * $int ) > $o ).

tff(pred_def_46939,type,
    v87516: state_type > $o ).

tff(pred_def_46940,type,
    v87517: state_type > $o ).

tff(pred_def_46941,type,
    v87319: state_type > $o ).

tff(pred_def_46942,type,
    v87519: state_type > $o ).

tff(pred_def_46943,type,
    v87518: ( state_type * $int ) > $o ).

tff(pred_def_46944,type,
    v87520: state_type > $o ).

tff(pred_def_46945,type,
    v87521: state_type > $o ).

tff(pred_def_46946,type,
    v87317: ( state_type * $int ) > $o ).

tff(pred_def_46947,type,
    v87315: ( state_type * $int ) > $o ).

tff(pred_def_46948,type,
    v87313: ( state_type * $int ) > $o ).

tff(pred_def_46949,type,
    v87527: state_type > $o ).

tff(pred_def_46950,type,
    v87525: state_type > $o ).

tff(pred_def_46951,type,
    v87523: state_type > $o ).

tff(pred_def_46952,type,
    v87534: state_type > $o ).

tff(pred_def_46953,type,
    v87532: state_type > $o ).

tff(pred_def_46954,type,
    v87531: state_type > $o ).

tff(pred_def_46955,type,
    v87530: state_type > $o ).

tff(pred_def_46956,type,
    v87542: state_type > $o ).

tff(pred_def_46957,type,
    v87543: state_type > $o ).

tff(pred_def_46958,type,
    v87541: state_type > $o ).

tff(pred_def_46959,type,
    v87538: ( state_type * $int ) > $o ).

tff(pred_def_46960,type,
    v87540: ( state_type * $int ) > $o ).

tff(pred_def_46961,type,
    v87529: ( state_type * $int ) > $o ).

tff(pred_def_46962,type,
    v87303: ( state_type * $int ) > $o ).

tff(pred_def_46963,type,
    v87301: ( state_type * $int ) > $o ).

tff(pred_def_46964,type,
    v87299: state_type > $o ).

tff(pred_def_46965,type,
    v87550: state_type > $o ).

tff(pred_def_46966,type,
    v87556: state_type > $o ).

tff(pred_def_46967,type,
    v87554: state_type > $o ).

tff(pred_def_46968,type,
    v87553: state_type > $o ).

tff(pred_def_46969,type,
    v87552: ( state_type * $int ) > $o ).

tff(pred_def_46970,type,
    v87547: state_type > $o ).

tff(pred_def_46971,type,
    v87563: state_type > $o ).

tff(pred_def_46972,type,
    v87569: state_type > $o ).

tff(pred_def_46973,type,
    v87567: state_type > $o ).

tff(pred_def_46974,type,
    v87566: state_type > $o ).

tff(pred_def_46975,type,
    v87565: ( state_type * $int ) > $o ).

tff(pred_def_46976,type,
    v87560: state_type > $o ).

tff(pred_def_46977,type,
    v87574: ( state_type * $int ) > $o ).

tff(pred_def_46978,type,
    v87573: ( state_type * $int ) > $o ).

tff(pred_def_46979,type,
    v87572: ( state_type * $int ) > $o ).

tff(pred_def_46980,type,
    v87297: ( state_type * $int ) > $o ).

tff(pred_def_46981,type,
    v87588: state_type > $o ).

tff(pred_def_46982,type,
    v87586: state_type > $o ).

tff(pred_def_46983,type,
    v87592: state_type > $o ).

tff(pred_def_46984,type,
    v87590: state_type > $o ).

tff(pred_def_46985,type,
    v87600: state_type > $o ).

tff(pred_def_46986,type,
    v87598: state_type > $o ).

tff(pred_def_46987,type,
    b0000100001000: $int > $o ).

tff(pred_def_46988,type,
    v87607: state_type > $o ).

tff(pred_def_46989,type,
    v87604: state_type > $o ).

tff(pred_def_46990,type,
    v87602: state_type > $o ).

tff(pred_def_46991,type,
    v87611: state_type > $o ).

tff(pred_def_46992,type,
    v87610: state_type > $o ).

tff(pred_def_46993,type,
    v87609: state_type > $o ).

tff(pred_def_46994,type,
    v87615: state_type > $o ).

tff(pred_def_46995,type,
    v87614: state_type > $o ).

tff(pred_def_46996,type,
    v87613: state_type > $o ).

tff(pred_def_46997,type,
    v87582: state_type > $o ).

tff(pred_def_46998,type,
    v87612: state_type > $o ).

tff(pred_def_46999,type,
    v87596: state_type > $o ).

tff(pred_def_47000,type,
    v87594: state_type > $o ).

tff(pred_def_47001,type,
    v87619: state_type > $o ).

tff(pred_def_47002,type,
    v87617: state_type > $o ).

tff(pred_def_47003,type,
    v87626: state_type > $o ).

tff(pred_def_47004,type,
    v87624: state_type > $o ).

tff(pred_def_47005,type,
    v87623: state_type > $o ).

tff(pred_def_47006,type,
    v87622: state_type > $o ).

tff(pred_def_47007,type,
    v87634: state_type > $o ).

tff(pred_def_47008,type,
    v87635: state_type > $o ).

tff(pred_def_47009,type,
    v87633: state_type > $o ).

tff(pred_def_47010,type,
    v87630: state_type > $o ).

tff(pred_def_47011,type,
    v87632: state_type > $o ).

tff(pred_def_47012,type,
    v87584: state_type > $o ).

tff(pred_def_47013,type,
    v87580: state_type > $o ).

tff(pred_def_47014,type,
    v87578: state_type > $o ).

tff(pred_def_47015,type,
    v87639: state_type > $o ).

tff(pred_def_47016,type,
    v87638: ( state_type * $int ) > $o ).

tff(pred_def_47017,type,
    v87576: ( state_type * $int ) > $o ).

tff(pred_def_47018,type,
    v87651: state_type > $o ).

tff(pred_def_47019,type,
    v87649: state_type > $o ).

tff(pred_def_47020,type,
    v87655: state_type > $o ).

tff(pred_def_47021,type,
    v87653: state_type > $o ).

tff(pred_def_47022,type,
    v87677: state_type > $o ).

tff(pred_def_47023,type,
    v87675: state_type > $o ).

tff(pred_def_47024,type,
    v87681: state_type > $o ).

tff(pred_def_47025,type,
    v87679: state_type > $o ).

tff(pred_def_47026,type,
    v87689: ( state_type * $int ) > $o ).

tff(pred_def_47027,type,
    v87690: ( state_type * $int ) > $o ).

tff(pred_def_47028,type,
    v87691: state_type > $o ).

tff(pred_def_47029,type,
    v87687: ( state_type * $int ) > $o ).

tff(pred_def_47030,type,
    b0001000011000: $int > $o ).

tff(pred_def_47031,type,
    v87698: state_type > $o ).

tff(pred_def_47032,type,
    v87695: state_type > $o ).

tff(pred_def_47033,type,
    v87693: state_type > $o ).

tff(pred_def_47034,type,
    v87702: state_type > $o ).

tff(pred_def_47035,type,
    v87701: ( state_type * $int ) > $o ).

tff(pred_def_47036,type,
    v87700: ( state_type * $int ) > $o ).

tff(pred_def_47037,type,
    v87706: state_type > $o ).

tff(pred_def_47038,type,
    v87705: ( state_type * $int ) > $o ).

tff(pred_def_47039,type,
    v87704: ( state_type * $int ) > $o ).

tff(pred_def_47040,type,
    v87671: ( state_type * $int ) > $o ).

tff(pred_def_47041,type,
    v87703: ( state_type * $int ) > $o ).

tff(pred_def_47042,type,
    v87699: ( state_type * $int ) > $o ).

tff(pred_def_47043,type,
    v87685: ( state_type * $int ) > $o ).

tff(pred_def_47044,type,
    v87683: ( state_type * $int ) > $o ).

tff(pred_def_47045,type,
    v87710: state_type > $o ).

tff(pred_def_47046,type,
    v87708: state_type > $o ).

tff(pred_def_47047,type,
    v87717: state_type > $o ).

tff(pred_def_47048,type,
    v87715: state_type > $o ).

tff(pred_def_47049,type,
    v87714: state_type > $o ).

tff(pred_def_47050,type,
    v87713: state_type > $o ).

tff(pred_def_47051,type,
    v87725: state_type > $o ).

tff(pred_def_47052,type,
    v87726: state_type > $o ).

tff(pred_def_47053,type,
    v87724: state_type > $o ).

tff(pred_def_47054,type,
    v87721: ( state_type * $int ) > $o ).

tff(pred_def_47055,type,
    v87723: ( state_type * $int ) > $o ).

tff(pred_def_47056,type,
    v87712: ( state_type * $int ) > $o ).

tff(pred_def_47057,type,
    v87673: ( state_type * $int ) > $o ).

tff(pred_def_47058,type,
    v87738: state_type > $o ).

tff(pred_def_47059,type,
    v87736: state_type > $o ).

tff(pred_def_47060,type,
    v87735: state_type > $o ).

tff(pred_def_47061,type,
    v87734: ( state_type * $int ) > $o ).

tff(pred_def_47062,type,
    v87730: state_type > $o ).

tff(pred_def_47063,type,
    v87669: ( state_type * $int ) > $o ).

tff(pred_def_47064,type,
    v87667: ( state_type * $int ) > $o ).

tff(pred_def_47065,type,
    v87665: ( state_type * $int ) > $o ).

tff(pred_def_47066,type,
    v87663: state_type > $o ).

tff(pred_def_47067,type,
    v87744: state_type > $o ).

tff(pred_def_47068,type,
    v87743: ( state_type * $int ) > $o ).

tff(pred_def_47069,type,
    v87745: state_type > $o ).

tff(pred_def_47070,type,
    v87746: state_type > $o ).

tff(pred_def_47071,type,
    v87747: state_type > $o ).

tff(pred_def_47072,type,
    v87748: state_type > $o ).

tff(pred_def_47073,type,
    v87749: state_type > $o ).

tff(pred_def_47074,type,
    v87750: state_type > $o ).

tff(pred_def_47075,type,
    v87661: ( state_type * $int ) > $o ).

tff(pred_def_47076,type,
    v87659: ( state_type * $int ) > $o ).

tff(pred_def_47077,type,
    v87657: ( state_type * $int ) > $o ).

tff(pred_def_47078,type,
    v87754: state_type > $o ).

tff(pred_def_47079,type,
    v87752: state_type > $o ).

tff(pred_def_47080,type,
    v87761: state_type > $o ).

tff(pred_def_47081,type,
    v87759: state_type > $o ).

tff(pred_def_47082,type,
    v87758: state_type > $o ).

tff(pred_def_47083,type,
    v87757: state_type > $o ).

tff(pred_def_47084,type,
    v87769: state_type > $o ).

tff(pred_def_47085,type,
    v87770: state_type > $o ).

tff(pred_def_47086,type,
    v87768: state_type > $o ).

tff(pred_def_47087,type,
    v87765: ( state_type * $int ) > $o ).

tff(pred_def_47088,type,
    v87767: ( state_type * $int ) > $o ).

tff(pred_def_47089,type,
    v87756: ( state_type * $int ) > $o ).

tff(pred_def_47090,type,
    v87647: ( state_type * $int ) > $o ).

tff(pred_def_47091,type,
    v87645: ( state_type * $int ) > $o ).

tff(pred_def_47092,type,
    v87643: state_type > $o ).

tff(pred_def_47093,type,
    v87782: state_type > $o ).

tff(pred_def_47094,type,
    v87780: state_type > $o ).

tff(pred_def_47095,type,
    v87779: state_type > $o ).

tff(pred_def_47096,type,
    v87778: ( state_type * $int ) > $o ).

tff(pred_def_47097,type,
    v87774: state_type > $o ).

tff(pred_def_47098,type,
    v87794: state_type > $o ).

tff(pred_def_47099,type,
    v87792: state_type > $o ).

tff(pred_def_47100,type,
    v87791: state_type > $o ).

tff(pred_def_47101,type,
    v87790: ( state_type * $int ) > $o ).

tff(pred_def_47102,type,
    v87786: state_type > $o ).

tff(pred_def_47103,type,
    v87806: state_type > $o ).

tff(pred_def_47104,type,
    v87804: state_type > $o ).

tff(pred_def_47105,type,
    v87803: state_type > $o ).

tff(pred_def_47106,type,
    v87802: ( state_type * $int ) > $o ).

tff(pred_def_47107,type,
    v87798: state_type > $o ).

tff(pred_def_47108,type,
    v87813: state_type > $o ).

tff(pred_def_47109,type,
    v87812: ( state_type * $int ) > $o ).

tff(pred_def_47110,type,
    v87811: ( state_type * $int ) > $o ).

tff(pred_def_47111,type,
    v87810: ( state_type * $int ) > $o ).

tff(pred_def_47112,type,
    v87809: ( state_type * $int ) > $o ).

tff(pred_def_47113,type,
    v87641: ( state_type * $int ) > $o ).

tff(pred_def_47114,type,
    v87829: state_type > $o ).

tff(pred_def_47115,type,
    v87834: state_type > $o ).

tff(pred_def_47116,type,
    v87836: state_type > $o ).

tff(pred_def_47117,type,
    v87837: state_type > $o ).

tff(pred_def_47118,type,
    v87835: state_type > $o ).

tff(pred_def_47119,type,
    v87833: state_type > $o ).

tff(pred_def_47120,type,
    v87832: state_type > $o ).

tff(pred_def_47121,type,
    v87838: state_type > $o ).

tff(pred_def_47122,type,
    v87831: state_type > $o ).

tff(pred_def_47123,type,
    v87839: state_type > $o ).

tff(pred_def_47124,type,
    v87830: state_type > $o ).

tff(pred_def_47125,type,
    v87828: state_type > $o ).

tff(pred_def_47126,type,
    v87840: state_type > $o ).

tff(pred_def_47127,type,
    v87827: state_type > $o ).

tff(pred_def_47128,type,
    v87826: state_type > $o ).

tff(pred_def_47129,type,
    v87848: state_type > $o ).

tff(pred_def_47130,type,
    v87847: state_type > $o ).

tff(pred_def_47131,type,
    v87846: state_type > $o ).

tff(pred_def_47132,type,
    v87850: state_type > $o ).

tff(pred_def_47133,type,
    v87849: state_type > $o ).

tff(pred_def_47134,type,
    v87845: state_type > $o ).

tff(pred_def_47135,type,
    v87844: state_type > $o ).

tff(pred_def_47136,type,
    v87851: state_type > $o ).

tff(pred_def_47137,type,
    v87843: state_type > $o ).

tff(pred_def_47138,type,
    v87852: state_type > $o ).

tff(pred_def_47139,type,
    v87842: state_type > $o ).

tff(pred_def_47140,type,
    v87841: state_type > $o ).

tff(pred_def_47141,type,
    v87825: state_type > $o ).

tff(pred_def_47142,type,
    v87853: state_type > $o ).

tff(pred_def_47143,type,
    v87824: state_type > $o ).

tff(pred_def_47144,type,
    v87856: state_type > $o ).

tff(pred_def_47145,type,
    v87857: state_type > $o ).

tff(pred_def_47146,type,
    v87855: state_type > $o ).

tff(pred_def_47147,type,
    v87858: state_type > $o ).

tff(pred_def_47148,type,
    v87854: state_type > $o ).

tff(pred_def_47149,type,
    v87861: state_type > $o ).

tff(pred_def_47150,type,
    v87860: state_type > $o ).

tff(pred_def_47151,type,
    v87862: state_type > $o ).

tff(pred_def_47152,type,
    v87859: state_type > $o ).

tff(pred_def_47153,type,
    v87822: ( state_type * $int ) > $o ).

tff(pred_def_47154,type,
    v87821: state_type > $o ).

tff(pred_def_47155,type,
    v87867: state_type > $o ).

tff(pred_def_47156,type,
    v87869: state_type > $o ).

tff(pred_def_47157,type,
    v87870: state_type > $o ).

tff(pred_def_47158,type,
    v87868: state_type > $o ).

tff(pred_def_47159,type,
    v87866: state_type > $o ).

tff(pred_def_47160,type,
    v87865: state_type > $o ).

tff(pred_def_47161,type,
    v87871: state_type > $o ).

tff(pred_def_47162,type,
    v87864: state_type > $o ).

tff(pred_def_47163,type,
    v87872: state_type > $o ).

tff(pred_def_47164,type,
    v87863: state_type > $o ).

tff(pred_def_47165,type,
    v87820: state_type > $o ).

tff(pred_def_47166,type,
    v87873: state_type > $o ).

tff(pred_def_47167,type,
    v87819: state_type > $o ).

tff(pred_def_47168,type,
    v87818: state_type > $o ).

tff(pred_def_47169,type,
    v87881: state_type > $o ).

tff(pred_def_47170,type,
    v87880: state_type > $o ).

tff(pred_def_47171,type,
    v87879: state_type > $o ).

tff(pred_def_47172,type,
    v87883: state_type > $o ).

tff(pred_def_47173,type,
    v87882: state_type > $o ).

tff(pred_def_47174,type,
    v87878: state_type > $o ).

tff(pred_def_47175,type,
    v87877: state_type > $o ).

tff(pred_def_47176,type,
    v87884: state_type > $o ).

tff(pred_def_47177,type,
    v87876: state_type > $o ).

tff(pred_def_47178,type,
    v87885: state_type > $o ).

tff(pred_def_47179,type,
    v87875: state_type > $o ).

tff(pred_def_47180,type,
    v87874: state_type > $o ).

tff(pred_def_47181,type,
    v87817: state_type > $o ).

tff(pred_def_47182,type,
    v87886: state_type > $o ).

tff(pred_def_47183,type,
    v87816: state_type > $o ).

tff(pred_def_47184,type,
    v87889: state_type > $o ).

tff(pred_def_47185,type,
    v87890: state_type > $o ).

tff(pred_def_47186,type,
    v87888: state_type > $o ).

tff(pred_def_47187,type,
    v87891: state_type > $o ).

tff(pred_def_47188,type,
    v87887: state_type > $o ).

tff(pred_def_47189,type,
    v87894: state_type > $o ).

tff(pred_def_47190,type,
    v87893: state_type > $o ).

tff(pred_def_47191,type,
    v87895: state_type > $o ).

tff(pred_def_47192,type,
    v87892: state_type > $o ).

tff(pred_def_47193,type,
    v87295: ( state_type * $int ) > $o ).

tff(pred_def_47194,type,
    v87910: state_type > $o ).

tff(pred_def_47195,type,
    v87909: state_type > $o ).

tff(pred_def_47196,type,
    v87908: ( state_type * $int ) > $o ).

tff(pred_def_47197,type,
    v87914: state_type > $o ).

tff(pred_def_47198,type,
    v87913: state_type > $o ).

tff(pred_def_47199,type,
    v87912: ( state_type * $int ) > $o ).

tff(pred_def_47200,type,
    b1111110: $int > $o ).

tff(pred_def_47201,type,
    v87911: ( state_type * $int ) > $o ).

tff(pred_def_47202,type,
    v87907: ( state_type * $int ) > $o ).

tff(pred_def_47203,type,
    v87918: state_type > $o ).

tff(pred_def_47204,type,
    v87917: state_type > $o ).

tff(pred_def_47205,type,
    v87916: ( state_type * $int ) > $o ).

tff(pred_def_47206,type,
    b1111100: $int > $o ).

tff(pred_def_47207,type,
    v87915: ( state_type * $int ) > $o ).

tff(pred_def_47208,type,
    v87906: ( state_type * $int ) > $o ).

tff(pred_def_47209,type,
    v87922: state_type > $o ).

tff(pred_def_47210,type,
    v87921: state_type > $o ).

tff(pred_def_47211,type,
    v87920: ( state_type * $int ) > $o ).

tff(pred_def_47212,type,
    b1111000: $int > $o ).

tff(pred_def_47213,type,
    v87919: ( state_type * $int ) > $o ).

tff(pred_def_47214,type,
    v87905: ( state_type * $int ) > $o ).

tff(pred_def_47215,type,
    v87926: state_type > $o ).

tff(pred_def_47216,type,
    v87925: state_type > $o ).

tff(pred_def_47217,type,
    v87924: ( state_type * $int ) > $o ).

tff(pred_def_47218,type,
    b1110000: $int > $o ).

tff(pred_def_47219,type,
    v87923: ( state_type * $int ) > $o ).

tff(pred_def_47220,type,
    v87904: ( state_type * $int ) > $o ).

tff(pred_def_47221,type,
    v87930: state_type > $o ).

tff(pred_def_47222,type,
    v87929: state_type > $o ).

tff(pred_def_47223,type,
    v87928: ( state_type * $int ) > $o ).

tff(pred_def_47224,type,
    b1100000: $int > $o ).

tff(pred_def_47225,type,
    v87927: ( state_type * $int ) > $o ).

tff(pred_def_47226,type,
    v87903: ( state_type * $int ) > $o ).

tff(pred_def_47227,type,
    v87934: state_type > $o ).

tff(pred_def_47228,type,
    v87933: state_type > $o ).

tff(pred_def_47229,type,
    v87932: ( state_type * $int ) > $o ).

tff(pred_def_47230,type,
    b1000000: $int > $o ).

tff(pred_def_47231,type,
    v87931: ( state_type * $int ) > $o ).

tff(pred_def_47232,type,
    v87293: ( state_type * $int ) > $o ).

tff(pred_def_47233,type,
    v87291: ( state_type * $int ) > $o ).

tff(pred_def_47234,type,
    v87289: ( state_type * $int ) > $o ).

tff(pred_def_47235,type,
    v87287: ( state_type * $int ) > $o ).

tff(pred_def_47236,type,
    v87938: state_type > $o ).

tff(pred_def_47237,type,
    v87936: state_type > $o ).

tff(pred_def_47238,type,
    v87945: state_type > $o ).

tff(pred_def_47239,type,
    v87943: state_type > $o ).

tff(pred_def_47240,type,
    v87942: state_type > $o ).

tff(pred_def_47241,type,
    v87941: state_type > $o ).

tff(pred_def_47242,type,
    v87953: state_type > $o ).

tff(pred_def_47243,type,
    v87954: state_type > $o ).

tff(pred_def_47244,type,
    v87952: state_type > $o ).

tff(pred_def_47245,type,
    v87949: ( state_type * $int ) > $o ).

tff(pred_def_47246,type,
    v87951: ( state_type * $int ) > $o ).

tff(pred_def_47247,type,
    v87269: ( state_type * $int ) > $o ).

tff(pred_def_47248,type,
    v87267: ( state_type * $int ) > $o ).

tff(pred_def_47249,type,
    v87265: ( state_type * $int ) > $o ).

tff(pred_def_47250,type,
    v87965: ( state_type * $int ) > $o ).

tff(pred_def_47251,type,
    v87964: state_type > $o ).

tff(pred_def_47252,type,
    v87963: state_type > $o ).

tff(pred_def_47253,type,
    v87962: state_type > $o ).

tff(pred_def_47254,type,
    v87961: state_type > $o ).

tff(pred_def_47255,type,
    v87960: state_type > $o ).

tff(pred_def_47256,type,
    v87959: state_type > $o ).

tff(pred_def_47257,type,
    v87202: state_type > $o ).

tff(pred_def_47258,type,
    v87200: state_type > $o ).

tff(pred_def_47259,type,
    v87967: state_type > $o ).

tff(pred_def_47260,type,
    v87198: state_type > $o ).

tff(pred_def_47261,type,
    v87196: state_type > $o ).

tff(pred_def_47262,type,
    v87973: state_type > $o ).

tff(pred_def_47263,type,
    v87971: state_type > $o ).

tff(pred_def_47264,type,
    v87970: state_type > $o ).

tff(pred_def_47265,type,
    v87969: ( state_type * $int ) > $o ).

tff(pred_def_47266,type,
    v87981: state_type > $o ).

tff(pred_def_47267,type,
    v87979: state_type > $o ).

tff(pred_def_47268,type,
    v87978: state_type > $o ).

tff(pred_def_47269,type,
    v87977: ( state_type * $int ) > $o ).

tff(pred_def_47270,type,
    v87985: ( state_type * $int ) > $o ).

tff(pred_def_47271,type,
    v87988: state_type > $o ).

tff(pred_def_47272,type,
    v87987: state_type > $o ).

tff(pred_def_47273,type,
    v87986: ( state_type * $int ) > $o ).

tff(pred_def_47274,type,
    v86954: ( state_type * $int ) > $o ).

tff(pred_def_47275,type,
    v86952: ( state_type * $int ) > $o ).

tff(pred_def_47276,type,
    v88000: state_type > $o ).

tff(pred_def_47277,type,
    v87998: state_type > $o ).

tff(pred_def_47278,type,
    v88004: state_type > $o ).

tff(pred_def_47279,type,
    v88002: state_type > $o ).

tff(pred_def_47280,type,
    v88012: ( state_type * $int ) > $o ).

tff(pred_def_47281,type,
    v88013: ( state_type * $int ) > $o ).

tff(pred_def_47282,type,
    v88014: ( state_type * $int ) > $o ).

tff(pred_def_47283,type,
    v88010: ( state_type * $int ) > $o ).

tff(pred_def_47284,type,
    v88020: state_type > $o ).

tff(pred_def_47285,type,
    v88018: state_type > $o ).

tff(pred_def_47286,type,
    v88016: state_type > $o ).

tff(pred_def_47287,type,
    v88024: state_type > $o ).

tff(pred_def_47288,type,
    v88023: ( state_type * $int ) > $o ).

tff(pred_def_47289,type,
    v88022: ( state_type * $int ) > $o ).

tff(pred_def_47290,type,
    v88028: state_type > $o ).

tff(pred_def_47291,type,
    v88027: ( state_type * $int ) > $o ).

tff(pred_def_47292,type,
    v88026: ( state_type * $int ) > $o ).

tff(pred_def_47293,type,
    v87994: ( state_type * $int ) > $o ).

tff(pred_def_47294,type,
    v88025: ( state_type * $int ) > $o ).

tff(pred_def_47295,type,
    v88021: ( state_type * $int ) > $o ).

tff(pred_def_47296,type,
    v88008: ( state_type * $int ) > $o ).

tff(pred_def_47297,type,
    v88006: ( state_type * $int ) > $o ).

tff(pred_def_47298,type,
    v88032: state_type > $o ).

tff(pred_def_47299,type,
    v88030: state_type > $o ).

tff(pred_def_47300,type,
    v88039: state_type > $o ).

tff(pred_def_47301,type,
    v88037: state_type > $o ).

tff(pred_def_47302,type,
    v88036: state_type > $o ).

tff(pred_def_47303,type,
    v88035: state_type > $o ).

tff(pred_def_47304,type,
    v88047: state_type > $o ).

tff(pred_def_47305,type,
    v88048: state_type > $o ).

tff(pred_def_47306,type,
    v88046: state_type > $o ).

tff(pred_def_47307,type,
    v88043: ( state_type * $int ) > $o ).

tff(pred_def_47308,type,
    v88045: ( state_type * $int ) > $o ).

tff(pred_def_47309,type,
    v88034: ( state_type * $int ) > $o ).

tff(pred_def_47310,type,
    v87996: ( state_type * $int ) > $o ).

tff(pred_def_47311,type,
    v88060: state_type > $o ).

tff(pred_def_47312,type,
    v88058: state_type > $o ).

tff(pred_def_47313,type,
    v88057: state_type > $o ).

tff(pred_def_47314,type,
    v88056: ( state_type * $int ) > $o ).

tff(pred_def_47315,type,
    v88052: ( state_type * $int ) > $o ).

tff(pred_def_47316,type,
    v88069: state_type > $o ).

tff(pred_def_47317,type,
    v88067: state_type > $o ).

tff(pred_def_47318,type,
    v88066: state_type > $o ).

tff(pred_def_47319,type,
    v88065: ( state_type * $int ) > $o ).

tff(pred_def_47320,type,
    v87992: ( state_type * $int ) > $o ).

tff(pred_def_47321,type,
    v88075: state_type > $o ).

tff(pred_def_47322,type,
    v87990: state_type > $o ).

tff(pred_def_47323,type,
    v88092: state_type > $o ).

tff(pred_def_47324,type,
    v88090: state_type > $o ).

tff(pred_def_47325,type,
    v88096: state_type > $o ).

tff(pred_def_47326,type,
    v88094: state_type > $o ).

tff(pred_def_47327,type,
    v88104: state_type > $o ).

tff(pred_def_47328,type,
    v88102: state_type > $o ).

tff(pred_def_47329,type,
    b0000101000000: $int > $o ).

tff(pred_def_47330,type,
    v88111: state_type > $o ).

tff(pred_def_47331,type,
    v88108: state_type > $o ).

tff(pred_def_47332,type,
    v88106: state_type > $o ).

tff(pred_def_47333,type,
    v88115: state_type > $o ).

tff(pred_def_47334,type,
    v88114: state_type > $o ).

tff(pred_def_47335,type,
    v88113: state_type > $o ).

tff(pred_def_47336,type,
    v88119: state_type > $o ).

tff(pred_def_47337,type,
    v88118: state_type > $o ).

tff(pred_def_47338,type,
    v88117: state_type > $o ).

tff(pred_def_47339,type,
    v88086: state_type > $o ).

tff(pred_def_47340,type,
    v88116: state_type > $o ).

tff(pred_def_47341,type,
    v88100: state_type > $o ).

tff(pred_def_47342,type,
    v88098: state_type > $o ).

tff(pred_def_47343,type,
    v88123: state_type > $o ).

tff(pred_def_47344,type,
    v88121: state_type > $o ).

tff(pred_def_47345,type,
    v88130: state_type > $o ).

tff(pred_def_47346,type,
    v88128: state_type > $o ).

tff(pred_def_47347,type,
    v88127: state_type > $o ).

tff(pred_def_47348,type,
    v88126: state_type > $o ).

tff(pred_def_47349,type,
    v88138: state_type > $o ).

tff(pred_def_47350,type,
    v88139: state_type > $o ).

tff(pred_def_47351,type,
    v88137: state_type > $o ).

tff(pred_def_47352,type,
    v88134: state_type > $o ).

tff(pred_def_47353,type,
    v88136: state_type > $o ).

tff(pred_def_47354,type,
    v88088: state_type > $o ).

tff(pred_def_47355,type,
    v88084: state_type > $o ).

tff(pred_def_47356,type,
    v88082: state_type > $o ).

tff(pred_def_47357,type,
    v88153: state_type > $o ).

tff(pred_def_47358,type,
    v88151: state_type > $o ).

tff(pred_def_47359,type,
    v88150: state_type > $o ).

tff(pred_def_47360,type,
    v88149: ( state_type * $int ) > $o ).

tff(pred_def_47361,type,
    v88145: state_type > $o ).

tff(pred_def_47362,type,
    v88165: state_type > $o ).

tff(pred_def_47363,type,
    v88163: state_type > $o ).

tff(pred_def_47364,type,
    v88162: state_type > $o ).

tff(pred_def_47365,type,
    v88161: ( state_type * $int ) > $o ).

tff(pred_def_47366,type,
    v88157: state_type > $o ).

tff(pred_def_47367,type,
    v88176: state_type > $o ).

tff(pred_def_47368,type,
    v88175: state_type > $o ).

tff(pred_def_47369,type,
    v88177: state_type > $o ).

tff(pred_def_47370,type,
    v88174: state_type > $o ).

tff(pred_def_47371,type,
    v88173: state_type > $o ).

tff(pred_def_47372,type,
    v88181: state_type > $o ).

tff(pred_def_47373,type,
    v88180: state_type > $o ).

tff(pred_def_47374,type,
    v88182: state_type > $o ).

tff(pred_def_47375,type,
    v88179: state_type > $o ).

tff(pred_def_47376,type,
    v88178: state_type > $o ).

tff(pred_def_47377,type,
    v88172: state_type > $o ).

tff(pred_def_47378,type,
    v88186: state_type > $o ).

tff(pred_def_47379,type,
    v88185: state_type > $o ).

tff(pred_def_47380,type,
    v88187: state_type > $o ).

tff(pred_def_47381,type,
    v88184: state_type > $o ).

tff(pred_def_47382,type,
    v88183: state_type > $o ).

tff(pred_def_47383,type,
    v88171: state_type > $o ).

tff(pred_def_47384,type,
    v88191: state_type > $o ).

tff(pred_def_47385,type,
    v88190: state_type > $o ).

tff(pred_def_47386,type,
    v88192: state_type > $o ).

tff(pred_def_47387,type,
    v88189: state_type > $o ).

tff(pred_def_47388,type,
    v88188: state_type > $o ).

tff(pred_def_47389,type,
    v88170: state_type > $o ).

tff(pred_def_47390,type,
    v88196: state_type > $o ).

tff(pred_def_47391,type,
    v88195: state_type > $o ).

tff(pred_def_47392,type,
    v88197: state_type > $o ).

tff(pred_def_47393,type,
    v88194: state_type > $o ).

tff(pred_def_47394,type,
    v88193: state_type > $o ).

tff(pred_def_47395,type,
    v88169: state_type > $o ).

tff(pred_def_47396,type,
    v88143: state_type > $o ).

tff(pred_def_47397,type,
    v88209: state_type > $o ).

tff(pred_def_47398,type,
    v88207: state_type > $o ).

tff(pred_def_47399,type,
    v88206: state_type > $o ).

tff(pred_def_47400,type,
    v88205: ( state_type * $int ) > $o ).

tff(pred_def_47401,type,
    v88201: state_type > $o ).

tff(pred_def_47402,type,
    v88214: state_type > $o ).

tff(pred_def_47403,type,
    v88213: state_type > $o ).

tff(pred_def_47404,type,
    v88218: state_type > $o ).

tff(pred_def_47405,type,
    v88217: state_type > $o ).

tff(pred_def_47406,type,
    v88221: state_type > $o ).

tff(pred_def_47407,type,
    v88220: state_type > $o ).

tff(pred_def_47408,type,
    v88219: state_type > $o ).

tff(pred_def_47409,type,
    v88216: state_type > $o ).

tff(pred_def_47410,type,
    v88226: state_type > $o ).

tff(pred_def_47411,type,
    v88225: state_type > $o ).

tff(pred_def_47412,type,
    v88229: state_type > $o ).

tff(pred_def_47413,type,
    v88228: state_type > $o ).

tff(pred_def_47414,type,
    v88227: state_type > $o ).

tff(pred_def_47415,type,
    v88224: state_type > $o ).

tff(pred_def_47416,type,
    v88231: state_type > $o ).

tff(pred_def_47417,type,
    v88230: state_type > $o ).

tff(pred_def_47418,type,
    v88223: state_type > $o ).

tff(pred_def_47419,type,
    v88237: state_type > $o ).

tff(pred_def_47420,type,
    v88236: state_type > $o ).

tff(pred_def_47421,type,
    v88240: state_type > $o ).

tff(pred_def_47422,type,
    v88239: state_type > $o ).

tff(pred_def_47423,type,
    v88238: state_type > $o ).

tff(pred_def_47424,type,
    v88235: state_type > $o ).

tff(pred_def_47425,type,
    v88242: state_type > $o ).

tff(pred_def_47426,type,
    v88241: state_type > $o ).

tff(pred_def_47427,type,
    v88234: state_type > $o ).

tff(pred_def_47428,type,
    v88244: state_type > $o ).

tff(pred_def_47429,type,
    v88243: state_type > $o ).

tff(pred_def_47430,type,
    v88233: state_type > $o ).

tff(pred_def_47431,type,
    v88250: state_type > $o ).

tff(pred_def_47432,type,
    v88249: state_type > $o ).

tff(pred_def_47433,type,
    v88248: state_type > $o ).

tff(pred_def_47434,type,
    v88252: state_type > $o ).

tff(pred_def_47435,type,
    v88251: state_type > $o ).

tff(pred_def_47436,type,
    v88247: state_type > $o ).

tff(pred_def_47437,type,
    v88254: state_type > $o ).

tff(pred_def_47438,type,
    v88253: state_type > $o ).

tff(pred_def_47439,type,
    v88246: state_type > $o ).

tff(pred_def_47440,type,
    v88258: state_type > $o ).

tff(pred_def_47441,type,
    v88257: state_type > $o ).

tff(pred_def_47442,type,
    v88260: state_type > $o ).

tff(pred_def_47443,type,
    v88259: state_type > $o ).

tff(pred_def_47444,type,
    v88256: state_type > $o ).

tff(pred_def_47445,type,
    v88263: state_type > $o ).

tff(pred_def_47446,type,
    v88262: state_type > $o ).

tff(pred_def_47447,type,
    v88261: state_type > $o ).

tff(pred_def_47448,type,
    v88255: state_type > $o ).

tff(pred_def_47449,type,
    v88245: state_type > $o ).

tff(pred_def_47450,type,
    v88232: state_type > $o ).

tff(pred_def_47451,type,
    v88222: state_type > $o ).

tff(pred_def_47452,type,
    v88215: state_type > $o ).

tff(pred_def_47453,type,
    v88199: state_type > $o ).

tff(pred_def_47454,type,
    v88080: state_type > $o ).

tff(pred_def_47455,type,
    v88078: state_type > $o ).

tff(pred_def_47456,type,
    v88272: state_type > $o ).

tff(pred_def_47457,type,
    v88275: state_type > $o ).

tff(pred_def_47458,type,
    v88274: state_type > $o ).

tff(pred_def_47459,type,
    v88276: state_type > $o ).

tff(pred_def_47460,type,
    v88273: state_type > $o ).

tff(pred_def_47461,type,
    v88270: ( state_type * $int ) > $o ).

tff(pred_def_47462,type,
    v88281: state_type > $o ).

tff(pred_def_47463,type,
    v88280: state_type > $o ).

tff(pred_def_47464,type,
    v88284: state_type > $o ).

tff(pred_def_47465,type,
    v88283: state_type > $o ).

tff(pred_def_47466,type,
    v88287: state_type > $o ).

tff(pred_def_47467,type,
    v88286: state_type > $o ).

tff(pred_def_47468,type,
    v88290: state_type > $o ).

tff(pred_def_47469,type,
    v88289: state_type > $o ).

tff(pred_def_47470,type,
    v88288: state_type > $o ).

tff(pred_def_47471,type,
    v88285: state_type > $o ).

tff(pred_def_47472,type,
    v88282: state_type > $o ).

tff(pred_def_47473,type,
    v88278: ( state_type * $int ) > $o ).

tff(pred_def_47474,type,
    v88291: ( state_type * $int ) > $o ).

tff(pred_def_47475,type,
    v88268: ( state_type * $int ) > $o ).

tff(pred_def_47476,type,
    v88266: ( state_type * $int ) > $o ).

tff(pred_def_47477,type,
    v88293: state_type > $o ).

tff(pred_def_47478,type,
    v88296: state_type > $o ).

tff(pred_def_47479,type,
    v88295: state_type > $o ).

tff(pred_def_47480,type,
    v88297: state_type > $o ).

tff(pred_def_47481,type,
    v88294: state_type > $o ).

tff(pred_def_47482,type,
    v88301: state_type > $o ).

tff(pred_def_47483,type,
    v88300: state_type > $o ).

tff(pred_def_47484,type,
    v88299: state_type > $o ).

tff(pred_def_47485,type,
    v88305: state_type > $o ).

tff(pred_def_47486,type,
    v88304: state_type > $o ).

tff(pred_def_47487,type,
    v88308: state_type > $o ).

tff(pred_def_47488,type,
    v88307: state_type > $o ).

tff(pred_def_47489,type,
    v88306: state_type > $o ).

tff(pred_def_47490,type,
    v88303: state_type > $o ).

tff(pred_def_47491,type,
    v88312: state_type > $o ).

tff(pred_def_47492,type,
    v88311: state_type > $o ).

tff(pred_def_47493,type,
    v88315: state_type > $o ).

tff(pred_def_47494,type,
    v88314: state_type > $o ).

tff(pred_def_47495,type,
    v88313: state_type > $o ).

tff(pred_def_47496,type,
    v88310: state_type > $o ).

tff(pred_def_47497,type,
    v88319: state_type > $o ).

tff(pred_def_47498,type,
    v88318: state_type > $o ).

tff(pred_def_47499,type,
    v88322: state_type > $o ).

tff(pred_def_47500,type,
    v88321: state_type > $o ).

tff(pred_def_47501,type,
    v88320: state_type > $o ).

tff(pred_def_47502,type,
    v88317: state_type > $o ).

tff(pred_def_47503,type,
    v88325: state_type > $o ).

tff(pred_def_47504,type,
    v88324: state_type > $o ).

tff(pred_def_47505,type,
    v88323: state_type > $o ).

tff(pred_def_47506,type,
    v88316: state_type > $o ).

tff(pred_def_47507,type,
    v88309: state_type > $o ).

tff(pred_def_47508,type,
    v88302: state_type > $o ).

tff(pred_def_47509,type,
    v88298: state_type > $o ).

tff(pred_def_47510,type,
    v88329: state_type > $o ).

tff(pred_def_47511,type,
    v88330: state_type > $o ).

tff(pred_def_47512,type,
    v88328: state_type > $o ).

tff(pred_def_47513,type,
    v88327: state_type > $o ).

tff(pred_def_47514,type,
    v88334: state_type > $o ).

tff(pred_def_47515,type,
    v88335: state_type > $o ).

tff(pred_def_47516,type,
    v88333: state_type > $o ).

tff(pred_def_47517,type,
    v88332: state_type > $o ).

tff(pred_def_47518,type,
    v88339: state_type > $o ).

tff(pred_def_47519,type,
    v88340: state_type > $o ).

tff(pred_def_47520,type,
    v88338: state_type > $o ).

tff(pred_def_47521,type,
    v88337: state_type > $o ).

tff(pred_def_47522,type,
    v88344: state_type > $o ).

tff(pred_def_47523,type,
    v88345: state_type > $o ).

tff(pred_def_47524,type,
    v88343: state_type > $o ).

tff(pred_def_47525,type,
    v88342: state_type > $o ).

tff(pred_def_47526,type,
    v88341: state_type > $o ).

tff(pred_def_47527,type,
    v88336: state_type > $o ).

tff(pred_def_47528,type,
    v88331: state_type > $o ).

tff(pred_def_47529,type,
    v86950: ( state_type * $int ) > $o ).

tff(pred_def_47530,type,
    v88347: state_type > $o ).

tff(pred_def_47531,type,
    v88349: state_type > $o ).

tff(pred_def_47532,type,
    v88350: state_type > $o ).

tff(pred_def_47533,type,
    v88353: state_type > $o ).

tff(pred_def_47534,type,
    v88352: ( state_type * $int ) > $o ).

tff(pred_def_47535,type,
    v88355: state_type > $o ).

tff(pred_def_47536,type,
    v88356: state_type > $o ).

tff(pred_def_47537,type,
    v88357: state_type > $o ).

tff(pred_def_47538,type,
    v88358: state_type > $o ).

tff(pred_def_47539,type,
    v88359: state_type > $o ).

tff(pred_def_47540,type,
    v88360: state_type > $o ).

tff(pred_def_47541,type,
    v88361: state_type > $o ).

tff(pred_def_47542,type,
    v88362: state_type > $o ).

tff(pred_def_47543,type,
    v88363: state_type > $o ).

tff(pred_def_47544,type,
    v88364: state_type > $o ).

tff(pred_def_47545,type,
    v88365: state_type > $o ).

tff(pred_def_47546,type,
    v88366: state_type > $o ).

tff(pred_def_47547,type,
    v88367: state_type > $o ).

tff(pred_def_47548,type,
    v88368: state_type > $o ).

tff(pred_def_47549,type,
    v88369: state_type > $o ).

tff(pred_def_47550,type,
    v88370: state_type > $o ).

tff(pred_def_47551,type,
    v88354: ( state_type * $int ) > $o ).

tff(pred_def_47552,type,
    v86883: ( state_type * $int ) > $o ).

tff(pred_def_47553,type,
    v88380: state_type > $o ).

tff(pred_def_47554,type,
    v88378: state_type > $o ).

tff(pred_def_47555,type,
    v88384: state_type > $o ).

tff(pred_def_47556,type,
    v88382: state_type > $o ).

tff(pred_def_47557,type,
    v88404: state_type > $o ).

tff(pred_def_47558,type,
    v88402: state_type > $o ).

tff(pred_def_47559,type,
    v88408: state_type > $o ).

tff(pred_def_47560,type,
    v88406: state_type > $o ).

tff(pred_def_47561,type,
    v88422: state_type > $o ).

tff(pred_def_47562,type,
    v88420: state_type > $o ).

tff(pred_def_47563,type,
    v88418: state_type > $o ).

tff(pred_def_47564,type,
    v88435: state_type > $o ).

tff(pred_def_47565,type,
    v88433: state_type > $o ).

tff(pred_def_47566,type,
    v88439: state_type > $o ).

tff(pred_def_47567,type,
    v88437: state_type > $o ).

tff(pred_def_47568,type,
    v88449: ( state_type * $int ) > $o ).

tff(pred_def_47569,type,
    v88451: state_type > $o ).

tff(pred_def_47570,type,
    v88452: state_type > $o ).

tff(pred_def_47571,type,
    v88453: state_type > $o ).

tff(pred_def_47572,type,
    v88454: state_type > $o ).

tff(pred_def_47573,type,
    v88450: ( state_type * $int ) > $o ).

tff(pred_def_47574,type,
    v88447: ( state_type * $int ) > $o ).

tff(pred_def_47575,type,
    v88445: ( state_type * $int ) > $o ).

tff(pred_def_47576,type,
    b0000011001000: $int > $o ).

tff(pred_def_47577,type,
    v88461: state_type > $o ).

tff(pred_def_47578,type,
    v88458: state_type > $o ).

tff(pred_def_47579,type,
    v88456: state_type > $o ).

tff(pred_def_47580,type,
    v88465: state_type > $o ).

tff(pred_def_47581,type,
    v88464: ( state_type * $int ) > $o ).

tff(pred_def_47582,type,
    v88463: ( state_type * $int ) > $o ).

tff(pred_def_47583,type,
    v88469: state_type > $o ).

tff(pred_def_47584,type,
    v88468: ( state_type * $int ) > $o ).

tff(pred_def_47585,type,
    v88467: ( state_type * $int ) > $o ).

tff(pred_def_47586,type,
    v88429: ( state_type * $int ) > $o ).

tff(pred_def_47587,type,
    v88466: ( state_type * $int ) > $o ).

tff(pred_def_47588,type,
    v88462: ( state_type * $int ) > $o ).

tff(pred_def_47589,type,
    v88443: ( state_type * $int ) > $o ).

tff(pred_def_47590,type,
    v88441: ( state_type * $int ) > $o ).

tff(pred_def_47591,type,
    v88473: state_type > $o ).

tff(pred_def_47592,type,
    v88471: state_type > $o ).

tff(pred_def_47593,type,
    v88480: state_type > $o ).

tff(pred_def_47594,type,
    v88478: state_type > $o ).

tff(pred_def_47595,type,
    v88477: state_type > $o ).

tff(pred_def_47596,type,
    v88476: state_type > $o ).

tff(pred_def_47597,type,
    v88488: state_type > $o ).

tff(pred_def_47598,type,
    v88489: state_type > $o ).

tff(pred_def_47599,type,
    v88487: state_type > $o ).

tff(pred_def_47600,type,
    v88484: ( state_type * $int ) > $o ).

tff(pred_def_47601,type,
    v88486: ( state_type * $int ) > $o ).

tff(pred_def_47602,type,
    v88475: ( state_type * $int ) > $o ).

tff(pred_def_47603,type,
    v88431: ( state_type * $int ) > $o ).

tff(pred_def_47604,type,
    v88427: ( state_type * $int ) > $o ).

tff(pred_def_47605,type,
    v88497: state_type > $o ).

tff(pred_def_47606,type,
    v88495: state_type > $o ).

tff(pred_def_47607,type,
    v88494: state_type > $o ).

tff(pred_def_47608,type,
    v88493: ( state_type * $int ) > $o ).

tff(pred_def_47609,type,
    v88505: state_type > $o ).

tff(pred_def_47610,type,
    v88503: state_type > $o ).

tff(pred_def_47611,type,
    v88502: state_type > $o ).

tff(pred_def_47612,type,
    v88501: ( state_type * $int ) > $o ).

tff(pred_def_47613,type,
    v88513: state_type > $o ).

tff(pred_def_47614,type,
    v88511: state_type > $o ).

tff(pred_def_47615,type,
    v88510: state_type > $o ).

tff(pred_def_47616,type,
    v88509: ( state_type * $int ) > $o ).

tff(pred_def_47617,type,
    v88521: state_type > $o ).

tff(pred_def_47618,type,
    v88519: state_type > $o ).

tff(pred_def_47619,type,
    v88518: state_type > $o ).

tff(pred_def_47620,type,
    v88517: ( state_type * $int ) > $o ).

tff(pred_def_47621,type,
    v88529: state_type > $o ).

tff(pred_def_47622,type,
    v88527: state_type > $o ).

tff(pred_def_47623,type,
    v88526: state_type > $o ).

tff(pred_def_47624,type,
    v88525: ( state_type * $int ) > $o ).

tff(pred_def_47625,type,
    v88537: state_type > $o ).

tff(pred_def_47626,type,
    v88535: state_type > $o ).

tff(pred_def_47627,type,
    v88534: state_type > $o ).

tff(pred_def_47628,type,
    v88533: ( state_type * $int ) > $o ).

tff(pred_def_47629,type,
    v88541: state_type > $o ).

tff(pred_def_47630,type,
    v88542: state_type > $o ).

tff(pred_def_47631,type,
    v88543: state_type > $o ).

tff(pred_def_47632,type,
    v88544: state_type > $o ).

tff(pred_def_47633,type,
    v88425: ( state_type * $int ) > $o ).

tff(pred_def_47634,type,
    v84295: state_type > $o ).

tff(pred_def_47635,type,
    v88546: state_type > $o ).

tff(pred_def_47636,type,
    v88396: ( state_type * $int ) > $o ).

tff(pred_def_47637,type,
    v88548: state_type > $o ).

tff(pred_def_47638,type,
    v88564: state_type > $o ).

tff(pred_def_47639,type,
    v88563: state_type > $o ).

tff(pred_def_47640,type,
    v88562: state_type > $o ).

tff(pred_def_47641,type,
    v88565: state_type > $o ).

tff(pred_def_47642,type,
    v88561: state_type > $o ).

tff(pred_def_47643,type,
    v88560: state_type > $o ).

tff(pred_def_47644,type,
    v88566: state_type > $o ).

tff(pred_def_47645,type,
    v88559: state_type > $o ).

tff(pred_def_47646,type,
    v88558: state_type > $o ).

tff(pred_def_47647,type,
    v88567: state_type > $o ).

tff(pred_def_47648,type,
    v88557: state_type > $o ).

tff(pred_def_47649,type,
    v88556: state_type > $o ).

tff(pred_def_47650,type,
    v88568: state_type > $o ).

tff(pred_def_47651,type,
    v88555: state_type > $o ).

tff(pred_def_47652,type,
    v88554: state_type > $o ).

tff(pred_def_47653,type,
    v88553: state_type > $o ).

tff(pred_def_47654,type,
    v88552: state_type > $o ).

tff(pred_def_47655,type,
    v88570: state_type > $o ).

tff(pred_def_47656,type,
    v88569: state_type > $o ).

tff(pred_def_47657,type,
    v88551: state_type > $o ).

tff(pred_def_47658,type,
    v88573: state_type > $o ).

tff(pred_def_47659,type,
    v88572: state_type > $o ).

tff(pred_def_47660,type,
    v88574: state_type > $o ).

tff(pred_def_47661,type,
    v88571: state_type > $o ).

tff(pred_def_47662,type,
    v88577: state_type > $o ).

tff(pred_def_47663,type,
    v88576: state_type > $o ).

tff(pred_def_47664,type,
    v88578: state_type > $o ).

tff(pred_def_47665,type,
    v88575: state_type > $o ).

tff(pred_def_47666,type,
    v88581: state_type > $o ).

tff(pred_def_47667,type,
    v88580: state_type > $o ).

tff(pred_def_47668,type,
    v88582: state_type > $o ).

tff(pred_def_47669,type,
    v88579: state_type > $o ).

tff(pred_def_47670,type,
    v88585: state_type > $o ).

tff(pred_def_47671,type,
    v88584: state_type > $o ).

tff(pred_def_47672,type,
    v88586: state_type > $o ).

tff(pred_def_47673,type,
    v88583: state_type > $o ).

tff(pred_def_47674,type,
    v88589: state_type > $o ).

tff(pred_def_47675,type,
    v88588: state_type > $o ).

tff(pred_def_47676,type,
    v88590: state_type > $o ).

tff(pred_def_47677,type,
    v88587: state_type > $o ).

tff(pred_def_47678,type,
    v88549: ( state_type * $int ) > $o ).

tff(pred_def_47679,type,
    v88547: ( state_type * $int ) > $o ).

tff(pred_def_47680,type,
    v88416: ( state_type * $int ) > $o ).

tff(pred_def_47681,type,
    v88414: ( state_type * $int ) > $o ).

tff(pred_def_47682,type,
    v88412: ( state_type * $int ) > $o ).

tff(pred_def_47683,type,
    v88410: ( state_type * $int ) > $o ).

tff(pred_def_47684,type,
    v88594: state_type > $o ).

tff(pred_def_47685,type,
    v88592: state_type > $o ).

tff(pred_def_47686,type,
    v88601: state_type > $o ).

tff(pred_def_47687,type,
    v88599: state_type > $o ).

tff(pred_def_47688,type,
    v88598: state_type > $o ).

tff(pred_def_47689,type,
    v88597: state_type > $o ).

tff(pred_def_47690,type,
    v88609: state_type > $o ).

tff(pred_def_47691,type,
    v88610: state_type > $o ).

tff(pred_def_47692,type,
    v88608: state_type > $o ).

tff(pred_def_47693,type,
    v88605: ( state_type * $int ) > $o ).

tff(pred_def_47694,type,
    v88607: ( state_type * $int ) > $o ).

tff(pred_def_47695,type,
    v88400: ( state_type * $int ) > $o ).

tff(pred_def_47696,type,
    v88398: ( state_type * $int ) > $o ).

tff(pred_def_47697,type,
    v88394: state_type > $o ).

tff(pred_def_47698,type,
    v88623: state_type > $o ).

tff(pred_def_47699,type,
    v88621: state_type > $o ).

tff(pred_def_47700,type,
    v88627: state_type > $o ).

tff(pred_def_47701,type,
    v88625: state_type > $o ).

tff(pred_def_47702,type,
    v88647: state_type > $o ).

tff(pred_def_47703,type,
    v88645: state_type > $o ).

tff(pred_def_47704,type,
    v88651: state_type > $o ).

tff(pred_def_47705,type,
    v88649: state_type > $o ).

tff(pred_def_47706,type,
    v88669: state_type > $o ).

tff(pred_def_47707,type,
    v88667: state_type > $o ).

tff(pred_def_47708,type,
    v88673: state_type > $o ).

tff(pred_def_47709,type,
    v88671: state_type > $o ).

tff(pred_def_47710,type,
    v88686: state_type > $o ).

tff(pred_def_47711,type,
    v84299: ( state_type * $int ) > $o ).

tff(pred_def_47712,type,
    v88687: state_type > $o ).

tff(pred_def_47713,type,
    v88685: state_type > $o ).

tff(pred_def_47714,type,
    v88683: state_type > $o ).

tff(pred_def_47715,type,
    v88697: state_type > $o ).

tff(pred_def_47716,type,
    v88696: state_type > $o ).

tff(pred_def_47717,type,
    v88695: state_type > $o ).

tff(pred_def_47718,type,
    v88694: state_type > $o ).

tff(pred_def_47719,type,
    v88693: state_type > $o ).

tff(pred_def_47720,type,
    v88699: state_type > $o ).

tff(pred_def_47721,type,
    v88698: state_type > $o ).

tff(pred_def_47722,type,
    v88692: state_type > $o ).

tff(pred_def_47723,type,
    v88702: state_type > $o ).

tff(pred_def_47724,type,
    v88701: state_type > $o ).

tff(pred_def_47725,type,
    v88703: state_type > $o ).

tff(pred_def_47726,type,
    v88700: state_type > $o ).

tff(pred_def_47727,type,
    v88689: ( state_type * $int ) > $o ).

tff(pred_def_47728,type,
    v88708: ( state_type * $int ) > $o ).

tff(pred_def_47729,type,
    v88372: ( state_type * $int ) > $o ).

tff(pred_def_47730,type,
    v88707: state_type > $o ).

tff(pred_def_47731,type,
    v88706: state_type > $o ).

tff(pred_def_47732,type,
    v88705: state_type > $o ).

tff(pred_def_47733,type,
    v88661: state_type > $o ).

tff(pred_def_47734,type,
    v88681: state_type > $o ).

tff(pred_def_47735,type,
    v88679: state_type > $o ).

tff(pred_def_47736,type,
    v88677: state_type > $o ).

tff(pred_def_47737,type,
    v88675: state_type > $o ).

tff(pred_def_47738,type,
    v88712: state_type > $o ).

tff(pred_def_47739,type,
    v88710: state_type > $o ).

tff(pred_def_47740,type,
    v88719: state_type > $o ).

tff(pred_def_47741,type,
    v88717: state_type > $o ).

tff(pred_def_47742,type,
    v88716: state_type > $o ).

tff(pred_def_47743,type,
    v88715: state_type > $o ).

tff(pred_def_47744,type,
    v88727: state_type > $o ).

tff(pred_def_47745,type,
    v88728: state_type > $o ).

tff(pred_def_47746,type,
    v88726: state_type > $o ).

tff(pred_def_47747,type,
    v88723: state_type > $o ).

tff(pred_def_47748,type,
    v88725: state_type > $o ).

tff(pred_def_47749,type,
    v88665: state_type > $o ).

tff(pred_def_47750,type,
    v88663: state_type > $o ).

tff(pred_def_47751,type,
    v88733: state_type > $o ).

tff(pred_def_47752,type,
    v88734: state_type > $o ).

tff(pred_def_47753,type,
    v88732: state_type > $o ).

tff(pred_def_47754,type,
    v88639: ( state_type * $int ) > $o ).

tff(pred_def_47755,type,
    v88745: state_type > $o ).

tff(pred_def_47756,type,
    v88744: state_type > $o ).

tff(pred_def_47757,type,
    v88743: state_type > $o ).

tff(pred_def_47758,type,
    v88742: state_type > $o ).

tff(pred_def_47759,type,
    v88741: state_type > $o ).

tff(pred_def_47760,type,
    v88740: state_type > $o ).

tff(pred_def_47761,type,
    v88739: state_type > $o ).

tff(pred_def_47762,type,
    v88746: state_type > $o ).

tff(pred_def_47763,type,
    v88738: state_type > $o ).

tff(pred_def_47764,type,
    v88747: state_type > $o ).

tff(pred_def_47765,type,
    v88737: state_type > $o ).

tff(pred_def_47766,type,
    v88750: state_type > $o ).

tff(pred_def_47767,type,
    v88751: state_type > $o ).

tff(pred_def_47768,type,
    v88749: state_type > $o ).

tff(pred_def_47769,type,
    v88752: state_type > $o ).

tff(pred_def_47770,type,
    v88748: state_type > $o ).

tff(pred_def_47771,type,
    v88755: state_type > $o ).

tff(pred_def_47772,type,
    v88756: state_type > $o ).

tff(pred_def_47773,type,
    v88754: state_type > $o ).

tff(pred_def_47774,type,
    v88757: state_type > $o ).

tff(pred_def_47775,type,
    v88753: state_type > $o ).

tff(pred_def_47776,type,
    v88760: state_type > $o ).

tff(pred_def_47777,type,
    v88761: state_type > $o ).

tff(pred_def_47778,type,
    v88759: state_type > $o ).

tff(pred_def_47779,type,
    v88762: state_type > $o ).

tff(pred_def_47780,type,
    v88758: state_type > $o ).

tff(pred_def_47781,type,
    v88765: state_type > $o ).

tff(pred_def_47782,type,
    v88766: state_type > $o ).

tff(pred_def_47783,type,
    v88764: state_type > $o ).

tff(pred_def_47784,type,
    v88767: state_type > $o ).

tff(pred_def_47785,type,
    v88763: state_type > $o ).

tff(pred_def_47786,type,
    v88770: state_type > $o ).

tff(pred_def_47787,type,
    v88771: state_type > $o ).

tff(pred_def_47788,type,
    v88769: state_type > $o ).

tff(pred_def_47789,type,
    v88772: state_type > $o ).

tff(pred_def_47790,type,
    v88768: state_type > $o ).

tff(pred_def_47791,type,
    v88775: state_type > $o ).

tff(pred_def_47792,type,
    v88776: state_type > $o ).

tff(pred_def_47793,type,
    v88774: state_type > $o ).

tff(pred_def_47794,type,
    v88777: state_type > $o ).

tff(pred_def_47795,type,
    v88773: state_type > $o ).

tff(pred_def_47796,type,
    v88735: ( state_type * $int ) > $o ).

tff(pred_def_47797,type,
    v88659: ( state_type * $int ) > $o ).

tff(pred_def_47798,type,
    v88657: ( state_type * $int ) > $o ).

tff(pred_def_47799,type,
    v88655: ( state_type * $int ) > $o ).

tff(pred_def_47800,type,
    v88653: ( state_type * $int ) > $o ).

tff(pred_def_47801,type,
    v88781: state_type > $o ).

tff(pred_def_47802,type,
    v88779: state_type > $o ).

tff(pred_def_47803,type,
    v88788: state_type > $o ).

tff(pred_def_47804,type,
    v88786: state_type > $o ).

tff(pred_def_47805,type,
    v88785: state_type > $o ).

tff(pred_def_47806,type,
    v88784: state_type > $o ).

tff(pred_def_47807,type,
    v88796: state_type > $o ).

tff(pred_def_47808,type,
    v88797: state_type > $o ).

tff(pred_def_47809,type,
    v88795: state_type > $o ).

tff(pred_def_47810,type,
    v88792: ( state_type * $int ) > $o ).

tff(pred_def_47811,type,
    v88794: ( state_type * $int ) > $o ).

tff(pred_def_47812,type,
    v88643: ( state_type * $int ) > $o ).

tff(pred_def_47813,type,
    v88641: ( state_type * $int ) > $o ).

tff(pred_def_47814,type,
    v88805: state_type > $o ).

tff(pred_def_47815,type,
    v88804: state_type > $o ).

tff(pred_def_47816,type,
    v88615: state_type > $o ).

tff(pred_def_47817,type,
    v88808: state_type > $o ).

tff(pred_def_47818,type,
    v88807: state_type > $o ).

tff(pred_def_47819,type,
    v88806: state_type > $o ).

tff(pred_def_47820,type,
    v88803: state_type > $o ).

tff(pred_def_47821,type,
    b11001000: $int > $o ).

tff(pred_def_47822,type,
    v88811: state_type > $o ).

tff(pred_def_47823,type,
    v88812: state_type > $o ).

tff(pred_def_47824,type,
    v88810: state_type > $o ).

tff(pred_def_47825,type,
    v88809: state_type > $o ).

tff(pred_def_47826,type,
    v88802: state_type > $o ).

tff(pred_def_47827,type,
    v88816: ( state_type * $int ) > $o ).

tff(pred_def_47828,type,
    v88815: state_type > $o ).

tff(pred_def_47829,type,
    v88814: state_type > $o ).

tff(pred_def_47830,type,
    v88817: state_type > $o ).

tff(pred_def_47831,type,
    v88818: state_type > $o ).

tff(pred_def_47832,type,
    v88813: state_type > $o ).

tff(pred_def_47833,type,
    v88392: ( state_type * $int ) > $o ).

tff(pred_def_47834,type,
    v88390: ( state_type * $int ) > $o ).

tff(pred_def_47835,type,
    v88388: ( state_type * $int ) > $o ).

tff(pred_def_47836,type,
    v88386: ( state_type * $int ) > $o ).

tff(pred_def_47837,type,
    v88822: state_type > $o ).

tff(pred_def_47838,type,
    v88820: state_type > $o ).

tff(pred_def_47839,type,
    v88829: state_type > $o ).

tff(pred_def_47840,type,
    v88827: state_type > $o ).

tff(pred_def_47841,type,
    v88826: state_type > $o ).

tff(pred_def_47842,type,
    v88825: state_type > $o ).

tff(pred_def_47843,type,
    v88837: state_type > $o ).

tff(pred_def_47844,type,
    v88838: state_type > $o ).

tff(pred_def_47845,type,
    v88836: state_type > $o ).

tff(pred_def_47846,type,
    v88833: ( state_type * $int ) > $o ).

tff(pred_def_47847,type,
    v88835: ( state_type * $int ) > $o ).

tff(pred_def_47848,type,
    v88824: ( state_type * $int ) > $o ).

tff(pred_def_47849,type,
    v88376: ( state_type * $int ) > $o ).

tff(pred_def_47850,type,
    v88374: ( state_type * $int ) > $o ).

tff(pred_def_47851,type,
    v88844: state_type > $o ).

tff(pred_def_47852,type,
    v88843: state_type > $o ).

tff(pred_def_47853,type,
    v88842: state_type > $o ).

tff(pred_def_47854,type,
    v88637: state_type > $o ).

tff(pred_def_47855,type,
    v88849: ( state_type * $int ) > $o ).

tff(pred_def_47856,type,
    v88848: state_type > $o ).

tff(pred_def_47857,type,
    v88847: state_type > $o ).

tff(pred_def_47858,type,
    v88846: state_type > $o ).

tff(pred_def_47859,type,
    v88635: state_type > $o ).

tff(pred_def_47860,type,
    v88633: state_type > $o ).

tff(pred_def_47861,type,
    v88631: state_type > $o ).

tff(pred_def_47862,type,
    v88629: state_type > $o ).

tff(pred_def_47863,type,
    v88853: state_type > $o ).

tff(pred_def_47864,type,
    v88851: state_type > $o ).

tff(pred_def_47865,type,
    v88860: state_type > $o ).

tff(pred_def_47866,type,
    v88858: state_type > $o ).

tff(pred_def_47867,type,
    v88857: state_type > $o ).

tff(pred_def_47868,type,
    v88856: state_type > $o ).

tff(pred_def_47869,type,
    v88868: state_type > $o ).

tff(pred_def_47870,type,
    v88869: state_type > $o ).

tff(pred_def_47871,type,
    v88867: state_type > $o ).

tff(pred_def_47872,type,
    v88864: state_type > $o ).

tff(pred_def_47873,type,
    v88866: state_type > $o ).

tff(pred_def_47874,type,
    v88619: state_type > $o ).

tff(pred_def_47875,type,
    v88617: state_type > $o ).

tff(pred_def_47876,type,
    v88875: state_type > $o ).

tff(pred_def_47877,type,
    v88877: state_type > $o ).

tff(pred_def_47878,type,
    v88876: state_type > $o ).

tff(pred_def_47879,type,
    v88874: state_type > $o ).

tff(pred_def_47880,type,
    v88880: state_type > $o ).

tff(pred_def_47881,type,
    v88879: state_type > $o ).

tff(pred_def_47882,type,
    v88878: state_type > $o ).

tff(pred_def_47883,type,
    v88873: state_type > $o ).

tff(pred_def_47884,type,
    v88893: state_type > $o ).

tff(pred_def_47885,type,
    v88894: state_type > $o ).

tff(pred_def_47886,type,
    v88892: state_type > $o ).

tff(pred_def_47887,type,
    v88891: ( state_type * $int ) > $o ).

tff(pred_def_47888,type,
    v88890: state_type > $o ).

tff(pred_def_47889,type,
    v88897: state_type > $o ).

tff(pred_def_47890,type,
    v88898: state_type > $o ).

tff(pred_def_47891,type,
    v88896: state_type > $o ).

tff(pred_def_47892,type,
    v88899: state_type > $o ).

tff(pred_def_47893,type,
    v88895: state_type > $o ).

tff(pred_def_47894,type,
    v88889: state_type > $o ).

tff(pred_def_47895,type,
    v88900: state_type > $o ).

tff(pred_def_47896,type,
    v88888: state_type > $o ).

tff(pred_def_47897,type,
    v88887: state_type > $o ).

tff(pred_def_47898,type,
    v88904: state_type > $o ).

tff(pred_def_47899,type,
    v88905: state_type > $o ).

tff(pred_def_47900,type,
    v88903: state_type > $o ).

tff(pred_def_47901,type,
    v88906: state_type > $o ).

tff(pred_def_47902,type,
    v88902: state_type > $o ).

tff(pred_def_47903,type,
    v88901: state_type > $o ).

tff(pred_def_47904,type,
    v88886: state_type > $o ).

tff(pred_def_47905,type,
    v88907: state_type > $o ).

tff(pred_def_47906,type,
    v88885: state_type > $o ).

tff(pred_def_47907,type,
    v88910: state_type > $o ).

tff(pred_def_47908,type,
    v88911: state_type > $o ).

tff(pred_def_47909,type,
    v88909: state_type > $o ).

tff(pred_def_47910,type,
    v88912: state_type > $o ).

tff(pred_def_47911,type,
    v88908: state_type > $o ).

tff(pred_def_47912,type,
    v88915: state_type > $o ).

tff(pred_def_47913,type,
    v88916: state_type > $o ).

tff(pred_def_47914,type,
    v88914: state_type > $o ).

tff(pred_def_47915,type,
    v88917: state_type > $o ).

tff(pred_def_47916,type,
    v88913: state_type > $o ).

tff(pred_def_47917,type,
    v88883: ( state_type * $int ) > $o ).

tff(pred_def_47918,type,
    v88882: ( state_type * $int ) > $o ).

tff(pred_def_47919,type,
    v88929: state_type > $o ).

tff(pred_def_47920,type,
    v88930: state_type > $o ).

tff(pred_def_47921,type,
    v88928: state_type > $o ).

tff(pred_def_47922,type,
    v88927: ( state_type * $int ) > $o ).

tff(pred_def_47923,type,
    v88926: state_type > $o ).

tff(pred_def_47924,type,
    v88933: state_type > $o ).

tff(pred_def_47925,type,
    v88932: state_type > $o ).

tff(pred_def_47926,type,
    v88934: state_type > $o ).

tff(pred_def_47927,type,
    v88931: state_type > $o ).

tff(pred_def_47928,type,
    v88925: state_type > $o ).

tff(pred_def_47929,type,
    v88935: state_type > $o ).

tff(pred_def_47930,type,
    v88924: state_type > $o ).

tff(pred_def_47931,type,
    v88923: state_type > $o ).

tff(pred_def_47932,type,
    v88939: state_type > $o ).

tff(pred_def_47933,type,
    v88938: state_type > $o ).

tff(pred_def_47934,type,
    v88940: state_type > $o ).

tff(pred_def_47935,type,
    v88937: state_type > $o ).

tff(pred_def_47936,type,
    v88936: state_type > $o ).

tff(pred_def_47937,type,
    v88922: state_type > $o ).

tff(pred_def_47938,type,
    v88941: state_type > $o ).

tff(pred_def_47939,type,
    v88921: state_type > $o ).

tff(pred_def_47940,type,
    v88944: state_type > $o ).

tff(pred_def_47941,type,
    v88945: state_type > $o ).

tff(pred_def_47942,type,
    v88943: state_type > $o ).

tff(pred_def_47943,type,
    v88946: state_type > $o ).

tff(pred_def_47944,type,
    v88942: state_type > $o ).

tff(pred_def_47945,type,
    v88949: state_type > $o ).

tff(pred_def_47946,type,
    v88948: state_type > $o ).

tff(pred_def_47947,type,
    v88950: state_type > $o ).

tff(pred_def_47948,type,
    v88947: state_type > $o ).

tff(pred_def_47949,type,
    v88919: ( state_type * $int ) > $o ).

tff(pred_def_47950,type,
    v88918: ( state_type * $int ) > $o ).

tff(pred_def_47951,type,
    v88962: state_type > $o ).

tff(pred_def_47952,type,
    v88963: state_type > $o ).

tff(pred_def_47953,type,
    v88961: state_type > $o ).

tff(pred_def_47954,type,
    v88960: ( state_type * $int ) > $o ).

tff(pred_def_47955,type,
    v88959: state_type > $o ).

tff(pred_def_47956,type,
    v88966: state_type > $o ).

tff(pred_def_47957,type,
    v88965: state_type > $o ).

tff(pred_def_47958,type,
    v88967: state_type > $o ).

tff(pred_def_47959,type,
    v88964: state_type > $o ).

tff(pred_def_47960,type,
    v88958: state_type > $o ).

tff(pred_def_47961,type,
    v88968: state_type > $o ).

tff(pred_def_47962,type,
    v88957: state_type > $o ).

tff(pred_def_47963,type,
    v88956: state_type > $o ).

tff(pred_def_47964,type,
    v88972: state_type > $o ).

tff(pred_def_47965,type,
    v88971: state_type > $o ).

tff(pred_def_47966,type,
    v88973: state_type > $o ).

tff(pred_def_47967,type,
    v88970: state_type > $o ).

tff(pred_def_47968,type,
    v88969: state_type > $o ).

tff(pred_def_47969,type,
    v88955: state_type > $o ).

tff(pred_def_47970,type,
    v88974: state_type > $o ).

tff(pred_def_47971,type,
    v88954: state_type > $o ).

tff(pred_def_47972,type,
    v88977: state_type > $o ).

tff(pred_def_47973,type,
    v88978: state_type > $o ).

tff(pred_def_47974,type,
    v88976: state_type > $o ).

tff(pred_def_47975,type,
    v88979: state_type > $o ).

tff(pred_def_47976,type,
    v88975: state_type > $o ).

tff(pred_def_47977,type,
    v88982: state_type > $o ).

tff(pred_def_47978,type,
    v88981: state_type > $o ).

tff(pred_def_47979,type,
    v88983: state_type > $o ).

tff(pred_def_47980,type,
    v88980: state_type > $o ).

tff(pred_def_47981,type,
    v88952: ( state_type * $int ) > $o ).

tff(pred_def_47982,type,
    v88951: ( state_type * $int ) > $o ).

tff(pred_def_47983,type,
    v88881: ( state_type * $int ) > $o ).

tff(pred_def_47984,type,
    v88987: state_type > $o ).

tff(pred_def_47985,type,
    v88989: state_type > $o ).

tff(pred_def_47986,type,
    v88988: state_type > $o ).

tff(pred_def_47987,type,
    v88986: state_type > $o ).

tff(pred_def_47988,type,
    v88992: state_type > $o ).

tff(pred_def_47989,type,
    v88991: state_type > $o ).

tff(pred_def_47990,type,
    v88990: state_type > $o ).

tff(pred_def_47991,type,
    v88985: state_type > $o ).

tff(pred_def_47992,type,
    v88995: state_type > $o ).

tff(pred_def_47993,type,
    v88994: state_type > $o ).

tff(pred_def_47994,type,
    v88997: state_type > $o ).

tff(pred_def_47995,type,
    v88996: state_type > $o ).

tff(pred_def_47996,type,
    v88999: state_type > $o ).

tff(pred_def_47997,type,
    v88998: state_type > $o ).

tff(pred_def_47998,type,
    v88993: state_type > $o ).

tff(pred_def_47999,type,
    v89005: state_type > $o ).

tff(pred_def_48000,type,
    v89003: state_type > $o ).

tff(pred_def_48001,type,
    v89002: state_type > $o ).

tff(pred_def_48002,type,
    v89001: ( state_type * $int ) > $o ).

tff(pred_def_48003,type,
    v89011: state_type > $o ).

tff(pred_def_48004,type,
    v89010: state_type > $o ).

tff(pred_def_48005,type,
    v89012: state_type > $o ).

tff(pred_def_48006,type,
    v89009: state_type > $o ).

tff(pred_def_48007,type,
    v89016: state_type > $o ).

tff(pred_def_48008,type,
    v89015: state_type > $o ).

tff(pred_def_48009,type,
    v89014: state_type > $o ).

tff(pred_def_48010,type,
    v89020: state_type > $o ).

tff(pred_def_48011,type,
    v89019: state_type > $o ).

tff(pred_def_48012,type,
    v89023: state_type > $o ).

tff(pred_def_48013,type,
    v89022: state_type > $o ).

tff(pred_def_48014,type,
    v89021: state_type > $o ).

tff(pred_def_48015,type,
    v89018: state_type > $o ).

tff(pred_def_48016,type,
    v89027: state_type > $o ).

tff(pred_def_48017,type,
    v89026: state_type > $o ).

tff(pred_def_48018,type,
    v89030: state_type > $o ).

tff(pred_def_48019,type,
    v89029: state_type > $o ).

tff(pred_def_48020,type,
    v89028: state_type > $o ).

tff(pred_def_48021,type,
    v89025: state_type > $o ).

tff(pred_def_48022,type,
    v89034: state_type > $o ).

tff(pred_def_48023,type,
    v89033: state_type > $o ).

tff(pred_def_48024,type,
    v89037: state_type > $o ).

tff(pred_def_48025,type,
    v89036: state_type > $o ).

tff(pred_def_48026,type,
    v89035: state_type > $o ).

tff(pred_def_48027,type,
    v89032: state_type > $o ).

tff(pred_def_48028,type,
    v89040: state_type > $o ).

tff(pred_def_48029,type,
    v89039: state_type > $o ).

tff(pred_def_48030,type,
    v89038: state_type > $o ).

tff(pred_def_48031,type,
    v89031: state_type > $o ).

tff(pred_def_48032,type,
    v89024: state_type > $o ).

tff(pred_def_48033,type,
    v89017: state_type > $o ).

tff(pred_def_48034,type,
    v89013: state_type > $o ).

tff(pred_def_48035,type,
    v89050: state_type > $o ).

tff(pred_def_48036,type,
    v89048: state_type > $o ).

tff(pred_def_48037,type,
    v89047: state_type > $o ).

tff(pred_def_48038,type,
    v89046: ( state_type * $int ) > $o ).

tff(pred_def_48039,type,
    v89042: state_type > $o ).

tff(pred_def_48040,type,
    v89062: state_type > $o ).

tff(pred_def_48041,type,
    v89060: state_type > $o ).

tff(pred_def_48042,type,
    v89059: state_type > $o ).

tff(pred_def_48043,type,
    v89058: ( state_type * $int ) > $o ).

tff(pred_def_48044,type,
    v89054: state_type > $o ).

tff(pred_def_48045,type,
    v89068: state_type > $o ).

tff(pred_def_48046,type,
    v89067: state_type > $o ).

tff(pred_def_48047,type,
    v89066: state_type > $o ).

tff(pred_def_48048,type,
    v89071: state_type > $o ).

tff(pred_def_48049,type,
    v89070: state_type > $o ).

tff(pred_def_48050,type,
    v89069: state_type > $o ).

tff(pred_def_48051,type,
    v89073: state_type > $o ).

tff(pred_def_48052,type,
    v89074: state_type > $o ).

tff(pred_def_48053,type,
    v89075: state_type > $o ).

tff(pred_def_48054,type,
    v89076: state_type > $o ).

tff(pred_def_48055,type,
    v89077: state_type > $o ).

tff(pred_def_48056,type,
    v89078: state_type > $o ).

tff(pred_def_48057,type,
    v89079: state_type > $o ).

tff(pred_def_48058,type,
    v89080: state_type > $o ).

tff(pred_def_48059,type,
    v89072: ( state_type * $int ) > $o ).

tff(pred_def_48060,type,
    v84297: ( state_type * $int ) > $o ).

tff(pred_def_48061,type,
    v89096: ( state_type * $int ) > $o ).

tff(pred_def_48062,type,
    v89095: state_type > $o ).

tff(pred_def_48063,type,
    v89094: state_type > $o ).

tff(pred_def_48064,type,
    v89097: state_type > $o ).

tff(pred_def_48065,type,
    v89093: state_type > $o ).

tff(pred_def_48066,type,
    v89092: state_type > $o ).

tff(pred_def_48067,type,
    v89101: state_type > $o ).

tff(pred_def_48068,type,
    v89100: state_type > $o ).

tff(pred_def_48069,type,
    v89102: state_type > $o ).

tff(pred_def_48070,type,
    v89099: state_type > $o ).

tff(pred_def_48071,type,
    v89098: state_type > $o ).

tff(pred_def_48072,type,
    v89091: state_type > $o ).

tff(pred_def_48073,type,
    v89106: state_type > $o ).

tff(pred_def_48074,type,
    v89105: state_type > $o ).

tff(pred_def_48075,type,
    v89107: state_type > $o ).

tff(pred_def_48076,type,
    v89104: state_type > $o ).

tff(pred_def_48077,type,
    v89103: state_type > $o ).

tff(pred_def_48078,type,
    v89090: state_type > $o ).

tff(pred_def_48079,type,
    v89111: state_type > $o ).

tff(pred_def_48080,type,
    v89112: state_type > $o ).

tff(pred_def_48081,type,
    v89110: state_type > $o ).

tff(pred_def_48082,type,
    v89113: state_type > $o ).

tff(pred_def_48083,type,
    v89109: state_type > $o ).

tff(pred_def_48084,type,
    v89108: state_type > $o ).

tff(pred_def_48085,type,
    v89089: state_type > $o ).

tff(pred_def_48086,type,
    v89087: state_type > $o ).

tff(pred_def_48087,type,
    v89114: state_type > $o ).

tff(pred_def_48088,type,
    v89086: state_type > $o ).

tff(pred_def_48089,type,
    v89115: state_type > $o ).

tff(pred_def_48090,type,
    v89085: state_type > $o ).

tff(pred_def_48091,type,
    v89084: state_type > $o ).

tff(pred_def_48092,type,
    v89083: state_type > $o ).

tff(pred_def_48093,type,
    v89082: ( state_type * $int ) > $o ).

tff(pred_def_48094,type,
    v86881: ( state_type * $int ) > $o ).

tff(pred_def_48095,type,
    v89122: ( state_type * $int ) > $o ).

tff(pred_def_48096,type,
    v89121: state_type > $o ).

tff(pred_def_48097,type,
    v89124: ( state_type * $int ) > $o ).

tff(pred_def_48098,type,
    v89123: state_type > $o ).

tff(pred_def_48099,type,
    v89126: ( state_type * $int ) > $o ).

tff(pred_def_48100,type,
    v89125: state_type > $o ).

tff(pred_def_48101,type,
    v89128: ( state_type * $int ) > $o ).

tff(pred_def_48102,type,
    v89127: state_type > $o ).

tff(pred_def_48103,type,
    v89130: ( state_type * $int ) > $o ).

tff(pred_def_48104,type,
    v89129: state_type > $o ).

tff(pred_def_48105,type,
    v89132: ( state_type * $int ) > $o ).

tff(pred_def_48106,type,
    v89131: state_type > $o ).

tff(pred_def_48107,type,
    v89134: ( state_type * $int ) > $o ).

tff(pred_def_48108,type,
    v89133: state_type > $o ).

tff(pred_def_48109,type,
    v89136: ( state_type * $int ) > $o ).

tff(pred_def_48110,type,
    v89135: state_type > $o ).

tff(pred_def_48111,type,
    v89138: ( state_type * $int ) > $o ).

tff(pred_def_48112,type,
    v89137: state_type > $o ).

tff(pred_def_48113,type,
    v89140: ( state_type * $int ) > $o ).

tff(pred_def_48114,type,
    v89139: state_type > $o ).

tff(pred_def_48115,type,
    v89142: ( state_type * $int ) > $o ).

tff(pred_def_48116,type,
    v89141: state_type > $o ).

tff(pred_def_48117,type,
    v89144: ( state_type * $int ) > $o ).

tff(pred_def_48118,type,
    v89143: state_type > $o ).

tff(pred_def_48119,type,
    v89146: ( state_type * $int ) > $o ).

tff(pred_def_48120,type,
    v89145: state_type > $o ).

tff(pred_def_48121,type,
    v89148: ( state_type * $int ) > $o ).

tff(pred_def_48122,type,
    v89147: state_type > $o ).

tff(pred_def_48123,type,
    v89150: ( state_type * $int ) > $o ).

tff(pred_def_48124,type,
    v89149: state_type > $o ).

tff(pred_def_48125,type,
    v89152: ( state_type * $int ) > $o ).

tff(pred_def_48126,type,
    v89151: state_type > $o ).

tff(pred_def_48127,type,
    v89119: ( state_type * $int ) > $o ).

tff(pred_def_48128,type,
    v89172: state_type > $o ).

tff(pred_def_48129,type,
    v89170: state_type > $o ).

tff(pred_def_48130,type,
    v89168: state_type > $o ).

tff(pred_def_48131,type,
    v89166: state_type > $o ).

tff(pred_def_48132,type,
    v89180: state_type > $o ).

tff(pred_def_48133,type,
    v89178: state_type > $o ).

tff(pred_def_48134,type,
    v89176: state_type > $o ).

tff(pred_def_48135,type,
    v89174: state_type > $o ).

tff(pred_def_48136,type,
    v89198: state_type > $o ).

tff(pred_def_48137,type,
    v89196: state_type > $o ).

tff(pred_def_48138,type,
    v89202: state_type > $o ).

tff(pred_def_48139,type,
    v89200: state_type > $o ).

tff(pred_def_48140,type,
    v89227: ( state_type * $int ) > $o ).

tff(pred_def_48141,type,
    v89226: ( state_type * $int ) > $o ).

tff(pred_def_48142,type,
    v89229: ( state_type * $int ) > $o ).

tff(pred_def_48143,type,
    v89228: ( state_type * $int ) > $o ).

tff(pred_def_48144,type,
    v89225: ( state_type * $int ) > $o ).

tff(pred_def_48145,type,
    v89231: ( state_type * $int ) > $o ).

tff(pred_def_48146,type,
    v89230: ( state_type * $int ) > $o ).

tff(pred_def_48147,type,
    v89224: ( state_type * $int ) > $o ).

tff(pred_def_48148,type,
    v89233: ( state_type * $int ) > $o ).

tff(pred_def_48149,type,
    v89232: ( state_type * $int ) > $o ).

tff(pred_def_48150,type,
    v89223: ( state_type * $int ) > $o ).

tff(pred_def_48151,type,
    v89235: ( state_type * $int ) > $o ).

tff(pred_def_48152,type,
    v89234: ( state_type * $int ) > $o ).

tff(pred_def_48153,type,
    v89222: ( state_type * $int ) > $o ).

tff(pred_def_48154,type,
    v89237: ( state_type * $int ) > $o ).

tff(pred_def_48155,type,
    v89236: ( state_type * $int ) > $o ).

tff(pred_def_48156,type,
    v89221: ( state_type * $int ) > $o ).

tff(pred_def_48157,type,
    v89239: ( state_type * $int ) > $o ).

tff(pred_def_48158,type,
    v89238: ( state_type * $int ) > $o ).

tff(pred_def_48159,type,
    v89220: ( state_type * $int ) > $o ).

tff(pred_def_48160,type,
    v89241: ( state_type * $int ) > $o ).

tff(pred_def_48161,type,
    v89240: ( state_type * $int ) > $o ).

tff(pred_def_48162,type,
    v89219: ( state_type * $int ) > $o ).

tff(pred_def_48163,type,
    v89218: ( state_type * $int ) > $o ).

tff(pred_def_48164,type,
    v89216: ( state_type * $int ) > $o ).

tff(pred_def_48165,type,
    v89214: ( state_type * $int ) > $o ).

tff(pred_def_48166,type,
    v89251: ( state_type * $int ) > $o ).

tff(pred_def_48167,type,
    v84901: ( state_type * $int ) > $o ).

tff(pred_def_48168,type,
    v89249: ( state_type * $int ) > $o ).

tff(pred_def_48169,type,
    v89261: state_type > $o ).

tff(pred_def_48170,type,
    v89259: state_type > $o ).

tff(pred_def_48171,type,
    v89265: state_type > $o ).

tff(pred_def_48172,type,
    v89263: state_type > $o ).

tff(pred_def_48173,type,
    v89285: state_type > $o ).

tff(pred_def_48174,type,
    v89283: state_type > $o ).

tff(pred_def_48175,type,
    v89289: state_type > $o ).

tff(pred_def_48176,type,
    v89287: state_type > $o ).

tff(pred_def_48177,type,
    v89305: ( state_type * $int ) > $o ).

tff(pred_def_48178,type,
    v89303: ( state_type * $int ) > $o ).

tff(pred_def_48179,type,
    v89301: ( state_type * $int ) > $o ).

tff(pred_def_48180,type,
    v89299: ( state_type * $int ) > $o ).

tff(pred_def_48181,type,
    v89297: ( state_type * $int ) > $o ).

tff(pred_def_48182,type,
    v89307: state_type > $o ).

tff(pred_def_48183,type,
    v89306: ( state_type * $int ) > $o ).

tff(pred_def_48184,type,
    v89308: state_type > $o ).

tff(pred_def_48185,type,
    v89309: state_type > $o ).

tff(pred_def_48186,type,
    v89310: ( state_type * $int ) > $o ).

tff(pred_def_48187,type,
    v89295: ( state_type * $int ) > $o ).

tff(pred_def_48188,type,
    v89293: ( state_type * $int ) > $o ).

tff(pred_def_48189,type,
    v89291: ( state_type * $int ) > $o ).

tff(pred_def_48190,type,
    v89314: state_type > $o ).

tff(pred_def_48191,type,
    v89312: state_type > $o ).

tff(pred_def_48192,type,
    v89321: state_type > $o ).

tff(pred_def_48193,type,
    v89319: state_type > $o ).

tff(pred_def_48194,type,
    v89318: state_type > $o ).

tff(pred_def_48195,type,
    v89317: state_type > $o ).

tff(pred_def_48196,type,
    v89329: state_type > $o ).

tff(pred_def_48197,type,
    v89330: state_type > $o ).

tff(pred_def_48198,type,
    v89328: state_type > $o ).

tff(pred_def_48199,type,
    v89325: ( state_type * $int ) > $o ).

tff(pred_def_48200,type,
    v89327: ( state_type * $int ) > $o ).

tff(pred_def_48201,type,
    v89316: ( state_type * $int ) > $o ).

tff(pred_def_48202,type,
    v89281: ( state_type * $int ) > $o ).

tff(pred_def_48203,type,
    v89279: ( state_type * $int ) > $o ).

tff(pred_def_48204,type,
    v89277: ( state_type * $int ) > $o ).

tff(pred_def_48205,type,
    v89334: ( state_type * $int ) > $o ).

tff(pred_def_48206,type,
    v89333: ( state_type * $int ) > $o ).

tff(pred_def_48207,type,
    v89335: state_type > $o ).

tff(pred_def_48208,type,
    v89275: ( state_type * $int ) > $o ).

tff(pred_def_48209,type,
    v89273: ( state_type * $int ) > $o ).

tff(pred_def_48210,type,
    v89271: ( state_type * $int ) > $o ).

tff(pred_def_48211,type,
    v136: ( state_type * $int ) > $o ).

tff(pred_def_48212,type,
    v89354: state_type > $o ).

tff(pred_def_48213,type,
    v89353: ( state_type * $int ) > $o ).

tff(pred_def_48214,type,
    v89352: ( state_type * $int ) > $o ).

tff(pred_def_48215,type,
    v89358: state_type > $o ).

tff(pred_def_48216,type,
    v89357: state_type > $o ).

tff(pred_def_48217,type,
    v89356: ( state_type * $int ) > $o ).

tff(pred_def_48218,type,
    v89355: ( state_type * $int ) > $o ).

tff(pred_def_48219,type,
    v89351: ( state_type * $int ) > $o ).

tff(pred_def_48220,type,
    v89350: ( state_type * $int ) > $o ).

tff(pred_def_48221,type,
    v89362: state_type > $o ).

tff(pred_def_48222,type,
    v89361: state_type > $o ).

tff(pred_def_48223,type,
    v89360: ( state_type * $int ) > $o ).

tff(pred_def_48224,type,
    v89359: ( state_type * $int ) > $o ).

tff(pred_def_48225,type,
    v89349: ( state_type * $int ) > $o ).

tff(pred_def_48226,type,
    v89348: ( state_type * $int ) > $o ).

tff(pred_def_48227,type,
    v89366: state_type > $o ).

tff(pred_def_48228,type,
    v89365: state_type > $o ).

tff(pred_def_48229,type,
    v89364: ( state_type * $int ) > $o ).

tff(pred_def_48230,type,
    v89363: ( state_type * $int ) > $o ).

tff(pred_def_48231,type,
    v89347: ( state_type * $int ) > $o ).

tff(pred_def_48232,type,
    v89346: ( state_type * $int ) > $o ).

tff(pred_def_48233,type,
    v89370: state_type > $o ).

tff(pred_def_48234,type,
    v89369: state_type > $o ).

tff(pred_def_48235,type,
    v89368: ( state_type * $int ) > $o ).

tff(pred_def_48236,type,
    v89367: ( state_type * $int ) > $o ).

tff(pred_def_48237,type,
    v89345: ( state_type * $int ) > $o ).

tff(pred_def_48238,type,
    v89344: ( state_type * $int ) > $o ).

tff(pred_def_48239,type,
    v89374: state_type > $o ).

tff(pred_def_48240,type,
    v89373: state_type > $o ).

tff(pred_def_48241,type,
    v89372: ( state_type * $int ) > $o ).

tff(pred_def_48242,type,
    v89371: ( state_type * $int ) > $o ).

tff(pred_def_48243,type,
    v89343: ( state_type * $int ) > $o ).

tff(pred_def_48244,type,
    v89342: ( state_type * $int ) > $o ).

tff(pred_def_48245,type,
    v89378: state_type > $o ).

tff(pred_def_48246,type,
    v89377: state_type > $o ).

tff(pred_def_48247,type,
    v89376: ( state_type * $int ) > $o ).

tff(pred_def_48248,type,
    v89375: ( state_type * $int ) > $o ).

tff(pred_def_48249,type,
    v89341: ( state_type * $int ) > $o ).

tff(pred_def_48250,type,
    v89381: state_type > $o ).

tff(pred_def_48251,type,
    v89380: state_type > $o ).

tff(pred_def_48252,type,
    v89379: ( state_type * $int ) > $o ).

tff(pred_def_48253,type,
    v89340: ( state_type * $int ) > $o ).

tff(pred_def_48254,type,
    v134: ( state_type * $int ) > $o ).

tff(pred_def_48255,type,
    v89391: state_type > $o ).

tff(pred_def_48256,type,
    v89389: state_type > $o ).

tff(pred_def_48257,type,
    v89395: state_type > $o ).

tff(pred_def_48258,type,
    v89393: state_type > $o ).

tff(pred_def_48259,type,
    v89427: state_type > $o ).

tff(pred_def_48260,type,
    v89425: state_type > $o ).

tff(pred_def_48261,type,
    v89431: state_type > $o ).

tff(pred_def_48262,type,
    v89429: state_type > $o ).

tff(pred_def_48263,type,
    v89451: state_type > $o ).

tff(pred_def_48264,type,
    v89449: state_type > $o ).

tff(pred_def_48265,type,
    v89455: state_type > $o ).

tff(pred_def_48266,type,
    v89453: state_type > $o ).

tff(pred_def_48267,type,
    v89474: state_type > $o ).

tff(pred_def_48268,type,
    v89480: state_type > $o ).

tff(pred_def_48269,type,
    v89478: state_type > $o ).

tff(pred_def_48270,type,
    v89477: state_type > $o ).

tff(pred_def_48271,type,
    v89476: ( state_type * $int ) > $o ).

tff(pred_def_48272,type,
    v89471: state_type > $o ).

tff(pred_def_48273,type,
    v89469: state_type > $o ).

tff(pred_def_48274,type,
    v89467: state_type > $o ).

tff(pred_def_48275,type,
    v89465: state_type > $o ).

tff(pred_def_48276,type,
    v89463: state_type > $o ).

tff(pred_def_48277,type,
    v89484: state_type > $o ).

tff(pred_def_48278,type,
    v89483: ( state_type * $int ) > $o ).

tff(pred_def_48279,type,
    v89485: state_type > $o ).

tff(pred_def_48280,type,
    v89486: ( state_type * $int ) > $o ).

tff(pred_def_48281,type,
    v89487: ( state_type * $int ) > $o ).

tff(pred_def_48282,type,
    v89461: ( state_type * $int ) > $o ).

tff(pred_def_48283,type,
    v89459: ( state_type * $int ) > $o ).

tff(pred_def_48284,type,
    v89457: ( state_type * $int ) > $o ).

tff(pred_def_48285,type,
    v89491: state_type > $o ).

tff(pred_def_48286,type,
    v89489: state_type > $o ).

tff(pred_def_48287,type,
    v89498: state_type > $o ).

tff(pred_def_48288,type,
    v89496: state_type > $o ).

tff(pred_def_48289,type,
    v89495: state_type > $o ).

tff(pred_def_48290,type,
    v89494: state_type > $o ).

tff(pred_def_48291,type,
    v89506: state_type > $o ).

tff(pred_def_48292,type,
    v89507: state_type > $o ).

tff(pred_def_48293,type,
    v89505: state_type > $o ).

tff(pred_def_48294,type,
    v89502: ( state_type * $int ) > $o ).

tff(pred_def_48295,type,
    v89504: ( state_type * $int ) > $o ).

tff(pred_def_48296,type,
    v89493: ( state_type * $int ) > $o ).

tff(pred_def_48297,type,
    v89447: ( state_type * $int ) > $o ).

tff(pred_def_48298,type,
    v89445: ( state_type * $int ) > $o ).

tff(pred_def_48299,type,
    v89443: ( state_type * $int ) > $o ).

tff(pred_def_48300,type,
    v89419: ( state_type * $int ) > $o ).

tff(pred_def_48301,type,
    v89512: state_type > $o ).

tff(pred_def_48302,type,
    v89511: state_type > $o ).

tff(pred_def_48303,type,
    v89513: state_type > $o ).

tff(pred_def_48304,type,
    v89441: state_type > $o ).

tff(pred_def_48305,type,
    v89539: state_type > $o ).

tff(pred_def_48306,type,
    v89537: state_type > $o ).

tff(pred_def_48307,type,
    v89543: state_type > $o ).

tff(pred_def_48308,type,
    v89541: state_type > $o ).

tff(pred_def_48309,type,
    v89554: state_type > $o ).

tff(pred_def_48310,type,
    v89553: state_type > $o ).

tff(pred_def_48311,type,
    v89531: state_type > $o ).

tff(pred_def_48312,type,
    v89551: state_type > $o ).

tff(pred_def_48313,type,
    v89549: state_type > $o ).

tff(pred_def_48314,type,
    v89547: state_type > $o ).

tff(pred_def_48315,type,
    v89545: state_type > $o ).

tff(pred_def_48316,type,
    v89558: state_type > $o ).

tff(pred_def_48317,type,
    v89556: state_type > $o ).

tff(pred_def_48318,type,
    v89565: state_type > $o ).

tff(pred_def_48319,type,
    v89563: state_type > $o ).

tff(pred_def_48320,type,
    v89562: state_type > $o ).

tff(pred_def_48321,type,
    v89561: state_type > $o ).

tff(pred_def_48322,type,
    v89573: state_type > $o ).

tff(pred_def_48323,type,
    v89574: state_type > $o ).

tff(pred_def_48324,type,
    v89572: state_type > $o ).

tff(pred_def_48325,type,
    v89569: state_type > $o ).

tff(pred_def_48326,type,
    v89571: state_type > $o ).

tff(pred_def_48327,type,
    v89535: state_type > $o ).

tff(pred_def_48328,type,
    v89533: state_type > $o ).

tff(pred_def_48329,type,
    v89529: state_type > $o ).

tff(pred_def_48330,type,
    v89527: state_type > $o ).

tff(pred_def_48331,type,
    v89525: state_type > $o ).

tff(pred_def_48332,type,
    v89523: state_type > $o ).

tff(pred_def_48333,type,
    v89592: state_type > $o ).

tff(pred_def_48334,type,
    v89590: state_type > $o ).

tff(pred_def_48335,type,
    v89588: state_type > $o ).

tff(pred_def_48336,type,
    v89586: state_type > $o ).

tff(pred_def_48337,type,
    v89600: state_type > $o ).

tff(pred_def_48338,type,
    v89598: state_type > $o ).

tff(pred_def_48339,type,
    v89596: state_type > $o ).

tff(pred_def_48340,type,
    v89594: state_type > $o ).

tff(pred_def_48341,type,
    v89608: ( state_type * $int ) > $o ).

tff(pred_def_48342,type,
    v89607: ( state_type * $int ) > $o ).

tff(pred_def_48343,type,
    v89578: ( state_type * $int ) > $o ).

tff(pred_def_48344,type,
    v89606: ( state_type * $int ) > $o ).

tff(pred_def_48345,type,
    v89632: state_type > $o ).

tff(pred_def_48346,type,
    v89630: state_type > $o ).

tff(pred_def_48347,type,
    v89636: state_type > $o ).

tff(pred_def_48348,type,
    v89634: state_type > $o ).

tff(pred_def_48349,type,
    v89624: ( state_type * $int ) > $o ).

tff(pred_def_48350,type,
    v89651: state_type > $o ).

tff(pred_def_48351,type,
    v89650: state_type > $o ).

tff(pred_def_48352,type,
    v89649: state_type > $o ).

tff(pred_def_48353,type,
    v89652: state_type > $o ).

tff(pred_def_48354,type,
    v89648: state_type > $o ).

tff(pred_def_48355,type,
    v89653: state_type > $o ).

tff(pred_def_48356,type,
    v89647: state_type > $o ).

tff(pred_def_48357,type,
    v89656: state_type > $o ).

tff(pred_def_48358,type,
    v89657: state_type > $o ).

tff(pred_def_48359,type,
    v89655: state_type > $o ).

tff(pred_def_48360,type,
    v89658: state_type > $o ).

tff(pred_def_48361,type,
    v89654: state_type > $o ).

tff(pred_def_48362,type,
    v89661: state_type > $o ).

tff(pred_def_48363,type,
    v89662: state_type > $o ).

tff(pred_def_48364,type,
    v89660: state_type > $o ).

tff(pred_def_48365,type,
    v89663: state_type > $o ).

tff(pred_def_48366,type,
    v89659: state_type > $o ).

tff(pred_def_48367,type,
    v89644: ( state_type * $int ) > $o ).

tff(pred_def_48368,type,
    v89642: ( state_type * $int ) > $o ).

tff(pred_def_48369,type,
    v89671: state_type > $o ).

tff(pred_def_48370,type,
    v89682: state_type > $o ).

tff(pred_def_48371,type,
    v89680: state_type > $o ).

tff(pred_def_48372,type,
    v89686: state_type > $o ).

tff(pred_def_48373,type,
    v89684: state_type > $o ).

tff(pred_def_48374,type,
    v89708: state_type > $o ).

tff(pred_def_48375,type,
    v89706: state_type > $o ).

tff(pred_def_48376,type,
    v89712: state_type > $o ).

tff(pred_def_48377,type,
    v89710: state_type > $o ).

tff(pred_def_48378,type,
    v89750: state_type > $o ).

tff(pred_def_48379,type,
    v89748: state_type > $o ).

tff(pred_def_48380,type,
    v89754: state_type > $o ).

tff(pred_def_48381,type,
    v89752: state_type > $o ).

tff(pred_def_48382,type,
    v89758: state_type > $o ).

tff(pred_def_48383,type,
    v89756: state_type > $o ).

tff(pred_def_48384,type,
    v89760: state_type > $o ).

tff(pred_def_48385,type,
    v89746: state_type > $o ).

tff(pred_def_48386,type,
    v89744: state_type > $o ).

tff(pred_def_48387,type,
    v89742: state_type > $o ).

tff(pred_def_48388,type,
    v89740: state_type > $o ).

tff(pred_def_48389,type,
    v89738: state_type > $o ).

tff(pred_def_48390,type,
    v89764: state_type > $o ).

tff(pred_def_48391,type,
    v89762: state_type > $o ).

tff(pred_def_48392,type,
    v89768: state_type > $o ).

tff(pred_def_48393,type,
    v89766: state_type > $o ).

tff(pred_def_48394,type,
    v89770: state_type > $o ).

tff(pred_def_48395,type,
    v89736: state_type > $o ).

tff(pred_def_48396,type,
    v89734: state_type > $o ).

tff(pred_def_48397,type,
    v89732: state_type > $o ).

tff(pred_def_48398,type,
    v89790: state_type > $o ).

tff(pred_def_48399,type,
    v89788: state_type > $o ).

tff(pred_def_48400,type,
    v89794: state_type > $o ).

tff(pred_def_48401,type,
    v89792: state_type > $o ).

tff(pred_def_48402,type,
    v89798: state_type > $o ).

tff(pred_def_48403,type,
    v89796: state_type > $o ).

tff(pred_def_48404,type,
    v89800: state_type > $o ).

tff(pred_def_48405,type,
    v89786: state_type > $o ).

tff(pred_def_48406,type,
    v89784: state_type > $o ).

tff(pred_def_48407,type,
    v89782: state_type > $o ).

tff(pred_def_48408,type,
    v89780: state_type > $o ).

tff(pred_def_48409,type,
    v89778: state_type > $o ).

tff(pred_def_48410,type,
    v89804: state_type > $o ).

tff(pred_def_48411,type,
    v89802: state_type > $o ).

tff(pred_def_48412,type,
    v89808: state_type > $o ).

tff(pred_def_48413,type,
    v89806: state_type > $o ).

tff(pred_def_48414,type,
    v89810: state_type > $o ).

tff(pred_def_48415,type,
    v89776: state_type > $o ).

tff(pred_def_48416,type,
    v89774: state_type > $o ).

tff(pred_def_48417,type,
    v89772: state_type > $o ).

tff(pred_def_48418,type,
    v89830: state_type > $o ).

tff(pred_def_48419,type,
    v89828: state_type > $o ).

tff(pred_def_48420,type,
    v89834: state_type > $o ).

tff(pred_def_48421,type,
    v89832: state_type > $o ).

tff(pred_def_48422,type,
    v89838: state_type > $o ).

tff(pred_def_48423,type,
    v89836: state_type > $o ).

tff(pred_def_48424,type,
    v89840: state_type > $o ).

tff(pred_def_48425,type,
    v89826: state_type > $o ).

tff(pred_def_48426,type,
    v89824: state_type > $o ).

tff(pred_def_48427,type,
    v89822: state_type > $o ).

tff(pred_def_48428,type,
    v89820: state_type > $o ).

tff(pred_def_48429,type,
    v89818: state_type > $o ).

tff(pred_def_48430,type,
    v89844: state_type > $o ).

tff(pred_def_48431,type,
    v89842: state_type > $o ).

tff(pred_def_48432,type,
    v89848: state_type > $o ).

tff(pred_def_48433,type,
    v89846: state_type > $o ).

tff(pred_def_48434,type,
    v89850: state_type > $o ).

tff(pred_def_48435,type,
    v89816: state_type > $o ).

tff(pred_def_48436,type,
    v89814: state_type > $o ).

tff(pred_def_48437,type,
    v89812: state_type > $o ).

tff(pred_def_48438,type,
    v89870: state_type > $o ).

tff(pred_def_48439,type,
    v89868: state_type > $o ).

tff(pred_def_48440,type,
    v89874: state_type > $o ).

tff(pred_def_48441,type,
    v89872: state_type > $o ).

tff(pred_def_48442,type,
    v89878: state_type > $o ).

tff(pred_def_48443,type,
    v89876: state_type > $o ).

tff(pred_def_48444,type,
    v89880: state_type > $o ).

tff(pred_def_48445,type,
    v89866: state_type > $o ).

tff(pred_def_48446,type,
    v89864: state_type > $o ).

tff(pred_def_48447,type,
    v89862: state_type > $o ).

tff(pred_def_48448,type,
    v89860: state_type > $o ).

tff(pred_def_48449,type,
    v89858: state_type > $o ).

tff(pred_def_48450,type,
    v89884: state_type > $o ).

tff(pred_def_48451,type,
    v89882: state_type > $o ).

tff(pred_def_48452,type,
    v89888: state_type > $o ).

tff(pred_def_48453,type,
    v89886: state_type > $o ).

tff(pred_def_48454,type,
    v89890: state_type > $o ).

tff(pred_def_48455,type,
    v89856: state_type > $o ).

tff(pred_def_48456,type,
    v89854: state_type > $o ).

tff(pred_def_48457,type,
    v89852: state_type > $o ).

tff(pred_def_48458,type,
    v89910: state_type > $o ).

tff(pred_def_48459,type,
    v89908: state_type > $o ).

tff(pred_def_48460,type,
    v89914: state_type > $o ).

tff(pred_def_48461,type,
    v89912: state_type > $o ).

tff(pred_def_48462,type,
    v89918: state_type > $o ).

tff(pred_def_48463,type,
    v89916: state_type > $o ).

tff(pred_def_48464,type,
    v89920: state_type > $o ).

tff(pred_def_48465,type,
    v89906: state_type > $o ).

tff(pred_def_48466,type,
    v89904: state_type > $o ).

tff(pred_def_48467,type,
    v89902: state_type > $o ).

tff(pred_def_48468,type,
    v89900: state_type > $o ).

tff(pred_def_48469,type,
    v89898: state_type > $o ).

tff(pred_def_48470,type,
    v89924: state_type > $o ).

tff(pred_def_48471,type,
    v89922: state_type > $o ).

tff(pred_def_48472,type,
    v89928: state_type > $o ).

tff(pred_def_48473,type,
    v89926: state_type > $o ).

tff(pred_def_48474,type,
    v89930: state_type > $o ).

tff(pred_def_48475,type,
    v89896: state_type > $o ).

tff(pred_def_48476,type,
    v89894: state_type > $o ).

tff(pred_def_48477,type,
    v89892: state_type > $o ).

tff(pred_def_48478,type,
    v89950: state_type > $o ).

tff(pred_def_48479,type,
    v89948: state_type > $o ).

tff(pred_def_48480,type,
    v89954: state_type > $o ).

tff(pred_def_48481,type,
    v89952: state_type > $o ).

tff(pred_def_48482,type,
    v89958: state_type > $o ).

tff(pred_def_48483,type,
    v89956: state_type > $o ).

tff(pred_def_48484,type,
    v89960: state_type > $o ).

tff(pred_def_48485,type,
    v89946: state_type > $o ).

tff(pred_def_48486,type,
    v89944: state_type > $o ).

tff(pred_def_48487,type,
    v89942: state_type > $o ).

tff(pred_def_48488,type,
    v89940: state_type > $o ).

tff(pred_def_48489,type,
    v89938: state_type > $o ).

tff(pred_def_48490,type,
    v89964: state_type > $o ).

tff(pred_def_48491,type,
    v89962: state_type > $o ).

tff(pred_def_48492,type,
    v89968: state_type > $o ).

tff(pred_def_48493,type,
    v89966: state_type > $o ).

tff(pred_def_48494,type,
    v89970: state_type > $o ).

tff(pred_def_48495,type,
    v89936: state_type > $o ).

tff(pred_def_48496,type,
    v89934: state_type > $o ).

tff(pred_def_48497,type,
    v89932: state_type > $o ).

tff(pred_def_48498,type,
    v89990: state_type > $o ).

tff(pred_def_48499,type,
    v89988: state_type > $o ).

tff(pred_def_48500,type,
    v89994: state_type > $o ).

tff(pred_def_48501,type,
    v89992: state_type > $o ).

tff(pred_def_48502,type,
    v89998: state_type > $o ).

tff(pred_def_48503,type,
    v89996: state_type > $o ).

tff(pred_def_48504,type,
    v90000: state_type > $o ).

tff(pred_def_48505,type,
    v89986: state_type > $o ).

tff(pred_def_48506,type,
    v89984: state_type > $o ).

tff(pred_def_48507,type,
    v89982: state_type > $o ).

tff(pred_def_48508,type,
    v89980: state_type > $o ).

tff(pred_def_48509,type,
    v89978: state_type > $o ).

tff(pred_def_48510,type,
    v90004: state_type > $o ).

tff(pred_def_48511,type,
    v90002: state_type > $o ).

tff(pred_def_48512,type,
    v90008: state_type > $o ).

tff(pred_def_48513,type,
    v90006: state_type > $o ).

tff(pred_def_48514,type,
    v90010: state_type > $o ).

tff(pred_def_48515,type,
    v89976: state_type > $o ).

tff(pred_def_48516,type,
    v89974: state_type > $o ).

tff(pred_def_48517,type,
    v89972: state_type > $o ).

tff(pred_def_48518,type,
    v90030: state_type > $o ).

tff(pred_def_48519,type,
    v90028: state_type > $o ).

tff(pred_def_48520,type,
    v90034: state_type > $o ).

tff(pred_def_48521,type,
    v90032: state_type > $o ).

tff(pred_def_48522,type,
    v90038: state_type > $o ).

tff(pred_def_48523,type,
    v90036: state_type > $o ).

tff(pred_def_48524,type,
    v90040: state_type > $o ).

tff(pred_def_48525,type,
    v90026: state_type > $o ).

tff(pred_def_48526,type,
    v90024: state_type > $o ).

tff(pred_def_48527,type,
    v90022: state_type > $o ).

tff(pred_def_48528,type,
    v90020: state_type > $o ).

tff(pred_def_48529,type,
    v90018: state_type > $o ).

tff(pred_def_48530,type,
    v90044: state_type > $o ).

tff(pred_def_48531,type,
    v90042: state_type > $o ).

tff(pred_def_48532,type,
    v90048: state_type > $o ).

tff(pred_def_48533,type,
    v90046: state_type > $o ).

tff(pred_def_48534,type,
    v90050: state_type > $o ).

tff(pred_def_48535,type,
    v90016: state_type > $o ).

tff(pred_def_48536,type,
    v90014: state_type > $o ).

tff(pred_def_48537,type,
    v90012: state_type > $o ).

tff(pred_def_48538,type,
    v90070: state_type > $o ).

tff(pred_def_48539,type,
    v90068: state_type > $o ).

tff(pred_def_48540,type,
    v90074: state_type > $o ).

tff(pred_def_48541,type,
    v90072: state_type > $o ).

tff(pred_def_48542,type,
    v90078: state_type > $o ).

tff(pred_def_48543,type,
    v90076: state_type > $o ).

tff(pred_def_48544,type,
    v90080: state_type > $o ).

tff(pred_def_48545,type,
    v90066: state_type > $o ).

tff(pred_def_48546,type,
    v90064: state_type > $o ).

tff(pred_def_48547,type,
    v90062: state_type > $o ).

tff(pred_def_48548,type,
    v90060: state_type > $o ).

tff(pred_def_48549,type,
    v90058: state_type > $o ).

tff(pred_def_48550,type,
    v90084: state_type > $o ).

tff(pred_def_48551,type,
    v90082: state_type > $o ).

tff(pred_def_48552,type,
    v90088: state_type > $o ).

tff(pred_def_48553,type,
    v90086: state_type > $o ).

tff(pred_def_48554,type,
    v90090: state_type > $o ).

tff(pred_def_48555,type,
    v90056: state_type > $o ).

tff(pred_def_48556,type,
    v90054: state_type > $o ).

tff(pred_def_48557,type,
    v90052: state_type > $o ).

tff(pred_def_48558,type,
    v90110: state_type > $o ).

tff(pred_def_48559,type,
    v90108: state_type > $o ).

tff(pred_def_48560,type,
    v90114: state_type > $o ).

tff(pred_def_48561,type,
    v90112: state_type > $o ).

tff(pred_def_48562,type,
    v90118: state_type > $o ).

tff(pred_def_48563,type,
    v90116: state_type > $o ).

tff(pred_def_48564,type,
    v90120: state_type > $o ).

tff(pred_def_48565,type,
    v90106: state_type > $o ).

tff(pred_def_48566,type,
    v90104: state_type > $o ).

tff(pred_def_48567,type,
    v90102: state_type > $o ).

tff(pred_def_48568,type,
    v90100: state_type > $o ).

tff(pred_def_48569,type,
    v90098: state_type > $o ).

tff(pred_def_48570,type,
    v90124: state_type > $o ).

tff(pred_def_48571,type,
    v90122: state_type > $o ).

tff(pred_def_48572,type,
    v90128: state_type > $o ).

tff(pred_def_48573,type,
    v90126: state_type > $o ).

tff(pred_def_48574,type,
    v90130: state_type > $o ).

tff(pred_def_48575,type,
    v90096: state_type > $o ).

tff(pred_def_48576,type,
    v90094: state_type > $o ).

tff(pred_def_48577,type,
    v90092: state_type > $o ).

tff(pred_def_48578,type,
    v90150: state_type > $o ).

tff(pred_def_48579,type,
    v90148: state_type > $o ).

tff(pred_def_48580,type,
    v90154: state_type > $o ).

tff(pred_def_48581,type,
    v90152: state_type > $o ).

tff(pred_def_48582,type,
    v90158: state_type > $o ).

tff(pred_def_48583,type,
    v90156: state_type > $o ).

tff(pred_def_48584,type,
    v90160: state_type > $o ).

tff(pred_def_48585,type,
    v90146: state_type > $o ).

tff(pred_def_48586,type,
    v90144: state_type > $o ).

tff(pred_def_48587,type,
    v90142: state_type > $o ).

tff(pred_def_48588,type,
    v90140: state_type > $o ).

tff(pred_def_48589,type,
    v90138: state_type > $o ).

tff(pred_def_48590,type,
    v90164: state_type > $o ).

tff(pred_def_48591,type,
    v90162: state_type > $o ).

tff(pred_def_48592,type,
    v90168: state_type > $o ).

tff(pred_def_48593,type,
    v90166: state_type > $o ).

tff(pred_def_48594,type,
    v90170: state_type > $o ).

tff(pred_def_48595,type,
    v90136: state_type > $o ).

tff(pred_def_48596,type,
    v90134: state_type > $o ).

tff(pred_def_48597,type,
    v90132: state_type > $o ).

tff(pred_def_48598,type,
    v90190: state_type > $o ).

tff(pred_def_48599,type,
    v90188: state_type > $o ).

tff(pred_def_48600,type,
    v90194: state_type > $o ).

tff(pred_def_48601,type,
    v90192: state_type > $o ).

tff(pred_def_48602,type,
    v90198: state_type > $o ).

tff(pred_def_48603,type,
    v90196: state_type > $o ).

tff(pred_def_48604,type,
    v90200: state_type > $o ).

tff(pred_def_48605,type,
    v90186: state_type > $o ).

tff(pred_def_48606,type,
    v90184: state_type > $o ).

tff(pred_def_48607,type,
    v90182: state_type > $o ).

tff(pred_def_48608,type,
    v90180: state_type > $o ).

tff(pred_def_48609,type,
    v90178: state_type > $o ).

tff(pred_def_48610,type,
    v90204: state_type > $o ).

tff(pred_def_48611,type,
    v90202: state_type > $o ).

tff(pred_def_48612,type,
    v90208: state_type > $o ).

tff(pred_def_48613,type,
    v90206: state_type > $o ).

tff(pred_def_48614,type,
    v90210: state_type > $o ).

tff(pred_def_48615,type,
    v90176: state_type > $o ).

tff(pred_def_48616,type,
    v90174: state_type > $o ).

tff(pred_def_48617,type,
    v90172: state_type > $o ).

tff(pred_def_48618,type,
    v89730: ( state_type * $int ) > $o ).

tff(pred_def_48619,type,
    v89728: ( state_type * $int ) > $o ).

tff(pred_def_48620,type,
    v89726: ( state_type * $int ) > $o ).

tff(pred_def_48621,type,
    v90222: state_type > $o ).

tff(pred_def_48622,type,
    v90220: state_type > $o ).

tff(pred_def_48623,type,
    v90226: state_type > $o ).

tff(pred_def_48624,type,
    v90224: state_type > $o ).

tff(pred_def_48625,type,
    v90235: state_type > $o ).

tff(pred_def_48626,type,
    v90234: state_type > $o ).

tff(pred_def_48627,type,
    v90233: ( state_type * $int ) > $o ).

tff(pred_def_48628,type,
    v90232: ( state_type * $int ) > $o ).

tff(pred_def_48629,type,
    v90237: state_type > $o ).

tff(pred_def_48630,type,
    v90241: state_type > $o ).

tff(pred_def_48631,type,
    v90240: ( state_type * $int ) > $o ).

tff(pred_def_48632,type,
    v90239: ( state_type * $int ) > $o ).

tff(pred_def_48633,type,
    v90245: state_type > $o ).

tff(pred_def_48634,type,
    v90244: ( state_type * $int ) > $o ).

tff(pred_def_48635,type,
    v90243: ( state_type * $int ) > $o ).

tff(pred_def_48636,type,
    v90216: ( state_type * $int ) > $o ).

tff(pred_def_48637,type,
    v90242: ( state_type * $int ) > $o ).

tff(pred_def_48638,type,
    v90230: ( state_type * $int ) > $o ).

tff(pred_def_48639,type,
    v90228: ( state_type * $int ) > $o ).

tff(pred_def_48640,type,
    v90249: state_type > $o ).

tff(pred_def_48641,type,
    v90247: state_type > $o ).

tff(pred_def_48642,type,
    v90256: state_type > $o ).

tff(pred_def_48643,type,
    v90254: state_type > $o ).

tff(pred_def_48644,type,
    v90253: state_type > $o ).

tff(pred_def_48645,type,
    v90252: state_type > $o ).

tff(pred_def_48646,type,
    v90264: state_type > $o ).

tff(pred_def_48647,type,
    v90265: state_type > $o ).

tff(pred_def_48648,type,
    v90263: state_type > $o ).

tff(pred_def_48649,type,
    v90260: ( state_type * $int ) > $o ).

tff(pred_def_48650,type,
    v90262: ( state_type * $int ) > $o ).

tff(pred_def_48651,type,
    v90218: ( state_type * $int ) > $o ).

tff(pred_def_48652,type,
    v90214: ( state_type * $int ) > $o ).

tff(pred_def_48653,type,
    v90280: state_type > $o ).

tff(pred_def_48654,type,
    v90282: state_type > $o ).

tff(pred_def_48655,type,
    v90284: state_type > $o ).

tff(pred_def_48656,type,
    v90286: state_type > $o ).

tff(pred_def_48657,type,
    v90288: state_type > $o ).

tff(pred_def_48658,type,
    v90290: state_type > $o ).

tff(pred_def_48659,type,
    v90292: state_type > $o ).

tff(pred_def_48660,type,
    v90294: state_type > $o ).

tff(pred_def_48661,type,
    v90296: state_type > $o ).

tff(pred_def_48662,type,
    v90298: state_type > $o ).

tff(pred_def_48663,type,
    v90300: state_type > $o ).

tff(pred_def_48664,type,
    b111111111111: $int > $o ).

tff(pred_def_48665,type,
    v90299: ( state_type * $int ) > $o ).

tff(pred_def_48666,type,
    b000000000001: $int > $o ).

tff(pred_def_48667,type,
    b011111111111: $int > $o ).

tff(pred_def_48668,type,
    v90297: ( state_type * $int ) > $o ).

tff(pred_def_48669,type,
    b001111111111: $int > $o ).

tff(pred_def_48670,type,
    v90295: ( state_type * $int ) > $o ).

tff(pred_def_48671,type,
    b000111111111: $int > $o ).

tff(pred_def_48672,type,
    v90293: ( state_type * $int ) > $o ).

tff(pred_def_48673,type,
    b000011111111: $int > $o ).

tff(pred_def_48674,type,
    v90291: ( state_type * $int ) > $o ).

tff(pred_def_48675,type,
    b000001111111: $int > $o ).

tff(pred_def_48676,type,
    v90289: ( state_type * $int ) > $o ).

tff(pred_def_48677,type,
    b000000111111: $int > $o ).

tff(pred_def_48678,type,
    v90287: ( state_type * $int ) > $o ).

tff(pred_def_48679,type,
    b000000011111: $int > $o ).

tff(pred_def_48680,type,
    v90285: ( state_type * $int ) > $o ).

tff(pred_def_48681,type,
    b000000001111: $int > $o ).

tff(pred_def_48682,type,
    v90283: ( state_type * $int ) > $o ).

tff(pred_def_48683,type,
    b000000000111: $int > $o ).

tff(pred_def_48684,type,
    v90281: ( state_type * $int ) > $o ).

tff(pred_def_48685,type,
    b000000000011: $int > $o ).

tff(pred_def_48686,type,
    v90212: ( state_type * $int ) > $o ).

tff(pred_def_48687,type,
    v90302: ( state_type * $int ) > $o ).

tff(pred_def_48688,type,
    v89724: ( state_type * $int ) > $o ).

tff(pred_def_48689,type,
    v90330: state_type > $o ).

tff(pred_def_48690,type,
    v90328: state_type > $o ).

tff(pred_def_48691,type,
    v90334: state_type > $o ).

tff(pred_def_48692,type,
    v90332: state_type > $o ).

tff(pred_def_48693,type,
    v90338: state_type > $o ).

tff(pred_def_48694,type,
    v90336: state_type > $o ).

tff(pred_def_48695,type,
    v90340: state_type > $o ).

tff(pred_def_48696,type,
    v90326: state_type > $o ).

tff(pred_def_48697,type,
    v90324: state_type > $o ).

tff(pred_def_48698,type,
    v90322: state_type > $o ).

tff(pred_def_48699,type,
    v90320: state_type > $o ).

tff(pred_def_48700,type,
    v90318: state_type > $o ).

tff(pred_def_48701,type,
    v90344: state_type > $o ).

tff(pred_def_48702,type,
    v90342: state_type > $o ).

tff(pred_def_48703,type,
    v90348: state_type > $o ).

tff(pred_def_48704,type,
    v90346: state_type > $o ).

tff(pred_def_48705,type,
    v90350: state_type > $o ).

tff(pred_def_48706,type,
    v90316: state_type > $o ).

tff(pred_def_48707,type,
    v90314: state_type > $o ).

tff(pred_def_48708,type,
    v90312: state_type > $o ).

tff(pred_def_48709,type,
    v90370: state_type > $o ).

tff(pred_def_48710,type,
    v90368: state_type > $o ).

tff(pred_def_48711,type,
    v90374: state_type > $o ).

tff(pred_def_48712,type,
    v90372: state_type > $o ).

tff(pred_def_48713,type,
    v90378: state_type > $o ).

tff(pred_def_48714,type,
    v90376: state_type > $o ).

tff(pred_def_48715,type,
    v90380: state_type > $o ).

tff(pred_def_48716,type,
    v90366: state_type > $o ).

tff(pred_def_48717,type,
    v90364: state_type > $o ).

tff(pred_def_48718,type,
    v90362: state_type > $o ).

tff(pred_def_48719,type,
    v90360: state_type > $o ).

tff(pred_def_48720,type,
    v90358: state_type > $o ).

tff(pred_def_48721,type,
    v90384: state_type > $o ).

tff(pred_def_48722,type,
    v90382: state_type > $o ).

tff(pred_def_48723,type,
    v90388: state_type > $o ).

tff(pred_def_48724,type,
    v90386: state_type > $o ).

tff(pred_def_48725,type,
    v90390: state_type > $o ).

tff(pred_def_48726,type,
    v90356: state_type > $o ).

tff(pred_def_48727,type,
    v90354: state_type > $o ).

tff(pred_def_48728,type,
    v90352: state_type > $o ).

tff(pred_def_48729,type,
    v90410: state_type > $o ).

tff(pred_def_48730,type,
    v90408: state_type > $o ).

tff(pred_def_48731,type,
    v90414: state_type > $o ).

tff(pred_def_48732,type,
    v90412: state_type > $o ).

tff(pred_def_48733,type,
    v90418: state_type > $o ).

tff(pred_def_48734,type,
    v90416: state_type > $o ).

tff(pred_def_48735,type,
    v90420: state_type > $o ).

tff(pred_def_48736,type,
    v90406: state_type > $o ).

tff(pred_def_48737,type,
    v90404: state_type > $o ).

tff(pred_def_48738,type,
    v90402: state_type > $o ).

tff(pred_def_48739,type,
    v90400: state_type > $o ).

tff(pred_def_48740,type,
    v90398: state_type > $o ).

tff(pred_def_48741,type,
    v90424: state_type > $o ).

tff(pred_def_48742,type,
    v90422: state_type > $o ).

tff(pred_def_48743,type,
    v90428: state_type > $o ).

tff(pred_def_48744,type,
    v90426: state_type > $o ).

tff(pred_def_48745,type,
    v90430: state_type > $o ).

tff(pred_def_48746,type,
    v90396: state_type > $o ).

tff(pred_def_48747,type,
    v90394: state_type > $o ).

tff(pred_def_48748,type,
    v90392: state_type > $o ).

tff(pred_def_48749,type,
    v90450: state_type > $o ).

tff(pred_def_48750,type,
    v90448: state_type > $o ).

tff(pred_def_48751,type,
    v90454: state_type > $o ).

tff(pred_def_48752,type,
    v90452: state_type > $o ).

tff(pred_def_48753,type,
    v90458: state_type > $o ).

tff(pred_def_48754,type,
    v90456: state_type > $o ).

tff(pred_def_48755,type,
    v90460: state_type > $o ).

tff(pred_def_48756,type,
    v90446: state_type > $o ).

tff(pred_def_48757,type,
    v90444: state_type > $o ).

tff(pred_def_48758,type,
    v90442: state_type > $o ).

tff(pred_def_48759,type,
    v90440: state_type > $o ).

tff(pred_def_48760,type,
    v90438: state_type > $o ).

tff(pred_def_48761,type,
    v90464: state_type > $o ).

tff(pred_def_48762,type,
    v90462: state_type > $o ).

tff(pred_def_48763,type,
    v90468: state_type > $o ).

tff(pred_def_48764,type,
    v90466: state_type > $o ).

tff(pred_def_48765,type,
    v90470: state_type > $o ).

tff(pred_def_48766,type,
    v90436: state_type > $o ).

tff(pred_def_48767,type,
    v90434: state_type > $o ).

tff(pred_def_48768,type,
    v90432: state_type > $o ).

tff(pred_def_48769,type,
    v90490: state_type > $o ).

tff(pred_def_48770,type,
    v90488: state_type > $o ).

tff(pred_def_48771,type,
    v90494: state_type > $o ).

tff(pred_def_48772,type,
    v90492: state_type > $o ).

tff(pred_def_48773,type,
    v90498: state_type > $o ).

tff(pred_def_48774,type,
    v90496: state_type > $o ).

tff(pred_def_48775,type,
    v90500: state_type > $o ).

tff(pred_def_48776,type,
    v90486: state_type > $o ).

tff(pred_def_48777,type,
    v90484: state_type > $o ).

tff(pred_def_48778,type,
    v90482: state_type > $o ).

tff(pred_def_48779,type,
    v90480: state_type > $o ).

tff(pred_def_48780,type,
    v90478: state_type > $o ).

tff(pred_def_48781,type,
    v90504: state_type > $o ).

tff(pred_def_48782,type,
    v90502: state_type > $o ).

tff(pred_def_48783,type,
    v90508: state_type > $o ).

tff(pred_def_48784,type,
    v90506: state_type > $o ).

tff(pred_def_48785,type,
    v90510: state_type > $o ).

tff(pred_def_48786,type,
    v90476: state_type > $o ).

tff(pred_def_48787,type,
    v90474: state_type > $o ).

tff(pred_def_48788,type,
    v90472: state_type > $o ).

tff(pred_def_48789,type,
    v90530: state_type > $o ).

tff(pred_def_48790,type,
    v90528: state_type > $o ).

tff(pred_def_48791,type,
    v90534: state_type > $o ).

tff(pred_def_48792,type,
    v90532: state_type > $o ).

tff(pred_def_48793,type,
    v90538: state_type > $o ).

tff(pred_def_48794,type,
    v90536: state_type > $o ).

tff(pred_def_48795,type,
    v90540: state_type > $o ).

tff(pred_def_48796,type,
    v90526: state_type > $o ).

tff(pred_def_48797,type,
    v90524: state_type > $o ).

tff(pred_def_48798,type,
    v90522: state_type > $o ).

tff(pred_def_48799,type,
    v90520: state_type > $o ).

tff(pred_def_48800,type,
    v90518: state_type > $o ).

tff(pred_def_48801,type,
    v90544: state_type > $o ).

tff(pred_def_48802,type,
    v90542: state_type > $o ).

tff(pred_def_48803,type,
    v90548: state_type > $o ).

tff(pred_def_48804,type,
    v90546: state_type > $o ).

tff(pred_def_48805,type,
    v90550: state_type > $o ).

tff(pred_def_48806,type,
    v90516: state_type > $o ).

tff(pred_def_48807,type,
    v90514: state_type > $o ).

tff(pred_def_48808,type,
    v90512: state_type > $o ).

tff(pred_def_48809,type,
    v90570: state_type > $o ).

tff(pred_def_48810,type,
    v90568: state_type > $o ).

tff(pred_def_48811,type,
    v90574: state_type > $o ).

tff(pred_def_48812,type,
    v90572: state_type > $o ).

tff(pred_def_48813,type,
    v90578: state_type > $o ).

tff(pred_def_48814,type,
    v90576: state_type > $o ).

tff(pred_def_48815,type,
    v90580: state_type > $o ).

tff(pred_def_48816,type,
    v90566: state_type > $o ).

tff(pred_def_48817,type,
    v90564: state_type > $o ).

tff(pred_def_48818,type,
    v90562: state_type > $o ).

tff(pred_def_48819,type,
    v90560: state_type > $o ).

tff(pred_def_48820,type,
    v90558: state_type > $o ).

tff(pred_def_48821,type,
    v90584: state_type > $o ).

tff(pred_def_48822,type,
    v90582: state_type > $o ).

tff(pred_def_48823,type,
    v90588: state_type > $o ).

tff(pred_def_48824,type,
    v90586: state_type > $o ).

tff(pred_def_48825,type,
    v90590: state_type > $o ).

tff(pred_def_48826,type,
    v90556: state_type > $o ).

tff(pred_def_48827,type,
    v90554: state_type > $o ).

tff(pred_def_48828,type,
    v90552: state_type > $o ).

tff(pred_def_48829,type,
    v90610: state_type > $o ).

tff(pred_def_48830,type,
    v90608: state_type > $o ).

tff(pred_def_48831,type,
    v90614: state_type > $o ).

tff(pred_def_48832,type,
    v90612: state_type > $o ).

tff(pred_def_48833,type,
    v90618: state_type > $o ).

tff(pred_def_48834,type,
    v90616: state_type > $o ).

tff(pred_def_48835,type,
    v90620: state_type > $o ).

tff(pred_def_48836,type,
    v90606: state_type > $o ).

tff(pred_def_48837,type,
    v90604: state_type > $o ).

tff(pred_def_48838,type,
    v90602: state_type > $o ).

tff(pred_def_48839,type,
    v90600: state_type > $o ).

tff(pred_def_48840,type,
    v90598: state_type > $o ).

tff(pred_def_48841,type,
    v90624: state_type > $o ).

tff(pred_def_48842,type,
    v90622: state_type > $o ).

tff(pred_def_48843,type,
    v90628: state_type > $o ).

tff(pred_def_48844,type,
    v90626: state_type > $o ).

tff(pred_def_48845,type,
    v90630: state_type > $o ).

tff(pred_def_48846,type,
    v90596: state_type > $o ).

tff(pred_def_48847,type,
    v90594: state_type > $o ).

tff(pred_def_48848,type,
    v90592: state_type > $o ).

tff(pred_def_48849,type,
    v90650: state_type > $o ).

tff(pred_def_48850,type,
    v90648: state_type > $o ).

tff(pred_def_48851,type,
    v90654: state_type > $o ).

tff(pred_def_48852,type,
    v90652: state_type > $o ).

tff(pred_def_48853,type,
    v90658: state_type > $o ).

tff(pred_def_48854,type,
    v90656: state_type > $o ).

tff(pred_def_48855,type,
    v90660: state_type > $o ).

tff(pred_def_48856,type,
    v90646: state_type > $o ).

tff(pred_def_48857,type,
    v90644: state_type > $o ).

tff(pred_def_48858,type,
    v90642: state_type > $o ).

tff(pred_def_48859,type,
    v90640: state_type > $o ).

tff(pred_def_48860,type,
    v90638: state_type > $o ).

tff(pred_def_48861,type,
    v90664: state_type > $o ).

tff(pred_def_48862,type,
    v90662: state_type > $o ).

tff(pred_def_48863,type,
    v90668: state_type > $o ).

tff(pred_def_48864,type,
    v90666: state_type > $o ).

tff(pred_def_48865,type,
    v90670: state_type > $o ).

tff(pred_def_48866,type,
    v90636: state_type > $o ).

tff(pred_def_48867,type,
    v90634: state_type > $o ).

tff(pred_def_48868,type,
    v90632: state_type > $o ).

tff(pred_def_48869,type,
    v90690: state_type > $o ).

tff(pred_def_48870,type,
    v90688: state_type > $o ).

tff(pred_def_48871,type,
    v90694: state_type > $o ).

tff(pred_def_48872,type,
    v90692: state_type > $o ).

tff(pred_def_48873,type,
    v90698: state_type > $o ).

tff(pred_def_48874,type,
    v90696: state_type > $o ).

tff(pred_def_48875,type,
    v90700: state_type > $o ).

tff(pred_def_48876,type,
    v90686: state_type > $o ).

tff(pred_def_48877,type,
    v90684: state_type > $o ).

tff(pred_def_48878,type,
    v90682: state_type > $o ).

tff(pred_def_48879,type,
    v90680: state_type > $o ).

tff(pred_def_48880,type,
    v90678: state_type > $o ).

tff(pred_def_48881,type,
    v90704: state_type > $o ).

tff(pred_def_48882,type,
    v90702: state_type > $o ).

tff(pred_def_48883,type,
    v90708: state_type > $o ).

tff(pred_def_48884,type,
    v90706: state_type > $o ).

tff(pred_def_48885,type,
    v90710: state_type > $o ).

tff(pred_def_48886,type,
    v90676: state_type > $o ).

tff(pred_def_48887,type,
    v90674: state_type > $o ).

tff(pred_def_48888,type,
    v90672: state_type > $o ).

tff(pred_def_48889,type,
    v90730: state_type > $o ).

tff(pred_def_48890,type,
    v90728: state_type > $o ).

tff(pred_def_48891,type,
    v90734: state_type > $o ).

tff(pred_def_48892,type,
    v90732: state_type > $o ).

tff(pred_def_48893,type,
    v90738: state_type > $o ).

tff(pred_def_48894,type,
    v90736: state_type > $o ).

tff(pred_def_48895,type,
    v90740: state_type > $o ).

tff(pred_def_48896,type,
    v90726: state_type > $o ).

tff(pred_def_48897,type,
    v90724: state_type > $o ).

tff(pred_def_48898,type,
    v90722: state_type > $o ).

tff(pred_def_48899,type,
    v90720: state_type > $o ).

tff(pred_def_48900,type,
    v90718: state_type > $o ).

tff(pred_def_48901,type,
    v90744: state_type > $o ).

tff(pred_def_48902,type,
    v90742: state_type > $o ).

tff(pred_def_48903,type,
    v90748: state_type > $o ).

tff(pred_def_48904,type,
    v90746: state_type > $o ).

tff(pred_def_48905,type,
    v90750: state_type > $o ).

tff(pred_def_48906,type,
    v90716: state_type > $o ).

tff(pred_def_48907,type,
    v90714: state_type > $o ).

tff(pred_def_48908,type,
    v90712: state_type > $o ).

tff(pred_def_48909,type,
    v90770: state_type > $o ).

tff(pred_def_48910,type,
    v90768: state_type > $o ).

tff(pred_def_48911,type,
    v90774: state_type > $o ).

tff(pred_def_48912,type,
    v90772: state_type > $o ).

tff(pred_def_48913,type,
    v90778: state_type > $o ).

tff(pred_def_48914,type,
    v90776: state_type > $o ).

tff(pred_def_48915,type,
    v90780: state_type > $o ).

tff(pred_def_48916,type,
    v90766: state_type > $o ).

tff(pred_def_48917,type,
    v90764: state_type > $o ).

tff(pred_def_48918,type,
    v90762: state_type > $o ).

tff(pred_def_48919,type,
    v90760: state_type > $o ).

tff(pred_def_48920,type,
    v90758: state_type > $o ).

tff(pred_def_48921,type,
    v90784: state_type > $o ).

tff(pred_def_48922,type,
    v90782: state_type > $o ).

tff(pred_def_48923,type,
    v90788: state_type > $o ).

tff(pred_def_48924,type,
    v90786: state_type > $o ).

tff(pred_def_48925,type,
    v90790: state_type > $o ).

tff(pred_def_48926,type,
    v90756: state_type > $o ).

tff(pred_def_48927,type,
    v90754: state_type > $o ).

tff(pred_def_48928,type,
    v90752: state_type > $o ).

tff(pred_def_48929,type,
    v90310: ( state_type * $int ) > $o ).

tff(pred_def_48930,type,
    v90308: ( state_type * $int ) > $o ).

tff(pred_def_48931,type,
    v90306: ( state_type * $int ) > $o ).

tff(pred_def_48932,type,
    v90793: ( state_type * $int ) > $o ).

tff(pred_def_48933,type,
    v90792: ( state_type * $int ) > $o ).

tff(pred_def_48934,type,
    v90796: state_type > $o ).

tff(pred_def_48935,type,
    v90795: state_type > $o ).

tff(pred_def_48936,type,
    v90794: ( state_type * $int ) > $o ).

tff(pred_def_48937,type,
    v90304: ( state_type * $int ) > $o ).

tff(pred_def_48938,type,
    v90808: state_type > $o ).

tff(pred_def_48939,type,
    v90806: state_type > $o ).

tff(pred_def_48940,type,
    v90812: state_type > $o ).

tff(pred_def_48941,type,
    v90810: state_type > $o ).

tff(pred_def_48942,type,
    v90820: ( state_type * $int ) > $o ).

tff(pred_def_48943,type,
    v90818: ( state_type * $int ) > $o ).

tff(pred_def_48944,type,
    b0110000001000: $int > $o ).

tff(pred_def_48945,type,
    v90827: state_type > $o ).

tff(pred_def_48946,type,
    v90824: state_type > $o ).

tff(pred_def_48947,type,
    v90822: state_type > $o ).

tff(pred_def_48948,type,
    v90831: state_type > $o ).

tff(pred_def_48949,type,
    v90830: ( state_type * $int ) > $o ).

tff(pred_def_48950,type,
    v90829: ( state_type * $int ) > $o ).

tff(pred_def_48951,type,
    v90835: state_type > $o ).

tff(pred_def_48952,type,
    v90834: ( state_type * $int ) > $o ).

tff(pred_def_48953,type,
    v90833: ( state_type * $int ) > $o ).

tff(pred_def_48954,type,
    v90802: ( state_type * $int ) > $o ).

tff(pred_def_48955,type,
    v90832: ( state_type * $int ) > $o ).

tff(pred_def_48956,type,
    v90816: ( state_type * $int ) > $o ).

tff(pred_def_48957,type,
    v90814: ( state_type * $int ) > $o ).

tff(pred_def_48958,type,
    v90839: state_type > $o ).

tff(pred_def_48959,type,
    v90837: state_type > $o ).

tff(pred_def_48960,type,
    v90846: state_type > $o ).

tff(pred_def_48961,type,
    v90844: state_type > $o ).

tff(pred_def_48962,type,
    v90843: state_type > $o ).

tff(pred_def_48963,type,
    v90842: state_type > $o ).

tff(pred_def_48964,type,
    v90854: state_type > $o ).

tff(pred_def_48965,type,
    v90855: state_type > $o ).

tff(pred_def_48966,type,
    v90853: state_type > $o ).

tff(pred_def_48967,type,
    v90850: ( state_type * $int ) > $o ).

tff(pred_def_48968,type,
    v90852: ( state_type * $int ) > $o ).

tff(pred_def_48969,type,
    v90804: ( state_type * $int ) > $o ).

tff(pred_def_48970,type,
    v90800: ( state_type * $int ) > $o ).

tff(pred_def_48971,type,
    v90867: state_type > $o ).

tff(pred_def_48972,type,
    v90865: state_type > $o ).

tff(pred_def_48973,type,
    v90871: state_type > $o ).

tff(pred_def_48974,type,
    v90869: state_type > $o ).

tff(pred_def_48975,type,
    v90891: state_type > $o ).

tff(pred_def_48976,type,
    v90889: state_type > $o ).

tff(pred_def_48977,type,
    v90895: state_type > $o ).

tff(pred_def_48978,type,
    v90893: state_type > $o ).

tff(pred_def_48979,type,
    v90905: ( state_type * $int ) > $o ).

tff(pred_def_48980,type,
    v90907: ( state_type * $int ) > $o ).

tff(pred_def_48981,type,
    v90903: state_type > $o ).

tff(pred_def_48982,type,
    v90909: state_type > $o ).

tff(pred_def_48983,type,
    v90908: ( state_type * $int ) > $o ).

tff(pred_def_48984,type,
    v90910: state_type > $o ).

tff(pred_def_48985,type,
    v90901: ( state_type * $int ) > $o ).

tff(pred_def_48986,type,
    v90912: state_type > $o ).

tff(pred_def_48987,type,
    v90916: state_type > $o ).

tff(pred_def_48988,type,
    v90915: ( state_type * $int ) > $o ).

tff(pred_def_48989,type,
    v90914: ( state_type * $int ) > $o ).

tff(pred_def_48990,type,
    v90920: state_type > $o ).

tff(pred_def_48991,type,
    v90919: ( state_type * $int ) > $o ).

tff(pred_def_48992,type,
    v90918: ( state_type * $int ) > $o ).

tff(pred_def_48993,type,
    v90885: ( state_type * $int ) > $o ).

tff(pred_def_48994,type,
    v90917: ( state_type * $int ) > $o ).

tff(pred_def_48995,type,
    v90913: ( state_type * $int ) > $o ).

tff(pred_def_48996,type,
    v90899: ( state_type * $int ) > $o ).

tff(pred_def_48997,type,
    v90897: ( state_type * $int ) > $o ).

tff(pred_def_48998,type,
    v90924: state_type > $o ).

tff(pred_def_48999,type,
    v90922: state_type > $o ).

tff(pred_def_49000,type,
    v90931: state_type > $o ).

tff(pred_def_49001,type,
    v90929: state_type > $o ).

tff(pred_def_49002,type,
    v90928: state_type > $o ).

tff(pred_def_49003,type,
    v90927: state_type > $o ).

tff(pred_def_49004,type,
    v90939: state_type > $o ).

tff(pred_def_49005,type,
    v90940: state_type > $o ).

tff(pred_def_49006,type,
    v90938: state_type > $o ).

tff(pred_def_49007,type,
    v90935: ( state_type * $int ) > $o ).

tff(pred_def_49008,type,
    v90937: ( state_type * $int ) > $o ).

tff(pred_def_49009,type,
    v90926: ( state_type * $int ) > $o ).

tff(pred_def_49010,type,
    v90887: ( state_type * $int ) > $o ).

tff(pred_def_49011,type,
    v90883: state_type > $o ).

tff(pred_def_49012,type,
    v90881: state_type > $o ).

tff(pred_def_49013,type,
    v90879: state_type > $o ).

tff(pred_def_49014,type,
    v90943: ( state_type * $int ) > $o ).

tff(pred_def_49015,type,
    v90944: state_type > $o ).

tff(pred_def_49016,type,
    v90877: ( state_type * $int ) > $o ).

tff(pred_def_49017,type,
    v90875: ( state_type * $int ) > $o ).

tff(pred_def_49018,type,
    v90873: ( state_type * $int ) > $o ).

tff(pred_def_49019,type,
    v90948: state_type > $o ).

tff(pred_def_49020,type,
    v90946: state_type > $o ).

tff(pred_def_49021,type,
    v90955: state_type > $o ).

tff(pred_def_49022,type,
    v90953: state_type > $o ).

tff(pred_def_49023,type,
    v90952: state_type > $o ).

tff(pred_def_49024,type,
    v90951: state_type > $o ).

tff(pred_def_49025,type,
    v90963: state_type > $o ).

tff(pred_def_49026,type,
    v90964: state_type > $o ).

tff(pred_def_49027,type,
    v90962: state_type > $o ).

tff(pred_def_49028,type,
    v90959: ( state_type * $int ) > $o ).

tff(pred_def_49029,type,
    v90961: ( state_type * $int ) > $o ).

tff(pred_def_49030,type,
    v90950: ( state_type * $int ) > $o ).

tff(pred_def_49031,type,
    v90863: ( state_type * $int ) > $o ).

tff(pred_def_49032,type,
    v90861: ( state_type * $int ) > $o ).

tff(pred_def_49033,type,
    v90859: state_type > $o ).

tff(pred_def_49034,type,
    v90976: state_type > $o ).

tff(pred_def_49035,type,
    v90974: state_type > $o ).

tff(pred_def_49036,type,
    v90980: state_type > $o ).

tff(pred_def_49037,type,
    v90978: state_type > $o ).

tff(pred_def_49038,type,
    v91016: ( state_type * $int ) > $o ).

tff(pred_def_49039,type,
    v91014: ( state_type * $int ) > $o ).

tff(pred_def_49040,type,
    v91012: ( state_type * $int ) > $o ).

tff(pred_def_49041,type,
    v91038: state_type > $o ).

tff(pred_def_49042,type,
    v91035: state_type > $o ).

tff(pred_def_49043,type,
    v91033: state_type > $o ).

tff(pred_def_49044,type,
    v91031: state_type > $o ).

tff(pred_def_49045,type,
    v91029: state_type > $o ).

tff(pred_def_49046,type,
    v91027: state_type > $o ).

tff(pred_def_49047,type,
    v91025: state_type > $o ).

tff(pred_def_49048,type,
    v91023: state_type > $o ).

tff(pred_def_49049,type,
    v91021: state_type > $o ).

tff(pred_def_49050,type,
    v91019: state_type > $o ).

tff(pred_def_49051,type,
    v91045: ( state_type * $int ) > $o ).

tff(pred_def_49052,type,
    v91043: ( state_type * $int ) > $o ).

tff(pred_def_49053,type,
    v91041: ( state_type * $int ) > $o ).

tff(pred_def_49054,type,
    v91060: state_type > $o ).

tff(pred_def_49055,type,
    v91058: state_type > $o ).

tff(pred_def_49056,type,
    v91056: state_type > $o ).

tff(pred_def_49057,type,
    v91054: state_type > $o ).

tff(pred_def_49058,type,
    v91052: state_type > $o ).

tff(pred_def_49059,type,
    v91050: state_type > $o ).

tff(pred_def_49060,type,
    v91048: state_type > $o ).

tff(pred_def_49061,type,
    v91064: state_type > $o ).

tff(pred_def_49062,type,
    v91063: ( state_type * $int ) > $o ).

tff(pred_def_49063,type,
    v91062: ( state_type * $int ) > $o ).

tff(pred_def_49064,type,
    v91067: state_type > $o ).

tff(pred_def_49065,type,
    v91066: ( state_type * $int ) > $o ).

tff(pred_def_49066,type,
    v91065: ( state_type * $int ) > $o ).

tff(pred_def_49067,type,
    v91010: ( state_type * $int ) > $o ).

tff(pred_def_49068,type,
    v91008: ( state_type * $int ) > $o ).

tff(pred_def_49069,type,
    v91006: ( state_type * $int ) > $o ).

tff(pred_def_49070,type,
    v91004: ( state_type * $int ) > $o ).

tff(pred_def_49071,type,
    v91002: ( state_type * $int ) > $o ).

tff(pred_def_49072,type,
    v91098: ( state_type * $int ) > $o ).

tff(pred_def_49073,type,
    v91097: ( state_type * $int ) > $o ).

tff(pred_def_49074,type,
    v91095: ( state_type * $int ) > $o ).

tff(pred_def_49075,type,
    v91093: ( state_type * $int ) > $o ).

tff(pred_def_49076,type,
    v91091: ( state_type * $int ) > $o ).

tff(pred_def_49077,type,
    v91138: state_type > $o ).

tff(pred_def_49078,type,
    v91137: state_type > $o ).

tff(pred_def_49079,type,
    v91136: state_type > $o ).

tff(pred_def_49080,type,
    v91135: state_type > $o ).

tff(pred_def_49081,type,
    v91134: state_type > $o ).

tff(pred_def_49082,type,
    v91133: state_type > $o ).

tff(pred_def_49083,type,
    v91132: state_type > $o ).

tff(pred_def_49084,type,
    v91131: state_type > $o ).

tff(pred_def_49085,type,
    v91130: state_type > $o ).

tff(pred_def_49086,type,
    v91129: state_type > $o ).

tff(pred_def_49087,type,
    v91128: state_type > $o ).

tff(pred_def_49088,type,
    v91127: state_type > $o ).

tff(pred_def_49089,type,
    v91126: state_type > $o ).

tff(pred_def_49090,type,
    v91125: state_type > $o ).

tff(pred_def_49091,type,
    v91124: state_type > $o ).

tff(pred_def_49092,type,
    v91123: state_type > $o ).

tff(pred_def_49093,type,
    v91122: state_type > $o ).

tff(pred_def_49094,type,
    v91121: state_type > $o ).

tff(pred_def_49095,type,
    v91120: state_type > $o ).

tff(pred_def_49096,type,
    v91119: state_type > $o ).

tff(pred_def_49097,type,
    v91118: state_type > $o ).

tff(pred_def_49098,type,
    v91117: state_type > $o ).

tff(pred_def_49099,type,
    v91116: state_type > $o ).

tff(pred_def_49100,type,
    v91115: state_type > $o ).

tff(pred_def_49101,type,
    v91114: state_type > $o ).

tff(pred_def_49102,type,
    v91113: state_type > $o ).

tff(pred_def_49103,type,
    v91112: state_type > $o ).

tff(pred_def_49104,type,
    v91111: state_type > $o ).

tff(pred_def_49105,type,
    v91110: state_type > $o ).

tff(pred_def_49106,type,
    v91109: state_type > $o ).

tff(pred_def_49107,type,
    v91108: state_type > $o ).

tff(pred_def_49108,type,
    v91107: state_type > $o ).

tff(pred_def_49109,type,
    v91106: state_type > $o ).

tff(pred_def_49110,type,
    v91105: state_type > $o ).

tff(pred_def_49111,type,
    v91104: state_type > $o ).

tff(pred_def_49112,type,
    v91103: state_type > $o ).

tff(pred_def_49113,type,
    v91102: state_type > $o ).

tff(pred_def_49114,type,
    v91101: state_type > $o ).

tff(pred_def_49115,type,
    v91100: state_type > $o ).

tff(pred_def_49116,type,
    v91089: ( state_type * $int ) > $o ).

tff(pred_def_49117,type,
    v91172: state_type > $o ).

tff(pred_def_49118,type,
    v91171: state_type > $o ).

tff(pred_def_49119,type,
    v91170: state_type > $o ).

tff(pred_def_49120,type,
    v91169: state_type > $o ).

tff(pred_def_49121,type,
    v91168: state_type > $o ).

tff(pred_def_49122,type,
    v91167: state_type > $o ).

tff(pred_def_49123,type,
    v91166: state_type > $o ).

tff(pred_def_49124,type,
    v91165: state_type > $o ).

tff(pred_def_49125,type,
    v91164: state_type > $o ).

tff(pred_def_49126,type,
    v91163: state_type > $o ).

tff(pred_def_49127,type,
    v91162: state_type > $o ).

tff(pred_def_49128,type,
    v91161: state_type > $o ).

tff(pred_def_49129,type,
    v91160: state_type > $o ).

tff(pred_def_49130,type,
    v91159: state_type > $o ).

tff(pred_def_49131,type,
    v91158: state_type > $o ).

tff(pred_def_49132,type,
    v91157: state_type > $o ).

tff(pred_def_49133,type,
    v91156: state_type > $o ).

tff(pred_def_49134,type,
    v91155: state_type > $o ).

tff(pred_def_49135,type,
    v91154: state_type > $o ).

tff(pred_def_49136,type,
    v91153: state_type > $o ).

tff(pred_def_49137,type,
    v91152: state_type > $o ).

tff(pred_def_49138,type,
    v91151: state_type > $o ).

tff(pred_def_49139,type,
    v91150: state_type > $o ).

tff(pred_def_49140,type,
    v91149: state_type > $o ).

tff(pred_def_49141,type,
    v91148: state_type > $o ).

tff(pred_def_49142,type,
    v91147: state_type > $o ).

tff(pred_def_49143,type,
    v91146: state_type > $o ).

tff(pred_def_49144,type,
    v91145: state_type > $o ).

tff(pred_def_49145,type,
    v91144: state_type > $o ).

tff(pred_def_49146,type,
    v91143: state_type > $o ).

tff(pred_def_49147,type,
    v91142: state_type > $o ).

tff(pred_def_49148,type,
    v91141: state_type > $o ).

tff(pred_def_49149,type,
    v91140: state_type > $o ).

tff(pred_def_49150,type,
    v91206: state_type > $o ).

tff(pred_def_49151,type,
    v91205: state_type > $o ).

tff(pred_def_49152,type,
    v91204: state_type > $o ).

tff(pred_def_49153,type,
    v91203: state_type > $o ).

tff(pred_def_49154,type,
    v91202: state_type > $o ).

tff(pred_def_49155,type,
    v91201: state_type > $o ).

tff(pred_def_49156,type,
    v91200: state_type > $o ).

tff(pred_def_49157,type,
    v91199: state_type > $o ).

tff(pred_def_49158,type,
    v91198: state_type > $o ).

tff(pred_def_49159,type,
    v91197: state_type > $o ).

tff(pred_def_49160,type,
    v91196: state_type > $o ).

tff(pred_def_49161,type,
    v91195: state_type > $o ).

tff(pred_def_49162,type,
    v91194: state_type > $o ).

tff(pred_def_49163,type,
    v91193: state_type > $o ).

tff(pred_def_49164,type,
    v91192: state_type > $o ).

tff(pred_def_49165,type,
    v91191: state_type > $o ).

tff(pred_def_49166,type,
    v91190: state_type > $o ).

tff(pred_def_49167,type,
    v91189: state_type > $o ).

tff(pred_def_49168,type,
    v91188: state_type > $o ).

tff(pred_def_49169,type,
    v91187: state_type > $o ).

tff(pred_def_49170,type,
    v91186: state_type > $o ).

tff(pred_def_49171,type,
    v91185: state_type > $o ).

tff(pred_def_49172,type,
    v91184: state_type > $o ).

tff(pred_def_49173,type,
    v91183: state_type > $o ).

tff(pred_def_49174,type,
    v91182: state_type > $o ).

tff(pred_def_49175,type,
    v91181: state_type > $o ).

tff(pred_def_49176,type,
    v91180: state_type > $o ).

tff(pred_def_49177,type,
    v91179: state_type > $o ).

tff(pred_def_49178,type,
    v91178: state_type > $o ).

tff(pred_def_49179,type,
    v91177: state_type > $o ).

tff(pred_def_49180,type,
    v91176: state_type > $o ).

tff(pred_def_49181,type,
    v91175: state_type > $o ).

tff(pred_def_49182,type,
    v91174: state_type > $o ).

tff(pred_def_49183,type,
    v91246: state_type > $o ).

tff(pred_def_49184,type,
    v91245: state_type > $o ).

tff(pred_def_49185,type,
    v91244: state_type > $o ).

tff(pred_def_49186,type,
    v91243: state_type > $o ).

tff(pred_def_49187,type,
    v91242: state_type > $o ).

tff(pred_def_49188,type,
    v91241: state_type > $o ).

tff(pred_def_49189,type,
    v91240: state_type > $o ).

tff(pred_def_49190,type,
    v91239: state_type > $o ).

tff(pred_def_49191,type,
    v91238: state_type > $o ).

tff(pred_def_49192,type,
    v91237: state_type > $o ).

tff(pred_def_49193,type,
    v91236: state_type > $o ).

tff(pred_def_49194,type,
    v91235: state_type > $o ).

tff(pred_def_49195,type,
    v91234: state_type > $o ).

tff(pred_def_49196,type,
    v91233: state_type > $o ).

tff(pred_def_49197,type,
    v91232: state_type > $o ).

tff(pred_def_49198,type,
    v91231: state_type > $o ).

tff(pred_def_49199,type,
    v91230: state_type > $o ).

tff(pred_def_49200,type,
    v91229: state_type > $o ).

tff(pred_def_49201,type,
    v91228: state_type > $o ).

tff(pred_def_49202,type,
    v91227: state_type > $o ).

tff(pred_def_49203,type,
    v91226: state_type > $o ).

tff(pred_def_49204,type,
    v91225: state_type > $o ).

tff(pred_def_49205,type,
    v91224: state_type > $o ).

tff(pred_def_49206,type,
    v91223: state_type > $o ).

tff(pred_def_49207,type,
    v91222: state_type > $o ).

tff(pred_def_49208,type,
    v91221: state_type > $o ).

tff(pred_def_49209,type,
    v91220: state_type > $o ).

tff(pred_def_49210,type,
    v91219: state_type > $o ).

tff(pred_def_49211,type,
    v91218: state_type > $o ).

tff(pred_def_49212,type,
    v91217: state_type > $o ).

tff(pred_def_49213,type,
    v91216: state_type > $o ).

tff(pred_def_49214,type,
    v91215: state_type > $o ).

tff(pred_def_49215,type,
    v91214: state_type > $o ).

tff(pred_def_49216,type,
    v91213: state_type > $o ).

tff(pred_def_49217,type,
    v91212: state_type > $o ).

tff(pred_def_49218,type,
    v91211: state_type > $o ).

tff(pred_def_49219,type,
    v91210: state_type > $o ).

tff(pred_def_49220,type,
    v91209: state_type > $o ).

tff(pred_def_49221,type,
    v91208: state_type > $o ).

tff(pred_def_49222,type,
    v91285: state_type > $o ).

tff(pred_def_49223,type,
    v91284: state_type > $o ).

tff(pred_def_49224,type,
    v91283: state_type > $o ).

tff(pred_def_49225,type,
    v91282: state_type > $o ).

tff(pred_def_49226,type,
    v91281: state_type > $o ).

tff(pred_def_49227,type,
    v91280: state_type > $o ).

tff(pred_def_49228,type,
    v91279: state_type > $o ).

tff(pred_def_49229,type,
    v91278: state_type > $o ).

tff(pred_def_49230,type,
    v91277: state_type > $o ).

tff(pred_def_49231,type,
    v91276: state_type > $o ).

tff(pred_def_49232,type,
    v91275: state_type > $o ).

tff(pred_def_49233,type,
    v91274: state_type > $o ).

tff(pred_def_49234,type,
    v91273: state_type > $o ).

tff(pred_def_49235,type,
    v91272: state_type > $o ).

tff(pred_def_49236,type,
    v91271: state_type > $o ).

tff(pred_def_49237,type,
    v91270: state_type > $o ).

tff(pred_def_49238,type,
    v91269: state_type > $o ).

tff(pred_def_49239,type,
    v91268: state_type > $o ).

tff(pred_def_49240,type,
    v91267: state_type > $o ).

tff(pred_def_49241,type,
    v91266: state_type > $o ).

tff(pred_def_49242,type,
    v91265: state_type > $o ).

tff(pred_def_49243,type,
    v91264: state_type > $o ).

tff(pred_def_49244,type,
    v91263: state_type > $o ).

tff(pred_def_49245,type,
    v91262: state_type > $o ).

tff(pred_def_49246,type,
    v91261: state_type > $o ).

tff(pred_def_49247,type,
    v91260: state_type > $o ).

tff(pred_def_49248,type,
    v91259: state_type > $o ).

tff(pred_def_49249,type,
    v91258: state_type > $o ).

tff(pred_def_49250,type,
    v91257: state_type > $o ).

tff(pred_def_49251,type,
    v91256: state_type > $o ).

tff(pred_def_49252,type,
    v91255: state_type > $o ).

tff(pred_def_49253,type,
    v91254: state_type > $o ).

tff(pred_def_49254,type,
    v91253: state_type > $o ).

tff(pred_def_49255,type,
    v91252: state_type > $o ).

tff(pred_def_49256,type,
    v91251: state_type > $o ).

tff(pred_def_49257,type,
    v91250: state_type > $o ).

tff(pred_def_49258,type,
    v91249: state_type > $o ).

tff(pred_def_49259,type,
    v91248: state_type > $o ).

tff(pred_def_49260,type,
    v91324: state_type > $o ).

tff(pred_def_49261,type,
    v91323: state_type > $o ).

tff(pred_def_49262,type,
    v91322: state_type > $o ).

tff(pred_def_49263,type,
    v91321: state_type > $o ).

tff(pred_def_49264,type,
    v91320: state_type > $o ).

tff(pred_def_49265,type,
    v91319: state_type > $o ).

tff(pred_def_49266,type,
    v91318: state_type > $o ).

tff(pred_def_49267,type,
    v91317: state_type > $o ).

tff(pred_def_49268,type,
    v91316: state_type > $o ).

tff(pred_def_49269,type,
    v91315: state_type > $o ).

tff(pred_def_49270,type,
    v91314: state_type > $o ).

tff(pred_def_49271,type,
    v91313: state_type > $o ).

tff(pred_def_49272,type,
    v91312: state_type > $o ).

tff(pred_def_49273,type,
    v91311: state_type > $o ).

tff(pred_def_49274,type,
    v91310: state_type > $o ).

tff(pred_def_49275,type,
    v91309: state_type > $o ).

tff(pred_def_49276,type,
    v91308: state_type > $o ).

tff(pred_def_49277,type,
    v91307: state_type > $o ).

tff(pred_def_49278,type,
    v91306: state_type > $o ).

tff(pred_def_49279,type,
    v91305: state_type > $o ).

tff(pred_def_49280,type,
    v91304: state_type > $o ).

tff(pred_def_49281,type,
    v91303: state_type > $o ).

tff(pred_def_49282,type,
    v91302: state_type > $o ).

tff(pred_def_49283,type,
    v91301: state_type > $o ).

tff(pred_def_49284,type,
    v91300: state_type > $o ).

tff(pred_def_49285,type,
    v91299: state_type > $o ).

tff(pred_def_49286,type,
    v91298: state_type > $o ).

tff(pred_def_49287,type,
    v91297: state_type > $o ).

tff(pred_def_49288,type,
    v91296: state_type > $o ).

tff(pred_def_49289,type,
    v91295: state_type > $o ).

tff(pred_def_49290,type,
    v91294: state_type > $o ).

tff(pred_def_49291,type,
    v91293: state_type > $o ).

tff(pred_def_49292,type,
    v91292: state_type > $o ).

tff(pred_def_49293,type,
    v91291: state_type > $o ).

tff(pred_def_49294,type,
    v91290: state_type > $o ).

tff(pred_def_49295,type,
    v91289: state_type > $o ).

tff(pred_def_49296,type,
    v91288: state_type > $o ).

tff(pred_def_49297,type,
    v91287: state_type > $o ).

tff(pred_def_49298,type,
    v91367: state_type > $o ).

tff(pred_def_49299,type,
    v91366: state_type > $o ).

tff(pred_def_49300,type,
    v91365: state_type > $o ).

tff(pred_def_49301,type,
    v91364: state_type > $o ).

tff(pred_def_49302,type,
    v91363: state_type > $o ).

tff(pred_def_49303,type,
    v91362: state_type > $o ).

tff(pred_def_49304,type,
    v91361: state_type > $o ).

tff(pred_def_49305,type,
    v91360: state_type > $o ).

tff(pred_def_49306,type,
    v91359: state_type > $o ).

tff(pred_def_49307,type,
    v91358: state_type > $o ).

tff(pred_def_49308,type,
    v91357: state_type > $o ).

tff(pred_def_49309,type,
    v91356: state_type > $o ).

tff(pred_def_49310,type,
    v91355: state_type > $o ).

tff(pred_def_49311,type,
    v91354: state_type > $o ).

tff(pred_def_49312,type,
    v91353: state_type > $o ).

tff(pred_def_49313,type,
    v91352: state_type > $o ).

tff(pred_def_49314,type,
    v91351: state_type > $o ).

tff(pred_def_49315,type,
    v91350: state_type > $o ).

tff(pred_def_49316,type,
    v91349: state_type > $o ).

tff(pred_def_49317,type,
    v91348: state_type > $o ).

tff(pred_def_49318,type,
    v91347: state_type > $o ).

tff(pred_def_49319,type,
    v91346: state_type > $o ).

tff(pred_def_49320,type,
    v91345: state_type > $o ).

tff(pred_def_49321,type,
    v91344: state_type > $o ).

tff(pred_def_49322,type,
    v91343: state_type > $o ).

tff(pred_def_49323,type,
    v91342: state_type > $o ).

tff(pred_def_49324,type,
    v91341: state_type > $o ).

tff(pred_def_49325,type,
    v91340: state_type > $o ).

tff(pred_def_49326,type,
    v91339: state_type > $o ).

tff(pred_def_49327,type,
    v91338: state_type > $o ).

tff(pred_def_49328,type,
    v91337: state_type > $o ).

tff(pred_def_49329,type,
    v91336: state_type > $o ).

tff(pred_def_49330,type,
    v91335: state_type > $o ).

tff(pred_def_49331,type,
    v91334: state_type > $o ).

tff(pred_def_49332,type,
    v91333: state_type > $o ).

tff(pred_def_49333,type,
    v91332: state_type > $o ).

tff(pred_def_49334,type,
    v91331: state_type > $o ).

tff(pred_def_49335,type,
    v91330: state_type > $o ).

tff(pred_def_49336,type,
    v91329: state_type > $o ).

tff(pred_def_49337,type,
    v91328: state_type > $o ).

tff(pred_def_49338,type,
    v91327: state_type > $o ).

tff(pred_def_49339,type,
    v91326: state_type > $o ).

tff(pred_def_49340,type,
    v91409: state_type > $o ).

tff(pred_def_49341,type,
    v91408: state_type > $o ).

tff(pred_def_49342,type,
    v91407: state_type > $o ).

tff(pred_def_49343,type,
    v91406: state_type > $o ).

tff(pred_def_49344,type,
    v91405: state_type > $o ).

tff(pred_def_49345,type,
    v91404: state_type > $o ).

tff(pred_def_49346,type,
    v91403: state_type > $o ).

tff(pred_def_49347,type,
    v91402: state_type > $o ).

tff(pred_def_49348,type,
    v91401: state_type > $o ).

tff(pred_def_49349,type,
    v91400: state_type > $o ).

tff(pred_def_49350,type,
    v91399: state_type > $o ).

tff(pred_def_49351,type,
    v91398: state_type > $o ).

tff(pred_def_49352,type,
    v91397: state_type > $o ).

tff(pred_def_49353,type,
    v91396: state_type > $o ).

tff(pred_def_49354,type,
    v91395: state_type > $o ).

tff(pred_def_49355,type,
    v91394: state_type > $o ).

tff(pred_def_49356,type,
    v91393: state_type > $o ).

tff(pred_def_49357,type,
    v91392: state_type > $o ).

tff(pred_def_49358,type,
    v91391: state_type > $o ).

tff(pred_def_49359,type,
    v91390: state_type > $o ).

tff(pred_def_49360,type,
    v91389: state_type > $o ).

tff(pred_def_49361,type,
    v91388: state_type > $o ).

tff(pred_def_49362,type,
    v91387: state_type > $o ).

tff(pred_def_49363,type,
    v91386: state_type > $o ).

tff(pred_def_49364,type,
    v91385: state_type > $o ).

tff(pred_def_49365,type,
    v91384: state_type > $o ).

tff(pred_def_49366,type,
    v91383: state_type > $o ).

tff(pred_def_49367,type,
    v91382: state_type > $o ).

tff(pred_def_49368,type,
    v91381: state_type > $o ).

tff(pred_def_49369,type,
    v91380: state_type > $o ).

tff(pred_def_49370,type,
    v91379: state_type > $o ).

tff(pred_def_49371,type,
    v91378: state_type > $o ).

tff(pred_def_49372,type,
    v91377: state_type > $o ).

tff(pred_def_49373,type,
    v91376: state_type > $o ).

tff(pred_def_49374,type,
    v91375: state_type > $o ).

tff(pred_def_49375,type,
    v91374: state_type > $o ).

tff(pred_def_49376,type,
    v91373: state_type > $o ).

tff(pred_def_49377,type,
    v91372: state_type > $o ).

tff(pred_def_49378,type,
    v91371: state_type > $o ).

tff(pred_def_49379,type,
    v91370: state_type > $o ).

tff(pred_def_49380,type,
    v91369: state_type > $o ).

tff(pred_def_49381,type,
    v91449: state_type > $o ).

tff(pred_def_49382,type,
    v91448: state_type > $o ).

tff(pred_def_49383,type,
    v91447: state_type > $o ).

tff(pred_def_49384,type,
    v91446: state_type > $o ).

tff(pred_def_49385,type,
    v91445: state_type > $o ).

tff(pred_def_49386,type,
    v91444: state_type > $o ).

tff(pred_def_49387,type,
    v91443: state_type > $o ).

tff(pred_def_49388,type,
    v91442: state_type > $o ).

tff(pred_def_49389,type,
    v91441: state_type > $o ).

tff(pred_def_49390,type,
    v91440: state_type > $o ).

tff(pred_def_49391,type,
    v91439: state_type > $o ).

tff(pred_def_49392,type,
    v91438: state_type > $o ).

tff(pred_def_49393,type,
    v91437: state_type > $o ).

tff(pred_def_49394,type,
    v91436: state_type > $o ).

tff(pred_def_49395,type,
    v91435: state_type > $o ).

tff(pred_def_49396,type,
    v91434: state_type > $o ).

tff(pred_def_49397,type,
    v91433: state_type > $o ).

tff(pred_def_49398,type,
    v91432: state_type > $o ).

tff(pred_def_49399,type,
    v91431: state_type > $o ).

tff(pred_def_49400,type,
    v91430: state_type > $o ).

tff(pred_def_49401,type,
    v91429: state_type > $o ).

tff(pred_def_49402,type,
    v91428: state_type > $o ).

tff(pred_def_49403,type,
    v91427: state_type > $o ).

tff(pred_def_49404,type,
    v91426: state_type > $o ).

tff(pred_def_49405,type,
    v91425: state_type > $o ).

tff(pred_def_49406,type,
    v91424: state_type > $o ).

tff(pred_def_49407,type,
    v91423: state_type > $o ).

tff(pred_def_49408,type,
    v91422: state_type > $o ).

tff(pred_def_49409,type,
    v91421: state_type > $o ).

tff(pred_def_49410,type,
    v91420: state_type > $o ).

tff(pred_def_49411,type,
    v91419: state_type > $o ).

tff(pred_def_49412,type,
    v91418: state_type > $o ).

tff(pred_def_49413,type,
    v91417: state_type > $o ).

tff(pred_def_49414,type,
    v91416: state_type > $o ).

tff(pred_def_49415,type,
    v91415: state_type > $o ).

tff(pred_def_49416,type,
    v91414: state_type > $o ).

tff(pred_def_49417,type,
    v91413: state_type > $o ).

tff(pred_def_49418,type,
    v91412: state_type > $o ).

tff(pred_def_49419,type,
    v91411: state_type > $o ).

tff(pred_def_49420,type,
    v91489: state_type > $o ).

tff(pred_def_49421,type,
    v91488: state_type > $o ).

tff(pred_def_49422,type,
    v91487: state_type > $o ).

tff(pred_def_49423,type,
    v91486: state_type > $o ).

tff(pred_def_49424,type,
    v91485: state_type > $o ).

tff(pred_def_49425,type,
    v91484: state_type > $o ).

tff(pred_def_49426,type,
    v91483: state_type > $o ).

tff(pred_def_49427,type,
    v91482: state_type > $o ).

tff(pred_def_49428,type,
    v91481: state_type > $o ).

tff(pred_def_49429,type,
    v91480: state_type > $o ).

tff(pred_def_49430,type,
    v91479: state_type > $o ).

tff(pred_def_49431,type,
    v91478: state_type > $o ).

tff(pred_def_49432,type,
    v91477: state_type > $o ).

tff(pred_def_49433,type,
    v91476: state_type > $o ).

tff(pred_def_49434,type,
    v91475: state_type > $o ).

tff(pred_def_49435,type,
    v91474: state_type > $o ).

tff(pred_def_49436,type,
    v91473: state_type > $o ).

tff(pred_def_49437,type,
    v91472: state_type > $o ).

tff(pred_def_49438,type,
    v91471: state_type > $o ).

tff(pred_def_49439,type,
    v91470: state_type > $o ).

tff(pred_def_49440,type,
    v91469: state_type > $o ).

tff(pred_def_49441,type,
    v91468: state_type > $o ).

tff(pred_def_49442,type,
    v91467: state_type > $o ).

tff(pred_def_49443,type,
    v91466: state_type > $o ).

tff(pred_def_49444,type,
    v91465: state_type > $o ).

tff(pred_def_49445,type,
    v91464: state_type > $o ).

tff(pred_def_49446,type,
    v91463: state_type > $o ).

tff(pred_def_49447,type,
    v91462: state_type > $o ).

tff(pred_def_49448,type,
    v91461: state_type > $o ).

tff(pred_def_49449,type,
    v91460: state_type > $o ).

tff(pred_def_49450,type,
    v91459: state_type > $o ).

tff(pred_def_49451,type,
    v91458: state_type > $o ).

tff(pred_def_49452,type,
    v91457: state_type > $o ).

tff(pred_def_49453,type,
    v91456: state_type > $o ).

tff(pred_def_49454,type,
    v91455: state_type > $o ).

tff(pred_def_49455,type,
    v91454: state_type > $o ).

tff(pred_def_49456,type,
    v91453: state_type > $o ).

tff(pred_def_49457,type,
    v91452: state_type > $o ).

tff(pred_def_49458,type,
    v91451: state_type > $o ).

tff(pred_def_49459,type,
    v91522: state_type > $o ).

tff(pred_def_49460,type,
    v91521: state_type > $o ).

tff(pred_def_49461,type,
    v91520: state_type > $o ).

tff(pred_def_49462,type,
    v91519: state_type > $o ).

tff(pred_def_49463,type,
    v91518: state_type > $o ).

tff(pred_def_49464,type,
    v91517: state_type > $o ).

tff(pred_def_49465,type,
    v91516: state_type > $o ).

tff(pred_def_49466,type,
    v91515: state_type > $o ).

tff(pred_def_49467,type,
    v91514: state_type > $o ).

tff(pred_def_49468,type,
    v91513: state_type > $o ).

tff(pred_def_49469,type,
    v91512: state_type > $o ).

tff(pred_def_49470,type,
    v91511: state_type > $o ).

tff(pred_def_49471,type,
    v91510: state_type > $o ).

tff(pred_def_49472,type,
    v91509: state_type > $o ).

tff(pred_def_49473,type,
    v91508: state_type > $o ).

tff(pred_def_49474,type,
    v91507: state_type > $o ).

tff(pred_def_49475,type,
    v91506: state_type > $o ).

tff(pred_def_49476,type,
    v91505: state_type > $o ).

tff(pred_def_49477,type,
    v91504: state_type > $o ).

tff(pred_def_49478,type,
    v91503: state_type > $o ).

tff(pred_def_49479,type,
    v91502: state_type > $o ).

tff(pred_def_49480,type,
    v91501: state_type > $o ).

tff(pred_def_49481,type,
    v91500: state_type > $o ).

tff(pred_def_49482,type,
    v91499: state_type > $o ).

tff(pred_def_49483,type,
    v91498: state_type > $o ).

tff(pred_def_49484,type,
    v91497: state_type > $o ).

tff(pred_def_49485,type,
    v91496: state_type > $o ).

tff(pred_def_49486,type,
    v91495: state_type > $o ).

tff(pred_def_49487,type,
    v91494: state_type > $o ).

tff(pred_def_49488,type,
    v91493: state_type > $o ).

tff(pred_def_49489,type,
    v91492: state_type > $o ).

tff(pred_def_49490,type,
    v91491: state_type > $o ).

tff(pred_def_49491,type,
    v91562: state_type > $o ).

tff(pred_def_49492,type,
    v91561: state_type > $o ).

tff(pred_def_49493,type,
    v91560: state_type > $o ).

tff(pred_def_49494,type,
    v91559: state_type > $o ).

tff(pred_def_49495,type,
    v91558: state_type > $o ).

tff(pred_def_49496,type,
    v91557: state_type > $o ).

tff(pred_def_49497,type,
    v91556: state_type > $o ).

tff(pred_def_49498,type,
    v91555: state_type > $o ).

tff(pred_def_49499,type,
    v91554: state_type > $o ).

tff(pred_def_49500,type,
    v91553: state_type > $o ).

tff(pred_def_49501,type,
    v91552: state_type > $o ).

tff(pred_def_49502,type,
    v91551: state_type > $o ).

tff(pred_def_49503,type,
    v91550: state_type > $o ).

tff(pred_def_49504,type,
    v91549: state_type > $o ).

tff(pred_def_49505,type,
    v91548: state_type > $o ).

tff(pred_def_49506,type,
    v91547: state_type > $o ).

tff(pred_def_49507,type,
    v91546: state_type > $o ).

tff(pred_def_49508,type,
    v91545: state_type > $o ).

tff(pred_def_49509,type,
    v91544: state_type > $o ).

tff(pred_def_49510,type,
    v91543: state_type > $o ).

tff(pred_def_49511,type,
    v91542: state_type > $o ).

tff(pred_def_49512,type,
    v91541: state_type > $o ).

tff(pred_def_49513,type,
    v91540: state_type > $o ).

tff(pred_def_49514,type,
    v91539: state_type > $o ).

tff(pred_def_49515,type,
    v91538: state_type > $o ).

tff(pred_def_49516,type,
    v91537: state_type > $o ).

tff(pred_def_49517,type,
    v91536: state_type > $o ).

tff(pred_def_49518,type,
    v91535: state_type > $o ).

tff(pred_def_49519,type,
    v91534: state_type > $o ).

tff(pred_def_49520,type,
    v91533: state_type > $o ).

tff(pred_def_49521,type,
    v91532: state_type > $o ).

tff(pred_def_49522,type,
    v91531: state_type > $o ).

tff(pred_def_49523,type,
    v91530: state_type > $o ).

tff(pred_def_49524,type,
    v91529: state_type > $o ).

tff(pred_def_49525,type,
    v91528: state_type > $o ).

tff(pred_def_49526,type,
    v91527: state_type > $o ).

tff(pred_def_49527,type,
    v91526: state_type > $o ).

tff(pred_def_49528,type,
    v91525: state_type > $o ).

tff(pred_def_49529,type,
    v91524: state_type > $o ).

tff(pred_def_49530,type,
    v91087: ( state_type * $int ) > $o ).

tff(pred_def_49531,type,
    v91085: ( state_type * $int ) > $o ).

tff(pred_def_49532,type,
    v91083: ( state_type * $int ) > $o ).

tff(pred_def_49533,type,
    v91081: ( state_type * $int ) > $o ).

tff(pred_def_49534,type,
    v91079: ( state_type * $int ) > $o ).

tff(pred_def_49535,type,
    v91572: state_type > $o ).

tff(pred_def_49536,type,
    v91570: state_type > $o ).

tff(pred_def_49537,type,
    v91568: state_type > $o ).

tff(pred_def_49538,type,
    v91566: state_type > $o ).

tff(pred_def_49539,type,
    v91564: state_type > $o ).

tff(pred_def_49540,type,
    v91586: ( state_type * $int ) > $o ).

tff(pred_def_49541,type,
    v91622: state_type > $o ).

tff(pred_def_49542,type,
    v91621: state_type > $o ).

tff(pred_def_49543,type,
    v91620: state_type > $o ).

tff(pred_def_49544,type,
    v91619: state_type > $o ).

tff(pred_def_49545,type,
    v91618: state_type > $o ).

tff(pred_def_49546,type,
    v91617: state_type > $o ).

tff(pred_def_49547,type,
    v91616: state_type > $o ).

tff(pred_def_49548,type,
    v91615: state_type > $o ).

tff(pred_def_49549,type,
    v91614: state_type > $o ).

tff(pred_def_49550,type,
    v91613: state_type > $o ).

tff(pred_def_49551,type,
    v91612: state_type > $o ).

tff(pred_def_49552,type,
    v91611: state_type > $o ).

tff(pred_def_49553,type,
    v91610: state_type > $o ).

tff(pred_def_49554,type,
    v91609: state_type > $o ).

tff(pred_def_49555,type,
    v91608: state_type > $o ).

tff(pred_def_49556,type,
    v91607: state_type > $o ).

tff(pred_def_49557,type,
    v91606: state_type > $o ).

tff(pred_def_49558,type,
    v91605: state_type > $o ).

tff(pred_def_49559,type,
    v91604: state_type > $o ).

tff(pred_def_49560,type,
    v91603: state_type > $o ).

tff(pred_def_49561,type,
    v91602: state_type > $o ).

tff(pred_def_49562,type,
    v91601: state_type > $o ).

tff(pred_def_49563,type,
    v91600: state_type > $o ).

tff(pred_def_49564,type,
    v91599: state_type > $o ).

tff(pred_def_49565,type,
    v91598: state_type > $o ).

tff(pred_def_49566,type,
    v91597: state_type > $o ).

tff(pred_def_49567,type,
    v91596: state_type > $o ).

tff(pred_def_49568,type,
    v91595: state_type > $o ).

tff(pred_def_49569,type,
    v91594: state_type > $o ).

tff(pred_def_49570,type,
    v91593: state_type > $o ).

tff(pred_def_49571,type,
    v91592: state_type > $o ).

tff(pred_def_49572,type,
    v91591: state_type > $o ).

tff(pred_def_49573,type,
    v91590: state_type > $o ).

tff(pred_def_49574,type,
    v91589: state_type > $o ).

tff(pred_def_49575,type,
    v91588: state_type > $o ).

tff(pred_def_49576,type,
    v91584: ( state_type * $int ) > $o ).

tff(pred_def_49577,type,
    v91657: state_type > $o ).

tff(pred_def_49578,type,
    v91656: state_type > $o ).

tff(pred_def_49579,type,
    v91655: state_type > $o ).

tff(pred_def_49580,type,
    v91654: state_type > $o ).

tff(pred_def_49581,type,
    v91653: state_type > $o ).

tff(pred_def_49582,type,
    v91652: state_type > $o ).

tff(pred_def_49583,type,
    v91651: state_type > $o ).

tff(pred_def_49584,type,
    v91650: state_type > $o ).

tff(pred_def_49585,type,
    v91649: state_type > $o ).

tff(pred_def_49586,type,
    v91648: state_type > $o ).

tff(pred_def_49587,type,
    v91647: state_type > $o ).

tff(pred_def_49588,type,
    v91646: state_type > $o ).

tff(pred_def_49589,type,
    v91645: state_type > $o ).

tff(pred_def_49590,type,
    v91644: state_type > $o ).

tff(pred_def_49591,type,
    v91643: state_type > $o ).

tff(pred_def_49592,type,
    v91642: state_type > $o ).

tff(pred_def_49593,type,
    v91641: state_type > $o ).

tff(pred_def_49594,type,
    v91640: state_type > $o ).

tff(pred_def_49595,type,
    v91639: state_type > $o ).

tff(pred_def_49596,type,
    v91638: state_type > $o ).

tff(pred_def_49597,type,
    v91637: state_type > $o ).

tff(pred_def_49598,type,
    v91636: state_type > $o ).

tff(pred_def_49599,type,
    v91635: state_type > $o ).

tff(pred_def_49600,type,
    v91634: state_type > $o ).

tff(pred_def_49601,type,
    v91633: state_type > $o ).

tff(pred_def_49602,type,
    v91632: state_type > $o ).

tff(pred_def_49603,type,
    v91631: state_type > $o ).

tff(pred_def_49604,type,
    v91630: state_type > $o ).

tff(pred_def_49605,type,
    v91629: state_type > $o ).

tff(pred_def_49606,type,
    v91628: state_type > $o ).

tff(pred_def_49607,type,
    v91627: state_type > $o ).

tff(pred_def_49608,type,
    v91626: state_type > $o ).

tff(pred_def_49609,type,
    v91625: state_type > $o ).

tff(pred_def_49610,type,
    v91624: state_type > $o ).

tff(pred_def_49611,type,
    v91695: state_type > $o ).

tff(pred_def_49612,type,
    v91694: state_type > $o ).

tff(pred_def_49613,type,
    v91693: state_type > $o ).

tff(pred_def_49614,type,
    v91692: state_type > $o ).

tff(pred_def_49615,type,
    v91691: state_type > $o ).

tff(pred_def_49616,type,
    v91690: state_type > $o ).

tff(pred_def_49617,type,
    v91689: state_type > $o ).

tff(pred_def_49618,type,
    v91688: state_type > $o ).

tff(pred_def_49619,type,
    v91687: state_type > $o ).

tff(pred_def_49620,type,
    v91686: state_type > $o ).

tff(pred_def_49621,type,
    v91685: state_type > $o ).

tff(pred_def_49622,type,
    v91684: state_type > $o ).

tff(pred_def_49623,type,
    v91683: state_type > $o ).

tff(pred_def_49624,type,
    v91682: state_type > $o ).

tff(pred_def_49625,type,
    v91681: state_type > $o ).

tff(pred_def_49626,type,
    v91680: state_type > $o ).

tff(pred_def_49627,type,
    v91679: state_type > $o ).

tff(pred_def_49628,type,
    v91678: state_type > $o ).

tff(pred_def_49629,type,
    v91677: state_type > $o ).

tff(pred_def_49630,type,
    v91676: state_type > $o ).

tff(pred_def_49631,type,
    v91675: state_type > $o ).

tff(pred_def_49632,type,
    v91674: state_type > $o ).

tff(pred_def_49633,type,
    v91673: state_type > $o ).

tff(pred_def_49634,type,
    v91672: state_type > $o ).

tff(pred_def_49635,type,
    v91671: state_type > $o ).

tff(pred_def_49636,type,
    v91670: state_type > $o ).

tff(pred_def_49637,type,
    v91669: state_type > $o ).

tff(pred_def_49638,type,
    v91668: state_type > $o ).

tff(pred_def_49639,type,
    v91667: state_type > $o ).

tff(pred_def_49640,type,
    v91666: state_type > $o ).

tff(pred_def_49641,type,
    v91665: state_type > $o ).

tff(pred_def_49642,type,
    v91664: state_type > $o ).

tff(pred_def_49643,type,
    v91663: state_type > $o ).

tff(pred_def_49644,type,
    v91662: state_type > $o ).

tff(pred_def_49645,type,
    v91661: state_type > $o ).

tff(pred_def_49646,type,
    v91660: state_type > $o ).

tff(pred_def_49647,type,
    v91659: state_type > $o ).

tff(pred_def_49648,type,
    v91732: state_type > $o ).

tff(pred_def_49649,type,
    v91731: state_type > $o ).

tff(pred_def_49650,type,
    v91730: state_type > $o ).

tff(pred_def_49651,type,
    v91729: state_type > $o ).

tff(pred_def_49652,type,
    v91728: state_type > $o ).

tff(pred_def_49653,type,
    v91727: state_type > $o ).

tff(pred_def_49654,type,
    v91726: state_type > $o ).

tff(pred_def_49655,type,
    v91725: state_type > $o ).

tff(pred_def_49656,type,
    v91724: state_type > $o ).

tff(pred_def_49657,type,
    v91723: state_type > $o ).

tff(pred_def_49658,type,
    v91722: state_type > $o ).

tff(pred_def_49659,type,
    v91721: state_type > $o ).

tff(pred_def_49660,type,
    v91720: state_type > $o ).

tff(pred_def_49661,type,
    v91719: state_type > $o ).

tff(pred_def_49662,type,
    v91718: state_type > $o ).

tff(pred_def_49663,type,
    v91717: state_type > $o ).

tff(pred_def_49664,type,
    v91716: state_type > $o ).

tff(pred_def_49665,type,
    v91715: state_type > $o ).

tff(pred_def_49666,type,
    v91714: state_type > $o ).

tff(pred_def_49667,type,
    v91713: state_type > $o ).

tff(pred_def_49668,type,
    v91712: state_type > $o ).

tff(pred_def_49669,type,
    v91711: state_type > $o ).

tff(pred_def_49670,type,
    v91710: state_type > $o ).

tff(pred_def_49671,type,
    v91709: state_type > $o ).

tff(pred_def_49672,type,
    v91708: state_type > $o ).

tff(pred_def_49673,type,
    v91707: state_type > $o ).

tff(pred_def_49674,type,
    v91706: state_type > $o ).

tff(pred_def_49675,type,
    v91705: state_type > $o ).

tff(pred_def_49676,type,
    v91704: state_type > $o ).

tff(pred_def_49677,type,
    v91703: state_type > $o ).

tff(pred_def_49678,type,
    v91702: state_type > $o ).

tff(pred_def_49679,type,
    v91701: state_type > $o ).

tff(pred_def_49680,type,
    v91700: state_type > $o ).

tff(pred_def_49681,type,
    v91699: state_type > $o ).

tff(pred_def_49682,type,
    v91698: state_type > $o ).

tff(pred_def_49683,type,
    v91697: state_type > $o ).

tff(pred_def_49684,type,
    v91768: state_type > $o ).

tff(pred_def_49685,type,
    v91767: state_type > $o ).

tff(pred_def_49686,type,
    v91766: state_type > $o ).

tff(pred_def_49687,type,
    v91765: state_type > $o ).

tff(pred_def_49688,type,
    v91764: state_type > $o ).

tff(pred_def_49689,type,
    v91763: state_type > $o ).

tff(pred_def_49690,type,
    v91762: state_type > $o ).

tff(pred_def_49691,type,
    v91761: state_type > $o ).

tff(pred_def_49692,type,
    v91760: state_type > $o ).

tff(pred_def_49693,type,
    v91759: state_type > $o ).

tff(pred_def_49694,type,
    v91758: state_type > $o ).

tff(pred_def_49695,type,
    v91757: state_type > $o ).

tff(pred_def_49696,type,
    v91756: state_type > $o ).

tff(pred_def_49697,type,
    v91755: state_type > $o ).

tff(pred_def_49698,type,
    v91754: state_type > $o ).

tff(pred_def_49699,type,
    v91753: state_type > $o ).

tff(pred_def_49700,type,
    v91752: state_type > $o ).

tff(pred_def_49701,type,
    v91751: state_type > $o ).

tff(pred_def_49702,type,
    v91750: state_type > $o ).

tff(pred_def_49703,type,
    v91749: state_type > $o ).

tff(pred_def_49704,type,
    v91748: state_type > $o ).

tff(pred_def_49705,type,
    v91747: state_type > $o ).

tff(pred_def_49706,type,
    v91746: state_type > $o ).

tff(pred_def_49707,type,
    v91745: state_type > $o ).

tff(pred_def_49708,type,
    v91744: state_type > $o ).

tff(pred_def_49709,type,
    v91743: state_type > $o ).

tff(pred_def_49710,type,
    v91742: state_type > $o ).

tff(pred_def_49711,type,
    v91741: state_type > $o ).

tff(pred_def_49712,type,
    v91740: state_type > $o ).

tff(pred_def_49713,type,
    v91739: state_type > $o ).

tff(pred_def_49714,type,
    v91738: state_type > $o ).

tff(pred_def_49715,type,
    v91737: state_type > $o ).

tff(pred_def_49716,type,
    v91736: state_type > $o ).

tff(pred_def_49717,type,
    v91735: state_type > $o ).

tff(pred_def_49718,type,
    v91734: state_type > $o ).

tff(pred_def_49719,type,
    v91804: state_type > $o ).

tff(pred_def_49720,type,
    v91803: state_type > $o ).

tff(pred_def_49721,type,
    v91802: state_type > $o ).

tff(pred_def_49722,type,
    v91801: state_type > $o ).

tff(pred_def_49723,type,
    v91800: state_type > $o ).

tff(pred_def_49724,type,
    v91799: state_type > $o ).

tff(pred_def_49725,type,
    v91798: state_type > $o ).

tff(pred_def_49726,type,
    v91797: state_type > $o ).

tff(pred_def_49727,type,
    v91796: state_type > $o ).

tff(pred_def_49728,type,
    v91795: state_type > $o ).

tff(pred_def_49729,type,
    v91794: state_type > $o ).

tff(pred_def_49730,type,
    v91793: state_type > $o ).

tff(pred_def_49731,type,
    v91792: state_type > $o ).

tff(pred_def_49732,type,
    v91791: state_type > $o ).

tff(pred_def_49733,type,
    v91790: state_type > $o ).

tff(pred_def_49734,type,
    v91789: state_type > $o ).

tff(pred_def_49735,type,
    v91788: state_type > $o ).

tff(pred_def_49736,type,
    v91787: state_type > $o ).

tff(pred_def_49737,type,
    v91786: state_type > $o ).

tff(pred_def_49738,type,
    v91785: state_type > $o ).

tff(pred_def_49739,type,
    v91784: state_type > $o ).

tff(pred_def_49740,type,
    v91783: state_type > $o ).

tff(pred_def_49741,type,
    v91782: state_type > $o ).

tff(pred_def_49742,type,
    v91781: state_type > $o ).

tff(pred_def_49743,type,
    v91780: state_type > $o ).

tff(pred_def_49744,type,
    v91779: state_type > $o ).

tff(pred_def_49745,type,
    v91778: state_type > $o ).

tff(pred_def_49746,type,
    v91777: state_type > $o ).

tff(pred_def_49747,type,
    v91776: state_type > $o ).

tff(pred_def_49748,type,
    v91775: state_type > $o ).

tff(pred_def_49749,type,
    v91774: state_type > $o ).

tff(pred_def_49750,type,
    v91773: state_type > $o ).

tff(pred_def_49751,type,
    v91772: state_type > $o ).

tff(pred_def_49752,type,
    v91771: state_type > $o ).

tff(pred_def_49753,type,
    v91770: state_type > $o ).

tff(pred_def_49754,type,
    v91582: ( state_type * $int ) > $o ).

tff(pred_def_49755,type,
    v91580: ( state_type * $int ) > $o ).

tff(pred_def_49756,type,
    v91578: ( state_type * $int ) > $o ).

tff(pred_def_49757,type,
    v91576: ( state_type * $int ) > $o ).

tff(pred_def_49758,type,
    v91574: ( state_type * $int ) > $o ).

tff(pred_def_49759,type,
    v91815: state_type > $o ).

tff(pred_def_49760,type,
    v91813: state_type > $o ).

tff(pred_def_49761,type,
    v91811: state_type > $o ).

tff(pred_def_49762,type,
    v91809: state_type > $o ).

tff(pred_def_49763,type,
    v91807: state_type > $o ).

tff(pred_def_49764,type,
    v91819: state_type > $o ).

tff(pred_def_49765,type,
    v91818: ( state_type * $int ) > $o ).

tff(pred_def_49766,type,
    v91817: ( state_type * $int ) > $o ).

tff(pred_def_49767,type,
    v91822: state_type > $o ).

tff(pred_def_49768,type,
    v91821: ( state_type * $int ) > $o ).

tff(pred_def_49769,type,
    v91820: ( state_type * $int ) > $o ).

tff(pred_def_49770,type,
    v91077: ( state_type * $int ) > $o ).

tff(pred_def_49771,type,
    v91075: ( state_type * $int ) > $o ).

tff(pred_def_49772,type,
    v91073: ( state_type * $int ) > $o ).

tff(pred_def_49773,type,
    v91071: ( state_type * $int ) > $o ).

tff(pred_def_49774,type,
    v91069: ( state_type * $int ) > $o ).

tff(pred_def_49775,type,
    v91000: state_type > $o ).

tff(pred_def_49776,type,
    v90998: state_type > $o ).

tff(pred_def_49777,type,
    v90996: state_type > $o ).

tff(pred_def_49778,type,
    v90994: state_type > $o ).

tff(pred_def_49779,type,
    v90992: state_type > $o ).

tff(pred_def_49780,type,
    v91849: ( state_type * $int ) > $o ).

tff(pred_def_49781,type,
    v91847: ( state_type * $int ) > $o ).

tff(pred_def_49782,type,
    v91845: ( state_type * $int ) > $o ).

tff(pred_def_49783,type,
    v91860: state_type > $o ).

tff(pred_def_49784,type,
    v91858: state_type > $o ).

tff(pred_def_49785,type,
    v91856: state_type > $o ).

tff(pred_def_49786,type,
    v91854: state_type > $o ).

tff(pred_def_49787,type,
    v91852: state_type > $o ).

tff(pred_def_49788,type,
    v91866: ( state_type * $int ) > $o ).

tff(pred_def_49789,type,
    v91864: ( state_type * $int ) > $o ).

tff(pred_def_49790,type,
    v91862: ( state_type * $int ) > $o ).

tff(pred_def_49791,type,
    v91877: state_type > $o ).

tff(pred_def_49792,type,
    v91875: state_type > $o ).

tff(pred_def_49793,type,
    v91873: state_type > $o ).

tff(pred_def_49794,type,
    v91871: state_type > $o ).

tff(pred_def_49795,type,
    v91869: state_type > $o ).

tff(pred_def_49796,type,
    v91881: state_type > $o ).

tff(pred_def_49797,type,
    v91880: ( state_type * $int ) > $o ).

tff(pred_def_49798,type,
    v91879: ( state_type * $int ) > $o ).

tff(pred_def_49799,type,
    v91884: state_type > $o ).

tff(pred_def_49800,type,
    v91883: ( state_type * $int ) > $o ).

tff(pred_def_49801,type,
    v91882: ( state_type * $int ) > $o ).

tff(pred_def_49802,type,
    v91843: ( state_type * $int ) > $o ).

tff(pred_def_49803,type,
    v91841: ( state_type * $int ) > $o ).

tff(pred_def_49804,type,
    v91839: ( state_type * $int ) > $o ).

tff(pred_def_49805,type,
    v91837: ( state_type * $int ) > $o ).

tff(pred_def_49806,type,
    v91835: ( state_type * $int ) > $o ).

tff(pred_def_49807,type,
    v91915: ( state_type * $int ) > $o ).

tff(pred_def_49808,type,
    v91914: ( state_type * $int ) > $o ).

tff(pred_def_49809,type,
    v91912: ( state_type * $int ) > $o ).

tff(pred_def_49810,type,
    v91910: ( state_type * $int ) > $o ).

tff(pred_def_49811,type,
    v91908: ( state_type * $int ) > $o ).

tff(pred_def_49812,type,
    v91955: state_type > $o ).

tff(pred_def_49813,type,
    v91954: state_type > $o ).

tff(pred_def_49814,type,
    v91953: state_type > $o ).

tff(pred_def_49815,type,
    v91952: state_type > $o ).

tff(pred_def_49816,type,
    v91951: state_type > $o ).

tff(pred_def_49817,type,
    v91950: state_type > $o ).

tff(pred_def_49818,type,
    v91949: state_type > $o ).

tff(pred_def_49819,type,
    v91948: state_type > $o ).

tff(pred_def_49820,type,
    v91947: state_type > $o ).

tff(pred_def_49821,type,
    v91946: state_type > $o ).

tff(pred_def_49822,type,
    v91945: state_type > $o ).

tff(pred_def_49823,type,
    v91944: state_type > $o ).

tff(pred_def_49824,type,
    v91943: state_type > $o ).

tff(pred_def_49825,type,
    v91942: state_type > $o ).

tff(pred_def_49826,type,
    v91941: state_type > $o ).

tff(pred_def_49827,type,
    v91940: state_type > $o ).

tff(pred_def_49828,type,
    v91939: state_type > $o ).

tff(pred_def_49829,type,
    v91938: state_type > $o ).

tff(pred_def_49830,type,
    v91937: state_type > $o ).

tff(pred_def_49831,type,
    v91936: state_type > $o ).

tff(pred_def_49832,type,
    v91935: state_type > $o ).

tff(pred_def_49833,type,
    v91934: state_type > $o ).

tff(pred_def_49834,type,
    v91933: state_type > $o ).

tff(pred_def_49835,type,
    v91932: state_type > $o ).

tff(pred_def_49836,type,
    v91931: state_type > $o ).

tff(pred_def_49837,type,
    v91930: state_type > $o ).

tff(pred_def_49838,type,
    v91929: state_type > $o ).

tff(pred_def_49839,type,
    v91928: state_type > $o ).

tff(pred_def_49840,type,
    v91927: state_type > $o ).

tff(pred_def_49841,type,
    v91926: state_type > $o ).

tff(pred_def_49842,type,
    v91925: state_type > $o ).

tff(pred_def_49843,type,
    v91924: state_type > $o ).

tff(pred_def_49844,type,
    v91923: state_type > $o ).

tff(pred_def_49845,type,
    v91922: state_type > $o ).

tff(pred_def_49846,type,
    v91921: state_type > $o ).

tff(pred_def_49847,type,
    v91920: state_type > $o ).

tff(pred_def_49848,type,
    v91919: state_type > $o ).

tff(pred_def_49849,type,
    v91918: state_type > $o ).

tff(pred_def_49850,type,
    v91917: state_type > $o ).

tff(pred_def_49851,type,
    v91906: ( state_type * $int ) > $o ).

tff(pred_def_49852,type,
    v91989: state_type > $o ).

tff(pred_def_49853,type,
    v91988: state_type > $o ).

tff(pred_def_49854,type,
    v91987: state_type > $o ).

tff(pred_def_49855,type,
    v91986: state_type > $o ).

tff(pred_def_49856,type,
    v91985: state_type > $o ).

tff(pred_def_49857,type,
    v91984: state_type > $o ).

tff(pred_def_49858,type,
    v91983: state_type > $o ).

tff(pred_def_49859,type,
    v91982: state_type > $o ).

tff(pred_def_49860,type,
    v91981: state_type > $o ).

tff(pred_def_49861,type,
    v91980: state_type > $o ).

tff(pred_def_49862,type,
    v91979: state_type > $o ).

tff(pred_def_49863,type,
    v91978: state_type > $o ).

tff(pred_def_49864,type,
    v91977: state_type > $o ).

tff(pred_def_49865,type,
    v91976: state_type > $o ).

tff(pred_def_49866,type,
    v91975: state_type > $o ).

tff(pred_def_49867,type,
    v91974: state_type > $o ).

tff(pred_def_49868,type,
    v91973: state_type > $o ).

tff(pred_def_49869,type,
    v91972: state_type > $o ).

tff(pred_def_49870,type,
    v91971: state_type > $o ).

tff(pred_def_49871,type,
    v91970: state_type > $o ).

tff(pred_def_49872,type,
    v91969: state_type > $o ).

tff(pred_def_49873,type,
    v91968: state_type > $o ).

tff(pred_def_49874,type,
    v91967: state_type > $o ).

tff(pred_def_49875,type,
    v91966: state_type > $o ).

tff(pred_def_49876,type,
    v91965: state_type > $o ).

tff(pred_def_49877,type,
    v91964: state_type > $o ).

tff(pred_def_49878,type,
    v91963: state_type > $o ).

tff(pred_def_49879,type,
    v91962: state_type > $o ).

tff(pred_def_49880,type,
    v91961: state_type > $o ).

tff(pred_def_49881,type,
    v91960: state_type > $o ).

tff(pred_def_49882,type,
    v91959: state_type > $o ).

tff(pred_def_49883,type,
    v91958: state_type > $o ).

tff(pred_def_49884,type,
    v91957: state_type > $o ).

tff(pred_def_49885,type,
    v92023: state_type > $o ).

tff(pred_def_49886,type,
    v92022: state_type > $o ).

tff(pred_def_49887,type,
    v92021: state_type > $o ).

tff(pred_def_49888,type,
    v92020: state_type > $o ).

tff(pred_def_49889,type,
    v92019: state_type > $o ).

tff(pred_def_49890,type,
    v92018: state_type > $o ).

tff(pred_def_49891,type,
    v92017: state_type > $o ).

tff(pred_def_49892,type,
    v92016: state_type > $o ).

tff(pred_def_49893,type,
    v92015: state_type > $o ).

tff(pred_def_49894,type,
    v92014: state_type > $o ).

tff(pred_def_49895,type,
    v92013: state_type > $o ).

tff(pred_def_49896,type,
    v92012: state_type > $o ).

tff(pred_def_49897,type,
    v92011: state_type > $o ).

tff(pred_def_49898,type,
    v92010: state_type > $o ).

tff(pred_def_49899,type,
    v92009: state_type > $o ).

tff(pred_def_49900,type,
    v92008: state_type > $o ).

tff(pred_def_49901,type,
    v92007: state_type > $o ).

tff(pred_def_49902,type,
    v92006: state_type > $o ).

tff(pred_def_49903,type,
    v92005: state_type > $o ).

tff(pred_def_49904,type,
    v92004: state_type > $o ).

tff(pred_def_49905,type,
    v92003: state_type > $o ).

tff(pred_def_49906,type,
    v92002: state_type > $o ).

tff(pred_def_49907,type,
    v92001: state_type > $o ).

tff(pred_def_49908,type,
    v92000: state_type > $o ).

tff(pred_def_49909,type,
    v91999: state_type > $o ).

tff(pred_def_49910,type,
    v91998: state_type > $o ).

tff(pred_def_49911,type,
    v91997: state_type > $o ).

tff(pred_def_49912,type,
    v91996: state_type > $o ).

tff(pred_def_49913,type,
    v91995: state_type > $o ).

tff(pred_def_49914,type,
    v91994: state_type > $o ).

tff(pred_def_49915,type,
    v91993: state_type > $o ).

tff(pred_def_49916,type,
    v91992: state_type > $o ).

tff(pred_def_49917,type,
    v91991: state_type > $o ).

tff(pred_def_49918,type,
    v92063: state_type > $o ).

tff(pred_def_49919,type,
    v92062: state_type > $o ).

tff(pred_def_49920,type,
    v92061: state_type > $o ).

tff(pred_def_49921,type,
    v92060: state_type > $o ).

tff(pred_def_49922,type,
    v92059: state_type > $o ).

tff(pred_def_49923,type,
    v92058: state_type > $o ).

tff(pred_def_49924,type,
    v92057: state_type > $o ).

tff(pred_def_49925,type,
    v92056: state_type > $o ).

tff(pred_def_49926,type,
    v92055: state_type > $o ).

tff(pred_def_49927,type,
    v92054: state_type > $o ).

tff(pred_def_49928,type,
    v92053: state_type > $o ).

tff(pred_def_49929,type,
    v92052: state_type > $o ).

tff(pred_def_49930,type,
    v92051: state_type > $o ).

tff(pred_def_49931,type,
    v92050: state_type > $o ).

tff(pred_def_49932,type,
    v92049: state_type > $o ).

tff(pred_def_49933,type,
    v92048: state_type > $o ).

tff(pred_def_49934,type,
    v92047: state_type > $o ).

tff(pred_def_49935,type,
    v92046: state_type > $o ).

tff(pred_def_49936,type,
    v92045: state_type > $o ).

tff(pred_def_49937,type,
    v92044: state_type > $o ).

tff(pred_def_49938,type,
    v92043: state_type > $o ).

tff(pred_def_49939,type,
    v92042: state_type > $o ).

tff(pred_def_49940,type,
    v92041: state_type > $o ).

tff(pred_def_49941,type,
    v92040: state_type > $o ).

tff(pred_def_49942,type,
    v92039: state_type > $o ).

tff(pred_def_49943,type,
    v92038: state_type > $o ).

tff(pred_def_49944,type,
    v92037: state_type > $o ).

tff(pred_def_49945,type,
    v92036: state_type > $o ).

tff(pred_def_49946,type,
    v92035: state_type > $o ).

tff(pred_def_49947,type,
    v92034: state_type > $o ).

tff(pred_def_49948,type,
    v92033: state_type > $o ).

tff(pred_def_49949,type,
    v92032: state_type > $o ).

tff(pred_def_49950,type,
    v92031: state_type > $o ).

tff(pred_def_49951,type,
    v92030: state_type > $o ).

tff(pred_def_49952,type,
    v92029: state_type > $o ).

tff(pred_def_49953,type,
    v92028: state_type > $o ).

tff(pred_def_49954,type,
    v92027: state_type > $o ).

tff(pred_def_49955,type,
    v92026: state_type > $o ).

tff(pred_def_49956,type,
    v92025: state_type > $o ).

tff(pred_def_49957,type,
    v92102: state_type > $o ).

tff(pred_def_49958,type,
    v92101: state_type > $o ).

tff(pred_def_49959,type,
    v92100: state_type > $o ).

tff(pred_def_49960,type,
    v92099: state_type > $o ).

tff(pred_def_49961,type,
    v92098: state_type > $o ).

tff(pred_def_49962,type,
    v92097: state_type > $o ).

tff(pred_def_49963,type,
    v92096: state_type > $o ).

tff(pred_def_49964,type,
    v92095: state_type > $o ).

tff(pred_def_49965,type,
    v92094: state_type > $o ).

tff(pred_def_49966,type,
    v92093: state_type > $o ).

tff(pred_def_49967,type,
    v92092: state_type > $o ).

tff(pred_def_49968,type,
    v92091: state_type > $o ).

tff(pred_def_49969,type,
    v92090: state_type > $o ).

tff(pred_def_49970,type,
    v92089: state_type > $o ).

tff(pred_def_49971,type,
    v92088: state_type > $o ).

tff(pred_def_49972,type,
    v92087: state_type > $o ).

tff(pred_def_49973,type,
    v92086: state_type > $o ).

tff(pred_def_49974,type,
    v92085: state_type > $o ).

tff(pred_def_49975,type,
    v92084: state_type > $o ).

tff(pred_def_49976,type,
    v92083: state_type > $o ).

tff(pred_def_49977,type,
    v92082: state_type > $o ).

tff(pred_def_49978,type,
    v92081: state_type > $o ).

tff(pred_def_49979,type,
    v92080: state_type > $o ).

tff(pred_def_49980,type,
    v92079: state_type > $o ).

tff(pred_def_49981,type,
    v92078: state_type > $o ).

tff(pred_def_49982,type,
    v92077: state_type > $o ).

tff(pred_def_49983,type,
    v92076: state_type > $o ).

tff(pred_def_49984,type,
    v92075: state_type > $o ).

tff(pred_def_49985,type,
    v92074: state_type > $o ).

tff(pred_def_49986,type,
    v92073: state_type > $o ).

tff(pred_def_49987,type,
    v92072: state_type > $o ).

tff(pred_def_49988,type,
    v92071: state_type > $o ).

tff(pred_def_49989,type,
    v92070: state_type > $o ).

tff(pred_def_49990,type,
    v92069: state_type > $o ).

tff(pred_def_49991,type,
    v92068: state_type > $o ).

tff(pred_def_49992,type,
    v92067: state_type > $o ).

tff(pred_def_49993,type,
    v92066: state_type > $o ).

tff(pred_def_49994,type,
    v92065: state_type > $o ).

tff(pred_def_49995,type,
    v92141: state_type > $o ).

tff(pred_def_49996,type,
    v92140: state_type > $o ).

tff(pred_def_49997,type,
    v92139: state_type > $o ).

tff(pred_def_49998,type,
    v92138: state_type > $o ).

tff(pred_def_49999,type,
    v92137: state_type > $o ).

tff(pred_def_50000,type,
    v92136: state_type > $o ).

tff(pred_def_50001,type,
    v92135: state_type > $o ).

tff(pred_def_50002,type,
    v92134: state_type > $o ).

tff(pred_def_50003,type,
    v92133: state_type > $o ).

tff(pred_def_50004,type,
    v92132: state_type > $o ).

tff(pred_def_50005,type,
    v92131: state_type > $o ).

tff(pred_def_50006,type,
    v92130: state_type > $o ).

tff(pred_def_50007,type,
    v92129: state_type > $o ).

tff(pred_def_50008,type,
    v92128: state_type > $o ).

tff(pred_def_50009,type,
    v92127: state_type > $o ).

tff(pred_def_50010,type,
    v92126: state_type > $o ).

tff(pred_def_50011,type,
    v92125: state_type > $o ).

tff(pred_def_50012,type,
    v92124: state_type > $o ).

tff(pred_def_50013,type,
    v92123: state_type > $o ).

tff(pred_def_50014,type,
    v92122: state_type > $o ).

tff(pred_def_50015,type,
    v92121: state_type > $o ).

tff(pred_def_50016,type,
    v92120: state_type > $o ).

tff(pred_def_50017,type,
    v92119: state_type > $o ).

tff(pred_def_50018,type,
    v92118: state_type > $o ).

tff(pred_def_50019,type,
    v92117: state_type > $o ).

tff(pred_def_50020,type,
    v92116: state_type > $o ).

tff(pred_def_50021,type,
    v92115: state_type > $o ).

tff(pred_def_50022,type,
    v92114: state_type > $o ).

tff(pred_def_50023,type,
    v92113: state_type > $o ).

tff(pred_def_50024,type,
    v92112: state_type > $o ).

tff(pred_def_50025,type,
    v92111: state_type > $o ).

tff(pred_def_50026,type,
    v92110: state_type > $o ).

tff(pred_def_50027,type,
    v92109: state_type > $o ).

tff(pred_def_50028,type,
    v92108: state_type > $o ).

tff(pred_def_50029,type,
    v92107: state_type > $o ).

tff(pred_def_50030,type,
    v92106: state_type > $o ).

tff(pred_def_50031,type,
    v92105: state_type > $o ).

tff(pred_def_50032,type,
    v92104: state_type > $o ).

tff(pred_def_50033,type,
    v92184: state_type > $o ).

tff(pred_def_50034,type,
    v92183: state_type > $o ).

tff(pred_def_50035,type,
    v92182: state_type > $o ).

tff(pred_def_50036,type,
    v92181: state_type > $o ).

tff(pred_def_50037,type,
    v92180: state_type > $o ).

tff(pred_def_50038,type,
    v92179: state_type > $o ).

tff(pred_def_50039,type,
    v92178: state_type > $o ).

tff(pred_def_50040,type,
    v92177: state_type > $o ).

tff(pred_def_50041,type,
    v92176: state_type > $o ).

tff(pred_def_50042,type,
    v92175: state_type > $o ).

tff(pred_def_50043,type,
    v92174: state_type > $o ).

tff(pred_def_50044,type,
    v92173: state_type > $o ).

tff(pred_def_50045,type,
    v92172: state_type > $o ).

tff(pred_def_50046,type,
    v92171: state_type > $o ).

tff(pred_def_50047,type,
    v92170: state_type > $o ).

tff(pred_def_50048,type,
    v92169: state_type > $o ).

tff(pred_def_50049,type,
    v92168: state_type > $o ).

tff(pred_def_50050,type,
    v92167: state_type > $o ).

tff(pred_def_50051,type,
    v92166: state_type > $o ).

tff(pred_def_50052,type,
    v92165: state_type > $o ).

tff(pred_def_50053,type,
    v92164: state_type > $o ).

tff(pred_def_50054,type,
    v92163: state_type > $o ).

tff(pred_def_50055,type,
    v92162: state_type > $o ).

tff(pred_def_50056,type,
    v92161: state_type > $o ).

tff(pred_def_50057,type,
    v92160: state_type > $o ).

tff(pred_def_50058,type,
    v92159: state_type > $o ).

tff(pred_def_50059,type,
    v92158: state_type > $o ).

tff(pred_def_50060,type,
    v92157: state_type > $o ).

tff(pred_def_50061,type,
    v92156: state_type > $o ).

tff(pred_def_50062,type,
    v92155: state_type > $o ).

tff(pred_def_50063,type,
    v92154: state_type > $o ).

tff(pred_def_50064,type,
    v92153: state_type > $o ).

tff(pred_def_50065,type,
    v92152: state_type > $o ).

tff(pred_def_50066,type,
    v92151: state_type > $o ).

tff(pred_def_50067,type,
    v92150: state_type > $o ).

tff(pred_def_50068,type,
    v92149: state_type > $o ).

tff(pred_def_50069,type,
    v92148: state_type > $o ).

tff(pred_def_50070,type,
    v92147: state_type > $o ).

tff(pred_def_50071,type,
    v92146: state_type > $o ).

tff(pred_def_50072,type,
    v92145: state_type > $o ).

tff(pred_def_50073,type,
    v92144: state_type > $o ).

tff(pred_def_50074,type,
    v92143: state_type > $o ).

tff(pred_def_50075,type,
    v92226: state_type > $o ).

tff(pred_def_50076,type,
    v92225: state_type > $o ).

tff(pred_def_50077,type,
    v92224: state_type > $o ).

tff(pred_def_50078,type,
    v92223: state_type > $o ).

tff(pred_def_50079,type,
    v92222: state_type > $o ).

tff(pred_def_50080,type,
    v92221: state_type > $o ).

tff(pred_def_50081,type,
    v92220: state_type > $o ).

tff(pred_def_50082,type,
    v92219: state_type > $o ).

tff(pred_def_50083,type,
    v92218: state_type > $o ).

tff(pred_def_50084,type,
    v92217: state_type > $o ).

tff(pred_def_50085,type,
    v92216: state_type > $o ).

tff(pred_def_50086,type,
    v92215: state_type > $o ).

tff(pred_def_50087,type,
    v92214: state_type > $o ).

tff(pred_def_50088,type,
    v92213: state_type > $o ).

tff(pred_def_50089,type,
    v92212: state_type > $o ).

tff(pred_def_50090,type,
    v92211: state_type > $o ).

tff(pred_def_50091,type,
    v92210: state_type > $o ).

tff(pred_def_50092,type,
    v92209: state_type > $o ).

tff(pred_def_50093,type,
    v92208: state_type > $o ).

tff(pred_def_50094,type,
    v92207: state_type > $o ).

tff(pred_def_50095,type,
    v92206: state_type > $o ).

tff(pred_def_50096,type,
    v92205: state_type > $o ).

tff(pred_def_50097,type,
    v92204: state_type > $o ).

tff(pred_def_50098,type,
    v92203: state_type > $o ).

tff(pred_def_50099,type,
    v92202: state_type > $o ).

tff(pred_def_50100,type,
    v92201: state_type > $o ).

tff(pred_def_50101,type,
    v92200: state_type > $o ).

tff(pred_def_50102,type,
    v92199: state_type > $o ).

tff(pred_def_50103,type,
    v92198: state_type > $o ).

tff(pred_def_50104,type,
    v92197: state_type > $o ).

tff(pred_def_50105,type,
    v92196: state_type > $o ).

tff(pred_def_50106,type,
    v92195: state_type > $o ).

tff(pred_def_50107,type,
    v92194: state_type > $o ).

tff(pred_def_50108,type,
    v92193: state_type > $o ).

tff(pred_def_50109,type,
    v92192: state_type > $o ).

tff(pred_def_50110,type,
    v92191: state_type > $o ).

tff(pred_def_50111,type,
    v92190: state_type > $o ).

tff(pred_def_50112,type,
    v92189: state_type > $o ).

tff(pred_def_50113,type,
    v92188: state_type > $o ).

tff(pred_def_50114,type,
    v92187: state_type > $o ).

tff(pred_def_50115,type,
    v92186: state_type > $o ).

tff(pred_def_50116,type,
    v92266: state_type > $o ).

tff(pred_def_50117,type,
    v92265: state_type > $o ).

tff(pred_def_50118,type,
    v92264: state_type > $o ).

tff(pred_def_50119,type,
    v92263: state_type > $o ).

tff(pred_def_50120,type,
    v92262: state_type > $o ).

tff(pred_def_50121,type,
    v92261: state_type > $o ).

tff(pred_def_50122,type,
    v92260: state_type > $o ).

tff(pred_def_50123,type,
    v92259: state_type > $o ).

tff(pred_def_50124,type,
    v92258: state_type > $o ).

tff(pred_def_50125,type,
    v92257: state_type > $o ).

tff(pred_def_50126,type,
    v92256: state_type > $o ).

tff(pred_def_50127,type,
    v92255: state_type > $o ).

tff(pred_def_50128,type,
    v92254: state_type > $o ).

tff(pred_def_50129,type,
    v92253: state_type > $o ).

tff(pred_def_50130,type,
    v92252: state_type > $o ).

tff(pred_def_50131,type,
    v92251: state_type > $o ).

tff(pred_def_50132,type,
    v92250: state_type > $o ).

tff(pred_def_50133,type,
    v92249: state_type > $o ).

tff(pred_def_50134,type,
    v92248: state_type > $o ).

tff(pred_def_50135,type,
    v92247: state_type > $o ).

tff(pred_def_50136,type,
    v92246: state_type > $o ).

tff(pred_def_50137,type,
    v92245: state_type > $o ).

tff(pred_def_50138,type,
    v92244: state_type > $o ).

tff(pred_def_50139,type,
    v92243: state_type > $o ).

tff(pred_def_50140,type,
    v92242: state_type > $o ).

tff(pred_def_50141,type,
    v92241: state_type > $o ).

tff(pred_def_50142,type,
    v92240: state_type > $o ).

tff(pred_def_50143,type,
    v92239: state_type > $o ).

tff(pred_def_50144,type,
    v92238: state_type > $o ).

tff(pred_def_50145,type,
    v92237: state_type > $o ).

tff(pred_def_50146,type,
    v92236: state_type > $o ).

tff(pred_def_50147,type,
    v92235: state_type > $o ).

tff(pred_def_50148,type,
    v92234: state_type > $o ).

tff(pred_def_50149,type,
    v92233: state_type > $o ).

tff(pred_def_50150,type,
    v92232: state_type > $o ).

tff(pred_def_50151,type,
    v92231: state_type > $o ).

tff(pred_def_50152,type,
    v92230: state_type > $o ).

tff(pred_def_50153,type,
    v92229: state_type > $o ).

tff(pred_def_50154,type,
    v92228: state_type > $o ).

tff(pred_def_50155,type,
    v92306: state_type > $o ).

tff(pred_def_50156,type,
    v92305: state_type > $o ).

tff(pred_def_50157,type,
    v92304: state_type > $o ).

tff(pred_def_50158,type,
    v92303: state_type > $o ).

tff(pred_def_50159,type,
    v92302: state_type > $o ).

tff(pred_def_50160,type,
    v92301: state_type > $o ).

tff(pred_def_50161,type,
    v92300: state_type > $o ).

tff(pred_def_50162,type,
    v92299: state_type > $o ).

tff(pred_def_50163,type,
    v92298: state_type > $o ).

tff(pred_def_50164,type,
    v92297: state_type > $o ).

tff(pred_def_50165,type,
    v92296: state_type > $o ).

tff(pred_def_50166,type,
    v92295: state_type > $o ).

tff(pred_def_50167,type,
    v92294: state_type > $o ).

tff(pred_def_50168,type,
    v92293: state_type > $o ).

tff(pred_def_50169,type,
    v92292: state_type > $o ).

tff(pred_def_50170,type,
    v92291: state_type > $o ).

tff(pred_def_50171,type,
    v92290: state_type > $o ).

tff(pred_def_50172,type,
    v92289: state_type > $o ).

tff(pred_def_50173,type,
    v92288: state_type > $o ).

tff(pred_def_50174,type,
    v92287: state_type > $o ).

tff(pred_def_50175,type,
    v92286: state_type > $o ).

tff(pred_def_50176,type,
    v92285: state_type > $o ).

tff(pred_def_50177,type,
    v92284: state_type > $o ).

tff(pred_def_50178,type,
    v92283: state_type > $o ).

tff(pred_def_50179,type,
    v92282: state_type > $o ).

tff(pred_def_50180,type,
    v92281: state_type > $o ).

tff(pred_def_50181,type,
    v92280: state_type > $o ).

tff(pred_def_50182,type,
    v92279: state_type > $o ).

tff(pred_def_50183,type,
    v92278: state_type > $o ).

tff(pred_def_50184,type,
    v92277: state_type > $o ).

tff(pred_def_50185,type,
    v92276: state_type > $o ).

tff(pred_def_50186,type,
    v92275: state_type > $o ).

tff(pred_def_50187,type,
    v92274: state_type > $o ).

tff(pred_def_50188,type,
    v92273: state_type > $o ).

tff(pred_def_50189,type,
    v92272: state_type > $o ).

tff(pred_def_50190,type,
    v92271: state_type > $o ).

tff(pred_def_50191,type,
    v92270: state_type > $o ).

tff(pred_def_50192,type,
    v92269: state_type > $o ).

tff(pred_def_50193,type,
    v92268: state_type > $o ).

tff(pred_def_50194,type,
    v92339: state_type > $o ).

tff(pred_def_50195,type,
    v92338: state_type > $o ).

tff(pred_def_50196,type,
    v92337: state_type > $o ).

tff(pred_def_50197,type,
    v92336: state_type > $o ).

tff(pred_def_50198,type,
    v92335: state_type > $o ).

tff(pred_def_50199,type,
    v92334: state_type > $o ).

tff(pred_def_50200,type,
    v92333: state_type > $o ).

tff(pred_def_50201,type,
    v92332: state_type > $o ).

tff(pred_def_50202,type,
    v92331: state_type > $o ).

tff(pred_def_50203,type,
    v92330: state_type > $o ).

tff(pred_def_50204,type,
    v92329: state_type > $o ).

tff(pred_def_50205,type,
    v92328: state_type > $o ).

tff(pred_def_50206,type,
    v92327: state_type > $o ).

tff(pred_def_50207,type,
    v92326: state_type > $o ).

tff(pred_def_50208,type,
    v92325: state_type > $o ).

tff(pred_def_50209,type,
    v92324: state_type > $o ).

tff(pred_def_50210,type,
    v92323: state_type > $o ).

tff(pred_def_50211,type,
    v92322: state_type > $o ).

tff(pred_def_50212,type,
    v92321: state_type > $o ).

tff(pred_def_50213,type,
    v92320: state_type > $o ).

tff(pred_def_50214,type,
    v92319: state_type > $o ).

tff(pred_def_50215,type,
    v92318: state_type > $o ).

tff(pred_def_50216,type,
    v92317: state_type > $o ).

tff(pred_def_50217,type,
    v92316: state_type > $o ).

tff(pred_def_50218,type,
    v92315: state_type > $o ).

tff(pred_def_50219,type,
    v92314: state_type > $o ).

tff(pred_def_50220,type,
    v92313: state_type > $o ).

tff(pred_def_50221,type,
    v92312: state_type > $o ).

tff(pred_def_50222,type,
    v92311: state_type > $o ).

tff(pred_def_50223,type,
    v92310: state_type > $o ).

tff(pred_def_50224,type,
    v92309: state_type > $o ).

tff(pred_def_50225,type,
    v92308: state_type > $o ).

tff(pred_def_50226,type,
    v92379: state_type > $o ).

tff(pred_def_50227,type,
    v92378: state_type > $o ).

tff(pred_def_50228,type,
    v92377: state_type > $o ).

tff(pred_def_50229,type,
    v92376: state_type > $o ).

tff(pred_def_50230,type,
    v92375: state_type > $o ).

tff(pred_def_50231,type,
    v92374: state_type > $o ).

tff(pred_def_50232,type,
    v92373: state_type > $o ).

tff(pred_def_50233,type,
    v92372: state_type > $o ).

tff(pred_def_50234,type,
    v92371: state_type > $o ).

tff(pred_def_50235,type,
    v92370: state_type > $o ).

tff(pred_def_50236,type,
    v92369: state_type > $o ).

tff(pred_def_50237,type,
    v92368: state_type > $o ).

tff(pred_def_50238,type,
    v92367: state_type > $o ).

tff(pred_def_50239,type,
    v92366: state_type > $o ).

tff(pred_def_50240,type,
    v92365: state_type > $o ).

tff(pred_def_50241,type,
    v92364: state_type > $o ).

tff(pred_def_50242,type,
    v92363: state_type > $o ).

tff(pred_def_50243,type,
    v92362: state_type > $o ).

tff(pred_def_50244,type,
    v92361: state_type > $o ).

tff(pred_def_50245,type,
    v92360: state_type > $o ).

tff(pred_def_50246,type,
    v92359: state_type > $o ).

tff(pred_def_50247,type,
    v92358: state_type > $o ).

tff(pred_def_50248,type,
    v92357: state_type > $o ).

tff(pred_def_50249,type,
    v92356: state_type > $o ).

tff(pred_def_50250,type,
    v92355: state_type > $o ).

tff(pred_def_50251,type,
    v92354: state_type > $o ).

tff(pred_def_50252,type,
    v92353: state_type > $o ).

tff(pred_def_50253,type,
    v92352: state_type > $o ).

tff(pred_def_50254,type,
    v92351: state_type > $o ).

tff(pred_def_50255,type,
    v92350: state_type > $o ).

tff(pred_def_50256,type,
    v92349: state_type > $o ).

tff(pred_def_50257,type,
    v92348: state_type > $o ).

tff(pred_def_50258,type,
    v92347: state_type > $o ).

tff(pred_def_50259,type,
    v92346: state_type > $o ).

tff(pred_def_50260,type,
    v92345: state_type > $o ).

tff(pred_def_50261,type,
    v92344: state_type > $o ).

tff(pred_def_50262,type,
    v92343: state_type > $o ).

tff(pred_def_50263,type,
    v92342: state_type > $o ).

tff(pred_def_50264,type,
    v92341: state_type > $o ).

tff(pred_def_50265,type,
    v91904: ( state_type * $int ) > $o ).

tff(pred_def_50266,type,
    v91902: ( state_type * $int ) > $o ).

tff(pred_def_50267,type,
    v91900: ( state_type * $int ) > $o ).

tff(pred_def_50268,type,
    v91898: ( state_type * $int ) > $o ).

tff(pred_def_50269,type,
    v91896: ( state_type * $int ) > $o ).

tff(pred_def_50270,type,
    v92389: state_type > $o ).

tff(pred_def_50271,type,
    v92387: state_type > $o ).

tff(pred_def_50272,type,
    v92385: state_type > $o ).

tff(pred_def_50273,type,
    v92383: state_type > $o ).

tff(pred_def_50274,type,
    v92381: state_type > $o ).

tff(pred_def_50275,type,
    v92403: ( state_type * $int ) > $o ).

tff(pred_def_50276,type,
    v92439: state_type > $o ).

tff(pred_def_50277,type,
    v92438: state_type > $o ).

tff(pred_def_50278,type,
    v92437: state_type > $o ).

tff(pred_def_50279,type,
    v92436: state_type > $o ).

tff(pred_def_50280,type,
    v92435: state_type > $o ).

tff(pred_def_50281,type,
    v92434: state_type > $o ).

tff(pred_def_50282,type,
    v92433: state_type > $o ).

tff(pred_def_50283,type,
    v92432: state_type > $o ).

tff(pred_def_50284,type,
    v92431: state_type > $o ).

tff(pred_def_50285,type,
    v92430: state_type > $o ).

tff(pred_def_50286,type,
    v92429: state_type > $o ).

tff(pred_def_50287,type,
    v92428: state_type > $o ).

tff(pred_def_50288,type,
    v92427: state_type > $o ).

tff(pred_def_50289,type,
    v92426: state_type > $o ).

tff(pred_def_50290,type,
    v92425: state_type > $o ).

tff(pred_def_50291,type,
    v92424: state_type > $o ).

tff(pred_def_50292,type,
    v92423: state_type > $o ).

tff(pred_def_50293,type,
    v92422: state_type > $o ).

tff(pred_def_50294,type,
    v92421: state_type > $o ).

tff(pred_def_50295,type,
    v92420: state_type > $o ).

tff(pred_def_50296,type,
    v92419: state_type > $o ).

tff(pred_def_50297,type,
    v92418: state_type > $o ).

tff(pred_def_50298,type,
    v92417: state_type > $o ).

tff(pred_def_50299,type,
    v92416: state_type > $o ).

tff(pred_def_50300,type,
    v92415: state_type > $o ).

tff(pred_def_50301,type,
    v92414: state_type > $o ).

tff(pred_def_50302,type,
    v92413: state_type > $o ).

tff(pred_def_50303,type,
    v92412: state_type > $o ).

tff(pred_def_50304,type,
    v92411: state_type > $o ).

tff(pred_def_50305,type,
    v92410: state_type > $o ).

tff(pred_def_50306,type,
    v92409: state_type > $o ).

tff(pred_def_50307,type,
    v92408: state_type > $o ).

tff(pred_def_50308,type,
    v92407: state_type > $o ).

tff(pred_def_50309,type,
    v92406: state_type > $o ).

tff(pred_def_50310,type,
    v92405: state_type > $o ).

tff(pred_def_50311,type,
    v92401: ( state_type * $int ) > $o ).

tff(pred_def_50312,type,
    v92474: state_type > $o ).

tff(pred_def_50313,type,
    v92473: state_type > $o ).

tff(pred_def_50314,type,
    v92472: state_type > $o ).

tff(pred_def_50315,type,
    v92471: state_type > $o ).

tff(pred_def_50316,type,
    v92470: state_type > $o ).

tff(pred_def_50317,type,
    v92469: state_type > $o ).

tff(pred_def_50318,type,
    v92468: state_type > $o ).

tff(pred_def_50319,type,
    v92467: state_type > $o ).

tff(pred_def_50320,type,
    v92466: state_type > $o ).

tff(pred_def_50321,type,
    v92465: state_type > $o ).

tff(pred_def_50322,type,
    v92464: state_type > $o ).

tff(pred_def_50323,type,
    v92463: state_type > $o ).

tff(pred_def_50324,type,
    v92462: state_type > $o ).

tff(pred_def_50325,type,
    v92461: state_type > $o ).

tff(pred_def_50326,type,
    v92460: state_type > $o ).

tff(pred_def_50327,type,
    v92459: state_type > $o ).

tff(pred_def_50328,type,
    v92458: state_type > $o ).

tff(pred_def_50329,type,
    v92457: state_type > $o ).

tff(pred_def_50330,type,
    v92456: state_type > $o ).

tff(pred_def_50331,type,
    v92455: state_type > $o ).

tff(pred_def_50332,type,
    v92454: state_type > $o ).

tff(pred_def_50333,type,
    v92453: state_type > $o ).

tff(pred_def_50334,type,
    v92452: state_type > $o ).

tff(pred_def_50335,type,
    v92451: state_type > $o ).

tff(pred_def_50336,type,
    v92450: state_type > $o ).

tff(pred_def_50337,type,
    v92449: state_type > $o ).

tff(pred_def_50338,type,
    v92448: state_type > $o ).

tff(pred_def_50339,type,
    v92447: state_type > $o ).

tff(pred_def_50340,type,
    v92446: state_type > $o ).

tff(pred_def_50341,type,
    v92445: state_type > $o ).

tff(pred_def_50342,type,
    v92444: state_type > $o ).

tff(pred_def_50343,type,
    v92443: state_type > $o ).

tff(pred_def_50344,type,
    v92442: state_type > $o ).

tff(pred_def_50345,type,
    v92441: state_type > $o ).

tff(pred_def_50346,type,
    v92512: state_type > $o ).

tff(pred_def_50347,type,
    v92511: state_type > $o ).

tff(pred_def_50348,type,
    v92510: state_type > $o ).

tff(pred_def_50349,type,
    v92509: state_type > $o ).

tff(pred_def_50350,type,
    v92508: state_type > $o ).

tff(pred_def_50351,type,
    v92507: state_type > $o ).

tff(pred_def_50352,type,
    v92506: state_type > $o ).

tff(pred_def_50353,type,
    v92505: state_type > $o ).

tff(pred_def_50354,type,
    v92504: state_type > $o ).

tff(pred_def_50355,type,
    v92503: state_type > $o ).

tff(pred_def_50356,type,
    v92502: state_type > $o ).

tff(pred_def_50357,type,
    v92501: state_type > $o ).

tff(pred_def_50358,type,
    v92500: state_type > $o ).

tff(pred_def_50359,type,
    v92499: state_type > $o ).

tff(pred_def_50360,type,
    v92498: state_type > $o ).

tff(pred_def_50361,type,
    v92497: state_type > $o ).

tff(pred_def_50362,type,
    v92496: state_type > $o ).

tff(pred_def_50363,type,
    v92495: state_type > $o ).

tff(pred_def_50364,type,
    v92494: state_type > $o ).

tff(pred_def_50365,type,
    v92493: state_type > $o ).

tff(pred_def_50366,type,
    v92492: state_type > $o ).

tff(pred_def_50367,type,
    v92491: state_type > $o ).

tff(pred_def_50368,type,
    v92490: state_type > $o ).

tff(pred_def_50369,type,
    v92489: state_type > $o ).

tff(pred_def_50370,type,
    v92488: state_type > $o ).

tff(pred_def_50371,type,
    v92487: state_type > $o ).

tff(pred_def_50372,type,
    v92486: state_type > $o ).

tff(pred_def_50373,type,
    v92485: state_type > $o ).

tff(pred_def_50374,type,
    v92484: state_type > $o ).

tff(pred_def_50375,type,
    v92483: state_type > $o ).

tff(pred_def_50376,type,
    v92482: state_type > $o ).

tff(pred_def_50377,type,
    v92481: state_type > $o ).

tff(pred_def_50378,type,
    v92480: state_type > $o ).

tff(pred_def_50379,type,
    v92479: state_type > $o ).

tff(pred_def_50380,type,
    v92478: state_type > $o ).

tff(pred_def_50381,type,
    v92477: state_type > $o ).

tff(pred_def_50382,type,
    v92476: state_type > $o ).

tff(pred_def_50383,type,
    v92549: state_type > $o ).

tff(pred_def_50384,type,
    v92548: state_type > $o ).

tff(pred_def_50385,type,
    v92547: state_type > $o ).

tff(pred_def_50386,type,
    v92546: state_type > $o ).

tff(pred_def_50387,type,
    v92545: state_type > $o ).

tff(pred_def_50388,type,
    v92544: state_type > $o ).

tff(pred_def_50389,type,
    v92543: state_type > $o ).

tff(pred_def_50390,type,
    v92542: state_type > $o ).

tff(pred_def_50391,type,
    v92541: state_type > $o ).

tff(pred_def_50392,type,
    v92540: state_type > $o ).

tff(pred_def_50393,type,
    v92539: state_type > $o ).

tff(pred_def_50394,type,
    v92538: state_type > $o ).

tff(pred_def_50395,type,
    v92537: state_type > $o ).

tff(pred_def_50396,type,
    v92536: state_type > $o ).

tff(pred_def_50397,type,
    v92535: state_type > $o ).

tff(pred_def_50398,type,
    v92534: state_type > $o ).

tff(pred_def_50399,type,
    v92533: state_type > $o ).

tff(pred_def_50400,type,
    v92532: state_type > $o ).

tff(pred_def_50401,type,
    v92531: state_type > $o ).

tff(pred_def_50402,type,
    v92530: state_type > $o ).

tff(pred_def_50403,type,
    v92529: state_type > $o ).

tff(pred_def_50404,type,
    v92528: state_type > $o ).

tff(pred_def_50405,type,
    v92527: state_type > $o ).

tff(pred_def_50406,type,
    v92526: state_type > $o ).

tff(pred_def_50407,type,
    v92525: state_type > $o ).

tff(pred_def_50408,type,
    v92524: state_type > $o ).

tff(pred_def_50409,type,
    v92523: state_type > $o ).

tff(pred_def_50410,type,
    v92522: state_type > $o ).

tff(pred_def_50411,type,
    v92521: state_type > $o ).

tff(pred_def_50412,type,
    v92520: state_type > $o ).

tff(pred_def_50413,type,
    v92519: state_type > $o ).

tff(pred_def_50414,type,
    v92518: state_type > $o ).

tff(pred_def_50415,type,
    v92517: state_type > $o ).

tff(pred_def_50416,type,
    v92516: state_type > $o ).

tff(pred_def_50417,type,
    v92515: state_type > $o ).

tff(pred_def_50418,type,
    v92514: state_type > $o ).

tff(pred_def_50419,type,
    v92585: state_type > $o ).

tff(pred_def_50420,type,
    v92584: state_type > $o ).

tff(pred_def_50421,type,
    v92583: state_type > $o ).

tff(pred_def_50422,type,
    v92582: state_type > $o ).

tff(pred_def_50423,type,
    v92581: state_type > $o ).

tff(pred_def_50424,type,
    v92580: state_type > $o ).

tff(pred_def_50425,type,
    v92579: state_type > $o ).

tff(pred_def_50426,type,
    v92578: state_type > $o ).

tff(pred_def_50427,type,
    v92577: state_type > $o ).

tff(pred_def_50428,type,
    v92576: state_type > $o ).

tff(pred_def_50429,type,
    v92575: state_type > $o ).

tff(pred_def_50430,type,
    v92574: state_type > $o ).

tff(pred_def_50431,type,
    v92573: state_type > $o ).

tff(pred_def_50432,type,
    v92572: state_type > $o ).

tff(pred_def_50433,type,
    v92571: state_type > $o ).

tff(pred_def_50434,type,
    v92570: state_type > $o ).

tff(pred_def_50435,type,
    v92569: state_type > $o ).

tff(pred_def_50436,type,
    v92568: state_type > $o ).

tff(pred_def_50437,type,
    v92567: state_type > $o ).

tff(pred_def_50438,type,
    v92566: state_type > $o ).

tff(pred_def_50439,type,
    v92565: state_type > $o ).

tff(pred_def_50440,type,
    v92564: state_type > $o ).

tff(pred_def_50441,type,
    v92563: state_type > $o ).

tff(pred_def_50442,type,
    v92562: state_type > $o ).

tff(pred_def_50443,type,
    v92561: state_type > $o ).

tff(pred_def_50444,type,
    v92560: state_type > $o ).

tff(pred_def_50445,type,
    v92559: state_type > $o ).

tff(pred_def_50446,type,
    v92558: state_type > $o ).

tff(pred_def_50447,type,
    v92557: state_type > $o ).

tff(pred_def_50448,type,
    v92556: state_type > $o ).

tff(pred_def_50449,type,
    v92555: state_type > $o ).

tff(pred_def_50450,type,
    v92554: state_type > $o ).

tff(pred_def_50451,type,
    v92553: state_type > $o ).

tff(pred_def_50452,type,
    v92552: state_type > $o ).

tff(pred_def_50453,type,
    v92551: state_type > $o ).

tff(pred_def_50454,type,
    v92621: state_type > $o ).

tff(pred_def_50455,type,
    v92620: state_type > $o ).

tff(pred_def_50456,type,
    v92619: state_type > $o ).

tff(pred_def_50457,type,
    v92618: state_type > $o ).

tff(pred_def_50458,type,
    v92617: state_type > $o ).

tff(pred_def_50459,type,
    v92616: state_type > $o ).

tff(pred_def_50460,type,
    v92615: state_type > $o ).

tff(pred_def_50461,type,
    v92614: state_type > $o ).

tff(pred_def_50462,type,
    v92613: state_type > $o ).

tff(pred_def_50463,type,
    v92612: state_type > $o ).

tff(pred_def_50464,type,
    v92611: state_type > $o ).

tff(pred_def_50465,type,
    v92610: state_type > $o ).

tff(pred_def_50466,type,
    v92609: state_type > $o ).

tff(pred_def_50467,type,
    v92608: state_type > $o ).

tff(pred_def_50468,type,
    v92607: state_type > $o ).

tff(pred_def_50469,type,
    v92606: state_type > $o ).

tff(pred_def_50470,type,
    v92605: state_type > $o ).

tff(pred_def_50471,type,
    v92604: state_type > $o ).

tff(pred_def_50472,type,
    v92603: state_type > $o ).

tff(pred_def_50473,type,
    v92602: state_type > $o ).

tff(pred_def_50474,type,
    v92601: state_type > $o ).

tff(pred_def_50475,type,
    v92600: state_type > $o ).

tff(pred_def_50476,type,
    v92599: state_type > $o ).

tff(pred_def_50477,type,
    v92598: state_type > $o ).

tff(pred_def_50478,type,
    v92597: state_type > $o ).

tff(pred_def_50479,type,
    v92596: state_type > $o ).

tff(pred_def_50480,type,
    v92595: state_type > $o ).

tff(pred_def_50481,type,
    v92594: state_type > $o ).

tff(pred_def_50482,type,
    v92593: state_type > $o ).

tff(pred_def_50483,type,
    v92592: state_type > $o ).

tff(pred_def_50484,type,
    v92591: state_type > $o ).

tff(pred_def_50485,type,
    v92590: state_type > $o ).

tff(pred_def_50486,type,
    v92589: state_type > $o ).

tff(pred_def_50487,type,
    v92588: state_type > $o ).

tff(pred_def_50488,type,
    v92587: state_type > $o ).

tff(pred_def_50489,type,
    v92399: ( state_type * $int ) > $o ).

tff(pred_def_50490,type,
    v92397: ( state_type * $int ) > $o ).

tff(pred_def_50491,type,
    v92395: ( state_type * $int ) > $o ).

tff(pred_def_50492,type,
    v92393: ( state_type * $int ) > $o ).

tff(pred_def_50493,type,
    v92391: ( state_type * $int ) > $o ).

tff(pred_def_50494,type,
    v92632: state_type > $o ).

tff(pred_def_50495,type,
    v92630: state_type > $o ).

tff(pred_def_50496,type,
    v92628: state_type > $o ).

tff(pred_def_50497,type,
    v92626: state_type > $o ).

tff(pred_def_50498,type,
    v92624: state_type > $o ).

tff(pred_def_50499,type,
    v92636: state_type > $o ).

tff(pred_def_50500,type,
    v92635: ( state_type * $int ) > $o ).

tff(pred_def_50501,type,
    v92634: ( state_type * $int ) > $o ).

tff(pred_def_50502,type,
    v92639: state_type > $o ).

tff(pred_def_50503,type,
    v92638: ( state_type * $int ) > $o ).

tff(pred_def_50504,type,
    v92637: ( state_type * $int ) > $o ).

tff(pred_def_50505,type,
    v91894: ( state_type * $int ) > $o ).

tff(pred_def_50506,type,
    v91892: ( state_type * $int ) > $o ).

tff(pred_def_50507,type,
    v91890: ( state_type * $int ) > $o ).

tff(pred_def_50508,type,
    v91888: ( state_type * $int ) > $o ).

tff(pred_def_50509,type,
    v91886: ( state_type * $int ) > $o ).

tff(pred_def_50510,type,
    v91833: state_type > $o ).

tff(pred_def_50511,type,
    v91831: state_type > $o ).

tff(pred_def_50512,type,
    v91829: state_type > $o ).

tff(pred_def_50513,type,
    v91827: state_type > $o ).

tff(pred_def_50514,type,
    v91825: state_type > $o ).

tff(pred_def_50515,type,
    v92666: ( state_type * $int ) > $o ).

tff(pred_def_50516,type,
    v92664: ( state_type * $int ) > $o ).

tff(pred_def_50517,type,
    v92662: ( state_type * $int ) > $o ).

tff(pred_def_50518,type,
    v92688: state_type > $o ).

tff(pred_def_50519,type,
    v92685: state_type > $o ).

tff(pred_def_50520,type,
    v92683: state_type > $o ).

tff(pred_def_50521,type,
    v92681: state_type > $o ).

tff(pred_def_50522,type,
    v92679: state_type > $o ).

tff(pred_def_50523,type,
    v92677: state_type > $o ).

tff(pred_def_50524,type,
    v92675: state_type > $o ).

tff(pred_def_50525,type,
    v92673: state_type > $o ).

tff(pred_def_50526,type,
    v92671: state_type > $o ).

tff(pred_def_50527,type,
    v92669: state_type > $o ).

tff(pred_def_50528,type,
    v92695: ( state_type * $int ) > $o ).

tff(pred_def_50529,type,
    v92693: ( state_type * $int ) > $o ).

tff(pred_def_50530,type,
    v92691: ( state_type * $int ) > $o ).

tff(pred_def_50531,type,
    v92710: state_type > $o ).

tff(pred_def_50532,type,
    v92708: state_type > $o ).

tff(pred_def_50533,type,
    v92706: state_type > $o ).

tff(pred_def_50534,type,
    v92704: state_type > $o ).

tff(pred_def_50535,type,
    v92702: state_type > $o ).

tff(pred_def_50536,type,
    v92700: state_type > $o ).

tff(pred_def_50537,type,
    v92698: state_type > $o ).

tff(pred_def_50538,type,
    v92714: state_type > $o ).

tff(pred_def_50539,type,
    v92713: ( state_type * $int ) > $o ).

tff(pred_def_50540,type,
    v92712: ( state_type * $int ) > $o ).

tff(pred_def_50541,type,
    v92717: state_type > $o ).

tff(pred_def_50542,type,
    v92716: ( state_type * $int ) > $o ).

tff(pred_def_50543,type,
    v92715: ( state_type * $int ) > $o ).

tff(pred_def_50544,type,
    v92660: ( state_type * $int ) > $o ).

tff(pred_def_50545,type,
    v92658: ( state_type * $int ) > $o ).

tff(pred_def_50546,type,
    v92656: ( state_type * $int ) > $o ).

tff(pred_def_50547,type,
    v92654: ( state_type * $int ) > $o ).

tff(pred_def_50548,type,
    v92652: ( state_type * $int ) > $o ).

tff(pred_def_50549,type,
    v92748: ( state_type * $int ) > $o ).

tff(pred_def_50550,type,
    v92747: ( state_type * $int ) > $o ).

tff(pred_def_50551,type,
    v92745: ( state_type * $int ) > $o ).

tff(pred_def_50552,type,
    v92743: ( state_type * $int ) > $o ).

tff(pred_def_50553,type,
    v92741: ( state_type * $int ) > $o ).

tff(pred_def_50554,type,
    v92788: state_type > $o ).

tff(pred_def_50555,type,
    v92787: state_type > $o ).

tff(pred_def_50556,type,
    v92786: state_type > $o ).

tff(pred_def_50557,type,
    v92785: state_type > $o ).

tff(pred_def_50558,type,
    v92784: state_type > $o ).

tff(pred_def_50559,type,
    v92783: state_type > $o ).

tff(pred_def_50560,type,
    v92782: state_type > $o ).

tff(pred_def_50561,type,
    v92781: state_type > $o ).

tff(pred_def_50562,type,
    v92780: state_type > $o ).

tff(pred_def_50563,type,
    v92779: state_type > $o ).

tff(pred_def_50564,type,
    v92778: state_type > $o ).

tff(pred_def_50565,type,
    v92777: state_type > $o ).

tff(pred_def_50566,type,
    v92776: state_type > $o ).

tff(pred_def_50567,type,
    v92775: state_type > $o ).

tff(pred_def_50568,type,
    v92774: state_type > $o ).

tff(pred_def_50569,type,
    v92773: state_type > $o ).

tff(pred_def_50570,type,
    v92772: state_type > $o ).

tff(pred_def_50571,type,
    v92771: state_type > $o ).

tff(pred_def_50572,type,
    v92770: state_type > $o ).

tff(pred_def_50573,type,
    v92769: state_type > $o ).

tff(pred_def_50574,type,
    v92768: state_type > $o ).

tff(pred_def_50575,type,
    v92767: state_type > $o ).

tff(pred_def_50576,type,
    v92766: state_type > $o ).

tff(pred_def_50577,type,
    v92765: state_type > $o ).

tff(pred_def_50578,type,
    v92764: state_type > $o ).

tff(pred_def_50579,type,
    v92763: state_type > $o ).

tff(pred_def_50580,type,
    v92762: state_type > $o ).

tff(pred_def_50581,type,
    v92761: state_type > $o ).

tff(pred_def_50582,type,
    v92760: state_type > $o ).

tff(pred_def_50583,type,
    v92759: state_type > $o ).

tff(pred_def_50584,type,
    v92758: state_type > $o ).

tff(pred_def_50585,type,
    v92757: state_type > $o ).

tff(pred_def_50586,type,
    v92756: state_type > $o ).

tff(pred_def_50587,type,
    v92755: state_type > $o ).

tff(pred_def_50588,type,
    v92754: state_type > $o ).

tff(pred_def_50589,type,
    v92753: state_type > $o ).

tff(pred_def_50590,type,
    v92752: state_type > $o ).

tff(pred_def_50591,type,
    v92751: state_type > $o ).

tff(pred_def_50592,type,
    v92750: state_type > $o ).

tff(pred_def_50593,type,
    v92739: ( state_type * $int ) > $o ).

tff(pred_def_50594,type,
    v92822: state_type > $o ).

tff(pred_def_50595,type,
    v92821: state_type > $o ).

tff(pred_def_50596,type,
    v92820: state_type > $o ).

tff(pred_def_50597,type,
    v92819: state_type > $o ).

tff(pred_def_50598,type,
    v92818: state_type > $o ).

tff(pred_def_50599,type,
    v92817: state_type > $o ).

tff(pred_def_50600,type,
    v92816: state_type > $o ).

tff(pred_def_50601,type,
    v92815: state_type > $o ).

tff(pred_def_50602,type,
    v92814: state_type > $o ).

tff(pred_def_50603,type,
    v92813: state_type > $o ).

tff(pred_def_50604,type,
    v92812: state_type > $o ).

tff(pred_def_50605,type,
    v92811: state_type > $o ).

tff(pred_def_50606,type,
    v92810: state_type > $o ).

tff(pred_def_50607,type,
    v92809: state_type > $o ).

tff(pred_def_50608,type,
    v92808: state_type > $o ).

tff(pred_def_50609,type,
    v92807: state_type > $o ).

tff(pred_def_50610,type,
    v92806: state_type > $o ).

tff(pred_def_50611,type,
    v92805: state_type > $o ).

tff(pred_def_50612,type,
    v92804: state_type > $o ).

tff(pred_def_50613,type,
    v92803: state_type > $o ).

tff(pred_def_50614,type,
    v92802: state_type > $o ).

tff(pred_def_50615,type,
    v92801: state_type > $o ).

tff(pred_def_50616,type,
    v92800: state_type > $o ).

tff(pred_def_50617,type,
    v92799: state_type > $o ).

tff(pred_def_50618,type,
    v92798: state_type > $o ).

tff(pred_def_50619,type,
    v92797: state_type > $o ).

tff(pred_def_50620,type,
    v92796: state_type > $o ).

tff(pred_def_50621,type,
    v92795: state_type > $o ).

tff(pred_def_50622,type,
    v92794: state_type > $o ).

tff(pred_def_50623,type,
    v92793: state_type > $o ).

tff(pred_def_50624,type,
    v92792: state_type > $o ).

tff(pred_def_50625,type,
    v92791: state_type > $o ).

tff(pred_def_50626,type,
    v92790: state_type > $o ).

tff(pred_def_50627,type,
    v92856: state_type > $o ).

tff(pred_def_50628,type,
    v92855: state_type > $o ).

tff(pred_def_50629,type,
    v92854: state_type > $o ).

tff(pred_def_50630,type,
    v92853: state_type > $o ).

tff(pred_def_50631,type,
    v92852: state_type > $o ).

tff(pred_def_50632,type,
    v92851: state_type > $o ).

tff(pred_def_50633,type,
    v92850: state_type > $o ).

tff(pred_def_50634,type,
    v92849: state_type > $o ).

tff(pred_def_50635,type,
    v92848: state_type > $o ).

tff(pred_def_50636,type,
    v92847: state_type > $o ).

tff(pred_def_50637,type,
    v92846: state_type > $o ).

tff(pred_def_50638,type,
    v92845: state_type > $o ).

tff(pred_def_50639,type,
    v92844: state_type > $o ).

tff(pred_def_50640,type,
    v92843: state_type > $o ).

tff(pred_def_50641,type,
    v92842: state_type > $o ).

tff(pred_def_50642,type,
    v92841: state_type > $o ).

tff(pred_def_50643,type,
    v92840: state_type > $o ).

tff(pred_def_50644,type,
    v92839: state_type > $o ).

tff(pred_def_50645,type,
    v92838: state_type > $o ).

tff(pred_def_50646,type,
    v92837: state_type > $o ).

tff(pred_def_50647,type,
    v92836: state_type > $o ).

tff(pred_def_50648,type,
    v92835: state_type > $o ).

tff(pred_def_50649,type,
    v92834: state_type > $o ).

tff(pred_def_50650,type,
    v92833: state_type > $o ).

tff(pred_def_50651,type,
    v92832: state_type > $o ).

tff(pred_def_50652,type,
    v92831: state_type > $o ).

tff(pred_def_50653,type,
    v92830: state_type > $o ).

tff(pred_def_50654,type,
    v92829: state_type > $o ).

tff(pred_def_50655,type,
    v92828: state_type > $o ).

tff(pred_def_50656,type,
    v92827: state_type > $o ).

tff(pred_def_50657,type,
    v92826: state_type > $o ).

tff(pred_def_50658,type,
    v92825: state_type > $o ).

tff(pred_def_50659,type,
    v92824: state_type > $o ).

tff(pred_def_50660,type,
    v92896: state_type > $o ).

tff(pred_def_50661,type,
    v92895: state_type > $o ).

tff(pred_def_50662,type,
    v92894: state_type > $o ).

tff(pred_def_50663,type,
    v92893: state_type > $o ).

tff(pred_def_50664,type,
    v92892: state_type > $o ).

tff(pred_def_50665,type,
    v92891: state_type > $o ).

tff(pred_def_50666,type,
    v92890: state_type > $o ).

tff(pred_def_50667,type,
    v92889: state_type > $o ).

tff(pred_def_50668,type,
    v92888: state_type > $o ).

tff(pred_def_50669,type,
    v92887: state_type > $o ).

tff(pred_def_50670,type,
    v92886: state_type > $o ).

tff(pred_def_50671,type,
    v92885: state_type > $o ).

tff(pred_def_50672,type,
    v92884: state_type > $o ).

tff(pred_def_50673,type,
    v92883: state_type > $o ).

tff(pred_def_50674,type,
    v92882: state_type > $o ).

tff(pred_def_50675,type,
    v92881: state_type > $o ).

tff(pred_def_50676,type,
    v92880: state_type > $o ).

tff(pred_def_50677,type,
    v92879: state_type > $o ).

tff(pred_def_50678,type,
    v92878: state_type > $o ).

tff(pred_def_50679,type,
    v92877: state_type > $o ).

tff(pred_def_50680,type,
    v92876: state_type > $o ).

tff(pred_def_50681,type,
    v92875: state_type > $o ).

tff(pred_def_50682,type,
    v92874: state_type > $o ).

tff(pred_def_50683,type,
    v92873: state_type > $o ).

tff(pred_def_50684,type,
    v92872: state_type > $o ).

tff(pred_def_50685,type,
    v92871: state_type > $o ).

tff(pred_def_50686,type,
    v92870: state_type > $o ).

tff(pred_def_50687,type,
    v92869: state_type > $o ).

tff(pred_def_50688,type,
    v92868: state_type > $o ).

tff(pred_def_50689,type,
    v92867: state_type > $o ).

tff(pred_def_50690,type,
    v92866: state_type > $o ).

tff(pred_def_50691,type,
    v92865: state_type > $o ).

tff(pred_def_50692,type,
    v92864: state_type > $o ).

tff(pred_def_50693,type,
    v92863: state_type > $o ).

tff(pred_def_50694,type,
    v92862: state_type > $o ).

tff(pred_def_50695,type,
    v92861: state_type > $o ).

tff(pred_def_50696,type,
    v92860: state_type > $o ).

tff(pred_def_50697,type,
    v92859: state_type > $o ).

tff(pred_def_50698,type,
    v92858: state_type > $o ).

tff(pred_def_50699,type,
    v92935: state_type > $o ).

tff(pred_def_50700,type,
    v92934: state_type > $o ).

tff(pred_def_50701,type,
    v92933: state_type > $o ).

tff(pred_def_50702,type,
    v92932: state_type > $o ).

tff(pred_def_50703,type,
    v92931: state_type > $o ).

tff(pred_def_50704,type,
    v92930: state_type > $o ).

tff(pred_def_50705,type,
    v92929: state_type > $o ).

tff(pred_def_50706,type,
    v92928: state_type > $o ).

tff(pred_def_50707,type,
    v92927: state_type > $o ).

tff(pred_def_50708,type,
    v92926: state_type > $o ).

tff(pred_def_50709,type,
    v92925: state_type > $o ).

tff(pred_def_50710,type,
    v92924: state_type > $o ).

tff(pred_def_50711,type,
    v92923: state_type > $o ).

tff(pred_def_50712,type,
    v92922: state_type > $o ).

tff(pred_def_50713,type,
    v92921: state_type > $o ).

tff(pred_def_50714,type,
    v92920: state_type > $o ).

tff(pred_def_50715,type,
    v92919: state_type > $o ).

tff(pred_def_50716,type,
    v92918: state_type > $o ).

tff(pred_def_50717,type,
    v92917: state_type > $o ).

tff(pred_def_50718,type,
    v92916: state_type > $o ).

tff(pred_def_50719,type,
    v92915: state_type > $o ).

tff(pred_def_50720,type,
    v92914: state_type > $o ).

tff(pred_def_50721,type,
    v92913: state_type > $o ).

tff(pred_def_50722,type,
    v92912: state_type > $o ).

tff(pred_def_50723,type,
    v92911: state_type > $o ).

tff(pred_def_50724,type,
    v92910: state_type > $o ).

tff(pred_def_50725,type,
    v92909: state_type > $o ).

tff(pred_def_50726,type,
    v92908: state_type > $o ).

tff(pred_def_50727,type,
    v92907: state_type > $o ).

tff(pred_def_50728,type,
    v92906: state_type > $o ).

tff(pred_def_50729,type,
    v92905: state_type > $o ).

tff(pred_def_50730,type,
    v92904: state_type > $o ).

tff(pred_def_50731,type,
    v92903: state_type > $o ).

tff(pred_def_50732,type,
    v92902: state_type > $o ).

tff(pred_def_50733,type,
    v92901: state_type > $o ).

tff(pred_def_50734,type,
    v92900: state_type > $o ).

tff(pred_def_50735,type,
    v92899: state_type > $o ).

tff(pred_def_50736,type,
    v92898: state_type > $o ).

tff(pred_def_50737,type,
    v92974: state_type > $o ).

tff(pred_def_50738,type,
    v92973: state_type > $o ).

tff(pred_def_50739,type,
    v92972: state_type > $o ).

tff(pred_def_50740,type,
    v92971: state_type > $o ).

tff(pred_def_50741,type,
    v92970: state_type > $o ).

tff(pred_def_50742,type,
    v92969: state_type > $o ).

tff(pred_def_50743,type,
    v92968: state_type > $o ).

tff(pred_def_50744,type,
    v92967: state_type > $o ).

tff(pred_def_50745,type,
    v92966: state_type > $o ).

tff(pred_def_50746,type,
    v92965: state_type > $o ).

tff(pred_def_50747,type,
    v92964: state_type > $o ).

tff(pred_def_50748,type,
    v92963: state_type > $o ).

tff(pred_def_50749,type,
    v92962: state_type > $o ).

tff(pred_def_50750,type,
    v92961: state_type > $o ).

tff(pred_def_50751,type,
    v92960: state_type > $o ).

tff(pred_def_50752,type,
    v92959: state_type > $o ).

tff(pred_def_50753,type,
    v92958: state_type > $o ).

tff(pred_def_50754,type,
    v92957: state_type > $o ).

tff(pred_def_50755,type,
    v92956: state_type > $o ).

tff(pred_def_50756,type,
    v92955: state_type > $o ).

tff(pred_def_50757,type,
    v92954: state_type > $o ).

tff(pred_def_50758,type,
    v92953: state_type > $o ).

tff(pred_def_50759,type,
    v92952: state_type > $o ).

tff(pred_def_50760,type,
    v92951: state_type > $o ).

tff(pred_def_50761,type,
    v92950: state_type > $o ).

tff(pred_def_50762,type,
    v92949: state_type > $o ).

tff(pred_def_50763,type,
    v92948: state_type > $o ).

tff(pred_def_50764,type,
    v92947: state_type > $o ).

tff(pred_def_50765,type,
    v92946: state_type > $o ).

tff(pred_def_50766,type,
    v92945: state_type > $o ).

tff(pred_def_50767,type,
    v92944: state_type > $o ).

tff(pred_def_50768,type,
    v92943: state_type > $o ).

tff(pred_def_50769,type,
    v92942: state_type > $o ).

tff(pred_def_50770,type,
    v92941: state_type > $o ).

tff(pred_def_50771,type,
    v92940: state_type > $o ).

tff(pred_def_50772,type,
    v92939: state_type > $o ).

tff(pred_def_50773,type,
    v92938: state_type > $o ).

tff(pred_def_50774,type,
    v92937: state_type > $o ).

tff(pred_def_50775,type,
    v93017: state_type > $o ).

tff(pred_def_50776,type,
    v93016: state_type > $o ).

tff(pred_def_50777,type,
    v93015: state_type > $o ).

tff(pred_def_50778,type,
    v93014: state_type > $o ).

tff(pred_def_50779,type,
    v93013: state_type > $o ).

tff(pred_def_50780,type,
    v93012: state_type > $o ).

tff(pred_def_50781,type,
    v93011: state_type > $o ).

tff(pred_def_50782,type,
    v93010: state_type > $o ).

tff(pred_def_50783,type,
    v93009: state_type > $o ).

tff(pred_def_50784,type,
    v93008: state_type > $o ).

tff(pred_def_50785,type,
    v93007: state_type > $o ).

tff(pred_def_50786,type,
    v93006: state_type > $o ).

tff(pred_def_50787,type,
    v93005: state_type > $o ).

tff(pred_def_50788,type,
    v93004: state_type > $o ).

tff(pred_def_50789,type,
    v93003: state_type > $o ).

tff(pred_def_50790,type,
    v93002: state_type > $o ).

tff(pred_def_50791,type,
    v93001: state_type > $o ).

tff(pred_def_50792,type,
    v93000: state_type > $o ).

tff(pred_def_50793,type,
    v92999: state_type > $o ).

tff(pred_def_50794,type,
    v92998: state_type > $o ).

tff(pred_def_50795,type,
    v92997: state_type > $o ).

tff(pred_def_50796,type,
    v92996: state_type > $o ).

tff(pred_def_50797,type,
    v92995: state_type > $o ).

tff(pred_def_50798,type,
    v92994: state_type > $o ).

tff(pred_def_50799,type,
    v92993: state_type > $o ).

tff(pred_def_50800,type,
    v92992: state_type > $o ).

tff(pred_def_50801,type,
    v92991: state_type > $o ).

tff(pred_def_50802,type,
    v92990: state_type > $o ).

tff(pred_def_50803,type,
    v92989: state_type > $o ).

tff(pred_def_50804,type,
    v92988: state_type > $o ).

tff(pred_def_50805,type,
    v92987: state_type > $o ).

tff(pred_def_50806,type,
    v92986: state_type > $o ).

tff(pred_def_50807,type,
    v92985: state_type > $o ).

tff(pred_def_50808,type,
    v92984: state_type > $o ).

tff(pred_def_50809,type,
    v92983: state_type > $o ).

tff(pred_def_50810,type,
    v92982: state_type > $o ).

tff(pred_def_50811,type,
    v92981: state_type > $o ).

tff(pred_def_50812,type,
    v92980: state_type > $o ).

tff(pred_def_50813,type,
    v92979: state_type > $o ).

tff(pred_def_50814,type,
    v92978: state_type > $o ).

tff(pred_def_50815,type,
    v92977: state_type > $o ).

tff(pred_def_50816,type,
    v92976: state_type > $o ).

tff(pred_def_50817,type,
    v93059: state_type > $o ).

tff(pred_def_50818,type,
    v93058: state_type > $o ).

tff(pred_def_50819,type,
    v93057: state_type > $o ).

tff(pred_def_50820,type,
    v93056: state_type > $o ).

tff(pred_def_50821,type,
    v93055: state_type > $o ).

tff(pred_def_50822,type,
    v93054: state_type > $o ).

tff(pred_def_50823,type,
    v93053: state_type > $o ).

tff(pred_def_50824,type,
    v93052: state_type > $o ).

tff(pred_def_50825,type,
    v93051: state_type > $o ).

tff(pred_def_50826,type,
    v93050: state_type > $o ).

tff(pred_def_50827,type,
    v93049: state_type > $o ).

tff(pred_def_50828,type,
    v93048: state_type > $o ).

tff(pred_def_50829,type,
    v93047: state_type > $o ).

tff(pred_def_50830,type,
    v93046: state_type > $o ).

tff(pred_def_50831,type,
    v93045: state_type > $o ).

tff(pred_def_50832,type,
    v93044: state_type > $o ).

tff(pred_def_50833,type,
    v93043: state_type > $o ).

tff(pred_def_50834,type,
    v93042: state_type > $o ).

tff(pred_def_50835,type,
    v93041: state_type > $o ).

tff(pred_def_50836,type,
    v93040: state_type > $o ).

tff(pred_def_50837,type,
    v93039: state_type > $o ).

tff(pred_def_50838,type,
    v93038: state_type > $o ).

tff(pred_def_50839,type,
    v93037: state_type > $o ).

tff(pred_def_50840,type,
    v93036: state_type > $o ).

tff(pred_def_50841,type,
    v93035: state_type > $o ).

tff(pred_def_50842,type,
    v93034: state_type > $o ).

tff(pred_def_50843,type,
    v93033: state_type > $o ).

tff(pred_def_50844,type,
    v93032: state_type > $o ).

tff(pred_def_50845,type,
    v93031: state_type > $o ).

tff(pred_def_50846,type,
    v93030: state_type > $o ).

tff(pred_def_50847,type,
    v93029: state_type > $o ).

tff(pred_def_50848,type,
    v93028: state_type > $o ).

tff(pred_def_50849,type,
    v93027: state_type > $o ).

tff(pred_def_50850,type,
    v93026: state_type > $o ).

tff(pred_def_50851,type,
    v93025: state_type > $o ).

tff(pred_def_50852,type,
    v93024: state_type > $o ).

tff(pred_def_50853,type,
    v93023: state_type > $o ).

tff(pred_def_50854,type,
    v93022: state_type > $o ).

tff(pred_def_50855,type,
    v93021: state_type > $o ).

tff(pred_def_50856,type,
    v93020: state_type > $o ).

tff(pred_def_50857,type,
    v93019: state_type > $o ).

tff(pred_def_50858,type,
    v93099: state_type > $o ).

tff(pred_def_50859,type,
    v93098: state_type > $o ).

tff(pred_def_50860,type,
    v93097: state_type > $o ).

tff(pred_def_50861,type,
    v93096: state_type > $o ).

tff(pred_def_50862,type,
    v93095: state_type > $o ).

tff(pred_def_50863,type,
    v93094: state_type > $o ).

tff(pred_def_50864,type,
    v93093: state_type > $o ).

tff(pred_def_50865,type,
    v93092: state_type > $o ).

tff(pred_def_50866,type,
    v93091: state_type > $o ).

tff(pred_def_50867,type,
    v93090: state_type > $o ).

tff(pred_def_50868,type,
    v93089: state_type > $o ).

tff(pred_def_50869,type,
    v93088: state_type > $o ).

tff(pred_def_50870,type,
    v93087: state_type > $o ).

tff(pred_def_50871,type,
    v93086: state_type > $o ).

tff(pred_def_50872,type,
    v93085: state_type > $o ).

tff(pred_def_50873,type,
    v93084: state_type > $o ).

tff(pred_def_50874,type,
    v93083: state_type > $o ).

tff(pred_def_50875,type,
    v93082: state_type > $o ).

tff(pred_def_50876,type,
    v93081: state_type > $o ).

tff(pred_def_50877,type,
    v93080: state_type > $o ).

tff(pred_def_50878,type,
    v93079: state_type > $o ).

tff(pred_def_50879,type,
    v93078: state_type > $o ).

tff(pred_def_50880,type,
    v93077: state_type > $o ).

tff(pred_def_50881,type,
    v93076: state_type > $o ).

tff(pred_def_50882,type,
    v93075: state_type > $o ).

tff(pred_def_50883,type,
    v93074: state_type > $o ).

tff(pred_def_50884,type,
    v93073: state_type > $o ).

tff(pred_def_50885,type,
    v93072: state_type > $o ).

tff(pred_def_50886,type,
    v93071: state_type > $o ).

tff(pred_def_50887,type,
    v93070: state_type > $o ).

tff(pred_def_50888,type,
    v93069: state_type > $o ).

tff(pred_def_50889,type,
    v93068: state_type > $o ).

tff(pred_def_50890,type,
    v93067: state_type > $o ).

tff(pred_def_50891,type,
    v93066: state_type > $o ).

tff(pred_def_50892,type,
    v93065: state_type > $o ).

tff(pred_def_50893,type,
    v93064: state_type > $o ).

tff(pred_def_50894,type,
    v93063: state_type > $o ).

tff(pred_def_50895,type,
    v93062: state_type > $o ).

tff(pred_def_50896,type,
    v93061: state_type > $o ).

tff(pred_def_50897,type,
    v93139: state_type > $o ).

tff(pred_def_50898,type,
    v93138: state_type > $o ).

tff(pred_def_50899,type,
    v93137: state_type > $o ).

tff(pred_def_50900,type,
    v93136: state_type > $o ).

tff(pred_def_50901,type,
    v93135: state_type > $o ).

tff(pred_def_50902,type,
    v93134: state_type > $o ).

tff(pred_def_50903,type,
    v93133: state_type > $o ).

tff(pred_def_50904,type,
    v93132: state_type > $o ).

tff(pred_def_50905,type,
    v93131: state_type > $o ).

tff(pred_def_50906,type,
    v93130: state_type > $o ).

tff(pred_def_50907,type,
    v93129: state_type > $o ).

tff(pred_def_50908,type,
    v93128: state_type > $o ).

tff(pred_def_50909,type,
    v93127: state_type > $o ).

tff(pred_def_50910,type,
    v93126: state_type > $o ).

tff(pred_def_50911,type,
    v93125: state_type > $o ).

tff(pred_def_50912,type,
    v93124: state_type > $o ).

tff(pred_def_50913,type,
    v93123: state_type > $o ).

tff(pred_def_50914,type,
    v93122: state_type > $o ).

tff(pred_def_50915,type,
    v93121: state_type > $o ).

tff(pred_def_50916,type,
    v93120: state_type > $o ).

tff(pred_def_50917,type,
    v93119: state_type > $o ).

tff(pred_def_50918,type,
    v93118: state_type > $o ).

tff(pred_def_50919,type,
    v93117: state_type > $o ).

tff(pred_def_50920,type,
    v93116: state_type > $o ).

tff(pred_def_50921,type,
    v93115: state_type > $o ).

tff(pred_def_50922,type,
    v93114: state_type > $o ).

tff(pred_def_50923,type,
    v93113: state_type > $o ).

tff(pred_def_50924,type,
    v93112: state_type > $o ).

tff(pred_def_50925,type,
    v93111: state_type > $o ).

tff(pred_def_50926,type,
    v93110: state_type > $o ).

tff(pred_def_50927,type,
    v93109: state_type > $o ).

tff(pred_def_50928,type,
    v93108: state_type > $o ).

tff(pred_def_50929,type,
    v93107: state_type > $o ).

tff(pred_def_50930,type,
    v93106: state_type > $o ).

tff(pred_def_50931,type,
    v93105: state_type > $o ).

tff(pred_def_50932,type,
    v93104: state_type > $o ).

tff(pred_def_50933,type,
    v93103: state_type > $o ).

tff(pred_def_50934,type,
    v93102: state_type > $o ).

tff(pred_def_50935,type,
    v93101: state_type > $o ).

tff(pred_def_50936,type,
    v93172: state_type > $o ).

tff(pred_def_50937,type,
    v93171: state_type > $o ).

tff(pred_def_50938,type,
    v93170: state_type > $o ).

tff(pred_def_50939,type,
    v93169: state_type > $o ).

tff(pred_def_50940,type,
    v93168: state_type > $o ).

tff(pred_def_50941,type,
    v93167: state_type > $o ).

tff(pred_def_50942,type,
    v93166: state_type > $o ).

tff(pred_def_50943,type,
    v93165: state_type > $o ).

tff(pred_def_50944,type,
    v93164: state_type > $o ).

tff(pred_def_50945,type,
    v93163: state_type > $o ).

tff(pred_def_50946,type,
    v93162: state_type > $o ).

tff(pred_def_50947,type,
    v93161: state_type > $o ).

tff(pred_def_50948,type,
    v93160: state_type > $o ).

tff(pred_def_50949,type,
    v93159: state_type > $o ).

tff(pred_def_50950,type,
    v93158: state_type > $o ).

tff(pred_def_50951,type,
    v93157: state_type > $o ).

tff(pred_def_50952,type,
    v93156: state_type > $o ).

tff(pred_def_50953,type,
    v93155: state_type > $o ).

tff(pred_def_50954,type,
    v93154: state_type > $o ).

tff(pred_def_50955,type,
    v93153: state_type > $o ).

tff(pred_def_50956,type,
    v93152: state_type > $o ).

tff(pred_def_50957,type,
    v93151: state_type > $o ).

tff(pred_def_50958,type,
    v93150: state_type > $o ).

tff(pred_def_50959,type,
    v93149: state_type > $o ).

tff(pred_def_50960,type,
    v93148: state_type > $o ).

tff(pred_def_50961,type,
    v93147: state_type > $o ).

tff(pred_def_50962,type,
    v93146: state_type > $o ).

tff(pred_def_50963,type,
    v93145: state_type > $o ).

tff(pred_def_50964,type,
    v93144: state_type > $o ).

tff(pred_def_50965,type,
    v93143: state_type > $o ).

tff(pred_def_50966,type,
    v93142: state_type > $o ).

tff(pred_def_50967,type,
    v93141: state_type > $o ).

tff(pred_def_50968,type,
    v93212: state_type > $o ).

tff(pred_def_50969,type,
    v93211: state_type > $o ).

tff(pred_def_50970,type,
    v93210: state_type > $o ).

tff(pred_def_50971,type,
    v93209: state_type > $o ).

tff(pred_def_50972,type,
    v93208: state_type > $o ).

tff(pred_def_50973,type,
    v93207: state_type > $o ).

tff(pred_def_50974,type,
    v93206: state_type > $o ).

tff(pred_def_50975,type,
    v93205: state_type > $o ).

tff(pred_def_50976,type,
    v93204: state_type > $o ).

tff(pred_def_50977,type,
    v93203: state_type > $o ).

tff(pred_def_50978,type,
    v93202: state_type > $o ).

tff(pred_def_50979,type,
    v93201: state_type > $o ).

tff(pred_def_50980,type,
    v93200: state_type > $o ).

tff(pred_def_50981,type,
    v93199: state_type > $o ).

tff(pred_def_50982,type,
    v93198: state_type > $o ).

tff(pred_def_50983,type,
    v93197: state_type > $o ).

tff(pred_def_50984,type,
    v93196: state_type > $o ).

tff(pred_def_50985,type,
    v93195: state_type > $o ).

tff(pred_def_50986,type,
    v93194: state_type > $o ).

tff(pred_def_50987,type,
    v93193: state_type > $o ).

tff(pred_def_50988,type,
    v93192: state_type > $o ).

tff(pred_def_50989,type,
    v93191: state_type > $o ).

tff(pred_def_50990,type,
    v93190: state_type > $o ).

tff(pred_def_50991,type,
    v93189: state_type > $o ).

tff(pred_def_50992,type,
    v93188: state_type > $o ).

tff(pred_def_50993,type,
    v93187: state_type > $o ).

tff(pred_def_50994,type,
    v93186: state_type > $o ).

tff(pred_def_50995,type,
    v93185: state_type > $o ).

tff(pred_def_50996,type,
    v93184: state_type > $o ).

tff(pred_def_50997,type,
    v93183: state_type > $o ).

tff(pred_def_50998,type,
    v93182: state_type > $o ).

tff(pred_def_50999,type,
    v93181: state_type > $o ).

tff(pred_def_51000,type,
    v93180: state_type > $o ).

tff(pred_def_51001,type,
    v93179: state_type > $o ).

tff(pred_def_51002,type,
    v93178: state_type > $o ).

tff(pred_def_51003,type,
    v93177: state_type > $o ).

tff(pred_def_51004,type,
    v93176: state_type > $o ).

tff(pred_def_51005,type,
    v93175: state_type > $o ).

tff(pred_def_51006,type,
    v93174: state_type > $o ).

tff(pred_def_51007,type,
    v92737: ( state_type * $int ) > $o ).

tff(pred_def_51008,type,
    v92735: ( state_type * $int ) > $o ).

tff(pred_def_51009,type,
    v92733: ( state_type * $int ) > $o ).

tff(pred_def_51010,type,
    v92731: ( state_type * $int ) > $o ).

tff(pred_def_51011,type,
    v92729: ( state_type * $int ) > $o ).

tff(pred_def_51012,type,
    v93222: state_type > $o ).

tff(pred_def_51013,type,
    v93220: state_type > $o ).

tff(pred_def_51014,type,
    v93218: state_type > $o ).

tff(pred_def_51015,type,
    v93216: state_type > $o ).

tff(pred_def_51016,type,
    v93214: state_type > $o ).

tff(pred_def_51017,type,
    v93236: ( state_type * $int ) > $o ).

tff(pred_def_51018,type,
    v93272: state_type > $o ).

tff(pred_def_51019,type,
    v93271: state_type > $o ).

tff(pred_def_51020,type,
    v93270: state_type > $o ).

tff(pred_def_51021,type,
    v93269: state_type > $o ).

tff(pred_def_51022,type,
    v93268: state_type > $o ).

tff(pred_def_51023,type,
    v93267: state_type > $o ).

tff(pred_def_51024,type,
    v93266: state_type > $o ).

tff(pred_def_51025,type,
    v93265: state_type > $o ).

tff(pred_def_51026,type,
    v93264: state_type > $o ).

tff(pred_def_51027,type,
    v93263: state_type > $o ).

tff(pred_def_51028,type,
    v93262: state_type > $o ).

tff(pred_def_51029,type,
    v93261: state_type > $o ).

tff(pred_def_51030,type,
    v93260: state_type > $o ).

tff(pred_def_51031,type,
    v93259: state_type > $o ).

tff(pred_def_51032,type,
    v93258: state_type > $o ).

tff(pred_def_51033,type,
    v93257: state_type > $o ).

tff(pred_def_51034,type,
    v93256: state_type > $o ).

tff(pred_def_51035,type,
    v93255: state_type > $o ).

tff(pred_def_51036,type,
    v93254: state_type > $o ).

tff(pred_def_51037,type,
    v93253: state_type > $o ).

tff(pred_def_51038,type,
    v93252: state_type > $o ).

tff(pred_def_51039,type,
    v93251: state_type > $o ).

tff(pred_def_51040,type,
    v93250: state_type > $o ).

tff(pred_def_51041,type,
    v93249: state_type > $o ).

tff(pred_def_51042,type,
    v93248: state_type > $o ).

tff(pred_def_51043,type,
    v93247: state_type > $o ).

tff(pred_def_51044,type,
    v93246: state_type > $o ).

tff(pred_def_51045,type,
    v93245: state_type > $o ).

tff(pred_def_51046,type,
    v93244: state_type > $o ).

tff(pred_def_51047,type,
    v93243: state_type > $o ).

tff(pred_def_51048,type,
    v93242: state_type > $o ).

tff(pred_def_51049,type,
    v93241: state_type > $o ).

tff(pred_def_51050,type,
    v93240: state_type > $o ).

tff(pred_def_51051,type,
    v93239: state_type > $o ).

tff(pred_def_51052,type,
    v93238: state_type > $o ).

tff(pred_def_51053,type,
    v93234: ( state_type * $int ) > $o ).

tff(pred_def_51054,type,
    v93307: state_type > $o ).

tff(pred_def_51055,type,
    v93306: state_type > $o ).

tff(pred_def_51056,type,
    v93305: state_type > $o ).

tff(pred_def_51057,type,
    v93304: state_type > $o ).

tff(pred_def_51058,type,
    v93303: state_type > $o ).

tff(pred_def_51059,type,
    v93302: state_type > $o ).

tff(pred_def_51060,type,
    v93301: state_type > $o ).

tff(pred_def_51061,type,
    v93300: state_type > $o ).

tff(pred_def_51062,type,
    v93299: state_type > $o ).

tff(pred_def_51063,type,
    v93298: state_type > $o ).

tff(pred_def_51064,type,
    v93297: state_type > $o ).

tff(pred_def_51065,type,
    v93296: state_type > $o ).

tff(pred_def_51066,type,
    v93295: state_type > $o ).

tff(pred_def_51067,type,
    v93294: state_type > $o ).

tff(pred_def_51068,type,
    v93293: state_type > $o ).

tff(pred_def_51069,type,
    v93292: state_type > $o ).

tff(pred_def_51070,type,
    v93291: state_type > $o ).

tff(pred_def_51071,type,
    v93290: state_type > $o ).

tff(pred_def_51072,type,
    v93289: state_type > $o ).

tff(pred_def_51073,type,
    v93288: state_type > $o ).

tff(pred_def_51074,type,
    v93287: state_type > $o ).

tff(pred_def_51075,type,
    v93286: state_type > $o ).

tff(pred_def_51076,type,
    v93285: state_type > $o ).

tff(pred_def_51077,type,
    v93284: state_type > $o ).

tff(pred_def_51078,type,
    v93283: state_type > $o ).

tff(pred_def_51079,type,
    v93282: state_type > $o ).

tff(pred_def_51080,type,
    v93281: state_type > $o ).

tff(pred_def_51081,type,
    v93280: state_type > $o ).

tff(pred_def_51082,type,
    v93279: state_type > $o ).

tff(pred_def_51083,type,
    v93278: state_type > $o ).

tff(pred_def_51084,type,
    v93277: state_type > $o ).

tff(pred_def_51085,type,
    v93276: state_type > $o ).

tff(pred_def_51086,type,
    v93275: state_type > $o ).

tff(pred_def_51087,type,
    v93274: state_type > $o ).

tff(pred_def_51088,type,
    v93345: state_type > $o ).

tff(pred_def_51089,type,
    v93344: state_type > $o ).

tff(pred_def_51090,type,
    v93343: state_type > $o ).

tff(pred_def_51091,type,
    v93342: state_type > $o ).

tff(pred_def_51092,type,
    v93341: state_type > $o ).

tff(pred_def_51093,type,
    v93340: state_type > $o ).

tff(pred_def_51094,type,
    v93339: state_type > $o ).

tff(pred_def_51095,type,
    v93338: state_type > $o ).

tff(pred_def_51096,type,
    v93337: state_type > $o ).

tff(pred_def_51097,type,
    v93336: state_type > $o ).

tff(pred_def_51098,type,
    v93335: state_type > $o ).

tff(pred_def_51099,type,
    v93334: state_type > $o ).

tff(pred_def_51100,type,
    v93333: state_type > $o ).

tff(pred_def_51101,type,
    v93332: state_type > $o ).

tff(pred_def_51102,type,
    v93331: state_type > $o ).

tff(pred_def_51103,type,
    v93330: state_type > $o ).

tff(pred_def_51104,type,
    v93329: state_type > $o ).

tff(pred_def_51105,type,
    v93328: state_type > $o ).

tff(pred_def_51106,type,
    v93327: state_type > $o ).

tff(pred_def_51107,type,
    v93326: state_type > $o ).

tff(pred_def_51108,type,
    v93325: state_type > $o ).

tff(pred_def_51109,type,
    v93324: state_type > $o ).

tff(pred_def_51110,type,
    v93323: state_type > $o ).

tff(pred_def_51111,type,
    v93322: state_type > $o ).

tff(pred_def_51112,type,
    v93321: state_type > $o ).

tff(pred_def_51113,type,
    v93320: state_type > $o ).

tff(pred_def_51114,type,
    v93319: state_type > $o ).

tff(pred_def_51115,type,
    v93318: state_type > $o ).

tff(pred_def_51116,type,
    v93317: state_type > $o ).

tff(pred_def_51117,type,
    v93316: state_type > $o ).

tff(pred_def_51118,type,
    v93315: state_type > $o ).

tff(pred_def_51119,type,
    v93314: state_type > $o ).

tff(pred_def_51120,type,
    v93313: state_type > $o ).

tff(pred_def_51121,type,
    v93312: state_type > $o ).

tff(pred_def_51122,type,
    v93311: state_type > $o ).

tff(pred_def_51123,type,
    v93310: state_type > $o ).

tff(pred_def_51124,type,
    v93309: state_type > $o ).

tff(pred_def_51125,type,
    v93382: state_type > $o ).

tff(pred_def_51126,type,
    v93381: state_type > $o ).

tff(pred_def_51127,type,
    v93380: state_type > $o ).

tff(pred_def_51128,type,
    v93379: state_type > $o ).

tff(pred_def_51129,type,
    v93378: state_type > $o ).

tff(pred_def_51130,type,
    v93377: state_type > $o ).

tff(pred_def_51131,type,
    v93376: state_type > $o ).

tff(pred_def_51132,type,
    v93375: state_type > $o ).

tff(pred_def_51133,type,
    v93374: state_type > $o ).

tff(pred_def_51134,type,
    v93373: state_type > $o ).

tff(pred_def_51135,type,
    v93372: state_type > $o ).

tff(pred_def_51136,type,
    v93371: state_type > $o ).

tff(pred_def_51137,type,
    v93370: state_type > $o ).

tff(pred_def_51138,type,
    v93369: state_type > $o ).

tff(pred_def_51139,type,
    v93368: state_type > $o ).

tff(pred_def_51140,type,
    v93367: state_type > $o ).

tff(pred_def_51141,type,
    v93366: state_type > $o ).

tff(pred_def_51142,type,
    v93365: state_type > $o ).

tff(pred_def_51143,type,
    v93364: state_type > $o ).

tff(pred_def_51144,type,
    v93363: state_type > $o ).

tff(pred_def_51145,type,
    v93362: state_type > $o ).

tff(pred_def_51146,type,
    v93361: state_type > $o ).

tff(pred_def_51147,type,
    v93360: state_type > $o ).

tff(pred_def_51148,type,
    v93359: state_type > $o ).

tff(pred_def_51149,type,
    v93358: state_type > $o ).

tff(pred_def_51150,type,
    v93357: state_type > $o ).

tff(pred_def_51151,type,
    v93356: state_type > $o ).

tff(pred_def_51152,type,
    v93355: state_type > $o ).

tff(pred_def_51153,type,
    v93354: state_type > $o ).

tff(pred_def_51154,type,
    v93353: state_type > $o ).

tff(pred_def_51155,type,
    v93352: state_type > $o ).

tff(pred_def_51156,type,
    v93351: state_type > $o ).

tff(pred_def_51157,type,
    v93350: state_type > $o ).

tff(pred_def_51158,type,
    v93349: state_type > $o ).

tff(pred_def_51159,type,
    v93348: state_type > $o ).

tff(pred_def_51160,type,
    v93347: state_type > $o ).

tff(pred_def_51161,type,
    v93418: state_type > $o ).

tff(pred_def_51162,type,
    v93417: state_type > $o ).

tff(pred_def_51163,type,
    v93416: state_type > $o ).

tff(pred_def_51164,type,
    v93415: state_type > $o ).

tff(pred_def_51165,type,
    v93414: state_type > $o ).

tff(pred_def_51166,type,
    v93413: state_type > $o ).

tff(pred_def_51167,type,
    v93412: state_type > $o ).

tff(pred_def_51168,type,
    v93411: state_type > $o ).

tff(pred_def_51169,type,
    v93410: state_type > $o ).

tff(pred_def_51170,type,
    v93409: state_type > $o ).

tff(pred_def_51171,type,
    v93408: state_type > $o ).

tff(pred_def_51172,type,
    v93407: state_type > $o ).

tff(pred_def_51173,type,
    v93406: state_type > $o ).

tff(pred_def_51174,type,
    v93405: state_type > $o ).

tff(pred_def_51175,type,
    v93404: state_type > $o ).

tff(pred_def_51176,type,
    v93403: state_type > $o ).

tff(pred_def_51177,type,
    v93402: state_type > $o ).

tff(pred_def_51178,type,
    v93401: state_type > $o ).

tff(pred_def_51179,type,
    v93400: state_type > $o ).

tff(pred_def_51180,type,
    v93399: state_type > $o ).

tff(pred_def_51181,type,
    v93398: state_type > $o ).

tff(pred_def_51182,type,
    v93397: state_type > $o ).

tff(pred_def_51183,type,
    v93396: state_type > $o ).

tff(pred_def_51184,type,
    v93395: state_type > $o ).

tff(pred_def_51185,type,
    v93394: state_type > $o ).

tff(pred_def_51186,type,
    v93393: state_type > $o ).

tff(pred_def_51187,type,
    v93392: state_type > $o ).

tff(pred_def_51188,type,
    v93391: state_type > $o ).

tff(pred_def_51189,type,
    v93390: state_type > $o ).

tff(pred_def_51190,type,
    v93389: state_type > $o ).

tff(pred_def_51191,type,
    v93388: state_type > $o ).

tff(pred_def_51192,type,
    v93387: state_type > $o ).

tff(pred_def_51193,type,
    v93386: state_type > $o ).

tff(pred_def_51194,type,
    v93385: state_type > $o ).

tff(pred_def_51195,type,
    v93384: state_type > $o ).

tff(pred_def_51196,type,
    v93454: state_type > $o ).

tff(pred_def_51197,type,
    v93453: state_type > $o ).

tff(pred_def_51198,type,
    v93452: state_type > $o ).

tff(pred_def_51199,type,
    v93451: state_type > $o ).

tff(pred_def_51200,type,
    v93450: state_type > $o ).

tff(pred_def_51201,type,
    v93449: state_type > $o ).

tff(pred_def_51202,type,
    v93448: state_type > $o ).

tff(pred_def_51203,type,
    v93447: state_type > $o ).

tff(pred_def_51204,type,
    v93446: state_type > $o ).

tff(pred_def_51205,type,
    v93445: state_type > $o ).

tff(pred_def_51206,type,
    v93444: state_type > $o ).

tff(pred_def_51207,type,
    v93443: state_type > $o ).

tff(pred_def_51208,type,
    v93442: state_type > $o ).

tff(pred_def_51209,type,
    v93441: state_type > $o ).

tff(pred_def_51210,type,
    v93440: state_type > $o ).

tff(pred_def_51211,type,
    v93439: state_type > $o ).

tff(pred_def_51212,type,
    v93438: state_type > $o ).

tff(pred_def_51213,type,
    v93437: state_type > $o ).

tff(pred_def_51214,type,
    v93436: state_type > $o ).

tff(pred_def_51215,type,
    v93435: state_type > $o ).

tff(pred_def_51216,type,
    v93434: state_type > $o ).

tff(pred_def_51217,type,
    v93433: state_type > $o ).

tff(pred_def_51218,type,
    v93432: state_type > $o ).

tff(pred_def_51219,type,
    v93431: state_type > $o ).

tff(pred_def_51220,type,
    v93430: state_type > $o ).

tff(pred_def_51221,type,
    v93429: state_type > $o ).

tff(pred_def_51222,type,
    v93428: state_type > $o ).

tff(pred_def_51223,type,
    v93427: state_type > $o ).

tff(pred_def_51224,type,
    v93426: state_type > $o ).

tff(pred_def_51225,type,
    v93425: state_type > $o ).

tff(pred_def_51226,type,
    v93424: state_type > $o ).

tff(pred_def_51227,type,
    v93423: state_type > $o ).

tff(pred_def_51228,type,
    v93422: state_type > $o ).

tff(pred_def_51229,type,
    v93421: state_type > $o ).

tff(pred_def_51230,type,
    v93420: state_type > $o ).

tff(pred_def_51231,type,
    v93232: ( state_type * $int ) > $o ).

tff(pred_def_51232,type,
    v93230: ( state_type * $int ) > $o ).

tff(pred_def_51233,type,
    v93228: ( state_type * $int ) > $o ).

tff(pred_def_51234,type,
    v93226: ( state_type * $int ) > $o ).

tff(pred_def_51235,type,
    v93224: ( state_type * $int ) > $o ).

tff(pred_def_51236,type,
    v93465: state_type > $o ).

tff(pred_def_51237,type,
    v93463: state_type > $o ).

tff(pred_def_51238,type,
    v93461: state_type > $o ).

tff(pred_def_51239,type,
    v93459: state_type > $o ).

tff(pred_def_51240,type,
    v93457: state_type > $o ).

tff(pred_def_51241,type,
    v93469: state_type > $o ).

tff(pred_def_51242,type,
    v93468: ( state_type * $int ) > $o ).

tff(pred_def_51243,type,
    v93467: ( state_type * $int ) > $o ).

tff(pred_def_51244,type,
    v93472: state_type > $o ).

tff(pred_def_51245,type,
    v93471: ( state_type * $int ) > $o ).

tff(pred_def_51246,type,
    v93470: ( state_type * $int ) > $o ).

tff(pred_def_51247,type,
    v92727: ( state_type * $int ) > $o ).

tff(pred_def_51248,type,
    v92725: ( state_type * $int ) > $o ).

tff(pred_def_51249,type,
    v92723: ( state_type * $int ) > $o ).

tff(pred_def_51250,type,
    v92721: ( state_type * $int ) > $o ).

tff(pred_def_51251,type,
    v92719: ( state_type * $int ) > $o ).

tff(pred_def_51252,type,
    v92650: state_type > $o ).

tff(pred_def_51253,type,
    v92648: state_type > $o ).

tff(pred_def_51254,type,
    v92646: state_type > $o ).

tff(pred_def_51255,type,
    v92644: state_type > $o ).

tff(pred_def_51256,type,
    v92642: state_type > $o ).

tff(pred_def_51257,type,
    v93499: ( state_type * $int ) > $o ).

tff(pred_def_51258,type,
    v93497: ( state_type * $int ) > $o ).

tff(pred_def_51259,type,
    v93495: ( state_type * $int ) > $o ).

tff(pred_def_51260,type,
    v93510: state_type > $o ).

tff(pred_def_51261,type,
    v93508: state_type > $o ).

tff(pred_def_51262,type,
    v93506: state_type > $o ).

tff(pred_def_51263,type,
    v93504: state_type > $o ).

tff(pred_def_51264,type,
    v93502: state_type > $o ).

tff(pred_def_51265,type,
    v93516: ( state_type * $int ) > $o ).

tff(pred_def_51266,type,
    v93514: ( state_type * $int ) > $o ).

tff(pred_def_51267,type,
    v93512: ( state_type * $int ) > $o ).

tff(pred_def_51268,type,
    v93527: state_type > $o ).

tff(pred_def_51269,type,
    v93525: state_type > $o ).

tff(pred_def_51270,type,
    v93523: state_type > $o ).

tff(pred_def_51271,type,
    v93521: state_type > $o ).

tff(pred_def_51272,type,
    v93519: state_type > $o ).

tff(pred_def_51273,type,
    v93531: state_type > $o ).

tff(pred_def_51274,type,
    v93530: ( state_type * $int ) > $o ).

tff(pred_def_51275,type,
    v93529: ( state_type * $int ) > $o ).

tff(pred_def_51276,type,
    v93534: state_type > $o ).

tff(pred_def_51277,type,
    v93533: ( state_type * $int ) > $o ).

tff(pred_def_51278,type,
    v93532: ( state_type * $int ) > $o ).

tff(pred_def_51279,type,
    v93493: ( state_type * $int ) > $o ).

tff(pred_def_51280,type,
    v93491: ( state_type * $int ) > $o ).

tff(pred_def_51281,type,
    v93489: ( state_type * $int ) > $o ).

tff(pred_def_51282,type,
    v93487: ( state_type * $int ) > $o ).

tff(pred_def_51283,type,
    v93485: ( state_type * $int ) > $o ).

tff(pred_def_51284,type,
    v93565: ( state_type * $int ) > $o ).

tff(pred_def_51285,type,
    v93564: ( state_type * $int ) > $o ).

tff(pred_def_51286,type,
    v93562: ( state_type * $int ) > $o ).

tff(pred_def_51287,type,
    v93560: ( state_type * $int ) > $o ).

tff(pred_def_51288,type,
    v93558: ( state_type * $int ) > $o ).

tff(pred_def_51289,type,
    v93605: state_type > $o ).

tff(pred_def_51290,type,
    v93604: state_type > $o ).

tff(pred_def_51291,type,
    v93603: state_type > $o ).

tff(pred_def_51292,type,
    v93602: state_type > $o ).

tff(pred_def_51293,type,
    v93601: state_type > $o ).

tff(pred_def_51294,type,
    v93600: state_type > $o ).

tff(pred_def_51295,type,
    v93599: state_type > $o ).

tff(pred_def_51296,type,
    v93598: state_type > $o ).

tff(pred_def_51297,type,
    v93597: state_type > $o ).

tff(pred_def_51298,type,
    v93596: state_type > $o ).

tff(pred_def_51299,type,
    v93595: state_type > $o ).

tff(pred_def_51300,type,
    v93594: state_type > $o ).

tff(pred_def_51301,type,
    v93593: state_type > $o ).

tff(pred_def_51302,type,
    v93592: state_type > $o ).

tff(pred_def_51303,type,
    v93591: state_type > $o ).

tff(pred_def_51304,type,
    v93590: state_type > $o ).

tff(pred_def_51305,type,
    v93589: state_type > $o ).

tff(pred_def_51306,type,
    v93588: state_type > $o ).

tff(pred_def_51307,type,
    v93587: state_type > $o ).

tff(pred_def_51308,type,
    v93586: state_type > $o ).

tff(pred_def_51309,type,
    v93585: state_type > $o ).

tff(pred_def_51310,type,
    v93584: state_type > $o ).

tff(pred_def_51311,type,
    v93583: state_type > $o ).

tff(pred_def_51312,type,
    v93582: state_type > $o ).

tff(pred_def_51313,type,
    v93581: state_type > $o ).

tff(pred_def_51314,type,
    v93580: state_type > $o ).

tff(pred_def_51315,type,
    v93579: state_type > $o ).

tff(pred_def_51316,type,
    v93578: state_type > $o ).

tff(pred_def_51317,type,
    v93577: state_type > $o ).

tff(pred_def_51318,type,
    v93576: state_type > $o ).

tff(pred_def_51319,type,
    v93575: state_type > $o ).

tff(pred_def_51320,type,
    v93574: state_type > $o ).

tff(pred_def_51321,type,
    v93573: state_type > $o ).

tff(pred_def_51322,type,
    v93572: state_type > $o ).

tff(pred_def_51323,type,
    v93571: state_type > $o ).

tff(pred_def_51324,type,
    v93570: state_type > $o ).

tff(pred_def_51325,type,
    v93569: state_type > $o ).

tff(pred_def_51326,type,
    v93568: state_type > $o ).

tff(pred_def_51327,type,
    v93567: state_type > $o ).

tff(pred_def_51328,type,
    v93556: ( state_type * $int ) > $o ).

tff(pred_def_51329,type,
    v93639: state_type > $o ).

tff(pred_def_51330,type,
    v93638: state_type > $o ).

tff(pred_def_51331,type,
    v93637: state_type > $o ).

tff(pred_def_51332,type,
    v93636: state_type > $o ).

tff(pred_def_51333,type,
    v93635: state_type > $o ).

tff(pred_def_51334,type,
    v93634: state_type > $o ).

tff(pred_def_51335,type,
    v93633: state_type > $o ).

tff(pred_def_51336,type,
    v93632: state_type > $o ).

tff(pred_def_51337,type,
    v93631: state_type > $o ).

tff(pred_def_51338,type,
    v93630: state_type > $o ).

tff(pred_def_51339,type,
    v93629: state_type > $o ).

tff(pred_def_51340,type,
    v93628: state_type > $o ).

tff(pred_def_51341,type,
    v93627: state_type > $o ).

tff(pred_def_51342,type,
    v93626: state_type > $o ).

tff(pred_def_51343,type,
    v93625: state_type > $o ).

tff(pred_def_51344,type,
    v93624: state_type > $o ).

tff(pred_def_51345,type,
    v93623: state_type > $o ).

tff(pred_def_51346,type,
    v93622: state_type > $o ).

tff(pred_def_51347,type,
    v93621: state_type > $o ).

tff(pred_def_51348,type,
    v93620: state_type > $o ).

tff(pred_def_51349,type,
    v93619: state_type > $o ).

tff(pred_def_51350,type,
    v93618: state_type > $o ).

tff(pred_def_51351,type,
    v93617: state_type > $o ).

tff(pred_def_51352,type,
    v93616: state_type > $o ).

tff(pred_def_51353,type,
    v93615: state_type > $o ).

tff(pred_def_51354,type,
    v93614: state_type > $o ).

tff(pred_def_51355,type,
    v93613: state_type > $o ).

tff(pred_def_51356,type,
    v93612: state_type > $o ).

tff(pred_def_51357,type,
    v93611: state_type > $o ).

tff(pred_def_51358,type,
    v93610: state_type > $o ).

tff(pred_def_51359,type,
    v93609: state_type > $o ).

tff(pred_def_51360,type,
    v93608: state_type > $o ).

tff(pred_def_51361,type,
    v93607: state_type > $o ).

tff(pred_def_51362,type,
    v93673: state_type > $o ).

tff(pred_def_51363,type,
    v93672: state_type > $o ).

tff(pred_def_51364,type,
    v93671: state_type > $o ).

tff(pred_def_51365,type,
    v93670: state_type > $o ).

tff(pred_def_51366,type,
    v93669: state_type > $o ).

tff(pred_def_51367,type,
    v93668: state_type > $o ).

tff(pred_def_51368,type,
    v93667: state_type > $o ).

tff(pred_def_51369,type,
    v93666: state_type > $o ).

tff(pred_def_51370,type,
    v93665: state_type > $o ).

tff(pred_def_51371,type,
    v93664: state_type > $o ).

tff(pred_def_51372,type,
    v93663: state_type > $o ).

tff(pred_def_51373,type,
    v93662: state_type > $o ).

tff(pred_def_51374,type,
    v93661: state_type > $o ).

tff(pred_def_51375,type,
    v93660: state_type > $o ).

tff(pred_def_51376,type,
    v93659: state_type > $o ).

tff(pred_def_51377,type,
    v93658: state_type > $o ).

tff(pred_def_51378,type,
    v93657: state_type > $o ).

tff(pred_def_51379,type,
    v93656: state_type > $o ).

tff(pred_def_51380,type,
    v93655: state_type > $o ).

tff(pred_def_51381,type,
    v93654: state_type > $o ).

tff(pred_def_51382,type,
    v93653: state_type > $o ).

tff(pred_def_51383,type,
    v93652: state_type > $o ).

tff(pred_def_51384,type,
    v93651: state_type > $o ).

tff(pred_def_51385,type,
    v93650: state_type > $o ).

tff(pred_def_51386,type,
    v93649: state_type > $o ).

tff(pred_def_51387,type,
    v93648: state_type > $o ).

tff(pred_def_51388,type,
    v93647: state_type > $o ).

tff(pred_def_51389,type,
    v93646: state_type > $o ).

tff(pred_def_51390,type,
    v93645: state_type > $o ).

tff(pred_def_51391,type,
    v93644: state_type > $o ).

tff(pred_def_51392,type,
    v93643: state_type > $o ).

tff(pred_def_51393,type,
    v93642: state_type > $o ).

tff(pred_def_51394,type,
    v93641: state_type > $o ).

tff(pred_def_51395,type,
    v93713: state_type > $o ).

tff(pred_def_51396,type,
    v93712: state_type > $o ).

tff(pred_def_51397,type,
    v93711: state_type > $o ).

tff(pred_def_51398,type,
    v93710: state_type > $o ).

tff(pred_def_51399,type,
    v93709: state_type > $o ).

tff(pred_def_51400,type,
    v93708: state_type > $o ).

tff(pred_def_51401,type,
    v93707: state_type > $o ).

tff(pred_def_51402,type,
    v93706: state_type > $o ).

tff(pred_def_51403,type,
    v93705: state_type > $o ).

tff(pred_def_51404,type,
    v93704: state_type > $o ).

tff(pred_def_51405,type,
    v93703: state_type > $o ).

tff(pred_def_51406,type,
    v93702: state_type > $o ).

tff(pred_def_51407,type,
    v93701: state_type > $o ).

tff(pred_def_51408,type,
    v93700: state_type > $o ).

tff(pred_def_51409,type,
    v93699: state_type > $o ).

tff(pred_def_51410,type,
    v93698: state_type > $o ).

tff(pred_def_51411,type,
    v93697: state_type > $o ).

tff(pred_def_51412,type,
    v93696: state_type > $o ).

tff(pred_def_51413,type,
    v93695: state_type > $o ).

tff(pred_def_51414,type,
    v93694: state_type > $o ).

tff(pred_def_51415,type,
    v93693: state_type > $o ).

tff(pred_def_51416,type,
    v93692: state_type > $o ).

tff(pred_def_51417,type,
    v93691: state_type > $o ).

tff(pred_def_51418,type,
    v93690: state_type > $o ).

tff(pred_def_51419,type,
    v93689: state_type > $o ).

tff(pred_def_51420,type,
    v93688: state_type > $o ).

tff(pred_def_51421,type,
    v93687: state_type > $o ).

tff(pred_def_51422,type,
    v93686: state_type > $o ).

tff(pred_def_51423,type,
    v93685: state_type > $o ).

tff(pred_def_51424,type,
    v93684: state_type > $o ).

tff(pred_def_51425,type,
    v93683: state_type > $o ).

tff(pred_def_51426,type,
    v93682: state_type > $o ).

tff(pred_def_51427,type,
    v93681: state_type > $o ).

tff(pred_def_51428,type,
    v93680: state_type > $o ).

tff(pred_def_51429,type,
    v93679: state_type > $o ).

tff(pred_def_51430,type,
    v93678: state_type > $o ).

tff(pred_def_51431,type,
    v93677: state_type > $o ).

tff(pred_def_51432,type,
    v93676: state_type > $o ).

tff(pred_def_51433,type,
    v93675: state_type > $o ).

tff(pred_def_51434,type,
    v93752: state_type > $o ).

tff(pred_def_51435,type,
    v93751: state_type > $o ).

tff(pred_def_51436,type,
    v93750: state_type > $o ).

tff(pred_def_51437,type,
    v93749: state_type > $o ).

tff(pred_def_51438,type,
    v93748: state_type > $o ).

tff(pred_def_51439,type,
    v93747: state_type > $o ).

tff(pred_def_51440,type,
    v93746: state_type > $o ).

tff(pred_def_51441,type,
    v93745: state_type > $o ).

tff(pred_def_51442,type,
    v93744: state_type > $o ).

tff(pred_def_51443,type,
    v93743: state_type > $o ).

tff(pred_def_51444,type,
    v93742: state_type > $o ).

tff(pred_def_51445,type,
    v93741: state_type > $o ).

tff(pred_def_51446,type,
    v93740: state_type > $o ).

tff(pred_def_51447,type,
    v93739: state_type > $o ).

tff(pred_def_51448,type,
    v93738: state_type > $o ).

tff(pred_def_51449,type,
    v93737: state_type > $o ).

tff(pred_def_51450,type,
    v93736: state_type > $o ).

tff(pred_def_51451,type,
    v93735: state_type > $o ).

tff(pred_def_51452,type,
    v93734: state_type > $o ).

tff(pred_def_51453,type,
    v93733: state_type > $o ).

tff(pred_def_51454,type,
    v93732: state_type > $o ).

tff(pred_def_51455,type,
    v93731: state_type > $o ).

tff(pred_def_51456,type,
    v93730: state_type > $o ).

tff(pred_def_51457,type,
    v93729: state_type > $o ).

tff(pred_def_51458,type,
    v93728: state_type > $o ).

tff(pred_def_51459,type,
    v93727: state_type > $o ).

tff(pred_def_51460,type,
    v93726: state_type > $o ).

tff(pred_def_51461,type,
    v93725: state_type > $o ).

tff(pred_def_51462,type,
    v93724: state_type > $o ).

tff(pred_def_51463,type,
    v93723: state_type > $o ).

tff(pred_def_51464,type,
    v93722: state_type > $o ).

tff(pred_def_51465,type,
    v93721: state_type > $o ).

tff(pred_def_51466,type,
    v93720: state_type > $o ).

tff(pred_def_51467,type,
    v93719: state_type > $o ).

tff(pred_def_51468,type,
    v93718: state_type > $o ).

tff(pred_def_51469,type,
    v93717: state_type > $o ).

tff(pred_def_51470,type,
    v93716: state_type > $o ).

tff(pred_def_51471,type,
    v93715: state_type > $o ).

tff(pred_def_51472,type,
    v93791: state_type > $o ).

tff(pred_def_51473,type,
    v93790: state_type > $o ).

tff(pred_def_51474,type,
    v93789: state_type > $o ).

tff(pred_def_51475,type,
    v93788: state_type > $o ).

tff(pred_def_51476,type,
    v93787: state_type > $o ).

tff(pred_def_51477,type,
    v93786: state_type > $o ).

tff(pred_def_51478,type,
    v93785: state_type > $o ).

tff(pred_def_51479,type,
    v93784: state_type > $o ).

tff(pred_def_51480,type,
    v93783: state_type > $o ).

tff(pred_def_51481,type,
    v93782: state_type > $o ).

tff(pred_def_51482,type,
    v93781: state_type > $o ).

tff(pred_def_51483,type,
    v93780: state_type > $o ).

tff(pred_def_51484,type,
    v93779: state_type > $o ).

tff(pred_def_51485,type,
    v93778: state_type > $o ).

tff(pred_def_51486,type,
    v93777: state_type > $o ).

tff(pred_def_51487,type,
    v93776: state_type > $o ).

tff(pred_def_51488,type,
    v93775: state_type > $o ).

tff(pred_def_51489,type,
    v93774: state_type > $o ).

tff(pred_def_51490,type,
    v93773: state_type > $o ).

tff(pred_def_51491,type,
    v93772: state_type > $o ).

tff(pred_def_51492,type,
    v93771: state_type > $o ).

tff(pred_def_51493,type,
    v93770: state_type > $o ).

tff(pred_def_51494,type,
    v93769: state_type > $o ).

tff(pred_def_51495,type,
    v93768: state_type > $o ).

tff(pred_def_51496,type,
    v93767: state_type > $o ).

tff(pred_def_51497,type,
    v93766: state_type > $o ).

tff(pred_def_51498,type,
    v93765: state_type > $o ).

tff(pred_def_51499,type,
    v93764: state_type > $o ).

tff(pred_def_51500,type,
    v93763: state_type > $o ).

tff(pred_def_51501,type,
    v93762: state_type > $o ).

tff(pred_def_51502,type,
    v93761: state_type > $o ).

tff(pred_def_51503,type,
    v93760: state_type > $o ).

tff(pred_def_51504,type,
    v93759: state_type > $o ).

tff(pred_def_51505,type,
    v93758: state_type > $o ).

tff(pred_def_51506,type,
    v93757: state_type > $o ).

tff(pred_def_51507,type,
    v93756: state_type > $o ).

tff(pred_def_51508,type,
    v93755: state_type > $o ).

tff(pred_def_51509,type,
    v93754: state_type > $o ).

tff(pred_def_51510,type,
    v93834: state_type > $o ).

tff(pred_def_51511,type,
    v93833: state_type > $o ).

tff(pred_def_51512,type,
    v93832: state_type > $o ).

tff(pred_def_51513,type,
    v93831: state_type > $o ).

tff(pred_def_51514,type,
    v93830: state_type > $o ).

tff(pred_def_51515,type,
    v93829: state_type > $o ).

tff(pred_def_51516,type,
    v93828: state_type > $o ).

tff(pred_def_51517,type,
    v93827: state_type > $o ).

tff(pred_def_51518,type,
    v93826: state_type > $o ).

tff(pred_def_51519,type,
    v93825: state_type > $o ).

tff(pred_def_51520,type,
    v93824: state_type > $o ).

tff(pred_def_51521,type,
    v93823: state_type > $o ).

tff(pred_def_51522,type,
    v93822: state_type > $o ).

tff(pred_def_51523,type,
    v93821: state_type > $o ).

tff(pred_def_51524,type,
    v93820: state_type > $o ).

tff(pred_def_51525,type,
    v93819: state_type > $o ).

tff(pred_def_51526,type,
    v93818: state_type > $o ).

tff(pred_def_51527,type,
    v93817: state_type > $o ).

tff(pred_def_51528,type,
    v93816: state_type > $o ).

tff(pred_def_51529,type,
    v93815: state_type > $o ).

tff(pred_def_51530,type,
    v93814: state_type > $o ).

tff(pred_def_51531,type,
    v93813: state_type > $o ).

tff(pred_def_51532,type,
    v93812: state_type > $o ).

tff(pred_def_51533,type,
    v93811: state_type > $o ).

tff(pred_def_51534,type,
    v93810: state_type > $o ).

tff(pred_def_51535,type,
    v93809: state_type > $o ).

tff(pred_def_51536,type,
    v93808: state_type > $o ).

tff(pred_def_51537,type,
    v93807: state_type > $o ).

tff(pred_def_51538,type,
    v93806: state_type > $o ).

tff(pred_def_51539,type,
    v93805: state_type > $o ).

tff(pred_def_51540,type,
    v93804: state_type > $o ).

tff(pred_def_51541,type,
    v93803: state_type > $o ).

tff(pred_def_51542,type,
    v93802: state_type > $o ).

tff(pred_def_51543,type,
    v93801: state_type > $o ).

tff(pred_def_51544,type,
    v93800: state_type > $o ).

tff(pred_def_51545,type,
    v93799: state_type > $o ).

tff(pred_def_51546,type,
    v93798: state_type > $o ).

tff(pred_def_51547,type,
    v93797: state_type > $o ).

tff(pred_def_51548,type,
    v93796: state_type > $o ).

tff(pred_def_51549,type,
    v93795: state_type > $o ).

tff(pred_def_51550,type,
    v93794: state_type > $o ).

tff(pred_def_51551,type,
    v93793: state_type > $o ).

tff(pred_def_51552,type,
    v93876: state_type > $o ).

tff(pred_def_51553,type,
    v93875: state_type > $o ).

tff(pred_def_51554,type,
    v93874: state_type > $o ).

tff(pred_def_51555,type,
    v93873: state_type > $o ).

tff(pred_def_51556,type,
    v93872: state_type > $o ).

tff(pred_def_51557,type,
    v93871: state_type > $o ).

tff(pred_def_51558,type,
    v93870: state_type > $o ).

tff(pred_def_51559,type,
    v93869: state_type > $o ).

tff(pred_def_51560,type,
    v93868: state_type > $o ).

tff(pred_def_51561,type,
    v93867: state_type > $o ).

tff(pred_def_51562,type,
    v93866: state_type > $o ).

tff(pred_def_51563,type,
    v93865: state_type > $o ).

tff(pred_def_51564,type,
    v93864: state_type > $o ).

tff(pred_def_51565,type,
    v93863: state_type > $o ).

tff(pred_def_51566,type,
    v93862: state_type > $o ).

tff(pred_def_51567,type,
    v93861: state_type > $o ).

tff(pred_def_51568,type,
    v93860: state_type > $o ).

tff(pred_def_51569,type,
    v93859: state_type > $o ).

tff(pred_def_51570,type,
    v93858: state_type > $o ).

tff(pred_def_51571,type,
    v93857: state_type > $o ).

tff(pred_def_51572,type,
    v93856: state_type > $o ).

tff(pred_def_51573,type,
    v93855: state_type > $o ).

tff(pred_def_51574,type,
    v93854: state_type > $o ).

tff(pred_def_51575,type,
    v93853: state_type > $o ).

tff(pred_def_51576,type,
    v93852: state_type > $o ).

tff(pred_def_51577,type,
    v93851: state_type > $o ).

tff(pred_def_51578,type,
    v93850: state_type > $o ).

tff(pred_def_51579,type,
    v93849: state_type > $o ).

tff(pred_def_51580,type,
    v93848: state_type > $o ).

tff(pred_def_51581,type,
    v93847: state_type > $o ).

tff(pred_def_51582,type,
    v93846: state_type > $o ).

tff(pred_def_51583,type,
    v93845: state_type > $o ).

tff(pred_def_51584,type,
    v93844: state_type > $o ).

tff(pred_def_51585,type,
    v93843: state_type > $o ).

tff(pred_def_51586,type,
    v93842: state_type > $o ).

tff(pred_def_51587,type,
    v93841: state_type > $o ).

tff(pred_def_51588,type,
    v93840: state_type > $o ).

tff(pred_def_51589,type,
    v93839: state_type > $o ).

tff(pred_def_51590,type,
    v93838: state_type > $o ).

tff(pred_def_51591,type,
    v93837: state_type > $o ).

tff(pred_def_51592,type,
    v93836: state_type > $o ).

tff(pred_def_51593,type,
    v93916: state_type > $o ).

tff(pred_def_51594,type,
    v93915: state_type > $o ).

tff(pred_def_51595,type,
    v93914: state_type > $o ).

tff(pred_def_51596,type,
    v93913: state_type > $o ).

tff(pred_def_51597,type,
    v93912: state_type > $o ).

tff(pred_def_51598,type,
    v93911: state_type > $o ).

tff(pred_def_51599,type,
    v93910: state_type > $o ).

tff(pred_def_51600,type,
    v93909: state_type > $o ).

tff(pred_def_51601,type,
    v93908: state_type > $o ).

tff(pred_def_51602,type,
    v93907: state_type > $o ).

tff(pred_def_51603,type,
    v93906: state_type > $o ).

tff(pred_def_51604,type,
    v93905: state_type > $o ).

tff(pred_def_51605,type,
    v93904: state_type > $o ).

tff(pred_def_51606,type,
    v93903: state_type > $o ).

tff(pred_def_51607,type,
    v93902: state_type > $o ).

tff(pred_def_51608,type,
    v93901: state_type > $o ).

tff(pred_def_51609,type,
    v93900: state_type > $o ).

tff(pred_def_51610,type,
    v93899: state_type > $o ).

tff(pred_def_51611,type,
    v93898: state_type > $o ).

tff(pred_def_51612,type,
    v93897: state_type > $o ).

tff(pred_def_51613,type,
    v93896: state_type > $o ).

tff(pred_def_51614,type,
    v93895: state_type > $o ).

tff(pred_def_51615,type,
    v93894: state_type > $o ).

tff(pred_def_51616,type,
    v93893: state_type > $o ).

tff(pred_def_51617,type,
    v93892: state_type > $o ).

tff(pred_def_51618,type,
    v93891: state_type > $o ).

tff(pred_def_51619,type,
    v93890: state_type > $o ).

tff(pred_def_51620,type,
    v93889: state_type > $o ).

tff(pred_def_51621,type,
    v93888: state_type > $o ).

tff(pred_def_51622,type,
    v93887: state_type > $o ).

tff(pred_def_51623,type,
    v93886: state_type > $o ).

tff(pred_def_51624,type,
    v93885: state_type > $o ).

tff(pred_def_51625,type,
    v93884: state_type > $o ).

tff(pred_def_51626,type,
    v93883: state_type > $o ).

tff(pred_def_51627,type,
    v93882: state_type > $o ).

tff(pred_def_51628,type,
    v93881: state_type > $o ).

tff(pred_def_51629,type,
    v93880: state_type > $o ).

tff(pred_def_51630,type,
    v93879: state_type > $o ).

tff(pred_def_51631,type,
    v93878: state_type > $o ).

tff(pred_def_51632,type,
    v93956: state_type > $o ).

tff(pred_def_51633,type,
    v93955: state_type > $o ).

tff(pred_def_51634,type,
    v93954: state_type > $o ).

tff(pred_def_51635,type,
    v93953: state_type > $o ).

tff(pred_def_51636,type,
    v93952: state_type > $o ).

tff(pred_def_51637,type,
    v93951: state_type > $o ).

tff(pred_def_51638,type,
    v93950: state_type > $o ).

tff(pred_def_51639,type,
    v93949: state_type > $o ).

tff(pred_def_51640,type,
    v93948: state_type > $o ).

tff(pred_def_51641,type,
    v93947: state_type > $o ).

tff(pred_def_51642,type,
    v93946: state_type > $o ).

tff(pred_def_51643,type,
    v93945: state_type > $o ).

tff(pred_def_51644,type,
    v93944: state_type > $o ).

tff(pred_def_51645,type,
    v93943: state_type > $o ).

tff(pred_def_51646,type,
    v93942: state_type > $o ).

tff(pred_def_51647,type,
    v93941: state_type > $o ).

tff(pred_def_51648,type,
    v93940: state_type > $o ).

tff(pred_def_51649,type,
    v93939: state_type > $o ).

tff(pred_def_51650,type,
    v93938: state_type > $o ).

tff(pred_def_51651,type,
    v93937: state_type > $o ).

tff(pred_def_51652,type,
    v93936: state_type > $o ).

tff(pred_def_51653,type,
    v93935: state_type > $o ).

tff(pred_def_51654,type,
    v93934: state_type > $o ).

tff(pred_def_51655,type,
    v93933: state_type > $o ).

tff(pred_def_51656,type,
    v93932: state_type > $o ).

tff(pred_def_51657,type,
    v93931: state_type > $o ).

tff(pred_def_51658,type,
    v93930: state_type > $o ).

tff(pred_def_51659,type,
    v93929: state_type > $o ).

tff(pred_def_51660,type,
    v93928: state_type > $o ).

tff(pred_def_51661,type,
    v93927: state_type > $o ).

tff(pred_def_51662,type,
    v93926: state_type > $o ).

tff(pred_def_51663,type,
    v93925: state_type > $o ).

tff(pred_def_51664,type,
    v93924: state_type > $o ).

tff(pred_def_51665,type,
    v93923: state_type > $o ).

tff(pred_def_51666,type,
    v93922: state_type > $o ).

tff(pred_def_51667,type,
    v93921: state_type > $o ).

tff(pred_def_51668,type,
    v93920: state_type > $o ).

tff(pred_def_51669,type,
    v93919: state_type > $o ).

tff(pred_def_51670,type,
    v93918: state_type > $o ).

tff(pred_def_51671,type,
    v93989: state_type > $o ).

tff(pred_def_51672,type,
    v93988: state_type > $o ).

tff(pred_def_51673,type,
    v93987: state_type > $o ).

tff(pred_def_51674,type,
    v93986: state_type > $o ).

tff(pred_def_51675,type,
    v93985: state_type > $o ).

tff(pred_def_51676,type,
    v93984: state_type > $o ).

tff(pred_def_51677,type,
    v93983: state_type > $o ).

tff(pred_def_51678,type,
    v93982: state_type > $o ).

tff(pred_def_51679,type,
    v93981: state_type > $o ).

tff(pred_def_51680,type,
    v93980: state_type > $o ).

tff(pred_def_51681,type,
    v93979: state_type > $o ).

tff(pred_def_51682,type,
    v93978: state_type > $o ).

tff(pred_def_51683,type,
    v93977: state_type > $o ).

tff(pred_def_51684,type,
    v93976: state_type > $o ).

tff(pred_def_51685,type,
    v93975: state_type > $o ).

tff(pred_def_51686,type,
    v93974: state_type > $o ).

tff(pred_def_51687,type,
    v93973: state_type > $o ).

tff(pred_def_51688,type,
    v93972: state_type > $o ).

tff(pred_def_51689,type,
    v93971: state_type > $o ).

tff(pred_def_51690,type,
    v93970: state_type > $o ).

tff(pred_def_51691,type,
    v93969: state_type > $o ).

tff(pred_def_51692,type,
    v93968: state_type > $o ).

tff(pred_def_51693,type,
    v93967: state_type > $o ).

tff(pred_def_51694,type,
    v93966: state_type > $o ).

tff(pred_def_51695,type,
    v93965: state_type > $o ).

tff(pred_def_51696,type,
    v93964: state_type > $o ).

tff(pred_def_51697,type,
    v93963: state_type > $o ).

tff(pred_def_51698,type,
    v93962: state_type > $o ).

tff(pred_def_51699,type,
    v93961: state_type > $o ).

tff(pred_def_51700,type,
    v93960: state_type > $o ).

tff(pred_def_51701,type,
    v93959: state_type > $o ).

tff(pred_def_51702,type,
    v93958: state_type > $o ).

tff(pred_def_51703,type,
    v94029: state_type > $o ).

tff(pred_def_51704,type,
    v94028: state_type > $o ).

tff(pred_def_51705,type,
    v94027: state_type > $o ).

tff(pred_def_51706,type,
    v94026: state_type > $o ).

tff(pred_def_51707,type,
    v94025: state_type > $o ).

tff(pred_def_51708,type,
    v94024: state_type > $o ).

tff(pred_def_51709,type,
    v94023: state_type > $o ).

tff(pred_def_51710,type,
    v94022: state_type > $o ).

tff(pred_def_51711,type,
    v94021: state_type > $o ).

tff(pred_def_51712,type,
    v94020: state_type > $o ).

tff(pred_def_51713,type,
    v94019: state_type > $o ).

tff(pred_def_51714,type,
    v94018: state_type > $o ).

tff(pred_def_51715,type,
    v94017: state_type > $o ).

tff(pred_def_51716,type,
    v94016: state_type > $o ).

tff(pred_def_51717,type,
    v94015: state_type > $o ).

tff(pred_def_51718,type,
    v94014: state_type > $o ).

tff(pred_def_51719,type,
    v94013: state_type > $o ).

tff(pred_def_51720,type,
    v94012: state_type > $o ).

tff(pred_def_51721,type,
    v94011: state_type > $o ).

tff(pred_def_51722,type,
    v94010: state_type > $o ).

tff(pred_def_51723,type,
    v94009: state_type > $o ).

tff(pred_def_51724,type,
    v94008: state_type > $o ).

tff(pred_def_51725,type,
    v94007: state_type > $o ).

tff(pred_def_51726,type,
    v94006: state_type > $o ).

tff(pred_def_51727,type,
    v94005: state_type > $o ).

tff(pred_def_51728,type,
    v94004: state_type > $o ).

tff(pred_def_51729,type,
    v94003: state_type > $o ).

tff(pred_def_51730,type,
    v94002: state_type > $o ).

tff(pred_def_51731,type,
    v94001: state_type > $o ).

tff(pred_def_51732,type,
    v94000: state_type > $o ).

tff(pred_def_51733,type,
    v93999: state_type > $o ).

tff(pred_def_51734,type,
    v93998: state_type > $o ).

tff(pred_def_51735,type,
    v93997: state_type > $o ).

tff(pred_def_51736,type,
    v93996: state_type > $o ).

tff(pred_def_51737,type,
    v93995: state_type > $o ).

tff(pred_def_51738,type,
    v93994: state_type > $o ).

tff(pred_def_51739,type,
    v93993: state_type > $o ).

tff(pred_def_51740,type,
    v93992: state_type > $o ).

tff(pred_def_51741,type,
    v93991: state_type > $o ).

tff(pred_def_51742,type,
    v93554: ( state_type * $int ) > $o ).

tff(pred_def_51743,type,
    v93552: ( state_type * $int ) > $o ).

tff(pred_def_51744,type,
    v93550: ( state_type * $int ) > $o ).

tff(pred_def_51745,type,
    v93548: ( state_type * $int ) > $o ).

tff(pred_def_51746,type,
    v93546: ( state_type * $int ) > $o ).

tff(pred_def_51747,type,
    v94039: state_type > $o ).

tff(pred_def_51748,type,
    v94037: state_type > $o ).

tff(pred_def_51749,type,
    v94035: state_type > $o ).

tff(pred_def_51750,type,
    v94033: state_type > $o ).

tff(pred_def_51751,type,
    v94031: state_type > $o ).

tff(pred_def_51752,type,
    v94053: ( state_type * $int ) > $o ).

tff(pred_def_51753,type,
    v94089: state_type > $o ).

tff(pred_def_51754,type,
    v94088: state_type > $o ).

tff(pred_def_51755,type,
    v94087: state_type > $o ).

tff(pred_def_51756,type,
    v94086: state_type > $o ).

tff(pred_def_51757,type,
    v94085: state_type > $o ).

tff(pred_def_51758,type,
    v94084: state_type > $o ).

tff(pred_def_51759,type,
    v94083: state_type > $o ).

tff(pred_def_51760,type,
    v94082: state_type > $o ).

tff(pred_def_51761,type,
    v94081: state_type > $o ).

tff(pred_def_51762,type,
    v94080: state_type > $o ).

tff(pred_def_51763,type,
    v94079: state_type > $o ).

tff(pred_def_51764,type,
    v94078: state_type > $o ).

tff(pred_def_51765,type,
    v94077: state_type > $o ).

tff(pred_def_51766,type,
    v94076: state_type > $o ).

tff(pred_def_51767,type,
    v94075: state_type > $o ).

tff(pred_def_51768,type,
    v94074: state_type > $o ).

tff(pred_def_51769,type,
    v94073: state_type > $o ).

tff(pred_def_51770,type,
    v94072: state_type > $o ).

tff(pred_def_51771,type,
    v94071: state_type > $o ).

tff(pred_def_51772,type,
    v94070: state_type > $o ).

tff(pred_def_51773,type,
    v94069: state_type > $o ).

tff(pred_def_51774,type,
    v94068: state_type > $o ).

tff(pred_def_51775,type,
    v94067: state_type > $o ).

tff(pred_def_51776,type,
    v94066: state_type > $o ).

tff(pred_def_51777,type,
    v94065: state_type > $o ).

tff(pred_def_51778,type,
    v94064: state_type > $o ).

tff(pred_def_51779,type,
    v94063: state_type > $o ).

tff(pred_def_51780,type,
    v94062: state_type > $o ).

tff(pred_def_51781,type,
    v94061: state_type > $o ).

tff(pred_def_51782,type,
    v94060: state_type > $o ).

tff(pred_def_51783,type,
    v94059: state_type > $o ).

tff(pred_def_51784,type,
    v94058: state_type > $o ).

tff(pred_def_51785,type,
    v94057: state_type > $o ).

tff(pred_def_51786,type,
    v94056: state_type > $o ).

tff(pred_def_51787,type,
    v94055: state_type > $o ).

tff(pred_def_51788,type,
    v94051: ( state_type * $int ) > $o ).

tff(pred_def_51789,type,
    v94124: state_type > $o ).

tff(pred_def_51790,type,
    v94123: state_type > $o ).

tff(pred_def_51791,type,
    v94122: state_type > $o ).

tff(pred_def_51792,type,
    v94121: state_type > $o ).

tff(pred_def_51793,type,
    v94120: state_type > $o ).

tff(pred_def_51794,type,
    v94119: state_type > $o ).

tff(pred_def_51795,type,
    v94118: state_type > $o ).

tff(pred_def_51796,type,
    v94117: state_type > $o ).

tff(pred_def_51797,type,
    v94116: state_type > $o ).

tff(pred_def_51798,type,
    v94115: state_type > $o ).

tff(pred_def_51799,type,
    v94114: state_type > $o ).

tff(pred_def_51800,type,
    v94113: state_type > $o ).

tff(pred_def_51801,type,
    v94112: state_type > $o ).

tff(pred_def_51802,type,
    v94111: state_type > $o ).

tff(pred_def_51803,type,
    v94110: state_type > $o ).

tff(pred_def_51804,type,
    v94109: state_type > $o ).

tff(pred_def_51805,type,
    v94108: state_type > $o ).

tff(pred_def_51806,type,
    v94107: state_type > $o ).

tff(pred_def_51807,type,
    v94106: state_type > $o ).

tff(pred_def_51808,type,
    v94105: state_type > $o ).

tff(pred_def_51809,type,
    v94104: state_type > $o ).

tff(pred_def_51810,type,
    v94103: state_type > $o ).

tff(pred_def_51811,type,
    v94102: state_type > $o ).

tff(pred_def_51812,type,
    v94101: state_type > $o ).

tff(pred_def_51813,type,
    v94100: state_type > $o ).

tff(pred_def_51814,type,
    v94099: state_type > $o ).

tff(pred_def_51815,type,
    v94098: state_type > $o ).

tff(pred_def_51816,type,
    v94097: state_type > $o ).

tff(pred_def_51817,type,
    v94096: state_type > $o ).

tff(pred_def_51818,type,
    v94095: state_type > $o ).

tff(pred_def_51819,type,
    v94094: state_type > $o ).

tff(pred_def_51820,type,
    v94093: state_type > $o ).

tff(pred_def_51821,type,
    v94092: state_type > $o ).

tff(pred_def_51822,type,
    v94091: state_type > $o ).

tff(pred_def_51823,type,
    v94162: state_type > $o ).

tff(pred_def_51824,type,
    v94161: state_type > $o ).

tff(pred_def_51825,type,
    v94160: state_type > $o ).

tff(pred_def_51826,type,
    v94159: state_type > $o ).

tff(pred_def_51827,type,
    v94158: state_type > $o ).

tff(pred_def_51828,type,
    v94157: state_type > $o ).

tff(pred_def_51829,type,
    v94156: state_type > $o ).

tff(pred_def_51830,type,
    v94155: state_type > $o ).

tff(pred_def_51831,type,
    v94154: state_type > $o ).

tff(pred_def_51832,type,
    v94153: state_type > $o ).

tff(pred_def_51833,type,
    v94152: state_type > $o ).

tff(pred_def_51834,type,
    v94151: state_type > $o ).

tff(pred_def_51835,type,
    v94150: state_type > $o ).

tff(pred_def_51836,type,
    v94149: state_type > $o ).

tff(pred_def_51837,type,
    v94148: state_type > $o ).

tff(pred_def_51838,type,
    v94147: state_type > $o ).

tff(pred_def_51839,type,
    v94146: state_type > $o ).

tff(pred_def_51840,type,
    v94145: state_type > $o ).

tff(pred_def_51841,type,
    v94144: state_type > $o ).

tff(pred_def_51842,type,
    v94143: state_type > $o ).

tff(pred_def_51843,type,
    v94142: state_type > $o ).

tff(pred_def_51844,type,
    v94141: state_type > $o ).

tff(pred_def_51845,type,
    v94140: state_type > $o ).

tff(pred_def_51846,type,
    v94139: state_type > $o ).

tff(pred_def_51847,type,
    v94138: state_type > $o ).

tff(pred_def_51848,type,
    v94137: state_type > $o ).

tff(pred_def_51849,type,
    v94136: state_type > $o ).

tff(pred_def_51850,type,
    v94135: state_type > $o ).

tff(pred_def_51851,type,
    v94134: state_type > $o ).

tff(pred_def_51852,type,
    v94133: state_type > $o ).

tff(pred_def_51853,type,
    v94132: state_type > $o ).

tff(pred_def_51854,type,
    v94131: state_type > $o ).

tff(pred_def_51855,type,
    v94130: state_type > $o ).

tff(pred_def_51856,type,
    v94129: state_type > $o ).

tff(pred_def_51857,type,
    v94128: state_type > $o ).

tff(pred_def_51858,type,
    v94127: state_type > $o ).

tff(pred_def_51859,type,
    v94126: state_type > $o ).

tff(pred_def_51860,type,
    v94199: state_type > $o ).

tff(pred_def_51861,type,
    v94198: state_type > $o ).

tff(pred_def_51862,type,
    v94197: state_type > $o ).

tff(pred_def_51863,type,
    v94196: state_type > $o ).

tff(pred_def_51864,type,
    v94195: state_type > $o ).

tff(pred_def_51865,type,
    v94194: state_type > $o ).

tff(pred_def_51866,type,
    v94193: state_type > $o ).

tff(pred_def_51867,type,
    v94192: state_type > $o ).

tff(pred_def_51868,type,
    v94191: state_type > $o ).

tff(pred_def_51869,type,
    v94190: state_type > $o ).

tff(pred_def_51870,type,
    v94189: state_type > $o ).

tff(pred_def_51871,type,
    v94188: state_type > $o ).

tff(pred_def_51872,type,
    v94187: state_type > $o ).

tff(pred_def_51873,type,
    v94186: state_type > $o ).

tff(pred_def_51874,type,
    v94185: state_type > $o ).

tff(pred_def_51875,type,
    v94184: state_type > $o ).

tff(pred_def_51876,type,
    v94183: state_type > $o ).

tff(pred_def_51877,type,
    v94182: state_type > $o ).

tff(pred_def_51878,type,
    v94181: state_type > $o ).

tff(pred_def_51879,type,
    v94180: state_type > $o ).

tff(pred_def_51880,type,
    v94179: state_type > $o ).

tff(pred_def_51881,type,
    v94178: state_type > $o ).

tff(pred_def_51882,type,
    v94177: state_type > $o ).

tff(pred_def_51883,type,
    v94176: state_type > $o ).

tff(pred_def_51884,type,
    v94175: state_type > $o ).

tff(pred_def_51885,type,
    v94174: state_type > $o ).

tff(pred_def_51886,type,
    v94173: state_type > $o ).

tff(pred_def_51887,type,
    v94172: state_type > $o ).

tff(pred_def_51888,type,
    v94171: state_type > $o ).

tff(pred_def_51889,type,
    v94170: state_type > $o ).

tff(pred_def_51890,type,
    v94169: state_type > $o ).

tff(pred_def_51891,type,
    v94168: state_type > $o ).

tff(pred_def_51892,type,
    v94167: state_type > $o ).

tff(pred_def_51893,type,
    v94166: state_type > $o ).

tff(pred_def_51894,type,
    v94165: state_type > $o ).

tff(pred_def_51895,type,
    v94164: state_type > $o ).

tff(pred_def_51896,type,
    v94235: state_type > $o ).

tff(pred_def_51897,type,
    v94234: state_type > $o ).

tff(pred_def_51898,type,
    v94233: state_type > $o ).

tff(pred_def_51899,type,
    v94232: state_type > $o ).

tff(pred_def_51900,type,
    v94231: state_type > $o ).

tff(pred_def_51901,type,
    v94230: state_type > $o ).

tff(pred_def_51902,type,
    v94229: state_type > $o ).

tff(pred_def_51903,type,
    v94228: state_type > $o ).

tff(pred_def_51904,type,
    v94227: state_type > $o ).

tff(pred_def_51905,type,
    v94226: state_type > $o ).

tff(pred_def_51906,type,
    v94225: state_type > $o ).

tff(pred_def_51907,type,
    v94224: state_type > $o ).

tff(pred_def_51908,type,
    v94223: state_type > $o ).

tff(pred_def_51909,type,
    v94222: state_type > $o ).

tff(pred_def_51910,type,
    v94221: state_type > $o ).

tff(pred_def_51911,type,
    v94220: state_type > $o ).

tff(pred_def_51912,type,
    v94219: state_type > $o ).

tff(pred_def_51913,type,
    v94218: state_type > $o ).

tff(pred_def_51914,type,
    v94217: state_type > $o ).

tff(pred_def_51915,type,
    v94216: state_type > $o ).

tff(pred_def_51916,type,
    v94215: state_type > $o ).

tff(pred_def_51917,type,
    v94214: state_type > $o ).

tff(pred_def_51918,type,
    v94213: state_type > $o ).

tff(pred_def_51919,type,
    v94212: state_type > $o ).

tff(pred_def_51920,type,
    v94211: state_type > $o ).

tff(pred_def_51921,type,
    v94210: state_type > $o ).

tff(pred_def_51922,type,
    v94209: state_type > $o ).

tff(pred_def_51923,type,
    v94208: state_type > $o ).

tff(pred_def_51924,type,
    v94207: state_type > $o ).

tff(pred_def_51925,type,
    v94206: state_type > $o ).

tff(pred_def_51926,type,
    v94205: state_type > $o ).

tff(pred_def_51927,type,
    v94204: state_type > $o ).

tff(pred_def_51928,type,
    v94203: state_type > $o ).

tff(pred_def_51929,type,
    v94202: state_type > $o ).

tff(pred_def_51930,type,
    v94201: state_type > $o ).

tff(pred_def_51931,type,
    v94271: state_type > $o ).

tff(pred_def_51932,type,
    v94270: state_type > $o ).

tff(pred_def_51933,type,
    v94269: state_type > $o ).

tff(pred_def_51934,type,
    v94268: state_type > $o ).

tff(pred_def_51935,type,
    v94267: state_type > $o ).

tff(pred_def_51936,type,
    v94266: state_type > $o ).

tff(pred_def_51937,type,
    v94265: state_type > $o ).

tff(pred_def_51938,type,
    v94264: state_type > $o ).

tff(pred_def_51939,type,
    v94263: state_type > $o ).

tff(pred_def_51940,type,
    v94262: state_type > $o ).

tff(pred_def_51941,type,
    v94261: state_type > $o ).

tff(pred_def_51942,type,
    v94260: state_type > $o ).

tff(pred_def_51943,type,
    v94259: state_type > $o ).

tff(pred_def_51944,type,
    v94258: state_type > $o ).

tff(pred_def_51945,type,
    v94257: state_type > $o ).

tff(pred_def_51946,type,
    v94256: state_type > $o ).

tff(pred_def_51947,type,
    v94255: state_type > $o ).

tff(pred_def_51948,type,
    v94254: state_type > $o ).

tff(pred_def_51949,type,
    v94253: state_type > $o ).

tff(pred_def_51950,type,
    v94252: state_type > $o ).

tff(pred_def_51951,type,
    v94251: state_type > $o ).

tff(pred_def_51952,type,
    v94250: state_type > $o ).

tff(pred_def_51953,type,
    v94249: state_type > $o ).

tff(pred_def_51954,type,
    v94248: state_type > $o ).

tff(pred_def_51955,type,
    v94247: state_type > $o ).

tff(pred_def_51956,type,
    v94246: state_type > $o ).

tff(pred_def_51957,type,
    v94245: state_type > $o ).

tff(pred_def_51958,type,
    v94244: state_type > $o ).

tff(pred_def_51959,type,
    v94243: state_type > $o ).

tff(pred_def_51960,type,
    v94242: state_type > $o ).

tff(pred_def_51961,type,
    v94241: state_type > $o ).

tff(pred_def_51962,type,
    v94240: state_type > $o ).

tff(pred_def_51963,type,
    v94239: state_type > $o ).

tff(pred_def_51964,type,
    v94238: state_type > $o ).

tff(pred_def_51965,type,
    v94237: state_type > $o ).

tff(pred_def_51966,type,
    v94049: ( state_type * $int ) > $o ).

tff(pred_def_51967,type,
    v94047: ( state_type * $int ) > $o ).

tff(pred_def_51968,type,
    v94045: ( state_type * $int ) > $o ).

tff(pred_def_51969,type,
    v94043: ( state_type * $int ) > $o ).

tff(pred_def_51970,type,
    v94041: ( state_type * $int ) > $o ).

tff(pred_def_51971,type,
    v94282: state_type > $o ).

tff(pred_def_51972,type,
    v94280: state_type > $o ).

tff(pred_def_51973,type,
    v94278: state_type > $o ).

tff(pred_def_51974,type,
    v94276: state_type > $o ).

tff(pred_def_51975,type,
    v94274: state_type > $o ).

tff(pred_def_51976,type,
    v94286: state_type > $o ).

tff(pred_def_51977,type,
    v94285: ( state_type * $int ) > $o ).

tff(pred_def_51978,type,
    v94284: ( state_type * $int ) > $o ).

tff(pred_def_51979,type,
    v94289: state_type > $o ).

tff(pred_def_51980,type,
    v94288: ( state_type * $int ) > $o ).

tff(pred_def_51981,type,
    v94287: ( state_type * $int ) > $o ).

tff(pred_def_51982,type,
    v93544: ( state_type * $int ) > $o ).

tff(pred_def_51983,type,
    v93542: ( state_type * $int ) > $o ).

tff(pred_def_51984,type,
    v93540: ( state_type * $int ) > $o ).

tff(pred_def_51985,type,
    v93538: ( state_type * $int ) > $o ).

tff(pred_def_51986,type,
    v93536: ( state_type * $int ) > $o ).

tff(pred_def_51987,type,
    v93483: state_type > $o ).

tff(pred_def_51988,type,
    v93481: state_type > $o ).

tff(pred_def_51989,type,
    v93479: state_type > $o ).

tff(pred_def_51990,type,
    v93477: state_type > $o ).

tff(pred_def_51991,type,
    v93475: state_type > $o ).

tff(pred_def_51992,type,
    v94306: state_type > $o ).

tff(pred_def_51993,type,
    v94304: state_type > $o ).

tff(pred_def_51994,type,
    v94303: state_type > $o ).

tff(pred_def_51995,type,
    v94302: ( state_type * $int ) > $o ).

tff(pred_def_51996,type,
    v94299: state_type > $o ).

tff(pred_def_51997,type,
    v94297: state_type > $o ).

tff(pred_def_51998,type,
    v94314: state_type > $o ).

tff(pred_def_51999,type,
    v94312: state_type > $o ).

tff(pred_def_52000,type,
    v94311: state_type > $o ).

tff(pred_def_52001,type,
    v94310: ( state_type * $int ) > $o ).

tff(pred_def_52002,type,
    v94294: state_type > $o ).

tff(pred_def_52003,type,
    v94318: state_type > $o ).

tff(pred_def_52004,type,
    v90968: state_type > $o ).

tff(pred_def_52005,type,
    v94321: state_type > $o ).

tff(pred_def_52006,type,
    v94320: state_type > $o ).

tff(pred_def_52007,type,
    v94319: state_type > $o ).

tff(pred_def_52008,type,
    v94292: state_type > $o ).

tff(pred_def_52009,type,
    v94328: state_type > $o ).

tff(pred_def_52010,type,
    v94327: state_type > $o ).

tff(pred_def_52011,type,
    v94326: state_type > $o ).

tff(pred_def_52012,type,
    v94325: state_type > $o ).

tff(pred_def_52013,type,
    v94324: state_type > $o ).

tff(pred_def_52014,type,
    v94323: state_type > $o ).

tff(pred_def_52015,type,
    v94329: state_type > $o ).

tff(pred_def_52016,type,
    v90990: state_type > $o ).

tff(pred_def_52017,type,
    v94353: state_type > $o ).

tff(pred_def_52018,type,
    v94351: state_type > $o ).

tff(pred_def_52019,type,
    v94357: state_type > $o ).

tff(pred_def_52020,type,
    v94355: state_type > $o ).

tff(pred_def_52021,type,
    v94349: state_type > $o ).

tff(pred_def_52022,type,
    v94347: state_type > $o ).

tff(pred_def_52023,type,
    v94345: state_type > $o ).

tff(pred_def_52024,type,
    v94368: state_type > $o ).

tff(pred_def_52025,type,
    v94366: state_type > $o ).

tff(pred_def_52026,type,
    v94372: state_type > $o ).

tff(pred_def_52027,type,
    v94370: state_type > $o ).

tff(pred_def_52028,type,
    v94364: state_type > $o ).

tff(pred_def_52029,type,
    v94362: state_type > $o ).

tff(pred_def_52030,type,
    v94360: state_type > $o ).

tff(pred_def_52031,type,
    v94383: state_type > $o ).

tff(pred_def_52032,type,
    v94381: state_type > $o ).

tff(pred_def_52033,type,
    v94387: state_type > $o ).

tff(pred_def_52034,type,
    v94385: state_type > $o ).

tff(pred_def_52035,type,
    v94379: state_type > $o ).

tff(pred_def_52036,type,
    v94377: state_type > $o ).

tff(pred_def_52037,type,
    v94375: state_type > $o ).

tff(pred_def_52038,type,
    v94398: state_type > $o ).

tff(pred_def_52039,type,
    v94396: state_type > $o ).

tff(pred_def_52040,type,
    v94402: state_type > $o ).

tff(pred_def_52041,type,
    v94400: state_type > $o ).

tff(pred_def_52042,type,
    v94394: state_type > $o ).

tff(pred_def_52043,type,
    v94392: state_type > $o ).

tff(pred_def_52044,type,
    v94390: state_type > $o ).

tff(pred_def_52045,type,
    v94413: state_type > $o ).

tff(pred_def_52046,type,
    v94411: state_type > $o ).

tff(pred_def_52047,type,
    v94417: state_type > $o ).

tff(pred_def_52048,type,
    v94415: state_type > $o ).

tff(pred_def_52049,type,
    v94409: state_type > $o ).

tff(pred_def_52050,type,
    v94407: state_type > $o ).

tff(pred_def_52051,type,
    v94405: state_type > $o ).

tff(pred_def_52052,type,
    v94428: state_type > $o ).

tff(pred_def_52053,type,
    v94426: state_type > $o ).

tff(pred_def_52054,type,
    v94432: state_type > $o ).

tff(pred_def_52055,type,
    v94430: state_type > $o ).

tff(pred_def_52056,type,
    v94424: state_type > $o ).

tff(pred_def_52057,type,
    v94422: state_type > $o ).

tff(pred_def_52058,type,
    v94420: state_type > $o ).

tff(pred_def_52059,type,
    v94443: state_type > $o ).

tff(pred_def_52060,type,
    v94441: state_type > $o ).

tff(pred_def_52061,type,
    v94447: state_type > $o ).

tff(pred_def_52062,type,
    v94445: state_type > $o ).

tff(pred_def_52063,type,
    v94439: state_type > $o ).

tff(pred_def_52064,type,
    v94437: state_type > $o ).

tff(pred_def_52065,type,
    v94435: state_type > $o ).

tff(pred_def_52066,type,
    v94458: state_type > $o ).

tff(pred_def_52067,type,
    v94456: state_type > $o ).

tff(pred_def_52068,type,
    v94462: state_type > $o ).

tff(pred_def_52069,type,
    v94460: state_type > $o ).

tff(pred_def_52070,type,
    v94454: state_type > $o ).

tff(pred_def_52071,type,
    v94452: state_type > $o ).

tff(pred_def_52072,type,
    v94450: state_type > $o ).

tff(pred_def_52073,type,
    v94473: state_type > $o ).

tff(pred_def_52074,type,
    v94471: state_type > $o ).

tff(pred_def_52075,type,
    v94477: state_type > $o ).

tff(pred_def_52076,type,
    v94475: state_type > $o ).

tff(pred_def_52077,type,
    v94469: state_type > $o ).

tff(pred_def_52078,type,
    v94467: state_type > $o ).

tff(pred_def_52079,type,
    v94465: state_type > $o ).

tff(pred_def_52080,type,
    v94488: state_type > $o ).

tff(pred_def_52081,type,
    v94486: state_type > $o ).

tff(pred_def_52082,type,
    v94492: state_type > $o ).

tff(pred_def_52083,type,
    v94490: state_type > $o ).

tff(pred_def_52084,type,
    v94484: state_type > $o ).

tff(pred_def_52085,type,
    v94482: state_type > $o ).

tff(pred_def_52086,type,
    v94480: state_type > $o ).

tff(pred_def_52087,type,
    v94503: state_type > $o ).

tff(pred_def_52088,type,
    v94501: state_type > $o ).

tff(pred_def_52089,type,
    v94507: state_type > $o ).

tff(pred_def_52090,type,
    v94505: state_type > $o ).

tff(pred_def_52091,type,
    v94499: state_type > $o ).

tff(pred_def_52092,type,
    v94497: state_type > $o ).

tff(pred_def_52093,type,
    v94495: state_type > $o ).

tff(pred_def_52094,type,
    v94518: state_type > $o ).

tff(pred_def_52095,type,
    v94516: state_type > $o ).

tff(pred_def_52096,type,
    v94522: state_type > $o ).

tff(pred_def_52097,type,
    v94520: state_type > $o ).

tff(pred_def_52098,type,
    v94514: state_type > $o ).

tff(pred_def_52099,type,
    v94512: state_type > $o ).

tff(pred_def_52100,type,
    v94510: state_type > $o ).

tff(pred_def_52101,type,
    v94343: ( state_type * $int ) > $o ).

tff(pred_def_52102,type,
    v94341: ( state_type * $int ) > $o ).

tff(pred_def_52103,type,
    v94339: ( state_type * $int ) > $o ).

tff(pred_def_52104,type,
    v94337: ( state_type * $int ) > $o ).

tff(pred_def_52105,type,
    v94542: state_type > $o ).

tff(pred_def_52106,type,
    v94540: state_type > $o ).

tff(pred_def_52107,type,
    v94546: state_type > $o ).

tff(pred_def_52108,type,
    v94544: state_type > $o ).

tff(pred_def_52109,type,
    v94538: state_type > $o ).

tff(pred_def_52110,type,
    v94536: state_type > $o ).

tff(pred_def_52111,type,
    v94534: state_type > $o ).

tff(pred_def_52112,type,
    v94557: state_type > $o ).

tff(pred_def_52113,type,
    v94555: state_type > $o ).

tff(pred_def_52114,type,
    v94561: state_type > $o ).

tff(pred_def_52115,type,
    v94559: state_type > $o ).

tff(pred_def_52116,type,
    v94553: state_type > $o ).

tff(pred_def_52117,type,
    v94551: state_type > $o ).

tff(pred_def_52118,type,
    v94549: state_type > $o ).

tff(pred_def_52119,type,
    v94572: state_type > $o ).

tff(pred_def_52120,type,
    v94570: state_type > $o ).

tff(pred_def_52121,type,
    v94576: state_type > $o ).

tff(pred_def_52122,type,
    v94574: state_type > $o ).

tff(pred_def_52123,type,
    v94568: state_type > $o ).

tff(pred_def_52124,type,
    v94566: state_type > $o ).

tff(pred_def_52125,type,
    v94564: state_type > $o ).

tff(pred_def_52126,type,
    v94587: state_type > $o ).

tff(pred_def_52127,type,
    v94585: state_type > $o ).

tff(pred_def_52128,type,
    v94591: state_type > $o ).

tff(pred_def_52129,type,
    v94589: state_type > $o ).

tff(pred_def_52130,type,
    v94583: state_type > $o ).

tff(pred_def_52131,type,
    v94581: state_type > $o ).

tff(pred_def_52132,type,
    v94579: state_type > $o ).

tff(pred_def_52133,type,
    v94602: state_type > $o ).

tff(pred_def_52134,type,
    v94600: state_type > $o ).

tff(pred_def_52135,type,
    v94606: state_type > $o ).

tff(pred_def_52136,type,
    v94604: state_type > $o ).

tff(pred_def_52137,type,
    v94598: state_type > $o ).

tff(pred_def_52138,type,
    v94596: state_type > $o ).

tff(pred_def_52139,type,
    v94594: state_type > $o ).

tff(pred_def_52140,type,
    v94617: state_type > $o ).

tff(pred_def_52141,type,
    v94615: state_type > $o ).

tff(pred_def_52142,type,
    v94621: state_type > $o ).

tff(pred_def_52143,type,
    v94619: state_type > $o ).

tff(pred_def_52144,type,
    v94613: state_type > $o ).

tff(pred_def_52145,type,
    v94611: state_type > $o ).

tff(pred_def_52146,type,
    v94609: state_type > $o ).

tff(pred_def_52147,type,
    v94632: state_type > $o ).

tff(pred_def_52148,type,
    v94630: state_type > $o ).

tff(pred_def_52149,type,
    v94636: state_type > $o ).

tff(pred_def_52150,type,
    v94634: state_type > $o ).

tff(pred_def_52151,type,
    v94628: state_type > $o ).

tff(pred_def_52152,type,
    v94626: state_type > $o ).

tff(pred_def_52153,type,
    v94624: state_type > $o ).

tff(pred_def_52154,type,
    v94647: state_type > $o ).

tff(pred_def_52155,type,
    v94645: state_type > $o ).

tff(pred_def_52156,type,
    v94651: state_type > $o ).

tff(pred_def_52157,type,
    v94649: state_type > $o ).

tff(pred_def_52158,type,
    v94643: state_type > $o ).

tff(pred_def_52159,type,
    v94641: state_type > $o ).

tff(pred_def_52160,type,
    v94639: state_type > $o ).

tff(pred_def_52161,type,
    v94662: state_type > $o ).

tff(pred_def_52162,type,
    v94660: state_type > $o ).

tff(pred_def_52163,type,
    v94666: state_type > $o ).

tff(pred_def_52164,type,
    v94664: state_type > $o ).

tff(pred_def_52165,type,
    v94658: state_type > $o ).

tff(pred_def_52166,type,
    v94656: state_type > $o ).

tff(pred_def_52167,type,
    v94654: state_type > $o ).

tff(pred_def_52168,type,
    v94677: state_type > $o ).

tff(pred_def_52169,type,
    v94675: state_type > $o ).

tff(pred_def_52170,type,
    v94681: state_type > $o ).

tff(pred_def_52171,type,
    v94679: state_type > $o ).

tff(pred_def_52172,type,
    v94673: state_type > $o ).

tff(pred_def_52173,type,
    v94671: state_type > $o ).

tff(pred_def_52174,type,
    v94669: state_type > $o ).

tff(pred_def_52175,type,
    v94692: state_type > $o ).

tff(pred_def_52176,type,
    v94690: state_type > $o ).

tff(pred_def_52177,type,
    v94696: state_type > $o ).

tff(pred_def_52178,type,
    v94694: state_type > $o ).

tff(pred_def_52179,type,
    v94688: state_type > $o ).

tff(pred_def_52180,type,
    v94686: state_type > $o ).

tff(pred_def_52181,type,
    v94684: state_type > $o ).

tff(pred_def_52182,type,
    v94707: state_type > $o ).

tff(pred_def_52183,type,
    v94705: state_type > $o ).

tff(pred_def_52184,type,
    v94711: state_type > $o ).

tff(pred_def_52185,type,
    v94709: state_type > $o ).

tff(pred_def_52186,type,
    v94703: state_type > $o ).

tff(pred_def_52187,type,
    v94701: state_type > $o ).

tff(pred_def_52188,type,
    v94699: state_type > $o ).

tff(pred_def_52189,type,
    v94532: ( state_type * $int ) > $o ).

tff(pred_def_52190,type,
    v94530: ( state_type * $int ) > $o ).

tff(pred_def_52191,type,
    v94528: ( state_type * $int ) > $o ).

tff(pred_def_52192,type,
    v94714: ( state_type * $int ) > $o ).

tff(pred_def_52193,type,
    v94717: state_type > $o ).

tff(pred_def_52194,type,
    v94716: state_type > $o ).

tff(pred_def_52195,type,
    v94715: ( state_type * $int ) > $o ).

tff(pred_def_52196,type,
    v94526: ( state_type * $int ) > $o ).

tff(pred_def_52197,type,
    v94721: state_type > $o ).

tff(pred_def_52198,type,
    v94724: state_type > $o ).

tff(pred_def_52199,type,
    v94723: state_type > $o ).

tff(pred_def_52200,type,
    v94722: state_type > $o ).

tff(pred_def_52201,type,
    v94719: state_type > $o ).

tff(pred_def_52202,type,
    v94742: state_type > $o ).

tff(pred_def_52203,type,
    v94741: state_type > $o ).

tff(pred_def_52204,type,
    v94740: state_type > $o ).

tff(pred_def_52205,type,
    v94739: state_type > $o ).

tff(pred_def_52206,type,
    v94738: state_type > $o ).

tff(pred_def_52207,type,
    v94737: state_type > $o ).

tff(pred_def_52208,type,
    v94736: state_type > $o ).

tff(pred_def_52209,type,
    v94735: state_type > $o ).

tff(pred_def_52210,type,
    v94734: state_type > $o ).

tff(pred_def_52211,type,
    v94733: state_type > $o ).

tff(pred_def_52212,type,
    v94731: state_type > $o ).

tff(pred_def_52213,type,
    v94754: state_type > $o ).

tff(pred_def_52214,type,
    v94753: state_type > $o ).

tff(pred_def_52215,type,
    v94752: state_type > $o ).

tff(pred_def_52216,type,
    v94751: state_type > $o ).

tff(pred_def_52217,type,
    v94750: state_type > $o ).

tff(pred_def_52218,type,
    v94749: state_type > $o ).

tff(pred_def_52219,type,
    v94748: state_type > $o ).

tff(pred_def_52220,type,
    v94747: state_type > $o ).

tff(pred_def_52221,type,
    v94746: state_type > $o ).

tff(pred_def_52222,type,
    v94745: state_type > $o ).

tff(pred_def_52223,type,
    v94743: state_type > $o ).

tff(pred_def_52224,type,
    v94730: state_type > $o ).

tff(pred_def_52225,type,
    v94729: state_type > $o ).

tff(pred_def_52226,type,
    v4513: state_type > $o ).

tff(pred_def_52227,type,
    v94728: state_type > $o ).

tff(pred_def_52228,type,
    v94755: state_type > $o ).

tff(pred_def_52229,type,
    v94727: state_type > $o ).

tff(pred_def_52230,type,
    v89722: state_type > $o ).

tff(pred_def_52231,type,
    v94756: state_type > $o ).

tff(pred_def_52232,type,
    v94726: state_type > $o ).

tff(pred_def_52233,type,
    v94335: state_type > $o ).

tff(pred_def_52234,type,
    v94770: state_type > $o ).

tff(pred_def_52235,type,
    v94768: state_type > $o ).

tff(pred_def_52236,type,
    v94774: state_type > $o ).

tff(pred_def_52237,type,
    v94772: state_type > $o ).

tff(pred_def_52238,type,
    v94781: ( state_type * $int ) > $o ).

tff(pred_def_52239,type,
    v94782: state_type > $o ).

tff(pred_def_52240,type,
    v94780: ( state_type * $int ) > $o ).

tff(pred_def_52241,type,
    v94778: ( state_type * $int ) > $o ).

tff(pred_def_52242,type,
    v94776: ( state_type * $int ) > $o ).

tff(pred_def_52243,type,
    v94786: state_type > $o ).

tff(pred_def_52244,type,
    v94784: state_type > $o ).

tff(pred_def_52245,type,
    v94793: state_type > $o ).

tff(pred_def_52246,type,
    v94791: state_type > $o ).

tff(pred_def_52247,type,
    v94790: state_type > $o ).

tff(pred_def_52248,type,
    v94789: state_type > $o ).

tff(pred_def_52249,type,
    v94801: state_type > $o ).

tff(pred_def_52250,type,
    v94802: state_type > $o ).

tff(pred_def_52251,type,
    v94800: state_type > $o ).

tff(pred_def_52252,type,
    v94797: ( state_type * $int ) > $o ).

tff(pred_def_52253,type,
    v94799: ( state_type * $int ) > $o ).

tff(pred_def_52254,type,
    v94788: ( state_type * $int ) > $o ).

tff(pred_def_52255,type,
    v94766: ( state_type * $int ) > $o ).

tff(pred_def_52256,type,
    v94764: ( state_type * $int ) > $o ).

tff(pred_def_52257,type,
    v94762: state_type > $o ).

tff(pred_def_52258,type,
    v94822: ( state_type * $int ) > $o ).

tff(pred_def_52259,type,
    v94820: ( state_type * $int ) > $o ).

tff(pred_def_52260,type,
    v94862: state_type > $o ).

tff(pred_def_52261,type,
    v94860: state_type > $o ).

tff(pred_def_52262,type,
    v94858: state_type > $o ).

tff(pred_def_52263,type,
    v94856: state_type > $o ).

tff(pred_def_52264,type,
    v94854: state_type > $o ).

tff(pred_def_52265,type,
    v94852: state_type > $o ).

tff(pred_def_52266,type,
    v94850: state_type > $o ).

tff(pred_def_52267,type,
    v94876: state_type > $o ).

tff(pred_def_52268,type,
    v94874: state_type > $o ).

tff(pred_def_52269,type,
    v94872: state_type > $o ).

tff(pred_def_52270,type,
    v94870: state_type > $o ).

tff(pred_def_52271,type,
    v94868: state_type > $o ).

tff(pred_def_52272,type,
    v94866: state_type > $o ).

tff(pred_def_52273,type,
    v94864: state_type > $o ).

tff(pred_def_52274,type,
    v94894: state_type > $o ).

tff(pred_def_52275,type,
    v94892: state_type > $o ).

tff(pred_def_52276,type,
    v94898: state_type > $o ).

tff(pred_def_52277,type,
    v94896: state_type > $o ).

tff(pred_def_52278,type,
    v94910: state_type > $o ).

tff(pred_def_52279,type,
    v4343: state_type > $o ).

tff(pred_def_52280,type,
    v94908: state_type > $o ).

tff(pred_def_52281,type,
    v94886: ( state_type * $int ) > $o ).

tff(pred_def_52282,type,
    v94915: state_type > $o ).

tff(pred_def_52283,type,
    v94914: state_type > $o ).

tff(pred_def_52284,type,
    v94913: state_type > $o ).

tff(pred_def_52285,type,
    v94912: ( state_type * $int ) > $o ).

tff(pred_def_52286,type,
    v94911: ( state_type * $int ) > $o ).

tff(pred_def_52287,type,
    v94906: ( state_type * $int ) > $o ).

tff(pred_def_52288,type,
    v94904: ( state_type * $int ) > $o ).

tff(pred_def_52289,type,
    v94902: ( state_type * $int ) > $o ).

tff(pred_def_52290,type,
    v94900: ( state_type * $int ) > $o ).

tff(pred_def_52291,type,
    v94937: state_type > $o ).

tff(pred_def_52292,type,
    v94935: state_type > $o ).

tff(pred_def_52293,type,
    v94933: state_type > $o ).

tff(pred_def_52294,type,
    v94931: state_type > $o ).

tff(pred_def_52295,type,
    v94929: state_type > $o ).

tff(pred_def_52296,type,
    v94927: state_type > $o ).

tff(pred_def_52297,type,
    v94948: state_type > $o ).

tff(pred_def_52298,type,
    v94950: state_type > $o ).

tff(pred_def_52299,type,
    v94952: state_type > $o ).

tff(pred_def_52300,type,
    v94954: state_type > $o ).

tff(pred_def_52301,type,
    v94946: state_type > $o ).

tff(pred_def_52302,type,
    v94944: state_type > $o ).

tff(pred_def_52303,type,
    v94942: state_type > $o ).

tff(pred_def_52304,type,
    v94958: state_type > $o ).

tff(pred_def_52305,type,
    v94956: state_type > $o ).

tff(pred_def_52306,type,
    v94966: state_type > $o ).

tff(pred_def_52307,type,
    v94964: state_type > $o ).

tff(pred_def_52308,type,
    v94962: state_type > $o ).

tff(pred_def_52309,type,
    v94960: state_type > $o ).

tff(pred_def_52310,type,
    v94940: state_type > $o ).

tff(pred_def_52311,type,
    v94972: state_type > $o ).

tff(pred_def_52312,type,
    v94974: state_type > $o ).

tff(pred_def_52313,type,
    v94970: state_type > $o ).

tff(pred_def_52314,type,
    v94969: state_type > $o ).

tff(pred_def_52315,type,
    v94980: state_type > $o ).

tff(pred_def_52316,type,
    v94981: state_type > $o ).

tff(pred_def_52317,type,
    v94977: state_type > $o ).

tff(pred_def_52318,type,
    v94979: state_type > $o ).

tff(pred_def_52319,type,
    v94991: state_type > $o ).

tff(pred_def_52320,type,
    v94989: state_type > $o ).

tff(pred_def_52321,type,
    v94987: state_type > $o ).

tff(pred_def_52322,type,
    v94985: state_type > $o ).

tff(pred_def_52323,type,
    v94994: state_type > $o ).

tff(pred_def_52324,type,
    v94925: state_type > $o ).

tff(pred_def_52325,type,
    v94923: state_type > $o ).

tff(pred_def_52326,type,
    v94921: state_type > $o ).

tff(pred_def_52327,type,
    v94919: state_type > $o ).

tff(pred_def_52328,type,
    v94917: state_type > $o ).

tff(pred_def_52329,type,
    v95001: state_type > $o ).

tff(pred_def_52330,type,
    v94999: state_type > $o ).

tff(pred_def_52331,type,
    v94998: state_type > $o ).

tff(pred_def_52332,type,
    v94997: state_type > $o ).

tff(pred_def_52333,type,
    v95009: state_type > $o ).

tff(pred_def_52334,type,
    v95010: state_type > $o ).

tff(pred_def_52335,type,
    v95008: state_type > $o ).

tff(pred_def_52336,type,
    v95005: ( state_type * $int ) > $o ).

tff(pred_def_52337,type,
    v95007: ( state_type * $int ) > $o ).

tff(pred_def_52338,type,
    v94996: ( state_type * $int ) > $o ).

tff(pred_def_52339,type,
    v94890: ( state_type * $int ) > $o ).

tff(pred_def_52340,type,
    v94888: ( state_type * $int ) > $o ).

tff(pred_def_52341,type,
    v95018: state_type > $o ).

tff(pred_def_52342,type,
    v95016: state_type > $o ).

tff(pred_def_52343,type,
    v95015: state_type > $o ).

tff(pred_def_52344,type,
    v95014: ( state_type * $int ) > $o ).

tff(pred_def_52345,type,
    v95026: state_type > $o ).

tff(pred_def_52346,type,
    v95024: state_type > $o ).

tff(pred_def_52347,type,
    v95023: state_type > $o ).

tff(pred_def_52348,type,
    v95022: ( state_type * $int ) > $o ).

tff(pred_def_52349,type,
    v95034: state_type > $o ).

tff(pred_def_52350,type,
    v95032: state_type > $o ).

tff(pred_def_52351,type,
    v95031: state_type > $o ).

tff(pred_def_52352,type,
    v95030: ( state_type * $int ) > $o ).

tff(pred_def_52353,type,
    v95042: state_type > $o ).

tff(pred_def_52354,type,
    v95040: state_type > $o ).

tff(pred_def_52355,type,
    v95039: state_type > $o ).

tff(pred_def_52356,type,
    v95038: ( state_type * $int ) > $o ).

tff(pred_def_52357,type,
    v95050: state_type > $o ).

tff(pred_def_52358,type,
    v95048: state_type > $o ).

tff(pred_def_52359,type,
    v95047: state_type > $o ).

tff(pred_def_52360,type,
    v95046: ( state_type * $int ) > $o ).

tff(pred_def_52361,type,
    v95058: state_type > $o ).

tff(pred_def_52362,type,
    v95056: state_type > $o ).

tff(pred_def_52363,type,
    v95055: state_type > $o ).

tff(pred_def_52364,type,
    v95054: ( state_type * $int ) > $o ).

tff(pred_def_52365,type,
    v95066: state_type > $o ).

tff(pred_def_52366,type,
    v95064: state_type > $o ).

tff(pred_def_52367,type,
    v95063: state_type > $o ).

tff(pred_def_52368,type,
    v95062: ( state_type * $int ) > $o ).

tff(pred_def_52369,type,
    v95074: state_type > $o ).

tff(pred_def_52370,type,
    v95072: state_type > $o ).

tff(pred_def_52371,type,
    v95071: state_type > $o ).

tff(pred_def_52372,type,
    v95070: ( state_type * $int ) > $o ).

tff(pred_def_52373,type,
    v95082: state_type > $o ).

tff(pred_def_52374,type,
    v95080: state_type > $o ).

tff(pred_def_52375,type,
    v95079: state_type > $o ).

tff(pred_def_52376,type,
    v95078: ( state_type * $int ) > $o ).

tff(pred_def_52377,type,
    v95090: state_type > $o ).

tff(pred_def_52378,type,
    v95088: state_type > $o ).

tff(pred_def_52379,type,
    v95087: state_type > $o ).

tff(pred_def_52380,type,
    v95086: ( state_type * $int ) > $o ).

tff(pred_def_52381,type,
    v95098: state_type > $o ).

tff(pred_def_52382,type,
    v95096: state_type > $o ).

tff(pred_def_52383,type,
    v95095: state_type > $o ).

tff(pred_def_52384,type,
    v95094: ( state_type * $int ) > $o ).

tff(pred_def_52385,type,
    v94884: ( state_type * $int ) > $o ).

tff(pred_def_52386,type,
    v94882: ( state_type * $int ) > $o ).

tff(pred_def_52387,type,
    v95103: state_type > $o ).

tff(pred_def_52388,type,
    v95102: ( state_type * $int ) > $o ).

tff(pred_def_52389,type,
    v95101: ( state_type * $int ) > $o ).

tff(pred_def_52390,type,
    v95104: ( state_type * $int ) > $o ).

tff(pred_def_52391,type,
    v94880: ( state_type * $int ) > $o ).

tff(pred_def_52392,type,
    v94878: ( state_type * $int ) > $o ).

tff(pred_def_52393,type,
    v95116: state_type > $o ).

tff(pred_def_52394,type,
    v95114: state_type > $o ).

tff(pred_def_52395,type,
    v95112: state_type > $o ).

tff(pred_def_52396,type,
    v95122: state_type > $o ).

tff(pred_def_52397,type,
    v95120: state_type > $o ).

tff(pred_def_52398,type,
    v95126: state_type > $o ).

tff(pred_def_52399,type,
    v95124: state_type > $o ).

tff(pred_def_52400,type,
    v95134: state_type > $o ).

tff(pred_def_52401,type,
    v95132: state_type > $o ).

tff(pred_def_52402,type,
    v95130: state_type > $o ).

tff(pred_def_52403,type,
    v95128: state_type > $o ).

tff(pred_def_52404,type,
    v95118: state_type > $o ).

tff(pred_def_52405,type,
    v95140: state_type > $o ).

tff(pred_def_52406,type,
    v95142: state_type > $o ).

tff(pred_def_52407,type,
    v95138: state_type > $o ).

tff(pred_def_52408,type,
    v95137: state_type > $o ).

tff(pred_def_52409,type,
    v95148: state_type > $o ).

tff(pred_def_52410,type,
    v95149: state_type > $o ).

tff(pred_def_52411,type,
    v95145: state_type > $o ).

tff(pred_def_52412,type,
    v95147: state_type > $o ).

tff(pred_def_52413,type,
    v95159: state_type > $o ).

tff(pred_def_52414,type,
    v95157: state_type > $o ).

tff(pred_def_52415,type,
    v95155: state_type > $o ).

tff(pred_def_52416,type,
    v95153: state_type > $o ).

tff(pred_def_52417,type,
    v95161: state_type > $o ).

tff(pred_def_52418,type,
    v95110: state_type > $o ).

tff(pred_def_52419,type,
    v95108: state_type > $o ).

tff(pred_def_52420,type,
    v95106: state_type > $o ).

tff(pred_def_52421,type,
    v95168: state_type > $o ).

tff(pred_def_52422,type,
    v95166: state_type > $o ).

tff(pred_def_52423,type,
    v95165: state_type > $o ).

tff(pred_def_52424,type,
    v95164: state_type > $o ).

tff(pred_def_52425,type,
    v95176: state_type > $o ).

tff(pred_def_52426,type,
    v95177: state_type > $o ).

tff(pred_def_52427,type,
    v95175: state_type > $o ).

tff(pred_def_52428,type,
    v95172: ( state_type * $int ) > $o ).

tff(pred_def_52429,type,
    v95174: ( state_type * $int ) > $o ).

tff(pred_def_52430,type,
    v95163: ( state_type * $int ) > $o ).

tff(pred_def_52431,type,
    v94848: ( state_type * $int ) > $o ).

tff(pred_def_52432,type,
    v94846: ( state_type * $int ) > $o ).

tff(pred_def_52433,type,
    v94844: ( state_type * $int ) > $o ).

tff(pred_def_52434,type,
    v94842: ( state_type * $int ) > $o ).

tff(pred_def_52435,type,
    v94840: ( state_type * $int ) > $o ).

tff(pred_def_52436,type,
    v95181: state_type > $o ).

tff(pred_def_52437,type,
    v95180: ( state_type * $int ) > $o ).

tff(pred_def_52438,type,
    v94838: ( state_type * $int ) > $o ).

tff(pred_def_52439,type,
    v94836: ( state_type * $int ) > $o ).

tff(pred_def_52440,type,
    v94834: ( state_type * $int ) > $o ).

tff(pred_def_52441,type,
    v95182: ( state_type * $int ) > $o ).

tff(pred_def_52442,type,
    v94832: ( state_type * $int ) > $o ).

tff(pred_def_52443,type,
    v94830: ( state_type * $int ) > $o ).

tff(pred_def_52444,type,
    v94828: ( state_type * $int ) > $o ).

tff(pred_def_52445,type,
    v95185: state_type > $o ).

tff(pred_def_52446,type,
    v95184: ( state_type * $int ) > $o ).

tff(pred_def_52447,type,
    v95187: state_type > $o ).

tff(pred_def_52448,type,
    v95186: ( state_type * $int ) > $o ).

tff(pred_def_52449,type,
    v94826: ( state_type * $int ) > $o ).

tff(pred_def_52450,type,
    v94824: ( state_type * $int ) > $o ).

tff(pred_def_52451,type,
    v94818: state_type > $o ).

tff(pred_def_52452,type,
    v94816: state_type > $o ).

tff(pred_def_52453,type,
    v94814: state_type > $o ).

tff(pred_def_52454,type,
    v95198: ( state_type * $int ) > $o ).

tff(pred_def_52455,type,
    v95196: ( state_type * $int ) > $o ).

tff(pred_def_52456,type,
    v95226: state_type > $o ).

tff(pred_def_52457,type,
    v95224: state_type > $o ).

tff(pred_def_52458,type,
    v95223: state_type > $o ).

tff(pred_def_52459,type,
    v95222: ( state_type * $int ) > $o ).

tff(pred_def_52460,type,
    v95220: ( state_type * $int ) > $o ).

tff(pred_def_52461,type,
    v95218: ( state_type * $int ) > $o ).

tff(pred_def_52462,type,
    v95216: ( state_type * $int ) > $o ).

tff(pred_def_52463,type,
    v95230: state_type > $o ).

tff(pred_def_52464,type,
    v95229: ( state_type * $int ) > $o ).

tff(pred_def_52465,type,
    v95214: ( state_type * $int ) > $o ).

tff(pred_def_52466,type,
    v95212: ( state_type * $int ) > $o ).

tff(pred_def_52467,type,
    v95210: ( state_type * $int ) > $o ).

tff(pred_def_52468,type,
    v95231: ( state_type * $int ) > $o ).

tff(pred_def_52469,type,
    v95208: ( state_type * $int ) > $o ).

tff(pred_def_52470,type,
    v95206: ( state_type * $int ) > $o ).

tff(pred_def_52471,type,
    v95204: ( state_type * $int ) > $o ).

tff(pred_def_52472,type,
    v95234: state_type > $o ).

tff(pred_def_52473,type,
    v95233: ( state_type * $int ) > $o ).

tff(pred_def_52474,type,
    v95236: state_type > $o ).

tff(pred_def_52475,type,
    v95235: ( state_type * $int ) > $o ).

tff(pred_def_52476,type,
    v95202: ( state_type * $int ) > $o ).

tff(pred_def_52477,type,
    v95200: ( state_type * $int ) > $o ).

tff(pred_def_52478,type,
    v95194: state_type > $o ).

tff(pred_def_52479,type,
    v95192: state_type > $o ).

tff(pred_def_52480,type,
    v95190: state_type > $o ).

tff(pred_def_52481,type,
    v95247: ( state_type * $int ) > $o ).

tff(pred_def_52482,type,
    v95245: ( state_type * $int ) > $o ).

tff(pred_def_52483,type,
    v95269: state_type > $o ).

tff(pred_def_52484,type,
    v95267: state_type > $o ).

tff(pred_def_52485,type,
    v95266: state_type > $o ).

tff(pred_def_52486,type,
    v95265: ( state_type * $int ) > $o ).

tff(pred_def_52487,type,
    v95273: state_type > $o ).

tff(pred_def_52488,type,
    v95272: ( state_type * $int ) > $o ).

tff(pred_def_52489,type,
    v95263: ( state_type * $int ) > $o ).

tff(pred_def_52490,type,
    v95261: ( state_type * $int ) > $o ).

tff(pred_def_52491,type,
    v95259: ( state_type * $int ) > $o ).

tff(pred_def_52492,type,
    v95274: ( state_type * $int ) > $o ).

tff(pred_def_52493,type,
    v95257: ( state_type * $int ) > $o ).

tff(pred_def_52494,type,
    v95255: ( state_type * $int ) > $o ).

tff(pred_def_52495,type,
    v95253: ( state_type * $int ) > $o ).

tff(pred_def_52496,type,
    v95277: state_type > $o ).

tff(pred_def_52497,type,
    v95276: ( state_type * $int ) > $o ).

tff(pred_def_52498,type,
    v95279: state_type > $o ).

tff(pred_def_52499,type,
    v95278: ( state_type * $int ) > $o ).

tff(pred_def_52500,type,
    v95251: ( state_type * $int ) > $o ).

tff(pred_def_52501,type,
    v95249: ( state_type * $int ) > $o ).

tff(pred_def_52502,type,
    v95243: state_type > $o ).

tff(pred_def_52503,type,
    v95241: state_type > $o ).

tff(pred_def_52504,type,
    v95239: state_type > $o ).

tff(pred_def_52505,type,
    v95290: ( state_type * $int ) > $o ).

tff(pred_def_52506,type,
    v95288: ( state_type * $int ) > $o ).

tff(pred_def_52507,type,
    v95312: state_type > $o ).

tff(pred_def_52508,type,
    v95310: state_type > $o ).

tff(pred_def_52509,type,
    v95309: state_type > $o ).

tff(pred_def_52510,type,
    v95308: ( state_type * $int ) > $o ).

tff(pred_def_52511,type,
    v95316: state_type > $o ).

tff(pred_def_52512,type,
    v95315: ( state_type * $int ) > $o ).

tff(pred_def_52513,type,
    v95306: ( state_type * $int ) > $o ).

tff(pred_def_52514,type,
    v95304: ( state_type * $int ) > $o ).

tff(pred_def_52515,type,
    v95302: ( state_type * $int ) > $o ).

tff(pred_def_52516,type,
    v95317: ( state_type * $int ) > $o ).

tff(pred_def_52517,type,
    v95300: ( state_type * $int ) > $o ).

tff(pred_def_52518,type,
    v95298: ( state_type * $int ) > $o ).

tff(pred_def_52519,type,
    v95296: ( state_type * $int ) > $o ).

tff(pred_def_52520,type,
    v95320: state_type > $o ).

tff(pred_def_52521,type,
    v95319: ( state_type * $int ) > $o ).

tff(pred_def_52522,type,
    v95322: state_type > $o ).

tff(pred_def_52523,type,
    v95321: ( state_type * $int ) > $o ).

tff(pred_def_52524,type,
    v95294: ( state_type * $int ) > $o ).

tff(pred_def_52525,type,
    v95292: ( state_type * $int ) > $o ).

tff(pred_def_52526,type,
    v95286: state_type > $o ).

tff(pred_def_52527,type,
    v95284: state_type > $o ).

tff(pred_def_52528,type,
    v95282: state_type > $o ).

tff(pred_def_52529,type,
    v95333: ( state_type * $int ) > $o ).

tff(pred_def_52530,type,
    v95331: ( state_type * $int ) > $o ).

tff(pred_def_52531,type,
    v95355: state_type > $o ).

tff(pred_def_52532,type,
    v95353: state_type > $o ).

tff(pred_def_52533,type,
    v95352: state_type > $o ).

tff(pred_def_52534,type,
    v95351: ( state_type * $int ) > $o ).

tff(pred_def_52535,type,
    v95359: state_type > $o ).

tff(pred_def_52536,type,
    v95358: ( state_type * $int ) > $o ).

tff(pred_def_52537,type,
    v95349: ( state_type * $int ) > $o ).

tff(pred_def_52538,type,
    v95347: ( state_type * $int ) > $o ).

tff(pred_def_52539,type,
    v95345: ( state_type * $int ) > $o ).

tff(pred_def_52540,type,
    v95360: ( state_type * $int ) > $o ).

tff(pred_def_52541,type,
    v95343: ( state_type * $int ) > $o ).

tff(pred_def_52542,type,
    v95341: ( state_type * $int ) > $o ).

tff(pred_def_52543,type,
    v95339: ( state_type * $int ) > $o ).

tff(pred_def_52544,type,
    v95363: state_type > $o ).

tff(pred_def_52545,type,
    v95362: ( state_type * $int ) > $o ).

tff(pred_def_52546,type,
    v95365: state_type > $o ).

tff(pred_def_52547,type,
    v95364: ( state_type * $int ) > $o ).

tff(pred_def_52548,type,
    v95337: ( state_type * $int ) > $o ).

tff(pred_def_52549,type,
    v95335: ( state_type * $int ) > $o ).

tff(pred_def_52550,type,
    v95329: state_type > $o ).

tff(pred_def_52551,type,
    v95327: state_type > $o ).

tff(pred_def_52552,type,
    v95325: state_type > $o ).

tff(pred_def_52553,type,
    v95376: ( state_type * $int ) > $o ).

tff(pred_def_52554,type,
    v95374: ( state_type * $int ) > $o ).

tff(pred_def_52555,type,
    v95398: state_type > $o ).

tff(pred_def_52556,type,
    v95396: state_type > $o ).

tff(pred_def_52557,type,
    v95395: state_type > $o ).

tff(pred_def_52558,type,
    v95394: ( state_type * $int ) > $o ).

tff(pred_def_52559,type,
    v95402: state_type > $o ).

tff(pred_def_52560,type,
    v95401: ( state_type * $int ) > $o ).

tff(pred_def_52561,type,
    v95392: ( state_type * $int ) > $o ).

tff(pred_def_52562,type,
    v95390: ( state_type * $int ) > $o ).

tff(pred_def_52563,type,
    v95388: ( state_type * $int ) > $o ).

tff(pred_def_52564,type,
    v95403: ( state_type * $int ) > $o ).

tff(pred_def_52565,type,
    v95386: ( state_type * $int ) > $o ).

tff(pred_def_52566,type,
    v95384: ( state_type * $int ) > $o ).

tff(pred_def_52567,type,
    v95382: ( state_type * $int ) > $o ).

tff(pred_def_52568,type,
    v95406: state_type > $o ).

tff(pred_def_52569,type,
    v95405: ( state_type * $int ) > $o ).

tff(pred_def_52570,type,
    v95408: state_type > $o ).

tff(pred_def_52571,type,
    v95407: ( state_type * $int ) > $o ).

tff(pred_def_52572,type,
    v95380: ( state_type * $int ) > $o ).

tff(pred_def_52573,type,
    v95378: ( state_type * $int ) > $o ).

tff(pred_def_52574,type,
    v95372: state_type > $o ).

tff(pred_def_52575,type,
    v95370: state_type > $o ).

tff(pred_def_52576,type,
    v95368: state_type > $o ).

tff(pred_def_52577,type,
    v95419: ( state_type * $int ) > $o ).

tff(pred_def_52578,type,
    v95417: ( state_type * $int ) > $o ).

tff(pred_def_52579,type,
    v95441: state_type > $o ).

tff(pred_def_52580,type,
    v95439: state_type > $o ).

tff(pred_def_52581,type,
    v95438: state_type > $o ).

tff(pred_def_52582,type,
    v95437: ( state_type * $int ) > $o ).

tff(pred_def_52583,type,
    v95445: state_type > $o ).

tff(pred_def_52584,type,
    v95444: ( state_type * $int ) > $o ).

tff(pred_def_52585,type,
    v95435: ( state_type * $int ) > $o ).

tff(pred_def_52586,type,
    v95433: ( state_type * $int ) > $o ).

tff(pred_def_52587,type,
    v95431: ( state_type * $int ) > $o ).

tff(pred_def_52588,type,
    v95446: ( state_type * $int ) > $o ).

tff(pred_def_52589,type,
    v95429: ( state_type * $int ) > $o ).

tff(pred_def_52590,type,
    v95427: ( state_type * $int ) > $o ).

tff(pred_def_52591,type,
    v95425: ( state_type * $int ) > $o ).

tff(pred_def_52592,type,
    v95449: state_type > $o ).

tff(pred_def_52593,type,
    v95448: ( state_type * $int ) > $o ).

tff(pred_def_52594,type,
    v95451: state_type > $o ).

tff(pred_def_52595,type,
    v95450: ( state_type * $int ) > $o ).

tff(pred_def_52596,type,
    v95423: ( state_type * $int ) > $o ).

tff(pred_def_52597,type,
    v95421: ( state_type * $int ) > $o ).

tff(pred_def_52598,type,
    v95415: state_type > $o ).

tff(pred_def_52599,type,
    v95413: state_type > $o ).

tff(pred_def_52600,type,
    v95411: state_type > $o ).

tff(pred_def_52601,type,
    v95462: ( state_type * $int ) > $o ).

tff(pred_def_52602,type,
    v95460: ( state_type * $int ) > $o ).

tff(pred_def_52603,type,
    v95484: state_type > $o ).

tff(pred_def_52604,type,
    v95482: state_type > $o ).

tff(pred_def_52605,type,
    v95481: state_type > $o ).

tff(pred_def_52606,type,
    v95480: ( state_type * $int ) > $o ).

tff(pred_def_52607,type,
    v95488: state_type > $o ).

tff(pred_def_52608,type,
    v95487: ( state_type * $int ) > $o ).

tff(pred_def_52609,type,
    v95478: ( state_type * $int ) > $o ).

tff(pred_def_52610,type,
    v95476: ( state_type * $int ) > $o ).

tff(pred_def_52611,type,
    v95474: ( state_type * $int ) > $o ).

tff(pred_def_52612,type,
    v95489: ( state_type * $int ) > $o ).

tff(pred_def_52613,type,
    v95472: ( state_type * $int ) > $o ).

tff(pred_def_52614,type,
    v95470: ( state_type * $int ) > $o ).

tff(pred_def_52615,type,
    v95468: ( state_type * $int ) > $o ).

tff(pred_def_52616,type,
    v95492: state_type > $o ).

tff(pred_def_52617,type,
    v95491: ( state_type * $int ) > $o ).

tff(pred_def_52618,type,
    v95494: state_type > $o ).

tff(pred_def_52619,type,
    v95493: ( state_type * $int ) > $o ).

tff(pred_def_52620,type,
    v95466: ( state_type * $int ) > $o ).

tff(pred_def_52621,type,
    v95464: ( state_type * $int ) > $o ).

tff(pred_def_52622,type,
    v95458: state_type > $o ).

tff(pred_def_52623,type,
    v95456: state_type > $o ).

tff(pred_def_52624,type,
    v95454: state_type > $o ).

tff(pred_def_52625,type,
    v95505: ( state_type * $int ) > $o ).

tff(pred_def_52626,type,
    v95503: ( state_type * $int ) > $o ).

tff(pred_def_52627,type,
    v95527: state_type > $o ).

tff(pred_def_52628,type,
    v95525: state_type > $o ).

tff(pred_def_52629,type,
    v95524: state_type > $o ).

tff(pred_def_52630,type,
    v95523: ( state_type * $int ) > $o ).

tff(pred_def_52631,type,
    v95531: state_type > $o ).

tff(pred_def_52632,type,
    v95530: ( state_type * $int ) > $o ).

tff(pred_def_52633,type,
    v95521: ( state_type * $int ) > $o ).

tff(pred_def_52634,type,
    v95519: ( state_type * $int ) > $o ).

tff(pred_def_52635,type,
    v95517: ( state_type * $int ) > $o ).

tff(pred_def_52636,type,
    v95532: ( state_type * $int ) > $o ).

tff(pred_def_52637,type,
    v95515: ( state_type * $int ) > $o ).

tff(pred_def_52638,type,
    v95513: ( state_type * $int ) > $o ).

tff(pred_def_52639,type,
    v95511: ( state_type * $int ) > $o ).

tff(pred_def_52640,type,
    v95535: state_type > $o ).

tff(pred_def_52641,type,
    v95534: ( state_type * $int ) > $o ).

tff(pred_def_52642,type,
    v95537: state_type > $o ).

tff(pred_def_52643,type,
    v95536: ( state_type * $int ) > $o ).

tff(pred_def_52644,type,
    v95509: ( state_type * $int ) > $o ).

tff(pred_def_52645,type,
    v95507: ( state_type * $int ) > $o ).

tff(pred_def_52646,type,
    v95501: state_type > $o ).

tff(pred_def_52647,type,
    v95499: state_type > $o ).

tff(pred_def_52648,type,
    v95497: state_type > $o ).

tff(pred_def_52649,type,
    v95548: ( state_type * $int ) > $o ).

tff(pred_def_52650,type,
    v95546: ( state_type * $int ) > $o ).

tff(pred_def_52651,type,
    v95570: state_type > $o ).

tff(pred_def_52652,type,
    v95568: state_type > $o ).

tff(pred_def_52653,type,
    v95567: state_type > $o ).

tff(pred_def_52654,type,
    v95566: ( state_type * $int ) > $o ).

tff(pred_def_52655,type,
    v95574: state_type > $o ).

tff(pred_def_52656,type,
    v95573: ( state_type * $int ) > $o ).

tff(pred_def_52657,type,
    v95564: ( state_type * $int ) > $o ).

tff(pred_def_52658,type,
    v95562: ( state_type * $int ) > $o ).

tff(pred_def_52659,type,
    v95560: ( state_type * $int ) > $o ).

tff(pred_def_52660,type,
    v95575: ( state_type * $int ) > $o ).

tff(pred_def_52661,type,
    v95558: ( state_type * $int ) > $o ).

tff(pred_def_52662,type,
    v95556: ( state_type * $int ) > $o ).

tff(pred_def_52663,type,
    v95554: ( state_type * $int ) > $o ).

tff(pred_def_52664,type,
    v95578: state_type > $o ).

tff(pred_def_52665,type,
    v95577: ( state_type * $int ) > $o ).

tff(pred_def_52666,type,
    v95580: state_type > $o ).

tff(pred_def_52667,type,
    v95579: ( state_type * $int ) > $o ).

tff(pred_def_52668,type,
    v95552: ( state_type * $int ) > $o ).

tff(pred_def_52669,type,
    v95550: ( state_type * $int ) > $o ).

tff(pred_def_52670,type,
    v95544: state_type > $o ).

tff(pred_def_52671,type,
    v95542: state_type > $o ).

tff(pred_def_52672,type,
    v95540: state_type > $o ).

tff(pred_def_52673,type,
    v95591: ( state_type * $int ) > $o ).

tff(pred_def_52674,type,
    v95589: ( state_type * $int ) > $o ).

tff(pred_def_52675,type,
    v95613: state_type > $o ).

tff(pred_def_52676,type,
    v95611: state_type > $o ).

tff(pred_def_52677,type,
    v95610: state_type > $o ).

tff(pred_def_52678,type,
    v95609: ( state_type * $int ) > $o ).

tff(pred_def_52679,type,
    v95617: state_type > $o ).

tff(pred_def_52680,type,
    v95616: ( state_type * $int ) > $o ).

tff(pred_def_52681,type,
    v95607: ( state_type * $int ) > $o ).

tff(pred_def_52682,type,
    v95605: ( state_type * $int ) > $o ).

tff(pred_def_52683,type,
    v95603: ( state_type * $int ) > $o ).

tff(pred_def_52684,type,
    v95618: ( state_type * $int ) > $o ).

tff(pred_def_52685,type,
    v95601: ( state_type * $int ) > $o ).

tff(pred_def_52686,type,
    v95599: ( state_type * $int ) > $o ).

tff(pred_def_52687,type,
    v95597: ( state_type * $int ) > $o ).

tff(pred_def_52688,type,
    v95621: state_type > $o ).

tff(pred_def_52689,type,
    v95620: ( state_type * $int ) > $o ).

tff(pred_def_52690,type,
    v95623: state_type > $o ).

tff(pred_def_52691,type,
    v95622: ( state_type * $int ) > $o ).

tff(pred_def_52692,type,
    v95595: ( state_type * $int ) > $o ).

tff(pred_def_52693,type,
    v95593: ( state_type * $int ) > $o ).

tff(pred_def_52694,type,
    v95587: state_type > $o ).

tff(pred_def_52695,type,
    v95585: state_type > $o ).

tff(pred_def_52696,type,
    v95583: state_type > $o ).

tff(pred_def_52697,type,
    v95634: ( state_type * $int ) > $o ).

tff(pred_def_52698,type,
    v95632: ( state_type * $int ) > $o ).

tff(pred_def_52699,type,
    v95656: state_type > $o ).

tff(pred_def_52700,type,
    v95654: state_type > $o ).

tff(pred_def_52701,type,
    v95653: state_type > $o ).

tff(pred_def_52702,type,
    v95652: ( state_type * $int ) > $o ).

tff(pred_def_52703,type,
    v95660: state_type > $o ).

tff(pred_def_52704,type,
    v95659: ( state_type * $int ) > $o ).

tff(pred_def_52705,type,
    v95650: ( state_type * $int ) > $o ).

tff(pred_def_52706,type,
    v95648: ( state_type * $int ) > $o ).

tff(pred_def_52707,type,
    v95646: ( state_type * $int ) > $o ).

tff(pred_def_52708,type,
    v95661: ( state_type * $int ) > $o ).

tff(pred_def_52709,type,
    v95644: ( state_type * $int ) > $o ).

tff(pred_def_52710,type,
    v95642: ( state_type * $int ) > $o ).

tff(pred_def_52711,type,
    v95640: ( state_type * $int ) > $o ).

tff(pred_def_52712,type,
    v95664: state_type > $o ).

tff(pred_def_52713,type,
    v95663: ( state_type * $int ) > $o ).

tff(pred_def_52714,type,
    v95666: state_type > $o ).

tff(pred_def_52715,type,
    v95665: ( state_type * $int ) > $o ).

tff(pred_def_52716,type,
    v95638: ( state_type * $int ) > $o ).

tff(pred_def_52717,type,
    v95636: ( state_type * $int ) > $o ).

tff(pred_def_52718,type,
    v95630: state_type > $o ).

tff(pred_def_52719,type,
    v95628: state_type > $o ).

tff(pred_def_52720,type,
    v95626: state_type > $o ).

tff(pred_def_52721,type,
    v95677: ( state_type * $int ) > $o ).

tff(pred_def_52722,type,
    v95675: ( state_type * $int ) > $o ).

tff(pred_def_52723,type,
    v95711: state_type > $o ).

tff(pred_def_52724,type,
    v95709: state_type > $o ).

tff(pred_def_52725,type,
    v95708: state_type > $o ).

tff(pred_def_52726,type,
    v95707: ( state_type * $int ) > $o ).

tff(pred_def_52727,type,
    b00000000000000000000000000000000000000000000000: $int > $o ).

tff(pred_def_52728,type,
    v95714: ( state_type * $int ) > $o ).

tff(pred_def_52729,type,
    v95705: ( state_type * $int ) > $o ).

tff(pred_def_52730,type,
    v95703: ( state_type * $int ) > $o ).

tff(pred_def_52731,type,
    v95720: ( state_type * $int ) > $o ).

tff(pred_def_52732,type,
    v95719: ( state_type * $int ) > $o ).

tff(pred_def_52733,type,
    v95717: ( state_type * $int ) > $o ).

tff(pred_def_52734,type,
    v95722: ( state_type * $int ) > $o ).

tff(pred_def_52735,type,
    v95721: ( state_type * $int ) > $o ).

tff(pred_def_52736,type,
    v95701: ( state_type * $int ) > $o ).

tff(pred_def_52737,type,
    v95699: ( state_type * $int ) > $o ).

tff(pred_def_52738,type,
    v95697: state_type > $o ).

tff(pred_def_52739,type,
    v95695: state_type > $o ).

tff(pred_def_52740,type,
    v95723: ( state_type * $int ) > $o ).

tff(pred_def_52741,type,
    v95693: ( state_type * $int ) > $o ).

tff(pred_def_52742,type,
    v95691: ( state_type * $int ) > $o ).

tff(pred_def_52743,type,
    v95689: ( state_type * $int ) > $o ).

tff(pred_def_52744,type,
    v95724: ( state_type * $int ) > $o ).

tff(pred_def_52745,type,
    v95687: ( state_type * $int ) > $o ).

tff(pred_def_52746,type,
    v95685: ( state_type * $int ) > $o ).

tff(pred_def_52747,type,
    v95683: ( state_type * $int ) > $o ).

tff(pred_def_52748,type,
    v95730: state_type > $o ).

tff(pred_def_52749,type,
    v95728: state_type > $o ).

tff(pred_def_52750,type,
    v95727: state_type > $o ).

tff(pred_def_52751,type,
    v95726: ( state_type * $int ) > $o ).

tff(pred_def_52752,type,
    v95735: state_type > $o ).

tff(pred_def_52753,type,
    v95734: ( state_type * $int ) > $o ).

tff(pred_def_52754,type,
    v95737: state_type > $o ).

tff(pred_def_52755,type,
    v95736: ( state_type * $int ) > $o ).

tff(pred_def_52756,type,
    v95681: ( state_type * $int ) > $o ).

tff(pred_def_52757,type,
    v95679: ( state_type * $int ) > $o ).

tff(pred_def_52758,type,
    v95673: state_type > $o ).

tff(pred_def_52759,type,
    v95671: state_type > $o ).

tff(pred_def_52760,type,
    v95669: state_type > $o ).

tff(pred_def_52761,type,
    v94812: ( state_type * $int ) > $o ).

tff(pred_def_52762,type,
    v94810: ( state_type * $int ) > $o ).

tff(pred_def_52763,type,
    v94808: ( state_type * $int ) > $o ).

tff(pred_def_52764,type,
    v95754: ( state_type * $int ) > $o ).

tff(pred_def_52765,type,
    v95752: ( state_type * $int ) > $o ).

tff(pred_def_52766,type,
    v95778: state_type > $o ).

tff(pred_def_52767,type,
    v95776: state_type > $o ).

tff(pred_def_52768,type,
    v95775: state_type > $o ).

tff(pred_def_52769,type,
    v95774: ( state_type * $int ) > $o ).

tff(pred_def_52770,type,
    v95772: ( state_type * $int ) > $o ).

tff(pred_def_52771,type,
    v95782: state_type > $o ).

tff(pred_def_52772,type,
    v95781: ( state_type * $int ) > $o ).

tff(pred_def_52773,type,
    v95770: ( state_type * $int ) > $o ).

tff(pred_def_52774,type,
    v95768: ( state_type * $int ) > $o ).

tff(pred_def_52775,type,
    v95766: ( state_type * $int ) > $o ).

tff(pred_def_52776,type,
    v95783: ( state_type * $int ) > $o ).

tff(pred_def_52777,type,
    v95764: ( state_type * $int ) > $o ).

tff(pred_def_52778,type,
    v95762: ( state_type * $int ) > $o ).

tff(pred_def_52779,type,
    v95760: ( state_type * $int ) > $o ).

tff(pred_def_52780,type,
    v95786: state_type > $o ).

tff(pred_def_52781,type,
    v95785: ( state_type * $int ) > $o ).

tff(pred_def_52782,type,
    v95788: state_type > $o ).

tff(pred_def_52783,type,
    v95787: ( state_type * $int ) > $o ).

tff(pred_def_52784,type,
    v95758: ( state_type * $int ) > $o ).

tff(pred_def_52785,type,
    v95756: ( state_type * $int ) > $o ).

tff(pred_def_52786,type,
    v95750: state_type > $o ).

tff(pred_def_52787,type,
    v95748: state_type > $o ).

tff(pred_def_52788,type,
    v95746: state_type > $o ).

tff(pred_def_52789,type,
    v95799: ( state_type * $int ) > $o ).

tff(pred_def_52790,type,
    v95797: ( state_type * $int ) > $o ).

tff(pred_def_52791,type,
    v95817: ( state_type * $int ) > $o ).

tff(pred_def_52792,type,
    v95819: state_type > $o ).

tff(pred_def_52793,type,
    v95818: ( state_type * $int ) > $o ).

tff(pred_def_52794,type,
    v95815: ( state_type * $int ) > $o ).

tff(pred_def_52795,type,
    v95813: ( state_type * $int ) > $o ).

tff(pred_def_52796,type,
    v95811: ( state_type * $int ) > $o ).

tff(pred_def_52797,type,
    v95820: ( state_type * $int ) > $o ).

tff(pred_def_52798,type,
    v95809: ( state_type * $int ) > $o ).

tff(pred_def_52799,type,
    v95807: ( state_type * $int ) > $o ).

tff(pred_def_52800,type,
    v95805: ( state_type * $int ) > $o ).

tff(pred_def_52801,type,
    v95823: state_type > $o ).

tff(pred_def_52802,type,
    v95822: ( state_type * $int ) > $o ).

tff(pred_def_52803,type,
    v95825: state_type > $o ).

tff(pred_def_52804,type,
    v95824: ( state_type * $int ) > $o ).

tff(pred_def_52805,type,
    v95803: ( state_type * $int ) > $o ).

tff(pred_def_52806,type,
    v95801: ( state_type * $int ) > $o ).

tff(pred_def_52807,type,
    v95795: state_type > $o ).

tff(pred_def_52808,type,
    v95793: state_type > $o ).

tff(pred_def_52809,type,
    v95791: state_type > $o ).

tff(pred_def_52810,type,
    v95836: ( state_type * $int ) > $o ).

tff(pred_def_52811,type,
    v95834: ( state_type * $int ) > $o ).

tff(pred_def_52812,type,
    v95854: state_type > $o ).

tff(pred_def_52813,type,
    v95853: ( state_type * $int ) > $o ).

tff(pred_def_52814,type,
    v95852: ( state_type * $int ) > $o ).

tff(pred_def_52815,type,
    v95850: ( state_type * $int ) > $o ).

tff(pred_def_52816,type,
    v95848: ( state_type * $int ) > $o ).

tff(pred_def_52817,type,
    v95855: ( state_type * $int ) > $o ).

tff(pred_def_52818,type,
    v95846: ( state_type * $int ) > $o ).

tff(pred_def_52819,type,
    v95844: ( state_type * $int ) > $o ).

tff(pred_def_52820,type,
    v95842: ( state_type * $int ) > $o ).

tff(pred_def_52821,type,
    v95858: state_type > $o ).

tff(pred_def_52822,type,
    v95857: ( state_type * $int ) > $o ).

tff(pred_def_52823,type,
    v95860: state_type > $o ).

tff(pred_def_52824,type,
    v95859: ( state_type * $int ) > $o ).

tff(pred_def_52825,type,
    v95840: ( state_type * $int ) > $o ).

tff(pred_def_52826,type,
    v95838: ( state_type * $int ) > $o ).

tff(pred_def_52827,type,
    v95832: state_type > $o ).

tff(pred_def_52828,type,
    v95830: state_type > $o ).

tff(pred_def_52829,type,
    v95828: state_type > $o ).

tff(pred_def_52830,type,
    v95871: ( state_type * $int ) > $o ).

tff(pred_def_52831,type,
    v95869: ( state_type * $int ) > $o ).

tff(pred_def_52832,type,
    v95889: state_type > $o ).

tff(pred_def_52833,type,
    v95888: ( state_type * $int ) > $o ).

tff(pred_def_52834,type,
    v95887: ( state_type * $int ) > $o ).

tff(pred_def_52835,type,
    v95885: ( state_type * $int ) > $o ).

tff(pred_def_52836,type,
    v95883: ( state_type * $int ) > $o ).

tff(pred_def_52837,type,
    v95890: ( state_type * $int ) > $o ).

tff(pred_def_52838,type,
    v95881: ( state_type * $int ) > $o ).

tff(pred_def_52839,type,
    v95879: ( state_type * $int ) > $o ).

tff(pred_def_52840,type,
    v95877: ( state_type * $int ) > $o ).

tff(pred_def_52841,type,
    v95893: state_type > $o ).

tff(pred_def_52842,type,
    v95892: ( state_type * $int ) > $o ).

tff(pred_def_52843,type,
    v95895: state_type > $o ).

tff(pred_def_52844,type,
    v95894: ( state_type * $int ) > $o ).

tff(pred_def_52845,type,
    v95875: ( state_type * $int ) > $o ).

tff(pred_def_52846,type,
    v95873: ( state_type * $int ) > $o ).

tff(pred_def_52847,type,
    v95867: state_type > $o ).

tff(pred_def_52848,type,
    v95865: state_type > $o ).

tff(pred_def_52849,type,
    v95863: state_type > $o ).

tff(pred_def_52850,type,
    v95906: ( state_type * $int ) > $o ).

tff(pred_def_52851,type,
    v95904: ( state_type * $int ) > $o ).

tff(pred_def_52852,type,
    v95924: state_type > $o ).

tff(pred_def_52853,type,
    v95923: ( state_type * $int ) > $o ).

tff(pred_def_52854,type,
    v95922: ( state_type * $int ) > $o ).

tff(pred_def_52855,type,
    v95920: ( state_type * $int ) > $o ).

tff(pred_def_52856,type,
    v95918: ( state_type * $int ) > $o ).

tff(pred_def_52857,type,
    v95925: ( state_type * $int ) > $o ).

tff(pred_def_52858,type,
    v95916: ( state_type * $int ) > $o ).

tff(pred_def_52859,type,
    v95914: ( state_type * $int ) > $o ).

tff(pred_def_52860,type,
    v95912: ( state_type * $int ) > $o ).

tff(pred_def_52861,type,
    v95928: state_type > $o ).

tff(pred_def_52862,type,
    v95927: ( state_type * $int ) > $o ).

tff(pred_def_52863,type,
    v95930: state_type > $o ).

tff(pred_def_52864,type,
    v95929: ( state_type * $int ) > $o ).

tff(pred_def_52865,type,
    v95910: ( state_type * $int ) > $o ).

tff(pred_def_52866,type,
    v95908: ( state_type * $int ) > $o ).

tff(pred_def_52867,type,
    v95902: state_type > $o ).

tff(pred_def_52868,type,
    v95900: state_type > $o ).

tff(pred_def_52869,type,
    v95898: state_type > $o ).

tff(pred_def_52870,type,
    v95941: ( state_type * $int ) > $o ).

tff(pred_def_52871,type,
    v95939: ( state_type * $int ) > $o ).

tff(pred_def_52872,type,
    v95959: state_type > $o ).

tff(pred_def_52873,type,
    v95958: ( state_type * $int ) > $o ).

tff(pred_def_52874,type,
    v95957: ( state_type * $int ) > $o ).

tff(pred_def_52875,type,
    v95955: ( state_type * $int ) > $o ).

tff(pred_def_52876,type,
    v95953: ( state_type * $int ) > $o ).

tff(pred_def_52877,type,
    v95960: ( state_type * $int ) > $o ).

tff(pred_def_52878,type,
    v95951: ( state_type * $int ) > $o ).

tff(pred_def_52879,type,
    v95949: ( state_type * $int ) > $o ).

tff(pred_def_52880,type,
    v95947: ( state_type * $int ) > $o ).

tff(pred_def_52881,type,
    v95963: state_type > $o ).

tff(pred_def_52882,type,
    v95962: ( state_type * $int ) > $o ).

tff(pred_def_52883,type,
    v95965: state_type > $o ).

tff(pred_def_52884,type,
    v95964: ( state_type * $int ) > $o ).

tff(pred_def_52885,type,
    v95945: ( state_type * $int ) > $o ).

tff(pred_def_52886,type,
    v95943: ( state_type * $int ) > $o ).

tff(pred_def_52887,type,
    v95937: state_type > $o ).

tff(pred_def_52888,type,
    v95935: state_type > $o ).

tff(pred_def_52889,type,
    v95933: state_type > $o ).

tff(pred_def_52890,type,
    v95976: ( state_type * $int ) > $o ).

tff(pred_def_52891,type,
    v95974: ( state_type * $int ) > $o ).

tff(pred_def_52892,type,
    v95994: state_type > $o ).

tff(pred_def_52893,type,
    v95993: ( state_type * $int ) > $o ).

tff(pred_def_52894,type,
    v95992: ( state_type * $int ) > $o ).

tff(pred_def_52895,type,
    v95990: ( state_type * $int ) > $o ).

tff(pred_def_52896,type,
    v95988: ( state_type * $int ) > $o ).

tff(pred_def_52897,type,
    v95995: ( state_type * $int ) > $o ).

tff(pred_def_52898,type,
    v95986: ( state_type * $int ) > $o ).

tff(pred_def_52899,type,
    v95984: ( state_type * $int ) > $o ).

tff(pred_def_52900,type,
    v95982: ( state_type * $int ) > $o ).

tff(pred_def_52901,type,
    v95998: state_type > $o ).

tff(pred_def_52902,type,
    v95997: ( state_type * $int ) > $o ).

tff(pred_def_52903,type,
    v96000: state_type > $o ).

tff(pred_def_52904,type,
    v95999: ( state_type * $int ) > $o ).

tff(pred_def_52905,type,
    v95980: ( state_type * $int ) > $o ).

tff(pred_def_52906,type,
    v95978: ( state_type * $int ) > $o ).

tff(pred_def_52907,type,
    v95972: state_type > $o ).

tff(pred_def_52908,type,
    v95970: state_type > $o ).

tff(pred_def_52909,type,
    v95968: state_type > $o ).

tff(pred_def_52910,type,
    v96011: ( state_type * $int ) > $o ).

tff(pred_def_52911,type,
    v96009: ( state_type * $int ) > $o ).

tff(pred_def_52912,type,
    v96029: state_type > $o ).

tff(pred_def_52913,type,
    v96028: ( state_type * $int ) > $o ).

tff(pred_def_52914,type,
    v96027: ( state_type * $int ) > $o ).

tff(pred_def_52915,type,
    v96025: ( state_type * $int ) > $o ).

tff(pred_def_52916,type,
    v96023: ( state_type * $int ) > $o ).

tff(pred_def_52917,type,
    v96030: ( state_type * $int ) > $o ).

tff(pred_def_52918,type,
    v96021: ( state_type * $int ) > $o ).

tff(pred_def_52919,type,
    v96019: ( state_type * $int ) > $o ).

tff(pred_def_52920,type,
    v96017: ( state_type * $int ) > $o ).

tff(pred_def_52921,type,
    v96033: state_type > $o ).

tff(pred_def_52922,type,
    v96032: ( state_type * $int ) > $o ).

tff(pred_def_52923,type,
    v96035: state_type > $o ).

tff(pred_def_52924,type,
    v96034: ( state_type * $int ) > $o ).

tff(pred_def_52925,type,
    v96015: ( state_type * $int ) > $o ).

tff(pred_def_52926,type,
    v96013: ( state_type * $int ) > $o ).

tff(pred_def_52927,type,
    v96007: state_type > $o ).

tff(pred_def_52928,type,
    v96005: state_type > $o ).

tff(pred_def_52929,type,
    v96003: state_type > $o ).

tff(pred_def_52930,type,
    v96046: ( state_type * $int ) > $o ).

tff(pred_def_52931,type,
    v96044: ( state_type * $int ) > $o ).

tff(pred_def_52932,type,
    v96064: state_type > $o ).

tff(pred_def_52933,type,
    v96063: ( state_type * $int ) > $o ).

tff(pred_def_52934,type,
    v96062: ( state_type * $int ) > $o ).

tff(pred_def_52935,type,
    v96060: ( state_type * $int ) > $o ).

tff(pred_def_52936,type,
    v96058: ( state_type * $int ) > $o ).

tff(pred_def_52937,type,
    v96065: ( state_type * $int ) > $o ).

tff(pred_def_52938,type,
    v96056: ( state_type * $int ) > $o ).

tff(pred_def_52939,type,
    v96054: ( state_type * $int ) > $o ).

tff(pred_def_52940,type,
    v96052: ( state_type * $int ) > $o ).

tff(pred_def_52941,type,
    v96068: state_type > $o ).

tff(pred_def_52942,type,
    v96067: ( state_type * $int ) > $o ).

tff(pred_def_52943,type,
    v96070: state_type > $o ).

tff(pred_def_52944,type,
    v96069: ( state_type * $int ) > $o ).

tff(pred_def_52945,type,
    v96050: ( state_type * $int ) > $o ).

tff(pred_def_52946,type,
    v96048: ( state_type * $int ) > $o ).

tff(pred_def_52947,type,
    v96042: state_type > $o ).

tff(pred_def_52948,type,
    v96040: state_type > $o ).

tff(pred_def_52949,type,
    v96038: state_type > $o ).

tff(pred_def_52950,type,
    v96081: ( state_type * $int ) > $o ).

tff(pred_def_52951,type,
    v96079: ( state_type * $int ) > $o ).

tff(pred_def_52952,type,
    v96099: state_type > $o ).

tff(pred_def_52953,type,
    v96098: ( state_type * $int ) > $o ).

tff(pred_def_52954,type,
    v96097: ( state_type * $int ) > $o ).

tff(pred_def_52955,type,
    v96095: ( state_type * $int ) > $o ).

tff(pred_def_52956,type,
    v96093: ( state_type * $int ) > $o ).

tff(pred_def_52957,type,
    v96100: ( state_type * $int ) > $o ).

tff(pred_def_52958,type,
    v96091: ( state_type * $int ) > $o ).

tff(pred_def_52959,type,
    v96089: ( state_type * $int ) > $o ).

tff(pred_def_52960,type,
    v96087: ( state_type * $int ) > $o ).

tff(pred_def_52961,type,
    v96103: state_type > $o ).

tff(pred_def_52962,type,
    v96102: ( state_type * $int ) > $o ).

tff(pred_def_52963,type,
    v96105: state_type > $o ).

tff(pred_def_52964,type,
    v96104: ( state_type * $int ) > $o ).

tff(pred_def_52965,type,
    v96085: ( state_type * $int ) > $o ).

tff(pred_def_52966,type,
    v96083: ( state_type * $int ) > $o ).

tff(pred_def_52967,type,
    v96077: state_type > $o ).

tff(pred_def_52968,type,
    v96075: state_type > $o ).

tff(pred_def_52969,type,
    v96073: state_type > $o ).

tff(pred_def_52970,type,
    v96116: ( state_type * $int ) > $o ).

tff(pred_def_52971,type,
    v96114: ( state_type * $int ) > $o ).

tff(pred_def_52972,type,
    v96134: state_type > $o ).

tff(pred_def_52973,type,
    v96133: ( state_type * $int ) > $o ).

tff(pred_def_52974,type,
    v96132: ( state_type * $int ) > $o ).

tff(pred_def_52975,type,
    v96130: ( state_type * $int ) > $o ).

tff(pred_def_52976,type,
    v96128: ( state_type * $int ) > $o ).

tff(pred_def_52977,type,
    v96135: ( state_type * $int ) > $o ).

tff(pred_def_52978,type,
    v96126: ( state_type * $int ) > $o ).

tff(pred_def_52979,type,
    v96124: ( state_type * $int ) > $o ).

tff(pred_def_52980,type,
    v96122: ( state_type * $int ) > $o ).

tff(pred_def_52981,type,
    v96138: state_type > $o ).

tff(pred_def_52982,type,
    v96137: ( state_type * $int ) > $o ).

tff(pred_def_52983,type,
    v96140: state_type > $o ).

tff(pred_def_52984,type,
    v96139: ( state_type * $int ) > $o ).

tff(pred_def_52985,type,
    v96120: ( state_type * $int ) > $o ).

tff(pred_def_52986,type,
    v96118: ( state_type * $int ) > $o ).

tff(pred_def_52987,type,
    v96112: state_type > $o ).

tff(pred_def_52988,type,
    v96110: state_type > $o ).

tff(pred_def_52989,type,
    v96108: state_type > $o ).

tff(pred_def_52990,type,
    v96151: ( state_type * $int ) > $o ).

tff(pred_def_52991,type,
    v96149: ( state_type * $int ) > $o ).

tff(pred_def_52992,type,
    v96169: state_type > $o ).

tff(pred_def_52993,type,
    v96168: ( state_type * $int ) > $o ).

tff(pred_def_52994,type,
    v96167: ( state_type * $int ) > $o ).

tff(pred_def_52995,type,
    v96165: ( state_type * $int ) > $o ).

tff(pred_def_52996,type,
    v96163: ( state_type * $int ) > $o ).

tff(pred_def_52997,type,
    v96170: ( state_type * $int ) > $o ).

tff(pred_def_52998,type,
    v96161: ( state_type * $int ) > $o ).

tff(pred_def_52999,type,
    v96159: ( state_type * $int ) > $o ).

tff(pred_def_53000,type,
    v96157: ( state_type * $int ) > $o ).

tff(pred_def_53001,type,
    v96173: state_type > $o ).

tff(pred_def_53002,type,
    v96172: ( state_type * $int ) > $o ).

tff(pred_def_53003,type,
    v96175: state_type > $o ).

tff(pred_def_53004,type,
    v96174: ( state_type * $int ) > $o ).

tff(pred_def_53005,type,
    v96155: ( state_type * $int ) > $o ).

tff(pred_def_53006,type,
    v96153: ( state_type * $int ) > $o ).

tff(pred_def_53007,type,
    v96147: state_type > $o ).

tff(pred_def_53008,type,
    v96145: state_type > $o ).

tff(pred_def_53009,type,
    v96143: state_type > $o ).

tff(pred_def_53010,type,
    v96186: ( state_type * $int ) > $o ).

tff(pred_def_53011,type,
    v96184: ( state_type * $int ) > $o ).

tff(pred_def_53012,type,
    v96204: state_type > $o ).

tff(pred_def_53013,type,
    v96205: ( state_type * $int ) > $o ).

tff(pred_def_53014,type,
    v96202: ( state_type * $int ) > $o ).

tff(pred_def_53015,type,
    v96200: ( state_type * $int ) > $o ).

tff(pred_def_53016,type,
    v96198: ( state_type * $int ) > $o ).

tff(pred_def_53017,type,
    v96206: ( state_type * $int ) > $o ).

tff(pred_def_53018,type,
    v96196: ( state_type * $int ) > $o ).

tff(pred_def_53019,type,
    v96194: ( state_type * $int ) > $o ).

tff(pred_def_53020,type,
    v96192: ( state_type * $int ) > $o ).

tff(pred_def_53021,type,
    v96209: state_type > $o ).

tff(pred_def_53022,type,
    v96208: ( state_type * $int ) > $o ).

tff(pred_def_53023,type,
    v96211: state_type > $o ).

tff(pred_def_53024,type,
    v96210: ( state_type * $int ) > $o ).

tff(pred_def_53025,type,
    v96190: ( state_type * $int ) > $o ).

tff(pred_def_53026,type,
    v96188: ( state_type * $int ) > $o ).

tff(pred_def_53027,type,
    v96182: state_type > $o ).

tff(pred_def_53028,type,
    v96180: state_type > $o ).

tff(pred_def_53029,type,
    v96178: state_type > $o ).

tff(pred_def_53030,type,
    v95744: ( state_type * $int ) > $o ).

tff(pred_def_53031,type,
    v95742: ( state_type * $int ) > $o ).

tff(pred_def_53032,type,
    v95740: ( state_type * $int ) > $o ).

tff(pred_def_53033,type,
    v96216: state_type > $o ).

tff(pred_def_53034,type,
    v96219: state_type > $o ).

tff(pred_def_53035,type,
    v96218: state_type > $o ).

tff(pred_def_53036,type,
    v96217: state_type > $o ).

tff(pred_def_53037,type,
    v96214: state_type > $o ).

tff(pred_def_53038,type,
    v96231: state_type > $o ).

tff(pred_def_53039,type,
    v96229: state_type > $o ).

tff(pred_def_53040,type,
    v96228: state_type > $o ).

tff(pred_def_53041,type,
    v96227: ( state_type * $int ) > $o ).

tff(pred_def_53042,type,
    v96225: state_type > $o ).

tff(pred_def_53043,type,
    v96223: state_type > $o ).

tff(pred_def_53044,type,
    v96221: state_type > $o ).

tff(pred_def_53045,type,
    v96251: state_type > $o ).

tff(pred_def_53046,type,
    v96250: state_type > $o ).

tff(pred_def_53047,type,
    v96249: state_type > $o ).

tff(pred_def_53048,type,
    v96248: state_type > $o ).

tff(pred_def_53049,type,
    v96247: state_type > $o ).

tff(pred_def_53050,type,
    v96246: state_type > $o ).

tff(pred_def_53051,type,
    v96245: state_type > $o ).

tff(pred_def_53052,type,
    v96244: state_type > $o ).

tff(pred_def_53053,type,
    v96243: state_type > $o ).

tff(pred_def_53054,type,
    v96242: state_type > $o ).

tff(pred_def_53055,type,
    v96241: state_type > $o ).

tff(pred_def_53056,type,
    v96239: state_type > $o ).

tff(pred_def_53057,type,
    v96265: state_type > $o ).

tff(pred_def_53058,type,
    v96264: state_type > $o ).

tff(pred_def_53059,type,
    v96263: state_type > $o ).

tff(pred_def_53060,type,
    v96262: state_type > $o ).

tff(pred_def_53061,type,
    v96261: state_type > $o ).

tff(pred_def_53062,type,
    v96260: state_type > $o ).

tff(pred_def_53063,type,
    v96259: state_type > $o ).

tff(pred_def_53064,type,
    v96258: state_type > $o ).

tff(pred_def_53065,type,
    v96257: state_type > $o ).

tff(pred_def_53066,type,
    v96256: state_type > $o ).

tff(pred_def_53067,type,
    v96255: state_type > $o ).

tff(pred_def_53068,type,
    v96253: state_type > $o ).

tff(pred_def_53069,type,
    v96266: state_type > $o ).

tff(pred_def_53070,type,
    v96252: state_type > $o ).

tff(pred_def_53071,type,
    v96238: state_type > $o ).

tff(pred_def_53072,type,
    v96237: state_type > $o ).

tff(pred_def_53073,type,
    v96267: state_type > $o ).

tff(pred_def_53074,type,
    v96236: state_type > $o ).

tff(pred_def_53075,type,
    v96235: state_type > $o ).

tff(pred_def_53076,type,
    v96268: state_type > $o ).

tff(pred_def_53077,type,
    v94806: state_type > $o ).

tff(pred_def_53078,type,
    v96278: state_type > $o ).

tff(pred_def_53079,type,
    v96276: state_type > $o ).

tff(pred_def_53080,type,
    v96282: state_type > $o ).

tff(pred_def_53081,type,
    v96280: state_type > $o ).

tff(pred_def_53082,type,
    v96289: ( state_type * $int ) > $o ).

tff(pred_def_53083,type,
    v96288: ( state_type * $int ) > $o ).

tff(pred_def_53084,type,
    v96286: ( state_type * $int ) > $o ).

tff(pred_def_53085,type,
    v96284: ( state_type * $int ) > $o ).

tff(pred_def_53086,type,
    v96293: state_type > $o ).

tff(pred_def_53087,type,
    v96291: state_type > $o ).

tff(pred_def_53088,type,
    v96300: state_type > $o ).

tff(pred_def_53089,type,
    v96298: state_type > $o ).

tff(pred_def_53090,type,
    v96297: state_type > $o ).

tff(pred_def_53091,type,
    v96296: state_type > $o ).

tff(pred_def_53092,type,
    v96308: state_type > $o ).

tff(pred_def_53093,type,
    v96309: state_type > $o ).

tff(pred_def_53094,type,
    v96307: state_type > $o ).

tff(pred_def_53095,type,
    v96304: ( state_type * $int ) > $o ).

tff(pred_def_53096,type,
    v96306: ( state_type * $int ) > $o ).

tff(pred_def_53097,type,
    v96295: ( state_type * $int ) > $o ).

tff(pred_def_53098,type,
    v96274: ( state_type * $int ) > $o ).

tff(pred_def_53099,type,
    v96272: ( state_type * $int ) > $o ).

tff(pred_def_53100,type,
    v96270: state_type > $o ).

tff(pred_def_53101,type,
    v89674: ( state_type * $int ) > $o ).

tff(pred_def_53102,type,
    v96314: state_type > $o ).

tff(pred_def_53103,type,
    v96313: state_type > $o ).

tff(pred_def_53104,type,
    v96315: state_type > $o ).

tff(pred_def_53105,type,
    v94760: state_type > $o ).

tff(pred_def_53106,type,
    v96326: state_type > $o ).

tff(pred_def_53107,type,
    v96325: state_type > $o ).

tff(pred_def_53108,type,
    v96324: state_type > $o ).

tff(pred_def_53109,type,
    v96323: state_type > $o ).

tff(pred_def_53110,type,
    v96322: state_type > $o ).

tff(pred_def_53111,type,
    v96321: state_type > $o ).

tff(pred_def_53112,type,
    v96327: state_type > $o ).

tff(pred_def_53113,type,
    v96319: state_type > $o ).

tff(pred_def_53114,type,
    v96333: state_type > $o ).

tff(pred_def_53115,type,
    v96334: state_type > $o ).

tff(pred_def_53116,type,
    v96332: state_type > $o ).

tff(pred_def_53117,type,
    v96336: state_type > $o ).

tff(pred_def_53118,type,
    v96337: state_type > $o ).

tff(pred_def_53119,type,
    v96335: state_type > $o ).

tff(pred_def_53120,type,
    v96331: state_type > $o ).

tff(pred_def_53121,type,
    v96340: state_type > $o ).

tff(pred_def_53122,type,
    v96341: state_type > $o ).

tff(pred_def_53123,type,
    v96339: state_type > $o ).

tff(pred_def_53124,type,
    v96342: state_type > $o ).

tff(pred_def_53125,type,
    v96338: state_type > $o ).

tff(pred_def_53126,type,
    v96330: state_type > $o ).

tff(pred_def_53127,type,
    v96329: state_type > $o ).

tff(pred_def_53128,type,
    v96317: state_type > $o ).

tff(pred_def_53129,type,
    v94758: state_type > $o ).

tff(pred_def_53130,type,
    v96346: state_type > $o ).

tff(pred_def_53131,type,
    v94331: state_type > $o ).

tff(pred_def_53132,type,
    v96345: state_type > $o ).

tff(pred_def_53133,type,
    v94333: state_type > $o ).

tff(pred_def_53134,type,
    v89720: state_type > $o ).

tff(pred_def_53135,type,
    v96347: ( state_type * $int ) > $o ).

tff(pred_def_53136,type,
    v96348: state_type > $o ).

tff(pred_def_53137,type,
    v96349: state_type > $o ).

tff(pred_def_53138,type,
    v89718: ( state_type * $int ) > $o ).

tff(pred_def_53139,type,
    v89716: ( state_type * $int ) > $o ).

tff(pred_def_53140,type,
    v89714: ( state_type * $int ) > $o ).

tff(pred_def_53141,type,
    v96353: state_type > $o ).

tff(pred_def_53142,type,
    v96351: state_type > $o ).

tff(pred_def_53143,type,
    v96360: state_type > $o ).

tff(pred_def_53144,type,
    v96358: state_type > $o ).

tff(pred_def_53145,type,
    v96357: state_type > $o ).

tff(pred_def_53146,type,
    v96356: state_type > $o ).

tff(pred_def_53147,type,
    v96368: state_type > $o ).

tff(pred_def_53148,type,
    v96369: state_type > $o ).

tff(pred_def_53149,type,
    v96367: state_type > $o ).

tff(pred_def_53150,type,
    v96364: ( state_type * $int ) > $o ).

tff(pred_def_53151,type,
    v96366: ( state_type * $int ) > $o ).

tff(pred_def_53152,type,
    v96355: ( state_type * $int ) > $o ).

tff(pred_def_53153,type,
    v89704: ( state_type * $int ) > $o ).

tff(pred_def_53154,type,
    v89702: ( state_type * $int ) > $o ).

tff(pred_def_53155,type,
    v96376: state_type > $o ).

tff(pred_def_53156,type,
    v96380: state_type > $o ).

tff(pred_def_53157,type,
    v96373: state_type > $o ).

tff(pred_def_53158,type,
    v96379: state_type > $o ).

tff(pred_def_53159,type,
    v96386: state_type > $o ).

tff(pred_def_53160,type,
    v96384: state_type > $o ).

tff(pred_def_53161,type,
    v96383: state_type > $o ).

tff(pred_def_53162,type,
    v96382: ( state_type * $int ) > $o ).

tff(pred_def_53163,type,
    v96404: state_type > $o ).

tff(pred_def_53164,type,
    v96402: state_type > $o ).

tff(pred_def_53165,type,
    v96408: state_type > $o ).

tff(pred_def_53166,type,
    v96406: state_type > $o ).

tff(pred_def_53167,type,
    v96421: state_type > $o ).

tff(pred_def_53168,type,
    v96420: state_type > $o ).

tff(pred_def_53169,type,
    v96418: state_type > $o ).

tff(pred_def_53170,type,
    v96423: state_type > $o ).

tff(pred_def_53171,type,
    v96425: state_type > $o ).

tff(pred_def_53172,type,
    v96426: state_type > $o ).

tff(pred_def_53173,type,
    v96416: state_type > $o ).

tff(pred_def_53174,type,
    v96414: state_type > $o ).

tff(pred_def_53175,type,
    v96412: state_type > $o ).

tff(pred_def_53176,type,
    v96410: state_type > $o ).

tff(pred_def_53177,type,
    v96430: state_type > $o ).

tff(pred_def_53178,type,
    v96428: state_type > $o ).

tff(pred_def_53179,type,
    v96437: state_type > $o ).

tff(pred_def_53180,type,
    v96435: state_type > $o ).

tff(pred_def_53181,type,
    v96434: state_type > $o ).

tff(pred_def_53182,type,
    v96433: state_type > $o ).

tff(pred_def_53183,type,
    v96445: state_type > $o ).

tff(pred_def_53184,type,
    v96446: state_type > $o ).

tff(pred_def_53185,type,
    v96444: state_type > $o ).

tff(pred_def_53186,type,
    v96441: state_type > $o ).

tff(pred_def_53187,type,
    v96443: state_type > $o ).

tff(pred_def_53188,type,
    v96400: state_type > $o ).

tff(pred_def_53189,type,
    v96398: state_type > $o ).

tff(pred_def_53190,type,
    v96396: state_type > $o ).

tff(pred_def_53191,type,
    v96452: state_type > $o ).

tff(pred_def_53192,type,
    v96450: state_type > $o ).

tff(pred_def_53193,type,
    v96394: state_type > $o ).

tff(pred_def_53194,type,
    v96392: state_type > $o ).

tff(pred_def_53195,type,
    v96390: state_type > $o ).

tff(pred_def_53196,type,
    v96463: state_type > $o ).

tff(pred_def_53197,type,
    v96461: state_type > $o ).

tff(pred_def_53198,type,
    v96467: state_type > $o ).

tff(pred_def_53199,type,
    v96465: state_type > $o ).

tff(pred_def_53200,type,
    v96473: state_type > $o ).

tff(pred_def_53201,type,
    v96471: state_type > $o ).

tff(pred_def_53202,type,
    v96469: state_type > $o ).

tff(pred_def_53203,type,
    v96477: state_type > $o ).

tff(pred_def_53204,type,
    v96475: state_type > $o ).

tff(pred_def_53205,type,
    v96484: state_type > $o ).

tff(pred_def_53206,type,
    v96482: state_type > $o ).

tff(pred_def_53207,type,
    v96481: state_type > $o ).

tff(pred_def_53208,type,
    v96480: state_type > $o ).

tff(pred_def_53209,type,
    v96492: state_type > $o ).

tff(pred_def_53210,type,
    v96493: state_type > $o ).

tff(pred_def_53211,type,
    v96491: state_type > $o ).

tff(pred_def_53212,type,
    v96488: state_type > $o ).

tff(pred_def_53213,type,
    v96490: state_type > $o ).

tff(pred_def_53214,type,
    v96459: state_type > $o ).

tff(pred_def_53215,type,
    v96457: state_type > $o ).

tff(pred_def_53216,type,
    v96455: state_type > $o ).

tff(pred_def_53217,type,
    v96501: state_type > $o ).

tff(pred_def_53218,type,
    v89700: state_type > $o ).

tff(pred_def_53219,type,
    v90798: state_type > $o ).

tff(pred_def_53220,type,
    v96502: state_type > $o ).

tff(pred_def_53221,type,
    v96500: state_type > $o ).

tff(pred_def_53222,type,
    v96503: state_type > $o ).

tff(pred_def_53223,type,
    v96499: state_type > $o ).

tff(pred_def_53224,type,
    v96504: state_type > $o ).

tff(pred_def_53225,type,
    v96498: state_type > $o ).

tff(pred_def_53226,type,
    v96497: state_type > $o ).

tff(pred_def_53227,type,
    v96506: state_type > $o ).

tff(pred_def_53228,type,
    v96505: state_type > $o ).

tff(pred_def_53229,type,
    v90988: state_type > $o ).

tff(pred_def_53230,type,
    v90986: state_type > $o ).

tff(pred_def_53231,type,
    v90984: state_type > $o ).

tff(pred_def_53232,type,
    v90982: state_type > $o ).

tff(pred_def_53233,type,
    v96510: state_type > $o ).

tff(pred_def_53234,type,
    v96508: state_type > $o ).

tff(pred_def_53235,type,
    v96517: state_type > $o ).

tff(pred_def_53236,type,
    v96515: state_type > $o ).

tff(pred_def_53237,type,
    v96514: state_type > $o ).

tff(pred_def_53238,type,
    v96513: state_type > $o ).

tff(pred_def_53239,type,
    v96525: state_type > $o ).

tff(pred_def_53240,type,
    v96526: state_type > $o ).

tff(pred_def_53241,type,
    v96524: state_type > $o ).

tff(pred_def_53242,type,
    v96521: state_type > $o ).

tff(pred_def_53243,type,
    v96523: state_type > $o ).

tff(pred_def_53244,type,
    v90972: state_type > $o ).

tff(pred_def_53245,type,
    v90970: state_type > $o ).

tff(pred_def_53246,type,
    v96530: state_type > $o ).

tff(pred_def_53247,type,
    v96533: state_type > $o ).

tff(pred_def_53248,type,
    v96532: state_type > $o ).

tff(pred_def_53249,type,
    v96531: state_type > $o ).

tff(pred_def_53250,type,
    v96550: state_type > $o ).

tff(pred_def_53251,type,
    v96549: state_type > $o ).

tff(pred_def_53252,type,
    v96548: state_type > $o ).

tff(pred_def_53253,type,
    v96547: state_type > $o ).

tff(pred_def_53254,type,
    v96546: state_type > $o ).

tff(pred_def_53255,type,
    v96545: state_type > $o ).

tff(pred_def_53256,type,
    v96544: state_type > $o ).

tff(pred_def_53257,type,
    v96543: state_type > $o ).

tff(pred_def_53258,type,
    v96542: state_type > $o ).

tff(pred_def_53259,type,
    v96541: state_type > $o ).

tff(pred_def_53260,type,
    v96539: state_type > $o ).

tff(pred_def_53261,type,
    v96562: state_type > $o ).

tff(pred_def_53262,type,
    v96561: state_type > $o ).

tff(pred_def_53263,type,
    v96560: state_type > $o ).

tff(pred_def_53264,type,
    v96559: state_type > $o ).

tff(pred_def_53265,type,
    v96558: state_type > $o ).

tff(pred_def_53266,type,
    v96557: state_type > $o ).

tff(pred_def_53267,type,
    v96556: state_type > $o ).

tff(pred_def_53268,type,
    v96555: state_type > $o ).

tff(pred_def_53269,type,
    v96554: state_type > $o ).

tff(pred_def_53270,type,
    v96553: state_type > $o ).

tff(pred_def_53271,type,
    v96551: state_type > $o ).

tff(pred_def_53272,type,
    v96538: state_type > $o ).

tff(pred_def_53273,type,
    v96537: state_type > $o ).

tff(pred_def_53274,type,
    v96536: state_type > $o ).

tff(pred_def_53275,type,
    v96563: state_type > $o ).

tff(pred_def_53276,type,
    v96535: state_type > $o ).

tff(pred_def_53277,type,
    v96565: state_type > $o ).

tff(pred_def_53278,type,
    v96569: state_type > $o ).

tff(pred_def_53279,type,
    v96568: state_type > $o ).

tff(pred_def_53280,type,
    v96575: state_type > $o ).

tff(pred_def_53281,type,
    v96573: state_type > $o ).

tff(pred_def_53282,type,
    v96572: state_type > $o ).

tff(pred_def_53283,type,
    v96571: ( state_type * $int ) > $o ).

tff(pred_def_53284,type,
    v96587: state_type > $o ).

tff(pred_def_53285,type,
    v96585: state_type > $o ).

tff(pred_def_53286,type,
    v96591: state_type > $o ).

tff(pred_def_53287,type,
    v96589: state_type > $o ).

tff(pred_def_53288,type,
    v96609: state_type > $o ).

tff(pred_def_53289,type,
    v96607: state_type > $o ).

tff(pred_def_53290,type,
    v96613: state_type > $o ).

tff(pred_def_53291,type,
    v96611: state_type > $o ).

tff(pred_def_53292,type,
    v96619: state_type > $o ).

tff(pred_def_53293,type,
    v96617: state_type > $o ).

tff(pred_def_53294,type,
    v96615: state_type > $o ).

tff(pred_def_53295,type,
    v96623: state_type > $o ).

tff(pred_def_53296,type,
    v96621: state_type > $o ).

tff(pred_def_53297,type,
    v96630: state_type > $o ).

tff(pred_def_53298,type,
    v96628: state_type > $o ).

tff(pred_def_53299,type,
    v96627: state_type > $o ).

tff(pred_def_53300,type,
    v96626: state_type > $o ).

tff(pred_def_53301,type,
    v96638: state_type > $o ).

tff(pred_def_53302,type,
    v96639: state_type > $o ).

tff(pred_def_53303,type,
    v96637: state_type > $o ).

tff(pred_def_53304,type,
    v96634: state_type > $o ).

tff(pred_def_53305,type,
    v96636: state_type > $o ).

tff(pred_def_53306,type,
    v96605: state_type > $o ).

tff(pred_def_53307,type,
    v96603: state_type > $o ).

tff(pred_def_53308,type,
    v96601: state_type > $o ).

tff(pred_def_53309,type,
    v96655: state_type > $o ).

tff(pred_def_53310,type,
    v96653: state_type > $o ).

tff(pred_def_53311,type,
    v96659: state_type > $o ).

tff(pred_def_53312,type,
    v96657: state_type > $o ).

tff(pred_def_53313,type,
    v96673: state_type > $o ).

tff(pred_def_53314,type,
    v96671: state_type > $o ).

tff(pred_def_53315,type,
    v96669: state_type > $o ).

tff(pred_def_53316,type,
    v960: state_type > $o ).

tff(pred_def_53317,type,
    v96676: state_type > $o ).

tff(pred_def_53318,type,
    v96675: state_type > $o ).

tff(pred_def_53319,type,
    v96667: state_type > $o ).

tff(pred_def_53320,type,
    v96665: state_type > $o ).

tff(pred_def_53321,type,
    v96663: state_type > $o ).

tff(pred_def_53322,type,
    v96661: state_type > $o ).

tff(pred_def_53323,type,
    v96680: state_type > $o ).

tff(pred_def_53324,type,
    v96678: state_type > $o ).

tff(pred_def_53325,type,
    v96687: state_type > $o ).

tff(pred_def_53326,type,
    v96685: state_type > $o ).

tff(pred_def_53327,type,
    v96684: state_type > $o ).

tff(pred_def_53328,type,
    v96683: state_type > $o ).

tff(pred_def_53329,type,
    v96695: state_type > $o ).

tff(pred_def_53330,type,
    v96696: state_type > $o ).

tff(pred_def_53331,type,
    v96694: state_type > $o ).

tff(pred_def_53332,type,
    v96691: state_type > $o ).

tff(pred_def_53333,type,
    v96693: state_type > $o ).

tff(pred_def_53334,type,
    v96651: state_type > $o ).

tff(pred_def_53335,type,
    v96649: state_type > $o ).

tff(pred_def_53336,type,
    v96647: state_type > $o ).

tff(pred_def_53337,type,
    v96645: state_type > $o ).

tff(pred_def_53338,type,
    v96643: state_type > $o ).

tff(pred_def_53339,type,
    v96708: state_type > $o ).

tff(pred_def_53340,type,
    v96706: state_type > $o ).

tff(pred_def_53341,type,
    v96712: state_type > $o ).

tff(pred_def_53342,type,
    v96710: state_type > $o ).

tff(pred_def_53343,type,
    v96730: state_type > $o ).

tff(pred_def_53344,type,
    v96728: state_type > $o ).

tff(pred_def_53345,type,
    v96734: state_type > $o ).

tff(pred_def_53346,type,
    v96732: state_type > $o ).

tff(pred_def_53347,type,
    v96722: state_type > $o ).

tff(pred_def_53348,type,
    v96742: state_type > $o ).

tff(pred_def_53349,type,
    v96745: state_type > $o ).

tff(pred_def_53350,type,
    v96744: ( state_type * $int ) > $o ).

tff(pred_def_53351,type,
    v96746: state_type > $o ).

tff(pred_def_53352,type,
    v96747: state_type > $o ).

tff(pred_def_53353,type,
    v96748: state_type > $o ).

tff(pred_def_53354,type,
    v96740: ( state_type * $int ) > $o ).

tff(pred_def_53355,type,
    v96755: state_type > $o ).

tff(pred_def_53356,type,
    v96754: state_type > $o ).

tff(pred_def_53357,type,
    v96752: state_type > $o ).

tff(pred_def_53358,type,
    v96750: state_type > $o ).

tff(pred_def_53359,type,
    v96759: state_type > $o ).

tff(pred_def_53360,type,
    v96758: ( state_type * $int ) > $o ).

tff(pred_def_53361,type,
    v96757: ( state_type * $int ) > $o ).

tff(pred_def_53362,type,
    v96756: ( state_type * $int ) > $o ).

tff(pred_def_53363,type,
    v96738: ( state_type * $int ) > $o ).

tff(pred_def_53364,type,
    v96736: ( state_type * $int ) > $o ).

tff(pred_def_53365,type,
    v96763: state_type > $o ).

tff(pred_def_53366,type,
    v96761: state_type > $o ).

tff(pred_def_53367,type,
    v96770: state_type > $o ).

tff(pred_def_53368,type,
    v96768: state_type > $o ).

tff(pred_def_53369,type,
    v96767: state_type > $o ).

tff(pred_def_53370,type,
    v96766: state_type > $o ).

tff(pred_def_53371,type,
    v96778: state_type > $o ).

tff(pred_def_53372,type,
    v96779: state_type > $o ).

tff(pred_def_53373,type,
    v96777: state_type > $o ).

tff(pred_def_53374,type,
    v96774: ( state_type * $int ) > $o ).

tff(pred_def_53375,type,
    v96776: ( state_type * $int ) > $o ).

tff(pred_def_53376,type,
    v96765: ( state_type * $int ) > $o ).

tff(pred_def_53377,type,
    v96726: ( state_type * $int ) > $o ).

tff(pred_def_53378,type,
    v96724: ( state_type * $int ) > $o ).

tff(pred_def_53379,type,
    v96787: state_type > $o ).

tff(pred_def_53380,type,
    v96700: ( state_type * $int ) > $o ).

tff(pred_def_53381,type,
    v96788: state_type > $o ).

tff(pred_def_53382,type,
    v96786: state_type > $o ).

tff(pred_def_53383,type,
    v96790: state_type > $o ).

tff(pred_def_53384,type,
    v96579: state_type > $o ).

tff(pred_def_53385,type,
    v96791: state_type > $o ).

tff(pred_def_53386,type,
    v96789: state_type > $o ).

tff(pred_def_53387,type,
    v96785: state_type > $o ).

tff(pred_def_53388,type,
    v96799: state_type > $o ).

tff(pred_def_53389,type,
    v96792: ( state_type * $int ) > $o ).

tff(pred_def_53390,type,
    v96793: ( state_type * $int ) > $o ).

tff(pred_def_53391,type,
    v96794: ( state_type * $int ) > $o ).

tff(pred_def_53392,type,
    v96795: state_type > $o ).

tff(pred_def_53393,type,
    v96796: state_type > $o ).

tff(pred_def_53394,type,
    v96797: state_type > $o ).

tff(pred_def_53395,type,
    v96798: state_type > $o ).

tff(pred_def_53396,type,
    v96802: state_type > $o ).

tff(pred_def_53397,type,
    v96783: state_type > $o ).

tff(pred_def_53398,type,
    v96803: state_type > $o ).

tff(pred_def_53399,type,
    v96801: state_type > $o ).

tff(pred_def_53400,type,
    v96804: ( state_type * $int ) > $o ).

tff(pred_def_53401,type,
    v96805: ( state_type * $int ) > $o ).

tff(pred_def_53402,type,
    v96800: ( state_type * $int ) > $o ).

tff(pred_def_53403,type,
    v96784: ( state_type * $int ) > $o ).

tff(pred_def_53404,type,
    v96720: ( state_type * $int ) > $o ).

tff(pred_def_53405,type,
    v96718: ( state_type * $int ) > $o ).

tff(pred_def_53406,type,
    v96815: state_type > $o ).

tff(pred_def_53407,type,
    v96816: state_type > $o ).

tff(pred_def_53408,type,
    v96814: state_type > $o ).

tff(pred_def_53409,type,
    v96818: state_type > $o ).

tff(pred_def_53410,type,
    v96819: state_type > $o ).

tff(pred_def_53411,type,
    v96817: state_type > $o ).

tff(pred_def_53412,type,
    v96813: state_type > $o ).

tff(pred_def_53413,type,
    v96821: state_type > $o ).

tff(pred_def_53414,type,
    v96822: state_type > $o ).

tff(pred_def_53415,type,
    v96820: state_type > $o ).

tff(pred_def_53416,type,
    v96812: state_type > $o ).

tff(pred_def_53417,type,
    b0110000000000: $int > $o ).

tff(pred_def_53418,type,
    v96824: state_type > $o ).

tff(pred_def_53419,type,
    v96823: state_type > $o ).

tff(pred_def_53420,type,
    v96809: state_type > $o ).

tff(pred_def_53421,type,
    v96807: state_type > $o ).

tff(pred_def_53422,type,
    v96828: state_type > $o ).

tff(pred_def_53423,type,
    v96827: ( state_type * $int ) > $o ).

tff(pred_def_53424,type,
    v96826: ( state_type * $int ) > $o ).

tff(pred_def_53425,type,
    v96832: state_type > $o ).

tff(pred_def_53426,type,
    v96831: ( state_type * $int ) > $o ).

tff(pred_def_53427,type,
    v96830: ( state_type * $int ) > $o ).

tff(pred_def_53428,type,
    v96702: ( state_type * $int ) > $o ).

tff(pred_def_53429,type,
    v96829: ( state_type * $int ) > $o ).

tff(pred_def_53430,type,
    v96825: ( state_type * $int ) > $o ).

tff(pred_def_53431,type,
    v96716: ( state_type * $int ) > $o ).

tff(pred_def_53432,type,
    v96714: ( state_type * $int ) > $o ).

tff(pred_def_53433,type,
    v96837: state_type > $o ).

tff(pred_def_53434,type,
    v96835: state_type > $o ).

tff(pred_def_53435,type,
    v96844: state_type > $o ).

tff(pred_def_53436,type,
    v96842: state_type > $o ).

tff(pred_def_53437,type,
    v96841: state_type > $o ).

tff(pred_def_53438,type,
    v96840: state_type > $o ).

tff(pred_def_53439,type,
    v96852: state_type > $o ).

tff(pred_def_53440,type,
    v96853: state_type > $o ).

tff(pred_def_53441,type,
    v96851: state_type > $o ).

tff(pred_def_53442,type,
    v96848: ( state_type * $int ) > $o ).

tff(pred_def_53443,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_53444,type,
    v96850: ( state_type * $int ) > $o ).

tff(pred_def_53445,type,
    v96839: ( state_type * $int ) > $o ).

tff(pred_def_53446,type,
    v96704: ( state_type * $int ) > $o ).

tff(pred_def_53447,type,
    v96861: state_type > $o ).

tff(pred_def_53448,type,
    v96859: state_type > $o ).

tff(pred_def_53449,type,
    v96858: state_type > $o ).

tff(pred_def_53450,type,
    v96857: ( state_type * $int ) > $o ).

tff(pred_def_53451,type,
    v96869: state_type > $o ).

tff(pred_def_53452,type,
    v96867: state_type > $o ).

tff(pred_def_53453,type,
    v96866: state_type > $o ).

tff(pred_def_53454,type,
    v96865: ( state_type * $int ) > $o ).

tff(pred_def_53455,type,
    v96873: state_type > $o ).

tff(pred_def_53456,type,
    v96875: state_type > $o ).

tff(pred_def_53457,type,
    v96874: state_type > $o ).

tff(pred_def_53458,type,
    v96599: state_type > $o ).

tff(pred_def_53459,type,
    v96597: state_type > $o ).

tff(pred_def_53460,type,
    v96595: state_type > $o ).

tff(pred_def_53461,type,
    v96593: state_type > $o ).

tff(pred_def_53462,type,
    v96879: state_type > $o ).

tff(pred_def_53463,type,
    v96877: state_type > $o ).

tff(pred_def_53464,type,
    v96886: state_type > $o ).

tff(pred_def_53465,type,
    v96884: state_type > $o ).

tff(pred_def_53466,type,
    v96883: state_type > $o ).

tff(pred_def_53467,type,
    v96882: state_type > $o ).

tff(pred_def_53468,type,
    v96894: state_type > $o ).

tff(pred_def_53469,type,
    v96895: state_type > $o ).

tff(pred_def_53470,type,
    v96893: state_type > $o ).

tff(pred_def_53471,type,
    v96890: state_type > $o ).

tff(pred_def_53472,type,
    v96892: state_type > $o ).

tff(pred_def_53473,type,
    v96583: state_type > $o ).

tff(pred_def_53474,type,
    v96581: state_type > $o ).

tff(pred_def_53475,type,
    v96899: state_type > $o ).

tff(pred_def_53476,type,
    v96905: state_type > $o ).

tff(pred_def_53477,type,
    v96907: state_type > $o ).

tff(pred_def_53478,type,
    v96913: state_type > $o ).

tff(pred_def_53479,type,
    v96911: state_type > $o ).

tff(pred_def_53480,type,
    v96910: state_type > $o ).

tff(pred_def_53481,type,
    v96909: ( state_type * $int ) > $o ).

tff(pred_def_53482,type,
    v96921: state_type > $o ).

tff(pred_def_53483,type,
    v96919: state_type > $o ).

tff(pred_def_53484,type,
    v96918: state_type > $o ).

tff(pred_def_53485,type,
    v96917: ( state_type * $int ) > $o ).

tff(pred_def_53486,type,
    v96901: state_type > $o ).

tff(pred_def_53487,type,
    v96935: state_type > $o ).

tff(pred_def_53488,type,
    v96933: state_type > $o ).

tff(pred_def_53489,type,
    v96939: state_type > $o ).

tff(pred_def_53490,type,
    v96937: state_type > $o ).

tff(pred_def_53491,type,
    v96950: state_type > $o ).

tff(pred_def_53492,type,
    v96927: state_type > $o ).

tff(pred_def_53493,type,
    v96951: state_type > $o ).

tff(pred_def_53494,type,
    v96949: state_type > $o ).

tff(pred_def_53495,type,
    v89669: state_type > $o ).

tff(pred_def_53496,type,
    v96952: state_type > $o ).

tff(pred_def_53497,type,
    v96947: state_type > $o ).

tff(pred_def_53498,type,
    v96945: state_type > $o ).

tff(pred_def_53499,type,
    v96943: state_type > $o ).

tff(pred_def_53500,type,
    v96941: state_type > $o ).

tff(pred_def_53501,type,
    v96956: state_type > $o ).

tff(pred_def_53502,type,
    v96954: state_type > $o ).

tff(pred_def_53503,type,
    v96963: state_type > $o ).

tff(pred_def_53504,type,
    v96961: state_type > $o ).

tff(pred_def_53505,type,
    v96960: state_type > $o ).

tff(pred_def_53506,type,
    v96959: state_type > $o ).

tff(pred_def_53507,type,
    v96971: state_type > $o ).

tff(pred_def_53508,type,
    v96972: state_type > $o ).

tff(pred_def_53509,type,
    v96970: state_type > $o ).

tff(pred_def_53510,type,
    v96967: state_type > $o ).

tff(pred_def_53511,type,
    v96969: state_type > $o ).

tff(pred_def_53512,type,
    v96931: state_type > $o ).

tff(pred_def_53513,type,
    v96929: state_type > $o ).

tff(pred_def_53514,type,
    v96978: state_type > $o ).

tff(pred_def_53515,type,
    v96988: state_type > $o ).

tff(pred_def_53516,type,
    v96989: state_type > $o ).

tff(pred_def_53517,type,
    v96987: state_type > $o ).

tff(pred_def_53518,type,
    v96990: state_type > $o ).

tff(pred_def_53519,type,
    v96986: state_type > $o ).

tff(pred_def_53520,type,
    v96991: state_type > $o ).

tff(pred_def_53521,type,
    v96985: state_type > $o ).

tff(pred_def_53522,type,
    v96992: state_type > $o ).

tff(pred_def_53523,type,
    v96984: state_type > $o ).

tff(pred_def_53524,type,
    v96993: state_type > $o ).

tff(pred_def_53525,type,
    v96983: state_type > $o ).

tff(pred_def_53526,type,
    v96994: state_type > $o ).

tff(pred_def_53527,type,
    v96982: state_type > $o ).

tff(pred_def_53528,type,
    v97001: state_type > $o ).

tff(pred_def_53529,type,
    v97000: state_type > $o ).

tff(pred_def_53530,type,
    v96999: state_type > $o ).

tff(pred_def_53531,type,
    v96998: state_type > $o ).

tff(pred_def_53532,type,
    v97005: state_type > $o ).

tff(pred_def_53533,type,
    v97004: state_type > $o ).

tff(pred_def_53534,type,
    v97003: state_type > $o ).

tff(pred_def_53535,type,
    v97006: state_type > $o ).

tff(pred_def_53536,type,
    v97002: state_type > $o ).

tff(pred_def_53537,type,
    v96997: state_type > $o ).

tff(pred_def_53538,type,
    v97011: state_type > $o ).

tff(pred_def_53539,type,
    v97010: state_type > $o ).

tff(pred_def_53540,type,
    v97009: state_type > $o ).

tff(pred_def_53541,type,
    v97008: state_type > $o ).

tff(pred_def_53542,type,
    b0000100: $int > $o ).

tff(pred_def_53543,type,
    v97007: ( state_type * $int ) > $o ).

tff(pred_def_53544,type,
    b0000010: $int > $o ).

tff(pred_def_53545,type,
    v96996: ( state_type * $int ) > $o ).

tff(pred_def_53546,type,
    v97014: state_type > $o ).

tff(pred_def_53547,type,
    v97013: state_type > $o ).

tff(pred_def_53548,type,
    v97017: state_type > $o ).

tff(pred_def_53549,type,
    v97016: state_type > $o ).

tff(pred_def_53550,type,
    v97015: ( state_type * $int ) > $o ).

tff(pred_def_53551,type,
    v97012: ( state_type * $int ) > $o ).

tff(pred_def_53552,type,
    v97019: state_type > $o ).

tff(pred_def_53553,type,
    b0001000: $int > $o ).

tff(pred_def_53554,type,
    v97018: ( state_type * $int ) > $o ).

tff(pred_def_53555,type,
    v97022: state_type > $o ).

tff(pred_def_53556,type,
    v97021: state_type > $o ).

tff(pred_def_53557,type,
    v97024: state_type > $o ).

tff(pred_def_53558,type,
    b0100000: $int > $o ).

tff(pred_def_53559,type,
    v97023: ( state_type * $int ) > $o ).

tff(pred_def_53560,type,
    b0010000: $int > $o ).

tff(pred_def_53561,type,
    v97020: ( state_type * $int ) > $o ).

tff(pred_def_53562,type,
    v97027: state_type > $o ).

tff(pred_def_53563,type,
    v97026: state_type > $o ).

tff(pred_def_53564,type,
    v97030: state_type > $o ).

tff(pred_def_53565,type,
    v97029: state_type > $o ).

tff(pred_def_53566,type,
    v97028: ( state_type * $int ) > $o ).

tff(pred_def_53567,type,
    v97025: ( state_type * $int ) > $o ).

tff(pred_def_53568,type,
    v97031: ( state_type * $int ) > $o ).

tff(pred_def_53569,type,
    v97034: state_type > $o ).

tff(pred_def_53570,type,
    v97033: state_type > $o ).

tff(pred_def_53571,type,
    v97032: ( state_type * $int ) > $o ).

tff(pred_def_53572,type,
    v96995: ( state_type * $int ) > $o ).

tff(pred_def_53573,type,
    v96981: ( state_type * $int ) > $o ).

tff(pred_def_53574,type,
    v89694: ( state_type * $int ) > $o ).

tff(pred_def_53575,type,
    v97035: ( state_type * $int ) > $o ).

tff(pred_def_53576,type,
    v89698: state_type > $o ).

tff(pred_def_53577,type,
    v89692: ( state_type * $int ) > $o ).

tff(pred_def_53578,type,
    v89690: ( state_type * $int ) > $o ).

tff(pred_def_53579,type,
    v89688: ( state_type * $int ) > $o ).

tff(pred_def_53580,type,
    v97039: state_type > $o ).

tff(pred_def_53581,type,
    v97037: state_type > $o ).

tff(pred_def_53582,type,
    v97046: state_type > $o ).

tff(pred_def_53583,type,
    v97044: state_type > $o ).

tff(pred_def_53584,type,
    v97043: state_type > $o ).

tff(pred_def_53585,type,
    v97042: state_type > $o ).

tff(pred_def_53586,type,
    v97054: state_type > $o ).

tff(pred_def_53587,type,
    v97055: state_type > $o ).

tff(pred_def_53588,type,
    v97053: state_type > $o ).

tff(pred_def_53589,type,
    v97050: ( state_type * $int ) > $o ).

tff(pred_def_53590,type,
    v97052: ( state_type * $int ) > $o ).

tff(pred_def_53591,type,
    v97041: ( state_type * $int ) > $o ).

tff(pred_def_53592,type,
    v89678: ( state_type * $int ) > $o ).

tff(pred_def_53593,type,
    v89676: ( state_type * $int ) > $o ).

tff(pred_def_53594,type,
    v97063: state_type > $o ).

tff(pred_def_53595,type,
    v97061: state_type > $o ).

tff(pred_def_53596,type,
    v97060: state_type > $o ).

tff(pred_def_53597,type,
    v97059: ( state_type * $int ) > $o ).

tff(pred_def_53598,type,
    v97071: state_type > $o ).

tff(pred_def_53599,type,
    v97069: state_type > $o ).

tff(pred_def_53600,type,
    v97068: state_type > $o ).

tff(pred_def_53601,type,
    v97067: ( state_type * $int ) > $o ).

tff(pred_def_53602,type,
    v97079: state_type > $o ).

tff(pred_def_53603,type,
    v97077: state_type > $o ).

tff(pred_def_53604,type,
    v97076: state_type > $o ).

tff(pred_def_53605,type,
    v97075: ( state_type * $int ) > $o ).

tff(pred_def_53606,type,
    v97087: state_type > $o ).

tff(pred_def_53607,type,
    v97085: state_type > $o ).

tff(pred_def_53608,type,
    v97084: state_type > $o ).

tff(pred_def_53609,type,
    v97083: ( state_type * $int ) > $o ).

tff(pred_def_53610,type,
    v97096: state_type > $o ).

tff(pred_def_53611,type,
    v97094: state_type > $o ).

tff(pred_def_53612,type,
    v97093: state_type > $o ).

tff(pred_def_53613,type,
    v97092: ( state_type * $int ) > $o ).

tff(pred_def_53614,type,
    v89696: state_type > $o ).

tff(pred_def_53615,type,
    v97105: state_type > $o ).

tff(pred_def_53616,type,
    v97103: state_type > $o ).

tff(pred_def_53617,type,
    v97102: state_type > $o ).

tff(pred_def_53618,type,
    v97101: ( state_type * $int ) > $o ).

tff(pred_def_53619,type,
    v97109: state_type > $o ).

tff(pred_def_53620,type,
    v97113: state_type > $o ).

tff(pred_def_53621,type,
    v97111: state_type > $o ).

tff(pred_def_53622,type,
    v89667: state_type > $o ).

tff(pred_def_53623,type,
    v89665: state_type > $o ).

tff(pred_def_53624,type,
    v97117: state_type > $o ).

tff(pred_def_53625,type,
    v97116: ( state_type * $int ) > $o ).

tff(pred_def_53626,type,
    v97115: ( state_type * $int ) > $o ).

tff(pred_def_53627,type,
    v97121: state_type > $o ).

tff(pred_def_53628,type,
    v97120: ( state_type * $int ) > $o ).

tff(pred_def_53629,type,
    v97119: ( state_type * $int ) > $o ).

tff(pred_def_53630,type,
    v89626: ( state_type * $int ) > $o ).

tff(pred_def_53631,type,
    v97118: ( state_type * $int ) > $o ).

tff(pred_def_53632,type,
    v89640: ( state_type * $int ) > $o ).

tff(pred_def_53633,type,
    v89638: ( state_type * $int ) > $o ).

tff(pred_def_53634,type,
    v97125: state_type > $o ).

tff(pred_def_53635,type,
    v97123: state_type > $o ).

tff(pred_def_53636,type,
    v97132: state_type > $o ).

tff(pred_def_53637,type,
    v97130: state_type > $o ).

tff(pred_def_53638,type,
    v97129: state_type > $o ).

tff(pred_def_53639,type,
    v97128: state_type > $o ).

tff(pred_def_53640,type,
    v97140: state_type > $o ).

tff(pred_def_53641,type,
    v97141: state_type > $o ).

tff(pred_def_53642,type,
    v97139: state_type > $o ).

tff(pred_def_53643,type,
    v97136: ( state_type * $int ) > $o ).

tff(pred_def_53644,type,
    v97138: ( state_type * $int ) > $o ).

tff(pred_def_53645,type,
    v89628: ( state_type * $int ) > $o ).

tff(pred_def_53646,type,
    v89622: state_type > $o ).

tff(pred_def_53647,type,
    v89620: state_type > $o ).

tff(pred_def_53648,type,
    v89618: state_type > $o ).

tff(pred_def_53649,type,
    v89616: state_type > $o ).

tff(pred_def_53650,type,
    v89614: state_type > $o ).

tff(pred_def_53651,type,
    v97148: state_type > $o ).

tff(pred_def_53652,type,
    v97146: state_type > $o ).

tff(pred_def_53653,type,
    v4093: state_type > $o ).

tff(pred_def_53654,type,
    v97151: state_type > $o ).

tff(pred_def_53655,type,
    v97150: state_type > $o ).

tff(pred_def_53656,type,
    v97152: state_type > $o ).

tff(pred_def_53657,type,
    v89612: state_type > $o ).

tff(pred_def_53658,type,
    v89610: state_type > $o ).

tff(pred_def_53659,type,
    v97156: state_type > $o ).

tff(pred_def_53660,type,
    v97155: ( state_type * $int ) > $o ).

tff(pred_def_53661,type,
    v97154: ( state_type * $int ) > $o ).

tff(pred_def_53662,type,
    v97153: ( state_type * $int ) > $o ).

tff(pred_def_53663,type,
    v89604: ( state_type * $int ) > $o ).

tff(pred_def_53664,type,
    v89602: ( state_type * $int ) > $o ).

tff(pred_def_53665,type,
    v97162: state_type > $o ).

tff(pred_def_53666,type,
    v97160: state_type > $o ).

tff(pred_def_53667,type,
    v97158: state_type > $o ).

tff(pred_def_53668,type,
    v97169: state_type > $o ).

tff(pred_def_53669,type,
    v97167: state_type > $o ).

tff(pred_def_53670,type,
    v97166: state_type > $o ).

tff(pred_def_53671,type,
    v97165: state_type > $o ).

tff(pred_def_53672,type,
    v97177: state_type > $o ).

tff(pred_def_53673,type,
    v97178: state_type > $o ).

tff(pred_def_53674,type,
    v97176: state_type > $o ).

tff(pred_def_53675,type,
    v97173: ( state_type * $int ) > $o ).

tff(pred_def_53676,type,
    v97175: ( state_type * $int ) > $o ).

tff(pred_def_53677,type,
    v97164: ( state_type * $int ) > $o ).

tff(pred_def_53678,type,
    v89584: ( state_type * $int ) > $o ).

tff(pred_def_53679,type,
    v89582: ( state_type * $int ) > $o ).

tff(pred_def_53680,type,
    v89580: ( state_type * $int ) > $o ).

tff(pred_def_53681,type,
    v97194: state_type > $o ).

tff(pred_def_53682,type,
    v97192: state_type > $o ).

tff(pred_def_53683,type,
    v97198: state_type > $o ).

tff(pred_def_53684,type,
    v97196: state_type > $o ).

tff(pred_def_53685,type,
    v97216: state_type > $o ).

tff(pred_def_53686,type,
    v97214: state_type > $o ).

tff(pred_def_53687,type,
    v97220: state_type > $o ).

tff(pred_def_53688,type,
    v97218: state_type > $o ).

tff(pred_def_53689,type,
    v97240: state_type > $o ).

tff(pred_def_53690,type,
    v97238: state_type > $o ).

tff(pred_def_53691,type,
    v97244: state_type > $o ).

tff(pred_def_53692,type,
    v97242: state_type > $o ).

tff(pred_def_53693,type,
    v97262: state_type > $o ).

tff(pred_def_53694,type,
    v97260: state_type > $o ).

tff(pred_def_53695,type,
    v97266: state_type > $o ).

tff(pred_def_53696,type,
    v97264: state_type > $o ).

tff(pred_def_53697,type,
    v97282: state_type > $o ).

tff(pred_def_53698,type,
    v97280: state_type > $o ).

tff(pred_def_53699,type,
    v97292: state_type > $o ).

tff(pred_def_53700,type,
    v97290: state_type > $o ).

tff(pred_def_53701,type,
    v97296: state_type > $o ).

tff(pred_def_53702,type,
    v97294: state_type > $o ).

tff(pred_def_53703,type,
    v97284: ( state_type * $int ) > $o ).

tff(pred_def_53704,type,
    v97311: state_type > $o ).

tff(pred_def_53705,type,
    v97310: state_type > $o ).

tff(pred_def_53706,type,
    v97312: state_type > $o ).

tff(pred_def_53707,type,
    v97309: state_type > $o ).

tff(pred_def_53708,type,
    v97313: state_type > $o ).

tff(pred_def_53709,type,
    v97308: state_type > $o ).

tff(pred_def_53710,type,
    v97316: state_type > $o ).

tff(pred_def_53711,type,
    v97317: state_type > $o ).

tff(pred_def_53712,type,
    v97315: state_type > $o ).

tff(pred_def_53713,type,
    v97318: state_type > $o ).

tff(pred_def_53714,type,
    v97314: state_type > $o ).

tff(pred_def_53715,type,
    v97306: ( state_type * $int ) > $o ).

tff(pred_def_53716,type,
    v97320: ( state_type * $int ) > $o ).

tff(pred_def_53717,type,
    v97319: ( state_type * $int ) > $o ).

tff(pred_def_53718,type,
    v97304: ( state_type * $int ) > $o ).

tff(pred_def_53719,type,
    v97302: ( state_type * $int ) > $o ).

tff(pred_def_53720,type,
    v97339: state_type > $o ).

tff(pred_def_53721,type,
    v97337: state_type > $o ).

tff(pred_def_53722,type,
    v97343: state_type > $o ).

tff(pred_def_53723,type,
    v97341: state_type > $o ).

tff(pred_def_53724,type,
    v97355: state_type > $o ).

tff(pred_def_53725,type,
    v97353: state_type > $o ).

tff(pred_def_53726,type,
    v97351: state_type > $o ).

tff(pred_def_53727,type,
    v97357: ( state_type * $int ) > $o ).

tff(pred_def_53728,type,
    v97349: ( state_type * $int ) > $o ).

tff(pred_def_53729,type,
    v97347: ( state_type * $int ) > $o ).

tff(pred_def_53730,type,
    v97345: ( state_type * $int ) > $o ).

tff(pred_def_53731,type,
    v97361: state_type > $o ).

tff(pred_def_53732,type,
    v97359: state_type > $o ).

tff(pred_def_53733,type,
    v97368: state_type > $o ).

tff(pred_def_53734,type,
    v97366: state_type > $o ).

tff(pred_def_53735,type,
    v97365: state_type > $o ).

tff(pred_def_53736,type,
    v97364: state_type > $o ).

tff(pred_def_53737,type,
    v97376: state_type > $o ).

tff(pred_def_53738,type,
    v97377: state_type > $o ).

tff(pred_def_53739,type,
    v97375: state_type > $o ).

tff(pred_def_53740,type,
    v97372: ( state_type * $int ) > $o ).

tff(pred_def_53741,type,
    v97374: ( state_type * $int ) > $o ).

tff(pred_def_53742,type,
    v97363: ( state_type * $int ) > $o ).

tff(pred_def_53743,type,
    v97335: ( state_type * $int ) > $o ).

tff(pred_def_53744,type,
    v97333: ( state_type * $int ) > $o ).

tff(pred_def_53745,type,
    v97331: state_type > $o ).

tff(pred_def_53746,type,
    v97329: state_type > $o ).

tff(pred_def_53747,type,
    v97327: state_type > $o ).

tff(pred_def_53748,type,
    v97393: state_type > $o ).

tff(pred_def_53749,type,
    v97391: state_type > $o ).

tff(pred_def_53750,type,
    v97397: state_type > $o ).

tff(pred_def_53751,type,
    v97395: state_type > $o ).

tff(pred_def_53752,type,
    v97421: state_type > $o ).

tff(pred_def_53753,type,
    v97419: state_type > $o ).

tff(pred_def_53754,type,
    v97425: state_type > $o ).

tff(pred_def_53755,type,
    v97423: state_type > $o ).

tff(pred_def_53756,type,
    v97409: ( state_type * $int ) > $o ).

tff(pred_def_53757,type,
    v97431: ( state_type * $int ) > $o ).

tff(pred_def_53758,type,
    v97254: ( state_type * $int ) > $o ).

tff(pred_def_53759,type,
    v97444: state_type > $o ).

tff(pred_def_53760,type,
    v97443: state_type > $o ).

tff(pred_def_53761,type,
    v97442: state_type > $o ).

tff(pred_def_53762,type,
    v97441: state_type > $o ).

tff(pred_def_53763,type,
    v97445: state_type > $o ).

tff(pred_def_53764,type,
    v97440: state_type > $o ).

tff(pred_def_53765,type,
    v97446: state_type > $o ).

tff(pred_def_53766,type,
    v97439: state_type > $o ).

tff(pred_def_53767,type,
    v97449: state_type > $o ).

tff(pred_def_53768,type,
    v97450: state_type > $o ).

tff(pred_def_53769,type,
    v97448: state_type > $o ).

tff(pred_def_53770,type,
    v97451: state_type > $o ).

tff(pred_def_53771,type,
    v97447: state_type > $o ).

tff(pred_def_53772,type,
    v97454: state_type > $o ).

tff(pred_def_53773,type,
    v97455: state_type > $o ).

tff(pred_def_53774,type,
    v97453: state_type > $o ).

tff(pred_def_53775,type,
    v97456: state_type > $o ).

tff(pred_def_53776,type,
    v97452: state_type > $o ).

tff(pred_def_53777,type,
    v97459: state_type > $o ).

tff(pred_def_53778,type,
    v97460: state_type > $o ).

tff(pred_def_53779,type,
    v97458: state_type > $o ).

tff(pred_def_53780,type,
    v97461: state_type > $o ).

tff(pred_def_53781,type,
    v97457: state_type > $o ).

tff(pred_def_53782,type,
    v97437: ( state_type * $int ) > $o ).

tff(pred_def_53783,type,
    v97276: state_type > $o ).

tff(pred_def_53784,type,
    v97436: ( state_type * $int ) > $o ).

tff(pred_def_53785,type,
    v97274: ( state_type * $int ) > $o ).

tff(pred_def_53786,type,
    v97272: ( state_type * $int ) > $o ).

tff(pred_def_53787,type,
    v97270: ( state_type * $int ) > $o ).

tff(pred_def_53788,type,
    v97268: ( state_type * $int ) > $o ).

tff(pred_def_53789,type,
    v97465: state_type > $o ).

tff(pred_def_53790,type,
    v97463: state_type > $o ).

tff(pred_def_53791,type,
    v97472: state_type > $o ).

tff(pred_def_53792,type,
    v97470: state_type > $o ).

tff(pred_def_53793,type,
    v97469: state_type > $o ).

tff(pred_def_53794,type,
    v97468: state_type > $o ).

tff(pred_def_53795,type,
    v97480: state_type > $o ).

tff(pred_def_53796,type,
    v97481: state_type > $o ).

tff(pred_def_53797,type,
    v97479: state_type > $o ).

tff(pred_def_53798,type,
    v97476: ( state_type * $int ) > $o ).

tff(pred_def_53799,type,
    v97478: ( state_type * $int ) > $o ).

tff(pred_def_53800,type,
    v97467: ( state_type * $int ) > $o ).

tff(pred_def_53801,type,
    v97258: ( state_type * $int ) > $o ).

tff(pred_def_53802,type,
    v97256: ( state_type * $int ) > $o ).

tff(pred_def_53803,type,
    v97485: state_type > $o ).

tff(pred_def_53804,type,
    v97435: state_type > $o ).

tff(pred_def_53805,type,
    v97433: state_type > $o ).

tff(pred_def_53806,type,
    v97489: state_type > $o ).

tff(pred_def_53807,type,
    v97488: ( state_type * $int ) > $o ).

tff(pred_def_53808,type,
    v97487: ( state_type * $int ) > $o ).

tff(pred_def_53809,type,
    v97493: state_type > $o ).

tff(pred_def_53810,type,
    v97492: ( state_type * $int ) > $o ).

tff(pred_def_53811,type,
    v97491: ( state_type * $int ) > $o ).

tff(pred_def_53812,type,
    v97415: ( state_type * $int ) > $o ).

tff(pred_def_53813,type,
    v97490: ( state_type * $int ) > $o ).

tff(pred_def_53814,type,
    v97486: ( state_type * $int ) > $o ).

tff(pred_def_53815,type,
    v97429: ( state_type * $int ) > $o ).

tff(pred_def_53816,type,
    v97427: ( state_type * $int ) > $o ).

tff(pred_def_53817,type,
    v97497: state_type > $o ).

tff(pred_def_53818,type,
    v97495: state_type > $o ).

tff(pred_def_53819,type,
    v97504: state_type > $o ).

tff(pred_def_53820,type,
    v97502: state_type > $o ).

tff(pred_def_53821,type,
    v97501: state_type > $o ).

tff(pred_def_53822,type,
    v97500: state_type > $o ).

tff(pred_def_53823,type,
    v97512: state_type > $o ).

tff(pred_def_53824,type,
    v97513: state_type > $o ).

tff(pred_def_53825,type,
    v97511: state_type > $o ).

tff(pred_def_53826,type,
    v97508: ( state_type * $int ) > $o ).

tff(pred_def_53827,type,
    v97510: ( state_type * $int ) > $o ).

tff(pred_def_53828,type,
    v97499: ( state_type * $int ) > $o ).

tff(pred_def_53829,type,
    v97417: ( state_type * $int ) > $o ).

tff(pred_def_53830,type,
    v97413: ( state_type * $int ) > $o ).

tff(pred_def_53831,type,
    v97525: state_type > $o ).

tff(pred_def_53832,type,
    v97523: state_type > $o ).

tff(pred_def_53833,type,
    v97529: state_type > $o ).

tff(pred_def_53834,type,
    v97527: state_type > $o ).

tff(pred_def_53835,type,
    v97535: ( state_type * $int ) > $o ).

tff(pred_def_53836,type,
    v97541: state_type > $o ).

tff(pred_def_53837,type,
    v97539: state_type > $o ).

tff(pred_def_53838,type,
    v97537: state_type > $o ).

tff(pred_def_53839,type,
    v97545: state_type > $o ).

tff(pred_def_53840,type,
    v97544: ( state_type * $int ) > $o ).

tff(pred_def_53841,type,
    v97543: ( state_type * $int ) > $o ).

tff(pred_def_53842,type,
    v97549: state_type > $o ).

tff(pred_def_53843,type,
    v97548: ( state_type * $int ) > $o ).

tff(pred_def_53844,type,
    v97547: ( state_type * $int ) > $o ).

tff(pred_def_53845,type,
    v97519: ( state_type * $int ) > $o ).

tff(pred_def_53846,type,
    v97546: ( state_type * $int ) > $o ).

tff(pred_def_53847,type,
    v97542: ( state_type * $int ) > $o ).

tff(pred_def_53848,type,
    v97533: ( state_type * $int ) > $o ).

tff(pred_def_53849,type,
    v97531: ( state_type * $int ) > $o ).

tff(pred_def_53850,type,
    v97553: state_type > $o ).

tff(pred_def_53851,type,
    v97551: state_type > $o ).

tff(pred_def_53852,type,
    v97560: state_type > $o ).

tff(pred_def_53853,type,
    v97558: state_type > $o ).

tff(pred_def_53854,type,
    v97557: state_type > $o ).

tff(pred_def_53855,type,
    v97556: state_type > $o ).

tff(pred_def_53856,type,
    v97568: state_type > $o ).

tff(pred_def_53857,type,
    v97569: state_type > $o ).

tff(pred_def_53858,type,
    v97567: state_type > $o ).

tff(pred_def_53859,type,
    v97564: ( state_type * $int ) > $o ).

tff(pred_def_53860,type,
    v97566: ( state_type * $int ) > $o ).

tff(pred_def_53861,type,
    v97555: ( state_type * $int ) > $o ).

tff(pred_def_53862,type,
    v97521: ( state_type * $int ) > $o ).

tff(pred_def_53863,type,
    v97517: ( state_type * $int ) > $o ).

tff(pred_def_53864,type,
    v97581: state_type > $o ).

tff(pred_def_53865,type,
    v97579: state_type > $o ).

tff(pred_def_53866,type,
    v97585: state_type > $o ).

tff(pred_def_53867,type,
    v97583: state_type > $o ).

tff(pred_def_53868,type,
    v97591: ( state_type * $int ) > $o ).

tff(pred_def_53869,type,
    v97597: state_type > $o ).

tff(pred_def_53870,type,
    v97595: state_type > $o ).

tff(pred_def_53871,type,
    v97593: state_type > $o ).

tff(pred_def_53872,type,
    v97601: state_type > $o ).

tff(pred_def_53873,type,
    v97600: ( state_type * $int ) > $o ).

tff(pred_def_53874,type,
    v97599: ( state_type * $int ) > $o ).

tff(pred_def_53875,type,
    v97605: state_type > $o ).

tff(pred_def_53876,type,
    v97604: ( state_type * $int ) > $o ).

tff(pred_def_53877,type,
    v97603: ( state_type * $int ) > $o ).

tff(pred_def_53878,type,
    v97575: ( state_type * $int ) > $o ).

tff(pred_def_53879,type,
    v97602: ( state_type * $int ) > $o ).

tff(pred_def_53880,type,
    v97598: ( state_type * $int ) > $o ).

tff(pred_def_53881,type,
    v97589: ( state_type * $int ) > $o ).

tff(pred_def_53882,type,
    v97587: ( state_type * $int ) > $o ).

tff(pred_def_53883,type,
    v97609: state_type > $o ).

tff(pred_def_53884,type,
    v97607: state_type > $o ).

tff(pred_def_53885,type,
    v97616: state_type > $o ).

tff(pred_def_53886,type,
    v97614: state_type > $o ).

tff(pred_def_53887,type,
    v97613: state_type > $o ).

tff(pred_def_53888,type,
    v97612: state_type > $o ).

tff(pred_def_53889,type,
    v97624: state_type > $o ).

tff(pred_def_53890,type,
    v97625: state_type > $o ).

tff(pred_def_53891,type,
    v97623: state_type > $o ).

tff(pred_def_53892,type,
    v97620: ( state_type * $int ) > $o ).

tff(pred_def_53893,type,
    v97622: ( state_type * $int ) > $o ).

tff(pred_def_53894,type,
    v97611: ( state_type * $int ) > $o ).

tff(pred_def_53895,type,
    v97577: ( state_type * $int ) > $o ).

tff(pred_def_53896,type,
    v97573: ( state_type * $int ) > $o ).

tff(pred_def_53897,type,
    v97637: state_type > $o ).

tff(pred_def_53898,type,
    v97635: state_type > $o ).

tff(pred_def_53899,type,
    v97641: state_type > $o ).

tff(pred_def_53900,type,
    v97639: state_type > $o ).

tff(pred_def_53901,type,
    v97647: ( state_type * $int ) > $o ).

tff(pred_def_53902,type,
    v97653: state_type > $o ).

tff(pred_def_53903,type,
    v97651: state_type > $o ).

tff(pred_def_53904,type,
    v97649: state_type > $o ).

tff(pred_def_53905,type,
    v97657: state_type > $o ).

tff(pred_def_53906,type,
    v97656: ( state_type * $int ) > $o ).

tff(pred_def_53907,type,
    v97655: ( state_type * $int ) > $o ).

tff(pred_def_53908,type,
    v97661: state_type > $o ).

tff(pred_def_53909,type,
    v97660: ( state_type * $int ) > $o ).

tff(pred_def_53910,type,
    v97659: ( state_type * $int ) > $o ).

tff(pred_def_53911,type,
    v97631: ( state_type * $int ) > $o ).

tff(pred_def_53912,type,
    v97658: ( state_type * $int ) > $o ).

tff(pred_def_53913,type,
    v97654: ( state_type * $int ) > $o ).

tff(pred_def_53914,type,
    v97645: ( state_type * $int ) > $o ).

tff(pred_def_53915,type,
    v97643: ( state_type * $int ) > $o ).

tff(pred_def_53916,type,
    v97665: state_type > $o ).

tff(pred_def_53917,type,
    v97663: state_type > $o ).

tff(pred_def_53918,type,
    v97672: state_type > $o ).

tff(pred_def_53919,type,
    v97670: state_type > $o ).

tff(pred_def_53920,type,
    v97669: state_type > $o ).

tff(pred_def_53921,type,
    v97668: state_type > $o ).

tff(pred_def_53922,type,
    v97680: state_type > $o ).

tff(pred_def_53923,type,
    v97681: state_type > $o ).

tff(pred_def_53924,type,
    v97679: state_type > $o ).

tff(pred_def_53925,type,
    v97676: ( state_type * $int ) > $o ).

tff(pred_def_53926,type,
    v97678: ( state_type * $int ) > $o ).

tff(pred_def_53927,type,
    v97667: ( state_type * $int ) > $o ).

tff(pred_def_53928,type,
    v97633: ( state_type * $int ) > $o ).

tff(pred_def_53929,type,
    v97629: ( state_type * $int ) > $o ).

tff(pred_def_53930,type,
    v97693: state_type > $o ).

tff(pred_def_53931,type,
    v97691: state_type > $o ).

tff(pred_def_53932,type,
    v97697: state_type > $o ).

tff(pred_def_53933,type,
    v97695: state_type > $o ).

tff(pred_def_53934,type,
    v97703: ( state_type * $int ) > $o ).

tff(pred_def_53935,type,
    v97709: state_type > $o ).

tff(pred_def_53936,type,
    v97707: state_type > $o ).

tff(pred_def_53937,type,
    v97705: state_type > $o ).

tff(pred_def_53938,type,
    v97713: state_type > $o ).

tff(pred_def_53939,type,
    v97712: ( state_type * $int ) > $o ).

tff(pred_def_53940,type,
    v97711: ( state_type * $int ) > $o ).

tff(pred_def_53941,type,
    v97717: state_type > $o ).

tff(pred_def_53942,type,
    v97716: ( state_type * $int ) > $o ).

tff(pred_def_53943,type,
    v97715: ( state_type * $int ) > $o ).

tff(pred_def_53944,type,
    v97687: ( state_type * $int ) > $o ).

tff(pred_def_53945,type,
    v97714: ( state_type * $int ) > $o ).

tff(pred_def_53946,type,
    v97710: ( state_type * $int ) > $o ).

tff(pred_def_53947,type,
    v97701: ( state_type * $int ) > $o ).

tff(pred_def_53948,type,
    v97699: ( state_type * $int ) > $o ).

tff(pred_def_53949,type,
    v97721: state_type > $o ).

tff(pred_def_53950,type,
    v97719: state_type > $o ).

tff(pred_def_53951,type,
    v97728: state_type > $o ).

tff(pred_def_53952,type,
    v97726: state_type > $o ).

tff(pred_def_53953,type,
    v97725: state_type > $o ).

tff(pred_def_53954,type,
    v97724: state_type > $o ).

tff(pred_def_53955,type,
    v97736: state_type > $o ).

tff(pred_def_53956,type,
    v97737: state_type > $o ).

tff(pred_def_53957,type,
    v97735: state_type > $o ).

tff(pred_def_53958,type,
    v97732: ( state_type * $int ) > $o ).

tff(pred_def_53959,type,
    v97734: ( state_type * $int ) > $o ).

tff(pred_def_53960,type,
    v97723: ( state_type * $int ) > $o ).

tff(pred_def_53961,type,
    v97689: ( state_type * $int ) > $o ).

tff(pred_def_53962,type,
    v97685: ( state_type * $int ) > $o ).

tff(pred_def_53963,type,
    v97749: state_type > $o ).

tff(pred_def_53964,type,
    v97747: state_type > $o ).

tff(pred_def_53965,type,
    v97753: state_type > $o ).

tff(pred_def_53966,type,
    v97751: state_type > $o ).

tff(pred_def_53967,type,
    v97759: ( state_type * $int ) > $o ).

tff(pred_def_53968,type,
    v97765: state_type > $o ).

tff(pred_def_53969,type,
    v97763: state_type > $o ).

tff(pred_def_53970,type,
    v97761: state_type > $o ).

tff(pred_def_53971,type,
    v97769: state_type > $o ).

tff(pred_def_53972,type,
    v97768: ( state_type * $int ) > $o ).

tff(pred_def_53973,type,
    v97767: ( state_type * $int ) > $o ).

tff(pred_def_53974,type,
    v97773: state_type > $o ).

tff(pred_def_53975,type,
    v97772: ( state_type * $int ) > $o ).

tff(pred_def_53976,type,
    v97771: ( state_type * $int ) > $o ).

tff(pred_def_53977,type,
    v97743: ( state_type * $int ) > $o ).

tff(pred_def_53978,type,
    v97770: ( state_type * $int ) > $o ).

tff(pred_def_53979,type,
    v97766: ( state_type * $int ) > $o ).

tff(pred_def_53980,type,
    v97757: ( state_type * $int ) > $o ).

tff(pred_def_53981,type,
    v97755: ( state_type * $int ) > $o ).

tff(pred_def_53982,type,
    v97777: state_type > $o ).

tff(pred_def_53983,type,
    v97775: state_type > $o ).

tff(pred_def_53984,type,
    v97784: state_type > $o ).

tff(pred_def_53985,type,
    v97782: state_type > $o ).

tff(pred_def_53986,type,
    v97781: state_type > $o ).

tff(pred_def_53987,type,
    v97780: state_type > $o ).

tff(pred_def_53988,type,
    v97792: state_type > $o ).

tff(pred_def_53989,type,
    v97793: state_type > $o ).

tff(pred_def_53990,type,
    v97791: state_type > $o ).

tff(pred_def_53991,type,
    v97788: ( state_type * $int ) > $o ).

tff(pred_def_53992,type,
    v97790: ( state_type * $int ) > $o ).

tff(pred_def_53993,type,
    v97779: ( state_type * $int ) > $o ).

tff(pred_def_53994,type,
    v97745: ( state_type * $int ) > $o ).

tff(pred_def_53995,type,
    v97741: ( state_type * $int ) > $o ).

tff(pred_def_53996,type,
    v97805: state_type > $o ).

tff(pred_def_53997,type,
    v97803: state_type > $o ).

tff(pred_def_53998,type,
    v97809: state_type > $o ).

tff(pred_def_53999,type,
    v97807: state_type > $o ).

tff(pred_def_54000,type,
    v97815: ( state_type * $int ) > $o ).

tff(pred_def_54001,type,
    v97821: state_type > $o ).

tff(pred_def_54002,type,
    v97819: state_type > $o ).

tff(pred_def_54003,type,
    v97817: state_type > $o ).

tff(pred_def_54004,type,
    v97825: state_type > $o ).

tff(pred_def_54005,type,
    v97824: ( state_type * $int ) > $o ).

tff(pred_def_54006,type,
    v97823: ( state_type * $int ) > $o ).

tff(pred_def_54007,type,
    v97829: state_type > $o ).

tff(pred_def_54008,type,
    v97828: ( state_type * $int ) > $o ).

tff(pred_def_54009,type,
    v97827: ( state_type * $int ) > $o ).

tff(pred_def_54010,type,
    v97799: ( state_type * $int ) > $o ).

tff(pred_def_54011,type,
    v97826: ( state_type * $int ) > $o ).

tff(pred_def_54012,type,
    v97822: ( state_type * $int ) > $o ).

tff(pred_def_54013,type,
    v97813: ( state_type * $int ) > $o ).

tff(pred_def_54014,type,
    v97811: ( state_type * $int ) > $o ).

tff(pred_def_54015,type,
    v97833: state_type > $o ).

tff(pred_def_54016,type,
    v97831: state_type > $o ).

tff(pred_def_54017,type,
    v97840: state_type > $o ).

tff(pred_def_54018,type,
    v97838: state_type > $o ).

tff(pred_def_54019,type,
    v97837: state_type > $o ).

tff(pred_def_54020,type,
    v97836: state_type > $o ).

tff(pred_def_54021,type,
    v97848: state_type > $o ).

tff(pred_def_54022,type,
    v97849: state_type > $o ).

tff(pred_def_54023,type,
    v97847: state_type > $o ).

tff(pred_def_54024,type,
    v97844: ( state_type * $int ) > $o ).

tff(pred_def_54025,type,
    v97846: ( state_type * $int ) > $o ).

tff(pred_def_54026,type,
    v97835: ( state_type * $int ) > $o ).

tff(pred_def_54027,type,
    v97801: ( state_type * $int ) > $o ).

tff(pred_def_54028,type,
    v97797: ( state_type * $int ) > $o ).

tff(pred_def_54029,type,
    v97861: state_type > $o ).

tff(pred_def_54030,type,
    v97859: state_type > $o ).

tff(pred_def_54031,type,
    v97865: state_type > $o ).

tff(pred_def_54032,type,
    v97863: state_type > $o ).

tff(pred_def_54033,type,
    v97871: ( state_type * $int ) > $o ).

tff(pred_def_54034,type,
    v97877: state_type > $o ).

tff(pred_def_54035,type,
    v97875: state_type > $o ).

tff(pred_def_54036,type,
    v97873: state_type > $o ).

tff(pred_def_54037,type,
    v97881: state_type > $o ).

tff(pred_def_54038,type,
    v97880: ( state_type * $int ) > $o ).

tff(pred_def_54039,type,
    v97879: ( state_type * $int ) > $o ).

tff(pred_def_54040,type,
    v97885: state_type > $o ).

tff(pred_def_54041,type,
    v97884: ( state_type * $int ) > $o ).

tff(pred_def_54042,type,
    v97883: ( state_type * $int ) > $o ).

tff(pred_def_54043,type,
    v97855: ( state_type * $int ) > $o ).

tff(pred_def_54044,type,
    v97882: ( state_type * $int ) > $o ).

tff(pred_def_54045,type,
    v97878: ( state_type * $int ) > $o ).

tff(pred_def_54046,type,
    v97869: ( state_type * $int ) > $o ).

tff(pred_def_54047,type,
    v97867: ( state_type * $int ) > $o ).

tff(pred_def_54048,type,
    v97889: state_type > $o ).

tff(pred_def_54049,type,
    v97887: state_type > $o ).

tff(pred_def_54050,type,
    v97896: state_type > $o ).

tff(pred_def_54051,type,
    v97894: state_type > $o ).

tff(pred_def_54052,type,
    v97893: state_type > $o ).

tff(pred_def_54053,type,
    v97892: state_type > $o ).

tff(pred_def_54054,type,
    v97904: state_type > $o ).

tff(pred_def_54055,type,
    v97905: state_type > $o ).

tff(pred_def_54056,type,
    v97903: state_type > $o ).

tff(pred_def_54057,type,
    v97900: ( state_type * $int ) > $o ).

tff(pred_def_54058,type,
    v97902: ( state_type * $int ) > $o ).

tff(pred_def_54059,type,
    v97891: ( state_type * $int ) > $o ).

tff(pred_def_54060,type,
    v97857: ( state_type * $int ) > $o ).

tff(pred_def_54061,type,
    v97853: ( state_type * $int ) > $o ).

tff(pred_def_54062,type,
    v97917: state_type > $o ).

tff(pred_def_54063,type,
    v97915: state_type > $o ).

tff(pred_def_54064,type,
    v97921: state_type > $o ).

tff(pred_def_54065,type,
    v97919: state_type > $o ).

tff(pred_def_54066,type,
    v97927: ( state_type * $int ) > $o ).

tff(pred_def_54067,type,
    v97933: state_type > $o ).

tff(pred_def_54068,type,
    v97931: state_type > $o ).

tff(pred_def_54069,type,
    v97929: state_type > $o ).

tff(pred_def_54070,type,
    v97937: state_type > $o ).

tff(pred_def_54071,type,
    v97936: ( state_type * $int ) > $o ).

tff(pred_def_54072,type,
    v97935: ( state_type * $int ) > $o ).

tff(pred_def_54073,type,
    v97941: state_type > $o ).

tff(pred_def_54074,type,
    v97940: ( state_type * $int ) > $o ).

tff(pred_def_54075,type,
    v97939: ( state_type * $int ) > $o ).

tff(pred_def_54076,type,
    v97911: ( state_type * $int ) > $o ).

tff(pred_def_54077,type,
    v97938: ( state_type * $int ) > $o ).

tff(pred_def_54078,type,
    v97934: ( state_type * $int ) > $o ).

tff(pred_def_54079,type,
    v97925: ( state_type * $int ) > $o ).

tff(pred_def_54080,type,
    v97923: ( state_type * $int ) > $o ).

tff(pred_def_54081,type,
    v97945: state_type > $o ).

tff(pred_def_54082,type,
    v97943: state_type > $o ).

tff(pred_def_54083,type,
    v97952: state_type > $o ).

tff(pred_def_54084,type,
    v97950: state_type > $o ).

tff(pred_def_54085,type,
    v97949: state_type > $o ).

tff(pred_def_54086,type,
    v97948: state_type > $o ).

tff(pred_def_54087,type,
    v97960: state_type > $o ).

tff(pred_def_54088,type,
    v97961: state_type > $o ).

tff(pred_def_54089,type,
    v97959: state_type > $o ).

tff(pred_def_54090,type,
    v97956: ( state_type * $int ) > $o ).

tff(pred_def_54091,type,
    v97958: ( state_type * $int ) > $o ).

tff(pred_def_54092,type,
    v97947: ( state_type * $int ) > $o ).

tff(pred_def_54093,type,
    v97913: ( state_type * $int ) > $o ).

tff(pred_def_54094,type,
    v97909: ( state_type * $int ) > $o ).

tff(pred_def_54095,type,
    v97973: state_type > $o ).

tff(pred_def_54096,type,
    v97971: state_type > $o ).

tff(pred_def_54097,type,
    v97977: state_type > $o ).

tff(pred_def_54098,type,
    v97975: state_type > $o ).

tff(pred_def_54099,type,
    v97983: ( state_type * $int ) > $o ).

tff(pred_def_54100,type,
    v97989: state_type > $o ).

tff(pred_def_54101,type,
    v97987: state_type > $o ).

tff(pred_def_54102,type,
    v97985: state_type > $o ).

tff(pred_def_54103,type,
    v97993: state_type > $o ).

tff(pred_def_54104,type,
    v97992: ( state_type * $int ) > $o ).

tff(pred_def_54105,type,
    v97991: ( state_type * $int ) > $o ).

tff(pred_def_54106,type,
    v97997: state_type > $o ).

tff(pred_def_54107,type,
    v97996: ( state_type * $int ) > $o ).

tff(pred_def_54108,type,
    v97995: ( state_type * $int ) > $o ).

tff(pred_def_54109,type,
    v97967: ( state_type * $int ) > $o ).

tff(pred_def_54110,type,
    v97994: ( state_type * $int ) > $o ).

tff(pred_def_54111,type,
    v97990: ( state_type * $int ) > $o ).

tff(pred_def_54112,type,
    v97981: ( state_type * $int ) > $o ).

tff(pred_def_54113,type,
    v97979: ( state_type * $int ) > $o ).

tff(pred_def_54114,type,
    v98001: state_type > $o ).

tff(pred_def_54115,type,
    v97999: state_type > $o ).

tff(pred_def_54116,type,
    v98008: state_type > $o ).

tff(pred_def_54117,type,
    v98006: state_type > $o ).

tff(pred_def_54118,type,
    v98005: state_type > $o ).

tff(pred_def_54119,type,
    v98004: state_type > $o ).

tff(pred_def_54120,type,
    v98016: state_type > $o ).

tff(pred_def_54121,type,
    v98017: state_type > $o ).

tff(pred_def_54122,type,
    v98015: state_type > $o ).

tff(pred_def_54123,type,
    v98012: ( state_type * $int ) > $o ).

tff(pred_def_54124,type,
    v98014: ( state_type * $int ) > $o ).

tff(pred_def_54125,type,
    v98003: ( state_type * $int ) > $o ).

tff(pred_def_54126,type,
    v97969: ( state_type * $int ) > $o ).

tff(pred_def_54127,type,
    v97965: ( state_type * $int ) > $o ).

tff(pred_def_54128,type,
    v98029: state_type > $o ).

tff(pred_def_54129,type,
    v98027: state_type > $o ).

tff(pred_def_54130,type,
    v98033: state_type > $o ).

tff(pred_def_54131,type,
    v98031: state_type > $o ).

tff(pred_def_54132,type,
    v98039: ( state_type * $int ) > $o ).

tff(pred_def_54133,type,
    v98045: state_type > $o ).

tff(pred_def_54134,type,
    v98043: state_type > $o ).

tff(pred_def_54135,type,
    v98041: state_type > $o ).

tff(pred_def_54136,type,
    v98049: state_type > $o ).

tff(pred_def_54137,type,
    v98048: ( state_type * $int ) > $o ).

tff(pred_def_54138,type,
    v98047: ( state_type * $int ) > $o ).

tff(pred_def_54139,type,
    v98053: state_type > $o ).

tff(pred_def_54140,type,
    v98052: ( state_type * $int ) > $o ).

tff(pred_def_54141,type,
    v98051: ( state_type * $int ) > $o ).

tff(pred_def_54142,type,
    v98023: ( state_type * $int ) > $o ).

tff(pred_def_54143,type,
    v98050: ( state_type * $int ) > $o ).

tff(pred_def_54144,type,
    v98046: ( state_type * $int ) > $o ).

tff(pred_def_54145,type,
    v98037: ( state_type * $int ) > $o ).

tff(pred_def_54146,type,
    v98035: ( state_type * $int ) > $o ).

tff(pred_def_54147,type,
    v98057: state_type > $o ).

tff(pred_def_54148,type,
    v98055: state_type > $o ).

tff(pred_def_54149,type,
    v98064: state_type > $o ).

tff(pred_def_54150,type,
    v98062: state_type > $o ).

tff(pred_def_54151,type,
    v98061: state_type > $o ).

tff(pred_def_54152,type,
    v98060: state_type > $o ).

tff(pred_def_54153,type,
    v98072: state_type > $o ).

tff(pred_def_54154,type,
    v98073: state_type > $o ).

tff(pred_def_54155,type,
    v98071: state_type > $o ).

tff(pred_def_54156,type,
    v98068: ( state_type * $int ) > $o ).

tff(pred_def_54157,type,
    v98070: ( state_type * $int ) > $o ).

tff(pred_def_54158,type,
    v98059: ( state_type * $int ) > $o ).

tff(pred_def_54159,type,
    v98025: ( state_type * $int ) > $o ).

tff(pred_def_54160,type,
    v98021: ( state_type * $int ) > $o ).

tff(pred_def_54161,type,
    v98085: state_type > $o ).

tff(pred_def_54162,type,
    v98083: state_type > $o ).

tff(pred_def_54163,type,
    v98089: state_type > $o ).

tff(pred_def_54164,type,
    v98087: state_type > $o ).

tff(pred_def_54165,type,
    v98095: ( state_type * $int ) > $o ).

tff(pred_def_54166,type,
    v98101: state_type > $o ).

tff(pred_def_54167,type,
    v98099: state_type > $o ).

tff(pred_def_54168,type,
    v98097: state_type > $o ).

tff(pred_def_54169,type,
    v98105: state_type > $o ).

tff(pred_def_54170,type,
    v98104: ( state_type * $int ) > $o ).

tff(pred_def_54171,type,
    v98103: ( state_type * $int ) > $o ).

tff(pred_def_54172,type,
    v98109: state_type > $o ).

tff(pred_def_54173,type,
    v98108: ( state_type * $int ) > $o ).

tff(pred_def_54174,type,
    v98107: ( state_type * $int ) > $o ).

tff(pred_def_54175,type,
    v98079: ( state_type * $int ) > $o ).

tff(pred_def_54176,type,
    v98106: ( state_type * $int ) > $o ).

tff(pred_def_54177,type,
    v98102: ( state_type * $int ) > $o ).

tff(pred_def_54178,type,
    v98093: ( state_type * $int ) > $o ).

tff(pred_def_54179,type,
    v98091: ( state_type * $int ) > $o ).

tff(pred_def_54180,type,
    v98113: state_type > $o ).

tff(pred_def_54181,type,
    v98111: state_type > $o ).

tff(pred_def_54182,type,
    v98120: state_type > $o ).

tff(pred_def_54183,type,
    v98118: state_type > $o ).

tff(pred_def_54184,type,
    v98117: state_type > $o ).

tff(pred_def_54185,type,
    v98116: state_type > $o ).

tff(pred_def_54186,type,
    v98128: state_type > $o ).

tff(pred_def_54187,type,
    v98129: state_type > $o ).

tff(pred_def_54188,type,
    v98127: state_type > $o ).

tff(pred_def_54189,type,
    v98124: ( state_type * $int ) > $o ).

tff(pred_def_54190,type,
    v98126: ( state_type * $int ) > $o ).

tff(pred_def_54191,type,
    v98115: ( state_type * $int ) > $o ).

tff(pred_def_54192,type,
    v98081: ( state_type * $int ) > $o ).

tff(pred_def_54193,type,
    v98077: ( state_type * $int ) > $o ).

tff(pred_def_54194,type,
    v98141: state_type > $o ).

tff(pred_def_54195,type,
    v98139: state_type > $o ).

tff(pred_def_54196,type,
    v98145: state_type > $o ).

tff(pred_def_54197,type,
    v98143: state_type > $o ).

tff(pred_def_54198,type,
    v98151: ( state_type * $int ) > $o ).

tff(pred_def_54199,type,
    v98157: state_type > $o ).

tff(pred_def_54200,type,
    v98155: state_type > $o ).

tff(pred_def_54201,type,
    v98153: state_type > $o ).

tff(pred_def_54202,type,
    v98161: state_type > $o ).

tff(pred_def_54203,type,
    v98160: ( state_type * $int ) > $o ).

tff(pred_def_54204,type,
    v98159: ( state_type * $int ) > $o ).

tff(pred_def_54205,type,
    v98165: state_type > $o ).

tff(pred_def_54206,type,
    v98164: ( state_type * $int ) > $o ).

tff(pred_def_54207,type,
    v98163: ( state_type * $int ) > $o ).

tff(pred_def_54208,type,
    v98135: ( state_type * $int ) > $o ).

tff(pred_def_54209,type,
    v98162: ( state_type * $int ) > $o ).

tff(pred_def_54210,type,
    v98158: ( state_type * $int ) > $o ).

tff(pred_def_54211,type,
    v98149: ( state_type * $int ) > $o ).

tff(pred_def_54212,type,
    v98147: ( state_type * $int ) > $o ).

tff(pred_def_54213,type,
    v98169: state_type > $o ).

tff(pred_def_54214,type,
    v98167: state_type > $o ).

tff(pred_def_54215,type,
    v98176: state_type > $o ).

tff(pred_def_54216,type,
    v98174: state_type > $o ).

tff(pred_def_54217,type,
    v98173: state_type > $o ).

tff(pred_def_54218,type,
    v98172: state_type > $o ).

tff(pred_def_54219,type,
    v98184: state_type > $o ).

tff(pred_def_54220,type,
    v98185: state_type > $o ).

tff(pred_def_54221,type,
    v98183: state_type > $o ).

tff(pred_def_54222,type,
    v98180: ( state_type * $int ) > $o ).

tff(pred_def_54223,type,
    v98182: ( state_type * $int ) > $o ).

tff(pred_def_54224,type,
    v98171: ( state_type * $int ) > $o ).

tff(pred_def_54225,type,
    v98137: ( state_type * $int ) > $o ).

tff(pred_def_54226,type,
    v98133: ( state_type * $int ) > $o ).

tff(pred_def_54227,type,
    v98197: state_type > $o ).

tff(pred_def_54228,type,
    v98195: state_type > $o ).

tff(pred_def_54229,type,
    v98201: state_type > $o ).

tff(pred_def_54230,type,
    v98199: state_type > $o ).

tff(pred_def_54231,type,
    v98207: ( state_type * $int ) > $o ).

tff(pred_def_54232,type,
    v98213: state_type > $o ).

tff(pred_def_54233,type,
    v98211: state_type > $o ).

tff(pred_def_54234,type,
    v98209: state_type > $o ).

tff(pred_def_54235,type,
    v98217: state_type > $o ).

tff(pred_def_54236,type,
    v98216: ( state_type * $int ) > $o ).

tff(pred_def_54237,type,
    v98215: ( state_type * $int ) > $o ).

tff(pred_def_54238,type,
    v98221: state_type > $o ).

tff(pred_def_54239,type,
    v98220: ( state_type * $int ) > $o ).

tff(pred_def_54240,type,
    v98219: ( state_type * $int ) > $o ).

tff(pred_def_54241,type,
    v98191: ( state_type * $int ) > $o ).

tff(pred_def_54242,type,
    v98218: ( state_type * $int ) > $o ).

tff(pred_def_54243,type,
    v98214: ( state_type * $int ) > $o ).

tff(pred_def_54244,type,
    v98205: ( state_type * $int ) > $o ).

tff(pred_def_54245,type,
    v98203: ( state_type * $int ) > $o ).

tff(pred_def_54246,type,
    v98225: state_type > $o ).

tff(pred_def_54247,type,
    v98223: state_type > $o ).

tff(pred_def_54248,type,
    v98232: state_type > $o ).

tff(pred_def_54249,type,
    v98230: state_type > $o ).

tff(pred_def_54250,type,
    v98229: state_type > $o ).

tff(pred_def_54251,type,
    v98228: state_type > $o ).

tff(pred_def_54252,type,
    v98240: state_type > $o ).

tff(pred_def_54253,type,
    v98241: state_type > $o ).

tff(pred_def_54254,type,
    v98239: state_type > $o ).

tff(pred_def_54255,type,
    v98236: ( state_type * $int ) > $o ).

tff(pred_def_54256,type,
    v98238: ( state_type * $int ) > $o ).

tff(pred_def_54257,type,
    v98227: ( state_type * $int ) > $o ).

tff(pred_def_54258,type,
    v98193: ( state_type * $int ) > $o ).

tff(pred_def_54259,type,
    v98189: ( state_type * $int ) > $o ).

tff(pred_def_54260,type,
    v98253: state_type > $o ).

tff(pred_def_54261,type,
    v98251: state_type > $o ).

tff(pred_def_54262,type,
    v98257: state_type > $o ).

tff(pred_def_54263,type,
    v98255: state_type > $o ).

tff(pred_def_54264,type,
    v98263: ( state_type * $int ) > $o ).

tff(pred_def_54265,type,
    v98269: state_type > $o ).

tff(pred_def_54266,type,
    v98267: state_type > $o ).

tff(pred_def_54267,type,
    v98265: state_type > $o ).

tff(pred_def_54268,type,
    v98273: state_type > $o ).

tff(pred_def_54269,type,
    v98272: ( state_type * $int ) > $o ).

tff(pred_def_54270,type,
    v98271: ( state_type * $int ) > $o ).

tff(pred_def_54271,type,
    v98277: state_type > $o ).

tff(pred_def_54272,type,
    v98276: ( state_type * $int ) > $o ).

tff(pred_def_54273,type,
    v98275: ( state_type * $int ) > $o ).

tff(pred_def_54274,type,
    v98247: ( state_type * $int ) > $o ).

tff(pred_def_54275,type,
    v98274: ( state_type * $int ) > $o ).

tff(pred_def_54276,type,
    v98270: ( state_type * $int ) > $o ).

tff(pred_def_54277,type,
    v98261: ( state_type * $int ) > $o ).

tff(pred_def_54278,type,
    v98259: ( state_type * $int ) > $o ).

tff(pred_def_54279,type,
    v98281: state_type > $o ).

tff(pred_def_54280,type,
    v98279: state_type > $o ).

tff(pred_def_54281,type,
    v98288: state_type > $o ).

tff(pred_def_54282,type,
    v98286: state_type > $o ).

tff(pred_def_54283,type,
    v98285: state_type > $o ).

tff(pred_def_54284,type,
    v98284: state_type > $o ).

tff(pred_def_54285,type,
    v98296: state_type > $o ).

tff(pred_def_54286,type,
    v98297: state_type > $o ).

tff(pred_def_54287,type,
    v98295: state_type > $o ).

tff(pred_def_54288,type,
    v98292: ( state_type * $int ) > $o ).

tff(pred_def_54289,type,
    v98294: ( state_type * $int ) > $o ).

tff(pred_def_54290,type,
    v98283: ( state_type * $int ) > $o ).

tff(pred_def_54291,type,
    v98249: ( state_type * $int ) > $o ).

tff(pred_def_54292,type,
    v98245: ( state_type * $int ) > $o ).

tff(pred_def_54293,type,
    v98309: state_type > $o ).

tff(pred_def_54294,type,
    v98307: state_type > $o ).

tff(pred_def_54295,type,
    v98313: state_type > $o ).

tff(pred_def_54296,type,
    v98311: state_type > $o ).

tff(pred_def_54297,type,
    v98319: ( state_type * $int ) > $o ).

tff(pred_def_54298,type,
    v98325: state_type > $o ).

tff(pred_def_54299,type,
    v98323: state_type > $o ).

tff(pred_def_54300,type,
    v98321: state_type > $o ).

tff(pred_def_54301,type,
    v98329: state_type > $o ).

tff(pred_def_54302,type,
    v98328: ( state_type * $int ) > $o ).

tff(pred_def_54303,type,
    v98327: ( state_type * $int ) > $o ).

tff(pred_def_54304,type,
    v98333: state_type > $o ).

tff(pred_def_54305,type,
    v98332: ( state_type * $int ) > $o ).

tff(pred_def_54306,type,
    v98331: ( state_type * $int ) > $o ).

tff(pred_def_54307,type,
    v98303: ( state_type * $int ) > $o ).

tff(pred_def_54308,type,
    v98330: ( state_type * $int ) > $o ).

tff(pred_def_54309,type,
    v98326: ( state_type * $int ) > $o ).

tff(pred_def_54310,type,
    v98317: ( state_type * $int ) > $o ).

tff(pred_def_54311,type,
    v98315: ( state_type * $int ) > $o ).

tff(pred_def_54312,type,
    v98337: state_type > $o ).

tff(pred_def_54313,type,
    v98335: state_type > $o ).

tff(pred_def_54314,type,
    v98344: state_type > $o ).

tff(pred_def_54315,type,
    v98342: state_type > $o ).

tff(pred_def_54316,type,
    v98341: state_type > $o ).

tff(pred_def_54317,type,
    v98340: state_type > $o ).

tff(pred_def_54318,type,
    v98352: state_type > $o ).

tff(pred_def_54319,type,
    v98353: state_type > $o ).

tff(pred_def_54320,type,
    v98351: state_type > $o ).

tff(pred_def_54321,type,
    v98348: ( state_type * $int ) > $o ).

tff(pred_def_54322,type,
    v98350: ( state_type * $int ) > $o ).

tff(pred_def_54323,type,
    v98339: ( state_type * $int ) > $o ).

tff(pred_def_54324,type,
    v98305: ( state_type * $int ) > $o ).

tff(pred_def_54325,type,
    v98301: ( state_type * $int ) > $o ).

tff(pred_def_54326,type,
    v97232: ( state_type * $int ) > $o ).

tff(pred_def_54327,type,
    v98374: state_type > $o ).

tff(pred_def_54328,type,
    v98373: state_type > $o ).

tff(pred_def_54329,type,
    v98372: ( state_type * $int ) > $o ).

tff(pred_def_54330,type,
    v98371: ( state_type * $int ) > $o ).

tff(pred_def_54331,type,
    v98378: state_type > $o ).

tff(pred_def_54332,type,
    v98377: state_type > $o ).

tff(pred_def_54333,type,
    v98376: ( state_type * $int ) > $o ).

tff(pred_def_54334,type,
    v98375: ( state_type * $int ) > $o ).

tff(pred_def_54335,type,
    v98370: ( state_type * $int ) > $o ).

tff(pred_def_54336,type,
    v98382: state_type > $o ).

tff(pred_def_54337,type,
    v98381: state_type > $o ).

tff(pred_def_54338,type,
    v98380: ( state_type * $int ) > $o ).

tff(pred_def_54339,type,
    v98379: ( state_type * $int ) > $o ).

tff(pred_def_54340,type,
    v98369: ( state_type * $int ) > $o ).

tff(pred_def_54341,type,
    v98386: state_type > $o ).

tff(pred_def_54342,type,
    v98385: state_type > $o ).

tff(pred_def_54343,type,
    v98384: ( state_type * $int ) > $o ).

tff(pred_def_54344,type,
    v98383: ( state_type * $int ) > $o ).

tff(pred_def_54345,type,
    v98368: ( state_type * $int ) > $o ).

tff(pred_def_54346,type,
    v98390: state_type > $o ).

tff(pred_def_54347,type,
    v98389: state_type > $o ).

tff(pred_def_54348,type,
    v98388: ( state_type * $int ) > $o ).

tff(pred_def_54349,type,
    v98387: ( state_type * $int ) > $o ).

tff(pred_def_54350,type,
    v98367: ( state_type * $int ) > $o ).

tff(pred_def_54351,type,
    v98394: state_type > $o ).

tff(pred_def_54352,type,
    v98393: state_type > $o ).

tff(pred_def_54353,type,
    v98392: ( state_type * $int ) > $o ).

tff(pred_def_54354,type,
    v98391: ( state_type * $int ) > $o ).

tff(pred_def_54355,type,
    v98366: ( state_type * $int ) > $o ).

tff(pred_def_54356,type,
    v98398: state_type > $o ).

tff(pred_def_54357,type,
    v98397: state_type > $o ).

tff(pred_def_54358,type,
    v98396: ( state_type * $int ) > $o ).

tff(pred_def_54359,type,
    v98395: ( state_type * $int ) > $o ).

tff(pred_def_54360,type,
    v98365: ( state_type * $int ) > $o ).

tff(pred_def_54361,type,
    v98402: state_type > $o ).

tff(pred_def_54362,type,
    v98401: state_type > $o ).

tff(pred_def_54363,type,
    v98400: ( state_type * $int ) > $o ).

tff(pred_def_54364,type,
    v98399: ( state_type * $int ) > $o ).

tff(pred_def_54365,type,
    v98364: ( state_type * $int ) > $o ).

tff(pred_def_54366,type,
    v98406: state_type > $o ).

tff(pred_def_54367,type,
    v98405: state_type > $o ).

tff(pred_def_54368,type,
    v98404: ( state_type * $int ) > $o ).

tff(pred_def_54369,type,
    v98403: ( state_type * $int ) > $o ).

tff(pred_def_54370,type,
    v98363: ( state_type * $int ) > $o ).

tff(pred_def_54371,type,
    v98410: state_type > $o ).

tff(pred_def_54372,type,
    v98409: state_type > $o ).

tff(pred_def_54373,type,
    v98408: ( state_type * $int ) > $o ).

tff(pred_def_54374,type,
    v98407: ( state_type * $int ) > $o ).

tff(pred_def_54375,type,
    v98362: ( state_type * $int ) > $o ).

tff(pred_def_54376,type,
    v98414: state_type > $o ).

tff(pred_def_54377,type,
    v98413: state_type > $o ).

tff(pred_def_54378,type,
    v98412: ( state_type * $int ) > $o ).

tff(pred_def_54379,type,
    v98411: ( state_type * $int ) > $o ).

tff(pred_def_54380,type,
    v98361: ( state_type * $int ) > $o ).

tff(pred_def_54381,type,
    v98418: state_type > $o ).

tff(pred_def_54382,type,
    v98417: state_type > $o ).

tff(pred_def_54383,type,
    v98416: ( state_type * $int ) > $o ).

tff(pred_def_54384,type,
    v98415: ( state_type * $int ) > $o ).

tff(pred_def_54385,type,
    v98360: ( state_type * $int ) > $o ).

tff(pred_def_54386,type,
    v98422: state_type > $o ).

tff(pred_def_54387,type,
    v98421: state_type > $o ).

tff(pred_def_54388,type,
    v98420: ( state_type * $int ) > $o ).

tff(pred_def_54389,type,
    v98419: ( state_type * $int ) > $o ).

tff(pred_def_54390,type,
    v98359: ( state_type * $int ) > $o ).

tff(pred_def_54391,type,
    v98426: state_type > $o ).

tff(pred_def_54392,type,
    v98425: state_type > $o ).

tff(pred_def_54393,type,
    v98424: ( state_type * $int ) > $o ).

tff(pred_def_54394,type,
    v98423: ( state_type * $int ) > $o ).

tff(pred_def_54395,type,
    v98358: ( state_type * $int ) > $o ).

tff(pred_def_54396,type,
    v98430: state_type > $o ).

tff(pred_def_54397,type,
    v98429: state_type > $o ).

tff(pred_def_54398,type,
    v98428: ( state_type * $int ) > $o ).

tff(pred_def_54399,type,
    v98427: ( state_type * $int ) > $o ).

tff(pred_def_54400,type,
    v98357: ( state_type * $int ) > $o ).

tff(pred_def_54401,type,
    v98434: state_type > $o ).

tff(pred_def_54402,type,
    v98433: state_type > $o ).

tff(pred_def_54403,type,
    v98432: ( state_type * $int ) > $o ).

tff(pred_def_54404,type,
    v98431: ( state_type * $int ) > $o ).

tff(pred_def_54405,type,
    v98356: ( state_type * $int ) > $o ).

tff(pred_def_54406,type,
    v97411: ( state_type * $int ) > $o ).

tff(pred_def_54407,type,
    v98440: state_type > $o ).

tff(pred_def_54408,type,
    v97325: state_type > $o ).

tff(pred_def_54409,type,
    v98438: state_type > $o ).

tff(pred_def_54410,type,
    v98452: state_type > $o ).

tff(pred_def_54411,type,
    v98450: state_type > $o ).

tff(pred_def_54412,type,
    v98456: state_type > $o ).

tff(pred_def_54413,type,
    v98454: state_type > $o ).

tff(pred_def_54414,type,
    v98470: state_type > $o ).

tff(pred_def_54415,type,
    v98468: state_type > $o ).

tff(pred_def_54416,type,
    v98467: state_type > $o ).

tff(pred_def_54417,type,
    v98466: ( state_type * $int ) > $o ).

tff(pred_def_54418,type,
    v98478: state_type > $o ).

tff(pred_def_54419,type,
    v98476: state_type > $o ).

tff(pred_def_54420,type,
    v98475: state_type > $o ).

tff(pred_def_54421,type,
    v98474: ( state_type * $int ) > $o ).

tff(pred_def_54422,type,
    v98486: state_type > $o ).

tff(pred_def_54423,type,
    v98484: state_type > $o ).

tff(pred_def_54424,type,
    v98483: state_type > $o ).

tff(pred_def_54425,type,
    v98482: ( state_type * $int ) > $o ).

tff(pred_def_54426,type,
    v98494: state_type > $o ).

tff(pred_def_54427,type,
    v98492: state_type > $o ).

tff(pred_def_54428,type,
    v98491: state_type > $o ).

tff(pred_def_54429,type,
    v98490: ( state_type * $int ) > $o ).

tff(pred_def_54430,type,
    v98502: state_type > $o ).

tff(pred_def_54431,type,
    v98500: state_type > $o ).

tff(pred_def_54432,type,
    v98499: state_type > $o ).

tff(pred_def_54433,type,
    v98498: ( state_type * $int ) > $o ).

tff(pred_def_54434,type,
    v98510: state_type > $o ).

tff(pred_def_54435,type,
    v98508: state_type > $o ).

tff(pred_def_54436,type,
    v98507: state_type > $o ).

tff(pred_def_54437,type,
    v98506: ( state_type * $int ) > $o ).

tff(pred_def_54438,type,
    v98518: state_type > $o ).

tff(pred_def_54439,type,
    v98516: state_type > $o ).

tff(pred_def_54440,type,
    v98515: state_type > $o ).

tff(pred_def_54441,type,
    v98514: ( state_type * $int ) > $o ).

tff(pred_def_54442,type,
    v98526: state_type > $o ).

tff(pred_def_54443,type,
    v98524: state_type > $o ).

tff(pred_def_54444,type,
    v98523: state_type > $o ).

tff(pred_def_54445,type,
    v98522: ( state_type * $int ) > $o ).

tff(pred_def_54446,type,
    v98534: state_type > $o ).

tff(pred_def_54447,type,
    v98532: state_type > $o ).

tff(pred_def_54448,type,
    v98531: state_type > $o ).

tff(pred_def_54449,type,
    v98530: ( state_type * $int ) > $o ).

tff(pred_def_54450,type,
    v98542: state_type > $o ).

tff(pred_def_54451,type,
    v98540: state_type > $o ).

tff(pred_def_54452,type,
    v98539: state_type > $o ).

tff(pred_def_54453,type,
    v98538: ( state_type * $int ) > $o ).

tff(pred_def_54454,type,
    v98550: state_type > $o ).

tff(pred_def_54455,type,
    v98548: state_type > $o ).

tff(pred_def_54456,type,
    v98547: state_type > $o ).

tff(pred_def_54457,type,
    v98546: ( state_type * $int ) > $o ).

tff(pred_def_54458,type,
    v98558: state_type > $o ).

tff(pred_def_54459,type,
    v98556: state_type > $o ).

tff(pred_def_54460,type,
    v98555: state_type > $o ).

tff(pred_def_54461,type,
    v98554: ( state_type * $int ) > $o ).

tff(pred_def_54462,type,
    v98566: state_type > $o ).

tff(pred_def_54463,type,
    v98564: state_type > $o ).

tff(pred_def_54464,type,
    v98563: state_type > $o ).

tff(pred_def_54465,type,
    v98562: ( state_type * $int ) > $o ).

tff(pred_def_54466,type,
    v98574: state_type > $o ).

tff(pred_def_54467,type,
    v98572: state_type > $o ).

tff(pred_def_54468,type,
    v98571: state_type > $o ).

tff(pred_def_54469,type,
    v98570: ( state_type * $int ) > $o ).

tff(pred_def_54470,type,
    v98582: state_type > $o ).

tff(pred_def_54471,type,
    v98580: state_type > $o ).

tff(pred_def_54472,type,
    v98579: state_type > $o ).

tff(pred_def_54473,type,
    v98578: ( state_type * $int ) > $o ).

tff(pred_def_54474,type,
    v98590: state_type > $o ).

tff(pred_def_54475,type,
    v98588: state_type > $o ).

tff(pred_def_54476,type,
    v98587: state_type > $o ).

tff(pred_def_54477,type,
    v98586: ( state_type * $int ) > $o ).

tff(pred_def_54478,type,
    v97208: state_type > $o ).

tff(pred_def_54479,type,
    v98436: state_type > $o ).

tff(pred_def_54480,type,
    v98464: state_type > $o ).

tff(pred_def_54481,type,
    v98462: state_type > $o ).

tff(pred_def_54482,type,
    v98601: state_type > $o ).

tff(pred_def_54483,type,
    v98600: state_type > $o ).

tff(pred_def_54484,type,
    v98603: state_type > $o ).

tff(pred_def_54485,type,
    v98602: state_type > $o ).

tff(pred_def_54486,type,
    v98598: state_type > $o ).

tff(pred_def_54487,type,
    v98596: state_type > $o ).

tff(pred_def_54488,type,
    v98607: state_type > $o ).

tff(pred_def_54489,type,
    v98606: state_type > $o ).

tff(pred_def_54490,type,
    v98605: state_type > $o ).

tff(pred_def_54491,type,
    v98611: state_type > $o ).

tff(pred_def_54492,type,
    v98610: state_type > $o ).

tff(pred_def_54493,type,
    v98609: state_type > $o ).

tff(pred_def_54494,type,
    v98446: state_type > $o ).

tff(pred_def_54495,type,
    v98608: state_type > $o ).

tff(pred_def_54496,type,
    v98460: state_type > $o ).

tff(pred_def_54497,type,
    v98458: state_type > $o ).

tff(pred_def_54498,type,
    v98615: state_type > $o ).

tff(pred_def_54499,type,
    v98613: state_type > $o ).

tff(pred_def_54500,type,
    v98622: state_type > $o ).

tff(pred_def_54501,type,
    v98620: state_type > $o ).

tff(pred_def_54502,type,
    v98619: state_type > $o ).

tff(pred_def_54503,type,
    v98618: state_type > $o ).

tff(pred_def_54504,type,
    v98630: state_type > $o ).

tff(pred_def_54505,type,
    v98631: state_type > $o ).

tff(pred_def_54506,type,
    v98629: state_type > $o ).

tff(pred_def_54507,type,
    v98626: state_type > $o ).

tff(pred_def_54508,type,
    v98628: state_type > $o ).

tff(pred_def_54509,type,
    v98448: state_type > $o ).

tff(pred_def_54510,type,
    v98444: state_type > $o ).

tff(pred_def_54511,type,
    v98651: state_type > $o ).

tff(pred_def_54512,type,
    v98649: state_type > $o ).

tff(pred_def_54513,type,
    v98655: state_type > $o ).

tff(pred_def_54514,type,
    v98653: state_type > $o ).

tff(pred_def_54515,type,
    v98675: state_type > $o ).

tff(pred_def_54516,type,
    v98674: state_type > $o ).

tff(pred_def_54517,type,
    v98673: state_type > $o ).

tff(pred_def_54518,type,
    v98672: state_type > $o ).

tff(pred_def_54519,type,
    v98671: state_type > $o ).

tff(pred_def_54520,type,
    v98670: state_type > $o ).

tff(pred_def_54521,type,
    v98667: state_type > $o ).

tff(pred_def_54522,type,
    v98678: state_type > $o ).

tff(pred_def_54523,type,
    v98677: state_type > $o ).

tff(pred_def_54524,type,
    v98679: state_type > $o ).

tff(pred_def_54525,type,
    v98665: state_type > $o ).

tff(pred_def_54526,type,
    v98691: state_type > $o ).

tff(pred_def_54527,type,
    v98690: state_type > $o ).

tff(pred_def_54528,type,
    v98692: state_type > $o ).

tff(pred_def_54529,type,
    v98689: state_type > $o ).

tff(pred_def_54530,type,
    v98694: state_type > $o ).

tff(pred_def_54531,type,
    v98695: state_type > $o ).

tff(pred_def_54532,type,
    v98693: state_type > $o ).

tff(pred_def_54533,type,
    v98687: ( state_type * $int ) > $o ).

tff(pred_def_54534,type,
    v98685: ( state_type * $int ) > $o ).

tff(pred_def_54535,type,
    v98683: ( state_type * $int ) > $o ).

tff(pred_def_54536,type,
    v98681: ( state_type * $int ) > $o ).

tff(pred_def_54537,type,
    v98706: state_type > $o ).

tff(pred_def_54538,type,
    v98705: state_type > $o ).

tff(pred_def_54539,type,
    v98704: state_type > $o ).

tff(pred_def_54540,type,
    v98703: state_type > $o ).

tff(pred_def_54541,type,
    v98702: state_type > $o ).

tff(pred_def_54542,type,
    v98701: state_type > $o ).

tff(pred_def_54543,type,
    v98699: state_type > $o ).

tff(pred_def_54544,type,
    v98698: state_type > $o ).

tff(pred_def_54545,type,
    v98697: state_type > $o ).

tff(pred_def_54546,type,
    v98643: ( state_type * $int ) > $o ).

tff(pred_def_54547,type,
    v98713: state_type > $o ).

tff(pred_def_54548,type,
    v98712: state_type > $o ).

tff(pred_def_54549,type,
    v98711: state_type > $o ).

tff(pred_def_54550,type,
    v98714: state_type > $o ).

tff(pred_def_54551,type,
    v98710: state_type > $o ).

tff(pred_def_54552,type,
    v98715: state_type > $o ).

tff(pred_def_54553,type,
    v98709: state_type > $o ).

tff(pred_def_54554,type,
    v98718: state_type > $o ).

tff(pred_def_54555,type,
    v98719: state_type > $o ).

tff(pred_def_54556,type,
    v98717: state_type > $o ).

tff(pred_def_54557,type,
    v98720: state_type > $o ).

tff(pred_def_54558,type,
    v98716: state_type > $o ).

tff(pred_def_54559,type,
    v98723: state_type > $o ).

tff(pred_def_54560,type,
    v98724: state_type > $o ).

tff(pred_def_54561,type,
    v98722: state_type > $o ).

tff(pred_def_54562,type,
    v98725: state_type > $o ).

tff(pred_def_54563,type,
    v98721: state_type > $o ).

tff(pred_def_54564,type,
    v98707: ( state_type * $int ) > $o ).

tff(pred_def_54565,type,
    v98728: state_type > $o ).

tff(pred_def_54566,type,
    v98729: state_type > $o ).

tff(pred_def_54567,type,
    v98727: state_type > $o ).

tff(pred_def_54568,type,
    v98738: state_type > $o ).

tff(pred_def_54569,type,
    v98737: state_type > $o ).

tff(pred_def_54570,type,
    v98736: state_type > $o ).

tff(pred_def_54571,type,
    v98735: state_type > $o ).

tff(pred_def_54572,type,
    v98734: state_type > $o ).

tff(pred_def_54573,type,
    v98733: state_type > $o ).

tff(pred_def_54574,type,
    v98739: state_type > $o ).

tff(pred_def_54575,type,
    v98732: state_type > $o ).

tff(pred_def_54576,type,
    v98742: state_type > $o ).

tff(pred_def_54577,type,
    v98741: state_type > $o ).

tff(pred_def_54578,type,
    v98743: state_type > $o ).

tff(pred_def_54579,type,
    v98740: state_type > $o ).

tff(pred_def_54580,type,
    v98745: state_type > $o ).

tff(pred_def_54581,type,
    v98746: state_type > $o ).

tff(pred_def_54582,type,
    v98744: state_type > $o ).

tff(pred_def_54583,type,
    v98730: ( state_type * $int ) > $o ).

tff(pred_def_54584,type,
    v98726: ( state_type * $int ) > $o ).

tff(pred_def_54585,type,
    v98663: ( state_type * $int ) > $o ).

tff(pred_def_54586,type,
    v98661: ( state_type * $int ) > $o ).

tff(pred_def_54587,type,
    v98659: ( state_type * $int ) > $o ).

tff(pred_def_54588,type,
    v98657: ( state_type * $int ) > $o ).

tff(pred_def_54589,type,
    v98750: state_type > $o ).

tff(pred_def_54590,type,
    v98748: state_type > $o ).

tff(pred_def_54591,type,
    v98757: state_type > $o ).

tff(pred_def_54592,type,
    v98755: state_type > $o ).

tff(pred_def_54593,type,
    v98754: state_type > $o ).

tff(pred_def_54594,type,
    v98753: state_type > $o ).

tff(pred_def_54595,type,
    v98765: state_type > $o ).

tff(pred_def_54596,type,
    v98766: state_type > $o ).

tff(pred_def_54597,type,
    v98764: state_type > $o ).

tff(pred_def_54598,type,
    v98761: ( state_type * $int ) > $o ).

tff(pred_def_54599,type,
    v98763: ( state_type * $int ) > $o ).

tff(pred_def_54600,type,
    v98647: ( state_type * $int ) > $o ).

tff(pred_def_54601,type,
    v98645: ( state_type * $int ) > $o ).

tff(pred_def_54602,type,
    v98783: state_type > $o ).

tff(pred_def_54603,type,
    v98782: ( state_type * $int ) > $o ).

tff(pred_def_54604,type,
    v98781: ( state_type * $int ) > $o ).

tff(pred_def_54605,type,
    v98787: state_type > $o ).

tff(pred_def_54606,type,
    v98786: state_type > $o ).

tff(pred_def_54607,type,
    v98785: ( state_type * $int ) > $o ).

tff(pred_def_54608,type,
    v98784: ( state_type * $int ) > $o ).

tff(pred_def_54609,type,
    v98780: ( state_type * $int ) > $o ).

tff(pred_def_54610,type,
    v98779: ( state_type * $int ) > $o ).

tff(pred_def_54611,type,
    v98791: state_type > $o ).

tff(pred_def_54612,type,
    v98790: state_type > $o ).

tff(pred_def_54613,type,
    v98789: ( state_type * $int ) > $o ).

tff(pred_def_54614,type,
    v98788: ( state_type * $int ) > $o ).

tff(pred_def_54615,type,
    v98778: ( state_type * $int ) > $o ).

tff(pred_def_54616,type,
    v98777: ( state_type * $int ) > $o ).

tff(pred_def_54617,type,
    v98795: state_type > $o ).

tff(pred_def_54618,type,
    v98794: state_type > $o ).

tff(pred_def_54619,type,
    v98793: ( state_type * $int ) > $o ).

tff(pred_def_54620,type,
    v98792: ( state_type * $int ) > $o ).

tff(pred_def_54621,type,
    v98776: ( state_type * $int ) > $o ).

tff(pred_def_54622,type,
    v98775: ( state_type * $int ) > $o ).

tff(pred_def_54623,type,
    v98799: state_type > $o ).

tff(pred_def_54624,type,
    v98798: state_type > $o ).

tff(pred_def_54625,type,
    v98797: ( state_type * $int ) > $o ).

tff(pred_def_54626,type,
    v98796: ( state_type * $int ) > $o ).

tff(pred_def_54627,type,
    v98774: ( state_type * $int ) > $o ).

tff(pred_def_54628,type,
    v98773: ( state_type * $int ) > $o ).

tff(pred_def_54629,type,
    v98803: state_type > $o ).

tff(pred_def_54630,type,
    v98802: state_type > $o ).

tff(pred_def_54631,type,
    v98801: ( state_type * $int ) > $o ).

tff(pred_def_54632,type,
    v98800: ( state_type * $int ) > $o ).

tff(pred_def_54633,type,
    v98772: ( state_type * $int ) > $o ).

tff(pred_def_54634,type,
    v98771: ( state_type * $int ) > $o ).

tff(pred_def_54635,type,
    v98807: state_type > $o ).

tff(pred_def_54636,type,
    v98806: state_type > $o ).

tff(pred_def_54637,type,
    v98805: ( state_type * $int ) > $o ).

tff(pred_def_54638,type,
    v98804: ( state_type * $int ) > $o ).

tff(pred_def_54639,type,
    v98770: ( state_type * $int ) > $o ).

tff(pred_def_54640,type,
    v98810: state_type > $o ).

tff(pred_def_54641,type,
    v98809: state_type > $o ).

tff(pred_def_54642,type,
    v98808: ( state_type * $int ) > $o ).

tff(pred_def_54643,type,
    v98641: ( state_type * $int ) > $o ).

tff(pred_def_54644,type,
    v98831: state_type > $o ).

tff(pred_def_54645,type,
    v98829: state_type > $o ).

tff(pred_def_54646,type,
    v98835: state_type > $o ).

tff(pred_def_54647,type,
    v98833: state_type > $o ).

tff(pred_def_54648,type,
    v98851: state_type > $o ).

tff(pred_def_54649,type,
    v98849: state_type > $o ).

tff(pred_def_54650,type,
    v98855: state_type > $o ).

tff(pred_def_54651,type,
    v98853: state_type > $o ).

tff(pred_def_54652,type,
    v98823: ( state_type * $int ) > $o ).

tff(pred_def_54653,type,
    v98870: state_type > $o ).

tff(pred_def_54654,type,
    v98869: state_type > $o ).

tff(pred_def_54655,type,
    v98868: state_type > $o ).

tff(pred_def_54656,type,
    v98871: state_type > $o ).

tff(pred_def_54657,type,
    v98867: state_type > $o ).

tff(pred_def_54658,type,
    v98872: state_type > $o ).

tff(pred_def_54659,type,
    v98866: state_type > $o ).

tff(pred_def_54660,type,
    v98875: state_type > $o ).

tff(pred_def_54661,type,
    v98876: state_type > $o ).

tff(pred_def_54662,type,
    v98874: state_type > $o ).

tff(pred_def_54663,type,
    v98877: state_type > $o ).

tff(pred_def_54664,type,
    v98873: state_type > $o ).

tff(pred_def_54665,type,
    v98880: state_type > $o ).

tff(pred_def_54666,type,
    v98881: state_type > $o ).

tff(pred_def_54667,type,
    v98879: state_type > $o ).

tff(pred_def_54668,type,
    v98882: state_type > $o ).

tff(pred_def_54669,type,
    v98878: state_type > $o ).

tff(pred_def_54670,type,
    v98863: ( state_type * $int ) > $o ).

tff(pred_def_54671,type,
    v98861: ( state_type * $int ) > $o ).

tff(pred_def_54672,type,
    v98889: state_type > $o ).

tff(pred_def_54673,type,
    v98888: state_type > $o ).

tff(pred_def_54674,type,
    v98890: state_type > $o ).

tff(pred_def_54675,type,
    v98886: state_type > $o ).

tff(pred_def_54676,type,
    v98884: state_type > $o ).

tff(pred_def_54677,type,
    v98894: state_type > $o ).

tff(pred_def_54678,type,
    v98893: ( state_type * $int ) > $o ).

tff(pred_def_54679,type,
    v98892: ( state_type * $int ) > $o ).

tff(pred_def_54680,type,
    v98898: state_type > $o ).

tff(pred_def_54681,type,
    v98897: ( state_type * $int ) > $o ).

tff(pred_def_54682,type,
    v98896: ( state_type * $int ) > $o ).

tff(pred_def_54683,type,
    v98845: ( state_type * $int ) > $o ).

tff(pred_def_54684,type,
    v98895: ( state_type * $int ) > $o ).

tff(pred_def_54685,type,
    v98859: ( state_type * $int ) > $o ).

tff(pred_def_54686,type,
    v98857: ( state_type * $int ) > $o ).

tff(pred_def_54687,type,
    v98902: state_type > $o ).

tff(pred_def_54688,type,
    v98900: state_type > $o ).

tff(pred_def_54689,type,
    v98909: state_type > $o ).

tff(pred_def_54690,type,
    v98907: state_type > $o ).

tff(pred_def_54691,type,
    v98906: state_type > $o ).

tff(pred_def_54692,type,
    v98905: state_type > $o ).

tff(pred_def_54693,type,
    v98917: state_type > $o ).

tff(pred_def_54694,type,
    v98918: state_type > $o ).

tff(pred_def_54695,type,
    v98916: state_type > $o ).

tff(pred_def_54696,type,
    v98913: ( state_type * $int ) > $o ).

tff(pred_def_54697,type,
    v98915: ( state_type * $int ) > $o ).

tff(pred_def_54698,type,
    v98847: ( state_type * $int ) > $o ).

tff(pred_def_54699,type,
    v98843: ( state_type * $int ) > $o ).

tff(pred_def_54700,type,
    v98841: ( state_type * $int ) > $o ).

tff(pred_def_54701,type,
    v98922: state_type > $o ).

tff(pred_def_54702,type,
    v98926: state_type > $o ).

tff(pred_def_54703,type,
    v98925: ( state_type * $int ) > $o ).

tff(pred_def_54704,type,
    v98924: ( state_type * $int ) > $o ).

tff(pred_def_54705,type,
    v98930: state_type > $o ).

tff(pred_def_54706,type,
    v98929: ( state_type * $int ) > $o ).

tff(pred_def_54707,type,
    v98928: ( state_type * $int ) > $o ).

tff(pred_def_54708,type,
    v98825: ( state_type * $int ) > $o ).

tff(pred_def_54709,type,
    v98927: ( state_type * $int ) > $o ).

tff(pred_def_54710,type,
    v98839: ( state_type * $int ) > $o ).

tff(pred_def_54711,type,
    v98837: ( state_type * $int ) > $o ).

tff(pred_def_54712,type,
    v98934: state_type > $o ).

tff(pred_def_54713,type,
    v98932: state_type > $o ).

tff(pred_def_54714,type,
    v98941: state_type > $o ).

tff(pred_def_54715,type,
    v98939: state_type > $o ).

tff(pred_def_54716,type,
    v98938: state_type > $o ).

tff(pred_def_54717,type,
    v98937: state_type > $o ).

tff(pred_def_54718,type,
    v98949: state_type > $o ).

tff(pred_def_54719,type,
    v98950: state_type > $o ).

tff(pred_def_54720,type,
    v98948: state_type > $o ).

tff(pred_def_54721,type,
    v98945: ( state_type * $int ) > $o ).

tff(pred_def_54722,type,
    v98947: ( state_type * $int ) > $o ).

tff(pred_def_54723,type,
    v98827: ( state_type * $int ) > $o ).

tff(pred_def_54724,type,
    v98821: ( state_type * $int ) > $o ).

tff(pred_def_54725,type,
    v98819: ( state_type * $int ) > $o ).

tff(pred_def_54726,type,
    v98817: ( state_type * $int ) > $o ).

tff(pred_def_54727,type,
    v98958: state_type > $o ).

tff(pred_def_54728,type,
    v98956: state_type > $o ).

tff(pred_def_54729,type,
    v98955: state_type > $o ).

tff(pred_def_54730,type,
    v98954: ( state_type * $int ) > $o ).

tff(pred_def_54731,type,
    v98814: ( state_type * $int ) > $o ).

tff(pred_def_54732,type,
    v98970: state_type > $o ).

tff(pred_def_54733,type,
    v98968: state_type > $o ).

tff(pred_def_54734,type,
    v98974: state_type > $o ).

tff(pred_def_54735,type,
    v98972: state_type > $o ).

tff(pred_def_54736,type,
    v98962: ( state_type * $int ) > $o ).

tff(pred_def_54737,type,
    v98989: state_type > $o ).

tff(pred_def_54738,type,
    v98988: state_type > $o ).

tff(pred_def_54739,type,
    v98987: state_type > $o ).

tff(pred_def_54740,type,
    v98990: state_type > $o ).

tff(pred_def_54741,type,
    v98986: state_type > $o ).

tff(pred_def_54742,type,
    v98991: state_type > $o ).

tff(pred_def_54743,type,
    v98985: state_type > $o ).

tff(pred_def_54744,type,
    v98994: state_type > $o ).

tff(pred_def_54745,type,
    v98995: state_type > $o ).

tff(pred_def_54746,type,
    v98993: state_type > $o ).

tff(pred_def_54747,type,
    v98996: state_type > $o ).

tff(pred_def_54748,type,
    v98992: state_type > $o ).

tff(pred_def_54749,type,
    v98999: state_type > $o ).

tff(pred_def_54750,type,
    v99000: state_type > $o ).

tff(pred_def_54751,type,
    v98998: state_type > $o ).

tff(pred_def_54752,type,
    v99001: state_type > $o ).

tff(pred_def_54753,type,
    v98997: state_type > $o ).

tff(pred_def_54754,type,
    v98982: ( state_type * $int ) > $o ).

tff(pred_def_54755,type,
    v98980: ( state_type * $int ) > $o ).

tff(pred_def_54756,type,
    v99005: state_type > $o ).

tff(pred_def_54757,type,
    v99003: state_type > $o ).

tff(pred_def_54758,type,
    v99010: state_type > $o ).

tff(pred_def_54759,type,
    v99009: ( state_type * $int ) > $o ).

tff(pred_def_54760,type,
    v99008: ( state_type * $int ) > $o ).

tff(pred_def_54761,type,
    v99014: state_type > $o ).

tff(pred_def_54762,type,
    v99013: ( state_type * $int ) > $o ).

tff(pred_def_54763,type,
    v99012: ( state_type * $int ) > $o ).

tff(pred_def_54764,type,
    v98964: ( state_type * $int ) > $o ).

tff(pred_def_54765,type,
    v99011: ( state_type * $int ) > $o ).

tff(pred_def_54766,type,
    v98978: ( state_type * $int ) > $o ).

tff(pred_def_54767,type,
    v98976: ( state_type * $int ) > $o ).

tff(pred_def_54768,type,
    v99018: state_type > $o ).

tff(pred_def_54769,type,
    v99016: state_type > $o ).

tff(pred_def_54770,type,
    v99025: state_type > $o ).

tff(pred_def_54771,type,
    v99023: state_type > $o ).

tff(pred_def_54772,type,
    v99022: state_type > $o ).

tff(pred_def_54773,type,
    v99021: state_type > $o ).

tff(pred_def_54774,type,
    v99033: state_type > $o ).

tff(pred_def_54775,type,
    v99034: state_type > $o ).

tff(pred_def_54776,type,
    v99032: state_type > $o ).

tff(pred_def_54777,type,
    v99029: ( state_type * $int ) > $o ).

tff(pred_def_54778,type,
    v99031: ( state_type * $int ) > $o ).

tff(pred_def_54779,type,
    v98966: ( state_type * $int ) > $o ).

tff(pred_def_54780,type,
    v99047: state_type > $o ).

tff(pred_def_54781,type,
    v99046: state_type > $o ).

tff(pred_def_54782,type,
    v99051: state_type > $o ).

tff(pred_def_54783,type,
    v99050: state_type > $o ).

tff(pred_def_54784,type,
    v99052: state_type > $o ).

tff(pred_def_54785,type,
    v99049: state_type > $o ).

tff(pred_def_54786,type,
    v99048: state_type > $o ).

tff(pred_def_54787,type,
    v99045: state_type > $o ).

tff(pred_def_54788,type,
    v99053: state_type > $o ).

tff(pred_def_54789,type,
    v99044: state_type > $o ).

tff(pred_def_54790,type,
    v99057: state_type > $o ).

tff(pred_def_54791,type,
    v99056: state_type > $o ).

tff(pred_def_54792,type,
    v99058: state_type > $o ).

tff(pred_def_54793,type,
    v99055: state_type > $o ).

tff(pred_def_54794,type,
    v99054: state_type > $o ).

tff(pred_def_54795,type,
    v99043: state_type > $o ).

tff(pred_def_54796,type,
    v99059: state_type > $o ).

tff(pred_def_54797,type,
    v99042: state_type > $o ).

tff(pred_def_54798,type,
    v99063: state_type > $o ).

tff(pred_def_54799,type,
    v99062: state_type > $o ).

tff(pred_def_54800,type,
    v99064: state_type > $o ).

tff(pred_def_54801,type,
    v99061: state_type > $o ).

tff(pred_def_54802,type,
    v99060: state_type > $o ).

tff(pred_def_54803,type,
    v99041: state_type > $o ).

tff(pred_def_54804,type,
    v99065: state_type > $o ).

tff(pred_def_54805,type,
    v99040: state_type > $o ).

tff(pred_def_54806,type,
    v99038: state_type > $o ).

tff(pred_def_54807,type,
    v99075: state_type > $o ).

tff(pred_def_54808,type,
    v99078: state_type > $o ).

tff(pred_def_54809,type,
    v99077: state_type > $o ).

tff(pred_def_54810,type,
    v99079: state_type > $o ).

tff(pred_def_54811,type,
    v99076: state_type > $o ).

tff(pred_def_54812,type,
    v99074: state_type > $o ).

tff(pred_def_54813,type,
    v99080: state_type > $o ).

tff(pred_def_54814,type,
    v99073: state_type > $o ).

tff(pred_def_54815,type,
    v99087: state_type > $o ).

tff(pred_def_54816,type,
    v99086: state_type > $o ).

tff(pred_def_54817,type,
    v99085: state_type > $o ).

tff(pred_def_54818,type,
    v99088: state_type > $o ).

tff(pred_def_54819,type,
    v99084: state_type > $o ).

tff(pred_def_54820,type,
    v99083: state_type > $o ).

tff(pred_def_54821,type,
    v99082: state_type > $o ).

tff(pred_def_54822,type,
    v99089: state_type > $o ).

tff(pred_def_54823,type,
    v99081: state_type > $o ).

tff(pred_def_54824,type,
    v99072: state_type > $o ).

tff(pred_def_54825,type,
    v99090: state_type > $o ).

tff(pred_def_54826,type,
    v99071: state_type > $o ).

tff(pred_def_54827,type,
    v99070: state_type > $o ).

tff(pred_def_54828,type,
    v99098: state_type > $o ).

tff(pred_def_54829,type,
    v99097: state_type > $o ).

tff(pred_def_54830,type,
    v99096: state_type > $o ).

tff(pred_def_54831,type,
    v99099: state_type > $o ).

tff(pred_def_54832,type,
    v99095: state_type > $o ).

tff(pred_def_54833,type,
    v99094: state_type > $o ).

tff(pred_def_54834,type,
    v99093: state_type > $o ).

tff(pred_def_54835,type,
    v99100: state_type > $o ).

tff(pred_def_54836,type,
    v99092: state_type > $o ).

tff(pred_def_54837,type,
    v99091: state_type > $o ).

tff(pred_def_54838,type,
    v99069: state_type > $o ).

tff(pred_def_54839,type,
    v99101: state_type > $o ).

tff(pred_def_54840,type,
    v99068: state_type > $o ).

tff(pred_def_54841,type,
    v99104: state_type > $o ).

tff(pred_def_54842,type,
    v99105: state_type > $o ).

tff(pred_def_54843,type,
    v99103: state_type > $o ).

tff(pred_def_54844,type,
    v99106: state_type > $o ).

tff(pred_def_54845,type,
    v99102: state_type > $o ).

tff(pred_def_54846,type,
    v99109: state_type > $o ).

tff(pred_def_54847,type,
    v99110: state_type > $o ).

tff(pred_def_54848,type,
    v99108: state_type > $o ).

tff(pred_def_54849,type,
    v99111: state_type > $o ).

tff(pred_def_54850,type,
    v99107: state_type > $o ).

tff(pred_def_54851,type,
    v99113: state_type > $o ).

tff(pred_def_54852,type,
    v99114: state_type > $o ).

tff(pred_def_54853,type,
    v99112: state_type > $o ).

tff(pred_def_54854,type,
    v99066: ( state_type * $int ) > $o ).

tff(pred_def_54855,type,
    v99136: state_type > $o ).

tff(pred_def_54856,type,
    v99137: state_type > $o ).

tff(pred_def_54857,type,
    v99135: state_type > $o ).

tff(pred_def_54858,type,
    v99134: state_type > $o ).

tff(pred_def_54859,type,
    v99133: state_type > $o ).

tff(pred_def_54860,type,
    v99138: state_type > $o ).

tff(pred_def_54861,type,
    v99132: state_type > $o ).

tff(pred_def_54862,type,
    v99131: state_type > $o ).

tff(pred_def_54863,type,
    v99139: state_type > $o ).

tff(pred_def_54864,type,
    v99130: state_type > $o ).

tff(pred_def_54865,type,
    v99146: state_type > $o ).

tff(pred_def_54866,type,
    v99145: state_type > $o ).

tff(pred_def_54867,type,
    v99144: state_type > $o ).

tff(pred_def_54868,type,
    v99147: state_type > $o ).

tff(pred_def_54869,type,
    v99143: state_type > $o ).

tff(pred_def_54870,type,
    v99142: state_type > $o ).

tff(pred_def_54871,type,
    v99141: state_type > $o ).

tff(pred_def_54872,type,
    v99148: state_type > $o ).

tff(pred_def_54873,type,
    v99140: state_type > $o ).

tff(pred_def_54874,type,
    v99129: state_type > $o ).

tff(pred_def_54875,type,
    v99149: state_type > $o ).

tff(pred_def_54876,type,
    v99128: state_type > $o ).

tff(pred_def_54877,type,
    v99127: state_type > $o ).

tff(pred_def_54878,type,
    v99157: state_type > $o ).

tff(pred_def_54879,type,
    v99156: state_type > $o ).

tff(pred_def_54880,type,
    v99155: state_type > $o ).

tff(pred_def_54881,type,
    v99158: state_type > $o ).

tff(pred_def_54882,type,
    v99154: state_type > $o ).

tff(pred_def_54883,type,
    v99153: state_type > $o ).

tff(pred_def_54884,type,
    v99152: state_type > $o ).

tff(pred_def_54885,type,
    v99159: state_type > $o ).

tff(pred_def_54886,type,
    v99151: state_type > $o ).

tff(pred_def_54887,type,
    v99150: state_type > $o ).

tff(pred_def_54888,type,
    v99126: state_type > $o ).

tff(pred_def_54889,type,
    v99160: state_type > $o ).

tff(pred_def_54890,type,
    v99125: state_type > $o ).

tff(pred_def_54891,type,
    v99163: state_type > $o ).

tff(pred_def_54892,type,
    v99164: state_type > $o ).

tff(pred_def_54893,type,
    v99162: state_type > $o ).

tff(pred_def_54894,type,
    v99165: state_type > $o ).

tff(pred_def_54895,type,
    v99161: state_type > $o ).

tff(pred_def_54896,type,
    v99168: state_type > $o ).

tff(pred_def_54897,type,
    v99167: state_type > $o ).

tff(pred_def_54898,type,
    v99169: state_type > $o ).

tff(pred_def_54899,type,
    v99166: state_type > $o ).

tff(pred_def_54900,type,
    v99123: ( state_type * $int ) > $o ).

tff(pred_def_54901,type,
    v99122: ( state_type * $int ) > $o ).

tff(pred_def_54902,type,
    v99121: state_type > $o ).

tff(pred_def_54903,type,
    v99120: state_type > $o ).

tff(pred_def_54904,type,
    v99119: state_type > $o ).

tff(pred_def_54905,type,
    v99170: state_type > $o ).

tff(pred_def_54906,type,
    v99118: state_type > $o ).

tff(pred_def_54907,type,
    v99171: state_type > $o ).

tff(pred_def_54908,type,
    v99117: state_type > $o ).

tff(pred_def_54909,type,
    v99174: state_type > $o ).

tff(pred_def_54910,type,
    v99175: state_type > $o ).

tff(pred_def_54911,type,
    v99173: state_type > $o ).

tff(pred_def_54912,type,
    v99176: state_type > $o ).

tff(pred_def_54913,type,
    v99172: state_type > $o ).

tff(pred_def_54914,type,
    v99179: state_type > $o ).

tff(pred_def_54915,type,
    v99180: state_type > $o ).

tff(pred_def_54916,type,
    v99178: state_type > $o ).

tff(pred_def_54917,type,
    v99181: state_type > $o ).

tff(pred_def_54918,type,
    v99177: state_type > $o ).

tff(pred_def_54919,type,
    v99115: ( state_type * $int ) > $o ).

tff(pred_def_54920,type,
    v98812: ( state_type * $int ) > $o ).

tff(pred_def_54921,type,
    v99197: state_type > $o ).

tff(pred_def_54922,type,
    v99196: ( state_type * $int ) > $o ).

tff(pred_def_54923,type,
    v99195: ( state_type * $int ) > $o ).

tff(pred_def_54924,type,
    v99201: state_type > $o ).

tff(pred_def_54925,type,
    v99200: state_type > $o ).

tff(pred_def_54926,type,
    v99199: ( state_type * $int ) > $o ).

tff(pred_def_54927,type,
    v99198: ( state_type * $int ) > $o ).

tff(pred_def_54928,type,
    v99194: ( state_type * $int ) > $o ).

tff(pred_def_54929,type,
    v99193: ( state_type * $int ) > $o ).

tff(pred_def_54930,type,
    v99205: state_type > $o ).

tff(pred_def_54931,type,
    v99204: state_type > $o ).

tff(pred_def_54932,type,
    v99203: ( state_type * $int ) > $o ).

tff(pred_def_54933,type,
    v99202: ( state_type * $int ) > $o ).

tff(pred_def_54934,type,
    v99192: ( state_type * $int ) > $o ).

tff(pred_def_54935,type,
    v99191: ( state_type * $int ) > $o ).

tff(pred_def_54936,type,
    v99209: state_type > $o ).

tff(pred_def_54937,type,
    v99208: state_type > $o ).

tff(pred_def_54938,type,
    v99207: ( state_type * $int ) > $o ).

tff(pred_def_54939,type,
    v99206: ( state_type * $int ) > $o ).

tff(pred_def_54940,type,
    v99190: ( state_type * $int ) > $o ).

tff(pred_def_54941,type,
    v99189: ( state_type * $int ) > $o ).

tff(pred_def_54942,type,
    v99213: state_type > $o ).

tff(pred_def_54943,type,
    v99212: state_type > $o ).

tff(pred_def_54944,type,
    v99211: ( state_type * $int ) > $o ).

tff(pred_def_54945,type,
    v99210: ( state_type * $int ) > $o ).

tff(pred_def_54946,type,
    v99188: ( state_type * $int ) > $o ).

tff(pred_def_54947,type,
    v99187: ( state_type * $int ) > $o ).

tff(pred_def_54948,type,
    v99217: state_type > $o ).

tff(pred_def_54949,type,
    v99216: state_type > $o ).

tff(pred_def_54950,type,
    v99215: ( state_type * $int ) > $o ).

tff(pred_def_54951,type,
    v99214: ( state_type * $int ) > $o ).

tff(pred_def_54952,type,
    v99186: ( state_type * $int ) > $o ).

tff(pred_def_54953,type,
    v99185: ( state_type * $int ) > $o ).

tff(pred_def_54954,type,
    v99221: state_type > $o ).

tff(pred_def_54955,type,
    v99220: state_type > $o ).

tff(pred_def_54956,type,
    v99219: ( state_type * $int ) > $o ).

tff(pred_def_54957,type,
    v99218: ( state_type * $int ) > $o ).

tff(pred_def_54958,type,
    v99184: ( state_type * $int ) > $o ).

tff(pred_def_54959,type,
    v99224: state_type > $o ).

tff(pred_def_54960,type,
    v99223: state_type > $o ).

tff(pred_def_54961,type,
    v99222: ( state_type * $int ) > $o ).

tff(pred_def_54962,type,
    v99183: ( state_type * $int ) > $o ).

tff(pred_def_54963,type,
    v98639: ( state_type * $int ) > $o ).

tff(pred_def_54964,type,
    v98637: ( state_type * $int ) > $o ).

tff(pred_def_54965,type,
    v98635: ( state_type * $int ) > $o ).

tff(pred_def_54966,type,
    v99242: state_type > $o ).

tff(pred_def_54967,type,
    v99240: state_type > $o ).

tff(pred_def_54968,type,
    v99246: state_type > $o ).

tff(pred_def_54969,type,
    v99244: state_type > $o ).

tff(pred_def_54970,type,
    v99266: state_type > $o ).

tff(pred_def_54971,type,
    v99265: state_type > $o ).

tff(pred_def_54972,type,
    v99264: state_type > $o ).

tff(pred_def_54973,type,
    v99263: state_type > $o ).

tff(pred_def_54974,type,
    v99262: state_type > $o ).

tff(pred_def_54975,type,
    v99261: state_type > $o ).

tff(pred_def_54976,type,
    v99258: state_type > $o ).

tff(pred_def_54977,type,
    v99269: state_type > $o ).

tff(pred_def_54978,type,
    v99268: state_type > $o ).

tff(pred_def_54979,type,
    v99270: state_type > $o ).

tff(pred_def_54980,type,
    v99256: state_type > $o ).

tff(pred_def_54981,type,
    v99281: state_type > $o ).

tff(pred_def_54982,type,
    v99282: state_type > $o ).

tff(pred_def_54983,type,
    v99280: state_type > $o ).

tff(pred_def_54984,type,
    v99284: state_type > $o ).

tff(pred_def_54985,type,
    v99285: state_type > $o ).

tff(pred_def_54986,type,
    v99283: state_type > $o ).

tff(pred_def_54987,type,
    v99278: ( state_type * $int ) > $o ).

tff(pred_def_54988,type,
    v99276: ( state_type * $int ) > $o ).

tff(pred_def_54989,type,
    v99274: ( state_type * $int ) > $o ).

tff(pred_def_54990,type,
    v99272: ( state_type * $int ) > $o ).

tff(pred_def_54991,type,
    v99296: state_type > $o ).

tff(pred_def_54992,type,
    v99295: state_type > $o ).

tff(pred_def_54993,type,
    v99294: state_type > $o ).

tff(pred_def_54994,type,
    v99293: state_type > $o ).

tff(pred_def_54995,type,
    v99292: state_type > $o ).

tff(pred_def_54996,type,
    v99291: state_type > $o ).

tff(pred_def_54997,type,
    v99289: state_type > $o ).

tff(pred_def_54998,type,
    v99288: state_type > $o ).

tff(pred_def_54999,type,
    v99287: state_type > $o ).

tff(pred_def_55000,type,
    v99234: ( state_type * $int ) > $o ).

tff(pred_def_55001,type,
    v99303: state_type > $o ).

tff(pred_def_55002,type,
    v99302: state_type > $o ).

tff(pred_def_55003,type,
    v99301: state_type > $o ).

tff(pred_def_55004,type,
    v99304: state_type > $o ).

tff(pred_def_55005,type,
    v99300: state_type > $o ).

tff(pred_def_55006,type,
    v99305: state_type > $o ).

tff(pred_def_55007,type,
    v99299: state_type > $o ).

tff(pred_def_55008,type,
    v99308: state_type > $o ).

tff(pred_def_55009,type,
    v99309: state_type > $o ).

tff(pred_def_55010,type,
    v99307: state_type > $o ).

tff(pred_def_55011,type,
    v99310: state_type > $o ).

tff(pred_def_55012,type,
    v99306: state_type > $o ).

tff(pred_def_55013,type,
    v99313: state_type > $o ).

tff(pred_def_55014,type,
    v99314: state_type > $o ).

tff(pred_def_55015,type,
    v99312: state_type > $o ).

tff(pred_def_55016,type,
    v99315: state_type > $o ).

tff(pred_def_55017,type,
    v99311: state_type > $o ).

tff(pred_def_55018,type,
    v99297: ( state_type * $int ) > $o ).

tff(pred_def_55019,type,
    v99318: state_type > $o ).

tff(pred_def_55020,type,
    v99319: state_type > $o ).

tff(pred_def_55021,type,
    v99317: state_type > $o ).

tff(pred_def_55022,type,
    v99328: state_type > $o ).

tff(pred_def_55023,type,
    v99327: state_type > $o ).

tff(pred_def_55024,type,
    v99326: state_type > $o ).

tff(pred_def_55025,type,
    v99325: state_type > $o ).

tff(pred_def_55026,type,
    v99324: state_type > $o ).

tff(pred_def_55027,type,
    v99323: state_type > $o ).

tff(pred_def_55028,type,
    v99329: state_type > $o ).

tff(pred_def_55029,type,
    v99322: state_type > $o ).

tff(pred_def_55030,type,
    v99332: state_type > $o ).

tff(pred_def_55031,type,
    v99331: state_type > $o ).

tff(pred_def_55032,type,
    v99333: state_type > $o ).

tff(pred_def_55033,type,
    v99330: state_type > $o ).

tff(pred_def_55034,type,
    v99335: state_type > $o ).

tff(pred_def_55035,type,
    v99336: state_type > $o ).

tff(pred_def_55036,type,
    v99334: state_type > $o ).

tff(pred_def_55037,type,
    v99320: ( state_type * $int ) > $o ).

tff(pred_def_55038,type,
    v99316: ( state_type * $int ) > $o ).

tff(pred_def_55039,type,
    v99254: ( state_type * $int ) > $o ).

tff(pred_def_55040,type,
    v99252: ( state_type * $int ) > $o ).

tff(pred_def_55041,type,
    v99250: ( state_type * $int ) > $o ).

tff(pred_def_55042,type,
    v99248: ( state_type * $int ) > $o ).

tff(pred_def_55043,type,
    v99340: state_type > $o ).

tff(pred_def_55044,type,
    v99338: state_type > $o ).

tff(pred_def_55045,type,
    v99347: state_type > $o ).

tff(pred_def_55046,type,
    v99345: state_type > $o ).

tff(pred_def_55047,type,
    v99344: state_type > $o ).

tff(pred_def_55048,type,
    v99343: state_type > $o ).

tff(pred_def_55049,type,
    v99355: state_type > $o ).

tff(pred_def_55050,type,
    v99356: state_type > $o ).

tff(pred_def_55051,type,
    v99354: state_type > $o ).

tff(pred_def_55052,type,
    v99351: ( state_type * $int ) > $o ).

tff(pred_def_55053,type,
    v99353: ( state_type * $int ) > $o ).

tff(pred_def_55054,type,
    v99238: ( state_type * $int ) > $o ).

tff(pred_def_55055,type,
    v99236: ( state_type * $int ) > $o ).

tff(pred_def_55056,type,
    v99373: state_type > $o ).

tff(pred_def_55057,type,
    v99372: ( state_type * $int ) > $o ).

tff(pred_def_55058,type,
    v99371: ( state_type * $int ) > $o ).

tff(pred_def_55059,type,
    v99377: state_type > $o ).

tff(pred_def_55060,type,
    v99376: state_type > $o ).

tff(pred_def_55061,type,
    v99375: ( state_type * $int ) > $o ).

tff(pred_def_55062,type,
    v99374: ( state_type * $int ) > $o ).

tff(pred_def_55063,type,
    v99370: ( state_type * $int ) > $o ).

tff(pred_def_55064,type,
    v99369: ( state_type * $int ) > $o ).

tff(pred_def_55065,type,
    v99381: state_type > $o ).

tff(pred_def_55066,type,
    v99380: state_type > $o ).

tff(pred_def_55067,type,
    v99379: ( state_type * $int ) > $o ).

tff(pred_def_55068,type,
    v99378: ( state_type * $int ) > $o ).

tff(pred_def_55069,type,
    v99368: ( state_type * $int ) > $o ).

tff(pred_def_55070,type,
    v99367: ( state_type * $int ) > $o ).

tff(pred_def_55071,type,
    v99385: state_type > $o ).

tff(pred_def_55072,type,
    v99384: state_type > $o ).

tff(pred_def_55073,type,
    v99383: ( state_type * $int ) > $o ).

tff(pred_def_55074,type,
    v99382: ( state_type * $int ) > $o ).

tff(pred_def_55075,type,
    v99366: ( state_type * $int ) > $o ).

tff(pred_def_55076,type,
    v99365: ( state_type * $int ) > $o ).

tff(pred_def_55077,type,
    v99389: state_type > $o ).

tff(pred_def_55078,type,
    v99388: state_type > $o ).

tff(pred_def_55079,type,
    v99387: ( state_type * $int ) > $o ).

tff(pred_def_55080,type,
    v99386: ( state_type * $int ) > $o ).

tff(pred_def_55081,type,
    v99364: ( state_type * $int ) > $o ).

tff(pred_def_55082,type,
    v99363: ( state_type * $int ) > $o ).

tff(pred_def_55083,type,
    v99393: state_type > $o ).

tff(pred_def_55084,type,
    v99392: state_type > $o ).

tff(pred_def_55085,type,
    v99391: ( state_type * $int ) > $o ).

tff(pred_def_55086,type,
    v99390: ( state_type * $int ) > $o ).

tff(pred_def_55087,type,
    v99362: ( state_type * $int ) > $o ).

tff(pred_def_55088,type,
    v99361: ( state_type * $int ) > $o ).

tff(pred_def_55089,type,
    v99397: state_type > $o ).

tff(pred_def_55090,type,
    v99396: state_type > $o ).

tff(pred_def_55091,type,
    v99395: ( state_type * $int ) > $o ).

tff(pred_def_55092,type,
    v99394: ( state_type * $int ) > $o ).

tff(pred_def_55093,type,
    v99360: ( state_type * $int ) > $o ).

tff(pred_def_55094,type,
    v99400: state_type > $o ).

tff(pred_def_55095,type,
    v99399: state_type > $o ).

tff(pred_def_55096,type,
    v99398: ( state_type * $int ) > $o ).

tff(pred_def_55097,type,
    v99232: ( state_type * $int ) > $o ).

tff(pred_def_55098,type,
    v99421: state_type > $o ).

tff(pred_def_55099,type,
    v99419: state_type > $o ).

tff(pred_def_55100,type,
    v99425: state_type > $o ).

tff(pred_def_55101,type,
    v99423: state_type > $o ).

tff(pred_def_55102,type,
    v99441: state_type > $o ).

tff(pred_def_55103,type,
    v99439: state_type > $o ).

tff(pred_def_55104,type,
    v99445: state_type > $o ).

tff(pred_def_55105,type,
    v99443: state_type > $o ).

tff(pred_def_55106,type,
    v99413: ( state_type * $int ) > $o ).

tff(pred_def_55107,type,
    v99460: state_type > $o ).

tff(pred_def_55108,type,
    v99459: state_type > $o ).

tff(pred_def_55109,type,
    v99458: state_type > $o ).

tff(pred_def_55110,type,
    v99461: state_type > $o ).

tff(pred_def_55111,type,
    v99457: state_type > $o ).

tff(pred_def_55112,type,
    v99462: state_type > $o ).

tff(pred_def_55113,type,
    v99456: state_type > $o ).

tff(pred_def_55114,type,
    v99465: state_type > $o ).

tff(pred_def_55115,type,
    v99466: state_type > $o ).

tff(pred_def_55116,type,
    v99464: state_type > $o ).

tff(pred_def_55117,type,
    v99467: state_type > $o ).

tff(pred_def_55118,type,
    v99463: state_type > $o ).

tff(pred_def_55119,type,
    v99470: state_type > $o ).

tff(pred_def_55120,type,
    v99471: state_type > $o ).

tff(pred_def_55121,type,
    v99469: state_type > $o ).

tff(pred_def_55122,type,
    v99472: state_type > $o ).

tff(pred_def_55123,type,
    v99468: state_type > $o ).

tff(pred_def_55124,type,
    v99453: ( state_type * $int ) > $o ).

tff(pred_def_55125,type,
    v99451: ( state_type * $int ) > $o ).

tff(pred_def_55126,type,
    v99479: state_type > $o ).

tff(pred_def_55127,type,
    v99478: state_type > $o ).

tff(pred_def_55128,type,
    v99480: state_type > $o ).

tff(pred_def_55129,type,
    v99476: state_type > $o ).

tff(pred_def_55130,type,
    v99474: state_type > $o ).

tff(pred_def_55131,type,
    v99484: state_type > $o ).

tff(pred_def_55132,type,
    v99483: ( state_type * $int ) > $o ).

tff(pred_def_55133,type,
    v99482: ( state_type * $int ) > $o ).

tff(pred_def_55134,type,
    v99488: state_type > $o ).

tff(pred_def_55135,type,
    v99487: ( state_type * $int ) > $o ).

tff(pred_def_55136,type,
    v99486: ( state_type * $int ) > $o ).

tff(pred_def_55137,type,
    v99435: ( state_type * $int ) > $o ).

tff(pred_def_55138,type,
    v99485: ( state_type * $int ) > $o ).

tff(pred_def_55139,type,
    v99449: ( state_type * $int ) > $o ).

tff(pred_def_55140,type,
    v99447: ( state_type * $int ) > $o ).

tff(pred_def_55141,type,
    v99492: state_type > $o ).

tff(pred_def_55142,type,
    v99490: state_type > $o ).

tff(pred_def_55143,type,
    v99499: state_type > $o ).

tff(pred_def_55144,type,
    v99497: state_type > $o ).

tff(pred_def_55145,type,
    v99496: state_type > $o ).

tff(pred_def_55146,type,
    v99495: state_type > $o ).

tff(pred_def_55147,type,
    v99507: state_type > $o ).

tff(pred_def_55148,type,
    v99508: state_type > $o ).

tff(pred_def_55149,type,
    v99506: state_type > $o ).

tff(pred_def_55150,type,
    v99503: ( state_type * $int ) > $o ).

tff(pred_def_55151,type,
    v99505: ( state_type * $int ) > $o ).

tff(pred_def_55152,type,
    v99437: ( state_type * $int ) > $o ).

tff(pred_def_55153,type,
    v99433: ( state_type * $int ) > $o ).

tff(pred_def_55154,type,
    v99431: ( state_type * $int ) > $o ).

tff(pred_def_55155,type,
    v99512: state_type > $o ).

tff(pred_def_55156,type,
    v99516: state_type > $o ).

tff(pred_def_55157,type,
    v99515: ( state_type * $int ) > $o ).

tff(pred_def_55158,type,
    v99514: ( state_type * $int ) > $o ).

tff(pred_def_55159,type,
    v99520: state_type > $o ).

tff(pred_def_55160,type,
    v99519: ( state_type * $int ) > $o ).

tff(pred_def_55161,type,
    v99518: ( state_type * $int ) > $o ).

tff(pred_def_55162,type,
    v99415: ( state_type * $int ) > $o ).

tff(pred_def_55163,type,
    v99517: ( state_type * $int ) > $o ).

tff(pred_def_55164,type,
    v99429: ( state_type * $int ) > $o ).

tff(pred_def_55165,type,
    v99427: ( state_type * $int ) > $o ).

tff(pred_def_55166,type,
    v99524: state_type > $o ).

tff(pred_def_55167,type,
    v99522: state_type > $o ).

tff(pred_def_55168,type,
    v99531: state_type > $o ).

tff(pred_def_55169,type,
    v99529: state_type > $o ).

tff(pred_def_55170,type,
    v99528: state_type > $o ).

tff(pred_def_55171,type,
    v99527: state_type > $o ).

tff(pred_def_55172,type,
    v99539: state_type > $o ).

tff(pred_def_55173,type,
    v99540: state_type > $o ).

tff(pred_def_55174,type,
    v99538: state_type > $o ).

tff(pred_def_55175,type,
    v99535: ( state_type * $int ) > $o ).

tff(pred_def_55176,type,
    v99537: ( state_type * $int ) > $o ).

tff(pred_def_55177,type,
    v99417: ( state_type * $int ) > $o ).

tff(pred_def_55178,type,
    v99411: ( state_type * $int ) > $o ).

tff(pred_def_55179,type,
    v99409: ( state_type * $int ) > $o ).

tff(pred_def_55180,type,
    v99407: ( state_type * $int ) > $o ).

tff(pred_def_55181,type,
    v99548: state_type > $o ).

tff(pred_def_55182,type,
    v99546: state_type > $o ).

tff(pred_def_55183,type,
    v99545: state_type > $o ).

tff(pred_def_55184,type,
    v99544: ( state_type * $int ) > $o ).

tff(pred_def_55185,type,
    v99404: ( state_type * $int ) > $o ).

tff(pred_def_55186,type,
    v99560: state_type > $o ).

tff(pred_def_55187,type,
    v99558: state_type > $o ).

tff(pred_def_55188,type,
    v99564: state_type > $o ).

tff(pred_def_55189,type,
    v99562: state_type > $o ).

tff(pred_def_55190,type,
    v99552: ( state_type * $int ) > $o ).

tff(pred_def_55191,type,
    v99579: state_type > $o ).

tff(pred_def_55192,type,
    v99578: state_type > $o ).

tff(pred_def_55193,type,
    v99577: state_type > $o ).

tff(pred_def_55194,type,
    v99580: state_type > $o ).

tff(pred_def_55195,type,
    v99576: state_type > $o ).

tff(pred_def_55196,type,
    v99581: state_type > $o ).

tff(pred_def_55197,type,
    v99575: state_type > $o ).

tff(pred_def_55198,type,
    v99584: state_type > $o ).

tff(pred_def_55199,type,
    v99585: state_type > $o ).

tff(pred_def_55200,type,
    v99583: state_type > $o ).

tff(pred_def_55201,type,
    v99586: state_type > $o ).

tff(pred_def_55202,type,
    v99582: state_type > $o ).

tff(pred_def_55203,type,
    v99589: state_type > $o ).

tff(pred_def_55204,type,
    v99590: state_type > $o ).

tff(pred_def_55205,type,
    v99588: state_type > $o ).

tff(pred_def_55206,type,
    v99591: state_type > $o ).

tff(pred_def_55207,type,
    v99587: state_type > $o ).

tff(pred_def_55208,type,
    v99572: ( state_type * $int ) > $o ).

tff(pred_def_55209,type,
    v99570: ( state_type * $int ) > $o ).

tff(pred_def_55210,type,
    v99595: state_type > $o ).

tff(pred_def_55211,type,
    v99593: state_type > $o ).

tff(pred_def_55212,type,
    v99600: state_type > $o ).

tff(pred_def_55213,type,
    v99599: ( state_type * $int ) > $o ).

tff(pred_def_55214,type,
    v99598: ( state_type * $int ) > $o ).

tff(pred_def_55215,type,
    v99604: state_type > $o ).

tff(pred_def_55216,type,
    v99603: ( state_type * $int ) > $o ).

tff(pred_def_55217,type,
    v99602: ( state_type * $int ) > $o ).

tff(pred_def_55218,type,
    v99554: ( state_type * $int ) > $o ).

tff(pred_def_55219,type,
    v99601: ( state_type * $int ) > $o ).

tff(pred_def_55220,type,
    v99568: ( state_type * $int ) > $o ).

tff(pred_def_55221,type,
    v99566: ( state_type * $int ) > $o ).

tff(pred_def_55222,type,
    v99608: state_type > $o ).

tff(pred_def_55223,type,
    v99606: state_type > $o ).

tff(pred_def_55224,type,
    v99615: state_type > $o ).

tff(pred_def_55225,type,
    v99613: state_type > $o ).

tff(pred_def_55226,type,
    v99612: state_type > $o ).

tff(pred_def_55227,type,
    v99611: state_type > $o ).

tff(pred_def_55228,type,
    v99623: state_type > $o ).

tff(pred_def_55229,type,
    v99624: state_type > $o ).

tff(pred_def_55230,type,
    v99622: state_type > $o ).

tff(pred_def_55231,type,
    v99619: ( state_type * $int ) > $o ).

tff(pred_def_55232,type,
    v99621: ( state_type * $int ) > $o ).

tff(pred_def_55233,type,
    v99556: ( state_type * $int ) > $o ).

tff(pred_def_55234,type,
    v99637: state_type > $o ).

tff(pred_def_55235,type,
    v99636: state_type > $o ).

tff(pred_def_55236,type,
    v99641: state_type > $o ).

tff(pred_def_55237,type,
    v99640: state_type > $o ).

tff(pred_def_55238,type,
    v99642: state_type > $o ).

tff(pred_def_55239,type,
    v99639: state_type > $o ).

tff(pred_def_55240,type,
    v99638: state_type > $o ).

tff(pred_def_55241,type,
    v99635: state_type > $o ).

tff(pred_def_55242,type,
    v99643: state_type > $o ).

tff(pred_def_55243,type,
    v99634: state_type > $o ).

tff(pred_def_55244,type,
    v99647: state_type > $o ).

tff(pred_def_55245,type,
    v99646: state_type > $o ).

tff(pred_def_55246,type,
    v99648: state_type > $o ).

tff(pred_def_55247,type,
    v99645: state_type > $o ).

tff(pred_def_55248,type,
    v99644: state_type > $o ).

tff(pred_def_55249,type,
    v99633: state_type > $o ).

tff(pred_def_55250,type,
    v99649: state_type > $o ).

tff(pred_def_55251,type,
    v99632: state_type > $o ).

tff(pred_def_55252,type,
    v99653: state_type > $o ).

tff(pred_def_55253,type,
    v99652: state_type > $o ).

tff(pred_def_55254,type,
    v99654: state_type > $o ).

tff(pred_def_55255,type,
    v99651: state_type > $o ).

tff(pred_def_55256,type,
    v99650: state_type > $o ).

tff(pred_def_55257,type,
    v99631: state_type > $o ).

tff(pred_def_55258,type,
    v99655: state_type > $o ).

tff(pred_def_55259,type,
    v99630: state_type > $o ).

tff(pred_def_55260,type,
    v99628: state_type > $o ).

tff(pred_def_55261,type,
    v99665: state_type > $o ).

tff(pred_def_55262,type,
    v99668: state_type > $o ).

tff(pred_def_55263,type,
    v99667: state_type > $o ).

tff(pred_def_55264,type,
    v99669: state_type > $o ).

tff(pred_def_55265,type,
    v99666: state_type > $o ).

tff(pred_def_55266,type,
    v99664: state_type > $o ).

tff(pred_def_55267,type,
    v99670: state_type > $o ).

tff(pred_def_55268,type,
    v99663: state_type > $o ).

tff(pred_def_55269,type,
    v99677: state_type > $o ).

tff(pred_def_55270,type,
    v99676: state_type > $o ).

tff(pred_def_55271,type,
    v99675: state_type > $o ).

tff(pred_def_55272,type,
    v99678: state_type > $o ).

tff(pred_def_55273,type,
    v99674: state_type > $o ).

tff(pred_def_55274,type,
    v99673: state_type > $o ).

tff(pred_def_55275,type,
    v99672: state_type > $o ).

tff(pred_def_55276,type,
    v99679: state_type > $o ).

tff(pred_def_55277,type,
    v99671: state_type > $o ).

tff(pred_def_55278,type,
    v99662: state_type > $o ).

tff(pred_def_55279,type,
    v99680: state_type > $o ).

tff(pred_def_55280,type,
    v99661: state_type > $o ).

tff(pred_def_55281,type,
    v99660: state_type > $o ).

tff(pred_def_55282,type,
    v99688: state_type > $o ).

tff(pred_def_55283,type,
    v99687: state_type > $o ).

tff(pred_def_55284,type,
    v99686: state_type > $o ).

tff(pred_def_55285,type,
    v99689: state_type > $o ).

tff(pred_def_55286,type,
    v99685: state_type > $o ).

tff(pred_def_55287,type,
    v99684: state_type > $o ).

tff(pred_def_55288,type,
    v99683: state_type > $o ).

tff(pred_def_55289,type,
    v99690: state_type > $o ).

tff(pred_def_55290,type,
    v99682: state_type > $o ).

tff(pred_def_55291,type,
    v99681: state_type > $o ).

tff(pred_def_55292,type,
    v99659: state_type > $o ).

tff(pred_def_55293,type,
    v99691: state_type > $o ).

tff(pred_def_55294,type,
    v99658: state_type > $o ).

tff(pred_def_55295,type,
    v99694: state_type > $o ).

tff(pred_def_55296,type,
    v99695: state_type > $o ).

tff(pred_def_55297,type,
    v99693: state_type > $o ).

tff(pred_def_55298,type,
    v99696: state_type > $o ).

tff(pred_def_55299,type,
    v99692: state_type > $o ).

tff(pred_def_55300,type,
    v99699: state_type > $o ).

tff(pred_def_55301,type,
    v99700: state_type > $o ).

tff(pred_def_55302,type,
    v99698: state_type > $o ).

tff(pred_def_55303,type,
    v99701: state_type > $o ).

tff(pred_def_55304,type,
    v99697: state_type > $o ).

tff(pred_def_55305,type,
    v99703: state_type > $o ).

tff(pred_def_55306,type,
    v99704: state_type > $o ).

tff(pred_def_55307,type,
    v99702: state_type > $o ).

tff(pred_def_55308,type,
    v99656: ( state_type * $int ) > $o ).

tff(pred_def_55309,type,
    v99726: state_type > $o ).

tff(pred_def_55310,type,
    v99727: state_type > $o ).

tff(pred_def_55311,type,
    v99725: state_type > $o ).

tff(pred_def_55312,type,
    v99724: state_type > $o ).

tff(pred_def_55313,type,
    v99723: state_type > $o ).

tff(pred_def_55314,type,
    v99728: state_type > $o ).

tff(pred_def_55315,type,
    v99722: state_type > $o ).

tff(pred_def_55316,type,
    v99721: state_type > $o ).

tff(pred_def_55317,type,
    v99729: state_type > $o ).

tff(pred_def_55318,type,
    v99720: state_type > $o ).

tff(pred_def_55319,type,
    v99736: state_type > $o ).

tff(pred_def_55320,type,
    v99735: state_type > $o ).

tff(pred_def_55321,type,
    v99734: state_type > $o ).

tff(pred_def_55322,type,
    v99737: state_type > $o ).

tff(pred_def_55323,type,
    v99733: state_type > $o ).

tff(pred_def_55324,type,
    v99732: state_type > $o ).

tff(pred_def_55325,type,
    v99731: state_type > $o ).

tff(pred_def_55326,type,
    v99738: state_type > $o ).

tff(pred_def_55327,type,
    v99730: state_type > $o ).

tff(pred_def_55328,type,
    v99719: state_type > $o ).

tff(pred_def_55329,type,
    v99739: state_type > $o ).

tff(pred_def_55330,type,
    v99718: state_type > $o ).

tff(pred_def_55331,type,
    v99717: state_type > $o ).

tff(pred_def_55332,type,
    v99747: state_type > $o ).

tff(pred_def_55333,type,
    v99746: state_type > $o ).

tff(pred_def_55334,type,
    v99745: state_type > $o ).

tff(pred_def_55335,type,
    v99748: state_type > $o ).

tff(pred_def_55336,type,
    v99744: state_type > $o ).

tff(pred_def_55337,type,
    v99743: state_type > $o ).

tff(pred_def_55338,type,
    v99742: state_type > $o ).

tff(pred_def_55339,type,
    v99749: state_type > $o ).

tff(pred_def_55340,type,
    v99741: state_type > $o ).

tff(pred_def_55341,type,
    v99740: state_type > $o ).

tff(pred_def_55342,type,
    v99716: state_type > $o ).

tff(pred_def_55343,type,
    v99750: state_type > $o ).

tff(pred_def_55344,type,
    v99715: state_type > $o ).

tff(pred_def_55345,type,
    v99753: state_type > $o ).

tff(pred_def_55346,type,
    v99754: state_type > $o ).

tff(pred_def_55347,type,
    v99752: state_type > $o ).

tff(pred_def_55348,type,
    v99755: state_type > $o ).

tff(pred_def_55349,type,
    v99751: state_type > $o ).

tff(pred_def_55350,type,
    v99758: state_type > $o ).

tff(pred_def_55351,type,
    v99757: state_type > $o ).

tff(pred_def_55352,type,
    v99759: state_type > $o ).

tff(pred_def_55353,type,
    v99756: state_type > $o ).

tff(pred_def_55354,type,
    v99713: ( state_type * $int ) > $o ).

tff(pred_def_55355,type,
    v99712: ( state_type * $int ) > $o ).

tff(pred_def_55356,type,
    v99711: state_type > $o ).

tff(pred_def_55357,type,
    v99710: state_type > $o ).

tff(pred_def_55358,type,
    v99709: state_type > $o ).

tff(pred_def_55359,type,
    v99760: state_type > $o ).

tff(pred_def_55360,type,
    v99708: state_type > $o ).

tff(pred_def_55361,type,
    v99761: state_type > $o ).

tff(pred_def_55362,type,
    v99707: state_type > $o ).

tff(pred_def_55363,type,
    v99764: state_type > $o ).

tff(pred_def_55364,type,
    v99765: state_type > $o ).

tff(pred_def_55365,type,
    v99763: state_type > $o ).

tff(pred_def_55366,type,
    v99766: state_type > $o ).

tff(pred_def_55367,type,
    v99762: state_type > $o ).

tff(pred_def_55368,type,
    v99769: state_type > $o ).

tff(pred_def_55369,type,
    v99770: state_type > $o ).

tff(pred_def_55370,type,
    v99768: state_type > $o ).

tff(pred_def_55371,type,
    v99771: state_type > $o ).

tff(pred_def_55372,type,
    v99767: state_type > $o ).

tff(pred_def_55373,type,
    v99705: ( state_type * $int ) > $o ).

tff(pred_def_55374,type,
    v99402: ( state_type * $int ) > $o ).

tff(pred_def_55375,type,
    v99787: state_type > $o ).

tff(pred_def_55376,type,
    v99786: ( state_type * $int ) > $o ).

tff(pred_def_55377,type,
    v99785: ( state_type * $int ) > $o ).

tff(pred_def_55378,type,
    v99791: state_type > $o ).

tff(pred_def_55379,type,
    v99790: state_type > $o ).

tff(pred_def_55380,type,
    v99789: ( state_type * $int ) > $o ).

tff(pred_def_55381,type,
    v99788: ( state_type * $int ) > $o ).

tff(pred_def_55382,type,
    v99784: ( state_type * $int ) > $o ).

tff(pred_def_55383,type,
    v99783: ( state_type * $int ) > $o ).

tff(pred_def_55384,type,
    v99795: state_type > $o ).

tff(pred_def_55385,type,
    v99794: state_type > $o ).

tff(pred_def_55386,type,
    v99793: ( state_type * $int ) > $o ).

tff(pred_def_55387,type,
    v99792: ( state_type * $int ) > $o ).

tff(pred_def_55388,type,
    v99782: ( state_type * $int ) > $o ).

tff(pred_def_55389,type,
    v99781: ( state_type * $int ) > $o ).

tff(pred_def_55390,type,
    v99799: state_type > $o ).

tff(pred_def_55391,type,
    v99798: state_type > $o ).

tff(pred_def_55392,type,
    v99797: ( state_type * $int ) > $o ).

tff(pred_def_55393,type,
    v99796: ( state_type * $int ) > $o ).

tff(pred_def_55394,type,
    v99780: ( state_type * $int ) > $o ).

tff(pred_def_55395,type,
    v99779: ( state_type * $int ) > $o ).

tff(pred_def_55396,type,
    v99803: state_type > $o ).

tff(pred_def_55397,type,
    v99802: state_type > $o ).

tff(pred_def_55398,type,
    v99801: ( state_type * $int ) > $o ).

tff(pred_def_55399,type,
    v99800: ( state_type * $int ) > $o ).

tff(pred_def_55400,type,
    v99778: ( state_type * $int ) > $o ).

tff(pred_def_55401,type,
    v99777: ( state_type * $int ) > $o ).

tff(pred_def_55402,type,
    v99807: state_type > $o ).

tff(pred_def_55403,type,
    v99806: state_type > $o ).

tff(pred_def_55404,type,
    v99805: ( state_type * $int ) > $o ).

tff(pred_def_55405,type,
    v99804: ( state_type * $int ) > $o ).

tff(pred_def_55406,type,
    v99776: ( state_type * $int ) > $o ).

tff(pred_def_55407,type,
    v99775: ( state_type * $int ) > $o ).

tff(pred_def_55408,type,
    v99811: state_type > $o ).

tff(pred_def_55409,type,
    v99810: state_type > $o ).

tff(pred_def_55410,type,
    v99809: ( state_type * $int ) > $o ).

tff(pred_def_55411,type,
    v99808: ( state_type * $int ) > $o ).

tff(pred_def_55412,type,
    v99774: ( state_type * $int ) > $o ).

tff(pred_def_55413,type,
    v99814: state_type > $o ).

tff(pred_def_55414,type,
    v99813: state_type > $o ).

tff(pred_def_55415,type,
    v99812: ( state_type * $int ) > $o ).

tff(pred_def_55416,type,
    v99773: ( state_type * $int ) > $o ).

tff(pred_def_55417,type,
    v99230: ( state_type * $int ) > $o ).

tff(pred_def_55418,type,
    v99228: ( state_type * $int ) > $o ).

tff(pred_def_55419,type,
    v99226: ( state_type * $int ) > $o ).

tff(pred_def_55420,type,
    v99825: state_type > $o ).

tff(pred_def_55421,type,
    v99824: state_type > $o ).

tff(pred_def_55422,type,
    v99823: state_type > $o ).

tff(pred_def_55423,type,
    v99822: state_type > $o ).

tff(pred_def_55424,type,
    v99821: state_type > $o ).

tff(pred_def_55425,type,
    v99820: state_type > $o ).

tff(pred_def_55426,type,
    v99818: state_type > $o ).

tff(pred_def_55427,type,
    v99817: state_type > $o ).

tff(pred_def_55428,type,
    v99816: state_type > $o ).

tff(pred_def_55429,type,
    v99833: state_type > $o ).

tff(pred_def_55430,type,
    v99832: state_type > $o ).

tff(pred_def_55431,type,
    v99831: state_type > $o ).

tff(pred_def_55432,type,
    v99830: state_type > $o ).

tff(pred_def_55433,type,
    v99829: state_type > $o ).

tff(pred_def_55434,type,
    v99828: state_type > $o ).

tff(pred_def_55435,type,
    v99826: state_type > $o ).

tff(pred_def_55436,type,
    v98442: state_type > $o ).

tff(pred_def_55437,type,
    v99843: state_type > $o ).

tff(pred_def_55438,type,
    v99841: state_type > $o ).

tff(pred_def_55439,type,
    v99847: state_type > $o ).

tff(pred_def_55440,type,
    v99845: state_type > $o ).

tff(pred_def_55441,type,
    v99853: state_type > $o ).

tff(pred_def_55442,type,
    v99855: state_type > $o ).

tff(pred_def_55443,type,
    v99859: state_type > $o ).

tff(pred_def_55444,type,
    v99858: state_type > $o ).

tff(pred_def_55445,type,
    v99857: state_type > $o ).

tff(pred_def_55446,type,
    v99863: state_type > $o ).

tff(pred_def_55447,type,
    v99862: state_type > $o ).

tff(pred_def_55448,type,
    v99861: state_type > $o ).

tff(pred_def_55449,type,
    v99837: state_type > $o ).

tff(pred_def_55450,type,
    v99860: state_type > $o ).

tff(pred_def_55451,type,
    v99851: state_type > $o ).

tff(pred_def_55452,type,
    v99849: state_type > $o ).

tff(pred_def_55453,type,
    v99867: state_type > $o ).

tff(pred_def_55454,type,
    v99865: state_type > $o ).

tff(pred_def_55455,type,
    v99874: state_type > $o ).

tff(pred_def_55456,type,
    v99872: state_type > $o ).

tff(pred_def_55457,type,
    v99871: state_type > $o ).

tff(pred_def_55458,type,
    v99870: state_type > $o ).

tff(pred_def_55459,type,
    v99882: state_type > $o ).

tff(pred_def_55460,type,
    v99883: state_type > $o ).

tff(pred_def_55461,type,
    v99881: state_type > $o ).

tff(pred_def_55462,type,
    v99878: state_type > $o ).

tff(pred_def_55463,type,
    v99880: state_type > $o ).

tff(pred_def_55464,type,
    v99839: state_type > $o ).

tff(pred_def_55465,type,
    v99835: state_type > $o ).

tff(pred_def_55466,type,
    v99900: state_type > $o ).

tff(pred_def_55467,type,
    v99898: state_type > $o ).

tff(pred_def_55468,type,
    v99904: state_type > $o ).

tff(pred_def_55469,type,
    v99902: state_type > $o ).

tff(pred_def_55470,type,
    v99922: state_type > $o ).

tff(pred_def_55471,type,
    v99920: state_type > $o ).

tff(pred_def_55472,type,
    v99926: state_type > $o ).

tff(pred_def_55473,type,
    v99924: state_type > $o ).

tff(pred_def_55474,type,
    v99940: ( state_type * $int ) > $o ).

tff(pred_def_55475,type,
    v99938: ( state_type * $int ) > $o ).

tff(pred_def_55476,type,
    v99936: ( state_type * $int ) > $o ).

tff(pred_def_55477,type,
    v99951: ( state_type * $int ) > $o ).

tff(pred_def_55478,type,
    v99949: ( state_type * $int ) > $o ).

tff(pred_def_55479,type,
    v99947: ( state_type * $int ) > $o ).

tff(pred_def_55480,type,
    v99945: ( state_type * $int ) > $o ).

tff(pred_def_55481,type,
    v99957: state_type > $o ).

tff(pred_def_55482,type,
    v99955: state_type > $o ).

tff(pred_def_55483,type,
    v99954: state_type > $o ).

tff(pred_def_55484,type,
    v99953: ( state_type * $int ) > $o ).

tff(pred_def_55485,type,
    v99961: ( state_type * $int ) > $o ).

tff(pred_def_55486,type,
    v99960: ( state_type * $int ) > $o ).

tff(pred_def_55487,type,
    v99962: ( state_type * $int ) > $o ).

tff(pred_def_55488,type,
    v99963: state_type > $o ).

tff(pred_def_55489,type,
    v99942: ( state_type * $int ) > $o ).

tff(pred_def_55490,type,
    v99964: ( state_type * $int ) > $o ).

tff(pred_def_55491,type,
    v99934: ( state_type * $int ) > $o ).

tff(pred_def_55492,type,
    v99932: ( state_type * $int ) > $o ).

tff(pred_def_55493,type,
    v99971: state_type > $o ).

tff(pred_def_55494,type,
    v99970: state_type > $o ).

tff(pred_def_55495,type,
    v99972: state_type > $o ).

tff(pred_def_55496,type,
    v99968: state_type > $o ).

tff(pred_def_55497,type,
    v99966: state_type > $o ).

tff(pred_def_55498,type,
    v99976: state_type > $o ).

tff(pred_def_55499,type,
    v99975: ( state_type * $int ) > $o ).

tff(pred_def_55500,type,
    v99974: ( state_type * $int ) > $o ).

tff(pred_def_55501,type,
    v99980: state_type > $o ).

tff(pred_def_55502,type,
    v99979: ( state_type * $int ) > $o ).

tff(pred_def_55503,type,
    v99978: ( state_type * $int ) > $o ).

tff(pred_def_55504,type,
    v99916: ( state_type * $int ) > $o ).

tff(pred_def_55505,type,
    v99977: ( state_type * $int ) > $o ).

tff(pred_def_55506,type,
    v99973: ( state_type * $int ) > $o ).

tff(pred_def_55507,type,
    v99930: ( state_type * $int ) > $o ).

tff(pred_def_55508,type,
    v99928: ( state_type * $int ) > $o ).

tff(pred_def_55509,type,
    v99985: state_type > $o ).

tff(pred_def_55510,type,
    v99983: state_type > $o ).

tff(pred_def_55511,type,
    v99992: state_type > $o ).

tff(pred_def_55512,type,
    v99990: state_type > $o ).

tff(pred_def_55513,type,
    v99989: state_type > $o ).

tff(pred_def_55514,type,
    v99988: state_type > $o ).

tff(pred_def_55515,type,
    v100000: state_type > $o ).

tff(pred_def_55516,type,
    v100001: state_type > $o ).

tff(pred_def_55517,type,
    v99999: state_type > $o ).

tff(pred_def_55518,type,
    v99996: ( state_type * $int ) > $o ).

tff(pred_def_55519,type,
    bxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_55520,type,
    v99998: ( state_type * $int ) > $o ).

tff(pred_def_55521,type,
    v99987: ( state_type * $int ) > $o ).

tff(pred_def_55522,type,
    v99918: ( state_type * $int ) > $o ).

tff(pred_def_55523,type,
    v99914: ( state_type * $int ) > $o ).

tff(pred_def_55524,type,
    v100004: ( state_type * $int ) > $o ).

tff(pred_def_55525,type,
    v99912: ( state_type * $int ) > $o ).

tff(pred_def_55526,type,
    v99910: ( state_type * $int ) > $o ).

tff(pred_def_55527,type,
    v100011: state_type > $o ).

tff(pred_def_55528,type,
    v100010: state_type > $o ).

tff(pred_def_55529,type,
    v100008: state_type > $o ).

tff(pred_def_55530,type,
    v100006: state_type > $o ).

tff(pred_def_55531,type,
    v100015: state_type > $o ).

tff(pred_def_55532,type,
    v100014: ( state_type * $int ) > $o ).

tff(pred_def_55533,type,
    v100013: ( state_type * $int ) > $o ).

tff(pred_def_55534,type,
    v100019: state_type > $o ).

tff(pred_def_55535,type,
    v100018: ( state_type * $int ) > $o ).

tff(pred_def_55536,type,
    v100017: ( state_type * $int ) > $o ).

tff(pred_def_55537,type,
    v99894: ( state_type * $int ) > $o ).

tff(pred_def_55538,type,
    v100016: ( state_type * $int ) > $o ).

tff(pred_def_55539,type,
    v100012: ( state_type * $int ) > $o ).

tff(pred_def_55540,type,
    v99908: ( state_type * $int ) > $o ).

tff(pred_def_55541,type,
    v99906: ( state_type * $int ) > $o ).

tff(pred_def_55542,type,
    v100023: state_type > $o ).

tff(pred_def_55543,type,
    v100021: state_type > $o ).

tff(pred_def_55544,type,
    v100030: state_type > $o ).

tff(pred_def_55545,type,
    v100028: state_type > $o ).

tff(pred_def_55546,type,
    v100027: state_type > $o ).

tff(pred_def_55547,type,
    v100026: state_type > $o ).

tff(pred_def_55548,type,
    v100038: state_type > $o ).

tff(pred_def_55549,type,
    v100039: state_type > $o ).

tff(pred_def_55550,type,
    v100037: state_type > $o ).

tff(pred_def_55551,type,
    v100034: ( state_type * $int ) > $o ).

tff(pred_def_55552,type,
    v100036: ( state_type * $int ) > $o ).

tff(pred_def_55553,type,
    v100025: ( state_type * $int ) > $o ).

tff(pred_def_55554,type,
    v99896: ( state_type * $int ) > $o ).

tff(pred_def_55555,type,
    v99892: ( state_type * $int ) > $o ).

tff(pred_def_55556,type,
    v99890: ( state_type * $int ) > $o ).

tff(pred_def_55557,type,
    v99888: ( state_type * $int ) > $o ).

tff(pred_def_55558,type,
    v100055: state_type > $o ).

tff(pred_def_55559,type,
    v100053: state_type > $o ).

tff(pred_def_55560,type,
    v100059: state_type > $o ).

tff(pred_def_55561,type,
    v100057: state_type > $o ).

tff(pred_def_55562,type,
    v100077: state_type > $o ).

tff(pred_def_55563,type,
    v100075: state_type > $o ).

tff(pred_def_55564,type,
    v100081: state_type > $o ).

tff(pred_def_55565,type,
    v100079: state_type > $o ).

tff(pred_def_55566,type,
    v100095: ( state_type * $int ) > $o ).

tff(pred_def_55567,type,
    v100093: ( state_type * $int ) > $o ).

tff(pred_def_55568,type,
    v100091: ( state_type * $int ) > $o ).

tff(pred_def_55569,type,
    v100106: ( state_type * $int ) > $o ).

tff(pred_def_55570,type,
    v100104: ( state_type * $int ) > $o ).

tff(pred_def_55571,type,
    v100102: ( state_type * $int ) > $o ).

tff(pred_def_55572,type,
    v100100: ( state_type * $int ) > $o ).

tff(pred_def_55573,type,
    v100112: state_type > $o ).

tff(pred_def_55574,type,
    v100110: state_type > $o ).

tff(pred_def_55575,type,
    v100109: state_type > $o ).

tff(pred_def_55576,type,
    v100108: ( state_type * $int ) > $o ).

tff(pred_def_55577,type,
    v100116: ( state_type * $int ) > $o ).

tff(pred_def_55578,type,
    v100115: ( state_type * $int ) > $o ).

tff(pred_def_55579,type,
    v100117: ( state_type * $int ) > $o ).

tff(pred_def_55580,type,
    v100118: state_type > $o ).

tff(pred_def_55581,type,
    v100097: ( state_type * $int ) > $o ).

tff(pred_def_55582,type,
    v100119: ( state_type * $int ) > $o ).

tff(pred_def_55583,type,
    v100089: ( state_type * $int ) > $o ).

tff(pred_def_55584,type,
    v100087: ( state_type * $int ) > $o ).

tff(pred_def_55585,type,
    v100126: state_type > $o ).

tff(pred_def_55586,type,
    v100125: state_type > $o ).

tff(pred_def_55587,type,
    v100127: state_type > $o ).

tff(pred_def_55588,type,
    v100123: state_type > $o ).

tff(pred_def_55589,type,
    v100121: state_type > $o ).

tff(pred_def_55590,type,
    v100131: state_type > $o ).

tff(pred_def_55591,type,
    v100130: ( state_type * $int ) > $o ).

tff(pred_def_55592,type,
    v100129: ( state_type * $int ) > $o ).

tff(pred_def_55593,type,
    v100135: state_type > $o ).

tff(pred_def_55594,type,
    v100134: ( state_type * $int ) > $o ).

tff(pred_def_55595,type,
    v100133: ( state_type * $int ) > $o ).

tff(pred_def_55596,type,
    v100071: ( state_type * $int ) > $o ).

tff(pred_def_55597,type,
    v100132: ( state_type * $int ) > $o ).

tff(pred_def_55598,type,
    v100128: ( state_type * $int ) > $o ).

tff(pred_def_55599,type,
    v100085: ( state_type * $int ) > $o ).

tff(pred_def_55600,type,
    v100083: ( state_type * $int ) > $o ).

tff(pred_def_55601,type,
    v100139: state_type > $o ).

tff(pred_def_55602,type,
    v100137: state_type > $o ).

tff(pred_def_55603,type,
    v100146: state_type > $o ).

tff(pred_def_55604,type,
    v100144: state_type > $o ).

tff(pred_def_55605,type,
    v100143: state_type > $o ).

tff(pred_def_55606,type,
    v100142: state_type > $o ).

tff(pred_def_55607,type,
    v100154: state_type > $o ).

tff(pred_def_55608,type,
    v100155: state_type > $o ).

tff(pred_def_55609,type,
    v100153: state_type > $o ).

tff(pred_def_55610,type,
    v100150: ( state_type * $int ) > $o ).

tff(pred_def_55611,type,
    v100152: ( state_type * $int ) > $o ).

tff(pred_def_55612,type,
    v100141: ( state_type * $int ) > $o ).

tff(pred_def_55613,type,
    v100073: ( state_type * $int ) > $o ).

tff(pred_def_55614,type,
    v100069: ( state_type * $int ) > $o ).

tff(pred_def_55615,type,
    v100158: ( state_type * $int ) > $o ).

tff(pred_def_55616,type,
    v100067: ( state_type * $int ) > $o ).

tff(pred_def_55617,type,
    v100065: ( state_type * $int ) > $o ).

tff(pred_def_55618,type,
    v100165: state_type > $o ).

tff(pred_def_55619,type,
    v100164: state_type > $o ).

tff(pred_def_55620,type,
    v100162: state_type > $o ).

tff(pred_def_55621,type,
    v100160: state_type > $o ).

tff(pred_def_55622,type,
    v100169: state_type > $o ).

tff(pred_def_55623,type,
    v100168: ( state_type * $int ) > $o ).

tff(pred_def_55624,type,
    v100167: ( state_type * $int ) > $o ).

tff(pred_def_55625,type,
    v100173: state_type > $o ).

tff(pred_def_55626,type,
    v100172: ( state_type * $int ) > $o ).

tff(pred_def_55627,type,
    v100171: ( state_type * $int ) > $o ).

tff(pred_def_55628,type,
    v100049: ( state_type * $int ) > $o ).

tff(pred_def_55629,type,
    v100170: ( state_type * $int ) > $o ).

tff(pred_def_55630,type,
    v100166: ( state_type * $int ) > $o ).

tff(pred_def_55631,type,
    v100063: ( state_type * $int ) > $o ).

tff(pred_def_55632,type,
    v100061: ( state_type * $int ) > $o ).

tff(pred_def_55633,type,
    v100177: state_type > $o ).

tff(pred_def_55634,type,
    v100175: state_type > $o ).

tff(pred_def_55635,type,
    v100184: state_type > $o ).

tff(pred_def_55636,type,
    v100182: state_type > $o ).

tff(pred_def_55637,type,
    v100181: state_type > $o ).

tff(pred_def_55638,type,
    v100180: state_type > $o ).

tff(pred_def_55639,type,
    v100192: state_type > $o ).

tff(pred_def_55640,type,
    v100193: state_type > $o ).

tff(pred_def_55641,type,
    v100191: state_type > $o ).

tff(pred_def_55642,type,
    v100188: ( state_type * $int ) > $o ).

tff(pred_def_55643,type,
    v100190: ( state_type * $int ) > $o ).

tff(pred_def_55644,type,
    v100179: ( state_type * $int ) > $o ).

tff(pred_def_55645,type,
    v100051: ( state_type * $int ) > $o ).

tff(pred_def_55646,type,
    v100047: ( state_type * $int ) > $o ).

tff(pred_def_55647,type,
    v100045: ( state_type * $int ) > $o ).

tff(pred_def_55648,type,
    v100043: ( state_type * $int ) > $o ).

tff(pred_def_55649,type,
    v100197: ( state_type * $int ) > $o ).

tff(pred_def_55650,type,
    v100196: ( state_type * $int ) > $o ).

tff(pred_def_55651,type,
    v100199: state_type > $o ).

tff(pred_def_55652,type,
    v97407: state_type > $o ).

tff(pred_def_55653,type,
    v100223: state_type > $o ).

tff(pred_def_55654,type,
    v100221: state_type > $o ).

tff(pred_def_55655,type,
    v100227: state_type > $o ).

tff(pred_def_55656,type,
    v100225: state_type > $o ).

tff(pred_def_55657,type,
    v100238: state_type > $o ).

tff(pred_def_55658,type,
    v100236: state_type > $o ).

tff(pred_def_55659,type,
    v100234: state_type > $o ).

tff(pred_def_55660,type,
    v100232: state_type > $o ).

tff(pred_def_55661,type,
    v100244: state_type > $o ).

tff(pred_def_55662,type,
    v100242: state_type > $o ).

tff(pred_def_55663,type,
    v100241: state_type > $o ).

tff(pred_def_55664,type,
    v100240: ( state_type * $int ) > $o ).

tff(pred_def_55665,type,
    v100252: state_type > $o ).

tff(pred_def_55666,type,
    v100250: state_type > $o ).

tff(pred_def_55667,type,
    v100249: state_type > $o ).

tff(pred_def_55668,type,
    v100248: ( state_type * $int ) > $o ).

tff(pred_def_55669,type,
    v100263: state_type > $o ).

tff(pred_def_55670,type,
    v100261: state_type > $o ).

tff(pred_def_55671,type,
    v100259: state_type > $o ).

tff(pred_def_55672,type,
    v100257: state_type > $o ).

tff(pred_def_55673,type,
    v100269: state_type > $o ).

tff(pred_def_55674,type,
    v100267: state_type > $o ).

tff(pred_def_55675,type,
    v100266: state_type > $o ).

tff(pred_def_55676,type,
    v100265: ( state_type * $int ) > $o ).

tff(pred_def_55677,type,
    v100277: state_type > $o ).

tff(pred_def_55678,type,
    v100275: state_type > $o ).

tff(pred_def_55679,type,
    v100274: state_type > $o ).

tff(pred_def_55680,type,
    v100273: ( state_type * $int ) > $o ).

tff(pred_def_55681,type,
    v100285: state_type > $o ).

tff(pred_def_55682,type,
    v100283: state_type > $o ).

tff(pred_def_55683,type,
    v100282: state_type > $o ).

tff(pred_def_55684,type,
    v100281: ( state_type * $int ) > $o ).

tff(pred_def_55685,type,
    v100293: state_type > $o ).

tff(pred_def_55686,type,
    v100291: state_type > $o ).

tff(pred_def_55687,type,
    v100290: state_type > $o ).

tff(pred_def_55688,type,
    v100289: ( state_type * $int ) > $o ).

tff(pred_def_55689,type,
    v100301: state_type > $o ).

tff(pred_def_55690,type,
    v100299: state_type > $o ).

tff(pred_def_55691,type,
    v100298: state_type > $o ).

tff(pred_def_55692,type,
    v100297: ( state_type * $int ) > $o ).

tff(pred_def_55693,type,
    v100309: state_type > $o ).

tff(pred_def_55694,type,
    v100307: state_type > $o ).

tff(pred_def_55695,type,
    v100306: state_type > $o ).

tff(pred_def_55696,type,
    v100305: ( state_type * $int ) > $o ).

tff(pred_def_55697,type,
    v100317: state_type > $o ).

tff(pred_def_55698,type,
    v100315: state_type > $o ).

tff(pred_def_55699,type,
    v100314: state_type > $o ).

tff(pred_def_55700,type,
    v100313: ( state_type * $int ) > $o ).

tff(pred_def_55701,type,
    v100325: state_type > $o ).

tff(pred_def_55702,type,
    v100323: state_type > $o ).

tff(pred_def_55703,type,
    v100322: state_type > $o ).

tff(pred_def_55704,type,
    v100321: ( state_type * $int ) > $o ).

tff(pred_def_55705,type,
    v100333: state_type > $o ).

tff(pred_def_55706,type,
    v100331: state_type > $o ).

tff(pred_def_55707,type,
    v100330: state_type > $o ).

tff(pred_def_55708,type,
    v100329: ( state_type * $int ) > $o ).

tff(pred_def_55709,type,
    v100341: state_type > $o ).

tff(pred_def_55710,type,
    v100339: state_type > $o ).

tff(pred_def_55711,type,
    v100338: state_type > $o ).

tff(pred_def_55712,type,
    v100337: ( state_type * $int ) > $o ).

tff(pred_def_55713,type,
    v100349: state_type > $o ).

tff(pred_def_55714,type,
    v100347: state_type > $o ).

tff(pred_def_55715,type,
    v100346: state_type > $o ).

tff(pred_def_55716,type,
    v100345: ( state_type * $int ) > $o ).

tff(pred_def_55717,type,
    v100357: state_type > $o ).

tff(pred_def_55718,type,
    v100355: state_type > $o ).

tff(pred_def_55719,type,
    v100354: state_type > $o ).

tff(pred_def_55720,type,
    v100353: ( state_type * $int ) > $o ).

tff(pred_def_55721,type,
    v100365: state_type > $o ).

tff(pred_def_55722,type,
    v100363: state_type > $o ).

tff(pred_def_55723,type,
    v100362: state_type > $o ).

tff(pred_def_55724,type,
    v100361: ( state_type * $int ) > $o ).

tff(pred_def_55725,type,
    v100373: state_type > $o ).

tff(pred_def_55726,type,
    v100371: state_type > $o ).

tff(pred_def_55727,type,
    v100370: state_type > $o ).

tff(pred_def_55728,type,
    v100369: ( state_type * $int ) > $o ).

tff(pred_def_55729,type,
    v100381: state_type > $o ).

tff(pred_def_55730,type,
    v100379: state_type > $o ).

tff(pred_def_55731,type,
    v100378: state_type > $o ).

tff(pred_def_55732,type,
    v100377: ( state_type * $int ) > $o ).

tff(pred_def_55733,type,
    v100389: state_type > $o ).

tff(pred_def_55734,type,
    v100387: state_type > $o ).

tff(pred_def_55735,type,
    v100386: state_type > $o ).

tff(pred_def_55736,type,
    v100385: ( state_type * $int ) > $o ).

tff(pred_def_55737,type,
    v100397: state_type > $o ).

tff(pred_def_55738,type,
    v100395: state_type > $o ).

tff(pred_def_55739,type,
    v100394: state_type > $o ).

tff(pred_def_55740,type,
    v100393: ( state_type * $int ) > $o ).

tff(pred_def_55741,type,
    v100405: state_type > $o ).

tff(pred_def_55742,type,
    v100403: state_type > $o ).

tff(pred_def_55743,type,
    v100402: state_type > $o ).

tff(pred_def_55744,type,
    v100401: ( state_type * $int ) > $o ).

tff(pred_def_55745,type,
    v100419: state_type > $o ).

tff(pred_def_55746,type,
    v100417: state_type > $o ).

tff(pred_def_55747,type,
    v100423: state_type > $o ).

tff(pred_def_55748,type,
    v100421: state_type > $o ).

tff(pred_def_55749,type,
    v100411: ( state_type * $int ) > $o ).

tff(pred_def_55750,type,
    v100463: state_type > $o ).

tff(pred_def_55751,type,
    v100462: ( state_type * $int ) > $o ).

tff(pred_def_55752,type,
    v100461: ( state_type * $int ) > $o ).

tff(pred_def_55753,type,
    v100466: state_type > $o ).

tff(pred_def_55754,type,
    v100465: ( state_type * $int ) > $o ).

tff(pred_def_55755,type,
    v100464: ( state_type * $int ) > $o ).

tff(pred_def_55756,type,
    v100460: ( state_type * $int ) > $o ).

tff(pred_def_55757,type,
    v100469: state_type > $o ).

tff(pred_def_55758,type,
    v100468: ( state_type * $int ) > $o ).

tff(pred_def_55759,type,
    v100467: ( state_type * $int ) > $o ).

tff(pred_def_55760,type,
    v100459: ( state_type * $int ) > $o ).

tff(pred_def_55761,type,
    v100472: state_type > $o ).

tff(pred_def_55762,type,
    v100471: ( state_type * $int ) > $o ).

tff(pred_def_55763,type,
    v100470: ( state_type * $int ) > $o ).

tff(pred_def_55764,type,
    v100458: ( state_type * $int ) > $o ).

tff(pred_def_55765,type,
    v100475: state_type > $o ).

tff(pred_def_55766,type,
    v100474: ( state_type * $int ) > $o ).

tff(pred_def_55767,type,
    v100473: ( state_type * $int ) > $o ).

tff(pred_def_55768,type,
    v100457: ( state_type * $int ) > $o ).

tff(pred_def_55769,type,
    v100478: state_type > $o ).

tff(pred_def_55770,type,
    v100477: ( state_type * $int ) > $o ).

tff(pred_def_55771,type,
    v100476: ( state_type * $int ) > $o ).

tff(pred_def_55772,type,
    v100456: ( state_type * $int ) > $o ).

tff(pred_def_55773,type,
    v100481: state_type > $o ).

tff(pred_def_55774,type,
    v100480: ( state_type * $int ) > $o ).

tff(pred_def_55775,type,
    v100479: ( state_type * $int ) > $o ).

tff(pred_def_55776,type,
    v100455: ( state_type * $int ) > $o ).

tff(pred_def_55777,type,
    v100484: state_type > $o ).

tff(pred_def_55778,type,
    v100483: ( state_type * $int ) > $o ).

tff(pred_def_55779,type,
    v100482: ( state_type * $int ) > $o ).

tff(pred_def_55780,type,
    v100454: ( state_type * $int ) > $o ).

tff(pred_def_55781,type,
    v100487: state_type > $o ).

tff(pred_def_55782,type,
    v100486: ( state_type * $int ) > $o ).

tff(pred_def_55783,type,
    v100485: ( state_type * $int ) > $o ).

tff(pred_def_55784,type,
    v100453: ( state_type * $int ) > $o ).

tff(pred_def_55785,type,
    v100490: state_type > $o ).

tff(pred_def_55786,type,
    v100489: ( state_type * $int ) > $o ).

tff(pred_def_55787,type,
    v100488: ( state_type * $int ) > $o ).

tff(pred_def_55788,type,
    v100452: ( state_type * $int ) > $o ).

tff(pred_def_55789,type,
    v100493: state_type > $o ).

tff(pred_def_55790,type,
    v100492: ( state_type * $int ) > $o ).

tff(pred_def_55791,type,
    v100491: ( state_type * $int ) > $o ).

tff(pred_def_55792,type,
    v100451: ( state_type * $int ) > $o ).

tff(pred_def_55793,type,
    v100496: state_type > $o ).

tff(pred_def_55794,type,
    v100495: ( state_type * $int ) > $o ).

tff(pred_def_55795,type,
    v100494: ( state_type * $int ) > $o ).

tff(pred_def_55796,type,
    v100450: ( state_type * $int ) > $o ).

tff(pred_def_55797,type,
    v100499: state_type > $o ).

tff(pred_def_55798,type,
    v100498: ( state_type * $int ) > $o ).

tff(pred_def_55799,type,
    v100497: ( state_type * $int ) > $o ).

tff(pred_def_55800,type,
    v100449: ( state_type * $int ) > $o ).

tff(pred_def_55801,type,
    v100502: state_type > $o ).

tff(pred_def_55802,type,
    v100501: ( state_type * $int ) > $o ).

tff(pred_def_55803,type,
    v100500: ( state_type * $int ) > $o ).

tff(pred_def_55804,type,
    v100448: ( state_type * $int ) > $o ).

tff(pred_def_55805,type,
    v100505: state_type > $o ).

tff(pred_def_55806,type,
    v100504: ( state_type * $int ) > $o ).

tff(pred_def_55807,type,
    v100503: ( state_type * $int ) > $o ).

tff(pred_def_55808,type,
    v100447: ( state_type * $int ) > $o ).

tff(pred_def_55809,type,
    v100508: state_type > $o ).

tff(pred_def_55810,type,
    v100507: ( state_type * $int ) > $o ).

tff(pred_def_55811,type,
    v100506: ( state_type * $int ) > $o ).

tff(pred_def_55812,type,
    v100446: ( state_type * $int ) > $o ).

tff(pred_def_55813,type,
    v100445: ( state_type * $int ) > $o ).

tff(pred_def_55814,type,
    v100514: state_type > $o ).

tff(pred_def_55815,type,
    v100512: state_type > $o ).

tff(pred_def_55816,type,
    v100511: state_type > $o ).

tff(pred_def_55817,type,
    v100510: ( state_type * $int ) > $o ).

tff(pred_def_55818,type,
    v100522: state_type > $o ).

tff(pred_def_55819,type,
    v100520: state_type > $o ).

tff(pred_def_55820,type,
    v100519: state_type > $o ).

tff(pred_def_55821,type,
    v100518: ( state_type * $int ) > $o ).

tff(pred_def_55822,type,
    v100530: state_type > $o ).

tff(pred_def_55823,type,
    v100528: state_type > $o ).

tff(pred_def_55824,type,
    v100527: state_type > $o ).

tff(pred_def_55825,type,
    v100526: ( state_type * $int ) > $o ).

tff(pred_def_55826,type,
    v100538: state_type > $o ).

tff(pred_def_55827,type,
    v100536: state_type > $o ).

tff(pred_def_55828,type,
    v100535: state_type > $o ).

tff(pred_def_55829,type,
    v100534: ( state_type * $int ) > $o ).

tff(pred_def_55830,type,
    v100546: state_type > $o ).

tff(pred_def_55831,type,
    v100544: state_type > $o ).

tff(pred_def_55832,type,
    v100543: state_type > $o ).

tff(pred_def_55833,type,
    v100542: ( state_type * $int ) > $o ).

tff(pred_def_55834,type,
    v100554: state_type > $o ).

tff(pred_def_55835,type,
    v100552: state_type > $o ).

tff(pred_def_55836,type,
    v100551: state_type > $o ).

tff(pred_def_55837,type,
    v100550: ( state_type * $int ) > $o ).

tff(pred_def_55838,type,
    v100562: state_type > $o ).

tff(pred_def_55839,type,
    v100560: state_type > $o ).

tff(pred_def_55840,type,
    v100559: state_type > $o ).

tff(pred_def_55841,type,
    v100558: ( state_type * $int ) > $o ).

tff(pred_def_55842,type,
    v100570: state_type > $o ).

tff(pred_def_55843,type,
    v100568: state_type > $o ).

tff(pred_def_55844,type,
    v100567: state_type > $o ).

tff(pred_def_55845,type,
    v100566: ( state_type * $int ) > $o ).

tff(pred_def_55846,type,
    v100578: state_type > $o ).

tff(pred_def_55847,type,
    v100576: state_type > $o ).

tff(pred_def_55848,type,
    v100575: state_type > $o ).

tff(pred_def_55849,type,
    v100574: ( state_type * $int ) > $o ).

tff(pred_def_55850,type,
    v100586: state_type > $o ).

tff(pred_def_55851,type,
    v100584: state_type > $o ).

tff(pred_def_55852,type,
    v100583: state_type > $o ).

tff(pred_def_55853,type,
    v100582: ( state_type * $int ) > $o ).

tff(pred_def_55854,type,
    v100594: state_type > $o ).

tff(pred_def_55855,type,
    v100592: state_type > $o ).

tff(pred_def_55856,type,
    v100591: state_type > $o ).

tff(pred_def_55857,type,
    v100590: ( state_type * $int ) > $o ).

tff(pred_def_55858,type,
    v100602: state_type > $o ).

tff(pred_def_55859,type,
    v100600: state_type > $o ).

tff(pred_def_55860,type,
    v100599: state_type > $o ).

tff(pred_def_55861,type,
    v100598: ( state_type * $int ) > $o ).

tff(pred_def_55862,type,
    v100610: state_type > $o ).

tff(pred_def_55863,type,
    v100608: state_type > $o ).

tff(pred_def_55864,type,
    v100607: state_type > $o ).

tff(pred_def_55865,type,
    v100606: ( state_type * $int ) > $o ).

tff(pred_def_55866,type,
    v100618: state_type > $o ).

tff(pred_def_55867,type,
    v100616: state_type > $o ).

tff(pred_def_55868,type,
    v100615: state_type > $o ).

tff(pred_def_55869,type,
    v100614: ( state_type * $int ) > $o ).

tff(pred_def_55870,type,
    v100626: state_type > $o ).

tff(pred_def_55871,type,
    v100624: state_type > $o ).

tff(pred_def_55872,type,
    v100623: state_type > $o ).

tff(pred_def_55873,type,
    v100622: ( state_type * $int ) > $o ).

tff(pred_def_55874,type,
    v100631: state_type > $o ).

tff(pred_def_55875,type,
    v100633: state_type > $o ).

tff(pred_def_55876,type,
    v100635: state_type > $o ).

tff(pred_def_55877,type,
    v100641: state_type > $o ).

tff(pred_def_55878,type,
    v100639: state_type > $o ).

tff(pred_def_55879,type,
    v100638: state_type > $o ).

tff(pred_def_55880,type,
    v100637: ( state_type * $int ) > $o ).

tff(pred_def_55881,type,
    v100646: state_type > $o ).

tff(pred_def_55882,type,
    v100648: state_type > $o ).

tff(pred_def_55883,type,
    v100650: state_type > $o ).

tff(pred_def_55884,type,
    v100656: state_type > $o ).

tff(pred_def_55885,type,
    v100654: state_type > $o ).

tff(pred_def_55886,type,
    v100653: state_type > $o ).

tff(pred_def_55887,type,
    v100652: ( state_type * $int ) > $o ).

tff(pred_def_55888,type,
    v100664: state_type > $o ).

tff(pred_def_55889,type,
    v100662: state_type > $o ).

tff(pred_def_55890,type,
    v100661: state_type > $o ).

tff(pred_def_55891,type,
    v100660: ( state_type * $int ) > $o ).

tff(pred_def_55892,type,
    v100669: state_type > $o ).

tff(pred_def_55893,type,
    v100670: state_type > $o ).

tff(pred_def_55894,type,
    v100668: state_type > $o ).

tff(pred_def_55895,type,
    v100443: ( state_type * $int ) > $o ).

tff(pred_def_55896,type,
    v100672: state_type > $o ).

tff(pred_def_55897,type,
    v100673: state_type > $o ).

tff(pred_def_55898,type,
    v100674: state_type > $o ).

tff(pred_def_55899,type,
    v100675: state_type > $o ).

tff(pred_def_55900,type,
    v100676: state_type > $o ).

tff(pred_def_55901,type,
    v100677: state_type > $o ).

tff(pred_def_55902,type,
    v100678: state_type > $o ).

tff(pred_def_55903,type,
    v100679: state_type > $o ).

tff(pred_def_55904,type,
    v100680: state_type > $o ).

tff(pred_def_55905,type,
    v100681: state_type > $o ).

tff(pred_def_55906,type,
    v100682: state_type > $o ).

tff(pred_def_55907,type,
    v100683: state_type > $o ).

tff(pred_def_55908,type,
    v100684: state_type > $o ).

tff(pred_def_55909,type,
    v100685: state_type > $o ).

tff(pred_def_55910,type,
    v100686: state_type > $o ).

tff(pred_def_55911,type,
    v100687: state_type > $o ).

tff(pred_def_55912,type,
    v100441: ( state_type * $int ) > $o ).

tff(pred_def_55913,type,
    v100699: state_type > $o ).

tff(pred_def_55914,type,
    v100697: state_type > $o ).

tff(pred_def_55915,type,
    v100703: state_type > $o ).

tff(pred_def_55916,type,
    v100701: state_type > $o ).

tff(pred_def_55917,type,
    v100731: state_type > $o ).

tff(pred_def_55918,type,
    v100729: state_type > $o ).

tff(pred_def_55919,type,
    v100727: state_type > $o ).

tff(pred_def_55920,type,
    v100725: state_type > $o ).

tff(pred_def_55921,type,
    v100723: state_type > $o ).

tff(pred_def_55922,type,
    v100751: state_type > $o ).

tff(pred_def_55923,type,
    v100750: state_type > $o ).

tff(pred_def_55924,type,
    v100754: state_type > $o ).

tff(pred_def_55925,type,
    v100753: state_type > $o ).

tff(pred_def_55926,type,
    v100752: ( state_type * $int ) > $o ).

tff(pred_def_55927,type,
    v100749: ( state_type * $int ) > $o ).

tff(pred_def_55928,type,
    v100748: ( state_type * $int ) > $o ).

tff(pred_def_55929,type,
    v100746: ( state_type * $int ) > $o ).

tff(pred_def_55930,type,
    v100744: ( state_type * $int ) > $o ).

tff(pred_def_55931,type,
    v100764: state_type > $o ).

tff(pred_def_55932,type,
    v100762: state_type > $o ).

tff(pred_def_55933,type,
    v100768: state_type > $o ).

tff(pred_def_55934,type,
    v100766: state_type > $o ).

tff(pred_def_55935,type,
    v100779: state_type > $o ).

tff(pred_def_55936,type,
    v100778: state_type > $o ).

tff(pred_def_55937,type,
    v100756: state_type > $o ).

tff(pred_def_55938,type,
    v100776: state_type > $o ).

tff(pred_def_55939,type,
    v100774: state_type > $o ).

tff(pred_def_55940,type,
    v100772: state_type > $o ).

tff(pred_def_55941,type,
    v100770: state_type > $o ).

tff(pred_def_55942,type,
    v100784: state_type > $o ).

tff(pred_def_55943,type,
    v100782: state_type > $o ).

tff(pred_def_55944,type,
    v100791: state_type > $o ).

tff(pred_def_55945,type,
    v100789: state_type > $o ).

tff(pred_def_55946,type,
    v100788: state_type > $o ).

tff(pred_def_55947,type,
    v100787: state_type > $o ).

tff(pred_def_55948,type,
    v100799: state_type > $o ).

tff(pred_def_55949,type,
    v100800: state_type > $o ).

tff(pred_def_55950,type,
    v100798: state_type > $o ).

tff(pred_def_55951,type,
    v100795: state_type > $o ).

tff(pred_def_55952,type,
    v100797: state_type > $o ).

tff(pred_def_55953,type,
    v100760: state_type > $o ).

tff(pred_def_55954,type,
    v100758: state_type > $o ).

tff(pred_def_55955,type,
    v100806: state_type > $o ).

tff(pred_def_55956,type,
    v100805: state_type > $o ).

tff(pred_def_55957,type,
    v100804: ( state_type * $int ) > $o ).

tff(pred_def_55958,type,
    v100803: ( state_type * $int ) > $o ).

tff(pred_def_55959,type,
    v100742: ( state_type * $int ) > $o ).

tff(pred_def_55960,type,
    v100740: ( state_type * $int ) > $o ).

tff(pred_def_55961,type,
    v100738: ( state_type * $int ) > $o ).

tff(pred_def_55962,type,
    v100203: ( state_type * $int ) > $o ).

tff(pred_def_55963,type,
    v100818: state_type > $o ).

tff(pred_def_55964,type,
    v100819: state_type > $o ).

tff(pred_def_55965,type,
    v100817: state_type > $o ).

tff(pred_def_55966,type,
    v100691: state_type > $o ).

tff(pred_def_55967,type,
    v100820: state_type > $o ).

tff(pred_def_55968,type,
    v100816: state_type > $o ).

tff(pred_def_55969,type,
    v100713: state_type > $o ).

tff(pred_def_55970,type,
    v100822: state_type > $o ).

tff(pred_def_55971,type,
    v100821: state_type > $o ).

tff(pred_def_55972,type,
    v100815: state_type > $o ).

tff(pred_def_55973,type,
    v100824: state_type > $o ).

tff(pred_def_55974,type,
    v100827: state_type > $o ).

tff(pred_def_55975,type,
    v100808: state_type > $o ).

tff(pred_def_55976,type,
    v100828: state_type > $o ).

tff(pred_def_55977,type,
    v100826: state_type > $o ).

tff(pred_def_55978,type,
    v100829: state_type > $o ).

tff(pred_def_55979,type,
    v100825: state_type > $o ).

tff(pred_def_55980,type,
    v100823: state_type > $o ).

tff(pred_def_55981,type,
    v100814: state_type > $o ).

tff(pred_def_55982,type,
    v100812: state_type > $o ).

tff(pred_def_55983,type,
    v100834: state_type > $o ).

tff(pred_def_55984,type,
    v100833: state_type > $o ).

tff(pred_def_55985,type,
    v100836: state_type > $o ).

tff(pred_def_55986,type,
    v100835: state_type > $o ).

tff(pred_def_55987,type,
    v100831: state_type > $o ).

tff(pred_def_55988,type,
    v100838: state_type > $o ).

tff(pred_def_55989,type,
    v100810: state_type > $o ).

tff(pred_def_55990,type,
    v100717: state_type > $o ).

tff(pred_def_55991,type,
    v100839: ( state_type * $int ) > $o ).

tff(pred_def_55992,type,
    v100711: state_type > $o ).

tff(pred_def_55993,type,
    v100736: state_type > $o ).

tff(pred_def_55994,type,
    v100709: ( state_type * $int ) > $o ).

tff(pred_def_55995,type,
    v100707: ( state_type * $int ) > $o ).

tff(pred_def_55996,type,
    v100705: ( state_type * $int ) > $o ).

tff(pred_def_55997,type,
    v100843: state_type > $o ).

tff(pred_def_55998,type,
    v100841: state_type > $o ).

tff(pred_def_55999,type,
    v100850: state_type > $o ).

tff(pred_def_56000,type,
    v100848: state_type > $o ).

tff(pred_def_56001,type,
    v100847: state_type > $o ).

tff(pred_def_56002,type,
    v100846: state_type > $o ).

tff(pred_def_56003,type,
    v100858: state_type > $o ).

tff(pred_def_56004,type,
    v100859: state_type > $o ).

tff(pred_def_56005,type,
    v100857: state_type > $o ).

tff(pred_def_56006,type,
    v100854: ( state_type * $int ) > $o ).

tff(pred_def_56007,type,
    v100856: ( state_type * $int ) > $o ).

tff(pred_def_56008,type,
    v100845: ( state_type * $int ) > $o ).

tff(pred_def_56009,type,
    v100695: ( state_type * $int ) > $o ).

tff(pred_def_56010,type,
    v100693: ( state_type * $int ) > $o ).

tff(pred_def_56011,type,
    v100865: state_type > $o ).

tff(pred_def_56012,type,
    v100867: state_type > $o ).

tff(pred_def_56013,type,
    v100866: state_type > $o ).

tff(pred_def_56014,type,
    v100864: state_type > $o ).

tff(pred_def_56015,type,
    v100869: state_type > $o ).

tff(pred_def_56016,type,
    v100873: state_type > $o ).

tff(pred_def_56017,type,
    v100872: state_type > $o ).

tff(pred_def_56018,type,
    v100734: state_type > $o ).

tff(pred_def_56019,type,
    v100874: state_type > $o ).

tff(pred_def_56020,type,
    v100871: state_type > $o ).

tff(pred_def_56021,type,
    v100875: state_type > $o ).

tff(pred_def_56022,type,
    v100870: state_type > $o ).

tff(pred_def_56023,type,
    v100868: state_type > $o ).

tff(pred_def_56024,type,
    v100863: state_type > $o ).

tff(pred_def_56025,type,
    v100881: state_type > $o ).

tff(pred_def_56026,type,
    v100879: state_type > $o ).

tff(pred_def_56027,type,
    v100878: state_type > $o ).

tff(pred_def_56028,type,
    v100877: ( state_type * $int ) > $o ).

tff(pred_def_56029,type,
    v97278: state_type > $o ).

tff(pred_def_56030,type,
    v100888: state_type > $o ).

tff(pred_def_56031,type,
    v100887: state_type > $o ).

tff(pred_def_56032,type,
    v100886: state_type > $o ).

tff(pred_def_56033,type,
    v100890: state_type > $o ).

tff(pred_def_56034,type,
    v100892: state_type > $o ).

tff(pred_def_56035,type,
    v100894: state_type > $o ).

tff(pred_def_56036,type,
    v100893: state_type > $o ).

tff(pred_def_56037,type,
    v100891: state_type > $o ).

tff(pred_def_56038,type,
    v100889: state_type > $o ).

tff(pred_def_56039,type,
    v100885: state_type > $o ).

tff(pred_def_56040,type,
    v100721: state_type > $o ).

tff(pred_def_56041,type,
    v100719: state_type > $o ).

tff(pred_def_56042,type,
    v100902: state_type > $o ).

tff(pred_def_56043,type,
    v100900: state_type > $o ).

tff(pred_def_56044,type,
    v100899: state_type > $o ).

tff(pred_def_56045,type,
    v100898: ( state_type * $int ) > $o ).

tff(pred_def_56046,type,
    v100715: state_type > $o ).

tff(pred_def_56047,type,
    v100908: state_type > $o ).

tff(pred_def_56048,type,
    v100910: state_type > $o ).

tff(pred_def_56049,type,
    v100912: state_type > $o ).

tff(pred_def_56050,type,
    v100911: state_type > $o ).

tff(pred_def_56051,type,
    v100909: state_type > $o ).

tff(pred_def_56052,type,
    v100907: state_type > $o ).

tff(pred_def_56053,type,
    v100918: state_type > $o ).

tff(pred_def_56054,type,
    v100916: state_type > $o ).

tff(pred_def_56055,type,
    v100915: state_type > $o ).

tff(pred_def_56056,type,
    v100914: ( state_type * $int ) > $o ).

tff(pred_def_56057,type,
    v100926: state_type > $o ).

tff(pred_def_56058,type,
    v100925: state_type > $o ).

tff(pred_def_56059,type,
    v100924: ( state_type * $int ) > $o ).

tff(pred_def_56060,type,
    v100928: state_type > $o ).

tff(pred_def_56061,type,
    v100930: state_type > $o ).

tff(pred_def_56062,type,
    v100932: state_type > $o ).

tff(pred_def_56063,type,
    v100931: ( state_type * $int ) > $o ).

tff(pred_def_56064,type,
    v100929: ( state_type * $int ) > $o ).

tff(pred_def_56065,type,
    v100927: ( state_type * $int ) > $o ).

tff(pred_def_56066,type,
    v100433: ( state_type * $int ) > $o ).

tff(pred_def_56067,type,
    v100946: ( state_type * $int ) > $o ).

tff(pred_def_56068,type,
    v100945: state_type > $o ).

tff(pred_def_56069,type,
    v100949: state_type > $o ).

tff(pred_def_56070,type,
    v100950: state_type > $o ).

tff(pred_def_56071,type,
    v100948: state_type > $o ).

tff(pred_def_56072,type,
    v100951: state_type > $o ).

tff(pred_def_56073,type,
    v100947: state_type > $o ).

tff(pred_def_56074,type,
    v100944: state_type > $o ).

tff(pred_def_56075,type,
    v100952: state_type > $o ).

tff(pred_def_56076,type,
    v100943: state_type > $o ).

tff(pred_def_56077,type,
    v100955: state_type > $o ).

tff(pred_def_56078,type,
    v100956: state_type > $o ).

tff(pred_def_56079,type,
    v100954: state_type > $o ).

tff(pred_def_56080,type,
    v100957: state_type > $o ).

tff(pred_def_56081,type,
    v100953: state_type > $o ).

tff(pred_def_56082,type,
    v100942: state_type > $o ).

tff(pred_def_56083,type,
    v100958: state_type > $o ).

tff(pred_def_56084,type,
    v100941: state_type > $o ).

tff(pred_def_56085,type,
    v100961: state_type > $o ).

tff(pred_def_56086,type,
    v100962: state_type > $o ).

tff(pred_def_56087,type,
    v100960: state_type > $o ).

tff(pred_def_56088,type,
    v100963: state_type > $o ).

tff(pred_def_56089,type,
    v100959: state_type > $o ).

tff(pred_def_56090,type,
    v100940: state_type > $o ).

tff(pred_def_56091,type,
    v100964: state_type > $o ).

tff(pred_def_56092,type,
    v100939: state_type > $o ).

tff(pred_def_56093,type,
    v100938: state_type > $o ).

tff(pred_def_56094,type,
    v100968: state_type > $o ).

tff(pred_def_56095,type,
    v100969: state_type > $o ).

tff(pred_def_56096,type,
    v100967: state_type > $o ).

tff(pred_def_56097,type,
    v100970: state_type > $o ).

tff(pred_def_56098,type,
    v100966: state_type > $o ).

tff(pred_def_56099,type,
    v100965: state_type > $o ).

tff(pred_def_56100,type,
    v100937: state_type > $o ).

tff(pred_def_56101,type,
    v100971: state_type > $o ).

tff(pred_def_56102,type,
    v100936: state_type > $o ).

tff(pred_def_56103,type,
    v100974: state_type > $o ).

tff(pred_def_56104,type,
    v100975: state_type > $o ).

tff(pred_def_56105,type,
    v100973: state_type > $o ).

tff(pred_def_56106,type,
    v100976: state_type > $o ).

tff(pred_def_56107,type,
    v100972: state_type > $o ).

tff(pred_def_56108,type,
    v100979: state_type > $o ).

tff(pred_def_56109,type,
    v100980: state_type > $o ).

tff(pred_def_56110,type,
    v100978: state_type > $o ).

tff(pred_def_56111,type,
    v100981: state_type > $o ).

tff(pred_def_56112,type,
    v100977: state_type > $o ).

tff(pred_def_56113,type,
    v100984: state_type > $o ).

tff(pred_def_56114,type,
    v100985: state_type > $o ).

tff(pred_def_56115,type,
    v100983: state_type > $o ).

tff(pred_def_56116,type,
    v100986: state_type > $o ).

tff(pred_def_56117,type,
    v100982: state_type > $o ).

tff(pred_def_56118,type,
    v100989: state_type > $o ).

tff(pred_def_56119,type,
    v100990: state_type > $o ).

tff(pred_def_56120,type,
    v100988: state_type > $o ).

tff(pred_def_56121,type,
    v100991: state_type > $o ).

tff(pred_def_56122,type,
    v100987: state_type > $o ).

tff(pred_def_56123,type,
    v100934: ( state_type * $int ) > $o ).

tff(pred_def_56124,type,
    v100933: ( state_type * $int ) > $o ).

tff(pred_def_56125,type,
    v100431: ( state_type * $int ) > $o ).

tff(pred_def_56126,type,
    v100429: ( state_type * $int ) > $o ).

tff(pred_def_56127,type,
    v100427: ( state_type * $int ) > $o ).

tff(pred_def_56128,type,
    v100425: ( state_type * $int ) > $o ).

tff(pred_def_56129,type,
    v100995: state_type > $o ).

tff(pred_def_56130,type,
    v100993: state_type > $o ).

tff(pred_def_56131,type,
    v101002: state_type > $o ).

tff(pred_def_56132,type,
    v101000: state_type > $o ).

tff(pred_def_56133,type,
    v100999: state_type > $o ).

tff(pred_def_56134,type,
    v100998: state_type > $o ).

tff(pred_def_56135,type,
    v101010: state_type > $o ).

tff(pred_def_56136,type,
    v101011: state_type > $o ).

tff(pred_def_56137,type,
    v101009: state_type > $o ).

tff(pred_def_56138,type,
    v101006: ( state_type * $int ) > $o ).

tff(pred_def_56139,type,
    v101008: ( state_type * $int ) > $o ).

tff(pred_def_56140,type,
    v100997: ( state_type * $int ) > $o ).

tff(pred_def_56141,type,
    v100415: ( state_type * $int ) > $o ).

tff(pred_def_56142,type,
    v100413: ( state_type * $int ) > $o ).

tff(pred_def_56143,type,
    v101024: state_type > $o ).

tff(pred_def_56144,type,
    v101027: state_type > $o ).

tff(pred_def_56145,type,
    v101028: state_type > $o ).

tff(pred_def_56146,type,
    v101026: state_type > $o ).

tff(pred_def_56147,type,
    v101025: state_type > $o ).

tff(pred_def_56148,type,
    v101023: state_type > $o ).

tff(pred_def_56149,type,
    v101029: state_type > $o ).

tff(pred_def_56150,type,
    v101022: state_type > $o ).

tff(pred_def_56151,type,
    v101032: state_type > $o ).

tff(pred_def_56152,type,
    v101033: state_type > $o ).

tff(pred_def_56153,type,
    v101031: state_type > $o ).

tff(pred_def_56154,type,
    v101030: state_type > $o ).

tff(pred_def_56155,type,
    v101021: state_type > $o ).

tff(pred_def_56156,type,
    v101034: state_type > $o ).

tff(pred_def_56157,type,
    v101020: state_type > $o ).

tff(pred_def_56158,type,
    v101037: state_type > $o ).

tff(pred_def_56159,type,
    v101038: state_type > $o ).

tff(pred_def_56160,type,
    v101036: state_type > $o ).

tff(pred_def_56161,type,
    v101035: state_type > $o ).

tff(pred_def_56162,type,
    v101019: state_type > $o ).

tff(pred_def_56163,type,
    v101039: state_type > $o ).

tff(pred_def_56164,type,
    v101018: state_type > $o ).

tff(pred_def_56165,type,
    v101042: state_type > $o ).

tff(pred_def_56166,type,
    v101043: state_type > $o ).

tff(pred_def_56167,type,
    v101041: state_type > $o ).

tff(pred_def_56168,type,
    v101040: state_type > $o ).

tff(pred_def_56169,type,
    v101017: state_type > $o ).

tff(pred_def_56170,type,
    v101044: state_type > $o ).

tff(pred_def_56171,type,
    v101015: state_type > $o ).

tff(pred_def_56172,type,
    v101056: state_type > $o ).

tff(pred_def_56173,type,
    v101061: state_type > $o ).

tff(pred_def_56174,type,
    v101062: state_type > $o ).

tff(pred_def_56175,type,
    v101060: state_type > $o ).

tff(pred_def_56176,type,
    v101059: state_type > $o ).

tff(pred_def_56177,type,
    v101058: state_type > $o ).

tff(pred_def_56178,type,
    v101063: state_type > $o ).

tff(pred_def_56179,type,
    v101057: state_type > $o ).

tff(pred_def_56180,type,
    v101055: state_type > $o ).

tff(pred_def_56181,type,
    v101064: state_type > $o ).

tff(pred_def_56182,type,
    v101054: state_type > $o ).

tff(pred_def_56183,type,
    v101071: state_type > $o ).

tff(pred_def_56184,type,
    v101070: state_type > $o ).

tff(pred_def_56185,type,
    v101069: state_type > $o ).

tff(pred_def_56186,type,
    v101072: state_type > $o ).

tff(pred_def_56187,type,
    v101068: state_type > $o ).

tff(pred_def_56188,type,
    v101067: state_type > $o ).

tff(pred_def_56189,type,
    v101066: state_type > $o ).

tff(pred_def_56190,type,
    v101073: state_type > $o ).

tff(pred_def_56191,type,
    v101065: state_type > $o ).

tff(pred_def_56192,type,
    v101053: state_type > $o ).

tff(pred_def_56193,type,
    v101074: state_type > $o ).

tff(pred_def_56194,type,
    v101052: state_type > $o ).

tff(pred_def_56195,type,
    v101081: state_type > $o ).

tff(pred_def_56196,type,
    v101080: state_type > $o ).

tff(pred_def_56197,type,
    v101079: state_type > $o ).

tff(pred_def_56198,type,
    v101082: state_type > $o ).

tff(pred_def_56199,type,
    v101078: state_type > $o ).

tff(pred_def_56200,type,
    v101077: state_type > $o ).

tff(pred_def_56201,type,
    v101076: state_type > $o ).

tff(pred_def_56202,type,
    v101083: state_type > $o ).

tff(pred_def_56203,type,
    v101075: state_type > $o ).

tff(pred_def_56204,type,
    v101051: state_type > $o ).

tff(pred_def_56205,type,
    v101084: state_type > $o ).

tff(pred_def_56206,type,
    v101050: state_type > $o ).

tff(pred_def_56207,type,
    v101049: state_type > $o ).

tff(pred_def_56208,type,
    v101092: state_type > $o ).

tff(pred_def_56209,type,
    v101091: state_type > $o ).

tff(pred_def_56210,type,
    v101090: state_type > $o ).

tff(pred_def_56211,type,
    v101093: state_type > $o ).

tff(pred_def_56212,type,
    v101089: state_type > $o ).

tff(pred_def_56213,type,
    v101088: state_type > $o ).

tff(pred_def_56214,type,
    v101087: state_type > $o ).

tff(pred_def_56215,type,
    v101094: state_type > $o ).

tff(pred_def_56216,type,
    v101086: state_type > $o ).

tff(pred_def_56217,type,
    v101085: state_type > $o ).

tff(pred_def_56218,type,
    v101048: state_type > $o ).

tff(pred_def_56219,type,
    v101095: state_type > $o ).

tff(pred_def_56220,type,
    v101047: state_type > $o ).

tff(pred_def_56221,type,
    v101098: state_type > $o ).

tff(pred_def_56222,type,
    v101099: state_type > $o ).

tff(pred_def_56223,type,
    v101097: state_type > $o ).

tff(pred_def_56224,type,
    v101100: state_type > $o ).

tff(pred_def_56225,type,
    v101096: state_type > $o ).

tff(pred_def_56226,type,
    v101103: state_type > $o ).

tff(pred_def_56227,type,
    v101104: state_type > $o ).

tff(pred_def_56228,type,
    v101102: state_type > $o ).

tff(pred_def_56229,type,
    v101105: state_type > $o ).

tff(pred_def_56230,type,
    v101101: state_type > $o ).

tff(pred_def_56231,type,
    v101108: state_type > $o ).

tff(pred_def_56232,type,
    v101109: state_type > $o ).

tff(pred_def_56233,type,
    v101107: state_type > $o ).

tff(pred_def_56234,type,
    v101110: state_type > $o ).

tff(pred_def_56235,type,
    v101106: state_type > $o ).

tff(pred_def_56236,type,
    v101112: state_type > $o ).

tff(pred_def_56237,type,
    v101113: state_type > $o ).

tff(pred_def_56238,type,
    v101111: state_type > $o ).

tff(pred_def_56239,type,
    v101045: ( state_type * $int ) > $o ).

tff(pred_def_56240,type,
    v101136: state_type > $o ).

tff(pred_def_56241,type,
    v101135: state_type > $o ).

tff(pred_def_56242,type,
    v101137: state_type > $o ).

tff(pred_def_56243,type,
    v101134: state_type > $o ).

tff(pred_def_56244,type,
    v101133: state_type > $o ).

tff(pred_def_56245,type,
    v101138: state_type > $o ).

tff(pred_def_56246,type,
    v101132: state_type > $o ).

tff(pred_def_56247,type,
    v101145: state_type > $o ).

tff(pred_def_56248,type,
    v101144: state_type > $o ).

tff(pred_def_56249,type,
    v101143: state_type > $o ).

tff(pred_def_56250,type,
    v101146: state_type > $o ).

tff(pred_def_56251,type,
    v101142: state_type > $o ).

tff(pred_def_56252,type,
    v101141: state_type > $o ).

tff(pred_def_56253,type,
    v101140: state_type > $o ).

tff(pred_def_56254,type,
    v101147: state_type > $o ).

tff(pred_def_56255,type,
    v101139: state_type > $o ).

tff(pred_def_56256,type,
    v101131: state_type > $o ).

tff(pred_def_56257,type,
    v101148: state_type > $o ).

tff(pred_def_56258,type,
    v101130: state_type > $o ).

tff(pred_def_56259,type,
    v101155: state_type > $o ).

tff(pred_def_56260,type,
    v101154: state_type > $o ).

tff(pred_def_56261,type,
    v101153: state_type > $o ).

tff(pred_def_56262,type,
    v101156: state_type > $o ).

tff(pred_def_56263,type,
    v101152: state_type > $o ).

tff(pred_def_56264,type,
    v101151: state_type > $o ).

tff(pred_def_56265,type,
    v101150: state_type > $o ).

tff(pred_def_56266,type,
    v101157: state_type > $o ).

tff(pred_def_56267,type,
    v101149: state_type > $o ).

tff(pred_def_56268,type,
    v101129: state_type > $o ).

tff(pred_def_56269,type,
    v101158: state_type > $o ).

tff(pred_def_56270,type,
    v101128: state_type > $o ).

tff(pred_def_56271,type,
    v101127: state_type > $o ).

tff(pred_def_56272,type,
    v101166: state_type > $o ).

tff(pred_def_56273,type,
    v101165: state_type > $o ).

tff(pred_def_56274,type,
    v101164: state_type > $o ).

tff(pred_def_56275,type,
    v101167: state_type > $o ).

tff(pred_def_56276,type,
    v101163: state_type > $o ).

tff(pred_def_56277,type,
    v101162: state_type > $o ).

tff(pred_def_56278,type,
    v101161: state_type > $o ).

tff(pred_def_56279,type,
    v101168: state_type > $o ).

tff(pred_def_56280,type,
    v101160: state_type > $o ).

tff(pred_def_56281,type,
    v101159: state_type > $o ).

tff(pred_def_56282,type,
    v101126: state_type > $o ).

tff(pred_def_56283,type,
    v101169: state_type > $o ).

tff(pred_def_56284,type,
    v101125: state_type > $o ).

tff(pred_def_56285,type,
    v101172: state_type > $o ).

tff(pred_def_56286,type,
    v101173: state_type > $o ).

tff(pred_def_56287,type,
    v101171: state_type > $o ).

tff(pred_def_56288,type,
    v101174: state_type > $o ).

tff(pred_def_56289,type,
    v101170: state_type > $o ).

tff(pred_def_56290,type,
    v101177: state_type > $o ).

tff(pred_def_56291,type,
    v101178: state_type > $o ).

tff(pred_def_56292,type,
    v101176: state_type > $o ).

tff(pred_def_56293,type,
    v101179: state_type > $o ).

tff(pred_def_56294,type,
    v101175: state_type > $o ).

tff(pred_def_56295,type,
    v101182: state_type > $o ).

tff(pred_def_56296,type,
    v101181: state_type > $o ).

tff(pred_def_56297,type,
    v101183: state_type > $o ).

tff(pred_def_56298,type,
    v101180: state_type > $o ).

tff(pred_def_56299,type,
    v101123: ( state_type * $int ) > $o ).

tff(pred_def_56300,type,
    v101122: ( state_type * $int ) > $o ).

tff(pred_def_56301,type,
    v101121: state_type > $o ).

tff(pred_def_56302,type,
    v101120: state_type > $o ).

tff(pred_def_56303,type,
    v101119: state_type > $o ).

tff(pred_def_56304,type,
    v101118: state_type > $o ).

tff(pred_def_56305,type,
    v101184: state_type > $o ).

tff(pred_def_56306,type,
    v101117: state_type > $o ).

tff(pred_def_56307,type,
    v101185: state_type > $o ).

tff(pred_def_56308,type,
    v101116: state_type > $o ).

tff(pred_def_56309,type,
    v101188: state_type > $o ).

tff(pred_def_56310,type,
    v101189: state_type > $o ).

tff(pred_def_56311,type,
    v101187: state_type > $o ).

tff(pred_def_56312,type,
    v101190: state_type > $o ).

tff(pred_def_56313,type,
    v101186: state_type > $o ).

tff(pred_def_56314,type,
    v101193: state_type > $o ).

tff(pred_def_56315,type,
    v101194: state_type > $o ).

tff(pred_def_56316,type,
    v101192: state_type > $o ).

tff(pred_def_56317,type,
    v101195: state_type > $o ).

tff(pred_def_56318,type,
    v101191: state_type > $o ).

tff(pred_def_56319,type,
    v101198: state_type > $o ).

tff(pred_def_56320,type,
    v101199: state_type > $o ).

tff(pred_def_56321,type,
    v101197: state_type > $o ).

tff(pred_def_56322,type,
    v101200: state_type > $o ).

tff(pred_def_56323,type,
    v101196: state_type > $o ).

tff(pred_def_56324,type,
    v101114: ( state_type * $int ) > $o ).

tff(pred_def_56325,type,
    v100922: ( state_type * $int ) > $o ).

tff(pred_def_56326,type,
    v101202: state_type > $o ).

tff(pred_def_56327,type,
    v101205: state_type > $o ).

tff(pred_def_56328,type,
    v101204: state_type > $o ).

tff(pred_def_56329,type,
    v101213: state_type > $o ).

tff(pred_def_56330,type,
    v101215: state_type > $o ).

tff(pred_def_56331,type,
    v101214: state_type > $o ).

tff(pred_def_56332,type,
    v101212: state_type > $o ).

tff(pred_def_56333,type,
    v101216: state_type > $o ).

tff(pred_def_56334,type,
    v101211: state_type > $o ).

tff(pred_def_56335,type,
    v101217: state_type > $o ).

tff(pred_def_56336,type,
    v101210: state_type > $o ).

tff(pred_def_56337,type,
    v101218: state_type > $o ).

tff(pred_def_56338,type,
    v101209: state_type > $o ).

tff(pred_def_56339,type,
    v101207: state_type > $o ).

tff(pred_def_56340,type,
    v101223: state_type > $o ).

tff(pred_def_56341,type,
    v101222: state_type > $o ).

tff(pred_def_56342,type,
    v101221: state_type > $o ).

tff(pred_def_56343,type,
    v101219: state_type > $o ).

tff(pred_def_56344,type,
    v101225: state_type > $o ).

tff(pred_def_56345,type,
    v101224: state_type > $o ).

tff(pred_def_56346,type,
    v101206: ( state_type * $int ) > $o ).

tff(pred_def_56347,type,
    v101203: ( state_type * $int ) > $o ).

tff(pred_def_56348,type,
    v101201: ( state_type * $int ) > $o ).

tff(pred_def_56349,type,
    v100689: ( state_type * $int ) > $o ).

tff(pred_def_56350,type,
    v101231: state_type > $o ).

tff(pred_def_56351,type,
    v101232: state_type > $o ).

tff(pred_def_56352,type,
    v101233: state_type > $o ).

tff(pred_def_56353,type,
    v101234: state_type > $o ).

tff(pred_def_56354,type,
    v101235: state_type > $o ).

tff(pred_def_56355,type,
    v101236: state_type > $o ).

tff(pred_def_56356,type,
    v101237: state_type > $o ).

tff(pred_def_56357,type,
    v101238: state_type > $o ).

tff(pred_def_56358,type,
    v101239: state_type > $o ).

tff(pred_def_56359,type,
    v101240: state_type > $o ).

tff(pred_def_56360,type,
    v101241: state_type > $o ).

tff(pred_def_56361,type,
    v101242: state_type > $o ).

tff(pred_def_56362,type,
    v101243: state_type > $o ).

tff(pred_def_56363,type,
    v101244: state_type > $o ).

tff(pred_def_56364,type,
    v101245: state_type > $o ).

tff(pred_def_56365,type,
    v101246: state_type > $o ).

tff(pred_def_56366,type,
    v101229: ( state_type * $int ) > $o ).

tff(pred_def_56367,type,
    v85706: ( state_type * $int ) > $o ).

tff(pred_def_56368,type,
    v101250: ( state_type * $int ) > $o ).

tff(pred_def_56369,type,
    v101270: state_type > $o ).

tff(pred_def_56370,type,
    v101268: state_type > $o ).

tff(pred_def_56371,type,
    v101274: state_type > $o ).

tff(pred_def_56372,type,
    v101272: state_type > $o ).

tff(pred_def_56373,type,
    v101296: state_type > $o ).

tff(pred_def_56374,type,
    v101294: state_type > $o ).

tff(pred_def_56375,type,
    v101300: state_type > $o ).

tff(pred_def_56376,type,
    v101298: state_type > $o ).

tff(pred_def_56377,type,
    v101308: ( state_type * $int ) > $o ).

tff(pred_def_56378,type,
    v101306: ( state_type * $int ) > $o ).

tff(pred_def_56379,type,
    b0000010100000: $int > $o ).

tff(pred_def_56380,type,
    v101315: state_type > $o ).

tff(pred_def_56381,type,
    v101312: state_type > $o ).

tff(pred_def_56382,type,
    v101310: state_type > $o ).

tff(pred_def_56383,type,
    v101319: state_type > $o ).

tff(pred_def_56384,type,
    v101318: ( state_type * $int ) > $o ).

tff(pred_def_56385,type,
    v101317: ( state_type * $int ) > $o ).

tff(pred_def_56386,type,
    v101323: state_type > $o ).

tff(pred_def_56387,type,
    v101322: ( state_type * $int ) > $o ).

tff(pred_def_56388,type,
    v101321: ( state_type * $int ) > $o ).

tff(pred_def_56389,type,
    v101290: ( state_type * $int ) > $o ).

tff(pred_def_56390,type,
    v101320: ( state_type * $int ) > $o ).

tff(pred_def_56391,type,
    v101316: ( state_type * $int ) > $o ).

tff(pred_def_56392,type,
    v101304: ( state_type * $int ) > $o ).

tff(pred_def_56393,type,
    v101302: ( state_type * $int ) > $o ).

tff(pred_def_56394,type,
    v101327: state_type > $o ).

tff(pred_def_56395,type,
    v101325: state_type > $o ).

tff(pred_def_56396,type,
    v101334: state_type > $o ).

tff(pred_def_56397,type,
    v101332: state_type > $o ).

tff(pred_def_56398,type,
    v101331: state_type > $o ).

tff(pred_def_56399,type,
    v101330: state_type > $o ).

tff(pred_def_56400,type,
    v101342: state_type > $o ).

tff(pred_def_56401,type,
    v101343: state_type > $o ).

tff(pred_def_56402,type,
    v101341: state_type > $o ).

tff(pred_def_56403,type,
    v101338: ( state_type * $int ) > $o ).

tff(pred_def_56404,type,
    v101340: ( state_type * $int ) > $o ).

tff(pred_def_56405,type,
    v101329: ( state_type * $int ) > $o ).

tff(pred_def_56406,type,
    v101292: ( state_type * $int ) > $o ).

tff(pred_def_56407,type,
    v101288: ( state_type * $int ) > $o ).

tff(pred_def_56408,type,
    v101351: state_type > $o ).

tff(pred_def_56409,type,
    v101349: state_type > $o ).

tff(pred_def_56410,type,
    v101348: state_type > $o ).

tff(pred_def_56411,type,
    v101347: ( state_type * $int ) > $o ).

tff(pred_def_56412,type,
    v101359: state_type > $o ).

tff(pred_def_56413,type,
    v101357: state_type > $o ).

tff(pred_def_56414,type,
    v101356: state_type > $o ).

tff(pred_def_56415,type,
    v101355: ( state_type * $int ) > $o ).

tff(pred_def_56416,type,
    v101367: state_type > $o ).

tff(pred_def_56417,type,
    v101365: state_type > $o ).

tff(pred_def_56418,type,
    v101364: state_type > $o ).

tff(pred_def_56419,type,
    v101363: ( state_type * $int ) > $o ).

tff(pred_def_56420,type,
    v101381: ( state_type * $int ) > $o ).

tff(pred_def_56421,type,
    v101380: ( state_type * $int ) > $o ).

tff(pred_def_56422,type,
    v101379: state_type > $o ).

tff(pred_def_56423,type,
    v101384: state_type > $o ).

tff(pred_def_56424,type,
    v101385: state_type > $o ).

tff(pred_def_56425,type,
    v101383: state_type > $o ).

tff(pred_def_56426,type,
    v101386: state_type > $o ).

tff(pred_def_56427,type,
    v101382: state_type > $o ).

tff(pred_def_56428,type,
    v101378: state_type > $o ).

tff(pred_def_56429,type,
    v101387: state_type > $o ).

tff(pred_def_56430,type,
    v101377: state_type > $o ).

tff(pred_def_56431,type,
    v101390: state_type > $o ).

tff(pred_def_56432,type,
    v101391: state_type > $o ).

tff(pred_def_56433,type,
    v101389: state_type > $o ).

tff(pred_def_56434,type,
    v101392: state_type > $o ).

tff(pred_def_56435,type,
    v101388: state_type > $o ).

tff(pred_def_56436,type,
    v101376: state_type > $o ).

tff(pred_def_56437,type,
    v101393: state_type > $o ).

tff(pred_def_56438,type,
    v101375: state_type > $o ).

tff(pred_def_56439,type,
    v101374: state_type > $o ).

tff(pred_def_56440,type,
    v101397: state_type > $o ).

tff(pred_def_56441,type,
    v101398: state_type > $o ).

tff(pred_def_56442,type,
    v101396: state_type > $o ).

tff(pred_def_56443,type,
    v101399: state_type > $o ).

tff(pred_def_56444,type,
    v101395: state_type > $o ).

tff(pred_def_56445,type,
    v101394: state_type > $o ).

tff(pred_def_56446,type,
    v101373: state_type > $o ).

tff(pred_def_56447,type,
    v101400: state_type > $o ).

tff(pred_def_56448,type,
    v101372: state_type > $o ).

tff(pred_def_56449,type,
    v101403: state_type > $o ).

tff(pred_def_56450,type,
    v101404: state_type > $o ).

tff(pred_def_56451,type,
    v101402: state_type > $o ).

tff(pred_def_56452,type,
    v101405: state_type > $o ).

tff(pred_def_56453,type,
    v101401: state_type > $o ).

tff(pred_def_56454,type,
    v101408: state_type > $o ).

tff(pred_def_56455,type,
    v101409: state_type > $o ).

tff(pred_def_56456,type,
    v101407: state_type > $o ).

tff(pred_def_56457,type,
    v101410: state_type > $o ).

tff(pred_def_56458,type,
    v101406: state_type > $o ).

tff(pred_def_56459,type,
    v101413: state_type > $o ).

tff(pred_def_56460,type,
    v101414: state_type > $o ).

tff(pred_def_56461,type,
    v101412: state_type > $o ).

tff(pred_def_56462,type,
    v101415: state_type > $o ).

tff(pred_def_56463,type,
    v101411: state_type > $o ).

tff(pred_def_56464,type,
    v101286: ( state_type * $int ) > $o ).

tff(pred_def_56465,type,
    v101284: ( state_type * $int ) > $o ).

tff(pred_def_56466,type,
    v101417: state_type > $o ).

tff(pred_def_56467,type,
    v101262: ( state_type * $int ) > $o ).

tff(pred_def_56468,type,
    v101420: state_type > $o ).

tff(pred_def_56469,type,
    v101431: state_type > $o ).

tff(pred_def_56470,type,
    v101430: state_type > $o ).

tff(pred_def_56471,type,
    v101429: state_type > $o ).

tff(pred_def_56472,type,
    v101432: state_type > $o ).

tff(pred_def_56473,type,
    v101428: state_type > $o ).

tff(pred_def_56474,type,
    v101427: state_type > $o ).

tff(pred_def_56475,type,
    v101426: state_type > $o ).

tff(pred_def_56476,type,
    v101425: state_type > $o ).

tff(pred_def_56477,type,
    v101434: state_type > $o ).

tff(pred_def_56478,type,
    v101433: state_type > $o ).

tff(pred_def_56479,type,
    v101424: state_type > $o ).

tff(pred_def_56480,type,
    v101437: state_type > $o ).

tff(pred_def_56481,type,
    v101436: state_type > $o ).

tff(pred_def_56482,type,
    v101438: state_type > $o ).

tff(pred_def_56483,type,
    v101435: state_type > $o ).

tff(pred_def_56484,type,
    v101441: state_type > $o ).

tff(pred_def_56485,type,
    v101440: state_type > $o ).

tff(pred_def_56486,type,
    v101442: state_type > $o ).

tff(pred_def_56487,type,
    v101439: state_type > $o ).

tff(pred_def_56488,type,
    v101422: ( state_type * $int ) > $o ).

tff(pred_def_56489,type,
    v101421: ( state_type * $int ) > $o ).

tff(pred_def_56490,type,
    v101419: ( state_type * $int ) > $o ).

tff(pred_def_56491,type,
    v89210: state_type > $o ).

tff(pred_def_56492,type,
    v101282: ( state_type * $int ) > $o ).

tff(pred_def_56493,type,
    v101280: ( state_type * $int ) > $o ).

tff(pred_def_56494,type,
    v101278: ( state_type * $int ) > $o ).

tff(pred_def_56495,type,
    v101276: ( state_type * $int ) > $o ).

tff(pred_def_56496,type,
    v101448: state_type > $o ).

tff(pred_def_56497,type,
    v101446: state_type > $o ).

tff(pred_def_56498,type,
    v101444: state_type > $o ).

tff(pred_def_56499,type,
    v101455: state_type > $o ).

tff(pred_def_56500,type,
    v101453: state_type > $o ).

tff(pred_def_56501,type,
    v101452: state_type > $o ).

tff(pred_def_56502,type,
    v101451: state_type > $o ).

tff(pred_def_56503,type,
    v101463: state_type > $o ).

tff(pred_def_56504,type,
    v101464: state_type > $o ).

tff(pred_def_56505,type,
    v101462: state_type > $o ).

tff(pred_def_56506,type,
    v101459: ( state_type * $int ) > $o ).

tff(pred_def_56507,type,
    v101461: ( state_type * $int ) > $o ).

tff(pred_def_56508,type,
    v101266: ( state_type * $int ) > $o ).

tff(pred_def_56509,type,
    v101264: ( state_type * $int ) > $o ).

tff(pred_def_56510,type,
    v101260: state_type > $o ).

tff(pred_def_56511,type,
    v101258: ( state_type * $int ) > $o ).

tff(pred_def_56512,type,
    v101481: state_type > $o ).

tff(pred_def_56513,type,
    v101479: state_type > $o ).

tff(pred_def_56514,type,
    v101485: state_type > $o ).

tff(pred_def_56515,type,
    v101483: state_type > $o ).

tff(pred_def_56516,type,
    v101524: ( state_type * $int ) > $o ).

tff(pred_def_56517,type,
    v101523: ( state_type * $int ) > $o ).

tff(pred_def_56518,type,
    v101526: ( state_type * $int ) > $o ).

tff(pred_def_56519,type,
    v101525: ( state_type * $int ) > $o ).

tff(pred_def_56520,type,
    v101522: ( state_type * $int ) > $o ).

tff(pred_def_56521,type,
    v101528: ( state_type * $int ) > $o ).

tff(pred_def_56522,type,
    v101527: ( state_type * $int ) > $o ).

tff(pred_def_56523,type,
    v101521: ( state_type * $int ) > $o ).

tff(pred_def_56524,type,
    v101530: ( state_type * $int ) > $o ).

tff(pred_def_56525,type,
    v101529: ( state_type * $int ) > $o ).

tff(pred_def_56526,type,
    v101520: ( state_type * $int ) > $o ).

tff(pred_def_56527,type,
    v101532: ( state_type * $int ) > $o ).

tff(pred_def_56528,type,
    v101531: ( state_type * $int ) > $o ).

tff(pred_def_56529,type,
    v101519: ( state_type * $int ) > $o ).

tff(pred_def_56530,type,
    v101534: ( state_type * $int ) > $o ).

tff(pred_def_56531,type,
    v101533: ( state_type * $int ) > $o ).

tff(pred_def_56532,type,
    v101518: ( state_type * $int ) > $o ).

tff(pred_def_56533,type,
    v101536: ( state_type * $int ) > $o ).

tff(pred_def_56534,type,
    v101535: ( state_type * $int ) > $o ).

tff(pred_def_56535,type,
    v101517: ( state_type * $int ) > $o ).

tff(pred_def_56536,type,
    v101538: ( state_type * $int ) > $o ).

tff(pred_def_56537,type,
    v101537: ( state_type * $int ) > $o ).

tff(pred_def_56538,type,
    v101516: ( state_type * $int ) > $o ).

tff(pred_def_56539,type,
    v101540: ( state_type * $int ) > $o ).

tff(pred_def_56540,type,
    v101539: ( state_type * $int ) > $o ).

tff(pred_def_56541,type,
    v101515: ( state_type * $int ) > $o ).

tff(pred_def_56542,type,
    v101542: ( state_type * $int ) > $o ).

tff(pred_def_56543,type,
    v101541: ( state_type * $int ) > $o ).

tff(pred_def_56544,type,
    v101514: ( state_type * $int ) > $o ).

tff(pred_def_56545,type,
    v101544: ( state_type * $int ) > $o ).

tff(pred_def_56546,type,
    v101543: ( state_type * $int ) > $o ).

tff(pred_def_56547,type,
    v101513: ( state_type * $int ) > $o ).

tff(pred_def_56548,type,
    v101546: ( state_type * $int ) > $o ).

tff(pred_def_56549,type,
    v101545: ( state_type * $int ) > $o ).

tff(pred_def_56550,type,
    v101512: ( state_type * $int ) > $o ).

tff(pred_def_56551,type,
    v101548: ( state_type * $int ) > $o ).

tff(pred_def_56552,type,
    v101547: ( state_type * $int ) > $o ).

tff(pred_def_56553,type,
    v101511: ( state_type * $int ) > $o ).

tff(pred_def_56554,type,
    v101550: ( state_type * $int ) > $o ).

tff(pred_def_56555,type,
    v101549: ( state_type * $int ) > $o ).

tff(pred_def_56556,type,
    v101510: ( state_type * $int ) > $o ).

tff(pred_def_56557,type,
    v101552: ( state_type * $int ) > $o ).

tff(pred_def_56558,type,
    v101551: ( state_type * $int ) > $o ).

tff(pred_def_56559,type,
    v101509: ( state_type * $int ) > $o ).

tff(pred_def_56560,type,
    v101554: ( state_type * $int ) > $o ).

tff(pred_def_56561,type,
    v101553: ( state_type * $int ) > $o ).

tff(pred_def_56562,type,
    v101508: ( state_type * $int ) > $o ).

tff(pred_def_56563,type,
    v100409: ( state_type * $int ) > $o ).

tff(pred_def_56564,type,
    v101555: ( state_type * $int ) > $o ).

tff(pred_def_56565,type,
    v100229: ( state_type * $int ) > $o ).

tff(pred_def_56566,type,
    v101507: ( state_type * $int ) > $o ).

tff(pred_def_56567,type,
    v101505: ( state_type * $int ) > $o ).

tff(pred_def_56568,type,
    v101557: state_type > $o ).

tff(pred_def_56569,type,
    v100207: ( state_type * $int ) > $o ).

tff(pred_def_56570,type,
    v101503: state_type > $o ).

tff(pred_def_56571,type,
    v101559: state_type > $o ).

tff(pred_def_56572,type,
    v101501: state_type > $o ).

tff(pred_def_56573,type,
    v101568: ( state_type * $int ) > $o ).

tff(pred_def_56574,type,
    v100219: ( state_type * $int ) > $o ).

tff(pred_def_56575,type,
    v101567: ( state_type * $int ) > $o ).

tff(pred_def_56576,type,
    v101565: ( state_type * $int ) > $o ).

tff(pred_def_56577,type,
    v101563: ( state_type * $int ) > $o ).

tff(pred_def_56578,type,
    v101580: state_type > $o ).

tff(pred_def_56579,type,
    v101578: state_type > $o ).

tff(pred_def_56580,type,
    v101584: state_type > $o ).

tff(pred_def_56581,type,
    v101582: state_type > $o ).

tff(pred_def_56582,type,
    v101608: state_type > $o ).

tff(pred_def_56583,type,
    v101606: state_type > $o ).

tff(pred_def_56584,type,
    v101612: state_type > $o ).

tff(pred_def_56585,type,
    v101610: state_type > $o ).

tff(pred_def_56586,type,
    v101630: state_type > $o ).

tff(pred_def_56587,type,
    v101628: state_type > $o ).

tff(pred_def_56588,type,
    v101634: state_type > $o ).

tff(pred_def_56589,type,
    v101632: state_type > $o ).

tff(pred_def_56590,type,
    v101622: ( state_type * $int ) > $o ).

tff(pred_def_56591,type,
    v101653: state_type > $o ).

tff(pred_def_56592,type,
    v101654: state_type > $o ).

tff(pred_def_56593,type,
    v101652: state_type > $o ).

tff(pred_def_56594,type,
    v101655: state_type > $o ).

tff(pred_def_56595,type,
    v101651: state_type > $o ).

tff(pred_def_56596,type,
    v101656: state_type > $o ).

tff(pred_def_56597,type,
    v101650: state_type > $o ).

tff(pred_def_56598,type,
    v101657: state_type > $o ).

tff(pred_def_56599,type,
    v101649: state_type > $o ).

tff(pred_def_56600,type,
    v101658: state_type > $o ).

tff(pred_def_56601,type,
    v101648: state_type > $o ).

tff(pred_def_56602,type,
    v101646: state_type > $o ).

tff(pred_def_56603,type,
    v101600: state_type > $o ).

tff(pred_def_56604,type,
    v101645: state_type > $o ).

tff(pred_def_56605,type,
    v101671: state_type > $o ).

tff(pred_def_56606,type,
    v101670: state_type > $o ).

tff(pred_def_56607,type,
    v101669: state_type > $o ).

tff(pred_def_56608,type,
    v101668: state_type > $o ).

tff(pred_def_56609,type,
    v101667: state_type > $o ).

tff(pred_def_56610,type,
    v101666: state_type > $o ).

tff(pred_def_56611,type,
    v101665: state_type > $o ).

tff(pred_def_56612,type,
    v101664: state_type > $o ).

tff(pred_def_56613,type,
    v101663: state_type > $o ).

tff(pred_def_56614,type,
    v101662: state_type > $o ).

tff(pred_def_56615,type,
    v101672: state_type > $o ).

tff(pred_def_56616,type,
    v101661: state_type > $o ).

tff(pred_def_56617,type,
    v101675: state_type > $o ).

tff(pred_def_56618,type,
    v101674: state_type > $o ).

tff(pred_def_56619,type,
    v101676: state_type > $o ).

tff(pred_def_56620,type,
    v101673: state_type > $o ).

tff(pred_def_56621,type,
    v101679: state_type > $o ).

tff(pred_def_56622,type,
    v101678: state_type > $o ).

tff(pred_def_56623,type,
    v101680: state_type > $o ).

tff(pred_def_56624,type,
    v101677: state_type > $o ).

tff(pred_def_56625,type,
    v101683: state_type > $o ).

tff(pred_def_56626,type,
    v101682: state_type > $o ).

tff(pred_def_56627,type,
    v101684: state_type > $o ).

tff(pred_def_56628,type,
    v101681: state_type > $o ).

tff(pred_def_56629,type,
    v101686: state_type > $o ).

tff(pred_def_56630,type,
    v101687: state_type > $o ).

tff(pred_def_56631,type,
    v101685: state_type > $o ).

tff(pred_def_56632,type,
    v101659: ( state_type * $int ) > $o ).

tff(pred_def_56633,type,
    v101690: state_type > $o ).

tff(pred_def_56634,type,
    v101697: state_type > $o ).

tff(pred_def_56635,type,
    v101696: state_type > $o ).

tff(pred_def_56636,type,
    v101695: state_type > $o ).

tff(pred_def_56637,type,
    v101694: state_type > $o ).

tff(pred_def_56638,type,
    v101693: state_type > $o ).

tff(pred_def_56639,type,
    v101691: state_type > $o ).

tff(pred_def_56640,type,
    v101689: state_type > $o ).

tff(pred_def_56641,type,
    v101705: state_type > $o ).

tff(pred_def_56642,type,
    v101704: state_type > $o ).

tff(pred_def_56643,type,
    v101703: state_type > $o ).

tff(pred_def_56644,type,
    v101702: state_type > $o ).

tff(pred_def_56645,type,
    v101701: state_type > $o ).

tff(pred_def_56646,type,
    v101706: state_type > $o ).

tff(pred_def_56647,type,
    v101700: state_type > $o ).

tff(pred_def_56648,type,
    v101709: state_type > $o ).

tff(pred_def_56649,type,
    v101708: state_type > $o ).

tff(pred_def_56650,type,
    v101710: state_type > $o ).

tff(pred_def_56651,type,
    v101707: state_type > $o ).

tff(pred_def_56652,type,
    v101713: state_type > $o ).

tff(pred_def_56653,type,
    v101712: state_type > $o ).

tff(pred_def_56654,type,
    v101714: state_type > $o ).

tff(pred_def_56655,type,
    v101711: state_type > $o ).

tff(pred_def_56656,type,
    v101717: state_type > $o ).

tff(pred_def_56657,type,
    v101716: state_type > $o ).

tff(pred_def_56658,type,
    v101718: state_type > $o ).

tff(pred_def_56659,type,
    v101715: state_type > $o ).

tff(pred_def_56660,type,
    v101720: state_type > $o ).

tff(pred_def_56661,type,
    v101721: state_type > $o ).

tff(pred_def_56662,type,
    v101719: state_type > $o ).

tff(pred_def_56663,type,
    v101698: ( state_type * $int ) > $o ).

tff(pred_def_56664,type,
    v101688: ( state_type * $int ) > $o ).

tff(pred_def_56665,type,
    v101642: ( state_type * $int ) > $o ).

tff(pred_def_56666,type,
    v101640: ( state_type * $int ) > $o ).

tff(pred_def_56667,type,
    v2904: ( state_type * $int ) > $o ).

tff(pred_def_56668,type,
    v101736: state_type > $o ).

tff(pred_def_56669,type,
    v101735: state_type > $o ).

tff(pred_def_56670,type,
    v101734: state_type > $o ).

tff(pred_def_56671,type,
    v101733: state_type > $o ).

tff(pred_def_56672,type,
    v101732: state_type > $o ).

tff(pred_def_56673,type,
    v101731: state_type > $o ).

tff(pred_def_56674,type,
    v101729: state_type > $o ).

tff(pred_def_56675,type,
    v101728: state_type > $o ).

tff(pred_def_56676,type,
    v101737: state_type > $o ).

tff(pred_def_56677,type,
    v101727: state_type > $o ).

tff(pred_def_56678,type,
    v101620: state_type > $o ).

tff(pred_def_56679,type,
    v101738: state_type > $o ).

tff(pred_def_56680,type,
    v101725: state_type > $o ).

tff(pred_def_56681,type,
    v101723: state_type > $o ).

tff(pred_def_56682,type,
    v101742: state_type > $o ).

tff(pred_def_56683,type,
    v101741: ( state_type * $int ) > $o ).

tff(pred_def_56684,type,
    v101740: ( state_type * $int ) > $o ).

tff(pred_def_56685,type,
    v101638: ( state_type * $int ) > $o ).

tff(pred_def_56686,type,
    v101636: ( state_type * $int ) > $o ).

tff(pred_def_56687,type,
    v101746: state_type > $o ).

tff(pred_def_56688,type,
    v101744: state_type > $o ).

tff(pred_def_56689,type,
    v101753: state_type > $o ).

tff(pred_def_56690,type,
    v101751: state_type > $o ).

tff(pred_def_56691,type,
    v101750: state_type > $o ).

tff(pred_def_56692,type,
    v101749: state_type > $o ).

tff(pred_def_56693,type,
    v101761: state_type > $o ).

tff(pred_def_56694,type,
    v101762: state_type > $o ).

tff(pred_def_56695,type,
    v101760: state_type > $o ).

tff(pred_def_56696,type,
    v101757: ( state_type * $int ) > $o ).

tff(pred_def_56697,type,
    v101759: ( state_type * $int ) > $o ).

tff(pred_def_56698,type,
    v101626: ( state_type * $int ) > $o ).

tff(pred_def_56699,type,
    v101624: ( state_type * $int ) > $o ).

tff(pred_def_56700,type,
    b111111: $int > $o ).

tff(pred_def_56701,type,
    v101618: state_type > $o ).

tff(pred_def_56702,type,
    v101767: state_type > $o ).

tff(pred_def_56703,type,
    v101771: state_type > $o ).

tff(pred_def_56704,type,
    v101769: state_type > $o ).

tff(pred_def_56705,type,
    v101777: state_type > $o ).

tff(pred_def_56706,type,
    v101776: state_type > $o ).

tff(pred_def_56707,type,
    v101775: state_type > $o ).

tff(pred_def_56708,type,
    v101780: state_type > $o ).

tff(pred_def_56709,type,
    v101779: state_type > $o ).

tff(pred_def_56710,type,
    v101778: state_type > $o ).

tff(pred_def_56711,type,
    v101774: state_type > $o ).

tff(pred_def_56712,type,
    v101785: state_type > $o ).

tff(pred_def_56713,type,
    v101784: state_type > $o ).

tff(pred_def_56714,type,
    v101783: state_type > $o ).

tff(pred_def_56715,type,
    v101602: state_type > $o ).

tff(pred_def_56716,type,
    v101782: state_type > $o ).

tff(pred_def_56717,type,
    v101788: state_type > $o ).

tff(pred_def_56718,type,
    v101787: state_type > $o ).

tff(pred_def_56719,type,
    v101786: state_type > $o ).

tff(pred_def_56720,type,
    v101781: state_type > $o ).

tff(pred_def_56721,type,
    v101616: state_type > $o ).

tff(pred_def_56722,type,
    v101614: state_type > $o ).

tff(pred_def_56723,type,
    v101792: state_type > $o ).

tff(pred_def_56724,type,
    v101790: state_type > $o ).

tff(pred_def_56725,type,
    v101799: state_type > $o ).

tff(pred_def_56726,type,
    v101797: state_type > $o ).

tff(pred_def_56727,type,
    v101796: state_type > $o ).

tff(pred_def_56728,type,
    v101795: state_type > $o ).

tff(pred_def_56729,type,
    v101807: state_type > $o ).

tff(pred_def_56730,type,
    v101808: state_type > $o ).

tff(pred_def_56731,type,
    v101806: state_type > $o ).

tff(pred_def_56732,type,
    v101803: state_type > $o ).

tff(pred_def_56733,type,
    v101805: state_type > $o ).

tff(pred_def_56734,type,
    v101604: state_type > $o ).

tff(pred_def_56735,type,
    v101820: state_type > $o ).

tff(pred_def_56736,type,
    v101818: state_type > $o ).

tff(pred_def_56737,type,
    v101824: state_type > $o ).

tff(pred_def_56738,type,
    v101822: state_type > $o ).

tff(pred_def_56739,type,
    v101842: state_type > $o ).

tff(pred_def_56740,type,
    v101840: state_type > $o ).

tff(pred_def_56741,type,
    v101846: state_type > $o ).

tff(pred_def_56742,type,
    v101844: state_type > $o ).

tff(pred_def_56743,type,
    v101834: ( state_type * $int ) > $o ).

tff(pred_def_56744,type,
    v101864: state_type > $o ).

tff(pred_def_56745,type,
    v101865: state_type > $o ).

tff(pred_def_56746,type,
    v101863: state_type > $o ).

tff(pred_def_56747,type,
    v101866: state_type > $o ).

tff(pred_def_56748,type,
    v101862: state_type > $o ).

tff(pred_def_56749,type,
    v101867: state_type > $o ).

tff(pred_def_56750,type,
    v101861: state_type > $o ).

tff(pred_def_56751,type,
    v101868: state_type > $o ).

tff(pred_def_56752,type,
    v101860: state_type > $o ).

tff(pred_def_56753,type,
    v101869: state_type > $o ).

tff(pred_def_56754,type,
    v101859: state_type > $o ).

tff(pred_def_56755,type,
    v101857: state_type > $o ).

tff(pred_def_56756,type,
    v101812: state_type > $o ).

tff(pred_def_56757,type,
    v101856: state_type > $o ).

tff(pred_def_56758,type,
    v101882: state_type > $o ).

tff(pred_def_56759,type,
    v101881: state_type > $o ).

tff(pred_def_56760,type,
    v101880: state_type > $o ).

tff(pred_def_56761,type,
    v101879: state_type > $o ).

tff(pred_def_56762,type,
    v101878: state_type > $o ).

tff(pred_def_56763,type,
    v101877: state_type > $o ).

tff(pred_def_56764,type,
    v101876: state_type > $o ).

tff(pred_def_56765,type,
    v101875: state_type > $o ).

tff(pred_def_56766,type,
    v101874: state_type > $o ).

tff(pred_def_56767,type,
    v101873: state_type > $o ).

tff(pred_def_56768,type,
    v101883: state_type > $o ).

tff(pred_def_56769,type,
    v101872: state_type > $o ).

tff(pred_def_56770,type,
    v101886: state_type > $o ).

tff(pred_def_56771,type,
    v101885: state_type > $o ).

tff(pred_def_56772,type,
    v101887: state_type > $o ).

tff(pred_def_56773,type,
    v101884: state_type > $o ).

tff(pred_def_56774,type,
    v101890: state_type > $o ).

tff(pred_def_56775,type,
    v101889: state_type > $o ).

tff(pred_def_56776,type,
    v101891: state_type > $o ).

tff(pred_def_56777,type,
    v101888: state_type > $o ).

tff(pred_def_56778,type,
    v101894: state_type > $o ).

tff(pred_def_56779,type,
    v101893: state_type > $o ).

tff(pred_def_56780,type,
    v101895: state_type > $o ).

tff(pred_def_56781,type,
    v101892: state_type > $o ).

tff(pred_def_56782,type,
    v101897: state_type > $o ).

tff(pred_def_56783,type,
    v101898: state_type > $o ).

tff(pred_def_56784,type,
    v101896: state_type > $o ).

tff(pred_def_56785,type,
    v101870: ( state_type * $int ) > $o ).

tff(pred_def_56786,type,
    v101901: state_type > $o ).

tff(pred_def_56787,type,
    v101908: state_type > $o ).

tff(pred_def_56788,type,
    v101907: state_type > $o ).

tff(pred_def_56789,type,
    v101906: state_type > $o ).

tff(pred_def_56790,type,
    v101905: state_type > $o ).

tff(pred_def_56791,type,
    v101904: state_type > $o ).

tff(pred_def_56792,type,
    v101902: state_type > $o ).

tff(pred_def_56793,type,
    v101900: state_type > $o ).

tff(pred_def_56794,type,
    v101916: state_type > $o ).

tff(pred_def_56795,type,
    v101915: state_type > $o ).

tff(pred_def_56796,type,
    v101914: state_type > $o ).

tff(pred_def_56797,type,
    v101913: state_type > $o ).

tff(pred_def_56798,type,
    v101912: state_type > $o ).

tff(pred_def_56799,type,
    v101917: state_type > $o ).

tff(pred_def_56800,type,
    v101911: state_type > $o ).

tff(pred_def_56801,type,
    v101920: state_type > $o ).

tff(pred_def_56802,type,
    v101919: state_type > $o ).

tff(pred_def_56803,type,
    v101921: state_type > $o ).

tff(pred_def_56804,type,
    v101918: state_type > $o ).

tff(pred_def_56805,type,
    v101924: state_type > $o ).

tff(pred_def_56806,type,
    v101923: state_type > $o ).

tff(pred_def_56807,type,
    v101925: state_type > $o ).

tff(pred_def_56808,type,
    v101922: state_type > $o ).

tff(pred_def_56809,type,
    v101928: state_type > $o ).

tff(pred_def_56810,type,
    v101927: state_type > $o ).

tff(pred_def_56811,type,
    v101929: state_type > $o ).

tff(pred_def_56812,type,
    v101926: state_type > $o ).

tff(pred_def_56813,type,
    v101931: state_type > $o ).

tff(pred_def_56814,type,
    v101932: state_type > $o ).

tff(pred_def_56815,type,
    v101930: state_type > $o ).

tff(pred_def_56816,type,
    v101909: ( state_type * $int ) > $o ).

tff(pred_def_56817,type,
    v101899: ( state_type * $int ) > $o ).

tff(pred_def_56818,type,
    v101854: ( state_type * $int ) > $o ).

tff(pred_def_56819,type,
    v101852: ( state_type * $int ) > $o ).

tff(pred_def_56820,type,
    v89413: ( state_type * $int ) > $o ).

tff(pred_def_56821,type,
    v101947: state_type > $o ).

tff(pred_def_56822,type,
    v101946: state_type > $o ).

tff(pred_def_56823,type,
    v101945: state_type > $o ).

tff(pred_def_56824,type,
    v101944: state_type > $o ).

tff(pred_def_56825,type,
    v101943: state_type > $o ).

tff(pred_def_56826,type,
    v101942: state_type > $o ).

tff(pred_def_56827,type,
    v101940: state_type > $o ).

tff(pred_def_56828,type,
    v101939: state_type > $o ).

tff(pred_def_56829,type,
    v101948: state_type > $o ).

tff(pred_def_56830,type,
    v101938: state_type > $o ).

tff(pred_def_56831,type,
    v101832: state_type > $o ).

tff(pred_def_56832,type,
    v101949: state_type > $o ).

tff(pred_def_56833,type,
    v101936: state_type > $o ).

tff(pred_def_56834,type,
    v101934: state_type > $o ).

tff(pred_def_56835,type,
    v101953: state_type > $o ).

tff(pred_def_56836,type,
    v101952: ( state_type * $int ) > $o ).

tff(pred_def_56837,type,
    v101951: ( state_type * $int ) > $o ).

tff(pred_def_56838,type,
    v101850: ( state_type * $int ) > $o ).

tff(pred_def_56839,type,
    v101848: ( state_type * $int ) > $o ).

tff(pred_def_56840,type,
    v101957: state_type > $o ).

tff(pred_def_56841,type,
    v101955: state_type > $o ).

tff(pred_def_56842,type,
    v101964: state_type > $o ).

tff(pred_def_56843,type,
    v101962: state_type > $o ).

tff(pred_def_56844,type,
    v101961: state_type > $o ).

tff(pred_def_56845,type,
    v101960: state_type > $o ).

tff(pred_def_56846,type,
    v101972: state_type > $o ).

tff(pred_def_56847,type,
    v101973: state_type > $o ).

tff(pred_def_56848,type,
    v101971: state_type > $o ).

tff(pred_def_56849,type,
    v101968: ( state_type * $int ) > $o ).

tff(pred_def_56850,type,
    v101970: ( state_type * $int ) > $o ).

tff(pred_def_56851,type,
    v101838: ( state_type * $int ) > $o ).

tff(pred_def_56852,type,
    v101836: ( state_type * $int ) > $o ).

tff(pred_def_56853,type,
    v101830: state_type > $o ).

tff(pred_def_56854,type,
    v101978: state_type > $o ).

tff(pred_def_56855,type,
    v101982: state_type > $o ).

tff(pred_def_56856,type,
    v101980: state_type > $o ).

tff(pred_def_56857,type,
    v101988: state_type > $o ).

tff(pred_def_56858,type,
    v101987: state_type > $o ).

tff(pred_def_56859,type,
    v101986: state_type > $o ).

tff(pred_def_56860,type,
    v101991: state_type > $o ).

tff(pred_def_56861,type,
    v101990: state_type > $o ).

tff(pred_def_56862,type,
    v101989: state_type > $o ).

tff(pred_def_56863,type,
    v101985: state_type > $o ).

tff(pred_def_56864,type,
    v101996: state_type > $o ).

tff(pred_def_56865,type,
    v101995: state_type > $o ).

tff(pred_def_56866,type,
    v101994: state_type > $o ).

tff(pred_def_56867,type,
    v101814: state_type > $o ).

tff(pred_def_56868,type,
    v101993: state_type > $o ).

tff(pred_def_56869,type,
    v101999: state_type > $o ).

tff(pred_def_56870,type,
    v101998: state_type > $o ).

tff(pred_def_56871,type,
    v101997: state_type > $o ).

tff(pred_def_56872,type,
    v101992: state_type > $o ).

tff(pred_def_56873,type,
    v101828: state_type > $o ).

tff(pred_def_56874,type,
    v101826: state_type > $o ).

tff(pred_def_56875,type,
    v102003: state_type > $o ).

tff(pred_def_56876,type,
    v102001: state_type > $o ).

tff(pred_def_56877,type,
    v102010: state_type > $o ).

tff(pred_def_56878,type,
    v102008: state_type > $o ).

tff(pred_def_56879,type,
    v102007: state_type > $o ).

tff(pred_def_56880,type,
    v102006: state_type > $o ).

tff(pred_def_56881,type,
    v102018: state_type > $o ).

tff(pred_def_56882,type,
    v102019: state_type > $o ).

tff(pred_def_56883,type,
    v102017: state_type > $o ).

tff(pred_def_56884,type,
    v102014: state_type > $o ).

tff(pred_def_56885,type,
    v102016: state_type > $o ).

tff(pred_def_56886,type,
    v101816: state_type > $o ).

tff(pred_def_56887,type,
    v101598: state_type > $o ).

tff(pred_def_56888,type,
    v102033: state_type > $o ).

tff(pred_def_56889,type,
    v102032: state_type > $o ).

tff(pred_def_56890,type,
    v102031: state_type > $o ).

tff(pred_def_56891,type,
    v102030: state_type > $o ).

tff(pred_def_56892,type,
    v102029: state_type > $o ).

tff(pred_def_56893,type,
    v102028: state_type > $o ).

tff(pred_def_56894,type,
    v102026: state_type > $o ).

tff(pred_def_56895,type,
    v102034: ( state_type * $int ) > $o ).

tff(pred_def_56896,type,
    v89243: ( state_type * $int ) > $o ).

tff(pred_def_56897,type,
    v102035: ( state_type * $int ) > $o ).

tff(pred_def_56898,type,
    v102025: ( state_type * $int ) > $o ).

tff(pred_def_56899,type,
    v102024: ( state_type * $int ) > $o ).

tff(pred_def_56900,type,
    v102038: state_type > $o ).

tff(pred_def_56901,type,
    v102039: ( state_type * $int ) > $o ).

tff(pred_def_56902,type,
    v102042: state_type > $o ).

tff(pred_def_56903,type,
    v102050: state_type > $o ).

tff(pred_def_56904,type,
    v102049: state_type > $o ).

tff(pred_def_56905,type,
    v102048: state_type > $o ).

tff(pred_def_56906,type,
    v102047: state_type > $o ).

tff(pred_def_56907,type,
    v102046: state_type > $o ).

tff(pred_def_56908,type,
    v102045: state_type > $o ).

tff(pred_def_56909,type,
    v102043: state_type > $o ).

tff(pred_def_56910,type,
    v102041: state_type > $o ).

tff(pred_def_56911,type,
    v102052: ( state_type * $int ) > $o ).

tff(pred_def_56912,type,
    v102051: ( state_type * $int ) > $o ).

tff(pred_def_56913,type,
    b000000000: $int > $o ).

tff(pred_def_56914,type,
    v102040: ( state_type * $int ) > $o ).

tff(pred_def_56915,type,
    v102037: ( state_type * $int ) > $o ).

tff(pred_def_56916,type,
    v101596: ( state_type * $int ) > $o ).

tff(pred_def_56917,type,
    v102055: state_type > $o ).

tff(pred_def_56918,type,
    v102054: ( state_type * $int ) > $o ).

tff(pred_def_56919,type,
    v82954: state_type > $o ).

tff(pred_def_56920,type,
    v83096: state_type > $o ).

tff(pred_def_56921,type,
    v102057: state_type > $o ).

tff(pred_def_56922,type,
    v102059: state_type > $o ).

tff(pred_def_56923,type,
    v102058: ( state_type * $int ) > $o ).

tff(pred_def_56924,type,
    v102060: state_type > $o ).

tff(pred_def_56925,type,
    v101570: ( state_type * $int ) > $o ).

tff(pred_def_56926,type,
    v102061: ( state_type * $int ) > $o ).

tff(pred_def_56927,type,
    v102056: ( state_type * $int ) > $o ).

tff(pred_def_56928,type,
    v102053: ( state_type * $int ) > $o ).

tff(pred_def_56929,type,
    v101594: ( state_type * $int ) > $o ).

tff(pred_def_56930,type,
    v101592: ( state_type * $int ) > $o ).

tff(pred_def_56931,type,
    v102062: ( state_type * $int ) > $o ).

tff(pred_def_56932,type,
    v101590: ( state_type * $int ) > $o ).

tff(pred_def_56933,type,
    v102064: state_type > $o ).

tff(pred_def_56934,type,
    v102068: state_type > $o ).

tff(pred_def_56935,type,
    v102067: ( state_type * $int ) > $o ).

tff(pred_def_56936,type,
    v102066: ( state_type * $int ) > $o ).

tff(pred_def_56937,type,
    v102072: state_type > $o ).

tff(pred_def_56938,type,
    v102071: ( state_type * $int ) > $o ).

tff(pred_def_56939,type,
    v102070: ( state_type * $int ) > $o ).

tff(pred_def_56940,type,
    v101574: ( state_type * $int ) > $o ).

tff(pred_def_56941,type,
    v102069: ( state_type * $int ) > $o ).

tff(pred_def_56942,type,
    v102065: ( state_type * $int ) > $o ).

tff(pred_def_56943,type,
    v101588: ( state_type * $int ) > $o ).

tff(pred_def_56944,type,
    v101586: ( state_type * $int ) > $o ).

tff(pred_def_56945,type,
    v102076: state_type > $o ).

tff(pred_def_56946,type,
    v102074: state_type > $o ).

tff(pred_def_56947,type,
    v102083: state_type > $o ).

tff(pred_def_56948,type,
    v102081: state_type > $o ).

tff(pred_def_56949,type,
    v102080: state_type > $o ).

tff(pred_def_56950,type,
    v102079: state_type > $o ).

tff(pred_def_56951,type,
    v102091: state_type > $o ).

tff(pred_def_56952,type,
    v102092: state_type > $o ).

tff(pred_def_56953,type,
    v102090: state_type > $o ).

tff(pred_def_56954,type,
    v102087: ( state_type * $int ) > $o ).

tff(pred_def_56955,type,
    v102089: ( state_type * $int ) > $o ).

tff(pred_def_56956,type,
    v102078: ( state_type * $int ) > $o ).

tff(pred_def_56957,type,
    v101576: ( state_type * $int ) > $o ).

tff(pred_def_56958,type,
    v102100: state_type > $o ).

tff(pred_def_56959,type,
    v102098: state_type > $o ).

tff(pred_def_56960,type,
    v102097: state_type > $o ).

tff(pred_def_56961,type,
    v102096: ( state_type * $int ) > $o ).

tff(pred_def_56962,type,
    v102108: state_type > $o ).

tff(pred_def_56963,type,
    v102106: state_type > $o ).

tff(pred_def_56964,type,
    v102105: state_type > $o ).

tff(pred_def_56965,type,
    v102104: ( state_type * $int ) > $o ).

tff(pred_def_56966,type,
    v102116: state_type > $o ).

tff(pred_def_56967,type,
    v102114: state_type > $o ).

tff(pred_def_56968,type,
    v102113: state_type > $o ).

tff(pred_def_56969,type,
    v102112: ( state_type * $int ) > $o ).

tff(pred_def_56970,type,
    v102124: state_type > $o ).

tff(pred_def_56971,type,
    v102122: state_type > $o ).

tff(pred_def_56972,type,
    v102121: state_type > $o ).

tff(pred_def_56973,type,
    v102120: ( state_type * $int ) > $o ).

tff(pred_def_56974,type,
    v102132: state_type > $o ).

tff(pred_def_56975,type,
    v102130: state_type > $o ).

tff(pred_def_56976,type,
    v102129: state_type > $o ).

tff(pred_def_56977,type,
    v102128: ( state_type * $int ) > $o ).

tff(pred_def_56978,type,
    v102140: state_type > $o ).

tff(pred_def_56979,type,
    v102138: state_type > $o ).

tff(pred_def_56980,type,
    v102137: state_type > $o ).

tff(pred_def_56981,type,
    v102136: ( state_type * $int ) > $o ).

tff(pred_def_56982,type,
    v102148: state_type > $o ).

tff(pred_def_56983,type,
    v102146: state_type > $o ).

tff(pred_def_56984,type,
    v102145: state_type > $o ).

tff(pred_def_56985,type,
    v102144: ( state_type * $int ) > $o ).

tff(pred_def_56986,type,
    v102156: state_type > $o ).

tff(pred_def_56987,type,
    v102154: state_type > $o ).

tff(pred_def_56988,type,
    v102153: state_type > $o ).

tff(pred_def_56989,type,
    v102152: ( state_type * $int ) > $o ).

tff(pred_def_56990,type,
    v102164: state_type > $o ).

tff(pred_def_56991,type,
    v102162: state_type > $o ).

tff(pred_def_56992,type,
    v102161: state_type > $o ).

tff(pred_def_56993,type,
    v102160: ( state_type * $int ) > $o ).

tff(pred_def_56994,type,
    v102172: state_type > $o ).

tff(pred_def_56995,type,
    v102170: state_type > $o ).

tff(pred_def_56996,type,
    v102169: state_type > $o ).

tff(pred_def_56997,type,
    v102168: ( state_type * $int ) > $o ).

tff(pred_def_56998,type,
    v102180: state_type > $o ).

tff(pred_def_56999,type,
    v102178: state_type > $o ).

tff(pred_def_57000,type,
    v102177: state_type > $o ).

tff(pred_def_57001,type,
    v102176: ( state_type * $int ) > $o ).

tff(pred_def_57002,type,
    v102188: state_type > $o ).

tff(pred_def_57003,type,
    v102186: state_type > $o ).

tff(pred_def_57004,type,
    v102185: state_type > $o ).

tff(pred_def_57005,type,
    v102184: ( state_type * $int ) > $o ).

tff(pred_def_57006,type,
    v102196: state_type > $o ).

tff(pred_def_57007,type,
    v102194: state_type > $o ).

tff(pred_def_57008,type,
    v102193: state_type > $o ).

tff(pred_def_57009,type,
    v102192: ( state_type * $int ) > $o ).

tff(pred_def_57010,type,
    v102204: state_type > $o ).

tff(pred_def_57011,type,
    v102202: state_type > $o ).

tff(pred_def_57012,type,
    v102201: state_type > $o ).

tff(pred_def_57013,type,
    v102200: ( state_type * $int ) > $o ).

tff(pred_def_57014,type,
    v102212: state_type > $o ).

tff(pred_def_57015,type,
    v102210: state_type > $o ).

tff(pred_def_57016,type,
    v102209: state_type > $o ).

tff(pred_def_57017,type,
    v102208: ( state_type * $int ) > $o ).

tff(pred_def_57018,type,
    v102220: state_type > $o ).

tff(pred_def_57019,type,
    v102218: state_type > $o ).

tff(pred_def_57020,type,
    v102217: state_type > $o ).

tff(pred_def_57021,type,
    v102216: ( state_type * $int ) > $o ).

tff(pred_def_57022,type,
    v102228: state_type > $o ).

tff(pred_def_57023,type,
    v102226: state_type > $o ).

tff(pred_def_57024,type,
    v102225: state_type > $o ).

tff(pred_def_57025,type,
    v102224: ( state_type * $int ) > $o ).

tff(pred_def_57026,type,
    v102234: state_type > $o ).

tff(pred_def_57027,type,
    v5687: state_type > $o ).

tff(pred_def_57028,type,
    v102233: ( state_type * $int ) > $o ).

tff(pred_def_57029,type,
    v102232: ( state_type * $int ) > $o ).

tff(pred_def_57030,type,
    v102238: state_type > $o ).

tff(pred_def_57031,type,
    v102237: ( state_type * $int ) > $o ).

tff(pred_def_57032,type,
    v102236: ( state_type * $int ) > $o ).

tff(pred_def_57033,type,
    v102235: ( state_type * $int ) > $o ).

tff(pred_def_57034,type,
    v102231: ( state_type * $int ) > $o ).

tff(pred_def_57035,type,
    v900: ( state_type * $int ) > $o ).

tff(pred_def_57036,type,
    v898: ( state_type * $int ) > $o ).

tff(pred_def_57037,type,
    v102242: state_type > $o ).

tff(pred_def_57038,type,
    v102240: state_type > $o ).

tff(pred_def_57039,type,
    v102249: state_type > $o ).

tff(pred_def_57040,type,
    v102247: state_type > $o ).

tff(pred_def_57041,type,
    v102246: state_type > $o ).

tff(pred_def_57042,type,
    v102245: state_type > $o ).

tff(pred_def_57043,type,
    v102257: state_type > $o ).

tff(pred_def_57044,type,
    v102258: state_type > $o ).

tff(pred_def_57045,type,
    v102256: state_type > $o ).

tff(pred_def_57046,type,
    v102253: ( state_type * $int ) > $o ).

tff(pred_def_57047,type,
    v102255: ( state_type * $int ) > $o ).

tff(pred_def_57048,type,
    v102244: ( state_type * $int ) > $o ).

tff(pred_def_57049,type,
    v102264: state_type > $o ).

tff(pred_def_57050,type,
    v102262: state_type > $o ).

tff(pred_def_57051,type,
    v102268: state_type > $o ).

tff(pred_def_57052,type,
    v102266: state_type > $o ).

tff(pred_def_57053,type,
    v102274: ( state_type * $int ) > $o ).

tff(pred_def_57054,type,
    v102280: state_type > $o ).

tff(pred_def_57055,type,
    v5745: state_type > $o ).

tff(pred_def_57056,type,
    v102278: state_type > $o ).

tff(pred_def_57057,type,
    v102276: state_type > $o ).

tff(pred_def_57058,type,
    v102284: state_type > $o ).

tff(pred_def_57059,type,
    v102283: ( state_type * $int ) > $o ).

tff(pred_def_57060,type,
    v102282: ( state_type * $int ) > $o ).

tff(pred_def_57061,type,
    v102288: state_type > $o ).

tff(pred_def_57062,type,
    v102287: ( state_type * $int ) > $o ).

tff(pred_def_57063,type,
    v102286: ( state_type * $int ) > $o ).

tff(pred_def_57064,type,
    v102285: ( state_type * $int ) > $o ).

tff(pred_def_57065,type,
    v102281: ( state_type * $int ) > $o ).

tff(pred_def_57066,type,
    v102272: ( state_type * $int ) > $o ).

tff(pred_def_57067,type,
    v102270: ( state_type * $int ) > $o ).

tff(pred_def_57068,type,
    v102292: state_type > $o ).

tff(pred_def_57069,type,
    v102290: state_type > $o ).

tff(pred_def_57070,type,
    v102299: state_type > $o ).

tff(pred_def_57071,type,
    v102297: state_type > $o ).

tff(pred_def_57072,type,
    v102296: state_type > $o ).

tff(pred_def_57073,type,
    v102295: state_type > $o ).

tff(pred_def_57074,type,
    v102307: state_type > $o ).

tff(pred_def_57075,type,
    v102308: state_type > $o ).

tff(pred_def_57076,type,
    v102306: state_type > $o ).

tff(pred_def_57077,type,
    v102303: ( state_type * $int ) > $o ).

tff(pred_def_57078,type,
    v102305: ( state_type * $int ) > $o ).

tff(pred_def_57079,type,
    v102294: ( state_type * $int ) > $o ).

tff(pred_def_57080,type,
    v102314: state_type > $o ).

tff(pred_def_57081,type,
    v102312: state_type > $o ).

tff(pred_def_57082,type,
    v102318: state_type > $o ).

tff(pred_def_57083,type,
    v102316: state_type > $o ).

tff(pred_def_57084,type,
    v102324: ( state_type * $int ) > $o ).

tff(pred_def_57085,type,
    v102330: state_type > $o ).

tff(pred_def_57086,type,
    v102328: state_type > $o ).

tff(pred_def_57087,type,
    v102326: state_type > $o ).

tff(pred_def_57088,type,
    v102334: state_type > $o ).

tff(pred_def_57089,type,
    v102333: ( state_type * $int ) > $o ).

tff(pred_def_57090,type,
    v102332: ( state_type * $int ) > $o ).

tff(pred_def_57091,type,
    v102338: state_type > $o ).

tff(pred_def_57092,type,
    v102337: ( state_type * $int ) > $o ).

tff(pred_def_57093,type,
    v102336: ( state_type * $int ) > $o ).

tff(pred_def_57094,type,
    v102335: ( state_type * $int ) > $o ).

tff(pred_def_57095,type,
    v102331: ( state_type * $int ) > $o ).

tff(pred_def_57096,type,
    v102322: ( state_type * $int ) > $o ).

tff(pred_def_57097,type,
    v102320: ( state_type * $int ) > $o ).

tff(pred_def_57098,type,
    v102342: state_type > $o ).

tff(pred_def_57099,type,
    v102340: state_type > $o ).

tff(pred_def_57100,type,
    v102349: state_type > $o ).

tff(pred_def_57101,type,
    v102347: state_type > $o ).

tff(pred_def_57102,type,
    v102346: state_type > $o ).

tff(pred_def_57103,type,
    v102345: state_type > $o ).

tff(pred_def_57104,type,
    v102357: state_type > $o ).

tff(pred_def_57105,type,
    v102358: state_type > $o ).

tff(pred_def_57106,type,
    v102356: state_type > $o ).

tff(pred_def_57107,type,
    v102353: ( state_type * $int ) > $o ).

tff(pred_def_57108,type,
    v102355: ( state_type * $int ) > $o ).

tff(pred_def_57109,type,
    v102344: ( state_type * $int ) > $o ).

tff(pred_def_57110,type,
    v102364: state_type > $o ).

tff(pred_def_57111,type,
    v102362: state_type > $o ).

tff(pred_def_57112,type,
    v102368: state_type > $o ).

tff(pred_def_57113,type,
    v102366: state_type > $o ).

tff(pred_def_57114,type,
    v102374: ( state_type * $int ) > $o ).

tff(pred_def_57115,type,
    v102380: state_type > $o ).

tff(pred_def_57116,type,
    v102378: state_type > $o ).

tff(pred_def_57117,type,
    v102376: state_type > $o ).

tff(pred_def_57118,type,
    v102384: state_type > $o ).

tff(pred_def_57119,type,
    v102383: ( state_type * $int ) > $o ).

tff(pred_def_57120,type,
    v102382: ( state_type * $int ) > $o ).

tff(pred_def_57121,type,
    v102388: state_type > $o ).

tff(pred_def_57122,type,
    v102387: ( state_type * $int ) > $o ).

tff(pred_def_57123,type,
    v102386: ( state_type * $int ) > $o ).

tff(pred_def_57124,type,
    v102385: ( state_type * $int ) > $o ).

tff(pred_def_57125,type,
    v102381: ( state_type * $int ) > $o ).

tff(pred_def_57126,type,
    v102372: ( state_type * $int ) > $o ).

tff(pred_def_57127,type,
    v102370: ( state_type * $int ) > $o ).

tff(pred_def_57128,type,
    v102392: state_type > $o ).

tff(pred_def_57129,type,
    v102390: state_type > $o ).

tff(pred_def_57130,type,
    v102399: state_type > $o ).

tff(pred_def_57131,type,
    v102397: state_type > $o ).

tff(pred_def_57132,type,
    v102396: state_type > $o ).

tff(pred_def_57133,type,
    v102395: state_type > $o ).

tff(pred_def_57134,type,
    v102407: state_type > $o ).

tff(pred_def_57135,type,
    v102408: state_type > $o ).

tff(pred_def_57136,type,
    v102406: state_type > $o ).

tff(pred_def_57137,type,
    v102403: ( state_type * $int ) > $o ).

tff(pred_def_57138,type,
    v102405: ( state_type * $int ) > $o ).

tff(pred_def_57139,type,
    v102394: ( state_type * $int ) > $o ).

tff(pred_def_57140,type,
    v102414: state_type > $o ).

tff(pred_def_57141,type,
    v102412: state_type > $o ).

tff(pred_def_57142,type,
    v102418: state_type > $o ).

tff(pred_def_57143,type,
    v102416: state_type > $o ).

tff(pred_def_57144,type,
    v102424: ( state_type * $int ) > $o ).

tff(pred_def_57145,type,
    v102430: state_type > $o ).

tff(pred_def_57146,type,
    v102428: state_type > $o ).

tff(pred_def_57147,type,
    v102426: state_type > $o ).

tff(pred_def_57148,type,
    v102434: state_type > $o ).

tff(pred_def_57149,type,
    v102433: ( state_type * $int ) > $o ).

tff(pred_def_57150,type,
    v102432: ( state_type * $int ) > $o ).

tff(pred_def_57151,type,
    v102438: state_type > $o ).

tff(pred_def_57152,type,
    v102437: ( state_type * $int ) > $o ).

tff(pred_def_57153,type,
    v102436: ( state_type * $int ) > $o ).

tff(pred_def_57154,type,
    v102435: ( state_type * $int ) > $o ).

tff(pred_def_57155,type,
    v102431: ( state_type * $int ) > $o ).

tff(pred_def_57156,type,
    v102422: ( state_type * $int ) > $o ).

tff(pred_def_57157,type,
    v102420: ( state_type * $int ) > $o ).

tff(pred_def_57158,type,
    v102442: state_type > $o ).

tff(pred_def_57159,type,
    v102440: state_type > $o ).

tff(pred_def_57160,type,
    v102449: state_type > $o ).

tff(pred_def_57161,type,
    v102447: state_type > $o ).

tff(pred_def_57162,type,
    v102446: state_type > $o ).

tff(pred_def_57163,type,
    v102445: state_type > $o ).

tff(pred_def_57164,type,
    v102457: state_type > $o ).

tff(pred_def_57165,type,
    v102458: state_type > $o ).

tff(pred_def_57166,type,
    v102456: state_type > $o ).

tff(pred_def_57167,type,
    v102453: ( state_type * $int ) > $o ).

tff(pred_def_57168,type,
    v102455: ( state_type * $int ) > $o ).

tff(pred_def_57169,type,
    v102444: ( state_type * $int ) > $o ).

tff(pred_def_57170,type,
    v102464: state_type > $o ).

tff(pred_def_57171,type,
    v102462: state_type > $o ).

tff(pred_def_57172,type,
    v102468: state_type > $o ).

tff(pred_def_57173,type,
    v102466: state_type > $o ).

tff(pred_def_57174,type,
    v102474: ( state_type * $int ) > $o ).

tff(pred_def_57175,type,
    v102480: state_type > $o ).

tff(pred_def_57176,type,
    v102478: state_type > $o ).

tff(pred_def_57177,type,
    v102476: state_type > $o ).

tff(pred_def_57178,type,
    v102484: state_type > $o ).

tff(pred_def_57179,type,
    v102483: ( state_type * $int ) > $o ).

tff(pred_def_57180,type,
    v102482: ( state_type * $int ) > $o ).

tff(pred_def_57181,type,
    v102488: state_type > $o ).

tff(pred_def_57182,type,
    v102487: ( state_type * $int ) > $o ).

tff(pred_def_57183,type,
    v102486: ( state_type * $int ) > $o ).

tff(pred_def_57184,type,
    v102485: ( state_type * $int ) > $o ).

tff(pred_def_57185,type,
    v102481: ( state_type * $int ) > $o ).

tff(pred_def_57186,type,
    v102472: ( state_type * $int ) > $o ).

tff(pred_def_57187,type,
    v102470: ( state_type * $int ) > $o ).

tff(pred_def_57188,type,
    v102492: state_type > $o ).

tff(pred_def_57189,type,
    v102490: state_type > $o ).

tff(pred_def_57190,type,
    v102499: state_type > $o ).

tff(pred_def_57191,type,
    v102497: state_type > $o ).

tff(pred_def_57192,type,
    v102496: state_type > $o ).

tff(pred_def_57193,type,
    v102495: state_type > $o ).

tff(pred_def_57194,type,
    v102507: state_type > $o ).

tff(pred_def_57195,type,
    v102508: state_type > $o ).

tff(pred_def_57196,type,
    v102506: state_type > $o ).

tff(pred_def_57197,type,
    v102503: ( state_type * $int ) > $o ).

tff(pred_def_57198,type,
    v102505: ( state_type * $int ) > $o ).

tff(pred_def_57199,type,
    v102494: ( state_type * $int ) > $o ).

tff(pred_def_57200,type,
    v102514: state_type > $o ).

tff(pred_def_57201,type,
    v102512: state_type > $o ).

tff(pred_def_57202,type,
    v102518: state_type > $o ).

tff(pred_def_57203,type,
    v102516: state_type > $o ).

tff(pred_def_57204,type,
    v102524: ( state_type * $int ) > $o ).

tff(pred_def_57205,type,
    v102530: state_type > $o ).

tff(pred_def_57206,type,
    v102528: state_type > $o ).

tff(pred_def_57207,type,
    v102526: state_type > $o ).

tff(pred_def_57208,type,
    v102534: state_type > $o ).

tff(pred_def_57209,type,
    v102533: ( state_type * $int ) > $o ).

tff(pred_def_57210,type,
    v102532: ( state_type * $int ) > $o ).

tff(pred_def_57211,type,
    v102538: state_type > $o ).

tff(pred_def_57212,type,
    v102537: ( state_type * $int ) > $o ).

tff(pred_def_57213,type,
    v102536: ( state_type * $int ) > $o ).

tff(pred_def_57214,type,
    v102535: ( state_type * $int ) > $o ).

tff(pred_def_57215,type,
    v102531: ( state_type * $int ) > $o ).

tff(pred_def_57216,type,
    v102522: ( state_type * $int ) > $o ).

tff(pred_def_57217,type,
    v102520: ( state_type * $int ) > $o ).

tff(pred_def_57218,type,
    v102542: state_type > $o ).

tff(pred_def_57219,type,
    v102540: state_type > $o ).

tff(pred_def_57220,type,
    v102549: state_type > $o ).

tff(pred_def_57221,type,
    v102547: state_type > $o ).

tff(pred_def_57222,type,
    v102546: state_type > $o ).

tff(pred_def_57223,type,
    v102545: state_type > $o ).

tff(pred_def_57224,type,
    v102557: state_type > $o ).

tff(pred_def_57225,type,
    v102558: state_type > $o ).

tff(pred_def_57226,type,
    v102556: state_type > $o ).

tff(pred_def_57227,type,
    v102553: ( state_type * $int ) > $o ).

tff(pred_def_57228,type,
    v102555: ( state_type * $int ) > $o ).

tff(pred_def_57229,type,
    v102544: ( state_type * $int ) > $o ).

tff(pred_def_57230,type,
    v102564: state_type > $o ).

tff(pred_def_57231,type,
    v102562: state_type > $o ).

tff(pred_def_57232,type,
    v102568: state_type > $o ).

tff(pred_def_57233,type,
    v102566: state_type > $o ).

tff(pred_def_57234,type,
    v102574: ( state_type * $int ) > $o ).

tff(pred_def_57235,type,
    v102580: state_type > $o ).

tff(pred_def_57236,type,
    v102578: state_type > $o ).

tff(pred_def_57237,type,
    v102576: state_type > $o ).

tff(pred_def_57238,type,
    v102584: state_type > $o ).

tff(pred_def_57239,type,
    v102583: ( state_type * $int ) > $o ).

tff(pred_def_57240,type,
    v102582: ( state_type * $int ) > $o ).

tff(pred_def_57241,type,
    v102588: state_type > $o ).

tff(pred_def_57242,type,
    v102587: ( state_type * $int ) > $o ).

tff(pred_def_57243,type,
    v102586: ( state_type * $int ) > $o ).

tff(pred_def_57244,type,
    v102585: ( state_type * $int ) > $o ).

tff(pred_def_57245,type,
    v102581: ( state_type * $int ) > $o ).

tff(pred_def_57246,type,
    v102572: ( state_type * $int ) > $o ).

tff(pred_def_57247,type,
    v102570: ( state_type * $int ) > $o ).

tff(pred_def_57248,type,
    v102592: state_type > $o ).

tff(pred_def_57249,type,
    v102590: state_type > $o ).

tff(pred_def_57250,type,
    v102599: state_type > $o ).

tff(pred_def_57251,type,
    v102597: state_type > $o ).

tff(pred_def_57252,type,
    v102596: state_type > $o ).

tff(pred_def_57253,type,
    v102595: state_type > $o ).

tff(pred_def_57254,type,
    v102607: state_type > $o ).

tff(pred_def_57255,type,
    v102608: state_type > $o ).

tff(pred_def_57256,type,
    v102606: state_type > $o ).

tff(pred_def_57257,type,
    v102603: ( state_type * $int ) > $o ).

tff(pred_def_57258,type,
    v102605: ( state_type * $int ) > $o ).

tff(pred_def_57259,type,
    v102594: ( state_type * $int ) > $o ).

tff(pred_def_57260,type,
    v102614: state_type > $o ).

tff(pred_def_57261,type,
    v102612: state_type > $o ).

tff(pred_def_57262,type,
    v102618: state_type > $o ).

tff(pred_def_57263,type,
    v102616: state_type > $o ).

tff(pred_def_57264,type,
    v102624: ( state_type * $int ) > $o ).

tff(pred_def_57265,type,
    v102630: state_type > $o ).

tff(pred_def_57266,type,
    v102628: state_type > $o ).

tff(pred_def_57267,type,
    v102626: state_type > $o ).

tff(pred_def_57268,type,
    v102634: state_type > $o ).

tff(pred_def_57269,type,
    v102633: ( state_type * $int ) > $o ).

tff(pred_def_57270,type,
    v102632: ( state_type * $int ) > $o ).

tff(pred_def_57271,type,
    v102638: state_type > $o ).

tff(pred_def_57272,type,
    v102637: ( state_type * $int ) > $o ).

tff(pred_def_57273,type,
    v102636: ( state_type * $int ) > $o ).

tff(pred_def_57274,type,
    v102635: ( state_type * $int ) > $o ).

tff(pred_def_57275,type,
    v102631: ( state_type * $int ) > $o ).

tff(pred_def_57276,type,
    v102622: ( state_type * $int ) > $o ).

tff(pred_def_57277,type,
    v102620: ( state_type * $int ) > $o ).

tff(pred_def_57278,type,
    v102642: state_type > $o ).

tff(pred_def_57279,type,
    v102640: state_type > $o ).

tff(pred_def_57280,type,
    v102649: state_type > $o ).

tff(pred_def_57281,type,
    v102647: state_type > $o ).

tff(pred_def_57282,type,
    v102646: state_type > $o ).

tff(pred_def_57283,type,
    v102645: state_type > $o ).

tff(pred_def_57284,type,
    v102657: state_type > $o ).

tff(pred_def_57285,type,
    v102658: state_type > $o ).

tff(pred_def_57286,type,
    v102656: state_type > $o ).

tff(pred_def_57287,type,
    v102653: ( state_type * $int ) > $o ).

tff(pred_def_57288,type,
    v102655: ( state_type * $int ) > $o ).

tff(pred_def_57289,type,
    v102644: ( state_type * $int ) > $o ).

tff(pred_def_57290,type,
    v102664: state_type > $o ).

tff(pred_def_57291,type,
    v102662: state_type > $o ).

tff(pred_def_57292,type,
    v102668: state_type > $o ).

tff(pred_def_57293,type,
    v102666: state_type > $o ).

tff(pred_def_57294,type,
    v102674: ( state_type * $int ) > $o ).

tff(pred_def_57295,type,
    v102680: state_type > $o ).

tff(pred_def_57296,type,
    v102678: state_type > $o ).

tff(pred_def_57297,type,
    v102676: state_type > $o ).

tff(pred_def_57298,type,
    v102684: state_type > $o ).

tff(pred_def_57299,type,
    v102683: ( state_type * $int ) > $o ).

tff(pred_def_57300,type,
    v102682: ( state_type * $int ) > $o ).

tff(pred_def_57301,type,
    v102688: state_type > $o ).

tff(pred_def_57302,type,
    v102687: ( state_type * $int ) > $o ).

tff(pred_def_57303,type,
    v102686: ( state_type * $int ) > $o ).

tff(pred_def_57304,type,
    v102685: ( state_type * $int ) > $o ).

tff(pred_def_57305,type,
    v102681: ( state_type * $int ) > $o ).

tff(pred_def_57306,type,
    v102672: ( state_type * $int ) > $o ).

tff(pred_def_57307,type,
    v102670: ( state_type * $int ) > $o ).

tff(pred_def_57308,type,
    v102692: state_type > $o ).

tff(pred_def_57309,type,
    v102690: state_type > $o ).

tff(pred_def_57310,type,
    v102699: state_type > $o ).

tff(pred_def_57311,type,
    v102697: state_type > $o ).

tff(pred_def_57312,type,
    v102696: state_type > $o ).

tff(pred_def_57313,type,
    v102695: state_type > $o ).

tff(pred_def_57314,type,
    v102707: state_type > $o ).

tff(pred_def_57315,type,
    v102708: state_type > $o ).

tff(pred_def_57316,type,
    v102706: state_type > $o ).

tff(pred_def_57317,type,
    v102703: ( state_type * $int ) > $o ).

tff(pred_def_57318,type,
    v102705: ( state_type * $int ) > $o ).

tff(pred_def_57319,type,
    v102694: ( state_type * $int ) > $o ).

tff(pred_def_57320,type,
    v102714: state_type > $o ).

tff(pred_def_57321,type,
    v102712: state_type > $o ).

tff(pred_def_57322,type,
    v102718: state_type > $o ).

tff(pred_def_57323,type,
    v102716: state_type > $o ).

tff(pred_def_57324,type,
    v102724: ( state_type * $int ) > $o ).

tff(pred_def_57325,type,
    v102730: state_type > $o ).

tff(pred_def_57326,type,
    v102728: state_type > $o ).

tff(pred_def_57327,type,
    v102726: state_type > $o ).

tff(pred_def_57328,type,
    v102734: state_type > $o ).

tff(pred_def_57329,type,
    v102733: ( state_type * $int ) > $o ).

tff(pred_def_57330,type,
    v102732: ( state_type * $int ) > $o ).

tff(pred_def_57331,type,
    v102738: state_type > $o ).

tff(pred_def_57332,type,
    v102737: ( state_type * $int ) > $o ).

tff(pred_def_57333,type,
    v102736: ( state_type * $int ) > $o ).

tff(pred_def_57334,type,
    v102735: ( state_type * $int ) > $o ).

tff(pred_def_57335,type,
    v102731: ( state_type * $int ) > $o ).

tff(pred_def_57336,type,
    v102722: ( state_type * $int ) > $o ).

tff(pred_def_57337,type,
    v102720: ( state_type * $int ) > $o ).

tff(pred_def_57338,type,
    v102742: state_type > $o ).

tff(pred_def_57339,type,
    v102740: state_type > $o ).

tff(pred_def_57340,type,
    v102749: state_type > $o ).

tff(pred_def_57341,type,
    v102747: state_type > $o ).

tff(pred_def_57342,type,
    v102746: state_type > $o ).

tff(pred_def_57343,type,
    v102745: state_type > $o ).

tff(pred_def_57344,type,
    v102757: state_type > $o ).

tff(pred_def_57345,type,
    v102758: state_type > $o ).

tff(pred_def_57346,type,
    v102756: state_type > $o ).

tff(pred_def_57347,type,
    v102753: ( state_type * $int ) > $o ).

tff(pred_def_57348,type,
    v102755: ( state_type * $int ) > $o ).

tff(pred_def_57349,type,
    v102744: ( state_type * $int ) > $o ).

tff(pred_def_57350,type,
    v102764: state_type > $o ).

tff(pred_def_57351,type,
    v102762: state_type > $o ).

tff(pred_def_57352,type,
    v102768: state_type > $o ).

tff(pred_def_57353,type,
    v102766: state_type > $o ).

tff(pred_def_57354,type,
    v102774: ( state_type * $int ) > $o ).

tff(pred_def_57355,type,
    v102780: state_type > $o ).

tff(pred_def_57356,type,
    v102778: state_type > $o ).

tff(pred_def_57357,type,
    v102776: state_type > $o ).

tff(pred_def_57358,type,
    v102784: state_type > $o ).

tff(pred_def_57359,type,
    v102783: ( state_type * $int ) > $o ).

tff(pred_def_57360,type,
    v102782: ( state_type * $int ) > $o ).

tff(pred_def_57361,type,
    v102788: state_type > $o ).

tff(pred_def_57362,type,
    v102787: ( state_type * $int ) > $o ).

tff(pred_def_57363,type,
    v102786: ( state_type * $int ) > $o ).

tff(pred_def_57364,type,
    v102785: ( state_type * $int ) > $o ).

tff(pred_def_57365,type,
    v102781: ( state_type * $int ) > $o ).

tff(pred_def_57366,type,
    v102772: ( state_type * $int ) > $o ).

tff(pred_def_57367,type,
    v102770: ( state_type * $int ) > $o ).

tff(pred_def_57368,type,
    v102792: state_type > $o ).

tff(pred_def_57369,type,
    v102790: state_type > $o ).

tff(pred_def_57370,type,
    v102799: state_type > $o ).

tff(pred_def_57371,type,
    v102797: state_type > $o ).

tff(pred_def_57372,type,
    v102796: state_type > $o ).

tff(pred_def_57373,type,
    v102795: state_type > $o ).

tff(pred_def_57374,type,
    v102807: state_type > $o ).

tff(pred_def_57375,type,
    v102808: state_type > $o ).

tff(pred_def_57376,type,
    v102806: state_type > $o ).

tff(pred_def_57377,type,
    v102803: ( state_type * $int ) > $o ).

tff(pred_def_57378,type,
    v102805: ( state_type * $int ) > $o ).

tff(pred_def_57379,type,
    v102794: ( state_type * $int ) > $o ).

tff(pred_def_57380,type,
    v102814: state_type > $o ).

tff(pred_def_57381,type,
    v102812: state_type > $o ).

tff(pred_def_57382,type,
    v102818: state_type > $o ).

tff(pred_def_57383,type,
    v102816: state_type > $o ).

tff(pred_def_57384,type,
    v102824: ( state_type * $int ) > $o ).

tff(pred_def_57385,type,
    v102830: state_type > $o ).

tff(pred_def_57386,type,
    v102828: state_type > $o ).

tff(pred_def_57387,type,
    v102826: state_type > $o ).

tff(pred_def_57388,type,
    v102834: state_type > $o ).

tff(pred_def_57389,type,
    v102833: ( state_type * $int ) > $o ).

tff(pred_def_57390,type,
    v102832: ( state_type * $int ) > $o ).

tff(pred_def_57391,type,
    v102838: state_type > $o ).

tff(pred_def_57392,type,
    v102837: ( state_type * $int ) > $o ).

tff(pred_def_57393,type,
    v102836: ( state_type * $int ) > $o ).

tff(pred_def_57394,type,
    v102835: ( state_type * $int ) > $o ).

tff(pred_def_57395,type,
    v102831: ( state_type * $int ) > $o ).

tff(pred_def_57396,type,
    v102822: ( state_type * $int ) > $o ).

tff(pred_def_57397,type,
    v102820: ( state_type * $int ) > $o ).

tff(pred_def_57398,type,
    v102842: state_type > $o ).

tff(pred_def_57399,type,
    v102840: state_type > $o ).

tff(pred_def_57400,type,
    v102849: state_type > $o ).

tff(pred_def_57401,type,
    v102847: state_type > $o ).

tff(pred_def_57402,type,
    v102846: state_type > $o ).

tff(pred_def_57403,type,
    v102845: state_type > $o ).

tff(pred_def_57404,type,
    v102857: state_type > $o ).

tff(pred_def_57405,type,
    v102858: state_type > $o ).

tff(pred_def_57406,type,
    v102856: state_type > $o ).

tff(pred_def_57407,type,
    v102853: ( state_type * $int ) > $o ).

tff(pred_def_57408,type,
    v102855: ( state_type * $int ) > $o ).

tff(pred_def_57409,type,
    v102844: ( state_type * $int ) > $o ).

tff(pred_def_57410,type,
    v102864: state_type > $o ).

tff(pred_def_57411,type,
    v102862: state_type > $o ).

tff(pred_def_57412,type,
    v102868: state_type > $o ).

tff(pred_def_57413,type,
    v102866: state_type > $o ).

tff(pred_def_57414,type,
    v102874: ( state_type * $int ) > $o ).

tff(pred_def_57415,type,
    v102880: state_type > $o ).

tff(pred_def_57416,type,
    v102878: state_type > $o ).

tff(pred_def_57417,type,
    v102876: state_type > $o ).

tff(pred_def_57418,type,
    v102884: state_type > $o ).

tff(pred_def_57419,type,
    v102883: ( state_type * $int ) > $o ).

tff(pred_def_57420,type,
    v102882: ( state_type * $int ) > $o ).

tff(pred_def_57421,type,
    v102888: state_type > $o ).

tff(pred_def_57422,type,
    v102887: ( state_type * $int ) > $o ).

tff(pred_def_57423,type,
    v102886: ( state_type * $int ) > $o ).

tff(pred_def_57424,type,
    v102885: ( state_type * $int ) > $o ).

tff(pred_def_57425,type,
    v102881: ( state_type * $int ) > $o ).

tff(pred_def_57426,type,
    v102872: ( state_type * $int ) > $o ).

tff(pred_def_57427,type,
    v102870: ( state_type * $int ) > $o ).

tff(pred_def_57428,type,
    v102892: state_type > $o ).

tff(pred_def_57429,type,
    v102890: state_type > $o ).

tff(pred_def_57430,type,
    v102899: state_type > $o ).

tff(pred_def_57431,type,
    v102897: state_type > $o ).

tff(pred_def_57432,type,
    v102896: state_type > $o ).

tff(pred_def_57433,type,
    v102895: state_type > $o ).

tff(pred_def_57434,type,
    v102907: state_type > $o ).

tff(pred_def_57435,type,
    v102908: state_type > $o ).

tff(pred_def_57436,type,
    v102906: state_type > $o ).

tff(pred_def_57437,type,
    v102903: ( state_type * $int ) > $o ).

tff(pred_def_57438,type,
    v102905: ( state_type * $int ) > $o ).

tff(pred_def_57439,type,
    v102894: ( state_type * $int ) > $o ).

tff(pred_def_57440,type,
    v102914: state_type > $o ).

tff(pred_def_57441,type,
    v102912: state_type > $o ).

tff(pred_def_57442,type,
    v102918: state_type > $o ).

tff(pred_def_57443,type,
    v102916: state_type > $o ).

tff(pred_def_57444,type,
    v102924: ( state_type * $int ) > $o ).

tff(pred_def_57445,type,
    v102930: state_type > $o ).

tff(pred_def_57446,type,
    v102928: state_type > $o ).

tff(pred_def_57447,type,
    v102926: state_type > $o ).

tff(pred_def_57448,type,
    v102934: state_type > $o ).

tff(pred_def_57449,type,
    v102933: ( state_type * $int ) > $o ).

tff(pred_def_57450,type,
    v102932: ( state_type * $int ) > $o ).

tff(pred_def_57451,type,
    v102938: state_type > $o ).

tff(pred_def_57452,type,
    v102937: ( state_type * $int ) > $o ).

tff(pred_def_57453,type,
    v102936: ( state_type * $int ) > $o ).

tff(pred_def_57454,type,
    v102935: ( state_type * $int ) > $o ).

tff(pred_def_57455,type,
    v102931: ( state_type * $int ) > $o ).

tff(pred_def_57456,type,
    v102922: ( state_type * $int ) > $o ).

tff(pred_def_57457,type,
    v102920: ( state_type * $int ) > $o ).

tff(pred_def_57458,type,
    v102942: state_type > $o ).

tff(pred_def_57459,type,
    v102940: state_type > $o ).

tff(pred_def_57460,type,
    v102949: state_type > $o ).

tff(pred_def_57461,type,
    v102947: state_type > $o ).

tff(pred_def_57462,type,
    v102946: state_type > $o ).

tff(pred_def_57463,type,
    v102945: state_type > $o ).

tff(pred_def_57464,type,
    v102957: state_type > $o ).

tff(pred_def_57465,type,
    v102958: state_type > $o ).

tff(pred_def_57466,type,
    v102956: state_type > $o ).

tff(pred_def_57467,type,
    v102953: ( state_type * $int ) > $o ).

tff(pred_def_57468,type,
    v102955: ( state_type * $int ) > $o ).

tff(pred_def_57469,type,
    v102944: ( state_type * $int ) > $o ).

tff(pred_def_57470,type,
    v102964: state_type > $o ).

tff(pred_def_57471,type,
    v102962: state_type > $o ).

tff(pred_def_57472,type,
    v102968: state_type > $o ).

tff(pred_def_57473,type,
    v102966: state_type > $o ).

tff(pred_def_57474,type,
    v102974: ( state_type * $int ) > $o ).

tff(pred_def_57475,type,
    v102980: state_type > $o ).

tff(pred_def_57476,type,
    v102978: state_type > $o ).

tff(pred_def_57477,type,
    v102976: state_type > $o ).

tff(pred_def_57478,type,
    v102984: state_type > $o ).

tff(pred_def_57479,type,
    v102983: ( state_type * $int ) > $o ).

tff(pred_def_57480,type,
    v102982: ( state_type * $int ) > $o ).

tff(pred_def_57481,type,
    v102988: state_type > $o ).

tff(pred_def_57482,type,
    v102987: ( state_type * $int ) > $o ).

tff(pred_def_57483,type,
    v102986: ( state_type * $int ) > $o ).

tff(pred_def_57484,type,
    v102985: ( state_type * $int ) > $o ).

tff(pred_def_57485,type,
    v102981: ( state_type * $int ) > $o ).

tff(pred_def_57486,type,
    v102972: ( state_type * $int ) > $o ).

tff(pred_def_57487,type,
    v102970: ( state_type * $int ) > $o ).

tff(pred_def_57488,type,
    v102992: state_type > $o ).

tff(pred_def_57489,type,
    v102990: state_type > $o ).

tff(pred_def_57490,type,
    v102999: state_type > $o ).

tff(pred_def_57491,type,
    v102997: state_type > $o ).

tff(pred_def_57492,type,
    v102996: state_type > $o ).

tff(pred_def_57493,type,
    v102995: state_type > $o ).

tff(pred_def_57494,type,
    v103007: state_type > $o ).

tff(pred_def_57495,type,
    v103008: state_type > $o ).

tff(pred_def_57496,type,
    v103006: state_type > $o ).

tff(pred_def_57497,type,
    v103003: ( state_type * $int ) > $o ).

tff(pred_def_57498,type,
    v103005: ( state_type * $int ) > $o ).

tff(pred_def_57499,type,
    v102994: ( state_type * $int ) > $o ).

tff(pred_def_57500,type,
    v103014: state_type > $o ).

tff(pred_def_57501,type,
    v103012: state_type > $o ).

tff(pred_def_57502,type,
    v103018: state_type > $o ).

tff(pred_def_57503,type,
    v103016: state_type > $o ).

tff(pred_def_57504,type,
    v103024: ( state_type * $int ) > $o ).

tff(pred_def_57505,type,
    v103030: state_type > $o ).

tff(pred_def_57506,type,
    v103028: state_type > $o ).

tff(pred_def_57507,type,
    v103026: state_type > $o ).

tff(pred_def_57508,type,
    v103034: state_type > $o ).

tff(pred_def_57509,type,
    v103033: ( state_type * $int ) > $o ).

tff(pred_def_57510,type,
    v103032: ( state_type * $int ) > $o ).

tff(pred_def_57511,type,
    v103038: state_type > $o ).

tff(pred_def_57512,type,
    v103037: ( state_type * $int ) > $o ).

tff(pred_def_57513,type,
    v103036: ( state_type * $int ) > $o ).

tff(pred_def_57514,type,
    v103035: ( state_type * $int ) > $o ).

tff(pred_def_57515,type,
    v103031: ( state_type * $int ) > $o ).

tff(pred_def_57516,type,
    v103022: ( state_type * $int ) > $o ).

tff(pred_def_57517,type,
    v103020: ( state_type * $int ) > $o ).

tff(pred_def_57518,type,
    v103042: state_type > $o ).

tff(pred_def_57519,type,
    v103040: state_type > $o ).

tff(pred_def_57520,type,
    v103049: state_type > $o ).

tff(pred_def_57521,type,
    v103047: state_type > $o ).

tff(pred_def_57522,type,
    v103046: state_type > $o ).

tff(pred_def_57523,type,
    v103045: state_type > $o ).

tff(pred_def_57524,type,
    v103057: state_type > $o ).

tff(pred_def_57525,type,
    v103058: state_type > $o ).

tff(pred_def_57526,type,
    v103056: state_type > $o ).

tff(pred_def_57527,type,
    v103053: ( state_type * $int ) > $o ).

tff(pred_def_57528,type,
    v103055: ( state_type * $int ) > $o ).

tff(pred_def_57529,type,
    v103044: ( state_type * $int ) > $o ).

tff(pred_def_57530,type,
    v103063: state_type > $o ).

tff(pred_def_57531,type,
    v103062: state_type > $o ).

tff(pred_def_57532,type,
    v103065: state_type > $o ).

tff(pred_def_57533,type,
    v103064: state_type > $o ).

tff(pred_def_57534,type,
    v101499: ( state_type * $int ) > $o ).

tff(pred_def_57535,type,
    v101497: state_type > $o ).

tff(pred_def_57536,type,
    v103066: ( state_type * $int ) > $o ).

tff(pred_def_57537,type,
    v103067: state_type > $o ).

tff(pred_def_57538,type,
    v89208: ( state_type * $int ) > $o ).

tff(pred_def_57539,type,
    v89206: ( state_type * $int ) > $o ).

tff(pred_def_57540,type,
    v89204: ( state_type * $int ) > $o ).

tff(pred_def_57541,type,
    v103071: state_type > $o ).

tff(pred_def_57542,type,
    v103069: state_type > $o ).

tff(pred_def_57543,type,
    v103078: state_type > $o ).

tff(pred_def_57544,type,
    v103076: state_type > $o ).

tff(pred_def_57545,type,
    v103075: state_type > $o ).

tff(pred_def_57546,type,
    v103074: state_type > $o ).

tff(pred_def_57547,type,
    v103086: state_type > $o ).

tff(pred_def_57548,type,
    v103087: state_type > $o ).

tff(pred_def_57549,type,
    v103085: state_type > $o ).

tff(pred_def_57550,type,
    v103082: ( state_type * $int ) > $o ).

tff(pred_def_57551,type,
    v103084: ( state_type * $int ) > $o ).

tff(pred_def_57552,type,
    v103073: ( state_type * $int ) > $o ).

tff(pred_def_57553,type,
    v89194: ( state_type * $int ) > $o ).

tff(pred_def_57554,type,
    v89192: ( state_type * $int ) > $o ).

tff(pred_def_57555,type,
    v101495: state_type > $o ).

tff(pred_def_57556,type,
    v103100: state_type > $o ).

tff(pred_def_57557,type,
    v103098: state_type > $o ).

tff(pred_def_57558,type,
    v103102: state_type > $o ).

tff(pred_def_57559,type,
    v103096: state_type > $o ).

tff(pred_def_57560,type,
    v103111: ( state_type * $int ) > $o ).

tff(pred_def_57561,type,
    v103110: ( state_type * $int ) > $o ).

tff(pred_def_57562,type,
    v103108: ( state_type * $int ) > $o ).

tff(pred_def_57563,type,
    v103106: ( state_type * $int ) > $o ).

tff(pred_def_57564,type,
    v103119: ( state_type * $int ) > $o ).

tff(pred_def_57565,type,
    v103117: ( state_type * $int ) > $o ).

tff(pred_def_57566,type,
    v103121: state_type > $o ).

tff(pred_def_57567,type,
    v103115: state_type > $o ).

tff(pred_def_57568,type,
    v103123: state_type > $o ).

tff(pred_def_57569,type,
    v103113: state_type > $o ).

tff(pred_def_57570,type,
    v103132: ( state_type * $int ) > $o ).

tff(pred_def_57571,type,
    v103131: ( state_type * $int ) > $o ).

tff(pred_def_57572,type,
    v103129: ( state_type * $int ) > $o ).

tff(pred_def_57573,type,
    v103127: ( state_type * $int ) > $o ).

tff(pred_def_57574,type,
    v103135: state_type > $o ).

tff(pred_def_57575,type,
    v103134: state_type > $o ).

tff(pred_def_57576,type,
    v103137: state_type > $o ).

tff(pred_def_57577,type,
    v103136: state_type > $o ).

tff(pred_def_57578,type,
    v103094: ( state_type * $int ) > $o ).

tff(pred_def_57579,type,
    v103143: state_type > $o ).

tff(pred_def_57580,type,
    v103141: state_type > $o ).

tff(pred_def_57581,type,
    v103140: state_type > $o ).

tff(pred_def_57582,type,
    v103139: ( state_type * $int ) > $o ).

tff(pred_def_57583,type,
    v103091: state_type > $o ).

tff(pred_def_57584,type,
    v103147: state_type > $o ).

tff(pred_def_57585,type,
    v103149: state_type > $o ).

tff(pred_def_57586,type,
    v101473: ( state_type * $int ) > $o ).

tff(pred_def_57587,type,
    v103151: state_type > $o ).

tff(pred_def_57588,type,
    v103156: state_type > $o ).

tff(pred_def_57589,type,
    v103155: state_type > $o ).

tff(pred_def_57590,type,
    v103158: state_type > $o ).

tff(pred_def_57591,type,
    v103157: state_type > $o ).

tff(pred_def_57592,type,
    v103154: state_type > $o ).

tff(pred_def_57593,type,
    v103152: ( state_type * $int ) > $o ).

tff(pred_def_57594,type,
    v103150: ( state_type * $int ) > $o ).

tff(pred_def_57595,type,
    v103148: ( state_type * $int ) > $o ).

tff(pred_def_57596,type,
    v101493: ( state_type * $int ) > $o ).

tff(pred_def_57597,type,
    v101491: ( state_type * $int ) > $o ).

tff(pred_def_57598,type,
    v101489: ( state_type * $int ) > $o ).

tff(pred_def_57599,type,
    v101487: ( state_type * $int ) > $o ).

tff(pred_def_57600,type,
    v103162: state_type > $o ).

tff(pred_def_57601,type,
    v103160: state_type > $o ).

tff(pred_def_57602,type,
    v103169: state_type > $o ).

tff(pred_def_57603,type,
    v103167: state_type > $o ).

tff(pred_def_57604,type,
    v103166: state_type > $o ).

tff(pred_def_57605,type,
    v103165: state_type > $o ).

tff(pred_def_57606,type,
    v103177: state_type > $o ).

tff(pred_def_57607,type,
    v103178: state_type > $o ).

tff(pred_def_57608,type,
    v103176: state_type > $o ).

tff(pred_def_57609,type,
    v103173: ( state_type * $int ) > $o ).

tff(pred_def_57610,type,
    v103175: ( state_type * $int ) > $o ).

tff(pred_def_57611,type,
    v101477: ( state_type * $int ) > $o ).

tff(pred_def_57612,type,
    v101475: ( state_type * $int ) > $o ).

tff(pred_def_57613,type,
    v101471: state_type > $o ).

tff(pred_def_57614,type,
    v101469: ( state_type * $int ) > $o ).

tff(pred_def_57615,type,
    v103195: state_type > $o ).

tff(pred_def_57616,type,
    v103193: state_type > $o ).

tff(pred_def_57617,type,
    v103199: state_type > $o ).

tff(pred_def_57618,type,
    v103197: state_type > $o ).

tff(pred_def_57619,type,
    v103209: state_type > $o ).

tff(pred_def_57620,type,
    v103222: state_type > $o ).

tff(pred_def_57621,type,
    v103220: state_type > $o ).

tff(pred_def_57622,type,
    v103226: state_type > $o ).

tff(pred_def_57623,type,
    v103224: state_type > $o ).

tff(pred_def_57624,type,
    v103234: ( state_type * $int ) > $o ).

tff(pred_def_57625,type,
    v103235: ( state_type * $int ) > $o ).

tff(pred_def_57626,type,
    v103236: state_type > $o ).

tff(pred_def_57627,type,
    v103232: ( state_type * $int ) > $o ).

tff(pred_def_57628,type,
    b0000010000000: $int > $o ).

tff(pred_def_57629,type,
    v103243: state_type > $o ).

tff(pred_def_57630,type,
    v103240: state_type > $o ).

tff(pred_def_57631,type,
    v103238: state_type > $o ).

tff(pred_def_57632,type,
    v103247: state_type > $o ).

tff(pred_def_57633,type,
    v103246: ( state_type * $int ) > $o ).

tff(pred_def_57634,type,
    v103245: ( state_type * $int ) > $o ).

tff(pred_def_57635,type,
    v103251: state_type > $o ).

tff(pred_def_57636,type,
    v103250: ( state_type * $int ) > $o ).

tff(pred_def_57637,type,
    v103249: ( state_type * $int ) > $o ).

tff(pred_def_57638,type,
    v103216: ( state_type * $int ) > $o ).

tff(pred_def_57639,type,
    v103248: ( state_type * $int ) > $o ).

tff(pred_def_57640,type,
    v103244: ( state_type * $int ) > $o ).

tff(pred_def_57641,type,
    v103230: ( state_type * $int ) > $o ).

tff(pred_def_57642,type,
    v103228: ( state_type * $int ) > $o ).

tff(pred_def_57643,type,
    v103255: state_type > $o ).

tff(pred_def_57644,type,
    v103253: state_type > $o ).

tff(pred_def_57645,type,
    v103262: state_type > $o ).

tff(pred_def_57646,type,
    v103260: state_type > $o ).

tff(pred_def_57647,type,
    v103259: state_type > $o ).

tff(pred_def_57648,type,
    v103258: state_type > $o ).

tff(pred_def_57649,type,
    v103270: state_type > $o ).

tff(pred_def_57650,type,
    v103271: state_type > $o ).

tff(pred_def_57651,type,
    v103269: state_type > $o ).

tff(pred_def_57652,type,
    v103266: ( state_type * $int ) > $o ).

tff(pred_def_57653,type,
    v103268: ( state_type * $int ) > $o ).

tff(pred_def_57654,type,
    v103257: ( state_type * $int ) > $o ).

tff(pred_def_57655,type,
    v103218: ( state_type * $int ) > $o ).

tff(pred_def_57656,type,
    v103214: ( state_type * $int ) > $o ).

tff(pred_def_57657,type,
    v103212: ( state_type * $int ) > $o ).

tff(pred_def_57658,type,
    v103283: state_type > $o ).

tff(pred_def_57659,type,
    v103281: state_type > $o ).

tff(pred_def_57660,type,
    v103280: state_type > $o ).

tff(pred_def_57661,type,
    v103279: ( state_type * $int ) > $o ).

tff(pred_def_57662,type,
    v103275: state_type > $o ).

tff(pred_def_57663,type,
    v103292: state_type > $o ).

tff(pred_def_57664,type,
    v103290: state_type > $o ).

tff(pred_def_57665,type,
    v103289: state_type > $o ).

tff(pred_def_57666,type,
    v103288: ( state_type * $int ) > $o ).

tff(pred_def_57667,type,
    v103300: state_type > $o ).

tff(pred_def_57668,type,
    v103298: state_type > $o ).

tff(pred_def_57669,type,
    v103297: state_type > $o ).

tff(pred_def_57670,type,
    v103296: ( state_type * $int ) > $o ).

tff(pred_def_57671,type,
    v103185: state_type > $o ).

tff(pred_def_57672,type,
    v103304: state_type > $o ).

tff(pred_def_57673,type,
    v103314: state_type > $o ).

tff(pred_def_57674,type,
    v103313: state_type > $o ).

tff(pred_def_57675,type,
    v103312: state_type > $o ).

tff(pred_def_57676,type,
    v103315: state_type > $o ).

tff(pred_def_57677,type,
    v103311: state_type > $o ).

tff(pred_def_57678,type,
    v103310: state_type > $o ).

tff(pred_def_57679,type,
    v103309: state_type > $o ).

tff(pred_def_57680,type,
    v103308: state_type > $o ).

tff(pred_def_57681,type,
    v103317: state_type > $o ).

tff(pred_def_57682,type,
    v103316: state_type > $o ).

tff(pred_def_57683,type,
    v103307: state_type > $o ).

tff(pred_def_57684,type,
    v103320: state_type > $o ).

tff(pred_def_57685,type,
    v103319: state_type > $o ).

tff(pred_def_57686,type,
    v103321: state_type > $o ).

tff(pred_def_57687,type,
    v103318: state_type > $o ).

tff(pred_def_57688,type,
    v103324: state_type > $o ).

tff(pred_def_57689,type,
    v103323: state_type > $o ).

tff(pred_def_57690,type,
    v103325: state_type > $o ).

tff(pred_def_57691,type,
    v103322: state_type > $o ).

tff(pred_def_57692,type,
    v103305: ( state_type * $int ) > $o ).

tff(pred_def_57693,type,
    v103327: state_type > $o ).

tff(pred_def_57694,type,
    v103187: ( state_type * $int ) > $o ).

tff(pred_def_57695,type,
    v103329: state_type > $o ).

tff(pred_def_57696,type,
    v103340: state_type > $o ).

tff(pred_def_57697,type,
    v103339: state_type > $o ).

tff(pred_def_57698,type,
    v103338: state_type > $o ).

tff(pred_def_57699,type,
    v103341: state_type > $o ).

tff(pred_def_57700,type,
    v103337: state_type > $o ).

tff(pred_def_57701,type,
    v103336: state_type > $o ).

tff(pred_def_57702,type,
    v103335: state_type > $o ).

tff(pred_def_57703,type,
    v103334: state_type > $o ).

tff(pred_def_57704,type,
    v103343: state_type > $o ).

tff(pred_def_57705,type,
    v103342: state_type > $o ).

tff(pred_def_57706,type,
    v103333: state_type > $o ).

tff(pred_def_57707,type,
    v103346: state_type > $o ).

tff(pred_def_57708,type,
    v103345: state_type > $o ).

tff(pred_def_57709,type,
    v103347: state_type > $o ).

tff(pred_def_57710,type,
    v103344: state_type > $o ).

tff(pred_def_57711,type,
    v103350: state_type > $o ).

tff(pred_def_57712,type,
    v103349: state_type > $o ).

tff(pred_def_57713,type,
    v103351: state_type > $o ).

tff(pred_def_57714,type,
    v103348: state_type > $o ).

tff(pred_def_57715,type,
    v103331: ( state_type * $int ) > $o ).

tff(pred_def_57716,type,
    v103330: ( state_type * $int ) > $o ).

tff(pred_def_57717,type,
    v103328: ( state_type * $int ) > $o ).

tff(pred_def_57718,type,
    v103326: ( state_type * $int ) > $o ).

tff(pred_def_57719,type,
    v103207: ( state_type * $int ) > $o ).

tff(pred_def_57720,type,
    v103205: ( state_type * $int ) > $o ).

tff(pred_def_57721,type,
    v103203: ( state_type * $int ) > $o ).

tff(pred_def_57722,type,
    v103201: ( state_type * $int ) > $o ).

tff(pred_def_57723,type,
    v103355: state_type > $o ).

tff(pred_def_57724,type,
    v103353: state_type > $o ).

tff(pred_def_57725,type,
    v103362: state_type > $o ).

tff(pred_def_57726,type,
    v103360: state_type > $o ).

tff(pred_def_57727,type,
    v103359: state_type > $o ).

tff(pred_def_57728,type,
    v103358: state_type > $o ).

tff(pred_def_57729,type,
    v103370: state_type > $o ).

tff(pred_def_57730,type,
    v103371: state_type > $o ).

tff(pred_def_57731,type,
    v103369: state_type > $o ).

tff(pred_def_57732,type,
    v103366: ( state_type * $int ) > $o ).

tff(pred_def_57733,type,
    v103368: ( state_type * $int ) > $o ).

tff(pred_def_57734,type,
    v103191: ( state_type * $int ) > $o ).

tff(pred_def_57735,type,
    v103189: ( state_type * $int ) > $o ).

tff(pred_def_57736,type,
    v103183: ( state_type * $int ) > $o ).

tff(pred_def_57737,type,
    v103390: state_type > $o ).

tff(pred_def_57738,type,
    v103388: state_type > $o ).

tff(pred_def_57739,type,
    v103394: state_type > $o ).

tff(pred_def_57740,type,
    v103392: state_type > $o ).

tff(pred_def_57741,type,
    v103406: state_type > $o ).

tff(pred_def_57742,type,
    v103404: state_type > $o ).

tff(pred_def_57743,type,
    v103418: state_type > $o ).

tff(pred_def_57744,type,
    v103416: state_type > $o ).

tff(pred_def_57745,type,
    v103422: state_type > $o ).

tff(pred_def_57746,type,
    v103420: state_type > $o ).

tff(pred_def_57747,type,
    v103430: ( state_type * $int ) > $o ).

tff(pred_def_57748,type,
    v103431: ( state_type * $int ) > $o ).

tff(pred_def_57749,type,
    v103432: ( state_type * $int ) > $o ).

tff(pred_def_57750,type,
    v103428: ( state_type * $int ) > $o ).

tff(pred_def_57751,type,
    b0000011011000: $int > $o ).

tff(pred_def_57752,type,
    v103439: state_type > $o ).

tff(pred_def_57753,type,
    v103436: state_type > $o ).

tff(pred_def_57754,type,
    v103434: state_type > $o ).

tff(pred_def_57755,type,
    v103443: state_type > $o ).

tff(pred_def_57756,type,
    v103442: ( state_type * $int ) > $o ).

tff(pred_def_57757,type,
    v103441: ( state_type * $int ) > $o ).

tff(pred_def_57758,type,
    v103447: state_type > $o ).

tff(pred_def_57759,type,
    v103446: ( state_type * $int ) > $o ).

tff(pred_def_57760,type,
    v103445: ( state_type * $int ) > $o ).

tff(pred_def_57761,type,
    v103412: ( state_type * $int ) > $o ).

tff(pred_def_57762,type,
    v103444: ( state_type * $int ) > $o ).

tff(pred_def_57763,type,
    v103440: ( state_type * $int ) > $o ).

tff(pred_def_57764,type,
    v103426: ( state_type * $int ) > $o ).

tff(pred_def_57765,type,
    v103424: ( state_type * $int ) > $o ).

tff(pred_def_57766,type,
    v103451: state_type > $o ).

tff(pred_def_57767,type,
    v103449: state_type > $o ).

tff(pred_def_57768,type,
    v103458: state_type > $o ).

tff(pred_def_57769,type,
    v103456: state_type > $o ).

tff(pred_def_57770,type,
    v103455: state_type > $o ).

tff(pred_def_57771,type,
    v103454: state_type > $o ).

tff(pred_def_57772,type,
    v103466: state_type > $o ).

tff(pred_def_57773,type,
    v103467: state_type > $o ).

tff(pred_def_57774,type,
    v103465: state_type > $o ).

tff(pred_def_57775,type,
    v103462: ( state_type * $int ) > $o ).

tff(pred_def_57776,type,
    v103464: ( state_type * $int ) > $o ).

tff(pred_def_57777,type,
    v103453: ( state_type * $int ) > $o ).

tff(pred_def_57778,type,
    v103414: ( state_type * $int ) > $o ).

tff(pred_def_57779,type,
    v103410: ( state_type * $int ) > $o ).

tff(pred_def_57780,type,
    v103408: ( state_type * $int ) > $o ).

tff(pred_def_57781,type,
    v103479: state_type > $o ).

tff(pred_def_57782,type,
    v103477: state_type > $o ).

tff(pred_def_57783,type,
    v103476: state_type > $o ).

tff(pred_def_57784,type,
    v103475: ( state_type * $int ) > $o ).

tff(pred_def_57785,type,
    v103471: ( state_type * $int ) > $o ).

tff(pred_def_57786,type,
    v103488: state_type > $o ).

tff(pred_def_57787,type,
    v103486: state_type > $o ).

tff(pred_def_57788,type,
    v103485: state_type > $o ).

tff(pred_def_57789,type,
    v103484: ( state_type * $int ) > $o ).

tff(pred_def_57790,type,
    v103497: state_type > $o ).

tff(pred_def_57791,type,
    v103495: state_type > $o ).

tff(pred_def_57792,type,
    v103494: state_type > $o ).

tff(pred_def_57793,type,
    v103493: ( state_type * $int ) > $o ).

tff(pred_def_57794,type,
    v103506: state_type > $o ).

tff(pred_def_57795,type,
    v103504: state_type > $o ).

tff(pred_def_57796,type,
    v103503: state_type > $o ).

tff(pred_def_57797,type,
    v103502: ( state_type * $int ) > $o ).

tff(pred_def_57798,type,
    v103380: state_type > $o ).

tff(pred_def_57799,type,
    v103511: state_type > $o ).

tff(pred_def_57800,type,
    v103510: state_type > $o ).

tff(pred_def_57801,type,
    v103523: state_type > $o ).

tff(pred_def_57802,type,
    v103522: state_type > $o ).

tff(pred_def_57803,type,
    v103521: state_type > $o ).

tff(pred_def_57804,type,
    v103524: state_type > $o ).

tff(pred_def_57805,type,
    v103520: state_type > $o ).

tff(pred_def_57806,type,
    v103519: state_type > $o ).

tff(pred_def_57807,type,
    v103525: state_type > $o ).

tff(pred_def_57808,type,
    v103518: state_type > $o ).

tff(pred_def_57809,type,
    v103517: state_type > $o ).

tff(pred_def_57810,type,
    v103516: state_type > $o ).

tff(pred_def_57811,type,
    v103515: state_type > $o ).

tff(pred_def_57812,type,
    v103527: state_type > $o ).

tff(pred_def_57813,type,
    v103526: state_type > $o ).

tff(pred_def_57814,type,
    v103514: state_type > $o ).

tff(pred_def_57815,type,
    v103530: state_type > $o ).

tff(pred_def_57816,type,
    v103529: state_type > $o ).

tff(pred_def_57817,type,
    v103531: state_type > $o ).

tff(pred_def_57818,type,
    v103528: state_type > $o ).

tff(pred_def_57819,type,
    v103534: state_type > $o ).

tff(pred_def_57820,type,
    v103533: state_type > $o ).

tff(pred_def_57821,type,
    v103535: state_type > $o ).

tff(pred_def_57822,type,
    v103532: state_type > $o ).

tff(pred_def_57823,type,
    v103538: state_type > $o ).

tff(pred_def_57824,type,
    v103537: state_type > $o ).

tff(pred_def_57825,type,
    v103539: state_type > $o ).

tff(pred_def_57826,type,
    v103536: state_type > $o ).

tff(pred_def_57827,type,
    v103512: ( state_type * $int ) > $o ).

tff(pred_def_57828,type,
    v103382: ( state_type * $int ) > $o ).

tff(pred_def_57829,type,
    v103552: state_type > $o ).

tff(pred_def_57830,type,
    v103551: state_type > $o ).

tff(pred_def_57831,type,
    v103550: state_type > $o ).

tff(pred_def_57832,type,
    v103553: state_type > $o ).

tff(pred_def_57833,type,
    v103549: state_type > $o ).

tff(pred_def_57834,type,
    v103548: state_type > $o ).

tff(pred_def_57835,type,
    v103554: state_type > $o ).

tff(pred_def_57836,type,
    v103547: state_type > $o ).

tff(pred_def_57837,type,
    v103546: state_type > $o ).

tff(pred_def_57838,type,
    v103545: state_type > $o ).

tff(pred_def_57839,type,
    v103544: state_type > $o ).

tff(pred_def_57840,type,
    v103556: state_type > $o ).

tff(pred_def_57841,type,
    v103555: state_type > $o ).

tff(pred_def_57842,type,
    v103543: state_type > $o ).

tff(pred_def_57843,type,
    v103559: state_type > $o ).

tff(pred_def_57844,type,
    v103558: state_type > $o ).

tff(pred_def_57845,type,
    v103560: state_type > $o ).

tff(pred_def_57846,type,
    v103557: state_type > $o ).

tff(pred_def_57847,type,
    v103563: state_type > $o ).

tff(pred_def_57848,type,
    v103562: state_type > $o ).

tff(pred_def_57849,type,
    v103564: state_type > $o ).

tff(pred_def_57850,type,
    v103561: state_type > $o ).

tff(pred_def_57851,type,
    v103567: state_type > $o ).

tff(pred_def_57852,type,
    v103566: state_type > $o ).

tff(pred_def_57853,type,
    v103568: state_type > $o ).

tff(pred_def_57854,type,
    v103565: state_type > $o ).

tff(pred_def_57855,type,
    v103541: ( state_type * $int ) > $o ).

tff(pred_def_57856,type,
    v103540: ( state_type * $int ) > $o ).

tff(pred_def_57857,type,
    v103402: ( state_type * $int ) > $o ).

tff(pred_def_57858,type,
    v103400: ( state_type * $int ) > $o ).

tff(pred_def_57859,type,
    v103398: ( state_type * $int ) > $o ).

tff(pred_def_57860,type,
    v103396: ( state_type * $int ) > $o ).

tff(pred_def_57861,type,
    v103572: state_type > $o ).

tff(pred_def_57862,type,
    v103570: state_type > $o ).

tff(pred_def_57863,type,
    v103579: state_type > $o ).

tff(pred_def_57864,type,
    v103577: state_type > $o ).

tff(pred_def_57865,type,
    v103576: state_type > $o ).

tff(pred_def_57866,type,
    v103575: state_type > $o ).

tff(pred_def_57867,type,
    v103587: state_type > $o ).

tff(pred_def_57868,type,
    v103588: state_type > $o ).

tff(pred_def_57869,type,
    v103586: state_type > $o ).

tff(pred_def_57870,type,
    v103583: ( state_type * $int ) > $o ).

tff(pred_def_57871,type,
    v103585: ( state_type * $int ) > $o ).

tff(pred_def_57872,type,
    v103386: ( state_type * $int ) > $o ).

tff(pred_def_57873,type,
    v103384: ( state_type * $int ) > $o ).

tff(pred_def_57874,type,
    v103603: state_type > $o ).

tff(pred_def_57875,type,
    v103601: state_type > $o ).

tff(pred_def_57876,type,
    v103607: state_type > $o ).

tff(pred_def_57877,type,
    v103605: state_type > $o ).

tff(pred_def_57878,type,
    v103620: state_type > $o ).

tff(pred_def_57879,type,
    v103593: state_type > $o ).

tff(pred_def_57880,type,
    v103619: state_type > $o ).

tff(pred_def_57881,type,
    v103618: state_type > $o ).

tff(pred_def_57882,type,
    v103617: state_type > $o ).

tff(pred_def_57883,type,
    v103621: ( state_type * $int ) > $o ).

tff(pred_def_57884,type,
    v103595: ( state_type * $int ) > $o ).

tff(pred_def_57885,type,
    v103634: state_type > $o ).

tff(pred_def_57886,type,
    v103633: state_type > $o ).

tff(pred_def_57887,type,
    v103632: state_type > $o ).

tff(pred_def_57888,type,
    v103635: state_type > $o ).

tff(pred_def_57889,type,
    v103631: state_type > $o ).

tff(pred_def_57890,type,
    v103630: state_type > $o ).

tff(pred_def_57891,type,
    v103636: state_type > $o ).

tff(pred_def_57892,type,
    v103629: state_type > $o ).

tff(pred_def_57893,type,
    v103628: state_type > $o ).

tff(pred_def_57894,type,
    v103627: state_type > $o ).

tff(pred_def_57895,type,
    v103626: state_type > $o ).

tff(pred_def_57896,type,
    v103638: state_type > $o ).

tff(pred_def_57897,type,
    v103637: state_type > $o ).

tff(pred_def_57898,type,
    v103625: state_type > $o ).

tff(pred_def_57899,type,
    v103641: state_type > $o ).

tff(pred_def_57900,type,
    v103640: state_type > $o ).

tff(pred_def_57901,type,
    v103642: state_type > $o ).

tff(pred_def_57902,type,
    v103639: state_type > $o ).

tff(pred_def_57903,type,
    v103645: state_type > $o ).

tff(pred_def_57904,type,
    v103644: state_type > $o ).

tff(pred_def_57905,type,
    v103646: state_type > $o ).

tff(pred_def_57906,type,
    v103643: state_type > $o ).

tff(pred_def_57907,type,
    v103649: state_type > $o ).

tff(pred_def_57908,type,
    v103648: state_type > $o ).

tff(pred_def_57909,type,
    v103650: state_type > $o ).

tff(pred_def_57910,type,
    v103647: state_type > $o ).

tff(pred_def_57911,type,
    v103623: ( state_type * $int ) > $o ).

tff(pred_def_57912,type,
    v103622: ( state_type * $int ) > $o ).

tff(pred_def_57913,type,
    v103615: ( state_type * $int ) > $o ).

tff(pred_def_57914,type,
    v103613: ( state_type * $int ) > $o ).

tff(pred_def_57915,type,
    v103611: ( state_type * $int ) > $o ).

tff(pred_def_57916,type,
    v103609: ( state_type * $int ) > $o ).

tff(pred_def_57917,type,
    v103654: state_type > $o ).

tff(pred_def_57918,type,
    v103652: state_type > $o ).

tff(pred_def_57919,type,
    v103661: state_type > $o ).

tff(pred_def_57920,type,
    v103659: state_type > $o ).

tff(pred_def_57921,type,
    v103658: state_type > $o ).

tff(pred_def_57922,type,
    v103657: state_type > $o ).

tff(pred_def_57923,type,
    v103669: state_type > $o ).

tff(pred_def_57924,type,
    v103670: state_type > $o ).

tff(pred_def_57925,type,
    v103668: state_type > $o ).

tff(pred_def_57926,type,
    v103665: ( state_type * $int ) > $o ).

tff(pred_def_57927,type,
    v103667: ( state_type * $int ) > $o ).

tff(pred_def_57928,type,
    v103599: ( state_type * $int ) > $o ).

tff(pred_def_57929,type,
    v103597: ( state_type * $int ) > $o ).

tff(pred_def_57930,type,
    v103685: state_type > $o ).

tff(pred_def_57931,type,
    v103683: state_type > $o ).

tff(pred_def_57932,type,
    v103689: state_type > $o ).

tff(pred_def_57933,type,
    v103687: state_type > $o ).

tff(pred_def_57934,type,
    v103703: state_type > $o ).

tff(pred_def_57935,type,
    v103675: state_type > $o ).

tff(pred_def_57936,type,
    v103702: state_type > $o ).

tff(pred_def_57937,type,
    v103704: state_type > $o ).

tff(pred_def_57938,type,
    v103701: state_type > $o ).

tff(pred_def_57939,type,
    v103700: state_type > $o ).

tff(pred_def_57940,type,
    v103699: state_type > $o ).

tff(pred_def_57941,type,
    v103705: ( state_type * $int ) > $o ).

tff(pred_def_57942,type,
    v103677: ( state_type * $int ) > $o ).

tff(pred_def_57943,type,
    v103718: state_type > $o ).

tff(pred_def_57944,type,
    v103717: state_type > $o ).

tff(pred_def_57945,type,
    v103716: state_type > $o ).

tff(pred_def_57946,type,
    v103719: state_type > $o ).

tff(pred_def_57947,type,
    v103715: state_type > $o ).

tff(pred_def_57948,type,
    v103714: state_type > $o ).

tff(pred_def_57949,type,
    v103720: state_type > $o ).

tff(pred_def_57950,type,
    v103713: state_type > $o ).

tff(pred_def_57951,type,
    v103712: state_type > $o ).

tff(pred_def_57952,type,
    v103711: state_type > $o ).

tff(pred_def_57953,type,
    v103710: state_type > $o ).

tff(pred_def_57954,type,
    v103722: state_type > $o ).

tff(pred_def_57955,type,
    v103721: state_type > $o ).

tff(pred_def_57956,type,
    v103709: state_type > $o ).

tff(pred_def_57957,type,
    v103725: state_type > $o ).

tff(pred_def_57958,type,
    v103724: state_type > $o ).

tff(pred_def_57959,type,
    v103726: state_type > $o ).

tff(pred_def_57960,type,
    v103723: state_type > $o ).

tff(pred_def_57961,type,
    v103729: state_type > $o ).

tff(pred_def_57962,type,
    v103728: state_type > $o ).

tff(pred_def_57963,type,
    v103730: state_type > $o ).

tff(pred_def_57964,type,
    v103727: state_type > $o ).

tff(pred_def_57965,type,
    v103733: state_type > $o ).

tff(pred_def_57966,type,
    v103732: state_type > $o ).

tff(pred_def_57967,type,
    v103734: state_type > $o ).

tff(pred_def_57968,type,
    v103731: state_type > $o ).

tff(pred_def_57969,type,
    v103707: ( state_type * $int ) > $o ).

tff(pred_def_57970,type,
    v103706: ( state_type * $int ) > $o ).

tff(pred_def_57971,type,
    v103697: ( state_type * $int ) > $o ).

tff(pred_def_57972,type,
    v103695: ( state_type * $int ) > $o ).

tff(pred_def_57973,type,
    v103693: ( state_type * $int ) > $o ).

tff(pred_def_57974,type,
    v103691: ( state_type * $int ) > $o ).

tff(pred_def_57975,type,
    v103738: state_type > $o ).

tff(pred_def_57976,type,
    v103736: state_type > $o ).

tff(pred_def_57977,type,
    v103745: state_type > $o ).

tff(pred_def_57978,type,
    v103743: state_type > $o ).

tff(pred_def_57979,type,
    v103742: state_type > $o ).

tff(pred_def_57980,type,
    v103741: state_type > $o ).

tff(pred_def_57981,type,
    v103753: state_type > $o ).

tff(pred_def_57982,type,
    v103754: state_type > $o ).

tff(pred_def_57983,type,
    v103752: state_type > $o ).

tff(pred_def_57984,type,
    v103749: ( state_type * $int ) > $o ).

tff(pred_def_57985,type,
    v103751: ( state_type * $int ) > $o ).

tff(pred_def_57986,type,
    v103681: ( state_type * $int ) > $o ).

tff(pred_def_57987,type,
    v103679: ( state_type * $int ) > $o ).

tff(pred_def_57988,type,
    v103769: state_type > $o ).

tff(pred_def_57989,type,
    v103767: state_type > $o ).

tff(pred_def_57990,type,
    v103773: state_type > $o ).

tff(pred_def_57991,type,
    v103771: state_type > $o ).

tff(pred_def_57992,type,
    v103788: state_type > $o ).

tff(pred_def_57993,type,
    v103759: state_type > $o ).

tff(pred_def_57994,type,
    v103787: state_type > $o ).

tff(pred_def_57995,type,
    v103789: state_type > $o ).

tff(pred_def_57996,type,
    v103786: state_type > $o ).

tff(pred_def_57997,type,
    v103790: state_type > $o ).

tff(pred_def_57998,type,
    v103785: state_type > $o ).

tff(pred_def_57999,type,
    v103784: state_type > $o ).

tff(pred_def_58000,type,
    v103783: state_type > $o ).

tff(pred_def_58001,type,
    v103791: ( state_type * $int ) > $o ).

tff(pred_def_58002,type,
    v103761: ( state_type * $int ) > $o ).

tff(pred_def_58003,type,
    v103804: state_type > $o ).

tff(pred_def_58004,type,
    v103803: state_type > $o ).

tff(pred_def_58005,type,
    v103802: state_type > $o ).

tff(pred_def_58006,type,
    v103805: state_type > $o ).

tff(pred_def_58007,type,
    v103801: state_type > $o ).

tff(pred_def_58008,type,
    v103800: state_type > $o ).

tff(pred_def_58009,type,
    v103806: state_type > $o ).

tff(pred_def_58010,type,
    v103799: state_type > $o ).

tff(pred_def_58011,type,
    v103798: state_type > $o ).

tff(pred_def_58012,type,
    v103797: state_type > $o ).

tff(pred_def_58013,type,
    v103796: state_type > $o ).

tff(pred_def_58014,type,
    v103808: state_type > $o ).

tff(pred_def_58015,type,
    v103807: state_type > $o ).

tff(pred_def_58016,type,
    v103795: state_type > $o ).

tff(pred_def_58017,type,
    v103811: state_type > $o ).

tff(pred_def_58018,type,
    v103810: state_type > $o ).

tff(pred_def_58019,type,
    v103812: state_type > $o ).

tff(pred_def_58020,type,
    v103809: state_type > $o ).

tff(pred_def_58021,type,
    v103815: state_type > $o ).

tff(pred_def_58022,type,
    v103814: state_type > $o ).

tff(pred_def_58023,type,
    v103816: state_type > $o ).

tff(pred_def_58024,type,
    v103813: state_type > $o ).

tff(pred_def_58025,type,
    v103819: state_type > $o ).

tff(pred_def_58026,type,
    v103818: state_type > $o ).

tff(pred_def_58027,type,
    v103820: state_type > $o ).

tff(pred_def_58028,type,
    v103817: state_type > $o ).

tff(pred_def_58029,type,
    v103793: ( state_type * $int ) > $o ).

tff(pred_def_58030,type,
    v103792: ( state_type * $int ) > $o ).

tff(pred_def_58031,type,
    v103781: ( state_type * $int ) > $o ).

tff(pred_def_58032,type,
    v103779: ( state_type * $int ) > $o ).

tff(pred_def_58033,type,
    v103777: ( state_type * $int ) > $o ).

tff(pred_def_58034,type,
    v103775: ( state_type * $int ) > $o ).

tff(pred_def_58035,type,
    v103824: state_type > $o ).

tff(pred_def_58036,type,
    v103822: state_type > $o ).

tff(pred_def_58037,type,
    v103831: state_type > $o ).

tff(pred_def_58038,type,
    v103829: state_type > $o ).

tff(pred_def_58039,type,
    v103828: state_type > $o ).

tff(pred_def_58040,type,
    v103827: state_type > $o ).

tff(pred_def_58041,type,
    v103839: state_type > $o ).

tff(pred_def_58042,type,
    v103840: state_type > $o ).

tff(pred_def_58043,type,
    v103838: state_type > $o ).

tff(pred_def_58044,type,
    v103835: ( state_type * $int ) > $o ).

tff(pred_def_58045,type,
    v103837: ( state_type * $int ) > $o ).

tff(pred_def_58046,type,
    v103765: ( state_type * $int ) > $o ).

tff(pred_def_58047,type,
    v103763: ( state_type * $int ) > $o ).

tff(pred_def_58048,type,
    v103847: state_type > $o ).

tff(pred_def_58049,type,
    v103848: state_type > $o ).

tff(pred_def_58050,type,
    v103846: state_type > $o ).

tff(pred_def_58051,type,
    v103849: state_type > $o ).

tff(pred_def_58052,type,
    v103845: state_type > $o ).

tff(pred_def_58053,type,
    v103850: state_type > $o ).

tff(pred_def_58054,type,
    v103378: state_type > $o ).

tff(pred_def_58055,type,
    v103376: ( state_type * $int ) > $o ).

tff(pred_def_58056,type,
    v103866: state_type > $o ).

tff(pred_def_58057,type,
    v103864: state_type > $o ).

tff(pred_def_58058,type,
    v103862: state_type > $o ).

tff(pred_def_58059,type,
    v103860: state_type > $o ).

tff(pred_def_58060,type,
    v103874: state_type > $o ).

tff(pred_def_58061,type,
    v103872: state_type > $o ).

tff(pred_def_58062,type,
    v103870: state_type > $o ).

tff(pred_def_58063,type,
    v103868: state_type > $o ).

tff(pred_def_58064,type,
    v103889: state_type > $o ).

tff(pred_def_58065,type,
    v118: state_type > $o ).

tff(pred_def_58066,type,
    v103888: state_type > $o ).

tff(pred_def_58067,type,
    v103891: state_type > $o ).

tff(pred_def_58068,type,
    v84899: state_type > $o ).

tff(pred_def_58069,type,
    v103890: state_type > $o ).

tff(pred_def_58070,type,
    v103887: state_type > $o ).

tff(pred_def_58071,type,
    v103893: state_type > $o ).

tff(pred_def_58072,type,
    v103892: state_type > $o ).

tff(pred_def_58073,type,
    v103886: state_type > $o ).

tff(pred_def_58074,type,
    v103895: state_type > $o ).

tff(pred_def_58075,type,
    v103894: state_type > $o ).

tff(pred_def_58076,type,
    v89212: ( state_type * $int ) > $o ).

tff(pred_def_58077,type,
    v103884: state_type > $o ).

tff(pred_def_58078,type,
    v103897: ( state_type * $int ) > $o ).

tff(pred_def_58079,type,
    v103899: state_type > $o ).

tff(pred_def_58080,type,
    v103854: ( state_type * $int ) > $o ).

tff(pred_def_58081,type,
    v103902: state_type > $o ).

tff(pred_def_58082,type,
    v103913: state_type > $o ).

tff(pred_def_58083,type,
    v103912: state_type > $o ).

tff(pred_def_58084,type,
    v103911: state_type > $o ).

tff(pred_def_58085,type,
    v103914: state_type > $o ).

tff(pred_def_58086,type,
    v103910: state_type > $o ).

tff(pred_def_58087,type,
    v103909: state_type > $o ).

tff(pred_def_58088,type,
    v103908: state_type > $o ).

tff(pred_def_58089,type,
    v103907: state_type > $o ).

tff(pred_def_58090,type,
    v103916: state_type > $o ).

tff(pred_def_58091,type,
    v103915: state_type > $o ).

tff(pred_def_58092,type,
    v103906: state_type > $o ).

tff(pred_def_58093,type,
    v103919: state_type > $o ).

tff(pred_def_58094,type,
    v103918: state_type > $o ).

tff(pred_def_58095,type,
    v103920: state_type > $o ).

tff(pred_def_58096,type,
    v103917: state_type > $o ).

tff(pred_def_58097,type,
    v103923: state_type > $o ).

tff(pred_def_58098,type,
    v103922: state_type > $o ).

tff(pred_def_58099,type,
    v103924: state_type > $o ).

tff(pred_def_58100,type,
    v103921: state_type > $o ).

tff(pred_def_58101,type,
    v103904: ( state_type * $int ) > $o ).

tff(pred_def_58102,type,
    v103903: ( state_type * $int ) > $o ).

tff(pred_def_58103,type,
    v103901: ( state_type * $int ) > $o ).

tff(pred_def_58104,type,
    v103882: ( state_type * $int ) > $o ).

tff(pred_def_58105,type,
    v103880: ( state_type * $int ) > $o ).

tff(pred_def_58106,type,
    v103878: ( state_type * $int ) > $o ).

tff(pred_def_58107,type,
    v103876: ( state_type * $int ) > $o ).

tff(pred_def_58108,type,
    v103930: state_type > $o ).

tff(pred_def_58109,type,
    v103928: state_type > $o ).

tff(pred_def_58110,type,
    v103926: state_type > $o ).

tff(pred_def_58111,type,
    v103937: state_type > $o ).

tff(pred_def_58112,type,
    v103935: state_type > $o ).

tff(pred_def_58113,type,
    v103934: state_type > $o ).

tff(pred_def_58114,type,
    v103933: state_type > $o ).

tff(pred_def_58115,type,
    v103945: state_type > $o ).

tff(pred_def_58116,type,
    v103946: state_type > $o ).

tff(pred_def_58117,type,
    v103944: state_type > $o ).

tff(pred_def_58118,type,
    v103941: ( state_type * $int ) > $o ).

tff(pred_def_58119,type,
    v103943: ( state_type * $int ) > $o ).

tff(pred_def_58120,type,
    v103858: ( state_type * $int ) > $o ).

tff(pred_def_58121,type,
    v103856: ( state_type * $int ) > $o ).

tff(pred_def_58122,type,
    v103852: state_type > $o ).

tff(pred_def_58123,type,
    v103961: state_type > $o ).

tff(pred_def_58124,type,
    v103959: state_type > $o ).

tff(pred_def_58125,type,
    v103965: state_type > $o ).

tff(pred_def_58126,type,
    v103963: state_type > $o ).

tff(pred_def_58127,type,
    v103983: state_type > $o ).

tff(pred_def_58128,type,
    v103981: state_type > $o ).

tff(pred_def_58129,type,
    v103987: state_type > $o ).

tff(pred_def_58130,type,
    v103985: state_type > $o ).

tff(pred_def_58131,type,
    v103998: state_type > $o ).

tff(pred_def_58132,type,
    v103997: state_type > $o ).

tff(pred_def_58133,type,
    v104000: state_type > $o ).

tff(pred_def_58134,type,
    v103999: state_type > $o ).

tff(pred_def_58135,type,
    v103995: state_type > $o ).

tff(pred_def_58136,type,
    v104001: ( state_type * $int ) > $o ).

tff(pred_def_58137,type,
    v104002: state_type > $o ).

tff(pred_def_58138,type,
    v103993: ( state_type * $int ) > $o ).

tff(pred_def_58139,type,
    v103991: ( state_type * $int ) > $o ).

tff(pred_def_58140,type,
    v103989: ( state_type * $int ) > $o ).

tff(pred_def_58141,type,
    v104006: state_type > $o ).

tff(pred_def_58142,type,
    v104004: state_type > $o ).

tff(pred_def_58143,type,
    v104013: state_type > $o ).

tff(pred_def_58144,type,
    v104011: state_type > $o ).

tff(pred_def_58145,type,
    v104010: state_type > $o ).

tff(pred_def_58146,type,
    v104009: state_type > $o ).

tff(pred_def_58147,type,
    v104021: state_type > $o ).

tff(pred_def_58148,type,
    v104022: state_type > $o ).

tff(pred_def_58149,type,
    v104020: state_type > $o ).

tff(pred_def_58150,type,
    v104017: ( state_type * $int ) > $o ).

tff(pred_def_58151,type,
    v104019: ( state_type * $int ) > $o ).

tff(pred_def_58152,type,
    v104008: ( state_type * $int ) > $o ).

tff(pred_def_58153,type,
    v103979: ( state_type * $int ) > $o ).

tff(pred_def_58154,type,
    v103977: ( state_type * $int ) > $o ).

tff(pred_def_58155,type,
    v103975: state_type > $o ).

tff(pred_def_58156,type,
    v104030: state_type > $o ).

tff(pred_def_58157,type,
    v104029: state_type > $o ).

tff(pred_def_58158,type,
    v104032: state_type > $o ).

tff(pred_def_58159,type,
    v104031: state_type > $o ).

tff(pred_def_58160,type,
    v104038: state_type > $o ).

tff(pred_def_58161,type,
    v104036: state_type > $o ).

tff(pred_def_58162,type,
    v104035: state_type > $o ).

tff(pred_def_58163,type,
    v104034: ( state_type * $int ) > $o ).

tff(pred_def_58164,type,
    v104026: state_type > $o ).

tff(pred_def_58165,type,
    v104042: state_type > $o ).

tff(pred_def_58166,type,
    v104044: state_type > $o ).

tff(pred_def_58167,type,
    v103953: ( state_type * $int ) > $o ).

tff(pred_def_58168,type,
    v104046: state_type > $o ).

tff(pred_def_58169,type,
    v104051: state_type > $o ).

tff(pred_def_58170,type,
    v104050: state_type > $o ).

tff(pred_def_58171,type,
    v104053: state_type > $o ).

tff(pred_def_58172,type,
    v104052: state_type > $o ).

tff(pred_def_58173,type,
    v104049: state_type > $o ).

tff(pred_def_58174,type,
    v104047: ( state_type * $int ) > $o ).

tff(pred_def_58175,type,
    v104045: ( state_type * $int ) > $o ).

tff(pred_def_58176,type,
    v104043: ( state_type * $int ) > $o ).

tff(pred_def_58177,type,
    v103973: ( state_type * $int ) > $o ).

tff(pred_def_58178,type,
    v103971: ( state_type * $int ) > $o ).

tff(pred_def_58179,type,
    v103969: ( state_type * $int ) > $o ).

tff(pred_def_58180,type,
    v103967: ( state_type * $int ) > $o ).

tff(pred_def_58181,type,
    v104057: state_type > $o ).

tff(pred_def_58182,type,
    v104055: state_type > $o ).

tff(pred_def_58183,type,
    v104064: state_type > $o ).

tff(pred_def_58184,type,
    v104062: state_type > $o ).

tff(pred_def_58185,type,
    v104061: state_type > $o ).

tff(pred_def_58186,type,
    v104060: state_type > $o ).

tff(pred_def_58187,type,
    v104072: state_type > $o ).

tff(pred_def_58188,type,
    v104073: state_type > $o ).

tff(pred_def_58189,type,
    v104071: state_type > $o ).

tff(pred_def_58190,type,
    v104068: ( state_type * $int ) > $o ).

tff(pred_def_58191,type,
    v104070: ( state_type * $int ) > $o ).

tff(pred_def_58192,type,
    v103957: ( state_type * $int ) > $o ).

tff(pred_def_58193,type,
    v103955: ( state_type * $int ) > $o ).

tff(pred_def_58194,type,
    v103951: state_type > $o ).

tff(pred_def_58195,type,
    v104088: state_type > $o ).

tff(pred_def_58196,type,
    v104086: state_type > $o ).

tff(pred_def_58197,type,
    v104092: state_type > $o ).

tff(pred_def_58198,type,
    v104090: state_type > $o ).

tff(pred_def_58199,type,
    v104102: state_type > $o ).

tff(pred_def_58200,type,
    v104105: ( state_type * $int ) > $o ).

tff(pred_def_58201,type,
    v104078: state_type > $o ).

tff(pred_def_58202,type,
    v104107: state_type > $o ).

tff(pred_def_58203,type,
    v104117: state_type > $o ).

tff(pred_def_58204,type,
    v104116: state_type > $o ).

tff(pred_def_58205,type,
    v104115: state_type > $o ).

tff(pred_def_58206,type,
    v104118: state_type > $o ).

tff(pred_def_58207,type,
    v104114: state_type > $o ).

tff(pred_def_58208,type,
    v104113: state_type > $o ).

tff(pred_def_58209,type,
    v104112: state_type > $o ).

tff(pred_def_58210,type,
    v104111: state_type > $o ).

tff(pred_def_58211,type,
    v104120: state_type > $o ).

tff(pred_def_58212,type,
    v104119: state_type > $o ).

tff(pred_def_58213,type,
    v104110: state_type > $o ).

tff(pred_def_58214,type,
    v104123: state_type > $o ).

tff(pred_def_58215,type,
    v104122: state_type > $o ).

tff(pred_def_58216,type,
    v104124: state_type > $o ).

tff(pred_def_58217,type,
    v104121: state_type > $o ).

tff(pred_def_58218,type,
    v104127: state_type > $o ).

tff(pred_def_58219,type,
    v104126: state_type > $o ).

tff(pred_def_58220,type,
    v104128: state_type > $o ).

tff(pred_def_58221,type,
    v104125: state_type > $o ).

tff(pred_def_58222,type,
    v104108: ( state_type * $int ) > $o ).

tff(pred_def_58223,type,
    v104130: state_type > $o ).

tff(pred_def_58224,type,
    v104080: ( state_type * $int ) > $o ).

tff(pred_def_58225,type,
    v104132: state_type > $o ).

tff(pred_def_58226,type,
    v104143: state_type > $o ).

tff(pred_def_58227,type,
    v104142: state_type > $o ).

tff(pred_def_58228,type,
    v104141: state_type > $o ).

tff(pred_def_58229,type,
    v104144: state_type > $o ).

tff(pred_def_58230,type,
    v104140: state_type > $o ).

tff(pred_def_58231,type,
    v104139: state_type > $o ).

tff(pred_def_58232,type,
    v104138: state_type > $o ).

tff(pred_def_58233,type,
    v104137: state_type > $o ).

tff(pred_def_58234,type,
    v104146: state_type > $o ).

tff(pred_def_58235,type,
    v104145: state_type > $o ).

tff(pred_def_58236,type,
    v104136: state_type > $o ).

tff(pred_def_58237,type,
    v104149: state_type > $o ).

tff(pred_def_58238,type,
    v104148: state_type > $o ).

tff(pred_def_58239,type,
    v104150: state_type > $o ).

tff(pred_def_58240,type,
    v104147: state_type > $o ).

tff(pred_def_58241,type,
    v104153: state_type > $o ).

tff(pred_def_58242,type,
    v104152: state_type > $o ).

tff(pred_def_58243,type,
    v104154: state_type > $o ).

tff(pred_def_58244,type,
    v104151: state_type > $o ).

tff(pred_def_58245,type,
    v104134: ( state_type * $int ) > $o ).

tff(pred_def_58246,type,
    v104133: ( state_type * $int ) > $o ).

tff(pred_def_58247,type,
    v104131: ( state_type * $int ) > $o ).

tff(pred_def_58248,type,
    v104129: ( state_type * $int ) > $o ).

tff(pred_def_58249,type,
    v104100: ( state_type * $int ) > $o ).

tff(pred_def_58250,type,
    v104098: ( state_type * $int ) > $o ).

tff(pred_def_58251,type,
    v104096: ( state_type * $int ) > $o ).

tff(pred_def_58252,type,
    v104094: ( state_type * $int ) > $o ).

tff(pred_def_58253,type,
    v104158: state_type > $o ).

tff(pred_def_58254,type,
    v104156: state_type > $o ).

tff(pred_def_58255,type,
    v104165: state_type > $o ).

tff(pred_def_58256,type,
    v104163: state_type > $o ).

tff(pred_def_58257,type,
    v104162: state_type > $o ).

tff(pred_def_58258,type,
    v104161: state_type > $o ).

tff(pred_def_58259,type,
    v104173: state_type > $o ).

tff(pred_def_58260,type,
    v104174: state_type > $o ).

tff(pred_def_58261,type,
    v104172: state_type > $o ).

tff(pred_def_58262,type,
    v104169: ( state_type * $int ) > $o ).

tff(pred_def_58263,type,
    v104171: ( state_type * $int ) > $o ).

tff(pred_def_58264,type,
    v104084: ( state_type * $int ) > $o ).

tff(pred_def_58265,type,
    v104082: ( state_type * $int ) > $o ).

tff(pred_def_58266,type,
    v104191: state_type > $o ).

tff(pred_def_58267,type,
    v104189: state_type > $o ).

tff(pred_def_58268,type,
    v104195: state_type > $o ).

tff(pred_def_58269,type,
    v104193: state_type > $o ).

tff(pred_def_58270,type,
    v104207: state_type > $o ).

tff(pred_def_58271,type,
    v104205: state_type > $o ).

tff(pred_def_58272,type,
    v104209: ( state_type * $int ) > $o ).

tff(pred_def_58273,type,
    v104181: state_type > $o ).

tff(pred_def_58274,type,
    v104212: state_type > $o ).

tff(pred_def_58275,type,
    v104211: state_type > $o ).

tff(pred_def_58276,type,
    v104224: state_type > $o ).

tff(pred_def_58277,type,
    v104223: state_type > $o ).

tff(pred_def_58278,type,
    v104222: state_type > $o ).

tff(pred_def_58279,type,
    v104225: state_type > $o ).

tff(pred_def_58280,type,
    v104221: state_type > $o ).

tff(pred_def_58281,type,
    v104220: state_type > $o ).

tff(pred_def_58282,type,
    v104226: state_type > $o ).

tff(pred_def_58283,type,
    v104219: state_type > $o ).

tff(pred_def_58284,type,
    v104218: state_type > $o ).

tff(pred_def_58285,type,
    v104217: state_type > $o ).

tff(pred_def_58286,type,
    v104216: state_type > $o ).

tff(pred_def_58287,type,
    v104228: state_type > $o ).

tff(pred_def_58288,type,
    v104227: state_type > $o ).

tff(pred_def_58289,type,
    v104215: state_type > $o ).

tff(pred_def_58290,type,
    v104231: state_type > $o ).

tff(pred_def_58291,type,
    v104230: state_type > $o ).

tff(pred_def_58292,type,
    v104232: state_type > $o ).

tff(pred_def_58293,type,
    v104229: state_type > $o ).

tff(pred_def_58294,type,
    v104235: state_type > $o ).

tff(pred_def_58295,type,
    v104234: state_type > $o ).

tff(pred_def_58296,type,
    v104236: state_type > $o ).

tff(pred_def_58297,type,
    v104233: state_type > $o ).

tff(pred_def_58298,type,
    v104239: state_type > $o ).

tff(pred_def_58299,type,
    v104238: state_type > $o ).

tff(pred_def_58300,type,
    v104240: state_type > $o ).

tff(pred_def_58301,type,
    v104237: state_type > $o ).

tff(pred_def_58302,type,
    v104213: ( state_type * $int ) > $o ).

tff(pred_def_58303,type,
    v104183: ( state_type * $int ) > $o ).

tff(pred_def_58304,type,
    v104253: state_type > $o ).

tff(pred_def_58305,type,
    v104252: state_type > $o ).

tff(pred_def_58306,type,
    v104251: state_type > $o ).

tff(pred_def_58307,type,
    v104254: state_type > $o ).

tff(pred_def_58308,type,
    v104250: state_type > $o ).

tff(pred_def_58309,type,
    v104249: state_type > $o ).

tff(pred_def_58310,type,
    v104255: state_type > $o ).

tff(pred_def_58311,type,
    v104248: state_type > $o ).

tff(pred_def_58312,type,
    v104247: state_type > $o ).

tff(pred_def_58313,type,
    v104246: state_type > $o ).

tff(pred_def_58314,type,
    v104245: state_type > $o ).

tff(pred_def_58315,type,
    v104257: state_type > $o ).

tff(pred_def_58316,type,
    v104256: state_type > $o ).

tff(pred_def_58317,type,
    v104244: state_type > $o ).

tff(pred_def_58318,type,
    v104260: state_type > $o ).

tff(pred_def_58319,type,
    v104259: state_type > $o ).

tff(pred_def_58320,type,
    v104261: state_type > $o ).

tff(pred_def_58321,type,
    v104258: state_type > $o ).

tff(pred_def_58322,type,
    v104264: state_type > $o ).

tff(pred_def_58323,type,
    v104263: state_type > $o ).

tff(pred_def_58324,type,
    v104265: state_type > $o ).

tff(pred_def_58325,type,
    v104262: state_type > $o ).

tff(pred_def_58326,type,
    v104268: state_type > $o ).

tff(pred_def_58327,type,
    v104267: state_type > $o ).

tff(pred_def_58328,type,
    v104269: state_type > $o ).

tff(pred_def_58329,type,
    v104266: state_type > $o ).

tff(pred_def_58330,type,
    v104242: ( state_type * $int ) > $o ).

tff(pred_def_58331,type,
    v104241: ( state_type * $int ) > $o ).

tff(pred_def_58332,type,
    v104203: ( state_type * $int ) > $o ).

tff(pred_def_58333,type,
    v104201: ( state_type * $int ) > $o ).

tff(pred_def_58334,type,
    v104199: ( state_type * $int ) > $o ).

tff(pred_def_58335,type,
    v104197: ( state_type * $int ) > $o ).

tff(pred_def_58336,type,
    v104273: state_type > $o ).

tff(pred_def_58337,type,
    v104271: state_type > $o ).

tff(pred_def_58338,type,
    v104280: state_type > $o ).

tff(pred_def_58339,type,
    v104278: state_type > $o ).

tff(pred_def_58340,type,
    v104277: state_type > $o ).

tff(pred_def_58341,type,
    v104276: state_type > $o ).

tff(pred_def_58342,type,
    v104288: state_type > $o ).

tff(pred_def_58343,type,
    v104289: state_type > $o ).

tff(pred_def_58344,type,
    v104287: state_type > $o ).

tff(pred_def_58345,type,
    v104284: ( state_type * $int ) > $o ).

tff(pred_def_58346,type,
    v104286: ( state_type * $int ) > $o ).

tff(pred_def_58347,type,
    v104187: ( state_type * $int ) > $o ).

tff(pred_def_58348,type,
    v104185: ( state_type * $int ) > $o ).

tff(pred_def_58349,type,
    v104304: state_type > $o ).

tff(pred_def_58350,type,
    v104302: state_type > $o ).

tff(pred_def_58351,type,
    v104308: state_type > $o ).

tff(pred_def_58352,type,
    v104306: state_type > $o ).

tff(pred_def_58353,type,
    v104321: state_type > $o ).

tff(pred_def_58354,type,
    v104294: state_type > $o ).

tff(pred_def_58355,type,
    v104320: state_type > $o ).

tff(pred_def_58356,type,
    v104319: state_type > $o ).

tff(pred_def_58357,type,
    v104318: state_type > $o ).

tff(pred_def_58358,type,
    v104322: ( state_type * $int ) > $o ).

tff(pred_def_58359,type,
    v104296: ( state_type * $int ) > $o ).

tff(pred_def_58360,type,
    v104335: state_type > $o ).

tff(pred_def_58361,type,
    v104334: state_type > $o ).

tff(pred_def_58362,type,
    v104333: state_type > $o ).

tff(pred_def_58363,type,
    v104336: state_type > $o ).

tff(pred_def_58364,type,
    v104332: state_type > $o ).

tff(pred_def_58365,type,
    v104331: state_type > $o ).

tff(pred_def_58366,type,
    v104337: state_type > $o ).

tff(pred_def_58367,type,
    v104330: state_type > $o ).

tff(pred_def_58368,type,
    v104329: state_type > $o ).

tff(pred_def_58369,type,
    v104328: state_type > $o ).

tff(pred_def_58370,type,
    v104327: state_type > $o ).

tff(pred_def_58371,type,
    v104339: state_type > $o ).

tff(pred_def_58372,type,
    v104338: state_type > $o ).

tff(pred_def_58373,type,
    v104326: state_type > $o ).

tff(pred_def_58374,type,
    v104342: state_type > $o ).

tff(pred_def_58375,type,
    v104341: state_type > $o ).

tff(pred_def_58376,type,
    v104343: state_type > $o ).

tff(pred_def_58377,type,
    v104340: state_type > $o ).

tff(pred_def_58378,type,
    v104346: state_type > $o ).

tff(pred_def_58379,type,
    v104345: state_type > $o ).

tff(pred_def_58380,type,
    v104347: state_type > $o ).

tff(pred_def_58381,type,
    v104344: state_type > $o ).

tff(pred_def_58382,type,
    v104350: state_type > $o ).

tff(pred_def_58383,type,
    v104349: state_type > $o ).

tff(pred_def_58384,type,
    v104351: state_type > $o ).

tff(pred_def_58385,type,
    v104348: state_type > $o ).

tff(pred_def_58386,type,
    v104324: ( state_type * $int ) > $o ).

tff(pred_def_58387,type,
    v104323: ( state_type * $int ) > $o ).

tff(pred_def_58388,type,
    v104316: ( state_type * $int ) > $o ).

tff(pred_def_58389,type,
    v104314: ( state_type * $int ) > $o ).

tff(pred_def_58390,type,
    v104312: ( state_type * $int ) > $o ).

tff(pred_def_58391,type,
    v104310: ( state_type * $int ) > $o ).

tff(pred_def_58392,type,
    v104355: state_type > $o ).

tff(pred_def_58393,type,
    v104353: state_type > $o ).

tff(pred_def_58394,type,
    v104362: state_type > $o ).

tff(pred_def_58395,type,
    v104360: state_type > $o ).

tff(pred_def_58396,type,
    v104359: state_type > $o ).

tff(pred_def_58397,type,
    v104358: state_type > $o ).

tff(pred_def_58398,type,
    v104370: state_type > $o ).

tff(pred_def_58399,type,
    v104371: state_type > $o ).

tff(pred_def_58400,type,
    v104369: state_type > $o ).

tff(pred_def_58401,type,
    v104366: ( state_type * $int ) > $o ).

tff(pred_def_58402,type,
    v104368: ( state_type * $int ) > $o ).

tff(pred_def_58403,type,
    v104300: ( state_type * $int ) > $o ).

tff(pred_def_58404,type,
    v104298: ( state_type * $int ) > $o ).

tff(pred_def_58405,type,
    v104386: state_type > $o ).

tff(pred_def_58406,type,
    v104384: state_type > $o ).

tff(pred_def_58407,type,
    v104390: state_type > $o ).

tff(pred_def_58408,type,
    v104388: state_type > $o ).

tff(pred_def_58409,type,
    v104404: state_type > $o ).

tff(pred_def_58410,type,
    v104376: state_type > $o ).

tff(pred_def_58411,type,
    v104403: state_type > $o ).

tff(pred_def_58412,type,
    v104405: state_type > $o ).

tff(pred_def_58413,type,
    v104402: state_type > $o ).

tff(pred_def_58414,type,
    v104401: state_type > $o ).

tff(pred_def_58415,type,
    v104400: state_type > $o ).

tff(pred_def_58416,type,
    v104406: ( state_type * $int ) > $o ).

tff(pred_def_58417,type,
    v104378: ( state_type * $int ) > $o ).

tff(pred_def_58418,type,
    v104419: state_type > $o ).

tff(pred_def_58419,type,
    v104418: state_type > $o ).

tff(pred_def_58420,type,
    v104417: state_type > $o ).

tff(pred_def_58421,type,
    v104420: state_type > $o ).

tff(pred_def_58422,type,
    v104416: state_type > $o ).

tff(pred_def_58423,type,
    v104415: state_type > $o ).

tff(pred_def_58424,type,
    v104421: state_type > $o ).

tff(pred_def_58425,type,
    v104414: state_type > $o ).

tff(pred_def_58426,type,
    v104413: state_type > $o ).

tff(pred_def_58427,type,
    v104412: state_type > $o ).

tff(pred_def_58428,type,
    v104411: state_type > $o ).

tff(pred_def_58429,type,
    v104423: state_type > $o ).

tff(pred_def_58430,type,
    v104422: state_type > $o ).

tff(pred_def_58431,type,
    v104410: state_type > $o ).

tff(pred_def_58432,type,
    v104426: state_type > $o ).

tff(pred_def_58433,type,
    v104425: state_type > $o ).

tff(pred_def_58434,type,
    v104427: state_type > $o ).

tff(pred_def_58435,type,
    v104424: state_type > $o ).

tff(pred_def_58436,type,
    v104430: state_type > $o ).

tff(pred_def_58437,type,
    v104429: state_type > $o ).

tff(pred_def_58438,type,
    v104431: state_type > $o ).

tff(pred_def_58439,type,
    v104428: state_type > $o ).

tff(pred_def_58440,type,
    v104434: state_type > $o ).

tff(pred_def_58441,type,
    v104433: state_type > $o ).

tff(pred_def_58442,type,
    v104435: state_type > $o ).

tff(pred_def_58443,type,
    v104432: state_type > $o ).

tff(pred_def_58444,type,
    v104408: ( state_type * $int ) > $o ).

tff(pred_def_58445,type,
    v104407: ( state_type * $int ) > $o ).

tff(pred_def_58446,type,
    v104398: ( state_type * $int ) > $o ).

tff(pred_def_58447,type,
    v104396: ( state_type * $int ) > $o ).

tff(pred_def_58448,type,
    v104394: ( state_type * $int ) > $o ).

tff(pred_def_58449,type,
    v104392: ( state_type * $int ) > $o ).

tff(pred_def_58450,type,
    v104439: state_type > $o ).

tff(pred_def_58451,type,
    v104437: state_type > $o ).

tff(pred_def_58452,type,
    v104446: state_type > $o ).

tff(pred_def_58453,type,
    v104444: state_type > $o ).

tff(pred_def_58454,type,
    v104443: state_type > $o ).

tff(pred_def_58455,type,
    v104442: state_type > $o ).

tff(pred_def_58456,type,
    v104454: state_type > $o ).

tff(pred_def_58457,type,
    v104455: state_type > $o ).

tff(pred_def_58458,type,
    v104453: state_type > $o ).

tff(pred_def_58459,type,
    v104450: ( state_type * $int ) > $o ).

tff(pred_def_58460,type,
    v104452: ( state_type * $int ) > $o ).

tff(pred_def_58461,type,
    v104382: ( state_type * $int ) > $o ).

tff(pred_def_58462,type,
    v104380: ( state_type * $int ) > $o ).

tff(pred_def_58463,type,
    v104470: state_type > $o ).

tff(pred_def_58464,type,
    v104468: state_type > $o ).

tff(pred_def_58465,type,
    v104474: state_type > $o ).

tff(pred_def_58466,type,
    v104472: state_type > $o ).

tff(pred_def_58467,type,
    v104489: state_type > $o ).

tff(pred_def_58468,type,
    v104460: state_type > $o ).

tff(pred_def_58469,type,
    v104488: state_type > $o ).

tff(pred_def_58470,type,
    v104490: state_type > $o ).

tff(pred_def_58471,type,
    v104487: state_type > $o ).

tff(pred_def_58472,type,
    v104491: state_type > $o ).

tff(pred_def_58473,type,
    v104486: state_type > $o ).

tff(pred_def_58474,type,
    v104485: state_type > $o ).

tff(pred_def_58475,type,
    v104484: state_type > $o ).

tff(pred_def_58476,type,
    v104492: ( state_type * $int ) > $o ).

tff(pred_def_58477,type,
    v104462: ( state_type * $int ) > $o ).

tff(pred_def_58478,type,
    v104505: state_type > $o ).

tff(pred_def_58479,type,
    v104504: state_type > $o ).

tff(pred_def_58480,type,
    v104503: state_type > $o ).

tff(pred_def_58481,type,
    v104506: state_type > $o ).

tff(pred_def_58482,type,
    v104502: state_type > $o ).

tff(pred_def_58483,type,
    v104501: state_type > $o ).

tff(pred_def_58484,type,
    v104507: state_type > $o ).

tff(pred_def_58485,type,
    v104500: state_type > $o ).

tff(pred_def_58486,type,
    v104499: state_type > $o ).

tff(pred_def_58487,type,
    v104498: state_type > $o ).

tff(pred_def_58488,type,
    v104497: state_type > $o ).

tff(pred_def_58489,type,
    v104509: state_type > $o ).

tff(pred_def_58490,type,
    v104508: state_type > $o ).

tff(pred_def_58491,type,
    v104496: state_type > $o ).

tff(pred_def_58492,type,
    v104512: state_type > $o ).

tff(pred_def_58493,type,
    v104511: state_type > $o ).

tff(pred_def_58494,type,
    v104513: state_type > $o ).

tff(pred_def_58495,type,
    v104510: state_type > $o ).

tff(pred_def_58496,type,
    v104516: state_type > $o ).

tff(pred_def_58497,type,
    v104515: state_type > $o ).

tff(pred_def_58498,type,
    v104517: state_type > $o ).

tff(pred_def_58499,type,
    v104514: state_type > $o ).

tff(pred_def_58500,type,
    v104520: state_type > $o ).

tff(pred_def_58501,type,
    v104519: state_type > $o ).

tff(pred_def_58502,type,
    v104521: state_type > $o ).

tff(pred_def_58503,type,
    v104518: state_type > $o ).

tff(pred_def_58504,type,
    v104494: ( state_type * $int ) > $o ).

tff(pred_def_58505,type,
    v104493: ( state_type * $int ) > $o ).

tff(pred_def_58506,type,
    v104482: ( state_type * $int ) > $o ).

tff(pred_def_58507,type,
    v104480: ( state_type * $int ) > $o ).

tff(pred_def_58508,type,
    v104478: ( state_type * $int ) > $o ).

tff(pred_def_58509,type,
    v104476: ( state_type * $int ) > $o ).

tff(pred_def_58510,type,
    v104525: state_type > $o ).

tff(pred_def_58511,type,
    v104523: state_type > $o ).

tff(pred_def_58512,type,
    v104532: state_type > $o ).

tff(pred_def_58513,type,
    v104530: state_type > $o ).

tff(pred_def_58514,type,
    v104529: state_type > $o ).

tff(pred_def_58515,type,
    v104528: state_type > $o ).

tff(pred_def_58516,type,
    v104540: state_type > $o ).

tff(pred_def_58517,type,
    v104541: state_type > $o ).

tff(pred_def_58518,type,
    v104539: state_type > $o ).

tff(pred_def_58519,type,
    v104536: ( state_type * $int ) > $o ).

tff(pred_def_58520,type,
    v104538: ( state_type * $int ) > $o ).

tff(pred_def_58521,type,
    v104466: ( state_type * $int ) > $o ).

tff(pred_def_58522,type,
    v104464: ( state_type * $int ) > $o ).

tff(pred_def_58523,type,
    v104548: state_type > $o ).

tff(pred_def_58524,type,
    v104549: state_type > $o ).

tff(pred_def_58525,type,
    v104547: state_type > $o ).

tff(pred_def_58526,type,
    v104550: state_type > $o ).

tff(pred_def_58527,type,
    v104546: state_type > $o ).

tff(pred_def_58528,type,
    v104551: state_type > $o ).

tff(pred_def_58529,type,
    v104179: state_type > $o ).

tff(pred_def_58530,type,
    v104567: state_type > $o ).

tff(pred_def_58531,type,
    v104565: state_type > $o ).

tff(pred_def_58532,type,
    v104563: state_type > $o ).

tff(pred_def_58533,type,
    v104561: state_type > $o ).

tff(pred_def_58534,type,
    v104575: state_type > $o ).

tff(pred_def_58535,type,
    v104573: state_type > $o ).

tff(pred_def_58536,type,
    v104571: state_type > $o ).

tff(pred_def_58537,type,
    v104569: state_type > $o ).

tff(pred_def_58538,type,
    v104590: state_type > $o ).

tff(pred_def_58539,type,
    v104589: state_type > $o ).

tff(pred_def_58540,type,
    v104592: state_type > $o ).

tff(pred_def_58541,type,
    v104591: state_type > $o ).

tff(pred_def_58542,type,
    v104588: state_type > $o ).

tff(pred_def_58543,type,
    v104594: state_type > $o ).

tff(pred_def_58544,type,
    v104593: state_type > $o ).

tff(pred_def_58545,type,
    v104587: state_type > $o ).

tff(pred_def_58546,type,
    v104596: state_type > $o ).

tff(pred_def_58547,type,
    v104595: state_type > $o ).

tff(pred_def_58548,type,
    v104585: state_type > $o ).

tff(pred_def_58549,type,
    v104598: ( state_type * $int ) > $o ).

tff(pred_def_58550,type,
    v104600: state_type > $o ).

tff(pred_def_58551,type,
    v104555: ( state_type * $int ) > $o ).

tff(pred_def_58552,type,
    v104603: state_type > $o ).

tff(pred_def_58553,type,
    v104614: state_type > $o ).

tff(pred_def_58554,type,
    v104613: state_type > $o ).

tff(pred_def_58555,type,
    v104612: state_type > $o ).

tff(pred_def_58556,type,
    v104615: state_type > $o ).

tff(pred_def_58557,type,
    v104611: state_type > $o ).

tff(pred_def_58558,type,
    v104610: state_type > $o ).

tff(pred_def_58559,type,
    v104609: state_type > $o ).

tff(pred_def_58560,type,
    v104608: state_type > $o ).

tff(pred_def_58561,type,
    v104617: state_type > $o ).

tff(pred_def_58562,type,
    v104616: state_type > $o ).

tff(pred_def_58563,type,
    v104607: state_type > $o ).

tff(pred_def_58564,type,
    v104620: state_type > $o ).

tff(pred_def_58565,type,
    v104619: state_type > $o ).

tff(pred_def_58566,type,
    v104621: state_type > $o ).

tff(pred_def_58567,type,
    v104618: state_type > $o ).

tff(pred_def_58568,type,
    v104624: state_type > $o ).

tff(pred_def_58569,type,
    v104623: state_type > $o ).

tff(pred_def_58570,type,
    v104625: state_type > $o ).

tff(pred_def_58571,type,
    v104622: state_type > $o ).

tff(pred_def_58572,type,
    v104605: ( state_type * $int ) > $o ).

tff(pred_def_58573,type,
    v104604: ( state_type * $int ) > $o ).

tff(pred_def_58574,type,
    v104602: ( state_type * $int ) > $o ).

tff(pred_def_58575,type,
    v104583: ( state_type * $int ) > $o ).

tff(pred_def_58576,type,
    v104581: ( state_type * $int ) > $o ).

tff(pred_def_58577,type,
    v104579: ( state_type * $int ) > $o ).

tff(pred_def_58578,type,
    v104577: ( state_type * $int ) > $o ).

tff(pred_def_58579,type,
    v104631: state_type > $o ).

tff(pred_def_58580,type,
    v104629: state_type > $o ).

tff(pred_def_58581,type,
    v104627: state_type > $o ).

tff(pred_def_58582,type,
    v104638: state_type > $o ).

tff(pred_def_58583,type,
    v104636: state_type > $o ).

tff(pred_def_58584,type,
    v104635: state_type > $o ).

tff(pred_def_58585,type,
    v104634: state_type > $o ).

tff(pred_def_58586,type,
    v104646: state_type > $o ).

tff(pred_def_58587,type,
    v104647: state_type > $o ).

tff(pred_def_58588,type,
    v104645: state_type > $o ).

tff(pred_def_58589,type,
    v104642: ( state_type * $int ) > $o ).

tff(pred_def_58590,type,
    v104644: ( state_type * $int ) > $o ).

tff(pred_def_58591,type,
    v104559: ( state_type * $int ) > $o ).

tff(pred_def_58592,type,
    v104557: ( state_type * $int ) > $o ).

tff(pred_def_58593,type,
    v104553: state_type > $o ).

tff(pred_def_58594,type,
    v104662: state_type > $o ).

tff(pred_def_58595,type,
    v104660: state_type > $o ).

tff(pred_def_58596,type,
    v104666: state_type > $o ).

tff(pred_def_58597,type,
    v104664: state_type > $o ).

tff(pred_def_58598,type,
    v104684: state_type > $o ).

tff(pred_def_58599,type,
    v104682: state_type > $o ).

tff(pred_def_58600,type,
    v104688: state_type > $o ).

tff(pred_def_58601,type,
    v104686: state_type > $o ).

tff(pred_def_58602,type,
    v104699: state_type > $o ).

tff(pred_def_58603,type,
    v104698: state_type > $o ).

tff(pred_def_58604,type,
    v104701: state_type > $o ).

tff(pred_def_58605,type,
    v104700: state_type > $o ).

tff(pred_def_58606,type,
    v104696: state_type > $o ).

tff(pred_def_58607,type,
    v104702: ( state_type * $int ) > $o ).

tff(pred_def_58608,type,
    v104703: state_type > $o ).

tff(pred_def_58609,type,
    v104694: ( state_type * $int ) > $o ).

tff(pred_def_58610,type,
    v104692: ( state_type * $int ) > $o ).

tff(pred_def_58611,type,
    v104690: ( state_type * $int ) > $o ).

tff(pred_def_58612,type,
    v104707: state_type > $o ).

tff(pred_def_58613,type,
    v104705: state_type > $o ).

tff(pred_def_58614,type,
    v104714: state_type > $o ).

tff(pred_def_58615,type,
    v104712: state_type > $o ).

tff(pred_def_58616,type,
    v104711: state_type > $o ).

tff(pred_def_58617,type,
    v104710: state_type > $o ).

tff(pred_def_58618,type,
    v104722: state_type > $o ).

tff(pred_def_58619,type,
    v104723: state_type > $o ).

tff(pred_def_58620,type,
    v104721: state_type > $o ).

tff(pred_def_58621,type,
    v104718: ( state_type * $int ) > $o ).

tff(pred_def_58622,type,
    v104720: ( state_type * $int ) > $o ).

tff(pred_def_58623,type,
    v104709: ( state_type * $int ) > $o ).

tff(pred_def_58624,type,
    v104680: ( state_type * $int ) > $o ).

tff(pred_def_58625,type,
    v104678: ( state_type * $int ) > $o ).

tff(pred_def_58626,type,
    v104676: state_type > $o ).

tff(pred_def_58627,type,
    v104731: state_type > $o ).

tff(pred_def_58628,type,
    v104730: state_type > $o ).

tff(pred_def_58629,type,
    v104733: state_type > $o ).

tff(pred_def_58630,type,
    v104732: state_type > $o ).

tff(pred_def_58631,type,
    v104739: state_type > $o ).

tff(pred_def_58632,type,
    v104737: state_type > $o ).

tff(pred_def_58633,type,
    v104736: state_type > $o ).

tff(pred_def_58634,type,
    v104735: ( state_type * $int ) > $o ).

tff(pred_def_58635,type,
    v104727: state_type > $o ).

tff(pred_def_58636,type,
    v104743: state_type > $o ).

tff(pred_def_58637,type,
    v104745: state_type > $o ).

tff(pred_def_58638,type,
    v104654: ( state_type * $int ) > $o ).

tff(pred_def_58639,type,
    v104747: state_type > $o ).

tff(pred_def_58640,type,
    v104752: state_type > $o ).

tff(pred_def_58641,type,
    v104751: state_type > $o ).

tff(pred_def_58642,type,
    v104754: state_type > $o ).

tff(pred_def_58643,type,
    v104753: state_type > $o ).

tff(pred_def_58644,type,
    v104750: state_type > $o ).

tff(pred_def_58645,type,
    v104748: ( state_type * $int ) > $o ).

tff(pred_def_58646,type,
    v104746: ( state_type * $int ) > $o ).

tff(pred_def_58647,type,
    v104744: ( state_type * $int ) > $o ).

tff(pred_def_58648,type,
    v104674: ( state_type * $int ) > $o ).

tff(pred_def_58649,type,
    v104672: ( state_type * $int ) > $o ).

tff(pred_def_58650,type,
    v104670: ( state_type * $int ) > $o ).

tff(pred_def_58651,type,
    v104668: ( state_type * $int ) > $o ).

tff(pred_def_58652,type,
    v104758: state_type > $o ).

tff(pred_def_58653,type,
    v104756: state_type > $o ).

tff(pred_def_58654,type,
    v104765: state_type > $o ).

tff(pred_def_58655,type,
    v104763: state_type > $o ).

tff(pred_def_58656,type,
    v104762: state_type > $o ).

tff(pred_def_58657,type,
    v104761: state_type > $o ).

tff(pred_def_58658,type,
    v104773: state_type > $o ).

tff(pred_def_58659,type,
    v104774: state_type > $o ).

tff(pred_def_58660,type,
    v104772: state_type > $o ).

tff(pred_def_58661,type,
    v104769: ( state_type * $int ) > $o ).

tff(pred_def_58662,type,
    v104771: ( state_type * $int ) > $o ).

tff(pred_def_58663,type,
    v104658: ( state_type * $int ) > $o ).

tff(pred_def_58664,type,
    v104656: ( state_type * $int ) > $o ).

tff(pred_def_58665,type,
    v104652: state_type > $o ).

tff(pred_def_58666,type,
    v104789: state_type > $o ).

tff(pred_def_58667,type,
    v104787: state_type > $o ).

tff(pred_def_58668,type,
    v104793: state_type > $o ).

tff(pred_def_58669,type,
    v104791: state_type > $o ).

tff(pred_def_58670,type,
    v104803: state_type > $o ).

tff(pred_def_58671,type,
    v104806: ( state_type * $int ) > $o ).

tff(pred_def_58672,type,
    v104779: state_type > $o ).

tff(pred_def_58673,type,
    v104808: state_type > $o ).

tff(pred_def_58674,type,
    v104818: state_type > $o ).

tff(pred_def_58675,type,
    v104817: state_type > $o ).

tff(pred_def_58676,type,
    v104816: state_type > $o ).

tff(pred_def_58677,type,
    v104819: state_type > $o ).

tff(pred_def_58678,type,
    v104815: state_type > $o ).

tff(pred_def_58679,type,
    v104814: state_type > $o ).

tff(pred_def_58680,type,
    v104813: state_type > $o ).

tff(pred_def_58681,type,
    v104812: state_type > $o ).

tff(pred_def_58682,type,
    v104821: state_type > $o ).

tff(pred_def_58683,type,
    v104820: state_type > $o ).

tff(pred_def_58684,type,
    v104811: state_type > $o ).

tff(pred_def_58685,type,
    v104824: state_type > $o ).

tff(pred_def_58686,type,
    v104823: state_type > $o ).

tff(pred_def_58687,type,
    v104825: state_type > $o ).

tff(pred_def_58688,type,
    v104822: state_type > $o ).

tff(pred_def_58689,type,
    v104828: state_type > $o ).

tff(pred_def_58690,type,
    v104827: state_type > $o ).

tff(pred_def_58691,type,
    v104829: state_type > $o ).

tff(pred_def_58692,type,
    v104826: state_type > $o ).

tff(pred_def_58693,type,
    v104809: ( state_type * $int ) > $o ).

tff(pred_def_58694,type,
    v104831: state_type > $o ).

tff(pred_def_58695,type,
    v104781: ( state_type * $int ) > $o ).

tff(pred_def_58696,type,
    v104833: state_type > $o ).

tff(pred_def_58697,type,
    v104844: state_type > $o ).

tff(pred_def_58698,type,
    v104843: state_type > $o ).

tff(pred_def_58699,type,
    v104842: state_type > $o ).

tff(pred_def_58700,type,
    v104845: state_type > $o ).

tff(pred_def_58701,type,
    v104841: state_type > $o ).

tff(pred_def_58702,type,
    v104840: state_type > $o ).

tff(pred_def_58703,type,
    v104839: state_type > $o ).

tff(pred_def_58704,type,
    v104838: state_type > $o ).

tff(pred_def_58705,type,
    v104847: state_type > $o ).

tff(pred_def_58706,type,
    v104846: state_type > $o ).

tff(pred_def_58707,type,
    v104837: state_type > $o ).

tff(pred_def_58708,type,
    v104850: state_type > $o ).

tff(pred_def_58709,type,
    v104849: state_type > $o ).

tff(pred_def_58710,type,
    v104851: state_type > $o ).

tff(pred_def_58711,type,
    v104848: state_type > $o ).

tff(pred_def_58712,type,
    v104854: state_type > $o ).

tff(pred_def_58713,type,
    v104853: state_type > $o ).

tff(pred_def_58714,type,
    v104855: state_type > $o ).

tff(pred_def_58715,type,
    v104852: state_type > $o ).

tff(pred_def_58716,type,
    v104835: ( state_type * $int ) > $o ).

tff(pred_def_58717,type,
    v104834: ( state_type * $int ) > $o ).

tff(pred_def_58718,type,
    v104832: ( state_type * $int ) > $o ).

tff(pred_def_58719,type,
    v104830: ( state_type * $int ) > $o ).

tff(pred_def_58720,type,
    v104801: ( state_type * $int ) > $o ).

tff(pred_def_58721,type,
    v104799: ( state_type * $int ) > $o ).

tff(pred_def_58722,type,
    v104797: ( state_type * $int ) > $o ).

tff(pred_def_58723,type,
    v104795: ( state_type * $int ) > $o ).

tff(pred_def_58724,type,
    v104859: state_type > $o ).

tff(pred_def_58725,type,
    v104857: state_type > $o ).

tff(pred_def_58726,type,
    v104866: state_type > $o ).

tff(pred_def_58727,type,
    v104864: state_type > $o ).

tff(pred_def_58728,type,
    v104863: state_type > $o ).

tff(pred_def_58729,type,
    v104862: state_type > $o ).

tff(pred_def_58730,type,
    v104874: state_type > $o ).

tff(pred_def_58731,type,
    v104875: state_type > $o ).

tff(pred_def_58732,type,
    v104873: state_type > $o ).

tff(pred_def_58733,type,
    v104870: ( state_type * $int ) > $o ).

tff(pred_def_58734,type,
    v104872: ( state_type * $int ) > $o ).

tff(pred_def_58735,type,
    v104785: ( state_type * $int ) > $o ).

tff(pred_def_58736,type,
    v104783: ( state_type * $int ) > $o ).

tff(pred_def_58737,type,
    v104892: state_type > $o ).

tff(pred_def_58738,type,
    v104890: state_type > $o ).

tff(pred_def_58739,type,
    v104896: state_type > $o ).

tff(pred_def_58740,type,
    v104894: state_type > $o ).

tff(pred_def_58741,type,
    v104908: state_type > $o ).

tff(pred_def_58742,type,
    v104906: state_type > $o ).

tff(pred_def_58743,type,
    v104910: ( state_type * $int ) > $o ).

tff(pred_def_58744,type,
    v104882: state_type > $o ).

tff(pred_def_58745,type,
    v104913: state_type > $o ).

tff(pred_def_58746,type,
    v104912: state_type > $o ).

tff(pred_def_58747,type,
    v104925: state_type > $o ).

tff(pred_def_58748,type,
    v104924: state_type > $o ).

tff(pred_def_58749,type,
    v104923: state_type > $o ).

tff(pred_def_58750,type,
    v104926: state_type > $o ).

tff(pred_def_58751,type,
    v104922: state_type > $o ).

tff(pred_def_58752,type,
    v104921: state_type > $o ).

tff(pred_def_58753,type,
    v104927: state_type > $o ).

tff(pred_def_58754,type,
    v104920: state_type > $o ).

tff(pred_def_58755,type,
    v104919: state_type > $o ).

tff(pred_def_58756,type,
    v104918: state_type > $o ).

tff(pred_def_58757,type,
    v104917: state_type > $o ).

tff(pred_def_58758,type,
    v104929: state_type > $o ).

tff(pred_def_58759,type,
    v104928: state_type > $o ).

tff(pred_def_58760,type,
    v104916: state_type > $o ).

tff(pred_def_58761,type,
    v104932: state_type > $o ).

tff(pred_def_58762,type,
    v104931: state_type > $o ).

tff(pred_def_58763,type,
    v104933: state_type > $o ).

tff(pred_def_58764,type,
    v104930: state_type > $o ).

tff(pred_def_58765,type,
    v104936: state_type > $o ).

tff(pred_def_58766,type,
    v104935: state_type > $o ).

tff(pred_def_58767,type,
    v104937: state_type > $o ).

tff(pred_def_58768,type,
    v104934: state_type > $o ).

tff(pred_def_58769,type,
    v104940: state_type > $o ).

tff(pred_def_58770,type,
    v104939: state_type > $o ).

tff(pred_def_58771,type,
    v104941: state_type > $o ).

tff(pred_def_58772,type,
    v104938: state_type > $o ).

tff(pred_def_58773,type,
    v104914: ( state_type * $int ) > $o ).

tff(pred_def_58774,type,
    v104884: ( state_type * $int ) > $o ).

tff(pred_def_58775,type,
    v104954: state_type > $o ).

tff(pred_def_58776,type,
    v104953: state_type > $o ).

tff(pred_def_58777,type,
    v104952: state_type > $o ).

tff(pred_def_58778,type,
    v104955: state_type > $o ).

tff(pred_def_58779,type,
    v104951: state_type > $o ).

tff(pred_def_58780,type,
    v104950: state_type > $o ).

tff(pred_def_58781,type,
    v104956: state_type > $o ).

tff(pred_def_58782,type,
    v104949: state_type > $o ).

tff(pred_def_58783,type,
    v104948: state_type > $o ).

tff(pred_def_58784,type,
    v104947: state_type > $o ).

tff(pred_def_58785,type,
    v104946: state_type > $o ).

tff(pred_def_58786,type,
    v104958: state_type > $o ).

tff(pred_def_58787,type,
    v104957: state_type > $o ).

tff(pred_def_58788,type,
    v104945: state_type > $o ).

tff(pred_def_58789,type,
    v104961: state_type > $o ).

tff(pred_def_58790,type,
    v104960: state_type > $o ).

tff(pred_def_58791,type,
    v104962: state_type > $o ).

tff(pred_def_58792,type,
    v104959: state_type > $o ).

tff(pred_def_58793,type,
    v104965: state_type > $o ).

tff(pred_def_58794,type,
    v104964: state_type > $o ).

tff(pred_def_58795,type,
    v104966: state_type > $o ).

tff(pred_def_58796,type,
    v104963: state_type > $o ).

tff(pred_def_58797,type,
    v104969: state_type > $o ).

tff(pred_def_58798,type,
    v104968: state_type > $o ).

tff(pred_def_58799,type,
    v104970: state_type > $o ).

tff(pred_def_58800,type,
    v104967: state_type > $o ).

tff(pred_def_58801,type,
    v104943: ( state_type * $int ) > $o ).

tff(pred_def_58802,type,
    v104942: ( state_type * $int ) > $o ).

tff(pred_def_58803,type,
    v104904: ( state_type * $int ) > $o ).

tff(pred_def_58804,type,
    v104902: ( state_type * $int ) > $o ).

tff(pred_def_58805,type,
    v104900: ( state_type * $int ) > $o ).

tff(pred_def_58806,type,
    v104898: ( state_type * $int ) > $o ).

tff(pred_def_58807,type,
    v104974: state_type > $o ).

tff(pred_def_58808,type,
    v104972: state_type > $o ).

tff(pred_def_58809,type,
    v104981: state_type > $o ).

tff(pred_def_58810,type,
    v104979: state_type > $o ).

tff(pred_def_58811,type,
    v104978: state_type > $o ).

tff(pred_def_58812,type,
    v104977: state_type > $o ).

tff(pred_def_58813,type,
    v104989: state_type > $o ).

tff(pred_def_58814,type,
    v104990: state_type > $o ).

tff(pred_def_58815,type,
    v104988: state_type > $o ).

tff(pred_def_58816,type,
    v104985: ( state_type * $int ) > $o ).

tff(pred_def_58817,type,
    v104987: ( state_type * $int ) > $o ).

tff(pred_def_58818,type,
    v104888: ( state_type * $int ) > $o ).

tff(pred_def_58819,type,
    v104886: ( state_type * $int ) > $o ).

tff(pred_def_58820,type,
    v105005: state_type > $o ).

tff(pred_def_58821,type,
    v105003: state_type > $o ).

tff(pred_def_58822,type,
    v105009: state_type > $o ).

tff(pred_def_58823,type,
    v105007: state_type > $o ).

tff(pred_def_58824,type,
    v105022: state_type > $o ).

tff(pred_def_58825,type,
    v104995: state_type > $o ).

tff(pred_def_58826,type,
    v105021: state_type > $o ).

tff(pred_def_58827,type,
    v105020: state_type > $o ).

tff(pred_def_58828,type,
    v105019: state_type > $o ).

tff(pred_def_58829,type,
    v105023: ( state_type * $int ) > $o ).

tff(pred_def_58830,type,
    v104997: ( state_type * $int ) > $o ).

tff(pred_def_58831,type,
    v105036: state_type > $o ).

tff(pred_def_58832,type,
    v105035: state_type > $o ).

tff(pred_def_58833,type,
    v105034: state_type > $o ).

tff(pred_def_58834,type,
    v105037: state_type > $o ).

tff(pred_def_58835,type,
    v105033: state_type > $o ).

tff(pred_def_58836,type,
    v105032: state_type > $o ).

tff(pred_def_58837,type,
    v105038: state_type > $o ).

tff(pred_def_58838,type,
    v105031: state_type > $o ).

tff(pred_def_58839,type,
    v105030: state_type > $o ).

tff(pred_def_58840,type,
    v105029: state_type > $o ).

tff(pred_def_58841,type,
    v105028: state_type > $o ).

tff(pred_def_58842,type,
    v105040: state_type > $o ).

tff(pred_def_58843,type,
    v105039: state_type > $o ).

tff(pred_def_58844,type,
    v105027: state_type > $o ).

tff(pred_def_58845,type,
    v105043: state_type > $o ).

tff(pred_def_58846,type,
    v105042: state_type > $o ).

tff(pred_def_58847,type,
    v105044: state_type > $o ).

tff(pred_def_58848,type,
    v105041: state_type > $o ).

tff(pred_def_58849,type,
    v105047: state_type > $o ).

tff(pred_def_58850,type,
    v105046: state_type > $o ).

tff(pred_def_58851,type,
    v105048: state_type > $o ).

tff(pred_def_58852,type,
    v105045: state_type > $o ).

tff(pred_def_58853,type,
    v105051: state_type > $o ).

tff(pred_def_58854,type,
    v105050: state_type > $o ).

tff(pred_def_58855,type,
    v105052: state_type > $o ).

tff(pred_def_58856,type,
    v105049: state_type > $o ).

tff(pred_def_58857,type,
    v105025: ( state_type * $int ) > $o ).

tff(pred_def_58858,type,
    v105024: ( state_type * $int ) > $o ).

tff(pred_def_58859,type,
    v105017: ( state_type * $int ) > $o ).

tff(pred_def_58860,type,
    v105015: ( state_type * $int ) > $o ).

tff(pred_def_58861,type,
    v105013: ( state_type * $int ) > $o ).

tff(pred_def_58862,type,
    v105011: ( state_type * $int ) > $o ).

tff(pred_def_58863,type,
    v105056: state_type > $o ).

tff(pred_def_58864,type,
    v105054: state_type > $o ).

tff(pred_def_58865,type,
    v105063: state_type > $o ).

tff(pred_def_58866,type,
    v105061: state_type > $o ).

tff(pred_def_58867,type,
    v105060: state_type > $o ).

tff(pred_def_58868,type,
    v105059: state_type > $o ).

tff(pred_def_58869,type,
    v105071: state_type > $o ).

tff(pred_def_58870,type,
    v105072: state_type > $o ).

tff(pred_def_58871,type,
    v105070: state_type > $o ).

tff(pred_def_58872,type,
    v105067: ( state_type * $int ) > $o ).

tff(pred_def_58873,type,
    v105069: ( state_type * $int ) > $o ).

tff(pred_def_58874,type,
    v105001: ( state_type * $int ) > $o ).

tff(pred_def_58875,type,
    v104999: ( state_type * $int ) > $o ).

tff(pred_def_58876,type,
    v105087: state_type > $o ).

tff(pred_def_58877,type,
    v105085: state_type > $o ).

tff(pred_def_58878,type,
    v105091: state_type > $o ).

tff(pred_def_58879,type,
    v105089: state_type > $o ).

tff(pred_def_58880,type,
    v105105: state_type > $o ).

tff(pred_def_58881,type,
    v105077: state_type > $o ).

tff(pred_def_58882,type,
    v105104: state_type > $o ).

tff(pred_def_58883,type,
    v105106: state_type > $o ).

tff(pred_def_58884,type,
    v105103: state_type > $o ).

tff(pred_def_58885,type,
    v105102: state_type > $o ).

tff(pred_def_58886,type,
    v105101: state_type > $o ).

tff(pred_def_58887,type,
    v105107: ( state_type * $int ) > $o ).

tff(pred_def_58888,type,
    v105079: ( state_type * $int ) > $o ).

tff(pred_def_58889,type,
    v105120: state_type > $o ).

tff(pred_def_58890,type,
    v105119: state_type > $o ).

tff(pred_def_58891,type,
    v105118: state_type > $o ).

tff(pred_def_58892,type,
    v105121: state_type > $o ).

tff(pred_def_58893,type,
    v105117: state_type > $o ).

tff(pred_def_58894,type,
    v105116: state_type > $o ).

tff(pred_def_58895,type,
    v105122: state_type > $o ).

tff(pred_def_58896,type,
    v105115: state_type > $o ).

tff(pred_def_58897,type,
    v105114: state_type > $o ).

tff(pred_def_58898,type,
    v105113: state_type > $o ).

tff(pred_def_58899,type,
    v105112: state_type > $o ).

tff(pred_def_58900,type,
    v105124: state_type > $o ).

tff(pred_def_58901,type,
    v105123: state_type > $o ).

tff(pred_def_58902,type,
    v105111: state_type > $o ).

tff(pred_def_58903,type,
    v105127: state_type > $o ).

tff(pred_def_58904,type,
    v105126: state_type > $o ).

tff(pred_def_58905,type,
    v105128: state_type > $o ).

tff(pred_def_58906,type,
    v105125: state_type > $o ).

tff(pred_def_58907,type,
    v105131: state_type > $o ).

tff(pred_def_58908,type,
    v105130: state_type > $o ).

tff(pred_def_58909,type,
    v105132: state_type > $o ).

tff(pred_def_58910,type,
    v105129: state_type > $o ).

tff(pred_def_58911,type,
    v105135: state_type > $o ).

tff(pred_def_58912,type,
    v105134: state_type > $o ).

tff(pred_def_58913,type,
    v105136: state_type > $o ).

tff(pred_def_58914,type,
    v105133: state_type > $o ).

tff(pred_def_58915,type,
    v105109: ( state_type * $int ) > $o ).

tff(pred_def_58916,type,
    v105108: ( state_type * $int ) > $o ).

tff(pred_def_58917,type,
    v105099: ( state_type * $int ) > $o ).

tff(pred_def_58918,type,
    v105097: ( state_type * $int ) > $o ).

tff(pred_def_58919,type,
    v105095: ( state_type * $int ) > $o ).

tff(pred_def_58920,type,
    v105093: ( state_type * $int ) > $o ).

tff(pred_def_58921,type,
    v105140: state_type > $o ).

tff(pred_def_58922,type,
    v105138: state_type > $o ).

tff(pred_def_58923,type,
    v105147: state_type > $o ).

tff(pred_def_58924,type,
    v105145: state_type > $o ).

tff(pred_def_58925,type,
    v105144: state_type > $o ).

tff(pred_def_58926,type,
    v105143: state_type > $o ).

tff(pred_def_58927,type,
    v105155: state_type > $o ).

tff(pred_def_58928,type,
    v105156: state_type > $o ).

tff(pred_def_58929,type,
    v105154: state_type > $o ).

tff(pred_def_58930,type,
    v105151: ( state_type * $int ) > $o ).

tff(pred_def_58931,type,
    v105153: ( state_type * $int ) > $o ).

tff(pred_def_58932,type,
    v105083: ( state_type * $int ) > $o ).

tff(pred_def_58933,type,
    v105081: ( state_type * $int ) > $o ).

tff(pred_def_58934,type,
    v105171: state_type > $o ).

tff(pred_def_58935,type,
    v105169: state_type > $o ).

tff(pred_def_58936,type,
    v105175: state_type > $o ).

tff(pred_def_58937,type,
    v105173: state_type > $o ).

tff(pred_def_58938,type,
    v105190: state_type > $o ).

tff(pred_def_58939,type,
    v105161: state_type > $o ).

tff(pred_def_58940,type,
    v105189: state_type > $o ).

tff(pred_def_58941,type,
    v105191: state_type > $o ).

tff(pred_def_58942,type,
    v105188: state_type > $o ).

tff(pred_def_58943,type,
    v105192: state_type > $o ).

tff(pred_def_58944,type,
    v105187: state_type > $o ).

tff(pred_def_58945,type,
    v105186: state_type > $o ).

tff(pred_def_58946,type,
    v105185: state_type > $o ).

tff(pred_def_58947,type,
    v105193: ( state_type * $int ) > $o ).

tff(pred_def_58948,type,
    v105163: ( state_type * $int ) > $o ).

tff(pred_def_58949,type,
    v105206: state_type > $o ).

tff(pred_def_58950,type,
    v105205: state_type > $o ).

tff(pred_def_58951,type,
    v105204: state_type > $o ).

tff(pred_def_58952,type,
    v105207: state_type > $o ).

tff(pred_def_58953,type,
    v105203: state_type > $o ).

tff(pred_def_58954,type,
    v105202: state_type > $o ).

tff(pred_def_58955,type,
    v105208: state_type > $o ).

tff(pred_def_58956,type,
    v105201: state_type > $o ).

tff(pred_def_58957,type,
    v105200: state_type > $o ).

tff(pred_def_58958,type,
    v105199: state_type > $o ).

tff(pred_def_58959,type,
    v105198: state_type > $o ).

tff(pred_def_58960,type,
    v105210: state_type > $o ).

tff(pred_def_58961,type,
    v105209: state_type > $o ).

tff(pred_def_58962,type,
    v105197: state_type > $o ).

tff(pred_def_58963,type,
    v105213: state_type > $o ).

tff(pred_def_58964,type,
    v105212: state_type > $o ).

tff(pred_def_58965,type,
    v105214: state_type > $o ).

tff(pred_def_58966,type,
    v105211: state_type > $o ).

tff(pred_def_58967,type,
    v105217: state_type > $o ).

tff(pred_def_58968,type,
    v105216: state_type > $o ).

tff(pred_def_58969,type,
    v105218: state_type > $o ).

tff(pred_def_58970,type,
    v105215: state_type > $o ).

tff(pred_def_58971,type,
    v105221: state_type > $o ).

tff(pred_def_58972,type,
    v105220: state_type > $o ).

tff(pred_def_58973,type,
    v105222: state_type > $o ).

tff(pred_def_58974,type,
    v105219: state_type > $o ).

tff(pred_def_58975,type,
    v105195: ( state_type * $int ) > $o ).

tff(pred_def_58976,type,
    v105194: ( state_type * $int ) > $o ).

tff(pred_def_58977,type,
    v105183: ( state_type * $int ) > $o ).

tff(pred_def_58978,type,
    v105181: ( state_type * $int ) > $o ).

tff(pred_def_58979,type,
    v105179: ( state_type * $int ) > $o ).

tff(pred_def_58980,type,
    v105177: ( state_type * $int ) > $o ).

tff(pred_def_58981,type,
    v105226: state_type > $o ).

tff(pred_def_58982,type,
    v105224: state_type > $o ).

tff(pred_def_58983,type,
    v105233: state_type > $o ).

tff(pred_def_58984,type,
    v105231: state_type > $o ).

tff(pred_def_58985,type,
    v105230: state_type > $o ).

tff(pred_def_58986,type,
    v105229: state_type > $o ).

tff(pred_def_58987,type,
    v105241: state_type > $o ).

tff(pred_def_58988,type,
    v105242: state_type > $o ).

tff(pred_def_58989,type,
    v105240: state_type > $o ).

tff(pred_def_58990,type,
    v105237: ( state_type * $int ) > $o ).

tff(pred_def_58991,type,
    v105239: ( state_type * $int ) > $o ).

tff(pred_def_58992,type,
    v105167: ( state_type * $int ) > $o ).

tff(pred_def_58993,type,
    v105165: ( state_type * $int ) > $o ).

tff(pred_def_58994,type,
    v105249: state_type > $o ).

tff(pred_def_58995,type,
    v105250: state_type > $o ).

tff(pred_def_58996,type,
    v105248: state_type > $o ).

tff(pred_def_58997,type,
    v105251: state_type > $o ).

tff(pred_def_58998,type,
    v105247: state_type > $o ).

tff(pred_def_58999,type,
    v105252: state_type > $o ).

tff(pred_def_59000,type,
    v104880: state_type > $o ).

tff(pred_def_59001,type,
    v105268: state_type > $o ).

tff(pred_def_59002,type,
    v105266: state_type > $o ).

tff(pred_def_59003,type,
    v105264: state_type > $o ).

tff(pred_def_59004,type,
    v105262: state_type > $o ).

tff(pred_def_59005,type,
    v105276: state_type > $o ).

tff(pred_def_59006,type,
    v105274: state_type > $o ).

tff(pred_def_59007,type,
    v105272: state_type > $o ).

tff(pred_def_59008,type,
    v105270: state_type > $o ).

tff(pred_def_59009,type,
    v105291: state_type > $o ).

tff(pred_def_59010,type,
    v105290: state_type > $o ).

tff(pred_def_59011,type,
    v105293: state_type > $o ).

tff(pred_def_59012,type,
    v105292: state_type > $o ).

tff(pred_def_59013,type,
    v105289: state_type > $o ).

tff(pred_def_59014,type,
    v105295: state_type > $o ).

tff(pred_def_59015,type,
    v105294: state_type > $o ).

tff(pred_def_59016,type,
    v105288: state_type > $o ).

tff(pred_def_59017,type,
    v105297: state_type > $o ).

tff(pred_def_59018,type,
    v105296: state_type > $o ).

tff(pred_def_59019,type,
    v105286: state_type > $o ).

tff(pred_def_59020,type,
    v105299: ( state_type * $int ) > $o ).

tff(pred_def_59021,type,
    v105301: state_type > $o ).

tff(pred_def_59022,type,
    v105256: ( state_type * $int ) > $o ).

tff(pred_def_59023,type,
    v105304: state_type > $o ).

tff(pred_def_59024,type,
    v105315: state_type > $o ).

tff(pred_def_59025,type,
    v105314: state_type > $o ).

tff(pred_def_59026,type,
    v105313: state_type > $o ).

tff(pred_def_59027,type,
    v105316: state_type > $o ).

tff(pred_def_59028,type,
    v105312: state_type > $o ).

tff(pred_def_59029,type,
    v105311: state_type > $o ).

tff(pred_def_59030,type,
    v105310: state_type > $o ).

tff(pred_def_59031,type,
    v105309: state_type > $o ).

tff(pred_def_59032,type,
    v105318: state_type > $o ).

tff(pred_def_59033,type,
    v105317: state_type > $o ).

tff(pred_def_59034,type,
    v105308: state_type > $o ).

tff(pred_def_59035,type,
    v105321: state_type > $o ).

tff(pred_def_59036,type,
    v105320: state_type > $o ).

tff(pred_def_59037,type,
    v105322: state_type > $o ).

tff(pred_def_59038,type,
    v105319: state_type > $o ).

tff(pred_def_59039,type,
    v105325: state_type > $o ).

tff(pred_def_59040,type,
    v105324: state_type > $o ).

tff(pred_def_59041,type,
    v105326: state_type > $o ).

tff(pred_def_59042,type,
    v105323: state_type > $o ).

tff(pred_def_59043,type,
    v105306: ( state_type * $int ) > $o ).

tff(pred_def_59044,type,
    v105305: ( state_type * $int ) > $o ).

tff(pred_def_59045,type,
    v105303: ( state_type * $int ) > $o ).

tff(pred_def_59046,type,
    v105284: ( state_type * $int ) > $o ).

tff(pred_def_59047,type,
    v105282: ( state_type * $int ) > $o ).

tff(pred_def_59048,type,
    v105280: ( state_type * $int ) > $o ).

tff(pred_def_59049,type,
    v105278: ( state_type * $int ) > $o ).

tff(pred_def_59050,type,
    v105332: state_type > $o ).

tff(pred_def_59051,type,
    v105330: state_type > $o ).

tff(pred_def_59052,type,
    v105328: state_type > $o ).

tff(pred_def_59053,type,
    v105339: state_type > $o ).

tff(pred_def_59054,type,
    v105337: state_type > $o ).

tff(pred_def_59055,type,
    v105336: state_type > $o ).

tff(pred_def_59056,type,
    v105335: state_type > $o ).

tff(pred_def_59057,type,
    v105347: state_type > $o ).

tff(pred_def_59058,type,
    v105348: state_type > $o ).

tff(pred_def_59059,type,
    v105346: state_type > $o ).

tff(pred_def_59060,type,
    v105343: ( state_type * $int ) > $o ).

tff(pred_def_59061,type,
    v105345: ( state_type * $int ) > $o ).

tff(pred_def_59062,type,
    v105260: ( state_type * $int ) > $o ).

tff(pred_def_59063,type,
    v105258: ( state_type * $int ) > $o ).

tff(pred_def_59064,type,
    v105254: state_type > $o ).

tff(pred_def_59065,type,
    v105363: state_type > $o ).

tff(pred_def_59066,type,
    v105361: state_type > $o ).

tff(pred_def_59067,type,
    v105367: state_type > $o ).

tff(pred_def_59068,type,
    v105365: state_type > $o ).

tff(pred_def_59069,type,
    v105385: state_type > $o ).

tff(pred_def_59070,type,
    v105383: state_type > $o ).

tff(pred_def_59071,type,
    v105389: state_type > $o ).

tff(pred_def_59072,type,
    v105387: state_type > $o ).

tff(pred_def_59073,type,
    v105400: state_type > $o ).

tff(pred_def_59074,type,
    v105399: state_type > $o ).

tff(pred_def_59075,type,
    v105402: state_type > $o ).

tff(pred_def_59076,type,
    v105401: state_type > $o ).

tff(pred_def_59077,type,
    v105397: state_type > $o ).

tff(pred_def_59078,type,
    v105403: ( state_type * $int ) > $o ).

tff(pred_def_59079,type,
    v105404: state_type > $o ).

tff(pred_def_59080,type,
    v105395: ( state_type * $int ) > $o ).

tff(pred_def_59081,type,
    v105393: ( state_type * $int ) > $o ).

tff(pred_def_59082,type,
    v105391: ( state_type * $int ) > $o ).

tff(pred_def_59083,type,
    v105408: state_type > $o ).

tff(pred_def_59084,type,
    v105406: state_type > $o ).

tff(pred_def_59085,type,
    v105415: state_type > $o ).

tff(pred_def_59086,type,
    v105413: state_type > $o ).

tff(pred_def_59087,type,
    v105412: state_type > $o ).

tff(pred_def_59088,type,
    v105411: state_type > $o ).

tff(pred_def_59089,type,
    v105423: state_type > $o ).

tff(pred_def_59090,type,
    v105424: state_type > $o ).

tff(pred_def_59091,type,
    v105422: state_type > $o ).

tff(pred_def_59092,type,
    v105419: ( state_type * $int ) > $o ).

tff(pred_def_59093,type,
    v105421: ( state_type * $int ) > $o ).

tff(pred_def_59094,type,
    v105410: ( state_type * $int ) > $o ).

tff(pred_def_59095,type,
    v105381: ( state_type * $int ) > $o ).

tff(pred_def_59096,type,
    v105379: ( state_type * $int ) > $o ).

tff(pred_def_59097,type,
    v105377: state_type > $o ).

tff(pred_def_59098,type,
    v105432: state_type > $o ).

tff(pred_def_59099,type,
    v105431: state_type > $o ).

tff(pred_def_59100,type,
    v105434: state_type > $o ).

tff(pred_def_59101,type,
    v105433: state_type > $o ).

tff(pred_def_59102,type,
    v105440: state_type > $o ).

tff(pred_def_59103,type,
    v105438: state_type > $o ).

tff(pred_def_59104,type,
    v105437: state_type > $o ).

tff(pred_def_59105,type,
    v105436: ( state_type * $int ) > $o ).

tff(pred_def_59106,type,
    v105428: state_type > $o ).

tff(pred_def_59107,type,
    v105444: state_type > $o ).

tff(pred_def_59108,type,
    v105446: state_type > $o ).

tff(pred_def_59109,type,
    v105355: ( state_type * $int ) > $o ).

tff(pred_def_59110,type,
    v105448: state_type > $o ).

tff(pred_def_59111,type,
    v105453: state_type > $o ).

tff(pred_def_59112,type,
    v105452: state_type > $o ).

tff(pred_def_59113,type,
    v105455: state_type > $o ).

tff(pred_def_59114,type,
    v105454: state_type > $o ).

tff(pred_def_59115,type,
    v105451: state_type > $o ).

tff(pred_def_59116,type,
    v105449: ( state_type * $int ) > $o ).

tff(pred_def_59117,type,
    v105447: ( state_type * $int ) > $o ).

tff(pred_def_59118,type,
    v105445: ( state_type * $int ) > $o ).

tff(pred_def_59119,type,
    v105375: ( state_type * $int ) > $o ).

tff(pred_def_59120,type,
    v105373: ( state_type * $int ) > $o ).

tff(pred_def_59121,type,
    v105371: ( state_type * $int ) > $o ).

tff(pred_def_59122,type,
    v105369: ( state_type * $int ) > $o ).

tff(pred_def_59123,type,
    v105459: state_type > $o ).

tff(pred_def_59124,type,
    v105457: state_type > $o ).

tff(pred_def_59125,type,
    v105466: state_type > $o ).

tff(pred_def_59126,type,
    v105464: state_type > $o ).

tff(pred_def_59127,type,
    v105463: state_type > $o ).

tff(pred_def_59128,type,
    v105462: state_type > $o ).

tff(pred_def_59129,type,
    v105474: state_type > $o ).

tff(pred_def_59130,type,
    v105475: state_type > $o ).

tff(pred_def_59131,type,
    v105473: state_type > $o ).

tff(pred_def_59132,type,
    v105470: ( state_type * $int ) > $o ).

tff(pred_def_59133,type,
    v105472: ( state_type * $int ) > $o ).

tff(pred_def_59134,type,
    v105359: ( state_type * $int ) > $o ).

tff(pred_def_59135,type,
    v105357: ( state_type * $int ) > $o ).

tff(pred_def_59136,type,
    v105353: state_type > $o ).

tff(pred_def_59137,type,
    v105490: state_type > $o ).

tff(pred_def_59138,type,
    v105488: state_type > $o ).

tff(pred_def_59139,type,
    v105494: state_type > $o ).

tff(pred_def_59140,type,
    v105492: state_type > $o ).

tff(pred_def_59141,type,
    v105504: state_type > $o ).

tff(pred_def_59142,type,
    v105507: ( state_type * $int ) > $o ).

tff(pred_def_59143,type,
    v105480: state_type > $o ).

tff(pred_def_59144,type,
    v105509: state_type > $o ).

tff(pred_def_59145,type,
    v105519: state_type > $o ).

tff(pred_def_59146,type,
    v105518: state_type > $o ).

tff(pred_def_59147,type,
    v105517: state_type > $o ).

tff(pred_def_59148,type,
    v105520: state_type > $o ).

tff(pred_def_59149,type,
    v105516: state_type > $o ).

tff(pred_def_59150,type,
    v105515: state_type > $o ).

tff(pred_def_59151,type,
    v105514: state_type > $o ).

tff(pred_def_59152,type,
    v105513: state_type > $o ).

tff(pred_def_59153,type,
    v105522: state_type > $o ).

tff(pred_def_59154,type,
    v105521: state_type > $o ).

tff(pred_def_59155,type,
    v105512: state_type > $o ).

tff(pred_def_59156,type,
    v105525: state_type > $o ).

tff(pred_def_59157,type,
    v105524: state_type > $o ).

tff(pred_def_59158,type,
    v105526: state_type > $o ).

tff(pred_def_59159,type,
    v105523: state_type > $o ).

tff(pred_def_59160,type,
    v105529: state_type > $o ).

tff(pred_def_59161,type,
    v105528: state_type > $o ).

tff(pred_def_59162,type,
    v105530: state_type > $o ).

tff(pred_def_59163,type,
    v105527: state_type > $o ).

tff(pred_def_59164,type,
    v105510: ( state_type * $int ) > $o ).

tff(pred_def_59165,type,
    v105532: state_type > $o ).

tff(pred_def_59166,type,
    v105482: ( state_type * $int ) > $o ).

tff(pred_def_59167,type,
    v105534: state_type > $o ).

tff(pred_def_59168,type,
    v105545: state_type > $o ).

tff(pred_def_59169,type,
    v105544: state_type > $o ).

tff(pred_def_59170,type,
    v105543: state_type > $o ).

tff(pred_def_59171,type,
    v105546: state_type > $o ).

tff(pred_def_59172,type,
    v105542: state_type > $o ).

tff(pred_def_59173,type,
    v105541: state_type > $o ).

tff(pred_def_59174,type,
    v105540: state_type > $o ).

tff(pred_def_59175,type,
    v105539: state_type > $o ).

tff(pred_def_59176,type,
    v105548: state_type > $o ).

tff(pred_def_59177,type,
    v105547: state_type > $o ).

tff(pred_def_59178,type,
    v105538: state_type > $o ).

tff(pred_def_59179,type,
    v105551: state_type > $o ).

tff(pred_def_59180,type,
    v105550: state_type > $o ).

tff(pred_def_59181,type,
    v105552: state_type > $o ).

tff(pred_def_59182,type,
    v105549: state_type > $o ).

tff(pred_def_59183,type,
    v105555: state_type > $o ).

tff(pred_def_59184,type,
    v105554: state_type > $o ).

tff(pred_def_59185,type,
    v105556: state_type > $o ).

tff(pred_def_59186,type,
    v105553: state_type > $o ).

tff(pred_def_59187,type,
    v105536: ( state_type * $int ) > $o ).

tff(pred_def_59188,type,
    v105535: ( state_type * $int ) > $o ).

tff(pred_def_59189,type,
    v105533: ( state_type * $int ) > $o ).

tff(pred_def_59190,type,
    v105531: ( state_type * $int ) > $o ).

tff(pred_def_59191,type,
    v105502: ( state_type * $int ) > $o ).

tff(pred_def_59192,type,
    v105500: ( state_type * $int ) > $o ).

tff(pred_def_59193,type,
    v105498: ( state_type * $int ) > $o ).

tff(pred_def_59194,type,
    v105496: ( state_type * $int ) > $o ).

tff(pred_def_59195,type,
    v105560: state_type > $o ).

tff(pred_def_59196,type,
    v105558: state_type > $o ).

tff(pred_def_59197,type,
    v105567: state_type > $o ).

tff(pred_def_59198,type,
    v105565: state_type > $o ).

tff(pred_def_59199,type,
    v105564: state_type > $o ).

tff(pred_def_59200,type,
    v105563: state_type > $o ).

tff(pred_def_59201,type,
    v105575: state_type > $o ).

tff(pred_def_59202,type,
    v105576: state_type > $o ).

tff(pred_def_59203,type,
    v105574: state_type > $o ).

tff(pred_def_59204,type,
    v105571: ( state_type * $int ) > $o ).

tff(pred_def_59205,type,
    v105573: ( state_type * $int ) > $o ).

tff(pred_def_59206,type,
    v105486: ( state_type * $int ) > $o ).

tff(pred_def_59207,type,
    v105484: ( state_type * $int ) > $o ).

tff(pred_def_59208,type,
    v105593: state_type > $o ).

tff(pred_def_59209,type,
    v105591: state_type > $o ).

tff(pred_def_59210,type,
    v105597: state_type > $o ).

tff(pred_def_59211,type,
    v105595: state_type > $o ).

tff(pred_def_59212,type,
    v105609: state_type > $o ).

tff(pred_def_59213,type,
    v105607: state_type > $o ).

tff(pred_def_59214,type,
    v105611: ( state_type * $int ) > $o ).

tff(pred_def_59215,type,
    v105583: state_type > $o ).

tff(pred_def_59216,type,
    v105614: state_type > $o ).

tff(pred_def_59217,type,
    v105613: state_type > $o ).

tff(pred_def_59218,type,
    v105626: state_type > $o ).

tff(pred_def_59219,type,
    v105625: state_type > $o ).

tff(pred_def_59220,type,
    v105624: state_type > $o ).

tff(pred_def_59221,type,
    v105627: state_type > $o ).

tff(pred_def_59222,type,
    v105623: state_type > $o ).

tff(pred_def_59223,type,
    v105622: state_type > $o ).

tff(pred_def_59224,type,
    v105628: state_type > $o ).

tff(pred_def_59225,type,
    v105621: state_type > $o ).

tff(pred_def_59226,type,
    v105620: state_type > $o ).

tff(pred_def_59227,type,
    v105619: state_type > $o ).

tff(pred_def_59228,type,
    v105618: state_type > $o ).

tff(pred_def_59229,type,
    v105630: state_type > $o ).

tff(pred_def_59230,type,
    v105629: state_type > $o ).

tff(pred_def_59231,type,
    v105617: state_type > $o ).

tff(pred_def_59232,type,
    v105633: state_type > $o ).

tff(pred_def_59233,type,
    v105632: state_type > $o ).

tff(pred_def_59234,type,
    v105634: state_type > $o ).

tff(pred_def_59235,type,
    v105631: state_type > $o ).

tff(pred_def_59236,type,
    v105637: state_type > $o ).

tff(pred_def_59237,type,
    v105636: state_type > $o ).

tff(pred_def_59238,type,
    v105638: state_type > $o ).

tff(pred_def_59239,type,
    v105635: state_type > $o ).

tff(pred_def_59240,type,
    v105641: state_type > $o ).

tff(pred_def_59241,type,
    v105640: state_type > $o ).

tff(pred_def_59242,type,
    v105642: state_type > $o ).

tff(pred_def_59243,type,
    v105639: state_type > $o ).

tff(pred_def_59244,type,
    v105615: ( state_type * $int ) > $o ).

tff(pred_def_59245,type,
    v105585: ( state_type * $int ) > $o ).

tff(pred_def_59246,type,
    v105655: state_type > $o ).

tff(pred_def_59247,type,
    v105654: state_type > $o ).

tff(pred_def_59248,type,
    v105653: state_type > $o ).

tff(pred_def_59249,type,
    v105656: state_type > $o ).

tff(pred_def_59250,type,
    v105652: state_type > $o ).

tff(pred_def_59251,type,
    v105651: state_type > $o ).

tff(pred_def_59252,type,
    v105657: state_type > $o ).

tff(pred_def_59253,type,
    v105650: state_type > $o ).

tff(pred_def_59254,type,
    v105649: state_type > $o ).

tff(pred_def_59255,type,
    v105648: state_type > $o ).

tff(pred_def_59256,type,
    v105647: state_type > $o ).

tff(pred_def_59257,type,
    v105659: state_type > $o ).

tff(pred_def_59258,type,
    v105658: state_type > $o ).

tff(pred_def_59259,type,
    v105646: state_type > $o ).

tff(pred_def_59260,type,
    v105662: state_type > $o ).

tff(pred_def_59261,type,
    v105661: state_type > $o ).

tff(pred_def_59262,type,
    v105663: state_type > $o ).

tff(pred_def_59263,type,
    v105660: state_type > $o ).

tff(pred_def_59264,type,
    v105666: state_type > $o ).

tff(pred_def_59265,type,
    v105665: state_type > $o ).

tff(pred_def_59266,type,
    v105667: state_type > $o ).

tff(pred_def_59267,type,
    v105664: state_type > $o ).

tff(pred_def_59268,type,
    v105670: state_type > $o ).

tff(pred_def_59269,type,
    v105669: state_type > $o ).

tff(pred_def_59270,type,
    v105671: state_type > $o ).

tff(pred_def_59271,type,
    v105668: state_type > $o ).

tff(pred_def_59272,type,
    v105644: ( state_type * $int ) > $o ).

tff(pred_def_59273,type,
    v105643: ( state_type * $int ) > $o ).

tff(pred_def_59274,type,
    v105605: ( state_type * $int ) > $o ).

tff(pred_def_59275,type,
    v105603: ( state_type * $int ) > $o ).

tff(pred_def_59276,type,
    v105601: ( state_type * $int ) > $o ).

tff(pred_def_59277,type,
    v105599: ( state_type * $int ) > $o ).

tff(pred_def_59278,type,
    v105675: state_type > $o ).

tff(pred_def_59279,type,
    v105673: state_type > $o ).

tff(pred_def_59280,type,
    v105682: state_type > $o ).

tff(pred_def_59281,type,
    v105680: state_type > $o ).

tff(pred_def_59282,type,
    v105679: state_type > $o ).

tff(pred_def_59283,type,
    v105678: state_type > $o ).

tff(pred_def_59284,type,
    v105690: state_type > $o ).

tff(pred_def_59285,type,
    v105691: state_type > $o ).

tff(pred_def_59286,type,
    v105689: state_type > $o ).

tff(pred_def_59287,type,
    v105686: ( state_type * $int ) > $o ).

tff(pred_def_59288,type,
    v105688: ( state_type * $int ) > $o ).

tff(pred_def_59289,type,
    v105589: ( state_type * $int ) > $o ).

tff(pred_def_59290,type,
    v105587: ( state_type * $int ) > $o ).

tff(pred_def_59291,type,
    v105706: state_type > $o ).

tff(pred_def_59292,type,
    v105704: state_type > $o ).

tff(pred_def_59293,type,
    v105710: state_type > $o ).

tff(pred_def_59294,type,
    v105708: state_type > $o ).

tff(pred_def_59295,type,
    v105723: state_type > $o ).

tff(pred_def_59296,type,
    v105696: state_type > $o ).

tff(pred_def_59297,type,
    v105722: state_type > $o ).

tff(pred_def_59298,type,
    v105721: state_type > $o ).

tff(pred_def_59299,type,
    v105720: state_type > $o ).

tff(pred_def_59300,type,
    v105724: ( state_type * $int ) > $o ).

tff(pred_def_59301,type,
    v105698: ( state_type * $int ) > $o ).

tff(pred_def_59302,type,
    v105737: state_type > $o ).

tff(pred_def_59303,type,
    v105736: state_type > $o ).

tff(pred_def_59304,type,
    v105735: state_type > $o ).

tff(pred_def_59305,type,
    v105738: state_type > $o ).

tff(pred_def_59306,type,
    v105734: state_type > $o ).

tff(pred_def_59307,type,
    v105733: state_type > $o ).

tff(pred_def_59308,type,
    v105739: state_type > $o ).

tff(pred_def_59309,type,
    v105732: state_type > $o ).

tff(pred_def_59310,type,
    v105731: state_type > $o ).

tff(pred_def_59311,type,
    v105730: state_type > $o ).

tff(pred_def_59312,type,
    v105729: state_type > $o ).

tff(pred_def_59313,type,
    v105741: state_type > $o ).

tff(pred_def_59314,type,
    v105740: state_type > $o ).

tff(pred_def_59315,type,
    v105728: state_type > $o ).

tff(pred_def_59316,type,
    v105744: state_type > $o ).

tff(pred_def_59317,type,
    v105743: state_type > $o ).

tff(pred_def_59318,type,
    v105745: state_type > $o ).

tff(pred_def_59319,type,
    v105742: state_type > $o ).

tff(pred_def_59320,type,
    v105748: state_type > $o ).

tff(pred_def_59321,type,
    v105747: state_type > $o ).

tff(pred_def_59322,type,
    v105749: state_type > $o ).

tff(pred_def_59323,type,
    v105746: state_type > $o ).

tff(pred_def_59324,type,
    v105752: state_type > $o ).

tff(pred_def_59325,type,
    v105751: state_type > $o ).

tff(pred_def_59326,type,
    v105753: state_type > $o ).

tff(pred_def_59327,type,
    v105750: state_type > $o ).

tff(pred_def_59328,type,
    v105726: ( state_type * $int ) > $o ).

tff(pred_def_59329,type,
    v105725: ( state_type * $int ) > $o ).

tff(pred_def_59330,type,
    v105718: ( state_type * $int ) > $o ).

tff(pred_def_59331,type,
    v105716: ( state_type * $int ) > $o ).

tff(pred_def_59332,type,
    v105714: ( state_type * $int ) > $o ).

tff(pred_def_59333,type,
    v105712: ( state_type * $int ) > $o ).

tff(pred_def_59334,type,
    v105757: state_type > $o ).

tff(pred_def_59335,type,
    v105755: state_type > $o ).

tff(pred_def_59336,type,
    v105764: state_type > $o ).

tff(pred_def_59337,type,
    v105762: state_type > $o ).

tff(pred_def_59338,type,
    v105761: state_type > $o ).

tff(pred_def_59339,type,
    v105760: state_type > $o ).

tff(pred_def_59340,type,
    v105772: state_type > $o ).

tff(pred_def_59341,type,
    v105773: state_type > $o ).

tff(pred_def_59342,type,
    v105771: state_type > $o ).

tff(pred_def_59343,type,
    v105768: ( state_type * $int ) > $o ).

tff(pred_def_59344,type,
    v105770: ( state_type * $int ) > $o ).

tff(pred_def_59345,type,
    v105702: ( state_type * $int ) > $o ).

tff(pred_def_59346,type,
    v105700: ( state_type * $int ) > $o ).

tff(pred_def_59347,type,
    v105788: state_type > $o ).

tff(pred_def_59348,type,
    v105786: state_type > $o ).

tff(pred_def_59349,type,
    v105792: state_type > $o ).

tff(pred_def_59350,type,
    v105790: state_type > $o ).

tff(pred_def_59351,type,
    v105806: state_type > $o ).

tff(pred_def_59352,type,
    v105778: state_type > $o ).

tff(pred_def_59353,type,
    v105805: state_type > $o ).

tff(pred_def_59354,type,
    v105807: state_type > $o ).

tff(pred_def_59355,type,
    v105804: state_type > $o ).

tff(pred_def_59356,type,
    v105803: state_type > $o ).

tff(pred_def_59357,type,
    v105802: state_type > $o ).

tff(pred_def_59358,type,
    v105808: ( state_type * $int ) > $o ).

tff(pred_def_59359,type,
    v105780: ( state_type * $int ) > $o ).

tff(pred_def_59360,type,
    v105821: state_type > $o ).

tff(pred_def_59361,type,
    v105820: state_type > $o ).

tff(pred_def_59362,type,
    v105819: state_type > $o ).

tff(pred_def_59363,type,
    v105822: state_type > $o ).

tff(pred_def_59364,type,
    v105818: state_type > $o ).

tff(pred_def_59365,type,
    v105817: state_type > $o ).

tff(pred_def_59366,type,
    v105823: state_type > $o ).

tff(pred_def_59367,type,
    v105816: state_type > $o ).

tff(pred_def_59368,type,
    v105815: state_type > $o ).

tff(pred_def_59369,type,
    v105814: state_type > $o ).

tff(pred_def_59370,type,
    v105813: state_type > $o ).

tff(pred_def_59371,type,
    v105825: state_type > $o ).

tff(pred_def_59372,type,
    v105824: state_type > $o ).

tff(pred_def_59373,type,
    v105812: state_type > $o ).

tff(pred_def_59374,type,
    v105828: state_type > $o ).

tff(pred_def_59375,type,
    v105827: state_type > $o ).

tff(pred_def_59376,type,
    v105829: state_type > $o ).

tff(pred_def_59377,type,
    v105826: state_type > $o ).

tff(pred_def_59378,type,
    v105832: state_type > $o ).

tff(pred_def_59379,type,
    v105831: state_type > $o ).

tff(pred_def_59380,type,
    v105833: state_type > $o ).

tff(pred_def_59381,type,
    v105830: state_type > $o ).

tff(pred_def_59382,type,
    v105836: state_type > $o ).

tff(pred_def_59383,type,
    v105835: state_type > $o ).

tff(pred_def_59384,type,
    v105837: state_type > $o ).

tff(pred_def_59385,type,
    v105834: state_type > $o ).

tff(pred_def_59386,type,
    v105810: ( state_type * $int ) > $o ).

tff(pred_def_59387,type,
    v105809: ( state_type * $int ) > $o ).

tff(pred_def_59388,type,
    v105800: ( state_type * $int ) > $o ).

tff(pred_def_59389,type,
    v105798: ( state_type * $int ) > $o ).

tff(pred_def_59390,type,
    v105796: ( state_type * $int ) > $o ).

tff(pred_def_59391,type,
    v105794: ( state_type * $int ) > $o ).

tff(pred_def_59392,type,
    v105841: state_type > $o ).

tff(pred_def_59393,type,
    v105839: state_type > $o ).

tff(pred_def_59394,type,
    v105848: state_type > $o ).

tff(pred_def_59395,type,
    v105846: state_type > $o ).

tff(pred_def_59396,type,
    v105845: state_type > $o ).

tff(pred_def_59397,type,
    v105844: state_type > $o ).

tff(pred_def_59398,type,
    v105856: state_type > $o ).

tff(pred_def_59399,type,
    v105857: state_type > $o ).

tff(pred_def_59400,type,
    v105855: state_type > $o ).

tff(pred_def_59401,type,
    v105852: ( state_type * $int ) > $o ).

tff(pred_def_59402,type,
    v105854: ( state_type * $int ) > $o ).

tff(pred_def_59403,type,
    v105784: ( state_type * $int ) > $o ).

tff(pred_def_59404,type,
    v105782: ( state_type * $int ) > $o ).

tff(pred_def_59405,type,
    v105872: state_type > $o ).

tff(pred_def_59406,type,
    v105870: state_type > $o ).

tff(pred_def_59407,type,
    v105876: state_type > $o ).

tff(pred_def_59408,type,
    v105874: state_type > $o ).

tff(pred_def_59409,type,
    v105891: state_type > $o ).

tff(pred_def_59410,type,
    v105862: state_type > $o ).

tff(pred_def_59411,type,
    v105890: state_type > $o ).

tff(pred_def_59412,type,
    v105892: state_type > $o ).

tff(pred_def_59413,type,
    v105889: state_type > $o ).

tff(pred_def_59414,type,
    v105893: state_type > $o ).

tff(pred_def_59415,type,
    v105888: state_type > $o ).

tff(pred_def_59416,type,
    v105887: state_type > $o ).

tff(pred_def_59417,type,
    v105886: state_type > $o ).

tff(pred_def_59418,type,
    v105894: ( state_type * $int ) > $o ).

tff(pred_def_59419,type,
    v105864: ( state_type * $int ) > $o ).

tff(pred_def_59420,type,
    v105907: state_type > $o ).

tff(pred_def_59421,type,
    v105906: state_type > $o ).

tff(pred_def_59422,type,
    v105905: state_type > $o ).

tff(pred_def_59423,type,
    v105908: state_type > $o ).

tff(pred_def_59424,type,
    v105904: state_type > $o ).

tff(pred_def_59425,type,
    v105903: state_type > $o ).

tff(pred_def_59426,type,
    v105909: state_type > $o ).

tff(pred_def_59427,type,
    v105902: state_type > $o ).

tff(pred_def_59428,type,
    v105901: state_type > $o ).

tff(pred_def_59429,type,
    v105900: state_type > $o ).

tff(pred_def_59430,type,
    v105899: state_type > $o ).

tff(pred_def_59431,type,
    v105911: state_type > $o ).

tff(pred_def_59432,type,
    v105910: state_type > $o ).

tff(pred_def_59433,type,
    v105898: state_type > $o ).

tff(pred_def_59434,type,
    v105914: state_type > $o ).

tff(pred_def_59435,type,
    v105913: state_type > $o ).

tff(pred_def_59436,type,
    v105915: state_type > $o ).

tff(pred_def_59437,type,
    v105912: state_type > $o ).

tff(pred_def_59438,type,
    v105918: state_type > $o ).

tff(pred_def_59439,type,
    v105917: state_type > $o ).

tff(pred_def_59440,type,
    v105919: state_type > $o ).

tff(pred_def_59441,type,
    v105916: state_type > $o ).

tff(pred_def_59442,type,
    v105922: state_type > $o ).

tff(pred_def_59443,type,
    v105921: state_type > $o ).

tff(pred_def_59444,type,
    v105923: state_type > $o ).

tff(pred_def_59445,type,
    v105920: state_type > $o ).

tff(pred_def_59446,type,
    v105896: ( state_type * $int ) > $o ).

tff(pred_def_59447,type,
    v105895: ( state_type * $int ) > $o ).

tff(pred_def_59448,type,
    v105884: ( state_type * $int ) > $o ).

tff(pred_def_59449,type,
    v105882: ( state_type * $int ) > $o ).

tff(pred_def_59450,type,
    v105880: ( state_type * $int ) > $o ).

tff(pred_def_59451,type,
    v105878: ( state_type * $int ) > $o ).

tff(pred_def_59452,type,
    v105927: state_type > $o ).

tff(pred_def_59453,type,
    v105925: state_type > $o ).

tff(pred_def_59454,type,
    v105934: state_type > $o ).

tff(pred_def_59455,type,
    v105932: state_type > $o ).

tff(pred_def_59456,type,
    v105931: state_type > $o ).

tff(pred_def_59457,type,
    v105930: state_type > $o ).

tff(pred_def_59458,type,
    v105942: state_type > $o ).

tff(pred_def_59459,type,
    v105943: state_type > $o ).

tff(pred_def_59460,type,
    v105941: state_type > $o ).

tff(pred_def_59461,type,
    v105938: ( state_type * $int ) > $o ).

tff(pred_def_59462,type,
    v105940: ( state_type * $int ) > $o ).

tff(pred_def_59463,type,
    v105868: ( state_type * $int ) > $o ).

tff(pred_def_59464,type,
    v105866: ( state_type * $int ) > $o ).

tff(pred_def_59465,type,
    v105950: state_type > $o ).

tff(pred_def_59466,type,
    v105951: state_type > $o ).

tff(pred_def_59467,type,
    v105949: state_type > $o ).

tff(pred_def_59468,type,
    v105952: state_type > $o ).

tff(pred_def_59469,type,
    v105948: state_type > $o ).

tff(pred_def_59470,type,
    v105953: state_type > $o ).

tff(pred_def_59471,type,
    v105581: state_type > $o ).

tff(pred_def_59472,type,
    v105969: state_type > $o ).

tff(pred_def_59473,type,
    v105967: state_type > $o ).

tff(pred_def_59474,type,
    v105965: state_type > $o ).

tff(pred_def_59475,type,
    v105963: state_type > $o ).

tff(pred_def_59476,type,
    v105977: state_type > $o ).

tff(pred_def_59477,type,
    v105975: state_type > $o ).

tff(pred_def_59478,type,
    v105973: state_type > $o ).

tff(pred_def_59479,type,
    v105971: state_type > $o ).

tff(pred_def_59480,type,
    v105992: state_type > $o ).

tff(pred_def_59481,type,
    v105991: state_type > $o ).

tff(pred_def_59482,type,
    v105994: state_type > $o ).

tff(pred_def_59483,type,
    v105993: state_type > $o ).

tff(pred_def_59484,type,
    v105990: state_type > $o ).

tff(pred_def_59485,type,
    v105996: state_type > $o ).

tff(pred_def_59486,type,
    v105995: state_type > $o ).

tff(pred_def_59487,type,
    v105989: state_type > $o ).

tff(pred_def_59488,type,
    v105998: state_type > $o ).

tff(pred_def_59489,type,
    v105997: state_type > $o ).

tff(pred_def_59490,type,
    v105987: state_type > $o ).

tff(pred_def_59491,type,
    v106000: ( state_type * $int ) > $o ).

tff(pred_def_59492,type,
    v106002: state_type > $o ).

tff(pred_def_59493,type,
    v105957: ( state_type * $int ) > $o ).

tff(pred_def_59494,type,
    v106005: state_type > $o ).

tff(pred_def_59495,type,
    v106016: state_type > $o ).

tff(pred_def_59496,type,
    v106015: state_type > $o ).

tff(pred_def_59497,type,
    v106014: state_type > $o ).

tff(pred_def_59498,type,
    v106017: state_type > $o ).

tff(pred_def_59499,type,
    v106013: state_type > $o ).

tff(pred_def_59500,type,
    v106012: state_type > $o ).

tff(pred_def_59501,type,
    v106011: state_type > $o ).

tff(pred_def_59502,type,
    v106010: state_type > $o ).

tff(pred_def_59503,type,
    v106019: state_type > $o ).

tff(pred_def_59504,type,
    v106018: state_type > $o ).

tff(pred_def_59505,type,
    v106009: state_type > $o ).

tff(pred_def_59506,type,
    v106022: state_type > $o ).

tff(pred_def_59507,type,
    v106021: state_type > $o ).

tff(pred_def_59508,type,
    v106023: state_type > $o ).

tff(pred_def_59509,type,
    v106020: state_type > $o ).

tff(pred_def_59510,type,
    v106026: state_type > $o ).

tff(pred_def_59511,type,
    v106025: state_type > $o ).

tff(pred_def_59512,type,
    v106027: state_type > $o ).

tff(pred_def_59513,type,
    v106024: state_type > $o ).

tff(pred_def_59514,type,
    v106007: ( state_type * $int ) > $o ).

tff(pred_def_59515,type,
    v106006: ( state_type * $int ) > $o ).

tff(pred_def_59516,type,
    v106004: ( state_type * $int ) > $o ).

tff(pred_def_59517,type,
    v105985: ( state_type * $int ) > $o ).

tff(pred_def_59518,type,
    v105983: ( state_type * $int ) > $o ).

tff(pred_def_59519,type,
    v105981: ( state_type * $int ) > $o ).

tff(pred_def_59520,type,
    v105979: ( state_type * $int ) > $o ).

tff(pred_def_59521,type,
    v106033: state_type > $o ).

tff(pred_def_59522,type,
    v106031: state_type > $o ).

tff(pred_def_59523,type,
    v106029: state_type > $o ).

tff(pred_def_59524,type,
    v106040: state_type > $o ).

tff(pred_def_59525,type,
    v106038: state_type > $o ).

tff(pred_def_59526,type,
    v106037: state_type > $o ).

tff(pred_def_59527,type,
    v106036: state_type > $o ).

tff(pred_def_59528,type,
    v106048: state_type > $o ).

tff(pred_def_59529,type,
    v106049: state_type > $o ).

tff(pred_def_59530,type,
    v106047: state_type > $o ).

tff(pred_def_59531,type,
    v106044: ( state_type * $int ) > $o ).

tff(pred_def_59532,type,
    v106046: ( state_type * $int ) > $o ).

tff(pred_def_59533,type,
    v105961: ( state_type * $int ) > $o ).

tff(pred_def_59534,type,
    v105959: ( state_type * $int ) > $o ).

tff(pred_def_59535,type,
    v105955: state_type > $o ).

tff(pred_def_59536,type,
    v106064: state_type > $o ).

tff(pred_def_59537,type,
    v106062: state_type > $o ).

tff(pred_def_59538,type,
    v106068: state_type > $o ).

tff(pred_def_59539,type,
    v106066: state_type > $o ).

tff(pred_def_59540,type,
    v106086: state_type > $o ).

tff(pred_def_59541,type,
    v106084: state_type > $o ).

tff(pred_def_59542,type,
    v106090: state_type > $o ).

tff(pred_def_59543,type,
    v106088: state_type > $o ).

tff(pred_def_59544,type,
    v106101: state_type > $o ).

tff(pred_def_59545,type,
    v106100: state_type > $o ).

tff(pred_def_59546,type,
    v106103: state_type > $o ).

tff(pred_def_59547,type,
    v106102: state_type > $o ).

tff(pred_def_59548,type,
    v106098: state_type > $o ).

tff(pred_def_59549,type,
    v106104: ( state_type * $int ) > $o ).

tff(pred_def_59550,type,
    v106105: state_type > $o ).

tff(pred_def_59551,type,
    v106096: ( state_type * $int ) > $o ).

tff(pred_def_59552,type,
    v106094: ( state_type * $int ) > $o ).

tff(pred_def_59553,type,
    v106092: ( state_type * $int ) > $o ).

tff(pred_def_59554,type,
    v106109: state_type > $o ).

tff(pred_def_59555,type,
    v106107: state_type > $o ).

tff(pred_def_59556,type,
    v106116: state_type > $o ).

tff(pred_def_59557,type,
    v106114: state_type > $o ).

tff(pred_def_59558,type,
    v106113: state_type > $o ).

tff(pred_def_59559,type,
    v106112: state_type > $o ).

tff(pred_def_59560,type,
    v106124: state_type > $o ).

tff(pred_def_59561,type,
    v106125: state_type > $o ).

tff(pred_def_59562,type,
    v106123: state_type > $o ).

tff(pred_def_59563,type,
    v106120: ( state_type * $int ) > $o ).

tff(pred_def_59564,type,
    v106122: ( state_type * $int ) > $o ).

tff(pred_def_59565,type,
    v106111: ( state_type * $int ) > $o ).

tff(pred_def_59566,type,
    v106082: ( state_type * $int ) > $o ).

tff(pred_def_59567,type,
    v106080: ( state_type * $int ) > $o ).

tff(pred_def_59568,type,
    v106078: state_type > $o ).

tff(pred_def_59569,type,
    v106133: state_type > $o ).

tff(pred_def_59570,type,
    v106132: state_type > $o ).

tff(pred_def_59571,type,
    v106135: state_type > $o ).

tff(pred_def_59572,type,
    v106134: state_type > $o ).

tff(pred_def_59573,type,
    v106141: state_type > $o ).

tff(pred_def_59574,type,
    v106139: state_type > $o ).

tff(pred_def_59575,type,
    v106138: state_type > $o ).

tff(pred_def_59576,type,
    v106137: ( state_type * $int ) > $o ).

tff(pred_def_59577,type,
    v106129: state_type > $o ).

tff(pred_def_59578,type,
    v106145: state_type > $o ).

tff(pred_def_59579,type,
    v106147: state_type > $o ).

tff(pred_def_59580,type,
    v106056: ( state_type * $int ) > $o ).

tff(pred_def_59581,type,
    v106149: state_type > $o ).

tff(pred_def_59582,type,
    v106154: state_type > $o ).

tff(pred_def_59583,type,
    v106153: state_type > $o ).

tff(pred_def_59584,type,
    v106156: state_type > $o ).

tff(pred_def_59585,type,
    v106155: state_type > $o ).

tff(pred_def_59586,type,
    v106152: state_type > $o ).

tff(pred_def_59587,type,
    v106150: ( state_type * $int ) > $o ).

tff(pred_def_59588,type,
    v106148: ( state_type * $int ) > $o ).

tff(pred_def_59589,type,
    v106146: ( state_type * $int ) > $o ).

tff(pred_def_59590,type,
    v106076: ( state_type * $int ) > $o ).

tff(pred_def_59591,type,
    v106074: ( state_type * $int ) > $o ).

tff(pred_def_59592,type,
    v106072: ( state_type * $int ) > $o ).

tff(pred_def_59593,type,
    v106070: ( state_type * $int ) > $o ).

tff(pred_def_59594,type,
    v106160: state_type > $o ).

tff(pred_def_59595,type,
    v106158: state_type > $o ).

tff(pred_def_59596,type,
    v106167: state_type > $o ).

tff(pred_def_59597,type,
    v106165: state_type > $o ).

tff(pred_def_59598,type,
    v106164: state_type > $o ).

tff(pred_def_59599,type,
    v106163: state_type > $o ).

tff(pred_def_59600,type,
    v106175: state_type > $o ).

tff(pred_def_59601,type,
    v106176: state_type > $o ).

tff(pred_def_59602,type,
    v106174: state_type > $o ).

tff(pred_def_59603,type,
    v106171: ( state_type * $int ) > $o ).

tff(pred_def_59604,type,
    v106173: ( state_type * $int ) > $o ).

tff(pred_def_59605,type,
    v106060: ( state_type * $int ) > $o ).

tff(pred_def_59606,type,
    v106058: ( state_type * $int ) > $o ).

tff(pred_def_59607,type,
    v106054: state_type > $o ).

tff(pred_def_59608,type,
    v106191: state_type > $o ).

tff(pred_def_59609,type,
    v106189: state_type > $o ).

tff(pred_def_59610,type,
    v106195: state_type > $o ).

tff(pred_def_59611,type,
    v106193: state_type > $o ).

tff(pred_def_59612,type,
    v106205: state_type > $o ).

tff(pred_def_59613,type,
    v106208: ( state_type * $int ) > $o ).

tff(pred_def_59614,type,
    v106181: state_type > $o ).

tff(pred_def_59615,type,
    v106210: state_type > $o ).

tff(pred_def_59616,type,
    v106220: state_type > $o ).

tff(pred_def_59617,type,
    v106219: state_type > $o ).

tff(pred_def_59618,type,
    v106218: state_type > $o ).

tff(pred_def_59619,type,
    v106221: state_type > $o ).

tff(pred_def_59620,type,
    v106217: state_type > $o ).

tff(pred_def_59621,type,
    v106216: state_type > $o ).

tff(pred_def_59622,type,
    v106215: state_type > $o ).

tff(pred_def_59623,type,
    v106214: state_type > $o ).

tff(pred_def_59624,type,
    v106223: state_type > $o ).

tff(pred_def_59625,type,
    v106222: state_type > $o ).

tff(pred_def_59626,type,
    v106213: state_type > $o ).

tff(pred_def_59627,type,
    v106226: state_type > $o ).

tff(pred_def_59628,type,
    v106225: state_type > $o ).

tff(pred_def_59629,type,
    v106227: state_type > $o ).

tff(pred_def_59630,type,
    v106224: state_type > $o ).

tff(pred_def_59631,type,
    v106230: state_type > $o ).

tff(pred_def_59632,type,
    v106229: state_type > $o ).

tff(pred_def_59633,type,
    v106231: state_type > $o ).

tff(pred_def_59634,type,
    v106228: state_type > $o ).

tff(pred_def_59635,type,
    v106211: ( state_type * $int ) > $o ).

tff(pred_def_59636,type,
    v106233: state_type > $o ).

tff(pred_def_59637,type,
    v106183: ( state_type * $int ) > $o ).

tff(pred_def_59638,type,
    v106235: state_type > $o ).

tff(pred_def_59639,type,
    v106246: state_type > $o ).

tff(pred_def_59640,type,
    v106245: state_type > $o ).

tff(pred_def_59641,type,
    v106244: state_type > $o ).

tff(pred_def_59642,type,
    v106247: state_type > $o ).

tff(pred_def_59643,type,
    v106243: state_type > $o ).

tff(pred_def_59644,type,
    v106242: state_type > $o ).

tff(pred_def_59645,type,
    v106241: state_type > $o ).

tff(pred_def_59646,type,
    v106240: state_type > $o ).

tff(pred_def_59647,type,
    v106249: state_type > $o ).

tff(pred_def_59648,type,
    v106248: state_type > $o ).

tff(pred_def_59649,type,
    v106239: state_type > $o ).

tff(pred_def_59650,type,
    v106252: state_type > $o ).

tff(pred_def_59651,type,
    v106251: state_type > $o ).

tff(pred_def_59652,type,
    v106253: state_type > $o ).

tff(pred_def_59653,type,
    v106250: state_type > $o ).

tff(pred_def_59654,type,
    v106256: state_type > $o ).

tff(pred_def_59655,type,
    v106255: state_type > $o ).

tff(pred_def_59656,type,
    v106257: state_type > $o ).

tff(pred_def_59657,type,
    v106254: state_type > $o ).

tff(pred_def_59658,type,
    v106237: ( state_type * $int ) > $o ).

tff(pred_def_59659,type,
    v106236: ( state_type * $int ) > $o ).

tff(pred_def_59660,type,
    v106234: ( state_type * $int ) > $o ).

tff(pred_def_59661,type,
    v106232: ( state_type * $int ) > $o ).

tff(pred_def_59662,type,
    v106203: ( state_type * $int ) > $o ).

tff(pred_def_59663,type,
    v106201: ( state_type * $int ) > $o ).

tff(pred_def_59664,type,
    v106199: ( state_type * $int ) > $o ).

tff(pred_def_59665,type,
    v106197: ( state_type * $int ) > $o ).

tff(pred_def_59666,type,
    v106261: state_type > $o ).

tff(pred_def_59667,type,
    v106259: state_type > $o ).

tff(pred_def_59668,type,
    v106268: state_type > $o ).

tff(pred_def_59669,type,
    v106266: state_type > $o ).

tff(pred_def_59670,type,
    v106265: state_type > $o ).

tff(pred_def_59671,type,
    v106264: state_type > $o ).

tff(pred_def_59672,type,
    v106276: state_type > $o ).

tff(pred_def_59673,type,
    v106277: state_type > $o ).

tff(pred_def_59674,type,
    v106275: state_type > $o ).

tff(pred_def_59675,type,
    v106272: ( state_type * $int ) > $o ).

tff(pred_def_59676,type,
    v106274: ( state_type * $int ) > $o ).

tff(pred_def_59677,type,
    v106187: ( state_type * $int ) > $o ).

tff(pred_def_59678,type,
    v106185: ( state_type * $int ) > $o ).

tff(pred_def_59679,type,
    v106294: state_type > $o ).

tff(pred_def_59680,type,
    v106292: state_type > $o ).

tff(pred_def_59681,type,
    v106298: state_type > $o ).

tff(pred_def_59682,type,
    v106296: state_type > $o ).

tff(pred_def_59683,type,
    v106310: state_type > $o ).

tff(pred_def_59684,type,
    v106308: state_type > $o ).

tff(pred_def_59685,type,
    v106312: ( state_type * $int ) > $o ).

tff(pred_def_59686,type,
    v106284: state_type > $o ).

tff(pred_def_59687,type,
    v106315: state_type > $o ).

tff(pred_def_59688,type,
    v106314: state_type > $o ).

tff(pred_def_59689,type,
    v106327: state_type > $o ).

tff(pred_def_59690,type,
    v106326: state_type > $o ).

tff(pred_def_59691,type,
    v106325: state_type > $o ).

tff(pred_def_59692,type,
    v106328: state_type > $o ).

tff(pred_def_59693,type,
    v106324: state_type > $o ).

tff(pred_def_59694,type,
    v106323: state_type > $o ).

tff(pred_def_59695,type,
    v106329: state_type > $o ).

tff(pred_def_59696,type,
    v106322: state_type > $o ).

tff(pred_def_59697,type,
    v106321: state_type > $o ).

tff(pred_def_59698,type,
    v106320: state_type > $o ).

tff(pred_def_59699,type,
    v106319: state_type > $o ).

tff(pred_def_59700,type,
    v106331: state_type > $o ).

tff(pred_def_59701,type,
    v106330: state_type > $o ).

tff(pred_def_59702,type,
    v106318: state_type > $o ).

tff(pred_def_59703,type,
    v106334: state_type > $o ).

tff(pred_def_59704,type,
    v106333: state_type > $o ).

tff(pred_def_59705,type,
    v106335: state_type > $o ).

tff(pred_def_59706,type,
    v106332: state_type > $o ).

tff(pred_def_59707,type,
    v106338: state_type > $o ).

tff(pred_def_59708,type,
    v106337: state_type > $o ).

tff(pred_def_59709,type,
    v106339: state_type > $o ).

tff(pred_def_59710,type,
    v106336: state_type > $o ).

tff(pred_def_59711,type,
    v106342: state_type > $o ).

tff(pred_def_59712,type,
    v106341: state_type > $o ).

tff(pred_def_59713,type,
    v106343: state_type > $o ).

tff(pred_def_59714,type,
    v106340: state_type > $o ).

tff(pred_def_59715,type,
    v106316: ( state_type * $int ) > $o ).

tff(pred_def_59716,type,
    v106286: ( state_type * $int ) > $o ).

tff(pred_def_59717,type,
    v106356: state_type > $o ).

tff(pred_def_59718,type,
    v106355: state_type > $o ).

tff(pred_def_59719,type,
    v106354: state_type > $o ).

tff(pred_def_59720,type,
    v106357: state_type > $o ).

tff(pred_def_59721,type,
    v106353: state_type > $o ).

tff(pred_def_59722,type,
    v106352: state_type > $o ).

tff(pred_def_59723,type,
    v106358: state_type > $o ).

tff(pred_def_59724,type,
    v106351: state_type > $o ).

tff(pred_def_59725,type,
    v106350: state_type > $o ).

tff(pred_def_59726,type,
    v106349: state_type > $o ).

tff(pred_def_59727,type,
    v106348: state_type > $o ).

tff(pred_def_59728,type,
    v106360: state_type > $o ).

tff(pred_def_59729,type,
    v106359: state_type > $o ).

tff(pred_def_59730,type,
    v106347: state_type > $o ).

tff(pred_def_59731,type,
    v106363: state_type > $o ).

tff(pred_def_59732,type,
    v106362: state_type > $o ).

tff(pred_def_59733,type,
    v106364: state_type > $o ).

tff(pred_def_59734,type,
    v106361: state_type > $o ).

tff(pred_def_59735,type,
    v106367: state_type > $o ).

tff(pred_def_59736,type,
    v106366: state_type > $o ).

tff(pred_def_59737,type,
    v106368: state_type > $o ).

tff(pred_def_59738,type,
    v106365: state_type > $o ).

tff(pred_def_59739,type,
    v106371: state_type > $o ).

tff(pred_def_59740,type,
    v106370: state_type > $o ).

tff(pred_def_59741,type,
    v106372: state_type > $o ).

tff(pred_def_59742,type,
    v106369: state_type > $o ).

tff(pred_def_59743,type,
    v106345: ( state_type * $int ) > $o ).

tff(pred_def_59744,type,
    v106344: ( state_type * $int ) > $o ).

tff(pred_def_59745,type,
    v106306: ( state_type * $int ) > $o ).

tff(pred_def_59746,type,
    v106304: ( state_type * $int ) > $o ).

tff(pred_def_59747,type,
    v106302: ( state_type * $int ) > $o ).

tff(pred_def_59748,type,
    v106300: ( state_type * $int ) > $o ).

tff(pred_def_59749,type,
    v106376: state_type > $o ).

tff(pred_def_59750,type,
    v106374: state_type > $o ).

tff(pred_def_59751,type,
    v106383: state_type > $o ).

tff(pred_def_59752,type,
    v106381: state_type > $o ).

tff(pred_def_59753,type,
    v106380: state_type > $o ).

tff(pred_def_59754,type,
    v106379: state_type > $o ).

tff(pred_def_59755,type,
    v106391: state_type > $o ).

tff(pred_def_59756,type,
    v106392: state_type > $o ).

tff(pred_def_59757,type,
    v106390: state_type > $o ).

tff(pred_def_59758,type,
    v106387: ( state_type * $int ) > $o ).

tff(pred_def_59759,type,
    v106389: ( state_type * $int ) > $o ).

tff(pred_def_59760,type,
    v106290: ( state_type * $int ) > $o ).

tff(pred_def_59761,type,
    v106288: ( state_type * $int ) > $o ).

tff(pred_def_59762,type,
    v106407: state_type > $o ).

tff(pred_def_59763,type,
    v106405: state_type > $o ).

tff(pred_def_59764,type,
    v106411: state_type > $o ).

tff(pred_def_59765,type,
    v106409: state_type > $o ).

tff(pred_def_59766,type,
    v106424: state_type > $o ).

tff(pred_def_59767,type,
    v106397: state_type > $o ).

tff(pred_def_59768,type,
    v106423: state_type > $o ).

tff(pred_def_59769,type,
    v106422: state_type > $o ).

tff(pred_def_59770,type,
    v106421: state_type > $o ).

tff(pred_def_59771,type,
    v106425: ( state_type * $int ) > $o ).

tff(pred_def_59772,type,
    v106399: ( state_type * $int ) > $o ).

tff(pred_def_59773,type,
    v106438: state_type > $o ).

tff(pred_def_59774,type,
    v106437: state_type > $o ).

tff(pred_def_59775,type,
    v106436: state_type > $o ).

tff(pred_def_59776,type,
    v106439: state_type > $o ).

tff(pred_def_59777,type,
    v106435: state_type > $o ).

tff(pred_def_59778,type,
    v106434: state_type > $o ).

tff(pred_def_59779,type,
    v106440: state_type > $o ).

tff(pred_def_59780,type,
    v106433: state_type > $o ).

tff(pred_def_59781,type,
    v106432: state_type > $o ).

tff(pred_def_59782,type,
    v106431: state_type > $o ).

tff(pred_def_59783,type,
    v106430: state_type > $o ).

tff(pred_def_59784,type,
    v106442: state_type > $o ).

tff(pred_def_59785,type,
    v106441: state_type > $o ).

tff(pred_def_59786,type,
    v106429: state_type > $o ).

tff(pred_def_59787,type,
    v106445: state_type > $o ).

tff(pred_def_59788,type,
    v106444: state_type > $o ).

tff(pred_def_59789,type,
    v106446: state_type > $o ).

tff(pred_def_59790,type,
    v106443: state_type > $o ).

tff(pred_def_59791,type,
    v106449: state_type > $o ).

tff(pred_def_59792,type,
    v106448: state_type > $o ).

tff(pred_def_59793,type,
    v106450: state_type > $o ).

tff(pred_def_59794,type,
    v106447: state_type > $o ).

tff(pred_def_59795,type,
    v106453: state_type > $o ).

tff(pred_def_59796,type,
    v106452: state_type > $o ).

tff(pred_def_59797,type,
    v106454: state_type > $o ).

tff(pred_def_59798,type,
    v106451: state_type > $o ).

tff(pred_def_59799,type,
    v106427: ( state_type * $int ) > $o ).

tff(pred_def_59800,type,
    v106426: ( state_type * $int ) > $o ).

tff(pred_def_59801,type,
    v106419: ( state_type * $int ) > $o ).

tff(pred_def_59802,type,
    v106417: ( state_type * $int ) > $o ).

tff(pred_def_59803,type,
    v106415: ( state_type * $int ) > $o ).

tff(pred_def_59804,type,
    v106413: ( state_type * $int ) > $o ).

tff(pred_def_59805,type,
    v106458: state_type > $o ).

tff(pred_def_59806,type,
    v106456: state_type > $o ).

tff(pred_def_59807,type,
    v106465: state_type > $o ).

tff(pred_def_59808,type,
    v106463: state_type > $o ).

tff(pred_def_59809,type,
    v106462: state_type > $o ).

tff(pred_def_59810,type,
    v106461: state_type > $o ).

tff(pred_def_59811,type,
    v106473: state_type > $o ).

tff(pred_def_59812,type,
    v106474: state_type > $o ).

tff(pred_def_59813,type,
    v106472: state_type > $o ).

tff(pred_def_59814,type,
    v106469: ( state_type * $int ) > $o ).

tff(pred_def_59815,type,
    v106471: ( state_type * $int ) > $o ).

tff(pred_def_59816,type,
    v106403: ( state_type * $int ) > $o ).

tff(pred_def_59817,type,
    v106401: ( state_type * $int ) > $o ).

tff(pred_def_59818,type,
    v106489: state_type > $o ).

tff(pred_def_59819,type,
    v106487: state_type > $o ).

tff(pred_def_59820,type,
    v106493: state_type > $o ).

tff(pred_def_59821,type,
    v106491: state_type > $o ).

tff(pred_def_59822,type,
    v106507: state_type > $o ).

tff(pred_def_59823,type,
    v106479: state_type > $o ).

tff(pred_def_59824,type,
    v106506: state_type > $o ).

tff(pred_def_59825,type,
    v106508: state_type > $o ).

tff(pred_def_59826,type,
    v106505: state_type > $o ).

tff(pred_def_59827,type,
    v106504: state_type > $o ).

tff(pred_def_59828,type,
    v106503: state_type > $o ).

tff(pred_def_59829,type,
    v106509: ( state_type * $int ) > $o ).

tff(pred_def_59830,type,
    v106481: ( state_type * $int ) > $o ).

tff(pred_def_59831,type,
    v106522: state_type > $o ).

tff(pred_def_59832,type,
    v106521: state_type > $o ).

tff(pred_def_59833,type,
    v106520: state_type > $o ).

tff(pred_def_59834,type,
    v106523: state_type > $o ).

tff(pred_def_59835,type,
    v106519: state_type > $o ).

tff(pred_def_59836,type,
    v106518: state_type > $o ).

tff(pred_def_59837,type,
    v106524: state_type > $o ).

tff(pred_def_59838,type,
    v106517: state_type > $o ).

tff(pred_def_59839,type,
    v106516: state_type > $o ).

tff(pred_def_59840,type,
    v106515: state_type > $o ).

tff(pred_def_59841,type,
    v106514: state_type > $o ).

tff(pred_def_59842,type,
    v106526: state_type > $o ).

tff(pred_def_59843,type,
    v106525: state_type > $o ).

tff(pred_def_59844,type,
    v106513: state_type > $o ).

tff(pred_def_59845,type,
    v106529: state_type > $o ).

tff(pred_def_59846,type,
    v106528: state_type > $o ).

tff(pred_def_59847,type,
    v106530: state_type > $o ).

tff(pred_def_59848,type,
    v106527: state_type > $o ).

tff(pred_def_59849,type,
    v106533: state_type > $o ).

tff(pred_def_59850,type,
    v106532: state_type > $o ).

tff(pred_def_59851,type,
    v106534: state_type > $o ).

tff(pred_def_59852,type,
    v106531: state_type > $o ).

tff(pred_def_59853,type,
    v106537: state_type > $o ).

tff(pred_def_59854,type,
    v106536: state_type > $o ).

tff(pred_def_59855,type,
    v106538: state_type > $o ).

tff(pred_def_59856,type,
    v106535: state_type > $o ).

tff(pred_def_59857,type,
    v106511: ( state_type * $int ) > $o ).

tff(pred_def_59858,type,
    v106510: ( state_type * $int ) > $o ).

tff(pred_def_59859,type,
    v106501: ( state_type * $int ) > $o ).

tff(pred_def_59860,type,
    v106499: ( state_type * $int ) > $o ).

tff(pred_def_59861,type,
    v106497: ( state_type * $int ) > $o ).

tff(pred_def_59862,type,
    v106495: ( state_type * $int ) > $o ).

tff(pred_def_59863,type,
    v106542: state_type > $o ).

tff(pred_def_59864,type,
    v106540: state_type > $o ).

tff(pred_def_59865,type,
    v106549: state_type > $o ).

tff(pred_def_59866,type,
    v106547: state_type > $o ).

tff(pred_def_59867,type,
    v106546: state_type > $o ).

tff(pred_def_59868,type,
    v106545: state_type > $o ).

tff(pred_def_59869,type,
    v106557: state_type > $o ).

tff(pred_def_59870,type,
    v106558: state_type > $o ).

tff(pred_def_59871,type,
    v106556: state_type > $o ).

tff(pred_def_59872,type,
    v106553: ( state_type * $int ) > $o ).

tff(pred_def_59873,type,
    v106555: ( state_type * $int ) > $o ).

tff(pred_def_59874,type,
    v106485: ( state_type * $int ) > $o ).

tff(pred_def_59875,type,
    v106483: ( state_type * $int ) > $o ).

tff(pred_def_59876,type,
    v106573: state_type > $o ).

tff(pred_def_59877,type,
    v106571: state_type > $o ).

tff(pred_def_59878,type,
    v106577: state_type > $o ).

tff(pred_def_59879,type,
    v106575: state_type > $o ).

tff(pred_def_59880,type,
    v106592: state_type > $o ).

tff(pred_def_59881,type,
    v106563: state_type > $o ).

tff(pred_def_59882,type,
    v106591: state_type > $o ).

tff(pred_def_59883,type,
    v106593: state_type > $o ).

tff(pred_def_59884,type,
    v106590: state_type > $o ).

tff(pred_def_59885,type,
    v106594: state_type > $o ).

tff(pred_def_59886,type,
    v106589: state_type > $o ).

tff(pred_def_59887,type,
    v106588: state_type > $o ).

tff(pred_def_59888,type,
    v106587: state_type > $o ).

tff(pred_def_59889,type,
    v106595: ( state_type * $int ) > $o ).

tff(pred_def_59890,type,
    v106565: ( state_type * $int ) > $o ).

tff(pred_def_59891,type,
    v106608: state_type > $o ).

tff(pred_def_59892,type,
    v106607: state_type > $o ).

tff(pred_def_59893,type,
    v106606: state_type > $o ).

tff(pred_def_59894,type,
    v106609: state_type > $o ).

tff(pred_def_59895,type,
    v106605: state_type > $o ).

tff(pred_def_59896,type,
    v106604: state_type > $o ).

tff(pred_def_59897,type,
    v106610: state_type > $o ).

tff(pred_def_59898,type,
    v106603: state_type > $o ).

tff(pred_def_59899,type,
    v106602: state_type > $o ).

tff(pred_def_59900,type,
    v106601: state_type > $o ).

tff(pred_def_59901,type,
    v106600: state_type > $o ).

tff(pred_def_59902,type,
    v106612: state_type > $o ).

tff(pred_def_59903,type,
    v106611: state_type > $o ).

tff(pred_def_59904,type,
    v106599: state_type > $o ).

tff(pred_def_59905,type,
    v106615: state_type > $o ).

tff(pred_def_59906,type,
    v106614: state_type > $o ).

tff(pred_def_59907,type,
    v106616: state_type > $o ).

tff(pred_def_59908,type,
    v106613: state_type > $o ).

tff(pred_def_59909,type,
    v106619: state_type > $o ).

tff(pred_def_59910,type,
    v106618: state_type > $o ).

tff(pred_def_59911,type,
    v106620: state_type > $o ).

tff(pred_def_59912,type,
    v106617: state_type > $o ).

tff(pred_def_59913,type,
    v106623: state_type > $o ).

tff(pred_def_59914,type,
    v106622: state_type > $o ).

tff(pred_def_59915,type,
    v106624: state_type > $o ).

tff(pred_def_59916,type,
    v106621: state_type > $o ).

tff(pred_def_59917,type,
    v106597: ( state_type * $int ) > $o ).

tff(pred_def_59918,type,
    v106596: ( state_type * $int ) > $o ).

tff(pred_def_59919,type,
    v106585: ( state_type * $int ) > $o ).

tff(pred_def_59920,type,
    v106583: ( state_type * $int ) > $o ).

tff(pred_def_59921,type,
    v106581: ( state_type * $int ) > $o ).

tff(pred_def_59922,type,
    v106579: ( state_type * $int ) > $o ).

tff(pred_def_59923,type,
    v106628: state_type > $o ).

tff(pred_def_59924,type,
    v106626: state_type > $o ).

tff(pred_def_59925,type,
    v106635: state_type > $o ).

tff(pred_def_59926,type,
    v106633: state_type > $o ).

tff(pred_def_59927,type,
    v106632: state_type > $o ).

tff(pred_def_59928,type,
    v106631: state_type > $o ).

tff(pred_def_59929,type,
    v106643: state_type > $o ).

tff(pred_def_59930,type,
    v106644: state_type > $o ).

tff(pred_def_59931,type,
    v106642: state_type > $o ).

tff(pred_def_59932,type,
    v106639: ( state_type * $int ) > $o ).

tff(pred_def_59933,type,
    v106641: ( state_type * $int ) > $o ).

tff(pred_def_59934,type,
    v106569: ( state_type * $int ) > $o ).

tff(pred_def_59935,type,
    v106567: ( state_type * $int ) > $o ).

tff(pred_def_59936,type,
    v106651: state_type > $o ).

tff(pred_def_59937,type,
    v106652: state_type > $o ).

tff(pred_def_59938,type,
    v106650: state_type > $o ).

tff(pred_def_59939,type,
    v106653: state_type > $o ).

tff(pred_def_59940,type,
    v106649: state_type > $o ).

tff(pred_def_59941,type,
    v106654: state_type > $o ).

tff(pred_def_59942,type,
    v106282: state_type > $o ).

tff(pred_def_59943,type,
    v106670: state_type > $o ).

tff(pred_def_59944,type,
    v106668: state_type > $o ).

tff(pred_def_59945,type,
    v106666: state_type > $o ).

tff(pred_def_59946,type,
    v106664: state_type > $o ).

tff(pred_def_59947,type,
    v106678: state_type > $o ).

tff(pred_def_59948,type,
    v106676: state_type > $o ).

tff(pred_def_59949,type,
    v106674: state_type > $o ).

tff(pred_def_59950,type,
    v106672: state_type > $o ).

tff(pred_def_59951,type,
    v106693: state_type > $o ).

tff(pred_def_59952,type,
    v106692: state_type > $o ).

tff(pred_def_59953,type,
    v106695: state_type > $o ).

tff(pred_def_59954,type,
    v106694: state_type > $o ).

tff(pred_def_59955,type,
    v106691: state_type > $o ).

tff(pred_def_59956,type,
    v106697: state_type > $o ).

tff(pred_def_59957,type,
    v106696: state_type > $o ).

tff(pred_def_59958,type,
    v106690: state_type > $o ).

tff(pred_def_59959,type,
    v106699: state_type > $o ).

tff(pred_def_59960,type,
    v106698: state_type > $o ).

tff(pred_def_59961,type,
    v106688: state_type > $o ).

tff(pred_def_59962,type,
    v106701: ( state_type * $int ) > $o ).

tff(pred_def_59963,type,
    v106703: state_type > $o ).

tff(pred_def_59964,type,
    v106658: ( state_type * $int ) > $o ).

tff(pred_def_59965,type,
    v106706: state_type > $o ).

tff(pred_def_59966,type,
    v106717: state_type > $o ).

tff(pred_def_59967,type,
    v106716: state_type > $o ).

tff(pred_def_59968,type,
    v106715: state_type > $o ).

tff(pred_def_59969,type,
    v106718: state_type > $o ).

tff(pred_def_59970,type,
    v106714: state_type > $o ).

tff(pred_def_59971,type,
    v106713: state_type > $o ).

tff(pred_def_59972,type,
    v106712: state_type > $o ).

tff(pred_def_59973,type,
    v106711: state_type > $o ).

tff(pred_def_59974,type,
    v106720: state_type > $o ).

tff(pred_def_59975,type,
    v106719: state_type > $o ).

tff(pred_def_59976,type,
    v106710: state_type > $o ).

tff(pred_def_59977,type,
    v106723: state_type > $o ).

tff(pred_def_59978,type,
    v106722: state_type > $o ).

tff(pred_def_59979,type,
    v106724: state_type > $o ).

tff(pred_def_59980,type,
    v106721: state_type > $o ).

tff(pred_def_59981,type,
    v106727: state_type > $o ).

tff(pred_def_59982,type,
    v106726: state_type > $o ).

tff(pred_def_59983,type,
    v106728: state_type > $o ).

tff(pred_def_59984,type,
    v106725: state_type > $o ).

tff(pred_def_59985,type,
    v106708: ( state_type * $int ) > $o ).

tff(pred_def_59986,type,
    v106707: ( state_type * $int ) > $o ).

tff(pred_def_59987,type,
    v106705: ( state_type * $int ) > $o ).

tff(pred_def_59988,type,
    v106686: ( state_type * $int ) > $o ).

tff(pred_def_59989,type,
    v106684: ( state_type * $int ) > $o ).

tff(pred_def_59990,type,
    v106682: ( state_type * $int ) > $o ).

tff(pred_def_59991,type,
    v106680: ( state_type * $int ) > $o ).

tff(pred_def_59992,type,
    v106734: state_type > $o ).

tff(pred_def_59993,type,
    v106732: state_type > $o ).

tff(pred_def_59994,type,
    v106730: state_type > $o ).

tff(pred_def_59995,type,
    v106741: state_type > $o ).

tff(pred_def_59996,type,
    v106739: state_type > $o ).

tff(pred_def_59997,type,
    v106738: state_type > $o ).

tff(pred_def_59998,type,
    v106737: state_type > $o ).

tff(pred_def_59999,type,
    v106749: state_type > $o ).

tff(pred_def_60000,type,
    v106750: state_type > $o ).

tff(pred_def_60001,type,
    v106748: state_type > $o ).

tff(pred_def_60002,type,
    v106745: ( state_type * $int ) > $o ).

tff(pred_def_60003,type,
    v106747: ( state_type * $int ) > $o ).

tff(pred_def_60004,type,
    v106662: ( state_type * $int ) > $o ).

tff(pred_def_60005,type,
    v106660: ( state_type * $int ) > $o ).

tff(pred_def_60006,type,
    v106656: state_type > $o ).

tff(pred_def_60007,type,
    v106765: state_type > $o ).

tff(pred_def_60008,type,
    v106763: state_type > $o ).

tff(pred_def_60009,type,
    v106769: state_type > $o ).

tff(pred_def_60010,type,
    v106767: state_type > $o ).

tff(pred_def_60011,type,
    v106787: state_type > $o ).

tff(pred_def_60012,type,
    v106785: state_type > $o ).

tff(pred_def_60013,type,
    v106791: state_type > $o ).

tff(pred_def_60014,type,
    v106789: state_type > $o ).

tff(pred_def_60015,type,
    v106802: state_type > $o ).

tff(pred_def_60016,type,
    v106801: state_type > $o ).

tff(pred_def_60017,type,
    v106804: state_type > $o ).

tff(pred_def_60018,type,
    v106803: state_type > $o ).

tff(pred_def_60019,type,
    v106799: state_type > $o ).

tff(pred_def_60020,type,
    v106805: ( state_type * $int ) > $o ).

tff(pred_def_60021,type,
    v106806: state_type > $o ).

tff(pred_def_60022,type,
    v106797: ( state_type * $int ) > $o ).

tff(pred_def_60023,type,
    v106795: ( state_type * $int ) > $o ).

tff(pred_def_60024,type,
    v106793: ( state_type * $int ) > $o ).

tff(pred_def_60025,type,
    v106810: state_type > $o ).

tff(pred_def_60026,type,
    v106808: state_type > $o ).

tff(pred_def_60027,type,
    v106817: state_type > $o ).

tff(pred_def_60028,type,
    v106815: state_type > $o ).

tff(pred_def_60029,type,
    v106814: state_type > $o ).

tff(pred_def_60030,type,
    v106813: state_type > $o ).

tff(pred_def_60031,type,
    v106825: state_type > $o ).

tff(pred_def_60032,type,
    v106826: state_type > $o ).

tff(pred_def_60033,type,
    v106824: state_type > $o ).

tff(pred_def_60034,type,
    v106821: ( state_type * $int ) > $o ).

tff(pred_def_60035,type,
    v106823: ( state_type * $int ) > $o ).

tff(pred_def_60036,type,
    v106812: ( state_type * $int ) > $o ).

tff(pred_def_60037,type,
    v106783: ( state_type * $int ) > $o ).

tff(pred_def_60038,type,
    v106781: ( state_type * $int ) > $o ).

tff(pred_def_60039,type,
    v106779: state_type > $o ).

tff(pred_def_60040,type,
    v106834: state_type > $o ).

tff(pred_def_60041,type,
    v106833: state_type > $o ).

tff(pred_def_60042,type,
    v106836: state_type > $o ).

tff(pred_def_60043,type,
    v106835: state_type > $o ).

tff(pred_def_60044,type,
    v106842: state_type > $o ).

tff(pred_def_60045,type,
    v106840: state_type > $o ).

tff(pred_def_60046,type,
    v106839: state_type > $o ).

tff(pred_def_60047,type,
    v106838: ( state_type * $int ) > $o ).

tff(pred_def_60048,type,
    v106830: state_type > $o ).

tff(pred_def_60049,type,
    v106846: state_type > $o ).

tff(pred_def_60050,type,
    v106848: state_type > $o ).

tff(pred_def_60051,type,
    v106757: ( state_type * $int ) > $o ).

tff(pred_def_60052,type,
    v106850: state_type > $o ).

tff(pred_def_60053,type,
    v106855: state_type > $o ).

tff(pred_def_60054,type,
    v106854: state_type > $o ).

tff(pred_def_60055,type,
    v106857: state_type > $o ).

tff(pred_def_60056,type,
    v106856: state_type > $o ).

tff(pred_def_60057,type,
    v106853: state_type > $o ).

tff(pred_def_60058,type,
    v106851: ( state_type * $int ) > $o ).

tff(pred_def_60059,type,
    v106849: ( state_type * $int ) > $o ).

tff(pred_def_60060,type,
    v106847: ( state_type * $int ) > $o ).

tff(pred_def_60061,type,
    v106777: ( state_type * $int ) > $o ).

tff(pred_def_60062,type,
    v106775: ( state_type * $int ) > $o ).

tff(pred_def_60063,type,
    v106773: ( state_type * $int ) > $o ).

tff(pred_def_60064,type,
    v106771: ( state_type * $int ) > $o ).

tff(pred_def_60065,type,
    v106861: state_type > $o ).

tff(pred_def_60066,type,
    v106859: state_type > $o ).

tff(pred_def_60067,type,
    v106868: state_type > $o ).

tff(pred_def_60068,type,
    v106866: state_type > $o ).

tff(pred_def_60069,type,
    v106865: state_type > $o ).

tff(pred_def_60070,type,
    v106864: state_type > $o ).

tff(pred_def_60071,type,
    v106876: state_type > $o ).

tff(pred_def_60072,type,
    v106877: state_type > $o ).

tff(pred_def_60073,type,
    v106875: state_type > $o ).

tff(pred_def_60074,type,
    v106872: ( state_type * $int ) > $o ).

tff(pred_def_60075,type,
    v106874: ( state_type * $int ) > $o ).

tff(pred_def_60076,type,
    v106761: ( state_type * $int ) > $o ).

tff(pred_def_60077,type,
    v106759: ( state_type * $int ) > $o ).

tff(pred_def_60078,type,
    v106755: state_type > $o ).

tff(pred_def_60079,type,
    v106892: state_type > $o ).

tff(pred_def_60080,type,
    v106890: state_type > $o ).

tff(pred_def_60081,type,
    v106896: state_type > $o ).

tff(pred_def_60082,type,
    v106894: state_type > $o ).

tff(pred_def_60083,type,
    v106906: state_type > $o ).

tff(pred_def_60084,type,
    v106909: ( state_type * $int ) > $o ).

tff(pred_def_60085,type,
    v106882: state_type > $o ).

tff(pred_def_60086,type,
    v106911: state_type > $o ).

tff(pred_def_60087,type,
    v106921: state_type > $o ).

tff(pred_def_60088,type,
    v106920: state_type > $o ).

tff(pred_def_60089,type,
    v106919: state_type > $o ).

tff(pred_def_60090,type,
    v106922: state_type > $o ).

tff(pred_def_60091,type,
    v106918: state_type > $o ).

tff(pred_def_60092,type,
    v106917: state_type > $o ).

tff(pred_def_60093,type,
    v106916: state_type > $o ).

tff(pred_def_60094,type,
    v106915: state_type > $o ).

tff(pred_def_60095,type,
    v106924: state_type > $o ).

tff(pred_def_60096,type,
    v106923: state_type > $o ).

tff(pred_def_60097,type,
    v106914: state_type > $o ).

tff(pred_def_60098,type,
    v106927: state_type > $o ).

tff(pred_def_60099,type,
    v106926: state_type > $o ).

tff(pred_def_60100,type,
    v106928: state_type > $o ).

tff(pred_def_60101,type,
    v106925: state_type > $o ).

tff(pred_def_60102,type,
    v106931: state_type > $o ).

tff(pred_def_60103,type,
    v106930: state_type > $o ).

tff(pred_def_60104,type,
    v106932: state_type > $o ).

tff(pred_def_60105,type,
    v106929: state_type > $o ).

tff(pred_def_60106,type,
    v106912: ( state_type * $int ) > $o ).

tff(pred_def_60107,type,
    v106934: state_type > $o ).

tff(pred_def_60108,type,
    v106884: ( state_type * $int ) > $o ).

tff(pred_def_60109,type,
    v106936: state_type > $o ).

tff(pred_def_60110,type,
    v106947: state_type > $o ).

tff(pred_def_60111,type,
    v106946: state_type > $o ).

tff(pred_def_60112,type,
    v106945: state_type > $o ).

tff(pred_def_60113,type,
    v106948: state_type > $o ).

tff(pred_def_60114,type,
    v106944: state_type > $o ).

tff(pred_def_60115,type,
    v106943: state_type > $o ).

tff(pred_def_60116,type,
    v106942: state_type > $o ).

tff(pred_def_60117,type,
    v106941: state_type > $o ).

tff(pred_def_60118,type,
    v106950: state_type > $o ).

tff(pred_def_60119,type,
    v106949: state_type > $o ).

tff(pred_def_60120,type,
    v106940: state_type > $o ).

tff(pred_def_60121,type,
    v106953: state_type > $o ).

tff(pred_def_60122,type,
    v106952: state_type > $o ).

tff(pred_def_60123,type,
    v106954: state_type > $o ).

tff(pred_def_60124,type,
    v106951: state_type > $o ).

tff(pred_def_60125,type,
    v106957: state_type > $o ).

tff(pred_def_60126,type,
    v106956: state_type > $o ).

tff(pred_def_60127,type,
    v106958: state_type > $o ).

tff(pred_def_60128,type,
    v106955: state_type > $o ).

tff(pred_def_60129,type,
    v106938: ( state_type * $int ) > $o ).

tff(pred_def_60130,type,
    v106937: ( state_type * $int ) > $o ).

tff(pred_def_60131,type,
    v106935: ( state_type * $int ) > $o ).

tff(pred_def_60132,type,
    v106933: ( state_type * $int ) > $o ).

tff(pred_def_60133,type,
    v106904: ( state_type * $int ) > $o ).

tff(pred_def_60134,type,
    v106902: ( state_type * $int ) > $o ).

tff(pred_def_60135,type,
    v106900: ( state_type * $int ) > $o ).

tff(pred_def_60136,type,
    v106898: ( state_type * $int ) > $o ).

tff(pred_def_60137,type,
    v106962: state_type > $o ).

tff(pred_def_60138,type,
    v106960: state_type > $o ).

tff(pred_def_60139,type,
    v106969: state_type > $o ).

tff(pred_def_60140,type,
    v106967: state_type > $o ).

tff(pred_def_60141,type,
    v106966: state_type > $o ).

tff(pred_def_60142,type,
    v106965: state_type > $o ).

tff(pred_def_60143,type,
    v106977: state_type > $o ).

tff(pred_def_60144,type,
    v106978: state_type > $o ).

tff(pred_def_60145,type,
    v106976: state_type > $o ).

tff(pred_def_60146,type,
    v106973: ( state_type * $int ) > $o ).

tff(pred_def_60147,type,
    v106975: ( state_type * $int ) > $o ).

tff(pred_def_60148,type,
    v106888: ( state_type * $int ) > $o ).

tff(pred_def_60149,type,
    v106886: ( state_type * $int ) > $o ).

tff(pred_def_60150,type,
    v106995: state_type > $o ).

tff(pred_def_60151,type,
    v106993: state_type > $o ).

tff(pred_def_60152,type,
    v106999: state_type > $o ).

tff(pred_def_60153,type,
    v106997: state_type > $o ).

tff(pred_def_60154,type,
    v107011: state_type > $o ).

tff(pred_def_60155,type,
    v107009: state_type > $o ).

tff(pred_def_60156,type,
    v107013: ( state_type * $int ) > $o ).

tff(pred_def_60157,type,
    v106985: state_type > $o ).

tff(pred_def_60158,type,
    v107016: state_type > $o ).

tff(pred_def_60159,type,
    v107015: state_type > $o ).

tff(pred_def_60160,type,
    v107028: state_type > $o ).

tff(pred_def_60161,type,
    v107027: state_type > $o ).

tff(pred_def_60162,type,
    v107026: state_type > $o ).

tff(pred_def_60163,type,
    v107029: state_type > $o ).

tff(pred_def_60164,type,
    v107025: state_type > $o ).

tff(pred_def_60165,type,
    v107024: state_type > $o ).

tff(pred_def_60166,type,
    v107030: state_type > $o ).

tff(pred_def_60167,type,
    v107023: state_type > $o ).

tff(pred_def_60168,type,
    v107022: state_type > $o ).

tff(pred_def_60169,type,
    v107021: state_type > $o ).

tff(pred_def_60170,type,
    v107020: state_type > $o ).

tff(pred_def_60171,type,
    v107032: state_type > $o ).

tff(pred_def_60172,type,
    v107031: state_type > $o ).

tff(pred_def_60173,type,
    v107019: state_type > $o ).

tff(pred_def_60174,type,
    v107035: state_type > $o ).

tff(pred_def_60175,type,
    v107034: state_type > $o ).

tff(pred_def_60176,type,
    v107036: state_type > $o ).

tff(pred_def_60177,type,
    v107033: state_type > $o ).

tff(pred_def_60178,type,
    v107039: state_type > $o ).

tff(pred_def_60179,type,
    v107038: state_type > $o ).

tff(pred_def_60180,type,
    v107040: state_type > $o ).

tff(pred_def_60181,type,
    v107037: state_type > $o ).

tff(pred_def_60182,type,
    v107043: state_type > $o ).

tff(pred_def_60183,type,
    v107042: state_type > $o ).

tff(pred_def_60184,type,
    v107044: state_type > $o ).

tff(pred_def_60185,type,
    v107041: state_type > $o ).

tff(pred_def_60186,type,
    v107017: ( state_type * $int ) > $o ).

tff(pred_def_60187,type,
    v106987: ( state_type * $int ) > $o ).

tff(pred_def_60188,type,
    v107057: state_type > $o ).

tff(pred_def_60189,type,
    v107056: state_type > $o ).

tff(pred_def_60190,type,
    v107055: state_type > $o ).

tff(pred_def_60191,type,
    v107058: state_type > $o ).

tff(pred_def_60192,type,
    v107054: state_type > $o ).

tff(pred_def_60193,type,
    v107053: state_type > $o ).

tff(pred_def_60194,type,
    v107059: state_type > $o ).

tff(pred_def_60195,type,
    v107052: state_type > $o ).

tff(pred_def_60196,type,
    v107051: state_type > $o ).

tff(pred_def_60197,type,
    v107050: state_type > $o ).

tff(pred_def_60198,type,
    v107049: state_type > $o ).

tff(pred_def_60199,type,
    v107061: state_type > $o ).

tff(pred_def_60200,type,
    v107060: state_type > $o ).

tff(pred_def_60201,type,
    v107048: state_type > $o ).

tff(pred_def_60202,type,
    v107064: state_type > $o ).

tff(pred_def_60203,type,
    v107063: state_type > $o ).

tff(pred_def_60204,type,
    v107065: state_type > $o ).

tff(pred_def_60205,type,
    v107062: state_type > $o ).

tff(pred_def_60206,type,
    v107068: state_type > $o ).

tff(pred_def_60207,type,
    v107067: state_type > $o ).

tff(pred_def_60208,type,
    v107069: state_type > $o ).

tff(pred_def_60209,type,
    v107066: state_type > $o ).

tff(pred_def_60210,type,
    v107072: state_type > $o ).

tff(pred_def_60211,type,
    v107071: state_type > $o ).

tff(pred_def_60212,type,
    v107073: state_type > $o ).

tff(pred_def_60213,type,
    v107070: state_type > $o ).

tff(pred_def_60214,type,
    v107046: ( state_type * $int ) > $o ).

tff(pred_def_60215,type,
    v107045: ( state_type * $int ) > $o ).

tff(pred_def_60216,type,
    v107007: ( state_type * $int ) > $o ).

tff(pred_def_60217,type,
    v107005: ( state_type * $int ) > $o ).

tff(pred_def_60218,type,
    v107003: ( state_type * $int ) > $o ).

tff(pred_def_60219,type,
    v107001: ( state_type * $int ) > $o ).

tff(pred_def_60220,type,
    v107077: state_type > $o ).

tff(pred_def_60221,type,
    v107075: state_type > $o ).

tff(pred_def_60222,type,
    v107084: state_type > $o ).

tff(pred_def_60223,type,
    v107082: state_type > $o ).

tff(pred_def_60224,type,
    v107081: state_type > $o ).

tff(pred_def_60225,type,
    v107080: state_type > $o ).

tff(pred_def_60226,type,
    v107092: state_type > $o ).

tff(pred_def_60227,type,
    v107093: state_type > $o ).

tff(pred_def_60228,type,
    v107091: state_type > $o ).

tff(pred_def_60229,type,
    v107088: ( state_type * $int ) > $o ).

tff(pred_def_60230,type,
    v107090: ( state_type * $int ) > $o ).

tff(pred_def_60231,type,
    v106991: ( state_type * $int ) > $o ).

tff(pred_def_60232,type,
    v106989: ( state_type * $int ) > $o ).

tff(pred_def_60233,type,
    v107108: state_type > $o ).

tff(pred_def_60234,type,
    v107106: state_type > $o ).

tff(pred_def_60235,type,
    v107112: state_type > $o ).

tff(pred_def_60236,type,
    v107110: state_type > $o ).

tff(pred_def_60237,type,
    v107125: state_type > $o ).

tff(pred_def_60238,type,
    v107098: state_type > $o ).

tff(pred_def_60239,type,
    v107124: state_type > $o ).

tff(pred_def_60240,type,
    v107123: state_type > $o ).

tff(pred_def_60241,type,
    v107122: state_type > $o ).

tff(pred_def_60242,type,
    v107126: ( state_type * $int ) > $o ).

tff(pred_def_60243,type,
    v107100: ( state_type * $int ) > $o ).

tff(pred_def_60244,type,
    v107139: state_type > $o ).

tff(pred_def_60245,type,
    v107138: state_type > $o ).

tff(pred_def_60246,type,
    v107137: state_type > $o ).

tff(pred_def_60247,type,
    v107140: state_type > $o ).

tff(pred_def_60248,type,
    v107136: state_type > $o ).

tff(pred_def_60249,type,
    v107135: state_type > $o ).

tff(pred_def_60250,type,
    v107141: state_type > $o ).

tff(pred_def_60251,type,
    v107134: state_type > $o ).

tff(pred_def_60252,type,
    v107133: state_type > $o ).

tff(pred_def_60253,type,
    v107132: state_type > $o ).

tff(pred_def_60254,type,
    v107131: state_type > $o ).

tff(pred_def_60255,type,
    v107143: state_type > $o ).

tff(pred_def_60256,type,
    v107142: state_type > $o ).

tff(pred_def_60257,type,
    v107130: state_type > $o ).

tff(pred_def_60258,type,
    v107146: state_type > $o ).

tff(pred_def_60259,type,
    v107145: state_type > $o ).

tff(pred_def_60260,type,
    v107147: state_type > $o ).

tff(pred_def_60261,type,
    v107144: state_type > $o ).

tff(pred_def_60262,type,
    v107150: state_type > $o ).

tff(pred_def_60263,type,
    v107149: state_type > $o ).

tff(pred_def_60264,type,
    v107151: state_type > $o ).

tff(pred_def_60265,type,
    v107148: state_type > $o ).

tff(pred_def_60266,type,
    v107154: state_type > $o ).

tff(pred_def_60267,type,
    v107153: state_type > $o ).

tff(pred_def_60268,type,
    v107155: state_type > $o ).

tff(pred_def_60269,type,
    v107152: state_type > $o ).

tff(pred_def_60270,type,
    v107128: ( state_type * $int ) > $o ).

tff(pred_def_60271,type,
    v107127: ( state_type * $int ) > $o ).

tff(pred_def_60272,type,
    v107120: ( state_type * $int ) > $o ).

tff(pred_def_60273,type,
    v107118: ( state_type * $int ) > $o ).

tff(pred_def_60274,type,
    v107116: ( state_type * $int ) > $o ).

tff(pred_def_60275,type,
    v107114: ( state_type * $int ) > $o ).

tff(pred_def_60276,type,
    v107159: state_type > $o ).

tff(pred_def_60277,type,
    v107157: state_type > $o ).

tff(pred_def_60278,type,
    v107166: state_type > $o ).

tff(pred_def_60279,type,
    v107164: state_type > $o ).

tff(pred_def_60280,type,
    v107163: state_type > $o ).

tff(pred_def_60281,type,
    v107162: state_type > $o ).

tff(pred_def_60282,type,
    v107174: state_type > $o ).

tff(pred_def_60283,type,
    v107175: state_type > $o ).

tff(pred_def_60284,type,
    v107173: state_type > $o ).

tff(pred_def_60285,type,
    v107170: ( state_type * $int ) > $o ).

tff(pred_def_60286,type,
    v107172: ( state_type * $int ) > $o ).

tff(pred_def_60287,type,
    v107104: ( state_type * $int ) > $o ).

tff(pred_def_60288,type,
    v107102: ( state_type * $int ) > $o ).

tff(pred_def_60289,type,
    v107190: state_type > $o ).

tff(pred_def_60290,type,
    v107188: state_type > $o ).

tff(pred_def_60291,type,
    v107194: state_type > $o ).

tff(pred_def_60292,type,
    v107192: state_type > $o ).

tff(pred_def_60293,type,
    v107208: state_type > $o ).

tff(pred_def_60294,type,
    v107180: state_type > $o ).

tff(pred_def_60295,type,
    v107207: state_type > $o ).

tff(pred_def_60296,type,
    v107209: state_type > $o ).

tff(pred_def_60297,type,
    v107206: state_type > $o ).

tff(pred_def_60298,type,
    v107205: state_type > $o ).

tff(pred_def_60299,type,
    v107204: state_type > $o ).

tff(pred_def_60300,type,
    v107210: ( state_type * $int ) > $o ).

tff(pred_def_60301,type,
    v107182: ( state_type * $int ) > $o ).

tff(pred_def_60302,type,
    v107223: state_type > $o ).

tff(pred_def_60303,type,
    v107222: state_type > $o ).

tff(pred_def_60304,type,
    v107221: state_type > $o ).

tff(pred_def_60305,type,
    v107224: state_type > $o ).

tff(pred_def_60306,type,
    v107220: state_type > $o ).

tff(pred_def_60307,type,
    v107219: state_type > $o ).

tff(pred_def_60308,type,
    v107225: state_type > $o ).

tff(pred_def_60309,type,
    v107218: state_type > $o ).

tff(pred_def_60310,type,
    v107217: state_type > $o ).

tff(pred_def_60311,type,
    v107216: state_type > $o ).

tff(pred_def_60312,type,
    v107215: state_type > $o ).

tff(pred_def_60313,type,
    v107227: state_type > $o ).

tff(pred_def_60314,type,
    v107226: state_type > $o ).

tff(pred_def_60315,type,
    v107214: state_type > $o ).

tff(pred_def_60316,type,
    v107230: state_type > $o ).

tff(pred_def_60317,type,
    v107229: state_type > $o ).

tff(pred_def_60318,type,
    v107231: state_type > $o ).

tff(pred_def_60319,type,
    v107228: state_type > $o ).

tff(pred_def_60320,type,
    v107234: state_type > $o ).

tff(pred_def_60321,type,
    v107233: state_type > $o ).

tff(pred_def_60322,type,
    v107235: state_type > $o ).

tff(pred_def_60323,type,
    v107232: state_type > $o ).

tff(pred_def_60324,type,
    v107238: state_type > $o ).

tff(pred_def_60325,type,
    v107237: state_type > $o ).

tff(pred_def_60326,type,
    v107239: state_type > $o ).

tff(pred_def_60327,type,
    v107236: state_type > $o ).

tff(pred_def_60328,type,
    v107212: ( state_type * $int ) > $o ).

tff(pred_def_60329,type,
    v107211: ( state_type * $int ) > $o ).

tff(pred_def_60330,type,
    v107202: ( state_type * $int ) > $o ).

tff(pred_def_60331,type,
    v107200: ( state_type * $int ) > $o ).

tff(pred_def_60332,type,
    v107198: ( state_type * $int ) > $o ).

tff(pred_def_60333,type,
    v107196: ( state_type * $int ) > $o ).

tff(pred_def_60334,type,
    v107243: state_type > $o ).

tff(pred_def_60335,type,
    v107241: state_type > $o ).

tff(pred_def_60336,type,
    v107250: state_type > $o ).

tff(pred_def_60337,type,
    v107248: state_type > $o ).

tff(pred_def_60338,type,
    v107247: state_type > $o ).

tff(pred_def_60339,type,
    v107246: state_type > $o ).

tff(pred_def_60340,type,
    v107258: state_type > $o ).

tff(pred_def_60341,type,
    v107259: state_type > $o ).

tff(pred_def_60342,type,
    v107257: state_type > $o ).

tff(pred_def_60343,type,
    v107254: ( state_type * $int ) > $o ).

tff(pred_def_60344,type,
    v107256: ( state_type * $int ) > $o ).

tff(pred_def_60345,type,
    v107186: ( state_type * $int ) > $o ).

tff(pred_def_60346,type,
    v107184: ( state_type * $int ) > $o ).

tff(pred_def_60347,type,
    v107274: state_type > $o ).

tff(pred_def_60348,type,
    v107272: state_type > $o ).

tff(pred_def_60349,type,
    v107278: state_type > $o ).

tff(pred_def_60350,type,
    v107276: state_type > $o ).

tff(pred_def_60351,type,
    v107293: state_type > $o ).

tff(pred_def_60352,type,
    v107264: state_type > $o ).

tff(pred_def_60353,type,
    v107292: state_type > $o ).

tff(pred_def_60354,type,
    v107294: state_type > $o ).

tff(pred_def_60355,type,
    v107291: state_type > $o ).

tff(pred_def_60356,type,
    v107295: state_type > $o ).

tff(pred_def_60357,type,
    v107290: state_type > $o ).

tff(pred_def_60358,type,
    v107289: state_type > $o ).

tff(pred_def_60359,type,
    v107288: state_type > $o ).

tff(pred_def_60360,type,
    v107296: ( state_type * $int ) > $o ).

tff(pred_def_60361,type,
    v107266: ( state_type * $int ) > $o ).

tff(pred_def_60362,type,
    v107309: state_type > $o ).

tff(pred_def_60363,type,
    v107308: state_type > $o ).

tff(pred_def_60364,type,
    v107307: state_type > $o ).

tff(pred_def_60365,type,
    v107310: state_type > $o ).

tff(pred_def_60366,type,
    v107306: state_type > $o ).

tff(pred_def_60367,type,
    v107305: state_type > $o ).

tff(pred_def_60368,type,
    v107311: state_type > $o ).

tff(pred_def_60369,type,
    v107304: state_type > $o ).

tff(pred_def_60370,type,
    v107303: state_type > $o ).

tff(pred_def_60371,type,
    v107302: state_type > $o ).

tff(pred_def_60372,type,
    v107301: state_type > $o ).

tff(pred_def_60373,type,
    v107313: state_type > $o ).

tff(pred_def_60374,type,
    v107312: state_type > $o ).

tff(pred_def_60375,type,
    v107300: state_type > $o ).

tff(pred_def_60376,type,
    v107316: state_type > $o ).

tff(pred_def_60377,type,
    v107315: state_type > $o ).

tff(pred_def_60378,type,
    v107317: state_type > $o ).

tff(pred_def_60379,type,
    v107314: state_type > $o ).

tff(pred_def_60380,type,
    v107320: state_type > $o ).

tff(pred_def_60381,type,
    v107319: state_type > $o ).

tff(pred_def_60382,type,
    v107321: state_type > $o ).

tff(pred_def_60383,type,
    v107318: state_type > $o ).

tff(pred_def_60384,type,
    v107324: state_type > $o ).

tff(pred_def_60385,type,
    v107323: state_type > $o ).

tff(pred_def_60386,type,
    v107325: state_type > $o ).

tff(pred_def_60387,type,
    v107322: state_type > $o ).

tff(pred_def_60388,type,
    v107298: ( state_type * $int ) > $o ).

tff(pred_def_60389,type,
    v107297: ( state_type * $int ) > $o ).

tff(pred_def_60390,type,
    v107286: ( state_type * $int ) > $o ).

tff(pred_def_60391,type,
    v107284: ( state_type * $int ) > $o ).

tff(pred_def_60392,type,
    v107282: ( state_type * $int ) > $o ).

tff(pred_def_60393,type,
    v107280: ( state_type * $int ) > $o ).

tff(pred_def_60394,type,
    v107329: state_type > $o ).

tff(pred_def_60395,type,
    v107327: state_type > $o ).

tff(pred_def_60396,type,
    v107336: state_type > $o ).

tff(pred_def_60397,type,
    v107334: state_type > $o ).

tff(pred_def_60398,type,
    v107333: state_type > $o ).

tff(pred_def_60399,type,
    v107332: state_type > $o ).

tff(pred_def_60400,type,
    v107344: state_type > $o ).

tff(pred_def_60401,type,
    v107345: state_type > $o ).

tff(pred_def_60402,type,
    v107343: state_type > $o ).

tff(pred_def_60403,type,
    v107340: ( state_type * $int ) > $o ).

tff(pred_def_60404,type,
    v107342: ( state_type * $int ) > $o ).

tff(pred_def_60405,type,
    v107270: ( state_type * $int ) > $o ).

tff(pred_def_60406,type,
    v107268: ( state_type * $int ) > $o ).

tff(pred_def_60407,type,
    v107352: state_type > $o ).

tff(pred_def_60408,type,
    v107353: state_type > $o ).

tff(pred_def_60409,type,
    v107351: state_type > $o ).

tff(pred_def_60410,type,
    v107354: state_type > $o ).

tff(pred_def_60411,type,
    v107350: state_type > $o ).

tff(pred_def_60412,type,
    v107355: state_type > $o ).

tff(pred_def_60413,type,
    v106983: state_type > $o ).

tff(pred_def_60414,type,
    v107371: state_type > $o ).

tff(pred_def_60415,type,
    v107369: state_type > $o ).

tff(pred_def_60416,type,
    v107367: state_type > $o ).

tff(pred_def_60417,type,
    v107365: state_type > $o ).

tff(pred_def_60418,type,
    v107379: state_type > $o ).

tff(pred_def_60419,type,
    v107377: state_type > $o ).

tff(pred_def_60420,type,
    v107375: state_type > $o ).

tff(pred_def_60421,type,
    v107373: state_type > $o ).

tff(pred_def_60422,type,
    v107394: state_type > $o ).

tff(pred_def_60423,type,
    v107393: state_type > $o ).

tff(pred_def_60424,type,
    v107396: state_type > $o ).

tff(pred_def_60425,type,
    v107395: state_type > $o ).

tff(pred_def_60426,type,
    v107392: state_type > $o ).

tff(pred_def_60427,type,
    v107398: state_type > $o ).

tff(pred_def_60428,type,
    v107397: state_type > $o ).

tff(pred_def_60429,type,
    v107391: state_type > $o ).

tff(pred_def_60430,type,
    v107400: state_type > $o ).

tff(pred_def_60431,type,
    v107399: state_type > $o ).

tff(pred_def_60432,type,
    v107389: state_type > $o ).

tff(pred_def_60433,type,
    v107402: ( state_type * $int ) > $o ).

tff(pred_def_60434,type,
    v107404: state_type > $o ).

tff(pred_def_60435,type,
    v107359: ( state_type * $int ) > $o ).

tff(pred_def_60436,type,
    v107407: state_type > $o ).

tff(pred_def_60437,type,
    v107418: state_type > $o ).

tff(pred_def_60438,type,
    v107417: state_type > $o ).

tff(pred_def_60439,type,
    v107416: state_type > $o ).

tff(pred_def_60440,type,
    v107419: state_type > $o ).

tff(pred_def_60441,type,
    v107415: state_type > $o ).

tff(pred_def_60442,type,
    v107414: state_type > $o ).

tff(pred_def_60443,type,
    v107413: state_type > $o ).

tff(pred_def_60444,type,
    v107412: state_type > $o ).

tff(pred_def_60445,type,
    v107421: state_type > $o ).

tff(pred_def_60446,type,
    v107420: state_type > $o ).

tff(pred_def_60447,type,
    v107411: state_type > $o ).

tff(pred_def_60448,type,
    v107424: state_type > $o ).

tff(pred_def_60449,type,
    v107423: state_type > $o ).

tff(pred_def_60450,type,
    v107425: state_type > $o ).

tff(pred_def_60451,type,
    v107422: state_type > $o ).

tff(pred_def_60452,type,
    v107428: state_type > $o ).

tff(pred_def_60453,type,
    v107427: state_type > $o ).

tff(pred_def_60454,type,
    v107429: state_type > $o ).

tff(pred_def_60455,type,
    v107426: state_type > $o ).

tff(pred_def_60456,type,
    v107409: ( state_type * $int ) > $o ).

tff(pred_def_60457,type,
    v107408: ( state_type * $int ) > $o ).

tff(pred_def_60458,type,
    v107406: ( state_type * $int ) > $o ).

tff(pred_def_60459,type,
    v107387: ( state_type * $int ) > $o ).

tff(pred_def_60460,type,
    v107385: ( state_type * $int ) > $o ).

tff(pred_def_60461,type,
    v107383: ( state_type * $int ) > $o ).

tff(pred_def_60462,type,
    v107381: ( state_type * $int ) > $o ).

tff(pred_def_60463,type,
    v107435: state_type > $o ).

tff(pred_def_60464,type,
    v107433: state_type > $o ).

tff(pred_def_60465,type,
    v107431: state_type > $o ).

tff(pred_def_60466,type,
    v107442: state_type > $o ).

tff(pred_def_60467,type,
    v107440: state_type > $o ).

tff(pred_def_60468,type,
    v107439: state_type > $o ).

tff(pred_def_60469,type,
    v107438: state_type > $o ).

tff(pred_def_60470,type,
    v107450: state_type > $o ).

tff(pred_def_60471,type,
    v107451: state_type > $o ).

tff(pred_def_60472,type,
    v107449: state_type > $o ).

tff(pred_def_60473,type,
    v107446: ( state_type * $int ) > $o ).

tff(pred_def_60474,type,
    v107448: ( state_type * $int ) > $o ).

tff(pred_def_60475,type,
    v107363: ( state_type * $int ) > $o ).

tff(pred_def_60476,type,
    v107361: ( state_type * $int ) > $o ).

tff(pred_def_60477,type,
    v107357: state_type > $o ).

tff(pred_def_60478,type,
    v107466: state_type > $o ).

tff(pred_def_60479,type,
    v107464: state_type > $o ).

tff(pred_def_60480,type,
    v107470: state_type > $o ).

tff(pred_def_60481,type,
    v107468: state_type > $o ).

tff(pred_def_60482,type,
    v107488: state_type > $o ).

tff(pred_def_60483,type,
    v107486: state_type > $o ).

tff(pred_def_60484,type,
    v107492: state_type > $o ).

tff(pred_def_60485,type,
    v107490: state_type > $o ).

tff(pred_def_60486,type,
    v107503: state_type > $o ).

tff(pred_def_60487,type,
    v107502: state_type > $o ).

tff(pred_def_60488,type,
    v107505: state_type > $o ).

tff(pred_def_60489,type,
    v107504: state_type > $o ).

tff(pred_def_60490,type,
    v107500: state_type > $o ).

tff(pred_def_60491,type,
    v107506: ( state_type * $int ) > $o ).

tff(pred_def_60492,type,
    v107507: state_type > $o ).

tff(pred_def_60493,type,
    v107498: ( state_type * $int ) > $o ).

tff(pred_def_60494,type,
    v107496: ( state_type * $int ) > $o ).

tff(pred_def_60495,type,
    v107494: ( state_type * $int ) > $o ).

tff(pred_def_60496,type,
    v107511: state_type > $o ).

tff(pred_def_60497,type,
    v107509: state_type > $o ).

tff(pred_def_60498,type,
    v107518: state_type > $o ).

tff(pred_def_60499,type,
    v107516: state_type > $o ).

tff(pred_def_60500,type,
    v107515: state_type > $o ).

tff(pred_def_60501,type,
    v107514: state_type > $o ).

tff(pred_def_60502,type,
    v107526: state_type > $o ).

tff(pred_def_60503,type,
    v107527: state_type > $o ).

tff(pred_def_60504,type,
    v107525: state_type > $o ).

tff(pred_def_60505,type,
    v107522: ( state_type * $int ) > $o ).

tff(pred_def_60506,type,
    v107524: ( state_type * $int ) > $o ).

tff(pred_def_60507,type,
    v107513: ( state_type * $int ) > $o ).

tff(pred_def_60508,type,
    v107484: ( state_type * $int ) > $o ).

tff(pred_def_60509,type,
    v107482: ( state_type * $int ) > $o ).

tff(pred_def_60510,type,
    v107480: state_type > $o ).

tff(pred_def_60511,type,
    v107535: state_type > $o ).

tff(pred_def_60512,type,
    v107534: state_type > $o ).

tff(pred_def_60513,type,
    v107537: state_type > $o ).

tff(pred_def_60514,type,
    v107536: state_type > $o ).

tff(pred_def_60515,type,
    v107543: state_type > $o ).

tff(pred_def_60516,type,
    v107541: state_type > $o ).

tff(pred_def_60517,type,
    v107540: state_type > $o ).

tff(pred_def_60518,type,
    v107539: ( state_type * $int ) > $o ).

tff(pred_def_60519,type,
    v107531: state_type > $o ).

tff(pred_def_60520,type,
    v107547: state_type > $o ).

tff(pred_def_60521,type,
    v107549: state_type > $o ).

tff(pred_def_60522,type,
    v107458: ( state_type * $int ) > $o ).

tff(pred_def_60523,type,
    v107551: state_type > $o ).

tff(pred_def_60524,type,
    v107556: state_type > $o ).

tff(pred_def_60525,type,
    v107555: state_type > $o ).

tff(pred_def_60526,type,
    v107558: state_type > $o ).

tff(pred_def_60527,type,
    v107557: state_type > $o ).

tff(pred_def_60528,type,
    v107554: state_type > $o ).

tff(pred_def_60529,type,
    v107552: ( state_type * $int ) > $o ).

tff(pred_def_60530,type,
    v107550: ( state_type * $int ) > $o ).

tff(pred_def_60531,type,
    v107548: ( state_type * $int ) > $o ).

tff(pred_def_60532,type,
    v107478: ( state_type * $int ) > $o ).

tff(pred_def_60533,type,
    v107476: ( state_type * $int ) > $o ).

tff(pred_def_60534,type,
    v107474: ( state_type * $int ) > $o ).

tff(pred_def_60535,type,
    v107472: ( state_type * $int ) > $o ).

tff(pred_def_60536,type,
    v107562: state_type > $o ).

tff(pred_def_60537,type,
    v107560: state_type > $o ).

tff(pred_def_60538,type,
    v107569: state_type > $o ).

tff(pred_def_60539,type,
    v107567: state_type > $o ).

tff(pred_def_60540,type,
    v107566: state_type > $o ).

tff(pred_def_60541,type,
    v107565: state_type > $o ).

tff(pred_def_60542,type,
    v107577: state_type > $o ).

tff(pred_def_60543,type,
    v107578: state_type > $o ).

tff(pred_def_60544,type,
    v107576: state_type > $o ).

tff(pred_def_60545,type,
    v107573: ( state_type * $int ) > $o ).

tff(pred_def_60546,type,
    v107575: ( state_type * $int ) > $o ).

tff(pred_def_60547,type,
    v107462: ( state_type * $int ) > $o ).

tff(pred_def_60548,type,
    v107460: ( state_type * $int ) > $o ).

tff(pred_def_60549,type,
    v107456: state_type > $o ).

tff(pred_def_60550,type,
    v107593: state_type > $o ).

tff(pred_def_60551,type,
    v107591: state_type > $o ).

tff(pred_def_60552,type,
    v107597: state_type > $o ).

tff(pred_def_60553,type,
    v107595: state_type > $o ).

tff(pred_def_60554,type,
    v107607: state_type > $o ).

tff(pred_def_60555,type,
    v107610: ( state_type * $int ) > $o ).

tff(pred_def_60556,type,
    v107583: state_type > $o ).

tff(pred_def_60557,type,
    v107612: state_type > $o ).

tff(pred_def_60558,type,
    v107622: state_type > $o ).

tff(pred_def_60559,type,
    v107621: state_type > $o ).

tff(pred_def_60560,type,
    v107620: state_type > $o ).

tff(pred_def_60561,type,
    v107623: state_type > $o ).

tff(pred_def_60562,type,
    v107619: state_type > $o ).

tff(pred_def_60563,type,
    v107618: state_type > $o ).

tff(pred_def_60564,type,
    v107617: state_type > $o ).

tff(pred_def_60565,type,
    v107616: state_type > $o ).

tff(pred_def_60566,type,
    v107625: state_type > $o ).

tff(pred_def_60567,type,
    v107624: state_type > $o ).

tff(pred_def_60568,type,
    v107615: state_type > $o ).

tff(pred_def_60569,type,
    v107628: state_type > $o ).

tff(pred_def_60570,type,
    v107627: state_type > $o ).

tff(pred_def_60571,type,
    v107629: state_type > $o ).

tff(pred_def_60572,type,
    v107626: state_type > $o ).

tff(pred_def_60573,type,
    v107632: state_type > $o ).

tff(pred_def_60574,type,
    v107631: state_type > $o ).

tff(pred_def_60575,type,
    v107633: state_type > $o ).

tff(pred_def_60576,type,
    v107630: state_type > $o ).

tff(pred_def_60577,type,
    v107613: ( state_type * $int ) > $o ).

tff(pred_def_60578,type,
    v107635: state_type > $o ).

tff(pred_def_60579,type,
    v107585: ( state_type * $int ) > $o ).

tff(pred_def_60580,type,
    v107637: state_type > $o ).

tff(pred_def_60581,type,
    v107648: state_type > $o ).

tff(pred_def_60582,type,
    v107647: state_type > $o ).

tff(pred_def_60583,type,
    v107646: state_type > $o ).

tff(pred_def_60584,type,
    v107649: state_type > $o ).

tff(pred_def_60585,type,
    v107645: state_type > $o ).

tff(pred_def_60586,type,
    v107644: state_type > $o ).

tff(pred_def_60587,type,
    v107643: state_type > $o ).

tff(pred_def_60588,type,
    v107642: state_type > $o ).

tff(pred_def_60589,type,
    v107651: state_type > $o ).

tff(pred_def_60590,type,
    v107650: state_type > $o ).

tff(pred_def_60591,type,
    v107641: state_type > $o ).

tff(pred_def_60592,type,
    v107654: state_type > $o ).

tff(pred_def_60593,type,
    v107653: state_type > $o ).

tff(pred_def_60594,type,
    v107655: state_type > $o ).

tff(pred_def_60595,type,
    v107652: state_type > $o ).

tff(pred_def_60596,type,
    v107658: state_type > $o ).

tff(pred_def_60597,type,
    v107657: state_type > $o ).

tff(pred_def_60598,type,
    v107659: state_type > $o ).

tff(pred_def_60599,type,
    v107656: state_type > $o ).

tff(pred_def_60600,type,
    v107639: ( state_type * $int ) > $o ).

tff(pred_def_60601,type,
    v107638: ( state_type * $int ) > $o ).

tff(pred_def_60602,type,
    v107636: ( state_type * $int ) > $o ).

tff(pred_def_60603,type,
    v107634: ( state_type * $int ) > $o ).

tff(pred_def_60604,type,
    v107605: ( state_type * $int ) > $o ).

tff(pred_def_60605,type,
    v107603: ( state_type * $int ) > $o ).

tff(pred_def_60606,type,
    v107601: ( state_type * $int ) > $o ).

tff(pred_def_60607,type,
    v107599: ( state_type * $int ) > $o ).

tff(pred_def_60608,type,
    v107663: state_type > $o ).

tff(pred_def_60609,type,
    v107661: state_type > $o ).

tff(pred_def_60610,type,
    v107670: state_type > $o ).

tff(pred_def_60611,type,
    v107668: state_type > $o ).

tff(pred_def_60612,type,
    v107667: state_type > $o ).

tff(pred_def_60613,type,
    v107666: state_type > $o ).

tff(pred_def_60614,type,
    v107678: state_type > $o ).

tff(pred_def_60615,type,
    v107679: state_type > $o ).

tff(pred_def_60616,type,
    v107677: state_type > $o ).

tff(pred_def_60617,type,
    v107674: ( state_type * $int ) > $o ).

tff(pred_def_60618,type,
    v107676: ( state_type * $int ) > $o ).

tff(pred_def_60619,type,
    v107589: ( state_type * $int ) > $o ).

tff(pred_def_60620,type,
    v107587: ( state_type * $int ) > $o ).

tff(pred_def_60621,type,
    v107696: state_type > $o ).

tff(pred_def_60622,type,
    v107694: state_type > $o ).

tff(pred_def_60623,type,
    v107700: state_type > $o ).

tff(pred_def_60624,type,
    v107698: state_type > $o ).

tff(pred_def_60625,type,
    v107712: state_type > $o ).

tff(pred_def_60626,type,
    v107710: state_type > $o ).

tff(pred_def_60627,type,
    v107714: ( state_type * $int ) > $o ).

tff(pred_def_60628,type,
    v107686: state_type > $o ).

tff(pred_def_60629,type,
    v107717: state_type > $o ).

tff(pred_def_60630,type,
    v107716: state_type > $o ).

tff(pred_def_60631,type,
    v107729: state_type > $o ).

tff(pred_def_60632,type,
    v107728: state_type > $o ).

tff(pred_def_60633,type,
    v107727: state_type > $o ).

tff(pred_def_60634,type,
    v107730: state_type > $o ).

tff(pred_def_60635,type,
    v107726: state_type > $o ).

tff(pred_def_60636,type,
    v107725: state_type > $o ).

tff(pred_def_60637,type,
    v107731: state_type > $o ).

tff(pred_def_60638,type,
    v107724: state_type > $o ).

tff(pred_def_60639,type,
    v107723: state_type > $o ).

tff(pred_def_60640,type,
    v107722: state_type > $o ).

tff(pred_def_60641,type,
    v107721: state_type > $o ).

tff(pred_def_60642,type,
    v107733: state_type > $o ).

tff(pred_def_60643,type,
    v107732: state_type > $o ).

tff(pred_def_60644,type,
    v107720: state_type > $o ).

tff(pred_def_60645,type,
    v107736: state_type > $o ).

tff(pred_def_60646,type,
    v107735: state_type > $o ).

tff(pred_def_60647,type,
    v107737: state_type > $o ).

tff(pred_def_60648,type,
    v107734: state_type > $o ).

tff(pred_def_60649,type,
    v107740: state_type > $o ).

tff(pred_def_60650,type,
    v107739: state_type > $o ).

tff(pred_def_60651,type,
    v107741: state_type > $o ).

tff(pred_def_60652,type,
    v107738: state_type > $o ).

tff(pred_def_60653,type,
    v107744: state_type > $o ).

tff(pred_def_60654,type,
    v107743: state_type > $o ).

tff(pred_def_60655,type,
    v107745: state_type > $o ).

tff(pred_def_60656,type,
    v107742: state_type > $o ).

tff(pred_def_60657,type,
    v107718: ( state_type * $int ) > $o ).

tff(pred_def_60658,type,
    v107688: ( state_type * $int ) > $o ).

tff(pred_def_60659,type,
    v107758: state_type > $o ).

tff(pred_def_60660,type,
    v107757: state_type > $o ).

tff(pred_def_60661,type,
    v107756: state_type > $o ).

tff(pred_def_60662,type,
    v107759: state_type > $o ).

tff(pred_def_60663,type,
    v107755: state_type > $o ).

tff(pred_def_60664,type,
    v107754: state_type > $o ).

tff(pred_def_60665,type,
    v107760: state_type > $o ).

tff(pred_def_60666,type,
    v107753: state_type > $o ).

tff(pred_def_60667,type,
    v107752: state_type > $o ).

tff(pred_def_60668,type,
    v107751: state_type > $o ).

tff(pred_def_60669,type,
    v107750: state_type > $o ).

tff(pred_def_60670,type,
    v107762: state_type > $o ).

tff(pred_def_60671,type,
    v107761: state_type > $o ).

tff(pred_def_60672,type,
    v107749: state_type > $o ).

tff(pred_def_60673,type,
    v107765: state_type > $o ).

tff(pred_def_60674,type,
    v107764: state_type > $o ).

tff(pred_def_60675,type,
    v107766: state_type > $o ).

tff(pred_def_60676,type,
    v107763: state_type > $o ).

tff(pred_def_60677,type,
    v107769: state_type > $o ).

tff(pred_def_60678,type,
    v107768: state_type > $o ).

tff(pred_def_60679,type,
    v107770: state_type > $o ).

tff(pred_def_60680,type,
    v107767: state_type > $o ).

tff(pred_def_60681,type,
    v107773: state_type > $o ).

tff(pred_def_60682,type,
    v107772: state_type > $o ).

tff(pred_def_60683,type,
    v107774: state_type > $o ).

tff(pred_def_60684,type,
    v107771: state_type > $o ).

tff(pred_def_60685,type,
    v107747: ( state_type * $int ) > $o ).

tff(pred_def_60686,type,
    v107746: ( state_type * $int ) > $o ).

tff(pred_def_60687,type,
    v107708: ( state_type * $int ) > $o ).

tff(pred_def_60688,type,
    v107706: ( state_type * $int ) > $o ).

tff(pred_def_60689,type,
    v107704: ( state_type * $int ) > $o ).

tff(pred_def_60690,type,
    v107702: ( state_type * $int ) > $o ).

tff(pred_def_60691,type,
    v107778: state_type > $o ).

tff(pred_def_60692,type,
    v107776: state_type > $o ).

tff(pred_def_60693,type,
    v107785: state_type > $o ).

tff(pred_def_60694,type,
    v107783: state_type > $o ).

tff(pred_def_60695,type,
    v107782: state_type > $o ).

tff(pred_def_60696,type,
    v107781: state_type > $o ).

tff(pred_def_60697,type,
    v107793: state_type > $o ).

tff(pred_def_60698,type,
    v107794: state_type > $o ).

tff(pred_def_60699,type,
    v107792: state_type > $o ).

tff(pred_def_60700,type,
    v107789: ( state_type * $int ) > $o ).

tff(pred_def_60701,type,
    v107791: ( state_type * $int ) > $o ).

tff(pred_def_60702,type,
    v107692: ( state_type * $int ) > $o ).

tff(pred_def_60703,type,
    v107690: ( state_type * $int ) > $o ).

tff(pred_def_60704,type,
    v107809: state_type > $o ).

tff(pred_def_60705,type,
    v107807: state_type > $o ).

tff(pred_def_60706,type,
    v107813: state_type > $o ).

tff(pred_def_60707,type,
    v107811: state_type > $o ).

tff(pred_def_60708,type,
    v107826: state_type > $o ).

tff(pred_def_60709,type,
    v107799: state_type > $o ).

tff(pred_def_60710,type,
    v107825: state_type > $o ).

tff(pred_def_60711,type,
    v107824: state_type > $o ).

tff(pred_def_60712,type,
    v107823: state_type > $o ).

tff(pred_def_60713,type,
    v107827: ( state_type * $int ) > $o ).

tff(pred_def_60714,type,
    v107801: ( state_type * $int ) > $o ).

tff(pred_def_60715,type,
    v107840: state_type > $o ).

tff(pred_def_60716,type,
    v107839: state_type > $o ).

tff(pred_def_60717,type,
    v107838: state_type > $o ).

tff(pred_def_60718,type,
    v107841: state_type > $o ).

tff(pred_def_60719,type,
    v107837: state_type > $o ).

tff(pred_def_60720,type,
    v107836: state_type > $o ).

tff(pred_def_60721,type,
    v107842: state_type > $o ).

tff(pred_def_60722,type,
    v107835: state_type > $o ).

tff(pred_def_60723,type,
    v107834: state_type > $o ).

tff(pred_def_60724,type,
    v107833: state_type > $o ).

tff(pred_def_60725,type,
    v107832: state_type > $o ).

tff(pred_def_60726,type,
    v107844: state_type > $o ).

tff(pred_def_60727,type,
    v107843: state_type > $o ).

tff(pred_def_60728,type,
    v107831: state_type > $o ).

tff(pred_def_60729,type,
    v107847: state_type > $o ).

tff(pred_def_60730,type,
    v107846: state_type > $o ).

tff(pred_def_60731,type,
    v107848: state_type > $o ).

tff(pred_def_60732,type,
    v107845: state_type > $o ).

tff(pred_def_60733,type,
    v107851: state_type > $o ).

tff(pred_def_60734,type,
    v107850: state_type > $o ).

tff(pred_def_60735,type,
    v107852: state_type > $o ).

tff(pred_def_60736,type,
    v107849: state_type > $o ).

tff(pred_def_60737,type,
    v107855: state_type > $o ).

tff(pred_def_60738,type,
    v107854: state_type > $o ).

tff(pred_def_60739,type,
    v107856: state_type > $o ).

tff(pred_def_60740,type,
    v107853: state_type > $o ).

tff(pred_def_60741,type,
    v107829: ( state_type * $int ) > $o ).

tff(pred_def_60742,type,
    v107828: ( state_type * $int ) > $o ).

tff(pred_def_60743,type,
    v107821: ( state_type * $int ) > $o ).

tff(pred_def_60744,type,
    v107819: ( state_type * $int ) > $o ).

tff(pred_def_60745,type,
    v107817: ( state_type * $int ) > $o ).

tff(pred_def_60746,type,
    v107815: ( state_type * $int ) > $o ).

tff(pred_def_60747,type,
    v107860: state_type > $o ).

tff(pred_def_60748,type,
    v107858: state_type > $o ).

tff(pred_def_60749,type,
    v107867: state_type > $o ).

tff(pred_def_60750,type,
    v107865: state_type > $o ).

tff(pred_def_60751,type,
    v107864: state_type > $o ).

tff(pred_def_60752,type,
    v107863: state_type > $o ).

tff(pred_def_60753,type,
    v107875: state_type > $o ).

tff(pred_def_60754,type,
    v107876: state_type > $o ).

tff(pred_def_60755,type,
    v107874: state_type > $o ).

tff(pred_def_60756,type,
    v107871: ( state_type * $int ) > $o ).

tff(pred_def_60757,type,
    v107873: ( state_type * $int ) > $o ).

tff(pred_def_60758,type,
    v107805: ( state_type * $int ) > $o ).

tff(pred_def_60759,type,
    v107803: ( state_type * $int ) > $o ).

tff(pred_def_60760,type,
    v107891: state_type > $o ).

tff(pred_def_60761,type,
    v107889: state_type > $o ).

tff(pred_def_60762,type,
    v107895: state_type > $o ).

tff(pred_def_60763,type,
    v107893: state_type > $o ).

tff(pred_def_60764,type,
    v107909: state_type > $o ).

tff(pred_def_60765,type,
    v107881: state_type > $o ).

tff(pred_def_60766,type,
    v107908: state_type > $o ).

tff(pred_def_60767,type,
    v107910: state_type > $o ).

tff(pred_def_60768,type,
    v107907: state_type > $o ).

tff(pred_def_60769,type,
    v107906: state_type > $o ).

tff(pred_def_60770,type,
    v107905: state_type > $o ).

tff(pred_def_60771,type,
    v107911: ( state_type * $int ) > $o ).

tff(pred_def_60772,type,
    v107883: ( state_type * $int ) > $o ).

tff(pred_def_60773,type,
    v107924: state_type > $o ).

tff(pred_def_60774,type,
    v107923: state_type > $o ).

tff(pred_def_60775,type,
    v107922: state_type > $o ).

tff(pred_def_60776,type,
    v107925: state_type > $o ).

tff(pred_def_60777,type,
    v107921: state_type > $o ).

tff(pred_def_60778,type,
    v107920: state_type > $o ).

tff(pred_def_60779,type,
    v107926: state_type > $o ).

tff(pred_def_60780,type,
    v107919: state_type > $o ).

tff(pred_def_60781,type,
    v107918: state_type > $o ).

tff(pred_def_60782,type,
    v107917: state_type > $o ).

tff(pred_def_60783,type,
    v107916: state_type > $o ).

tff(pred_def_60784,type,
    v107928: state_type > $o ).

tff(pred_def_60785,type,
    v107927: state_type > $o ).

tff(pred_def_60786,type,
    v107915: state_type > $o ).

tff(pred_def_60787,type,
    v107931: state_type > $o ).

tff(pred_def_60788,type,
    v107930: state_type > $o ).

tff(pred_def_60789,type,
    v107932: state_type > $o ).

tff(pred_def_60790,type,
    v107929: state_type > $o ).

tff(pred_def_60791,type,
    v107935: state_type > $o ).

tff(pred_def_60792,type,
    v107934: state_type > $o ).

tff(pred_def_60793,type,
    v107936: state_type > $o ).

tff(pred_def_60794,type,
    v107933: state_type > $o ).

tff(pred_def_60795,type,
    v107939: state_type > $o ).

tff(pred_def_60796,type,
    v107938: state_type > $o ).

tff(pred_def_60797,type,
    v107940: state_type > $o ).

tff(pred_def_60798,type,
    v107937: state_type > $o ).

tff(pred_def_60799,type,
    v107913: ( state_type * $int ) > $o ).

tff(pred_def_60800,type,
    v107912: ( state_type * $int ) > $o ).

tff(pred_def_60801,type,
    v107903: ( state_type * $int ) > $o ).

tff(pred_def_60802,type,
    v107901: ( state_type * $int ) > $o ).

tff(pred_def_60803,type,
    v107899: ( state_type * $int ) > $o ).

tff(pred_def_60804,type,
    v107897: ( state_type * $int ) > $o ).

tff(pred_def_60805,type,
    v107944: state_type > $o ).

tff(pred_def_60806,type,
    v107942: state_type > $o ).

tff(pred_def_60807,type,
    v107951: state_type > $o ).

tff(pred_def_60808,type,
    v107949: state_type > $o ).

tff(pred_def_60809,type,
    v107948: state_type > $o ).

tff(pred_def_60810,type,
    v107947: state_type > $o ).

tff(pred_def_60811,type,
    v107959: state_type > $o ).

tff(pred_def_60812,type,
    v107960: state_type > $o ).

tff(pred_def_60813,type,
    v107958: state_type > $o ).

tff(pred_def_60814,type,
    v107955: ( state_type * $int ) > $o ).

tff(pred_def_60815,type,
    v107957: ( state_type * $int ) > $o ).

tff(pred_def_60816,type,
    v107887: ( state_type * $int ) > $o ).

tff(pred_def_60817,type,
    v107885: ( state_type * $int ) > $o ).

tff(pred_def_60818,type,
    v107975: state_type > $o ).

tff(pred_def_60819,type,
    v107973: state_type > $o ).

tff(pred_def_60820,type,
    v107979: state_type > $o ).

tff(pred_def_60821,type,
    v107977: state_type > $o ).

tff(pred_def_60822,type,
    v107994: state_type > $o ).

tff(pred_def_60823,type,
    v107965: state_type > $o ).

tff(pred_def_60824,type,
    v107993: state_type > $o ).

tff(pred_def_60825,type,
    v107995: state_type > $o ).

tff(pred_def_60826,type,
    v107992: state_type > $o ).

tff(pred_def_60827,type,
    v107996: state_type > $o ).

tff(pred_def_60828,type,
    v107991: state_type > $o ).

tff(pred_def_60829,type,
    v107990: state_type > $o ).

tff(pred_def_60830,type,
    v107989: state_type > $o ).

tff(pred_def_60831,type,
    v107997: ( state_type * $int ) > $o ).

tff(pred_def_60832,type,
    v107967: ( state_type * $int ) > $o ).

tff(pred_def_60833,type,
    v108010: state_type > $o ).

tff(pred_def_60834,type,
    v108009: state_type > $o ).

tff(pred_def_60835,type,
    v108008: state_type > $o ).

tff(pred_def_60836,type,
    v108011: state_type > $o ).

tff(pred_def_60837,type,
    v108007: state_type > $o ).

tff(pred_def_60838,type,
    v108006: state_type > $o ).

tff(pred_def_60839,type,
    v108012: state_type > $o ).

tff(pred_def_60840,type,
    v108005: state_type > $o ).

tff(pred_def_60841,type,
    v108004: state_type > $o ).

tff(pred_def_60842,type,
    v108003: state_type > $o ).

tff(pred_def_60843,type,
    v108002: state_type > $o ).

tff(pred_def_60844,type,
    v108014: state_type > $o ).

tff(pred_def_60845,type,
    v108013: state_type > $o ).

tff(pred_def_60846,type,
    v108001: state_type > $o ).

tff(pred_def_60847,type,
    v108017: state_type > $o ).

tff(pred_def_60848,type,
    v108016: state_type > $o ).

tff(pred_def_60849,type,
    v108018: state_type > $o ).

tff(pred_def_60850,type,
    v108015: state_type > $o ).

tff(pred_def_60851,type,
    v108021: state_type > $o ).

tff(pred_def_60852,type,
    v108020: state_type > $o ).

tff(pred_def_60853,type,
    v108022: state_type > $o ).

tff(pred_def_60854,type,
    v108019: state_type > $o ).

tff(pred_def_60855,type,
    v108025: state_type > $o ).

tff(pred_def_60856,type,
    v108024: state_type > $o ).

tff(pred_def_60857,type,
    v108026: state_type > $o ).

tff(pred_def_60858,type,
    v108023: state_type > $o ).

tff(pred_def_60859,type,
    v107999: ( state_type * $int ) > $o ).

tff(pred_def_60860,type,
    v107998: ( state_type * $int ) > $o ).

tff(pred_def_60861,type,
    v107987: ( state_type * $int ) > $o ).

tff(pred_def_60862,type,
    v107985: ( state_type * $int ) > $o ).

tff(pred_def_60863,type,
    v107983: ( state_type * $int ) > $o ).

tff(pred_def_60864,type,
    v107981: ( state_type * $int ) > $o ).

tff(pred_def_60865,type,
    v108030: state_type > $o ).

tff(pred_def_60866,type,
    v108028: state_type > $o ).

tff(pred_def_60867,type,
    v108037: state_type > $o ).

tff(pred_def_60868,type,
    v108035: state_type > $o ).

tff(pred_def_60869,type,
    v108034: state_type > $o ).

tff(pred_def_60870,type,
    v108033: state_type > $o ).

tff(pred_def_60871,type,
    v108045: state_type > $o ).

tff(pred_def_60872,type,
    v108046: state_type > $o ).

tff(pred_def_60873,type,
    v108044: state_type > $o ).

tff(pred_def_60874,type,
    v108041: ( state_type * $int ) > $o ).

tff(pred_def_60875,type,
    v108043: ( state_type * $int ) > $o ).

tff(pred_def_60876,type,
    v107971: ( state_type * $int ) > $o ).

tff(pred_def_60877,type,
    v107969: ( state_type * $int ) > $o ).

tff(pred_def_60878,type,
    v108053: state_type > $o ).

tff(pred_def_60879,type,
    v108054: state_type > $o ).

tff(pred_def_60880,type,
    v108052: state_type > $o ).

tff(pred_def_60881,type,
    v108055: state_type > $o ).

tff(pred_def_60882,type,
    v108051: state_type > $o ).

tff(pred_def_60883,type,
    v108056: state_type > $o ).

tff(pred_def_60884,type,
    v107684: state_type > $o ).

tff(pred_def_60885,type,
    v108072: state_type > $o ).

tff(pred_def_60886,type,
    v108070: state_type > $o ).

tff(pred_def_60887,type,
    v108068: state_type > $o ).

tff(pred_def_60888,type,
    v108066: state_type > $o ).

tff(pred_def_60889,type,
    v108080: state_type > $o ).

tff(pred_def_60890,type,
    v108078: state_type > $o ).

tff(pred_def_60891,type,
    v108076: state_type > $o ).

tff(pred_def_60892,type,
    v108074: state_type > $o ).

tff(pred_def_60893,type,
    v108095: state_type > $o ).

tff(pred_def_60894,type,
    v108094: state_type > $o ).

tff(pred_def_60895,type,
    v108097: state_type > $o ).

tff(pred_def_60896,type,
    v108096: state_type > $o ).

tff(pred_def_60897,type,
    v108093: state_type > $o ).

tff(pred_def_60898,type,
    v108099: state_type > $o ).

tff(pred_def_60899,type,
    v108098: state_type > $o ).

tff(pred_def_60900,type,
    v108092: state_type > $o ).

tff(pred_def_60901,type,
    v108101: state_type > $o ).

tff(pred_def_60902,type,
    v108100: state_type > $o ).

tff(pred_def_60903,type,
    v108090: state_type > $o ).

tff(pred_def_60904,type,
    v108103: ( state_type * $int ) > $o ).

tff(pred_def_60905,type,
    v108105: state_type > $o ).

tff(pred_def_60906,type,
    v108060: ( state_type * $int ) > $o ).

tff(pred_def_60907,type,
    v108108: state_type > $o ).

tff(pred_def_60908,type,
    v108119: state_type > $o ).

tff(pred_def_60909,type,
    v108118: state_type > $o ).

tff(pred_def_60910,type,
    v108117: state_type > $o ).

tff(pred_def_60911,type,
    v108120: state_type > $o ).

tff(pred_def_60912,type,
    v108116: state_type > $o ).

tff(pred_def_60913,type,
    v108115: state_type > $o ).

tff(pred_def_60914,type,
    v108114: state_type > $o ).

tff(pred_def_60915,type,
    v108113: state_type > $o ).

tff(pred_def_60916,type,
    v108122: state_type > $o ).

tff(pred_def_60917,type,
    v108121: state_type > $o ).

tff(pred_def_60918,type,
    v108112: state_type > $o ).

tff(pred_def_60919,type,
    v108125: state_type > $o ).

tff(pred_def_60920,type,
    v108124: state_type > $o ).

tff(pred_def_60921,type,
    v108126: state_type > $o ).

tff(pred_def_60922,type,
    v108123: state_type > $o ).

tff(pred_def_60923,type,
    v108129: state_type > $o ).

tff(pred_def_60924,type,
    v108128: state_type > $o ).

tff(pred_def_60925,type,
    v108130: state_type > $o ).

tff(pred_def_60926,type,
    v108127: state_type > $o ).

tff(pred_def_60927,type,
    v108110: ( state_type * $int ) > $o ).

tff(pred_def_60928,type,
    v108109: ( state_type * $int ) > $o ).

tff(pred_def_60929,type,
    v108107: ( state_type * $int ) > $o ).

tff(pred_def_60930,type,
    v108088: ( state_type * $int ) > $o ).

tff(pred_def_60931,type,
    v108086: ( state_type * $int ) > $o ).

tff(pred_def_60932,type,
    v108084: ( state_type * $int ) > $o ).

tff(pred_def_60933,type,
    v108082: ( state_type * $int ) > $o ).

tff(pred_def_60934,type,
    v108136: state_type > $o ).

tff(pred_def_60935,type,
    v108134: state_type > $o ).

tff(pred_def_60936,type,
    v108132: state_type > $o ).

tff(pred_def_60937,type,
    v108143: state_type > $o ).

tff(pred_def_60938,type,
    v108141: state_type > $o ).

tff(pred_def_60939,type,
    v108140: state_type > $o ).

tff(pred_def_60940,type,
    v108139: state_type > $o ).

tff(pred_def_60941,type,
    v108151: state_type > $o ).

tff(pred_def_60942,type,
    v108152: state_type > $o ).

tff(pred_def_60943,type,
    v108150: state_type > $o ).

tff(pred_def_60944,type,
    v108147: ( state_type * $int ) > $o ).

tff(pred_def_60945,type,
    v108149: ( state_type * $int ) > $o ).

tff(pred_def_60946,type,
    v108064: ( state_type * $int ) > $o ).

tff(pred_def_60947,type,
    v108062: ( state_type * $int ) > $o ).

tff(pred_def_60948,type,
    v108058: state_type > $o ).

tff(pred_def_60949,type,
    v108167: state_type > $o ).

tff(pred_def_60950,type,
    v108165: state_type > $o ).

tff(pred_def_60951,type,
    v108171: state_type > $o ).

tff(pred_def_60952,type,
    v108169: state_type > $o ).

tff(pred_def_60953,type,
    v108189: state_type > $o ).

tff(pred_def_60954,type,
    v108187: state_type > $o ).

tff(pred_def_60955,type,
    v108193: state_type > $o ).

tff(pred_def_60956,type,
    v108191: state_type > $o ).

tff(pred_def_60957,type,
    v108204: state_type > $o ).

tff(pred_def_60958,type,
    v108203: state_type > $o ).

tff(pred_def_60959,type,
    v108206: state_type > $o ).

tff(pred_def_60960,type,
    v108205: state_type > $o ).

tff(pred_def_60961,type,
    v108201: state_type > $o ).

tff(pred_def_60962,type,
    v108207: ( state_type * $int ) > $o ).

tff(pred_def_60963,type,
    v108208: state_type > $o ).

tff(pred_def_60964,type,
    v108199: ( state_type * $int ) > $o ).

tff(pred_def_60965,type,
    v108197: ( state_type * $int ) > $o ).

tff(pred_def_60966,type,
    v108195: ( state_type * $int ) > $o ).

tff(pred_def_60967,type,
    v108212: state_type > $o ).

tff(pred_def_60968,type,
    v108210: state_type > $o ).

tff(pred_def_60969,type,
    v108219: state_type > $o ).

tff(pred_def_60970,type,
    v108217: state_type > $o ).

tff(pred_def_60971,type,
    v108216: state_type > $o ).

tff(pred_def_60972,type,
    v108215: state_type > $o ).

tff(pred_def_60973,type,
    v108227: state_type > $o ).

tff(pred_def_60974,type,
    v108228: state_type > $o ).

tff(pred_def_60975,type,
    v108226: state_type > $o ).

tff(pred_def_60976,type,
    v108223: ( state_type * $int ) > $o ).

tff(pred_def_60977,type,
    v108225: ( state_type * $int ) > $o ).

tff(pred_def_60978,type,
    v108214: ( state_type * $int ) > $o ).

tff(pred_def_60979,type,
    v108185: ( state_type * $int ) > $o ).

tff(pred_def_60980,type,
    v108183: ( state_type * $int ) > $o ).

tff(pred_def_60981,type,
    v108181: state_type > $o ).

tff(pred_def_60982,type,
    v108236: state_type > $o ).

tff(pred_def_60983,type,
    v108235: state_type > $o ).

tff(pred_def_60984,type,
    v108238: state_type > $o ).

tff(pred_def_60985,type,
    v108237: state_type > $o ).

tff(pred_def_60986,type,
    v108244: state_type > $o ).

tff(pred_def_60987,type,
    v108242: state_type > $o ).

tff(pred_def_60988,type,
    v108241: state_type > $o ).

tff(pred_def_60989,type,
    v108240: ( state_type * $int ) > $o ).

tff(pred_def_60990,type,
    v108232: state_type > $o ).

tff(pred_def_60991,type,
    v108248: state_type > $o ).

tff(pred_def_60992,type,
    v108250: state_type > $o ).

tff(pred_def_60993,type,
    v108159: ( state_type * $int ) > $o ).

tff(pred_def_60994,type,
    v108252: state_type > $o ).

tff(pred_def_60995,type,
    v108257: state_type > $o ).

tff(pred_def_60996,type,
    v108256: state_type > $o ).

tff(pred_def_60997,type,
    v108259: state_type > $o ).

tff(pred_def_60998,type,
    v108258: state_type > $o ).

tff(pred_def_60999,type,
    v108255: state_type > $o ).

tff(pred_def_61000,type,
    v108253: ( state_type * $int ) > $o ).

tff(pred_def_61001,type,
    v108251: ( state_type * $int ) > $o ).

tff(pred_def_61002,type,
    v108249: ( state_type * $int ) > $o ).

tff(pred_def_61003,type,
    v108179: ( state_type * $int ) > $o ).

tff(pred_def_61004,type,
    v108177: ( state_type * $int ) > $o ).

tff(pred_def_61005,type,
    v108175: ( state_type * $int ) > $o ).

tff(pred_def_61006,type,
    v108173: ( state_type * $int ) > $o ).

tff(pred_def_61007,type,
    v108263: state_type > $o ).

tff(pred_def_61008,type,
    v108261: state_type > $o ).

tff(pred_def_61009,type,
    v108270: state_type > $o ).

tff(pred_def_61010,type,
    v108268: state_type > $o ).

tff(pred_def_61011,type,
    v108267: state_type > $o ).

tff(pred_def_61012,type,
    v108266: state_type > $o ).

tff(pred_def_61013,type,
    v108278: state_type > $o ).

tff(pred_def_61014,type,
    v108279: state_type > $o ).

tff(pred_def_61015,type,
    v108277: state_type > $o ).

tff(pred_def_61016,type,
    v108274: ( state_type * $int ) > $o ).

tff(pred_def_61017,type,
    v108276: ( state_type * $int ) > $o ).

tff(pred_def_61018,type,
    v108163: ( state_type * $int ) > $o ).

tff(pred_def_61019,type,
    v108161: ( state_type * $int ) > $o ).

tff(pred_def_61020,type,
    v108157: state_type > $o ).

tff(pred_def_61021,type,
    v108294: state_type > $o ).

tff(pred_def_61022,type,
    v108292: state_type > $o ).

tff(pred_def_61023,type,
    v108298: state_type > $o ).

tff(pred_def_61024,type,
    v108296: state_type > $o ).

tff(pred_def_61025,type,
    v108308: state_type > $o ).

tff(pred_def_61026,type,
    v108311: ( state_type * $int ) > $o ).

tff(pred_def_61027,type,
    v108284: state_type > $o ).

tff(pred_def_61028,type,
    v108313: state_type > $o ).

tff(pred_def_61029,type,
    v108323: state_type > $o ).

tff(pred_def_61030,type,
    v108322: state_type > $o ).

tff(pred_def_61031,type,
    v108321: state_type > $o ).

tff(pred_def_61032,type,
    v108324: state_type > $o ).

tff(pred_def_61033,type,
    v108320: state_type > $o ).

tff(pred_def_61034,type,
    v108319: state_type > $o ).

tff(pred_def_61035,type,
    v108318: state_type > $o ).

tff(pred_def_61036,type,
    v108317: state_type > $o ).

tff(pred_def_61037,type,
    v108326: state_type > $o ).

tff(pred_def_61038,type,
    v108325: state_type > $o ).

tff(pred_def_61039,type,
    v108316: state_type > $o ).

tff(pred_def_61040,type,
    v108329: state_type > $o ).

tff(pred_def_61041,type,
    v108328: state_type > $o ).

tff(pred_def_61042,type,
    v108330: state_type > $o ).

tff(pred_def_61043,type,
    v108327: state_type > $o ).

tff(pred_def_61044,type,
    v108333: state_type > $o ).

tff(pred_def_61045,type,
    v108332: state_type > $o ).

tff(pred_def_61046,type,
    v108334: state_type > $o ).

tff(pred_def_61047,type,
    v108331: state_type > $o ).

tff(pred_def_61048,type,
    v108314: ( state_type * $int ) > $o ).

tff(pred_def_61049,type,
    v108336: state_type > $o ).

tff(pred_def_61050,type,
    v108286: ( state_type * $int ) > $o ).

tff(pred_def_61051,type,
    v108338: state_type > $o ).

tff(pred_def_61052,type,
    v108349: state_type > $o ).

tff(pred_def_61053,type,
    v108348: state_type > $o ).

tff(pred_def_61054,type,
    v108347: state_type > $o ).

tff(pred_def_61055,type,
    v108350: state_type > $o ).

tff(pred_def_61056,type,
    v108346: state_type > $o ).

tff(pred_def_61057,type,
    v108345: state_type > $o ).

tff(pred_def_61058,type,
    v108344: state_type > $o ).

tff(pred_def_61059,type,
    v108343: state_type > $o ).

tff(pred_def_61060,type,
    v108352: state_type > $o ).

tff(pred_def_61061,type,
    v108351: state_type > $o ).

tff(pred_def_61062,type,
    v108342: state_type > $o ).

tff(pred_def_61063,type,
    v108355: state_type > $o ).

tff(pred_def_61064,type,
    v108354: state_type > $o ).

tff(pred_def_61065,type,
    v108356: state_type > $o ).

tff(pred_def_61066,type,
    v108353: state_type > $o ).

tff(pred_def_61067,type,
    v108359: state_type > $o ).

tff(pred_def_61068,type,
    v108358: state_type > $o ).

tff(pred_def_61069,type,
    v108360: state_type > $o ).

tff(pred_def_61070,type,
    v108357: state_type > $o ).

tff(pred_def_61071,type,
    v108340: ( state_type * $int ) > $o ).

tff(pred_def_61072,type,
    v108339: ( state_type * $int ) > $o ).

tff(pred_def_61073,type,
    v108337: ( state_type * $int ) > $o ).

tff(pred_def_61074,type,
    v108335: ( state_type * $int ) > $o ).

tff(pred_def_61075,type,
    v108306: ( state_type * $int ) > $o ).

tff(pred_def_61076,type,
    v108304: ( state_type * $int ) > $o ).

tff(pred_def_61077,type,
    v108302: ( state_type * $int ) > $o ).

tff(pred_def_61078,type,
    v108300: ( state_type * $int ) > $o ).

tff(pred_def_61079,type,
    v108364: state_type > $o ).

tff(pred_def_61080,type,
    v108362: state_type > $o ).

tff(pred_def_61081,type,
    v108371: state_type > $o ).

tff(pred_def_61082,type,
    v108369: state_type > $o ).

tff(pred_def_61083,type,
    v108368: state_type > $o ).

tff(pred_def_61084,type,
    v108367: state_type > $o ).

tff(pred_def_61085,type,
    v108379: state_type > $o ).

tff(pred_def_61086,type,
    v108380: state_type > $o ).

tff(pred_def_61087,type,
    v108378: state_type > $o ).

tff(pred_def_61088,type,
    v108375: ( state_type * $int ) > $o ).

tff(pred_def_61089,type,
    v108377: ( state_type * $int ) > $o ).

tff(pred_def_61090,type,
    v108290: ( state_type * $int ) > $o ).

tff(pred_def_61091,type,
    v108288: ( state_type * $int ) > $o ).

tff(pred_def_61092,type,
    v108397: state_type > $o ).

tff(pred_def_61093,type,
    v108395: state_type > $o ).

tff(pred_def_61094,type,
    v108401: state_type > $o ).

tff(pred_def_61095,type,
    v108399: state_type > $o ).

tff(pred_def_61096,type,
    v108413: state_type > $o ).

tff(pred_def_61097,type,
    v108411: state_type > $o ).

tff(pred_def_61098,type,
    v108415: ( state_type * $int ) > $o ).

tff(pred_def_61099,type,
    v108387: state_type > $o ).

tff(pred_def_61100,type,
    v108418: state_type > $o ).

tff(pred_def_61101,type,
    v108417: state_type > $o ).

tff(pred_def_61102,type,
    v108430: state_type > $o ).

tff(pred_def_61103,type,
    v108429: state_type > $o ).

tff(pred_def_61104,type,
    v108428: state_type > $o ).

tff(pred_def_61105,type,
    v108431: state_type > $o ).

tff(pred_def_61106,type,
    v108427: state_type > $o ).

tff(pred_def_61107,type,
    v108426: state_type > $o ).

tff(pred_def_61108,type,
    v108432: state_type > $o ).

tff(pred_def_61109,type,
    v108425: state_type > $o ).

tff(pred_def_61110,type,
    v108424: state_type > $o ).

tff(pred_def_61111,type,
    v108423: state_type > $o ).

tff(pred_def_61112,type,
    v108422: state_type > $o ).

tff(pred_def_61113,type,
    v108434: state_type > $o ).

tff(pred_def_61114,type,
    v108433: state_type > $o ).

tff(pred_def_61115,type,
    v108421: state_type > $o ).

tff(pred_def_61116,type,
    v108437: state_type > $o ).

tff(pred_def_61117,type,
    v108436: state_type > $o ).

tff(pred_def_61118,type,
    v108438: state_type > $o ).

tff(pred_def_61119,type,
    v108435: state_type > $o ).

tff(pred_def_61120,type,
    v108441: state_type > $o ).

tff(pred_def_61121,type,
    v108440: state_type > $o ).

tff(pred_def_61122,type,
    v108442: state_type > $o ).

tff(pred_def_61123,type,
    v108439: state_type > $o ).

tff(pred_def_61124,type,
    v108445: state_type > $o ).

tff(pred_def_61125,type,
    v108444: state_type > $o ).

tff(pred_def_61126,type,
    v108446: state_type > $o ).

tff(pred_def_61127,type,
    v108443: state_type > $o ).

tff(pred_def_61128,type,
    v108419: ( state_type * $int ) > $o ).

tff(pred_def_61129,type,
    v108389: ( state_type * $int ) > $o ).

tff(pred_def_61130,type,
    v108459: state_type > $o ).

tff(pred_def_61131,type,
    v108458: state_type > $o ).

tff(pred_def_61132,type,
    v108457: state_type > $o ).

tff(pred_def_61133,type,
    v108460: state_type > $o ).

tff(pred_def_61134,type,
    v108456: state_type > $o ).

tff(pred_def_61135,type,
    v108455: state_type > $o ).

tff(pred_def_61136,type,
    v108461: state_type > $o ).

tff(pred_def_61137,type,
    v108454: state_type > $o ).

tff(pred_def_61138,type,
    v108453: state_type > $o ).

tff(pred_def_61139,type,
    v108452: state_type > $o ).

tff(pred_def_61140,type,
    v108451: state_type > $o ).

tff(pred_def_61141,type,
    v108463: state_type > $o ).

tff(pred_def_61142,type,
    v108462: state_type > $o ).

tff(pred_def_61143,type,
    v108450: state_type > $o ).

tff(pred_def_61144,type,
    v108466: state_type > $o ).

tff(pred_def_61145,type,
    v108465: state_type > $o ).

tff(pred_def_61146,type,
    v108467: state_type > $o ).

tff(pred_def_61147,type,
    v108464: state_type > $o ).

tff(pred_def_61148,type,
    v108470: state_type > $o ).

tff(pred_def_61149,type,
    v108469: state_type > $o ).

tff(pred_def_61150,type,
    v108471: state_type > $o ).

tff(pred_def_61151,type,
    v108468: state_type > $o ).

tff(pred_def_61152,type,
    v108474: state_type > $o ).

tff(pred_def_61153,type,
    v108473: state_type > $o ).

tff(pred_def_61154,type,
    v108475: state_type > $o ).

tff(pred_def_61155,type,
    v108472: state_type > $o ).

tff(pred_def_61156,type,
    v108448: ( state_type * $int ) > $o ).

tff(pred_def_61157,type,
    v108447: ( state_type * $int ) > $o ).

tff(pred_def_61158,type,
    v108409: ( state_type * $int ) > $o ).

tff(pred_def_61159,type,
    v108407: ( state_type * $int ) > $o ).

tff(pred_def_61160,type,
    v108405: ( state_type * $int ) > $o ).

tff(pred_def_61161,type,
    v108403: ( state_type * $int ) > $o ).

tff(pred_def_61162,type,
    v108479: state_type > $o ).

tff(pred_def_61163,type,
    v108477: state_type > $o ).

tff(pred_def_61164,type,
    v108486: state_type > $o ).

tff(pred_def_61165,type,
    v108484: state_type > $o ).

tff(pred_def_61166,type,
    v108483: state_type > $o ).

tff(pred_def_61167,type,
    v108482: state_type > $o ).

tff(pred_def_61168,type,
    v108494: state_type > $o ).

tff(pred_def_61169,type,
    v108495: state_type > $o ).

tff(pred_def_61170,type,
    v108493: state_type > $o ).

tff(pred_def_61171,type,
    v108490: ( state_type * $int ) > $o ).

tff(pred_def_61172,type,
    v108492: ( state_type * $int ) > $o ).

tff(pred_def_61173,type,
    v108393: ( state_type * $int ) > $o ).

tff(pred_def_61174,type,
    v108391: ( state_type * $int ) > $o ).

tff(pred_def_61175,type,
    v108510: state_type > $o ).

tff(pred_def_61176,type,
    v108508: state_type > $o ).

tff(pred_def_61177,type,
    v108514: state_type > $o ).

tff(pred_def_61178,type,
    v108512: state_type > $o ).

tff(pred_def_61179,type,
    v108527: state_type > $o ).

tff(pred_def_61180,type,
    v108500: state_type > $o ).

tff(pred_def_61181,type,
    v108526: state_type > $o ).

tff(pred_def_61182,type,
    v108525: state_type > $o ).

tff(pred_def_61183,type,
    v108524: state_type > $o ).

tff(pred_def_61184,type,
    v108528: ( state_type * $int ) > $o ).

tff(pred_def_61185,type,
    v108502: ( state_type * $int ) > $o ).

tff(pred_def_61186,type,
    v108541: state_type > $o ).

tff(pred_def_61187,type,
    v108540: state_type > $o ).

tff(pred_def_61188,type,
    v108539: state_type > $o ).

tff(pred_def_61189,type,
    v108542: state_type > $o ).

tff(pred_def_61190,type,
    v108538: state_type > $o ).

tff(pred_def_61191,type,
    v108537: state_type > $o ).

tff(pred_def_61192,type,
    v108543: state_type > $o ).

tff(pred_def_61193,type,
    v108536: state_type > $o ).

tff(pred_def_61194,type,
    v108535: state_type > $o ).

tff(pred_def_61195,type,
    v108534: state_type > $o ).

tff(pred_def_61196,type,
    v108533: state_type > $o ).

tff(pred_def_61197,type,
    v108545: state_type > $o ).

tff(pred_def_61198,type,
    v108544: state_type > $o ).

tff(pred_def_61199,type,
    v108532: state_type > $o ).

tff(pred_def_61200,type,
    v108548: state_type > $o ).

tff(pred_def_61201,type,
    v108547: state_type > $o ).

tff(pred_def_61202,type,
    v108549: state_type > $o ).

tff(pred_def_61203,type,
    v108546: state_type > $o ).

tff(pred_def_61204,type,
    v108552: state_type > $o ).

tff(pred_def_61205,type,
    v108551: state_type > $o ).

tff(pred_def_61206,type,
    v108553: state_type > $o ).

tff(pred_def_61207,type,
    v108550: state_type > $o ).

tff(pred_def_61208,type,
    v108556: state_type > $o ).

tff(pred_def_61209,type,
    v108555: state_type > $o ).

tff(pred_def_61210,type,
    v108557: state_type > $o ).

tff(pred_def_61211,type,
    v108554: state_type > $o ).

tff(pred_def_61212,type,
    v108530: ( state_type * $int ) > $o ).

tff(pred_def_61213,type,
    v108529: ( state_type * $int ) > $o ).

tff(pred_def_61214,type,
    v108522: ( state_type * $int ) > $o ).

tff(pred_def_61215,type,
    v108520: ( state_type * $int ) > $o ).

tff(pred_def_61216,type,
    v108518: ( state_type * $int ) > $o ).

tff(pred_def_61217,type,
    v108516: ( state_type * $int ) > $o ).

tff(pred_def_61218,type,
    v108561: state_type > $o ).

tff(pred_def_61219,type,
    v108559: state_type > $o ).

tff(pred_def_61220,type,
    v108568: state_type > $o ).

tff(pred_def_61221,type,
    v108566: state_type > $o ).

tff(pred_def_61222,type,
    v108565: state_type > $o ).

tff(pred_def_61223,type,
    v108564: state_type > $o ).

tff(pred_def_61224,type,
    v108576: state_type > $o ).

tff(pred_def_61225,type,
    v108577: state_type > $o ).

tff(pred_def_61226,type,
    v108575: state_type > $o ).

tff(pred_def_61227,type,
    v108572: ( state_type * $int ) > $o ).

tff(pred_def_61228,type,
    v108574: ( state_type * $int ) > $o ).

tff(pred_def_61229,type,
    v108506: ( state_type * $int ) > $o ).

tff(pred_def_61230,type,
    v108504: ( state_type * $int ) > $o ).

tff(pred_def_61231,type,
    v108592: state_type > $o ).

tff(pred_def_61232,type,
    v108590: state_type > $o ).

tff(pred_def_61233,type,
    v108596: state_type > $o ).

tff(pred_def_61234,type,
    v108594: state_type > $o ).

tff(pred_def_61235,type,
    v108610: state_type > $o ).

tff(pred_def_61236,type,
    v108582: state_type > $o ).

tff(pred_def_61237,type,
    v108609: state_type > $o ).

tff(pred_def_61238,type,
    v108611: state_type > $o ).

tff(pred_def_61239,type,
    v108608: state_type > $o ).

tff(pred_def_61240,type,
    v108607: state_type > $o ).

tff(pred_def_61241,type,
    v108606: state_type > $o ).

tff(pred_def_61242,type,
    v108612: ( state_type * $int ) > $o ).

tff(pred_def_61243,type,
    v108584: ( state_type * $int ) > $o ).

tff(pred_def_61244,type,
    v108625: state_type > $o ).

tff(pred_def_61245,type,
    v108624: state_type > $o ).

tff(pred_def_61246,type,
    v108623: state_type > $o ).

tff(pred_def_61247,type,
    v108626: state_type > $o ).

tff(pred_def_61248,type,
    v108622: state_type > $o ).

tff(pred_def_61249,type,
    v108621: state_type > $o ).

tff(pred_def_61250,type,
    v108627: state_type > $o ).

tff(pred_def_61251,type,
    v108620: state_type > $o ).

tff(pred_def_61252,type,
    v108619: state_type > $o ).

tff(pred_def_61253,type,
    v108618: state_type > $o ).

tff(pred_def_61254,type,
    v108617: state_type > $o ).

tff(pred_def_61255,type,
    v108629: state_type > $o ).

tff(pred_def_61256,type,
    v108628: state_type > $o ).

tff(pred_def_61257,type,
    v108616: state_type > $o ).

tff(pred_def_61258,type,
    v108632: state_type > $o ).

tff(pred_def_61259,type,
    v108631: state_type > $o ).

tff(pred_def_61260,type,
    v108633: state_type > $o ).

tff(pred_def_61261,type,
    v108630: state_type > $o ).

tff(pred_def_61262,type,
    v108636: state_type > $o ).

tff(pred_def_61263,type,
    v108635: state_type > $o ).

tff(pred_def_61264,type,
    v108637: state_type > $o ).

tff(pred_def_61265,type,
    v108634: state_type > $o ).

tff(pred_def_61266,type,
    v108640: state_type > $o ).

tff(pred_def_61267,type,
    v108639: state_type > $o ).

tff(pred_def_61268,type,
    v108641: state_type > $o ).

tff(pred_def_61269,type,
    v108638: state_type > $o ).

tff(pred_def_61270,type,
    v108614: ( state_type * $int ) > $o ).

tff(pred_def_61271,type,
    v108613: ( state_type * $int ) > $o ).

tff(pred_def_61272,type,
    v108604: ( state_type * $int ) > $o ).

tff(pred_def_61273,type,
    v108602: ( state_type * $int ) > $o ).

tff(pred_def_61274,type,
    v108600: ( state_type * $int ) > $o ).

tff(pred_def_61275,type,
    v108598: ( state_type * $int ) > $o ).

tff(pred_def_61276,type,
    v108645: state_type > $o ).

tff(pred_def_61277,type,
    v108643: state_type > $o ).

tff(pred_def_61278,type,
    v108652: state_type > $o ).

tff(pred_def_61279,type,
    v108650: state_type > $o ).

tff(pred_def_61280,type,
    v108649: state_type > $o ).

tff(pred_def_61281,type,
    v108648: state_type > $o ).

tff(pred_def_61282,type,
    v108660: state_type > $o ).

tff(pred_def_61283,type,
    v108661: state_type > $o ).

tff(pred_def_61284,type,
    v108659: state_type > $o ).

tff(pred_def_61285,type,
    v108656: ( state_type * $int ) > $o ).

tff(pred_def_61286,type,
    v108658: ( state_type * $int ) > $o ).

tff(pred_def_61287,type,
    v108588: ( state_type * $int ) > $o ).

tff(pred_def_61288,type,
    v108586: ( state_type * $int ) > $o ).

tff(pred_def_61289,type,
    v108676: state_type > $o ).

tff(pred_def_61290,type,
    v108674: state_type > $o ).

tff(pred_def_61291,type,
    v108680: state_type > $o ).

tff(pred_def_61292,type,
    v108678: state_type > $o ).

tff(pred_def_61293,type,
    v108695: state_type > $o ).

tff(pred_def_61294,type,
    v108666: state_type > $o ).

tff(pred_def_61295,type,
    v108694: state_type > $o ).

tff(pred_def_61296,type,
    v108696: state_type > $o ).

tff(pred_def_61297,type,
    v108693: state_type > $o ).

tff(pred_def_61298,type,
    v108697: state_type > $o ).

tff(pred_def_61299,type,
    v108692: state_type > $o ).

tff(pred_def_61300,type,
    v108691: state_type > $o ).

tff(pred_def_61301,type,
    v108690: state_type > $o ).

tff(pred_def_61302,type,
    v108698: ( state_type * $int ) > $o ).

tff(pred_def_61303,type,
    v108668: ( state_type * $int ) > $o ).

tff(pred_def_61304,type,
    v108711: state_type > $o ).

tff(pred_def_61305,type,
    v108710: state_type > $o ).

tff(pred_def_61306,type,
    v108709: state_type > $o ).

tff(pred_def_61307,type,
    v108712: state_type > $o ).

tff(pred_def_61308,type,
    v108708: state_type > $o ).

tff(pred_def_61309,type,
    v108707: state_type > $o ).

tff(pred_def_61310,type,
    v108713: state_type > $o ).

tff(pred_def_61311,type,
    v108706: state_type > $o ).

tff(pred_def_61312,type,
    v108705: state_type > $o ).

tff(pred_def_61313,type,
    v108704: state_type > $o ).

tff(pred_def_61314,type,
    v108703: state_type > $o ).

tff(pred_def_61315,type,
    v108715: state_type > $o ).

tff(pred_def_61316,type,
    v108714: state_type > $o ).

tff(pred_def_61317,type,
    v108702: state_type > $o ).

tff(pred_def_61318,type,
    v108718: state_type > $o ).

tff(pred_def_61319,type,
    v108717: state_type > $o ).

tff(pred_def_61320,type,
    v108719: state_type > $o ).

tff(pred_def_61321,type,
    v108716: state_type > $o ).

tff(pred_def_61322,type,
    v108722: state_type > $o ).

tff(pred_def_61323,type,
    v108721: state_type > $o ).

tff(pred_def_61324,type,
    v108723: state_type > $o ).

tff(pred_def_61325,type,
    v108720: state_type > $o ).

tff(pred_def_61326,type,
    v108726: state_type > $o ).

tff(pred_def_61327,type,
    v108725: state_type > $o ).

tff(pred_def_61328,type,
    v108727: state_type > $o ).

tff(pred_def_61329,type,
    v108724: state_type > $o ).

tff(pred_def_61330,type,
    v108700: ( state_type * $int ) > $o ).

tff(pred_def_61331,type,
    v108699: ( state_type * $int ) > $o ).

tff(pred_def_61332,type,
    v108688: ( state_type * $int ) > $o ).

tff(pred_def_61333,type,
    v108686: ( state_type * $int ) > $o ).

tff(pred_def_61334,type,
    v108684: ( state_type * $int ) > $o ).

tff(pred_def_61335,type,
    v108682: ( state_type * $int ) > $o ).

tff(pred_def_61336,type,
    v108731: state_type > $o ).

tff(pred_def_61337,type,
    v108729: state_type > $o ).

tff(pred_def_61338,type,
    v108738: state_type > $o ).

tff(pred_def_61339,type,
    v108736: state_type > $o ).

tff(pred_def_61340,type,
    v108735: state_type > $o ).

tff(pred_def_61341,type,
    v108734: state_type > $o ).

tff(pred_def_61342,type,
    v108746: state_type > $o ).

tff(pred_def_61343,type,
    v108747: state_type > $o ).

tff(pred_def_61344,type,
    v108745: state_type > $o ).

tff(pred_def_61345,type,
    v108742: ( state_type * $int ) > $o ).

tff(pred_def_61346,type,
    v108744: ( state_type * $int ) > $o ).

tff(pred_def_61347,type,
    v108672: ( state_type * $int ) > $o ).

tff(pred_def_61348,type,
    v108670: ( state_type * $int ) > $o ).

tff(pred_def_61349,type,
    v108754: state_type > $o ).

tff(pred_def_61350,type,
    v108755: state_type > $o ).

tff(pred_def_61351,type,
    v108753: state_type > $o ).

tff(pred_def_61352,type,
    v108756: state_type > $o ).

tff(pred_def_61353,type,
    v108752: state_type > $o ).

tff(pred_def_61354,type,
    v108757: state_type > $o ).

tff(pred_def_61355,type,
    v108385: state_type > $o ).

tff(pred_def_61356,type,
    v108760: state_type > $o ).

tff(pred_def_61357,type,
    v108759: state_type > $o ).

tff(pred_def_61358,type,
    v108761: state_type > $o ).

tff(pred_def_61359,type,
    v101256: ( state_type * $int ) > $o ).

tff(pred_def_61360,type,
    v108764: state_type > $o ).

tff(pred_def_61361,type,
    v108763: state_type > $o ).

tff(pred_def_61362,type,
    v108765: state_type > $o ).

tff(pred_def_61363,type,
    v108768: state_type > $o ).

tff(pred_def_61364,type,
    v108767: state_type > $o ).

tff(pred_def_61365,type,
    v108769: state_type > $o ).

tff(pred_def_61366,type,
    v108772: state_type > $o ).

tff(pred_def_61367,type,
    v108771: state_type > $o ).

tff(pred_def_61368,type,
    v108773: state_type > $o ).

tff(pred_def_61369,type,
    v108776: state_type > $o ).

tff(pred_def_61370,type,
    v108775: state_type > $o ).

tff(pred_def_61371,type,
    v108777: state_type > $o ).

tff(pred_def_61372,type,
    v108780: state_type > $o ).

tff(pred_def_61373,type,
    v108779: state_type > $o ).

tff(pred_def_61374,type,
    v108781: state_type > $o ).

tff(pred_def_61375,type,
    v108784: state_type > $o ).

tff(pred_def_61376,type,
    v108783: state_type > $o ).

tff(pred_def_61377,type,
    v108785: state_type > $o ).

tff(pred_def_61378,type,
    v108788: state_type > $o ).

tff(pred_def_61379,type,
    v108787: state_type > $o ).

tff(pred_def_61380,type,
    v108789: state_type > $o ).

tff(pred_def_61381,type,
    v101254: ( state_type * $int ) > $o ).

tff(pred_def_61382,type,
    v101252: ( state_type * $int ) > $o ).

tff(pred_def_61383,type,
    v108791: ( state_type * $int ) > $o ).

tff(pred_def_61384,type,
    v101248: ( state_type * $int ) > $o ).

tff(pred_def_61385,type,
    v108808: ( state_type * $int ) > $o ).

tff(pred_def_61386,type,
    v108807: state_type > $o ).

tff(pred_def_61387,type,
    v108806: state_type > $o ).

tff(pred_def_61388,type,
    v108805: state_type > $o ).

tff(pred_def_61389,type,
    v108804: state_type > $o ).

tff(pred_def_61390,type,
    v108803: state_type > $o ).

tff(pred_def_61391,type,
    v108802: state_type > $o ).

tff(pred_def_61392,type,
    v108801: state_type > $o ).

tff(pred_def_61393,type,
    v108800: state_type > $o ).

tff(pred_def_61394,type,
    v108799: state_type > $o ).

tff(pred_def_61395,type,
    v108798: state_type > $o ).

tff(pred_def_61396,type,
    v108797: state_type > $o ).

tff(pred_def_61397,type,
    v108796: state_type > $o ).

tff(pred_def_61398,type,
    v108795: state_type > $o ).

tff(pred_def_61399,type,
    v108794: state_type > $o ).

tff(pred_def_61400,type,
    v101227: state_type > $o ).

tff(pred_def_61401,type,
    v108812: state_type > $o ).

tff(pred_def_61402,type,
    v108810: state_type > $o ).

tff(pred_def_61403,type,
    v108816: state_type > $o ).

tff(pred_def_61404,type,
    v108814: state_type > $o ).

tff(pred_def_61405,type,
    v108820: state_type > $o ).

tff(pred_def_61406,type,
    v108818: state_type > $o ).

tff(pred_def_61407,type,
    v108824: ( state_type * $int ) > $o ).

tff(pred_def_61408,type,
    v108822: ( state_type * $int ) > $o ).

tff(pred_def_61409,type,
    v108828: state_type > $o ).

tff(pred_def_61410,type,
    v108826: state_type > $o ).

tff(pred_def_61411,type,
    v108833: state_type > $o ).

tff(pred_def_61412,type,
    v108837: state_type > $o ).

tff(pred_def_61413,type,
    v108838: state_type > $o ).

tff(pred_def_61414,type,
    v108836: state_type > $o ).

tff(pred_def_61415,type,
    v108847: state_type > $o ).

tff(pred_def_61416,type,
    v108848: state_type > $o ).

tff(pred_def_61417,type,
    v108846: state_type > $o ).

tff(pred_def_61418,type,
    v108849: state_type > $o ).

tff(pred_def_61419,type,
    v108845: state_type > $o ).

tff(pred_def_61420,type,
    v108844: state_type > $o ).

tff(pred_def_61421,type,
    v108853: state_type > $o ).

tff(pred_def_61422,type,
    v108854: state_type > $o ).

tff(pred_def_61423,type,
    v108852: state_type > $o ).

tff(pred_def_61424,type,
    v108855: state_type > $o ).

tff(pred_def_61425,type,
    v108851: state_type > $o ).

tff(pred_def_61426,type,
    v108850: state_type > $o ).

tff(pred_def_61427,type,
    v108843: state_type > $o ).

tff(pred_def_61428,type,
    v108859: state_type > $o ).

tff(pred_def_61429,type,
    v108860: state_type > $o ).

tff(pred_def_61430,type,
    v108858: state_type > $o ).

tff(pred_def_61431,type,
    v108861: state_type > $o ).

tff(pred_def_61432,type,
    v108857: state_type > $o ).

tff(pred_def_61433,type,
    v108856: state_type > $o ).

tff(pred_def_61434,type,
    v108842: state_type > $o ).

tff(pred_def_61435,type,
    v108865: state_type > $o ).

tff(pred_def_61436,type,
    v108866: state_type > $o ).

tff(pred_def_61437,type,
    v108864: state_type > $o ).

tff(pred_def_61438,type,
    v108867: state_type > $o ).

tff(pred_def_61439,type,
    v108863: state_type > $o ).

tff(pred_def_61440,type,
    v108862: state_type > $o ).

tff(pred_def_61441,type,
    v108841: state_type > $o ).

tff(pred_def_61442,type,
    v108839: state_type > $o ).

tff(pred_def_61443,type,
    v108835: state_type > $o ).

tff(pred_def_61444,type,
    v108834: state_type > $o ).

tff(pred_def_61445,type,
    v108832: state_type > $o ).

tff(pred_def_61446,type,
    v108831: state_type > $o ).

tff(pred_def_61447,type,
    v108830: ( state_type * $int ) > $o ).

tff(pred_def_61448,type,
    v100439: ( state_type * $int ) > $o ).

tff(pred_def_61449,type,
    v100437: ( state_type * $int ) > $o ).

tff(pred_def_61450,type,
    v100435: ( state_type * $int ) > $o ).

tff(pred_def_61451,type,
    v108879: state_type > $o ).

tff(pred_def_61452,type,
    v108877: state_type > $o ).

tff(pred_def_61453,type,
    v108883: state_type > $o ).

tff(pred_def_61454,type,
    v108881: state_type > $o ).

tff(pred_def_61455,type,
    v108909: state_type > $o ).

tff(pred_def_61456,type,
    v108907: state_type > $o ).

tff(pred_def_61457,type,
    v108913: state_type > $o ).

tff(pred_def_61458,type,
    v108911: state_type > $o ).

tff(pred_def_61459,type,
    v108929: ( state_type * $int ) > $o ).

tff(pred_def_61460,type,
    v108927: ( state_type * $int ) > $o ).

tff(pred_def_61461,type,
    v108925: ( state_type * $int ) > $o ).

tff(pred_def_61462,type,
    v108923: ( state_type * $int ) > $o ).

tff(pred_def_61463,type,
    v108935: state_type > $o ).

tff(pred_def_61464,type,
    v108933: state_type > $o ).

tff(pred_def_61465,type,
    v108932: state_type > $o ).

tff(pred_def_61466,type,
    v108931: ( state_type * $int ) > $o ).

tff(pred_def_61467,type,
    v108939: state_type > $o ).

tff(pred_def_61468,type,
    v108945: state_type > $o ).

tff(pred_def_61469,type,
    v108943: state_type > $o ).

tff(pred_def_61470,type,
    v108942: state_type > $o ).

tff(pred_def_61471,type,
    v108941: ( state_type * $int ) > $o ).

tff(pred_def_61472,type,
    v108953: state_type > $o ).

tff(pred_def_61473,type,
    v108951: state_type > $o ).

tff(pred_def_61474,type,
    v108950: state_type > $o ).

tff(pred_def_61475,type,
    v108949: ( state_type * $int ) > $o ).

tff(pred_def_61476,type,
    v108961: state_type > $o ).

tff(pred_def_61477,type,
    v108959: state_type > $o ).

tff(pred_def_61478,type,
    v108958: state_type > $o ).

tff(pred_def_61479,type,
    v108957: ( state_type * $int ) > $o ).

tff(pred_def_61480,type,
    v108969: state_type > $o ).

tff(pred_def_61481,type,
    v108967: state_type > $o ).

tff(pred_def_61482,type,
    v108966: state_type > $o ).

tff(pred_def_61483,type,
    v108965: ( state_type * $int ) > $o ).

tff(pred_def_61484,type,
    v108977: state_type > $o ).

tff(pred_def_61485,type,
    v108975: state_type > $o ).

tff(pred_def_61486,type,
    v108974: state_type > $o ).

tff(pred_def_61487,type,
    v108973: ( state_type * $int ) > $o ).

tff(pred_def_61488,type,
    v108985: state_type > $o ).

tff(pred_def_61489,type,
    v108983: state_type > $o ).

tff(pred_def_61490,type,
    v108982: state_type > $o ).

tff(pred_def_61491,type,
    v108981: ( state_type * $int ) > $o ).

tff(pred_def_61492,type,
    v108993: state_type > $o ).

tff(pred_def_61493,type,
    v108991: state_type > $o ).

tff(pred_def_61494,type,
    v108990: state_type > $o ).

tff(pred_def_61495,type,
    v108989: ( state_type * $int ) > $o ).

tff(pred_def_61496,type,
    v109001: state_type > $o ).

tff(pred_def_61497,type,
    v108999: state_type > $o ).

tff(pred_def_61498,type,
    v108998: state_type > $o ).

tff(pred_def_61499,type,
    v108997: ( state_type * $int ) > $o ).

tff(pred_def_61500,type,
    v109009: state_type > $o ).

tff(pred_def_61501,type,
    v109007: state_type > $o ).

tff(pred_def_61502,type,
    v109006: state_type > $o ).

tff(pred_def_61503,type,
    v109005: ( state_type * $int ) > $o ).

tff(pred_def_61504,type,
    v109020: ( state_type * $int ) > $o ).

tff(pred_def_61505,type,
    v109019: ( state_type * $int ) > $o ).

tff(pred_def_61506,type,
    v109022: ( state_type * $int ) > $o ).

tff(pred_def_61507,type,
    v109021: ( state_type * $int ) > $o ).

tff(pred_def_61508,type,
    v109018: ( state_type * $int ) > $o ).

tff(pred_def_61509,type,
    v109024: ( state_type * $int ) > $o ).

tff(pred_def_61510,type,
    v109023: ( state_type * $int ) > $o ).

tff(pred_def_61511,type,
    v109017: ( state_type * $int ) > $o ).

tff(pred_def_61512,type,
    v109026: ( state_type * $int ) > $o ).

tff(pred_def_61513,type,
    v109025: ( state_type * $int ) > $o ).

tff(pred_def_61514,type,
    v109016: ( state_type * $int ) > $o ).

tff(pred_def_61515,type,
    v109028: ( state_type * $int ) > $o ).

tff(pred_def_61516,type,
    v109027: ( state_type * $int ) > $o ).

tff(pred_def_61517,type,
    v109015: ( state_type * $int ) > $o ).

tff(pred_def_61518,type,
    v109030: ( state_type * $int ) > $o ).

tff(pred_def_61519,type,
    v109029: ( state_type * $int ) > $o ).

tff(pred_def_61520,type,
    v109014: ( state_type * $int ) > $o ).

tff(pred_def_61521,type,
    v109032: ( state_type * $int ) > $o ).

tff(pred_def_61522,type,
    v109031: ( state_type * $int ) > $o ).

tff(pred_def_61523,type,
    v109013: ( state_type * $int ) > $o ).

tff(pred_def_61524,type,
    v109034: ( state_type * $int ) > $o ).

tff(pred_def_61525,type,
    v109033: ( state_type * $int ) > $o ).

tff(pred_def_61526,type,
    v109036: state_type > $o ).

tff(pred_def_61527,type,
    v109037: state_type > $o ).

tff(pred_def_61528,type,
    v109047: ( state_type * $int ) > $o ).

tff(pred_def_61529,type,
    v109045: ( state_type * $int ) > $o ).

tff(pred_def_61530,type,
    v109043: ( state_type * $int ) > $o ).

tff(pred_def_61531,type,
    v109041: ( state_type * $int ) > $o ).

tff(pred_def_61532,type,
    v109053: state_type > $o ).

tff(pred_def_61533,type,
    v109051: state_type > $o ).

tff(pred_def_61534,type,
    v109050: state_type > $o ).

tff(pred_def_61535,type,
    v109049: ( state_type * $int ) > $o ).

tff(pred_def_61536,type,
    v109064: state_type > $o ).

tff(pred_def_61537,type,
    v109062: state_type > $o ).

tff(pred_def_61538,type,
    v109060: state_type > $o ).

tff(pred_def_61539,type,
    v109058: state_type > $o ).

tff(pred_def_61540,type,
    v109070: state_type > $o ).

tff(pred_def_61541,type,
    v109068: state_type > $o ).

tff(pred_def_61542,type,
    v109067: state_type > $o ).

tff(pred_def_61543,type,
    v109066: ( state_type * $int ) > $o ).

tff(pred_def_61544,type,
    v109074: state_type > $o ).

tff(pred_def_61545,type,
    v109080: state_type > $o ).

tff(pred_def_61546,type,
    v109078: state_type > $o ).

tff(pred_def_61547,type,
    v109077: state_type > $o ).

tff(pred_def_61548,type,
    v109076: ( state_type * $int ) > $o ).

tff(pred_def_61549,type,
    v109086: state_type > $o ).

tff(pred_def_61550,type,
    v89337: state_type > $o ).

tff(pred_def_61551,type,
    v109085: ( state_type * $int ) > $o ).

tff(pred_def_61552,type,
    v109084: ( state_type * $int ) > $o ).

tff(pred_def_61553,type,
    v109090: state_type > $o ).

tff(pred_def_61554,type,
    v109089: ( state_type * $int ) > $o ).

tff(pred_def_61555,type,
    v109088: ( state_type * $int ) > $o ).

tff(pred_def_61556,type,
    v89255: ( state_type * $int ) > $o ).

tff(pred_def_61557,type,
    v109087: ( state_type * $int ) > $o ).

tff(pred_def_61558,type,
    v109083: ( state_type * $int ) > $o ).

tff(pred_def_61559,type,
    v89269: ( state_type * $int ) > $o ).

tff(pred_def_61560,type,
    v89267: ( state_type * $int ) > $o ).

tff(pred_def_61561,type,
    v109094: state_type > $o ).

tff(pred_def_61562,type,
    v109092: state_type > $o ).

tff(pred_def_61563,type,
    v109101: state_type > $o ).

tff(pred_def_61564,type,
    v109099: state_type > $o ).

tff(pred_def_61565,type,
    v109098: state_type > $o ).

tff(pred_def_61566,type,
    v109097: state_type > $o ).

tff(pred_def_61567,type,
    v109109: state_type > $o ).

tff(pred_def_61568,type,
    v109110: state_type > $o ).

tff(pred_def_61569,type,
    v109108: state_type > $o ).

tff(pred_def_61570,type,
    v109105: ( state_type * $int ) > $o ).

tff(pred_def_61571,type,
    v109107: ( state_type * $int ) > $o ).

tff(pred_def_61572,type,
    v109096: ( state_type * $int ) > $o ).

tff(pred_def_61573,type,
    v89257: ( state_type * $int ) > $o ).

tff(pred_def_61574,type,
    v89253: ( state_type * $int ) > $o ).

tff(pred_def_61575,type,
    v109122: state_type > $o ).

tff(pred_def_61576,type,
    v109120: state_type > $o ).

tff(pred_def_61577,type,
    v109126: state_type > $o ).

tff(pred_def_61578,type,
    v109124: state_type > $o ).

tff(pred_def_61579,type,
    v109135: ( state_type * $int ) > $o ).

tff(pred_def_61580,type,
    v109134: ( state_type * $int ) > $o ).

tff(pred_def_61581,type,
    v109132: ( state_type * $int ) > $o ).

tff(pred_def_61582,type,
    v109142: state_type > $o ).

tff(pred_def_61583,type,
    v170: state_type > $o ).

tff(pred_def_61584,type,
    v109141: state_type > $o ).

tff(pred_def_61585,type,
    v89383: ( state_type * $int ) > $o ).

tff(pred_def_61586,type,
    v109149: state_type > $o ).

tff(pred_def_61587,type,
    v109148: state_type > $o ).

tff(pred_def_61588,type,
    v109147: state_type > $o ).

tff(pred_def_61589,type,
    v109146: state_type > $o ).

tff(pred_def_61590,type,
    v109145: state_type > $o ).

tff(pred_def_61591,type,
    v109143: state_type > $o ).

tff(pred_def_61592,type,
    v109139: state_type > $o ).

tff(pred_def_61593,type,
    v109137: state_type > $o ).

tff(pred_def_61594,type,
    v109153: state_type > $o ).

tff(pred_def_61595,type,
    v109152: ( state_type * $int ) > $o ).

tff(pred_def_61596,type,
    v109151: ( state_type * $int ) > $o ).

tff(pred_def_61597,type,
    v109157: state_type > $o ).

tff(pred_def_61598,type,
    v109156: ( state_type * $int ) > $o ).

tff(pred_def_61599,type,
    v109155: ( state_type * $int ) > $o ).

tff(pred_def_61600,type,
    v109116: ( state_type * $int ) > $o ).

tff(pred_def_61601,type,
    v109154: ( state_type * $int ) > $o ).

tff(pred_def_61602,type,
    v109150: ( state_type * $int ) > $o ).

tff(pred_def_61603,type,
    v109130: ( state_type * $int ) > $o ).

tff(pred_def_61604,type,
    v109128: ( state_type * $int ) > $o ).

tff(pred_def_61605,type,
    v109161: state_type > $o ).

tff(pred_def_61606,type,
    v109159: state_type > $o ).

tff(pred_def_61607,type,
    v109168: state_type > $o ).

tff(pred_def_61608,type,
    v109166: state_type > $o ).

tff(pred_def_61609,type,
    v109165: state_type > $o ).

tff(pred_def_61610,type,
    v109164: state_type > $o ).

tff(pred_def_61611,type,
    v109176: state_type > $o ).

tff(pred_def_61612,type,
    v109177: state_type > $o ).

tff(pred_def_61613,type,
    v109175: state_type > $o ).

tff(pred_def_61614,type,
    v109172: ( state_type * $int ) > $o ).

tff(pred_def_61615,type,
    v109174: ( state_type * $int ) > $o ).

tff(pred_def_61616,type,
    v109163: ( state_type * $int ) > $o ).

tff(pred_def_61617,type,
    v109118: ( state_type * $int ) > $o ).

tff(pred_def_61618,type,
    v109114: ( state_type * $int ) > $o ).

tff(pred_def_61619,type,
    v109189: state_type > $o ).

tff(pred_def_61620,type,
    v109187: state_type > $o ).

tff(pred_def_61621,type,
    v109193: state_type > $o ).

tff(pred_def_61622,type,
    v109191: state_type > $o ).

tff(pred_def_61623,type,
    v109202: ( state_type * $int ) > $o ).

tff(pred_def_61624,type,
    v109201: ( state_type * $int ) > $o ).

tff(pred_def_61625,type,
    v109199: ( state_type * $int ) > $o ).

tff(pred_def_61626,type,
    v109209: state_type > $o ).

tff(pred_def_61627,type,
    v109208: state_type > $o ).

tff(pred_def_61628,type,
    v109210: state_type > $o ).

tff(pred_def_61629,type,
    v109206: state_type > $o ).

tff(pred_def_61630,type,
    v109204: state_type > $o ).

tff(pred_def_61631,type,
    v109214: state_type > $o ).

tff(pred_def_61632,type,
    v109213: ( state_type * $int ) > $o ).

tff(pred_def_61633,type,
    v109212: ( state_type * $int ) > $o ).

tff(pred_def_61634,type,
    v109218: state_type > $o ).

tff(pred_def_61635,type,
    v109217: ( state_type * $int ) > $o ).

tff(pred_def_61636,type,
    v109216: ( state_type * $int ) > $o ).

tff(pred_def_61637,type,
    v109183: ( state_type * $int ) > $o ).

tff(pred_def_61638,type,
    v109215: ( state_type * $int ) > $o ).

tff(pred_def_61639,type,
    v109211: ( state_type * $int ) > $o ).

tff(pred_def_61640,type,
    v109197: ( state_type * $int ) > $o ).

tff(pred_def_61641,type,
    v109195: ( state_type * $int ) > $o ).

tff(pred_def_61642,type,
    v109222: state_type > $o ).

tff(pred_def_61643,type,
    v109220: state_type > $o ).

tff(pred_def_61644,type,
    v109229: state_type > $o ).

tff(pred_def_61645,type,
    v109227: state_type > $o ).

tff(pred_def_61646,type,
    v109226: state_type > $o ).

tff(pred_def_61647,type,
    v109225: state_type > $o ).

tff(pred_def_61648,type,
    v109237: state_type > $o ).

tff(pred_def_61649,type,
    v109238: state_type > $o ).

tff(pred_def_61650,type,
    v109236: state_type > $o ).

tff(pred_def_61651,type,
    v109233: ( state_type * $int ) > $o ).

tff(pred_def_61652,type,
    v109235: ( state_type * $int ) > $o ).

tff(pred_def_61653,type,
    v109224: ( state_type * $int ) > $o ).

tff(pred_def_61654,type,
    v109185: ( state_type * $int ) > $o ).

tff(pred_def_61655,type,
    v109181: ( state_type * $int ) > $o ).

tff(pred_def_61656,type,
    v109250: state_type > $o ).

tff(pred_def_61657,type,
    v109248: state_type > $o ).

tff(pred_def_61658,type,
    v109254: state_type > $o ).

tff(pred_def_61659,type,
    v109252: state_type > $o ).

tff(pred_def_61660,type,
    v109263: ( state_type * $int ) > $o ).

tff(pred_def_61661,type,
    v109262: ( state_type * $int ) > $o ).

tff(pred_def_61662,type,
    v109260: ( state_type * $int ) > $o ).

tff(pred_def_61663,type,
    v109270: state_type > $o ).

tff(pred_def_61664,type,
    v109269: state_type > $o ).

tff(pred_def_61665,type,
    v109271: state_type > $o ).

tff(pred_def_61666,type,
    v109267: state_type > $o ).

tff(pred_def_61667,type,
    v109265: state_type > $o ).

tff(pred_def_61668,type,
    v109275: state_type > $o ).

tff(pred_def_61669,type,
    v109274: ( state_type * $int ) > $o ).

tff(pred_def_61670,type,
    v109273: ( state_type * $int ) > $o ).

tff(pred_def_61671,type,
    v109279: state_type > $o ).

tff(pred_def_61672,type,
    v109278: ( state_type * $int ) > $o ).

tff(pred_def_61673,type,
    v109277: ( state_type * $int ) > $o ).

tff(pred_def_61674,type,
    v109244: ( state_type * $int ) > $o ).

tff(pred_def_61675,type,
    v109276: ( state_type * $int ) > $o ).

tff(pred_def_61676,type,
    v109272: ( state_type * $int ) > $o ).

tff(pred_def_61677,type,
    v109258: ( state_type * $int ) > $o ).

tff(pred_def_61678,type,
    v109256: ( state_type * $int ) > $o ).

tff(pred_def_61679,type,
    v109283: state_type > $o ).

tff(pred_def_61680,type,
    v109281: state_type > $o ).

tff(pred_def_61681,type,
    v109290: state_type > $o ).

tff(pred_def_61682,type,
    v109288: state_type > $o ).

tff(pred_def_61683,type,
    v109287: state_type > $o ).

tff(pred_def_61684,type,
    v109286: state_type > $o ).

tff(pred_def_61685,type,
    v109298: state_type > $o ).

tff(pred_def_61686,type,
    v109299: state_type > $o ).

tff(pred_def_61687,type,
    v109297: state_type > $o ).

tff(pred_def_61688,type,
    v109294: ( state_type * $int ) > $o ).

tff(pred_def_61689,type,
    v109296: ( state_type * $int ) > $o ).

tff(pred_def_61690,type,
    v109285: ( state_type * $int ) > $o ).

tff(pred_def_61691,type,
    v109246: ( state_type * $int ) > $o ).

tff(pred_def_61692,type,
    v109242: ( state_type * $int ) > $o ).

tff(pred_def_61693,type,
    v109311: state_type > $o ).

tff(pred_def_61694,type,
    v109309: state_type > $o ).

tff(pred_def_61695,type,
    v109315: state_type > $o ).

tff(pred_def_61696,type,
    v109313: state_type > $o ).

tff(pred_def_61697,type,
    v109324: ( state_type * $int ) > $o ).

tff(pred_def_61698,type,
    v109323: ( state_type * $int ) > $o ).

tff(pred_def_61699,type,
    v109321: ( state_type * $int ) > $o ).

tff(pred_def_61700,type,
    v109331: state_type > $o ).

tff(pred_def_61701,type,
    v109330: state_type > $o ).

tff(pred_def_61702,type,
    v109332: state_type > $o ).

tff(pred_def_61703,type,
    v109328: state_type > $o ).

tff(pred_def_61704,type,
    v109326: state_type > $o ).

tff(pred_def_61705,type,
    v109336: state_type > $o ).

tff(pred_def_61706,type,
    v109335: ( state_type * $int ) > $o ).

tff(pred_def_61707,type,
    v109334: ( state_type * $int ) > $o ).

tff(pred_def_61708,type,
    v109340: state_type > $o ).

tff(pred_def_61709,type,
    v109339: ( state_type * $int ) > $o ).

tff(pred_def_61710,type,
    v109338: ( state_type * $int ) > $o ).

tff(pred_def_61711,type,
    v109305: ( state_type * $int ) > $o ).

tff(pred_def_61712,type,
    v109337: ( state_type * $int ) > $o ).

tff(pred_def_61713,type,
    v109333: ( state_type * $int ) > $o ).

tff(pred_def_61714,type,
    v109319: ( state_type * $int ) > $o ).

tff(pred_def_61715,type,
    v109317: ( state_type * $int ) > $o ).

tff(pred_def_61716,type,
    v109344: state_type > $o ).

tff(pred_def_61717,type,
    v109342: state_type > $o ).

tff(pred_def_61718,type,
    v109351: state_type > $o ).

tff(pred_def_61719,type,
    v109349: state_type > $o ).

tff(pred_def_61720,type,
    v109348: state_type > $o ).

tff(pred_def_61721,type,
    v109347: state_type > $o ).

tff(pred_def_61722,type,
    v109359: state_type > $o ).

tff(pred_def_61723,type,
    v109360: state_type > $o ).

tff(pred_def_61724,type,
    v109358: state_type > $o ).

tff(pred_def_61725,type,
    v109355: ( state_type * $int ) > $o ).

tff(pred_def_61726,type,
    v109357: ( state_type * $int ) > $o ).

tff(pred_def_61727,type,
    v109346: ( state_type * $int ) > $o ).

tff(pred_def_61728,type,
    v109307: ( state_type * $int ) > $o ).

tff(pred_def_61729,type,
    v109303: ( state_type * $int ) > $o ).

tff(pred_def_61730,type,
    v109372: state_type > $o ).

tff(pred_def_61731,type,
    v109370: state_type > $o ).

tff(pred_def_61732,type,
    v109376: state_type > $o ).

tff(pred_def_61733,type,
    v109374: state_type > $o ).

tff(pred_def_61734,type,
    v109385: ( state_type * $int ) > $o ).

tff(pred_def_61735,type,
    v109384: ( state_type * $int ) > $o ).

tff(pred_def_61736,type,
    v109382: ( state_type * $int ) > $o ).

tff(pred_def_61737,type,
    v109392: state_type > $o ).

tff(pred_def_61738,type,
    v109391: state_type > $o ).

tff(pred_def_61739,type,
    v109393: state_type > $o ).

tff(pred_def_61740,type,
    v109389: state_type > $o ).

tff(pred_def_61741,type,
    v109387: state_type > $o ).

tff(pred_def_61742,type,
    v109397: state_type > $o ).

tff(pred_def_61743,type,
    v109396: ( state_type * $int ) > $o ).

tff(pred_def_61744,type,
    v109395: ( state_type * $int ) > $o ).

tff(pred_def_61745,type,
    v109401: state_type > $o ).

tff(pred_def_61746,type,
    v109400: ( state_type * $int ) > $o ).

tff(pred_def_61747,type,
    v109399: ( state_type * $int ) > $o ).

tff(pred_def_61748,type,
    v109366: ( state_type * $int ) > $o ).

tff(pred_def_61749,type,
    v109398: ( state_type * $int ) > $o ).

tff(pred_def_61750,type,
    v109394: ( state_type * $int ) > $o ).

tff(pred_def_61751,type,
    v109380: ( state_type * $int ) > $o ).

tff(pred_def_61752,type,
    v109378: ( state_type * $int ) > $o ).

tff(pred_def_61753,type,
    v109405: state_type > $o ).

tff(pred_def_61754,type,
    v109403: state_type > $o ).

tff(pred_def_61755,type,
    v109412: state_type > $o ).

tff(pred_def_61756,type,
    v109410: state_type > $o ).

tff(pred_def_61757,type,
    v109409: state_type > $o ).

tff(pred_def_61758,type,
    v109408: state_type > $o ).

tff(pred_def_61759,type,
    v109420: state_type > $o ).

tff(pred_def_61760,type,
    v109421: state_type > $o ).

tff(pred_def_61761,type,
    v109419: state_type > $o ).

tff(pred_def_61762,type,
    v109416: ( state_type * $int ) > $o ).

tff(pred_def_61763,type,
    v109418: ( state_type * $int ) > $o ).

tff(pred_def_61764,type,
    v109407: ( state_type * $int ) > $o ).

tff(pred_def_61765,type,
    v109368: ( state_type * $int ) > $o ).

tff(pred_def_61766,type,
    v109364: ( state_type * $int ) > $o ).

tff(pred_def_61767,type,
    v109433: state_type > $o ).

tff(pred_def_61768,type,
    v109431: state_type > $o ).

tff(pred_def_61769,type,
    v109437: state_type > $o ).

tff(pred_def_61770,type,
    v109435: state_type > $o ).

tff(pred_def_61771,type,
    v109446: ( state_type * $int ) > $o ).

tff(pred_def_61772,type,
    v109445: ( state_type * $int ) > $o ).

tff(pred_def_61773,type,
    v109443: ( state_type * $int ) > $o ).

tff(pred_def_61774,type,
    v109453: state_type > $o ).

tff(pred_def_61775,type,
    v109452: state_type > $o ).

tff(pred_def_61776,type,
    v109454: state_type > $o ).

tff(pred_def_61777,type,
    v109450: state_type > $o ).

tff(pred_def_61778,type,
    v109448: state_type > $o ).

tff(pred_def_61779,type,
    v109458: state_type > $o ).

tff(pred_def_61780,type,
    v109457: ( state_type * $int ) > $o ).

tff(pred_def_61781,type,
    v109456: ( state_type * $int ) > $o ).

tff(pred_def_61782,type,
    v109462: state_type > $o ).

tff(pred_def_61783,type,
    v109461: ( state_type * $int ) > $o ).

tff(pred_def_61784,type,
    v109460: ( state_type * $int ) > $o ).

tff(pred_def_61785,type,
    v109427: ( state_type * $int ) > $o ).

tff(pred_def_61786,type,
    v109459: ( state_type * $int ) > $o ).

tff(pred_def_61787,type,
    v109455: ( state_type * $int ) > $o ).

tff(pred_def_61788,type,
    v109441: ( state_type * $int ) > $o ).

tff(pred_def_61789,type,
    v109439: ( state_type * $int ) > $o ).

tff(pred_def_61790,type,
    v109466: state_type > $o ).

tff(pred_def_61791,type,
    v109464: state_type > $o ).

tff(pred_def_61792,type,
    v109473: state_type > $o ).

tff(pred_def_61793,type,
    v109471: state_type > $o ).

tff(pred_def_61794,type,
    v109470: state_type > $o ).

tff(pred_def_61795,type,
    v109469: state_type > $o ).

tff(pred_def_61796,type,
    v109481: state_type > $o ).

tff(pred_def_61797,type,
    v109482: state_type > $o ).

tff(pred_def_61798,type,
    v109480: state_type > $o ).

tff(pred_def_61799,type,
    v109477: ( state_type * $int ) > $o ).

tff(pred_def_61800,type,
    v109479: ( state_type * $int ) > $o ).

tff(pred_def_61801,type,
    v109468: ( state_type * $int ) > $o ).

tff(pred_def_61802,type,
    v109429: ( state_type * $int ) > $o ).

tff(pred_def_61803,type,
    v109425: ( state_type * $int ) > $o ).

tff(pred_def_61804,type,
    v109494: state_type > $o ).

tff(pred_def_61805,type,
    v109492: state_type > $o ).

tff(pred_def_61806,type,
    v109498: state_type > $o ).

tff(pred_def_61807,type,
    v109496: state_type > $o ).

tff(pred_def_61808,type,
    v109507: ( state_type * $int ) > $o ).

tff(pred_def_61809,type,
    v109506: ( state_type * $int ) > $o ).

tff(pred_def_61810,type,
    v109504: ( state_type * $int ) > $o ).

tff(pred_def_61811,type,
    v109514: state_type > $o ).

tff(pred_def_61812,type,
    v109513: state_type > $o ).

tff(pred_def_61813,type,
    v109511: state_type > $o ).

tff(pred_def_61814,type,
    v109509: state_type > $o ).

tff(pred_def_61815,type,
    v109518: state_type > $o ).

tff(pred_def_61816,type,
    v109517: ( state_type * $int ) > $o ).

tff(pred_def_61817,type,
    v109516: ( state_type * $int ) > $o ).

tff(pred_def_61818,type,
    v109522: state_type > $o ).

tff(pred_def_61819,type,
    v109521: ( state_type * $int ) > $o ).

tff(pred_def_61820,type,
    v109520: ( state_type * $int ) > $o ).

tff(pred_def_61821,type,
    v109488: ( state_type * $int ) > $o ).

tff(pred_def_61822,type,
    v109519: ( state_type * $int ) > $o ).

tff(pred_def_61823,type,
    v109515: ( state_type * $int ) > $o ).

tff(pred_def_61824,type,
    v109502: ( state_type * $int ) > $o ).

tff(pred_def_61825,type,
    v109500: ( state_type * $int ) > $o ).

tff(pred_def_61826,type,
    v109526: state_type > $o ).

tff(pred_def_61827,type,
    v109524: state_type > $o ).

tff(pred_def_61828,type,
    v109533: state_type > $o ).

tff(pred_def_61829,type,
    v109531: state_type > $o ).

tff(pred_def_61830,type,
    v109530: state_type > $o ).

tff(pred_def_61831,type,
    v109529: state_type > $o ).

tff(pred_def_61832,type,
    v109541: state_type > $o ).

tff(pred_def_61833,type,
    v109542: state_type > $o ).

tff(pred_def_61834,type,
    v109540: state_type > $o ).

tff(pred_def_61835,type,
    v109537: ( state_type * $int ) > $o ).

tff(pred_def_61836,type,
    v109539: ( state_type * $int ) > $o ).

tff(pred_def_61837,type,
    v109528: ( state_type * $int ) > $o ).

tff(pred_def_61838,type,
    v109490: ( state_type * $int ) > $o ).

tff(pred_def_61839,type,
    v109486: ( state_type * $int ) > $o ).

tff(pred_def_61840,type,
    v109550: state_type > $o ).

tff(pred_def_61841,type,
    v109548: state_type > $o ).

tff(pred_def_61842,type,
    v109547: state_type > $o ).

tff(pred_def_61843,type,
    v109546: ( state_type * $int ) > $o ).

tff(pred_def_61844,type,
    v109558: state_type > $o ).

tff(pred_def_61845,type,
    v109556: state_type > $o ).

tff(pred_def_61846,type,
    v109555: state_type > $o ).

tff(pred_def_61847,type,
    v109554: ( state_type * $int ) > $o ).

tff(pred_def_61848,type,
    v109566: state_type > $o ).

tff(pred_def_61849,type,
    v109564: state_type > $o ).

tff(pred_def_61850,type,
    v109563: state_type > $o ).

tff(pred_def_61851,type,
    v109562: ( state_type * $int ) > $o ).

tff(pred_def_61852,type,
    v109574: state_type > $o ).

tff(pred_def_61853,type,
    v109572: state_type > $o ).

tff(pred_def_61854,type,
    v109571: state_type > $o ).

tff(pred_def_61855,type,
    v109570: ( state_type * $int ) > $o ).

tff(pred_def_61856,type,
    v109582: state_type > $o ).

tff(pred_def_61857,type,
    v109580: state_type > $o ).

tff(pred_def_61858,type,
    v109579: state_type > $o ).

tff(pred_def_61859,type,
    v109578: ( state_type * $int ) > $o ).

tff(pred_def_61860,type,
    v109590: state_type > $o ).

tff(pred_def_61861,type,
    v109588: state_type > $o ).

tff(pred_def_61862,type,
    v109587: state_type > $o ).

tff(pred_def_61863,type,
    v109586: ( state_type * $int ) > $o ).

tff(pred_def_61864,type,
    v109598: state_type > $o ).

tff(pred_def_61865,type,
    v109596: state_type > $o ).

tff(pred_def_61866,type,
    v109595: state_type > $o ).

tff(pred_def_61867,type,
    v109594: ( state_type * $int ) > $o ).

tff(pred_def_61868,type,
    v109606: state_type > $o ).

tff(pred_def_61869,type,
    v109604: state_type > $o ).

tff(pred_def_61870,type,
    v109603: state_type > $o ).

tff(pred_def_61871,type,
    v109602: ( state_type * $int ) > $o ).

tff(pred_def_61872,type,
    v109617: ( state_type * $int ) > $o ).

tff(pred_def_61873,type,
    v109616: ( state_type * $int ) > $o ).

tff(pred_def_61874,type,
    v109619: ( state_type * $int ) > $o ).

tff(pred_def_61875,type,
    v109618: ( state_type * $int ) > $o ).

tff(pred_def_61876,type,
    v109615: ( state_type * $int ) > $o ).

tff(pred_def_61877,type,
    v109621: ( state_type * $int ) > $o ).

tff(pred_def_61878,type,
    v109620: ( state_type * $int ) > $o ).

tff(pred_def_61879,type,
    v109614: ( state_type * $int ) > $o ).

tff(pred_def_61880,type,
    v109623: ( state_type * $int ) > $o ).

tff(pred_def_61881,type,
    v109622: ( state_type * $int ) > $o ).

tff(pred_def_61882,type,
    v109613: ( state_type * $int ) > $o ).

tff(pred_def_61883,type,
    v109625: ( state_type * $int ) > $o ).

tff(pred_def_61884,type,
    v109624: ( state_type * $int ) > $o ).

tff(pred_def_61885,type,
    v109612: ( state_type * $int ) > $o ).

tff(pred_def_61886,type,
    v109627: ( state_type * $int ) > $o ).

tff(pred_def_61887,type,
    v109626: ( state_type * $int ) > $o ).

tff(pred_def_61888,type,
    v109611: ( state_type * $int ) > $o ).

tff(pred_def_61889,type,
    v109629: ( state_type * $int ) > $o ).

tff(pred_def_61890,type,
    v109628: ( state_type * $int ) > $o ).

tff(pred_def_61891,type,
    v109610: ( state_type * $int ) > $o ).

tff(pred_def_61892,type,
    v109631: ( state_type * $int ) > $o ).

tff(pred_def_61893,type,
    v109630: ( state_type * $int ) > $o ).

tff(pred_def_61894,type,
    v109609: ( state_type * $int ) > $o ).

tff(pred_def_61895,type,
    v89247: ( state_type * $int ) > $o ).

tff(pred_def_61896,type,
    v109640: ( state_type * $int ) > $o ).

tff(pred_def_61897,type,
    v109639: ( state_type * $int ) > $o ).

tff(pred_def_61898,type,
    v109642: ( state_type * $int ) > $o ).

tff(pred_def_61899,type,
    v109641: ( state_type * $int ) > $o ).

tff(pred_def_61900,type,
    v109638: ( state_type * $int ) > $o ).

tff(pred_def_61901,type,
    v109644: ( state_type * $int ) > $o ).

tff(pred_def_61902,type,
    v109643: ( state_type * $int ) > $o ).

tff(pred_def_61903,type,
    v109637: ( state_type * $int ) > $o ).

tff(pred_def_61904,type,
    v109646: ( state_type * $int ) > $o ).

tff(pred_def_61905,type,
    v109645: ( state_type * $int ) > $o ).

tff(pred_def_61906,type,
    v109636: ( state_type * $int ) > $o ).

tff(pred_def_61907,type,
    v109648: ( state_type * $int ) > $o ).

tff(pred_def_61908,type,
    v109647: ( state_type * $int ) > $o ).

tff(pred_def_61909,type,
    v109635: ( state_type * $int ) > $o ).

tff(pred_def_61910,type,
    v109650: ( state_type * $int ) > $o ).

tff(pred_def_61911,type,
    v109649: ( state_type * $int ) > $o ).

tff(pred_def_61912,type,
    v109634: ( state_type * $int ) > $o ).

tff(pred_def_61913,type,
    v109652: ( state_type * $int ) > $o ).

tff(pred_def_61914,type,
    v109651: ( state_type * $int ) > $o ).

tff(pred_def_61915,type,
    v109633: ( state_type * $int ) > $o ).

tff(pred_def_61916,type,
    v109654: ( state_type * $int ) > $o ).

tff(pred_def_61917,type,
    v109653: ( state_type * $int ) > $o ).

tff(pred_def_61918,type,
    v109656: state_type > $o ).

tff(pred_def_61919,type,
    v109657: state_type > $o ).

tff(pred_def_61920,type,
    v89245: ( state_type * $int ) > $o ).

tff(pred_def_61921,type,
    v109671: state_type > $o ).

tff(pred_def_61922,type,
    v109669: state_type > $o ).

tff(pred_def_61923,type,
    v109668: state_type > $o ).

tff(pred_def_61924,type,
    v109667: ( state_type * $int ) > $o ).

tff(pred_def_61925,type,
    v109677: state_type > $o ).

tff(pred_def_61926,type,
    v5743: state_type > $o ).

tff(pred_def_61927,type,
    v109676: ( state_type * $int ) > $o ).

tff(pred_def_61928,type,
    v109675: ( state_type * $int ) > $o ).

tff(pred_def_61929,type,
    v109681: state_type > $o ).

tff(pred_def_61930,type,
    v109680: ( state_type * $int ) > $o ).

tff(pred_def_61931,type,
    v109679: ( state_type * $int ) > $o ).

tff(pred_def_61932,type,
    v5693: ( state_type * $int ) > $o ).

tff(pred_def_61933,type,
    v109678: ( state_type * $int ) > $o ).

tff(pred_def_61934,type,
    v109674: ( state_type * $int ) > $o ).

tff(pred_def_61935,type,
    v5707: ( state_type * $int ) > $o ).

tff(pred_def_61936,type,
    v5705: ( state_type * $int ) > $o ).

tff(pred_def_61937,type,
    v109685: state_type > $o ).

tff(pred_def_61938,type,
    v109683: state_type > $o ).

tff(pred_def_61939,type,
    v109692: state_type > $o ).

tff(pred_def_61940,type,
    v109690: state_type > $o ).

tff(pred_def_61941,type,
    v109689: state_type > $o ).

tff(pred_def_61942,type,
    v109688: state_type > $o ).

tff(pred_def_61943,type,
    v109700: state_type > $o ).

tff(pred_def_61944,type,
    v109701: state_type > $o ).

tff(pred_def_61945,type,
    v109699: state_type > $o ).

tff(pred_def_61946,type,
    v109696: ( state_type * $int ) > $o ).

tff(pred_def_61947,type,
    v109698: ( state_type * $int ) > $o ).

tff(pred_def_61948,type,
    v109687: ( state_type * $int ) > $o ).

tff(pred_def_61949,type,
    v5695: ( state_type * $int ) > $o ).

tff(pred_def_61950,type,
    v109665: state_type > $o ).

tff(pred_def_61951,type,
    v109663: state_type > $o ).

tff(pred_def_61952,type,
    v109709: ( state_type * $int ) > $o ).

tff(pred_def_61953,type,
    v109711: ( state_type * $int ) > $o ).

tff(pred_def_61954,type,
    v109718: state_type > $o ).

tff(pred_def_61955,type,
    v109716: state_type > $o ).

tff(pred_def_61956,type,
    v109715: state_type > $o ).

tff(pred_def_61957,type,
    v109714: ( state_type * $int ) > $o ).

tff(pred_def_61958,type,
    v109726: state_type > $o ).

tff(pred_def_61959,type,
    v109724: state_type > $o ).

tff(pred_def_61960,type,
    v109723: state_type > $o ).

tff(pred_def_61961,type,
    v109722: ( state_type * $int ) > $o ).

tff(pred_def_61962,type,
    v109734: state_type > $o ).

tff(pred_def_61963,type,
    v109732: state_type > $o ).

tff(pred_def_61964,type,
    v109731: state_type > $o ).

tff(pred_def_61965,type,
    v109730: ( state_type * $int ) > $o ).

tff(pred_def_61966,type,
    v109742: state_type > $o ).

tff(pred_def_61967,type,
    v109740: state_type > $o ).

tff(pred_def_61968,type,
    v109739: state_type > $o ).

tff(pred_def_61969,type,
    v109738: ( state_type * $int ) > $o ).

tff(pred_def_61970,type,
    v109750: state_type > $o ).

tff(pred_def_61971,type,
    v109748: state_type > $o ).

tff(pred_def_61972,type,
    v109747: state_type > $o ).

tff(pred_def_61973,type,
    v109746: ( state_type * $int ) > $o ).

tff(pred_def_61974,type,
    v109758: state_type > $o ).

tff(pred_def_61975,type,
    v109756: state_type > $o ).

tff(pred_def_61976,type,
    v109755: state_type > $o ).

tff(pred_def_61977,type,
    v109754: ( state_type * $int ) > $o ).

tff(pred_def_61978,type,
    v109766: state_type > $o ).

tff(pred_def_61979,type,
    v109764: state_type > $o ).

tff(pred_def_61980,type,
    v109763: state_type > $o ).

tff(pred_def_61981,type,
    v109762: ( state_type * $int ) > $o ).

tff(pred_def_61982,type,
    v109774: state_type > $o ).

tff(pred_def_61983,type,
    v109772: state_type > $o ).

tff(pred_def_61984,type,
    v109771: state_type > $o ).

tff(pred_def_61985,type,
    v109770: ( state_type * $int ) > $o ).

tff(pred_def_61986,type,
    v109782: state_type > $o ).

tff(pred_def_61987,type,
    v109780: state_type > $o ).

tff(pred_def_61988,type,
    v109779: state_type > $o ).

tff(pred_def_61989,type,
    v109778: ( state_type * $int ) > $o ).

tff(pred_def_61990,type,
    v109790: state_type > $o ).

tff(pred_def_61991,type,
    v109788: state_type > $o ).

tff(pred_def_61992,type,
    v109787: state_type > $o ).

tff(pred_def_61993,type,
    v109786: ( state_type * $int ) > $o ).

tff(pred_def_61994,type,
    v109798: state_type > $o ).

tff(pred_def_61995,type,
    v109796: state_type > $o ).

tff(pred_def_61996,type,
    v109795: state_type > $o ).

tff(pred_def_61997,type,
    v109794: ( state_type * $int ) > $o ).

tff(pred_def_61998,type,
    v109806: state_type > $o ).

tff(pred_def_61999,type,
    v109804: state_type > $o ).

tff(pred_def_62000,type,
    v109803: state_type > $o ).

tff(pred_def_62001,type,
    v109802: ( state_type * $int ) > $o ).

tff(pred_def_62002,type,
    v109814: state_type > $o ).

tff(pred_def_62003,type,
    v109812: state_type > $o ).

tff(pred_def_62004,type,
    v109811: state_type > $o ).

tff(pred_def_62005,type,
    v109810: ( state_type * $int ) > $o ).

tff(pred_def_62006,type,
    v109822: state_type > $o ).

tff(pred_def_62007,type,
    v109820: state_type > $o ).

tff(pred_def_62008,type,
    v109819: state_type > $o ).

tff(pred_def_62009,type,
    v109818: ( state_type * $int ) > $o ).

tff(pred_def_62010,type,
    v109830: state_type > $o ).

tff(pred_def_62011,type,
    v109828: state_type > $o ).

tff(pred_def_62012,type,
    v109827: state_type > $o ).

tff(pred_def_62013,type,
    v109826: ( state_type * $int ) > $o ).

tff(pred_def_62014,type,
    v109838: state_type > $o ).

tff(pred_def_62015,type,
    v109836: state_type > $o ).

tff(pred_def_62016,type,
    v109835: state_type > $o ).

tff(pred_def_62017,type,
    v109834: ( state_type * $int ) > $o ).

tff(pred_def_62018,type,
    v109846: state_type > $o ).

tff(pred_def_62019,type,
    v109844: state_type > $o ).

tff(pred_def_62020,type,
    v109843: state_type > $o ).

tff(pred_def_62021,type,
    v109842: ( state_type * $int ) > $o ).

tff(pred_def_62022,type,
    v109854: state_type > $o ).

tff(pred_def_62023,type,
    v109852: state_type > $o ).

tff(pred_def_62024,type,
    v109851: state_type > $o ).

tff(pred_def_62025,type,
    v109850: ( state_type * $int ) > $o ).

tff(pred_def_62026,type,
    v109862: state_type > $o ).

tff(pred_def_62027,type,
    v109860: state_type > $o ).

tff(pred_def_62028,type,
    v109859: state_type > $o ).

tff(pred_def_62029,type,
    v109858: ( state_type * $int ) > $o ).

tff(pred_def_62030,type,
    v109870: state_type > $o ).

tff(pred_def_62031,type,
    v109868: state_type > $o ).

tff(pred_def_62032,type,
    v109867: state_type > $o ).

tff(pred_def_62033,type,
    v109866: ( state_type * $int ) > $o ).

tff(pred_def_62034,type,
    v109878: state_type > $o ).

tff(pred_def_62035,type,
    v109876: state_type > $o ).

tff(pred_def_62036,type,
    v109875: state_type > $o ).

tff(pred_def_62037,type,
    v109874: ( state_type * $int ) > $o ).

tff(pred_def_62038,type,
    v109886: state_type > $o ).

tff(pred_def_62039,type,
    v109884: state_type > $o ).

tff(pred_def_62040,type,
    v109883: state_type > $o ).

tff(pred_def_62041,type,
    v109882: ( state_type * $int ) > $o ).

tff(pred_def_62042,type,
    v109894: state_type > $o ).

tff(pred_def_62043,type,
    v109892: state_type > $o ).

tff(pred_def_62044,type,
    v109891: state_type > $o ).

tff(pred_def_62045,type,
    v109890: ( state_type * $int ) > $o ).

tff(pred_def_62046,type,
    v109902: state_type > $o ).

tff(pred_def_62047,type,
    v109900: state_type > $o ).

tff(pred_def_62048,type,
    v109899: state_type > $o ).

tff(pred_def_62049,type,
    v109898: ( state_type * $int ) > $o ).

tff(pred_def_62050,type,
    v109910: state_type > $o ).

tff(pred_def_62051,type,
    v109908: state_type > $o ).

tff(pred_def_62052,type,
    v109907: state_type > $o ).

tff(pred_def_62053,type,
    v109906: ( state_type * $int ) > $o ).

tff(pred_def_62054,type,
    v109918: state_type > $o ).

tff(pred_def_62055,type,
    v109916: state_type > $o ).

tff(pred_def_62056,type,
    v109915: state_type > $o ).

tff(pred_def_62057,type,
    v109914: ( state_type * $int ) > $o ).

tff(pred_def_62058,type,
    v109926: state_type > $o ).

tff(pred_def_62059,type,
    v109924: state_type > $o ).

tff(pred_def_62060,type,
    v109923: state_type > $o ).

tff(pred_def_62061,type,
    v109922: ( state_type * $int ) > $o ).

tff(pred_def_62062,type,
    v109934: state_type > $o ).

tff(pred_def_62063,type,
    v109932: state_type > $o ).

tff(pred_def_62064,type,
    v109931: state_type > $o ).

tff(pred_def_62065,type,
    v109930: ( state_type * $int ) > $o ).

tff(pred_def_62066,type,
    v109942: state_type > $o ).

tff(pred_def_62067,type,
    v109940: state_type > $o ).

tff(pred_def_62068,type,
    v109939: state_type > $o ).

tff(pred_def_62069,type,
    v109938: ( state_type * $int ) > $o ).

tff(pred_def_62070,type,
    v109950: state_type > $o ).

tff(pred_def_62071,type,
    v109948: state_type > $o ).

tff(pred_def_62072,type,
    v109947: state_type > $o ).

tff(pred_def_62073,type,
    v109946: ( state_type * $int ) > $o ).

tff(pred_def_62074,type,
    v109958: state_type > $o ).

tff(pred_def_62075,type,
    v109956: state_type > $o ).

tff(pred_def_62076,type,
    v109955: state_type > $o ).

tff(pred_def_62077,type,
    v109954: ( state_type * $int ) > $o ).

tff(pred_def_62078,type,
    v109966: state_type > $o ).

tff(pred_def_62079,type,
    v109964: state_type > $o ).

tff(pred_def_62080,type,
    v109963: state_type > $o ).

tff(pred_def_62081,type,
    v109962: ( state_type * $int ) > $o ).

tff(pred_def_62082,type,
    v109974: state_type > $o ).

tff(pred_def_62083,type,
    v109972: state_type > $o ).

tff(pred_def_62084,type,
    v109971: state_type > $o ).

tff(pred_def_62085,type,
    v109970: ( state_type * $int ) > $o ).

tff(pred_def_62086,type,
    v109982: state_type > $o ).

tff(pred_def_62087,type,
    v109980: state_type > $o ).

tff(pred_def_62088,type,
    v109979: state_type > $o ).

tff(pred_def_62089,type,
    v109978: ( state_type * $int ) > $o ).

tff(pred_def_62090,type,
    v109989: ( state_type * $int ) > $o ).

tff(pred_def_62091,type,
    v109991: ( state_type * $int ) > $o ).

tff(pred_def_62092,type,
    v109997: state_type > $o ).

tff(pred_def_62093,type,
    v109995: state_type > $o ).

tff(pred_def_62094,type,
    v109994: state_type > $o ).

tff(pred_def_62095,type,
    v109993: ( state_type * $int ) > $o ).

tff(pred_def_62096,type,
    v110005: state_type > $o ).

tff(pred_def_62097,type,
    v110003: state_type > $o ).

tff(pred_def_62098,type,
    v110002: state_type > $o ).

tff(pred_def_62099,type,
    v110001: ( state_type * $int ) > $o ).

tff(pred_def_62100,type,
    v110013: state_type > $o ).

tff(pred_def_62101,type,
    v110011: state_type > $o ).

tff(pred_def_62102,type,
    v110010: state_type > $o ).

tff(pred_def_62103,type,
    v110009: ( state_type * $int ) > $o ).

tff(pred_def_62104,type,
    v110021: state_type > $o ).

tff(pred_def_62105,type,
    v110019: state_type > $o ).

tff(pred_def_62106,type,
    v110018: state_type > $o ).

tff(pred_def_62107,type,
    v110017: ( state_type * $int ) > $o ).

tff(pred_def_62108,type,
    v110029: state_type > $o ).

tff(pred_def_62109,type,
    v110027: state_type > $o ).

tff(pred_def_62110,type,
    v110026: state_type > $o ).

tff(pred_def_62111,type,
    v110025: ( state_type * $int ) > $o ).

tff(pred_def_62112,type,
    v110037: state_type > $o ).

tff(pred_def_62113,type,
    v110035: state_type > $o ).

tff(pred_def_62114,type,
    v110034: state_type > $o ).

tff(pred_def_62115,type,
    v110033: ( state_type * $int ) > $o ).

tff(pred_def_62116,type,
    v110045: state_type > $o ).

tff(pred_def_62117,type,
    v110043: state_type > $o ).

tff(pred_def_62118,type,
    v110042: state_type > $o ).

tff(pred_def_62119,type,
    v110041: ( state_type * $int ) > $o ).

tff(pred_def_62120,type,
    v110053: state_type > $o ).

tff(pred_def_62121,type,
    v110051: state_type > $o ).

tff(pred_def_62122,type,
    v110050: state_type > $o ).

tff(pred_def_62123,type,
    v110049: ( state_type * $int ) > $o ).

tff(pred_def_62124,type,
    v110061: state_type > $o ).

tff(pred_def_62125,type,
    v110059: state_type > $o ).

tff(pred_def_62126,type,
    v110058: state_type > $o ).

tff(pred_def_62127,type,
    v110057: ( state_type * $int ) > $o ).

tff(pred_def_62128,type,
    v110069: state_type > $o ).

tff(pred_def_62129,type,
    v110067: state_type > $o ).

tff(pred_def_62130,type,
    v110066: state_type > $o ).

tff(pred_def_62131,type,
    v110065: ( state_type * $int ) > $o ).

tff(pred_def_62132,type,
    v110077: state_type > $o ).

tff(pred_def_62133,type,
    v110075: state_type > $o ).

tff(pred_def_62134,type,
    v110074: state_type > $o ).

tff(pred_def_62135,type,
    v110073: ( state_type * $int ) > $o ).

tff(pred_def_62136,type,
    v110085: state_type > $o ).

tff(pred_def_62137,type,
    v110083: state_type > $o ).

tff(pred_def_62138,type,
    v110082: state_type > $o ).

tff(pred_def_62139,type,
    v110081: ( state_type * $int ) > $o ).

tff(pred_def_62140,type,
    v110093: state_type > $o ).

tff(pred_def_62141,type,
    v110091: state_type > $o ).

tff(pred_def_62142,type,
    v110090: state_type > $o ).

tff(pred_def_62143,type,
    v110089: ( state_type * $int ) > $o ).

tff(pred_def_62144,type,
    v110101: state_type > $o ).

tff(pred_def_62145,type,
    v110099: state_type > $o ).

tff(pred_def_62146,type,
    v110098: state_type > $o ).

tff(pred_def_62147,type,
    v110097: ( state_type * $int ) > $o ).

tff(pred_def_62148,type,
    v110109: state_type > $o ).

tff(pred_def_62149,type,
    v110107: state_type > $o ).

tff(pred_def_62150,type,
    v110106: state_type > $o ).

tff(pred_def_62151,type,
    v110105: ( state_type * $int ) > $o ).

tff(pred_def_62152,type,
    v110117: state_type > $o ).

tff(pred_def_62153,type,
    v110115: state_type > $o ).

tff(pred_def_62154,type,
    v110114: state_type > $o ).

tff(pred_def_62155,type,
    v110113: ( state_type * $int ) > $o ).

tff(pred_def_62156,type,
    v110125: state_type > $o ).

tff(pred_def_62157,type,
    v110123: state_type > $o ).

tff(pred_def_62158,type,
    v110122: state_type > $o ).

tff(pred_def_62159,type,
    v110121: ( state_type * $int ) > $o ).

tff(pred_def_62160,type,
    v110133: state_type > $o ).

tff(pred_def_62161,type,
    v110131: state_type > $o ).

tff(pred_def_62162,type,
    v110130: state_type > $o ).

tff(pred_def_62163,type,
    v110129: ( state_type * $int ) > $o ).

tff(pred_def_62164,type,
    v110141: state_type > $o ).

tff(pred_def_62165,type,
    v110139: state_type > $o ).

tff(pred_def_62166,type,
    v110138: state_type > $o ).

tff(pred_def_62167,type,
    v110137: ( state_type * $int ) > $o ).

tff(pred_def_62168,type,
    v110149: state_type > $o ).

tff(pred_def_62169,type,
    v110147: state_type > $o ).

tff(pred_def_62170,type,
    v110146: state_type > $o ).

tff(pred_def_62171,type,
    v110145: ( state_type * $int ) > $o ).

tff(pred_def_62172,type,
    v110157: state_type > $o ).

tff(pred_def_62173,type,
    v110155: state_type > $o ).

tff(pred_def_62174,type,
    v110154: state_type > $o ).

tff(pred_def_62175,type,
    v110153: ( state_type * $int ) > $o ).

tff(pred_def_62176,type,
    v110165: state_type > $o ).

tff(pred_def_62177,type,
    v110163: state_type > $o ).

tff(pred_def_62178,type,
    v110162: state_type > $o ).

tff(pred_def_62179,type,
    v110161: ( state_type * $int ) > $o ).

tff(pred_def_62180,type,
    v110173: state_type > $o ).

tff(pred_def_62181,type,
    v110171: state_type > $o ).

tff(pred_def_62182,type,
    v110170: state_type > $o ).

tff(pred_def_62183,type,
    v110169: ( state_type * $int ) > $o ).

tff(pred_def_62184,type,
    v110181: state_type > $o ).

tff(pred_def_62185,type,
    v110179: state_type > $o ).

tff(pred_def_62186,type,
    v110178: state_type > $o ).

tff(pred_def_62187,type,
    v110177: ( state_type * $int ) > $o ).

tff(pred_def_62188,type,
    v110189: state_type > $o ).

tff(pred_def_62189,type,
    v110187: state_type > $o ).

tff(pred_def_62190,type,
    v110186: state_type > $o ).

tff(pred_def_62191,type,
    v110185: ( state_type * $int ) > $o ).

tff(pred_def_62192,type,
    v110197: state_type > $o ).

tff(pred_def_62193,type,
    v110195: state_type > $o ).

tff(pred_def_62194,type,
    v110194: state_type > $o ).

tff(pred_def_62195,type,
    v110193: ( state_type * $int ) > $o ).

tff(pred_def_62196,type,
    v110205: state_type > $o ).

tff(pred_def_62197,type,
    v110203: state_type > $o ).

tff(pred_def_62198,type,
    v110202: state_type > $o ).

tff(pred_def_62199,type,
    v110201: ( state_type * $int ) > $o ).

tff(pred_def_62200,type,
    v110213: state_type > $o ).

tff(pred_def_62201,type,
    v110211: state_type > $o ).

tff(pred_def_62202,type,
    v110210: state_type > $o ).

tff(pred_def_62203,type,
    v110209: ( state_type * $int ) > $o ).

tff(pred_def_62204,type,
    v110221: state_type > $o ).

tff(pred_def_62205,type,
    v110219: state_type > $o ).

tff(pred_def_62206,type,
    v110218: state_type > $o ).

tff(pred_def_62207,type,
    v110217: ( state_type * $int ) > $o ).

tff(pred_def_62208,type,
    v110229: state_type > $o ).

tff(pred_def_62209,type,
    v110227: state_type > $o ).

tff(pred_def_62210,type,
    v110226: state_type > $o ).

tff(pred_def_62211,type,
    v110225: ( state_type * $int ) > $o ).

tff(pred_def_62212,type,
    v110237: state_type > $o ).

tff(pred_def_62213,type,
    v110235: state_type > $o ).

tff(pred_def_62214,type,
    v110234: state_type > $o ).

tff(pred_def_62215,type,
    v110233: ( state_type * $int ) > $o ).

tff(pred_def_62216,type,
    v110245: state_type > $o ).

tff(pred_def_62217,type,
    v110243: state_type > $o ).

tff(pred_def_62218,type,
    v110242: state_type > $o ).

tff(pred_def_62219,type,
    v110241: ( state_type * $int ) > $o ).

tff(pred_def_62220,type,
    v110253: state_type > $o ).

tff(pred_def_62221,type,
    v110251: state_type > $o ).

tff(pred_def_62222,type,
    v110250: state_type > $o ).

tff(pred_def_62223,type,
    v110249: ( state_type * $int ) > $o ).

tff(pred_def_62224,type,
    v110261: state_type > $o ).

tff(pred_def_62225,type,
    v110259: state_type > $o ).

tff(pred_def_62226,type,
    v110258: state_type > $o ).

tff(pred_def_62227,type,
    v110257: ( state_type * $int ) > $o ).

tff(pred_def_62228,type,
    v110265: state_type > $o ).

tff(pred_def_62229,type,
    v110266: state_type > $o ).

tff(pred_def_62230,type,
    v110270: state_type > $o ).

tff(pred_def_62231,type,
    v110269: state_type > $o ).

tff(pred_def_62232,type,
    v110268: ( state_type * $int ) > $o ).

tff(pred_def_62233,type,
    v110272: state_type > $o ).

tff(pred_def_62234,type,
    v110273: state_type > $o ).

tff(pred_def_62235,type,
    v110274: state_type > $o ).

tff(pred_def_62236,type,
    v110275: state_type > $o ).

tff(pred_def_62237,type,
    v110276: state_type > $o ).

tff(pred_def_62238,type,
    v110277: state_type > $o ).

tff(pred_def_62239,type,
    v110278: state_type > $o ).

tff(pred_def_62240,type,
    v110279: state_type > $o ).

tff(pred_def_62241,type,
    v110280: state_type > $o ).

tff(pred_def_62242,type,
    v110281: state_type > $o ).

tff(pred_def_62243,type,
    v110282: state_type > $o ).

tff(pred_def_62244,type,
    v110283: state_type > $o ).

tff(pred_def_62245,type,
    v110284: state_type > $o ).

tff(pred_def_62246,type,
    v110285: state_type > $o ).

tff(pred_def_62247,type,
    v110286: state_type > $o ).

tff(pred_def_62248,type,
    v110287: state_type > $o ).

tff(pred_def_62249,type,
    v110271: ( state_type * $int ) > $o ).

tff(pred_def_62250,type,
    v110267: ( state_type * $int ) > $o ).

tff(pred_def_62251,type,
    v109661: ( state_type * $int ) > $o ).

tff(pred_def_62252,type,
    v110303: ( state_type * $int ) > $o ).

tff(pred_def_62253,type,
    v110302: state_type > $o ).

tff(pred_def_62254,type,
    v110301: state_type > $o ).

tff(pred_def_62255,type,
    v110304: state_type > $o ).

tff(pred_def_62256,type,
    v110300: state_type > $o ).

tff(pred_def_62257,type,
    v110299: state_type > $o ).

tff(pred_def_62258,type,
    v110308: state_type > $o ).

tff(pred_def_62259,type,
    v110307: state_type > $o ).

tff(pred_def_62260,type,
    v110309: state_type > $o ).

tff(pred_def_62261,type,
    v110306: state_type > $o ).

tff(pred_def_62262,type,
    v110305: state_type > $o ).

tff(pred_def_62263,type,
    v110298: state_type > $o ).

tff(pred_def_62264,type,
    v110313: state_type > $o ).

tff(pred_def_62265,type,
    v110312: state_type > $o ).

tff(pred_def_62266,type,
    v110314: state_type > $o ).

tff(pred_def_62267,type,
    v110311: state_type > $o ).

tff(pred_def_62268,type,
    v110310: state_type > $o ).

tff(pred_def_62269,type,
    v110297: state_type > $o ).

tff(pred_def_62270,type,
    v110318: state_type > $o ).

tff(pred_def_62271,type,
    v110317: state_type > $o ).

tff(pred_def_62272,type,
    v110319: state_type > $o ).

tff(pred_def_62273,type,
    v110316: state_type > $o ).

tff(pred_def_62274,type,
    v110315: state_type > $o ).

tff(pred_def_62275,type,
    v110296: state_type > $o ).

tff(pred_def_62276,type,
    v110294: state_type > $o ).

tff(pred_def_62277,type,
    v110320: state_type > $o ).

tff(pred_def_62278,type,
    v110293: state_type > $o ).

tff(pred_def_62279,type,
    v110321: state_type > $o ).

tff(pred_def_62280,type,
    v110292: state_type > $o ).

tff(pred_def_62281,type,
    v110291: state_type > $o ).

tff(pred_def_62282,type,
    v110290: state_type > $o ).

tff(pred_def_62283,type,
    v110289: ( state_type * $int ) > $o ).

tff(pred_def_62284,type,
    v110288: ( state_type * $int ) > $o ).

tff(pred_def_62285,type,
    v109659: ( state_type * $int ) > $o ).

tff(pred_def_62286,type,
    v110327: state_type > $o ).

tff(pred_def_62287,type,
    v110326: state_type > $o ).

tff(pred_def_62288,type,
    v110329: state_type > $o ).

tff(pred_def_62289,type,
    v110328: state_type > $o ).

tff(pred_def_62290,type,
    v110325: state_type > $o ).

tff(pred_def_62291,type,
    v110331: state_type > $o ).

tff(pred_def_62292,type,
    v110330: state_type > $o ).

tff(pred_def_62293,type,
    v110324: state_type > $o ).

tff(pred_def_62294,type,
    v110332: state_type > $o ).

tff(pred_def_62295,type,
    v110323: state_type > $o ).

tff(pred_def_62296,type,
    v110334: state_type > $o ).

tff(pred_def_62297,type,
    v110333: state_type > $o ).

tff(pred_def_62298,type,
    v116: ( state_type * $int ) > $o ).

tff(pred_def_62299,type,
    v110340: state_type > $o ).

tff(pred_def_62300,type,
    v110339: state_type > $o ).

tff(pred_def_62301,type,
    v110342: state_type > $o ).

tff(pred_def_62302,type,
    v110341: state_type > $o ).

tff(pred_def_62303,type,
    v110338: state_type > $o ).

tff(pred_def_62304,type,
    v110344: state_type > $o ).

tff(pred_def_62305,type,
    v110343: state_type > $o ).

tff(pred_def_62306,type,
    v110337: state_type > $o ).

tff(pred_def_62307,type,
    v110345: state_type > $o ).

tff(pred_def_62308,type,
    v110336: state_type > $o ).

tff(pred_def_62309,type,
    v110347: state_type > $o ).

tff(pred_def_62310,type,
    v110346: state_type > $o ).

tff(pred_def_62311,type,
    v110353: state_type > $o ).

tff(pred_def_62312,type,
    v110352: state_type > $o ).

tff(pred_def_62313,type,
    v110355: state_type > $o ).

tff(pred_def_62314,type,
    v110354: state_type > $o ).

tff(pred_def_62315,type,
    v110351: state_type > $o ).

tff(pred_def_62316,type,
    v110357: state_type > $o ).

tff(pred_def_62317,type,
    v110356: state_type > $o ).

tff(pred_def_62318,type,
    v110350: state_type > $o ).

tff(pred_def_62319,type,
    v110358: state_type > $o ).

tff(pred_def_62320,type,
    v110349: state_type > $o ).

tff(pred_def_62321,type,
    v110360: state_type > $o ).

tff(pred_def_62322,type,
    v110359: state_type > $o ).

tff(pred_def_62323,type,
    v110366: state_type > $o ).

tff(pred_def_62324,type,
    v110365: state_type > $o ).

tff(pred_def_62325,type,
    v110368: state_type > $o ).

tff(pred_def_62326,type,
    v110367: state_type > $o ).

tff(pred_def_62327,type,
    v110364: state_type > $o ).

tff(pred_def_62328,type,
    v110370: state_type > $o ).

tff(pred_def_62329,type,
    v110369: state_type > $o ).

tff(pred_def_62330,type,
    v110363: state_type > $o ).

tff(pred_def_62331,type,
    v110371: state_type > $o ).

tff(pred_def_62332,type,
    v110362: state_type > $o ).

tff(pred_def_62333,type,
    v110373: state_type > $o ).

tff(pred_def_62334,type,
    v110372: state_type > $o ).

tff(pred_def_62335,type,
    v110379: state_type > $o ).

tff(pred_def_62336,type,
    v110378: state_type > $o ).

tff(pred_def_62337,type,
    v110381: state_type > $o ).

tff(pred_def_62338,type,
    v110380: state_type > $o ).

tff(pred_def_62339,type,
    v110377: state_type > $o ).

tff(pred_def_62340,type,
    v110383: state_type > $o ).

tff(pred_def_62341,type,
    v110382: state_type > $o ).

tff(pred_def_62342,type,
    v110376: state_type > $o ).

tff(pred_def_62343,type,
    v110384: state_type > $o ).

tff(pred_def_62344,type,
    v110375: state_type > $o ).

tff(pred_def_62345,type,
    v110386: state_type > $o ).

tff(pred_def_62346,type,
    v110385: state_type > $o ).

tff(pred_def_62347,type,
    v110392: state_type > $o ).

tff(pred_def_62348,type,
    v110391: state_type > $o ).

tff(pred_def_62349,type,
    v110394: state_type > $o ).

tff(pred_def_62350,type,
    v110393: state_type > $o ).

tff(pred_def_62351,type,
    v110390: state_type > $o ).

tff(pred_def_62352,type,
    v110396: state_type > $o ).

tff(pred_def_62353,type,
    v110395: state_type > $o ).

tff(pred_def_62354,type,
    v110389: state_type > $o ).

tff(pred_def_62355,type,
    v110397: state_type > $o ).

tff(pred_def_62356,type,
    v110388: state_type > $o ).

tff(pred_def_62357,type,
    v110399: state_type > $o ).

tff(pred_def_62358,type,
    v110398: state_type > $o ).

tff(pred_def_62359,type,
    v110405: state_type > $o ).

tff(pred_def_62360,type,
    v110404: state_type > $o ).

tff(pred_def_62361,type,
    v110407: state_type > $o ).

tff(pred_def_62362,type,
    v110406: state_type > $o ).

tff(pred_def_62363,type,
    v110403: state_type > $o ).

tff(pred_def_62364,type,
    v110409: state_type > $o ).

tff(pred_def_62365,type,
    v110408: state_type > $o ).

tff(pred_def_62366,type,
    v110402: state_type > $o ).

tff(pred_def_62367,type,
    v110410: state_type > $o ).

tff(pred_def_62368,type,
    v110401: state_type > $o ).

tff(pred_def_62369,type,
    v110412: state_type > $o ).

tff(pred_def_62370,type,
    v110411: state_type > $o ).

tff(pred_def_62371,type,
    v110418: state_type > $o ).

tff(pred_def_62372,type,
    v110417: state_type > $o ).

tff(pred_def_62373,type,
    v110420: state_type > $o ).

tff(pred_def_62374,type,
    v110419: state_type > $o ).

tff(pred_def_62375,type,
    v110416: state_type > $o ).

tff(pred_def_62376,type,
    v110422: state_type > $o ).

tff(pred_def_62377,type,
    v110421: state_type > $o ).

tff(pred_def_62378,type,
    v110415: state_type > $o ).

tff(pred_def_62379,type,
    v110423: state_type > $o ).

tff(pred_def_62380,type,
    v110414: state_type > $o ).

tff(pred_def_62381,type,
    v110425: state_type > $o ).

tff(pred_def_62382,type,
    v110424: state_type > $o ).

tff(pred_def_62383,type,
    v110431: state_type > $o ).

tff(pred_def_62384,type,
    v110430: state_type > $o ).

tff(pred_def_62385,type,
    v110433: state_type > $o ).

tff(pred_def_62386,type,
    v110432: state_type > $o ).

tff(pred_def_62387,type,
    v110429: state_type > $o ).

tff(pred_def_62388,type,
    v110435: state_type > $o ).

tff(pred_def_62389,type,
    v110434: state_type > $o ).

tff(pred_def_62390,type,
    v110428: state_type > $o ).

tff(pred_def_62391,type,
    v110436: state_type > $o ).

tff(pred_def_62392,type,
    v110427: state_type > $o ).

tff(pred_def_62393,type,
    v110438: state_type > $o ).

tff(pred_def_62394,type,
    v110437: state_type > $o ).

tff(pred_def_62395,type,
    v110444: state_type > $o ).

tff(pred_def_62396,type,
    v110443: state_type > $o ).

tff(pred_def_62397,type,
    v110446: state_type > $o ).

tff(pred_def_62398,type,
    v110445: state_type > $o ).

tff(pred_def_62399,type,
    v110442: state_type > $o ).

tff(pred_def_62400,type,
    v110448: state_type > $o ).

tff(pred_def_62401,type,
    v110447: state_type > $o ).

tff(pred_def_62402,type,
    v110441: state_type > $o ).

tff(pred_def_62403,type,
    v110449: state_type > $o ).

tff(pred_def_62404,type,
    v110440: state_type > $o ).

tff(pred_def_62405,type,
    v110451: state_type > $o ).

tff(pred_def_62406,type,
    v110450: state_type > $o ).

tff(pred_def_62407,type,
    v110457: state_type > $o ).

tff(pred_def_62408,type,
    v110456: state_type > $o ).

tff(pred_def_62409,type,
    v110459: state_type > $o ).

tff(pred_def_62410,type,
    v110458: state_type > $o ).

tff(pred_def_62411,type,
    v110455: state_type > $o ).

tff(pred_def_62412,type,
    v110461: state_type > $o ).

tff(pred_def_62413,type,
    v110460: state_type > $o ).

tff(pred_def_62414,type,
    v110454: state_type > $o ).

tff(pred_def_62415,type,
    v110462: state_type > $o ).

tff(pred_def_62416,type,
    v110453: state_type > $o ).

tff(pred_def_62417,type,
    v110464: state_type > $o ).

tff(pred_def_62418,type,
    v110463: state_type > $o ).

tff(pred_def_62419,type,
    v110470: state_type > $o ).

tff(pred_def_62420,type,
    v110469: state_type > $o ).

tff(pred_def_62421,type,
    v110472: state_type > $o ).

tff(pred_def_62422,type,
    v110471: state_type > $o ).

tff(pred_def_62423,type,
    v110468: state_type > $o ).

tff(pred_def_62424,type,
    v110474: state_type > $o ).

tff(pred_def_62425,type,
    v110473: state_type > $o ).

tff(pred_def_62426,type,
    v110467: state_type > $o ).

tff(pred_def_62427,type,
    v110475: state_type > $o ).

tff(pred_def_62428,type,
    v110466: state_type > $o ).

tff(pred_def_62429,type,
    v110477: state_type > $o ).

tff(pred_def_62430,type,
    v110476: state_type > $o ).

tff(pred_def_62431,type,
    v110483: state_type > $o ).

tff(pred_def_62432,type,
    v110482: state_type > $o ).

tff(pred_def_62433,type,
    v110485: state_type > $o ).

tff(pred_def_62434,type,
    v110484: state_type > $o ).

tff(pred_def_62435,type,
    v110481: state_type > $o ).

tff(pred_def_62436,type,
    v110487: state_type > $o ).

tff(pred_def_62437,type,
    v110486: state_type > $o ).

tff(pred_def_62438,type,
    v110480: state_type > $o ).

tff(pred_def_62439,type,
    v110488: state_type > $o ).

tff(pred_def_62440,type,
    v110479: state_type > $o ).

tff(pred_def_62441,type,
    v110490: state_type > $o ).

tff(pred_def_62442,type,
    v110489: state_type > $o ).

tff(pred_def_62443,type,
    v110496: state_type > $o ).

tff(pred_def_62444,type,
    v110495: state_type > $o ).

tff(pred_def_62445,type,
    v110498: state_type > $o ).

tff(pred_def_62446,type,
    v110497: state_type > $o ).

tff(pred_def_62447,type,
    v110494: state_type > $o ).

tff(pred_def_62448,type,
    v110500: state_type > $o ).

tff(pred_def_62449,type,
    v110499: state_type > $o ).

tff(pred_def_62450,type,
    v110493: state_type > $o ).

tff(pred_def_62451,type,
    v110501: state_type > $o ).

tff(pred_def_62452,type,
    v110492: state_type > $o ).

tff(pred_def_62453,type,
    v110503: state_type > $o ).

tff(pred_def_62454,type,
    v110502: state_type > $o ).

tff(pred_def_62455,type,
    v110509: state_type > $o ).

tff(pred_def_62456,type,
    v110508: state_type > $o ).

tff(pred_def_62457,type,
    v110511: state_type > $o ).

tff(pred_def_62458,type,
    v110510: state_type > $o ).

tff(pred_def_62459,type,
    v110507: state_type > $o ).

tff(pred_def_62460,type,
    v110513: state_type > $o ).

tff(pred_def_62461,type,
    v110512: state_type > $o ).

tff(pred_def_62462,type,
    v110506: state_type > $o ).

tff(pred_def_62463,type,
    v110514: state_type > $o ).

tff(pred_def_62464,type,
    v110505: state_type > $o ).

tff(pred_def_62465,type,
    v110516: state_type > $o ).

tff(pred_def_62466,type,
    v110515: state_type > $o ).

tff(pred_def_62467,type,
    v110522: state_type > $o ).

tff(pred_def_62468,type,
    v110521: state_type > $o ).

tff(pred_def_62469,type,
    v110524: state_type > $o ).

tff(pred_def_62470,type,
    v110523: state_type > $o ).

tff(pred_def_62471,type,
    v110520: state_type > $o ).

tff(pred_def_62472,type,
    v110526: state_type > $o ).

tff(pred_def_62473,type,
    v110525: state_type > $o ).

tff(pred_def_62474,type,
    v110519: state_type > $o ).

tff(pred_def_62475,type,
    v110527: state_type > $o ).

tff(pred_def_62476,type,
    v110518: state_type > $o ).

tff(pred_def_62477,type,
    v110529: state_type > $o ).

tff(pred_def_62478,type,
    v110528: state_type > $o ).

tff(pred_def_62479,type,
    v108919: ( state_type * $int ) > $o ).

tff(pred_def_62480,type,
    v110531: state_type > $o ).

tff(pred_def_62481,type,
    v110535: state_type > $o ).

tff(pred_def_62482,type,
    v110534: ( state_type * $int ) > $o ).

tff(pred_def_62483,type,
    v110533: ( state_type * $int ) > $o ).

tff(pred_def_62484,type,
    v110539: state_type > $o ).

tff(pred_def_62485,type,
    v110538: ( state_type * $int ) > $o ).

tff(pred_def_62486,type,
    v110537: ( state_type * $int ) > $o ).

tff(pred_def_62487,type,
    v108903: ( state_type * $int ) > $o ).

tff(pred_def_62488,type,
    v110536: ( state_type * $int ) > $o ).

tff(pred_def_62489,type,
    v108917: ( state_type * $int ) > $o ).

tff(pred_def_62490,type,
    v108915: ( state_type * $int ) > $o ).

tff(pred_def_62491,type,
    v110543: state_type > $o ).

tff(pred_def_62492,type,
    v110541: state_type > $o ).

tff(pred_def_62493,type,
    v110550: state_type > $o ).

tff(pred_def_62494,type,
    v110548: state_type > $o ).

tff(pred_def_62495,type,
    v110547: state_type > $o ).

tff(pred_def_62496,type,
    v110546: state_type > $o ).

tff(pred_def_62497,type,
    v110558: state_type > $o ).

tff(pred_def_62498,type,
    v110559: state_type > $o ).

tff(pred_def_62499,type,
    v110557: state_type > $o ).

tff(pred_def_62500,type,
    v110554: ( state_type * $int ) > $o ).

tff(pred_def_62501,type,
    v110556: ( state_type * $int ) > $o ).

tff(pred_def_62502,type,
    v108905: ( state_type * $int ) > $o ).

tff(pred_def_62503,type,
    v108901: ( state_type * $int ) > $o ).

tff(pred_def_62504,type,
    v110571: state_type > $o ).

tff(pred_def_62505,type,
    v110569: state_type > $o ).

tff(pred_def_62506,type,
    v110575: state_type > $o ).

tff(pred_def_62507,type,
    v110573: state_type > $o ).

tff(pred_def_62508,type,
    v110586: state_type > $o ).

tff(pred_def_62509,type,
    v110585: state_type > $o ).

tff(pred_def_62510,type,
    v110588: state_type > $o ).

tff(pred_def_62511,type,
    v110587: state_type > $o ).

tff(pred_def_62512,type,
    v110583: ( state_type * $int ) > $o ).

tff(pred_def_62513,type,
    v110591: state_type > $o ).

tff(pred_def_62514,type,
    v110590: state_type > $o ).

tff(pred_def_62515,type,
    v110593: state_type > $o ).

tff(pred_def_62516,type,
    v110592: state_type > $o ).

tff(pred_def_62517,type,
    v110596: state_type > $o ).

tff(pred_def_62518,type,
    v110595: state_type > $o ).

tff(pred_def_62519,type,
    v110598: state_type > $o ).

tff(pred_def_62520,type,
    v110597: state_type > $o ).

tff(pred_def_62521,type,
    v110601: state_type > $o ).

tff(pred_def_62522,type,
    v110600: state_type > $o ).

tff(pred_def_62523,type,
    v110603: state_type > $o ).

tff(pred_def_62524,type,
    v110602: state_type > $o ).

tff(pred_def_62525,type,
    v110606: state_type > $o ).

tff(pred_def_62526,type,
    v110605: state_type > $o ).

tff(pred_def_62527,type,
    v110608: state_type > $o ).

tff(pred_def_62528,type,
    v110607: state_type > $o ).

tff(pred_def_62529,type,
    v110611: state_type > $o ).

tff(pred_def_62530,type,
    v110610: state_type > $o ).

tff(pred_def_62531,type,
    v110613: state_type > $o ).

tff(pred_def_62532,type,
    v110612: state_type > $o ).

tff(pred_def_62533,type,
    v110616: state_type > $o ).

tff(pred_def_62534,type,
    v110615: state_type > $o ).

tff(pred_def_62535,type,
    v110618: state_type > $o ).

tff(pred_def_62536,type,
    v110617: state_type > $o ).

tff(pred_def_62537,type,
    v110621: state_type > $o ).

tff(pred_def_62538,type,
    v110620: state_type > $o ).

tff(pred_def_62539,type,
    v110623: state_type > $o ).

tff(pred_def_62540,type,
    v110622: state_type > $o ).

tff(pred_def_62541,type,
    v110626: state_type > $o ).

tff(pred_def_62542,type,
    v110625: state_type > $o ).

tff(pred_def_62543,type,
    v110628: state_type > $o ).

tff(pred_def_62544,type,
    v110627: state_type > $o ).

tff(pred_def_62545,type,
    v110631: state_type > $o ).

tff(pred_def_62546,type,
    v110630: state_type > $o ).

tff(pred_def_62547,type,
    v110633: state_type > $o ).

tff(pred_def_62548,type,
    v110632: state_type > $o ).

tff(pred_def_62549,type,
    v110636: state_type > $o ).

tff(pred_def_62550,type,
    v110635: state_type > $o ).

tff(pred_def_62551,type,
    v110638: state_type > $o ).

tff(pred_def_62552,type,
    v110637: state_type > $o ).

tff(pred_def_62553,type,
    v110641: state_type > $o ).

tff(pred_def_62554,type,
    v110640: state_type > $o ).

tff(pred_def_62555,type,
    v110643: state_type > $o ).

tff(pred_def_62556,type,
    v110642: state_type > $o ).

tff(pred_def_62557,type,
    v110646: state_type > $o ).

tff(pred_def_62558,type,
    v110645: state_type > $o ).

tff(pred_def_62559,type,
    v110648: state_type > $o ).

tff(pred_def_62560,type,
    v110647: state_type > $o ).

tff(pred_def_62561,type,
    v110651: state_type > $o ).

tff(pred_def_62562,type,
    v110650: state_type > $o ).

tff(pred_def_62563,type,
    v110653: state_type > $o ).

tff(pred_def_62564,type,
    v110652: state_type > $o ).

tff(pred_def_62565,type,
    v110656: state_type > $o ).

tff(pred_def_62566,type,
    v110655: state_type > $o ).

tff(pred_def_62567,type,
    v110658: state_type > $o ).

tff(pred_def_62568,type,
    v110657: state_type > $o ).

tff(pred_def_62569,type,
    v110661: state_type > $o ).

tff(pred_def_62570,type,
    v110660: state_type > $o ).

tff(pred_def_62571,type,
    v110663: state_type > $o ).

tff(pred_def_62572,type,
    v110662: state_type > $o ).

tff(pred_def_62573,type,
    v110581: ( state_type * $int ) > $o ).

tff(pred_def_62574,type,
    v110665: state_type > $o ).

tff(pred_def_62575,type,
    v110669: state_type > $o ).

tff(pred_def_62576,type,
    v110668: ( state_type * $int ) > $o ).

tff(pred_def_62577,type,
    v110667: ( state_type * $int ) > $o ).

tff(pred_def_62578,type,
    v110673: state_type > $o ).

tff(pred_def_62579,type,
    v110672: ( state_type * $int ) > $o ).

tff(pred_def_62580,type,
    v110671: ( state_type * $int ) > $o ).

tff(pred_def_62581,type,
    v110565: ( state_type * $int ) > $o ).

tff(pred_def_62582,type,
    v110670: ( state_type * $int ) > $o ).

tff(pred_def_62583,type,
    v110579: ( state_type * $int ) > $o ).

tff(pred_def_62584,type,
    v110577: ( state_type * $int ) > $o ).

tff(pred_def_62585,type,
    v110677: state_type > $o ).

tff(pred_def_62586,type,
    v110675: state_type > $o ).

tff(pred_def_62587,type,
    v110684: state_type > $o ).

tff(pred_def_62588,type,
    v110682: state_type > $o ).

tff(pred_def_62589,type,
    v110681: state_type > $o ).

tff(pred_def_62590,type,
    v110680: state_type > $o ).

tff(pred_def_62591,type,
    v110692: state_type > $o ).

tff(pred_def_62592,type,
    v110693: state_type > $o ).

tff(pred_def_62593,type,
    v110691: state_type > $o ).

tff(pred_def_62594,type,
    v110688: ( state_type * $int ) > $o ).

tff(pred_def_62595,type,
    v110690: ( state_type * $int ) > $o ).

tff(pred_def_62596,type,
    v110567: ( state_type * $int ) > $o ).

tff(pred_def_62597,type,
    v110563: ( state_type * $int ) > $o ).

tff(pred_def_62598,type,
    v108899: ( state_type * $int ) > $o ).

tff(pred_def_62599,type,
    v110712: state_type > $o ).

tff(pred_def_62600,type,
    v110711: state_type > $o ).

tff(pred_def_62601,type,
    v110710: state_type > $o ).

tff(pred_def_62602,type,
    v110709: state_type > $o ).

tff(pred_def_62603,type,
    v110708: state_type > $o ).

tff(pred_def_62604,type,
    v110707: state_type > $o ).

tff(pred_def_62605,type,
    v110706: state_type > $o ).

tff(pred_def_62606,type,
    v110705: state_type > $o ).

tff(pred_def_62607,type,
    v110704: state_type > $o ).

tff(pred_def_62608,type,
    v110703: state_type > $o ).

tff(pred_def_62609,type,
    v110702: state_type > $o ).

tff(pred_def_62610,type,
    v110701: state_type > $o ).

tff(pred_def_62611,type,
    v110700: state_type > $o ).

tff(pred_def_62612,type,
    v110699: state_type > $o ).

tff(pred_def_62613,type,
    v108897: state_type > $o ).

tff(pred_def_62614,type,
    v108895: state_type > $o ).

tff(pred_def_62615,type,
    v110713: ( state_type * $int ) > $o ).

tff(pred_def_62616,type,
    v108893: state_type > $o ).

tff(pred_def_62617,type,
    v108891: state_type > $o ).

tff(pred_def_62618,type,
    v108889: ( state_type * $int ) > $o ).

tff(pred_def_62619,type,
    v108887: ( state_type * $int ) > $o ).

tff(pred_def_62620,type,
    v108885: ( state_type * $int ) > $o ).

tff(pred_def_62621,type,
    v110717: state_type > $o ).

tff(pred_def_62622,type,
    v110715: state_type > $o ).

tff(pred_def_62623,type,
    v110724: state_type > $o ).

tff(pred_def_62624,type,
    v110722: state_type > $o ).

tff(pred_def_62625,type,
    v110721: state_type > $o ).

tff(pred_def_62626,type,
    v110720: state_type > $o ).

tff(pred_def_62627,type,
    v110732: state_type > $o ).

tff(pred_def_62628,type,
    v110733: state_type > $o ).

tff(pred_def_62629,type,
    v110731: state_type > $o ).

tff(pred_def_62630,type,
    v110728: ( state_type * $int ) > $o ).

tff(pred_def_62631,type,
    v110730: ( state_type * $int ) > $o ).

tff(pred_def_62632,type,
    v110719: ( state_type * $int ) > $o ).

tff(pred_def_62633,type,
    v108875: ( state_type * $int ) > $o ).

tff(pred_def_62634,type,
    v108873: ( state_type * $int ) > $o ).

tff(pred_def_62635,type,
    v110741: state_type > $o ).

tff(pred_def_62636,type,
    v110739: state_type > $o ).

tff(pred_def_62637,type,
    v110738: state_type > $o ).

tff(pred_def_62638,type,
    v110737: ( state_type * $int ) > $o ).

tff(pred_def_62639,type,
    v110749: state_type > $o ).

tff(pred_def_62640,type,
    v110747: state_type > $o ).

tff(pred_def_62641,type,
    v110746: state_type > $o ).

tff(pred_def_62642,type,
    v110745: ( state_type * $int ) > $o ).

tff(pred_def_62643,type,
    v108871: state_type > $o ).

tff(pred_def_62644,type,
    v108869: state_type > $o ).

tff(pred_def_62645,type,
    v110762: state_type > $o ).

tff(pred_def_62646,type,
    v110760: state_type > $o ).

tff(pred_def_62647,type,
    v110766: state_type > $o ).

tff(pred_def_62648,type,
    v110764: state_type > $o ).

tff(pred_def_62649,type,
    v110774: state_type > $o ).

tff(pred_def_62650,type,
    v110772: ( state_type * $int ) > $o ).

tff(pred_def_62651,type,
    v110781: ( state_type * $int ) > $o ).

tff(pred_def_62652,type,
    v110798: state_type > $o ).

tff(pred_def_62653,type,
    v110797: state_type > $o ).

tff(pred_def_62654,type,
    v110796: state_type > $o ).

tff(pred_def_62655,type,
    v110795: state_type > $o ).

tff(pred_def_62656,type,
    v110794: state_type > $o ).

tff(pred_def_62657,type,
    v110793: state_type > $o ).

tff(pred_def_62658,type,
    v110792: state_type > $o ).

tff(pred_def_62659,type,
    v110791: state_type > $o ).

tff(pred_def_62660,type,
    v110790: state_type > $o ).

tff(pred_def_62661,type,
    v110789: state_type > $o ).

tff(pred_def_62662,type,
    v110788: state_type > $o ).

tff(pred_def_62663,type,
    v110787: state_type > $o ).

tff(pred_def_62664,type,
    v110786: state_type > $o ).

tff(pred_def_62665,type,
    v110785: state_type > $o ).

tff(pred_def_62666,type,
    v110779: state_type > $o ).

tff(pred_def_62667,type,
    v110777: state_type > $o ).

tff(pred_def_62668,type,
    v110802: state_type > $o ).

tff(pred_def_62669,type,
    v110801: ( state_type * $int ) > $o ).

tff(pred_def_62670,type,
    v110800: ( state_type * $int ) > $o ).

tff(pred_def_62671,type,
    v110806: state_type > $o ).

tff(pred_def_62672,type,
    v110805: ( state_type * $int ) > $o ).

tff(pred_def_62673,type,
    v110804: ( state_type * $int ) > $o ).

tff(pred_def_62674,type,
    v110756: ( state_type * $int ) > $o ).

tff(pred_def_62675,type,
    v110803: ( state_type * $int ) > $o ).

tff(pred_def_62676,type,
    v110770: ( state_type * $int ) > $o ).

tff(pred_def_62677,type,
    v110768: ( state_type * $int ) > $o ).

tff(pred_def_62678,type,
    v110810: state_type > $o ).

tff(pred_def_62679,type,
    v110808: state_type > $o ).

tff(pred_def_62680,type,
    v110817: state_type > $o ).

tff(pred_def_62681,type,
    v110815: state_type > $o ).

tff(pred_def_62682,type,
    v110814: state_type > $o ).

tff(pred_def_62683,type,
    v110813: state_type > $o ).

tff(pred_def_62684,type,
    v110825: state_type > $o ).

tff(pred_def_62685,type,
    v110826: state_type > $o ).

tff(pred_def_62686,type,
    v110824: state_type > $o ).

tff(pred_def_62687,type,
    v110821: ( state_type * $int ) > $o ).

tff(pred_def_62688,type,
    v110823: ( state_type * $int ) > $o ).

tff(pred_def_62689,type,
    v110758: ( state_type * $int ) > $o ).

tff(pred_def_62690,type,
    v110754: ( state_type * $int ) > $o ).

tff(pred_def_62691,type,
    v110837: state_type > $o ).

tff(pred_def_62692,type,
    v110838: state_type > $o ).

tff(pred_def_62693,type,
    v110836: state_type > $o ).

tff(pred_def_62694,type,
    v110834: state_type > $o ).

tff(pred_def_62695,type,
    v110832: state_type > $o ).

tff(pred_def_62696,type,
    v110830: state_type > $o ).

tff(pred_def_62697,type,
    v110846: state_type > $o ).

tff(pred_def_62698,type,
    v110844: state_type > $o ).

tff(pred_def_62699,type,
    v110842: state_type > $o ).

tff(pred_def_62700,type,
    v110840: state_type > $o ).

tff(pred_def_62701,type,
    v110858: state_type > $o ).

tff(pred_def_62702,type,
    v110856: state_type > $o ).

tff(pred_def_62703,type,
    v110862: state_type > $o ).

tff(pred_def_62704,type,
    v110860: state_type > $o ).

tff(pred_def_62705,type,
    v110880: state_type > $o ).

tff(pred_def_62706,type,
    v110878: state_type > $o ).

tff(pred_def_62707,type,
    v110884: state_type > $o ).

tff(pred_def_62708,type,
    v110882: state_type > $o ).

tff(pred_def_62709,type,
    v110904: state_type > $o ).

tff(pred_def_62710,type,
    v110902: state_type > $o ).

tff(pred_def_62711,type,
    v110908: state_type > $o ).

tff(pred_def_62712,type,
    v110906: state_type > $o ).

tff(pred_def_62713,type,
    v110926: state_type > $o ).

tff(pred_def_62714,type,
    v110924: state_type > $o ).

tff(pred_def_62715,type,
    v110930: state_type > $o ).

tff(pred_def_62716,type,
    v110928: state_type > $o ).

tff(pred_def_62717,type,
    v110941: state_type > $o ).

tff(pred_def_62718,type,
    v110940: state_type > $o ).

tff(pred_def_62719,type,
    v110918: state_type > $o ).

tff(pred_def_62720,type,
    v110938: state_type > $o ).

tff(pred_def_62721,type,
    v110936: state_type > $o ).

tff(pred_def_62722,type,
    v110934: state_type > $o ).

tff(pred_def_62723,type,
    v110932: state_type > $o ).

tff(pred_def_62724,type,
    v110945: state_type > $o ).

tff(pred_def_62725,type,
    v110943: state_type > $o ).

tff(pred_def_62726,type,
    v110952: state_type > $o ).

tff(pred_def_62727,type,
    v110950: state_type > $o ).

tff(pred_def_62728,type,
    v110949: state_type > $o ).

tff(pred_def_62729,type,
    v110948: state_type > $o ).

tff(pred_def_62730,type,
    v110960: state_type > $o ).

tff(pred_def_62731,type,
    v110961: state_type > $o ).

tff(pred_def_62732,type,
    v110959: state_type > $o ).

tff(pred_def_62733,type,
    v110956: state_type > $o ).

tff(pred_def_62734,type,
    v110958: state_type > $o ).

tff(pred_def_62735,type,
    v110922: state_type > $o ).

tff(pred_def_62736,type,
    v110920: state_type > $o ).

tff(pred_def_62737,type,
    v110916: state_type > $o ).

tff(pred_def_62738,type,
    v110914: state_type > $o ).

tff(pred_def_62739,type,
    v110966: state_type > $o ).

tff(pred_def_62740,type,
    v110970: state_type > $o ).

tff(pred_def_62741,type,
    v110969: state_type > $o ).

tff(pred_def_62742,type,
    v110968: state_type > $o ).

tff(pred_def_62743,type,
    v110974: state_type > $o ).

tff(pred_def_62744,type,
    v110973: state_type > $o ).

tff(pred_def_62745,type,
    v110972: state_type > $o ).

tff(pred_def_62746,type,
    v110898: state_type > $o ).

tff(pred_def_62747,type,
    v110971: state_type > $o ).

tff(pred_def_62748,type,
    v110912: state_type > $o ).

tff(pred_def_62749,type,
    v110910: state_type > $o ).

tff(pred_def_62750,type,
    v110978: state_type > $o ).

tff(pred_def_62751,type,
    v110976: state_type > $o ).

tff(pred_def_62752,type,
    v110985: state_type > $o ).

tff(pred_def_62753,type,
    v110983: state_type > $o ).

tff(pred_def_62754,type,
    v110982: state_type > $o ).

tff(pred_def_62755,type,
    v110981: state_type > $o ).

tff(pred_def_62756,type,
    v110993: state_type > $o ).

tff(pred_def_62757,type,
    v110994: state_type > $o ).

tff(pred_def_62758,type,
    v110992: state_type > $o ).

tff(pred_def_62759,type,
    v110989: state_type > $o ).

tff(pred_def_62760,type,
    v110991: state_type > $o ).

tff(pred_def_62761,type,
    v110900: state_type > $o ).

tff(pred_def_62762,type,
    v110896: state_type > $o ).

tff(pred_def_62763,type,
    v110894: state_type > $o ).

tff(pred_def_62764,type,
    v110892: state_type > $o ).

tff(pred_def_62765,type,
    v110997: ( state_type * $int ) > $o ).

tff(pred_def_62766,type,
    v110998: ( state_type * $int ) > $o ).

tff(pred_def_62767,type,
    v110890: ( state_type * $int ) > $o ).

tff(pred_def_62768,type,
    v110888: ( state_type * $int ) > $o ).

tff(pred_def_62769,type,
    v110886: ( state_type * $int ) > $o ).

tff(pred_def_62770,type,
    v111002: state_type > $o ).

tff(pred_def_62771,type,
    v111000: state_type > $o ).

tff(pred_def_62772,type,
    v111009: state_type > $o ).

tff(pred_def_62773,type,
    v111007: state_type > $o ).

tff(pred_def_62774,type,
    v111006: state_type > $o ).

tff(pred_def_62775,type,
    v111005: state_type > $o ).

tff(pred_def_62776,type,
    v111017: state_type > $o ).

tff(pred_def_62777,type,
    v111018: state_type > $o ).

tff(pred_def_62778,type,
    v111016: state_type > $o ).

tff(pred_def_62779,type,
    v111013: ( state_type * $int ) > $o ).

tff(pred_def_62780,type,
    v111015: ( state_type * $int ) > $o ).

tff(pred_def_62781,type,
    v111004: ( state_type * $int ) > $o ).

tff(pred_def_62782,type,
    v110876: ( state_type * $int ) > $o ).

tff(pred_def_62783,type,
    v110874: ( state_type * $int ) > $o ).

tff(pred_def_62784,type,
    v110872: state_type > $o ).

tff(pred_def_62785,type,
    v111035: state_type > $o ).

tff(pred_def_62786,type,
    v111033: state_type > $o ).

tff(pred_def_62787,type,
    v111039: state_type > $o ).

tff(pred_def_62788,type,
    v111037: state_type > $o ).

tff(pred_def_62789,type,
    v111045: ( state_type * $int ) > $o ).

tff(pred_def_62790,type,
    v111047: state_type > $o ).

tff(pred_def_62791,type,
    v111051: state_type > $o ).

tff(pred_def_62792,type,
    v111050: ( state_type * $int ) > $o ).

tff(pred_def_62793,type,
    v111049: ( state_type * $int ) > $o ).

tff(pred_def_62794,type,
    v111055: state_type > $o ).

tff(pred_def_62795,type,
    v111054: ( state_type * $int ) > $o ).

tff(pred_def_62796,type,
    v111053: ( state_type * $int ) > $o ).

tff(pred_def_62797,type,
    v111029: ( state_type * $int ) > $o ).

tff(pred_def_62798,type,
    v111052: ( state_type * $int ) > $o ).

tff(pred_def_62799,type,
    v111043: ( state_type * $int ) > $o ).

tff(pred_def_62800,type,
    v111041: ( state_type * $int ) > $o ).

tff(pred_def_62801,type,
    v111059: state_type > $o ).

tff(pred_def_62802,type,
    v111057: state_type > $o ).

tff(pred_def_62803,type,
    v111066: state_type > $o ).

tff(pred_def_62804,type,
    v111064: state_type > $o ).

tff(pred_def_62805,type,
    v111063: state_type > $o ).

tff(pred_def_62806,type,
    v111062: state_type > $o ).

tff(pred_def_62807,type,
    v111074: state_type > $o ).

tff(pred_def_62808,type,
    v111075: state_type > $o ).

tff(pred_def_62809,type,
    v111073: state_type > $o ).

tff(pred_def_62810,type,
    v111070: ( state_type * $int ) > $o ).

tff(pred_def_62811,type,
    v111072: ( state_type * $int ) > $o ).

tff(pred_def_62812,type,
    v111031: ( state_type * $int ) > $o ).

tff(pred_def_62813,type,
    v111027: ( state_type * $int ) > $o ).

tff(pred_def_62814,type,
    v111025: ( state_type * $int ) > $o ).

tff(pred_def_62815,type,
    v111083: state_type > $o ).

tff(pred_def_62816,type,
    v111081: state_type > $o ).

tff(pred_def_62817,type,
    v111080: state_type > $o ).

tff(pred_def_62818,type,
    v111079: ( state_type * $int ) > $o ).

tff(pred_def_62819,type,
    v111022: ( state_type * $int ) > $o ).

tff(pred_def_62820,type,
    v111099: state_type > $o ).

tff(pred_def_62821,type,
    v111097: state_type > $o ).

tff(pred_def_62822,type,
    v111096: state_type > $o ).

tff(pred_def_62823,type,
    v111095: ( state_type * $int ) > $o ).

tff(pred_def_62824,type,
    v111107: state_type > $o ).

tff(pred_def_62825,type,
    v111105: state_type > $o ).

tff(pred_def_62826,type,
    v111104: state_type > $o ).

tff(pred_def_62827,type,
    v111103: ( state_type * $int ) > $o ).

tff(pred_def_62828,type,
    v111115: state_type > $o ).

tff(pred_def_62829,type,
    v111113: state_type > $o ).

tff(pred_def_62830,type,
    v111112: state_type > $o ).

tff(pred_def_62831,type,
    v111111: ( state_type * $int ) > $o ).

tff(pred_def_62832,type,
    v111123: state_type > $o ).

tff(pred_def_62833,type,
    v111121: state_type > $o ).

tff(pred_def_62834,type,
    v111120: state_type > $o ).

tff(pred_def_62835,type,
    v111119: ( state_type * $int ) > $o ).

tff(pred_def_62836,type,
    v111131: state_type > $o ).

tff(pred_def_62837,type,
    v111129: state_type > $o ).

tff(pred_def_62838,type,
    v111128: state_type > $o ).

tff(pred_def_62839,type,
    v111127: ( state_type * $int ) > $o ).

tff(pred_def_62840,type,
    v111139: state_type > $o ).

tff(pred_def_62841,type,
    v111137: state_type > $o ).

tff(pred_def_62842,type,
    v111136: state_type > $o ).

tff(pred_def_62843,type,
    v111135: ( state_type * $int ) > $o ).

tff(pred_def_62844,type,
    v111147: state_type > $o ).

tff(pred_def_62845,type,
    v111145: state_type > $o ).

tff(pred_def_62846,type,
    v111144: state_type > $o ).

tff(pred_def_62847,type,
    v111143: ( state_type * $int ) > $o ).

tff(pred_def_62848,type,
    v111155: state_type > $o ).

tff(pred_def_62849,type,
    v111153: state_type > $o ).

tff(pred_def_62850,type,
    v111152: state_type > $o ).

tff(pred_def_62851,type,
    v111151: ( state_type * $int ) > $o ).

tff(pred_def_62852,type,
    v111163: state_type > $o ).

tff(pred_def_62853,type,
    v111161: state_type > $o ).

tff(pred_def_62854,type,
    v111160: state_type > $o ).

tff(pred_def_62855,type,
    v111159: ( state_type * $int ) > $o ).

tff(pred_def_62856,type,
    v111171: state_type > $o ).

tff(pred_def_62857,type,
    v111169: state_type > $o ).

tff(pred_def_62858,type,
    v111168: state_type > $o ).

tff(pred_def_62859,type,
    v111167: ( state_type * $int ) > $o ).

tff(pred_def_62860,type,
    v111179: state_type > $o ).

tff(pred_def_62861,type,
    v111177: state_type > $o ).

tff(pred_def_62862,type,
    v111176: state_type > $o ).

tff(pred_def_62863,type,
    v111175: ( state_type * $int ) > $o ).

tff(pred_def_62864,type,
    v111187: state_type > $o ).

tff(pred_def_62865,type,
    v111185: state_type > $o ).

tff(pred_def_62866,type,
    v111184: state_type > $o ).

tff(pred_def_62867,type,
    v111183: ( state_type * $int ) > $o ).

tff(pred_def_62868,type,
    v111195: state_type > $o ).

tff(pred_def_62869,type,
    v111193: state_type > $o ).

tff(pred_def_62870,type,
    v111192: state_type > $o ).

tff(pred_def_62871,type,
    v111191: ( state_type * $int ) > $o ).

tff(pred_def_62872,type,
    v111203: state_type > $o ).

tff(pred_def_62873,type,
    v111201: state_type > $o ).

tff(pred_def_62874,type,
    v111200: state_type > $o ).

tff(pred_def_62875,type,
    v111199: ( state_type * $int ) > $o ).

tff(pred_def_62876,type,
    v111211: state_type > $o ).

tff(pred_def_62877,type,
    v111209: state_type > $o ).

tff(pred_def_62878,type,
    v111208: state_type > $o ).

tff(pred_def_62879,type,
    v111207: ( state_type * $int ) > $o ).

tff(pred_def_62880,type,
    v111219: state_type > $o ).

tff(pred_def_62881,type,
    v111217: state_type > $o ).

tff(pred_def_62882,type,
    v111216: state_type > $o ).

tff(pred_def_62883,type,
    v111215: ( state_type * $int ) > $o ).

tff(pred_def_62884,type,
    v111225: state_type > $o ).

tff(pred_def_62885,type,
    v111223: state_type > $o ).

tff(pred_def_62886,type,
    v111229: state_type > $o ).

tff(pred_def_62887,type,
    v111227: state_type > $o ).

tff(pred_def_62888,type,
    v111243: ( state_type * $int ) > $o ).

tff(pred_def_62889,type,
    v111241: ( state_type * $int ) > $o ).

tff(pred_def_62890,type,
    v111239: ( state_type * $int ) > $o ).

tff(pred_def_62891,type,
    v111256: state_type > $o ).

tff(pred_def_62892,type,
    v111254: state_type > $o ).

tff(pred_def_62893,type,
    v111260: state_type > $o ).

tff(pred_def_62894,type,
    v111258: state_type > $o ).

tff(pred_def_62895,type,
    v111280: state_type > $o ).

tff(pred_def_62896,type,
    v111278: state_type > $o ).

tff(pred_def_62897,type,
    v111284: state_type > $o ).

tff(pred_def_62898,type,
    v111282: state_type > $o ).

tff(pred_def_62899,type,
    v111290: ( state_type * $int ) > $o ).

tff(pred_def_62900,type,
    v111292: state_type > $o ).

tff(pred_def_62901,type,
    v111296: state_type > $o ).

tff(pred_def_62902,type,
    v111295: ( state_type * $int ) > $o ).

tff(pred_def_62903,type,
    v111294: ( state_type * $int ) > $o ).

tff(pred_def_62904,type,
    v111300: state_type > $o ).

tff(pred_def_62905,type,
    v111299: ( state_type * $int ) > $o ).

tff(pred_def_62906,type,
    v111298: ( state_type * $int ) > $o ).

tff(pred_def_62907,type,
    v111274: ( state_type * $int ) > $o ).

tff(pred_def_62908,type,
    v111297: ( state_type * $int ) > $o ).

tff(pred_def_62909,type,
    v111288: ( state_type * $int ) > $o ).

tff(pred_def_62910,type,
    v111286: ( state_type * $int ) > $o ).

tff(pred_def_62911,type,
    v111304: state_type > $o ).

tff(pred_def_62912,type,
    v111302: state_type > $o ).

tff(pred_def_62913,type,
    v111311: state_type > $o ).

tff(pred_def_62914,type,
    v111309: state_type > $o ).

tff(pred_def_62915,type,
    v111308: state_type > $o ).

tff(pred_def_62916,type,
    v111307: state_type > $o ).

tff(pred_def_62917,type,
    v111319: state_type > $o ).

tff(pred_def_62918,type,
    v111320: state_type > $o ).

tff(pred_def_62919,type,
    v111318: state_type > $o ).

tff(pred_def_62920,type,
    v111315: ( state_type * $int ) > $o ).

tff(pred_def_62921,type,
    v111317: ( state_type * $int ) > $o ).

tff(pred_def_62922,type,
    v111276: ( state_type * $int ) > $o ).

tff(pred_def_62923,type,
    v111272: ( state_type * $int ) > $o ).

tff(pred_def_62924,type,
    v111270: ( state_type * $int ) > $o ).

tff(pred_def_62925,type,
    v111268: ( state_type * $int ) > $o ).

tff(pred_def_62926,type,
    v111324: state_type > $o ).

tff(pred_def_62927,type,
    v111323: ( state_type * $int ) > $o ).

tff(pred_def_62928,type,
    v111266: ( state_type * $int ) > $o ).

tff(pred_def_62929,type,
    v111264: ( state_type * $int ) > $o ).

tff(pred_def_62930,type,
    v111262: ( state_type * $int ) > $o ).

tff(pred_def_62931,type,
    v111328: state_type > $o ).

tff(pred_def_62932,type,
    v111326: state_type > $o ).

tff(pred_def_62933,type,
    v111335: state_type > $o ).

tff(pred_def_62934,type,
    v111333: state_type > $o ).

tff(pred_def_62935,type,
    v111332: state_type > $o ).

tff(pred_def_62936,type,
    v111331: state_type > $o ).

tff(pred_def_62937,type,
    v111343: state_type > $o ).

tff(pred_def_62938,type,
    v111344: state_type > $o ).

tff(pred_def_62939,type,
    v111342: state_type > $o ).

tff(pred_def_62940,type,
    v111339: ( state_type * $int ) > $o ).

tff(pred_def_62941,type,
    v111341: ( state_type * $int ) > $o ).

tff(pred_def_62942,type,
    v111330: ( state_type * $int ) > $o ).

tff(pred_def_62943,type,
    v111252: ( state_type * $int ) > $o ).

tff(pred_def_62944,type,
    v111250: ( state_type * $int ) > $o ).

tff(pred_def_62945,type,
    v111248: ( state_type * $int ) > $o ).

tff(pred_def_62946,type,
    v111246: ( state_type * $int ) > $o ).

tff(pred_def_62947,type,
    v111347: ( state_type * $int ) > $o ).

tff(pred_def_62948,type,
    v111237: ( state_type * $int ) > $o ).

tff(pred_def_62949,type,
    v111235: ( state_type * $int ) > $o ).

tff(pred_def_62950,type,
    v111354: state_type > $o ).

tff(pred_def_62951,type,
    v111353: state_type > $o ).

tff(pred_def_62952,type,
    v111355: state_type > $o ).

tff(pred_def_62953,type,
    v111351: state_type > $o ).

tff(pred_def_62954,type,
    v111349: state_type > $o ).

tff(pred_def_62955,type,
    v111359: state_type > $o ).

tff(pred_def_62956,type,
    v111358: ( state_type * $int ) > $o ).

tff(pred_def_62957,type,
    v111357: ( state_type * $int ) > $o ).

tff(pred_def_62958,type,
    v111363: state_type > $o ).

tff(pred_def_62959,type,
    v111362: ( state_type * $int ) > $o ).

tff(pred_def_62960,type,
    v111361: ( state_type * $int ) > $o ).

tff(pred_def_62961,type,
    v111360: ( state_type * $int ) > $o ).

tff(pred_def_62962,type,
    v111356: ( state_type * $int ) > $o ).

tff(pred_def_62963,type,
    v111233: ( state_type * $int ) > $o ).

tff(pred_def_62964,type,
    v111231: ( state_type * $int ) > $o ).

tff(pred_def_62965,type,
    v111367: state_type > $o ).

tff(pred_def_62966,type,
    v111365: state_type > $o ).

tff(pred_def_62967,type,
    v111374: state_type > $o ).

tff(pred_def_62968,type,
    v111372: state_type > $o ).

tff(pred_def_62969,type,
    v111371: state_type > $o ).

tff(pred_def_62970,type,
    v111370: state_type > $o ).

tff(pred_def_62971,type,
    v111382: state_type > $o ).

tff(pred_def_62972,type,
    v111383: state_type > $o ).

tff(pred_def_62973,type,
    v111381: state_type > $o ).

tff(pred_def_62974,type,
    v111378: ( state_type * $int ) > $o ).

tff(pred_def_62975,type,
    v111380: ( state_type * $int ) > $o ).

tff(pred_def_62976,type,
    v111369: ( state_type * $int ) > $o ).

tff(pred_def_62977,type,
    v111391: state_type > $o ).

tff(pred_def_62978,type,
    v111389: state_type > $o ).

tff(pred_def_62979,type,
    v111388: state_type > $o ).

tff(pred_def_62980,type,
    v111387: ( state_type * $int ) > $o ).

tff(pred_def_62981,type,
    v111399: state_type > $o ).

tff(pred_def_62982,type,
    v111397: state_type > $o ).

tff(pred_def_62983,type,
    v111396: state_type > $o ).

tff(pred_def_62984,type,
    v111395: ( state_type * $int ) > $o ).

tff(pred_def_62985,type,
    v111405: state_type > $o ).

tff(pred_def_62986,type,
    v111403: state_type > $o ).

tff(pred_def_62987,type,
    v111409: state_type > $o ).

tff(pred_def_62988,type,
    v111407: state_type > $o ).

tff(pred_def_62989,type,
    v111423: ( state_type * $int ) > $o ).

tff(pred_def_62990,type,
    v111421: ( state_type * $int ) > $o ).

tff(pred_def_62991,type,
    v111419: ( state_type * $int ) > $o ).

tff(pred_def_62992,type,
    v111426: ( state_type * $int ) > $o ).

tff(pred_def_62993,type,
    v111427: ( state_type * $int ) > $o ).

tff(pred_def_62994,type,
    v111417: ( state_type * $int ) > $o ).

tff(pred_def_62995,type,
    v111415: ( state_type * $int ) > $o ).

tff(pred_def_62996,type,
    v111434: state_type > $o ).

tff(pred_def_62997,type,
    v111433: state_type > $o ).

tff(pred_def_62998,type,
    v111435: state_type > $o ).

tff(pred_def_62999,type,
    v111431: state_type > $o ).

tff(pred_def_63000,type,
    v111429: state_type > $o ).

tff(pred_def_63001,type,
    v111439: state_type > $o ).

tff(pred_def_63002,type,
    v111438: ( state_type * $int ) > $o ).

tff(pred_def_63003,type,
    v111437: ( state_type * $int ) > $o ).

tff(pred_def_63004,type,
    v111443: state_type > $o ).

tff(pred_def_63005,type,
    v111442: ( state_type * $int ) > $o ).

tff(pred_def_63006,type,
    v111441: ( state_type * $int ) > $o ).

tff(pred_def_63007,type,
    v111440: ( state_type * $int ) > $o ).

tff(pred_def_63008,type,
    v111436: ( state_type * $int ) > $o ).

tff(pred_def_63009,type,
    v111413: ( state_type * $int ) > $o ).

tff(pred_def_63010,type,
    v111411: ( state_type * $int ) > $o ).

tff(pred_def_63011,type,
    v111447: state_type > $o ).

tff(pred_def_63012,type,
    v111445: state_type > $o ).

tff(pred_def_63013,type,
    v111454: state_type > $o ).

tff(pred_def_63014,type,
    v111452: state_type > $o ).

tff(pred_def_63015,type,
    v111451: state_type > $o ).

tff(pred_def_63016,type,
    v111450: state_type > $o ).

tff(pred_def_63017,type,
    v111462: state_type > $o ).

tff(pred_def_63018,type,
    v111463: state_type > $o ).

tff(pred_def_63019,type,
    v111461: state_type > $o ).

tff(pred_def_63020,type,
    v111458: ( state_type * $int ) > $o ).

tff(pred_def_63021,type,
    v111460: ( state_type * $int ) > $o ).

tff(pred_def_63022,type,
    v111449: ( state_type * $int ) > $o ).

tff(pred_def_63023,type,
    v111471: state_type > $o ).

tff(pred_def_63024,type,
    v111469: state_type > $o ).

tff(pred_def_63025,type,
    v111468: state_type > $o ).

tff(pred_def_63026,type,
    v111467: ( state_type * $int ) > $o ).

tff(pred_def_63027,type,
    v111479: state_type > $o ).

tff(pred_def_63028,type,
    v111477: state_type > $o ).

tff(pred_def_63029,type,
    v111476: state_type > $o ).

tff(pred_def_63030,type,
    v111475: ( state_type * $int ) > $o ).

tff(pred_def_63031,type,
    v111483: ( state_type * $int ) > $o ).

tff(pred_def_63032,type,
    v111484: ( state_type * $int ) > $o ).

tff(pred_def_63033,type,
    v111482: ( state_type * $int ) > $o ).

tff(pred_def_63034,type,
    v111093: ( state_type * $int ) > $o ).

tff(pred_def_63035,type,
    v111091: ( state_type * $int ) > $o ).

tff(pred_def_63036,type,
    v111089: ( state_type * $int ) > $o ).

tff(pred_def_63037,type,
    v111087: ( state_type * $int ) > $o ).

tff(pred_def_63038,type,
    v111487: state_type > $o ).

tff(pred_def_63039,type,
    v111486: state_type > $o ).

tff(pred_def_63040,type,
    v111490: state_type > $o ).

tff(pred_def_63041,type,
    v111489: state_type > $o ).

tff(pred_def_63042,type,
    v111488: state_type > $o ).

tff(pred_def_63043,type,
    v110870: state_type > $o ).

tff(pred_def_63044,type,
    v111491: ( state_type * $int ) > $o ).

tff(pred_def_63045,type,
    v111492: state_type > $o ).

tff(pred_def_63046,type,
    v110868: ( state_type * $int ) > $o ).

tff(pred_def_63047,type,
    v110866: ( state_type * $int ) > $o ).

tff(pred_def_63048,type,
    v110864: ( state_type * $int ) > $o ).

tff(pred_def_63049,type,
    v111496: state_type > $o ).

tff(pred_def_63050,type,
    v111494: state_type > $o ).

tff(pred_def_63051,type,
    v111503: state_type > $o ).

tff(pred_def_63052,type,
    v111501: state_type > $o ).

tff(pred_def_63053,type,
    v111500: state_type > $o ).

tff(pred_def_63054,type,
    v111499: state_type > $o ).

tff(pred_def_63055,type,
    v111511: state_type > $o ).

tff(pred_def_63056,type,
    v111512: state_type > $o ).

tff(pred_def_63057,type,
    v111510: state_type > $o ).

tff(pred_def_63058,type,
    v111507: ( state_type * $int ) > $o ).

tff(pred_def_63059,type,
    v111509: ( state_type * $int ) > $o ).

tff(pred_def_63060,type,
    v111498: ( state_type * $int ) > $o ).

tff(pred_def_63061,type,
    v110854: ( state_type * $int ) > $o ).

tff(pred_def_63062,type,
    v110852: ( state_type * $int ) > $o ).

tff(pred_def_63063,type,
    v110850: state_type > $o ).

tff(pred_def_63064,type,
    v111532: state_type > $o ).

tff(pred_def_63065,type,
    v111530: state_type > $o ).

tff(pred_def_63066,type,
    v111536: state_type > $o ).

tff(pred_def_63067,type,
    v111534: state_type > $o ).

tff(pred_def_63068,type,
    v111554: state_type > $o ).

tff(pred_def_63069,type,
    v111552: state_type > $o ).

tff(pred_def_63070,type,
    v111558: state_type > $o ).

tff(pred_def_63071,type,
    v111556: state_type > $o ).

tff(pred_def_63072,type,
    v111569: state_type > $o ).

tff(pred_def_63073,type,
    v111568: state_type > $o ).

tff(pred_def_63074,type,
    v111546: state_type > $o ).

tff(pred_def_63075,type,
    v111566: state_type > $o ).

tff(pred_def_63076,type,
    v111564: state_type > $o ).

tff(pred_def_63077,type,
    v111562: state_type > $o ).

tff(pred_def_63078,type,
    v111560: state_type > $o ).

tff(pred_def_63079,type,
    v111573: state_type > $o ).

tff(pred_def_63080,type,
    v111571: state_type > $o ).

tff(pred_def_63081,type,
    v111580: state_type > $o ).

tff(pred_def_63082,type,
    v111578: state_type > $o ).

tff(pred_def_63083,type,
    v111577: state_type > $o ).

tff(pred_def_63084,type,
    v111576: state_type > $o ).

tff(pred_def_63085,type,
    v111588: state_type > $o ).

tff(pred_def_63086,type,
    v111589: state_type > $o ).

tff(pred_def_63087,type,
    v111587: state_type > $o ).

tff(pred_def_63088,type,
    v111584: state_type > $o ).

tff(pred_def_63089,type,
    v111586: state_type > $o ).

tff(pred_def_63090,type,
    v111550: state_type > $o ).

tff(pred_def_63091,type,
    v111548: state_type > $o ).

tff(pred_def_63092,type,
    v111544: state_type > $o ).

tff(pred_def_63093,type,
    v111542: state_type > $o ).

tff(pred_def_63094,type,
    v111594: state_type > $o ).

tff(pred_def_63095,type,
    v111598: state_type > $o ).

tff(pred_def_63096,type,
    v111597: state_type > $o ).

tff(pred_def_63097,type,
    v111596: state_type > $o ).

tff(pred_def_63098,type,
    v111602: state_type > $o ).

tff(pred_def_63099,type,
    v111601: state_type > $o ).

tff(pred_def_63100,type,
    v111600: state_type > $o ).

tff(pred_def_63101,type,
    v111526: state_type > $o ).

tff(pred_def_63102,type,
    v111599: state_type > $o ).

tff(pred_def_63103,type,
    v111540: state_type > $o ).

tff(pred_def_63104,type,
    v111538: state_type > $o ).

tff(pred_def_63105,type,
    v111606: state_type > $o ).

tff(pred_def_63106,type,
    v111604: state_type > $o ).

tff(pred_def_63107,type,
    v111613: state_type > $o ).

tff(pred_def_63108,type,
    v111611: state_type > $o ).

tff(pred_def_63109,type,
    v111610: state_type > $o ).

tff(pred_def_63110,type,
    v111609: state_type > $o ).

tff(pred_def_63111,type,
    v111621: state_type > $o ).

tff(pred_def_63112,type,
    v111622: state_type > $o ).

tff(pred_def_63113,type,
    v111620: state_type > $o ).

tff(pred_def_63114,type,
    v111617: state_type > $o ).

tff(pred_def_63115,type,
    v111619: state_type > $o ).

tff(pred_def_63116,type,
    v111528: state_type > $o ).

tff(pred_def_63117,type,
    v111524: state_type > $o ).

tff(pred_def_63118,type,
    v111522: state_type > $o ).

tff(pred_def_63119,type,
    v111630: state_type > $o ).

tff(pred_def_63120,type,
    v111628: state_type > $o ).

tff(pred_def_63121,type,
    v111627: state_type > $o ).

tff(pred_def_63122,type,
    v111626: ( state_type * $int ) > $o ).

tff(pred_def_63123,type,
    v111519: state_type > $o ).

tff(pred_def_63124,type,
    v111634: ( state_type * $int ) > $o ).

tff(pred_def_63125,type,
    v111637: state_type > $o ).

tff(pred_def_63126,type,
    v111636: state_type > $o ).

tff(pred_def_63127,type,
    v111640: state_type > $o ).

tff(pred_def_63128,type,
    v111639: state_type > $o ).

tff(pred_def_63129,type,
    v111638: state_type > $o ).

tff(pred_def_63130,type,
    v111646: state_type > $o ).

tff(pred_def_63131,type,
    v111644: state_type > $o ).

tff(pred_def_63132,type,
    v111643: state_type > $o ).

tff(pred_def_63133,type,
    v111642: ( state_type * $int ) > $o ).

tff(pred_def_63134,type,
    v111516: state_type > $o ).

tff(pred_def_63135,type,
    v110848: state_type > $o ).

tff(pred_def_63136,type,
    v111659: state_type > $o ).

tff(pred_def_63137,type,
    v111657: state_type > $o ).

tff(pred_def_63138,type,
    v111663: state_type > $o ).

tff(pred_def_63139,type,
    v111661: state_type > $o ).

tff(pred_def_63140,type,
    v111669: state_type > $o ).

tff(pred_def_63141,type,
    v111667: state_type > $o ).

tff(pred_def_63142,type,
    v111665: state_type > $o ).

tff(pred_def_63143,type,
    v111673: state_type > $o ).

tff(pred_def_63144,type,
    v111671: state_type > $o ).

tff(pred_def_63145,type,
    v111680: state_type > $o ).

tff(pred_def_63146,type,
    v111678: state_type > $o ).

tff(pred_def_63147,type,
    v111677: state_type > $o ).

tff(pred_def_63148,type,
    v111676: state_type > $o ).

tff(pred_def_63149,type,
    v111688: state_type > $o ).

tff(pred_def_63150,type,
    v111689: state_type > $o ).

tff(pred_def_63151,type,
    v111687: state_type > $o ).

tff(pred_def_63152,type,
    v111684: state_type > $o ).

tff(pred_def_63153,type,
    v111686: state_type > $o ).

tff(pred_def_63154,type,
    v111655: state_type > $o ).

tff(pred_def_63155,type,
    v111653: state_type > $o ).

tff(pred_def_63156,type,
    v111651: state_type > $o ).

tff(pred_def_63157,type,
    v111701: state_type > $o ).

tff(pred_def_63158,type,
    v111699: state_type > $o ).

tff(pred_def_63159,type,
    v111705: state_type > $o ).

tff(pred_def_63160,type,
    v111703: state_type > $o ).

tff(pred_def_63161,type,
    v111723: state_type > $o ).

tff(pred_def_63162,type,
    v111721: state_type > $o ).

tff(pred_def_63163,type,
    v111727: state_type > $o ).

tff(pred_def_63164,type,
    v111725: state_type > $o ).

tff(pred_def_63165,type,
    v111747: state_type > $o ).

tff(pred_def_63166,type,
    v111745: state_type > $o ).

tff(pred_def_63167,type,
    v111751: state_type > $o ).

tff(pred_def_63168,type,
    v111749: state_type > $o ).

tff(pred_def_63169,type,
    v111739: ( state_type * $int ) > $o ).

tff(pred_def_63170,type,
    v111779: state_type > $o ).

tff(pred_def_63171,type,
    v111778: state_type > $o ).

tff(pred_def_63172,type,
    v111777: state_type > $o ).

tff(pred_def_63173,type,
    v111776: state_type > $o ).

tff(pred_def_63174,type,
    v111775: state_type > $o ).

tff(pred_def_63175,type,
    v111774: state_type > $o ).

tff(pred_def_63176,type,
    v111773: state_type > $o ).

tff(pred_def_63177,type,
    v111772: state_type > $o ).

tff(pred_def_63178,type,
    v111771: state_type > $o ).

tff(pred_def_63179,type,
    v111770: state_type > $o ).

tff(pred_def_63180,type,
    v111769: state_type > $o ).

tff(pred_def_63181,type,
    v111768: state_type > $o ).

tff(pred_def_63182,type,
    v111767: state_type > $o ).

tff(pred_def_63183,type,
    v111766: state_type > $o ).

tff(pred_def_63184,type,
    v111765: state_type > $o ).

tff(pred_def_63185,type,
    v111780: state_type > $o ).

tff(pred_def_63186,type,
    v111764: state_type > $o ).

tff(pred_def_63187,type,
    v111781: state_type > $o ).

tff(pred_def_63188,type,
    v111763: state_type > $o ).

tff(pred_def_63189,type,
    v111784: state_type > $o ).

tff(pred_def_63190,type,
    v111785: state_type > $o ).

tff(pred_def_63191,type,
    v111783: state_type > $o ).

tff(pred_def_63192,type,
    v111786: state_type > $o ).

tff(pred_def_63193,type,
    v111782: state_type > $o ).

tff(pred_def_63194,type,
    v111789: state_type > $o ).

tff(pred_def_63195,type,
    v111790: state_type > $o ).

tff(pred_def_63196,type,
    v111788: state_type > $o ).

tff(pred_def_63197,type,
    v111791: state_type > $o ).

tff(pred_def_63198,type,
    v111787: state_type > $o ).

tff(pred_def_63199,type,
    v111794: state_type > $o ).

tff(pred_def_63200,type,
    v111795: state_type > $o ).

tff(pred_def_63201,type,
    v111793: state_type > $o ).

tff(pred_def_63202,type,
    v111796: state_type > $o ).

tff(pred_def_63203,type,
    v111792: state_type > $o ).

tff(pred_def_63204,type,
    v111799: state_type > $o ).

tff(pred_def_63205,type,
    v111800: state_type > $o ).

tff(pred_def_63206,type,
    v111798: state_type > $o ).

tff(pred_def_63207,type,
    v111801: state_type > $o ).

tff(pred_def_63208,type,
    v111797: state_type > $o ).

tff(pred_def_63209,type,
    v111804: state_type > $o ).

tff(pred_def_63210,type,
    v111805: state_type > $o ).

tff(pred_def_63211,type,
    v111803: state_type > $o ).

tff(pred_def_63212,type,
    v111806: state_type > $o ).

tff(pred_def_63213,type,
    v111802: state_type > $o ).

tff(pred_def_63214,type,
    v111809: state_type > $o ).

tff(pred_def_63215,type,
    v111810: state_type > $o ).

tff(pred_def_63216,type,
    v111808: state_type > $o ).

tff(pred_def_63217,type,
    v111811: state_type > $o ).

tff(pred_def_63218,type,
    v111807: state_type > $o ).

tff(pred_def_63219,type,
    v111814: state_type > $o ).

tff(pred_def_63220,type,
    v111815: state_type > $o ).

tff(pred_def_63221,type,
    v111813: state_type > $o ).

tff(pred_def_63222,type,
    v111816: state_type > $o ).

tff(pred_def_63223,type,
    v111812: state_type > $o ).

tff(pred_def_63224,type,
    v111819: state_type > $o ).

tff(pred_def_63225,type,
    v111820: state_type > $o ).

tff(pred_def_63226,type,
    v111818: state_type > $o ).

tff(pred_def_63227,type,
    v111821: state_type > $o ).

tff(pred_def_63228,type,
    v111817: state_type > $o ).

tff(pred_def_63229,type,
    v111824: state_type > $o ).

tff(pred_def_63230,type,
    v111825: state_type > $o ).

tff(pred_def_63231,type,
    v111823: state_type > $o ).

tff(pred_def_63232,type,
    v111826: state_type > $o ).

tff(pred_def_63233,type,
    v111822: state_type > $o ).

tff(pred_def_63234,type,
    v111829: state_type > $o ).

tff(pred_def_63235,type,
    v111830: state_type > $o ).

tff(pred_def_63236,type,
    v111828: state_type > $o ).

tff(pred_def_63237,type,
    v111831: state_type > $o ).

tff(pred_def_63238,type,
    v111827: state_type > $o ).

tff(pred_def_63239,type,
    v111834: state_type > $o ).

tff(pred_def_63240,type,
    v111835: state_type > $o ).

tff(pred_def_63241,type,
    v111833: state_type > $o ).

tff(pred_def_63242,type,
    v111836: state_type > $o ).

tff(pred_def_63243,type,
    v111832: state_type > $o ).

tff(pred_def_63244,type,
    v111839: state_type > $o ).

tff(pred_def_63245,type,
    v111840: state_type > $o ).

tff(pred_def_63246,type,
    v111838: state_type > $o ).

tff(pred_def_63247,type,
    v111841: state_type > $o ).

tff(pred_def_63248,type,
    v111837: state_type > $o ).

tff(pred_def_63249,type,
    v111844: state_type > $o ).

tff(pred_def_63250,type,
    v111845: state_type > $o ).

tff(pred_def_63251,type,
    v111843: state_type > $o ).

tff(pred_def_63252,type,
    v111846: state_type > $o ).

tff(pred_def_63253,type,
    v111842: state_type > $o ).

tff(pred_def_63254,type,
    v111849: state_type > $o ).

tff(pred_def_63255,type,
    v111850: state_type > $o ).

tff(pred_def_63256,type,
    v111848: state_type > $o ).

tff(pred_def_63257,type,
    v111851: state_type > $o ).

tff(pred_def_63258,type,
    v111847: state_type > $o ).

tff(pred_def_63259,type,
    v111761: ( state_type * $int ) > $o ).

tff(pred_def_63260,type,
    v111737: state_type > $o ).

tff(pred_def_63261,type,
    v111759: ( state_type * $int ) > $o ).

tff(pred_def_63262,type,
    v111757: ( state_type * $int ) > $o ).

tff(pred_def_63263,type,
    v111755: ( state_type * $int ) > $o ).

tff(pred_def_63264,type,
    v111753: ( state_type * $int ) > $o ).

tff(pred_def_63265,type,
    v111855: state_type > $o ).

tff(pred_def_63266,type,
    v111853: state_type > $o ).

tff(pred_def_63267,type,
    v111862: state_type > $o ).

tff(pred_def_63268,type,
    v111860: state_type > $o ).

tff(pred_def_63269,type,
    v111859: state_type > $o ).

tff(pred_def_63270,type,
    v111858: state_type > $o ).

tff(pred_def_63271,type,
    v111870: state_type > $o ).

tff(pred_def_63272,type,
    v111871: state_type > $o ).

tff(pred_def_63273,type,
    v111869: state_type > $o ).

tff(pred_def_63274,type,
    v111866: ( state_type * $int ) > $o ).

tff(pred_def_63275,type,
    v111868: ( state_type * $int ) > $o ).

tff(pred_def_63276,type,
    v111743: ( state_type * $int ) > $o ).

tff(pred_def_63277,type,
    v111741: ( state_type * $int ) > $o ).

tff(pred_def_63278,type,
    v111885: state_type > $o ).

tff(pred_def_63279,type,
    v111883: state_type > $o ).

tff(pred_def_63280,type,
    v111889: state_type > $o ).

tff(pred_def_63281,type,
    v111887: state_type > $o ).

tff(pred_def_63282,type,
    v111899: ( state_type * $int ) > $o ).

tff(pred_def_63283,type,
    v111897: ( state_type * $int ) > $o ).

tff(pred_def_63284,type,
    v111895: ( state_type * $int ) > $o ).

tff(pred_def_63285,type,
    b0000001001000: $int > $o ).

tff(pred_def_63286,type,
    v111907: state_type > $o ).

tff(pred_def_63287,type,
    v111904: state_type > $o ).

tff(pred_def_63288,type,
    v111902: state_type > $o ).

tff(pred_def_63289,type,
    v111911: state_type > $o ).

tff(pred_def_63290,type,
    v111910: ( state_type * $int ) > $o ).

tff(pred_def_63291,type,
    v111909: ( state_type * $int ) > $o ).

tff(pred_def_63292,type,
    v111915: state_type > $o ).

tff(pred_def_63293,type,
    v111914: ( state_type * $int ) > $o ).

tff(pred_def_63294,type,
    v111913: ( state_type * $int ) > $o ).

tff(pred_def_63295,type,
    v111879: ( state_type * $int ) > $o ).

tff(pred_def_63296,type,
    v111912: ( state_type * $int ) > $o ).

tff(pred_def_63297,type,
    v111893: ( state_type * $int ) > $o ).

tff(pred_def_63298,type,
    v111891: ( state_type * $int ) > $o ).

tff(pred_def_63299,type,
    v111919: state_type > $o ).

tff(pred_def_63300,type,
    v111917: state_type > $o ).

tff(pred_def_63301,type,
    v111926: state_type > $o ).

tff(pred_def_63302,type,
    v111924: state_type > $o ).

tff(pred_def_63303,type,
    v111923: state_type > $o ).

tff(pred_def_63304,type,
    v111922: state_type > $o ).

tff(pred_def_63305,type,
    v111934: state_type > $o ).

tff(pred_def_63306,type,
    v111935: state_type > $o ).

tff(pred_def_63307,type,
    v111933: state_type > $o ).

tff(pred_def_63308,type,
    v111930: ( state_type * $int ) > $o ).

tff(pred_def_63309,type,
    v111932: ( state_type * $int ) > $o ).

tff(pred_def_63310,type,
    v111881: ( state_type * $int ) > $o ).

tff(pred_def_63311,type,
    v111877: ( state_type * $int ) > $o ).

tff(pred_def_63312,type,
    v111875: ( state_type * $int ) > $o ).

tff(pred_def_63313,type,
    v111948: state_type > $o ).

tff(pred_def_63314,type,
    v111946: state_type > $o ).

tff(pred_def_63315,type,
    v111952: state_type > $o ).

tff(pred_def_63316,type,
    v111950: state_type > $o ).

tff(pred_def_63317,type,
    v111960: state_type > $o ).

tff(pred_def_63318,type,
    v111962: state_type > $o ).

tff(pred_def_63319,type,
    v111964: state_type > $o ).

tff(pred_def_63320,type,
    v111966: state_type > $o ).

tff(pred_def_63321,type,
    v111968: state_type > $o ).

tff(pred_def_63322,type,
    v111970: state_type > $o ).

tff(pred_def_63323,type,
    v111974: state_type > $o ).

tff(pred_def_63324,type,
    v111976: state_type > $o ).

tff(pred_def_63325,type,
    v111972: state_type > $o ).

tff(pred_def_63326,type,
    v111958: ( state_type * $int ) > $o ).

tff(pred_def_63327,type,
    v111956: ( state_type * $int ) > $o ).

tff(pred_def_63328,type,
    v111954: ( state_type * $int ) > $o ).

tff(pred_def_63329,type,
    v111981: state_type > $o ).

tff(pred_def_63330,type,
    v111979: state_type > $o ).

tff(pred_def_63331,type,
    v111988: state_type > $o ).

tff(pred_def_63332,type,
    v111986: state_type > $o ).

tff(pred_def_63333,type,
    v111985: state_type > $o ).

tff(pred_def_63334,type,
    v111984: state_type > $o ).

tff(pred_def_63335,type,
    v111996: state_type > $o ).

tff(pred_def_63336,type,
    v111997: state_type > $o ).

tff(pred_def_63337,type,
    v111995: state_type > $o ).

tff(pred_def_63338,type,
    v111992: ( state_type * $int ) > $o ).

tff(pred_def_63339,type,
    v111994: ( state_type * $int ) > $o ).

tff(pred_def_63340,type,
    v111944: ( state_type * $int ) > $o ).

tff(pred_def_63341,type,
    v111942: ( state_type * $int ) > $o ).

tff(pred_def_63342,type,
    v111940: ( state_type * $int ) > $o ).

tff(pred_def_63343,type,
    v112033: state_type > $o ).

tff(pred_def_63344,type,
    v112037: state_type > $o ).

tff(pred_def_63345,type,
    v112036: state_type > $o ).

tff(pred_def_63346,type,
    v112038: state_type > $o ).

tff(pred_def_63347,type,
    v112035: state_type > $o ).

tff(pred_def_63348,type,
    v112034: state_type > $o ).

tff(pred_def_63349,type,
    v112032: state_type > $o ).

tff(pred_def_63350,type,
    v112039: state_type > $o ).

tff(pred_def_63351,type,
    v112031: state_type > $o ).

tff(pred_def_63352,type,
    v112043: state_type > $o ).

tff(pred_def_63353,type,
    v112042: state_type > $o ).

tff(pred_def_63354,type,
    v112044: state_type > $o ).

tff(pred_def_63355,type,
    v112041: state_type > $o ).

tff(pred_def_63356,type,
    v112040: state_type > $o ).

tff(pred_def_63357,type,
    v112030: state_type > $o ).

tff(pred_def_63358,type,
    v112045: state_type > $o ).

tff(pred_def_63359,type,
    v112029: state_type > $o ).

tff(pred_def_63360,type,
    v112049: state_type > $o ).

tff(pred_def_63361,type,
    v112048: state_type > $o ).

tff(pred_def_63362,type,
    v112050: state_type > $o ).

tff(pred_def_63363,type,
    v112047: state_type > $o ).

tff(pred_def_63364,type,
    v112046: state_type > $o ).

tff(pred_def_63365,type,
    v112028: state_type > $o ).

tff(pred_def_63366,type,
    v112051: state_type > $o ).

tff(pred_def_63367,type,
    v112027: state_type > $o ).

tff(pred_def_63368,type,
    v112055: state_type > $o ).

tff(pred_def_63369,type,
    v112054: state_type > $o ).

tff(pred_def_63370,type,
    v112056: state_type > $o ).

tff(pred_def_63371,type,
    v112053: state_type > $o ).

tff(pred_def_63372,type,
    v112052: state_type > $o ).

tff(pred_def_63373,type,
    v112026: state_type > $o ).

tff(pred_def_63374,type,
    v112057: state_type > $o ).

tff(pred_def_63375,type,
    v112025: state_type > $o ).

tff(pred_def_63376,type,
    v112061: state_type > $o ).

tff(pred_def_63377,type,
    v112060: state_type > $o ).

tff(pred_def_63378,type,
    v112062: state_type > $o ).

tff(pred_def_63379,type,
    v112059: state_type > $o ).

tff(pred_def_63380,type,
    v112058: state_type > $o ).

tff(pred_def_63381,type,
    v112024: state_type > $o ).

tff(pred_def_63382,type,
    v112063: state_type > $o ).

tff(pred_def_63383,type,
    v112023: state_type > $o ).

tff(pred_def_63384,type,
    v112067: state_type > $o ).

tff(pred_def_63385,type,
    v112066: state_type > $o ).

tff(pred_def_63386,type,
    v112068: state_type > $o ).

tff(pred_def_63387,type,
    v112065: state_type > $o ).

tff(pred_def_63388,type,
    v112064: state_type > $o ).

tff(pred_def_63389,type,
    v112022: state_type > $o ).

tff(pred_def_63390,type,
    v112069: state_type > $o ).

tff(pred_def_63391,type,
    v112021: state_type > $o ).

tff(pred_def_63392,type,
    v112073: state_type > $o ).

tff(pred_def_63393,type,
    v112072: state_type > $o ).

tff(pred_def_63394,type,
    v112074: state_type > $o ).

tff(pred_def_63395,type,
    v112071: state_type > $o ).

tff(pred_def_63396,type,
    v112070: state_type > $o ).

tff(pred_def_63397,type,
    v112020: state_type > $o ).

tff(pred_def_63398,type,
    v112075: state_type > $o ).

tff(pred_def_63399,type,
    v112019: state_type > $o ).

tff(pred_def_63400,type,
    v112079: state_type > $o ).

tff(pred_def_63401,type,
    v112078: state_type > $o ).

tff(pred_def_63402,type,
    v112080: state_type > $o ).

tff(pred_def_63403,type,
    v112077: state_type > $o ).

tff(pred_def_63404,type,
    v112076: state_type > $o ).

tff(pred_def_63405,type,
    v112018: state_type > $o ).

tff(pred_def_63406,type,
    v112081: state_type > $o ).

tff(pred_def_63407,type,
    v112017: state_type > $o ).

tff(pred_def_63408,type,
    v112085: state_type > $o ).

tff(pred_def_63409,type,
    v112084: state_type > $o ).

tff(pred_def_63410,type,
    v112086: state_type > $o ).

tff(pred_def_63411,type,
    v112083: state_type > $o ).

tff(pred_def_63412,type,
    v112082: state_type > $o ).

tff(pred_def_63413,type,
    v112016: state_type > $o ).

tff(pred_def_63414,type,
    v112087: state_type > $o ).

tff(pred_def_63415,type,
    v112015: state_type > $o ).

tff(pred_def_63416,type,
    v112091: state_type > $o ).

tff(pred_def_63417,type,
    v112090: state_type > $o ).

tff(pred_def_63418,type,
    v112092: state_type > $o ).

tff(pred_def_63419,type,
    v112089: state_type > $o ).

tff(pred_def_63420,type,
    v112088: state_type > $o ).

tff(pred_def_63421,type,
    v112014: state_type > $o ).

tff(pred_def_63422,type,
    v112093: state_type > $o ).

tff(pred_def_63423,type,
    v112013: state_type > $o ).

tff(pred_def_63424,type,
    v112097: state_type > $o ).

tff(pred_def_63425,type,
    v112096: state_type > $o ).

tff(pred_def_63426,type,
    v112098: state_type > $o ).

tff(pred_def_63427,type,
    v112095: state_type > $o ).

tff(pred_def_63428,type,
    v112094: state_type > $o ).

tff(pred_def_63429,type,
    v112012: state_type > $o ).

tff(pred_def_63430,type,
    v112099: state_type > $o ).

tff(pred_def_63431,type,
    v112011: state_type > $o ).

tff(pred_def_63432,type,
    v112103: state_type > $o ).

tff(pred_def_63433,type,
    v112102: state_type > $o ).

tff(pred_def_63434,type,
    v112104: state_type > $o ).

tff(pred_def_63435,type,
    v112101: state_type > $o ).

tff(pred_def_63436,type,
    v112100: state_type > $o ).

tff(pred_def_63437,type,
    v112010: state_type > $o ).

tff(pred_def_63438,type,
    v112105: state_type > $o ).

tff(pred_def_63439,type,
    v112009: state_type > $o ).

tff(pred_def_63440,type,
    v112109: state_type > $o ).

tff(pred_def_63441,type,
    v112108: state_type > $o ).

tff(pred_def_63442,type,
    v112110: state_type > $o ).

tff(pred_def_63443,type,
    v112107: state_type > $o ).

tff(pred_def_63444,type,
    v112106: state_type > $o ).

tff(pred_def_63445,type,
    v112008: state_type > $o ).

tff(pred_def_63446,type,
    v112111: state_type > $o ).

tff(pred_def_63447,type,
    v112007: state_type > $o ).

tff(pred_def_63448,type,
    v112115: state_type > $o ).

tff(pred_def_63449,type,
    v112114: state_type > $o ).

tff(pred_def_63450,type,
    v112116: state_type > $o ).

tff(pred_def_63451,type,
    v112113: state_type > $o ).

tff(pred_def_63452,type,
    v112112: state_type > $o ).

tff(pred_def_63453,type,
    v112006: state_type > $o ).

tff(pred_def_63454,type,
    v112117: state_type > $o ).

tff(pred_def_63455,type,
    v112005: state_type > $o ).

tff(pred_def_63456,type,
    v112121: state_type > $o ).

tff(pred_def_63457,type,
    v112120: state_type > $o ).

tff(pred_def_63458,type,
    v112122: state_type > $o ).

tff(pred_def_63459,type,
    v112119: state_type > $o ).

tff(pred_def_63460,type,
    v112118: state_type > $o ).

tff(pred_def_63461,type,
    v112004: state_type > $o ).

tff(pred_def_63462,type,
    v112123: state_type > $o ).

tff(pred_def_63463,type,
    v112003: state_type > $o ).

tff(pred_def_63464,type,
    v112001: state_type > $o ).

tff(pred_def_63465,type,
    v112127: state_type > $o ).

tff(pred_def_63466,type,
    v112126: state_type > $o ).

tff(pred_def_63467,type,
    v112124: state_type > $o ).

tff(pred_def_63468,type,
    v111715: ( state_type * $int ) > $o ).

tff(pred_def_63469,type,
    v112150: state_type > $o ).

tff(pred_def_63470,type,
    v112149: state_type > $o ).

tff(pred_def_63471,type,
    v112148: state_type > $o ).

tff(pred_def_63472,type,
    v112147: state_type > $o ).

tff(pred_def_63473,type,
    v112146: state_type > $o ).

tff(pred_def_63474,type,
    v112145: state_type > $o ).

tff(pred_def_63475,type,
    v112144: state_type > $o ).

tff(pred_def_63476,type,
    v112143: state_type > $o ).

tff(pred_def_63477,type,
    v112142: state_type > $o ).

tff(pred_def_63478,type,
    v112141: state_type > $o ).

tff(pred_def_63479,type,
    v112140: state_type > $o ).

tff(pred_def_63480,type,
    v112139: state_type > $o ).

tff(pred_def_63481,type,
    v112138: state_type > $o ).

tff(pred_def_63482,type,
    v112137: state_type > $o ).

tff(pred_def_63483,type,
    v112136: state_type > $o ).

tff(pred_def_63484,type,
    v112135: state_type > $o ).

tff(pred_def_63485,type,
    v112151: state_type > $o ).

tff(pred_def_63486,type,
    v112134: state_type > $o ).

tff(pred_def_63487,type,
    v112152: state_type > $o ).

tff(pred_def_63488,type,
    v112133: state_type > $o ).

tff(pred_def_63489,type,
    v112155: state_type > $o ).

tff(pred_def_63490,type,
    v112156: state_type > $o ).

tff(pred_def_63491,type,
    v112154: state_type > $o ).

tff(pred_def_63492,type,
    v112157: state_type > $o ).

tff(pred_def_63493,type,
    v112153: state_type > $o ).

tff(pred_def_63494,type,
    v112160: state_type > $o ).

tff(pred_def_63495,type,
    v112161: state_type > $o ).

tff(pred_def_63496,type,
    v112159: state_type > $o ).

tff(pred_def_63497,type,
    v112162: state_type > $o ).

tff(pred_def_63498,type,
    v112158: state_type > $o ).

tff(pred_def_63499,type,
    v112165: state_type > $o ).

tff(pred_def_63500,type,
    v112166: state_type > $o ).

tff(pred_def_63501,type,
    v112164: state_type > $o ).

tff(pred_def_63502,type,
    v112167: state_type > $o ).

tff(pred_def_63503,type,
    v112163: state_type > $o ).

tff(pred_def_63504,type,
    v112170: state_type > $o ).

tff(pred_def_63505,type,
    v112171: state_type > $o ).

tff(pred_def_63506,type,
    v112169: state_type > $o ).

tff(pred_def_63507,type,
    v112172: state_type > $o ).

tff(pred_def_63508,type,
    v112168: state_type > $o ).

tff(pred_def_63509,type,
    v112175: state_type > $o ).

tff(pred_def_63510,type,
    v112176: state_type > $o ).

tff(pred_def_63511,type,
    v112174: state_type > $o ).

tff(pred_def_63512,type,
    v112177: state_type > $o ).

tff(pred_def_63513,type,
    v112173: state_type > $o ).

tff(pred_def_63514,type,
    v112180: state_type > $o ).

tff(pred_def_63515,type,
    v112181: state_type > $o ).

tff(pred_def_63516,type,
    v112179: state_type > $o ).

tff(pred_def_63517,type,
    v112182: state_type > $o ).

tff(pred_def_63518,type,
    v112178: state_type > $o ).

tff(pred_def_63519,type,
    v112185: state_type > $o ).

tff(pred_def_63520,type,
    v112186: state_type > $o ).

tff(pred_def_63521,type,
    v112184: state_type > $o ).

tff(pred_def_63522,type,
    v112187: state_type > $o ).

tff(pred_def_63523,type,
    v112183: state_type > $o ).

tff(pred_def_63524,type,
    v112190: state_type > $o ).

tff(pred_def_63525,type,
    v112191: state_type > $o ).

tff(pred_def_63526,type,
    v112189: state_type > $o ).

tff(pred_def_63527,type,
    v112192: state_type > $o ).

tff(pred_def_63528,type,
    v112188: state_type > $o ).

tff(pred_def_63529,type,
    v112195: state_type > $o ).

tff(pred_def_63530,type,
    v112196: state_type > $o ).

tff(pred_def_63531,type,
    v112194: state_type > $o ).

tff(pred_def_63532,type,
    v112197: state_type > $o ).

tff(pred_def_63533,type,
    v112193: state_type > $o ).

tff(pred_def_63534,type,
    v112200: state_type > $o ).

tff(pred_def_63535,type,
    v112201: state_type > $o ).

tff(pred_def_63536,type,
    v112199: state_type > $o ).

tff(pred_def_63537,type,
    v112202: state_type > $o ).

tff(pred_def_63538,type,
    v112198: state_type > $o ).

tff(pred_def_63539,type,
    v112205: state_type > $o ).

tff(pred_def_63540,type,
    v112206: state_type > $o ).

tff(pred_def_63541,type,
    v112204: state_type > $o ).

tff(pred_def_63542,type,
    v112207: state_type > $o ).

tff(pred_def_63543,type,
    v112203: state_type > $o ).

tff(pred_def_63544,type,
    v112210: state_type > $o ).

tff(pred_def_63545,type,
    v112211: state_type > $o ).

tff(pred_def_63546,type,
    v112209: state_type > $o ).

tff(pred_def_63547,type,
    v112212: state_type > $o ).

tff(pred_def_63548,type,
    v112208: state_type > $o ).

tff(pred_def_63549,type,
    v112215: state_type > $o ).

tff(pred_def_63550,type,
    v112216: state_type > $o ).

tff(pred_def_63551,type,
    v112214: state_type > $o ).

tff(pred_def_63552,type,
    v112217: state_type > $o ).

tff(pred_def_63553,type,
    v112213: state_type > $o ).

tff(pred_def_63554,type,
    v112220: state_type > $o ).

tff(pred_def_63555,type,
    v112221: state_type > $o ).

tff(pred_def_63556,type,
    v112219: state_type > $o ).

tff(pred_def_63557,type,
    v112222: state_type > $o ).

tff(pred_def_63558,type,
    v112218: state_type > $o ).

tff(pred_def_63559,type,
    v112225: state_type > $o ).

tff(pred_def_63560,type,
    v112226: state_type > $o ).

tff(pred_def_63561,type,
    v112224: state_type > $o ).

tff(pred_def_63562,type,
    v112227: state_type > $o ).

tff(pred_def_63563,type,
    v112223: state_type > $o ).

tff(pred_def_63564,type,
    v112131: ( state_type * $int ) > $o ).

tff(pred_def_63565,type,
    b00000000000000000: $int > $o ).

tff(pred_def_63566,type,
    v111735: ( state_type * $int ) > $o ).

tff(pred_def_63567,type,
    v111733: ( state_type * $int ) > $o ).

tff(pred_def_63568,type,
    v112231: state_type > $o ).

tff(pred_def_63569,type,
    v112229: state_type > $o ).

tff(pred_def_63570,type,
    v112236: state_type > $o ).

tff(pred_def_63571,type,
    v112235: ( state_type * $int ) > $o ).

tff(pred_def_63572,type,
    v112234: ( state_type * $int ) > $o ).

tff(pred_def_63573,type,
    v112240: state_type > $o ).

tff(pred_def_63574,type,
    v112239: ( state_type * $int ) > $o ).

tff(pred_def_63575,type,
    v112238: ( state_type * $int ) > $o ).

tff(pred_def_63576,type,
    v111717: ( state_type * $int ) > $o ).

tff(pred_def_63577,type,
    v112237: ( state_type * $int ) > $o ).

tff(pred_def_63578,type,
    v111731: ( state_type * $int ) > $o ).

tff(pred_def_63579,type,
    v111729: ( state_type * $int ) > $o ).

tff(pred_def_63580,type,
    v112245: state_type > $o ).

tff(pred_def_63581,type,
    v112243: state_type > $o ).

tff(pred_def_63582,type,
    v112252: state_type > $o ).

tff(pred_def_63583,type,
    v112250: state_type > $o ).

tff(pred_def_63584,type,
    v112249: state_type > $o ).

tff(pred_def_63585,type,
    v112248: state_type > $o ).

tff(pred_def_63586,type,
    v112260: state_type > $o ).

tff(pred_def_63587,type,
    v112261: state_type > $o ).

tff(pred_def_63588,type,
    v112259: state_type > $o ).

tff(pred_def_63589,type,
    v112256: ( state_type * $int ) > $o ).

tff(pred_def_63590,type,
    bxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_63591,type,
    v112258: ( state_type * $int ) > $o ).

tff(pred_def_63592,type,
    v111719: ( state_type * $int ) > $o ).

tff(pred_def_63593,type,
    v112275: state_type > $o ).

tff(pred_def_63594,type,
    v112273: state_type > $o ).

tff(pred_def_63595,type,
    v112279: state_type > $o ).

tff(pred_def_63596,type,
    v112277: state_type > $o ).

tff(pred_def_63597,type,
    v112289: ( state_type * $int ) > $o ).

tff(pred_def_63598,type,
    v112287: ( state_type * $int ) > $o ).

tff(pred_def_63599,type,
    v112285: ( state_type * $int ) > $o ).

tff(pred_def_63600,type,
    b0000000101000: $int > $o ).

tff(pred_def_63601,type,
    v112297: state_type > $o ).

tff(pred_def_63602,type,
    v112294: state_type > $o ).

tff(pred_def_63603,type,
    v112292: state_type > $o ).

tff(pred_def_63604,type,
    v112301: state_type > $o ).

tff(pred_def_63605,type,
    v112300: ( state_type * $int ) > $o ).

tff(pred_def_63606,type,
    v112299: ( state_type * $int ) > $o ).

tff(pred_def_63607,type,
    v112305: state_type > $o ).

tff(pred_def_63608,type,
    v112304: ( state_type * $int ) > $o ).

tff(pred_def_63609,type,
    v112303: ( state_type * $int ) > $o ).

tff(pred_def_63610,type,
    v112269: ( state_type * $int ) > $o ).

tff(pred_def_63611,type,
    v112302: ( state_type * $int ) > $o ).

tff(pred_def_63612,type,
    v112283: ( state_type * $int ) > $o ).

tff(pred_def_63613,type,
    v112281: ( state_type * $int ) > $o ).

tff(pred_def_63614,type,
    v112309: state_type > $o ).

tff(pred_def_63615,type,
    v112307: state_type > $o ).

tff(pred_def_63616,type,
    v112316: state_type > $o ).

tff(pred_def_63617,type,
    v112314: state_type > $o ).

tff(pred_def_63618,type,
    v112313: state_type > $o ).

tff(pred_def_63619,type,
    v112312: state_type > $o ).

tff(pred_def_63620,type,
    v112324: state_type > $o ).

tff(pred_def_63621,type,
    v112325: state_type > $o ).

tff(pred_def_63622,type,
    v112323: state_type > $o ).

tff(pred_def_63623,type,
    v112320: ( state_type * $int ) > $o ).

tff(pred_def_63624,type,
    v112322: ( state_type * $int ) > $o ).

tff(pred_def_63625,type,
    v112271: ( state_type * $int ) > $o ).

tff(pred_def_63626,type,
    v112267: ( state_type * $int ) > $o ).

tff(pred_def_63627,type,
    v112265: ( state_type * $int ) > $o ).

tff(pred_def_63628,type,
    v112363: state_type > $o ).

tff(pred_def_63629,type,
    v112367: state_type > $o ).

tff(pred_def_63630,type,
    v112366: state_type > $o ).

tff(pred_def_63631,type,
    v112368: state_type > $o ).

tff(pred_def_63632,type,
    v112365: state_type > $o ).

tff(pred_def_63633,type,
    v112364: state_type > $o ).

tff(pred_def_63634,type,
    v112362: state_type > $o ).

tff(pred_def_63635,type,
    v112369: state_type > $o ).

tff(pred_def_63636,type,
    v112361: state_type > $o ).

tff(pred_def_63637,type,
    v112373: state_type > $o ).

tff(pred_def_63638,type,
    v112372: state_type > $o ).

tff(pred_def_63639,type,
    v112374: state_type > $o ).

tff(pred_def_63640,type,
    v112371: state_type > $o ).

tff(pred_def_63641,type,
    v112370: state_type > $o ).

tff(pred_def_63642,type,
    v112360: state_type > $o ).

tff(pred_def_63643,type,
    v112375: state_type > $o ).

tff(pred_def_63644,type,
    v112359: state_type > $o ).

tff(pred_def_63645,type,
    v112379: state_type > $o ).

tff(pred_def_63646,type,
    v112378: state_type > $o ).

tff(pred_def_63647,type,
    v112380: state_type > $o ).

tff(pred_def_63648,type,
    v112377: state_type > $o ).

tff(pred_def_63649,type,
    v112376: state_type > $o ).

tff(pred_def_63650,type,
    v112358: state_type > $o ).

tff(pred_def_63651,type,
    v112381: state_type > $o ).

tff(pred_def_63652,type,
    v112357: state_type > $o ).

tff(pred_def_63653,type,
    v112385: state_type > $o ).

tff(pred_def_63654,type,
    v112384: state_type > $o ).

tff(pred_def_63655,type,
    v112386: state_type > $o ).

tff(pred_def_63656,type,
    v112383: state_type > $o ).

tff(pred_def_63657,type,
    v112382: state_type > $o ).

tff(pred_def_63658,type,
    v112356: state_type > $o ).

tff(pred_def_63659,type,
    v112387: state_type > $o ).

tff(pred_def_63660,type,
    v112355: state_type > $o ).

tff(pred_def_63661,type,
    v112391: state_type > $o ).

tff(pred_def_63662,type,
    v112390: state_type > $o ).

tff(pred_def_63663,type,
    v112392: state_type > $o ).

tff(pred_def_63664,type,
    v112389: state_type > $o ).

tff(pred_def_63665,type,
    v112388: state_type > $o ).

tff(pred_def_63666,type,
    v112354: state_type > $o ).

tff(pred_def_63667,type,
    v112393: state_type > $o ).

tff(pred_def_63668,type,
    v112353: state_type > $o ).

tff(pred_def_63669,type,
    v112397: state_type > $o ).

tff(pred_def_63670,type,
    v112396: state_type > $o ).

tff(pred_def_63671,type,
    v112398: state_type > $o ).

tff(pred_def_63672,type,
    v112395: state_type > $o ).

tff(pred_def_63673,type,
    v112394: state_type > $o ).

tff(pred_def_63674,type,
    v112352: state_type > $o ).

tff(pred_def_63675,type,
    v112399: state_type > $o ).

tff(pred_def_63676,type,
    v112351: state_type > $o ).

tff(pred_def_63677,type,
    v112403: state_type > $o ).

tff(pred_def_63678,type,
    v112402: state_type > $o ).

tff(pred_def_63679,type,
    v112404: state_type > $o ).

tff(pred_def_63680,type,
    v112401: state_type > $o ).

tff(pred_def_63681,type,
    v112400: state_type > $o ).

tff(pred_def_63682,type,
    v112350: state_type > $o ).

tff(pred_def_63683,type,
    v112405: state_type > $o ).

tff(pred_def_63684,type,
    v112349: state_type > $o ).

tff(pred_def_63685,type,
    v112409: state_type > $o ).

tff(pred_def_63686,type,
    v112408: state_type > $o ).

tff(pred_def_63687,type,
    v112410: state_type > $o ).

tff(pred_def_63688,type,
    v112407: state_type > $o ).

tff(pred_def_63689,type,
    v112406: state_type > $o ).

tff(pred_def_63690,type,
    v112348: state_type > $o ).

tff(pred_def_63691,type,
    v112411: state_type > $o ).

tff(pred_def_63692,type,
    v112347: state_type > $o ).

tff(pred_def_63693,type,
    v112415: state_type > $o ).

tff(pred_def_63694,type,
    v112414: state_type > $o ).

tff(pred_def_63695,type,
    v112416: state_type > $o ).

tff(pred_def_63696,type,
    v112413: state_type > $o ).

tff(pred_def_63697,type,
    v112412: state_type > $o ).

tff(pred_def_63698,type,
    v112346: state_type > $o ).

tff(pred_def_63699,type,
    v112417: state_type > $o ).

tff(pred_def_63700,type,
    v112345: state_type > $o ).

tff(pred_def_63701,type,
    v112421: state_type > $o ).

tff(pred_def_63702,type,
    v112420: state_type > $o ).

tff(pred_def_63703,type,
    v112422: state_type > $o ).

tff(pred_def_63704,type,
    v112419: state_type > $o ).

tff(pred_def_63705,type,
    v112418: state_type > $o ).

tff(pred_def_63706,type,
    v112344: state_type > $o ).

tff(pred_def_63707,type,
    v112423: state_type > $o ).

tff(pred_def_63708,type,
    v112343: state_type > $o ).

tff(pred_def_63709,type,
    v112427: state_type > $o ).

tff(pred_def_63710,type,
    v112426: state_type > $o ).

tff(pred_def_63711,type,
    v112428: state_type > $o ).

tff(pred_def_63712,type,
    v112425: state_type > $o ).

tff(pred_def_63713,type,
    v112424: state_type > $o ).

tff(pred_def_63714,type,
    v112342: state_type > $o ).

tff(pred_def_63715,type,
    v112429: state_type > $o ).

tff(pred_def_63716,type,
    v112341: state_type > $o ).

tff(pred_def_63717,type,
    v112433: state_type > $o ).

tff(pred_def_63718,type,
    v112432: state_type > $o ).

tff(pred_def_63719,type,
    v112434: state_type > $o ).

tff(pred_def_63720,type,
    v112431: state_type > $o ).

tff(pred_def_63721,type,
    v112430: state_type > $o ).

tff(pred_def_63722,type,
    v112340: state_type > $o ).

tff(pred_def_63723,type,
    v112435: state_type > $o ).

tff(pred_def_63724,type,
    v112339: state_type > $o ).

tff(pred_def_63725,type,
    v112439: state_type > $o ).

tff(pred_def_63726,type,
    v112438: state_type > $o ).

tff(pred_def_63727,type,
    v112440: state_type > $o ).

tff(pred_def_63728,type,
    v112437: state_type > $o ).

tff(pred_def_63729,type,
    v112436: state_type > $o ).

tff(pred_def_63730,type,
    v112338: state_type > $o ).

tff(pred_def_63731,type,
    v112441: state_type > $o ).

tff(pred_def_63732,type,
    v112337: state_type > $o ).

tff(pred_def_63733,type,
    v112445: state_type > $o ).

tff(pred_def_63734,type,
    v112444: state_type > $o ).

tff(pred_def_63735,type,
    v112446: state_type > $o ).

tff(pred_def_63736,type,
    v112443: state_type > $o ).

tff(pred_def_63737,type,
    v112442: state_type > $o ).

tff(pred_def_63738,type,
    v112336: state_type > $o ).

tff(pred_def_63739,type,
    v112447: state_type > $o ).

tff(pred_def_63740,type,
    v112335: state_type > $o ).

tff(pred_def_63741,type,
    v112451: state_type > $o ).

tff(pred_def_63742,type,
    v112450: state_type > $o ).

tff(pred_def_63743,type,
    v112452: state_type > $o ).

tff(pred_def_63744,type,
    v112449: state_type > $o ).

tff(pred_def_63745,type,
    v112448: state_type > $o ).

tff(pred_def_63746,type,
    v112334: state_type > $o ).

tff(pred_def_63747,type,
    v112453: state_type > $o ).

tff(pred_def_63748,type,
    v112333: state_type > $o ).

tff(pred_def_63749,type,
    v112457: state_type > $o ).

tff(pred_def_63750,type,
    v112456: state_type > $o ).

tff(pred_def_63751,type,
    v112458: state_type > $o ).

tff(pred_def_63752,type,
    v112455: state_type > $o ).

tff(pred_def_63753,type,
    v112454: state_type > $o ).

tff(pred_def_63754,type,
    v112332: state_type > $o ).

tff(pred_def_63755,type,
    v112459: state_type > $o ).

tff(pred_def_63756,type,
    v112331: state_type > $o ).

tff(pred_def_63757,type,
    v111713: state_type > $o ).

tff(pred_def_63758,type,
    v111711: state_type > $o ).

tff(pred_def_63759,type,
    v111709: state_type > $o ).

tff(pred_def_63760,type,
    v111707: state_type > $o ).

tff(pred_def_63761,type,
    v112463: state_type > $o ).

tff(pred_def_63762,type,
    v112461: state_type > $o ).

tff(pred_def_63763,type,
    v112470: state_type > $o ).

tff(pred_def_63764,type,
    v112468: state_type > $o ).

tff(pred_def_63765,type,
    v112467: state_type > $o ).

tff(pred_def_63766,type,
    v112466: state_type > $o ).

tff(pred_def_63767,type,
    v112478: state_type > $o ).

tff(pred_def_63768,type,
    v112479: state_type > $o ).

tff(pred_def_63769,type,
    v112477: state_type > $o ).

tff(pred_def_63770,type,
    v112474: state_type > $o ).

tff(pred_def_63771,type,
    v112476: state_type > $o ).

tff(pred_def_63772,type,
    v111697: state_type > $o ).

tff(pred_def_63773,type,
    v111695: state_type > $o ).

tff(pred_def_63774,type,
    v111693: state_type > $o ).

tff(pred_def_63775,type,
    v2898: state_type > $o ).

tff(pred_def_63776,type,
    v112484: ( state_type * $int ) > $o ).

tff(pred_def_63777,type,
    v2896: ( state_type * $int ) > $o ).

tff(pred_def_63778,type,
    v112486: state_type > $o ).

tff(pred_def_63779,type,
    v112490: state_type > $o ).

tff(pred_def_63780,type,
    v112489: ( state_type * $int ) > $o ).

tff(pred_def_63781,type,
    v112488: ( state_type * $int ) > $o ).

tff(pred_def_63782,type,
    v112494: state_type > $o ).

tff(pred_def_63783,type,
    v112493: ( state_type * $int ) > $o ).

tff(pred_def_63784,type,
    v112492: ( state_type * $int ) > $o ).

tff(pred_def_63785,type,
    v2880: ( state_type * $int ) > $o ).

tff(pred_def_63786,type,
    v112491: ( state_type * $int ) > $o ).

tff(pred_def_63787,type,
    v112487: ( state_type * $int ) > $o ).

tff(pred_def_63788,type,
    v2894: ( state_type * $int ) > $o ).

tff(pred_def_63789,type,
    v2892: ( state_type * $int ) > $o ).

tff(pred_def_63790,type,
    v112498: state_type > $o ).

tff(pred_def_63791,type,
    v112496: state_type > $o ).

tff(pred_def_63792,type,
    v112505: state_type > $o ).

tff(pred_def_63793,type,
    v112503: state_type > $o ).

tff(pred_def_63794,type,
    v112502: state_type > $o ).

tff(pred_def_63795,type,
    v112501: state_type > $o ).

tff(pred_def_63796,type,
    v112513: state_type > $o ).

tff(pred_def_63797,type,
    v112514: state_type > $o ).

tff(pred_def_63798,type,
    v112512: state_type > $o ).

tff(pred_def_63799,type,
    v112509: ( state_type * $int ) > $o ).

tff(pred_def_63800,type,
    v112511: ( state_type * $int ) > $o ).

tff(pred_def_63801,type,
    v112500: ( state_type * $int ) > $o ).

tff(pred_def_63802,type,
    v2882: ( state_type * $int ) > $o ).

tff(pred_def_63803,type,
    v112483: state_type > $o ).

tff(pred_def_63804,type,
    v112540: state_type > $o ).

tff(pred_def_63805,type,
    v112538: state_type > $o ).

tff(pred_def_63806,type,
    v112544: state_type > $o ).

tff(pred_def_63807,type,
    v112542: state_type > $o ).

tff(pred_def_63808,type,
    v112552: state_type > $o ).

tff(pred_def_63809,type,
    v112550: state_type > $o ).

tff(pred_def_63810,type,
    b0001000111000: $int > $o ).

tff(pred_def_63811,type,
    v112559: state_type > $o ).

tff(pred_def_63812,type,
    v112556: state_type > $o ).

tff(pred_def_63813,type,
    v112554: state_type > $o ).

tff(pred_def_63814,type,
    v112563: state_type > $o ).

tff(pred_def_63815,type,
    v112562: state_type > $o ).

tff(pred_def_63816,type,
    v112561: state_type > $o ).

tff(pred_def_63817,type,
    v112567: state_type > $o ).

tff(pred_def_63818,type,
    v112566: state_type > $o ).

tff(pred_def_63819,type,
    v112565: state_type > $o ).

tff(pred_def_63820,type,
    v112534: state_type > $o ).

tff(pred_def_63821,type,
    v112564: state_type > $o ).

tff(pred_def_63822,type,
    v112548: state_type > $o ).

tff(pred_def_63823,type,
    v112546: state_type > $o ).

tff(pred_def_63824,type,
    v112571: state_type > $o ).

tff(pred_def_63825,type,
    v112569: state_type > $o ).

tff(pred_def_63826,type,
    v112578: state_type > $o ).

tff(pred_def_63827,type,
    v112576: state_type > $o ).

tff(pred_def_63828,type,
    v112575: state_type > $o ).

tff(pred_def_63829,type,
    v112574: state_type > $o ).

tff(pred_def_63830,type,
    v112586: state_type > $o ).

tff(pred_def_63831,type,
    v112587: state_type > $o ).

tff(pred_def_63832,type,
    v112585: state_type > $o ).

tff(pred_def_63833,type,
    v112582: state_type > $o ).

tff(pred_def_63834,type,
    v112584: state_type > $o ).

tff(pred_def_63835,type,
    v112536: state_type > $o ).

tff(pred_def_63836,type,
    v112532: state_type > $o ).

tff(pred_def_63837,type,
    v112592: state_type > $o ).

tff(pred_def_63838,type,
    v112591: ( state_type * $int ) > $o ).

tff(pred_def_63839,type,
    v112608: state_type > $o ).

tff(pred_def_63840,type,
    v112607: ( state_type * $int ) > $o ).

tff(pred_def_63841,type,
    v112606: ( state_type * $int ) > $o ).

tff(pred_def_63842,type,
    v112612: state_type > $o ).

tff(pred_def_63843,type,
    v112611: state_type > $o ).

tff(pred_def_63844,type,
    v112610: ( state_type * $int ) > $o ).

tff(pred_def_63845,type,
    v112609: ( state_type * $int ) > $o ).

tff(pred_def_63846,type,
    v112605: ( state_type * $int ) > $o ).

tff(pred_def_63847,type,
    v112604: ( state_type * $int ) > $o ).

tff(pred_def_63848,type,
    v112616: state_type > $o ).

tff(pred_def_63849,type,
    v112615: state_type > $o ).

tff(pred_def_63850,type,
    v112614: ( state_type * $int ) > $o ).

tff(pred_def_63851,type,
    v112613: ( state_type * $int ) > $o ).

tff(pred_def_63852,type,
    v112603: ( state_type * $int ) > $o ).

tff(pred_def_63853,type,
    v112602: ( state_type * $int ) > $o ).

tff(pred_def_63854,type,
    v112620: state_type > $o ).

tff(pred_def_63855,type,
    v112619: state_type > $o ).

tff(pred_def_63856,type,
    v112618: ( state_type * $int ) > $o ).

tff(pred_def_63857,type,
    v112617: ( state_type * $int ) > $o ).

tff(pred_def_63858,type,
    v112601: ( state_type * $int ) > $o ).

tff(pred_def_63859,type,
    v112600: ( state_type * $int ) > $o ).

tff(pred_def_63860,type,
    v112624: state_type > $o ).

tff(pred_def_63861,type,
    v112623: state_type > $o ).

tff(pred_def_63862,type,
    v112622: ( state_type * $int ) > $o ).

tff(pred_def_63863,type,
    v112621: ( state_type * $int ) > $o ).

tff(pred_def_63864,type,
    v112599: ( state_type * $int ) > $o ).

tff(pred_def_63865,type,
    v112598: ( state_type * $int ) > $o ).

tff(pred_def_63866,type,
    v112628: state_type > $o ).

tff(pred_def_63867,type,
    v112627: state_type > $o ).

tff(pred_def_63868,type,
    v112626: ( state_type * $int ) > $o ).

tff(pred_def_63869,type,
    v112625: ( state_type * $int ) > $o ).

tff(pred_def_63870,type,
    v112597: ( state_type * $int ) > $o ).

tff(pred_def_63871,type,
    v112596: ( state_type * $int ) > $o ).

tff(pred_def_63872,type,
    v112632: state_type > $o ).

tff(pred_def_63873,type,
    v112631: state_type > $o ).

tff(pred_def_63874,type,
    v112630: ( state_type * $int ) > $o ).

tff(pred_def_63875,type,
    v112629: ( state_type * $int ) > $o ).

tff(pred_def_63876,type,
    v112595: ( state_type * $int ) > $o ).

tff(pred_def_63877,type,
    v112635: state_type > $o ).

tff(pred_def_63878,type,
    v112634: state_type > $o ).

tff(pred_def_63879,type,
    v112633: ( state_type * $int ) > $o ).

tff(pred_def_63880,type,
    v112594: ( state_type * $int ) > $o ).

tff(pred_def_63881,type,
    v112593: ( state_type * $int ) > $o ).

tff(pred_def_63882,type,
    v112590: ( state_type * $int ) > $o ).

tff(pred_def_63883,type,
    v112530: ( state_type * $int ) > $o ).

tff(pred_def_63884,type,
    v112528: ( state_type * $int ) > $o ).

tff(pred_def_63885,type,
    v112526: state_type > $o ).

tff(pred_def_63886,type,
    v112637: state_type > $o ).

tff(pred_def_63887,type,
    v112639: state_type > $o ).

tff(pred_def_63888,type,
    v112653: state_type > $o ).

tff(pred_def_63889,type,
    v112651: state_type > $o ).

tff(pred_def_63890,type,
    v112657: state_type > $o ).

tff(pred_def_63891,type,
    v112655: state_type > $o ).

tff(pred_def_63892,type,
    v112664: ( state_type * $int ) > $o ).

tff(pred_def_63893,type,
    v112663: ( state_type * $int ) > $o ).

tff(pred_def_63894,type,
    v112661: ( state_type * $int ) > $o ).

tff(pred_def_63895,type,
    v112659: ( state_type * $int ) > $o ).

tff(pred_def_63896,type,
    v112668: state_type > $o ).

tff(pred_def_63897,type,
    v112666: state_type > $o ).

tff(pred_def_63898,type,
    v112675: state_type > $o ).

tff(pred_def_63899,type,
    v112673: state_type > $o ).

tff(pred_def_63900,type,
    v112672: state_type > $o ).

tff(pred_def_63901,type,
    v112671: state_type > $o ).

tff(pred_def_63902,type,
    v112683: state_type > $o ).

tff(pred_def_63903,type,
    v112684: state_type > $o ).

tff(pred_def_63904,type,
    v112682: state_type > $o ).

tff(pred_def_63905,type,
    v112679: ( state_type * $int ) > $o ).

tff(pred_def_63906,type,
    v112681: ( state_type * $int ) > $o ).

tff(pred_def_63907,type,
    v112670: ( state_type * $int ) > $o ).

tff(pred_def_63908,type,
    v112649: ( state_type * $int ) > $o ).

tff(pred_def_63909,type,
    v112647: ( state_type * $int ) > $o ).

tff(pred_def_63910,type,
    v112645: state_type > $o ).

tff(pred_def_63911,type,
    v112694: state_type > $o ).

tff(pred_def_63912,type,
    v112692: state_type > $o ).

tff(pred_def_63913,type,
    v112691: state_type > $o ).

tff(pred_def_63914,type,
    v112690: ( state_type * $int ) > $o ).

tff(pred_def_63915,type,
    v112688: state_type > $o ).

tff(pred_def_63916,type,
    v112706: state_type > $o ).

tff(pred_def_63917,type,
    v112704: state_type > $o ).

tff(pred_def_63918,type,
    v112710: state_type > $o ).

tff(pred_def_63919,type,
    v112708: state_type > $o ).

tff(pred_def_63920,type,
    v2878: state_type > $o ).

tff(pred_def_63921,type,
    v112717: ( state_type * $int ) > $o ).

tff(pred_def_63922,type,
    v112716: ( state_type * $int ) > $o ).

tff(pred_def_63923,type,
    v112719: state_type > $o ).

tff(pred_def_63924,type,
    v112723: state_type > $o ).

tff(pred_def_63925,type,
    v112722: ( state_type * $int ) > $o ).

tff(pred_def_63926,type,
    v112721: ( state_type * $int ) > $o ).

tff(pred_def_63927,type,
    v112727: state_type > $o ).

tff(pred_def_63928,type,
    v112726: ( state_type * $int ) > $o ).

tff(pred_def_63929,type,
    v112725: ( state_type * $int ) > $o ).

tff(pred_def_63930,type,
    v112700: ( state_type * $int ) > $o ).

tff(pred_def_63931,type,
    v112724: ( state_type * $int ) > $o ).

tff(pred_def_63932,type,
    v112720: ( state_type * $int ) > $o ).

tff(pred_def_63933,type,
    v112714: ( state_type * $int ) > $o ).

tff(pred_def_63934,type,
    v112712: ( state_type * $int ) > $o ).

tff(pred_def_63935,type,
    v112731: state_type > $o ).

tff(pred_def_63936,type,
    v112729: state_type > $o ).

tff(pred_def_63937,type,
    v112738: state_type > $o ).

tff(pred_def_63938,type,
    v112736: state_type > $o ).

tff(pred_def_63939,type,
    v112735: state_type > $o ).

tff(pred_def_63940,type,
    v112734: state_type > $o ).

tff(pred_def_63941,type,
    v112746: state_type > $o ).

tff(pred_def_63942,type,
    v112747: state_type > $o ).

tff(pred_def_63943,type,
    v112745: state_type > $o ).

tff(pred_def_63944,type,
    v112742: ( state_type * $int ) > $o ).

tff(pred_def_63945,type,
    v112744: ( state_type * $int ) > $o ).

tff(pred_def_63946,type,
    v112733: ( state_type * $int ) > $o ).

tff(pred_def_63947,type,
    v112702: ( state_type * $int ) > $o ).

tff(pred_def_63948,type,
    v112698: state_type > $o ).

tff(pred_def_63949,type,
    v85748: state_type > $o ).

tff(pred_def_63950,type,
    v112760: state_type > $o ).

tff(pred_def_63951,type,
    v112759: state_type > $o ).

tff(pred_def_63952,type,
    v85714: ( state_type * $int ) > $o ).

tff(pred_def_63953,type,
    v112761: state_type > $o ).

tff(pred_def_63954,type,
    v112758: state_type > $o ).

tff(pred_def_63955,type,
    v112763: state_type > $o ).

tff(pred_def_63956,type,
    v112641: state_type > $o ).

tff(pred_def_63957,type,
    v112766: state_type > $o ).

tff(pred_def_63958,type,
    v112771: state_type > $o ).

tff(pred_def_63959,type,
    v112772: state_type > $o ).

tff(pred_def_63960,type,
    v112770: state_type > $o ).

tff(pred_def_63961,type,
    v112774: state_type > $o ).

tff(pred_def_63962,type,
    v112775: state_type > $o ).

tff(pred_def_63963,type,
    v112773: state_type > $o ).

tff(pred_def_63964,type,
    v112769: state_type > $o ).

tff(pred_def_63965,type,
    v112768: state_type > $o ).

tff(pred_def_63966,type,
    v112767: state_type > $o ).

tff(pred_def_63967,type,
    v112765: state_type > $o ).

tff(pred_def_63968,type,
    v112776: state_type > $o ).

tff(pred_def_63969,type,
    v112764: state_type > $o ).

tff(pred_def_63970,type,
    v112762: state_type > $o ).

tff(pred_def_63971,type,
    v112757: state_type > $o ).

tff(pred_def_63972,type,
    v85746: ( state_type * $int ) > $o ).

tff(pred_def_63973,type,
    v112777: ( state_type * $int ) > $o ).

tff(pred_def_63974,type,
    v85744: state_type > $o ).

tff(pred_def_63975,type,
    v85742: ( state_type * $int ) > $o ).

tff(pred_def_63976,type,
    v85740: ( state_type * $int ) > $o ).

tff(pred_def_63977,type,
    v85738: ( state_type * $int ) > $o ).

tff(pred_def_63978,type,
    v112783: state_type > $o ).

tff(pred_def_63979,type,
    v112781: state_type > $o ).

tff(pred_def_63980,type,
    v112779: state_type > $o ).

tff(pred_def_63981,type,
    v112790: state_type > $o ).

tff(pred_def_63982,type,
    v112788: state_type > $o ).

tff(pred_def_63983,type,
    v112787: state_type > $o ).

tff(pred_def_63984,type,
    v112786: state_type > $o ).

tff(pred_def_63985,type,
    v112798: state_type > $o ).

tff(pred_def_63986,type,
    v112799: state_type > $o ).

tff(pred_def_63987,type,
    v112797: state_type > $o ).

tff(pred_def_63988,type,
    v112794: ( state_type * $int ) > $o ).

tff(pred_def_63989,type,
    v112796: ( state_type * $int ) > $o ).

tff(pred_def_63990,type,
    v112785: ( state_type * $int ) > $o ).

tff(pred_def_63991,type,
    v85720: ( state_type * $int ) > $o ).

tff(pred_def_63992,type,
    v85718: ( state_type * $int ) > $o ).

tff(pred_def_63993,type,
    v112813: state_type > $o ).

tff(pred_def_63994,type,
    v112811: state_type > $o ).

tff(pred_def_63995,type,
    v112817: state_type > $o ).

tff(pred_def_63996,type,
    v112815: state_type > $o ).

tff(pred_def_63997,type,
    v112522: ( state_type * $int ) > $o ).

tff(pred_def_63998,type,
    b1000000000000000: $int > $o ).

tff(pred_def_63999,type,
    v112864: ( state_type * $int ) > $o ).

tff(pred_def_64000,type,
    b0100000000000000: $int > $o ).

tff(pred_def_64001,type,
    v112863: ( state_type * $int ) > $o ).

tff(pred_def_64002,type,
    b0010000000000000: $int > $o ).

tff(pred_def_64003,type,
    v112862: ( state_type * $int ) > $o ).

tff(pred_def_64004,type,
    b0001000000000000: $int > $o ).

tff(pred_def_64005,type,
    v112861: ( state_type * $int ) > $o ).

tff(pred_def_64006,type,
    b0000100000000000: $int > $o ).

tff(pred_def_64007,type,
    v112860: ( state_type * $int ) > $o ).

tff(pred_def_64008,type,
    b0000010000000000: $int > $o ).

tff(pred_def_64009,type,
    v112859: ( state_type * $int ) > $o ).

tff(pred_def_64010,type,
    b0000001000000000: $int > $o ).

tff(pred_def_64011,type,
    v112858: ( state_type * $int ) > $o ).

tff(pred_def_64012,type,
    b0000000100000000: $int > $o ).

tff(pred_def_64013,type,
    v112857: ( state_type * $int ) > $o ).

tff(pred_def_64014,type,
    b0000000010000000: $int > $o ).

tff(pred_def_64015,type,
    v112856: ( state_type * $int ) > $o ).

tff(pred_def_64016,type,
    b0000000001000000: $int > $o ).

tff(pred_def_64017,type,
    v112855: ( state_type * $int ) > $o ).

tff(pred_def_64018,type,
    b0000000000100000: $int > $o ).

tff(pred_def_64019,type,
    v112854: ( state_type * $int ) > $o ).

tff(pred_def_64020,type,
    b0000000000010000: $int > $o ).

tff(pred_def_64021,type,
    v112853: ( state_type * $int ) > $o ).

tff(pred_def_64022,type,
    b0000000000001000: $int > $o ).

tff(pred_def_64023,type,
    v112852: ( state_type * $int ) > $o ).

tff(pred_def_64024,type,
    b0000000000000100: $int > $o ).

tff(pred_def_64025,type,
    v112851: ( state_type * $int ) > $o ).

tff(pred_def_64026,type,
    b0000000000000010: $int > $o ).

tff(pred_def_64027,type,
    v112850: ( state_type * $int ) > $o ).

tff(pred_def_64028,type,
    b0000000000000001: $int > $o ).

tff(pred_def_64029,type,
    v112849: ( state_type * $int ) > $o ).

tff(pred_def_64030,type,
    v112833: ( state_type * $int ) > $o ).

tff(pred_def_64031,type,
    v112873: state_type > $o ).

tff(pred_def_64032,type,
    v112872: state_type > $o ).

tff(pred_def_64033,type,
    v112874: state_type > $o ).

tff(pred_def_64034,type,
    v112871: state_type > $o ).

tff(pred_def_64035,type,
    v112875: state_type > $o ).

tff(pred_def_64036,type,
    v112870: state_type > $o ).

tff(pred_def_64037,type,
    v112520: state_type > $o ).

tff(pred_def_64038,type,
    v112869: state_type > $o ).

tff(pred_def_64039,type,
    v112868: state_type > $o ).

tff(pred_def_64040,type,
    v112867: state_type > $o ).

tff(pred_def_64041,type,
    v112866: ( state_type * $int ) > $o ).

tff(pred_def_64042,type,
    v112865: ( state_type * $int ) > $o ).

tff(pred_def_64043,type,
    v112831: ( state_type * $int ) > $o ).

tff(pred_def_64044,type,
    v112829: state_type > $o ).

tff(pred_def_64045,type,
    v112877: state_type > $o ).

tff(pred_def_64046,type,
    v112878: state_type > $o ).

tff(pred_def_64047,type,
    v112827: state_type > $o ).

tff(pred_def_64048,type,
    v112805: ( state_type * $int ) > $o ).

tff(pred_def_64049,type,
    v112885: state_type > $o ).

tff(pred_def_64050,type,
    v112884: state_type > $o ).

tff(pred_def_64051,type,
    v112887: state_type > $o ).

tff(pred_def_64052,type,
    v112886: state_type > $o ).

tff(pred_def_64053,type,
    v112883: state_type > $o ).

tff(pred_def_64054,type,
    v112881: ( state_type * $int ) > $o ).

tff(pred_def_64055,type,
    v112803: state_type > $o ).

tff(pred_def_64056,type,
    v112880: ( state_type * $int ) > $o ).

tff(pred_def_64057,type,
    v112825: ( state_type * $int ) > $o ).

tff(pred_def_64058,type,
    v112823: ( state_type * $int ) > $o ).

tff(pred_def_64059,type,
    v112821: ( state_type * $int ) > $o ).

tff(pred_def_64060,type,
    v112819: ( state_type * $int ) > $o ).

tff(pred_def_64061,type,
    v112891: state_type > $o ).

tff(pred_def_64062,type,
    v112889: state_type > $o ).

tff(pred_def_64063,type,
    v112898: state_type > $o ).

tff(pred_def_64064,type,
    v112896: state_type > $o ).

tff(pred_def_64065,type,
    v112895: state_type > $o ).

tff(pred_def_64066,type,
    v112894: state_type > $o ).

tff(pred_def_64067,type,
    v112906: state_type > $o ).

tff(pred_def_64068,type,
    v112907: state_type > $o ).

tff(pred_def_64069,type,
    v112905: state_type > $o ).

tff(pred_def_64070,type,
    v112902: ( state_type * $int ) > $o ).

tff(pred_def_64071,type,
    v112904: ( state_type * $int ) > $o ).

tff(pred_def_64072,type,
    v112809: ( state_type * $int ) > $o ).

tff(pred_def_64073,type,
    v112807: ( state_type * $int ) > $o ).

tff(pred_def_64074,type,
    v112922: state_type > $o ).

tff(pred_def_64075,type,
    v112920: state_type > $o ).

tff(pred_def_64076,type,
    v112926: state_type > $o ).

tff(pred_def_64077,type,
    v112924: state_type > $o ).

tff(pred_def_64078,type,
    v112952: state_type > $o ).

tff(pred_def_64079,type,
    v112950: state_type > $o ).

tff(pred_def_64080,type,
    v112956: state_type > $o ).

tff(pred_def_64081,type,
    v112954: state_type > $o ).

tff(pred_def_64082,type,
    v112976: state_type > $o ).

tff(pred_def_64083,type,
    v112975: state_type > $o ).

tff(pred_def_64084,type,
    v112974: state_type > $o ).

tff(pred_def_64085,type,
    v112973: state_type > $o ).

tff(pred_def_64086,type,
    v112972: state_type > $o ).

tff(pred_def_64087,type,
    v112971: state_type > $o ).

tff(pred_def_64088,type,
    v112969: state_type > $o ).

tff(pred_def_64089,type,
    v112977: state_type > $o ).

tff(pred_def_64090,type,
    v112968: state_type > $o ).

tff(pred_def_64091,type,
    v112967: state_type > $o ).

tff(pred_def_64092,type,
    v112966: ( state_type * $int ) > $o ).

tff(pred_def_64093,type,
    v112979: state_type > $o ).

tff(pred_def_64094,type,
    v112980: state_type > $o ).

tff(pred_def_64095,type,
    v112981: state_type > $o ).

tff(pred_def_64096,type,
    v112982: state_type > $o ).

tff(pred_def_64097,type,
    v112983: state_type > $o ).

tff(pred_def_64098,type,
    v112984: state_type > $o ).

tff(pred_def_64099,type,
    v112985: state_type > $o ).

tff(pred_def_64100,type,
    v112986: state_type > $o ).

tff(pred_def_64101,type,
    v112987: state_type > $o ).

tff(pred_def_64102,type,
    v112988: state_type > $o ).

tff(pred_def_64103,type,
    v112989: state_type > $o ).

tff(pred_def_64104,type,
    v112990: state_type > $o ).

tff(pred_def_64105,type,
    v112991: state_type > $o ).

tff(pred_def_64106,type,
    v112992: state_type > $o ).

tff(pred_def_64107,type,
    v112993: state_type > $o ).

tff(pred_def_64108,type,
    v112994: state_type > $o ).

tff(pred_def_64109,type,
    v112978: ( state_type * $int ) > $o ).

tff(pred_def_64110,type,
    v112965: ( state_type * $int ) > $o ).

tff(pred_def_64111,type,
    v112964: ( state_type * $int ) > $o ).

tff(pred_def_64112,type,
    v112962: ( state_type * $int ) > $o ).

tff(pred_def_64113,type,
    v112960: ( state_type * $int ) > $o ).

tff(pred_def_64114,type,
    v112958: ( state_type * $int ) > $o ).

tff(pred_def_64115,type,
    v112998: state_type > $o ).

tff(pred_def_64116,type,
    v112996: state_type > $o ).

tff(pred_def_64117,type,
    v113005: state_type > $o ).

tff(pred_def_64118,type,
    v113003: state_type > $o ).

tff(pred_def_64119,type,
    v113002: state_type > $o ).

tff(pred_def_64120,type,
    v113001: state_type > $o ).

tff(pred_def_64121,type,
    v113013: state_type > $o ).

tff(pred_def_64122,type,
    v113014: state_type > $o ).

tff(pred_def_64123,type,
    v113012: state_type > $o ).

tff(pred_def_64124,type,
    v113009: ( state_type * $int ) > $o ).

tff(pred_def_64125,type,
    v113011: ( state_type * $int ) > $o ).

tff(pred_def_64126,type,
    v113000: ( state_type * $int ) > $o ).

tff(pred_def_64127,type,
    v112948: ( state_type * $int ) > $o ).

tff(pred_def_64128,type,
    v112946: ( state_type * $int ) > $o ).

tff(pred_def_64129,type,
    v112944: ( state_type * $int ) > $o ).

tff(pred_def_64130,type,
    v112942: ( state_type * $int ) > $o ).

tff(pred_def_64131,type,
    v112940: ( state_type * $int ) > $o ).

tff(pred_def_64132,type,
    v112938: state_type > $o ).

tff(pred_def_64133,type,
    v113032: state_type > $o ).

tff(pred_def_64134,type,
    v113030: state_type > $o ).

tff(pred_def_64135,type,
    v113036: state_type > $o ).

tff(pred_def_64136,type,
    v113034: state_type > $o ).

tff(pred_def_64137,type,
    v113056: state_type > $o ).

tff(pred_def_64138,type,
    v113055: state_type > $o ).

tff(pred_def_64139,type,
    v113054: state_type > $o ).

tff(pred_def_64140,type,
    v113053: state_type > $o ).

tff(pred_def_64141,type,
    v113052: state_type > $o ).

tff(pred_def_64142,type,
    v113051: state_type > $o ).

tff(pred_def_64143,type,
    v113049: state_type > $o ).

tff(pred_def_64144,type,
    v89405: state_type > $o ).

tff(pred_def_64145,type,
    v113057: state_type > $o ).

tff(pred_def_64146,type,
    v113048: state_type > $o ).

tff(pred_def_64147,type,
    v113047: state_type > $o ).

tff(pred_def_64148,type,
    v113046: ( state_type * $int ) > $o ).

tff(pred_def_64149,type,
    v113059: state_type > $o ).

tff(pred_def_64150,type,
    v113060: state_type > $o ).

tff(pred_def_64151,type,
    v113061: state_type > $o ).

tff(pred_def_64152,type,
    v113062: state_type > $o ).

tff(pred_def_64153,type,
    v113063: state_type > $o ).

tff(pred_def_64154,type,
    v113064: state_type > $o ).

tff(pred_def_64155,type,
    v113065: state_type > $o ).

tff(pred_def_64156,type,
    v113066: state_type > $o ).

tff(pred_def_64157,type,
    v113067: state_type > $o ).

tff(pred_def_64158,type,
    v113068: state_type > $o ).

tff(pred_def_64159,type,
    v113069: state_type > $o ).

tff(pred_def_64160,type,
    v113070: state_type > $o ).

tff(pred_def_64161,type,
    v113071: state_type > $o ).

tff(pred_def_64162,type,
    v113072: state_type > $o ).

tff(pred_def_64163,type,
    v113073: state_type > $o ).

tff(pred_def_64164,type,
    v113074: state_type > $o ).

tff(pred_def_64165,type,
    v113058: ( state_type * $int ) > $o ).

tff(pred_def_64166,type,
    v113045: ( state_type * $int ) > $o ).

tff(pred_def_64167,type,
    v113044: ( state_type * $int ) > $o ).

tff(pred_def_64168,type,
    v113042: ( state_type * $int ) > $o ).

tff(pred_def_64169,type,
    v113040: ( state_type * $int ) > $o ).

tff(pred_def_64170,type,
    v113038: ( state_type * $int ) > $o ).

tff(pred_def_64171,type,
    v113078: state_type > $o ).

tff(pred_def_64172,type,
    v113076: state_type > $o ).

tff(pred_def_64173,type,
    v113085: state_type > $o ).

tff(pred_def_64174,type,
    v113083: state_type > $o ).

tff(pred_def_64175,type,
    v113082: state_type > $o ).

tff(pred_def_64176,type,
    v113081: state_type > $o ).

tff(pred_def_64177,type,
    v113093: state_type > $o ).

tff(pred_def_64178,type,
    v113094: state_type > $o ).

tff(pred_def_64179,type,
    v113092: state_type > $o ).

tff(pred_def_64180,type,
    v113089: ( state_type * $int ) > $o ).

tff(pred_def_64181,type,
    v113091: ( state_type * $int ) > $o ).

tff(pred_def_64182,type,
    v113080: ( state_type * $int ) > $o ).

tff(pred_def_64183,type,
    v113028: ( state_type * $int ) > $o ).

tff(pred_def_64184,type,
    v113026: ( state_type * $int ) > $o ).

tff(pred_def_64185,type,
    v113024: ( state_type * $int ) > $o ).

tff(pred_def_64186,type,
    v113022: ( state_type * $int ) > $o ).

tff(pred_def_64187,type,
    v113020: ( state_type * $int ) > $o ).

tff(pred_def_64188,type,
    v113018: state_type > $o ).

tff(pred_def_64189,type,
    v113103: state_type > $o ).

tff(pred_def_64190,type,
    v113102: ( state_type * $int ) > $o ).

tff(pred_def_64191,type,
    v113101: ( state_type * $int ) > $o ).

tff(pred_def_64192,type,
    v113100: ( state_type * $int ) > $o ).

tff(pred_def_64193,type,
    v113098: state_type > $o ).

tff(pred_def_64194,type,
    v113112: ( state_type * $int ) > $o ).

tff(pred_def_64195,type,
    v113111: state_type > $o ).

tff(pred_def_64196,type,
    v113114: ( state_type * $int ) > $o ).

tff(pred_def_64197,type,
    v113113: state_type > $o ).

tff(pred_def_64198,type,
    v113116: ( state_type * $int ) > $o ).

tff(pred_def_64199,type,
    v113115: state_type > $o ).

tff(pred_def_64200,type,
    v113118: ( state_type * $int ) > $o ).

tff(pred_def_64201,type,
    v113117: state_type > $o ).

tff(pred_def_64202,type,
    v113120: ( state_type * $int ) > $o ).

tff(pred_def_64203,type,
    v113119: state_type > $o ).

tff(pred_def_64204,type,
    v113122: ( state_type * $int ) > $o ).

tff(pred_def_64205,type,
    v113121: state_type > $o ).

tff(pred_def_64206,type,
    v113124: ( state_type * $int ) > $o ).

tff(pred_def_64207,type,
    v113123: state_type > $o ).

tff(pred_def_64208,type,
    v113126: ( state_type * $int ) > $o ).

tff(pred_def_64209,type,
    v113125: state_type > $o ).

tff(pred_def_64210,type,
    v113128: ( state_type * $int ) > $o ).

tff(pred_def_64211,type,
    v113127: state_type > $o ).

tff(pred_def_64212,type,
    v113130: ( state_type * $int ) > $o ).

tff(pred_def_64213,type,
    v113129: state_type > $o ).

tff(pred_def_64214,type,
    v113132: ( state_type * $int ) > $o ).

tff(pred_def_64215,type,
    v113131: state_type > $o ).

tff(pred_def_64216,type,
    v113134: ( state_type * $int ) > $o ).

tff(pred_def_64217,type,
    v113133: state_type > $o ).

tff(pred_def_64218,type,
    v113136: ( state_type * $int ) > $o ).

tff(pred_def_64219,type,
    v113135: state_type > $o ).

tff(pred_def_64220,type,
    v113138: ( state_type * $int ) > $o ).

tff(pred_def_64221,type,
    v113137: state_type > $o ).

tff(pred_def_64222,type,
    v113140: ( state_type * $int ) > $o ).

tff(pred_def_64223,type,
    v113139: state_type > $o ).

tff(pred_def_64224,type,
    v113142: ( state_type * $int ) > $o ).

tff(pred_def_64225,type,
    v113141: state_type > $o ).

tff(pred_def_64226,type,
    v113110: ( state_type * $int ) > $o ).

tff(pred_def_64227,type,
    v113109: ( state_type * $int ) > $o ).

tff(pred_def_64228,type,
    v113145: state_type > $o ).

tff(pred_def_64229,type,
    v113144: ( state_type * $int ) > $o ).

tff(pred_def_64230,type,
    v113143: ( state_type * $int ) > $o ).

tff(pred_def_64231,type,
    v113107: ( state_type * $int ) > $o ).

tff(pred_def_64232,type,
    v113105: state_type > $o ).

tff(pred_def_64233,type,
    v113148: state_type > $o ).

tff(pred_def_64234,type,
    v113147: state_type > $o ).

tff(pred_def_64235,type,
    v112936: state_type > $o ).

tff(pred_def_64236,type,
    v113160: state_type > $o ).

tff(pred_def_64237,type,
    v113158: state_type > $o ).

tff(pred_def_64238,type,
    v113164: state_type > $o ).

tff(pred_def_64239,type,
    v113162: state_type > $o ).

tff(pred_def_64240,type,
    v113190: state_type > $o ).

tff(pred_def_64241,type,
    v113188: state_type > $o ).

tff(pred_def_64242,type,
    v113194: state_type > $o ).

tff(pred_def_64243,type,
    v113192: state_type > $o ).

tff(pred_def_64244,type,
    v113204: ( state_type * $int ) > $o ).

tff(pred_def_64245,type,
    v113205: ( state_type * $int ) > $o ).

tff(pred_def_64246,type,
    v113202: ( state_type * $int ) > $o ).

tff(pred_def_64247,type,
    v113206: ( state_type * $int ) > $o ).

tff(pred_def_64248,type,
    v113200: ( state_type * $int ) > $o ).

tff(pred_def_64249,type,
    b0000100011000: $int > $o ).

tff(pred_def_64250,type,
    v113213: state_type > $o ).

tff(pred_def_64251,type,
    v113210: state_type > $o ).

tff(pred_def_64252,type,
    v113208: state_type > $o ).

tff(pred_def_64253,type,
    v113217: state_type > $o ).

tff(pred_def_64254,type,
    v113216: ( state_type * $int ) > $o ).

tff(pred_def_64255,type,
    v113215: ( state_type * $int ) > $o ).

tff(pred_def_64256,type,
    v113221: state_type > $o ).

tff(pred_def_64257,type,
    v113220: ( state_type * $int ) > $o ).

tff(pred_def_64258,type,
    v113219: ( state_type * $int ) > $o ).

tff(pred_def_64259,type,
    v113184: ( state_type * $int ) > $o ).

tff(pred_def_64260,type,
    v113218: ( state_type * $int ) > $o ).

tff(pred_def_64261,type,
    v113214: ( state_type * $int ) > $o ).

tff(pred_def_64262,type,
    v113198: ( state_type * $int ) > $o ).

tff(pred_def_64263,type,
    v113196: ( state_type * $int ) > $o ).

tff(pred_def_64264,type,
    v113225: state_type > $o ).

tff(pred_def_64265,type,
    v113223: state_type > $o ).

tff(pred_def_64266,type,
    v113232: state_type > $o ).

tff(pred_def_64267,type,
    v113230: state_type > $o ).

tff(pred_def_64268,type,
    v113229: state_type > $o ).

tff(pred_def_64269,type,
    v113228: state_type > $o ).

tff(pred_def_64270,type,
    v113240: state_type > $o ).

tff(pred_def_64271,type,
    v113241: state_type > $o ).

tff(pred_def_64272,type,
    v113239: state_type > $o ).

tff(pred_def_64273,type,
    v113236: ( state_type * $int ) > $o ).

tff(pred_def_64274,type,
    v113238: ( state_type * $int ) > $o ).

tff(pred_def_64275,type,
    v113227: ( state_type * $int ) > $o ).

tff(pred_def_64276,type,
    v113186: ( state_type * $int ) > $o ).

tff(pred_def_64277,type,
    v113182: ( state_type * $int ) > $o ).

tff(pred_def_64278,type,
    v113244: ( state_type * $int ) > $o ).

tff(pred_def_64279,type,
    v113180: ( state_type * $int ) > $o ).

tff(pred_def_64280,type,
    v113250: state_type > $o ).

tff(pred_def_64281,type,
    v113248: state_type > $o ).

tff(pred_def_64282,type,
    v113247: state_type > $o ).

tff(pred_def_64283,type,
    v113246: ( state_type * $int ) > $o ).

tff(pred_def_64284,type,
    v113258: state_type > $o ).

tff(pred_def_64285,type,
    v113256: state_type > $o ).

tff(pred_def_64286,type,
    v113255: state_type > $o ).

tff(pred_def_64287,type,
    v113254: ( state_type * $int ) > $o ).

tff(pred_def_64288,type,
    v113273: ( state_type * $int ) > $o ).

tff(pred_def_64289,type,
    v113275: ( state_type * $int ) > $o ).

tff(pred_def_64290,type,
    v113274: ( state_type * $int ) > $o ).

tff(pred_def_64291,type,
    v113272: state_type > $o ).

tff(pred_def_64292,type,
    v113278: state_type > $o ).

tff(pred_def_64293,type,
    v113279: state_type > $o ).

tff(pred_def_64294,type,
    v113277: state_type > $o ).

tff(pred_def_64295,type,
    v113280: state_type > $o ).

tff(pred_def_64296,type,
    v113276: state_type > $o ).

tff(pred_def_64297,type,
    v113271: state_type > $o ).

tff(pred_def_64298,type,
    v113281: state_type > $o ).

tff(pred_def_64299,type,
    v113270: state_type > $o ).

tff(pred_def_64300,type,
    v113284: state_type > $o ).

tff(pred_def_64301,type,
    v113285: state_type > $o ).

tff(pred_def_64302,type,
    v113283: state_type > $o ).

tff(pred_def_64303,type,
    v113286: state_type > $o ).

tff(pred_def_64304,type,
    v113282: state_type > $o ).

tff(pred_def_64305,type,
    v113269: state_type > $o ).

tff(pred_def_64306,type,
    v113287: state_type > $o ).

tff(pred_def_64307,type,
    v113268: state_type > $o ).

tff(pred_def_64308,type,
    v113290: state_type > $o ).

tff(pred_def_64309,type,
    v113291: state_type > $o ).

tff(pred_def_64310,type,
    v113289: state_type > $o ).

tff(pred_def_64311,type,
    v113292: state_type > $o ).

tff(pred_def_64312,type,
    v113288: state_type > $o ).

tff(pred_def_64313,type,
    v113267: state_type > $o ).

tff(pred_def_64314,type,
    v113293: state_type > $o ).

tff(pred_def_64315,type,
    v113266: state_type > $o ).

tff(pred_def_64316,type,
    v113265: state_type > $o ).

tff(pred_def_64317,type,
    v113297: state_type > $o ).

tff(pred_def_64318,type,
    v113298: state_type > $o ).

tff(pred_def_64319,type,
    v113296: state_type > $o ).

tff(pred_def_64320,type,
    v113299: state_type > $o ).

tff(pred_def_64321,type,
    v113295: state_type > $o ).

tff(pred_def_64322,type,
    v113294: state_type > $o ).

tff(pred_def_64323,type,
    v113264: state_type > $o ).

tff(pred_def_64324,type,
    v113300: state_type > $o ).

tff(pred_def_64325,type,
    v113263: state_type > $o ).

tff(pred_def_64326,type,
    v113303: state_type > $o ).

tff(pred_def_64327,type,
    v113304: state_type > $o ).

tff(pred_def_64328,type,
    v113302: state_type > $o ).

tff(pred_def_64329,type,
    v113305: state_type > $o ).

tff(pred_def_64330,type,
    v113301: state_type > $o ).

tff(pred_def_64331,type,
    v113308: state_type > $o ).

tff(pred_def_64332,type,
    v113309: state_type > $o ).

tff(pred_def_64333,type,
    v113307: state_type > $o ).

tff(pred_def_64334,type,
    v113310: state_type > $o ).

tff(pred_def_64335,type,
    v113306: state_type > $o ).

tff(pred_def_64336,type,
    v113313: state_type > $o ).

tff(pred_def_64337,type,
    v113314: state_type > $o ).

tff(pred_def_64338,type,
    v113312: state_type > $o ).

tff(pred_def_64339,type,
    v113315: state_type > $o ).

tff(pred_def_64340,type,
    v113311: state_type > $o ).

tff(pred_def_64341,type,
    v113318: state_type > $o ).

tff(pred_def_64342,type,
    v113319: state_type > $o ).

tff(pred_def_64343,type,
    v113317: state_type > $o ).

tff(pred_def_64344,type,
    v113320: state_type > $o ).

tff(pred_def_64345,type,
    v113316: state_type > $o ).

tff(pred_def_64346,type,
    v113178: ( state_type * $int ) > $o ).

tff(pred_def_64347,type,
    v113330: state_type > $o ).

tff(pred_def_64348,type,
    v113328: state_type > $o ).

tff(pred_def_64349,type,
    v113334: state_type > $o ).

tff(pred_def_64350,type,
    v113332: state_type > $o ).

tff(pred_def_64351,type,
    b0000010101000: $int > $o ).

tff(pred_def_64352,type,
    v113347: state_type > $o ).

tff(pred_def_64353,type,
    v113346: state_type > $o ).

tff(pred_def_64354,type,
    v113351: state_type > $o ).

tff(pred_def_64355,type,
    v113352: state_type > $o ).

tff(pred_def_64356,type,
    v113350: state_type > $o ).

tff(pred_def_64357,type,
    v113348: state_type > $o ).

tff(pred_def_64358,type,
    v113345: state_type > $o ).

tff(pred_def_64359,type,
    v113355: state_type > $o ).

tff(pred_def_64360,type,
    v113354: state_type > $o ).

tff(pred_def_64361,type,
    v113353: ( state_type * $int ) > $o ).

tff(pred_def_64362,type,
    v113322: ( state_type * $int ) > $o ).

tff(pred_def_64363,type,
    v113344: ( state_type * $int ) > $o ).

tff(pred_def_64364,type,
    v113342: ( state_type * $int ) > $o ).

tff(pred_def_64365,type,
    v113356: ( state_type * $int ) > $o ).

tff(pred_def_64366,type,
    v113357: state_type > $o ).

tff(pred_def_64367,type,
    v113340: ( state_type * $int ) > $o ).

tff(pred_def_64368,type,
    v113363: state_type > $o ).

tff(pred_def_64369,type,
    v113361: state_type > $o ).

tff(pred_def_64370,type,
    v113359: state_type > $o ).

tff(pred_def_64371,type,
    v113367: state_type > $o ).

tff(pred_def_64372,type,
    v113366: ( state_type * $int ) > $o ).

tff(pred_def_64373,type,
    v113365: ( state_type * $int ) > $o ).

tff(pred_def_64374,type,
    v113371: state_type > $o ).

tff(pred_def_64375,type,
    v113370: ( state_type * $int ) > $o ).

tff(pred_def_64376,type,
    v113369: ( state_type * $int ) > $o ).

tff(pred_def_64377,type,
    v113324: ( state_type * $int ) > $o ).

tff(pred_def_64378,type,
    v113368: ( state_type * $int ) > $o ).

tff(pred_def_64379,type,
    v113364: ( state_type * $int ) > $o ).

tff(pred_def_64380,type,
    v113338: ( state_type * $int ) > $o ).

tff(pred_def_64381,type,
    v113336: ( state_type * $int ) > $o ).

tff(pred_def_64382,type,
    v113375: state_type > $o ).

tff(pred_def_64383,type,
    v113373: state_type > $o ).

tff(pred_def_64384,type,
    v113382: state_type > $o ).

tff(pred_def_64385,type,
    v113380: state_type > $o ).

tff(pred_def_64386,type,
    v113379: state_type > $o ).

tff(pred_def_64387,type,
    v113378: state_type > $o ).

tff(pred_def_64388,type,
    v113390: state_type > $o ).

tff(pred_def_64389,type,
    v113391: state_type > $o ).

tff(pred_def_64390,type,
    v113389: state_type > $o ).

tff(pred_def_64391,type,
    v113386: ( state_type * $int ) > $o ).

tff(pred_def_64392,type,
    v113388: ( state_type * $int ) > $o ).

tff(pred_def_64393,type,
    v113377: ( state_type * $int ) > $o ).

tff(pred_def_64394,type,
    v113326: ( state_type * $int ) > $o ).

tff(pred_def_64395,type,
    v113399: state_type > $o ).

tff(pred_def_64396,type,
    v113397: state_type > $o ).

tff(pred_def_64397,type,
    v113396: state_type > $o ).

tff(pred_def_64398,type,
    v113395: ( state_type * $int ) > $o ).

tff(pred_def_64399,type,
    v113411: state_type > $o ).

tff(pred_def_64400,type,
    v113409: state_type > $o ).

tff(pred_def_64401,type,
    v113408: state_type > $o ).

tff(pred_def_64402,type,
    v113407: ( state_type * $int ) > $o ).

tff(pred_def_64403,type,
    v113403: state_type > $o ).

tff(pred_def_64404,type,
    v113426: ( state_type * $int ) > $o ).

tff(pred_def_64405,type,
    v113425: state_type > $o ).

tff(pred_def_64406,type,
    v113424: state_type > $o ).

tff(pred_def_64407,type,
    v113430: state_type > $o ).

tff(pred_def_64408,type,
    v113431: state_type > $o ).

tff(pred_def_64409,type,
    v113429: state_type > $o ).

tff(pred_def_64410,type,
    v113432: state_type > $o ).

tff(pred_def_64411,type,
    v113428: state_type > $o ).

tff(pred_def_64412,type,
    v113427: state_type > $o ).

tff(pred_def_64413,type,
    v113423: state_type > $o ).

tff(pred_def_64414,type,
    v113433: state_type > $o ).

tff(pred_def_64415,type,
    v113422: state_type > $o ).

tff(pred_def_64416,type,
    v113437: state_type > $o ).

tff(pred_def_64417,type,
    v113438: state_type > $o ).

tff(pred_def_64418,type,
    v113436: state_type > $o ).

tff(pred_def_64419,type,
    v113439: state_type > $o ).

tff(pred_def_64420,type,
    v113435: state_type > $o ).

tff(pred_def_64421,type,
    v113434: state_type > $o ).

tff(pred_def_64422,type,
    v113421: state_type > $o ).

tff(pred_def_64423,type,
    v113440: state_type > $o ).

tff(pred_def_64424,type,
    v113420: state_type > $o ).

tff(pred_def_64425,type,
    v113444: state_type > $o ).

tff(pred_def_64426,type,
    v113445: state_type > $o ).

tff(pred_def_64427,type,
    v113443: state_type > $o ).

tff(pred_def_64428,type,
    v113446: state_type > $o ).

tff(pred_def_64429,type,
    v113442: state_type > $o ).

tff(pred_def_64430,type,
    v113441: state_type > $o ).

tff(pred_def_64431,type,
    v113419: state_type > $o ).

tff(pred_def_64432,type,
    v113447: state_type > $o ).

tff(pred_def_64433,type,
    v113418: state_type > $o ).

tff(pred_def_64434,type,
    v113451: state_type > $o ).

tff(pred_def_64435,type,
    v113452: state_type > $o ).

tff(pred_def_64436,type,
    v113450: state_type > $o ).

tff(pred_def_64437,type,
    v113453: state_type > $o ).

tff(pred_def_64438,type,
    v113449: state_type > $o ).

tff(pred_def_64439,type,
    v113448: state_type > $o ).

tff(pred_def_64440,type,
    v113417: state_type > $o ).

tff(pred_def_64441,type,
    v113454: state_type > $o ).

tff(pred_def_64442,type,
    v113176: state_type > $o ).

tff(pred_def_64443,type,
    v113466: state_type > $o ).

tff(pred_def_64444,type,
    v113464: state_type > $o ).

tff(pred_def_64445,type,
    v113470: state_type > $o ).

tff(pred_def_64446,type,
    v113468: state_type > $o ).

tff(pred_def_64447,type,
    b0000010110000: $int > $o ).

tff(pred_def_64448,type,
    v113482: state_type > $o ).

tff(pred_def_64449,type,
    v113481: state_type > $o ).

tff(pred_def_64450,type,
    v113480: ( state_type * $int ) > $o ).

tff(pred_def_64451,type,
    v113458: ( state_type * $int ) > $o ).

tff(pred_def_64452,type,
    v113478: ( state_type * $int ) > $o ).

tff(pred_def_64453,type,
    v113483: ( state_type * $int ) > $o ).

tff(pred_def_64454,type,
    v113484: ( state_type * $int ) > $o ).

tff(pred_def_64455,type,
    v113476: ( state_type * $int ) > $o ).

tff(pred_def_64456,type,
    v113490: state_type > $o ).

tff(pred_def_64457,type,
    v113488: state_type > $o ).

tff(pred_def_64458,type,
    v113486: state_type > $o ).

tff(pred_def_64459,type,
    v113494: state_type > $o ).

tff(pred_def_64460,type,
    v113493: ( state_type * $int ) > $o ).

tff(pred_def_64461,type,
    v113492: ( state_type * $int ) > $o ).

tff(pred_def_64462,type,
    v113498: state_type > $o ).

tff(pred_def_64463,type,
    v113497: ( state_type * $int ) > $o ).

tff(pred_def_64464,type,
    v113496: ( state_type * $int ) > $o ).

tff(pred_def_64465,type,
    v113460: ( state_type * $int ) > $o ).

tff(pred_def_64466,type,
    v113495: ( state_type * $int ) > $o ).

tff(pred_def_64467,type,
    v113491: ( state_type * $int ) > $o ).

tff(pred_def_64468,type,
    v113474: ( state_type * $int ) > $o ).

tff(pred_def_64469,type,
    v113472: ( state_type * $int ) > $o ).

tff(pred_def_64470,type,
    v113502: state_type > $o ).

tff(pred_def_64471,type,
    v113500: state_type > $o ).

tff(pred_def_64472,type,
    v113509: state_type > $o ).

tff(pred_def_64473,type,
    v113507: state_type > $o ).

tff(pred_def_64474,type,
    v113506: state_type > $o ).

tff(pred_def_64475,type,
    v113505: state_type > $o ).

tff(pred_def_64476,type,
    v113517: state_type > $o ).

tff(pred_def_64477,type,
    v113518: state_type > $o ).

tff(pred_def_64478,type,
    v113516: state_type > $o ).

tff(pred_def_64479,type,
    v113513: ( state_type * $int ) > $o ).

tff(pred_def_64480,type,
    v113515: ( state_type * $int ) > $o ).

tff(pred_def_64481,type,
    v113504: ( state_type * $int ) > $o ).

tff(pred_def_64482,type,
    v113462: ( state_type * $int ) > $o ).

tff(pred_def_64483,type,
    v113530: state_type > $o ).

tff(pred_def_64484,type,
    v113528: state_type > $o ).

tff(pred_def_64485,type,
    v113527: state_type > $o ).

tff(pred_def_64486,type,
    v113526: ( state_type * $int ) > $o ).

tff(pred_def_64487,type,
    v113522: ( state_type * $int ) > $o ).

tff(pred_def_64488,type,
    v113539: state_type > $o ).

tff(pred_def_64489,type,
    v113537: state_type > $o ).

tff(pred_def_64490,type,
    v113536: state_type > $o ).

tff(pred_def_64491,type,
    v113535: ( state_type * $int ) > $o ).

tff(pred_def_64492,type,
    v113555: ( state_type * $int ) > $o ).

tff(pred_def_64493,type,
    v113554: state_type > $o ).

tff(pred_def_64494,type,
    v113556: ( state_type * $int ) > $o ).

tff(pred_def_64495,type,
    v113553: state_type > $o ).

tff(pred_def_64496,type,
    v113560: state_type > $o ).

tff(pred_def_64497,type,
    v113561: state_type > $o ).

tff(pred_def_64498,type,
    v113559: state_type > $o ).

tff(pred_def_64499,type,
    v113562: state_type > $o ).

tff(pred_def_64500,type,
    v113558: state_type > $o ).

tff(pred_def_64501,type,
    v113557: state_type > $o ).

tff(pred_def_64502,type,
    v113552: state_type > $o ).

tff(pred_def_64503,type,
    v113563: state_type > $o ).

tff(pred_def_64504,type,
    v113551: state_type > $o ).

tff(pred_def_64505,type,
    v113567: state_type > $o ).

tff(pred_def_64506,type,
    v113568: state_type > $o ).

tff(pred_def_64507,type,
    v113566: state_type > $o ).

tff(pred_def_64508,type,
    v113569: state_type > $o ).

tff(pred_def_64509,type,
    v113565: state_type > $o ).

tff(pred_def_64510,type,
    v113564: state_type > $o ).

tff(pred_def_64511,type,
    v113550: state_type > $o ).

tff(pred_def_64512,type,
    v113570: state_type > $o ).

tff(pred_def_64513,type,
    v113549: state_type > $o ).

tff(pred_def_64514,type,
    v113574: state_type > $o ).

tff(pred_def_64515,type,
    v113575: state_type > $o ).

tff(pred_def_64516,type,
    v113573: state_type > $o ).

tff(pred_def_64517,type,
    v113576: state_type > $o ).

tff(pred_def_64518,type,
    v113572: state_type > $o ).

tff(pred_def_64519,type,
    v113571: state_type > $o ).

tff(pred_def_64520,type,
    v113548: state_type > $o ).

tff(pred_def_64521,type,
    v113577: state_type > $o ).

tff(pred_def_64522,type,
    v113547: state_type > $o ).

tff(pred_def_64523,type,
    v113581: state_type > $o ).

tff(pred_def_64524,type,
    v113582: state_type > $o ).

tff(pred_def_64525,type,
    v113580: state_type > $o ).

tff(pred_def_64526,type,
    v113583: state_type > $o ).

tff(pred_def_64527,type,
    v113579: state_type > $o ).

tff(pred_def_64528,type,
    v113578: state_type > $o ).

tff(pred_def_64529,type,
    v113546: state_type > $o ).

tff(pred_def_64530,type,
    v113584: state_type > $o ).

tff(pred_def_64531,type,
    v113456: state_type > $o ).

tff(pred_def_64532,type,
    v113598: ( state_type * $int ) > $o ).

tff(pred_def_64533,type,
    v113597: state_type > $o ).

tff(pred_def_64534,type,
    v113596: state_type > $o ).

tff(pred_def_64535,type,
    v113602: state_type > $o ).

tff(pred_def_64536,type,
    v113601: state_type > $o ).

tff(pred_def_64537,type,
    v113603: state_type > $o ).

tff(pred_def_64538,type,
    v113600: state_type > $o ).

tff(pred_def_64539,type,
    v113599: state_type > $o ).

tff(pred_def_64540,type,
    v113595: state_type > $o ).

tff(pred_def_64541,type,
    v113604: state_type > $o ).

tff(pred_def_64542,type,
    v113594: state_type > $o ).

tff(pred_def_64543,type,
    v113608: state_type > $o ).

tff(pred_def_64544,type,
    v113607: state_type > $o ).

tff(pred_def_64545,type,
    v113609: state_type > $o ).

tff(pred_def_64546,type,
    v113606: state_type > $o ).

tff(pred_def_64547,type,
    v113605: state_type > $o ).

tff(pred_def_64548,type,
    v113593: state_type > $o ).

tff(pred_def_64549,type,
    v113610: state_type > $o ).

tff(pred_def_64550,type,
    v113592: state_type > $o ).

tff(pred_def_64551,type,
    v113614: state_type > $o ).

tff(pred_def_64552,type,
    v113613: state_type > $o ).

tff(pred_def_64553,type,
    v113615: state_type > $o ).

tff(pred_def_64554,type,
    v113612: state_type > $o ).

tff(pred_def_64555,type,
    v113611: state_type > $o ).

tff(pred_def_64556,type,
    v113591: state_type > $o ).

tff(pred_def_64557,type,
    v113616: state_type > $o ).

tff(pred_def_64558,type,
    v113590: state_type > $o ).

tff(pred_def_64559,type,
    v113620: state_type > $o ).

tff(pred_def_64560,type,
    v113619: state_type > $o ).

tff(pred_def_64561,type,
    v113621: state_type > $o ).

tff(pred_def_64562,type,
    v113618: state_type > $o ).

tff(pred_def_64563,type,
    v113617: state_type > $o ).

tff(pred_def_64564,type,
    v113589: state_type > $o ).

tff(pred_def_64565,type,
    v113622: state_type > $o ).

tff(pred_def_64566,type,
    v113586: state_type > $o ).

tff(pred_def_64567,type,
    v113625: state_type > $o ).

tff(pred_def_64568,type,
    v113626: state_type > $o ).

tff(pred_def_64569,type,
    v113624: state_type > $o ).

tff(pred_def_64570,type,
    v113627: ( state_type * $int ) > $o ).

tff(pred_def_64571,type,
    v113630: state_type > $o ).

tff(pred_def_64572,type,
    v113629: state_type > $o ).

tff(pred_def_64573,type,
    v113631: ( state_type * $int ) > $o ).

tff(pred_def_64574,type,
    v113628: ( state_type * $int ) > $o ).

tff(pred_def_64575,type,
    v113623: ( state_type * $int ) > $o ).

tff(pred_def_64576,type,
    v113174: ( state_type * $int ) > $o ).

tff(pred_def_64577,type,
    v113643: state_type > $o ).

tff(pred_def_64578,type,
    v113641: state_type > $o ).

tff(pred_def_64579,type,
    v113647: state_type > $o ).

tff(pred_def_64580,type,
    v113645: state_type > $o ).

tff(pred_def_64581,type,
    b0000010111000: $int > $o ).

tff(pred_def_64582,type,
    v113661: state_type > $o ).

tff(pred_def_64583,type,
    v113660: state_type > $o ).

tff(pred_def_64584,type,
    v113659: ( state_type * $int ) > $o ).

tff(pred_def_64585,type,
    v113633: ( state_type * $int ) > $o ).

tff(pred_def_64586,type,
    v113657: ( state_type * $int ) > $o ).

tff(pred_def_64587,type,
    v113662: ( state_type * $int ) > $o ).

tff(pred_def_64588,type,
    v113655: ( state_type * $int ) > $o ).

tff(pred_def_64589,type,
    v113663: ( state_type * $int ) > $o ).

tff(pred_def_64590,type,
    v113653: ( state_type * $int ) > $o ).

tff(pred_def_64591,type,
    v113669: state_type > $o ).

tff(pred_def_64592,type,
    v113667: state_type > $o ).

tff(pred_def_64593,type,
    v113665: state_type > $o ).

tff(pred_def_64594,type,
    v113673: state_type > $o ).

tff(pred_def_64595,type,
    v113672: ( state_type * $int ) > $o ).

tff(pred_def_64596,type,
    v113671: ( state_type * $int ) > $o ).

tff(pred_def_64597,type,
    v113677: state_type > $o ).

tff(pred_def_64598,type,
    v113676: ( state_type * $int ) > $o ).

tff(pred_def_64599,type,
    v113675: ( state_type * $int ) > $o ).

tff(pred_def_64600,type,
    v113637: ( state_type * $int ) > $o ).

tff(pred_def_64601,type,
    v113674: ( state_type * $int ) > $o ).

tff(pred_def_64602,type,
    v113670: ( state_type * $int ) > $o ).

tff(pred_def_64603,type,
    v113651: ( state_type * $int ) > $o ).

tff(pred_def_64604,type,
    v113649: ( state_type * $int ) > $o ).

tff(pred_def_64605,type,
    v113681: state_type > $o ).

tff(pred_def_64606,type,
    v113679: state_type > $o ).

tff(pred_def_64607,type,
    v113688: state_type > $o ).

tff(pred_def_64608,type,
    v113686: state_type > $o ).

tff(pred_def_64609,type,
    v113685: state_type > $o ).

tff(pred_def_64610,type,
    v113684: state_type > $o ).

tff(pred_def_64611,type,
    v113696: state_type > $o ).

tff(pred_def_64612,type,
    v113697: state_type > $o ).

tff(pred_def_64613,type,
    v113695: state_type > $o ).

tff(pred_def_64614,type,
    v113692: ( state_type * $int ) > $o ).

tff(pred_def_64615,type,
    v113694: ( state_type * $int ) > $o ).

tff(pred_def_64616,type,
    v113683: ( state_type * $int ) > $o ).

tff(pred_def_64617,type,
    v113639: ( state_type * $int ) > $o ).

tff(pred_def_64618,type,
    v113635: ( state_type * $int ) > $o ).

tff(pred_def_64619,type,
    v113700: ( state_type * $int ) > $o ).

tff(pred_def_64620,type,
    v113706: state_type > $o ).

tff(pred_def_64621,type,
    v113704: state_type > $o ).

tff(pred_def_64622,type,
    v113703: state_type > $o ).

tff(pred_def_64623,type,
    v113702: ( state_type * $int ) > $o ).

tff(pred_def_64624,type,
    v113714: state_type > $o ).

tff(pred_def_64625,type,
    v113712: state_type > $o ).

tff(pred_def_64626,type,
    v113711: state_type > $o ).

tff(pred_def_64627,type,
    v113710: ( state_type * $int ) > $o ).

tff(pred_def_64628,type,
    v113722: state_type > $o ).

tff(pred_def_64629,type,
    v113720: state_type > $o ).

tff(pred_def_64630,type,
    v113719: state_type > $o ).

tff(pred_def_64631,type,
    v113718: ( state_type * $int ) > $o ).

tff(pred_def_64632,type,
    v113737: ( state_type * $int ) > $o ).

tff(pred_def_64633,type,
    v113736: state_type > $o ).

tff(pred_def_64634,type,
    v113740: state_type > $o ).

tff(pred_def_64635,type,
    v113741: state_type > $o ).

tff(pred_def_64636,type,
    v113739: state_type > $o ).

tff(pred_def_64637,type,
    v113742: state_type > $o ).

tff(pred_def_64638,type,
    v113738: state_type > $o ).

tff(pred_def_64639,type,
    v113735: state_type > $o ).

tff(pred_def_64640,type,
    v113743: state_type > $o ).

tff(pred_def_64641,type,
    v113734: state_type > $o ).

tff(pred_def_64642,type,
    v113746: state_type > $o ).

tff(pred_def_64643,type,
    v113747: state_type > $o ).

tff(pred_def_64644,type,
    v113745: state_type > $o ).

tff(pred_def_64645,type,
    v113748: state_type > $o ).

tff(pred_def_64646,type,
    v113744: state_type > $o ).

tff(pred_def_64647,type,
    v113733: state_type > $o ).

tff(pred_def_64648,type,
    v113749: state_type > $o ).

tff(pred_def_64649,type,
    v113732: state_type > $o ).

tff(pred_def_64650,type,
    v113752: state_type > $o ).

tff(pred_def_64651,type,
    v113753: state_type > $o ).

tff(pred_def_64652,type,
    v113751: state_type > $o ).

tff(pred_def_64653,type,
    v113754: state_type > $o ).

tff(pred_def_64654,type,
    v113750: state_type > $o ).

tff(pred_def_64655,type,
    v113731: state_type > $o ).

tff(pred_def_64656,type,
    v113755: state_type > $o ).

tff(pred_def_64657,type,
    v113730: state_type > $o ).

tff(pred_def_64658,type,
    v113729: state_type > $o ).

tff(pred_def_64659,type,
    v113759: state_type > $o ).

tff(pred_def_64660,type,
    v113760: state_type > $o ).

tff(pred_def_64661,type,
    v113758: state_type > $o ).

tff(pred_def_64662,type,
    v113761: state_type > $o ).

tff(pred_def_64663,type,
    v113757: state_type > $o ).

tff(pred_def_64664,type,
    v113756: state_type > $o ).

tff(pred_def_64665,type,
    v113728: state_type > $o ).

tff(pred_def_64666,type,
    v113762: state_type > $o ).

tff(pred_def_64667,type,
    v113727: state_type > $o ).

tff(pred_def_64668,type,
    v113765: state_type > $o ).

tff(pred_def_64669,type,
    v113766: state_type > $o ).

tff(pred_def_64670,type,
    v113764: state_type > $o ).

tff(pred_def_64671,type,
    v113767: state_type > $o ).

tff(pred_def_64672,type,
    v113763: state_type > $o ).

tff(pred_def_64673,type,
    v113770: state_type > $o ).

tff(pred_def_64674,type,
    v113771: state_type > $o ).

tff(pred_def_64675,type,
    v113769: state_type > $o ).

tff(pred_def_64676,type,
    v113772: state_type > $o ).

tff(pred_def_64677,type,
    v113768: state_type > $o ).

tff(pred_def_64678,type,
    v113775: state_type > $o ).

tff(pred_def_64679,type,
    v113776: state_type > $o ).

tff(pred_def_64680,type,
    v113774: state_type > $o ).

tff(pred_def_64681,type,
    v113777: state_type > $o ).

tff(pred_def_64682,type,
    v113773: state_type > $o ).

tff(pred_def_64683,type,
    v113780: state_type > $o ).

tff(pred_def_64684,type,
    v113781: state_type > $o ).

tff(pred_def_64685,type,
    v113779: state_type > $o ).

tff(pred_def_64686,type,
    v113782: state_type > $o ).

tff(pred_def_64687,type,
    v113778: state_type > $o ).

tff(pred_def_64688,type,
    v113172: ( state_type * $int ) > $o ).

tff(pred_def_64689,type,
    v113170: ( state_type * $int ) > $o ).

tff(pred_def_64690,type,
    v113168: ( state_type * $int ) > $o ).

tff(pred_def_64691,type,
    v113166: ( state_type * $int ) > $o ).

tff(pred_def_64692,type,
    v113786: state_type > $o ).

tff(pred_def_64693,type,
    v113784: state_type > $o ).

tff(pred_def_64694,type,
    v113793: state_type > $o ).

tff(pred_def_64695,type,
    v113791: state_type > $o ).

tff(pred_def_64696,type,
    v113790: state_type > $o ).

tff(pred_def_64697,type,
    v113789: state_type > $o ).

tff(pred_def_64698,type,
    v113801: state_type > $o ).

tff(pred_def_64699,type,
    v113802: state_type > $o ).

tff(pred_def_64700,type,
    v113800: state_type > $o ).

tff(pred_def_64701,type,
    v113797: ( state_type * $int ) > $o ).

tff(pred_def_64702,type,
    v113799: ( state_type * $int ) > $o ).

tff(pred_def_64703,type,
    v113156: ( state_type * $int ) > $o ).

tff(pred_def_64704,type,
    v113154: ( state_type * $int ) > $o ).

tff(pred_def_64705,type,
    v113152: ( state_type * $int ) > $o ).

tff(pred_def_64706,type,
    v113150: ( state_type * $int ) > $o ).

tff(pred_def_64707,type,
    v113822: state_type > $o ).

tff(pred_def_64708,type,
    v113820: state_type > $o ).

tff(pred_def_64709,type,
    v113826: state_type > $o ).

tff(pred_def_64710,type,
    v113824: state_type > $o ).

tff(pred_def_64711,type,
    v113838: state_type > $o ).

tff(pred_def_64712,type,
    v113839: state_type > $o ).

tff(pred_def_64713,type,
    v113840: state_type > $o ).

tff(pred_def_64714,type,
    v113841: state_type > $o ).

tff(pred_def_64715,type,
    v113842: state_type > $o ).

tff(pred_def_64716,type,
    v113843: state_type > $o ).

tff(pred_def_64717,type,
    v113844: state_type > $o ).

tff(pred_def_64718,type,
    v113845: state_type > $o ).

tff(pred_def_64719,type,
    v113846: state_type > $o ).

tff(pred_def_64720,type,
    v113847: state_type > $o ).

tff(pred_def_64721,type,
    v113848: state_type > $o ).

tff(pred_def_64722,type,
    v113849: state_type > $o ).

tff(pred_def_64723,type,
    v113850: state_type > $o ).

tff(pred_def_64724,type,
    v113851: state_type > $o ).

tff(pred_def_64725,type,
    v113852: state_type > $o ).

tff(pred_def_64726,type,
    v113853: state_type > $o ).

tff(pred_def_64727,type,
    v113837: ( state_type * $int ) > $o ).

tff(pred_def_64728,type,
    v113836: ( state_type * $int ) > $o ).

tff(pred_def_64729,type,
    v113857: state_type > $o ).

tff(pred_def_64730,type,
    v113858: state_type > $o ).

tff(pred_def_64731,type,
    v113859: state_type > $o ).

tff(pred_def_64732,type,
    v113860: state_type > $o ).

tff(pred_def_64733,type,
    v113861: state_type > $o ).

tff(pred_def_64734,type,
    v113862: state_type > $o ).

tff(pred_def_64735,type,
    v113863: state_type > $o ).

tff(pred_def_64736,type,
    v113864: state_type > $o ).

tff(pred_def_64737,type,
    v113865: state_type > $o ).

tff(pred_def_64738,type,
    v113866: state_type > $o ).

tff(pred_def_64739,type,
    v113867: state_type > $o ).

tff(pred_def_64740,type,
    v113868: state_type > $o ).

tff(pred_def_64741,type,
    v113869: state_type > $o ).

tff(pred_def_64742,type,
    v113870: state_type > $o ).

tff(pred_def_64743,type,
    v113871: state_type > $o ).

tff(pred_def_64744,type,
    v113872: state_type > $o ).

tff(pred_def_64745,type,
    v113856: ( state_type * $int ) > $o ).

tff(pred_def_64746,type,
    v113855: ( state_type * $int ) > $o ).

tff(pred_def_64747,type,
    v113879: state_type > $o ).

tff(pred_def_64748,type,
    v113878: state_type > $o ).

tff(pred_def_64749,type,
    v113877: state_type > $o ).

tff(pred_def_64750,type,
    v113876: ( state_type * $int ) > $o ).

tff(pred_def_64751,type,
    v113875: ( state_type * $int ) > $o ).

tff(pred_def_64752,type,
    v113882: state_type > $o ).

tff(pred_def_64753,type,
    v113881: ( state_type * $int ) > $o ).

tff(pred_def_64754,type,
    v113880: ( state_type * $int ) > $o ).

tff(pred_def_64755,type,
    v113874: ( state_type * $int ) > $o ).

tff(pred_def_64756,type,
    v113885: state_type > $o ).

tff(pred_def_64757,type,
    v113884: ( state_type * $int ) > $o ).

tff(pred_def_64758,type,
    v113883: ( state_type * $int ) > $o ).

tff(pred_def_64759,type,
    v113873: ( state_type * $int ) > $o ).

tff(pred_def_64760,type,
    v113834: ( state_type * $int ) > $o ).

tff(pred_def_64761,type,
    v113832: ( state_type * $int ) > $o ).

tff(pred_def_64762,type,
    v113830: ( state_type * $int ) > $o ).

tff(pred_def_64763,type,
    v113828: ( state_type * $int ) > $o ).

tff(pred_def_64764,type,
    v113889: state_type > $o ).

tff(pred_def_64765,type,
    v113887: state_type > $o ).

tff(pred_def_64766,type,
    v113896: state_type > $o ).

tff(pred_def_64767,type,
    v113894: state_type > $o ).

tff(pred_def_64768,type,
    v113893: state_type > $o ).

tff(pred_def_64769,type,
    v113892: state_type > $o ).

tff(pred_def_64770,type,
    v113904: state_type > $o ).

tff(pred_def_64771,type,
    v113905: state_type > $o ).

tff(pred_def_64772,type,
    v113903: state_type > $o ).

tff(pred_def_64773,type,
    v113900: ( state_type * $int ) > $o ).

tff(pred_def_64774,type,
    v113902: ( state_type * $int ) > $o ).

tff(pred_def_64775,type,
    v113891: ( state_type * $int ) > $o ).

tff(pred_def_64776,type,
    v113818: ( state_type * $int ) > $o ).

tff(pred_def_64777,type,
    v113816: ( state_type * $int ) > $o ).

tff(pred_def_64778,type,
    v113814: ( state_type * $int ) > $o ).

tff(pred_def_64779,type,
    v113812: ( state_type * $int ) > $o ).

tff(pred_def_64780,type,
    v113810: ( state_type * $int ) > $o ).

tff(pred_def_64781,type,
    v113808: state_type > $o ).

tff(pred_def_64782,type,
    v113919: state_type > $o ).

tff(pred_def_64783,type,
    v113920: state_type > $o ).

tff(pred_def_64784,type,
    v113921: state_type > $o ).

tff(pred_def_64785,type,
    v113922: state_type > $o ).

tff(pred_def_64786,type,
    v113923: state_type > $o ).

tff(pred_def_64787,type,
    v113924: state_type > $o ).

tff(pred_def_64788,type,
    v113925: state_type > $o ).

tff(pred_def_64789,type,
    v113926: state_type > $o ).

tff(pred_def_64790,type,
    v113927: state_type > $o ).

tff(pred_def_64791,type,
    v113928: state_type > $o ).

tff(pred_def_64792,type,
    v113929: state_type > $o ).

tff(pred_def_64793,type,
    v113930: state_type > $o ).

tff(pred_def_64794,type,
    v113931: state_type > $o ).

tff(pred_def_64795,type,
    v113932: state_type > $o ).

tff(pred_def_64796,type,
    v113933: state_type > $o ).

tff(pred_def_64797,type,
    v113934: state_type > $o ).

tff(pred_def_64798,type,
    v113918: ( state_type * $int ) > $o ).

tff(pred_def_64799,type,
    v113917: ( state_type * $int ) > $o ).

tff(pred_def_64800,type,
    v113940: state_type > $o ).

tff(pred_def_64801,type,
    v113941: state_type > $o ).

tff(pred_def_64802,type,
    v113939: state_type > $o ).

tff(pred_def_64803,type,
    v113938: state_type > $o ).

tff(pred_def_64804,type,
    v113937: state_type > $o ).

tff(pred_def_64805,type,
    v113936: ( state_type * $int ) > $o ).

tff(pred_def_64806,type,
    v113935: ( state_type * $int ) > $o ).

tff(pred_def_64807,type,
    v113915: ( state_type * $int ) > $o ).

tff(pred_def_64808,type,
    v113913: ( state_type * $int ) > $o ).

tff(pred_def_64809,type,
    v113911: ( state_type * $int ) > $o ).

tff(pred_def_64810,type,
    v113909: state_type > $o ).

tff(pred_def_64811,type,
    v113806: state_type > $o ).

tff(pred_def_64812,type,
    v113954: state_type > $o ).

tff(pred_def_64813,type,
    v113952: state_type > $o ).

tff(pred_def_64814,type,
    v113958: state_type > $o ).

tff(pred_def_64815,type,
    v113956: state_type > $o ).

tff(pred_def_64816,type,
    v113978: state_type > $o ).

tff(pred_def_64817,type,
    v113976: state_type > $o ).

tff(pred_def_64818,type,
    v113982: state_type > $o ).

tff(pred_def_64819,type,
    v113980: state_type > $o ).

tff(pred_def_64820,type,
    b0000011000000: $int > $o ).

tff(pred_def_64821,type,
    v113996: state_type > $o ).

tff(pred_def_64822,type,
    v113995: state_type > $o ).

tff(pred_def_64823,type,
    v113994: ( state_type * $int ) > $o ).

tff(pred_def_64824,type,
    v113968: ( state_type * $int ) > $o ).

tff(pred_def_64825,type,
    v113992: ( state_type * $int ) > $o ).

tff(pred_def_64826,type,
    v113997: ( state_type * $int ) > $o ).

tff(pred_def_64827,type,
    v113990: ( state_type * $int ) > $o ).

tff(pred_def_64828,type,
    v113998: ( state_type * $int ) > $o ).

tff(pred_def_64829,type,
    v113988: ( state_type * $int ) > $o ).

tff(pred_def_64830,type,
    v114004: state_type > $o ).

tff(pred_def_64831,type,
    v114002: state_type > $o ).

tff(pred_def_64832,type,
    v114000: state_type > $o ).

tff(pred_def_64833,type,
    v114008: state_type > $o ).

tff(pred_def_64834,type,
    v114007: ( state_type * $int ) > $o ).

tff(pred_def_64835,type,
    v114006: ( state_type * $int ) > $o ).

tff(pred_def_64836,type,
    v114012: state_type > $o ).

tff(pred_def_64837,type,
    v114011: ( state_type * $int ) > $o ).

tff(pred_def_64838,type,
    v114010: ( state_type * $int ) > $o ).

tff(pred_def_64839,type,
    v113972: ( state_type * $int ) > $o ).

tff(pred_def_64840,type,
    v114009: ( state_type * $int ) > $o ).

tff(pred_def_64841,type,
    v114005: ( state_type * $int ) > $o ).

tff(pred_def_64842,type,
    v113986: ( state_type * $int ) > $o ).

tff(pred_def_64843,type,
    v113984: ( state_type * $int ) > $o ).

tff(pred_def_64844,type,
    v114016: state_type > $o ).

tff(pred_def_64845,type,
    v114014: state_type > $o ).

tff(pred_def_64846,type,
    v114023: state_type > $o ).

tff(pred_def_64847,type,
    v114021: state_type > $o ).

tff(pred_def_64848,type,
    v114020: state_type > $o ).

tff(pred_def_64849,type,
    v114019: state_type > $o ).

tff(pred_def_64850,type,
    v114031: state_type > $o ).

tff(pred_def_64851,type,
    v114032: state_type > $o ).

tff(pred_def_64852,type,
    v114030: state_type > $o ).

tff(pred_def_64853,type,
    v114027: ( state_type * $int ) > $o ).

tff(pred_def_64854,type,
    v114029: ( state_type * $int ) > $o ).

tff(pred_def_64855,type,
    v114018: ( state_type * $int ) > $o ).

tff(pred_def_64856,type,
    v113974: ( state_type * $int ) > $o ).

tff(pred_def_64857,type,
    v113970: ( state_type * $int ) > $o ).

tff(pred_def_64858,type,
    v114035: ( state_type * $int ) > $o ).

tff(pred_def_64859,type,
    v114041: state_type > $o ).

tff(pred_def_64860,type,
    v114039: state_type > $o ).

tff(pred_def_64861,type,
    v114038: state_type > $o ).

tff(pred_def_64862,type,
    v114037: ( state_type * $int ) > $o ).

tff(pred_def_64863,type,
    v114049: state_type > $o ).

tff(pred_def_64864,type,
    v114047: state_type > $o ).

tff(pred_def_64865,type,
    v114046: state_type > $o ).

tff(pred_def_64866,type,
    v114045: ( state_type * $int ) > $o ).

tff(pred_def_64867,type,
    v114057: state_type > $o ).

tff(pred_def_64868,type,
    v114055: state_type > $o ).

tff(pred_def_64869,type,
    v114054: state_type > $o ).

tff(pred_def_64870,type,
    v114053: ( state_type * $int ) > $o ).

tff(pred_def_64871,type,
    v114071: state_type > $o ).

tff(pred_def_64872,type,
    v114069: state_type > $o ).

tff(pred_def_64873,type,
    v114075: state_type > $o ).

tff(pred_def_64874,type,
    v114073: state_type > $o ).

tff(pred_def_64875,type,
    b0000000010000: $int > $o ).

tff(pred_def_64876,type,
    v114089: state_type > $o ).

tff(pred_def_64877,type,
    v114088: state_type > $o ).

tff(pred_def_64878,type,
    v114087: ( state_type * $int ) > $o ).

tff(pred_def_64879,type,
    v114061: ( state_type * $int ) > $o ).

tff(pred_def_64880,type,
    v114085: ( state_type * $int ) > $o ).

tff(pred_def_64881,type,
    v114090: ( state_type * $int ) > $o ).

tff(pred_def_64882,type,
    v114083: ( state_type * $int ) > $o ).

tff(pred_def_64883,type,
    v114091: ( state_type * $int ) > $o ).

tff(pred_def_64884,type,
    v114081: ( state_type * $int ) > $o ).

tff(pred_def_64885,type,
    v114097: state_type > $o ).

tff(pred_def_64886,type,
    v114095: state_type > $o ).

tff(pred_def_64887,type,
    v114093: state_type > $o ).

tff(pred_def_64888,type,
    v114101: state_type > $o ).

tff(pred_def_64889,type,
    v114100: ( state_type * $int ) > $o ).

tff(pred_def_64890,type,
    v114099: ( state_type * $int ) > $o ).

tff(pred_def_64891,type,
    v114105: state_type > $o ).

tff(pred_def_64892,type,
    v114104: ( state_type * $int ) > $o ).

tff(pred_def_64893,type,
    v114103: ( state_type * $int ) > $o ).

tff(pred_def_64894,type,
    v114065: ( state_type * $int ) > $o ).

tff(pred_def_64895,type,
    v114102: ( state_type * $int ) > $o ).

tff(pred_def_64896,type,
    v114098: ( state_type * $int ) > $o ).

tff(pred_def_64897,type,
    v114079: ( state_type * $int ) > $o ).

tff(pred_def_64898,type,
    v114077: ( state_type * $int ) > $o ).

tff(pred_def_64899,type,
    v114109: state_type > $o ).

tff(pred_def_64900,type,
    v114107: state_type > $o ).

tff(pred_def_64901,type,
    v114116: state_type > $o ).

tff(pred_def_64902,type,
    v114114: state_type > $o ).

tff(pred_def_64903,type,
    v114113: state_type > $o ).

tff(pred_def_64904,type,
    v114112: state_type > $o ).

tff(pred_def_64905,type,
    v114124: state_type > $o ).

tff(pred_def_64906,type,
    v114125: state_type > $o ).

tff(pred_def_64907,type,
    v114123: state_type > $o ).

tff(pred_def_64908,type,
    v114120: ( state_type * $int ) > $o ).

tff(pred_def_64909,type,
    v114122: ( state_type * $int ) > $o ).

tff(pred_def_64910,type,
    v114111: ( state_type * $int ) > $o ).

tff(pred_def_64911,type,
    v114067: ( state_type * $int ) > $o ).

tff(pred_def_64912,type,
    v114063: ( state_type * $int ) > $o ).

tff(pred_def_64913,type,
    v114129: ( state_type * $int ) > $o ).

tff(pred_def_64914,type,
    v114128: ( state_type * $int ) > $o ).

tff(pred_def_64915,type,
    v114135: state_type > $o ).

tff(pred_def_64916,type,
    v114133: state_type > $o ).

tff(pred_def_64917,type,
    v114132: state_type > $o ).

tff(pred_def_64918,type,
    v114131: ( state_type * $int ) > $o ).

tff(pred_def_64919,type,
    v114143: state_type > $o ).

tff(pred_def_64920,type,
    v114141: state_type > $o ).

tff(pred_def_64921,type,
    v114140: state_type > $o ).

tff(pred_def_64922,type,
    v114139: ( state_type * $int ) > $o ).

tff(pred_def_64923,type,
    v114183: ( state_type * $int ) > $o ).

tff(pred_def_64924,type,
    v114182: ( state_type * $int ) > $o ).

tff(pred_def_64925,type,
    v114184: ( state_type * $int ) > $o ).

tff(pred_def_64926,type,
    v114181: state_type > $o ).

tff(pred_def_64927,type,
    v114187: state_type > $o ).

tff(pred_def_64928,type,
    v114188: state_type > $o ).

tff(pred_def_64929,type,
    v114186: state_type > $o ).

tff(pred_def_64930,type,
    v114189: state_type > $o ).

tff(pred_def_64931,type,
    v114185: state_type > $o ).

tff(pred_def_64932,type,
    v114180: state_type > $o ).

tff(pred_def_64933,type,
    v114190: state_type > $o ).

tff(pred_def_64934,type,
    v114179: state_type > $o ).

tff(pred_def_64935,type,
    v114193: state_type > $o ).

tff(pred_def_64936,type,
    v114194: state_type > $o ).

tff(pred_def_64937,type,
    v114192: state_type > $o ).

tff(pred_def_64938,type,
    v114195: state_type > $o ).

tff(pred_def_64939,type,
    v114191: state_type > $o ).

tff(pred_def_64940,type,
    v114178: state_type > $o ).

tff(pred_def_64941,type,
    v114196: state_type > $o ).

tff(pred_def_64942,type,
    v114177: state_type > $o ).

tff(pred_def_64943,type,
    v114199: state_type > $o ).

tff(pred_def_64944,type,
    v114200: state_type > $o ).

tff(pred_def_64945,type,
    v114198: state_type > $o ).

tff(pred_def_64946,type,
    v114201: state_type > $o ).

tff(pred_def_64947,type,
    v114197: state_type > $o ).

tff(pred_def_64948,type,
    v114176: state_type > $o ).

tff(pred_def_64949,type,
    v114202: state_type > $o ).

tff(pred_def_64950,type,
    v114175: state_type > $o ).

tff(pred_def_64951,type,
    v114174: state_type > $o ).

tff(pred_def_64952,type,
    v114206: state_type > $o ).

tff(pred_def_64953,type,
    v114207: state_type > $o ).

tff(pred_def_64954,type,
    v114205: state_type > $o ).

tff(pred_def_64955,type,
    v114208: state_type > $o ).

tff(pred_def_64956,type,
    v114204: state_type > $o ).

tff(pred_def_64957,type,
    v114203: state_type > $o ).

tff(pred_def_64958,type,
    v114173: state_type > $o ).

tff(pred_def_64959,type,
    v114209: state_type > $o ).

tff(pred_def_64960,type,
    v114172: state_type > $o ).

tff(pred_def_64961,type,
    v114212: state_type > $o ).

tff(pred_def_64962,type,
    v114213: state_type > $o ).

tff(pred_def_64963,type,
    v114211: state_type > $o ).

tff(pred_def_64964,type,
    v114214: state_type > $o ).

tff(pred_def_64965,type,
    v114210: state_type > $o ).

tff(pred_def_64966,type,
    v114217: state_type > $o ).

tff(pred_def_64967,type,
    v114218: state_type > $o ).

tff(pred_def_64968,type,
    v114216: state_type > $o ).

tff(pred_def_64969,type,
    v114219: state_type > $o ).

tff(pred_def_64970,type,
    v114215: state_type > $o ).

tff(pred_def_64971,type,
    v114222: state_type > $o ).

tff(pred_def_64972,type,
    v114223: state_type > $o ).

tff(pred_def_64973,type,
    v114221: state_type > $o ).

tff(pred_def_64974,type,
    v114224: state_type > $o ).

tff(pred_def_64975,type,
    v114220: state_type > $o ).

tff(pred_def_64976,type,
    v114227: state_type > $o ).

tff(pred_def_64977,type,
    v114228: state_type > $o ).

tff(pred_def_64978,type,
    v114226: state_type > $o ).

tff(pred_def_64979,type,
    v114229: state_type > $o ).

tff(pred_def_64980,type,
    v114225: state_type > $o ).

tff(pred_def_64981,type,
    v114170: ( state_type * $int ) > $o ).

tff(pred_def_64982,type,
    v114230: ( state_type * $int ) > $o ).

tff(pred_def_64983,type,
    v114169: state_type > $o ).

tff(pred_def_64984,type,
    v114233: state_type > $o ).

tff(pred_def_64985,type,
    v114234: state_type > $o ).

tff(pred_def_64986,type,
    v114232: state_type > $o ).

tff(pred_def_64987,type,
    v114235: state_type > $o ).

tff(pred_def_64988,type,
    v114231: state_type > $o ).

tff(pred_def_64989,type,
    v114168: state_type > $o ).

tff(pred_def_64990,type,
    v114236: state_type > $o ).

tff(pred_def_64991,type,
    v114167: state_type > $o ).

tff(pred_def_64992,type,
    v114239: state_type > $o ).

tff(pred_def_64993,type,
    v114240: state_type > $o ).

tff(pred_def_64994,type,
    v114238: state_type > $o ).

tff(pred_def_64995,type,
    v114241: state_type > $o ).

tff(pred_def_64996,type,
    v114237: state_type > $o ).

tff(pred_def_64997,type,
    v114166: state_type > $o ).

tff(pred_def_64998,type,
    v114242: state_type > $o ).

tff(pred_def_64999,type,
    v114165: state_type > $o ).

tff(pred_def_65000,type,
    v114245: state_type > $o ).

tff(pred_def_65001,type,
    v114246: state_type > $o ).

tff(pred_def_65002,type,
    v114244: state_type > $o ).

tff(pred_def_65003,type,
    v114247: state_type > $o ).

tff(pred_def_65004,type,
    v114243: state_type > $o ).

tff(pred_def_65005,type,
    v114164: state_type > $o ).

tff(pred_def_65006,type,
    v114248: state_type > $o ).

tff(pred_def_65007,type,
    v114163: state_type > $o ).

tff(pred_def_65008,type,
    v114162: state_type > $o ).

tff(pred_def_65009,type,
    v114252: state_type > $o ).

tff(pred_def_65010,type,
    v114253: state_type > $o ).

tff(pred_def_65011,type,
    v114251: state_type > $o ).

tff(pred_def_65012,type,
    v114254: state_type > $o ).

tff(pred_def_65013,type,
    v114250: state_type > $o ).

tff(pred_def_65014,type,
    v114249: state_type > $o ).

tff(pred_def_65015,type,
    v114161: state_type > $o ).

tff(pred_def_65016,type,
    v114255: state_type > $o ).

tff(pred_def_65017,type,
    v114160: state_type > $o ).

tff(pred_def_65018,type,
    v114258: state_type > $o ).

tff(pred_def_65019,type,
    v114259: state_type > $o ).

tff(pred_def_65020,type,
    v114257: state_type > $o ).

tff(pred_def_65021,type,
    v114260: state_type > $o ).

tff(pred_def_65022,type,
    v114256: state_type > $o ).

tff(pred_def_65023,type,
    v114263: state_type > $o ).

tff(pred_def_65024,type,
    v114264: state_type > $o ).

tff(pred_def_65025,type,
    v114262: state_type > $o ).

tff(pred_def_65026,type,
    v114265: state_type > $o ).

tff(pred_def_65027,type,
    v114261: state_type > $o ).

tff(pred_def_65028,type,
    v114268: state_type > $o ).

tff(pred_def_65029,type,
    v114269: state_type > $o ).

tff(pred_def_65030,type,
    v114267: state_type > $o ).

tff(pred_def_65031,type,
    v114270: state_type > $o ).

tff(pred_def_65032,type,
    v114266: state_type > $o ).

tff(pred_def_65033,type,
    v114273: state_type > $o ).

tff(pred_def_65034,type,
    v114274: state_type > $o ).

tff(pred_def_65035,type,
    v114272: state_type > $o ).

tff(pred_def_65036,type,
    v114275: state_type > $o ).

tff(pred_def_65037,type,
    v114271: state_type > $o ).

tff(pred_def_65038,type,
    v114158: ( state_type * $int ) > $o ).

tff(pred_def_65039,type,
    v114294: ( state_type * $int ) > $o ).

tff(pred_def_65040,type,
    v114295: ( state_type * $int ) > $o ).

tff(pred_def_65041,type,
    v114293: state_type > $o ).

tff(pred_def_65042,type,
    v114298: state_type > $o ).

tff(pred_def_65043,type,
    v114299: state_type > $o ).

tff(pred_def_65044,type,
    v114297: state_type > $o ).

tff(pred_def_65045,type,
    v114300: state_type > $o ).

tff(pred_def_65046,type,
    v114296: state_type > $o ).

tff(pred_def_65047,type,
    v114292: state_type > $o ).

tff(pred_def_65048,type,
    v114301: state_type > $o ).

tff(pred_def_65049,type,
    v114291: state_type > $o ).

tff(pred_def_65050,type,
    v114304: state_type > $o ).

tff(pred_def_65051,type,
    v114305: state_type > $o ).

tff(pred_def_65052,type,
    v114303: state_type > $o ).

tff(pred_def_65053,type,
    v114306: state_type > $o ).

tff(pred_def_65054,type,
    v114302: state_type > $o ).

tff(pred_def_65055,type,
    v114290: state_type > $o ).

tff(pred_def_65056,type,
    v114307: state_type > $o ).

tff(pred_def_65057,type,
    v114289: state_type > $o ).

tff(pred_def_65058,type,
    v114310: state_type > $o ).

tff(pred_def_65059,type,
    v114311: state_type > $o ).

tff(pred_def_65060,type,
    v114309: state_type > $o ).

tff(pred_def_65061,type,
    v114312: state_type > $o ).

tff(pred_def_65062,type,
    v114308: state_type > $o ).

tff(pred_def_65063,type,
    v114288: state_type > $o ).

tff(pred_def_65064,type,
    v114313: state_type > $o ).

tff(pred_def_65065,type,
    v114287: state_type > $o ).

tff(pred_def_65066,type,
    v114286: state_type > $o ).

tff(pred_def_65067,type,
    v114317: state_type > $o ).

tff(pred_def_65068,type,
    v114318: state_type > $o ).

tff(pred_def_65069,type,
    v114316: state_type > $o ).

tff(pred_def_65070,type,
    v114319: state_type > $o ).

tff(pred_def_65071,type,
    v114315: state_type > $o ).

tff(pred_def_65072,type,
    v114314: state_type > $o ).

tff(pred_def_65073,type,
    v114285: state_type > $o ).

tff(pred_def_65074,type,
    v114320: state_type > $o ).

tff(pred_def_65075,type,
    v114284: state_type > $o ).

tff(pred_def_65076,type,
    v114323: state_type > $o ).

tff(pred_def_65077,type,
    v114324: state_type > $o ).

tff(pred_def_65078,type,
    v114322: state_type > $o ).

tff(pred_def_65079,type,
    v114325: state_type > $o ).

tff(pred_def_65080,type,
    v114321: state_type > $o ).

tff(pred_def_65081,type,
    v114328: state_type > $o ).

tff(pred_def_65082,type,
    v114329: state_type > $o ).

tff(pred_def_65083,type,
    v114327: state_type > $o ).

tff(pred_def_65084,type,
    v114330: state_type > $o ).

tff(pred_def_65085,type,
    v114326: state_type > $o ).

tff(pred_def_65086,type,
    v114333: state_type > $o ).

tff(pred_def_65087,type,
    v114334: state_type > $o ).

tff(pred_def_65088,type,
    v114332: state_type > $o ).

tff(pred_def_65089,type,
    v114335: state_type > $o ).

tff(pred_def_65090,type,
    v114331: state_type > $o ).

tff(pred_def_65091,type,
    v114338: state_type > $o ).

tff(pred_def_65092,type,
    v114339: state_type > $o ).

tff(pred_def_65093,type,
    v114337: state_type > $o ).

tff(pred_def_65094,type,
    v114340: state_type > $o ).

tff(pred_def_65095,type,
    v114336: state_type > $o ).

tff(pred_def_65096,type,
    v114282: ( state_type * $int ) > $o ).

tff(pred_def_65097,type,
    v114346: state_type > $o ).

tff(pred_def_65098,type,
    v114345: state_type > $o ).

tff(pred_def_65099,type,
    v114344: state_type > $o ).

tff(pred_def_65100,type,
    v114347: state_type > $o ).

tff(pred_def_65101,type,
    v114343: state_type > $o ).

tff(pred_def_65102,type,
    v114342: state_type > $o ).

tff(pred_def_65103,type,
    v114348: state_type > $o ).

tff(pred_def_65104,type,
    v114341: state_type > $o ).

tff(pred_def_65105,type,
    v114281: state_type > $o ).

tff(pred_def_65106,type,
    v114280: state_type > $o ).

tff(pred_def_65107,type,
    v114279: state_type > $o ).

tff(pred_def_65108,type,
    v114350: state_type > $o ).

tff(pred_def_65109,type,
    v114349: state_type > $o ).

tff(pred_def_65110,type,
    v114278: state_type > $o ).

tff(pred_def_65111,type,
    v114353: state_type > $o ).

tff(pred_def_65112,type,
    v114352: state_type > $o ).

tff(pred_def_65113,type,
    v114354: state_type > $o ).

tff(pred_def_65114,type,
    v114351: state_type > $o ).

tff(pred_def_65115,type,
    v114357: state_type > $o ).

tff(pred_def_65116,type,
    v114356: state_type > $o ).

tff(pred_def_65117,type,
    v114358: state_type > $o ).

tff(pred_def_65118,type,
    v114355: state_type > $o ).

tff(pred_def_65119,type,
    v114361: state_type > $o ).

tff(pred_def_65120,type,
    v114360: state_type > $o ).

tff(pred_def_65121,type,
    v114362: state_type > $o ).

tff(pred_def_65122,type,
    v114359: state_type > $o ).

tff(pred_def_65123,type,
    v114276: ( state_type * $int ) > $o ).

tff(pred_def_65124,type,
    v114157: state_type > $o ).

tff(pred_def_65125,type,
    v114365: state_type > $o ).

tff(pred_def_65126,type,
    v114366: state_type > $o ).

tff(pred_def_65127,type,
    v114364: state_type > $o ).

tff(pred_def_65128,type,
    v114367: state_type > $o ).

tff(pred_def_65129,type,
    v114363: state_type > $o ).

tff(pred_def_65130,type,
    v114156: state_type > $o ).

tff(pred_def_65131,type,
    v114368: state_type > $o ).

tff(pred_def_65132,type,
    v114155: state_type > $o ).

tff(pred_def_65133,type,
    v114371: state_type > $o ).

tff(pred_def_65134,type,
    v114372: state_type > $o ).

tff(pred_def_65135,type,
    v114370: state_type > $o ).

tff(pred_def_65136,type,
    v114373: state_type > $o ).

tff(pred_def_65137,type,
    v114369: state_type > $o ).

tff(pred_def_65138,type,
    v114154: state_type > $o ).

tff(pred_def_65139,type,
    v114374: state_type > $o ).

tff(pred_def_65140,type,
    v114153: state_type > $o ).

tff(pred_def_65141,type,
    v114377: state_type > $o ).

tff(pred_def_65142,type,
    v114378: state_type > $o ).

tff(pred_def_65143,type,
    v114376: state_type > $o ).

tff(pred_def_65144,type,
    v114379: state_type > $o ).

tff(pred_def_65145,type,
    v114375: state_type > $o ).

tff(pred_def_65146,type,
    v114152: state_type > $o ).

tff(pred_def_65147,type,
    v114380: state_type > $o ).

tff(pred_def_65148,type,
    v114151: state_type > $o ).

tff(pred_def_65149,type,
    v114150: state_type > $o ).

tff(pred_def_65150,type,
    v114384: state_type > $o ).

tff(pred_def_65151,type,
    v114385: state_type > $o ).

tff(pred_def_65152,type,
    v114383: state_type > $o ).

tff(pred_def_65153,type,
    v114386: state_type > $o ).

tff(pred_def_65154,type,
    v114382: state_type > $o ).

tff(pred_def_65155,type,
    v114381: state_type > $o ).

tff(pred_def_65156,type,
    v114149: state_type > $o ).

tff(pred_def_65157,type,
    v114387: state_type > $o ).

tff(pred_def_65158,type,
    v114148: state_type > $o ).

tff(pred_def_65159,type,
    v114390: state_type > $o ).

tff(pred_def_65160,type,
    v114391: state_type > $o ).

tff(pred_def_65161,type,
    v114389: state_type > $o ).

tff(pred_def_65162,type,
    v114392: state_type > $o ).

tff(pred_def_65163,type,
    v114388: state_type > $o ).

tff(pred_def_65164,type,
    v114395: state_type > $o ).

tff(pred_def_65165,type,
    v114396: state_type > $o ).

tff(pred_def_65166,type,
    v114394: state_type > $o ).

tff(pred_def_65167,type,
    v114397: state_type > $o ).

tff(pred_def_65168,type,
    v114393: state_type > $o ).

tff(pred_def_65169,type,
    v114400: state_type > $o ).

tff(pred_def_65170,type,
    v114401: state_type > $o ).

tff(pred_def_65171,type,
    v114399: state_type > $o ).

tff(pred_def_65172,type,
    v114402: state_type > $o ).

tff(pred_def_65173,type,
    v114398: state_type > $o ).

tff(pred_def_65174,type,
    v114405: state_type > $o ).

tff(pred_def_65175,type,
    v114406: state_type > $o ).

tff(pred_def_65176,type,
    v114404: state_type > $o ).

tff(pred_def_65177,type,
    v114407: state_type > $o ).

tff(pred_def_65178,type,
    v114403: state_type > $o ).

tff(pred_def_65179,type,
    v113966: ( state_type * $int ) > $o ).

tff(pred_def_65180,type,
    v113964: ( state_type * $int ) > $o ).

tff(pred_def_65181,type,
    v113962: ( state_type * $int ) > $o ).

tff(pred_def_65182,type,
    v113960: ( state_type * $int ) > $o ).

tff(pred_def_65183,type,
    v114411: state_type > $o ).

tff(pred_def_65184,type,
    v114409: state_type > $o ).

tff(pred_def_65185,type,
    v114418: state_type > $o ).

tff(pred_def_65186,type,
    v114416: state_type > $o ).

tff(pred_def_65187,type,
    v114415: state_type > $o ).

tff(pred_def_65188,type,
    v114414: state_type > $o ).

tff(pred_def_65189,type,
    v114426: state_type > $o ).

tff(pred_def_65190,type,
    v114427: state_type > $o ).

tff(pred_def_65191,type,
    v114425: state_type > $o ).

tff(pred_def_65192,type,
    v114422: ( state_type * $int ) > $o ).

tff(pred_def_65193,type,
    v114424: ( state_type * $int ) > $o ).

tff(pred_def_65194,type,
    v113950: ( state_type * $int ) > $o ).

tff(pred_def_65195,type,
    v113948: ( state_type * $int ) > $o ).

tff(pred_def_65196,type,
    v113946: ( state_type * $int ) > $o ).

tff(pred_def_65197,type,
    v113944: ( state_type * $int ) > $o ).

tff(pred_def_65198,type,
    v112914: ( state_type * $int ) > $o ).

tff(pred_def_65199,type,
    v114444: state_type > $o ).

tff(pred_def_65200,type,
    v114443: state_type > $o ).

tff(pred_def_65201,type,
    v114442: state_type > $o ).

tff(pred_def_65202,type,
    v114445: state_type > $o ).

tff(pred_def_65203,type,
    v114441: state_type > $o ).

tff(pred_def_65204,type,
    v114440: state_type > $o ).

tff(pred_def_65205,type,
    v114446: state_type > $o ).

tff(pred_def_65206,type,
    v114439: state_type > $o ).

tff(pred_def_65207,type,
    v114438: state_type > $o ).

tff(pred_def_65208,type,
    v114437: state_type > $o ).

tff(pred_def_65209,type,
    v114436: state_type > $o ).

tff(pred_def_65210,type,
    v114448: state_type > $o ).

tff(pred_def_65211,type,
    v114447: state_type > $o ).

tff(pred_def_65212,type,
    v114435: state_type > $o ).

tff(pred_def_65213,type,
    v114451: state_type > $o ).

tff(pred_def_65214,type,
    v114450: state_type > $o ).

tff(pred_def_65215,type,
    v114452: state_type > $o ).

tff(pred_def_65216,type,
    v114449: state_type > $o ).

tff(pred_def_65217,type,
    v114455: state_type > $o ).

tff(pred_def_65218,type,
    v114454: state_type > $o ).

tff(pred_def_65219,type,
    v114456: state_type > $o ).

tff(pred_def_65220,type,
    v114453: state_type > $o ).

tff(pred_def_65221,type,
    v114459: state_type > $o ).

tff(pred_def_65222,type,
    v114458: state_type > $o ).

tff(pred_def_65223,type,
    v114460: state_type > $o ).

tff(pred_def_65224,type,
    v114457: state_type > $o ).

tff(pred_def_65225,type,
    v114433: ( state_type * $int ) > $o ).

tff(pred_def_65226,type,
    v112912: state_type > $o ).

tff(pred_def_65227,type,
    v114432: ( state_type * $int ) > $o ).

tff(pred_def_65228,type,
    v114431: ( state_type * $int ) > $o ).

tff(pred_def_65229,type,
    v112934: ( state_type * $int ) > $o ).

tff(pred_def_65230,type,
    v112932: ( state_type * $int ) > $o ).

tff(pred_def_65231,type,
    v112930: ( state_type * $int ) > $o ).

tff(pred_def_65232,type,
    v112928: ( state_type * $int ) > $o ).

tff(pred_def_65233,type,
    v114464: state_type > $o ).

tff(pred_def_65234,type,
    v114462: state_type > $o ).

tff(pred_def_65235,type,
    v114471: state_type > $o ).

tff(pred_def_65236,type,
    v114469: state_type > $o ).

tff(pred_def_65237,type,
    v114468: state_type > $o ).

tff(pred_def_65238,type,
    v114467: state_type > $o ).

tff(pred_def_65239,type,
    v114479: state_type > $o ).

tff(pred_def_65240,type,
    v114480: state_type > $o ).

tff(pred_def_65241,type,
    v114478: state_type > $o ).

tff(pred_def_65242,type,
    v114475: ( state_type * $int ) > $o ).

tff(pred_def_65243,type,
    v114477: ( state_type * $int ) > $o ).

tff(pred_def_65244,type,
    v112918: ( state_type * $int ) > $o ).

tff(pred_def_65245,type,
    v112916: ( state_type * $int ) > $o ).

tff(pred_def_65246,type,
    v114485: state_type > $o ).

tff(pred_def_65247,type,
    v112755: state_type > $o ).

tff(pred_def_65248,type,
    v114501: state_type > $o ).

tff(pred_def_65249,type,
    v114499: state_type > $o ).

tff(pred_def_65250,type,
    v114497: state_type > $o ).

tff(pred_def_65251,type,
    v114495: state_type > $o ).

tff(pred_def_65252,type,
    v114509: state_type > $o ).

tff(pred_def_65253,type,
    v114507: state_type > $o ).

tff(pred_def_65254,type,
    v114505: state_type > $o ).

tff(pred_def_65255,type,
    v114503: state_type > $o ).

tff(pred_def_65256,type,
    v114529: state_type > $o ).

tff(pred_def_65257,type,
    v114527: state_type > $o ).

tff(pred_def_65258,type,
    v114533: state_type > $o ).

tff(pred_def_65259,type,
    v114531: state_type > $o ).

tff(pred_def_65260,type,
    v114543: state_type > $o ).

tff(pred_def_65261,type,
    v85774: state_type > $o ).

tff(pred_def_65262,type,
    v114556: state_type > $o ).

tff(pred_def_65263,type,
    v114555: ( state_type * $int ) > $o ).

tff(pred_def_65264,type,
    v114558: state_type > $o ).

tff(pred_def_65265,type,
    v114559: state_type > $o ).

tff(pred_def_65266,type,
    v114560: state_type > $o ).

tff(pred_def_65267,type,
    v114561: state_type > $o ).

tff(pred_def_65268,type,
    v114562: state_type > $o ).

tff(pred_def_65269,type,
    v114563: state_type > $o ).

tff(pred_def_65270,type,
    v114564: state_type > $o ).

tff(pred_def_65271,type,
    v114565: state_type > $o ).

tff(pred_def_65272,type,
    v114566: state_type > $o ).

tff(pred_def_65273,type,
    v114567: state_type > $o ).

tff(pred_def_65274,type,
    v114568: state_type > $o ).

tff(pred_def_65275,type,
    v114569: state_type > $o ).

tff(pred_def_65276,type,
    v114570: state_type > $o ).

tff(pred_def_65277,type,
    v114571: state_type > $o ).

tff(pred_def_65278,type,
    v114572: state_type > $o ).

tff(pred_def_65279,type,
    v114573: state_type > $o ).

tff(pred_def_65280,type,
    v114557: ( state_type * $int ) > $o ).

tff(pred_def_65281,type,
    v114554: ( state_type * $int ) > $o ).

tff(pred_def_65282,type,
    v114553: ( state_type * $int ) > $o ).

tff(pred_def_65283,type,
    v114551: ( state_type * $int ) > $o ).

tff(pred_def_65284,type,
    v114549: ( state_type * $int ) > $o ).

tff(pred_def_65285,type,
    v114547: state_type > $o ).

tff(pred_def_65286,type,
    v114584: state_type > $o ).

tff(pred_def_65287,type,
    v114583: ( state_type * $int ) > $o ).

tff(pred_def_65288,type,
    v114586: state_type > $o ).

tff(pred_def_65289,type,
    v114587: state_type > $o ).

tff(pred_def_65290,type,
    v114588: state_type > $o ).

tff(pred_def_65291,type,
    v114589: state_type > $o ).

tff(pred_def_65292,type,
    v114590: state_type > $o ).

tff(pred_def_65293,type,
    v114591: state_type > $o ).

tff(pred_def_65294,type,
    v114592: state_type > $o ).

tff(pred_def_65295,type,
    v114593: state_type > $o ).

tff(pred_def_65296,type,
    v114594: state_type > $o ).

tff(pred_def_65297,type,
    v114595: state_type > $o ).

tff(pred_def_65298,type,
    v114596: state_type > $o ).

tff(pred_def_65299,type,
    v114597: state_type > $o ).

tff(pred_def_65300,type,
    v114598: state_type > $o ).

tff(pred_def_65301,type,
    v114599: state_type > $o ).

tff(pred_def_65302,type,
    v114600: state_type > $o ).

tff(pred_def_65303,type,
    v114601: state_type > $o ).

tff(pred_def_65304,type,
    v114585: ( state_type * $int ) > $o ).

tff(pred_def_65305,type,
    v114582: ( state_type * $int ) > $o ).

tff(pred_def_65306,type,
    v114581: ( state_type * $int ) > $o ).

tff(pred_def_65307,type,
    v114579: ( state_type * $int ) > $o ).

tff(pred_def_65308,type,
    v114577: ( state_type * $int ) > $o ).

tff(pred_def_65309,type,
    v114575: state_type > $o ).

tff(pred_def_65310,type,
    v114612: state_type > $o ).

tff(pred_def_65311,type,
    v114611: ( state_type * $int ) > $o ).

tff(pred_def_65312,type,
    v114614: state_type > $o ).

tff(pred_def_65313,type,
    v114615: state_type > $o ).

tff(pred_def_65314,type,
    v114616: state_type > $o ).

tff(pred_def_65315,type,
    v114617: state_type > $o ).

tff(pred_def_65316,type,
    v114618: state_type > $o ).

tff(pred_def_65317,type,
    v114619: state_type > $o ).

tff(pred_def_65318,type,
    v114620: state_type > $o ).

tff(pred_def_65319,type,
    v114621: state_type > $o ).

tff(pred_def_65320,type,
    v114622: state_type > $o ).

tff(pred_def_65321,type,
    v114623: state_type > $o ).

tff(pred_def_65322,type,
    v114624: state_type > $o ).

tff(pred_def_65323,type,
    v114625: state_type > $o ).

tff(pred_def_65324,type,
    v114626: state_type > $o ).

tff(pred_def_65325,type,
    v114627: state_type > $o ).

tff(pred_def_65326,type,
    v114628: state_type > $o ).

tff(pred_def_65327,type,
    v114629: state_type > $o ).

tff(pred_def_65328,type,
    v114613: ( state_type * $int ) > $o ).

tff(pred_def_65329,type,
    v114610: ( state_type * $int ) > $o ).

tff(pred_def_65330,type,
    v114609: ( state_type * $int ) > $o ).

tff(pred_def_65331,type,
    v114607: ( state_type * $int ) > $o ).

tff(pred_def_65332,type,
    v114605: ( state_type * $int ) > $o ).

tff(pred_def_65333,type,
    v114603: state_type > $o ).

tff(pred_def_65334,type,
    v114640: state_type > $o ).

tff(pred_def_65335,type,
    v114639: ( state_type * $int ) > $o ).

tff(pred_def_65336,type,
    v114642: state_type > $o ).

tff(pred_def_65337,type,
    v114643: state_type > $o ).

tff(pred_def_65338,type,
    v114644: state_type > $o ).

tff(pred_def_65339,type,
    v114645: state_type > $o ).

tff(pred_def_65340,type,
    v114646: state_type > $o ).

tff(pred_def_65341,type,
    v114647: state_type > $o ).

tff(pred_def_65342,type,
    v114648: state_type > $o ).

tff(pred_def_65343,type,
    v114649: state_type > $o ).

tff(pred_def_65344,type,
    v114650: state_type > $o ).

tff(pred_def_65345,type,
    v114651: state_type > $o ).

tff(pred_def_65346,type,
    v114652: state_type > $o ).

tff(pred_def_65347,type,
    v114653: state_type > $o ).

tff(pred_def_65348,type,
    v114654: state_type > $o ).

tff(pred_def_65349,type,
    v114655: state_type > $o ).

tff(pred_def_65350,type,
    v114656: state_type > $o ).

tff(pred_def_65351,type,
    v114657: state_type > $o ).

tff(pred_def_65352,type,
    v114641: ( state_type * $int ) > $o ).

tff(pred_def_65353,type,
    v114638: ( state_type * $int ) > $o ).

tff(pred_def_65354,type,
    v114637: ( state_type * $int ) > $o ).

tff(pred_def_65355,type,
    v114635: ( state_type * $int ) > $o ).

tff(pred_def_65356,type,
    v114633: ( state_type * $int ) > $o ).

tff(pred_def_65357,type,
    v114631: state_type > $o ).

tff(pred_def_65358,type,
    v114664: state_type > $o ).

tff(pred_def_65359,type,
    v5747: state_type > $o ).

tff(pred_def_65360,type,
    v114663: ( state_type * $int ) > $o ).

tff(pred_def_65361,type,
    v114666: state_type > $o ).

tff(pred_def_65362,type,
    v114667: state_type > $o ).

tff(pred_def_65363,type,
    v114668: state_type > $o ).

tff(pred_def_65364,type,
    v114669: state_type > $o ).

tff(pred_def_65365,type,
    v114670: state_type > $o ).

tff(pred_def_65366,type,
    v114671: state_type > $o ).

tff(pred_def_65367,type,
    v114672: state_type > $o ).

tff(pred_def_65368,type,
    v114673: state_type > $o ).

tff(pred_def_65369,type,
    v114674: state_type > $o ).

tff(pred_def_65370,type,
    v114675: state_type > $o ).

tff(pred_def_65371,type,
    v114676: state_type > $o ).

tff(pred_def_65372,type,
    v114677: state_type > $o ).

tff(pred_def_65373,type,
    v114678: state_type > $o ).

tff(pred_def_65374,type,
    v114679: state_type > $o ).

tff(pred_def_65375,type,
    v114680: state_type > $o ).

tff(pred_def_65376,type,
    v114681: state_type > $o ).

tff(pred_def_65377,type,
    v114665: ( state_type * $int ) > $o ).

tff(pred_def_65378,type,
    v114662: ( state_type * $int ) > $o ).

tff(pred_def_65379,type,
    v114661: ( state_type * $int ) > $o ).

tff(pred_def_65380,type,
    v114659: state_type > $o ).

tff(pred_def_65381,type,
    v114688: state_type > $o ).

tff(pred_def_65382,type,
    v86711: state_type > $o ).

tff(pred_def_65383,type,
    v114687: ( state_type * $int ) > $o ).

tff(pred_def_65384,type,
    v114686: ( state_type * $int ) > $o ).

tff(pred_def_65385,type,
    v114685: ( state_type * $int ) > $o ).

tff(pred_def_65386,type,
    v114683: state_type > $o ).

tff(pred_def_65387,type,
    v114701: state_type > $o ).

tff(pred_def_65388,type,
    v114700: state_type > $o ).

tff(pred_def_65389,type,
    v114699: state_type > $o ).

tff(pred_def_65390,type,
    v114698: ( state_type * $int ) > $o ).

tff(pred_def_65391,type,
    v114697: ( state_type * $int ) > $o ).

tff(pred_def_65392,type,
    v114696: ( state_type * $int ) > $o ).

tff(pred_def_65393,type,
    v114694: ( state_type * $int ) > $o ).

tff(pred_def_65394,type,
    v114692: ( state_type * $int ) > $o ).

tff(pred_def_65395,type,
    v114690: state_type > $o ).

tff(pred_def_65396,type,
    v114750: ( state_type * $int ) > $o ).

tff(pred_def_65397,type,
    v114751: ( state_type * $int ) > $o ).

tff(pred_def_65398,type,
    v114749: state_type > $o ).

tff(pred_def_65399,type,
    v114754: state_type > $o ).

tff(pred_def_65400,type,
    v114755: state_type > $o ).

tff(pred_def_65401,type,
    v114753: state_type > $o ).

tff(pred_def_65402,type,
    v114756: state_type > $o ).

tff(pred_def_65403,type,
    v114752: state_type > $o ).

tff(pred_def_65404,type,
    v114748: state_type > $o ).

tff(pred_def_65405,type,
    v114757: state_type > $o ).

tff(pred_def_65406,type,
    v114747: state_type > $o ).

tff(pred_def_65407,type,
    v114746: state_type > $o ).

tff(pred_def_65408,type,
    v114761: state_type > $o ).

tff(pred_def_65409,type,
    v114762: state_type > $o ).

tff(pred_def_65410,type,
    v114760: state_type > $o ).

tff(pred_def_65411,type,
    v114763: state_type > $o ).

tff(pred_def_65412,type,
    v114759: state_type > $o ).

tff(pred_def_65413,type,
    v114758: state_type > $o ).

tff(pred_def_65414,type,
    v114745: state_type > $o ).

tff(pred_def_65415,type,
    v114764: state_type > $o ).

tff(pred_def_65416,type,
    v114744: state_type > $o ).

tff(pred_def_65417,type,
    v114767: state_type > $o ).

tff(pred_def_65418,type,
    v114768: state_type > $o ).

tff(pred_def_65419,type,
    v114766: state_type > $o ).

tff(pred_def_65420,type,
    v114769: state_type > $o ).

tff(pred_def_65421,type,
    v114765: state_type > $o ).

tff(pred_def_65422,type,
    v114772: state_type > $o ).

tff(pred_def_65423,type,
    v114773: state_type > $o ).

tff(pred_def_65424,type,
    v114771: state_type > $o ).

tff(pred_def_65425,type,
    v114774: state_type > $o ).

tff(pred_def_65426,type,
    v114770: state_type > $o ).

tff(pred_def_65427,type,
    v114742: ( state_type * $int ) > $o ).

tff(pred_def_65428,type,
    v114775: ( state_type * $int ) > $o ).

tff(pred_def_65429,type,
    v114741: state_type > $o ).

tff(pred_def_65430,type,
    v114778: state_type > $o ).

tff(pred_def_65431,type,
    v114779: state_type > $o ).

tff(pred_def_65432,type,
    v114777: state_type > $o ).

tff(pred_def_65433,type,
    v114780: state_type > $o ).

tff(pred_def_65434,type,
    v114776: state_type > $o ).

tff(pred_def_65435,type,
    v114740: state_type > $o ).

tff(pred_def_65436,type,
    v114781: state_type > $o ).

tff(pred_def_65437,type,
    v114739: state_type > $o ).

tff(pred_def_65438,type,
    v114738: state_type > $o ).

tff(pred_def_65439,type,
    v114785: state_type > $o ).

tff(pred_def_65440,type,
    v114786: state_type > $o ).

tff(pred_def_65441,type,
    v114784: state_type > $o ).

tff(pred_def_65442,type,
    v114787: state_type > $o ).

tff(pred_def_65443,type,
    v114783: state_type > $o ).

tff(pred_def_65444,type,
    v114782: state_type > $o ).

tff(pred_def_65445,type,
    v114737: state_type > $o ).

tff(pred_def_65446,type,
    v114788: state_type > $o ).

tff(pred_def_65447,type,
    v114736: state_type > $o ).

tff(pred_def_65448,type,
    v114791: state_type > $o ).

tff(pred_def_65449,type,
    v114792: state_type > $o ).

tff(pred_def_65450,type,
    v114790: state_type > $o ).

tff(pred_def_65451,type,
    v114793: state_type > $o ).

tff(pred_def_65452,type,
    v114789: state_type > $o ).

tff(pred_def_65453,type,
    v114796: state_type > $o ).

tff(pred_def_65454,type,
    v114797: state_type > $o ).

tff(pred_def_65455,type,
    v114795: state_type > $o ).

tff(pred_def_65456,type,
    v114798: state_type > $o ).

tff(pred_def_65457,type,
    v114794: state_type > $o ).

tff(pred_def_65458,type,
    v114734: ( state_type * $int ) > $o ).

tff(pred_def_65459,type,
    v114799: ( state_type * $int ) > $o ).

tff(pred_def_65460,type,
    v114733: state_type > $o ).

tff(pred_def_65461,type,
    v114802: state_type > $o ).

tff(pred_def_65462,type,
    v114803: state_type > $o ).

tff(pred_def_65463,type,
    v114801: state_type > $o ).

tff(pred_def_65464,type,
    v114804: state_type > $o ).

tff(pred_def_65465,type,
    v114800: state_type > $o ).

tff(pred_def_65466,type,
    v114732: state_type > $o ).

tff(pred_def_65467,type,
    v114805: state_type > $o ).

tff(pred_def_65468,type,
    v114731: state_type > $o ).

tff(pred_def_65469,type,
    v114730: state_type > $o ).

tff(pred_def_65470,type,
    v114809: state_type > $o ).

tff(pred_def_65471,type,
    v114810: state_type > $o ).

tff(pred_def_65472,type,
    v114808: state_type > $o ).

tff(pred_def_65473,type,
    v114811: state_type > $o ).

tff(pred_def_65474,type,
    v114807: state_type > $o ).

tff(pred_def_65475,type,
    v114806: state_type > $o ).

tff(pred_def_65476,type,
    v114729: state_type > $o ).

tff(pred_def_65477,type,
    v114812: state_type > $o ).

tff(pred_def_65478,type,
    v114728: state_type > $o ).

tff(pred_def_65479,type,
    v114815: state_type > $o ).

tff(pred_def_65480,type,
    v114816: state_type > $o ).

tff(pred_def_65481,type,
    v114814: state_type > $o ).

tff(pred_def_65482,type,
    v114817: state_type > $o ).

tff(pred_def_65483,type,
    v114813: state_type > $o ).

tff(pred_def_65484,type,
    v114820: state_type > $o ).

tff(pred_def_65485,type,
    v114821: state_type > $o ).

tff(pred_def_65486,type,
    v114819: state_type > $o ).

tff(pred_def_65487,type,
    v114822: state_type > $o ).

tff(pred_def_65488,type,
    v114818: state_type > $o ).

tff(pred_def_65489,type,
    v114726: ( state_type * $int ) > $o ).

tff(pred_def_65490,type,
    v114823: ( state_type * $int ) > $o ).

tff(pred_def_65491,type,
    v114725: state_type > $o ).

tff(pred_def_65492,type,
    v114826: state_type > $o ).

tff(pred_def_65493,type,
    v114827: state_type > $o ).

tff(pred_def_65494,type,
    v114825: state_type > $o ).

tff(pred_def_65495,type,
    v114828: state_type > $o ).

tff(pred_def_65496,type,
    v114824: state_type > $o ).

tff(pred_def_65497,type,
    v114724: state_type > $o ).

tff(pred_def_65498,type,
    v114829: state_type > $o ).

tff(pred_def_65499,type,
    v114723: state_type > $o ).

tff(pred_def_65500,type,
    v114722: state_type > $o ).

tff(pred_def_65501,type,
    v114833: state_type > $o ).

tff(pred_def_65502,type,
    v114834: state_type > $o ).

tff(pred_def_65503,type,
    v114832: state_type > $o ).

tff(pred_def_65504,type,
    v114835: state_type > $o ).

tff(pred_def_65505,type,
    v114831: state_type > $o ).

tff(pred_def_65506,type,
    v114830: state_type > $o ).

tff(pred_def_65507,type,
    v114721: state_type > $o ).

tff(pred_def_65508,type,
    v114836: state_type > $o ).

tff(pred_def_65509,type,
    v114720: state_type > $o ).

tff(pred_def_65510,type,
    v114839: state_type > $o ).

tff(pred_def_65511,type,
    v114840: state_type > $o ).

tff(pred_def_65512,type,
    v114838: state_type > $o ).

tff(pred_def_65513,type,
    v114841: state_type > $o ).

tff(pred_def_65514,type,
    v114837: state_type > $o ).

tff(pred_def_65515,type,
    v114844: state_type > $o ).

tff(pred_def_65516,type,
    v114845: state_type > $o ).

tff(pred_def_65517,type,
    v114843: state_type > $o ).

tff(pred_def_65518,type,
    v114846: state_type > $o ).

tff(pred_def_65519,type,
    v114842: state_type > $o ).

tff(pred_def_65520,type,
    v114718: ( state_type * $int ) > $o ).

tff(pred_def_65521,type,
    v114847: ( state_type * $int ) > $o ).

tff(pred_def_65522,type,
    v114717: state_type > $o ).

tff(pred_def_65523,type,
    v114850: state_type > $o ).

tff(pred_def_65524,type,
    v114851: state_type > $o ).

tff(pred_def_65525,type,
    v114849: state_type > $o ).

tff(pred_def_65526,type,
    v114852: state_type > $o ).

tff(pred_def_65527,type,
    v114848: state_type > $o ).

tff(pred_def_65528,type,
    v114716: state_type > $o ).

tff(pred_def_65529,type,
    v114853: state_type > $o ).

tff(pred_def_65530,type,
    v114715: state_type > $o ).

tff(pred_def_65531,type,
    v114714: state_type > $o ).

tff(pred_def_65532,type,
    v114857: state_type > $o ).

tff(pred_def_65533,type,
    v114858: state_type > $o ).

tff(pred_def_65534,type,
    v114856: state_type > $o ).

tff(pred_def_65535,type,
    v114859: state_type > $o ).

tff(pred_def_65536,type,
    v114855: state_type > $o ).

tff(pred_def_65537,type,
    v114854: state_type > $o ).

tff(pred_def_65538,type,
    v114713: state_type > $o ).

tff(pred_def_65539,type,
    v114860: state_type > $o ).

tff(pred_def_65540,type,
    v114712: state_type > $o ).

tff(pred_def_65541,type,
    v114863: state_type > $o ).

tff(pred_def_65542,type,
    v114864: state_type > $o ).

tff(pred_def_65543,type,
    v114862: state_type > $o ).

tff(pred_def_65544,type,
    v114865: state_type > $o ).

tff(pred_def_65545,type,
    v114861: state_type > $o ).

tff(pred_def_65546,type,
    v114868: state_type > $o ).

tff(pred_def_65547,type,
    v114869: state_type > $o ).

tff(pred_def_65548,type,
    v114867: state_type > $o ).

tff(pred_def_65549,type,
    v114870: state_type > $o ).

tff(pred_def_65550,type,
    v114866: state_type > $o ).

tff(pred_def_65551,type,
    v114710: ( state_type * $int ) > $o ).

tff(pred_def_65552,type,
    v114871: ( state_type * $int ) > $o ).

tff(pred_def_65553,type,
    v114709: state_type > $o ).

tff(pred_def_65554,type,
    v114874: state_type > $o ).

tff(pred_def_65555,type,
    v114875: state_type > $o ).

tff(pred_def_65556,type,
    v114873: state_type > $o ).

tff(pred_def_65557,type,
    v114876: state_type > $o ).

tff(pred_def_65558,type,
    v114872: state_type > $o ).

tff(pred_def_65559,type,
    v114708: state_type > $o ).

tff(pred_def_65560,type,
    v114877: state_type > $o ).

tff(pred_def_65561,type,
    v114707: state_type > $o ).

tff(pred_def_65562,type,
    v114706: state_type > $o ).

tff(pred_def_65563,type,
    v114881: state_type > $o ).

tff(pred_def_65564,type,
    v114882: state_type > $o ).

tff(pred_def_65565,type,
    v114880: state_type > $o ).

tff(pred_def_65566,type,
    v114883: state_type > $o ).

tff(pred_def_65567,type,
    v114879: state_type > $o ).

tff(pred_def_65568,type,
    v114878: state_type > $o ).

tff(pred_def_65569,type,
    v114705: state_type > $o ).

tff(pred_def_65570,type,
    v114884: state_type > $o ).

tff(pred_def_65571,type,
    v114704: state_type > $o ).

tff(pred_def_65572,type,
    v114887: state_type > $o ).

tff(pred_def_65573,type,
    v114888: state_type > $o ).

tff(pred_def_65574,type,
    v114886: state_type > $o ).

tff(pred_def_65575,type,
    v114889: state_type > $o ).

tff(pred_def_65576,type,
    v114885: state_type > $o ).

tff(pred_def_65577,type,
    v114892: state_type > $o ).

tff(pred_def_65578,type,
    v114893: state_type > $o ).

tff(pred_def_65579,type,
    v114891: state_type > $o ).

tff(pred_def_65580,type,
    v114894: state_type > $o ).

tff(pred_def_65581,type,
    v114890: state_type > $o ).

tff(pred_def_65582,type,
    v114702: ( state_type * $int ) > $o ).

tff(pred_def_65583,type,
    v114545: ( state_type * $int ) > $o ).

tff(pred_def_65584,type,
    v114904: state_type > $o ).

tff(pred_def_65585,type,
    v114902: state_type > $o ).

tff(pred_def_65586,type,
    v114901: state_type > $o ).

tff(pred_def_65587,type,
    v114900: ( state_type * $int ) > $o ).

tff(pred_def_65588,type,
    v114898: state_type > $o ).

tff(pred_def_65589,type,
    v114914: state_type > $o ).

tff(pred_def_65590,type,
    v114912: state_type > $o ).

tff(pred_def_65591,type,
    v114911: state_type > $o ).

tff(pred_def_65592,type,
    v114910: ( state_type * $int ) > $o ).

tff(pred_def_65593,type,
    v114908: state_type > $o ).

tff(pred_def_65594,type,
    v114924: state_type > $o ).

tff(pred_def_65595,type,
    v114922: state_type > $o ).

tff(pred_def_65596,type,
    v114921: state_type > $o ).

tff(pred_def_65597,type,
    v114920: ( state_type * $int ) > $o ).

tff(pred_def_65598,type,
    v114918: state_type > $o ).

tff(pred_def_65599,type,
    v114928: state_type > $o ).

tff(pred_def_65600,type,
    v114930: state_type > $o ).

tff(pred_def_65601,type,
    v114932: state_type > $o ).

tff(pred_def_65602,type,
    v114938: state_type > $o ).

tff(pred_def_65603,type,
    v114937: state_type > $o ).

tff(pred_def_65604,type,
    v114936: state_type > $o ).

tff(pred_def_65605,type,
    v114935: state_type > $o ).

tff(pred_def_65606,type,
    v114934: state_type > $o ).

tff(pred_def_65607,type,
    v114933: ( state_type * $int ) > $o ).

tff(pred_def_65608,type,
    v114896: ( state_type * $int ) > $o ).

tff(pred_def_65609,type,
    v114942: state_type > $o ).

tff(pred_def_65610,type,
    v114941: state_type > $o ).

tff(pred_def_65611,type,
    v114940: ( state_type * $int ) > $o ).

tff(pred_def_65612,type,
    v114971: ( state_type * $int ) > $o ).

tff(pred_def_65613,type,
    v114521: ( state_type * $int ) > $o ).

tff(pred_def_65614,type,
    v114970: state_type > $o ).

tff(pred_def_65615,type,
    v114974: state_type > $o ).

tff(pred_def_65616,type,
    v114975: state_type > $o ).

tff(pred_def_65617,type,
    v114973: state_type > $o ).

tff(pred_def_65618,type,
    v114976: state_type > $o ).

tff(pred_def_65619,type,
    v114972: state_type > $o ).

tff(pred_def_65620,type,
    v114969: state_type > $o ).

tff(pred_def_65621,type,
    v114977: state_type > $o ).

tff(pred_def_65622,type,
    v114968: state_type > $o ).

tff(pred_def_65623,type,
    v114980: state_type > $o ).

tff(pred_def_65624,type,
    v114981: state_type > $o ).

tff(pred_def_65625,type,
    v114979: state_type > $o ).

tff(pred_def_65626,type,
    v114982: state_type > $o ).

tff(pred_def_65627,type,
    v114978: state_type > $o ).

tff(pred_def_65628,type,
    v114967: state_type > $o ).

tff(pred_def_65629,type,
    v114983: state_type > $o ).

tff(pred_def_65630,type,
    v114966: state_type > $o ).

tff(pred_def_65631,type,
    v114986: state_type > $o ).

tff(pred_def_65632,type,
    v114987: state_type > $o ).

tff(pred_def_65633,type,
    v114985: state_type > $o ).

tff(pred_def_65634,type,
    v114988: state_type > $o ).

tff(pred_def_65635,type,
    v114984: state_type > $o ).

tff(pred_def_65636,type,
    v114965: state_type > $o ).

tff(pred_def_65637,type,
    v114989: state_type > $o ).

tff(pred_def_65638,type,
    v114964: state_type > $o ).

tff(pred_def_65639,type,
    v114992: state_type > $o ).

tff(pred_def_65640,type,
    v114993: state_type > $o ).

tff(pred_def_65641,type,
    v114991: state_type > $o ).

tff(pred_def_65642,type,
    v114994: state_type > $o ).

tff(pred_def_65643,type,
    v114990: state_type > $o ).

tff(pred_def_65644,type,
    v114963: state_type > $o ).

tff(pred_def_65645,type,
    v114995: state_type > $o ).

tff(pred_def_65646,type,
    v114962: state_type > $o ).

tff(pred_def_65647,type,
    v114961: state_type > $o ).

tff(pred_def_65648,type,
    v114999: state_type > $o ).

tff(pred_def_65649,type,
    v115000: state_type > $o ).

tff(pred_def_65650,type,
    v114998: state_type > $o ).

tff(pred_def_65651,type,
    v115001: state_type > $o ).

tff(pred_def_65652,type,
    v114997: state_type > $o ).

tff(pred_def_65653,type,
    v114996: state_type > $o ).

tff(pred_def_65654,type,
    v114960: state_type > $o ).

tff(pred_def_65655,type,
    v115002: state_type > $o ).

tff(pred_def_65656,type,
    v114959: state_type > $o ).

tff(pred_def_65657,type,
    v115005: state_type > $o ).

tff(pred_def_65658,type,
    v115006: state_type > $o ).

tff(pred_def_65659,type,
    v115004: state_type > $o ).

tff(pred_def_65660,type,
    v115007: state_type > $o ).

tff(pred_def_65661,type,
    v115003: state_type > $o ).

tff(pred_def_65662,type,
    v115010: state_type > $o ).

tff(pred_def_65663,type,
    v115011: state_type > $o ).

tff(pred_def_65664,type,
    v115009: state_type > $o ).

tff(pred_def_65665,type,
    v115012: state_type > $o ).

tff(pred_def_65666,type,
    v115008: state_type > $o ).

tff(pred_def_65667,type,
    v115015: state_type > $o ).

tff(pred_def_65668,type,
    v115016: state_type > $o ).

tff(pred_def_65669,type,
    v115014: state_type > $o ).

tff(pred_def_65670,type,
    v115017: state_type > $o ).

tff(pred_def_65671,type,
    v115013: state_type > $o ).

tff(pred_def_65672,type,
    v115020: state_type > $o ).

tff(pred_def_65673,type,
    v115021: state_type > $o ).

tff(pred_def_65674,type,
    v115019: state_type > $o ).

tff(pred_def_65675,type,
    v115022: state_type > $o ).

tff(pred_def_65676,type,
    v115018: state_type > $o ).

tff(pred_def_65677,type,
    v115025: state_type > $o ).

tff(pred_def_65678,type,
    v115026: state_type > $o ).

tff(pred_def_65679,type,
    v115024: state_type > $o ).

tff(pred_def_65680,type,
    v115027: state_type > $o ).

tff(pred_def_65681,type,
    v115023: state_type > $o ).

tff(pred_def_65682,type,
    v114957: ( state_type * $int ) > $o ).

tff(pred_def_65683,type,
    v114956: state_type > $o ).

tff(pred_def_65684,type,
    v115032: state_type > $o ).

tff(pred_def_65685,type,
    v115034: state_type > $o ).

tff(pred_def_65686,type,
    v115035: state_type > $o ).

tff(pred_def_65687,type,
    v115033: state_type > $o ).

tff(pred_def_65688,type,
    v115031: state_type > $o ).

tff(pred_def_65689,type,
    v115030: state_type > $o ).

tff(pred_def_65690,type,
    v115036: state_type > $o ).

tff(pred_def_65691,type,
    v115029: state_type > $o ).

tff(pred_def_65692,type,
    v115037: state_type > $o ).

tff(pred_def_65693,type,
    v115028: state_type > $o ).

tff(pred_def_65694,type,
    v114955: state_type > $o ).

tff(pred_def_65695,type,
    v115038: state_type > $o ).

tff(pred_def_65696,type,
    v114954: state_type > $o ).

tff(pred_def_65697,type,
    v115045: state_type > $o ).

tff(pred_def_65698,type,
    v115044: state_type > $o ).

tff(pred_def_65699,type,
    v115043: state_type > $o ).

tff(pred_def_65700,type,
    v115047: state_type > $o ).

tff(pred_def_65701,type,
    v115046: state_type > $o ).

tff(pred_def_65702,type,
    v115042: state_type > $o ).

tff(pred_def_65703,type,
    v115041: state_type > $o ).

tff(pred_def_65704,type,
    v115048: state_type > $o ).

tff(pred_def_65705,type,
    v115040: state_type > $o ).

tff(pred_def_65706,type,
    v115049: state_type > $o ).

tff(pred_def_65707,type,
    v115039: state_type > $o ).

tff(pred_def_65708,type,
    v114953: state_type > $o ).

tff(pred_def_65709,type,
    v115050: state_type > $o ).

tff(pred_def_65710,type,
    v114952: state_type > $o ).

tff(pred_def_65711,type,
    v115057: state_type > $o ).

tff(pred_def_65712,type,
    v115056: state_type > $o ).

tff(pred_def_65713,type,
    v115055: state_type > $o ).

tff(pred_def_65714,type,
    v115059: state_type > $o ).

tff(pred_def_65715,type,
    v115058: state_type > $o ).

tff(pred_def_65716,type,
    v115054: state_type > $o ).

tff(pred_def_65717,type,
    v115053: state_type > $o ).

tff(pred_def_65718,type,
    v115060: state_type > $o ).

tff(pred_def_65719,type,
    v115052: state_type > $o ).

tff(pred_def_65720,type,
    v115061: state_type > $o ).

tff(pred_def_65721,type,
    v115051: state_type > $o ).

tff(pred_def_65722,type,
    v114951: state_type > $o ).

tff(pred_def_65723,type,
    v115062: state_type > $o ).

tff(pred_def_65724,type,
    v114950: state_type > $o ).

tff(pred_def_65725,type,
    v115069: state_type > $o ).

tff(pred_def_65726,type,
    v115068: state_type > $o ).

tff(pred_def_65727,type,
    v115067: state_type > $o ).

tff(pred_def_65728,type,
    v115071: state_type > $o ).

tff(pred_def_65729,type,
    v115070: state_type > $o ).

tff(pred_def_65730,type,
    v115066: state_type > $o ).

tff(pred_def_65731,type,
    v115065: state_type > $o ).

tff(pred_def_65732,type,
    v115072: state_type > $o ).

tff(pred_def_65733,type,
    v115064: state_type > $o ).

tff(pred_def_65734,type,
    v115073: state_type > $o ).

tff(pred_def_65735,type,
    v115063: state_type > $o ).

tff(pred_def_65736,type,
    v114949: state_type > $o ).

tff(pred_def_65737,type,
    v115074: state_type > $o ).

tff(pred_def_65738,type,
    v114948: state_type > $o ).

tff(pred_def_65739,type,
    v114947: state_type > $o ).

tff(pred_def_65740,type,
    v115082: state_type > $o ).

tff(pred_def_65741,type,
    v115081: state_type > $o ).

tff(pred_def_65742,type,
    v115080: state_type > $o ).

tff(pred_def_65743,type,
    v115084: state_type > $o ).

tff(pred_def_65744,type,
    v115083: state_type > $o ).

tff(pred_def_65745,type,
    v115079: state_type > $o ).

tff(pred_def_65746,type,
    v115078: state_type > $o ).

tff(pred_def_65747,type,
    v115085: state_type > $o ).

tff(pred_def_65748,type,
    v115077: state_type > $o ).

tff(pred_def_65749,type,
    v115086: state_type > $o ).

tff(pred_def_65750,type,
    v115076: state_type > $o ).

tff(pred_def_65751,type,
    v115075: state_type > $o ).

tff(pred_def_65752,type,
    v114946: state_type > $o ).

tff(pred_def_65753,type,
    v115087: state_type > $o ).

tff(pred_def_65754,type,
    v114945: state_type > $o ).

tff(pred_def_65755,type,
    v115090: state_type > $o ).

tff(pred_def_65756,type,
    v115091: state_type > $o ).

tff(pred_def_65757,type,
    v115089: state_type > $o ).

tff(pred_def_65758,type,
    v115092: state_type > $o ).

tff(pred_def_65759,type,
    v115088: state_type > $o ).

tff(pred_def_65760,type,
    v115095: state_type > $o ).

tff(pred_def_65761,type,
    v115096: state_type > $o ).

tff(pred_def_65762,type,
    v115094: state_type > $o ).

tff(pred_def_65763,type,
    v115097: state_type > $o ).

tff(pred_def_65764,type,
    v115093: state_type > $o ).

tff(pred_def_65765,type,
    v115100: state_type > $o ).

tff(pred_def_65766,type,
    v115101: state_type > $o ).

tff(pred_def_65767,type,
    v115099: state_type > $o ).

tff(pred_def_65768,type,
    v115102: state_type > $o ).

tff(pred_def_65769,type,
    v115098: state_type > $o ).

tff(pred_def_65770,type,
    v115105: state_type > $o ).

tff(pred_def_65771,type,
    v115106: state_type > $o ).

tff(pred_def_65772,type,
    v115104: state_type > $o ).

tff(pred_def_65773,type,
    v115107: state_type > $o ).

tff(pred_def_65774,type,
    v115103: state_type > $o ).

tff(pred_def_65775,type,
    v115110: state_type > $o ).

tff(pred_def_65776,type,
    v115109: state_type > $o ).

tff(pred_def_65777,type,
    v115111: state_type > $o ).

tff(pred_def_65778,type,
    v115108: state_type > $o ).

tff(pred_def_65779,type,
    v114943: ( state_type * $int ) > $o ).

tff(pred_def_65780,type,
    v114541: ( state_type * $int ) > $o ).

tff(pred_def_65781,type,
    v114539: ( state_type * $int ) > $o ).

tff(pred_def_65782,type,
    v114537: ( state_type * $int ) > $o ).

tff(pred_def_65783,type,
    v114535: ( state_type * $int ) > $o ).

tff(pred_def_65784,type,
    v115117: state_type > $o ).

tff(pred_def_65785,type,
    v115115: state_type > $o ).

tff(pred_def_65786,type,
    v115113: state_type > $o ).

tff(pred_def_65787,type,
    v115124: state_type > $o ).

tff(pred_def_65788,type,
    v115122: state_type > $o ).

tff(pred_def_65789,type,
    v115121: state_type > $o ).

tff(pred_def_65790,type,
    v115120: state_type > $o ).

tff(pred_def_65791,type,
    v115132: state_type > $o ).

tff(pred_def_65792,type,
    v115133: state_type > $o ).

tff(pred_def_65793,type,
    v115131: state_type > $o ).

tff(pred_def_65794,type,
    v115128: ( state_type * $int ) > $o ).

tff(pred_def_65795,type,
    v115130: ( state_type * $int ) > $o ).

tff(pred_def_65796,type,
    v114525: ( state_type * $int ) > $o ).

tff(pred_def_65797,type,
    v114523: ( state_type * $int ) > $o ).

tff(pred_def_65798,type,
    v115143: state_type > $o ).

tff(pred_def_65799,type,
    v115144: state_type > $o ).

tff(pred_def_65800,type,
    v115145: state_type > $o ).

tff(pred_def_65801,type,
    v115146: state_type > $o ).

tff(pred_def_65802,type,
    v115147: state_type > $o ).

tff(pred_def_65803,type,
    v115148: state_type > $o ).

tff(pred_def_65804,type,
    v115149: state_type > $o ).

tff(pred_def_65805,type,
    v115150: state_type > $o ).

tff(pred_def_65806,type,
    v115151: state_type > $o ).

tff(pred_def_65807,type,
    v115152: state_type > $o ).

tff(pred_def_65808,type,
    v115153: state_type > $o ).

tff(pred_def_65809,type,
    v115154: state_type > $o ).

tff(pred_def_65810,type,
    v115155: state_type > $o ).

tff(pred_def_65811,type,
    v115156: state_type > $o ).

tff(pred_def_65812,type,
    v115157: state_type > $o ).

tff(pred_def_65813,type,
    v115158: state_type > $o ).

tff(pred_def_65814,type,
    v115142: ( state_type * $int ) > $o ).

tff(pred_def_65815,type,
    v115141: ( state_type * $int ) > $o ).

tff(pred_def_65816,type,
    v115165: state_type > $o ).

tff(pred_def_65817,type,
    v115163: state_type > $o ).

tff(pred_def_65818,type,
    v115162: state_type > $o ).

tff(pred_def_65819,type,
    v115161: ( state_type * $int ) > $o ).

tff(pred_def_65820,type,
    v115160: ( state_type * $int ) > $o ).

tff(pred_def_65821,type,
    v115169: state_type > $o ).

tff(pred_def_65822,type,
    v115168: state_type > $o ).

tff(pred_def_65823,type,
    v115167: state_type > $o ).

tff(pred_def_65824,type,
    v115166: ( state_type * $int ) > $o ).

tff(pred_def_65825,type,
    v115159: ( state_type * $int ) > $o ).

tff(pred_def_65826,type,
    v115139: ( state_type * $int ) > $o ).

tff(pred_def_65827,type,
    v115137: state_type > $o ).

tff(pred_def_65828,type,
    v115172: state_type > $o ).

tff(pred_def_65829,type,
    v115173: state_type > $o ).

tff(pred_def_65830,type,
    v114519: state_type > $o ).

tff(pred_def_65831,type,
    v115175: state_type > $o ).

tff(pred_def_65832,type,
    v115177: state_type > $o ).

tff(pred_def_65833,type,
    v112753: ( state_type * $int ) > $o ).

tff(pred_def_65834,type,
    v115201: ( state_type * $int ) > $o ).

tff(pred_def_65835,type,
    v115200: ( state_type * $int ) > $o ).

tff(pred_def_65836,type,
    v115199: ( state_type * $int ) > $o ).

tff(pred_def_65837,type,
    v115198: ( state_type * $int ) > $o ).

tff(pred_def_65838,type,
    v115197: ( state_type * $int ) > $o ).

tff(pred_def_65839,type,
    v115196: ( state_type * $int ) > $o ).

tff(pred_def_65840,type,
    v115195: ( state_type * $int ) > $o ).

tff(pred_def_65841,type,
    v115194: ( state_type * $int ) > $o ).

tff(pred_def_65842,type,
    v115193: ( state_type * $int ) > $o ).

tff(pred_def_65843,type,
    v115192: ( state_type * $int ) > $o ).

tff(pred_def_65844,type,
    v115191: ( state_type * $int ) > $o ).

tff(pred_def_65845,type,
    v115190: ( state_type * $int ) > $o ).

tff(pred_def_65846,type,
    v115189: ( state_type * $int ) > $o ).

tff(pred_def_65847,type,
    v115188: ( state_type * $int ) > $o ).

tff(pred_def_65848,type,
    v115187: ( state_type * $int ) > $o ).

tff(pred_def_65849,type,
    v115186: ( state_type * $int ) > $o ).

tff(pred_def_65850,type,
    v115185: ( state_type * $int ) > $o ).

tff(pred_def_65851,type,
    v115211: state_type > $o ).

tff(pred_def_65852,type,
    v115210: state_type > $o ).

tff(pred_def_65853,type,
    v115212: state_type > $o ).

tff(pred_def_65854,type,
    v115209: state_type > $o ).

tff(pred_def_65855,type,
    v115213: state_type > $o ).

tff(pred_def_65856,type,
    v115208: state_type > $o ).

tff(pred_def_65857,type,
    v115214: state_type > $o ).

tff(pred_def_65858,type,
    v115207: state_type > $o ).

tff(pred_def_65859,type,
    v112751: state_type > $o ).

tff(pred_def_65860,type,
    v115206: state_type > $o ).

tff(pred_def_65861,type,
    v115205: state_type > $o ).

tff(pred_def_65862,type,
    v115204: state_type > $o ).

tff(pred_def_65863,type,
    v115203: ( state_type * $int ) > $o ).

tff(pred_def_65864,type,
    v115202: ( state_type * $int ) > $o ).

tff(pred_def_65865,type,
    v112643: ( state_type * $int ) > $o ).

tff(pred_def_65866,type,
    v115183: state_type > $o ).

tff(pred_def_65867,type,
    v115216: state_type > $o ).

tff(pred_def_65868,type,
    v115226: state_type > $o ).

tff(pred_def_65869,type,
    v115227: state_type > $o ).

tff(pred_def_65870,type,
    v115225: state_type > $o ).

tff(pred_def_65871,type,
    v115229: state_type > $o ).

tff(pred_def_65872,type,
    v115230: state_type > $o ).

tff(pred_def_65873,type,
    v115228: state_type > $o ).

tff(pred_def_65874,type,
    v115224: state_type > $o ).

tff(pred_def_65875,type,
    v115223: state_type > $o ).

tff(pred_def_65876,type,
    v115222: state_type > $o ).

tff(pred_def_65877,type,
    v115221: state_type > $o ).

tff(pred_def_65878,type,
    v114489: ( state_type * $int ) > $o ).

tff(pred_def_65879,type,
    v115231: state_type > $o ).

tff(pred_def_65880,type,
    v115220: state_type > $o ).

tff(pred_def_65881,type,
    v115233: state_type > $o ).

tff(pred_def_65882,type,
    v115232: state_type > $o ).

tff(pred_def_65883,type,
    v115219: state_type > $o ).

tff(pred_def_65884,type,
    v115235: state_type > $o ).

tff(pred_def_65885,type,
    v115241: state_type > $o ).

tff(pred_def_65886,type,
    v115242: state_type > $o ).

tff(pred_def_65887,type,
    v115240: state_type > $o ).

tff(pred_def_65888,type,
    v115239: state_type > $o ).

tff(pred_def_65889,type,
    v115245: state_type > $o ).

tff(pred_def_65890,type,
    v115244: state_type > $o ).

tff(pred_def_65891,type,
    v115243: state_type > $o ).

tff(pred_def_65892,type,
    v115238: state_type > $o ).

tff(pred_def_65893,type,
    v115246: state_type > $o ).

tff(pred_def_65894,type,
    v115237: state_type > $o ).

tff(pred_def_65895,type,
    v115247: state_type > $o ).

tff(pred_def_65896,type,
    v115236: state_type > $o ).

tff(pred_def_65897,type,
    v115234: state_type > $o ).

tff(pred_def_65898,type,
    v115218: state_type > $o ).

tff(pred_def_65899,type,
    v114517: ( state_type * $int ) > $o ).

tff(pred_def_65900,type,
    v115248: ( state_type * $int ) > $o ).

tff(pred_def_65901,type,
    v115181: state_type > $o ).

tff(pred_def_65902,type,
    v114515: ( state_type * $int ) > $o ).

tff(pred_def_65903,type,
    v114513: ( state_type * $int ) > $o ).

tff(pred_def_65904,type,
    v114511: ( state_type * $int ) > $o ).

tff(pred_def_65905,type,
    v115252: state_type > $o ).

tff(pred_def_65906,type,
    v115250: state_type > $o ).

tff(pred_def_65907,type,
    v115259: state_type > $o ).

tff(pred_def_65908,type,
    v115257: state_type > $o ).

tff(pred_def_65909,type,
    v115256: state_type > $o ).

tff(pred_def_65910,type,
    v115255: state_type > $o ).

tff(pred_def_65911,type,
    v115267: state_type > $o ).

tff(pred_def_65912,type,
    v115268: state_type > $o ).

tff(pred_def_65913,type,
    v115266: state_type > $o ).

tff(pred_def_65914,type,
    v115263: ( state_type * $int ) > $o ).

tff(pred_def_65915,type,
    v115265: ( state_type * $int ) > $o ).

tff(pred_def_65916,type,
    v115254: ( state_type * $int ) > $o ).

tff(pred_def_65917,type,
    v114493: ( state_type * $int ) > $o ).

tff(pred_def_65918,type,
    v114491: ( state_type * $int ) > $o ).

tff(pred_def_65919,type,
    v115272: state_type > $o ).

tff(pred_def_65920,type,
    v115278: state_type > $o ).

tff(pred_def_65921,type,
    v115277: state_type > $o ).

tff(pred_def_65922,type,
    v115276: state_type > $o ).

tff(pred_def_65923,type,
    v115280: state_type > $o ).

tff(pred_def_65924,type,
    v115279: state_type > $o ).

tff(pred_def_65925,type,
    v115275: state_type > $o ).

tff(pred_def_65926,type,
    v115282: state_type > $o ).

tff(pred_def_65927,type,
    v115288: state_type > $o ).

tff(pred_def_65928,type,
    v115287: state_type > $o ).

tff(pred_def_65929,type,
    v115286: state_type > $o ).

tff(pred_def_65930,type,
    v115285: state_type > $o ).

tff(pred_def_65931,type,
    v115289: state_type > $o ).

tff(pred_def_65932,type,
    v115284: state_type > $o ).

tff(pred_def_65933,type,
    v115290: state_type > $o ).

tff(pred_def_65934,type,
    v115283: state_type > $o ).

tff(pred_def_65935,type,
    v115281: state_type > $o ).

tff(pred_def_65936,type,
    v115274: state_type > $o ).

tff(pred_def_65937,type,
    v115296: state_type > $o ).

tff(pred_def_65938,type,
    v115294: state_type > $o ).

tff(pred_def_65939,type,
    v115293: state_type > $o ).

tff(pred_def_65940,type,
    v115292: ( state_type * $int ) > $o ).

tff(pred_def_65941,type,
    v115306: state_type > $o ).

tff(pred_def_65942,type,
    v115305: state_type > $o ).

tff(pred_def_65943,type,
    v115304: state_type > $o ).

tff(pred_def_65944,type,
    v115303: state_type > $o ).

tff(pred_def_65945,type,
    v115308: state_type > $o ).

tff(pred_def_65946,type,
    v115309: state_type > $o ).

tff(pred_def_65947,type,
    v115307: state_type > $o ).

tff(pred_def_65948,type,
    v115302: state_type > $o ).

tff(pred_def_65949,type,
    v115312: state_type > $o ).

tff(pred_def_65950,type,
    v115311: state_type > $o ).

tff(pred_def_65951,type,
    v115313: state_type > $o ).

tff(pred_def_65952,type,
    v115310: state_type > $o ).

tff(pred_def_65953,type,
    v115301: state_type > $o ).

tff(pred_def_65954,type,
    v115317: state_type > $o ).

tff(pred_def_65955,type,
    v115316: state_type > $o ).

tff(pred_def_65956,type,
    v115315: state_type > $o ).

tff(pred_def_65957,type,
    v115318: state_type > $o ).

tff(pred_def_65958,type,
    v115314: state_type > $o ).

tff(pred_def_65959,type,
    v115300: state_type > $o ).

tff(pred_def_65960,type,
    v115325: state_type > $o ).

tff(pred_def_65961,type,
    v115323: state_type > $o ).

tff(pred_def_65962,type,
    v115322: state_type > $o ).

tff(pred_def_65963,type,
    v115321: ( state_type * $int ) > $o ).

tff(pred_def_65964,type,
    v115179: state_type > $o ).

tff(pred_def_65965,type,
    v115331: state_type > $o ).

tff(pred_def_65966,type,
    v115333: state_type > $o ).

tff(pred_def_65967,type,
    v115336: state_type > $o ).

tff(pred_def_65968,type,
    v115337: state_type > $o ).

tff(pred_def_65969,type,
    v115335: state_type > $o ).

tff(pred_def_65970,type,
    v115334: state_type > $o ).

tff(pred_def_65971,type,
    v115332: state_type > $o ).

tff(pred_def_65972,type,
    v115330: state_type > $o ).

tff(pred_def_65973,type,
    v115343: state_type > $o ).

tff(pred_def_65974,type,
    v115341: state_type > $o ).

tff(pred_def_65975,type,
    v115340: state_type > $o ).

tff(pred_def_65976,type,
    v115339: ( state_type * $int ) > $o ).

tff(pred_def_65977,type,
    v115357: state_type > $o ).

tff(pred_def_65978,type,
    v115355: state_type > $o ).

tff(pred_def_65979,type,
    v115361: state_type > $o ).

tff(pred_def_65980,type,
    v115359: state_type > $o ).

tff(pred_def_65981,type,
    v115373: state_type > $o ).

tff(pred_def_65982,type,
    v115374: state_type > $o ).

tff(pred_def_65983,type,
    v115371: state_type > $o ).

tff(pred_def_65984,type,
    v115349: ( state_type * $int ) > $o ).

tff(pred_def_65985,type,
    v115381: state_type > $o ).

tff(pred_def_65986,type,
    v115380: state_type > $o ).

tff(pred_def_65987,type,
    v115383: state_type > $o ).

tff(pred_def_65988,type,
    v115382: state_type > $o ).

tff(pred_def_65989,type,
    v115379: state_type > $o ).

tff(pred_def_65990,type,
    v115377: ( state_type * $int ) > $o ).

tff(pred_def_65991,type,
    v115347: state_type > $o ).

tff(pred_def_65992,type,
    v115376: ( state_type * $int ) > $o ).

tff(pred_def_65993,type,
    v115369: ( state_type * $int ) > $o ).

tff(pred_def_65994,type,
    v115367: ( state_type * $int ) > $o ).

tff(pred_def_65995,type,
    v115365: ( state_type * $int ) > $o ).

tff(pred_def_65996,type,
    v115363: ( state_type * $int ) > $o ).

tff(pred_def_65997,type,
    v115387: state_type > $o ).

tff(pred_def_65998,type,
    v115385: state_type > $o ).

tff(pred_def_65999,type,
    v115394: state_type > $o ).

tff(pred_def_66000,type,
    v115392: state_type > $o ).

tff(pred_def_66001,type,
    v115391: state_type > $o ).

tff(pred_def_66002,type,
    v115390: state_type > $o ).

tff(pred_def_66003,type,
    v115402: state_type > $o ).

tff(pred_def_66004,type,
    v115403: state_type > $o ).

tff(pred_def_66005,type,
    v115401: state_type > $o ).

tff(pred_def_66006,type,
    v115398: ( state_type * $int ) > $o ).

tff(pred_def_66007,type,
    v115400: ( state_type * $int ) > $o ).

tff(pred_def_66008,type,
    v115353: ( state_type * $int ) > $o ).

tff(pred_def_66009,type,
    v115351: ( state_type * $int ) > $o ).

tff(pred_def_66010,type,
    v115418: state_type > $o ).

tff(pred_def_66011,type,
    v115416: state_type > $o ).

tff(pred_def_66012,type,
    v115422: state_type > $o ).

tff(pred_def_66013,type,
    v115420: state_type > $o ).

tff(pred_def_66014,type,
    v115435: state_type > $o ).

tff(pred_def_66015,type,
    v115434: state_type > $o ).

tff(pred_def_66016,type,
    v115432: state_type > $o ).

tff(pred_def_66017,type,
    v115437: ( state_type * $int ) > $o ).

tff(pred_def_66018,type,
    v115439: state_type > $o ).

tff(pred_def_66019,type,
    v115442: ( state_type * $int ) > $o ).

tff(pred_def_66020,type,
    v115410: ( state_type * $int ) > $o ).

tff(pred_def_66021,type,
    v115457: state_type > $o ).

tff(pred_def_66022,type,
    v115456: state_type > $o ).

tff(pred_def_66023,type,
    v115455: state_type > $o ).

tff(pred_def_66024,type,
    v115458: state_type > $o ).

tff(pred_def_66025,type,
    v115454: state_type > $o ).

tff(pred_def_66026,type,
    v115453: state_type > $o ).

tff(pred_def_66027,type,
    v115459: state_type > $o ).

tff(pred_def_66028,type,
    v115452: state_type > $o ).

tff(pred_def_66029,type,
    v115451: state_type > $o ).

tff(pred_def_66030,type,
    v115450: state_type > $o ).

tff(pred_def_66031,type,
    v115449: state_type > $o ).

tff(pred_def_66032,type,
    v115461: state_type > $o ).

tff(pred_def_66033,type,
    v115460: state_type > $o ).

tff(pred_def_66034,type,
    v115448: state_type > $o ).

tff(pred_def_66035,type,
    v115464: state_type > $o ).

tff(pred_def_66036,type,
    v115463: state_type > $o ).

tff(pred_def_66037,type,
    v115465: state_type > $o ).

tff(pred_def_66038,type,
    v115462: state_type > $o ).

tff(pred_def_66039,type,
    v115468: state_type > $o ).

tff(pred_def_66040,type,
    v115467: state_type > $o ).

tff(pred_def_66041,type,
    v115469: state_type > $o ).

tff(pred_def_66042,type,
    v115466: state_type > $o ).

tff(pred_def_66043,type,
    v115472: state_type > $o ).

tff(pred_def_66044,type,
    v115471: state_type > $o ).

tff(pred_def_66045,type,
    v115473: state_type > $o ).

tff(pred_def_66046,type,
    v115470: state_type > $o ).

tff(pred_def_66047,type,
    v115446: ( state_type * $int ) > $o ).

tff(pred_def_66048,type,
    v115408: state_type > $o ).

tff(pred_def_66049,type,
    v115445: ( state_type * $int ) > $o ).

tff(pred_def_66050,type,
    v115444: ( state_type * $int ) > $o ).

tff(pred_def_66051,type,
    v115430: ( state_type * $int ) > $o ).

tff(pred_def_66052,type,
    v115428: ( state_type * $int ) > $o ).

tff(pred_def_66053,type,
    v115426: ( state_type * $int ) > $o ).

tff(pred_def_66054,type,
    v115424: ( state_type * $int ) > $o ).

tff(pred_def_66055,type,
    v115477: state_type > $o ).

tff(pred_def_66056,type,
    v115475: state_type > $o ).

tff(pred_def_66057,type,
    v115484: state_type > $o ).

tff(pred_def_66058,type,
    v115482: state_type > $o ).

tff(pred_def_66059,type,
    v115481: state_type > $o ).

tff(pred_def_66060,type,
    v115480: state_type > $o ).

tff(pred_def_66061,type,
    v115492: state_type > $o ).

tff(pred_def_66062,type,
    v115493: state_type > $o ).

tff(pred_def_66063,type,
    v115491: state_type > $o ).

tff(pred_def_66064,type,
    v115488: ( state_type * $int ) > $o ).

tff(pred_def_66065,type,
    v115490: ( state_type * $int ) > $o ).

tff(pred_def_66066,type,
    v115414: ( state_type * $int ) > $o ).

tff(pred_def_66067,type,
    v115412: ( state_type * $int ) > $o ).

tff(pred_def_66068,type,
    v115498: state_type > $o ).

tff(pred_def_66069,type,
    v114487: state_type > $o ).

tff(pred_def_66070,type,
    v115514: state_type > $o ).

tff(pred_def_66071,type,
    v115512: state_type > $o ).

tff(pred_def_66072,type,
    v115510: state_type > $o ).

tff(pred_def_66073,type,
    v115508: state_type > $o ).

tff(pred_def_66074,type,
    v115522: state_type > $o ).

tff(pred_def_66075,type,
    v115520: state_type > $o ).

tff(pred_def_66076,type,
    v115518: state_type > $o ).

tff(pred_def_66077,type,
    v115516: state_type > $o ).

tff(pred_def_66078,type,
    v115542: state_type > $o ).

tff(pred_def_66079,type,
    v115540: state_type > $o ).

tff(pred_def_66080,type,
    v115546: state_type > $o ).

tff(pred_def_66081,type,
    v115544: state_type > $o ).

tff(pred_def_66082,type,
    v115556: state_type > $o ).

tff(pred_def_66083,type,
    v115560: state_type > $o ).

tff(pred_def_66084,type,
    v115562: state_type > $o ).

tff(pred_def_66085,type,
    v115564: state_type > $o ).

tff(pred_def_66086,type,
    v115566: state_type > $o ).

tff(pred_def_66087,type,
    v115568: state_type > $o ).

tff(pred_def_66088,type,
    v115570: state_type > $o ).

tff(pred_def_66089,type,
    v115572: state_type > $o ).

tff(pred_def_66090,type,
    v115621: ( state_type * $int ) > $o ).

tff(pred_def_66091,type,
    v115622: ( state_type * $int ) > $o ).

tff(pred_def_66092,type,
    v115620: state_type > $o ).

tff(pred_def_66093,type,
    v115625: state_type > $o ).

tff(pred_def_66094,type,
    v115626: state_type > $o ).

tff(pred_def_66095,type,
    v115624: state_type > $o ).

tff(pred_def_66096,type,
    v115627: state_type > $o ).

tff(pred_def_66097,type,
    v115623: state_type > $o ).

tff(pred_def_66098,type,
    v115619: state_type > $o ).

tff(pred_def_66099,type,
    v115628: state_type > $o ).

tff(pred_def_66100,type,
    v115618: state_type > $o ).

tff(pred_def_66101,type,
    v115617: state_type > $o ).

tff(pred_def_66102,type,
    v115632: state_type > $o ).

tff(pred_def_66103,type,
    v115633: state_type > $o ).

tff(pred_def_66104,type,
    v115631: state_type > $o ).

tff(pred_def_66105,type,
    v115634: state_type > $o ).

tff(pred_def_66106,type,
    v115630: state_type > $o ).

tff(pred_def_66107,type,
    v115629: state_type > $o ).

tff(pred_def_66108,type,
    v115616: state_type > $o ).

tff(pred_def_66109,type,
    v115635: state_type > $o ).

tff(pred_def_66110,type,
    v115615: state_type > $o ).

tff(pred_def_66111,type,
    v115638: state_type > $o ).

tff(pred_def_66112,type,
    v115639: state_type > $o ).

tff(pred_def_66113,type,
    v115637: state_type > $o ).

tff(pred_def_66114,type,
    v115640: state_type > $o ).

tff(pred_def_66115,type,
    v115636: state_type > $o ).

tff(pred_def_66116,type,
    v115643: state_type > $o ).

tff(pred_def_66117,type,
    v115644: state_type > $o ).

tff(pred_def_66118,type,
    v115642: state_type > $o ).

tff(pred_def_66119,type,
    v115645: state_type > $o ).

tff(pred_def_66120,type,
    v115641: state_type > $o ).

tff(pred_def_66121,type,
    v115613: ( state_type * $int ) > $o ).

tff(pred_def_66122,type,
    v115646: ( state_type * $int ) > $o ).

tff(pred_def_66123,type,
    v115612: state_type > $o ).

tff(pred_def_66124,type,
    v115649: state_type > $o ).

tff(pred_def_66125,type,
    v115650: state_type > $o ).

tff(pred_def_66126,type,
    v115648: state_type > $o ).

tff(pred_def_66127,type,
    v115651: state_type > $o ).

tff(pred_def_66128,type,
    v115647: state_type > $o ).

tff(pred_def_66129,type,
    v115611: state_type > $o ).

tff(pred_def_66130,type,
    v115652: state_type > $o ).

tff(pred_def_66131,type,
    v115610: state_type > $o ).

tff(pred_def_66132,type,
    v115609: state_type > $o ).

tff(pred_def_66133,type,
    v115656: state_type > $o ).

tff(pred_def_66134,type,
    v115657: state_type > $o ).

tff(pred_def_66135,type,
    v115655: state_type > $o ).

tff(pred_def_66136,type,
    v115658: state_type > $o ).

tff(pred_def_66137,type,
    v115654: state_type > $o ).

tff(pred_def_66138,type,
    v115653: state_type > $o ).

tff(pred_def_66139,type,
    v115608: state_type > $o ).

tff(pred_def_66140,type,
    v115659: state_type > $o ).

tff(pred_def_66141,type,
    v115607: state_type > $o ).

tff(pred_def_66142,type,
    v115662: state_type > $o ).

tff(pred_def_66143,type,
    v115663: state_type > $o ).

tff(pred_def_66144,type,
    v115661: state_type > $o ).

tff(pred_def_66145,type,
    v115664: state_type > $o ).

tff(pred_def_66146,type,
    v115660: state_type > $o ).

tff(pred_def_66147,type,
    v115667: state_type > $o ).

tff(pred_def_66148,type,
    v115668: state_type > $o ).

tff(pred_def_66149,type,
    v115666: state_type > $o ).

tff(pred_def_66150,type,
    v115669: state_type > $o ).

tff(pred_def_66151,type,
    v115665: state_type > $o ).

tff(pred_def_66152,type,
    v115605: ( state_type * $int ) > $o ).

tff(pred_def_66153,type,
    v115670: ( state_type * $int ) > $o ).

tff(pred_def_66154,type,
    v115604: state_type > $o ).

tff(pred_def_66155,type,
    v115673: state_type > $o ).

tff(pred_def_66156,type,
    v115674: state_type > $o ).

tff(pred_def_66157,type,
    v115672: state_type > $o ).

tff(pred_def_66158,type,
    v115675: state_type > $o ).

tff(pred_def_66159,type,
    v115671: state_type > $o ).

tff(pred_def_66160,type,
    v115603: state_type > $o ).

tff(pred_def_66161,type,
    v115676: state_type > $o ).

tff(pred_def_66162,type,
    v115602: state_type > $o ).

tff(pred_def_66163,type,
    v115601: state_type > $o ).

tff(pred_def_66164,type,
    v115680: state_type > $o ).

tff(pred_def_66165,type,
    v115681: state_type > $o ).

tff(pred_def_66166,type,
    v115679: state_type > $o ).

tff(pred_def_66167,type,
    v115682: state_type > $o ).

tff(pred_def_66168,type,
    v115678: state_type > $o ).

tff(pred_def_66169,type,
    v115677: state_type > $o ).

tff(pred_def_66170,type,
    v115600: state_type > $o ).

tff(pred_def_66171,type,
    v115683: state_type > $o ).

tff(pred_def_66172,type,
    v115599: state_type > $o ).

tff(pred_def_66173,type,
    v115686: state_type > $o ).

tff(pred_def_66174,type,
    v115687: state_type > $o ).

tff(pred_def_66175,type,
    v115685: state_type > $o ).

tff(pred_def_66176,type,
    v115688: state_type > $o ).

tff(pred_def_66177,type,
    v115684: state_type > $o ).

tff(pred_def_66178,type,
    v115691: state_type > $o ).

tff(pred_def_66179,type,
    v115692: state_type > $o ).

tff(pred_def_66180,type,
    v115690: state_type > $o ).

tff(pred_def_66181,type,
    v115693: state_type > $o ).

tff(pred_def_66182,type,
    v115689: state_type > $o ).

tff(pred_def_66183,type,
    v115597: ( state_type * $int ) > $o ).

tff(pred_def_66184,type,
    v115694: ( state_type * $int ) > $o ).

tff(pred_def_66185,type,
    v115596: state_type > $o ).

tff(pred_def_66186,type,
    v115697: state_type > $o ).

tff(pred_def_66187,type,
    v115698: state_type > $o ).

tff(pred_def_66188,type,
    v115696: state_type > $o ).

tff(pred_def_66189,type,
    v115699: state_type > $o ).

tff(pred_def_66190,type,
    v115695: state_type > $o ).

tff(pred_def_66191,type,
    v115595: state_type > $o ).

tff(pred_def_66192,type,
    v115700: state_type > $o ).

tff(pred_def_66193,type,
    v115594: state_type > $o ).

tff(pred_def_66194,type,
    v115593: state_type > $o ).

tff(pred_def_66195,type,
    v115704: state_type > $o ).

tff(pred_def_66196,type,
    v115705: state_type > $o ).

tff(pred_def_66197,type,
    v115703: state_type > $o ).

tff(pred_def_66198,type,
    v115706: state_type > $o ).

tff(pred_def_66199,type,
    v115702: state_type > $o ).

tff(pred_def_66200,type,
    v115701: state_type > $o ).

tff(pred_def_66201,type,
    v115592: state_type > $o ).

tff(pred_def_66202,type,
    v115707: state_type > $o ).

tff(pred_def_66203,type,
    v115591: state_type > $o ).

tff(pred_def_66204,type,
    v115710: state_type > $o ).

tff(pred_def_66205,type,
    v115711: state_type > $o ).

tff(pred_def_66206,type,
    v115709: state_type > $o ).

tff(pred_def_66207,type,
    v115712: state_type > $o ).

tff(pred_def_66208,type,
    v115708: state_type > $o ).

tff(pred_def_66209,type,
    v115715: state_type > $o ).

tff(pred_def_66210,type,
    v115716: state_type > $o ).

tff(pred_def_66211,type,
    v115714: state_type > $o ).

tff(pred_def_66212,type,
    v115717: state_type > $o ).

tff(pred_def_66213,type,
    v115713: state_type > $o ).

tff(pred_def_66214,type,
    v115589: ( state_type * $int ) > $o ).

tff(pred_def_66215,type,
    v115718: ( state_type * $int ) > $o ).

tff(pred_def_66216,type,
    v115588: state_type > $o ).

tff(pred_def_66217,type,
    v115721: state_type > $o ).

tff(pred_def_66218,type,
    v115722: state_type > $o ).

tff(pred_def_66219,type,
    v115720: state_type > $o ).

tff(pred_def_66220,type,
    v115723: state_type > $o ).

tff(pred_def_66221,type,
    v115719: state_type > $o ).

tff(pred_def_66222,type,
    v115587: state_type > $o ).

tff(pred_def_66223,type,
    v115724: state_type > $o ).

tff(pred_def_66224,type,
    v115586: state_type > $o ).

tff(pred_def_66225,type,
    v115585: state_type > $o ).

tff(pred_def_66226,type,
    v115728: state_type > $o ).

tff(pred_def_66227,type,
    v115729: state_type > $o ).

tff(pred_def_66228,type,
    v115727: state_type > $o ).

tff(pred_def_66229,type,
    v115730: state_type > $o ).

tff(pred_def_66230,type,
    v115726: state_type > $o ).

tff(pred_def_66231,type,
    v115725: state_type > $o ).

tff(pred_def_66232,type,
    v115584: state_type > $o ).

tff(pred_def_66233,type,
    v115731: state_type > $o ).

tff(pred_def_66234,type,
    v115583: state_type > $o ).

tff(pred_def_66235,type,
    v115734: state_type > $o ).

tff(pred_def_66236,type,
    v115735: state_type > $o ).

tff(pred_def_66237,type,
    v115733: state_type > $o ).

tff(pred_def_66238,type,
    v115736: state_type > $o ).

tff(pred_def_66239,type,
    v115732: state_type > $o ).

tff(pred_def_66240,type,
    v115739: state_type > $o ).

tff(pred_def_66241,type,
    v115740: state_type > $o ).

tff(pred_def_66242,type,
    v115738: state_type > $o ).

tff(pred_def_66243,type,
    v115741: state_type > $o ).

tff(pred_def_66244,type,
    v115737: state_type > $o ).

tff(pred_def_66245,type,
    v115581: ( state_type * $int ) > $o ).

tff(pred_def_66246,type,
    v115742: ( state_type * $int ) > $o ).

tff(pred_def_66247,type,
    v115580: state_type > $o ).

tff(pred_def_66248,type,
    v115745: state_type > $o ).

tff(pred_def_66249,type,
    v115746: state_type > $o ).

tff(pred_def_66250,type,
    v115744: state_type > $o ).

tff(pred_def_66251,type,
    v115747: state_type > $o ).

tff(pred_def_66252,type,
    v115743: state_type > $o ).

tff(pred_def_66253,type,
    v115579: state_type > $o ).

tff(pred_def_66254,type,
    v115748: state_type > $o ).

tff(pred_def_66255,type,
    v115578: state_type > $o ).

tff(pred_def_66256,type,
    v115577: state_type > $o ).

tff(pred_def_66257,type,
    v115752: state_type > $o ).

tff(pred_def_66258,type,
    v115753: state_type > $o ).

tff(pred_def_66259,type,
    v115751: state_type > $o ).

tff(pred_def_66260,type,
    v115754: state_type > $o ).

tff(pred_def_66261,type,
    v115750: state_type > $o ).

tff(pred_def_66262,type,
    v115749: state_type > $o ).

tff(pred_def_66263,type,
    v115576: state_type > $o ).

tff(pred_def_66264,type,
    v115755: state_type > $o ).

tff(pred_def_66265,type,
    v115575: state_type > $o ).

tff(pred_def_66266,type,
    v115758: state_type > $o ).

tff(pred_def_66267,type,
    v115759: state_type > $o ).

tff(pred_def_66268,type,
    v115757: state_type > $o ).

tff(pred_def_66269,type,
    v115760: state_type > $o ).

tff(pred_def_66270,type,
    v115756: state_type > $o ).

tff(pred_def_66271,type,
    v115763: state_type > $o ).

tff(pred_def_66272,type,
    v115764: state_type > $o ).

tff(pred_def_66273,type,
    v115762: state_type > $o ).

tff(pred_def_66274,type,
    v115765: state_type > $o ).

tff(pred_def_66275,type,
    v115761: state_type > $o ).

tff(pred_def_66276,type,
    v115573: ( state_type * $int ) > $o ).

tff(pred_def_66277,type,
    v115558: ( state_type * $int ) > $o ).

tff(pred_def_66278,type,
    v115775: state_type > $o ).

tff(pred_def_66279,type,
    v115773: state_type > $o ).

tff(pred_def_66280,type,
    v115772: state_type > $o ).

tff(pred_def_66281,type,
    v115771: ( state_type * $int ) > $o ).

tff(pred_def_66282,type,
    v115769: state_type > $o ).

tff(pred_def_66283,type,
    v115785: state_type > $o ).

tff(pred_def_66284,type,
    v115783: state_type > $o ).

tff(pred_def_66285,type,
    v115782: state_type > $o ).

tff(pred_def_66286,type,
    v115781: ( state_type * $int ) > $o ).

tff(pred_def_66287,type,
    v115779: state_type > $o ).

tff(pred_def_66288,type,
    v115795: state_type > $o ).

tff(pred_def_66289,type,
    v115793: state_type > $o ).

tff(pred_def_66290,type,
    v115792: state_type > $o ).

tff(pred_def_66291,type,
    v115791: ( state_type * $int ) > $o ).

tff(pred_def_66292,type,
    v115789: state_type > $o ).

tff(pred_def_66293,type,
    v115799: state_type > $o ).

tff(pred_def_66294,type,
    v115801: state_type > $o ).

tff(pred_def_66295,type,
    v115803: state_type > $o ).

tff(pred_def_66296,type,
    v115809: state_type > $o ).

tff(pred_def_66297,type,
    v115808: state_type > $o ).

tff(pred_def_66298,type,
    v115807: state_type > $o ).

tff(pred_def_66299,type,
    v115806: state_type > $o ).

tff(pred_def_66300,type,
    v115805: state_type > $o ).

tff(pred_def_66301,type,
    v115804: ( state_type * $int ) > $o ).

tff(pred_def_66302,type,
    v115767: ( state_type * $int ) > $o ).

tff(pred_def_66303,type,
    v115813: state_type > $o ).

tff(pred_def_66304,type,
    v115812: state_type > $o ).

tff(pred_def_66305,type,
    v115811: ( state_type * $int ) > $o ).

tff(pred_def_66306,type,
    v115842: ( state_type * $int ) > $o ).

tff(pred_def_66307,type,
    v115534: ( state_type * $int ) > $o ).

tff(pred_def_66308,type,
    v115841: state_type > $o ).

tff(pred_def_66309,type,
    v115845: state_type > $o ).

tff(pred_def_66310,type,
    v115846: state_type > $o ).

tff(pred_def_66311,type,
    v115844: state_type > $o ).

tff(pred_def_66312,type,
    v115847: state_type > $o ).

tff(pred_def_66313,type,
    v115843: state_type > $o ).

tff(pred_def_66314,type,
    v115840: state_type > $o ).

tff(pred_def_66315,type,
    v115848: state_type > $o ).

tff(pred_def_66316,type,
    v115839: state_type > $o ).

tff(pred_def_66317,type,
    v115851: state_type > $o ).

tff(pred_def_66318,type,
    v115852: state_type > $o ).

tff(pred_def_66319,type,
    v115850: state_type > $o ).

tff(pred_def_66320,type,
    v115853: state_type > $o ).

tff(pred_def_66321,type,
    v115849: state_type > $o ).

tff(pred_def_66322,type,
    v115838: state_type > $o ).

tff(pred_def_66323,type,
    v115854: state_type > $o ).

tff(pred_def_66324,type,
    v115837: state_type > $o ).

tff(pred_def_66325,type,
    v115857: state_type > $o ).

tff(pred_def_66326,type,
    v115858: state_type > $o ).

tff(pred_def_66327,type,
    v115856: state_type > $o ).

tff(pred_def_66328,type,
    v115859: state_type > $o ).

tff(pred_def_66329,type,
    v115855: state_type > $o ).

tff(pred_def_66330,type,
    v115836: state_type > $o ).

tff(pred_def_66331,type,
    v115860: state_type > $o ).

tff(pred_def_66332,type,
    v115835: state_type > $o ).

tff(pred_def_66333,type,
    v115863: state_type > $o ).

tff(pred_def_66334,type,
    v115864: state_type > $o ).

tff(pred_def_66335,type,
    v115862: state_type > $o ).

tff(pred_def_66336,type,
    v115865: state_type > $o ).

tff(pred_def_66337,type,
    v115861: state_type > $o ).

tff(pred_def_66338,type,
    v115834: state_type > $o ).

tff(pred_def_66339,type,
    v115866: state_type > $o ).

tff(pred_def_66340,type,
    v115833: state_type > $o ).

tff(pred_def_66341,type,
    v115832: state_type > $o ).

tff(pred_def_66342,type,
    v115870: state_type > $o ).

tff(pred_def_66343,type,
    v115871: state_type > $o ).

tff(pred_def_66344,type,
    v115869: state_type > $o ).

tff(pred_def_66345,type,
    v115872: state_type > $o ).

tff(pred_def_66346,type,
    v115868: state_type > $o ).

tff(pred_def_66347,type,
    v115867: state_type > $o ).

tff(pred_def_66348,type,
    v115831: state_type > $o ).

tff(pred_def_66349,type,
    v115873: state_type > $o ).

tff(pred_def_66350,type,
    v115830: state_type > $o ).

tff(pred_def_66351,type,
    v115876: state_type > $o ).

tff(pred_def_66352,type,
    v115877: state_type > $o ).

tff(pred_def_66353,type,
    v115875: state_type > $o ).

tff(pred_def_66354,type,
    v115878: state_type > $o ).

tff(pred_def_66355,type,
    v115874: state_type > $o ).

tff(pred_def_66356,type,
    v115881: state_type > $o ).

tff(pred_def_66357,type,
    v115882: state_type > $o ).

tff(pred_def_66358,type,
    v115880: state_type > $o ).

tff(pred_def_66359,type,
    v115883: state_type > $o ).

tff(pred_def_66360,type,
    v115879: state_type > $o ).

tff(pred_def_66361,type,
    v115886: state_type > $o ).

tff(pred_def_66362,type,
    v115887: state_type > $o ).

tff(pred_def_66363,type,
    v115885: state_type > $o ).

tff(pred_def_66364,type,
    v115888: state_type > $o ).

tff(pred_def_66365,type,
    v115884: state_type > $o ).

tff(pred_def_66366,type,
    v115891: state_type > $o ).

tff(pred_def_66367,type,
    v115892: state_type > $o ).

tff(pred_def_66368,type,
    v115890: state_type > $o ).

tff(pred_def_66369,type,
    v115893: state_type > $o ).

tff(pred_def_66370,type,
    v115889: state_type > $o ).

tff(pred_def_66371,type,
    v115896: state_type > $o ).

tff(pred_def_66372,type,
    v115897: state_type > $o ).

tff(pred_def_66373,type,
    v115895: state_type > $o ).

tff(pred_def_66374,type,
    v115898: state_type > $o ).

tff(pred_def_66375,type,
    v115894: state_type > $o ).

tff(pred_def_66376,type,
    v115828: ( state_type * $int ) > $o ).

tff(pred_def_66377,type,
    v115827: state_type > $o ).

tff(pred_def_66378,type,
    v115903: state_type > $o ).

tff(pred_def_66379,type,
    v115905: state_type > $o ).

tff(pred_def_66380,type,
    v115906: state_type > $o ).

tff(pred_def_66381,type,
    v115904: state_type > $o ).

tff(pred_def_66382,type,
    v115902: state_type > $o ).

tff(pred_def_66383,type,
    v115901: state_type > $o ).

tff(pred_def_66384,type,
    v115907: state_type > $o ).

tff(pred_def_66385,type,
    v115900: state_type > $o ).

tff(pred_def_66386,type,
    v115908: state_type > $o ).

tff(pred_def_66387,type,
    v115899: state_type > $o ).

tff(pred_def_66388,type,
    v115826: state_type > $o ).

tff(pred_def_66389,type,
    v115909: state_type > $o ).

tff(pred_def_66390,type,
    v115825: state_type > $o ).

tff(pred_def_66391,type,
    v115916: state_type > $o ).

tff(pred_def_66392,type,
    v115915: state_type > $o ).

tff(pred_def_66393,type,
    v115914: state_type > $o ).

tff(pred_def_66394,type,
    v115918: state_type > $o ).

tff(pred_def_66395,type,
    v115917: state_type > $o ).

tff(pred_def_66396,type,
    v115913: state_type > $o ).

tff(pred_def_66397,type,
    v115912: state_type > $o ).

tff(pred_def_66398,type,
    v115919: state_type > $o ).

tff(pred_def_66399,type,
    v115911: state_type > $o ).

tff(pred_def_66400,type,
    v115920: state_type > $o ).

tff(pred_def_66401,type,
    v115910: state_type > $o ).

tff(pred_def_66402,type,
    v115824: state_type > $o ).

tff(pred_def_66403,type,
    v115921: state_type > $o ).

tff(pred_def_66404,type,
    v115823: state_type > $o ).

tff(pred_def_66405,type,
    v115928: state_type > $o ).

tff(pred_def_66406,type,
    v115927: state_type > $o ).

tff(pred_def_66407,type,
    v115926: state_type > $o ).

tff(pred_def_66408,type,
    v115930: state_type > $o ).

tff(pred_def_66409,type,
    v115929: state_type > $o ).

tff(pred_def_66410,type,
    v115925: state_type > $o ).

tff(pred_def_66411,type,
    v115924: state_type > $o ).

tff(pred_def_66412,type,
    v115931: state_type > $o ).

tff(pred_def_66413,type,
    v115923: state_type > $o ).

tff(pred_def_66414,type,
    v115932: state_type > $o ).

tff(pred_def_66415,type,
    v115922: state_type > $o ).

tff(pred_def_66416,type,
    v115822: state_type > $o ).

tff(pred_def_66417,type,
    v115933: state_type > $o ).

tff(pred_def_66418,type,
    v115821: state_type > $o ).

tff(pred_def_66419,type,
    v115940: state_type > $o ).

tff(pred_def_66420,type,
    v115939: state_type > $o ).

tff(pred_def_66421,type,
    v115938: state_type > $o ).

tff(pred_def_66422,type,
    v115942: state_type > $o ).

tff(pred_def_66423,type,
    v115941: state_type > $o ).

tff(pred_def_66424,type,
    v115937: state_type > $o ).

tff(pred_def_66425,type,
    v115936: state_type > $o ).

tff(pred_def_66426,type,
    v115943: state_type > $o ).

tff(pred_def_66427,type,
    v115935: state_type > $o ).

tff(pred_def_66428,type,
    v115944: state_type > $o ).

tff(pred_def_66429,type,
    v115934: state_type > $o ).

tff(pred_def_66430,type,
    v115820: state_type > $o ).

tff(pred_def_66431,type,
    v115945: state_type > $o ).

tff(pred_def_66432,type,
    v115819: state_type > $o ).

tff(pred_def_66433,type,
    v115818: state_type > $o ).

tff(pred_def_66434,type,
    v115953: state_type > $o ).

tff(pred_def_66435,type,
    v115952: state_type > $o ).

tff(pred_def_66436,type,
    v115951: state_type > $o ).

tff(pred_def_66437,type,
    v115955: state_type > $o ).

tff(pred_def_66438,type,
    v115954: state_type > $o ).

tff(pred_def_66439,type,
    v115950: state_type > $o ).

tff(pred_def_66440,type,
    v115949: state_type > $o ).

tff(pred_def_66441,type,
    v115956: state_type > $o ).

tff(pred_def_66442,type,
    v115948: state_type > $o ).

tff(pred_def_66443,type,
    v115957: state_type > $o ).

tff(pred_def_66444,type,
    v115947: state_type > $o ).

tff(pred_def_66445,type,
    v115946: state_type > $o ).

tff(pred_def_66446,type,
    v115817: state_type > $o ).

tff(pred_def_66447,type,
    v115958: state_type > $o ).

tff(pred_def_66448,type,
    v115816: state_type > $o ).

tff(pred_def_66449,type,
    v115961: state_type > $o ).

tff(pred_def_66450,type,
    v115962: state_type > $o ).

tff(pred_def_66451,type,
    v115960: state_type > $o ).

tff(pred_def_66452,type,
    v115963: state_type > $o ).

tff(pred_def_66453,type,
    v115959: state_type > $o ).

tff(pred_def_66454,type,
    v115966: state_type > $o ).

tff(pred_def_66455,type,
    v115967: state_type > $o ).

tff(pred_def_66456,type,
    v115965: state_type > $o ).

tff(pred_def_66457,type,
    v115968: state_type > $o ).

tff(pred_def_66458,type,
    v115964: state_type > $o ).

tff(pred_def_66459,type,
    v115971: state_type > $o ).

tff(pred_def_66460,type,
    v115972: state_type > $o ).

tff(pred_def_66461,type,
    v115970: state_type > $o ).

tff(pred_def_66462,type,
    v115973: state_type > $o ).

tff(pred_def_66463,type,
    v115969: state_type > $o ).

tff(pred_def_66464,type,
    v115976: state_type > $o ).

tff(pred_def_66465,type,
    v115977: state_type > $o ).

tff(pred_def_66466,type,
    v115975: state_type > $o ).

tff(pred_def_66467,type,
    v115978: state_type > $o ).

tff(pred_def_66468,type,
    v115974: state_type > $o ).

tff(pred_def_66469,type,
    v115981: state_type > $o ).

tff(pred_def_66470,type,
    v115980: state_type > $o ).

tff(pred_def_66471,type,
    v115982: state_type > $o ).

tff(pred_def_66472,type,
    v115979: state_type > $o ).

tff(pred_def_66473,type,
    v115814: ( state_type * $int ) > $o ).

tff(pred_def_66474,type,
    v115554: ( state_type * $int ) > $o ).

tff(pred_def_66475,type,
    v115552: ( state_type * $int ) > $o ).

tff(pred_def_66476,type,
    v115550: ( state_type * $int ) > $o ).

tff(pred_def_66477,type,
    v115548: ( state_type * $int ) > $o ).

tff(pred_def_66478,type,
    v115988: state_type > $o ).

tff(pred_def_66479,type,
    v115986: state_type > $o ).

tff(pred_def_66480,type,
    v115984: state_type > $o ).

tff(pred_def_66481,type,
    v115995: state_type > $o ).

tff(pred_def_66482,type,
    v115993: state_type > $o ).

tff(pred_def_66483,type,
    v115992: state_type > $o ).

tff(pred_def_66484,type,
    v115991: state_type > $o ).

tff(pred_def_66485,type,
    v116003: state_type > $o ).

tff(pred_def_66486,type,
    v116004: state_type > $o ).

tff(pred_def_66487,type,
    v116002: state_type > $o ).

tff(pred_def_66488,type,
    v115999: ( state_type * $int ) > $o ).

tff(pred_def_66489,type,
    v116001: ( state_type * $int ) > $o ).

tff(pred_def_66490,type,
    v115538: ( state_type * $int ) > $o ).

tff(pred_def_66491,type,
    v115536: ( state_type * $int ) > $o ).

tff(pred_def_66492,type,
    v116008: state_type > $o ).

tff(pred_def_66493,type,
    v116010: state_type > $o ).

tff(pred_def_66494,type,
    v116011: state_type > $o ).

tff(pred_def_66495,type,
    v115532: state_type > $o ).

tff(pred_def_66496,type,
    v116013: state_type > $o ).

tff(pred_def_66497,type,
    v116015: state_type > $o ).

tff(pred_def_66498,type,
    v116021: state_type > $o ).

tff(pred_def_66499,type,
    v116023: state_type > $o ).

tff(pred_def_66500,type,
    v116033: state_type > $o ).

tff(pred_def_66501,type,
    v116034: state_type > $o ).

tff(pred_def_66502,type,
    v116032: state_type > $o ).

tff(pred_def_66503,type,
    v116036: state_type > $o ).

tff(pred_def_66504,type,
    v116037: state_type > $o ).

tff(pred_def_66505,type,
    v116035: state_type > $o ).

tff(pred_def_66506,type,
    v116031: state_type > $o ).

tff(pred_def_66507,type,
    v116030: state_type > $o ).

tff(pred_def_66508,type,
    v116029: state_type > $o ).

tff(pred_def_66509,type,
    v116028: state_type > $o ).

tff(pred_def_66510,type,
    v115502: ( state_type * $int ) > $o ).

tff(pred_def_66511,type,
    v116038: state_type > $o ).

tff(pred_def_66512,type,
    v116027: state_type > $o ).

tff(pred_def_66513,type,
    v116040: state_type > $o ).

tff(pred_def_66514,type,
    v116039: state_type > $o ).

tff(pred_def_66515,type,
    v116026: state_type > $o ).

tff(pred_def_66516,type,
    v116042: state_type > $o ).

tff(pred_def_66517,type,
    v116048: state_type > $o ).

tff(pred_def_66518,type,
    v116049: state_type > $o ).

tff(pred_def_66519,type,
    v116047: state_type > $o ).

tff(pred_def_66520,type,
    v116046: state_type > $o ).

tff(pred_def_66521,type,
    v116052: state_type > $o ).

tff(pred_def_66522,type,
    v116051: state_type > $o ).

tff(pred_def_66523,type,
    v116050: state_type > $o ).

tff(pred_def_66524,type,
    v116045: state_type > $o ).

tff(pred_def_66525,type,
    v116053: state_type > $o ).

tff(pred_def_66526,type,
    v116044: state_type > $o ).

tff(pred_def_66527,type,
    v116054: state_type > $o ).

tff(pred_def_66528,type,
    v116043: state_type > $o ).

tff(pred_def_66529,type,
    v116041: state_type > $o ).

tff(pred_def_66530,type,
    v116025: state_type > $o ).

tff(pred_def_66531,type,
    v115530: ( state_type * $int ) > $o ).

tff(pred_def_66532,type,
    v116055: ( state_type * $int ) > $o ).

tff(pred_def_66533,type,
    v116019: state_type > $o ).

tff(pred_def_66534,type,
    v115528: ( state_type * $int ) > $o ).

tff(pred_def_66535,type,
    v115526: ( state_type * $int ) > $o ).

tff(pred_def_66536,type,
    v115524: ( state_type * $int ) > $o ).

tff(pred_def_66537,type,
    v116059: state_type > $o ).

tff(pred_def_66538,type,
    v116057: state_type > $o ).

tff(pred_def_66539,type,
    v116066: state_type > $o ).

tff(pred_def_66540,type,
    v116064: state_type > $o ).

tff(pred_def_66541,type,
    v116063: state_type > $o ).

tff(pred_def_66542,type,
    v116062: state_type > $o ).

tff(pred_def_66543,type,
    v116074: state_type > $o ).

tff(pred_def_66544,type,
    v116075: state_type > $o ).

tff(pred_def_66545,type,
    v116073: state_type > $o ).

tff(pred_def_66546,type,
    v116070: ( state_type * $int ) > $o ).

tff(pred_def_66547,type,
    v116072: ( state_type * $int ) > $o ).

tff(pred_def_66548,type,
    v116061: ( state_type * $int ) > $o ).

tff(pred_def_66549,type,
    v115506: ( state_type * $int ) > $o ).

tff(pred_def_66550,type,
    v115504: ( state_type * $int ) > $o ).

tff(pred_def_66551,type,
    v116079: state_type > $o ).

tff(pred_def_66552,type,
    v116085: state_type > $o ).

tff(pred_def_66553,type,
    v116084: state_type > $o ).

tff(pred_def_66554,type,
    v116083: state_type > $o ).

tff(pred_def_66555,type,
    v116087: state_type > $o ).

tff(pred_def_66556,type,
    v116086: state_type > $o ).

tff(pred_def_66557,type,
    v116082: state_type > $o ).

tff(pred_def_66558,type,
    v116089: state_type > $o ).

tff(pred_def_66559,type,
    v116095: state_type > $o ).

tff(pred_def_66560,type,
    v116094: state_type > $o ).

tff(pred_def_66561,type,
    v116093: state_type > $o ).

tff(pred_def_66562,type,
    v116092: state_type > $o ).

tff(pred_def_66563,type,
    v116096: state_type > $o ).

tff(pred_def_66564,type,
    v116091: state_type > $o ).

tff(pred_def_66565,type,
    v116097: state_type > $o ).

tff(pred_def_66566,type,
    v116090: state_type > $o ).

tff(pred_def_66567,type,
    v116088: state_type > $o ).

tff(pred_def_66568,type,
    v116081: state_type > $o ).

tff(pred_def_66569,type,
    v116103: state_type > $o ).

tff(pred_def_66570,type,
    v116101: state_type > $o ).

tff(pred_def_66571,type,
    v116100: state_type > $o ).

tff(pred_def_66572,type,
    v116099: ( state_type * $int ) > $o ).

tff(pred_def_66573,type,
    v116113: state_type > $o ).

tff(pred_def_66574,type,
    v116112: state_type > $o ).

tff(pred_def_66575,type,
    v116111: state_type > $o ).

tff(pred_def_66576,type,
    v116110: state_type > $o ).

tff(pred_def_66577,type,
    v116115: state_type > $o ).

tff(pred_def_66578,type,
    v116116: state_type > $o ).

tff(pred_def_66579,type,
    v116114: state_type > $o ).

tff(pred_def_66580,type,
    v116109: state_type > $o ).

tff(pred_def_66581,type,
    v116119: state_type > $o ).

tff(pred_def_66582,type,
    v116118: state_type > $o ).

tff(pred_def_66583,type,
    v116120: state_type > $o ).

tff(pred_def_66584,type,
    v116117: state_type > $o ).

tff(pred_def_66585,type,
    v116108: state_type > $o ).

tff(pred_def_66586,type,
    v116124: state_type > $o ).

tff(pred_def_66587,type,
    v116123: state_type > $o ).

tff(pred_def_66588,type,
    v116122: state_type > $o ).

tff(pred_def_66589,type,
    v116125: state_type > $o ).

tff(pred_def_66590,type,
    v116121: state_type > $o ).

tff(pred_def_66591,type,
    v116107: state_type > $o ).

tff(pred_def_66592,type,
    v116132: state_type > $o ).

tff(pred_def_66593,type,
    v116130: state_type > $o ).

tff(pred_def_66594,type,
    v116129: state_type > $o ).

tff(pred_def_66595,type,
    v116128: ( state_type * $int ) > $o ).

tff(pred_def_66596,type,
    v116017: state_type > $o ).

tff(pred_def_66597,type,
    v116138: state_type > $o ).

tff(pred_def_66598,type,
    v116140: state_type > $o ).

tff(pred_def_66599,type,
    v116143: state_type > $o ).

tff(pred_def_66600,type,
    v116144: state_type > $o ).

tff(pred_def_66601,type,
    v116142: state_type > $o ).

tff(pred_def_66602,type,
    v116141: state_type > $o ).

tff(pred_def_66603,type,
    v116139: state_type > $o ).

tff(pred_def_66604,type,
    v116137: state_type > $o ).

tff(pred_def_66605,type,
    v116150: state_type > $o ).

tff(pred_def_66606,type,
    v116148: state_type > $o ).

tff(pred_def_66607,type,
    v116147: state_type > $o ).

tff(pred_def_66608,type,
    v116146: ( state_type * $int ) > $o ).

tff(pred_def_66609,type,
    v116164: state_type > $o ).

tff(pred_def_66610,type,
    v116162: state_type > $o ).

tff(pred_def_66611,type,
    v116168: state_type > $o ).

tff(pred_def_66612,type,
    v116166: state_type > $o ).

tff(pred_def_66613,type,
    v116180: state_type > $o ).

tff(pred_def_66614,type,
    v116181: state_type > $o ).

tff(pred_def_66615,type,
    v116178: state_type > $o ).

tff(pred_def_66616,type,
    v116156: ( state_type * $int ) > $o ).

tff(pred_def_66617,type,
    v116188: state_type > $o ).

tff(pred_def_66618,type,
    v116187: state_type > $o ).

tff(pred_def_66619,type,
    v116190: state_type > $o ).

tff(pred_def_66620,type,
    v116189: state_type > $o ).

tff(pred_def_66621,type,
    v116186: state_type > $o ).

tff(pred_def_66622,type,
    v116184: ( state_type * $int ) > $o ).

tff(pred_def_66623,type,
    v116154: state_type > $o ).

tff(pred_def_66624,type,
    v116183: ( state_type * $int ) > $o ).

tff(pred_def_66625,type,
    v116176: ( state_type * $int ) > $o ).

tff(pred_def_66626,type,
    v116174: ( state_type * $int ) > $o ).

tff(pred_def_66627,type,
    v116172: ( state_type * $int ) > $o ).

tff(pred_def_66628,type,
    v116170: ( state_type * $int ) > $o ).

tff(pred_def_66629,type,
    v116194: state_type > $o ).

tff(pred_def_66630,type,
    v116192: state_type > $o ).

tff(pred_def_66631,type,
    v116201: state_type > $o ).

tff(pred_def_66632,type,
    v116199: state_type > $o ).

tff(pred_def_66633,type,
    v116198: state_type > $o ).

tff(pred_def_66634,type,
    v116197: state_type > $o ).

tff(pred_def_66635,type,
    v116209: state_type > $o ).

tff(pred_def_66636,type,
    v116210: state_type > $o ).

tff(pred_def_66637,type,
    v116208: state_type > $o ).

tff(pred_def_66638,type,
    v116205: ( state_type * $int ) > $o ).

tff(pred_def_66639,type,
    v116207: ( state_type * $int ) > $o ).

tff(pred_def_66640,type,
    v116160: ( state_type * $int ) > $o ).

tff(pred_def_66641,type,
    v116158: ( state_type * $int ) > $o ).

tff(pred_def_66642,type,
    v116225: state_type > $o ).

tff(pred_def_66643,type,
    v116223: state_type > $o ).

tff(pred_def_66644,type,
    v116229: state_type > $o ).

tff(pred_def_66645,type,
    v116227: state_type > $o ).

tff(pred_def_66646,type,
    v116242: state_type > $o ).

tff(pred_def_66647,type,
    v116241: state_type > $o ).

tff(pred_def_66648,type,
    v116239: state_type > $o ).

tff(pred_def_66649,type,
    v116244: ( state_type * $int ) > $o ).

tff(pred_def_66650,type,
    v116246: state_type > $o ).

tff(pred_def_66651,type,
    v116249: ( state_type * $int ) > $o ).

tff(pred_def_66652,type,
    v116217: ( state_type * $int ) > $o ).

tff(pred_def_66653,type,
    v116264: state_type > $o ).

tff(pred_def_66654,type,
    v116263: state_type > $o ).

tff(pred_def_66655,type,
    v116262: state_type > $o ).

tff(pred_def_66656,type,
    v116265: state_type > $o ).

tff(pred_def_66657,type,
    v116261: state_type > $o ).

tff(pred_def_66658,type,
    v116260: state_type > $o ).

tff(pred_def_66659,type,
    v116266: state_type > $o ).

tff(pred_def_66660,type,
    v116259: state_type > $o ).

tff(pred_def_66661,type,
    v116258: state_type > $o ).

tff(pred_def_66662,type,
    v116257: state_type > $o ).

tff(pred_def_66663,type,
    v116256: state_type > $o ).

tff(pred_def_66664,type,
    v116268: state_type > $o ).

tff(pred_def_66665,type,
    v116267: state_type > $o ).

tff(pred_def_66666,type,
    v116255: state_type > $o ).

tff(pred_def_66667,type,
    v116271: state_type > $o ).

tff(pred_def_66668,type,
    v116270: state_type > $o ).

tff(pred_def_66669,type,
    v116272: state_type > $o ).

tff(pred_def_66670,type,
    v116269: state_type > $o ).

tff(pred_def_66671,type,
    v116275: state_type > $o ).

tff(pred_def_66672,type,
    v116274: state_type > $o ).

tff(pred_def_66673,type,
    v116276: state_type > $o ).

tff(pred_def_66674,type,
    v116273: state_type > $o ).

tff(pred_def_66675,type,
    v116279: state_type > $o ).

tff(pred_def_66676,type,
    v116278: state_type > $o ).

tff(pred_def_66677,type,
    v116280: state_type > $o ).

tff(pred_def_66678,type,
    v116277: state_type > $o ).

tff(pred_def_66679,type,
    v116253: ( state_type * $int ) > $o ).

tff(pred_def_66680,type,
    v116215: state_type > $o ).

tff(pred_def_66681,type,
    v116252: ( state_type * $int ) > $o ).

tff(pred_def_66682,type,
    v116251: ( state_type * $int ) > $o ).

tff(pred_def_66683,type,
    v116237: ( state_type * $int ) > $o ).

tff(pred_def_66684,type,
    v116235: ( state_type * $int ) > $o ).

tff(pred_def_66685,type,
    v116233: ( state_type * $int ) > $o ).

tff(pred_def_66686,type,
    v116231: ( state_type * $int ) > $o ).

tff(pred_def_66687,type,
    v116284: state_type > $o ).

tff(pred_def_66688,type,
    v116282: state_type > $o ).

tff(pred_def_66689,type,
    v116291: state_type > $o ).

tff(pred_def_66690,type,
    v116289: state_type > $o ).

tff(pred_def_66691,type,
    v116288: state_type > $o ).

tff(pred_def_66692,type,
    v116287: state_type > $o ).

tff(pred_def_66693,type,
    v116299: state_type > $o ).

tff(pred_def_66694,type,
    v116300: state_type > $o ).

tff(pred_def_66695,type,
    v116298: state_type > $o ).

tff(pred_def_66696,type,
    v116295: ( state_type * $int ) > $o ).

tff(pred_def_66697,type,
    v116297: ( state_type * $int ) > $o ).

tff(pred_def_66698,type,
    v116221: ( state_type * $int ) > $o ).

tff(pred_def_66699,type,
    v116219: ( state_type * $int ) > $o ).

tff(pred_def_66700,type,
    v116305: state_type > $o ).

tff(pred_def_66701,type,
    v115500: state_type > $o ).

tff(pred_def_66702,type,
    v116321: state_type > $o ).

tff(pred_def_66703,type,
    v116319: state_type > $o ).

tff(pred_def_66704,type,
    v116317: state_type > $o ).

tff(pred_def_66705,type,
    v116315: state_type > $o ).

tff(pred_def_66706,type,
    v116329: state_type > $o ).

tff(pred_def_66707,type,
    v116327: state_type > $o ).

tff(pred_def_66708,type,
    v116325: state_type > $o ).

tff(pred_def_66709,type,
    v116323: state_type > $o ).

tff(pred_def_66710,type,
    v116349: state_type > $o ).

tff(pred_def_66711,type,
    v116347: state_type > $o ).

tff(pred_def_66712,type,
    v116353: state_type > $o ).

tff(pred_def_66713,type,
    v116351: state_type > $o ).

tff(pred_def_66714,type,
    v116363: state_type > $o ).

tff(pred_def_66715,type,
    v116367: state_type > $o ).

tff(pred_def_66716,type,
    v116369: state_type > $o ).

tff(pred_def_66717,type,
    v116371: state_type > $o ).

tff(pred_def_66718,type,
    v116373: state_type > $o ).

tff(pred_def_66719,type,
    v116375: state_type > $o ).

tff(pred_def_66720,type,
    v116377: state_type > $o ).

tff(pred_def_66721,type,
    v116379: state_type > $o ).

tff(pred_def_66722,type,
    v116428: ( state_type * $int ) > $o ).

tff(pred_def_66723,type,
    v116429: ( state_type * $int ) > $o ).

tff(pred_def_66724,type,
    v116427: state_type > $o ).

tff(pred_def_66725,type,
    v116432: state_type > $o ).

tff(pred_def_66726,type,
    v116433: state_type > $o ).

tff(pred_def_66727,type,
    v116431: state_type > $o ).

tff(pred_def_66728,type,
    v116434: state_type > $o ).

tff(pred_def_66729,type,
    v116430: state_type > $o ).

tff(pred_def_66730,type,
    v116426: state_type > $o ).

tff(pred_def_66731,type,
    v116435: state_type > $o ).

tff(pred_def_66732,type,
    v116425: state_type > $o ).

tff(pred_def_66733,type,
    v116424: state_type > $o ).

tff(pred_def_66734,type,
    v116439: state_type > $o ).

tff(pred_def_66735,type,
    v116440: state_type > $o ).

tff(pred_def_66736,type,
    v116438: state_type > $o ).

tff(pred_def_66737,type,
    v116441: state_type > $o ).

tff(pred_def_66738,type,
    v116437: state_type > $o ).

tff(pred_def_66739,type,
    v116436: state_type > $o ).

tff(pred_def_66740,type,
    v116423: state_type > $o ).

tff(pred_def_66741,type,
    v116442: state_type > $o ).

tff(pred_def_66742,type,
    v116422: state_type > $o ).

tff(pred_def_66743,type,
    v116445: state_type > $o ).

tff(pred_def_66744,type,
    v116446: state_type > $o ).

tff(pred_def_66745,type,
    v116444: state_type > $o ).

tff(pred_def_66746,type,
    v116447: state_type > $o ).

tff(pred_def_66747,type,
    v116443: state_type > $o ).

tff(pred_def_66748,type,
    v116450: state_type > $o ).

tff(pred_def_66749,type,
    v116451: state_type > $o ).

tff(pred_def_66750,type,
    v116449: state_type > $o ).

tff(pred_def_66751,type,
    v116452: state_type > $o ).

tff(pred_def_66752,type,
    v116448: state_type > $o ).

tff(pred_def_66753,type,
    v116420: ( state_type * $int ) > $o ).

tff(pred_def_66754,type,
    v116453: ( state_type * $int ) > $o ).

tff(pred_def_66755,type,
    v116419: state_type > $o ).

tff(pred_def_66756,type,
    v116456: state_type > $o ).

tff(pred_def_66757,type,
    v116457: state_type > $o ).

tff(pred_def_66758,type,
    v116455: state_type > $o ).

tff(pred_def_66759,type,
    v116458: state_type > $o ).

tff(pred_def_66760,type,
    v116454: state_type > $o ).

tff(pred_def_66761,type,
    v116418: state_type > $o ).

tff(pred_def_66762,type,
    v116459: state_type > $o ).

tff(pred_def_66763,type,
    v116417: state_type > $o ).

tff(pred_def_66764,type,
    v116416: state_type > $o ).

tff(pred_def_66765,type,
    v116463: state_type > $o ).

tff(pred_def_66766,type,
    v116464: state_type > $o ).

tff(pred_def_66767,type,
    v116462: state_type > $o ).

tff(pred_def_66768,type,
    v116465: state_type > $o ).

tff(pred_def_66769,type,
    v116461: state_type > $o ).

tff(pred_def_66770,type,
    v116460: state_type > $o ).

tff(pred_def_66771,type,
    v116415: state_type > $o ).

tff(pred_def_66772,type,
    v116466: state_type > $o ).

tff(pred_def_66773,type,
    v116414: state_type > $o ).

tff(pred_def_66774,type,
    v116469: state_type > $o ).

tff(pred_def_66775,type,
    v116470: state_type > $o ).

tff(pred_def_66776,type,
    v116468: state_type > $o ).

tff(pred_def_66777,type,
    v116471: state_type > $o ).

tff(pred_def_66778,type,
    v116467: state_type > $o ).

tff(pred_def_66779,type,
    v116474: state_type > $o ).

tff(pred_def_66780,type,
    v116475: state_type > $o ).

tff(pred_def_66781,type,
    v116473: state_type > $o ).

tff(pred_def_66782,type,
    v116476: state_type > $o ).

tff(pred_def_66783,type,
    v116472: state_type > $o ).

tff(pred_def_66784,type,
    v116412: ( state_type * $int ) > $o ).

tff(pred_def_66785,type,
    v116477: ( state_type * $int ) > $o ).

tff(pred_def_66786,type,
    v116411: state_type > $o ).

tff(pred_def_66787,type,
    v116480: state_type > $o ).

tff(pred_def_66788,type,
    v116481: state_type > $o ).

tff(pred_def_66789,type,
    v116479: state_type > $o ).

tff(pred_def_66790,type,
    v116482: state_type > $o ).

tff(pred_def_66791,type,
    v116478: state_type > $o ).

tff(pred_def_66792,type,
    v116410: state_type > $o ).

tff(pred_def_66793,type,
    v116483: state_type > $o ).

tff(pred_def_66794,type,
    v116409: state_type > $o ).

tff(pred_def_66795,type,
    v116408: state_type > $o ).

tff(pred_def_66796,type,
    v116487: state_type > $o ).

tff(pred_def_66797,type,
    v116488: state_type > $o ).

tff(pred_def_66798,type,
    v116486: state_type > $o ).

tff(pred_def_66799,type,
    v116489: state_type > $o ).

tff(pred_def_66800,type,
    v116485: state_type > $o ).

tff(pred_def_66801,type,
    v116484: state_type > $o ).

tff(pred_def_66802,type,
    v116407: state_type > $o ).

tff(pred_def_66803,type,
    v116490: state_type > $o ).

tff(pred_def_66804,type,
    v116406: state_type > $o ).

tff(pred_def_66805,type,
    v116493: state_type > $o ).

tff(pred_def_66806,type,
    v116494: state_type > $o ).

tff(pred_def_66807,type,
    v116492: state_type > $o ).

tff(pred_def_66808,type,
    v116495: state_type > $o ).

tff(pred_def_66809,type,
    v116491: state_type > $o ).

tff(pred_def_66810,type,
    v116498: state_type > $o ).

tff(pred_def_66811,type,
    v116499: state_type > $o ).

tff(pred_def_66812,type,
    v116497: state_type > $o ).

tff(pred_def_66813,type,
    v116500: state_type > $o ).

tff(pred_def_66814,type,
    v116496: state_type > $o ).

tff(pred_def_66815,type,
    v116404: ( state_type * $int ) > $o ).

tff(pred_def_66816,type,
    v116501: ( state_type * $int ) > $o ).

tff(pred_def_66817,type,
    v116403: state_type > $o ).

tff(pred_def_66818,type,
    v116504: state_type > $o ).

tff(pred_def_66819,type,
    v116505: state_type > $o ).

tff(pred_def_66820,type,
    v116503: state_type > $o ).

tff(pred_def_66821,type,
    v116506: state_type > $o ).

tff(pred_def_66822,type,
    v116502: state_type > $o ).

tff(pred_def_66823,type,
    v116402: state_type > $o ).

tff(pred_def_66824,type,
    v116507: state_type > $o ).

tff(pred_def_66825,type,
    v116401: state_type > $o ).

tff(pred_def_66826,type,
    v116400: state_type > $o ).

tff(pred_def_66827,type,
    v116511: state_type > $o ).

tff(pred_def_66828,type,
    v116512: state_type > $o ).

tff(pred_def_66829,type,
    v116510: state_type > $o ).

tff(pred_def_66830,type,
    v116513: state_type > $o ).

tff(pred_def_66831,type,
    v116509: state_type > $o ).

tff(pred_def_66832,type,
    v116508: state_type > $o ).

tff(pred_def_66833,type,
    v116399: state_type > $o ).

tff(pred_def_66834,type,
    v116514: state_type > $o ).

tff(pred_def_66835,type,
    v116398: state_type > $o ).

tff(pred_def_66836,type,
    v116517: state_type > $o ).

tff(pred_def_66837,type,
    v116518: state_type > $o ).

tff(pred_def_66838,type,
    v116516: state_type > $o ).

tff(pred_def_66839,type,
    v116519: state_type > $o ).

tff(pred_def_66840,type,
    v116515: state_type > $o ).

tff(pred_def_66841,type,
    v116522: state_type > $o ).

tff(pred_def_66842,type,
    v116523: state_type > $o ).

tff(pred_def_66843,type,
    v116521: state_type > $o ).

tff(pred_def_66844,type,
    v116524: state_type > $o ).

tff(pred_def_66845,type,
    v116520: state_type > $o ).

tff(pred_def_66846,type,
    v116396: ( state_type * $int ) > $o ).

tff(pred_def_66847,type,
    v116525: ( state_type * $int ) > $o ).

tff(pred_def_66848,type,
    v116395: state_type > $o ).

tff(pred_def_66849,type,
    v116528: state_type > $o ).

tff(pred_def_66850,type,
    v116529: state_type > $o ).

tff(pred_def_66851,type,
    v116527: state_type > $o ).

tff(pred_def_66852,type,
    v116530: state_type > $o ).

tff(pred_def_66853,type,
    v116526: state_type > $o ).

tff(pred_def_66854,type,
    v116394: state_type > $o ).

tff(pred_def_66855,type,
    v116531: state_type > $o ).

tff(pred_def_66856,type,
    v116393: state_type > $o ).

tff(pred_def_66857,type,
    v116392: state_type > $o ).

tff(pred_def_66858,type,
    v116535: state_type > $o ).

tff(pred_def_66859,type,
    v116536: state_type > $o ).

tff(pred_def_66860,type,
    v116534: state_type > $o ).

tff(pred_def_66861,type,
    v116537: state_type > $o ).

tff(pred_def_66862,type,
    v116533: state_type > $o ).

tff(pred_def_66863,type,
    v116532: state_type > $o ).

tff(pred_def_66864,type,
    v116391: state_type > $o ).

tff(pred_def_66865,type,
    v116538: state_type > $o ).

tff(pred_def_66866,type,
    v116390: state_type > $o ).

tff(pred_def_66867,type,
    v116541: state_type > $o ).

tff(pred_def_66868,type,
    v116542: state_type > $o ).

tff(pred_def_66869,type,
    v116540: state_type > $o ).

tff(pred_def_66870,type,
    v116543: state_type > $o ).

tff(pred_def_66871,type,
    v116539: state_type > $o ).

tff(pred_def_66872,type,
    v116546: state_type > $o ).

tff(pred_def_66873,type,
    v116547: state_type > $o ).

tff(pred_def_66874,type,
    v116545: state_type > $o ).

tff(pred_def_66875,type,
    v116548: state_type > $o ).

tff(pred_def_66876,type,
    v116544: state_type > $o ).

tff(pred_def_66877,type,
    v116388: ( state_type * $int ) > $o ).

tff(pred_def_66878,type,
    v116549: ( state_type * $int ) > $o ).

tff(pred_def_66879,type,
    v116387: state_type > $o ).

tff(pred_def_66880,type,
    v116552: state_type > $o ).

tff(pred_def_66881,type,
    v116553: state_type > $o ).

tff(pred_def_66882,type,
    v116551: state_type > $o ).

tff(pred_def_66883,type,
    v116554: state_type > $o ).

tff(pred_def_66884,type,
    v116550: state_type > $o ).

tff(pred_def_66885,type,
    v116386: state_type > $o ).

tff(pred_def_66886,type,
    v116555: state_type > $o ).

tff(pred_def_66887,type,
    v116385: state_type > $o ).

tff(pred_def_66888,type,
    v116384: state_type > $o ).

tff(pred_def_66889,type,
    v116559: state_type > $o ).

tff(pred_def_66890,type,
    v116560: state_type > $o ).

tff(pred_def_66891,type,
    v116558: state_type > $o ).

tff(pred_def_66892,type,
    v116561: state_type > $o ).

tff(pred_def_66893,type,
    v116557: state_type > $o ).

tff(pred_def_66894,type,
    v116556: state_type > $o ).

tff(pred_def_66895,type,
    v116383: state_type > $o ).

tff(pred_def_66896,type,
    v116562: state_type > $o ).

tff(pred_def_66897,type,
    v116382: state_type > $o ).

tff(pred_def_66898,type,
    v116565: state_type > $o ).

tff(pred_def_66899,type,
    v116566: state_type > $o ).

tff(pred_def_66900,type,
    v116564: state_type > $o ).

tff(pred_def_66901,type,
    v116567: state_type > $o ).

tff(pred_def_66902,type,
    v116563: state_type > $o ).

tff(pred_def_66903,type,
    v116570: state_type > $o ).

tff(pred_def_66904,type,
    v116571: state_type > $o ).

tff(pred_def_66905,type,
    v116569: state_type > $o ).

tff(pred_def_66906,type,
    v116572: state_type > $o ).

tff(pred_def_66907,type,
    v116568: state_type > $o ).

tff(pred_def_66908,type,
    v116380: ( state_type * $int ) > $o ).

tff(pred_def_66909,type,
    v116365: ( state_type * $int ) > $o ).

tff(pred_def_66910,type,
    v116582: state_type > $o ).

tff(pred_def_66911,type,
    v116580: state_type > $o ).

tff(pred_def_66912,type,
    v116579: state_type > $o ).

tff(pred_def_66913,type,
    v116578: ( state_type * $int ) > $o ).

tff(pred_def_66914,type,
    v116576: state_type > $o ).

tff(pred_def_66915,type,
    v116592: state_type > $o ).

tff(pred_def_66916,type,
    v116590: state_type > $o ).

tff(pred_def_66917,type,
    v116589: state_type > $o ).

tff(pred_def_66918,type,
    v116588: ( state_type * $int ) > $o ).

tff(pred_def_66919,type,
    v116586: state_type > $o ).

tff(pred_def_66920,type,
    v116602: state_type > $o ).

tff(pred_def_66921,type,
    v116600: state_type > $o ).

tff(pred_def_66922,type,
    v116599: state_type > $o ).

tff(pred_def_66923,type,
    v116598: ( state_type * $int ) > $o ).

tff(pred_def_66924,type,
    v116596: state_type > $o ).

tff(pred_def_66925,type,
    v116606: state_type > $o ).

tff(pred_def_66926,type,
    v116608: state_type > $o ).

tff(pred_def_66927,type,
    v116610: state_type > $o ).

tff(pred_def_66928,type,
    v116616: state_type > $o ).

tff(pred_def_66929,type,
    v116615: state_type > $o ).

tff(pred_def_66930,type,
    v116614: state_type > $o ).

tff(pred_def_66931,type,
    v116613: state_type > $o ).

tff(pred_def_66932,type,
    v116612: state_type > $o ).

tff(pred_def_66933,type,
    v116611: ( state_type * $int ) > $o ).

tff(pred_def_66934,type,
    v116574: ( state_type * $int ) > $o ).

tff(pred_def_66935,type,
    v116620: state_type > $o ).

tff(pred_def_66936,type,
    v116619: state_type > $o ).

tff(pred_def_66937,type,
    v116618: ( state_type * $int ) > $o ).

tff(pred_def_66938,type,
    v116649: ( state_type * $int ) > $o ).

tff(pred_def_66939,type,
    v116341: ( state_type * $int ) > $o ).

tff(pred_def_66940,type,
    v116648: state_type > $o ).

tff(pred_def_66941,type,
    v116652: state_type > $o ).

tff(pred_def_66942,type,
    v116653: state_type > $o ).

tff(pred_def_66943,type,
    v116651: state_type > $o ).

tff(pred_def_66944,type,
    v116654: state_type > $o ).

tff(pred_def_66945,type,
    v116650: state_type > $o ).

tff(pred_def_66946,type,
    v116647: state_type > $o ).

tff(pred_def_66947,type,
    v116655: state_type > $o ).

tff(pred_def_66948,type,
    v116646: state_type > $o ).

tff(pred_def_66949,type,
    v116658: state_type > $o ).

tff(pred_def_66950,type,
    v116659: state_type > $o ).

tff(pred_def_66951,type,
    v116657: state_type > $o ).

tff(pred_def_66952,type,
    v116660: state_type > $o ).

tff(pred_def_66953,type,
    v116656: state_type > $o ).

tff(pred_def_66954,type,
    v116645: state_type > $o ).

tff(pred_def_66955,type,
    v116661: state_type > $o ).

tff(pred_def_66956,type,
    v116644: state_type > $o ).

tff(pred_def_66957,type,
    v116664: state_type > $o ).

tff(pred_def_66958,type,
    v116665: state_type > $o ).

tff(pred_def_66959,type,
    v116663: state_type > $o ).

tff(pred_def_66960,type,
    v116666: state_type > $o ).

tff(pred_def_66961,type,
    v116662: state_type > $o ).

tff(pred_def_66962,type,
    v116643: state_type > $o ).

tff(pred_def_66963,type,
    v116667: state_type > $o ).

tff(pred_def_66964,type,
    v116642: state_type > $o ).

tff(pred_def_66965,type,
    v116670: state_type > $o ).

tff(pred_def_66966,type,
    v116671: state_type > $o ).

tff(pred_def_66967,type,
    v116669: state_type > $o ).

tff(pred_def_66968,type,
    v116672: state_type > $o ).

tff(pred_def_66969,type,
    v116668: state_type > $o ).

tff(pred_def_66970,type,
    v116641: state_type > $o ).

tff(pred_def_66971,type,
    v116673: state_type > $o ).

tff(pred_def_66972,type,
    v116640: state_type > $o ).

tff(pred_def_66973,type,
    v116639: state_type > $o ).

tff(pred_def_66974,type,
    v116677: state_type > $o ).

tff(pred_def_66975,type,
    v116678: state_type > $o ).

tff(pred_def_66976,type,
    v116676: state_type > $o ).

tff(pred_def_66977,type,
    v116679: state_type > $o ).

tff(pred_def_66978,type,
    v116675: state_type > $o ).

tff(pred_def_66979,type,
    v116674: state_type > $o ).

tff(pred_def_66980,type,
    v116638: state_type > $o ).

tff(pred_def_66981,type,
    v116680: state_type > $o ).

tff(pred_def_66982,type,
    v116637: state_type > $o ).

tff(pred_def_66983,type,
    v116683: state_type > $o ).

tff(pred_def_66984,type,
    v116684: state_type > $o ).

tff(pred_def_66985,type,
    v116682: state_type > $o ).

tff(pred_def_66986,type,
    v116685: state_type > $o ).

tff(pred_def_66987,type,
    v116681: state_type > $o ).

tff(pred_def_66988,type,
    v116688: state_type > $o ).

tff(pred_def_66989,type,
    v116689: state_type > $o ).

tff(pred_def_66990,type,
    v116687: state_type > $o ).

tff(pred_def_66991,type,
    v116690: state_type > $o ).

tff(pred_def_66992,type,
    v116686: state_type > $o ).

tff(pred_def_66993,type,
    v116693: state_type > $o ).

tff(pred_def_66994,type,
    v116694: state_type > $o ).

tff(pred_def_66995,type,
    v116692: state_type > $o ).

tff(pred_def_66996,type,
    v116695: state_type > $o ).

tff(pred_def_66997,type,
    v116691: state_type > $o ).

tff(pred_def_66998,type,
    v116698: state_type > $o ).

tff(pred_def_66999,type,
    v116699: state_type > $o ).

tff(pred_def_67000,type,
    v116697: state_type > $o ).

tff(pred_def_67001,type,
    v116700: state_type > $o ).

tff(pred_def_67002,type,
    v116696: state_type > $o ).

tff(pred_def_67003,type,
    v116703: state_type > $o ).

tff(pred_def_67004,type,
    v116704: state_type > $o ).

tff(pred_def_67005,type,
    v116702: state_type > $o ).

tff(pred_def_67006,type,
    v116705: state_type > $o ).

tff(pred_def_67007,type,
    v116701: state_type > $o ).

tff(pred_def_67008,type,
    v116635: ( state_type * $int ) > $o ).

tff(pred_def_67009,type,
    v116634: state_type > $o ).

tff(pred_def_67010,type,
    v116710: state_type > $o ).

tff(pred_def_67011,type,
    v116712: state_type > $o ).

tff(pred_def_67012,type,
    v116713: state_type > $o ).

tff(pred_def_67013,type,
    v116711: state_type > $o ).

tff(pred_def_67014,type,
    v116709: state_type > $o ).

tff(pred_def_67015,type,
    v116708: state_type > $o ).

tff(pred_def_67016,type,
    v116714: state_type > $o ).

tff(pred_def_67017,type,
    v116707: state_type > $o ).

tff(pred_def_67018,type,
    v116715: state_type > $o ).

tff(pred_def_67019,type,
    v116706: state_type > $o ).

tff(pred_def_67020,type,
    v116633: state_type > $o ).

tff(pred_def_67021,type,
    v116716: state_type > $o ).

tff(pred_def_67022,type,
    v116632: state_type > $o ).

tff(pred_def_67023,type,
    v116723: state_type > $o ).

tff(pred_def_67024,type,
    v116722: state_type > $o ).

tff(pred_def_67025,type,
    v116721: state_type > $o ).

tff(pred_def_67026,type,
    v116725: state_type > $o ).

tff(pred_def_67027,type,
    v116724: state_type > $o ).

tff(pred_def_67028,type,
    v116720: state_type > $o ).

tff(pred_def_67029,type,
    v116719: state_type > $o ).

tff(pred_def_67030,type,
    v116726: state_type > $o ).

tff(pred_def_67031,type,
    v116718: state_type > $o ).

tff(pred_def_67032,type,
    v116727: state_type > $o ).

tff(pred_def_67033,type,
    v116717: state_type > $o ).

tff(pred_def_67034,type,
    v116631: state_type > $o ).

tff(pred_def_67035,type,
    v116728: state_type > $o ).

tff(pred_def_67036,type,
    v116630: state_type > $o ).

tff(pred_def_67037,type,
    v116735: state_type > $o ).

tff(pred_def_67038,type,
    v116734: state_type > $o ).

tff(pred_def_67039,type,
    v116733: state_type > $o ).

tff(pred_def_67040,type,
    v116737: state_type > $o ).

tff(pred_def_67041,type,
    v116736: state_type > $o ).

tff(pred_def_67042,type,
    v116732: state_type > $o ).

tff(pred_def_67043,type,
    v116731: state_type > $o ).

tff(pred_def_67044,type,
    v116738: state_type > $o ).

tff(pred_def_67045,type,
    v116730: state_type > $o ).

tff(pred_def_67046,type,
    v116739: state_type > $o ).

tff(pred_def_67047,type,
    v116729: state_type > $o ).

tff(pred_def_67048,type,
    v116629: state_type > $o ).

tff(pred_def_67049,type,
    v116740: state_type > $o ).

tff(pred_def_67050,type,
    v116628: state_type > $o ).

tff(pred_def_67051,type,
    v116747: state_type > $o ).

tff(pred_def_67052,type,
    v116746: state_type > $o ).

tff(pred_def_67053,type,
    v116745: state_type > $o ).

tff(pred_def_67054,type,
    v116749: state_type > $o ).

tff(pred_def_67055,type,
    v116748: state_type > $o ).

tff(pred_def_67056,type,
    v116744: state_type > $o ).

tff(pred_def_67057,type,
    v116743: state_type > $o ).

tff(pred_def_67058,type,
    v116750: state_type > $o ).

tff(pred_def_67059,type,
    v116742: state_type > $o ).

tff(pred_def_67060,type,
    v116751: state_type > $o ).

tff(pred_def_67061,type,
    v116741: state_type > $o ).

tff(pred_def_67062,type,
    v116627: state_type > $o ).

tff(pred_def_67063,type,
    v116752: state_type > $o ).

tff(pred_def_67064,type,
    v116626: state_type > $o ).

tff(pred_def_67065,type,
    v116625: state_type > $o ).

tff(pred_def_67066,type,
    v116760: state_type > $o ).

tff(pred_def_67067,type,
    v116759: state_type > $o ).

tff(pred_def_67068,type,
    v116758: state_type > $o ).

tff(pred_def_67069,type,
    v116762: state_type > $o ).

tff(pred_def_67070,type,
    v116761: state_type > $o ).

tff(pred_def_67071,type,
    v116757: state_type > $o ).

tff(pred_def_67072,type,
    v116756: state_type > $o ).

tff(pred_def_67073,type,
    v116763: state_type > $o ).

tff(pred_def_67074,type,
    v116755: state_type > $o ).

tff(pred_def_67075,type,
    v116764: state_type > $o ).

tff(pred_def_67076,type,
    v116754: state_type > $o ).

tff(pred_def_67077,type,
    v116753: state_type > $o ).

tff(pred_def_67078,type,
    v116624: state_type > $o ).

tff(pred_def_67079,type,
    v116765: state_type > $o ).

tff(pred_def_67080,type,
    v116623: state_type > $o ).

tff(pred_def_67081,type,
    v116768: state_type > $o ).

tff(pred_def_67082,type,
    v116769: state_type > $o ).

tff(pred_def_67083,type,
    v116767: state_type > $o ).

tff(pred_def_67084,type,
    v116770: state_type > $o ).

tff(pred_def_67085,type,
    v116766: state_type > $o ).

tff(pred_def_67086,type,
    v116773: state_type > $o ).

tff(pred_def_67087,type,
    v116774: state_type > $o ).

tff(pred_def_67088,type,
    v116772: state_type > $o ).

tff(pred_def_67089,type,
    v116775: state_type > $o ).

tff(pred_def_67090,type,
    v116771: state_type > $o ).

tff(pred_def_67091,type,
    v116778: state_type > $o ).

tff(pred_def_67092,type,
    v116779: state_type > $o ).

tff(pred_def_67093,type,
    v116777: state_type > $o ).

tff(pred_def_67094,type,
    v116780: state_type > $o ).

tff(pred_def_67095,type,
    v116776: state_type > $o ).

tff(pred_def_67096,type,
    v116783: state_type > $o ).

tff(pred_def_67097,type,
    v116784: state_type > $o ).

tff(pred_def_67098,type,
    v116782: state_type > $o ).

tff(pred_def_67099,type,
    v116785: state_type > $o ).

tff(pred_def_67100,type,
    v116781: state_type > $o ).

tff(pred_def_67101,type,
    v116788: state_type > $o ).

tff(pred_def_67102,type,
    v116787: state_type > $o ).

tff(pred_def_67103,type,
    v116789: state_type > $o ).

tff(pred_def_67104,type,
    v116786: state_type > $o ).

tff(pred_def_67105,type,
    v116621: ( state_type * $int ) > $o ).

tff(pred_def_67106,type,
    v116361: ( state_type * $int ) > $o ).

tff(pred_def_67107,type,
    v116359: ( state_type * $int ) > $o ).

tff(pred_def_67108,type,
    v116357: ( state_type * $int ) > $o ).

tff(pred_def_67109,type,
    v116355: ( state_type * $int ) > $o ).

tff(pred_def_67110,type,
    v116795: state_type > $o ).

tff(pred_def_67111,type,
    v116793: state_type > $o ).

tff(pred_def_67112,type,
    v116791: state_type > $o ).

tff(pred_def_67113,type,
    v116802: state_type > $o ).

tff(pred_def_67114,type,
    v116800: state_type > $o ).

tff(pred_def_67115,type,
    v116799: state_type > $o ).

tff(pred_def_67116,type,
    v116798: state_type > $o ).

tff(pred_def_67117,type,
    v116810: state_type > $o ).

tff(pred_def_67118,type,
    v116811: state_type > $o ).

tff(pred_def_67119,type,
    v116809: state_type > $o ).

tff(pred_def_67120,type,
    v116806: ( state_type * $int ) > $o ).

tff(pred_def_67121,type,
    v116808: ( state_type * $int ) > $o ).

tff(pred_def_67122,type,
    v116345: ( state_type * $int ) > $o ).

tff(pred_def_67123,type,
    v116343: ( state_type * $int ) > $o ).

tff(pred_def_67124,type,
    v116815: state_type > $o ).

tff(pred_def_67125,type,
    v116817: state_type > $o ).

tff(pred_def_67126,type,
    v116818: state_type > $o ).

tff(pred_def_67127,type,
    v116339: state_type > $o ).

tff(pred_def_67128,type,
    v116820: state_type > $o ).

tff(pred_def_67129,type,
    v116822: state_type > $o ).

tff(pred_def_67130,type,
    v116828: state_type > $o ).

tff(pred_def_67131,type,
    v116830: state_type > $o ).

tff(pred_def_67132,type,
    v116840: state_type > $o ).

tff(pred_def_67133,type,
    v116841: state_type > $o ).

tff(pred_def_67134,type,
    v116839: state_type > $o ).

tff(pred_def_67135,type,
    v116843: state_type > $o ).

tff(pred_def_67136,type,
    v116844: state_type > $o ).

tff(pred_def_67137,type,
    v116842: state_type > $o ).

tff(pred_def_67138,type,
    v116838: state_type > $o ).

tff(pred_def_67139,type,
    v116837: state_type > $o ).

tff(pred_def_67140,type,
    v116836: state_type > $o ).

tff(pred_def_67141,type,
    v116835: state_type > $o ).

tff(pred_def_67142,type,
    v116309: ( state_type * $int ) > $o ).

tff(pred_def_67143,type,
    v116845: state_type > $o ).

tff(pred_def_67144,type,
    v116834: state_type > $o ).

tff(pred_def_67145,type,
    v116847: state_type > $o ).

tff(pred_def_67146,type,
    v116846: state_type > $o ).

tff(pred_def_67147,type,
    v116833: state_type > $o ).

tff(pred_def_67148,type,
    v116849: state_type > $o ).

tff(pred_def_67149,type,
    v116855: state_type > $o ).

tff(pred_def_67150,type,
    v116856: state_type > $o ).

tff(pred_def_67151,type,
    v116854: state_type > $o ).

tff(pred_def_67152,type,
    v116853: state_type > $o ).

tff(pred_def_67153,type,
    v116859: state_type > $o ).

tff(pred_def_67154,type,
    v116858: state_type > $o ).

tff(pred_def_67155,type,
    v116857: state_type > $o ).

tff(pred_def_67156,type,
    v116852: state_type > $o ).

tff(pred_def_67157,type,
    v116860: state_type > $o ).

tff(pred_def_67158,type,
    v116851: state_type > $o ).

tff(pred_def_67159,type,
    v116861: state_type > $o ).

tff(pred_def_67160,type,
    v116850: state_type > $o ).

tff(pred_def_67161,type,
    v116848: state_type > $o ).

tff(pred_def_67162,type,
    v116832: state_type > $o ).

tff(pred_def_67163,type,
    v116337: ( state_type * $int ) > $o ).

tff(pred_def_67164,type,
    v116862: ( state_type * $int ) > $o ).

tff(pred_def_67165,type,
    v116826: state_type > $o ).

tff(pred_def_67166,type,
    v116335: ( state_type * $int ) > $o ).

tff(pred_def_67167,type,
    v116333: ( state_type * $int ) > $o ).

tff(pred_def_67168,type,
    v116331: ( state_type * $int ) > $o ).

tff(pred_def_67169,type,
    v116866: state_type > $o ).

tff(pred_def_67170,type,
    v116864: state_type > $o ).

tff(pred_def_67171,type,
    v116873: state_type > $o ).

tff(pred_def_67172,type,
    v116871: state_type > $o ).

tff(pred_def_67173,type,
    v116870: state_type > $o ).

tff(pred_def_67174,type,
    v116869: state_type > $o ).

tff(pred_def_67175,type,
    v116881: state_type > $o ).

tff(pred_def_67176,type,
    v116882: state_type > $o ).

tff(pred_def_67177,type,
    v116880: state_type > $o ).

tff(pred_def_67178,type,
    v116877: ( state_type * $int ) > $o ).

tff(pred_def_67179,type,
    v116879: ( state_type * $int ) > $o ).

tff(pred_def_67180,type,
    v116868: ( state_type * $int ) > $o ).

tff(pred_def_67181,type,
    v116313: ( state_type * $int ) > $o ).

tff(pred_def_67182,type,
    v116311: ( state_type * $int ) > $o ).

tff(pred_def_67183,type,
    v116886: state_type > $o ).

tff(pred_def_67184,type,
    v116892: state_type > $o ).

tff(pred_def_67185,type,
    v116891: state_type > $o ).

tff(pred_def_67186,type,
    v116890: state_type > $o ).

tff(pred_def_67187,type,
    v116894: state_type > $o ).

tff(pred_def_67188,type,
    v116893: state_type > $o ).

tff(pred_def_67189,type,
    v116889: state_type > $o ).

tff(pred_def_67190,type,
    v116896: state_type > $o ).

tff(pred_def_67191,type,
    v116902: state_type > $o ).

tff(pred_def_67192,type,
    v116901: state_type > $o ).

tff(pred_def_67193,type,
    v116900: state_type > $o ).

tff(pred_def_67194,type,
    v116899: state_type > $o ).

tff(pred_def_67195,type,
    v116903: state_type > $o ).

tff(pred_def_67196,type,
    v116898: state_type > $o ).

tff(pred_def_67197,type,
    v116904: state_type > $o ).

tff(pred_def_67198,type,
    v116897: state_type > $o ).

tff(pred_def_67199,type,
    v116895: state_type > $o ).

tff(pred_def_67200,type,
    v116888: state_type > $o ).

tff(pred_def_67201,type,
    v116910: state_type > $o ).

tff(pred_def_67202,type,
    v116908: state_type > $o ).

tff(pred_def_67203,type,
    v116907: state_type > $o ).

tff(pred_def_67204,type,
    v116906: ( state_type * $int ) > $o ).

tff(pred_def_67205,type,
    v116920: state_type > $o ).

tff(pred_def_67206,type,
    v116919: state_type > $o ).

tff(pred_def_67207,type,
    v116918: state_type > $o ).

tff(pred_def_67208,type,
    v116917: state_type > $o ).

tff(pred_def_67209,type,
    v116922: state_type > $o ).

tff(pred_def_67210,type,
    v116923: state_type > $o ).

tff(pred_def_67211,type,
    v116921: state_type > $o ).

tff(pred_def_67212,type,
    v116916: state_type > $o ).

tff(pred_def_67213,type,
    v116926: state_type > $o ).

tff(pred_def_67214,type,
    v116925: state_type > $o ).

tff(pred_def_67215,type,
    v116927: state_type > $o ).

tff(pred_def_67216,type,
    v116924: state_type > $o ).

tff(pred_def_67217,type,
    v116915: state_type > $o ).

tff(pred_def_67218,type,
    v116931: state_type > $o ).

tff(pred_def_67219,type,
    v116930: state_type > $o ).

tff(pred_def_67220,type,
    v116929: state_type > $o ).

tff(pred_def_67221,type,
    v116932: state_type > $o ).

tff(pred_def_67222,type,
    v116928: state_type > $o ).

tff(pred_def_67223,type,
    v116914: state_type > $o ).

tff(pred_def_67224,type,
    v116939: state_type > $o ).

tff(pred_def_67225,type,
    v116937: state_type > $o ).

tff(pred_def_67226,type,
    v116936: state_type > $o ).

tff(pred_def_67227,type,
    v116935: ( state_type * $int ) > $o ).

tff(pred_def_67228,type,
    v116824: state_type > $o ).

tff(pred_def_67229,type,
    v116945: state_type > $o ).

tff(pred_def_67230,type,
    v116947: state_type > $o ).

tff(pred_def_67231,type,
    v116950: state_type > $o ).

tff(pred_def_67232,type,
    v116951: state_type > $o ).

tff(pred_def_67233,type,
    v116949: state_type > $o ).

tff(pred_def_67234,type,
    v116948: state_type > $o ).

tff(pred_def_67235,type,
    v116946: state_type > $o ).

tff(pred_def_67236,type,
    v116944: state_type > $o ).

tff(pred_def_67237,type,
    v116957: state_type > $o ).

tff(pred_def_67238,type,
    v116955: state_type > $o ).

tff(pred_def_67239,type,
    v116954: state_type > $o ).

tff(pred_def_67240,type,
    v116953: ( state_type * $int ) > $o ).

tff(pred_def_67241,type,
    v116971: state_type > $o ).

tff(pred_def_67242,type,
    v116969: state_type > $o ).

tff(pred_def_67243,type,
    v116975: state_type > $o ).

tff(pred_def_67244,type,
    v116973: state_type > $o ).

tff(pred_def_67245,type,
    v116987: state_type > $o ).

tff(pred_def_67246,type,
    v116988: state_type > $o ).

tff(pred_def_67247,type,
    v116985: state_type > $o ).

tff(pred_def_67248,type,
    v116963: ( state_type * $int ) > $o ).

tff(pred_def_67249,type,
    v116995: state_type > $o ).

tff(pred_def_67250,type,
    v116994: state_type > $o ).

tff(pred_def_67251,type,
    v116997: state_type > $o ).

tff(pred_def_67252,type,
    v116996: state_type > $o ).

tff(pred_def_67253,type,
    v116993: state_type > $o ).

tff(pred_def_67254,type,
    v116991: ( state_type * $int ) > $o ).

tff(pred_def_67255,type,
    v116961: state_type > $o ).

tff(pred_def_67256,type,
    v116990: ( state_type * $int ) > $o ).

tff(pred_def_67257,type,
    v116983: ( state_type * $int ) > $o ).

tff(pred_def_67258,type,
    v116981: ( state_type * $int ) > $o ).

tff(pred_def_67259,type,
    v116979: ( state_type * $int ) > $o ).

tff(pred_def_67260,type,
    v116977: ( state_type * $int ) > $o ).

tff(pred_def_67261,type,
    v117001: state_type > $o ).

tff(pred_def_67262,type,
    v116999: state_type > $o ).

tff(pred_def_67263,type,
    v117008: state_type > $o ).

tff(pred_def_67264,type,
    v117006: state_type > $o ).

tff(pred_def_67265,type,
    v117005: state_type > $o ).

tff(pred_def_67266,type,
    v117004: state_type > $o ).

tff(pred_def_67267,type,
    v117016: state_type > $o ).

tff(pred_def_67268,type,
    v117017: state_type > $o ).

tff(pred_def_67269,type,
    v117015: state_type > $o ).

tff(pred_def_67270,type,
    v117012: ( state_type * $int ) > $o ).

tff(pred_def_67271,type,
    v117014: ( state_type * $int ) > $o ).

tff(pred_def_67272,type,
    v116967: ( state_type * $int ) > $o ).

tff(pred_def_67273,type,
    v116965: ( state_type * $int ) > $o ).

tff(pred_def_67274,type,
    v117032: state_type > $o ).

tff(pred_def_67275,type,
    v117030: state_type > $o ).

tff(pred_def_67276,type,
    v117036: state_type > $o ).

tff(pred_def_67277,type,
    v117034: state_type > $o ).

tff(pred_def_67278,type,
    v117049: state_type > $o ).

tff(pred_def_67279,type,
    v117048: state_type > $o ).

tff(pred_def_67280,type,
    v117046: state_type > $o ).

tff(pred_def_67281,type,
    v117051: ( state_type * $int ) > $o ).

tff(pred_def_67282,type,
    v117053: state_type > $o ).

tff(pred_def_67283,type,
    v117056: ( state_type * $int ) > $o ).

tff(pred_def_67284,type,
    v117024: ( state_type * $int ) > $o ).

tff(pred_def_67285,type,
    v117071: state_type > $o ).

tff(pred_def_67286,type,
    v117070: state_type > $o ).

tff(pred_def_67287,type,
    v117069: state_type > $o ).

tff(pred_def_67288,type,
    v117072: state_type > $o ).

tff(pred_def_67289,type,
    v117068: state_type > $o ).

tff(pred_def_67290,type,
    v117067: state_type > $o ).

tff(pred_def_67291,type,
    v117073: state_type > $o ).

tff(pred_def_67292,type,
    v117066: state_type > $o ).

tff(pred_def_67293,type,
    v117065: state_type > $o ).

tff(pred_def_67294,type,
    v117064: state_type > $o ).

tff(pred_def_67295,type,
    v117063: state_type > $o ).

tff(pred_def_67296,type,
    v117075: state_type > $o ).

tff(pred_def_67297,type,
    v117074: state_type > $o ).

tff(pred_def_67298,type,
    v117062: state_type > $o ).

tff(pred_def_67299,type,
    v117078: state_type > $o ).

tff(pred_def_67300,type,
    v117077: state_type > $o ).

tff(pred_def_67301,type,
    v117079: state_type > $o ).

tff(pred_def_67302,type,
    v117076: state_type > $o ).

tff(pred_def_67303,type,
    v117082: state_type > $o ).

tff(pred_def_67304,type,
    v117081: state_type > $o ).

tff(pred_def_67305,type,
    v117083: state_type > $o ).

tff(pred_def_67306,type,
    v117080: state_type > $o ).

tff(pred_def_67307,type,
    v117086: state_type > $o ).

tff(pred_def_67308,type,
    v117085: state_type > $o ).

tff(pred_def_67309,type,
    v117087: state_type > $o ).

tff(pred_def_67310,type,
    v117084: state_type > $o ).

tff(pred_def_67311,type,
    v117060: ( state_type * $int ) > $o ).

tff(pred_def_67312,type,
    v117022: state_type > $o ).

tff(pred_def_67313,type,
    v117059: ( state_type * $int ) > $o ).

tff(pred_def_67314,type,
    v117058: ( state_type * $int ) > $o ).

tff(pred_def_67315,type,
    v117044: ( state_type * $int ) > $o ).

tff(pred_def_67316,type,
    v117042: ( state_type * $int ) > $o ).

tff(pred_def_67317,type,
    v117040: ( state_type * $int ) > $o ).

tff(pred_def_67318,type,
    v117038: ( state_type * $int ) > $o ).

tff(pred_def_67319,type,
    v117091: state_type > $o ).

tff(pred_def_67320,type,
    v117089: state_type > $o ).

tff(pred_def_67321,type,
    v117098: state_type > $o ).

tff(pred_def_67322,type,
    v117096: state_type > $o ).

tff(pred_def_67323,type,
    v117095: state_type > $o ).

tff(pred_def_67324,type,
    v117094: state_type > $o ).

tff(pred_def_67325,type,
    v117106: state_type > $o ).

tff(pred_def_67326,type,
    v117107: state_type > $o ).

tff(pred_def_67327,type,
    v117105: state_type > $o ).

tff(pred_def_67328,type,
    v117102: ( state_type * $int ) > $o ).

tff(pred_def_67329,type,
    v117104: ( state_type * $int ) > $o ).

tff(pred_def_67330,type,
    v117028: ( state_type * $int ) > $o ).

tff(pred_def_67331,type,
    v117026: ( state_type * $int ) > $o ).

tff(pred_def_67332,type,
    v117112: state_type > $o ).

tff(pred_def_67333,type,
    v116307: state_type > $o ).

tff(pred_def_67334,type,
    v117128: state_type > $o ).

tff(pred_def_67335,type,
    v117126: state_type > $o ).

tff(pred_def_67336,type,
    v117124: state_type > $o ).

tff(pred_def_67337,type,
    v117122: state_type > $o ).

tff(pred_def_67338,type,
    v117136: state_type > $o ).

tff(pred_def_67339,type,
    v117134: state_type > $o ).

tff(pred_def_67340,type,
    v117132: state_type > $o ).

tff(pred_def_67341,type,
    v117130: state_type > $o ).

tff(pred_def_67342,type,
    v117156: state_type > $o ).

tff(pred_def_67343,type,
    v117154: state_type > $o ).

tff(pred_def_67344,type,
    v117160: state_type > $o ).

tff(pred_def_67345,type,
    v117158: state_type > $o ).

tff(pred_def_67346,type,
    v117172: state_type > $o ).

tff(pred_def_67347,type,
    v117174: state_type > $o ).

tff(pred_def_67348,type,
    v117176: state_type > $o ).

tff(pred_def_67349,type,
    v117178: state_type > $o ).

tff(pred_def_67350,type,
    v117180: state_type > $o ).

tff(pred_def_67351,type,
    v117182: state_type > $o ).

tff(pred_def_67352,type,
    v117184: state_type > $o ).

tff(pred_def_67353,type,
    v117233: ( state_type * $int ) > $o ).

tff(pred_def_67354,type,
    v117234: ( state_type * $int ) > $o ).

tff(pred_def_67355,type,
    v117232: state_type > $o ).

tff(pred_def_67356,type,
    v117237: state_type > $o ).

tff(pred_def_67357,type,
    v117238: state_type > $o ).

tff(pred_def_67358,type,
    v117236: state_type > $o ).

tff(pred_def_67359,type,
    v117239: state_type > $o ).

tff(pred_def_67360,type,
    v117235: state_type > $o ).

tff(pred_def_67361,type,
    v117231: state_type > $o ).

tff(pred_def_67362,type,
    v117240: state_type > $o ).

tff(pred_def_67363,type,
    v117230: state_type > $o ).

tff(pred_def_67364,type,
    v117229: state_type > $o ).

tff(pred_def_67365,type,
    v117244: state_type > $o ).

tff(pred_def_67366,type,
    v117245: state_type > $o ).

tff(pred_def_67367,type,
    v117243: state_type > $o ).

tff(pred_def_67368,type,
    v117246: state_type > $o ).

tff(pred_def_67369,type,
    v117242: state_type > $o ).

tff(pred_def_67370,type,
    v117241: state_type > $o ).

tff(pred_def_67371,type,
    v117228: state_type > $o ).

tff(pred_def_67372,type,
    v117247: state_type > $o ).

tff(pred_def_67373,type,
    v117227: state_type > $o ).

tff(pred_def_67374,type,
    v117250: state_type > $o ).

tff(pred_def_67375,type,
    v117251: state_type > $o ).

tff(pred_def_67376,type,
    v117249: state_type > $o ).

tff(pred_def_67377,type,
    v117252: state_type > $o ).

tff(pred_def_67378,type,
    v117248: state_type > $o ).

tff(pred_def_67379,type,
    v117255: state_type > $o ).

tff(pred_def_67380,type,
    v117256: state_type > $o ).

tff(pred_def_67381,type,
    v117254: state_type > $o ).

tff(pred_def_67382,type,
    v117257: state_type > $o ).

tff(pred_def_67383,type,
    v117253: state_type > $o ).

tff(pred_def_67384,type,
    v117225: ( state_type * $int ) > $o ).

tff(pred_def_67385,type,
    v117258: ( state_type * $int ) > $o ).

tff(pred_def_67386,type,
    v117224: state_type > $o ).

tff(pred_def_67387,type,
    v117261: state_type > $o ).

tff(pred_def_67388,type,
    v117262: state_type > $o ).

tff(pred_def_67389,type,
    v117260: state_type > $o ).

tff(pred_def_67390,type,
    v117263: state_type > $o ).

tff(pred_def_67391,type,
    v117259: state_type > $o ).

tff(pred_def_67392,type,
    v117223: state_type > $o ).

tff(pred_def_67393,type,
    v117264: state_type > $o ).

tff(pred_def_67394,type,
    v117222: state_type > $o ).

tff(pred_def_67395,type,
    v117221: state_type > $o ).

tff(pred_def_67396,type,
    v117268: state_type > $o ).

tff(pred_def_67397,type,
    v117269: state_type > $o ).

tff(pred_def_67398,type,
    v117267: state_type > $o ).

tff(pred_def_67399,type,
    v117270: state_type > $o ).

tff(pred_def_67400,type,
    v117266: state_type > $o ).

tff(pred_def_67401,type,
    v117265: state_type > $o ).

tff(pred_def_67402,type,
    v117220: state_type > $o ).

tff(pred_def_67403,type,
    v117271: state_type > $o ).

tff(pred_def_67404,type,
    v117219: state_type > $o ).

tff(pred_def_67405,type,
    v117274: state_type > $o ).

tff(pred_def_67406,type,
    v117275: state_type > $o ).

tff(pred_def_67407,type,
    v117273: state_type > $o ).

tff(pred_def_67408,type,
    v117276: state_type > $o ).

tff(pred_def_67409,type,
    v117272: state_type > $o ).

tff(pred_def_67410,type,
    v117279: state_type > $o ).

tff(pred_def_67411,type,
    v117280: state_type > $o ).

tff(pred_def_67412,type,
    v117278: state_type > $o ).

tff(pred_def_67413,type,
    v117281: state_type > $o ).

tff(pred_def_67414,type,
    v117277: state_type > $o ).

tff(pred_def_67415,type,
    v117217: ( state_type * $int ) > $o ).

tff(pred_def_67416,type,
    v117282: ( state_type * $int ) > $o ).

tff(pred_def_67417,type,
    v117216: state_type > $o ).

tff(pred_def_67418,type,
    v117285: state_type > $o ).

tff(pred_def_67419,type,
    v117286: state_type > $o ).

tff(pred_def_67420,type,
    v117284: state_type > $o ).

tff(pred_def_67421,type,
    v117287: state_type > $o ).

tff(pred_def_67422,type,
    v117283: state_type > $o ).

tff(pred_def_67423,type,
    v117215: state_type > $o ).

tff(pred_def_67424,type,
    v117288: state_type > $o ).

tff(pred_def_67425,type,
    v117214: state_type > $o ).

tff(pred_def_67426,type,
    v117213: state_type > $o ).

tff(pred_def_67427,type,
    v117292: state_type > $o ).

tff(pred_def_67428,type,
    v117293: state_type > $o ).

tff(pred_def_67429,type,
    v117291: state_type > $o ).

tff(pred_def_67430,type,
    v117294: state_type > $o ).

tff(pred_def_67431,type,
    v117290: state_type > $o ).

tff(pred_def_67432,type,
    v117289: state_type > $o ).

tff(pred_def_67433,type,
    v117212: state_type > $o ).

tff(pred_def_67434,type,
    v117295: state_type > $o ).

tff(pred_def_67435,type,
    v117211: state_type > $o ).

tff(pred_def_67436,type,
    v117298: state_type > $o ).

tff(pred_def_67437,type,
    v117299: state_type > $o ).

tff(pred_def_67438,type,
    v117297: state_type > $o ).

tff(pred_def_67439,type,
    v117300: state_type > $o ).

tff(pred_def_67440,type,
    v117296: state_type > $o ).

tff(pred_def_67441,type,
    v117303: state_type > $o ).

tff(pred_def_67442,type,
    v117304: state_type > $o ).

tff(pred_def_67443,type,
    v117302: state_type > $o ).

tff(pred_def_67444,type,
    v117305: state_type > $o ).

tff(pred_def_67445,type,
    v117301: state_type > $o ).

tff(pred_def_67446,type,
    v117209: ( state_type * $int ) > $o ).

tff(pred_def_67447,type,
    v117306: ( state_type * $int ) > $o ).

tff(pred_def_67448,type,
    v117208: state_type > $o ).

tff(pred_def_67449,type,
    v117309: state_type > $o ).

tff(pred_def_67450,type,
    v117310: state_type > $o ).

tff(pred_def_67451,type,
    v117308: state_type > $o ).

tff(pred_def_67452,type,
    v117311: state_type > $o ).

tff(pred_def_67453,type,
    v117307: state_type > $o ).

tff(pred_def_67454,type,
    v117207: state_type > $o ).

tff(pred_def_67455,type,
    v117312: state_type > $o ).

tff(pred_def_67456,type,
    v117206: state_type > $o ).

tff(pred_def_67457,type,
    v117205: state_type > $o ).

tff(pred_def_67458,type,
    v117316: state_type > $o ).

tff(pred_def_67459,type,
    v117317: state_type > $o ).

tff(pred_def_67460,type,
    v117315: state_type > $o ).

tff(pred_def_67461,type,
    v117318: state_type > $o ).

tff(pred_def_67462,type,
    v117314: state_type > $o ).

tff(pred_def_67463,type,
    v117313: state_type > $o ).

tff(pred_def_67464,type,
    v117204: state_type > $o ).

tff(pred_def_67465,type,
    v117319: state_type > $o ).

tff(pred_def_67466,type,
    v117203: state_type > $o ).

tff(pred_def_67467,type,
    v117322: state_type > $o ).

tff(pred_def_67468,type,
    v117323: state_type > $o ).

tff(pred_def_67469,type,
    v117321: state_type > $o ).

tff(pred_def_67470,type,
    v117324: state_type > $o ).

tff(pred_def_67471,type,
    v117320: state_type > $o ).

tff(pred_def_67472,type,
    v117327: state_type > $o ).

tff(pred_def_67473,type,
    v117328: state_type > $o ).

tff(pred_def_67474,type,
    v117326: state_type > $o ).

tff(pred_def_67475,type,
    v117329: state_type > $o ).

tff(pred_def_67476,type,
    v117325: state_type > $o ).

tff(pred_def_67477,type,
    v117201: ( state_type * $int ) > $o ).

tff(pred_def_67478,type,
    v117330: ( state_type * $int ) > $o ).

tff(pred_def_67479,type,
    v117200: state_type > $o ).

tff(pred_def_67480,type,
    v117333: state_type > $o ).

tff(pred_def_67481,type,
    v117334: state_type > $o ).

tff(pred_def_67482,type,
    v117332: state_type > $o ).

tff(pred_def_67483,type,
    v117335: state_type > $o ).

tff(pred_def_67484,type,
    v117331: state_type > $o ).

tff(pred_def_67485,type,
    v117199: state_type > $o ).

tff(pred_def_67486,type,
    v117336: state_type > $o ).

tff(pred_def_67487,type,
    v117198: state_type > $o ).

tff(pred_def_67488,type,
    v117197: state_type > $o ).

tff(pred_def_67489,type,
    v117340: state_type > $o ).

tff(pred_def_67490,type,
    v117341: state_type > $o ).

tff(pred_def_67491,type,
    v117339: state_type > $o ).

tff(pred_def_67492,type,
    v117342: state_type > $o ).

tff(pred_def_67493,type,
    v117338: state_type > $o ).

tff(pred_def_67494,type,
    v117337: state_type > $o ).

tff(pred_def_67495,type,
    v117196: state_type > $o ).

tff(pred_def_67496,type,
    v117343: state_type > $o ).

tff(pred_def_67497,type,
    v117195: state_type > $o ).

tff(pred_def_67498,type,
    v117346: state_type > $o ).

tff(pred_def_67499,type,
    v117347: state_type > $o ).

tff(pred_def_67500,type,
    v117345: state_type > $o ).

tff(pred_def_67501,type,
    v117348: state_type > $o ).

tff(pred_def_67502,type,
    v117344: state_type > $o ).

tff(pred_def_67503,type,
    v117351: state_type > $o ).

tff(pred_def_67504,type,
    v117352: state_type > $o ).

tff(pred_def_67505,type,
    v117350: state_type > $o ).

tff(pred_def_67506,type,
    v117353: state_type > $o ).

tff(pred_def_67507,type,
    v117349: state_type > $o ).

tff(pred_def_67508,type,
    v117193: ( state_type * $int ) > $o ).

tff(pred_def_67509,type,
    v117354: ( state_type * $int ) > $o ).

tff(pred_def_67510,type,
    v117192: state_type > $o ).

tff(pred_def_67511,type,
    v117357: state_type > $o ).

tff(pred_def_67512,type,
    v117358: state_type > $o ).

tff(pred_def_67513,type,
    v117356: state_type > $o ).

tff(pred_def_67514,type,
    v117359: state_type > $o ).

tff(pred_def_67515,type,
    v117355: state_type > $o ).

tff(pred_def_67516,type,
    v117191: state_type > $o ).

tff(pred_def_67517,type,
    v117360: state_type > $o ).

tff(pred_def_67518,type,
    v117190: state_type > $o ).

tff(pred_def_67519,type,
    v117189: state_type > $o ).

tff(pred_def_67520,type,
    v117364: state_type > $o ).

tff(pred_def_67521,type,
    v117365: state_type > $o ).

tff(pred_def_67522,type,
    v117363: state_type > $o ).

tff(pred_def_67523,type,
    v117366: state_type > $o ).

tff(pred_def_67524,type,
    v117362: state_type > $o ).

tff(pred_def_67525,type,
    v117361: state_type > $o ).

tff(pred_def_67526,type,
    v117188: state_type > $o ).

tff(pred_def_67527,type,
    v117367: state_type > $o ).

tff(pred_def_67528,type,
    v117187: state_type > $o ).

tff(pred_def_67529,type,
    v117370: state_type > $o ).

tff(pred_def_67530,type,
    v117371: state_type > $o ).

tff(pred_def_67531,type,
    v117369: state_type > $o ).

tff(pred_def_67532,type,
    v117372: state_type > $o ).

tff(pred_def_67533,type,
    v117368: state_type > $o ).

tff(pred_def_67534,type,
    v117375: state_type > $o ).

tff(pred_def_67535,type,
    v117376: state_type > $o ).

tff(pred_def_67536,type,
    v117374: state_type > $o ).

tff(pred_def_67537,type,
    v117377: state_type > $o ).

tff(pred_def_67538,type,
    v117373: state_type > $o ).

tff(pred_def_67539,type,
    v117185: ( state_type * $int ) > $o ).

tff(pred_def_67540,type,
    v117170: ( state_type * $int ) > $o ).

tff(pred_def_67541,type,
    v117387: state_type > $o ).

tff(pred_def_67542,type,
    v117385: state_type > $o ).

tff(pred_def_67543,type,
    v117384: state_type > $o ).

tff(pred_def_67544,type,
    v117383: ( state_type * $int ) > $o ).

tff(pred_def_67545,type,
    v117381: state_type > $o ).

tff(pred_def_67546,type,
    v117397: state_type > $o ).

tff(pred_def_67547,type,
    v117395: state_type > $o ).

tff(pred_def_67548,type,
    v117394: state_type > $o ).

tff(pred_def_67549,type,
    v117393: ( state_type * $int ) > $o ).

tff(pred_def_67550,type,
    v117391: state_type > $o ).

tff(pred_def_67551,type,
    v117407: state_type > $o ).

tff(pred_def_67552,type,
    v117405: state_type > $o ).

tff(pred_def_67553,type,
    v117404: state_type > $o ).

tff(pred_def_67554,type,
    v117403: ( state_type * $int ) > $o ).

tff(pred_def_67555,type,
    v117401: state_type > $o ).

tff(pred_def_67556,type,
    v117411: state_type > $o ).

tff(pred_def_67557,type,
    v117413: state_type > $o ).

tff(pred_def_67558,type,
    v117415: state_type > $o ).

tff(pred_def_67559,type,
    v117421: state_type > $o ).

tff(pred_def_67560,type,
    v117420: state_type > $o ).

tff(pred_def_67561,type,
    v117419: state_type > $o ).

tff(pred_def_67562,type,
    v117418: state_type > $o ).

tff(pred_def_67563,type,
    v117417: state_type > $o ).

tff(pred_def_67564,type,
    v117416: ( state_type * $int ) > $o ).

tff(pred_def_67565,type,
    v117379: ( state_type * $int ) > $o ).

tff(pred_def_67566,type,
    v117450: ( state_type * $int ) > $o ).

tff(pred_def_67567,type,
    v117148: ( state_type * $int ) > $o ).

tff(pred_def_67568,type,
    v117449: state_type > $o ).

tff(pred_def_67569,type,
    v117453: state_type > $o ).

tff(pred_def_67570,type,
    v117454: state_type > $o ).

tff(pred_def_67571,type,
    v117452: state_type > $o ).

tff(pred_def_67572,type,
    v117455: state_type > $o ).

tff(pred_def_67573,type,
    v117451: state_type > $o ).

tff(pred_def_67574,type,
    v117448: state_type > $o ).

tff(pred_def_67575,type,
    v117456: state_type > $o ).

tff(pred_def_67576,type,
    v117447: state_type > $o ).

tff(pred_def_67577,type,
    v117459: state_type > $o ).

tff(pred_def_67578,type,
    v117460: state_type > $o ).

tff(pred_def_67579,type,
    v117458: state_type > $o ).

tff(pred_def_67580,type,
    v117461: state_type > $o ).

tff(pred_def_67581,type,
    v117457: state_type > $o ).

tff(pred_def_67582,type,
    v117446: state_type > $o ).

tff(pred_def_67583,type,
    v117462: state_type > $o ).

tff(pred_def_67584,type,
    v117445: state_type > $o ).

tff(pred_def_67585,type,
    v117465: state_type > $o ).

tff(pred_def_67586,type,
    v117466: state_type > $o ).

tff(pred_def_67587,type,
    v117464: state_type > $o ).

tff(pred_def_67588,type,
    v117467: state_type > $o ).

tff(pred_def_67589,type,
    v117463: state_type > $o ).

tff(pred_def_67590,type,
    v117444: state_type > $o ).

tff(pred_def_67591,type,
    v117468: state_type > $o ).

tff(pred_def_67592,type,
    v117443: state_type > $o ).

tff(pred_def_67593,type,
    v117471: state_type > $o ).

tff(pred_def_67594,type,
    v117472: state_type > $o ).

tff(pred_def_67595,type,
    v117470: state_type > $o ).

tff(pred_def_67596,type,
    v117473: state_type > $o ).

tff(pred_def_67597,type,
    v117469: state_type > $o ).

tff(pred_def_67598,type,
    v117442: state_type > $o ).

tff(pred_def_67599,type,
    v117474: state_type > $o ).

tff(pred_def_67600,type,
    v117441: state_type > $o ).

tff(pred_def_67601,type,
    v117440: state_type > $o ).

tff(pred_def_67602,type,
    v117478: state_type > $o ).

tff(pred_def_67603,type,
    v117479: state_type > $o ).

tff(pred_def_67604,type,
    v117477: state_type > $o ).

tff(pred_def_67605,type,
    v117480: state_type > $o ).

tff(pred_def_67606,type,
    v117476: state_type > $o ).

tff(pred_def_67607,type,
    v117475: state_type > $o ).

tff(pred_def_67608,type,
    v117439: state_type > $o ).

tff(pred_def_67609,type,
    v117481: state_type > $o ).

tff(pred_def_67610,type,
    v117438: state_type > $o ).

tff(pred_def_67611,type,
    v117484: state_type > $o ).

tff(pred_def_67612,type,
    v117485: state_type > $o ).

tff(pred_def_67613,type,
    v117483: state_type > $o ).

tff(pred_def_67614,type,
    v117486: state_type > $o ).

tff(pred_def_67615,type,
    v117482: state_type > $o ).

tff(pred_def_67616,type,
    v117489: state_type > $o ).

tff(pred_def_67617,type,
    v117490: state_type > $o ).

tff(pred_def_67618,type,
    v117488: state_type > $o ).

tff(pred_def_67619,type,
    v117491: state_type > $o ).

tff(pred_def_67620,type,
    v117487: state_type > $o ).

tff(pred_def_67621,type,
    v117494: state_type > $o ).

tff(pred_def_67622,type,
    v117495: state_type > $o ).

tff(pred_def_67623,type,
    v117493: state_type > $o ).

tff(pred_def_67624,type,
    v117496: state_type > $o ).

tff(pred_def_67625,type,
    v117492: state_type > $o ).

tff(pred_def_67626,type,
    v117499: state_type > $o ).

tff(pred_def_67627,type,
    v117500: state_type > $o ).

tff(pred_def_67628,type,
    v117498: state_type > $o ).

tff(pred_def_67629,type,
    v117501: state_type > $o ).

tff(pred_def_67630,type,
    v117497: state_type > $o ).

tff(pred_def_67631,type,
    v117504: state_type > $o ).

tff(pred_def_67632,type,
    v117505: state_type > $o ).

tff(pred_def_67633,type,
    v117503: state_type > $o ).

tff(pred_def_67634,type,
    v117506: state_type > $o ).

tff(pred_def_67635,type,
    v117502: state_type > $o ).

tff(pred_def_67636,type,
    v117436: ( state_type * $int ) > $o ).

tff(pred_def_67637,type,
    v117435: state_type > $o ).

tff(pred_def_67638,type,
    v117511: state_type > $o ).

tff(pred_def_67639,type,
    v117513: state_type > $o ).

tff(pred_def_67640,type,
    v117514: state_type > $o ).

tff(pred_def_67641,type,
    v117512: state_type > $o ).

tff(pred_def_67642,type,
    v117510: state_type > $o ).

tff(pred_def_67643,type,
    v117509: state_type > $o ).

tff(pred_def_67644,type,
    v117515: state_type > $o ).

tff(pred_def_67645,type,
    v117508: state_type > $o ).

tff(pred_def_67646,type,
    v117516: state_type > $o ).

tff(pred_def_67647,type,
    v117507: state_type > $o ).

tff(pred_def_67648,type,
    v117434: state_type > $o ).

tff(pred_def_67649,type,
    v117517: state_type > $o ).

tff(pred_def_67650,type,
    v117433: state_type > $o ).

tff(pred_def_67651,type,
    v117524: state_type > $o ).

tff(pred_def_67652,type,
    v117523: state_type > $o ).

tff(pred_def_67653,type,
    v117522: state_type > $o ).

tff(pred_def_67654,type,
    v117526: state_type > $o ).

tff(pred_def_67655,type,
    v117525: state_type > $o ).

tff(pred_def_67656,type,
    v117521: state_type > $o ).

tff(pred_def_67657,type,
    v117520: state_type > $o ).

tff(pred_def_67658,type,
    v117527: state_type > $o ).

tff(pred_def_67659,type,
    v117519: state_type > $o ).

tff(pred_def_67660,type,
    v117528: state_type > $o ).

tff(pred_def_67661,type,
    v117518: state_type > $o ).

tff(pred_def_67662,type,
    v117432: state_type > $o ).

tff(pred_def_67663,type,
    v117529: state_type > $o ).

tff(pred_def_67664,type,
    v117431: state_type > $o ).

tff(pred_def_67665,type,
    v117536: state_type > $o ).

tff(pred_def_67666,type,
    v117535: state_type > $o ).

tff(pred_def_67667,type,
    v117534: state_type > $o ).

tff(pred_def_67668,type,
    v117538: state_type > $o ).

tff(pred_def_67669,type,
    v117537: state_type > $o ).

tff(pred_def_67670,type,
    v117533: state_type > $o ).

tff(pred_def_67671,type,
    v117532: state_type > $o ).

tff(pred_def_67672,type,
    v117539: state_type > $o ).

tff(pred_def_67673,type,
    v117531: state_type > $o ).

tff(pred_def_67674,type,
    v117540: state_type > $o ).

tff(pred_def_67675,type,
    v117530: state_type > $o ).

tff(pred_def_67676,type,
    v117430: state_type > $o ).

tff(pred_def_67677,type,
    v117541: state_type > $o ).

tff(pred_def_67678,type,
    v117429: state_type > $o ).

tff(pred_def_67679,type,
    v117548: state_type > $o ).

tff(pred_def_67680,type,
    v117547: state_type > $o ).

tff(pred_def_67681,type,
    v117546: state_type > $o ).

tff(pred_def_67682,type,
    v117550: state_type > $o ).

tff(pred_def_67683,type,
    v117549: state_type > $o ).

tff(pred_def_67684,type,
    v117545: state_type > $o ).

tff(pred_def_67685,type,
    v117544: state_type > $o ).

tff(pred_def_67686,type,
    v117551: state_type > $o ).

tff(pred_def_67687,type,
    v117543: state_type > $o ).

tff(pred_def_67688,type,
    v117552: state_type > $o ).

tff(pred_def_67689,type,
    v117542: state_type > $o ).

tff(pred_def_67690,type,
    v117428: state_type > $o ).

tff(pred_def_67691,type,
    v117553: state_type > $o ).

tff(pred_def_67692,type,
    v117427: state_type > $o ).

tff(pred_def_67693,type,
    v117426: state_type > $o ).

tff(pred_def_67694,type,
    v117561: state_type > $o ).

tff(pred_def_67695,type,
    v117560: state_type > $o ).

tff(pred_def_67696,type,
    v117559: state_type > $o ).

tff(pred_def_67697,type,
    v117563: state_type > $o ).

tff(pred_def_67698,type,
    v117562: state_type > $o ).

tff(pred_def_67699,type,
    v117558: state_type > $o ).

tff(pred_def_67700,type,
    v117557: state_type > $o ).

tff(pred_def_67701,type,
    v117564: state_type > $o ).

tff(pred_def_67702,type,
    v117556: state_type > $o ).

tff(pred_def_67703,type,
    v117565: state_type > $o ).

tff(pred_def_67704,type,
    v117555: state_type > $o ).

tff(pred_def_67705,type,
    v117554: state_type > $o ).

tff(pred_def_67706,type,
    v117425: state_type > $o ).

tff(pred_def_67707,type,
    v117566: state_type > $o ).

tff(pred_def_67708,type,
    v117424: state_type > $o ).

tff(pred_def_67709,type,
    v117569: state_type > $o ).

tff(pred_def_67710,type,
    v117570: state_type > $o ).

tff(pred_def_67711,type,
    v117568: state_type > $o ).

tff(pred_def_67712,type,
    v117571: state_type > $o ).

tff(pred_def_67713,type,
    v117567: state_type > $o ).

tff(pred_def_67714,type,
    v117574: state_type > $o ).

tff(pred_def_67715,type,
    v117575: state_type > $o ).

tff(pred_def_67716,type,
    v117573: state_type > $o ).

tff(pred_def_67717,type,
    v117576: state_type > $o ).

tff(pred_def_67718,type,
    v117572: state_type > $o ).

tff(pred_def_67719,type,
    v117579: state_type > $o ).

tff(pred_def_67720,type,
    v117580: state_type > $o ).

tff(pred_def_67721,type,
    v117578: state_type > $o ).

tff(pred_def_67722,type,
    v117581: state_type > $o ).

tff(pred_def_67723,type,
    v117577: state_type > $o ).

tff(pred_def_67724,type,
    v117584: state_type > $o ).

tff(pred_def_67725,type,
    v117585: state_type > $o ).

tff(pred_def_67726,type,
    v117583: state_type > $o ).

tff(pred_def_67727,type,
    v117586: state_type > $o ).

tff(pred_def_67728,type,
    v117582: state_type > $o ).

tff(pred_def_67729,type,
    v117589: state_type > $o ).

tff(pred_def_67730,type,
    v117588: state_type > $o ).

tff(pred_def_67731,type,
    v117590: state_type > $o ).

tff(pred_def_67732,type,
    v117587: state_type > $o ).

tff(pred_def_67733,type,
    v117168: ( state_type * $int ) > $o ).

tff(pred_def_67734,type,
    v117166: ( state_type * $int ) > $o ).

tff(pred_def_67735,type,
    v117164: ( state_type * $int ) > $o ).

tff(pred_def_67736,type,
    v117162: ( state_type * $int ) > $o ).

tff(pred_def_67737,type,
    v117596: state_type > $o ).

tff(pred_def_67738,type,
    v117594: state_type > $o ).

tff(pred_def_67739,type,
    v117592: state_type > $o ).

tff(pred_def_67740,type,
    v117603: state_type > $o ).

tff(pred_def_67741,type,
    v117601: state_type > $o ).

tff(pred_def_67742,type,
    v117600: state_type > $o ).

tff(pred_def_67743,type,
    v117599: state_type > $o ).

tff(pred_def_67744,type,
    v117611: state_type > $o ).

tff(pred_def_67745,type,
    v117612: state_type > $o ).

tff(pred_def_67746,type,
    v117610: state_type > $o ).

tff(pred_def_67747,type,
    v117607: ( state_type * $int ) > $o ).

tff(pred_def_67748,type,
    v117609: ( state_type * $int ) > $o ).

tff(pred_def_67749,type,
    v117152: ( state_type * $int ) > $o ).

tff(pred_def_67750,type,
    v117150: ( state_type * $int ) > $o ).

tff(pred_def_67751,type,
    v117616: state_type > $o ).

tff(pred_def_67752,type,
    v117618: state_type > $o ).

tff(pred_def_67753,type,
    v117619: state_type > $o ).

tff(pred_def_67754,type,
    v117146: state_type > $o ).

tff(pred_def_67755,type,
    v117621: state_type > $o ).

tff(pred_def_67756,type,
    v117623: state_type > $o ).

tff(pred_def_67757,type,
    v117629: state_type > $o ).

tff(pred_def_67758,type,
    v117631: state_type > $o ).

tff(pred_def_67759,type,
    v117641: state_type > $o ).

tff(pred_def_67760,type,
    v117642: state_type > $o ).

tff(pred_def_67761,type,
    v117640: state_type > $o ).

tff(pred_def_67762,type,
    v117644: state_type > $o ).

tff(pred_def_67763,type,
    v117645: state_type > $o ).

tff(pred_def_67764,type,
    v117643: state_type > $o ).

tff(pred_def_67765,type,
    v117639: state_type > $o ).

tff(pred_def_67766,type,
    v117638: state_type > $o ).

tff(pred_def_67767,type,
    v117637: state_type > $o ).

tff(pred_def_67768,type,
    v117636: state_type > $o ).

tff(pred_def_67769,type,
    v117116: ( state_type * $int ) > $o ).

tff(pred_def_67770,type,
    v117646: state_type > $o ).

tff(pred_def_67771,type,
    v117635: state_type > $o ).

tff(pred_def_67772,type,
    v117648: state_type > $o ).

tff(pred_def_67773,type,
    v117647: state_type > $o ).

tff(pred_def_67774,type,
    v117634: state_type > $o ).

tff(pred_def_67775,type,
    v117650: state_type > $o ).

tff(pred_def_67776,type,
    v117656: state_type > $o ).

tff(pred_def_67777,type,
    v117657: state_type > $o ).

tff(pred_def_67778,type,
    v117655: state_type > $o ).

tff(pred_def_67779,type,
    v117654: state_type > $o ).

tff(pred_def_67780,type,
    v117660: state_type > $o ).

tff(pred_def_67781,type,
    v117659: state_type > $o ).

tff(pred_def_67782,type,
    v117658: state_type > $o ).

tff(pred_def_67783,type,
    v117653: state_type > $o ).

tff(pred_def_67784,type,
    v117661: state_type > $o ).

tff(pred_def_67785,type,
    v117652: state_type > $o ).

tff(pred_def_67786,type,
    v117662: state_type > $o ).

tff(pred_def_67787,type,
    v117651: state_type > $o ).

tff(pred_def_67788,type,
    v117649: state_type > $o ).

tff(pred_def_67789,type,
    v117633: state_type > $o ).

tff(pred_def_67790,type,
    v117144: ( state_type * $int ) > $o ).

tff(pred_def_67791,type,
    v117663: ( state_type * $int ) > $o ).

tff(pred_def_67792,type,
    v117627: state_type > $o ).

tff(pred_def_67793,type,
    v117142: ( state_type * $int ) > $o ).

tff(pred_def_67794,type,
    v117140: ( state_type * $int ) > $o ).

tff(pred_def_67795,type,
    v117138: ( state_type * $int ) > $o ).

tff(pred_def_67796,type,
    v117667: state_type > $o ).

tff(pred_def_67797,type,
    v117665: state_type > $o ).

tff(pred_def_67798,type,
    v117674: state_type > $o ).

tff(pred_def_67799,type,
    v117672: state_type > $o ).

tff(pred_def_67800,type,
    v117671: state_type > $o ).

tff(pred_def_67801,type,
    v117670: state_type > $o ).

tff(pred_def_67802,type,
    v117682: state_type > $o ).

tff(pred_def_67803,type,
    v117683: state_type > $o ).

tff(pred_def_67804,type,
    v117681: state_type > $o ).

tff(pred_def_67805,type,
    v117678: ( state_type * $int ) > $o ).

tff(pred_def_67806,type,
    v117680: ( state_type * $int ) > $o ).

tff(pred_def_67807,type,
    v117669: ( state_type * $int ) > $o ).

tff(pred_def_67808,type,
    v117120: ( state_type * $int ) > $o ).

tff(pred_def_67809,type,
    v117118: ( state_type * $int ) > $o ).

tff(pred_def_67810,type,
    v117687: state_type > $o ).

tff(pred_def_67811,type,
    v117693: state_type > $o ).

tff(pred_def_67812,type,
    v117692: state_type > $o ).

tff(pred_def_67813,type,
    v117691: state_type > $o ).

tff(pred_def_67814,type,
    v117695: state_type > $o ).

tff(pred_def_67815,type,
    v117694: state_type > $o ).

tff(pred_def_67816,type,
    v117690: state_type > $o ).

tff(pred_def_67817,type,
    v117697: state_type > $o ).

tff(pred_def_67818,type,
    v117703: state_type > $o ).

tff(pred_def_67819,type,
    v117702: state_type > $o ).

tff(pred_def_67820,type,
    v117701: state_type > $o ).

tff(pred_def_67821,type,
    v117700: state_type > $o ).

tff(pred_def_67822,type,
    v117704: state_type > $o ).

tff(pred_def_67823,type,
    v117699: state_type > $o ).

tff(pred_def_67824,type,
    v117705: state_type > $o ).

tff(pred_def_67825,type,
    v117698: state_type > $o ).

tff(pred_def_67826,type,
    v117696: state_type > $o ).

tff(pred_def_67827,type,
    v117689: state_type > $o ).

tff(pred_def_67828,type,
    v117711: state_type > $o ).

tff(pred_def_67829,type,
    v117709: state_type > $o ).

tff(pred_def_67830,type,
    v117708: state_type > $o ).

tff(pred_def_67831,type,
    v117707: ( state_type * $int ) > $o ).

tff(pred_def_67832,type,
    v117721: state_type > $o ).

tff(pred_def_67833,type,
    v117720: state_type > $o ).

tff(pred_def_67834,type,
    v117719: state_type > $o ).

tff(pred_def_67835,type,
    v117718: state_type > $o ).

tff(pred_def_67836,type,
    v117723: state_type > $o ).

tff(pred_def_67837,type,
    v117724: state_type > $o ).

tff(pred_def_67838,type,
    v117722: state_type > $o ).

tff(pred_def_67839,type,
    v117717: state_type > $o ).

tff(pred_def_67840,type,
    v117727: state_type > $o ).

tff(pred_def_67841,type,
    v117726: state_type > $o ).

tff(pred_def_67842,type,
    v117728: state_type > $o ).

tff(pred_def_67843,type,
    v117725: state_type > $o ).

tff(pred_def_67844,type,
    v117716: state_type > $o ).

tff(pred_def_67845,type,
    v117732: state_type > $o ).

tff(pred_def_67846,type,
    v117731: state_type > $o ).

tff(pred_def_67847,type,
    v117730: state_type > $o ).

tff(pred_def_67848,type,
    v117733: state_type > $o ).

tff(pred_def_67849,type,
    v117729: state_type > $o ).

tff(pred_def_67850,type,
    v117715: state_type > $o ).

tff(pred_def_67851,type,
    v117740: state_type > $o ).

tff(pred_def_67852,type,
    v117738: state_type > $o ).

tff(pred_def_67853,type,
    v117737: state_type > $o ).

tff(pred_def_67854,type,
    v117736: ( state_type * $int ) > $o ).

tff(pred_def_67855,type,
    v117625: state_type > $o ).

tff(pred_def_67856,type,
    v117746: state_type > $o ).

tff(pred_def_67857,type,
    v117748: state_type > $o ).

tff(pred_def_67858,type,
    v117751: state_type > $o ).

tff(pred_def_67859,type,
    v117752: state_type > $o ).

tff(pred_def_67860,type,
    v117750: state_type > $o ).

tff(pred_def_67861,type,
    v117749: state_type > $o ).

tff(pred_def_67862,type,
    v117747: state_type > $o ).

tff(pred_def_67863,type,
    v117745: state_type > $o ).

tff(pred_def_67864,type,
    v117758: state_type > $o ).

tff(pred_def_67865,type,
    v117756: state_type > $o ).

tff(pred_def_67866,type,
    v117755: state_type > $o ).

tff(pred_def_67867,type,
    v117754: ( state_type * $int ) > $o ).

tff(pred_def_67868,type,
    v117772: state_type > $o ).

tff(pred_def_67869,type,
    v117770: state_type > $o ).

tff(pred_def_67870,type,
    v117776: state_type > $o ).

tff(pred_def_67871,type,
    v117774: state_type > $o ).

tff(pred_def_67872,type,
    v117788: state_type > $o ).

tff(pred_def_67873,type,
    v117789: state_type > $o ).

tff(pred_def_67874,type,
    v117786: state_type > $o ).

tff(pred_def_67875,type,
    v117764: ( state_type * $int ) > $o ).

tff(pred_def_67876,type,
    v117796: state_type > $o ).

tff(pred_def_67877,type,
    v117795: state_type > $o ).

tff(pred_def_67878,type,
    v117798: state_type > $o ).

tff(pred_def_67879,type,
    v117797: state_type > $o ).

tff(pred_def_67880,type,
    v117794: state_type > $o ).

tff(pred_def_67881,type,
    v117792: ( state_type * $int ) > $o ).

tff(pred_def_67882,type,
    v117762: state_type > $o ).

tff(pred_def_67883,type,
    v117791: ( state_type * $int ) > $o ).

tff(pred_def_67884,type,
    v117784: ( state_type * $int ) > $o ).

tff(pred_def_67885,type,
    v117782: ( state_type * $int ) > $o ).

tff(pred_def_67886,type,
    v117780: ( state_type * $int ) > $o ).

tff(pred_def_67887,type,
    v117778: ( state_type * $int ) > $o ).

tff(pred_def_67888,type,
    v117802: state_type > $o ).

tff(pred_def_67889,type,
    v117800: state_type > $o ).

tff(pred_def_67890,type,
    v117809: state_type > $o ).

tff(pred_def_67891,type,
    v117807: state_type > $o ).

tff(pred_def_67892,type,
    v117806: state_type > $o ).

tff(pred_def_67893,type,
    v117805: state_type > $o ).

tff(pred_def_67894,type,
    v117817: state_type > $o ).

tff(pred_def_67895,type,
    v117818: state_type > $o ).

tff(pred_def_67896,type,
    v117816: state_type > $o ).

tff(pred_def_67897,type,
    v117813: ( state_type * $int ) > $o ).

tff(pred_def_67898,type,
    v117815: ( state_type * $int ) > $o ).

tff(pred_def_67899,type,
    v117768: ( state_type * $int ) > $o ).

tff(pred_def_67900,type,
    v117766: ( state_type * $int ) > $o ).

tff(pred_def_67901,type,
    v117833: state_type > $o ).

tff(pred_def_67902,type,
    v117831: state_type > $o ).

tff(pred_def_67903,type,
    v117837: state_type > $o ).

tff(pred_def_67904,type,
    v117835: state_type > $o ).

tff(pred_def_67905,type,
    v117850: state_type > $o ).

tff(pred_def_67906,type,
    v117849: state_type > $o ).

tff(pred_def_67907,type,
    v117847: state_type > $o ).

tff(pred_def_67908,type,
    v117852: ( state_type * $int ) > $o ).

tff(pred_def_67909,type,
    v117854: state_type > $o ).

tff(pred_def_67910,type,
    v117857: ( state_type * $int ) > $o ).

tff(pred_def_67911,type,
    v117825: ( state_type * $int ) > $o ).

tff(pred_def_67912,type,
    v117872: state_type > $o ).

tff(pred_def_67913,type,
    v117871: state_type > $o ).

tff(pred_def_67914,type,
    v117870: state_type > $o ).

tff(pred_def_67915,type,
    v117873: state_type > $o ).

tff(pred_def_67916,type,
    v117869: state_type > $o ).

tff(pred_def_67917,type,
    v117868: state_type > $o ).

tff(pred_def_67918,type,
    v117874: state_type > $o ).

tff(pred_def_67919,type,
    v117867: state_type > $o ).

tff(pred_def_67920,type,
    v117866: state_type > $o ).

tff(pred_def_67921,type,
    v117865: state_type > $o ).

tff(pred_def_67922,type,
    v117864: state_type > $o ).

tff(pred_def_67923,type,
    v117876: state_type > $o ).

tff(pred_def_67924,type,
    v117875: state_type > $o ).

tff(pred_def_67925,type,
    v117863: state_type > $o ).

tff(pred_def_67926,type,
    v117879: state_type > $o ).

tff(pred_def_67927,type,
    v117878: state_type > $o ).

tff(pred_def_67928,type,
    v117880: state_type > $o ).

tff(pred_def_67929,type,
    v117877: state_type > $o ).

tff(pred_def_67930,type,
    v117883: state_type > $o ).

tff(pred_def_67931,type,
    v117882: state_type > $o ).

tff(pred_def_67932,type,
    v117884: state_type > $o ).

tff(pred_def_67933,type,
    v117881: state_type > $o ).

tff(pred_def_67934,type,
    v117887: state_type > $o ).

tff(pred_def_67935,type,
    v117886: state_type > $o ).

tff(pred_def_67936,type,
    v117888: state_type > $o ).

tff(pred_def_67937,type,
    v117885: state_type > $o ).

tff(pred_def_67938,type,
    v117861: ( state_type * $int ) > $o ).

tff(pred_def_67939,type,
    v117823: state_type > $o ).

tff(pred_def_67940,type,
    v117860: ( state_type * $int ) > $o ).

tff(pred_def_67941,type,
    v117859: ( state_type * $int ) > $o ).

tff(pred_def_67942,type,
    v117845: ( state_type * $int ) > $o ).

tff(pred_def_67943,type,
    v117843: ( state_type * $int ) > $o ).

tff(pred_def_67944,type,
    v117841: ( state_type * $int ) > $o ).

tff(pred_def_67945,type,
    v117839: ( state_type * $int ) > $o ).

tff(pred_def_67946,type,
    v117892: state_type > $o ).

tff(pred_def_67947,type,
    v117890: state_type > $o ).

tff(pred_def_67948,type,
    v117899: state_type > $o ).

tff(pred_def_67949,type,
    v117897: state_type > $o ).

tff(pred_def_67950,type,
    v117896: state_type > $o ).

tff(pred_def_67951,type,
    v117895: state_type > $o ).

tff(pred_def_67952,type,
    v117907: state_type > $o ).

tff(pred_def_67953,type,
    v117908: state_type > $o ).

tff(pred_def_67954,type,
    v117906: state_type > $o ).

tff(pred_def_67955,type,
    v117903: ( state_type * $int ) > $o ).

tff(pred_def_67956,type,
    v117905: ( state_type * $int ) > $o ).

tff(pred_def_67957,type,
    v117829: ( state_type * $int ) > $o ).

tff(pred_def_67958,type,
    v117827: ( state_type * $int ) > $o ).

tff(pred_def_67959,type,
    v117913: state_type > $o ).

tff(pred_def_67960,type,
    v117114: state_type > $o ).

tff(pred_def_67961,type,
    v117929: state_type > $o ).

tff(pred_def_67962,type,
    v117927: state_type > $o ).

tff(pred_def_67963,type,
    v117925: state_type > $o ).

tff(pred_def_67964,type,
    v117923: state_type > $o ).

tff(pred_def_67965,type,
    v117937: state_type > $o ).

tff(pred_def_67966,type,
    v117935: state_type > $o ).

tff(pred_def_67967,type,
    v117933: state_type > $o ).

tff(pred_def_67968,type,
    v117931: state_type > $o ).

tff(pred_def_67969,type,
    v117957: state_type > $o ).

tff(pred_def_67970,type,
    v117955: state_type > $o ).

tff(pred_def_67971,type,
    v117961: state_type > $o ).

tff(pred_def_67972,type,
    v117959: state_type > $o ).

tff(pred_def_67973,type,
    v117973: state_type > $o ).

tff(pred_def_67974,type,
    v117975: state_type > $o ).

tff(pred_def_67975,type,
    v117977: state_type > $o ).

tff(pred_def_67976,type,
    v117979: state_type > $o ).

tff(pred_def_67977,type,
    v117981: state_type > $o ).

tff(pred_def_67978,type,
    v117983: state_type > $o ).

tff(pred_def_67979,type,
    v117985: state_type > $o ).

tff(pred_def_67980,type,
    v118034: ( state_type * $int ) > $o ).

tff(pred_def_67981,type,
    v118035: ( state_type * $int ) > $o ).

tff(pred_def_67982,type,
    v118033: state_type > $o ).

tff(pred_def_67983,type,
    v118038: state_type > $o ).

tff(pred_def_67984,type,
    v118039: state_type > $o ).

tff(pred_def_67985,type,
    v118037: state_type > $o ).

tff(pred_def_67986,type,
    v118040: state_type > $o ).

tff(pred_def_67987,type,
    v118036: state_type > $o ).

tff(pred_def_67988,type,
    v118032: state_type > $o ).

tff(pred_def_67989,type,
    v118041: state_type > $o ).

tff(pred_def_67990,type,
    v118031: state_type > $o ).

tff(pred_def_67991,type,
    v118030: state_type > $o ).

tff(pred_def_67992,type,
    v118045: state_type > $o ).

tff(pred_def_67993,type,
    v118046: state_type > $o ).

tff(pred_def_67994,type,
    v118044: state_type > $o ).

tff(pred_def_67995,type,
    v118047: state_type > $o ).

tff(pred_def_67996,type,
    v118043: state_type > $o ).

tff(pred_def_67997,type,
    v118042: state_type > $o ).

tff(pred_def_67998,type,
    v118029: state_type > $o ).

tff(pred_def_67999,type,
    v118048: state_type > $o ).

tff(pred_def_68000,type,
    v118028: state_type > $o ).

tff(pred_def_68001,type,
    v118051: state_type > $o ).

tff(pred_def_68002,type,
    v118052: state_type > $o ).

tff(pred_def_68003,type,
    v118050: state_type > $o ).

tff(pred_def_68004,type,
    v118053: state_type > $o ).

tff(pred_def_68005,type,
    v118049: state_type > $o ).

tff(pred_def_68006,type,
    v118056: state_type > $o ).

tff(pred_def_68007,type,
    v118057: state_type > $o ).

tff(pred_def_68008,type,
    v118055: state_type > $o ).

tff(pred_def_68009,type,
    v118058: state_type > $o ).

tff(pred_def_68010,type,
    v118054: state_type > $o ).

tff(pred_def_68011,type,
    v118026: ( state_type * $int ) > $o ).

tff(pred_def_68012,type,
    v118059: ( state_type * $int ) > $o ).

tff(pred_def_68013,type,
    v118025: state_type > $o ).

tff(pred_def_68014,type,
    v118062: state_type > $o ).

tff(pred_def_68015,type,
    v118063: state_type > $o ).

tff(pred_def_68016,type,
    v118061: state_type > $o ).

tff(pred_def_68017,type,
    v118064: state_type > $o ).

tff(pred_def_68018,type,
    v118060: state_type > $o ).

tff(pred_def_68019,type,
    v118024: state_type > $o ).

tff(pred_def_68020,type,
    v118065: state_type > $o ).

tff(pred_def_68021,type,
    v118023: state_type > $o ).

tff(pred_def_68022,type,
    v118022: state_type > $o ).

tff(pred_def_68023,type,
    v118069: state_type > $o ).

tff(pred_def_68024,type,
    v118070: state_type > $o ).

tff(pred_def_68025,type,
    v118068: state_type > $o ).

tff(pred_def_68026,type,
    v118071: state_type > $o ).

tff(pred_def_68027,type,
    v118067: state_type > $o ).

tff(pred_def_68028,type,
    v118066: state_type > $o ).

tff(pred_def_68029,type,
    v118021: state_type > $o ).

tff(pred_def_68030,type,
    v118072: state_type > $o ).

tff(pred_def_68031,type,
    v118020: state_type > $o ).

tff(pred_def_68032,type,
    v118075: state_type > $o ).

tff(pred_def_68033,type,
    v118076: state_type > $o ).

tff(pred_def_68034,type,
    v118074: state_type > $o ).

tff(pred_def_68035,type,
    v118077: state_type > $o ).

tff(pred_def_68036,type,
    v118073: state_type > $o ).

tff(pred_def_68037,type,
    v118080: state_type > $o ).

tff(pred_def_68038,type,
    v118081: state_type > $o ).

tff(pred_def_68039,type,
    v118079: state_type > $o ).

tff(pred_def_68040,type,
    v118082: state_type > $o ).

tff(pred_def_68041,type,
    v118078: state_type > $o ).

tff(pred_def_68042,type,
    v118018: ( state_type * $int ) > $o ).

tff(pred_def_68043,type,
    v118083: ( state_type * $int ) > $o ).

tff(pred_def_68044,type,
    v118017: state_type > $o ).

tff(pred_def_68045,type,
    v118086: state_type > $o ).

tff(pred_def_68046,type,
    v118087: state_type > $o ).

tff(pred_def_68047,type,
    v118085: state_type > $o ).

tff(pred_def_68048,type,
    v118088: state_type > $o ).

tff(pred_def_68049,type,
    v118084: state_type > $o ).

tff(pred_def_68050,type,
    v118016: state_type > $o ).

tff(pred_def_68051,type,
    v118089: state_type > $o ).

tff(pred_def_68052,type,
    v118015: state_type > $o ).

tff(pred_def_68053,type,
    v118014: state_type > $o ).

tff(pred_def_68054,type,
    v118093: state_type > $o ).

tff(pred_def_68055,type,
    v118094: state_type > $o ).

tff(pred_def_68056,type,
    v118092: state_type > $o ).

tff(pred_def_68057,type,
    v118095: state_type > $o ).

tff(pred_def_68058,type,
    v118091: state_type > $o ).

tff(pred_def_68059,type,
    v118090: state_type > $o ).

tff(pred_def_68060,type,
    v118013: state_type > $o ).

tff(pred_def_68061,type,
    v118096: state_type > $o ).

tff(pred_def_68062,type,
    v118012: state_type > $o ).

tff(pred_def_68063,type,
    v118099: state_type > $o ).

tff(pred_def_68064,type,
    v118100: state_type > $o ).

tff(pred_def_68065,type,
    v118098: state_type > $o ).

tff(pred_def_68066,type,
    v118101: state_type > $o ).

tff(pred_def_68067,type,
    v118097: state_type > $o ).

tff(pred_def_68068,type,
    v118104: state_type > $o ).

tff(pred_def_68069,type,
    v118105: state_type > $o ).

tff(pred_def_68070,type,
    v118103: state_type > $o ).

tff(pred_def_68071,type,
    v118106: state_type > $o ).

tff(pred_def_68072,type,
    v118102: state_type > $o ).

tff(pred_def_68073,type,
    v118010: ( state_type * $int ) > $o ).

tff(pred_def_68074,type,
    v118107: ( state_type * $int ) > $o ).

tff(pred_def_68075,type,
    v118009: state_type > $o ).

tff(pred_def_68076,type,
    v118110: state_type > $o ).

tff(pred_def_68077,type,
    v118111: state_type > $o ).

tff(pred_def_68078,type,
    v118109: state_type > $o ).

tff(pred_def_68079,type,
    v118112: state_type > $o ).

tff(pred_def_68080,type,
    v118108: state_type > $o ).

tff(pred_def_68081,type,
    v118008: state_type > $o ).

tff(pred_def_68082,type,
    v118113: state_type > $o ).

tff(pred_def_68083,type,
    v118007: state_type > $o ).

tff(pred_def_68084,type,
    v118006: state_type > $o ).

tff(pred_def_68085,type,
    v118117: state_type > $o ).

tff(pred_def_68086,type,
    v118118: state_type > $o ).

tff(pred_def_68087,type,
    v118116: state_type > $o ).

tff(pred_def_68088,type,
    v118119: state_type > $o ).

tff(pred_def_68089,type,
    v118115: state_type > $o ).

tff(pred_def_68090,type,
    v118114: state_type > $o ).

tff(pred_def_68091,type,
    v118005: state_type > $o ).

tff(pred_def_68092,type,
    v118120: state_type > $o ).

tff(pred_def_68093,type,
    v118004: state_type > $o ).

tff(pred_def_68094,type,
    v118123: state_type > $o ).

tff(pred_def_68095,type,
    v118124: state_type > $o ).

tff(pred_def_68096,type,
    v118122: state_type > $o ).

tff(pred_def_68097,type,
    v118125: state_type > $o ).

tff(pred_def_68098,type,
    v118121: state_type > $o ).

tff(pred_def_68099,type,
    v118128: state_type > $o ).

tff(pred_def_68100,type,
    v118129: state_type > $o ).

tff(pred_def_68101,type,
    v118127: state_type > $o ).

tff(pred_def_68102,type,
    v118130: state_type > $o ).

tff(pred_def_68103,type,
    v118126: state_type > $o ).

tff(pred_def_68104,type,
    v118002: ( state_type * $int ) > $o ).

tff(pred_def_68105,type,
    v118131: ( state_type * $int ) > $o ).

tff(pred_def_68106,type,
    v118001: state_type > $o ).

tff(pred_def_68107,type,
    v118134: state_type > $o ).

tff(pred_def_68108,type,
    v118135: state_type > $o ).

tff(pred_def_68109,type,
    v118133: state_type > $o ).

tff(pred_def_68110,type,
    v118136: state_type > $o ).

tff(pred_def_68111,type,
    v118132: state_type > $o ).

tff(pred_def_68112,type,
    v118000: state_type > $o ).

tff(pred_def_68113,type,
    v118137: state_type > $o ).

tff(pred_def_68114,type,
    v117999: state_type > $o ).

tff(pred_def_68115,type,
    v117998: state_type > $o ).

tff(pred_def_68116,type,
    v118141: state_type > $o ).

tff(pred_def_68117,type,
    v118142: state_type > $o ).

tff(pred_def_68118,type,
    v118140: state_type > $o ).

tff(pred_def_68119,type,
    v118143: state_type > $o ).

tff(pred_def_68120,type,
    v118139: state_type > $o ).

tff(pred_def_68121,type,
    v118138: state_type > $o ).

tff(pred_def_68122,type,
    v117997: state_type > $o ).

tff(pred_def_68123,type,
    v118144: state_type > $o ).

tff(pred_def_68124,type,
    v117996: state_type > $o ).

tff(pred_def_68125,type,
    v118147: state_type > $o ).

tff(pred_def_68126,type,
    v118148: state_type > $o ).

tff(pred_def_68127,type,
    v118146: state_type > $o ).

tff(pred_def_68128,type,
    v118149: state_type > $o ).

tff(pred_def_68129,type,
    v118145: state_type > $o ).

tff(pred_def_68130,type,
    v118152: state_type > $o ).

tff(pred_def_68131,type,
    v118153: state_type > $o ).

tff(pred_def_68132,type,
    v118151: state_type > $o ).

tff(pred_def_68133,type,
    v118154: state_type > $o ).

tff(pred_def_68134,type,
    v118150: state_type > $o ).

tff(pred_def_68135,type,
    v117994: ( state_type * $int ) > $o ).

tff(pred_def_68136,type,
    v118155: ( state_type * $int ) > $o ).

tff(pred_def_68137,type,
    v117993: state_type > $o ).

tff(pred_def_68138,type,
    v118158: state_type > $o ).

tff(pred_def_68139,type,
    v118159: state_type > $o ).

tff(pred_def_68140,type,
    v118157: state_type > $o ).

tff(pred_def_68141,type,
    v118160: state_type > $o ).

tff(pred_def_68142,type,
    v118156: state_type > $o ).

tff(pred_def_68143,type,
    v117992: state_type > $o ).

tff(pred_def_68144,type,
    v118161: state_type > $o ).

tff(pred_def_68145,type,
    v117991: state_type > $o ).

tff(pred_def_68146,type,
    v117990: state_type > $o ).

tff(pred_def_68147,type,
    v118165: state_type > $o ).

tff(pred_def_68148,type,
    v118166: state_type > $o ).

tff(pred_def_68149,type,
    v118164: state_type > $o ).

tff(pred_def_68150,type,
    v118167: state_type > $o ).

tff(pred_def_68151,type,
    v118163: state_type > $o ).

tff(pred_def_68152,type,
    v118162: state_type > $o ).

tff(pred_def_68153,type,
    v117989: state_type > $o ).

tff(pred_def_68154,type,
    v118168: state_type > $o ).

tff(pred_def_68155,type,
    v117988: state_type > $o ).

tff(pred_def_68156,type,
    v118171: state_type > $o ).

tff(pred_def_68157,type,
    v118172: state_type > $o ).

tff(pred_def_68158,type,
    v118170: state_type > $o ).

tff(pred_def_68159,type,
    v118173: state_type > $o ).

tff(pred_def_68160,type,
    v118169: state_type > $o ).

tff(pred_def_68161,type,
    v118176: state_type > $o ).

tff(pred_def_68162,type,
    v118177: state_type > $o ).

tff(pred_def_68163,type,
    v118175: state_type > $o ).

tff(pred_def_68164,type,
    v118178: state_type > $o ).

tff(pred_def_68165,type,
    v118174: state_type > $o ).

tff(pred_def_68166,type,
    v117986: ( state_type * $int ) > $o ).

tff(pred_def_68167,type,
    v117971: ( state_type * $int ) > $o ).

tff(pred_def_68168,type,
    v118188: state_type > $o ).

tff(pred_def_68169,type,
    v118186: state_type > $o ).

tff(pred_def_68170,type,
    v118185: state_type > $o ).

tff(pred_def_68171,type,
    v118184: ( state_type * $int ) > $o ).

tff(pred_def_68172,type,
    v118182: state_type > $o ).

tff(pred_def_68173,type,
    v118198: state_type > $o ).

tff(pred_def_68174,type,
    v118196: state_type > $o ).

tff(pred_def_68175,type,
    v118195: state_type > $o ).

tff(pred_def_68176,type,
    v118194: ( state_type * $int ) > $o ).

tff(pred_def_68177,type,
    v118192: state_type > $o ).

tff(pred_def_68178,type,
    v118208: state_type > $o ).

tff(pred_def_68179,type,
    v118206: state_type > $o ).

tff(pred_def_68180,type,
    v118205: state_type > $o ).

tff(pred_def_68181,type,
    v118204: ( state_type * $int ) > $o ).

tff(pred_def_68182,type,
    v118202: state_type > $o ).

tff(pred_def_68183,type,
    v118212: state_type > $o ).

tff(pred_def_68184,type,
    v118214: state_type > $o ).

tff(pred_def_68185,type,
    v118216: state_type > $o ).

tff(pred_def_68186,type,
    v118222: state_type > $o ).

tff(pred_def_68187,type,
    v118221: state_type > $o ).

tff(pred_def_68188,type,
    v118220: state_type > $o ).

tff(pred_def_68189,type,
    v118219: state_type > $o ).

tff(pred_def_68190,type,
    v118218: state_type > $o ).

tff(pred_def_68191,type,
    v118217: ( state_type * $int ) > $o ).

tff(pred_def_68192,type,
    v118180: ( state_type * $int ) > $o ).

tff(pred_def_68193,type,
    v118251: ( state_type * $int ) > $o ).

tff(pred_def_68194,type,
    v117949: ( state_type * $int ) > $o ).

tff(pred_def_68195,type,
    v118250: state_type > $o ).

tff(pred_def_68196,type,
    v118254: state_type > $o ).

tff(pred_def_68197,type,
    v118255: state_type > $o ).

tff(pred_def_68198,type,
    v118253: state_type > $o ).

tff(pred_def_68199,type,
    v118256: state_type > $o ).

tff(pred_def_68200,type,
    v118252: state_type > $o ).

tff(pred_def_68201,type,
    v118249: state_type > $o ).

tff(pred_def_68202,type,
    v118257: state_type > $o ).

tff(pred_def_68203,type,
    v118248: state_type > $o ).

tff(pred_def_68204,type,
    v118260: state_type > $o ).

tff(pred_def_68205,type,
    v118261: state_type > $o ).

tff(pred_def_68206,type,
    v118259: state_type > $o ).

tff(pred_def_68207,type,
    v118262: state_type > $o ).

tff(pred_def_68208,type,
    v118258: state_type > $o ).

tff(pred_def_68209,type,
    v118247: state_type > $o ).

tff(pred_def_68210,type,
    v118263: state_type > $o ).

tff(pred_def_68211,type,
    v118246: state_type > $o ).

tff(pred_def_68212,type,
    v118266: state_type > $o ).

tff(pred_def_68213,type,
    v118267: state_type > $o ).

tff(pred_def_68214,type,
    v118265: state_type > $o ).

tff(pred_def_68215,type,
    v118268: state_type > $o ).

tff(pred_def_68216,type,
    v118264: state_type > $o ).

tff(pred_def_68217,type,
    v118245: state_type > $o ).

tff(pred_def_68218,type,
    v118269: state_type > $o ).

tff(pred_def_68219,type,
    v118244: state_type > $o ).

tff(pred_def_68220,type,
    v118272: state_type > $o ).

tff(pred_def_68221,type,
    v118273: state_type > $o ).

tff(pred_def_68222,type,
    v118271: state_type > $o ).

tff(pred_def_68223,type,
    v118274: state_type > $o ).

tff(pred_def_68224,type,
    v118270: state_type > $o ).

tff(pred_def_68225,type,
    v118243: state_type > $o ).

tff(pred_def_68226,type,
    v118275: state_type > $o ).

tff(pred_def_68227,type,
    v118242: state_type > $o ).

tff(pred_def_68228,type,
    v118241: state_type > $o ).

tff(pred_def_68229,type,
    v118279: state_type > $o ).

tff(pred_def_68230,type,
    v118280: state_type > $o ).

tff(pred_def_68231,type,
    v118278: state_type > $o ).

tff(pred_def_68232,type,
    v118281: state_type > $o ).

tff(pred_def_68233,type,
    v118277: state_type > $o ).

tff(pred_def_68234,type,
    v118276: state_type > $o ).

tff(pred_def_68235,type,
    v118240: state_type > $o ).

tff(pred_def_68236,type,
    v118282: state_type > $o ).

tff(pred_def_68237,type,
    v118239: state_type > $o ).

tff(pred_def_68238,type,
    v118285: state_type > $o ).

tff(pred_def_68239,type,
    v118286: state_type > $o ).

tff(pred_def_68240,type,
    v118284: state_type > $o ).

tff(pred_def_68241,type,
    v118287: state_type > $o ).

tff(pred_def_68242,type,
    v118283: state_type > $o ).

tff(pred_def_68243,type,
    v118290: state_type > $o ).

tff(pred_def_68244,type,
    v118291: state_type > $o ).

tff(pred_def_68245,type,
    v118289: state_type > $o ).

tff(pred_def_68246,type,
    v118292: state_type > $o ).

tff(pred_def_68247,type,
    v118288: state_type > $o ).

tff(pred_def_68248,type,
    v118295: state_type > $o ).

tff(pred_def_68249,type,
    v118296: state_type > $o ).

tff(pred_def_68250,type,
    v118294: state_type > $o ).

tff(pred_def_68251,type,
    v118297: state_type > $o ).

tff(pred_def_68252,type,
    v118293: state_type > $o ).

tff(pred_def_68253,type,
    v118300: state_type > $o ).

tff(pred_def_68254,type,
    v118301: state_type > $o ).

tff(pred_def_68255,type,
    v118299: state_type > $o ).

tff(pred_def_68256,type,
    v118302: state_type > $o ).

tff(pred_def_68257,type,
    v118298: state_type > $o ).

tff(pred_def_68258,type,
    v118305: state_type > $o ).

tff(pred_def_68259,type,
    v118306: state_type > $o ).

tff(pred_def_68260,type,
    v118304: state_type > $o ).

tff(pred_def_68261,type,
    v118307: state_type > $o ).

tff(pred_def_68262,type,
    v118303: state_type > $o ).

tff(pred_def_68263,type,
    v118237: ( state_type * $int ) > $o ).

tff(pred_def_68264,type,
    v118236: state_type > $o ).

tff(pred_def_68265,type,
    v118312: state_type > $o ).

tff(pred_def_68266,type,
    v118314: state_type > $o ).

tff(pred_def_68267,type,
    v118315: state_type > $o ).

tff(pred_def_68268,type,
    v118313: state_type > $o ).

tff(pred_def_68269,type,
    v118311: state_type > $o ).

tff(pred_def_68270,type,
    v118310: state_type > $o ).

tff(pred_def_68271,type,
    v118316: state_type > $o ).

tff(pred_def_68272,type,
    v118309: state_type > $o ).

tff(pred_def_68273,type,
    v118317: state_type > $o ).

tff(pred_def_68274,type,
    v118308: state_type > $o ).

tff(pred_def_68275,type,
    v118235: state_type > $o ).

tff(pred_def_68276,type,
    v118318: state_type > $o ).

tff(pred_def_68277,type,
    v118234: state_type > $o ).

tff(pred_def_68278,type,
    v118325: state_type > $o ).

tff(pred_def_68279,type,
    v118324: state_type > $o ).

tff(pred_def_68280,type,
    v118323: state_type > $o ).

tff(pred_def_68281,type,
    v118327: state_type > $o ).

tff(pred_def_68282,type,
    v118326: state_type > $o ).

tff(pred_def_68283,type,
    v118322: state_type > $o ).

tff(pred_def_68284,type,
    v118321: state_type > $o ).

tff(pred_def_68285,type,
    v118328: state_type > $o ).

tff(pred_def_68286,type,
    v118320: state_type > $o ).

tff(pred_def_68287,type,
    v118329: state_type > $o ).

tff(pred_def_68288,type,
    v118319: state_type > $o ).

tff(pred_def_68289,type,
    v118233: state_type > $o ).

tff(pred_def_68290,type,
    v118330: state_type > $o ).

tff(pred_def_68291,type,
    v118232: state_type > $o ).

tff(pred_def_68292,type,
    v118337: state_type > $o ).

tff(pred_def_68293,type,
    v118336: state_type > $o ).

tff(pred_def_68294,type,
    v118335: state_type > $o ).

tff(pred_def_68295,type,
    v118339: state_type > $o ).

tff(pred_def_68296,type,
    v118338: state_type > $o ).

tff(pred_def_68297,type,
    v118334: state_type > $o ).

tff(pred_def_68298,type,
    v118333: state_type > $o ).

tff(pred_def_68299,type,
    v118340: state_type > $o ).

tff(pred_def_68300,type,
    v118332: state_type > $o ).

tff(pred_def_68301,type,
    v118341: state_type > $o ).

tff(pred_def_68302,type,
    v118331: state_type > $o ).

tff(pred_def_68303,type,
    v118231: state_type > $o ).

tff(pred_def_68304,type,
    v118342: state_type > $o ).

tff(pred_def_68305,type,
    v118230: state_type > $o ).

tff(pred_def_68306,type,
    v118349: state_type > $o ).

tff(pred_def_68307,type,
    v118348: state_type > $o ).

tff(pred_def_68308,type,
    v118347: state_type > $o ).

tff(pred_def_68309,type,
    v118351: state_type > $o ).

tff(pred_def_68310,type,
    v118350: state_type > $o ).

tff(pred_def_68311,type,
    v118346: state_type > $o ).

tff(pred_def_68312,type,
    v118345: state_type > $o ).

tff(pred_def_68313,type,
    v118352: state_type > $o ).

tff(pred_def_68314,type,
    v118344: state_type > $o ).

tff(pred_def_68315,type,
    v118353: state_type > $o ).

tff(pred_def_68316,type,
    v118343: state_type > $o ).

tff(pred_def_68317,type,
    v118229: state_type > $o ).

tff(pred_def_68318,type,
    v118354: state_type > $o ).

tff(pred_def_68319,type,
    v118228: state_type > $o ).

tff(pred_def_68320,type,
    v118227: state_type > $o ).

tff(pred_def_68321,type,
    v118362: state_type > $o ).

tff(pred_def_68322,type,
    v118361: state_type > $o ).

tff(pred_def_68323,type,
    v118360: state_type > $o ).

tff(pred_def_68324,type,
    v118364: state_type > $o ).

tff(pred_def_68325,type,
    v118363: state_type > $o ).

tff(pred_def_68326,type,
    v118359: state_type > $o ).

tff(pred_def_68327,type,
    v118358: state_type > $o ).

tff(pred_def_68328,type,
    v118365: state_type > $o ).

tff(pred_def_68329,type,
    v118357: state_type > $o ).

tff(pred_def_68330,type,
    v118366: state_type > $o ).

tff(pred_def_68331,type,
    v118356: state_type > $o ).

tff(pred_def_68332,type,
    v118355: state_type > $o ).

tff(pred_def_68333,type,
    v118226: state_type > $o ).

tff(pred_def_68334,type,
    v118367: state_type > $o ).

tff(pred_def_68335,type,
    v118225: state_type > $o ).

tff(pred_def_68336,type,
    v118370: state_type > $o ).

tff(pred_def_68337,type,
    v118371: state_type > $o ).

tff(pred_def_68338,type,
    v118369: state_type > $o ).

tff(pred_def_68339,type,
    v118372: state_type > $o ).

tff(pred_def_68340,type,
    v118368: state_type > $o ).

tff(pred_def_68341,type,
    v118375: state_type > $o ).

tff(pred_def_68342,type,
    v118376: state_type > $o ).

tff(pred_def_68343,type,
    v118374: state_type > $o ).

tff(pred_def_68344,type,
    v118377: state_type > $o ).

tff(pred_def_68345,type,
    v118373: state_type > $o ).

tff(pred_def_68346,type,
    v118380: state_type > $o ).

tff(pred_def_68347,type,
    v118381: state_type > $o ).

tff(pred_def_68348,type,
    v118379: state_type > $o ).

tff(pred_def_68349,type,
    v118382: state_type > $o ).

tff(pred_def_68350,type,
    v118378: state_type > $o ).

tff(pred_def_68351,type,
    v118385: state_type > $o ).

tff(pred_def_68352,type,
    v118386: state_type > $o ).

tff(pred_def_68353,type,
    v118384: state_type > $o ).

tff(pred_def_68354,type,
    v118387: state_type > $o ).

tff(pred_def_68355,type,
    v118383: state_type > $o ).

tff(pred_def_68356,type,
    v118390: state_type > $o ).

tff(pred_def_68357,type,
    v118389: state_type > $o ).

tff(pred_def_68358,type,
    v118391: state_type > $o ).

tff(pred_def_68359,type,
    v118388: state_type > $o ).

tff(pred_def_68360,type,
    v117969: ( state_type * $int ) > $o ).

tff(pred_def_68361,type,
    v117967: ( state_type * $int ) > $o ).

tff(pred_def_68362,type,
    v117965: ( state_type * $int ) > $o ).

tff(pred_def_68363,type,
    v117963: ( state_type * $int ) > $o ).

tff(pred_def_68364,type,
    v118397: state_type > $o ).

tff(pred_def_68365,type,
    v118395: state_type > $o ).

tff(pred_def_68366,type,
    v118393: state_type > $o ).

tff(pred_def_68367,type,
    v118404: state_type > $o ).

tff(pred_def_68368,type,
    v118402: state_type > $o ).

tff(pred_def_68369,type,
    v118401: state_type > $o ).

tff(pred_def_68370,type,
    v118400: state_type > $o ).

tff(pred_def_68371,type,
    v118412: state_type > $o ).

tff(pred_def_68372,type,
    v118413: state_type > $o ).

tff(pred_def_68373,type,
    v118411: state_type > $o ).

tff(pred_def_68374,type,
    v118408: ( state_type * $int ) > $o ).

tff(pred_def_68375,type,
    v118410: ( state_type * $int ) > $o ).

tff(pred_def_68376,type,
    v117953: ( state_type * $int ) > $o ).

tff(pred_def_68377,type,
    v117951: ( state_type * $int ) > $o ).

tff(pred_def_68378,type,
    v118417: state_type > $o ).

tff(pred_def_68379,type,
    v118419: state_type > $o ).

tff(pred_def_68380,type,
    v118420: state_type > $o ).

tff(pred_def_68381,type,
    v117947: state_type > $o ).

tff(pred_def_68382,type,
    v118422: state_type > $o ).

tff(pred_def_68383,type,
    v118424: state_type > $o ).

tff(pred_def_68384,type,
    v118430: state_type > $o ).

tff(pred_def_68385,type,
    v118432: state_type > $o ).

tff(pred_def_68386,type,
    v118442: state_type > $o ).

tff(pred_def_68387,type,
    v118443: state_type > $o ).

tff(pred_def_68388,type,
    v118441: state_type > $o ).

tff(pred_def_68389,type,
    v118445: state_type > $o ).

tff(pred_def_68390,type,
    v118446: state_type > $o ).

tff(pred_def_68391,type,
    v118444: state_type > $o ).

tff(pred_def_68392,type,
    v118440: state_type > $o ).

tff(pred_def_68393,type,
    v118439: state_type > $o ).

tff(pred_def_68394,type,
    v118438: state_type > $o ).

tff(pred_def_68395,type,
    v118437: state_type > $o ).

tff(pred_def_68396,type,
    v117917: ( state_type * $int ) > $o ).

tff(pred_def_68397,type,
    v118447: state_type > $o ).

tff(pred_def_68398,type,
    v118436: state_type > $o ).

tff(pred_def_68399,type,
    v118449: state_type > $o ).

tff(pred_def_68400,type,
    v118448: state_type > $o ).

tff(pred_def_68401,type,
    v118435: state_type > $o ).

tff(pred_def_68402,type,
    v118451: state_type > $o ).

tff(pred_def_68403,type,
    v118457: state_type > $o ).

tff(pred_def_68404,type,
    v118458: state_type > $o ).

tff(pred_def_68405,type,
    v118456: state_type > $o ).

tff(pred_def_68406,type,
    v118455: state_type > $o ).

tff(pred_def_68407,type,
    v118461: state_type > $o ).

tff(pred_def_68408,type,
    v118460: state_type > $o ).

tff(pred_def_68409,type,
    v118459: state_type > $o ).

tff(pred_def_68410,type,
    v118454: state_type > $o ).

tff(pred_def_68411,type,
    v118462: state_type > $o ).

tff(pred_def_68412,type,
    v118453: state_type > $o ).

tff(pred_def_68413,type,
    v118463: state_type > $o ).

tff(pred_def_68414,type,
    v118452: state_type > $o ).

tff(pred_def_68415,type,
    v118450: state_type > $o ).

tff(pred_def_68416,type,
    v118434: state_type > $o ).

tff(pred_def_68417,type,
    v117945: ( state_type * $int ) > $o ).

tff(pred_def_68418,type,
    v118464: ( state_type * $int ) > $o ).

tff(pred_def_68419,type,
    v118428: state_type > $o ).

tff(pred_def_68420,type,
    v117943: ( state_type * $int ) > $o ).

tff(pred_def_68421,type,
    v117941: ( state_type * $int ) > $o ).

tff(pred_def_68422,type,
    v117939: ( state_type * $int ) > $o ).

tff(pred_def_68423,type,
    v118468: state_type > $o ).

tff(pred_def_68424,type,
    v118466: state_type > $o ).

tff(pred_def_68425,type,
    v118475: state_type > $o ).

tff(pred_def_68426,type,
    v118473: state_type > $o ).

tff(pred_def_68427,type,
    v118472: state_type > $o ).

tff(pred_def_68428,type,
    v118471: state_type > $o ).

tff(pred_def_68429,type,
    v118483: state_type > $o ).

tff(pred_def_68430,type,
    v118484: state_type > $o ).

tff(pred_def_68431,type,
    v118482: state_type > $o ).

tff(pred_def_68432,type,
    v118479: ( state_type * $int ) > $o ).

tff(pred_def_68433,type,
    v118481: ( state_type * $int ) > $o ).

tff(pred_def_68434,type,
    v118470: ( state_type * $int ) > $o ).

tff(pred_def_68435,type,
    v117921: ( state_type * $int ) > $o ).

tff(pred_def_68436,type,
    v117919: ( state_type * $int ) > $o ).

tff(pred_def_68437,type,
    v118488: state_type > $o ).

tff(pred_def_68438,type,
    v118494: state_type > $o ).

tff(pred_def_68439,type,
    v118493: state_type > $o ).

tff(pred_def_68440,type,
    v118492: state_type > $o ).

tff(pred_def_68441,type,
    v118496: state_type > $o ).

tff(pred_def_68442,type,
    v118495: state_type > $o ).

tff(pred_def_68443,type,
    v118491: state_type > $o ).

tff(pred_def_68444,type,
    v118498: state_type > $o ).

tff(pred_def_68445,type,
    v118504: state_type > $o ).

tff(pred_def_68446,type,
    v118503: state_type > $o ).

tff(pred_def_68447,type,
    v118502: state_type > $o ).

tff(pred_def_68448,type,
    v118501: state_type > $o ).

tff(pred_def_68449,type,
    v118505: state_type > $o ).

tff(pred_def_68450,type,
    v118500: state_type > $o ).

tff(pred_def_68451,type,
    v118506: state_type > $o ).

tff(pred_def_68452,type,
    v118499: state_type > $o ).

tff(pred_def_68453,type,
    v118497: state_type > $o ).

tff(pred_def_68454,type,
    v118490: state_type > $o ).

tff(pred_def_68455,type,
    v118512: state_type > $o ).

tff(pred_def_68456,type,
    v118510: state_type > $o ).

tff(pred_def_68457,type,
    v118509: state_type > $o ).

tff(pred_def_68458,type,
    v118508: ( state_type * $int ) > $o ).

tff(pred_def_68459,type,
    v118522: state_type > $o ).

tff(pred_def_68460,type,
    v118521: state_type > $o ).

tff(pred_def_68461,type,
    v118520: state_type > $o ).

tff(pred_def_68462,type,
    v118519: state_type > $o ).

tff(pred_def_68463,type,
    v118524: state_type > $o ).

tff(pred_def_68464,type,
    v118525: state_type > $o ).

tff(pred_def_68465,type,
    v118523: state_type > $o ).

tff(pred_def_68466,type,
    v118518: state_type > $o ).

tff(pred_def_68467,type,
    v118528: state_type > $o ).

tff(pred_def_68468,type,
    v118527: state_type > $o ).

tff(pred_def_68469,type,
    v118529: state_type > $o ).

tff(pred_def_68470,type,
    v118526: state_type > $o ).

tff(pred_def_68471,type,
    v118517: state_type > $o ).

tff(pred_def_68472,type,
    v118533: state_type > $o ).

tff(pred_def_68473,type,
    v118532: state_type > $o ).

tff(pred_def_68474,type,
    v118531: state_type > $o ).

tff(pred_def_68475,type,
    v118534: state_type > $o ).

tff(pred_def_68476,type,
    v118530: state_type > $o ).

tff(pred_def_68477,type,
    v118516: state_type > $o ).

tff(pred_def_68478,type,
    v118541: state_type > $o ).

tff(pred_def_68479,type,
    v118539: state_type > $o ).

tff(pred_def_68480,type,
    v118538: state_type > $o ).

tff(pred_def_68481,type,
    v118537: ( state_type * $int ) > $o ).

tff(pred_def_68482,type,
    v118426: state_type > $o ).

tff(pred_def_68483,type,
    v118547: state_type > $o ).

tff(pred_def_68484,type,
    v118549: state_type > $o ).

tff(pred_def_68485,type,
    v118552: state_type > $o ).

tff(pred_def_68486,type,
    v118553: state_type > $o ).

tff(pred_def_68487,type,
    v118551: state_type > $o ).

tff(pred_def_68488,type,
    v118550: state_type > $o ).

tff(pred_def_68489,type,
    v118548: state_type > $o ).

tff(pred_def_68490,type,
    v118546: state_type > $o ).

tff(pred_def_68491,type,
    v118559: state_type > $o ).

tff(pred_def_68492,type,
    v118557: state_type > $o ).

tff(pred_def_68493,type,
    v118556: state_type > $o ).

tff(pred_def_68494,type,
    v118555: ( state_type * $int ) > $o ).

tff(pred_def_68495,type,
    v118573: state_type > $o ).

tff(pred_def_68496,type,
    v118571: state_type > $o ).

tff(pred_def_68497,type,
    v118577: state_type > $o ).

tff(pred_def_68498,type,
    v118575: state_type > $o ).

tff(pred_def_68499,type,
    v118589: state_type > $o ).

tff(pred_def_68500,type,
    v118590: state_type > $o ).

tff(pred_def_68501,type,
    v118587: state_type > $o ).

tff(pred_def_68502,type,
    v118565: ( state_type * $int ) > $o ).

tff(pred_def_68503,type,
    v118597: state_type > $o ).

tff(pred_def_68504,type,
    v118596: state_type > $o ).

tff(pred_def_68505,type,
    v118599: state_type > $o ).

tff(pred_def_68506,type,
    v118598: state_type > $o ).

tff(pred_def_68507,type,
    v118595: state_type > $o ).

tff(pred_def_68508,type,
    v118593: ( state_type * $int ) > $o ).

tff(pred_def_68509,type,
    v118563: state_type > $o ).

tff(pred_def_68510,type,
    v118592: ( state_type * $int ) > $o ).

tff(pred_def_68511,type,
    v118585: ( state_type * $int ) > $o ).

tff(pred_def_68512,type,
    v118583: ( state_type * $int ) > $o ).

tff(pred_def_68513,type,
    v118581: ( state_type * $int ) > $o ).

tff(pred_def_68514,type,
    v118579: ( state_type * $int ) > $o ).

tff(pred_def_68515,type,
    v118603: state_type > $o ).

tff(pred_def_68516,type,
    v118601: state_type > $o ).

tff(pred_def_68517,type,
    v118610: state_type > $o ).

tff(pred_def_68518,type,
    v118608: state_type > $o ).

tff(pred_def_68519,type,
    v118607: state_type > $o ).

tff(pred_def_68520,type,
    v118606: state_type > $o ).

tff(pred_def_68521,type,
    v118618: state_type > $o ).

tff(pred_def_68522,type,
    v118619: state_type > $o ).

tff(pred_def_68523,type,
    v118617: state_type > $o ).

tff(pred_def_68524,type,
    v118614: ( state_type * $int ) > $o ).

tff(pred_def_68525,type,
    v118616: ( state_type * $int ) > $o ).

tff(pred_def_68526,type,
    v118569: ( state_type * $int ) > $o ).

tff(pred_def_68527,type,
    v118567: ( state_type * $int ) > $o ).

tff(pred_def_68528,type,
    v118634: state_type > $o ).

tff(pred_def_68529,type,
    v118632: state_type > $o ).

tff(pred_def_68530,type,
    v118638: state_type > $o ).

tff(pred_def_68531,type,
    v118636: state_type > $o ).

tff(pred_def_68532,type,
    v118651: state_type > $o ).

tff(pred_def_68533,type,
    v118650: state_type > $o ).

tff(pred_def_68534,type,
    v118648: state_type > $o ).

tff(pred_def_68535,type,
    v118653: ( state_type * $int ) > $o ).

tff(pred_def_68536,type,
    v118655: state_type > $o ).

tff(pred_def_68537,type,
    v118658: ( state_type * $int ) > $o ).

tff(pred_def_68538,type,
    v118626: ( state_type * $int ) > $o ).

tff(pred_def_68539,type,
    v118673: state_type > $o ).

tff(pred_def_68540,type,
    v118672: state_type > $o ).

tff(pred_def_68541,type,
    v118671: state_type > $o ).

tff(pred_def_68542,type,
    v118674: state_type > $o ).

tff(pred_def_68543,type,
    v118670: state_type > $o ).

tff(pred_def_68544,type,
    v118669: state_type > $o ).

tff(pred_def_68545,type,
    v118675: state_type > $o ).

tff(pred_def_68546,type,
    v118668: state_type > $o ).

tff(pred_def_68547,type,
    v118667: state_type > $o ).

tff(pred_def_68548,type,
    v118666: state_type > $o ).

tff(pred_def_68549,type,
    v118665: state_type > $o ).

tff(pred_def_68550,type,
    v118677: state_type > $o ).

tff(pred_def_68551,type,
    v118676: state_type > $o ).

tff(pred_def_68552,type,
    v118664: state_type > $o ).

tff(pred_def_68553,type,
    v118680: state_type > $o ).

tff(pred_def_68554,type,
    v118679: state_type > $o ).

tff(pred_def_68555,type,
    v118681: state_type > $o ).

tff(pred_def_68556,type,
    v118678: state_type > $o ).

tff(pred_def_68557,type,
    v118684: state_type > $o ).

tff(pred_def_68558,type,
    v118683: state_type > $o ).

tff(pred_def_68559,type,
    v118685: state_type > $o ).

tff(pred_def_68560,type,
    v118682: state_type > $o ).

tff(pred_def_68561,type,
    v118688: state_type > $o ).

tff(pred_def_68562,type,
    v118687: state_type > $o ).

tff(pred_def_68563,type,
    v118689: state_type > $o ).

tff(pred_def_68564,type,
    v118686: state_type > $o ).

tff(pred_def_68565,type,
    v118662: ( state_type * $int ) > $o ).

tff(pred_def_68566,type,
    v118624: state_type > $o ).

tff(pred_def_68567,type,
    v118661: ( state_type * $int ) > $o ).

tff(pred_def_68568,type,
    v118660: ( state_type * $int ) > $o ).

tff(pred_def_68569,type,
    v118646: ( state_type * $int ) > $o ).

tff(pred_def_68570,type,
    v118644: ( state_type * $int ) > $o ).

tff(pred_def_68571,type,
    v118642: ( state_type * $int ) > $o ).

tff(pred_def_68572,type,
    v118640: ( state_type * $int ) > $o ).

tff(pred_def_68573,type,
    v118693: state_type > $o ).

tff(pred_def_68574,type,
    v118691: state_type > $o ).

tff(pred_def_68575,type,
    v118700: state_type > $o ).

tff(pred_def_68576,type,
    v118698: state_type > $o ).

tff(pred_def_68577,type,
    v118697: state_type > $o ).

tff(pred_def_68578,type,
    v118696: state_type > $o ).

tff(pred_def_68579,type,
    v118708: state_type > $o ).

tff(pred_def_68580,type,
    v118709: state_type > $o ).

tff(pred_def_68581,type,
    v118707: state_type > $o ).

tff(pred_def_68582,type,
    v118704: ( state_type * $int ) > $o ).

tff(pred_def_68583,type,
    v118706: ( state_type * $int ) > $o ).

tff(pred_def_68584,type,
    v118630: ( state_type * $int ) > $o ).

tff(pred_def_68585,type,
    v118628: ( state_type * $int ) > $o ).

tff(pred_def_68586,type,
    v118714: state_type > $o ).

tff(pred_def_68587,type,
    v117915: state_type > $o ).

tff(pred_def_68588,type,
    v118730: state_type > $o ).

tff(pred_def_68589,type,
    v118728: state_type > $o ).

tff(pred_def_68590,type,
    v118726: state_type > $o ).

tff(pred_def_68591,type,
    v118724: state_type > $o ).

tff(pred_def_68592,type,
    v118738: state_type > $o ).

tff(pred_def_68593,type,
    v118736: state_type > $o ).

tff(pred_def_68594,type,
    v118734: state_type > $o ).

tff(pred_def_68595,type,
    v118732: state_type > $o ).

tff(pred_def_68596,type,
    v118758: state_type > $o ).

tff(pred_def_68597,type,
    v118756: state_type > $o ).

tff(pred_def_68598,type,
    v118762: state_type > $o ).

tff(pred_def_68599,type,
    v118760: state_type > $o ).

tff(pred_def_68600,type,
    v118774: state_type > $o ).

tff(pred_def_68601,type,
    v118776: state_type > $o ).

tff(pred_def_68602,type,
    v118778: state_type > $o ).

tff(pred_def_68603,type,
    v118780: state_type > $o ).

tff(pred_def_68604,type,
    v118782: state_type > $o ).

tff(pred_def_68605,type,
    v118784: state_type > $o ).

tff(pred_def_68606,type,
    v118786: state_type > $o ).

tff(pred_def_68607,type,
    v118835: ( state_type * $int ) > $o ).

tff(pred_def_68608,type,
    v118836: ( state_type * $int ) > $o ).

tff(pred_def_68609,type,
    v118834: state_type > $o ).

tff(pred_def_68610,type,
    v118839: state_type > $o ).

tff(pred_def_68611,type,
    v118840: state_type > $o ).

tff(pred_def_68612,type,
    v118838: state_type > $o ).

tff(pred_def_68613,type,
    v118841: state_type > $o ).

tff(pred_def_68614,type,
    v118837: state_type > $o ).

tff(pred_def_68615,type,
    v118833: state_type > $o ).

tff(pred_def_68616,type,
    v118842: state_type > $o ).

tff(pred_def_68617,type,
    v118832: state_type > $o ).

tff(pred_def_68618,type,
    v118831: state_type > $o ).

tff(pred_def_68619,type,
    v118846: state_type > $o ).

tff(pred_def_68620,type,
    v118847: state_type > $o ).

tff(pred_def_68621,type,
    v118845: state_type > $o ).

tff(pred_def_68622,type,
    v118848: state_type > $o ).

tff(pred_def_68623,type,
    v118844: state_type > $o ).

tff(pred_def_68624,type,
    v118843: state_type > $o ).

tff(pred_def_68625,type,
    v118830: state_type > $o ).

tff(pred_def_68626,type,
    v118849: state_type > $o ).

tff(pred_def_68627,type,
    v118829: state_type > $o ).

tff(pred_def_68628,type,
    v118852: state_type > $o ).

tff(pred_def_68629,type,
    v118853: state_type > $o ).

tff(pred_def_68630,type,
    v118851: state_type > $o ).

tff(pred_def_68631,type,
    v118854: state_type > $o ).

tff(pred_def_68632,type,
    v118850: state_type > $o ).

tff(pred_def_68633,type,
    v118857: state_type > $o ).

tff(pred_def_68634,type,
    v118858: state_type > $o ).

tff(pred_def_68635,type,
    v118856: state_type > $o ).

tff(pred_def_68636,type,
    v118859: state_type > $o ).

tff(pred_def_68637,type,
    v118855: state_type > $o ).

tff(pred_def_68638,type,
    v118827: ( state_type * $int ) > $o ).

tff(pred_def_68639,type,
    v118860: ( state_type * $int ) > $o ).

tff(pred_def_68640,type,
    v118826: state_type > $o ).

tff(pred_def_68641,type,
    v118863: state_type > $o ).

tff(pred_def_68642,type,
    v118864: state_type > $o ).

tff(pred_def_68643,type,
    v118862: state_type > $o ).

tff(pred_def_68644,type,
    v118865: state_type > $o ).

tff(pred_def_68645,type,
    v118861: state_type > $o ).

tff(pred_def_68646,type,
    v118825: state_type > $o ).

tff(pred_def_68647,type,
    v118866: state_type > $o ).

tff(pred_def_68648,type,
    v118824: state_type > $o ).

tff(pred_def_68649,type,
    v118823: state_type > $o ).

tff(pred_def_68650,type,
    v118870: state_type > $o ).

tff(pred_def_68651,type,
    v118871: state_type > $o ).

tff(pred_def_68652,type,
    v118869: state_type > $o ).

tff(pred_def_68653,type,
    v118872: state_type > $o ).

tff(pred_def_68654,type,
    v118868: state_type > $o ).

tff(pred_def_68655,type,
    v118867: state_type > $o ).

tff(pred_def_68656,type,
    v118822: state_type > $o ).

tff(pred_def_68657,type,
    v118873: state_type > $o ).

tff(pred_def_68658,type,
    v118821: state_type > $o ).

tff(pred_def_68659,type,
    v118876: state_type > $o ).

tff(pred_def_68660,type,
    v118877: state_type > $o ).

tff(pred_def_68661,type,
    v118875: state_type > $o ).

tff(pred_def_68662,type,
    v118878: state_type > $o ).

tff(pred_def_68663,type,
    v118874: state_type > $o ).

tff(pred_def_68664,type,
    v118881: state_type > $o ).

tff(pred_def_68665,type,
    v118882: state_type > $o ).

tff(pred_def_68666,type,
    v118880: state_type > $o ).

tff(pred_def_68667,type,
    v118883: state_type > $o ).

tff(pred_def_68668,type,
    v118879: state_type > $o ).

tff(pred_def_68669,type,
    v118819: ( state_type * $int ) > $o ).

tff(pred_def_68670,type,
    v118884: ( state_type * $int ) > $o ).

tff(pred_def_68671,type,
    v118818: state_type > $o ).

tff(pred_def_68672,type,
    v118887: state_type > $o ).

tff(pred_def_68673,type,
    v118888: state_type > $o ).

tff(pred_def_68674,type,
    v118886: state_type > $o ).

tff(pred_def_68675,type,
    v118889: state_type > $o ).

tff(pred_def_68676,type,
    v118885: state_type > $o ).

tff(pred_def_68677,type,
    v118817: state_type > $o ).

tff(pred_def_68678,type,
    v118890: state_type > $o ).

tff(pred_def_68679,type,
    v118816: state_type > $o ).

tff(pred_def_68680,type,
    v118815: state_type > $o ).

tff(pred_def_68681,type,
    v118894: state_type > $o ).

tff(pred_def_68682,type,
    v118895: state_type > $o ).

tff(pred_def_68683,type,
    v118893: state_type > $o ).

tff(pred_def_68684,type,
    v118896: state_type > $o ).

tff(pred_def_68685,type,
    v118892: state_type > $o ).

tff(pred_def_68686,type,
    v118891: state_type > $o ).

tff(pred_def_68687,type,
    v118814: state_type > $o ).

tff(pred_def_68688,type,
    v118897: state_type > $o ).

tff(pred_def_68689,type,
    v118813: state_type > $o ).

tff(pred_def_68690,type,
    v118900: state_type > $o ).

tff(pred_def_68691,type,
    v118901: state_type > $o ).

tff(pred_def_68692,type,
    v118899: state_type > $o ).

tff(pred_def_68693,type,
    v118902: state_type > $o ).

tff(pred_def_68694,type,
    v118898: state_type > $o ).

tff(pred_def_68695,type,
    v118905: state_type > $o ).

tff(pred_def_68696,type,
    v118906: state_type > $o ).

tff(pred_def_68697,type,
    v118904: state_type > $o ).

tff(pred_def_68698,type,
    v118907: state_type > $o ).

tff(pred_def_68699,type,
    v118903: state_type > $o ).

tff(pred_def_68700,type,
    v118811: ( state_type * $int ) > $o ).

tff(pred_def_68701,type,
    v118908: ( state_type * $int ) > $o ).

tff(pred_def_68702,type,
    v118810: state_type > $o ).

tff(pred_def_68703,type,
    v118911: state_type > $o ).

tff(pred_def_68704,type,
    v118912: state_type > $o ).

tff(pred_def_68705,type,
    v118910: state_type > $o ).

tff(pred_def_68706,type,
    v118913: state_type > $o ).

tff(pred_def_68707,type,
    v118909: state_type > $o ).

tff(pred_def_68708,type,
    v118809: state_type > $o ).

tff(pred_def_68709,type,
    v118914: state_type > $o ).

tff(pred_def_68710,type,
    v118808: state_type > $o ).

tff(pred_def_68711,type,
    v118807: state_type > $o ).

tff(pred_def_68712,type,
    v118918: state_type > $o ).

tff(pred_def_68713,type,
    v118919: state_type > $o ).

tff(pred_def_68714,type,
    v118917: state_type > $o ).

tff(pred_def_68715,type,
    v118920: state_type > $o ).

tff(pred_def_68716,type,
    v118916: state_type > $o ).

tff(pred_def_68717,type,
    v118915: state_type > $o ).

tff(pred_def_68718,type,
    v118806: state_type > $o ).

tff(pred_def_68719,type,
    v118921: state_type > $o ).

tff(pred_def_68720,type,
    v118805: state_type > $o ).

tff(pred_def_68721,type,
    v118924: state_type > $o ).

tff(pred_def_68722,type,
    v118925: state_type > $o ).

tff(pred_def_68723,type,
    v118923: state_type > $o ).

tff(pred_def_68724,type,
    v118926: state_type > $o ).

tff(pred_def_68725,type,
    v118922: state_type > $o ).

tff(pred_def_68726,type,
    v118929: state_type > $o ).

tff(pred_def_68727,type,
    v118930: state_type > $o ).

tff(pred_def_68728,type,
    v118928: state_type > $o ).

tff(pred_def_68729,type,
    v118931: state_type > $o ).

tff(pred_def_68730,type,
    v118927: state_type > $o ).

tff(pred_def_68731,type,
    v118803: ( state_type * $int ) > $o ).

tff(pred_def_68732,type,
    v118932: ( state_type * $int ) > $o ).

tff(pred_def_68733,type,
    v118802: state_type > $o ).

tff(pred_def_68734,type,
    v118935: state_type > $o ).

tff(pred_def_68735,type,
    v118936: state_type > $o ).

tff(pred_def_68736,type,
    v118934: state_type > $o ).

tff(pred_def_68737,type,
    v118937: state_type > $o ).

tff(pred_def_68738,type,
    v118933: state_type > $o ).

tff(pred_def_68739,type,
    v118801: state_type > $o ).

tff(pred_def_68740,type,
    v118938: state_type > $o ).

tff(pred_def_68741,type,
    v118800: state_type > $o ).

tff(pred_def_68742,type,
    v118799: state_type > $o ).

tff(pred_def_68743,type,
    v118942: state_type > $o ).

tff(pred_def_68744,type,
    v118943: state_type > $o ).

tff(pred_def_68745,type,
    v118941: state_type > $o ).

tff(pred_def_68746,type,
    v118944: state_type > $o ).

tff(pred_def_68747,type,
    v118940: state_type > $o ).

tff(pred_def_68748,type,
    v118939: state_type > $o ).

tff(pred_def_68749,type,
    v118798: state_type > $o ).

tff(pred_def_68750,type,
    v118945: state_type > $o ).

tff(pred_def_68751,type,
    v118797: state_type > $o ).

tff(pred_def_68752,type,
    v118948: state_type > $o ).

tff(pred_def_68753,type,
    v118949: state_type > $o ).

tff(pred_def_68754,type,
    v118947: state_type > $o ).

tff(pred_def_68755,type,
    v118950: state_type > $o ).

tff(pred_def_68756,type,
    v118946: state_type > $o ).

tff(pred_def_68757,type,
    v118953: state_type > $o ).

tff(pred_def_68758,type,
    v118954: state_type > $o ).

tff(pred_def_68759,type,
    v118952: state_type > $o ).

tff(pred_def_68760,type,
    v118955: state_type > $o ).

tff(pred_def_68761,type,
    v118951: state_type > $o ).

tff(pred_def_68762,type,
    v118795: ( state_type * $int ) > $o ).

tff(pred_def_68763,type,
    v118956: ( state_type * $int ) > $o ).

tff(pred_def_68764,type,
    v118794: state_type > $o ).

tff(pred_def_68765,type,
    v118959: state_type > $o ).

tff(pred_def_68766,type,
    v118960: state_type > $o ).

tff(pred_def_68767,type,
    v118958: state_type > $o ).

tff(pred_def_68768,type,
    v118961: state_type > $o ).

tff(pred_def_68769,type,
    v118957: state_type > $o ).

tff(pred_def_68770,type,
    v118793: state_type > $o ).

tff(pred_def_68771,type,
    v118962: state_type > $o ).

tff(pred_def_68772,type,
    v118792: state_type > $o ).

tff(pred_def_68773,type,
    v118791: state_type > $o ).

tff(pred_def_68774,type,
    v118966: state_type > $o ).

tff(pred_def_68775,type,
    v118967: state_type > $o ).

tff(pred_def_68776,type,
    v118965: state_type > $o ).

tff(pred_def_68777,type,
    v118968: state_type > $o ).

tff(pred_def_68778,type,
    v118964: state_type > $o ).

tff(pred_def_68779,type,
    v118963: state_type > $o ).

tff(pred_def_68780,type,
    v118790: state_type > $o ).

tff(pred_def_68781,type,
    v118969: state_type > $o ).

tff(pred_def_68782,type,
    v118789: state_type > $o ).

tff(pred_def_68783,type,
    v118972: state_type > $o ).

tff(pred_def_68784,type,
    v118973: state_type > $o ).

tff(pred_def_68785,type,
    v118971: state_type > $o ).

tff(pred_def_68786,type,
    v118974: state_type > $o ).

tff(pred_def_68787,type,
    v118970: state_type > $o ).

tff(pred_def_68788,type,
    v118977: state_type > $o ).

tff(pred_def_68789,type,
    v118978: state_type > $o ).

tff(pred_def_68790,type,
    v118976: state_type > $o ).

tff(pred_def_68791,type,
    v118979: state_type > $o ).

tff(pred_def_68792,type,
    v118975: state_type > $o ).

tff(pred_def_68793,type,
    v118787: ( state_type * $int ) > $o ).

tff(pred_def_68794,type,
    v118772: ( state_type * $int ) > $o ).

tff(pred_def_68795,type,
    v118989: state_type > $o ).

tff(pred_def_68796,type,
    v118987: state_type > $o ).

tff(pred_def_68797,type,
    v118986: state_type > $o ).

tff(pred_def_68798,type,
    v118985: ( state_type * $int ) > $o ).

tff(pred_def_68799,type,
    v118983: state_type > $o ).

tff(pred_def_68800,type,
    v118999: state_type > $o ).

tff(pred_def_68801,type,
    v118997: state_type > $o ).

tff(pred_def_68802,type,
    v118996: state_type > $o ).

tff(pred_def_68803,type,
    v118995: ( state_type * $int ) > $o ).

tff(pred_def_68804,type,
    v118993: state_type > $o ).

tff(pred_def_68805,type,
    v119009: state_type > $o ).

tff(pred_def_68806,type,
    v119007: state_type > $o ).

tff(pred_def_68807,type,
    v119006: state_type > $o ).

tff(pred_def_68808,type,
    v119005: ( state_type * $int ) > $o ).

tff(pred_def_68809,type,
    v119003: state_type > $o ).

tff(pred_def_68810,type,
    v119013: state_type > $o ).

tff(pred_def_68811,type,
    v119015: state_type > $o ).

tff(pred_def_68812,type,
    v119017: state_type > $o ).

tff(pred_def_68813,type,
    v119023: state_type > $o ).

tff(pred_def_68814,type,
    v119022: state_type > $o ).

tff(pred_def_68815,type,
    v119021: state_type > $o ).

tff(pred_def_68816,type,
    v119020: state_type > $o ).

tff(pred_def_68817,type,
    v119019: state_type > $o ).

tff(pred_def_68818,type,
    v119018: ( state_type * $int ) > $o ).

tff(pred_def_68819,type,
    v118981: ( state_type * $int ) > $o ).

tff(pred_def_68820,type,
    v119052: ( state_type * $int ) > $o ).

tff(pred_def_68821,type,
    v118750: ( state_type * $int ) > $o ).

tff(pred_def_68822,type,
    v119051: state_type > $o ).

tff(pred_def_68823,type,
    v119055: state_type > $o ).

tff(pred_def_68824,type,
    v119056: state_type > $o ).

tff(pred_def_68825,type,
    v119054: state_type > $o ).

tff(pred_def_68826,type,
    v119057: state_type > $o ).

tff(pred_def_68827,type,
    v119053: state_type > $o ).

tff(pred_def_68828,type,
    v119050: state_type > $o ).

tff(pred_def_68829,type,
    v119058: state_type > $o ).

tff(pred_def_68830,type,
    v119049: state_type > $o ).

tff(pred_def_68831,type,
    v119061: state_type > $o ).

tff(pred_def_68832,type,
    v119062: state_type > $o ).

tff(pred_def_68833,type,
    v119060: state_type > $o ).

tff(pred_def_68834,type,
    v119063: state_type > $o ).

tff(pred_def_68835,type,
    v119059: state_type > $o ).

tff(pred_def_68836,type,
    v119048: state_type > $o ).

tff(pred_def_68837,type,
    v119064: state_type > $o ).

tff(pred_def_68838,type,
    v119047: state_type > $o ).

tff(pred_def_68839,type,
    v119067: state_type > $o ).

tff(pred_def_68840,type,
    v119068: state_type > $o ).

tff(pred_def_68841,type,
    v119066: state_type > $o ).

tff(pred_def_68842,type,
    v119069: state_type > $o ).

tff(pred_def_68843,type,
    v119065: state_type > $o ).

tff(pred_def_68844,type,
    v119046: state_type > $o ).

tff(pred_def_68845,type,
    v119070: state_type > $o ).

tff(pred_def_68846,type,
    v119045: state_type > $o ).

tff(pred_def_68847,type,
    v119073: state_type > $o ).

tff(pred_def_68848,type,
    v119074: state_type > $o ).

tff(pred_def_68849,type,
    v119072: state_type > $o ).

tff(pred_def_68850,type,
    v119075: state_type > $o ).

tff(pred_def_68851,type,
    v119071: state_type > $o ).

tff(pred_def_68852,type,
    v119044: state_type > $o ).

tff(pred_def_68853,type,
    v119076: state_type > $o ).

tff(pred_def_68854,type,
    v119043: state_type > $o ).

tff(pred_def_68855,type,
    v119042: state_type > $o ).

tff(pred_def_68856,type,
    v119080: state_type > $o ).

tff(pred_def_68857,type,
    v119081: state_type > $o ).

tff(pred_def_68858,type,
    v119079: state_type > $o ).

tff(pred_def_68859,type,
    v119082: state_type > $o ).

tff(pred_def_68860,type,
    v119078: state_type > $o ).

tff(pred_def_68861,type,
    v119077: state_type > $o ).

tff(pred_def_68862,type,
    v119041: state_type > $o ).

tff(pred_def_68863,type,
    v119083: state_type > $o ).

tff(pred_def_68864,type,
    v119040: state_type > $o ).

tff(pred_def_68865,type,
    v119086: state_type > $o ).

tff(pred_def_68866,type,
    v119087: state_type > $o ).

tff(pred_def_68867,type,
    v119085: state_type > $o ).

tff(pred_def_68868,type,
    v119088: state_type > $o ).

tff(pred_def_68869,type,
    v119084: state_type > $o ).

tff(pred_def_68870,type,
    v119091: state_type > $o ).

tff(pred_def_68871,type,
    v119092: state_type > $o ).

tff(pred_def_68872,type,
    v119090: state_type > $o ).

tff(pred_def_68873,type,
    v119093: state_type > $o ).

tff(pred_def_68874,type,
    v119089: state_type > $o ).

tff(pred_def_68875,type,
    v119096: state_type > $o ).

tff(pred_def_68876,type,
    v119097: state_type > $o ).

tff(pred_def_68877,type,
    v119095: state_type > $o ).

tff(pred_def_68878,type,
    v119098: state_type > $o ).

tff(pred_def_68879,type,
    v119094: state_type > $o ).

tff(pred_def_68880,type,
    v119101: state_type > $o ).

tff(pred_def_68881,type,
    v119102: state_type > $o ).

tff(pred_def_68882,type,
    v119100: state_type > $o ).

tff(pred_def_68883,type,
    v119103: state_type > $o ).

tff(pred_def_68884,type,
    v119099: state_type > $o ).

tff(pred_def_68885,type,
    v119106: state_type > $o ).

tff(pred_def_68886,type,
    v119107: state_type > $o ).

tff(pred_def_68887,type,
    v119105: state_type > $o ).

tff(pred_def_68888,type,
    v119108: state_type > $o ).

tff(pred_def_68889,type,
    v119104: state_type > $o ).

tff(pred_def_68890,type,
    v119038: ( state_type * $int ) > $o ).

tff(pred_def_68891,type,
    v119037: state_type > $o ).

tff(pred_def_68892,type,
    v119113: state_type > $o ).

tff(pred_def_68893,type,
    v119115: state_type > $o ).

tff(pred_def_68894,type,
    v119116: state_type > $o ).

tff(pred_def_68895,type,
    v119114: state_type > $o ).

tff(pred_def_68896,type,
    v119112: state_type > $o ).

tff(pred_def_68897,type,
    v119111: state_type > $o ).

tff(pred_def_68898,type,
    v119117: state_type > $o ).

tff(pred_def_68899,type,
    v119110: state_type > $o ).

tff(pred_def_68900,type,
    v119118: state_type > $o ).

tff(pred_def_68901,type,
    v119109: state_type > $o ).

tff(pred_def_68902,type,
    v119036: state_type > $o ).

tff(pred_def_68903,type,
    v119119: state_type > $o ).

tff(pred_def_68904,type,
    v119035: state_type > $o ).

tff(pred_def_68905,type,
    v119126: state_type > $o ).

tff(pred_def_68906,type,
    v119125: state_type > $o ).

tff(pred_def_68907,type,
    v119124: state_type > $o ).

tff(pred_def_68908,type,
    v119128: state_type > $o ).

tff(pred_def_68909,type,
    v119127: state_type > $o ).

tff(pred_def_68910,type,
    v119123: state_type > $o ).

tff(pred_def_68911,type,
    v119122: state_type > $o ).

tff(pred_def_68912,type,
    v119129: state_type > $o ).

tff(pred_def_68913,type,
    v119121: state_type > $o ).

tff(pred_def_68914,type,
    v119130: state_type > $o ).

tff(pred_def_68915,type,
    v119120: state_type > $o ).

tff(pred_def_68916,type,
    v119034: state_type > $o ).

tff(pred_def_68917,type,
    v119131: state_type > $o ).

tff(pred_def_68918,type,
    v119033: state_type > $o ).

tff(pred_def_68919,type,
    v119138: state_type > $o ).

tff(pred_def_68920,type,
    v119137: state_type > $o ).

tff(pred_def_68921,type,
    v119136: state_type > $o ).

tff(pred_def_68922,type,
    v119140: state_type > $o ).

tff(pred_def_68923,type,
    v119139: state_type > $o ).

tff(pred_def_68924,type,
    v119135: state_type > $o ).

tff(pred_def_68925,type,
    v119134: state_type > $o ).

tff(pred_def_68926,type,
    v119141: state_type > $o ).

tff(pred_def_68927,type,
    v119133: state_type > $o ).

tff(pred_def_68928,type,
    v119142: state_type > $o ).

tff(pred_def_68929,type,
    v119132: state_type > $o ).

tff(pred_def_68930,type,
    v119032: state_type > $o ).

tff(pred_def_68931,type,
    v119143: state_type > $o ).

tff(pred_def_68932,type,
    v119031: state_type > $o ).

tff(pred_def_68933,type,
    v119150: state_type > $o ).

tff(pred_def_68934,type,
    v119149: state_type > $o ).

tff(pred_def_68935,type,
    v119148: state_type > $o ).

tff(pred_def_68936,type,
    v119152: state_type > $o ).

tff(pred_def_68937,type,
    v119151: state_type > $o ).

tff(pred_def_68938,type,
    v119147: state_type > $o ).

tff(pred_def_68939,type,
    v119146: state_type > $o ).

tff(pred_def_68940,type,
    v119153: state_type > $o ).

tff(pred_def_68941,type,
    v119145: state_type > $o ).

tff(pred_def_68942,type,
    v119154: state_type > $o ).

tff(pred_def_68943,type,
    v119144: state_type > $o ).

tff(pred_def_68944,type,
    v119030: state_type > $o ).

tff(pred_def_68945,type,
    v119155: state_type > $o ).

tff(pred_def_68946,type,
    v119029: state_type > $o ).

tff(pred_def_68947,type,
    v119028: state_type > $o ).

tff(pred_def_68948,type,
    v119163: state_type > $o ).

tff(pred_def_68949,type,
    v119162: state_type > $o ).

tff(pred_def_68950,type,
    v119161: state_type > $o ).

tff(pred_def_68951,type,
    v119165: state_type > $o ).

tff(pred_def_68952,type,
    v119164: state_type > $o ).

tff(pred_def_68953,type,
    v119160: state_type > $o ).

tff(pred_def_68954,type,
    v119159: state_type > $o ).

tff(pred_def_68955,type,
    v119166: state_type > $o ).

tff(pred_def_68956,type,
    v119158: state_type > $o ).

tff(pred_def_68957,type,
    v119167: state_type > $o ).

tff(pred_def_68958,type,
    v119157: state_type > $o ).

tff(pred_def_68959,type,
    v119156: state_type > $o ).

tff(pred_def_68960,type,
    v119027: state_type > $o ).

tff(pred_def_68961,type,
    v119168: state_type > $o ).

tff(pred_def_68962,type,
    v119026: state_type > $o ).

tff(pred_def_68963,type,
    v119171: state_type > $o ).

tff(pred_def_68964,type,
    v119172: state_type > $o ).

tff(pred_def_68965,type,
    v119170: state_type > $o ).

tff(pred_def_68966,type,
    v119173: state_type > $o ).

tff(pred_def_68967,type,
    v119169: state_type > $o ).

tff(pred_def_68968,type,
    v119176: state_type > $o ).

tff(pred_def_68969,type,
    v119177: state_type > $o ).

tff(pred_def_68970,type,
    v119175: state_type > $o ).

tff(pred_def_68971,type,
    v119178: state_type > $o ).

tff(pred_def_68972,type,
    v119174: state_type > $o ).

tff(pred_def_68973,type,
    v119181: state_type > $o ).

tff(pred_def_68974,type,
    v119182: state_type > $o ).

tff(pred_def_68975,type,
    v119180: state_type > $o ).

tff(pred_def_68976,type,
    v119183: state_type > $o ).

tff(pred_def_68977,type,
    v119179: state_type > $o ).

tff(pred_def_68978,type,
    v119186: state_type > $o ).

tff(pred_def_68979,type,
    v119187: state_type > $o ).

tff(pred_def_68980,type,
    v119185: state_type > $o ).

tff(pred_def_68981,type,
    v119188: state_type > $o ).

tff(pred_def_68982,type,
    v119184: state_type > $o ).

tff(pred_def_68983,type,
    v119191: state_type > $o ).

tff(pred_def_68984,type,
    v119190: state_type > $o ).

tff(pred_def_68985,type,
    v119192: state_type > $o ).

tff(pred_def_68986,type,
    v119189: state_type > $o ).

tff(pred_def_68987,type,
    v118770: ( state_type * $int ) > $o ).

tff(pred_def_68988,type,
    v118768: ( state_type * $int ) > $o ).

tff(pred_def_68989,type,
    v118766: ( state_type * $int ) > $o ).

tff(pred_def_68990,type,
    v118764: ( state_type * $int ) > $o ).

tff(pred_def_68991,type,
    v119198: state_type > $o ).

tff(pred_def_68992,type,
    v119196: state_type > $o ).

tff(pred_def_68993,type,
    v119194: state_type > $o ).

tff(pred_def_68994,type,
    v119205: state_type > $o ).

tff(pred_def_68995,type,
    v119203: state_type > $o ).

tff(pred_def_68996,type,
    v119202: state_type > $o ).

tff(pred_def_68997,type,
    v119201: state_type > $o ).

tff(pred_def_68998,type,
    v119213: state_type > $o ).

tff(pred_def_68999,type,
    v119214: state_type > $o ).

tff(pred_def_69000,type,
    v119212: state_type > $o ).

tff(pred_def_69001,type,
    v119209: ( state_type * $int ) > $o ).

tff(pred_def_69002,type,
    v119211: ( state_type * $int ) > $o ).

tff(pred_def_69003,type,
    v118754: ( state_type * $int ) > $o ).

tff(pred_def_69004,type,
    v118752: ( state_type * $int ) > $o ).

tff(pred_def_69005,type,
    v119218: state_type > $o ).

tff(pred_def_69006,type,
    v119220: state_type > $o ).

tff(pred_def_69007,type,
    v119221: state_type > $o ).

tff(pred_def_69008,type,
    v118748: state_type > $o ).

tff(pred_def_69009,type,
    v119223: state_type > $o ).

tff(pred_def_69010,type,
    v119225: state_type > $o ).

tff(pred_def_69011,type,
    v119231: state_type > $o ).

tff(pred_def_69012,type,
    v119233: state_type > $o ).

tff(pred_def_69013,type,
    v119243: state_type > $o ).

tff(pred_def_69014,type,
    v119244: state_type > $o ).

tff(pred_def_69015,type,
    v119242: state_type > $o ).

tff(pred_def_69016,type,
    v119246: state_type > $o ).

tff(pred_def_69017,type,
    v119247: state_type > $o ).

tff(pred_def_69018,type,
    v119245: state_type > $o ).

tff(pred_def_69019,type,
    v119241: state_type > $o ).

tff(pred_def_69020,type,
    v119240: state_type > $o ).

tff(pred_def_69021,type,
    v119239: state_type > $o ).

tff(pred_def_69022,type,
    v119238: state_type > $o ).

tff(pred_def_69023,type,
    v118718: ( state_type * $int ) > $o ).

tff(pred_def_69024,type,
    v119248: state_type > $o ).

tff(pred_def_69025,type,
    v119237: state_type > $o ).

tff(pred_def_69026,type,
    v119250: state_type > $o ).

tff(pred_def_69027,type,
    v119249: state_type > $o ).

tff(pred_def_69028,type,
    v119236: state_type > $o ).

tff(pred_def_69029,type,
    v119252: state_type > $o ).

tff(pred_def_69030,type,
    v119258: state_type > $o ).

tff(pred_def_69031,type,
    v119259: state_type > $o ).

tff(pred_def_69032,type,
    v119257: state_type > $o ).

tff(pred_def_69033,type,
    v119256: state_type > $o ).

tff(pred_def_69034,type,
    v119262: state_type > $o ).

tff(pred_def_69035,type,
    v119261: state_type > $o ).

tff(pred_def_69036,type,
    v119260: state_type > $o ).

tff(pred_def_69037,type,
    v119255: state_type > $o ).

tff(pred_def_69038,type,
    v119263: state_type > $o ).

tff(pred_def_69039,type,
    v119254: state_type > $o ).

tff(pred_def_69040,type,
    v119264: state_type > $o ).

tff(pred_def_69041,type,
    v119253: state_type > $o ).

tff(pred_def_69042,type,
    v119251: state_type > $o ).

tff(pred_def_69043,type,
    v119235: state_type > $o ).

tff(pred_def_69044,type,
    v118746: ( state_type * $int ) > $o ).

tff(pred_def_69045,type,
    v119265: ( state_type * $int ) > $o ).

tff(pred_def_69046,type,
    v119229: state_type > $o ).

tff(pred_def_69047,type,
    v118744: ( state_type * $int ) > $o ).

tff(pred_def_69048,type,
    v118742: ( state_type * $int ) > $o ).

tff(pred_def_69049,type,
    v118740: ( state_type * $int ) > $o ).

tff(pred_def_69050,type,
    v119269: state_type > $o ).

tff(pred_def_69051,type,
    v119267: state_type > $o ).

tff(pred_def_69052,type,
    v119276: state_type > $o ).

tff(pred_def_69053,type,
    v119274: state_type > $o ).

tff(pred_def_69054,type,
    v119273: state_type > $o ).

tff(pred_def_69055,type,
    v119272: state_type > $o ).

tff(pred_def_69056,type,
    v119284: state_type > $o ).

tff(pred_def_69057,type,
    v119285: state_type > $o ).

tff(pred_def_69058,type,
    v119283: state_type > $o ).

tff(pred_def_69059,type,
    v119280: ( state_type * $int ) > $o ).

tff(pred_def_69060,type,
    v119282: ( state_type * $int ) > $o ).

tff(pred_def_69061,type,
    v119271: ( state_type * $int ) > $o ).

tff(pred_def_69062,type,
    v118722: ( state_type * $int ) > $o ).

tff(pred_def_69063,type,
    v118720: ( state_type * $int ) > $o ).

tff(pred_def_69064,type,
    v119289: state_type > $o ).

tff(pred_def_69065,type,
    v119295: state_type > $o ).

tff(pred_def_69066,type,
    v119294: state_type > $o ).

tff(pred_def_69067,type,
    v119293: state_type > $o ).

tff(pred_def_69068,type,
    v119297: state_type > $o ).

tff(pred_def_69069,type,
    v119296: state_type > $o ).

tff(pred_def_69070,type,
    v119292: state_type > $o ).

tff(pred_def_69071,type,
    v119299: state_type > $o ).

tff(pred_def_69072,type,
    v119305: state_type > $o ).

tff(pred_def_69073,type,
    v119304: state_type > $o ).

tff(pred_def_69074,type,
    v119303: state_type > $o ).

tff(pred_def_69075,type,
    v119302: state_type > $o ).

tff(pred_def_69076,type,
    v119306: state_type > $o ).

tff(pred_def_69077,type,
    v119301: state_type > $o ).

tff(pred_def_69078,type,
    v119307: state_type > $o ).

tff(pred_def_69079,type,
    v119300: state_type > $o ).

tff(pred_def_69080,type,
    v119298: state_type > $o ).

tff(pred_def_69081,type,
    v119291: state_type > $o ).

tff(pred_def_69082,type,
    v119313: state_type > $o ).

tff(pred_def_69083,type,
    v119311: state_type > $o ).

tff(pred_def_69084,type,
    v119310: state_type > $o ).

tff(pred_def_69085,type,
    v119309: ( state_type * $int ) > $o ).

tff(pred_def_69086,type,
    v119323: state_type > $o ).

tff(pred_def_69087,type,
    v119322: state_type > $o ).

tff(pred_def_69088,type,
    v119321: state_type > $o ).

tff(pred_def_69089,type,
    v119320: state_type > $o ).

tff(pred_def_69090,type,
    v119325: state_type > $o ).

tff(pred_def_69091,type,
    v119326: state_type > $o ).

tff(pred_def_69092,type,
    v119324: state_type > $o ).

tff(pred_def_69093,type,
    v119319: state_type > $o ).

tff(pred_def_69094,type,
    v119329: state_type > $o ).

tff(pred_def_69095,type,
    v119328: state_type > $o ).

tff(pred_def_69096,type,
    v119330: state_type > $o ).

tff(pred_def_69097,type,
    v119327: state_type > $o ).

tff(pred_def_69098,type,
    v119318: state_type > $o ).

tff(pred_def_69099,type,
    v119334: state_type > $o ).

tff(pred_def_69100,type,
    v119333: state_type > $o ).

tff(pred_def_69101,type,
    v119332: state_type > $o ).

tff(pred_def_69102,type,
    v119335: state_type > $o ).

tff(pred_def_69103,type,
    v119331: state_type > $o ).

tff(pred_def_69104,type,
    v119317: state_type > $o ).

tff(pred_def_69105,type,
    v119342: state_type > $o ).

tff(pred_def_69106,type,
    v119340: state_type > $o ).

tff(pred_def_69107,type,
    v119339: state_type > $o ).

tff(pred_def_69108,type,
    v119338: ( state_type * $int ) > $o ).

tff(pred_def_69109,type,
    v119227: state_type > $o ).

tff(pred_def_69110,type,
    v119348: state_type > $o ).

tff(pred_def_69111,type,
    v119350: state_type > $o ).

tff(pred_def_69112,type,
    v119353: state_type > $o ).

tff(pred_def_69113,type,
    v119354: state_type > $o ).

tff(pred_def_69114,type,
    v119352: state_type > $o ).

tff(pred_def_69115,type,
    v119351: state_type > $o ).

tff(pred_def_69116,type,
    v119349: state_type > $o ).

tff(pred_def_69117,type,
    v119347: state_type > $o ).

tff(pred_def_69118,type,
    v119360: state_type > $o ).

tff(pred_def_69119,type,
    v119358: state_type > $o ).

tff(pred_def_69120,type,
    v119357: state_type > $o ).

tff(pred_def_69121,type,
    v119356: ( state_type * $int ) > $o ).

tff(pred_def_69122,type,
    v119374: state_type > $o ).

tff(pred_def_69123,type,
    v119372: state_type > $o ).

tff(pred_def_69124,type,
    v119378: state_type > $o ).

tff(pred_def_69125,type,
    v119376: state_type > $o ).

tff(pred_def_69126,type,
    v119390: state_type > $o ).

tff(pred_def_69127,type,
    v119391: state_type > $o ).

tff(pred_def_69128,type,
    v119388: state_type > $o ).

tff(pred_def_69129,type,
    v119366: ( state_type * $int ) > $o ).

tff(pred_def_69130,type,
    v119398: state_type > $o ).

tff(pred_def_69131,type,
    v119397: state_type > $o ).

tff(pred_def_69132,type,
    v119400: state_type > $o ).

tff(pred_def_69133,type,
    v119399: state_type > $o ).

tff(pred_def_69134,type,
    v119396: state_type > $o ).

tff(pred_def_69135,type,
    v119394: ( state_type * $int ) > $o ).

tff(pred_def_69136,type,
    v119364: state_type > $o ).

tff(pred_def_69137,type,
    v119393: ( state_type * $int ) > $o ).

tff(pred_def_69138,type,
    v119386: ( state_type * $int ) > $o ).

tff(pred_def_69139,type,
    v119384: ( state_type * $int ) > $o ).

tff(pred_def_69140,type,
    v119382: ( state_type * $int ) > $o ).

tff(pred_def_69141,type,
    v119380: ( state_type * $int ) > $o ).

tff(pred_def_69142,type,
    v119404: state_type > $o ).

tff(pred_def_69143,type,
    v119402: state_type > $o ).

tff(pred_def_69144,type,
    v119411: state_type > $o ).

tff(pred_def_69145,type,
    v119409: state_type > $o ).

tff(pred_def_69146,type,
    v119408: state_type > $o ).

tff(pred_def_69147,type,
    v119407: state_type > $o ).

tff(pred_def_69148,type,
    v119419: state_type > $o ).

tff(pred_def_69149,type,
    v119420: state_type > $o ).

tff(pred_def_69150,type,
    v119418: state_type > $o ).

tff(pred_def_69151,type,
    v119415: ( state_type * $int ) > $o ).

tff(pred_def_69152,type,
    v119417: ( state_type * $int ) > $o ).

tff(pred_def_69153,type,
    v119370: ( state_type * $int ) > $o ).

tff(pred_def_69154,type,
    v119368: ( state_type * $int ) > $o ).

tff(pred_def_69155,type,
    v119435: state_type > $o ).

tff(pred_def_69156,type,
    v119433: state_type > $o ).

tff(pred_def_69157,type,
    v119439: state_type > $o ).

tff(pred_def_69158,type,
    v119437: state_type > $o ).

tff(pred_def_69159,type,
    v119452: state_type > $o ).

tff(pred_def_69160,type,
    v119451: state_type > $o ).

tff(pred_def_69161,type,
    v119449: state_type > $o ).

tff(pred_def_69162,type,
    v119454: ( state_type * $int ) > $o ).

tff(pred_def_69163,type,
    v119456: state_type > $o ).

tff(pred_def_69164,type,
    v119459: ( state_type * $int ) > $o ).

tff(pred_def_69165,type,
    v119427: ( state_type * $int ) > $o ).

tff(pred_def_69166,type,
    v119474: state_type > $o ).

tff(pred_def_69167,type,
    v119473: state_type > $o ).

tff(pred_def_69168,type,
    v119472: state_type > $o ).

tff(pred_def_69169,type,
    v119475: state_type > $o ).

tff(pred_def_69170,type,
    v119471: state_type > $o ).

tff(pred_def_69171,type,
    v119470: state_type > $o ).

tff(pred_def_69172,type,
    v119476: state_type > $o ).

tff(pred_def_69173,type,
    v119469: state_type > $o ).

tff(pred_def_69174,type,
    v119468: state_type > $o ).

tff(pred_def_69175,type,
    v119467: state_type > $o ).

tff(pred_def_69176,type,
    v119466: state_type > $o ).

tff(pred_def_69177,type,
    v119478: state_type > $o ).

tff(pred_def_69178,type,
    v119477: state_type > $o ).

tff(pred_def_69179,type,
    v119465: state_type > $o ).

tff(pred_def_69180,type,
    v119481: state_type > $o ).

tff(pred_def_69181,type,
    v119480: state_type > $o ).

tff(pred_def_69182,type,
    v119482: state_type > $o ).

tff(pred_def_69183,type,
    v119479: state_type > $o ).

tff(pred_def_69184,type,
    v119485: state_type > $o ).

tff(pred_def_69185,type,
    v119484: state_type > $o ).

tff(pred_def_69186,type,
    v119486: state_type > $o ).

tff(pred_def_69187,type,
    v119483: state_type > $o ).

tff(pred_def_69188,type,
    v119489: state_type > $o ).

tff(pred_def_69189,type,
    v119488: state_type > $o ).

tff(pred_def_69190,type,
    v119490: state_type > $o ).

tff(pred_def_69191,type,
    v119487: state_type > $o ).

tff(pred_def_69192,type,
    v119463: ( state_type * $int ) > $o ).

tff(pred_def_69193,type,
    v119425: state_type > $o ).

tff(pred_def_69194,type,
    v119462: ( state_type * $int ) > $o ).

tff(pred_def_69195,type,
    v119461: ( state_type * $int ) > $o ).

tff(pred_def_69196,type,
    v119447: ( state_type * $int ) > $o ).

tff(pred_def_69197,type,
    v119445: ( state_type * $int ) > $o ).

tff(pred_def_69198,type,
    v119443: ( state_type * $int ) > $o ).

tff(pred_def_69199,type,
    v119441: ( state_type * $int ) > $o ).

tff(pred_def_69200,type,
    v119494: state_type > $o ).

tff(pred_def_69201,type,
    v119492: state_type > $o ).

tff(pred_def_69202,type,
    v119501: state_type > $o ).

tff(pred_def_69203,type,
    v119499: state_type > $o ).

tff(pred_def_69204,type,
    v119498: state_type > $o ).

tff(pred_def_69205,type,
    v119497: state_type > $o ).

tff(pred_def_69206,type,
    v119509: state_type > $o ).

tff(pred_def_69207,type,
    v119510: state_type > $o ).

tff(pred_def_69208,type,
    v119508: state_type > $o ).

tff(pred_def_69209,type,
    v119505: ( state_type * $int ) > $o ).

tff(pred_def_69210,type,
    v119507: ( state_type * $int ) > $o ).

tff(pred_def_69211,type,
    v119431: ( state_type * $int ) > $o ).

tff(pred_def_69212,type,
    v119429: ( state_type * $int ) > $o ).

tff(pred_def_69213,type,
    v119515: state_type > $o ).

tff(pred_def_69214,type,
    v118716: state_type > $o ).

tff(pred_def_69215,type,
    v119531: state_type > $o ).

tff(pred_def_69216,type,
    v119529: state_type > $o ).

tff(pred_def_69217,type,
    v119527: state_type > $o ).

tff(pred_def_69218,type,
    v119525: state_type > $o ).

tff(pred_def_69219,type,
    v119539: state_type > $o ).

tff(pred_def_69220,type,
    v119537: state_type > $o ).

tff(pred_def_69221,type,
    v119535: state_type > $o ).

tff(pred_def_69222,type,
    v119533: state_type > $o ).

tff(pred_def_69223,type,
    v119559: state_type > $o ).

tff(pred_def_69224,type,
    v119557: state_type > $o ).

tff(pred_def_69225,type,
    v119563: state_type > $o ).

tff(pred_def_69226,type,
    v119561: state_type > $o ).

tff(pred_def_69227,type,
    v119575: state_type > $o ).

tff(pred_def_69228,type,
    v119577: state_type > $o ).

tff(pred_def_69229,type,
    v119579: state_type > $o ).

tff(pred_def_69230,type,
    v119581: state_type > $o ).

tff(pred_def_69231,type,
    v119583: state_type > $o ).

tff(pred_def_69232,type,
    v119585: state_type > $o ).

tff(pred_def_69233,type,
    v119587: state_type > $o ).

tff(pred_def_69234,type,
    v119636: ( state_type * $int ) > $o ).

tff(pred_def_69235,type,
    v119637: ( state_type * $int ) > $o ).

tff(pred_def_69236,type,
    v119635: state_type > $o ).

tff(pred_def_69237,type,
    v119640: state_type > $o ).

tff(pred_def_69238,type,
    v119641: state_type > $o ).

tff(pred_def_69239,type,
    v119639: state_type > $o ).

tff(pred_def_69240,type,
    v119642: state_type > $o ).

tff(pred_def_69241,type,
    v119638: state_type > $o ).

tff(pred_def_69242,type,
    v119634: state_type > $o ).

tff(pred_def_69243,type,
    v119643: state_type > $o ).

tff(pred_def_69244,type,
    v119633: state_type > $o ).

tff(pred_def_69245,type,
    v119632: state_type > $o ).

tff(pred_def_69246,type,
    v119647: state_type > $o ).

tff(pred_def_69247,type,
    v119648: state_type > $o ).

tff(pred_def_69248,type,
    v119646: state_type > $o ).

tff(pred_def_69249,type,
    v119649: state_type > $o ).

tff(pred_def_69250,type,
    v119645: state_type > $o ).

tff(pred_def_69251,type,
    v119644: state_type > $o ).

tff(pred_def_69252,type,
    v119631: state_type > $o ).

tff(pred_def_69253,type,
    v119650: state_type > $o ).

tff(pred_def_69254,type,
    v119630: state_type > $o ).

tff(pred_def_69255,type,
    v119653: state_type > $o ).

tff(pred_def_69256,type,
    v119654: state_type > $o ).

tff(pred_def_69257,type,
    v119652: state_type > $o ).

tff(pred_def_69258,type,
    v119655: state_type > $o ).

tff(pred_def_69259,type,
    v119651: state_type > $o ).

tff(pred_def_69260,type,
    v119658: state_type > $o ).

tff(pred_def_69261,type,
    v119659: state_type > $o ).

tff(pred_def_69262,type,
    v119657: state_type > $o ).

tff(pred_def_69263,type,
    v119660: state_type > $o ).

tff(pred_def_69264,type,
    v119656: state_type > $o ).

tff(pred_def_69265,type,
    v119628: ( state_type * $int ) > $o ).

tff(pred_def_69266,type,
    v119661: ( state_type * $int ) > $o ).

tff(pred_def_69267,type,
    v119627: state_type > $o ).

tff(pred_def_69268,type,
    v119664: state_type > $o ).

tff(pred_def_69269,type,
    v119665: state_type > $o ).

tff(pred_def_69270,type,
    v119663: state_type > $o ).

tff(pred_def_69271,type,
    v119666: state_type > $o ).

tff(pred_def_69272,type,
    v119662: state_type > $o ).

tff(pred_def_69273,type,
    v119626: state_type > $o ).

tff(pred_def_69274,type,
    v119667: state_type > $o ).

tff(pred_def_69275,type,
    v119625: state_type > $o ).

tff(pred_def_69276,type,
    v119624: state_type > $o ).

tff(pred_def_69277,type,
    v119671: state_type > $o ).

tff(pred_def_69278,type,
    v119672: state_type > $o ).

tff(pred_def_69279,type,
    v119670: state_type > $o ).

tff(pred_def_69280,type,
    v119673: state_type > $o ).

tff(pred_def_69281,type,
    v119669: state_type > $o ).

tff(pred_def_69282,type,
    v119668: state_type > $o ).

tff(pred_def_69283,type,
    v119623: state_type > $o ).

tff(pred_def_69284,type,
    v119674: state_type > $o ).

tff(pred_def_69285,type,
    v119622: state_type > $o ).

tff(pred_def_69286,type,
    v119677: state_type > $o ).

tff(pred_def_69287,type,
    v119678: state_type > $o ).

tff(pred_def_69288,type,
    v119676: state_type > $o ).

tff(pred_def_69289,type,
    v119679: state_type > $o ).

tff(pred_def_69290,type,
    v119675: state_type > $o ).

tff(pred_def_69291,type,
    v119682: state_type > $o ).

tff(pred_def_69292,type,
    v119683: state_type > $o ).

tff(pred_def_69293,type,
    v119681: state_type > $o ).

tff(pred_def_69294,type,
    v119684: state_type > $o ).

tff(pred_def_69295,type,
    v119680: state_type > $o ).

tff(pred_def_69296,type,
    v119620: ( state_type * $int ) > $o ).

tff(pred_def_69297,type,
    v119685: ( state_type * $int ) > $o ).

tff(pred_def_69298,type,
    v119619: state_type > $o ).

tff(pred_def_69299,type,
    v119688: state_type > $o ).

tff(pred_def_69300,type,
    v119689: state_type > $o ).

tff(pred_def_69301,type,
    v119687: state_type > $o ).

tff(pred_def_69302,type,
    v119690: state_type > $o ).

tff(pred_def_69303,type,
    v119686: state_type > $o ).

tff(pred_def_69304,type,
    v119618: state_type > $o ).

tff(pred_def_69305,type,
    v119691: state_type > $o ).

tff(pred_def_69306,type,
    v119617: state_type > $o ).

tff(pred_def_69307,type,
    v119616: state_type > $o ).

tff(pred_def_69308,type,
    v119695: state_type > $o ).

tff(pred_def_69309,type,
    v119696: state_type > $o ).

tff(pred_def_69310,type,
    v119694: state_type > $o ).

tff(pred_def_69311,type,
    v119697: state_type > $o ).

tff(pred_def_69312,type,
    v119693: state_type > $o ).

tff(pred_def_69313,type,
    v119692: state_type > $o ).

tff(pred_def_69314,type,
    v119615: state_type > $o ).

tff(pred_def_69315,type,
    v119698: state_type > $o ).

tff(pred_def_69316,type,
    v119614: state_type > $o ).

tff(pred_def_69317,type,
    v119701: state_type > $o ).

tff(pred_def_69318,type,
    v119702: state_type > $o ).

tff(pred_def_69319,type,
    v119700: state_type > $o ).

tff(pred_def_69320,type,
    v119703: state_type > $o ).

tff(pred_def_69321,type,
    v119699: state_type > $o ).

tff(pred_def_69322,type,
    v119706: state_type > $o ).

tff(pred_def_69323,type,
    v119707: state_type > $o ).

tff(pred_def_69324,type,
    v119705: state_type > $o ).

tff(pred_def_69325,type,
    v119708: state_type > $o ).

tff(pred_def_69326,type,
    v119704: state_type > $o ).

tff(pred_def_69327,type,
    v119612: ( state_type * $int ) > $o ).

tff(pred_def_69328,type,
    v119709: ( state_type * $int ) > $o ).

tff(pred_def_69329,type,
    v119611: state_type > $o ).

tff(pred_def_69330,type,
    v119712: state_type > $o ).

tff(pred_def_69331,type,
    v119713: state_type > $o ).

tff(pred_def_69332,type,
    v119711: state_type > $o ).

tff(pred_def_69333,type,
    v119714: state_type > $o ).

tff(pred_def_69334,type,
    v119710: state_type > $o ).

tff(pred_def_69335,type,
    v119610: state_type > $o ).

tff(pred_def_69336,type,
    v119715: state_type > $o ).

tff(pred_def_69337,type,
    v119609: state_type > $o ).

tff(pred_def_69338,type,
    v119608: state_type > $o ).

tff(pred_def_69339,type,
    v119719: state_type > $o ).

tff(pred_def_69340,type,
    v119720: state_type > $o ).

tff(pred_def_69341,type,
    v119718: state_type > $o ).

tff(pred_def_69342,type,
    v119721: state_type > $o ).

tff(pred_def_69343,type,
    v119717: state_type > $o ).

tff(pred_def_69344,type,
    v119716: state_type > $o ).

tff(pred_def_69345,type,
    v119607: state_type > $o ).

tff(pred_def_69346,type,
    v119722: state_type > $o ).

tff(pred_def_69347,type,
    v119606: state_type > $o ).

tff(pred_def_69348,type,
    v119725: state_type > $o ).

tff(pred_def_69349,type,
    v119726: state_type > $o ).

tff(pred_def_69350,type,
    v119724: state_type > $o ).

tff(pred_def_69351,type,
    v119727: state_type > $o ).

tff(pred_def_69352,type,
    v119723: state_type > $o ).

tff(pred_def_69353,type,
    v119730: state_type > $o ).

tff(pred_def_69354,type,
    v119731: state_type > $o ).

tff(pred_def_69355,type,
    v119729: state_type > $o ).

tff(pred_def_69356,type,
    v119732: state_type > $o ).

tff(pred_def_69357,type,
    v119728: state_type > $o ).

tff(pred_def_69358,type,
    v119604: ( state_type * $int ) > $o ).

tff(pred_def_69359,type,
    v119733: ( state_type * $int ) > $o ).

tff(pred_def_69360,type,
    v119603: state_type > $o ).

tff(pred_def_69361,type,
    v119736: state_type > $o ).

tff(pred_def_69362,type,
    v119737: state_type > $o ).

tff(pred_def_69363,type,
    v119735: state_type > $o ).

tff(pred_def_69364,type,
    v119738: state_type > $o ).

tff(pred_def_69365,type,
    v119734: state_type > $o ).

tff(pred_def_69366,type,
    v119602: state_type > $o ).

tff(pred_def_69367,type,
    v119739: state_type > $o ).

tff(pred_def_69368,type,
    v119601: state_type > $o ).

tff(pred_def_69369,type,
    v119600: state_type > $o ).

tff(pred_def_69370,type,
    v119743: state_type > $o ).

tff(pred_def_69371,type,
    v119744: state_type > $o ).

tff(pred_def_69372,type,
    v119742: state_type > $o ).

tff(pred_def_69373,type,
    v119745: state_type > $o ).

tff(pred_def_69374,type,
    v119741: state_type > $o ).

tff(pred_def_69375,type,
    v119740: state_type > $o ).

tff(pred_def_69376,type,
    v119599: state_type > $o ).

tff(pred_def_69377,type,
    v119746: state_type > $o ).

tff(pred_def_69378,type,
    v119598: state_type > $o ).

tff(pred_def_69379,type,
    v119749: state_type > $o ).

tff(pred_def_69380,type,
    v119750: state_type > $o ).

tff(pred_def_69381,type,
    v119748: state_type > $o ).

tff(pred_def_69382,type,
    v119751: state_type > $o ).

tff(pred_def_69383,type,
    v119747: state_type > $o ).

tff(pred_def_69384,type,
    v119754: state_type > $o ).

tff(pred_def_69385,type,
    v119755: state_type > $o ).

tff(pred_def_69386,type,
    v119753: state_type > $o ).

tff(pred_def_69387,type,
    v119756: state_type > $o ).

tff(pred_def_69388,type,
    v119752: state_type > $o ).

tff(pred_def_69389,type,
    v119596: ( state_type * $int ) > $o ).

tff(pred_def_69390,type,
    v119757: ( state_type * $int ) > $o ).

tff(pred_def_69391,type,
    v119595: state_type > $o ).

tff(pred_def_69392,type,
    v119760: state_type > $o ).

tff(pred_def_69393,type,
    v119761: state_type > $o ).

tff(pred_def_69394,type,
    v119759: state_type > $o ).

tff(pred_def_69395,type,
    v119762: state_type > $o ).

tff(pred_def_69396,type,
    v119758: state_type > $o ).

tff(pred_def_69397,type,
    v119594: state_type > $o ).

tff(pred_def_69398,type,
    v119763: state_type > $o ).

tff(pred_def_69399,type,
    v119593: state_type > $o ).

tff(pred_def_69400,type,
    v119592: state_type > $o ).

tff(pred_def_69401,type,
    v119767: state_type > $o ).

tff(pred_def_69402,type,
    v119768: state_type > $o ).

tff(pred_def_69403,type,
    v119766: state_type > $o ).

tff(pred_def_69404,type,
    v119769: state_type > $o ).

tff(pred_def_69405,type,
    v119765: state_type > $o ).

tff(pred_def_69406,type,
    v119764: state_type > $o ).

tff(pred_def_69407,type,
    v119591: state_type > $o ).

tff(pred_def_69408,type,
    v119770: state_type > $o ).

tff(pred_def_69409,type,
    v119590: state_type > $o ).

tff(pred_def_69410,type,
    v119773: state_type > $o ).

tff(pred_def_69411,type,
    v119774: state_type > $o ).

tff(pred_def_69412,type,
    v119772: state_type > $o ).

tff(pred_def_69413,type,
    v119775: state_type > $o ).

tff(pred_def_69414,type,
    v119771: state_type > $o ).

tff(pred_def_69415,type,
    v119778: state_type > $o ).

tff(pred_def_69416,type,
    v119779: state_type > $o ).

tff(pred_def_69417,type,
    v119777: state_type > $o ).

tff(pred_def_69418,type,
    v119780: state_type > $o ).

tff(pred_def_69419,type,
    v119776: state_type > $o ).

tff(pred_def_69420,type,
    v119588: ( state_type * $int ) > $o ).

tff(pred_def_69421,type,
    v119573: ( state_type * $int ) > $o ).

tff(pred_def_69422,type,
    v119790: state_type > $o ).

tff(pred_def_69423,type,
    v119788: state_type > $o ).

tff(pred_def_69424,type,
    v119787: state_type > $o ).

tff(pred_def_69425,type,
    v119786: ( state_type * $int ) > $o ).

tff(pred_def_69426,type,
    v119784: state_type > $o ).

tff(pred_def_69427,type,
    v119800: state_type > $o ).

tff(pred_def_69428,type,
    v119798: state_type > $o ).

tff(pred_def_69429,type,
    v119797: state_type > $o ).

tff(pred_def_69430,type,
    v119796: ( state_type * $int ) > $o ).

tff(pred_def_69431,type,
    v119794: state_type > $o ).

tff(pred_def_69432,type,
    v119810: state_type > $o ).

tff(pred_def_69433,type,
    v119808: state_type > $o ).

tff(pred_def_69434,type,
    v119807: state_type > $o ).

tff(pred_def_69435,type,
    v119806: ( state_type * $int ) > $o ).

tff(pred_def_69436,type,
    v119804: state_type > $o ).

tff(pred_def_69437,type,
    v119814: state_type > $o ).

tff(pred_def_69438,type,
    v119816: state_type > $o ).

tff(pred_def_69439,type,
    v119818: state_type > $o ).

tff(pred_def_69440,type,
    v119824: state_type > $o ).

tff(pred_def_69441,type,
    v119823: state_type > $o ).

tff(pred_def_69442,type,
    v119822: state_type > $o ).

tff(pred_def_69443,type,
    v119821: state_type > $o ).

tff(pred_def_69444,type,
    v119820: state_type > $o ).

tff(pred_def_69445,type,
    v119819: ( state_type * $int ) > $o ).

tff(pred_def_69446,type,
    v119782: ( state_type * $int ) > $o ).

tff(pred_def_69447,type,
    v119853: ( state_type * $int ) > $o ).

tff(pred_def_69448,type,
    v119551: ( state_type * $int ) > $o ).

tff(pred_def_69449,type,
    v119852: state_type > $o ).

tff(pred_def_69450,type,
    v119856: state_type > $o ).

tff(pred_def_69451,type,
    v119857: state_type > $o ).

tff(pred_def_69452,type,
    v119855: state_type > $o ).

tff(pred_def_69453,type,
    v119858: state_type > $o ).

tff(pred_def_69454,type,
    v119854: state_type > $o ).

tff(pred_def_69455,type,
    v119851: state_type > $o ).

tff(pred_def_69456,type,
    v119859: state_type > $o ).

tff(pred_def_69457,type,
    v119850: state_type > $o ).

tff(pred_def_69458,type,
    v119862: state_type > $o ).

tff(pred_def_69459,type,
    v119863: state_type > $o ).

tff(pred_def_69460,type,
    v119861: state_type > $o ).

tff(pred_def_69461,type,
    v119864: state_type > $o ).

tff(pred_def_69462,type,
    v119860: state_type > $o ).

tff(pred_def_69463,type,
    v119849: state_type > $o ).

tff(pred_def_69464,type,
    v119865: state_type > $o ).

tff(pred_def_69465,type,
    v119848: state_type > $o ).

tff(pred_def_69466,type,
    v119868: state_type > $o ).

tff(pred_def_69467,type,
    v119869: state_type > $o ).

tff(pred_def_69468,type,
    v119867: state_type > $o ).

tff(pred_def_69469,type,
    v119870: state_type > $o ).

tff(pred_def_69470,type,
    v119866: state_type > $o ).

tff(pred_def_69471,type,
    v119847: state_type > $o ).

tff(pred_def_69472,type,
    v119871: state_type > $o ).

tff(pred_def_69473,type,
    v119846: state_type > $o ).

tff(pred_def_69474,type,
    v119874: state_type > $o ).

tff(pred_def_69475,type,
    v119875: state_type > $o ).

tff(pred_def_69476,type,
    v119873: state_type > $o ).

tff(pred_def_69477,type,
    v119876: state_type > $o ).

tff(pred_def_69478,type,
    v119872: state_type > $o ).

tff(pred_def_69479,type,
    v119845: state_type > $o ).

tff(pred_def_69480,type,
    v119877: state_type > $o ).

tff(pred_def_69481,type,
    v119844: state_type > $o ).

tff(pred_def_69482,type,
    v119843: state_type > $o ).

tff(pred_def_69483,type,
    v119881: state_type > $o ).

tff(pred_def_69484,type,
    v119882: state_type > $o ).

tff(pred_def_69485,type,
    v119880: state_type > $o ).

tff(pred_def_69486,type,
    v119883: state_type > $o ).

tff(pred_def_69487,type,
    v119879: state_type > $o ).

tff(pred_def_69488,type,
    v119878: state_type > $o ).

tff(pred_def_69489,type,
    v119842: state_type > $o ).

tff(pred_def_69490,type,
    v119884: state_type > $o ).

tff(pred_def_69491,type,
    v119841: state_type > $o ).

tff(pred_def_69492,type,
    v119887: state_type > $o ).

tff(pred_def_69493,type,
    v119888: state_type > $o ).

tff(pred_def_69494,type,
    v119886: state_type > $o ).

tff(pred_def_69495,type,
    v119889: state_type > $o ).

tff(pred_def_69496,type,
    v119885: state_type > $o ).

tff(pred_def_69497,type,
    v119892: state_type > $o ).

tff(pred_def_69498,type,
    v119893: state_type > $o ).

tff(pred_def_69499,type,
    v119891: state_type > $o ).

tff(pred_def_69500,type,
    v119894: state_type > $o ).

tff(pred_def_69501,type,
    v119890: state_type > $o ).

tff(pred_def_69502,type,
    v119897: state_type > $o ).

tff(pred_def_69503,type,
    v119898: state_type > $o ).

tff(pred_def_69504,type,
    v119896: state_type > $o ).

tff(pred_def_69505,type,
    v119899: state_type > $o ).

tff(pred_def_69506,type,
    v119895: state_type > $o ).

tff(pred_def_69507,type,
    v119902: state_type > $o ).

tff(pred_def_69508,type,
    v119903: state_type > $o ).

tff(pred_def_69509,type,
    v119901: state_type > $o ).

tff(pred_def_69510,type,
    v119904: state_type > $o ).

tff(pred_def_69511,type,
    v119900: state_type > $o ).

tff(pred_def_69512,type,
    v119907: state_type > $o ).

tff(pred_def_69513,type,
    v119908: state_type > $o ).

tff(pred_def_69514,type,
    v119906: state_type > $o ).

tff(pred_def_69515,type,
    v119909: state_type > $o ).

tff(pred_def_69516,type,
    v119905: state_type > $o ).

tff(pred_def_69517,type,
    v119839: ( state_type * $int ) > $o ).

tff(pred_def_69518,type,
    v119838: state_type > $o ).

tff(pred_def_69519,type,
    v119914: state_type > $o ).

tff(pred_def_69520,type,
    v119916: state_type > $o ).

tff(pred_def_69521,type,
    v119917: state_type > $o ).

tff(pred_def_69522,type,
    v119915: state_type > $o ).

tff(pred_def_69523,type,
    v119913: state_type > $o ).

tff(pred_def_69524,type,
    v119912: state_type > $o ).

tff(pred_def_69525,type,
    v119918: state_type > $o ).

tff(pred_def_69526,type,
    v119911: state_type > $o ).

tff(pred_def_69527,type,
    v119919: state_type > $o ).

tff(pred_def_69528,type,
    v119910: state_type > $o ).

tff(pred_def_69529,type,
    v119837: state_type > $o ).

tff(pred_def_69530,type,
    v119920: state_type > $o ).

tff(pred_def_69531,type,
    v119836: state_type > $o ).

tff(pred_def_69532,type,
    v119927: state_type > $o ).

tff(pred_def_69533,type,
    v119926: state_type > $o ).

tff(pred_def_69534,type,
    v119925: state_type > $o ).

tff(pred_def_69535,type,
    v119929: state_type > $o ).

tff(pred_def_69536,type,
    v119928: state_type > $o ).

tff(pred_def_69537,type,
    v119924: state_type > $o ).

tff(pred_def_69538,type,
    v119923: state_type > $o ).

tff(pred_def_69539,type,
    v119930: state_type > $o ).

tff(pred_def_69540,type,
    v119922: state_type > $o ).

tff(pred_def_69541,type,
    v119931: state_type > $o ).

tff(pred_def_69542,type,
    v119921: state_type > $o ).

tff(pred_def_69543,type,
    v119835: state_type > $o ).

tff(pred_def_69544,type,
    v119932: state_type > $o ).

tff(pred_def_69545,type,
    v119834: state_type > $o ).

tff(pred_def_69546,type,
    v119939: state_type > $o ).

tff(pred_def_69547,type,
    v119938: state_type > $o ).

tff(pred_def_69548,type,
    v119937: state_type > $o ).

tff(pred_def_69549,type,
    v119941: state_type > $o ).

tff(pred_def_69550,type,
    v119940: state_type > $o ).

tff(pred_def_69551,type,
    v119936: state_type > $o ).

tff(pred_def_69552,type,
    v119935: state_type > $o ).

tff(pred_def_69553,type,
    v119942: state_type > $o ).

tff(pred_def_69554,type,
    v119934: state_type > $o ).

tff(pred_def_69555,type,
    v119943: state_type > $o ).

tff(pred_def_69556,type,
    v119933: state_type > $o ).

tff(pred_def_69557,type,
    v119833: state_type > $o ).

tff(pred_def_69558,type,
    v119944: state_type > $o ).

tff(pred_def_69559,type,
    v119832: state_type > $o ).

tff(pred_def_69560,type,
    v119951: state_type > $o ).

tff(pred_def_69561,type,
    v119950: state_type > $o ).

tff(pred_def_69562,type,
    v119949: state_type > $o ).

tff(pred_def_69563,type,
    v119953: state_type > $o ).

tff(pred_def_69564,type,
    v119952: state_type > $o ).

tff(pred_def_69565,type,
    v119948: state_type > $o ).

tff(pred_def_69566,type,
    v119947: state_type > $o ).

tff(pred_def_69567,type,
    v119954: state_type > $o ).

tff(pred_def_69568,type,
    v119946: state_type > $o ).

tff(pred_def_69569,type,
    v119955: state_type > $o ).

tff(pred_def_69570,type,
    v119945: state_type > $o ).

tff(pred_def_69571,type,
    v119831: state_type > $o ).

tff(pred_def_69572,type,
    v119956: state_type > $o ).

tff(pred_def_69573,type,
    v119830: state_type > $o ).

tff(pred_def_69574,type,
    v119829: state_type > $o ).

tff(pred_def_69575,type,
    v119964: state_type > $o ).

tff(pred_def_69576,type,
    v119963: state_type > $o ).

tff(pred_def_69577,type,
    v119962: state_type > $o ).

tff(pred_def_69578,type,
    v119966: state_type > $o ).

tff(pred_def_69579,type,
    v119965: state_type > $o ).

tff(pred_def_69580,type,
    v119961: state_type > $o ).

tff(pred_def_69581,type,
    v119960: state_type > $o ).

tff(pred_def_69582,type,
    v119967: state_type > $o ).

tff(pred_def_69583,type,
    v119959: state_type > $o ).

tff(pred_def_69584,type,
    v119968: state_type > $o ).

tff(pred_def_69585,type,
    v119958: state_type > $o ).

tff(pred_def_69586,type,
    v119957: state_type > $o ).

tff(pred_def_69587,type,
    v119828: state_type > $o ).

tff(pred_def_69588,type,
    v119969: state_type > $o ).

tff(pred_def_69589,type,
    v119827: state_type > $o ).

tff(pred_def_69590,type,
    v119972: state_type > $o ).

tff(pred_def_69591,type,
    v119973: state_type > $o ).

tff(pred_def_69592,type,
    v119971: state_type > $o ).

tff(pred_def_69593,type,
    v119974: state_type > $o ).

tff(pred_def_69594,type,
    v119970: state_type > $o ).

tff(pred_def_69595,type,
    v119977: state_type > $o ).

tff(pred_def_69596,type,
    v119978: state_type > $o ).

tff(pred_def_69597,type,
    v119976: state_type > $o ).

tff(pred_def_69598,type,
    v119979: state_type > $o ).

tff(pred_def_69599,type,
    v119975: state_type > $o ).

tff(pred_def_69600,type,
    v119982: state_type > $o ).

tff(pred_def_69601,type,
    v119983: state_type > $o ).

tff(pred_def_69602,type,
    v119981: state_type > $o ).

tff(pred_def_69603,type,
    v119984: state_type > $o ).

tff(pred_def_69604,type,
    v119980: state_type > $o ).

tff(pred_def_69605,type,
    v119987: state_type > $o ).

tff(pred_def_69606,type,
    v119988: state_type > $o ).

tff(pred_def_69607,type,
    v119986: state_type > $o ).

tff(pred_def_69608,type,
    v119989: state_type > $o ).

tff(pred_def_69609,type,
    v119985: state_type > $o ).

tff(pred_def_69610,type,
    v119992: state_type > $o ).

tff(pred_def_69611,type,
    v119991: state_type > $o ).

tff(pred_def_69612,type,
    v119993: state_type > $o ).

tff(pred_def_69613,type,
    v119990: state_type > $o ).

tff(pred_def_69614,type,
    v119571: ( state_type * $int ) > $o ).

tff(pred_def_69615,type,
    v119569: ( state_type * $int ) > $o ).

tff(pred_def_69616,type,
    v119567: ( state_type * $int ) > $o ).

tff(pred_def_69617,type,
    v119565: ( state_type * $int ) > $o ).

tff(pred_def_69618,type,
    v119999: state_type > $o ).

tff(pred_def_69619,type,
    v119997: state_type > $o ).

tff(pred_def_69620,type,
    v119995: state_type > $o ).

tff(pred_def_69621,type,
    v120006: state_type > $o ).

tff(pred_def_69622,type,
    v120004: state_type > $o ).

tff(pred_def_69623,type,
    v120003: state_type > $o ).

tff(pred_def_69624,type,
    v120002: state_type > $o ).

tff(pred_def_69625,type,
    v120014: state_type > $o ).

tff(pred_def_69626,type,
    v120015: state_type > $o ).

tff(pred_def_69627,type,
    v120013: state_type > $o ).

tff(pred_def_69628,type,
    v120010: ( state_type * $int ) > $o ).

tff(pred_def_69629,type,
    v120012: ( state_type * $int ) > $o ).

tff(pred_def_69630,type,
    v119555: ( state_type * $int ) > $o ).

tff(pred_def_69631,type,
    v119553: ( state_type * $int ) > $o ).

tff(pred_def_69632,type,
    v120019: state_type > $o ).

tff(pred_def_69633,type,
    v120021: state_type > $o ).

tff(pred_def_69634,type,
    v120022: state_type > $o ).

tff(pred_def_69635,type,
    v119549: state_type > $o ).

tff(pred_def_69636,type,
    v120024: state_type > $o ).

tff(pred_def_69637,type,
    v120026: state_type > $o ).

tff(pred_def_69638,type,
    v120032: state_type > $o ).

tff(pred_def_69639,type,
    v120034: state_type > $o ).

tff(pred_def_69640,type,
    v120044: state_type > $o ).

tff(pred_def_69641,type,
    v120045: state_type > $o ).

tff(pred_def_69642,type,
    v120043: state_type > $o ).

tff(pred_def_69643,type,
    v120047: state_type > $o ).

tff(pred_def_69644,type,
    v120048: state_type > $o ).

tff(pred_def_69645,type,
    v120046: state_type > $o ).

tff(pred_def_69646,type,
    v120042: state_type > $o ).

tff(pred_def_69647,type,
    v120041: state_type > $o ).

tff(pred_def_69648,type,
    v120040: state_type > $o ).

tff(pred_def_69649,type,
    v120039: state_type > $o ).

tff(pred_def_69650,type,
    v119519: ( state_type * $int ) > $o ).

tff(pred_def_69651,type,
    v120049: state_type > $o ).

tff(pred_def_69652,type,
    v120038: state_type > $o ).

tff(pred_def_69653,type,
    v120051: state_type > $o ).

tff(pred_def_69654,type,
    v120050: state_type > $o ).

tff(pred_def_69655,type,
    v120037: state_type > $o ).

tff(pred_def_69656,type,
    v120053: state_type > $o ).

tff(pred_def_69657,type,
    v120059: state_type > $o ).

tff(pred_def_69658,type,
    v120060: state_type > $o ).

tff(pred_def_69659,type,
    v120058: state_type > $o ).

tff(pred_def_69660,type,
    v120057: state_type > $o ).

tff(pred_def_69661,type,
    v120063: state_type > $o ).

tff(pred_def_69662,type,
    v120062: state_type > $o ).

tff(pred_def_69663,type,
    v120061: state_type > $o ).

tff(pred_def_69664,type,
    v120056: state_type > $o ).

tff(pred_def_69665,type,
    v120064: state_type > $o ).

tff(pred_def_69666,type,
    v120055: state_type > $o ).

tff(pred_def_69667,type,
    v120065: state_type > $o ).

tff(pred_def_69668,type,
    v120054: state_type > $o ).

tff(pred_def_69669,type,
    v120052: state_type > $o ).

tff(pred_def_69670,type,
    v120036: state_type > $o ).

tff(pred_def_69671,type,
    v119547: ( state_type * $int ) > $o ).

tff(pred_def_69672,type,
    v120066: ( state_type * $int ) > $o ).

tff(pred_def_69673,type,
    v120030: state_type > $o ).

tff(pred_def_69674,type,
    v119545: ( state_type * $int ) > $o ).

tff(pred_def_69675,type,
    v119543: ( state_type * $int ) > $o ).

tff(pred_def_69676,type,
    v119541: ( state_type * $int ) > $o ).

tff(pred_def_69677,type,
    v120070: state_type > $o ).

tff(pred_def_69678,type,
    v120068: state_type > $o ).

tff(pred_def_69679,type,
    v120077: state_type > $o ).

tff(pred_def_69680,type,
    v120075: state_type > $o ).

tff(pred_def_69681,type,
    v120074: state_type > $o ).

tff(pred_def_69682,type,
    v120073: state_type > $o ).

tff(pred_def_69683,type,
    v120085: state_type > $o ).

tff(pred_def_69684,type,
    v120086: state_type > $o ).

tff(pred_def_69685,type,
    v120084: state_type > $o ).

tff(pred_def_69686,type,
    v120081: ( state_type * $int ) > $o ).

tff(pred_def_69687,type,
    v120083: ( state_type * $int ) > $o ).

tff(pred_def_69688,type,
    v120072: ( state_type * $int ) > $o ).

tff(pred_def_69689,type,
    v119523: ( state_type * $int ) > $o ).

tff(pred_def_69690,type,
    v119521: ( state_type * $int ) > $o ).

tff(pred_def_69691,type,
    v120090: state_type > $o ).

tff(pred_def_69692,type,
    v120096: state_type > $o ).

tff(pred_def_69693,type,
    v120095: state_type > $o ).

tff(pred_def_69694,type,
    v120094: state_type > $o ).

tff(pred_def_69695,type,
    v120098: state_type > $o ).

tff(pred_def_69696,type,
    v120097: state_type > $o ).

tff(pred_def_69697,type,
    v120093: state_type > $o ).

tff(pred_def_69698,type,
    v120100: state_type > $o ).

tff(pred_def_69699,type,
    v120106: state_type > $o ).

tff(pred_def_69700,type,
    v120105: state_type > $o ).

tff(pred_def_69701,type,
    v120104: state_type > $o ).

tff(pred_def_69702,type,
    v120103: state_type > $o ).

tff(pred_def_69703,type,
    v120107: state_type > $o ).

tff(pred_def_69704,type,
    v120102: state_type > $o ).

tff(pred_def_69705,type,
    v120108: state_type > $o ).

tff(pred_def_69706,type,
    v120101: state_type > $o ).

tff(pred_def_69707,type,
    v120099: state_type > $o ).

tff(pred_def_69708,type,
    v120092: state_type > $o ).

tff(pred_def_69709,type,
    v120114: state_type > $o ).

tff(pred_def_69710,type,
    v120112: state_type > $o ).

tff(pred_def_69711,type,
    v120111: state_type > $o ).

tff(pred_def_69712,type,
    v120110: ( state_type * $int ) > $o ).

tff(pred_def_69713,type,
    v120124: state_type > $o ).

tff(pred_def_69714,type,
    v120123: state_type > $o ).

tff(pred_def_69715,type,
    v120122: state_type > $o ).

tff(pred_def_69716,type,
    v120121: state_type > $o ).

tff(pred_def_69717,type,
    v120126: state_type > $o ).

tff(pred_def_69718,type,
    v120127: state_type > $o ).

tff(pred_def_69719,type,
    v120125: state_type > $o ).

tff(pred_def_69720,type,
    v120120: state_type > $o ).

tff(pred_def_69721,type,
    v120130: state_type > $o ).

tff(pred_def_69722,type,
    v120129: state_type > $o ).

tff(pred_def_69723,type,
    v120131: state_type > $o ).

tff(pred_def_69724,type,
    v120128: state_type > $o ).

tff(pred_def_69725,type,
    v120119: state_type > $o ).

tff(pred_def_69726,type,
    v120135: state_type > $o ).

tff(pred_def_69727,type,
    v120134: state_type > $o ).

tff(pred_def_69728,type,
    v120133: state_type > $o ).

tff(pred_def_69729,type,
    v120136: state_type > $o ).

tff(pred_def_69730,type,
    v120132: state_type > $o ).

tff(pred_def_69731,type,
    v120118: state_type > $o ).

tff(pred_def_69732,type,
    v120143: state_type > $o ).

tff(pred_def_69733,type,
    v120141: state_type > $o ).

tff(pred_def_69734,type,
    v120140: state_type > $o ).

tff(pred_def_69735,type,
    v120139: ( state_type * $int ) > $o ).

tff(pred_def_69736,type,
    v120028: state_type > $o ).

tff(pred_def_69737,type,
    v120149: state_type > $o ).

tff(pred_def_69738,type,
    v120151: state_type > $o ).

tff(pred_def_69739,type,
    v120154: state_type > $o ).

tff(pred_def_69740,type,
    v120155: state_type > $o ).

tff(pred_def_69741,type,
    v120153: state_type > $o ).

tff(pred_def_69742,type,
    v120152: state_type > $o ).

tff(pred_def_69743,type,
    v120150: state_type > $o ).

tff(pred_def_69744,type,
    v120148: state_type > $o ).

tff(pred_def_69745,type,
    v120161: state_type > $o ).

tff(pred_def_69746,type,
    v120159: state_type > $o ).

tff(pred_def_69747,type,
    v120158: state_type > $o ).

tff(pred_def_69748,type,
    v120157: ( state_type * $int ) > $o ).

tff(pred_def_69749,type,
    v120175: state_type > $o ).

tff(pred_def_69750,type,
    v120173: state_type > $o ).

tff(pred_def_69751,type,
    v120179: state_type > $o ).

tff(pred_def_69752,type,
    v120177: state_type > $o ).

tff(pred_def_69753,type,
    v120191: state_type > $o ).

tff(pred_def_69754,type,
    v120192: state_type > $o ).

tff(pred_def_69755,type,
    v120189: state_type > $o ).

tff(pred_def_69756,type,
    v120167: ( state_type * $int ) > $o ).

tff(pred_def_69757,type,
    v120199: state_type > $o ).

tff(pred_def_69758,type,
    v120198: state_type > $o ).

tff(pred_def_69759,type,
    v120201: state_type > $o ).

tff(pred_def_69760,type,
    v120200: state_type > $o ).

tff(pred_def_69761,type,
    v120197: state_type > $o ).

tff(pred_def_69762,type,
    v120195: ( state_type * $int ) > $o ).

tff(pred_def_69763,type,
    v120165: state_type > $o ).

tff(pred_def_69764,type,
    v120194: ( state_type * $int ) > $o ).

tff(pred_def_69765,type,
    v120187: ( state_type * $int ) > $o ).

tff(pred_def_69766,type,
    v120185: ( state_type * $int ) > $o ).

tff(pred_def_69767,type,
    v120183: ( state_type * $int ) > $o ).

tff(pred_def_69768,type,
    v120181: ( state_type * $int ) > $o ).

tff(pred_def_69769,type,
    v120205: state_type > $o ).

tff(pred_def_69770,type,
    v120203: state_type > $o ).

tff(pred_def_69771,type,
    v120212: state_type > $o ).

tff(pred_def_69772,type,
    v120210: state_type > $o ).

tff(pred_def_69773,type,
    v120209: state_type > $o ).

tff(pred_def_69774,type,
    v120208: state_type > $o ).

tff(pred_def_69775,type,
    v120220: state_type > $o ).

tff(pred_def_69776,type,
    v120221: state_type > $o ).

tff(pred_def_69777,type,
    v120219: state_type > $o ).

tff(pred_def_69778,type,
    v120216: ( state_type * $int ) > $o ).

tff(pred_def_69779,type,
    v120218: ( state_type * $int ) > $o ).

tff(pred_def_69780,type,
    v120171: ( state_type * $int ) > $o ).

tff(pred_def_69781,type,
    v120169: ( state_type * $int ) > $o ).

tff(pred_def_69782,type,
    v120236: state_type > $o ).

tff(pred_def_69783,type,
    v120234: state_type > $o ).

tff(pred_def_69784,type,
    v120240: state_type > $o ).

tff(pred_def_69785,type,
    v120238: state_type > $o ).

tff(pred_def_69786,type,
    v120253: state_type > $o ).

tff(pred_def_69787,type,
    v120252: state_type > $o ).

tff(pred_def_69788,type,
    v120250: state_type > $o ).

tff(pred_def_69789,type,
    v120255: ( state_type * $int ) > $o ).

tff(pred_def_69790,type,
    v120257: state_type > $o ).

tff(pred_def_69791,type,
    v120260: ( state_type * $int ) > $o ).

tff(pred_def_69792,type,
    v120228: ( state_type * $int ) > $o ).

tff(pred_def_69793,type,
    v120275: state_type > $o ).

tff(pred_def_69794,type,
    v120274: state_type > $o ).

tff(pred_def_69795,type,
    v120273: state_type > $o ).

tff(pred_def_69796,type,
    v120276: state_type > $o ).

tff(pred_def_69797,type,
    v120272: state_type > $o ).

tff(pred_def_69798,type,
    v120271: state_type > $o ).

tff(pred_def_69799,type,
    v120277: state_type > $o ).

tff(pred_def_69800,type,
    v120270: state_type > $o ).

tff(pred_def_69801,type,
    v120269: state_type > $o ).

tff(pred_def_69802,type,
    v120268: state_type > $o ).

tff(pred_def_69803,type,
    v120267: state_type > $o ).

tff(pred_def_69804,type,
    v120279: state_type > $o ).

tff(pred_def_69805,type,
    v120278: state_type > $o ).

tff(pred_def_69806,type,
    v120266: state_type > $o ).

tff(pred_def_69807,type,
    v120282: state_type > $o ).

tff(pred_def_69808,type,
    v120281: state_type > $o ).

tff(pred_def_69809,type,
    v120283: state_type > $o ).

tff(pred_def_69810,type,
    v120280: state_type > $o ).

tff(pred_def_69811,type,
    v120286: state_type > $o ).

tff(pred_def_69812,type,
    v120285: state_type > $o ).

tff(pred_def_69813,type,
    v120287: state_type > $o ).

tff(pred_def_69814,type,
    v120284: state_type > $o ).

tff(pred_def_69815,type,
    v120290: state_type > $o ).

tff(pred_def_69816,type,
    v120289: state_type > $o ).

tff(pred_def_69817,type,
    v120291: state_type > $o ).

tff(pred_def_69818,type,
    v120288: state_type > $o ).

tff(pred_def_69819,type,
    v120264: ( state_type * $int ) > $o ).

tff(pred_def_69820,type,
    v120226: state_type > $o ).

tff(pred_def_69821,type,
    v120263: ( state_type * $int ) > $o ).

tff(pred_def_69822,type,
    v120262: ( state_type * $int ) > $o ).

tff(pred_def_69823,type,
    v120248: ( state_type * $int ) > $o ).

tff(pred_def_69824,type,
    v120246: ( state_type * $int ) > $o ).

tff(pred_def_69825,type,
    v120244: ( state_type * $int ) > $o ).

tff(pred_def_69826,type,
    v120242: ( state_type * $int ) > $o ).

tff(pred_def_69827,type,
    v120295: state_type > $o ).

tff(pred_def_69828,type,
    v120293: state_type > $o ).

tff(pred_def_69829,type,
    v120302: state_type > $o ).

tff(pred_def_69830,type,
    v120300: state_type > $o ).

tff(pred_def_69831,type,
    v120299: state_type > $o ).

tff(pred_def_69832,type,
    v120298: state_type > $o ).

tff(pred_def_69833,type,
    v120310: state_type > $o ).

tff(pred_def_69834,type,
    v120311: state_type > $o ).

tff(pred_def_69835,type,
    v120309: state_type > $o ).

tff(pred_def_69836,type,
    v120306: ( state_type * $int ) > $o ).

tff(pred_def_69837,type,
    v120308: ( state_type * $int ) > $o ).

tff(pred_def_69838,type,
    v120232: ( state_type * $int ) > $o ).

tff(pred_def_69839,type,
    v120230: ( state_type * $int ) > $o ).

tff(pred_def_69840,type,
    v120316: state_type > $o ).

tff(pred_def_69841,type,
    v119517: state_type > $o ).

tff(pred_def_69842,type,
    v120332: state_type > $o ).

tff(pred_def_69843,type,
    v120330: state_type > $o ).

tff(pred_def_69844,type,
    v120328: state_type > $o ).

tff(pred_def_69845,type,
    v120326: state_type > $o ).

tff(pred_def_69846,type,
    v120340: state_type > $o ).

tff(pred_def_69847,type,
    v120338: state_type > $o ).

tff(pred_def_69848,type,
    v120336: state_type > $o ).

tff(pred_def_69849,type,
    v120334: state_type > $o ).

tff(pred_def_69850,type,
    v120360: state_type > $o ).

tff(pred_def_69851,type,
    v120358: state_type > $o ).

tff(pred_def_69852,type,
    v120364: state_type > $o ).

tff(pred_def_69853,type,
    v120362: state_type > $o ).

tff(pred_def_69854,type,
    v120376: state_type > $o ).

tff(pred_def_69855,type,
    v120378: state_type > $o ).

tff(pred_def_69856,type,
    v120380: state_type > $o ).

tff(pred_def_69857,type,
    v120382: state_type > $o ).

tff(pred_def_69858,type,
    v120384: state_type > $o ).

tff(pred_def_69859,type,
    v120386: state_type > $o ).

tff(pred_def_69860,type,
    v120388: state_type > $o ).

tff(pred_def_69861,type,
    v120437: ( state_type * $int ) > $o ).

tff(pred_def_69862,type,
    v120438: ( state_type * $int ) > $o ).

tff(pred_def_69863,type,
    v120436: state_type > $o ).

tff(pred_def_69864,type,
    v120441: state_type > $o ).

tff(pred_def_69865,type,
    v120442: state_type > $o ).

tff(pred_def_69866,type,
    v120440: state_type > $o ).

tff(pred_def_69867,type,
    v120443: state_type > $o ).

tff(pred_def_69868,type,
    v120439: state_type > $o ).

tff(pred_def_69869,type,
    v120435: state_type > $o ).

tff(pred_def_69870,type,
    v120444: state_type > $o ).

tff(pred_def_69871,type,
    v120434: state_type > $o ).

tff(pred_def_69872,type,
    v120433: state_type > $o ).

tff(pred_def_69873,type,
    v120448: state_type > $o ).

tff(pred_def_69874,type,
    v120449: state_type > $o ).

tff(pred_def_69875,type,
    v120447: state_type > $o ).

tff(pred_def_69876,type,
    v120450: state_type > $o ).

tff(pred_def_69877,type,
    v120446: state_type > $o ).

tff(pred_def_69878,type,
    v120445: state_type > $o ).

tff(pred_def_69879,type,
    v120432: state_type > $o ).

tff(pred_def_69880,type,
    v120451: state_type > $o ).

tff(pred_def_69881,type,
    v120431: state_type > $o ).

tff(pred_def_69882,type,
    v120454: state_type > $o ).

tff(pred_def_69883,type,
    v120455: state_type > $o ).

tff(pred_def_69884,type,
    v120453: state_type > $o ).

tff(pred_def_69885,type,
    v120456: state_type > $o ).

tff(pred_def_69886,type,
    v120452: state_type > $o ).

tff(pred_def_69887,type,
    v120459: state_type > $o ).

tff(pred_def_69888,type,
    v120460: state_type > $o ).

tff(pred_def_69889,type,
    v120458: state_type > $o ).

tff(pred_def_69890,type,
    v120461: state_type > $o ).

tff(pred_def_69891,type,
    v120457: state_type > $o ).

tff(pred_def_69892,type,
    v120429: ( state_type * $int ) > $o ).

tff(pred_def_69893,type,
    v120462: ( state_type * $int ) > $o ).

tff(pred_def_69894,type,
    v120428: state_type > $o ).

tff(pred_def_69895,type,
    v120465: state_type > $o ).

tff(pred_def_69896,type,
    v120466: state_type > $o ).

tff(pred_def_69897,type,
    v120464: state_type > $o ).

tff(pred_def_69898,type,
    v120467: state_type > $o ).

tff(pred_def_69899,type,
    v120463: state_type > $o ).

tff(pred_def_69900,type,
    v120427: state_type > $o ).

tff(pred_def_69901,type,
    v120468: state_type > $o ).

tff(pred_def_69902,type,
    v120426: state_type > $o ).

tff(pred_def_69903,type,
    v120425: state_type > $o ).

tff(pred_def_69904,type,
    v120472: state_type > $o ).

tff(pred_def_69905,type,
    v120473: state_type > $o ).

tff(pred_def_69906,type,
    v120471: state_type > $o ).

tff(pred_def_69907,type,
    v120474: state_type > $o ).

tff(pred_def_69908,type,
    v120470: state_type > $o ).

tff(pred_def_69909,type,
    v120469: state_type > $o ).

tff(pred_def_69910,type,
    v120424: state_type > $o ).

tff(pred_def_69911,type,
    v120475: state_type > $o ).

tff(pred_def_69912,type,
    v120423: state_type > $o ).

tff(pred_def_69913,type,
    v120478: state_type > $o ).

tff(pred_def_69914,type,
    v120479: state_type > $o ).

tff(pred_def_69915,type,
    v120477: state_type > $o ).

tff(pred_def_69916,type,
    v120480: state_type > $o ).

tff(pred_def_69917,type,
    v120476: state_type > $o ).

tff(pred_def_69918,type,
    v120483: state_type > $o ).

tff(pred_def_69919,type,
    v120484: state_type > $o ).

tff(pred_def_69920,type,
    v120482: state_type > $o ).

tff(pred_def_69921,type,
    v120485: state_type > $o ).

tff(pred_def_69922,type,
    v120481: state_type > $o ).

tff(pred_def_69923,type,
    v120421: ( state_type * $int ) > $o ).

tff(pred_def_69924,type,
    v120486: ( state_type * $int ) > $o ).

tff(pred_def_69925,type,
    v120420: state_type > $o ).

tff(pred_def_69926,type,
    v120489: state_type > $o ).

tff(pred_def_69927,type,
    v120490: state_type > $o ).

tff(pred_def_69928,type,
    v120488: state_type > $o ).

tff(pred_def_69929,type,
    v120491: state_type > $o ).

tff(pred_def_69930,type,
    v120487: state_type > $o ).

tff(pred_def_69931,type,
    v120419: state_type > $o ).

tff(pred_def_69932,type,
    v120492: state_type > $o ).

tff(pred_def_69933,type,
    v120418: state_type > $o ).

tff(pred_def_69934,type,
    v120417: state_type > $o ).

tff(pred_def_69935,type,
    v120496: state_type > $o ).

tff(pred_def_69936,type,
    v120497: state_type > $o ).

tff(pred_def_69937,type,
    v120495: state_type > $o ).

tff(pred_def_69938,type,
    v120498: state_type > $o ).

tff(pred_def_69939,type,
    v120494: state_type > $o ).

tff(pred_def_69940,type,
    v120493: state_type > $o ).

tff(pred_def_69941,type,
    v120416: state_type > $o ).

tff(pred_def_69942,type,
    v120499: state_type > $o ).

tff(pred_def_69943,type,
    v120415: state_type > $o ).

tff(pred_def_69944,type,
    v120502: state_type > $o ).

tff(pred_def_69945,type,
    v120503: state_type > $o ).

tff(pred_def_69946,type,
    v120501: state_type > $o ).

tff(pred_def_69947,type,
    v120504: state_type > $o ).

tff(pred_def_69948,type,
    v120500: state_type > $o ).

tff(pred_def_69949,type,
    v120507: state_type > $o ).

tff(pred_def_69950,type,
    v120508: state_type > $o ).

tff(pred_def_69951,type,
    v120506: state_type > $o ).

tff(pred_def_69952,type,
    v120509: state_type > $o ).

tff(pred_def_69953,type,
    v120505: state_type > $o ).

tff(pred_def_69954,type,
    v120413: ( state_type * $int ) > $o ).

tff(pred_def_69955,type,
    v120510: ( state_type * $int ) > $o ).

tff(pred_def_69956,type,
    v120412: state_type > $o ).

tff(pred_def_69957,type,
    v120513: state_type > $o ).

tff(pred_def_69958,type,
    v120514: state_type > $o ).

tff(pred_def_69959,type,
    v120512: state_type > $o ).

tff(pred_def_69960,type,
    v120515: state_type > $o ).

tff(pred_def_69961,type,
    v120511: state_type > $o ).

tff(pred_def_69962,type,
    v120411: state_type > $o ).

tff(pred_def_69963,type,
    v120516: state_type > $o ).

tff(pred_def_69964,type,
    v120410: state_type > $o ).

tff(pred_def_69965,type,
    v120409: state_type > $o ).

tff(pred_def_69966,type,
    v120520: state_type > $o ).

tff(pred_def_69967,type,
    v120521: state_type > $o ).

tff(pred_def_69968,type,
    v120519: state_type > $o ).

tff(pred_def_69969,type,
    v120522: state_type > $o ).

tff(pred_def_69970,type,
    v120518: state_type > $o ).

tff(pred_def_69971,type,
    v120517: state_type > $o ).

tff(pred_def_69972,type,
    v120408: state_type > $o ).

tff(pred_def_69973,type,
    v120523: state_type > $o ).

tff(pred_def_69974,type,
    v120407: state_type > $o ).

tff(pred_def_69975,type,
    v120526: state_type > $o ).

tff(pred_def_69976,type,
    v120527: state_type > $o ).

tff(pred_def_69977,type,
    v120525: state_type > $o ).

tff(pred_def_69978,type,
    v120528: state_type > $o ).

tff(pred_def_69979,type,
    v120524: state_type > $o ).

tff(pred_def_69980,type,
    v120531: state_type > $o ).

tff(pred_def_69981,type,
    v120532: state_type > $o ).

tff(pred_def_69982,type,
    v120530: state_type > $o ).

tff(pred_def_69983,type,
    v120533: state_type > $o ).

tff(pred_def_69984,type,
    v120529: state_type > $o ).

tff(pred_def_69985,type,
    v120405: ( state_type * $int ) > $o ).

tff(pred_def_69986,type,
    v120534: ( state_type * $int ) > $o ).

tff(pred_def_69987,type,
    v120404: state_type > $o ).

tff(pred_def_69988,type,
    v120537: state_type > $o ).

tff(pred_def_69989,type,
    v120538: state_type > $o ).

tff(pred_def_69990,type,
    v120536: state_type > $o ).

tff(pred_def_69991,type,
    v120539: state_type > $o ).

tff(pred_def_69992,type,
    v120535: state_type > $o ).

tff(pred_def_69993,type,
    v120403: state_type > $o ).

tff(pred_def_69994,type,
    v120540: state_type > $o ).

tff(pred_def_69995,type,
    v120402: state_type > $o ).

tff(pred_def_69996,type,
    v120401: state_type > $o ).

tff(pred_def_69997,type,
    v120544: state_type > $o ).

tff(pred_def_69998,type,
    v120545: state_type > $o ).

tff(pred_def_69999,type,
    v120543: state_type > $o ).

tff(pred_def_70000,type,
    v120546: state_type > $o ).

tff(pred_def_70001,type,
    v120542: state_type > $o ).

tff(pred_def_70002,type,
    v120541: state_type > $o ).

tff(pred_def_70003,type,
    v120400: state_type > $o ).

tff(pred_def_70004,type,
    v120547: state_type > $o ).

tff(pred_def_70005,type,
    v120399: state_type > $o ).

tff(pred_def_70006,type,
    v120550: state_type > $o ).

tff(pred_def_70007,type,
    v120551: state_type > $o ).

tff(pred_def_70008,type,
    v120549: state_type > $o ).

tff(pred_def_70009,type,
    v120552: state_type > $o ).

tff(pred_def_70010,type,
    v120548: state_type > $o ).

tff(pred_def_70011,type,
    v120555: state_type > $o ).

tff(pred_def_70012,type,
    v120556: state_type > $o ).

tff(pred_def_70013,type,
    v120554: state_type > $o ).

tff(pred_def_70014,type,
    v120557: state_type > $o ).

tff(pred_def_70015,type,
    v120553: state_type > $o ).

tff(pred_def_70016,type,
    v120397: ( state_type * $int ) > $o ).

tff(pred_def_70017,type,
    v120558: ( state_type * $int ) > $o ).

tff(pred_def_70018,type,
    v120396: state_type > $o ).

tff(pred_def_70019,type,
    v120561: state_type > $o ).

tff(pred_def_70020,type,
    v120562: state_type > $o ).

tff(pred_def_70021,type,
    v120560: state_type > $o ).

tff(pred_def_70022,type,
    v120563: state_type > $o ).

tff(pred_def_70023,type,
    v120559: state_type > $o ).

tff(pred_def_70024,type,
    v120395: state_type > $o ).

tff(pred_def_70025,type,
    v120564: state_type > $o ).

tff(pred_def_70026,type,
    v120394: state_type > $o ).

tff(pred_def_70027,type,
    v120393: state_type > $o ).

tff(pred_def_70028,type,
    v120568: state_type > $o ).

tff(pred_def_70029,type,
    v120569: state_type > $o ).

tff(pred_def_70030,type,
    v120567: state_type > $o ).

tff(pred_def_70031,type,
    v120570: state_type > $o ).

tff(pred_def_70032,type,
    v120566: state_type > $o ).

tff(pred_def_70033,type,
    v120565: state_type > $o ).

tff(pred_def_70034,type,
    v120392: state_type > $o ).

tff(pred_def_70035,type,
    v120571: state_type > $o ).

tff(pred_def_70036,type,
    v120391: state_type > $o ).

tff(pred_def_70037,type,
    v120574: state_type > $o ).

tff(pred_def_70038,type,
    v120575: state_type > $o ).

tff(pred_def_70039,type,
    v120573: state_type > $o ).

tff(pred_def_70040,type,
    v120576: state_type > $o ).

tff(pred_def_70041,type,
    v120572: state_type > $o ).

tff(pred_def_70042,type,
    v120579: state_type > $o ).

tff(pred_def_70043,type,
    v120580: state_type > $o ).

tff(pred_def_70044,type,
    v120578: state_type > $o ).

tff(pred_def_70045,type,
    v120581: state_type > $o ).

tff(pred_def_70046,type,
    v120577: state_type > $o ).

tff(pred_def_70047,type,
    v120389: ( state_type * $int ) > $o ).

tff(pred_def_70048,type,
    v120374: ( state_type * $int ) > $o ).

tff(pred_def_70049,type,
    v120591: state_type > $o ).

tff(pred_def_70050,type,
    v120589: state_type > $o ).

tff(pred_def_70051,type,
    v120588: state_type > $o ).

tff(pred_def_70052,type,
    v120587: ( state_type * $int ) > $o ).

tff(pred_def_70053,type,
    v120585: state_type > $o ).

tff(pred_def_70054,type,
    v120601: state_type > $o ).

tff(pred_def_70055,type,
    v120599: state_type > $o ).

tff(pred_def_70056,type,
    v120598: state_type > $o ).

tff(pred_def_70057,type,
    v120597: ( state_type * $int ) > $o ).

tff(pred_def_70058,type,
    v120595: state_type > $o ).

tff(pred_def_70059,type,
    v120611: state_type > $o ).

tff(pred_def_70060,type,
    v120609: state_type > $o ).

tff(pred_def_70061,type,
    v120608: state_type > $o ).

tff(pred_def_70062,type,
    v120607: ( state_type * $int ) > $o ).

tff(pred_def_70063,type,
    v120605: state_type > $o ).

tff(pred_def_70064,type,
    v120615: state_type > $o ).

tff(pred_def_70065,type,
    v120617: state_type > $o ).

tff(pred_def_70066,type,
    v120619: state_type > $o ).

tff(pred_def_70067,type,
    v120625: state_type > $o ).

tff(pred_def_70068,type,
    v120624: state_type > $o ).

tff(pred_def_70069,type,
    v120623: state_type > $o ).

tff(pred_def_70070,type,
    v120622: state_type > $o ).

tff(pred_def_70071,type,
    v120621: state_type > $o ).

tff(pred_def_70072,type,
    v120620: ( state_type * $int ) > $o ).

tff(pred_def_70073,type,
    v120583: ( state_type * $int ) > $o ).

tff(pred_def_70074,type,
    v120654: ( state_type * $int ) > $o ).

tff(pred_def_70075,type,
    v120352: ( state_type * $int ) > $o ).

tff(pred_def_70076,type,
    v120653: state_type > $o ).

tff(pred_def_70077,type,
    v120657: state_type > $o ).

tff(pred_def_70078,type,
    v120658: state_type > $o ).

tff(pred_def_70079,type,
    v120656: state_type > $o ).

tff(pred_def_70080,type,
    v120659: state_type > $o ).

tff(pred_def_70081,type,
    v120655: state_type > $o ).

tff(pred_def_70082,type,
    v120652: state_type > $o ).

tff(pred_def_70083,type,
    v120660: state_type > $o ).

tff(pred_def_70084,type,
    v120651: state_type > $o ).

tff(pred_def_70085,type,
    v120663: state_type > $o ).

tff(pred_def_70086,type,
    v120664: state_type > $o ).

tff(pred_def_70087,type,
    v120662: state_type > $o ).

tff(pred_def_70088,type,
    v120665: state_type > $o ).

tff(pred_def_70089,type,
    v120661: state_type > $o ).

tff(pred_def_70090,type,
    v120650: state_type > $o ).

tff(pred_def_70091,type,
    v120666: state_type > $o ).

tff(pred_def_70092,type,
    v120649: state_type > $o ).

tff(pred_def_70093,type,
    v120669: state_type > $o ).

tff(pred_def_70094,type,
    v120670: state_type > $o ).

tff(pred_def_70095,type,
    v120668: state_type > $o ).

tff(pred_def_70096,type,
    v120671: state_type > $o ).

tff(pred_def_70097,type,
    v120667: state_type > $o ).

tff(pred_def_70098,type,
    v120648: state_type > $o ).

tff(pred_def_70099,type,
    v120672: state_type > $o ).

tff(pred_def_70100,type,
    v120647: state_type > $o ).

tff(pred_def_70101,type,
    v120675: state_type > $o ).

tff(pred_def_70102,type,
    v120676: state_type > $o ).

tff(pred_def_70103,type,
    v120674: state_type > $o ).

tff(pred_def_70104,type,
    v120677: state_type > $o ).

tff(pred_def_70105,type,
    v120673: state_type > $o ).

tff(pred_def_70106,type,
    v120646: state_type > $o ).

tff(pred_def_70107,type,
    v120678: state_type > $o ).

tff(pred_def_70108,type,
    v120645: state_type > $o ).

tff(pred_def_70109,type,
    v120644: state_type > $o ).

tff(pred_def_70110,type,
    v120682: state_type > $o ).

tff(pred_def_70111,type,
    v120683: state_type > $o ).

tff(pred_def_70112,type,
    v120681: state_type > $o ).

tff(pred_def_70113,type,
    v120684: state_type > $o ).

tff(pred_def_70114,type,
    v120680: state_type > $o ).

tff(pred_def_70115,type,
    v120679: state_type > $o ).

tff(pred_def_70116,type,
    v120643: state_type > $o ).

tff(pred_def_70117,type,
    v120685: state_type > $o ).

tff(pred_def_70118,type,
    v120642: state_type > $o ).

tff(pred_def_70119,type,
    v120688: state_type > $o ).

tff(pred_def_70120,type,
    v120689: state_type > $o ).

tff(pred_def_70121,type,
    v120687: state_type > $o ).

tff(pred_def_70122,type,
    v120690: state_type > $o ).

tff(pred_def_70123,type,
    v120686: state_type > $o ).

tff(pred_def_70124,type,
    v120693: state_type > $o ).

tff(pred_def_70125,type,
    v120694: state_type > $o ).

tff(pred_def_70126,type,
    v120692: state_type > $o ).

tff(pred_def_70127,type,
    v120695: state_type > $o ).

tff(pred_def_70128,type,
    v120691: state_type > $o ).

tff(pred_def_70129,type,
    v120698: state_type > $o ).

tff(pred_def_70130,type,
    v120699: state_type > $o ).

tff(pred_def_70131,type,
    v120697: state_type > $o ).

tff(pred_def_70132,type,
    v120700: state_type > $o ).

tff(pred_def_70133,type,
    v120696: state_type > $o ).

tff(pred_def_70134,type,
    v120703: state_type > $o ).

tff(pred_def_70135,type,
    v120704: state_type > $o ).

tff(pred_def_70136,type,
    v120702: state_type > $o ).

tff(pred_def_70137,type,
    v120705: state_type > $o ).

tff(pred_def_70138,type,
    v120701: state_type > $o ).

tff(pred_def_70139,type,
    v120708: state_type > $o ).

tff(pred_def_70140,type,
    v120709: state_type > $o ).

tff(pred_def_70141,type,
    v120707: state_type > $o ).

tff(pred_def_70142,type,
    v120710: state_type > $o ).

tff(pred_def_70143,type,
    v120706: state_type > $o ).

tff(pred_def_70144,type,
    v120640: ( state_type * $int ) > $o ).

tff(pred_def_70145,type,
    v120639: state_type > $o ).

tff(pred_def_70146,type,
    v120715: state_type > $o ).

tff(pred_def_70147,type,
    v120717: state_type > $o ).

tff(pred_def_70148,type,
    v120718: state_type > $o ).

tff(pred_def_70149,type,
    v120716: state_type > $o ).

tff(pred_def_70150,type,
    v120714: state_type > $o ).

tff(pred_def_70151,type,
    v120713: state_type > $o ).

tff(pred_def_70152,type,
    v120719: state_type > $o ).

tff(pred_def_70153,type,
    v120712: state_type > $o ).

tff(pred_def_70154,type,
    v120720: state_type > $o ).

tff(pred_def_70155,type,
    v120711: state_type > $o ).

tff(pred_def_70156,type,
    v120638: state_type > $o ).

tff(pred_def_70157,type,
    v120721: state_type > $o ).

tff(pred_def_70158,type,
    v120637: state_type > $o ).

tff(pred_def_70159,type,
    v120728: state_type > $o ).

tff(pred_def_70160,type,
    v120727: state_type > $o ).

tff(pred_def_70161,type,
    v120726: state_type > $o ).

tff(pred_def_70162,type,
    v120730: state_type > $o ).

tff(pred_def_70163,type,
    v120729: state_type > $o ).

tff(pred_def_70164,type,
    v120725: state_type > $o ).

tff(pred_def_70165,type,
    v120724: state_type > $o ).

tff(pred_def_70166,type,
    v120731: state_type > $o ).

tff(pred_def_70167,type,
    v120723: state_type > $o ).

tff(pred_def_70168,type,
    v120732: state_type > $o ).

tff(pred_def_70169,type,
    v120722: state_type > $o ).

tff(pred_def_70170,type,
    v120636: state_type > $o ).

tff(pred_def_70171,type,
    v120733: state_type > $o ).

tff(pred_def_70172,type,
    v120635: state_type > $o ).

tff(pred_def_70173,type,
    v120740: state_type > $o ).

tff(pred_def_70174,type,
    v120739: state_type > $o ).

tff(pred_def_70175,type,
    v120738: state_type > $o ).

tff(pred_def_70176,type,
    v120742: state_type > $o ).

tff(pred_def_70177,type,
    v120741: state_type > $o ).

tff(pred_def_70178,type,
    v120737: state_type > $o ).

tff(pred_def_70179,type,
    v120736: state_type > $o ).

tff(pred_def_70180,type,
    v120743: state_type > $o ).

tff(pred_def_70181,type,
    v120735: state_type > $o ).

tff(pred_def_70182,type,
    v120744: state_type > $o ).

tff(pred_def_70183,type,
    v120734: state_type > $o ).

tff(pred_def_70184,type,
    v120634: state_type > $o ).

tff(pred_def_70185,type,
    v120745: state_type > $o ).

tff(pred_def_70186,type,
    v120633: state_type > $o ).

tff(pred_def_70187,type,
    v120752: state_type > $o ).

tff(pred_def_70188,type,
    v120751: state_type > $o ).

tff(pred_def_70189,type,
    v120750: state_type > $o ).

tff(pred_def_70190,type,
    v120754: state_type > $o ).

tff(pred_def_70191,type,
    v120753: state_type > $o ).

tff(pred_def_70192,type,
    v120749: state_type > $o ).

tff(pred_def_70193,type,
    v120748: state_type > $o ).

tff(pred_def_70194,type,
    v120755: state_type > $o ).

tff(pred_def_70195,type,
    v120747: state_type > $o ).

tff(pred_def_70196,type,
    v120756: state_type > $o ).

tff(pred_def_70197,type,
    v120746: state_type > $o ).

tff(pred_def_70198,type,
    v120632: state_type > $o ).

tff(pred_def_70199,type,
    v120757: state_type > $o ).

tff(pred_def_70200,type,
    v120631: state_type > $o ).

tff(pred_def_70201,type,
    v120630: state_type > $o ).

tff(pred_def_70202,type,
    v120765: state_type > $o ).

tff(pred_def_70203,type,
    v120764: state_type > $o ).

tff(pred_def_70204,type,
    v120763: state_type > $o ).

tff(pred_def_70205,type,
    v120767: state_type > $o ).

tff(pred_def_70206,type,
    v120766: state_type > $o ).

tff(pred_def_70207,type,
    v120762: state_type > $o ).

tff(pred_def_70208,type,
    v120761: state_type > $o ).

tff(pred_def_70209,type,
    v120768: state_type > $o ).

tff(pred_def_70210,type,
    v120760: state_type > $o ).

tff(pred_def_70211,type,
    v120769: state_type > $o ).

tff(pred_def_70212,type,
    v120759: state_type > $o ).

tff(pred_def_70213,type,
    v120758: state_type > $o ).

tff(pred_def_70214,type,
    v120629: state_type > $o ).

tff(pred_def_70215,type,
    v120770: state_type > $o ).

tff(pred_def_70216,type,
    v120628: state_type > $o ).

tff(pred_def_70217,type,
    v120773: state_type > $o ).

tff(pred_def_70218,type,
    v120774: state_type > $o ).

tff(pred_def_70219,type,
    v120772: state_type > $o ).

tff(pred_def_70220,type,
    v120775: state_type > $o ).

tff(pred_def_70221,type,
    v120771: state_type > $o ).

tff(pred_def_70222,type,
    v120778: state_type > $o ).

tff(pred_def_70223,type,
    v120779: state_type > $o ).

tff(pred_def_70224,type,
    v120777: state_type > $o ).

tff(pred_def_70225,type,
    v120780: state_type > $o ).

tff(pred_def_70226,type,
    v120776: state_type > $o ).

tff(pred_def_70227,type,
    v120783: state_type > $o ).

tff(pred_def_70228,type,
    v120784: state_type > $o ).

tff(pred_def_70229,type,
    v120782: state_type > $o ).

tff(pred_def_70230,type,
    v120785: state_type > $o ).

tff(pred_def_70231,type,
    v120781: state_type > $o ).

tff(pred_def_70232,type,
    v120788: state_type > $o ).

tff(pred_def_70233,type,
    v120789: state_type > $o ).

tff(pred_def_70234,type,
    v120787: state_type > $o ).

tff(pred_def_70235,type,
    v120790: state_type > $o ).

tff(pred_def_70236,type,
    v120786: state_type > $o ).

tff(pred_def_70237,type,
    v120793: state_type > $o ).

tff(pred_def_70238,type,
    v120792: state_type > $o ).

tff(pred_def_70239,type,
    v120794: state_type > $o ).

tff(pred_def_70240,type,
    v120791: state_type > $o ).

tff(pred_def_70241,type,
    v120372: ( state_type * $int ) > $o ).

tff(pred_def_70242,type,
    v120370: ( state_type * $int ) > $o ).

tff(pred_def_70243,type,
    v120368: ( state_type * $int ) > $o ).

tff(pred_def_70244,type,
    v120366: ( state_type * $int ) > $o ).

tff(pred_def_70245,type,
    v120800: state_type > $o ).

tff(pred_def_70246,type,
    v120798: state_type > $o ).

tff(pred_def_70247,type,
    v120796: state_type > $o ).

tff(pred_def_70248,type,
    v120807: state_type > $o ).

tff(pred_def_70249,type,
    v120805: state_type > $o ).

tff(pred_def_70250,type,
    v120804: state_type > $o ).

tff(pred_def_70251,type,
    v120803: state_type > $o ).

tff(pred_def_70252,type,
    v120815: state_type > $o ).

tff(pred_def_70253,type,
    v120816: state_type > $o ).

tff(pred_def_70254,type,
    v120814: state_type > $o ).

tff(pred_def_70255,type,
    v120811: ( state_type * $int ) > $o ).

tff(pred_def_70256,type,
    v120813: ( state_type * $int ) > $o ).

tff(pred_def_70257,type,
    v120356: ( state_type * $int ) > $o ).

tff(pred_def_70258,type,
    v120354: ( state_type * $int ) > $o ).

tff(pred_def_70259,type,
    v120820: state_type > $o ).

tff(pred_def_70260,type,
    v120822: state_type > $o ).

tff(pred_def_70261,type,
    v120823: state_type > $o ).

tff(pred_def_70262,type,
    v120350: state_type > $o ).

tff(pred_def_70263,type,
    v120825: state_type > $o ).

tff(pred_def_70264,type,
    v120828: ( state_type * $int ) > $o ).

tff(pred_def_70265,type,
    v120827: state_type > $o ).

tff(pred_def_70266,type,
    v120834: state_type > $o ).

tff(pred_def_70267,type,
    v120836: state_type > $o ).

tff(pred_def_70268,type,
    v120846: state_type > $o ).

tff(pred_def_70269,type,
    v120847: state_type > $o ).

tff(pred_def_70270,type,
    v120845: state_type > $o ).

tff(pred_def_70271,type,
    v120849: state_type > $o ).

tff(pred_def_70272,type,
    v120850: state_type > $o ).

tff(pred_def_70273,type,
    v120848: state_type > $o ).

tff(pred_def_70274,type,
    v120844: state_type > $o ).

tff(pred_def_70275,type,
    v120843: state_type > $o ).

tff(pred_def_70276,type,
    v120842: state_type > $o ).

tff(pred_def_70277,type,
    v120841: state_type > $o ).

tff(pred_def_70278,type,
    v120320: ( state_type * $int ) > $o ).

tff(pred_def_70279,type,
    v120851: state_type > $o ).

tff(pred_def_70280,type,
    v120840: state_type > $o ).

tff(pred_def_70281,type,
    v120853: state_type > $o ).

tff(pred_def_70282,type,
    v120852: state_type > $o ).

tff(pred_def_70283,type,
    v120839: state_type > $o ).

tff(pred_def_70284,type,
    v120855: state_type > $o ).

tff(pred_def_70285,type,
    v120861: state_type > $o ).

tff(pred_def_70286,type,
    v120862: state_type > $o ).

tff(pred_def_70287,type,
    v120860: state_type > $o ).

tff(pred_def_70288,type,
    v120859: state_type > $o ).

tff(pred_def_70289,type,
    v120865: state_type > $o ).

tff(pred_def_70290,type,
    v120864: state_type > $o ).

tff(pred_def_70291,type,
    v120863: state_type > $o ).

tff(pred_def_70292,type,
    v120858: state_type > $o ).

tff(pred_def_70293,type,
    v120866: state_type > $o ).

tff(pred_def_70294,type,
    v120857: state_type > $o ).

tff(pred_def_70295,type,
    v120867: state_type > $o ).

tff(pred_def_70296,type,
    v120856: state_type > $o ).

tff(pred_def_70297,type,
    v120854: state_type > $o ).

tff(pred_def_70298,type,
    v120838: state_type > $o ).

tff(pred_def_70299,type,
    v120348: ( state_type * $int ) > $o ).

tff(pred_def_70300,type,
    v120868: ( state_type * $int ) > $o ).

tff(pred_def_70301,type,
    v120832: state_type > $o ).

tff(pred_def_70302,type,
    v120346: ( state_type * $int ) > $o ).

tff(pred_def_70303,type,
    v120344: ( state_type * $int ) > $o ).

tff(pred_def_70304,type,
    v120342: ( state_type * $int ) > $o ).

tff(pred_def_70305,type,
    v120872: state_type > $o ).

tff(pred_def_70306,type,
    v120870: state_type > $o ).

tff(pred_def_70307,type,
    v120879: state_type > $o ).

tff(pred_def_70308,type,
    v120877: state_type > $o ).

tff(pred_def_70309,type,
    v120876: state_type > $o ).

tff(pred_def_70310,type,
    v120875: state_type > $o ).

tff(pred_def_70311,type,
    v120887: state_type > $o ).

tff(pred_def_70312,type,
    v120888: state_type > $o ).

tff(pred_def_70313,type,
    v120886: state_type > $o ).

tff(pred_def_70314,type,
    v120883: ( state_type * $int ) > $o ).

tff(pred_def_70315,type,
    v120885: ( state_type * $int ) > $o ).

tff(pred_def_70316,type,
    v120874: ( state_type * $int ) > $o ).

tff(pred_def_70317,type,
    v120324: ( state_type * $int ) > $o ).

tff(pred_def_70318,type,
    v120322: ( state_type * $int ) > $o ).

tff(pred_def_70319,type,
    v120892: state_type > $o ).

tff(pred_def_70320,type,
    v120898: state_type > $o ).

tff(pred_def_70321,type,
    v120897: state_type > $o ).

tff(pred_def_70322,type,
    v120896: state_type > $o ).

tff(pred_def_70323,type,
    v120900: state_type > $o ).

tff(pred_def_70324,type,
    v120899: state_type > $o ).

tff(pred_def_70325,type,
    v120895: state_type > $o ).

tff(pred_def_70326,type,
    v120902: state_type > $o ).

tff(pred_def_70327,type,
    v120908: state_type > $o ).

tff(pred_def_70328,type,
    v120907: state_type > $o ).

tff(pred_def_70329,type,
    v120906: state_type > $o ).

tff(pred_def_70330,type,
    v120905: state_type > $o ).

tff(pred_def_70331,type,
    v120909: state_type > $o ).

tff(pred_def_70332,type,
    v120904: state_type > $o ).

tff(pred_def_70333,type,
    v120910: state_type > $o ).

tff(pred_def_70334,type,
    v120903: state_type > $o ).

tff(pred_def_70335,type,
    v120901: state_type > $o ).

tff(pred_def_70336,type,
    v120894: state_type > $o ).

tff(pred_def_70337,type,
    v120916: state_type > $o ).

tff(pred_def_70338,type,
    v120914: state_type > $o ).

tff(pred_def_70339,type,
    v120913: state_type > $o ).

tff(pred_def_70340,type,
    v120912: ( state_type * $int ) > $o ).

tff(pred_def_70341,type,
    v120926: state_type > $o ).

tff(pred_def_70342,type,
    v120925: state_type > $o ).

tff(pred_def_70343,type,
    v120924: state_type > $o ).

tff(pred_def_70344,type,
    v120923: state_type > $o ).

tff(pred_def_70345,type,
    v120928: state_type > $o ).

tff(pred_def_70346,type,
    v120929: state_type > $o ).

tff(pred_def_70347,type,
    v120927: state_type > $o ).

tff(pred_def_70348,type,
    v120922: state_type > $o ).

tff(pred_def_70349,type,
    v120932: state_type > $o ).

tff(pred_def_70350,type,
    v120931: state_type > $o ).

tff(pred_def_70351,type,
    v120933: state_type > $o ).

tff(pred_def_70352,type,
    v120930: state_type > $o ).

tff(pred_def_70353,type,
    v120921: state_type > $o ).

tff(pred_def_70354,type,
    v120937: state_type > $o ).

tff(pred_def_70355,type,
    v120936: state_type > $o ).

tff(pred_def_70356,type,
    v120935: state_type > $o ).

tff(pred_def_70357,type,
    v120938: state_type > $o ).

tff(pred_def_70358,type,
    v120934: state_type > $o ).

tff(pred_def_70359,type,
    v120920: state_type > $o ).

tff(pred_def_70360,type,
    v120945: state_type > $o ).

tff(pred_def_70361,type,
    v120943: state_type > $o ).

tff(pred_def_70362,type,
    v120942: state_type > $o ).

tff(pred_def_70363,type,
    v120941: ( state_type * $int ) > $o ).

tff(pred_def_70364,type,
    v120830: state_type > $o ).

tff(pred_def_70365,type,
    v120951: state_type > $o ).

tff(pred_def_70366,type,
    v120953: state_type > $o ).

tff(pred_def_70367,type,
    v120956: state_type > $o ).

tff(pred_def_70368,type,
    v120957: state_type > $o ).

tff(pred_def_70369,type,
    v120955: state_type > $o ).

tff(pred_def_70370,type,
    v120954: state_type > $o ).

tff(pred_def_70371,type,
    v120952: state_type > $o ).

tff(pred_def_70372,type,
    v120950: state_type > $o ).

tff(pred_def_70373,type,
    v120963: state_type > $o ).

tff(pred_def_70374,type,
    v120961: state_type > $o ).

tff(pred_def_70375,type,
    v120960: state_type > $o ).

tff(pred_def_70376,type,
    v120959: ( state_type * $int ) > $o ).

tff(pred_def_70377,type,
    v120977: state_type > $o ).

tff(pred_def_70378,type,
    v120975: state_type > $o ).

tff(pred_def_70379,type,
    v120981: state_type > $o ).

tff(pred_def_70380,type,
    v120979: state_type > $o ).

tff(pred_def_70381,type,
    v120993: state_type > $o ).

tff(pred_def_70382,type,
    v120994: state_type > $o ).

tff(pred_def_70383,type,
    v120991: state_type > $o ).

tff(pred_def_70384,type,
    v120969: ( state_type * $int ) > $o ).

tff(pred_def_70385,type,
    v121001: state_type > $o ).

tff(pred_def_70386,type,
    v121000: state_type > $o ).

tff(pred_def_70387,type,
    v121003: state_type > $o ).

tff(pred_def_70388,type,
    v121002: state_type > $o ).

tff(pred_def_70389,type,
    v120999: state_type > $o ).

tff(pred_def_70390,type,
    v120997: ( state_type * $int ) > $o ).

tff(pred_def_70391,type,
    v120967: state_type > $o ).

tff(pred_def_70392,type,
    v120996: ( state_type * $int ) > $o ).

tff(pred_def_70393,type,
    v120989: ( state_type * $int ) > $o ).

tff(pred_def_70394,type,
    v120987: ( state_type * $int ) > $o ).

tff(pred_def_70395,type,
    v120985: ( state_type * $int ) > $o ).

tff(pred_def_70396,type,
    v120983: ( state_type * $int ) > $o ).

tff(pred_def_70397,type,
    v121007: state_type > $o ).

tff(pred_def_70398,type,
    v121005: state_type > $o ).

tff(pred_def_70399,type,
    v121014: state_type > $o ).

tff(pred_def_70400,type,
    v121012: state_type > $o ).

tff(pred_def_70401,type,
    v121011: state_type > $o ).

tff(pred_def_70402,type,
    v121010: state_type > $o ).

tff(pred_def_70403,type,
    v121022: state_type > $o ).

tff(pred_def_70404,type,
    v121023: state_type > $o ).

tff(pred_def_70405,type,
    v121021: state_type > $o ).

tff(pred_def_70406,type,
    v121018: ( state_type * $int ) > $o ).

tff(pred_def_70407,type,
    v121020: ( state_type * $int ) > $o ).

tff(pred_def_70408,type,
    v120973: ( state_type * $int ) > $o ).

tff(pred_def_70409,type,
    v120971: ( state_type * $int ) > $o ).

tff(pred_def_70410,type,
    v121038: state_type > $o ).

tff(pred_def_70411,type,
    v121036: state_type > $o ).

tff(pred_def_70412,type,
    v121042: state_type > $o ).

tff(pred_def_70413,type,
    v121040: state_type > $o ).

tff(pred_def_70414,type,
    v121055: state_type > $o ).

tff(pred_def_70415,type,
    v121054: state_type > $o ).

tff(pred_def_70416,type,
    v121052: state_type > $o ).

tff(pred_def_70417,type,
    v121057: ( state_type * $int ) > $o ).

tff(pred_def_70418,type,
    v121059: state_type > $o ).

tff(pred_def_70419,type,
    v121062: ( state_type * $int ) > $o ).

tff(pred_def_70420,type,
    v121030: ( state_type * $int ) > $o ).

tff(pred_def_70421,type,
    v121077: state_type > $o ).

tff(pred_def_70422,type,
    v121076: state_type > $o ).

tff(pred_def_70423,type,
    v121075: state_type > $o ).

tff(pred_def_70424,type,
    v121078: state_type > $o ).

tff(pred_def_70425,type,
    v121074: state_type > $o ).

tff(pred_def_70426,type,
    v121073: state_type > $o ).

tff(pred_def_70427,type,
    v121079: state_type > $o ).

tff(pred_def_70428,type,
    v121072: state_type > $o ).

tff(pred_def_70429,type,
    v121071: state_type > $o ).

tff(pred_def_70430,type,
    v121070: state_type > $o ).

tff(pred_def_70431,type,
    v121069: state_type > $o ).

tff(pred_def_70432,type,
    v121081: state_type > $o ).

tff(pred_def_70433,type,
    v121080: state_type > $o ).

tff(pred_def_70434,type,
    v121068: state_type > $o ).

tff(pred_def_70435,type,
    v121084: state_type > $o ).

tff(pred_def_70436,type,
    v121083: state_type > $o ).

tff(pred_def_70437,type,
    v121085: state_type > $o ).

tff(pred_def_70438,type,
    v121082: state_type > $o ).

tff(pred_def_70439,type,
    v121088: state_type > $o ).

tff(pred_def_70440,type,
    v121087: state_type > $o ).

tff(pred_def_70441,type,
    v121089: state_type > $o ).

tff(pred_def_70442,type,
    v121086: state_type > $o ).

tff(pred_def_70443,type,
    v121092: state_type > $o ).

tff(pred_def_70444,type,
    v121091: state_type > $o ).

tff(pred_def_70445,type,
    v121093: state_type > $o ).

tff(pred_def_70446,type,
    v121090: state_type > $o ).

tff(pred_def_70447,type,
    v121066: ( state_type * $int ) > $o ).

tff(pred_def_70448,type,
    v121028: state_type > $o ).

tff(pred_def_70449,type,
    v121065: ( state_type * $int ) > $o ).

tff(pred_def_70450,type,
    v121064: ( state_type * $int ) > $o ).

tff(pred_def_70451,type,
    v121050: ( state_type * $int ) > $o ).

tff(pred_def_70452,type,
    v121048: ( state_type * $int ) > $o ).

tff(pred_def_70453,type,
    v121046: ( state_type * $int ) > $o ).

tff(pred_def_70454,type,
    v121044: ( state_type * $int ) > $o ).

tff(pred_def_70455,type,
    v121097: state_type > $o ).

tff(pred_def_70456,type,
    v121095: state_type > $o ).

tff(pred_def_70457,type,
    v121104: state_type > $o ).

tff(pred_def_70458,type,
    v121102: state_type > $o ).

tff(pred_def_70459,type,
    v121101: state_type > $o ).

tff(pred_def_70460,type,
    v121100: state_type > $o ).

tff(pred_def_70461,type,
    v121112: state_type > $o ).

tff(pred_def_70462,type,
    v121113: state_type > $o ).

tff(pred_def_70463,type,
    v121111: state_type > $o ).

tff(pred_def_70464,type,
    v121108: ( state_type * $int ) > $o ).

tff(pred_def_70465,type,
    v121110: ( state_type * $int ) > $o ).

tff(pred_def_70466,type,
    v121034: ( state_type * $int ) > $o ).

tff(pred_def_70467,type,
    v121032: ( state_type * $int ) > $o ).

tff(pred_def_70468,type,
    v121118: state_type > $o ).

tff(pred_def_70469,type,
    v120318: state_type > $o ).

tff(pred_def_70470,type,
    v121134: state_type > $o ).

tff(pred_def_70471,type,
    v121132: state_type > $o ).

tff(pred_def_70472,type,
    v121130: state_type > $o ).

tff(pred_def_70473,type,
    v121128: state_type > $o ).

tff(pred_def_70474,type,
    v121142: state_type > $o ).

tff(pred_def_70475,type,
    v121140: state_type > $o ).

tff(pred_def_70476,type,
    v121138: state_type > $o ).

tff(pred_def_70477,type,
    v121136: state_type > $o ).

tff(pred_def_70478,type,
    v121162: state_type > $o ).

tff(pred_def_70479,type,
    v121160: state_type > $o ).

tff(pred_def_70480,type,
    v121166: state_type > $o ).

tff(pred_def_70481,type,
    v121164: state_type > $o ).

tff(pred_def_70482,type,
    v121178: state_type > $o ).

tff(pred_def_70483,type,
    v121180: state_type > $o ).

tff(pred_def_70484,type,
    v121182: state_type > $o ).

tff(pred_def_70485,type,
    v121184: state_type > $o ).

tff(pred_def_70486,type,
    v121186: state_type > $o ).

tff(pred_def_70487,type,
    v121188: state_type > $o ).

tff(pred_def_70488,type,
    v121190: state_type > $o ).

tff(pred_def_70489,type,
    v121239: ( state_type * $int ) > $o ).

tff(pred_def_70490,type,
    v121240: ( state_type * $int ) > $o ).

tff(pred_def_70491,type,
    v121238: state_type > $o ).

tff(pred_def_70492,type,
    v121243: state_type > $o ).

tff(pred_def_70493,type,
    v121244: state_type > $o ).

tff(pred_def_70494,type,
    v121242: state_type > $o ).

tff(pred_def_70495,type,
    v121245: state_type > $o ).

tff(pred_def_70496,type,
    v121241: state_type > $o ).

tff(pred_def_70497,type,
    v121237: state_type > $o ).

tff(pred_def_70498,type,
    v121246: state_type > $o ).

tff(pred_def_70499,type,
    v121236: state_type > $o ).

tff(pred_def_70500,type,
    v121235: state_type > $o ).

tff(pred_def_70501,type,
    v121250: state_type > $o ).

tff(pred_def_70502,type,
    v121251: state_type > $o ).

tff(pred_def_70503,type,
    v121249: state_type > $o ).

tff(pred_def_70504,type,
    v121252: state_type > $o ).

tff(pred_def_70505,type,
    v121248: state_type > $o ).

tff(pred_def_70506,type,
    v121247: state_type > $o ).

tff(pred_def_70507,type,
    v121234: state_type > $o ).

tff(pred_def_70508,type,
    v121253: state_type > $o ).

tff(pred_def_70509,type,
    v121233: state_type > $o ).

tff(pred_def_70510,type,
    v121256: state_type > $o ).

tff(pred_def_70511,type,
    v121257: state_type > $o ).

tff(pred_def_70512,type,
    v121255: state_type > $o ).

tff(pred_def_70513,type,
    v121258: state_type > $o ).

tff(pred_def_70514,type,
    v121254: state_type > $o ).

tff(pred_def_70515,type,
    v121261: state_type > $o ).

tff(pred_def_70516,type,
    v121262: state_type > $o ).

tff(pred_def_70517,type,
    v121260: state_type > $o ).

tff(pred_def_70518,type,
    v121263: state_type > $o ).

tff(pred_def_70519,type,
    v121259: state_type > $o ).

tff(pred_def_70520,type,
    v121231: ( state_type * $int ) > $o ).

tff(pred_def_70521,type,
    v121264: ( state_type * $int ) > $o ).

tff(pred_def_70522,type,
    v121230: state_type > $o ).

tff(pred_def_70523,type,
    v121267: state_type > $o ).

tff(pred_def_70524,type,
    v121268: state_type > $o ).

tff(pred_def_70525,type,
    v121266: state_type > $o ).

tff(pred_def_70526,type,
    v121269: state_type > $o ).

tff(pred_def_70527,type,
    v121265: state_type > $o ).

tff(pred_def_70528,type,
    v121229: state_type > $o ).

tff(pred_def_70529,type,
    v121270: state_type > $o ).

tff(pred_def_70530,type,
    v121228: state_type > $o ).

tff(pred_def_70531,type,
    v121227: state_type > $o ).

tff(pred_def_70532,type,
    v121274: state_type > $o ).

tff(pred_def_70533,type,
    v121275: state_type > $o ).

tff(pred_def_70534,type,
    v121273: state_type > $o ).

tff(pred_def_70535,type,
    v121276: state_type > $o ).

tff(pred_def_70536,type,
    v121272: state_type > $o ).

tff(pred_def_70537,type,
    v121271: state_type > $o ).

tff(pred_def_70538,type,
    v121226: state_type > $o ).

tff(pred_def_70539,type,
    v121277: state_type > $o ).

tff(pred_def_70540,type,
    v121225: state_type > $o ).

tff(pred_def_70541,type,
    v121280: state_type > $o ).

tff(pred_def_70542,type,
    v121281: state_type > $o ).

tff(pred_def_70543,type,
    v121279: state_type > $o ).

tff(pred_def_70544,type,
    v121282: state_type > $o ).

tff(pred_def_70545,type,
    v121278: state_type > $o ).

tff(pred_def_70546,type,
    v121285: state_type > $o ).

tff(pred_def_70547,type,
    v121286: state_type > $o ).

tff(pred_def_70548,type,
    v121284: state_type > $o ).

tff(pred_def_70549,type,
    v121287: state_type > $o ).

tff(pred_def_70550,type,
    v121283: state_type > $o ).

tff(pred_def_70551,type,
    v121223: ( state_type * $int ) > $o ).

tff(pred_def_70552,type,
    v121288: ( state_type * $int ) > $o ).

tff(pred_def_70553,type,
    v121222: state_type > $o ).

tff(pred_def_70554,type,
    v121291: state_type > $o ).

tff(pred_def_70555,type,
    v121292: state_type > $o ).

tff(pred_def_70556,type,
    v121290: state_type > $o ).

tff(pred_def_70557,type,
    v121293: state_type > $o ).

tff(pred_def_70558,type,
    v121289: state_type > $o ).

tff(pred_def_70559,type,
    v121221: state_type > $o ).

tff(pred_def_70560,type,
    v121294: state_type > $o ).

tff(pred_def_70561,type,
    v121220: state_type > $o ).

tff(pred_def_70562,type,
    v121219: state_type > $o ).

tff(pred_def_70563,type,
    v121298: state_type > $o ).

tff(pred_def_70564,type,
    v121299: state_type > $o ).

tff(pred_def_70565,type,
    v121297: state_type > $o ).

tff(pred_def_70566,type,
    v121300: state_type > $o ).

tff(pred_def_70567,type,
    v121296: state_type > $o ).

tff(pred_def_70568,type,
    v121295: state_type > $o ).

tff(pred_def_70569,type,
    v121218: state_type > $o ).

tff(pred_def_70570,type,
    v121301: state_type > $o ).

tff(pred_def_70571,type,
    v121217: state_type > $o ).

tff(pred_def_70572,type,
    v121304: state_type > $o ).

tff(pred_def_70573,type,
    v121305: state_type > $o ).

tff(pred_def_70574,type,
    v121303: state_type > $o ).

tff(pred_def_70575,type,
    v121306: state_type > $o ).

tff(pred_def_70576,type,
    v121302: state_type > $o ).

tff(pred_def_70577,type,
    v121309: state_type > $o ).

tff(pred_def_70578,type,
    v121310: state_type > $o ).

tff(pred_def_70579,type,
    v121308: state_type > $o ).

tff(pred_def_70580,type,
    v121311: state_type > $o ).

tff(pred_def_70581,type,
    v121307: state_type > $o ).

tff(pred_def_70582,type,
    v121215: ( state_type * $int ) > $o ).

tff(pred_def_70583,type,
    v121312: ( state_type * $int ) > $o ).

tff(pred_def_70584,type,
    v121214: state_type > $o ).

tff(pred_def_70585,type,
    v121315: state_type > $o ).

tff(pred_def_70586,type,
    v121316: state_type > $o ).

tff(pred_def_70587,type,
    v121314: state_type > $o ).

tff(pred_def_70588,type,
    v121317: state_type > $o ).

tff(pred_def_70589,type,
    v121313: state_type > $o ).

tff(pred_def_70590,type,
    v121213: state_type > $o ).

tff(pred_def_70591,type,
    v121318: state_type > $o ).

tff(pred_def_70592,type,
    v121212: state_type > $o ).

tff(pred_def_70593,type,
    v121211: state_type > $o ).

tff(pred_def_70594,type,
    v121322: state_type > $o ).

tff(pred_def_70595,type,
    v121323: state_type > $o ).

tff(pred_def_70596,type,
    v121321: state_type > $o ).

tff(pred_def_70597,type,
    v121324: state_type > $o ).

tff(pred_def_70598,type,
    v121320: state_type > $o ).

tff(pred_def_70599,type,
    v121319: state_type > $o ).

tff(pred_def_70600,type,
    v121210: state_type > $o ).

tff(pred_def_70601,type,
    v121325: state_type > $o ).

tff(pred_def_70602,type,
    v121209: state_type > $o ).

tff(pred_def_70603,type,
    v121328: state_type > $o ).

tff(pred_def_70604,type,
    v121329: state_type > $o ).

tff(pred_def_70605,type,
    v121327: state_type > $o ).

tff(pred_def_70606,type,
    v121330: state_type > $o ).

tff(pred_def_70607,type,
    v121326: state_type > $o ).

tff(pred_def_70608,type,
    v121333: state_type > $o ).

tff(pred_def_70609,type,
    v121334: state_type > $o ).

tff(pred_def_70610,type,
    v121332: state_type > $o ).

tff(pred_def_70611,type,
    v121335: state_type > $o ).

tff(pred_def_70612,type,
    v121331: state_type > $o ).

tff(pred_def_70613,type,
    v121207: ( state_type * $int ) > $o ).

tff(pred_def_70614,type,
    v121336: ( state_type * $int ) > $o ).

tff(pred_def_70615,type,
    v121206: state_type > $o ).

tff(pred_def_70616,type,
    v121339: state_type > $o ).

tff(pred_def_70617,type,
    v121340: state_type > $o ).

tff(pred_def_70618,type,
    v121338: state_type > $o ).

tff(pred_def_70619,type,
    v121341: state_type > $o ).

tff(pred_def_70620,type,
    v121337: state_type > $o ).

tff(pred_def_70621,type,
    v121205: state_type > $o ).

tff(pred_def_70622,type,
    v121342: state_type > $o ).

tff(pred_def_70623,type,
    v121204: state_type > $o ).

tff(pred_def_70624,type,
    v121203: state_type > $o ).

tff(pred_def_70625,type,
    v121346: state_type > $o ).

tff(pred_def_70626,type,
    v121347: state_type > $o ).

tff(pred_def_70627,type,
    v121345: state_type > $o ).

tff(pred_def_70628,type,
    v121348: state_type > $o ).

tff(pred_def_70629,type,
    v121344: state_type > $o ).

tff(pred_def_70630,type,
    v121343: state_type > $o ).

tff(pred_def_70631,type,
    v121202: state_type > $o ).

tff(pred_def_70632,type,
    v121349: state_type > $o ).

tff(pred_def_70633,type,
    v121201: state_type > $o ).

tff(pred_def_70634,type,
    v121352: state_type > $o ).

tff(pred_def_70635,type,
    v121353: state_type > $o ).

tff(pred_def_70636,type,
    v121351: state_type > $o ).

tff(pred_def_70637,type,
    v121354: state_type > $o ).

tff(pred_def_70638,type,
    v121350: state_type > $o ).

tff(pred_def_70639,type,
    v121357: state_type > $o ).

tff(pred_def_70640,type,
    v121358: state_type > $o ).

tff(pred_def_70641,type,
    v121356: state_type > $o ).

tff(pred_def_70642,type,
    v121359: state_type > $o ).

tff(pred_def_70643,type,
    v121355: state_type > $o ).

tff(pred_def_70644,type,
    v121199: ( state_type * $int ) > $o ).

tff(pred_def_70645,type,
    v121360: ( state_type * $int ) > $o ).

tff(pred_def_70646,type,
    v121198: state_type > $o ).

tff(pred_def_70647,type,
    v121363: state_type > $o ).

tff(pred_def_70648,type,
    v121364: state_type > $o ).

tff(pred_def_70649,type,
    v121362: state_type > $o ).

tff(pred_def_70650,type,
    v121365: state_type > $o ).

tff(pred_def_70651,type,
    v121361: state_type > $o ).

tff(pred_def_70652,type,
    v121197: state_type > $o ).

tff(pred_def_70653,type,
    v121366: state_type > $o ).

tff(pred_def_70654,type,
    v121196: state_type > $o ).

tff(pred_def_70655,type,
    v121195: state_type > $o ).

tff(pred_def_70656,type,
    v121370: state_type > $o ).

tff(pred_def_70657,type,
    v121371: state_type > $o ).

tff(pred_def_70658,type,
    v121369: state_type > $o ).

tff(pred_def_70659,type,
    v121372: state_type > $o ).

tff(pred_def_70660,type,
    v121368: state_type > $o ).

tff(pred_def_70661,type,
    v121367: state_type > $o ).

tff(pred_def_70662,type,
    v121194: state_type > $o ).

tff(pred_def_70663,type,
    v121373: state_type > $o ).

tff(pred_def_70664,type,
    v121193: state_type > $o ).

tff(pred_def_70665,type,
    v121376: state_type > $o ).

tff(pred_def_70666,type,
    v121377: state_type > $o ).

tff(pred_def_70667,type,
    v121375: state_type > $o ).

tff(pred_def_70668,type,
    v121378: state_type > $o ).

tff(pred_def_70669,type,
    v121374: state_type > $o ).

tff(pred_def_70670,type,
    v121381: state_type > $o ).

tff(pred_def_70671,type,
    v121382: state_type > $o ).

tff(pred_def_70672,type,
    v121380: state_type > $o ).

tff(pred_def_70673,type,
    v121383: state_type > $o ).

tff(pred_def_70674,type,
    v121379: state_type > $o ).

tff(pred_def_70675,type,
    v121191: ( state_type * $int ) > $o ).

tff(pred_def_70676,type,
    v121176: ( state_type * $int ) > $o ).

tff(pred_def_70677,type,
    v121393: state_type > $o ).

tff(pred_def_70678,type,
    v121391: state_type > $o ).

tff(pred_def_70679,type,
    v121390: state_type > $o ).

tff(pred_def_70680,type,
    v121389: ( state_type * $int ) > $o ).

tff(pred_def_70681,type,
    v121387: state_type > $o ).

tff(pred_def_70682,type,
    v121403: state_type > $o ).

tff(pred_def_70683,type,
    v121401: state_type > $o ).

tff(pred_def_70684,type,
    v121400: state_type > $o ).

tff(pred_def_70685,type,
    v121399: ( state_type * $int ) > $o ).

tff(pred_def_70686,type,
    v121397: state_type > $o ).

tff(pred_def_70687,type,
    v121413: state_type > $o ).

tff(pred_def_70688,type,
    v121411: state_type > $o ).

tff(pred_def_70689,type,
    v121410: state_type > $o ).

tff(pred_def_70690,type,
    v121409: ( state_type * $int ) > $o ).

tff(pred_def_70691,type,
    v121407: state_type > $o ).

tff(pred_def_70692,type,
    v121417: state_type > $o ).

tff(pred_def_70693,type,
    v121419: state_type > $o ).

tff(pred_def_70694,type,
    v121421: state_type > $o ).

tff(pred_def_70695,type,
    v121427: state_type > $o ).

tff(pred_def_70696,type,
    v121426: state_type > $o ).

tff(pred_def_70697,type,
    v121425: state_type > $o ).

tff(pred_def_70698,type,
    v121424: state_type > $o ).

tff(pred_def_70699,type,
    v121423: state_type > $o ).

tff(pred_def_70700,type,
    v121422: ( state_type * $int ) > $o ).

tff(pred_def_70701,type,
    v121385: ( state_type * $int ) > $o ).

tff(pred_def_70702,type,
    v121456: ( state_type * $int ) > $o ).

tff(pred_def_70703,type,
    v121154: ( state_type * $int ) > $o ).

tff(pred_def_70704,type,
    v121455: state_type > $o ).

tff(pred_def_70705,type,
    v121459: state_type > $o ).

tff(pred_def_70706,type,
    v121460: state_type > $o ).

tff(pred_def_70707,type,
    v121458: state_type > $o ).

tff(pred_def_70708,type,
    v121461: state_type > $o ).

tff(pred_def_70709,type,
    v121457: state_type > $o ).

tff(pred_def_70710,type,
    v121454: state_type > $o ).

tff(pred_def_70711,type,
    v121462: state_type > $o ).

tff(pred_def_70712,type,
    v121453: state_type > $o ).

tff(pred_def_70713,type,
    v121465: state_type > $o ).

tff(pred_def_70714,type,
    v121466: state_type > $o ).

tff(pred_def_70715,type,
    v121464: state_type > $o ).

tff(pred_def_70716,type,
    v121467: state_type > $o ).

tff(pred_def_70717,type,
    v121463: state_type > $o ).

tff(pred_def_70718,type,
    v121452: state_type > $o ).

tff(pred_def_70719,type,
    v121468: state_type > $o ).

tff(pred_def_70720,type,
    v121451: state_type > $o ).

tff(pred_def_70721,type,
    v121471: state_type > $o ).

tff(pred_def_70722,type,
    v121472: state_type > $o ).

tff(pred_def_70723,type,
    v121470: state_type > $o ).

tff(pred_def_70724,type,
    v121473: state_type > $o ).

tff(pred_def_70725,type,
    v121469: state_type > $o ).

tff(pred_def_70726,type,
    v121450: state_type > $o ).

tff(pred_def_70727,type,
    v121474: state_type > $o ).

tff(pred_def_70728,type,
    v121449: state_type > $o ).

tff(pred_def_70729,type,
    v121477: state_type > $o ).

tff(pred_def_70730,type,
    v121478: state_type > $o ).

tff(pred_def_70731,type,
    v121476: state_type > $o ).

tff(pred_def_70732,type,
    v121479: state_type > $o ).

tff(pred_def_70733,type,
    v121475: state_type > $o ).

tff(pred_def_70734,type,
    v121448: state_type > $o ).

tff(pred_def_70735,type,
    v121480: state_type > $o ).

tff(pred_def_70736,type,
    v121447: state_type > $o ).

tff(pred_def_70737,type,
    v121446: state_type > $o ).

tff(pred_def_70738,type,
    v121484: state_type > $o ).

tff(pred_def_70739,type,
    v121485: state_type > $o ).

tff(pred_def_70740,type,
    v121483: state_type > $o ).

tff(pred_def_70741,type,
    v121486: state_type > $o ).

tff(pred_def_70742,type,
    v121482: state_type > $o ).

tff(pred_def_70743,type,
    v121481: state_type > $o ).

tff(pred_def_70744,type,
    v121445: state_type > $o ).

tff(pred_def_70745,type,
    v121487: state_type > $o ).

tff(pred_def_70746,type,
    v121444: state_type > $o ).

tff(pred_def_70747,type,
    v121490: state_type > $o ).

tff(pred_def_70748,type,
    v121491: state_type > $o ).

tff(pred_def_70749,type,
    v121489: state_type > $o ).

tff(pred_def_70750,type,
    v121492: state_type > $o ).

tff(pred_def_70751,type,
    v121488: state_type > $o ).

tff(pred_def_70752,type,
    v121495: state_type > $o ).

tff(pred_def_70753,type,
    v121496: state_type > $o ).

tff(pred_def_70754,type,
    v121494: state_type > $o ).

tff(pred_def_70755,type,
    v121497: state_type > $o ).

tff(pred_def_70756,type,
    v121493: state_type > $o ).

tff(pred_def_70757,type,
    v121500: state_type > $o ).

tff(pred_def_70758,type,
    v121501: state_type > $o ).

tff(pred_def_70759,type,
    v121499: state_type > $o ).

tff(pred_def_70760,type,
    v121502: state_type > $o ).

tff(pred_def_70761,type,
    v121498: state_type > $o ).

tff(pred_def_70762,type,
    v121505: state_type > $o ).

tff(pred_def_70763,type,
    v121506: state_type > $o ).

tff(pred_def_70764,type,
    v121504: state_type > $o ).

tff(pred_def_70765,type,
    v121507: state_type > $o ).

tff(pred_def_70766,type,
    v121503: state_type > $o ).

tff(pred_def_70767,type,
    v121510: state_type > $o ).

tff(pred_def_70768,type,
    v121511: state_type > $o ).

tff(pred_def_70769,type,
    v121509: state_type > $o ).

tff(pred_def_70770,type,
    v121512: state_type > $o ).

tff(pred_def_70771,type,
    v121508: state_type > $o ).

tff(pred_def_70772,type,
    v121442: ( state_type * $int ) > $o ).

tff(pred_def_70773,type,
    v121441: state_type > $o ).

tff(pred_def_70774,type,
    v121517: state_type > $o ).

tff(pred_def_70775,type,
    v121519: state_type > $o ).

tff(pred_def_70776,type,
    v121520: state_type > $o ).

tff(pred_def_70777,type,
    v121518: state_type > $o ).

tff(pred_def_70778,type,
    v121516: state_type > $o ).

tff(pred_def_70779,type,
    v121515: state_type > $o ).

tff(pred_def_70780,type,
    v121521: state_type > $o ).

tff(pred_def_70781,type,
    v121514: state_type > $o ).

tff(pred_def_70782,type,
    v121522: state_type > $o ).

tff(pred_def_70783,type,
    v121513: state_type > $o ).

tff(pred_def_70784,type,
    v121440: state_type > $o ).

tff(pred_def_70785,type,
    v121523: state_type > $o ).

tff(pred_def_70786,type,
    v121439: state_type > $o ).

tff(pred_def_70787,type,
    v121530: state_type > $o ).

tff(pred_def_70788,type,
    v121529: state_type > $o ).

tff(pred_def_70789,type,
    v121528: state_type > $o ).

tff(pred_def_70790,type,
    v121532: state_type > $o ).

tff(pred_def_70791,type,
    v121531: state_type > $o ).

tff(pred_def_70792,type,
    v121527: state_type > $o ).

tff(pred_def_70793,type,
    v121526: state_type > $o ).

tff(pred_def_70794,type,
    v121533: state_type > $o ).

tff(pred_def_70795,type,
    v121525: state_type > $o ).

tff(pred_def_70796,type,
    v121534: state_type > $o ).

tff(pred_def_70797,type,
    v121524: state_type > $o ).

tff(pred_def_70798,type,
    v121438: state_type > $o ).

tff(pred_def_70799,type,
    v121535: state_type > $o ).

tff(pred_def_70800,type,
    v121437: state_type > $o ).

tff(pred_def_70801,type,
    v121542: state_type > $o ).

tff(pred_def_70802,type,
    v121541: state_type > $o ).

tff(pred_def_70803,type,
    v121540: state_type > $o ).

tff(pred_def_70804,type,
    v121544: state_type > $o ).

tff(pred_def_70805,type,
    v121543: state_type > $o ).

tff(pred_def_70806,type,
    v121539: state_type > $o ).

tff(pred_def_70807,type,
    v121538: state_type > $o ).

tff(pred_def_70808,type,
    v121545: state_type > $o ).

tff(pred_def_70809,type,
    v121537: state_type > $o ).

tff(pred_def_70810,type,
    v121546: state_type > $o ).

tff(pred_def_70811,type,
    v121536: state_type > $o ).

tff(pred_def_70812,type,
    v121436: state_type > $o ).

tff(pred_def_70813,type,
    v121547: state_type > $o ).

tff(pred_def_70814,type,
    v121435: state_type > $o ).

tff(pred_def_70815,type,
    v121554: state_type > $o ).

tff(pred_def_70816,type,
    v121553: state_type > $o ).

tff(pred_def_70817,type,
    v121552: state_type > $o ).

tff(pred_def_70818,type,
    v121556: state_type > $o ).

tff(pred_def_70819,type,
    v121555: state_type > $o ).

tff(pred_def_70820,type,
    v121551: state_type > $o ).

tff(pred_def_70821,type,
    v121550: state_type > $o ).

tff(pred_def_70822,type,
    v121557: state_type > $o ).

tff(pred_def_70823,type,
    v121549: state_type > $o ).

tff(pred_def_70824,type,
    v121558: state_type > $o ).

tff(pred_def_70825,type,
    v121548: state_type > $o ).

tff(pred_def_70826,type,
    v121434: state_type > $o ).

tff(pred_def_70827,type,
    v121559: state_type > $o ).

tff(pred_def_70828,type,
    v121433: state_type > $o ).

tff(pred_def_70829,type,
    v121432: state_type > $o ).

tff(pred_def_70830,type,
    v121567: state_type > $o ).

tff(pred_def_70831,type,
    v121566: state_type > $o ).

tff(pred_def_70832,type,
    v121565: state_type > $o ).

tff(pred_def_70833,type,
    v121569: state_type > $o ).

tff(pred_def_70834,type,
    v121568: state_type > $o ).

tff(pred_def_70835,type,
    v121564: state_type > $o ).

tff(pred_def_70836,type,
    v121563: state_type > $o ).

tff(pred_def_70837,type,
    v121570: state_type > $o ).

tff(pred_def_70838,type,
    v121562: state_type > $o ).

tff(pred_def_70839,type,
    v121571: state_type > $o ).

tff(pred_def_70840,type,
    v121561: state_type > $o ).

tff(pred_def_70841,type,
    v121560: state_type > $o ).

tff(pred_def_70842,type,
    v121431: state_type > $o ).

tff(pred_def_70843,type,
    v121572: state_type > $o ).

tff(pred_def_70844,type,
    v121430: state_type > $o ).

tff(pred_def_70845,type,
    v121575: state_type > $o ).

tff(pred_def_70846,type,
    v121576: state_type > $o ).

tff(pred_def_70847,type,
    v121574: state_type > $o ).

tff(pred_def_70848,type,
    v121577: state_type > $o ).

tff(pred_def_70849,type,
    v121573: state_type > $o ).

tff(pred_def_70850,type,
    v121580: state_type > $o ).

tff(pred_def_70851,type,
    v121581: state_type > $o ).

tff(pred_def_70852,type,
    v121579: state_type > $o ).

tff(pred_def_70853,type,
    v121582: state_type > $o ).

tff(pred_def_70854,type,
    v121578: state_type > $o ).

tff(pred_def_70855,type,
    v121585: state_type > $o ).

tff(pred_def_70856,type,
    v121586: state_type > $o ).

tff(pred_def_70857,type,
    v121584: state_type > $o ).

tff(pred_def_70858,type,
    v121587: state_type > $o ).

tff(pred_def_70859,type,
    v121583: state_type > $o ).

tff(pred_def_70860,type,
    v121590: state_type > $o ).

tff(pred_def_70861,type,
    v121591: state_type > $o ).

tff(pred_def_70862,type,
    v121589: state_type > $o ).

tff(pred_def_70863,type,
    v121592: state_type > $o ).

tff(pred_def_70864,type,
    v121588: state_type > $o ).

tff(pred_def_70865,type,
    v121595: state_type > $o ).

tff(pred_def_70866,type,
    v121594: state_type > $o ).

tff(pred_def_70867,type,
    v121596: state_type > $o ).

tff(pred_def_70868,type,
    v121593: state_type > $o ).

tff(pred_def_70869,type,
    v121174: ( state_type * $int ) > $o ).

tff(pred_def_70870,type,
    v121172: ( state_type * $int ) > $o ).

tff(pred_def_70871,type,
    v121170: ( state_type * $int ) > $o ).

tff(pred_def_70872,type,
    v121168: ( state_type * $int ) > $o ).

tff(pred_def_70873,type,
    v121602: state_type > $o ).

tff(pred_def_70874,type,
    v121600: state_type > $o ).

tff(pred_def_70875,type,
    v121598: state_type > $o ).

tff(pred_def_70876,type,
    v121609: state_type > $o ).

tff(pred_def_70877,type,
    v121607: state_type > $o ).

tff(pred_def_70878,type,
    v121606: state_type > $o ).

tff(pred_def_70879,type,
    v121605: state_type > $o ).

tff(pred_def_70880,type,
    v121617: state_type > $o ).

tff(pred_def_70881,type,
    v121618: state_type > $o ).

tff(pred_def_70882,type,
    v121616: state_type > $o ).

tff(pred_def_70883,type,
    v121613: ( state_type * $int ) > $o ).

tff(pred_def_70884,type,
    v121615: ( state_type * $int ) > $o ).

tff(pred_def_70885,type,
    v121158: ( state_type * $int ) > $o ).

tff(pred_def_70886,type,
    v121156: ( state_type * $int ) > $o ).

tff(pred_def_70887,type,
    v121622: state_type > $o ).

tff(pred_def_70888,type,
    v121624: state_type > $o ).

tff(pred_def_70889,type,
    v121625: state_type > $o ).

tff(pred_def_70890,type,
    v121152: state_type > $o ).

tff(pred_def_70891,type,
    v121627: state_type > $o ).

tff(pred_def_70892,type,
    v121629: state_type > $o ).

tff(pred_def_70893,type,
    v121635: state_type > $o ).

tff(pred_def_70894,type,
    v121637: state_type > $o ).

tff(pred_def_70895,type,
    v121647: state_type > $o ).

tff(pred_def_70896,type,
    v121648: state_type > $o ).

tff(pred_def_70897,type,
    v121646: state_type > $o ).

tff(pred_def_70898,type,
    v121650: state_type > $o ).

tff(pred_def_70899,type,
    v121651: state_type > $o ).

tff(pred_def_70900,type,
    v121649: state_type > $o ).

tff(pred_def_70901,type,
    v121645: state_type > $o ).

tff(pred_def_70902,type,
    v121644: state_type > $o ).

tff(pred_def_70903,type,
    v121643: state_type > $o ).

tff(pred_def_70904,type,
    v121642: state_type > $o ).

tff(pred_def_70905,type,
    v121122: ( state_type * $int ) > $o ).

tff(pred_def_70906,type,
    v121652: state_type > $o ).

tff(pred_def_70907,type,
    v121641: state_type > $o ).

tff(pred_def_70908,type,
    v121654: state_type > $o ).

tff(pred_def_70909,type,
    v121653: state_type > $o ).

tff(pred_def_70910,type,
    v121640: state_type > $o ).

tff(pred_def_70911,type,
    v121656: state_type > $o ).

tff(pred_def_70912,type,
    v121662: state_type > $o ).

tff(pred_def_70913,type,
    v121663: state_type > $o ).

tff(pred_def_70914,type,
    v121661: state_type > $o ).

tff(pred_def_70915,type,
    v121660: state_type > $o ).

tff(pred_def_70916,type,
    v121666: state_type > $o ).

tff(pred_def_70917,type,
    v121665: state_type > $o ).

tff(pred_def_70918,type,
    v121664: state_type > $o ).

tff(pred_def_70919,type,
    v121659: state_type > $o ).

tff(pred_def_70920,type,
    v121667: state_type > $o ).

tff(pred_def_70921,type,
    v121658: state_type > $o ).

tff(pred_def_70922,type,
    v121668: state_type > $o ).

tff(pred_def_70923,type,
    v121657: state_type > $o ).

tff(pred_def_70924,type,
    v121655: state_type > $o ).

tff(pred_def_70925,type,
    v121639: state_type > $o ).

tff(pred_def_70926,type,
    v121150: ( state_type * $int ) > $o ).

tff(pred_def_70927,type,
    v121669: ( state_type * $int ) > $o ).

tff(pred_def_70928,type,
    v121633: state_type > $o ).

tff(pred_def_70929,type,
    v121148: ( state_type * $int ) > $o ).

tff(pred_def_70930,type,
    v121146: ( state_type * $int ) > $o ).

tff(pred_def_70931,type,
    v121144: ( state_type * $int ) > $o ).

tff(pred_def_70932,type,
    v121673: state_type > $o ).

tff(pred_def_70933,type,
    v121671: state_type > $o ).

tff(pred_def_70934,type,
    v121680: state_type > $o ).

tff(pred_def_70935,type,
    v121678: state_type > $o ).

tff(pred_def_70936,type,
    v121677: state_type > $o ).

tff(pred_def_70937,type,
    v121676: state_type > $o ).

tff(pred_def_70938,type,
    v121688: state_type > $o ).

tff(pred_def_70939,type,
    v121689: state_type > $o ).

tff(pred_def_70940,type,
    v121687: state_type > $o ).

tff(pred_def_70941,type,
    v121684: ( state_type * $int ) > $o ).

tff(pred_def_70942,type,
    v121686: ( state_type * $int ) > $o ).

tff(pred_def_70943,type,
    v121675: ( state_type * $int ) > $o ).

tff(pred_def_70944,type,
    v121126: ( state_type * $int ) > $o ).

tff(pred_def_70945,type,
    v121124: ( state_type * $int ) > $o ).

tff(pred_def_70946,type,
    v121693: state_type > $o ).

tff(pred_def_70947,type,
    v121699: state_type > $o ).

tff(pred_def_70948,type,
    v121698: state_type > $o ).

tff(pred_def_70949,type,
    v121697: state_type > $o ).

tff(pred_def_70950,type,
    v121701: state_type > $o ).

tff(pred_def_70951,type,
    v121700: state_type > $o ).

tff(pred_def_70952,type,
    v121696: state_type > $o ).

tff(pred_def_70953,type,
    v121703: state_type > $o ).

tff(pred_def_70954,type,
    v121709: state_type > $o ).

tff(pred_def_70955,type,
    v121708: state_type > $o ).

tff(pred_def_70956,type,
    v121707: state_type > $o ).

tff(pred_def_70957,type,
    v121706: state_type > $o ).

tff(pred_def_70958,type,
    v121710: state_type > $o ).

tff(pred_def_70959,type,
    v121705: state_type > $o ).

tff(pred_def_70960,type,
    v121711: state_type > $o ).

tff(pred_def_70961,type,
    v121704: state_type > $o ).

tff(pred_def_70962,type,
    v121702: state_type > $o ).

tff(pred_def_70963,type,
    v121695: state_type > $o ).

tff(pred_def_70964,type,
    v121717: state_type > $o ).

tff(pred_def_70965,type,
    v121715: state_type > $o ).

tff(pred_def_70966,type,
    v121714: state_type > $o ).

tff(pred_def_70967,type,
    v121713: ( state_type * $int ) > $o ).

tff(pred_def_70968,type,
    v121727: state_type > $o ).

tff(pred_def_70969,type,
    v121726: state_type > $o ).

tff(pred_def_70970,type,
    v121725: state_type > $o ).

tff(pred_def_70971,type,
    v121724: state_type > $o ).

tff(pred_def_70972,type,
    v121729: state_type > $o ).

tff(pred_def_70973,type,
    v121730: state_type > $o ).

tff(pred_def_70974,type,
    v121728: state_type > $o ).

tff(pred_def_70975,type,
    v121723: state_type > $o ).

tff(pred_def_70976,type,
    v121733: state_type > $o ).

tff(pred_def_70977,type,
    v121732: state_type > $o ).

tff(pred_def_70978,type,
    v121734: state_type > $o ).

tff(pred_def_70979,type,
    v121731: state_type > $o ).

tff(pred_def_70980,type,
    v121722: state_type > $o ).

tff(pred_def_70981,type,
    v121738: state_type > $o ).

tff(pred_def_70982,type,
    v121737: state_type > $o ).

tff(pred_def_70983,type,
    v121736: state_type > $o ).

tff(pred_def_70984,type,
    v121739: state_type > $o ).

tff(pred_def_70985,type,
    v121735: state_type > $o ).

tff(pred_def_70986,type,
    v121721: state_type > $o ).

tff(pred_def_70987,type,
    v121746: state_type > $o ).

tff(pred_def_70988,type,
    v121744: state_type > $o ).

tff(pred_def_70989,type,
    v121743: state_type > $o ).

tff(pred_def_70990,type,
    v121742: ( state_type * $int ) > $o ).

tff(pred_def_70991,type,
    v121631: state_type > $o ).

tff(pred_def_70992,type,
    v121752: state_type > $o ).

tff(pred_def_70993,type,
    v121754: state_type > $o ).

tff(pred_def_70994,type,
    v121757: state_type > $o ).

tff(pred_def_70995,type,
    v121758: state_type > $o ).

tff(pred_def_70996,type,
    v121756: state_type > $o ).

tff(pred_def_70997,type,
    v121755: state_type > $o ).

tff(pred_def_70998,type,
    v121753: state_type > $o ).

tff(pred_def_70999,type,
    v121751: state_type > $o ).

tff(pred_def_71000,type,
    v121764: state_type > $o ).

tff(pred_def_71001,type,
    v121762: state_type > $o ).

tff(pred_def_71002,type,
    v121761: state_type > $o ).

tff(pred_def_71003,type,
    v121760: ( state_type * $int ) > $o ).

tff(pred_def_71004,type,
    v121778: state_type > $o ).

tff(pred_def_71005,type,
    v121776: state_type > $o ).

tff(pred_def_71006,type,
    v121782: state_type > $o ).

tff(pred_def_71007,type,
    v121780: state_type > $o ).

tff(pred_def_71008,type,
    v121794: state_type > $o ).

tff(pred_def_71009,type,
    v121795: state_type > $o ).

tff(pred_def_71010,type,
    v121792: state_type > $o ).

tff(pred_def_71011,type,
    v121770: ( state_type * $int ) > $o ).

tff(pred_def_71012,type,
    v121802: state_type > $o ).

tff(pred_def_71013,type,
    v121801: state_type > $o ).

tff(pred_def_71014,type,
    v121804: state_type > $o ).

tff(pred_def_71015,type,
    v121803: state_type > $o ).

tff(pred_def_71016,type,
    v121800: state_type > $o ).

tff(pred_def_71017,type,
    v121798: ( state_type * $int ) > $o ).

tff(pred_def_71018,type,
    v121768: state_type > $o ).

tff(pred_def_71019,type,
    v121797: ( state_type * $int ) > $o ).

tff(pred_def_71020,type,
    v121790: ( state_type * $int ) > $o ).

tff(pred_def_71021,type,
    v121788: ( state_type * $int ) > $o ).

tff(pred_def_71022,type,
    v121786: ( state_type * $int ) > $o ).

tff(pred_def_71023,type,
    v121784: ( state_type * $int ) > $o ).

tff(pred_def_71024,type,
    v121808: state_type > $o ).

tff(pred_def_71025,type,
    v121806: state_type > $o ).

tff(pred_def_71026,type,
    v121815: state_type > $o ).

tff(pred_def_71027,type,
    v121813: state_type > $o ).

tff(pred_def_71028,type,
    v121812: state_type > $o ).

tff(pred_def_71029,type,
    v121811: state_type > $o ).

tff(pred_def_71030,type,
    v121823: state_type > $o ).

tff(pred_def_71031,type,
    v121824: state_type > $o ).

tff(pred_def_71032,type,
    v121822: state_type > $o ).

tff(pred_def_71033,type,
    v121819: ( state_type * $int ) > $o ).

tff(pred_def_71034,type,
    v121821: ( state_type * $int ) > $o ).

tff(pred_def_71035,type,
    v121774: ( state_type * $int ) > $o ).

tff(pred_def_71036,type,
    v121772: ( state_type * $int ) > $o ).

tff(pred_def_71037,type,
    v121839: state_type > $o ).

tff(pred_def_71038,type,
    v121837: state_type > $o ).

tff(pred_def_71039,type,
    v121843: state_type > $o ).

tff(pred_def_71040,type,
    v121841: state_type > $o ).

tff(pred_def_71041,type,
    v121856: state_type > $o ).

tff(pred_def_71042,type,
    v121855: state_type > $o ).

tff(pred_def_71043,type,
    v121853: state_type > $o ).

tff(pred_def_71044,type,
    v121858: ( state_type * $int ) > $o ).

tff(pred_def_71045,type,
    v121860: state_type > $o ).

tff(pred_def_71046,type,
    v121863: ( state_type * $int ) > $o ).

tff(pred_def_71047,type,
    v121831: ( state_type * $int ) > $o ).

tff(pred_def_71048,type,
    v121878: state_type > $o ).

tff(pred_def_71049,type,
    v121877: state_type > $o ).

tff(pred_def_71050,type,
    v121876: state_type > $o ).

tff(pred_def_71051,type,
    v121879: state_type > $o ).

tff(pred_def_71052,type,
    v121875: state_type > $o ).

tff(pred_def_71053,type,
    v121874: state_type > $o ).

tff(pred_def_71054,type,
    v121880: state_type > $o ).

tff(pred_def_71055,type,
    v121873: state_type > $o ).

tff(pred_def_71056,type,
    v121872: state_type > $o ).

tff(pred_def_71057,type,
    v121871: state_type > $o ).

tff(pred_def_71058,type,
    v121870: state_type > $o ).

tff(pred_def_71059,type,
    v121882: state_type > $o ).

tff(pred_def_71060,type,
    v121881: state_type > $o ).

tff(pred_def_71061,type,
    v121869: state_type > $o ).

tff(pred_def_71062,type,
    v121885: state_type > $o ).

tff(pred_def_71063,type,
    v121884: state_type > $o ).

tff(pred_def_71064,type,
    v121886: state_type > $o ).

tff(pred_def_71065,type,
    v121883: state_type > $o ).

tff(pred_def_71066,type,
    v121889: state_type > $o ).

tff(pred_def_71067,type,
    v121888: state_type > $o ).

tff(pred_def_71068,type,
    v121890: state_type > $o ).

tff(pred_def_71069,type,
    v121887: state_type > $o ).

tff(pred_def_71070,type,
    v121893: state_type > $o ).

tff(pred_def_71071,type,
    v121892: state_type > $o ).

tff(pred_def_71072,type,
    v121894: state_type > $o ).

tff(pred_def_71073,type,
    v121891: state_type > $o ).

tff(pred_def_71074,type,
    v121867: ( state_type * $int ) > $o ).

tff(pred_def_71075,type,
    v121829: state_type > $o ).

tff(pred_def_71076,type,
    v121866: ( state_type * $int ) > $o ).

tff(pred_def_71077,type,
    v121865: ( state_type * $int ) > $o ).

tff(pred_def_71078,type,
    v121851: ( state_type * $int ) > $o ).

tff(pred_def_71079,type,
    v121849: ( state_type * $int ) > $o ).

tff(pred_def_71080,type,
    v121847: ( state_type * $int ) > $o ).

tff(pred_def_71081,type,
    v121845: ( state_type * $int ) > $o ).

tff(pred_def_71082,type,
    v121898: state_type > $o ).

tff(pred_def_71083,type,
    v121896: state_type > $o ).

tff(pred_def_71084,type,
    v121905: state_type > $o ).

tff(pred_def_71085,type,
    v121903: state_type > $o ).

tff(pred_def_71086,type,
    v121902: state_type > $o ).

tff(pred_def_71087,type,
    v121901: state_type > $o ).

tff(pred_def_71088,type,
    v121913: state_type > $o ).

tff(pred_def_71089,type,
    v121914: state_type > $o ).

tff(pred_def_71090,type,
    v121912: state_type > $o ).

tff(pred_def_71091,type,
    v121909: ( state_type * $int ) > $o ).

tff(pred_def_71092,type,
    v121911: ( state_type * $int ) > $o ).

tff(pred_def_71093,type,
    v121835: ( state_type * $int ) > $o ).

tff(pred_def_71094,type,
    v121833: ( state_type * $int ) > $o ).

tff(pred_def_71095,type,
    v121919: state_type > $o ).

tff(pred_def_71096,type,
    v121120: state_type > $o ).

tff(pred_def_71097,type,
    v121935: state_type > $o ).

tff(pred_def_71098,type,
    v121933: state_type > $o ).

tff(pred_def_71099,type,
    v121931: state_type > $o ).

tff(pred_def_71100,type,
    v121929: state_type > $o ).

tff(pred_def_71101,type,
    v121943: state_type > $o ).

tff(pred_def_71102,type,
    v121941: state_type > $o ).

tff(pred_def_71103,type,
    v121939: state_type > $o ).

tff(pred_def_71104,type,
    v121937: state_type > $o ).

tff(pred_def_71105,type,
    v121963: state_type > $o ).

tff(pred_def_71106,type,
    v121961: state_type > $o ).

tff(pred_def_71107,type,
    v121967: state_type > $o ).

tff(pred_def_71108,type,
    v121965: state_type > $o ).

tff(pred_def_71109,type,
    v121979: state_type > $o ).

tff(pred_def_71110,type,
    v121981: state_type > $o ).

tff(pred_def_71111,type,
    v121983: state_type > $o ).

tff(pred_def_71112,type,
    v121985: state_type > $o ).

tff(pred_def_71113,type,
    v121987: state_type > $o ).

tff(pred_def_71114,type,
    v121989: state_type > $o ).

tff(pred_def_71115,type,
    v121991: state_type > $o ).

tff(pred_def_71116,type,
    v122040: ( state_type * $int ) > $o ).

tff(pred_def_71117,type,
    v122041: ( state_type * $int ) > $o ).

tff(pred_def_71118,type,
    v122039: state_type > $o ).

tff(pred_def_71119,type,
    v122044: state_type > $o ).

tff(pred_def_71120,type,
    v122045: state_type > $o ).

tff(pred_def_71121,type,
    v122043: state_type > $o ).

tff(pred_def_71122,type,
    v122046: state_type > $o ).

tff(pred_def_71123,type,
    v122042: state_type > $o ).

tff(pred_def_71124,type,
    v122038: state_type > $o ).

tff(pred_def_71125,type,
    v122047: state_type > $o ).

tff(pred_def_71126,type,
    v122037: state_type > $o ).

tff(pred_def_71127,type,
    v122036: state_type > $o ).

tff(pred_def_71128,type,
    v122051: state_type > $o ).

tff(pred_def_71129,type,
    v122052: state_type > $o ).

tff(pred_def_71130,type,
    v122050: state_type > $o ).

tff(pred_def_71131,type,
    v122053: state_type > $o ).

tff(pred_def_71132,type,
    v122049: state_type > $o ).

tff(pred_def_71133,type,
    v122048: state_type > $o ).

tff(pred_def_71134,type,
    v122035: state_type > $o ).

tff(pred_def_71135,type,
    v122054: state_type > $o ).

tff(pred_def_71136,type,
    v122034: state_type > $o ).

tff(pred_def_71137,type,
    v122057: state_type > $o ).

tff(pred_def_71138,type,
    v122058: state_type > $o ).

tff(pred_def_71139,type,
    v122056: state_type > $o ).

tff(pred_def_71140,type,
    v122059: state_type > $o ).

tff(pred_def_71141,type,
    v122055: state_type > $o ).

tff(pred_def_71142,type,
    v122062: state_type > $o ).

tff(pred_def_71143,type,
    v122063: state_type > $o ).

tff(pred_def_71144,type,
    v122061: state_type > $o ).

tff(pred_def_71145,type,
    v122064: state_type > $o ).

tff(pred_def_71146,type,
    v122060: state_type > $o ).

tff(pred_def_71147,type,
    v122032: ( state_type * $int ) > $o ).

tff(pred_def_71148,type,
    v122065: ( state_type * $int ) > $o ).

tff(pred_def_71149,type,
    v122031: state_type > $o ).

tff(pred_def_71150,type,
    v122068: state_type > $o ).

tff(pred_def_71151,type,
    v122069: state_type > $o ).

tff(pred_def_71152,type,
    v122067: state_type > $o ).

tff(pred_def_71153,type,
    v122070: state_type > $o ).

tff(pred_def_71154,type,
    v122066: state_type > $o ).

tff(pred_def_71155,type,
    v122030: state_type > $o ).

tff(pred_def_71156,type,
    v122071: state_type > $o ).

tff(pred_def_71157,type,
    v122029: state_type > $o ).

tff(pred_def_71158,type,
    v122028: state_type > $o ).

tff(pred_def_71159,type,
    v122075: state_type > $o ).

tff(pred_def_71160,type,
    v122076: state_type > $o ).

tff(pred_def_71161,type,
    v122074: state_type > $o ).

tff(pred_def_71162,type,
    v122077: state_type > $o ).

tff(pred_def_71163,type,
    v122073: state_type > $o ).

tff(pred_def_71164,type,
    v122072: state_type > $o ).

tff(pred_def_71165,type,
    v122027: state_type > $o ).

tff(pred_def_71166,type,
    v122078: state_type > $o ).

tff(pred_def_71167,type,
    v122026: state_type > $o ).

tff(pred_def_71168,type,
    v122081: state_type > $o ).

tff(pred_def_71169,type,
    v122082: state_type > $o ).

tff(pred_def_71170,type,
    v122080: state_type > $o ).

tff(pred_def_71171,type,
    v122083: state_type > $o ).

tff(pred_def_71172,type,
    v122079: state_type > $o ).

tff(pred_def_71173,type,
    v122086: state_type > $o ).

tff(pred_def_71174,type,
    v122087: state_type > $o ).

tff(pred_def_71175,type,
    v122085: state_type > $o ).

tff(pred_def_71176,type,
    v122088: state_type > $o ).

tff(pred_def_71177,type,
    v122084: state_type > $o ).

tff(pred_def_71178,type,
    v122024: ( state_type * $int ) > $o ).

tff(pred_def_71179,type,
    v122089: ( state_type * $int ) > $o ).

tff(pred_def_71180,type,
    v122023: state_type > $o ).

tff(pred_def_71181,type,
    v122092: state_type > $o ).

tff(pred_def_71182,type,
    v122093: state_type > $o ).

tff(pred_def_71183,type,
    v122091: state_type > $o ).

tff(pred_def_71184,type,
    v122094: state_type > $o ).

tff(pred_def_71185,type,
    v122090: state_type > $o ).

tff(pred_def_71186,type,
    v122022: state_type > $o ).

tff(pred_def_71187,type,
    v122095: state_type > $o ).

tff(pred_def_71188,type,
    v122021: state_type > $o ).

tff(pred_def_71189,type,
    v122020: state_type > $o ).

tff(pred_def_71190,type,
    v122099: state_type > $o ).

tff(pred_def_71191,type,
    v122100: state_type > $o ).

tff(pred_def_71192,type,
    v122098: state_type > $o ).

tff(pred_def_71193,type,
    v122101: state_type > $o ).

tff(pred_def_71194,type,
    v122097: state_type > $o ).

tff(pred_def_71195,type,
    v122096: state_type > $o ).

tff(pred_def_71196,type,
    v122019: state_type > $o ).

tff(pred_def_71197,type,
    v122102: state_type > $o ).

tff(pred_def_71198,type,
    v122018: state_type > $o ).

tff(pred_def_71199,type,
    v122105: state_type > $o ).

tff(pred_def_71200,type,
    v122106: state_type > $o ).

tff(pred_def_71201,type,
    v122104: state_type > $o ).

tff(pred_def_71202,type,
    v122107: state_type > $o ).

tff(pred_def_71203,type,
    v122103: state_type > $o ).

tff(pred_def_71204,type,
    v122110: state_type > $o ).

tff(pred_def_71205,type,
    v122111: state_type > $o ).

tff(pred_def_71206,type,
    v122109: state_type > $o ).

tff(pred_def_71207,type,
    v122112: state_type > $o ).

tff(pred_def_71208,type,
    v122108: state_type > $o ).

tff(pred_def_71209,type,
    v122016: ( state_type * $int ) > $o ).

tff(pred_def_71210,type,
    v122113: ( state_type * $int ) > $o ).

tff(pred_def_71211,type,
    v122015: state_type > $o ).

tff(pred_def_71212,type,
    v122116: state_type > $o ).

tff(pred_def_71213,type,
    v122117: state_type > $o ).

tff(pred_def_71214,type,
    v122115: state_type > $o ).

tff(pred_def_71215,type,
    v122118: state_type > $o ).

tff(pred_def_71216,type,
    v122114: state_type > $o ).

tff(pred_def_71217,type,
    v122014: state_type > $o ).

tff(pred_def_71218,type,
    v122119: state_type > $o ).

tff(pred_def_71219,type,
    v122013: state_type > $o ).

tff(pred_def_71220,type,
    v122012: state_type > $o ).

tff(pred_def_71221,type,
    v122123: state_type > $o ).

tff(pred_def_71222,type,
    v122124: state_type > $o ).

tff(pred_def_71223,type,
    v122122: state_type > $o ).

tff(pred_def_71224,type,
    v122125: state_type > $o ).

tff(pred_def_71225,type,
    v122121: state_type > $o ).

tff(pred_def_71226,type,
    v122120: state_type > $o ).

tff(pred_def_71227,type,
    v122011: state_type > $o ).

tff(pred_def_71228,type,
    v122126: state_type > $o ).

tff(pred_def_71229,type,
    v122010: state_type > $o ).

tff(pred_def_71230,type,
    v122129: state_type > $o ).

tff(pred_def_71231,type,
    v122130: state_type > $o ).

tff(pred_def_71232,type,
    v122128: state_type > $o ).

tff(pred_def_71233,type,
    v122131: state_type > $o ).

tff(pred_def_71234,type,
    v122127: state_type > $o ).

tff(pred_def_71235,type,
    v122134: state_type > $o ).

tff(pred_def_71236,type,
    v122135: state_type > $o ).

tff(pred_def_71237,type,
    v122133: state_type > $o ).

tff(pred_def_71238,type,
    v122136: state_type > $o ).

tff(pred_def_71239,type,
    v122132: state_type > $o ).

tff(pred_def_71240,type,
    v122008: ( state_type * $int ) > $o ).

tff(pred_def_71241,type,
    v122137: ( state_type * $int ) > $o ).

tff(pred_def_71242,type,
    v122007: state_type > $o ).

tff(pred_def_71243,type,
    v122140: state_type > $o ).

tff(pred_def_71244,type,
    v122141: state_type > $o ).

tff(pred_def_71245,type,
    v122139: state_type > $o ).

tff(pred_def_71246,type,
    v122142: state_type > $o ).

tff(pred_def_71247,type,
    v122138: state_type > $o ).

tff(pred_def_71248,type,
    v122006: state_type > $o ).

tff(pred_def_71249,type,
    v122143: state_type > $o ).

tff(pred_def_71250,type,
    v122005: state_type > $o ).

tff(pred_def_71251,type,
    v122004: state_type > $o ).

tff(pred_def_71252,type,
    v122147: state_type > $o ).

tff(pred_def_71253,type,
    v122148: state_type > $o ).

tff(pred_def_71254,type,
    v122146: state_type > $o ).

tff(pred_def_71255,type,
    v122149: state_type > $o ).

tff(pred_def_71256,type,
    v122145: state_type > $o ).

tff(pred_def_71257,type,
    v122144: state_type > $o ).

tff(pred_def_71258,type,
    v122003: state_type > $o ).

tff(pred_def_71259,type,
    v122150: state_type > $o ).

tff(pred_def_71260,type,
    v122002: state_type > $o ).

tff(pred_def_71261,type,
    v122153: state_type > $o ).

tff(pred_def_71262,type,
    v122154: state_type > $o ).

tff(pred_def_71263,type,
    v122152: state_type > $o ).

tff(pred_def_71264,type,
    v122155: state_type > $o ).

tff(pred_def_71265,type,
    v122151: state_type > $o ).

tff(pred_def_71266,type,
    v122158: state_type > $o ).

tff(pred_def_71267,type,
    v122159: state_type > $o ).

tff(pred_def_71268,type,
    v122157: state_type > $o ).

tff(pred_def_71269,type,
    v122160: state_type > $o ).

tff(pred_def_71270,type,
    v122156: state_type > $o ).

tff(pred_def_71271,type,
    v122000: ( state_type * $int ) > $o ).

tff(pred_def_71272,type,
    v122161: ( state_type * $int ) > $o ).

tff(pred_def_71273,type,
    v121999: state_type > $o ).

tff(pred_def_71274,type,
    v122164: state_type > $o ).

tff(pred_def_71275,type,
    v122165: state_type > $o ).

tff(pred_def_71276,type,
    v122163: state_type > $o ).

tff(pred_def_71277,type,
    v122166: state_type > $o ).

tff(pred_def_71278,type,
    v122162: state_type > $o ).

tff(pred_def_71279,type,
    v121998: state_type > $o ).

tff(pred_def_71280,type,
    v122167: state_type > $o ).

tff(pred_def_71281,type,
    v121997: state_type > $o ).

tff(pred_def_71282,type,
    v121996: state_type > $o ).

tff(pred_def_71283,type,
    v122171: state_type > $o ).

tff(pred_def_71284,type,
    v122172: state_type > $o ).

tff(pred_def_71285,type,
    v122170: state_type > $o ).

tff(pred_def_71286,type,
    v122173: state_type > $o ).

tff(pred_def_71287,type,
    v122169: state_type > $o ).

tff(pred_def_71288,type,
    v122168: state_type > $o ).

tff(pred_def_71289,type,
    v121995: state_type > $o ).

tff(pred_def_71290,type,
    v122174: state_type > $o ).

tff(pred_def_71291,type,
    v121994: state_type > $o ).

tff(pred_def_71292,type,
    v122177: state_type > $o ).

tff(pred_def_71293,type,
    v122178: state_type > $o ).

tff(pred_def_71294,type,
    v122176: state_type > $o ).

tff(pred_def_71295,type,
    v122179: state_type > $o ).

tff(pred_def_71296,type,
    v122175: state_type > $o ).

tff(pred_def_71297,type,
    v122182: state_type > $o ).

tff(pred_def_71298,type,
    v122183: state_type > $o ).

tff(pred_def_71299,type,
    v122181: state_type > $o ).

tff(pred_def_71300,type,
    v122184: state_type > $o ).

tff(pred_def_71301,type,
    v122180: state_type > $o ).

tff(pred_def_71302,type,
    v121992: ( state_type * $int ) > $o ).

tff(pred_def_71303,type,
    v121977: ( state_type * $int ) > $o ).

tff(pred_def_71304,type,
    v122194: state_type > $o ).

tff(pred_def_71305,type,
    v122192: state_type > $o ).

tff(pred_def_71306,type,
    v122191: state_type > $o ).

tff(pred_def_71307,type,
    v122190: ( state_type * $int ) > $o ).

tff(pred_def_71308,type,
    v122188: state_type > $o ).

tff(pred_def_71309,type,
    v122204: state_type > $o ).

tff(pred_def_71310,type,
    v122202: state_type > $o ).

tff(pred_def_71311,type,
    v122201: state_type > $o ).

tff(pred_def_71312,type,
    v122200: ( state_type * $int ) > $o ).

tff(pred_def_71313,type,
    v122198: state_type > $o ).

tff(pred_def_71314,type,
    v122214: state_type > $o ).

tff(pred_def_71315,type,
    v122212: state_type > $o ).

tff(pred_def_71316,type,
    v122211: state_type > $o ).

tff(pred_def_71317,type,
    v122210: ( state_type * $int ) > $o ).

tff(pred_def_71318,type,
    v122208: state_type > $o ).

tff(pred_def_71319,type,
    v122218: state_type > $o ).

tff(pred_def_71320,type,
    v122220: state_type > $o ).

tff(pred_def_71321,type,
    v122222: state_type > $o ).

tff(pred_def_71322,type,
    v122228: state_type > $o ).

tff(pred_def_71323,type,
    v122227: state_type > $o ).

tff(pred_def_71324,type,
    v122226: state_type > $o ).

tff(pred_def_71325,type,
    v122225: state_type > $o ).

tff(pred_def_71326,type,
    v122224: state_type > $o ).

tff(pred_def_71327,type,
    v122223: ( state_type * $int ) > $o ).

tff(pred_def_71328,type,
    v122186: ( state_type * $int ) > $o ).

tff(pred_def_71329,type,
    v122257: ( state_type * $int ) > $o ).

tff(pred_def_71330,type,
    v121955: ( state_type * $int ) > $o ).

tff(pred_def_71331,type,
    v122256: state_type > $o ).

tff(pred_def_71332,type,
    v122260: state_type > $o ).

tff(pred_def_71333,type,
    v122261: state_type > $o ).

tff(pred_def_71334,type,
    v122259: state_type > $o ).

tff(pred_def_71335,type,
    v122262: state_type > $o ).

tff(pred_def_71336,type,
    v122258: state_type > $o ).

tff(pred_def_71337,type,
    v122255: state_type > $o ).

tff(pred_def_71338,type,
    v122263: state_type > $o ).

tff(pred_def_71339,type,
    v122254: state_type > $o ).

tff(pred_def_71340,type,
    v122266: state_type > $o ).

tff(pred_def_71341,type,
    v122267: state_type > $o ).

tff(pred_def_71342,type,
    v122265: state_type > $o ).

tff(pred_def_71343,type,
    v122268: state_type > $o ).

tff(pred_def_71344,type,
    v122264: state_type > $o ).

tff(pred_def_71345,type,
    v122253: state_type > $o ).

tff(pred_def_71346,type,
    v122269: state_type > $o ).

tff(pred_def_71347,type,
    v122252: state_type > $o ).

tff(pred_def_71348,type,
    v122272: state_type > $o ).

tff(pred_def_71349,type,
    v122273: state_type > $o ).

tff(pred_def_71350,type,
    v122271: state_type > $o ).

tff(pred_def_71351,type,
    v122274: state_type > $o ).

tff(pred_def_71352,type,
    v122270: state_type > $o ).

tff(pred_def_71353,type,
    v122251: state_type > $o ).

tff(pred_def_71354,type,
    v122275: state_type > $o ).

tff(pred_def_71355,type,
    v122250: state_type > $o ).

tff(pred_def_71356,type,
    v122278: state_type > $o ).

tff(pred_def_71357,type,
    v122279: state_type > $o ).

tff(pred_def_71358,type,
    v122277: state_type > $o ).

tff(pred_def_71359,type,
    v122280: state_type > $o ).

tff(pred_def_71360,type,
    v122276: state_type > $o ).

tff(pred_def_71361,type,
    v122249: state_type > $o ).

tff(pred_def_71362,type,
    v122281: state_type > $o ).

tff(pred_def_71363,type,
    v122248: state_type > $o ).

tff(pred_def_71364,type,
    v122247: state_type > $o ).

tff(pred_def_71365,type,
    v122285: state_type > $o ).

tff(pred_def_71366,type,
    v122286: state_type > $o ).

tff(pred_def_71367,type,
    v122284: state_type > $o ).

tff(pred_def_71368,type,
    v122287: state_type > $o ).

tff(pred_def_71369,type,
    v122283: state_type > $o ).

tff(pred_def_71370,type,
    v122282: state_type > $o ).

tff(pred_def_71371,type,
    v122246: state_type > $o ).

tff(pred_def_71372,type,
    v122288: state_type > $o ).

tff(pred_def_71373,type,
    v122245: state_type > $o ).

tff(pred_def_71374,type,
    v122291: state_type > $o ).

tff(pred_def_71375,type,
    v122292: state_type > $o ).

tff(pred_def_71376,type,
    v122290: state_type > $o ).

tff(pred_def_71377,type,
    v122293: state_type > $o ).

tff(pred_def_71378,type,
    v122289: state_type > $o ).

tff(pred_def_71379,type,
    v122296: state_type > $o ).

tff(pred_def_71380,type,
    v122297: state_type > $o ).

tff(pred_def_71381,type,
    v122295: state_type > $o ).

tff(pred_def_71382,type,
    v122298: state_type > $o ).

tff(pred_def_71383,type,
    v122294: state_type > $o ).

tff(pred_def_71384,type,
    v122301: state_type > $o ).

tff(pred_def_71385,type,
    v122302: state_type > $o ).

tff(pred_def_71386,type,
    v122300: state_type > $o ).

tff(pred_def_71387,type,
    v122303: state_type > $o ).

tff(pred_def_71388,type,
    v122299: state_type > $o ).

tff(pred_def_71389,type,
    v122306: state_type > $o ).

tff(pred_def_71390,type,
    v122307: state_type > $o ).

tff(pred_def_71391,type,
    v122305: state_type > $o ).

tff(pred_def_71392,type,
    v122308: state_type > $o ).

tff(pred_def_71393,type,
    v122304: state_type > $o ).

tff(pred_def_71394,type,
    v122311: state_type > $o ).

tff(pred_def_71395,type,
    v122312: state_type > $o ).

tff(pred_def_71396,type,
    v122310: state_type > $o ).

tff(pred_def_71397,type,
    v122313: state_type > $o ).

tff(pred_def_71398,type,
    v122309: state_type > $o ).

tff(pred_def_71399,type,
    v122243: ( state_type * $int ) > $o ).

tff(pred_def_71400,type,
    v122242: state_type > $o ).

tff(pred_def_71401,type,
    v122318: state_type > $o ).

tff(pred_def_71402,type,
    v122320: state_type > $o ).

tff(pred_def_71403,type,
    v122321: state_type > $o ).

tff(pred_def_71404,type,
    v122319: state_type > $o ).

tff(pred_def_71405,type,
    v122317: state_type > $o ).

tff(pred_def_71406,type,
    v122316: state_type > $o ).

tff(pred_def_71407,type,
    v122322: state_type > $o ).

tff(pred_def_71408,type,
    v122315: state_type > $o ).

tff(pred_def_71409,type,
    v122323: state_type > $o ).

tff(pred_def_71410,type,
    v122314: state_type > $o ).

tff(pred_def_71411,type,
    v122241: state_type > $o ).

tff(pred_def_71412,type,
    v122324: state_type > $o ).

tff(pred_def_71413,type,
    v122240: state_type > $o ).

tff(pred_def_71414,type,
    v122331: state_type > $o ).

tff(pred_def_71415,type,
    v122330: state_type > $o ).

tff(pred_def_71416,type,
    v122329: state_type > $o ).

tff(pred_def_71417,type,
    v122333: state_type > $o ).

tff(pred_def_71418,type,
    v122332: state_type > $o ).

tff(pred_def_71419,type,
    v122328: state_type > $o ).

tff(pred_def_71420,type,
    v122327: state_type > $o ).

tff(pred_def_71421,type,
    v122334: state_type > $o ).

tff(pred_def_71422,type,
    v122326: state_type > $o ).

tff(pred_def_71423,type,
    v122335: state_type > $o ).

tff(pred_def_71424,type,
    v122325: state_type > $o ).

tff(pred_def_71425,type,
    v122239: state_type > $o ).

tff(pred_def_71426,type,
    v122336: state_type > $o ).

tff(pred_def_71427,type,
    v122238: state_type > $o ).

tff(pred_def_71428,type,
    v122343: state_type > $o ).

tff(pred_def_71429,type,
    v122342: state_type > $o ).

tff(pred_def_71430,type,
    v122341: state_type > $o ).

tff(pred_def_71431,type,
    v122345: state_type > $o ).

tff(pred_def_71432,type,
    v122344: state_type > $o ).

tff(pred_def_71433,type,
    v122340: state_type > $o ).

tff(pred_def_71434,type,
    v122339: state_type > $o ).

tff(pred_def_71435,type,
    v122346: state_type > $o ).

tff(pred_def_71436,type,
    v122338: state_type > $o ).

tff(pred_def_71437,type,
    v122347: state_type > $o ).

tff(pred_def_71438,type,
    v122337: state_type > $o ).

tff(pred_def_71439,type,
    v122237: state_type > $o ).

tff(pred_def_71440,type,
    v122348: state_type > $o ).

tff(pred_def_71441,type,
    v122236: state_type > $o ).

tff(pred_def_71442,type,
    v122355: state_type > $o ).

tff(pred_def_71443,type,
    v122354: state_type > $o ).

tff(pred_def_71444,type,
    v122353: state_type > $o ).

tff(pred_def_71445,type,
    v122357: state_type > $o ).

tff(pred_def_71446,type,
    v122356: state_type > $o ).

tff(pred_def_71447,type,
    v122352: state_type > $o ).

tff(pred_def_71448,type,
    v122351: state_type > $o ).

tff(pred_def_71449,type,
    v122358: state_type > $o ).

tff(pred_def_71450,type,
    v122350: state_type > $o ).

tff(pred_def_71451,type,
    v122359: state_type > $o ).

tff(pred_def_71452,type,
    v122349: state_type > $o ).

tff(pred_def_71453,type,
    v122235: state_type > $o ).

tff(pred_def_71454,type,
    v122360: state_type > $o ).

tff(pred_def_71455,type,
    v122234: state_type > $o ).

tff(pred_def_71456,type,
    v122233: state_type > $o ).

tff(pred_def_71457,type,
    v122368: state_type > $o ).

tff(pred_def_71458,type,
    v122367: state_type > $o ).

tff(pred_def_71459,type,
    v122366: state_type > $o ).

tff(pred_def_71460,type,
    v122370: state_type > $o ).

tff(pred_def_71461,type,
    v122369: state_type > $o ).

tff(pred_def_71462,type,
    v122365: state_type > $o ).

tff(pred_def_71463,type,
    v122364: state_type > $o ).

tff(pred_def_71464,type,
    v122371: state_type > $o ).

tff(pred_def_71465,type,
    v122363: state_type > $o ).

tff(pred_def_71466,type,
    v122372: state_type > $o ).

tff(pred_def_71467,type,
    v122362: state_type > $o ).

tff(pred_def_71468,type,
    v122361: state_type > $o ).

tff(pred_def_71469,type,
    v122232: state_type > $o ).

tff(pred_def_71470,type,
    v122373: state_type > $o ).

tff(pred_def_71471,type,
    v122231: state_type > $o ).

tff(pred_def_71472,type,
    v122376: state_type > $o ).

tff(pred_def_71473,type,
    v122377: state_type > $o ).

tff(pred_def_71474,type,
    v122375: state_type > $o ).

tff(pred_def_71475,type,
    v122378: state_type > $o ).

tff(pred_def_71476,type,
    v122374: state_type > $o ).

tff(pred_def_71477,type,
    v122381: state_type > $o ).

tff(pred_def_71478,type,
    v122382: state_type > $o ).

tff(pred_def_71479,type,
    v122380: state_type > $o ).

tff(pred_def_71480,type,
    v122383: state_type > $o ).

tff(pred_def_71481,type,
    v122379: state_type > $o ).

tff(pred_def_71482,type,
    v122386: state_type > $o ).

tff(pred_def_71483,type,
    v122387: state_type > $o ).

tff(pred_def_71484,type,
    v122385: state_type > $o ).

tff(pred_def_71485,type,
    v122388: state_type > $o ).

tff(pred_def_71486,type,
    v122384: state_type > $o ).

tff(pred_def_71487,type,
    v122391: state_type > $o ).

tff(pred_def_71488,type,
    v122392: state_type > $o ).

tff(pred_def_71489,type,
    v122390: state_type > $o ).

tff(pred_def_71490,type,
    v122393: state_type > $o ).

tff(pred_def_71491,type,
    v122389: state_type > $o ).

tff(pred_def_71492,type,
    v122396: state_type > $o ).

tff(pred_def_71493,type,
    v122395: state_type > $o ).

tff(pred_def_71494,type,
    v122397: state_type > $o ).

tff(pred_def_71495,type,
    v122394: state_type > $o ).

tff(pred_def_71496,type,
    v121975: ( state_type * $int ) > $o ).

tff(pred_def_71497,type,
    v121973: ( state_type * $int ) > $o ).

tff(pred_def_71498,type,
    v121971: ( state_type * $int ) > $o ).

tff(pred_def_71499,type,
    v121969: ( state_type * $int ) > $o ).

tff(pred_def_71500,type,
    v122403: state_type > $o ).

tff(pred_def_71501,type,
    v122401: state_type > $o ).

tff(pred_def_71502,type,
    v122399: state_type > $o ).

tff(pred_def_71503,type,
    v122410: state_type > $o ).

tff(pred_def_71504,type,
    v122408: state_type > $o ).

tff(pred_def_71505,type,
    v122407: state_type > $o ).

tff(pred_def_71506,type,
    v122406: state_type > $o ).

tff(pred_def_71507,type,
    v122418: state_type > $o ).

tff(pred_def_71508,type,
    v122419: state_type > $o ).

tff(pred_def_71509,type,
    v122417: state_type > $o ).

tff(pred_def_71510,type,
    v122414: ( state_type * $int ) > $o ).

tff(pred_def_71511,type,
    v122416: ( state_type * $int ) > $o ).

tff(pred_def_71512,type,
    v121959: ( state_type * $int ) > $o ).

tff(pred_def_71513,type,
    v121957: ( state_type * $int ) > $o ).

tff(pred_def_71514,type,
    v122423: state_type > $o ).

tff(pred_def_71515,type,
    v122425: state_type > $o ).

tff(pred_def_71516,type,
    v122426: state_type > $o ).

tff(pred_def_71517,type,
    v121953: state_type > $o ).

tff(pred_def_71518,type,
    v122428: state_type > $o ).

tff(pred_def_71519,type,
    v122430: state_type > $o ).

tff(pred_def_71520,type,
    v122436: state_type > $o ).

tff(pred_def_71521,type,
    v122438: state_type > $o ).

tff(pred_def_71522,type,
    v122448: state_type > $o ).

tff(pred_def_71523,type,
    v122449: state_type > $o ).

tff(pred_def_71524,type,
    v122447: state_type > $o ).

tff(pred_def_71525,type,
    v122451: state_type > $o ).

tff(pred_def_71526,type,
    v122452: state_type > $o ).

tff(pred_def_71527,type,
    v122450: state_type > $o ).

tff(pred_def_71528,type,
    v122446: state_type > $o ).

tff(pred_def_71529,type,
    v122445: state_type > $o ).

tff(pred_def_71530,type,
    v122444: state_type > $o ).

tff(pred_def_71531,type,
    v122443: state_type > $o ).

tff(pred_def_71532,type,
    v121923: ( state_type * $int ) > $o ).

tff(pred_def_71533,type,
    v122453: state_type > $o ).

tff(pred_def_71534,type,
    v122442: state_type > $o ).

tff(pred_def_71535,type,
    v122455: state_type > $o ).

tff(pred_def_71536,type,
    v122454: state_type > $o ).

tff(pred_def_71537,type,
    v122441: state_type > $o ).

tff(pred_def_71538,type,
    v122457: state_type > $o ).

tff(pred_def_71539,type,
    v122463: state_type > $o ).

tff(pred_def_71540,type,
    v122464: state_type > $o ).

tff(pred_def_71541,type,
    v122462: state_type > $o ).

tff(pred_def_71542,type,
    v122461: state_type > $o ).

tff(pred_def_71543,type,
    v122467: state_type > $o ).

tff(pred_def_71544,type,
    v122466: state_type > $o ).

tff(pred_def_71545,type,
    v122465: state_type > $o ).

tff(pred_def_71546,type,
    v122460: state_type > $o ).

tff(pred_def_71547,type,
    v122468: state_type > $o ).

tff(pred_def_71548,type,
    v122459: state_type > $o ).

tff(pred_def_71549,type,
    v122469: state_type > $o ).

tff(pred_def_71550,type,
    v122458: state_type > $o ).

tff(pred_def_71551,type,
    v122456: state_type > $o ).

tff(pred_def_71552,type,
    v122440: state_type > $o ).

tff(pred_def_71553,type,
    v121951: ( state_type * $int ) > $o ).

tff(pred_def_71554,type,
    v122470: ( state_type * $int ) > $o ).

tff(pred_def_71555,type,
    v122434: state_type > $o ).

tff(pred_def_71556,type,
    v121949: ( state_type * $int ) > $o ).

tff(pred_def_71557,type,
    v121947: ( state_type * $int ) > $o ).

tff(pred_def_71558,type,
    v121945: ( state_type * $int ) > $o ).

tff(pred_def_71559,type,
    v122474: state_type > $o ).

tff(pred_def_71560,type,
    v122472: state_type > $o ).

tff(pred_def_71561,type,
    v122481: state_type > $o ).

tff(pred_def_71562,type,
    v122479: state_type > $o ).

tff(pred_def_71563,type,
    v122478: state_type > $o ).

tff(pred_def_71564,type,
    v122477: state_type > $o ).

tff(pred_def_71565,type,
    v122489: state_type > $o ).

tff(pred_def_71566,type,
    v122490: state_type > $o ).

tff(pred_def_71567,type,
    v122488: state_type > $o ).

tff(pred_def_71568,type,
    v122485: ( state_type * $int ) > $o ).

tff(pred_def_71569,type,
    v122487: ( state_type * $int ) > $o ).

tff(pred_def_71570,type,
    v122476: ( state_type * $int ) > $o ).

tff(pred_def_71571,type,
    v121927: ( state_type * $int ) > $o ).

tff(pred_def_71572,type,
    v121925: ( state_type * $int ) > $o ).

tff(pred_def_71573,type,
    v122494: state_type > $o ).

tff(pred_def_71574,type,
    v122500: state_type > $o ).

tff(pred_def_71575,type,
    v122499: state_type > $o ).

tff(pred_def_71576,type,
    v122498: state_type > $o ).

tff(pred_def_71577,type,
    v122502: state_type > $o ).

tff(pred_def_71578,type,
    v122501: state_type > $o ).

tff(pred_def_71579,type,
    v122497: state_type > $o ).

tff(pred_def_71580,type,
    v122504: state_type > $o ).

tff(pred_def_71581,type,
    v122510: state_type > $o ).

tff(pred_def_71582,type,
    v122509: state_type > $o ).

tff(pred_def_71583,type,
    v122508: state_type > $o ).

tff(pred_def_71584,type,
    v122507: state_type > $o ).

tff(pred_def_71585,type,
    v122511: state_type > $o ).

tff(pred_def_71586,type,
    v122506: state_type > $o ).

tff(pred_def_71587,type,
    v122512: state_type > $o ).

tff(pred_def_71588,type,
    v122505: state_type > $o ).

tff(pred_def_71589,type,
    v122503: state_type > $o ).

tff(pred_def_71590,type,
    v122496: state_type > $o ).

tff(pred_def_71591,type,
    v122518: state_type > $o ).

tff(pred_def_71592,type,
    v122516: state_type > $o ).

tff(pred_def_71593,type,
    v122515: state_type > $o ).

tff(pred_def_71594,type,
    v122514: ( state_type * $int ) > $o ).

tff(pred_def_71595,type,
    v122528: state_type > $o ).

tff(pred_def_71596,type,
    v122527: state_type > $o ).

tff(pred_def_71597,type,
    v122526: state_type > $o ).

tff(pred_def_71598,type,
    v122525: state_type > $o ).

tff(pred_def_71599,type,
    v122530: state_type > $o ).

tff(pred_def_71600,type,
    v122531: state_type > $o ).

tff(pred_def_71601,type,
    v122529: state_type > $o ).

tff(pred_def_71602,type,
    v122524: state_type > $o ).

tff(pred_def_71603,type,
    v122534: state_type > $o ).

tff(pred_def_71604,type,
    v122533: state_type > $o ).

tff(pred_def_71605,type,
    v122535: state_type > $o ).

tff(pred_def_71606,type,
    v122532: state_type > $o ).

tff(pred_def_71607,type,
    v122523: state_type > $o ).

tff(pred_def_71608,type,
    v122539: state_type > $o ).

tff(pred_def_71609,type,
    v122538: state_type > $o ).

tff(pred_def_71610,type,
    v122537: state_type > $o ).

tff(pred_def_71611,type,
    v122540: state_type > $o ).

tff(pred_def_71612,type,
    v122536: state_type > $o ).

tff(pred_def_71613,type,
    v122522: state_type > $o ).

tff(pred_def_71614,type,
    v122547: state_type > $o ).

tff(pred_def_71615,type,
    v122545: state_type > $o ).

tff(pred_def_71616,type,
    v122544: state_type > $o ).

tff(pred_def_71617,type,
    v122543: ( state_type * $int ) > $o ).

tff(pred_def_71618,type,
    v122432: state_type > $o ).

tff(pred_def_71619,type,
    v122553: state_type > $o ).

tff(pred_def_71620,type,
    v122555: state_type > $o ).

tff(pred_def_71621,type,
    v122558: state_type > $o ).

tff(pred_def_71622,type,
    v122559: state_type > $o ).

tff(pred_def_71623,type,
    v122557: state_type > $o ).

tff(pred_def_71624,type,
    v122556: state_type > $o ).

tff(pred_def_71625,type,
    v122554: state_type > $o ).

tff(pred_def_71626,type,
    v122552: state_type > $o ).

tff(pred_def_71627,type,
    v122565: state_type > $o ).

tff(pred_def_71628,type,
    v122563: state_type > $o ).

tff(pred_def_71629,type,
    v122562: state_type > $o ).

tff(pred_def_71630,type,
    v122561: ( state_type * $int ) > $o ).

tff(pred_def_71631,type,
    v122579: state_type > $o ).

tff(pred_def_71632,type,
    v122577: state_type > $o ).

tff(pred_def_71633,type,
    v122583: state_type > $o ).

tff(pred_def_71634,type,
    v122581: state_type > $o ).

tff(pred_def_71635,type,
    v122595: state_type > $o ).

tff(pred_def_71636,type,
    v122596: state_type > $o ).

tff(pred_def_71637,type,
    v122593: state_type > $o ).

tff(pred_def_71638,type,
    v122571: ( state_type * $int ) > $o ).

tff(pred_def_71639,type,
    v122603: state_type > $o ).

tff(pred_def_71640,type,
    v122602: state_type > $o ).

tff(pred_def_71641,type,
    v122605: state_type > $o ).

tff(pred_def_71642,type,
    v122604: state_type > $o ).

tff(pred_def_71643,type,
    v122601: state_type > $o ).

tff(pred_def_71644,type,
    v122599: ( state_type * $int ) > $o ).

tff(pred_def_71645,type,
    v122569: state_type > $o ).

tff(pred_def_71646,type,
    v122598: ( state_type * $int ) > $o ).

tff(pred_def_71647,type,
    v122591: ( state_type * $int ) > $o ).

tff(pred_def_71648,type,
    v122589: ( state_type * $int ) > $o ).

tff(pred_def_71649,type,
    v122587: ( state_type * $int ) > $o ).

tff(pred_def_71650,type,
    v122585: ( state_type * $int ) > $o ).

tff(pred_def_71651,type,
    v122609: state_type > $o ).

tff(pred_def_71652,type,
    v122607: state_type > $o ).

tff(pred_def_71653,type,
    v122616: state_type > $o ).

tff(pred_def_71654,type,
    v122614: state_type > $o ).

tff(pred_def_71655,type,
    v122613: state_type > $o ).

tff(pred_def_71656,type,
    v122612: state_type > $o ).

tff(pred_def_71657,type,
    v122624: state_type > $o ).

tff(pred_def_71658,type,
    v122625: state_type > $o ).

tff(pred_def_71659,type,
    v122623: state_type > $o ).

tff(pred_def_71660,type,
    v122620: ( state_type * $int ) > $o ).

tff(pred_def_71661,type,
    v122622: ( state_type * $int ) > $o ).

tff(pred_def_71662,type,
    v122575: ( state_type * $int ) > $o ).

tff(pred_def_71663,type,
    v122573: ( state_type * $int ) > $o ).

tff(pred_def_71664,type,
    v122640: state_type > $o ).

tff(pred_def_71665,type,
    v122638: state_type > $o ).

tff(pred_def_71666,type,
    v122644: state_type > $o ).

tff(pred_def_71667,type,
    v122642: state_type > $o ).

tff(pred_def_71668,type,
    v122657: state_type > $o ).

tff(pred_def_71669,type,
    v122656: state_type > $o ).

tff(pred_def_71670,type,
    v122654: state_type > $o ).

tff(pred_def_71671,type,
    v122659: ( state_type * $int ) > $o ).

tff(pred_def_71672,type,
    v122661: state_type > $o ).

tff(pred_def_71673,type,
    v122664: ( state_type * $int ) > $o ).

tff(pred_def_71674,type,
    v122632: ( state_type * $int ) > $o ).

tff(pred_def_71675,type,
    v122679: state_type > $o ).

tff(pred_def_71676,type,
    v122678: state_type > $o ).

tff(pred_def_71677,type,
    v122677: state_type > $o ).

tff(pred_def_71678,type,
    v122680: state_type > $o ).

tff(pred_def_71679,type,
    v122676: state_type > $o ).

tff(pred_def_71680,type,
    v122675: state_type > $o ).

tff(pred_def_71681,type,
    v122681: state_type > $o ).

tff(pred_def_71682,type,
    v122674: state_type > $o ).

tff(pred_def_71683,type,
    v122673: state_type > $o ).

tff(pred_def_71684,type,
    v122672: state_type > $o ).

tff(pred_def_71685,type,
    v122671: state_type > $o ).

tff(pred_def_71686,type,
    v122683: state_type > $o ).

tff(pred_def_71687,type,
    v122682: state_type > $o ).

tff(pred_def_71688,type,
    v122670: state_type > $o ).

tff(pred_def_71689,type,
    v122686: state_type > $o ).

tff(pred_def_71690,type,
    v122685: state_type > $o ).

tff(pred_def_71691,type,
    v122687: state_type > $o ).

tff(pred_def_71692,type,
    v122684: state_type > $o ).

tff(pred_def_71693,type,
    v122690: state_type > $o ).

tff(pred_def_71694,type,
    v122689: state_type > $o ).

tff(pred_def_71695,type,
    v122691: state_type > $o ).

tff(pred_def_71696,type,
    v122688: state_type > $o ).

tff(pred_def_71697,type,
    v122694: state_type > $o ).

tff(pred_def_71698,type,
    v122693: state_type > $o ).

tff(pred_def_71699,type,
    v122695: state_type > $o ).

tff(pred_def_71700,type,
    v122692: state_type > $o ).

tff(pred_def_71701,type,
    v122668: ( state_type * $int ) > $o ).

tff(pred_def_71702,type,
    v122630: state_type > $o ).

tff(pred_def_71703,type,
    v122667: ( state_type * $int ) > $o ).

tff(pred_def_71704,type,
    v122666: ( state_type * $int ) > $o ).

tff(pred_def_71705,type,
    v122652: ( state_type * $int ) > $o ).

tff(pred_def_71706,type,
    v122650: ( state_type * $int ) > $o ).

tff(pred_def_71707,type,
    v122648: ( state_type * $int ) > $o ).

tff(pred_def_71708,type,
    v122646: ( state_type * $int ) > $o ).

tff(pred_def_71709,type,
    v122699: state_type > $o ).

tff(pred_def_71710,type,
    v122697: state_type > $o ).

tff(pred_def_71711,type,
    v122706: state_type > $o ).

tff(pred_def_71712,type,
    v122704: state_type > $o ).

tff(pred_def_71713,type,
    v122703: state_type > $o ).

tff(pred_def_71714,type,
    v122702: state_type > $o ).

tff(pred_def_71715,type,
    v122714: state_type > $o ).

tff(pred_def_71716,type,
    v122715: state_type > $o ).

tff(pred_def_71717,type,
    v122713: state_type > $o ).

tff(pred_def_71718,type,
    v122710: ( state_type * $int ) > $o ).

tff(pred_def_71719,type,
    v122712: ( state_type * $int ) > $o ).

tff(pred_def_71720,type,
    v122636: ( state_type * $int ) > $o ).

tff(pred_def_71721,type,
    v122634: ( state_type * $int ) > $o ).

tff(pred_def_71722,type,
    v122720: state_type > $o ).

tff(pred_def_71723,type,
    v121921: state_type > $o ).

tff(pred_def_71724,type,
    v122736: state_type > $o ).

tff(pred_def_71725,type,
    v122734: state_type > $o ).

tff(pred_def_71726,type,
    v122732: state_type > $o ).

tff(pred_def_71727,type,
    v122730: state_type > $o ).

tff(pred_def_71728,type,
    v122744: state_type > $o ).

tff(pred_def_71729,type,
    v122742: state_type > $o ).

tff(pred_def_71730,type,
    v122740: state_type > $o ).

tff(pred_def_71731,type,
    v122738: state_type > $o ).

tff(pred_def_71732,type,
    v122764: state_type > $o ).

tff(pred_def_71733,type,
    v122762: state_type > $o ).

tff(pred_def_71734,type,
    v122768: state_type > $o ).

tff(pred_def_71735,type,
    v122766: state_type > $o ).

tff(pred_def_71736,type,
    v122780: state_type > $o ).

tff(pred_def_71737,type,
    v122782: state_type > $o ).

tff(pred_def_71738,type,
    v122784: state_type > $o ).

tff(pred_def_71739,type,
    v122786: state_type > $o ).

tff(pred_def_71740,type,
    v122788: state_type > $o ).

tff(pred_def_71741,type,
    v122790: state_type > $o ).

tff(pred_def_71742,type,
    v122792: state_type > $o ).

tff(pred_def_71743,type,
    v122841: ( state_type * $int ) > $o ).

tff(pred_def_71744,type,
    v122842: ( state_type * $int ) > $o ).

tff(pred_def_71745,type,
    v122840: state_type > $o ).

tff(pred_def_71746,type,
    v122845: state_type > $o ).

tff(pred_def_71747,type,
    v122846: state_type > $o ).

tff(pred_def_71748,type,
    v122844: state_type > $o ).

tff(pred_def_71749,type,
    v122847: state_type > $o ).

tff(pred_def_71750,type,
    v122843: state_type > $o ).

tff(pred_def_71751,type,
    v122839: state_type > $o ).

tff(pred_def_71752,type,
    v122848: state_type > $o ).

tff(pred_def_71753,type,
    v122838: state_type > $o ).

tff(pred_def_71754,type,
    v122837: state_type > $o ).

tff(pred_def_71755,type,
    v122852: state_type > $o ).

tff(pred_def_71756,type,
    v122853: state_type > $o ).

tff(pred_def_71757,type,
    v122851: state_type > $o ).

tff(pred_def_71758,type,
    v122854: state_type > $o ).

tff(pred_def_71759,type,
    v122850: state_type > $o ).

tff(pred_def_71760,type,
    v122849: state_type > $o ).

tff(pred_def_71761,type,
    v122836: state_type > $o ).

tff(pred_def_71762,type,
    v122855: state_type > $o ).

tff(pred_def_71763,type,
    v122835: state_type > $o ).

tff(pred_def_71764,type,
    v122858: state_type > $o ).

tff(pred_def_71765,type,
    v122859: state_type > $o ).

tff(pred_def_71766,type,
    v122857: state_type > $o ).

tff(pred_def_71767,type,
    v122860: state_type > $o ).

tff(pred_def_71768,type,
    v122856: state_type > $o ).

tff(pred_def_71769,type,
    v122863: state_type > $o ).

tff(pred_def_71770,type,
    v122864: state_type > $o ).

tff(pred_def_71771,type,
    v122862: state_type > $o ).

tff(pred_def_71772,type,
    v122865: state_type > $o ).

tff(pred_def_71773,type,
    v122861: state_type > $o ).

tff(pred_def_71774,type,
    v122833: ( state_type * $int ) > $o ).

tff(pred_def_71775,type,
    v122866: ( state_type * $int ) > $o ).

tff(pred_def_71776,type,
    v122832: state_type > $o ).

tff(pred_def_71777,type,
    v122869: state_type > $o ).

tff(pred_def_71778,type,
    v122870: state_type > $o ).

tff(pred_def_71779,type,
    v122868: state_type > $o ).

tff(pred_def_71780,type,
    v122871: state_type > $o ).

tff(pred_def_71781,type,
    v122867: state_type > $o ).

tff(pred_def_71782,type,
    v122831: state_type > $o ).

tff(pred_def_71783,type,
    v122872: state_type > $o ).

tff(pred_def_71784,type,
    v122830: state_type > $o ).

tff(pred_def_71785,type,
    v122829: state_type > $o ).

tff(pred_def_71786,type,
    v122876: state_type > $o ).

tff(pred_def_71787,type,
    v122877: state_type > $o ).

tff(pred_def_71788,type,
    v122875: state_type > $o ).

tff(pred_def_71789,type,
    v122878: state_type > $o ).

tff(pred_def_71790,type,
    v122874: state_type > $o ).

tff(pred_def_71791,type,
    v122873: state_type > $o ).

tff(pred_def_71792,type,
    v122828: state_type > $o ).

tff(pred_def_71793,type,
    v122879: state_type > $o ).

tff(pred_def_71794,type,
    v122827: state_type > $o ).

tff(pred_def_71795,type,
    v122882: state_type > $o ).

tff(pred_def_71796,type,
    v122883: state_type > $o ).

tff(pred_def_71797,type,
    v122881: state_type > $o ).

tff(pred_def_71798,type,
    v122884: state_type > $o ).

tff(pred_def_71799,type,
    v122880: state_type > $o ).

tff(pred_def_71800,type,
    v122887: state_type > $o ).

tff(pred_def_71801,type,
    v122888: state_type > $o ).

tff(pred_def_71802,type,
    v122886: state_type > $o ).

tff(pred_def_71803,type,
    v122889: state_type > $o ).

tff(pred_def_71804,type,
    v122885: state_type > $o ).

tff(pred_def_71805,type,
    v122825: ( state_type * $int ) > $o ).

tff(pred_def_71806,type,
    v122890: ( state_type * $int ) > $o ).

tff(pred_def_71807,type,
    v122824: state_type > $o ).

tff(pred_def_71808,type,
    v122893: state_type > $o ).

tff(pred_def_71809,type,
    v122894: state_type > $o ).

tff(pred_def_71810,type,
    v122892: state_type > $o ).

tff(pred_def_71811,type,
    v122895: state_type > $o ).

tff(pred_def_71812,type,
    v122891: state_type > $o ).

tff(pred_def_71813,type,
    v122823: state_type > $o ).

tff(pred_def_71814,type,
    v122896: state_type > $o ).

tff(pred_def_71815,type,
    v122822: state_type > $o ).

tff(pred_def_71816,type,
    v122821: state_type > $o ).

tff(pred_def_71817,type,
    v122900: state_type > $o ).

tff(pred_def_71818,type,
    v122901: state_type > $o ).

tff(pred_def_71819,type,
    v122899: state_type > $o ).

tff(pred_def_71820,type,
    v122902: state_type > $o ).

tff(pred_def_71821,type,
    v122898: state_type > $o ).

tff(pred_def_71822,type,
    v122897: state_type > $o ).

tff(pred_def_71823,type,
    v122820: state_type > $o ).

tff(pred_def_71824,type,
    v122903: state_type > $o ).

tff(pred_def_71825,type,
    v122819: state_type > $o ).

tff(pred_def_71826,type,
    v122906: state_type > $o ).

tff(pred_def_71827,type,
    v122907: state_type > $o ).

tff(pred_def_71828,type,
    v122905: state_type > $o ).

tff(pred_def_71829,type,
    v122908: state_type > $o ).

tff(pred_def_71830,type,
    v122904: state_type > $o ).

tff(pred_def_71831,type,
    v122911: state_type > $o ).

tff(pred_def_71832,type,
    v122912: state_type > $o ).

tff(pred_def_71833,type,
    v122910: state_type > $o ).

tff(pred_def_71834,type,
    v122913: state_type > $o ).

tff(pred_def_71835,type,
    v122909: state_type > $o ).

tff(pred_def_71836,type,
    v122817: ( state_type * $int ) > $o ).

tff(pred_def_71837,type,
    v122914: ( state_type * $int ) > $o ).

tff(pred_def_71838,type,
    v122816: state_type > $o ).

tff(pred_def_71839,type,
    v122917: state_type > $o ).

tff(pred_def_71840,type,
    v122918: state_type > $o ).

tff(pred_def_71841,type,
    v122916: state_type > $o ).

tff(pred_def_71842,type,
    v122919: state_type > $o ).

tff(pred_def_71843,type,
    v122915: state_type > $o ).

tff(pred_def_71844,type,
    v122815: state_type > $o ).

tff(pred_def_71845,type,
    v122920: state_type > $o ).

tff(pred_def_71846,type,
    v122814: state_type > $o ).

tff(pred_def_71847,type,
    v122813: state_type > $o ).

tff(pred_def_71848,type,
    v122924: state_type > $o ).

tff(pred_def_71849,type,
    v122925: state_type > $o ).

tff(pred_def_71850,type,
    v122923: state_type > $o ).

tff(pred_def_71851,type,
    v122926: state_type > $o ).

tff(pred_def_71852,type,
    v122922: state_type > $o ).

tff(pred_def_71853,type,
    v122921: state_type > $o ).

tff(pred_def_71854,type,
    v122812: state_type > $o ).

tff(pred_def_71855,type,
    v122927: state_type > $o ).

tff(pred_def_71856,type,
    v122811: state_type > $o ).

tff(pred_def_71857,type,
    v122930: state_type > $o ).

tff(pred_def_71858,type,
    v122931: state_type > $o ).

tff(pred_def_71859,type,
    v122929: state_type > $o ).

tff(pred_def_71860,type,
    v122932: state_type > $o ).

tff(pred_def_71861,type,
    v122928: state_type > $o ).

tff(pred_def_71862,type,
    v122935: state_type > $o ).

tff(pred_def_71863,type,
    v122936: state_type > $o ).

tff(pred_def_71864,type,
    v122934: state_type > $o ).

tff(pred_def_71865,type,
    v122937: state_type > $o ).

tff(pred_def_71866,type,
    v122933: state_type > $o ).

tff(pred_def_71867,type,
    v122809: ( state_type * $int ) > $o ).

tff(pred_def_71868,type,
    v122938: ( state_type * $int ) > $o ).

tff(pred_def_71869,type,
    v122808: state_type > $o ).

tff(pred_def_71870,type,
    v122941: state_type > $o ).

tff(pred_def_71871,type,
    v122942: state_type > $o ).

tff(pred_def_71872,type,
    v122940: state_type > $o ).

tff(pred_def_71873,type,
    v122943: state_type > $o ).

tff(pred_def_71874,type,
    v122939: state_type > $o ).

tff(pred_def_71875,type,
    v122807: state_type > $o ).

tff(pred_def_71876,type,
    v122944: state_type > $o ).

tff(pred_def_71877,type,
    v122806: state_type > $o ).

tff(pred_def_71878,type,
    v122805: state_type > $o ).

tff(pred_def_71879,type,
    v122948: state_type > $o ).

tff(pred_def_71880,type,
    v122949: state_type > $o ).

tff(pred_def_71881,type,
    v122947: state_type > $o ).

tff(pred_def_71882,type,
    v122950: state_type > $o ).

tff(pred_def_71883,type,
    v122946: state_type > $o ).

tff(pred_def_71884,type,
    v122945: state_type > $o ).

tff(pred_def_71885,type,
    v122804: state_type > $o ).

tff(pred_def_71886,type,
    v122951: state_type > $o ).

tff(pred_def_71887,type,
    v122803: state_type > $o ).

tff(pred_def_71888,type,
    v122954: state_type > $o ).

tff(pred_def_71889,type,
    v122955: state_type > $o ).

tff(pred_def_71890,type,
    v122953: state_type > $o ).

tff(pred_def_71891,type,
    v122956: state_type > $o ).

tff(pred_def_71892,type,
    v122952: state_type > $o ).

tff(pred_def_71893,type,
    v122959: state_type > $o ).

tff(pred_def_71894,type,
    v122960: state_type > $o ).

tff(pred_def_71895,type,
    v122958: state_type > $o ).

tff(pred_def_71896,type,
    v122961: state_type > $o ).

tff(pred_def_71897,type,
    v122957: state_type > $o ).

tff(pred_def_71898,type,
    v122801: ( state_type * $int ) > $o ).

tff(pred_def_71899,type,
    v122962: ( state_type * $int ) > $o ).

tff(pred_def_71900,type,
    v122800: state_type > $o ).

tff(pred_def_71901,type,
    v122965: state_type > $o ).

tff(pred_def_71902,type,
    v122966: state_type > $o ).

tff(pred_def_71903,type,
    v122964: state_type > $o ).

tff(pred_def_71904,type,
    v122967: state_type > $o ).

tff(pred_def_71905,type,
    v122963: state_type > $o ).

tff(pred_def_71906,type,
    v122799: state_type > $o ).

tff(pred_def_71907,type,
    v122968: state_type > $o ).

tff(pred_def_71908,type,
    v122798: state_type > $o ).

tff(pred_def_71909,type,
    v122797: state_type > $o ).

tff(pred_def_71910,type,
    v122972: state_type > $o ).

tff(pred_def_71911,type,
    v122973: state_type > $o ).

tff(pred_def_71912,type,
    v122971: state_type > $o ).

tff(pred_def_71913,type,
    v122974: state_type > $o ).

tff(pred_def_71914,type,
    v122970: state_type > $o ).

tff(pred_def_71915,type,
    v122969: state_type > $o ).

tff(pred_def_71916,type,
    v122796: state_type > $o ).

tff(pred_def_71917,type,
    v122975: state_type > $o ).

tff(pred_def_71918,type,
    v122795: state_type > $o ).

tff(pred_def_71919,type,
    v122978: state_type > $o ).

tff(pred_def_71920,type,
    v122979: state_type > $o ).

tff(pred_def_71921,type,
    v122977: state_type > $o ).

tff(pred_def_71922,type,
    v122980: state_type > $o ).

tff(pred_def_71923,type,
    v122976: state_type > $o ).

tff(pred_def_71924,type,
    v122983: state_type > $o ).

tff(pred_def_71925,type,
    v122984: state_type > $o ).

tff(pred_def_71926,type,
    v122982: state_type > $o ).

tff(pred_def_71927,type,
    v122985: state_type > $o ).

tff(pred_def_71928,type,
    v122981: state_type > $o ).

tff(pred_def_71929,type,
    v122793: ( state_type * $int ) > $o ).

tff(pred_def_71930,type,
    v122778: ( state_type * $int ) > $o ).

tff(pred_def_71931,type,
    v122995: state_type > $o ).

tff(pred_def_71932,type,
    v122993: state_type > $o ).

tff(pred_def_71933,type,
    v122992: state_type > $o ).

tff(pred_def_71934,type,
    v122991: ( state_type * $int ) > $o ).

tff(pred_def_71935,type,
    v122989: state_type > $o ).

tff(pred_def_71936,type,
    v123005: state_type > $o ).

tff(pred_def_71937,type,
    v123003: state_type > $o ).

tff(pred_def_71938,type,
    v123002: state_type > $o ).

tff(pred_def_71939,type,
    v123001: ( state_type * $int ) > $o ).

tff(pred_def_71940,type,
    v122999: state_type > $o ).

tff(pred_def_71941,type,
    v123015: state_type > $o ).

tff(pred_def_71942,type,
    v123013: state_type > $o ).

tff(pred_def_71943,type,
    v123012: state_type > $o ).

tff(pred_def_71944,type,
    v123011: ( state_type * $int ) > $o ).

tff(pred_def_71945,type,
    v123009: state_type > $o ).

tff(pred_def_71946,type,
    v123019: state_type > $o ).

tff(pred_def_71947,type,
    v123021: state_type > $o ).

tff(pred_def_71948,type,
    v123023: state_type > $o ).

tff(pred_def_71949,type,
    v123029: state_type > $o ).

tff(pred_def_71950,type,
    v123028: state_type > $o ).

tff(pred_def_71951,type,
    v123027: state_type > $o ).

tff(pred_def_71952,type,
    v123026: state_type > $o ).

tff(pred_def_71953,type,
    v123025: state_type > $o ).

tff(pred_def_71954,type,
    v123024: ( state_type * $int ) > $o ).

tff(pred_def_71955,type,
    v122987: ( state_type * $int ) > $o ).

tff(pred_def_71956,type,
    v123058: ( state_type * $int ) > $o ).

tff(pred_def_71957,type,
    v122756: ( state_type * $int ) > $o ).

tff(pred_def_71958,type,
    v123057: state_type > $o ).

tff(pred_def_71959,type,
    v123061: state_type > $o ).

tff(pred_def_71960,type,
    v123062: state_type > $o ).

tff(pred_def_71961,type,
    v123060: state_type > $o ).

tff(pred_def_71962,type,
    v123063: state_type > $o ).

tff(pred_def_71963,type,
    v123059: state_type > $o ).

tff(pred_def_71964,type,
    v123056: state_type > $o ).

tff(pred_def_71965,type,
    v123064: state_type > $o ).

tff(pred_def_71966,type,
    v123055: state_type > $o ).

tff(pred_def_71967,type,
    v123067: state_type > $o ).

tff(pred_def_71968,type,
    v123068: state_type > $o ).

tff(pred_def_71969,type,
    v123066: state_type > $o ).

tff(pred_def_71970,type,
    v123069: state_type > $o ).

tff(pred_def_71971,type,
    v123065: state_type > $o ).

tff(pred_def_71972,type,
    v123054: state_type > $o ).

tff(pred_def_71973,type,
    v123070: state_type > $o ).

tff(pred_def_71974,type,
    v123053: state_type > $o ).

tff(pred_def_71975,type,
    v123073: state_type > $o ).

tff(pred_def_71976,type,
    v123074: state_type > $o ).

tff(pred_def_71977,type,
    v123072: state_type > $o ).

tff(pred_def_71978,type,
    v123075: state_type > $o ).

tff(pred_def_71979,type,
    v123071: state_type > $o ).

tff(pred_def_71980,type,
    v123052: state_type > $o ).

tff(pred_def_71981,type,
    v123076: state_type > $o ).

tff(pred_def_71982,type,
    v123051: state_type > $o ).

tff(pred_def_71983,type,
    v123079: state_type > $o ).

tff(pred_def_71984,type,
    v123080: state_type > $o ).

tff(pred_def_71985,type,
    v123078: state_type > $o ).

tff(pred_def_71986,type,
    v123081: state_type > $o ).

tff(pred_def_71987,type,
    v123077: state_type > $o ).

tff(pred_def_71988,type,
    v123050: state_type > $o ).

tff(pred_def_71989,type,
    v123082: state_type > $o ).

tff(pred_def_71990,type,
    v123049: state_type > $o ).

tff(pred_def_71991,type,
    v123048: state_type > $o ).

tff(pred_def_71992,type,
    v123086: state_type > $o ).

tff(pred_def_71993,type,
    v123087: state_type > $o ).

tff(pred_def_71994,type,
    v123085: state_type > $o ).

tff(pred_def_71995,type,
    v123088: state_type > $o ).

tff(pred_def_71996,type,
    v123084: state_type > $o ).

tff(pred_def_71997,type,
    v123083: state_type > $o ).

tff(pred_def_71998,type,
    v123047: state_type > $o ).

tff(pred_def_71999,type,
    v123089: state_type > $o ).

tff(pred_def_72000,type,
    v123046: state_type > $o ).

tff(pred_def_72001,type,
    v123092: state_type > $o ).

tff(pred_def_72002,type,
    v123093: state_type > $o ).

tff(pred_def_72003,type,
    v123091: state_type > $o ).

tff(pred_def_72004,type,
    v123094: state_type > $o ).

tff(pred_def_72005,type,
    v123090: state_type > $o ).

tff(pred_def_72006,type,
    v123097: state_type > $o ).

tff(pred_def_72007,type,
    v123098: state_type > $o ).

tff(pred_def_72008,type,
    v123096: state_type > $o ).

tff(pred_def_72009,type,
    v123099: state_type > $o ).

tff(pred_def_72010,type,
    v123095: state_type > $o ).

tff(pred_def_72011,type,
    v123102: state_type > $o ).

tff(pred_def_72012,type,
    v123103: state_type > $o ).

tff(pred_def_72013,type,
    v123101: state_type > $o ).

tff(pred_def_72014,type,
    v123104: state_type > $o ).

tff(pred_def_72015,type,
    v123100: state_type > $o ).

tff(pred_def_72016,type,
    v123107: state_type > $o ).

tff(pred_def_72017,type,
    v123108: state_type > $o ).

tff(pred_def_72018,type,
    v123106: state_type > $o ).

tff(pred_def_72019,type,
    v123109: state_type > $o ).

tff(pred_def_72020,type,
    v123105: state_type > $o ).

tff(pred_def_72021,type,
    v123112: state_type > $o ).

tff(pred_def_72022,type,
    v123113: state_type > $o ).

tff(pred_def_72023,type,
    v123111: state_type > $o ).

tff(pred_def_72024,type,
    v123114: state_type > $o ).

tff(pred_def_72025,type,
    v123110: state_type > $o ).

tff(pred_def_72026,type,
    v123044: ( state_type * $int ) > $o ).

tff(pred_def_72027,type,
    v123043: state_type > $o ).

tff(pred_def_72028,type,
    v123119: state_type > $o ).

tff(pred_def_72029,type,
    v123121: state_type > $o ).

tff(pred_def_72030,type,
    v123122: state_type > $o ).

tff(pred_def_72031,type,
    v123120: state_type > $o ).

tff(pred_def_72032,type,
    v123118: state_type > $o ).

tff(pred_def_72033,type,
    v123117: state_type > $o ).

tff(pred_def_72034,type,
    v123123: state_type > $o ).

tff(pred_def_72035,type,
    v123116: state_type > $o ).

tff(pred_def_72036,type,
    v123124: state_type > $o ).

tff(pred_def_72037,type,
    v123115: state_type > $o ).

tff(pred_def_72038,type,
    v123042: state_type > $o ).

tff(pred_def_72039,type,
    v123125: state_type > $o ).

tff(pred_def_72040,type,
    v123041: state_type > $o ).

tff(pred_def_72041,type,
    v123132: state_type > $o ).

tff(pred_def_72042,type,
    v123131: state_type > $o ).

tff(pred_def_72043,type,
    v123130: state_type > $o ).

tff(pred_def_72044,type,
    v123134: state_type > $o ).

tff(pred_def_72045,type,
    v123133: state_type > $o ).

tff(pred_def_72046,type,
    v123129: state_type > $o ).

tff(pred_def_72047,type,
    v123128: state_type > $o ).

tff(pred_def_72048,type,
    v123135: state_type > $o ).

tff(pred_def_72049,type,
    v123127: state_type > $o ).

tff(pred_def_72050,type,
    v123136: state_type > $o ).

tff(pred_def_72051,type,
    v123126: state_type > $o ).

tff(pred_def_72052,type,
    v123040: state_type > $o ).

tff(pred_def_72053,type,
    v123137: state_type > $o ).

tff(pred_def_72054,type,
    v123039: state_type > $o ).

tff(pred_def_72055,type,
    v123144: state_type > $o ).

tff(pred_def_72056,type,
    v123143: state_type > $o ).

tff(pred_def_72057,type,
    v123142: state_type > $o ).

tff(pred_def_72058,type,
    v123146: state_type > $o ).

tff(pred_def_72059,type,
    v123145: state_type > $o ).

tff(pred_def_72060,type,
    v123141: state_type > $o ).

tff(pred_def_72061,type,
    v123140: state_type > $o ).

tff(pred_def_72062,type,
    v123147: state_type > $o ).

tff(pred_def_72063,type,
    v123139: state_type > $o ).

tff(pred_def_72064,type,
    v123148: state_type > $o ).

tff(pred_def_72065,type,
    v123138: state_type > $o ).

tff(pred_def_72066,type,
    v123038: state_type > $o ).

tff(pred_def_72067,type,
    v123149: state_type > $o ).

tff(pred_def_72068,type,
    v123037: state_type > $o ).

tff(pred_def_72069,type,
    v123156: state_type > $o ).

tff(pred_def_72070,type,
    v123155: state_type > $o ).

tff(pred_def_72071,type,
    v123154: state_type > $o ).

tff(pred_def_72072,type,
    v123158: state_type > $o ).

tff(pred_def_72073,type,
    v123157: state_type > $o ).

tff(pred_def_72074,type,
    v123153: state_type > $o ).

tff(pred_def_72075,type,
    v123152: state_type > $o ).

tff(pred_def_72076,type,
    v123159: state_type > $o ).

tff(pred_def_72077,type,
    v123151: state_type > $o ).

tff(pred_def_72078,type,
    v123160: state_type > $o ).

tff(pred_def_72079,type,
    v123150: state_type > $o ).

tff(pred_def_72080,type,
    v123036: state_type > $o ).

tff(pred_def_72081,type,
    v123161: state_type > $o ).

tff(pred_def_72082,type,
    v123035: state_type > $o ).

tff(pred_def_72083,type,
    v123034: state_type > $o ).

tff(pred_def_72084,type,
    v123169: state_type > $o ).

tff(pred_def_72085,type,
    v123168: state_type > $o ).

tff(pred_def_72086,type,
    v123167: state_type > $o ).

tff(pred_def_72087,type,
    v123171: state_type > $o ).

tff(pred_def_72088,type,
    v123170: state_type > $o ).

tff(pred_def_72089,type,
    v123166: state_type > $o ).

tff(pred_def_72090,type,
    v123165: state_type > $o ).

tff(pred_def_72091,type,
    v123172: state_type > $o ).

tff(pred_def_72092,type,
    v123164: state_type > $o ).

tff(pred_def_72093,type,
    v123173: state_type > $o ).

tff(pred_def_72094,type,
    v123163: state_type > $o ).

tff(pred_def_72095,type,
    v123162: state_type > $o ).

tff(pred_def_72096,type,
    v123033: state_type > $o ).

tff(pred_def_72097,type,
    v123174: state_type > $o ).

tff(pred_def_72098,type,
    v123032: state_type > $o ).

tff(pred_def_72099,type,
    v123177: state_type > $o ).

tff(pred_def_72100,type,
    v123178: state_type > $o ).

tff(pred_def_72101,type,
    v123176: state_type > $o ).

tff(pred_def_72102,type,
    v123179: state_type > $o ).

tff(pred_def_72103,type,
    v123175: state_type > $o ).

tff(pred_def_72104,type,
    v123182: state_type > $o ).

tff(pred_def_72105,type,
    v123183: state_type > $o ).

tff(pred_def_72106,type,
    v123181: state_type > $o ).

tff(pred_def_72107,type,
    v123184: state_type > $o ).

tff(pred_def_72108,type,
    v123180: state_type > $o ).

tff(pred_def_72109,type,
    v123187: state_type > $o ).

tff(pred_def_72110,type,
    v123188: state_type > $o ).

tff(pred_def_72111,type,
    v123186: state_type > $o ).

tff(pred_def_72112,type,
    v123189: state_type > $o ).

tff(pred_def_72113,type,
    v123185: state_type > $o ).

tff(pred_def_72114,type,
    v123192: state_type > $o ).

tff(pred_def_72115,type,
    v123193: state_type > $o ).

tff(pred_def_72116,type,
    v123191: state_type > $o ).

tff(pred_def_72117,type,
    v123194: state_type > $o ).

tff(pred_def_72118,type,
    v123190: state_type > $o ).

tff(pred_def_72119,type,
    v123197: state_type > $o ).

tff(pred_def_72120,type,
    v123196: state_type > $o ).

tff(pred_def_72121,type,
    v123198: state_type > $o ).

tff(pred_def_72122,type,
    v123195: state_type > $o ).

tff(pred_def_72123,type,
    v122776: ( state_type * $int ) > $o ).

tff(pred_def_72124,type,
    v122774: ( state_type * $int ) > $o ).

tff(pred_def_72125,type,
    v122772: ( state_type * $int ) > $o ).

tff(pred_def_72126,type,
    v122770: ( state_type * $int ) > $o ).

tff(pred_def_72127,type,
    v123204: state_type > $o ).

tff(pred_def_72128,type,
    v123202: state_type > $o ).

tff(pred_def_72129,type,
    v123200: state_type > $o ).

tff(pred_def_72130,type,
    v123211: state_type > $o ).

tff(pred_def_72131,type,
    v123209: state_type > $o ).

tff(pred_def_72132,type,
    v123208: state_type > $o ).

tff(pred_def_72133,type,
    v123207: state_type > $o ).

tff(pred_def_72134,type,
    v123219: state_type > $o ).

tff(pred_def_72135,type,
    v123220: state_type > $o ).

tff(pred_def_72136,type,
    v123218: state_type > $o ).

tff(pred_def_72137,type,
    v123215: ( state_type * $int ) > $o ).

tff(pred_def_72138,type,
    v123217: ( state_type * $int ) > $o ).

tff(pred_def_72139,type,
    v122760: ( state_type * $int ) > $o ).

tff(pred_def_72140,type,
    v122758: ( state_type * $int ) > $o ).

tff(pred_def_72141,type,
    v123224: state_type > $o ).

tff(pred_def_72142,type,
    v123226: state_type > $o ).

tff(pred_def_72143,type,
    v123227: state_type > $o ).

tff(pred_def_72144,type,
    v122754: state_type > $o ).

tff(pred_def_72145,type,
    v123229: state_type > $o ).

tff(pred_def_72146,type,
    v123231: state_type > $o ).

tff(pred_def_72147,type,
    v123237: state_type > $o ).

tff(pred_def_72148,type,
    v123239: state_type > $o ).

tff(pred_def_72149,type,
    v123249: state_type > $o ).

tff(pred_def_72150,type,
    v123250: state_type > $o ).

tff(pred_def_72151,type,
    v123248: state_type > $o ).

tff(pred_def_72152,type,
    v123252: state_type > $o ).

tff(pred_def_72153,type,
    v123253: state_type > $o ).

tff(pred_def_72154,type,
    v123251: state_type > $o ).

tff(pred_def_72155,type,
    v123247: state_type > $o ).

tff(pred_def_72156,type,
    v123246: state_type > $o ).

tff(pred_def_72157,type,
    v123245: state_type > $o ).

tff(pred_def_72158,type,
    v123244: state_type > $o ).

tff(pred_def_72159,type,
    v122724: ( state_type * $int ) > $o ).

tff(pred_def_72160,type,
    v123254: state_type > $o ).

tff(pred_def_72161,type,
    v123243: state_type > $o ).

tff(pred_def_72162,type,
    v123256: state_type > $o ).

tff(pred_def_72163,type,
    v123255: state_type > $o ).

tff(pred_def_72164,type,
    v123242: state_type > $o ).

tff(pred_def_72165,type,
    v123258: state_type > $o ).

tff(pred_def_72166,type,
    v123264: state_type > $o ).

tff(pred_def_72167,type,
    v123265: state_type > $o ).

tff(pred_def_72168,type,
    v123263: state_type > $o ).

tff(pred_def_72169,type,
    v123262: state_type > $o ).

tff(pred_def_72170,type,
    v123268: state_type > $o ).

tff(pred_def_72171,type,
    v123267: state_type > $o ).

tff(pred_def_72172,type,
    v123266: state_type > $o ).

tff(pred_def_72173,type,
    v123261: state_type > $o ).

tff(pred_def_72174,type,
    v123269: state_type > $o ).

tff(pred_def_72175,type,
    v123260: state_type > $o ).

tff(pred_def_72176,type,
    v123270: state_type > $o ).

tff(pred_def_72177,type,
    v123259: state_type > $o ).

tff(pred_def_72178,type,
    v123257: state_type > $o ).

tff(pred_def_72179,type,
    v123241: state_type > $o ).

tff(pred_def_72180,type,
    v122752: ( state_type * $int ) > $o ).

tff(pred_def_72181,type,
    v123271: ( state_type * $int ) > $o ).

tff(pred_def_72182,type,
    v123235: state_type > $o ).

tff(pred_def_72183,type,
    v122750: ( state_type * $int ) > $o ).

tff(pred_def_72184,type,
    v122748: ( state_type * $int ) > $o ).

tff(pred_def_72185,type,
    v122746: ( state_type * $int ) > $o ).

tff(pred_def_72186,type,
    v123275: state_type > $o ).

tff(pred_def_72187,type,
    v123273: state_type > $o ).

tff(pred_def_72188,type,
    v123282: state_type > $o ).

tff(pred_def_72189,type,
    v123280: state_type > $o ).

tff(pred_def_72190,type,
    v123279: state_type > $o ).

tff(pred_def_72191,type,
    v123278: state_type > $o ).

tff(pred_def_72192,type,
    v123290: state_type > $o ).

tff(pred_def_72193,type,
    v123291: state_type > $o ).

tff(pred_def_72194,type,
    v123289: state_type > $o ).

tff(pred_def_72195,type,
    v123286: ( state_type * $int ) > $o ).

tff(pred_def_72196,type,
    v123288: ( state_type * $int ) > $o ).

tff(pred_def_72197,type,
    v123277: ( state_type * $int ) > $o ).

tff(pred_def_72198,type,
    v122728: ( state_type * $int ) > $o ).

tff(pred_def_72199,type,
    v122726: ( state_type * $int ) > $o ).

tff(pred_def_72200,type,
    v123295: state_type > $o ).

tff(pred_def_72201,type,
    v123301: state_type > $o ).

tff(pred_def_72202,type,
    v123300: state_type > $o ).

tff(pred_def_72203,type,
    v123299: state_type > $o ).

tff(pred_def_72204,type,
    v123303: state_type > $o ).

tff(pred_def_72205,type,
    v123302: state_type > $o ).

tff(pred_def_72206,type,
    v123298: state_type > $o ).

tff(pred_def_72207,type,
    v123305: state_type > $o ).

tff(pred_def_72208,type,
    v123311: state_type > $o ).

tff(pred_def_72209,type,
    v123310: state_type > $o ).

tff(pred_def_72210,type,
    v123309: state_type > $o ).

tff(pred_def_72211,type,
    v123308: state_type > $o ).

tff(pred_def_72212,type,
    v123312: state_type > $o ).

tff(pred_def_72213,type,
    v123307: state_type > $o ).

tff(pred_def_72214,type,
    v123313: state_type > $o ).

tff(pred_def_72215,type,
    v123306: state_type > $o ).

tff(pred_def_72216,type,
    v123304: state_type > $o ).

tff(pred_def_72217,type,
    v123297: state_type > $o ).

tff(pred_def_72218,type,
    v123319: state_type > $o ).

tff(pred_def_72219,type,
    v123317: state_type > $o ).

tff(pred_def_72220,type,
    v123316: state_type > $o ).

tff(pred_def_72221,type,
    v123315: ( state_type * $int ) > $o ).

tff(pred_def_72222,type,
    v123329: state_type > $o ).

tff(pred_def_72223,type,
    v123328: state_type > $o ).

tff(pred_def_72224,type,
    v123327: state_type > $o ).

tff(pred_def_72225,type,
    v123326: state_type > $o ).

tff(pred_def_72226,type,
    v123331: state_type > $o ).

tff(pred_def_72227,type,
    v123332: state_type > $o ).

tff(pred_def_72228,type,
    v123330: state_type > $o ).

tff(pred_def_72229,type,
    v123325: state_type > $o ).

tff(pred_def_72230,type,
    v123335: state_type > $o ).

tff(pred_def_72231,type,
    v123334: state_type > $o ).

tff(pred_def_72232,type,
    v123336: state_type > $o ).

tff(pred_def_72233,type,
    v123333: state_type > $o ).

tff(pred_def_72234,type,
    v123324: state_type > $o ).

tff(pred_def_72235,type,
    v123340: state_type > $o ).

tff(pred_def_72236,type,
    v123339: state_type > $o ).

tff(pred_def_72237,type,
    v123338: state_type > $o ).

tff(pred_def_72238,type,
    v123341: state_type > $o ).

tff(pred_def_72239,type,
    v123337: state_type > $o ).

tff(pred_def_72240,type,
    v123323: state_type > $o ).

tff(pred_def_72241,type,
    v123348: state_type > $o ).

tff(pred_def_72242,type,
    v123346: state_type > $o ).

tff(pred_def_72243,type,
    v123345: state_type > $o ).

tff(pred_def_72244,type,
    v123344: ( state_type * $int ) > $o ).

tff(pred_def_72245,type,
    v123233: state_type > $o ).

tff(pred_def_72246,type,
    v123354: state_type > $o ).

tff(pred_def_72247,type,
    v123356: state_type > $o ).

tff(pred_def_72248,type,
    v123359: state_type > $o ).

tff(pred_def_72249,type,
    v123360: state_type > $o ).

tff(pred_def_72250,type,
    v123358: state_type > $o ).

tff(pred_def_72251,type,
    v123357: state_type > $o ).

tff(pred_def_72252,type,
    v123355: state_type > $o ).

tff(pred_def_72253,type,
    v123353: state_type > $o ).

tff(pred_def_72254,type,
    v123366: state_type > $o ).

tff(pred_def_72255,type,
    v123364: state_type > $o ).

tff(pred_def_72256,type,
    v123363: state_type > $o ).

tff(pred_def_72257,type,
    v123362: ( state_type * $int ) > $o ).

tff(pred_def_72258,type,
    v123380: state_type > $o ).

tff(pred_def_72259,type,
    v123378: state_type > $o ).

tff(pred_def_72260,type,
    v123384: state_type > $o ).

tff(pred_def_72261,type,
    v123382: state_type > $o ).

tff(pred_def_72262,type,
    v123396: state_type > $o ).

tff(pred_def_72263,type,
    v123397: state_type > $o ).

tff(pred_def_72264,type,
    v123394: state_type > $o ).

tff(pred_def_72265,type,
    v123372: ( state_type * $int ) > $o ).

tff(pred_def_72266,type,
    v123404: state_type > $o ).

tff(pred_def_72267,type,
    v123403: state_type > $o ).

tff(pred_def_72268,type,
    v123406: state_type > $o ).

tff(pred_def_72269,type,
    v123405: state_type > $o ).

tff(pred_def_72270,type,
    v123402: state_type > $o ).

tff(pred_def_72271,type,
    v123400: ( state_type * $int ) > $o ).

tff(pred_def_72272,type,
    v123370: state_type > $o ).

tff(pred_def_72273,type,
    v123399: ( state_type * $int ) > $o ).

tff(pred_def_72274,type,
    v123392: ( state_type * $int ) > $o ).

tff(pred_def_72275,type,
    v123390: ( state_type * $int ) > $o ).

tff(pred_def_72276,type,
    v123388: ( state_type * $int ) > $o ).

tff(pred_def_72277,type,
    v123386: ( state_type * $int ) > $o ).

tff(pred_def_72278,type,
    v123410: state_type > $o ).

tff(pred_def_72279,type,
    v123408: state_type > $o ).

tff(pred_def_72280,type,
    v123417: state_type > $o ).

tff(pred_def_72281,type,
    v123415: state_type > $o ).

tff(pred_def_72282,type,
    v123414: state_type > $o ).

tff(pred_def_72283,type,
    v123413: state_type > $o ).

tff(pred_def_72284,type,
    v123425: state_type > $o ).

tff(pred_def_72285,type,
    v123426: state_type > $o ).

tff(pred_def_72286,type,
    v123424: state_type > $o ).

tff(pred_def_72287,type,
    v123421: ( state_type * $int ) > $o ).

tff(pred_def_72288,type,
    v123423: ( state_type * $int ) > $o ).

tff(pred_def_72289,type,
    v123376: ( state_type * $int ) > $o ).

tff(pred_def_72290,type,
    v123374: ( state_type * $int ) > $o ).

tff(pred_def_72291,type,
    v123441: state_type > $o ).

tff(pred_def_72292,type,
    v123439: state_type > $o ).

tff(pred_def_72293,type,
    v123445: state_type > $o ).

tff(pred_def_72294,type,
    v123443: state_type > $o ).

tff(pred_def_72295,type,
    v123458: state_type > $o ).

tff(pred_def_72296,type,
    v123457: state_type > $o ).

tff(pred_def_72297,type,
    v123455: state_type > $o ).

tff(pred_def_72298,type,
    v123460: ( state_type * $int ) > $o ).

tff(pred_def_72299,type,
    v123462: state_type > $o ).

tff(pred_def_72300,type,
    v123465: ( state_type * $int ) > $o ).

tff(pred_def_72301,type,
    v123433: ( state_type * $int ) > $o ).

tff(pred_def_72302,type,
    v123480: state_type > $o ).

tff(pred_def_72303,type,
    v123479: state_type > $o ).

tff(pred_def_72304,type,
    v123478: state_type > $o ).

tff(pred_def_72305,type,
    v123481: state_type > $o ).

tff(pred_def_72306,type,
    v123477: state_type > $o ).

tff(pred_def_72307,type,
    v123476: state_type > $o ).

tff(pred_def_72308,type,
    v123482: state_type > $o ).

tff(pred_def_72309,type,
    v123475: state_type > $o ).

tff(pred_def_72310,type,
    v123474: state_type > $o ).

tff(pred_def_72311,type,
    v123473: state_type > $o ).

tff(pred_def_72312,type,
    v123472: state_type > $o ).

tff(pred_def_72313,type,
    v123484: state_type > $o ).

tff(pred_def_72314,type,
    v123483: state_type > $o ).

tff(pred_def_72315,type,
    v123471: state_type > $o ).

tff(pred_def_72316,type,
    v123487: state_type > $o ).

tff(pred_def_72317,type,
    v123486: state_type > $o ).

tff(pred_def_72318,type,
    v123488: state_type > $o ).

tff(pred_def_72319,type,
    v123485: state_type > $o ).

tff(pred_def_72320,type,
    v123491: state_type > $o ).

tff(pred_def_72321,type,
    v123490: state_type > $o ).

tff(pred_def_72322,type,
    v123492: state_type > $o ).

tff(pred_def_72323,type,
    v123489: state_type > $o ).

tff(pred_def_72324,type,
    v123495: state_type > $o ).

tff(pred_def_72325,type,
    v123494: state_type > $o ).

tff(pred_def_72326,type,
    v123496: state_type > $o ).

tff(pred_def_72327,type,
    v123493: state_type > $o ).

tff(pred_def_72328,type,
    v123469: ( state_type * $int ) > $o ).

tff(pred_def_72329,type,
    v123431: state_type > $o ).

tff(pred_def_72330,type,
    v123468: ( state_type * $int ) > $o ).

tff(pred_def_72331,type,
    v123467: ( state_type * $int ) > $o ).

tff(pred_def_72332,type,
    v123453: ( state_type * $int ) > $o ).

tff(pred_def_72333,type,
    v123451: ( state_type * $int ) > $o ).

tff(pred_def_72334,type,
    v123449: ( state_type * $int ) > $o ).

tff(pred_def_72335,type,
    v123447: ( state_type * $int ) > $o ).

tff(pred_def_72336,type,
    v123500: state_type > $o ).

tff(pred_def_72337,type,
    v123498: state_type > $o ).

tff(pred_def_72338,type,
    v123507: state_type > $o ).

tff(pred_def_72339,type,
    v123505: state_type > $o ).

tff(pred_def_72340,type,
    v123504: state_type > $o ).

tff(pred_def_72341,type,
    v123503: state_type > $o ).

tff(pred_def_72342,type,
    v123515: state_type > $o ).

tff(pred_def_72343,type,
    v123516: state_type > $o ).

tff(pred_def_72344,type,
    v123514: state_type > $o ).

tff(pred_def_72345,type,
    v123511: ( state_type * $int ) > $o ).

tff(pred_def_72346,type,
    v123513: ( state_type * $int ) > $o ).

tff(pred_def_72347,type,
    v123437: ( state_type * $int ) > $o ).

tff(pred_def_72348,type,
    v123435: ( state_type * $int ) > $o ).

tff(pred_def_72349,type,
    v123521: state_type > $o ).

tff(pred_def_72350,type,
    v122722: state_type > $o ).

tff(pred_def_72351,type,
    v123537: state_type > $o ).

tff(pred_def_72352,type,
    v123535: state_type > $o ).

tff(pred_def_72353,type,
    v123533: state_type > $o ).

tff(pred_def_72354,type,
    v123531: state_type > $o ).

tff(pred_def_72355,type,
    v123545: state_type > $o ).

tff(pred_def_72356,type,
    v123543: state_type > $o ).

tff(pred_def_72357,type,
    v123541: state_type > $o ).

tff(pred_def_72358,type,
    v123539: state_type > $o ).

tff(pred_def_72359,type,
    v123565: state_type > $o ).

tff(pred_def_72360,type,
    v123563: state_type > $o ).

tff(pred_def_72361,type,
    v123569: state_type > $o ).

tff(pred_def_72362,type,
    v123567: state_type > $o ).

tff(pred_def_72363,type,
    v123581: state_type > $o ).

tff(pred_def_72364,type,
    v123583: state_type > $o ).

tff(pred_def_72365,type,
    v123585: state_type > $o ).

tff(pred_def_72366,type,
    v123587: state_type > $o ).

tff(pred_def_72367,type,
    v123589: state_type > $o ).

tff(pred_def_72368,type,
    v123591: state_type > $o ).

tff(pred_def_72369,type,
    v123593: state_type > $o ).

tff(pred_def_72370,type,
    v123642: ( state_type * $int ) > $o ).

tff(pred_def_72371,type,
    v123643: ( state_type * $int ) > $o ).

tff(pred_def_72372,type,
    v123641: state_type > $o ).

tff(pred_def_72373,type,
    v123646: state_type > $o ).

tff(pred_def_72374,type,
    v123647: state_type > $o ).

tff(pred_def_72375,type,
    v123645: state_type > $o ).

tff(pred_def_72376,type,
    v123648: state_type > $o ).

tff(pred_def_72377,type,
    v123644: state_type > $o ).

tff(pred_def_72378,type,
    v123640: state_type > $o ).

tff(pred_def_72379,type,
    v123649: state_type > $o ).

tff(pred_def_72380,type,
    v123639: state_type > $o ).

tff(pred_def_72381,type,
    v123638: state_type > $o ).

tff(pred_def_72382,type,
    v123653: state_type > $o ).

tff(pred_def_72383,type,
    v123654: state_type > $o ).

tff(pred_def_72384,type,
    v123652: state_type > $o ).

tff(pred_def_72385,type,
    v123655: state_type > $o ).

tff(pred_def_72386,type,
    v123651: state_type > $o ).

tff(pred_def_72387,type,
    v123650: state_type > $o ).

tff(pred_def_72388,type,
    v123637: state_type > $o ).

tff(pred_def_72389,type,
    v123656: state_type > $o ).

tff(pred_def_72390,type,
    v123636: state_type > $o ).

tff(pred_def_72391,type,
    v123659: state_type > $o ).

tff(pred_def_72392,type,
    v123660: state_type > $o ).

tff(pred_def_72393,type,
    v123658: state_type > $o ).

tff(pred_def_72394,type,
    v123661: state_type > $o ).

tff(pred_def_72395,type,
    v123657: state_type > $o ).

tff(pred_def_72396,type,
    v123664: state_type > $o ).

tff(pred_def_72397,type,
    v123665: state_type > $o ).

tff(pred_def_72398,type,
    v123663: state_type > $o ).

tff(pred_def_72399,type,
    v123666: state_type > $o ).

tff(pred_def_72400,type,
    v123662: state_type > $o ).

tff(pred_def_72401,type,
    v123634: ( state_type * $int ) > $o ).

tff(pred_def_72402,type,
    v123667: ( state_type * $int ) > $o ).

tff(pred_def_72403,type,
    v123633: state_type > $o ).

tff(pred_def_72404,type,
    v123670: state_type > $o ).

tff(pred_def_72405,type,
    v123671: state_type > $o ).

tff(pred_def_72406,type,
    v123669: state_type > $o ).

tff(pred_def_72407,type,
    v123672: state_type > $o ).

tff(pred_def_72408,type,
    v123668: state_type > $o ).

tff(pred_def_72409,type,
    v123632: state_type > $o ).

tff(pred_def_72410,type,
    v123673: state_type > $o ).

tff(pred_def_72411,type,
    v123631: state_type > $o ).

tff(pred_def_72412,type,
    v123630: state_type > $o ).

tff(pred_def_72413,type,
    v123677: state_type > $o ).

tff(pred_def_72414,type,
    v123678: state_type > $o ).

tff(pred_def_72415,type,
    v123676: state_type > $o ).

tff(pred_def_72416,type,
    v123679: state_type > $o ).

tff(pred_def_72417,type,
    v123675: state_type > $o ).

tff(pred_def_72418,type,
    v123674: state_type > $o ).

tff(pred_def_72419,type,
    v123629: state_type > $o ).

tff(pred_def_72420,type,
    v123680: state_type > $o ).

tff(pred_def_72421,type,
    v123628: state_type > $o ).

tff(pred_def_72422,type,
    v123683: state_type > $o ).

tff(pred_def_72423,type,
    v123684: state_type > $o ).

tff(pred_def_72424,type,
    v123682: state_type > $o ).

tff(pred_def_72425,type,
    v123685: state_type > $o ).

tff(pred_def_72426,type,
    v123681: state_type > $o ).

tff(pred_def_72427,type,
    v123688: state_type > $o ).

tff(pred_def_72428,type,
    v123689: state_type > $o ).

tff(pred_def_72429,type,
    v123687: state_type > $o ).

tff(pred_def_72430,type,
    v123690: state_type > $o ).

tff(pred_def_72431,type,
    v123686: state_type > $o ).

tff(pred_def_72432,type,
    v123626: ( state_type * $int ) > $o ).

tff(pred_def_72433,type,
    v123691: ( state_type * $int ) > $o ).

tff(pred_def_72434,type,
    v123625: state_type > $o ).

tff(pred_def_72435,type,
    v123694: state_type > $o ).

tff(pred_def_72436,type,
    v123695: state_type > $o ).

tff(pred_def_72437,type,
    v123693: state_type > $o ).

tff(pred_def_72438,type,
    v123696: state_type > $o ).

tff(pred_def_72439,type,
    v123692: state_type > $o ).

tff(pred_def_72440,type,
    v123624: state_type > $o ).

tff(pred_def_72441,type,
    v123697: state_type > $o ).

tff(pred_def_72442,type,
    v123623: state_type > $o ).

tff(pred_def_72443,type,
    v123622: state_type > $o ).

tff(pred_def_72444,type,
    v123701: state_type > $o ).

tff(pred_def_72445,type,
    v123702: state_type > $o ).

tff(pred_def_72446,type,
    v123700: state_type > $o ).

tff(pred_def_72447,type,
    v123703: state_type > $o ).

tff(pred_def_72448,type,
    v123699: state_type > $o ).

tff(pred_def_72449,type,
    v123698: state_type > $o ).

tff(pred_def_72450,type,
    v123621: state_type > $o ).

tff(pred_def_72451,type,
    v123704: state_type > $o ).

tff(pred_def_72452,type,
    v123620: state_type > $o ).

tff(pred_def_72453,type,
    v123707: state_type > $o ).

tff(pred_def_72454,type,
    v123708: state_type > $o ).

tff(pred_def_72455,type,
    v123706: state_type > $o ).

tff(pred_def_72456,type,
    v123709: state_type > $o ).

tff(pred_def_72457,type,
    v123705: state_type > $o ).

tff(pred_def_72458,type,
    v123712: state_type > $o ).

tff(pred_def_72459,type,
    v123713: state_type > $o ).

tff(pred_def_72460,type,
    v123711: state_type > $o ).

tff(pred_def_72461,type,
    v123714: state_type > $o ).

tff(pred_def_72462,type,
    v123710: state_type > $o ).

tff(pred_def_72463,type,
    v123618: ( state_type * $int ) > $o ).

tff(pred_def_72464,type,
    v123715: ( state_type * $int ) > $o ).

tff(pred_def_72465,type,
    v123617: state_type > $o ).

tff(pred_def_72466,type,
    v123718: state_type > $o ).

tff(pred_def_72467,type,
    v123719: state_type > $o ).

tff(pred_def_72468,type,
    v123717: state_type > $o ).

tff(pred_def_72469,type,
    v123720: state_type > $o ).

tff(pred_def_72470,type,
    v123716: state_type > $o ).

tff(pred_def_72471,type,
    v123616: state_type > $o ).

tff(pred_def_72472,type,
    v123721: state_type > $o ).

tff(pred_def_72473,type,
    v123615: state_type > $o ).

tff(pred_def_72474,type,
    v123614: state_type > $o ).

tff(pred_def_72475,type,
    v123725: state_type > $o ).

tff(pred_def_72476,type,
    v123726: state_type > $o ).

tff(pred_def_72477,type,
    v123724: state_type > $o ).

tff(pred_def_72478,type,
    v123727: state_type > $o ).

tff(pred_def_72479,type,
    v123723: state_type > $o ).

tff(pred_def_72480,type,
    v123722: state_type > $o ).

tff(pred_def_72481,type,
    v123613: state_type > $o ).

tff(pred_def_72482,type,
    v123728: state_type > $o ).

tff(pred_def_72483,type,
    v123612: state_type > $o ).

tff(pred_def_72484,type,
    v123731: state_type > $o ).

tff(pred_def_72485,type,
    v123732: state_type > $o ).

tff(pred_def_72486,type,
    v123730: state_type > $o ).

tff(pred_def_72487,type,
    v123733: state_type > $o ).

tff(pred_def_72488,type,
    v123729: state_type > $o ).

tff(pred_def_72489,type,
    v123736: state_type > $o ).

tff(pred_def_72490,type,
    v123737: state_type > $o ).

tff(pred_def_72491,type,
    v123735: state_type > $o ).

tff(pred_def_72492,type,
    v123738: state_type > $o ).

tff(pred_def_72493,type,
    v123734: state_type > $o ).

tff(pred_def_72494,type,
    v123610: ( state_type * $int ) > $o ).

tff(pred_def_72495,type,
    v123739: ( state_type * $int ) > $o ).

tff(pred_def_72496,type,
    v123609: state_type > $o ).

tff(pred_def_72497,type,
    v123742: state_type > $o ).

tff(pred_def_72498,type,
    v123743: state_type > $o ).

tff(pred_def_72499,type,
    v123741: state_type > $o ).

tff(pred_def_72500,type,
    v123744: state_type > $o ).

tff(pred_def_72501,type,
    v123740: state_type > $o ).

tff(pred_def_72502,type,
    v123608: state_type > $o ).

tff(pred_def_72503,type,
    v123745: state_type > $o ).

tff(pred_def_72504,type,
    v123607: state_type > $o ).

tff(pred_def_72505,type,
    v123606: state_type > $o ).

tff(pred_def_72506,type,
    v123749: state_type > $o ).

tff(pred_def_72507,type,
    v123750: state_type > $o ).

tff(pred_def_72508,type,
    v123748: state_type > $o ).

tff(pred_def_72509,type,
    v123751: state_type > $o ).

tff(pred_def_72510,type,
    v123747: state_type > $o ).

tff(pred_def_72511,type,
    v123746: state_type > $o ).

tff(pred_def_72512,type,
    v123605: state_type > $o ).

tff(pred_def_72513,type,
    v123752: state_type > $o ).

tff(pred_def_72514,type,
    v123604: state_type > $o ).

tff(pred_def_72515,type,
    v123755: state_type > $o ).

tff(pred_def_72516,type,
    v123756: state_type > $o ).

tff(pred_def_72517,type,
    v123754: state_type > $o ).

tff(pred_def_72518,type,
    v123757: state_type > $o ).

tff(pred_def_72519,type,
    v123753: state_type > $o ).

tff(pred_def_72520,type,
    v123760: state_type > $o ).

tff(pred_def_72521,type,
    v123761: state_type > $o ).

tff(pred_def_72522,type,
    v123759: state_type > $o ).

tff(pred_def_72523,type,
    v123762: state_type > $o ).

tff(pred_def_72524,type,
    v123758: state_type > $o ).

tff(pred_def_72525,type,
    v123602: ( state_type * $int ) > $o ).

tff(pred_def_72526,type,
    v123763: ( state_type * $int ) > $o ).

tff(pred_def_72527,type,
    v123601: state_type > $o ).

tff(pred_def_72528,type,
    v123766: state_type > $o ).

tff(pred_def_72529,type,
    v123767: state_type > $o ).

tff(pred_def_72530,type,
    v123765: state_type > $o ).

tff(pred_def_72531,type,
    v123768: state_type > $o ).

tff(pred_def_72532,type,
    v123764: state_type > $o ).

tff(pred_def_72533,type,
    v123600: state_type > $o ).

tff(pred_def_72534,type,
    v123769: state_type > $o ).

tff(pred_def_72535,type,
    v123599: state_type > $o ).

tff(pred_def_72536,type,
    v123598: state_type > $o ).

tff(pred_def_72537,type,
    v123773: state_type > $o ).

tff(pred_def_72538,type,
    v123774: state_type > $o ).

tff(pred_def_72539,type,
    v123772: state_type > $o ).

tff(pred_def_72540,type,
    v123775: state_type > $o ).

tff(pred_def_72541,type,
    v123771: state_type > $o ).

tff(pred_def_72542,type,
    v123770: state_type > $o ).

tff(pred_def_72543,type,
    v123597: state_type > $o ).

tff(pred_def_72544,type,
    v123776: state_type > $o ).

tff(pred_def_72545,type,
    v123596: state_type > $o ).

tff(pred_def_72546,type,
    v123779: state_type > $o ).

tff(pred_def_72547,type,
    v123780: state_type > $o ).

tff(pred_def_72548,type,
    v123778: state_type > $o ).

tff(pred_def_72549,type,
    v123781: state_type > $o ).

tff(pred_def_72550,type,
    v123777: state_type > $o ).

tff(pred_def_72551,type,
    v123784: state_type > $o ).

tff(pred_def_72552,type,
    v123785: state_type > $o ).

tff(pred_def_72553,type,
    v123783: state_type > $o ).

tff(pred_def_72554,type,
    v123786: state_type > $o ).

tff(pred_def_72555,type,
    v123782: state_type > $o ).

tff(pred_def_72556,type,
    v123594: ( state_type * $int ) > $o ).

tff(pred_def_72557,type,
    v123579: ( state_type * $int ) > $o ).

tff(pred_def_72558,type,
    v123796: state_type > $o ).

tff(pred_def_72559,type,
    v123794: state_type > $o ).

tff(pred_def_72560,type,
    v123793: state_type > $o ).

tff(pred_def_72561,type,
    v123792: ( state_type * $int ) > $o ).

tff(pred_def_72562,type,
    v123790: state_type > $o ).

tff(pred_def_72563,type,
    v123806: state_type > $o ).

tff(pred_def_72564,type,
    v123804: state_type > $o ).

tff(pred_def_72565,type,
    v123803: state_type > $o ).

tff(pred_def_72566,type,
    v123802: ( state_type * $int ) > $o ).

tff(pred_def_72567,type,
    v123800: state_type > $o ).

tff(pred_def_72568,type,
    v123816: state_type > $o ).

tff(pred_def_72569,type,
    v123814: state_type > $o ).

tff(pred_def_72570,type,
    v123813: state_type > $o ).

tff(pred_def_72571,type,
    v123812: ( state_type * $int ) > $o ).

tff(pred_def_72572,type,
    v123810: state_type > $o ).

tff(pred_def_72573,type,
    v123820: state_type > $o ).

tff(pred_def_72574,type,
    v123822: state_type > $o ).

tff(pred_def_72575,type,
    v123824: state_type > $o ).

tff(pred_def_72576,type,
    v123830: state_type > $o ).

tff(pred_def_72577,type,
    v123829: state_type > $o ).

tff(pred_def_72578,type,
    v123828: state_type > $o ).

tff(pred_def_72579,type,
    v123827: state_type > $o ).

tff(pred_def_72580,type,
    v123826: state_type > $o ).

tff(pred_def_72581,type,
    v123825: ( state_type * $int ) > $o ).

tff(pred_def_72582,type,
    v123788: ( state_type * $int ) > $o ).

tff(pred_def_72583,type,
    v123859: ( state_type * $int ) > $o ).

tff(pred_def_72584,type,
    v123557: ( state_type * $int ) > $o ).

tff(pred_def_72585,type,
    v123858: state_type > $o ).

tff(pred_def_72586,type,
    v123862: state_type > $o ).

tff(pred_def_72587,type,
    v123863: state_type > $o ).

tff(pred_def_72588,type,
    v123861: state_type > $o ).

tff(pred_def_72589,type,
    v123864: state_type > $o ).

tff(pred_def_72590,type,
    v123860: state_type > $o ).

tff(pred_def_72591,type,
    v123857: state_type > $o ).

tff(pred_def_72592,type,
    v123865: state_type > $o ).

tff(pred_def_72593,type,
    v123856: state_type > $o ).

tff(pred_def_72594,type,
    v123868: state_type > $o ).

tff(pred_def_72595,type,
    v123869: state_type > $o ).

tff(pred_def_72596,type,
    v123867: state_type > $o ).

tff(pred_def_72597,type,
    v123870: state_type > $o ).

tff(pred_def_72598,type,
    v123866: state_type > $o ).

tff(pred_def_72599,type,
    v123855: state_type > $o ).

tff(pred_def_72600,type,
    v123871: state_type > $o ).

tff(pred_def_72601,type,
    v123854: state_type > $o ).

tff(pred_def_72602,type,
    v123874: state_type > $o ).

tff(pred_def_72603,type,
    v123875: state_type > $o ).

tff(pred_def_72604,type,
    v123873: state_type > $o ).

tff(pred_def_72605,type,
    v123876: state_type > $o ).

tff(pred_def_72606,type,
    v123872: state_type > $o ).

tff(pred_def_72607,type,
    v123853: state_type > $o ).

tff(pred_def_72608,type,
    v123877: state_type > $o ).

tff(pred_def_72609,type,
    v123852: state_type > $o ).

tff(pred_def_72610,type,
    v123880: state_type > $o ).

tff(pred_def_72611,type,
    v123881: state_type > $o ).

tff(pred_def_72612,type,
    v123879: state_type > $o ).

tff(pred_def_72613,type,
    v123882: state_type > $o ).

tff(pred_def_72614,type,
    v123878: state_type > $o ).

tff(pred_def_72615,type,
    v123851: state_type > $o ).

tff(pred_def_72616,type,
    v123883: state_type > $o ).

tff(pred_def_72617,type,
    v123850: state_type > $o ).

tff(pred_def_72618,type,
    v123849: state_type > $o ).

tff(pred_def_72619,type,
    v123887: state_type > $o ).

tff(pred_def_72620,type,
    v123888: state_type > $o ).

tff(pred_def_72621,type,
    v123886: state_type > $o ).

tff(pred_def_72622,type,
    v123889: state_type > $o ).

tff(pred_def_72623,type,
    v123885: state_type > $o ).

tff(pred_def_72624,type,
    v123884: state_type > $o ).

tff(pred_def_72625,type,
    v123848: state_type > $o ).

tff(pred_def_72626,type,
    v123890: state_type > $o ).

tff(pred_def_72627,type,
    v123847: state_type > $o ).

tff(pred_def_72628,type,
    v123893: state_type > $o ).

tff(pred_def_72629,type,
    v123894: state_type > $o ).

tff(pred_def_72630,type,
    v123892: state_type > $o ).

tff(pred_def_72631,type,
    v123895: state_type > $o ).

tff(pred_def_72632,type,
    v123891: state_type > $o ).

tff(pred_def_72633,type,
    v123898: state_type > $o ).

tff(pred_def_72634,type,
    v123899: state_type > $o ).

tff(pred_def_72635,type,
    v123897: state_type > $o ).

tff(pred_def_72636,type,
    v123900: state_type > $o ).

tff(pred_def_72637,type,
    v123896: state_type > $o ).

tff(pred_def_72638,type,
    v123903: state_type > $o ).

tff(pred_def_72639,type,
    v123904: state_type > $o ).

tff(pred_def_72640,type,
    v123902: state_type > $o ).

tff(pred_def_72641,type,
    v123905: state_type > $o ).

tff(pred_def_72642,type,
    v123901: state_type > $o ).

tff(pred_def_72643,type,
    v123908: state_type > $o ).

tff(pred_def_72644,type,
    v123909: state_type > $o ).

tff(pred_def_72645,type,
    v123907: state_type > $o ).

tff(pred_def_72646,type,
    v123910: state_type > $o ).

tff(pred_def_72647,type,
    v123906: state_type > $o ).

tff(pred_def_72648,type,
    v123913: state_type > $o ).

tff(pred_def_72649,type,
    v123914: state_type > $o ).

tff(pred_def_72650,type,
    v123912: state_type > $o ).

tff(pred_def_72651,type,
    v123915: state_type > $o ).

tff(pred_def_72652,type,
    v123911: state_type > $o ).

tff(pred_def_72653,type,
    v123845: ( state_type * $int ) > $o ).

tff(pred_def_72654,type,
    v123844: state_type > $o ).

tff(pred_def_72655,type,
    v123920: state_type > $o ).

tff(pred_def_72656,type,
    v123922: state_type > $o ).

tff(pred_def_72657,type,
    v123923: state_type > $o ).

tff(pred_def_72658,type,
    v123921: state_type > $o ).

tff(pred_def_72659,type,
    v123919: state_type > $o ).

tff(pred_def_72660,type,
    v123918: state_type > $o ).

tff(pred_def_72661,type,
    v123924: state_type > $o ).

tff(pred_def_72662,type,
    v123917: state_type > $o ).

tff(pred_def_72663,type,
    v123925: state_type > $o ).

tff(pred_def_72664,type,
    v123916: state_type > $o ).

tff(pred_def_72665,type,
    v123843: state_type > $o ).

tff(pred_def_72666,type,
    v123926: state_type > $o ).

tff(pred_def_72667,type,
    v123842: state_type > $o ).

tff(pred_def_72668,type,
    v123933: state_type > $o ).

tff(pred_def_72669,type,
    v123932: state_type > $o ).

tff(pred_def_72670,type,
    v123931: state_type > $o ).

tff(pred_def_72671,type,
    v123935: state_type > $o ).

tff(pred_def_72672,type,
    v123934: state_type > $o ).

tff(pred_def_72673,type,
    v123930: state_type > $o ).

tff(pred_def_72674,type,
    v123929: state_type > $o ).

tff(pred_def_72675,type,
    v123936: state_type > $o ).

tff(pred_def_72676,type,
    v123928: state_type > $o ).

tff(pred_def_72677,type,
    v123937: state_type > $o ).

tff(pred_def_72678,type,
    v123927: state_type > $o ).

tff(pred_def_72679,type,
    v123841: state_type > $o ).

tff(pred_def_72680,type,
    v123938: state_type > $o ).

tff(pred_def_72681,type,
    v123840: state_type > $o ).

tff(pred_def_72682,type,
    v123945: state_type > $o ).

tff(pred_def_72683,type,
    v123944: state_type > $o ).

tff(pred_def_72684,type,
    v123943: state_type > $o ).

tff(pred_def_72685,type,
    v123947: state_type > $o ).

tff(pred_def_72686,type,
    v123946: state_type > $o ).

tff(pred_def_72687,type,
    v123942: state_type > $o ).

tff(pred_def_72688,type,
    v123941: state_type > $o ).

tff(pred_def_72689,type,
    v123948: state_type > $o ).

tff(pred_def_72690,type,
    v123940: state_type > $o ).

tff(pred_def_72691,type,
    v123949: state_type > $o ).

tff(pred_def_72692,type,
    v123939: state_type > $o ).

tff(pred_def_72693,type,
    v123839: state_type > $o ).

tff(pred_def_72694,type,
    v123950: state_type > $o ).

tff(pred_def_72695,type,
    v123838: state_type > $o ).

tff(pred_def_72696,type,
    v123957: state_type > $o ).

tff(pred_def_72697,type,
    v123956: state_type > $o ).

tff(pred_def_72698,type,
    v123955: state_type > $o ).

tff(pred_def_72699,type,
    v123959: state_type > $o ).

tff(pred_def_72700,type,
    v123958: state_type > $o ).

tff(pred_def_72701,type,
    v123954: state_type > $o ).

tff(pred_def_72702,type,
    v123953: state_type > $o ).

tff(pred_def_72703,type,
    v123960: state_type > $o ).

tff(pred_def_72704,type,
    v123952: state_type > $o ).

tff(pred_def_72705,type,
    v123961: state_type > $o ).

tff(pred_def_72706,type,
    v123951: state_type > $o ).

tff(pred_def_72707,type,
    v123837: state_type > $o ).

tff(pred_def_72708,type,
    v123962: state_type > $o ).

tff(pred_def_72709,type,
    v123836: state_type > $o ).

tff(pred_def_72710,type,
    v123835: state_type > $o ).

tff(pred_def_72711,type,
    v123970: state_type > $o ).

tff(pred_def_72712,type,
    v123969: state_type > $o ).

tff(pred_def_72713,type,
    v123968: state_type > $o ).

tff(pred_def_72714,type,
    v123972: state_type > $o ).

tff(pred_def_72715,type,
    v123971: state_type > $o ).

tff(pred_def_72716,type,
    v123967: state_type > $o ).

tff(pred_def_72717,type,
    v123966: state_type > $o ).

tff(pred_def_72718,type,
    v123973: state_type > $o ).

tff(pred_def_72719,type,
    v123965: state_type > $o ).

tff(pred_def_72720,type,
    v123974: state_type > $o ).

tff(pred_def_72721,type,
    v123964: state_type > $o ).

tff(pred_def_72722,type,
    v123963: state_type > $o ).

tff(pred_def_72723,type,
    v123834: state_type > $o ).

tff(pred_def_72724,type,
    v123975: state_type > $o ).

tff(pred_def_72725,type,
    v123833: state_type > $o ).

tff(pred_def_72726,type,
    v123978: state_type > $o ).

tff(pred_def_72727,type,
    v123979: state_type > $o ).

tff(pred_def_72728,type,
    v123977: state_type > $o ).

tff(pred_def_72729,type,
    v123980: state_type > $o ).

tff(pred_def_72730,type,
    v123976: state_type > $o ).

tff(pred_def_72731,type,
    v123983: state_type > $o ).

tff(pred_def_72732,type,
    v123984: state_type > $o ).

tff(pred_def_72733,type,
    v123982: state_type > $o ).

tff(pred_def_72734,type,
    v123985: state_type > $o ).

tff(pred_def_72735,type,
    v123981: state_type > $o ).

tff(pred_def_72736,type,
    v123988: state_type > $o ).

tff(pred_def_72737,type,
    v123989: state_type > $o ).

tff(pred_def_72738,type,
    v123987: state_type > $o ).

tff(pred_def_72739,type,
    v123990: state_type > $o ).

tff(pred_def_72740,type,
    v123986: state_type > $o ).

tff(pred_def_72741,type,
    v123993: state_type > $o ).

tff(pred_def_72742,type,
    v123994: state_type > $o ).

tff(pred_def_72743,type,
    v123992: state_type > $o ).

tff(pred_def_72744,type,
    v123995: state_type > $o ).

tff(pred_def_72745,type,
    v123991: state_type > $o ).

tff(pred_def_72746,type,
    v123998: state_type > $o ).

tff(pred_def_72747,type,
    v123997: state_type > $o ).

tff(pred_def_72748,type,
    v123999: state_type > $o ).

tff(pred_def_72749,type,
    v123996: state_type > $o ).

tff(pred_def_72750,type,
    v123577: ( state_type * $int ) > $o ).

tff(pred_def_72751,type,
    v123575: ( state_type * $int ) > $o ).

tff(pred_def_72752,type,
    v123573: ( state_type * $int ) > $o ).

tff(pred_def_72753,type,
    v123571: ( state_type * $int ) > $o ).

tff(pred_def_72754,type,
    v124005: state_type > $o ).

tff(pred_def_72755,type,
    v124003: state_type > $o ).

tff(pred_def_72756,type,
    v124001: state_type > $o ).

tff(pred_def_72757,type,
    v124012: state_type > $o ).

tff(pred_def_72758,type,
    v124010: state_type > $o ).

tff(pred_def_72759,type,
    v124009: state_type > $o ).

tff(pred_def_72760,type,
    v124008: state_type > $o ).

tff(pred_def_72761,type,
    v124020: state_type > $o ).

tff(pred_def_72762,type,
    v124021: state_type > $o ).

tff(pred_def_72763,type,
    v124019: state_type > $o ).

tff(pred_def_72764,type,
    v124016: ( state_type * $int ) > $o ).

tff(pred_def_72765,type,
    v124018: ( state_type * $int ) > $o ).

tff(pred_def_72766,type,
    v123561: ( state_type * $int ) > $o ).

tff(pred_def_72767,type,
    v123559: ( state_type * $int ) > $o ).

tff(pred_def_72768,type,
    v124025: state_type > $o ).

tff(pred_def_72769,type,
    v124027: state_type > $o ).

tff(pred_def_72770,type,
    v124028: state_type > $o ).

tff(pred_def_72771,type,
    v123555: state_type > $o ).

tff(pred_def_72772,type,
    v124030: state_type > $o ).

tff(pred_def_72773,type,
    v124032: state_type > $o ).

tff(pred_def_72774,type,
    v124038: state_type > $o ).

tff(pred_def_72775,type,
    v124040: state_type > $o ).

tff(pred_def_72776,type,
    v124050: state_type > $o ).

tff(pred_def_72777,type,
    v124051: state_type > $o ).

tff(pred_def_72778,type,
    v124049: state_type > $o ).

tff(pred_def_72779,type,
    v124053: state_type > $o ).

tff(pred_def_72780,type,
    v124054: state_type > $o ).

tff(pred_def_72781,type,
    v124052: state_type > $o ).

tff(pred_def_72782,type,
    v124048: state_type > $o ).

tff(pred_def_72783,type,
    v124047: state_type > $o ).

tff(pred_def_72784,type,
    v124046: state_type > $o ).

tff(pred_def_72785,type,
    v124045: state_type > $o ).

tff(pred_def_72786,type,
    v123525: ( state_type * $int ) > $o ).

tff(pred_def_72787,type,
    v124055: state_type > $o ).

tff(pred_def_72788,type,
    v124044: state_type > $o ).

tff(pred_def_72789,type,
    v124057: state_type > $o ).

tff(pred_def_72790,type,
    v124056: state_type > $o ).

tff(pred_def_72791,type,
    v124043: state_type > $o ).

tff(pred_def_72792,type,
    v124059: state_type > $o ).

tff(pred_def_72793,type,
    v124065: state_type > $o ).

tff(pred_def_72794,type,
    v124066: state_type > $o ).

tff(pred_def_72795,type,
    v124064: state_type > $o ).

tff(pred_def_72796,type,
    v124063: state_type > $o ).

tff(pred_def_72797,type,
    v124069: state_type > $o ).

tff(pred_def_72798,type,
    v124068: state_type > $o ).

tff(pred_def_72799,type,
    v124067: state_type > $o ).

tff(pred_def_72800,type,
    v124062: state_type > $o ).

tff(pred_def_72801,type,
    v124070: state_type > $o ).

tff(pred_def_72802,type,
    v124061: state_type > $o ).

tff(pred_def_72803,type,
    v124071: state_type > $o ).

tff(pred_def_72804,type,
    v124060: state_type > $o ).

tff(pred_def_72805,type,
    v124058: state_type > $o ).

tff(pred_def_72806,type,
    v124042: state_type > $o ).

tff(pred_def_72807,type,
    v123553: ( state_type * $int ) > $o ).

tff(pred_def_72808,type,
    v124072: ( state_type * $int ) > $o ).

tff(pred_def_72809,type,
    v124036: state_type > $o ).

tff(pred_def_72810,type,
    v123551: ( state_type * $int ) > $o ).

tff(pred_def_72811,type,
    v123549: ( state_type * $int ) > $o ).

tff(pred_def_72812,type,
    v123547: ( state_type * $int ) > $o ).

tff(pred_def_72813,type,
    v124076: state_type > $o ).

tff(pred_def_72814,type,
    v124074: state_type > $o ).

tff(pred_def_72815,type,
    v124083: state_type > $o ).

tff(pred_def_72816,type,
    v124081: state_type > $o ).

tff(pred_def_72817,type,
    v124080: state_type > $o ).

tff(pred_def_72818,type,
    v124079: state_type > $o ).

tff(pred_def_72819,type,
    v124091: state_type > $o ).

tff(pred_def_72820,type,
    v124092: state_type > $o ).

tff(pred_def_72821,type,
    v124090: state_type > $o ).

tff(pred_def_72822,type,
    v124087: ( state_type * $int ) > $o ).

tff(pred_def_72823,type,
    v124089: ( state_type * $int ) > $o ).

tff(pred_def_72824,type,
    v124078: ( state_type * $int ) > $o ).

tff(pred_def_72825,type,
    v123529: ( state_type * $int ) > $o ).

tff(pred_def_72826,type,
    v123527: ( state_type * $int ) > $o ).

tff(pred_def_72827,type,
    v124096: state_type > $o ).

tff(pred_def_72828,type,
    v124102: state_type > $o ).

tff(pred_def_72829,type,
    v124101: state_type > $o ).

tff(pred_def_72830,type,
    v124100: state_type > $o ).

tff(pred_def_72831,type,
    v124104: state_type > $o ).

tff(pred_def_72832,type,
    v124103: state_type > $o ).

tff(pred_def_72833,type,
    v124099: state_type > $o ).

tff(pred_def_72834,type,
    v124106: state_type > $o ).

tff(pred_def_72835,type,
    v124112: state_type > $o ).

tff(pred_def_72836,type,
    v124111: state_type > $o ).

tff(pred_def_72837,type,
    v124110: state_type > $o ).

tff(pred_def_72838,type,
    v124109: state_type > $o ).

tff(pred_def_72839,type,
    v124113: state_type > $o ).

tff(pred_def_72840,type,
    v124108: state_type > $o ).

tff(pred_def_72841,type,
    v124114: state_type > $o ).

tff(pred_def_72842,type,
    v124107: state_type > $o ).

tff(pred_def_72843,type,
    v124105: state_type > $o ).

tff(pred_def_72844,type,
    v124098: state_type > $o ).

tff(pred_def_72845,type,
    v124120: state_type > $o ).

tff(pred_def_72846,type,
    v124118: state_type > $o ).

tff(pred_def_72847,type,
    v124117: state_type > $o ).

tff(pred_def_72848,type,
    v124116: ( state_type * $int ) > $o ).

tff(pred_def_72849,type,
    v124130: state_type > $o ).

tff(pred_def_72850,type,
    v124129: state_type > $o ).

tff(pred_def_72851,type,
    v124128: state_type > $o ).

tff(pred_def_72852,type,
    v124127: state_type > $o ).

tff(pred_def_72853,type,
    v124132: state_type > $o ).

tff(pred_def_72854,type,
    v124133: state_type > $o ).

tff(pred_def_72855,type,
    v124131: state_type > $o ).

tff(pred_def_72856,type,
    v124126: state_type > $o ).

tff(pred_def_72857,type,
    v124136: state_type > $o ).

tff(pred_def_72858,type,
    v124135: state_type > $o ).

tff(pred_def_72859,type,
    v124137: state_type > $o ).

tff(pred_def_72860,type,
    v124134: state_type > $o ).

tff(pred_def_72861,type,
    v124125: state_type > $o ).

tff(pred_def_72862,type,
    v124141: state_type > $o ).

tff(pred_def_72863,type,
    v124140: state_type > $o ).

tff(pred_def_72864,type,
    v124139: state_type > $o ).

tff(pred_def_72865,type,
    v124142: state_type > $o ).

tff(pred_def_72866,type,
    v124138: state_type > $o ).

tff(pred_def_72867,type,
    v124124: state_type > $o ).

tff(pred_def_72868,type,
    v124149: state_type > $o ).

tff(pred_def_72869,type,
    v124147: state_type > $o ).

tff(pred_def_72870,type,
    v124146: state_type > $o ).

tff(pred_def_72871,type,
    v124145: ( state_type * $int ) > $o ).

tff(pred_def_72872,type,
    v124034: state_type > $o ).

tff(pred_def_72873,type,
    v124155: state_type > $o ).

tff(pred_def_72874,type,
    v124157: state_type > $o ).

tff(pred_def_72875,type,
    v124160: state_type > $o ).

tff(pred_def_72876,type,
    v124161: state_type > $o ).

tff(pred_def_72877,type,
    v124159: state_type > $o ).

tff(pred_def_72878,type,
    v124158: state_type > $o ).

tff(pred_def_72879,type,
    v124156: state_type > $o ).

tff(pred_def_72880,type,
    v124154: state_type > $o ).

tff(pred_def_72881,type,
    v124167: state_type > $o ).

tff(pred_def_72882,type,
    v124165: state_type > $o ).

tff(pred_def_72883,type,
    v124164: state_type > $o ).

tff(pred_def_72884,type,
    v124163: ( state_type * $int ) > $o ).

tff(pred_def_72885,type,
    v124181: state_type > $o ).

tff(pred_def_72886,type,
    v124179: state_type > $o ).

tff(pred_def_72887,type,
    v124185: state_type > $o ).

tff(pred_def_72888,type,
    v124183: state_type > $o ).

tff(pred_def_72889,type,
    v124197: state_type > $o ).

tff(pred_def_72890,type,
    v124198: state_type > $o ).

tff(pred_def_72891,type,
    v124195: state_type > $o ).

tff(pred_def_72892,type,
    v124173: ( state_type * $int ) > $o ).

tff(pred_def_72893,type,
    v124205: state_type > $o ).

tff(pred_def_72894,type,
    v124204: state_type > $o ).

tff(pred_def_72895,type,
    v124207: state_type > $o ).

tff(pred_def_72896,type,
    v124206: state_type > $o ).

tff(pred_def_72897,type,
    v124203: state_type > $o ).

tff(pred_def_72898,type,
    v124201: ( state_type * $int ) > $o ).

tff(pred_def_72899,type,
    v124171: state_type > $o ).

tff(pred_def_72900,type,
    v124200: ( state_type * $int ) > $o ).

tff(pred_def_72901,type,
    v124193: ( state_type * $int ) > $o ).

tff(pred_def_72902,type,
    v124191: ( state_type * $int ) > $o ).

tff(pred_def_72903,type,
    v124189: ( state_type * $int ) > $o ).

tff(pred_def_72904,type,
    v124187: ( state_type * $int ) > $o ).

tff(pred_def_72905,type,
    v124211: state_type > $o ).

tff(pred_def_72906,type,
    v124209: state_type > $o ).

tff(pred_def_72907,type,
    v124218: state_type > $o ).

tff(pred_def_72908,type,
    v124216: state_type > $o ).

tff(pred_def_72909,type,
    v124215: state_type > $o ).

tff(pred_def_72910,type,
    v124214: state_type > $o ).

tff(pred_def_72911,type,
    v124226: state_type > $o ).

tff(pred_def_72912,type,
    v124227: state_type > $o ).

tff(pred_def_72913,type,
    v124225: state_type > $o ).

tff(pred_def_72914,type,
    v124222: ( state_type * $int ) > $o ).

tff(pred_def_72915,type,
    v124224: ( state_type * $int ) > $o ).

tff(pred_def_72916,type,
    v124177: ( state_type * $int ) > $o ).

tff(pred_def_72917,type,
    v124175: ( state_type * $int ) > $o ).

tff(pred_def_72918,type,
    v124242: state_type > $o ).

tff(pred_def_72919,type,
    v124240: state_type > $o ).

tff(pred_def_72920,type,
    v124246: state_type > $o ).

tff(pred_def_72921,type,
    v124244: state_type > $o ).

tff(pred_def_72922,type,
    v124259: state_type > $o ).

tff(pred_def_72923,type,
    v124258: state_type > $o ).

tff(pred_def_72924,type,
    v124256: state_type > $o ).

tff(pred_def_72925,type,
    v124261: ( state_type * $int ) > $o ).

tff(pred_def_72926,type,
    v124263: state_type > $o ).

tff(pred_def_72927,type,
    v124266: ( state_type * $int ) > $o ).

tff(pred_def_72928,type,
    v124234: ( state_type * $int ) > $o ).

tff(pred_def_72929,type,
    v124281: state_type > $o ).

tff(pred_def_72930,type,
    v124280: state_type > $o ).

tff(pred_def_72931,type,
    v124279: state_type > $o ).

tff(pred_def_72932,type,
    v124282: state_type > $o ).

tff(pred_def_72933,type,
    v124278: state_type > $o ).

tff(pred_def_72934,type,
    v124277: state_type > $o ).

tff(pred_def_72935,type,
    v124283: state_type > $o ).

tff(pred_def_72936,type,
    v124276: state_type > $o ).

tff(pred_def_72937,type,
    v124275: state_type > $o ).

tff(pred_def_72938,type,
    v124274: state_type > $o ).

tff(pred_def_72939,type,
    v124273: state_type > $o ).

tff(pred_def_72940,type,
    v124285: state_type > $o ).

tff(pred_def_72941,type,
    v124284: state_type > $o ).

tff(pred_def_72942,type,
    v124272: state_type > $o ).

tff(pred_def_72943,type,
    v124288: state_type > $o ).

tff(pred_def_72944,type,
    v124287: state_type > $o ).

tff(pred_def_72945,type,
    v124289: state_type > $o ).

tff(pred_def_72946,type,
    v124286: state_type > $o ).

tff(pred_def_72947,type,
    v124292: state_type > $o ).

tff(pred_def_72948,type,
    v124291: state_type > $o ).

tff(pred_def_72949,type,
    v124293: state_type > $o ).

tff(pred_def_72950,type,
    v124290: state_type > $o ).

tff(pred_def_72951,type,
    v124296: state_type > $o ).

tff(pred_def_72952,type,
    v124295: state_type > $o ).

tff(pred_def_72953,type,
    v124297: state_type > $o ).

tff(pred_def_72954,type,
    v124294: state_type > $o ).

tff(pred_def_72955,type,
    v124270: ( state_type * $int ) > $o ).

tff(pred_def_72956,type,
    v124232: state_type > $o ).

tff(pred_def_72957,type,
    v124269: ( state_type * $int ) > $o ).

tff(pred_def_72958,type,
    v124268: ( state_type * $int ) > $o ).

tff(pred_def_72959,type,
    v124254: ( state_type * $int ) > $o ).

tff(pred_def_72960,type,
    v124252: ( state_type * $int ) > $o ).

tff(pred_def_72961,type,
    v124250: ( state_type * $int ) > $o ).

tff(pred_def_72962,type,
    v124248: ( state_type * $int ) > $o ).

tff(pred_def_72963,type,
    v124301: state_type > $o ).

tff(pred_def_72964,type,
    v124299: state_type > $o ).

tff(pred_def_72965,type,
    v124308: state_type > $o ).

tff(pred_def_72966,type,
    v124306: state_type > $o ).

tff(pred_def_72967,type,
    v124305: state_type > $o ).

tff(pred_def_72968,type,
    v124304: state_type > $o ).

tff(pred_def_72969,type,
    v124316: state_type > $o ).

tff(pred_def_72970,type,
    v124317: state_type > $o ).

tff(pred_def_72971,type,
    v124315: state_type > $o ).

tff(pred_def_72972,type,
    v124312: ( state_type * $int ) > $o ).

tff(pred_def_72973,type,
    v124314: ( state_type * $int ) > $o ).

tff(pred_def_72974,type,
    v124238: ( state_type * $int ) > $o ).

tff(pred_def_72975,type,
    v124236: ( state_type * $int ) > $o ).

tff(pred_def_72976,type,
    v124322: state_type > $o ).

tff(pred_def_72977,type,
    v123523: state_type > $o ).

tff(pred_def_72978,type,
    v124338: state_type > $o ).

tff(pred_def_72979,type,
    v124336: state_type > $o ).

tff(pred_def_72980,type,
    v124334: state_type > $o ).

tff(pred_def_72981,type,
    v124332: state_type > $o ).

tff(pred_def_72982,type,
    v124346: state_type > $o ).

tff(pred_def_72983,type,
    v124344: state_type > $o ).

tff(pred_def_72984,type,
    v124342: state_type > $o ).

tff(pred_def_72985,type,
    v124340: state_type > $o ).

tff(pred_def_72986,type,
    v124366: state_type > $o ).

tff(pred_def_72987,type,
    v124364: state_type > $o ).

tff(pred_def_72988,type,
    v124370: state_type > $o ).

tff(pred_def_72989,type,
    v124368: state_type > $o ).

tff(pred_def_72990,type,
    v124382: state_type > $o ).

tff(pred_def_72991,type,
    v124384: state_type > $o ).

tff(pred_def_72992,type,
    v124386: state_type > $o ).

tff(pred_def_72993,type,
    v124388: state_type > $o ).

tff(pred_def_72994,type,
    v124390: state_type > $o ).

tff(pred_def_72995,type,
    v124392: state_type > $o ).

tff(pred_def_72996,type,
    v124394: state_type > $o ).

tff(pred_def_72997,type,
    v124443: ( state_type * $int ) > $o ).

tff(pred_def_72998,type,
    v124444: ( state_type * $int ) > $o ).

tff(pred_def_72999,type,
    v124442: state_type > $o ).

tff(pred_def_73000,type,
    v124447: state_type > $o ).

tff(pred_def_73001,type,
    v124448: state_type > $o ).

tff(pred_def_73002,type,
    v124446: state_type > $o ).

tff(pred_def_73003,type,
    v124449: state_type > $o ).

tff(pred_def_73004,type,
    v124445: state_type > $o ).

tff(pred_def_73005,type,
    v124441: state_type > $o ).

tff(pred_def_73006,type,
    v124450: state_type > $o ).

tff(pred_def_73007,type,
    v124440: state_type > $o ).

tff(pred_def_73008,type,
    v124439: state_type > $o ).

tff(pred_def_73009,type,
    v124454: state_type > $o ).

tff(pred_def_73010,type,
    v124455: state_type > $o ).

tff(pred_def_73011,type,
    v124453: state_type > $o ).

tff(pred_def_73012,type,
    v124456: state_type > $o ).

tff(pred_def_73013,type,
    v124452: state_type > $o ).

tff(pred_def_73014,type,
    v124451: state_type > $o ).

tff(pred_def_73015,type,
    v124438: state_type > $o ).

tff(pred_def_73016,type,
    v124457: state_type > $o ).

tff(pred_def_73017,type,
    v124437: state_type > $o ).

tff(pred_def_73018,type,
    v124460: state_type > $o ).

tff(pred_def_73019,type,
    v124461: state_type > $o ).

tff(pred_def_73020,type,
    v124459: state_type > $o ).

tff(pred_def_73021,type,
    v124462: state_type > $o ).

tff(pred_def_73022,type,
    v124458: state_type > $o ).

tff(pred_def_73023,type,
    v124465: state_type > $o ).

tff(pred_def_73024,type,
    v124466: state_type > $o ).

tff(pred_def_73025,type,
    v124464: state_type > $o ).

tff(pred_def_73026,type,
    v124467: state_type > $o ).

tff(pred_def_73027,type,
    v124463: state_type > $o ).

tff(pred_def_73028,type,
    v124435: ( state_type * $int ) > $o ).

tff(pred_def_73029,type,
    v124468: ( state_type * $int ) > $o ).

tff(pred_def_73030,type,
    v124434: state_type > $o ).

tff(pred_def_73031,type,
    v124471: state_type > $o ).

tff(pred_def_73032,type,
    v124472: state_type > $o ).

tff(pred_def_73033,type,
    v124470: state_type > $o ).

tff(pred_def_73034,type,
    v124473: state_type > $o ).

tff(pred_def_73035,type,
    v124469: state_type > $o ).

tff(pred_def_73036,type,
    v124433: state_type > $o ).

tff(pred_def_73037,type,
    v124474: state_type > $o ).

tff(pred_def_73038,type,
    v124432: state_type > $o ).

tff(pred_def_73039,type,
    v124431: state_type > $o ).

tff(pred_def_73040,type,
    v124478: state_type > $o ).

tff(pred_def_73041,type,
    v124479: state_type > $o ).

tff(pred_def_73042,type,
    v124477: state_type > $o ).

tff(pred_def_73043,type,
    v124480: state_type > $o ).

tff(pred_def_73044,type,
    v124476: state_type > $o ).

tff(pred_def_73045,type,
    v124475: state_type > $o ).

tff(pred_def_73046,type,
    v124430: state_type > $o ).

tff(pred_def_73047,type,
    v124481: state_type > $o ).

tff(pred_def_73048,type,
    v124429: state_type > $o ).

tff(pred_def_73049,type,
    v124484: state_type > $o ).

tff(pred_def_73050,type,
    v124485: state_type > $o ).

tff(pred_def_73051,type,
    v124483: state_type > $o ).

tff(pred_def_73052,type,
    v124486: state_type > $o ).

tff(pred_def_73053,type,
    v124482: state_type > $o ).

tff(pred_def_73054,type,
    v124489: state_type > $o ).

tff(pred_def_73055,type,
    v124490: state_type > $o ).

tff(pred_def_73056,type,
    v124488: state_type > $o ).

tff(pred_def_73057,type,
    v124491: state_type > $o ).

tff(pred_def_73058,type,
    v124487: state_type > $o ).

tff(pred_def_73059,type,
    v124427: ( state_type * $int ) > $o ).

tff(pred_def_73060,type,
    v124492: ( state_type * $int ) > $o ).

tff(pred_def_73061,type,
    v124426: state_type > $o ).

tff(pred_def_73062,type,
    v124495: state_type > $o ).

tff(pred_def_73063,type,
    v124496: state_type > $o ).

tff(pred_def_73064,type,
    v124494: state_type > $o ).

tff(pred_def_73065,type,
    v124497: state_type > $o ).

tff(pred_def_73066,type,
    v124493: state_type > $o ).

tff(pred_def_73067,type,
    v124425: state_type > $o ).

tff(pred_def_73068,type,
    v124498: state_type > $o ).

tff(pred_def_73069,type,
    v124424: state_type > $o ).

tff(pred_def_73070,type,
    v124423: state_type > $o ).

tff(pred_def_73071,type,
    v124502: state_type > $o ).

tff(pred_def_73072,type,
    v124503: state_type > $o ).

tff(pred_def_73073,type,
    v124501: state_type > $o ).

tff(pred_def_73074,type,
    v124504: state_type > $o ).

tff(pred_def_73075,type,
    v124500: state_type > $o ).

tff(pred_def_73076,type,
    v124499: state_type > $o ).

tff(pred_def_73077,type,
    v124422: state_type > $o ).

tff(pred_def_73078,type,
    v124505: state_type > $o ).

tff(pred_def_73079,type,
    v124421: state_type > $o ).

tff(pred_def_73080,type,
    v124508: state_type > $o ).

tff(pred_def_73081,type,
    v124509: state_type > $o ).

tff(pred_def_73082,type,
    v124507: state_type > $o ).

tff(pred_def_73083,type,
    v124510: state_type > $o ).

tff(pred_def_73084,type,
    v124506: state_type > $o ).

tff(pred_def_73085,type,
    v124513: state_type > $o ).

tff(pred_def_73086,type,
    v124514: state_type > $o ).

tff(pred_def_73087,type,
    v124512: state_type > $o ).

tff(pred_def_73088,type,
    v124515: state_type > $o ).

tff(pred_def_73089,type,
    v124511: state_type > $o ).

tff(pred_def_73090,type,
    v124419: ( state_type * $int ) > $o ).

tff(pred_def_73091,type,
    v124516: ( state_type * $int ) > $o ).

tff(pred_def_73092,type,
    v124418: state_type > $o ).

tff(pred_def_73093,type,
    v124519: state_type > $o ).

tff(pred_def_73094,type,
    v124520: state_type > $o ).

tff(pred_def_73095,type,
    v124518: state_type > $o ).

tff(pred_def_73096,type,
    v124521: state_type > $o ).

tff(pred_def_73097,type,
    v124517: state_type > $o ).

tff(pred_def_73098,type,
    v124417: state_type > $o ).

tff(pred_def_73099,type,
    v124522: state_type > $o ).

tff(pred_def_73100,type,
    v124416: state_type > $o ).

tff(pred_def_73101,type,
    v124415: state_type > $o ).

tff(pred_def_73102,type,
    v124526: state_type > $o ).

tff(pred_def_73103,type,
    v124527: state_type > $o ).

tff(pred_def_73104,type,
    v124525: state_type > $o ).

tff(pred_def_73105,type,
    v124528: state_type > $o ).

tff(pred_def_73106,type,
    v124524: state_type > $o ).

tff(pred_def_73107,type,
    v124523: state_type > $o ).

tff(pred_def_73108,type,
    v124414: state_type > $o ).

tff(pred_def_73109,type,
    v124529: state_type > $o ).

tff(pred_def_73110,type,
    v124413: state_type > $o ).

tff(pred_def_73111,type,
    v124532: state_type > $o ).

tff(pred_def_73112,type,
    v124533: state_type > $o ).

tff(pred_def_73113,type,
    v124531: state_type > $o ).

tff(pred_def_73114,type,
    v124534: state_type > $o ).

tff(pred_def_73115,type,
    v124530: state_type > $o ).

tff(pred_def_73116,type,
    v124537: state_type > $o ).

tff(pred_def_73117,type,
    v124538: state_type > $o ).

tff(pred_def_73118,type,
    v124536: state_type > $o ).

tff(pred_def_73119,type,
    v124539: state_type > $o ).

tff(pred_def_73120,type,
    v124535: state_type > $o ).

tff(pred_def_73121,type,
    v124411: ( state_type * $int ) > $o ).

tff(pred_def_73122,type,
    v124540: ( state_type * $int ) > $o ).

tff(pred_def_73123,type,
    v124410: state_type > $o ).

tff(pred_def_73124,type,
    v124543: state_type > $o ).

tff(pred_def_73125,type,
    v124544: state_type > $o ).

tff(pred_def_73126,type,
    v124542: state_type > $o ).

tff(pred_def_73127,type,
    v124545: state_type > $o ).

tff(pred_def_73128,type,
    v124541: state_type > $o ).

tff(pred_def_73129,type,
    v124409: state_type > $o ).

tff(pred_def_73130,type,
    v124546: state_type > $o ).

tff(pred_def_73131,type,
    v124408: state_type > $o ).

tff(pred_def_73132,type,
    v124407: state_type > $o ).

tff(pred_def_73133,type,
    v124550: state_type > $o ).

tff(pred_def_73134,type,
    v124551: state_type > $o ).

tff(pred_def_73135,type,
    v124549: state_type > $o ).

tff(pred_def_73136,type,
    v124552: state_type > $o ).

tff(pred_def_73137,type,
    v124548: state_type > $o ).

tff(pred_def_73138,type,
    v124547: state_type > $o ).

tff(pred_def_73139,type,
    v124406: state_type > $o ).

tff(pred_def_73140,type,
    v124553: state_type > $o ).

tff(pred_def_73141,type,
    v124405: state_type > $o ).

tff(pred_def_73142,type,
    v124556: state_type > $o ).

tff(pred_def_73143,type,
    v124557: state_type > $o ).

tff(pred_def_73144,type,
    v124555: state_type > $o ).

tff(pred_def_73145,type,
    v124558: state_type > $o ).

tff(pred_def_73146,type,
    v124554: state_type > $o ).

tff(pred_def_73147,type,
    v124561: state_type > $o ).

tff(pred_def_73148,type,
    v124562: state_type > $o ).

tff(pred_def_73149,type,
    v124560: state_type > $o ).

tff(pred_def_73150,type,
    v124563: state_type > $o ).

tff(pred_def_73151,type,
    v124559: state_type > $o ).

tff(pred_def_73152,type,
    v124403: ( state_type * $int ) > $o ).

tff(pred_def_73153,type,
    v124564: ( state_type * $int ) > $o ).

tff(pred_def_73154,type,
    v124402: state_type > $o ).

tff(pred_def_73155,type,
    v124567: state_type > $o ).

tff(pred_def_73156,type,
    v124568: state_type > $o ).

tff(pred_def_73157,type,
    v124566: state_type > $o ).

tff(pred_def_73158,type,
    v124569: state_type > $o ).

tff(pred_def_73159,type,
    v124565: state_type > $o ).

tff(pred_def_73160,type,
    v124401: state_type > $o ).

tff(pred_def_73161,type,
    v124570: state_type > $o ).

tff(pred_def_73162,type,
    v124400: state_type > $o ).

tff(pred_def_73163,type,
    v124399: state_type > $o ).

tff(pred_def_73164,type,
    v124574: state_type > $o ).

tff(pred_def_73165,type,
    v124575: state_type > $o ).

tff(pred_def_73166,type,
    v124573: state_type > $o ).

tff(pred_def_73167,type,
    v124576: state_type > $o ).

tff(pred_def_73168,type,
    v124572: state_type > $o ).

tff(pred_def_73169,type,
    v124571: state_type > $o ).

tff(pred_def_73170,type,
    v124398: state_type > $o ).

tff(pred_def_73171,type,
    v124577: state_type > $o ).

tff(pred_def_73172,type,
    v124397: state_type > $o ).

tff(pred_def_73173,type,
    v124580: state_type > $o ).

tff(pred_def_73174,type,
    v124581: state_type > $o ).

tff(pred_def_73175,type,
    v124579: state_type > $o ).

tff(pred_def_73176,type,
    v124582: state_type > $o ).

tff(pred_def_73177,type,
    v124578: state_type > $o ).

tff(pred_def_73178,type,
    v124585: state_type > $o ).

tff(pred_def_73179,type,
    v124586: state_type > $o ).

tff(pred_def_73180,type,
    v124584: state_type > $o ).

tff(pred_def_73181,type,
    v124587: state_type > $o ).

tff(pred_def_73182,type,
    v124583: state_type > $o ).

tff(pred_def_73183,type,
    v124395: ( state_type * $int ) > $o ).

tff(pred_def_73184,type,
    v124380: ( state_type * $int ) > $o ).

tff(pred_def_73185,type,
    v124597: state_type > $o ).

tff(pred_def_73186,type,
    v124595: state_type > $o ).

tff(pred_def_73187,type,
    v124594: state_type > $o ).

tff(pred_def_73188,type,
    v124593: ( state_type * $int ) > $o ).

tff(pred_def_73189,type,
    v124591: state_type > $o ).

tff(pred_def_73190,type,
    v124607: state_type > $o ).

tff(pred_def_73191,type,
    v124605: state_type > $o ).

tff(pred_def_73192,type,
    v124604: state_type > $o ).

tff(pred_def_73193,type,
    v124603: ( state_type * $int ) > $o ).

tff(pred_def_73194,type,
    v124601: state_type > $o ).

tff(pred_def_73195,type,
    v124617: state_type > $o ).

tff(pred_def_73196,type,
    v124615: state_type > $o ).

tff(pred_def_73197,type,
    v124614: state_type > $o ).

tff(pred_def_73198,type,
    v124613: ( state_type * $int ) > $o ).

tff(pred_def_73199,type,
    v124611: state_type > $o ).

tff(pred_def_73200,type,
    v124621: state_type > $o ).

tff(pred_def_73201,type,
    v124623: state_type > $o ).

tff(pred_def_73202,type,
    v124625: state_type > $o ).

tff(pred_def_73203,type,
    v124631: state_type > $o ).

tff(pred_def_73204,type,
    v124630: state_type > $o ).

tff(pred_def_73205,type,
    v124629: state_type > $o ).

tff(pred_def_73206,type,
    v124628: state_type > $o ).

tff(pred_def_73207,type,
    v124627: state_type > $o ).

tff(pred_def_73208,type,
    v124626: ( state_type * $int ) > $o ).

tff(pred_def_73209,type,
    v124589: ( state_type * $int ) > $o ).

tff(pred_def_73210,type,
    v124660: ( state_type * $int ) > $o ).

tff(pred_def_73211,type,
    v124358: ( state_type * $int ) > $o ).

tff(pred_def_73212,type,
    v124659: state_type > $o ).

tff(pred_def_73213,type,
    v124663: state_type > $o ).

tff(pred_def_73214,type,
    v124664: state_type > $o ).

tff(pred_def_73215,type,
    v124662: state_type > $o ).

tff(pred_def_73216,type,
    v124665: state_type > $o ).

tff(pred_def_73217,type,
    v124661: state_type > $o ).

tff(pred_def_73218,type,
    v124658: state_type > $o ).

tff(pred_def_73219,type,
    v124666: state_type > $o ).

tff(pred_def_73220,type,
    v124657: state_type > $o ).

tff(pred_def_73221,type,
    v124669: state_type > $o ).

tff(pred_def_73222,type,
    v124670: state_type > $o ).

tff(pred_def_73223,type,
    v124668: state_type > $o ).

tff(pred_def_73224,type,
    v124671: state_type > $o ).

tff(pred_def_73225,type,
    v124667: state_type > $o ).

tff(pred_def_73226,type,
    v124656: state_type > $o ).

tff(pred_def_73227,type,
    v124672: state_type > $o ).

tff(pred_def_73228,type,
    v124655: state_type > $o ).

tff(pred_def_73229,type,
    v124675: state_type > $o ).

tff(pred_def_73230,type,
    v124676: state_type > $o ).

tff(pred_def_73231,type,
    v124674: state_type > $o ).

tff(pred_def_73232,type,
    v124677: state_type > $o ).

tff(pred_def_73233,type,
    v124673: state_type > $o ).

tff(pred_def_73234,type,
    v124654: state_type > $o ).

tff(pred_def_73235,type,
    v124678: state_type > $o ).

tff(pred_def_73236,type,
    v124653: state_type > $o ).

tff(pred_def_73237,type,
    v124681: state_type > $o ).

tff(pred_def_73238,type,
    v124682: state_type > $o ).

tff(pred_def_73239,type,
    v124680: state_type > $o ).

tff(pred_def_73240,type,
    v124683: state_type > $o ).

tff(pred_def_73241,type,
    v124679: state_type > $o ).

tff(pred_def_73242,type,
    v124652: state_type > $o ).

tff(pred_def_73243,type,
    v124684: state_type > $o ).

tff(pred_def_73244,type,
    v124651: state_type > $o ).

tff(pred_def_73245,type,
    v124650: state_type > $o ).

tff(pred_def_73246,type,
    v124688: state_type > $o ).

tff(pred_def_73247,type,
    v124689: state_type > $o ).

tff(pred_def_73248,type,
    v124687: state_type > $o ).

tff(pred_def_73249,type,
    v124690: state_type > $o ).

tff(pred_def_73250,type,
    v124686: state_type > $o ).

tff(pred_def_73251,type,
    v124685: state_type > $o ).

tff(pred_def_73252,type,
    v124649: state_type > $o ).

tff(pred_def_73253,type,
    v124691: state_type > $o ).

tff(pred_def_73254,type,
    v124648: state_type > $o ).

tff(pred_def_73255,type,
    v124694: state_type > $o ).

tff(pred_def_73256,type,
    v124695: state_type > $o ).

tff(pred_def_73257,type,
    v124693: state_type > $o ).

tff(pred_def_73258,type,
    v124696: state_type > $o ).

tff(pred_def_73259,type,
    v124692: state_type > $o ).

tff(pred_def_73260,type,
    v124699: state_type > $o ).

tff(pred_def_73261,type,
    v124700: state_type > $o ).

tff(pred_def_73262,type,
    v124698: state_type > $o ).

tff(pred_def_73263,type,
    v124701: state_type > $o ).

tff(pred_def_73264,type,
    v124697: state_type > $o ).

tff(pred_def_73265,type,
    v124704: state_type > $o ).

tff(pred_def_73266,type,
    v124705: state_type > $o ).

tff(pred_def_73267,type,
    v124703: state_type > $o ).

tff(pred_def_73268,type,
    v124706: state_type > $o ).

tff(pred_def_73269,type,
    v124702: state_type > $o ).

tff(pred_def_73270,type,
    v124709: state_type > $o ).

tff(pred_def_73271,type,
    v124710: state_type > $o ).

tff(pred_def_73272,type,
    v124708: state_type > $o ).

tff(pred_def_73273,type,
    v124711: state_type > $o ).

tff(pred_def_73274,type,
    v124707: state_type > $o ).

tff(pred_def_73275,type,
    v124714: state_type > $o ).

tff(pred_def_73276,type,
    v124715: state_type > $o ).

tff(pred_def_73277,type,
    v124713: state_type > $o ).

tff(pred_def_73278,type,
    v124716: state_type > $o ).

tff(pred_def_73279,type,
    v124712: state_type > $o ).

tff(pred_def_73280,type,
    v124646: ( state_type * $int ) > $o ).

tff(pred_def_73281,type,
    v124645: state_type > $o ).

tff(pred_def_73282,type,
    v124721: state_type > $o ).

tff(pred_def_73283,type,
    v124723: state_type > $o ).

tff(pred_def_73284,type,
    v124724: state_type > $o ).

tff(pred_def_73285,type,
    v124722: state_type > $o ).

tff(pred_def_73286,type,
    v124720: state_type > $o ).

tff(pred_def_73287,type,
    v124719: state_type > $o ).

tff(pred_def_73288,type,
    v124725: state_type > $o ).

tff(pred_def_73289,type,
    v124718: state_type > $o ).

tff(pred_def_73290,type,
    v124726: state_type > $o ).

tff(pred_def_73291,type,
    v124717: state_type > $o ).

tff(pred_def_73292,type,
    v124644: state_type > $o ).

tff(pred_def_73293,type,
    v124727: state_type > $o ).

tff(pred_def_73294,type,
    v124643: state_type > $o ).

tff(pred_def_73295,type,
    v124734: state_type > $o ).

tff(pred_def_73296,type,
    v124733: state_type > $o ).

tff(pred_def_73297,type,
    v124732: state_type > $o ).

tff(pred_def_73298,type,
    v124736: state_type > $o ).

tff(pred_def_73299,type,
    v124735: state_type > $o ).

tff(pred_def_73300,type,
    v124731: state_type > $o ).

tff(pred_def_73301,type,
    v124730: state_type > $o ).

tff(pred_def_73302,type,
    v124737: state_type > $o ).

tff(pred_def_73303,type,
    v124729: state_type > $o ).

tff(pred_def_73304,type,
    v124738: state_type > $o ).

tff(pred_def_73305,type,
    v124728: state_type > $o ).

tff(pred_def_73306,type,
    v124642: state_type > $o ).

tff(pred_def_73307,type,
    v124739: state_type > $o ).

tff(pred_def_73308,type,
    v124641: state_type > $o ).

tff(pred_def_73309,type,
    v124746: state_type > $o ).

tff(pred_def_73310,type,
    v124745: state_type > $o ).

tff(pred_def_73311,type,
    v124744: state_type > $o ).

tff(pred_def_73312,type,
    v124748: state_type > $o ).

tff(pred_def_73313,type,
    v124747: state_type > $o ).

tff(pred_def_73314,type,
    v124743: state_type > $o ).

tff(pred_def_73315,type,
    v124742: state_type > $o ).

tff(pred_def_73316,type,
    v124749: state_type > $o ).

tff(pred_def_73317,type,
    v124741: state_type > $o ).

tff(pred_def_73318,type,
    v124750: state_type > $o ).

tff(pred_def_73319,type,
    v124740: state_type > $o ).

tff(pred_def_73320,type,
    v124640: state_type > $o ).

tff(pred_def_73321,type,
    v124751: state_type > $o ).

tff(pred_def_73322,type,
    v124639: state_type > $o ).

tff(pred_def_73323,type,
    v124758: state_type > $o ).

tff(pred_def_73324,type,
    v124757: state_type > $o ).

tff(pred_def_73325,type,
    v124756: state_type > $o ).

tff(pred_def_73326,type,
    v124760: state_type > $o ).

tff(pred_def_73327,type,
    v124759: state_type > $o ).

tff(pred_def_73328,type,
    v124755: state_type > $o ).

tff(pred_def_73329,type,
    v124754: state_type > $o ).

tff(pred_def_73330,type,
    v124761: state_type > $o ).

tff(pred_def_73331,type,
    v124753: state_type > $o ).

tff(pred_def_73332,type,
    v124762: state_type > $o ).

tff(pred_def_73333,type,
    v124752: state_type > $o ).

tff(pred_def_73334,type,
    v124638: state_type > $o ).

tff(pred_def_73335,type,
    v124763: state_type > $o ).

tff(pred_def_73336,type,
    v124637: state_type > $o ).

tff(pred_def_73337,type,
    v124636: state_type > $o ).

tff(pred_def_73338,type,
    v124771: state_type > $o ).

tff(pred_def_73339,type,
    v124770: state_type > $o ).

tff(pred_def_73340,type,
    v124769: state_type > $o ).

tff(pred_def_73341,type,
    v124773: state_type > $o ).

tff(pred_def_73342,type,
    v124772: state_type > $o ).

tff(pred_def_73343,type,
    v124768: state_type > $o ).

tff(pred_def_73344,type,
    v124767: state_type > $o ).

tff(pred_def_73345,type,
    v124774: state_type > $o ).

tff(pred_def_73346,type,
    v124766: state_type > $o ).

tff(pred_def_73347,type,
    v124775: state_type > $o ).

tff(pred_def_73348,type,
    v124765: state_type > $o ).

tff(pred_def_73349,type,
    v124764: state_type > $o ).

tff(pred_def_73350,type,
    v124635: state_type > $o ).

tff(pred_def_73351,type,
    v124776: state_type > $o ).

tff(pred_def_73352,type,
    v124634: state_type > $o ).

tff(pred_def_73353,type,
    v124779: state_type > $o ).

tff(pred_def_73354,type,
    v124780: state_type > $o ).

tff(pred_def_73355,type,
    v124778: state_type > $o ).

tff(pred_def_73356,type,
    v124781: state_type > $o ).

tff(pred_def_73357,type,
    v124777: state_type > $o ).

tff(pred_def_73358,type,
    v124784: state_type > $o ).

tff(pred_def_73359,type,
    v124785: state_type > $o ).

tff(pred_def_73360,type,
    v124783: state_type > $o ).

tff(pred_def_73361,type,
    v124786: state_type > $o ).

tff(pred_def_73362,type,
    v124782: state_type > $o ).

tff(pred_def_73363,type,
    v124789: state_type > $o ).

tff(pred_def_73364,type,
    v124790: state_type > $o ).

tff(pred_def_73365,type,
    v124788: state_type > $o ).

tff(pred_def_73366,type,
    v124791: state_type > $o ).

tff(pred_def_73367,type,
    v124787: state_type > $o ).

tff(pred_def_73368,type,
    v124794: state_type > $o ).

tff(pred_def_73369,type,
    v124795: state_type > $o ).

tff(pred_def_73370,type,
    v124793: state_type > $o ).

tff(pred_def_73371,type,
    v124796: state_type > $o ).

tff(pred_def_73372,type,
    v124792: state_type > $o ).

tff(pred_def_73373,type,
    v124799: state_type > $o ).

tff(pred_def_73374,type,
    v124798: state_type > $o ).

tff(pred_def_73375,type,
    v124800: state_type > $o ).

tff(pred_def_73376,type,
    v124797: state_type > $o ).

tff(pred_def_73377,type,
    v124378: ( state_type * $int ) > $o ).

tff(pred_def_73378,type,
    v124376: ( state_type * $int ) > $o ).

tff(pred_def_73379,type,
    v124374: ( state_type * $int ) > $o ).

tff(pred_def_73380,type,
    v124372: ( state_type * $int ) > $o ).

tff(pred_def_73381,type,
    v124806: state_type > $o ).

tff(pred_def_73382,type,
    v124804: state_type > $o ).

tff(pred_def_73383,type,
    v124802: state_type > $o ).

tff(pred_def_73384,type,
    v124813: state_type > $o ).

tff(pred_def_73385,type,
    v124811: state_type > $o ).

tff(pred_def_73386,type,
    v124810: state_type > $o ).

tff(pred_def_73387,type,
    v124809: state_type > $o ).

tff(pred_def_73388,type,
    v124821: state_type > $o ).

tff(pred_def_73389,type,
    v124822: state_type > $o ).

tff(pred_def_73390,type,
    v124820: state_type > $o ).

tff(pred_def_73391,type,
    v124817: ( state_type * $int ) > $o ).

tff(pred_def_73392,type,
    v124819: ( state_type * $int ) > $o ).

tff(pred_def_73393,type,
    v124362: ( state_type * $int ) > $o ).

tff(pred_def_73394,type,
    v124360: ( state_type * $int ) > $o ).

tff(pred_def_73395,type,
    v124826: state_type > $o ).

tff(pred_def_73396,type,
    v124828: state_type > $o ).

tff(pred_def_73397,type,
    v124829: state_type > $o ).

tff(pred_def_73398,type,
    v124356: state_type > $o ).

tff(pred_def_73399,type,
    v124831: state_type > $o ).

tff(pred_def_73400,type,
    v124833: state_type > $o ).

tff(pred_def_73401,type,
    v124839: state_type > $o ).

tff(pred_def_73402,type,
    v124841: state_type > $o ).

tff(pred_def_73403,type,
    v124851: state_type > $o ).

tff(pred_def_73404,type,
    v124852: state_type > $o ).

tff(pred_def_73405,type,
    v124850: state_type > $o ).

tff(pred_def_73406,type,
    v124854: state_type > $o ).

tff(pred_def_73407,type,
    v124855: state_type > $o ).

tff(pred_def_73408,type,
    v124853: state_type > $o ).

tff(pred_def_73409,type,
    v124849: state_type > $o ).

tff(pred_def_73410,type,
    v124848: state_type > $o ).

tff(pred_def_73411,type,
    v124847: state_type > $o ).

tff(pred_def_73412,type,
    v124846: state_type > $o ).

tff(pred_def_73413,type,
    v124326: ( state_type * $int ) > $o ).

tff(pred_def_73414,type,
    v124856: state_type > $o ).

tff(pred_def_73415,type,
    v124845: state_type > $o ).

tff(pred_def_73416,type,
    v124858: state_type > $o ).

tff(pred_def_73417,type,
    v124857: state_type > $o ).

tff(pred_def_73418,type,
    v124844: state_type > $o ).

tff(pred_def_73419,type,
    v124860: state_type > $o ).

tff(pred_def_73420,type,
    v124866: state_type > $o ).

tff(pred_def_73421,type,
    v124867: state_type > $o ).

tff(pred_def_73422,type,
    v124865: state_type > $o ).

tff(pred_def_73423,type,
    v124864: state_type > $o ).

tff(pred_def_73424,type,
    v124870: state_type > $o ).

tff(pred_def_73425,type,
    v124869: state_type > $o ).

tff(pred_def_73426,type,
    v124868: state_type > $o ).

tff(pred_def_73427,type,
    v124863: state_type > $o ).

tff(pred_def_73428,type,
    v124871: state_type > $o ).

tff(pred_def_73429,type,
    v124862: state_type > $o ).

tff(pred_def_73430,type,
    v124872: state_type > $o ).

tff(pred_def_73431,type,
    v124861: state_type > $o ).

tff(pred_def_73432,type,
    v124859: state_type > $o ).

tff(pred_def_73433,type,
    v124843: state_type > $o ).

tff(pred_def_73434,type,
    v124354: ( state_type * $int ) > $o ).

tff(pred_def_73435,type,
    v124873: ( state_type * $int ) > $o ).

tff(pred_def_73436,type,
    v124837: state_type > $o ).

tff(pred_def_73437,type,
    v124352: ( state_type * $int ) > $o ).

tff(pred_def_73438,type,
    v124350: ( state_type * $int ) > $o ).

tff(pred_def_73439,type,
    v124348: ( state_type * $int ) > $o ).

tff(pred_def_73440,type,
    v124877: state_type > $o ).

tff(pred_def_73441,type,
    v124875: state_type > $o ).

tff(pred_def_73442,type,
    v124884: state_type > $o ).

tff(pred_def_73443,type,
    v124882: state_type > $o ).

tff(pred_def_73444,type,
    v124881: state_type > $o ).

tff(pred_def_73445,type,
    v124880: state_type > $o ).

tff(pred_def_73446,type,
    v124892: state_type > $o ).

tff(pred_def_73447,type,
    v124893: state_type > $o ).

tff(pred_def_73448,type,
    v124891: state_type > $o ).

tff(pred_def_73449,type,
    v124888: ( state_type * $int ) > $o ).

tff(pred_def_73450,type,
    v124890: ( state_type * $int ) > $o ).

tff(pred_def_73451,type,
    v124879: ( state_type * $int ) > $o ).

tff(pred_def_73452,type,
    v124330: ( state_type * $int ) > $o ).

tff(pred_def_73453,type,
    v124328: ( state_type * $int ) > $o ).

tff(pred_def_73454,type,
    v124897: state_type > $o ).

tff(pred_def_73455,type,
    v124903: state_type > $o ).

tff(pred_def_73456,type,
    v124902: state_type > $o ).

tff(pred_def_73457,type,
    v124901: state_type > $o ).

tff(pred_def_73458,type,
    v124905: state_type > $o ).

tff(pred_def_73459,type,
    v124904: state_type > $o ).

tff(pred_def_73460,type,
    v124900: state_type > $o ).

tff(pred_def_73461,type,
    v124907: state_type > $o ).

tff(pred_def_73462,type,
    v124913: state_type > $o ).

tff(pred_def_73463,type,
    v124912: state_type > $o ).

tff(pred_def_73464,type,
    v124911: state_type > $o ).

tff(pred_def_73465,type,
    v124910: state_type > $o ).

tff(pred_def_73466,type,
    v124914: state_type > $o ).

tff(pred_def_73467,type,
    v124909: state_type > $o ).

tff(pred_def_73468,type,
    v124915: state_type > $o ).

tff(pred_def_73469,type,
    v124908: state_type > $o ).

tff(pred_def_73470,type,
    v124906: state_type > $o ).

tff(pred_def_73471,type,
    v124899: state_type > $o ).

tff(pred_def_73472,type,
    v124921: state_type > $o ).

tff(pred_def_73473,type,
    v124919: state_type > $o ).

tff(pred_def_73474,type,
    v124918: state_type > $o ).

tff(pred_def_73475,type,
    v124917: ( state_type * $int ) > $o ).

tff(pred_def_73476,type,
    v124931: state_type > $o ).

tff(pred_def_73477,type,
    v124930: state_type > $o ).

tff(pred_def_73478,type,
    v124929: state_type > $o ).

tff(pred_def_73479,type,
    v124928: state_type > $o ).

tff(pred_def_73480,type,
    v124933: state_type > $o ).

tff(pred_def_73481,type,
    v124934: state_type > $o ).

tff(pred_def_73482,type,
    v124932: state_type > $o ).

tff(pred_def_73483,type,
    v124927: state_type > $o ).

tff(pred_def_73484,type,
    v124937: state_type > $o ).

tff(pred_def_73485,type,
    v124936: state_type > $o ).

tff(pred_def_73486,type,
    v124938: state_type > $o ).

tff(pred_def_73487,type,
    v124935: state_type > $o ).

tff(pred_def_73488,type,
    v124926: state_type > $o ).

tff(pred_def_73489,type,
    v124942: state_type > $o ).

tff(pred_def_73490,type,
    v124941: state_type > $o ).

tff(pred_def_73491,type,
    v124940: state_type > $o ).

tff(pred_def_73492,type,
    v124943: state_type > $o ).

tff(pred_def_73493,type,
    v124939: state_type > $o ).

tff(pred_def_73494,type,
    v124925: state_type > $o ).

tff(pred_def_73495,type,
    v124950: state_type > $o ).

tff(pred_def_73496,type,
    v124948: state_type > $o ).

tff(pred_def_73497,type,
    v124947: state_type > $o ).

tff(pred_def_73498,type,
    v124946: ( state_type * $int ) > $o ).

tff(pred_def_73499,type,
    v124835: state_type > $o ).

tff(pred_def_73500,type,
    v124956: state_type > $o ).

tff(pred_def_73501,type,
    v124958: state_type > $o ).

tff(pred_def_73502,type,
    v124961: state_type > $o ).

tff(pred_def_73503,type,
    v124962: state_type > $o ).

tff(pred_def_73504,type,
    v124960: state_type > $o ).

tff(pred_def_73505,type,
    v124959: state_type > $o ).

tff(pred_def_73506,type,
    v124957: state_type > $o ).

tff(pred_def_73507,type,
    v124955: state_type > $o ).

tff(pred_def_73508,type,
    v124968: state_type > $o ).

tff(pred_def_73509,type,
    v124966: state_type > $o ).

tff(pred_def_73510,type,
    v124965: state_type > $o ).

tff(pred_def_73511,type,
    v124964: ( state_type * $int ) > $o ).

tff(pred_def_73512,type,
    v124982: state_type > $o ).

tff(pred_def_73513,type,
    v124980: state_type > $o ).

tff(pred_def_73514,type,
    v124986: state_type > $o ).

tff(pred_def_73515,type,
    v124984: state_type > $o ).

tff(pred_def_73516,type,
    v124998: state_type > $o ).

tff(pred_def_73517,type,
    v124999: state_type > $o ).

tff(pred_def_73518,type,
    v124996: state_type > $o ).

tff(pred_def_73519,type,
    v124974: ( state_type * $int ) > $o ).

tff(pred_def_73520,type,
    v125006: state_type > $o ).

tff(pred_def_73521,type,
    v125005: state_type > $o ).

tff(pred_def_73522,type,
    v125008: state_type > $o ).

tff(pred_def_73523,type,
    v125007: state_type > $o ).

tff(pred_def_73524,type,
    v125004: state_type > $o ).

tff(pred_def_73525,type,
    v125002: ( state_type * $int ) > $o ).

tff(pred_def_73526,type,
    v124972: state_type > $o ).

tff(pred_def_73527,type,
    v125001: ( state_type * $int ) > $o ).

tff(pred_def_73528,type,
    v124994: ( state_type * $int ) > $o ).

tff(pred_def_73529,type,
    v124992: ( state_type * $int ) > $o ).

tff(pred_def_73530,type,
    v124990: ( state_type * $int ) > $o ).

tff(pred_def_73531,type,
    v124988: ( state_type * $int ) > $o ).

tff(pred_def_73532,type,
    v125012: state_type > $o ).

tff(pred_def_73533,type,
    v125010: state_type > $o ).

tff(pred_def_73534,type,
    v125019: state_type > $o ).

tff(pred_def_73535,type,
    v125017: state_type > $o ).

tff(pred_def_73536,type,
    v125016: state_type > $o ).

tff(pred_def_73537,type,
    v125015: state_type > $o ).

tff(pred_def_73538,type,
    v125027: state_type > $o ).

tff(pred_def_73539,type,
    v125028: state_type > $o ).

tff(pred_def_73540,type,
    v125026: state_type > $o ).

tff(pred_def_73541,type,
    v125023: ( state_type * $int ) > $o ).

tff(pred_def_73542,type,
    v125025: ( state_type * $int ) > $o ).

tff(pred_def_73543,type,
    v124978: ( state_type * $int ) > $o ).

tff(pred_def_73544,type,
    v124976: ( state_type * $int ) > $o ).

tff(pred_def_73545,type,
    v125043: state_type > $o ).

tff(pred_def_73546,type,
    v125041: state_type > $o ).

tff(pred_def_73547,type,
    v125047: state_type > $o ).

tff(pred_def_73548,type,
    v125045: state_type > $o ).

tff(pred_def_73549,type,
    v125060: state_type > $o ).

tff(pred_def_73550,type,
    v125059: state_type > $o ).

tff(pred_def_73551,type,
    v125057: state_type > $o ).

tff(pred_def_73552,type,
    v125062: ( state_type * $int ) > $o ).

tff(pred_def_73553,type,
    v125064: state_type > $o ).

tff(pred_def_73554,type,
    v125067: ( state_type * $int ) > $o ).

tff(pred_def_73555,type,
    v125035: ( state_type * $int ) > $o ).

tff(pred_def_73556,type,
    v125082: state_type > $o ).

tff(pred_def_73557,type,
    v125081: state_type > $o ).

tff(pred_def_73558,type,
    v125080: state_type > $o ).

tff(pred_def_73559,type,
    v125083: state_type > $o ).

tff(pred_def_73560,type,
    v125079: state_type > $o ).

tff(pred_def_73561,type,
    v125078: state_type > $o ).

tff(pred_def_73562,type,
    v125084: state_type > $o ).

tff(pred_def_73563,type,
    v125077: state_type > $o ).

tff(pred_def_73564,type,
    v125076: state_type > $o ).

tff(pred_def_73565,type,
    v125075: state_type > $o ).

tff(pred_def_73566,type,
    v125074: state_type > $o ).

tff(pred_def_73567,type,
    v125086: state_type > $o ).

tff(pred_def_73568,type,
    v125085: state_type > $o ).

tff(pred_def_73569,type,
    v125073: state_type > $o ).

tff(pred_def_73570,type,
    v125089: state_type > $o ).

tff(pred_def_73571,type,
    v125088: state_type > $o ).

tff(pred_def_73572,type,
    v125090: state_type > $o ).

tff(pred_def_73573,type,
    v125087: state_type > $o ).

tff(pred_def_73574,type,
    v125093: state_type > $o ).

tff(pred_def_73575,type,
    v125092: state_type > $o ).

tff(pred_def_73576,type,
    v125094: state_type > $o ).

tff(pred_def_73577,type,
    v125091: state_type > $o ).

tff(pred_def_73578,type,
    v125097: state_type > $o ).

tff(pred_def_73579,type,
    v125096: state_type > $o ).

tff(pred_def_73580,type,
    v125098: state_type > $o ).

tff(pred_def_73581,type,
    v125095: state_type > $o ).

tff(pred_def_73582,type,
    v125071: ( state_type * $int ) > $o ).

tff(pred_def_73583,type,
    v125033: state_type > $o ).

tff(pred_def_73584,type,
    v125070: ( state_type * $int ) > $o ).

tff(pred_def_73585,type,
    v125069: ( state_type * $int ) > $o ).

tff(pred_def_73586,type,
    v125055: ( state_type * $int ) > $o ).

tff(pred_def_73587,type,
    v125053: ( state_type * $int ) > $o ).

tff(pred_def_73588,type,
    v125051: ( state_type * $int ) > $o ).

tff(pred_def_73589,type,
    v125049: ( state_type * $int ) > $o ).

tff(pred_def_73590,type,
    v125102: state_type > $o ).

tff(pred_def_73591,type,
    v125100: state_type > $o ).

tff(pred_def_73592,type,
    v125109: state_type > $o ).

tff(pred_def_73593,type,
    v125107: state_type > $o ).

tff(pred_def_73594,type,
    v125106: state_type > $o ).

tff(pred_def_73595,type,
    v125105: state_type > $o ).

tff(pred_def_73596,type,
    v125117: state_type > $o ).

tff(pred_def_73597,type,
    v125118: state_type > $o ).

tff(pred_def_73598,type,
    v125116: state_type > $o ).

tff(pred_def_73599,type,
    v125113: ( state_type * $int ) > $o ).

tff(pred_def_73600,type,
    v125115: ( state_type * $int ) > $o ).

tff(pred_def_73601,type,
    v125039: ( state_type * $int ) > $o ).

tff(pred_def_73602,type,
    v125037: ( state_type * $int ) > $o ).

tff(pred_def_73603,type,
    v125123: state_type > $o ).

tff(pred_def_73604,type,
    v124324: state_type > $o ).

tff(pred_def_73605,type,
    v125139: state_type > $o ).

tff(pred_def_73606,type,
    v125137: state_type > $o ).

tff(pred_def_73607,type,
    v125135: state_type > $o ).

tff(pred_def_73608,type,
    v125133: state_type > $o ).

tff(pred_def_73609,type,
    v125147: state_type > $o ).

tff(pred_def_73610,type,
    v125145: state_type > $o ).

tff(pred_def_73611,type,
    v125143: state_type > $o ).

tff(pred_def_73612,type,
    v125141: state_type > $o ).

tff(pred_def_73613,type,
    v125167: state_type > $o ).

tff(pred_def_73614,type,
    v125165: state_type > $o ).

tff(pred_def_73615,type,
    v125171: state_type > $o ).

tff(pred_def_73616,type,
    v125169: state_type > $o ).

tff(pred_def_73617,type,
    v125183: state_type > $o ).

tff(pred_def_73618,type,
    v125185: state_type > $o ).

tff(pred_def_73619,type,
    v125187: state_type > $o ).

tff(pred_def_73620,type,
    v125189: state_type > $o ).

tff(pred_def_73621,type,
    v125191: state_type > $o ).

tff(pred_def_73622,type,
    v125193: state_type > $o ).

tff(pred_def_73623,type,
    v125195: state_type > $o ).

tff(pred_def_73624,type,
    v125244: ( state_type * $int ) > $o ).

tff(pred_def_73625,type,
    v125245: ( state_type * $int ) > $o ).

tff(pred_def_73626,type,
    v125243: state_type > $o ).

tff(pred_def_73627,type,
    v125248: state_type > $o ).

tff(pred_def_73628,type,
    v125249: state_type > $o ).

tff(pred_def_73629,type,
    v125247: state_type > $o ).

tff(pred_def_73630,type,
    v125250: state_type > $o ).

tff(pred_def_73631,type,
    v125246: state_type > $o ).

tff(pred_def_73632,type,
    v125242: state_type > $o ).

tff(pred_def_73633,type,
    v125251: state_type > $o ).

tff(pred_def_73634,type,
    v125241: state_type > $o ).

tff(pred_def_73635,type,
    v125240: state_type > $o ).

tff(pred_def_73636,type,
    v125255: state_type > $o ).

tff(pred_def_73637,type,
    v125256: state_type > $o ).

tff(pred_def_73638,type,
    v125254: state_type > $o ).

tff(pred_def_73639,type,
    v125257: state_type > $o ).

tff(pred_def_73640,type,
    v125253: state_type > $o ).

tff(pred_def_73641,type,
    v125252: state_type > $o ).

tff(pred_def_73642,type,
    v125239: state_type > $o ).

tff(pred_def_73643,type,
    v125258: state_type > $o ).

tff(pred_def_73644,type,
    v125238: state_type > $o ).

tff(pred_def_73645,type,
    v125261: state_type > $o ).

tff(pred_def_73646,type,
    v125262: state_type > $o ).

tff(pred_def_73647,type,
    v125260: state_type > $o ).

tff(pred_def_73648,type,
    v125263: state_type > $o ).

tff(pred_def_73649,type,
    v125259: state_type > $o ).

tff(pred_def_73650,type,
    v125266: state_type > $o ).

tff(pred_def_73651,type,
    v125267: state_type > $o ).

tff(pred_def_73652,type,
    v125265: state_type > $o ).

tff(pred_def_73653,type,
    v125268: state_type > $o ).

tff(pred_def_73654,type,
    v125264: state_type > $o ).

tff(pred_def_73655,type,
    v125236: ( state_type * $int ) > $o ).

tff(pred_def_73656,type,
    v125269: ( state_type * $int ) > $o ).

tff(pred_def_73657,type,
    v125235: state_type > $o ).

tff(pred_def_73658,type,
    v125272: state_type > $o ).

tff(pred_def_73659,type,
    v125273: state_type > $o ).

tff(pred_def_73660,type,
    v125271: state_type > $o ).

tff(pred_def_73661,type,
    v125274: state_type > $o ).

tff(pred_def_73662,type,
    v125270: state_type > $o ).

tff(pred_def_73663,type,
    v125234: state_type > $o ).

tff(pred_def_73664,type,
    v125275: state_type > $o ).

tff(pred_def_73665,type,
    v125233: state_type > $o ).

tff(pred_def_73666,type,
    v125232: state_type > $o ).

tff(pred_def_73667,type,
    v125279: state_type > $o ).

tff(pred_def_73668,type,
    v125280: state_type > $o ).

tff(pred_def_73669,type,
    v125278: state_type > $o ).

tff(pred_def_73670,type,
    v125281: state_type > $o ).

tff(pred_def_73671,type,
    v125277: state_type > $o ).

tff(pred_def_73672,type,
    v125276: state_type > $o ).

tff(pred_def_73673,type,
    v125231: state_type > $o ).

tff(pred_def_73674,type,
    v125282: state_type > $o ).

tff(pred_def_73675,type,
    v125230: state_type > $o ).

tff(pred_def_73676,type,
    v125285: state_type > $o ).

tff(pred_def_73677,type,
    v125286: state_type > $o ).

tff(pred_def_73678,type,
    v125284: state_type > $o ).

tff(pred_def_73679,type,
    v125287: state_type > $o ).

tff(pred_def_73680,type,
    v125283: state_type > $o ).

tff(pred_def_73681,type,
    v125290: state_type > $o ).

tff(pred_def_73682,type,
    v125291: state_type > $o ).

tff(pred_def_73683,type,
    v125289: state_type > $o ).

tff(pred_def_73684,type,
    v125292: state_type > $o ).

tff(pred_def_73685,type,
    v125288: state_type > $o ).

tff(pred_def_73686,type,
    v125228: ( state_type * $int ) > $o ).

tff(pred_def_73687,type,
    v125293: ( state_type * $int ) > $o ).

tff(pred_def_73688,type,
    v125227: state_type > $o ).

tff(pred_def_73689,type,
    v125296: state_type > $o ).

tff(pred_def_73690,type,
    v125297: state_type > $o ).

tff(pred_def_73691,type,
    v125295: state_type > $o ).

tff(pred_def_73692,type,
    v125298: state_type > $o ).

tff(pred_def_73693,type,
    v125294: state_type > $o ).

tff(pred_def_73694,type,
    v125226: state_type > $o ).

tff(pred_def_73695,type,
    v125299: state_type > $o ).

tff(pred_def_73696,type,
    v125225: state_type > $o ).

tff(pred_def_73697,type,
    v125224: state_type > $o ).

tff(pred_def_73698,type,
    v125303: state_type > $o ).

tff(pred_def_73699,type,
    v125304: state_type > $o ).

tff(pred_def_73700,type,
    v125302: state_type > $o ).

tff(pred_def_73701,type,
    v125305: state_type > $o ).

tff(pred_def_73702,type,
    v125301: state_type > $o ).

tff(pred_def_73703,type,
    v125300: state_type > $o ).

tff(pred_def_73704,type,
    v125223: state_type > $o ).

tff(pred_def_73705,type,
    v125306: state_type > $o ).

tff(pred_def_73706,type,
    v125222: state_type > $o ).

tff(pred_def_73707,type,
    v125309: state_type > $o ).

tff(pred_def_73708,type,
    v125310: state_type > $o ).

tff(pred_def_73709,type,
    v125308: state_type > $o ).

tff(pred_def_73710,type,
    v125311: state_type > $o ).

tff(pred_def_73711,type,
    v125307: state_type > $o ).

tff(pred_def_73712,type,
    v125314: state_type > $o ).

tff(pred_def_73713,type,
    v125315: state_type > $o ).

tff(pred_def_73714,type,
    v125313: state_type > $o ).

tff(pred_def_73715,type,
    v125316: state_type > $o ).

tff(pred_def_73716,type,
    v125312: state_type > $o ).

tff(pred_def_73717,type,
    v125220: ( state_type * $int ) > $o ).

tff(pred_def_73718,type,
    v125317: ( state_type * $int ) > $o ).

tff(pred_def_73719,type,
    v125219: state_type > $o ).

tff(pred_def_73720,type,
    v125320: state_type > $o ).

tff(pred_def_73721,type,
    v125321: state_type > $o ).

tff(pred_def_73722,type,
    v125319: state_type > $o ).

tff(pred_def_73723,type,
    v125322: state_type > $o ).

tff(pred_def_73724,type,
    v125318: state_type > $o ).

tff(pred_def_73725,type,
    v125218: state_type > $o ).

tff(pred_def_73726,type,
    v125323: state_type > $o ).

tff(pred_def_73727,type,
    v125217: state_type > $o ).

tff(pred_def_73728,type,
    v125216: state_type > $o ).

tff(pred_def_73729,type,
    v125327: state_type > $o ).

tff(pred_def_73730,type,
    v125328: state_type > $o ).

tff(pred_def_73731,type,
    v125326: state_type > $o ).

tff(pred_def_73732,type,
    v125329: state_type > $o ).

tff(pred_def_73733,type,
    v125325: state_type > $o ).

tff(pred_def_73734,type,
    v125324: state_type > $o ).

tff(pred_def_73735,type,
    v125215: state_type > $o ).

tff(pred_def_73736,type,
    v125330: state_type > $o ).

tff(pred_def_73737,type,
    v125214: state_type > $o ).

tff(pred_def_73738,type,
    v125333: state_type > $o ).

tff(pred_def_73739,type,
    v125334: state_type > $o ).

tff(pred_def_73740,type,
    v125332: state_type > $o ).

tff(pred_def_73741,type,
    v125335: state_type > $o ).

tff(pred_def_73742,type,
    v125331: state_type > $o ).

tff(pred_def_73743,type,
    v125338: state_type > $o ).

tff(pred_def_73744,type,
    v125339: state_type > $o ).

tff(pred_def_73745,type,
    v125337: state_type > $o ).

tff(pred_def_73746,type,
    v125340: state_type > $o ).

tff(pred_def_73747,type,
    v125336: state_type > $o ).

tff(pred_def_73748,type,
    v125212: ( state_type * $int ) > $o ).

tff(pred_def_73749,type,
    v125341: ( state_type * $int ) > $o ).

tff(pred_def_73750,type,
    v125211: state_type > $o ).

tff(pred_def_73751,type,
    v125344: state_type > $o ).

tff(pred_def_73752,type,
    v125345: state_type > $o ).

tff(pred_def_73753,type,
    v125343: state_type > $o ).

tff(pred_def_73754,type,
    v125346: state_type > $o ).

tff(pred_def_73755,type,
    v125342: state_type > $o ).

tff(pred_def_73756,type,
    v125210: state_type > $o ).

tff(pred_def_73757,type,
    v125347: state_type > $o ).

tff(pred_def_73758,type,
    v125209: state_type > $o ).

tff(pred_def_73759,type,
    v125208: state_type > $o ).

tff(pred_def_73760,type,
    v125351: state_type > $o ).

tff(pred_def_73761,type,
    v125352: state_type > $o ).

tff(pred_def_73762,type,
    v125350: state_type > $o ).

tff(pred_def_73763,type,
    v125353: state_type > $o ).

tff(pred_def_73764,type,
    v125349: state_type > $o ).

tff(pred_def_73765,type,
    v125348: state_type > $o ).

tff(pred_def_73766,type,
    v125207: state_type > $o ).

tff(pred_def_73767,type,
    v125354: state_type > $o ).

tff(pred_def_73768,type,
    v125206: state_type > $o ).

tff(pred_def_73769,type,
    v125357: state_type > $o ).

tff(pred_def_73770,type,
    v125358: state_type > $o ).

tff(pred_def_73771,type,
    v125356: state_type > $o ).

tff(pred_def_73772,type,
    v125359: state_type > $o ).

tff(pred_def_73773,type,
    v125355: state_type > $o ).

tff(pred_def_73774,type,
    v125362: state_type > $o ).

tff(pred_def_73775,type,
    v125363: state_type > $o ).

tff(pred_def_73776,type,
    v125361: state_type > $o ).

tff(pred_def_73777,type,
    v125364: state_type > $o ).

tff(pred_def_73778,type,
    v125360: state_type > $o ).

tff(pred_def_73779,type,
    v125204: ( state_type * $int ) > $o ).

tff(pred_def_73780,type,
    v125365: ( state_type * $int ) > $o ).

tff(pred_def_73781,type,
    v125203: state_type > $o ).

tff(pred_def_73782,type,
    v125368: state_type > $o ).

tff(pred_def_73783,type,
    v125369: state_type > $o ).

tff(pred_def_73784,type,
    v125367: state_type > $o ).

tff(pred_def_73785,type,
    v125370: state_type > $o ).

tff(pred_def_73786,type,
    v125366: state_type > $o ).

tff(pred_def_73787,type,
    v125202: state_type > $o ).

tff(pred_def_73788,type,
    v125371: state_type > $o ).

tff(pred_def_73789,type,
    v125201: state_type > $o ).

tff(pred_def_73790,type,
    v125200: state_type > $o ).

tff(pred_def_73791,type,
    v125375: state_type > $o ).

tff(pred_def_73792,type,
    v125376: state_type > $o ).

tff(pred_def_73793,type,
    v125374: state_type > $o ).

tff(pred_def_73794,type,
    v125377: state_type > $o ).

tff(pred_def_73795,type,
    v125373: state_type > $o ).

tff(pred_def_73796,type,
    v125372: state_type > $o ).

tff(pred_def_73797,type,
    v125199: state_type > $o ).

tff(pred_def_73798,type,
    v125378: state_type > $o ).

tff(pred_def_73799,type,
    v125198: state_type > $o ).

tff(pred_def_73800,type,
    v125381: state_type > $o ).

tff(pred_def_73801,type,
    v125382: state_type > $o ).

tff(pred_def_73802,type,
    v125380: state_type > $o ).

tff(pred_def_73803,type,
    v125383: state_type > $o ).

tff(pred_def_73804,type,
    v125379: state_type > $o ).

tff(pred_def_73805,type,
    v125386: state_type > $o ).

tff(pred_def_73806,type,
    v125387: state_type > $o ).

tff(pred_def_73807,type,
    v125385: state_type > $o ).

tff(pred_def_73808,type,
    v125388: state_type > $o ).

tff(pred_def_73809,type,
    v125384: state_type > $o ).

tff(pred_def_73810,type,
    v125196: ( state_type * $int ) > $o ).

tff(pred_def_73811,type,
    v125181: ( state_type * $int ) > $o ).

tff(pred_def_73812,type,
    v125398: state_type > $o ).

tff(pred_def_73813,type,
    v125396: state_type > $o ).

tff(pred_def_73814,type,
    v125395: state_type > $o ).

tff(pred_def_73815,type,
    v125394: ( state_type * $int ) > $o ).

tff(pred_def_73816,type,
    v125392: state_type > $o ).

tff(pred_def_73817,type,
    v125408: state_type > $o ).

tff(pred_def_73818,type,
    v125406: state_type > $o ).

tff(pred_def_73819,type,
    v125405: state_type > $o ).

tff(pred_def_73820,type,
    v125404: ( state_type * $int ) > $o ).

tff(pred_def_73821,type,
    v125402: state_type > $o ).

tff(pred_def_73822,type,
    v125418: state_type > $o ).

tff(pred_def_73823,type,
    v125416: state_type > $o ).

tff(pred_def_73824,type,
    v125415: state_type > $o ).

tff(pred_def_73825,type,
    v125414: ( state_type * $int ) > $o ).

tff(pred_def_73826,type,
    v125412: state_type > $o ).

tff(pred_def_73827,type,
    v125422: state_type > $o ).

tff(pred_def_73828,type,
    v125424: state_type > $o ).

tff(pred_def_73829,type,
    v125426: state_type > $o ).

tff(pred_def_73830,type,
    v125432: state_type > $o ).

tff(pred_def_73831,type,
    v125431: state_type > $o ).

tff(pred_def_73832,type,
    v125430: state_type > $o ).

tff(pred_def_73833,type,
    v125429: state_type > $o ).

tff(pred_def_73834,type,
    v125428: state_type > $o ).

tff(pred_def_73835,type,
    v125427: ( state_type * $int ) > $o ).

tff(pred_def_73836,type,
    v125390: ( state_type * $int ) > $o ).

tff(pred_def_73837,type,
    v125461: ( state_type * $int ) > $o ).

tff(pred_def_73838,type,
    v125159: ( state_type * $int ) > $o ).

tff(pred_def_73839,type,
    v125460: state_type > $o ).

tff(pred_def_73840,type,
    v125464: state_type > $o ).

tff(pred_def_73841,type,
    v125465: state_type > $o ).

tff(pred_def_73842,type,
    v125463: state_type > $o ).

tff(pred_def_73843,type,
    v125466: state_type > $o ).

tff(pred_def_73844,type,
    v125462: state_type > $o ).

tff(pred_def_73845,type,
    v125459: state_type > $o ).

tff(pred_def_73846,type,
    v125467: state_type > $o ).

tff(pred_def_73847,type,
    v125458: state_type > $o ).

tff(pred_def_73848,type,
    v125470: state_type > $o ).

tff(pred_def_73849,type,
    v125471: state_type > $o ).

tff(pred_def_73850,type,
    v125469: state_type > $o ).

tff(pred_def_73851,type,
    v125472: state_type > $o ).

tff(pred_def_73852,type,
    v125468: state_type > $o ).

tff(pred_def_73853,type,
    v125457: state_type > $o ).

tff(pred_def_73854,type,
    v125473: state_type > $o ).

tff(pred_def_73855,type,
    v125456: state_type > $o ).

tff(pred_def_73856,type,
    v125476: state_type > $o ).

tff(pred_def_73857,type,
    v125477: state_type > $o ).

tff(pred_def_73858,type,
    v125475: state_type > $o ).

tff(pred_def_73859,type,
    v125478: state_type > $o ).

tff(pred_def_73860,type,
    v125474: state_type > $o ).

tff(pred_def_73861,type,
    v125455: state_type > $o ).

tff(pred_def_73862,type,
    v125479: state_type > $o ).

tff(pred_def_73863,type,
    v125454: state_type > $o ).

tff(pred_def_73864,type,
    v125482: state_type > $o ).

tff(pred_def_73865,type,
    v125483: state_type > $o ).

tff(pred_def_73866,type,
    v125481: state_type > $o ).

tff(pred_def_73867,type,
    v125484: state_type > $o ).

tff(pred_def_73868,type,
    v125480: state_type > $o ).

tff(pred_def_73869,type,
    v125453: state_type > $o ).

tff(pred_def_73870,type,
    v125485: state_type > $o ).

tff(pred_def_73871,type,
    v125452: state_type > $o ).

tff(pred_def_73872,type,
    v125451: state_type > $o ).

tff(pred_def_73873,type,
    v125489: state_type > $o ).

tff(pred_def_73874,type,
    v125490: state_type > $o ).

tff(pred_def_73875,type,
    v125488: state_type > $o ).

tff(pred_def_73876,type,
    v125491: state_type > $o ).

tff(pred_def_73877,type,
    v125487: state_type > $o ).

tff(pred_def_73878,type,
    v125486: state_type > $o ).

tff(pred_def_73879,type,
    v125450: state_type > $o ).

tff(pred_def_73880,type,
    v125492: state_type > $o ).

tff(pred_def_73881,type,
    v125449: state_type > $o ).

tff(pred_def_73882,type,
    v125495: state_type > $o ).

tff(pred_def_73883,type,
    v125496: state_type > $o ).

tff(pred_def_73884,type,
    v125494: state_type > $o ).

tff(pred_def_73885,type,
    v125497: state_type > $o ).

tff(pred_def_73886,type,
    v125493: state_type > $o ).

tff(pred_def_73887,type,
    v125500: state_type > $o ).

tff(pred_def_73888,type,
    v125501: state_type > $o ).

tff(pred_def_73889,type,
    v125499: state_type > $o ).

tff(pred_def_73890,type,
    v125502: state_type > $o ).

tff(pred_def_73891,type,
    v125498: state_type > $o ).

tff(pred_def_73892,type,
    v125505: state_type > $o ).

tff(pred_def_73893,type,
    v125506: state_type > $o ).

tff(pred_def_73894,type,
    v125504: state_type > $o ).

tff(pred_def_73895,type,
    v125507: state_type > $o ).

tff(pred_def_73896,type,
    v125503: state_type > $o ).

tff(pred_def_73897,type,
    v125510: state_type > $o ).

tff(pred_def_73898,type,
    v125511: state_type > $o ).

tff(pred_def_73899,type,
    v125509: state_type > $o ).

tff(pred_def_73900,type,
    v125512: state_type > $o ).

tff(pred_def_73901,type,
    v125508: state_type > $o ).

tff(pred_def_73902,type,
    v125515: state_type > $o ).

tff(pred_def_73903,type,
    v125516: state_type > $o ).

tff(pred_def_73904,type,
    v125514: state_type > $o ).

tff(pred_def_73905,type,
    v125517: state_type > $o ).

tff(pred_def_73906,type,
    v125513: state_type > $o ).

tff(pred_def_73907,type,
    v125447: ( state_type * $int ) > $o ).

tff(pred_def_73908,type,
    v125446: state_type > $o ).

tff(pred_def_73909,type,
    v125522: state_type > $o ).

tff(pred_def_73910,type,
    v125524: state_type > $o ).

tff(pred_def_73911,type,
    v125525: state_type > $o ).

tff(pred_def_73912,type,
    v125523: state_type > $o ).

tff(pred_def_73913,type,
    v125521: state_type > $o ).

tff(pred_def_73914,type,
    v125520: state_type > $o ).

tff(pred_def_73915,type,
    v125526: state_type > $o ).

tff(pred_def_73916,type,
    v125519: state_type > $o ).

tff(pred_def_73917,type,
    v125527: state_type > $o ).

tff(pred_def_73918,type,
    v125518: state_type > $o ).

tff(pred_def_73919,type,
    v125445: state_type > $o ).

tff(pred_def_73920,type,
    v125528: state_type > $o ).

tff(pred_def_73921,type,
    v125444: state_type > $o ).

tff(pred_def_73922,type,
    v125535: state_type > $o ).

tff(pred_def_73923,type,
    v125534: state_type > $o ).

tff(pred_def_73924,type,
    v125533: state_type > $o ).

tff(pred_def_73925,type,
    v125537: state_type > $o ).

tff(pred_def_73926,type,
    v125536: state_type > $o ).

tff(pred_def_73927,type,
    v125532: state_type > $o ).

tff(pred_def_73928,type,
    v125531: state_type > $o ).

tff(pred_def_73929,type,
    v125538: state_type > $o ).

tff(pred_def_73930,type,
    v125530: state_type > $o ).

tff(pred_def_73931,type,
    v125539: state_type > $o ).

tff(pred_def_73932,type,
    v125529: state_type > $o ).

tff(pred_def_73933,type,
    v125443: state_type > $o ).

tff(pred_def_73934,type,
    v125540: state_type > $o ).

tff(pred_def_73935,type,
    v125442: state_type > $o ).

tff(pred_def_73936,type,
    v125547: state_type > $o ).

tff(pred_def_73937,type,
    v125546: state_type > $o ).

tff(pred_def_73938,type,
    v125545: state_type > $o ).

tff(pred_def_73939,type,
    v125549: state_type > $o ).

tff(pred_def_73940,type,
    v125548: state_type > $o ).

tff(pred_def_73941,type,
    v125544: state_type > $o ).

tff(pred_def_73942,type,
    v125543: state_type > $o ).

tff(pred_def_73943,type,
    v125550: state_type > $o ).

tff(pred_def_73944,type,
    v125542: state_type > $o ).

tff(pred_def_73945,type,
    v125551: state_type > $o ).

tff(pred_def_73946,type,
    v125541: state_type > $o ).

tff(pred_def_73947,type,
    v125441: state_type > $o ).

tff(pred_def_73948,type,
    v125552: state_type > $o ).

tff(pred_def_73949,type,
    v125440: state_type > $o ).

tff(pred_def_73950,type,
    v125559: state_type > $o ).

tff(pred_def_73951,type,
    v125558: state_type > $o ).

tff(pred_def_73952,type,
    v125557: state_type > $o ).

tff(pred_def_73953,type,
    v125561: state_type > $o ).

tff(pred_def_73954,type,
    v125560: state_type > $o ).

tff(pred_def_73955,type,
    v125556: state_type > $o ).

tff(pred_def_73956,type,
    v125555: state_type > $o ).

tff(pred_def_73957,type,
    v125562: state_type > $o ).

tff(pred_def_73958,type,
    v125554: state_type > $o ).

tff(pred_def_73959,type,
    v125563: state_type > $o ).

tff(pred_def_73960,type,
    v125553: state_type > $o ).

tff(pred_def_73961,type,
    v125439: state_type > $o ).

tff(pred_def_73962,type,
    v125564: state_type > $o ).

tff(pred_def_73963,type,
    v125438: state_type > $o ).

tff(pred_def_73964,type,
    v125437: state_type > $o ).

tff(pred_def_73965,type,
    v125572: state_type > $o ).

tff(pred_def_73966,type,
    v125571: state_type > $o ).

tff(pred_def_73967,type,
    v125570: state_type > $o ).

tff(pred_def_73968,type,
    v125574: state_type > $o ).

tff(pred_def_73969,type,
    v125573: state_type > $o ).

tff(pred_def_73970,type,
    v125569: state_type > $o ).

tff(pred_def_73971,type,
    v125568: state_type > $o ).

tff(pred_def_73972,type,
    v125575: state_type > $o ).

tff(pred_def_73973,type,
    v125567: state_type > $o ).

tff(pred_def_73974,type,
    v125576: state_type > $o ).

tff(pred_def_73975,type,
    v125566: state_type > $o ).

tff(pred_def_73976,type,
    v125565: state_type > $o ).

tff(pred_def_73977,type,
    v125436: state_type > $o ).

tff(pred_def_73978,type,
    v125577: state_type > $o ).

tff(pred_def_73979,type,
    v125435: state_type > $o ).

tff(pred_def_73980,type,
    v125580: state_type > $o ).

tff(pred_def_73981,type,
    v125581: state_type > $o ).

tff(pred_def_73982,type,
    v125579: state_type > $o ).

tff(pred_def_73983,type,
    v125582: state_type > $o ).

tff(pred_def_73984,type,
    v125578: state_type > $o ).

tff(pred_def_73985,type,
    v125585: state_type > $o ).

tff(pred_def_73986,type,
    v125586: state_type > $o ).

tff(pred_def_73987,type,
    v125584: state_type > $o ).

tff(pred_def_73988,type,
    v125587: state_type > $o ).

tff(pred_def_73989,type,
    v125583: state_type > $o ).

tff(pred_def_73990,type,
    v125590: state_type > $o ).

tff(pred_def_73991,type,
    v125591: state_type > $o ).

tff(pred_def_73992,type,
    v125589: state_type > $o ).

tff(pred_def_73993,type,
    v125592: state_type > $o ).

tff(pred_def_73994,type,
    v125588: state_type > $o ).

tff(pred_def_73995,type,
    v125595: state_type > $o ).

tff(pred_def_73996,type,
    v125596: state_type > $o ).

tff(pred_def_73997,type,
    v125594: state_type > $o ).

tff(pred_def_73998,type,
    v125597: state_type > $o ).

tff(pred_def_73999,type,
    v125593: state_type > $o ).

tff(pred_def_74000,type,
    v125600: state_type > $o ).

tff(pred_def_74001,type,
    v125599: state_type > $o ).

tff(pred_def_74002,type,
    v125601: state_type > $o ).

tff(pred_def_74003,type,
    v125598: state_type > $o ).

tff(pred_def_74004,type,
    v125179: ( state_type * $int ) > $o ).

tff(pred_def_74005,type,
    v125177: ( state_type * $int ) > $o ).

tff(pred_def_74006,type,
    v125175: ( state_type * $int ) > $o ).

tff(pred_def_74007,type,
    v125173: ( state_type * $int ) > $o ).

tff(pred_def_74008,type,
    v125607: state_type > $o ).

tff(pred_def_74009,type,
    v125605: state_type > $o ).

tff(pred_def_74010,type,
    v125603: state_type > $o ).

tff(pred_def_74011,type,
    v125614: state_type > $o ).

tff(pred_def_74012,type,
    v125612: state_type > $o ).

tff(pred_def_74013,type,
    v125611: state_type > $o ).

tff(pred_def_74014,type,
    v125610: state_type > $o ).

tff(pred_def_74015,type,
    v125622: state_type > $o ).

tff(pred_def_74016,type,
    v125623: state_type > $o ).

tff(pred_def_74017,type,
    v125621: state_type > $o ).

tff(pred_def_74018,type,
    v125618: ( state_type * $int ) > $o ).

tff(pred_def_74019,type,
    v125620: ( state_type * $int ) > $o ).

tff(pred_def_74020,type,
    v125163: ( state_type * $int ) > $o ).

tff(pred_def_74021,type,
    v125161: ( state_type * $int ) > $o ).

tff(pred_def_74022,type,
    v125627: state_type > $o ).

tff(pred_def_74023,type,
    v125629: state_type > $o ).

tff(pred_def_74024,type,
    v125630: state_type > $o ).

tff(pred_def_74025,type,
    v125157: state_type > $o ).

tff(pred_def_74026,type,
    v125632: state_type > $o ).

tff(pred_def_74027,type,
    v125634: state_type > $o ).

tff(pred_def_74028,type,
    v125640: state_type > $o ).

tff(pred_def_74029,type,
    v125642: state_type > $o ).

tff(pred_def_74030,type,
    v125652: state_type > $o ).

tff(pred_def_74031,type,
    v125653: state_type > $o ).

tff(pred_def_74032,type,
    v125651: state_type > $o ).

tff(pred_def_74033,type,
    v125655: state_type > $o ).

tff(pred_def_74034,type,
    v125656: state_type > $o ).

tff(pred_def_74035,type,
    v125654: state_type > $o ).

tff(pred_def_74036,type,
    v125650: state_type > $o ).

tff(pred_def_74037,type,
    v125649: state_type > $o ).

tff(pred_def_74038,type,
    v125648: state_type > $o ).

tff(pred_def_74039,type,
    v125647: state_type > $o ).

tff(pred_def_74040,type,
    v125127: ( state_type * $int ) > $o ).

tff(pred_def_74041,type,
    v125657: state_type > $o ).

tff(pred_def_74042,type,
    v125646: state_type > $o ).

tff(pred_def_74043,type,
    v125659: state_type > $o ).

tff(pred_def_74044,type,
    v125658: state_type > $o ).

tff(pred_def_74045,type,
    v125645: state_type > $o ).

tff(pred_def_74046,type,
    v125661: state_type > $o ).

tff(pred_def_74047,type,
    v125667: state_type > $o ).

tff(pred_def_74048,type,
    v125668: state_type > $o ).

tff(pred_def_74049,type,
    v125666: state_type > $o ).

tff(pred_def_74050,type,
    v125665: state_type > $o ).

tff(pred_def_74051,type,
    v125671: state_type > $o ).

tff(pred_def_74052,type,
    v125670: state_type > $o ).

tff(pred_def_74053,type,
    v125669: state_type > $o ).

tff(pred_def_74054,type,
    v125664: state_type > $o ).

tff(pred_def_74055,type,
    v125672: state_type > $o ).

tff(pred_def_74056,type,
    v125663: state_type > $o ).

tff(pred_def_74057,type,
    v125673: state_type > $o ).

tff(pred_def_74058,type,
    v125662: state_type > $o ).

tff(pred_def_74059,type,
    v125660: state_type > $o ).

tff(pred_def_74060,type,
    v125644: state_type > $o ).

tff(pred_def_74061,type,
    v125155: ( state_type * $int ) > $o ).

tff(pred_def_74062,type,
    v125674: ( state_type * $int ) > $o ).

tff(pred_def_74063,type,
    v125638: state_type > $o ).

tff(pred_def_74064,type,
    v125153: ( state_type * $int ) > $o ).

tff(pred_def_74065,type,
    v125151: ( state_type * $int ) > $o ).

tff(pred_def_74066,type,
    v125149: ( state_type * $int ) > $o ).

tff(pred_def_74067,type,
    v125678: state_type > $o ).

tff(pred_def_74068,type,
    v125676: state_type > $o ).

tff(pred_def_74069,type,
    v125685: state_type > $o ).

tff(pred_def_74070,type,
    v125683: state_type > $o ).

tff(pred_def_74071,type,
    v125682: state_type > $o ).

tff(pred_def_74072,type,
    v125681: state_type > $o ).

tff(pred_def_74073,type,
    v125693: state_type > $o ).

tff(pred_def_74074,type,
    v125694: state_type > $o ).

tff(pred_def_74075,type,
    v125692: state_type > $o ).

tff(pred_def_74076,type,
    v125689: ( state_type * $int ) > $o ).

tff(pred_def_74077,type,
    v125691: ( state_type * $int ) > $o ).

tff(pred_def_74078,type,
    v125680: ( state_type * $int ) > $o ).

tff(pred_def_74079,type,
    v125131: ( state_type * $int ) > $o ).

tff(pred_def_74080,type,
    v125129: ( state_type * $int ) > $o ).

tff(pred_def_74081,type,
    v125698: state_type > $o ).

tff(pred_def_74082,type,
    v125704: state_type > $o ).

tff(pred_def_74083,type,
    v125703: state_type > $o ).

tff(pred_def_74084,type,
    v125702: state_type > $o ).

tff(pred_def_74085,type,
    v125706: state_type > $o ).

tff(pred_def_74086,type,
    v125705: state_type > $o ).

tff(pred_def_74087,type,
    v125701: state_type > $o ).

tff(pred_def_74088,type,
    v125708: state_type > $o ).

tff(pred_def_74089,type,
    v125714: state_type > $o ).

tff(pred_def_74090,type,
    v125713: state_type > $o ).

tff(pred_def_74091,type,
    v125712: state_type > $o ).

tff(pred_def_74092,type,
    v125711: state_type > $o ).

tff(pred_def_74093,type,
    v125715: state_type > $o ).

tff(pred_def_74094,type,
    v125710: state_type > $o ).

tff(pred_def_74095,type,
    v125716: state_type > $o ).

tff(pred_def_74096,type,
    v125709: state_type > $o ).

tff(pred_def_74097,type,
    v125707: state_type > $o ).

tff(pred_def_74098,type,
    v125700: state_type > $o ).

tff(pred_def_74099,type,
    v125722: state_type > $o ).

tff(pred_def_74100,type,
    v125720: state_type > $o ).

tff(pred_def_74101,type,
    v125719: state_type > $o ).

tff(pred_def_74102,type,
    v125718: ( state_type * $int ) > $o ).

tff(pred_def_74103,type,
    v125732: state_type > $o ).

tff(pred_def_74104,type,
    v125731: state_type > $o ).

tff(pred_def_74105,type,
    v125730: state_type > $o ).

tff(pred_def_74106,type,
    v125729: state_type > $o ).

tff(pred_def_74107,type,
    v125734: state_type > $o ).

tff(pred_def_74108,type,
    v125735: state_type > $o ).

tff(pred_def_74109,type,
    v125733: state_type > $o ).

tff(pred_def_74110,type,
    v125728: state_type > $o ).

tff(pred_def_74111,type,
    v125738: state_type > $o ).

tff(pred_def_74112,type,
    v125737: state_type > $o ).

tff(pred_def_74113,type,
    v125739: state_type > $o ).

tff(pred_def_74114,type,
    v125736: state_type > $o ).

tff(pred_def_74115,type,
    v125727: state_type > $o ).

tff(pred_def_74116,type,
    v125743: state_type > $o ).

tff(pred_def_74117,type,
    v125742: state_type > $o ).

tff(pred_def_74118,type,
    v125741: state_type > $o ).

tff(pred_def_74119,type,
    v125744: state_type > $o ).

tff(pred_def_74120,type,
    v125740: state_type > $o ).

tff(pred_def_74121,type,
    v125726: state_type > $o ).

tff(pred_def_74122,type,
    v125751: state_type > $o ).

tff(pred_def_74123,type,
    v125749: state_type > $o ).

tff(pred_def_74124,type,
    v125748: state_type > $o ).

tff(pred_def_74125,type,
    v125747: ( state_type * $int ) > $o ).

tff(pred_def_74126,type,
    v125636: state_type > $o ).

tff(pred_def_74127,type,
    v125757: state_type > $o ).

tff(pred_def_74128,type,
    v125759: state_type > $o ).

tff(pred_def_74129,type,
    v125762: state_type > $o ).

tff(pred_def_74130,type,
    v125763: state_type > $o ).

tff(pred_def_74131,type,
    v125761: state_type > $o ).

tff(pred_def_74132,type,
    v125760: state_type > $o ).

tff(pred_def_74133,type,
    v125758: state_type > $o ).

tff(pred_def_74134,type,
    v125756: state_type > $o ).

tff(pred_def_74135,type,
    v125769: state_type > $o ).

tff(pred_def_74136,type,
    v125767: state_type > $o ).

tff(pred_def_74137,type,
    v125766: state_type > $o ).

tff(pred_def_74138,type,
    v125765: ( state_type * $int ) > $o ).

tff(pred_def_74139,type,
    v125783: state_type > $o ).

tff(pred_def_74140,type,
    v125781: state_type > $o ).

tff(pred_def_74141,type,
    v125787: state_type > $o ).

tff(pred_def_74142,type,
    v125785: state_type > $o ).

tff(pred_def_74143,type,
    v125799: state_type > $o ).

tff(pred_def_74144,type,
    v125800: state_type > $o ).

tff(pred_def_74145,type,
    v125797: state_type > $o ).

tff(pred_def_74146,type,
    v125775: ( state_type * $int ) > $o ).

tff(pred_def_74147,type,
    v125807: state_type > $o ).

tff(pred_def_74148,type,
    v125806: state_type > $o ).

tff(pred_def_74149,type,
    v125809: state_type > $o ).

tff(pred_def_74150,type,
    v125808: state_type > $o ).

tff(pred_def_74151,type,
    v125805: state_type > $o ).

tff(pred_def_74152,type,
    v125803: ( state_type * $int ) > $o ).

tff(pred_def_74153,type,
    v125773: state_type > $o ).

tff(pred_def_74154,type,
    v125802: ( state_type * $int ) > $o ).

tff(pred_def_74155,type,
    v125795: ( state_type * $int ) > $o ).

tff(pred_def_74156,type,
    v125793: ( state_type * $int ) > $o ).

tff(pred_def_74157,type,
    v125791: ( state_type * $int ) > $o ).

tff(pred_def_74158,type,
    v125789: ( state_type * $int ) > $o ).

tff(pred_def_74159,type,
    v125813: state_type > $o ).

tff(pred_def_74160,type,
    v125811: state_type > $o ).

tff(pred_def_74161,type,
    v125820: state_type > $o ).

tff(pred_def_74162,type,
    v125818: state_type > $o ).

tff(pred_def_74163,type,
    v125817: state_type > $o ).

tff(pred_def_74164,type,
    v125816: state_type > $o ).

tff(pred_def_74165,type,
    v125828: state_type > $o ).

tff(pred_def_74166,type,
    v125829: state_type > $o ).

tff(pred_def_74167,type,
    v125827: state_type > $o ).

tff(pred_def_74168,type,
    v125824: ( state_type * $int ) > $o ).

tff(pred_def_74169,type,
    v125826: ( state_type * $int ) > $o ).

tff(pred_def_74170,type,
    v125779: ( state_type * $int ) > $o ).

tff(pred_def_74171,type,
    v125777: ( state_type * $int ) > $o ).

tff(pred_def_74172,type,
    v125844: state_type > $o ).

tff(pred_def_74173,type,
    v125842: state_type > $o ).

tff(pred_def_74174,type,
    v125848: state_type > $o ).

tff(pred_def_74175,type,
    v125846: state_type > $o ).

tff(pred_def_74176,type,
    v125861: state_type > $o ).

tff(pred_def_74177,type,
    v125860: state_type > $o ).

tff(pred_def_74178,type,
    v125858: state_type > $o ).

tff(pred_def_74179,type,
    v125863: ( state_type * $int ) > $o ).

tff(pred_def_74180,type,
    v125865: state_type > $o ).

tff(pred_def_74181,type,
    v125868: ( state_type * $int ) > $o ).

tff(pred_def_74182,type,
    v125836: ( state_type * $int ) > $o ).

tff(pred_def_74183,type,
    v125883: state_type > $o ).

tff(pred_def_74184,type,
    v125882: state_type > $o ).

tff(pred_def_74185,type,
    v125881: state_type > $o ).

tff(pred_def_74186,type,
    v125884: state_type > $o ).

tff(pred_def_74187,type,
    v125880: state_type > $o ).

tff(pred_def_74188,type,
    v125879: state_type > $o ).

tff(pred_def_74189,type,
    v125885: state_type > $o ).

tff(pred_def_74190,type,
    v125878: state_type > $o ).

tff(pred_def_74191,type,
    v125877: state_type > $o ).

tff(pred_def_74192,type,
    v125876: state_type > $o ).

tff(pred_def_74193,type,
    v125875: state_type > $o ).

tff(pred_def_74194,type,
    v125887: state_type > $o ).

tff(pred_def_74195,type,
    v125886: state_type > $o ).

tff(pred_def_74196,type,
    v125874: state_type > $o ).

tff(pred_def_74197,type,
    v125890: state_type > $o ).

tff(pred_def_74198,type,
    v125889: state_type > $o ).

tff(pred_def_74199,type,
    v125891: state_type > $o ).

tff(pred_def_74200,type,
    v125888: state_type > $o ).

tff(pred_def_74201,type,
    v125894: state_type > $o ).

tff(pred_def_74202,type,
    v125893: state_type > $o ).

tff(pred_def_74203,type,
    v125895: state_type > $o ).

tff(pred_def_74204,type,
    v125892: state_type > $o ).

tff(pred_def_74205,type,
    v125898: state_type > $o ).

tff(pred_def_74206,type,
    v125897: state_type > $o ).

tff(pred_def_74207,type,
    v125899: state_type > $o ).

tff(pred_def_74208,type,
    v125896: state_type > $o ).

tff(pred_def_74209,type,
    v125872: ( state_type * $int ) > $o ).

tff(pred_def_74210,type,
    v125834: state_type > $o ).

tff(pred_def_74211,type,
    v125871: ( state_type * $int ) > $o ).

tff(pred_def_74212,type,
    v125870: ( state_type * $int ) > $o ).

tff(pred_def_74213,type,
    v125856: ( state_type * $int ) > $o ).

tff(pred_def_74214,type,
    v125854: ( state_type * $int ) > $o ).

tff(pred_def_74215,type,
    v125852: ( state_type * $int ) > $o ).

tff(pred_def_74216,type,
    v125850: ( state_type * $int ) > $o ).

tff(pred_def_74217,type,
    v125903: state_type > $o ).

tff(pred_def_74218,type,
    v125901: state_type > $o ).

tff(pred_def_74219,type,
    v125910: state_type > $o ).

tff(pred_def_74220,type,
    v125908: state_type > $o ).

tff(pred_def_74221,type,
    v125907: state_type > $o ).

tff(pred_def_74222,type,
    v125906: state_type > $o ).

tff(pred_def_74223,type,
    v125918: state_type > $o ).

tff(pred_def_74224,type,
    v125919: state_type > $o ).

tff(pred_def_74225,type,
    v125917: state_type > $o ).

tff(pred_def_74226,type,
    v125914: ( state_type * $int ) > $o ).

tff(pred_def_74227,type,
    v125916: ( state_type * $int ) > $o ).

tff(pred_def_74228,type,
    v125840: ( state_type * $int ) > $o ).

tff(pred_def_74229,type,
    v125838: ( state_type * $int ) > $o ).

tff(pred_def_74230,type,
    v125924: state_type > $o ).

tff(pred_def_74231,type,
    v125125: state_type > $o ).

tff(pred_def_74232,type,
    v125940: state_type > $o ).

tff(pred_def_74233,type,
    v125938: state_type > $o ).

tff(pred_def_74234,type,
    v125936: state_type > $o ).

tff(pred_def_74235,type,
    v125934: state_type > $o ).

tff(pred_def_74236,type,
    v125948: state_type > $o ).

tff(pred_def_74237,type,
    v125946: state_type > $o ).

tff(pred_def_74238,type,
    v125944: state_type > $o ).

tff(pred_def_74239,type,
    v125942: state_type > $o ).

tff(pred_def_74240,type,
    v125968: state_type > $o ).

tff(pred_def_74241,type,
    v125966: state_type > $o ).

tff(pred_def_74242,type,
    v125972: state_type > $o ).

tff(pred_def_74243,type,
    v125970: state_type > $o ).

tff(pred_def_74244,type,
    v125984: state_type > $o ).

tff(pred_def_74245,type,
    v125986: state_type > $o ).

tff(pred_def_74246,type,
    v125988: state_type > $o ).

tff(pred_def_74247,type,
    v125990: state_type > $o ).

tff(pred_def_74248,type,
    v125992: state_type > $o ).

tff(pred_def_74249,type,
    v125994: state_type > $o ).

tff(pred_def_74250,type,
    v125996: state_type > $o ).

tff(pred_def_74251,type,
    v126045: ( state_type * $int ) > $o ).

tff(pred_def_74252,type,
    v126046: ( state_type * $int ) > $o ).

tff(pred_def_74253,type,
    v126044: state_type > $o ).

tff(pred_def_74254,type,
    v126049: state_type > $o ).

tff(pred_def_74255,type,
    v126050: state_type > $o ).

tff(pred_def_74256,type,
    v126048: state_type > $o ).

tff(pred_def_74257,type,
    v126051: state_type > $o ).

tff(pred_def_74258,type,
    v126047: state_type > $o ).

tff(pred_def_74259,type,
    v126043: state_type > $o ).

tff(pred_def_74260,type,
    v126052: state_type > $o ).

tff(pred_def_74261,type,
    v126042: state_type > $o ).

tff(pred_def_74262,type,
    v126041: state_type > $o ).

tff(pred_def_74263,type,
    v126056: state_type > $o ).

tff(pred_def_74264,type,
    v126057: state_type > $o ).

tff(pred_def_74265,type,
    v126055: state_type > $o ).

tff(pred_def_74266,type,
    v126058: state_type > $o ).

tff(pred_def_74267,type,
    v126054: state_type > $o ).

tff(pred_def_74268,type,
    v126053: state_type > $o ).

tff(pred_def_74269,type,
    v126040: state_type > $o ).

tff(pred_def_74270,type,
    v126059: state_type > $o ).

tff(pred_def_74271,type,
    v126039: state_type > $o ).

tff(pred_def_74272,type,
    v126062: state_type > $o ).

tff(pred_def_74273,type,
    v126063: state_type > $o ).

tff(pred_def_74274,type,
    v126061: state_type > $o ).

tff(pred_def_74275,type,
    v126064: state_type > $o ).

tff(pred_def_74276,type,
    v126060: state_type > $o ).

tff(pred_def_74277,type,
    v126067: state_type > $o ).

tff(pred_def_74278,type,
    v126068: state_type > $o ).

tff(pred_def_74279,type,
    v126066: state_type > $o ).

tff(pred_def_74280,type,
    v126069: state_type > $o ).

tff(pred_def_74281,type,
    v126065: state_type > $o ).

tff(pred_def_74282,type,
    v126037: ( state_type * $int ) > $o ).

tff(pred_def_74283,type,
    v126070: ( state_type * $int ) > $o ).

tff(pred_def_74284,type,
    v126036: state_type > $o ).

tff(pred_def_74285,type,
    v126073: state_type > $o ).

tff(pred_def_74286,type,
    v126074: state_type > $o ).

tff(pred_def_74287,type,
    v126072: state_type > $o ).

tff(pred_def_74288,type,
    v126075: state_type > $o ).

tff(pred_def_74289,type,
    v126071: state_type > $o ).

tff(pred_def_74290,type,
    v126035: state_type > $o ).

tff(pred_def_74291,type,
    v126076: state_type > $o ).

tff(pred_def_74292,type,
    v126034: state_type > $o ).

tff(pred_def_74293,type,
    v126033: state_type > $o ).

tff(pred_def_74294,type,
    v126080: state_type > $o ).

tff(pred_def_74295,type,
    v126081: state_type > $o ).

tff(pred_def_74296,type,
    v126079: state_type > $o ).

tff(pred_def_74297,type,
    v126082: state_type > $o ).

tff(pred_def_74298,type,
    v126078: state_type > $o ).

tff(pred_def_74299,type,
    v126077: state_type > $o ).

tff(pred_def_74300,type,
    v126032: state_type > $o ).

tff(pred_def_74301,type,
    v126083: state_type > $o ).

tff(pred_def_74302,type,
    v126031: state_type > $o ).

tff(pred_def_74303,type,
    v126086: state_type > $o ).

tff(pred_def_74304,type,
    v126087: state_type > $o ).

tff(pred_def_74305,type,
    v126085: state_type > $o ).

tff(pred_def_74306,type,
    v126088: state_type > $o ).

tff(pred_def_74307,type,
    v126084: state_type > $o ).

tff(pred_def_74308,type,
    v126091: state_type > $o ).

tff(pred_def_74309,type,
    v126092: state_type > $o ).

tff(pred_def_74310,type,
    v126090: state_type > $o ).

tff(pred_def_74311,type,
    v126093: state_type > $o ).

tff(pred_def_74312,type,
    v126089: state_type > $o ).

tff(pred_def_74313,type,
    v126029: ( state_type * $int ) > $o ).

tff(pred_def_74314,type,
    v126094: ( state_type * $int ) > $o ).

tff(pred_def_74315,type,
    v126028: state_type > $o ).

tff(pred_def_74316,type,
    v126097: state_type > $o ).

tff(pred_def_74317,type,
    v126098: state_type > $o ).

tff(pred_def_74318,type,
    v126096: state_type > $o ).

tff(pred_def_74319,type,
    v126099: state_type > $o ).

tff(pred_def_74320,type,
    v126095: state_type > $o ).

tff(pred_def_74321,type,
    v126027: state_type > $o ).

tff(pred_def_74322,type,
    v126100: state_type > $o ).

tff(pred_def_74323,type,
    v126026: state_type > $o ).

tff(pred_def_74324,type,
    v126025: state_type > $o ).

tff(pred_def_74325,type,
    v126104: state_type > $o ).

tff(pred_def_74326,type,
    v126105: state_type > $o ).

tff(pred_def_74327,type,
    v126103: state_type > $o ).

tff(pred_def_74328,type,
    v126106: state_type > $o ).

tff(pred_def_74329,type,
    v126102: state_type > $o ).

tff(pred_def_74330,type,
    v126101: state_type > $o ).

tff(pred_def_74331,type,
    v126024: state_type > $o ).

tff(pred_def_74332,type,
    v126107: state_type > $o ).

tff(pred_def_74333,type,
    v126023: state_type > $o ).

tff(pred_def_74334,type,
    v126110: state_type > $o ).

tff(pred_def_74335,type,
    v126111: state_type > $o ).

tff(pred_def_74336,type,
    v126109: state_type > $o ).

tff(pred_def_74337,type,
    v126112: state_type > $o ).

tff(pred_def_74338,type,
    v126108: state_type > $o ).

tff(pred_def_74339,type,
    v126115: state_type > $o ).

tff(pred_def_74340,type,
    v126116: state_type > $o ).

tff(pred_def_74341,type,
    v126114: state_type > $o ).

tff(pred_def_74342,type,
    v126117: state_type > $o ).

tff(pred_def_74343,type,
    v126113: state_type > $o ).

tff(pred_def_74344,type,
    v126021: ( state_type * $int ) > $o ).

tff(pred_def_74345,type,
    v126118: ( state_type * $int ) > $o ).

tff(pred_def_74346,type,
    v126020: state_type > $o ).

tff(pred_def_74347,type,
    v126121: state_type > $o ).

tff(pred_def_74348,type,
    v126122: state_type > $o ).

tff(pred_def_74349,type,
    v126120: state_type > $o ).

tff(pred_def_74350,type,
    v126123: state_type > $o ).

tff(pred_def_74351,type,
    v126119: state_type > $o ).

tff(pred_def_74352,type,
    v126019: state_type > $o ).

tff(pred_def_74353,type,
    v126124: state_type > $o ).

tff(pred_def_74354,type,
    v126018: state_type > $o ).

tff(pred_def_74355,type,
    v126017: state_type > $o ).

tff(pred_def_74356,type,
    v126128: state_type > $o ).

tff(pred_def_74357,type,
    v126129: state_type > $o ).

tff(pred_def_74358,type,
    v126127: state_type > $o ).

tff(pred_def_74359,type,
    v126130: state_type > $o ).

tff(pred_def_74360,type,
    v126126: state_type > $o ).

tff(pred_def_74361,type,
    v126125: state_type > $o ).

tff(pred_def_74362,type,
    v126016: state_type > $o ).

tff(pred_def_74363,type,
    v126131: state_type > $o ).

tff(pred_def_74364,type,
    v126015: state_type > $o ).

tff(pred_def_74365,type,
    v126134: state_type > $o ).

tff(pred_def_74366,type,
    v126135: state_type > $o ).

tff(pred_def_74367,type,
    v126133: state_type > $o ).

tff(pred_def_74368,type,
    v126136: state_type > $o ).

tff(pred_def_74369,type,
    v126132: state_type > $o ).

tff(pred_def_74370,type,
    v126139: state_type > $o ).

tff(pred_def_74371,type,
    v126140: state_type > $o ).

tff(pred_def_74372,type,
    v126138: state_type > $o ).

tff(pred_def_74373,type,
    v126141: state_type > $o ).

tff(pred_def_74374,type,
    v126137: state_type > $o ).

tff(pred_def_74375,type,
    v126013: ( state_type * $int ) > $o ).

tff(pred_def_74376,type,
    v126142: ( state_type * $int ) > $o ).

tff(pred_def_74377,type,
    v126012: state_type > $o ).

tff(pred_def_74378,type,
    v126145: state_type > $o ).

tff(pred_def_74379,type,
    v126146: state_type > $o ).

tff(pred_def_74380,type,
    v126144: state_type > $o ).

tff(pred_def_74381,type,
    v126147: state_type > $o ).

tff(pred_def_74382,type,
    v126143: state_type > $o ).

tff(pred_def_74383,type,
    v126011: state_type > $o ).

tff(pred_def_74384,type,
    v126148: state_type > $o ).

tff(pred_def_74385,type,
    v126010: state_type > $o ).

tff(pred_def_74386,type,
    v126009: state_type > $o ).

tff(pred_def_74387,type,
    v126152: state_type > $o ).

tff(pred_def_74388,type,
    v126153: state_type > $o ).

tff(pred_def_74389,type,
    v126151: state_type > $o ).

tff(pred_def_74390,type,
    v126154: state_type > $o ).

tff(pred_def_74391,type,
    v126150: state_type > $o ).

tff(pred_def_74392,type,
    v126149: state_type > $o ).

tff(pred_def_74393,type,
    v126008: state_type > $o ).

tff(pred_def_74394,type,
    v126155: state_type > $o ).

tff(pred_def_74395,type,
    v126007: state_type > $o ).

tff(pred_def_74396,type,
    v126158: state_type > $o ).

tff(pred_def_74397,type,
    v126159: state_type > $o ).

tff(pred_def_74398,type,
    v126157: state_type > $o ).

tff(pred_def_74399,type,
    v126160: state_type > $o ).

tff(pred_def_74400,type,
    v126156: state_type > $o ).

tff(pred_def_74401,type,
    v126163: state_type > $o ).

tff(pred_def_74402,type,
    v126164: state_type > $o ).

tff(pred_def_74403,type,
    v126162: state_type > $o ).

tff(pred_def_74404,type,
    v126165: state_type > $o ).

tff(pred_def_74405,type,
    v126161: state_type > $o ).

tff(pred_def_74406,type,
    v126005: ( state_type * $int ) > $o ).

tff(pred_def_74407,type,
    v126166: ( state_type * $int ) > $o ).

tff(pred_def_74408,type,
    v126004: state_type > $o ).

tff(pred_def_74409,type,
    v126169: state_type > $o ).

tff(pred_def_74410,type,
    v126170: state_type > $o ).

tff(pred_def_74411,type,
    v126168: state_type > $o ).

tff(pred_def_74412,type,
    v126171: state_type > $o ).

tff(pred_def_74413,type,
    v126167: state_type > $o ).

tff(pred_def_74414,type,
    v126003: state_type > $o ).

tff(pred_def_74415,type,
    v126172: state_type > $o ).

tff(pred_def_74416,type,
    v126002: state_type > $o ).

tff(pred_def_74417,type,
    v126001: state_type > $o ).

tff(pred_def_74418,type,
    v126176: state_type > $o ).

tff(pred_def_74419,type,
    v126177: state_type > $o ).

tff(pred_def_74420,type,
    v126175: state_type > $o ).

tff(pred_def_74421,type,
    v126178: state_type > $o ).

tff(pred_def_74422,type,
    v126174: state_type > $o ).

tff(pred_def_74423,type,
    v126173: state_type > $o ).

tff(pred_def_74424,type,
    v126000: state_type > $o ).

tff(pred_def_74425,type,
    v126179: state_type > $o ).

tff(pred_def_74426,type,
    v125999: state_type > $o ).

tff(pred_def_74427,type,
    v126182: state_type > $o ).

tff(pred_def_74428,type,
    v126183: state_type > $o ).

tff(pred_def_74429,type,
    v126181: state_type > $o ).

tff(pred_def_74430,type,
    v126184: state_type > $o ).

tff(pred_def_74431,type,
    v126180: state_type > $o ).

tff(pred_def_74432,type,
    v126187: state_type > $o ).

tff(pred_def_74433,type,
    v126188: state_type > $o ).

tff(pred_def_74434,type,
    v126186: state_type > $o ).

tff(pred_def_74435,type,
    v126189: state_type > $o ).

tff(pred_def_74436,type,
    v126185: state_type > $o ).

tff(pred_def_74437,type,
    v125997: ( state_type * $int ) > $o ).

tff(pred_def_74438,type,
    v125982: ( state_type * $int ) > $o ).

tff(pred_def_74439,type,
    v126199: state_type > $o ).

tff(pred_def_74440,type,
    v126197: state_type > $o ).

tff(pred_def_74441,type,
    v126196: state_type > $o ).

tff(pred_def_74442,type,
    v126195: ( state_type * $int ) > $o ).

tff(pred_def_74443,type,
    v126193: state_type > $o ).

tff(pred_def_74444,type,
    v126209: state_type > $o ).

tff(pred_def_74445,type,
    v126207: state_type > $o ).

tff(pred_def_74446,type,
    v126206: state_type > $o ).

tff(pred_def_74447,type,
    v126205: ( state_type * $int ) > $o ).

tff(pred_def_74448,type,
    v126203: state_type > $o ).

tff(pred_def_74449,type,
    v126219: state_type > $o ).

tff(pred_def_74450,type,
    v126217: state_type > $o ).

tff(pred_def_74451,type,
    v126216: state_type > $o ).

tff(pred_def_74452,type,
    v126215: ( state_type * $int ) > $o ).

tff(pred_def_74453,type,
    v126213: state_type > $o ).

tff(pred_def_74454,type,
    v126223: state_type > $o ).

tff(pred_def_74455,type,
    v126225: state_type > $o ).

tff(pred_def_74456,type,
    v126227: state_type > $o ).

tff(pred_def_74457,type,
    v126233: state_type > $o ).

tff(pred_def_74458,type,
    v126232: state_type > $o ).

tff(pred_def_74459,type,
    v126231: state_type > $o ).

tff(pred_def_74460,type,
    v126230: state_type > $o ).

tff(pred_def_74461,type,
    v126229: state_type > $o ).

tff(pred_def_74462,type,
    v126228: ( state_type * $int ) > $o ).

tff(pred_def_74463,type,
    v126191: ( state_type * $int ) > $o ).

tff(pred_def_74464,type,
    v126262: ( state_type * $int ) > $o ).

tff(pred_def_74465,type,
    v125960: ( state_type * $int ) > $o ).

tff(pred_def_74466,type,
    v126261: state_type > $o ).

tff(pred_def_74467,type,
    v126265: state_type > $o ).

tff(pred_def_74468,type,
    v126266: state_type > $o ).

tff(pred_def_74469,type,
    v126264: state_type > $o ).

tff(pred_def_74470,type,
    v126267: state_type > $o ).

tff(pred_def_74471,type,
    v126263: state_type > $o ).

tff(pred_def_74472,type,
    v126260: state_type > $o ).

tff(pred_def_74473,type,
    v126268: state_type > $o ).

tff(pred_def_74474,type,
    v126259: state_type > $o ).

tff(pred_def_74475,type,
    v126271: state_type > $o ).

tff(pred_def_74476,type,
    v126272: state_type > $o ).

tff(pred_def_74477,type,
    v126270: state_type > $o ).

tff(pred_def_74478,type,
    v126273: state_type > $o ).

tff(pred_def_74479,type,
    v126269: state_type > $o ).

tff(pred_def_74480,type,
    v126258: state_type > $o ).

tff(pred_def_74481,type,
    v126274: state_type > $o ).

tff(pred_def_74482,type,
    v126257: state_type > $o ).

tff(pred_def_74483,type,
    v126277: state_type > $o ).

tff(pred_def_74484,type,
    v126278: state_type > $o ).

tff(pred_def_74485,type,
    v126276: state_type > $o ).

tff(pred_def_74486,type,
    v126279: state_type > $o ).

tff(pred_def_74487,type,
    v126275: state_type > $o ).

tff(pred_def_74488,type,
    v126256: state_type > $o ).

tff(pred_def_74489,type,
    v126280: state_type > $o ).

tff(pred_def_74490,type,
    v126255: state_type > $o ).

tff(pred_def_74491,type,
    v126283: state_type > $o ).

tff(pred_def_74492,type,
    v126284: state_type > $o ).

tff(pred_def_74493,type,
    v126282: state_type > $o ).

tff(pred_def_74494,type,
    v126285: state_type > $o ).

tff(pred_def_74495,type,
    v126281: state_type > $o ).

tff(pred_def_74496,type,
    v126254: state_type > $o ).

tff(pred_def_74497,type,
    v126286: state_type > $o ).

tff(pred_def_74498,type,
    v126253: state_type > $o ).

tff(pred_def_74499,type,
    v126252: state_type > $o ).

tff(pred_def_74500,type,
    v126290: state_type > $o ).

tff(pred_def_74501,type,
    v126291: state_type > $o ).

tff(pred_def_74502,type,
    v126289: state_type > $o ).

tff(pred_def_74503,type,
    v126292: state_type > $o ).

tff(pred_def_74504,type,
    v126288: state_type > $o ).

tff(pred_def_74505,type,
    v126287: state_type > $o ).

tff(pred_def_74506,type,
    v126251: state_type > $o ).

tff(pred_def_74507,type,
    v126293: state_type > $o ).

tff(pred_def_74508,type,
    v126250: state_type > $o ).

tff(pred_def_74509,type,
    v126296: state_type > $o ).

tff(pred_def_74510,type,
    v126297: state_type > $o ).

tff(pred_def_74511,type,
    v126295: state_type > $o ).

tff(pred_def_74512,type,
    v126298: state_type > $o ).

tff(pred_def_74513,type,
    v126294: state_type > $o ).

tff(pred_def_74514,type,
    v126301: state_type > $o ).

tff(pred_def_74515,type,
    v126302: state_type > $o ).

tff(pred_def_74516,type,
    v126300: state_type > $o ).

tff(pred_def_74517,type,
    v126303: state_type > $o ).

tff(pred_def_74518,type,
    v126299: state_type > $o ).

tff(pred_def_74519,type,
    v126306: state_type > $o ).

tff(pred_def_74520,type,
    v126307: state_type > $o ).

tff(pred_def_74521,type,
    v126305: state_type > $o ).

tff(pred_def_74522,type,
    v126308: state_type > $o ).

tff(pred_def_74523,type,
    v126304: state_type > $o ).

tff(pred_def_74524,type,
    v126311: state_type > $o ).

tff(pred_def_74525,type,
    v126312: state_type > $o ).

tff(pred_def_74526,type,
    v126310: state_type > $o ).

tff(pred_def_74527,type,
    v126313: state_type > $o ).

tff(pred_def_74528,type,
    v126309: state_type > $o ).

tff(pred_def_74529,type,
    v126316: state_type > $o ).

tff(pred_def_74530,type,
    v126317: state_type > $o ).

tff(pred_def_74531,type,
    v126315: state_type > $o ).

tff(pred_def_74532,type,
    v126318: state_type > $o ).

tff(pred_def_74533,type,
    v126314: state_type > $o ).

tff(pred_def_74534,type,
    v126248: ( state_type * $int ) > $o ).

tff(pred_def_74535,type,
    v126247: state_type > $o ).

tff(pred_def_74536,type,
    v126323: state_type > $o ).

tff(pred_def_74537,type,
    v126325: state_type > $o ).

tff(pred_def_74538,type,
    v126326: state_type > $o ).

tff(pred_def_74539,type,
    v126324: state_type > $o ).

tff(pred_def_74540,type,
    v126322: state_type > $o ).

tff(pred_def_74541,type,
    v126321: state_type > $o ).

tff(pred_def_74542,type,
    v126327: state_type > $o ).

tff(pred_def_74543,type,
    v126320: state_type > $o ).

tff(pred_def_74544,type,
    v126328: state_type > $o ).

tff(pred_def_74545,type,
    v126319: state_type > $o ).

tff(pred_def_74546,type,
    v126246: state_type > $o ).

tff(pred_def_74547,type,
    v126329: state_type > $o ).

tff(pred_def_74548,type,
    v126245: state_type > $o ).

tff(pred_def_74549,type,
    v126336: state_type > $o ).

tff(pred_def_74550,type,
    v126335: state_type > $o ).

tff(pred_def_74551,type,
    v126334: state_type > $o ).

tff(pred_def_74552,type,
    v126338: state_type > $o ).

tff(pred_def_74553,type,
    v126337: state_type > $o ).

tff(pred_def_74554,type,
    v126333: state_type > $o ).

tff(pred_def_74555,type,
    v126332: state_type > $o ).

tff(pred_def_74556,type,
    v126339: state_type > $o ).

tff(pred_def_74557,type,
    v126331: state_type > $o ).

tff(pred_def_74558,type,
    v126340: state_type > $o ).

tff(pred_def_74559,type,
    v126330: state_type > $o ).

tff(pred_def_74560,type,
    v126244: state_type > $o ).

tff(pred_def_74561,type,
    v126341: state_type > $o ).

tff(pred_def_74562,type,
    v126243: state_type > $o ).

tff(pred_def_74563,type,
    v126348: state_type > $o ).

tff(pred_def_74564,type,
    v126347: state_type > $o ).

tff(pred_def_74565,type,
    v126346: state_type > $o ).

tff(pred_def_74566,type,
    v126350: state_type > $o ).

tff(pred_def_74567,type,
    v126349: state_type > $o ).

tff(pred_def_74568,type,
    v126345: state_type > $o ).

tff(pred_def_74569,type,
    v126344: state_type > $o ).

tff(pred_def_74570,type,
    v126351: state_type > $o ).

tff(pred_def_74571,type,
    v126343: state_type > $o ).

tff(pred_def_74572,type,
    v126352: state_type > $o ).

tff(pred_def_74573,type,
    v126342: state_type > $o ).

tff(pred_def_74574,type,
    v126242: state_type > $o ).

tff(pred_def_74575,type,
    v126353: state_type > $o ).

tff(pred_def_74576,type,
    v126241: state_type > $o ).

tff(pred_def_74577,type,
    v126360: state_type > $o ).

tff(pred_def_74578,type,
    v126359: state_type > $o ).

tff(pred_def_74579,type,
    v126358: state_type > $o ).

tff(pred_def_74580,type,
    v126362: state_type > $o ).

tff(pred_def_74581,type,
    v126361: state_type > $o ).

tff(pred_def_74582,type,
    v126357: state_type > $o ).

tff(pred_def_74583,type,
    v126356: state_type > $o ).

tff(pred_def_74584,type,
    v126363: state_type > $o ).

tff(pred_def_74585,type,
    v126355: state_type > $o ).

tff(pred_def_74586,type,
    v126364: state_type > $o ).

tff(pred_def_74587,type,
    v126354: state_type > $o ).

tff(pred_def_74588,type,
    v126240: state_type > $o ).

tff(pred_def_74589,type,
    v126365: state_type > $o ).

tff(pred_def_74590,type,
    v126239: state_type > $o ).

tff(pred_def_74591,type,
    v126238: state_type > $o ).

tff(pred_def_74592,type,
    v126373: state_type > $o ).

tff(pred_def_74593,type,
    v126372: state_type > $o ).

tff(pred_def_74594,type,
    v126371: state_type > $o ).

tff(pred_def_74595,type,
    v126375: state_type > $o ).

tff(pred_def_74596,type,
    v126374: state_type > $o ).

tff(pred_def_74597,type,
    v126370: state_type > $o ).

tff(pred_def_74598,type,
    v126369: state_type > $o ).

tff(pred_def_74599,type,
    v126376: state_type > $o ).

tff(pred_def_74600,type,
    v126368: state_type > $o ).

tff(pred_def_74601,type,
    v126377: state_type > $o ).

tff(pred_def_74602,type,
    v126367: state_type > $o ).

tff(pred_def_74603,type,
    v126366: state_type > $o ).

tff(pred_def_74604,type,
    v126237: state_type > $o ).

tff(pred_def_74605,type,
    v126378: state_type > $o ).

tff(pred_def_74606,type,
    v126236: state_type > $o ).

tff(pred_def_74607,type,
    v126381: state_type > $o ).

tff(pred_def_74608,type,
    v126382: state_type > $o ).

tff(pred_def_74609,type,
    v126380: state_type > $o ).

tff(pred_def_74610,type,
    v126383: state_type > $o ).

tff(pred_def_74611,type,
    v126379: state_type > $o ).

tff(pred_def_74612,type,
    v126386: state_type > $o ).

tff(pred_def_74613,type,
    v126387: state_type > $o ).

tff(pred_def_74614,type,
    v126385: state_type > $o ).

tff(pred_def_74615,type,
    v126388: state_type > $o ).

tff(pred_def_74616,type,
    v126384: state_type > $o ).

tff(pred_def_74617,type,
    v126391: state_type > $o ).

tff(pred_def_74618,type,
    v126392: state_type > $o ).

tff(pred_def_74619,type,
    v126390: state_type > $o ).

tff(pred_def_74620,type,
    v126393: state_type > $o ).

tff(pred_def_74621,type,
    v126389: state_type > $o ).

tff(pred_def_74622,type,
    v126396: state_type > $o ).

tff(pred_def_74623,type,
    v126397: state_type > $o ).

tff(pred_def_74624,type,
    v126395: state_type > $o ).

tff(pred_def_74625,type,
    v126398: state_type > $o ).

tff(pred_def_74626,type,
    v126394: state_type > $o ).

tff(pred_def_74627,type,
    v126401: state_type > $o ).

tff(pred_def_74628,type,
    v126400: state_type > $o ).

tff(pred_def_74629,type,
    v126402: state_type > $o ).

tff(pred_def_74630,type,
    v126399: state_type > $o ).

tff(pred_def_74631,type,
    v125980: ( state_type * $int ) > $o ).

tff(pred_def_74632,type,
    v125978: ( state_type * $int ) > $o ).

tff(pred_def_74633,type,
    v125976: ( state_type * $int ) > $o ).

tff(pred_def_74634,type,
    v125974: ( state_type * $int ) > $o ).

tff(pred_def_74635,type,
    v126408: state_type > $o ).

tff(pred_def_74636,type,
    v126406: state_type > $o ).

tff(pred_def_74637,type,
    v126404: state_type > $o ).

tff(pred_def_74638,type,
    v126415: state_type > $o ).

tff(pred_def_74639,type,
    v126413: state_type > $o ).

tff(pred_def_74640,type,
    v126412: state_type > $o ).

tff(pred_def_74641,type,
    v126411: state_type > $o ).

tff(pred_def_74642,type,
    v126423: state_type > $o ).

tff(pred_def_74643,type,
    v126424: state_type > $o ).

tff(pred_def_74644,type,
    v126422: state_type > $o ).

tff(pred_def_74645,type,
    v126419: ( state_type * $int ) > $o ).

tff(pred_def_74646,type,
    v126421: ( state_type * $int ) > $o ).

tff(pred_def_74647,type,
    v125964: ( state_type * $int ) > $o ).

tff(pred_def_74648,type,
    v125962: ( state_type * $int ) > $o ).

tff(pred_def_74649,type,
    v126428: state_type > $o ).

tff(pred_def_74650,type,
    v126430: state_type > $o ).

tff(pred_def_74651,type,
    v126431: state_type > $o ).

tff(pred_def_74652,type,
    v125958: state_type > $o ).

tff(pred_def_74653,type,
    v126433: state_type > $o ).

tff(pred_def_74654,type,
    v126435: state_type > $o ).

tff(pred_def_74655,type,
    v126441: state_type > $o ).

tff(pred_def_74656,type,
    v126443: state_type > $o ).

tff(pred_def_74657,type,
    v126453: state_type > $o ).

tff(pred_def_74658,type,
    v126454: state_type > $o ).

tff(pred_def_74659,type,
    v126452: state_type > $o ).

tff(pred_def_74660,type,
    v126456: state_type > $o ).

tff(pred_def_74661,type,
    v126457: state_type > $o ).

tff(pred_def_74662,type,
    v126455: state_type > $o ).

tff(pred_def_74663,type,
    v126451: state_type > $o ).

tff(pred_def_74664,type,
    v126450: state_type > $o ).

tff(pred_def_74665,type,
    v126449: state_type > $o ).

tff(pred_def_74666,type,
    v126448: state_type > $o ).

tff(pred_def_74667,type,
    v125928: ( state_type * $int ) > $o ).

tff(pred_def_74668,type,
    v126458: state_type > $o ).

tff(pred_def_74669,type,
    v126447: state_type > $o ).

tff(pred_def_74670,type,
    v126460: state_type > $o ).

tff(pred_def_74671,type,
    v126459: state_type > $o ).

tff(pred_def_74672,type,
    v126446: state_type > $o ).

tff(pred_def_74673,type,
    v126462: state_type > $o ).

tff(pred_def_74674,type,
    v126468: state_type > $o ).

tff(pred_def_74675,type,
    v126469: state_type > $o ).

tff(pred_def_74676,type,
    v126467: state_type > $o ).

tff(pred_def_74677,type,
    v126466: state_type > $o ).

tff(pred_def_74678,type,
    v126472: state_type > $o ).

tff(pred_def_74679,type,
    v126471: state_type > $o ).

tff(pred_def_74680,type,
    v126470: state_type > $o ).

tff(pred_def_74681,type,
    v126465: state_type > $o ).

tff(pred_def_74682,type,
    v126473: state_type > $o ).

tff(pred_def_74683,type,
    v126464: state_type > $o ).

tff(pred_def_74684,type,
    v126474: state_type > $o ).

tff(pred_def_74685,type,
    v126463: state_type > $o ).

tff(pred_def_74686,type,
    v126461: state_type > $o ).

tff(pred_def_74687,type,
    v126445: state_type > $o ).

tff(pred_def_74688,type,
    v125956: ( state_type * $int ) > $o ).

tff(pred_def_74689,type,
    v126475: ( state_type * $int ) > $o ).

tff(pred_def_74690,type,
    v126439: state_type > $o ).

tff(pred_def_74691,type,
    v125954: ( state_type * $int ) > $o ).

tff(pred_def_74692,type,
    v125952: ( state_type * $int ) > $o ).

tff(pred_def_74693,type,
    v125950: ( state_type * $int ) > $o ).

tff(pred_def_74694,type,
    v126479: state_type > $o ).

tff(pred_def_74695,type,
    v126477: state_type > $o ).

tff(pred_def_74696,type,
    v126486: state_type > $o ).

tff(pred_def_74697,type,
    v126484: state_type > $o ).

tff(pred_def_74698,type,
    v126483: state_type > $o ).

tff(pred_def_74699,type,
    v126482: state_type > $o ).

tff(pred_def_74700,type,
    v126494: state_type > $o ).

tff(pred_def_74701,type,
    v126495: state_type > $o ).

tff(pred_def_74702,type,
    v126493: state_type > $o ).

tff(pred_def_74703,type,
    v126490: ( state_type * $int ) > $o ).

tff(pred_def_74704,type,
    v126492: ( state_type * $int ) > $o ).

tff(pred_def_74705,type,
    v126481: ( state_type * $int ) > $o ).

tff(pred_def_74706,type,
    v125932: ( state_type * $int ) > $o ).

tff(pred_def_74707,type,
    v125930: ( state_type * $int ) > $o ).

tff(pred_def_74708,type,
    v126499: state_type > $o ).

tff(pred_def_74709,type,
    v126505: state_type > $o ).

tff(pred_def_74710,type,
    v126504: state_type > $o ).

tff(pred_def_74711,type,
    v126503: state_type > $o ).

tff(pred_def_74712,type,
    v126507: state_type > $o ).

tff(pred_def_74713,type,
    v126506: state_type > $o ).

tff(pred_def_74714,type,
    v126502: state_type > $o ).

tff(pred_def_74715,type,
    v126509: state_type > $o ).

tff(pred_def_74716,type,
    v126515: state_type > $o ).

tff(pred_def_74717,type,
    v126514: state_type > $o ).

tff(pred_def_74718,type,
    v126513: state_type > $o ).

tff(pred_def_74719,type,
    v126512: state_type > $o ).

tff(pred_def_74720,type,
    v126516: state_type > $o ).

tff(pred_def_74721,type,
    v126511: state_type > $o ).

tff(pred_def_74722,type,
    v126517: state_type > $o ).

tff(pred_def_74723,type,
    v126510: state_type > $o ).

tff(pred_def_74724,type,
    v126508: state_type > $o ).

tff(pred_def_74725,type,
    v126501: state_type > $o ).

tff(pred_def_74726,type,
    v126523: state_type > $o ).

tff(pred_def_74727,type,
    v126521: state_type > $o ).

tff(pred_def_74728,type,
    v126520: state_type > $o ).

tff(pred_def_74729,type,
    v126519: ( state_type * $int ) > $o ).

tff(pred_def_74730,type,
    v126533: state_type > $o ).

tff(pred_def_74731,type,
    v126532: state_type > $o ).

tff(pred_def_74732,type,
    v126531: state_type > $o ).

tff(pred_def_74733,type,
    v126530: state_type > $o ).

tff(pred_def_74734,type,
    v126535: state_type > $o ).

tff(pred_def_74735,type,
    v126536: state_type > $o ).

tff(pred_def_74736,type,
    v126534: state_type > $o ).

tff(pred_def_74737,type,
    v126529: state_type > $o ).

tff(pred_def_74738,type,
    v126539: state_type > $o ).

tff(pred_def_74739,type,
    v126538: state_type > $o ).

tff(pred_def_74740,type,
    v126540: state_type > $o ).

tff(pred_def_74741,type,
    v126537: state_type > $o ).

tff(pred_def_74742,type,
    v126528: state_type > $o ).

tff(pred_def_74743,type,
    v126544: state_type > $o ).

tff(pred_def_74744,type,
    v126543: state_type > $o ).

tff(pred_def_74745,type,
    v126542: state_type > $o ).

tff(pred_def_74746,type,
    v126545: state_type > $o ).

tff(pred_def_74747,type,
    v126541: state_type > $o ).

tff(pred_def_74748,type,
    v126527: state_type > $o ).

tff(pred_def_74749,type,
    v126552: state_type > $o ).

tff(pred_def_74750,type,
    v126550: state_type > $o ).

tff(pred_def_74751,type,
    v126549: state_type > $o ).

tff(pred_def_74752,type,
    v126548: ( state_type * $int ) > $o ).

tff(pred_def_74753,type,
    v126437: state_type > $o ).

tff(pred_def_74754,type,
    v126558: state_type > $o ).

tff(pred_def_74755,type,
    v126560: state_type > $o ).

tff(pred_def_74756,type,
    v126563: state_type > $o ).

tff(pred_def_74757,type,
    v126564: state_type > $o ).

tff(pred_def_74758,type,
    v126562: state_type > $o ).

tff(pred_def_74759,type,
    v126561: state_type > $o ).

tff(pred_def_74760,type,
    v126559: state_type > $o ).

tff(pred_def_74761,type,
    v126557: state_type > $o ).

tff(pred_def_74762,type,
    v126570: state_type > $o ).

tff(pred_def_74763,type,
    v126568: state_type > $o ).

tff(pred_def_74764,type,
    v126567: state_type > $o ).

tff(pred_def_74765,type,
    v126566: ( state_type * $int ) > $o ).

tff(pred_def_74766,type,
    v126584: state_type > $o ).

tff(pred_def_74767,type,
    v126582: state_type > $o ).

tff(pred_def_74768,type,
    v126588: state_type > $o ).

tff(pred_def_74769,type,
    v126586: state_type > $o ).

tff(pred_def_74770,type,
    v126600: state_type > $o ).

tff(pred_def_74771,type,
    v126601: state_type > $o ).

tff(pred_def_74772,type,
    v126598: state_type > $o ).

tff(pred_def_74773,type,
    v126576: ( state_type * $int ) > $o ).

tff(pred_def_74774,type,
    v126608: state_type > $o ).

tff(pred_def_74775,type,
    v126607: state_type > $o ).

tff(pred_def_74776,type,
    v126610: state_type > $o ).

tff(pred_def_74777,type,
    v126609: state_type > $o ).

tff(pred_def_74778,type,
    v126606: state_type > $o ).

tff(pred_def_74779,type,
    v126604: ( state_type * $int ) > $o ).

tff(pred_def_74780,type,
    v126574: state_type > $o ).

tff(pred_def_74781,type,
    v126603: ( state_type * $int ) > $o ).

tff(pred_def_74782,type,
    v126596: ( state_type * $int ) > $o ).

tff(pred_def_74783,type,
    v126594: ( state_type * $int ) > $o ).

tff(pred_def_74784,type,
    v126592: ( state_type * $int ) > $o ).

tff(pred_def_74785,type,
    v126590: ( state_type * $int ) > $o ).

tff(pred_def_74786,type,
    v126614: state_type > $o ).

tff(pred_def_74787,type,
    v126612: state_type > $o ).

tff(pred_def_74788,type,
    v126621: state_type > $o ).

tff(pred_def_74789,type,
    v126619: state_type > $o ).

tff(pred_def_74790,type,
    v126618: state_type > $o ).

tff(pred_def_74791,type,
    v126617: state_type > $o ).

tff(pred_def_74792,type,
    v126629: state_type > $o ).

tff(pred_def_74793,type,
    v126630: state_type > $o ).

tff(pred_def_74794,type,
    v126628: state_type > $o ).

tff(pred_def_74795,type,
    v126625: ( state_type * $int ) > $o ).

tff(pred_def_74796,type,
    v126627: ( state_type * $int ) > $o ).

tff(pred_def_74797,type,
    v126580: ( state_type * $int ) > $o ).

tff(pred_def_74798,type,
    v126578: ( state_type * $int ) > $o ).

tff(pred_def_74799,type,
    v126645: state_type > $o ).

tff(pred_def_74800,type,
    v126643: state_type > $o ).

tff(pred_def_74801,type,
    v126649: state_type > $o ).

tff(pred_def_74802,type,
    v126647: state_type > $o ).

tff(pred_def_74803,type,
    v126662: state_type > $o ).

tff(pred_def_74804,type,
    v126661: state_type > $o ).

tff(pred_def_74805,type,
    v126659: state_type > $o ).

tff(pred_def_74806,type,
    v126664: ( state_type * $int ) > $o ).

tff(pred_def_74807,type,
    v126666: state_type > $o ).

tff(pred_def_74808,type,
    v126669: ( state_type * $int ) > $o ).

tff(pred_def_74809,type,
    v126637: ( state_type * $int ) > $o ).

tff(pred_def_74810,type,
    v126684: state_type > $o ).

tff(pred_def_74811,type,
    v126683: state_type > $o ).

tff(pred_def_74812,type,
    v126682: state_type > $o ).

tff(pred_def_74813,type,
    v126685: state_type > $o ).

tff(pred_def_74814,type,
    v126681: state_type > $o ).

tff(pred_def_74815,type,
    v126680: state_type > $o ).

tff(pred_def_74816,type,
    v126686: state_type > $o ).

tff(pred_def_74817,type,
    v126679: state_type > $o ).

tff(pred_def_74818,type,
    v126678: state_type > $o ).

tff(pred_def_74819,type,
    v126677: state_type > $o ).

tff(pred_def_74820,type,
    v126676: state_type > $o ).

tff(pred_def_74821,type,
    v126688: state_type > $o ).

tff(pred_def_74822,type,
    v126687: state_type > $o ).

tff(pred_def_74823,type,
    v126675: state_type > $o ).

tff(pred_def_74824,type,
    v126691: state_type > $o ).

tff(pred_def_74825,type,
    v126690: state_type > $o ).

tff(pred_def_74826,type,
    v126692: state_type > $o ).

tff(pred_def_74827,type,
    v126689: state_type > $o ).

tff(pred_def_74828,type,
    v126695: state_type > $o ).

tff(pred_def_74829,type,
    v126694: state_type > $o ).

tff(pred_def_74830,type,
    v126696: state_type > $o ).

tff(pred_def_74831,type,
    v126693: state_type > $o ).

tff(pred_def_74832,type,
    v126699: state_type > $o ).

tff(pred_def_74833,type,
    v126698: state_type > $o ).

tff(pred_def_74834,type,
    v126700: state_type > $o ).

tff(pred_def_74835,type,
    v126697: state_type > $o ).

tff(pred_def_74836,type,
    v126673: ( state_type * $int ) > $o ).

tff(pred_def_74837,type,
    v126635: state_type > $o ).

tff(pred_def_74838,type,
    v126672: ( state_type * $int ) > $o ).

tff(pred_def_74839,type,
    v126671: ( state_type * $int ) > $o ).

tff(pred_def_74840,type,
    v126657: ( state_type * $int ) > $o ).

tff(pred_def_74841,type,
    v126655: ( state_type * $int ) > $o ).

tff(pred_def_74842,type,
    v126653: ( state_type * $int ) > $o ).

tff(pred_def_74843,type,
    v126651: ( state_type * $int ) > $o ).

tff(pred_def_74844,type,
    v126704: state_type > $o ).

tff(pred_def_74845,type,
    v126702: state_type > $o ).

tff(pred_def_74846,type,
    v126711: state_type > $o ).

tff(pred_def_74847,type,
    v126709: state_type > $o ).

tff(pred_def_74848,type,
    v126708: state_type > $o ).

tff(pred_def_74849,type,
    v126707: state_type > $o ).

tff(pred_def_74850,type,
    v126719: state_type > $o ).

tff(pred_def_74851,type,
    v126720: state_type > $o ).

tff(pred_def_74852,type,
    v126718: state_type > $o ).

tff(pred_def_74853,type,
    v126715: ( state_type * $int ) > $o ).

tff(pred_def_74854,type,
    v126717: ( state_type * $int ) > $o ).

tff(pred_def_74855,type,
    v126641: ( state_type * $int ) > $o ).

tff(pred_def_74856,type,
    v126639: ( state_type * $int ) > $o ).

tff(pred_def_74857,type,
    v126725: state_type > $o ).

tff(pred_def_74858,type,
    v125926: state_type > $o ).

tff(pred_def_74859,type,
    v126733: state_type > $o ).

tff(pred_def_74860,type,
    v126731: state_type > $o ).

tff(pred_def_74861,type,
    v126730: state_type > $o ).

tff(pred_def_74862,type,
    v126729: ( state_type * $int ) > $o ).

tff(pred_def_74863,type,
    v126727: state_type > $o ).

tff(pred_def_74864,type,
    v126745: state_type > $o ).

tff(pred_def_74865,type,
    v126743: state_type > $o ).

tff(pred_def_74866,type,
    v126742: state_type > $o ).

tff(pred_def_74867,type,
    v126741: ( state_type * $int ) > $o ).

tff(pred_def_74868,type,
    v126739: ( state_type * $int ) > $o ).

tff(pred_def_74869,type,
    v126737: ( state_type * $int ) > $o ).

tff(pred_def_74870,type,
    v126765: ( state_type * $int ) > $o ).

tff(pred_def_74871,type,
    v126764: ( state_type * $int ) > $o ).

tff(pred_def_74872,type,
    v126763: ( state_type * $int ) > $o ).

tff(pred_def_74873,type,
    v126762: ( state_type * $int ) > $o ).

tff(pred_def_74874,type,
    v126761: ( state_type * $int ) > $o ).

tff(pred_def_74875,type,
    v126760: ( state_type * $int ) > $o ).

tff(pred_def_74876,type,
    v126759: ( state_type * $int ) > $o ).

tff(pred_def_74877,type,
    v126758: ( state_type * $int ) > $o ).

tff(pred_def_74878,type,
    v126757: ( state_type * $int ) > $o ).

tff(pred_def_74879,type,
    v126756: ( state_type * $int ) > $o ).

tff(pred_def_74880,type,
    v126755: ( state_type * $int ) > $o ).

tff(pred_def_74881,type,
    v126754: ( state_type * $int ) > $o ).

tff(pred_def_74882,type,
    v126753: ( state_type * $int ) > $o ).

tff(pred_def_74883,type,
    v126752: ( state_type * $int ) > $o ).

tff(pred_def_74884,type,
    v126750: ( state_type * $int ) > $o ).

tff(pred_def_74885,type,
    v126773: state_type > $o ).

tff(pred_def_74886,type,
    v126771: state_type > $o ).

tff(pred_def_74887,type,
    v126770: state_type > $o ).

tff(pred_def_74888,type,
    v126769: ( state_type * $int ) > $o ).

tff(pred_def_74889,type,
    v126767: state_type > $o ).

tff(pred_def_74890,type,
    v126787: state_type > $o ).

tff(pred_def_74891,type,
    v126785: state_type > $o ).

tff(pred_def_74892,type,
    v126791: state_type > $o ).

tff(pred_def_74893,type,
    v126789: state_type > $o ).

tff(pred_def_74894,type,
    v126798: ( state_type * $int ) > $o ).

tff(pred_def_74895,type,
    v126797: ( state_type * $int ) > $o ).

tff(pred_def_74896,type,
    v126800: state_type > $o ).

tff(pred_def_74897,type,
    v126804: state_type > $o ).

tff(pred_def_74898,type,
    v126803: ( state_type * $int ) > $o ).

tff(pred_def_74899,type,
    v126802: ( state_type * $int ) > $o ).

tff(pred_def_74900,type,
    v126808: state_type > $o ).

tff(pred_def_74901,type,
    v126807: ( state_type * $int ) > $o ).

tff(pred_def_74902,type,
    v126806: ( state_type * $int ) > $o ).

tff(pred_def_74903,type,
    v126781: ( state_type * $int ) > $o ).

tff(pred_def_74904,type,
    v126805: ( state_type * $int ) > $o ).

tff(pred_def_74905,type,
    v126801: ( state_type * $int ) > $o ).

tff(pred_def_74906,type,
    v126795: ( state_type * $int ) > $o ).

tff(pred_def_74907,type,
    v126793: ( state_type * $int ) > $o ).

tff(pred_def_74908,type,
    v126812: state_type > $o ).

tff(pred_def_74909,type,
    v126810: state_type > $o ).

tff(pred_def_74910,type,
    v126819: state_type > $o ).

tff(pred_def_74911,type,
    v126817: state_type > $o ).

tff(pred_def_74912,type,
    v126816: state_type > $o ).

tff(pred_def_74913,type,
    v126815: state_type > $o ).

tff(pred_def_74914,type,
    v126827: state_type > $o ).

tff(pred_def_74915,type,
    v126828: state_type > $o ).

tff(pred_def_74916,type,
    v126826: state_type > $o ).

tff(pred_def_74917,type,
    v126823: ( state_type * $int ) > $o ).

tff(pred_def_74918,type,
    v126825: ( state_type * $int ) > $o ).

tff(pred_def_74919,type,
    v126814: ( state_type * $int ) > $o ).

tff(pred_def_74920,type,
    v126783: ( state_type * $int ) > $o ).

tff(pred_def_74921,type,
    v126779: ( state_type * $int ) > $o ).

tff(pred_def_74922,type,
    v126840: state_type > $o ).

tff(pred_def_74923,type,
    v126838: state_type > $o ).

tff(pred_def_74924,type,
    v126844: state_type > $o ).

tff(pred_def_74925,type,
    v126842: state_type > $o ).

tff(pred_def_74926,type,
    v126852: ( state_type * $int ) > $o ).

tff(pred_def_74927,type,
    v126851: ( state_type * $int ) > $o ).

tff(pred_def_74928,type,
    v126853: state_type > $o ).

tff(pred_def_74929,type,
    v126854: ( state_type * $int ) > $o ).

tff(pred_def_74930,type,
    v126850: ( state_type * $int ) > $o ).

tff(pred_def_74931,type,
    v126856: state_type > $o ).

tff(pred_def_74932,type,
    v126860: state_type > $o ).

tff(pred_def_74933,type,
    v126859: ( state_type * $int ) > $o ).

tff(pred_def_74934,type,
    v126858: ( state_type * $int ) > $o ).

tff(pred_def_74935,type,
    v126864: state_type > $o ).

tff(pred_def_74936,type,
    v126863: ( state_type * $int ) > $o ).

tff(pred_def_74937,type,
    v126862: ( state_type * $int ) > $o ).

tff(pred_def_74938,type,
    v126834: ( state_type * $int ) > $o ).

tff(pred_def_74939,type,
    v126861: ( state_type * $int ) > $o ).

tff(pred_def_74940,type,
    v126857: ( state_type * $int ) > $o ).

tff(pred_def_74941,type,
    v126848: ( state_type * $int ) > $o ).

tff(pred_def_74942,type,
    v126846: ( state_type * $int ) > $o ).

tff(pred_def_74943,type,
    v126869: state_type > $o ).

tff(pred_def_74944,type,
    v126867: state_type > $o ).

tff(pred_def_74945,type,
    v126876: state_type > $o ).

tff(pred_def_74946,type,
    v126874: state_type > $o ).

tff(pred_def_74947,type,
    v126873: state_type > $o ).

tff(pred_def_74948,type,
    v126872: state_type > $o ).

tff(pred_def_74949,type,
    v126884: state_type > $o ).

tff(pred_def_74950,type,
    v126885: state_type > $o ).

tff(pred_def_74951,type,
    v126883: state_type > $o ).

tff(pred_def_74952,type,
    v126880: ( state_type * $int ) > $o ).

tff(pred_def_74953,type,
    bxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_74954,type,
    v126882: ( state_type * $int ) > $o ).

tff(pred_def_74955,type,
    v126871: ( state_type * $int ) > $o ).

tff(pred_def_74956,type,
    v126836: ( state_type * $int ) > $o ).

tff(pred_def_74957,type,
    v126832: ( state_type * $int ) > $o ).

tff(pred_def_74958,type,
    v126889: ( state_type * $int ) > $o ).

tff(pred_def_74959,type,
    v126777: ( state_type * $int ) > $o ).

tff(pred_def_74960,type,
    v126909: state_type > $o ).

tff(pred_def_74961,type,
    v126908: state_type > $o ).

tff(pred_def_74962,type,
    v126907: state_type > $o ).

tff(pred_def_74963,type,
    v126906: state_type > $o ).

tff(pred_def_74964,type,
    v126905: state_type > $o ).

tff(pred_def_74965,type,
    v126904: state_type > $o ).

tff(pred_def_74966,type,
    v126903: state_type > $o ).

tff(pred_def_74967,type,
    v126902: state_type > $o ).

tff(pred_def_74968,type,
    v126901: state_type > $o ).

tff(pred_def_74969,type,
    v126900: state_type > $o ).

tff(pred_def_74970,type,
    v126899: state_type > $o ).

tff(pred_def_74971,type,
    v126898: state_type > $o ).

tff(pred_def_74972,type,
    v126897: state_type > $o ).

tff(pred_def_74973,type,
    v126896: state_type > $o ).

tff(pred_def_74974,type,
    v126894: state_type > $o ).

tff(pred_def_74975,type,
    v126910: state_type > $o ).

tff(pred_def_74976,type,
    v126893: state_type > $o ).

tff(pred_def_74977,type,
    v126913: state_type > $o ).

tff(pred_def_74978,type,
    v126914: state_type > $o ).

tff(pred_def_74979,type,
    v126912: state_type > $o ).

tff(pred_def_74980,type,
    v126922: state_type > $o ).

tff(pred_def_74981,type,
    v126923: state_type > $o ).

tff(pred_def_74982,type,
    v126921: state_type > $o ).

tff(pred_def_74983,type,
    v126924: state_type > $o ).

tff(pred_def_74984,type,
    v126920: state_type > $o ).

tff(pred_def_74985,type,
    v126919: state_type > $o ).

tff(pred_def_74986,type,
    v126928: state_type > $o ).

tff(pred_def_74987,type,
    v126929: state_type > $o ).

tff(pred_def_74988,type,
    v126927: state_type > $o ).

tff(pred_def_74989,type,
    v126930: state_type > $o ).

tff(pred_def_74990,type,
    v126926: state_type > $o ).

tff(pred_def_74991,type,
    v126925: state_type > $o ).

tff(pred_def_74992,type,
    v126918: state_type > $o ).

tff(pred_def_74993,type,
    v126934: state_type > $o ).

tff(pred_def_74994,type,
    v126935: state_type > $o ).

tff(pred_def_74995,type,
    v126933: state_type > $o ).

tff(pred_def_74996,type,
    v126936: state_type > $o ).

tff(pred_def_74997,type,
    v126932: state_type > $o ).

tff(pred_def_74998,type,
    v126931: state_type > $o ).

tff(pred_def_74999,type,
    v126917: state_type > $o ).

tff(pred_def_75000,type,
    v126915: state_type > $o ).

tff(pred_def_75001,type,
    v126911: state_type > $o ).

tff(pred_def_75002,type,
    v126892: state_type > $o ).

tff(pred_def_75003,type,
    v126939: state_type > $o ).

tff(pred_def_75004,type,
    v126940: state_type > $o ).

tff(pred_def_75005,type,
    v126938: state_type > $o ).

tff(pred_def_75006,type,
    v126948: state_type > $o ).

tff(pred_def_75007,type,
    v126947: state_type > $o ).

tff(pred_def_75008,type,
    v126949: state_type > $o ).

tff(pred_def_75009,type,
    v126946: state_type > $o ).

tff(pred_def_75010,type,
    v126945: state_type > $o ).

tff(pred_def_75011,type,
    v126953: state_type > $o ).

tff(pred_def_75012,type,
    v126952: state_type > $o ).

tff(pred_def_75013,type,
    v126954: state_type > $o ).

tff(pred_def_75014,type,
    v126951: state_type > $o ).

tff(pred_def_75015,type,
    v126950: state_type > $o ).

tff(pred_def_75016,type,
    v126944: state_type > $o ).

tff(pred_def_75017,type,
    v126958: state_type > $o ).

tff(pred_def_75018,type,
    v126957: state_type > $o ).

tff(pred_def_75019,type,
    v126959: state_type > $o ).

tff(pred_def_75020,type,
    v126956: state_type > $o ).

tff(pred_def_75021,type,
    v126955: state_type > $o ).

tff(pred_def_75022,type,
    v126943: state_type > $o ).

tff(pred_def_75023,type,
    v126941: state_type > $o ).

tff(pred_def_75024,type,
    v126937: state_type > $o ).

tff(pred_def_75025,type,
    v126891: state_type > $o ).

tff(pred_def_75026,type,
    v126961: state_type > $o ).

tff(pred_def_75027,type,
    v126968: state_type > $o ).

tff(pred_def_75028,type,
    v126969: state_type > $o ).

tff(pred_def_75029,type,
    v126967: state_type > $o ).

tff(pred_def_75030,type,
    v126966: state_type > $o ).

tff(pred_def_75031,type,
    v126972: state_type > $o ).

tff(pred_def_75032,type,
    v126973: state_type > $o ).

tff(pred_def_75033,type,
    v126971: state_type > $o ).

tff(pred_def_75034,type,
    v126970: state_type > $o ).

tff(pred_def_75035,type,
    v126965: state_type > $o ).

tff(pred_def_75036,type,
    v126976: state_type > $o ).

tff(pred_def_75037,type,
    v126977: state_type > $o ).

tff(pred_def_75038,type,
    v126975: state_type > $o ).

tff(pred_def_75039,type,
    v126974: state_type > $o ).

tff(pred_def_75040,type,
    v126964: state_type > $o ).

tff(pred_def_75041,type,
    v126962: state_type > $o ).

tff(pred_def_75042,type,
    v126960: state_type > $o ).

tff(pred_def_75043,type,
    v126983: state_type > $o ).

tff(pred_def_75044,type,
    v126982: state_type > $o ).

tff(pred_def_75045,type,
    v126981: state_type > $o ).

tff(pred_def_75046,type,
    v126984: state_type > $o ).

tff(pred_def_75047,type,
    v126980: state_type > $o ).

tff(pred_def_75048,type,
    v126986: state_type > $o ).

tff(pred_def_75049,type,
    v126992: state_type > $o ).

tff(pred_def_75050,type,
    v126993: state_type > $o ).

tff(pred_def_75051,type,
    v126991: state_type > $o ).

tff(pred_def_75052,type,
    v126990: state_type > $o ).

tff(pred_def_75053,type,
    v126996: state_type > $o ).

tff(pred_def_75054,type,
    v126995: state_type > $o ).

tff(pred_def_75055,type,
    v126994: state_type > $o ).

tff(pred_def_75056,type,
    v126989: state_type > $o ).

tff(pred_def_75057,type,
    v126997: state_type > $o ).

tff(pred_def_75058,type,
    v126988: state_type > $o ).

tff(pred_def_75059,type,
    v126998: state_type > $o ).

tff(pred_def_75060,type,
    v126987: state_type > $o ).

tff(pred_def_75061,type,
    v126985: state_type > $o ).

tff(pred_def_75062,type,
    v126979: state_type > $o ).

tff(pred_def_75063,type,
    v127004: state_type > $o ).

tff(pred_def_75064,type,
    v127002: state_type > $o ).

tff(pred_def_75065,type,
    v127001: state_type > $o ).

tff(pred_def_75066,type,
    v127000: ( state_type * $int ) > $o ).

tff(pred_def_75067,type,
    v127012: state_type > $o ).

tff(pred_def_75068,type,
    v127011: state_type > $o ).

tff(pred_def_75069,type,
    v127010: state_type > $o ).

tff(pred_def_75070,type,
    v127014: state_type > $o ).

tff(pred_def_75071,type,
    v127013: state_type > $o ).

tff(pred_def_75072,type,
    v127009: state_type > $o ).

tff(pred_def_75073,type,
    v127016: state_type > $o ).

tff(pred_def_75074,type,
    v127022: state_type > $o ).

tff(pred_def_75075,type,
    v127021: state_type > $o ).

tff(pred_def_75076,type,
    v127020: state_type > $o ).

tff(pred_def_75077,type,
    v127019: state_type > $o ).

tff(pred_def_75078,type,
    v127023: state_type > $o ).

tff(pred_def_75079,type,
    v127018: state_type > $o ).

tff(pred_def_75080,type,
    v127024: state_type > $o ).

tff(pred_def_75081,type,
    v127017: state_type > $o ).

tff(pred_def_75082,type,
    v127015: state_type > $o ).

tff(pred_def_75083,type,
    v127008: state_type > $o ).

tff(pred_def_75084,type,
    v127030: state_type > $o ).

tff(pred_def_75085,type,
    v127028: state_type > $o ).

tff(pred_def_75086,type,
    v127027: state_type > $o ).

tff(pred_def_75087,type,
    v127026: ( state_type * $int ) > $o ).

tff(pred_def_75088,type,
    v112524: state_type > $o ).

tff(pred_def_75089,type,
    v127035: state_type > $o ).

tff(pred_def_75090,type,
    v127038: state_type > $o ).

tff(pred_def_75091,type,
    v127041: state_type > $o ).

tff(pred_def_75092,type,
    v127044: state_type > $o ).

tff(pred_def_75093,type,
    v127047: state_type > $o ).

tff(pred_def_75094,type,
    v127050: state_type > $o ).

tff(pred_def_75095,type,
    v127053: state_type > $o ).

tff(pred_def_75096,type,
    v127056: state_type > $o ).

tff(pred_def_75097,type,
    v127059: state_type > $o ).

tff(pred_def_75098,type,
    v127062: state_type > $o ).

tff(pred_def_75099,type,
    v127065: state_type > $o ).

tff(pred_def_75100,type,
    v127068: state_type > $o ).

tff(pred_def_75101,type,
    v127071: state_type > $o ).

tff(pred_def_75102,type,
    v127074: state_type > $o ).

tff(pred_def_75103,type,
    v127077: state_type > $o ).

tff(pred_def_75104,type,
    v127095: ( state_type * $int ) > $o ).

tff(pred_def_75105,type,
    v127094: ( state_type * $int ) > $o ).

tff(pred_def_75106,type,
    v127093: ( state_type * $int ) > $o ).

tff(pred_def_75107,type,
    v127092: ( state_type * $int ) > $o ).

tff(pred_def_75108,type,
    v127091: ( state_type * $int ) > $o ).

tff(pred_def_75109,type,
    v127090: ( state_type * $int ) > $o ).

tff(pred_def_75110,type,
    v127089: ( state_type * $int ) > $o ).

tff(pred_def_75111,type,
    v127088: ( state_type * $int ) > $o ).

tff(pred_def_75112,type,
    v127087: ( state_type * $int ) > $o ).

tff(pred_def_75113,type,
    v127086: ( state_type * $int ) > $o ).

tff(pred_def_75114,type,
    v127085: ( state_type * $int ) > $o ).

tff(pred_def_75115,type,
    v127084: ( state_type * $int ) > $o ).

tff(pred_def_75116,type,
    v127083: ( state_type * $int ) > $o ).

tff(pred_def_75117,type,
    v127082: ( state_type * $int ) > $o ).

tff(pred_def_75118,type,
    v127080: ( state_type * $int ) > $o ).

tff(pred_def_75119,type,
    v127115: state_type > $o ).

tff(pred_def_75120,type,
    v127114: state_type > $o ).

tff(pred_def_75121,type,
    v127113: state_type > $o ).

tff(pred_def_75122,type,
    v127112: state_type > $o ).

tff(pred_def_75123,type,
    v127111: state_type > $o ).

tff(pred_def_75124,type,
    v127110: state_type > $o ).

tff(pred_def_75125,type,
    v127109: state_type > $o ).

tff(pred_def_75126,type,
    v127108: state_type > $o ).

tff(pred_def_75127,type,
    v127107: state_type > $o ).

tff(pred_def_75128,type,
    v127106: state_type > $o ).

tff(pred_def_75129,type,
    v127105: state_type > $o ).

tff(pred_def_75130,type,
    v127104: state_type > $o ).

tff(pred_def_75131,type,
    v127103: state_type > $o ).

tff(pred_def_75132,type,
    v127102: state_type > $o ).

tff(pred_def_75133,type,
    v127100: state_type > $o ).

tff(pred_def_75134,type,
    v127116: state_type > $o ).

tff(pred_def_75135,type,
    v127099: state_type > $o ).

tff(pred_def_75136,type,
    v127119: state_type > $o ).

tff(pred_def_75137,type,
    v127120: state_type > $o ).

tff(pred_def_75138,type,
    v127118: state_type > $o ).

tff(pred_def_75139,type,
    v127128: state_type > $o ).

tff(pred_def_75140,type,
    v127127: state_type > $o ).

tff(pred_def_75141,type,
    v127129: state_type > $o ).

tff(pred_def_75142,type,
    v127126: state_type > $o ).

tff(pred_def_75143,type,
    v127125: state_type > $o ).

tff(pred_def_75144,type,
    v127133: state_type > $o ).

tff(pred_def_75145,type,
    v127132: state_type > $o ).

tff(pred_def_75146,type,
    v127134: state_type > $o ).

tff(pred_def_75147,type,
    v127131: state_type > $o ).

tff(pred_def_75148,type,
    v127130: state_type > $o ).

tff(pred_def_75149,type,
    v127124: state_type > $o ).

tff(pred_def_75150,type,
    v127138: state_type > $o ).

tff(pred_def_75151,type,
    v127137: state_type > $o ).

tff(pred_def_75152,type,
    v127139: state_type > $o ).

tff(pred_def_75153,type,
    v127136: state_type > $o ).

tff(pred_def_75154,type,
    v127135: state_type > $o ).

tff(pred_def_75155,type,
    v127123: state_type > $o ).

tff(pred_def_75156,type,
    v127121: state_type > $o ).

tff(pred_def_75157,type,
    v127117: state_type > $o ).

tff(pred_def_75158,type,
    v127098: state_type > $o ).

tff(pred_def_75159,type,
    v127142: state_type > $o ).

tff(pred_def_75160,type,
    v127143: state_type > $o ).

tff(pred_def_75161,type,
    v127141: state_type > $o ).

tff(pred_def_75162,type,
    v127150: state_type > $o ).

tff(pred_def_75163,type,
    v127151: state_type > $o ).

tff(pred_def_75164,type,
    v127149: state_type > $o ).

tff(pred_def_75165,type,
    v127148: state_type > $o ).

tff(pred_def_75166,type,
    v127154: state_type > $o ).

tff(pred_def_75167,type,
    v127155: state_type > $o ).

tff(pred_def_75168,type,
    v127153: state_type > $o ).

tff(pred_def_75169,type,
    v127152: state_type > $o ).

tff(pred_def_75170,type,
    v127147: state_type > $o ).

tff(pred_def_75171,type,
    v127158: state_type > $o ).

tff(pred_def_75172,type,
    v127159: state_type > $o ).

tff(pred_def_75173,type,
    v127157: state_type > $o ).

tff(pred_def_75174,type,
    v127156: state_type > $o ).

tff(pred_def_75175,type,
    v127146: state_type > $o ).

tff(pred_def_75176,type,
    v127144: state_type > $o ).

tff(pred_def_75177,type,
    v127140: state_type > $o ).

tff(pred_def_75178,type,
    v127097: state_type > $o ).

tff(pred_def_75179,type,
    v127161: state_type > $o ).

tff(pred_def_75180,type,
    v127168: state_type > $o ).

tff(pred_def_75181,type,
    v127169: state_type > $o ).

tff(pred_def_75182,type,
    v127167: state_type > $o ).

tff(pred_def_75183,type,
    v127166: state_type > $o ).

tff(pred_def_75184,type,
    v127172: state_type > $o ).

tff(pred_def_75185,type,
    v127173: state_type > $o ).

tff(pred_def_75186,type,
    v127171: state_type > $o ).

tff(pred_def_75187,type,
    v127170: state_type > $o ).

tff(pred_def_75188,type,
    v127165: state_type > $o ).

tff(pred_def_75189,type,
    v127176: state_type > $o ).

tff(pred_def_75190,type,
    v127177: state_type > $o ).

tff(pred_def_75191,type,
    v127175: state_type > $o ).

tff(pred_def_75192,type,
    v127174: state_type > $o ).

tff(pred_def_75193,type,
    v127164: state_type > $o ).

tff(pred_def_75194,type,
    v127162: state_type > $o ).

tff(pred_def_75195,type,
    v127160: state_type > $o ).

tff(pred_def_75196,type,
    v112518: state_type > $o ).

tff(pred_def_75197,type,
    v127182: state_type > $o ).

tff(pred_def_75198,type,
    v127180: state_type > $o ).

tff(pred_def_75199,type,
    v100209: ( state_type * $int ) > $o ).

tff(pred_def_75200,type,
    v127193: state_type > $o ).

tff(pred_def_75201,type,
    v76: ( state_type * $int ) > $o ).

tff(pred_def_75202,type,
    v100211: ( state_type * $int ) > $o ).

tff(pred_def_75203,type,
    v127210: ( state_type * $int ) > $o ).

tff(pred_def_75204,type,
    v127209: state_type > $o ).

tff(pred_def_75205,type,
    v127208: state_type > $o ).

tff(pred_def_75206,type,
    v127207: state_type > $o ).

tff(pred_def_75207,type,
    v127206: state_type > $o ).

tff(pred_def_75208,type,
    v127205: state_type > $o ).

tff(pred_def_75209,type,
    v127204: state_type > $o ).

tff(pred_def_75210,type,
    v127203: state_type > $o ).

tff(pred_def_75211,type,
    v127202: state_type > $o ).

tff(pred_def_75212,type,
    v127201: state_type > $o ).

tff(pred_def_75213,type,
    v127200: state_type > $o ).

tff(pred_def_75214,type,
    v127199: state_type > $o ).

tff(pred_def_75215,type,
    v127198: state_type > $o ).

tff(pred_def_75216,type,
    v127197: state_type > $o ).

tff(pred_def_75217,type,
    v127196: state_type > $o ).

tff(pred_def_75218,type,
    v127194: state_type > $o ).

tff(pred_def_75219,type,
    v127192: state_type > $o ).

tff(pred_def_75220,type,
    v127212: state_type > $o ).

tff(pred_def_75221,type,
    v127213: state_type > $o ).

tff(pred_def_75222,type,
    v127211: state_type > $o ).

tff(pred_def_75223,type,
    v127191: state_type > $o ).

tff(pred_def_75224,type,
    v127217: state_type > $o ).

tff(pred_def_75225,type,
    v127216: state_type > $o ).

tff(pred_def_75226,type,
    v127215: state_type > $o ).

tff(pred_def_75227,type,
    v127214: state_type > $o ).

tff(pred_def_75228,type,
    v127190: state_type > $o ).

tff(pred_def_75229,type,
    v127218: state_type > $o ).

tff(pred_def_75230,type,
    v127189: state_type > $o ).

tff(pred_def_75231,type,
    v127219: state_type > $o ).

tff(pred_def_75232,type,
    v127188: state_type > $o ).

tff(pred_def_75233,type,
    v127187: state_type > $o ).

tff(pred_def_75234,type,
    v127220: state_type > $o ).

tff(pred_def_75235,type,
    v127186: state_type > $o ).

tff(pred_def_75236,type,
    v127221: state_type > $o ).

tff(pred_def_75237,type,
    v127185: state_type > $o ).

tff(pred_def_75238,type,
    v127222: state_type > $o ).

tff(pred_def_75239,type,
    v127184: state_type > $o ).

tff(pred_def_75240,type,
    v127223: state_type > $o ).

tff(pred_def_75241,type,
    v127243: ( state_type * $int ) > $o ).

tff(pred_def_75242,type,
    v127242: state_type > $o ).

tff(pred_def_75243,type,
    v127241: state_type > $o ).

tff(pred_def_75244,type,
    v127240: state_type > $o ).

tff(pred_def_75245,type,
    v127239: state_type > $o ).

tff(pred_def_75246,type,
    v127238: state_type > $o ).

tff(pred_def_75247,type,
    v127237: state_type > $o ).

tff(pred_def_75248,type,
    v127236: state_type > $o ).

tff(pred_def_75249,type,
    v127235: state_type > $o ).

tff(pred_def_75250,type,
    v127234: state_type > $o ).

tff(pred_def_75251,type,
    v127233: state_type > $o ).

tff(pred_def_75252,type,
    v127232: state_type > $o ).

tff(pred_def_75253,type,
    v127231: state_type > $o ).

tff(pred_def_75254,type,
    v127230: state_type > $o ).

tff(pred_def_75255,type,
    v127229: state_type > $o ).

tff(pred_def_75256,type,
    v127227: state_type > $o ).

tff(pred_def_75257,type,
    v127245: state_type > $o ).

tff(pred_def_75258,type,
    v127246: state_type > $o ).

tff(pred_def_75259,type,
    v127244: state_type > $o ).

tff(pred_def_75260,type,
    v127226: state_type > $o ).

tff(pred_def_75261,type,
    v127225: state_type > $o ).

tff(pred_def_75262,type,
    v127254: state_type > $o ).

tff(pred_def_75263,type,
    v127255: state_type > $o ).

tff(pred_def_75264,type,
    v127253: state_type > $o ).

tff(pred_def_75265,type,
    v127256: state_type > $o ).

tff(pred_def_75266,type,
    v127252: state_type > $o ).

tff(pred_def_75267,type,
    v127251: state_type > $o ).

tff(pred_def_75268,type,
    v127260: state_type > $o ).

tff(pred_def_75269,type,
    v127261: state_type > $o ).

tff(pred_def_75270,type,
    v127259: state_type > $o ).

tff(pred_def_75271,type,
    v127262: state_type > $o ).

tff(pred_def_75272,type,
    v127258: state_type > $o ).

tff(pred_def_75273,type,
    v127257: state_type > $o ).

tff(pred_def_75274,type,
    v127250: state_type > $o ).

tff(pred_def_75275,type,
    v127266: state_type > $o ).

tff(pred_def_75276,type,
    v127267: state_type > $o ).

tff(pred_def_75277,type,
    v127265: state_type > $o ).

tff(pred_def_75278,type,
    v127268: state_type > $o ).

tff(pred_def_75279,type,
    v127264: state_type > $o ).

tff(pred_def_75280,type,
    v127263: state_type > $o ).

tff(pred_def_75281,type,
    v127249: state_type > $o ).

tff(pred_def_75282,type,
    v127247: state_type > $o ).

tff(pred_def_75283,type,
    v127276: state_type > $o ).

tff(pred_def_75284,type,
    v127274: state_type > $o ).

tff(pred_def_75285,type,
    v127273: state_type > $o ).

tff(pred_def_75286,type,
    v127272: ( state_type * $int ) > $o ).

tff(pred_def_75287,type,
    v127270: state_type > $o ).

tff(pred_def_75288,type,
    v127282: state_type > $o ).

tff(pred_def_75289,type,
    v127280: state_type > $o ).

tff(pred_def_75290,type,
    v127288: state_type > $o ).

tff(pred_def_75291,type,
    v127287: state_type > $o ).

tff(pred_def_75292,type,
    v127289: state_type > $o ).

tff(pred_def_75293,type,
    v127286: state_type > $o ).

tff(pred_def_75294,type,
    v84897: state_type > $o ).

tff(pred_def_75295,type,
    v127290: state_type > $o ).

tff(pred_def_75296,type,
    v127285: state_type > $o ).

tff(pred_def_75297,type,
    v127291: state_type > $o ).

tff(pred_def_75298,type,
    v127284: state_type > $o ).

tff(pred_def_75299,type,
    v127292: state_type > $o ).

tff(pred_def_75300,type,
    v100205: ( state_type * $int ) > $o ).

tff(pred_def_75301,type,
    v127298: state_type > $o ).

tff(pred_def_75302,type,
    v127296: state_type > $o ).

tff(pred_def_75303,type,
    v127295: state_type > $o ).

tff(pred_def_75304,type,
    v127294: ( state_type * $int ) > $o ).

tff(pred_def_75305,type,
    v127303: state_type > $o ).

tff(pred_def_75306,type,
    v127304: state_type > $o ).

tff(pred_def_75307,type,
    v127302: state_type > $o ).

tff(pred_def_75308,type,
    v127306: state_type > $o ).

tff(pred_def_75309,type,
    v127307: state_type > $o ).

tff(pred_def_75310,type,
    v127308: state_type > $o ).

tff(pred_def_75311,type,
    v127309: state_type > $o ).

tff(pred_def_75312,type,
    v127310: state_type > $o ).

tff(pred_def_75313,type,
    v127311: state_type > $o ).

tff(pred_def_75314,type,
    v127312: state_type > $o ).

tff(pred_def_75315,type,
    v127313: state_type > $o ).

tff(pred_def_75316,type,
    v127314: state_type > $o ).

tff(pred_def_75317,type,
    v127315: state_type > $o ).

tff(pred_def_75318,type,
    v127316: state_type > $o ).

tff(pred_def_75319,type,
    v127317: state_type > $o ).

tff(pred_def_75320,type,
    v127318: state_type > $o ).

tff(pred_def_75321,type,
    v127319: state_type > $o ).

tff(pred_def_75322,type,
    v127320: state_type > $o ).

tff(pred_def_75323,type,
    v127321: state_type > $o ).

tff(pred_def_75324,type,
    v100217: ( state_type * $int ) > $o ).

tff(pred_def_75325,type,
    v127333: state_type > $o ).

tff(pred_def_75326,type,
    v127332: state_type > $o ).

tff(pred_def_75327,type,
    v127331: state_type > $o ).

tff(pred_def_75328,type,
    v127330: state_type > $o ).

tff(pred_def_75329,type,
    v127329: state_type > $o ).

tff(pred_def_75330,type,
    v127327: state_type > $o ).

tff(pred_def_75331,type,
    v127334: state_type > $o ).

tff(pred_def_75332,type,
    v127326: state_type > $o ).

tff(pred_def_75333,type,
    v127324: state_type > $o ).

tff(pred_def_75334,type,
    v127341: state_type > $o ).

tff(pred_def_75335,type,
    v127342: state_type > $o ).

tff(pred_def_75336,type,
    v127343: state_type > $o ).

tff(pred_def_75337,type,
    v127344: state_type > $o ).

tff(pred_def_75338,type,
    v127345: state_type > $o ).

tff(pred_def_75339,type,
    v127346: state_type > $o ).

tff(pred_def_75340,type,
    v127347: state_type > $o ).

tff(pred_def_75341,type,
    v127348: state_type > $o ).

tff(pred_def_75342,type,
    v127349: state_type > $o ).

tff(pred_def_75343,type,
    v127350: state_type > $o ).

tff(pred_def_75344,type,
    v127351: state_type > $o ).

tff(pred_def_75345,type,
    v127352: state_type > $o ).

tff(pred_def_75346,type,
    v127353: state_type > $o ).

tff(pred_def_75347,type,
    v127354: state_type > $o ).

tff(pred_def_75348,type,
    v127355: state_type > $o ).

tff(pred_def_75349,type,
    v127356: state_type > $o ).

tff(pred_def_75350,type,
    v127339: ( state_type * $int ) > $o ).

tff(pred_def_75351,type,
    v127373: ( state_type * $int ) > $o ).

tff(pred_def_75352,type,
    v127372: state_type > $o ).

tff(pred_def_75353,type,
    v127371: state_type > $o ).

tff(pred_def_75354,type,
    v127370: state_type > $o ).

tff(pred_def_75355,type,
    v127369: state_type > $o ).

tff(pred_def_75356,type,
    v127368: state_type > $o ).

tff(pred_def_75357,type,
    v127367: state_type > $o ).

tff(pred_def_75358,type,
    v127366: state_type > $o ).

tff(pred_def_75359,type,
    v127365: state_type > $o ).

tff(pred_def_75360,type,
    v127364: state_type > $o ).

tff(pred_def_75361,type,
    v127363: state_type > $o ).

tff(pred_def_75362,type,
    v127362: state_type > $o ).

tff(pred_def_75363,type,
    v127361: state_type > $o ).

tff(pred_def_75364,type,
    v127360: state_type > $o ).

tff(pred_def_75365,type,
    v127359: state_type > $o ).

tff(pred_def_75366,type,
    v127337: state_type > $o ).

tff(pred_def_75367,type,
    v127378: state_type > $o ).

tff(pred_def_75368,type,
    v127382: state_type > $o ).

tff(pred_def_75369,type,
    v127383: state_type > $o ).

tff(pred_def_75370,type,
    v127381: state_type > $o ).

tff(pred_def_75371,type,
    v127392: state_type > $o ).

tff(pred_def_75372,type,
    v127391: state_type > $o ).

tff(pred_def_75373,type,
    v127393: state_type > $o ).

tff(pred_def_75374,type,
    v127390: state_type > $o ).

tff(pred_def_75375,type,
    v127389: state_type > $o ).

tff(pred_def_75376,type,
    v127397: state_type > $o ).

tff(pred_def_75377,type,
    v127396: state_type > $o ).

tff(pred_def_75378,type,
    v127398: state_type > $o ).

tff(pred_def_75379,type,
    v127395: state_type > $o ).

tff(pred_def_75380,type,
    v127394: state_type > $o ).

tff(pred_def_75381,type,
    v127388: state_type > $o ).

tff(pred_def_75382,type,
    v127402: state_type > $o ).

tff(pred_def_75383,type,
    v127401: state_type > $o ).

tff(pred_def_75384,type,
    v127403: state_type > $o ).

tff(pred_def_75385,type,
    v127400: state_type > $o ).

tff(pred_def_75386,type,
    v127399: state_type > $o ).

tff(pred_def_75387,type,
    v127387: state_type > $o ).

tff(pred_def_75388,type,
    v127407: state_type > $o ).

tff(pred_def_75389,type,
    v127406: state_type > $o ).

tff(pred_def_75390,type,
    v127408: state_type > $o ).

tff(pred_def_75391,type,
    v127405: state_type > $o ).

tff(pred_def_75392,type,
    v127404: state_type > $o ).

tff(pred_def_75393,type,
    v127386: state_type > $o ).

tff(pred_def_75394,type,
    v127384: state_type > $o ).

tff(pred_def_75395,type,
    v127380: state_type > $o ).

tff(pred_def_75396,type,
    v127379: state_type > $o ).

tff(pred_def_75397,type,
    v127377: state_type > $o ).

tff(pred_def_75398,type,
    v127376: state_type > $o ).

tff(pred_def_75399,type,
    v127375: ( state_type * $int ) > $o ).

tff(pred_def_75400,type,
    v100215: ( state_type * $int ) > $o ).

tff(pred_def_75401,type,
    v100213: ( state_type * $int ) > $o ).

tff(pred_def_75402,type,
    v127425: state_type > $o ).

tff(pred_def_75403,type,
    v127426: state_type > $o ).

tff(pred_def_75404,type,
    v127424: state_type > $o ).

tff(pred_def_75405,type,
    v127422: ( state_type * $int ) > $o ).

tff(pred_def_75406,type,
    v127428: state_type > $o ).

tff(pred_def_75407,type,
    v127429: state_type > $o ).

tff(pred_def_75408,type,
    v127430: state_type > $o ).

tff(pred_def_75409,type,
    v127431: state_type > $o ).

tff(pred_def_75410,type,
    v127432: state_type > $o ).

tff(pred_def_75411,type,
    v127433: state_type > $o ).

tff(pred_def_75412,type,
    v127434: state_type > $o ).

tff(pred_def_75413,type,
    v127435: state_type > $o ).

tff(pred_def_75414,type,
    v127436: state_type > $o ).

tff(pred_def_75415,type,
    v127437: state_type > $o ).

tff(pred_def_75416,type,
    v127438: state_type > $o ).

tff(pred_def_75417,type,
    v127439: state_type > $o ).

tff(pred_def_75418,type,
    v127440: state_type > $o ).

tff(pred_def_75419,type,
    v127441: state_type > $o ).

tff(pred_def_75420,type,
    v127442: state_type > $o ).

tff(pred_def_75421,type,
    v127443: state_type > $o ).

tff(pred_def_75422,type,
    v127420: ( state_type * $int ) > $o ).

tff(pred_def_75423,type,
    v127450: state_type > $o ).

tff(pred_def_75424,type,
    v127451: state_type > $o ).

tff(pred_def_75425,type,
    v127449: state_type > $o ).

tff(pred_def_75426,type,
    v127447: ( state_type * $int ) > $o ).

tff(pred_def_75427,type,
    v127453: state_type > $o ).

tff(pred_def_75428,type,
    v127454: state_type > $o ).

tff(pred_def_75429,type,
    v127455: state_type > $o ).

tff(pred_def_75430,type,
    v127456: state_type > $o ).

tff(pred_def_75431,type,
    v127457: state_type > $o ).

tff(pred_def_75432,type,
    v127458: state_type > $o ).

tff(pred_def_75433,type,
    v127459: state_type > $o ).

tff(pred_def_75434,type,
    v127460: state_type > $o ).

tff(pred_def_75435,type,
    v127461: state_type > $o ).

tff(pred_def_75436,type,
    v127462: state_type > $o ).

tff(pred_def_75437,type,
    v127463: state_type > $o ).

tff(pred_def_75438,type,
    v127464: state_type > $o ).

tff(pred_def_75439,type,
    v127465: state_type > $o ).

tff(pred_def_75440,type,
    v127466: state_type > $o ).

tff(pred_def_75441,type,
    v127467: state_type > $o ).

tff(pred_def_75442,type,
    v127468: state_type > $o ).

tff(pred_def_75443,type,
    v127445: ( state_type * $int ) > $o ).

tff(pred_def_75444,type,
    v127475: state_type > $o ).

tff(pred_def_75445,type,
    v127476: state_type > $o ).

tff(pred_def_75446,type,
    v127474: state_type > $o ).

tff(pred_def_75447,type,
    v127472: ( state_type * $int ) > $o ).

tff(pred_def_75448,type,
    v127478: state_type > $o ).

tff(pred_def_75449,type,
    v127479: state_type > $o ).

tff(pred_def_75450,type,
    v127480: state_type > $o ).

tff(pred_def_75451,type,
    v127481: state_type > $o ).

tff(pred_def_75452,type,
    v127482: state_type > $o ).

tff(pred_def_75453,type,
    v127483: state_type > $o ).

tff(pred_def_75454,type,
    v127484: state_type > $o ).

tff(pred_def_75455,type,
    v127485: state_type > $o ).

tff(pred_def_75456,type,
    v127486: state_type > $o ).

tff(pred_def_75457,type,
    v127487: state_type > $o ).

tff(pred_def_75458,type,
    v127488: state_type > $o ).

tff(pred_def_75459,type,
    v127489: state_type > $o ).

tff(pred_def_75460,type,
    v127490: state_type > $o ).

tff(pred_def_75461,type,
    v127491: state_type > $o ).

tff(pred_def_75462,type,
    v127492: state_type > $o ).

tff(pred_def_75463,type,
    v127493: state_type > $o ).

tff(pred_def_75464,type,
    v127470: ( state_type * $int ) > $o ).

tff(pred_def_75465,type,
    v127500: state_type > $o ).

tff(pred_def_75466,type,
    v127501: state_type > $o ).

tff(pred_def_75467,type,
    v127499: state_type > $o ).

tff(pred_def_75468,type,
    v127497: ( state_type * $int ) > $o ).

tff(pred_def_75469,type,
    v127503: state_type > $o ).

tff(pred_def_75470,type,
    v127504: state_type > $o ).

tff(pred_def_75471,type,
    v127505: state_type > $o ).

tff(pred_def_75472,type,
    v127506: state_type > $o ).

tff(pred_def_75473,type,
    v127507: state_type > $o ).

tff(pred_def_75474,type,
    v127508: state_type > $o ).

tff(pred_def_75475,type,
    v127509: state_type > $o ).

tff(pred_def_75476,type,
    v127510: state_type > $o ).

tff(pred_def_75477,type,
    v127511: state_type > $o ).

tff(pred_def_75478,type,
    v127512: state_type > $o ).

tff(pred_def_75479,type,
    v127513: state_type > $o ).

tff(pred_def_75480,type,
    v127514: state_type > $o ).

tff(pred_def_75481,type,
    v127515: state_type > $o ).

tff(pred_def_75482,type,
    v127516: state_type > $o ).

tff(pred_def_75483,type,
    v127517: state_type > $o ).

tff(pred_def_75484,type,
    v127518: state_type > $o ).

tff(pred_def_75485,type,
    v127495: ( state_type * $int ) > $o ).

tff(pred_def_75486,type,
    v127525: state_type > $o ).

tff(pred_def_75487,type,
    v127526: state_type > $o ).

tff(pred_def_75488,type,
    v127524: state_type > $o ).

tff(pred_def_75489,type,
    v127522: ( state_type * $int ) > $o ).

tff(pred_def_75490,type,
    v127528: state_type > $o ).

tff(pred_def_75491,type,
    v127529: state_type > $o ).

tff(pred_def_75492,type,
    v127530: state_type > $o ).

tff(pred_def_75493,type,
    v127531: state_type > $o ).

tff(pred_def_75494,type,
    v127532: state_type > $o ).

tff(pred_def_75495,type,
    v127533: state_type > $o ).

tff(pred_def_75496,type,
    v127534: state_type > $o ).

tff(pred_def_75497,type,
    v127535: state_type > $o ).

tff(pred_def_75498,type,
    v127536: state_type > $o ).

tff(pred_def_75499,type,
    v127537: state_type > $o ).

tff(pred_def_75500,type,
    v127538: state_type > $o ).

tff(pred_def_75501,type,
    v127539: state_type > $o ).

tff(pred_def_75502,type,
    v127540: state_type > $o ).

tff(pred_def_75503,type,
    v127541: state_type > $o ).

tff(pred_def_75504,type,
    v127542: state_type > $o ).

tff(pred_def_75505,type,
    v127543: state_type > $o ).

tff(pred_def_75506,type,
    v127520: ( state_type * $int ) > $o ).

tff(pred_def_75507,type,
    v127550: state_type > $o ).

tff(pred_def_75508,type,
    v127551: state_type > $o ).

tff(pred_def_75509,type,
    v127549: state_type > $o ).

tff(pred_def_75510,type,
    v127547: ( state_type * $int ) > $o ).

tff(pred_def_75511,type,
    v127553: state_type > $o ).

tff(pred_def_75512,type,
    v127554: state_type > $o ).

tff(pred_def_75513,type,
    v127555: state_type > $o ).

tff(pred_def_75514,type,
    v127556: state_type > $o ).

tff(pred_def_75515,type,
    v127557: state_type > $o ).

tff(pred_def_75516,type,
    v127558: state_type > $o ).

tff(pred_def_75517,type,
    v127559: state_type > $o ).

tff(pred_def_75518,type,
    v127560: state_type > $o ).

tff(pred_def_75519,type,
    v127561: state_type > $o ).

tff(pred_def_75520,type,
    v127562: state_type > $o ).

tff(pred_def_75521,type,
    v127563: state_type > $o ).

tff(pred_def_75522,type,
    v127564: state_type > $o ).

tff(pred_def_75523,type,
    v127565: state_type > $o ).

tff(pred_def_75524,type,
    v127566: state_type > $o ).

tff(pred_def_75525,type,
    v127567: state_type > $o ).

tff(pred_def_75526,type,
    v127568: state_type > $o ).

tff(pred_def_75527,type,
    v127545: ( state_type * $int ) > $o ).

tff(pred_def_75528,type,
    v127575: state_type > $o ).

tff(pred_def_75529,type,
    v127576: state_type > $o ).

tff(pred_def_75530,type,
    v127574: state_type > $o ).

tff(pred_def_75531,type,
    v127572: ( state_type * $int ) > $o ).

tff(pred_def_75532,type,
    v127578: state_type > $o ).

tff(pred_def_75533,type,
    v127579: state_type > $o ).

tff(pred_def_75534,type,
    v127580: state_type > $o ).

tff(pred_def_75535,type,
    v127581: state_type > $o ).

tff(pred_def_75536,type,
    v127582: state_type > $o ).

tff(pred_def_75537,type,
    v127583: state_type > $o ).

tff(pred_def_75538,type,
    v127584: state_type > $o ).

tff(pred_def_75539,type,
    v127585: state_type > $o ).

tff(pred_def_75540,type,
    v127586: state_type > $o ).

tff(pred_def_75541,type,
    v127587: state_type > $o ).

tff(pred_def_75542,type,
    v127588: state_type > $o ).

tff(pred_def_75543,type,
    v127589: state_type > $o ).

tff(pred_def_75544,type,
    v127590: state_type > $o ).

tff(pred_def_75545,type,
    v127591: state_type > $o ).

tff(pred_def_75546,type,
    v127592: state_type > $o ).

tff(pred_def_75547,type,
    v127593: state_type > $o ).

tff(pred_def_75548,type,
    v127570: ( state_type * $int ) > $o ).

tff(pred_def_75549,type,
    v127600: state_type > $o ).

tff(pred_def_75550,type,
    v127601: state_type > $o ).

tff(pred_def_75551,type,
    v127599: state_type > $o ).

tff(pred_def_75552,type,
    v127597: ( state_type * $int ) > $o ).

tff(pred_def_75553,type,
    v127603: state_type > $o ).

tff(pred_def_75554,type,
    v127604: state_type > $o ).

tff(pred_def_75555,type,
    v127605: state_type > $o ).

tff(pred_def_75556,type,
    v127606: state_type > $o ).

tff(pred_def_75557,type,
    v127607: state_type > $o ).

tff(pred_def_75558,type,
    v127608: state_type > $o ).

tff(pred_def_75559,type,
    v127609: state_type > $o ).

tff(pred_def_75560,type,
    v127610: state_type > $o ).

tff(pred_def_75561,type,
    v127611: state_type > $o ).

tff(pred_def_75562,type,
    v127612: state_type > $o ).

tff(pred_def_75563,type,
    v127613: state_type > $o ).

tff(pred_def_75564,type,
    v127614: state_type > $o ).

tff(pred_def_75565,type,
    v127615: state_type > $o ).

tff(pred_def_75566,type,
    v127616: state_type > $o ).

tff(pred_def_75567,type,
    v127617: state_type > $o ).

tff(pred_def_75568,type,
    v127618: state_type > $o ).

tff(pred_def_75569,type,
    v127595: ( state_type * $int ) > $o ).

tff(pred_def_75570,type,
    v127632: state_type > $o ).

tff(pred_def_75571,type,
    v127630: state_type > $o ).

tff(pred_def_75572,type,
    v127636: state_type > $o ).

tff(pred_def_75573,type,
    v127634: state_type > $o ).

tff(pred_def_75574,type,
    v84319: ( state_type * $int ) > $o ).

tff(pred_def_75575,type,
    v127646: state_type > $o ).

tff(pred_def_75576,type,
    v127648: state_type > $o ).

tff(pred_def_75577,type,
    v127624: state_type > $o ).

tff(pred_def_75578,type,
    v127647: state_type > $o ).

tff(pred_def_75579,type,
    v127644: state_type > $o ).

tff(pred_def_75580,type,
    v127642: state_type > $o ).

tff(pred_def_75581,type,
    v127640: state_type > $o ).

tff(pred_def_75582,type,
    v127638: state_type > $o ).

tff(pred_def_75583,type,
    v127652: state_type > $o ).

tff(pred_def_75584,type,
    v127650: state_type > $o ).

tff(pred_def_75585,type,
    v127659: state_type > $o ).

tff(pred_def_75586,type,
    v127657: state_type > $o ).

tff(pred_def_75587,type,
    v127656: state_type > $o ).

tff(pred_def_75588,type,
    v127655: state_type > $o ).

tff(pred_def_75589,type,
    v127667: state_type > $o ).

tff(pred_def_75590,type,
    v127668: state_type > $o ).

tff(pred_def_75591,type,
    v127666: state_type > $o ).

tff(pred_def_75592,type,
    v127663: state_type > $o ).

tff(pred_def_75593,type,
    v127665: state_type > $o ).

tff(pred_def_75594,type,
    v127628: state_type > $o ).

tff(pred_def_75595,type,
    v127626: state_type > $o ).

tff(pred_def_75596,type,
    v127622: state_type > $o ).

tff(pred_def_75597,type,
    v127620: state_type > $o ).

tff(pred_def_75598,type,
    v127681: state_type > $o ).

tff(pred_def_75599,type,
    v127680: ( state_type * $int ) > $o ).

tff(pred_def_75600,type,
    v127679: ( state_type * $int ) > $o ).

tff(pred_def_75601,type,
    v127684: state_type > $o ).

tff(pred_def_75602,type,
    v127683: ( state_type * $int ) > $o ).

tff(pred_def_75603,type,
    v127682: ( state_type * $int ) > $o ).

tff(pred_def_75604,type,
    v127678: ( state_type * $int ) > $o ).

tff(pred_def_75605,type,
    v127687: state_type > $o ).

tff(pred_def_75606,type,
    v127686: ( state_type * $int ) > $o ).

tff(pred_def_75607,type,
    v127685: ( state_type * $int ) > $o ).

tff(pred_def_75608,type,
    v127677: ( state_type * $int ) > $o ).

tff(pred_def_75609,type,
    v127690: state_type > $o ).

tff(pred_def_75610,type,
    v127689: ( state_type * $int ) > $o ).

tff(pred_def_75611,type,
    v127688: ( state_type * $int ) > $o ).

tff(pred_def_75612,type,
    v127676: ( state_type * $int ) > $o ).

tff(pred_def_75613,type,
    v127693: state_type > $o ).

tff(pred_def_75614,type,
    v127692: ( state_type * $int ) > $o ).

tff(pred_def_75615,type,
    v127691: ( state_type * $int ) > $o ).

tff(pred_def_75616,type,
    v127675: ( state_type * $int ) > $o ).

tff(pred_def_75617,type,
    v127696: state_type > $o ).

tff(pred_def_75618,type,
    v127695: ( state_type * $int ) > $o ).

tff(pred_def_75619,type,
    v127694: ( state_type * $int ) > $o ).

tff(pred_def_75620,type,
    v127674: ( state_type * $int ) > $o ).

tff(pred_def_75621,type,
    v127699: state_type > $o ).

tff(pred_def_75622,type,
    v127698: ( state_type * $int ) > $o ).

tff(pred_def_75623,type,
    v127697: ( state_type * $int ) > $o ).

tff(pred_def_75624,type,
    v127673: ( state_type * $int ) > $o ).

tff(pred_def_75625,type,
    v127702: state_type > $o ).

tff(pred_def_75626,type,
    v127701: ( state_type * $int ) > $o ).

tff(pred_def_75627,type,
    v127700: ( state_type * $int ) > $o ).

tff(pred_def_75628,type,
    v127672: ( state_type * $int ) > $o ).

tff(pred_def_75629,type,
    v127704: state_type > $o ).

tff(pred_def_75630,type,
    v127703: ( state_type * $int ) > $o ).

tff(pred_def_75631,type,
    v127418: ( state_type * $int ) > $o ).

tff(pred_def_75632,type,
    v127416: ( state_type * $int ) > $o ).

tff(pred_def_75633,type,
    v127414: ( state_type * $int ) > $o ).

tff(pred_def_75634,type,
    v127720: state_type > $o ).

tff(pred_def_75635,type,
    v127718: state_type > $o ).

tff(pred_def_75636,type,
    v127717: state_type > $o ).

tff(pred_def_75637,type,
    v127716: ( state_type * $int ) > $o ).

tff(pred_def_75638,type,
    v127728: state_type > $o ).

tff(pred_def_75639,type,
    v127726: state_type > $o ).

tff(pred_def_75640,type,
    v127725: state_type > $o ).

tff(pred_def_75641,type,
    v127724: ( state_type * $int ) > $o ).

tff(pred_def_75642,type,
    v127736: state_type > $o ).

tff(pred_def_75643,type,
    v127734: state_type > $o ).

tff(pred_def_75644,type,
    v127733: state_type > $o ).

tff(pred_def_75645,type,
    v127732: ( state_type * $int ) > $o ).

tff(pred_def_75646,type,
    v127744: state_type > $o ).

tff(pred_def_75647,type,
    v127742: state_type > $o ).

tff(pred_def_75648,type,
    v127741: state_type > $o ).

tff(pred_def_75649,type,
    v127740: ( state_type * $int ) > $o ).

tff(pred_def_75650,type,
    v127752: state_type > $o ).

tff(pred_def_75651,type,
    v127750: state_type > $o ).

tff(pred_def_75652,type,
    v127749: state_type > $o ).

tff(pred_def_75653,type,
    v127748: ( state_type * $int ) > $o ).

tff(pred_def_75654,type,
    v127760: state_type > $o ).

tff(pred_def_75655,type,
    v127758: state_type > $o ).

tff(pred_def_75656,type,
    v127757: state_type > $o ).

tff(pred_def_75657,type,
    v127756: ( state_type * $int ) > $o ).

tff(pred_def_75658,type,
    v127768: state_type > $o ).

tff(pred_def_75659,type,
    v127766: state_type > $o ).

tff(pred_def_75660,type,
    v127765: state_type > $o ).

tff(pred_def_75661,type,
    v127764: ( state_type * $int ) > $o ).

tff(pred_def_75662,type,
    v127776: state_type > $o ).

tff(pred_def_75663,type,
    v127774: state_type > $o ).

tff(pred_def_75664,type,
    v127773: state_type > $o ).

tff(pred_def_75665,type,
    v127772: ( state_type * $int ) > $o ).

tff(pred_def_75666,type,
    v127784: state_type > $o ).

tff(pred_def_75667,type,
    v127782: state_type > $o ).

tff(pred_def_75668,type,
    v127781: state_type > $o ).

tff(pred_def_75669,type,
    v127780: ( state_type * $int ) > $o ).

tff(pred_def_75670,type,
    v127792: state_type > $o ).

tff(pred_def_75671,type,
    v127790: state_type > $o ).

tff(pred_def_75672,type,
    v127789: state_type > $o ).

tff(pred_def_75673,type,
    v127788: ( state_type * $int ) > $o ).

tff(pred_def_75674,type,
    v127800: state_type > $o ).

tff(pred_def_75675,type,
    v127798: state_type > $o ).

tff(pred_def_75676,type,
    v127797: state_type > $o ).

tff(pred_def_75677,type,
    v127796: ( state_type * $int ) > $o ).

tff(pred_def_75678,type,
    v127808: state_type > $o ).

tff(pred_def_75679,type,
    v127806: state_type > $o ).

tff(pred_def_75680,type,
    v127805: state_type > $o ).

tff(pred_def_75681,type,
    v127804: ( state_type * $int ) > $o ).

tff(pred_def_75682,type,
    v127816: state_type > $o ).

tff(pred_def_75683,type,
    v127814: state_type > $o ).

tff(pred_def_75684,type,
    v127813: state_type > $o ).

tff(pred_def_75685,type,
    v127812: ( state_type * $int ) > $o ).

tff(pred_def_75686,type,
    v127824: state_type > $o ).

tff(pred_def_75687,type,
    v127822: state_type > $o ).

tff(pred_def_75688,type,
    v127821: state_type > $o ).

tff(pred_def_75689,type,
    v127820: ( state_type * $int ) > $o ).

tff(pred_def_75690,type,
    v127829: state_type > $o ).

tff(pred_def_75691,type,
    v127830: state_type > $o ).

tff(pred_def_75692,type,
    v127828: state_type > $o ).

tff(pred_def_75693,type,
    v127714: ( state_type * $int ) > $o ).

tff(pred_def_75694,type,
    v127832: state_type > $o ).

tff(pred_def_75695,type,
    v127833: state_type > $o ).

tff(pred_def_75696,type,
    v127834: state_type > $o ).

tff(pred_def_75697,type,
    v127835: state_type > $o ).

tff(pred_def_75698,type,
    v127836: state_type > $o ).

tff(pred_def_75699,type,
    v127837: state_type > $o ).

tff(pred_def_75700,type,
    v127838: state_type > $o ).

tff(pred_def_75701,type,
    v127839: state_type > $o ).

tff(pred_def_75702,type,
    v127840: state_type > $o ).

tff(pred_def_75703,type,
    v127841: state_type > $o ).

tff(pred_def_75704,type,
    v127842: state_type > $o ).

tff(pred_def_75705,type,
    v127843: state_type > $o ).

tff(pred_def_75706,type,
    v127844: state_type > $o ).

tff(pred_def_75707,type,
    v127845: state_type > $o ).

tff(pred_def_75708,type,
    v127846: state_type > $o ).

tff(pred_def_75709,type,
    v127847: state_type > $o ).

tff(pred_def_75710,type,
    v127712: ( state_type * $int ) > $o ).

tff(pred_def_75711,type,
    v127854: state_type > $o ).

tff(pred_def_75712,type,
    v127855: state_type > $o ).

tff(pred_def_75713,type,
    v127853: state_type > $o ).

tff(pred_def_75714,type,
    v127851: ( state_type * $int ) > $o ).

tff(pred_def_75715,type,
    v127857: state_type > $o ).

tff(pred_def_75716,type,
    v127858: state_type > $o ).

tff(pred_def_75717,type,
    v127859: state_type > $o ).

tff(pred_def_75718,type,
    v127860: state_type > $o ).

tff(pred_def_75719,type,
    v127861: state_type > $o ).

tff(pred_def_75720,type,
    v127862: state_type > $o ).

tff(pred_def_75721,type,
    v127863: state_type > $o ).

tff(pred_def_75722,type,
    v127864: state_type > $o ).

tff(pred_def_75723,type,
    v127865: state_type > $o ).

tff(pred_def_75724,type,
    v127866: state_type > $o ).

tff(pred_def_75725,type,
    v127867: state_type > $o ).

tff(pred_def_75726,type,
    v127868: state_type > $o ).

tff(pred_def_75727,type,
    v127869: state_type > $o ).

tff(pred_def_75728,type,
    v127870: state_type > $o ).

tff(pred_def_75729,type,
    v127871: state_type > $o ).

tff(pred_def_75730,type,
    v127872: state_type > $o ).

tff(pred_def_75731,type,
    v127849: ( state_type * $int ) > $o ).

tff(pred_def_75732,type,
    v127879: state_type > $o ).

tff(pred_def_75733,type,
    v127880: state_type > $o ).

tff(pred_def_75734,type,
    v127878: state_type > $o ).

tff(pred_def_75735,type,
    v127876: ( state_type * $int ) > $o ).

tff(pred_def_75736,type,
    v127882: state_type > $o ).

tff(pred_def_75737,type,
    v127883: state_type > $o ).

tff(pred_def_75738,type,
    v127884: state_type > $o ).

tff(pred_def_75739,type,
    v127885: state_type > $o ).

tff(pred_def_75740,type,
    v127886: state_type > $o ).

tff(pred_def_75741,type,
    v127887: state_type > $o ).

tff(pred_def_75742,type,
    v127888: state_type > $o ).

tff(pred_def_75743,type,
    v127889: state_type > $o ).

tff(pred_def_75744,type,
    v127890: state_type > $o ).

tff(pred_def_75745,type,
    v127891: state_type > $o ).

tff(pred_def_75746,type,
    v127892: state_type > $o ).

tff(pred_def_75747,type,
    v127893: state_type > $o ).

tff(pred_def_75748,type,
    v127894: state_type > $o ).

tff(pred_def_75749,type,
    v127895: state_type > $o ).

tff(pred_def_75750,type,
    v127896: state_type > $o ).

tff(pred_def_75751,type,
    v127897: state_type > $o ).

tff(pred_def_75752,type,
    v127874: ( state_type * $int ) > $o ).

tff(pred_def_75753,type,
    v127904: state_type > $o ).

tff(pred_def_75754,type,
    v127905: state_type > $o ).

tff(pred_def_75755,type,
    v127903: state_type > $o ).

tff(pred_def_75756,type,
    v127901: ( state_type * $int ) > $o ).

tff(pred_def_75757,type,
    v127907: state_type > $o ).

tff(pred_def_75758,type,
    v127908: state_type > $o ).

tff(pred_def_75759,type,
    v127909: state_type > $o ).

tff(pred_def_75760,type,
    v127910: state_type > $o ).

tff(pred_def_75761,type,
    v127911: state_type > $o ).

tff(pred_def_75762,type,
    v127912: state_type > $o ).

tff(pred_def_75763,type,
    v127913: state_type > $o ).

tff(pred_def_75764,type,
    v127914: state_type > $o ).

tff(pred_def_75765,type,
    v127915: state_type > $o ).

tff(pred_def_75766,type,
    v127916: state_type > $o ).

tff(pred_def_75767,type,
    v127917: state_type > $o ).

tff(pred_def_75768,type,
    v127918: state_type > $o ).

tff(pred_def_75769,type,
    v127919: state_type > $o ).

tff(pred_def_75770,type,
    v127920: state_type > $o ).

tff(pred_def_75771,type,
    v127921: state_type > $o ).

tff(pred_def_75772,type,
    v127922: state_type > $o ).

tff(pred_def_75773,type,
    v127899: ( state_type * $int ) > $o ).

tff(pred_def_75774,type,
    v127929: state_type > $o ).

tff(pred_def_75775,type,
    v127930: state_type > $o ).

tff(pred_def_75776,type,
    v127928: state_type > $o ).

tff(pred_def_75777,type,
    v127926: ( state_type * $int ) > $o ).

tff(pred_def_75778,type,
    v127932: state_type > $o ).

tff(pred_def_75779,type,
    v127933: state_type > $o ).

tff(pred_def_75780,type,
    v127934: state_type > $o ).

tff(pred_def_75781,type,
    v127935: state_type > $o ).

tff(pred_def_75782,type,
    v127936: state_type > $o ).

tff(pred_def_75783,type,
    v127937: state_type > $o ).

tff(pred_def_75784,type,
    v127938: state_type > $o ).

tff(pred_def_75785,type,
    v127939: state_type > $o ).

tff(pred_def_75786,type,
    v127940: state_type > $o ).

tff(pred_def_75787,type,
    v127941: state_type > $o ).

tff(pred_def_75788,type,
    v127942: state_type > $o ).

tff(pred_def_75789,type,
    v127943: state_type > $o ).

tff(pred_def_75790,type,
    v127944: state_type > $o ).

tff(pred_def_75791,type,
    v127945: state_type > $o ).

tff(pred_def_75792,type,
    v127946: state_type > $o ).

tff(pred_def_75793,type,
    v127947: state_type > $o ).

tff(pred_def_75794,type,
    v127924: ( state_type * $int ) > $o ).

tff(pred_def_75795,type,
    v127954: state_type > $o ).

tff(pred_def_75796,type,
    v127955: state_type > $o ).

tff(pred_def_75797,type,
    v127953: state_type > $o ).

tff(pred_def_75798,type,
    v127951: ( state_type * $int ) > $o ).

tff(pred_def_75799,type,
    v127957: state_type > $o ).

tff(pred_def_75800,type,
    v127958: state_type > $o ).

tff(pred_def_75801,type,
    v127959: state_type > $o ).

tff(pred_def_75802,type,
    v127960: state_type > $o ).

tff(pred_def_75803,type,
    v127961: state_type > $o ).

tff(pred_def_75804,type,
    v127962: state_type > $o ).

tff(pred_def_75805,type,
    v127963: state_type > $o ).

tff(pred_def_75806,type,
    v127964: state_type > $o ).

tff(pred_def_75807,type,
    v127965: state_type > $o ).

tff(pred_def_75808,type,
    v127966: state_type > $o ).

tff(pred_def_75809,type,
    v127967: state_type > $o ).

tff(pred_def_75810,type,
    v127968: state_type > $o ).

tff(pred_def_75811,type,
    v127969: state_type > $o ).

tff(pred_def_75812,type,
    v127970: state_type > $o ).

tff(pred_def_75813,type,
    v127971: state_type > $o ).

tff(pred_def_75814,type,
    v127972: state_type > $o ).

tff(pred_def_75815,type,
    v127949: ( state_type * $int ) > $o ).

tff(pred_def_75816,type,
    v127979: state_type > $o ).

tff(pred_def_75817,type,
    v127980: state_type > $o ).

tff(pred_def_75818,type,
    v127978: state_type > $o ).

tff(pred_def_75819,type,
    v127976: ( state_type * $int ) > $o ).

tff(pred_def_75820,type,
    v127982: state_type > $o ).

tff(pred_def_75821,type,
    v127983: state_type > $o ).

tff(pred_def_75822,type,
    v127984: state_type > $o ).

tff(pred_def_75823,type,
    v127985: state_type > $o ).

tff(pred_def_75824,type,
    v127986: state_type > $o ).

tff(pred_def_75825,type,
    v127987: state_type > $o ).

tff(pred_def_75826,type,
    v127988: state_type > $o ).

tff(pred_def_75827,type,
    v127989: state_type > $o ).

tff(pred_def_75828,type,
    v127990: state_type > $o ).

tff(pred_def_75829,type,
    v127991: state_type > $o ).

tff(pred_def_75830,type,
    v127992: state_type > $o ).

tff(pred_def_75831,type,
    v127993: state_type > $o ).

tff(pred_def_75832,type,
    v127994: state_type > $o ).

tff(pred_def_75833,type,
    v127995: state_type > $o ).

tff(pred_def_75834,type,
    v127996: state_type > $o ).

tff(pred_def_75835,type,
    v127997: state_type > $o ).

tff(pred_def_75836,type,
    v127974: ( state_type * $int ) > $o ).

tff(pred_def_75837,type,
    v128004: state_type > $o ).

tff(pred_def_75838,type,
    v128005: state_type > $o ).

tff(pred_def_75839,type,
    v128003: state_type > $o ).

tff(pred_def_75840,type,
    v128001: ( state_type * $int ) > $o ).

tff(pred_def_75841,type,
    v128007: state_type > $o ).

tff(pred_def_75842,type,
    v128008: state_type > $o ).

tff(pred_def_75843,type,
    v128009: state_type > $o ).

tff(pred_def_75844,type,
    v128010: state_type > $o ).

tff(pred_def_75845,type,
    v128011: state_type > $o ).

tff(pred_def_75846,type,
    v128012: state_type > $o ).

tff(pred_def_75847,type,
    v128013: state_type > $o ).

tff(pred_def_75848,type,
    v128014: state_type > $o ).

tff(pred_def_75849,type,
    v128015: state_type > $o ).

tff(pred_def_75850,type,
    v128016: state_type > $o ).

tff(pred_def_75851,type,
    v128017: state_type > $o ).

tff(pred_def_75852,type,
    v128018: state_type > $o ).

tff(pred_def_75853,type,
    v128019: state_type > $o ).

tff(pred_def_75854,type,
    v128020: state_type > $o ).

tff(pred_def_75855,type,
    v128021: state_type > $o ).

tff(pred_def_75856,type,
    v128022: state_type > $o ).

tff(pred_def_75857,type,
    v127999: ( state_type * $int ) > $o ).

tff(pred_def_75858,type,
    v128024: state_type > $o ).

tff(pred_def_75859,type,
    v128035: state_type > $o ).

tff(pred_def_75860,type,
    v128034: ( state_type * $int ) > $o ).

tff(pred_def_75861,type,
    v128033: ( state_type * $int ) > $o ).

tff(pred_def_75862,type,
    v128038: state_type > $o ).

tff(pred_def_75863,type,
    v128037: ( state_type * $int ) > $o ).

tff(pred_def_75864,type,
    v128036: ( state_type * $int ) > $o ).

tff(pred_def_75865,type,
    v128032: ( state_type * $int ) > $o ).

tff(pred_def_75866,type,
    v128041: state_type > $o ).

tff(pred_def_75867,type,
    v128040: ( state_type * $int ) > $o ).

tff(pred_def_75868,type,
    v128039: ( state_type * $int ) > $o ).

tff(pred_def_75869,type,
    v128031: ( state_type * $int ) > $o ).

tff(pred_def_75870,type,
    v128044: state_type > $o ).

tff(pred_def_75871,type,
    v128043: ( state_type * $int ) > $o ).

tff(pred_def_75872,type,
    v128042: ( state_type * $int ) > $o ).

tff(pred_def_75873,type,
    v128030: ( state_type * $int ) > $o ).

tff(pred_def_75874,type,
    v128047: state_type > $o ).

tff(pred_def_75875,type,
    v128046: ( state_type * $int ) > $o ).

tff(pred_def_75876,type,
    v128045: ( state_type * $int ) > $o ).

tff(pred_def_75877,type,
    v128029: ( state_type * $int ) > $o ).

tff(pred_def_75878,type,
    v128050: state_type > $o ).

tff(pred_def_75879,type,
    v128049: ( state_type * $int ) > $o ).

tff(pred_def_75880,type,
    v128048: ( state_type * $int ) > $o ).

tff(pred_def_75881,type,
    v128028: ( state_type * $int ) > $o ).

tff(pred_def_75882,type,
    v128053: state_type > $o ).

tff(pred_def_75883,type,
    v128052: ( state_type * $int ) > $o ).

tff(pred_def_75884,type,
    v128051: ( state_type * $int ) > $o ).

tff(pred_def_75885,type,
    v128027: ( state_type * $int ) > $o ).

tff(pred_def_75886,type,
    v128056: state_type > $o ).

tff(pred_def_75887,type,
    v128055: ( state_type * $int ) > $o ).

tff(pred_def_75888,type,
    v128054: ( state_type * $int ) > $o ).

tff(pred_def_75889,type,
    v128026: ( state_type * $int ) > $o ).

tff(pred_def_75890,type,
    v128058: state_type > $o ).

tff(pred_def_75891,type,
    v128057: ( state_type * $int ) > $o ).

tff(pred_def_75892,type,
    v127710: ( state_type * $int ) > $o ).

tff(pred_def_75893,type,
    v127708: ( state_type * $int ) > $o ).

tff(pred_def_75894,type,
    v127706: ( state_type * $int ) > $o ).

tff(pred_def_75895,type,
    v128076: ( state_type * $int ) > $o ).

tff(pred_def_75896,type,
    v128075: state_type > $o ).

tff(pred_def_75897,type,
    v128074: state_type > $o ).

tff(pred_def_75898,type,
    v128073: state_type > $o ).

tff(pred_def_75899,type,
    v128072: state_type > $o ).

tff(pred_def_75900,type,
    v128071: state_type > $o ).

tff(pred_def_75901,type,
    v128070: state_type > $o ).

tff(pred_def_75902,type,
    v128069: state_type > $o ).

tff(pred_def_75903,type,
    v128068: state_type > $o ).

tff(pred_def_75904,type,
    v128067: state_type > $o ).

tff(pred_def_75905,type,
    v128066: state_type > $o ).

tff(pred_def_75906,type,
    v128065: state_type > $o ).

tff(pred_def_75907,type,
    v128064: state_type > $o ).

tff(pred_def_75908,type,
    v128063: state_type > $o ).

tff(pred_def_75909,type,
    v128062: state_type > $o ).

tff(pred_def_75910,type,
    v128060: state_type > $o ).

tff(pred_def_75911,type,
    v128093: ( state_type * $int ) > $o ).

tff(pred_def_75912,type,
    v128092: state_type > $o ).

tff(pred_def_75913,type,
    v128091: state_type > $o ).

tff(pred_def_75914,type,
    v128090: state_type > $o ).

tff(pred_def_75915,type,
    v128089: state_type > $o ).

tff(pred_def_75916,type,
    v128088: state_type > $o ).

tff(pred_def_75917,type,
    v128087: state_type > $o ).

tff(pred_def_75918,type,
    v128086: state_type > $o ).

tff(pred_def_75919,type,
    v128085: state_type > $o ).

tff(pred_def_75920,type,
    v128084: state_type > $o ).

tff(pred_def_75921,type,
    v128083: state_type > $o ).

tff(pred_def_75922,type,
    v128082: state_type > $o ).

tff(pred_def_75923,type,
    v128081: state_type > $o ).

tff(pred_def_75924,type,
    v128080: state_type > $o ).

tff(pred_def_75925,type,
    v128079: state_type > $o ).

tff(pred_def_75926,type,
    v128077: state_type > $o ).

tff(pred_def_75927,type,
    v127412: state_type > $o ).

tff(pred_def_75928,type,
    v128103: state_type > $o ).

tff(pred_def_75929,type,
    v128101: state_type > $o ).

tff(pred_def_75930,type,
    v128107: state_type > $o ).

tff(pred_def_75931,type,
    v128105: state_type > $o ).

tff(pred_def_75932,type,
    v128117: state_type > $o ).

tff(pred_def_75933,type,
    v89409: state_type > $o ).

tff(pred_def_75934,type,
    v128118: state_type > $o ).

tff(pred_def_75935,type,
    v128115: state_type > $o ).

tff(pred_def_75936,type,
    v128113: state_type > $o ).

tff(pred_def_75937,type,
    v128122: state_type > $o ).

tff(pred_def_75938,type,
    v128120: state_type > $o ).

tff(pred_def_75939,type,
    v128136: state_type > $o ).

tff(pred_def_75940,type,
    v128134: state_type > $o ).

tff(pred_def_75941,type,
    v128140: state_type > $o ).

tff(pred_def_75942,type,
    v128138: state_type > $o ).

tff(pred_def_75943,type,
    v128148: state_type > $o ).

tff(pred_def_75944,type,
    v128128: state_type > $o ).

tff(pred_def_75945,type,
    v128150: ( state_type * $int ) > $o ).

tff(pred_def_75946,type,
    v128151: ( state_type * $int ) > $o ).

tff(pred_def_75947,type,
    v128146: ( state_type * $int ) > $o ).

tff(pred_def_75948,type,
    v128126: state_type > $o ).

tff(pred_def_75949,type,
    v128155: state_type > $o ).

tff(pred_def_75950,type,
    v128153: state_type > $o ).

tff(pred_def_75951,type,
    v128160: state_type > $o ).

tff(pred_def_75952,type,
    v128159: ( state_type * $int ) > $o ).

tff(pred_def_75953,type,
    v128158: ( state_type * $int ) > $o ).

tff(pred_def_75954,type,
    v128164: state_type > $o ).

tff(pred_def_75955,type,
    v128163: ( state_type * $int ) > $o ).

tff(pred_def_75956,type,
    v128162: ( state_type * $int ) > $o ).

tff(pred_def_75957,type,
    v128130: ( state_type * $int ) > $o ).

tff(pred_def_75958,type,
    v128161: ( state_type * $int ) > $o ).

tff(pred_def_75959,type,
    v128157: ( state_type * $int ) > $o ).

tff(pred_def_75960,type,
    v128144: ( state_type * $int ) > $o ).

tff(pred_def_75961,type,
    v128142: ( state_type * $int ) > $o ).

tff(pred_def_75962,type,
    v128168: state_type > $o ).

tff(pred_def_75963,type,
    v128166: state_type > $o ).

tff(pred_def_75964,type,
    v128175: state_type > $o ).

tff(pred_def_75965,type,
    v128173: state_type > $o ).

tff(pred_def_75966,type,
    v128172: state_type > $o ).

tff(pred_def_75967,type,
    v128171: state_type > $o ).

tff(pred_def_75968,type,
    v128183: state_type > $o ).

tff(pred_def_75969,type,
    v128184: state_type > $o ).

tff(pred_def_75970,type,
    v128182: state_type > $o ).

tff(pred_def_75971,type,
    v128179: ( state_type * $int ) > $o ).

tff(pred_def_75972,type,
    v128181: ( state_type * $int ) > $o ).

tff(pred_def_75973,type,
    v128170: ( state_type * $int ) > $o ).

tff(pred_def_75974,type,
    v128132: ( state_type * $int ) > $o ).

tff(pred_def_75975,type,
    v128200: state_type > $o ).

tff(pred_def_75976,type,
    v128198: state_type > $o ).

tff(pred_def_75977,type,
    v128197: state_type > $o ).

tff(pred_def_75978,type,
    v128196: ( state_type * $int ) > $o ).

tff(pred_def_75979,type,
    v128208: state_type > $o ).

tff(pred_def_75980,type,
    v128206: state_type > $o ).

tff(pred_def_75981,type,
    v128205: state_type > $o ).

tff(pred_def_75982,type,
    v128204: ( state_type * $int ) > $o ).

tff(pred_def_75983,type,
    v128216: state_type > $o ).

tff(pred_def_75984,type,
    v128214: state_type > $o ).

tff(pred_def_75985,type,
    v128213: state_type > $o ).

tff(pred_def_75986,type,
    v128212: ( state_type * $int ) > $o ).

tff(pred_def_75987,type,
    v128224: state_type > $o ).

tff(pred_def_75988,type,
    v128222: state_type > $o ).

tff(pred_def_75989,type,
    v128221: state_type > $o ).

tff(pred_def_75990,type,
    v128220: ( state_type * $int ) > $o ).

tff(pred_def_75991,type,
    v128232: state_type > $o ).

tff(pred_def_75992,type,
    v128230: state_type > $o ).

tff(pred_def_75993,type,
    v128229: state_type > $o ).

tff(pred_def_75994,type,
    v128228: ( state_type * $int ) > $o ).

tff(pred_def_75995,type,
    v128240: state_type > $o ).

tff(pred_def_75996,type,
    v128238: state_type > $o ).

tff(pred_def_75997,type,
    v128237: state_type > $o ).

tff(pred_def_75998,type,
    v128236: ( state_type * $int ) > $o ).

tff(pred_def_75999,type,
    v128248: state_type > $o ).

tff(pred_def_76000,type,
    v128246: state_type > $o ).

tff(pred_def_76001,type,
    v128245: state_type > $o ).

tff(pred_def_76002,type,
    v128244: ( state_type * $int ) > $o ).

tff(pred_def_76003,type,
    v128256: state_type > $o ).

tff(pred_def_76004,type,
    v128254: state_type > $o ).

tff(pred_def_76005,type,
    v128253: state_type > $o ).

tff(pred_def_76006,type,
    v128252: ( state_type * $int ) > $o ).

tff(pred_def_76007,type,
    v128264: state_type > $o ).

tff(pred_def_76008,type,
    v128262: state_type > $o ).

tff(pred_def_76009,type,
    v128261: state_type > $o ).

tff(pred_def_76010,type,
    v128260: ( state_type * $int ) > $o ).

tff(pred_def_76011,type,
    v128272: state_type > $o ).

tff(pred_def_76012,type,
    v128270: state_type > $o ).

tff(pred_def_76013,type,
    v128269: state_type > $o ).

tff(pred_def_76014,type,
    v128268: ( state_type * $int ) > $o ).

tff(pred_def_76015,type,
    v128280: state_type > $o ).

tff(pred_def_76016,type,
    v128278: state_type > $o ).

tff(pred_def_76017,type,
    v128277: state_type > $o ).

tff(pred_def_76018,type,
    v128276: ( state_type * $int ) > $o ).

tff(pred_def_76019,type,
    v128288: state_type > $o ).

tff(pred_def_76020,type,
    v128286: state_type > $o ).

tff(pred_def_76021,type,
    v128285: state_type > $o ).

tff(pred_def_76022,type,
    v128284: ( state_type * $int ) > $o ).

tff(pred_def_76023,type,
    v128296: state_type > $o ).

tff(pred_def_76024,type,
    v128294: state_type > $o ).

tff(pred_def_76025,type,
    v128293: state_type > $o ).

tff(pred_def_76026,type,
    v128292: ( state_type * $int ) > $o ).

tff(pred_def_76027,type,
    v128304: state_type > $o ).

tff(pred_def_76028,type,
    v128302: state_type > $o ).

tff(pred_def_76029,type,
    v128301: state_type > $o ).

tff(pred_def_76030,type,
    v128300: ( state_type * $int ) > $o ).

tff(pred_def_76031,type,
    v128312: state_type > $o ).

tff(pred_def_76032,type,
    v128310: state_type > $o ).

tff(pred_def_76033,type,
    v128309: state_type > $o ).

tff(pred_def_76034,type,
    v128308: ( state_type * $int ) > $o ).

tff(pred_def_76035,type,
    v128320: state_type > $o ).

tff(pred_def_76036,type,
    v128318: state_type > $o ).

tff(pred_def_76037,type,
    v128317: state_type > $o ).

tff(pred_def_76038,type,
    v128316: ( state_type * $int ) > $o ).

tff(pred_def_76039,type,
    v128324: state_type > $o ).

tff(pred_def_76040,type,
    v128325: state_type > $o ).

tff(pred_def_76041,type,
    v128326: state_type > $o ).

tff(pred_def_76042,type,
    v128327: state_type > $o ).

tff(pred_def_76043,type,
    v128328: state_type > $o ).

tff(pred_def_76044,type,
    v128329: state_type > $o ).

tff(pred_def_76045,type,
    v128330: state_type > $o ).

tff(pred_def_76046,type,
    v128331: state_type > $o ).

tff(pred_def_76047,type,
    v128194: ( state_type * $int ) > $o ).

tff(pred_def_76048,type,
    v128334: state_type > $o ).

tff(pred_def_76049,type,
    v128333: ( state_type * $int ) > $o ).

tff(pred_def_76050,type,
    v128192: ( state_type * $int ) > $o ).

tff(pred_def_76051,type,
    v128190: ( state_type * $int ) > $o ).

tff(pred_def_76052,type,
    v128188: ( state_type * $int ) > $o ).

tff(pred_def_76053,type,
    v128340: state_type > $o ).

tff(pred_def_76054,type,
    v128339: ( state_type * $int ) > $o ).

tff(pred_def_76055,type,
    v2902: ( state_type * $int ) > $o ).

tff(pred_def_76056,type,
    v128341: ( state_type * $int ) > $o ).

tff(pred_def_76057,type,
    v89411: ( state_type * $int ) > $o ).

tff(pred_def_76058,type,
    v128347: state_type > $o ).

tff(pred_def_76059,type,
    v128345: state_type > $o ).

tff(pred_def_76060,type,
    v128344: state_type > $o ).

tff(pred_def_76061,type,
    v128343: ( state_type * $int ) > $o ).

tff(pred_def_76062,type,
    v128336: ( state_type * $int ) > $o ).

tff(pred_def_76063,type,
    v128358: state_type > $o ).

tff(pred_def_76064,type,
    v128357: ( state_type * $int ) > $o ).

tff(pred_def_76065,type,
    v128355: ( state_type * $int ) > $o ).

tff(pred_def_76066,type,
    v128353: ( state_type * $int ) > $o ).

tff(pred_def_76067,type,
    v128351: ( state_type * $int ) > $o ).

tff(pred_def_76068,type,
    v128368: state_type > $o ).

tff(pred_def_76069,type,
    v128369: state_type > $o ).

tff(pred_def_76070,type,
    v128370: state_type > $o ).

tff(pred_def_76071,type,
    v128371: state_type > $o ).

tff(pred_def_76072,type,
    v128372: state_type > $o ).

tff(pred_def_76073,type,
    v128373: state_type > $o ).

tff(pred_def_76074,type,
    v128374: state_type > $o ).

tff(pred_def_76075,type,
    v128375: state_type > $o ).

tff(pred_def_76076,type,
    v128366: ( state_type * $int ) > $o ).

tff(pred_def_76077,type,
    v128378: state_type > $o ).

tff(pred_def_76078,type,
    v128377: ( state_type * $int ) > $o ).

tff(pred_def_76079,type,
    v128364: ( state_type * $int ) > $o ).

tff(pred_def_76080,type,
    v128362: ( state_type * $int ) > $o ).

tff(pred_def_76081,type,
    v128360: ( state_type * $int ) > $o ).

tff(pred_def_76082,type,
    v128385: state_type > $o ).

tff(pred_def_76083,type,
    v128394: ( state_type * $int ) > $o ).

tff(pred_def_76084,type,
    v128393: state_type > $o ).

tff(pred_def_76085,type,
    v128392: state_type > $o ).

tff(pred_def_76086,type,
    v128391: state_type > $o ).

tff(pred_def_76087,type,
    v128390: state_type > $o ).

tff(pred_def_76088,type,
    v128389: state_type > $o ).

tff(pred_def_76089,type,
    v128388: state_type > $o ).

tff(pred_def_76090,type,
    v128386: state_type > $o ).

tff(pred_def_76091,type,
    v128384: state_type > $o ).

tff(pred_def_76092,type,
    v128396: state_type > $o ).

tff(pred_def_76093,type,
    v128405: ( state_type * $int ) > $o ).

tff(pred_def_76094,type,
    v128404: state_type > $o ).

tff(pred_def_76095,type,
    v128403: state_type > $o ).

tff(pred_def_76096,type,
    v128402: state_type > $o ).

tff(pred_def_76097,type,
    v128401: state_type > $o ).

tff(pred_def_76098,type,
    v128400: state_type > $o ).

tff(pred_def_76099,type,
    v128399: state_type > $o ).

tff(pred_def_76100,type,
    v128397: state_type > $o ).

tff(pred_def_76101,type,
    v128395: state_type > $o ).

tff(pred_def_76102,type,
    v128383: state_type > $o ).

tff(pred_def_76103,type,
    v128407: state_type > $o ).

tff(pred_def_76104,type,
    v128416: ( state_type * $int ) > $o ).

tff(pred_def_76105,type,
    v128415: state_type > $o ).

tff(pred_def_76106,type,
    v128414: state_type > $o ).

tff(pred_def_76107,type,
    v128413: state_type > $o ).

tff(pred_def_76108,type,
    v128412: state_type > $o ).

tff(pred_def_76109,type,
    v128411: state_type > $o ).

tff(pred_def_76110,type,
    v128410: state_type > $o ).

tff(pred_def_76111,type,
    v128408: state_type > $o ).

tff(pred_def_76112,type,
    v128406: state_type > $o ).

tff(pred_def_76113,type,
    v128382: state_type > $o ).

tff(pred_def_76114,type,
    v128419: state_type > $o ).

tff(pred_def_76115,type,
    v128418: state_type > $o ).

tff(pred_def_76116,type,
    v128428: ( state_type * $int ) > $o ).

tff(pred_def_76117,type,
    v128427: state_type > $o ).

tff(pred_def_76118,type,
    v128426: state_type > $o ).

tff(pred_def_76119,type,
    v128425: state_type > $o ).

tff(pred_def_76120,type,
    v128424: state_type > $o ).

tff(pred_def_76121,type,
    v128423: state_type > $o ).

tff(pred_def_76122,type,
    v128422: state_type > $o ).

tff(pred_def_76123,type,
    v128420: state_type > $o ).

tff(pred_def_76124,type,
    v128417: state_type > $o ).

tff(pred_def_76125,type,
    v128381: state_type > $o ).

tff(pred_def_76126,type,
    v128431: state_type > $o ).

tff(pred_def_76127,type,
    v128430: state_type > $o ).

tff(pred_def_76128,type,
    v128440: ( state_type * $int ) > $o ).

tff(pred_def_76129,type,
    v128439: state_type > $o ).

tff(pred_def_76130,type,
    v128438: state_type > $o ).

tff(pred_def_76131,type,
    v128437: state_type > $o ).

tff(pred_def_76132,type,
    v128436: state_type > $o ).

tff(pred_def_76133,type,
    v128435: state_type > $o ).

tff(pred_def_76134,type,
    v128434: state_type > $o ).

tff(pred_def_76135,type,
    v128432: state_type > $o ).

tff(pred_def_76136,type,
    v128429: state_type > $o ).

tff(pred_def_76137,type,
    v128380: state_type > $o ).

tff(pred_def_76138,type,
    v128443: state_type > $o ).

tff(pred_def_76139,type,
    v128442: state_type > $o ).

tff(pred_def_76140,type,
    v128452: ( state_type * $int ) > $o ).

tff(pred_def_76141,type,
    v128451: state_type > $o ).

tff(pred_def_76142,type,
    v128450: state_type > $o ).

tff(pred_def_76143,type,
    v128449: state_type > $o ).

tff(pred_def_76144,type,
    v128448: state_type > $o ).

tff(pred_def_76145,type,
    v128447: state_type > $o ).

tff(pred_def_76146,type,
    v128446: state_type > $o ).

tff(pred_def_76147,type,
    v128444: state_type > $o ).

tff(pred_def_76148,type,
    v128441: state_type > $o ).

tff(pred_def_76149,type,
    v128124: state_type > $o ).

tff(pred_def_76150,type,
    v128457: state_type > $o ).

tff(pred_def_76151,type,
    v128456: state_type > $o ).

tff(pred_def_76152,type,
    v128455: state_type > $o ).

tff(pred_def_76153,type,
    v128460: state_type > $o ).

tff(pred_def_76154,type,
    v128459: state_type > $o ).

tff(pred_def_76155,type,
    v128458: state_type > $o ).

tff(pred_def_76156,type,
    v128454: state_type > $o ).

tff(pred_def_76157,type,
    v128465: state_type > $o ).

tff(pred_def_76158,type,
    v128464: state_type > $o ).

tff(pred_def_76159,type,
    v128463: state_type > $o ).

tff(pred_def_76160,type,
    v128097: state_type > $o ).

tff(pred_def_76161,type,
    v128462: state_type > $o ).

tff(pred_def_76162,type,
    v128468: state_type > $o ).

tff(pred_def_76163,type,
    v128467: state_type > $o ).

tff(pred_def_76164,type,
    v128466: state_type > $o ).

tff(pred_def_76165,type,
    v128461: state_type > $o ).

tff(pred_def_76166,type,
    v128111: state_type > $o ).

tff(pred_def_76167,type,
    v128109: state_type > $o ).

tff(pred_def_76168,type,
    v128472: state_type > $o ).

tff(pred_def_76169,type,
    v128470: state_type > $o ).

tff(pred_def_76170,type,
    v128479: state_type > $o ).

tff(pred_def_76171,type,
    v128477: state_type > $o ).

tff(pred_def_76172,type,
    v128476: state_type > $o ).

tff(pred_def_76173,type,
    v128475: state_type > $o ).

tff(pred_def_76174,type,
    v128487: state_type > $o ).

tff(pred_def_76175,type,
    v128488: state_type > $o ).

tff(pred_def_76176,type,
    v128486: state_type > $o ).

tff(pred_def_76177,type,
    v128483: state_type > $o ).

tff(pred_def_76178,type,
    v128485: state_type > $o ).

tff(pred_def_76179,type,
    v128099: state_type > $o ).

tff(pred_def_76180,type,
    v128095: state_type > $o ).

tff(pred_def_76181,type,
    v128500: state_type > $o ).

tff(pred_def_76182,type,
    v5049: state_type > $o ).

tff(pred_def_76183,type,
    v128498: state_type > $o ).

tff(pred_def_76184,type,
    v5138: state_type > $o ).

tff(pred_def_76185,type,
    v128502: ( state_type * $int ) > $o ).

tff(pred_def_76186,type,
    v5136: ( state_type * $int ) > $o ).

tff(pred_def_76187,type,
    v5134: ( state_type * $int ) > $o ).

tff(pred_def_76188,type,
    v5132: ( state_type * $int ) > $o ).

tff(pred_def_76189,type,
    v128506: state_type > $o ).

tff(pred_def_76190,type,
    v128504: state_type > $o ).

tff(pred_def_76191,type,
    v128513: state_type > $o ).

tff(pred_def_76192,type,
    v128511: state_type > $o ).

tff(pred_def_76193,type,
    v128510: state_type > $o ).

tff(pred_def_76194,type,
    v128509: state_type > $o ).

tff(pred_def_76195,type,
    v128521: state_type > $o ).

tff(pred_def_76196,type,
    v128522: state_type > $o ).

tff(pred_def_76197,type,
    v128520: state_type > $o ).

tff(pred_def_76198,type,
    v128517: ( state_type * $int ) > $o ).

tff(pred_def_76199,type,
    v128519: ( state_type * $int ) > $o ).

tff(pred_def_76200,type,
    v128508: ( state_type * $int ) > $o ).

tff(pred_def_76201,type,
    v5122: ( state_type * $int ) > $o ).

tff(pred_def_76202,type,
    v5120: ( state_type * $int ) > $o ).

tff(pred_def_76203,type,
    v4333: state_type > $o ).

tff(pred_def_76204,type,
    v128496: state_type > $o ).

tff(pred_def_76205,type,
    v128494: state_type > $o ).

tff(pred_def_76206,type,
    v128492: state_type > $o ).

tff(pred_def_76207,type,
    v128537: state_type > $o ).

tff(pred_def_76208,type,
    v128536: state_type > $o ).

tff(pred_def_76209,type,
    v128538: state_type > $o ).

tff(pred_def_76210,type,
    v128535: state_type > $o ).

tff(pred_def_76211,type,
    v128534: state_type > $o ).

tff(pred_def_76212,type,
    v128539: state_type > $o ).

tff(pred_def_76213,type,
    v128533: state_type > $o ).

tff(pred_def_76214,type,
    v86879: state_type > $o ).

tff(pred_def_76215,type,
    v128532: state_type > $o ).

tff(pred_def_76216,type,
    v128541: state_type > $o ).

tff(pred_def_76217,type,
    v128540: state_type > $o ).

tff(pred_def_76218,type,
    v128531: state_type > $o ).

tff(pred_def_76219,type,
    v128530: state_type > $o ).

tff(pred_def_76220,type,
    v128529: state_type > $o ).

tff(pred_def_76221,type,
    v128528: state_type > $o ).

tff(pred_def_76222,type,
    v128527: state_type > $o ).

tff(pred_def_76223,type,
    v127410: state_type > $o ).

tff(pred_def_76224,type,
    v128560: ( state_type * $int ) > $o ).

tff(pred_def_76225,type,
    v128559: state_type > $o ).

tff(pred_def_76226,type,
    v128558: state_type > $o ).

tff(pred_def_76227,type,
    v128557: state_type > $o ).

tff(pred_def_76228,type,
    v128556: state_type > $o ).

tff(pred_def_76229,type,
    v128555: state_type > $o ).

tff(pred_def_76230,type,
    v128554: state_type > $o ).

tff(pred_def_76231,type,
    v128553: state_type > $o ).

tff(pred_def_76232,type,
    v128552: state_type > $o ).

tff(pred_def_76233,type,
    v128551: state_type > $o ).

tff(pred_def_76234,type,
    v128550: state_type > $o ).

tff(pred_def_76235,type,
    v128549: state_type > $o ).

tff(pred_def_76236,type,
    v128548: state_type > $o ).

tff(pred_def_76237,type,
    v128547: state_type > $o ).

tff(pred_def_76238,type,
    v128546: state_type > $o ).

tff(pred_def_76239,type,
    v128544: state_type > $o ).

tff(pred_def_76240,type,
    v128561: state_type > $o ).

tff(pred_def_76241,type,
    v128543: state_type > $o ).

tff(pred_def_76242,type,
    v128563: state_type > $o ).

tff(pred_def_76243,type,
    v128564: state_type > $o ).

tff(pred_def_76244,type,
    v128562: state_type > $o ).

tff(pred_def_76245,type,
    v128567: state_type > $o ).

tff(pred_def_76246,type,
    v128566: state_type > $o ).

tff(pred_def_76247,type,
    v128568: state_type > $o ).

tff(pred_def_76248,type,
    v128574: state_type > $o ).

tff(pred_def_76249,type,
    v128573: state_type > $o ).

tff(pred_def_76250,type,
    v128575: state_type > $o ).

tff(pred_def_76251,type,
    v128572: state_type > $o ).

tff(pred_def_76252,type,
    v128576: state_type > $o ).

tff(pred_def_76253,type,
    v128571: state_type > $o ).

tff(pred_def_76254,type,
    v128577: state_type > $o ).

tff(pred_def_76255,type,
    v128570: state_type > $o ).

tff(pred_def_76256,type,
    v128578: state_type > $o ).

tff(pred_def_76257,type,
    v128581: state_type > $o ).

tff(pred_def_76258,type,
    v128583: state_type > $o ).

tff(pred_def_76259,type,
    v128580: state_type > $o ).

tff(pred_def_76260,type,
    v128585: state_type > $o ).

tff(pred_def_76261,type,
    v128584: state_type > $o ).

tff(pred_def_76262,type,
    v100201: state_type > $o ).

tff(pred_def_76263,type,
    v128588: state_type > $o ).

tff(pred_def_76264,type,
    v128587: state_type > $o ).

tff(pred_def_76265,type,
    v97385: ( state_type * $int ) > $o ).

tff(pred_def_76266,type,
    v128594: state_type > $o ).

tff(pred_def_76267,type,
    v128593: state_type > $o ).

tff(pred_def_76268,type,
    v128595: state_type > $o ).

tff(pred_def_76269,type,
    v128592: state_type > $o ).

tff(pred_def_76270,type,
    v128596: state_type > $o ).

tff(pred_def_76271,type,
    v128591: state_type > $o ).

tff(pred_def_76272,type,
    v128599: state_type > $o ).

tff(pred_def_76273,type,
    v128600: state_type > $o ).

tff(pred_def_76274,type,
    v128598: state_type > $o ).

tff(pred_def_76275,type,
    v128601: state_type > $o ).

tff(pred_def_76276,type,
    v128597: state_type > $o ).

tff(pred_def_76277,type,
    v128589: ( state_type * $int ) > $o ).

tff(pred_def_76278,type,
    v128604: state_type > $o ).

tff(pred_def_76279,type,
    v128603: state_type > $o ).

tff(pred_def_76280,type,
    v128611: state_type > $o ).

tff(pred_def_76281,type,
    v128610: state_type > $o ).

tff(pred_def_76282,type,
    v128609: state_type > $o ).

tff(pred_def_76283,type,
    v128608: state_type > $o ).

tff(pred_def_76284,type,
    v128612: state_type > $o ).

tff(pred_def_76285,type,
    v128607: state_type > $o ).

tff(pred_def_76286,type,
    v128614: state_type > $o ).

tff(pred_def_76287,type,
    v128615: state_type > $o ).

tff(pred_def_76288,type,
    v128613: state_type > $o ).

tff(pred_def_76289,type,
    v128605: ( state_type * $int ) > $o ).

tff(pred_def_76290,type,
    v128602: ( state_type * $int ) > $o ).

tff(pred_def_76291,type,
    v128586: ( state_type * $int ) > $o ).

tff(pred_def_76292,type,
    v97405: ( state_type * $int ) > $o ).

tff(pred_def_76293,type,
    v97403: ( state_type * $int ) > $o ).

tff(pred_def_76294,type,
    v128617: state_type > $o ).

tff(pred_def_76295,type,
    v128621: state_type > $o ).

tff(pred_def_76296,type,
    v128620: ( state_type * $int ) > $o ).

tff(pred_def_76297,type,
    v128619: ( state_type * $int ) > $o ).

tff(pred_def_76298,type,
    v128618: ( state_type * $int ) > $o ).

tff(pred_def_76299,type,
    v97401: ( state_type * $int ) > $o ).

tff(pred_def_76300,type,
    v97399: ( state_type * $int ) > $o ).

tff(pred_def_76301,type,
    v128625: state_type > $o ).

tff(pred_def_76302,type,
    v128623: state_type > $o ).

tff(pred_def_76303,type,
    v128632: state_type > $o ).

tff(pred_def_76304,type,
    v128630: state_type > $o ).

tff(pred_def_76305,type,
    v128629: state_type > $o ).

tff(pred_def_76306,type,
    v128628: state_type > $o ).

tff(pred_def_76307,type,
    v128640: state_type > $o ).

tff(pred_def_76308,type,
    v128641: state_type > $o ).

tff(pred_def_76309,type,
    v128639: state_type > $o ).

tff(pred_def_76310,type,
    v128636: ( state_type * $int ) > $o ).

tff(pred_def_76311,type,
    v128638: ( state_type * $int ) > $o ).

tff(pred_def_76312,type,
    v128627: ( state_type * $int ) > $o ).

tff(pred_def_76313,type,
    v97389: ( state_type * $int ) > $o ).

tff(pred_def_76314,type,
    v97387: ( state_type * $int ) > $o ).

tff(pred_def_76315,type,
    v128649: state_type > $o ).

tff(pred_def_76316,type,
    v128647: state_type > $o ).

tff(pred_def_76317,type,
    v128646: state_type > $o ).

tff(pred_def_76318,type,
    v128645: ( state_type * $int ) > $o ).

tff(pred_def_76319,type,
    v128653: state_type > $o ).

tff(pred_def_76320,type,
    v128654: state_type > $o ).

tff(pred_def_76321,type,
    v97383: state_type > $o ).

tff(pred_def_76322,type,
    v128667: state_type > $o ).

tff(pred_def_76323,type,
    v128665: state_type > $o ).

tff(pred_def_76324,type,
    v128671: state_type > $o ).

tff(pred_def_76325,type,
    v128669: state_type > $o ).

tff(pred_def_76326,type,
    v128683: state_type > $o ).

tff(pred_def_76327,type,
    v128681: state_type > $o ).

tff(pred_def_76328,type,
    v128688: state_type > $o ).

tff(pred_def_76329,type,
    v128689: state_type > $o ).

tff(pred_def_76330,type,
    v128687: state_type > $o ).

tff(pred_def_76331,type,
    v128691: state_type > $o ).

tff(pred_def_76332,type,
    v128690: state_type > $o ).

tff(pred_def_76333,type,
    v128685: state_type > $o ).

tff(pred_def_76334,type,
    v128694: state_type > $o ).

tff(pred_def_76335,type,
    v128693: state_type > $o ).

tff(pred_def_76336,type,
    v128659: ( state_type * $int ) > $o ).

tff(pred_def_76337,type,
    v128700: state_type > $o ).

tff(pred_def_76338,type,
    v128699: state_type > $o ).

tff(pred_def_76339,type,
    v128701: state_type > $o ).

tff(pred_def_76340,type,
    v128698: state_type > $o ).

tff(pred_def_76341,type,
    v128702: state_type > $o ).

tff(pred_def_76342,type,
    v128697: state_type > $o ).

tff(pred_def_76343,type,
    v128705: state_type > $o ).

tff(pred_def_76344,type,
    v128706: state_type > $o ).

tff(pred_def_76345,type,
    v128704: state_type > $o ).

tff(pred_def_76346,type,
    v128707: state_type > $o ).

tff(pred_def_76347,type,
    v128703: state_type > $o ).

tff(pred_def_76348,type,
    v128695: ( state_type * $int ) > $o ).

tff(pred_def_76349,type,
    v128710: state_type > $o ).

tff(pred_def_76350,type,
    v128709: state_type > $o ).

tff(pred_def_76351,type,
    v128717: state_type > $o ).

tff(pred_def_76352,type,
    v128716: state_type > $o ).

tff(pred_def_76353,type,
    v128715: state_type > $o ).

tff(pred_def_76354,type,
    v128714: state_type > $o ).

tff(pred_def_76355,type,
    v128718: state_type > $o ).

tff(pred_def_76356,type,
    v128713: state_type > $o ).

tff(pred_def_76357,type,
    v128720: state_type > $o ).

tff(pred_def_76358,type,
    v128721: state_type > $o ).

tff(pred_def_76359,type,
    v128719: state_type > $o ).

tff(pred_def_76360,type,
    v128711: ( state_type * $int ) > $o ).

tff(pred_def_76361,type,
    v128708: ( state_type * $int ) > $o ).

tff(pred_def_76362,type,
    v128692: ( state_type * $int ) > $o ).

tff(pred_def_76363,type,
    v128679: ( state_type * $int ) > $o ).

tff(pred_def_76364,type,
    v128677: ( state_type * $int ) > $o ).

tff(pred_def_76365,type,
    v128723: state_type > $o ).

tff(pred_def_76366,type,
    v128727: state_type > $o ).

tff(pred_def_76367,type,
    v128726: ( state_type * $int ) > $o ).

tff(pred_def_76368,type,
    v128725: ( state_type * $int ) > $o ).

tff(pred_def_76369,type,
    v128724: ( state_type * $int ) > $o ).

tff(pred_def_76370,type,
    v128675: ( state_type * $int ) > $o ).

tff(pred_def_76371,type,
    v128673: ( state_type * $int ) > $o ).

tff(pred_def_76372,type,
    v128731: state_type > $o ).

tff(pred_def_76373,type,
    v128729: state_type > $o ).

tff(pred_def_76374,type,
    v128738: state_type > $o ).

tff(pred_def_76375,type,
    v128736: state_type > $o ).

tff(pred_def_76376,type,
    v128735: state_type > $o ).

tff(pred_def_76377,type,
    v128734: state_type > $o ).

tff(pred_def_76378,type,
    v128746: state_type > $o ).

tff(pred_def_76379,type,
    v128747: state_type > $o ).

tff(pred_def_76380,type,
    v128745: state_type > $o ).

tff(pred_def_76381,type,
    v128742: ( state_type * $int ) > $o ).

tff(pred_def_76382,type,
    v128744: ( state_type * $int ) > $o ).

tff(pred_def_76383,type,
    v128733: ( state_type * $int ) > $o ).

tff(pred_def_76384,type,
    v128663: ( state_type * $int ) > $o ).

tff(pred_def_76385,type,
    v128661: ( state_type * $int ) > $o ).

tff(pred_def_76386,type,
    v128755: state_type > $o ).

tff(pred_def_76387,type,
    v128753: state_type > $o ).

tff(pred_def_76388,type,
    v128752: state_type > $o ).

tff(pred_def_76389,type,
    v128751: ( state_type * $int ) > $o ).

tff(pred_def_76390,type,
    v128759: state_type > $o ).

tff(pred_def_76391,type,
    v128760: state_type > $o ).

tff(pred_def_76392,type,
    v128657: state_type > $o ).

tff(pred_def_76393,type,
    v128773: state_type > $o ).

tff(pred_def_76394,type,
    v128771: state_type > $o ).

tff(pred_def_76395,type,
    v128777: state_type > $o ).

tff(pred_def_76396,type,
    v128775: state_type > $o ).

tff(pred_def_76397,type,
    v128789: state_type > $o ).

tff(pred_def_76398,type,
    v128787: state_type > $o ).

tff(pred_def_76399,type,
    v128794: state_type > $o ).

tff(pred_def_76400,type,
    v128795: state_type > $o ).

tff(pred_def_76401,type,
    v128793: state_type > $o ).

tff(pred_def_76402,type,
    v128797: state_type > $o ).

tff(pred_def_76403,type,
    v128796: state_type > $o ).

tff(pred_def_76404,type,
    v128791: state_type > $o ).

tff(pred_def_76405,type,
    v128800: state_type > $o ).

tff(pred_def_76406,type,
    v128799: state_type > $o ).

tff(pred_def_76407,type,
    v128765: ( state_type * $int ) > $o ).

tff(pred_def_76408,type,
    v128806: state_type > $o ).

tff(pred_def_76409,type,
    v128805: state_type > $o ).

tff(pred_def_76410,type,
    v128807: state_type > $o ).

tff(pred_def_76411,type,
    v128804: state_type > $o ).

tff(pred_def_76412,type,
    v128808: state_type > $o ).

tff(pred_def_76413,type,
    v128803: state_type > $o ).

tff(pred_def_76414,type,
    v128811: state_type > $o ).

tff(pred_def_76415,type,
    v128812: state_type > $o ).

tff(pred_def_76416,type,
    v128810: state_type > $o ).

tff(pred_def_76417,type,
    v128813: state_type > $o ).

tff(pred_def_76418,type,
    v128809: state_type > $o ).

tff(pred_def_76419,type,
    v128801: ( state_type * $int ) > $o ).

tff(pred_def_76420,type,
    v128816: state_type > $o ).

tff(pred_def_76421,type,
    v128815: state_type > $o ).

tff(pred_def_76422,type,
    v128823: state_type > $o ).

tff(pred_def_76423,type,
    v128822: state_type > $o ).

tff(pred_def_76424,type,
    v128821: state_type > $o ).

tff(pred_def_76425,type,
    v128820: state_type > $o ).

tff(pred_def_76426,type,
    v128824: state_type > $o ).

tff(pred_def_76427,type,
    v128819: state_type > $o ).

tff(pred_def_76428,type,
    v128826: state_type > $o ).

tff(pred_def_76429,type,
    v128827: state_type > $o ).

tff(pred_def_76430,type,
    v128825: state_type > $o ).

tff(pred_def_76431,type,
    v128817: ( state_type * $int ) > $o ).

tff(pred_def_76432,type,
    v128814: ( state_type * $int ) > $o ).

tff(pred_def_76433,type,
    v128798: ( state_type * $int ) > $o ).

tff(pred_def_76434,type,
    v128785: ( state_type * $int ) > $o ).

tff(pred_def_76435,type,
    v128783: ( state_type * $int ) > $o ).

tff(pred_def_76436,type,
    v128829: state_type > $o ).

tff(pred_def_76437,type,
    v128833: state_type > $o ).

tff(pred_def_76438,type,
    v128832: ( state_type * $int ) > $o ).

tff(pred_def_76439,type,
    v128831: ( state_type * $int ) > $o ).

tff(pred_def_76440,type,
    v128830: ( state_type * $int ) > $o ).

tff(pred_def_76441,type,
    v128781: ( state_type * $int ) > $o ).

tff(pred_def_76442,type,
    v128779: ( state_type * $int ) > $o ).

tff(pred_def_76443,type,
    v128837: state_type > $o ).

tff(pred_def_76444,type,
    v128835: state_type > $o ).

tff(pred_def_76445,type,
    v128844: state_type > $o ).

tff(pred_def_76446,type,
    v128842: state_type > $o ).

tff(pred_def_76447,type,
    v128841: state_type > $o ).

tff(pred_def_76448,type,
    v128840: state_type > $o ).

tff(pred_def_76449,type,
    v128852: state_type > $o ).

tff(pred_def_76450,type,
    v128853: state_type > $o ).

tff(pred_def_76451,type,
    v128851: state_type > $o ).

tff(pred_def_76452,type,
    v128848: ( state_type * $int ) > $o ).

tff(pred_def_76453,type,
    v128850: ( state_type * $int ) > $o ).

tff(pred_def_76454,type,
    v128839: ( state_type * $int ) > $o ).

tff(pred_def_76455,type,
    v128769: ( state_type * $int ) > $o ).

tff(pred_def_76456,type,
    v128767: ( state_type * $int ) > $o ).

tff(pred_def_76457,type,
    v128861: state_type > $o ).

tff(pred_def_76458,type,
    v128859: state_type > $o ).

tff(pred_def_76459,type,
    v128858: state_type > $o ).

tff(pred_def_76460,type,
    v128857: ( state_type * $int ) > $o ).

tff(pred_def_76461,type,
    v128865: state_type > $o ).

tff(pred_def_76462,type,
    v128866: state_type > $o ).

tff(pred_def_76463,type,
    v128763: state_type > $o ).

tff(pred_def_76464,type,
    v128879: state_type > $o ).

tff(pred_def_76465,type,
    v128877: state_type > $o ).

tff(pred_def_76466,type,
    v128883: state_type > $o ).

tff(pred_def_76467,type,
    v128881: state_type > $o ).

tff(pred_def_76468,type,
    v128895: state_type > $o ).

tff(pred_def_76469,type,
    v128893: state_type > $o ).

tff(pred_def_76470,type,
    v128900: state_type > $o ).

tff(pred_def_76471,type,
    v128901: state_type > $o ).

tff(pred_def_76472,type,
    v128899: state_type > $o ).

tff(pred_def_76473,type,
    v128903: state_type > $o ).

tff(pred_def_76474,type,
    v128902: state_type > $o ).

tff(pred_def_76475,type,
    v128897: state_type > $o ).

tff(pred_def_76476,type,
    v128906: state_type > $o ).

tff(pred_def_76477,type,
    v128905: state_type > $o ).

tff(pred_def_76478,type,
    v128871: ( state_type * $int ) > $o ).

tff(pred_def_76479,type,
    v128912: state_type > $o ).

tff(pred_def_76480,type,
    v128911: state_type > $o ).

tff(pred_def_76481,type,
    v128913: state_type > $o ).

tff(pred_def_76482,type,
    v128910: state_type > $o ).

tff(pred_def_76483,type,
    v128914: state_type > $o ).

tff(pred_def_76484,type,
    v128909: state_type > $o ).

tff(pred_def_76485,type,
    v128917: state_type > $o ).

tff(pred_def_76486,type,
    v128918: state_type > $o ).

tff(pred_def_76487,type,
    v128916: state_type > $o ).

tff(pred_def_76488,type,
    v128919: state_type > $o ).

tff(pred_def_76489,type,
    v128915: state_type > $o ).

tff(pred_def_76490,type,
    v128907: ( state_type * $int ) > $o ).

tff(pred_def_76491,type,
    v128922: state_type > $o ).

tff(pred_def_76492,type,
    v128921: state_type > $o ).

tff(pred_def_76493,type,
    v128929: state_type > $o ).

tff(pred_def_76494,type,
    v128928: state_type > $o ).

tff(pred_def_76495,type,
    v128927: state_type > $o ).

tff(pred_def_76496,type,
    v128926: state_type > $o ).

tff(pred_def_76497,type,
    v128930: state_type > $o ).

tff(pred_def_76498,type,
    v128925: state_type > $o ).

tff(pred_def_76499,type,
    v128932: state_type > $o ).

tff(pred_def_76500,type,
    v128933: state_type > $o ).

tff(pred_def_76501,type,
    v128931: state_type > $o ).

tff(pred_def_76502,type,
    v128923: ( state_type * $int ) > $o ).

tff(pred_def_76503,type,
    v128920: ( state_type * $int ) > $o ).

tff(pred_def_76504,type,
    v128904: ( state_type * $int ) > $o ).

tff(pred_def_76505,type,
    v128891: ( state_type * $int ) > $o ).

tff(pred_def_76506,type,
    v128889: ( state_type * $int ) > $o ).

tff(pred_def_76507,type,
    v128935: state_type > $o ).

tff(pred_def_76508,type,
    v128939: state_type > $o ).

tff(pred_def_76509,type,
    v128938: ( state_type * $int ) > $o ).

tff(pred_def_76510,type,
    v128937: ( state_type * $int ) > $o ).

tff(pred_def_76511,type,
    v128936: ( state_type * $int ) > $o ).

tff(pred_def_76512,type,
    v128887: ( state_type * $int ) > $o ).

tff(pred_def_76513,type,
    v128885: ( state_type * $int ) > $o ).

tff(pred_def_76514,type,
    v128943: state_type > $o ).

tff(pred_def_76515,type,
    v128941: state_type > $o ).

tff(pred_def_76516,type,
    v128950: state_type > $o ).

tff(pred_def_76517,type,
    v128948: state_type > $o ).

tff(pred_def_76518,type,
    v128947: state_type > $o ).

tff(pred_def_76519,type,
    v128946: state_type > $o ).

tff(pred_def_76520,type,
    v128958: state_type > $o ).

tff(pred_def_76521,type,
    v128959: state_type > $o ).

tff(pred_def_76522,type,
    v128957: state_type > $o ).

tff(pred_def_76523,type,
    v128954: ( state_type * $int ) > $o ).

tff(pred_def_76524,type,
    v128956: ( state_type * $int ) > $o ).

tff(pred_def_76525,type,
    v128945: ( state_type * $int ) > $o ).

tff(pred_def_76526,type,
    v128875: ( state_type * $int ) > $o ).

tff(pred_def_76527,type,
    v128873: ( state_type * $int ) > $o ).

tff(pred_def_76528,type,
    v128967: state_type > $o ).

tff(pred_def_76529,type,
    v128965: state_type > $o ).

tff(pred_def_76530,type,
    v128964: state_type > $o ).

tff(pred_def_76531,type,
    v128963: ( state_type * $int ) > $o ).

tff(pred_def_76532,type,
    v128971: state_type > $o ).

tff(pred_def_76533,type,
    v128972: state_type > $o ).

tff(pred_def_76534,type,
    v128869: state_type > $o ).

tff(pred_def_76535,type,
    v128985: state_type > $o ).

tff(pred_def_76536,type,
    v128983: state_type > $o ).

tff(pred_def_76537,type,
    v128989: state_type > $o ).

tff(pred_def_76538,type,
    v128987: state_type > $o ).

tff(pred_def_76539,type,
    v129001: state_type > $o ).

tff(pred_def_76540,type,
    v128999: state_type > $o ).

tff(pred_def_76541,type,
    v129006: state_type > $o ).

tff(pred_def_76542,type,
    v129007: state_type > $o ).

tff(pred_def_76543,type,
    v129005: state_type > $o ).

tff(pred_def_76544,type,
    v129009: state_type > $o ).

tff(pred_def_76545,type,
    v129008: state_type > $o ).

tff(pred_def_76546,type,
    v129003: state_type > $o ).

tff(pred_def_76547,type,
    v129012: state_type > $o ).

tff(pred_def_76548,type,
    v129011: state_type > $o ).

tff(pred_def_76549,type,
    v128977: ( state_type * $int ) > $o ).

tff(pred_def_76550,type,
    v129018: state_type > $o ).

tff(pred_def_76551,type,
    v129017: state_type > $o ).

tff(pred_def_76552,type,
    v129019: state_type > $o ).

tff(pred_def_76553,type,
    v129016: state_type > $o ).

tff(pred_def_76554,type,
    v129020: state_type > $o ).

tff(pred_def_76555,type,
    v129015: state_type > $o ).

tff(pred_def_76556,type,
    v129023: state_type > $o ).

tff(pred_def_76557,type,
    v129024: state_type > $o ).

tff(pred_def_76558,type,
    v129022: state_type > $o ).

tff(pred_def_76559,type,
    v129025: state_type > $o ).

tff(pred_def_76560,type,
    v129021: state_type > $o ).

tff(pred_def_76561,type,
    v129013: ( state_type * $int ) > $o ).

tff(pred_def_76562,type,
    v129028: state_type > $o ).

tff(pred_def_76563,type,
    v129027: state_type > $o ).

tff(pred_def_76564,type,
    v129035: state_type > $o ).

tff(pred_def_76565,type,
    v129034: state_type > $o ).

tff(pred_def_76566,type,
    v129033: state_type > $o ).

tff(pred_def_76567,type,
    v129032: state_type > $o ).

tff(pred_def_76568,type,
    v129036: state_type > $o ).

tff(pred_def_76569,type,
    v129031: state_type > $o ).

tff(pred_def_76570,type,
    v129038: state_type > $o ).

tff(pred_def_76571,type,
    v129039: state_type > $o ).

tff(pred_def_76572,type,
    v129037: state_type > $o ).

tff(pred_def_76573,type,
    v129029: ( state_type * $int ) > $o ).

tff(pred_def_76574,type,
    v129026: ( state_type * $int ) > $o ).

tff(pred_def_76575,type,
    v129010: ( state_type * $int ) > $o ).

tff(pred_def_76576,type,
    v128997: ( state_type * $int ) > $o ).

tff(pred_def_76577,type,
    v128995: ( state_type * $int ) > $o ).

tff(pred_def_76578,type,
    v129041: state_type > $o ).

tff(pred_def_76579,type,
    v129045: state_type > $o ).

tff(pred_def_76580,type,
    v129044: ( state_type * $int ) > $o ).

tff(pred_def_76581,type,
    v129043: ( state_type * $int ) > $o ).

tff(pred_def_76582,type,
    v129042: ( state_type * $int ) > $o ).

tff(pred_def_76583,type,
    v128993: ( state_type * $int ) > $o ).

tff(pred_def_76584,type,
    v128991: ( state_type * $int ) > $o ).

tff(pred_def_76585,type,
    v129049: state_type > $o ).

tff(pred_def_76586,type,
    v129047: state_type > $o ).

tff(pred_def_76587,type,
    v129056: state_type > $o ).

tff(pred_def_76588,type,
    v129054: state_type > $o ).

tff(pred_def_76589,type,
    v129053: state_type > $o ).

tff(pred_def_76590,type,
    v129052: state_type > $o ).

tff(pred_def_76591,type,
    v129064: state_type > $o ).

tff(pred_def_76592,type,
    v129065: state_type > $o ).

tff(pred_def_76593,type,
    v129063: state_type > $o ).

tff(pred_def_76594,type,
    v129060: ( state_type * $int ) > $o ).

tff(pred_def_76595,type,
    v129062: ( state_type * $int ) > $o ).

tff(pred_def_76596,type,
    v129051: ( state_type * $int ) > $o ).

tff(pred_def_76597,type,
    v128981: ( state_type * $int ) > $o ).

tff(pred_def_76598,type,
    v128979: ( state_type * $int ) > $o ).

tff(pred_def_76599,type,
    v129073: state_type > $o ).

tff(pred_def_76600,type,
    v129071: state_type > $o ).

tff(pred_def_76601,type,
    v129070: state_type > $o ).

tff(pred_def_76602,type,
    v129069: ( state_type * $int ) > $o ).

tff(pred_def_76603,type,
    v129077: state_type > $o ).

tff(pred_def_76604,type,
    v129078: state_type > $o ).

tff(pred_def_76605,type,
    v128975: state_type > $o ).

tff(pred_def_76606,type,
    v129091: state_type > $o ).

tff(pred_def_76607,type,
    v129089: state_type > $o ).

tff(pred_def_76608,type,
    v129095: state_type > $o ).

tff(pred_def_76609,type,
    v129093: state_type > $o ).

tff(pred_def_76610,type,
    v129107: state_type > $o ).

tff(pred_def_76611,type,
    v129105: state_type > $o ).

tff(pred_def_76612,type,
    v129112: state_type > $o ).

tff(pred_def_76613,type,
    v129113: state_type > $o ).

tff(pred_def_76614,type,
    v129111: state_type > $o ).

tff(pred_def_76615,type,
    v129115: state_type > $o ).

tff(pred_def_76616,type,
    v129114: state_type > $o ).

tff(pred_def_76617,type,
    v129109: state_type > $o ).

tff(pred_def_76618,type,
    v129118: state_type > $o ).

tff(pred_def_76619,type,
    v129117: state_type > $o ).

tff(pred_def_76620,type,
    v129083: ( state_type * $int ) > $o ).

tff(pred_def_76621,type,
    v129124: state_type > $o ).

tff(pred_def_76622,type,
    v129123: state_type > $o ).

tff(pred_def_76623,type,
    v129125: state_type > $o ).

tff(pred_def_76624,type,
    v129122: state_type > $o ).

tff(pred_def_76625,type,
    v129126: state_type > $o ).

tff(pred_def_76626,type,
    v129121: state_type > $o ).

tff(pred_def_76627,type,
    v129129: state_type > $o ).

tff(pred_def_76628,type,
    v129130: state_type > $o ).

tff(pred_def_76629,type,
    v129128: state_type > $o ).

tff(pred_def_76630,type,
    v129131: state_type > $o ).

tff(pred_def_76631,type,
    v129127: state_type > $o ).

tff(pred_def_76632,type,
    v129119: ( state_type * $int ) > $o ).

tff(pred_def_76633,type,
    v129134: state_type > $o ).

tff(pred_def_76634,type,
    v129133: state_type > $o ).

tff(pred_def_76635,type,
    v129141: state_type > $o ).

tff(pred_def_76636,type,
    v129140: state_type > $o ).

tff(pred_def_76637,type,
    v129139: state_type > $o ).

tff(pred_def_76638,type,
    v129138: state_type > $o ).

tff(pred_def_76639,type,
    v129142: state_type > $o ).

tff(pred_def_76640,type,
    v129137: state_type > $o ).

tff(pred_def_76641,type,
    v129144: state_type > $o ).

tff(pred_def_76642,type,
    v129145: state_type > $o ).

tff(pred_def_76643,type,
    v129143: state_type > $o ).

tff(pred_def_76644,type,
    v129135: ( state_type * $int ) > $o ).

tff(pred_def_76645,type,
    v129132: ( state_type * $int ) > $o ).

tff(pred_def_76646,type,
    v129116: ( state_type * $int ) > $o ).

tff(pred_def_76647,type,
    v129103: ( state_type * $int ) > $o ).

tff(pred_def_76648,type,
    v129101: ( state_type * $int ) > $o ).

tff(pred_def_76649,type,
    v129147: state_type > $o ).

tff(pred_def_76650,type,
    v129151: state_type > $o ).

tff(pred_def_76651,type,
    v129150: ( state_type * $int ) > $o ).

tff(pred_def_76652,type,
    v129149: ( state_type * $int ) > $o ).

tff(pred_def_76653,type,
    v129148: ( state_type * $int ) > $o ).

tff(pred_def_76654,type,
    v129099: ( state_type * $int ) > $o ).

tff(pred_def_76655,type,
    v129097: ( state_type * $int ) > $o ).

tff(pred_def_76656,type,
    v129155: state_type > $o ).

tff(pred_def_76657,type,
    v129153: state_type > $o ).

tff(pred_def_76658,type,
    v129162: state_type > $o ).

tff(pred_def_76659,type,
    v129160: state_type > $o ).

tff(pred_def_76660,type,
    v129159: state_type > $o ).

tff(pred_def_76661,type,
    v129158: state_type > $o ).

tff(pred_def_76662,type,
    v129170: state_type > $o ).

tff(pred_def_76663,type,
    v129171: state_type > $o ).

tff(pred_def_76664,type,
    v129169: state_type > $o ).

tff(pred_def_76665,type,
    v129166: ( state_type * $int ) > $o ).

tff(pred_def_76666,type,
    v129168: ( state_type * $int ) > $o ).

tff(pred_def_76667,type,
    v129157: ( state_type * $int ) > $o ).

tff(pred_def_76668,type,
    v129087: ( state_type * $int ) > $o ).

tff(pred_def_76669,type,
    v129085: ( state_type * $int ) > $o ).

tff(pred_def_76670,type,
    v129179: state_type > $o ).

tff(pred_def_76671,type,
    v129177: state_type > $o ).

tff(pred_def_76672,type,
    v129176: state_type > $o ).

tff(pred_def_76673,type,
    v129175: ( state_type * $int ) > $o ).

tff(pred_def_76674,type,
    v129183: state_type > $o ).

tff(pred_def_76675,type,
    v129184: state_type > $o ).

tff(pred_def_76676,type,
    v129081: state_type > $o ).

tff(pred_def_76677,type,
    v129197: state_type > $o ).

tff(pred_def_76678,type,
    v129195: state_type > $o ).

tff(pred_def_76679,type,
    v129201: state_type > $o ).

tff(pred_def_76680,type,
    v129199: state_type > $o ).

tff(pred_def_76681,type,
    v129213: state_type > $o ).

tff(pred_def_76682,type,
    v129211: state_type > $o ).

tff(pred_def_76683,type,
    v129218: state_type > $o ).

tff(pred_def_76684,type,
    v129219: state_type > $o ).

tff(pred_def_76685,type,
    v129217: state_type > $o ).

tff(pred_def_76686,type,
    v129221: state_type > $o ).

tff(pred_def_76687,type,
    v129220: state_type > $o ).

tff(pred_def_76688,type,
    v129215: state_type > $o ).

tff(pred_def_76689,type,
    v129224: state_type > $o ).

tff(pred_def_76690,type,
    v129223: state_type > $o ).

tff(pred_def_76691,type,
    v129189: ( state_type * $int ) > $o ).

tff(pred_def_76692,type,
    v129230: state_type > $o ).

tff(pred_def_76693,type,
    v129229: state_type > $o ).

tff(pred_def_76694,type,
    v129231: state_type > $o ).

tff(pred_def_76695,type,
    v129228: state_type > $o ).

tff(pred_def_76696,type,
    v129232: state_type > $o ).

tff(pred_def_76697,type,
    v129227: state_type > $o ).

tff(pred_def_76698,type,
    v129235: state_type > $o ).

tff(pred_def_76699,type,
    v129236: state_type > $o ).

tff(pred_def_76700,type,
    v129234: state_type > $o ).

tff(pred_def_76701,type,
    v129237: state_type > $o ).

tff(pred_def_76702,type,
    v129233: state_type > $o ).

tff(pred_def_76703,type,
    v129225: ( state_type * $int ) > $o ).

tff(pred_def_76704,type,
    v129240: state_type > $o ).

tff(pred_def_76705,type,
    v129239: state_type > $o ).

tff(pred_def_76706,type,
    v129247: state_type > $o ).

tff(pred_def_76707,type,
    v129246: state_type > $o ).

tff(pred_def_76708,type,
    v129245: state_type > $o ).

tff(pred_def_76709,type,
    v129244: state_type > $o ).

tff(pred_def_76710,type,
    v129248: state_type > $o ).

tff(pred_def_76711,type,
    v129243: state_type > $o ).

tff(pred_def_76712,type,
    v129250: state_type > $o ).

tff(pred_def_76713,type,
    v129251: state_type > $o ).

tff(pred_def_76714,type,
    v129249: state_type > $o ).

tff(pred_def_76715,type,
    v129241: ( state_type * $int ) > $o ).

tff(pred_def_76716,type,
    v129238: ( state_type * $int ) > $o ).

tff(pred_def_76717,type,
    v129222: ( state_type * $int ) > $o ).

tff(pred_def_76718,type,
    v129209: ( state_type * $int ) > $o ).

tff(pred_def_76719,type,
    v129207: ( state_type * $int ) > $o ).

tff(pred_def_76720,type,
    v129253: state_type > $o ).

tff(pred_def_76721,type,
    v129257: state_type > $o ).

tff(pred_def_76722,type,
    v129256: ( state_type * $int ) > $o ).

tff(pred_def_76723,type,
    v129255: ( state_type * $int ) > $o ).

tff(pred_def_76724,type,
    v129254: ( state_type * $int ) > $o ).

tff(pred_def_76725,type,
    v129205: ( state_type * $int ) > $o ).

tff(pred_def_76726,type,
    v129203: ( state_type * $int ) > $o ).

tff(pred_def_76727,type,
    v129261: state_type > $o ).

tff(pred_def_76728,type,
    v129259: state_type > $o ).

tff(pred_def_76729,type,
    v129268: state_type > $o ).

tff(pred_def_76730,type,
    v129266: state_type > $o ).

tff(pred_def_76731,type,
    v129265: state_type > $o ).

tff(pred_def_76732,type,
    v129264: state_type > $o ).

tff(pred_def_76733,type,
    v129276: state_type > $o ).

tff(pred_def_76734,type,
    v129277: state_type > $o ).

tff(pred_def_76735,type,
    v129275: state_type > $o ).

tff(pred_def_76736,type,
    v129272: ( state_type * $int ) > $o ).

tff(pred_def_76737,type,
    v129274: ( state_type * $int ) > $o ).

tff(pred_def_76738,type,
    v129263: ( state_type * $int ) > $o ).

tff(pred_def_76739,type,
    v129193: ( state_type * $int ) > $o ).

tff(pred_def_76740,type,
    v129191: ( state_type * $int ) > $o ).

tff(pred_def_76741,type,
    v129285: state_type > $o ).

tff(pred_def_76742,type,
    v129283: state_type > $o ).

tff(pred_def_76743,type,
    v129282: state_type > $o ).

tff(pred_def_76744,type,
    v129281: ( state_type * $int ) > $o ).

tff(pred_def_76745,type,
    v129289: state_type > $o ).

tff(pred_def_76746,type,
    v129290: state_type > $o ).

tff(pred_def_76747,type,
    v129187: state_type > $o ).

tff(pred_def_76748,type,
    v129303: state_type > $o ).

tff(pred_def_76749,type,
    v129301: state_type > $o ).

tff(pred_def_76750,type,
    v129307: state_type > $o ).

tff(pred_def_76751,type,
    v129305: state_type > $o ).

tff(pred_def_76752,type,
    v129319: state_type > $o ).

tff(pred_def_76753,type,
    v129317: state_type > $o ).

tff(pred_def_76754,type,
    v129324: state_type > $o ).

tff(pred_def_76755,type,
    v129325: state_type > $o ).

tff(pred_def_76756,type,
    v129323: state_type > $o ).

tff(pred_def_76757,type,
    v129327: state_type > $o ).

tff(pred_def_76758,type,
    v129326: state_type > $o ).

tff(pred_def_76759,type,
    v129321: state_type > $o ).

tff(pred_def_76760,type,
    v129330: state_type > $o ).

tff(pred_def_76761,type,
    v129329: state_type > $o ).

tff(pred_def_76762,type,
    v129295: ( state_type * $int ) > $o ).

tff(pred_def_76763,type,
    v129336: state_type > $o ).

tff(pred_def_76764,type,
    v129335: state_type > $o ).

tff(pred_def_76765,type,
    v129337: state_type > $o ).

tff(pred_def_76766,type,
    v129334: state_type > $o ).

tff(pred_def_76767,type,
    v129338: state_type > $o ).

tff(pred_def_76768,type,
    v129333: state_type > $o ).

tff(pred_def_76769,type,
    v129341: state_type > $o ).

tff(pred_def_76770,type,
    v129342: state_type > $o ).

tff(pred_def_76771,type,
    v129340: state_type > $o ).

tff(pred_def_76772,type,
    v129343: state_type > $o ).

tff(pred_def_76773,type,
    v129339: state_type > $o ).

tff(pred_def_76774,type,
    v129331: ( state_type * $int ) > $o ).

tff(pred_def_76775,type,
    v129346: state_type > $o ).

tff(pred_def_76776,type,
    v129345: state_type > $o ).

tff(pred_def_76777,type,
    v129353: state_type > $o ).

tff(pred_def_76778,type,
    v129352: state_type > $o ).

tff(pred_def_76779,type,
    v129351: state_type > $o ).

tff(pred_def_76780,type,
    v129350: state_type > $o ).

tff(pred_def_76781,type,
    v129354: state_type > $o ).

tff(pred_def_76782,type,
    v129349: state_type > $o ).

tff(pred_def_76783,type,
    v129356: state_type > $o ).

tff(pred_def_76784,type,
    v129357: state_type > $o ).

tff(pred_def_76785,type,
    v129355: state_type > $o ).

tff(pred_def_76786,type,
    v129347: ( state_type * $int ) > $o ).

tff(pred_def_76787,type,
    v129344: ( state_type * $int ) > $o ).

tff(pred_def_76788,type,
    v129328: ( state_type * $int ) > $o ).

tff(pred_def_76789,type,
    v129315: ( state_type * $int ) > $o ).

tff(pred_def_76790,type,
    v129313: ( state_type * $int ) > $o ).

tff(pred_def_76791,type,
    v129359: state_type > $o ).

tff(pred_def_76792,type,
    v129363: state_type > $o ).

tff(pred_def_76793,type,
    v129362: ( state_type * $int ) > $o ).

tff(pred_def_76794,type,
    v129361: ( state_type * $int ) > $o ).

tff(pred_def_76795,type,
    v129360: ( state_type * $int ) > $o ).

tff(pred_def_76796,type,
    v129311: ( state_type * $int ) > $o ).

tff(pred_def_76797,type,
    v129309: ( state_type * $int ) > $o ).

tff(pred_def_76798,type,
    v129367: state_type > $o ).

tff(pred_def_76799,type,
    v129365: state_type > $o ).

tff(pred_def_76800,type,
    v129374: state_type > $o ).

tff(pred_def_76801,type,
    v129372: state_type > $o ).

tff(pred_def_76802,type,
    v129371: state_type > $o ).

tff(pred_def_76803,type,
    v129370: state_type > $o ).

tff(pred_def_76804,type,
    v129382: state_type > $o ).

tff(pred_def_76805,type,
    v129383: state_type > $o ).

tff(pred_def_76806,type,
    v129381: state_type > $o ).

tff(pred_def_76807,type,
    v129378: ( state_type * $int ) > $o ).

tff(pred_def_76808,type,
    v129380: ( state_type * $int ) > $o ).

tff(pred_def_76809,type,
    v129369: ( state_type * $int ) > $o ).

tff(pred_def_76810,type,
    v129299: ( state_type * $int ) > $o ).

tff(pred_def_76811,type,
    v129297: ( state_type * $int ) > $o ).

tff(pred_def_76812,type,
    v129391: state_type > $o ).

tff(pred_def_76813,type,
    v129389: state_type > $o ).

tff(pred_def_76814,type,
    v129388: state_type > $o ).

tff(pred_def_76815,type,
    v129387: ( state_type * $int ) > $o ).

tff(pred_def_76816,type,
    v129395: state_type > $o ).

tff(pred_def_76817,type,
    v129396: state_type > $o ).

tff(pred_def_76818,type,
    v129293: state_type > $o ).

tff(pred_def_76819,type,
    v129404: state_type > $o ).

tff(pred_def_76820,type,
    v129403: state_type > $o ).

tff(pred_def_76821,type,
    v129402: state_type > $o ).

tff(pred_def_76822,type,
    v129401: state_type > $o ).

tff(pred_def_76823,type,
    v129400: state_type > $o ).

tff(pred_def_76824,type,
    v129399: state_type > $o ).

tff(pred_def_76825,type,
    v97381: state_type > $o ).

tff(pred_def_76826,type,
    v129410: state_type > $o ).

tff(pred_def_76827,type,
    v129408: state_type > $o ).

tff(pred_def_76828,type,
    v129406: state_type > $o ).

tff(pred_def_76829,type,
    v129415: state_type > $o ).

tff(pred_def_76830,type,
    v129413: state_type > $o ).

tff(pred_def_76831,type,
    v129419: state_type > $o ).

tff(pred_def_76832,type,
    v129417: state_type > $o ).

tff(pred_def_76833,type,
    v129423: state_type > $o ).

tff(pred_def_76834,type,
    v129421: state_type > $o ).

tff(pred_def_76835,type,
    v129427: state_type > $o ).

tff(pred_def_76836,type,
    v129425: state_type > $o ).

tff(pred_def_76837,type,
    v129431: state_type > $o ).

tff(pred_def_76838,type,
    v129429: state_type > $o ).

tff(pred_def_76839,type,
    v129435: state_type > $o ).

tff(pred_def_76840,type,
    v129433: state_type > $o ).

tff(pred_def_76841,type,
    v129439: state_type > $o ).

tff(pred_def_76842,type,
    v129437: state_type > $o ).

tff(pred_def_76843,type,
    v129448: state_type > $o ).

tff(pred_def_76844,type,
    v129447: state_type > $o ).

tff(pred_def_76845,type,
    v129449: state_type > $o ).

tff(pred_def_76846,type,
    v129446: state_type > $o ).

tff(pred_def_76847,type,
    v129450: state_type > $o ).

tff(pred_def_76848,type,
    v129445: state_type > $o ).

tff(pred_def_76849,type,
    v129451: state_type > $o ).

tff(pred_def_76850,type,
    v129444: state_type > $o ).

tff(pred_def_76851,type,
    v129452: state_type > $o ).

tff(pred_def_76852,type,
    v129443: state_type > $o ).

tff(pred_def_76853,type,
    v129453: state_type > $o ).

tff(pred_def_76854,type,
    v129442: state_type > $o ).

tff(pred_def_76855,type,
    v129459: state_type > $o ).

tff(pred_def_76856,type,
    v129461: state_type > $o ).

tff(pred_def_76857,type,
    v129460: state_type > $o ).

tff(pred_def_76858,type,
    v129458: state_type > $o ).

tff(pred_def_76859,type,
    v129462: state_type > $o ).

tff(pred_def_76860,type,
    v129457: state_type > $o ).

tff(pred_def_76861,type,
    v129463: state_type > $o ).

tff(pred_def_76862,type,
    v129456: state_type > $o ).

tff(pred_def_76863,type,
    v129468: state_type > $o ).

tff(pred_def_76864,type,
    v129467: state_type > $o ).

tff(pred_def_76865,type,
    v129466: state_type > $o ).

tff(pred_def_76866,type,
    v129469: state_type > $o ).

tff(pred_def_76867,type,
    v129465: state_type > $o ).

tff(pred_def_76868,type,
    v129470: state_type > $o ).

tff(pred_def_76869,type,
    v129464: state_type > $o ).

tff(pred_def_76870,type,
    v129455: state_type > $o ).

tff(pred_def_76871,type,
    v97230: state_type > $o ).

tff(pred_def_76872,type,
    v129473: state_type > $o ).

tff(pred_def_76873,type,
    v129472: state_type > $o ).

tff(pred_def_76874,type,
    v129471: state_type > $o ).

tff(pred_def_76875,type,
    v129454: state_type > $o ).

tff(pred_def_76876,type,
    v129441: state_type > $o ).

tff(pred_def_76877,type,
    v129478: state_type > $o ).

tff(pred_def_76878,type,
    v129477: state_type > $o ).

tff(pred_def_76879,type,
    v129475: state_type > $o ).

tff(pred_def_76880,type,
    v129485: state_type > $o ).

tff(pred_def_76881,type,
    v129486: state_type > $o ).

tff(pred_def_76882,type,
    v129484: state_type > $o ).

tff(pred_def_76883,type,
    v129487: state_type > $o ).

tff(pred_def_76884,type,
    v129483: state_type > $o ).

tff(pred_def_76885,type,
    v129488: state_type > $o ).

tff(pred_def_76886,type,
    v129482: state_type > $o ).

tff(pred_def_76887,type,
    v129489: state_type > $o ).

tff(pred_def_76888,type,
    v129481: state_type > $o ).

tff(pred_def_76889,type,
    v129490: state_type > $o ).

tff(pred_def_76890,type,
    v129480: state_type > $o ).

tff(pred_def_76891,type,
    v129491: state_type > $o ).

tff(pred_def_76892,type,
    v129479: state_type > $o ).

tff(pred_def_76893,type,
    v129474: state_type > $o ).

tff(pred_def_76894,type,
    v97323: state_type > $o ).

tff(pred_def_76895,type,
    v129495: state_type > $o ).

tff(pred_def_76896,type,
    v129494: ( state_type * $int ) > $o ).

tff(pred_def_76897,type,
    v129493: ( state_type * $int ) > $o ).

tff(pred_def_76898,type,
    v129499: state_type > $o ).

tff(pred_def_76899,type,
    v129498: ( state_type * $int ) > $o ).

tff(pred_def_76900,type,
    v129497: ( state_type * $int ) > $o ).

tff(pred_def_76901,type,
    v97286: ( state_type * $int ) > $o ).

tff(pred_def_76902,type,
    v129496: ( state_type * $int ) > $o ).

tff(pred_def_76903,type,
    v97300: ( state_type * $int ) > $o ).

tff(pred_def_76904,type,
    v97298: ( state_type * $int ) > $o ).

tff(pred_def_76905,type,
    v129503: state_type > $o ).

tff(pred_def_76906,type,
    v129501: state_type > $o ).

tff(pred_def_76907,type,
    v129510: state_type > $o ).

tff(pred_def_76908,type,
    v129508: state_type > $o ).

tff(pred_def_76909,type,
    v129507: state_type > $o ).

tff(pred_def_76910,type,
    v129506: state_type > $o ).

tff(pred_def_76911,type,
    v129518: state_type > $o ).

tff(pred_def_76912,type,
    v129519: state_type > $o ).

tff(pred_def_76913,type,
    v129517: state_type > $o ).

tff(pred_def_76914,type,
    v129514: ( state_type * $int ) > $o ).

tff(pred_def_76915,type,
    v129516: ( state_type * $int ) > $o ).

tff(pred_def_76916,type,
    v97288: ( state_type * $int ) > $o ).

tff(pred_def_76917,type,
    v129524: state_type > $o ).

tff(pred_def_76918,type,
    v129523: state_type > $o ).

tff(pred_def_76919,type,
    v129526: state_type > $o ).

tff(pred_def_76920,type,
    v129525: state_type > $o ).

tff(pred_def_76921,type,
    v129528: state_type > $o ).

tff(pred_def_76922,type,
    v129534: state_type > $o ).

tff(pred_def_76923,type,
    v129532: state_type > $o ).

tff(pred_def_76924,type,
    v129531: state_type > $o ).

tff(pred_def_76925,type,
    v129530: ( state_type * $int ) > $o ).

tff(pred_def_76926,type,
    v129550: ( state_type * $int ) > $o ).

tff(pred_def_76927,type,
    v97186: ( state_type * $int ) > $o ).

tff(pred_def_76928,type,
    v129549: state_type > $o ).

tff(pred_def_76929,type,
    v129553: state_type > $o ).

tff(pred_def_76930,type,
    v129554: state_type > $o ).

tff(pred_def_76931,type,
    v129552: state_type > $o ).

tff(pred_def_76932,type,
    v129555: state_type > $o ).

tff(pred_def_76933,type,
    v129551: state_type > $o ).

tff(pred_def_76934,type,
    v129548: state_type > $o ).

tff(pred_def_76935,type,
    v129556: state_type > $o ).

tff(pred_def_76936,type,
    v129547: state_type > $o ).

tff(pred_def_76937,type,
    v129559: state_type > $o ).

tff(pred_def_76938,type,
    v129560: state_type > $o ).

tff(pred_def_76939,type,
    v129558: state_type > $o ).

tff(pred_def_76940,type,
    v129561: state_type > $o ).

tff(pred_def_76941,type,
    v129557: state_type > $o ).

tff(pred_def_76942,type,
    v129546: state_type > $o ).

tff(pred_def_76943,type,
    v129562: state_type > $o ).

tff(pred_def_76944,type,
    v129545: state_type > $o ).

tff(pred_def_76945,type,
    v129565: state_type > $o ).

tff(pred_def_76946,type,
    v129566: state_type > $o ).

tff(pred_def_76947,type,
    v129564: state_type > $o ).

tff(pred_def_76948,type,
    v129567: state_type > $o ).

tff(pred_def_76949,type,
    v129563: state_type > $o ).

tff(pred_def_76950,type,
    v129544: state_type > $o ).

tff(pred_def_76951,type,
    v129568: state_type > $o ).

tff(pred_def_76952,type,
    v129543: state_type > $o ).

tff(pred_def_76953,type,
    v129542: state_type > $o ).

tff(pred_def_76954,type,
    v129572: state_type > $o ).

tff(pred_def_76955,type,
    v129573: state_type > $o ).

tff(pred_def_76956,type,
    v129571: state_type > $o ).

tff(pred_def_76957,type,
    v129574: state_type > $o ).

tff(pred_def_76958,type,
    v129570: state_type > $o ).

tff(pred_def_76959,type,
    v129569: state_type > $o ).

tff(pred_def_76960,type,
    v129541: state_type > $o ).

tff(pred_def_76961,type,
    v129575: state_type > $o ).

tff(pred_def_76962,type,
    v129540: state_type > $o ).

tff(pred_def_76963,type,
    v129578: state_type > $o ).

tff(pred_def_76964,type,
    v129579: state_type > $o ).

tff(pred_def_76965,type,
    v129577: state_type > $o ).

tff(pred_def_76966,type,
    v129580: state_type > $o ).

tff(pred_def_76967,type,
    v129576: state_type > $o ).

tff(pred_def_76968,type,
    v129583: state_type > $o ).

tff(pred_def_76969,type,
    v129584: state_type > $o ).

tff(pred_def_76970,type,
    v129582: state_type > $o ).

tff(pred_def_76971,type,
    v129585: state_type > $o ).

tff(pred_def_76972,type,
    v129581: state_type > $o ).

tff(pred_def_76973,type,
    v129588: state_type > $o ).

tff(pred_def_76974,type,
    v129589: state_type > $o ).

tff(pred_def_76975,type,
    v129587: state_type > $o ).

tff(pred_def_76976,type,
    v129590: state_type > $o ).

tff(pred_def_76977,type,
    v129586: state_type > $o ).

tff(pred_def_76978,type,
    v129593: state_type > $o ).

tff(pred_def_76979,type,
    v129594: state_type > $o ).

tff(pred_def_76980,type,
    v129592: state_type > $o ).

tff(pred_def_76981,type,
    v129595: state_type > $o ).

tff(pred_def_76982,type,
    v129591: state_type > $o ).

tff(pred_def_76983,type,
    v129538: ( state_type * $int ) > $o ).

tff(pred_def_76984,type,
    v129537: ( state_type * $int ) > $o ).

tff(pred_def_76985,type,
    v97206: ( state_type * $int ) > $o ).

tff(pred_def_76986,type,
    v97204: ( state_type * $int ) > $o ).

tff(pred_def_76987,type,
    v97202: ( state_type * $int ) > $o ).

tff(pred_def_76988,type,
    v97200: ( state_type * $int ) > $o ).

tff(pred_def_76989,type,
    v129599: state_type > $o ).

tff(pred_def_76990,type,
    v129597: state_type > $o ).

tff(pred_def_76991,type,
    v129606: state_type > $o ).

tff(pred_def_76992,type,
    v129604: state_type > $o ).

tff(pred_def_76993,type,
    v129603: state_type > $o ).

tff(pred_def_76994,type,
    v129602: state_type > $o ).

tff(pred_def_76995,type,
    v129614: state_type > $o ).

tff(pred_def_76996,type,
    v129615: state_type > $o ).

tff(pred_def_76997,type,
    v129613: state_type > $o ).

tff(pred_def_76998,type,
    v129610: ( state_type * $int ) > $o ).

tff(pred_def_76999,type,
    v129612: ( state_type * $int ) > $o ).

tff(pred_def_77000,type,
    v129601: ( state_type * $int ) > $o ).

tff(pred_def_77001,type,
    v97190: ( state_type * $int ) > $o ).

tff(pred_def_77002,type,
    v97188: ( state_type * $int ) > $o ).

tff(pred_def_77003,type,
    v129620: state_type > $o ).

tff(pred_def_77004,type,
    v129619: state_type > $o ).

tff(pred_def_77005,type,
    v129622: state_type > $o ).

tff(pred_def_77006,type,
    v129630: state_type > $o ).

tff(pred_def_77007,type,
    v129629: state_type > $o ).

tff(pred_def_77008,type,
    v129628: state_type > $o ).

tff(pred_def_77009,type,
    v129627: state_type > $o ).

tff(pred_def_77010,type,
    v129631: state_type > $o ).

tff(pred_def_77011,type,
    v129626: state_type > $o ).

tff(pred_def_77012,type,
    v129632: state_type > $o ).

tff(pred_def_77013,type,
    v129625: state_type > $o ).

tff(pred_def_77014,type,
    v129635: state_type > $o ).

tff(pred_def_77015,type,
    v129636: state_type > $o ).

tff(pred_def_77016,type,
    v129634: state_type > $o ).

tff(pred_def_77017,type,
    v129637: state_type > $o ).

tff(pred_def_77018,type,
    v129633: state_type > $o ).

tff(pred_def_77019,type,
    v129640: state_type > $o ).

tff(pred_def_77020,type,
    v129641: state_type > $o ).

tff(pred_def_77021,type,
    v129639: state_type > $o ).

tff(pred_def_77022,type,
    v129642: state_type > $o ).

tff(pred_def_77023,type,
    v129638: state_type > $o ).

tff(pred_def_77024,type,
    v129645: state_type > $o ).

tff(pred_def_77025,type,
    v129646: state_type > $o ).

tff(pred_def_77026,type,
    v129644: state_type > $o ).

tff(pred_def_77027,type,
    v129647: state_type > $o ).

tff(pred_def_77028,type,
    v129643: state_type > $o ).

tff(pred_def_77029,type,
    v129623: ( state_type * $int ) > $o ).

tff(pred_def_77030,type,
    v129621: ( state_type * $int ) > $o ).

tff(pred_def_77031,type,
    v97252: ( state_type * $int ) > $o ).

tff(pred_def_77032,type,
    v97250: ( state_type * $int ) > $o ).

tff(pred_def_77033,type,
    v97248: ( state_type * $int ) > $o ).

tff(pred_def_77034,type,
    v97246: ( state_type * $int ) > $o ).

tff(pred_def_77035,type,
    v129651: state_type > $o ).

tff(pred_def_77036,type,
    v129649: state_type > $o ).

tff(pred_def_77037,type,
    v129658: state_type > $o ).

tff(pred_def_77038,type,
    v129656: state_type > $o ).

tff(pred_def_77039,type,
    v129655: state_type > $o ).

tff(pred_def_77040,type,
    v129654: state_type > $o ).

tff(pred_def_77041,type,
    v129666: state_type > $o ).

tff(pred_def_77042,type,
    v129667: state_type > $o ).

tff(pred_def_77043,type,
    v129665: state_type > $o ).

tff(pred_def_77044,type,
    v129662: ( state_type * $int ) > $o ).

tff(pred_def_77045,type,
    v129664: ( state_type * $int ) > $o ).

tff(pred_def_77046,type,
    v97236: ( state_type * $int ) > $o ).

tff(pred_def_77047,type,
    v97234: ( state_type * $int ) > $o ).

tff(pred_def_77048,type,
    v129672: state_type > $o ).

tff(pred_def_77049,type,
    v97228: state_type > $o ).

tff(pred_def_77050,type,
    v97226: state_type > $o ).

tff(pred_def_77051,type,
    v97224: state_type > $o ).

tff(pred_def_77052,type,
    v97222: state_type > $o ).

tff(pred_def_77053,type,
    v129676: state_type > $o ).

tff(pred_def_77054,type,
    v129674: state_type > $o ).

tff(pred_def_77055,type,
    v129683: state_type > $o ).

tff(pred_def_77056,type,
    v129681: state_type > $o ).

tff(pred_def_77057,type,
    v129680: state_type > $o ).

tff(pred_def_77058,type,
    v129679: state_type > $o ).

tff(pred_def_77059,type,
    v129691: state_type > $o ).

tff(pred_def_77060,type,
    v129692: state_type > $o ).

tff(pred_def_77061,type,
    v129690: state_type > $o ).

tff(pred_def_77062,type,
    v129687: state_type > $o ).

tff(pred_def_77063,type,
    v129689: state_type > $o ).

tff(pred_def_77064,type,
    v97212: state_type > $o ).

tff(pred_def_77065,type,
    v97210: state_type > $o ).

tff(pred_def_77066,type,
    v129700: state_type > $o ).

tff(pred_def_77067,type,
    v129698: state_type > $o ).

tff(pred_def_77068,type,
    v129697: state_type > $o ).

tff(pred_def_77069,type,
    v129696: ( state_type * $int ) > $o ).

tff(pred_def_77070,type,
    v129720: state_type > $o ).

tff(pred_def_77071,type,
    v129719: ( state_type * $int ) > $o ).

tff(pred_def_77072,type,
    v129718: ( state_type * $int ) > $o ).

tff(pred_def_77073,type,
    v129723: state_type > $o ).

tff(pred_def_77074,type,
    v129722: ( state_type * $int ) > $o ).

tff(pred_def_77075,type,
    v129721: ( state_type * $int ) > $o ).

tff(pred_def_77076,type,
    v129717: ( state_type * $int ) > $o ).

tff(pred_def_77077,type,
    v129726: state_type > $o ).

tff(pred_def_77078,type,
    v129725: ( state_type * $int ) > $o ).

tff(pred_def_77079,type,
    v129724: ( state_type * $int ) > $o ).

tff(pred_def_77080,type,
    v129716: ( state_type * $int ) > $o ).

tff(pred_def_77081,type,
    v129729: state_type > $o ).

tff(pred_def_77082,type,
    v129728: ( state_type * $int ) > $o ).

tff(pred_def_77083,type,
    v129727: ( state_type * $int ) > $o ).

tff(pred_def_77084,type,
    v129715: ( state_type * $int ) > $o ).

tff(pred_def_77085,type,
    v129732: state_type > $o ).

tff(pred_def_77086,type,
    v129731: ( state_type * $int ) > $o ).

tff(pred_def_77087,type,
    v129730: ( state_type * $int ) > $o ).

tff(pred_def_77088,type,
    v129714: ( state_type * $int ) > $o ).

tff(pred_def_77089,type,
    v129735: state_type > $o ).

tff(pred_def_77090,type,
    v129734: ( state_type * $int ) > $o ).

tff(pred_def_77091,type,
    v129733: ( state_type * $int ) > $o ).

tff(pred_def_77092,type,
    v129713: ( state_type * $int ) > $o ).

tff(pred_def_77093,type,
    v129738: state_type > $o ).

tff(pred_def_77094,type,
    v129737: ( state_type * $int ) > $o ).

tff(pred_def_77095,type,
    v129736: ( state_type * $int ) > $o ).

tff(pred_def_77096,type,
    v129712: ( state_type * $int ) > $o ).

tff(pred_def_77097,type,
    v129741: state_type > $o ).

tff(pred_def_77098,type,
    v129740: ( state_type * $int ) > $o ).

tff(pred_def_77099,type,
    v129739: ( state_type * $int ) > $o ).

tff(pred_def_77100,type,
    v129711: ( state_type * $int ) > $o ).

tff(pred_def_77101,type,
    v129744: state_type > $o ).

tff(pred_def_77102,type,
    v129743: ( state_type * $int ) > $o ).

tff(pred_def_77103,type,
    v129742: ( state_type * $int ) > $o ).

tff(pred_def_77104,type,
    v129710: ( state_type * $int ) > $o ).

tff(pred_def_77105,type,
    v129747: state_type > $o ).

tff(pred_def_77106,type,
    v129746: ( state_type * $int ) > $o ).

tff(pred_def_77107,type,
    v129745: ( state_type * $int ) > $o ).

tff(pred_def_77108,type,
    v129709: ( state_type * $int ) > $o ).

tff(pred_def_77109,type,
    v129750: state_type > $o ).

tff(pred_def_77110,type,
    v129749: ( state_type * $int ) > $o ).

tff(pred_def_77111,type,
    v129748: ( state_type * $int ) > $o ).

tff(pred_def_77112,type,
    v129708: ( state_type * $int ) > $o ).

tff(pred_def_77113,type,
    v129753: state_type > $o ).

tff(pred_def_77114,type,
    v129752: ( state_type * $int ) > $o ).

tff(pred_def_77115,type,
    v129751: ( state_type * $int ) > $o ).

tff(pred_def_77116,type,
    v129707: ( state_type * $int ) > $o ).

tff(pred_def_77117,type,
    v129756: state_type > $o ).

tff(pred_def_77118,type,
    v129755: ( state_type * $int ) > $o ).

tff(pred_def_77119,type,
    v129754: ( state_type * $int ) > $o ).

tff(pred_def_77120,type,
    v129706: ( state_type * $int ) > $o ).

tff(pred_def_77121,type,
    v129759: state_type > $o ).

tff(pred_def_77122,type,
    v129758: ( state_type * $int ) > $o ).

tff(pred_def_77123,type,
    v129757: ( state_type * $int ) > $o ).

tff(pred_def_77124,type,
    v129705: ( state_type * $int ) > $o ).

tff(pred_def_77125,type,
    v129762: state_type > $o ).

tff(pred_def_77126,type,
    v129761: ( state_type * $int ) > $o ).

tff(pred_def_77127,type,
    v129760: ( state_type * $int ) > $o ).

tff(pred_def_77128,type,
    v129704: ( state_type * $int ) > $o ).

tff(pred_def_77129,type,
    v129765: state_type > $o ).

tff(pred_def_77130,type,
    v129764: ( state_type * $int ) > $o ).

tff(pred_def_77131,type,
    v129763: ( state_type * $int ) > $o ).

tff(pred_def_77132,type,
    v129703: ( state_type * $int ) > $o ).

tff(pred_def_77133,type,
    v97184: ( state_type * $int ) > $o ).

tff(pred_def_77134,type,
    v129770: state_type > $o ).

tff(pred_def_77135,type,
    v129769: ( state_type * $int ) > $o ).

tff(pred_def_77136,type,
    v129768: ( state_type * $int ) > $o ).

tff(pred_def_77137,type,
    v129767: ( state_type * $int ) > $o ).

tff(pred_def_77138,type,
    v129775: state_type > $o ).

tff(pred_def_77139,type,
    v129776: state_type > $o ).

tff(pred_def_77140,type,
    v129777: state_type > $o ).

tff(pred_def_77141,type,
    v129778: state_type > $o ).

tff(pred_def_77142,type,
    v129779: state_type > $o ).

tff(pred_def_77143,type,
    v129780: state_type > $o ).

tff(pred_def_77144,type,
    v129781: state_type > $o ).

tff(pred_def_77145,type,
    v129782: state_type > $o ).

tff(pred_def_77146,type,
    v129774: ( state_type * $int ) > $o ).

tff(pred_def_77147,type,
    v129773: ( state_type * $int ) > $o ).

tff(pred_def_77148,type,
    v129801: ( state_type * $int ) > $o ).

tff(pred_def_77149,type,
    v129800: ( state_type * $int ) > $o ).

tff(pred_def_77150,type,
    v129803: ( state_type * $int ) > $o ).

tff(pred_def_77151,type,
    v129802: ( state_type * $int ) > $o ).

tff(pred_def_77152,type,
    v129799: ( state_type * $int ) > $o ).

tff(pred_def_77153,type,
    v129805: ( state_type * $int ) > $o ).

tff(pred_def_77154,type,
    v129804: ( state_type * $int ) > $o ).

tff(pred_def_77155,type,
    v129798: ( state_type * $int ) > $o ).

tff(pred_def_77156,type,
    v129807: ( state_type * $int ) > $o ).

tff(pred_def_77157,type,
    v129806: ( state_type * $int ) > $o ).

tff(pred_def_77158,type,
    v129797: ( state_type * $int ) > $o ).

tff(pred_def_77159,type,
    v129809: ( state_type * $int ) > $o ).

tff(pred_def_77160,type,
    v129808: ( state_type * $int ) > $o ).

tff(pred_def_77161,type,
    v129796: ( state_type * $int ) > $o ).

tff(pred_def_77162,type,
    v129811: ( state_type * $int ) > $o ).

tff(pred_def_77163,type,
    v129810: ( state_type * $int ) > $o ).

tff(pred_def_77164,type,
    v129795: ( state_type * $int ) > $o ).

tff(pred_def_77165,type,
    v129813: ( state_type * $int ) > $o ).

tff(pred_def_77166,type,
    v129812: ( state_type * $int ) > $o ).

tff(pred_def_77167,type,
    v129794: ( state_type * $int ) > $o ).

tff(pred_def_77168,type,
    v129815: ( state_type * $int ) > $o ).

tff(pred_def_77169,type,
    v129814: ( state_type * $int ) > $o ).

tff(pred_def_77170,type,
    v129793: ( state_type * $int ) > $o ).

tff(pred_def_77171,type,
    v129817: ( state_type * $int ) > $o ).

tff(pred_def_77172,type,
    v129816: ( state_type * $int ) > $o ).

tff(pred_def_77173,type,
    v129792: ( state_type * $int ) > $o ).

tff(pred_def_77174,type,
    v129819: ( state_type * $int ) > $o ).

tff(pred_def_77175,type,
    v129818: ( state_type * $int ) > $o ).

tff(pred_def_77176,type,
    v129791: ( state_type * $int ) > $o ).

tff(pred_def_77177,type,
    v129821: ( state_type * $int ) > $o ).

tff(pred_def_77178,type,
    v129820: ( state_type * $int ) > $o ).

tff(pred_def_77179,type,
    v129790: ( state_type * $int ) > $o ).

tff(pred_def_77180,type,
    v129823: ( state_type * $int ) > $o ).

tff(pred_def_77181,type,
    v129822: ( state_type * $int ) > $o ).

tff(pred_def_77182,type,
    v129789: ( state_type * $int ) > $o ).

tff(pred_def_77183,type,
    v129825: ( state_type * $int ) > $o ).

tff(pred_def_77184,type,
    v129824: ( state_type * $int ) > $o ).

tff(pred_def_77185,type,
    v129788: ( state_type * $int ) > $o ).

tff(pred_def_77186,type,
    v129827: ( state_type * $int ) > $o ).

tff(pred_def_77187,type,
    v129826: ( state_type * $int ) > $o ).

tff(pred_def_77188,type,
    v129787: ( state_type * $int ) > $o ).

tff(pred_def_77189,type,
    v129829: ( state_type * $int ) > $o ).

tff(pred_def_77190,type,
    v129828: ( state_type * $int ) > $o ).

tff(pred_def_77191,type,
    v129786: ( state_type * $int ) > $o ).

tff(pred_def_77192,type,
    v129831: ( state_type * $int ) > $o ).

tff(pred_def_77193,type,
    v129830: ( state_type * $int ) > $o ).

tff(pred_def_77194,type,
    v129785: ( state_type * $int ) > $o ).

tff(pred_def_77195,type,
    v129784: ( state_type * $int ) > $o ).

tff(pred_def_77196,type,
    v129835: state_type > $o ).

tff(pred_def_77197,type,
    v129836: state_type > $o ).

tff(pred_def_77198,type,
    v129837: state_type > $o ).

tff(pred_def_77199,type,
    v129838: state_type > $o ).

tff(pred_def_77200,type,
    v129839: state_type > $o ).

tff(pred_def_77201,type,
    v129840: state_type > $o ).

tff(pred_def_77202,type,
    v129841: state_type > $o ).

tff(pred_def_77203,type,
    v129842: state_type > $o ).

tff(pred_def_77204,type,
    v129834: ( state_type * $int ) > $o ).

tff(pred_def_77205,type,
    v129833: ( state_type * $int ) > $o ).

tff(pred_def_77206,type,
    v129846: state_type > $o ).

tff(pred_def_77207,type,
    v129847: state_type > $o ).

tff(pred_def_77208,type,
    v129848: state_type > $o ).

tff(pred_def_77209,type,
    v129849: state_type > $o ).

tff(pred_def_77210,type,
    v129850: state_type > $o ).

tff(pred_def_77211,type,
    v129851: state_type > $o ).

tff(pred_def_77212,type,
    v129852: state_type > $o ).

tff(pred_def_77213,type,
    v129853: state_type > $o ).

tff(pred_def_77214,type,
    v129845: ( state_type * $int ) > $o ).

tff(pred_def_77215,type,
    v129844: ( state_type * $int ) > $o ).

tff(pred_def_77216,type,
    v129860: state_type > $o ).

tff(pred_def_77217,type,
    v129861: state_type > $o ).

tff(pred_def_77218,type,
    v129859: state_type > $o ).

tff(pred_def_77219,type,
    v129858: state_type > $o ).

tff(pred_def_77220,type,
    v129857: ( state_type * $int ) > $o ).

tff(pred_def_77221,type,
    v129856: ( state_type * $int ) > $o ).

tff(pred_def_77222,type,
    v129866: state_type > $o ).

tff(pred_def_77223,type,
    v129867: state_type > $o ).

tff(pred_def_77224,type,
    v129865: state_type > $o ).

tff(pred_def_77225,type,
    v129864: state_type > $o ).

tff(pred_def_77226,type,
    v129863: ( state_type * $int ) > $o ).

tff(pred_def_77227,type,
    v129862: ( state_type * $int ) > $o ).

tff(pred_def_77228,type,
    v129855: ( state_type * $int ) > $o ).

tff(pred_def_77229,type,
    v129872: state_type > $o ).

tff(pred_def_77230,type,
    v129871: state_type > $o ).

tff(pred_def_77231,type,
    v129870: state_type > $o ).

tff(pred_def_77232,type,
    v129869: ( state_type * $int ) > $o ).

tff(pred_def_77233,type,
    v129868: ( state_type * $int ) > $o ).

tff(pred_def_77234,type,
    v129854: ( state_type * $int ) > $o ).

tff(pred_def_77235,type,
    v97182: ( state_type * $int ) > $o ).

tff(pred_def_77236,type,
    v129873: ( state_type * $int ) > $o ).

tff(pred_def_77237,type,
    v129875: state_type > $o ).

tff(pred_def_77238,type,
    v129874: ( state_type * $int ) > $o ).

tff(pred_def_77239,type,
    v89521: ( state_type * $int ) > $o ).

tff(pred_def_77240,type,
    v89519: ( state_type * $int ) > $o ).

tff(pred_def_77241,type,
    v89517: ( state_type * $int ) > $o ).

tff(pred_def_77242,type,
    v89515: ( state_type * $int ) > $o ).

tff(pred_def_77243,type,
    v129881: state_type > $o ).

tff(pred_def_77244,type,
    v129880: state_type > $o ).

tff(pred_def_77245,type,
    v129879: state_type > $o ).

tff(pred_def_77246,type,
    v129882: state_type > $o ).

tff(pred_def_77247,type,
    v129877: state_type > $o ).

tff(pred_def_77248,type,
    v129888: state_type > $o ).

tff(pred_def_77249,type,
    v129886: state_type > $o ).

tff(pred_def_77250,type,
    v129885: state_type > $o ).

tff(pred_def_77251,type,
    v129884: ( state_type * $int ) > $o ).

tff(pred_def_77252,type,
    v129896: state_type > $o ).

tff(pred_def_77253,type,
    v129897: state_type > $o ).

tff(pred_def_77254,type,
    v129895: state_type > $o ).

tff(pred_def_77255,type,
    v129894: state_type > $o ).

tff(pred_def_77256,type,
    v129898: state_type > $o ).

tff(pred_def_77257,type,
    v129892: state_type > $o ).

tff(pred_def_77258,type,
    v129904: state_type > $o ).

tff(pred_def_77259,type,
    v129902: state_type > $o ).

tff(pred_def_77260,type,
    v129901: state_type > $o ).

tff(pred_def_77261,type,
    v129900: ( state_type * $int ) > $o ).

tff(pred_def_77262,type,
    v129912: state_type > $o ).

tff(pred_def_77263,type,
    v129913: state_type > $o ).

tff(pred_def_77264,type,
    v129911: state_type > $o ).

tff(pred_def_77265,type,
    v129910: state_type > $o ).

tff(pred_def_77266,type,
    v129914: state_type > $o ).

tff(pred_def_77267,type,
    v129908: state_type > $o ).

tff(pred_def_77268,type,
    v129920: state_type > $o ).

tff(pred_def_77269,type,
    v129918: state_type > $o ).

tff(pred_def_77270,type,
    v129917: state_type > $o ).

tff(pred_def_77271,type,
    v129916: ( state_type * $int ) > $o ).

tff(pred_def_77272,type,
    v129928: state_type > $o ).

tff(pred_def_77273,type,
    v129929: state_type > $o ).

tff(pred_def_77274,type,
    v129927: state_type > $o ).

tff(pred_def_77275,type,
    v129926: state_type > $o ).

tff(pred_def_77276,type,
    v129930: state_type > $o ).

tff(pred_def_77277,type,
    v129924: state_type > $o ).

tff(pred_def_77278,type,
    v129936: state_type > $o ).

tff(pred_def_77279,type,
    v129934: state_type > $o ).

tff(pred_def_77280,type,
    v129933: state_type > $o ).

tff(pred_def_77281,type,
    v129932: ( state_type * $int ) > $o ).

tff(pred_def_77282,type,
    v129944: state_type > $o ).

tff(pred_def_77283,type,
    v129945: state_type > $o ).

tff(pred_def_77284,type,
    v129943: state_type > $o ).

tff(pred_def_77285,type,
    v129942: state_type > $o ).

tff(pred_def_77286,type,
    v129946: state_type > $o ).

tff(pred_def_77287,type,
    v129940: state_type > $o ).

tff(pred_def_77288,type,
    v129952: state_type > $o ).

tff(pred_def_77289,type,
    v129950: state_type > $o ).

tff(pred_def_77290,type,
    v129949: state_type > $o ).

tff(pred_def_77291,type,
    v129948: ( state_type * $int ) > $o ).

tff(pred_def_77292,type,
    v129960: state_type > $o ).

tff(pred_def_77293,type,
    v129961: state_type > $o ).

tff(pred_def_77294,type,
    v129959: state_type > $o ).

tff(pred_def_77295,type,
    v129958: state_type > $o ).

tff(pred_def_77296,type,
    v129962: state_type > $o ).

tff(pred_def_77297,type,
    v129956: state_type > $o ).

tff(pred_def_77298,type,
    v129968: state_type > $o ).

tff(pred_def_77299,type,
    v129966: state_type > $o ).

tff(pred_def_77300,type,
    v129965: state_type > $o ).

tff(pred_def_77301,type,
    v129964: ( state_type * $int ) > $o ).

tff(pred_def_77302,type,
    v129976: state_type > $o ).

tff(pred_def_77303,type,
    v129977: state_type > $o ).

tff(pred_def_77304,type,
    v129975: state_type > $o ).

tff(pred_def_77305,type,
    v129974: state_type > $o ).

tff(pred_def_77306,type,
    v129978: state_type > $o ).

tff(pred_def_77307,type,
    v129972: state_type > $o ).

tff(pred_def_77308,type,
    v129984: state_type > $o ).

tff(pred_def_77309,type,
    v129982: state_type > $o ).

tff(pred_def_77310,type,
    v129981: state_type > $o ).

tff(pred_def_77311,type,
    v129980: ( state_type * $int ) > $o ).

tff(pred_def_77312,type,
    v129988: state_type > $o ).

tff(pred_def_77313,type,
    v89439: ( state_type * $int ) > $o ).

tff(pred_def_77314,type,
    v129990: state_type > $o ).

tff(pred_def_77315,type,
    v129992: state_type > $o ).

tff(pred_def_77316,type,
    v129994: state_type > $o ).

tff(pred_def_77317,type,
    v129996: state_type > $o ).

tff(pred_def_77318,type,
    v129998: state_type > $o ).

tff(pred_def_77319,type,
    v130000: state_type > $o ).

tff(pred_def_77320,type,
    v130002: state_type > $o ).

tff(pred_def_77321,type,
    v89437: ( state_type * $int ) > $o ).

tff(pred_def_77322,type,
    v89435: ( state_type * $int ) > $o ).

tff(pred_def_77323,type,
    v89433: ( state_type * $int ) > $o ).

tff(pred_def_77324,type,
    v130006: state_type > $o ).

tff(pred_def_77325,type,
    v130004: state_type > $o ).

tff(pred_def_77326,type,
    v130013: state_type > $o ).

tff(pred_def_77327,type,
    v130011: state_type > $o ).

tff(pred_def_77328,type,
    v130010: state_type > $o ).

tff(pred_def_77329,type,
    v130009: state_type > $o ).

tff(pred_def_77330,type,
    v130021: state_type > $o ).

tff(pred_def_77331,type,
    v130022: state_type > $o ).

tff(pred_def_77332,type,
    v130020: state_type > $o ).

tff(pred_def_77333,type,
    v130017: ( state_type * $int ) > $o ).

tff(pred_def_77334,type,
    v130019: ( state_type * $int ) > $o ).

tff(pred_def_77335,type,
    v89423: ( state_type * $int ) > $o ).

tff(pred_def_77336,type,
    v89421: ( state_type * $int ) > $o ).

tff(pred_def_77337,type,
    v130034: state_type > $o ).

tff(pred_def_77338,type,
    v130032: state_type > $o ).

tff(pred_def_77339,type,
    v130038: state_type > $o ).

tff(pred_def_77340,type,
    v130036: state_type > $o ).

tff(pred_def_77341,type,
    v130056: state_type > $o ).

tff(pred_def_77342,type,
    v130057: state_type > $o ).

tff(pred_def_77343,type,
    v130058: state_type > $o ).

tff(pred_def_77344,type,
    v130059: state_type > $o ).

tff(pred_def_77345,type,
    v130060: state_type > $o ).

tff(pred_def_77346,type,
    v130061: state_type > $o ).

tff(pred_def_77347,type,
    v130062: state_type > $o ).

tff(pred_def_77348,type,
    v130063: state_type > $o ).

tff(pred_def_77349,type,
    v130055: ( state_type * $int ) > $o ).

tff(pred_def_77350,type,
    v130054: ( state_type * $int ) > $o ).

tff(pred_def_77351,type,
    v130067: state_type > $o ).

tff(pred_def_77352,type,
    v130068: state_type > $o ).

tff(pred_def_77353,type,
    v130069: state_type > $o ).

tff(pred_def_77354,type,
    v130070: state_type > $o ).

tff(pred_def_77355,type,
    v130071: state_type > $o ).

tff(pred_def_77356,type,
    v130072: state_type > $o ).

tff(pred_def_77357,type,
    v130073: state_type > $o ).

tff(pred_def_77358,type,
    v130074: state_type > $o ).

tff(pred_def_77359,type,
    v130066: ( state_type * $int ) > $o ).

tff(pred_def_77360,type,
    v130065: ( state_type * $int ) > $o ).

tff(pred_def_77361,type,
    v130080: state_type > $o ).

tff(pred_def_77362,type,
    v130079: state_type > $o ).

tff(pred_def_77363,type,
    v130078: ( state_type * $int ) > $o ).

tff(pred_def_77364,type,
    v130077: ( state_type * $int ) > $o ).

tff(pred_def_77365,type,
    v130084: state_type > $o ).

tff(pred_def_77366,type,
    v130083: state_type > $o ).

tff(pred_def_77367,type,
    v130082: ( state_type * $int ) > $o ).

tff(pred_def_77368,type,
    v130081: ( state_type * $int ) > $o ).

tff(pred_def_77369,type,
    v130076: ( state_type * $int ) > $o ).

tff(pred_def_77370,type,
    v130088: state_type > $o ).

tff(pred_def_77371,type,
    v130087: state_type > $o ).

tff(pred_def_77372,type,
    v130086: ( state_type * $int ) > $o ).

tff(pred_def_77373,type,
    v130085: ( state_type * $int ) > $o ).

tff(pred_def_77374,type,
    v130075: ( state_type * $int ) > $o ).

tff(pred_def_77375,type,
    v130052: ( state_type * $int ) > $o ).

tff(pred_def_77376,type,
    v130050: ( state_type * $int ) > $o ).

tff(pred_def_77377,type,
    v130048: ( state_type * $int ) > $o ).

tff(pred_def_77378,type,
    v130090: state_type > $o ).

tff(pred_def_77379,type,
    v130026: ( state_type * $int ) > $o ).

tff(pred_def_77380,type,
    v130046: ( state_type * $int ) > $o ).

tff(pred_def_77381,type,
    v130092: state_type > $o ).

tff(pred_def_77382,type,
    v130094: state_type > $o ).

tff(pred_def_77383,type,
    v130096: state_type > $o ).

tff(pred_def_77384,type,
    v130098: state_type > $o ).

tff(pred_def_77385,type,
    v130100: state_type > $o ).

tff(pred_def_77386,type,
    v130102: state_type > $o ).

tff(pred_def_77387,type,
    v130104: state_type > $o ).

tff(pred_def_77388,type,
    v130044: ( state_type * $int ) > $o ).

tff(pred_def_77389,type,
    v130042: ( state_type * $int ) > $o ).

tff(pred_def_77390,type,
    v130040: ( state_type * $int ) > $o ).

tff(pred_def_77391,type,
    v130108: state_type > $o ).

tff(pred_def_77392,type,
    v130106: state_type > $o ).

tff(pred_def_77393,type,
    v130115: state_type > $o ).

tff(pred_def_77394,type,
    v130113: state_type > $o ).

tff(pred_def_77395,type,
    v130112: state_type > $o ).

tff(pred_def_77396,type,
    v130111: state_type > $o ).

tff(pred_def_77397,type,
    v130123: state_type > $o ).

tff(pred_def_77398,type,
    v130124: state_type > $o ).

tff(pred_def_77399,type,
    v130122: state_type > $o ).

tff(pred_def_77400,type,
    v130119: ( state_type * $int ) > $o ).

tff(pred_def_77401,type,
    v130121: ( state_type * $int ) > $o ).

tff(pred_def_77402,type,
    v130030: ( state_type * $int ) > $o ).

tff(pred_def_77403,type,
    v130028: ( state_type * $int ) > $o ).

tff(pred_def_77404,type,
    v130128: ( state_type * $int ) > $o ).

tff(pred_def_77405,type,
    v89417: ( state_type * $int ) > $o ).

tff(pred_def_77406,type,
    v89415: ( state_type * $int ) > $o ).

tff(pred_def_77407,type,
    v130176: state_type > $o ).

tff(pred_def_77408,type,
    v130174: state_type > $o ).

tff(pred_def_77409,type,
    v130172: state_type > $o ).

tff(pred_def_77410,type,
    v130170: state_type > $o ).

tff(pred_def_77411,type,
    v130168: state_type > $o ).

tff(pred_def_77412,type,
    v130166: state_type > $o ).

tff(pred_def_77413,type,
    v130164: state_type > $o ).

tff(pred_def_77414,type,
    v130162: state_type > $o ).

tff(pred_def_77415,type,
    v130192: state_type > $o ).

tff(pred_def_77416,type,
    v130190: state_type > $o ).

tff(pred_def_77417,type,
    v130188: state_type > $o ).

tff(pred_def_77418,type,
    v130186: state_type > $o ).

tff(pred_def_77419,type,
    v130184: state_type > $o ).

tff(pred_def_77420,type,
    v130182: state_type > $o ).

tff(pred_def_77421,type,
    v130180: state_type > $o ).

tff(pred_def_77422,type,
    v130178: state_type > $o ).

tff(pred_def_77423,type,
    v130212: state_type > $o ).

tff(pred_def_77424,type,
    v130210: state_type > $o ).

tff(pred_def_77425,type,
    v130208: state_type > $o ).

tff(pred_def_77426,type,
    v130206: state_type > $o ).

tff(pred_def_77427,type,
    v130204: state_type > $o ).

tff(pred_def_77428,type,
    v130222: state_type > $o ).

tff(pred_def_77429,type,
    v130220: state_type > $o ).

tff(pred_def_77430,type,
    v130218: state_type > $o ).

tff(pred_def_77431,type,
    v130216: state_type > $o ).

tff(pred_def_77432,type,
    v130214: state_type > $o ).

tff(pred_def_77433,type,
    v130230: state_type > $o ).

tff(pred_def_77434,type,
    v130232: ( state_type * $int ) > $o ).

tff(pred_def_77435,type,
    v130228: ( state_type * $int ) > $o ).

tff(pred_def_77436,type,
    v130235: ( state_type * $int ) > $o ).

tff(pred_def_77437,type,
    v130234: ( state_type * $int ) > $o ).

tff(pred_def_77438,type,
    v130236: ( state_type * $int ) > $o ).

tff(pred_def_77439,type,
    v130237: ( state_type * $int ) > $o ).

tff(pred_def_77440,type,
    v130238: ( state_type * $int ) > $o ).

tff(pred_def_77441,type,
    v130226: ( state_type * $int ) > $o ).

tff(pred_def_77442,type,
    v130224: ( state_type * $int ) > $o ).

tff(pred_def_77443,type,
    v130252: state_type > $o ).

tff(pred_def_77444,type,
    v130250: state_type > $o ).

tff(pred_def_77445,type,
    v130248: state_type > $o ).

tff(pred_def_77446,type,
    v130246: state_type > $o ).

tff(pred_def_77447,type,
    v130264: state_type > $o ).

tff(pred_def_77448,type,
    v130262: state_type > $o ).

tff(pred_def_77449,type,
    v130260: state_type > $o ).

tff(pred_def_77450,type,
    v130258: state_type > $o ).

tff(pred_def_77451,type,
    v130256: state_type > $o ).

tff(pred_def_77452,type,
    v130254: state_type > $o ).

tff(pred_def_77453,type,
    v130266: state_type > $o ).

tff(pred_def_77454,type,
    v130244: state_type > $o ).

tff(pred_def_77455,type,
    v130242: state_type > $o ).

tff(pred_def_77456,type,
    v130240: state_type > $o ).

tff(pred_def_77457,type,
    v130273: state_type > $o ).

tff(pred_def_77458,type,
    v130271: state_type > $o ).

tff(pred_def_77459,type,
    v130270: state_type > $o ).

tff(pred_def_77460,type,
    v130269: state_type > $o ).

tff(pred_def_77461,type,
    v130281: state_type > $o ).

tff(pred_def_77462,type,
    v130282: state_type > $o ).

tff(pred_def_77463,type,
    v130280: state_type > $o ).

tff(pred_def_77464,type,
    v130277: ( state_type * $int ) > $o ).

tff(pred_def_77465,type,
    v130279: ( state_type * $int ) > $o ).

tff(pred_def_77466,type,
    v130268: ( state_type * $int ) > $o ).

tff(pred_def_77467,type,
    v130202: ( state_type * $int ) > $o ).

tff(pred_def_77468,type,
    v130200: ( state_type * $int ) > $o ).

tff(pred_def_77469,type,
    v130198: ( state_type * $int ) > $o ).

tff(pred_def_77470,type,
    v130286: ( state_type * $int ) > $o ).

tff(pred_def_77471,type,
    v130285: ( state_type * $int ) > $o ).

tff(pred_def_77472,type,
    v130287: ( state_type * $int ) > $o ).

tff(pred_def_77473,type,
    v130288: ( state_type * $int ) > $o ).

tff(pred_def_77474,type,
    v130289: ( state_type * $int ) > $o ).

tff(pred_def_77475,type,
    v130196: ( state_type * $int ) > $o ).

tff(pred_def_77476,type,
    v130194: ( state_type * $int ) > $o ).

tff(pred_def_77477,type,
    v130299: state_type > $o ).

tff(pred_def_77478,type,
    v130297: state_type > $o ).

tff(pred_def_77479,type,
    v130305: state_type > $o ).

tff(pred_def_77480,type,
    v130303: state_type > $o ).

tff(pred_def_77481,type,
    v130319: state_type > $o ).

tff(pred_def_77482,type,
    v130317: state_type > $o ).

tff(pred_def_77483,type,
    v130315: state_type > $o ).

tff(pred_def_77484,type,
    v130313: state_type > $o ).

tff(pred_def_77485,type,
    v130311: state_type > $o ).

tff(pred_def_77486,type,
    v130309: state_type > $o ).

tff(pred_def_77487,type,
    v130307: state_type > $o ).

tff(pred_def_77488,type,
    v130329: state_type > $o ).

tff(pred_def_77489,type,
    v130327: state_type > $o ).

tff(pred_def_77490,type,
    v130325: state_type > $o ).

tff(pred_def_77491,type,
    v130323: state_type > $o ).

tff(pred_def_77492,type,
    v130321: state_type > $o ).

tff(pred_def_77493,type,
    v130301: state_type > $o ).

tff(pred_def_77494,type,
    v130335: state_type > $o ).

tff(pred_def_77495,type,
    v130337: state_type > $o ).

tff(pred_def_77496,type,
    v130333: state_type > $o ).

tff(pred_def_77497,type,
    v130332: state_type > $o ).

tff(pred_def_77498,type,
    v130343: state_type > $o ).

tff(pred_def_77499,type,
    v130344: state_type > $o ).

tff(pred_def_77500,type,
    v130340: state_type > $o ).

tff(pred_def_77501,type,
    v130342: state_type > $o ).

tff(pred_def_77502,type,
    v130350: state_type > $o ).

tff(pred_def_77503,type,
    v130348: state_type > $o ).

tff(pred_def_77504,type,
    v130352: state_type > $o ).

tff(pred_def_77505,type,
    v130295: state_type > $o ).

tff(pred_def_77506,type,
    v130293: state_type > $o ).

tff(pred_def_77507,type,
    v130291: state_type > $o ).

tff(pred_def_77508,type,
    v130359: state_type > $o ).

tff(pred_def_77509,type,
    v130357: state_type > $o ).

tff(pred_def_77510,type,
    v130356: state_type > $o ).

tff(pred_def_77511,type,
    v130355: state_type > $o ).

tff(pred_def_77512,type,
    v130367: state_type > $o ).

tff(pred_def_77513,type,
    v130368: state_type > $o ).

tff(pred_def_77514,type,
    v130366: state_type > $o ).

tff(pred_def_77515,type,
    v130363: ( state_type * $int ) > $o ).

tff(pred_def_77516,type,
    v130365: ( state_type * $int ) > $o ).

tff(pred_def_77517,type,
    v130354: ( state_type * $int ) > $o ).

tff(pred_def_77518,type,
    v130160: ( state_type * $int ) > $o ).

tff(pred_def_77519,type,
    v130158: ( state_type * $int ) > $o ).

tff(pred_def_77520,type,
    v130156: ( state_type * $int ) > $o ).

tff(pred_def_77521,type,
    v130372: ( state_type * $int ) > $o ).

tff(pred_def_77522,type,
    v130371: ( state_type * $int ) > $o ).

tff(pred_def_77523,type,
    v130373: ( state_type * $int ) > $o ).

tff(pred_def_77524,type,
    v130374: ( state_type * $int ) > $o ).

tff(pred_def_77525,type,
    v130375: ( state_type * $int ) > $o ).

tff(pred_def_77526,type,
    v130154: ( state_type * $int ) > $o ).

tff(pred_def_77527,type,
    v130152: ( state_type * $int ) > $o ).

tff(pred_def_77528,type,
    v130407: state_type > $o ).

tff(pred_def_77529,type,
    v130411: state_type > $o ).

tff(pred_def_77530,type,
    v130410: state_type > $o ).

tff(pred_def_77531,type,
    v130408: state_type > $o ).

tff(pred_def_77532,type,
    v130406: state_type > $o ).

tff(pred_def_77533,type,
    v130404: state_type > $o ).

tff(pred_def_77534,type,
    v130416: state_type > $o ).

tff(pred_def_77535,type,
    v130409: state_type > $o ).

tff(pred_def_77536,type,
    v130417: state_type > $o ).

tff(pred_def_77537,type,
    v130415: state_type > $o ).

tff(pred_def_77538,type,
    v130413: state_type > $o ).

tff(pred_def_77539,type,
    v130423: state_type > $o ).

tff(pred_def_77540,type,
    v130418: state_type > $o ).

tff(pred_def_77541,type,
    v130424: state_type > $o ).

tff(pred_def_77542,type,
    v130422: state_type > $o ).

tff(pred_def_77543,type,
    v130420: state_type > $o ).

tff(pred_def_77544,type,
    v130430: state_type > $o ).

tff(pred_def_77545,type,
    v130425: state_type > $o ).

tff(pred_def_77546,type,
    v130431: state_type > $o ).

tff(pred_def_77547,type,
    v130429: state_type > $o ).

tff(pred_def_77548,type,
    v130427: state_type > $o ).

tff(pred_def_77549,type,
    v130437: state_type > $o ).

tff(pred_def_77550,type,
    v130438: state_type > $o ).

tff(pred_def_77551,type,
    v130436: state_type > $o ).

tff(pred_def_77552,type,
    v130434: state_type > $o ).

tff(pred_def_77553,type,
    v130443: state_type > $o ).

tff(pred_def_77554,type,
    v130444: state_type > $o ).

tff(pred_def_77555,type,
    v130442: state_type > $o ).

tff(pred_def_77556,type,
    v130440: state_type > $o ).

tff(pred_def_77557,type,
    v130449: state_type > $o ).

tff(pred_def_77558,type,
    v130448: state_type > $o ).

tff(pred_def_77559,type,
    v130446: state_type > $o ).

tff(pred_def_77560,type,
    v130453: state_type > $o ).

tff(pred_def_77561,type,
    v130452: state_type > $o ).

tff(pred_def_77562,type,
    v130451: state_type > $o ).

tff(pred_def_77563,type,
    v130456: state_type > $o ).

tff(pred_def_77564,type,
    v130455: state_type > $o ).

tff(pred_def_77565,type,
    v130454: state_type > $o ).

tff(pred_def_77566,type,
    v130459: state_type > $o ).

tff(pred_def_77567,type,
    v130458: state_type > $o ).

tff(pred_def_77568,type,
    v130457: state_type > $o ).

tff(pred_def_77569,type,
    v130465: state_type > $o ).

tff(pred_def_77570,type,
    v130463: state_type > $o ).

tff(pred_def_77571,type,
    v130462: state_type > $o ).

tff(pred_def_77572,type,
    v130461: ( state_type * $int ) > $o ).

tff(pred_def_77573,type,
    v130469: state_type > $o ).

tff(pred_def_77574,type,
    v130470: state_type > $o ).

tff(pred_def_77575,type,
    v130471: state_type > $o ).

tff(pred_def_77576,type,
    v130472: state_type > $o ).

tff(pred_def_77577,type,
    v130473: state_type > $o ).

tff(pred_def_77578,type,
    v130474: state_type > $o ).

tff(pred_def_77579,type,
    v130475: state_type > $o ).

tff(pred_def_77580,type,
    v130476: state_type > $o ).

tff(pred_def_77581,type,
    v130468: ( state_type * $int ) > $o ).

tff(pred_def_77582,type,
    v130401: ( state_type * $int ) > $o ).

tff(pred_def_77583,type,
    v130484: state_type > $o ).

tff(pred_def_77584,type,
    v130482: state_type > $o ).

tff(pred_def_77585,type,
    v130481: state_type > $o ).

tff(pred_def_77586,type,
    v130480: ( state_type * $int ) > $o ).

tff(pred_def_77587,type,
    v130488: state_type > $o ).

tff(pred_def_77588,type,
    v130489: state_type > $o ).

tff(pred_def_77589,type,
    v130490: state_type > $o ).

tff(pred_def_77590,type,
    v130491: state_type > $o ).

tff(pred_def_77591,type,
    v130492: state_type > $o ).

tff(pred_def_77592,type,
    v130493: state_type > $o ).

tff(pred_def_77593,type,
    v130494: state_type > $o ).

tff(pred_def_77594,type,
    v130495: state_type > $o ).

tff(pred_def_77595,type,
    v130487: ( state_type * $int ) > $o ).

tff(pred_def_77596,type,
    v130478: ( state_type * $int ) > $o ).

tff(pred_def_77597,type,
    v130503: state_type > $o ).

tff(pred_def_77598,type,
    v130501: state_type > $o ).

tff(pred_def_77599,type,
    v130500: state_type > $o ).

tff(pred_def_77600,type,
    v130499: ( state_type * $int ) > $o ).

tff(pred_def_77601,type,
    v130507: state_type > $o ).

tff(pred_def_77602,type,
    v130508: state_type > $o ).

tff(pred_def_77603,type,
    v130509: state_type > $o ).

tff(pred_def_77604,type,
    v130510: state_type > $o ).

tff(pred_def_77605,type,
    v130511: state_type > $o ).

tff(pred_def_77606,type,
    v130512: state_type > $o ).

tff(pred_def_77607,type,
    v130513: state_type > $o ).

tff(pred_def_77608,type,
    v130514: state_type > $o ).

tff(pred_def_77609,type,
    v130506: ( state_type * $int ) > $o ).

tff(pred_def_77610,type,
    v130497: ( state_type * $int ) > $o ).

tff(pred_def_77611,type,
    v130522: state_type > $o ).

tff(pred_def_77612,type,
    v130520: state_type > $o ).

tff(pred_def_77613,type,
    v130519: state_type > $o ).

tff(pred_def_77614,type,
    v130518: ( state_type * $int ) > $o ).

tff(pred_def_77615,type,
    v130526: state_type > $o ).

tff(pred_def_77616,type,
    v130527: state_type > $o ).

tff(pred_def_77617,type,
    v130528: state_type > $o ).

tff(pred_def_77618,type,
    v130529: state_type > $o ).

tff(pred_def_77619,type,
    v130530: state_type > $o ).

tff(pred_def_77620,type,
    v130531: state_type > $o ).

tff(pred_def_77621,type,
    v130532: state_type > $o ).

tff(pred_def_77622,type,
    v130533: state_type > $o ).

tff(pred_def_77623,type,
    v130525: ( state_type * $int ) > $o ).

tff(pred_def_77624,type,
    v130516: ( state_type * $int ) > $o ).

tff(pred_def_77625,type,
    v130541: state_type > $o ).

tff(pred_def_77626,type,
    v130539: state_type > $o ).

tff(pred_def_77627,type,
    v130538: state_type > $o ).

tff(pred_def_77628,type,
    v130537: ( state_type * $int ) > $o ).

tff(pred_def_77629,type,
    v130545: state_type > $o ).

tff(pred_def_77630,type,
    v130546: state_type > $o ).

tff(pred_def_77631,type,
    v130547: state_type > $o ).

tff(pred_def_77632,type,
    v130548: state_type > $o ).

tff(pred_def_77633,type,
    v130549: state_type > $o ).

tff(pred_def_77634,type,
    v130550: state_type > $o ).

tff(pred_def_77635,type,
    v130551: state_type > $o ).

tff(pred_def_77636,type,
    v130552: state_type > $o ).

tff(pred_def_77637,type,
    v130544: ( state_type * $int ) > $o ).

tff(pred_def_77638,type,
    v130535: ( state_type * $int ) > $o ).

tff(pred_def_77639,type,
    v130560: state_type > $o ).

tff(pred_def_77640,type,
    v130558: state_type > $o ).

tff(pred_def_77641,type,
    v130557: state_type > $o ).

tff(pred_def_77642,type,
    v130556: ( state_type * $int ) > $o ).

tff(pred_def_77643,type,
    v130564: state_type > $o ).

tff(pred_def_77644,type,
    v130565: state_type > $o ).

tff(pred_def_77645,type,
    v130566: state_type > $o ).

tff(pred_def_77646,type,
    v130567: state_type > $o ).

tff(pred_def_77647,type,
    v130568: state_type > $o ).

tff(pred_def_77648,type,
    v130569: state_type > $o ).

tff(pred_def_77649,type,
    v130570: state_type > $o ).

tff(pred_def_77650,type,
    v130571: state_type > $o ).

tff(pred_def_77651,type,
    v130563: ( state_type * $int ) > $o ).

tff(pred_def_77652,type,
    v130554: ( state_type * $int ) > $o ).

tff(pred_def_77653,type,
    v130579: state_type > $o ).

tff(pred_def_77654,type,
    v130577: state_type > $o ).

tff(pred_def_77655,type,
    v130576: state_type > $o ).

tff(pred_def_77656,type,
    v130575: ( state_type * $int ) > $o ).

tff(pred_def_77657,type,
    v130583: state_type > $o ).

tff(pred_def_77658,type,
    v130584: state_type > $o ).

tff(pred_def_77659,type,
    v130585: state_type > $o ).

tff(pred_def_77660,type,
    v130586: state_type > $o ).

tff(pred_def_77661,type,
    v130587: state_type > $o ).

tff(pred_def_77662,type,
    v130588: state_type > $o ).

tff(pred_def_77663,type,
    v130589: state_type > $o ).

tff(pred_def_77664,type,
    v130590: state_type > $o ).

tff(pred_def_77665,type,
    v130582: ( state_type * $int ) > $o ).

tff(pred_def_77666,type,
    v130573: ( state_type * $int ) > $o ).

tff(pred_def_77667,type,
    v130598: state_type > $o ).

tff(pred_def_77668,type,
    v130596: state_type > $o ).

tff(pred_def_77669,type,
    v130595: state_type > $o ).

tff(pred_def_77670,type,
    v130594: ( state_type * $int ) > $o ).

tff(pred_def_77671,type,
    v130602: state_type > $o ).

tff(pred_def_77672,type,
    v130603: state_type > $o ).

tff(pred_def_77673,type,
    v130604: state_type > $o ).

tff(pred_def_77674,type,
    v130605: state_type > $o ).

tff(pred_def_77675,type,
    v130606: state_type > $o ).

tff(pred_def_77676,type,
    v130607: state_type > $o ).

tff(pred_def_77677,type,
    v130608: state_type > $o ).

tff(pred_def_77678,type,
    v130609: state_type > $o ).

tff(pred_def_77679,type,
    v130601: ( state_type * $int ) > $o ).

tff(pred_def_77680,type,
    v130592: ( state_type * $int ) > $o ).

tff(pred_def_77681,type,
    v130620: state_type > $o ).

tff(pred_def_77682,type,
    v130619: ( state_type * $int ) > $o ).

tff(pred_def_77683,type,
    v130618: ( state_type * $int ) > $o ).

tff(pred_def_77684,type,
    v130623: state_type > $o ).

tff(pred_def_77685,type,
    v130622: ( state_type * $int ) > $o ).

tff(pred_def_77686,type,
    v130621: ( state_type * $int ) > $o ).

tff(pred_def_77687,type,
    v130617: ( state_type * $int ) > $o ).

tff(pred_def_77688,type,
    v130626: state_type > $o ).

tff(pred_def_77689,type,
    v130625: ( state_type * $int ) > $o ).

tff(pred_def_77690,type,
    v130624: ( state_type * $int ) > $o ).

tff(pred_def_77691,type,
    v130616: ( state_type * $int ) > $o ).

tff(pred_def_77692,type,
    v130629: state_type > $o ).

tff(pred_def_77693,type,
    v130628: ( state_type * $int ) > $o ).

tff(pred_def_77694,type,
    v130627: ( state_type * $int ) > $o ).

tff(pred_def_77695,type,
    v130615: ( state_type * $int ) > $o ).

tff(pred_def_77696,type,
    v130632: state_type > $o ).

tff(pred_def_77697,type,
    v130631: ( state_type * $int ) > $o ).

tff(pred_def_77698,type,
    v130630: ( state_type * $int ) > $o ).

tff(pred_def_77699,type,
    v130614: ( state_type * $int ) > $o ).

tff(pred_def_77700,type,
    v130635: state_type > $o ).

tff(pred_def_77701,type,
    v130634: ( state_type * $int ) > $o ).

tff(pred_def_77702,type,
    v130633: ( state_type * $int ) > $o ).

tff(pred_def_77703,type,
    v130613: ( state_type * $int ) > $o ).

tff(pred_def_77704,type,
    v130638: state_type > $o ).

tff(pred_def_77705,type,
    v130637: ( state_type * $int ) > $o ).

tff(pred_def_77706,type,
    v130636: ( state_type * $int ) > $o ).

tff(pred_def_77707,type,
    v130612: ( state_type * $int ) > $o ).

tff(pred_def_77708,type,
    v130641: state_type > $o ).

tff(pred_def_77709,type,
    v130640: ( state_type * $int ) > $o ).

tff(pred_def_77710,type,
    v130639: ( state_type * $int ) > $o ).

tff(pred_def_77711,type,
    v130611: ( state_type * $int ) > $o ).

tff(pred_def_77712,type,
    v130644: state_type > $o ).

tff(pred_def_77713,type,
    v130643: state_type > $o ).

tff(pred_def_77714,type,
    v130642: ( state_type * $int ) > $o ).

tff(pred_def_77715,type,
    v130610: ( state_type * $int ) > $o ).

tff(pred_def_77716,type,
    v130399: ( state_type * $int ) > $o ).

tff(pred_def_77717,type,
    v130397: ( state_type * $int ) > $o ).

tff(pred_def_77718,type,
    v130395: ( state_type * $int ) > $o ).

tff(pred_def_77719,type,
    v130654: state_type > $o ).

tff(pred_def_77720,type,
    v130652: state_type > $o ).

tff(pred_def_77721,type,
    v130651: state_type > $o ).

tff(pred_def_77722,type,
    v130650: ( state_type * $int ) > $o ).

tff(pred_def_77723,type,
    v130662: state_type > $o ).

tff(pred_def_77724,type,
    v130660: state_type > $o ).

tff(pred_def_77725,type,
    v130659: state_type > $o ).

tff(pred_def_77726,type,
    v130658: ( state_type * $int ) > $o ).

tff(pred_def_77727,type,
    v130670: state_type > $o ).

tff(pred_def_77728,type,
    v130668: state_type > $o ).

tff(pred_def_77729,type,
    v130667: state_type > $o ).

tff(pred_def_77730,type,
    v130666: ( state_type * $int ) > $o ).

tff(pred_def_77731,type,
    v130678: state_type > $o ).

tff(pred_def_77732,type,
    v130676: state_type > $o ).

tff(pred_def_77733,type,
    v130675: state_type > $o ).

tff(pred_def_77734,type,
    v130674: ( state_type * $int ) > $o ).

tff(pred_def_77735,type,
    v130686: state_type > $o ).

tff(pred_def_77736,type,
    v130684: state_type > $o ).

tff(pred_def_77737,type,
    v130683: state_type > $o ).

tff(pred_def_77738,type,
    v130682: ( state_type * $int ) > $o ).

tff(pred_def_77739,type,
    v130694: state_type > $o ).

tff(pred_def_77740,type,
    v130692: state_type > $o ).

tff(pred_def_77741,type,
    v130691: state_type > $o ).

tff(pred_def_77742,type,
    v130690: ( state_type * $int ) > $o ).

tff(pred_def_77743,type,
    v130702: state_type > $o ).

tff(pred_def_77744,type,
    v130700: state_type > $o ).

tff(pred_def_77745,type,
    v130699: state_type > $o ).

tff(pred_def_77746,type,
    v130698: ( state_type * $int ) > $o ).

tff(pred_def_77747,type,
    v130710: state_type > $o ).

tff(pred_def_77748,type,
    v130708: state_type > $o ).

tff(pred_def_77749,type,
    v130707: state_type > $o ).

tff(pred_def_77750,type,
    v130706: ( state_type * $int ) > $o ).

tff(pred_def_77751,type,
    v130718: state_type > $o ).

tff(pred_def_77752,type,
    v130716: state_type > $o ).

tff(pred_def_77753,type,
    v130715: state_type > $o ).

tff(pred_def_77754,type,
    v130714: ( state_type * $int ) > $o ).

tff(pred_def_77755,type,
    v130726: state_type > $o ).

tff(pred_def_77756,type,
    v130724: state_type > $o ).

tff(pred_def_77757,type,
    v130723: state_type > $o ).

tff(pred_def_77758,type,
    v130722: ( state_type * $int ) > $o ).

tff(pred_def_77759,type,
    v130734: state_type > $o ).

tff(pred_def_77760,type,
    v130732: state_type > $o ).

tff(pred_def_77761,type,
    v130731: state_type > $o ).

tff(pred_def_77762,type,
    v130730: ( state_type * $int ) > $o ).

tff(pred_def_77763,type,
    v130742: state_type > $o ).

tff(pred_def_77764,type,
    v130740: state_type > $o ).

tff(pred_def_77765,type,
    v130739: state_type > $o ).

tff(pred_def_77766,type,
    v130738: ( state_type * $int ) > $o ).

tff(pred_def_77767,type,
    v130750: state_type > $o ).

tff(pred_def_77768,type,
    v130748: state_type > $o ).

tff(pred_def_77769,type,
    v130747: state_type > $o ).

tff(pred_def_77770,type,
    v130746: ( state_type * $int ) > $o ).

tff(pred_def_77771,type,
    v130758: state_type > $o ).

tff(pred_def_77772,type,
    v130756: state_type > $o ).

tff(pred_def_77773,type,
    v130755: state_type > $o ).

tff(pred_def_77774,type,
    v130754: ( state_type * $int ) > $o ).

tff(pred_def_77775,type,
    v130766: state_type > $o ).

tff(pred_def_77776,type,
    v130764: state_type > $o ).

tff(pred_def_77777,type,
    v130763: state_type > $o ).

tff(pred_def_77778,type,
    v130762: ( state_type * $int ) > $o ).

tff(pred_def_77779,type,
    v130774: state_type > $o ).

tff(pred_def_77780,type,
    v130772: state_type > $o ).

tff(pred_def_77781,type,
    v130771: state_type > $o ).

tff(pred_def_77782,type,
    v130770: ( state_type * $int ) > $o ).

tff(pred_def_77783,type,
    v130782: state_type > $o ).

tff(pred_def_77784,type,
    v130780: state_type > $o ).

tff(pred_def_77785,type,
    v130779: state_type > $o ).

tff(pred_def_77786,type,
    v130778: ( state_type * $int ) > $o ).

tff(pred_def_77787,type,
    v130790: state_type > $o ).

tff(pred_def_77788,type,
    v130788: state_type > $o ).

tff(pred_def_77789,type,
    v130787: state_type > $o ).

tff(pred_def_77790,type,
    v130786: ( state_type * $int ) > $o ).

tff(pred_def_77791,type,
    v130794: state_type > $o ).

tff(pred_def_77792,type,
    v130795: state_type > $o ).

tff(pred_def_77793,type,
    v130796: state_type > $o ).

tff(pred_def_77794,type,
    v130797: state_type > $o ).

tff(pred_def_77795,type,
    v130798: state_type > $o ).

tff(pred_def_77796,type,
    v130799: state_type > $o ).

tff(pred_def_77797,type,
    v130800: state_type > $o ).

tff(pred_def_77798,type,
    v130801: state_type > $o ).

tff(pred_def_77799,type,
    v130793: ( state_type * $int ) > $o ).

tff(pred_def_77800,type,
    v130646: ( state_type * $int ) > $o ).

tff(pred_def_77801,type,
    v130802: ( state_type * $int ) > $o ).

tff(pred_def_77802,type,
    v130393: ( state_type * $int ) > $o ).

tff(pred_def_77803,type,
    v130391: ( state_type * $int ) > $o ).

tff(pred_def_77804,type,
    v130389: ( state_type * $int ) > $o ).

tff(pred_def_77805,type,
    v130387: ( state_type * $int ) > $o ).

tff(pred_def_77806,type,
    v130385: state_type > $o ).

tff(pred_def_77807,type,
    v130383: state_type > $o ).

tff(pred_def_77808,type,
    v130381: state_type > $o ).

tff(pred_def_77809,type,
    v130379: state_type > $o ).

tff(pred_def_77810,type,
    v130377: state_type > $o ).

tff(pred_def_77811,type,
    v130822: state_type > $o ).

tff(pred_def_77812,type,
    v130820: state_type > $o ).

tff(pred_def_77813,type,
    v130818: state_type > $o ).

tff(pred_def_77814,type,
    v130816: state_type > $o ).

tff(pred_def_77815,type,
    v130814: state_type > $o ).

tff(pred_def_77816,type,
    v130832: state_type > $o ).

tff(pred_def_77817,type,
    v130830: state_type > $o ).

tff(pred_def_77818,type,
    v130828: state_type > $o ).

tff(pred_def_77819,type,
    v130826: state_type > $o ).

tff(pred_def_77820,type,
    v130824: state_type > $o ).

tff(pred_def_77821,type,
    v130837: ( state_type * $int ) > $o ).

tff(pred_def_77822,type,
    v130836: ( state_type * $int ) > $o ).

tff(pred_def_77823,type,
    v130834: ( state_type * $int ) > $o ).

tff(pred_def_77824,type,
    v130847: state_type > $o ).

tff(pred_def_77825,type,
    v130845: state_type > $o ).

tff(pred_def_77826,type,
    v130853: state_type > $o ).

tff(pred_def_77827,type,
    v130851: state_type > $o ).

tff(pred_def_77828,type,
    v130867: state_type > $o ).

tff(pred_def_77829,type,
    v130865: state_type > $o ).

tff(pred_def_77830,type,
    v130863: state_type > $o ).

tff(pred_def_77831,type,
    v130861: state_type > $o ).

tff(pred_def_77832,type,
    v130859: state_type > $o ).

tff(pred_def_77833,type,
    v130857: state_type > $o ).

tff(pred_def_77834,type,
    v130855: state_type > $o ).

tff(pred_def_77835,type,
    v130871: state_type > $o ).

tff(pred_def_77836,type,
    v130869: state_type > $o ).

tff(pred_def_77837,type,
    v130849: state_type > $o ).

tff(pred_def_77838,type,
    v130877: state_type > $o ).

tff(pred_def_77839,type,
    v130879: state_type > $o ).

tff(pred_def_77840,type,
    v130875: state_type > $o ).

tff(pred_def_77841,type,
    v130874: state_type > $o ).

tff(pred_def_77842,type,
    v130885: state_type > $o ).

tff(pred_def_77843,type,
    v130886: state_type > $o ).

tff(pred_def_77844,type,
    v130882: state_type > $o ).

tff(pred_def_77845,type,
    v130884: state_type > $o ).

tff(pred_def_77846,type,
    v130892: state_type > $o ).

tff(pred_def_77847,type,
    v130890: state_type > $o ).

tff(pred_def_77848,type,
    v130894: state_type > $o ).

tff(pred_def_77849,type,
    v130843: state_type > $o ).

tff(pred_def_77850,type,
    v130841: state_type > $o ).

tff(pred_def_77851,type,
    v130839: state_type > $o ).

tff(pred_def_77852,type,
    v130901: state_type > $o ).

tff(pred_def_77853,type,
    v130899: state_type > $o ).

tff(pred_def_77854,type,
    v130898: state_type > $o ).

tff(pred_def_77855,type,
    v130897: state_type > $o ).

tff(pred_def_77856,type,
    v130909: state_type > $o ).

tff(pred_def_77857,type,
    v130910: state_type > $o ).

tff(pred_def_77858,type,
    v130908: state_type > $o ).

tff(pred_def_77859,type,
    v130905: ( state_type * $int ) > $o ).

tff(pred_def_77860,type,
    v130907: ( state_type * $int ) > $o ).

tff(pred_def_77861,type,
    v130896: ( state_type * $int ) > $o ).

tff(pred_def_77862,type,
    v130812: ( state_type * $int ) > $o ).

tff(pred_def_77863,type,
    v130810: ( state_type * $int ) > $o ).

tff(pred_def_77864,type,
    v130808: ( state_type * $int ) > $o ).

tff(pred_def_77865,type,
    v130914: ( state_type * $int ) > $o ).

tff(pred_def_77866,type,
    v130913: ( state_type * $int ) > $o ).

tff(pred_def_77867,type,
    v130915: ( state_type * $int ) > $o ).

tff(pred_def_77868,type,
    v130916: ( state_type * $int ) > $o ).

tff(pred_def_77869,type,
    v130917: ( state_type * $int ) > $o ).

tff(pred_def_77870,type,
    v130806: ( state_type * $int ) > $o ).

tff(pred_def_77871,type,
    v130804: ( state_type * $int ) > $o ).

tff(pred_def_77872,type,
    v130927: state_type > $o ).

tff(pred_def_77873,type,
    v130925: state_type > $o ).

tff(pred_def_77874,type,
    v130923: state_type > $o ).

tff(pred_def_77875,type,
    v130921: state_type > $o ).

tff(pred_def_77876,type,
    v130919: state_type > $o ).

tff(pred_def_77877,type,
    v130947: state_type > $o ).

tff(pred_def_77878,type,
    v130945: state_type > $o ).

tff(pred_def_77879,type,
    v130943: state_type > $o ).

tff(pred_def_77880,type,
    v130941: state_type > $o ).

tff(pred_def_77881,type,
    v130939: state_type > $o ).

tff(pred_def_77882,type,
    v130957: state_type > $o ).

tff(pred_def_77883,type,
    v130955: state_type > $o ).

tff(pred_def_77884,type,
    v130953: state_type > $o ).

tff(pred_def_77885,type,
    v130951: state_type > $o ).

tff(pred_def_77886,type,
    v130949: state_type > $o ).

tff(pred_def_77887,type,
    v130962: ( state_type * $int ) > $o ).

tff(pred_def_77888,type,
    v130961: ( state_type * $int ) > $o ).

tff(pred_def_77889,type,
    v130959: ( state_type * $int ) > $o ).

tff(pred_def_77890,type,
    v130972: state_type > $o ).

tff(pred_def_77891,type,
    v130970: state_type > $o ).

tff(pred_def_77892,type,
    v130978: state_type > $o ).

tff(pred_def_77893,type,
    v130976: state_type > $o ).

tff(pred_def_77894,type,
    v130992: state_type > $o ).

tff(pred_def_77895,type,
    v130990: state_type > $o ).

tff(pred_def_77896,type,
    v130988: state_type > $o ).

tff(pred_def_77897,type,
    v130986: state_type > $o ).

tff(pred_def_77898,type,
    v130984: state_type > $o ).

tff(pred_def_77899,type,
    v130982: state_type > $o ).

tff(pred_def_77900,type,
    v130980: state_type > $o ).

tff(pred_def_77901,type,
    v130996: state_type > $o ).

tff(pred_def_77902,type,
    v130994: state_type > $o ).

tff(pred_def_77903,type,
    v130974: state_type > $o ).

tff(pred_def_77904,type,
    v131002: state_type > $o ).

tff(pred_def_77905,type,
    v131004: state_type > $o ).

tff(pred_def_77906,type,
    v131000: state_type > $o ).

tff(pred_def_77907,type,
    v130999: state_type > $o ).

tff(pred_def_77908,type,
    v131010: state_type > $o ).

tff(pred_def_77909,type,
    v131011: state_type > $o ).

tff(pred_def_77910,type,
    v131007: state_type > $o ).

tff(pred_def_77911,type,
    v131009: state_type > $o ).

tff(pred_def_77912,type,
    v131017: state_type > $o ).

tff(pred_def_77913,type,
    v131015: state_type > $o ).

tff(pred_def_77914,type,
    v131019: state_type > $o ).

tff(pred_def_77915,type,
    v130968: state_type > $o ).

tff(pred_def_77916,type,
    v130966: state_type > $o ).

tff(pred_def_77917,type,
    v130964: state_type > $o ).

tff(pred_def_77918,type,
    v131026: state_type > $o ).

tff(pred_def_77919,type,
    v131024: state_type > $o ).

tff(pred_def_77920,type,
    v131023: state_type > $o ).

tff(pred_def_77921,type,
    v131022: state_type > $o ).

tff(pred_def_77922,type,
    v131034: state_type > $o ).

tff(pred_def_77923,type,
    v131035: state_type > $o ).

tff(pred_def_77924,type,
    v131033: state_type > $o ).

tff(pred_def_77925,type,
    v131030: ( state_type * $int ) > $o ).

tff(pred_def_77926,type,
    v131032: ( state_type * $int ) > $o ).

tff(pred_def_77927,type,
    v131021: ( state_type * $int ) > $o ).

tff(pred_def_77928,type,
    v130937: ( state_type * $int ) > $o ).

tff(pred_def_77929,type,
    v130935: ( state_type * $int ) > $o ).

tff(pred_def_77930,type,
    v130933: ( state_type * $int ) > $o ).

tff(pred_def_77931,type,
    v131039: ( state_type * $int ) > $o ).

tff(pred_def_77932,type,
    v131038: ( state_type * $int ) > $o ).

tff(pred_def_77933,type,
    v131040: ( state_type * $int ) > $o ).

tff(pred_def_77934,type,
    v131041: ( state_type * $int ) > $o ).

tff(pred_def_77935,type,
    v131042: ( state_type * $int ) > $o ).

tff(pred_def_77936,type,
    v130931: ( state_type * $int ) > $o ).

tff(pred_def_77937,type,
    v130929: ( state_type * $int ) > $o ).

tff(pred_def_77938,type,
    v131052: state_type > $o ).

tff(pred_def_77939,type,
    v131050: state_type > $o ).

tff(pred_def_77940,type,
    v131048: state_type > $o ).

tff(pred_def_77941,type,
    v131046: state_type > $o ).

tff(pred_def_77942,type,
    v131044: state_type > $o ).

tff(pred_def_77943,type,
    v131072: state_type > $o ).

tff(pred_def_77944,type,
    v131070: state_type > $o ).

tff(pred_def_77945,type,
    v131068: state_type > $o ).

tff(pred_def_77946,type,
    v131066: state_type > $o ).

tff(pred_def_77947,type,
    v131064: state_type > $o ).

tff(pred_def_77948,type,
    v131082: state_type > $o ).

tff(pred_def_77949,type,
    v131080: state_type > $o ).

tff(pred_def_77950,type,
    v131078: state_type > $o ).

tff(pred_def_77951,type,
    v131076: state_type > $o ).

tff(pred_def_77952,type,
    v131074: state_type > $o ).

tff(pred_def_77953,type,
    v131087: ( state_type * $int ) > $o ).

tff(pred_def_77954,type,
    v131086: ( state_type * $int ) > $o ).

tff(pred_def_77955,type,
    v131084: ( state_type * $int ) > $o ).

tff(pred_def_77956,type,
    v131097: state_type > $o ).

tff(pred_def_77957,type,
    v131095: state_type > $o ).

tff(pred_def_77958,type,
    v131103: state_type > $o ).

tff(pred_def_77959,type,
    v131101: state_type > $o ).

tff(pred_def_77960,type,
    v131117: state_type > $o ).

tff(pred_def_77961,type,
    v131115: state_type > $o ).

tff(pred_def_77962,type,
    v131113: state_type > $o ).

tff(pred_def_77963,type,
    v131111: state_type > $o ).

tff(pred_def_77964,type,
    v131109: state_type > $o ).

tff(pred_def_77965,type,
    v131107: state_type > $o ).

tff(pred_def_77966,type,
    v131105: state_type > $o ).

tff(pred_def_77967,type,
    v131121: state_type > $o ).

tff(pred_def_77968,type,
    v131119: state_type > $o ).

tff(pred_def_77969,type,
    v131099: state_type > $o ).

tff(pred_def_77970,type,
    v131127: state_type > $o ).

tff(pred_def_77971,type,
    v131129: state_type > $o ).

tff(pred_def_77972,type,
    v131125: state_type > $o ).

tff(pred_def_77973,type,
    v131124: state_type > $o ).

tff(pred_def_77974,type,
    v131135: state_type > $o ).

tff(pred_def_77975,type,
    v131136: state_type > $o ).

tff(pred_def_77976,type,
    v131132: state_type > $o ).

tff(pred_def_77977,type,
    v131134: state_type > $o ).

tff(pred_def_77978,type,
    v131142: state_type > $o ).

tff(pred_def_77979,type,
    v131140: state_type > $o ).

tff(pred_def_77980,type,
    v131144: state_type > $o ).

tff(pred_def_77981,type,
    v131093: state_type > $o ).

tff(pred_def_77982,type,
    v131091: state_type > $o ).

tff(pred_def_77983,type,
    v131089: state_type > $o ).

tff(pred_def_77984,type,
    v131151: state_type > $o ).

tff(pred_def_77985,type,
    v131149: state_type > $o ).

tff(pred_def_77986,type,
    v131148: state_type > $o ).

tff(pred_def_77987,type,
    v131147: state_type > $o ).

tff(pred_def_77988,type,
    v131159: state_type > $o ).

tff(pred_def_77989,type,
    v131160: state_type > $o ).

tff(pred_def_77990,type,
    v131158: state_type > $o ).

tff(pred_def_77991,type,
    v131155: ( state_type * $int ) > $o ).

tff(pred_def_77992,type,
    v131157: ( state_type * $int ) > $o ).

tff(pred_def_77993,type,
    v131146: ( state_type * $int ) > $o ).

tff(pred_def_77994,type,
    v131062: ( state_type * $int ) > $o ).

tff(pred_def_77995,type,
    v131060: ( state_type * $int ) > $o ).

tff(pred_def_77996,type,
    v131058: ( state_type * $int ) > $o ).

tff(pred_def_77997,type,
    v131164: ( state_type * $int ) > $o ).

tff(pred_def_77998,type,
    v131163: ( state_type * $int ) > $o ).

tff(pred_def_77999,type,
    v131165: ( state_type * $int ) > $o ).

tff(pred_def_78000,type,
    v131166: ( state_type * $int ) > $o ).

tff(pred_def_78001,type,
    v131167: ( state_type * $int ) > $o ).

tff(pred_def_78002,type,
    v131056: ( state_type * $int ) > $o ).

tff(pred_def_78003,type,
    v131054: ( state_type * $int ) > $o ).

tff(pred_def_78004,type,
    v131177: state_type > $o ).

tff(pred_def_78005,type,
    v131175: state_type > $o ).

tff(pred_def_78006,type,
    v131173: state_type > $o ).

tff(pred_def_78007,type,
    v131171: state_type > $o ).

tff(pred_def_78008,type,
    v131169: state_type > $o ).

tff(pred_def_78009,type,
    v131197: state_type > $o ).

tff(pred_def_78010,type,
    v131195: state_type > $o ).

tff(pred_def_78011,type,
    v131193: state_type > $o ).

tff(pred_def_78012,type,
    v131191: state_type > $o ).

tff(pred_def_78013,type,
    v131189: state_type > $o ).

tff(pred_def_78014,type,
    v131207: state_type > $o ).

tff(pred_def_78015,type,
    v131205: state_type > $o ).

tff(pred_def_78016,type,
    v131203: state_type > $o ).

tff(pred_def_78017,type,
    v131201: state_type > $o ).

tff(pred_def_78018,type,
    v131199: state_type > $o ).

tff(pred_def_78019,type,
    v131212: ( state_type * $int ) > $o ).

tff(pred_def_78020,type,
    v131211: ( state_type * $int ) > $o ).

tff(pred_def_78021,type,
    v131209: ( state_type * $int ) > $o ).

tff(pred_def_78022,type,
    v131222: state_type > $o ).

tff(pred_def_78023,type,
    v131220: state_type > $o ).

tff(pred_def_78024,type,
    v131228: state_type > $o ).

tff(pred_def_78025,type,
    v131226: state_type > $o ).

tff(pred_def_78026,type,
    v131242: state_type > $o ).

tff(pred_def_78027,type,
    v131240: state_type > $o ).

tff(pred_def_78028,type,
    v131238: state_type > $o ).

tff(pred_def_78029,type,
    v131236: state_type > $o ).

tff(pred_def_78030,type,
    v131234: state_type > $o ).

tff(pred_def_78031,type,
    v131232: state_type > $o ).

tff(pred_def_78032,type,
    v131230: state_type > $o ).

tff(pred_def_78033,type,
    v131246: state_type > $o ).

tff(pred_def_78034,type,
    v131244: state_type > $o ).

tff(pred_def_78035,type,
    v131224: state_type > $o ).

tff(pred_def_78036,type,
    v131252: state_type > $o ).

tff(pred_def_78037,type,
    v131254: state_type > $o ).

tff(pred_def_78038,type,
    v131250: state_type > $o ).

tff(pred_def_78039,type,
    v131249: state_type > $o ).

tff(pred_def_78040,type,
    v131260: state_type > $o ).

tff(pred_def_78041,type,
    v131261: state_type > $o ).

tff(pred_def_78042,type,
    v131257: state_type > $o ).

tff(pred_def_78043,type,
    v131259: state_type > $o ).

tff(pred_def_78044,type,
    v131267: state_type > $o ).

tff(pred_def_78045,type,
    v131265: state_type > $o ).

tff(pred_def_78046,type,
    v131269: state_type > $o ).

tff(pred_def_78047,type,
    v131218: state_type > $o ).

tff(pred_def_78048,type,
    v131216: state_type > $o ).

tff(pred_def_78049,type,
    v131214: state_type > $o ).

tff(pred_def_78050,type,
    v131276: state_type > $o ).

tff(pred_def_78051,type,
    v131274: state_type > $o ).

tff(pred_def_78052,type,
    v131273: state_type > $o ).

tff(pred_def_78053,type,
    v131272: state_type > $o ).

tff(pred_def_78054,type,
    v131284: state_type > $o ).

tff(pred_def_78055,type,
    v131285: state_type > $o ).

tff(pred_def_78056,type,
    v131283: state_type > $o ).

tff(pred_def_78057,type,
    v131280: ( state_type * $int ) > $o ).

tff(pred_def_78058,type,
    v131282: ( state_type * $int ) > $o ).

tff(pred_def_78059,type,
    v131271: ( state_type * $int ) > $o ).

tff(pred_def_78060,type,
    v131187: ( state_type * $int ) > $o ).

tff(pred_def_78061,type,
    v131185: ( state_type * $int ) > $o ).

tff(pred_def_78062,type,
    v131183: ( state_type * $int ) > $o ).

tff(pred_def_78063,type,
    v131289: ( state_type * $int ) > $o ).

tff(pred_def_78064,type,
    v131288: ( state_type * $int ) > $o ).

tff(pred_def_78065,type,
    v131290: ( state_type * $int ) > $o ).

tff(pred_def_78066,type,
    v131291: ( state_type * $int ) > $o ).

tff(pred_def_78067,type,
    v131292: ( state_type * $int ) > $o ).

tff(pred_def_78068,type,
    v131181: ( state_type * $int ) > $o ).

tff(pred_def_78069,type,
    v131179: ( state_type * $int ) > $o ).

tff(pred_def_78070,type,
    v131302: state_type > $o ).

tff(pred_def_78071,type,
    v131300: state_type > $o ).

tff(pred_def_78072,type,
    v131298: state_type > $o ).

tff(pred_def_78073,type,
    v131296: state_type > $o ).

tff(pred_def_78074,type,
    v131294: state_type > $o ).

tff(pred_def_78075,type,
    v131322: state_type > $o ).

tff(pred_def_78076,type,
    v131320: state_type > $o ).

tff(pred_def_78077,type,
    v131318: state_type > $o ).

tff(pred_def_78078,type,
    v131316: state_type > $o ).

tff(pred_def_78079,type,
    v131314: state_type > $o ).

tff(pred_def_78080,type,
    v131332: state_type > $o ).

tff(pred_def_78081,type,
    v131330: state_type > $o ).

tff(pred_def_78082,type,
    v131328: state_type > $o ).

tff(pred_def_78083,type,
    v131326: state_type > $o ).

tff(pred_def_78084,type,
    v131324: state_type > $o ).

tff(pred_def_78085,type,
    v131337: ( state_type * $int ) > $o ).

tff(pred_def_78086,type,
    v131336: ( state_type * $int ) > $o ).

tff(pred_def_78087,type,
    v131334: ( state_type * $int ) > $o ).

tff(pred_def_78088,type,
    v131347: state_type > $o ).

tff(pred_def_78089,type,
    v131345: state_type > $o ).

tff(pred_def_78090,type,
    v131353: state_type > $o ).

tff(pred_def_78091,type,
    v131351: state_type > $o ).

tff(pred_def_78092,type,
    v131367: state_type > $o ).

tff(pred_def_78093,type,
    v131365: state_type > $o ).

tff(pred_def_78094,type,
    v131363: state_type > $o ).

tff(pred_def_78095,type,
    v131361: state_type > $o ).

tff(pred_def_78096,type,
    v131359: state_type > $o ).

tff(pred_def_78097,type,
    v131357: state_type > $o ).

tff(pred_def_78098,type,
    v131355: state_type > $o ).

tff(pred_def_78099,type,
    v131371: state_type > $o ).

tff(pred_def_78100,type,
    v131369: state_type > $o ).

tff(pred_def_78101,type,
    v131349: state_type > $o ).

tff(pred_def_78102,type,
    v131377: state_type > $o ).

tff(pred_def_78103,type,
    v131379: state_type > $o ).

tff(pred_def_78104,type,
    v131375: state_type > $o ).

tff(pred_def_78105,type,
    v131374: state_type > $o ).

tff(pred_def_78106,type,
    v131385: state_type > $o ).

tff(pred_def_78107,type,
    v131386: state_type > $o ).

tff(pred_def_78108,type,
    v131382: state_type > $o ).

tff(pred_def_78109,type,
    v131384: state_type > $o ).

tff(pred_def_78110,type,
    v131392: state_type > $o ).

tff(pred_def_78111,type,
    v131390: state_type > $o ).

tff(pred_def_78112,type,
    v131394: state_type > $o ).

tff(pred_def_78113,type,
    v131343: state_type > $o ).

tff(pred_def_78114,type,
    v131341: state_type > $o ).

tff(pred_def_78115,type,
    v131339: state_type > $o ).

tff(pred_def_78116,type,
    v131401: state_type > $o ).

tff(pred_def_78117,type,
    v131399: state_type > $o ).

tff(pred_def_78118,type,
    v131398: state_type > $o ).

tff(pred_def_78119,type,
    v131397: state_type > $o ).

tff(pred_def_78120,type,
    v131409: state_type > $o ).

tff(pred_def_78121,type,
    v131410: state_type > $o ).

tff(pred_def_78122,type,
    v131408: state_type > $o ).

tff(pred_def_78123,type,
    v131405: ( state_type * $int ) > $o ).

tff(pred_def_78124,type,
    v131407: ( state_type * $int ) > $o ).

tff(pred_def_78125,type,
    v131396: ( state_type * $int ) > $o ).

tff(pred_def_78126,type,
    v131312: ( state_type * $int ) > $o ).

tff(pred_def_78127,type,
    v131310: ( state_type * $int ) > $o ).

tff(pred_def_78128,type,
    v131308: ( state_type * $int ) > $o ).

tff(pred_def_78129,type,
    v131414: ( state_type * $int ) > $o ).

tff(pred_def_78130,type,
    v131413: ( state_type * $int ) > $o ).

tff(pred_def_78131,type,
    v131415: ( state_type * $int ) > $o ).

tff(pred_def_78132,type,
    v131416: ( state_type * $int ) > $o ).

tff(pred_def_78133,type,
    v131417: ( state_type * $int ) > $o ).

tff(pred_def_78134,type,
    v131306: ( state_type * $int ) > $o ).

tff(pred_def_78135,type,
    v131304: ( state_type * $int ) > $o ).

tff(pred_def_78136,type,
    v131427: state_type > $o ).

tff(pred_def_78137,type,
    v131425: state_type > $o ).

tff(pred_def_78138,type,
    v131423: state_type > $o ).

tff(pred_def_78139,type,
    v131421: state_type > $o ).

tff(pred_def_78140,type,
    v131419: state_type > $o ).

tff(pred_def_78141,type,
    v131447: state_type > $o ).

tff(pred_def_78142,type,
    v131445: state_type > $o ).

tff(pred_def_78143,type,
    v131443: state_type > $o ).

tff(pred_def_78144,type,
    v131441: state_type > $o ).

tff(pred_def_78145,type,
    v131439: state_type > $o ).

tff(pred_def_78146,type,
    v131457: state_type > $o ).

tff(pred_def_78147,type,
    v131455: state_type > $o ).

tff(pred_def_78148,type,
    v131453: state_type > $o ).

tff(pred_def_78149,type,
    v131451: state_type > $o ).

tff(pred_def_78150,type,
    v131449: state_type > $o ).

tff(pred_def_78151,type,
    v131462: ( state_type * $int ) > $o ).

tff(pred_def_78152,type,
    v131461: ( state_type * $int ) > $o ).

tff(pred_def_78153,type,
    v131459: ( state_type * $int ) > $o ).

tff(pred_def_78154,type,
    v131472: state_type > $o ).

tff(pred_def_78155,type,
    v131470: state_type > $o ).

tff(pred_def_78156,type,
    v131478: state_type > $o ).

tff(pred_def_78157,type,
    v131476: state_type > $o ).

tff(pred_def_78158,type,
    v131492: state_type > $o ).

tff(pred_def_78159,type,
    v131490: state_type > $o ).

tff(pred_def_78160,type,
    v131488: state_type > $o ).

tff(pred_def_78161,type,
    v131486: state_type > $o ).

tff(pred_def_78162,type,
    v131484: state_type > $o ).

tff(pred_def_78163,type,
    v131482: state_type > $o ).

tff(pred_def_78164,type,
    v131480: state_type > $o ).

tff(pred_def_78165,type,
    v131496: state_type > $o ).

tff(pred_def_78166,type,
    v131494: state_type > $o ).

tff(pred_def_78167,type,
    v131474: state_type > $o ).

tff(pred_def_78168,type,
    v131502: state_type > $o ).

tff(pred_def_78169,type,
    v131504: state_type > $o ).

tff(pred_def_78170,type,
    v131500: state_type > $o ).

tff(pred_def_78171,type,
    v131499: state_type > $o ).

tff(pred_def_78172,type,
    v131510: state_type > $o ).

tff(pred_def_78173,type,
    v131511: state_type > $o ).

tff(pred_def_78174,type,
    v131507: state_type > $o ).

tff(pred_def_78175,type,
    v131509: state_type > $o ).

tff(pred_def_78176,type,
    v131517: state_type > $o ).

tff(pred_def_78177,type,
    v131515: state_type > $o ).

tff(pred_def_78178,type,
    v131519: state_type > $o ).

tff(pred_def_78179,type,
    v131468: state_type > $o ).

tff(pred_def_78180,type,
    v131466: state_type > $o ).

tff(pred_def_78181,type,
    v131464: state_type > $o ).

tff(pred_def_78182,type,
    v131526: state_type > $o ).

tff(pred_def_78183,type,
    v131524: state_type > $o ).

tff(pred_def_78184,type,
    v131523: state_type > $o ).

tff(pred_def_78185,type,
    v131522: state_type > $o ).

tff(pred_def_78186,type,
    v131534: state_type > $o ).

tff(pred_def_78187,type,
    v131535: state_type > $o ).

tff(pred_def_78188,type,
    v131533: state_type > $o ).

tff(pred_def_78189,type,
    v131530: ( state_type * $int ) > $o ).

tff(pred_def_78190,type,
    v131532: ( state_type * $int ) > $o ).

tff(pred_def_78191,type,
    v131521: ( state_type * $int ) > $o ).

tff(pred_def_78192,type,
    v131437: ( state_type * $int ) > $o ).

tff(pred_def_78193,type,
    v131435: ( state_type * $int ) > $o ).

tff(pred_def_78194,type,
    v131433: ( state_type * $int ) > $o ).

tff(pred_def_78195,type,
    v131539: ( state_type * $int ) > $o ).

tff(pred_def_78196,type,
    v131538: ( state_type * $int ) > $o ).

tff(pred_def_78197,type,
    v131540: ( state_type * $int ) > $o ).

tff(pred_def_78198,type,
    v131541: ( state_type * $int ) > $o ).

tff(pred_def_78199,type,
    v131542: ( state_type * $int ) > $o ).

tff(pred_def_78200,type,
    v131431: ( state_type * $int ) > $o ).

tff(pred_def_78201,type,
    v131429: ( state_type * $int ) > $o ).

tff(pred_def_78202,type,
    v131552: state_type > $o ).

tff(pred_def_78203,type,
    v131550: state_type > $o ).

tff(pred_def_78204,type,
    v131548: state_type > $o ).

tff(pred_def_78205,type,
    v131546: state_type > $o ).

tff(pred_def_78206,type,
    v131544: state_type > $o ).

tff(pred_def_78207,type,
    v131572: state_type > $o ).

tff(pred_def_78208,type,
    v131570: state_type > $o ).

tff(pred_def_78209,type,
    v131568: state_type > $o ).

tff(pred_def_78210,type,
    v131566: state_type > $o ).

tff(pred_def_78211,type,
    v131564: state_type > $o ).

tff(pred_def_78212,type,
    v131582: state_type > $o ).

tff(pred_def_78213,type,
    v131580: state_type > $o ).

tff(pred_def_78214,type,
    v131578: state_type > $o ).

tff(pred_def_78215,type,
    v131576: state_type > $o ).

tff(pred_def_78216,type,
    v131574: state_type > $o ).

tff(pred_def_78217,type,
    v131587: ( state_type * $int ) > $o ).

tff(pred_def_78218,type,
    v131586: ( state_type * $int ) > $o ).

tff(pred_def_78219,type,
    v131584: ( state_type * $int ) > $o ).

tff(pred_def_78220,type,
    v131597: state_type > $o ).

tff(pred_def_78221,type,
    v131595: state_type > $o ).

tff(pred_def_78222,type,
    v131603: state_type > $o ).

tff(pred_def_78223,type,
    v131601: state_type > $o ).

tff(pred_def_78224,type,
    v131617: state_type > $o ).

tff(pred_def_78225,type,
    v131615: state_type > $o ).

tff(pred_def_78226,type,
    v131613: state_type > $o ).

tff(pred_def_78227,type,
    v131611: state_type > $o ).

tff(pred_def_78228,type,
    v131609: state_type > $o ).

tff(pred_def_78229,type,
    v131607: state_type > $o ).

tff(pred_def_78230,type,
    v131605: state_type > $o ).

tff(pred_def_78231,type,
    v131621: state_type > $o ).

tff(pred_def_78232,type,
    v131619: state_type > $o ).

tff(pred_def_78233,type,
    v131599: state_type > $o ).

tff(pred_def_78234,type,
    v131627: state_type > $o ).

tff(pred_def_78235,type,
    v131629: state_type > $o ).

tff(pred_def_78236,type,
    v131625: state_type > $o ).

tff(pred_def_78237,type,
    v131624: state_type > $o ).

tff(pred_def_78238,type,
    v131635: state_type > $o ).

tff(pred_def_78239,type,
    v131636: state_type > $o ).

tff(pred_def_78240,type,
    v131632: state_type > $o ).

tff(pred_def_78241,type,
    v131634: state_type > $o ).

tff(pred_def_78242,type,
    v131642: state_type > $o ).

tff(pred_def_78243,type,
    v131640: state_type > $o ).

tff(pred_def_78244,type,
    v131644: state_type > $o ).

tff(pred_def_78245,type,
    v131593: state_type > $o ).

tff(pred_def_78246,type,
    v131591: state_type > $o ).

tff(pred_def_78247,type,
    v131589: state_type > $o ).

tff(pred_def_78248,type,
    v131651: state_type > $o ).

tff(pred_def_78249,type,
    v131649: state_type > $o ).

tff(pred_def_78250,type,
    v131648: state_type > $o ).

tff(pred_def_78251,type,
    v131647: state_type > $o ).

tff(pred_def_78252,type,
    v131659: state_type > $o ).

tff(pred_def_78253,type,
    v131660: state_type > $o ).

tff(pred_def_78254,type,
    v131658: state_type > $o ).

tff(pred_def_78255,type,
    v131655: ( state_type * $int ) > $o ).

tff(pred_def_78256,type,
    v131657: ( state_type * $int ) > $o ).

tff(pred_def_78257,type,
    v131646: ( state_type * $int ) > $o ).

tff(pred_def_78258,type,
    v131562: ( state_type * $int ) > $o ).

tff(pred_def_78259,type,
    v131560: ( state_type * $int ) > $o ).

tff(pred_def_78260,type,
    v131558: ( state_type * $int ) > $o ).

tff(pred_def_78261,type,
    v131664: ( state_type * $int ) > $o ).

tff(pred_def_78262,type,
    v131663: ( state_type * $int ) > $o ).

tff(pred_def_78263,type,
    v131665: ( state_type * $int ) > $o ).

tff(pred_def_78264,type,
    v131666: ( state_type * $int ) > $o ).

tff(pred_def_78265,type,
    v131667: ( state_type * $int ) > $o ).

tff(pred_def_78266,type,
    v131556: ( state_type * $int ) > $o ).

tff(pred_def_78267,type,
    v131554: ( state_type * $int ) > $o ).

tff(pred_def_78268,type,
    v131677: state_type > $o ).

tff(pred_def_78269,type,
    v131675: state_type > $o ).

tff(pred_def_78270,type,
    v131673: state_type > $o ).

tff(pred_def_78271,type,
    v131671: state_type > $o ).

tff(pred_def_78272,type,
    v131669: state_type > $o ).

tff(pred_def_78273,type,
    v131687: state_type > $o ).

tff(pred_def_78274,type,
    v131686: ( state_type * $int ) > $o ).

tff(pred_def_78275,type,
    v131685: ( state_type * $int ) > $o ).

tff(pred_def_78276,type,
    v131690: state_type > $o ).

tff(pred_def_78277,type,
    v131689: ( state_type * $int ) > $o ).

tff(pred_def_78278,type,
    v131688: ( state_type * $int ) > $o ).

tff(pred_def_78279,type,
    v131684: ( state_type * $int ) > $o ).

tff(pred_def_78280,type,
    v131693: state_type > $o ).

tff(pred_def_78281,type,
    v131692: ( state_type * $int ) > $o ).

tff(pred_def_78282,type,
    v131691: ( state_type * $int ) > $o ).

tff(pred_def_78283,type,
    v131683: ( state_type * $int ) > $o ).

tff(pred_def_78284,type,
    v131696: state_type > $o ).

tff(pred_def_78285,type,
    v131695: ( state_type * $int ) > $o ).

tff(pred_def_78286,type,
    v131694: ( state_type * $int ) > $o ).

tff(pred_def_78287,type,
    v131682: ( state_type * $int ) > $o ).

tff(pred_def_78288,type,
    v131699: state_type > $o ).

tff(pred_def_78289,type,
    v131698: ( state_type * $int ) > $o ).

tff(pred_def_78290,type,
    v131697: ( state_type * $int ) > $o ).

tff(pred_def_78291,type,
    v131681: ( state_type * $int ) > $o ).

tff(pred_def_78292,type,
    v131702: state_type > $o ).

tff(pred_def_78293,type,
    v131701: ( state_type * $int ) > $o ).

tff(pred_def_78294,type,
    v131700: ( state_type * $int ) > $o ).

tff(pred_def_78295,type,
    v131680: ( state_type * $int ) > $o ).

tff(pred_def_78296,type,
    v131705: state_type > $o ).

tff(pred_def_78297,type,
    v131704: ( state_type * $int ) > $o ).

tff(pred_def_78298,type,
    v131703: ( state_type * $int ) > $o ).

tff(pred_def_78299,type,
    v131679: ( state_type * $int ) > $o ).

tff(pred_def_78300,type,
    v131708: state_type > $o ).

tff(pred_def_78301,type,
    v131707: ( state_type * $int ) > $o ).

tff(pred_def_78302,type,
    v131706: ( state_type * $int ) > $o ).

tff(pred_def_78303,type,
    v131678: ( state_type * $int ) > $o ).

tff(pred_def_78304,type,
    v130150: ( state_type * $int ) > $o ).

tff(pred_def_78305,type,
    v130148: ( state_type * $int ) > $o ).

tff(pred_def_78306,type,
    v130146: ( state_type * $int ) > $o ).

tff(pred_def_78307,type,
    v131715: ( state_type * $int ) > $o ).

tff(pred_def_78308,type,
    v131721: state_type > $o ).

tff(pred_def_78309,type,
    v131719: state_type > $o ).

tff(pred_def_78310,type,
    v131718: state_type > $o ).

tff(pred_def_78311,type,
    v131717: ( state_type * $int ) > $o ).

tff(pred_def_78312,type,
    v131729: state_type > $o ).

tff(pred_def_78313,type,
    v131727: state_type > $o ).

tff(pred_def_78314,type,
    v131726: state_type > $o ).

tff(pred_def_78315,type,
    v131725: ( state_type * $int ) > $o ).

tff(pred_def_78316,type,
    v131738: state_type > $o ).

tff(pred_def_78317,type,
    v131736: state_type > $o ).

tff(pred_def_78318,type,
    v131735: state_type > $o ).

tff(pred_def_78319,type,
    v131734: ( state_type * $int ) > $o ).

tff(pred_def_78320,type,
    v131747: state_type > $o ).

tff(pred_def_78321,type,
    v131745: state_type > $o ).

tff(pred_def_78322,type,
    v131744: state_type > $o ).

tff(pred_def_78323,type,
    v131743: ( state_type * $int ) > $o ).

tff(pred_def_78324,type,
    v131756: state_type > $o ).

tff(pred_def_78325,type,
    v131754: state_type > $o ).

tff(pred_def_78326,type,
    v131753: state_type > $o ).

tff(pred_def_78327,type,
    v131752: ( state_type * $int ) > $o ).

tff(pred_def_78328,type,
    v131765: state_type > $o ).

tff(pred_def_78329,type,
    v131763: state_type > $o ).

tff(pred_def_78330,type,
    v131762: state_type > $o ).

tff(pred_def_78331,type,
    v131761: ( state_type * $int ) > $o ).

tff(pred_def_78332,type,
    v131774: state_type > $o ).

tff(pred_def_78333,type,
    v131772: state_type > $o ).

tff(pred_def_78334,type,
    v131771: state_type > $o ).

tff(pred_def_78335,type,
    v131770: ( state_type * $int ) > $o ).

tff(pred_def_78336,type,
    v131783: state_type > $o ).

tff(pred_def_78337,type,
    v131781: state_type > $o ).

tff(pred_def_78338,type,
    v131780: state_type > $o ).

tff(pred_def_78339,type,
    v131779: ( state_type * $int ) > $o ).

tff(pred_def_78340,type,
    v131792: state_type > $o ).

tff(pred_def_78341,type,
    v131790: state_type > $o ).

tff(pred_def_78342,type,
    v131789: state_type > $o ).

tff(pred_def_78343,type,
    v131788: ( state_type * $int ) > $o ).

tff(pred_def_78344,type,
    v131710: ( state_type * $int ) > $o ).

tff(pred_def_78345,type,
    v131809: ( state_type * $int ) > $o ).

tff(pred_def_78346,type,
    v131807: ( state_type * $int ) > $o ).

tff(pred_def_78347,type,
    v131805: ( state_type * $int ) > $o ).

tff(pred_def_78348,type,
    v131803: ( state_type * $int ) > $o ).

tff(pred_def_78349,type,
    v131801: ( state_type * $int ) > $o ).

tff(pred_def_78350,type,
    v131815: state_type > $o ).

tff(pred_def_78351,type,
    v131813: state_type > $o ).

tff(pred_def_78352,type,
    v131812: state_type > $o ).

tff(pred_def_78353,type,
    v131811: ( state_type * $int ) > $o ).

tff(pred_def_78354,type,
    v131823: state_type > $o ).

tff(pred_def_78355,type,
    v131821: state_type > $o ).

tff(pred_def_78356,type,
    v131820: state_type > $o ).

tff(pred_def_78357,type,
    v131819: ( state_type * $int ) > $o ).

tff(pred_def_78358,type,
    v131832: state_type > $o ).

tff(pred_def_78359,type,
    v131830: state_type > $o ).

tff(pred_def_78360,type,
    v131829: state_type > $o ).

tff(pred_def_78361,type,
    v131828: ( state_type * $int ) > $o ).

tff(pred_def_78362,type,
    v131841: state_type > $o ).

tff(pred_def_78363,type,
    v131839: state_type > $o ).

tff(pred_def_78364,type,
    v131838: state_type > $o ).

tff(pred_def_78365,type,
    v131837: ( state_type * $int ) > $o ).

tff(pred_def_78366,type,
    v131850: state_type > $o ).

tff(pred_def_78367,type,
    v131848: state_type > $o ).

tff(pred_def_78368,type,
    v131847: state_type > $o ).

tff(pred_def_78369,type,
    v131846: ( state_type * $int ) > $o ).

tff(pred_def_78370,type,
    v131859: state_type > $o ).

tff(pred_def_78371,type,
    v131857: state_type > $o ).

tff(pred_def_78372,type,
    v131856: state_type > $o ).

tff(pred_def_78373,type,
    v131855: ( state_type * $int ) > $o ).

tff(pred_def_78374,type,
    v131868: state_type > $o ).

tff(pred_def_78375,type,
    v131866: state_type > $o ).

tff(pred_def_78376,type,
    v131865: state_type > $o ).

tff(pred_def_78377,type,
    v131864: ( state_type * $int ) > $o ).

tff(pred_def_78378,type,
    v131877: state_type > $o ).

tff(pred_def_78379,type,
    v131875: state_type > $o ).

tff(pred_def_78380,type,
    v131874: state_type > $o ).

tff(pred_def_78381,type,
    v131873: ( state_type * $int ) > $o ).

tff(pred_def_78382,type,
    v131886: state_type > $o ).

tff(pred_def_78383,type,
    v131884: state_type > $o ).

tff(pred_def_78384,type,
    v131883: state_type > $o ).

tff(pred_def_78385,type,
    v131882: ( state_type * $int ) > $o ).

tff(pred_def_78386,type,
    v131796: ( state_type * $int ) > $o ).

tff(pred_def_78387,type,
    v131899: ( state_type * $int ) > $o ).

tff(pred_def_78388,type,
    v131897: ( state_type * $int ) > $o ).

tff(pred_def_78389,type,
    v131895: ( state_type * $int ) > $o ).

tff(pred_def_78390,type,
    v131905: state_type > $o ).

tff(pred_def_78391,type,
    v131903: state_type > $o ).

tff(pred_def_78392,type,
    v131902: state_type > $o ).

tff(pred_def_78393,type,
    v131901: ( state_type * $int ) > $o ).

tff(pred_def_78394,type,
    v131913: state_type > $o ).

tff(pred_def_78395,type,
    v131911: state_type > $o ).

tff(pred_def_78396,type,
    v131910: state_type > $o ).

tff(pred_def_78397,type,
    v131909: ( state_type * $int ) > $o ).

tff(pred_def_78398,type,
    v131922: state_type > $o ).

tff(pred_def_78399,type,
    v131920: state_type > $o ).

tff(pred_def_78400,type,
    v131919: state_type > $o ).

tff(pred_def_78401,type,
    v131918: ( state_type * $int ) > $o ).

tff(pred_def_78402,type,
    v131931: state_type > $o ).

tff(pred_def_78403,type,
    v131929: state_type > $o ).

tff(pred_def_78404,type,
    v131928: state_type > $o ).

tff(pred_def_78405,type,
    v131927: ( state_type * $int ) > $o ).

tff(pred_def_78406,type,
    v131940: state_type > $o ).

tff(pred_def_78407,type,
    v131938: state_type > $o ).

tff(pred_def_78408,type,
    v131937: state_type > $o ).

tff(pred_def_78409,type,
    v131936: ( state_type * $int ) > $o ).

tff(pred_def_78410,type,
    v131949: state_type > $o ).

tff(pred_def_78411,type,
    v131947: state_type > $o ).

tff(pred_def_78412,type,
    v131946: state_type > $o ).

tff(pred_def_78413,type,
    v131945: ( state_type * $int ) > $o ).

tff(pred_def_78414,type,
    v131958: state_type > $o ).

tff(pred_def_78415,type,
    v131956: state_type > $o ).

tff(pred_def_78416,type,
    v131955: state_type > $o ).

tff(pred_def_78417,type,
    v131954: ( state_type * $int ) > $o ).

tff(pred_def_78418,type,
    v131967: state_type > $o ).

tff(pred_def_78419,type,
    v131965: state_type > $o ).

tff(pred_def_78420,type,
    v131964: state_type > $o ).

tff(pred_def_78421,type,
    v131963: ( state_type * $int ) > $o ).

tff(pred_def_78422,type,
    v131976: state_type > $o ).

tff(pred_def_78423,type,
    v131974: state_type > $o ).

tff(pred_def_78424,type,
    v131973: state_type > $o ).

tff(pred_def_78425,type,
    v131972: ( state_type * $int ) > $o ).

tff(pred_def_78426,type,
    v131890: ( state_type * $int ) > $o ).

tff(pred_def_78427,type,
    v132014: state_type > $o ).

tff(pred_def_78428,type,
    v132012: state_type > $o ).

tff(pred_def_78429,type,
    v132010: state_type > $o ).

tff(pred_def_78430,type,
    v132008: state_type > $o ).

tff(pred_def_78431,type,
    v132006: state_type > $o ).

tff(pred_def_78432,type,
    v132024: state_type > $o ).

tff(pred_def_78433,type,
    v132022: state_type > $o ).

tff(pred_def_78434,type,
    v132020: state_type > $o ).

tff(pred_def_78435,type,
    v132018: state_type > $o ).

tff(pred_def_78436,type,
    v132016: state_type > $o ).

tff(pred_def_78437,type,
    v132034: state_type > $o ).

tff(pred_def_78438,type,
    v132032: state_type > $o ).

tff(pred_def_78439,type,
    v132030: state_type > $o ).

tff(pred_def_78440,type,
    v132035: ( state_type * $int ) > $o ).

tff(pred_def_78441,type,
    v132036: ( state_type * $int ) > $o ).

tff(pred_def_78442,type,
    v132037: ( state_type * $int ) > $o ).

tff(pred_def_78443,type,
    v132038: ( state_type * $int ) > $o ).

tff(pred_def_78444,type,
    v132039: ( state_type * $int ) > $o ).

tff(pred_def_78445,type,
    v132028: ( state_type * $int ) > $o ).

tff(pred_def_78446,type,
    v132026: ( state_type * $int ) > $o ).

tff(pred_def_78447,type,
    v132049: state_type > $o ).

tff(pred_def_78448,type,
    v132047: state_type > $o ).

tff(pred_def_78449,type,
    v132055: state_type > $o ).

tff(pred_def_78450,type,
    v132053: state_type > $o ).

tff(pred_def_78451,type,
    v132059: state_type > $o ).

tff(pred_def_78452,type,
    v132057: state_type > $o ).

tff(pred_def_78453,type,
    v132063: state_type > $o ).

tff(pred_def_78454,type,
    v132061: state_type > $o ).

tff(pred_def_78455,type,
    v132051: state_type > $o ).

tff(pred_def_78456,type,
    v132069: state_type > $o ).

tff(pred_def_78457,type,
    v132071: state_type > $o ).

tff(pred_def_78458,type,
    v132067: state_type > $o ).

tff(pred_def_78459,type,
    v132066: state_type > $o ).

tff(pred_def_78460,type,
    v132077: state_type > $o ).

tff(pred_def_78461,type,
    v132078: state_type > $o ).

tff(pred_def_78462,type,
    v132074: state_type > $o ).

tff(pred_def_78463,type,
    v132076: state_type > $o ).

tff(pred_def_78464,type,
    v132084: state_type > $o ).

tff(pred_def_78465,type,
    v132082: state_type > $o ).

tff(pred_def_78466,type,
    v132086: state_type > $o ).

tff(pred_def_78467,type,
    v132045: state_type > $o ).

tff(pred_def_78468,type,
    v132043: state_type > $o ).

tff(pred_def_78469,type,
    v132041: state_type > $o ).

tff(pred_def_78470,type,
    v132093: state_type > $o ).

tff(pred_def_78471,type,
    v132091: state_type > $o ).

tff(pred_def_78472,type,
    v132090: state_type > $o ).

tff(pred_def_78473,type,
    v132089: state_type > $o ).

tff(pred_def_78474,type,
    v132101: state_type > $o ).

tff(pred_def_78475,type,
    v132102: state_type > $o ).

tff(pred_def_78476,type,
    v132100: state_type > $o ).

tff(pred_def_78477,type,
    v132097: ( state_type * $int ) > $o ).

tff(pred_def_78478,type,
    v132099: ( state_type * $int ) > $o ).

tff(pred_def_78479,type,
    v132088: ( state_type * $int ) > $o ).

tff(pred_def_78480,type,
    v132004: ( state_type * $int ) > $o ).

tff(pred_def_78481,type,
    v132002: ( state_type * $int ) > $o ).

tff(pred_def_78482,type,
    v132000: state_type > $o ).

tff(pred_def_78483,type,
    v131998: state_type > $o ).

tff(pred_def_78484,type,
    v131996: state_type > $o ).

tff(pred_def_78485,type,
    v131994: state_type > $o ).

tff(pred_def_78486,type,
    v131992: state_type > $o ).

tff(pred_def_78487,type,
    v131990: state_type > $o ).

tff(pred_def_78488,type,
    v131988: state_type > $o ).

tff(pred_def_78489,type,
    v131986: state_type > $o ).

tff(pred_def_78490,type,
    v132115: state_type > $o ).

tff(pred_def_78491,type,
    v132113: state_type > $o ).

tff(pred_def_78492,type,
    v132112: state_type > $o ).

tff(pred_def_78493,type,
    v132111: ( state_type * $int ) > $o ).

tff(pred_def_78494,type,
    v132123: state_type > $o ).

tff(pred_def_78495,type,
    v132121: state_type > $o ).

tff(pred_def_78496,type,
    v132120: state_type > $o ).

tff(pred_def_78497,type,
    v132119: ( state_type * $int ) > $o ).

tff(pred_def_78498,type,
    v132131: state_type > $o ).

tff(pred_def_78499,type,
    v132129: state_type > $o ).

tff(pred_def_78500,type,
    v132128: state_type > $o ).

tff(pred_def_78501,type,
    v132127: ( state_type * $int ) > $o ).

tff(pred_def_78502,type,
    v132139: state_type > $o ).

tff(pred_def_78503,type,
    v132137: state_type > $o ).

tff(pred_def_78504,type,
    v132136: state_type > $o ).

tff(pred_def_78505,type,
    v132135: ( state_type * $int ) > $o ).

tff(pred_def_78506,type,
    v132147: state_type > $o ).

tff(pred_def_78507,type,
    v132145: state_type > $o ).

tff(pred_def_78508,type,
    v132144: state_type > $o ).

tff(pred_def_78509,type,
    v132143: ( state_type * $int ) > $o ).

tff(pred_def_78510,type,
    v132155: state_type > $o ).

tff(pred_def_78511,type,
    v132153: state_type > $o ).

tff(pred_def_78512,type,
    v132152: state_type > $o ).

tff(pred_def_78513,type,
    v132151: ( state_type * $int ) > $o ).

tff(pred_def_78514,type,
    v132163: state_type > $o ).

tff(pred_def_78515,type,
    v132161: state_type > $o ).

tff(pred_def_78516,type,
    v132160: state_type > $o ).

tff(pred_def_78517,type,
    v132159: ( state_type * $int ) > $o ).

tff(pred_def_78518,type,
    v132171: state_type > $o ).

tff(pred_def_78519,type,
    v132169: state_type > $o ).

tff(pred_def_78520,type,
    v132168: state_type > $o ).

tff(pred_def_78521,type,
    v132167: ( state_type * $int ) > $o ).

tff(pred_def_78522,type,
    v132179: state_type > $o ).

tff(pred_def_78523,type,
    v132177: state_type > $o ).

tff(pred_def_78524,type,
    v132176: state_type > $o ).

tff(pred_def_78525,type,
    v132175: ( state_type * $int ) > $o ).

tff(pred_def_78526,type,
    v132109: state_type > $o ).

tff(pred_def_78527,type,
    v132107: state_type > $o ).

tff(pred_def_78528,type,
    v131984: state_type > $o ).

tff(pred_def_78529,type,
    v131982: state_type > $o ).

tff(pred_def_78530,type,
    v131980: state_type > $o ).

tff(pred_def_78531,type,
    v130144: ( state_type * $int ) > $o ).

tff(pred_def_78532,type,
    v130142: ( state_type * $int ) > $o ).

tff(pred_def_78533,type,
    v132203: state_type > $o ).

tff(pred_def_78534,type,
    v132201: state_type > $o ).

tff(pred_def_78535,type,
    v132199: state_type > $o ).

tff(pred_def_78536,type,
    v132197: state_type > $o ).

tff(pred_def_78537,type,
    v132195: state_type > $o ).

tff(pred_def_78538,type,
    v132213: state_type > $o ).

tff(pred_def_78539,type,
    v132211: state_type > $o ).

tff(pred_def_78540,type,
    v132209: state_type > $o ).

tff(pred_def_78541,type,
    v132207: state_type > $o ).

tff(pred_def_78542,type,
    v132205: state_type > $o ).

tff(pred_def_78543,type,
    v132222: state_type > $o ).

tff(pred_def_78544,type,
    v132224: ( state_type * $int ) > $o ).

tff(pred_def_78545,type,
    v132231: state_type > $o ).

tff(pred_def_78546,type,
    v132229: state_type > $o ).

tff(pred_def_78547,type,
    v132228: state_type > $o ).

tff(pred_def_78548,type,
    v132227: ( state_type * $int ) > $o ).

tff(pred_def_78549,type,
    v132219: ( state_type * $int ) > $o ).

tff(pred_def_78550,type,
    v132234: ( state_type * $int ) > $o ).

tff(pred_def_78551,type,
    v132235: ( state_type * $int ) > $o ).

tff(pred_def_78552,type,
    v132236: ( state_type * $int ) > $o ).

tff(pred_def_78553,type,
    v132237: ( state_type * $int ) > $o ).

tff(pred_def_78554,type,
    v132217: ( state_type * $int ) > $o ).

tff(pred_def_78555,type,
    v132215: ( state_type * $int ) > $o ).

tff(pred_def_78556,type,
    v132248: state_type > $o ).

tff(pred_def_78557,type,
    v132246: state_type > $o ).

tff(pred_def_78558,type,
    v132254: state_type > $o ).

tff(pred_def_78559,type,
    v132252: state_type > $o ).

tff(pred_def_78560,type,
    v132268: state_type > $o ).

tff(pred_def_78561,type,
    v132266: state_type > $o ).

tff(pred_def_78562,type,
    v132264: state_type > $o ).

tff(pred_def_78563,type,
    v132262: state_type > $o ).

tff(pred_def_78564,type,
    v132260: state_type > $o ).

tff(pred_def_78565,type,
    v132258: state_type > $o ).

tff(pred_def_78566,type,
    v132256: state_type > $o ).

tff(pred_def_78567,type,
    v132272: state_type > $o ).

tff(pred_def_78568,type,
    v132270: state_type > $o ).

tff(pred_def_78569,type,
    v132250: state_type > $o ).

tff(pred_def_78570,type,
    v132278: state_type > $o ).

tff(pred_def_78571,type,
    v132280: state_type > $o ).

tff(pred_def_78572,type,
    v132276: state_type > $o ).

tff(pred_def_78573,type,
    v132275: state_type > $o ).

tff(pred_def_78574,type,
    v132286: state_type > $o ).

tff(pred_def_78575,type,
    v132287: state_type > $o ).

tff(pred_def_78576,type,
    v132283: state_type > $o ).

tff(pred_def_78577,type,
    v132285: state_type > $o ).

tff(pred_def_78578,type,
    v132293: state_type > $o ).

tff(pred_def_78579,type,
    v132291: state_type > $o ).

tff(pred_def_78580,type,
    v132295: state_type > $o ).

tff(pred_def_78581,type,
    v132244: state_type > $o ).

tff(pred_def_78582,type,
    v132242: state_type > $o ).

tff(pred_def_78583,type,
    v132240: state_type > $o ).

tff(pred_def_78584,type,
    v132302: state_type > $o ).

tff(pred_def_78585,type,
    v132300: state_type > $o ).

tff(pred_def_78586,type,
    v132299: state_type > $o ).

tff(pred_def_78587,type,
    v132298: state_type > $o ).

tff(pred_def_78588,type,
    v132310: state_type > $o ).

tff(pred_def_78589,type,
    v132311: state_type > $o ).

tff(pred_def_78590,type,
    v132309: state_type > $o ).

tff(pred_def_78591,type,
    v132306: ( state_type * $int ) > $o ).

tff(pred_def_78592,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_78593,type,
    v132308: ( state_type * $int ) > $o ).

tff(pred_def_78594,type,
    v132297: ( state_type * $int ) > $o ).

tff(pred_def_78595,type,
    v132193: ( state_type * $int ) > $o ).

tff(pred_def_78596,type,
    v132191: ( state_type * $int ) > $o ).

tff(pred_def_78597,type,
    v132189: ( state_type * $int ) > $o ).

tff(pred_def_78598,type,
    v132323: ( state_type * $int ) > $o ).

tff(pred_def_78599,type,
    v132321: ( state_type * $int ) > $o ).

tff(pred_def_78600,type,
    v132319: ( state_type * $int ) > $o ).

tff(pred_def_78601,type,
    v132329: state_type > $o ).

tff(pred_def_78602,type,
    v132327: state_type > $o ).

tff(pred_def_78603,type,
    v132326: state_type > $o ).

tff(pred_def_78604,type,
    v132325: ( state_type * $int ) > $o ).

tff(pred_def_78605,type,
    v132337: state_type > $o ).

tff(pred_def_78606,type,
    v132335: state_type > $o ).

tff(pred_def_78607,type,
    v132334: state_type > $o ).

tff(pred_def_78608,type,
    v132333: ( state_type * $int ) > $o ).

tff(pred_def_78609,type,
    v132315: ( state_type * $int ) > $o ).

tff(pred_def_78610,type,
    v132349: ( state_type * $int ) > $o ).

tff(pred_def_78611,type,
    v132347: ( state_type * $int ) > $o ).

tff(pred_def_78612,type,
    v132345: ( state_type * $int ) > $o ).

tff(pred_def_78613,type,
    v132355: state_type > $o ).

tff(pred_def_78614,type,
    v132353: state_type > $o ).

tff(pred_def_78615,type,
    v132352: state_type > $o ).

tff(pred_def_78616,type,
    v132351: ( state_type * $int ) > $o ).

tff(pred_def_78617,type,
    v132363: state_type > $o ).

tff(pred_def_78618,type,
    v132361: state_type > $o ).

tff(pred_def_78619,type,
    v132360: state_type > $o ).

tff(pred_def_78620,type,
    v132359: ( state_type * $int ) > $o ).

tff(pred_def_78621,type,
    v132341: ( state_type * $int ) > $o ).

tff(pred_def_78622,type,
    v132375: ( state_type * $int ) > $o ).

tff(pred_def_78623,type,
    v132373: ( state_type * $int ) > $o ).

tff(pred_def_78624,type,
    v132371: ( state_type * $int ) > $o ).

tff(pred_def_78625,type,
    v132381: state_type > $o ).

tff(pred_def_78626,type,
    v132379: state_type > $o ).

tff(pred_def_78627,type,
    v132378: state_type > $o ).

tff(pred_def_78628,type,
    v132377: ( state_type * $int ) > $o ).

tff(pred_def_78629,type,
    v132389: state_type > $o ).

tff(pred_def_78630,type,
    v132387: state_type > $o ).

tff(pred_def_78631,type,
    v132386: state_type > $o ).

tff(pred_def_78632,type,
    v132385: ( state_type * $int ) > $o ).

tff(pred_def_78633,type,
    v132367: ( state_type * $int ) > $o ).

tff(pred_def_78634,type,
    v132187: ( state_type * $int ) > $o ).

tff(pred_def_78635,type,
    v132185: ( state_type * $int ) > $o ).

tff(pred_def_78636,type,
    v130140: state_type > $o ).

tff(pred_def_78637,type,
    v130138: state_type > $o ).

tff(pred_def_78638,type,
    v130136: state_type > $o ).

tff(pred_def_78639,type,
    v130134: state_type > $o ).

tff(pred_def_78640,type,
    v130132: state_type > $o ).

tff(pred_def_78641,type,
    v130130: state_type > $o ).

tff(pred_def_78642,type,
    v132409: ( state_type * $int ) > $o ).

tff(pred_def_78643,type,
    v132407: ( state_type * $int ) > $o ).

tff(pred_def_78644,type,
    v132430: state_type > $o ).

tff(pred_def_78645,type,
    v132428: state_type > $o ).

tff(pred_def_78646,type,
    v132426: state_type > $o ).

tff(pred_def_78647,type,
    v132424: state_type > $o ).

tff(pred_def_78648,type,
    v132422: state_type > $o ).

tff(pred_def_78649,type,
    v132440: state_type > $o ).

tff(pred_def_78650,type,
    v132438: state_type > $o ).

tff(pred_def_78651,type,
    v132436: state_type > $o ).

tff(pred_def_78652,type,
    v132434: state_type > $o ).

tff(pred_def_78653,type,
    v132432: state_type > $o ).

tff(pred_def_78654,type,
    v132445: ( state_type * $int ) > $o ).

tff(pred_def_78655,type,
    v132444: ( state_type * $int ) > $o ).

tff(pred_def_78656,type,
    v132442: ( state_type * $int ) > $o ).

tff(pred_def_78657,type,
    v132455: state_type > $o ).

tff(pred_def_78658,type,
    v132453: state_type > $o ).

tff(pred_def_78659,type,
    v132461: state_type > $o ).

tff(pred_def_78660,type,
    v132459: state_type > $o ).

tff(pred_def_78661,type,
    v132475: state_type > $o ).

tff(pred_def_78662,type,
    v132473: state_type > $o ).

tff(pred_def_78663,type,
    v132471: state_type > $o ).

tff(pred_def_78664,type,
    v132469: state_type > $o ).

tff(pred_def_78665,type,
    v132467: state_type > $o ).

tff(pred_def_78666,type,
    v132465: state_type > $o ).

tff(pred_def_78667,type,
    v132463: state_type > $o ).

tff(pred_def_78668,type,
    v132479: state_type > $o ).

tff(pred_def_78669,type,
    v132477: state_type > $o ).

tff(pred_def_78670,type,
    v132457: state_type > $o ).

tff(pred_def_78671,type,
    v132485: state_type > $o ).

tff(pred_def_78672,type,
    v132487: state_type > $o ).

tff(pred_def_78673,type,
    v132483: state_type > $o ).

tff(pred_def_78674,type,
    v132482: state_type > $o ).

tff(pred_def_78675,type,
    v132493: state_type > $o ).

tff(pred_def_78676,type,
    v132494: state_type > $o ).

tff(pred_def_78677,type,
    v132490: state_type > $o ).

tff(pred_def_78678,type,
    v132492: state_type > $o ).

tff(pred_def_78679,type,
    v132500: state_type > $o ).

tff(pred_def_78680,type,
    v132498: state_type > $o ).

tff(pred_def_78681,type,
    v132502: state_type > $o ).

tff(pred_def_78682,type,
    v132451: state_type > $o ).

tff(pred_def_78683,type,
    v132449: state_type > $o ).

tff(pred_def_78684,type,
    v132447: state_type > $o ).

tff(pred_def_78685,type,
    v132509: state_type > $o ).

tff(pred_def_78686,type,
    v132507: state_type > $o ).

tff(pred_def_78687,type,
    v132506: state_type > $o ).

tff(pred_def_78688,type,
    v132505: state_type > $o ).

tff(pred_def_78689,type,
    v132517: state_type > $o ).

tff(pred_def_78690,type,
    v132518: state_type > $o ).

tff(pred_def_78691,type,
    v132516: state_type > $o ).

tff(pred_def_78692,type,
    v132513: ( state_type * $int ) > $o ).

tff(pred_def_78693,type,
    v132515: ( state_type * $int ) > $o ).

tff(pred_def_78694,type,
    v132504: ( state_type * $int ) > $o ).

tff(pred_def_78695,type,
    v132420: ( state_type * $int ) > $o ).

tff(pred_def_78696,type,
    v132418: ( state_type * $int ) > $o ).

tff(pred_def_78697,type,
    v132416: ( state_type * $int ) > $o ).

tff(pred_def_78698,type,
    v132528: state_type > $o ).

tff(pred_def_78699,type,
    v132526: state_type > $o ).

tff(pred_def_78700,type,
    v132525: state_type > $o ).

tff(pred_def_78701,type,
    v132524: ( state_type * $int ) > $o ).

tff(pred_def_78702,type,
    v132522: ( state_type * $int ) > $o ).

tff(pred_def_78703,type,
    v132538: state_type > $o ).

tff(pred_def_78704,type,
    v132536: state_type > $o ).

tff(pred_def_78705,type,
    v132535: state_type > $o ).

tff(pred_def_78706,type,
    v132534: ( state_type * $int ) > $o ).

tff(pred_def_78707,type,
    v132532: ( state_type * $int ) > $o ).

tff(pred_def_78708,type,
    v132548: state_type > $o ).

tff(pred_def_78709,type,
    v132546: state_type > $o ).

tff(pred_def_78710,type,
    v132545: state_type > $o ).

tff(pred_def_78711,type,
    v132544: ( state_type * $int ) > $o ).

tff(pred_def_78712,type,
    v132542: ( state_type * $int ) > $o ).

tff(pred_def_78713,type,
    v132414: ( state_type * $int ) > $o ).

tff(pred_def_78714,type,
    v132412: ( state_type * $int ) > $o ).

tff(pred_def_78715,type,
    v132405: state_type > $o ).

tff(pred_def_78716,type,
    v132403: state_type > $o ).

tff(pred_def_78717,type,
    v132401: state_type > $o ).

tff(pred_def_78718,type,
    v132399: state_type > $o ).

tff(pred_def_78719,type,
    v132397: state_type > $o ).

tff(pred_def_78720,type,
    v132395: state_type > $o ).

tff(pred_def_78721,type,
    v132568: ( state_type * $int ) > $o ).

tff(pred_def_78722,type,
    v132566: ( state_type * $int ) > $o ).

tff(pred_def_78723,type,
    v132589: state_type > $o ).

tff(pred_def_78724,type,
    v132587: state_type > $o ).

tff(pred_def_78725,type,
    v132585: state_type > $o ).

tff(pred_def_78726,type,
    v132583: state_type > $o ).

tff(pred_def_78727,type,
    v132581: state_type > $o ).

tff(pred_def_78728,type,
    v132599: state_type > $o ).

tff(pred_def_78729,type,
    v132597: state_type > $o ).

tff(pred_def_78730,type,
    v132595: state_type > $o ).

tff(pred_def_78731,type,
    v132593: state_type > $o ).

tff(pred_def_78732,type,
    v132591: state_type > $o ).

tff(pred_def_78733,type,
    v132604: ( state_type * $int ) > $o ).

tff(pred_def_78734,type,
    v132603: ( state_type * $int ) > $o ).

tff(pred_def_78735,type,
    v132601: ( state_type * $int ) > $o ).

tff(pred_def_78736,type,
    v132614: state_type > $o ).

tff(pred_def_78737,type,
    v132612: state_type > $o ).

tff(pred_def_78738,type,
    v132620: state_type > $o ).

tff(pred_def_78739,type,
    v132618: state_type > $o ).

tff(pred_def_78740,type,
    v132634: state_type > $o ).

tff(pred_def_78741,type,
    v132632: state_type > $o ).

tff(pred_def_78742,type,
    v132630: state_type > $o ).

tff(pred_def_78743,type,
    v132628: state_type > $o ).

tff(pred_def_78744,type,
    v132626: state_type > $o ).

tff(pred_def_78745,type,
    v132624: state_type > $o ).

tff(pred_def_78746,type,
    v132622: state_type > $o ).

tff(pred_def_78747,type,
    v132638: state_type > $o ).

tff(pred_def_78748,type,
    v132636: state_type > $o ).

tff(pred_def_78749,type,
    v132616: state_type > $o ).

tff(pred_def_78750,type,
    v132644: state_type > $o ).

tff(pred_def_78751,type,
    v132646: state_type > $o ).

tff(pred_def_78752,type,
    v132642: state_type > $o ).

tff(pred_def_78753,type,
    v132641: state_type > $o ).

tff(pred_def_78754,type,
    v132652: state_type > $o ).

tff(pred_def_78755,type,
    v132653: state_type > $o ).

tff(pred_def_78756,type,
    v132649: state_type > $o ).

tff(pred_def_78757,type,
    v132651: state_type > $o ).

tff(pred_def_78758,type,
    v132659: state_type > $o ).

tff(pred_def_78759,type,
    v132657: state_type > $o ).

tff(pred_def_78760,type,
    v132661: state_type > $o ).

tff(pred_def_78761,type,
    v132610: state_type > $o ).

tff(pred_def_78762,type,
    v132608: state_type > $o ).

tff(pred_def_78763,type,
    v132606: state_type > $o ).

tff(pred_def_78764,type,
    v132668: state_type > $o ).

tff(pred_def_78765,type,
    v132666: state_type > $o ).

tff(pred_def_78766,type,
    v132665: state_type > $o ).

tff(pred_def_78767,type,
    v132664: state_type > $o ).

tff(pred_def_78768,type,
    v132676: state_type > $o ).

tff(pred_def_78769,type,
    v132677: state_type > $o ).

tff(pred_def_78770,type,
    v132675: state_type > $o ).

tff(pred_def_78771,type,
    v132672: ( state_type * $int ) > $o ).

tff(pred_def_78772,type,
    v132674: ( state_type * $int ) > $o ).

tff(pred_def_78773,type,
    v132663: ( state_type * $int ) > $o ).

tff(pred_def_78774,type,
    v132579: ( state_type * $int ) > $o ).

tff(pred_def_78775,type,
    v132577: ( state_type * $int ) > $o ).

tff(pred_def_78776,type,
    v132575: ( state_type * $int ) > $o ).

tff(pred_def_78777,type,
    v132687: state_type > $o ).

tff(pred_def_78778,type,
    v132685: state_type > $o ).

tff(pred_def_78779,type,
    v132684: state_type > $o ).

tff(pred_def_78780,type,
    v132683: ( state_type * $int ) > $o ).

tff(pred_def_78781,type,
    v132681: ( state_type * $int ) > $o ).

tff(pred_def_78782,type,
    v132697: state_type > $o ).

tff(pred_def_78783,type,
    v132695: state_type > $o ).

tff(pred_def_78784,type,
    v132694: state_type > $o ).

tff(pred_def_78785,type,
    v132693: ( state_type * $int ) > $o ).

tff(pred_def_78786,type,
    v132691: ( state_type * $int ) > $o ).

tff(pred_def_78787,type,
    v132707: state_type > $o ).

tff(pred_def_78788,type,
    v132705: state_type > $o ).

tff(pred_def_78789,type,
    v132704: state_type > $o ).

tff(pred_def_78790,type,
    v132703: ( state_type * $int ) > $o ).

tff(pred_def_78791,type,
    v132701: ( state_type * $int ) > $o ).

tff(pred_def_78792,type,
    v132573: ( state_type * $int ) > $o ).

tff(pred_def_78793,type,
    v132571: ( state_type * $int ) > $o ).

tff(pred_def_78794,type,
    v132564: state_type > $o ).

tff(pred_def_78795,type,
    v132562: state_type > $o ).

tff(pred_def_78796,type,
    v132560: state_type > $o ).

tff(pred_def_78797,type,
    v132558: state_type > $o ).

tff(pred_def_78798,type,
    v132556: state_type > $o ).

tff(pred_def_78799,type,
    v132554: state_type > $o ).

tff(pred_def_78800,type,
    v132727: ( state_type * $int ) > $o ).

tff(pred_def_78801,type,
    v132725: ( state_type * $int ) > $o ).

tff(pred_def_78802,type,
    v132748: state_type > $o ).

tff(pred_def_78803,type,
    v132746: state_type > $o ).

tff(pred_def_78804,type,
    v132744: state_type > $o ).

tff(pred_def_78805,type,
    v132742: state_type > $o ).

tff(pred_def_78806,type,
    v132740: state_type > $o ).

tff(pred_def_78807,type,
    v132758: state_type > $o ).

tff(pred_def_78808,type,
    v132756: state_type > $o ).

tff(pred_def_78809,type,
    v132754: state_type > $o ).

tff(pred_def_78810,type,
    v132752: state_type > $o ).

tff(pred_def_78811,type,
    v132750: state_type > $o ).

tff(pred_def_78812,type,
    v132763: ( state_type * $int ) > $o ).

tff(pred_def_78813,type,
    v132762: ( state_type * $int ) > $o ).

tff(pred_def_78814,type,
    v132760: ( state_type * $int ) > $o ).

tff(pred_def_78815,type,
    v132773: state_type > $o ).

tff(pred_def_78816,type,
    v132771: state_type > $o ).

tff(pred_def_78817,type,
    v132779: state_type > $o ).

tff(pred_def_78818,type,
    v132777: state_type > $o ).

tff(pred_def_78819,type,
    v132793: state_type > $o ).

tff(pred_def_78820,type,
    v132791: state_type > $o ).

tff(pred_def_78821,type,
    v132789: state_type > $o ).

tff(pred_def_78822,type,
    v132787: state_type > $o ).

tff(pred_def_78823,type,
    v132785: state_type > $o ).

tff(pred_def_78824,type,
    v132783: state_type > $o ).

tff(pred_def_78825,type,
    v132781: state_type > $o ).

tff(pred_def_78826,type,
    v132797: state_type > $o ).

tff(pred_def_78827,type,
    v132795: state_type > $o ).

tff(pred_def_78828,type,
    v132775: state_type > $o ).

tff(pred_def_78829,type,
    v132803: state_type > $o ).

tff(pred_def_78830,type,
    v132805: state_type > $o ).

tff(pred_def_78831,type,
    v132801: state_type > $o ).

tff(pred_def_78832,type,
    v132800: state_type > $o ).

tff(pred_def_78833,type,
    v132811: state_type > $o ).

tff(pred_def_78834,type,
    v132812: state_type > $o ).

tff(pred_def_78835,type,
    v132808: state_type > $o ).

tff(pred_def_78836,type,
    v132810: state_type > $o ).

tff(pred_def_78837,type,
    v132818: state_type > $o ).

tff(pred_def_78838,type,
    v132816: state_type > $o ).

tff(pred_def_78839,type,
    v132820: state_type > $o ).

tff(pred_def_78840,type,
    v132769: state_type > $o ).

tff(pred_def_78841,type,
    v132767: state_type > $o ).

tff(pred_def_78842,type,
    v132765: state_type > $o ).

tff(pred_def_78843,type,
    v132827: state_type > $o ).

tff(pred_def_78844,type,
    v132825: state_type > $o ).

tff(pred_def_78845,type,
    v132824: state_type > $o ).

tff(pred_def_78846,type,
    v132823: state_type > $o ).

tff(pred_def_78847,type,
    v132835: state_type > $o ).

tff(pred_def_78848,type,
    v132836: state_type > $o ).

tff(pred_def_78849,type,
    v132834: state_type > $o ).

tff(pred_def_78850,type,
    v132831: ( state_type * $int ) > $o ).

tff(pred_def_78851,type,
    v132833: ( state_type * $int ) > $o ).

tff(pred_def_78852,type,
    v132822: ( state_type * $int ) > $o ).

tff(pred_def_78853,type,
    v132738: ( state_type * $int ) > $o ).

tff(pred_def_78854,type,
    v132736: ( state_type * $int ) > $o ).

tff(pred_def_78855,type,
    v132734: ( state_type * $int ) > $o ).

tff(pred_def_78856,type,
    v132846: state_type > $o ).

tff(pred_def_78857,type,
    v132844: state_type > $o ).

tff(pred_def_78858,type,
    v132843: state_type > $o ).

tff(pred_def_78859,type,
    v132842: ( state_type * $int ) > $o ).

tff(pred_def_78860,type,
    v132840: ( state_type * $int ) > $o ).

tff(pred_def_78861,type,
    v132856: state_type > $o ).

tff(pred_def_78862,type,
    v132854: state_type > $o ).

tff(pred_def_78863,type,
    v132853: state_type > $o ).

tff(pred_def_78864,type,
    v132852: ( state_type * $int ) > $o ).

tff(pred_def_78865,type,
    v132850: ( state_type * $int ) > $o ).

tff(pred_def_78866,type,
    v132866: state_type > $o ).

tff(pred_def_78867,type,
    v132864: state_type > $o ).

tff(pred_def_78868,type,
    v132863: state_type > $o ).

tff(pred_def_78869,type,
    v132862: ( state_type * $int ) > $o ).

tff(pred_def_78870,type,
    v132860: ( state_type * $int ) > $o ).

tff(pred_def_78871,type,
    v132732: ( state_type * $int ) > $o ).

tff(pred_def_78872,type,
    v132730: ( state_type * $int ) > $o ).

tff(pred_def_78873,type,
    v132723: state_type > $o ).

tff(pred_def_78874,type,
    v132721: state_type > $o ).

tff(pred_def_78875,type,
    v132719: state_type > $o ).

tff(pred_def_78876,type,
    v132717: state_type > $o ).

tff(pred_def_78877,type,
    v132715: state_type > $o ).

tff(pred_def_78878,type,
    v132713: state_type > $o ).

tff(pred_def_78879,type,
    v132886: ( state_type * $int ) > $o ).

tff(pred_def_78880,type,
    v132884: ( state_type * $int ) > $o ).

tff(pred_def_78881,type,
    v132907: state_type > $o ).

tff(pred_def_78882,type,
    v132905: state_type > $o ).

tff(pred_def_78883,type,
    v132903: state_type > $o ).

tff(pred_def_78884,type,
    v132901: state_type > $o ).

tff(pred_def_78885,type,
    v132899: state_type > $o ).

tff(pred_def_78886,type,
    v132917: state_type > $o ).

tff(pred_def_78887,type,
    v132915: state_type > $o ).

tff(pred_def_78888,type,
    v132913: state_type > $o ).

tff(pred_def_78889,type,
    v132911: state_type > $o ).

tff(pred_def_78890,type,
    v132909: state_type > $o ).

tff(pred_def_78891,type,
    v132922: ( state_type * $int ) > $o ).

tff(pred_def_78892,type,
    v132921: ( state_type * $int ) > $o ).

tff(pred_def_78893,type,
    v132919: ( state_type * $int ) > $o ).

tff(pred_def_78894,type,
    v132932: state_type > $o ).

tff(pred_def_78895,type,
    v132930: state_type > $o ).

tff(pred_def_78896,type,
    v132938: state_type > $o ).

tff(pred_def_78897,type,
    v132936: state_type > $o ).

tff(pred_def_78898,type,
    v132952: state_type > $o ).

tff(pred_def_78899,type,
    v132950: state_type > $o ).

tff(pred_def_78900,type,
    v132948: state_type > $o ).

tff(pred_def_78901,type,
    v132946: state_type > $o ).

tff(pred_def_78902,type,
    v132944: state_type > $o ).

tff(pred_def_78903,type,
    v132942: state_type > $o ).

tff(pred_def_78904,type,
    v132940: state_type > $o ).

tff(pred_def_78905,type,
    v132956: state_type > $o ).

tff(pred_def_78906,type,
    v132954: state_type > $o ).

tff(pred_def_78907,type,
    v132934: state_type > $o ).

tff(pred_def_78908,type,
    v132962: state_type > $o ).

tff(pred_def_78909,type,
    v132964: state_type > $o ).

tff(pred_def_78910,type,
    v132960: state_type > $o ).

tff(pred_def_78911,type,
    v132959: state_type > $o ).

tff(pred_def_78912,type,
    v132970: state_type > $o ).

tff(pred_def_78913,type,
    v132971: state_type > $o ).

tff(pred_def_78914,type,
    v132967: state_type > $o ).

tff(pred_def_78915,type,
    v132969: state_type > $o ).

tff(pred_def_78916,type,
    v132977: state_type > $o ).

tff(pred_def_78917,type,
    v132975: state_type > $o ).

tff(pred_def_78918,type,
    v132979: state_type > $o ).

tff(pred_def_78919,type,
    v132928: state_type > $o ).

tff(pred_def_78920,type,
    v132926: state_type > $o ).

tff(pred_def_78921,type,
    v132924: state_type > $o ).

tff(pred_def_78922,type,
    v132986: state_type > $o ).

tff(pred_def_78923,type,
    v132984: state_type > $o ).

tff(pred_def_78924,type,
    v132983: state_type > $o ).

tff(pred_def_78925,type,
    v132982: state_type > $o ).

tff(pred_def_78926,type,
    v132994: state_type > $o ).

tff(pred_def_78927,type,
    v132995: state_type > $o ).

tff(pred_def_78928,type,
    v132993: state_type > $o ).

tff(pred_def_78929,type,
    v132990: ( state_type * $int ) > $o ).

tff(pred_def_78930,type,
    v132992: ( state_type * $int ) > $o ).

tff(pred_def_78931,type,
    v132981: ( state_type * $int ) > $o ).

tff(pred_def_78932,type,
    v132897: ( state_type * $int ) > $o ).

tff(pred_def_78933,type,
    v132895: ( state_type * $int ) > $o ).

tff(pred_def_78934,type,
    v132893: ( state_type * $int ) > $o ).

tff(pred_def_78935,type,
    v133005: state_type > $o ).

tff(pred_def_78936,type,
    v133003: state_type > $o ).

tff(pred_def_78937,type,
    v133002: state_type > $o ).

tff(pred_def_78938,type,
    v133001: ( state_type * $int ) > $o ).

tff(pred_def_78939,type,
    v132999: ( state_type * $int ) > $o ).

tff(pred_def_78940,type,
    v133015: state_type > $o ).

tff(pred_def_78941,type,
    v133013: state_type > $o ).

tff(pred_def_78942,type,
    v133012: state_type > $o ).

tff(pred_def_78943,type,
    v133011: ( state_type * $int ) > $o ).

tff(pred_def_78944,type,
    v133009: ( state_type * $int ) > $o ).

tff(pred_def_78945,type,
    v133025: state_type > $o ).

tff(pred_def_78946,type,
    v133023: state_type > $o ).

tff(pred_def_78947,type,
    v133022: state_type > $o ).

tff(pred_def_78948,type,
    v133021: ( state_type * $int ) > $o ).

tff(pred_def_78949,type,
    v133019: ( state_type * $int ) > $o ).

tff(pred_def_78950,type,
    v132891: ( state_type * $int ) > $o ).

tff(pred_def_78951,type,
    v132889: ( state_type * $int ) > $o ).

tff(pred_def_78952,type,
    v132882: state_type > $o ).

tff(pred_def_78953,type,
    v132880: state_type > $o ).

tff(pred_def_78954,type,
    v132878: state_type > $o ).

tff(pred_def_78955,type,
    v132876: state_type > $o ).

tff(pred_def_78956,type,
    v132874: state_type > $o ).

tff(pred_def_78957,type,
    v132872: state_type > $o ).

tff(pred_def_78958,type,
    v133045: ( state_type * $int ) > $o ).

tff(pred_def_78959,type,
    v133043: ( state_type * $int ) > $o ).

tff(pred_def_78960,type,
    v133066: state_type > $o ).

tff(pred_def_78961,type,
    v133064: state_type > $o ).

tff(pred_def_78962,type,
    v133062: state_type > $o ).

tff(pred_def_78963,type,
    v133060: state_type > $o ).

tff(pred_def_78964,type,
    v133058: state_type > $o ).

tff(pred_def_78965,type,
    v133076: state_type > $o ).

tff(pred_def_78966,type,
    v133074: state_type > $o ).

tff(pred_def_78967,type,
    v133072: state_type > $o ).

tff(pred_def_78968,type,
    v133070: state_type > $o ).

tff(pred_def_78969,type,
    v133068: state_type > $o ).

tff(pred_def_78970,type,
    v133081: ( state_type * $int ) > $o ).

tff(pred_def_78971,type,
    v133080: ( state_type * $int ) > $o ).

tff(pred_def_78972,type,
    v133078: ( state_type * $int ) > $o ).

tff(pred_def_78973,type,
    v133091: state_type > $o ).

tff(pred_def_78974,type,
    v133089: state_type > $o ).

tff(pred_def_78975,type,
    v133097: state_type > $o ).

tff(pred_def_78976,type,
    v133095: state_type > $o ).

tff(pred_def_78977,type,
    v133111: state_type > $o ).

tff(pred_def_78978,type,
    v133109: state_type > $o ).

tff(pred_def_78979,type,
    v133107: state_type > $o ).

tff(pred_def_78980,type,
    v133105: state_type > $o ).

tff(pred_def_78981,type,
    v133103: state_type > $o ).

tff(pred_def_78982,type,
    v133101: state_type > $o ).

tff(pred_def_78983,type,
    v133099: state_type > $o ).

tff(pred_def_78984,type,
    v133115: state_type > $o ).

tff(pred_def_78985,type,
    v133113: state_type > $o ).

tff(pred_def_78986,type,
    v133093: state_type > $o ).

tff(pred_def_78987,type,
    v133121: state_type > $o ).

tff(pred_def_78988,type,
    v133123: state_type > $o ).

tff(pred_def_78989,type,
    v133119: state_type > $o ).

tff(pred_def_78990,type,
    v133118: state_type > $o ).

tff(pred_def_78991,type,
    v133129: state_type > $o ).

tff(pred_def_78992,type,
    v133130: state_type > $o ).

tff(pred_def_78993,type,
    v133126: state_type > $o ).

tff(pred_def_78994,type,
    v133128: state_type > $o ).

tff(pred_def_78995,type,
    v133136: state_type > $o ).

tff(pred_def_78996,type,
    v133134: state_type > $o ).

tff(pred_def_78997,type,
    v133138: state_type > $o ).

tff(pred_def_78998,type,
    v133087: state_type > $o ).

tff(pred_def_78999,type,
    v133085: state_type > $o ).

tff(pred_def_79000,type,
    v133083: state_type > $o ).

tff(pred_def_79001,type,
    v133145: state_type > $o ).

tff(pred_def_79002,type,
    v133143: state_type > $o ).

tff(pred_def_79003,type,
    v133142: state_type > $o ).

tff(pred_def_79004,type,
    v133141: state_type > $o ).

tff(pred_def_79005,type,
    v133153: state_type > $o ).

tff(pred_def_79006,type,
    v133154: state_type > $o ).

tff(pred_def_79007,type,
    v133152: state_type > $o ).

tff(pred_def_79008,type,
    v133149: ( state_type * $int ) > $o ).

tff(pred_def_79009,type,
    v133151: ( state_type * $int ) > $o ).

tff(pred_def_79010,type,
    v133140: ( state_type * $int ) > $o ).

tff(pred_def_79011,type,
    v133056: ( state_type * $int ) > $o ).

tff(pred_def_79012,type,
    v133054: ( state_type * $int ) > $o ).

tff(pred_def_79013,type,
    v133052: ( state_type * $int ) > $o ).

tff(pred_def_79014,type,
    v133164: state_type > $o ).

tff(pred_def_79015,type,
    v133162: state_type > $o ).

tff(pred_def_79016,type,
    v133161: state_type > $o ).

tff(pred_def_79017,type,
    v133160: ( state_type * $int ) > $o ).

tff(pred_def_79018,type,
    v133158: ( state_type * $int ) > $o ).

tff(pred_def_79019,type,
    v133174: state_type > $o ).

tff(pred_def_79020,type,
    v133172: state_type > $o ).

tff(pred_def_79021,type,
    v133171: state_type > $o ).

tff(pred_def_79022,type,
    v133170: ( state_type * $int ) > $o ).

tff(pred_def_79023,type,
    v133168: ( state_type * $int ) > $o ).

tff(pred_def_79024,type,
    v133184: state_type > $o ).

tff(pred_def_79025,type,
    v133182: state_type > $o ).

tff(pred_def_79026,type,
    v133181: state_type > $o ).

tff(pred_def_79027,type,
    v133180: ( state_type * $int ) > $o ).

tff(pred_def_79028,type,
    v133178: ( state_type * $int ) > $o ).

tff(pred_def_79029,type,
    v133050: ( state_type * $int ) > $o ).

tff(pred_def_79030,type,
    v133048: ( state_type * $int ) > $o ).

tff(pred_def_79031,type,
    v133041: state_type > $o ).

tff(pred_def_79032,type,
    v133039: state_type > $o ).

tff(pred_def_79033,type,
    v133037: state_type > $o ).

tff(pred_def_79034,type,
    v133035: state_type > $o ).

tff(pred_def_79035,type,
    v133033: state_type > $o ).

tff(pred_def_79036,type,
    v133031: state_type > $o ).

tff(pred_def_79037,type,
    v133204: ( state_type * $int ) > $o ).

tff(pred_def_79038,type,
    v133202: ( state_type * $int ) > $o ).

tff(pred_def_79039,type,
    v133225: state_type > $o ).

tff(pred_def_79040,type,
    v133223: state_type > $o ).

tff(pred_def_79041,type,
    v133221: state_type > $o ).

tff(pred_def_79042,type,
    v133219: state_type > $o ).

tff(pred_def_79043,type,
    v133217: state_type > $o ).

tff(pred_def_79044,type,
    v133235: state_type > $o ).

tff(pred_def_79045,type,
    v133233: state_type > $o ).

tff(pred_def_79046,type,
    v133231: state_type > $o ).

tff(pred_def_79047,type,
    v133229: state_type > $o ).

tff(pred_def_79048,type,
    v133227: state_type > $o ).

tff(pred_def_79049,type,
    v133240: ( state_type * $int ) > $o ).

tff(pred_def_79050,type,
    v133239: ( state_type * $int ) > $o ).

tff(pred_def_79051,type,
    v133237: ( state_type * $int ) > $o ).

tff(pred_def_79052,type,
    v133250: state_type > $o ).

tff(pred_def_79053,type,
    v133248: state_type > $o ).

tff(pred_def_79054,type,
    v133256: state_type > $o ).

tff(pred_def_79055,type,
    v133254: state_type > $o ).

tff(pred_def_79056,type,
    v133270: state_type > $o ).

tff(pred_def_79057,type,
    v133268: state_type > $o ).

tff(pred_def_79058,type,
    v133266: state_type > $o ).

tff(pred_def_79059,type,
    v133264: state_type > $o ).

tff(pred_def_79060,type,
    v133262: state_type > $o ).

tff(pred_def_79061,type,
    v133260: state_type > $o ).

tff(pred_def_79062,type,
    v133258: state_type > $o ).

tff(pred_def_79063,type,
    v133274: state_type > $o ).

tff(pred_def_79064,type,
    v133272: state_type > $o ).

tff(pred_def_79065,type,
    v133252: state_type > $o ).

tff(pred_def_79066,type,
    v133280: state_type > $o ).

tff(pred_def_79067,type,
    v133282: state_type > $o ).

tff(pred_def_79068,type,
    v133278: state_type > $o ).

tff(pred_def_79069,type,
    v133277: state_type > $o ).

tff(pred_def_79070,type,
    v133288: state_type > $o ).

tff(pred_def_79071,type,
    v133289: state_type > $o ).

tff(pred_def_79072,type,
    v133285: state_type > $o ).

tff(pred_def_79073,type,
    v133287: state_type > $o ).

tff(pred_def_79074,type,
    v133295: state_type > $o ).

tff(pred_def_79075,type,
    v133293: state_type > $o ).

tff(pred_def_79076,type,
    v133297: state_type > $o ).

tff(pred_def_79077,type,
    v133246: state_type > $o ).

tff(pred_def_79078,type,
    v133244: state_type > $o ).

tff(pred_def_79079,type,
    v133242: state_type > $o ).

tff(pred_def_79080,type,
    v133304: state_type > $o ).

tff(pred_def_79081,type,
    v133302: state_type > $o ).

tff(pred_def_79082,type,
    v133301: state_type > $o ).

tff(pred_def_79083,type,
    v133300: state_type > $o ).

tff(pred_def_79084,type,
    v133312: state_type > $o ).

tff(pred_def_79085,type,
    v133313: state_type > $o ).

tff(pred_def_79086,type,
    v133311: state_type > $o ).

tff(pred_def_79087,type,
    v133308: ( state_type * $int ) > $o ).

tff(pred_def_79088,type,
    v133310: ( state_type * $int ) > $o ).

tff(pred_def_79089,type,
    v133299: ( state_type * $int ) > $o ).

tff(pred_def_79090,type,
    v133215: ( state_type * $int ) > $o ).

tff(pred_def_79091,type,
    v133213: ( state_type * $int ) > $o ).

tff(pred_def_79092,type,
    v133211: ( state_type * $int ) > $o ).

tff(pred_def_79093,type,
    v133323: state_type > $o ).

tff(pred_def_79094,type,
    v133321: state_type > $o ).

tff(pred_def_79095,type,
    v133320: state_type > $o ).

tff(pred_def_79096,type,
    v133319: ( state_type * $int ) > $o ).

tff(pred_def_79097,type,
    v133317: ( state_type * $int ) > $o ).

tff(pred_def_79098,type,
    v133333: state_type > $o ).

tff(pred_def_79099,type,
    v133331: state_type > $o ).

tff(pred_def_79100,type,
    v133330: state_type > $o ).

tff(pred_def_79101,type,
    v133329: ( state_type * $int ) > $o ).

tff(pred_def_79102,type,
    v133327: ( state_type * $int ) > $o ).

tff(pred_def_79103,type,
    v133343: state_type > $o ).

tff(pred_def_79104,type,
    v133341: state_type > $o ).

tff(pred_def_79105,type,
    v133340: state_type > $o ).

tff(pred_def_79106,type,
    v133339: ( state_type * $int ) > $o ).

tff(pred_def_79107,type,
    v133337: ( state_type * $int ) > $o ).

tff(pred_def_79108,type,
    v133209: ( state_type * $int ) > $o ).

tff(pred_def_79109,type,
    v133207: ( state_type * $int ) > $o ).

tff(pred_def_79110,type,
    v133200: state_type > $o ).

tff(pred_def_79111,type,
    v133198: state_type > $o ).

tff(pred_def_79112,type,
    v133196: state_type > $o ).

tff(pred_def_79113,type,
    v133194: state_type > $o ).

tff(pred_def_79114,type,
    v133192: state_type > $o ).

tff(pred_def_79115,type,
    v133190: state_type > $o ).

tff(pred_def_79116,type,
    v133363: ( state_type * $int ) > $o ).

tff(pred_def_79117,type,
    v133361: ( state_type * $int ) > $o ).

tff(pred_def_79118,type,
    v133384: state_type > $o ).

tff(pred_def_79119,type,
    v133382: state_type > $o ).

tff(pred_def_79120,type,
    v133380: state_type > $o ).

tff(pred_def_79121,type,
    v133378: state_type > $o ).

tff(pred_def_79122,type,
    v133376: state_type > $o ).

tff(pred_def_79123,type,
    v133394: state_type > $o ).

tff(pred_def_79124,type,
    v133392: state_type > $o ).

tff(pred_def_79125,type,
    v133390: state_type > $o ).

tff(pred_def_79126,type,
    v133388: state_type > $o ).

tff(pred_def_79127,type,
    v133386: state_type > $o ).

tff(pred_def_79128,type,
    v133399: ( state_type * $int ) > $o ).

tff(pred_def_79129,type,
    v133398: ( state_type * $int ) > $o ).

tff(pred_def_79130,type,
    v133396: ( state_type * $int ) > $o ).

tff(pred_def_79131,type,
    v133409: state_type > $o ).

tff(pred_def_79132,type,
    v133407: state_type > $o ).

tff(pred_def_79133,type,
    v133415: state_type > $o ).

tff(pred_def_79134,type,
    v133413: state_type > $o ).

tff(pred_def_79135,type,
    v133429: state_type > $o ).

tff(pred_def_79136,type,
    v133427: state_type > $o ).

tff(pred_def_79137,type,
    v133425: state_type > $o ).

tff(pred_def_79138,type,
    v133423: state_type > $o ).

tff(pred_def_79139,type,
    v133421: state_type > $o ).

tff(pred_def_79140,type,
    v133419: state_type > $o ).

tff(pred_def_79141,type,
    v133417: state_type > $o ).

tff(pred_def_79142,type,
    v133433: state_type > $o ).

tff(pred_def_79143,type,
    v133431: state_type > $o ).

tff(pred_def_79144,type,
    v133411: state_type > $o ).

tff(pred_def_79145,type,
    v133439: state_type > $o ).

tff(pred_def_79146,type,
    v133441: state_type > $o ).

tff(pred_def_79147,type,
    v133437: state_type > $o ).

tff(pred_def_79148,type,
    v133436: state_type > $o ).

tff(pred_def_79149,type,
    v133447: state_type > $o ).

tff(pred_def_79150,type,
    v133448: state_type > $o ).

tff(pred_def_79151,type,
    v133444: state_type > $o ).

tff(pred_def_79152,type,
    v133446: state_type > $o ).

tff(pred_def_79153,type,
    v133454: state_type > $o ).

tff(pred_def_79154,type,
    v133452: state_type > $o ).

tff(pred_def_79155,type,
    v133456: state_type > $o ).

tff(pred_def_79156,type,
    v133405: state_type > $o ).

tff(pred_def_79157,type,
    v133403: state_type > $o ).

tff(pred_def_79158,type,
    v133401: state_type > $o ).

tff(pred_def_79159,type,
    v133463: state_type > $o ).

tff(pred_def_79160,type,
    v133461: state_type > $o ).

tff(pred_def_79161,type,
    v133460: state_type > $o ).

tff(pred_def_79162,type,
    v133459: state_type > $o ).

tff(pred_def_79163,type,
    v133471: state_type > $o ).

tff(pred_def_79164,type,
    v133472: state_type > $o ).

tff(pred_def_79165,type,
    v133470: state_type > $o ).

tff(pred_def_79166,type,
    v133467: ( state_type * $int ) > $o ).

tff(pred_def_79167,type,
    v133469: ( state_type * $int ) > $o ).

tff(pred_def_79168,type,
    v133458: ( state_type * $int ) > $o ).

tff(pred_def_79169,type,
    v133374: ( state_type * $int ) > $o ).

tff(pred_def_79170,type,
    v133372: ( state_type * $int ) > $o ).

tff(pred_def_79171,type,
    v133370: ( state_type * $int ) > $o ).

tff(pred_def_79172,type,
    v133482: state_type > $o ).

tff(pred_def_79173,type,
    v133480: state_type > $o ).

tff(pred_def_79174,type,
    v133479: state_type > $o ).

tff(pred_def_79175,type,
    v133478: ( state_type * $int ) > $o ).

tff(pred_def_79176,type,
    v133476: ( state_type * $int ) > $o ).

tff(pred_def_79177,type,
    v133492: state_type > $o ).

tff(pred_def_79178,type,
    v133490: state_type > $o ).

tff(pred_def_79179,type,
    v133489: state_type > $o ).

tff(pred_def_79180,type,
    v133488: ( state_type * $int ) > $o ).

tff(pred_def_79181,type,
    v133486: ( state_type * $int ) > $o ).

tff(pred_def_79182,type,
    v133502: state_type > $o ).

tff(pred_def_79183,type,
    v133500: state_type > $o ).

tff(pred_def_79184,type,
    v133499: state_type > $o ).

tff(pred_def_79185,type,
    v133498: ( state_type * $int ) > $o ).

tff(pred_def_79186,type,
    v133496: ( state_type * $int ) > $o ).

tff(pred_def_79187,type,
    v133368: ( state_type * $int ) > $o ).

tff(pred_def_79188,type,
    v133366: ( state_type * $int ) > $o ).

tff(pred_def_79189,type,
    v133359: state_type > $o ).

tff(pred_def_79190,type,
    v133357: state_type > $o ).

tff(pred_def_79191,type,
    v133355: state_type > $o ).

tff(pred_def_79192,type,
    v133353: state_type > $o ).

tff(pred_def_79193,type,
    v133351: state_type > $o ).

tff(pred_def_79194,type,
    v133349: state_type > $o ).

tff(pred_def_79195,type,
    v133508: ( state_type * $int ) > $o ).

tff(pred_def_79196,type,
    v133516: state_type > $o ).

tff(pred_def_79197,type,
    v133515: state_type > $o ).

tff(pred_def_79198,type,
    v133514: state_type > $o ).

tff(pred_def_79199,type,
    v133513: state_type > $o ).

tff(pred_def_79200,type,
    v133512: state_type > $o ).

tff(pred_def_79201,type,
    v133511: state_type > $o ).

tff(pred_def_79202,type,
    v89407: state_type > $o ).

tff(pred_def_79203,type,
    v133520: state_type > $o ).

tff(pred_def_79204,type,
    v133519: state_type > $o ).

tff(pred_def_79205,type,
    v133518: ( state_type * $int ) > $o ).

tff(pred_def_79206,type,
    v89403: ( state_type * $int ) > $o ).

tff(pred_def_79207,type,
    v89401: ( state_type * $int ) > $o ).

tff(pred_def_79208,type,
    v89399: ( state_type * $int ) > $o ).

tff(pred_def_79209,type,
    v89397: ( state_type * $int ) > $o ).

tff(pred_def_79210,type,
    v133524: state_type > $o ).

tff(pred_def_79211,type,
    v133522: state_type > $o ).

tff(pred_def_79212,type,
    v133531: state_type > $o ).

tff(pred_def_79213,type,
    v133529: state_type > $o ).

tff(pred_def_79214,type,
    v133528: state_type > $o ).

tff(pred_def_79215,type,
    v133527: state_type > $o ).

tff(pred_def_79216,type,
    v133539: state_type > $o ).

tff(pred_def_79217,type,
    v133540: state_type > $o ).

tff(pred_def_79218,type,
    v133538: state_type > $o ).

tff(pred_def_79219,type,
    v133535: ( state_type * $int ) > $o ).

tff(pred_def_79220,type,
    v133537: ( state_type * $int ) > $o ).

tff(pred_def_79221,type,
    v89387: ( state_type * $int ) > $o ).

tff(pred_def_79222,type,
    v89385: ( state_type * $int ) > $o ).

tff(pred_def_79223,type,
    v133545: state_type > $o ).

tff(pred_def_79224,type,
    v133544: state_type > $o ).

tff(pred_def_79225,type,
    v109144: state_type > $o ).

tff(pred_def_79226,type,
    v133546: state_type > $o ).

tff(pred_def_79227,type,
    v89339: state_type > $o ).

tff(pred_def_79228,type,
    v133553: state_type > $o ).

tff(pred_def_79229,type,
    v133551: state_type > $o ).

tff(pred_def_79230,type,
    v133550: state_type > $o ).

tff(pred_def_79231,type,
    v133549: ( state_type * $int ) > $o ).

tff(pred_def_79232,type,
    v133561: state_type > $o ).

tff(pred_def_79233,type,
    v133559: state_type > $o ).

tff(pred_def_79234,type,
    v133558: state_type > $o ).

tff(pred_def_79235,type,
    v133557: ( state_type * $int ) > $o ).

tff(pred_def_79236,type,
    v133569: state_type > $o ).

tff(pred_def_79237,type,
    v133567: state_type > $o ).

tff(pred_def_79238,type,
    v133566: state_type > $o ).

tff(pred_def_79239,type,
    v133565: ( state_type * $int ) > $o ).

tff(pred_def_79240,type,
    v133577: state_type > $o ).

tff(pred_def_79241,type,
    v133575: state_type > $o ).

tff(pred_def_79242,type,
    v133574: state_type > $o ).

tff(pred_def_79243,type,
    v133573: ( state_type * $int ) > $o ).

tff(pred_def_79244,type,
    v133585: state_type > $o ).

tff(pred_def_79245,type,
    v133583: state_type > $o ).

tff(pred_def_79246,type,
    v133582: state_type > $o ).

tff(pred_def_79247,type,
    v133581: ( state_type * $int ) > $o ).

tff(pred_def_79248,type,
    v133593: state_type > $o ).

tff(pred_def_79249,type,
    v133591: state_type > $o ).

tff(pred_def_79250,type,
    v133590: state_type > $o ).

tff(pred_def_79251,type,
    v133589: ( state_type * $int ) > $o ).

tff(pred_def_79252,type,
    v133601: state_type > $o ).

tff(pred_def_79253,type,
    v133599: state_type > $o ).

tff(pred_def_79254,type,
    v133598: state_type > $o ).

tff(pred_def_79255,type,
    v133597: ( state_type * $int ) > $o ).

tff(pred_def_79256,type,
    v133609: state_type > $o ).

tff(pred_def_79257,type,
    v133607: state_type > $o ).

tff(pred_def_79258,type,
    v133606: state_type > $o ).

tff(pred_def_79259,type,
    v133605: ( state_type * $int ) > $o ).

tff(pred_def_79260,type,
    v133616: state_type > $o ).

tff(pred_def_79261,type,
    v133615: state_type > $o ).

tff(pred_def_79262,type,
    v133618: state_type > $o ).

tff(pred_def_79263,type,
    v133617: state_type > $o ).

tff(pred_def_79264,type,
    v133614: state_type > $o ).

tff(pred_def_79265,type,
    v133620: state_type > $o ).

tff(pred_def_79266,type,
    v133619: state_type > $o ).

tff(pred_def_79267,type,
    v133613: state_type > $o ).

tff(pred_def_79268,type,
    v133622: state_type > $o ).

tff(pred_def_79269,type,
    v133621: state_type > $o ).

tff(pred_def_79270,type,
    v133628: state_type > $o ).

tff(pred_def_79271,type,
    v133626: state_type > $o ).

tff(pred_def_79272,type,
    v133625: state_type > $o ).

tff(pred_def_79273,type,
    v133624: ( state_type * $int ) > $o ).

tff(pred_def_79274,type,
    v89190: state_type > $o ).

tff(pred_def_79275,type,
    v133632: state_type > $o ).

tff(pred_def_79276,type,
    v89160: state_type > $o ).

tff(pred_def_79277,type,
    v133634: state_type > $o ).

tff(pred_def_79278,type,
    v133635: state_type > $o ).

tff(pred_def_79279,type,
    v133633: state_type > $o ).

tff(pred_def_79280,type,
    v89188: state_type > $o ).

tff(pred_def_79281,type,
    v89186: state_type > $o ).

tff(pred_def_79282,type,
    v89184: state_type > $o ).

tff(pred_def_79283,type,
    v89182: state_type > $o ).

tff(pred_def_79284,type,
    v133640: state_type > $o ).

tff(pred_def_79285,type,
    v133638: state_type > $o ).

tff(pred_def_79286,type,
    v133647: state_type > $o ).

tff(pred_def_79287,type,
    v133645: state_type > $o ).

tff(pred_def_79288,type,
    v133644: state_type > $o ).

tff(pred_def_79289,type,
    v133643: state_type > $o ).

tff(pred_def_79290,type,
    v133655: state_type > $o ).

tff(pred_def_79291,type,
    v133656: state_type > $o ).

tff(pred_def_79292,type,
    v133654: state_type > $o ).

tff(pred_def_79293,type,
    v133651: state_type > $o ).

tff(pred_def_79294,type,
    v133653: state_type > $o ).

tff(pred_def_79295,type,
    v89164: state_type > $o ).

tff(pred_def_79296,type,
    v89162: state_type > $o ).

tff(pred_def_79297,type,
    v89158: state_type > $o ).

tff(pred_def_79298,type,
    v89156: ( state_type * $int ) > $o ).

tff(pred_def_79299,type,
    v133673: state_type > $o ).

tff(pred_def_79300,type,
    v133671: state_type > $o ).

tff(pred_def_79301,type,
    v133677: state_type > $o ).

tff(pred_def_79302,type,
    v133675: state_type > $o ).

tff(pred_def_79303,type,
    v133699: state_type > $o ).

tff(pred_def_79304,type,
    v133697: state_type > $o ).

tff(pred_def_79305,type,
    v133703: state_type > $o ).

tff(pred_def_79306,type,
    v133701: state_type > $o ).

tff(pred_def_79307,type,
    v133711: ( state_type * $int ) > $o ).

tff(pred_def_79308,type,
    v133709: ( state_type * $int ) > $o ).

tff(pred_def_79309,type,
    b0000010011000: $int > $o ).

tff(pred_def_79310,type,
    v133718: state_type > $o ).

tff(pred_def_79311,type,
    v133715: state_type > $o ).

tff(pred_def_79312,type,
    v133713: state_type > $o ).

tff(pred_def_79313,type,
    v133722: state_type > $o ).

tff(pred_def_79314,type,
    v133721: ( state_type * $int ) > $o ).

tff(pred_def_79315,type,
    v133720: ( state_type * $int ) > $o ).

tff(pred_def_79316,type,
    v133726: state_type > $o ).

tff(pred_def_79317,type,
    v133725: ( state_type * $int ) > $o ).

tff(pred_def_79318,type,
    v133724: ( state_type * $int ) > $o ).

tff(pred_def_79319,type,
    v133693: ( state_type * $int ) > $o ).

tff(pred_def_79320,type,
    v133723: ( state_type * $int ) > $o ).

tff(pred_def_79321,type,
    v133719: ( state_type * $int ) > $o ).

tff(pred_def_79322,type,
    v133707: ( state_type * $int ) > $o ).

tff(pred_def_79323,type,
    v133705: ( state_type * $int ) > $o ).

tff(pred_def_79324,type,
    v133730: state_type > $o ).

tff(pred_def_79325,type,
    v133728: state_type > $o ).

tff(pred_def_79326,type,
    v133737: state_type > $o ).

tff(pred_def_79327,type,
    v133735: state_type > $o ).

tff(pred_def_79328,type,
    v133734: state_type > $o ).

tff(pred_def_79329,type,
    v133733: state_type > $o ).

tff(pred_def_79330,type,
    v133745: state_type > $o ).

tff(pred_def_79331,type,
    v133746: state_type > $o ).

tff(pred_def_79332,type,
    v133744: state_type > $o ).

tff(pred_def_79333,type,
    v133741: ( state_type * $int ) > $o ).

tff(pred_def_79334,type,
    v133743: ( state_type * $int ) > $o ).

tff(pred_def_79335,type,
    v133732: ( state_type * $int ) > $o ).

tff(pred_def_79336,type,
    v133695: ( state_type * $int ) > $o ).

tff(pred_def_79337,type,
    v133691: ( state_type * $int ) > $o ).

tff(pred_def_79338,type,
    v133754: state_type > $o ).

tff(pred_def_79339,type,
    v133752: state_type > $o ).

tff(pred_def_79340,type,
    v133751: state_type > $o ).

tff(pred_def_79341,type,
    v133750: ( state_type * $int ) > $o ).

tff(pred_def_79342,type,
    v133762: state_type > $o ).

tff(pred_def_79343,type,
    v133760: state_type > $o ).

tff(pred_def_79344,type,
    v133759: state_type > $o ).

tff(pred_def_79345,type,
    v133758: ( state_type * $int ) > $o ).

tff(pred_def_79346,type,
    v133770: state_type > $o ).

tff(pred_def_79347,type,
    v133768: state_type > $o ).

tff(pred_def_79348,type,
    v133767: state_type > $o ).

tff(pred_def_79349,type,
    v133766: ( state_type * $int ) > $o ).

tff(pred_def_79350,type,
    v133782: state_type > $o ).

tff(pred_def_79351,type,
    v133780: state_type > $o ).

tff(pred_def_79352,type,
    v133786: state_type > $o ).

tff(pred_def_79353,type,
    v133784: state_type > $o ).

tff(pred_def_79354,type,
    v133794: ( state_type * $int ) > $o ).

tff(pred_def_79355,type,
    v133796: state_type > $o ).

tff(pred_def_79356,type,
    v133795: ( state_type * $int ) > $o ).

tff(pred_def_79357,type,
    v133792: ( state_type * $int ) > $o ).

tff(pred_def_79358,type,
    b0000011100000: $int > $o ).

tff(pred_def_79359,type,
    v133803: state_type > $o ).

tff(pred_def_79360,type,
    v133800: state_type > $o ).

tff(pred_def_79361,type,
    v133798: state_type > $o ).

tff(pred_def_79362,type,
    v133807: state_type > $o ).

tff(pred_def_79363,type,
    v133806: ( state_type * $int ) > $o ).

tff(pred_def_79364,type,
    v133805: ( state_type * $int ) > $o ).

tff(pred_def_79365,type,
    v133811: state_type > $o ).

tff(pred_def_79366,type,
    v133810: ( state_type * $int ) > $o ).

tff(pred_def_79367,type,
    v133809: ( state_type * $int ) > $o ).

tff(pred_def_79368,type,
    v133776: ( state_type * $int ) > $o ).

tff(pred_def_79369,type,
    v133808: ( state_type * $int ) > $o ).

tff(pred_def_79370,type,
    v133804: ( state_type * $int ) > $o ).

tff(pred_def_79371,type,
    v133790: ( state_type * $int ) > $o ).

tff(pred_def_79372,type,
    v133788: ( state_type * $int ) > $o ).

tff(pred_def_79373,type,
    v133815: state_type > $o ).

tff(pred_def_79374,type,
    v133813: state_type > $o ).

tff(pred_def_79375,type,
    v133822: state_type > $o ).

tff(pred_def_79376,type,
    v133820: state_type > $o ).

tff(pred_def_79377,type,
    v133819: state_type > $o ).

tff(pred_def_79378,type,
    v133818: state_type > $o ).

tff(pred_def_79379,type,
    v133830: state_type > $o ).

tff(pred_def_79380,type,
    v133831: state_type > $o ).

tff(pred_def_79381,type,
    v133829: state_type > $o ).

tff(pred_def_79382,type,
    v133826: ( state_type * $int ) > $o ).

tff(pred_def_79383,type,
    v133828: ( state_type * $int ) > $o ).

tff(pred_def_79384,type,
    v133817: ( state_type * $int ) > $o ).

tff(pred_def_79385,type,
    v133778: ( state_type * $int ) > $o ).

tff(pred_def_79386,type,
    v133774: ( state_type * $int ) > $o ).

tff(pred_def_79387,type,
    v133843: state_type > $o ).

tff(pred_def_79388,type,
    v133841: state_type > $o ).

tff(pred_def_79389,type,
    v133840: state_type > $o ).

tff(pred_def_79390,type,
    v133839: ( state_type * $int ) > $o ).

tff(pred_def_79391,type,
    v133835: state_type > $o ).

tff(pred_def_79392,type,
    v133877: ( state_type * $int ) > $o ).

tff(pred_def_79393,type,
    v133876: state_type > $o ).

tff(pred_def_79394,type,
    v133880: state_type > $o ).

tff(pred_def_79395,type,
    v133881: state_type > $o ).

tff(pred_def_79396,type,
    v133879: state_type > $o ).

tff(pred_def_79397,type,
    v133882: state_type > $o ).

tff(pred_def_79398,type,
    v133878: state_type > $o ).

tff(pred_def_79399,type,
    v133875: state_type > $o ).

tff(pred_def_79400,type,
    v133883: state_type > $o ).

tff(pred_def_79401,type,
    v133874: state_type > $o ).

tff(pred_def_79402,type,
    v133886: state_type > $o ).

tff(pred_def_79403,type,
    v133887: state_type > $o ).

tff(pred_def_79404,type,
    v133885: state_type > $o ).

tff(pred_def_79405,type,
    v133888: state_type > $o ).

tff(pred_def_79406,type,
    v133884: state_type > $o ).

tff(pred_def_79407,type,
    v133873: state_type > $o ).

tff(pred_def_79408,type,
    v133889: state_type > $o ).

tff(pred_def_79409,type,
    v133872: state_type > $o ).

tff(pred_def_79410,type,
    v133871: state_type > $o ).

tff(pred_def_79411,type,
    v133893: state_type > $o ).

tff(pred_def_79412,type,
    v133894: state_type > $o ).

tff(pred_def_79413,type,
    v133892: state_type > $o ).

tff(pred_def_79414,type,
    v133895: state_type > $o ).

tff(pred_def_79415,type,
    v133891: state_type > $o ).

tff(pred_def_79416,type,
    v133890: state_type > $o ).

tff(pred_def_79417,type,
    v133870: state_type > $o ).

tff(pred_def_79418,type,
    v133896: state_type > $o ).

tff(pred_def_79419,type,
    v133869: state_type > $o ).

tff(pred_def_79420,type,
    v133899: state_type > $o ).

tff(pred_def_79421,type,
    v133900: state_type > $o ).

tff(pred_def_79422,type,
    v133898: state_type > $o ).

tff(pred_def_79423,type,
    v133901: state_type > $o ).

tff(pred_def_79424,type,
    v133897: state_type > $o ).

tff(pred_def_79425,type,
    v133904: state_type > $o ).

tff(pred_def_79426,type,
    v133905: state_type > $o ).

tff(pred_def_79427,type,
    v133903: state_type > $o ).

tff(pred_def_79428,type,
    v133906: state_type > $o ).

tff(pred_def_79429,type,
    v133902: state_type > $o ).

tff(pred_def_79430,type,
    v133909: state_type > $o ).

tff(pred_def_79431,type,
    v133910: state_type > $o ).

tff(pred_def_79432,type,
    v133908: state_type > $o ).

tff(pred_def_79433,type,
    v133911: state_type > $o ).

tff(pred_def_79434,type,
    v133907: state_type > $o ).

tff(pred_def_79435,type,
    v133867: ( state_type * $int ) > $o ).

tff(pred_def_79436,type,
    v133912: ( state_type * $int ) > $o ).

tff(pred_def_79437,type,
    v133866: state_type > $o ).

tff(pred_def_79438,type,
    v133915: state_type > $o ).

tff(pred_def_79439,type,
    v133916: state_type > $o ).

tff(pred_def_79440,type,
    v133914: state_type > $o ).

tff(pred_def_79441,type,
    v133917: state_type > $o ).

tff(pred_def_79442,type,
    v133913: state_type > $o ).

tff(pred_def_79443,type,
    v133865: state_type > $o ).

tff(pred_def_79444,type,
    v133918: state_type > $o ).

tff(pred_def_79445,type,
    v133864: state_type > $o ).

tff(pred_def_79446,type,
    v133921: state_type > $o ).

tff(pred_def_79447,type,
    v133922: state_type > $o ).

tff(pred_def_79448,type,
    v133920: state_type > $o ).

tff(pred_def_79449,type,
    v133923: state_type > $o ).

tff(pred_def_79450,type,
    v133919: state_type > $o ).

tff(pred_def_79451,type,
    v133863: state_type > $o ).

tff(pred_def_79452,type,
    v133924: state_type > $o ).

tff(pred_def_79453,type,
    v133862: state_type > $o ).

tff(pred_def_79454,type,
    v133861: state_type > $o ).

tff(pred_def_79455,type,
    v133928: state_type > $o ).

tff(pred_def_79456,type,
    v133929: state_type > $o ).

tff(pred_def_79457,type,
    v133927: state_type > $o ).

tff(pred_def_79458,type,
    v133930: state_type > $o ).

tff(pred_def_79459,type,
    v133926: state_type > $o ).

tff(pred_def_79460,type,
    v133925: state_type > $o ).

tff(pred_def_79461,type,
    v133860: state_type > $o ).

tff(pred_def_79462,type,
    v133931: state_type > $o ).

tff(pred_def_79463,type,
    v133859: state_type > $o ).

tff(pred_def_79464,type,
    v133934: state_type > $o ).

tff(pred_def_79465,type,
    v133935: state_type > $o ).

tff(pred_def_79466,type,
    v133933: state_type > $o ).

tff(pred_def_79467,type,
    v133936: state_type > $o ).

tff(pred_def_79468,type,
    v133932: state_type > $o ).

tff(pred_def_79469,type,
    v133939: state_type > $o ).

tff(pred_def_79470,type,
    v133940: state_type > $o ).

tff(pred_def_79471,type,
    v133938: state_type > $o ).

tff(pred_def_79472,type,
    v133941: state_type > $o ).

tff(pred_def_79473,type,
    v133937: state_type > $o ).

tff(pred_def_79474,type,
    v133944: state_type > $o ).

tff(pred_def_79475,type,
    v133945: state_type > $o ).

tff(pred_def_79476,type,
    v133943: state_type > $o ).

tff(pred_def_79477,type,
    v133946: state_type > $o ).

tff(pred_def_79478,type,
    v133942: state_type > $o ).

tff(pred_def_79479,type,
    v133857: ( state_type * $int ) > $o ).

tff(pred_def_79480,type,
    v133948: ( state_type * $int ) > $o ).

tff(pred_def_79481,type,
    v133947: ( state_type * $int ) > $o ).

tff(pred_def_79482,type,
    v133856: state_type > $o ).

tff(pred_def_79483,type,
    v133951: state_type > $o ).

tff(pred_def_79484,type,
    v133952: state_type > $o ).

tff(pred_def_79485,type,
    v133950: state_type > $o ).

tff(pred_def_79486,type,
    v133953: state_type > $o ).

tff(pred_def_79487,type,
    v133949: state_type > $o ).

tff(pred_def_79488,type,
    v133855: state_type > $o ).

tff(pred_def_79489,type,
    v133954: state_type > $o ).

tff(pred_def_79490,type,
    v133854: state_type > $o ).

tff(pred_def_79491,type,
    v133957: state_type > $o ).

tff(pred_def_79492,type,
    v133958: state_type > $o ).

tff(pred_def_79493,type,
    v133956: state_type > $o ).

tff(pred_def_79494,type,
    v133959: state_type > $o ).

tff(pred_def_79495,type,
    v133955: state_type > $o ).

tff(pred_def_79496,type,
    v133853: state_type > $o ).

tff(pred_def_79497,type,
    v133960: state_type > $o ).

tff(pred_def_79498,type,
    v133852: state_type > $o ).

tff(pred_def_79499,type,
    v133851: state_type > $o ).

tff(pred_def_79500,type,
    v133964: state_type > $o ).

tff(pred_def_79501,type,
    v133965: state_type > $o ).

tff(pred_def_79502,type,
    v133963: state_type > $o ).

tff(pred_def_79503,type,
    v133966: state_type > $o ).

tff(pred_def_79504,type,
    v133962: state_type > $o ).

tff(pred_def_79505,type,
    v133961: state_type > $o ).

tff(pred_def_79506,type,
    v133850: state_type > $o ).

tff(pred_def_79507,type,
    v133967: state_type > $o ).

tff(pred_def_79508,type,
    v133849: state_type > $o ).

tff(pred_def_79509,type,
    v133970: state_type > $o ).

tff(pred_def_79510,type,
    v133971: state_type > $o ).

tff(pred_def_79511,type,
    v133969: state_type > $o ).

tff(pred_def_79512,type,
    v133972: state_type > $o ).

tff(pred_def_79513,type,
    v133968: state_type > $o ).

tff(pred_def_79514,type,
    v133975: state_type > $o ).

tff(pred_def_79515,type,
    v133976: state_type > $o ).

tff(pred_def_79516,type,
    v133974: state_type > $o ).

tff(pred_def_79517,type,
    v133977: state_type > $o ).

tff(pred_def_79518,type,
    v133973: state_type > $o ).

tff(pred_def_79519,type,
    v133980: state_type > $o ).

tff(pred_def_79520,type,
    v133981: state_type > $o ).

tff(pred_def_79521,type,
    v133979: state_type > $o ).

tff(pred_def_79522,type,
    v133982: state_type > $o ).

tff(pred_def_79523,type,
    v133978: state_type > $o ).

tff(pred_def_79524,type,
    v133689: ( state_type * $int ) > $o ).

tff(pred_def_79525,type,
    v133687: ( state_type * $int ) > $o ).

tff(pred_def_79526,type,
    v133991: state_type > $o ).

tff(pred_def_79527,type,
    v133990: state_type > $o ).

tff(pred_def_79528,type,
    v133989: state_type > $o ).

tff(pred_def_79529,type,
    v133992: state_type > $o ).

tff(pred_def_79530,type,
    v133988: state_type > $o ).

tff(pred_def_79531,type,
    v133993: state_type > $o ).

tff(pred_def_79532,type,
    v133987: state_type > $o ).

tff(pred_def_79533,type,
    v133996: state_type > $o ).

tff(pred_def_79534,type,
    v133997: state_type > $o ).

tff(pred_def_79535,type,
    v133995: state_type > $o ).

tff(pred_def_79536,type,
    v133998: state_type > $o ).

tff(pred_def_79537,type,
    v133994: state_type > $o ).

tff(pred_def_79538,type,
    v134001: state_type > $o ).

tff(pred_def_79539,type,
    v134002: state_type > $o ).

tff(pred_def_79540,type,
    v134000: state_type > $o ).

tff(pred_def_79541,type,
    v134003: state_type > $o ).

tff(pred_def_79542,type,
    v133999: state_type > $o ).

tff(pred_def_79543,type,
    v133985: ( state_type * $int ) > $o ).

tff(pred_def_79544,type,
    v133665: ( state_type * $int ) > $o ).

tff(pred_def_79545,type,
    v134005: state_type > $o ).

tff(pred_def_79546,type,
    v134016: state_type > $o ).

tff(pred_def_79547,type,
    v134015: state_type > $o ).

tff(pred_def_79548,type,
    v134014: state_type > $o ).

tff(pred_def_79549,type,
    v134017: state_type > $o ).

tff(pred_def_79550,type,
    v134013: state_type > $o ).

tff(pred_def_79551,type,
    v134012: state_type > $o ).

tff(pred_def_79552,type,
    v134011: state_type > $o ).

tff(pred_def_79553,type,
    v134010: state_type > $o ).

tff(pred_def_79554,type,
    v134019: state_type > $o ).

tff(pred_def_79555,type,
    v134018: state_type > $o ).

tff(pred_def_79556,type,
    v134009: state_type > $o ).

tff(pred_def_79557,type,
    v134022: state_type > $o ).

tff(pred_def_79558,type,
    v134021: state_type > $o ).

tff(pred_def_79559,type,
    v134023: state_type > $o ).

tff(pred_def_79560,type,
    v134020: state_type > $o ).

tff(pred_def_79561,type,
    v134026: state_type > $o ).

tff(pred_def_79562,type,
    v134025: state_type > $o ).

tff(pred_def_79563,type,
    v134027: state_type > $o ).

tff(pred_def_79564,type,
    v134024: state_type > $o ).

tff(pred_def_79565,type,
    v134007: ( state_type * $int ) > $o ).

tff(pred_def_79566,type,
    v134006: ( state_type * $int ) > $o ).

tff(pred_def_79567,type,
    v134004: ( state_type * $int ) > $o ).

tff(pred_def_79568,type,
    v133984: ( state_type * $int ) > $o ).

tff(pred_def_79569,type,
    v133685: ( state_type * $int ) > $o ).

tff(pred_def_79570,type,
    v133683: ( state_type * $int ) > $o ).

tff(pred_def_79571,type,
    v133681: ( state_type * $int ) > $o ).

tff(pred_def_79572,type,
    v133679: ( state_type * $int ) > $o ).

tff(pred_def_79573,type,
    v134031: state_type > $o ).

tff(pred_def_79574,type,
    v134029: state_type > $o ).

tff(pred_def_79575,type,
    v134038: state_type > $o ).

tff(pred_def_79576,type,
    v134036: state_type > $o ).

tff(pred_def_79577,type,
    v134035: state_type > $o ).

tff(pred_def_79578,type,
    v134034: state_type > $o ).

tff(pred_def_79579,type,
    v134046: state_type > $o ).

tff(pred_def_79580,type,
    v134047: state_type > $o ).

tff(pred_def_79581,type,
    v134045: state_type > $o ).

tff(pred_def_79582,type,
    v134042: ( state_type * $int ) > $o ).

tff(pred_def_79583,type,
    v134044: ( state_type * $int ) > $o ).

tff(pred_def_79584,type,
    v133669: ( state_type * $int ) > $o ).

tff(pred_def_79585,type,
    v133667: ( state_type * $int ) > $o ).

tff(pred_def_79586,type,
    v133663: state_type > $o ).

tff(pred_def_79587,type,
    v133661: ( state_type * $int ) > $o ).

tff(pred_def_79588,type,
    v134062: state_type > $o ).

tff(pred_def_79589,type,
    v134060: state_type > $o ).

tff(pred_def_79590,type,
    v134066: state_type > $o ).

tff(pred_def_79591,type,
    v134064: state_type > $o ).

tff(pred_def_79592,type,
    v134082: state_type > $o ).

tff(pred_def_79593,type,
    v134080: state_type > $o ).

tff(pred_def_79594,type,
    v134079: state_type > $o ).

tff(pred_def_79595,type,
    v134078: ( state_type * $int ) > $o ).

tff(pred_def_79596,type,
    v134076: state_type > $o ).

tff(pred_def_79597,type,
    v134086: state_type > $o ).

tff(pred_def_79598,type,
    v134054: state_type > $o ).

tff(pred_def_79599,type,
    v134088: state_type > $o ).

tff(pred_def_79600,type,
    v134089: state_type > $o ).

tff(pred_def_79601,type,
    v134087: state_type > $o ).

tff(pred_def_79602,type,
    v134074: state_type > $o ).

tff(pred_def_79603,type,
    v134072: state_type > $o ).

tff(pred_def_79604,type,
    v134070: state_type > $o ).

tff(pred_def_79605,type,
    v134068: state_type > $o ).

tff(pred_def_79606,type,
    v134094: state_type > $o ).

tff(pred_def_79607,type,
    v134092: state_type > $o ).

tff(pred_def_79608,type,
    v134101: state_type > $o ).

tff(pred_def_79609,type,
    v134099: state_type > $o ).

tff(pred_def_79610,type,
    v134098: state_type > $o ).

tff(pred_def_79611,type,
    v134097: state_type > $o ).

tff(pred_def_79612,type,
    v134109: state_type > $o ).

tff(pred_def_79613,type,
    v134110: state_type > $o ).

tff(pred_def_79614,type,
    v134108: state_type > $o ).

tff(pred_def_79615,type,
    v134105: state_type > $o ).

tff(pred_def_79616,type,
    v134107: state_type > $o ).

tff(pred_def_79617,type,
    v134058: state_type > $o ).

tff(pred_def_79618,type,
    v134056: state_type > $o ).

tff(pred_def_79619,type,
    v134052: state_type > $o ).

tff(pred_def_79620,type,
    v134125: state_type > $o ).

tff(pred_def_79621,type,
    v134123: state_type > $o ).

tff(pred_def_79622,type,
    v134129: state_type > $o ).

tff(pred_def_79623,type,
    v134127: state_type > $o ).

tff(pred_def_79624,type,
    v134139: ( state_type * $int ) > $o ).

tff(pred_def_79625,type,
    v134148: state_type > $o ).

tff(pred_def_79626,type,
    v134147: state_type > $o ).

tff(pred_def_79627,type,
    v134146: state_type > $o ).

tff(pred_def_79628,type,
    v134149: state_type > $o ).

tff(pred_def_79629,type,
    v134145: state_type > $o ).

tff(pred_def_79630,type,
    v134150: state_type > $o ).

tff(pred_def_79631,type,
    v134144: state_type > $o ).

tff(pred_def_79632,type,
    v134153: state_type > $o ).

tff(pred_def_79633,type,
    v134154: state_type > $o ).

tff(pred_def_79634,type,
    v134152: state_type > $o ).

tff(pred_def_79635,type,
    v134155: state_type > $o ).

tff(pred_def_79636,type,
    v134151: state_type > $o ).

tff(pred_def_79637,type,
    v134158: state_type > $o ).

tff(pred_def_79638,type,
    v134159: state_type > $o ).

tff(pred_def_79639,type,
    v134157: state_type > $o ).

tff(pred_def_79640,type,
    v134160: state_type > $o ).

tff(pred_def_79641,type,
    v134156: state_type > $o ).

tff(pred_def_79642,type,
    v134142: ( state_type * $int ) > $o ).

tff(pred_def_79643,type,
    v134117: ( state_type * $int ) > $o ).

tff(pred_def_79644,type,
    v134162: state_type > $o ).

tff(pred_def_79645,type,
    v134173: state_type > $o ).

tff(pred_def_79646,type,
    v134172: state_type > $o ).

tff(pred_def_79647,type,
    v134171: state_type > $o ).

tff(pred_def_79648,type,
    v134174: state_type > $o ).

tff(pred_def_79649,type,
    v134170: state_type > $o ).

tff(pred_def_79650,type,
    v134169: state_type > $o ).

tff(pred_def_79651,type,
    v134168: state_type > $o ).

tff(pred_def_79652,type,
    v134167: state_type > $o ).

tff(pred_def_79653,type,
    v134176: state_type > $o ).

tff(pred_def_79654,type,
    v134175: state_type > $o ).

tff(pred_def_79655,type,
    v134166: state_type > $o ).

tff(pred_def_79656,type,
    v134179: state_type > $o ).

tff(pred_def_79657,type,
    v134178: state_type > $o ).

tff(pred_def_79658,type,
    v134180: state_type > $o ).

tff(pred_def_79659,type,
    v134177: state_type > $o ).

tff(pred_def_79660,type,
    v134183: state_type > $o ).

tff(pred_def_79661,type,
    v134182: state_type > $o ).

tff(pred_def_79662,type,
    v134184: state_type > $o ).

tff(pred_def_79663,type,
    v134181: state_type > $o ).

tff(pred_def_79664,type,
    v134164: ( state_type * $int ) > $o ).

tff(pred_def_79665,type,
    v134163: ( state_type * $int ) > $o ).

tff(pred_def_79666,type,
    v134161: ( state_type * $int ) > $o ).

tff(pred_def_79667,type,
    v134141: ( state_type * $int ) > $o ).

tff(pred_def_79668,type,
    v134137: ( state_type * $int ) > $o ).

tff(pred_def_79669,type,
    v134135: ( state_type * $int ) > $o ).

tff(pred_def_79670,type,
    v134133: ( state_type * $int ) > $o ).

tff(pred_def_79671,type,
    v134131: ( state_type * $int ) > $o ).

tff(pred_def_79672,type,
    v134188: state_type > $o ).

tff(pred_def_79673,type,
    v134186: state_type > $o ).

tff(pred_def_79674,type,
    v134195: state_type > $o ).

tff(pred_def_79675,type,
    v134193: state_type > $o ).

tff(pred_def_79676,type,
    v134192: state_type > $o ).

tff(pred_def_79677,type,
    v134191: state_type > $o ).

tff(pred_def_79678,type,
    v134203: state_type > $o ).

tff(pred_def_79679,type,
    v134204: state_type > $o ).

tff(pred_def_79680,type,
    v134202: state_type > $o ).

tff(pred_def_79681,type,
    v134199: ( state_type * $int ) > $o ).

tff(pred_def_79682,type,
    v134201: ( state_type * $int ) > $o ).

tff(pred_def_79683,type,
    v134121: ( state_type * $int ) > $o ).

tff(pred_def_79684,type,
    v134119: ( state_type * $int ) > $o ).

tff(pred_def_79685,type,
    v134115: state_type > $o ).

tff(pred_def_79686,type,
    v134219: state_type > $o ).

tff(pred_def_79687,type,
    v134217: state_type > $o ).

tff(pred_def_79688,type,
    v134223: state_type > $o ).

tff(pred_def_79689,type,
    v134221: state_type > $o ).

tff(pred_def_79690,type,
    v134239: state_type > $o ).

tff(pred_def_79691,type,
    v134237: state_type > $o ).

tff(pred_def_79692,type,
    v134236: state_type > $o ).

tff(pred_def_79693,type,
    v134235: ( state_type * $int ) > $o ).

tff(pred_def_79694,type,
    v134233: state_type > $o ).

tff(pred_def_79695,type,
    v134243: state_type > $o ).

tff(pred_def_79696,type,
    v134211: state_type > $o ).

tff(pred_def_79697,type,
    v134245: state_type > $o ).

tff(pred_def_79698,type,
    v134246: state_type > $o ).

tff(pred_def_79699,type,
    v134244: state_type > $o ).

tff(pred_def_79700,type,
    v134231: state_type > $o ).

tff(pred_def_79701,type,
    v134229: state_type > $o ).

tff(pred_def_79702,type,
    v134227: state_type > $o ).

tff(pred_def_79703,type,
    v134225: state_type > $o ).

tff(pred_def_79704,type,
    v134251: state_type > $o ).

tff(pred_def_79705,type,
    v134249: state_type > $o ).

tff(pred_def_79706,type,
    v134258: state_type > $o ).

tff(pred_def_79707,type,
    v134256: state_type > $o ).

tff(pred_def_79708,type,
    v134255: state_type > $o ).

tff(pred_def_79709,type,
    v134254: state_type > $o ).

tff(pred_def_79710,type,
    v134266: state_type > $o ).

tff(pred_def_79711,type,
    v134267: state_type > $o ).

tff(pred_def_79712,type,
    v134265: state_type > $o ).

tff(pred_def_79713,type,
    v134262: state_type > $o ).

tff(pred_def_79714,type,
    v134264: state_type > $o ).

tff(pred_def_79715,type,
    v134215: state_type > $o ).

tff(pred_def_79716,type,
    v134213: state_type > $o ).

tff(pred_def_79717,type,
    v134209: state_type > $o ).

tff(pred_def_79718,type,
    v134282: state_type > $o ).

tff(pred_def_79719,type,
    v134280: state_type > $o ).

tff(pred_def_79720,type,
    v134286: state_type > $o ).

tff(pred_def_79721,type,
    v134284: state_type > $o ).

tff(pred_def_79722,type,
    v134296: ( state_type * $int ) > $o ).

tff(pred_def_79723,type,
    v134305: state_type > $o ).

tff(pred_def_79724,type,
    v134304: state_type > $o ).

tff(pred_def_79725,type,
    v134303: state_type > $o ).

tff(pred_def_79726,type,
    v134306: state_type > $o ).

tff(pred_def_79727,type,
    v134302: state_type > $o ).

tff(pred_def_79728,type,
    v134307: state_type > $o ).

tff(pred_def_79729,type,
    v134301: state_type > $o ).

tff(pred_def_79730,type,
    v134310: state_type > $o ).

tff(pred_def_79731,type,
    v134311: state_type > $o ).

tff(pred_def_79732,type,
    v134309: state_type > $o ).

tff(pred_def_79733,type,
    v134312: state_type > $o ).

tff(pred_def_79734,type,
    v134308: state_type > $o ).

tff(pred_def_79735,type,
    v134315: state_type > $o ).

tff(pred_def_79736,type,
    v134316: state_type > $o ).

tff(pred_def_79737,type,
    v134314: state_type > $o ).

tff(pred_def_79738,type,
    v134317: state_type > $o ).

tff(pred_def_79739,type,
    v134313: state_type > $o ).

tff(pred_def_79740,type,
    v134299: ( state_type * $int ) > $o ).

tff(pred_def_79741,type,
    v134274: ( state_type * $int ) > $o ).

tff(pred_def_79742,type,
    v134319: state_type > $o ).

tff(pred_def_79743,type,
    v134330: state_type > $o ).

tff(pred_def_79744,type,
    v134329: state_type > $o ).

tff(pred_def_79745,type,
    v134328: state_type > $o ).

tff(pred_def_79746,type,
    v134331: state_type > $o ).

tff(pred_def_79747,type,
    v134327: state_type > $o ).

tff(pred_def_79748,type,
    v134326: state_type > $o ).

tff(pred_def_79749,type,
    v134325: state_type > $o ).

tff(pred_def_79750,type,
    v134324: state_type > $o ).

tff(pred_def_79751,type,
    v134333: state_type > $o ).

tff(pred_def_79752,type,
    v134332: state_type > $o ).

tff(pred_def_79753,type,
    v134323: state_type > $o ).

tff(pred_def_79754,type,
    v134336: state_type > $o ).

tff(pred_def_79755,type,
    v134335: state_type > $o ).

tff(pred_def_79756,type,
    v134337: state_type > $o ).

tff(pred_def_79757,type,
    v134334: state_type > $o ).

tff(pred_def_79758,type,
    v134340: state_type > $o ).

tff(pred_def_79759,type,
    v134339: state_type > $o ).

tff(pred_def_79760,type,
    v134341: state_type > $o ).

tff(pred_def_79761,type,
    v134338: state_type > $o ).

tff(pred_def_79762,type,
    v134321: ( state_type * $int ) > $o ).

tff(pred_def_79763,type,
    v134320: ( state_type * $int ) > $o ).

tff(pred_def_79764,type,
    v134318: ( state_type * $int ) > $o ).

tff(pred_def_79765,type,
    v134298: ( state_type * $int ) > $o ).

tff(pred_def_79766,type,
    v134294: ( state_type * $int ) > $o ).

tff(pred_def_79767,type,
    v134292: ( state_type * $int ) > $o ).

tff(pred_def_79768,type,
    v134290: ( state_type * $int ) > $o ).

tff(pred_def_79769,type,
    v134288: ( state_type * $int ) > $o ).

tff(pred_def_79770,type,
    v134345: state_type > $o ).

tff(pred_def_79771,type,
    v134343: state_type > $o ).

tff(pred_def_79772,type,
    v134352: state_type > $o ).

tff(pred_def_79773,type,
    v134350: state_type > $o ).

tff(pred_def_79774,type,
    v134349: state_type > $o ).

tff(pred_def_79775,type,
    v134348: state_type > $o ).

tff(pred_def_79776,type,
    v134360: state_type > $o ).

tff(pred_def_79777,type,
    v134361: state_type > $o ).

tff(pred_def_79778,type,
    v134359: state_type > $o ).

tff(pred_def_79779,type,
    v134356: ( state_type * $int ) > $o ).

tff(pred_def_79780,type,
    v134358: ( state_type * $int ) > $o ).

tff(pred_def_79781,type,
    v134278: ( state_type * $int ) > $o ).

tff(pred_def_79782,type,
    v134276: ( state_type * $int ) > $o ).

tff(pred_def_79783,type,
    v134272: state_type > $o ).

tff(pred_def_79784,type,
    v134376: state_type > $o ).

tff(pred_def_79785,type,
    v134374: state_type > $o ).

tff(pred_def_79786,type,
    v134380: state_type > $o ).

tff(pred_def_79787,type,
    v134378: state_type > $o ).

tff(pred_def_79788,type,
    v134396: state_type > $o ).

tff(pred_def_79789,type,
    v134394: state_type > $o ).

tff(pred_def_79790,type,
    v134393: state_type > $o ).

tff(pred_def_79791,type,
    v134392: ( state_type * $int ) > $o ).

tff(pred_def_79792,type,
    v134390: state_type > $o ).

tff(pred_def_79793,type,
    v134400: state_type > $o ).

tff(pred_def_79794,type,
    v134368: state_type > $o ).

tff(pred_def_79795,type,
    v134402: state_type > $o ).

tff(pred_def_79796,type,
    v134403: state_type > $o ).

tff(pred_def_79797,type,
    v134401: state_type > $o ).

tff(pred_def_79798,type,
    v134388: state_type > $o ).

tff(pred_def_79799,type,
    v134386: state_type > $o ).

tff(pred_def_79800,type,
    v134384: state_type > $o ).

tff(pred_def_79801,type,
    v134382: state_type > $o ).

tff(pred_def_79802,type,
    v134408: state_type > $o ).

tff(pred_def_79803,type,
    v134406: state_type > $o ).

tff(pred_def_79804,type,
    v134415: state_type > $o ).

tff(pred_def_79805,type,
    v134413: state_type > $o ).

tff(pred_def_79806,type,
    v134412: state_type > $o ).

tff(pred_def_79807,type,
    v134411: state_type > $o ).

tff(pred_def_79808,type,
    v134423: state_type > $o ).

tff(pred_def_79809,type,
    v134424: state_type > $o ).

tff(pred_def_79810,type,
    v134422: state_type > $o ).

tff(pred_def_79811,type,
    v134419: state_type > $o ).

tff(pred_def_79812,type,
    v134421: state_type > $o ).

tff(pred_def_79813,type,
    v134372: state_type > $o ).

tff(pred_def_79814,type,
    v134370: state_type > $o ).

tff(pred_def_79815,type,
    v134366: state_type > $o ).

tff(pred_def_79816,type,
    v134439: state_type > $o ).

tff(pred_def_79817,type,
    v134437: state_type > $o ).

tff(pred_def_79818,type,
    v134443: state_type > $o ).

tff(pred_def_79819,type,
    v134441: state_type > $o ).

tff(pred_def_79820,type,
    v134453: ( state_type * $int ) > $o ).

tff(pred_def_79821,type,
    v134462: state_type > $o ).

tff(pred_def_79822,type,
    v134461: state_type > $o ).

tff(pred_def_79823,type,
    v134460: state_type > $o ).

tff(pred_def_79824,type,
    v134463: state_type > $o ).

tff(pred_def_79825,type,
    v134459: state_type > $o ).

tff(pred_def_79826,type,
    v134464: state_type > $o ).

tff(pred_def_79827,type,
    v134458: state_type > $o ).

tff(pred_def_79828,type,
    v134467: state_type > $o ).

tff(pred_def_79829,type,
    v134468: state_type > $o ).

tff(pred_def_79830,type,
    v134466: state_type > $o ).

tff(pred_def_79831,type,
    v134469: state_type > $o ).

tff(pred_def_79832,type,
    v134465: state_type > $o ).

tff(pred_def_79833,type,
    v134472: state_type > $o ).

tff(pred_def_79834,type,
    v134473: state_type > $o ).

tff(pred_def_79835,type,
    v134471: state_type > $o ).

tff(pred_def_79836,type,
    v134474: state_type > $o ).

tff(pred_def_79837,type,
    v134470: state_type > $o ).

tff(pred_def_79838,type,
    v134456: ( state_type * $int ) > $o ).

tff(pred_def_79839,type,
    v134431: ( state_type * $int ) > $o ).

tff(pred_def_79840,type,
    v134476: state_type > $o ).

tff(pred_def_79841,type,
    v134487: state_type > $o ).

tff(pred_def_79842,type,
    v134486: state_type > $o ).

tff(pred_def_79843,type,
    v134485: state_type > $o ).

tff(pred_def_79844,type,
    v134488: state_type > $o ).

tff(pred_def_79845,type,
    v134484: state_type > $o ).

tff(pred_def_79846,type,
    v134483: state_type > $o ).

tff(pred_def_79847,type,
    v134482: state_type > $o ).

tff(pred_def_79848,type,
    v134481: state_type > $o ).

tff(pred_def_79849,type,
    v134490: state_type > $o ).

tff(pred_def_79850,type,
    v134489: state_type > $o ).

tff(pred_def_79851,type,
    v134480: state_type > $o ).

tff(pred_def_79852,type,
    v134493: state_type > $o ).

tff(pred_def_79853,type,
    v134492: state_type > $o ).

tff(pred_def_79854,type,
    v134494: state_type > $o ).

tff(pred_def_79855,type,
    v134491: state_type > $o ).

tff(pred_def_79856,type,
    v134497: state_type > $o ).

tff(pred_def_79857,type,
    v134496: state_type > $o ).

tff(pred_def_79858,type,
    v134498: state_type > $o ).

tff(pred_def_79859,type,
    v134495: state_type > $o ).

tff(pred_def_79860,type,
    v134478: ( state_type * $int ) > $o ).

tff(pred_def_79861,type,
    v134477: ( state_type * $int ) > $o ).

tff(pred_def_79862,type,
    v134475: ( state_type * $int ) > $o ).

tff(pred_def_79863,type,
    v134455: ( state_type * $int ) > $o ).

tff(pred_def_79864,type,
    v134451: ( state_type * $int ) > $o ).

tff(pred_def_79865,type,
    v134449: ( state_type * $int ) > $o ).

tff(pred_def_79866,type,
    v134447: ( state_type * $int ) > $o ).

tff(pred_def_79867,type,
    v134445: ( state_type * $int ) > $o ).

tff(pred_def_79868,type,
    v134502: state_type > $o ).

tff(pred_def_79869,type,
    v134500: state_type > $o ).

tff(pred_def_79870,type,
    v134509: state_type > $o ).

tff(pred_def_79871,type,
    v134507: state_type > $o ).

tff(pred_def_79872,type,
    v134506: state_type > $o ).

tff(pred_def_79873,type,
    v134505: state_type > $o ).

tff(pred_def_79874,type,
    v134517: state_type > $o ).

tff(pred_def_79875,type,
    v134518: state_type > $o ).

tff(pred_def_79876,type,
    v134516: state_type > $o ).

tff(pred_def_79877,type,
    v134513: ( state_type * $int ) > $o ).

tff(pred_def_79878,type,
    v134515: ( state_type * $int ) > $o ).

tff(pred_def_79879,type,
    v134435: ( state_type * $int ) > $o ).

tff(pred_def_79880,type,
    v134433: ( state_type * $int ) > $o ).

tff(pred_def_79881,type,
    v134429: state_type > $o ).

tff(pred_def_79882,type,
    v134533: state_type > $o ).

tff(pred_def_79883,type,
    v134531: state_type > $o ).

tff(pred_def_79884,type,
    v134537: state_type > $o ).

tff(pred_def_79885,type,
    v134535: state_type > $o ).

tff(pred_def_79886,type,
    v134553: state_type > $o ).

tff(pred_def_79887,type,
    v134551: state_type > $o ).

tff(pred_def_79888,type,
    v134550: state_type > $o ).

tff(pred_def_79889,type,
    v134549: ( state_type * $int ) > $o ).

tff(pred_def_79890,type,
    v134547: state_type > $o ).

tff(pred_def_79891,type,
    v134557: state_type > $o ).

tff(pred_def_79892,type,
    v134525: state_type > $o ).

tff(pred_def_79893,type,
    v134559: state_type > $o ).

tff(pred_def_79894,type,
    v134560: state_type > $o ).

tff(pred_def_79895,type,
    v134558: state_type > $o ).

tff(pred_def_79896,type,
    v134545: state_type > $o ).

tff(pred_def_79897,type,
    v134543: state_type > $o ).

tff(pred_def_79898,type,
    v134541: state_type > $o ).

tff(pred_def_79899,type,
    v134539: state_type > $o ).

tff(pred_def_79900,type,
    v134565: state_type > $o ).

tff(pred_def_79901,type,
    v134563: state_type > $o ).

tff(pred_def_79902,type,
    v134572: state_type > $o ).

tff(pred_def_79903,type,
    v134570: state_type > $o ).

tff(pred_def_79904,type,
    v134569: state_type > $o ).

tff(pred_def_79905,type,
    v134568: state_type > $o ).

tff(pred_def_79906,type,
    v134580: state_type > $o ).

tff(pred_def_79907,type,
    v134581: state_type > $o ).

tff(pred_def_79908,type,
    v134579: state_type > $o ).

tff(pred_def_79909,type,
    v134576: state_type > $o ).

tff(pred_def_79910,type,
    v134578: state_type > $o ).

tff(pred_def_79911,type,
    v134529: state_type > $o ).

tff(pred_def_79912,type,
    v134527: state_type > $o ).

tff(pred_def_79913,type,
    v134523: state_type > $o ).

tff(pred_def_79914,type,
    v134596: state_type > $o ).

tff(pred_def_79915,type,
    v134594: state_type > $o ).

tff(pred_def_79916,type,
    v134600: state_type > $o ).

tff(pred_def_79917,type,
    v134598: state_type > $o ).

tff(pred_def_79918,type,
    v134610: ( state_type * $int ) > $o ).

tff(pred_def_79919,type,
    v134619: state_type > $o ).

tff(pred_def_79920,type,
    v134618: state_type > $o ).

tff(pred_def_79921,type,
    v134617: state_type > $o ).

tff(pred_def_79922,type,
    v134620: state_type > $o ).

tff(pred_def_79923,type,
    v134616: state_type > $o ).

tff(pred_def_79924,type,
    v134621: state_type > $o ).

tff(pred_def_79925,type,
    v134615: state_type > $o ).

tff(pred_def_79926,type,
    v134624: state_type > $o ).

tff(pred_def_79927,type,
    v134625: state_type > $o ).

tff(pred_def_79928,type,
    v134623: state_type > $o ).

tff(pred_def_79929,type,
    v134626: state_type > $o ).

tff(pred_def_79930,type,
    v134622: state_type > $o ).

tff(pred_def_79931,type,
    v134629: state_type > $o ).

tff(pred_def_79932,type,
    v134630: state_type > $o ).

tff(pred_def_79933,type,
    v134628: state_type > $o ).

tff(pred_def_79934,type,
    v134631: state_type > $o ).

tff(pred_def_79935,type,
    v134627: state_type > $o ).

tff(pred_def_79936,type,
    v134613: ( state_type * $int ) > $o ).

tff(pred_def_79937,type,
    v134588: ( state_type * $int ) > $o ).

tff(pred_def_79938,type,
    v134633: state_type > $o ).

tff(pred_def_79939,type,
    v134644: state_type > $o ).

tff(pred_def_79940,type,
    v134643: state_type > $o ).

tff(pred_def_79941,type,
    v134642: state_type > $o ).

tff(pred_def_79942,type,
    v134645: state_type > $o ).

tff(pred_def_79943,type,
    v134641: state_type > $o ).

tff(pred_def_79944,type,
    v134640: state_type > $o ).

tff(pred_def_79945,type,
    v134639: state_type > $o ).

tff(pred_def_79946,type,
    v134638: state_type > $o ).

tff(pred_def_79947,type,
    v134647: state_type > $o ).

tff(pred_def_79948,type,
    v134646: state_type > $o ).

tff(pred_def_79949,type,
    v134637: state_type > $o ).

tff(pred_def_79950,type,
    v134650: state_type > $o ).

tff(pred_def_79951,type,
    v134649: state_type > $o ).

tff(pred_def_79952,type,
    v134651: state_type > $o ).

tff(pred_def_79953,type,
    v134648: state_type > $o ).

tff(pred_def_79954,type,
    v134654: state_type > $o ).

tff(pred_def_79955,type,
    v134653: state_type > $o ).

tff(pred_def_79956,type,
    v134655: state_type > $o ).

tff(pred_def_79957,type,
    v134652: state_type > $o ).

tff(pred_def_79958,type,
    v134635: ( state_type * $int ) > $o ).

tff(pred_def_79959,type,
    v134634: ( state_type * $int ) > $o ).

tff(pred_def_79960,type,
    v134632: ( state_type * $int ) > $o ).

tff(pred_def_79961,type,
    v134612: ( state_type * $int ) > $o ).

tff(pred_def_79962,type,
    v134608: ( state_type * $int ) > $o ).

tff(pred_def_79963,type,
    v134606: ( state_type * $int ) > $o ).

tff(pred_def_79964,type,
    v134604: ( state_type * $int ) > $o ).

tff(pred_def_79965,type,
    v134602: ( state_type * $int ) > $o ).

tff(pred_def_79966,type,
    v134659: state_type > $o ).

tff(pred_def_79967,type,
    v134657: state_type > $o ).

tff(pred_def_79968,type,
    v134666: state_type > $o ).

tff(pred_def_79969,type,
    v134664: state_type > $o ).

tff(pred_def_79970,type,
    v134663: state_type > $o ).

tff(pred_def_79971,type,
    v134662: state_type > $o ).

tff(pred_def_79972,type,
    v134674: state_type > $o ).

tff(pred_def_79973,type,
    v134675: state_type > $o ).

tff(pred_def_79974,type,
    v134673: state_type > $o ).

tff(pred_def_79975,type,
    v134670: ( state_type * $int ) > $o ).

tff(pred_def_79976,type,
    v134672: ( state_type * $int ) > $o ).

tff(pred_def_79977,type,
    v134592: ( state_type * $int ) > $o ).

tff(pred_def_79978,type,
    v134590: ( state_type * $int ) > $o ).

tff(pred_def_79979,type,
    v134586: state_type > $o ).

tff(pred_def_79980,type,
    v134690: state_type > $o ).

tff(pred_def_79981,type,
    v134688: state_type > $o ).

tff(pred_def_79982,type,
    v134694: state_type > $o ).

tff(pred_def_79983,type,
    v134692: state_type > $o ).

tff(pred_def_79984,type,
    v134710: state_type > $o ).

tff(pred_def_79985,type,
    v134708: state_type > $o ).

tff(pred_def_79986,type,
    v134707: state_type > $o ).

tff(pred_def_79987,type,
    v134706: ( state_type * $int ) > $o ).

tff(pred_def_79988,type,
    v134704: state_type > $o ).

tff(pred_def_79989,type,
    v134714: state_type > $o ).

tff(pred_def_79990,type,
    v134682: state_type > $o ).

tff(pred_def_79991,type,
    v134716: state_type > $o ).

tff(pred_def_79992,type,
    v134717: state_type > $o ).

tff(pred_def_79993,type,
    v134715: state_type > $o ).

tff(pred_def_79994,type,
    v134702: state_type > $o ).

tff(pred_def_79995,type,
    v134700: state_type > $o ).

tff(pred_def_79996,type,
    v134698: state_type > $o ).

tff(pred_def_79997,type,
    v134696: state_type > $o ).

tff(pred_def_79998,type,
    v134722: state_type > $o ).

tff(pred_def_79999,type,
    v134720: state_type > $o ).

tff(pred_def_80000,type,
    v134729: state_type > $o ).

tff(pred_def_80001,type,
    v134727: state_type > $o ).

tff(pred_def_80002,type,
    v134726: state_type > $o ).

tff(pred_def_80003,type,
    v134725: state_type > $o ).

tff(pred_def_80004,type,
    v134737: state_type > $o ).

tff(pred_def_80005,type,
    v134738: state_type > $o ).

tff(pred_def_80006,type,
    v134736: state_type > $o ).

tff(pred_def_80007,type,
    v134733: state_type > $o ).

tff(pred_def_80008,type,
    v134735: state_type > $o ).

tff(pred_def_80009,type,
    v134686: state_type > $o ).

tff(pred_def_80010,type,
    v134684: state_type > $o ).

tff(pred_def_80011,type,
    v134680: state_type > $o ).

tff(pred_def_80012,type,
    v134753: state_type > $o ).

tff(pred_def_80013,type,
    v134751: state_type > $o ).

tff(pred_def_80014,type,
    v134757: state_type > $o ).

tff(pred_def_80015,type,
    v134755: state_type > $o ).

tff(pred_def_80016,type,
    v134767: ( state_type * $int ) > $o ).

tff(pred_def_80017,type,
    v134776: state_type > $o ).

tff(pred_def_80018,type,
    v134775: state_type > $o ).

tff(pred_def_80019,type,
    v134774: state_type > $o ).

tff(pred_def_80020,type,
    v134777: state_type > $o ).

tff(pred_def_80021,type,
    v134773: state_type > $o ).

tff(pred_def_80022,type,
    v134778: state_type > $o ).

tff(pred_def_80023,type,
    v134772: state_type > $o ).

tff(pred_def_80024,type,
    v134781: state_type > $o ).

tff(pred_def_80025,type,
    v134782: state_type > $o ).

tff(pred_def_80026,type,
    v134780: state_type > $o ).

tff(pred_def_80027,type,
    v134783: state_type > $o ).

tff(pred_def_80028,type,
    v134779: state_type > $o ).

tff(pred_def_80029,type,
    v134786: state_type > $o ).

tff(pred_def_80030,type,
    v134787: state_type > $o ).

tff(pred_def_80031,type,
    v134785: state_type > $o ).

tff(pred_def_80032,type,
    v134788: state_type > $o ).

tff(pred_def_80033,type,
    v134784: state_type > $o ).

tff(pred_def_80034,type,
    v134770: ( state_type * $int ) > $o ).

tff(pred_def_80035,type,
    v134745: ( state_type * $int ) > $o ).

tff(pred_def_80036,type,
    v134790: state_type > $o ).

tff(pred_def_80037,type,
    v134801: state_type > $o ).

tff(pred_def_80038,type,
    v134800: state_type > $o ).

tff(pred_def_80039,type,
    v134799: state_type > $o ).

tff(pred_def_80040,type,
    v134802: state_type > $o ).

tff(pred_def_80041,type,
    v134798: state_type > $o ).

tff(pred_def_80042,type,
    v134797: state_type > $o ).

tff(pred_def_80043,type,
    v134796: state_type > $o ).

tff(pred_def_80044,type,
    v134795: state_type > $o ).

tff(pred_def_80045,type,
    v134804: state_type > $o ).

tff(pred_def_80046,type,
    v134803: state_type > $o ).

tff(pred_def_80047,type,
    v134794: state_type > $o ).

tff(pred_def_80048,type,
    v134807: state_type > $o ).

tff(pred_def_80049,type,
    v134806: state_type > $o ).

tff(pred_def_80050,type,
    v134808: state_type > $o ).

tff(pred_def_80051,type,
    v134805: state_type > $o ).

tff(pred_def_80052,type,
    v134811: state_type > $o ).

tff(pred_def_80053,type,
    v134810: state_type > $o ).

tff(pred_def_80054,type,
    v134812: state_type > $o ).

tff(pred_def_80055,type,
    v134809: state_type > $o ).

tff(pred_def_80056,type,
    v134792: ( state_type * $int ) > $o ).

tff(pred_def_80057,type,
    v134791: ( state_type * $int ) > $o ).

tff(pred_def_80058,type,
    v134789: ( state_type * $int ) > $o ).

tff(pred_def_80059,type,
    v134769: ( state_type * $int ) > $o ).

tff(pred_def_80060,type,
    v134765: ( state_type * $int ) > $o ).

tff(pred_def_80061,type,
    v134763: ( state_type * $int ) > $o ).

tff(pred_def_80062,type,
    v134761: ( state_type * $int ) > $o ).

tff(pred_def_80063,type,
    v134759: ( state_type * $int ) > $o ).

tff(pred_def_80064,type,
    v134816: state_type > $o ).

tff(pred_def_80065,type,
    v134814: state_type > $o ).

tff(pred_def_80066,type,
    v134823: state_type > $o ).

tff(pred_def_80067,type,
    v134821: state_type > $o ).

tff(pred_def_80068,type,
    v134820: state_type > $o ).

tff(pred_def_80069,type,
    v134819: state_type > $o ).

tff(pred_def_80070,type,
    v134831: state_type > $o ).

tff(pred_def_80071,type,
    v134832: state_type > $o ).

tff(pred_def_80072,type,
    v134830: state_type > $o ).

tff(pred_def_80073,type,
    v134827: ( state_type * $int ) > $o ).

tff(pred_def_80074,type,
    v134829: ( state_type * $int ) > $o ).

tff(pred_def_80075,type,
    v134749: ( state_type * $int ) > $o ).

tff(pred_def_80076,type,
    v134747: ( state_type * $int ) > $o ).

tff(pred_def_80077,type,
    v134743: state_type > $o ).

tff(pred_def_80078,type,
    v134847: state_type > $o ).

tff(pred_def_80079,type,
    v134845: state_type > $o ).

tff(pred_def_80080,type,
    v134851: state_type > $o ).

tff(pred_def_80081,type,
    v134849: state_type > $o ).

tff(pred_def_80082,type,
    v134867: state_type > $o ).

tff(pred_def_80083,type,
    v134865: state_type > $o ).

tff(pred_def_80084,type,
    v134864: state_type > $o ).

tff(pred_def_80085,type,
    v134863: ( state_type * $int ) > $o ).

tff(pred_def_80086,type,
    v134861: state_type > $o ).

tff(pred_def_80087,type,
    v134871: state_type > $o ).

tff(pred_def_80088,type,
    v134839: state_type > $o ).

tff(pred_def_80089,type,
    v134873: state_type > $o ).

tff(pred_def_80090,type,
    v134874: state_type > $o ).

tff(pred_def_80091,type,
    v134872: state_type > $o ).

tff(pred_def_80092,type,
    v134859: state_type > $o ).

tff(pred_def_80093,type,
    v134857: state_type > $o ).

tff(pred_def_80094,type,
    v134855: state_type > $o ).

tff(pred_def_80095,type,
    v134853: state_type > $o ).

tff(pred_def_80096,type,
    v134879: state_type > $o ).

tff(pred_def_80097,type,
    v134877: state_type > $o ).

tff(pred_def_80098,type,
    v134886: state_type > $o ).

tff(pred_def_80099,type,
    v134884: state_type > $o ).

tff(pred_def_80100,type,
    v134883: state_type > $o ).

tff(pred_def_80101,type,
    v134882: state_type > $o ).

tff(pred_def_80102,type,
    v134894: state_type > $o ).

tff(pred_def_80103,type,
    v134895: state_type > $o ).

tff(pred_def_80104,type,
    v134893: state_type > $o ).

tff(pred_def_80105,type,
    v134890: state_type > $o ).

tff(pred_def_80106,type,
    v134892: state_type > $o ).

tff(pred_def_80107,type,
    v134843: state_type > $o ).

tff(pred_def_80108,type,
    v134841: state_type > $o ).

tff(pred_def_80109,type,
    v134837: state_type > $o ).

tff(pred_def_80110,type,
    v134910: state_type > $o ).

tff(pred_def_80111,type,
    v134908: state_type > $o ).

tff(pred_def_80112,type,
    v134914: state_type > $o ).

tff(pred_def_80113,type,
    v134912: state_type > $o ).

tff(pred_def_80114,type,
    v134924: ( state_type * $int ) > $o ).

tff(pred_def_80115,type,
    v134933: state_type > $o ).

tff(pred_def_80116,type,
    v134932: state_type > $o ).

tff(pred_def_80117,type,
    v134931: state_type > $o ).

tff(pred_def_80118,type,
    v134934: state_type > $o ).

tff(pred_def_80119,type,
    v134930: state_type > $o ).

tff(pred_def_80120,type,
    v134935: state_type > $o ).

tff(pred_def_80121,type,
    v134929: state_type > $o ).

tff(pred_def_80122,type,
    v134938: state_type > $o ).

tff(pred_def_80123,type,
    v134939: state_type > $o ).

tff(pred_def_80124,type,
    v134937: state_type > $o ).

tff(pred_def_80125,type,
    v134940: state_type > $o ).

tff(pred_def_80126,type,
    v134936: state_type > $o ).

tff(pred_def_80127,type,
    v134943: state_type > $o ).

tff(pred_def_80128,type,
    v134944: state_type > $o ).

tff(pred_def_80129,type,
    v134942: state_type > $o ).

tff(pred_def_80130,type,
    v134945: state_type > $o ).

tff(pred_def_80131,type,
    v134941: state_type > $o ).

tff(pred_def_80132,type,
    v134927: ( state_type * $int ) > $o ).

tff(pred_def_80133,type,
    v134902: ( state_type * $int ) > $o ).

tff(pred_def_80134,type,
    v134947: state_type > $o ).

tff(pred_def_80135,type,
    v134958: state_type > $o ).

tff(pred_def_80136,type,
    v134957: state_type > $o ).

tff(pred_def_80137,type,
    v134956: state_type > $o ).

tff(pred_def_80138,type,
    v134959: state_type > $o ).

tff(pred_def_80139,type,
    v134955: state_type > $o ).

tff(pred_def_80140,type,
    v134954: state_type > $o ).

tff(pred_def_80141,type,
    v134953: state_type > $o ).

tff(pred_def_80142,type,
    v134952: state_type > $o ).

tff(pred_def_80143,type,
    v134961: state_type > $o ).

tff(pred_def_80144,type,
    v134960: state_type > $o ).

tff(pred_def_80145,type,
    v134951: state_type > $o ).

tff(pred_def_80146,type,
    v134964: state_type > $o ).

tff(pred_def_80147,type,
    v134963: state_type > $o ).

tff(pred_def_80148,type,
    v134965: state_type > $o ).

tff(pred_def_80149,type,
    v134962: state_type > $o ).

tff(pred_def_80150,type,
    v134968: state_type > $o ).

tff(pred_def_80151,type,
    v134967: state_type > $o ).

tff(pred_def_80152,type,
    v134969: state_type > $o ).

tff(pred_def_80153,type,
    v134966: state_type > $o ).

tff(pred_def_80154,type,
    v134949: ( state_type * $int ) > $o ).

tff(pred_def_80155,type,
    v134948: ( state_type * $int ) > $o ).

tff(pred_def_80156,type,
    v134946: ( state_type * $int ) > $o ).

tff(pred_def_80157,type,
    v134926: ( state_type * $int ) > $o ).

tff(pred_def_80158,type,
    v134922: ( state_type * $int ) > $o ).

tff(pred_def_80159,type,
    v134920: ( state_type * $int ) > $o ).

tff(pred_def_80160,type,
    v134918: ( state_type * $int ) > $o ).

tff(pred_def_80161,type,
    v134916: ( state_type * $int ) > $o ).

tff(pred_def_80162,type,
    v134973: state_type > $o ).

tff(pred_def_80163,type,
    v134971: state_type > $o ).

tff(pred_def_80164,type,
    v134980: state_type > $o ).

tff(pred_def_80165,type,
    v134978: state_type > $o ).

tff(pred_def_80166,type,
    v134977: state_type > $o ).

tff(pred_def_80167,type,
    v134976: state_type > $o ).

tff(pred_def_80168,type,
    v134988: state_type > $o ).

tff(pred_def_80169,type,
    v134989: state_type > $o ).

tff(pred_def_80170,type,
    v134987: state_type > $o ).

tff(pred_def_80171,type,
    v134984: ( state_type * $int ) > $o ).

tff(pred_def_80172,type,
    v134986: ( state_type * $int ) > $o ).

tff(pred_def_80173,type,
    v134906: ( state_type * $int ) > $o ).

tff(pred_def_80174,type,
    v134904: ( state_type * $int ) > $o ).

tff(pred_def_80175,type,
    v134900: state_type > $o ).

tff(pred_def_80176,type,
    v135004: state_type > $o ).

tff(pred_def_80177,type,
    v135002: state_type > $o ).

tff(pred_def_80178,type,
    v135008: state_type > $o ).

tff(pred_def_80179,type,
    v135006: state_type > $o ).

tff(pred_def_80180,type,
    v135024: state_type > $o ).

tff(pred_def_80181,type,
    v135022: state_type > $o ).

tff(pred_def_80182,type,
    v135021: state_type > $o ).

tff(pred_def_80183,type,
    v135020: ( state_type * $int ) > $o ).

tff(pred_def_80184,type,
    v135018: state_type > $o ).

tff(pred_def_80185,type,
    v135028: state_type > $o ).

tff(pred_def_80186,type,
    v134996: state_type > $o ).

tff(pred_def_80187,type,
    v135030: state_type > $o ).

tff(pred_def_80188,type,
    v135031: state_type > $o ).

tff(pred_def_80189,type,
    v135029: state_type > $o ).

tff(pred_def_80190,type,
    v135016: state_type > $o ).

tff(pred_def_80191,type,
    v135014: state_type > $o ).

tff(pred_def_80192,type,
    v135012: state_type > $o ).

tff(pred_def_80193,type,
    v135010: state_type > $o ).

tff(pred_def_80194,type,
    v135036: state_type > $o ).

tff(pred_def_80195,type,
    v135034: state_type > $o ).

tff(pred_def_80196,type,
    v135043: state_type > $o ).

tff(pred_def_80197,type,
    v135041: state_type > $o ).

tff(pred_def_80198,type,
    v135040: state_type > $o ).

tff(pred_def_80199,type,
    v135039: state_type > $o ).

tff(pred_def_80200,type,
    v135051: state_type > $o ).

tff(pred_def_80201,type,
    v135052: state_type > $o ).

tff(pred_def_80202,type,
    v135050: state_type > $o ).

tff(pred_def_80203,type,
    v135047: state_type > $o ).

tff(pred_def_80204,type,
    v135049: state_type > $o ).

tff(pred_def_80205,type,
    v135000: state_type > $o ).

tff(pred_def_80206,type,
    v134998: state_type > $o ).

tff(pred_def_80207,type,
    v134994: state_type > $o ).

tff(pred_def_80208,type,
    v135067: state_type > $o ).

tff(pred_def_80209,type,
    v135065: state_type > $o ).

tff(pred_def_80210,type,
    v135071: state_type > $o ).

tff(pred_def_80211,type,
    v135069: state_type > $o ).

tff(pred_def_80212,type,
    v135081: ( state_type * $int ) > $o ).

tff(pred_def_80213,type,
    v135090: state_type > $o ).

tff(pred_def_80214,type,
    v135089: state_type > $o ).

tff(pred_def_80215,type,
    v135088: state_type > $o ).

tff(pred_def_80216,type,
    v135091: state_type > $o ).

tff(pred_def_80217,type,
    v135087: state_type > $o ).

tff(pred_def_80218,type,
    v135092: state_type > $o ).

tff(pred_def_80219,type,
    v135086: state_type > $o ).

tff(pred_def_80220,type,
    v135095: state_type > $o ).

tff(pred_def_80221,type,
    v135096: state_type > $o ).

tff(pred_def_80222,type,
    v135094: state_type > $o ).

tff(pred_def_80223,type,
    v135097: state_type > $o ).

tff(pred_def_80224,type,
    v135093: state_type > $o ).

tff(pred_def_80225,type,
    v135100: state_type > $o ).

tff(pred_def_80226,type,
    v135101: state_type > $o ).

tff(pred_def_80227,type,
    v135099: state_type > $o ).

tff(pred_def_80228,type,
    v135102: state_type > $o ).

tff(pred_def_80229,type,
    v135098: state_type > $o ).

tff(pred_def_80230,type,
    v135084: ( state_type * $int ) > $o ).

tff(pred_def_80231,type,
    v135059: ( state_type * $int ) > $o ).

tff(pred_def_80232,type,
    v135104: state_type > $o ).

tff(pred_def_80233,type,
    v135115: state_type > $o ).

tff(pred_def_80234,type,
    v135114: state_type > $o ).

tff(pred_def_80235,type,
    v135113: state_type > $o ).

tff(pred_def_80236,type,
    v135116: state_type > $o ).

tff(pred_def_80237,type,
    v135112: state_type > $o ).

tff(pred_def_80238,type,
    v135111: state_type > $o ).

tff(pred_def_80239,type,
    v135110: state_type > $o ).

tff(pred_def_80240,type,
    v135109: state_type > $o ).

tff(pred_def_80241,type,
    v135118: state_type > $o ).

tff(pred_def_80242,type,
    v135117: state_type > $o ).

tff(pred_def_80243,type,
    v135108: state_type > $o ).

tff(pred_def_80244,type,
    v135121: state_type > $o ).

tff(pred_def_80245,type,
    v135120: state_type > $o ).

tff(pred_def_80246,type,
    v135122: state_type > $o ).

tff(pred_def_80247,type,
    v135119: state_type > $o ).

tff(pred_def_80248,type,
    v135125: state_type > $o ).

tff(pred_def_80249,type,
    v135124: state_type > $o ).

tff(pred_def_80250,type,
    v135126: state_type > $o ).

tff(pred_def_80251,type,
    v135123: state_type > $o ).

tff(pred_def_80252,type,
    v135106: ( state_type * $int ) > $o ).

tff(pred_def_80253,type,
    v135105: ( state_type * $int ) > $o ).

tff(pred_def_80254,type,
    v135103: ( state_type * $int ) > $o ).

tff(pred_def_80255,type,
    v135083: ( state_type * $int ) > $o ).

tff(pred_def_80256,type,
    v135079: ( state_type * $int ) > $o ).

tff(pred_def_80257,type,
    v135077: ( state_type * $int ) > $o ).

tff(pred_def_80258,type,
    v135075: ( state_type * $int ) > $o ).

tff(pred_def_80259,type,
    v135073: ( state_type * $int ) > $o ).

tff(pred_def_80260,type,
    v135130: state_type > $o ).

tff(pred_def_80261,type,
    v135128: state_type > $o ).

tff(pred_def_80262,type,
    v135137: state_type > $o ).

tff(pred_def_80263,type,
    v135135: state_type > $o ).

tff(pred_def_80264,type,
    v135134: state_type > $o ).

tff(pred_def_80265,type,
    v135133: state_type > $o ).

tff(pred_def_80266,type,
    v135145: state_type > $o ).

tff(pred_def_80267,type,
    v135146: state_type > $o ).

tff(pred_def_80268,type,
    v135144: state_type > $o ).

tff(pred_def_80269,type,
    v135141: ( state_type * $int ) > $o ).

tff(pred_def_80270,type,
    v135143: ( state_type * $int ) > $o ).

tff(pred_def_80271,type,
    v135063: ( state_type * $int ) > $o ).

tff(pred_def_80272,type,
    v135061: ( state_type * $int ) > $o ).

tff(pred_def_80273,type,
    v135057: state_type > $o ).

tff(pred_def_80274,type,
    v135152: state_type > $o ).

tff(pred_def_80275,type,
    v135151: state_type > $o ).

tff(pred_def_80276,type,
    v135153: state_type > $o ).

tff(pred_def_80277,type,
    v89154: ( state_type * $int ) > $o ).

tff(pred_def_80278,type,
    v135156: state_type > $o ).

tff(pred_def_80279,type,
    v135155: state_type > $o ).

tff(pred_def_80280,type,
    v135157: state_type > $o ).

tff(pred_def_80281,type,
    v135160: state_type > $o ).

tff(pred_def_80282,type,
    v135159: state_type > $o ).

tff(pred_def_80283,type,
    v135161: state_type > $o ).

tff(pred_def_80284,type,
    v135164: state_type > $o ).

tff(pred_def_80285,type,
    v135163: state_type > $o ).

tff(pred_def_80286,type,
    v135165: state_type > $o ).

tff(pred_def_80287,type,
    v135168: state_type > $o ).

tff(pred_def_80288,type,
    v135167: state_type > $o ).

tff(pred_def_80289,type,
    v135169: state_type > $o ).

tff(pred_def_80290,type,
    v135172: state_type > $o ).

tff(pred_def_80291,type,
    v135171: state_type > $o ).

tff(pred_def_80292,type,
    v135173: state_type > $o ).

tff(pred_def_80293,type,
    v135176: state_type > $o ).

tff(pred_def_80294,type,
    v135175: state_type > $o ).

tff(pred_def_80295,type,
    v135177: state_type > $o ).

tff(pred_def_80296,type,
    v135180: state_type > $o ).

tff(pred_def_80297,type,
    v135179: state_type > $o ).

tff(pred_def_80298,type,
    v135181: state_type > $o ).

tff(pred_def_80299,type,
    v85708: ( state_type * $int ) > $o ).

tff(pred_def_80300,type,
    v135183: ( state_type * $int ) > $o ).

tff(pred_def_80301,type,
    v135184: ( state_type * $int ) > $o ).

tff(pred_def_80302,type,
    v89117: ( state_type * $int ) > $o ).

tff(pred_def_80303,type,
    v135194: state_type > $o ).

tff(pred_def_80304,type,
    v135192: state_type > $o ).

tff(pred_def_80305,type,
    v135198: state_type > $o ).

tff(pred_def_80306,type,
    v135196: state_type > $o ).

tff(pred_def_80307,type,
    v135204: state_type > $o ).

tff(pred_def_80308,type,
    v135202: state_type > $o ).

tff(pred_def_80309,type,
    v135200: state_type > $o ).

tff(pred_def_80310,type,
    v135208: state_type > $o ).

tff(pred_def_80311,type,
    v135206: state_type > $o ).

tff(pred_def_80312,type,
    v135215: state_type > $o ).

tff(pred_def_80313,type,
    v135213: state_type > $o ).

tff(pred_def_80314,type,
    v135212: state_type > $o ).

tff(pred_def_80315,type,
    v135211: state_type > $o ).

tff(pred_def_80316,type,
    v135223: state_type > $o ).

tff(pred_def_80317,type,
    v135224: state_type > $o ).

tff(pred_def_80318,type,
    v135222: state_type > $o ).

tff(pred_def_80319,type,
    v135219: state_type > $o ).

tff(pred_def_80320,type,
    v135221: state_type > $o ).

tff(pred_def_80321,type,
    v135190: state_type > $o ).

tff(pred_def_80322,type,
    v135188: state_type > $o ).

tff(pred_def_80323,type,
    v135186: state_type > $o ).

tff(pred_def_80324,type,
    v135237: state_type > $o ).

tff(pred_def_80325,type,
    v135236: state_type > $o ).

tff(pred_def_80326,type,
    v135239: state_type > $o ).

tff(pred_def_80327,type,
    v135238: state_type > $o ).

tff(pred_def_80328,type,
    v135235: state_type > $o ).

tff(pred_def_80329,type,
    v135241: state_type > $o ).

tff(pred_def_80330,type,
    v135240: state_type > $o ).

tff(pred_def_80331,type,
    v135234: state_type > $o ).

tff(pred_def_80332,type,
    v135243: state_type > $o ).

tff(pred_def_80333,type,
    v135242: state_type > $o ).

tff(pred_def_80334,type,
    v135233: state_type > $o ).

tff(pred_def_80335,type,
    v135245: state_type > $o ).

tff(pred_def_80336,type,
    v135244: state_type > $o ).

tff(pred_def_80337,type,
    v135232: state_type > $o ).

tff(pred_def_80338,type,
    v135247: state_type > $o ).

tff(pred_def_80339,type,
    v135246: state_type > $o ).

tff(pred_def_80340,type,
    v135231: state_type > $o ).

tff(pred_def_80341,type,
    v135249: state_type > $o ).

tff(pred_def_80342,type,
    v135248: state_type > $o ).

tff(pred_def_80343,type,
    v135230: state_type > $o ).

tff(pred_def_80344,type,
    v135251: state_type > $o ).

tff(pred_def_80345,type,
    v135250: state_type > $o ).

tff(pred_def_80346,type,
    v135228: state_type > $o ).

tff(pred_def_80347,type,
    v135272: ( state_type * $int ) > $o ).

tff(pred_def_80348,type,
    v999: state_type > $o ).

tff(pred_def_80349,type,
    v135271: state_type > $o ).

tff(pred_def_80350,type,
    v135275: state_type > $o ).

tff(pred_def_80351,type,
    v135276: state_type > $o ).

tff(pred_def_80352,type,
    v135274: state_type > $o ).

tff(pred_def_80353,type,
    v135277: state_type > $o ).

tff(pred_def_80354,type,
    v135273: state_type > $o ).

tff(pred_def_80355,type,
    v135270: state_type > $o ).

tff(pred_def_80356,type,
    v135278: state_type > $o ).

tff(pred_def_80357,type,
    v135269: state_type > $o ).

tff(pred_def_80358,type,
    v135281: state_type > $o ).

tff(pred_def_80359,type,
    v135282: state_type > $o ).

tff(pred_def_80360,type,
    v135280: state_type > $o ).

tff(pred_def_80361,type,
    v135283: state_type > $o ).

tff(pred_def_80362,type,
    v135279: state_type > $o ).

tff(pred_def_80363,type,
    v135268: state_type > $o ).

tff(pred_def_80364,type,
    v135284: state_type > $o ).

tff(pred_def_80365,type,
    v135267: state_type > $o ).

tff(pred_def_80366,type,
    v135287: state_type > $o ).

tff(pred_def_80367,type,
    v135288: state_type > $o ).

tff(pred_def_80368,type,
    v135286: state_type > $o ).

tff(pred_def_80369,type,
    v135289: state_type > $o ).

tff(pred_def_80370,type,
    v135285: state_type > $o ).

tff(pred_def_80371,type,
    v135266: state_type > $o ).

tff(pred_def_80372,type,
    v135290: state_type > $o ).

tff(pred_def_80373,type,
    v135265: state_type > $o ).

tff(pred_def_80374,type,
    v135264: state_type > $o ).

tff(pred_def_80375,type,
    v135294: state_type > $o ).

tff(pred_def_80376,type,
    v135295: state_type > $o ).

tff(pred_def_80377,type,
    v135293: state_type > $o ).

tff(pred_def_80378,type,
    v135296: state_type > $o ).

tff(pred_def_80379,type,
    v135292: state_type > $o ).

tff(pred_def_80380,type,
    v135291: state_type > $o ).

tff(pred_def_80381,type,
    v135263: state_type > $o ).

tff(pred_def_80382,type,
    v135297: state_type > $o ).

tff(pred_def_80383,type,
    v135262: state_type > $o ).

tff(pred_def_80384,type,
    v135300: state_type > $o ).

tff(pred_def_80385,type,
    v135301: state_type > $o ).

tff(pred_def_80386,type,
    v135299: state_type > $o ).

tff(pred_def_80387,type,
    v135302: state_type > $o ).

tff(pred_def_80388,type,
    v135298: state_type > $o ).

tff(pred_def_80389,type,
    v135305: state_type > $o ).

tff(pred_def_80390,type,
    v135306: state_type > $o ).

tff(pred_def_80391,type,
    v135304: state_type > $o ).

tff(pred_def_80392,type,
    v135307: state_type > $o ).

tff(pred_def_80393,type,
    v135303: state_type > $o ).

tff(pred_def_80394,type,
    v135310: state_type > $o ).

tff(pred_def_80395,type,
    v135311: state_type > $o ).

tff(pred_def_80396,type,
    v135309: state_type > $o ).

tff(pred_def_80397,type,
    v135312: state_type > $o ).

tff(pred_def_80398,type,
    v135308: state_type > $o ).

tff(pred_def_80399,type,
    v135315: state_type > $o ).

tff(pred_def_80400,type,
    v135316: state_type > $o ).

tff(pred_def_80401,type,
    v135314: state_type > $o ).

tff(pred_def_80402,type,
    v135317: state_type > $o ).

tff(pred_def_80403,type,
    v135313: state_type > $o ).

tff(pred_def_80404,type,
    v135260: ( state_type * $int ) > $o ).

tff(pred_def_80405,type,
    v996: ( state_type * $int ) > $o ).

tff(pred_def_80406,type,
    v994: ( state_type * $int ) > $o ).

tff(pred_def_80407,type,
    v992: ( state_type * $int ) > $o ).

tff(pred_def_80408,type,
    v990: ( state_type * $int ) > $o ).

tff(pred_def_80409,type,
    v135321: state_type > $o ).

tff(pred_def_80410,type,
    v135319: state_type > $o ).

tff(pred_def_80411,type,
    v135328: state_type > $o ).

tff(pred_def_80412,type,
    v135326: state_type > $o ).

tff(pred_def_80413,type,
    v135325: state_type > $o ).

tff(pred_def_80414,type,
    v135324: state_type > $o ).

tff(pred_def_80415,type,
    v135336: state_type > $o ).

tff(pred_def_80416,type,
    v135337: state_type > $o ).

tff(pred_def_80417,type,
    v135335: state_type > $o ).

tff(pred_def_80418,type,
    v135332: ( state_type * $int ) > $o ).

tff(pred_def_80419,type,
    v135334: ( state_type * $int ) > $o ).

tff(pred_def_80420,type,
    v135323: ( state_type * $int ) > $o ).

tff(pred_def_80421,type,
    v972: ( state_type * $int ) > $o ).

tff(pred_def_80422,type,
    v970: ( state_type * $int ) > $o ).

tff(pred_def_80423,type,
    v135352: ( state_type * $int ) > $o ).

tff(pred_def_80424,type,
    v135351: state_type > $o ).

tff(pred_def_80425,type,
    v135355: state_type > $o ).

tff(pred_def_80426,type,
    v135356: state_type > $o ).

tff(pred_def_80427,type,
    v135354: state_type > $o ).

tff(pred_def_80428,type,
    v135357: state_type > $o ).

tff(pred_def_80429,type,
    v135353: state_type > $o ).

tff(pred_def_80430,type,
    v135350: state_type > $o ).

tff(pred_def_80431,type,
    v135358: state_type > $o ).

tff(pred_def_80432,type,
    v135349: state_type > $o ).

tff(pred_def_80433,type,
    v135361: state_type > $o ).

tff(pred_def_80434,type,
    v135362: state_type > $o ).

tff(pred_def_80435,type,
    v135360: state_type > $o ).

tff(pred_def_80436,type,
    v135363: state_type > $o ).

tff(pred_def_80437,type,
    v135359: state_type > $o ).

tff(pred_def_80438,type,
    v135348: state_type > $o ).

tff(pred_def_80439,type,
    v135364: state_type > $o ).

tff(pred_def_80440,type,
    v135347: state_type > $o ).

tff(pred_def_80441,type,
    v135367: state_type > $o ).

tff(pred_def_80442,type,
    v135368: state_type > $o ).

tff(pred_def_80443,type,
    v135366: state_type > $o ).

tff(pred_def_80444,type,
    v135369: state_type > $o ).

tff(pred_def_80445,type,
    v135365: state_type > $o ).

tff(pred_def_80446,type,
    v135346: state_type > $o ).

tff(pred_def_80447,type,
    v135370: state_type > $o ).

tff(pred_def_80448,type,
    v135345: state_type > $o ).

tff(pred_def_80449,type,
    v135344: state_type > $o ).

tff(pred_def_80450,type,
    v135374: state_type > $o ).

tff(pred_def_80451,type,
    v135375: state_type > $o ).

tff(pred_def_80452,type,
    v135373: state_type > $o ).

tff(pred_def_80453,type,
    v135376: state_type > $o ).

tff(pred_def_80454,type,
    v135372: state_type > $o ).

tff(pred_def_80455,type,
    v135371: state_type > $o ).

tff(pred_def_80456,type,
    v135343: state_type > $o ).

tff(pred_def_80457,type,
    v135377: state_type > $o ).

tff(pred_def_80458,type,
    v135342: state_type > $o ).

tff(pred_def_80459,type,
    v135380: state_type > $o ).

tff(pred_def_80460,type,
    v135381: state_type > $o ).

tff(pred_def_80461,type,
    v135379: state_type > $o ).

tff(pred_def_80462,type,
    v135382: state_type > $o ).

tff(pred_def_80463,type,
    v135378: state_type > $o ).

tff(pred_def_80464,type,
    v135385: state_type > $o ).

tff(pred_def_80465,type,
    v135386: state_type > $o ).

tff(pred_def_80466,type,
    v135384: state_type > $o ).

tff(pred_def_80467,type,
    v135387: state_type > $o ).

tff(pred_def_80468,type,
    v135383: state_type > $o ).

tff(pred_def_80469,type,
    v135390: state_type > $o ).

tff(pred_def_80470,type,
    v135391: state_type > $o ).

tff(pred_def_80471,type,
    v135389: state_type > $o ).

tff(pred_def_80472,type,
    v135392: state_type > $o ).

tff(pred_def_80473,type,
    v135388: state_type > $o ).

tff(pred_def_80474,type,
    v135395: state_type > $o ).

tff(pred_def_80475,type,
    v135396: state_type > $o ).

tff(pred_def_80476,type,
    v135394: state_type > $o ).

tff(pred_def_80477,type,
    v135397: state_type > $o ).

tff(pred_def_80478,type,
    v135393: state_type > $o ).

tff(pred_def_80479,type,
    v135340: ( state_type * $int ) > $o ).

tff(pred_def_80480,type,
    v83062: ( state_type * $int ) > $o ).

tff(pred_def_80481,type,
    v83060: ( state_type * $int ) > $o ).

tff(pred_def_80482,type,
    v83058: ( state_type * $int ) > $o ).

tff(pred_def_80483,type,
    v83056: ( state_type * $int ) > $o ).

tff(pred_def_80484,type,
    v135401: state_type > $o ).

tff(pred_def_80485,type,
    v135399: state_type > $o ).

tff(pred_def_80486,type,
    v135408: state_type > $o ).

tff(pred_def_80487,type,
    v135406: state_type > $o ).

tff(pred_def_80488,type,
    v135405: state_type > $o ).

tff(pred_def_80489,type,
    v135404: state_type > $o ).

tff(pred_def_80490,type,
    v135416: state_type > $o ).

tff(pred_def_80491,type,
    v135417: state_type > $o ).

tff(pred_def_80492,type,
    v135415: state_type > $o ).

tff(pred_def_80493,type,
    v135412: ( state_type * $int ) > $o ).

tff(pred_def_80494,type,
    v135414: ( state_type * $int ) > $o ).

tff(pred_def_80495,type,
    v135403: ( state_type * $int ) > $o ).

tff(pred_def_80496,type,
    v83046: ( state_type * $int ) > $o ).

tff(pred_def_80497,type,
    v83044: ( state_type * $int ) > $o ).

tff(pred_def_80498,type,
    v135422: state_type > $o ).

tff(pred_def_80499,type,
    v135421: ( state_type * $int ) > $o ).

tff(pred_def_80500,type,
    v135259: state_type > $o ).

tff(pred_def_80501,type,
    v135257: state_type > $o ).

tff(pred_def_80502,type,
    v135255: state_type > $o ).

tff(pred_def_80503,type,
    v135253: state_type > $o ).

tff(pred_def_80504,type,
    v135426: state_type > $o ).

tff(pred_def_80505,type,
    v135424: state_type > $o ).

tff(pred_def_80506,type,
    v135454: ( state_type * $int ) > $o ).

tff(pred_def_80507,type,
    v135453: state_type > $o ).

tff(pred_def_80508,type,
    v135452: state_type > $o ).

tff(pred_def_80509,type,
    v135451: state_type > $o ).

tff(pred_def_80510,type,
    v135450: state_type > $o ).

tff(pred_def_80511,type,
    v135449: state_type > $o ).

tff(pred_def_80512,type,
    v135448: state_type > $o ).

tff(pred_def_80513,type,
    v135447: state_type > $o ).

tff(pred_def_80514,type,
    v135446: state_type > $o ).

tff(pred_def_80515,type,
    v135445: state_type > $o ).

tff(pred_def_80516,type,
    v135444: state_type > $o ).

tff(pred_def_80517,type,
    v135443: state_type > $o ).

tff(pred_def_80518,type,
    v135442: state_type > $o ).

tff(pred_def_80519,type,
    v135441: state_type > $o ).

tff(pred_def_80520,type,
    v135440: state_type > $o ).

tff(pred_def_80521,type,
    v135438: state_type > $o ).

tff(pred_def_80522,type,
    v135470: state_type > $o ).

tff(pred_def_80523,type,
    v135469: state_type > $o ).

tff(pred_def_80524,type,
    v135468: state_type > $o ).

tff(pred_def_80525,type,
    v135467: state_type > $o ).

tff(pred_def_80526,type,
    v135466: state_type > $o ).

tff(pred_def_80527,type,
    v135465: state_type > $o ).

tff(pred_def_80528,type,
    v135464: state_type > $o ).

tff(pred_def_80529,type,
    v135463: state_type > $o ).

tff(pred_def_80530,type,
    v135462: state_type > $o ).

tff(pred_def_80531,type,
    v135461: state_type > $o ).

tff(pred_def_80532,type,
    v135460: state_type > $o ).

tff(pred_def_80533,type,
    v135459: state_type > $o ).

tff(pred_def_80534,type,
    v135458: state_type > $o ).

tff(pred_def_80535,type,
    v135457: state_type > $o ).

tff(pred_def_80536,type,
    v135455: state_type > $o ).

tff(pred_def_80537,type,
    v135437: state_type > $o ).

tff(pred_def_80538,type,
    v135471: state_type > $o ).

tff(pred_def_80539,type,
    v135436: state_type > $o ).

tff(pred_def_80540,type,
    v135435: state_type > $o ).

tff(pred_def_80541,type,
    v135434: state_type > $o ).

tff(pred_def_80542,type,
    v135472: state_type > $o ).

tff(pred_def_80543,type,
    v135433: state_type > $o ).

tff(pred_def_80544,type,
    v135432: state_type > $o ).

tff(pred_def_80545,type,
    v135473: state_type > $o ).

tff(pred_def_80546,type,
    v135431: state_type > $o ).

tff(pred_def_80547,type,
    v135474: state_type > $o ).

tff(pred_def_80548,type,
    v135430: state_type > $o ).

tff(pred_def_80549,type,
    v135475: state_type > $o ).

tff(pred_def_80550,type,
    v135429: state_type > $o ).

tff(pred_def_80551,type,
    v135476: state_type > $o ).

tff(pred_def_80552,type,
    v135428: state_type > $o ).

tff(pred_def_80553,type,
    v135477: state_type > $o ).

tff(pred_def_80554,type,
    v135488: state_type > $o ).

tff(pred_def_80555,type,
    v135487: state_type > $o ).

tff(pred_def_80556,type,
    v135490: state_type > $o ).

tff(pred_def_80557,type,
    v135489: state_type > $o ).

tff(pred_def_80558,type,
    v135486: state_type > $o ).

tff(pred_def_80559,type,
    v135492: state_type > $o ).

tff(pred_def_80560,type,
    v135491: state_type > $o ).

tff(pred_def_80561,type,
    v135485: state_type > $o ).

tff(pred_def_80562,type,
    v135494: state_type > $o ).

tff(pred_def_80563,type,
    v135493: state_type > $o ).

tff(pred_def_80564,type,
    v135484: state_type > $o ).

tff(pred_def_80565,type,
    v135496: state_type > $o ).

tff(pred_def_80566,type,
    v135495: state_type > $o ).

tff(pred_def_80567,type,
    v135483: state_type > $o ).

tff(pred_def_80568,type,
    v135498: state_type > $o ).

tff(pred_def_80569,type,
    v135497: state_type > $o ).

tff(pred_def_80570,type,
    v135482: state_type > $o ).

tff(pred_def_80571,type,
    v135500: state_type > $o ).

tff(pred_def_80572,type,
    v135499: state_type > $o ).

tff(pred_def_80573,type,
    v135481: state_type > $o ).

tff(pred_def_80574,type,
    v135502: state_type > $o ).

tff(pred_def_80575,type,
    v135501: state_type > $o ).

tff(pred_def_80576,type,
    v135479: state_type > $o ).

tff(pred_def_80577,type,
    v135513: state_type > $o ).

tff(pred_def_80578,type,
    v135512: state_type > $o ).

tff(pred_def_80579,type,
    v135515: state_type > $o ).

tff(pred_def_80580,type,
    v135514: state_type > $o ).

tff(pred_def_80581,type,
    v135511: state_type > $o ).

tff(pred_def_80582,type,
    v135517: state_type > $o ).

tff(pred_def_80583,type,
    v135516: state_type > $o ).

tff(pred_def_80584,type,
    v135510: state_type > $o ).

tff(pred_def_80585,type,
    v135519: state_type > $o ).

tff(pred_def_80586,type,
    v135518: state_type > $o ).

tff(pred_def_80587,type,
    v135509: state_type > $o ).

tff(pred_def_80588,type,
    v135521: state_type > $o ).

tff(pred_def_80589,type,
    v135520: state_type > $o ).

tff(pred_def_80590,type,
    v135508: state_type > $o ).

tff(pred_def_80591,type,
    v135523: state_type > $o ).

tff(pred_def_80592,type,
    v135522: state_type > $o ).

tff(pred_def_80593,type,
    v135507: state_type > $o ).

tff(pred_def_80594,type,
    v135525: state_type > $o ).

tff(pred_def_80595,type,
    v135524: state_type > $o ).

tff(pred_def_80596,type,
    v135506: state_type > $o ).

tff(pred_def_80597,type,
    v135527: state_type > $o ).

tff(pred_def_80598,type,
    v135526: state_type > $o ).

tff(pred_def_80599,type,
    v135504: state_type > $o ).

tff(pred_def_80600,type,
    v135539: state_type > $o ).

tff(pred_def_80601,type,
    v135537: state_type > $o ).

tff(pred_def_80602,type,
    v135543: state_type > $o ).

tff(pred_def_80603,type,
    v135541: state_type > $o ).

tff(pred_def_80604,type,
    v135558: state_type > $o ).

tff(pred_def_80605,type,
    v135557: state_type > $o ).

tff(pred_def_80606,type,
    v135560: state_type > $o ).

tff(pred_def_80607,type,
    v135559: state_type > $o ).

tff(pred_def_80608,type,
    v135556: state_type > $o ).

tff(pred_def_80609,type,
    v135555: state_type > $o ).

tff(pred_def_80610,type,
    v135554: state_type > $o ).

tff(pred_def_80611,type,
    v135529: state_type > $o ).

tff(pred_def_80612,type,
    v135553: state_type > $o ).

tff(pred_def_80613,type,
    v135561: ( state_type * $int ) > $o ).

tff(pred_def_80614,type,
    v135531: ( state_type * $int ) > $o ).

tff(pred_def_80615,type,
    v135563: state_type > $o ).

tff(pred_def_80616,type,
    v135569: state_type > $o ).

tff(pred_def_80617,type,
    v135568: state_type > $o ).

tff(pred_def_80618,type,
    v135571: state_type > $o ).

tff(pred_def_80619,type,
    v135570: state_type > $o ).

tff(pred_def_80620,type,
    v135567: state_type > $o ).

tff(pred_def_80621,type,
    v135565: ( state_type * $int ) > $o ).

tff(pred_def_80622,type,
    v135564: ( state_type * $int ) > $o ).

tff(pred_def_80623,type,
    v135562: ( state_type * $int ) > $o ).

tff(pred_def_80624,type,
    v135551: ( state_type * $int ) > $o ).

tff(pred_def_80625,type,
    v135549: ( state_type * $int ) > $o ).

tff(pred_def_80626,type,
    v135547: ( state_type * $int ) > $o ).

tff(pred_def_80627,type,
    v135545: ( state_type * $int ) > $o ).

tff(pred_def_80628,type,
    v135575: state_type > $o ).

tff(pred_def_80629,type,
    v135573: state_type > $o ).

tff(pred_def_80630,type,
    v135582: state_type > $o ).

tff(pred_def_80631,type,
    v135580: state_type > $o ).

tff(pred_def_80632,type,
    v135579: state_type > $o ).

tff(pred_def_80633,type,
    v135578: state_type > $o ).

tff(pred_def_80634,type,
    v135590: state_type > $o ).

tff(pred_def_80635,type,
    v135591: state_type > $o ).

tff(pred_def_80636,type,
    v135589: state_type > $o ).

tff(pred_def_80637,type,
    v135586: ( state_type * $int ) > $o ).

tff(pred_def_80638,type,
    v135588: ( state_type * $int ) > $o ).

tff(pred_def_80639,type,
    v135535: ( state_type * $int ) > $o ).

tff(pred_def_80640,type,
    v135533: ( state_type * $int ) > $o ).

tff(pred_def_80641,type,
    v135598: state_type > $o ).

tff(pred_def_80642,type,
    v135597: state_type > $o ).

tff(pred_def_80643,type,
    v135596: state_type > $o ).

tff(pred_def_80644,type,
    v135601: state_type > $o ).

tff(pred_def_80645,type,
    v135609: state_type > $o ).

tff(pred_def_80646,type,
    v135610: state_type > $o ).

tff(pred_def_80647,type,
    v135608: state_type > $o ).

tff(pred_def_80648,type,
    v135611: state_type > $o ).

tff(pred_def_80649,type,
    v135607: state_type > $o ).

tff(pred_def_80650,type,
    v135606: state_type > $o ).

tff(pred_def_80651,type,
    v135615: state_type > $o ).

tff(pred_def_80652,type,
    v135616: state_type > $o ).

tff(pred_def_80653,type,
    v135614: state_type > $o ).

tff(pred_def_80654,type,
    v135617: state_type > $o ).

tff(pred_def_80655,type,
    v135613: state_type > $o ).

tff(pred_def_80656,type,
    v135612: state_type > $o ).

tff(pred_def_80657,type,
    v135605: state_type > $o ).

tff(pred_def_80658,type,
    v135621: state_type > $o ).

tff(pred_def_80659,type,
    v135622: state_type > $o ).

tff(pred_def_80660,type,
    v135620: state_type > $o ).

tff(pred_def_80661,type,
    v135623: state_type > $o ).

tff(pred_def_80662,type,
    v135619: state_type > $o ).

tff(pred_def_80663,type,
    v135618: state_type > $o ).

tff(pred_def_80664,type,
    v135604: state_type > $o ).

tff(pred_def_80665,type,
    v135602: state_type > $o ).

tff(pred_def_80666,type,
    v135600: state_type > $o ).

tff(pred_def_80667,type,
    v135625: ( state_type * $int ) > $o ).

tff(pred_def_80668,type,
    v135624: state_type > $o ).

tff(pred_def_80669,type,
    v135599: state_type > $o ).

tff(pred_def_80670,type,
    v135627: state_type > $o ).

tff(pred_def_80671,type,
    v135628: state_type > $o ).

tff(pred_def_80672,type,
    v86875: state_type > $o ).

tff(pred_def_80673,type,
    v86873: state_type > $o ).

tff(pred_def_80674,type,
    v135633: state_type > $o ).

tff(pred_def_80675,type,
    v135632: ( state_type * $int ) > $o ).

tff(pred_def_80676,type,
    v135631: ( state_type * $int ) > $o ).

tff(pred_def_80677,type,
    v135636: state_type > $o ).

tff(pred_def_80678,type,
    v135635: ( state_type * $int ) > $o ).

tff(pred_def_80679,type,
    v135634: ( state_type * $int ) > $o ).

tff(pred_def_80680,type,
    v135630: ( state_type * $int ) > $o ).

tff(pred_def_80681,type,
    v135641: state_type > $o ).

tff(pred_def_80682,type,
    v135640: ( state_type * $int ) > $o ).

tff(pred_def_80683,type,
    v135639: ( state_type * $int ) > $o ).

tff(pred_def_80684,type,
    v86719: ( state_type * $int ) > $o ).

tff(pred_def_80685,type,
    v135638: ( state_type * $int ) > $o ).

tff(pred_def_80686,type,
    v135644: state_type > $o ).

tff(pred_def_80687,type,
    v135643: ( state_type * $int ) > $o ).

tff(pred_def_80688,type,
    v135642: ( state_type * $int ) > $o ).

tff(pred_def_80689,type,
    v135637: ( state_type * $int ) > $o ).

tff(pred_def_80690,type,
    v86733: ( state_type * $int ) > $o ).

tff(pred_def_80691,type,
    v86731: ( state_type * $int ) > $o ).

tff(pred_def_80692,type,
    v135648: state_type > $o ).

tff(pred_def_80693,type,
    v135646: state_type > $o ).

tff(pred_def_80694,type,
    v135655: state_type > $o ).

tff(pred_def_80695,type,
    v135653: state_type > $o ).

tff(pred_def_80696,type,
    v135652: state_type > $o ).

tff(pred_def_80697,type,
    v135651: state_type > $o ).

tff(pred_def_80698,type,
    v135663: state_type > $o ).

tff(pred_def_80699,type,
    v135664: state_type > $o ).

tff(pred_def_80700,type,
    v135662: state_type > $o ).

tff(pred_def_80701,type,
    v135659: ( state_type * $int ) > $o ).

tff(pred_def_80702,type,
    v135661: ( state_type * $int ) > $o ).

tff(pred_def_80703,type,
    v86721: ( state_type * $int ) > $o ).

tff(pred_def_80704,type,
    v135678: state_type > $o ).

tff(pred_def_80705,type,
    v135676: state_type > $o ).

tff(pred_def_80706,type,
    v135682: state_type > $o ).

tff(pred_def_80707,type,
    v135680: state_type > $o ).

tff(pred_def_80708,type,
    v135692: ( state_type * $int ) > $o ).

tff(pred_def_80709,type,
    v135690: ( state_type * $int ) > $o ).

tff(pred_def_80710,type,
    v135688: ( state_type * $int ) > $o ).

tff(pred_def_80711,type,
    b0000000011000: $int > $o ).

tff(pred_def_80712,type,
    v135700: state_type > $o ).

tff(pred_def_80713,type,
    v135697: state_type > $o ).

tff(pred_def_80714,type,
    v135695: state_type > $o ).

tff(pred_def_80715,type,
    v135704: state_type > $o ).

tff(pred_def_80716,type,
    v135703: ( state_type * $int ) > $o ).

tff(pred_def_80717,type,
    v135702: ( state_type * $int ) > $o ).

tff(pred_def_80718,type,
    v135708: state_type > $o ).

tff(pred_def_80719,type,
    v135707: ( state_type * $int ) > $o ).

tff(pred_def_80720,type,
    v135706: ( state_type * $int ) > $o ).

tff(pred_def_80721,type,
    v135672: ( state_type * $int ) > $o ).

tff(pred_def_80722,type,
    v135705: ( state_type * $int ) > $o ).

tff(pred_def_80723,type,
    v135686: ( state_type * $int ) > $o ).

tff(pred_def_80724,type,
    v135684: ( state_type * $int ) > $o ).

tff(pred_def_80725,type,
    v135712: state_type > $o ).

tff(pred_def_80726,type,
    v135710: state_type > $o ).

tff(pred_def_80727,type,
    v135719: state_type > $o ).

tff(pred_def_80728,type,
    v135717: state_type > $o ).

tff(pred_def_80729,type,
    v135716: state_type > $o ).

tff(pred_def_80730,type,
    v135715: state_type > $o ).

tff(pred_def_80731,type,
    v135727: state_type > $o ).

tff(pred_def_80732,type,
    v135728: state_type > $o ).

tff(pred_def_80733,type,
    v135726: state_type > $o ).

tff(pred_def_80734,type,
    v135723: ( state_type * $int ) > $o ).

tff(pred_def_80735,type,
    v135725: ( state_type * $int ) > $o ).

tff(pred_def_80736,type,
    v135674: ( state_type * $int ) > $o ).

tff(pred_def_80737,type,
    v135670: ( state_type * $int ) > $o ).

tff(pred_def_80738,type,
    v135668: ( state_type * $int ) > $o ).

tff(pred_def_80739,type,
    v135757: state_type > $o ).

tff(pred_def_80740,type,
    v135761: state_type > $o ).

tff(pred_def_80741,type,
    v135760: state_type > $o ).

tff(pred_def_80742,type,
    v135762: state_type > $o ).

tff(pred_def_80743,type,
    v135759: state_type > $o ).

tff(pred_def_80744,type,
    v135758: state_type > $o ).

tff(pred_def_80745,type,
    v135756: state_type > $o ).

tff(pred_def_80746,type,
    v135763: state_type > $o ).

tff(pred_def_80747,type,
    v135755: state_type > $o ).

tff(pred_def_80748,type,
    v135767: state_type > $o ).

tff(pred_def_80749,type,
    v135766: state_type > $o ).

tff(pred_def_80750,type,
    v135768: state_type > $o ).

tff(pred_def_80751,type,
    v135765: state_type > $o ).

tff(pred_def_80752,type,
    v135764: state_type > $o ).

tff(pred_def_80753,type,
    v135754: state_type > $o ).

tff(pred_def_80754,type,
    v135769: state_type > $o ).

tff(pred_def_80755,type,
    v135753: state_type > $o ).

tff(pred_def_80756,type,
    v135773: state_type > $o ).

tff(pred_def_80757,type,
    v135772: state_type > $o ).

tff(pred_def_80758,type,
    v135774: state_type > $o ).

tff(pred_def_80759,type,
    v135771: state_type > $o ).

tff(pred_def_80760,type,
    v135770: state_type > $o ).

tff(pred_def_80761,type,
    v135752: state_type > $o ).

tff(pred_def_80762,type,
    v135775: state_type > $o ).

tff(pred_def_80763,type,
    v135751: state_type > $o ).

tff(pred_def_80764,type,
    v135779: state_type > $o ).

tff(pred_def_80765,type,
    v135778: state_type > $o ).

tff(pred_def_80766,type,
    v135780: state_type > $o ).

tff(pred_def_80767,type,
    v135777: state_type > $o ).

tff(pred_def_80768,type,
    v135776: state_type > $o ).

tff(pred_def_80769,type,
    v135750: state_type > $o ).

tff(pred_def_80770,type,
    v135781: state_type > $o ).

tff(pred_def_80771,type,
    v135749: state_type > $o ).

tff(pred_def_80772,type,
    v135785: state_type > $o ).

tff(pred_def_80773,type,
    v135784: state_type > $o ).

tff(pred_def_80774,type,
    v135786: state_type > $o ).

tff(pred_def_80775,type,
    v135783: state_type > $o ).

tff(pred_def_80776,type,
    v135782: state_type > $o ).

tff(pred_def_80777,type,
    v135748: state_type > $o ).

tff(pred_def_80778,type,
    v135787: state_type > $o ).

tff(pred_def_80779,type,
    v135747: state_type > $o ).

tff(pred_def_80780,type,
    v135791: state_type > $o ).

tff(pred_def_80781,type,
    v135790: state_type > $o ).

tff(pred_def_80782,type,
    v135792: state_type > $o ).

tff(pred_def_80783,type,
    v135789: state_type > $o ).

tff(pred_def_80784,type,
    v135788: state_type > $o ).

tff(pred_def_80785,type,
    v135746: state_type > $o ).

tff(pred_def_80786,type,
    v135793: state_type > $o ).

tff(pred_def_80787,type,
    v135745: state_type > $o ).

tff(pred_def_80788,type,
    v135797: state_type > $o ).

tff(pred_def_80789,type,
    v135796: state_type > $o ).

tff(pred_def_80790,type,
    v135798: state_type > $o ).

tff(pred_def_80791,type,
    v135795: state_type > $o ).

tff(pred_def_80792,type,
    v135794: state_type > $o ).

tff(pred_def_80793,type,
    v135744: state_type > $o ).

tff(pred_def_80794,type,
    v135799: state_type > $o ).

tff(pred_def_80795,type,
    v135743: state_type > $o ).

tff(pred_def_80796,type,
    v135803: state_type > $o ).

tff(pred_def_80797,type,
    v135802: state_type > $o ).

tff(pred_def_80798,type,
    v135804: state_type > $o ).

tff(pred_def_80799,type,
    v135801: state_type > $o ).

tff(pred_def_80800,type,
    v135800: state_type > $o ).

tff(pred_def_80801,type,
    v135742: state_type > $o ).

tff(pred_def_80802,type,
    v135805: state_type > $o ).

tff(pred_def_80803,type,
    v135741: state_type > $o ).

tff(pred_def_80804,type,
    v135809: state_type > $o ).

tff(pred_def_80805,type,
    v135808: state_type > $o ).

tff(pred_def_80806,type,
    v135810: state_type > $o ).

tff(pred_def_80807,type,
    v135807: state_type > $o ).

tff(pred_def_80808,type,
    v135806: state_type > $o ).

tff(pred_def_80809,type,
    v135740: state_type > $o ).

tff(pred_def_80810,type,
    v135811: state_type > $o ).

tff(pred_def_80811,type,
    v135739: state_type > $o ).

tff(pred_def_80812,type,
    v135815: state_type > $o ).

tff(pred_def_80813,type,
    v135814: state_type > $o ).

tff(pred_def_80814,type,
    v135816: state_type > $o ).

tff(pred_def_80815,type,
    v135813: state_type > $o ).

tff(pred_def_80816,type,
    v135812: state_type > $o ).

tff(pred_def_80817,type,
    v135738: state_type > $o ).

tff(pred_def_80818,type,
    v135817: state_type > $o ).

tff(pred_def_80819,type,
    v135737: state_type > $o ).

tff(pred_def_80820,type,
    v135821: state_type > $o ).

tff(pred_def_80821,type,
    v135820: state_type > $o ).

tff(pred_def_80822,type,
    v135822: state_type > $o ).

tff(pred_def_80823,type,
    v135819: state_type > $o ).

tff(pred_def_80824,type,
    v135818: state_type > $o ).

tff(pred_def_80825,type,
    v135736: state_type > $o ).

tff(pred_def_80826,type,
    v135823: state_type > $o ).

tff(pred_def_80827,type,
    v135735: state_type > $o ).

tff(pred_def_80828,type,
    v135733: state_type > $o ).

tff(pred_def_80829,type,
    v135833: state_type > $o ).

tff(pred_def_80830,type,
    v135831: state_type > $o ).

tff(pred_def_80831,type,
    v135837: state_type > $o ).

tff(pred_def_80832,type,
    v135835: state_type > $o ).

tff(pred_def_80833,type,
    v135843: state_type > $o ).

tff(pred_def_80834,type,
    v135845: state_type > $o ).

tff(pred_def_80835,type,
    v135855: state_type > $o ).

tff(pred_def_80836,type,
    v135856: state_type > $o ).

tff(pred_def_80837,type,
    v135853: state_type > $o ).

tff(pred_def_80838,type,
    v135851: state_type > $o ).

tff(pred_def_80839,type,
    v135849: state_type > $o ).

tff(pred_def_80840,type,
    v135847: state_type > $o ).

tff(pred_def_80841,type,
    v135861: state_type > $o ).

tff(pred_def_80842,type,
    v135860: state_type > $o ).

tff(pred_def_80843,type,
    v135859: state_type > $o ).

tff(pred_def_80844,type,
    v135864: state_type > $o ).

tff(pred_def_80845,type,
    v135863: state_type > $o ).

tff(pred_def_80846,type,
    v135862: state_type > $o ).

tff(pred_def_80847,type,
    v135858: state_type > $o ).

tff(pred_def_80848,type,
    v135869: state_type > $o ).

tff(pred_def_80849,type,
    v135868: state_type > $o ).

tff(pred_def_80850,type,
    v135867: state_type > $o ).

tff(pred_def_80851,type,
    v135827: state_type > $o ).

tff(pred_def_80852,type,
    v135866: state_type > $o ).

tff(pred_def_80853,type,
    v135872: state_type > $o ).

tff(pred_def_80854,type,
    v135871: state_type > $o ).

tff(pred_def_80855,type,
    v135870: state_type > $o ).

tff(pred_def_80856,type,
    v135865: state_type > $o ).

tff(pred_def_80857,type,
    v135841: state_type > $o ).

tff(pred_def_80858,type,
    v135839: state_type > $o ).

tff(pred_def_80859,type,
    v135876: state_type > $o ).

tff(pred_def_80860,type,
    v135874: state_type > $o ).

tff(pred_def_80861,type,
    v135883: state_type > $o ).

tff(pred_def_80862,type,
    v135881: state_type > $o ).

tff(pred_def_80863,type,
    v135880: state_type > $o ).

tff(pred_def_80864,type,
    v135879: state_type > $o ).

tff(pred_def_80865,type,
    v135891: state_type > $o ).

tff(pred_def_80866,type,
    v135892: state_type > $o ).

tff(pred_def_80867,type,
    v135890: state_type > $o ).

tff(pred_def_80868,type,
    v135887: state_type > $o ).

tff(pred_def_80869,type,
    v135889: state_type > $o ).

tff(pred_def_80870,type,
    v135829: state_type > $o ).

tff(pred_def_80871,type,
    v135825: state_type > $o ).

tff(pred_def_80872,type,
    v135899: state_type > $o ).

tff(pred_def_80873,type,
    v135898: state_type > $o ).

tff(pred_def_80874,type,
    v135900: state_type > $o ).

tff(pred_def_80875,type,
    v135897: state_type > $o ).

tff(pred_def_80876,type,
    v135896: state_type > $o ).

tff(pred_def_80877,type,
    v135910: state_type > $o ).

tff(pred_def_80878,type,
    v135908: state_type > $o ).

tff(pred_def_80879,type,
    v135914: state_type > $o ).

tff(pred_def_80880,type,
    v135912: state_type > $o ).

tff(pred_def_80881,type,
    v135920: state_type > $o ).

tff(pred_def_80882,type,
    v135918: state_type > $o ).

tff(pred_def_80883,type,
    v135916: state_type > $o ).

tff(pred_def_80884,type,
    v135924: state_type > $o ).

tff(pred_def_80885,type,
    v135922: state_type > $o ).

tff(pred_def_80886,type,
    v135931: state_type > $o ).

tff(pred_def_80887,type,
    v135929: state_type > $o ).

tff(pred_def_80888,type,
    v135928: state_type > $o ).

tff(pred_def_80889,type,
    v135927: state_type > $o ).

tff(pred_def_80890,type,
    v135939: state_type > $o ).

tff(pred_def_80891,type,
    v135940: state_type > $o ).

tff(pred_def_80892,type,
    v135938: state_type > $o ).

tff(pred_def_80893,type,
    v135935: state_type > $o ).

tff(pred_def_80894,type,
    v135937: state_type > $o ).

tff(pred_def_80895,type,
    v135906: state_type > $o ).

tff(pred_def_80896,type,
    v135904: state_type > $o ).

tff(pred_def_80897,type,
    v135902: state_type > $o ).

tff(pred_def_80898,type,
    v135944: state_type > $o ).

tff(pred_def_80899,type,
    v135951: state_type > $o ).

tff(pred_def_80900,type,
    v5144: state_type > $o ).

tff(pred_def_80901,type,
    v135950: state_type > $o ).

tff(pred_def_80902,type,
    v135952: state_type > $o ).

tff(pred_def_80903,type,
    v135949: state_type > $o ).

tff(pred_def_80904,type,
    v135953: state_type > $o ).

tff(pred_def_80905,type,
    v135948: state_type > $o ).

tff(pred_def_80906,type,
    v135954: state_type > $o ).

tff(pred_def_80907,type,
    v135947: state_type > $o ).

tff(pred_def_80908,type,
    v135955: state_type > $o ).

tff(pred_def_80909,type,
    v135946: state_type > $o ).

tff(pred_def_80910,type,
    v135956: state_type > $o ).

tff(pred_def_80911,type,
    v85776: state_type > $o ).

tff(pred_def_80912,type,
    v135962: state_type > $o ).

tff(pred_def_80913,type,
    v135964: state_type > $o ).

tff(pred_def_80914,type,
    v135966: state_type > $o ).

tff(pred_def_80915,type,
    v135968: state_type > $o ).

tff(pred_def_80916,type,
    v135960: state_type > $o ).

tff(pred_def_80917,type,
    v135975: state_type > $o ).

tff(pred_def_80918,type,
    v135973: state_type > $o ).

tff(pred_def_80919,type,
    v135972: state_type > $o ).

tff(pred_def_80920,type,
    v135971: state_type > $o ).

tff(pred_def_80921,type,
    v135983: state_type > $o ).

tff(pred_def_80922,type,
    v135984: state_type > $o ).

tff(pred_def_80923,type,
    v135982: state_type > $o ).

tff(pred_def_80924,type,
    v135979: state_type > $o ).

tff(pred_def_80925,type,
    v135981: state_type > $o ).

tff(pred_def_80926,type,
    v135958: state_type > $o ).

tff(pred_def_80927,type,
    v135988: state_type > $o ).

tff(pred_def_80928,type,
    v85772: state_type > $o ).

tff(pred_def_80929,type,
    v135992: state_type > $o ).

tff(pred_def_80930,type,
    v135994: state_type > $o ).

tff(pred_def_80931,type,
    v135996: state_type > $o ).

tff(pred_def_80932,type,
    v135998: state_type > $o ).

tff(pred_def_80933,type,
    v136000: state_type > $o ).

tff(pred_def_80934,type,
    v136002: state_type > $o ).

tff(pred_def_80935,type,
    v136004: state_type > $o ).

tff(pred_def_80936,type,
    v136053: ( state_type * $int ) > $o ).

tff(pred_def_80937,type,
    v136054: ( state_type * $int ) > $o ).

tff(pred_def_80938,type,
    v136052: state_type > $o ).

tff(pred_def_80939,type,
    v136057: state_type > $o ).

tff(pred_def_80940,type,
    v136058: state_type > $o ).

tff(pred_def_80941,type,
    v136056: state_type > $o ).

tff(pred_def_80942,type,
    v136059: state_type > $o ).

tff(pred_def_80943,type,
    v136055: state_type > $o ).

tff(pred_def_80944,type,
    v136051: state_type > $o ).

tff(pred_def_80945,type,
    v136060: state_type > $o ).

tff(pred_def_80946,type,
    v136050: state_type > $o ).

tff(pred_def_80947,type,
    v136049: state_type > $o ).

tff(pred_def_80948,type,
    v136064: state_type > $o ).

tff(pred_def_80949,type,
    v136065: state_type > $o ).

tff(pred_def_80950,type,
    v136063: state_type > $o ).

tff(pred_def_80951,type,
    v136066: state_type > $o ).

tff(pred_def_80952,type,
    v136062: state_type > $o ).

tff(pred_def_80953,type,
    v136061: state_type > $o ).

tff(pred_def_80954,type,
    v136048: state_type > $o ).

tff(pred_def_80955,type,
    v136067: state_type > $o ).

tff(pred_def_80956,type,
    v136047: state_type > $o ).

tff(pred_def_80957,type,
    v136070: state_type > $o ).

tff(pred_def_80958,type,
    v136071: state_type > $o ).

tff(pred_def_80959,type,
    v136069: state_type > $o ).

tff(pred_def_80960,type,
    v136072: state_type > $o ).

tff(pred_def_80961,type,
    v136068: state_type > $o ).

tff(pred_def_80962,type,
    v136075: state_type > $o ).

tff(pred_def_80963,type,
    v136076: state_type > $o ).

tff(pred_def_80964,type,
    v136074: state_type > $o ).

tff(pred_def_80965,type,
    v136077: state_type > $o ).

tff(pred_def_80966,type,
    v136073: state_type > $o ).

tff(pred_def_80967,type,
    v136045: ( state_type * $int ) > $o ).

tff(pred_def_80968,type,
    v136078: ( state_type * $int ) > $o ).

tff(pred_def_80969,type,
    v136044: state_type > $o ).

tff(pred_def_80970,type,
    v136081: state_type > $o ).

tff(pred_def_80971,type,
    v136082: state_type > $o ).

tff(pred_def_80972,type,
    v136080: state_type > $o ).

tff(pred_def_80973,type,
    v136083: state_type > $o ).

tff(pred_def_80974,type,
    v136079: state_type > $o ).

tff(pred_def_80975,type,
    v136043: state_type > $o ).

tff(pred_def_80976,type,
    v136084: state_type > $o ).

tff(pred_def_80977,type,
    v136042: state_type > $o ).

tff(pred_def_80978,type,
    v136041: state_type > $o ).

tff(pred_def_80979,type,
    v136088: state_type > $o ).

tff(pred_def_80980,type,
    v136089: state_type > $o ).

tff(pred_def_80981,type,
    v136087: state_type > $o ).

tff(pred_def_80982,type,
    v136090: state_type > $o ).

tff(pred_def_80983,type,
    v136086: state_type > $o ).

tff(pred_def_80984,type,
    v136085: state_type > $o ).

tff(pred_def_80985,type,
    v136040: state_type > $o ).

tff(pred_def_80986,type,
    v136091: state_type > $o ).

tff(pred_def_80987,type,
    v136039: state_type > $o ).

tff(pred_def_80988,type,
    v136094: state_type > $o ).

tff(pred_def_80989,type,
    v136095: state_type > $o ).

tff(pred_def_80990,type,
    v136093: state_type > $o ).

tff(pred_def_80991,type,
    v136096: state_type > $o ).

tff(pred_def_80992,type,
    v136092: state_type > $o ).

tff(pred_def_80993,type,
    v136099: state_type > $o ).

tff(pred_def_80994,type,
    v136100: state_type > $o ).

tff(pred_def_80995,type,
    v136098: state_type > $o ).

tff(pred_def_80996,type,
    v136101: state_type > $o ).

tff(pred_def_80997,type,
    v136097: state_type > $o ).

tff(pred_def_80998,type,
    v136037: ( state_type * $int ) > $o ).

tff(pred_def_80999,type,
    v136102: ( state_type * $int ) > $o ).

tff(pred_def_81000,type,
    v136036: state_type > $o ).

tff(pred_def_81001,type,
    v136105: state_type > $o ).

tff(pred_def_81002,type,
    v136106: state_type > $o ).

tff(pred_def_81003,type,
    v136104: state_type > $o ).

tff(pred_def_81004,type,
    v136107: state_type > $o ).

tff(pred_def_81005,type,
    v136103: state_type > $o ).

tff(pred_def_81006,type,
    v136035: state_type > $o ).

tff(pred_def_81007,type,
    v136108: state_type > $o ).

tff(pred_def_81008,type,
    v136034: state_type > $o ).

tff(pred_def_81009,type,
    v136033: state_type > $o ).

tff(pred_def_81010,type,
    v136112: state_type > $o ).

tff(pred_def_81011,type,
    v136113: state_type > $o ).

tff(pred_def_81012,type,
    v136111: state_type > $o ).

tff(pred_def_81013,type,
    v136114: state_type > $o ).

tff(pred_def_81014,type,
    v136110: state_type > $o ).

tff(pred_def_81015,type,
    v136109: state_type > $o ).

tff(pred_def_81016,type,
    v136032: state_type > $o ).

tff(pred_def_81017,type,
    v136115: state_type > $o ).

tff(pred_def_81018,type,
    v136031: state_type > $o ).

tff(pred_def_81019,type,
    v136118: state_type > $o ).

tff(pred_def_81020,type,
    v136119: state_type > $o ).

tff(pred_def_81021,type,
    v136117: state_type > $o ).

tff(pred_def_81022,type,
    v136120: state_type > $o ).

tff(pred_def_81023,type,
    v136116: state_type > $o ).

tff(pred_def_81024,type,
    v136123: state_type > $o ).

tff(pred_def_81025,type,
    v136124: state_type > $o ).

tff(pred_def_81026,type,
    v136122: state_type > $o ).

tff(pred_def_81027,type,
    v136125: state_type > $o ).

tff(pred_def_81028,type,
    v136121: state_type > $o ).

tff(pred_def_81029,type,
    v136029: ( state_type * $int ) > $o ).

tff(pred_def_81030,type,
    v136126: ( state_type * $int ) > $o ).

tff(pred_def_81031,type,
    v136028: state_type > $o ).

tff(pred_def_81032,type,
    v136129: state_type > $o ).

tff(pred_def_81033,type,
    v136130: state_type > $o ).

tff(pred_def_81034,type,
    v136128: state_type > $o ).

tff(pred_def_81035,type,
    v136131: state_type > $o ).

tff(pred_def_81036,type,
    v136127: state_type > $o ).

tff(pred_def_81037,type,
    v136027: state_type > $o ).

tff(pred_def_81038,type,
    v136132: state_type > $o ).

tff(pred_def_81039,type,
    v136026: state_type > $o ).

tff(pred_def_81040,type,
    v136025: state_type > $o ).

tff(pred_def_81041,type,
    v136136: state_type > $o ).

tff(pred_def_81042,type,
    v136137: state_type > $o ).

tff(pred_def_81043,type,
    v136135: state_type > $o ).

tff(pred_def_81044,type,
    v136138: state_type > $o ).

tff(pred_def_81045,type,
    v136134: state_type > $o ).

tff(pred_def_81046,type,
    v136133: state_type > $o ).

tff(pred_def_81047,type,
    v136024: state_type > $o ).

tff(pred_def_81048,type,
    v136139: state_type > $o ).

tff(pred_def_81049,type,
    v136023: state_type > $o ).

tff(pred_def_81050,type,
    v136142: state_type > $o ).

tff(pred_def_81051,type,
    v136143: state_type > $o ).

tff(pred_def_81052,type,
    v136141: state_type > $o ).

tff(pred_def_81053,type,
    v136144: state_type > $o ).

tff(pred_def_81054,type,
    v136140: state_type > $o ).

tff(pred_def_81055,type,
    v136147: state_type > $o ).

tff(pred_def_81056,type,
    v136148: state_type > $o ).

tff(pred_def_81057,type,
    v136146: state_type > $o ).

tff(pred_def_81058,type,
    v136149: state_type > $o ).

tff(pred_def_81059,type,
    v136145: state_type > $o ).

tff(pred_def_81060,type,
    v136021: ( state_type * $int ) > $o ).

tff(pred_def_81061,type,
    v136150: ( state_type * $int ) > $o ).

tff(pred_def_81062,type,
    v136020: state_type > $o ).

tff(pred_def_81063,type,
    v136153: state_type > $o ).

tff(pred_def_81064,type,
    v136154: state_type > $o ).

tff(pred_def_81065,type,
    v136152: state_type > $o ).

tff(pred_def_81066,type,
    v136155: state_type > $o ).

tff(pred_def_81067,type,
    v136151: state_type > $o ).

tff(pred_def_81068,type,
    v136019: state_type > $o ).

tff(pred_def_81069,type,
    v136156: state_type > $o ).

tff(pred_def_81070,type,
    v136018: state_type > $o ).

tff(pred_def_81071,type,
    v136017: state_type > $o ).

tff(pred_def_81072,type,
    v136160: state_type > $o ).

tff(pred_def_81073,type,
    v136161: state_type > $o ).

tff(pred_def_81074,type,
    v136159: state_type > $o ).

tff(pred_def_81075,type,
    v136162: state_type > $o ).

tff(pred_def_81076,type,
    v136158: state_type > $o ).

tff(pred_def_81077,type,
    v136157: state_type > $o ).

tff(pred_def_81078,type,
    v136016: state_type > $o ).

tff(pred_def_81079,type,
    v136163: state_type > $o ).

tff(pred_def_81080,type,
    v136015: state_type > $o ).

tff(pred_def_81081,type,
    v136166: state_type > $o ).

tff(pred_def_81082,type,
    v136167: state_type > $o ).

tff(pred_def_81083,type,
    v136165: state_type > $o ).

tff(pred_def_81084,type,
    v136168: state_type > $o ).

tff(pred_def_81085,type,
    v136164: state_type > $o ).

tff(pred_def_81086,type,
    v136171: state_type > $o ).

tff(pred_def_81087,type,
    v136172: state_type > $o ).

tff(pred_def_81088,type,
    v136170: state_type > $o ).

tff(pred_def_81089,type,
    v136173: state_type > $o ).

tff(pred_def_81090,type,
    v136169: state_type > $o ).

tff(pred_def_81091,type,
    v136013: ( state_type * $int ) > $o ).

tff(pred_def_81092,type,
    v136174: ( state_type * $int ) > $o ).

tff(pred_def_81093,type,
    v136012: state_type > $o ).

tff(pred_def_81094,type,
    v136177: state_type > $o ).

tff(pred_def_81095,type,
    v136178: state_type > $o ).

tff(pred_def_81096,type,
    v136176: state_type > $o ).

tff(pred_def_81097,type,
    v136179: state_type > $o ).

tff(pred_def_81098,type,
    v136175: state_type > $o ).

tff(pred_def_81099,type,
    v136011: state_type > $o ).

tff(pred_def_81100,type,
    v136180: state_type > $o ).

tff(pred_def_81101,type,
    v136010: state_type > $o ).

tff(pred_def_81102,type,
    v136009: state_type > $o ).

tff(pred_def_81103,type,
    v136184: state_type > $o ).

tff(pred_def_81104,type,
    v136185: state_type > $o ).

tff(pred_def_81105,type,
    v136183: state_type > $o ).

tff(pred_def_81106,type,
    v136186: state_type > $o ).

tff(pred_def_81107,type,
    v136182: state_type > $o ).

tff(pred_def_81108,type,
    v136181: state_type > $o ).

tff(pred_def_81109,type,
    v136008: state_type > $o ).

tff(pred_def_81110,type,
    v136187: state_type > $o ).

tff(pred_def_81111,type,
    v136007: state_type > $o ).

tff(pred_def_81112,type,
    v136190: state_type > $o ).

tff(pred_def_81113,type,
    v136191: state_type > $o ).

tff(pred_def_81114,type,
    v136189: state_type > $o ).

tff(pred_def_81115,type,
    v136192: state_type > $o ).

tff(pred_def_81116,type,
    v136188: state_type > $o ).

tff(pred_def_81117,type,
    v136195: state_type > $o ).

tff(pred_def_81118,type,
    v136196: state_type > $o ).

tff(pred_def_81119,type,
    v136194: state_type > $o ).

tff(pred_def_81120,type,
    v136197: state_type > $o ).

tff(pred_def_81121,type,
    v136193: state_type > $o ).

tff(pred_def_81122,type,
    v136005: ( state_type * $int ) > $o ).

tff(pred_def_81123,type,
    v135990: ( state_type * $int ) > $o ).

tff(pred_def_81124,type,
    v136205: state_type > $o ).

tff(pred_def_81125,type,
    v136204: state_type > $o ).

tff(pred_def_81126,type,
    v136203: state_type > $o ).

tff(pred_def_81127,type,
    v136202: state_type > $o ).

tff(pred_def_81128,type,
    v136201: state_type > $o ).

tff(pred_def_81129,type,
    v136200: ( state_type * $int ) > $o ).

tff(pred_def_81130,type,
    v136199: ( state_type * $int ) > $o ).

tff(pred_def_81131,type,
    v136209: state_type > $o ).

tff(pred_def_81132,type,
    v136208: state_type > $o ).

tff(pred_def_81133,type,
    v136207: ( state_type * $int ) > $o ).

tff(pred_def_81134,type,
    v136238: ( state_type * $int ) > $o ).

tff(pred_def_81135,type,
    v85750: ( state_type * $int ) > $o ).

tff(pred_def_81136,type,
    v136237: state_type > $o ).

tff(pred_def_81137,type,
    v136241: state_type > $o ).

tff(pred_def_81138,type,
    v136242: state_type > $o ).

tff(pred_def_81139,type,
    v136240: state_type > $o ).

tff(pred_def_81140,type,
    v136243: state_type > $o ).

tff(pred_def_81141,type,
    v136239: state_type > $o ).

tff(pred_def_81142,type,
    v136236: state_type > $o ).

tff(pred_def_81143,type,
    v136244: state_type > $o ).

tff(pred_def_81144,type,
    v136235: state_type > $o ).

tff(pred_def_81145,type,
    v136247: state_type > $o ).

tff(pred_def_81146,type,
    v136248: state_type > $o ).

tff(pred_def_81147,type,
    v136246: state_type > $o ).

tff(pred_def_81148,type,
    v136249: state_type > $o ).

tff(pred_def_81149,type,
    v136245: state_type > $o ).

tff(pred_def_81150,type,
    v136234: state_type > $o ).

tff(pred_def_81151,type,
    v136250: state_type > $o ).

tff(pred_def_81152,type,
    v136233: state_type > $o ).

tff(pred_def_81153,type,
    v136253: state_type > $o ).

tff(pred_def_81154,type,
    v136254: state_type > $o ).

tff(pred_def_81155,type,
    v136252: state_type > $o ).

tff(pred_def_81156,type,
    v136255: state_type > $o ).

tff(pred_def_81157,type,
    v136251: state_type > $o ).

tff(pred_def_81158,type,
    v136232: state_type > $o ).

tff(pred_def_81159,type,
    v136256: state_type > $o ).

tff(pred_def_81160,type,
    v136231: state_type > $o ).

tff(pred_def_81161,type,
    v136259: state_type > $o ).

tff(pred_def_81162,type,
    v136260: state_type > $o ).

tff(pred_def_81163,type,
    v136258: state_type > $o ).

tff(pred_def_81164,type,
    v136261: state_type > $o ).

tff(pred_def_81165,type,
    v136257: state_type > $o ).

tff(pred_def_81166,type,
    v136230: state_type > $o ).

tff(pred_def_81167,type,
    v136262: state_type > $o ).

tff(pred_def_81168,type,
    v136229: state_type > $o ).

tff(pred_def_81169,type,
    v136228: state_type > $o ).

tff(pred_def_81170,type,
    v136266: state_type > $o ).

tff(pred_def_81171,type,
    v136267: state_type > $o ).

tff(pred_def_81172,type,
    v136265: state_type > $o ).

tff(pred_def_81173,type,
    v136268: state_type > $o ).

tff(pred_def_81174,type,
    v136264: state_type > $o ).

tff(pred_def_81175,type,
    v136263: state_type > $o ).

tff(pred_def_81176,type,
    v136227: state_type > $o ).

tff(pred_def_81177,type,
    v136269: state_type > $o ).

tff(pred_def_81178,type,
    v136226: state_type > $o ).

tff(pred_def_81179,type,
    v136272: state_type > $o ).

tff(pred_def_81180,type,
    v136273: state_type > $o ).

tff(pred_def_81181,type,
    v136271: state_type > $o ).

tff(pred_def_81182,type,
    v136274: state_type > $o ).

tff(pred_def_81183,type,
    v136270: state_type > $o ).

tff(pred_def_81184,type,
    v136277: state_type > $o ).

tff(pred_def_81185,type,
    v136278: state_type > $o ).

tff(pred_def_81186,type,
    v136276: state_type > $o ).

tff(pred_def_81187,type,
    v136279: state_type > $o ).

tff(pred_def_81188,type,
    v136275: state_type > $o ).

tff(pred_def_81189,type,
    v136282: state_type > $o ).

tff(pred_def_81190,type,
    v136283: state_type > $o ).

tff(pred_def_81191,type,
    v136281: state_type > $o ).

tff(pred_def_81192,type,
    v136284: state_type > $o ).

tff(pred_def_81193,type,
    v136280: state_type > $o ).

tff(pred_def_81194,type,
    v136287: state_type > $o ).

tff(pred_def_81195,type,
    v136288: state_type > $o ).

tff(pred_def_81196,type,
    v136286: state_type > $o ).

tff(pred_def_81197,type,
    v136289: state_type > $o ).

tff(pred_def_81198,type,
    v136285: state_type > $o ).

tff(pred_def_81199,type,
    v136292: state_type > $o ).

tff(pred_def_81200,type,
    v136293: state_type > $o ).

tff(pred_def_81201,type,
    v136291: state_type > $o ).

tff(pred_def_81202,type,
    v136294: state_type > $o ).

tff(pred_def_81203,type,
    v136290: state_type > $o ).

tff(pred_def_81204,type,
    v136224: ( state_type * $int ) > $o ).

tff(pred_def_81205,type,
    v136223: state_type > $o ).

tff(pred_def_81206,type,
    v136299: state_type > $o ).

tff(pred_def_81207,type,
    v136301: state_type > $o ).

tff(pred_def_81208,type,
    v136302: state_type > $o ).

tff(pred_def_81209,type,
    v136300: state_type > $o ).

tff(pred_def_81210,type,
    v136298: state_type > $o ).

tff(pred_def_81211,type,
    v136297: state_type > $o ).

tff(pred_def_81212,type,
    v136303: state_type > $o ).

tff(pred_def_81213,type,
    v136296: state_type > $o ).

tff(pred_def_81214,type,
    v136304: state_type > $o ).

tff(pred_def_81215,type,
    v136295: state_type > $o ).

tff(pred_def_81216,type,
    v136222: state_type > $o ).

tff(pred_def_81217,type,
    v136305: state_type > $o ).

tff(pred_def_81218,type,
    v136221: state_type > $o ).

tff(pred_def_81219,type,
    v136312: state_type > $o ).

tff(pred_def_81220,type,
    v136311: state_type > $o ).

tff(pred_def_81221,type,
    v136310: state_type > $o ).

tff(pred_def_81222,type,
    v136314: state_type > $o ).

tff(pred_def_81223,type,
    v136313: state_type > $o ).

tff(pred_def_81224,type,
    v136309: state_type > $o ).

tff(pred_def_81225,type,
    v136308: state_type > $o ).

tff(pred_def_81226,type,
    v136315: state_type > $o ).

tff(pred_def_81227,type,
    v136307: state_type > $o ).

tff(pred_def_81228,type,
    v136316: state_type > $o ).

tff(pred_def_81229,type,
    v136306: state_type > $o ).

tff(pred_def_81230,type,
    v136220: state_type > $o ).

tff(pred_def_81231,type,
    v136317: state_type > $o ).

tff(pred_def_81232,type,
    v136219: state_type > $o ).

tff(pred_def_81233,type,
    v136324: state_type > $o ).

tff(pred_def_81234,type,
    v136323: state_type > $o ).

tff(pred_def_81235,type,
    v136322: state_type > $o ).

tff(pred_def_81236,type,
    v136326: state_type > $o ).

tff(pred_def_81237,type,
    v136325: state_type > $o ).

tff(pred_def_81238,type,
    v136321: state_type > $o ).

tff(pred_def_81239,type,
    v136320: state_type > $o ).

tff(pred_def_81240,type,
    v136327: state_type > $o ).

tff(pred_def_81241,type,
    v136319: state_type > $o ).

tff(pred_def_81242,type,
    v136328: state_type > $o ).

tff(pred_def_81243,type,
    v136318: state_type > $o ).

tff(pred_def_81244,type,
    v136218: state_type > $o ).

tff(pred_def_81245,type,
    v136329: state_type > $o ).

tff(pred_def_81246,type,
    v136217: state_type > $o ).

tff(pred_def_81247,type,
    v136336: state_type > $o ).

tff(pred_def_81248,type,
    v136335: state_type > $o ).

tff(pred_def_81249,type,
    v136334: state_type > $o ).

tff(pred_def_81250,type,
    v136338: state_type > $o ).

tff(pred_def_81251,type,
    v136337: state_type > $o ).

tff(pred_def_81252,type,
    v136333: state_type > $o ).

tff(pred_def_81253,type,
    v136332: state_type > $o ).

tff(pred_def_81254,type,
    v136339: state_type > $o ).

tff(pred_def_81255,type,
    v136331: state_type > $o ).

tff(pred_def_81256,type,
    v136340: state_type > $o ).

tff(pred_def_81257,type,
    v136330: state_type > $o ).

tff(pred_def_81258,type,
    v136216: state_type > $o ).

tff(pred_def_81259,type,
    v136341: state_type > $o ).

tff(pred_def_81260,type,
    v136215: state_type > $o ).

tff(pred_def_81261,type,
    v136214: state_type > $o ).

tff(pred_def_81262,type,
    v136349: state_type > $o ).

tff(pred_def_81263,type,
    v136348: state_type > $o ).

tff(pred_def_81264,type,
    v136347: state_type > $o ).

tff(pred_def_81265,type,
    v136351: state_type > $o ).

tff(pred_def_81266,type,
    v136350: state_type > $o ).

tff(pred_def_81267,type,
    v136346: state_type > $o ).

tff(pred_def_81268,type,
    v136345: state_type > $o ).

tff(pred_def_81269,type,
    v136352: state_type > $o ).

tff(pred_def_81270,type,
    v136344: state_type > $o ).

tff(pred_def_81271,type,
    v136353: state_type > $o ).

tff(pred_def_81272,type,
    v136343: state_type > $o ).

tff(pred_def_81273,type,
    v136342: state_type > $o ).

tff(pred_def_81274,type,
    v136213: state_type > $o ).

tff(pred_def_81275,type,
    v136354: state_type > $o ).

tff(pred_def_81276,type,
    v136212: state_type > $o ).

tff(pred_def_81277,type,
    v136357: state_type > $o ).

tff(pred_def_81278,type,
    v136358: state_type > $o ).

tff(pred_def_81279,type,
    v136356: state_type > $o ).

tff(pred_def_81280,type,
    v136359: state_type > $o ).

tff(pred_def_81281,type,
    v136355: state_type > $o ).

tff(pred_def_81282,type,
    v136362: state_type > $o ).

tff(pred_def_81283,type,
    v136363: state_type > $o ).

tff(pred_def_81284,type,
    v136361: state_type > $o ).

tff(pred_def_81285,type,
    v136364: state_type > $o ).

tff(pred_def_81286,type,
    v136360: state_type > $o ).

tff(pred_def_81287,type,
    v136367: state_type > $o ).

tff(pred_def_81288,type,
    v136368: state_type > $o ).

tff(pred_def_81289,type,
    v136366: state_type > $o ).

tff(pred_def_81290,type,
    v136369: state_type > $o ).

tff(pred_def_81291,type,
    v136365: state_type > $o ).

tff(pred_def_81292,type,
    v136372: state_type > $o ).

tff(pred_def_81293,type,
    v136373: state_type > $o ).

tff(pred_def_81294,type,
    v136371: state_type > $o ).

tff(pred_def_81295,type,
    v136374: state_type > $o ).

tff(pred_def_81296,type,
    v136370: state_type > $o ).

tff(pred_def_81297,type,
    v136377: state_type > $o ).

tff(pred_def_81298,type,
    v136376: state_type > $o ).

tff(pred_def_81299,type,
    v136378: state_type > $o ).

tff(pred_def_81300,type,
    v136375: state_type > $o ).

tff(pred_def_81301,type,
    v136210: ( state_type * $int ) > $o ).

tff(pred_def_81302,type,
    v85770: ( state_type * $int ) > $o ).

tff(pred_def_81303,type,
    v85768: ( state_type * $int ) > $o ).

tff(pred_def_81304,type,
    v85766: ( state_type * $int ) > $o ).

tff(pred_def_81305,type,
    v85764: ( state_type * $int ) > $o ).

tff(pred_def_81306,type,
    v136382: state_type > $o ).

tff(pred_def_81307,type,
    v136380: state_type > $o ).

tff(pred_def_81308,type,
    v136389: state_type > $o ).

tff(pred_def_81309,type,
    v136387: state_type > $o ).

tff(pred_def_81310,type,
    v136386: state_type > $o ).

tff(pred_def_81311,type,
    v136385: state_type > $o ).

tff(pred_def_81312,type,
    v136397: state_type > $o ).

tff(pred_def_81313,type,
    v136398: state_type > $o ).

tff(pred_def_81314,type,
    v136396: state_type > $o ).

tff(pred_def_81315,type,
    v136393: ( state_type * $int ) > $o ).

tff(pred_def_81316,type,
    v136395: ( state_type * $int ) > $o ).

tff(pred_def_81317,type,
    v85754: ( state_type * $int ) > $o ).

tff(pred_def_81318,type,
    v85752: ( state_type * $int ) > $o ).

tff(pred_def_81319,type,
    v136402: state_type > $o ).

tff(pred_def_81320,type,
    v136404: state_type > $o ).

tff(pred_def_81321,type,
    v136405: state_type > $o ).

tff(pred_def_81322,type,
    v136411: state_type > $o ).

tff(pred_def_81323,type,
    v136410: state_type > $o ).

tff(pred_def_81324,type,
    v136413: state_type > $o ).

tff(pred_def_81325,type,
    v136414: state_type > $o ).

tff(pred_def_81326,type,
    v136412: state_type > $o ).

tff(pred_def_81327,type,
    v136409: state_type > $o ).

tff(pred_def_81328,type,
    v136417: state_type > $o ).

tff(pred_def_81329,type,
    v136416: state_type > $o ).

tff(pred_def_81330,type,
    v136418: state_type > $o ).

tff(pred_def_81331,type,
    v136415: state_type > $o ).

tff(pred_def_81332,type,
    v136408: state_type > $o ).

tff(pred_def_81333,type,
    v136422: state_type > $o ).

tff(pred_def_81334,type,
    v136421: state_type > $o ).

tff(pred_def_81335,type,
    v136420: state_type > $o ).

tff(pred_def_81336,type,
    v136423: state_type > $o ).

tff(pred_def_81337,type,
    v136419: state_type > $o ).

tff(pred_def_81338,type,
    v136407: state_type > $o ).

tff(pred_def_81339,type,
    v136430: state_type > $o ).

tff(pred_def_81340,type,
    v136428: state_type > $o ).

tff(pred_def_81341,type,
    v136427: state_type > $o ).

tff(pred_def_81342,type,
    v136426: ( state_type * $int ) > $o ).

tff(pred_def_81343,type,
    v85716: state_type > $o ).

tff(pred_def_81344,type,
    v136445: state_type > $o ).

tff(pred_def_81345,type,
    v136443: state_type > $o ).

tff(pred_def_81346,type,
    v136449: state_type > $o ).

tff(pred_def_81347,type,
    v136447: state_type > $o ).

tff(pred_def_81348,type,
    v136459: state_type > $o ).

tff(pred_def_81349,type,
    v136437: ( state_type * $int ) > $o ).

tff(pred_def_81350,type,
    v136467: state_type > $o ).

tff(pred_def_81351,type,
    v136466: state_type > $o ).

tff(pred_def_81352,type,
    v136469: state_type > $o ).

tff(pred_def_81353,type,
    v136468: state_type > $o ).

tff(pred_def_81354,type,
    v136465: state_type > $o ).

tff(pred_def_81355,type,
    v136463: ( state_type * $int ) > $o ).

tff(pred_def_81356,type,
    v136435: state_type > $o ).

tff(pred_def_81357,type,
    v136462: ( state_type * $int ) > $o ).

tff(pred_def_81358,type,
    v136457: ( state_type * $int ) > $o ).

tff(pred_def_81359,type,
    v136455: ( state_type * $int ) > $o ).

tff(pred_def_81360,type,
    v136453: ( state_type * $int ) > $o ).

tff(pred_def_81361,type,
    v136451: ( state_type * $int ) > $o ).

tff(pred_def_81362,type,
    v136473: state_type > $o ).

tff(pred_def_81363,type,
    v136471: state_type > $o ).

tff(pred_def_81364,type,
    v136480: state_type > $o ).

tff(pred_def_81365,type,
    v136478: state_type > $o ).

tff(pred_def_81366,type,
    v136477: state_type > $o ).

tff(pred_def_81367,type,
    v136476: state_type > $o ).

tff(pred_def_81368,type,
    v136488: state_type > $o ).

tff(pred_def_81369,type,
    v136489: state_type > $o ).

tff(pred_def_81370,type,
    v136487: state_type > $o ).

tff(pred_def_81371,type,
    v136484: ( state_type * $int ) > $o ).

tff(pred_def_81372,type,
    v136486: ( state_type * $int ) > $o ).

tff(pred_def_81373,type,
    v136441: ( state_type * $int ) > $o ).

tff(pred_def_81374,type,
    v136439: ( state_type * $int ) > $o ).

tff(pred_def_81375,type,
    v85712: state_type > $o ).

tff(pred_def_81376,type,
    v136507: state_type > $o ).

tff(pred_def_81377,type,
    v136505: state_type > $o ).

tff(pred_def_81378,type,
    v136511: state_type > $o ).

tff(pred_def_81379,type,
    v136509: state_type > $o ).

tff(pred_def_81380,type,
    v136521: state_type > $o ).

tff(pred_def_81381,type,
    v136499: ( state_type * $int ) > $o ).

tff(pred_def_81382,type,
    v136529: state_type > $o ).

tff(pred_def_81383,type,
    v136528: state_type > $o ).

tff(pred_def_81384,type,
    v136531: state_type > $o ).

tff(pred_def_81385,type,
    v136530: state_type > $o ).

tff(pred_def_81386,type,
    v136527: state_type > $o ).

tff(pred_def_81387,type,
    v136525: ( state_type * $int ) > $o ).

tff(pred_def_81388,type,
    v136497: state_type > $o ).

tff(pred_def_81389,type,
    v136524: ( state_type * $int ) > $o ).

tff(pred_def_81390,type,
    v136519: ( state_type * $int ) > $o ).

tff(pred_def_81391,type,
    v136517: ( state_type * $int ) > $o ).

tff(pred_def_81392,type,
    v136515: ( state_type * $int ) > $o ).

tff(pred_def_81393,type,
    v136513: ( state_type * $int ) > $o ).

tff(pred_def_81394,type,
    v136535: state_type > $o ).

tff(pred_def_81395,type,
    v136533: state_type > $o ).

tff(pred_def_81396,type,
    v136542: state_type > $o ).

tff(pred_def_81397,type,
    v136540: state_type > $o ).

tff(pred_def_81398,type,
    v136539: state_type > $o ).

tff(pred_def_81399,type,
    v136538: state_type > $o ).

tff(pred_def_81400,type,
    v136550: state_type > $o ).

tff(pred_def_81401,type,
    v136551: state_type > $o ).

tff(pred_def_81402,type,
    v136549: state_type > $o ).

tff(pred_def_81403,type,
    v136546: ( state_type * $int ) > $o ).

tff(pred_def_81404,type,
    v136548: ( state_type * $int ) > $o ).

tff(pred_def_81405,type,
    v136503: ( state_type * $int ) > $o ).

tff(pred_def_81406,type,
    v136501: ( state_type * $int ) > $o ).

tff(pred_def_81407,type,
    v136495: state_type > $o ).

tff(pred_def_81408,type,
    v136569: state_type > $o ).

tff(pred_def_81409,type,
    v136567: state_type > $o ).

tff(pred_def_81410,type,
    v136573: state_type > $o ).

tff(pred_def_81411,type,
    v136571: state_type > $o ).

tff(pred_def_81412,type,
    v136583: state_type > $o ).

tff(pred_def_81413,type,
    v136561: ( state_type * $int ) > $o ).

tff(pred_def_81414,type,
    v136591: state_type > $o ).

tff(pred_def_81415,type,
    v136590: state_type > $o ).

tff(pred_def_81416,type,
    v136593: state_type > $o ).

tff(pred_def_81417,type,
    v136592: state_type > $o ).

tff(pred_def_81418,type,
    v136589: state_type > $o ).

tff(pred_def_81419,type,
    v136587: ( state_type * $int ) > $o ).

tff(pred_def_81420,type,
    v136559: state_type > $o ).

tff(pred_def_81421,type,
    v136586: ( state_type * $int ) > $o ).

tff(pred_def_81422,type,
    v136581: ( state_type * $int ) > $o ).

tff(pred_def_81423,type,
    v136579: ( state_type * $int ) > $o ).

tff(pred_def_81424,type,
    v136577: ( state_type * $int ) > $o ).

tff(pred_def_81425,type,
    v136575: ( state_type * $int ) > $o ).

tff(pred_def_81426,type,
    v136597: state_type > $o ).

tff(pred_def_81427,type,
    v136595: state_type > $o ).

tff(pred_def_81428,type,
    v136604: state_type > $o ).

tff(pred_def_81429,type,
    v136602: state_type > $o ).

tff(pred_def_81430,type,
    v136601: state_type > $o ).

tff(pred_def_81431,type,
    v136600: state_type > $o ).

tff(pred_def_81432,type,
    v136612: state_type > $o ).

tff(pred_def_81433,type,
    v136613: state_type > $o ).

tff(pred_def_81434,type,
    v136611: state_type > $o ).

tff(pred_def_81435,type,
    v136608: ( state_type * $int ) > $o ).

tff(pred_def_81436,type,
    v136610: ( state_type * $int ) > $o ).

tff(pred_def_81437,type,
    v136565: ( state_type * $int ) > $o ).

tff(pred_def_81438,type,
    v136563: ( state_type * $int ) > $o ).

tff(pred_def_81439,type,
    v136557: state_type > $o ).

tff(pred_def_81440,type,
    v136631: state_type > $o ).

tff(pred_def_81441,type,
    v136629: state_type > $o ).

tff(pred_def_81442,type,
    v136635: state_type > $o ).

tff(pred_def_81443,type,
    v136633: state_type > $o ).

tff(pred_def_81444,type,
    v136645: state_type > $o ).

tff(pred_def_81445,type,
    v136623: ( state_type * $int ) > $o ).

tff(pred_def_81446,type,
    v136653: state_type > $o ).

tff(pred_def_81447,type,
    v136652: state_type > $o ).

tff(pred_def_81448,type,
    v136655: state_type > $o ).

tff(pred_def_81449,type,
    v136654: state_type > $o ).

tff(pred_def_81450,type,
    v136651: state_type > $o ).

tff(pred_def_81451,type,
    v136649: ( state_type * $int ) > $o ).

tff(pred_def_81452,type,
    v136621: state_type > $o ).

tff(pred_def_81453,type,
    v136648: ( state_type * $int ) > $o ).

tff(pred_def_81454,type,
    v136643: ( state_type * $int ) > $o ).

tff(pred_def_81455,type,
    v136641: ( state_type * $int ) > $o ).

tff(pred_def_81456,type,
    v136639: ( state_type * $int ) > $o ).

tff(pred_def_81457,type,
    v136637: ( state_type * $int ) > $o ).

tff(pred_def_81458,type,
    v136659: state_type > $o ).

tff(pred_def_81459,type,
    v136657: state_type > $o ).

tff(pred_def_81460,type,
    v136666: state_type > $o ).

tff(pred_def_81461,type,
    v136664: state_type > $o ).

tff(pred_def_81462,type,
    v136663: state_type > $o ).

tff(pred_def_81463,type,
    v136662: state_type > $o ).

tff(pred_def_81464,type,
    v136674: state_type > $o ).

tff(pred_def_81465,type,
    v136675: state_type > $o ).

tff(pred_def_81466,type,
    v136673: state_type > $o ).

tff(pred_def_81467,type,
    v136670: ( state_type * $int ) > $o ).

tff(pred_def_81468,type,
    v136672: ( state_type * $int ) > $o ).

tff(pred_def_81469,type,
    v136627: ( state_type * $int ) > $o ).

tff(pred_def_81470,type,
    v136625: ( state_type * $int ) > $o ).

tff(pred_def_81471,type,
    v136619: state_type > $o ).

tff(pred_def_81472,type,
    v136693: state_type > $o ).

tff(pred_def_81473,type,
    v136691: state_type > $o ).

tff(pred_def_81474,type,
    v136697: state_type > $o ).

tff(pred_def_81475,type,
    v136695: state_type > $o ).

tff(pred_def_81476,type,
    v136707: state_type > $o ).

tff(pred_def_81477,type,
    v136685: ( state_type * $int ) > $o ).

tff(pred_def_81478,type,
    v136715: state_type > $o ).

tff(pred_def_81479,type,
    v136714: state_type > $o ).

tff(pred_def_81480,type,
    v136717: state_type > $o ).

tff(pred_def_81481,type,
    v136716: state_type > $o ).

tff(pred_def_81482,type,
    v136713: state_type > $o ).

tff(pred_def_81483,type,
    v136711: ( state_type * $int ) > $o ).

tff(pred_def_81484,type,
    v136683: state_type > $o ).

tff(pred_def_81485,type,
    v136710: ( state_type * $int ) > $o ).

tff(pred_def_81486,type,
    v136705: ( state_type * $int ) > $o ).

tff(pred_def_81487,type,
    v136703: ( state_type * $int ) > $o ).

tff(pred_def_81488,type,
    v136701: ( state_type * $int ) > $o ).

tff(pred_def_81489,type,
    v136699: ( state_type * $int ) > $o ).

tff(pred_def_81490,type,
    v136721: state_type > $o ).

tff(pred_def_81491,type,
    v136719: state_type > $o ).

tff(pred_def_81492,type,
    v136728: state_type > $o ).

tff(pred_def_81493,type,
    v136726: state_type > $o ).

tff(pred_def_81494,type,
    v136725: state_type > $o ).

tff(pred_def_81495,type,
    v136724: state_type > $o ).

tff(pred_def_81496,type,
    v136736: state_type > $o ).

tff(pred_def_81497,type,
    v136737: state_type > $o ).

tff(pred_def_81498,type,
    v136735: state_type > $o ).

tff(pred_def_81499,type,
    v136732: ( state_type * $int ) > $o ).

tff(pred_def_81500,type,
    v136734: ( state_type * $int ) > $o ).

tff(pred_def_81501,type,
    v136689: ( state_type * $int ) > $o ).

tff(pred_def_81502,type,
    v136687: ( state_type * $int ) > $o ).

tff(pred_def_81503,type,
    v136681: state_type > $o ).

tff(pred_def_81504,type,
    v136755: state_type > $o ).

tff(pred_def_81505,type,
    v136753: state_type > $o ).

tff(pred_def_81506,type,
    v136759: state_type > $o ).

tff(pred_def_81507,type,
    v136757: state_type > $o ).

tff(pred_def_81508,type,
    v136769: state_type > $o ).

tff(pred_def_81509,type,
    v136747: ( state_type * $int ) > $o ).

tff(pred_def_81510,type,
    v136777: state_type > $o ).

tff(pred_def_81511,type,
    v136776: state_type > $o ).

tff(pred_def_81512,type,
    v136779: state_type > $o ).

tff(pred_def_81513,type,
    v136778: state_type > $o ).

tff(pred_def_81514,type,
    v136775: state_type > $o ).

tff(pred_def_81515,type,
    v136773: ( state_type * $int ) > $o ).

tff(pred_def_81516,type,
    v136745: state_type > $o ).

tff(pred_def_81517,type,
    v136772: ( state_type * $int ) > $o ).

tff(pred_def_81518,type,
    v136767: ( state_type * $int ) > $o ).

tff(pred_def_81519,type,
    v136765: ( state_type * $int ) > $o ).

tff(pred_def_81520,type,
    v136763: ( state_type * $int ) > $o ).

tff(pred_def_81521,type,
    v136761: ( state_type * $int ) > $o ).

tff(pred_def_81522,type,
    v136783: state_type > $o ).

tff(pred_def_81523,type,
    v136781: state_type > $o ).

tff(pred_def_81524,type,
    v136790: state_type > $o ).

tff(pred_def_81525,type,
    v136788: state_type > $o ).

tff(pred_def_81526,type,
    v136787: state_type > $o ).

tff(pred_def_81527,type,
    v136786: state_type > $o ).

tff(pred_def_81528,type,
    v136798: state_type > $o ).

tff(pred_def_81529,type,
    v136799: state_type > $o ).

tff(pred_def_81530,type,
    v136797: state_type > $o ).

tff(pred_def_81531,type,
    v136794: ( state_type * $int ) > $o ).

tff(pred_def_81532,type,
    v136796: ( state_type * $int ) > $o ).

tff(pred_def_81533,type,
    v136751: ( state_type * $int ) > $o ).

tff(pred_def_81534,type,
    v136749: ( state_type * $int ) > $o ).

tff(pred_def_81535,type,
    v136743: state_type > $o ).

tff(pred_def_81536,type,
    v136817: state_type > $o ).

tff(pred_def_81537,type,
    v136815: state_type > $o ).

tff(pred_def_81538,type,
    v136821: state_type > $o ).

tff(pred_def_81539,type,
    v136819: state_type > $o ).

tff(pred_def_81540,type,
    v136831: state_type > $o ).

tff(pred_def_81541,type,
    v136809: ( state_type * $int ) > $o ).

tff(pred_def_81542,type,
    v136839: state_type > $o ).

tff(pred_def_81543,type,
    v136838: state_type > $o ).

tff(pred_def_81544,type,
    v136841: state_type > $o ).

tff(pred_def_81545,type,
    v136840: state_type > $o ).

tff(pred_def_81546,type,
    v136837: state_type > $o ).

tff(pred_def_81547,type,
    v136835: ( state_type * $int ) > $o ).

tff(pred_def_81548,type,
    v136807: state_type > $o ).

tff(pred_def_81549,type,
    v136834: ( state_type * $int ) > $o ).

tff(pred_def_81550,type,
    v136829: ( state_type * $int ) > $o ).

tff(pred_def_81551,type,
    v136827: ( state_type * $int ) > $o ).

tff(pred_def_81552,type,
    v136825: ( state_type * $int ) > $o ).

tff(pred_def_81553,type,
    v136823: ( state_type * $int ) > $o ).

tff(pred_def_81554,type,
    v136845: state_type > $o ).

tff(pred_def_81555,type,
    v136843: state_type > $o ).

tff(pred_def_81556,type,
    v136852: state_type > $o ).

tff(pred_def_81557,type,
    v136850: state_type > $o ).

tff(pred_def_81558,type,
    v136849: state_type > $o ).

tff(pred_def_81559,type,
    v136848: state_type > $o ).

tff(pred_def_81560,type,
    v136860: state_type > $o ).

tff(pred_def_81561,type,
    v136861: state_type > $o ).

tff(pred_def_81562,type,
    v136859: state_type > $o ).

tff(pred_def_81563,type,
    v136856: ( state_type * $int ) > $o ).

tff(pred_def_81564,type,
    v136858: ( state_type * $int ) > $o ).

tff(pred_def_81565,type,
    v136813: ( state_type * $int ) > $o ).

tff(pred_def_81566,type,
    v136811: ( state_type * $int ) > $o ).

tff(pred_def_81567,type,
    v136805: state_type > $o ).

tff(pred_def_81568,type,
    v136879: state_type > $o ).

tff(pred_def_81569,type,
    v136877: state_type > $o ).

tff(pred_def_81570,type,
    v136883: state_type > $o ).

tff(pred_def_81571,type,
    v136881: state_type > $o ).

tff(pred_def_81572,type,
    v136893: state_type > $o ).

tff(pred_def_81573,type,
    v136871: ( state_type * $int ) > $o ).

tff(pred_def_81574,type,
    v136901: state_type > $o ).

tff(pred_def_81575,type,
    v136900: state_type > $o ).

tff(pred_def_81576,type,
    v136903: state_type > $o ).

tff(pred_def_81577,type,
    v136902: state_type > $o ).

tff(pred_def_81578,type,
    v136899: state_type > $o ).

tff(pred_def_81579,type,
    v136897: ( state_type * $int ) > $o ).

tff(pred_def_81580,type,
    v136869: state_type > $o ).

tff(pred_def_81581,type,
    v136896: ( state_type * $int ) > $o ).

tff(pred_def_81582,type,
    v136891: ( state_type * $int ) > $o ).

tff(pred_def_81583,type,
    v136889: ( state_type * $int ) > $o ).

tff(pred_def_81584,type,
    v136887: ( state_type * $int ) > $o ).

tff(pred_def_81585,type,
    v136885: ( state_type * $int ) > $o ).

tff(pred_def_81586,type,
    v136907: state_type > $o ).

tff(pred_def_81587,type,
    v136905: state_type > $o ).

tff(pred_def_81588,type,
    v136914: state_type > $o ).

tff(pred_def_81589,type,
    v136912: state_type > $o ).

tff(pred_def_81590,type,
    v136911: state_type > $o ).

tff(pred_def_81591,type,
    v136910: state_type > $o ).

tff(pred_def_81592,type,
    v136922: state_type > $o ).

tff(pred_def_81593,type,
    v136923: state_type > $o ).

tff(pred_def_81594,type,
    v136921: state_type > $o ).

tff(pred_def_81595,type,
    v136918: ( state_type * $int ) > $o ).

tff(pred_def_81596,type,
    v136920: ( state_type * $int ) > $o ).

tff(pred_def_81597,type,
    v136875: ( state_type * $int ) > $o ).

tff(pred_def_81598,type,
    v136873: ( state_type * $int ) > $o ).

tff(pred_def_81599,type,
    v136867: state_type > $o ).

tff(pred_def_81600,type,
    v136941: state_type > $o ).

tff(pred_def_81601,type,
    v136939: state_type > $o ).

tff(pred_def_81602,type,
    v136945: state_type > $o ).

tff(pred_def_81603,type,
    v136943: state_type > $o ).

tff(pred_def_81604,type,
    v136955: state_type > $o ).

tff(pred_def_81605,type,
    v136933: ( state_type * $int ) > $o ).

tff(pred_def_81606,type,
    v136963: state_type > $o ).

tff(pred_def_81607,type,
    v136962: state_type > $o ).

tff(pred_def_81608,type,
    v136965: state_type > $o ).

tff(pred_def_81609,type,
    v136964: state_type > $o ).

tff(pred_def_81610,type,
    v136961: state_type > $o ).

tff(pred_def_81611,type,
    v136959: ( state_type * $int ) > $o ).

tff(pred_def_81612,type,
    v136931: state_type > $o ).

tff(pred_def_81613,type,
    v136958: ( state_type * $int ) > $o ).

tff(pred_def_81614,type,
    v136953: ( state_type * $int ) > $o ).

tff(pred_def_81615,type,
    v136951: ( state_type * $int ) > $o ).

tff(pred_def_81616,type,
    v136949: ( state_type * $int ) > $o ).

tff(pred_def_81617,type,
    v136947: ( state_type * $int ) > $o ).

tff(pred_def_81618,type,
    v136969: state_type > $o ).

tff(pred_def_81619,type,
    v136967: state_type > $o ).

tff(pred_def_81620,type,
    v136976: state_type > $o ).

tff(pred_def_81621,type,
    v136974: state_type > $o ).

tff(pred_def_81622,type,
    v136973: state_type > $o ).

tff(pred_def_81623,type,
    v136972: state_type > $o ).

tff(pred_def_81624,type,
    v136984: state_type > $o ).

tff(pred_def_81625,type,
    v136985: state_type > $o ).

tff(pred_def_81626,type,
    v136983: state_type > $o ).

tff(pred_def_81627,type,
    v136980: ( state_type * $int ) > $o ).

tff(pred_def_81628,type,
    v136982: ( state_type * $int ) > $o ).

tff(pred_def_81629,type,
    v136937: ( state_type * $int ) > $o ).

tff(pred_def_81630,type,
    v136935: ( state_type * $int ) > $o ).

tff(pred_def_81631,type,
    v136929: state_type > $o ).

tff(pred_def_81632,type,
    v137003: state_type > $o ).

tff(pred_def_81633,type,
    v137001: state_type > $o ).

tff(pred_def_81634,type,
    v137007: state_type > $o ).

tff(pred_def_81635,type,
    v137005: state_type > $o ).

tff(pred_def_81636,type,
    v137017: state_type > $o ).

tff(pred_def_81637,type,
    v136995: ( state_type * $int ) > $o ).

tff(pred_def_81638,type,
    v137025: state_type > $o ).

tff(pred_def_81639,type,
    v137024: state_type > $o ).

tff(pred_def_81640,type,
    v137027: state_type > $o ).

tff(pred_def_81641,type,
    v137026: state_type > $o ).

tff(pred_def_81642,type,
    v137023: state_type > $o ).

tff(pred_def_81643,type,
    v137021: ( state_type * $int ) > $o ).

tff(pred_def_81644,type,
    v136993: state_type > $o ).

tff(pred_def_81645,type,
    v137020: ( state_type * $int ) > $o ).

tff(pred_def_81646,type,
    v137015: ( state_type * $int ) > $o ).

tff(pred_def_81647,type,
    v137013: ( state_type * $int ) > $o ).

tff(pred_def_81648,type,
    v137011: ( state_type * $int ) > $o ).

tff(pred_def_81649,type,
    v137009: ( state_type * $int ) > $o ).

tff(pred_def_81650,type,
    v137031: state_type > $o ).

tff(pred_def_81651,type,
    v137029: state_type > $o ).

tff(pred_def_81652,type,
    v137038: state_type > $o ).

tff(pred_def_81653,type,
    v137036: state_type > $o ).

tff(pred_def_81654,type,
    v137035: state_type > $o ).

tff(pred_def_81655,type,
    v137034: state_type > $o ).

tff(pred_def_81656,type,
    v137046: state_type > $o ).

tff(pred_def_81657,type,
    v137047: state_type > $o ).

tff(pred_def_81658,type,
    v137045: state_type > $o ).

tff(pred_def_81659,type,
    v137042: ( state_type * $int ) > $o ).

tff(pred_def_81660,type,
    v137044: ( state_type * $int ) > $o ).

tff(pred_def_81661,type,
    v136999: ( state_type * $int ) > $o ).

tff(pred_def_81662,type,
    v136997: ( state_type * $int ) > $o ).

tff(pred_def_81663,type,
    v136991: state_type > $o ).

tff(pred_def_81664,type,
    v137065: state_type > $o ).

tff(pred_def_81665,type,
    v137063: state_type > $o ).

tff(pred_def_81666,type,
    v137069: state_type > $o ).

tff(pred_def_81667,type,
    v137067: state_type > $o ).

tff(pred_def_81668,type,
    v137079: state_type > $o ).

tff(pred_def_81669,type,
    v137057: ( state_type * $int ) > $o ).

tff(pred_def_81670,type,
    v137087: state_type > $o ).

tff(pred_def_81671,type,
    v137086: state_type > $o ).

tff(pred_def_81672,type,
    v137089: state_type > $o ).

tff(pred_def_81673,type,
    v137088: state_type > $o ).

tff(pred_def_81674,type,
    v137085: state_type > $o ).

tff(pred_def_81675,type,
    v137083: ( state_type * $int ) > $o ).

tff(pred_def_81676,type,
    v137055: state_type > $o ).

tff(pred_def_81677,type,
    v137082: ( state_type * $int ) > $o ).

tff(pred_def_81678,type,
    v137077: ( state_type * $int ) > $o ).

tff(pred_def_81679,type,
    v137075: ( state_type * $int ) > $o ).

tff(pred_def_81680,type,
    v137073: ( state_type * $int ) > $o ).

tff(pred_def_81681,type,
    v137071: ( state_type * $int ) > $o ).

tff(pred_def_81682,type,
    v137093: state_type > $o ).

tff(pred_def_81683,type,
    v137091: state_type > $o ).

tff(pred_def_81684,type,
    v137100: state_type > $o ).

tff(pred_def_81685,type,
    v137098: state_type > $o ).

tff(pred_def_81686,type,
    v137097: state_type > $o ).

tff(pred_def_81687,type,
    v137096: state_type > $o ).

tff(pred_def_81688,type,
    v137108: state_type > $o ).

tff(pred_def_81689,type,
    v137109: state_type > $o ).

tff(pred_def_81690,type,
    v137107: state_type > $o ).

tff(pred_def_81691,type,
    v137104: ( state_type * $int ) > $o ).

tff(pred_def_81692,type,
    v137106: ( state_type * $int ) > $o ).

tff(pred_def_81693,type,
    v137061: ( state_type * $int ) > $o ).

tff(pred_def_81694,type,
    v137059: ( state_type * $int ) > $o ).

tff(pred_def_81695,type,
    v137053: state_type > $o ).

tff(pred_def_81696,type,
    v137127: state_type > $o ).

tff(pred_def_81697,type,
    v137125: state_type > $o ).

tff(pred_def_81698,type,
    v137131: state_type > $o ).

tff(pred_def_81699,type,
    v137129: state_type > $o ).

tff(pred_def_81700,type,
    v137141: state_type > $o ).

tff(pred_def_81701,type,
    v137119: ( state_type * $int ) > $o ).

tff(pred_def_81702,type,
    v137149: state_type > $o ).

tff(pred_def_81703,type,
    v137148: state_type > $o ).

tff(pred_def_81704,type,
    v137151: state_type > $o ).

tff(pred_def_81705,type,
    v137150: state_type > $o ).

tff(pred_def_81706,type,
    v137147: state_type > $o ).

tff(pred_def_81707,type,
    v137145: ( state_type * $int ) > $o ).

tff(pred_def_81708,type,
    v137117: state_type > $o ).

tff(pred_def_81709,type,
    v137144: ( state_type * $int ) > $o ).

tff(pred_def_81710,type,
    v137139: ( state_type * $int ) > $o ).

tff(pred_def_81711,type,
    v137137: ( state_type * $int ) > $o ).

tff(pred_def_81712,type,
    v137135: ( state_type * $int ) > $o ).

tff(pred_def_81713,type,
    v137133: ( state_type * $int ) > $o ).

tff(pred_def_81714,type,
    v137155: state_type > $o ).

tff(pred_def_81715,type,
    v137153: state_type > $o ).

tff(pred_def_81716,type,
    v137162: state_type > $o ).

tff(pred_def_81717,type,
    v137160: state_type > $o ).

tff(pred_def_81718,type,
    v137159: state_type > $o ).

tff(pred_def_81719,type,
    v137158: state_type > $o ).

tff(pred_def_81720,type,
    v137170: state_type > $o ).

tff(pred_def_81721,type,
    v137171: state_type > $o ).

tff(pred_def_81722,type,
    v137169: state_type > $o ).

tff(pred_def_81723,type,
    v137166: ( state_type * $int ) > $o ).

tff(pred_def_81724,type,
    v137168: ( state_type * $int ) > $o ).

tff(pred_def_81725,type,
    v137123: ( state_type * $int ) > $o ).

tff(pred_def_81726,type,
    v137121: ( state_type * $int ) > $o ).

tff(pred_def_81727,type,
    v137115: state_type > $o ).

tff(pred_def_81728,type,
    v137189: state_type > $o ).

tff(pred_def_81729,type,
    v137187: state_type > $o ).

tff(pred_def_81730,type,
    v137193: state_type > $o ).

tff(pred_def_81731,type,
    v137191: state_type > $o ).

tff(pred_def_81732,type,
    v137203: state_type > $o ).

tff(pred_def_81733,type,
    v137181: ( state_type * $int ) > $o ).

tff(pred_def_81734,type,
    v137211: state_type > $o ).

tff(pred_def_81735,type,
    v137210: state_type > $o ).

tff(pred_def_81736,type,
    v137213: state_type > $o ).

tff(pred_def_81737,type,
    v137212: state_type > $o ).

tff(pred_def_81738,type,
    v137209: state_type > $o ).

tff(pred_def_81739,type,
    v137207: ( state_type * $int ) > $o ).

tff(pred_def_81740,type,
    v137179: state_type > $o ).

tff(pred_def_81741,type,
    v137206: ( state_type * $int ) > $o ).

tff(pred_def_81742,type,
    v137201: ( state_type * $int ) > $o ).

tff(pred_def_81743,type,
    v137199: ( state_type * $int ) > $o ).

tff(pred_def_81744,type,
    v137197: ( state_type * $int ) > $o ).

tff(pred_def_81745,type,
    v137195: ( state_type * $int ) > $o ).

tff(pred_def_81746,type,
    v137217: state_type > $o ).

tff(pred_def_81747,type,
    v137215: state_type > $o ).

tff(pred_def_81748,type,
    v137224: state_type > $o ).

tff(pred_def_81749,type,
    v137222: state_type > $o ).

tff(pred_def_81750,type,
    v137221: state_type > $o ).

tff(pred_def_81751,type,
    v137220: state_type > $o ).

tff(pred_def_81752,type,
    v137232: state_type > $o ).

tff(pred_def_81753,type,
    v137233: state_type > $o ).

tff(pred_def_81754,type,
    v137231: state_type > $o ).

tff(pred_def_81755,type,
    v137228: ( state_type * $int ) > $o ).

tff(pred_def_81756,type,
    v137230: ( state_type * $int ) > $o ).

tff(pred_def_81757,type,
    v137185: ( state_type * $int ) > $o ).

tff(pred_def_81758,type,
    v137183: ( state_type * $int ) > $o ).

tff(pred_def_81759,type,
    v137177: state_type > $o ).

tff(pred_def_81760,type,
    v137251: state_type > $o ).

tff(pred_def_81761,type,
    v137249: state_type > $o ).

tff(pred_def_81762,type,
    v137255: state_type > $o ).

tff(pred_def_81763,type,
    v137253: state_type > $o ).

tff(pred_def_81764,type,
    v137265: state_type > $o ).

tff(pred_def_81765,type,
    v137243: ( state_type * $int ) > $o ).

tff(pred_def_81766,type,
    v137273: state_type > $o ).

tff(pred_def_81767,type,
    v137272: state_type > $o ).

tff(pred_def_81768,type,
    v137275: state_type > $o ).

tff(pred_def_81769,type,
    v137274: state_type > $o ).

tff(pred_def_81770,type,
    v137271: state_type > $o ).

tff(pred_def_81771,type,
    v137269: ( state_type * $int ) > $o ).

tff(pred_def_81772,type,
    v137241: state_type > $o ).

tff(pred_def_81773,type,
    v137268: ( state_type * $int ) > $o ).

tff(pred_def_81774,type,
    v137263: ( state_type * $int ) > $o ).

tff(pred_def_81775,type,
    v137261: ( state_type * $int ) > $o ).

tff(pred_def_81776,type,
    v137259: ( state_type * $int ) > $o ).

tff(pred_def_81777,type,
    v137257: ( state_type * $int ) > $o ).

tff(pred_def_81778,type,
    v137279: state_type > $o ).

tff(pred_def_81779,type,
    v137277: state_type > $o ).

tff(pred_def_81780,type,
    v137286: state_type > $o ).

tff(pred_def_81781,type,
    v137284: state_type > $o ).

tff(pred_def_81782,type,
    v137283: state_type > $o ).

tff(pred_def_81783,type,
    v137282: state_type > $o ).

tff(pred_def_81784,type,
    v137294: state_type > $o ).

tff(pred_def_81785,type,
    v137295: state_type > $o ).

tff(pred_def_81786,type,
    v137293: state_type > $o ).

tff(pred_def_81787,type,
    v137290: ( state_type * $int ) > $o ).

tff(pred_def_81788,type,
    v137292: ( state_type * $int ) > $o ).

tff(pred_def_81789,type,
    v137247: ( state_type * $int ) > $o ).

tff(pred_def_81790,type,
    v137245: ( state_type * $int ) > $o ).

tff(pred_def_81791,type,
    v137239: state_type > $o ).

tff(pred_def_81792,type,
    v137313: state_type > $o ).

tff(pred_def_81793,type,
    v137311: state_type > $o ).

tff(pred_def_81794,type,
    v137317: state_type > $o ).

tff(pred_def_81795,type,
    v137315: state_type > $o ).

tff(pred_def_81796,type,
    v137327: state_type > $o ).

tff(pred_def_81797,type,
    v137305: ( state_type * $int ) > $o ).

tff(pred_def_81798,type,
    v137335: state_type > $o ).

tff(pred_def_81799,type,
    v137334: state_type > $o ).

tff(pred_def_81800,type,
    v137337: state_type > $o ).

tff(pred_def_81801,type,
    v137336: state_type > $o ).

tff(pred_def_81802,type,
    v137333: state_type > $o ).

tff(pred_def_81803,type,
    v137331: ( state_type * $int ) > $o ).

tff(pred_def_81804,type,
    v137303: state_type > $o ).

tff(pred_def_81805,type,
    v137330: ( state_type * $int ) > $o ).

tff(pred_def_81806,type,
    v137325: ( state_type * $int ) > $o ).

tff(pred_def_81807,type,
    v137323: ( state_type * $int ) > $o ).

tff(pred_def_81808,type,
    v137321: ( state_type * $int ) > $o ).

tff(pred_def_81809,type,
    v137319: ( state_type * $int ) > $o ).

tff(pred_def_81810,type,
    v137341: state_type > $o ).

tff(pred_def_81811,type,
    v137339: state_type > $o ).

tff(pred_def_81812,type,
    v137348: state_type > $o ).

tff(pred_def_81813,type,
    v137346: state_type > $o ).

tff(pred_def_81814,type,
    v137345: state_type > $o ).

tff(pred_def_81815,type,
    v137344: state_type > $o ).

tff(pred_def_81816,type,
    v137356: state_type > $o ).

tff(pred_def_81817,type,
    v137357: state_type > $o ).

tff(pred_def_81818,type,
    v137355: state_type > $o ).

tff(pred_def_81819,type,
    v137352: ( state_type * $int ) > $o ).

tff(pred_def_81820,type,
    v137354: ( state_type * $int ) > $o ).

tff(pred_def_81821,type,
    v137309: ( state_type * $int ) > $o ).

tff(pred_def_81822,type,
    v137307: ( state_type * $int ) > $o ).

tff(pred_def_81823,type,
    v137301: state_type > $o ).

tff(pred_def_81824,type,
    v137375: state_type > $o ).

tff(pred_def_81825,type,
    v137373: state_type > $o ).

tff(pred_def_81826,type,
    v137379: state_type > $o ).

tff(pred_def_81827,type,
    v137377: state_type > $o ).

tff(pred_def_81828,type,
    v137389: state_type > $o ).

tff(pred_def_81829,type,
    v137367: ( state_type * $int ) > $o ).

tff(pred_def_81830,type,
    v137397: state_type > $o ).

tff(pred_def_81831,type,
    v137396: state_type > $o ).

tff(pred_def_81832,type,
    v137399: state_type > $o ).

tff(pred_def_81833,type,
    v137398: state_type > $o ).

tff(pred_def_81834,type,
    v137395: state_type > $o ).

tff(pred_def_81835,type,
    v137393: ( state_type * $int ) > $o ).

tff(pred_def_81836,type,
    v137365: state_type > $o ).

tff(pred_def_81837,type,
    v137392: ( state_type * $int ) > $o ).

tff(pred_def_81838,type,
    v137387: ( state_type * $int ) > $o ).

tff(pred_def_81839,type,
    v137385: ( state_type * $int ) > $o ).

tff(pred_def_81840,type,
    v137383: ( state_type * $int ) > $o ).

tff(pred_def_81841,type,
    v137381: ( state_type * $int ) > $o ).

tff(pred_def_81842,type,
    v137403: state_type > $o ).

tff(pred_def_81843,type,
    v137401: state_type > $o ).

tff(pred_def_81844,type,
    v137410: state_type > $o ).

tff(pred_def_81845,type,
    v137408: state_type > $o ).

tff(pred_def_81846,type,
    v137407: state_type > $o ).

tff(pred_def_81847,type,
    v137406: state_type > $o ).

tff(pred_def_81848,type,
    v137418: state_type > $o ).

tff(pred_def_81849,type,
    v137419: state_type > $o ).

tff(pred_def_81850,type,
    v137417: state_type > $o ).

tff(pred_def_81851,type,
    v137414: ( state_type * $int ) > $o ).

tff(pred_def_81852,type,
    v137416: ( state_type * $int ) > $o ).

tff(pred_def_81853,type,
    v137371: ( state_type * $int ) > $o ).

tff(pred_def_81854,type,
    v137369: ( state_type * $int ) > $o ).

tff(pred_def_81855,type,
    v137363: state_type > $o ).

tff(pred_def_81856,type,
    v85710: ( state_type * $int ) > $o ).

tff(pred_def_81857,type,
    v137427: ( state_type * $int ) > $o ).

tff(pred_def_81858,type,
    v137428: ( state_type * $int ) > $o ).

tff(pred_def_81859,type,
    v137426: ( state_type * $int ) > $o ).

tff(pred_def_81860,type,
    v137425: ( state_type * $int ) > $o ).

tff(pred_def_81861,type,
    v137430: ( state_type * $int ) > $o ).

tff(pred_def_81862,type,
    v137431: ( state_type * $int ) > $o ).

tff(pred_def_81863,type,
    v137429: ( state_type * $int ) > $o ).

tff(pred_def_81864,type,
    v85704: ( state_type * $int ) > $o ).

tff(pred_def_81865,type,
    v137435: ( state_type * $int ) > $o ).

tff(pred_def_81866,type,
    v137433: ( state_type * $int ) > $o ).

tff(pred_def_81867,type,
    v137437: ( state_type * $int ) > $o ).

tff(pred_def_81868,type,
    v85702: ( state_type * $int ) > $o ).

tff(pred_def_81869,type,
    v137454: ( state_type * $int ) > $o ).

tff(pred_def_81870,type,
    v137453: state_type > $o ).

tff(pred_def_81871,type,
    v137452: state_type > $o ).

tff(pred_def_81872,type,
    v137451: state_type > $o ).

tff(pred_def_81873,type,
    v137450: state_type > $o ).

tff(pred_def_81874,type,
    v137449: state_type > $o ).

tff(pred_def_81875,type,
    v137448: state_type > $o ).

tff(pred_def_81876,type,
    v137447: state_type > $o ).

tff(pred_def_81877,type,
    v137446: state_type > $o ).

tff(pred_def_81878,type,
    v137445: state_type > $o ).

tff(pred_def_81879,type,
    v137444: state_type > $o ).

tff(pred_def_81880,type,
    v137443: state_type > $o ).

tff(pred_def_81881,type,
    v137442: state_type > $o ).

tff(pred_def_81882,type,
    v137441: state_type > $o ).

tff(pred_def_81883,type,
    v137440: state_type > $o ).

tff(pred_def_81884,type,
    v85124: state_type > $o ).

tff(pred_def_81885,type,
    v137456: ( state_type * $int ) > $o ).

tff(pred_def_81886,type,
    v137458: state_type > $o ).

tff(pred_def_81887,type,
    v137460: state_type > $o ).

tff(pred_def_81888,type,
    v137462: state_type > $o ).

tff(pred_def_81889,type,
    v137464: state_type > $o ).

tff(pred_def_81890,type,
    v137469: state_type > $o ).

tff(pred_def_81891,type,
    v137468: state_type > $o ).

tff(pred_def_81892,type,
    v137467: ( state_type * $int ) > $o ).

tff(pred_def_81893,type,
    v137466: ( state_type * $int ) > $o ).

tff(pred_def_81894,type,
    v137483: state_type > $o ).

tff(pred_def_81895,type,
    v137484: state_type > $o ).

tff(pred_def_81896,type,
    v137482: state_type > $o ).

tff(pred_def_81897,type,
    v137485: state_type > $o ).

tff(pred_def_81898,type,
    v137481: state_type > $o ).

tff(pred_def_81899,type,
    v137480: state_type > $o ).

tff(pred_def_81900,type,
    v137489: state_type > $o ).

tff(pred_def_81901,type,
    v137490: state_type > $o ).

tff(pred_def_81902,type,
    v137488: state_type > $o ).

tff(pred_def_81903,type,
    v137491: state_type > $o ).

tff(pred_def_81904,type,
    v137487: state_type > $o ).

tff(pred_def_81905,type,
    v137486: state_type > $o ).

tff(pred_def_81906,type,
    v137479: state_type > $o ).

tff(pred_def_81907,type,
    v137495: state_type > $o ).

tff(pred_def_81908,type,
    v137496: state_type > $o ).

tff(pred_def_81909,type,
    v137494: state_type > $o ).

tff(pred_def_81910,type,
    v137497: state_type > $o ).

tff(pred_def_81911,type,
    v137493: state_type > $o ).

tff(pred_def_81912,type,
    v137492: state_type > $o ).

tff(pred_def_81913,type,
    v137478: state_type > $o ).

tff(pred_def_81914,type,
    v137501: state_type > $o ).

tff(pred_def_81915,type,
    v137502: state_type > $o ).

tff(pred_def_81916,type,
    v137500: state_type > $o ).

tff(pred_def_81917,type,
    v137503: state_type > $o ).

tff(pred_def_81918,type,
    v137499: state_type > $o ).

tff(pred_def_81919,type,
    v137498: state_type > $o ).

tff(pred_def_81920,type,
    v137477: state_type > $o ).

tff(pred_def_81921,type,
    v137475: state_type > $o ).

tff(pred_def_81922,type,
    v137504: state_type > $o ).

tff(pred_def_81923,type,
    v137474: state_type > $o ).

tff(pred_def_81924,type,
    v137505: state_type > $o ).

tff(pred_def_81925,type,
    v137473: state_type > $o ).

tff(pred_def_81926,type,
    v137472: state_type > $o ).

tff(pred_def_81927,type,
    v137471: state_type > $o ).

tff(pred_def_81928,type,
    v137470: ( state_type * $int ) > $o ).

tff(pred_def_81929,type,
    v84913: ( state_type * $int ) > $o ).

tff(pred_def_81930,type,
    v84911: ( state_type * $int ) > $o ).

tff(pred_def_81931,type,
    v84909: ( state_type * $int ) > $o ).

tff(pred_def_81932,type,
    v137517: state_type > $o ).

tff(pred_def_81933,type,
    v137518: state_type > $o ).

tff(pred_def_81934,type,
    v137519: state_type > $o ).

tff(pred_def_81935,type,
    v137520: state_type > $o ).

tff(pred_def_81936,type,
    v137521: state_type > $o ).

tff(pred_def_81937,type,
    v137522: state_type > $o ).

tff(pred_def_81938,type,
    v137523: state_type > $o ).

tff(pred_def_81939,type,
    v137524: state_type > $o ).

tff(pred_def_81940,type,
    v137525: state_type > $o ).

tff(pred_def_81941,type,
    v137526: state_type > $o ).

tff(pred_def_81942,type,
    v137527: state_type > $o ).

tff(pred_def_81943,type,
    v137528: state_type > $o ).

tff(pred_def_81944,type,
    v137529: state_type > $o ).

tff(pred_def_81945,type,
    v137530: state_type > $o ).

tff(pred_def_81946,type,
    v137531: state_type > $o ).

tff(pred_def_81947,type,
    v137532: state_type > $o ).

tff(pred_def_81948,type,
    v137515: ( state_type * $int ) > $o ).

tff(pred_def_81949,type,
    v137549: ( state_type * $int ) > $o ).

tff(pred_def_81950,type,
    v137548: state_type > $o ).

tff(pred_def_81951,type,
    v137547: state_type > $o ).

tff(pred_def_81952,type,
    v137546: state_type > $o ).

tff(pred_def_81953,type,
    v137545: state_type > $o ).

tff(pred_def_81954,type,
    v137544: state_type > $o ).

tff(pred_def_81955,type,
    v137543: state_type > $o ).

tff(pred_def_81956,type,
    v137542: state_type > $o ).

tff(pred_def_81957,type,
    v137541: state_type > $o ).

tff(pred_def_81958,type,
    v137540: state_type > $o ).

tff(pred_def_81959,type,
    v137539: state_type > $o ).

tff(pred_def_81960,type,
    v137538: state_type > $o ).

tff(pred_def_81961,type,
    v137537: state_type > $o ).

tff(pred_def_81962,type,
    v137536: state_type > $o ).

tff(pred_def_81963,type,
    v137535: state_type > $o ).

tff(pred_def_81964,type,
    v137513: state_type > $o ).

tff(pred_def_81965,type,
    v137554: state_type > $o ).

tff(pred_def_81966,type,
    v137553: state_type > $o ).

tff(pred_def_81967,type,
    v137552: ( state_type * $int ) > $o ).

tff(pred_def_81968,type,
    v137551: ( state_type * $int ) > $o ).

tff(pred_def_81969,type,
    v137568: state_type > $o ).

tff(pred_def_81970,type,
    v137567: state_type > $o ).

tff(pred_def_81971,type,
    v137569: state_type > $o ).

tff(pred_def_81972,type,
    v137566: state_type > $o ).

tff(pred_def_81973,type,
    v137565: state_type > $o ).

tff(pred_def_81974,type,
    v137573: state_type > $o ).

tff(pred_def_81975,type,
    v137572: state_type > $o ).

tff(pred_def_81976,type,
    v137574: state_type > $o ).

tff(pred_def_81977,type,
    v137571: state_type > $o ).

tff(pred_def_81978,type,
    v137570: state_type > $o ).

tff(pred_def_81979,type,
    v137564: state_type > $o ).

tff(pred_def_81980,type,
    v137578: state_type > $o ).

tff(pred_def_81981,type,
    v137577: state_type > $o ).

tff(pred_def_81982,type,
    v137579: state_type > $o ).

tff(pred_def_81983,type,
    v137576: state_type > $o ).

tff(pred_def_81984,type,
    v137575: state_type > $o ).

tff(pred_def_81985,type,
    v137563: state_type > $o ).

tff(pred_def_81986,type,
    v137583: state_type > $o ).

tff(pred_def_81987,type,
    v137582: state_type > $o ).

tff(pred_def_81988,type,
    v137584: state_type > $o ).

tff(pred_def_81989,type,
    v137581: state_type > $o ).

tff(pred_def_81990,type,
    v137580: state_type > $o ).

tff(pred_def_81991,type,
    v137562: state_type > $o ).

tff(pred_def_81992,type,
    v137560: state_type > $o ).

tff(pred_def_81993,type,
    v137585: state_type > $o ).

tff(pred_def_81994,type,
    v137559: state_type > $o ).

tff(pred_def_81995,type,
    v137586: state_type > $o ).

tff(pred_def_81996,type,
    v137558: state_type > $o ).

tff(pred_def_81997,type,
    v137557: state_type > $o ).

tff(pred_def_81998,type,
    v137556: state_type > $o ).

tff(pred_def_81999,type,
    v137555: ( state_type * $int ) > $o ).

tff(pred_def_82000,type,
    v137511: ( state_type * $int ) > $o ).

tff(pred_def_82001,type,
    v137509: ( state_type * $int ) > $o ).

tff(pred_def_82002,type,
    v137507: ( state_type * $int ) > $o ).

tff(pred_def_82003,type,
    v137598: state_type > $o ).

tff(pred_def_82004,type,
    v137599: state_type > $o ).

tff(pred_def_82005,type,
    v137600: state_type > $o ).

tff(pred_def_82006,type,
    v137601: state_type > $o ).

tff(pred_def_82007,type,
    v137602: state_type > $o ).

tff(pred_def_82008,type,
    v137603: state_type > $o ).

tff(pred_def_82009,type,
    v137604: state_type > $o ).

tff(pred_def_82010,type,
    v137605: state_type > $o ).

tff(pred_def_82011,type,
    v137606: state_type > $o ).

tff(pred_def_82012,type,
    v137607: state_type > $o ).

tff(pred_def_82013,type,
    v137608: state_type > $o ).

tff(pred_def_82014,type,
    v137609: state_type > $o ).

tff(pred_def_82015,type,
    v137610: state_type > $o ).

tff(pred_def_82016,type,
    v137611: state_type > $o ).

tff(pred_def_82017,type,
    v137612: state_type > $o ).

tff(pred_def_82018,type,
    v137613: state_type > $o ).

tff(pred_def_82019,type,
    v137596: ( state_type * $int ) > $o ).

tff(pred_def_82020,type,
    v137630: ( state_type * $int ) > $o ).

tff(pred_def_82021,type,
    v137629: state_type > $o ).

tff(pred_def_82022,type,
    v137628: state_type > $o ).

tff(pred_def_82023,type,
    v137627: state_type > $o ).

tff(pred_def_82024,type,
    v137626: state_type > $o ).

tff(pred_def_82025,type,
    v137625: state_type > $o ).

tff(pred_def_82026,type,
    v137624: state_type > $o ).

tff(pred_def_82027,type,
    v137623: state_type > $o ).

tff(pred_def_82028,type,
    v137622: state_type > $o ).

tff(pred_def_82029,type,
    v137621: state_type > $o ).

tff(pred_def_82030,type,
    v137620: state_type > $o ).

tff(pred_def_82031,type,
    v137619: state_type > $o ).

tff(pred_def_82032,type,
    v137618: state_type > $o ).

tff(pred_def_82033,type,
    v137617: state_type > $o ).

tff(pred_def_82034,type,
    v137616: state_type > $o ).

tff(pred_def_82035,type,
    v137594: state_type > $o ).

tff(pred_def_82036,type,
    v137635: state_type > $o ).

tff(pred_def_82037,type,
    v137634: state_type > $o ).

tff(pred_def_82038,type,
    v137633: ( state_type * $int ) > $o ).

tff(pred_def_82039,type,
    v137632: ( state_type * $int ) > $o ).

tff(pred_def_82040,type,
    v137649: state_type > $o ).

tff(pred_def_82041,type,
    v137648: state_type > $o ).

tff(pred_def_82042,type,
    v137650: state_type > $o ).

tff(pred_def_82043,type,
    v137647: state_type > $o ).

tff(pred_def_82044,type,
    v137646: state_type > $o ).

tff(pred_def_82045,type,
    v137654: state_type > $o ).

tff(pred_def_82046,type,
    v137653: state_type > $o ).

tff(pred_def_82047,type,
    v137655: state_type > $o ).

tff(pred_def_82048,type,
    v137652: state_type > $o ).

tff(pred_def_82049,type,
    v137651: state_type > $o ).

tff(pred_def_82050,type,
    v137645: state_type > $o ).

tff(pred_def_82051,type,
    v137659: state_type > $o ).

tff(pred_def_82052,type,
    v137658: state_type > $o ).

tff(pred_def_82053,type,
    v137660: state_type > $o ).

tff(pred_def_82054,type,
    v137657: state_type > $o ).

tff(pred_def_82055,type,
    v137656: state_type > $o ).

tff(pred_def_82056,type,
    v137644: state_type > $o ).

tff(pred_def_82057,type,
    v137664: state_type > $o ).

tff(pred_def_82058,type,
    v137663: state_type > $o ).

tff(pred_def_82059,type,
    v137665: state_type > $o ).

tff(pred_def_82060,type,
    v137662: state_type > $o ).

tff(pred_def_82061,type,
    v137661: state_type > $o ).

tff(pred_def_82062,type,
    v137643: state_type > $o ).

tff(pred_def_82063,type,
    v137641: state_type > $o ).

tff(pred_def_82064,type,
    v137666: state_type > $o ).

tff(pred_def_82065,type,
    v137640: state_type > $o ).

tff(pred_def_82066,type,
    v137667: state_type > $o ).

tff(pred_def_82067,type,
    v137639: state_type > $o ).

tff(pred_def_82068,type,
    v137638: state_type > $o ).

tff(pred_def_82069,type,
    v137637: state_type > $o ).

tff(pred_def_82070,type,
    v137636: ( state_type * $int ) > $o ).

tff(pred_def_82071,type,
    v137592: ( state_type * $int ) > $o ).

tff(pred_def_82072,type,
    v137590: ( state_type * $int ) > $o ).

tff(pred_def_82073,type,
    v137588: ( state_type * $int ) > $o ).

tff(pred_def_82074,type,
    v137679: state_type > $o ).

tff(pred_def_82075,type,
    v137680: state_type > $o ).

tff(pred_def_82076,type,
    v137681: state_type > $o ).

tff(pred_def_82077,type,
    v137682: state_type > $o ).

tff(pred_def_82078,type,
    v137683: state_type > $o ).

tff(pred_def_82079,type,
    v137684: state_type > $o ).

tff(pred_def_82080,type,
    v137685: state_type > $o ).

tff(pred_def_82081,type,
    v137686: state_type > $o ).

tff(pred_def_82082,type,
    v137687: state_type > $o ).

tff(pred_def_82083,type,
    v137688: state_type > $o ).

tff(pred_def_82084,type,
    v137689: state_type > $o ).

tff(pred_def_82085,type,
    v137690: state_type > $o ).

tff(pred_def_82086,type,
    v137691: state_type > $o ).

tff(pred_def_82087,type,
    v137692: state_type > $o ).

tff(pred_def_82088,type,
    v137693: state_type > $o ).

tff(pred_def_82089,type,
    v137694: state_type > $o ).

tff(pred_def_82090,type,
    v137677: ( state_type * $int ) > $o ).

tff(pred_def_82091,type,
    v137711: ( state_type * $int ) > $o ).

tff(pred_def_82092,type,
    v137710: state_type > $o ).

tff(pred_def_82093,type,
    v137709: state_type > $o ).

tff(pred_def_82094,type,
    v137708: state_type > $o ).

tff(pred_def_82095,type,
    v137707: state_type > $o ).

tff(pred_def_82096,type,
    v137706: state_type > $o ).

tff(pred_def_82097,type,
    v137705: state_type > $o ).

tff(pred_def_82098,type,
    v137704: state_type > $o ).

tff(pred_def_82099,type,
    v137703: state_type > $o ).

tff(pred_def_82100,type,
    v137702: state_type > $o ).

tff(pred_def_82101,type,
    v137701: state_type > $o ).

tff(pred_def_82102,type,
    v137700: state_type > $o ).

tff(pred_def_82103,type,
    v137699: state_type > $o ).

tff(pred_def_82104,type,
    v137698: state_type > $o ).

tff(pred_def_82105,type,
    v137697: state_type > $o ).

tff(pred_def_82106,type,
    v137675: state_type > $o ).

tff(pred_def_82107,type,
    v137716: state_type > $o ).

tff(pred_def_82108,type,
    v137715: state_type > $o ).

tff(pred_def_82109,type,
    v137714: ( state_type * $int ) > $o ).

tff(pred_def_82110,type,
    v137713: ( state_type * $int ) > $o ).

tff(pred_def_82111,type,
    v137730: state_type > $o ).

tff(pred_def_82112,type,
    v137729: state_type > $o ).

tff(pred_def_82113,type,
    v137731: state_type > $o ).

tff(pred_def_82114,type,
    v137728: state_type > $o ).

tff(pred_def_82115,type,
    v137727: state_type > $o ).

tff(pred_def_82116,type,
    v137735: state_type > $o ).

tff(pred_def_82117,type,
    v137734: state_type > $o ).

tff(pred_def_82118,type,
    v137736: state_type > $o ).

tff(pred_def_82119,type,
    v137733: state_type > $o ).

tff(pred_def_82120,type,
    v137732: state_type > $o ).

tff(pred_def_82121,type,
    v137726: state_type > $o ).

tff(pred_def_82122,type,
    v137740: state_type > $o ).

tff(pred_def_82123,type,
    v137739: state_type > $o ).

tff(pred_def_82124,type,
    v137741: state_type > $o ).

tff(pred_def_82125,type,
    v137738: state_type > $o ).

tff(pred_def_82126,type,
    v137737: state_type > $o ).

tff(pred_def_82127,type,
    v137725: state_type > $o ).

tff(pred_def_82128,type,
    v137745: state_type > $o ).

tff(pred_def_82129,type,
    v137744: state_type > $o ).

tff(pred_def_82130,type,
    v137746: state_type > $o ).

tff(pred_def_82131,type,
    v137743: state_type > $o ).

tff(pred_def_82132,type,
    v137742: state_type > $o ).

tff(pred_def_82133,type,
    v137724: state_type > $o ).

tff(pred_def_82134,type,
    v137722: state_type > $o ).

tff(pred_def_82135,type,
    v137747: state_type > $o ).

tff(pred_def_82136,type,
    v137721: state_type > $o ).

tff(pred_def_82137,type,
    v137748: state_type > $o ).

tff(pred_def_82138,type,
    v137720: state_type > $o ).

tff(pred_def_82139,type,
    v137719: state_type > $o ).

tff(pred_def_82140,type,
    v137718: state_type > $o ).

tff(pred_def_82141,type,
    v137717: ( state_type * $int ) > $o ).

tff(pred_def_82142,type,
    v137673: ( state_type * $int ) > $o ).

tff(pred_def_82143,type,
    v137671: ( state_type * $int ) > $o ).

tff(pred_def_82144,type,
    v137669: ( state_type * $int ) > $o ).

tff(pred_def_82145,type,
    v137760: state_type > $o ).

tff(pred_def_82146,type,
    v137761: state_type > $o ).

tff(pred_def_82147,type,
    v137762: state_type > $o ).

tff(pred_def_82148,type,
    v137763: state_type > $o ).

tff(pred_def_82149,type,
    v137764: state_type > $o ).

tff(pred_def_82150,type,
    v137765: state_type > $o ).

tff(pred_def_82151,type,
    v137766: state_type > $o ).

tff(pred_def_82152,type,
    v137767: state_type > $o ).

tff(pred_def_82153,type,
    v137768: state_type > $o ).

tff(pred_def_82154,type,
    v137769: state_type > $o ).

tff(pred_def_82155,type,
    v137770: state_type > $o ).

tff(pred_def_82156,type,
    v137771: state_type > $o ).

tff(pred_def_82157,type,
    v137772: state_type > $o ).

tff(pred_def_82158,type,
    v137773: state_type > $o ).

tff(pred_def_82159,type,
    v137774: state_type > $o ).

tff(pred_def_82160,type,
    v137775: state_type > $o ).

tff(pred_def_82161,type,
    v137758: ( state_type * $int ) > $o ).

tff(pred_def_82162,type,
    v137792: ( state_type * $int ) > $o ).

tff(pred_def_82163,type,
    v137791: state_type > $o ).

tff(pred_def_82164,type,
    v137790: state_type > $o ).

tff(pred_def_82165,type,
    v137789: state_type > $o ).

tff(pred_def_82166,type,
    v137788: state_type > $o ).

tff(pred_def_82167,type,
    v137787: state_type > $o ).

tff(pred_def_82168,type,
    v137786: state_type > $o ).

tff(pred_def_82169,type,
    v137785: state_type > $o ).

tff(pred_def_82170,type,
    v137784: state_type > $o ).

tff(pred_def_82171,type,
    v137783: state_type > $o ).

tff(pred_def_82172,type,
    v137782: state_type > $o ).

tff(pred_def_82173,type,
    v137781: state_type > $o ).

tff(pred_def_82174,type,
    v137780: state_type > $o ).

tff(pred_def_82175,type,
    v137779: state_type > $o ).

tff(pred_def_82176,type,
    v137778: state_type > $o ).

tff(pred_def_82177,type,
    v137756: state_type > $o ).

tff(pred_def_82178,type,
    v137797: state_type > $o ).

tff(pred_def_82179,type,
    v137796: state_type > $o ).

tff(pred_def_82180,type,
    v137795: ( state_type * $int ) > $o ).

tff(pred_def_82181,type,
    v137794: ( state_type * $int ) > $o ).

tff(pred_def_82182,type,
    v137811: state_type > $o ).

tff(pred_def_82183,type,
    v137810: state_type > $o ).

tff(pred_def_82184,type,
    v137812: state_type > $o ).

tff(pred_def_82185,type,
    v137809: state_type > $o ).

tff(pred_def_82186,type,
    v137808: state_type > $o ).

tff(pred_def_82187,type,
    v137816: state_type > $o ).

tff(pred_def_82188,type,
    v137815: state_type > $o ).

tff(pred_def_82189,type,
    v137817: state_type > $o ).

tff(pred_def_82190,type,
    v137814: state_type > $o ).

tff(pred_def_82191,type,
    v137813: state_type > $o ).

tff(pred_def_82192,type,
    v137807: state_type > $o ).

tff(pred_def_82193,type,
    v137821: state_type > $o ).

tff(pred_def_82194,type,
    v137820: state_type > $o ).

tff(pred_def_82195,type,
    v137822: state_type > $o ).

tff(pred_def_82196,type,
    v137819: state_type > $o ).

tff(pred_def_82197,type,
    v137818: state_type > $o ).

tff(pred_def_82198,type,
    v137806: state_type > $o ).

tff(pred_def_82199,type,
    v137826: state_type > $o ).

tff(pred_def_82200,type,
    v137825: state_type > $o ).

tff(pred_def_82201,type,
    v137827: state_type > $o ).

tff(pred_def_82202,type,
    v137824: state_type > $o ).

tff(pred_def_82203,type,
    v137823: state_type > $o ).

tff(pred_def_82204,type,
    v137805: state_type > $o ).

tff(pred_def_82205,type,
    v137803: state_type > $o ).

tff(pred_def_82206,type,
    v137828: state_type > $o ).

tff(pred_def_82207,type,
    v137802: state_type > $o ).

tff(pred_def_82208,type,
    v137829: state_type > $o ).

tff(pred_def_82209,type,
    v137801: state_type > $o ).

tff(pred_def_82210,type,
    v137800: state_type > $o ).

tff(pred_def_82211,type,
    v137799: state_type > $o ).

tff(pred_def_82212,type,
    v137798: ( state_type * $int ) > $o ).

tff(pred_def_82213,type,
    v137754: ( state_type * $int ) > $o ).

tff(pred_def_82214,type,
    v137752: ( state_type * $int ) > $o ).

tff(pred_def_82215,type,
    v137750: ( state_type * $int ) > $o ).

tff(pred_def_82216,type,
    v137841: state_type > $o ).

tff(pred_def_82217,type,
    v137842: state_type > $o ).

tff(pred_def_82218,type,
    v137843: state_type > $o ).

tff(pred_def_82219,type,
    v137844: state_type > $o ).

tff(pred_def_82220,type,
    v137845: state_type > $o ).

tff(pred_def_82221,type,
    v137846: state_type > $o ).

tff(pred_def_82222,type,
    v137847: state_type > $o ).

tff(pred_def_82223,type,
    v137848: state_type > $o ).

tff(pred_def_82224,type,
    v137849: state_type > $o ).

tff(pred_def_82225,type,
    v137850: state_type > $o ).

tff(pred_def_82226,type,
    v137851: state_type > $o ).

tff(pred_def_82227,type,
    v137852: state_type > $o ).

tff(pred_def_82228,type,
    v137853: state_type > $o ).

tff(pred_def_82229,type,
    v137854: state_type > $o ).

tff(pred_def_82230,type,
    v137855: state_type > $o ).

tff(pred_def_82231,type,
    v137856: state_type > $o ).

tff(pred_def_82232,type,
    v137839: ( state_type * $int ) > $o ).

tff(pred_def_82233,type,
    v137873: ( state_type * $int ) > $o ).

tff(pred_def_82234,type,
    v137872: state_type > $o ).

tff(pred_def_82235,type,
    v137871: state_type > $o ).

tff(pred_def_82236,type,
    v137870: state_type > $o ).

tff(pred_def_82237,type,
    v137869: state_type > $o ).

tff(pred_def_82238,type,
    v137868: state_type > $o ).

tff(pred_def_82239,type,
    v137867: state_type > $o ).

tff(pred_def_82240,type,
    v137866: state_type > $o ).

tff(pred_def_82241,type,
    v137865: state_type > $o ).

tff(pred_def_82242,type,
    v137864: state_type > $o ).

tff(pred_def_82243,type,
    v137863: state_type > $o ).

tff(pred_def_82244,type,
    v137862: state_type > $o ).

tff(pred_def_82245,type,
    v137861: state_type > $o ).

tff(pred_def_82246,type,
    v137860: state_type > $o ).

tff(pred_def_82247,type,
    v137859: state_type > $o ).

tff(pred_def_82248,type,
    v137837: state_type > $o ).

tff(pred_def_82249,type,
    v137878: state_type > $o ).

tff(pred_def_82250,type,
    v137877: state_type > $o ).

tff(pred_def_82251,type,
    v137876: ( state_type * $int ) > $o ).

tff(pred_def_82252,type,
    v137875: ( state_type * $int ) > $o ).

tff(pred_def_82253,type,
    v137892: state_type > $o ).

tff(pred_def_82254,type,
    v137891: state_type > $o ).

tff(pred_def_82255,type,
    v137893: state_type > $o ).

tff(pred_def_82256,type,
    v137890: state_type > $o ).

tff(pred_def_82257,type,
    v137889: state_type > $o ).

tff(pred_def_82258,type,
    v137897: state_type > $o ).

tff(pred_def_82259,type,
    v137896: state_type > $o ).

tff(pred_def_82260,type,
    v137898: state_type > $o ).

tff(pred_def_82261,type,
    v137895: state_type > $o ).

tff(pred_def_82262,type,
    v137894: state_type > $o ).

tff(pred_def_82263,type,
    v137888: state_type > $o ).

tff(pred_def_82264,type,
    v137902: state_type > $o ).

tff(pred_def_82265,type,
    v137901: state_type > $o ).

tff(pred_def_82266,type,
    v137903: state_type > $o ).

tff(pred_def_82267,type,
    v137900: state_type > $o ).

tff(pred_def_82268,type,
    v137899: state_type > $o ).

tff(pred_def_82269,type,
    v137887: state_type > $o ).

tff(pred_def_82270,type,
    v137907: state_type > $o ).

tff(pred_def_82271,type,
    v137906: state_type > $o ).

tff(pred_def_82272,type,
    v137908: state_type > $o ).

tff(pred_def_82273,type,
    v137905: state_type > $o ).

tff(pred_def_82274,type,
    v137904: state_type > $o ).

tff(pred_def_82275,type,
    v137886: state_type > $o ).

tff(pred_def_82276,type,
    v137884: state_type > $o ).

tff(pred_def_82277,type,
    v137909: state_type > $o ).

tff(pred_def_82278,type,
    v137883: state_type > $o ).

tff(pred_def_82279,type,
    v137910: state_type > $o ).

tff(pred_def_82280,type,
    v137882: state_type > $o ).

tff(pred_def_82281,type,
    v137881: state_type > $o ).

tff(pred_def_82282,type,
    v137880: state_type > $o ).

tff(pred_def_82283,type,
    v137879: ( state_type * $int ) > $o ).

tff(pred_def_82284,type,
    v137835: ( state_type * $int ) > $o ).

tff(pred_def_82285,type,
    v137833: ( state_type * $int ) > $o ).

tff(pred_def_82286,type,
    v137831: ( state_type * $int ) > $o ).

tff(pred_def_82287,type,
    v137922: state_type > $o ).

tff(pred_def_82288,type,
    v137923: state_type > $o ).

tff(pred_def_82289,type,
    v137924: state_type > $o ).

tff(pred_def_82290,type,
    v137925: state_type > $o ).

tff(pred_def_82291,type,
    v137926: state_type > $o ).

tff(pred_def_82292,type,
    v137927: state_type > $o ).

tff(pred_def_82293,type,
    v137928: state_type > $o ).

tff(pred_def_82294,type,
    v137929: state_type > $o ).

tff(pred_def_82295,type,
    v137930: state_type > $o ).

tff(pred_def_82296,type,
    v137931: state_type > $o ).

tff(pred_def_82297,type,
    v137932: state_type > $o ).

tff(pred_def_82298,type,
    v137933: state_type > $o ).

tff(pred_def_82299,type,
    v137934: state_type > $o ).

tff(pred_def_82300,type,
    v137935: state_type > $o ).

tff(pred_def_82301,type,
    v137936: state_type > $o ).

tff(pred_def_82302,type,
    v137937: state_type > $o ).

tff(pred_def_82303,type,
    v137920: ( state_type * $int ) > $o ).

tff(pred_def_82304,type,
    v137954: ( state_type * $int ) > $o ).

tff(pred_def_82305,type,
    v137953: state_type > $o ).

tff(pred_def_82306,type,
    v137952: state_type > $o ).

tff(pred_def_82307,type,
    v137951: state_type > $o ).

tff(pred_def_82308,type,
    v137950: state_type > $o ).

tff(pred_def_82309,type,
    v137949: state_type > $o ).

tff(pred_def_82310,type,
    v137948: state_type > $o ).

tff(pred_def_82311,type,
    v137947: state_type > $o ).

tff(pred_def_82312,type,
    v137946: state_type > $o ).

tff(pred_def_82313,type,
    v137945: state_type > $o ).

tff(pred_def_82314,type,
    v137944: state_type > $o ).

tff(pred_def_82315,type,
    v137943: state_type > $o ).

tff(pred_def_82316,type,
    v137942: state_type > $o ).

tff(pred_def_82317,type,
    v137941: state_type > $o ).

tff(pred_def_82318,type,
    v137940: state_type > $o ).

tff(pred_def_82319,type,
    v137918: state_type > $o ).

tff(pred_def_82320,type,
    v137959: state_type > $o ).

tff(pred_def_82321,type,
    v137958: state_type > $o ).

tff(pred_def_82322,type,
    v137957: ( state_type * $int ) > $o ).

tff(pred_def_82323,type,
    v137956: ( state_type * $int ) > $o ).

tff(pred_def_82324,type,
    v137973: state_type > $o ).

tff(pred_def_82325,type,
    v137972: state_type > $o ).

tff(pred_def_82326,type,
    v137974: state_type > $o ).

tff(pred_def_82327,type,
    v137971: state_type > $o ).

tff(pred_def_82328,type,
    v137970: state_type > $o ).

tff(pred_def_82329,type,
    v137978: state_type > $o ).

tff(pred_def_82330,type,
    v137977: state_type > $o ).

tff(pred_def_82331,type,
    v137979: state_type > $o ).

tff(pred_def_82332,type,
    v137976: state_type > $o ).

tff(pred_def_82333,type,
    v137975: state_type > $o ).

tff(pred_def_82334,type,
    v137969: state_type > $o ).

tff(pred_def_82335,type,
    v137983: state_type > $o ).

tff(pred_def_82336,type,
    v137982: state_type > $o ).

tff(pred_def_82337,type,
    v137984: state_type > $o ).

tff(pred_def_82338,type,
    v137981: state_type > $o ).

tff(pred_def_82339,type,
    v137980: state_type > $o ).

tff(pred_def_82340,type,
    v137968: state_type > $o ).

tff(pred_def_82341,type,
    v137988: state_type > $o ).

tff(pred_def_82342,type,
    v137987: state_type > $o ).

tff(pred_def_82343,type,
    v137989: state_type > $o ).

tff(pred_def_82344,type,
    v137986: state_type > $o ).

tff(pred_def_82345,type,
    v137985: state_type > $o ).

tff(pred_def_82346,type,
    v137967: state_type > $o ).

tff(pred_def_82347,type,
    v137965: state_type > $o ).

tff(pred_def_82348,type,
    v137990: state_type > $o ).

tff(pred_def_82349,type,
    v137964: state_type > $o ).

tff(pred_def_82350,type,
    v137991: state_type > $o ).

tff(pred_def_82351,type,
    v137963: state_type > $o ).

tff(pred_def_82352,type,
    v137962: state_type > $o ).

tff(pred_def_82353,type,
    v137961: state_type > $o ).

tff(pred_def_82354,type,
    v137960: ( state_type * $int ) > $o ).

tff(pred_def_82355,type,
    v137916: ( state_type * $int ) > $o ).

tff(pred_def_82356,type,
    v137914: ( state_type * $int ) > $o ).

tff(pred_def_82357,type,
    v137912: ( state_type * $int ) > $o ).

tff(pred_def_82358,type,
    v138003: state_type > $o ).

tff(pred_def_82359,type,
    v138004: state_type > $o ).

tff(pred_def_82360,type,
    v138005: state_type > $o ).

tff(pred_def_82361,type,
    v138006: state_type > $o ).

tff(pred_def_82362,type,
    v138007: state_type > $o ).

tff(pred_def_82363,type,
    v138008: state_type > $o ).

tff(pred_def_82364,type,
    v138009: state_type > $o ).

tff(pred_def_82365,type,
    v138010: state_type > $o ).

tff(pred_def_82366,type,
    v138011: state_type > $o ).

tff(pred_def_82367,type,
    v138012: state_type > $o ).

tff(pred_def_82368,type,
    v138013: state_type > $o ).

tff(pred_def_82369,type,
    v138014: state_type > $o ).

tff(pred_def_82370,type,
    v138015: state_type > $o ).

tff(pred_def_82371,type,
    v138016: state_type > $o ).

tff(pred_def_82372,type,
    v138017: state_type > $o ).

tff(pred_def_82373,type,
    v138018: state_type > $o ).

tff(pred_def_82374,type,
    v138001: ( state_type * $int ) > $o ).

tff(pred_def_82375,type,
    v138035: ( state_type * $int ) > $o ).

tff(pred_def_82376,type,
    v138034: state_type > $o ).

tff(pred_def_82377,type,
    v138033: state_type > $o ).

tff(pred_def_82378,type,
    v138032: state_type > $o ).

tff(pred_def_82379,type,
    v138031: state_type > $o ).

tff(pred_def_82380,type,
    v138030: state_type > $o ).

tff(pred_def_82381,type,
    v138029: state_type > $o ).

tff(pred_def_82382,type,
    v138028: state_type > $o ).

tff(pred_def_82383,type,
    v138027: state_type > $o ).

tff(pred_def_82384,type,
    v138026: state_type > $o ).

tff(pred_def_82385,type,
    v138025: state_type > $o ).

tff(pred_def_82386,type,
    v138024: state_type > $o ).

tff(pred_def_82387,type,
    v138023: state_type > $o ).

tff(pred_def_82388,type,
    v138022: state_type > $o ).

tff(pred_def_82389,type,
    v138021: state_type > $o ).

tff(pred_def_82390,type,
    v137999: state_type > $o ).

tff(pred_def_82391,type,
    v138040: state_type > $o ).

tff(pred_def_82392,type,
    v138039: state_type > $o ).

tff(pred_def_82393,type,
    v138038: ( state_type * $int ) > $o ).

tff(pred_def_82394,type,
    v138037: ( state_type * $int ) > $o ).

tff(pred_def_82395,type,
    v138054: state_type > $o ).

tff(pred_def_82396,type,
    v138053: state_type > $o ).

tff(pred_def_82397,type,
    v138055: state_type > $o ).

tff(pred_def_82398,type,
    v138052: state_type > $o ).

tff(pred_def_82399,type,
    v138051: state_type > $o ).

tff(pred_def_82400,type,
    v138059: state_type > $o ).

tff(pred_def_82401,type,
    v138058: state_type > $o ).

tff(pred_def_82402,type,
    v138060: state_type > $o ).

tff(pred_def_82403,type,
    v138057: state_type > $o ).

tff(pred_def_82404,type,
    v138056: state_type > $o ).

tff(pred_def_82405,type,
    v138050: state_type > $o ).

tff(pred_def_82406,type,
    v138064: state_type > $o ).

tff(pred_def_82407,type,
    v138063: state_type > $o ).

tff(pred_def_82408,type,
    v138065: state_type > $o ).

tff(pred_def_82409,type,
    v138062: state_type > $o ).

tff(pred_def_82410,type,
    v138061: state_type > $o ).

tff(pred_def_82411,type,
    v138049: state_type > $o ).

tff(pred_def_82412,type,
    v138069: state_type > $o ).

tff(pred_def_82413,type,
    v138068: state_type > $o ).

tff(pred_def_82414,type,
    v138070: state_type > $o ).

tff(pred_def_82415,type,
    v138067: state_type > $o ).

tff(pred_def_82416,type,
    v138066: state_type > $o ).

tff(pred_def_82417,type,
    v138048: state_type > $o ).

tff(pred_def_82418,type,
    v138046: state_type > $o ).

tff(pred_def_82419,type,
    v138071: state_type > $o ).

tff(pred_def_82420,type,
    v138045: state_type > $o ).

tff(pred_def_82421,type,
    v138072: state_type > $o ).

tff(pred_def_82422,type,
    v138044: state_type > $o ).

tff(pred_def_82423,type,
    v138043: state_type > $o ).

tff(pred_def_82424,type,
    v138042: state_type > $o ).

tff(pred_def_82425,type,
    v138041: ( state_type * $int ) > $o ).

tff(pred_def_82426,type,
    v137997: ( state_type * $int ) > $o ).

tff(pred_def_82427,type,
    v137995: ( state_type * $int ) > $o ).

tff(pred_def_82428,type,
    v137993: ( state_type * $int ) > $o ).

tff(pred_def_82429,type,
    v138079: ( state_type * $int ) > $o ).

tff(pred_def_82430,type,
    v138078: ( state_type * $int ) > $o ).

tff(pred_def_82431,type,
    v138077: ( state_type * $int ) > $o ).

tff(pred_def_82432,type,
    v138076: ( state_type * $int ) > $o ).

tff(pred_def_82433,type,
    v138075: ( state_type * $int ) > $o ).

tff(pred_def_82434,type,
    v138074: ( state_type * $int ) > $o ).

tff(pred_def_82435,type,
    v84907: ( state_type * $int ) > $o ).

tff(pred_def_82436,type,
    v138096: ( state_type * $int ) > $o ).

tff(pred_def_82437,type,
    v138095: state_type > $o ).

tff(pred_def_82438,type,
    v138094: state_type > $o ).

tff(pred_def_82439,type,
    v138093: state_type > $o ).

tff(pred_def_82440,type,
    v138092: state_type > $o ).

tff(pred_def_82441,type,
    v138091: state_type > $o ).

tff(pred_def_82442,type,
    v138090: state_type > $o ).

tff(pred_def_82443,type,
    v138089: state_type > $o ).

tff(pred_def_82444,type,
    v138088: state_type > $o ).

tff(pred_def_82445,type,
    v138087: state_type > $o ).

tff(pred_def_82446,type,
    v138086: state_type > $o ).

tff(pred_def_82447,type,
    v138085: state_type > $o ).

tff(pred_def_82448,type,
    v138084: state_type > $o ).

tff(pred_def_82449,type,
    v138083: state_type > $o ).

tff(pred_def_82450,type,
    v138082: state_type > $o ).

tff(pred_def_82451,type,
    v84905: state_type > $o ).

tff(pred_def_82452,type,
    v138106: state_type > $o ).

tff(pred_def_82453,type,
    v138104: state_type > $o ).

tff(pred_def_82454,type,
    v138110: state_type > $o ).

tff(pred_def_82455,type,
    v138108: state_type > $o ).

tff(pred_def_82456,type,
    v138121: state_type > $o ).

tff(pred_def_82457,type,
    v138120: state_type > $o ).

tff(pred_def_82458,type,
    v138124: state_type > $o ).

tff(pred_def_82459,type,
    v138123: state_type > $o ).

tff(pred_def_82460,type,
    v138122: state_type > $o ).

tff(pred_def_82461,type,
    v138098: state_type > $o ).

tff(pred_def_82462,type,
    v138118: state_type > $o ).

tff(pred_def_82463,type,
    v138116: state_type > $o ).

tff(pred_def_82464,type,
    v138114: state_type > $o ).

tff(pred_def_82465,type,
    v138112: state_type > $o ).

tff(pred_def_82466,type,
    v138128: state_type > $o ).

tff(pred_def_82467,type,
    v138126: state_type > $o ).

tff(pred_def_82468,type,
    v138135: state_type > $o ).

tff(pred_def_82469,type,
    v138133: state_type > $o ).

tff(pred_def_82470,type,
    v138132: state_type > $o ).

tff(pred_def_82471,type,
    v138131: state_type > $o ).

tff(pred_def_82472,type,
    v138143: state_type > $o ).

tff(pred_def_82473,type,
    v138144: state_type > $o ).

tff(pred_def_82474,type,
    v138142: state_type > $o ).

tff(pred_def_82475,type,
    v138139: state_type > $o ).

tff(pred_def_82476,type,
    v138141: state_type > $o ).

tff(pred_def_82477,type,
    v138102: state_type > $o ).

tff(pred_def_82478,type,
    v138100: state_type > $o ).

tff(pred_def_82479,type,
    v138160: state_type > $o ).

tff(pred_def_82480,type,
    v138158: state_type > $o ).

tff(pred_def_82481,type,
    v138164: state_type > $o ).

tff(pred_def_82482,type,
    v138162: state_type > $o ).

tff(pred_def_82483,type,
    v138175: state_type > $o ).

tff(pred_def_82484,type,
    v138176: state_type > $o ).

tff(pred_def_82485,type,
    v138174: state_type > $o ).

tff(pred_def_82486,type,
    v138172: state_type > $o ).

tff(pred_def_82487,type,
    v138170: state_type > $o ).

tff(pred_def_82488,type,
    v138168: state_type > $o ).

tff(pred_def_82489,type,
    v138166: state_type > $o ).

tff(pred_def_82490,type,
    v138180: state_type > $o ).

tff(pred_def_82491,type,
    v138178: state_type > $o ).

tff(pred_def_82492,type,
    v138187: state_type > $o ).

tff(pred_def_82493,type,
    v138185: state_type > $o ).

tff(pred_def_82494,type,
    v138184: state_type > $o ).

tff(pred_def_82495,type,
    v138183: state_type > $o ).

tff(pred_def_82496,type,
    v138195: state_type > $o ).

tff(pred_def_82497,type,
    v138196: state_type > $o ).

tff(pred_def_82498,type,
    v138194: state_type > $o ).

tff(pred_def_82499,type,
    v138191: state_type > $o ).

tff(pred_def_82500,type,
    v138193: state_type > $o ).

tff(pred_def_82501,type,
    v138156: state_type > $o ).

tff(pred_def_82502,type,
    v138154: state_type > $o ).

tff(pred_def_82503,type,
    v138152: state_type > $o ).

tff(pred_def_82504,type,
    v138210: state_type > $o ).

tff(pred_def_82505,type,
    v138209: ( state_type * $int ) > $o ).

tff(pred_def_82506,type,
    v138208: ( state_type * $int ) > $o ).

tff(pred_def_82507,type,
    v138213: state_type > $o ).

tff(pred_def_82508,type,
    v138212: ( state_type * $int ) > $o ).

tff(pred_def_82509,type,
    v138211: ( state_type * $int ) > $o ).

tff(pred_def_82510,type,
    v138206: ( state_type * $int ) > $o ).

tff(pred_def_82511,type,
    v138204: ( state_type * $int ) > $o ).

tff(pred_def_82512,type,
    v138202: ( state_type * $int ) > $o ).

tff(pred_def_82513,type,
    v138230: ( state_type * $int ) > $o ).

tff(pred_def_82514,type,
    v138229: state_type > $o ).

tff(pred_def_82515,type,
    v138228: state_type > $o ).

tff(pred_def_82516,type,
    v138227: state_type > $o ).

tff(pred_def_82517,type,
    v138226: state_type > $o ).

tff(pred_def_82518,type,
    v138225: state_type > $o ).

tff(pred_def_82519,type,
    v138224: state_type > $o ).

tff(pred_def_82520,type,
    v138223: state_type > $o ).

tff(pred_def_82521,type,
    v138222: state_type > $o ).

tff(pred_def_82522,type,
    v138221: state_type > $o ).

tff(pred_def_82523,type,
    v138220: state_type > $o ).

tff(pred_def_82524,type,
    v138219: state_type > $o ).

tff(pred_def_82525,type,
    v138218: state_type > $o ).

tff(pred_def_82526,type,
    v138217: state_type > $o ).

tff(pred_def_82527,type,
    v138216: state_type > $o ).

tff(pred_def_82528,type,
    v138200: state_type > $o ).

tff(pred_def_82529,type,
    v138244: state_type > $o ).

tff(pred_def_82530,type,
    v138245: state_type > $o ).

tff(pred_def_82531,type,
    v138243: state_type > $o ).

tff(pred_def_82532,type,
    v138246: state_type > $o ).

tff(pred_def_82533,type,
    v138242: state_type > $o ).

tff(pred_def_82534,type,
    v138247: state_type > $o ).

tff(pred_def_82535,type,
    v138241: state_type > $o ).

tff(pred_def_82536,type,
    v138240: state_type > $o ).

tff(pred_def_82537,type,
    v138239: state_type > $o ).

tff(pred_def_82538,type,
    v138249: state_type > $o ).

tff(pred_def_82539,type,
    v138248: state_type > $o ).

tff(pred_def_82540,type,
    v138238: state_type > $o ).

tff(pred_def_82541,type,
    v138237: state_type > $o ).

tff(pred_def_82542,type,
    v138236: state_type > $o ).

tff(pred_def_82543,type,
    v138235: state_type > $o ).

tff(pred_def_82544,type,
    v138234: state_type > $o ).

tff(pred_def_82545,type,
    v138233: state_type > $o ).

tff(pred_def_82546,type,
    v138232: state_type > $o ).

tff(pred_def_82547,type,
    v138150: state_type > $o ).

tff(pred_def_82548,type,
    v138255: ( state_type * $int ) > $o ).

tff(pred_def_82549,type,
    v138253: ( state_type * $int ) > $o ).

tff(pred_def_82550,type,
    v138251: ( state_type * $int ) > $o ).

tff(pred_def_82551,type,
    v138261: state_type > $o ).

tff(pred_def_82552,type,
    v138259: state_type > $o ).

tff(pred_def_82553,type,
    v138257: state_type > $o ).

tff(pred_def_82554,type,
    v128: ( state_type * $int ) > $o ).

tff(pred_def_82555,type,
    v138280: ( state_type * $int ) > $o ).

tff(pred_def_82556,type,
    v138279: state_type > $o ).

tff(pred_def_82557,type,
    v138278: state_type > $o ).

tff(pred_def_82558,type,
    v138277: state_type > $o ).

tff(pred_def_82559,type,
    v138276: state_type > $o ).

tff(pred_def_82560,type,
    v138275: state_type > $o ).

tff(pred_def_82561,type,
    v138274: state_type > $o ).

tff(pred_def_82562,type,
    v138273: state_type > $o ).

tff(pred_def_82563,type,
    v138272: state_type > $o ).

tff(pred_def_82564,type,
    v138271: state_type > $o ).

tff(pred_def_82565,type,
    v138270: state_type > $o ).

tff(pred_def_82566,type,
    v138269: state_type > $o ).

tff(pred_def_82567,type,
    v138268: state_type > $o ).

tff(pred_def_82568,type,
    v138267: state_type > $o ).

tff(pred_def_82569,type,
    v138266: state_type > $o ).

tff(pred_def_82570,type,
    v138264: state_type > $o ).

tff(pred_def_82571,type,
    v138281: state_type > $o ).

tff(pred_def_82572,type,
    v138263: state_type > $o ).

tff(pred_def_82573,type,
    v138284: state_type > $o ).

tff(pred_def_82574,type,
    v138292: state_type > $o ).

tff(pred_def_82575,type,
    v138291: state_type > $o ).

tff(pred_def_82576,type,
    v138293: state_type > $o ).

tff(pred_def_82577,type,
    v138290: state_type > $o ).

tff(pred_def_82578,type,
    v138289: state_type > $o ).

tff(pred_def_82579,type,
    v138297: state_type > $o ).

tff(pred_def_82580,type,
    v138296: state_type > $o ).

tff(pred_def_82581,type,
    v138298: state_type > $o ).

tff(pred_def_82582,type,
    v138295: state_type > $o ).

tff(pred_def_82583,type,
    v138294: state_type > $o ).

tff(pred_def_82584,type,
    v138288: state_type > $o ).

tff(pred_def_82585,type,
    v138302: state_type > $o ).

tff(pred_def_82586,type,
    v138301: state_type > $o ).

tff(pred_def_82587,type,
    v138303: state_type > $o ).

tff(pred_def_82588,type,
    v138300: state_type > $o ).

tff(pred_def_82589,type,
    v138299: state_type > $o ).

tff(pred_def_82590,type,
    v138287: state_type > $o ).

tff(pred_def_82591,type,
    v138285: state_type > $o ).

tff(pred_def_82592,type,
    v138283: state_type > $o ).

tff(pred_def_82593,type,
    v138305: ( state_type * $int ) > $o ).

tff(pred_def_82594,type,
    v138304: state_type > $o ).

tff(pred_def_82595,type,
    v138282: state_type > $o ).

tff(pred_def_82596,type,
    v138148: ( state_type * $int ) > $o ).

tff(pred_def_82597,type,
    v138317: state_type > $o ).

tff(pred_def_82598,type,
    v138318: state_type > $o ).

tff(pred_def_82599,type,
    v138319: state_type > $o ).

tff(pred_def_82600,type,
    v138320: state_type > $o ).

tff(pred_def_82601,type,
    v138321: state_type > $o ).

tff(pred_def_82602,type,
    v138322: state_type > $o ).

tff(pred_def_82603,type,
    v138323: state_type > $o ).

tff(pred_def_82604,type,
    v138324: state_type > $o ).

tff(pred_def_82605,type,
    v138325: state_type > $o ).

tff(pred_def_82606,type,
    v138326: state_type > $o ).

tff(pred_def_82607,type,
    v138327: state_type > $o ).

tff(pred_def_82608,type,
    v138328: state_type > $o ).

tff(pred_def_82609,type,
    v138329: state_type > $o ).

tff(pred_def_82610,type,
    v138330: state_type > $o ).

tff(pred_def_82611,type,
    v138331: state_type > $o ).

tff(pred_def_82612,type,
    v138332: state_type > $o ).

tff(pred_def_82613,type,
    v138315: ( state_type * $int ) > $o ).

tff(pred_def_82614,type,
    v138336: ( state_type * $int ) > $o ).

tff(pred_def_82615,type,
    v138338: ( state_type * $int ) > $o ).

tff(pred_def_82616,type,
    v138340: ( state_type * $int ) > $o ).

tff(pred_def_82617,type,
    v138334: ( state_type * $int ) > $o ).

tff(pred_def_82618,type,
    v138357: ( state_type * $int ) > $o ).

tff(pred_def_82619,type,
    v138356: state_type > $o ).

tff(pred_def_82620,type,
    v138355: state_type > $o ).

tff(pred_def_82621,type,
    v138354: state_type > $o ).

tff(pred_def_82622,type,
    v138353: state_type > $o ).

tff(pred_def_82623,type,
    v138352: state_type > $o ).

tff(pred_def_82624,type,
    v138351: state_type > $o ).

tff(pred_def_82625,type,
    v138350: state_type > $o ).

tff(pred_def_82626,type,
    v138349: state_type > $o ).

tff(pred_def_82627,type,
    v138348: state_type > $o ).

tff(pred_def_82628,type,
    v138347: state_type > $o ).

tff(pred_def_82629,type,
    v138346: state_type > $o ).

tff(pred_def_82630,type,
    v138345: state_type > $o ).

tff(pred_def_82631,type,
    v138344: state_type > $o ).

tff(pred_def_82632,type,
    v138343: state_type > $o ).

tff(pred_def_82633,type,
    v138313: state_type > $o ).

tff(pred_def_82634,type,
    v138359: ( state_type * $int ) > $o ).

tff(pred_def_82635,type,
    v138361: state_type > $o ).

tff(pred_def_82636,type,
    v138363: state_type > $o ).

tff(pred_def_82637,type,
    v138365: state_type > $o ).

tff(pred_def_82638,type,
    v138367: state_type > $o ).

tff(pred_def_82639,type,
    v138372: state_type > $o ).

tff(pred_def_82640,type,
    v138371: state_type > $o ).

tff(pred_def_82641,type,
    v138370: ( state_type * $int ) > $o ).

tff(pred_def_82642,type,
    v138369: ( state_type * $int ) > $o ).

tff(pred_def_82643,type,
    v138386: state_type > $o ).

tff(pred_def_82644,type,
    v138387: state_type > $o ).

tff(pred_def_82645,type,
    v138385: state_type > $o ).

tff(pred_def_82646,type,
    v138388: state_type > $o ).

tff(pred_def_82647,type,
    v138384: state_type > $o ).

tff(pred_def_82648,type,
    v138383: state_type > $o ).

tff(pred_def_82649,type,
    v138392: state_type > $o ).

tff(pred_def_82650,type,
    v138393: state_type > $o ).

tff(pred_def_82651,type,
    v138391: state_type > $o ).

tff(pred_def_82652,type,
    v138394: state_type > $o ).

tff(pred_def_82653,type,
    v138390: state_type > $o ).

tff(pred_def_82654,type,
    v138389: state_type > $o ).

tff(pred_def_82655,type,
    v138382: state_type > $o ).

tff(pred_def_82656,type,
    v138398: state_type > $o ).

tff(pred_def_82657,type,
    v138399: state_type > $o ).

tff(pred_def_82658,type,
    v138397: state_type > $o ).

tff(pred_def_82659,type,
    v138400: state_type > $o ).

tff(pred_def_82660,type,
    v138396: state_type > $o ).

tff(pred_def_82661,type,
    v138395: state_type > $o ).

tff(pred_def_82662,type,
    v138381: state_type > $o ).

tff(pred_def_82663,type,
    v138404: state_type > $o ).

tff(pred_def_82664,type,
    v138405: state_type > $o ).

tff(pred_def_82665,type,
    v138403: state_type > $o ).

tff(pred_def_82666,type,
    v138406: state_type > $o ).

tff(pred_def_82667,type,
    v138402: state_type > $o ).

tff(pred_def_82668,type,
    v138401: state_type > $o ).

tff(pred_def_82669,type,
    v138380: state_type > $o ).

tff(pred_def_82670,type,
    v138378: state_type > $o ).

tff(pred_def_82671,type,
    v138407: state_type > $o ).

tff(pred_def_82672,type,
    v138377: state_type > $o ).

tff(pred_def_82673,type,
    v138408: state_type > $o ).

tff(pred_def_82674,type,
    v138376: state_type > $o ).

tff(pred_def_82675,type,
    v138375: state_type > $o ).

tff(pred_def_82676,type,
    v138374: state_type > $o ).

tff(pred_def_82677,type,
    v138373: ( state_type * $int ) > $o ).

tff(pred_def_82678,type,
    v138311: ( state_type * $int ) > $o ).

tff(pred_def_82679,type,
    v138309: ( state_type * $int ) > $o ).

tff(pred_def_82680,type,
    v138307: ( state_type * $int ) > $o ).

tff(pred_def_82681,type,
    v138414: ( state_type * $int ) > $o ).

tff(pred_def_82682,type,
    v138412: ( state_type * $int ) > $o ).

tff(pred_def_82683,type,
    v138410: ( state_type * $int ) > $o ).

tff(pred_def_82684,type,
    v138420: state_type > $o ).

tff(pred_def_82685,type,
    v138418: state_type > $o ).

tff(pred_def_82686,type,
    v138416: state_type > $o ).

tff(pred_def_82687,type,
    v138439: ( state_type * $int ) > $o ).

tff(pred_def_82688,type,
    v138438: state_type > $o ).

tff(pred_def_82689,type,
    v138437: state_type > $o ).

tff(pred_def_82690,type,
    v138436: state_type > $o ).

tff(pred_def_82691,type,
    v138435: state_type > $o ).

tff(pred_def_82692,type,
    v138434: state_type > $o ).

tff(pred_def_82693,type,
    v138433: state_type > $o ).

tff(pred_def_82694,type,
    v138432: state_type > $o ).

tff(pred_def_82695,type,
    v138431: state_type > $o ).

tff(pred_def_82696,type,
    v138430: state_type > $o ).

tff(pred_def_82697,type,
    v138429: state_type > $o ).

tff(pred_def_82698,type,
    v138428: state_type > $o ).

tff(pred_def_82699,type,
    v138427: state_type > $o ).

tff(pred_def_82700,type,
    v138426: state_type > $o ).

tff(pred_def_82701,type,
    v138425: state_type > $o ).

tff(pred_def_82702,type,
    v138423: state_type > $o ).

tff(pred_def_82703,type,
    v138440: state_type > $o ).

tff(pred_def_82704,type,
    v138422: state_type > $o ).

tff(pred_def_82705,type,
    v138443: state_type > $o ).

tff(pred_def_82706,type,
    v138451: state_type > $o ).

tff(pred_def_82707,type,
    v138450: state_type > $o ).

tff(pred_def_82708,type,
    v138452: state_type > $o ).

tff(pred_def_82709,type,
    v138449: state_type > $o ).

tff(pred_def_82710,type,
    v138448: state_type > $o ).

tff(pred_def_82711,type,
    v138456: state_type > $o ).

tff(pred_def_82712,type,
    v138455: state_type > $o ).

tff(pred_def_82713,type,
    v138457: state_type > $o ).

tff(pred_def_82714,type,
    v138454: state_type > $o ).

tff(pred_def_82715,type,
    v138453: state_type > $o ).

tff(pred_def_82716,type,
    v138447: state_type > $o ).

tff(pred_def_82717,type,
    v138461: state_type > $o ).

tff(pred_def_82718,type,
    v138460: state_type > $o ).

tff(pred_def_82719,type,
    v138462: state_type > $o ).

tff(pred_def_82720,type,
    v138459: state_type > $o ).

tff(pred_def_82721,type,
    v138458: state_type > $o ).

tff(pred_def_82722,type,
    v138446: state_type > $o ).

tff(pred_def_82723,type,
    v138444: state_type > $o ).

tff(pred_def_82724,type,
    v138442: state_type > $o ).

tff(pred_def_82725,type,
    v138464: ( state_type * $int ) > $o ).

tff(pred_def_82726,type,
    v138463: state_type > $o ).

tff(pred_def_82727,type,
    v138441: state_type > $o ).

tff(pred_def_82728,type,
    v138476: state_type > $o ).

tff(pred_def_82729,type,
    v138477: state_type > $o ).

tff(pred_def_82730,type,
    v138478: state_type > $o ).

tff(pred_def_82731,type,
    v138479: state_type > $o ).

tff(pred_def_82732,type,
    v138480: state_type > $o ).

tff(pred_def_82733,type,
    v138481: state_type > $o ).

tff(pred_def_82734,type,
    v138482: state_type > $o ).

tff(pred_def_82735,type,
    v138483: state_type > $o ).

tff(pred_def_82736,type,
    v138484: state_type > $o ).

tff(pred_def_82737,type,
    v138485: state_type > $o ).

tff(pred_def_82738,type,
    v138486: state_type > $o ).

tff(pred_def_82739,type,
    v138487: state_type > $o ).

tff(pred_def_82740,type,
    v138488: state_type > $o ).

tff(pred_def_82741,type,
    v138489: state_type > $o ).

tff(pred_def_82742,type,
    v138490: state_type > $o ).

tff(pred_def_82743,type,
    v138491: state_type > $o ).

tff(pred_def_82744,type,
    v138474: ( state_type * $int ) > $o ).

tff(pred_def_82745,type,
    v138508: ( state_type * $int ) > $o ).

tff(pred_def_82746,type,
    v138507: state_type > $o ).

tff(pred_def_82747,type,
    v138506: state_type > $o ).

tff(pred_def_82748,type,
    v138505: state_type > $o ).

tff(pred_def_82749,type,
    v138504: state_type > $o ).

tff(pred_def_82750,type,
    v138503: state_type > $o ).

tff(pred_def_82751,type,
    v138502: state_type > $o ).

tff(pred_def_82752,type,
    v138501: state_type > $o ).

tff(pred_def_82753,type,
    v138500: state_type > $o ).

tff(pred_def_82754,type,
    v138499: state_type > $o ).

tff(pred_def_82755,type,
    v138498: state_type > $o ).

tff(pred_def_82756,type,
    v138497: state_type > $o ).

tff(pred_def_82757,type,
    v138496: state_type > $o ).

tff(pred_def_82758,type,
    v138495: state_type > $o ).

tff(pred_def_82759,type,
    v138494: state_type > $o ).

tff(pred_def_82760,type,
    v138472: state_type > $o ).

tff(pred_def_82761,type,
    v138513: state_type > $o ).

tff(pred_def_82762,type,
    v138512: state_type > $o ).

tff(pred_def_82763,type,
    v138511: ( state_type * $int ) > $o ).

tff(pred_def_82764,type,
    v138510: ( state_type * $int ) > $o ).

tff(pred_def_82765,type,
    v138527: state_type > $o ).

tff(pred_def_82766,type,
    v138526: state_type > $o ).

tff(pred_def_82767,type,
    v138528: state_type > $o ).

tff(pred_def_82768,type,
    v138525: state_type > $o ).

tff(pred_def_82769,type,
    v138524: state_type > $o ).

tff(pred_def_82770,type,
    v138532: state_type > $o ).

tff(pred_def_82771,type,
    v138531: state_type > $o ).

tff(pred_def_82772,type,
    v138533: state_type > $o ).

tff(pred_def_82773,type,
    v138530: state_type > $o ).

tff(pred_def_82774,type,
    v138529: state_type > $o ).

tff(pred_def_82775,type,
    v138523: state_type > $o ).

tff(pred_def_82776,type,
    v138537: state_type > $o ).

tff(pred_def_82777,type,
    v138536: state_type > $o ).

tff(pred_def_82778,type,
    v138538: state_type > $o ).

tff(pred_def_82779,type,
    v138535: state_type > $o ).

tff(pred_def_82780,type,
    v138534: state_type > $o ).

tff(pred_def_82781,type,
    v138522: state_type > $o ).

tff(pred_def_82782,type,
    v138542: state_type > $o ).

tff(pred_def_82783,type,
    v138541: state_type > $o ).

tff(pred_def_82784,type,
    v138543: state_type > $o ).

tff(pred_def_82785,type,
    v138540: state_type > $o ).

tff(pred_def_82786,type,
    v138539: state_type > $o ).

tff(pred_def_82787,type,
    v138521: state_type > $o ).

tff(pred_def_82788,type,
    v138519: state_type > $o ).

tff(pred_def_82789,type,
    v138544: state_type > $o ).

tff(pred_def_82790,type,
    v138518: state_type > $o ).

tff(pred_def_82791,type,
    v138545: state_type > $o ).

tff(pred_def_82792,type,
    v138517: state_type > $o ).

tff(pred_def_82793,type,
    v138516: state_type > $o ).

tff(pred_def_82794,type,
    v138515: state_type > $o ).

tff(pred_def_82795,type,
    v138514: ( state_type * $int ) > $o ).

tff(pred_def_82796,type,
    v138470: ( state_type * $int ) > $o ).

tff(pred_def_82797,type,
    v138468: ( state_type * $int ) > $o ).

tff(pred_def_82798,type,
    v138466: ( state_type * $int ) > $o ).

tff(pred_def_82799,type,
    v138551: ( state_type * $int ) > $o ).

tff(pred_def_82800,type,
    v138549: ( state_type * $int ) > $o ).

tff(pred_def_82801,type,
    v138547: ( state_type * $int ) > $o ).

tff(pred_def_82802,type,
    v138557: state_type > $o ).

tff(pred_def_82803,type,
    v138555: state_type > $o ).

tff(pred_def_82804,type,
    v138553: state_type > $o ).

tff(pred_def_82805,type,
    v138576: ( state_type * $int ) > $o ).

tff(pred_def_82806,type,
    v138575: state_type > $o ).

tff(pred_def_82807,type,
    v138574: state_type > $o ).

tff(pred_def_82808,type,
    v138573: state_type > $o ).

tff(pred_def_82809,type,
    v138572: state_type > $o ).

tff(pred_def_82810,type,
    v138571: state_type > $o ).

tff(pred_def_82811,type,
    v138570: state_type > $o ).

tff(pred_def_82812,type,
    v138569: state_type > $o ).

tff(pred_def_82813,type,
    v138568: state_type > $o ).

tff(pred_def_82814,type,
    v138567: state_type > $o ).

tff(pred_def_82815,type,
    v138566: state_type > $o ).

tff(pred_def_82816,type,
    v138565: state_type > $o ).

tff(pred_def_82817,type,
    v138564: state_type > $o ).

tff(pred_def_82818,type,
    v138563: state_type > $o ).

tff(pred_def_82819,type,
    v138562: state_type > $o ).

tff(pred_def_82820,type,
    v138560: state_type > $o ).

tff(pred_def_82821,type,
    v138577: state_type > $o ).

tff(pred_def_82822,type,
    v138559: state_type > $o ).

tff(pred_def_82823,type,
    v138580: state_type > $o ).

tff(pred_def_82824,type,
    v138588: state_type > $o ).

tff(pred_def_82825,type,
    v138587: state_type > $o ).

tff(pred_def_82826,type,
    v138589: state_type > $o ).

tff(pred_def_82827,type,
    v138586: state_type > $o ).

tff(pred_def_82828,type,
    v138585: state_type > $o ).

tff(pred_def_82829,type,
    v138593: state_type > $o ).

tff(pred_def_82830,type,
    v138592: state_type > $o ).

tff(pred_def_82831,type,
    v138594: state_type > $o ).

tff(pred_def_82832,type,
    v138591: state_type > $o ).

tff(pred_def_82833,type,
    v138590: state_type > $o ).

tff(pred_def_82834,type,
    v138584: state_type > $o ).

tff(pred_def_82835,type,
    v138598: state_type > $o ).

tff(pred_def_82836,type,
    v138597: state_type > $o ).

tff(pred_def_82837,type,
    v138599: state_type > $o ).

tff(pred_def_82838,type,
    v138596: state_type > $o ).

tff(pred_def_82839,type,
    v138595: state_type > $o ).

tff(pred_def_82840,type,
    v138583: state_type > $o ).

tff(pred_def_82841,type,
    v138581: state_type > $o ).

tff(pred_def_82842,type,
    v138579: state_type > $o ).

tff(pred_def_82843,type,
    v138601: ( state_type * $int ) > $o ).

tff(pred_def_82844,type,
    v138600: state_type > $o ).

tff(pred_def_82845,type,
    v138578: state_type > $o ).

tff(pred_def_82846,type,
    v138613: state_type > $o ).

tff(pred_def_82847,type,
    v138614: state_type > $o ).

tff(pred_def_82848,type,
    v138615: state_type > $o ).

tff(pred_def_82849,type,
    v138616: state_type > $o ).

tff(pred_def_82850,type,
    v138617: state_type > $o ).

tff(pred_def_82851,type,
    v138618: state_type > $o ).

tff(pred_def_82852,type,
    v138619: state_type > $o ).

tff(pred_def_82853,type,
    v138620: state_type > $o ).

tff(pred_def_82854,type,
    v138621: state_type > $o ).

tff(pred_def_82855,type,
    v138622: state_type > $o ).

tff(pred_def_82856,type,
    v138623: state_type > $o ).

tff(pred_def_82857,type,
    v138624: state_type > $o ).

tff(pred_def_82858,type,
    v138625: state_type > $o ).

tff(pred_def_82859,type,
    v138626: state_type > $o ).

tff(pred_def_82860,type,
    v138627: state_type > $o ).

tff(pred_def_82861,type,
    v138628: state_type > $o ).

tff(pred_def_82862,type,
    v138611: ( state_type * $int ) > $o ).

tff(pred_def_82863,type,
    v138645: ( state_type * $int ) > $o ).

tff(pred_def_82864,type,
    v138644: state_type > $o ).

tff(pred_def_82865,type,
    v138643: state_type > $o ).

tff(pred_def_82866,type,
    v138642: state_type > $o ).

tff(pred_def_82867,type,
    v138641: state_type > $o ).

tff(pred_def_82868,type,
    v138640: state_type > $o ).

tff(pred_def_82869,type,
    v138639: state_type > $o ).

tff(pred_def_82870,type,
    v138638: state_type > $o ).

tff(pred_def_82871,type,
    v138637: state_type > $o ).

tff(pred_def_82872,type,
    v138636: state_type > $o ).

tff(pred_def_82873,type,
    v138635: state_type > $o ).

tff(pred_def_82874,type,
    v138634: state_type > $o ).

tff(pred_def_82875,type,
    v138633: state_type > $o ).

tff(pred_def_82876,type,
    v138632: state_type > $o ).

tff(pred_def_82877,type,
    v138631: state_type > $o ).

tff(pred_def_82878,type,
    v138609: state_type > $o ).

tff(pred_def_82879,type,
    v138650: state_type > $o ).

tff(pred_def_82880,type,
    v138649: state_type > $o ).

tff(pred_def_82881,type,
    v138648: ( state_type * $int ) > $o ).

tff(pred_def_82882,type,
    v138647: ( state_type * $int ) > $o ).

tff(pred_def_82883,type,
    v138664: state_type > $o ).

tff(pred_def_82884,type,
    v138663: state_type > $o ).

tff(pred_def_82885,type,
    v138665: state_type > $o ).

tff(pred_def_82886,type,
    v138662: state_type > $o ).

tff(pred_def_82887,type,
    v138661: state_type > $o ).

tff(pred_def_82888,type,
    v138669: state_type > $o ).

tff(pred_def_82889,type,
    v138668: state_type > $o ).

tff(pred_def_82890,type,
    v138670: state_type > $o ).

tff(pred_def_82891,type,
    v138667: state_type > $o ).

tff(pred_def_82892,type,
    v138666: state_type > $o ).

tff(pred_def_82893,type,
    v138660: state_type > $o ).

tff(pred_def_82894,type,
    v138674: state_type > $o ).

tff(pred_def_82895,type,
    v138673: state_type > $o ).

tff(pred_def_82896,type,
    v138675: state_type > $o ).

tff(pred_def_82897,type,
    v138672: state_type > $o ).

tff(pred_def_82898,type,
    v138671: state_type > $o ).

tff(pred_def_82899,type,
    v138659: state_type > $o ).

tff(pred_def_82900,type,
    v138679: state_type > $o ).

tff(pred_def_82901,type,
    v138678: state_type > $o ).

tff(pred_def_82902,type,
    v138680: state_type > $o ).

tff(pred_def_82903,type,
    v138677: state_type > $o ).

tff(pred_def_82904,type,
    v138676: state_type > $o ).

tff(pred_def_82905,type,
    v138658: state_type > $o ).

tff(pred_def_82906,type,
    v138656: state_type > $o ).

tff(pred_def_82907,type,
    v138681: state_type > $o ).

tff(pred_def_82908,type,
    v138655: state_type > $o ).

tff(pred_def_82909,type,
    v138682: state_type > $o ).

tff(pred_def_82910,type,
    v138654: state_type > $o ).

tff(pred_def_82911,type,
    v138653: state_type > $o ).

tff(pred_def_82912,type,
    v138652: state_type > $o ).

tff(pred_def_82913,type,
    v138651: ( state_type * $int ) > $o ).

tff(pred_def_82914,type,
    v138607: ( state_type * $int ) > $o ).

tff(pred_def_82915,type,
    v138605: ( state_type * $int ) > $o ).

tff(pred_def_82916,type,
    v138603: ( state_type * $int ) > $o ).

tff(pred_def_82917,type,
    v138688: ( state_type * $int ) > $o ).

tff(pred_def_82918,type,
    v138686: ( state_type * $int ) > $o ).

tff(pred_def_82919,type,
    v138684: ( state_type * $int ) > $o ).

tff(pred_def_82920,type,
    v138694: state_type > $o ).

tff(pred_def_82921,type,
    v138692: state_type > $o ).

tff(pred_def_82922,type,
    v138690: state_type > $o ).

tff(pred_def_82923,type,
    v138713: ( state_type * $int ) > $o ).

tff(pred_def_82924,type,
    v138712: state_type > $o ).

tff(pred_def_82925,type,
    v138711: state_type > $o ).

tff(pred_def_82926,type,
    v138710: state_type > $o ).

tff(pred_def_82927,type,
    v138709: state_type > $o ).

tff(pred_def_82928,type,
    v138708: state_type > $o ).

tff(pred_def_82929,type,
    v138707: state_type > $o ).

tff(pred_def_82930,type,
    v138706: state_type > $o ).

tff(pred_def_82931,type,
    v138705: state_type > $o ).

tff(pred_def_82932,type,
    v138704: state_type > $o ).

tff(pred_def_82933,type,
    v138703: state_type > $o ).

tff(pred_def_82934,type,
    v138702: state_type > $o ).

tff(pred_def_82935,type,
    v138701: state_type > $o ).

tff(pred_def_82936,type,
    v138700: state_type > $o ).

tff(pred_def_82937,type,
    v138699: state_type > $o ).

tff(pred_def_82938,type,
    v138697: state_type > $o ).

tff(pred_def_82939,type,
    v138714: state_type > $o ).

tff(pred_def_82940,type,
    v138696: state_type > $o ).

tff(pred_def_82941,type,
    v138717: state_type > $o ).

tff(pred_def_82942,type,
    v138725: state_type > $o ).

tff(pred_def_82943,type,
    v138724: state_type > $o ).

tff(pred_def_82944,type,
    v138726: state_type > $o ).

tff(pred_def_82945,type,
    v138723: state_type > $o ).

tff(pred_def_82946,type,
    v138722: state_type > $o ).

tff(pred_def_82947,type,
    v138730: state_type > $o ).

tff(pred_def_82948,type,
    v138729: state_type > $o ).

tff(pred_def_82949,type,
    v138731: state_type > $o ).

tff(pred_def_82950,type,
    v138728: state_type > $o ).

tff(pred_def_82951,type,
    v138727: state_type > $o ).

tff(pred_def_82952,type,
    v138721: state_type > $o ).

tff(pred_def_82953,type,
    v138735: state_type > $o ).

tff(pred_def_82954,type,
    v138734: state_type > $o ).

tff(pred_def_82955,type,
    v138736: state_type > $o ).

tff(pred_def_82956,type,
    v138733: state_type > $o ).

tff(pred_def_82957,type,
    v138732: state_type > $o ).

tff(pred_def_82958,type,
    v138720: state_type > $o ).

tff(pred_def_82959,type,
    v138718: state_type > $o ).

tff(pred_def_82960,type,
    v138716: state_type > $o ).

tff(pred_def_82961,type,
    v138738: ( state_type * $int ) > $o ).

tff(pred_def_82962,type,
    v138737: state_type > $o ).

tff(pred_def_82963,type,
    v138715: state_type > $o ).

tff(pred_def_82964,type,
    v138750: state_type > $o ).

tff(pred_def_82965,type,
    v138751: state_type > $o ).

tff(pred_def_82966,type,
    v138752: state_type > $o ).

tff(pred_def_82967,type,
    v138753: state_type > $o ).

tff(pred_def_82968,type,
    v138754: state_type > $o ).

tff(pred_def_82969,type,
    v138755: state_type > $o ).

tff(pred_def_82970,type,
    v138756: state_type > $o ).

tff(pred_def_82971,type,
    v138757: state_type > $o ).

tff(pred_def_82972,type,
    v138758: state_type > $o ).

tff(pred_def_82973,type,
    v138759: state_type > $o ).

tff(pred_def_82974,type,
    v138760: state_type > $o ).

tff(pred_def_82975,type,
    v138761: state_type > $o ).

tff(pred_def_82976,type,
    v138762: state_type > $o ).

tff(pred_def_82977,type,
    v138763: state_type > $o ).

tff(pred_def_82978,type,
    v138764: state_type > $o ).

tff(pred_def_82979,type,
    v138765: state_type > $o ).

tff(pred_def_82980,type,
    v138748: ( state_type * $int ) > $o ).

tff(pred_def_82981,type,
    v138782: ( state_type * $int ) > $o ).

tff(pred_def_82982,type,
    v138781: state_type > $o ).

tff(pred_def_82983,type,
    v138780: state_type > $o ).

tff(pred_def_82984,type,
    v138779: state_type > $o ).

tff(pred_def_82985,type,
    v138778: state_type > $o ).

tff(pred_def_82986,type,
    v138777: state_type > $o ).

tff(pred_def_82987,type,
    v138776: state_type > $o ).

tff(pred_def_82988,type,
    v138775: state_type > $o ).

tff(pred_def_82989,type,
    v138774: state_type > $o ).

tff(pred_def_82990,type,
    v138773: state_type > $o ).

tff(pred_def_82991,type,
    v138772: state_type > $o ).

tff(pred_def_82992,type,
    v138771: state_type > $o ).

tff(pred_def_82993,type,
    v138770: state_type > $o ).

tff(pred_def_82994,type,
    v138769: state_type > $o ).

tff(pred_def_82995,type,
    v138768: state_type > $o ).

tff(pred_def_82996,type,
    v138746: state_type > $o ).

tff(pred_def_82997,type,
    v138787: state_type > $o ).

tff(pred_def_82998,type,
    v138786: state_type > $o ).

tff(pred_def_82999,type,
    v138785: ( state_type * $int ) > $o ).

tff(pred_def_83000,type,
    v138784: ( state_type * $int ) > $o ).

tff(pred_def_83001,type,
    v138801: state_type > $o ).

tff(pred_def_83002,type,
    v138800: state_type > $o ).

tff(pred_def_83003,type,
    v138802: state_type > $o ).

tff(pred_def_83004,type,
    v138799: state_type > $o ).

tff(pred_def_83005,type,
    v138798: state_type > $o ).

tff(pred_def_83006,type,
    v138806: state_type > $o ).

tff(pred_def_83007,type,
    v138805: state_type > $o ).

tff(pred_def_83008,type,
    v138807: state_type > $o ).

tff(pred_def_83009,type,
    v138804: state_type > $o ).

tff(pred_def_83010,type,
    v138803: state_type > $o ).

tff(pred_def_83011,type,
    v138797: state_type > $o ).

tff(pred_def_83012,type,
    v138811: state_type > $o ).

tff(pred_def_83013,type,
    v138810: state_type > $o ).

tff(pred_def_83014,type,
    v138812: state_type > $o ).

tff(pred_def_83015,type,
    v138809: state_type > $o ).

tff(pred_def_83016,type,
    v138808: state_type > $o ).

tff(pred_def_83017,type,
    v138796: state_type > $o ).

tff(pred_def_83018,type,
    v138816: state_type > $o ).

tff(pred_def_83019,type,
    v138815: state_type > $o ).

tff(pred_def_83020,type,
    v138817: state_type > $o ).

tff(pred_def_83021,type,
    v138814: state_type > $o ).

tff(pred_def_83022,type,
    v138813: state_type > $o ).

tff(pred_def_83023,type,
    v138795: state_type > $o ).

tff(pred_def_83024,type,
    v138793: state_type > $o ).

tff(pred_def_83025,type,
    v138818: state_type > $o ).

tff(pred_def_83026,type,
    v138792: state_type > $o ).

tff(pred_def_83027,type,
    v138819: state_type > $o ).

tff(pred_def_83028,type,
    v138791: state_type > $o ).

tff(pred_def_83029,type,
    v138790: state_type > $o ).

tff(pred_def_83030,type,
    v138789: state_type > $o ).

tff(pred_def_83031,type,
    v138788: ( state_type * $int ) > $o ).

tff(pred_def_83032,type,
    v138744: ( state_type * $int ) > $o ).

tff(pred_def_83033,type,
    v138742: ( state_type * $int ) > $o ).

tff(pred_def_83034,type,
    v138740: ( state_type * $int ) > $o ).

tff(pred_def_83035,type,
    v138825: ( state_type * $int ) > $o ).

tff(pred_def_83036,type,
    v138823: ( state_type * $int ) > $o ).

tff(pred_def_83037,type,
    v138821: ( state_type * $int ) > $o ).

tff(pred_def_83038,type,
    v138831: state_type > $o ).

tff(pred_def_83039,type,
    v138829: state_type > $o ).

tff(pred_def_83040,type,
    v138827: state_type > $o ).

tff(pred_def_83041,type,
    v138850: ( state_type * $int ) > $o ).

tff(pred_def_83042,type,
    v138849: state_type > $o ).

tff(pred_def_83043,type,
    v138848: state_type > $o ).

tff(pred_def_83044,type,
    v138847: state_type > $o ).

tff(pred_def_83045,type,
    v138846: state_type > $o ).

tff(pred_def_83046,type,
    v138845: state_type > $o ).

tff(pred_def_83047,type,
    v138844: state_type > $o ).

tff(pred_def_83048,type,
    v138843: state_type > $o ).

tff(pred_def_83049,type,
    v138842: state_type > $o ).

tff(pred_def_83050,type,
    v138841: state_type > $o ).

tff(pred_def_83051,type,
    v138840: state_type > $o ).

tff(pred_def_83052,type,
    v138839: state_type > $o ).

tff(pred_def_83053,type,
    v138838: state_type > $o ).

tff(pred_def_83054,type,
    v138837: state_type > $o ).

tff(pred_def_83055,type,
    v138836: state_type > $o ).

tff(pred_def_83056,type,
    v138834: state_type > $o ).

tff(pred_def_83057,type,
    v138851: state_type > $o ).

tff(pred_def_83058,type,
    v138833: state_type > $o ).

tff(pred_def_83059,type,
    v138854: state_type > $o ).

tff(pred_def_83060,type,
    v138862: state_type > $o ).

tff(pred_def_83061,type,
    v138861: state_type > $o ).

tff(pred_def_83062,type,
    v138863: state_type > $o ).

tff(pred_def_83063,type,
    v138860: state_type > $o ).

tff(pred_def_83064,type,
    v138859: state_type > $o ).

tff(pred_def_83065,type,
    v138867: state_type > $o ).

tff(pred_def_83066,type,
    v138866: state_type > $o ).

tff(pred_def_83067,type,
    v138868: state_type > $o ).

tff(pred_def_83068,type,
    v138865: state_type > $o ).

tff(pred_def_83069,type,
    v138864: state_type > $o ).

tff(pred_def_83070,type,
    v138858: state_type > $o ).

tff(pred_def_83071,type,
    v138872: state_type > $o ).

tff(pred_def_83072,type,
    v138871: state_type > $o ).

tff(pred_def_83073,type,
    v138873: state_type > $o ).

tff(pred_def_83074,type,
    v138870: state_type > $o ).

tff(pred_def_83075,type,
    v138869: state_type > $o ).

tff(pred_def_83076,type,
    v138857: state_type > $o ).

tff(pred_def_83077,type,
    v138855: state_type > $o ).

tff(pred_def_83078,type,
    v138853: state_type > $o ).

tff(pred_def_83079,type,
    v138875: ( state_type * $int ) > $o ).

tff(pred_def_83080,type,
    v138874: state_type > $o ).

tff(pred_def_83081,type,
    v138852: state_type > $o ).

tff(pred_def_83082,type,
    v138887: state_type > $o ).

tff(pred_def_83083,type,
    v138888: state_type > $o ).

tff(pred_def_83084,type,
    v138889: state_type > $o ).

tff(pred_def_83085,type,
    v138890: state_type > $o ).

tff(pred_def_83086,type,
    v138891: state_type > $o ).

tff(pred_def_83087,type,
    v138892: state_type > $o ).

tff(pred_def_83088,type,
    v138893: state_type > $o ).

tff(pred_def_83089,type,
    v138894: state_type > $o ).

tff(pred_def_83090,type,
    v138895: state_type > $o ).

tff(pred_def_83091,type,
    v138896: state_type > $o ).

tff(pred_def_83092,type,
    v138897: state_type > $o ).

tff(pred_def_83093,type,
    v138898: state_type > $o ).

tff(pred_def_83094,type,
    v138899: state_type > $o ).

tff(pred_def_83095,type,
    v138900: state_type > $o ).

tff(pred_def_83096,type,
    v138901: state_type > $o ).

tff(pred_def_83097,type,
    v138902: state_type > $o ).

tff(pred_def_83098,type,
    v138885: ( state_type * $int ) > $o ).

tff(pred_def_83099,type,
    v138919: ( state_type * $int ) > $o ).

tff(pred_def_83100,type,
    v138918: state_type > $o ).

tff(pred_def_83101,type,
    v138917: state_type > $o ).

tff(pred_def_83102,type,
    v138916: state_type > $o ).

tff(pred_def_83103,type,
    v138915: state_type > $o ).

tff(pred_def_83104,type,
    v138914: state_type > $o ).

tff(pred_def_83105,type,
    v138913: state_type > $o ).

tff(pred_def_83106,type,
    v138912: state_type > $o ).

tff(pred_def_83107,type,
    v138911: state_type > $o ).

tff(pred_def_83108,type,
    v138910: state_type > $o ).

tff(pred_def_83109,type,
    v138909: state_type > $o ).

tff(pred_def_83110,type,
    v138908: state_type > $o ).

tff(pred_def_83111,type,
    v138907: state_type > $o ).

tff(pred_def_83112,type,
    v138906: state_type > $o ).

tff(pred_def_83113,type,
    v138905: state_type > $o ).

tff(pred_def_83114,type,
    v138883: state_type > $o ).

tff(pred_def_83115,type,
    v138924: state_type > $o ).

tff(pred_def_83116,type,
    v138923: state_type > $o ).

tff(pred_def_83117,type,
    v138922: ( state_type * $int ) > $o ).

tff(pred_def_83118,type,
    v138921: ( state_type * $int ) > $o ).

tff(pred_def_83119,type,
    v138938: state_type > $o ).

tff(pred_def_83120,type,
    v138937: state_type > $o ).

tff(pred_def_83121,type,
    v138939: state_type > $o ).

tff(pred_def_83122,type,
    v138936: state_type > $o ).

tff(pred_def_83123,type,
    v138935: state_type > $o ).

tff(pred_def_83124,type,
    v138943: state_type > $o ).

tff(pred_def_83125,type,
    v138942: state_type > $o ).

tff(pred_def_83126,type,
    v138944: state_type > $o ).

tff(pred_def_83127,type,
    v138941: state_type > $o ).

tff(pred_def_83128,type,
    v138940: state_type > $o ).

tff(pred_def_83129,type,
    v138934: state_type > $o ).

tff(pred_def_83130,type,
    v138948: state_type > $o ).

tff(pred_def_83131,type,
    v138947: state_type > $o ).

tff(pred_def_83132,type,
    v138949: state_type > $o ).

tff(pred_def_83133,type,
    v138946: state_type > $o ).

tff(pred_def_83134,type,
    v138945: state_type > $o ).

tff(pred_def_83135,type,
    v138933: state_type > $o ).

tff(pred_def_83136,type,
    v138953: state_type > $o ).

tff(pred_def_83137,type,
    v138952: state_type > $o ).

tff(pred_def_83138,type,
    v138954: state_type > $o ).

tff(pred_def_83139,type,
    v138951: state_type > $o ).

tff(pred_def_83140,type,
    v138950: state_type > $o ).

tff(pred_def_83141,type,
    v138932: state_type > $o ).

tff(pred_def_83142,type,
    v138930: state_type > $o ).

tff(pred_def_83143,type,
    v138955: state_type > $o ).

tff(pred_def_83144,type,
    v138929: state_type > $o ).

tff(pred_def_83145,type,
    v138956: state_type > $o ).

tff(pred_def_83146,type,
    v138928: state_type > $o ).

tff(pred_def_83147,type,
    v138927: state_type > $o ).

tff(pred_def_83148,type,
    v138926: state_type > $o ).

tff(pred_def_83149,type,
    v138925: ( state_type * $int ) > $o ).

tff(pred_def_83150,type,
    v138881: ( state_type * $int ) > $o ).

tff(pred_def_83151,type,
    v138879: ( state_type * $int ) > $o ).

tff(pred_def_83152,type,
    v138877: ( state_type * $int ) > $o ).

tff(pred_def_83153,type,
    v138962: ( state_type * $int ) > $o ).

tff(pred_def_83154,type,
    v138960: ( state_type * $int ) > $o ).

tff(pred_def_83155,type,
    v138958: ( state_type * $int ) > $o ).

tff(pred_def_83156,type,
    v138968: state_type > $o ).

tff(pred_def_83157,type,
    v138966: state_type > $o ).

tff(pred_def_83158,type,
    v138964: state_type > $o ).

tff(pred_def_83159,type,
    v138987: ( state_type * $int ) > $o ).

tff(pred_def_83160,type,
    v138986: state_type > $o ).

tff(pred_def_83161,type,
    v138985: state_type > $o ).

tff(pred_def_83162,type,
    v138984: state_type > $o ).

tff(pred_def_83163,type,
    v138983: state_type > $o ).

tff(pred_def_83164,type,
    v138982: state_type > $o ).

tff(pred_def_83165,type,
    v138981: state_type > $o ).

tff(pred_def_83166,type,
    v138980: state_type > $o ).

tff(pred_def_83167,type,
    v138979: state_type > $o ).

tff(pred_def_83168,type,
    v138978: state_type > $o ).

tff(pred_def_83169,type,
    v138977: state_type > $o ).

tff(pred_def_83170,type,
    v138976: state_type > $o ).

tff(pred_def_83171,type,
    v138975: state_type > $o ).

tff(pred_def_83172,type,
    v138974: state_type > $o ).

tff(pred_def_83173,type,
    v138973: state_type > $o ).

tff(pred_def_83174,type,
    v138971: state_type > $o ).

tff(pred_def_83175,type,
    v138988: state_type > $o ).

tff(pred_def_83176,type,
    v138970: state_type > $o ).

tff(pred_def_83177,type,
    v138991: state_type > $o ).

tff(pred_def_83178,type,
    v138999: state_type > $o ).

tff(pred_def_83179,type,
    v138998: state_type > $o ).

tff(pred_def_83180,type,
    v139000: state_type > $o ).

tff(pred_def_83181,type,
    v138997: state_type > $o ).

tff(pred_def_83182,type,
    v138996: state_type > $o ).

tff(pred_def_83183,type,
    v139004: state_type > $o ).

tff(pred_def_83184,type,
    v139003: state_type > $o ).

tff(pred_def_83185,type,
    v139005: state_type > $o ).

tff(pred_def_83186,type,
    v139002: state_type > $o ).

tff(pred_def_83187,type,
    v139001: state_type > $o ).

tff(pred_def_83188,type,
    v138995: state_type > $o ).

tff(pred_def_83189,type,
    v139009: state_type > $o ).

tff(pred_def_83190,type,
    v139008: state_type > $o ).

tff(pred_def_83191,type,
    v139010: state_type > $o ).

tff(pred_def_83192,type,
    v139007: state_type > $o ).

tff(pred_def_83193,type,
    v139006: state_type > $o ).

tff(pred_def_83194,type,
    v138994: state_type > $o ).

tff(pred_def_83195,type,
    v138992: state_type > $o ).

tff(pred_def_83196,type,
    v138990: state_type > $o ).

tff(pred_def_83197,type,
    v139012: ( state_type * $int ) > $o ).

tff(pred_def_83198,type,
    v139011: state_type > $o ).

tff(pred_def_83199,type,
    v138989: state_type > $o ).

tff(pred_def_83200,type,
    v139024: state_type > $o ).

tff(pred_def_83201,type,
    v139025: state_type > $o ).

tff(pred_def_83202,type,
    v139026: state_type > $o ).

tff(pred_def_83203,type,
    v139027: state_type > $o ).

tff(pred_def_83204,type,
    v139028: state_type > $o ).

tff(pred_def_83205,type,
    v139029: state_type > $o ).

tff(pred_def_83206,type,
    v139030: state_type > $o ).

tff(pred_def_83207,type,
    v139031: state_type > $o ).

tff(pred_def_83208,type,
    v139032: state_type > $o ).

tff(pred_def_83209,type,
    v139033: state_type > $o ).

tff(pred_def_83210,type,
    v139034: state_type > $o ).

tff(pred_def_83211,type,
    v139035: state_type > $o ).

tff(pred_def_83212,type,
    v139036: state_type > $o ).

tff(pred_def_83213,type,
    v139037: state_type > $o ).

tff(pred_def_83214,type,
    v139038: state_type > $o ).

tff(pred_def_83215,type,
    v139039: state_type > $o ).

tff(pred_def_83216,type,
    v139022: ( state_type * $int ) > $o ).

tff(pred_def_83217,type,
    v139056: ( state_type * $int ) > $o ).

tff(pred_def_83218,type,
    v139055: state_type > $o ).

tff(pred_def_83219,type,
    v139054: state_type > $o ).

tff(pred_def_83220,type,
    v139053: state_type > $o ).

tff(pred_def_83221,type,
    v139052: state_type > $o ).

tff(pred_def_83222,type,
    v139051: state_type > $o ).

tff(pred_def_83223,type,
    v139050: state_type > $o ).

tff(pred_def_83224,type,
    v139049: state_type > $o ).

tff(pred_def_83225,type,
    v139048: state_type > $o ).

tff(pred_def_83226,type,
    v139047: state_type > $o ).

tff(pred_def_83227,type,
    v139046: state_type > $o ).

tff(pred_def_83228,type,
    v139045: state_type > $o ).

tff(pred_def_83229,type,
    v139044: state_type > $o ).

tff(pred_def_83230,type,
    v139043: state_type > $o ).

tff(pred_def_83231,type,
    v139042: state_type > $o ).

tff(pred_def_83232,type,
    v139020: state_type > $o ).

tff(pred_def_83233,type,
    v139061: state_type > $o ).

tff(pred_def_83234,type,
    v139060: state_type > $o ).

tff(pred_def_83235,type,
    v139059: ( state_type * $int ) > $o ).

tff(pred_def_83236,type,
    v139058: ( state_type * $int ) > $o ).

tff(pred_def_83237,type,
    v139075: state_type > $o ).

tff(pred_def_83238,type,
    v139074: state_type > $o ).

tff(pred_def_83239,type,
    v139076: state_type > $o ).

tff(pred_def_83240,type,
    v139073: state_type > $o ).

tff(pred_def_83241,type,
    v139072: state_type > $o ).

tff(pred_def_83242,type,
    v139080: state_type > $o ).

tff(pred_def_83243,type,
    v139079: state_type > $o ).

tff(pred_def_83244,type,
    v139081: state_type > $o ).

tff(pred_def_83245,type,
    v139078: state_type > $o ).

tff(pred_def_83246,type,
    v139077: state_type > $o ).

tff(pred_def_83247,type,
    v139071: state_type > $o ).

tff(pred_def_83248,type,
    v139085: state_type > $o ).

tff(pred_def_83249,type,
    v139084: state_type > $o ).

tff(pred_def_83250,type,
    v139086: state_type > $o ).

tff(pred_def_83251,type,
    v139083: state_type > $o ).

tff(pred_def_83252,type,
    v139082: state_type > $o ).

tff(pred_def_83253,type,
    v139070: state_type > $o ).

tff(pred_def_83254,type,
    v139090: state_type > $o ).

tff(pred_def_83255,type,
    v139089: state_type > $o ).

tff(pred_def_83256,type,
    v139091: state_type > $o ).

tff(pred_def_83257,type,
    v139088: state_type > $o ).

tff(pred_def_83258,type,
    v139087: state_type > $o ).

tff(pred_def_83259,type,
    v139069: state_type > $o ).

tff(pred_def_83260,type,
    v139067: state_type > $o ).

tff(pred_def_83261,type,
    v139092: state_type > $o ).

tff(pred_def_83262,type,
    v139066: state_type > $o ).

tff(pred_def_83263,type,
    v139093: state_type > $o ).

tff(pred_def_83264,type,
    v139065: state_type > $o ).

tff(pred_def_83265,type,
    v139064: state_type > $o ).

tff(pred_def_83266,type,
    v139063: state_type > $o ).

tff(pred_def_83267,type,
    v139062: ( state_type * $int ) > $o ).

tff(pred_def_83268,type,
    v139018: ( state_type * $int ) > $o ).

tff(pred_def_83269,type,
    v139016: ( state_type * $int ) > $o ).

tff(pred_def_83270,type,
    v139014: ( state_type * $int ) > $o ).

tff(pred_def_83271,type,
    v139099: ( state_type * $int ) > $o ).

tff(pred_def_83272,type,
    v139097: ( state_type * $int ) > $o ).

tff(pred_def_83273,type,
    v139095: ( state_type * $int ) > $o ).

tff(pred_def_83274,type,
    v139105: state_type > $o ).

tff(pred_def_83275,type,
    v139103: state_type > $o ).

tff(pred_def_83276,type,
    v139101: state_type > $o ).

tff(pred_def_83277,type,
    v139124: ( state_type * $int ) > $o ).

tff(pred_def_83278,type,
    v139123: state_type > $o ).

tff(pred_def_83279,type,
    v139122: state_type > $o ).

tff(pred_def_83280,type,
    v139121: state_type > $o ).

tff(pred_def_83281,type,
    v139120: state_type > $o ).

tff(pred_def_83282,type,
    v139119: state_type > $o ).

tff(pred_def_83283,type,
    v139118: state_type > $o ).

tff(pred_def_83284,type,
    v139117: state_type > $o ).

tff(pred_def_83285,type,
    v139116: state_type > $o ).

tff(pred_def_83286,type,
    v139115: state_type > $o ).

tff(pred_def_83287,type,
    v139114: state_type > $o ).

tff(pred_def_83288,type,
    v139113: state_type > $o ).

tff(pred_def_83289,type,
    v139112: state_type > $o ).

tff(pred_def_83290,type,
    v139111: state_type > $o ).

tff(pred_def_83291,type,
    v139110: state_type > $o ).

tff(pred_def_83292,type,
    v139108: state_type > $o ).

tff(pred_def_83293,type,
    v139125: state_type > $o ).

tff(pred_def_83294,type,
    v139107: state_type > $o ).

tff(pred_def_83295,type,
    v139128: state_type > $o ).

tff(pred_def_83296,type,
    v139136: state_type > $o ).

tff(pred_def_83297,type,
    v139135: state_type > $o ).

tff(pred_def_83298,type,
    v139137: state_type > $o ).

tff(pred_def_83299,type,
    v139134: state_type > $o ).

tff(pred_def_83300,type,
    v139133: state_type > $o ).

tff(pred_def_83301,type,
    v139141: state_type > $o ).

tff(pred_def_83302,type,
    v139140: state_type > $o ).

tff(pred_def_83303,type,
    v139142: state_type > $o ).

tff(pred_def_83304,type,
    v139139: state_type > $o ).

tff(pred_def_83305,type,
    v139138: state_type > $o ).

tff(pred_def_83306,type,
    v139132: state_type > $o ).

tff(pred_def_83307,type,
    v139146: state_type > $o ).

tff(pred_def_83308,type,
    v139145: state_type > $o ).

tff(pred_def_83309,type,
    v139147: state_type > $o ).

tff(pred_def_83310,type,
    v139144: state_type > $o ).

tff(pred_def_83311,type,
    v139143: state_type > $o ).

tff(pred_def_83312,type,
    v139131: state_type > $o ).

tff(pred_def_83313,type,
    v139129: state_type > $o ).

tff(pred_def_83314,type,
    v139127: state_type > $o ).

tff(pred_def_83315,type,
    v139149: ( state_type * $int ) > $o ).

tff(pred_def_83316,type,
    v139148: state_type > $o ).

tff(pred_def_83317,type,
    v139126: state_type > $o ).

tff(pred_def_83318,type,
    v139161: state_type > $o ).

tff(pred_def_83319,type,
    v139162: state_type > $o ).

tff(pred_def_83320,type,
    v139163: state_type > $o ).

tff(pred_def_83321,type,
    v139164: state_type > $o ).

tff(pred_def_83322,type,
    v139165: state_type > $o ).

tff(pred_def_83323,type,
    v139166: state_type > $o ).

tff(pred_def_83324,type,
    v139167: state_type > $o ).

tff(pred_def_83325,type,
    v139168: state_type > $o ).

tff(pred_def_83326,type,
    v139169: state_type > $o ).

tff(pred_def_83327,type,
    v139170: state_type > $o ).

tff(pred_def_83328,type,
    v139171: state_type > $o ).

tff(pred_def_83329,type,
    v139172: state_type > $o ).

tff(pred_def_83330,type,
    v139173: state_type > $o ).

tff(pred_def_83331,type,
    v139174: state_type > $o ).

tff(pred_def_83332,type,
    v139175: state_type > $o ).

tff(pred_def_83333,type,
    v139176: state_type > $o ).

tff(pred_def_83334,type,
    v139159: ( state_type * $int ) > $o ).

tff(pred_def_83335,type,
    v139193: ( state_type * $int ) > $o ).

tff(pred_def_83336,type,
    v139192: state_type > $o ).

tff(pred_def_83337,type,
    v139191: state_type > $o ).

tff(pred_def_83338,type,
    v139190: state_type > $o ).

tff(pred_def_83339,type,
    v139189: state_type > $o ).

tff(pred_def_83340,type,
    v139188: state_type > $o ).

tff(pred_def_83341,type,
    v139187: state_type > $o ).

tff(pred_def_83342,type,
    v139186: state_type > $o ).

tff(pred_def_83343,type,
    v139185: state_type > $o ).

tff(pred_def_83344,type,
    v139184: state_type > $o ).

tff(pred_def_83345,type,
    v139183: state_type > $o ).

tff(pred_def_83346,type,
    v139182: state_type > $o ).

tff(pred_def_83347,type,
    v139181: state_type > $o ).

tff(pred_def_83348,type,
    v139180: state_type > $o ).

tff(pred_def_83349,type,
    v139179: state_type > $o ).

tff(pred_def_83350,type,
    v139157: state_type > $o ).

tff(pred_def_83351,type,
    v139198: state_type > $o ).

tff(pred_def_83352,type,
    v139197: state_type > $o ).

tff(pred_def_83353,type,
    v139196: ( state_type * $int ) > $o ).

tff(pred_def_83354,type,
    v139195: ( state_type * $int ) > $o ).

tff(pred_def_83355,type,
    v139212: state_type > $o ).

tff(pred_def_83356,type,
    v139211: state_type > $o ).

tff(pred_def_83357,type,
    v139213: state_type > $o ).

tff(pred_def_83358,type,
    v139210: state_type > $o ).

tff(pred_def_83359,type,
    v139209: state_type > $o ).

tff(pred_def_83360,type,
    v139217: state_type > $o ).

tff(pred_def_83361,type,
    v139216: state_type > $o ).

tff(pred_def_83362,type,
    v139218: state_type > $o ).

tff(pred_def_83363,type,
    v139215: state_type > $o ).

tff(pred_def_83364,type,
    v139214: state_type > $o ).

tff(pred_def_83365,type,
    v139208: state_type > $o ).

tff(pred_def_83366,type,
    v139222: state_type > $o ).

tff(pred_def_83367,type,
    v139221: state_type > $o ).

tff(pred_def_83368,type,
    v139223: state_type > $o ).

tff(pred_def_83369,type,
    v139220: state_type > $o ).

tff(pred_def_83370,type,
    v139219: state_type > $o ).

tff(pred_def_83371,type,
    v139207: state_type > $o ).

tff(pred_def_83372,type,
    v139227: state_type > $o ).

tff(pred_def_83373,type,
    v139226: state_type > $o ).

tff(pred_def_83374,type,
    v139228: state_type > $o ).

tff(pred_def_83375,type,
    v139225: state_type > $o ).

tff(pred_def_83376,type,
    v139224: state_type > $o ).

tff(pred_def_83377,type,
    v139206: state_type > $o ).

tff(pred_def_83378,type,
    v139204: state_type > $o ).

tff(pred_def_83379,type,
    v139229: state_type > $o ).

tff(pred_def_83380,type,
    v139203: state_type > $o ).

tff(pred_def_83381,type,
    v139230: state_type > $o ).

tff(pred_def_83382,type,
    v139202: state_type > $o ).

tff(pred_def_83383,type,
    v139201: state_type > $o ).

tff(pred_def_83384,type,
    v139200: state_type > $o ).

tff(pred_def_83385,type,
    v139199: ( state_type * $int ) > $o ).

tff(pred_def_83386,type,
    v139155: ( state_type * $int ) > $o ).

tff(pred_def_83387,type,
    v139153: ( state_type * $int ) > $o ).

tff(pred_def_83388,type,
    v139151: ( state_type * $int ) > $o ).

tff(pred_def_83389,type,
    v139236: ( state_type * $int ) > $o ).

tff(pred_def_83390,type,
    v139234: ( state_type * $int ) > $o ).

tff(pred_def_83391,type,
    v139232: ( state_type * $int ) > $o ).

tff(pred_def_83392,type,
    v139242: state_type > $o ).

tff(pred_def_83393,type,
    v139240: state_type > $o ).

tff(pred_def_83394,type,
    v139238: state_type > $o ).

tff(pred_def_83395,type,
    v139261: ( state_type * $int ) > $o ).

tff(pred_def_83396,type,
    v139260: state_type > $o ).

tff(pred_def_83397,type,
    v139259: state_type > $o ).

tff(pred_def_83398,type,
    v139258: state_type > $o ).

tff(pred_def_83399,type,
    v139257: state_type > $o ).

tff(pred_def_83400,type,
    v139256: state_type > $o ).

tff(pred_def_83401,type,
    v139255: state_type > $o ).

tff(pred_def_83402,type,
    v139254: state_type > $o ).

tff(pred_def_83403,type,
    v139253: state_type > $o ).

tff(pred_def_83404,type,
    v139252: state_type > $o ).

tff(pred_def_83405,type,
    v139251: state_type > $o ).

tff(pred_def_83406,type,
    v139250: state_type > $o ).

tff(pred_def_83407,type,
    v139249: state_type > $o ).

tff(pred_def_83408,type,
    v139248: state_type > $o ).

tff(pred_def_83409,type,
    v139247: state_type > $o ).

tff(pred_def_83410,type,
    v139245: state_type > $o ).

tff(pred_def_83411,type,
    v139262: state_type > $o ).

tff(pred_def_83412,type,
    v139244: state_type > $o ).

tff(pred_def_83413,type,
    v139265: state_type > $o ).

tff(pred_def_83414,type,
    v139273: state_type > $o ).

tff(pred_def_83415,type,
    v139272: state_type > $o ).

tff(pred_def_83416,type,
    v139274: state_type > $o ).

tff(pred_def_83417,type,
    v139271: state_type > $o ).

tff(pred_def_83418,type,
    v139270: state_type > $o ).

tff(pred_def_83419,type,
    v139278: state_type > $o ).

tff(pred_def_83420,type,
    v139277: state_type > $o ).

tff(pred_def_83421,type,
    v139279: state_type > $o ).

tff(pred_def_83422,type,
    v139276: state_type > $o ).

tff(pred_def_83423,type,
    v139275: state_type > $o ).

tff(pred_def_83424,type,
    v139269: state_type > $o ).

tff(pred_def_83425,type,
    v139283: state_type > $o ).

tff(pred_def_83426,type,
    v139282: state_type > $o ).

tff(pred_def_83427,type,
    v139284: state_type > $o ).

tff(pred_def_83428,type,
    v139281: state_type > $o ).

tff(pred_def_83429,type,
    v139280: state_type > $o ).

tff(pred_def_83430,type,
    v139268: state_type > $o ).

tff(pred_def_83431,type,
    v139266: state_type > $o ).

tff(pred_def_83432,type,
    v139264: state_type > $o ).

tff(pred_def_83433,type,
    v139286: ( state_type * $int ) > $o ).

tff(pred_def_83434,type,
    v139285: state_type > $o ).

tff(pred_def_83435,type,
    v139263: state_type > $o ).

tff(pred_def_83436,type,
    v139290: state_type > $o ).

tff(pred_def_83437,type,
    v139289: state_type > $o ).

tff(pred_def_83438,type,
    v84903: ( state_type * $int ) > $o ).

tff(pred_def_83439,type,
    v139293: state_type > $o ).

tff(pred_def_83440,type,
    v139292: state_type > $o ).

tff(pred_def_83441,type,
    v139294: state_type > $o ).

tff(pred_def_83442,type,
    v139297: state_type > $o ).

tff(pred_def_83443,type,
    v139296: state_type > $o ).

tff(pred_def_83444,type,
    v139298: state_type > $o ).

tff(pred_def_83445,type,
    v139301: state_type > $o ).

tff(pred_def_83446,type,
    v139300: state_type > $o ).

tff(pred_def_83447,type,
    v139302: state_type > $o ).

tff(pred_def_83448,type,
    v139305: state_type > $o ).

tff(pred_def_83449,type,
    v139304: state_type > $o ).

tff(pred_def_83450,type,
    v139306: state_type > $o ).

tff(pred_def_83451,type,
    v139309: state_type > $o ).

tff(pred_def_83452,type,
    v139308: state_type > $o ).

tff(pred_def_83453,type,
    v139310: state_type > $o ).

tff(pred_def_83454,type,
    v139313: state_type > $o ).

tff(pred_def_83455,type,
    v139312: state_type > $o ).

tff(pred_def_83456,type,
    v139314: state_type > $o ).

tff(pred_def_83457,type,
    v139317: state_type > $o ).

tff(pred_def_83458,type,
    v139316: state_type > $o ).

tff(pred_def_83459,type,
    b10000000: $int > $o ).

tff(pred_def_83460,type,
    v139318: state_type > $o ).

tff(pred_def_83461,type,
    v139323: state_type > $o ).

tff(pred_def_83462,type,
    v139322: state_type > $o ).

tff(pred_def_83463,type,
    v139321: state_type > $o ).

tff(pred_def_83464,type,
    v139320: ( state_type * $int ) > $o ).

tff(pred_def_83465,type,
    v139335: state_type > $o ).

tff(pred_def_83466,type,
    v139333: state_type > $o ).

tff(pred_def_83467,type,
    v139339: state_type > $o ).

tff(pred_def_83468,type,
    v139337: state_type > $o ).

tff(pred_def_83469,type,
    v139357: state_type > $o ).

tff(pred_def_83470,type,
    v139355: state_type > $o ).

tff(pred_def_83471,type,
    v139361: state_type > $o ).

tff(pred_def_83472,type,
    v139359: state_type > $o ).

tff(pred_def_83473,type,
    b0000010001000: $int > $o ).

tff(pred_def_83474,type,
    v139373: state_type > $o ).

tff(pred_def_83475,type,
    v139372: state_type > $o ).

tff(pred_def_83476,type,
    v139387: ( state_type * $int ) > $o ).

tff(pred_def_83477,type,
    v139388: ( state_type * $int ) > $o ).

tff(pred_def_83478,type,
    v139386: state_type > $o ).

tff(pred_def_83479,type,
    v139391: state_type > $o ).

tff(pred_def_83480,type,
    v139392: state_type > $o ).

tff(pred_def_83481,type,
    v139390: state_type > $o ).

tff(pred_def_83482,type,
    v139393: state_type > $o ).

tff(pred_def_83483,type,
    v139389: state_type > $o ).

tff(pred_def_83484,type,
    v139385: state_type > $o ).

tff(pred_def_83485,type,
    v139394: state_type > $o ).

tff(pred_def_83486,type,
    v139384: state_type > $o ).

tff(pred_def_83487,type,
    v139397: state_type > $o ).

tff(pred_def_83488,type,
    v139398: state_type > $o ).

tff(pred_def_83489,type,
    v139396: state_type > $o ).

tff(pred_def_83490,type,
    v139399: state_type > $o ).

tff(pred_def_83491,type,
    v139395: state_type > $o ).

tff(pred_def_83492,type,
    v139383: state_type > $o ).

tff(pred_def_83493,type,
    v139400: state_type > $o ).

tff(pred_def_83494,type,
    v139382: state_type > $o ).

tff(pred_def_83495,type,
    v139403: state_type > $o ).

tff(pred_def_83496,type,
    v139404: state_type > $o ).

tff(pred_def_83497,type,
    v139402: state_type > $o ).

tff(pred_def_83498,type,
    v139405: state_type > $o ).

tff(pred_def_83499,type,
    v139401: state_type > $o ).

tff(pred_def_83500,type,
    v139381: state_type > $o ).

tff(pred_def_83501,type,
    v139406: state_type > $o ).

tff(pred_def_83502,type,
    v139380: state_type > $o ).

tff(pred_def_83503,type,
    v139379: state_type > $o ).

tff(pred_def_83504,type,
    v139410: state_type > $o ).

tff(pred_def_83505,type,
    v139411: state_type > $o ).

tff(pred_def_83506,type,
    v139409: state_type > $o ).

tff(pred_def_83507,type,
    v139412: state_type > $o ).

tff(pred_def_83508,type,
    v139408: state_type > $o ).

tff(pred_def_83509,type,
    v139407: state_type > $o ).

tff(pred_def_83510,type,
    v139378: state_type > $o ).

tff(pred_def_83511,type,
    v139413: state_type > $o ).

tff(pred_def_83512,type,
    v139377: state_type > $o ).

tff(pred_def_83513,type,
    v139416: state_type > $o ).

tff(pred_def_83514,type,
    v139417: state_type > $o ).

tff(pred_def_83515,type,
    v139415: state_type > $o ).

tff(pred_def_83516,type,
    v139418: state_type > $o ).

tff(pred_def_83517,type,
    v139414: state_type > $o ).

tff(pred_def_83518,type,
    v139421: state_type > $o ).

tff(pred_def_83519,type,
    v139422: state_type > $o ).

tff(pred_def_83520,type,
    v139420: state_type > $o ).

tff(pred_def_83521,type,
    v139423: state_type > $o ).

tff(pred_def_83522,type,
    v139419: state_type > $o ).

tff(pred_def_83523,type,
    v139426: state_type > $o ).

tff(pred_def_83524,type,
    v139427: state_type > $o ).

tff(pred_def_83525,type,
    v139425: state_type > $o ).

tff(pred_def_83526,type,
    v139428: state_type > $o ).

tff(pred_def_83527,type,
    v139424: state_type > $o ).

tff(pred_def_83528,type,
    v139431: state_type > $o ).

tff(pred_def_83529,type,
    v139432: state_type > $o ).

tff(pred_def_83530,type,
    v139430: state_type > $o ).

tff(pred_def_83531,type,
    v139433: state_type > $o ).

tff(pred_def_83532,type,
    v139429: state_type > $o ).

tff(pred_def_83533,type,
    v139375: ( state_type * $int ) > $o ).

tff(pred_def_83534,type,
    v139447: ( state_type * $int ) > $o ).

tff(pred_def_83535,type,
    v139448: ( state_type * $int ) > $o ).

tff(pred_def_83536,type,
    v139446: state_type > $o ).

tff(pred_def_83537,type,
    v139451: state_type > $o ).

tff(pred_def_83538,type,
    v139452: state_type > $o ).

tff(pred_def_83539,type,
    v139450: state_type > $o ).

tff(pred_def_83540,type,
    v139453: state_type > $o ).

tff(pred_def_83541,type,
    v139449: state_type > $o ).

tff(pred_def_83542,type,
    v139445: state_type > $o ).

tff(pred_def_83543,type,
    v139454: state_type > $o ).

tff(pred_def_83544,type,
    v139444: state_type > $o ).

tff(pred_def_83545,type,
    v139457: state_type > $o ).

tff(pred_def_83546,type,
    v139458: state_type > $o ).

tff(pred_def_83547,type,
    v139456: state_type > $o ).

tff(pred_def_83548,type,
    v139459: state_type > $o ).

tff(pred_def_83549,type,
    v139455: state_type > $o ).

tff(pred_def_83550,type,
    v139443: state_type > $o ).

tff(pred_def_83551,type,
    v139460: state_type > $o ).

tff(pred_def_83552,type,
    v139442: state_type > $o ).

tff(pred_def_83553,type,
    v139463: state_type > $o ).

tff(pred_def_83554,type,
    v139464: state_type > $o ).

tff(pred_def_83555,type,
    v139462: state_type > $o ).

tff(pred_def_83556,type,
    v139465: state_type > $o ).

tff(pred_def_83557,type,
    v139461: state_type > $o ).

tff(pred_def_83558,type,
    v139441: state_type > $o ).

tff(pred_def_83559,type,
    v139466: state_type > $o ).

tff(pred_def_83560,type,
    v139440: state_type > $o ).

tff(pred_def_83561,type,
    v139439: state_type > $o ).

tff(pred_def_83562,type,
    v139470: state_type > $o ).

tff(pred_def_83563,type,
    v139471: state_type > $o ).

tff(pred_def_83564,type,
    v139469: state_type > $o ).

tff(pred_def_83565,type,
    v139472: state_type > $o ).

tff(pred_def_83566,type,
    v139468: state_type > $o ).

tff(pred_def_83567,type,
    v139467: state_type > $o ).

tff(pred_def_83568,type,
    v139438: state_type > $o ).

tff(pred_def_83569,type,
    v139473: state_type > $o ).

tff(pred_def_83570,type,
    v139437: state_type > $o ).

tff(pred_def_83571,type,
    v139476: state_type > $o ).

tff(pred_def_83572,type,
    v139477: state_type > $o ).

tff(pred_def_83573,type,
    v139475: state_type > $o ).

tff(pred_def_83574,type,
    v139478: state_type > $o ).

tff(pred_def_83575,type,
    v139474: state_type > $o ).

tff(pred_def_83576,type,
    v139481: state_type > $o ).

tff(pred_def_83577,type,
    v139482: state_type > $o ).

tff(pred_def_83578,type,
    v139480: state_type > $o ).

tff(pred_def_83579,type,
    v139483: state_type > $o ).

tff(pred_def_83580,type,
    v139479: state_type > $o ).

tff(pred_def_83581,type,
    v139486: state_type > $o ).

tff(pred_def_83582,type,
    v139487: state_type > $o ).

tff(pred_def_83583,type,
    v139485: state_type > $o ).

tff(pred_def_83584,type,
    v139488: state_type > $o ).

tff(pred_def_83585,type,
    v139484: state_type > $o ).

tff(pred_def_83586,type,
    v139491: state_type > $o ).

tff(pred_def_83587,type,
    v139492: state_type > $o ).

tff(pred_def_83588,type,
    v139490: state_type > $o ).

tff(pred_def_83589,type,
    v139493: state_type > $o ).

tff(pred_def_83590,type,
    v139489: state_type > $o ).

tff(pred_def_83591,type,
    v139435: ( state_type * $int ) > $o ).

tff(pred_def_83592,type,
    v139434: ( state_type * $int ) > $o ).

tff(pred_def_83593,type,
    v139349: ( state_type * $int ) > $o ).

tff(pred_def_83594,type,
    v139374: ( state_type * $int ) > $o ).

tff(pred_def_83595,type,
    v139371: ( state_type * $int ) > $o ).

tff(pred_def_83596,type,
    v139369: ( state_type * $int ) > $o ).

tff(pred_def_83597,type,
    v139494: ( state_type * $int ) > $o ).

tff(pred_def_83598,type,
    v139495: ( state_type * $int ) > $o ).

tff(pred_def_83599,type,
    v139367: ( state_type * $int ) > $o ).

tff(pred_def_83600,type,
    v139501: state_type > $o ).

tff(pred_def_83601,type,
    v139503: state_type > $o ).

tff(pred_def_83602,type,
    v139502: state_type > $o ).

tff(pred_def_83603,type,
    v139499: state_type > $o ).

tff(pred_def_83604,type,
    v139497: state_type > $o ).

tff(pred_def_83605,type,
    v139507: state_type > $o ).

tff(pred_def_83606,type,
    v139506: ( state_type * $int ) > $o ).

tff(pred_def_83607,type,
    v139505: ( state_type * $int ) > $o ).

tff(pred_def_83608,type,
    v139511: state_type > $o ).

tff(pred_def_83609,type,
    v139510: ( state_type * $int ) > $o ).

tff(pred_def_83610,type,
    v139509: ( state_type * $int ) > $o ).

tff(pred_def_83611,type,
    v139351: ( state_type * $int ) > $o ).

tff(pred_def_83612,type,
    v139508: ( state_type * $int ) > $o ).

tff(pred_def_83613,type,
    v139504: ( state_type * $int ) > $o ).

tff(pred_def_83614,type,
    v139365: ( state_type * $int ) > $o ).

tff(pred_def_83615,type,
    v139363: ( state_type * $int ) > $o ).

tff(pred_def_83616,type,
    v139515: state_type > $o ).

tff(pred_def_83617,type,
    v139513: state_type > $o ).

tff(pred_def_83618,type,
    v139522: state_type > $o ).

tff(pred_def_83619,type,
    v139520: state_type > $o ).

tff(pred_def_83620,type,
    v139519: state_type > $o ).

tff(pred_def_83621,type,
    v139518: state_type > $o ).

tff(pred_def_83622,type,
    v139530: state_type > $o ).

tff(pred_def_83623,type,
    v139531: state_type > $o ).

tff(pred_def_83624,type,
    v139529: state_type > $o ).

tff(pred_def_83625,type,
    v139526: ( state_type * $int ) > $o ).

tff(pred_def_83626,type,
    v139528: ( state_type * $int ) > $o ).

tff(pred_def_83627,type,
    v139517: ( state_type * $int ) > $o ).

tff(pred_def_83628,type,
    v139353: ( state_type * $int ) > $o ).

tff(pred_def_83629,type,
    v139539: state_type > $o ).

tff(pred_def_83630,type,
    v139537: state_type > $o ).

tff(pred_def_83631,type,
    v139536: state_type > $o ).

tff(pred_def_83632,type,
    v139535: ( state_type * $int ) > $o ).

tff(pred_def_83633,type,
    v139551: state_type > $o ).

tff(pred_def_83634,type,
    v139549: state_type > $o ).

tff(pred_def_83635,type,
    v139548: state_type > $o ).

tff(pred_def_83636,type,
    v139547: ( state_type * $int ) > $o ).

tff(pred_def_83637,type,
    v139543: ( state_type * $int ) > $o ).

tff(pred_def_83638,type,
    v139557: state_type > $o ).

tff(pred_def_83639,type,
    v139566: state_type > $o ).

tff(pred_def_83640,type,
    v139567: state_type > $o ).

tff(pred_def_83641,type,
    v139565: state_type > $o ).

tff(pred_def_83642,type,
    v139568: state_type > $o ).

tff(pred_def_83643,type,
    v139564: state_type > $o ).

tff(pred_def_83644,type,
    v139569: state_type > $o ).

tff(pred_def_83645,type,
    v139563: state_type > $o ).

tff(pred_def_83646,type,
    v139570: state_type > $o ).

tff(pred_def_83647,type,
    v139562: state_type > $o ).

tff(pred_def_83648,type,
    v139571: state_type > $o ).

tff(pred_def_83649,type,
    v139561: state_type > $o ).

tff(pred_def_83650,type,
    v139327: ( state_type * $int ) > $o ).

tff(pred_def_83651,type,
    v139585: state_type > $o ).

tff(pred_def_83652,type,
    v139595: state_type > $o ).

tff(pred_def_83653,type,
    v139594: state_type > $o ).

tff(pred_def_83654,type,
    v139593: state_type > $o ).

tff(pred_def_83655,type,
    v139596: state_type > $o ).

tff(pred_def_83656,type,
    v139592: state_type > $o ).

tff(pred_def_83657,type,
    v139591: state_type > $o ).

tff(pred_def_83658,type,
    v139590: state_type > $o ).

tff(pred_def_83659,type,
    v139589: state_type > $o ).

tff(pred_def_83660,type,
    v139598: state_type > $o ).

tff(pred_def_83661,type,
    v139597: state_type > $o ).

tff(pred_def_83662,type,
    v139588: state_type > $o ).

tff(pred_def_83663,type,
    v139601: state_type > $o ).

tff(pred_def_83664,type,
    v139600: state_type > $o ).

tff(pred_def_83665,type,
    v139602: state_type > $o ).

tff(pred_def_83666,type,
    v139599: state_type > $o ).

tff(pred_def_83667,type,
    v139605: state_type > $o ).

tff(pred_def_83668,type,
    v139604: state_type > $o ).

tff(pred_def_83669,type,
    v139606: state_type > $o ).

tff(pred_def_83670,type,
    v139603: state_type > $o ).

tff(pred_def_83671,type,
    v139586: ( state_type * $int ) > $o ).

tff(pred_def_83672,type,
    v139584: state_type > $o ).

tff(pred_def_83673,type,
    v139610: state_type > $o ).

tff(pred_def_83674,type,
    v139611: state_type > $o ).

tff(pred_def_83675,type,
    v139609: state_type > $o ).

tff(pred_def_83676,type,
    v139612: state_type > $o ).

tff(pred_def_83677,type,
    v139608: state_type > $o ).

tff(pred_def_83678,type,
    v139607: state_type > $o ).

tff(pred_def_83679,type,
    v139583: state_type > $o ).

tff(pred_def_83680,type,
    v139613: state_type > $o ).

tff(pred_def_83681,type,
    v139582: state_type > $o ).

tff(pred_def_83682,type,
    v139617: state_type > $o ).

tff(pred_def_83683,type,
    v139618: state_type > $o ).

tff(pred_def_83684,type,
    v139616: state_type > $o ).

tff(pred_def_83685,type,
    v139619: state_type > $o ).

tff(pred_def_83686,type,
    v139615: state_type > $o ).

tff(pred_def_83687,type,
    v139614: state_type > $o ).

tff(pred_def_83688,type,
    v139581: state_type > $o ).

tff(pred_def_83689,type,
    v139620: state_type > $o ).

tff(pred_def_83690,type,
    v139580: state_type > $o ).

tff(pred_def_83691,type,
    v139624: state_type > $o ).

tff(pred_def_83692,type,
    v139625: state_type > $o ).

tff(pred_def_83693,type,
    v139623: state_type > $o ).

tff(pred_def_83694,type,
    v139626: state_type > $o ).

tff(pred_def_83695,type,
    v139622: state_type > $o ).

tff(pred_def_83696,type,
    v139621: state_type > $o ).

tff(pred_def_83697,type,
    v139579: state_type > $o ).

tff(pred_def_83698,type,
    v139627: state_type > $o ).

tff(pred_def_83699,type,
    v139578: state_type > $o ).

tff(pred_def_83700,type,
    v139631: state_type > $o ).

tff(pred_def_83701,type,
    v139632: state_type > $o ).

tff(pred_def_83702,type,
    v139630: state_type > $o ).

tff(pred_def_83703,type,
    v139633: state_type > $o ).

tff(pred_def_83704,type,
    v139629: state_type > $o ).

tff(pred_def_83705,type,
    v139628: state_type > $o ).

tff(pred_def_83706,type,
    v139577: state_type > $o ).

tff(pred_def_83707,type,
    v139634: state_type > $o ).

tff(pred_def_83708,type,
    v139576: state_type > $o ).

tff(pred_def_83709,type,
    v139574: state_type > $o ).

tff(pred_def_83710,type,
    v139655: state_type > $o ).

tff(pred_def_83711,type,
    v139654: state_type > $o ).

tff(pred_def_83712,type,
    v139653: state_type > $o ).

tff(pred_def_83713,type,
    v139656: state_type > $o ).

tff(pred_def_83714,type,
    v139652: state_type > $o ).

tff(pred_def_83715,type,
    v139651: state_type > $o ).

tff(pred_def_83716,type,
    v139650: state_type > $o ).

tff(pred_def_83717,type,
    v139649: state_type > $o ).

tff(pred_def_83718,type,
    v139658: state_type > $o ).

tff(pred_def_83719,type,
    v139657: state_type > $o ).

tff(pred_def_83720,type,
    v139648: state_type > $o ).

tff(pred_def_83721,type,
    v139661: state_type > $o ).

tff(pred_def_83722,type,
    v139660: state_type > $o ).

tff(pred_def_83723,type,
    v139662: state_type > $o ).

tff(pred_def_83724,type,
    v139659: state_type > $o ).

tff(pred_def_83725,type,
    v139665: state_type > $o ).

tff(pred_def_83726,type,
    v139664: state_type > $o ).

tff(pred_def_83727,type,
    v139666: state_type > $o ).

tff(pred_def_83728,type,
    v139663: state_type > $o ).

tff(pred_def_83729,type,
    v139646: ( state_type * $int ) > $o ).

tff(pred_def_83730,type,
    v139645: state_type > $o ).

tff(pred_def_83731,type,
    v139670: state_type > $o ).

tff(pred_def_83732,type,
    v139669: state_type > $o ).

tff(pred_def_83733,type,
    v139671: state_type > $o ).

tff(pred_def_83734,type,
    v139668: state_type > $o ).

tff(pred_def_83735,type,
    v139667: state_type > $o ).

tff(pred_def_83736,type,
    v139644: state_type > $o ).

tff(pred_def_83737,type,
    v139672: state_type > $o ).

tff(pred_def_83738,type,
    v139643: state_type > $o ).

tff(pred_def_83739,type,
    v139676: state_type > $o ).

tff(pred_def_83740,type,
    v139675: state_type > $o ).

tff(pred_def_83741,type,
    v139677: state_type > $o ).

tff(pred_def_83742,type,
    v139674: state_type > $o ).

tff(pred_def_83743,type,
    v139673: state_type > $o ).

tff(pred_def_83744,type,
    v139642: state_type > $o ).

tff(pred_def_83745,type,
    v139678: state_type > $o ).

tff(pred_def_83746,type,
    v139641: state_type > $o ).

tff(pred_def_83747,type,
    v139682: state_type > $o ).

tff(pred_def_83748,type,
    v139681: state_type > $o ).

tff(pred_def_83749,type,
    v139683: state_type > $o ).

tff(pred_def_83750,type,
    v139680: state_type > $o ).

tff(pred_def_83751,type,
    v139679: state_type > $o ).

tff(pred_def_83752,type,
    v139640: state_type > $o ).

tff(pred_def_83753,type,
    v139684: state_type > $o ).

tff(pred_def_83754,type,
    v139639: state_type > $o ).

tff(pred_def_83755,type,
    v139688: state_type > $o ).

tff(pred_def_83756,type,
    v139687: state_type > $o ).

tff(pred_def_83757,type,
    v139689: state_type > $o ).

tff(pred_def_83758,type,
    v139686: state_type > $o ).

tff(pred_def_83759,type,
    v139685: state_type > $o ).

tff(pred_def_83760,type,
    v139638: state_type > $o ).

tff(pred_def_83761,type,
    v139690: state_type > $o ).

tff(pred_def_83762,type,
    v139637: state_type > $o ).

tff(pred_def_83763,type,
    v139635: state_type > $o ).

tff(pred_def_83764,type,
    v139573: state_type > $o ).

tff(pred_def_83765,type,
    v139711: state_type > $o ).

tff(pred_def_83766,type,
    v139710: state_type > $o ).

tff(pred_def_83767,type,
    v139709: state_type > $o ).

tff(pred_def_83768,type,
    v139712: state_type > $o ).

tff(pred_def_83769,type,
    v139708: state_type > $o ).

tff(pred_def_83770,type,
    v139707: state_type > $o ).

tff(pred_def_83771,type,
    v139706: state_type > $o ).

tff(pred_def_83772,type,
    v139705: state_type > $o ).

tff(pred_def_83773,type,
    v139714: state_type > $o ).

tff(pred_def_83774,type,
    v139713: state_type > $o ).

tff(pred_def_83775,type,
    v139704: state_type > $o ).

tff(pred_def_83776,type,
    v139717: state_type > $o ).

tff(pred_def_83777,type,
    v139716: state_type > $o ).

tff(pred_def_83778,type,
    v139718: state_type > $o ).

tff(pred_def_83779,type,
    v139715: state_type > $o ).

tff(pred_def_83780,type,
    v139721: state_type > $o ).

tff(pred_def_83781,type,
    v139720: state_type > $o ).

tff(pred_def_83782,type,
    v139722: state_type > $o ).

tff(pred_def_83783,type,
    v139719: state_type > $o ).

tff(pred_def_83784,type,
    v139702: ( state_type * $int ) > $o ).

tff(pred_def_83785,type,
    v139701: state_type > $o ).

tff(pred_def_83786,type,
    v139726: state_type > $o ).

tff(pred_def_83787,type,
    v139725: state_type > $o ).

tff(pred_def_83788,type,
    v139727: state_type > $o ).

tff(pred_def_83789,type,
    v139724: state_type > $o ).

tff(pred_def_83790,type,
    v139723: state_type > $o ).

tff(pred_def_83791,type,
    v139700: state_type > $o ).

tff(pred_def_83792,type,
    v139728: state_type > $o ).

tff(pred_def_83793,type,
    v139699: state_type > $o ).

tff(pred_def_83794,type,
    v139732: state_type > $o ).

tff(pred_def_83795,type,
    v139731: state_type > $o ).

tff(pred_def_83796,type,
    v139733: state_type > $o ).

tff(pred_def_83797,type,
    v139730: state_type > $o ).

tff(pred_def_83798,type,
    v139729: state_type > $o ).

tff(pred_def_83799,type,
    v139698: state_type > $o ).

tff(pred_def_83800,type,
    v139734: state_type > $o ).

tff(pred_def_83801,type,
    v139697: state_type > $o ).

tff(pred_def_83802,type,
    v139738: state_type > $o ).

tff(pred_def_83803,type,
    v139737: state_type > $o ).

tff(pred_def_83804,type,
    v139739: state_type > $o ).

tff(pred_def_83805,type,
    v139736: state_type > $o ).

tff(pred_def_83806,type,
    v139735: state_type > $o ).

tff(pred_def_83807,type,
    v139696: state_type > $o ).

tff(pred_def_83808,type,
    v139740: state_type > $o ).

tff(pred_def_83809,type,
    v139695: state_type > $o ).

tff(pred_def_83810,type,
    v139744: state_type > $o ).

tff(pred_def_83811,type,
    v139743: state_type > $o ).

tff(pred_def_83812,type,
    v139745: state_type > $o ).

tff(pred_def_83813,type,
    v139742: state_type > $o ).

tff(pred_def_83814,type,
    v139741: state_type > $o ).

tff(pred_def_83815,type,
    v139694: state_type > $o ).

tff(pred_def_83816,type,
    v139746: state_type > $o ).

tff(pred_def_83817,type,
    v139693: state_type > $o ).

tff(pred_def_83818,type,
    v139691: state_type > $o ).

tff(pred_def_83819,type,
    v139572: state_type > $o ).

tff(pred_def_83820,type,
    v139560: state_type > $o ).

tff(pred_def_83821,type,
    v139747: state_type > $o ).

tff(pred_def_83822,type,
    v139559: state_type > $o ).

tff(pred_def_83823,type,
    v139748: state_type > $o ).

tff(pred_def_83824,type,
    v139558: state_type > $o ).

tff(pred_def_83825,type,
    v139556: state_type > $o ).

tff(pred_def_83826,type,
    v139758: state_type > $o ).

tff(pred_def_83827,type,
    v139757: state_type > $o ).

tff(pred_def_83828,type,
    v139756: state_type > $o ).

tff(pred_def_83829,type,
    v139755: state_type > $o ).

tff(pred_def_83830,type,
    v139754: state_type > $o ).

tff(pred_def_83831,type,
    v139759: state_type > $o ).

tff(pred_def_83832,type,
    v139753: state_type > $o ).

tff(pred_def_83833,type,
    v139762: state_type > $o ).

tff(pred_def_83834,type,
    v139761: state_type > $o ).

tff(pred_def_83835,type,
    v139763: state_type > $o ).

tff(pred_def_83836,type,
    v139760: state_type > $o ).

tff(pred_def_83837,type,
    v139766: state_type > $o ).

tff(pred_def_83838,type,
    v139765: state_type > $o ).

tff(pred_def_83839,type,
    v139767: state_type > $o ).

tff(pred_def_83840,type,
    v139764: state_type > $o ).

tff(pred_def_83841,type,
    v139769: state_type > $o ).

tff(pred_def_83842,type,
    v139770: state_type > $o ).

tff(pred_def_83843,type,
    v139768: state_type > $o ).

tff(pred_def_83844,type,
    v139751: ( state_type * $int ) > $o ).

tff(pred_def_83845,type,
    v139750: ( state_type * $int ) > $o ).

tff(pred_def_83846,type,
    v139749: ( state_type * $int ) > $o ).

tff(pred_def_83847,type,
    v139347: ( state_type * $int ) > $o ).

tff(pred_def_83848,type,
    v139345: ( state_type * $int ) > $o ).

tff(pred_def_83849,type,
    v139343: ( state_type * $int ) > $o ).

tff(pred_def_83850,type,
    v139341: ( state_type * $int ) > $o ).

tff(pred_def_83851,type,
    v139774: state_type > $o ).

tff(pred_def_83852,type,
    v139772: state_type > $o ).

tff(pred_def_83853,type,
    v139781: state_type > $o ).

tff(pred_def_83854,type,
    v139779: state_type > $o ).

tff(pred_def_83855,type,
    v139778: state_type > $o ).

tff(pred_def_83856,type,
    v139777: state_type > $o ).

tff(pred_def_83857,type,
    v139789: state_type > $o ).

tff(pred_def_83858,type,
    v139790: state_type > $o ).

tff(pred_def_83859,type,
    v139788: state_type > $o ).

tff(pred_def_83860,type,
    v139785: ( state_type * $int ) > $o ).

tff(pred_def_83861,type,
    v139787: ( state_type * $int ) > $o ).

tff(pred_def_83862,type,
    v139331: ( state_type * $int ) > $o ).

tff(pred_def_83863,type,
    v139329: ( state_type * $int ) > $o ).

tff(pred_def_83864,type,
    v139804: state_type > $o ).

tff(pred_def_83865,type,
    v139805: state_type > $o ).

tff(pred_def_83866,type,
    v139803: state_type > $o ).

tff(pred_def_83867,type,
    v139802: state_type > $o ).

tff(pred_def_83868,type,
    v139806: state_type > $o ).

tff(pred_def_83869,type,
    v139801: state_type > $o ).

tff(pred_def_83870,type,
    v139808: state_type > $o ).

tff(pred_def_83871,type,
    v139807: state_type > $o ).

tff(pred_def_83872,type,
    v139800: state_type > $o ).

tff(pred_def_83873,type,
    v139810: state_type > $o ).

tff(pred_def_83874,type,
    v139809: state_type > $o ).

tff(pred_def_83875,type,
    v139799: state_type > $o ).

tff(pred_def_83876,type,
    v139816: state_type > $o ).

tff(pred_def_83877,type,
    v139817: state_type > $o ).

tff(pred_def_83878,type,
    v139815: state_type > $o ).

tff(pred_def_83879,type,
    v139824: state_type > $o ).

tff(pred_def_83880,type,
    v139825: state_type > $o ).

tff(pred_def_83881,type,
    v139823: state_type > $o ).

tff(pred_def_83882,type,
    v139822: state_type > $o ).

tff(pred_def_83883,type,
    v139828: state_type > $o ).

tff(pred_def_83884,type,
    v139829: state_type > $o ).

tff(pred_def_83885,type,
    v139827: state_type > $o ).

tff(pred_def_83886,type,
    v139826: state_type > $o ).

tff(pred_def_83887,type,
    v139821: state_type > $o ).

tff(pred_def_83888,type,
    v139832: state_type > $o ).

tff(pred_def_83889,type,
    v139833: state_type > $o ).

tff(pred_def_83890,type,
    v139831: state_type > $o ).

tff(pred_def_83891,type,
    v139830: state_type > $o ).

tff(pred_def_83892,type,
    v139820: state_type > $o ).

tff(pred_def_83893,type,
    v139818: state_type > $o ).

tff(pred_def_83894,type,
    v139814: state_type > $o ).

tff(pred_def_83895,type,
    v139813: state_type > $o ).

tff(pred_def_83896,type,
    v139834: state_type > $o ).

tff(pred_def_83897,type,
    v139812: state_type > $o ).

tff(pred_def_83898,type,
    v139835: state_type > $o ).

tff(pred_def_83899,type,
    v139811: state_type > $o ).

tff(pred_def_83900,type,
    v139798: state_type > $o ).

tff(pred_def_83901,type,
    v139836: state_type > $o ).

tff(pred_def_83902,type,
    v139797: state_type > $o ).

tff(pred_def_83903,type,
    v139837: state_type > $o ).

tff(pred_def_83904,type,
    v139796: state_type > $o ).

tff(pred_def_83905,type,
    v139838: state_type > $o ).

tff(pred_def_83906,type,
    v139795: state_type > $o ).

tff(pred_def_83907,type,
    v139845: state_type > $o ).

tff(pred_def_83908,type,
    v139844: state_type > $o ).

tff(pred_def_83909,type,
    v139843: state_type > $o ).

tff(pred_def_83910,type,
    v139842: state_type > $o ).

tff(pred_def_83911,type,
    v139841: state_type > $o ).

tff(pred_def_83912,type,
    v139840: state_type > $o ).

tff(pred_def_83913,type,
    v139839: state_type > $o ).

tff(pred_def_83914,type,
    v139794: state_type > $o ).

tff(pred_def_83915,type,
    v139847: ( state_type * $int ) > $o ).

tff(pred_def_83916,type,
    v139850: ( state_type * $int ) > $o ).

tff(pred_def_83917,type,
    v139849: ( state_type * $int ) > $o ).

tff(pred_def_83918,type,
    v139848: ( state_type * $int ) > $o ).

tff(pred_def_83919,type,
    v139846: ( state_type * $int ) > $o ).

tff(pred_def_83920,type,
    v84317: ( state_type * $int ) > $o ).

tff(pred_def_83921,type,
    v84315: ( state_type * $int ) > $o ).

tff(pred_def_83922,type,
    v84313: ( state_type * $int ) > $o ).

tff(pred_def_83923,type,
    v139854: state_type > $o ).

tff(pred_def_83924,type,
    v139852: state_type > $o ).

tff(pred_def_83925,type,
    v139861: state_type > $o ).

tff(pred_def_83926,type,
    v139859: state_type > $o ).

tff(pred_def_83927,type,
    v139858: state_type > $o ).

tff(pred_def_83928,type,
    v139857: state_type > $o ).

tff(pred_def_83929,type,
    v139869: state_type > $o ).

tff(pred_def_83930,type,
    v139870: state_type > $o ).

tff(pred_def_83931,type,
    v139868: state_type > $o ).

tff(pred_def_83932,type,
    v139865: ( state_type * $int ) > $o ).

tff(pred_def_83933,type,
    v139867: ( state_type * $int ) > $o ).

tff(pred_def_83934,type,
    v84303: ( state_type * $int ) > $o ).

tff(pred_def_83935,type,
    v84301: ( state_type * $int ) > $o ).

tff(pred_def_83936,type,
    v139876: state_type > $o ).

tff(pred_def_83937,type,
    v139879: state_type > $o ).

tff(pred_def_83938,type,
    v139880: state_type > $o ).

tff(pred_def_83939,type,
    v139878: state_type > $o ).

tff(pred_def_83940,type,
    v139881: state_type > $o ).

tff(pred_def_83941,type,
    v139877: state_type > $o ).

tff(pred_def_83942,type,
    v139875: state_type > $o ).

tff(pred_def_83943,type,
    v139882: state_type > $o ).

tff(pred_def_83944,type,
    v139874: state_type > $o ).

tff(pred_def_83945,type,
    v139899: ( state_type * $int ) > $o ).

tff(pred_def_83946,type,
    v139898: state_type > $o ).

tff(pred_def_83947,type,
    v139897: state_type > $o ).

tff(pred_def_83948,type,
    v139896: state_type > $o ).

tff(pred_def_83949,type,
    v139895: state_type > $o ).

tff(pred_def_83950,type,
    v139894: state_type > $o ).

tff(pred_def_83951,type,
    v139893: state_type > $o ).

tff(pred_def_83952,type,
    v139892: state_type > $o ).

tff(pred_def_83953,type,
    v139891: state_type > $o ).

tff(pred_def_83954,type,
    v139890: state_type > $o ).

tff(pred_def_83955,type,
    v139889: state_type > $o ).

tff(pred_def_83956,type,
    v139888: state_type > $o ).

tff(pred_def_83957,type,
    v139887: state_type > $o ).

tff(pred_def_83958,type,
    v139886: state_type > $o ).

tff(pred_def_83959,type,
    v139885: state_type > $o ).

tff(pred_def_83960,type,
    v139883: state_type > $o ).

tff(pred_def_83961,type,
    v139906: state_type > $o ).

tff(pred_def_83962,type,
    v139905: state_type > $o ).

tff(pred_def_83963,type,
    v139907: state_type > $o ).

tff(pred_def_83964,type,
    v139904: state_type > $o ).

tff(pred_def_83965,type,
    v139903: state_type > $o ).

tff(pred_def_83966,type,
    v139909: state_type > $o ).

tff(pred_def_83967,type,
    v139902: state_type > $o ).

tff(pred_def_83968,type,
    v139912: state_type > $o ).

tff(pred_def_83969,type,
    v139911: state_type > $o ).

tff(pred_def_83970,type,
    v139910: state_type > $o ).

tff(pred_def_83971,type,
    v139901: state_type > $o ).

tff(pred_def_83972,type,
    v139913: state_type > $o ).

tff(pred_def_83973,type,
    v83161: state_type > $o ).

tff(pred_def_83974,type,
    v139917: state_type > $o ).

tff(pred_def_83975,type,
    v139916: ( state_type * $int ) > $o ).

tff(pred_def_83976,type,
    v139915: ( state_type * $int ) > $o ).

tff(pred_def_83977,type,
    v139921: state_type > $o ).

tff(pred_def_83978,type,
    v139920: ( state_type * $int ) > $o ).

tff(pred_def_83979,type,
    v139919: ( state_type * $int ) > $o ).

tff(pred_def_83980,type,
    v83124: ( state_type * $int ) > $o ).

tff(pred_def_83981,type,
    v139918: ( state_type * $int ) > $o ).

tff(pred_def_83982,type,
    v139914: ( state_type * $int ) > $o ).

tff(pred_def_83983,type,
    v83138: ( state_type * $int ) > $o ).

tff(pred_def_83984,type,
    v83136: ( state_type * $int ) > $o ).

tff(pred_def_83985,type,
    v139925: state_type > $o ).

tff(pred_def_83986,type,
    v139923: state_type > $o ).

tff(pred_def_83987,type,
    v139932: state_type > $o ).

tff(pred_def_83988,type,
    v139930: state_type > $o ).

tff(pred_def_83989,type,
    v139929: state_type > $o ).

tff(pred_def_83990,type,
    v139928: state_type > $o ).

tff(pred_def_83991,type,
    v139940: state_type > $o ).

tff(pred_def_83992,type,
    v139941: state_type > $o ).

tff(pred_def_83993,type,
    v139939: state_type > $o ).

tff(pred_def_83994,type,
    v139936: ( state_type * $int ) > $o ).

tff(pred_def_83995,type,
    v139938: ( state_type * $int ) > $o ).

tff(pred_def_83996,type,
    v139927: ( state_type * $int ) > $o ).

tff(pred_def_83997,type,
    v83126: ( state_type * $int ) > $o ).

tff(pred_def_83998,type,
    v139949: state_type > $o ).

tff(pred_def_83999,type,
    v139947: state_type > $o ).

tff(pred_def_84000,type,
    v139946: state_type > $o ).

tff(pred_def_84001,type,
    v139945: ( state_type * $int ) > $o ).

tff(pred_def_84002,type,
    v139954: state_type > $o ).

tff(pred_def_84003,type,
    v139956: state_type > $o ).

tff(pred_def_84004,type,
    v139957: state_type > $o ).

tff(pred_def_84005,type,
    v139955: state_type > $o ).

tff(pred_def_84006,type,
    v139953: state_type > $o ).

tff(pred_def_84007,type,
    v139958: state_type > $o ).

tff(pred_def_84008,type,
    v83100: state_type > $o ).

tff(pred_def_84009,type,
    v83120: state_type > $o ).

tff(pred_def_84010,type,
    v83118: state_type > $o ).

tff(pred_def_84011,type,
    v83116: state_type > $o ).

tff(pred_def_84012,type,
    v83114: state_type > $o ).

tff(pred_def_84013,type,
    v139962: state_type > $o ).

tff(pred_def_84014,type,
    v139960: state_type > $o ).

tff(pred_def_84015,type,
    v139969: state_type > $o ).

tff(pred_def_84016,type,
    v139967: state_type > $o ).

tff(pred_def_84017,type,
    v139966: state_type > $o ).

tff(pred_def_84018,type,
    v139965: state_type > $o ).

tff(pred_def_84019,type,
    v139977: state_type > $o ).

tff(pred_def_84020,type,
    v139978: state_type > $o ).

tff(pred_def_84021,type,
    v139976: state_type > $o ).

tff(pred_def_84022,type,
    v139973: state_type > $o ).

tff(pred_def_84023,type,
    v139975: state_type > $o ).

tff(pred_def_84024,type,
    v83104: state_type > $o ).

tff(pred_def_84025,type,
    v83102: state_type > $o ).

tff(pred_def_84026,type,
    v74: state_type > $o ).

tff(pred_def_84027,type,
    v139986: state_type > $o ).

tff(pred_def_84028,type,
    v139985: state_type > $o ).

tff(pred_def_84029,type,
    v139987: state_type > $o ).

tff(pred_def_84030,type,
    v139984: state_type > $o ).

tff(pred_def_84031,type,
    v139988: state_type > $o ).

tff(pred_def_84032,type,
    v139983: state_type > $o ).

tff(pred_def_84033,type,
    v139989: state_type > $o ).

tff(pred_def_84034,type,
    v139982: state_type > $o ).

tff(pred_def_84035,type,
    v139990: state_type > $o ).

tff(pred_def_84036,type,
    v83098: state_type > $o ).

tff(pred_def_84037,type,
    v140001: state_type > $o ).

tff(pred_def_84038,type,
    v140000: state_type > $o ).

tff(pred_def_84039,type,
    v140003: state_type > $o ).

tff(pred_def_84040,type,
    v140002: state_type > $o ).

tff(pred_def_84041,type,
    v139999: state_type > $o ).

tff(pred_def_84042,type,
    v140005: state_type > $o ).

tff(pred_def_84043,type,
    v140004: state_type > $o ).

tff(pred_def_84044,type,
    v139998: state_type > $o ).

tff(pred_def_84045,type,
    v140007: state_type > $o ).

tff(pred_def_84046,type,
    v140006: state_type > $o ).

tff(pred_def_84047,type,
    v139997: state_type > $o ).

tff(pred_def_84048,type,
    v140009: state_type > $o ).

tff(pred_def_84049,type,
    v140008: state_type > $o ).

tff(pred_def_84050,type,
    v139996: state_type > $o ).

tff(pred_def_84051,type,
    v140011: state_type > $o ).

tff(pred_def_84052,type,
    v140010: state_type > $o ).

tff(pred_def_84053,type,
    v139995: state_type > $o ).

tff(pred_def_84054,type,
    v140013: state_type > $o ).

tff(pred_def_84055,type,
    v140012: state_type > $o ).

tff(pred_def_84056,type,
    v139994: state_type > $o ).

tff(pred_def_84057,type,
    v140015: state_type > $o ).

tff(pred_def_84058,type,
    v140014: state_type > $o ).

tff(pred_def_84059,type,
    v139992: state_type > $o ).

tff(pred_def_84060,type,
    v140026: state_type > $o ).

tff(pred_def_84061,type,
    v140025: state_type > $o ).

tff(pred_def_84062,type,
    v140028: state_type > $o ).

tff(pred_def_84063,type,
    v140027: state_type > $o ).

tff(pred_def_84064,type,
    v140024: state_type > $o ).

tff(pred_def_84065,type,
    v140030: state_type > $o ).

tff(pred_def_84066,type,
    v140029: state_type > $o ).

tff(pred_def_84067,type,
    v140023: state_type > $o ).

tff(pred_def_84068,type,
    v140032: state_type > $o ).

tff(pred_def_84069,type,
    v140031: state_type > $o ).

tff(pred_def_84070,type,
    v140022: state_type > $o ).

tff(pred_def_84071,type,
    v140034: state_type > $o ).

tff(pred_def_84072,type,
    v140033: state_type > $o ).

tff(pred_def_84073,type,
    v140021: state_type > $o ).

tff(pred_def_84074,type,
    v140036: state_type > $o ).

tff(pred_def_84075,type,
    v140035: state_type > $o ).

tff(pred_def_84076,type,
    v140020: state_type > $o ).

tff(pred_def_84077,type,
    v140038: state_type > $o ).

tff(pred_def_84078,type,
    v140037: state_type > $o ).

tff(pred_def_84079,type,
    v140019: state_type > $o ).

tff(pred_def_84080,type,
    v140040: state_type > $o ).

tff(pred_def_84081,type,
    v140039: state_type > $o ).

tff(pred_def_84082,type,
    v140017: state_type > $o ).

tff(pred_def_84083,type,
    v140043: state_type > $o ).

tff(pred_def_84084,type,
    v140042: state_type > $o ).

tff(pred_def_84085,type,
    v140046: state_type > $o ).

tff(pred_def_84086,type,
    v140054: state_type > $o ).

tff(pred_def_84087,type,
    v140053: state_type > $o ).

tff(pred_def_84088,type,
    v140055: state_type > $o ).

tff(pred_def_84089,type,
    v140052: state_type > $o ).

tff(pred_def_84090,type,
    v140051: state_type > $o ).

tff(pred_def_84091,type,
    v140059: state_type > $o ).

tff(pred_def_84092,type,
    v140058: state_type > $o ).

tff(pred_def_84093,type,
    v140060: state_type > $o ).

tff(pred_def_84094,type,
    v140057: state_type > $o ).

tff(pred_def_84095,type,
    v140056: state_type > $o ).

tff(pred_def_84096,type,
    v140050: state_type > $o ).

tff(pred_def_84097,type,
    v140064: state_type > $o ).

tff(pred_def_84098,type,
    v140063: state_type > $o ).

tff(pred_def_84099,type,
    v140065: state_type > $o ).

tff(pred_def_84100,type,
    v140062: state_type > $o ).

tff(pred_def_84101,type,
    v140061: state_type > $o ).

tff(pred_def_84102,type,
    v140049: state_type > $o ).

tff(pred_def_84103,type,
    v140047: state_type > $o ).

tff(pred_def_84104,type,
    v140045: state_type > $o ).

tff(pred_def_84105,type,
    v140067: ( state_type * $int ) > $o ).

tff(pred_def_84106,type,
    v140066: state_type > $o ).

tff(pred_def_84107,type,
    v140044: state_type > $o ).

tff(pred_def_84108,type,
    v140071: state_type > $o ).

tff(pred_def_84109,type,
    v140073: state_type > $o ).

tff(pred_def_84110,type,
    v140072: state_type > $o ).

tff(pred_def_84111,type,
    v140069: state_type > $o ).

tff(pred_def_84112,type,
    v140076: state_type > $o ).

tff(pred_def_84113,type,
    v140075: state_type > $o ).

tff(pred_def_84114,type,
    v83094: state_type > $o ).

tff(pred_def_84115,type,
    v83092: state_type > $o ).

tff(pred_def_84116,type,
    v140078: state_type > $o ).

tff(pred_def_84117,type,
    v140082: state_type > $o ).

tff(pred_def_84118,type,
    v140081: state_type > $o ).

tff(pred_def_84119,type,
    v140080: state_type > $o ).

tff(pred_def_84120,type,
    v140086: state_type > $o ).

tff(pred_def_84121,type,
    v140085: state_type > $o ).

tff(pred_def_84122,type,
    v140084: state_type > $o ).

tff(pred_def_84123,type,
    v83076: state_type > $o ).

tff(pred_def_84124,type,
    v140083: state_type > $o ).

tff(pred_def_84125,type,
    v83090: state_type > $o ).

tff(pred_def_84126,type,
    v83088: state_type > $o ).

tff(pred_def_84127,type,
    v140090: state_type > $o ).

tff(pred_def_84128,type,
    v140088: state_type > $o ).

tff(pred_def_84129,type,
    v140097: state_type > $o ).

tff(pred_def_84130,type,
    v140095: state_type > $o ).

tff(pred_def_84131,type,
    v140094: state_type > $o ).

tff(pred_def_84132,type,
    v140093: state_type > $o ).

tff(pred_def_84133,type,
    v140105: state_type > $o ).

tff(pred_def_84134,type,
    v140106: state_type > $o ).

tff(pred_def_84135,type,
    v140104: state_type > $o ).

tff(pred_def_84136,type,
    v140101: state_type > $o ).

tff(pred_def_84137,type,
    v140103: state_type > $o ).

tff(pred_def_84138,type,
    v83078: state_type > $o ).

tff(pred_def_84139,type,
    v83074: state_type > $o ).

tff(pred_def_84140,type,
    v83072: state_type > $o ).

tff(pred_def_84141,type,
    v140111: state_type > $o ).

tff(pred_def_84142,type,
    v140110: state_type > $o ).

tff(pred_def_84143,type,
    v83070: state_type > $o ).

tff(pred_def_84144,type,
    v83068: state_type > $o ).

tff(pred_def_84145,type,
    v83066: state_type > $o ).

tff(pred_def_84146,type,
    v140117: state_type > $o ).

tff(pred_def_84147,type,
    v140115: state_type > $o ).

tff(pred_def_84148,type,
    v140114: state_type > $o ).

tff(pred_def_84149,type,
    v140113: ( state_type * $int ) > $o ).

tff(pred_def_84150,type,
    v140121: state_type > $o ).

tff(pred_def_84151,type,
    v83040: state_type > $o ).

tff(pred_def_84152,type,
    v140127: state_type > $o ).

tff(pred_def_84153,type,
    v140125: state_type > $o ).

tff(pred_def_84154,type,
    v140124: state_type > $o ).

tff(pred_def_84155,type,
    v140123: ( state_type * $int ) > $o ).

tff(pred_def_84156,type,
    v140135: state_type > $o ).

tff(pred_def_84157,type,
    v140133: state_type > $o ).

tff(pred_def_84158,type,
    v140132: state_type > $o ).

tff(pred_def_84159,type,
    v140131: ( state_type * $int ) > $o ).

tff(pred_def_84160,type,
    v140143: state_type > $o ).

tff(pred_def_84161,type,
    v140141: state_type > $o ).

tff(pred_def_84162,type,
    v140140: state_type > $o ).

tff(pred_def_84163,type,
    v140139: ( state_type * $int ) > $o ).

tff(pred_def_84164,type,
    v140151: state_type > $o ).

tff(pred_def_84165,type,
    v140149: state_type > $o ).

tff(pred_def_84166,type,
    v140148: state_type > $o ).

tff(pred_def_84167,type,
    v140147: ( state_type * $int ) > $o ).

tff(pred_def_84168,type,
    v140159: state_type > $o ).

tff(pred_def_84169,type,
    v140157: state_type > $o ).

tff(pred_def_84170,type,
    v140156: state_type > $o ).

tff(pred_def_84171,type,
    v140155: ( state_type * $int ) > $o ).

tff(pred_def_84172,type,
    v140167: state_type > $o ).

tff(pred_def_84173,type,
    v140165: state_type > $o ).

tff(pred_def_84174,type,
    v140164: state_type > $o ).

tff(pred_def_84175,type,
    v140163: ( state_type * $int ) > $o ).

tff(pred_def_84176,type,
    v140175: state_type > $o ).

tff(pred_def_84177,type,
    v140173: state_type > $o ).

tff(pred_def_84178,type,
    v140172: state_type > $o ).

tff(pred_def_84179,type,
    v140171: ( state_type * $int ) > $o ).

tff(pred_def_84180,type,
    v140183: state_type > $o ).

tff(pred_def_84181,type,
    v140181: state_type > $o ).

tff(pred_def_84182,type,
    v140180: state_type > $o ).

tff(pred_def_84183,type,
    v140179: ( state_type * $int ) > $o ).

tff(pred_def_84184,type,
    v140191: state_type > $o ).

tff(pred_def_84185,type,
    v140189: state_type > $o ).

tff(pred_def_84186,type,
    v140188: state_type > $o ).

tff(pred_def_84187,type,
    v140187: ( state_type * $int ) > $o ).

tff(pred_def_84188,type,
    v140199: state_type > $o ).

tff(pred_def_84189,type,
    v140197: state_type > $o ).

tff(pred_def_84190,type,
    v140196: state_type > $o ).

tff(pred_def_84191,type,
    v140195: ( state_type * $int ) > $o ).

tff(pred_def_84192,type,
    v140207: state_type > $o ).

tff(pred_def_84193,type,
    v140205: state_type > $o ).

tff(pred_def_84194,type,
    v140204: state_type > $o ).

tff(pred_def_84195,type,
    v140203: ( state_type * $int ) > $o ).

tff(pred_def_84196,type,
    v140215: state_type > $o ).

tff(pred_def_84197,type,
    v140213: state_type > $o ).

tff(pred_def_84198,type,
    v140212: state_type > $o ).

tff(pred_def_84199,type,
    v140211: ( state_type * $int ) > $o ).

tff(pred_def_84200,type,
    v140223: state_type > $o ).

tff(pred_def_84201,type,
    v140221: state_type > $o ).

tff(pred_def_84202,type,
    v140220: state_type > $o ).

tff(pred_def_84203,type,
    v140219: ( state_type * $int ) > $o ).

tff(pred_def_84204,type,
    v140231: state_type > $o ).

tff(pred_def_84205,type,
    v140229: state_type > $o ).

tff(pred_def_84206,type,
    v140228: state_type > $o ).

tff(pred_def_84207,type,
    v140227: ( state_type * $int ) > $o ).

tff(pred_def_84208,type,
    v140239: state_type > $o ).

tff(pred_def_84209,type,
    v140237: state_type > $o ).

tff(pred_def_84210,type,
    v140236: state_type > $o ).

tff(pred_def_84211,type,
    v140235: ( state_type * $int ) > $o ).

tff(pred_def_84212,type,
    v140247: state_type > $o ).

tff(pred_def_84213,type,
    v140245: state_type > $o ).

tff(pred_def_84214,type,
    v140244: state_type > $o ).

tff(pred_def_84215,type,
    v140243: ( state_type * $int ) > $o ).

tff(pred_def_84216,type,
    v140251: state_type > $o ).

tff(pred_def_84217,type,
    v82962: state_type > $o ).

tff(pred_def_84218,type,
    v82960: state_type > $o ).

tff(pred_def_84219,type,
    v82958: state_type > $o ).

tff(pred_def_84220,type,
    v140255: state_type > $o ).

tff(pred_def_84221,type,
    v140253: state_type > $o ).

tff(pred_def_84222,type,
    v140258: state_type > $o ).

tff(pred_def_84223,type,
    v140257: state_type > $o ).

tff(pred_def_84224,type,
    v140261: state_type > $o ).

tff(pred_def_84225,type,
    v140262: state_type > $o ).

tff(pred_def_84226,type,
    v140260: state_type > $o ).

tff(pred_def_84227,type,
    v140263: state_type > $o ).

tff(pred_def_84228,type,
    v140259: state_type > $o ).

tff(pred_def_84229,type,
    v68: ( state_type * $int ) > $o ).

tff(pred_def_84230,type,
    v140264: ( state_type * $int ) > $o ).

tff(pred_def_84231,type,
    v72: state_type > $o ).

tff(pred_def_84232,type,
    v66: ( state_type * $int ) > $o ).

tff(pred_def_84233,type,
    v64: ( state_type * $int ) > $o ).

tff(pred_def_84234,type,
    v62: ( state_type * $int ) > $o ).

tff(pred_def_84235,type,
    v140268: state_type > $o ).

tff(pred_def_84236,type,
    v140266: state_type > $o ).

tff(pred_def_84237,type,
    v140275: state_type > $o ).

tff(pred_def_84238,type,
    v140273: state_type > $o ).

tff(pred_def_84239,type,
    v140272: state_type > $o ).

tff(pred_def_84240,type,
    v140271: state_type > $o ).

tff(pred_def_84241,type,
    v140283: state_type > $o ).

tff(pred_def_84242,type,
    v140284: state_type > $o ).

tff(pred_def_84243,type,
    v140282: state_type > $o ).

tff(pred_def_84244,type,
    v140279: ( state_type * $int ) > $o ).

tff(pred_def_84245,type,
    v140281: ( state_type * $int ) > $o ).

tff(pred_def_84246,type,
    v140270: ( state_type * $int ) > $o ).

tff(pred_def_84247,type,
    v12: ( state_type * $int ) > $o ).

tff(pred_def_84248,type,
    v10: ( state_type * $int ) > $o ).

tff(pred_def_84249,type,
    v140291: state_type > $o ).

tff(pred_def_84250,type,
    v140292: state_type > $o ).

tff(pred_def_84251,type,
    v140293: state_type > $o ).

tff(pred_def_84252,type,
    v140294: state_type > $o ).

tff(pred_def_84253,type,
    v140295: state_type > $o ).

tff(pred_def_84254,type,
    v140296: state_type > $o ).

tff(pred_def_84255,type,
    v140297: state_type > $o ).

tff(pred_def_84256,type,
    v140298: state_type > $o ).

tff(pred_def_84257,type,
    v140290: ( state_type * $int ) > $o ).

tff(pred_def_84258,type,
    v140288: ( state_type * $int ) > $o ).

tff(pred_def_84259,type,
    v140302: state_type > $o ).

tff(pred_def_84260,type,
    v140304: state_type > $o ).

tff(pred_def_84261,type,
    v140303: state_type > $o ).

tff(pred_def_84262,type,
    v140301: state_type > $o ).

tff(pred_def_84263,type,
    v140300: state_type > $o ).

tff(pred_def_84264,type,
    v140312: state_type > $o ).

tff(pred_def_84265,type,
    v140311: state_type > $o ).

tff(pred_def_84266,type,
    v140310: state_type > $o ).

tff(pred_def_84267,type,
    v140309: state_type > $o ).

tff(pred_def_84268,type,
    v140308: state_type > $o ).

tff(pred_def_84269,type,
    v140307: state_type > $o ).

tff(pred_def_84270,type,
    v140305: state_type > $o ).

tff(pred_def_84271,type,
    v82956: state_type > $o ).

tff(pred_def_84272,type,
    v140323: state_type > $o ).

tff(pred_def_84273,type,
    v140322: state_type > $o ).

tff(pred_def_84274,type,
    v140325: state_type > $o ).

tff(pred_def_84275,type,
    v140324: state_type > $o ).

tff(pred_def_84276,type,
    v140321: state_type > $o ).

tff(pred_def_84277,type,
    v140327: state_type > $o ).

tff(pred_def_84278,type,
    v140326: state_type > $o ).

tff(pred_def_84279,type,
    v140320: state_type > $o ).

tff(pred_def_84280,type,
    v140329: state_type > $o ).

tff(pred_def_84281,type,
    v140328: state_type > $o ).

tff(pred_def_84282,type,
    v140319: state_type > $o ).

tff(pred_def_84283,type,
    v140331: state_type > $o ).

tff(pred_def_84284,type,
    v140330: state_type > $o ).

tff(pred_def_84285,type,
    v140318: state_type > $o ).

tff(pred_def_84286,type,
    v140333: state_type > $o ).

tff(pred_def_84287,type,
    v140332: state_type > $o ).

tff(pred_def_84288,type,
    v140317: state_type > $o ).

tff(pred_def_84289,type,
    v140335: state_type > $o ).

tff(pred_def_84290,type,
    v140334: state_type > $o ).

tff(pred_def_84291,type,
    v140316: state_type > $o ).

tff(pred_def_84292,type,
    v140337: state_type > $o ).

tff(pred_def_84293,type,
    v140336: state_type > $o ).

tff(pred_def_84294,type,
    v140314: state_type > $o ).

tff(pred_def_84295,type,
    v140348: state_type > $o ).

tff(pred_def_84296,type,
    v140347: state_type > $o ).

tff(pred_def_84297,type,
    v140350: state_type > $o ).

tff(pred_def_84298,type,
    v140349: state_type > $o ).

tff(pred_def_84299,type,
    v140346: state_type > $o ).

tff(pred_def_84300,type,
    v140352: state_type > $o ).

tff(pred_def_84301,type,
    v140351: state_type > $o ).

tff(pred_def_84302,type,
    v140345: state_type > $o ).

tff(pred_def_84303,type,
    v140354: state_type > $o ).

tff(pred_def_84304,type,
    v140353: state_type > $o ).

tff(pred_def_84305,type,
    v140344: state_type > $o ).

tff(pred_def_84306,type,
    v140356: state_type > $o ).

tff(pred_def_84307,type,
    v140355: state_type > $o ).

tff(pred_def_84308,type,
    v140343: state_type > $o ).

tff(pred_def_84309,type,
    v140358: state_type > $o ).

tff(pred_def_84310,type,
    v140357: state_type > $o ).

tff(pred_def_84311,type,
    v140342: state_type > $o ).

tff(pred_def_84312,type,
    v140360: state_type > $o ).

tff(pred_def_84313,type,
    v140359: state_type > $o ).

tff(pred_def_84314,type,
    v140341: state_type > $o ).

tff(pred_def_84315,type,
    v140362: state_type > $o ).

tff(pred_def_84316,type,
    v140361: state_type > $o ).

tff(pred_def_84317,type,
    v140339: state_type > $o ).

tff(pred_def_84318,type,
    v140366: state_type > $o ).

tff(pred_def_84319,type,
    v140365: state_type > $o ).

tff(pred_def_84320,type,
    v140364: state_type > $o ).

tff(pred_def_84321,type,
    v140369: state_type > $o ).

tff(pred_def_84322,type,
    v140370: state_type > $o ).

tff(pred_def_84323,type,
    v140368: state_type > $o ).

tff(pred_def_84324,type,
    v140372: ( state_type * $int ) > $o ).

tff(pred_def_84325,type,
    v140371: state_type > $o ).

tff(pred_def_84326,type,
    v140367: state_type > $o ).

tff(pred_def_84327,type,
    v82952: state_type > $o ).

tff(pred_def_84328,type,
    v82950: state_type > $o ).

tff(pred_def_84329,type,
    v82948: state_type > $o ).

tff(pred_def_84330,type,
    v140376: state_type > $o ).

tff(pred_def_84331,type,
    v140374: state_type > $o ).

tff(pred_def_84332,type,
    v140383: state_type > $o ).

tff(pred_def_84333,type,
    v140381: state_type > $o ).

tff(pred_def_84334,type,
    v140380: state_type > $o ).

tff(pred_def_84335,type,
    v140379: state_type > $o ).

tff(pred_def_84336,type,
    v140391: state_type > $o ).

tff(pred_def_84337,type,
    v140392: state_type > $o ).

tff(pred_def_84338,type,
    v140390: state_type > $o ).

tff(pred_def_84339,type,
    v140387: state_type > $o ).

tff(pred_def_84340,type,
    v140389: state_type > $o ).

tff(pred_def_84341,type,
    v82938: state_type > $o ).

tff(pred_def_84342,type,
    v82936: state_type > $o ).

tff(pred_def_84343,type,
    v140400: state_type > $o ).

tff(pred_def_84344,type,
    v140398: state_type > $o ).

tff(pred_def_84345,type,
    v140397: state_type > $o ).

tff(pred_def_84346,type,
    v140396: ( state_type * $int ) > $o ).

tff(pred_def_84347,type,
    v140408: state_type > $o ).

tff(pred_def_84348,type,
    v140406: state_type > $o ).

tff(pred_def_84349,type,
    v140405: state_type > $o ).

tff(pred_def_84350,type,
    v140404: ( state_type * $int ) > $o ).

tff(pred_def_84351,type,
    v140416: state_type > $o ).

tff(pred_def_84352,type,
    v140414: state_type > $o ).

tff(pred_def_84353,type,
    v140413: state_type > $o ).

tff(pred_def_84354,type,
    v140412: ( state_type * $int ) > $o ).

tff(pred_def_84355,type,
    v140424: state_type > $o ).

tff(pred_def_84356,type,
    v140422: state_type > $o ).

tff(pred_def_84357,type,
    v140421: state_type > $o ).

tff(pred_def_84358,type,
    v140420: ( state_type * $int ) > $o ).

tff(pred_def_84359,type,
    v140432: state_type > $o ).

tff(pred_def_84360,type,
    v140430: state_type > $o ).

tff(pred_def_84361,type,
    v140429: state_type > $o ).

tff(pred_def_84362,type,
    v140428: ( state_type * $int ) > $o ).

tff(pred_def_84363,type,
    v140440: state_type > $o ).

tff(pred_def_84364,type,
    v140438: state_type > $o ).

tff(pred_def_84365,type,
    v140437: state_type > $o ).

tff(pred_def_84366,type,
    v140436: ( state_type * $int ) > $o ).

tff(pred_def_84367,type,
    v140448: state_type > $o ).

tff(pred_def_84368,type,
    v140446: state_type > $o ).

tff(pred_def_84369,type,
    v140445: state_type > $o ).

tff(pred_def_84370,type,
    v140444: ( state_type * $int ) > $o ).

tff(pred_def_84371,type,
    v140456: state_type > $o ).

tff(pred_def_84372,type,
    v140454: state_type > $o ).

tff(pred_def_84373,type,
    v140453: state_type > $o ).

tff(pred_def_84374,type,
    v140452: ( state_type * $int ) > $o ).

tff(pred_def_84375,type,
    v140464: state_type > $o ).

tff(pred_def_84376,type,
    v140462: state_type > $o ).

tff(pred_def_84377,type,
    v140461: state_type > $o ).

tff(pred_def_84378,type,
    v140460: ( state_type * $int ) > $o ).

tff(pred_def_84379,type,
    v140472: state_type > $o ).

tff(pred_def_84380,type,
    v140470: state_type > $o ).

tff(pred_def_84381,type,
    v140469: state_type > $o ).

tff(pred_def_84382,type,
    v140468: ( state_type * $int ) > $o ).

tff(pred_def_84383,type,
    v140480: state_type > $o ).

tff(pred_def_84384,type,
    v140478: state_type > $o ).

tff(pred_def_84385,type,
    v140477: state_type > $o ).

tff(pred_def_84386,type,
    v140476: ( state_type * $int ) > $o ).

tff(pred_def_84387,type,
    v140488: state_type > $o ).

tff(pred_def_84388,type,
    v140486: state_type > $o ).

tff(pred_def_84389,type,
    v140485: state_type > $o ).

tff(pred_def_84390,type,
    v140484: ( state_type * $int ) > $o ).

tff(pred_def_84391,type,
    v140496: state_type > $o ).

tff(pred_def_84392,type,
    v140494: state_type > $o ).

tff(pred_def_84393,type,
    v140493: state_type > $o ).

tff(pred_def_84394,type,
    v140492: ( state_type * $int ) > $o ).

tff(pred_def_84395,type,
    v140504: state_type > $o ).

tff(pred_def_84396,type,
    v140502: state_type > $o ).

tff(pred_def_84397,type,
    v140501: state_type > $o ).

tff(pred_def_84398,type,
    v140500: ( state_type * $int ) > $o ).

tff(pred_def_84399,type,
    v140512: state_type > $o ).

tff(pred_def_84400,type,
    v140510: state_type > $o ).

tff(pred_def_84401,type,
    v140509: state_type > $o ).

tff(pred_def_84402,type,
    v140508: ( state_type * $int ) > $o ).

tff(pred_def_84403,type,
    v140520: state_type > $o ).

tff(pred_def_84404,type,
    v140518: state_type > $o ).

tff(pred_def_84405,type,
    v140517: state_type > $o ).

tff(pred_def_84406,type,
    v140516: ( state_type * $int ) > $o ).

tff(pred_def_84407,type,
    v140528: state_type > $o ).

tff(pred_def_84408,type,
    v140526: state_type > $o ).

tff(pred_def_84409,type,
    v140525: state_type > $o ).

tff(pred_def_84410,type,
    v140524: ( state_type * $int ) > $o ).

tff(pred_def_84411,type,
    v140534: state_type > $o ).

tff(pred_def_84412,type,
    v140533: ( state_type * $int ) > $o ).

tff(pred_def_84413,type,
    v140535: state_type > $o ).

tff(pred_def_84414,type,
    v140536: state_type > $o ).

tff(pred_def_84415,type,
    v958: ( state_type * $int ) > $o ).

tff(pred_def_84416,type,
    v956: ( state_type * $int ) > $o ).

tff(pred_def_84417,type,
    v954: ( state_type * $int ) > $o ).

tff(pred_def_84418,type,
    v140540: state_type > $o ).

tff(pred_def_84419,type,
    v140538: state_type > $o ).

tff(pred_def_84420,type,
    v140547: state_type > $o ).

tff(pred_def_84421,type,
    v140545: state_type > $o ).

tff(pred_def_84422,type,
    v140544: state_type > $o ).

tff(pred_def_84423,type,
    v140543: state_type > $o ).

tff(pred_def_84424,type,
    v140555: state_type > $o ).

tff(pred_def_84425,type,
    v140556: state_type > $o ).

tff(pred_def_84426,type,
    v140554: state_type > $o ).

tff(pred_def_84427,type,
    v140551: ( state_type * $int ) > $o ).

tff(pred_def_84428,type,
    v140553: ( state_type * $int ) > $o ).

tff(pred_def_84429,type,
    v140542: ( state_type * $int ) > $o ).

tff(pred_def_84430,type,
    v944: ( state_type * $int ) > $o ).

tff(pred_def_84431,type,
    v942: ( state_type * $int ) > $o ).

tff(pred_def_84432,type,
    v140532: state_type > $o ).

tff(pred_def_84433,type,
    v140566: state_type > $o ).

tff(pred_def_84434,type,
    v140564: state_type > $o ).

tff(pred_def_84435,type,
    v140563: state_type > $o ).

tff(pred_def_84436,type,
    v140562: ( state_type * $int ) > $o ).

tff(pred_def_84437,type,
    v140560: state_type > $o ).

tff(pred_def_84438,type,
    v140578: state_type > $o ).

tff(pred_def_84439,type,
    v140576: state_type > $o ).

tff(pred_def_84440,type,
    v140582: state_type > $o ).

tff(pred_def_84441,type,
    v140580: state_type > $o ).

tff(pred_def_84442,type,
    v140602: state_type > $o ).

tff(pred_def_84443,type,
    v140600: state_type > $o ).

tff(pred_def_84444,type,
    v140606: state_type > $o ).

tff(pred_def_84445,type,
    v140604: state_type > $o ).

tff(pred_def_84446,type,
    v140592: state_type > $o ).

tff(pred_def_84447,type,
    v140613: ( state_type * $int ) > $o ).

tff(pred_def_84448,type,
    v140614: state_type > $o ).

tff(pred_def_84449,type,
    v140612: ( state_type * $int ) > $o ).

tff(pred_def_84450,type,
    v140610: ( state_type * $int ) > $o ).

tff(pred_def_84451,type,
    v140608: ( state_type * $int ) > $o ).

tff(pred_def_84452,type,
    v140618: state_type > $o ).

tff(pred_def_84453,type,
    v140616: state_type > $o ).

tff(pred_def_84454,type,
    v140625: state_type > $o ).

tff(pred_def_84455,type,
    v140623: state_type > $o ).

tff(pred_def_84456,type,
    v140622: state_type > $o ).

tff(pred_def_84457,type,
    v140621: state_type > $o ).

tff(pred_def_84458,type,
    v140633: state_type > $o ).

tff(pred_def_84459,type,
    v140634: state_type > $o ).

tff(pred_def_84460,type,
    v140632: state_type > $o ).

tff(pred_def_84461,type,
    v140629: ( state_type * $int ) > $o ).

tff(pred_def_84462,type,
    v140631: ( state_type * $int ) > $o ).

tff(pred_def_84463,type,
    v140620: ( state_type * $int ) > $o ).

tff(pred_def_84464,type,
    v140598: ( state_type * $int ) > $o ).

tff(pred_def_84465,type,
    v140596: ( state_type * $int ) > $o ).

tff(pred_def_84466,type,
    v140594: state_type > $o ).

tff(pred_def_84467,type,
    v140646: state_type > $o ).

tff(pred_def_84468,type,
    v140644: state_type > $o ).

tff(pred_def_84469,type,
    v140650: state_type > $o ).

tff(pred_def_84470,type,
    v140648: state_type > $o ).

tff(pred_def_84471,type,
    v140656: state_type > $o ).

tff(pred_def_84472,type,
    v140662: ( state_type * $int ) > $o ).

tff(pred_def_84473,type,
    v140664: ( state_type * $int ) > $o ).

tff(pred_def_84474,type,
    v140660: state_type > $o ).

tff(pred_def_84475,type,
    v140658: state_type > $o ).

tff(pred_def_84476,type,
    v140666: state_type > $o ).

tff(pred_def_84477,type,
    v140671: state_type > $o ).

tff(pred_def_84478,type,
    v140670: state_type > $o ).

tff(pred_def_84479,type,
    v140669: state_type > $o ).

tff(pred_def_84480,type,
    v140674: state_type > $o ).

tff(pred_def_84481,type,
    v140673: state_type > $o ).

tff(pred_def_84482,type,
    v140672: state_type > $o ).

tff(pred_def_84483,type,
    v140668: state_type > $o ).

tff(pred_def_84484,type,
    v140679: state_type > $o ).

tff(pred_def_84485,type,
    v140678: state_type > $o ).

tff(pred_def_84486,type,
    v140677: state_type > $o ).

tff(pred_def_84487,type,
    v140640: state_type > $o ).

tff(pred_def_84488,type,
    v140676: state_type > $o ).

tff(pred_def_84489,type,
    v140682: state_type > $o ).

tff(pred_def_84490,type,
    v140681: state_type > $o ).

tff(pred_def_84491,type,
    v140680: state_type > $o ).

tff(pred_def_84492,type,
    v140675: state_type > $o ).

tff(pred_def_84493,type,
    v140654: state_type > $o ).

tff(pred_def_84494,type,
    v140652: state_type > $o ).

tff(pred_def_84495,type,
    v140686: state_type > $o ).

tff(pred_def_84496,type,
    v140684: state_type > $o ).

tff(pred_def_84497,type,
    v140693: state_type > $o ).

tff(pred_def_84498,type,
    v140691: state_type > $o ).

tff(pred_def_84499,type,
    v140690: state_type > $o ).

tff(pred_def_84500,type,
    v140689: state_type > $o ).

tff(pred_def_84501,type,
    v140701: state_type > $o ).

tff(pred_def_84502,type,
    v140702: state_type > $o ).

tff(pred_def_84503,type,
    v140700: state_type > $o ).

tff(pred_def_84504,type,
    v140697: state_type > $o ).

tff(pred_def_84505,type,
    v140699: state_type > $o ).

tff(pred_def_84506,type,
    v140642: state_type > $o ).

tff(pred_def_84507,type,
    v140638: state_type > $o ).

tff(pred_def_84508,type,
    v140714: state_type > $o ).

tff(pred_def_84509,type,
    v140712: state_type > $o ).

tff(pred_def_84510,type,
    v140718: state_type > $o ).

tff(pred_def_84511,type,
    v140716: state_type > $o ).

tff(pred_def_84512,type,
    v140736: state_type > $o ).

tff(pred_def_84513,type,
    v140734: state_type > $o ).

tff(pred_def_84514,type,
    v140740: state_type > $o ).

tff(pred_def_84515,type,
    v140738: state_type > $o ).

tff(pred_def_84516,type,
    v140746: state_type > $o ).

tff(pred_def_84517,type,
    v140752: ( state_type * $int ) > $o ).

tff(pred_def_84518,type,
    v140754: ( state_type * $int ) > $o ).

tff(pred_def_84519,type,
    v140750: state_type > $o ).

tff(pred_def_84520,type,
    v140748: state_type > $o ).

tff(pred_def_84521,type,
    v140764: state_type > $o ).

tff(pred_def_84522,type,
    v140765: state_type > $o ).

tff(pred_def_84523,type,
    v140763: state_type > $o ).

tff(pred_def_84524,type,
    v140768: state_type > $o ).

tff(pred_def_84525,type,
    v140767: state_type > $o ).

tff(pred_def_84526,type,
    v140758: state_type > $o ).

tff(pred_def_84527,type,
    v140766: state_type > $o ).

tff(pred_def_84528,type,
    v140762: state_type > $o ).

tff(pred_def_84529,type,
    v140728: state_type > $o ).

tff(pred_def_84530,type,
    v140761: state_type > $o ).

tff(pred_def_84531,type,
    v140770: state_type > $o ).

tff(pred_def_84532,type,
    v140706: state_type > $o ).

tff(pred_def_84533,type,
    v140769: state_type > $o ).

tff(pred_def_84534,type,
    v140776: state_type > $o ).

tff(pred_def_84535,type,
    v140774: state_type > $o ).

tff(pred_def_84536,type,
    v140773: state_type > $o ).

tff(pred_def_84537,type,
    v140772: ( state_type * $int ) > $o ).

tff(pred_def_84538,type,
    v140756: state_type > $o ).

tff(pred_def_84539,type,
    v140783: state_type > $o ).

tff(pred_def_84540,type,
    v140782: state_type > $o ).

tff(pred_def_84541,type,
    v140781: state_type > $o ).

tff(pred_def_84542,type,
    v140786: state_type > $o ).

tff(pred_def_84543,type,
    v140785: state_type > $o ).

tff(pred_def_84544,type,
    v140784: state_type > $o ).

tff(pred_def_84545,type,
    v140780: state_type > $o ).

tff(pred_def_84546,type,
    v140791: state_type > $o ).

tff(pred_def_84547,type,
    v140790: state_type > $o ).

tff(pred_def_84548,type,
    v140789: state_type > $o ).

tff(pred_def_84549,type,
    v140730: state_type > $o ).

tff(pred_def_84550,type,
    v140788: state_type > $o ).

tff(pred_def_84551,type,
    v140794: state_type > $o ).

tff(pred_def_84552,type,
    v140793: state_type > $o ).

tff(pred_def_84553,type,
    v140792: state_type > $o ).

tff(pred_def_84554,type,
    v140787: state_type > $o ).

tff(pred_def_84555,type,
    v140744: state_type > $o ).

tff(pred_def_84556,type,
    v140742: state_type > $o ).

tff(pred_def_84557,type,
    v140798: state_type > $o ).

tff(pred_def_84558,type,
    v140796: state_type > $o ).

tff(pred_def_84559,type,
    v140805: state_type > $o ).

tff(pred_def_84560,type,
    v140803: state_type > $o ).

tff(pred_def_84561,type,
    v140802: state_type > $o ).

tff(pred_def_84562,type,
    v140801: state_type > $o ).

tff(pred_def_84563,type,
    v140813: state_type > $o ).

tff(pred_def_84564,type,
    v140814: state_type > $o ).

tff(pred_def_84565,type,
    v140812: state_type > $o ).

tff(pred_def_84566,type,
    v140809: state_type > $o ).

tff(pred_def_84567,type,
    v140811: state_type > $o ).

tff(pred_def_84568,type,
    v140732: state_type > $o ).

tff(pred_def_84569,type,
    v140819: state_type > $o ).

tff(pred_def_84570,type,
    v140818: state_type > $o ).

tff(pred_def_84571,type,
    v140822: state_type > $o ).

tff(pred_def_84572,type,
    v140821: state_type > $o ).

tff(pred_def_84573,type,
    v140820: state_type > $o ).

tff(pred_def_84574,type,
    v140726: state_type > $o ).

tff(pred_def_84575,type,
    v140724: state_type > $o ).

tff(pred_def_84576,type,
    v140722: state_type > $o ).

tff(pred_def_84577,type,
    v140720: state_type > $o ).

tff(pred_def_84578,type,
    v140826: state_type > $o ).

tff(pred_def_84579,type,
    v140824: state_type > $o ).

tff(pred_def_84580,type,
    v140833: state_type > $o ).

tff(pred_def_84581,type,
    v140831: state_type > $o ).

tff(pred_def_84582,type,
    v140830: state_type > $o ).

tff(pred_def_84583,type,
    v140829: state_type > $o ).

tff(pred_def_84584,type,
    v140841: state_type > $o ).

tff(pred_def_84585,type,
    v140842: state_type > $o ).

tff(pred_def_84586,type,
    v140840: state_type > $o ).

tff(pred_def_84587,type,
    v140837: state_type > $o ).

tff(pred_def_84588,type,
    v140839: state_type > $o ).

tff(pred_def_84589,type,
    v140710: state_type > $o ).

tff(pred_def_84590,type,
    v140708: state_type > $o ).

tff(pred_def_84591,type,
    v140849: state_type > $o ).

tff(pred_def_84592,type,
    v140850: state_type > $o ).

tff(pred_def_84593,type,
    v140848: state_type > $o ).

tff(pred_def_84594,type,
    v140853: state_type > $o ).

tff(pred_def_84595,type,
    v140852: state_type > $o ).

tff(pred_def_84596,type,
    v140851: state_type > $o ).

tff(pred_def_84597,type,
    v140847: state_type > $o ).

tff(pred_def_84598,type,
    v140846: state_type > $o ).

tff(pred_def_84599,type,
    v140855: state_type > $o ).

tff(pred_def_84600,type,
    v140856: state_type > $o ).

tff(pred_def_84601,type,
    v140854: state_type > $o ).

tff(pred_def_84602,type,
    v140866: state_type > $o ).

tff(pred_def_84603,type,
    v140864: state_type > $o ).

tff(pred_def_84604,type,
    v140870: state_type > $o ).

tff(pred_def_84605,type,
    v140868: state_type > $o ).

tff(pred_def_84606,type,
    v140878: state_type > $o ).

tff(pred_def_84607,type,
    v140880: state_type > $o ).

tff(pred_def_84608,type,
    v140879: ( state_type * $int ) > $o ).

tff(pred_def_84609,type,
    v140881: ( state_type * $int ) > $o ).

tff(pred_def_84610,type,
    v140876: ( state_type * $int ) > $o ).

tff(pred_def_84611,type,
    v140883: state_type > $o ).

tff(pred_def_84612,type,
    v140887: state_type > $o ).

tff(pred_def_84613,type,
    v140886: ( state_type * $int ) > $o ).

tff(pred_def_84614,type,
    v140885: ( state_type * $int ) > $o ).

tff(pred_def_84615,type,
    v140891: state_type > $o ).

tff(pred_def_84616,type,
    v140890: ( state_type * $int ) > $o ).

tff(pred_def_84617,type,
    v140889: ( state_type * $int ) > $o ).

tff(pred_def_84618,type,
    v140860: ( state_type * $int ) > $o ).

tff(pred_def_84619,type,
    v140888: ( state_type * $int ) > $o ).

tff(pred_def_84620,type,
    v140884: ( state_type * $int ) > $o ).

tff(pred_def_84621,type,
    v140874: ( state_type * $int ) > $o ).

tff(pred_def_84622,type,
    v140872: ( state_type * $int ) > $o ).

tff(pred_def_84623,type,
    v140895: state_type > $o ).

tff(pred_def_84624,type,
    v140893: state_type > $o ).

tff(pred_def_84625,type,
    v140902: state_type > $o ).

tff(pred_def_84626,type,
    v140900: state_type > $o ).

tff(pred_def_84627,type,
    v140899: state_type > $o ).

tff(pred_def_84628,type,
    v140898: state_type > $o ).

tff(pred_def_84629,type,
    v140910: state_type > $o ).

tff(pred_def_84630,type,
    v140911: state_type > $o ).

tff(pred_def_84631,type,
    v140909: state_type > $o ).

tff(pred_def_84632,type,
    v140906: ( state_type * $int ) > $o ).

tff(pred_def_84633,type,
    v140908: ( state_type * $int ) > $o ).

tff(pred_def_84634,type,
    v140897: ( state_type * $int ) > $o ).

tff(pred_def_84635,type,
    v140862: ( state_type * $int ) > $o ).

tff(pred_def_84636,type,
    v140858: state_type > $o ).

tff(pred_def_84637,type,
    v140923: state_type > $o ).

tff(pred_def_84638,type,
    v140921: state_type > $o ).

tff(pred_def_84639,type,
    v140927: state_type > $o ).

tff(pred_def_84640,type,
    v140925: state_type > $o ).

tff(pred_def_84641,type,
    v140935: state_type > $o ).

tff(pred_def_84642,type,
    v140937: state_type > $o ).

tff(pred_def_84643,type,
    v140936: ( state_type * $int ) > $o ).

tff(pred_def_84644,type,
    v140938: ( state_type * $int ) > $o ).

tff(pred_def_84645,type,
    v140933: ( state_type * $int ) > $o ).

tff(pred_def_84646,type,
    v140940: state_type > $o ).

tff(pred_def_84647,type,
    v140944: state_type > $o ).

tff(pred_def_84648,type,
    v140943: ( state_type * $int ) > $o ).

tff(pred_def_84649,type,
    v140942: ( state_type * $int ) > $o ).

tff(pred_def_84650,type,
    v140948: state_type > $o ).

tff(pred_def_84651,type,
    v140947: ( state_type * $int ) > $o ).

tff(pred_def_84652,type,
    v140946: ( state_type * $int ) > $o ).

tff(pred_def_84653,type,
    v140917: ( state_type * $int ) > $o ).

tff(pred_def_84654,type,
    v140945: ( state_type * $int ) > $o ).

tff(pred_def_84655,type,
    v140941: ( state_type * $int ) > $o ).

tff(pred_def_84656,type,
    v140931: ( state_type * $int ) > $o ).

tff(pred_def_84657,type,
    v140929: ( state_type * $int ) > $o ).

tff(pred_def_84658,type,
    v140952: state_type > $o ).

tff(pred_def_84659,type,
    v140950: state_type > $o ).

tff(pred_def_84660,type,
    v140959: state_type > $o ).

tff(pred_def_84661,type,
    v140957: state_type > $o ).

tff(pred_def_84662,type,
    v140956: state_type > $o ).

tff(pred_def_84663,type,
    v140955: state_type > $o ).

tff(pred_def_84664,type,
    v140967: state_type > $o ).

tff(pred_def_84665,type,
    v140968: state_type > $o ).

tff(pred_def_84666,type,
    v140966: state_type > $o ).

tff(pred_def_84667,type,
    v140963: ( state_type * $int ) > $o ).

tff(pred_def_84668,type,
    v140965: ( state_type * $int ) > $o ).

tff(pred_def_84669,type,
    v140954: ( state_type * $int ) > $o ).

tff(pred_def_84670,type,
    v140919: ( state_type * $int ) > $o ).

tff(pred_def_84671,type,
    v140915: state_type > $o ).

tff(pred_def_84672,type,
    v140972: state_type > $o ).

tff(pred_def_84673,type,
    v962: state_type > $o ).

tff(pred_def_84674,type,
    v140590: state_type > $o ).

tff(pred_def_84675,type,
    v140588: state_type > $o ).

tff(pred_def_84676,type,
    v140586: state_type > $o ).

tff(pred_def_84677,type,
    v140584: state_type > $o ).

tff(pred_def_84678,type,
    v140976: state_type > $o ).

tff(pred_def_84679,type,
    v140974: state_type > $o ).

tff(pred_def_84680,type,
    v140983: state_type > $o ).

tff(pred_def_84681,type,
    v140981: state_type > $o ).

tff(pred_def_84682,type,
    v140980: state_type > $o ).

tff(pred_def_84683,type,
    v140979: state_type > $o ).

tff(pred_def_84684,type,
    v140991: state_type > $o ).

tff(pred_def_84685,type,
    v140992: state_type > $o ).

tff(pred_def_84686,type,
    v140990: state_type > $o ).

tff(pred_def_84687,type,
    v140987: state_type > $o ).

tff(pred_def_84688,type,
    v140989: state_type > $o ).

tff(pred_def_84689,type,
    v140574: state_type > $o ).

tff(pred_def_84690,type,
    v140572: state_type > $o ).

tff(pred_def_84691,type,
    v140570: state_type > $o ).

tff(pred_def_84692,type,
    v140999: state_type > $o ).

tff(pred_def_84693,type,
    v141001: state_type > $o ).

tff(pred_def_84694,type,
    v141000: state_type > $o ).

tff(pred_def_84695,type,
    v140998: state_type > $o ).

tff(pred_def_84696,type,
    v141004: state_type > $o ).

tff(pred_def_84697,type,
    v141003: state_type > $o ).

tff(pred_def_84698,type,
    v141002: state_type > $o ).

tff(pred_def_84699,type,
    v140997: state_type > $o ).

tff(pred_def_84700,type,
    v140996: state_type > $o ).

tff(pred_def_84701,type,
    v141006: state_type > $o ).

tff(pred_def_84702,type,
    v141005: state_type > $o ).

tff(pred_def_84703,type,
    v5751: state_type > $o ).

tff(pred_def_84704,type,
    v5749: state_type > $o ).

tff(pred_def_84705,type,
    v141012: state_type > $o ).

tff(pred_def_84706,type,
    v141010: state_type > $o ).

tff(pred_def_84707,type,
    v141009: state_type > $o ).

tff(pred_def_84708,type,
    v141008: ( state_type * $int ) > $o ).

tff(pred_def_84709,type,
    v141016: state_type > $o ).

tff(pred_def_84710,type,
    v5689: state_type > $o ).

tff(pred_def_84711,type,
    v141022: state_type > $o ).

tff(pred_def_84712,type,
    v141020: state_type > $o ).

tff(pred_def_84713,type,
    v141019: state_type > $o ).

tff(pred_def_84714,type,
    v141018: ( state_type * $int ) > $o ).

tff(pred_def_84715,type,
    v141030: state_type > $o ).

tff(pred_def_84716,type,
    v141028: state_type > $o ).

tff(pred_def_84717,type,
    v141027: state_type > $o ).

tff(pred_def_84718,type,
    v141026: ( state_type * $int ) > $o ).

tff(pred_def_84719,type,
    v141038: state_type > $o ).

tff(pred_def_84720,type,
    v141036: state_type > $o ).

tff(pred_def_84721,type,
    v141035: state_type > $o ).

tff(pred_def_84722,type,
    v141034: ( state_type * $int ) > $o ).

tff(pred_def_84723,type,
    v141046: state_type > $o ).

tff(pred_def_84724,type,
    v141044: state_type > $o ).

tff(pred_def_84725,type,
    v141043: state_type > $o ).

tff(pred_def_84726,type,
    v141042: ( state_type * $int ) > $o ).

tff(pred_def_84727,type,
    v141054: state_type > $o ).

tff(pred_def_84728,type,
    v141052: state_type > $o ).

tff(pred_def_84729,type,
    v141051: state_type > $o ).

tff(pred_def_84730,type,
    v141050: ( state_type * $int ) > $o ).

tff(pred_def_84731,type,
    v141062: state_type > $o ).

tff(pred_def_84732,type,
    v141060: state_type > $o ).

tff(pred_def_84733,type,
    v141059: state_type > $o ).

tff(pred_def_84734,type,
    v141058: ( state_type * $int ) > $o ).

tff(pred_def_84735,type,
    v141070: state_type > $o ).

tff(pred_def_84736,type,
    v141068: state_type > $o ).

tff(pred_def_84737,type,
    v141067: state_type > $o ).

tff(pred_def_84738,type,
    v141066: ( state_type * $int ) > $o ).

tff(pred_def_84739,type,
    v141078: state_type > $o ).

tff(pred_def_84740,type,
    v141076: state_type > $o ).

tff(pred_def_84741,type,
    v141075: state_type > $o ).

tff(pred_def_84742,type,
    v141074: ( state_type * $int ) > $o ).

tff(pred_def_84743,type,
    v141086: state_type > $o ).

tff(pred_def_84744,type,
    v141084: state_type > $o ).

tff(pred_def_84745,type,
    v141083: state_type > $o ).

tff(pred_def_84746,type,
    v141082: ( state_type * $int ) > $o ).

tff(pred_def_84747,type,
    v141094: state_type > $o ).

tff(pred_def_84748,type,
    v141092: state_type > $o ).

tff(pred_def_84749,type,
    v141091: state_type > $o ).

tff(pred_def_84750,type,
    v141090: ( state_type * $int ) > $o ).

tff(pred_def_84751,type,
    v141102: state_type > $o ).

tff(pred_def_84752,type,
    v141100: state_type > $o ).

tff(pred_def_84753,type,
    v141099: state_type > $o ).

tff(pred_def_84754,type,
    v141098: ( state_type * $int ) > $o ).

tff(pred_def_84755,type,
    v141110: state_type > $o ).

tff(pred_def_84756,type,
    v141108: state_type > $o ).

tff(pred_def_84757,type,
    v141107: state_type > $o ).

tff(pred_def_84758,type,
    v141106: ( state_type * $int ) > $o ).

tff(pred_def_84759,type,
    v141118: state_type > $o ).

tff(pred_def_84760,type,
    v141116: state_type > $o ).

tff(pred_def_84761,type,
    v141115: state_type > $o ).

tff(pred_def_84762,type,
    v141114: ( state_type * $int ) > $o ).

tff(pred_def_84763,type,
    v141126: state_type > $o ).

tff(pred_def_84764,type,
    v141124: state_type > $o ).

tff(pred_def_84765,type,
    v141123: state_type > $o ).

tff(pred_def_84766,type,
    v141122: ( state_type * $int ) > $o ).

tff(pred_def_84767,type,
    v141134: state_type > $o ).

tff(pred_def_84768,type,
    v141132: state_type > $o ).

tff(pred_def_84769,type,
    v141131: state_type > $o ).

tff(pred_def_84770,type,
    v141130: ( state_type * $int ) > $o ).

tff(pred_def_84771,type,
    v141142: state_type > $o ).

tff(pred_def_84772,type,
    v141140: state_type > $o ).

tff(pred_def_84773,type,
    v141139: state_type > $o ).

tff(pred_def_84774,type,
    v141138: ( state_type * $int ) > $o ).

tff(pred_def_84775,type,
    v141150: state_type > $o ).

tff(pred_def_84776,type,
    v141148: state_type > $o ).

tff(pred_def_84777,type,
    v141147: state_type > $o ).

tff(pred_def_84778,type,
    v141146: ( state_type * $int ) > $o ).

tff(pred_def_84779,type,
    v141157: state_type > $o ).

tff(pred_def_84780,type,
    v141156: state_type > $o ).

tff(pred_def_84781,type,
    v141158: state_type > $o ).

tff(pred_def_84782,type,
    v141155: state_type > $o ).

tff(pred_def_84783,type,
    v141159: state_type > $o ).

tff(pred_def_84784,type,
    v141154: state_type > $o ).

tff(pred_def_84785,type,
    v141160: state_type > $o ).

tff(pred_def_84786,type,
    v5216: ( state_type * $int ) > $o ).

tff(pred_def_84787,type,
    v5214: ( state_type * $int ) > $o ).

tff(pred_def_84788,type,
    v5212: ( state_type * $int ) > $o ).

tff(pred_def_84789,type,
    v141172: ( state_type * $int ) > $o ).

tff(pred_def_84790,type,
    v141174: ( state_type * $int ) > $o ).

tff(pred_def_84791,type,
    v141170: ( state_type * $int ) > $o ).

tff(pred_def_84792,type,
    v141168: ( state_type * $int ) > $o ).

tff(pred_def_84793,type,
    v141166: ( state_type * $int ) > $o ).

tff(pred_def_84794,type,
    v141164: ( state_type * $int ) > $o ).

tff(pred_def_84795,type,
    v141162: ( state_type * $int ) > $o ).

tff(pred_def_84796,type,
    v141175: ( state_type * $int ) > $o ).

tff(pred_def_84797,type,
    v5210: ( state_type * $int ) > $o ).

tff(pred_def_84798,type,
    v141180: state_type > $o ).

tff(pred_def_84799,type,
    v141179: state_type > $o ).

tff(pred_def_84800,type,
    v141177: state_type > $o ).

tff(pred_def_84801,type,
    v141185: state_type > $o ).

tff(pred_def_84802,type,
    v141184: state_type > $o ).

tff(pred_def_84803,type,
    v141186: state_type > $o ).

tff(pred_def_84804,type,
    v141183: state_type > $o ).

tff(pred_def_84805,type,
    v141187: state_type > $o ).

tff(pred_def_84806,type,
    v141182: state_type > $o ).

tff(pred_def_84807,type,
    v141188: state_type > $o ).

tff(pred_def_84808,type,
    v141193: state_type > $o ).

tff(pred_def_84809,type,
    v141194: state_type > $o ).

tff(pred_def_84810,type,
    v141192: state_type > $o ).

tff(pred_def_84811,type,
    v141190: state_type > $o ).

tff(pred_def_84812,type,
    v141199: state_type > $o ).

tff(pred_def_84813,type,
    v141198: state_type > $o ).

tff(pred_def_84814,type,
    v141200: state_type > $o ).

tff(pred_def_84815,type,
    v141197: state_type > $o ).

tff(pred_def_84816,type,
    v141201: state_type > $o ).

tff(pred_def_84817,type,
    v141196: state_type > $o ).

tff(pred_def_84818,type,
    v141202: state_type > $o ).

tff(pred_def_84819,type,
    v141207: state_type > $o ).

tff(pred_def_84820,type,
    v141208: state_type > $o ).

tff(pred_def_84821,type,
    v141206: state_type > $o ).

tff(pred_def_84822,type,
    v141204: state_type > $o ).

tff(pred_def_84823,type,
    v141213: state_type > $o ).

tff(pred_def_84824,type,
    v141212: state_type > $o ).

tff(pred_def_84825,type,
    v141214: state_type > $o ).

tff(pred_def_84826,type,
    v141211: state_type > $o ).

tff(pred_def_84827,type,
    v141215: state_type > $o ).

tff(pred_def_84828,type,
    v141210: state_type > $o ).

tff(pred_def_84829,type,
    v141216: state_type > $o ).

tff(pred_def_84830,type,
    v141221: state_type > $o ).

tff(pred_def_84831,type,
    v141222: state_type > $o ).

tff(pred_def_84832,type,
    v141220: state_type > $o ).

tff(pred_def_84833,type,
    v141218: state_type > $o ).

tff(pred_def_84834,type,
    v141227: state_type > $o ).

tff(pred_def_84835,type,
    v141226: state_type > $o ).

tff(pred_def_84836,type,
    v141228: state_type > $o ).

tff(pred_def_84837,type,
    v141225: state_type > $o ).

tff(pred_def_84838,type,
    v141229: state_type > $o ).

tff(pred_def_84839,type,
    v141224: state_type > $o ).

tff(pred_def_84840,type,
    v141230: state_type > $o ).

tff(pred_def_84841,type,
    v141235: state_type > $o ).

tff(pred_def_84842,type,
    v141236: state_type > $o ).

tff(pred_def_84843,type,
    v141234: state_type > $o ).

tff(pred_def_84844,type,
    v141232: state_type > $o ).

tff(pred_def_84845,type,
    v141241: state_type > $o ).

tff(pred_def_84846,type,
    v141240: state_type > $o ).

tff(pred_def_84847,type,
    v141242: state_type > $o ).

tff(pred_def_84848,type,
    v141239: state_type > $o ).

tff(pred_def_84849,type,
    v141243: state_type > $o ).

tff(pred_def_84850,type,
    v141238: state_type > $o ).

tff(pred_def_84851,type,
    v141244: state_type > $o ).

tff(pred_def_84852,type,
    v141249: state_type > $o ).

tff(pred_def_84853,type,
    v141250: state_type > $o ).

tff(pred_def_84854,type,
    v141248: state_type > $o ).

tff(pred_def_84855,type,
    v141246: state_type > $o ).

tff(pred_def_84856,type,
    v141255: state_type > $o ).

tff(pred_def_84857,type,
    v141254: state_type > $o ).

tff(pred_def_84858,type,
    v141256: state_type > $o ).

tff(pred_def_84859,type,
    v141253: state_type > $o ).

tff(pred_def_84860,type,
    v141257: state_type > $o ).

tff(pred_def_84861,type,
    v141252: state_type > $o ).

tff(pred_def_84862,type,
    v141258: state_type > $o ).

tff(pred_def_84863,type,
    v141263: state_type > $o ).

tff(pred_def_84864,type,
    v141264: state_type > $o ).

tff(pred_def_84865,type,
    v141262: state_type > $o ).

tff(pred_def_84866,type,
    v141260: state_type > $o ).

tff(pred_def_84867,type,
    v141269: state_type > $o ).

tff(pred_def_84868,type,
    v141268: state_type > $o ).

tff(pred_def_84869,type,
    v141270: state_type > $o ).

tff(pred_def_84870,type,
    v141267: state_type > $o ).

tff(pred_def_84871,type,
    v141271: state_type > $o ).

tff(pred_def_84872,type,
    v141266: state_type > $o ).

tff(pred_def_84873,type,
    v141272: state_type > $o ).

tff(pred_def_84874,type,
    v141274: state_type > $o ).

tff(pred_def_84875,type,
    v5185: ( state_type * $int ) > $o ).

tff(pred_def_84876,type,
    v141276: state_type > $o ).

tff(pred_def_84877,type,
    v141278: state_type > $o ).

tff(pred_def_84878,type,
    v141280: state_type > $o ).

tff(pred_def_84879,type,
    v141282: state_type > $o ).

tff(pred_def_84880,type,
    v141284: state_type > $o ).

tff(pred_def_84881,type,
    v141286: state_type > $o ).

tff(pred_def_84882,type,
    v141288: state_type > $o ).

tff(pred_def_84883,type,
    v5183: ( state_type * $int ) > $o ).

tff(pred_def_84884,type,
    v5181: ( state_type * $int ) > $o ).

tff(pred_def_84885,type,
    v5179: ( state_type * $int ) > $o ).

tff(pred_def_84886,type,
    v141292: state_type > $o ).

tff(pred_def_84887,type,
    v141290: state_type > $o ).

tff(pred_def_84888,type,
    v141299: state_type > $o ).

tff(pred_def_84889,type,
    v141297: state_type > $o ).

tff(pred_def_84890,type,
    v141296: state_type > $o ).

tff(pred_def_84891,type,
    v141295: state_type > $o ).

tff(pred_def_84892,type,
    v141307: state_type > $o ).

tff(pred_def_84893,type,
    v141308: state_type > $o ).

tff(pred_def_84894,type,
    v141306: state_type > $o ).

tff(pred_def_84895,type,
    v141303: ( state_type * $int ) > $o ).

tff(pred_def_84896,type,
    v141305: ( state_type * $int ) > $o ).

tff(pred_def_84897,type,
    v5169: ( state_type * $int ) > $o ).

tff(pred_def_84898,type,
    v5167: ( state_type * $int ) > $o ).

tff(pred_def_84899,type,
    v141319: state_type > $o ).

tff(pred_def_84900,type,
    v141318: state_type > $o ).

tff(pred_def_84901,type,
    v141317: state_type > $o ).

tff(pred_def_84902,type,
    v141316: state_type > $o ).

tff(pred_def_84903,type,
    v141315: state_type > $o ).

tff(pred_def_84904,type,
    v141314: state_type > $o ).

tff(pred_def_84905,type,
    v141312: state_type > $o ).

tff(pred_def_84906,type,
    v5163: state_type > $o ).

tff(pred_def_84907,type,
    v5150: state_type > $o ).

tff(pred_def_84908,type,
    v5148: state_type > $o ).

tff(pred_def_84909,type,
    v5146: state_type > $o ).

tff(pred_def_84910,type,
    v141337: state_type > $o ).

tff(pred_def_84911,type,
    v141336: state_type > $o ).

tff(pred_def_84912,type,
    v141335: state_type > $o ).

tff(pred_def_84913,type,
    v141334: state_type > $o ).

tff(pred_def_84914,type,
    v141333: state_type > $o ).

tff(pred_def_84915,type,
    v141332: state_type > $o ).

tff(pred_def_84916,type,
    v141330: state_type > $o ).

tff(pred_def_84917,type,
    v141328: state_type > $o ).

tff(pred_def_84918,type,
    v141348: state_type > $o ).

tff(pred_def_84919,type,
    v141347: state_type > $o ).

tff(pred_def_84920,type,
    v141346: state_type > $o ).

tff(pred_def_84921,type,
    v141345: state_type > $o ).

tff(pred_def_84922,type,
    v141344: state_type > $o ).

tff(pred_def_84923,type,
    v141343: state_type > $o ).

tff(pred_def_84924,type,
    v141341: state_type > $o ).

tff(pred_def_84925,type,
    v141339: state_type > $o ).

tff(pred_def_84926,type,
    v141326: state_type > $o ).

tff(pred_def_84927,type,
    v141324: state_type > $o ).

tff(pred_def_84928,type,
    v141322: state_type > $o ).

tff(pred_def_84929,type,
    v141353: state_type > $o ).

tff(pred_def_84930,type,
    v141351: state_type > $o ).

tff(pred_def_84931,type,
    v141357: state_type > $o ).

tff(pred_def_84932,type,
    v141356: state_type > $o ).

tff(pred_def_84933,type,
    v141355: state_type > $o ).

tff(pred_def_84934,type,
    v141359: state_type > $o ).

tff(pred_def_84935,type,
    v141358: state_type > $o ).

tff(pred_def_84936,type,
    v5142: state_type > $o ).

tff(pred_def_84937,type,
    v5140: state_type > $o ).

tff(pred_def_84938,type,
    v141367: state_type > $o ).

tff(pred_def_84939,type,
    v141365: state_type > $o ).

tff(pred_def_84940,type,
    v141363: state_type > $o ).

tff(pred_def_84941,type,
    v141361: state_type > $o ).

tff(pred_def_84942,type,
    v141375: state_type > $o ).

tff(pred_def_84943,type,
    v141373: state_type > $o ).

tff(pred_def_84944,type,
    v141372: state_type > $o ).

tff(pred_def_84945,type,
    v141371: ( state_type * $int ) > $o ).

tff(pred_def_84946,type,
    v5118: state_type > $o ).

tff(pred_def_84947,type,
    v141384: state_type > $o ).

tff(pred_def_84948,type,
    v141382: state_type > $o ).

tff(pred_def_84949,type,
    v141381: state_type > $o ).

tff(pred_def_84950,type,
    v141380: ( state_type * $int ) > $o ).

tff(pred_def_84951,type,
    v141402: state_type > $o ).

tff(pred_def_84952,type,
    v141400: state_type > $o ).

tff(pred_def_84953,type,
    v141398: state_type > $o ).

tff(pred_def_84954,type,
    v141406: state_type > $o ).

tff(pred_def_84955,type,
    v141404: state_type > $o ).

tff(pred_def_84956,type,
    b101010: $int > $o ).

tff(pred_def_84957,type,
    v141416: ( state_type * $int ) > $o ).

tff(pred_def_84958,type,
    v141414: ( state_type * $int ) > $o ).

tff(pred_def_84959,type,
    v141412: ( state_type * $int ) > $o ).

tff(pred_def_84960,type,
    v141422: state_type > $o ).

tff(pred_def_84961,type,
    v141424: ( state_type * $int ) > $o ).

tff(pred_def_84962,type,
    b0100010110000: $int > $o ).

tff(pred_def_84963,type,
    v141427: state_type > $o ).

tff(pred_def_84964,type,
    v141420: state_type > $o ).

tff(pred_def_84965,type,
    v141418: state_type > $o ).

tff(pred_def_84966,type,
    v141431: state_type > $o ).

tff(pred_def_84967,type,
    v141430: ( state_type * $int ) > $o ).

tff(pred_def_84968,type,
    v141429: ( state_type * $int ) > $o ).

tff(pred_def_84969,type,
    v141435: state_type > $o ).

tff(pred_def_84970,type,
    v141434: ( state_type * $int ) > $o ).

tff(pred_def_84971,type,
    v141433: ( state_type * $int ) > $o ).

tff(pred_def_84972,type,
    v141394: ( state_type * $int ) > $o ).

tff(pred_def_84973,type,
    v141432: ( state_type * $int ) > $o ).

tff(pred_def_84974,type,
    v141428: ( state_type * $int ) > $o ).

tff(pred_def_84975,type,
    v141410: ( state_type * $int ) > $o ).

tff(pred_def_84976,type,
    v141408: ( state_type * $int ) > $o ).

tff(pred_def_84977,type,
    v141439: state_type > $o ).

tff(pred_def_84978,type,
    v141437: state_type > $o ).

tff(pred_def_84979,type,
    v141446: state_type > $o ).

tff(pred_def_84980,type,
    v141444: state_type > $o ).

tff(pred_def_84981,type,
    v141443: state_type > $o ).

tff(pred_def_84982,type,
    v141442: state_type > $o ).

tff(pred_def_84983,type,
    v141454: state_type > $o ).

tff(pred_def_84984,type,
    v141455: state_type > $o ).

tff(pred_def_84985,type,
    v141453: state_type > $o ).

tff(pred_def_84986,type,
    v141450: ( state_type * $int ) > $o ).

tff(pred_def_84987,type,
    v141452: ( state_type * $int ) > $o ).

tff(pred_def_84988,type,
    v141441: ( state_type * $int ) > $o ).

tff(pred_def_84989,type,
    v141396: ( state_type * $int ) > $o ).

tff(pred_def_84990,type,
    v141392: ( state_type * $int ) > $o ).

tff(pred_def_84991,type,
    v141458: ( state_type * $int ) > $o ).

tff(pred_def_84992,type,
    v141390: ( state_type * $int ) > $o ).

tff(pred_def_84993,type,
    v141388: ( state_type * $int ) > $o ).

tff(pred_def_84994,type,
    v141461: state_type > $o ).

tff(pred_def_84995,type,
    v141460: state_type > $o ).

tff(pred_def_84996,type,
    v141459: ( state_type * $int ) > $o ).

tff(pred_def_84997,type,
    v5047: ( state_type * $int ) > $o ).

tff(pred_def_84998,type,
    v5045: ( state_type * $int ) > $o ).

tff(pred_def_84999,type,
    v5043: ( state_type * $int ) > $o ).

tff(pred_def_85000,type,
    v141467: state_type > $o ).

tff(pred_def_85001,type,
    v141465: state_type > $o ).

tff(pred_def_85002,type,
    v141464: state_type > $o ).

tff(pred_def_85003,type,
    v141463: ( state_type * $int ) > $o ).

tff(pred_def_85004,type,
    v141475: state_type > $o ).

tff(pred_def_85005,type,
    v141473: state_type > $o ).

tff(pred_def_85006,type,
    v141472: state_type > $o ).

tff(pred_def_85007,type,
    v141471: ( state_type * $int ) > $o ).

tff(pred_def_85008,type,
    v141483: state_type > $o ).

tff(pred_def_85009,type,
    v141481: state_type > $o ).

tff(pred_def_85010,type,
    v141480: state_type > $o ).

tff(pred_def_85011,type,
    v141479: ( state_type * $int ) > $o ).

tff(pred_def_85012,type,
    v141491: state_type > $o ).

tff(pred_def_85013,type,
    v141489: state_type > $o ).

tff(pred_def_85014,type,
    v141488: state_type > $o ).

tff(pred_def_85015,type,
    v141487: ( state_type * $int ) > $o ).

tff(pred_def_85016,type,
    v141499: state_type > $o ).

tff(pred_def_85017,type,
    v141497: state_type > $o ).

tff(pred_def_85018,type,
    v141496: state_type > $o ).

tff(pred_def_85019,type,
    v141495: ( state_type * $int ) > $o ).

tff(pred_def_85020,type,
    v141507: state_type > $o ).

tff(pred_def_85021,type,
    v141505: state_type > $o ).

tff(pred_def_85022,type,
    v141504: state_type > $o ).

tff(pred_def_85023,type,
    v141503: ( state_type * $int ) > $o ).

tff(pred_def_85024,type,
    v141515: state_type > $o ).

tff(pred_def_85025,type,
    v141513: state_type > $o ).

tff(pred_def_85026,type,
    v141512: state_type > $o ).

tff(pred_def_85027,type,
    v141511: ( state_type * $int ) > $o ).

tff(pred_def_85028,type,
    v141523: state_type > $o ).

tff(pred_def_85029,type,
    v141521: state_type > $o ).

tff(pred_def_85030,type,
    v141520: state_type > $o ).

tff(pred_def_85031,type,
    v141519: ( state_type * $int ) > $o ).

tff(pred_def_85032,type,
    v141531: state_type > $o ).

tff(pred_def_85033,type,
    v141529: state_type > $o ).

tff(pred_def_85034,type,
    v141528: state_type > $o ).

tff(pred_def_85035,type,
    v141527: ( state_type * $int ) > $o ).

tff(pred_def_85036,type,
    v141539: state_type > $o ).

tff(pred_def_85037,type,
    v141537: state_type > $o ).

tff(pred_def_85038,type,
    v141536: state_type > $o ).

tff(pred_def_85039,type,
    v141535: ( state_type * $int ) > $o ).

tff(pred_def_85040,type,
    v141544: state_type > $o ).

tff(pred_def_85041,type,
    v141543: ( state_type * $int ) > $o ).

tff(pred_def_85042,type,
    v141559: state_type > $o ).

tff(pred_def_85043,type,
    v141558: state_type > $o ).

tff(pred_def_85044,type,
    v141557: state_type > $o ).

tff(pred_def_85045,type,
    v141560: state_type > $o ).

tff(pred_def_85046,type,
    v141556: state_type > $o ).

tff(pred_def_85047,type,
    v141555: state_type > $o ).

tff(pred_def_85048,type,
    v141561: state_type > $o ).

tff(pred_def_85049,type,
    v141554: state_type > $o ).

tff(pred_def_85050,type,
    v141553: state_type > $o ).

tff(pred_def_85051,type,
    v141562: state_type > $o ).

tff(pred_def_85052,type,
    v141552: state_type > $o ).

tff(pred_def_85053,type,
    v141551: state_type > $o ).

tff(pred_def_85054,type,
    v141550: state_type > $o ).

tff(pred_def_85055,type,
    v141549: state_type > $o ).

tff(pred_def_85056,type,
    v141564: state_type > $o ).

tff(pred_def_85057,type,
    v141563: state_type > $o ).

tff(pred_def_85058,type,
    v141548: state_type > $o ).

tff(pred_def_85059,type,
    v141567: state_type > $o ).

tff(pred_def_85060,type,
    v141566: state_type > $o ).

tff(pred_def_85061,type,
    v141568: state_type > $o ).

tff(pred_def_85062,type,
    v141565: state_type > $o ).

tff(pred_def_85063,type,
    v141571: state_type > $o ).

tff(pred_def_85064,type,
    v141570: state_type > $o ).

tff(pred_def_85065,type,
    v141572: state_type > $o ).

tff(pred_def_85066,type,
    v141569: state_type > $o ).

tff(pred_def_85067,type,
    v141575: state_type > $o ).

tff(pred_def_85068,type,
    v141574: state_type > $o ).

tff(pred_def_85069,type,
    v141576: state_type > $o ).

tff(pred_def_85070,type,
    v141573: state_type > $o ).

tff(pred_def_85071,type,
    v141579: state_type > $o ).

tff(pred_def_85072,type,
    v141578: state_type > $o ).

tff(pred_def_85073,type,
    v141580: state_type > $o ).

tff(pred_def_85074,type,
    v141577: state_type > $o ).

tff(pred_def_85075,type,
    v141546: ( state_type * $int ) > $o ).

tff(pred_def_85076,type,
    v141594: state_type > $o ).

tff(pred_def_85077,type,
    v141593: state_type > $o ).

tff(pred_def_85078,type,
    v141592: state_type > $o ).

tff(pred_def_85079,type,
    v141595: state_type > $o ).

tff(pred_def_85080,type,
    v141591: state_type > $o ).

tff(pred_def_85081,type,
    v141590: state_type > $o ).

tff(pred_def_85082,type,
    v141596: state_type > $o ).

tff(pred_def_85083,type,
    v141589: state_type > $o ).

tff(pred_def_85084,type,
    v141588: state_type > $o ).

tff(pred_def_85085,type,
    v141597: state_type > $o ).

tff(pred_def_85086,type,
    v141587: state_type > $o ).

tff(pred_def_85087,type,
    v141586: state_type > $o ).

tff(pred_def_85088,type,
    v141585: state_type > $o ).

tff(pred_def_85089,type,
    v141584: state_type > $o ).

tff(pred_def_85090,type,
    v141599: state_type > $o ).

tff(pred_def_85091,type,
    v141598: state_type > $o ).

tff(pred_def_85092,type,
    v141583: state_type > $o ).

tff(pred_def_85093,type,
    v141602: state_type > $o ).

tff(pred_def_85094,type,
    v141601: state_type > $o ).

tff(pred_def_85095,type,
    v141603: state_type > $o ).

tff(pred_def_85096,type,
    v141600: state_type > $o ).

tff(pred_def_85097,type,
    v141606: state_type > $o ).

tff(pred_def_85098,type,
    v141605: state_type > $o ).

tff(pred_def_85099,type,
    v141607: state_type > $o ).

tff(pred_def_85100,type,
    v141604: state_type > $o ).

tff(pred_def_85101,type,
    v141610: state_type > $o ).

tff(pred_def_85102,type,
    v141609: state_type > $o ).

tff(pred_def_85103,type,
    v141611: state_type > $o ).

tff(pred_def_85104,type,
    v141608: state_type > $o ).

tff(pred_def_85105,type,
    v141614: state_type > $o ).

tff(pred_def_85106,type,
    v141613: state_type > $o ).

tff(pred_def_85107,type,
    v141615: state_type > $o ).

tff(pred_def_85108,type,
    v141612: state_type > $o ).

tff(pred_def_85109,type,
    v141581: ( state_type * $int ) > $o ).

tff(pred_def_85110,type,
    v141545: ( state_type * $int ) > $o ).

tff(pred_def_85111,type,
    v4566: ( state_type * $int ) > $o ).

tff(pred_def_85112,type,
    v4564: ( state_type * $int ) > $o ).

tff(pred_def_85113,type,
    v4562: ( state_type * $int ) > $o ).

tff(pred_def_85114,type,
    v4560: ( state_type * $int ) > $o ).

tff(pred_def_85115,type,
    v141619: state_type > $o ).

tff(pred_def_85116,type,
    v141617: state_type > $o ).

tff(pred_def_85117,type,
    v141626: state_type > $o ).

tff(pred_def_85118,type,
    v141624: state_type > $o ).

tff(pred_def_85119,type,
    v141623: state_type > $o ).

tff(pred_def_85120,type,
    v141622: state_type > $o ).

tff(pred_def_85121,type,
    v141634: state_type > $o ).

tff(pred_def_85122,type,
    v141635: state_type > $o ).

tff(pred_def_85123,type,
    v141633: state_type > $o ).

tff(pred_def_85124,type,
    v141630: ( state_type * $int ) > $o ).

tff(pred_def_85125,type,
    v141632: ( state_type * $int ) > $o ).

tff(pred_def_85126,type,
    v4538: ( state_type * $int ) > $o ).

tff(pred_def_85127,type,
    v4536: ( state_type * $int ) > $o ).

tff(pred_def_85128,type,
    v4532: ( state_type * $int ) > $o ).

tff(pred_def_85129,type,
    v4528: state_type > $o ).

tff(pred_def_85130,type,
    v4526: state_type > $o ).

tff(pred_def_85131,type,
    v141640: state_type > $o ).

tff(pred_def_85132,type,
    v4520: state_type > $o ).

tff(pred_def_85133,type,
    v141647: state_type > $o ).

tff(pred_def_85134,type,
    v141645: state_type > $o ).

tff(pred_def_85135,type,
    v141644: state_type > $o ).

tff(pred_def_85136,type,
    v141643: state_type > $o ).

tff(pred_def_85137,type,
    v141655: state_type > $o ).

tff(pred_def_85138,type,
    v141656: state_type > $o ).

tff(pred_def_85139,type,
    v141654: state_type > $o ).

tff(pred_def_85140,type,
    v141651: state_type > $o ).

tff(pred_def_85141,type,
    v141653: state_type > $o ).

tff(pred_def_85142,type,
    v4518: state_type > $o ).

tff(pred_def_85143,type,
    v141661: state_type > $o ).

tff(pred_def_85144,type,
    v141660: state_type > $o ).

tff(pred_def_85145,type,
    v141673: state_type > $o ).

tff(pred_def_85146,type,
    v141671: state_type > $o ).

tff(pred_def_85147,type,
    v141677: state_type > $o ).

tff(pred_def_85148,type,
    v141675: state_type > $o ).

tff(pred_def_85149,type,
    v2872: ( state_type * $int ) > $o ).

tff(pred_def_85150,type,
    v141685: state_type > $o ).

tff(pred_def_85151,type,
    v141687: ( state_type * $int ) > $o ).

tff(pred_def_85152,type,
    v141665: state_type > $o ).

tff(pred_def_85153,type,
    v141688: state_type > $o ).

tff(pred_def_85154,type,
    v141683: ( state_type * $int ) > $o ).

tff(pred_def_85155,type,
    v141681: ( state_type * $int ) > $o ).

tff(pred_def_85156,type,
    v141679: ( state_type * $int ) > $o ).

tff(pred_def_85157,type,
    v141692: state_type > $o ).

tff(pred_def_85158,type,
    v141690: state_type > $o ).

tff(pred_def_85159,type,
    v141699: state_type > $o ).

tff(pred_def_85160,type,
    v141697: state_type > $o ).

tff(pred_def_85161,type,
    v141696: state_type > $o ).

tff(pred_def_85162,type,
    v141695: state_type > $o ).

tff(pred_def_85163,type,
    v141707: state_type > $o ).

tff(pred_def_85164,type,
    v141708: state_type > $o ).

tff(pred_def_85165,type,
    v141706: state_type > $o ).

tff(pred_def_85166,type,
    v141703: ( state_type * $int ) > $o ).

tff(pred_def_85167,type,
    v141705: ( state_type * $int ) > $o ).

tff(pred_def_85168,type,
    v141694: ( state_type * $int ) > $o ).

tff(pred_def_85169,type,
    v141669: ( state_type * $int ) > $o ).

tff(pred_def_85170,type,
    v141667: ( state_type * $int ) > $o ).

tff(pred_def_85171,type,
    v141717: state_type > $o ).

tff(pred_def_85172,type,
    v141715: state_type > $o ).

tff(pred_def_85173,type,
    v141714: state_type > $o ).

tff(pred_def_85174,type,
    v141713: ( state_type * $int ) > $o ).

tff(pred_def_85175,type,
    v141727: state_type > $o ).

tff(pred_def_85176,type,
    v141725: state_type > $o ).

tff(pred_def_85177,type,
    v141724: state_type > $o ).

tff(pred_def_85178,type,
    v141723: ( state_type * $int ) > $o ).

tff(pred_def_85179,type,
    v141721: state_type > $o ).

tff(pred_def_85180,type,
    v141734: state_type > $o ).

tff(pred_def_85181,type,
    v141733: ( state_type * $int ) > $o ).

tff(pred_def_85182,type,
    v141732: ( state_type * $int ) > $o ).

tff(pred_def_85183,type,
    v141731: ( state_type * $int ) > $o ).

tff(pred_def_85184,type,
    v141735: ( state_type * $int ) > $o ).

tff(pred_def_85185,type,
    v141663: ( state_type * $int ) > $o ).

tff(pred_def_85186,type,
    v141744: state_type > $o ).

tff(pred_def_85187,type,
    v141747: ( state_type * $int ) > $o ).

tff(pred_def_85188,type,
    v141746: ( state_type * $int ) > $o ).

tff(pred_def_85189,type,
    v141745: ( state_type * $int ) > $o ).

tff(pred_def_85190,type,
    v141743: ( state_type * $int ) > $o ).

tff(pred_def_85191,type,
    v141741: ( state_type * $int ) > $o ).

tff(pred_def_85192,type,
    v141739: ( state_type * $int ) > $o ).

tff(pred_def_85193,type,
    v141737: ( state_type * $int ) > $o ).

tff(pred_def_85194,type,
    v141761: state_type > $o ).

tff(pred_def_85195,type,
    v141760: state_type > $o ).

tff(pred_def_85196,type,
    v141759: state_type > $o ).

tff(pred_def_85197,type,
    v141758: state_type > $o ).

tff(pred_def_85198,type,
    v141757: ( state_type * $int ) > $o ).

tff(pred_def_85199,type,
    v141756: ( state_type * $int ) > $o ).

tff(pred_def_85200,type,
    v141755: ( state_type * $int ) > $o ).

tff(pred_def_85201,type,
    v141753: ( state_type * $int ) > $o ).

tff(pred_def_85202,type,
    v141751: ( state_type * $int ) > $o ).

tff(pred_def_85203,type,
    v141749: ( state_type * $int ) > $o ).

tff(pred_def_85204,type,
    v141773: state_type > $o ).

tff(pred_def_85205,type,
    v141771: state_type > $o ).

tff(pred_def_85206,type,
    v141777: state_type > $o ).

tff(pred_def_85207,type,
    v141775: state_type > $o ).

tff(pred_def_85208,type,
    v141791: state_type > $o ).

tff(pred_def_85209,type,
    v141789: state_type > $o ).

tff(pred_def_85210,type,
    v141787: state_type > $o ).

tff(pred_def_85211,type,
    b0100100001000: $int > $o ).

tff(pred_def_85212,type,
    v141796: state_type > $o ).

tff(pred_def_85213,type,
    v141795: state_type > $o ).

tff(pred_def_85214,type,
    v141797: state_type > $o ).

tff(pred_def_85215,type,
    v141794: state_type > $o ).

tff(pred_def_85216,type,
    v141800: state_type > $o ).

tff(pred_def_85217,type,
    v141763: state_type > $o ).

tff(pred_def_85218,type,
    v141799: state_type > $o ).

tff(pred_def_85219,type,
    v141798: state_type > $o ).

tff(pred_def_85220,type,
    v141765: state_type > $o ).

tff(pred_def_85221,type,
    v141785: state_type > $o ).

tff(pred_def_85222,type,
    v141802: state_type > $o ).

tff(pred_def_85223,type,
    v141801: ( state_type * $int ) > $o ).

tff(pred_def_85224,type,
    v141783: ( state_type * $int ) > $o ).

tff(pred_def_85225,type,
    v141781: ( state_type * $int ) > $o ).

tff(pred_def_85226,type,
    v141779: ( state_type * $int ) > $o ).

tff(pred_def_85227,type,
    v141806: state_type > $o ).

tff(pred_def_85228,type,
    v141804: state_type > $o ).

tff(pred_def_85229,type,
    v141813: state_type > $o ).

tff(pred_def_85230,type,
    v141811: state_type > $o ).

tff(pred_def_85231,type,
    v141810: state_type > $o ).

tff(pred_def_85232,type,
    v141809: state_type > $o ).

tff(pred_def_85233,type,
    v141821: state_type > $o ).

tff(pred_def_85234,type,
    v141822: state_type > $o ).

tff(pred_def_85235,type,
    v141820: state_type > $o ).

tff(pred_def_85236,type,
    v141817: ( state_type * $int ) > $o ).

tff(pred_def_85237,type,
    v141819: ( state_type * $int ) > $o ).

tff(pred_def_85238,type,
    v141808: ( state_type * $int ) > $o ).

tff(pred_def_85239,type,
    v141769: ( state_type * $int ) > $o ).

tff(pred_def_85240,type,
    v141767: ( state_type * $int ) > $o ).

tff(pred_def_85241,type,
    v141833: state_type > $o ).

tff(pred_def_85242,type,
    v141834: state_type > $o ).

tff(pred_def_85243,type,
    v141832: state_type > $o ).

tff(pred_def_85244,type,
    v141835: state_type > $o ).

tff(pred_def_85245,type,
    v141831: state_type > $o ).

tff(pred_def_85246,type,
    v141836: state_type > $o ).

tff(pred_def_85247,type,
    v141830: state_type > $o ).

tff(pred_def_85248,type,
    v141837: state_type > $o ).

tff(pred_def_85249,type,
    v141829: state_type > $o ).

tff(pred_def_85250,type,
    v141838: state_type > $o ).

tff(pred_def_85251,type,
    v141828: state_type > $o ).

tff(pred_def_85252,type,
    v141839: state_type > $o ).

tff(pred_def_85253,type,
    v141826: state_type > $o ).

tff(pred_def_85254,type,
    v141842: state_type > $o ).

tff(pred_def_85255,type,
    v141841: state_type > $o ).

tff(pred_def_85256,type,
    v141844: ( state_type * $int ) > $o ).

tff(pred_def_85257,type,
    v141847: state_type > $o ).

tff(pred_def_85258,type,
    v141849: state_type > $o ).

tff(pred_def_85259,type,
    v141852: state_type > $o ).

tff(pred_def_85260,type,
    v141853: state_type > $o ).

tff(pred_def_85261,type,
    v141851: state_type > $o ).

tff(pred_def_85262,type,
    v141856: state_type > $o ).

tff(pred_def_85263,type,
    v141857: state_type > $o ).

tff(pred_def_85264,type,
    v141855: state_type > $o ).

tff(pred_def_85265,type,
    v141858: ( state_type * $int ) > $o ).

tff(pred_def_85266,type,
    v141854: ( state_type * $int ) > $o ).

tff(pred_def_85267,type,
    v141850: ( state_type * $int ) > $o ).

tff(pred_def_85268,type,
    v141848: ( state_type * $int ) > $o ).

tff(pred_def_85269,type,
    v141846: ( state_type * $int ) > $o ).

tff(pred_def_85270,type,
    v141845: ( state_type * $int ) > $o ).

tff(pred_def_85271,type,
    v141862: state_type > $o ).

tff(pred_def_85272,type,
    v2809: state_type > $o ).

tff(pred_def_85273,type,
    v141861: ( state_type * $int ) > $o ).

tff(pred_def_85274,type,
    v141860: ( state_type * $int ) > $o ).

tff(pred_def_85275,type,
    v141866: state_type > $o ).

tff(pred_def_85276,type,
    v141865: ( state_type * $int ) > $o ).

tff(pred_def_85277,type,
    v141864: ( state_type * $int ) > $o ).

tff(pred_def_85278,type,
    v2304: ( state_type * $int ) > $o ).

tff(pred_def_85279,type,
    v141863: ( state_type * $int ) > $o ).

tff(pred_def_85280,type,
    v141859: ( state_type * $int ) > $o ).

tff(pred_def_85281,type,
    v2318: ( state_type * $int ) > $o ).

tff(pred_def_85282,type,
    v2316: ( state_type * $int ) > $o ).

tff(pred_def_85283,type,
    v141870: state_type > $o ).

tff(pred_def_85284,type,
    v141868: state_type > $o ).

tff(pred_def_85285,type,
    v141877: state_type > $o ).

tff(pred_def_85286,type,
    v141875: state_type > $o ).

tff(pred_def_85287,type,
    v141874: state_type > $o ).

tff(pred_def_85288,type,
    v141873: state_type > $o ).

tff(pred_def_85289,type,
    v141885: state_type > $o ).

tff(pred_def_85290,type,
    v141886: state_type > $o ).

tff(pred_def_85291,type,
    v141884: state_type > $o ).

tff(pred_def_85292,type,
    v141881: ( state_type * $int ) > $o ).

tff(pred_def_85293,type,
    v141883: ( state_type * $int ) > $o ).

tff(pred_def_85294,type,
    v141872: ( state_type * $int ) > $o ).

tff(pred_def_85295,type,
    v2306: ( state_type * $int ) > $o ).

tff(pred_def_85296,type,
    v2302: ( state_type * $int ) > $o ).

tff(pred_def_85297,type,
    v141898: state_type > $o ).

tff(pred_def_85298,type,
    v141896: state_type > $o ).

tff(pred_def_85299,type,
    v141902: state_type > $o ).

tff(pred_def_85300,type,
    v141900: state_type > $o ).

tff(pred_def_85301,type,
    v141908: ( state_type * $int ) > $o ).

tff(pred_def_85302,type,
    v141914: state_type > $o ).

tff(pred_def_85303,type,
    v2868: state_type > $o ).

tff(pred_def_85304,type,
    v141912: state_type > $o ).

tff(pred_def_85305,type,
    v141910: state_type > $o ).

tff(pred_def_85306,type,
    v141918: state_type > $o ).

tff(pred_def_85307,type,
    v141917: ( state_type * $int ) > $o ).

tff(pred_def_85308,type,
    v141916: ( state_type * $int ) > $o ).

tff(pred_def_85309,type,
    v141922: state_type > $o ).

tff(pred_def_85310,type,
    v141921: ( state_type * $int ) > $o ).

tff(pred_def_85311,type,
    v141920: ( state_type * $int ) > $o ).

tff(pred_def_85312,type,
    v141892: ( state_type * $int ) > $o ).

tff(pred_def_85313,type,
    v141919: ( state_type * $int ) > $o ).

tff(pred_def_85314,type,
    v141915: ( state_type * $int ) > $o ).

tff(pred_def_85315,type,
    v141906: ( state_type * $int ) > $o ).

tff(pred_def_85316,type,
    v141904: ( state_type * $int ) > $o ).

tff(pred_def_85317,type,
    v141926: state_type > $o ).

tff(pred_def_85318,type,
    v141924: state_type > $o ).

tff(pred_def_85319,type,
    v141933: state_type > $o ).

tff(pred_def_85320,type,
    v141931: state_type > $o ).

tff(pred_def_85321,type,
    v141930: state_type > $o ).

tff(pred_def_85322,type,
    v141929: state_type > $o ).

tff(pred_def_85323,type,
    v141941: state_type > $o ).

tff(pred_def_85324,type,
    v141942: state_type > $o ).

tff(pred_def_85325,type,
    v141940: state_type > $o ).

tff(pred_def_85326,type,
    v141937: ( state_type * $int ) > $o ).

tff(pred_def_85327,type,
    v141939: ( state_type * $int ) > $o ).

tff(pred_def_85328,type,
    v141928: ( state_type * $int ) > $o ).

tff(pred_def_85329,type,
    v141894: ( state_type * $int ) > $o ).

tff(pred_def_85330,type,
    v141890: ( state_type * $int ) > $o ).

tff(pred_def_85331,type,
    v141954: state_type > $o ).

tff(pred_def_85332,type,
    v141952: state_type > $o ).

tff(pred_def_85333,type,
    v141958: state_type > $o ).

tff(pred_def_85334,type,
    v141956: state_type > $o ).

tff(pred_def_85335,type,
    v141964: ( state_type * $int ) > $o ).

tff(pred_def_85336,type,
    v141970: state_type > $o ).

tff(pred_def_85337,type,
    v141968: state_type > $o ).

tff(pred_def_85338,type,
    v141966: state_type > $o ).

tff(pred_def_85339,type,
    v141974: state_type > $o ).

tff(pred_def_85340,type,
    v141973: ( state_type * $int ) > $o ).

tff(pred_def_85341,type,
    v141972: ( state_type * $int ) > $o ).

tff(pred_def_85342,type,
    v141978: state_type > $o ).

tff(pred_def_85343,type,
    v141977: ( state_type * $int ) > $o ).

tff(pred_def_85344,type,
    v141976: ( state_type * $int ) > $o ).

tff(pred_def_85345,type,
    v141948: ( state_type * $int ) > $o ).

tff(pred_def_85346,type,
    v141975: ( state_type * $int ) > $o ).

tff(pred_def_85347,type,
    v141971: ( state_type * $int ) > $o ).

tff(pred_def_85348,type,
    v141962: ( state_type * $int ) > $o ).

tff(pred_def_85349,type,
    v141960: ( state_type * $int ) > $o ).

tff(pred_def_85350,type,
    v141982: state_type > $o ).

tff(pred_def_85351,type,
    v141980: state_type > $o ).

tff(pred_def_85352,type,
    v141989: state_type > $o ).

tff(pred_def_85353,type,
    v141987: state_type > $o ).

tff(pred_def_85354,type,
    v141986: state_type > $o ).

tff(pred_def_85355,type,
    v141985: state_type > $o ).

tff(pred_def_85356,type,
    v141997: state_type > $o ).

tff(pred_def_85357,type,
    v141998: state_type > $o ).

tff(pred_def_85358,type,
    v141996: state_type > $o ).

tff(pred_def_85359,type,
    v141993: ( state_type * $int ) > $o ).

tff(pred_def_85360,type,
    v141995: ( state_type * $int ) > $o ).

tff(pred_def_85361,type,
    v141984: ( state_type * $int ) > $o ).

tff(pred_def_85362,type,
    v141950: ( state_type * $int ) > $o ).

tff(pred_def_85363,type,
    v141946: ( state_type * $int ) > $o ).

tff(pred_def_85364,type,
    v142010: state_type > $o ).

tff(pred_def_85365,type,
    v142008: state_type > $o ).

tff(pred_def_85366,type,
    v142014: state_type > $o ).

tff(pred_def_85367,type,
    v142012: state_type > $o ).

tff(pred_def_85368,type,
    v142020: ( state_type * $int ) > $o ).

tff(pred_def_85369,type,
    v142026: state_type > $o ).

tff(pred_def_85370,type,
    v142024: state_type > $o ).

tff(pred_def_85371,type,
    v142022: state_type > $o ).

tff(pred_def_85372,type,
    v142030: state_type > $o ).

tff(pred_def_85373,type,
    v142029: ( state_type * $int ) > $o ).

tff(pred_def_85374,type,
    v142028: ( state_type * $int ) > $o ).

tff(pred_def_85375,type,
    v142034: state_type > $o ).

tff(pred_def_85376,type,
    v142033: ( state_type * $int ) > $o ).

tff(pred_def_85377,type,
    v142032: ( state_type * $int ) > $o ).

tff(pred_def_85378,type,
    v142004: ( state_type * $int ) > $o ).

tff(pred_def_85379,type,
    v142031: ( state_type * $int ) > $o ).

tff(pred_def_85380,type,
    v142027: ( state_type * $int ) > $o ).

tff(pred_def_85381,type,
    v142018: ( state_type * $int ) > $o ).

tff(pred_def_85382,type,
    v142016: ( state_type * $int ) > $o ).

tff(pred_def_85383,type,
    v142038: state_type > $o ).

tff(pred_def_85384,type,
    v142036: state_type > $o ).

tff(pred_def_85385,type,
    v142045: state_type > $o ).

tff(pred_def_85386,type,
    v142043: state_type > $o ).

tff(pred_def_85387,type,
    v142042: state_type > $o ).

tff(pred_def_85388,type,
    v142041: state_type > $o ).

tff(pred_def_85389,type,
    v142053: state_type > $o ).

tff(pred_def_85390,type,
    v142054: state_type > $o ).

tff(pred_def_85391,type,
    v142052: state_type > $o ).

tff(pred_def_85392,type,
    v142049: ( state_type * $int ) > $o ).

tff(pred_def_85393,type,
    v142051: ( state_type * $int ) > $o ).

tff(pred_def_85394,type,
    v142040: ( state_type * $int ) > $o ).

tff(pred_def_85395,type,
    v142006: ( state_type * $int ) > $o ).

tff(pred_def_85396,type,
    v142002: ( state_type * $int ) > $o ).

tff(pred_def_85397,type,
    v142066: state_type > $o ).

tff(pred_def_85398,type,
    v142064: state_type > $o ).

tff(pred_def_85399,type,
    v142070: state_type > $o ).

tff(pred_def_85400,type,
    v142068: state_type > $o ).

tff(pred_def_85401,type,
    v142076: ( state_type * $int ) > $o ).

tff(pred_def_85402,type,
    v142082: state_type > $o ).

tff(pred_def_85403,type,
    v142080: state_type > $o ).

tff(pred_def_85404,type,
    v142078: state_type > $o ).

tff(pred_def_85405,type,
    v142086: state_type > $o ).

tff(pred_def_85406,type,
    v142085: ( state_type * $int ) > $o ).

tff(pred_def_85407,type,
    v142084: ( state_type * $int ) > $o ).

tff(pred_def_85408,type,
    v142090: state_type > $o ).

tff(pred_def_85409,type,
    v142089: ( state_type * $int ) > $o ).

tff(pred_def_85410,type,
    v142088: ( state_type * $int ) > $o ).

tff(pred_def_85411,type,
    v142060: ( state_type * $int ) > $o ).

tff(pred_def_85412,type,
    v142087: ( state_type * $int ) > $o ).

tff(pred_def_85413,type,
    v142083: ( state_type * $int ) > $o ).

tff(pred_def_85414,type,
    v142074: ( state_type * $int ) > $o ).

tff(pred_def_85415,type,
    v142072: ( state_type * $int ) > $o ).

tff(pred_def_85416,type,
    v142094: state_type > $o ).

tff(pred_def_85417,type,
    v142092: state_type > $o ).

tff(pred_def_85418,type,
    v142101: state_type > $o ).

tff(pred_def_85419,type,
    v142099: state_type > $o ).

tff(pred_def_85420,type,
    v142098: state_type > $o ).

tff(pred_def_85421,type,
    v142097: state_type > $o ).

tff(pred_def_85422,type,
    v142109: state_type > $o ).

tff(pred_def_85423,type,
    v142110: state_type > $o ).

tff(pred_def_85424,type,
    v142108: state_type > $o ).

tff(pred_def_85425,type,
    v142105: ( state_type * $int ) > $o ).

tff(pred_def_85426,type,
    v142107: ( state_type * $int ) > $o ).

tff(pred_def_85427,type,
    v142096: ( state_type * $int ) > $o ).

tff(pred_def_85428,type,
    v142062: ( state_type * $int ) > $o ).

tff(pred_def_85429,type,
    v142058: ( state_type * $int ) > $o ).

tff(pred_def_85430,type,
    v142122: state_type > $o ).

tff(pred_def_85431,type,
    v142120: state_type > $o ).

tff(pred_def_85432,type,
    v142126: state_type > $o ).

tff(pred_def_85433,type,
    v142124: state_type > $o ).

tff(pred_def_85434,type,
    v142132: ( state_type * $int ) > $o ).

tff(pred_def_85435,type,
    v142138: state_type > $o ).

tff(pred_def_85436,type,
    v142136: state_type > $o ).

tff(pred_def_85437,type,
    v142134: state_type > $o ).

tff(pred_def_85438,type,
    v142142: state_type > $o ).

tff(pred_def_85439,type,
    v142141: ( state_type * $int ) > $o ).

tff(pred_def_85440,type,
    v142140: ( state_type * $int ) > $o ).

tff(pred_def_85441,type,
    v142146: state_type > $o ).

tff(pred_def_85442,type,
    v142145: ( state_type * $int ) > $o ).

tff(pred_def_85443,type,
    v142144: ( state_type * $int ) > $o ).

tff(pred_def_85444,type,
    v142116: ( state_type * $int ) > $o ).

tff(pred_def_85445,type,
    v142143: ( state_type * $int ) > $o ).

tff(pred_def_85446,type,
    v142139: ( state_type * $int ) > $o ).

tff(pred_def_85447,type,
    v142130: ( state_type * $int ) > $o ).

tff(pred_def_85448,type,
    v142128: ( state_type * $int ) > $o ).

tff(pred_def_85449,type,
    v142150: state_type > $o ).

tff(pred_def_85450,type,
    v142148: state_type > $o ).

tff(pred_def_85451,type,
    v142157: state_type > $o ).

tff(pred_def_85452,type,
    v142155: state_type > $o ).

tff(pred_def_85453,type,
    v142154: state_type > $o ).

tff(pred_def_85454,type,
    v142153: state_type > $o ).

tff(pred_def_85455,type,
    v142165: state_type > $o ).

tff(pred_def_85456,type,
    v142166: state_type > $o ).

tff(pred_def_85457,type,
    v142164: state_type > $o ).

tff(pred_def_85458,type,
    v142161: ( state_type * $int ) > $o ).

tff(pred_def_85459,type,
    v142163: ( state_type * $int ) > $o ).

tff(pred_def_85460,type,
    v142152: ( state_type * $int ) > $o ).

tff(pred_def_85461,type,
    v142118: ( state_type * $int ) > $o ).

tff(pred_def_85462,type,
    v142114: ( state_type * $int ) > $o ).

tff(pred_def_85463,type,
    v142178: state_type > $o ).

tff(pred_def_85464,type,
    v142176: state_type > $o ).

tff(pred_def_85465,type,
    v142182: state_type > $o ).

tff(pred_def_85466,type,
    v142180: state_type > $o ).

tff(pred_def_85467,type,
    v142188: ( state_type * $int ) > $o ).

tff(pred_def_85468,type,
    v142194: state_type > $o ).

tff(pred_def_85469,type,
    v142192: state_type > $o ).

tff(pred_def_85470,type,
    v142190: state_type > $o ).

tff(pred_def_85471,type,
    v142198: state_type > $o ).

tff(pred_def_85472,type,
    v142197: ( state_type * $int ) > $o ).

tff(pred_def_85473,type,
    v142196: ( state_type * $int ) > $o ).

tff(pred_def_85474,type,
    v142202: state_type > $o ).

tff(pred_def_85475,type,
    v142201: ( state_type * $int ) > $o ).

tff(pred_def_85476,type,
    v142200: ( state_type * $int ) > $o ).

tff(pred_def_85477,type,
    v142172: ( state_type * $int ) > $o ).

tff(pred_def_85478,type,
    v142199: ( state_type * $int ) > $o ).

tff(pred_def_85479,type,
    v142195: ( state_type * $int ) > $o ).

tff(pred_def_85480,type,
    v142186: ( state_type * $int ) > $o ).

tff(pred_def_85481,type,
    v142184: ( state_type * $int ) > $o ).

tff(pred_def_85482,type,
    v142206: state_type > $o ).

tff(pred_def_85483,type,
    v142204: state_type > $o ).

tff(pred_def_85484,type,
    v142213: state_type > $o ).

tff(pred_def_85485,type,
    v142211: state_type > $o ).

tff(pred_def_85486,type,
    v142210: state_type > $o ).

tff(pred_def_85487,type,
    v142209: state_type > $o ).

tff(pred_def_85488,type,
    v142221: state_type > $o ).

tff(pred_def_85489,type,
    v142222: state_type > $o ).

tff(pred_def_85490,type,
    v142220: state_type > $o ).

tff(pred_def_85491,type,
    v142217: ( state_type * $int ) > $o ).

tff(pred_def_85492,type,
    v142219: ( state_type * $int ) > $o ).

tff(pred_def_85493,type,
    v142208: ( state_type * $int ) > $o ).

tff(pred_def_85494,type,
    v142174: ( state_type * $int ) > $o ).

tff(pred_def_85495,type,
    v142170: ( state_type * $int ) > $o ).

tff(pred_def_85496,type,
    v142234: state_type > $o ).

tff(pred_def_85497,type,
    v142232: state_type > $o ).

tff(pred_def_85498,type,
    v142238: state_type > $o ).

tff(pred_def_85499,type,
    v142236: state_type > $o ).

tff(pred_def_85500,type,
    v142244: ( state_type * $int ) > $o ).

tff(pred_def_85501,type,
    v142250: state_type > $o ).

tff(pred_def_85502,type,
    v142248: state_type > $o ).

tff(pred_def_85503,type,
    v142246: state_type > $o ).

tff(pred_def_85504,type,
    v142254: state_type > $o ).

tff(pred_def_85505,type,
    v142253: ( state_type * $int ) > $o ).

tff(pred_def_85506,type,
    v142252: ( state_type * $int ) > $o ).

tff(pred_def_85507,type,
    v142258: state_type > $o ).

tff(pred_def_85508,type,
    v142257: ( state_type * $int ) > $o ).

tff(pred_def_85509,type,
    v142256: ( state_type * $int ) > $o ).

tff(pred_def_85510,type,
    v142228: ( state_type * $int ) > $o ).

tff(pred_def_85511,type,
    v142255: ( state_type * $int ) > $o ).

tff(pred_def_85512,type,
    v142251: ( state_type * $int ) > $o ).

tff(pred_def_85513,type,
    v142242: ( state_type * $int ) > $o ).

tff(pred_def_85514,type,
    v142240: ( state_type * $int ) > $o ).

tff(pred_def_85515,type,
    v142262: state_type > $o ).

tff(pred_def_85516,type,
    v142260: state_type > $o ).

tff(pred_def_85517,type,
    v142269: state_type > $o ).

tff(pred_def_85518,type,
    v142267: state_type > $o ).

tff(pred_def_85519,type,
    v142266: state_type > $o ).

tff(pred_def_85520,type,
    v142265: state_type > $o ).

tff(pred_def_85521,type,
    v142277: state_type > $o ).

tff(pred_def_85522,type,
    v142278: state_type > $o ).

tff(pred_def_85523,type,
    v142276: state_type > $o ).

tff(pred_def_85524,type,
    v142273: ( state_type * $int ) > $o ).

tff(pred_def_85525,type,
    v142275: ( state_type * $int ) > $o ).

tff(pred_def_85526,type,
    v142264: ( state_type * $int ) > $o ).

tff(pred_def_85527,type,
    v142230: ( state_type * $int ) > $o ).

tff(pred_def_85528,type,
    v142226: ( state_type * $int ) > $o ).

tff(pred_def_85529,type,
    v142290: state_type > $o ).

tff(pred_def_85530,type,
    v142288: state_type > $o ).

tff(pred_def_85531,type,
    v142294: state_type > $o ).

tff(pred_def_85532,type,
    v142292: state_type > $o ).

tff(pred_def_85533,type,
    v142300: ( state_type * $int ) > $o ).

tff(pred_def_85534,type,
    v142306: state_type > $o ).

tff(pred_def_85535,type,
    v142304: state_type > $o ).

tff(pred_def_85536,type,
    v142302: state_type > $o ).

tff(pred_def_85537,type,
    v142310: state_type > $o ).

tff(pred_def_85538,type,
    v142309: ( state_type * $int ) > $o ).

tff(pred_def_85539,type,
    v142308: ( state_type * $int ) > $o ).

tff(pred_def_85540,type,
    v142314: state_type > $o ).

tff(pred_def_85541,type,
    v142313: ( state_type * $int ) > $o ).

tff(pred_def_85542,type,
    v142312: ( state_type * $int ) > $o ).

tff(pred_def_85543,type,
    v142284: ( state_type * $int ) > $o ).

tff(pred_def_85544,type,
    v142311: ( state_type * $int ) > $o ).

tff(pred_def_85545,type,
    v142307: ( state_type * $int ) > $o ).

tff(pred_def_85546,type,
    v142298: ( state_type * $int ) > $o ).

tff(pred_def_85547,type,
    v142296: ( state_type * $int ) > $o ).

tff(pred_def_85548,type,
    v142318: state_type > $o ).

tff(pred_def_85549,type,
    v142316: state_type > $o ).

tff(pred_def_85550,type,
    v142325: state_type > $o ).

tff(pred_def_85551,type,
    v142323: state_type > $o ).

tff(pred_def_85552,type,
    v142322: state_type > $o ).

tff(pred_def_85553,type,
    v142321: state_type > $o ).

tff(pred_def_85554,type,
    v142333: state_type > $o ).

tff(pred_def_85555,type,
    v142334: state_type > $o ).

tff(pred_def_85556,type,
    v142332: state_type > $o ).

tff(pred_def_85557,type,
    v142329: ( state_type * $int ) > $o ).

tff(pred_def_85558,type,
    v142331: ( state_type * $int ) > $o ).

tff(pred_def_85559,type,
    v142320: ( state_type * $int ) > $o ).

tff(pred_def_85560,type,
    v142286: ( state_type * $int ) > $o ).

tff(pred_def_85561,type,
    v142282: ( state_type * $int ) > $o ).

tff(pred_def_85562,type,
    v142346: state_type > $o ).

tff(pred_def_85563,type,
    v142344: state_type > $o ).

tff(pred_def_85564,type,
    v142350: state_type > $o ).

tff(pred_def_85565,type,
    v142348: state_type > $o ).

tff(pred_def_85566,type,
    v142356: ( state_type * $int ) > $o ).

tff(pred_def_85567,type,
    v142362: state_type > $o ).

tff(pred_def_85568,type,
    v142360: state_type > $o ).

tff(pred_def_85569,type,
    v142358: state_type > $o ).

tff(pred_def_85570,type,
    v142366: state_type > $o ).

tff(pred_def_85571,type,
    v142365: ( state_type * $int ) > $o ).

tff(pred_def_85572,type,
    v142364: ( state_type * $int ) > $o ).

tff(pred_def_85573,type,
    v142370: state_type > $o ).

tff(pred_def_85574,type,
    v142369: ( state_type * $int ) > $o ).

tff(pred_def_85575,type,
    v142368: ( state_type * $int ) > $o ).

tff(pred_def_85576,type,
    v142340: ( state_type * $int ) > $o ).

tff(pred_def_85577,type,
    v142367: ( state_type * $int ) > $o ).

tff(pred_def_85578,type,
    v142363: ( state_type * $int ) > $o ).

tff(pred_def_85579,type,
    v142354: ( state_type * $int ) > $o ).

tff(pred_def_85580,type,
    v142352: ( state_type * $int ) > $o ).

tff(pred_def_85581,type,
    v142374: state_type > $o ).

tff(pred_def_85582,type,
    v142372: state_type > $o ).

tff(pred_def_85583,type,
    v142381: state_type > $o ).

tff(pred_def_85584,type,
    v142379: state_type > $o ).

tff(pred_def_85585,type,
    v142378: state_type > $o ).

tff(pred_def_85586,type,
    v142377: state_type > $o ).

tff(pred_def_85587,type,
    v142389: state_type > $o ).

tff(pred_def_85588,type,
    v142390: state_type > $o ).

tff(pred_def_85589,type,
    v142388: state_type > $o ).

tff(pred_def_85590,type,
    v142385: ( state_type * $int ) > $o ).

tff(pred_def_85591,type,
    v142387: ( state_type * $int ) > $o ).

tff(pred_def_85592,type,
    v142376: ( state_type * $int ) > $o ).

tff(pred_def_85593,type,
    v142342: ( state_type * $int ) > $o ).

tff(pred_def_85594,type,
    v142338: ( state_type * $int ) > $o ).

tff(pred_def_85595,type,
    v142402: state_type > $o ).

tff(pred_def_85596,type,
    v142400: state_type > $o ).

tff(pred_def_85597,type,
    v142406: state_type > $o ).

tff(pred_def_85598,type,
    v142404: state_type > $o ).

tff(pred_def_85599,type,
    v142412: ( state_type * $int ) > $o ).

tff(pred_def_85600,type,
    v142418: state_type > $o ).

tff(pred_def_85601,type,
    v142416: state_type > $o ).

tff(pred_def_85602,type,
    v142414: state_type > $o ).

tff(pred_def_85603,type,
    v142422: state_type > $o ).

tff(pred_def_85604,type,
    v142421: ( state_type * $int ) > $o ).

tff(pred_def_85605,type,
    v142420: ( state_type * $int ) > $o ).

tff(pred_def_85606,type,
    v142426: state_type > $o ).

tff(pred_def_85607,type,
    v142425: ( state_type * $int ) > $o ).

tff(pred_def_85608,type,
    v142424: ( state_type * $int ) > $o ).

tff(pred_def_85609,type,
    v142396: ( state_type * $int ) > $o ).

tff(pred_def_85610,type,
    v142423: ( state_type * $int ) > $o ).

tff(pred_def_85611,type,
    v142419: ( state_type * $int ) > $o ).

tff(pred_def_85612,type,
    v142410: ( state_type * $int ) > $o ).

tff(pred_def_85613,type,
    v142408: ( state_type * $int ) > $o ).

tff(pred_def_85614,type,
    v142430: state_type > $o ).

tff(pred_def_85615,type,
    v142428: state_type > $o ).

tff(pred_def_85616,type,
    v142437: state_type > $o ).

tff(pred_def_85617,type,
    v142435: state_type > $o ).

tff(pred_def_85618,type,
    v142434: state_type > $o ).

tff(pred_def_85619,type,
    v142433: state_type > $o ).

tff(pred_def_85620,type,
    v142445: state_type > $o ).

tff(pred_def_85621,type,
    v142446: state_type > $o ).

tff(pred_def_85622,type,
    v142444: state_type > $o ).

tff(pred_def_85623,type,
    v142441: ( state_type * $int ) > $o ).

tff(pred_def_85624,type,
    v142443: ( state_type * $int ) > $o ).

tff(pred_def_85625,type,
    v142432: ( state_type * $int ) > $o ).

tff(pred_def_85626,type,
    v142398: ( state_type * $int ) > $o ).

tff(pred_def_85627,type,
    v142394: ( state_type * $int ) > $o ).

tff(pred_def_85628,type,
    v142458: state_type > $o ).

tff(pred_def_85629,type,
    v142456: state_type > $o ).

tff(pred_def_85630,type,
    v142462: state_type > $o ).

tff(pred_def_85631,type,
    v142460: state_type > $o ).

tff(pred_def_85632,type,
    v142468: ( state_type * $int ) > $o ).

tff(pred_def_85633,type,
    v142474: state_type > $o ).

tff(pred_def_85634,type,
    v142472: state_type > $o ).

tff(pred_def_85635,type,
    v142470: state_type > $o ).

tff(pred_def_85636,type,
    v142478: state_type > $o ).

tff(pred_def_85637,type,
    v142477: ( state_type * $int ) > $o ).

tff(pred_def_85638,type,
    v142476: ( state_type * $int ) > $o ).

tff(pred_def_85639,type,
    v142482: state_type > $o ).

tff(pred_def_85640,type,
    v142481: ( state_type * $int ) > $o ).

tff(pred_def_85641,type,
    v142480: ( state_type * $int ) > $o ).

tff(pred_def_85642,type,
    v142452: ( state_type * $int ) > $o ).

tff(pred_def_85643,type,
    v142479: ( state_type * $int ) > $o ).

tff(pred_def_85644,type,
    v142475: ( state_type * $int ) > $o ).

tff(pred_def_85645,type,
    v142466: ( state_type * $int ) > $o ).

tff(pred_def_85646,type,
    v142464: ( state_type * $int ) > $o ).

tff(pred_def_85647,type,
    v142486: state_type > $o ).

tff(pred_def_85648,type,
    v142484: state_type > $o ).

tff(pred_def_85649,type,
    v142493: state_type > $o ).

tff(pred_def_85650,type,
    v142491: state_type > $o ).

tff(pred_def_85651,type,
    v142490: state_type > $o ).

tff(pred_def_85652,type,
    v142489: state_type > $o ).

tff(pred_def_85653,type,
    v142501: state_type > $o ).

tff(pred_def_85654,type,
    v142502: state_type > $o ).

tff(pred_def_85655,type,
    v142500: state_type > $o ).

tff(pred_def_85656,type,
    v142497: ( state_type * $int ) > $o ).

tff(pred_def_85657,type,
    v142499: ( state_type * $int ) > $o ).

tff(pred_def_85658,type,
    v142488: ( state_type * $int ) > $o ).

tff(pred_def_85659,type,
    v142454: ( state_type * $int ) > $o ).

tff(pred_def_85660,type,
    v142450: ( state_type * $int ) > $o ).

tff(pred_def_85661,type,
    v142514: state_type > $o ).

tff(pred_def_85662,type,
    v142512: state_type > $o ).

tff(pred_def_85663,type,
    v142518: state_type > $o ).

tff(pred_def_85664,type,
    v142516: state_type > $o ).

tff(pred_def_85665,type,
    v142524: ( state_type * $int ) > $o ).

tff(pred_def_85666,type,
    v142530: state_type > $o ).

tff(pred_def_85667,type,
    v142528: state_type > $o ).

tff(pred_def_85668,type,
    v142526: state_type > $o ).

tff(pred_def_85669,type,
    v142534: state_type > $o ).

tff(pred_def_85670,type,
    v142533: ( state_type * $int ) > $o ).

tff(pred_def_85671,type,
    v142532: ( state_type * $int ) > $o ).

tff(pred_def_85672,type,
    v142538: state_type > $o ).

tff(pred_def_85673,type,
    v142537: ( state_type * $int ) > $o ).

tff(pred_def_85674,type,
    v142536: ( state_type * $int ) > $o ).

tff(pred_def_85675,type,
    v142508: ( state_type * $int ) > $o ).

tff(pred_def_85676,type,
    v142535: ( state_type * $int ) > $o ).

tff(pred_def_85677,type,
    v142531: ( state_type * $int ) > $o ).

tff(pred_def_85678,type,
    v142522: ( state_type * $int ) > $o ).

tff(pred_def_85679,type,
    v142520: ( state_type * $int ) > $o ).

tff(pred_def_85680,type,
    v142542: state_type > $o ).

tff(pred_def_85681,type,
    v142540: state_type > $o ).

tff(pred_def_85682,type,
    v142549: state_type > $o ).

tff(pred_def_85683,type,
    v142547: state_type > $o ).

tff(pred_def_85684,type,
    v142546: state_type > $o ).

tff(pred_def_85685,type,
    v142545: state_type > $o ).

tff(pred_def_85686,type,
    v142557: state_type > $o ).

tff(pred_def_85687,type,
    v142558: state_type > $o ).

tff(pred_def_85688,type,
    v142556: state_type > $o ).

tff(pred_def_85689,type,
    v142553: ( state_type * $int ) > $o ).

tff(pred_def_85690,type,
    v142555: ( state_type * $int ) > $o ).

tff(pred_def_85691,type,
    v142544: ( state_type * $int ) > $o ).

tff(pred_def_85692,type,
    v142510: ( state_type * $int ) > $o ).

tff(pred_def_85693,type,
    v142506: ( state_type * $int ) > $o ).

tff(pred_def_85694,type,
    v142570: state_type > $o ).

tff(pred_def_85695,type,
    v142568: state_type > $o ).

tff(pred_def_85696,type,
    v142574: state_type > $o ).

tff(pred_def_85697,type,
    v142572: state_type > $o ).

tff(pred_def_85698,type,
    v142580: ( state_type * $int ) > $o ).

tff(pred_def_85699,type,
    v142586: state_type > $o ).

tff(pred_def_85700,type,
    v142584: state_type > $o ).

tff(pred_def_85701,type,
    v142582: state_type > $o ).

tff(pred_def_85702,type,
    v142590: state_type > $o ).

tff(pred_def_85703,type,
    v142589: ( state_type * $int ) > $o ).

tff(pred_def_85704,type,
    v142588: ( state_type * $int ) > $o ).

tff(pred_def_85705,type,
    v142594: state_type > $o ).

tff(pred_def_85706,type,
    v142593: ( state_type * $int ) > $o ).

tff(pred_def_85707,type,
    v142592: ( state_type * $int ) > $o ).

tff(pred_def_85708,type,
    v142564: ( state_type * $int ) > $o ).

tff(pred_def_85709,type,
    v142591: ( state_type * $int ) > $o ).

tff(pred_def_85710,type,
    v142587: ( state_type * $int ) > $o ).

tff(pred_def_85711,type,
    v142578: ( state_type * $int ) > $o ).

tff(pred_def_85712,type,
    v142576: ( state_type * $int ) > $o ).

tff(pred_def_85713,type,
    v142598: state_type > $o ).

tff(pred_def_85714,type,
    v142596: state_type > $o ).

tff(pred_def_85715,type,
    v142605: state_type > $o ).

tff(pred_def_85716,type,
    v142603: state_type > $o ).

tff(pred_def_85717,type,
    v142602: state_type > $o ).

tff(pred_def_85718,type,
    v142601: state_type > $o ).

tff(pred_def_85719,type,
    v142613: state_type > $o ).

tff(pred_def_85720,type,
    v142614: state_type > $o ).

tff(pred_def_85721,type,
    v142612: state_type > $o ).

tff(pred_def_85722,type,
    v142609: ( state_type * $int ) > $o ).

tff(pred_def_85723,type,
    v142611: ( state_type * $int ) > $o ).

tff(pred_def_85724,type,
    v142600: ( state_type * $int ) > $o ).

tff(pred_def_85725,type,
    v142566: ( state_type * $int ) > $o ).

tff(pred_def_85726,type,
    v142562: ( state_type * $int ) > $o ).

tff(pred_def_85727,type,
    v142626: state_type > $o ).

tff(pred_def_85728,type,
    v142624: state_type > $o ).

tff(pred_def_85729,type,
    v142630: state_type > $o ).

tff(pred_def_85730,type,
    v142628: state_type > $o ).

tff(pred_def_85731,type,
    v142636: ( state_type * $int ) > $o ).

tff(pred_def_85732,type,
    v142642: state_type > $o ).

tff(pred_def_85733,type,
    v142640: state_type > $o ).

tff(pred_def_85734,type,
    v142638: state_type > $o ).

tff(pred_def_85735,type,
    v142646: state_type > $o ).

tff(pred_def_85736,type,
    v142645: ( state_type * $int ) > $o ).

tff(pred_def_85737,type,
    v142644: ( state_type * $int ) > $o ).

tff(pred_def_85738,type,
    v142650: state_type > $o ).

tff(pred_def_85739,type,
    v142649: ( state_type * $int ) > $o ).

tff(pred_def_85740,type,
    v142648: ( state_type * $int ) > $o ).

tff(pred_def_85741,type,
    v142620: ( state_type * $int ) > $o ).

tff(pred_def_85742,type,
    v142647: ( state_type * $int ) > $o ).

tff(pred_def_85743,type,
    v142643: ( state_type * $int ) > $o ).

tff(pred_def_85744,type,
    v142634: ( state_type * $int ) > $o ).

tff(pred_def_85745,type,
    v142632: ( state_type * $int ) > $o ).

tff(pred_def_85746,type,
    v142654: state_type > $o ).

tff(pred_def_85747,type,
    v142652: state_type > $o ).

tff(pred_def_85748,type,
    v142661: state_type > $o ).

tff(pred_def_85749,type,
    v142659: state_type > $o ).

tff(pred_def_85750,type,
    v142658: state_type > $o ).

tff(pred_def_85751,type,
    v142657: state_type > $o ).

tff(pred_def_85752,type,
    v142669: state_type > $o ).

tff(pred_def_85753,type,
    v142670: state_type > $o ).

tff(pred_def_85754,type,
    v142668: state_type > $o ).

tff(pred_def_85755,type,
    v142665: ( state_type * $int ) > $o ).

tff(pred_def_85756,type,
    v142667: ( state_type * $int ) > $o ).

tff(pred_def_85757,type,
    v142656: ( state_type * $int ) > $o ).

tff(pred_def_85758,type,
    v142622: ( state_type * $int ) > $o ).

tff(pred_def_85759,type,
    v142618: ( state_type * $int ) > $o ).

tff(pred_def_85760,type,
    v142682: state_type > $o ).

tff(pred_def_85761,type,
    v142680: state_type > $o ).

tff(pred_def_85762,type,
    v142686: state_type > $o ).

tff(pred_def_85763,type,
    v142684: state_type > $o ).

tff(pred_def_85764,type,
    v142692: ( state_type * $int ) > $o ).

tff(pred_def_85765,type,
    v142698: state_type > $o ).

tff(pred_def_85766,type,
    v142696: state_type > $o ).

tff(pred_def_85767,type,
    v142694: state_type > $o ).

tff(pred_def_85768,type,
    v142702: state_type > $o ).

tff(pred_def_85769,type,
    v142701: ( state_type * $int ) > $o ).

tff(pred_def_85770,type,
    v142700: ( state_type * $int ) > $o ).

tff(pred_def_85771,type,
    v142706: state_type > $o ).

tff(pred_def_85772,type,
    v142705: ( state_type * $int ) > $o ).

tff(pred_def_85773,type,
    v142704: ( state_type * $int ) > $o ).

tff(pred_def_85774,type,
    v142676: ( state_type * $int ) > $o ).

tff(pred_def_85775,type,
    v142703: ( state_type * $int ) > $o ).

tff(pred_def_85776,type,
    v142699: ( state_type * $int ) > $o ).

tff(pred_def_85777,type,
    v142690: ( state_type * $int ) > $o ).

tff(pred_def_85778,type,
    v142688: ( state_type * $int ) > $o ).

tff(pred_def_85779,type,
    v142710: state_type > $o ).

tff(pred_def_85780,type,
    v142708: state_type > $o ).

tff(pred_def_85781,type,
    v142717: state_type > $o ).

tff(pred_def_85782,type,
    v142715: state_type > $o ).

tff(pred_def_85783,type,
    v142714: state_type > $o ).

tff(pred_def_85784,type,
    v142713: state_type > $o ).

tff(pred_def_85785,type,
    v142725: state_type > $o ).

tff(pred_def_85786,type,
    v142726: state_type > $o ).

tff(pred_def_85787,type,
    v142724: state_type > $o ).

tff(pred_def_85788,type,
    v142721: ( state_type * $int ) > $o ).

tff(pred_def_85789,type,
    v142723: ( state_type * $int ) > $o ).

tff(pred_def_85790,type,
    v142712: ( state_type * $int ) > $o ).

tff(pred_def_85791,type,
    v142678: ( state_type * $int ) > $o ).

tff(pred_def_85792,type,
    v142674: ( state_type * $int ) > $o ).

tff(pred_def_85793,type,
    v142738: state_type > $o ).

tff(pred_def_85794,type,
    v142736: state_type > $o ).

tff(pred_def_85795,type,
    v142742: state_type > $o ).

tff(pred_def_85796,type,
    v142740: state_type > $o ).

tff(pred_def_85797,type,
    v142748: ( state_type * $int ) > $o ).

tff(pred_def_85798,type,
    v142754: state_type > $o ).

tff(pred_def_85799,type,
    v142752: state_type > $o ).

tff(pred_def_85800,type,
    v142750: state_type > $o ).

tff(pred_def_85801,type,
    v142758: state_type > $o ).

tff(pred_def_85802,type,
    v142757: ( state_type * $int ) > $o ).

tff(pred_def_85803,type,
    v142756: ( state_type * $int ) > $o ).

tff(pred_def_85804,type,
    v142762: state_type > $o ).

tff(pred_def_85805,type,
    v142761: ( state_type * $int ) > $o ).

tff(pred_def_85806,type,
    v142760: ( state_type * $int ) > $o ).

tff(pred_def_85807,type,
    v142732: ( state_type * $int ) > $o ).

tff(pred_def_85808,type,
    v142759: ( state_type * $int ) > $o ).

tff(pred_def_85809,type,
    v142755: ( state_type * $int ) > $o ).

tff(pred_def_85810,type,
    v142746: ( state_type * $int ) > $o ).

tff(pred_def_85811,type,
    v142744: ( state_type * $int ) > $o ).

tff(pred_def_85812,type,
    v142766: state_type > $o ).

tff(pred_def_85813,type,
    v142764: state_type > $o ).

tff(pred_def_85814,type,
    v142773: state_type > $o ).

tff(pred_def_85815,type,
    v142771: state_type > $o ).

tff(pred_def_85816,type,
    v142770: state_type > $o ).

tff(pred_def_85817,type,
    v142769: state_type > $o ).

tff(pred_def_85818,type,
    v142781: state_type > $o ).

tff(pred_def_85819,type,
    v142782: state_type > $o ).

tff(pred_def_85820,type,
    v142780: state_type > $o ).

tff(pred_def_85821,type,
    v142777: ( state_type * $int ) > $o ).

tff(pred_def_85822,type,
    v142779: ( state_type * $int ) > $o ).

tff(pred_def_85823,type,
    v142768: ( state_type * $int ) > $o ).

tff(pred_def_85824,type,
    v142734: ( state_type * $int ) > $o ).

tff(pred_def_85825,type,
    v142730: ( state_type * $int ) > $o ).

tff(pred_def_85826,type,
    v142795: state_type > $o ).

tff(pred_def_85827,type,
    v142793: state_type > $o ).

tff(pred_def_85828,type,
    v142799: state_type > $o ).

tff(pred_def_85829,type,
    v142797: state_type > $o ).

tff(pred_def_85830,type,
    v142805: ( state_type * $int ) > $o ).

tff(pred_def_85831,type,
    b10001: $int > $o ).

tff(pred_def_85832,type,
    v142811: state_type > $o ).

tff(pred_def_85833,type,
    v142809: state_type > $o ).

tff(pred_def_85834,type,
    v142807: state_type > $o ).

tff(pred_def_85835,type,
    v142815: state_type > $o ).

tff(pred_def_85836,type,
    v142814: ( state_type * $int ) > $o ).

tff(pred_def_85837,type,
    v142813: ( state_type * $int ) > $o ).

tff(pred_def_85838,type,
    v142819: state_type > $o ).

tff(pred_def_85839,type,
    v142818: ( state_type * $int ) > $o ).

tff(pred_def_85840,type,
    v142817: ( state_type * $int ) > $o ).

tff(pred_def_85841,type,
    v142789: ( state_type * $int ) > $o ).

tff(pred_def_85842,type,
    v142816: ( state_type * $int ) > $o ).

tff(pred_def_85843,type,
    v142812: ( state_type * $int ) > $o ).

tff(pred_def_85844,type,
    v142803: ( state_type * $int ) > $o ).

tff(pred_def_85845,type,
    v142801: ( state_type * $int ) > $o ).

tff(pred_def_85846,type,
    v142823: state_type > $o ).

tff(pred_def_85847,type,
    v142821: state_type > $o ).

tff(pred_def_85848,type,
    v142830: state_type > $o ).

tff(pred_def_85849,type,
    v142828: state_type > $o ).

tff(pred_def_85850,type,
    v142827: state_type > $o ).

tff(pred_def_85851,type,
    v142826: state_type > $o ).

tff(pred_def_85852,type,
    v142838: state_type > $o ).

tff(pred_def_85853,type,
    v142839: state_type > $o ).

tff(pred_def_85854,type,
    v142837: state_type > $o ).

tff(pred_def_85855,type,
    v142834: ( state_type * $int ) > $o ).

tff(pred_def_85856,type,
    v142836: ( state_type * $int ) > $o ).

tff(pred_def_85857,type,
    v142825: ( state_type * $int ) > $o ).

tff(pred_def_85858,type,
    v142791: ( state_type * $int ) > $o ).

tff(pred_def_85859,type,
    v142787: ( state_type * $int ) > $o ).

tff(pred_def_85860,type,
    v142852: state_type > $o ).

tff(pred_def_85861,type,
    v142850: state_type > $o ).

tff(pred_def_85862,type,
    v142856: state_type > $o ).

tff(pred_def_85863,type,
    v142854: state_type > $o ).

tff(pred_def_85864,type,
    v142862: ( state_type * $int ) > $o ).

tff(pred_def_85865,type,
    b10010: $int > $o ).

tff(pred_def_85866,type,
    v142868: state_type > $o ).

tff(pred_def_85867,type,
    v142866: state_type > $o ).

tff(pred_def_85868,type,
    v142864: state_type > $o ).

tff(pred_def_85869,type,
    v142872: state_type > $o ).

tff(pred_def_85870,type,
    v142871: ( state_type * $int ) > $o ).

tff(pred_def_85871,type,
    v142870: ( state_type * $int ) > $o ).

tff(pred_def_85872,type,
    v142876: state_type > $o ).

tff(pred_def_85873,type,
    v142875: ( state_type * $int ) > $o ).

tff(pred_def_85874,type,
    v142874: ( state_type * $int ) > $o ).

tff(pred_def_85875,type,
    v142846: ( state_type * $int ) > $o ).

tff(pred_def_85876,type,
    v142873: ( state_type * $int ) > $o ).

tff(pred_def_85877,type,
    v142869: ( state_type * $int ) > $o ).

tff(pred_def_85878,type,
    v142860: ( state_type * $int ) > $o ).

tff(pred_def_85879,type,
    v142858: ( state_type * $int ) > $o ).

tff(pred_def_85880,type,
    v142880: state_type > $o ).

tff(pred_def_85881,type,
    v142878: state_type > $o ).

tff(pred_def_85882,type,
    v142887: state_type > $o ).

tff(pred_def_85883,type,
    v142885: state_type > $o ).

tff(pred_def_85884,type,
    v142884: state_type > $o ).

tff(pred_def_85885,type,
    v142883: state_type > $o ).

tff(pred_def_85886,type,
    v142895: state_type > $o ).

tff(pred_def_85887,type,
    v142896: state_type > $o ).

tff(pred_def_85888,type,
    v142894: state_type > $o ).

tff(pred_def_85889,type,
    v142891: ( state_type * $int ) > $o ).

tff(pred_def_85890,type,
    v142893: ( state_type * $int ) > $o ).

tff(pred_def_85891,type,
    v142882: ( state_type * $int ) > $o ).

tff(pred_def_85892,type,
    v142848: ( state_type * $int ) > $o ).

tff(pred_def_85893,type,
    v142844: ( state_type * $int ) > $o ).

tff(pred_def_85894,type,
    v142909: state_type > $o ).

tff(pred_def_85895,type,
    v142907: state_type > $o ).

tff(pred_def_85896,type,
    v142913: state_type > $o ).

tff(pred_def_85897,type,
    v142911: state_type > $o ).

tff(pred_def_85898,type,
    v142919: ( state_type * $int ) > $o ).

tff(pred_def_85899,type,
    b10011: $int > $o ).

tff(pred_def_85900,type,
    v142925: state_type > $o ).

tff(pred_def_85901,type,
    v142923: state_type > $o ).

tff(pred_def_85902,type,
    v142921: state_type > $o ).

tff(pred_def_85903,type,
    v142929: state_type > $o ).

tff(pred_def_85904,type,
    v142928: ( state_type * $int ) > $o ).

tff(pred_def_85905,type,
    v142927: ( state_type * $int ) > $o ).

tff(pred_def_85906,type,
    v142933: state_type > $o ).

tff(pred_def_85907,type,
    v142932: ( state_type * $int ) > $o ).

tff(pred_def_85908,type,
    v142931: ( state_type * $int ) > $o ).

tff(pred_def_85909,type,
    v142903: ( state_type * $int ) > $o ).

tff(pred_def_85910,type,
    v142930: ( state_type * $int ) > $o ).

tff(pred_def_85911,type,
    v142926: ( state_type * $int ) > $o ).

tff(pred_def_85912,type,
    v142917: ( state_type * $int ) > $o ).

tff(pred_def_85913,type,
    v142915: ( state_type * $int ) > $o ).

tff(pred_def_85914,type,
    v142937: state_type > $o ).

tff(pred_def_85915,type,
    v142935: state_type > $o ).

tff(pred_def_85916,type,
    v142944: state_type > $o ).

tff(pred_def_85917,type,
    v142942: state_type > $o ).

tff(pred_def_85918,type,
    v142941: state_type > $o ).

tff(pred_def_85919,type,
    v142940: state_type > $o ).

tff(pred_def_85920,type,
    v142952: state_type > $o ).

tff(pred_def_85921,type,
    v142953: state_type > $o ).

tff(pred_def_85922,type,
    v142951: state_type > $o ).

tff(pred_def_85923,type,
    v142948: ( state_type * $int ) > $o ).

tff(pred_def_85924,type,
    v142950: ( state_type * $int ) > $o ).

tff(pred_def_85925,type,
    v142939: ( state_type * $int ) > $o ).

tff(pred_def_85926,type,
    v142905: ( state_type * $int ) > $o ).

tff(pred_def_85927,type,
    v142901: ( state_type * $int ) > $o ).

tff(pred_def_85928,type,
    v142966: state_type > $o ).

tff(pred_def_85929,type,
    v142964: state_type > $o ).

tff(pred_def_85930,type,
    v142970: state_type > $o ).

tff(pred_def_85931,type,
    v142968: state_type > $o ).

tff(pred_def_85932,type,
    v142976: ( state_type * $int ) > $o ).

tff(pred_def_85933,type,
    b10100: $int > $o ).

tff(pred_def_85934,type,
    v142982: state_type > $o ).

tff(pred_def_85935,type,
    v142980: state_type > $o ).

tff(pred_def_85936,type,
    v142978: state_type > $o ).

tff(pred_def_85937,type,
    v142986: state_type > $o ).

tff(pred_def_85938,type,
    v142985: ( state_type * $int ) > $o ).

tff(pred_def_85939,type,
    v142984: ( state_type * $int ) > $o ).

tff(pred_def_85940,type,
    v142990: state_type > $o ).

tff(pred_def_85941,type,
    v142989: ( state_type * $int ) > $o ).

tff(pred_def_85942,type,
    v142988: ( state_type * $int ) > $o ).

tff(pred_def_85943,type,
    v142960: ( state_type * $int ) > $o ).

tff(pred_def_85944,type,
    v142987: ( state_type * $int ) > $o ).

tff(pred_def_85945,type,
    v142983: ( state_type * $int ) > $o ).

tff(pred_def_85946,type,
    v142974: ( state_type * $int ) > $o ).

tff(pred_def_85947,type,
    v142972: ( state_type * $int ) > $o ).

tff(pred_def_85948,type,
    v142994: state_type > $o ).

tff(pred_def_85949,type,
    v142992: state_type > $o ).

tff(pred_def_85950,type,
    v143001: state_type > $o ).

tff(pred_def_85951,type,
    v142999: state_type > $o ).

tff(pred_def_85952,type,
    v142998: state_type > $o ).

tff(pred_def_85953,type,
    v142997: state_type > $o ).

tff(pred_def_85954,type,
    v143009: state_type > $o ).

tff(pred_def_85955,type,
    v143010: state_type > $o ).

tff(pred_def_85956,type,
    v143008: state_type > $o ).

tff(pred_def_85957,type,
    v143005: ( state_type * $int ) > $o ).

tff(pred_def_85958,type,
    v143007: ( state_type * $int ) > $o ).

tff(pred_def_85959,type,
    v142996: ( state_type * $int ) > $o ).

tff(pred_def_85960,type,
    v142962: ( state_type * $int ) > $o ).

tff(pred_def_85961,type,
    v142958: ( state_type * $int ) > $o ).

tff(pred_def_85962,type,
    v143023: state_type > $o ).

tff(pred_def_85963,type,
    v143021: state_type > $o ).

tff(pred_def_85964,type,
    v143027: state_type > $o ).

tff(pred_def_85965,type,
    v143025: state_type > $o ).

tff(pred_def_85966,type,
    v143033: ( state_type * $int ) > $o ).

tff(pred_def_85967,type,
    b10101: $int > $o ).

tff(pred_def_85968,type,
    v143039: state_type > $o ).

tff(pred_def_85969,type,
    v143037: state_type > $o ).

tff(pred_def_85970,type,
    v143035: state_type > $o ).

tff(pred_def_85971,type,
    v143043: state_type > $o ).

tff(pred_def_85972,type,
    v143042: ( state_type * $int ) > $o ).

tff(pred_def_85973,type,
    v143041: ( state_type * $int ) > $o ).

tff(pred_def_85974,type,
    v143047: state_type > $o ).

tff(pred_def_85975,type,
    v143046: ( state_type * $int ) > $o ).

tff(pred_def_85976,type,
    v143045: ( state_type * $int ) > $o ).

tff(pred_def_85977,type,
    v143017: ( state_type * $int ) > $o ).

tff(pred_def_85978,type,
    v143044: ( state_type * $int ) > $o ).

tff(pred_def_85979,type,
    v143040: ( state_type * $int ) > $o ).

tff(pred_def_85980,type,
    v143031: ( state_type * $int ) > $o ).

tff(pred_def_85981,type,
    v143029: ( state_type * $int ) > $o ).

tff(pred_def_85982,type,
    v143051: state_type > $o ).

tff(pred_def_85983,type,
    v143049: state_type > $o ).

tff(pred_def_85984,type,
    v143058: state_type > $o ).

tff(pred_def_85985,type,
    v143056: state_type > $o ).

tff(pred_def_85986,type,
    v143055: state_type > $o ).

tff(pred_def_85987,type,
    v143054: state_type > $o ).

tff(pred_def_85988,type,
    v143066: state_type > $o ).

tff(pred_def_85989,type,
    v143067: state_type > $o ).

tff(pred_def_85990,type,
    v143065: state_type > $o ).

tff(pred_def_85991,type,
    v143062: ( state_type * $int ) > $o ).

tff(pred_def_85992,type,
    v143064: ( state_type * $int ) > $o ).

tff(pred_def_85993,type,
    v143053: ( state_type * $int ) > $o ).

tff(pred_def_85994,type,
    v143019: ( state_type * $int ) > $o ).

tff(pred_def_85995,type,
    v143015: ( state_type * $int ) > $o ).

tff(pred_def_85996,type,
    v143080: state_type > $o ).

tff(pred_def_85997,type,
    v143078: state_type > $o ).

tff(pred_def_85998,type,
    v143084: state_type > $o ).

tff(pred_def_85999,type,
    v143082: state_type > $o ).

tff(pred_def_86000,type,
    v143090: ( state_type * $int ) > $o ).

tff(pred_def_86001,type,
    b10110: $int > $o ).

tff(pred_def_86002,type,
    v143096: state_type > $o ).

tff(pred_def_86003,type,
    v143094: state_type > $o ).

tff(pred_def_86004,type,
    v143092: state_type > $o ).

tff(pred_def_86005,type,
    v143100: state_type > $o ).

tff(pred_def_86006,type,
    v143099: ( state_type * $int ) > $o ).

tff(pred_def_86007,type,
    v143098: ( state_type * $int ) > $o ).

tff(pred_def_86008,type,
    v143104: state_type > $o ).

tff(pred_def_86009,type,
    v143103: ( state_type * $int ) > $o ).

tff(pred_def_86010,type,
    v143102: ( state_type * $int ) > $o ).

tff(pred_def_86011,type,
    v143074: ( state_type * $int ) > $o ).

tff(pred_def_86012,type,
    v143101: ( state_type * $int ) > $o ).

tff(pred_def_86013,type,
    v143097: ( state_type * $int ) > $o ).

tff(pred_def_86014,type,
    v143088: ( state_type * $int ) > $o ).

tff(pred_def_86015,type,
    v143086: ( state_type * $int ) > $o ).

tff(pred_def_86016,type,
    v143108: state_type > $o ).

tff(pred_def_86017,type,
    v143106: state_type > $o ).

tff(pred_def_86018,type,
    v143115: state_type > $o ).

tff(pred_def_86019,type,
    v143113: state_type > $o ).

tff(pred_def_86020,type,
    v143112: state_type > $o ).

tff(pred_def_86021,type,
    v143111: state_type > $o ).

tff(pred_def_86022,type,
    v143123: state_type > $o ).

tff(pred_def_86023,type,
    v143124: state_type > $o ).

tff(pred_def_86024,type,
    v143122: state_type > $o ).

tff(pred_def_86025,type,
    v143119: ( state_type * $int ) > $o ).

tff(pred_def_86026,type,
    v143121: ( state_type * $int ) > $o ).

tff(pred_def_86027,type,
    v143110: ( state_type * $int ) > $o ).

tff(pred_def_86028,type,
    v143076: ( state_type * $int ) > $o ).

tff(pred_def_86029,type,
    v143072: ( state_type * $int ) > $o ).

tff(pred_def_86030,type,
    v143137: state_type > $o ).

tff(pred_def_86031,type,
    v143135: state_type > $o ).

tff(pred_def_86032,type,
    v143141: state_type > $o ).

tff(pred_def_86033,type,
    v143139: state_type > $o ).

tff(pred_def_86034,type,
    v143147: ( state_type * $int ) > $o ).

tff(pred_def_86035,type,
    b10111: $int > $o ).

tff(pred_def_86036,type,
    v143153: state_type > $o ).

tff(pred_def_86037,type,
    v143151: state_type > $o ).

tff(pred_def_86038,type,
    v143149: state_type > $o ).

tff(pred_def_86039,type,
    v143157: state_type > $o ).

tff(pred_def_86040,type,
    v143156: ( state_type * $int ) > $o ).

tff(pred_def_86041,type,
    v143155: ( state_type * $int ) > $o ).

tff(pred_def_86042,type,
    v143161: state_type > $o ).

tff(pred_def_86043,type,
    v143160: ( state_type * $int ) > $o ).

tff(pred_def_86044,type,
    v143159: ( state_type * $int ) > $o ).

tff(pred_def_86045,type,
    v143131: ( state_type * $int ) > $o ).

tff(pred_def_86046,type,
    v143158: ( state_type * $int ) > $o ).

tff(pred_def_86047,type,
    v143154: ( state_type * $int ) > $o ).

tff(pred_def_86048,type,
    v143145: ( state_type * $int ) > $o ).

tff(pred_def_86049,type,
    v143143: ( state_type * $int ) > $o ).

tff(pred_def_86050,type,
    v143165: state_type > $o ).

tff(pred_def_86051,type,
    v143163: state_type > $o ).

tff(pred_def_86052,type,
    v143172: state_type > $o ).

tff(pred_def_86053,type,
    v143170: state_type > $o ).

tff(pred_def_86054,type,
    v143169: state_type > $o ).

tff(pred_def_86055,type,
    v143168: state_type > $o ).

tff(pred_def_86056,type,
    v143180: state_type > $o ).

tff(pred_def_86057,type,
    v143181: state_type > $o ).

tff(pred_def_86058,type,
    v143179: state_type > $o ).

tff(pred_def_86059,type,
    v143176: ( state_type * $int ) > $o ).

tff(pred_def_86060,type,
    v143178: ( state_type * $int ) > $o ).

tff(pred_def_86061,type,
    v143167: ( state_type * $int ) > $o ).

tff(pred_def_86062,type,
    v143133: ( state_type * $int ) > $o ).

tff(pred_def_86063,type,
    v143129: ( state_type * $int ) > $o ).

tff(pred_def_86064,type,
    v143194: state_type > $o ).

tff(pred_def_86065,type,
    v143192: state_type > $o ).

tff(pred_def_86066,type,
    v143198: state_type > $o ).

tff(pred_def_86067,type,
    v143196: state_type > $o ).

tff(pred_def_86068,type,
    v143204: ( state_type * $int ) > $o ).

tff(pred_def_86069,type,
    b11000: $int > $o ).

tff(pred_def_86070,type,
    v143210: state_type > $o ).

tff(pred_def_86071,type,
    v143208: state_type > $o ).

tff(pred_def_86072,type,
    v143206: state_type > $o ).

tff(pred_def_86073,type,
    v143214: state_type > $o ).

tff(pred_def_86074,type,
    v143213: ( state_type * $int ) > $o ).

tff(pred_def_86075,type,
    v143212: ( state_type * $int ) > $o ).

tff(pred_def_86076,type,
    v143218: state_type > $o ).

tff(pred_def_86077,type,
    v143217: ( state_type * $int ) > $o ).

tff(pred_def_86078,type,
    v143216: ( state_type * $int ) > $o ).

tff(pred_def_86079,type,
    v143188: ( state_type * $int ) > $o ).

tff(pred_def_86080,type,
    v143215: ( state_type * $int ) > $o ).

tff(pred_def_86081,type,
    v143211: ( state_type * $int ) > $o ).

tff(pred_def_86082,type,
    v143202: ( state_type * $int ) > $o ).

tff(pred_def_86083,type,
    v143200: ( state_type * $int ) > $o ).

tff(pred_def_86084,type,
    v143222: state_type > $o ).

tff(pred_def_86085,type,
    v143220: state_type > $o ).

tff(pred_def_86086,type,
    v143229: state_type > $o ).

tff(pred_def_86087,type,
    v143227: state_type > $o ).

tff(pred_def_86088,type,
    v143226: state_type > $o ).

tff(pred_def_86089,type,
    v143225: state_type > $o ).

tff(pred_def_86090,type,
    v143237: state_type > $o ).

tff(pred_def_86091,type,
    v143238: state_type > $o ).

tff(pred_def_86092,type,
    v143236: state_type > $o ).

tff(pred_def_86093,type,
    v143233: ( state_type * $int ) > $o ).

tff(pred_def_86094,type,
    v143235: ( state_type * $int ) > $o ).

tff(pred_def_86095,type,
    v143224: ( state_type * $int ) > $o ).

tff(pred_def_86096,type,
    v143190: ( state_type * $int ) > $o ).

tff(pred_def_86097,type,
    v143186: ( state_type * $int ) > $o ).

tff(pred_def_86098,type,
    v143251: state_type > $o ).

tff(pred_def_86099,type,
    v143249: state_type > $o ).

tff(pred_def_86100,type,
    v143255: state_type > $o ).

tff(pred_def_86101,type,
    v143253: state_type > $o ).

tff(pred_def_86102,type,
    v143261: ( state_type * $int ) > $o ).

tff(pred_def_86103,type,
    b11001: $int > $o ).

tff(pred_def_86104,type,
    v143267: state_type > $o ).

tff(pred_def_86105,type,
    v143265: state_type > $o ).

tff(pred_def_86106,type,
    v143263: state_type > $o ).

tff(pred_def_86107,type,
    v143271: state_type > $o ).

tff(pred_def_86108,type,
    v143270: ( state_type * $int ) > $o ).

tff(pred_def_86109,type,
    v143269: ( state_type * $int ) > $o ).

tff(pred_def_86110,type,
    v143275: state_type > $o ).

tff(pred_def_86111,type,
    v143274: ( state_type * $int ) > $o ).

tff(pred_def_86112,type,
    v143273: ( state_type * $int ) > $o ).

tff(pred_def_86113,type,
    v143245: ( state_type * $int ) > $o ).

tff(pred_def_86114,type,
    v143272: ( state_type * $int ) > $o ).

tff(pred_def_86115,type,
    v143268: ( state_type * $int ) > $o ).

tff(pred_def_86116,type,
    v143259: ( state_type * $int ) > $o ).

tff(pred_def_86117,type,
    v143257: ( state_type * $int ) > $o ).

tff(pred_def_86118,type,
    v143279: state_type > $o ).

tff(pred_def_86119,type,
    v143277: state_type > $o ).

tff(pred_def_86120,type,
    v143286: state_type > $o ).

tff(pred_def_86121,type,
    v143284: state_type > $o ).

tff(pred_def_86122,type,
    v143283: state_type > $o ).

tff(pred_def_86123,type,
    v143282: state_type > $o ).

tff(pred_def_86124,type,
    v143294: state_type > $o ).

tff(pred_def_86125,type,
    v143295: state_type > $o ).

tff(pred_def_86126,type,
    v143293: state_type > $o ).

tff(pred_def_86127,type,
    v143290: ( state_type * $int ) > $o ).

tff(pred_def_86128,type,
    v143292: ( state_type * $int ) > $o ).

tff(pred_def_86129,type,
    v143281: ( state_type * $int ) > $o ).

tff(pred_def_86130,type,
    v143247: ( state_type * $int ) > $o ).

tff(pred_def_86131,type,
    v143243: ( state_type * $int ) > $o ).

tff(pred_def_86132,type,
    v143308: state_type > $o ).

tff(pred_def_86133,type,
    v143306: state_type > $o ).

tff(pred_def_86134,type,
    v143312: state_type > $o ).

tff(pred_def_86135,type,
    v143310: state_type > $o ).

tff(pred_def_86136,type,
    v143318: ( state_type * $int ) > $o ).

tff(pred_def_86137,type,
    b11010: $int > $o ).

tff(pred_def_86138,type,
    v143324: state_type > $o ).

tff(pred_def_86139,type,
    v143322: state_type > $o ).

tff(pred_def_86140,type,
    v143320: state_type > $o ).

tff(pred_def_86141,type,
    v143328: state_type > $o ).

tff(pred_def_86142,type,
    v143327: ( state_type * $int ) > $o ).

tff(pred_def_86143,type,
    v143326: ( state_type * $int ) > $o ).

tff(pred_def_86144,type,
    v143332: state_type > $o ).

tff(pred_def_86145,type,
    v143331: ( state_type * $int ) > $o ).

tff(pred_def_86146,type,
    v143330: ( state_type * $int ) > $o ).

tff(pred_def_86147,type,
    v143302: ( state_type * $int ) > $o ).

tff(pred_def_86148,type,
    v143329: ( state_type * $int ) > $o ).

tff(pred_def_86149,type,
    v143325: ( state_type * $int ) > $o ).

tff(pred_def_86150,type,
    v143316: ( state_type * $int ) > $o ).

tff(pred_def_86151,type,
    v143314: ( state_type * $int ) > $o ).

tff(pred_def_86152,type,
    v143336: state_type > $o ).

tff(pred_def_86153,type,
    v143334: state_type > $o ).

tff(pred_def_86154,type,
    v143343: state_type > $o ).

tff(pred_def_86155,type,
    v143341: state_type > $o ).

tff(pred_def_86156,type,
    v143340: state_type > $o ).

tff(pred_def_86157,type,
    v143339: state_type > $o ).

tff(pred_def_86158,type,
    v143351: state_type > $o ).

tff(pred_def_86159,type,
    v143352: state_type > $o ).

tff(pred_def_86160,type,
    v143350: state_type > $o ).

tff(pred_def_86161,type,
    v143347: ( state_type * $int ) > $o ).

tff(pred_def_86162,type,
    v143349: ( state_type * $int ) > $o ).

tff(pred_def_86163,type,
    v143338: ( state_type * $int ) > $o ).

tff(pred_def_86164,type,
    v143304: ( state_type * $int ) > $o ).

tff(pred_def_86165,type,
    v143300: ( state_type * $int ) > $o ).

tff(pred_def_86166,type,
    v143365: state_type > $o ).

tff(pred_def_86167,type,
    v143363: state_type > $o ).

tff(pred_def_86168,type,
    v143369: state_type > $o ).

tff(pred_def_86169,type,
    v143367: state_type > $o ).

tff(pred_def_86170,type,
    v143375: ( state_type * $int ) > $o ).

tff(pred_def_86171,type,
    b11011: $int > $o ).

tff(pred_def_86172,type,
    v143381: state_type > $o ).

tff(pred_def_86173,type,
    v143379: state_type > $o ).

tff(pred_def_86174,type,
    v143377: state_type > $o ).

tff(pred_def_86175,type,
    v143385: state_type > $o ).

tff(pred_def_86176,type,
    v143384: ( state_type * $int ) > $o ).

tff(pred_def_86177,type,
    v143383: ( state_type * $int ) > $o ).

tff(pred_def_86178,type,
    v143389: state_type > $o ).

tff(pred_def_86179,type,
    v143388: ( state_type * $int ) > $o ).

tff(pred_def_86180,type,
    v143387: ( state_type * $int ) > $o ).

tff(pred_def_86181,type,
    v143359: ( state_type * $int ) > $o ).

tff(pred_def_86182,type,
    v143386: ( state_type * $int ) > $o ).

tff(pred_def_86183,type,
    v143382: ( state_type * $int ) > $o ).

tff(pred_def_86184,type,
    v143373: ( state_type * $int ) > $o ).

tff(pred_def_86185,type,
    v143371: ( state_type * $int ) > $o ).

tff(pred_def_86186,type,
    v143393: state_type > $o ).

tff(pred_def_86187,type,
    v143391: state_type > $o ).

tff(pred_def_86188,type,
    v143400: state_type > $o ).

tff(pred_def_86189,type,
    v143398: state_type > $o ).

tff(pred_def_86190,type,
    v143397: state_type > $o ).

tff(pred_def_86191,type,
    v143396: state_type > $o ).

tff(pred_def_86192,type,
    v143408: state_type > $o ).

tff(pred_def_86193,type,
    v143409: state_type > $o ).

tff(pred_def_86194,type,
    v143407: state_type > $o ).

tff(pred_def_86195,type,
    v143404: ( state_type * $int ) > $o ).

tff(pred_def_86196,type,
    v143406: ( state_type * $int ) > $o ).

tff(pred_def_86197,type,
    v143395: ( state_type * $int ) > $o ).

tff(pred_def_86198,type,
    v143361: ( state_type * $int ) > $o ).

tff(pred_def_86199,type,
    v143357: ( state_type * $int ) > $o ).

tff(pred_def_86200,type,
    v143422: state_type > $o ).

tff(pred_def_86201,type,
    v143420: state_type > $o ).

tff(pred_def_86202,type,
    v143426: state_type > $o ).

tff(pred_def_86203,type,
    v143424: state_type > $o ).

tff(pred_def_86204,type,
    v143432: ( state_type * $int ) > $o ).

tff(pred_def_86205,type,
    b11100: $int > $o ).

tff(pred_def_86206,type,
    v143438: state_type > $o ).

tff(pred_def_86207,type,
    v143436: state_type > $o ).

tff(pred_def_86208,type,
    v143434: state_type > $o ).

tff(pred_def_86209,type,
    v143442: state_type > $o ).

tff(pred_def_86210,type,
    v143441: ( state_type * $int ) > $o ).

tff(pred_def_86211,type,
    v143440: ( state_type * $int ) > $o ).

tff(pred_def_86212,type,
    v143446: state_type > $o ).

tff(pred_def_86213,type,
    v143445: ( state_type * $int ) > $o ).

tff(pred_def_86214,type,
    v143444: ( state_type * $int ) > $o ).

tff(pred_def_86215,type,
    v143416: ( state_type * $int ) > $o ).

tff(pred_def_86216,type,
    v143443: ( state_type * $int ) > $o ).

tff(pred_def_86217,type,
    v143439: ( state_type * $int ) > $o ).

tff(pred_def_86218,type,
    v143430: ( state_type * $int ) > $o ).

tff(pred_def_86219,type,
    v143428: ( state_type * $int ) > $o ).

tff(pred_def_86220,type,
    v143450: state_type > $o ).

tff(pred_def_86221,type,
    v143448: state_type > $o ).

tff(pred_def_86222,type,
    v143457: state_type > $o ).

tff(pred_def_86223,type,
    v143455: state_type > $o ).

tff(pred_def_86224,type,
    v143454: state_type > $o ).

tff(pred_def_86225,type,
    v143453: state_type > $o ).

tff(pred_def_86226,type,
    v143465: state_type > $o ).

tff(pred_def_86227,type,
    v143466: state_type > $o ).

tff(pred_def_86228,type,
    v143464: state_type > $o ).

tff(pred_def_86229,type,
    v143461: ( state_type * $int ) > $o ).

tff(pred_def_86230,type,
    v143463: ( state_type * $int ) > $o ).

tff(pred_def_86231,type,
    v143452: ( state_type * $int ) > $o ).

tff(pred_def_86232,type,
    v143418: ( state_type * $int ) > $o ).

tff(pred_def_86233,type,
    v143414: ( state_type * $int ) > $o ).

tff(pred_def_86234,type,
    v143479: state_type > $o ).

tff(pred_def_86235,type,
    v143477: state_type > $o ).

tff(pred_def_86236,type,
    v143483: state_type > $o ).

tff(pred_def_86237,type,
    v143481: state_type > $o ).

tff(pred_def_86238,type,
    v143489: ( state_type * $int ) > $o ).

tff(pred_def_86239,type,
    b11101: $int > $o ).

tff(pred_def_86240,type,
    v143495: state_type > $o ).

tff(pred_def_86241,type,
    v143493: state_type > $o ).

tff(pred_def_86242,type,
    v143491: state_type > $o ).

tff(pred_def_86243,type,
    v143499: state_type > $o ).

tff(pred_def_86244,type,
    v143498: ( state_type * $int ) > $o ).

tff(pred_def_86245,type,
    v143497: ( state_type * $int ) > $o ).

tff(pred_def_86246,type,
    v143503: state_type > $o ).

tff(pred_def_86247,type,
    v143502: ( state_type * $int ) > $o ).

tff(pred_def_86248,type,
    v143501: ( state_type * $int ) > $o ).

tff(pred_def_86249,type,
    v143473: ( state_type * $int ) > $o ).

tff(pred_def_86250,type,
    v143500: ( state_type * $int ) > $o ).

tff(pred_def_86251,type,
    v143496: ( state_type * $int ) > $o ).

tff(pred_def_86252,type,
    v143487: ( state_type * $int ) > $o ).

tff(pred_def_86253,type,
    v143485: ( state_type * $int ) > $o ).

tff(pred_def_86254,type,
    v143507: state_type > $o ).

tff(pred_def_86255,type,
    v143505: state_type > $o ).

tff(pred_def_86256,type,
    v143514: state_type > $o ).

tff(pred_def_86257,type,
    v143512: state_type > $o ).

tff(pred_def_86258,type,
    v143511: state_type > $o ).

tff(pred_def_86259,type,
    v143510: state_type > $o ).

tff(pred_def_86260,type,
    v143522: state_type > $o ).

tff(pred_def_86261,type,
    v143523: state_type > $o ).

tff(pred_def_86262,type,
    v143521: state_type > $o ).

tff(pred_def_86263,type,
    v143518: ( state_type * $int ) > $o ).

tff(pred_def_86264,type,
    v143520: ( state_type * $int ) > $o ).

tff(pred_def_86265,type,
    v143509: ( state_type * $int ) > $o ).

tff(pred_def_86266,type,
    v143475: ( state_type * $int ) > $o ).

tff(pred_def_86267,type,
    v143471: ( state_type * $int ) > $o ).

tff(pred_def_86268,type,
    v143536: state_type > $o ).

tff(pred_def_86269,type,
    v143534: state_type > $o ).

tff(pred_def_86270,type,
    v143540: state_type > $o ).

tff(pred_def_86271,type,
    v143538: state_type > $o ).

tff(pred_def_86272,type,
    v143546: ( state_type * $int ) > $o ).

tff(pred_def_86273,type,
    b11110: $int > $o ).

tff(pred_def_86274,type,
    v143552: state_type > $o ).

tff(pred_def_86275,type,
    v143550: state_type > $o ).

tff(pred_def_86276,type,
    v143548: state_type > $o ).

tff(pred_def_86277,type,
    v143556: state_type > $o ).

tff(pred_def_86278,type,
    v143555: ( state_type * $int ) > $o ).

tff(pred_def_86279,type,
    v143554: ( state_type * $int ) > $o ).

tff(pred_def_86280,type,
    v143560: state_type > $o ).

tff(pred_def_86281,type,
    v143559: ( state_type * $int ) > $o ).

tff(pred_def_86282,type,
    v143558: ( state_type * $int ) > $o ).

tff(pred_def_86283,type,
    v143530: ( state_type * $int ) > $o ).

tff(pred_def_86284,type,
    v143557: ( state_type * $int ) > $o ).

tff(pred_def_86285,type,
    v143553: ( state_type * $int ) > $o ).

tff(pred_def_86286,type,
    v143544: ( state_type * $int ) > $o ).

tff(pred_def_86287,type,
    v143542: ( state_type * $int ) > $o ).

tff(pred_def_86288,type,
    v143564: state_type > $o ).

tff(pred_def_86289,type,
    v143562: state_type > $o ).

tff(pred_def_86290,type,
    v143571: state_type > $o ).

tff(pred_def_86291,type,
    v143569: state_type > $o ).

tff(pred_def_86292,type,
    v143568: state_type > $o ).

tff(pred_def_86293,type,
    v143567: state_type > $o ).

tff(pred_def_86294,type,
    v143579: state_type > $o ).

tff(pred_def_86295,type,
    v143580: state_type > $o ).

tff(pred_def_86296,type,
    v143578: state_type > $o ).

tff(pred_def_86297,type,
    v143575: ( state_type * $int ) > $o ).

tff(pred_def_86298,type,
    v143577: ( state_type * $int ) > $o ).

tff(pred_def_86299,type,
    v143566: ( state_type * $int ) > $o ).

tff(pred_def_86300,type,
    v143532: ( state_type * $int ) > $o ).

tff(pred_def_86301,type,
    v143528: ( state_type * $int ) > $o ).

tff(pred_def_86302,type,
    v143593: state_type > $o ).

tff(pred_def_86303,type,
    v143591: state_type > $o ).

tff(pred_def_86304,type,
    v143597: state_type > $o ).

tff(pred_def_86305,type,
    v143595: state_type > $o ).

tff(pred_def_86306,type,
    v143603: ( state_type * $int ) > $o ).

tff(pred_def_86307,type,
    b11111: $int > $o ).

tff(pred_def_86308,type,
    v143609: state_type > $o ).

tff(pred_def_86309,type,
    v143607: state_type > $o ).

tff(pred_def_86310,type,
    v143605: state_type > $o ).

tff(pred_def_86311,type,
    v143613: state_type > $o ).

tff(pred_def_86312,type,
    v143612: ( state_type * $int ) > $o ).

tff(pred_def_86313,type,
    v143611: ( state_type * $int ) > $o ).

tff(pred_def_86314,type,
    v143617: state_type > $o ).

tff(pred_def_86315,type,
    v143616: ( state_type * $int ) > $o ).

tff(pred_def_86316,type,
    v143615: ( state_type * $int ) > $o ).

tff(pred_def_86317,type,
    v143587: ( state_type * $int ) > $o ).

tff(pred_def_86318,type,
    v143614: ( state_type * $int ) > $o ).

tff(pred_def_86319,type,
    v143610: ( state_type * $int ) > $o ).

tff(pred_def_86320,type,
    v143601: ( state_type * $int ) > $o ).

tff(pred_def_86321,type,
    v143599: ( state_type * $int ) > $o ).

tff(pred_def_86322,type,
    v143621: state_type > $o ).

tff(pred_def_86323,type,
    v143619: state_type > $o ).

tff(pred_def_86324,type,
    v143628: state_type > $o ).

tff(pred_def_86325,type,
    v143626: state_type > $o ).

tff(pred_def_86326,type,
    v143625: state_type > $o ).

tff(pred_def_86327,type,
    v143624: state_type > $o ).

tff(pred_def_86328,type,
    v143636: state_type > $o ).

tff(pred_def_86329,type,
    v143637: state_type > $o ).

tff(pred_def_86330,type,
    v143635: state_type > $o ).

tff(pred_def_86331,type,
    v143632: ( state_type * $int ) > $o ).

tff(pred_def_86332,type,
    v143634: ( state_type * $int ) > $o ).

tff(pred_def_86333,type,
    v143623: ( state_type * $int ) > $o ).

tff(pred_def_86334,type,
    v143589: ( state_type * $int ) > $o ).

tff(pred_def_86335,type,
    v143585: ( state_type * $int ) > $o ).

tff(pred_def_86336,type,
    v143674: state_type > $o ).

tff(pred_def_86337,type,
    v143673: state_type > $o ).

tff(pred_def_86338,type,
    v143672: ( state_type * $int ) > $o ).

tff(pred_def_86339,type,
    v143671: ( state_type * $int ) > $o ).

tff(pred_def_86340,type,
    v143678: state_type > $o ).

tff(pred_def_86341,type,
    v143677: state_type > $o ).

tff(pred_def_86342,type,
    v143676: ( state_type * $int ) > $o ).

tff(pred_def_86343,type,
    v143675: ( state_type * $int ) > $o ).

tff(pred_def_86344,type,
    v143670: ( state_type * $int ) > $o ).

tff(pred_def_86345,type,
    v143682: state_type > $o ).

tff(pred_def_86346,type,
    v143681: state_type > $o ).

tff(pred_def_86347,type,
    v143680: ( state_type * $int ) > $o ).

tff(pred_def_86348,type,
    v143679: ( state_type * $int ) > $o ).

tff(pred_def_86349,type,
    v143669: ( state_type * $int ) > $o ).

tff(pred_def_86350,type,
    v143686: state_type > $o ).

tff(pred_def_86351,type,
    v143685: state_type > $o ).

tff(pred_def_86352,type,
    v143684: ( state_type * $int ) > $o ).

tff(pred_def_86353,type,
    v143683: ( state_type * $int ) > $o ).

tff(pred_def_86354,type,
    v143668: ( state_type * $int ) > $o ).

tff(pred_def_86355,type,
    v143690: state_type > $o ).

tff(pred_def_86356,type,
    v143689: state_type > $o ).

tff(pred_def_86357,type,
    v143688: ( state_type * $int ) > $o ).

tff(pred_def_86358,type,
    v143687: ( state_type * $int ) > $o ).

tff(pred_def_86359,type,
    v143667: ( state_type * $int ) > $o ).

tff(pred_def_86360,type,
    v143694: state_type > $o ).

tff(pred_def_86361,type,
    v143693: state_type > $o ).

tff(pred_def_86362,type,
    v143692: ( state_type * $int ) > $o ).

tff(pred_def_86363,type,
    v143691: ( state_type * $int ) > $o ).

tff(pred_def_86364,type,
    v143666: ( state_type * $int ) > $o ).

tff(pred_def_86365,type,
    v143698: state_type > $o ).

tff(pred_def_86366,type,
    v143697: state_type > $o ).

tff(pred_def_86367,type,
    v143696: ( state_type * $int ) > $o ).

tff(pred_def_86368,type,
    v143695: ( state_type * $int ) > $o ).

tff(pred_def_86369,type,
    v143665: ( state_type * $int ) > $o ).

tff(pred_def_86370,type,
    v143702: state_type > $o ).

tff(pred_def_86371,type,
    v143701: state_type > $o ).

tff(pred_def_86372,type,
    v143700: ( state_type * $int ) > $o ).

tff(pred_def_86373,type,
    v143699: ( state_type * $int ) > $o ).

tff(pred_def_86374,type,
    v143664: ( state_type * $int ) > $o ).

tff(pred_def_86375,type,
    v143706: state_type > $o ).

tff(pred_def_86376,type,
    v143705: state_type > $o ).

tff(pred_def_86377,type,
    v143704: ( state_type * $int ) > $o ).

tff(pred_def_86378,type,
    v143703: ( state_type * $int ) > $o ).

tff(pred_def_86379,type,
    v143663: ( state_type * $int ) > $o ).

tff(pred_def_86380,type,
    v143710: state_type > $o ).

tff(pred_def_86381,type,
    v143709: state_type > $o ).

tff(pred_def_86382,type,
    v143708: ( state_type * $int ) > $o ).

tff(pred_def_86383,type,
    v143707: ( state_type * $int ) > $o ).

tff(pred_def_86384,type,
    v143662: ( state_type * $int ) > $o ).

tff(pred_def_86385,type,
    v143714: state_type > $o ).

tff(pred_def_86386,type,
    v143713: state_type > $o ).

tff(pred_def_86387,type,
    v143712: ( state_type * $int ) > $o ).

tff(pred_def_86388,type,
    v143711: ( state_type * $int ) > $o ).

tff(pred_def_86389,type,
    v143661: ( state_type * $int ) > $o ).

tff(pred_def_86390,type,
    v143718: state_type > $o ).

tff(pred_def_86391,type,
    v143717: state_type > $o ).

tff(pred_def_86392,type,
    v143716: ( state_type * $int ) > $o ).

tff(pred_def_86393,type,
    v143715: ( state_type * $int ) > $o ).

tff(pred_def_86394,type,
    v143660: ( state_type * $int ) > $o ).

tff(pred_def_86395,type,
    v143722: state_type > $o ).

tff(pred_def_86396,type,
    v143721: state_type > $o ).

tff(pred_def_86397,type,
    v143720: ( state_type * $int ) > $o ).

tff(pred_def_86398,type,
    v143719: ( state_type * $int ) > $o ).

tff(pred_def_86399,type,
    v143659: ( state_type * $int ) > $o ).

tff(pred_def_86400,type,
    v143726: state_type > $o ).

tff(pred_def_86401,type,
    v143725: state_type > $o ).

tff(pred_def_86402,type,
    v143724: ( state_type * $int ) > $o ).

tff(pred_def_86403,type,
    v143723: ( state_type * $int ) > $o ).

tff(pred_def_86404,type,
    v143658: ( state_type * $int ) > $o ).

tff(pred_def_86405,type,
    v143730: state_type > $o ).

tff(pred_def_86406,type,
    v143729: state_type > $o ).

tff(pred_def_86407,type,
    v143728: ( state_type * $int ) > $o ).

tff(pred_def_86408,type,
    v143727: ( state_type * $int ) > $o ).

tff(pred_def_86409,type,
    v143657: ( state_type * $int ) > $o ).

tff(pred_def_86410,type,
    v143734: state_type > $o ).

tff(pred_def_86411,type,
    v143733: state_type > $o ).

tff(pred_def_86412,type,
    v143732: ( state_type * $int ) > $o ).

tff(pred_def_86413,type,
    v143731: ( state_type * $int ) > $o ).

tff(pred_def_86414,type,
    v143656: ( state_type * $int ) > $o ).

tff(pred_def_86415,type,
    v143738: state_type > $o ).

tff(pred_def_86416,type,
    v143737: state_type > $o ).

tff(pred_def_86417,type,
    v143736: ( state_type * $int ) > $o ).

tff(pred_def_86418,type,
    v143735: ( state_type * $int ) > $o ).

tff(pred_def_86419,type,
    v143655: ( state_type * $int ) > $o ).

tff(pred_def_86420,type,
    v143742: state_type > $o ).

tff(pred_def_86421,type,
    v143741: state_type > $o ).

tff(pred_def_86422,type,
    v143740: ( state_type * $int ) > $o ).

tff(pred_def_86423,type,
    v143739: ( state_type * $int ) > $o ).

tff(pred_def_86424,type,
    v143654: ( state_type * $int ) > $o ).

tff(pred_def_86425,type,
    v143746: state_type > $o ).

tff(pred_def_86426,type,
    v143745: state_type > $o ).

tff(pred_def_86427,type,
    v143744: ( state_type * $int ) > $o ).

tff(pred_def_86428,type,
    v143743: ( state_type * $int ) > $o ).

tff(pred_def_86429,type,
    v143653: ( state_type * $int ) > $o ).

tff(pred_def_86430,type,
    v143750: state_type > $o ).

tff(pred_def_86431,type,
    v143749: state_type > $o ).

tff(pred_def_86432,type,
    v143748: ( state_type * $int ) > $o ).

tff(pred_def_86433,type,
    v143747: ( state_type * $int ) > $o ).

tff(pred_def_86434,type,
    v143652: ( state_type * $int ) > $o ).

tff(pred_def_86435,type,
    v143754: state_type > $o ).

tff(pred_def_86436,type,
    v143753: state_type > $o ).

tff(pred_def_86437,type,
    v143752: ( state_type * $int ) > $o ).

tff(pred_def_86438,type,
    v143751: ( state_type * $int ) > $o ).

tff(pred_def_86439,type,
    v143651: ( state_type * $int ) > $o ).

tff(pred_def_86440,type,
    v143758: state_type > $o ).

tff(pred_def_86441,type,
    v143757: state_type > $o ).

tff(pred_def_86442,type,
    v143756: ( state_type * $int ) > $o ).

tff(pred_def_86443,type,
    v143755: ( state_type * $int ) > $o ).

tff(pred_def_86444,type,
    v143650: ( state_type * $int ) > $o ).

tff(pred_def_86445,type,
    v143762: state_type > $o ).

tff(pred_def_86446,type,
    v143761: state_type > $o ).

tff(pred_def_86447,type,
    v143760: ( state_type * $int ) > $o ).

tff(pred_def_86448,type,
    v143759: ( state_type * $int ) > $o ).

tff(pred_def_86449,type,
    v143649: ( state_type * $int ) > $o ).

tff(pred_def_86450,type,
    v143766: state_type > $o ).

tff(pred_def_86451,type,
    v143765: state_type > $o ).

tff(pred_def_86452,type,
    v143764: ( state_type * $int ) > $o ).

tff(pred_def_86453,type,
    v143763: ( state_type * $int ) > $o ).

tff(pred_def_86454,type,
    v143648: ( state_type * $int ) > $o ).

tff(pred_def_86455,type,
    v143770: state_type > $o ).

tff(pred_def_86456,type,
    v143769: state_type > $o ).

tff(pred_def_86457,type,
    v143768: ( state_type * $int ) > $o ).

tff(pred_def_86458,type,
    v143767: ( state_type * $int ) > $o ).

tff(pred_def_86459,type,
    v143647: ( state_type * $int ) > $o ).

tff(pred_def_86460,type,
    v143774: state_type > $o ).

tff(pred_def_86461,type,
    v143773: state_type > $o ).

tff(pred_def_86462,type,
    v143772: ( state_type * $int ) > $o ).

tff(pred_def_86463,type,
    v143771: ( state_type * $int ) > $o ).

tff(pred_def_86464,type,
    v143646: ( state_type * $int ) > $o ).

tff(pred_def_86465,type,
    v143778: state_type > $o ).

tff(pred_def_86466,type,
    v143777: state_type > $o ).

tff(pred_def_86467,type,
    v143776: ( state_type * $int ) > $o ).

tff(pred_def_86468,type,
    v143775: ( state_type * $int ) > $o ).

tff(pred_def_86469,type,
    v143645: ( state_type * $int ) > $o ).

tff(pred_def_86470,type,
    v143782: state_type > $o ).

tff(pred_def_86471,type,
    v143781: state_type > $o ).

tff(pred_def_86472,type,
    v143780: ( state_type * $int ) > $o ).

tff(pred_def_86473,type,
    v143779: ( state_type * $int ) > $o ).

tff(pred_def_86474,type,
    v143644: ( state_type * $int ) > $o ).

tff(pred_def_86475,type,
    v143786: state_type > $o ).

tff(pred_def_86476,type,
    v143785: state_type > $o ).

tff(pred_def_86477,type,
    v143784: ( state_type * $int ) > $o ).

tff(pred_def_86478,type,
    v143783: ( state_type * $int ) > $o ).

tff(pred_def_86479,type,
    v143643: ( state_type * $int ) > $o ).

tff(pred_def_86480,type,
    v143790: state_type > $o ).

tff(pred_def_86481,type,
    v143789: state_type > $o ).

tff(pred_def_86482,type,
    v143788: ( state_type * $int ) > $o ).

tff(pred_def_86483,type,
    v143787: ( state_type * $int ) > $o ).

tff(pred_def_86484,type,
    v143642: ( state_type * $int ) > $o ).

tff(pred_def_86485,type,
    v143794: state_type > $o ).

tff(pred_def_86486,type,
    v143793: state_type > $o ).

tff(pred_def_86487,type,
    v143792: ( state_type * $int ) > $o ).

tff(pred_def_86488,type,
    v143791: ( state_type * $int ) > $o ).

tff(pred_def_86489,type,
    v143641: ( state_type * $int ) > $o ).

tff(pred_def_86490,type,
    v143798: state_type > $o ).

tff(pred_def_86491,type,
    v143797: state_type > $o ).

tff(pred_def_86492,type,
    v143796: ( state_type * $int ) > $o ).

tff(pred_def_86493,type,
    v143795: ( state_type * $int ) > $o ).

tff(pred_def_86494,type,
    v143640: ( state_type * $int ) > $o ).

tff(pred_def_86495,type,
    v2202: ( state_type * $int ) > $o ).

tff(pred_def_86496,type,
    v143808: state_type > $o ).

tff(pred_def_86497,type,
    v143806: state_type > $o ).

tff(pred_def_86498,type,
    v143812: state_type > $o ).

tff(pred_def_86499,type,
    v143810: state_type > $o ).

tff(pred_def_86500,type,
    v143822: state_type > $o ).

tff(pred_def_86501,type,
    v143820: state_type > $o ).

tff(pred_def_86502,type,
    v143823: ( state_type * $int ) > $o ).

tff(pred_def_86503,type,
    v143800: state_type > $o ).

tff(pred_def_86504,type,
    v143824: state_type > $o ).

tff(pred_def_86505,type,
    v143818: ( state_type * $int ) > $o ).

tff(pred_def_86506,type,
    v143816: ( state_type * $int ) > $o ).

tff(pred_def_86507,type,
    v143814: ( state_type * $int ) > $o ).

tff(pred_def_86508,type,
    v143828: state_type > $o ).

tff(pred_def_86509,type,
    v143826: state_type > $o ).

tff(pred_def_86510,type,
    v143835: state_type > $o ).

tff(pred_def_86511,type,
    v143833: state_type > $o ).

tff(pred_def_86512,type,
    v143832: state_type > $o ).

tff(pred_def_86513,type,
    v143831: state_type > $o ).

tff(pred_def_86514,type,
    v143843: state_type > $o ).

tff(pred_def_86515,type,
    v143844: state_type > $o ).

tff(pred_def_86516,type,
    v143842: state_type > $o ).

tff(pred_def_86517,type,
    v143839: ( state_type * $int ) > $o ).

tff(pred_def_86518,type,
    v143841: ( state_type * $int ) > $o ).

tff(pred_def_86519,type,
    v143830: ( state_type * $int ) > $o ).

tff(pred_def_86520,type,
    v143804: ( state_type * $int ) > $o ).

tff(pred_def_86521,type,
    v143802: ( state_type * $int ) > $o ).

tff(pred_def_86522,type,
    v143856: state_type > $o ).

tff(pred_def_86523,type,
    v143854: state_type > $o ).

tff(pred_def_86524,type,
    v143860: state_type > $o ).

tff(pred_def_86525,type,
    v143858: state_type > $o ).

tff(pred_def_86526,type,
    v143866: ( state_type * $int ) > $o ).

tff(pred_def_86527,type,
    v143872: state_type > $o ).

tff(pred_def_86528,type,
    v143870: state_type > $o ).

tff(pred_def_86529,type,
    v143868: state_type > $o ).

tff(pred_def_86530,type,
    v143876: state_type > $o ).

tff(pred_def_86531,type,
    v143875: ( state_type * $int ) > $o ).

tff(pred_def_86532,type,
    v143874: ( state_type * $int ) > $o ).

tff(pred_def_86533,type,
    v143880: state_type > $o ).

tff(pred_def_86534,type,
    v143879: ( state_type * $int ) > $o ).

tff(pred_def_86535,type,
    v143878: ( state_type * $int ) > $o ).

tff(pred_def_86536,type,
    v143850: ( state_type * $int ) > $o ).

tff(pred_def_86537,type,
    v143877: ( state_type * $int ) > $o ).

tff(pred_def_86538,type,
    v143864: ( state_type * $int ) > $o ).

tff(pred_def_86539,type,
    v143862: ( state_type * $int ) > $o ).

tff(pred_def_86540,type,
    v143884: state_type > $o ).

tff(pred_def_86541,type,
    v143882: state_type > $o ).

tff(pred_def_86542,type,
    v143891: state_type > $o ).

tff(pred_def_86543,type,
    v143889: state_type > $o ).

tff(pred_def_86544,type,
    v143888: state_type > $o ).

tff(pred_def_86545,type,
    v143887: state_type > $o ).

tff(pred_def_86546,type,
    v143899: state_type > $o ).

tff(pred_def_86547,type,
    v143900: state_type > $o ).

tff(pred_def_86548,type,
    v143898: state_type > $o ).

tff(pred_def_86549,type,
    v143895: ( state_type * $int ) > $o ).

tff(pred_def_86550,type,
    v143897: ( state_type * $int ) > $o ).

tff(pred_def_86551,type,
    v143852: ( state_type * $int ) > $o ).

tff(pred_def_86552,type,
    v143848: ( state_type * $int ) > $o ).

tff(pred_def_86553,type,
    v143909: state_type > $o ).

tff(pred_def_86554,type,
    v143907: state_type > $o ).

tff(pred_def_86555,type,
    v143906: state_type > $o ).

tff(pred_def_86556,type,
    v143905: ( state_type * $int ) > $o ).

tff(pred_def_86557,type,
    v143919: state_type > $o ).

tff(pred_def_86558,type,
    v143917: state_type > $o ).

tff(pred_def_86559,type,
    v143916: state_type > $o ).

tff(pred_def_86560,type,
    v143915: ( state_type * $int ) > $o ).

tff(pred_def_86561,type,
    v143913: state_type > $o ).

tff(pred_def_86562,type,
    v143926: state_type > $o ).

tff(pred_def_86563,type,
    v143925: state_type > $o ).

tff(pred_def_86564,type,
    v143928: state_type > $o ).

tff(pred_def_86565,type,
    v143927: state_type > $o ).

tff(pred_def_86566,type,
    v143924: state_type > $o ).

tff(pred_def_86567,type,
    v143930: state_type > $o ).

tff(pred_def_86568,type,
    v143929: state_type > $o ).

tff(pred_def_86569,type,
    v143923: state_type > $o ).

tff(pred_def_86570,type,
    v143932: state_type > $o ).

tff(pred_def_86571,type,
    v143931: state_type > $o ).

tff(pred_def_86572,type,
    v4511: state_type > $o ).

tff(pred_def_86573,type,
    v143937: state_type > $o ).

tff(pred_def_86574,type,
    v143935: state_type > $o ).

tff(pred_def_86575,type,
    v143938: state_type > $o ).

tff(pred_def_86576,type,
    v143934: state_type > $o ).

tff(pred_def_86577,type,
    v143939: state_type > $o ).

tff(pred_def_86578,type,
    v4345: state_type > $o ).

tff(pred_def_86579,type,
    v4381: state_type > $o ).

tff(pred_def_86580,type,
    v4379: state_type > $o ).

tff(pred_def_86581,type,
    v4377: state_type > $o ).

tff(pred_def_86582,type,
    v4375: state_type > $o ).

tff(pred_def_86583,type,
    v143943: state_type > $o ).

tff(pred_def_86584,type,
    v143941: state_type > $o ).

tff(pred_def_86585,type,
    v143950: state_type > $o ).

tff(pred_def_86586,type,
    v143948: state_type > $o ).

tff(pred_def_86587,type,
    v143947: state_type > $o ).

tff(pred_def_86588,type,
    v143946: state_type > $o ).

tff(pred_def_86589,type,
    v143958: state_type > $o ).

tff(pred_def_86590,type,
    v143959: state_type > $o ).

tff(pred_def_86591,type,
    v143957: state_type > $o ).

tff(pred_def_86592,type,
    v143954: state_type > $o ).

tff(pred_def_86593,type,
    v143956: state_type > $o ).

tff(pred_def_86594,type,
    v4349: state_type > $o ).

tff(pred_def_86595,type,
    v4347: state_type > $o ).

tff(pred_def_86596,type,
    v4341: state_type > $o ).

tff(pred_def_86597,type,
    v143963: state_type > $o ).

tff(pred_def_86598,type,
    v4335: state_type > $o ).

tff(pred_def_86599,type,
    v143970: state_type > $o ).

tff(pred_def_86600,type,
    v143968: state_type > $o ).

tff(pred_def_86601,type,
    v143967: state_type > $o ).

tff(pred_def_86602,type,
    v143966: state_type > $o ).

tff(pred_def_86603,type,
    v143978: state_type > $o ).

tff(pred_def_86604,type,
    v143979: state_type > $o ).

tff(pred_def_86605,type,
    v143977: state_type > $o ).

tff(pred_def_86606,type,
    v143974: state_type > $o ).

tff(pred_def_86607,type,
    v143976: state_type > $o ).

tff(pred_def_86608,type,
    v143984: state_type > $o ).

tff(pred_def_86609,type,
    v143983: state_type > $o ).

tff(pred_def_86610,type,
    v4103: state_type > $o ).

tff(pred_def_86611,type,
    v143985: state_type > $o ).

tff(pred_def_86612,type,
    v4331: state_type > $o ).

tff(pred_def_86613,type,
    v143993: state_type > $o ).

tff(pred_def_86614,type,
    v143991: state_type > $o ).

tff(pred_def_86615,type,
    v143989: state_type > $o ).

tff(pred_def_86616,type,
    v143987: state_type > $o ).

tff(pred_def_86617,type,
    v143995: state_type > $o ).

tff(pred_def_86618,type,
    v144000: state_type > $o ).

tff(pred_def_86619,type,
    v143999: state_type > $o ).

tff(pred_def_86620,type,
    v143998: state_type > $o ).

tff(pred_def_86621,type,
    v143997: state_type > $o ).

tff(pred_def_86622,type,
    v144004: state_type > $o ).

tff(pred_def_86623,type,
    v144003: state_type > $o ).

tff(pred_def_86624,type,
    v144005: state_type > $o ).

tff(pred_def_86625,type,
    v144002: state_type > $o ).

tff(pred_def_86626,type,
    v144009: state_type > $o ).

tff(pred_def_86627,type,
    v144008: state_type > $o ).

tff(pred_def_86628,type,
    v144007: state_type > $o ).

tff(pred_def_86629,type,
    v144006: state_type > $o ).

tff(pred_def_86630,type,
    v4248: state_type > $o ).

tff(pred_def_86631,type,
    v4246: state_type > $o ).

tff(pred_def_86632,type,
    v144022: state_type > $o ).

tff(pred_def_86633,type,
    v144021: state_type > $o ).

tff(pred_def_86634,type,
    v144023: state_type > $o ).

tff(pred_def_86635,type,
    v144020: state_type > $o ).

tff(pred_def_86636,type,
    v144019: state_type > $o ).

tff(pred_def_86637,type,
    v144018: state_type > $o ).

tff(pred_def_86638,type,
    v144017: state_type > $o ).

tff(pred_def_86639,type,
    v144016: state_type > $o ).

tff(pred_def_86640,type,
    b0100001000000: $int > $o ).

tff(pred_def_86641,type,
    v144025: state_type > $o ).

tff(pred_def_86642,type,
    v144024: state_type > $o ).

tff(pred_def_86643,type,
    v144013: state_type > $o ).

tff(pred_def_86644,type,
    v144011: state_type > $o ).

tff(pred_def_86645,type,
    v144029: state_type > $o ).

tff(pred_def_86646,type,
    v144028: state_type > $o ).

tff(pred_def_86647,type,
    v144027: state_type > $o ).

tff(pred_def_86648,type,
    v144033: state_type > $o ).

tff(pred_def_86649,type,
    v144032: state_type > $o ).

tff(pred_def_86650,type,
    v144031: state_type > $o ).

tff(pred_def_86651,type,
    v4230: state_type > $o ).

tff(pred_def_86652,type,
    v144030: state_type > $o ).

tff(pred_def_86653,type,
    v4244: state_type > $o ).

tff(pred_def_86654,type,
    v4242: state_type > $o ).

tff(pred_def_86655,type,
    v144037: state_type > $o ).

tff(pred_def_86656,type,
    v144035: state_type > $o ).

tff(pred_def_86657,type,
    v144044: state_type > $o ).

tff(pred_def_86658,type,
    v144042: state_type > $o ).

tff(pred_def_86659,type,
    v144041: state_type > $o ).

tff(pred_def_86660,type,
    v144040: state_type > $o ).

tff(pred_def_86661,type,
    v144052: state_type > $o ).

tff(pred_def_86662,type,
    v144053: state_type > $o ).

tff(pred_def_86663,type,
    v144051: state_type > $o ).

tff(pred_def_86664,type,
    v144048: state_type > $o ).

tff(pred_def_86665,type,
    v144050: state_type > $o ).

tff(pred_def_86666,type,
    v4232: state_type > $o ).

tff(pred_def_86667,type,
    v144065: state_type > $o ).

tff(pred_def_86668,type,
    v144063: state_type > $o ).

tff(pred_def_86669,type,
    v144069: state_type > $o ).

tff(pred_def_86670,type,
    v144067: state_type > $o ).

tff(pred_def_86671,type,
    v144077: ( state_type * $int ) > $o ).

tff(pred_def_86672,type,
    v144075: ( state_type * $int ) > $o ).

tff(pred_def_86673,type,
    b0100000001000: $int > $o ).

tff(pred_def_86674,type,
    v144084: state_type > $o ).

tff(pred_def_86675,type,
    v144081: state_type > $o ).

tff(pred_def_86676,type,
    v144079: state_type > $o ).

tff(pred_def_86677,type,
    v144088: state_type > $o ).

tff(pred_def_86678,type,
    v144087: ( state_type * $int ) > $o ).

tff(pred_def_86679,type,
    v144086: ( state_type * $int ) > $o ).

tff(pred_def_86680,type,
    v144092: state_type > $o ).

tff(pred_def_86681,type,
    v144091: ( state_type * $int ) > $o ).

tff(pred_def_86682,type,
    v144090: ( state_type * $int ) > $o ).

tff(pred_def_86683,type,
    v144059: ( state_type * $int ) > $o ).

tff(pred_def_86684,type,
    v144089: ( state_type * $int ) > $o ).

tff(pred_def_86685,type,
    v144085: ( state_type * $int ) > $o ).

tff(pred_def_86686,type,
    v144073: ( state_type * $int ) > $o ).

tff(pred_def_86687,type,
    v144071: ( state_type * $int ) > $o ).

tff(pred_def_86688,type,
    v144096: state_type > $o ).

tff(pred_def_86689,type,
    v144094: state_type > $o ).

tff(pred_def_86690,type,
    v144103: state_type > $o ).

tff(pred_def_86691,type,
    v144101: state_type > $o ).

tff(pred_def_86692,type,
    v144100: state_type > $o ).

tff(pred_def_86693,type,
    v144099: state_type > $o ).

tff(pred_def_86694,type,
    v144111: state_type > $o ).

tff(pred_def_86695,type,
    v144112: state_type > $o ).

tff(pred_def_86696,type,
    v144110: state_type > $o ).

tff(pred_def_86697,type,
    v144107: ( state_type * $int ) > $o ).

tff(pred_def_86698,type,
    v144109: ( state_type * $int ) > $o ).

tff(pred_def_86699,type,
    v144098: ( state_type * $int ) > $o ).

tff(pred_def_86700,type,
    v144061: ( state_type * $int ) > $o ).

tff(pred_def_86701,type,
    v144057: state_type > $o ).

tff(pred_def_86702,type,
    v144120: state_type > $o ).

tff(pred_def_86703,type,
    v144118: state_type > $o ).

tff(pred_def_86704,type,
    v144124: state_type > $o ).

tff(pred_def_86705,type,
    v144122: state_type > $o ).

tff(pred_def_86706,type,
    v144133: ( state_type * $int ) > $o ).

tff(pred_def_86707,type,
    v144132: ( state_type * $int ) > $o ).

tff(pred_def_86708,type,
    v144134: ( state_type * $int ) > $o ).

tff(pred_def_86709,type,
    v144130: ( state_type * $int ) > $o ).

tff(pred_def_86710,type,
    b0111010110000: $int > $o ).

tff(pred_def_86711,type,
    v144141: state_type > $o ).

tff(pred_def_86712,type,
    v144138: state_type > $o ).

tff(pred_def_86713,type,
    v144136: state_type > $o ).

tff(pred_def_86714,type,
    v144145: state_type > $o ).

tff(pred_def_86715,type,
    v144144: ( state_type * $int ) > $o ).

tff(pred_def_86716,type,
    v144143: ( state_type * $int ) > $o ).

tff(pred_def_86717,type,
    v144149: state_type > $o ).

tff(pred_def_86718,type,
    v144148: ( state_type * $int ) > $o ).

tff(pred_def_86719,type,
    v144147: ( state_type * $int ) > $o ).

tff(pred_def_86720,type,
    v144146: ( state_type * $int ) > $o ).

tff(pred_def_86721,type,
    v144142: ( state_type * $int ) > $o ).

tff(pred_def_86722,type,
    v144128: ( state_type * $int ) > $o ).

tff(pred_def_86723,type,
    v144126: ( state_type * $int ) > $o ).

tff(pred_def_86724,type,
    v144154: state_type > $o ).

tff(pred_def_86725,type,
    v144152: state_type > $o ).

tff(pred_def_86726,type,
    v144161: state_type > $o ).

tff(pred_def_86727,type,
    v144159: state_type > $o ).

tff(pred_def_86728,type,
    v144158: state_type > $o ).

tff(pred_def_86729,type,
    v144157: state_type > $o ).

tff(pred_def_86730,type,
    v144169: state_type > $o ).

tff(pred_def_86731,type,
    v144170: state_type > $o ).

tff(pred_def_86732,type,
    v144168: state_type > $o ).

tff(pred_def_86733,type,
    v144165: ( state_type * $int ) > $o ).

tff(pred_def_86734,type,
    bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx: $int > $o ).

tff(pred_def_86735,type,
    v144167: ( state_type * $int ) > $o ).

tff(pred_def_86736,type,
    v144156: ( state_type * $int ) > $o ).

tff(pred_def_86737,type,
    v144116: state_type > $o ).

tff(pred_def_86738,type,
    v144178: state_type > $o ).

tff(pred_def_86739,type,
    v144177: state_type > $o ).

tff(pred_def_86740,type,
    v144182: state_type > $o ).

tff(pred_def_86741,type,
    v144184: state_type > $o ).

tff(pred_def_86742,type,
    v144183: state_type > $o ).

tff(pred_def_86743,type,
    v144181: state_type > $o ).

tff(pred_def_86744,type,
    v144187: state_type > $o ).

tff(pred_def_86745,type,
    v144186: state_type > $o ).

tff(pred_def_86746,type,
    v144185: state_type > $o ).

tff(pred_def_86747,type,
    v144180: state_type > $o ).

tff(pred_def_86748,type,
    v144189: state_type > $o ).

tff(pred_def_86749,type,
    v144188: state_type > $o ).

tff(pred_def_86750,type,
    v144179: state_type > $o ).

tff(pred_def_86751,type,
    v144176: state_type > $o ).

tff(pred_def_86752,type,
    v144175: state_type > $o ).

tff(pred_def_86753,type,
    v144193: state_type > $o ).

tff(pred_def_86754,type,
    v144192: state_type > $o ).

tff(pred_def_86755,type,
    v144196: state_type > $o ).

tff(pred_def_86756,type,
    v144195: state_type > $o ).

tff(pred_def_86757,type,
    v144197: state_type > $o ).

tff(pred_def_86758,type,
    v144194: state_type > $o ).

tff(pred_def_86759,type,
    v144191: state_type > $o ).

tff(pred_def_86760,type,
    v144206: state_type > $o ).

tff(pred_def_86761,type,
    v144205: state_type > $o ).

tff(pred_def_86762,type,
    v144208: state_type > $o ).

tff(pred_def_86763,type,
    v144207: state_type > $o ).

tff(pred_def_86764,type,
    v144204: state_type > $o ).

tff(pred_def_86765,type,
    v144210: state_type > $o ).

tff(pred_def_86766,type,
    v144209: state_type > $o ).

tff(pred_def_86767,type,
    v144203: state_type > $o ).

tff(pred_def_86768,type,
    v144212: state_type > $o ).

tff(pred_def_86769,type,
    v144211: state_type > $o ).

tff(pred_def_86770,type,
    v144202: state_type > $o ).

tff(pred_def_86771,type,
    v144214: state_type > $o ).

tff(pred_def_86772,type,
    v144213: state_type > $o ).

tff(pred_def_86773,type,
    v144201: state_type > $o ).

tff(pred_def_86774,type,
    v144200: state_type > $o ).

tff(pred_def_86775,type,
    v144199: state_type > $o ).

tff(pred_def_86776,type,
    v144218: state_type > $o ).

tff(pred_def_86777,type,
    v144217: state_type > $o ).

tff(pred_def_86778,type,
    v144216: state_type > $o ).

tff(pred_def_86779,type,
    v144222: state_type > $o ).

tff(pred_def_86780,type,
    v144221: state_type > $o ).

tff(pred_def_86781,type,
    v144220: state_type > $o ).

tff(pred_def_86782,type,
    v144226: state_type > $o ).

tff(pred_def_86783,type,
    v144225: state_type > $o ).

tff(pred_def_86784,type,
    v144224: state_type > $o ).

tff(pred_def_86785,type,
    v144232: state_type > $o ).

tff(pred_def_86786,type,
    v144231: state_type > $o ).

tff(pred_def_86787,type,
    v144230: state_type > $o ).

tff(pred_def_86788,type,
    v144229: state_type > $o ).

tff(pred_def_86789,type,
    v144228: state_type > $o ).

tff(pred_def_86790,type,
    v144235: state_type > $o ).

tff(pred_def_86791,type,
    v144237: state_type > $o ).

tff(pred_def_86792,type,
    v144236: state_type > $o ).

tff(pred_def_86793,type,
    v144234: state_type > $o ).

tff(pred_def_86794,type,
    v144241: state_type > $o ).

tff(pred_def_86795,type,
    v144240: state_type > $o ).

tff(pred_def_86796,type,
    v144242: state_type > $o ).

tff(pred_def_86797,type,
    v144239: state_type > $o ).

tff(pred_def_86798,type,
    v144238: ( state_type * $int ) > $o ).

tff(pred_def_86799,type,
    v144233: ( state_type * $int ) > $o ).

tff(pred_def_86800,type,
    v144227: ( state_type * $int ) > $o ).

tff(pred_def_86801,type,
    v144223: ( state_type * $int ) > $o ).

tff(pred_def_86802,type,
    v144219: ( state_type * $int ) > $o ).

tff(pred_def_86803,type,
    v144215: ( state_type * $int ) > $o ).

tff(pred_def_86804,type,
    v144198: ( state_type * $int ) > $o ).

tff(pred_def_86805,type,
    v144190: ( state_type * $int ) > $o ).

tff(pred_def_86806,type,
    v144174: ( state_type * $int ) > $o ).

tff(pred_def_86807,type,
    v144243: ( state_type * $int ) > $o ).

tff(pred_def_86808,type,
    v4219: ( state_type * $int ) > $o ).

tff(pred_def_86809,type,
    v144245: state_type > $o ).

tff(pred_def_86810,type,
    v144249: state_type > $o ).

tff(pred_def_86811,type,
    v144248: ( state_type * $int ) > $o ).

tff(pred_def_86812,type,
    v144247: ( state_type * $int ) > $o ).

tff(pred_def_86813,type,
    v144253: state_type > $o ).

tff(pred_def_86814,type,
    v144252: ( state_type * $int ) > $o ).

tff(pred_def_86815,type,
    v144251: ( state_type * $int ) > $o ).

tff(pred_def_86816,type,
    v4203: ( state_type * $int ) > $o ).

tff(pred_def_86817,type,
    v144250: ( state_type * $int ) > $o ).

tff(pred_def_86818,type,
    v144246: ( state_type * $int ) > $o ).

tff(pred_def_86819,type,
    v4217: ( state_type * $int ) > $o ).

tff(pred_def_86820,type,
    v4215: ( state_type * $int ) > $o ).

tff(pred_def_86821,type,
    v144257: state_type > $o ).

tff(pred_def_86822,type,
    v144255: state_type > $o ).

tff(pred_def_86823,type,
    v144264: state_type > $o ).

tff(pred_def_86824,type,
    v144262: state_type > $o ).

tff(pred_def_86825,type,
    v144261: state_type > $o ).

tff(pred_def_86826,type,
    v144260: state_type > $o ).

tff(pred_def_86827,type,
    v144272: state_type > $o ).

tff(pred_def_86828,type,
    v144273: state_type > $o ).

tff(pred_def_86829,type,
    v144271: state_type > $o ).

tff(pred_def_86830,type,
    v144268: ( state_type * $int ) > $o ).

tff(pred_def_86831,type,
    v144270: ( state_type * $int ) > $o ).

tff(pred_def_86832,type,
    v144259: ( state_type * $int ) > $o ).

tff(pred_def_86833,type,
    v4205: ( state_type * $int ) > $o ).

tff(pred_def_86834,type,
    v144279: state_type > $o ).

tff(pred_def_86835,type,
    v144280: state_type > $o ).

tff(pred_def_86836,type,
    v144278: state_type > $o ).

tff(pred_def_86837,type,
    v144281: state_type > $o ).

tff(pred_def_86838,type,
    v144277: state_type > $o ).

tff(pred_def_86839,type,
    v144282: state_type > $o ).

tff(pred_def_86840,type,
    v4199: state_type > $o ).

tff(pred_def_86841,type,
    v4197: state_type > $o ).

tff(pred_def_86842,type,
    v4193: state_type > $o ).

tff(pred_def_86843,type,
    v144284: state_type > $o ).

tff(pred_def_86844,type,
    v144283: ( state_type * $int ) > $o ).

tff(pred_def_86845,type,
    v144285: state_type > $o ).

tff(pred_def_86846,type,
    v4191: ( state_type * $int ) > $o ).

tff(pred_def_86847,type,
    v4189: ( state_type * $int ) > $o ).

tff(pred_def_86848,type,
    v144286: ( state_type * $int ) > $o ).

tff(pred_def_86849,type,
    v4187: ( state_type * $int ) > $o ).

tff(pred_def_86850,type,
    v4185: ( state_type * $int ) > $o ).

tff(pred_def_86851,type,
    v4183: state_type > $o ).

tff(pred_def_86852,type,
    v144288: state_type > $o ).

tff(pred_def_86853,type,
    v4181: ( state_type * $int ) > $o ).

tff(pred_def_86854,type,
    v4179: ( state_type * $int ) > $o ).

tff(pred_def_86855,type,
    v144322: state_type > $o ).

tff(pred_def_86856,type,
    v144320: state_type > $o ).

tff(pred_def_86857,type,
    v144318: state_type > $o ).

tff(pred_def_86858,type,
    v144316: state_type > $o ).

tff(pred_def_86859,type,
    v144314: state_type > $o ).

tff(pred_def_86860,type,
    v144312: state_type > $o ).

tff(pred_def_86861,type,
    v144310: state_type > $o ).

tff(pred_def_86862,type,
    v144336: state_type > $o ).

tff(pred_def_86863,type,
    v144334: state_type > $o ).

tff(pred_def_86864,type,
    v144332: state_type > $o ).

tff(pred_def_86865,type,
    v144330: state_type > $o ).

tff(pred_def_86866,type,
    v144328: state_type > $o ).

tff(pred_def_86867,type,
    v144326: state_type > $o ).

tff(pred_def_86868,type,
    v144324: state_type > $o ).

tff(pred_def_86869,type,
    v144352: ( state_type * $int ) > $o ).

tff(pred_def_86870,type,
    v144350: ( state_type * $int ) > $o ).

tff(pred_def_86871,type,
    v144348: ( state_type * $int ) > $o ).

tff(pred_def_86872,type,
    v144346: ( state_type * $int ) > $o ).

tff(pred_def_86873,type,
    v144344: ( state_type * $int ) > $o ).

tff(pred_def_86874,type,
    v144382: ( state_type * $int ) > $o ).

tff(pred_def_86875,type,
    v144384: ( state_type * $int ) > $o ).

tff(pred_def_86876,type,
    v144380: ( state_type * $int ) > $o ).

tff(pred_def_86877,type,
    v144378: ( state_type * $int ) > $o ).

tff(pred_def_86878,type,
    v144376: ( state_type * $int ) > $o ).

tff(pred_def_86879,type,
    v144374: ( state_type * $int ) > $o ).

tff(pred_def_86880,type,
    v144372: state_type > $o ).

tff(pred_def_86881,type,
    v144370: state_type > $o ).

tff(pred_def_86882,type,
    v144388: state_type > $o ).

tff(pred_def_86883,type,
    v144386: state_type > $o ).

tff(pred_def_86884,type,
    v144390: state_type > $o ).

tff(pred_def_86885,type,
    v144368: state_type > $o ).

tff(pred_def_86886,type,
    v144366: state_type > $o ).

tff(pred_def_86887,type,
    v144364: state_type > $o ).

tff(pred_def_86888,type,
    v144362: state_type > $o ).

tff(pred_def_86889,type,
    v144360: state_type > $o ).

tff(pred_def_86890,type,
    v144358: state_type > $o ).

tff(pred_def_86891,type,
    v144356: state_type > $o ).

tff(pred_def_86892,type,
    v144354: state_type > $o ).

tff(pred_def_86893,type,
    v144400: ( state_type * $int ) > $o ).

tff(pred_def_86894,type,
    v144398: ( state_type * $int ) > $o ).

tff(pred_def_86895,type,
    v144396: ( state_type * $int ) > $o ).

tff(pred_def_86896,type,
    v144394: ( state_type * $int ) > $o ).

tff(pred_def_86897,type,
    v144392: ( state_type * $int ) > $o ).

tff(pred_def_86898,type,
    v144430: ( state_type * $int ) > $o ).

tff(pred_def_86899,type,
    v144428: ( state_type * $int ) > $o ).

tff(pred_def_86900,type,
    v144431: ( state_type * $int ) > $o ).

tff(pred_def_86901,type,
    v144426: ( state_type * $int ) > $o ).

tff(pred_def_86902,type,
    v144424: ( state_type * $int ) > $o ).

tff(pred_def_86903,type,
    v144422: ( state_type * $int ) > $o ).

tff(pred_def_86904,type,
    v144420: state_type > $o ).

tff(pred_def_86905,type,
    v144418: state_type > $o ).

tff(pred_def_86906,type,
    v144435: state_type > $o ).

tff(pred_def_86907,type,
    v144433: state_type > $o ).

tff(pred_def_86908,type,
    v144437: state_type > $o ).

tff(pred_def_86909,type,
    v144416: state_type > $o ).

tff(pred_def_86910,type,
    v144414: state_type > $o ).

tff(pred_def_86911,type,
    v144412: state_type > $o ).

tff(pred_def_86912,type,
    v144410: state_type > $o ).

tff(pred_def_86913,type,
    v144408: state_type > $o ).

tff(pred_def_86914,type,
    v144406: state_type > $o ).

tff(pred_def_86915,type,
    v144404: state_type > $o ).

tff(pred_def_86916,type,
    v144402: state_type > $o ).

tff(pred_def_86917,type,
    v144447: ( state_type * $int ) > $o ).

tff(pred_def_86918,type,
    v144445: ( state_type * $int ) > $o ).

tff(pred_def_86919,type,
    v144443: ( state_type * $int ) > $o ).

tff(pred_def_86920,type,
    v144441: ( state_type * $int ) > $o ).

tff(pred_def_86921,type,
    v144439: ( state_type * $int ) > $o ).

tff(pred_def_86922,type,
    v144467: state_type > $o ).

tff(pred_def_86923,type,
    v144465: state_type > $o ).

tff(pred_def_86924,type,
    v144471: state_type > $o ).

tff(pred_def_86925,type,
    v144469: state_type > $o ).

tff(pred_def_86926,type,
    v144473: state_type > $o ).

tff(pred_def_86927,type,
    v144463: state_type > $o ).

tff(pred_def_86928,type,
    v144461: state_type > $o ).

tff(pred_def_86929,type,
    v144459: state_type > $o ).

tff(pred_def_86930,type,
    v144457: state_type > $o ).

tff(pred_def_86931,type,
    v144455: state_type > $o ).

tff(pred_def_86932,type,
    v144453: state_type > $o ).

tff(pred_def_86933,type,
    v144451: state_type > $o ).

tff(pred_def_86934,type,
    v144449: state_type > $o ).

tff(pred_def_86935,type,
    v144483: ( state_type * $int ) > $o ).

tff(pred_def_86936,type,
    v144481: ( state_type * $int ) > $o ).

tff(pred_def_86937,type,
    v144479: ( state_type * $int ) > $o ).

tff(pred_def_86938,type,
    v144477: ( state_type * $int ) > $o ).

tff(pred_def_86939,type,
    v144475: ( state_type * $int ) > $o ).

tff(pred_def_86940,type,
    v144503: state_type > $o ).

tff(pred_def_86941,type,
    v144501: state_type > $o ).

tff(pred_def_86942,type,
    v144507: state_type > $o ).

tff(pred_def_86943,type,
    v144505: state_type > $o ).

tff(pred_def_86944,type,
    v144509: state_type > $o ).

tff(pred_def_86945,type,
    v144499: state_type > $o ).

tff(pred_def_86946,type,
    v144497: state_type > $o ).

tff(pred_def_86947,type,
    v144495: state_type > $o ).

tff(pred_def_86948,type,
    v144493: state_type > $o ).

tff(pred_def_86949,type,
    v144491: state_type > $o ).

tff(pred_def_86950,type,
    v144489: state_type > $o ).

tff(pred_def_86951,type,
    v144487: state_type > $o ).

tff(pred_def_86952,type,
    v144485: state_type > $o ).

tff(pred_def_86953,type,
    v144515: state_type > $o ).

tff(pred_def_86954,type,
    v144514: ( state_type * $int ) > $o ).

tff(pred_def_86955,type,
    v144513: ( state_type * $int ) > $o ).

tff(pred_def_86956,type,
    v144518: state_type > $o ).

tff(pred_def_86957,type,
    v144517: ( state_type * $int ) > $o ).

tff(pred_def_86958,type,
    v144516: ( state_type * $int ) > $o ).

tff(pred_def_86959,type,
    v144512: ( state_type * $int ) > $o ).

tff(pred_def_86960,type,
    v144521: state_type > $o ).

tff(pred_def_86961,type,
    v144520: ( state_type * $int ) > $o ).

tff(pred_def_86962,type,
    v144519: ( state_type * $int ) > $o ).

tff(pred_def_86963,type,
    v144511: ( state_type * $int ) > $o ).

tff(pred_def_86964,type,
    v144524: state_type > $o ).

tff(pred_def_86965,type,
    v144523: ( state_type * $int ) > $o ).

tff(pred_def_86966,type,
    v144522: ( state_type * $int ) > $o ).

tff(pred_def_86967,type,
    v144342: ( state_type * $int ) > $o ).

tff(pred_def_86968,type,
    v144340: ( state_type * $int ) > $o ).

tff(pred_def_86969,type,
    v144338: ( state_type * $int ) > $o ).

tff(pred_def_86970,type,
    v144536: state_type > $o ).

tff(pred_def_86971,type,
    v144534: state_type > $o ).

tff(pred_def_86972,type,
    v144532: state_type > $o ).

tff(pred_def_86973,type,
    v144546: state_type > $o ).

tff(pred_def_86974,type,
    v144544: state_type > $o ).

tff(pred_def_86975,type,
    v144542: state_type > $o ).

tff(pred_def_86976,type,
    v144540: state_type > $o ).

tff(pred_def_86977,type,
    v144538: state_type > $o ).

tff(pred_def_86978,type,
    v144548: state_type > $o ).

tff(pred_def_86979,type,
    v144530: state_type > $o ).

tff(pred_def_86980,type,
    v144528: state_type > $o ).

tff(pred_def_86981,type,
    v144526: state_type > $o ).

tff(pred_def_86982,type,
    v144555: state_type > $o ).

tff(pred_def_86983,type,
    v144553: state_type > $o ).

tff(pred_def_86984,type,
    v144552: state_type > $o ).

tff(pred_def_86985,type,
    v144551: state_type > $o ).

tff(pred_def_86986,type,
    v144563: state_type > $o ).

tff(pred_def_86987,type,
    v144564: state_type > $o ).

tff(pred_def_86988,type,
    v144562: state_type > $o ).

tff(pred_def_86989,type,
    v144559: ( state_type * $int ) > $o ).

tff(pred_def_86990,type,
    v144561: ( state_type * $int ) > $o ).

tff(pred_def_86991,type,
    v144308: ( state_type * $int ) > $o ).

tff(pred_def_86992,type,
    v144306: ( state_type * $int ) > $o ).

tff(pred_def_86993,type,
    v144304: ( state_type * $int ) > $o ).

tff(pred_def_86994,type,
    v144302: ( state_type * $int ) > $o ).

tff(pred_def_86995,type,
    v144300: ( state_type * $int ) > $o ).

tff(pred_def_86996,type,
    v144570: state_type > $o ).

tff(pred_def_86997,type,
    v144568: state_type > $o ).

tff(pred_def_86998,type,
    v144574: ( state_type * $int ) > $o ).

tff(pred_def_86999,type,
    v144572: ( state_type * $int ) > $o ).

tff(pred_def_87000,type,
    v144578: state_type > $o ).

tff(pred_def_87001,type,
    v144576: state_type > $o ).

tff(pred_def_87002,type,
    v144582: state_type > $o ).

tff(pred_def_87003,type,
    v144581: ( state_type * $int ) > $o ).

tff(pred_def_87004,type,
    v144580: ( state_type * $int ) > $o ).

tff(pred_def_87005,type,
    v144585: state_type > $o ).

tff(pred_def_87006,type,
    v144584: ( state_type * $int ) > $o ).

tff(pred_def_87007,type,
    v144583: ( state_type * $int ) > $o ).

tff(pred_def_87008,type,
    v144298: ( state_type * $int ) > $o ).

tff(pred_def_87009,type,
    v144296: ( state_type * $int ) > $o ).

tff(pred_def_87010,type,
    v144294: ( state_type * $int ) > $o ).

tff(pred_def_87011,type,
    v144292: ( state_type * $int ) > $o ).

tff(pred_def_87012,type,
    v144290: ( state_type * $int ) > $o ).

tff(pred_def_87013,type,
    v4177: ( state_type * $int ) > $o ).

tff(pred_def_87014,type,
    v4175: ( state_type * $int ) > $o ).

tff(pred_def_87015,type,
    v4173: ( state_type * $int ) > $o ).

tff(pred_def_87016,type,
    v4171: ( state_type * $int ) > $o ).

tff(pred_def_87017,type,
    v4169: ( state_type * $int ) > $o ).

tff(pred_def_87018,type,
    v144598: state_type > $o ).

tff(pred_def_87019,type,
    v144596: state_type > $o ).

tff(pred_def_87020,type,
    v144594: state_type > $o ).

tff(pred_def_87021,type,
    v144604: state_type > $o ).

tff(pred_def_87022,type,
    v144602: state_type > $o ).

tff(pred_def_87023,type,
    v144622: ( state_type * $int ) > $o ).

tff(pred_def_87024,type,
    v144624: ( state_type * $int ) > $o ).

tff(pred_def_87025,type,
    v144620: ( state_type * $int ) > $o ).

tff(pred_def_87026,type,
    v144618: state_type > $o ).

tff(pred_def_87027,type,
    v144616: state_type > $o ).

tff(pred_def_87028,type,
    v144628: state_type > $o ).

tff(pred_def_87029,type,
    v144626: state_type > $o ).

tff(pred_def_87030,type,
    v144632: state_type > $o ).

tff(pred_def_87031,type,
    v144630: state_type > $o ).

tff(pred_def_87032,type,
    v144635: state_type > $o ).

tff(pred_def_87033,type,
    v144634: state_type > $o ).

tff(pred_def_87034,type,
    v144614: state_type > $o ).

tff(pred_def_87035,type,
    v144612: state_type > $o ).

tff(pred_def_87036,type,
    v144610: state_type > $o ).

tff(pred_def_87037,type,
    v144608: state_type > $o ).

tff(pred_def_87038,type,
    v144606: state_type > $o ).

tff(pred_def_87039,type,
    v144643: state_type > $o ).

tff(pred_def_87040,type,
    v144641: state_type > $o ).

tff(pred_def_87041,type,
    v144639: state_type > $o ).

tff(pred_def_87042,type,
    v144637: state_type > $o ).

tff(pred_def_87043,type,
    v144600: state_type > $o ).

tff(pred_def_87044,type,
    v144649: state_type > $o ).

tff(pred_def_87045,type,
    v144651: state_type > $o ).

tff(pred_def_87046,type,
    v144647: state_type > $o ).

tff(pred_def_87047,type,
    v144646: state_type > $o ).

tff(pred_def_87048,type,
    v144657: state_type > $o ).

tff(pred_def_87049,type,
    v144658: state_type > $o ).

tff(pred_def_87050,type,
    v144654: state_type > $o ).

tff(pred_def_87051,type,
    v144656: state_type > $o ).

tff(pred_def_87052,type,
    v144668: state_type > $o ).

tff(pred_def_87053,type,
    v144666: state_type > $o ).

tff(pred_def_87054,type,
    v144664: state_type > $o ).

tff(pred_def_87055,type,
    v144662: state_type > $o ).

tff(pred_def_87056,type,
    v144670: state_type > $o ).

tff(pred_def_87057,type,
    v144592: state_type > $o ).

tff(pred_def_87058,type,
    v144590: state_type > $o ).

tff(pred_def_87059,type,
    v144588: state_type > $o ).

tff(pred_def_87060,type,
    v144677: state_type > $o ).

tff(pred_def_87061,type,
    v144675: state_type > $o ).

tff(pred_def_87062,type,
    v144674: state_type > $o ).

tff(pred_def_87063,type,
    v144673: state_type > $o ).

tff(pred_def_87064,type,
    v144685: state_type > $o ).

tff(pred_def_87065,type,
    v144686: state_type > $o ).

tff(pred_def_87066,type,
    v144684: state_type > $o ).

tff(pred_def_87067,type,
    v144681: ( state_type * $int ) > $o ).

tff(pred_def_87068,type,
    v144683: ( state_type * $int ) > $o ).

tff(pred_def_87069,type,
    v4135: ( state_type * $int ) > $o ).

tff(pred_def_87070,type,
    v4133: ( state_type * $int ) > $o ).

tff(pred_def_87071,type,
    v4131: ( state_type * $int ) > $o ).

tff(pred_def_87072,type,
    v4129: ( state_type * $int ) > $o ).

tff(pred_def_87073,type,
    v4127: ( state_type * $int ) > $o ).

tff(pred_def_87074,type,
    v144722: state_type > $o ).

tff(pred_def_87075,type,
    v144720: state_type > $o ).

tff(pred_def_87076,type,
    v144718: state_type > $o ).

tff(pred_def_87077,type,
    v144716: state_type > $o ).

tff(pred_def_87078,type,
    v144714: state_type > $o ).

tff(pred_def_87079,type,
    v144712: state_type > $o ).

tff(pred_def_87080,type,
    v144732: state_type > $o ).

tff(pred_def_87081,type,
    v144730: state_type > $o ).

tff(pred_def_87082,type,
    v144728: state_type > $o ).

tff(pred_def_87083,type,
    v144726: state_type > $o ).

tff(pred_def_87084,type,
    v144724: state_type > $o ).

tff(pred_def_87085,type,
    v144759: state_type > $o ).

tff(pred_def_87086,type,
    v144758: ( state_type * $int ) > $o ).

tff(pred_def_87087,type,
    v144757: ( state_type * $int ) > $o ).

tff(pred_def_87088,type,
    v144755: ( state_type * $int ) > $o ).

tff(pred_def_87089,type,
    v144775: state_type > $o ).

tff(pred_def_87090,type,
    v144776: ( state_type * $int ) > $o ).

tff(pred_def_87091,type,
    v144777: state_type > $o ).

tff(pred_def_87092,type,
    v144773: ( state_type * $int ) > $o ).

tff(pred_def_87093,type,
    v144771: ( state_type * $int ) > $o ).

tff(pred_def_87094,type,
    v144801: ( state_type * $int ) > $o ).

tff(pred_def_87095,type,
    v144710: ( state_type * $int ) > $o ).

tff(pred_def_87096,type,
    v144799: ( state_type * $int ) > $o ).

tff(pred_def_87097,type,
    v144802: ( state_type * $int ) > $o ).

tff(pred_def_87098,type,
    v144797: ( state_type * $int ) > $o ).

tff(pred_def_87099,type,
    v144795: ( state_type * $int ) > $o ).

tff(pred_def_87100,type,
    v144793: ( state_type * $int ) > $o ).

tff(pred_def_87101,type,
    v144791: state_type > $o ).

tff(pred_def_87102,type,
    v144789: state_type > $o ).

tff(pred_def_87103,type,
    v144808: state_type > $o ).

tff(pred_def_87104,type,
    v144748: state_type > $o ).

tff(pred_def_87105,type,
    v144807: ( state_type * $int ) > $o ).

tff(pred_def_87106,type,
    v144746: ( state_type * $int ) > $o ).

tff(pred_def_87107,type,
    v144744: ( state_type * $int ) > $o ).

tff(pred_def_87108,type,
    v144823: ( state_type * $int ) > $o ).

tff(pred_def_87109,type,
    v144822: ( state_type * $int ) > $o ).

tff(pred_def_87110,type,
    v144820: ( state_type * $int ) > $o ).

tff(pred_def_87111,type,
    v144827: state_type > $o ).

tff(pred_def_87112,type,
    v144825: state_type > $o ).

tff(pred_def_87113,type,
    v144838: ( state_type * $int ) > $o ).

tff(pred_def_87114,type,
    v144837: state_type > $o ).

tff(pred_def_87115,type,
    v144841: state_type > $o ).

tff(pred_def_87116,type,
    v144842: state_type > $o ).

tff(pred_def_87117,type,
    v144840: state_type > $o ).

tff(pred_def_87118,type,
    v144843: state_type > $o ).

tff(pred_def_87119,type,
    v144839: state_type > $o ).

tff(pred_def_87120,type,
    v144836: state_type > $o ).

tff(pred_def_87121,type,
    v144844: state_type > $o ).

tff(pred_def_87122,type,
    v144835: state_type > $o ).

tff(pred_def_87123,type,
    v144847: state_type > $o ).

tff(pred_def_87124,type,
    v144848: state_type > $o ).

tff(pred_def_87125,type,
    v144846: state_type > $o ).

tff(pred_def_87126,type,
    v144849: state_type > $o ).

tff(pred_def_87127,type,
    v144845: state_type > $o ).

tff(pred_def_87128,type,
    v144834: state_type > $o ).

tff(pred_def_87129,type,
    v144850: state_type > $o ).

tff(pred_def_87130,type,
    v144833: state_type > $o ).

tff(pred_def_87131,type,
    v144832: state_type > $o ).

tff(pred_def_87132,type,
    v144854: state_type > $o ).

tff(pred_def_87133,type,
    v144855: state_type > $o ).

tff(pred_def_87134,type,
    v144853: state_type > $o ).

tff(pred_def_87135,type,
    v144856: state_type > $o ).

tff(pred_def_87136,type,
    v144852: state_type > $o ).

tff(pred_def_87137,type,
    v144851: state_type > $o ).

tff(pred_def_87138,type,
    v144831: state_type > $o ).

tff(pred_def_87139,type,
    v144857: state_type > $o ).

tff(pred_def_87140,type,
    v144830: state_type > $o ).

tff(pred_def_87141,type,
    v144860: state_type > $o ).

tff(pred_def_87142,type,
    v144861: state_type > $o ).

tff(pred_def_87143,type,
    v144859: state_type > $o ).

tff(pred_def_87144,type,
    v144862: state_type > $o ).

tff(pred_def_87145,type,
    v144858: state_type > $o ).

tff(pred_def_87146,type,
    v144865: state_type > $o ).

tff(pred_def_87147,type,
    v144866: state_type > $o ).

tff(pred_def_87148,type,
    v144864: state_type > $o ).

tff(pred_def_87149,type,
    v144867: state_type > $o ).

tff(pred_def_87150,type,
    v144863: state_type > $o ).

tff(pred_def_87151,type,
    v144870: state_type > $o ).

tff(pred_def_87152,type,
    v144871: state_type > $o ).

tff(pred_def_87153,type,
    v144869: state_type > $o ).

tff(pred_def_87154,type,
    v144872: state_type > $o ).

tff(pred_def_87155,type,
    v144868: state_type > $o ).

tff(pred_def_87156,type,
    v144828: ( state_type * $int ) > $o ).

tff(pred_def_87157,type,
    v144818: ( state_type * $int ) > $o ).

tff(pred_def_87158,type,
    v144816: ( state_type * $int ) > $o ).

tff(pred_def_87159,type,
    v144814: ( state_type * $int ) > $o ).

tff(pred_def_87160,type,
    v144812: ( state_type * $int ) > $o ).

tff(pred_def_87161,type,
    v144810: ( state_type * $int ) > $o ).

tff(pred_def_87162,type,
    v144873: ( state_type * $int ) > $o ).

tff(pred_def_87163,type,
    v144742: ( state_type * $int ) > $o ).

tff(pred_def_87164,type,
    v144740: ( state_type * $int ) > $o ).

tff(pred_def_87165,type,
    v144738: ( state_type * $int ) > $o ).

tff(pred_def_87166,type,
    v144874: ( state_type * $int ) > $o ).

tff(pred_def_87167,type,
    v144875: ( state_type * $int ) > $o ).

tff(pred_def_87168,type,
    v144736: ( state_type * $int ) > $o ).

tff(pred_def_87169,type,
    v144734: ( state_type * $int ) > $o ).

tff(pred_def_87170,type,
    v144885: state_type > $o ).

tff(pred_def_87171,type,
    v144883: state_type > $o ).

tff(pred_def_87172,type,
    v144891: state_type > $o ).

tff(pred_def_87173,type,
    v144889: state_type > $o ).

tff(pred_def_87174,type,
    v144895: state_type > $o ).

tff(pred_def_87175,type,
    v144893: state_type > $o ).

tff(pred_def_87176,type,
    v144899: state_type > $o ).

tff(pred_def_87177,type,
    v144897: state_type > $o ).

tff(pred_def_87178,type,
    v144887: state_type > $o ).

tff(pred_def_87179,type,
    v144905: state_type > $o ).

tff(pred_def_87180,type,
    v144907: state_type > $o ).

tff(pred_def_87181,type,
    v144903: state_type > $o ).

tff(pred_def_87182,type,
    v144902: state_type > $o ).

tff(pred_def_87183,type,
    v144913: state_type > $o ).

tff(pred_def_87184,type,
    v144914: state_type > $o ).

tff(pred_def_87185,type,
    v144910: state_type > $o ).

tff(pred_def_87186,type,
    v144912: state_type > $o ).

tff(pred_def_87187,type,
    v144920: state_type > $o ).

tff(pred_def_87188,type,
    v144918: state_type > $o ).

tff(pred_def_87189,type,
    v144922: state_type > $o ).

tff(pred_def_87190,type,
    v144881: state_type > $o ).

tff(pred_def_87191,type,
    v144879: state_type > $o ).

tff(pred_def_87192,type,
    v144877: state_type > $o ).

tff(pred_def_87193,type,
    v144929: state_type > $o ).

tff(pred_def_87194,type,
    v144927: state_type > $o ).

tff(pred_def_87195,type,
    v144926: state_type > $o ).

tff(pred_def_87196,type,
    v144925: state_type > $o ).

tff(pred_def_87197,type,
    v144937: state_type > $o ).

tff(pred_def_87198,type,
    v144938: state_type > $o ).

tff(pred_def_87199,type,
    v144936: state_type > $o ).

tff(pred_def_87200,type,
    v144933: ( state_type * $int ) > $o ).

tff(pred_def_87201,type,
    v144935: ( state_type * $int ) > $o ).

tff(pred_def_87202,type,
    v144924: ( state_type * $int ) > $o ).

tff(pred_def_87203,type,
    v144806: state_type > $o ).

tff(pred_def_87204,type,
    v144804: state_type > $o ).

tff(pred_def_87205,type,
    v144950: state_type > $o ).

tff(pred_def_87206,type,
    v144948: state_type > $o ).

tff(pred_def_87207,type,
    v144947: state_type > $o ).

tff(pred_def_87208,type,
    v144946: ( state_type * $int ) > $o ).

tff(pred_def_87209,type,
    v144944: state_type > $o ).

tff(pred_def_87210,type,
    v144942: state_type > $o ).

tff(pred_def_87211,type,
    v144955: state_type > $o ).

tff(pred_def_87212,type,
    v144954: state_type > $o ).

tff(pred_def_87213,type,
    v144787: state_type > $o ).

tff(pred_def_87214,type,
    v144785: state_type > $o ).

tff(pred_def_87215,type,
    v144783: state_type > $o ).

tff(pred_def_87216,type,
    v144956: ( state_type * $int ) > $o ).

tff(pred_def_87217,type,
    v144957: state_type > $o ).

tff(pred_def_87218,type,
    v144781: ( state_type * $int ) > $o ).

tff(pred_def_87219,type,
    v144779: ( state_type * $int ) > $o ).

tff(pred_def_87220,type,
    v144958: ( state_type * $int ) > $o ).

tff(pred_def_87221,type,
    v144769: ( state_type * $int ) > $o ).

tff(pred_def_87222,type,
    v144767: ( state_type * $int ) > $o ).

tff(pred_def_87223,type,
    v144765: state_type > $o ).

tff(pred_def_87224,type,
    v144959: ( state_type * $int ) > $o ).

tff(pred_def_87225,type,
    v144960: state_type > $o ).

tff(pred_def_87226,type,
    v144763: ( state_type * $int ) > $o ).

tff(pred_def_87227,type,
    v144761: ( state_type * $int ) > $o ).

tff(pred_def_87228,type,
    v144961: ( state_type * $int ) > $o ).

tff(pred_def_87229,type,
    v144753: ( state_type * $int ) > $o ).

tff(pred_def_87230,type,
    v144751: ( state_type * $int ) > $o ).

tff(pred_def_87231,type,
    v144967: state_type > $o ).

tff(pred_def_87232,type,
    v144965: state_type > $o ).

tff(pred_def_87233,type,
    v144964: state_type > $o ).

tff(pred_def_87234,type,
    v144963: ( state_type * $int ) > $o ).

tff(pred_def_87235,type,
    v144708: state_type > $o ).

tff(pred_def_87236,type,
    v144706: state_type > $o ).

tff(pred_def_87237,type,
    v144973: state_type > $o ).

tff(pred_def_87238,type,
    v144971: state_type > $o ).

tff(pred_def_87239,type,
    v144977: state_type > $o ).

tff(pred_def_87240,type,
    v144975: state_type > $o ).

tff(pred_def_87241,type,
    v144980: state_type > $o ).

tff(pred_def_87242,type,
    v144979: state_type > $o ).

tff(pred_def_87243,type,
    v144704: state_type > $o ).

tff(pred_def_87244,type,
    v144702: state_type > $o ).

tff(pred_def_87245,type,
    v144700: state_type > $o ).

tff(pred_def_87246,type,
    v144698: state_type > $o ).

tff(pred_def_87247,type,
    v144696: state_type > $o ).

tff(pred_def_87248,type,
    v144694: state_type > $o ).

tff(pred_def_87249,type,
    v144692: state_type > $o ).

tff(pred_def_87250,type,
    v144690: state_type > $o ).

tff(pred_def_87251,type,
    v145000: state_type > $o ).

tff(pred_def_87252,type,
    v144998: state_type > $o ).

tff(pred_def_87253,type,
    v144996: state_type > $o ).

tff(pred_def_87254,type,
    v144994: state_type > $o ).

tff(pred_def_87255,type,
    v144992: state_type > $o ).

tff(pred_def_87256,type,
    v145010: state_type > $o ).

tff(pred_def_87257,type,
    v145008: state_type > $o ).

tff(pred_def_87258,type,
    v145006: state_type > $o ).

tff(pred_def_87259,type,
    v145004: state_type > $o ).

tff(pred_def_87260,type,
    v145002: state_type > $o ).

tff(pred_def_87261,type,
    v145014: ( state_type * $int ) > $o ).

tff(pred_def_87262,type,
    v145012: ( state_type * $int ) > $o ).

tff(pred_def_87263,type,
    v145024: state_type > $o ).

tff(pred_def_87264,type,
    v145022: state_type > $o ).

tff(pred_def_87265,type,
    v145030: state_type > $o ).

tff(pred_def_87266,type,
    v145028: state_type > $o ).

tff(pred_def_87267,type,
    v145054: ( state_type * $int ) > $o ).

tff(pred_def_87268,type,
    v145052: ( state_type * $int ) > $o ).

tff(pred_def_87269,type,
    v145055: ( state_type * $int ) > $o ).

tff(pred_def_87270,type,
    v145050: ( state_type * $int ) > $o ).

tff(pred_def_87271,type,
    v145048: ( state_type * $int ) > $o ).

tff(pred_def_87272,type,
    v145046: ( state_type * $int ) > $o ).

tff(pred_def_87273,type,
    v145044: state_type > $o ).

tff(pred_def_87274,type,
    v145042: state_type > $o ).

tff(pred_def_87275,type,
    v145059: state_type > $o ).

tff(pred_def_87276,type,
    v145057: state_type > $o ).

tff(pred_def_87277,type,
    v145063: state_type > $o ).

tff(pred_def_87278,type,
    v145061: state_type > $o ).

tff(pred_def_87279,type,
    v145066: state_type > $o ).

tff(pred_def_87280,type,
    v145065: state_type > $o ).

tff(pred_def_87281,type,
    v145040: state_type > $o ).

tff(pred_def_87282,type,
    v145038: state_type > $o ).

tff(pred_def_87283,type,
    v145036: state_type > $o ).

tff(pred_def_87284,type,
    v145034: state_type > $o ).

tff(pred_def_87285,type,
    v145032: state_type > $o ).

tff(pred_def_87286,type,
    v145070: state_type > $o ).

tff(pred_def_87287,type,
    v145068: state_type > $o ).

tff(pred_def_87288,type,
    v145026: state_type > $o ).

tff(pred_def_87289,type,
    v145076: state_type > $o ).

tff(pred_def_87290,type,
    v145078: state_type > $o ).

tff(pred_def_87291,type,
    v145074: state_type > $o ).

tff(pred_def_87292,type,
    v145073: state_type > $o ).

tff(pred_def_87293,type,
    v145084: state_type > $o ).

tff(pred_def_87294,type,
    v145085: state_type > $o ).

tff(pred_def_87295,type,
    v145081: state_type > $o ).

tff(pred_def_87296,type,
    v145083: state_type > $o ).

tff(pred_def_87297,type,
    v145091: state_type > $o ).

tff(pred_def_87298,type,
    v145089: state_type > $o ).

tff(pred_def_87299,type,
    v145093: state_type > $o ).

tff(pred_def_87300,type,
    v145020: state_type > $o ).

tff(pred_def_87301,type,
    v145018: state_type > $o ).

tff(pred_def_87302,type,
    v145016: state_type > $o ).

tff(pred_def_87303,type,
    v145100: state_type > $o ).

tff(pred_def_87304,type,
    v145098: state_type > $o ).

tff(pred_def_87305,type,
    v145097: state_type > $o ).

tff(pred_def_87306,type,
    v145096: state_type > $o ).

tff(pred_def_87307,type,
    v145108: state_type > $o ).

tff(pred_def_87308,type,
    v145109: state_type > $o ).

tff(pred_def_87309,type,
    v145107: state_type > $o ).

tff(pred_def_87310,type,
    v145104: ( state_type * $int ) > $o ).

tff(pred_def_87311,type,
    v145106: ( state_type * $int ) > $o ).

tff(pred_def_87312,type,
    v144990: ( state_type * $int ) > $o ).

tff(pred_def_87313,type,
    v144988: ( state_type * $int ) > $o ).

tff(pred_def_87314,type,
    v144986: ( state_type * $int ) > $o ).

tff(pred_def_87315,type,
    v144984: ( state_type * $int ) > $o ).

tff(pred_def_87316,type,
    v144982: ( state_type * $int ) > $o ).

tff(pred_def_87317,type,
    v145131: state_type > $o ).

tff(pred_def_87318,type,
    v145129: state_type > $o ).

tff(pred_def_87319,type,
    v145135: state_type > $o ).

tff(pred_def_87320,type,
    v145133: state_type > $o ).

tff(pred_def_87321,type,
    v145139: state_type > $o ).

tff(pred_def_87322,type,
    v145137: state_type > $o ).

tff(pred_def_87323,type,
    v145142: state_type > $o ).

tff(pred_def_87324,type,
    v145141: state_type > $o ).

tff(pred_def_87325,type,
    v145127: state_type > $o ).

tff(pred_def_87326,type,
    v145125: state_type > $o ).

tff(pred_def_87327,type,
    v145123: state_type > $o ).

tff(pred_def_87328,type,
    v145121: state_type > $o ).

tff(pred_def_87329,type,
    v145119: state_type > $o ).

tff(pred_def_87330,type,
    v145117: state_type > $o ).

tff(pred_def_87331,type,
    v145115: state_type > $o ).

tff(pred_def_87332,type,
    v145113: state_type > $o ).

tff(pred_def_87333,type,
    v145162: state_type > $o ).

tff(pred_def_87334,type,
    v145160: state_type > $o ).

tff(pred_def_87335,type,
    v145158: state_type > $o ).

tff(pred_def_87336,type,
    v145156: state_type > $o ).

tff(pred_def_87337,type,
    v145154: state_type > $o ).

tff(pred_def_87338,type,
    v145172: state_type > $o ).

tff(pred_def_87339,type,
    v145170: state_type > $o ).

tff(pred_def_87340,type,
    v145168: state_type > $o ).

tff(pred_def_87341,type,
    v145166: state_type > $o ).

tff(pred_def_87342,type,
    v145164: state_type > $o ).

tff(pred_def_87343,type,
    v145176: ( state_type * $int ) > $o ).

tff(pred_def_87344,type,
    v145174: ( state_type * $int ) > $o ).

tff(pred_def_87345,type,
    v145186: state_type > $o ).

tff(pred_def_87346,type,
    v145184: state_type > $o ).

tff(pred_def_87347,type,
    v145192: state_type > $o ).

tff(pred_def_87348,type,
    v145190: state_type > $o ).

tff(pred_def_87349,type,
    v145206: state_type > $o ).

tff(pred_def_87350,type,
    v145204: state_type > $o ).

tff(pred_def_87351,type,
    v145210: state_type > $o ).

tff(pred_def_87352,type,
    v145208: state_type > $o ).

tff(pred_def_87353,type,
    v145214: state_type > $o ).

tff(pred_def_87354,type,
    v145212: state_type > $o ).

tff(pred_def_87355,type,
    v145217: state_type > $o ).

tff(pred_def_87356,type,
    v145216: state_type > $o ).

tff(pred_def_87357,type,
    v145202: state_type > $o ).

tff(pred_def_87358,type,
    v145200: state_type > $o ).

tff(pred_def_87359,type,
    v145198: state_type > $o ).

tff(pred_def_87360,type,
    v145196: state_type > $o ).

tff(pred_def_87361,type,
    v145194: state_type > $o ).

tff(pred_def_87362,type,
    v145221: state_type > $o ).

tff(pred_def_87363,type,
    v145219: state_type > $o ).

tff(pred_def_87364,type,
    v145188: state_type > $o ).

tff(pred_def_87365,type,
    v145227: state_type > $o ).

tff(pred_def_87366,type,
    v145229: state_type > $o ).

tff(pred_def_87367,type,
    v145225: state_type > $o ).

tff(pred_def_87368,type,
    v145224: state_type > $o ).

tff(pred_def_87369,type,
    v145235: state_type > $o ).

tff(pred_def_87370,type,
    v145236: state_type > $o ).

tff(pred_def_87371,type,
    v145232: state_type > $o ).

tff(pred_def_87372,type,
    v145234: state_type > $o ).

tff(pred_def_87373,type,
    v145242: state_type > $o ).

tff(pred_def_87374,type,
    v145240: state_type > $o ).

tff(pred_def_87375,type,
    v145244: state_type > $o ).

tff(pred_def_87376,type,
    v145182: state_type > $o ).

tff(pred_def_87377,type,
    v145180: state_type > $o ).

tff(pred_def_87378,type,
    v145178: state_type > $o ).

tff(pred_def_87379,type,
    v145251: state_type > $o ).

tff(pred_def_87380,type,
    v145249: state_type > $o ).

tff(pred_def_87381,type,
    v145248: state_type > $o ).

tff(pred_def_87382,type,
    v145247: state_type > $o ).

tff(pred_def_87383,type,
    v145259: state_type > $o ).

tff(pred_def_87384,type,
    v145260: state_type > $o ).

tff(pred_def_87385,type,
    v145258: state_type > $o ).

tff(pred_def_87386,type,
    v145255: ( state_type * $int ) > $o ).

tff(pred_def_87387,type,
    v145257: ( state_type * $int ) > $o ).

tff(pred_def_87388,type,
    v145152: ( state_type * $int ) > $o ).

tff(pred_def_87389,type,
    v145150: ( state_type * $int ) > $o ).

tff(pred_def_87390,type,
    v145148: ( state_type * $int ) > $o ).

tff(pred_def_87391,type,
    v145146: ( state_type * $int ) > $o ).

tff(pred_def_87392,type,
    v145144: ( state_type * $int ) > $o ).

tff(pred_def_87393,type,
    v145282: state_type > $o ).

tff(pred_def_87394,type,
    v145280: state_type > $o ).

tff(pred_def_87395,type,
    v145286: state_type > $o ).

tff(pred_def_87396,type,
    v145284: state_type > $o ).

tff(pred_def_87397,type,
    v145290: state_type > $o ).

tff(pred_def_87398,type,
    v145288: state_type > $o ).

tff(pred_def_87399,type,
    v145293: state_type > $o ).

tff(pred_def_87400,type,
    v145292: state_type > $o ).

tff(pred_def_87401,type,
    v145278: state_type > $o ).

tff(pred_def_87402,type,
    v145276: state_type > $o ).

tff(pred_def_87403,type,
    v145274: state_type > $o ).

tff(pred_def_87404,type,
    v145272: state_type > $o ).

tff(pred_def_87405,type,
    v145270: state_type > $o ).

tff(pred_def_87406,type,
    v145268: state_type > $o ).

tff(pred_def_87407,type,
    v145266: state_type > $o ).

tff(pred_def_87408,type,
    v145264: state_type > $o ).

tff(pred_def_87409,type,
    v145313: state_type > $o ).

tff(pred_def_87410,type,
    v145311: state_type > $o ).

tff(pred_def_87411,type,
    v145309: state_type > $o ).

tff(pred_def_87412,type,
    v145307: state_type > $o ).

tff(pred_def_87413,type,
    v145305: state_type > $o ).

tff(pred_def_87414,type,
    v145323: state_type > $o ).

tff(pred_def_87415,type,
    v145321: state_type > $o ).

tff(pred_def_87416,type,
    v145319: state_type > $o ).

tff(pred_def_87417,type,
    v145317: state_type > $o ).

tff(pred_def_87418,type,
    v145315: state_type > $o ).

tff(pred_def_87419,type,
    v145327: ( state_type * $int ) > $o ).

tff(pred_def_87420,type,
    v145325: ( state_type * $int ) > $o ).

tff(pred_def_87421,type,
    v145337: state_type > $o ).

tff(pred_def_87422,type,
    v145335: state_type > $o ).

tff(pred_def_87423,type,
    v145343: state_type > $o ).

tff(pred_def_87424,type,
    v145341: state_type > $o ).

tff(pred_def_87425,type,
    v145357: state_type > $o ).

tff(pred_def_87426,type,
    v145355: state_type > $o ).

tff(pred_def_87427,type,
    v145361: state_type > $o ).

tff(pred_def_87428,type,
    v145359: state_type > $o ).

tff(pred_def_87429,type,
    v145365: state_type > $o ).

tff(pred_def_87430,type,
    v145363: state_type > $o ).

tff(pred_def_87431,type,
    v145368: state_type > $o ).

tff(pred_def_87432,type,
    v145367: state_type > $o ).

tff(pred_def_87433,type,
    v145353: state_type > $o ).

tff(pred_def_87434,type,
    v145351: state_type > $o ).

tff(pred_def_87435,type,
    v145349: state_type > $o ).

tff(pred_def_87436,type,
    v145347: state_type > $o ).

tff(pred_def_87437,type,
    v145345: state_type > $o ).

tff(pred_def_87438,type,
    v145372: state_type > $o ).

tff(pred_def_87439,type,
    v145370: state_type > $o ).

tff(pred_def_87440,type,
    v145339: state_type > $o ).

tff(pred_def_87441,type,
    v145378: state_type > $o ).

tff(pred_def_87442,type,
    v145380: state_type > $o ).

tff(pred_def_87443,type,
    v145376: state_type > $o ).

tff(pred_def_87444,type,
    v145375: state_type > $o ).

tff(pred_def_87445,type,
    v145386: state_type > $o ).

tff(pred_def_87446,type,
    v145387: state_type > $o ).

tff(pred_def_87447,type,
    v145383: state_type > $o ).

tff(pred_def_87448,type,
    v145385: state_type > $o ).

tff(pred_def_87449,type,
    v145393: state_type > $o ).

tff(pred_def_87450,type,
    v145391: state_type > $o ).

tff(pred_def_87451,type,
    v145395: state_type > $o ).

tff(pred_def_87452,type,
    v145333: state_type > $o ).

tff(pred_def_87453,type,
    v145331: state_type > $o ).

tff(pred_def_87454,type,
    v145329: state_type > $o ).

tff(pred_def_87455,type,
    v145402: state_type > $o ).

tff(pred_def_87456,type,
    v145400: state_type > $o ).

tff(pred_def_87457,type,
    v145399: state_type > $o ).

tff(pred_def_87458,type,
    v145398: state_type > $o ).

tff(pred_def_87459,type,
    v145410: state_type > $o ).

tff(pred_def_87460,type,
    v145411: state_type > $o ).

tff(pred_def_87461,type,
    v145409: state_type > $o ).

tff(pred_def_87462,type,
    v145406: ( state_type * $int ) > $o ).

tff(pred_def_87463,type,
    v145408: ( state_type * $int ) > $o ).

tff(pred_def_87464,type,
    v145303: ( state_type * $int ) > $o ).

tff(pred_def_87465,type,
    v145301: ( state_type * $int ) > $o ).

tff(pred_def_87466,type,
    v145299: ( state_type * $int ) > $o ).

tff(pred_def_87467,type,
    v145297: ( state_type * $int ) > $o ).

tff(pred_def_87468,type,
    v145295: ( state_type * $int ) > $o ).

tff(pred_def_87469,type,
    v145433: state_type > $o ).

tff(pred_def_87470,type,
    v145431: state_type > $o ).

tff(pred_def_87471,type,
    v145437: state_type > $o ).

tff(pred_def_87472,type,
    v145435: state_type > $o ).

tff(pred_def_87473,type,
    v145441: state_type > $o ).

tff(pred_def_87474,type,
    v145439: state_type > $o ).

tff(pred_def_87475,type,
    v145444: state_type > $o ).

tff(pred_def_87476,type,
    v145443: state_type > $o ).

tff(pred_def_87477,type,
    v145429: state_type > $o ).

tff(pred_def_87478,type,
    v145427: state_type > $o ).

tff(pred_def_87479,type,
    v145425: state_type > $o ).

tff(pred_def_87480,type,
    v145423: state_type > $o ).

tff(pred_def_87481,type,
    v145421: state_type > $o ).

tff(pred_def_87482,type,
    v145419: state_type > $o ).

tff(pred_def_87483,type,
    v145417: state_type > $o ).

tff(pred_def_87484,type,
    v145415: state_type > $o ).

tff(pred_def_87485,type,
    v145464: state_type > $o ).

tff(pred_def_87486,type,
    v145462: state_type > $o ).

tff(pred_def_87487,type,
    v145460: state_type > $o ).

tff(pred_def_87488,type,
    v145458: state_type > $o ).

tff(pred_def_87489,type,
    v145456: state_type > $o ).

tff(pred_def_87490,type,
    v145474: state_type > $o ).

tff(pred_def_87491,type,
    v145472: state_type > $o ).

tff(pred_def_87492,type,
    v145470: state_type > $o ).

tff(pred_def_87493,type,
    v145468: state_type > $o ).

tff(pred_def_87494,type,
    v145466: state_type > $o ).

tff(pred_def_87495,type,
    v145478: ( state_type * $int ) > $o ).

tff(pred_def_87496,type,
    v145476: ( state_type * $int ) > $o ).

tff(pred_def_87497,type,
    v145488: state_type > $o ).

tff(pred_def_87498,type,
    v145486: state_type > $o ).

tff(pred_def_87499,type,
    v145494: state_type > $o ).

tff(pred_def_87500,type,
    v145492: state_type > $o ).

tff(pred_def_87501,type,
    v145508: state_type > $o ).

tff(pred_def_87502,type,
    v145506: state_type > $o ).

tff(pred_def_87503,type,
    v145512: state_type > $o ).

tff(pred_def_87504,type,
    v145510: state_type > $o ).

tff(pred_def_87505,type,
    v145516: state_type > $o ).

tff(pred_def_87506,type,
    v145514: state_type > $o ).

tff(pred_def_87507,type,
    v145519: state_type > $o ).

tff(pred_def_87508,type,
    v145518: state_type > $o ).

tff(pred_def_87509,type,
    v145504: state_type > $o ).

tff(pred_def_87510,type,
    v145502: state_type > $o ).

tff(pred_def_87511,type,
    v145500: state_type > $o ).

tff(pred_def_87512,type,
    v145498: state_type > $o ).

tff(pred_def_87513,type,
    v145496: state_type > $o ).

tff(pred_def_87514,type,
    v145523: state_type > $o ).

tff(pred_def_87515,type,
    v145521: state_type > $o ).

tff(pred_def_87516,type,
    v145490: state_type > $o ).

tff(pred_def_87517,type,
    v145529: state_type > $o ).

tff(pred_def_87518,type,
    v145531: state_type > $o ).

tff(pred_def_87519,type,
    v145527: state_type > $o ).

tff(pred_def_87520,type,
    v145526: state_type > $o ).

tff(pred_def_87521,type,
    v145537: state_type > $o ).

tff(pred_def_87522,type,
    v145538: state_type > $o ).

tff(pred_def_87523,type,
    v145534: state_type > $o ).

tff(pred_def_87524,type,
    v145536: state_type > $o ).

tff(pred_def_87525,type,
    v145544: state_type > $o ).

tff(pred_def_87526,type,
    v145542: state_type > $o ).

tff(pred_def_87527,type,
    v145546: state_type > $o ).

tff(pred_def_87528,type,
    v145484: state_type > $o ).

tff(pred_def_87529,type,
    v145482: state_type > $o ).

tff(pred_def_87530,type,
    v145480: state_type > $o ).

tff(pred_def_87531,type,
    v145553: state_type > $o ).

tff(pred_def_87532,type,
    v145551: state_type > $o ).

tff(pred_def_87533,type,
    v145550: state_type > $o ).

tff(pred_def_87534,type,
    v145549: state_type > $o ).

tff(pred_def_87535,type,
    v145561: state_type > $o ).

tff(pred_def_87536,type,
    v145562: state_type > $o ).

tff(pred_def_87537,type,
    v145560: state_type > $o ).

tff(pred_def_87538,type,
    v145557: ( state_type * $int ) > $o ).

tff(pred_def_87539,type,
    v145559: ( state_type * $int ) > $o ).

tff(pred_def_87540,type,
    v145454: ( state_type * $int ) > $o ).

tff(pred_def_87541,type,
    v145452: ( state_type * $int ) > $o ).

tff(pred_def_87542,type,
    v145450: ( state_type * $int ) > $o ).

tff(pred_def_87543,type,
    v145448: ( state_type * $int ) > $o ).

tff(pred_def_87544,type,
    v145446: ( state_type * $int ) > $o ).

tff(pred_def_87545,type,
    v145584: state_type > $o ).

tff(pred_def_87546,type,
    v145582: state_type > $o ).

tff(pred_def_87547,type,
    v145588: state_type > $o ).

tff(pred_def_87548,type,
    v145586: state_type > $o ).

tff(pred_def_87549,type,
    v145592: state_type > $o ).

tff(pred_def_87550,type,
    v145590: state_type > $o ).

tff(pred_def_87551,type,
    v145595: state_type > $o ).

tff(pred_def_87552,type,
    v145594: state_type > $o ).

tff(pred_def_87553,type,
    v145580: state_type > $o ).

tff(pred_def_87554,type,
    v145578: state_type > $o ).

tff(pred_def_87555,type,
    v145576: state_type > $o ).

tff(pred_def_87556,type,
    v145574: state_type > $o ).

tff(pred_def_87557,type,
    v145572: state_type > $o ).

tff(pred_def_87558,type,
    v145570: state_type > $o ).

tff(pred_def_87559,type,
    v145568: state_type > $o ).

tff(pred_def_87560,type,
    v145566: state_type > $o ).

tff(pred_def_87561,type,
    v145615: state_type > $o ).

tff(pred_def_87562,type,
    v145613: state_type > $o ).

tff(pred_def_87563,type,
    v145611: state_type > $o ).

tff(pred_def_87564,type,
    v145609: state_type > $o ).

tff(pred_def_87565,type,
    v145607: state_type > $o ).

tff(pred_def_87566,type,
    v145625: state_type > $o ).

tff(pred_def_87567,type,
    v145623: state_type > $o ).

tff(pred_def_87568,type,
    v145621: state_type > $o ).

tff(pred_def_87569,type,
    v145619: state_type > $o ).

tff(pred_def_87570,type,
    v145617: state_type > $o ).

tff(pred_def_87571,type,
    v145629: ( state_type * $int ) > $o ).

tff(pred_def_87572,type,
    v145627: ( state_type * $int ) > $o ).

tff(pred_def_87573,type,
    v145639: state_type > $o ).

tff(pred_def_87574,type,
    v145637: state_type > $o ).

tff(pred_def_87575,type,
    v145645: state_type > $o ).

tff(pred_def_87576,type,
    v145643: state_type > $o ).

tff(pred_def_87577,type,
    v145658: state_type > $o ).

tff(pred_def_87578,type,
    v145656: state_type > $o ).

tff(pred_def_87579,type,
    v145662: state_type > $o ).

tff(pred_def_87580,type,
    v145660: state_type > $o ).

tff(pred_def_87581,type,
    v145666: state_type > $o ).

tff(pred_def_87582,type,
    v145664: state_type > $o ).

tff(pred_def_87583,type,
    v145669: state_type > $o ).

tff(pred_def_87584,type,
    v145668: state_type > $o ).

tff(pred_def_87585,type,
    v145654: state_type > $o ).

tff(pred_def_87586,type,
    v145652: state_type > $o ).

tff(pred_def_87587,type,
    v145649: state_type > $o ).

tff(pred_def_87588,type,
    v145647: state_type > $o ).

tff(pred_def_87589,type,
    v145673: state_type > $o ).

tff(pred_def_87590,type,
    v145671: state_type > $o ).

tff(pred_def_87591,type,
    v145641: state_type > $o ).

tff(pred_def_87592,type,
    v145679: state_type > $o ).

tff(pred_def_87593,type,
    v145681: state_type > $o ).

tff(pred_def_87594,type,
    v145677: state_type > $o ).

tff(pred_def_87595,type,
    v145676: state_type > $o ).

tff(pred_def_87596,type,
    v145687: state_type > $o ).

tff(pred_def_87597,type,
    v145688: state_type > $o ).

tff(pred_def_87598,type,
    v145684: state_type > $o ).

tff(pred_def_87599,type,
    v145686: state_type > $o ).

tff(pred_def_87600,type,
    v145694: state_type > $o ).

tff(pred_def_87601,type,
    v145692: state_type > $o ).

tff(pred_def_87602,type,
    v145696: state_type > $o ).

tff(pred_def_87603,type,
    v145635: state_type > $o ).

tff(pred_def_87604,type,
    v145633: state_type > $o ).

tff(pred_def_87605,type,
    v145631: state_type > $o ).

tff(pred_def_87606,type,
    v145703: state_type > $o ).

tff(pred_def_87607,type,
    v145701: state_type > $o ).

tff(pred_def_87608,type,
    v145700: state_type > $o ).

tff(pred_def_87609,type,
    v145699: state_type > $o ).

tff(pred_def_87610,type,
    v145711: state_type > $o ).

tff(pred_def_87611,type,
    v145712: state_type > $o ).

tff(pred_def_87612,type,
    v145710: state_type > $o ).

tff(pred_def_87613,type,
    v145707: ( state_type * $int ) > $o ).

tff(pred_def_87614,type,
    v145709: ( state_type * $int ) > $o ).

tff(pred_def_87615,type,
    v145605: ( state_type * $int ) > $o ).

tff(pred_def_87616,type,
    v145603: ( state_type * $int ) > $o ).

tff(pred_def_87617,type,
    v145601: ( state_type * $int ) > $o ).

tff(pred_def_87618,type,
    v145599: ( state_type * $int ) > $o ).

tff(pred_def_87619,type,
    v145597: ( state_type * $int ) > $o ).

tff(pred_def_87620,type,
    v145724: state_type > $o ).

tff(pred_def_87621,type,
    v145722: state_type > $o ).

tff(pred_def_87622,type,
    v145720: state_type > $o ).

tff(pred_def_87623,type,
    v145718: state_type > $o ).

tff(pred_def_87624,type,
    v145716: state_type > $o ).

tff(pred_def_87625,type,
    v145732: state_type > $o ).

tff(pred_def_87626,type,
    v145731: ( state_type * $int ) > $o ).

tff(pred_def_87627,type,
    v145730: ( state_type * $int ) > $o ).

tff(pred_def_87628,type,
    v145735: state_type > $o ).

tff(pred_def_87629,type,
    v145734: ( state_type * $int ) > $o ).

tff(pred_def_87630,type,
    v145733: ( state_type * $int ) > $o ).

tff(pred_def_87631,type,
    v145729: ( state_type * $int ) > $o ).

tff(pred_def_87632,type,
    v145738: state_type > $o ).

tff(pred_def_87633,type,
    v145737: ( state_type * $int ) > $o ).

tff(pred_def_87634,type,
    v145736: ( state_type * $int ) > $o ).

tff(pred_def_87635,type,
    v145728: ( state_type * $int ) > $o ).

tff(pred_def_87636,type,
    v145741: state_type > $o ).

tff(pred_def_87637,type,
    v145740: ( state_type * $int ) > $o ).

tff(pred_def_87638,type,
    v145739: ( state_type * $int ) > $o ).

tff(pred_def_87639,type,
    v145727: ( state_type * $int ) > $o ).

tff(pred_def_87640,type,
    v145744: state_type > $o ).

tff(pred_def_87641,type,
    v145743: ( state_type * $int ) > $o ).

tff(pred_def_87642,type,
    v145742: ( state_type * $int ) > $o ).

tff(pred_def_87643,type,
    v145726: ( state_type * $int ) > $o ).

tff(pred_def_87644,type,
    v145747: state_type > $o ).

tff(pred_def_87645,type,
    v145746: ( state_type * $int ) > $o ).

tff(pred_def_87646,type,
    v145745: ( state_type * $int ) > $o ).

tff(pred_def_87647,type,
    v4125: ( state_type * $int ) > $o ).

tff(pred_def_87648,type,
    v4123: ( state_type * $int ) > $o ).

tff(pred_def_87649,type,
    v4119: ( state_type * $int ) > $o ).

tff(pred_def_87650,type,
    v4117: ( state_type * $int ) > $o ).

tff(pred_def_87651,type,
    v145754: state_type > $o ).

tff(pred_def_87652,type,
    v145753: ( state_type * $int ) > $o ).

tff(pred_def_87653,type,
    v145756: state_type > $o ).

tff(pred_def_87654,type,
    v145755: ( state_type * $int ) > $o ).

tff(pred_def_87655,type,
    v145751: ( state_type * $int ) > $o ).

tff(pred_def_87656,type,
    v145749: ( state_type * $int ) > $o ).

tff(pred_def_87657,type,
    v4115: state_type > $o ).

tff(pred_def_87658,type,
    v4113: state_type > $o ).

tff(pred_def_87659,type,
    v4111: state_type > $o ).

tff(pred_def_87660,type,
    v145767: ( state_type * $int ) > $o ).

tff(pred_def_87661,type,
    v145765: ( state_type * $int ) > $o ).

tff(pred_def_87662,type,
    v145774: state_type > $o ).

tff(pred_def_87663,type,
    v145773: ( state_type * $int ) > $o ).

tff(pred_def_87664,type,
    v145776: state_type > $o ).

tff(pred_def_87665,type,
    v145775: ( state_type * $int ) > $o ).

tff(pred_def_87666,type,
    v145771: ( state_type * $int ) > $o ).

tff(pred_def_87667,type,
    v145769: ( state_type * $int ) > $o ).

tff(pred_def_87668,type,
    v145763: state_type > $o ).

tff(pred_def_87669,type,
    v145761: state_type > $o ).

tff(pred_def_87670,type,
    v145759: state_type > $o ).

tff(pred_def_87671,type,
    v145787: ( state_type * $int ) > $o ).

tff(pred_def_87672,type,
    v145785: ( state_type * $int ) > $o ).

tff(pred_def_87673,type,
    v145794: state_type > $o ).

tff(pred_def_87674,type,
    v145793: ( state_type * $int ) > $o ).

tff(pred_def_87675,type,
    v145796: state_type > $o ).

tff(pred_def_87676,type,
    v145795: ( state_type * $int ) > $o ).

tff(pred_def_87677,type,
    v145791: ( state_type * $int ) > $o ).

tff(pred_def_87678,type,
    v145789: ( state_type * $int ) > $o ).

tff(pred_def_87679,type,
    v145783: state_type > $o ).

tff(pred_def_87680,type,
    v145781: state_type > $o ).

tff(pred_def_87681,type,
    v145779: state_type > $o ).

tff(pred_def_87682,type,
    v145807: ( state_type * $int ) > $o ).

tff(pred_def_87683,type,
    v145805: ( state_type * $int ) > $o ).

tff(pred_def_87684,type,
    v145814: state_type > $o ).

tff(pred_def_87685,type,
    v145813: ( state_type * $int ) > $o ).

tff(pred_def_87686,type,
    v145816: state_type > $o ).

tff(pred_def_87687,type,
    v145815: ( state_type * $int ) > $o ).

tff(pred_def_87688,type,
    v145811: ( state_type * $int ) > $o ).

tff(pred_def_87689,type,
    v145809: ( state_type * $int ) > $o ).

tff(pred_def_87690,type,
    v145803: state_type > $o ).

tff(pred_def_87691,type,
    v145801: state_type > $o ).

tff(pred_def_87692,type,
    v145799: state_type > $o ).

tff(pred_def_87693,type,
    v145827: ( state_type * $int ) > $o ).

tff(pred_def_87694,type,
    v145825: ( state_type * $int ) > $o ).

tff(pred_def_87695,type,
    v145834: state_type > $o ).

tff(pred_def_87696,type,
    v145833: ( state_type * $int ) > $o ).

tff(pred_def_87697,type,
    v145836: state_type > $o ).

tff(pred_def_87698,type,
    v145835: ( state_type * $int ) > $o ).

tff(pred_def_87699,type,
    v145831: ( state_type * $int ) > $o ).

tff(pred_def_87700,type,
    v145829: ( state_type * $int ) > $o ).

tff(pred_def_87701,type,
    v145823: state_type > $o ).

tff(pred_def_87702,type,
    v145821: state_type > $o ).

tff(pred_def_87703,type,
    v145819: state_type > $o ).

tff(pred_def_87704,type,
    v145847: ( state_type * $int ) > $o ).

tff(pred_def_87705,type,
    v145845: ( state_type * $int ) > $o ).

tff(pred_def_87706,type,
    v145854: state_type > $o ).

tff(pred_def_87707,type,
    v145853: ( state_type * $int ) > $o ).

tff(pred_def_87708,type,
    v145856: state_type > $o ).

tff(pred_def_87709,type,
    v145855: ( state_type * $int ) > $o ).

tff(pred_def_87710,type,
    v145851: ( state_type * $int ) > $o ).

tff(pred_def_87711,type,
    v145849: ( state_type * $int ) > $o ).

tff(pred_def_87712,type,
    v145843: state_type > $o ).

tff(pred_def_87713,type,
    v145841: state_type > $o ).

tff(pred_def_87714,type,
    v145839: state_type > $o ).

tff(pred_def_87715,type,
    v145867: ( state_type * $int ) > $o ).

tff(pred_def_87716,type,
    v145865: ( state_type * $int ) > $o ).

tff(pred_def_87717,type,
    v145874: state_type > $o ).

tff(pred_def_87718,type,
    v145873: ( state_type * $int ) > $o ).

tff(pred_def_87719,type,
    v145876: state_type > $o ).

tff(pred_def_87720,type,
    v145875: ( state_type * $int ) > $o ).

tff(pred_def_87721,type,
    v145871: ( state_type * $int ) > $o ).

tff(pred_def_87722,type,
    v145869: ( state_type * $int ) > $o ).

tff(pred_def_87723,type,
    v145863: state_type > $o ).

tff(pred_def_87724,type,
    v145861: state_type > $o ).

tff(pred_def_87725,type,
    v145859: state_type > $o ).

tff(pred_def_87726,type,
    v145887: ( state_type * $int ) > $o ).

tff(pred_def_87727,type,
    v145885: ( state_type * $int ) > $o ).

tff(pred_def_87728,type,
    v145894: state_type > $o ).

tff(pred_def_87729,type,
    v145893: ( state_type * $int ) > $o ).

tff(pred_def_87730,type,
    v145896: state_type > $o ).

tff(pred_def_87731,type,
    v145895: ( state_type * $int ) > $o ).

tff(pred_def_87732,type,
    v145891: ( state_type * $int ) > $o ).

tff(pred_def_87733,type,
    v145889: ( state_type * $int ) > $o ).

tff(pred_def_87734,type,
    v145883: state_type > $o ).

tff(pred_def_87735,type,
    v145881: state_type > $o ).

tff(pred_def_87736,type,
    v145879: state_type > $o ).

tff(pred_def_87737,type,
    v145907: ( state_type * $int ) > $o ).

tff(pred_def_87738,type,
    v145905: ( state_type * $int ) > $o ).

tff(pred_def_87739,type,
    v145914: state_type > $o ).

tff(pred_def_87740,type,
    v145913: ( state_type * $int ) > $o ).

tff(pred_def_87741,type,
    v145916: state_type > $o ).

tff(pred_def_87742,type,
    v145915: ( state_type * $int ) > $o ).

tff(pred_def_87743,type,
    v145911: ( state_type * $int ) > $o ).

tff(pred_def_87744,type,
    v145909: ( state_type * $int ) > $o ).

tff(pred_def_87745,type,
    v145903: state_type > $o ).

tff(pred_def_87746,type,
    v145901: state_type > $o ).

tff(pred_def_87747,type,
    v145899: state_type > $o ).

tff(pred_def_87748,type,
    v145927: ( state_type * $int ) > $o ).

tff(pred_def_87749,type,
    v145925: ( state_type * $int ) > $o ).

tff(pred_def_87750,type,
    v145934: state_type > $o ).

tff(pred_def_87751,type,
    v145933: ( state_type * $int ) > $o ).

tff(pred_def_87752,type,
    v145936: state_type > $o ).

tff(pred_def_87753,type,
    v145935: ( state_type * $int ) > $o ).

tff(pred_def_87754,type,
    v145931: ( state_type * $int ) > $o ).

tff(pred_def_87755,type,
    v145929: ( state_type * $int ) > $o ).

tff(pred_def_87756,type,
    v145923: state_type > $o ).

tff(pred_def_87757,type,
    v145921: state_type > $o ).

tff(pred_def_87758,type,
    v145919: state_type > $o ).

tff(pred_def_87759,type,
    v145947: ( state_type * $int ) > $o ).

tff(pred_def_87760,type,
    v145945: ( state_type * $int ) > $o ).

tff(pred_def_87761,type,
    v145954: state_type > $o ).

tff(pred_def_87762,type,
    v145953: ( state_type * $int ) > $o ).

tff(pred_def_87763,type,
    v145956: state_type > $o ).

tff(pred_def_87764,type,
    v145955: ( state_type * $int ) > $o ).

tff(pred_def_87765,type,
    v145951: ( state_type * $int ) > $o ).

tff(pred_def_87766,type,
    v145949: ( state_type * $int ) > $o ).

tff(pred_def_87767,type,
    v145943: state_type > $o ).

tff(pred_def_87768,type,
    v145941: state_type > $o ).

tff(pred_def_87769,type,
    v145939: state_type > $o ).

tff(pred_def_87770,type,
    v145967: ( state_type * $int ) > $o ).

tff(pred_def_87771,type,
    v145965: ( state_type * $int ) > $o ).

tff(pred_def_87772,type,
    v145974: state_type > $o ).

tff(pred_def_87773,type,
    v145973: ( state_type * $int ) > $o ).

tff(pred_def_87774,type,
    v145976: state_type > $o ).

tff(pred_def_87775,type,
    v145975: ( state_type * $int ) > $o ).

tff(pred_def_87776,type,
    v145971: ( state_type * $int ) > $o ).

tff(pred_def_87777,type,
    v145969: ( state_type * $int ) > $o ).

tff(pred_def_87778,type,
    v145963: state_type > $o ).

tff(pred_def_87779,type,
    v145961: state_type > $o ).

tff(pred_def_87780,type,
    v145959: state_type > $o ).

tff(pred_def_87781,type,
    v145987: ( state_type * $int ) > $o ).

tff(pred_def_87782,type,
    v145985: ( state_type * $int ) > $o ).

tff(pred_def_87783,type,
    v145994: state_type > $o ).

tff(pred_def_87784,type,
    v145993: ( state_type * $int ) > $o ).

tff(pred_def_87785,type,
    v145996: state_type > $o ).

tff(pred_def_87786,type,
    v145995: ( state_type * $int ) > $o ).

tff(pred_def_87787,type,
    v145991: ( state_type * $int ) > $o ).

tff(pred_def_87788,type,
    v145989: ( state_type * $int ) > $o ).

tff(pred_def_87789,type,
    v145983: state_type > $o ).

tff(pred_def_87790,type,
    v145981: state_type > $o ).

tff(pred_def_87791,type,
    v145979: state_type > $o ).

tff(pred_def_87792,type,
    v4109: ( state_type * $int ) > $o ).

tff(pred_def_87793,type,
    v4107: ( state_type * $int ) > $o ).

tff(pred_def_87794,type,
    v4105: ( state_type * $int ) > $o ).

tff(pred_def_87795,type,
    v146013: ( state_type * $int ) > $o ).

tff(pred_def_87796,type,
    v146011: ( state_type * $int ) > $o ).

tff(pred_def_87797,type,
    v146020: state_type > $o ).

tff(pred_def_87798,type,
    v146019: ( state_type * $int ) > $o ).

tff(pred_def_87799,type,
    v146022: state_type > $o ).

tff(pred_def_87800,type,
    v146021: ( state_type * $int ) > $o ).

tff(pred_def_87801,type,
    v146017: ( state_type * $int ) > $o ).

tff(pred_def_87802,type,
    v146015: ( state_type * $int ) > $o ).

tff(pred_def_87803,type,
    v146009: state_type > $o ).

tff(pred_def_87804,type,
    v146007: state_type > $o ).

tff(pred_def_87805,type,
    v146005: state_type > $o ).

tff(pred_def_87806,type,
    v146033: ( state_type * $int ) > $o ).

tff(pred_def_87807,type,
    v146031: ( state_type * $int ) > $o ).

tff(pred_def_87808,type,
    v146040: state_type > $o ).

tff(pred_def_87809,type,
    v146039: ( state_type * $int ) > $o ).

tff(pred_def_87810,type,
    v146042: state_type > $o ).

tff(pred_def_87811,type,
    v146041: ( state_type * $int ) > $o ).

tff(pred_def_87812,type,
    v146037: ( state_type * $int ) > $o ).

tff(pred_def_87813,type,
    v146035: ( state_type * $int ) > $o ).

tff(pred_def_87814,type,
    v146029: state_type > $o ).

tff(pred_def_87815,type,
    v146027: state_type > $o ).

tff(pred_def_87816,type,
    v146025: state_type > $o ).

tff(pred_def_87817,type,
    v146053: ( state_type * $int ) > $o ).

tff(pred_def_87818,type,
    v146051: ( state_type * $int ) > $o ).

tff(pred_def_87819,type,
    v146060: state_type > $o ).

tff(pred_def_87820,type,
    v146059: ( state_type * $int ) > $o ).

tff(pred_def_87821,type,
    v146062: state_type > $o ).

tff(pred_def_87822,type,
    v146061: ( state_type * $int ) > $o ).

tff(pred_def_87823,type,
    v146057: ( state_type * $int ) > $o ).

tff(pred_def_87824,type,
    v146055: ( state_type * $int ) > $o ).

tff(pred_def_87825,type,
    v146049: state_type > $o ).

tff(pred_def_87826,type,
    v146047: state_type > $o ).

tff(pred_def_87827,type,
    v146045: state_type > $o ).

tff(pred_def_87828,type,
    v146073: ( state_type * $int ) > $o ).

tff(pred_def_87829,type,
    v146071: ( state_type * $int ) > $o ).

tff(pred_def_87830,type,
    v146080: state_type > $o ).

tff(pred_def_87831,type,
    v146079: ( state_type * $int ) > $o ).

tff(pred_def_87832,type,
    v146082: state_type > $o ).

tff(pred_def_87833,type,
    v146081: ( state_type * $int ) > $o ).

tff(pred_def_87834,type,
    v146077: ( state_type * $int ) > $o ).

tff(pred_def_87835,type,
    v146075: ( state_type * $int ) > $o ).

tff(pred_def_87836,type,
    v146069: state_type > $o ).

tff(pred_def_87837,type,
    v146067: state_type > $o ).

tff(pred_def_87838,type,
    v146065: state_type > $o ).

tff(pred_def_87839,type,
    v146093: ( state_type * $int ) > $o ).

tff(pred_def_87840,type,
    v146091: ( state_type * $int ) > $o ).

tff(pred_def_87841,type,
    v146100: state_type > $o ).

tff(pred_def_87842,type,
    v146099: ( state_type * $int ) > $o ).

tff(pred_def_87843,type,
    v146102: state_type > $o ).

tff(pred_def_87844,type,
    v146101: ( state_type * $int ) > $o ).

tff(pred_def_87845,type,
    v146097: ( state_type * $int ) > $o ).

tff(pred_def_87846,type,
    v146095: ( state_type * $int ) > $o ).

tff(pred_def_87847,type,
    v146089: state_type > $o ).

tff(pred_def_87848,type,
    v146087: state_type > $o ).

tff(pred_def_87849,type,
    v146085: state_type > $o ).

tff(pred_def_87850,type,
    v146113: ( state_type * $int ) > $o ).

tff(pred_def_87851,type,
    v146111: ( state_type * $int ) > $o ).

tff(pred_def_87852,type,
    v146120: state_type > $o ).

tff(pred_def_87853,type,
    v146119: ( state_type * $int ) > $o ).

tff(pred_def_87854,type,
    v146122: state_type > $o ).

tff(pred_def_87855,type,
    v146121: ( state_type * $int ) > $o ).

tff(pred_def_87856,type,
    v146117: ( state_type * $int ) > $o ).

tff(pred_def_87857,type,
    v146115: ( state_type * $int ) > $o ).

tff(pred_def_87858,type,
    v146109: state_type > $o ).

tff(pred_def_87859,type,
    v146107: state_type > $o ).

tff(pred_def_87860,type,
    v146105: state_type > $o ).

tff(pred_def_87861,type,
    v146133: ( state_type * $int ) > $o ).

tff(pred_def_87862,type,
    v146131: ( state_type * $int ) > $o ).

tff(pred_def_87863,type,
    v146140: state_type > $o ).

tff(pred_def_87864,type,
    v146139: ( state_type * $int ) > $o ).

tff(pred_def_87865,type,
    v146142: state_type > $o ).

tff(pred_def_87866,type,
    v146141: ( state_type * $int ) > $o ).

tff(pred_def_87867,type,
    v146137: ( state_type * $int ) > $o ).

tff(pred_def_87868,type,
    v146135: ( state_type * $int ) > $o ).

tff(pred_def_87869,type,
    v146129: state_type > $o ).

tff(pred_def_87870,type,
    v146127: state_type > $o ).

tff(pred_def_87871,type,
    v146125: state_type > $o ).

tff(pred_def_87872,type,
    v146153: ( state_type * $int ) > $o ).

tff(pred_def_87873,type,
    v146151: ( state_type * $int ) > $o ).

tff(pred_def_87874,type,
    v146160: state_type > $o ).

tff(pred_def_87875,type,
    v146159: ( state_type * $int ) > $o ).

tff(pred_def_87876,type,
    v146162: state_type > $o ).

tff(pred_def_87877,type,
    v146161: ( state_type * $int ) > $o ).

tff(pred_def_87878,type,
    v146157: ( state_type * $int ) > $o ).

tff(pred_def_87879,type,
    v146155: ( state_type * $int ) > $o ).

tff(pred_def_87880,type,
    v146149: state_type > $o ).

tff(pred_def_87881,type,
    v146147: state_type > $o ).

tff(pred_def_87882,type,
    v146145: state_type > $o ).

tff(pred_def_87883,type,
    v146173: ( state_type * $int ) > $o ).

tff(pred_def_87884,type,
    v146171: ( state_type * $int ) > $o ).

tff(pred_def_87885,type,
    v146180: state_type > $o ).

tff(pred_def_87886,type,
    v146179: ( state_type * $int ) > $o ).

tff(pred_def_87887,type,
    v146182: state_type > $o ).

tff(pred_def_87888,type,
    v146181: ( state_type * $int ) > $o ).

tff(pred_def_87889,type,
    v146177: ( state_type * $int ) > $o ).

tff(pred_def_87890,type,
    v146175: ( state_type * $int ) > $o ).

tff(pred_def_87891,type,
    v146169: state_type > $o ).

tff(pred_def_87892,type,
    v146167: state_type > $o ).

tff(pred_def_87893,type,
    v146165: state_type > $o ).

tff(pred_def_87894,type,
    v146193: ( state_type * $int ) > $o ).

tff(pred_def_87895,type,
    v146191: ( state_type * $int ) > $o ).

tff(pred_def_87896,type,
    v146200: state_type > $o ).

tff(pred_def_87897,type,
    v146199: ( state_type * $int ) > $o ).

tff(pred_def_87898,type,
    v146202: state_type > $o ).

tff(pred_def_87899,type,
    v146201: ( state_type * $int ) > $o ).

tff(pred_def_87900,type,
    v146197: ( state_type * $int ) > $o ).

tff(pred_def_87901,type,
    v146195: ( state_type * $int ) > $o ).

tff(pred_def_87902,type,
    v146189: state_type > $o ).

tff(pred_def_87903,type,
    v146187: state_type > $o ).

tff(pred_def_87904,type,
    v146185: state_type > $o ).

tff(pred_def_87905,type,
    v146213: ( state_type * $int ) > $o ).

tff(pred_def_87906,type,
    v146211: ( state_type * $int ) > $o ).

tff(pred_def_87907,type,
    v146220: state_type > $o ).

tff(pred_def_87908,type,
    v146219: ( state_type * $int ) > $o ).

tff(pred_def_87909,type,
    v146222: state_type > $o ).

tff(pred_def_87910,type,
    v146221: ( state_type * $int ) > $o ).

tff(pred_def_87911,type,
    v146217: ( state_type * $int ) > $o ).

tff(pred_def_87912,type,
    v146215: ( state_type * $int ) > $o ).

tff(pred_def_87913,type,
    v146209: state_type > $o ).

tff(pred_def_87914,type,
    v146207: state_type > $o ).

tff(pred_def_87915,type,
    v146205: state_type > $o ).

tff(pred_def_87916,type,
    v146233: ( state_type * $int ) > $o ).

tff(pred_def_87917,type,
    v146231: ( state_type * $int ) > $o ).

tff(pred_def_87918,type,
    v146240: state_type > $o ).

tff(pred_def_87919,type,
    v146239: ( state_type * $int ) > $o ).

tff(pred_def_87920,type,
    v146242: state_type > $o ).

tff(pred_def_87921,type,
    v146241: ( state_type * $int ) > $o ).

tff(pred_def_87922,type,
    v146237: ( state_type * $int ) > $o ).

tff(pred_def_87923,type,
    v146235: ( state_type * $int ) > $o ).

tff(pred_def_87924,type,
    v146229: state_type > $o ).

tff(pred_def_87925,type,
    v146227: state_type > $o ).

tff(pred_def_87926,type,
    v146225: state_type > $o ).

tff(pred_def_87927,type,
    v146253: ( state_type * $int ) > $o ).

tff(pred_def_87928,type,
    v146251: ( state_type * $int ) > $o ).

tff(pred_def_87929,type,
    v146260: state_type > $o ).

tff(pred_def_87930,type,
    v146259: ( state_type * $int ) > $o ).

tff(pred_def_87931,type,
    v146262: state_type > $o ).

tff(pred_def_87932,type,
    v146261: ( state_type * $int ) > $o ).

tff(pred_def_87933,type,
    v146257: ( state_type * $int ) > $o ).

tff(pred_def_87934,type,
    v146255: ( state_type * $int ) > $o ).

tff(pred_def_87935,type,
    v146249: state_type > $o ).

tff(pred_def_87936,type,
    v146247: state_type > $o ).

tff(pred_def_87937,type,
    v146245: state_type > $o ).

tff(pred_def_87938,type,
    v146003: ( state_type * $int ) > $o ).

tff(pred_def_87939,type,
    v146001: ( state_type * $int ) > $o ).

tff(pred_def_87940,type,
    v145999: ( state_type * $int ) > $o ).

tff(pred_def_87941,type,
    v146279: state_type > $o ).

tff(pred_def_87942,type,
    v146278: state_type > $o ).

tff(pred_def_87943,type,
    v146277: state_type > $o ).

tff(pred_def_87944,type,
    v146276: state_type > $o ).

tff(pred_def_87945,type,
    v146275: state_type > $o ).

tff(pred_def_87946,type,
    v146274: state_type > $o ).

tff(pred_def_87947,type,
    v146273: state_type > $o ).

tff(pred_def_87948,type,
    v146272: state_type > $o ).

tff(pred_def_87949,type,
    v146271: state_type > $o ).

tff(pred_def_87950,type,
    v146270: state_type > $o ).

tff(pred_def_87951,type,
    v146269: state_type > $o ).

tff(pred_def_87952,type,
    v146267: state_type > $o ).

tff(pred_def_87953,type,
    v146293: state_type > $o ).

tff(pred_def_87954,type,
    v146292: state_type > $o ).

tff(pred_def_87955,type,
    v146291: state_type > $o ).

tff(pred_def_87956,type,
    v146290: state_type > $o ).

tff(pred_def_87957,type,
    v146289: state_type > $o ).

tff(pred_def_87958,type,
    v146288: state_type > $o ).

tff(pred_def_87959,type,
    v146287: state_type > $o ).

tff(pred_def_87960,type,
    v146286: state_type > $o ).

tff(pred_def_87961,type,
    v146285: state_type > $o ).

tff(pred_def_87962,type,
    v146284: state_type > $o ).

tff(pred_def_87963,type,
    v146283: state_type > $o ).

tff(pred_def_87964,type,
    v146281: state_type > $o ).

tff(pred_def_87965,type,
    v146280: state_type > $o ).

tff(pred_def_87966,type,
    v146266: state_type > $o ).

tff(pred_def_87967,type,
    v146294: state_type > $o ).

tff(pred_def_87968,type,
    v146265: state_type > $o ).

tff(pred_def_87969,type,
    v146295: state_type > $o ).

tff(pred_def_87970,type,
    v146299: state_type > $o ).

tff(pred_def_87971,type,
    v146298: state_type > $o ).

tff(pred_def_87972,type,
    v146302: state_type > $o ).

tff(pred_def_87973,type,
    v146301: state_type > $o ).

tff(pred_def_87974,type,
    v146303: state_type > $o ).

tff(pred_def_87975,type,
    v146300: state_type > $o ).

tff(pred_def_87976,type,
    v146297: state_type > $o ).

tff(pred_def_87977,type,
    v4101: state_type > $o ).

tff(pred_def_87978,type,
    v4099: state_type > $o ).

tff(pred_def_87979,type,
    v4097: state_type > $o ).

tff(pred_def_87980,type,
    v4095: state_type > $o ).

tff(pred_def_87981,type,
    v146312: state_type > $o ).

tff(pred_def_87982,type,
    v146310: state_type > $o ).

tff(pred_def_87983,type,
    v146309: state_type > $o ).

tff(pred_def_87984,type,
    v146308: ( state_type * $int ) > $o ).

tff(pred_def_87985,type,
    v146306: ( state_type * $int ) > $o ).

tff(pred_def_87986,type,
    v146324: state_type > $o ).

tff(pred_def_87987,type,
    v146323: state_type > $o ).

tff(pred_def_87988,type,
    v146325: state_type > $o ).

tff(pred_def_87989,type,
    v146322: state_type > $o ).

tff(pred_def_87990,type,
    v146321: state_type > $o ).

tff(pred_def_87991,type,
    v146320: ( state_type * $int ) > $o ).

tff(pred_def_87992,type,
    v146319: ( state_type * $int ) > $o ).

tff(pred_def_87993,type,
    v146331: state_type > $o ).

tff(pred_def_87994,type,
    v146330: state_type > $o ).

tff(pred_def_87995,type,
    v146332: state_type > $o ).

tff(pred_def_87996,type,
    v146329: state_type > $o ).

tff(pred_def_87997,type,
    v146328: state_type > $o ).

tff(pred_def_87998,type,
    v146327: ( state_type * $int ) > $o ).

tff(pred_def_87999,type,
    v146326: ( state_type * $int ) > $o ).

tff(pred_def_88000,type,
    v146318: ( state_type * $int ) > $o ).

tff(pred_def_88001,type,
    v146338: state_type > $o ).

tff(pred_def_88002,type,
    v146337: state_type > $o ).

tff(pred_def_88003,type,
    v146336: state_type > $o ).

tff(pred_def_88004,type,
    v146335: state_type > $o ).

tff(pred_def_88005,type,
    v146334: ( state_type * $int ) > $o ).

tff(pred_def_88006,type,
    v146333: ( state_type * $int ) > $o ).

tff(pred_def_88007,type,
    v146317: ( state_type * $int ) > $o ).

tff(pred_def_88008,type,
    v146316: ( state_type * $int ) > $o ).

tff(pred_def_88009,type,
    v146339: ( state_type * $int ) > $o ).

tff(pred_def_88010,type,
    v146341: state_type > $o ).

tff(pred_def_88011,type,
    v146340: ( state_type * $int ) > $o ).

tff(pred_def_88012,type,
    v4091: ( state_type * $int ) > $o ).

tff(pred_def_88013,type,
    v4089: ( state_type * $int ) > $o ).

tff(pred_def_88014,type,
    v4087: ( state_type * $int ) > $o ).

tff(pred_def_88015,type,
    v4085: ( state_type * $int ) > $o ).

tff(pred_def_88016,type,
    v146347: state_type > $o ).

tff(pred_def_88017,type,
    v146346: state_type > $o ).

tff(pred_def_88018,type,
    v146345: state_type > $o ).

tff(pred_def_88019,type,
    v146348: state_type > $o ).

tff(pred_def_88020,type,
    v146343: state_type > $o ).

tff(pred_def_88021,type,
    v146354: state_type > $o ).

tff(pred_def_88022,type,
    v146352: state_type > $o ).

tff(pred_def_88023,type,
    v146351: state_type > $o ).

tff(pred_def_88024,type,
    v146350: ( state_type * $int ) > $o ).

tff(pred_def_88025,type,
    v146362: state_type > $o ).

tff(pred_def_88026,type,
    v146363: state_type > $o ).

tff(pred_def_88027,type,
    v146361: state_type > $o ).

tff(pred_def_88028,type,
    v146360: state_type > $o ).

tff(pred_def_88029,type,
    v146364: state_type > $o ).

tff(pred_def_88030,type,
    v146358: state_type > $o ).

tff(pred_def_88031,type,
    v146370: state_type > $o ).

tff(pred_def_88032,type,
    v146368: state_type > $o ).

tff(pred_def_88033,type,
    v146367: state_type > $o ).

tff(pred_def_88034,type,
    v146366: ( state_type * $int ) > $o ).

tff(pred_def_88035,type,
    v146378: state_type > $o ).

tff(pred_def_88036,type,
    v146379: state_type > $o ).

tff(pred_def_88037,type,
    v146377: state_type > $o ).

tff(pred_def_88038,type,
    v146376: state_type > $o ).

tff(pred_def_88039,type,
    v146380: state_type > $o ).

tff(pred_def_88040,type,
    v146374: state_type > $o ).

tff(pred_def_88041,type,
    v146386: state_type > $o ).

tff(pred_def_88042,type,
    v146384: state_type > $o ).

tff(pred_def_88043,type,
    v146383: state_type > $o ).

tff(pred_def_88044,type,
    v146382: ( state_type * $int ) > $o ).

tff(pred_def_88045,type,
    v146394: state_type > $o ).

tff(pred_def_88046,type,
    v146395: state_type > $o ).

tff(pred_def_88047,type,
    v146393: state_type > $o ).

tff(pred_def_88048,type,
    v146392: state_type > $o ).

tff(pred_def_88049,type,
    v146396: state_type > $o ).

tff(pred_def_88050,type,
    v146390: state_type > $o ).

tff(pred_def_88051,type,
    v146402: state_type > $o ).

tff(pred_def_88052,type,
    v146400: state_type > $o ).

tff(pred_def_88053,type,
    v146399: state_type > $o ).

tff(pred_def_88054,type,
    v146398: ( state_type * $int ) > $o ).

tff(pred_def_88055,type,
    v146410: state_type > $o ).

tff(pred_def_88056,type,
    v146411: state_type > $o ).

tff(pred_def_88057,type,
    v146409: state_type > $o ).

tff(pred_def_88058,type,
    v146408: state_type > $o ).

tff(pred_def_88059,type,
    v146412: state_type > $o ).

tff(pred_def_88060,type,
    v146406: state_type > $o ).

tff(pred_def_88061,type,
    v146418: state_type > $o ).

tff(pred_def_88062,type,
    v146416: state_type > $o ).

tff(pred_def_88063,type,
    v146415: state_type > $o ).

tff(pred_def_88064,type,
    v146414: ( state_type * $int ) > $o ).

tff(pred_def_88065,type,
    v146426: state_type > $o ).

tff(pred_def_88066,type,
    v146427: state_type > $o ).

tff(pred_def_88067,type,
    v146425: state_type > $o ).

tff(pred_def_88068,type,
    v146424: state_type > $o ).

tff(pred_def_88069,type,
    v146428: state_type > $o ).

tff(pred_def_88070,type,
    v146422: state_type > $o ).

tff(pred_def_88071,type,
    v146434: state_type > $o ).

tff(pred_def_88072,type,
    v146432: state_type > $o ).

tff(pred_def_88073,type,
    v146431: state_type > $o ).

tff(pred_def_88074,type,
    v146430: ( state_type * $int ) > $o ).

tff(pred_def_88075,type,
    v146442: state_type > $o ).

tff(pred_def_88076,type,
    v146443: state_type > $o ).

tff(pred_def_88077,type,
    v146441: state_type > $o ).

tff(pred_def_88078,type,
    v146440: state_type > $o ).

tff(pred_def_88079,type,
    v146444: state_type > $o ).

tff(pred_def_88080,type,
    v146438: state_type > $o ).

tff(pred_def_88081,type,
    v146450: state_type > $o ).

tff(pred_def_88082,type,
    v146448: state_type > $o ).

tff(pred_def_88083,type,
    v146447: state_type > $o ).

tff(pred_def_88084,type,
    v146446: ( state_type * $int ) > $o ).

tff(pred_def_88085,type,
    v146454: state_type > $o ).

tff(pred_def_88086,type,
    v2938: ( state_type * $int ) > $o ).

tff(pred_def_88087,type,
    v146456: state_type > $o ).

tff(pred_def_88088,type,
    v146458: state_type > $o ).

tff(pred_def_88089,type,
    v146460: state_type > $o ).

tff(pred_def_88090,type,
    v146462: state_type > $o ).

tff(pred_def_88091,type,
    v146464: state_type > $o ).

tff(pred_def_88092,type,
    v146466: state_type > $o ).

tff(pred_def_88093,type,
    v146468: state_type > $o ).

tff(pred_def_88094,type,
    v2936: ( state_type * $int ) > $o ).

tff(pred_def_88095,type,
    v2934: ( state_type * $int ) > $o ).

tff(pred_def_88096,type,
    v2932: ( state_type * $int ) > $o ).

tff(pred_def_88097,type,
    v146472: state_type > $o ).

tff(pred_def_88098,type,
    v146470: state_type > $o ).

tff(pred_def_88099,type,
    v146479: state_type > $o ).

tff(pred_def_88100,type,
    v146477: state_type > $o ).

tff(pred_def_88101,type,
    v146476: state_type > $o ).

tff(pred_def_88102,type,
    v146475: state_type > $o ).

tff(pred_def_88103,type,
    v146487: state_type > $o ).

tff(pred_def_88104,type,
    v146488: state_type > $o ).

tff(pred_def_88105,type,
    v146486: state_type > $o ).

tff(pred_def_88106,type,
    v146483: ( state_type * $int ) > $o ).

tff(pred_def_88107,type,
    v146485: ( state_type * $int ) > $o ).

tff(pred_def_88108,type,
    v2914: ( state_type * $int ) > $o ).

tff(pred_def_88109,type,
    v2912: ( state_type * $int ) > $o ).

tff(pred_def_88110,type,
    v146500: state_type > $o ).

tff(pred_def_88111,type,
    v146498: state_type > $o ).

tff(pred_def_88112,type,
    v146504: state_type > $o ).

tff(pred_def_88113,type,
    v146502: state_type > $o ).

tff(pred_def_88114,type,
    v146525: state_type > $o ).

tff(pred_def_88115,type,
    v146524: state_type > $o ).

tff(pred_def_88116,type,
    v146523: state_type > $o ).

tff(pred_def_88117,type,
    v146522: ( state_type * $int ) > $o ).

tff(pred_def_88118,type,
    v146521: ( state_type * $int ) > $o ).

tff(pred_def_88119,type,
    v146530: state_type > $o ).

tff(pred_def_88120,type,
    v146529: state_type > $o ).

tff(pred_def_88121,type,
    v146528: state_type > $o ).

tff(pred_def_88122,type,
    v146527: ( state_type * $int ) > $o ).

tff(pred_def_88123,type,
    v146526: ( state_type * $int ) > $o ).

tff(pred_def_88124,type,
    v146520: ( state_type * $int ) > $o ).

tff(pred_def_88125,type,
    v146535: state_type > $o ).

tff(pred_def_88126,type,
    v146534: state_type > $o ).

tff(pred_def_88127,type,
    v146533: state_type > $o ).

tff(pred_def_88128,type,
    v146532: ( state_type * $int ) > $o ).

tff(pred_def_88129,type,
    v146531: ( state_type * $int ) > $o ).

tff(pred_def_88130,type,
    v146519: ( state_type * $int ) > $o ).

tff(pred_def_88131,type,
    v146518: ( state_type * $int ) > $o ).

tff(pred_def_88132,type,
    v146516: ( state_type * $int ) > $o ).

tff(pred_def_88133,type,
    v146514: ( state_type * $int ) > $o ).

tff(pred_def_88134,type,
    v146537: state_type > $o ).

tff(pred_def_88135,type,
    v146492: ( state_type * $int ) > $o ).

tff(pred_def_88136,type,
    v146512: ( state_type * $int ) > $o ).

tff(pred_def_88137,type,
    v146539: state_type > $o ).

tff(pred_def_88138,type,
    v146541: state_type > $o ).

tff(pred_def_88139,type,
    v146543: state_type > $o ).

tff(pred_def_88140,type,
    v146545: state_type > $o ).

tff(pred_def_88141,type,
    v146547: state_type > $o ).

tff(pred_def_88142,type,
    v146549: state_type > $o ).

tff(pred_def_88143,type,
    v146551: state_type > $o ).

tff(pred_def_88144,type,
    v146510: ( state_type * $int ) > $o ).

tff(pred_def_88145,type,
    v146508: ( state_type * $int ) > $o ).

tff(pred_def_88146,type,
    v146506: ( state_type * $int ) > $o ).

tff(pred_def_88147,type,
    v146555: state_type > $o ).

tff(pred_def_88148,type,
    v146553: state_type > $o ).

tff(pred_def_88149,type,
    v146562: state_type > $o ).

tff(pred_def_88150,type,
    v146560: state_type > $o ).

tff(pred_def_88151,type,
    v146559: state_type > $o ).

tff(pred_def_88152,type,
    v146558: state_type > $o ).

tff(pred_def_88153,type,
    v146570: state_type > $o ).

tff(pred_def_88154,type,
    v146571: state_type > $o ).

tff(pred_def_88155,type,
    v146569: state_type > $o ).

tff(pred_def_88156,type,
    v146566: ( state_type * $int ) > $o ).

tff(pred_def_88157,type,
    v146568: ( state_type * $int ) > $o ).

tff(pred_def_88158,type,
    v146496: ( state_type * $int ) > $o ).

tff(pred_def_88159,type,
    v146494: ( state_type * $int ) > $o ).

tff(pred_def_88160,type,
    v146575: ( state_type * $int ) > $o ).

tff(pred_def_88161,type,
    v2908: ( state_type * $int ) > $o ).

tff(pred_def_88162,type,
    v2906: ( state_type * $int ) > $o ).

tff(pred_def_88163,type,
    v146621: state_type > $o ).

tff(pred_def_88164,type,
    v146619: state_type > $o ).

tff(pred_def_88165,type,
    v146617: state_type > $o ).

tff(pred_def_88166,type,
    v146615: state_type > $o ).

tff(pred_def_88167,type,
    v146613: state_type > $o ).

tff(pred_def_88168,type,
    v146611: state_type > $o ).

tff(pred_def_88169,type,
    v146609: state_type > $o ).

tff(pred_def_88170,type,
    v146635: state_type > $o ).

tff(pred_def_88171,type,
    v146633: state_type > $o ).

tff(pred_def_88172,type,
    v146631: state_type > $o ).

tff(pred_def_88173,type,
    v146629: state_type > $o ).

tff(pred_def_88174,type,
    v146627: state_type > $o ).

tff(pred_def_88175,type,
    v146625: state_type > $o ).

tff(pred_def_88176,type,
    v146623: state_type > $o ).

tff(pred_def_88177,type,
    v146655: state_type > $o ).

tff(pred_def_88178,type,
    v146653: state_type > $o ).

tff(pred_def_88179,type,
    v146651: state_type > $o ).

tff(pred_def_88180,type,
    v146649: state_type > $o ).

tff(pred_def_88181,type,
    v146647: state_type > $o ).

tff(pred_def_88182,type,
    v146665: state_type > $o ).

tff(pred_def_88183,type,
    v146663: state_type > $o ).

tff(pred_def_88184,type,
    v146661: state_type > $o ).

tff(pred_def_88185,type,
    v146659: state_type > $o ).

tff(pred_def_88186,type,
    v146657: state_type > $o ).

tff(pred_def_88187,type,
    v146673: state_type > $o ).

tff(pred_def_88188,type,
    v146675: ( state_type * $int ) > $o ).

tff(pred_def_88189,type,
    v146671: ( state_type * $int ) > $o ).

tff(pred_def_88190,type,
    v146678: ( state_type * $int ) > $o ).

tff(pred_def_88191,type,
    v146677: ( state_type * $int ) > $o ).

tff(pred_def_88192,type,
    v146679: ( state_type * $int ) > $o ).

tff(pred_def_88193,type,
    v146680: ( state_type * $int ) > $o ).

tff(pred_def_88194,type,
    v146681: ( state_type * $int ) > $o ).

tff(pred_def_88195,type,
    v146669: ( state_type * $int ) > $o ).

tff(pred_def_88196,type,
    v146667: ( state_type * $int ) > $o ).

tff(pred_def_88197,type,
    v146693: state_type > $o ).

tff(pred_def_88198,type,
    v146691: state_type > $o ).

tff(pred_def_88199,type,
    v146689: state_type > $o ).

tff(pred_def_88200,type,
    v146703: state_type > $o ).

tff(pred_def_88201,type,
    v146701: state_type > $o ).

tff(pred_def_88202,type,
    v146699: state_type > $o ).

tff(pred_def_88203,type,
    v146697: state_type > $o ).

tff(pred_def_88204,type,
    v146695: state_type > $o ).

tff(pred_def_88205,type,
    v146705: state_type > $o ).

tff(pred_def_88206,type,
    v146687: state_type > $o ).

tff(pred_def_88207,type,
    v146685: state_type > $o ).

tff(pred_def_88208,type,
    v146683: state_type > $o ).

tff(pred_def_88209,type,
    v146712: state_type > $o ).

tff(pred_def_88210,type,
    v146710: state_type > $o ).

tff(pred_def_88211,type,
    v146709: state_type > $o ).

tff(pred_def_88212,type,
    v146708: state_type > $o ).

tff(pred_def_88213,type,
    v146720: state_type > $o ).

tff(pred_def_88214,type,
    v146721: state_type > $o ).

tff(pred_def_88215,type,
    v146719: state_type > $o ).

tff(pred_def_88216,type,
    v146716: ( state_type * $int ) > $o ).

tff(pred_def_88217,type,
    v146718: ( state_type * $int ) > $o ).

tff(pred_def_88218,type,
    v146707: ( state_type * $int ) > $o ).

tff(pred_def_88219,type,
    v146645: ( state_type * $int ) > $o ).

tff(pred_def_88220,type,
    v146643: ( state_type * $int ) > $o ).

tff(pred_def_88221,type,
    v146641: ( state_type * $int ) > $o ).

tff(pred_def_88222,type,
    v146725: ( state_type * $int ) > $o ).

tff(pred_def_88223,type,
    v146724: ( state_type * $int ) > $o ).

tff(pred_def_88224,type,
    v146726: ( state_type * $int ) > $o ).

tff(pred_def_88225,type,
    v146727: ( state_type * $int ) > $o ).

tff(pred_def_88226,type,
    v146728: ( state_type * $int ) > $o ).

tff(pred_def_88227,type,
    v146639: ( state_type * $int ) > $o ).

tff(pred_def_88228,type,
    v146637: ( state_type * $int ) > $o ).

tff(pred_def_88229,type,
    v146738: state_type > $o ).

tff(pred_def_88230,type,
    v146736: state_type > $o ).

tff(pred_def_88231,type,
    v146744: state_type > $o ).

tff(pred_def_88232,type,
    v146742: state_type > $o ).

tff(pred_def_88233,type,
    v146758: state_type > $o ).

tff(pred_def_88234,type,
    v146756: state_type > $o ).

tff(pred_def_88235,type,
    v146754: state_type > $o ).

tff(pred_def_88236,type,
    v146752: state_type > $o ).

tff(pred_def_88237,type,
    v146750: state_type > $o ).

tff(pred_def_88238,type,
    v146748: state_type > $o ).

tff(pred_def_88239,type,
    v146746: state_type > $o ).

tff(pred_def_88240,type,
    v146766: state_type > $o ).

tff(pred_def_88241,type,
    v146764: state_type > $o ).

tff(pred_def_88242,type,
    v146762: state_type > $o ).

tff(pred_def_88243,type,
    v146760: state_type > $o ).

tff(pred_def_88244,type,
    v146740: state_type > $o ).

tff(pred_def_88245,type,
    v146772: state_type > $o ).

tff(pred_def_88246,type,
    v146774: state_type > $o ).

tff(pred_def_88247,type,
    v146770: state_type > $o ).

tff(pred_def_88248,type,
    v146769: state_type > $o ).

tff(pred_def_88249,type,
    v146780: state_type > $o ).

tff(pred_def_88250,type,
    v146781: state_type > $o ).

tff(pred_def_88251,type,
    v146777: state_type > $o ).

tff(pred_def_88252,type,
    v146779: state_type > $o ).

tff(pred_def_88253,type,
    v146787: state_type > $o ).

tff(pred_def_88254,type,
    v146785: state_type > $o ).

tff(pred_def_88255,type,
    v146789: state_type > $o ).

tff(pred_def_88256,type,
    v146734: state_type > $o ).

tff(pred_def_88257,type,
    v146732: state_type > $o ).

tff(pred_def_88258,type,
    v146730: state_type > $o ).

tff(pred_def_88259,type,
    v146796: state_type > $o ).

tff(pred_def_88260,type,
    v146794: state_type > $o ).

tff(pred_def_88261,type,
    v146793: state_type > $o ).

tff(pred_def_88262,type,
    v146792: state_type > $o ).

tff(pred_def_88263,type,
    v146804: state_type > $o ).

tff(pred_def_88264,type,
    v146805: state_type > $o ).

tff(pred_def_88265,type,
    v146803: state_type > $o ).

tff(pred_def_88266,type,
    v146800: ( state_type * $int ) > $o ).

tff(pred_def_88267,type,
    v146802: ( state_type * $int ) > $o ).

tff(pred_def_88268,type,
    v146791: ( state_type * $int ) > $o ).

tff(pred_def_88269,type,
    v146607: ( state_type * $int ) > $o ).

tff(pred_def_88270,type,
    v146605: ( state_type * $int ) > $o ).

tff(pred_def_88271,type,
    v146603: ( state_type * $int ) > $o ).

tff(pred_def_88272,type,
    v146809: ( state_type * $int ) > $o ).

tff(pred_def_88273,type,
    v146808: ( state_type * $int ) > $o ).

tff(pred_def_88274,type,
    v146810: ( state_type * $int ) > $o ).

tff(pred_def_88275,type,
    v146811: ( state_type * $int ) > $o ).

tff(pred_def_88276,type,
    v146812: ( state_type * $int ) > $o ).

tff(pred_def_88277,type,
    v146601: ( state_type * $int ) > $o ).

tff(pred_def_88278,type,
    v146599: ( state_type * $int ) > $o ).

tff(pred_def_88279,type,
    v146843: state_type > $o ).

tff(pred_def_88280,type,
    v146842: state_type > $o ).

tff(pred_def_88281,type,
    v146841: state_type > $o ).

tff(pred_def_88282,type,
    v146846: state_type > $o ).

tff(pred_def_88283,type,
    v146845: state_type > $o ).

tff(pred_def_88284,type,
    v146844: state_type > $o ).

tff(pred_def_88285,type,
    v146849: state_type > $o ).

tff(pred_def_88286,type,
    v146848: state_type > $o ).

tff(pred_def_88287,type,
    v146847: state_type > $o ).

tff(pred_def_88288,type,
    v146855: state_type > $o ).

tff(pred_def_88289,type,
    v146853: state_type > $o ).

tff(pred_def_88290,type,
    v146852: state_type > $o ).

tff(pred_def_88291,type,
    v146851: ( state_type * $int ) > $o ).

tff(pred_def_88292,type,
    v146859: state_type > $o ).

tff(pred_def_88293,type,
    v146860: state_type > $o ).

tff(pred_def_88294,type,
    v146861: state_type > $o ).

tff(pred_def_88295,type,
    v146862: state_type > $o ).

tff(pred_def_88296,type,
    v146863: state_type > $o ).

tff(pred_def_88297,type,
    v146864: state_type > $o ).

tff(pred_def_88298,type,
    v146865: state_type > $o ).

tff(pred_def_88299,type,
    v146866: state_type > $o ).

tff(pred_def_88300,type,
    v146858: ( state_type * $int ) > $o ).

tff(pred_def_88301,type,
    v146838: ( state_type * $int ) > $o ).

tff(pred_def_88302,type,
    v146874: state_type > $o ).

tff(pred_def_88303,type,
    v146872: state_type > $o ).

tff(pred_def_88304,type,
    v146871: state_type > $o ).

tff(pred_def_88305,type,
    v146870: ( state_type * $int ) > $o ).

tff(pred_def_88306,type,
    v146878: state_type > $o ).

tff(pred_def_88307,type,
    v146879: state_type > $o ).

tff(pred_def_88308,type,
    v146880: state_type > $o ).

tff(pred_def_88309,type,
    v146881: state_type > $o ).

tff(pred_def_88310,type,
    v146882: state_type > $o ).

tff(pred_def_88311,type,
    v146883: state_type > $o ).

tff(pred_def_88312,type,
    v146884: state_type > $o ).

tff(pred_def_88313,type,
    v146885: state_type > $o ).

tff(pred_def_88314,type,
    v146877: ( state_type * $int ) > $o ).

tff(pred_def_88315,type,
    v146868: ( state_type * $int ) > $o ).

tff(pred_def_88316,type,
    v146893: state_type > $o ).

tff(pred_def_88317,type,
    v146891: state_type > $o ).

tff(pred_def_88318,type,
    v146890: state_type > $o ).

tff(pred_def_88319,type,
    v146889: ( state_type * $int ) > $o ).

tff(pred_def_88320,type,
    v146897: state_type > $o ).

tff(pred_def_88321,type,
    v146898: state_type > $o ).

tff(pred_def_88322,type,
    v146899: state_type > $o ).

tff(pred_def_88323,type,
    v146900: state_type > $o ).

tff(pred_def_88324,type,
    v146901: state_type > $o ).

tff(pred_def_88325,type,
    v146902: state_type > $o ).

tff(pred_def_88326,type,
    v146903: state_type > $o ).

tff(pred_def_88327,type,
    v146904: state_type > $o ).

tff(pred_def_88328,type,
    v146896: ( state_type * $int ) > $o ).

tff(pred_def_88329,type,
    v146887: ( state_type * $int ) > $o ).

tff(pred_def_88330,type,
    v146912: state_type > $o ).

tff(pred_def_88331,type,
    v146910: state_type > $o ).

tff(pred_def_88332,type,
    v146909: state_type > $o ).

tff(pred_def_88333,type,
    v146908: ( state_type * $int ) > $o ).

tff(pred_def_88334,type,
    v146916: state_type > $o ).

tff(pred_def_88335,type,
    v146917: state_type > $o ).

tff(pred_def_88336,type,
    v146918: state_type > $o ).

tff(pred_def_88337,type,
    v146919: state_type > $o ).

tff(pred_def_88338,type,
    v146920: state_type > $o ).

tff(pred_def_88339,type,
    v146921: state_type > $o ).

tff(pred_def_88340,type,
    v146922: state_type > $o ).

tff(pred_def_88341,type,
    v146923: state_type > $o ).

tff(pred_def_88342,type,
    v146915: ( state_type * $int ) > $o ).

tff(pred_def_88343,type,
    v146906: ( state_type * $int ) > $o ).

tff(pred_def_88344,type,
    v146931: state_type > $o ).

tff(pred_def_88345,type,
    v146929: state_type > $o ).

tff(pred_def_88346,type,
    v146928: state_type > $o ).

tff(pred_def_88347,type,
    v146927: ( state_type * $int ) > $o ).

tff(pred_def_88348,type,
    v146935: state_type > $o ).

tff(pred_def_88349,type,
    v146936: state_type > $o ).

tff(pred_def_88350,type,
    v146937: state_type > $o ).

tff(pred_def_88351,type,
    v146938: state_type > $o ).

tff(pred_def_88352,type,
    v146939: state_type > $o ).

tff(pred_def_88353,type,
    v146940: state_type > $o ).

tff(pred_def_88354,type,
    v146941: state_type > $o ).

tff(pred_def_88355,type,
    v146942: state_type > $o ).

tff(pred_def_88356,type,
    v146934: ( state_type * $int ) > $o ).

tff(pred_def_88357,type,
    v146925: ( state_type * $int ) > $o ).

tff(pred_def_88358,type,
    v146950: state_type > $o ).

tff(pred_def_88359,type,
    v146948: state_type > $o ).

tff(pred_def_88360,type,
    v146947: state_type > $o ).

tff(pred_def_88361,type,
    v146946: ( state_type * $int ) > $o ).

tff(pred_def_88362,type,
    v146954: state_type > $o ).

tff(pred_def_88363,type,
    v146955: state_type > $o ).

tff(pred_def_88364,type,
    v146956: state_type > $o ).

tff(pred_def_88365,type,
    v146957: state_type > $o ).

tff(pred_def_88366,type,
    v146958: state_type > $o ).

tff(pred_def_88367,type,
    v146959: state_type > $o ).

tff(pred_def_88368,type,
    v146960: state_type > $o ).

tff(pred_def_88369,type,
    v146961: state_type > $o ).

tff(pred_def_88370,type,
    v146953: ( state_type * $int ) > $o ).

tff(pred_def_88371,type,
    v146944: ( state_type * $int ) > $o ).

tff(pred_def_88372,type,
    v146969: state_type > $o ).

tff(pred_def_88373,type,
    v146967: state_type > $o ).

tff(pred_def_88374,type,
    v146966: state_type > $o ).

tff(pred_def_88375,type,
    v146965: ( state_type * $int ) > $o ).

tff(pred_def_88376,type,
    v146973: state_type > $o ).

tff(pred_def_88377,type,
    v146974: state_type > $o ).

tff(pred_def_88378,type,
    v146975: state_type > $o ).

tff(pred_def_88379,type,
    v146976: state_type > $o ).

tff(pred_def_88380,type,
    v146977: state_type > $o ).

tff(pred_def_88381,type,
    v146978: state_type > $o ).

tff(pred_def_88382,type,
    v146979: state_type > $o ).

tff(pred_def_88383,type,
    v146980: state_type > $o ).

tff(pred_def_88384,type,
    v146972: ( state_type * $int ) > $o ).

tff(pred_def_88385,type,
    v146963: ( state_type * $int ) > $o ).

tff(pred_def_88386,type,
    v146988: state_type > $o ).

tff(pred_def_88387,type,
    v146986: state_type > $o ).

tff(pred_def_88388,type,
    v146985: state_type > $o ).

tff(pred_def_88389,type,
    v146984: ( state_type * $int ) > $o ).

tff(pred_def_88390,type,
    v146992: state_type > $o ).

tff(pred_def_88391,type,
    v146993: state_type > $o ).

tff(pred_def_88392,type,
    v146994: state_type > $o ).

tff(pred_def_88393,type,
    v146995: state_type > $o ).

tff(pred_def_88394,type,
    v146996: state_type > $o ).

tff(pred_def_88395,type,
    v146997: state_type > $o ).

tff(pred_def_88396,type,
    v146998: state_type > $o ).

tff(pred_def_88397,type,
    v146999: state_type > $o ).

tff(pred_def_88398,type,
    v146991: ( state_type * $int ) > $o ).

tff(pred_def_88399,type,
    v146982: ( state_type * $int ) > $o ).

tff(pred_def_88400,type,
    v147010: state_type > $o ).

tff(pred_def_88401,type,
    v147009: ( state_type * $int ) > $o ).

tff(pred_def_88402,type,
    v147008: ( state_type * $int ) > $o ).

tff(pred_def_88403,type,
    v147013: state_type > $o ).

tff(pred_def_88404,type,
    v147012: ( state_type * $int ) > $o ).

tff(pred_def_88405,type,
    v147011: ( state_type * $int ) > $o ).

tff(pred_def_88406,type,
    v147007: ( state_type * $int ) > $o ).

tff(pred_def_88407,type,
    v147016: state_type > $o ).

tff(pred_def_88408,type,
    v147015: ( state_type * $int ) > $o ).

tff(pred_def_88409,type,
    v147014: ( state_type * $int ) > $o ).

tff(pred_def_88410,type,
    v147006: ( state_type * $int ) > $o ).

tff(pred_def_88411,type,
    v147019: state_type > $o ).

tff(pred_def_88412,type,
    v147018: ( state_type * $int ) > $o ).

tff(pred_def_88413,type,
    v147017: ( state_type * $int ) > $o ).

tff(pred_def_88414,type,
    v147005: ( state_type * $int ) > $o ).

tff(pred_def_88415,type,
    v147022: state_type > $o ).

tff(pred_def_88416,type,
    v147021: ( state_type * $int ) > $o ).

tff(pred_def_88417,type,
    v147020: ( state_type * $int ) > $o ).

tff(pred_def_88418,type,
    v147004: ( state_type * $int ) > $o ).

tff(pred_def_88419,type,
    v147025: state_type > $o ).

tff(pred_def_88420,type,
    v147024: ( state_type * $int ) > $o ).

tff(pred_def_88421,type,
    v147023: ( state_type * $int ) > $o ).

tff(pred_def_88422,type,
    v147003: ( state_type * $int ) > $o ).

tff(pred_def_88423,type,
    v147028: state_type > $o ).

tff(pred_def_88424,type,
    v147027: ( state_type * $int ) > $o ).

tff(pred_def_88425,type,
    v147026: ( state_type * $int ) > $o ).

tff(pred_def_88426,type,
    v147002: ( state_type * $int ) > $o ).

tff(pred_def_88427,type,
    v147031: state_type > $o ).

tff(pred_def_88428,type,
    v147030: ( state_type * $int ) > $o ).

tff(pred_def_88429,type,
    v147029: ( state_type * $int ) > $o ).

tff(pred_def_88430,type,
    v147001: ( state_type * $int ) > $o ).

tff(pred_def_88431,type,
    v147034: state_type > $o ).

tff(pred_def_88432,type,
    v147033: state_type > $o ).

tff(pred_def_88433,type,
    v147032: ( state_type * $int ) > $o ).

tff(pred_def_88434,type,
    v147000: ( state_type * $int ) > $o ).

tff(pred_def_88435,type,
    v146836: ( state_type * $int ) > $o ).

tff(pred_def_88436,type,
    v146834: ( state_type * $int ) > $o ).

tff(pred_def_88437,type,
    v146832: ( state_type * $int ) > $o ).

tff(pred_def_88438,type,
    v147035: ( state_type * $int ) > $o ).

tff(pred_def_88439,type,
    v146830: ( state_type * $int ) > $o ).

tff(pred_def_88440,type,
    v146828: ( state_type * $int ) > $o ).

tff(pred_def_88441,type,
    v146826: ( state_type * $int ) > $o ).

tff(pred_def_88442,type,
    v146824: ( state_type * $int ) > $o ).

tff(pred_def_88443,type,
    v146822: state_type > $o ).

tff(pred_def_88444,type,
    v146820: state_type > $o ).

tff(pred_def_88445,type,
    v146818: state_type > $o ).

tff(pred_def_88446,type,
    v146816: state_type > $o ).

tff(pred_def_88447,type,
    v146814: state_type > $o ).

tff(pred_def_88448,type,
    v147055: state_type > $o ).

tff(pred_def_88449,type,
    v147053: state_type > $o ).

tff(pred_def_88450,type,
    v147051: state_type > $o ).

tff(pred_def_88451,type,
    v147049: state_type > $o ).

tff(pred_def_88452,type,
    v147047: state_type > $o ).

tff(pred_def_88453,type,
    v147065: state_type > $o ).

tff(pred_def_88454,type,
    v147063: state_type > $o ).

tff(pred_def_88455,type,
    v147061: state_type > $o ).

tff(pred_def_88456,type,
    v147059: state_type > $o ).

tff(pred_def_88457,type,
    v147057: state_type > $o ).

tff(pred_def_88458,type,
    v147070: ( state_type * $int ) > $o ).

tff(pred_def_88459,type,
    v147069: ( state_type * $int ) > $o ).

tff(pred_def_88460,type,
    v147067: ( state_type * $int ) > $o ).

tff(pred_def_88461,type,
    v147080: state_type > $o ).

tff(pred_def_88462,type,
    v147078: state_type > $o ).

tff(pred_def_88463,type,
    v147086: state_type > $o ).

tff(pred_def_88464,type,
    v147084: state_type > $o ).

tff(pred_def_88465,type,
    v147100: state_type > $o ).

tff(pred_def_88466,type,
    v147098: state_type > $o ).

tff(pred_def_88467,type,
    v147096: state_type > $o ).

tff(pred_def_88468,type,
    v147094: state_type > $o ).

tff(pred_def_88469,type,
    v147092: state_type > $o ).

tff(pred_def_88470,type,
    v147090: state_type > $o ).

tff(pred_def_88471,type,
    v147088: state_type > $o ).

tff(pred_def_88472,type,
    v147104: state_type > $o ).

tff(pred_def_88473,type,
    v147102: state_type > $o ).

tff(pred_def_88474,type,
    v147082: state_type > $o ).

tff(pred_def_88475,type,
    v147110: state_type > $o ).

tff(pred_def_88476,type,
    v147112: state_type > $o ).

tff(pred_def_88477,type,
    v147108: state_type > $o ).

tff(pred_def_88478,type,
    v147107: state_type > $o ).

tff(pred_def_88479,type,
    v147118: state_type > $o ).

tff(pred_def_88480,type,
    v147119: state_type > $o ).

tff(pred_def_88481,type,
    v147115: state_type > $o ).

tff(pred_def_88482,type,
    v147117: state_type > $o ).

tff(pred_def_88483,type,
    v147125: state_type > $o ).

tff(pred_def_88484,type,
    v147123: state_type > $o ).

tff(pred_def_88485,type,
    v147127: state_type > $o ).

tff(pred_def_88486,type,
    v147076: state_type > $o ).

tff(pred_def_88487,type,
    v147074: state_type > $o ).

tff(pred_def_88488,type,
    v147072: state_type > $o ).

tff(pred_def_88489,type,
    v147134: state_type > $o ).

tff(pred_def_88490,type,
    v147132: state_type > $o ).

tff(pred_def_88491,type,
    v147131: state_type > $o ).

tff(pred_def_88492,type,
    v147130: state_type > $o ).

tff(pred_def_88493,type,
    v147142: state_type > $o ).

tff(pred_def_88494,type,
    v147143: state_type > $o ).

tff(pred_def_88495,type,
    v147141: state_type > $o ).

tff(pred_def_88496,type,
    v147138: ( state_type * $int ) > $o ).

tff(pred_def_88497,type,
    v147140: ( state_type * $int ) > $o ).

tff(pred_def_88498,type,
    v147129: ( state_type * $int ) > $o ).

tff(pred_def_88499,type,
    v147045: ( state_type * $int ) > $o ).

tff(pred_def_88500,type,
    v147043: ( state_type * $int ) > $o ).

tff(pred_def_88501,type,
    v147041: ( state_type * $int ) > $o ).

tff(pred_def_88502,type,
    v147147: ( state_type * $int ) > $o ).

tff(pred_def_88503,type,
    v147146: ( state_type * $int ) > $o ).

tff(pred_def_88504,type,
    v147148: ( state_type * $int ) > $o ).

tff(pred_def_88505,type,
    v147149: ( state_type * $int ) > $o ).

tff(pred_def_88506,type,
    v147150: ( state_type * $int ) > $o ).

tff(pred_def_88507,type,
    v147039: ( state_type * $int ) > $o ).

tff(pred_def_88508,type,
    v147037: ( state_type * $int ) > $o ).

tff(pred_def_88509,type,
    v147160: state_type > $o ).

tff(pred_def_88510,type,
    v147158: state_type > $o ).

tff(pred_def_88511,type,
    v147156: state_type > $o ).

tff(pred_def_88512,type,
    v147154: state_type > $o ).

tff(pred_def_88513,type,
    v147152: state_type > $o ).

tff(pred_def_88514,type,
    v147180: state_type > $o ).

tff(pred_def_88515,type,
    v147178: state_type > $o ).

tff(pred_def_88516,type,
    v147176: state_type > $o ).

tff(pred_def_88517,type,
    v147174: state_type > $o ).

tff(pred_def_88518,type,
    v147172: state_type > $o ).

tff(pred_def_88519,type,
    v147190: state_type > $o ).

tff(pred_def_88520,type,
    v147188: state_type > $o ).

tff(pred_def_88521,type,
    v147186: state_type > $o ).

tff(pred_def_88522,type,
    v147184: state_type > $o ).

tff(pred_def_88523,type,
    v147182: state_type > $o ).

tff(pred_def_88524,type,
    v147195: ( state_type * $int ) > $o ).

tff(pred_def_88525,type,
    v147194: ( state_type * $int ) > $o ).

tff(pred_def_88526,type,
    v147192: ( state_type * $int ) > $o ).

tff(pred_def_88527,type,
    v147205: state_type > $o ).

tff(pred_def_88528,type,
    v147203: state_type > $o ).

tff(pred_def_88529,type,
    v147211: state_type > $o ).

tff(pred_def_88530,type,
    v147209: state_type > $o ).

tff(pred_def_88531,type,
    v147225: state_type > $o ).

tff(pred_def_88532,type,
    v147223: state_type > $o ).

tff(pred_def_88533,type,
    v147221: state_type > $o ).

tff(pred_def_88534,type,
    v147219: state_type > $o ).

tff(pred_def_88535,type,
    v147217: state_type > $o ).

tff(pred_def_88536,type,
    v147215: state_type > $o ).

tff(pred_def_88537,type,
    v147213: state_type > $o ).

tff(pred_def_88538,type,
    v147229: state_type > $o ).

tff(pred_def_88539,type,
    v147227: state_type > $o ).

tff(pred_def_88540,type,
    v147207: state_type > $o ).

tff(pred_def_88541,type,
    v147235: state_type > $o ).

tff(pred_def_88542,type,
    v147237: state_type > $o ).

tff(pred_def_88543,type,
    v147233: state_type > $o ).

tff(pred_def_88544,type,
    v147232: state_type > $o ).

tff(pred_def_88545,type,
    v147243: state_type > $o ).

tff(pred_def_88546,type,
    v147244: state_type > $o ).

tff(pred_def_88547,type,
    v147240: state_type > $o ).

tff(pred_def_88548,type,
    v147242: state_type > $o ).

tff(pred_def_88549,type,
    v147250: state_type > $o ).

tff(pred_def_88550,type,
    v147248: state_type > $o ).

tff(pred_def_88551,type,
    v147252: state_type > $o ).

tff(pred_def_88552,type,
    v147201: state_type > $o ).

tff(pred_def_88553,type,
    v147199: state_type > $o ).

tff(pred_def_88554,type,
    v147197: state_type > $o ).

tff(pred_def_88555,type,
    v147259: state_type > $o ).

tff(pred_def_88556,type,
    v147257: state_type > $o ).

tff(pred_def_88557,type,
    v147256: state_type > $o ).

tff(pred_def_88558,type,
    v147255: state_type > $o ).

tff(pred_def_88559,type,
    v147267: state_type > $o ).

tff(pred_def_88560,type,
    v147268: state_type > $o ).

tff(pred_def_88561,type,
    v147266: state_type > $o ).

tff(pred_def_88562,type,
    v147263: ( state_type * $int ) > $o ).

tff(pred_def_88563,type,
    v147265: ( state_type * $int ) > $o ).

tff(pred_def_88564,type,
    v147254: ( state_type * $int ) > $o ).

tff(pred_def_88565,type,
    v147170: ( state_type * $int ) > $o ).

tff(pred_def_88566,type,
    v147168: ( state_type * $int ) > $o ).

tff(pred_def_88567,type,
    v147166: ( state_type * $int ) > $o ).

tff(pred_def_88568,type,
    v147272: ( state_type * $int ) > $o ).

tff(pred_def_88569,type,
    v147271: ( state_type * $int ) > $o ).

tff(pred_def_88570,type,
    v147273: ( state_type * $int ) > $o ).

tff(pred_def_88571,type,
    v147274: ( state_type * $int ) > $o ).

tff(pred_def_88572,type,
    v147275: ( state_type * $int ) > $o ).

tff(pred_def_88573,type,
    v147164: ( state_type * $int ) > $o ).

tff(pred_def_88574,type,
    v147162: ( state_type * $int ) > $o ).

tff(pred_def_88575,type,
    v147285: state_type > $o ).

tff(pred_def_88576,type,
    v147283: state_type > $o ).

tff(pred_def_88577,type,
    v147281: state_type > $o ).

tff(pred_def_88578,type,
    v147279: state_type > $o ).

tff(pred_def_88579,type,
    v147277: state_type > $o ).

tff(pred_def_88580,type,
    v147305: state_type > $o ).

tff(pred_def_88581,type,
    v147303: state_type > $o ).

tff(pred_def_88582,type,
    v147301: state_type > $o ).

tff(pred_def_88583,type,
    v147299: state_type > $o ).

tff(pred_def_88584,type,
    v147297: state_type > $o ).

tff(pred_def_88585,type,
    v147315: state_type > $o ).

tff(pred_def_88586,type,
    v147313: state_type > $o ).

tff(pred_def_88587,type,
    v147311: state_type > $o ).

tff(pred_def_88588,type,
    v147309: state_type > $o ).

tff(pred_def_88589,type,
    v147307: state_type > $o ).

tff(pred_def_88590,type,
    v147320: ( state_type * $int ) > $o ).

tff(pred_def_88591,type,
    v147319: ( state_type * $int ) > $o ).

tff(pred_def_88592,type,
    v147317: ( state_type * $int ) > $o ).

tff(pred_def_88593,type,
    v147330: state_type > $o ).

tff(pred_def_88594,type,
    v147328: state_type > $o ).

tff(pred_def_88595,type,
    v147336: state_type > $o ).

tff(pred_def_88596,type,
    v147334: state_type > $o ).

tff(pred_def_88597,type,
    v147350: state_type > $o ).

tff(pred_def_88598,type,
    v147348: state_type > $o ).

tff(pred_def_88599,type,
    v147346: state_type > $o ).

tff(pred_def_88600,type,
    v147344: state_type > $o ).

tff(pred_def_88601,type,
    v147342: state_type > $o ).

tff(pred_def_88602,type,
    v147340: state_type > $o ).

tff(pred_def_88603,type,
    v147338: state_type > $o ).

tff(pred_def_88604,type,
    v147354: state_type > $o ).

tff(pred_def_88605,type,
    v147352: state_type > $o ).

tff(pred_def_88606,type,
    v147332: state_type > $o ).

tff(pred_def_88607,type,
    v147360: state_type > $o ).

tff(pred_def_88608,type,
    v147362: state_type > $o ).

tff(pred_def_88609,type,
    v147358: state_type > $o ).

tff(pred_def_88610,type,
    v147357: state_type > $o ).

tff(pred_def_88611,type,
    v147368: state_type > $o ).

tff(pred_def_88612,type,
    v147369: state_type > $o ).

tff(pred_def_88613,type,
    v147365: state_type > $o ).

tff(pred_def_88614,type,
    v147367: state_type > $o ).

tff(pred_def_88615,type,
    v147375: state_type > $o ).

tff(pred_def_88616,type,
    v147373: state_type > $o ).

tff(pred_def_88617,type,
    v147377: state_type > $o ).

tff(pred_def_88618,type,
    v147326: state_type > $o ).

tff(pred_def_88619,type,
    v147324: state_type > $o ).

tff(pred_def_88620,type,
    v147322: state_type > $o ).

tff(pred_def_88621,type,
    v147384: state_type > $o ).

tff(pred_def_88622,type,
    v147382: state_type > $o ).

tff(pred_def_88623,type,
    v147381: state_type > $o ).

tff(pred_def_88624,type,
    v147380: state_type > $o ).

tff(pred_def_88625,type,
    v147392: state_type > $o ).

tff(pred_def_88626,type,
    v147393: state_type > $o ).

tff(pred_def_88627,type,
    v147391: state_type > $o ).

tff(pred_def_88628,type,
    v147388: ( state_type * $int ) > $o ).

tff(pred_def_88629,type,
    v147390: ( state_type * $int ) > $o ).

tff(pred_def_88630,type,
    v147379: ( state_type * $int ) > $o ).

tff(pred_def_88631,type,
    v147295: ( state_type * $int ) > $o ).

tff(pred_def_88632,type,
    v147293: ( state_type * $int ) > $o ).

tff(pred_def_88633,type,
    v147291: ( state_type * $int ) > $o ).

tff(pred_def_88634,type,
    v147397: ( state_type * $int ) > $o ).

tff(pred_def_88635,type,
    v147396: ( state_type * $int ) > $o ).

tff(pred_def_88636,type,
    v147398: ( state_type * $int ) > $o ).

tff(pred_def_88637,type,
    v147399: ( state_type * $int ) > $o ).

tff(pred_def_88638,type,
    v147400: ( state_type * $int ) > $o ).

tff(pred_def_88639,type,
    v147289: ( state_type * $int ) > $o ).

tff(pred_def_88640,type,
    v147287: ( state_type * $int ) > $o ).

tff(pred_def_88641,type,
    v147410: state_type > $o ).

tff(pred_def_88642,type,
    v147408: state_type > $o ).

tff(pred_def_88643,type,
    v147406: state_type > $o ).

tff(pred_def_88644,type,
    v147404: state_type > $o ).

tff(pred_def_88645,type,
    v147402: state_type > $o ).

tff(pred_def_88646,type,
    v147430: state_type > $o ).

tff(pred_def_88647,type,
    v147428: state_type > $o ).

tff(pred_def_88648,type,
    v147426: state_type > $o ).

tff(pred_def_88649,type,
    v147424: state_type > $o ).

tff(pred_def_88650,type,
    v147422: state_type > $o ).

tff(pred_def_88651,type,
    v147440: state_type > $o ).

tff(pred_def_88652,type,
    v147438: state_type > $o ).

tff(pred_def_88653,type,
    v147436: state_type > $o ).

tff(pred_def_88654,type,
    v147434: state_type > $o ).

tff(pred_def_88655,type,
    v147432: state_type > $o ).

tff(pred_def_88656,type,
    v147445: ( state_type * $int ) > $o ).

tff(pred_def_88657,type,
    v147444: ( state_type * $int ) > $o ).

tff(pred_def_88658,type,
    v147442: ( state_type * $int ) > $o ).

tff(pred_def_88659,type,
    v147455: state_type > $o ).

tff(pred_def_88660,type,
    v147453: state_type > $o ).

tff(pred_def_88661,type,
    v147461: state_type > $o ).

tff(pred_def_88662,type,
    v147459: state_type > $o ).

tff(pred_def_88663,type,
    v147475: state_type > $o ).

tff(pred_def_88664,type,
    v147473: state_type > $o ).

tff(pred_def_88665,type,
    v147471: state_type > $o ).

tff(pred_def_88666,type,
    v147469: state_type > $o ).

tff(pred_def_88667,type,
    v147467: state_type > $o ).

tff(pred_def_88668,type,
    v147465: state_type > $o ).

tff(pred_def_88669,type,
    v147463: state_type > $o ).

tff(pred_def_88670,type,
    v147479: state_type > $o ).

tff(pred_def_88671,type,
    v147477: state_type > $o ).

tff(pred_def_88672,type,
    v147457: state_type > $o ).

tff(pred_def_88673,type,
    v147485: state_type > $o ).

tff(pred_def_88674,type,
    v147487: state_type > $o ).

tff(pred_def_88675,type,
    v147483: state_type > $o ).

tff(pred_def_88676,type,
    v147482: state_type > $o ).

tff(pred_def_88677,type,
    v147493: state_type > $o ).

tff(pred_def_88678,type,
    v147494: state_type > $o ).

tff(pred_def_88679,type,
    v147490: state_type > $o ).

tff(pred_def_88680,type,
    v147492: state_type > $o ).

tff(pred_def_88681,type,
    v147500: state_type > $o ).

tff(pred_def_88682,type,
    v147498: state_type > $o ).

tff(pred_def_88683,type,
    v147502: state_type > $o ).

tff(pred_def_88684,type,
    v147451: state_type > $o ).

tff(pred_def_88685,type,
    v147449: state_type > $o ).

tff(pred_def_88686,type,
    v147447: state_type > $o ).

tff(pred_def_88687,type,
    v147509: state_type > $o ).

tff(pred_def_88688,type,
    v147507: state_type > $o ).

tff(pred_def_88689,type,
    v147506: state_type > $o ).

tff(pred_def_88690,type,
    v147505: state_type > $o ).

tff(pred_def_88691,type,
    v147517: state_type > $o ).

tff(pred_def_88692,type,
    v147518: state_type > $o ).

tff(pred_def_88693,type,
    v147516: state_type > $o ).

tff(pred_def_88694,type,
    v147513: ( state_type * $int ) > $o ).

tff(pred_def_88695,type,
    v147515: ( state_type * $int ) > $o ).

tff(pred_def_88696,type,
    v147504: ( state_type * $int ) > $o ).

tff(pred_def_88697,type,
    v147420: ( state_type * $int ) > $o ).

tff(pred_def_88698,type,
    v147418: ( state_type * $int ) > $o ).

tff(pred_def_88699,type,
    v147416: ( state_type * $int ) > $o ).

tff(pred_def_88700,type,
    v147522: ( state_type * $int ) > $o ).

tff(pred_def_88701,type,
    v147521: ( state_type * $int ) > $o ).

tff(pred_def_88702,type,
    v147523: ( state_type * $int ) > $o ).

tff(pred_def_88703,type,
    v147524: ( state_type * $int ) > $o ).

tff(pred_def_88704,type,
    v147525: ( state_type * $int ) > $o ).

tff(pred_def_88705,type,
    v147414: ( state_type * $int ) > $o ).

tff(pred_def_88706,type,
    v147412: ( state_type * $int ) > $o ).

tff(pred_def_88707,type,
    v147535: state_type > $o ).

tff(pred_def_88708,type,
    v147533: state_type > $o ).

tff(pred_def_88709,type,
    v147531: state_type > $o ).

tff(pred_def_88710,type,
    v147529: state_type > $o ).

tff(pred_def_88711,type,
    v147527: state_type > $o ).

tff(pred_def_88712,type,
    v147555: state_type > $o ).

tff(pred_def_88713,type,
    v147553: state_type > $o ).

tff(pred_def_88714,type,
    v147551: state_type > $o ).

tff(pred_def_88715,type,
    v147549: state_type > $o ).

tff(pred_def_88716,type,
    v147547: state_type > $o ).

tff(pred_def_88717,type,
    v147565: state_type > $o ).

tff(pred_def_88718,type,
    v147563: state_type > $o ).

tff(pred_def_88719,type,
    v147561: state_type > $o ).

tff(pred_def_88720,type,
    v147559: state_type > $o ).

tff(pred_def_88721,type,
    v147557: state_type > $o ).

tff(pred_def_88722,type,
    v147570: ( state_type * $int ) > $o ).

tff(pred_def_88723,type,
    v147569: ( state_type * $int ) > $o ).

tff(pred_def_88724,type,
    v147567: ( state_type * $int ) > $o ).

tff(pred_def_88725,type,
    v147580: state_type > $o ).

tff(pred_def_88726,type,
    v147578: state_type > $o ).

tff(pred_def_88727,type,
    v147586: state_type > $o ).

tff(pred_def_88728,type,
    v147584: state_type > $o ).

tff(pred_def_88729,type,
    v147600: state_type > $o ).

tff(pred_def_88730,type,
    v147598: state_type > $o ).

tff(pred_def_88731,type,
    v147596: state_type > $o ).

tff(pred_def_88732,type,
    v147594: state_type > $o ).

tff(pred_def_88733,type,
    v147592: state_type > $o ).

tff(pred_def_88734,type,
    v147590: state_type > $o ).

tff(pred_def_88735,type,
    v147588: state_type > $o ).

tff(pred_def_88736,type,
    v147604: state_type > $o ).

tff(pred_def_88737,type,
    v147602: state_type > $o ).

tff(pred_def_88738,type,
    v147582: state_type > $o ).

tff(pred_def_88739,type,
    v147610: state_type > $o ).

tff(pred_def_88740,type,
    v147612: state_type > $o ).

tff(pred_def_88741,type,
    v147608: state_type > $o ).

tff(pred_def_88742,type,
    v147607: state_type > $o ).

tff(pred_def_88743,type,
    v147618: state_type > $o ).

tff(pred_def_88744,type,
    v147619: state_type > $o ).

tff(pred_def_88745,type,
    v147615: state_type > $o ).

tff(pred_def_88746,type,
    v147617: state_type > $o ).

tff(pred_def_88747,type,
    v147625: state_type > $o ).

tff(pred_def_88748,type,
    v147623: state_type > $o ).

tff(pred_def_88749,type,
    v147627: state_type > $o ).

tff(pred_def_88750,type,
    v147576: state_type > $o ).

tff(pred_def_88751,type,
    v147574: state_type > $o ).

tff(pred_def_88752,type,
    v147572: state_type > $o ).

tff(pred_def_88753,type,
    v147634: state_type > $o ).

tff(pred_def_88754,type,
    v147632: state_type > $o ).

tff(pred_def_88755,type,
    v147631: state_type > $o ).

tff(pred_def_88756,type,
    v147630: state_type > $o ).

tff(pred_def_88757,type,
    v147642: state_type > $o ).

tff(pred_def_88758,type,
    v147643: state_type > $o ).

tff(pred_def_88759,type,
    v147641: state_type > $o ).

tff(pred_def_88760,type,
    v147638: ( state_type * $int ) > $o ).

tff(pred_def_88761,type,
    v147640: ( state_type * $int ) > $o ).

tff(pred_def_88762,type,
    v147629: ( state_type * $int ) > $o ).

tff(pred_def_88763,type,
    v147545: ( state_type * $int ) > $o ).

tff(pred_def_88764,type,
    v147543: ( state_type * $int ) > $o ).

tff(pred_def_88765,type,
    v147541: ( state_type * $int ) > $o ).

tff(pred_def_88766,type,
    v147647: ( state_type * $int ) > $o ).

tff(pred_def_88767,type,
    v147646: ( state_type * $int ) > $o ).

tff(pred_def_88768,type,
    v147648: ( state_type * $int ) > $o ).

tff(pred_def_88769,type,
    v147649: ( state_type * $int ) > $o ).

tff(pred_def_88770,type,
    v147650: ( state_type * $int ) > $o ).

tff(pred_def_88771,type,
    v147539: ( state_type * $int ) > $o ).

tff(pred_def_88772,type,
    v147537: ( state_type * $int ) > $o ).

tff(pred_def_88773,type,
    v147660: state_type > $o ).

tff(pred_def_88774,type,
    v147658: state_type > $o ).

tff(pred_def_88775,type,
    v147656: state_type > $o ).

tff(pred_def_88776,type,
    v147654: state_type > $o ).

tff(pred_def_88777,type,
    v147652: state_type > $o ).

tff(pred_def_88778,type,
    v147680: state_type > $o ).

tff(pred_def_88779,type,
    v147678: state_type > $o ).

tff(pred_def_88780,type,
    v147676: state_type > $o ).

tff(pred_def_88781,type,
    v147674: state_type > $o ).

tff(pred_def_88782,type,
    v147672: state_type > $o ).

tff(pred_def_88783,type,
    v147690: state_type > $o ).

tff(pred_def_88784,type,
    v147688: state_type > $o ).

tff(pred_def_88785,type,
    v147686: state_type > $o ).

tff(pred_def_88786,type,
    v147684: state_type > $o ).

tff(pred_def_88787,type,
    v147682: state_type > $o ).

tff(pred_def_88788,type,
    v147695: ( state_type * $int ) > $o ).

tff(pred_def_88789,type,
    v147694: ( state_type * $int ) > $o ).

tff(pred_def_88790,type,
    v147692: ( state_type * $int ) > $o ).

tff(pred_def_88791,type,
    v147705: state_type > $o ).

tff(pred_def_88792,type,
    v147703: state_type > $o ).

tff(pred_def_88793,type,
    v147711: state_type > $o ).

tff(pred_def_88794,type,
    v147709: state_type > $o ).

tff(pred_def_88795,type,
    v147725: state_type > $o ).

tff(pred_def_88796,type,
    v147723: state_type > $o ).

tff(pred_def_88797,type,
    v147721: state_type > $o ).

tff(pred_def_88798,type,
    v147719: state_type > $o ).

tff(pred_def_88799,type,
    v147717: state_type > $o ).

tff(pred_def_88800,type,
    v147715: state_type > $o ).

tff(pred_def_88801,type,
    v147713: state_type > $o ).

tff(pred_def_88802,type,
    v147729: state_type > $o ).

tff(pred_def_88803,type,
    v147727: state_type > $o ).

tff(pred_def_88804,type,
    v147707: state_type > $o ).

tff(pred_def_88805,type,
    v147735: state_type > $o ).

tff(pred_def_88806,type,
    v147737: state_type > $o ).

tff(pred_def_88807,type,
    v147733: state_type > $o ).

tff(pred_def_88808,type,
    v147732: state_type > $o ).

tff(pred_def_88809,type,
    v147743: state_type > $o ).

tff(pred_def_88810,type,
    v147744: state_type > $o ).

tff(pred_def_88811,type,
    v147740: state_type > $o ).

tff(pred_def_88812,type,
    v147742: state_type > $o ).

tff(pred_def_88813,type,
    v147750: state_type > $o ).

tff(pred_def_88814,type,
    v147748: state_type > $o ).

tff(pred_def_88815,type,
    v147752: state_type > $o ).

tff(pred_def_88816,type,
    v147701: state_type > $o ).

tff(pred_def_88817,type,
    v147699: state_type > $o ).

tff(pred_def_88818,type,
    v147697: state_type > $o ).

tff(pred_def_88819,type,
    v147759: state_type > $o ).

tff(pred_def_88820,type,
    v147757: state_type > $o ).

tff(pred_def_88821,type,
    v147756: state_type > $o ).

tff(pred_def_88822,type,
    v147755: state_type > $o ).

tff(pred_def_88823,type,
    v147767: state_type > $o ).

tff(pred_def_88824,type,
    v147768: state_type > $o ).

tff(pred_def_88825,type,
    v147766: state_type > $o ).

tff(pred_def_88826,type,
    v147763: ( state_type * $int ) > $o ).

tff(pred_def_88827,type,
    v147765: ( state_type * $int ) > $o ).

tff(pred_def_88828,type,
    v147754: ( state_type * $int ) > $o ).

tff(pred_def_88829,type,
    v147670: ( state_type * $int ) > $o ).

tff(pred_def_88830,type,
    v147668: ( state_type * $int ) > $o ).

tff(pred_def_88831,type,
    v147666: ( state_type * $int ) > $o ).

tff(pred_def_88832,type,
    v147772: ( state_type * $int ) > $o ).

tff(pred_def_88833,type,
    v147771: ( state_type * $int ) > $o ).

tff(pred_def_88834,type,
    v147773: ( state_type * $int ) > $o ).

tff(pred_def_88835,type,
    v147774: ( state_type * $int ) > $o ).

tff(pred_def_88836,type,
    v147775: ( state_type * $int ) > $o ).

tff(pred_def_88837,type,
    v147664: ( state_type * $int ) > $o ).

tff(pred_def_88838,type,
    v147662: ( state_type * $int ) > $o ).

tff(pred_def_88839,type,
    v147785: state_type > $o ).

tff(pred_def_88840,type,
    v147783: state_type > $o ).

tff(pred_def_88841,type,
    v147781: state_type > $o ).

tff(pred_def_88842,type,
    v147779: state_type > $o ).

tff(pred_def_88843,type,
    v147777: state_type > $o ).

tff(pred_def_88844,type,
    v147805: state_type > $o ).

tff(pred_def_88845,type,
    v147803: state_type > $o ).

tff(pred_def_88846,type,
    v147801: state_type > $o ).

tff(pred_def_88847,type,
    v147799: state_type > $o ).

tff(pred_def_88848,type,
    v147797: state_type > $o ).

tff(pred_def_88849,type,
    v147815: state_type > $o ).

tff(pred_def_88850,type,
    v147813: state_type > $o ).

tff(pred_def_88851,type,
    v147811: state_type > $o ).

tff(pred_def_88852,type,
    v147809: state_type > $o ).

tff(pred_def_88853,type,
    v147807: state_type > $o ).

tff(pred_def_88854,type,
    v147820: ( state_type * $int ) > $o ).

tff(pred_def_88855,type,
    v147819: ( state_type * $int ) > $o ).

tff(pred_def_88856,type,
    v147817: ( state_type * $int ) > $o ).

tff(pred_def_88857,type,
    v147830: state_type > $o ).

tff(pred_def_88858,type,
    v147828: state_type > $o ).

tff(pred_def_88859,type,
    v147836: state_type > $o ).

tff(pred_def_88860,type,
    v147834: state_type > $o ).

tff(pred_def_88861,type,
    v147850: state_type > $o ).

tff(pred_def_88862,type,
    v147848: state_type > $o ).

tff(pred_def_88863,type,
    v147846: state_type > $o ).

tff(pred_def_88864,type,
    v147844: state_type > $o ).

tff(pred_def_88865,type,
    v147842: state_type > $o ).

tff(pred_def_88866,type,
    v147840: state_type > $o ).

tff(pred_def_88867,type,
    v147838: state_type > $o ).

tff(pred_def_88868,type,
    v147854: state_type > $o ).

tff(pred_def_88869,type,
    v147852: state_type > $o ).

tff(pred_def_88870,type,
    v147832: state_type > $o ).

tff(pred_def_88871,type,
    v147860: state_type > $o ).

tff(pred_def_88872,type,
    v147862: state_type > $o ).

tff(pred_def_88873,type,
    v147858: state_type > $o ).

tff(pred_def_88874,type,
    v147857: state_type > $o ).

tff(pred_def_88875,type,
    v147868: state_type > $o ).

tff(pred_def_88876,type,
    v147869: state_type > $o ).

tff(pred_def_88877,type,
    v147865: state_type > $o ).

tff(pred_def_88878,type,
    v147867: state_type > $o ).

tff(pred_def_88879,type,
    v147875: state_type > $o ).

tff(pred_def_88880,type,
    v147873: state_type > $o ).

tff(pred_def_88881,type,
    v147877: state_type > $o ).

tff(pred_def_88882,type,
    v147826: state_type > $o ).

tff(pred_def_88883,type,
    v147824: state_type > $o ).

tff(pred_def_88884,type,
    v147822: state_type > $o ).

tff(pred_def_88885,type,
    v147884: state_type > $o ).

tff(pred_def_88886,type,
    v147882: state_type > $o ).

tff(pred_def_88887,type,
    v147881: state_type > $o ).

tff(pred_def_88888,type,
    v147880: state_type > $o ).

tff(pred_def_88889,type,
    v147892: state_type > $o ).

tff(pred_def_88890,type,
    v147893: state_type > $o ).

tff(pred_def_88891,type,
    v147891: state_type > $o ).

tff(pred_def_88892,type,
    v147888: ( state_type * $int ) > $o ).

tff(pred_def_88893,type,
    v147890: ( state_type * $int ) > $o ).

tff(pred_def_88894,type,
    v147879: ( state_type * $int ) > $o ).

tff(pred_def_88895,type,
    v147795: ( state_type * $int ) > $o ).

tff(pred_def_88896,type,
    v147793: ( state_type * $int ) > $o ).

tff(pred_def_88897,type,
    v147791: ( state_type * $int ) > $o ).

tff(pred_def_88898,type,
    v147897: ( state_type * $int ) > $o ).

tff(pred_def_88899,type,
    v147896: ( state_type * $int ) > $o ).

tff(pred_def_88900,type,
    v147898: ( state_type * $int ) > $o ).

tff(pred_def_88901,type,
    v147899: ( state_type * $int ) > $o ).

tff(pred_def_88902,type,
    v147900: ( state_type * $int ) > $o ).

tff(pred_def_88903,type,
    v147789: ( state_type * $int ) > $o ).

tff(pred_def_88904,type,
    v147787: ( state_type * $int ) > $o ).

tff(pred_def_88905,type,
    v147910: state_type > $o ).

tff(pred_def_88906,type,
    v147908: state_type > $o ).

tff(pred_def_88907,type,
    v147906: state_type > $o ).

tff(pred_def_88908,type,
    v147904: state_type > $o ).

tff(pred_def_88909,type,
    v147902: state_type > $o ).

tff(pred_def_88910,type,
    v147920: state_type > $o ).

tff(pred_def_88911,type,
    v147919: ( state_type * $int ) > $o ).

tff(pred_def_88912,type,
    v147918: ( state_type * $int ) > $o ).

tff(pred_def_88913,type,
    v147923: state_type > $o ).

tff(pred_def_88914,type,
    v147922: ( state_type * $int ) > $o ).

tff(pred_def_88915,type,
    v147921: ( state_type * $int ) > $o ).

tff(pred_def_88916,type,
    v147917: ( state_type * $int ) > $o ).

tff(pred_def_88917,type,
    v147926: state_type > $o ).

tff(pred_def_88918,type,
    v147925: ( state_type * $int ) > $o ).

tff(pred_def_88919,type,
    v147924: ( state_type * $int ) > $o ).

tff(pred_def_88920,type,
    v147916: ( state_type * $int ) > $o ).

tff(pred_def_88921,type,
    v147929: state_type > $o ).

tff(pred_def_88922,type,
    v147928: ( state_type * $int ) > $o ).

tff(pred_def_88923,type,
    v147927: ( state_type * $int ) > $o ).

tff(pred_def_88924,type,
    v147915: ( state_type * $int ) > $o ).

tff(pred_def_88925,type,
    v147932: state_type > $o ).

tff(pred_def_88926,type,
    v147931: ( state_type * $int ) > $o ).

tff(pred_def_88927,type,
    v147930: ( state_type * $int ) > $o ).

tff(pred_def_88928,type,
    v147914: ( state_type * $int ) > $o ).

tff(pred_def_88929,type,
    v147935: state_type > $o ).

tff(pred_def_88930,type,
    v147934: ( state_type * $int ) > $o ).

tff(pred_def_88931,type,
    v147933: ( state_type * $int ) > $o ).

tff(pred_def_88932,type,
    v147913: ( state_type * $int ) > $o ).

tff(pred_def_88933,type,
    v147938: state_type > $o ).

tff(pred_def_88934,type,
    v147937: ( state_type * $int ) > $o ).

tff(pred_def_88935,type,
    v147936: ( state_type * $int ) > $o ).

tff(pred_def_88936,type,
    v147912: ( state_type * $int ) > $o ).

tff(pred_def_88937,type,
    v147941: state_type > $o ).

tff(pred_def_88938,type,
    v147940: ( state_type * $int ) > $o ).

tff(pred_def_88939,type,
    v147939: ( state_type * $int ) > $o ).

tff(pred_def_88940,type,
    v147911: ( state_type * $int ) > $o ).

tff(pred_def_88941,type,
    v146597: ( state_type * $int ) > $o ).

tff(pred_def_88942,type,
    v146595: ( state_type * $int ) > $o ).

tff(pred_def_88943,type,
    v146593: ( state_type * $int ) > $o ).

tff(pred_def_88944,type,
    v147948: ( state_type * $int ) > $o ).

tff(pred_def_88945,type,
    v147954: state_type > $o ).

tff(pred_def_88946,type,
    v147952: state_type > $o ).

tff(pred_def_88947,type,
    v147951: state_type > $o ).

tff(pred_def_88948,type,
    v147950: ( state_type * $int ) > $o ).

tff(pred_def_88949,type,
    v147962: state_type > $o ).

tff(pred_def_88950,type,
    v147960: state_type > $o ).

tff(pred_def_88951,type,
    v147959: state_type > $o ).

tff(pred_def_88952,type,
    v147958: ( state_type * $int ) > $o ).

tff(pred_def_88953,type,
    v147971: state_type > $o ).

tff(pred_def_88954,type,
    v147969: state_type > $o ).

tff(pred_def_88955,type,
    v147968: state_type > $o ).

tff(pred_def_88956,type,
    v147967: ( state_type * $int ) > $o ).

tff(pred_def_88957,type,
    v147980: state_type > $o ).

tff(pred_def_88958,type,
    v147978: state_type > $o ).

tff(pred_def_88959,type,
    v147977: state_type > $o ).

tff(pred_def_88960,type,
    v147976: ( state_type * $int ) > $o ).

tff(pred_def_88961,type,
    v147989: state_type > $o ).

tff(pred_def_88962,type,
    v147987: state_type > $o ).

tff(pred_def_88963,type,
    v147986: state_type > $o ).

tff(pred_def_88964,type,
    v147985: ( state_type * $int ) > $o ).

tff(pred_def_88965,type,
    v147998: state_type > $o ).

tff(pred_def_88966,type,
    v147996: state_type > $o ).

tff(pred_def_88967,type,
    v147995: state_type > $o ).

tff(pred_def_88968,type,
    v147994: ( state_type * $int ) > $o ).

tff(pred_def_88969,type,
    v148007: state_type > $o ).

tff(pred_def_88970,type,
    v148005: state_type > $o ).

tff(pred_def_88971,type,
    v148004: state_type > $o ).

tff(pred_def_88972,type,
    v148003: ( state_type * $int ) > $o ).

tff(pred_def_88973,type,
    v148016: state_type > $o ).

tff(pred_def_88974,type,
    v148014: state_type > $o ).

tff(pred_def_88975,type,
    v148013: state_type > $o ).

tff(pred_def_88976,type,
    v148012: ( state_type * $int ) > $o ).

tff(pred_def_88977,type,
    v148025: state_type > $o ).

tff(pred_def_88978,type,
    v148023: state_type > $o ).

tff(pred_def_88979,type,
    v148022: state_type > $o ).

tff(pred_def_88980,type,
    v148021: ( state_type * $int ) > $o ).

tff(pred_def_88981,type,
    v147943: ( state_type * $int ) > $o ).

tff(pred_def_88982,type,
    v148042: ( state_type * $int ) > $o ).

tff(pred_def_88983,type,
    v148040: ( state_type * $int ) > $o ).

tff(pred_def_88984,type,
    v148038: ( state_type * $int ) > $o ).

tff(pred_def_88985,type,
    v148036: ( state_type * $int ) > $o ).

tff(pred_def_88986,type,
    v148034: ( state_type * $int ) > $o ).

tff(pred_def_88987,type,
    v148048: state_type > $o ).

tff(pred_def_88988,type,
    v148046: state_type > $o ).

tff(pred_def_88989,type,
    v148045: state_type > $o ).

tff(pred_def_88990,type,
    v148044: ( state_type * $int ) > $o ).

tff(pred_def_88991,type,
    v148056: state_type > $o ).

tff(pred_def_88992,type,
    v148054: state_type > $o ).

tff(pred_def_88993,type,
    v148053: state_type > $o ).

tff(pred_def_88994,type,
    v148052: ( state_type * $int ) > $o ).

tff(pred_def_88995,type,
    v148065: state_type > $o ).

tff(pred_def_88996,type,
    v148063: state_type > $o ).

tff(pred_def_88997,type,
    v148062: state_type > $o ).

tff(pred_def_88998,type,
    v148061: ( state_type * $int ) > $o ).

tff(pred_def_88999,type,
    v148074: state_type > $o ).

tff(pred_def_89000,type,
    v148072: state_type > $o ).

tff(pred_def_89001,type,
    v148071: state_type > $o ).

tff(pred_def_89002,type,
    v148070: ( state_type * $int ) > $o ).

tff(pred_def_89003,type,
    v148083: state_type > $o ).

tff(pred_def_89004,type,
    v148081: state_type > $o ).

tff(pred_def_89005,type,
    v148080: state_type > $o ).

tff(pred_def_89006,type,
    v148079: ( state_type * $int ) > $o ).

tff(pred_def_89007,type,
    v148092: state_type > $o ).

tff(pred_def_89008,type,
    v148090: state_type > $o ).

tff(pred_def_89009,type,
    v148089: state_type > $o ).

tff(pred_def_89010,type,
    v148088: ( state_type * $int ) > $o ).

tff(pred_def_89011,type,
    v148101: state_type > $o ).

tff(pred_def_89012,type,
    v148099: state_type > $o ).

tff(pred_def_89013,type,
    v148098: state_type > $o ).

tff(pred_def_89014,type,
    v148097: ( state_type * $int ) > $o ).

tff(pred_def_89015,type,
    v148110: state_type > $o ).

tff(pred_def_89016,type,
    v148108: state_type > $o ).

tff(pred_def_89017,type,
    v148107: state_type > $o ).

tff(pred_def_89018,type,
    v148106: ( state_type * $int ) > $o ).

tff(pred_def_89019,type,
    v148119: state_type > $o ).

tff(pred_def_89020,type,
    v148117: state_type > $o ).

tff(pred_def_89021,type,
    v148116: state_type > $o ).

tff(pred_def_89022,type,
    v148115: ( state_type * $int ) > $o ).

tff(pred_def_89023,type,
    v148029: ( state_type * $int ) > $o ).

tff(pred_def_89024,type,
    v148132: ( state_type * $int ) > $o ).

tff(pred_def_89025,type,
    v148130: ( state_type * $int ) > $o ).

tff(pred_def_89026,type,
    v148128: ( state_type * $int ) > $o ).

tff(pred_def_89027,type,
    v148138: state_type > $o ).

tff(pred_def_89028,type,
    v148136: state_type > $o ).

tff(pred_def_89029,type,
    v148135: state_type > $o ).

tff(pred_def_89030,type,
    v148134: ( state_type * $int ) > $o ).

tff(pred_def_89031,type,
    v148146: state_type > $o ).

tff(pred_def_89032,type,
    v148144: state_type > $o ).

tff(pred_def_89033,type,
    v148143: state_type > $o ).

tff(pred_def_89034,type,
    v148142: ( state_type * $int ) > $o ).

tff(pred_def_89035,type,
    v148155: state_type > $o ).

tff(pred_def_89036,type,
    v148153: state_type > $o ).

tff(pred_def_89037,type,
    v148152: state_type > $o ).

tff(pred_def_89038,type,
    v148151: ( state_type * $int ) > $o ).

tff(pred_def_89039,type,
    v148164: state_type > $o ).

tff(pred_def_89040,type,
    v148162: state_type > $o ).

tff(pred_def_89041,type,
    v148161: state_type > $o ).

tff(pred_def_89042,type,
    v148160: ( state_type * $int ) > $o ).

tff(pred_def_89043,type,
    v148173: state_type > $o ).

tff(pred_def_89044,type,
    v148171: state_type > $o ).

tff(pred_def_89045,type,
    v148170: state_type > $o ).

tff(pred_def_89046,type,
    v148169: ( state_type * $int ) > $o ).

tff(pred_def_89047,type,
    v148182: state_type > $o ).

tff(pred_def_89048,type,
    v148180: state_type > $o ).

tff(pred_def_89049,type,
    v148179: state_type > $o ).

tff(pred_def_89050,type,
    v148178: ( state_type * $int ) > $o ).

tff(pred_def_89051,type,
    v148191: state_type > $o ).

tff(pred_def_89052,type,
    v148189: state_type > $o ).

tff(pred_def_89053,type,
    v148188: state_type > $o ).

tff(pred_def_89054,type,
    v148187: ( state_type * $int ) > $o ).

tff(pred_def_89055,type,
    v148200: state_type > $o ).

tff(pred_def_89056,type,
    v148198: state_type > $o ).

tff(pred_def_89057,type,
    v148197: state_type > $o ).

tff(pred_def_89058,type,
    v148196: ( state_type * $int ) > $o ).

tff(pred_def_89059,type,
    v148209: state_type > $o ).

tff(pred_def_89060,type,
    v148207: state_type > $o ).

tff(pred_def_89061,type,
    v148206: state_type > $o ).

tff(pred_def_89062,type,
    v148205: ( state_type * $int ) > $o ).

tff(pred_def_89063,type,
    v148123: ( state_type * $int ) > $o ).

tff(pred_def_89064,type,
    v148247: state_type > $o ).

tff(pred_def_89065,type,
    v148245: state_type > $o ).

tff(pred_def_89066,type,
    v148243: state_type > $o ).

tff(pred_def_89067,type,
    v148241: state_type > $o ).

tff(pred_def_89068,type,
    v148239: state_type > $o ).

tff(pred_def_89069,type,
    v148257: state_type > $o ).

tff(pred_def_89070,type,
    v148255: state_type > $o ).

tff(pred_def_89071,type,
    v148253: state_type > $o ).

tff(pred_def_89072,type,
    v148251: state_type > $o ).

tff(pred_def_89073,type,
    v148249: state_type > $o ).

tff(pred_def_89074,type,
    v148263: state_type > $o ).

tff(pred_def_89075,type,
    v148264: ( state_type * $int ) > $o ).

tff(pred_def_89076,type,
    v148265: ( state_type * $int ) > $o ).

tff(pred_def_89077,type,
    v148266: ( state_type * $int ) > $o ).

tff(pred_def_89078,type,
    v148267: ( state_type * $int ) > $o ).

tff(pred_def_89079,type,
    v148268: ( state_type * $int ) > $o ).

tff(pred_def_89080,type,
    v148261: ( state_type * $int ) > $o ).

tff(pred_def_89081,type,
    v148259: ( state_type * $int ) > $o ).

tff(pred_def_89082,type,
    v148278: state_type > $o ).

tff(pred_def_89083,type,
    v148276: state_type > $o ).

tff(pred_def_89084,type,
    v148284: state_type > $o ).

tff(pred_def_89085,type,
    v148282: state_type > $o ).

tff(pred_def_89086,type,
    v148288: state_type > $o ).

tff(pred_def_89087,type,
    v148286: state_type > $o ).

tff(pred_def_89088,type,
    v148292: state_type > $o ).

tff(pred_def_89089,type,
    v148290: state_type > $o ).

tff(pred_def_89090,type,
    v148280: state_type > $o ).

tff(pred_def_89091,type,
    v148298: state_type > $o ).

tff(pred_def_89092,type,
    v148300: state_type > $o ).

tff(pred_def_89093,type,
    v148296: state_type > $o ).

tff(pred_def_89094,type,
    v148295: state_type > $o ).

tff(pred_def_89095,type,
    v148306: state_type > $o ).

tff(pred_def_89096,type,
    v148307: state_type > $o ).

tff(pred_def_89097,type,
    v148303: state_type > $o ).

tff(pred_def_89098,type,
    v148305: state_type > $o ).

tff(pred_def_89099,type,
    v148313: state_type > $o ).

tff(pred_def_89100,type,
    v148311: state_type > $o ).

tff(pred_def_89101,type,
    v148315: state_type > $o ).

tff(pred_def_89102,type,
    v148274: state_type > $o ).

tff(pred_def_89103,type,
    v148272: state_type > $o ).

tff(pred_def_89104,type,
    v148270: state_type > $o ).

tff(pred_def_89105,type,
    v148322: state_type > $o ).

tff(pred_def_89106,type,
    v148320: state_type > $o ).

tff(pred_def_89107,type,
    v148319: state_type > $o ).

tff(pred_def_89108,type,
    v148318: state_type > $o ).

tff(pred_def_89109,type,
    v148330: state_type > $o ).

tff(pred_def_89110,type,
    v148331: state_type > $o ).

tff(pred_def_89111,type,
    v148329: state_type > $o ).

tff(pred_def_89112,type,
    v148326: ( state_type * $int ) > $o ).

tff(pred_def_89113,type,
    v148328: ( state_type * $int ) > $o ).

tff(pred_def_89114,type,
    v148317: ( state_type * $int ) > $o ).

tff(pred_def_89115,type,
    v148237: ( state_type * $int ) > $o ).

tff(pred_def_89116,type,
    v148235: ( state_type * $int ) > $o ).

tff(pred_def_89117,type,
    v148233: state_type > $o ).

tff(pred_def_89118,type,
    v148231: state_type > $o ).

tff(pred_def_89119,type,
    v148229: state_type > $o ).

tff(pred_def_89120,type,
    v148227: state_type > $o ).

tff(pred_def_89121,type,
    v148225: state_type > $o ).

tff(pred_def_89122,type,
    v148223: state_type > $o ).

tff(pred_def_89123,type,
    v148221: state_type > $o ).

tff(pred_def_89124,type,
    v148219: state_type > $o ).

tff(pred_def_89125,type,
    v148344: state_type > $o ).

tff(pred_def_89126,type,
    v148342: state_type > $o ).

tff(pred_def_89127,type,
    v148341: state_type > $o ).

tff(pred_def_89128,type,
    v148340: ( state_type * $int ) > $o ).

tff(pred_def_89129,type,
    v148352: state_type > $o ).

tff(pred_def_89130,type,
    v148350: state_type > $o ).

tff(pred_def_89131,type,
    v148349: state_type > $o ).

tff(pred_def_89132,type,
    v148348: ( state_type * $int ) > $o ).

tff(pred_def_89133,type,
    v148360: state_type > $o ).

tff(pred_def_89134,type,
    v148358: state_type > $o ).

tff(pred_def_89135,type,
    v148357: state_type > $o ).

tff(pred_def_89136,type,
    v148356: ( state_type * $int ) > $o ).

tff(pred_def_89137,type,
    v148368: state_type > $o ).

tff(pred_def_89138,type,
    v148366: state_type > $o ).

tff(pred_def_89139,type,
    v148365: state_type > $o ).

tff(pred_def_89140,type,
    v148364: ( state_type * $int ) > $o ).

tff(pred_def_89141,type,
    v148376: state_type > $o ).

tff(pred_def_89142,type,
    v148374: state_type > $o ).

tff(pred_def_89143,type,
    v148373: state_type > $o ).

tff(pred_def_89144,type,
    v148372: ( state_type * $int ) > $o ).

tff(pred_def_89145,type,
    v148384: state_type > $o ).

tff(pred_def_89146,type,
    v148382: state_type > $o ).

tff(pred_def_89147,type,
    v148381: state_type > $o ).

tff(pred_def_89148,type,
    v148380: ( state_type * $int ) > $o ).

tff(pred_def_89149,type,
    v148392: state_type > $o ).

tff(pred_def_89150,type,
    v148390: state_type > $o ).

tff(pred_def_89151,type,
    v148389: state_type > $o ).

tff(pred_def_89152,type,
    v148388: ( state_type * $int ) > $o ).

tff(pred_def_89153,type,
    v148400: state_type > $o ).

tff(pred_def_89154,type,
    v148398: state_type > $o ).

tff(pred_def_89155,type,
    v148397: state_type > $o ).

tff(pred_def_89156,type,
    v148396: ( state_type * $int ) > $o ).

tff(pred_def_89157,type,
    v148408: state_type > $o ).

tff(pred_def_89158,type,
    v148406: state_type > $o ).

tff(pred_def_89159,type,
    v148405: state_type > $o ).

tff(pred_def_89160,type,
    v148404: ( state_type * $int ) > $o ).

tff(pred_def_89161,type,
    v148338: state_type > $o ).

tff(pred_def_89162,type,
    v148336: state_type > $o ).

tff(pred_def_89163,type,
    v148217: state_type > $o ).

tff(pred_def_89164,type,
    v148215: state_type > $o ).

tff(pred_def_89165,type,
    v148213: state_type > $o ).

tff(pred_def_89166,type,
    v146591: ( state_type * $int ) > $o ).

tff(pred_def_89167,type,
    v146589: ( state_type * $int ) > $o ).

tff(pred_def_89168,type,
    v148432: state_type > $o ).

tff(pred_def_89169,type,
    v148430: state_type > $o ).

tff(pred_def_89170,type,
    v148428: state_type > $o ).

tff(pred_def_89171,type,
    v148426: state_type > $o ).

tff(pred_def_89172,type,
    v148424: state_type > $o ).

tff(pred_def_89173,type,
    v148442: state_type > $o ).

tff(pred_def_89174,type,
    v148440: state_type > $o ).

tff(pred_def_89175,type,
    v148438: state_type > $o ).

tff(pred_def_89176,type,
    v148436: state_type > $o ).

tff(pred_def_89177,type,
    v148434: state_type > $o ).

tff(pred_def_89178,type,
    v148451: state_type > $o ).

tff(pred_def_89179,type,
    v148453: ( state_type * $int ) > $o ).

tff(pred_def_89180,type,
    v148460: state_type > $o ).

tff(pred_def_89181,type,
    v148458: state_type > $o ).

tff(pred_def_89182,type,
    v148457: state_type > $o ).

tff(pred_def_89183,type,
    v148456: ( state_type * $int ) > $o ).

tff(pred_def_89184,type,
    v148448: ( state_type * $int ) > $o ).

tff(pred_def_89185,type,
    v148463: ( state_type * $int ) > $o ).

tff(pred_def_89186,type,
    v148464: ( state_type * $int ) > $o ).

tff(pred_def_89187,type,
    v148465: ( state_type * $int ) > $o ).

tff(pred_def_89188,type,
    v148466: ( state_type * $int ) > $o ).

tff(pred_def_89189,type,
    v148446: ( state_type * $int ) > $o ).

tff(pred_def_89190,type,
    v148444: ( state_type * $int ) > $o ).

tff(pred_def_89191,type,
    v148476: state_type > $o ).

tff(pred_def_89192,type,
    v148474: state_type > $o ).

tff(pred_def_89193,type,
    v148482: state_type > $o ).

tff(pred_def_89194,type,
    v148480: state_type > $o ).

tff(pred_def_89195,type,
    v148496: state_type > $o ).

tff(pred_def_89196,type,
    v148494: state_type > $o ).

tff(pred_def_89197,type,
    v148492: state_type > $o ).

tff(pred_def_89198,type,
    v148490: state_type > $o ).

tff(pred_def_89199,type,
    v148488: state_type > $o ).

tff(pred_def_89200,type,
    v148486: state_type > $o ).

tff(pred_def_89201,type,
    v148484: state_type > $o ).

tff(pred_def_89202,type,
    v148500: state_type > $o ).

tff(pred_def_89203,type,
    v148498: state_type > $o ).

tff(pred_def_89204,type,
    v148478: state_type > $o ).

tff(pred_def_89205,type,
    v148506: state_type > $o ).

tff(pred_def_89206,type,
    v148508: state_type > $o ).

tff(pred_def_89207,type,
    v148504: state_type > $o ).

tff(pred_def_89208,type,
    v148503: state_type > $o ).

tff(pred_def_89209,type,
    v148514: state_type > $o ).

tff(pred_def_89210,type,
    v148515: state_type > $o ).

tff(pred_def_89211,type,
    v148511: state_type > $o ).

tff(pred_def_89212,type,
    v148513: state_type > $o ).

tff(pred_def_89213,type,
    v148521: state_type > $o ).

tff(pred_def_89214,type,
    v148519: state_type > $o ).

tff(pred_def_89215,type,
    v148523: state_type > $o ).

tff(pred_def_89216,type,
    v148472: state_type > $o ).

tff(pred_def_89217,type,
    v148470: state_type > $o ).

tff(pred_def_89218,type,
    v148468: state_type > $o ).

tff(pred_def_89219,type,
    v148530: state_type > $o ).

tff(pred_def_89220,type,
    v148528: state_type > $o ).

tff(pred_def_89221,type,
    v148527: state_type > $o ).

tff(pred_def_89222,type,
    v148526: state_type > $o ).

tff(pred_def_89223,type,
    v148538: state_type > $o ).

tff(pred_def_89224,type,
    v148539: state_type > $o ).

tff(pred_def_89225,type,
    v148537: state_type > $o ).

tff(pred_def_89226,type,
    v148534: ( state_type * $int ) > $o ).

tff(pred_def_89227,type,
    v148536: ( state_type * $int ) > $o ).

tff(pred_def_89228,type,
    v148525: ( state_type * $int ) > $o ).

tff(pred_def_89229,type,
    v148422: ( state_type * $int ) > $o ).

tff(pred_def_89230,type,
    v148420: ( state_type * $int ) > $o ).

tff(pred_def_89231,type,
    v148418: ( state_type * $int ) > $o ).

tff(pred_def_89232,type,
    v148551: ( state_type * $int ) > $o ).

tff(pred_def_89233,type,
    v148549: ( state_type * $int ) > $o ).

tff(pred_def_89234,type,
    v148547: ( state_type * $int ) > $o ).

tff(pred_def_89235,type,
    v148557: state_type > $o ).

tff(pred_def_89236,type,
    v148555: state_type > $o ).

tff(pred_def_89237,type,
    v148554: state_type > $o ).

tff(pred_def_89238,type,
    v148553: ( state_type * $int ) > $o ).

tff(pred_def_89239,type,
    v148565: state_type > $o ).

tff(pred_def_89240,type,
    v148563: state_type > $o ).

tff(pred_def_89241,type,
    v148562: state_type > $o ).

tff(pred_def_89242,type,
    v148561: ( state_type * $int ) > $o ).

tff(pred_def_89243,type,
    v148543: ( state_type * $int ) > $o ).

tff(pred_def_89244,type,
    v148577: ( state_type * $int ) > $o ).

tff(pred_def_89245,type,
    v148575: ( state_type * $int ) > $o ).

tff(pred_def_89246,type,
    v148573: ( state_type * $int ) > $o ).

tff(pred_def_89247,type,
    v148583: state_type > $o ).

tff(pred_def_89248,type,
    v148581: state_type > $o ).

tff(pred_def_89249,type,
    v148580: state_type > $o ).

tff(pred_def_89250,type,
    v148579: ( state_type * $int ) > $o ).

tff(pred_def_89251,type,
    v148591: state_type > $o ).

tff(pred_def_89252,type,
    v148589: state_type > $o ).

tff(pred_def_89253,type,
    v148588: state_type > $o ).

tff(pred_def_89254,type,
    v148587: ( state_type * $int ) > $o ).

tff(pred_def_89255,type,
    v148569: ( state_type * $int ) > $o ).

tff(pred_def_89256,type,
    v148603: ( state_type * $int ) > $o ).

tff(pred_def_89257,type,
    v148601: ( state_type * $int ) > $o ).

tff(pred_def_89258,type,
    v148599: ( state_type * $int ) > $o ).

tff(pred_def_89259,type,
    v148609: state_type > $o ).

tff(pred_def_89260,type,
    v148607: state_type > $o ).

tff(pred_def_89261,type,
    v148606: state_type > $o ).

tff(pred_def_89262,type,
    v148605: ( state_type * $int ) > $o ).

tff(pred_def_89263,type,
    v148617: state_type > $o ).

tff(pred_def_89264,type,
    v148615: state_type > $o ).

tff(pred_def_89265,type,
    v148614: state_type > $o ).

tff(pred_def_89266,type,
    v148613: ( state_type * $int ) > $o ).

tff(pred_def_89267,type,
    v148595: ( state_type * $int ) > $o ).

tff(pred_def_89268,type,
    v148416: ( state_type * $int ) > $o ).

tff(pred_def_89269,type,
    v148414: ( state_type * $int ) > $o ).

tff(pred_def_89270,type,
    v146587: state_type > $o ).

tff(pred_def_89271,type,
    v146585: state_type > $o ).

tff(pred_def_89272,type,
    v146583: state_type > $o ).

tff(pred_def_89273,type,
    v146581: state_type > $o ).

tff(pred_def_89274,type,
    v146579: state_type > $o ).

tff(pred_def_89275,type,
    v146577: state_type > $o ).

tff(pred_def_89276,type,
    v148637: ( state_type * $int ) > $o ).

tff(pred_def_89277,type,
    v148635: ( state_type * $int ) > $o ).

tff(pred_def_89278,type,
    v148658: state_type > $o ).

tff(pred_def_89279,type,
    v148656: state_type > $o ).

tff(pred_def_89280,type,
    v148654: state_type > $o ).

tff(pred_def_89281,type,
    v148652: state_type > $o ).

tff(pred_def_89282,type,
    v148650: state_type > $o ).

tff(pred_def_89283,type,
    v148668: state_type > $o ).

tff(pred_def_89284,type,
    v148666: state_type > $o ).

tff(pred_def_89285,type,
    v148664: state_type > $o ).

tff(pred_def_89286,type,
    v148662: state_type > $o ).

tff(pred_def_89287,type,
    v148660: state_type > $o ).

tff(pred_def_89288,type,
    v148673: ( state_type * $int ) > $o ).

tff(pred_def_89289,type,
    v148672: ( state_type * $int ) > $o ).

tff(pred_def_89290,type,
    v148670: ( state_type * $int ) > $o ).

tff(pred_def_89291,type,
    v148683: state_type > $o ).

tff(pred_def_89292,type,
    v148681: state_type > $o ).

tff(pred_def_89293,type,
    v148689: state_type > $o ).

tff(pred_def_89294,type,
    v148687: state_type > $o ).

tff(pred_def_89295,type,
    v148703: state_type > $o ).

tff(pred_def_89296,type,
    v148701: state_type > $o ).

tff(pred_def_89297,type,
    v148699: state_type > $o ).

tff(pred_def_89298,type,
    v148697: state_type > $o ).

tff(pred_def_89299,type,
    v148695: state_type > $o ).

tff(pred_def_89300,type,
    v148693: state_type > $o ).

tff(pred_def_89301,type,
    v148691: state_type > $o ).

tff(pred_def_89302,type,
    v148707: state_type > $o ).

tff(pred_def_89303,type,
    v148705: state_type > $o ).

tff(pred_def_89304,type,
    v148685: state_type > $o ).

tff(pred_def_89305,type,
    v148713: state_type > $o ).

tff(pred_def_89306,type,
    v148715: state_type > $o ).

tff(pred_def_89307,type,
    v148711: state_type > $o ).

tff(pred_def_89308,type,
    v148710: state_type > $o ).

tff(pred_def_89309,type,
    v148721: state_type > $o ).

tff(pred_def_89310,type,
    v148722: state_type > $o ).

tff(pred_def_89311,type,
    v148718: state_type > $o ).

tff(pred_def_89312,type,
    v148720: state_type > $o ).

tff(pred_def_89313,type,
    v148728: state_type > $o ).

tff(pred_def_89314,type,
    v148726: state_type > $o ).

tff(pred_def_89315,type,
    v148730: state_type > $o ).

tff(pred_def_89316,type,
    v148679: state_type > $o ).

tff(pred_def_89317,type,
    v148677: state_type > $o ).

tff(pred_def_89318,type,
    v148675: state_type > $o ).

tff(pred_def_89319,type,
    v148737: state_type > $o ).

tff(pred_def_89320,type,
    v148735: state_type > $o ).

tff(pred_def_89321,type,
    v148734: state_type > $o ).

tff(pred_def_89322,type,
    v148733: state_type > $o ).

tff(pred_def_89323,type,
    v148745: state_type > $o ).

tff(pred_def_89324,type,
    v148746: state_type > $o ).

tff(pred_def_89325,type,
    v148744: state_type > $o ).

tff(pred_def_89326,type,
    v148741: ( state_type * $int ) > $o ).

tff(pred_def_89327,type,
    v148743: ( state_type * $int ) > $o ).

tff(pred_def_89328,type,
    v148732: ( state_type * $int ) > $o ).

tff(pred_def_89329,type,
    v148648: ( state_type * $int ) > $o ).

tff(pred_def_89330,type,
    v148646: ( state_type * $int ) > $o ).

tff(pred_def_89331,type,
    v148644: ( state_type * $int ) > $o ).

tff(pred_def_89332,type,
    v148756: state_type > $o ).

tff(pred_def_89333,type,
    v148754: state_type > $o ).

tff(pred_def_89334,type,
    v148753: state_type > $o ).

tff(pred_def_89335,type,
    v148752: ( state_type * $int ) > $o ).

tff(pred_def_89336,type,
    v148750: ( state_type * $int ) > $o ).

tff(pred_def_89337,type,
    v148766: state_type > $o ).

tff(pred_def_89338,type,
    v148764: state_type > $o ).

tff(pred_def_89339,type,
    v148763: state_type > $o ).

tff(pred_def_89340,type,
    v148762: ( state_type * $int ) > $o ).

tff(pred_def_89341,type,
    v148760: ( state_type * $int ) > $o ).

tff(pred_def_89342,type,
    v148776: state_type > $o ).

tff(pred_def_89343,type,
    v148774: state_type > $o ).

tff(pred_def_89344,type,
    v148773: state_type > $o ).

tff(pred_def_89345,type,
    v148772: ( state_type * $int ) > $o ).

tff(pred_def_89346,type,
    v148770: ( state_type * $int ) > $o ).

tff(pred_def_89347,type,
    v148642: ( state_type * $int ) > $o ).

tff(pred_def_89348,type,
    v148640: ( state_type * $int ) > $o ).

tff(pred_def_89349,type,
    v148633: state_type > $o ).

tff(pred_def_89350,type,
    v148631: state_type > $o ).

tff(pred_def_89351,type,
    v148629: state_type > $o ).

tff(pred_def_89352,type,
    v148627: state_type > $o ).

tff(pred_def_89353,type,
    v148625: state_type > $o ).

tff(pred_def_89354,type,
    v148623: state_type > $o ).

tff(pred_def_89355,type,
    v148796: ( state_type * $int ) > $o ).

tff(pred_def_89356,type,
    v148794: ( state_type * $int ) > $o ).

tff(pred_def_89357,type,
    v148817: state_type > $o ).

tff(pred_def_89358,type,
    v148815: state_type > $o ).

tff(pred_def_89359,type,
    v148813: state_type > $o ).

tff(pred_def_89360,type,
    v148811: state_type > $o ).

tff(pred_def_89361,type,
    v148809: state_type > $o ).

tff(pred_def_89362,type,
    v148827: state_type > $o ).

tff(pred_def_89363,type,
    v148825: state_type > $o ).

tff(pred_def_89364,type,
    v148823: state_type > $o ).

tff(pred_def_89365,type,
    v148821: state_type > $o ).

tff(pred_def_89366,type,
    v148819: state_type > $o ).

tff(pred_def_89367,type,
    v148832: ( state_type * $int ) > $o ).

tff(pred_def_89368,type,
    v148831: ( state_type * $int ) > $o ).

tff(pred_def_89369,type,
    v148829: ( state_type * $int ) > $o ).

tff(pred_def_89370,type,
    v148842: state_type > $o ).

tff(pred_def_89371,type,
    v148840: state_type > $o ).

tff(pred_def_89372,type,
    v148848: state_type > $o ).

tff(pred_def_89373,type,
    v148846: state_type > $o ).

tff(pred_def_89374,type,
    v148862: state_type > $o ).

tff(pred_def_89375,type,
    v148860: state_type > $o ).

tff(pred_def_89376,type,
    v148858: state_type > $o ).

tff(pred_def_89377,type,
    v148856: state_type > $o ).

tff(pred_def_89378,type,
    v148854: state_type > $o ).

tff(pred_def_89379,type,
    v148852: state_type > $o ).

tff(pred_def_89380,type,
    v148850: state_type > $o ).

tff(pred_def_89381,type,
    v148866: state_type > $o ).

tff(pred_def_89382,type,
    v148864: state_type > $o ).

tff(pred_def_89383,type,
    v148844: state_type > $o ).

tff(pred_def_89384,type,
    v148872: state_type > $o ).

tff(pred_def_89385,type,
    v148874: state_type > $o ).

tff(pred_def_89386,type,
    v148870: state_type > $o ).

tff(pred_def_89387,type,
    v148869: state_type > $o ).

tff(pred_def_89388,type,
    v148880: state_type > $o ).

tff(pred_def_89389,type,
    v148881: state_type > $o ).

tff(pred_def_89390,type,
    v148877: state_type > $o ).

tff(pred_def_89391,type,
    v148879: state_type > $o ).

tff(pred_def_89392,type,
    v148887: state_type > $o ).

tff(pred_def_89393,type,
    v148885: state_type > $o ).

tff(pred_def_89394,type,
    v148889: state_type > $o ).

tff(pred_def_89395,type,
    v148838: state_type > $o ).

tff(pred_def_89396,type,
    v148836: state_type > $o ).

tff(pred_def_89397,type,
    v148834: state_type > $o ).

tff(pred_def_89398,type,
    v148896: state_type > $o ).

tff(pred_def_89399,type,
    v148894: state_type > $o ).

tff(pred_def_89400,type,
    v148893: state_type > $o ).

tff(pred_def_89401,type,
    v148892: state_type > $o ).

tff(pred_def_89402,type,
    v148904: state_type > $o ).

tff(pred_def_89403,type,
    v148905: state_type > $o ).

tff(pred_def_89404,type,
    v148903: state_type > $o ).

tff(pred_def_89405,type,
    v148900: ( state_type * $int ) > $o ).

tff(pred_def_89406,type,
    v148902: ( state_type * $int ) > $o ).

tff(pred_def_89407,type,
    v148891: ( state_type * $int ) > $o ).

tff(pred_def_89408,type,
    v148807: ( state_type * $int ) > $o ).

tff(pred_def_89409,type,
    v148805: ( state_type * $int ) > $o ).

tff(pred_def_89410,type,
    v148803: ( state_type * $int ) > $o ).

tff(pred_def_89411,type,
    v148915: state_type > $o ).

tff(pred_def_89412,type,
    v148913: state_type > $o ).

tff(pred_def_89413,type,
    v148912: state_type > $o ).

tff(pred_def_89414,type,
    v148911: ( state_type * $int ) > $o ).

tff(pred_def_89415,type,
    v148909: ( state_type * $int ) > $o ).

tff(pred_def_89416,type,
    v148925: state_type > $o ).

tff(pred_def_89417,type,
    v148923: state_type > $o ).

tff(pred_def_89418,type,
    v148922: state_type > $o ).

tff(pred_def_89419,type,
    v148921: ( state_type * $int ) > $o ).

tff(pred_def_89420,type,
    v148919: ( state_type * $int ) > $o ).

tff(pred_def_89421,type,
    v148935: state_type > $o ).

tff(pred_def_89422,type,
    v148933: state_type > $o ).

tff(pred_def_89423,type,
    v148932: state_type > $o ).

tff(pred_def_89424,type,
    v148931: ( state_type * $int ) > $o ).

tff(pred_def_89425,type,
    v148929: ( state_type * $int ) > $o ).

tff(pred_def_89426,type,
    v148801: ( state_type * $int ) > $o ).

tff(pred_def_89427,type,
    v148799: ( state_type * $int ) > $o ).

tff(pred_def_89428,type,
    v148792: state_type > $o ).

tff(pred_def_89429,type,
    v148790: state_type > $o ).

tff(pred_def_89430,type,
    v148788: state_type > $o ).

tff(pred_def_89431,type,
    v148786: state_type > $o ).

tff(pred_def_89432,type,
    v148784: state_type > $o ).

tff(pred_def_89433,type,
    v148782: state_type > $o ).

tff(pred_def_89434,type,
    v148955: ( state_type * $int ) > $o ).

tff(pred_def_89435,type,
    v148953: ( state_type * $int ) > $o ).

tff(pred_def_89436,type,
    v148976: state_type > $o ).

tff(pred_def_89437,type,
    v148974: state_type > $o ).

tff(pred_def_89438,type,
    v148972: state_type > $o ).

tff(pred_def_89439,type,
    v148970: state_type > $o ).

tff(pred_def_89440,type,
    v148968: state_type > $o ).

tff(pred_def_89441,type,
    v148986: state_type > $o ).

tff(pred_def_89442,type,
    v148984: state_type > $o ).

tff(pred_def_89443,type,
    v148982: state_type > $o ).

tff(pred_def_89444,type,
    v148980: state_type > $o ).

tff(pred_def_89445,type,
    v148978: state_type > $o ).

tff(pred_def_89446,type,
    v148991: ( state_type * $int ) > $o ).

tff(pred_def_89447,type,
    v148990: ( state_type * $int ) > $o ).

tff(pred_def_89448,type,
    v148988: ( state_type * $int ) > $o ).

tff(pred_def_89449,type,
    v149001: state_type > $o ).

tff(pred_def_89450,type,
    v148999: state_type > $o ).

tff(pred_def_89451,type,
    v149007: state_type > $o ).

tff(pred_def_89452,type,
    v149005: state_type > $o ).

tff(pred_def_89453,type,
    v149021: state_type > $o ).

tff(pred_def_89454,type,
    v149019: state_type > $o ).

tff(pred_def_89455,type,
    v149017: state_type > $o ).

tff(pred_def_89456,type,
    v149015: state_type > $o ).

tff(pred_def_89457,type,
    v149013: state_type > $o ).

tff(pred_def_89458,type,
    v149011: state_type > $o ).

tff(pred_def_89459,type,
    v149009: state_type > $o ).

tff(pred_def_89460,type,
    v149025: state_type > $o ).

tff(pred_def_89461,type,
    v149023: state_type > $o ).

tff(pred_def_89462,type,
    v149003: state_type > $o ).

tff(pred_def_89463,type,
    v149031: state_type > $o ).

tff(pred_def_89464,type,
    v149033: state_type > $o ).

tff(pred_def_89465,type,
    v149029: state_type > $o ).

tff(pred_def_89466,type,
    v149028: state_type > $o ).

tff(pred_def_89467,type,
    v149039: state_type > $o ).

tff(pred_def_89468,type,
    v149040: state_type > $o ).

tff(pred_def_89469,type,
    v149036: state_type > $o ).

tff(pred_def_89470,type,
    v149038: state_type > $o ).

tff(pred_def_89471,type,
    v149046: state_type > $o ).

tff(pred_def_89472,type,
    v149044: state_type > $o ).

tff(pred_def_89473,type,
    v149048: state_type > $o ).

tff(pred_def_89474,type,
    v148997: state_type > $o ).

tff(pred_def_89475,type,
    v148995: state_type > $o ).

tff(pred_def_89476,type,
    v148993: state_type > $o ).

tff(pred_def_89477,type,
    v149055: state_type > $o ).

tff(pred_def_89478,type,
    v149053: state_type > $o ).

tff(pred_def_89479,type,
    v149052: state_type > $o ).

tff(pred_def_89480,type,
    v149051: state_type > $o ).

tff(pred_def_89481,type,
    v149063: state_type > $o ).

tff(pred_def_89482,type,
    v149064: state_type > $o ).

tff(pred_def_89483,type,
    v149062: state_type > $o ).

tff(pred_def_89484,type,
    v149059: ( state_type * $int ) > $o ).

tff(pred_def_89485,type,
    v149061: ( state_type * $int ) > $o ).

tff(pred_def_89486,type,
    v149050: ( state_type * $int ) > $o ).

tff(pred_def_89487,type,
    v148966: ( state_type * $int ) > $o ).

tff(pred_def_89488,type,
    v148964: ( state_type * $int ) > $o ).

tff(pred_def_89489,type,
    v148962: ( state_type * $int ) > $o ).

tff(pred_def_89490,type,
    v149074: state_type > $o ).

tff(pred_def_89491,type,
    v149072: state_type > $o ).

tff(pred_def_89492,type,
    v149071: state_type > $o ).

tff(pred_def_89493,type,
    v149070: ( state_type * $int ) > $o ).

tff(pred_def_89494,type,
    v149068: ( state_type * $int ) > $o ).

tff(pred_def_89495,type,
    v149084: state_type > $o ).

tff(pred_def_89496,type,
    v149082: state_type > $o ).

tff(pred_def_89497,type,
    v149081: state_type > $o ).

tff(pred_def_89498,type,
    v149080: ( state_type * $int ) > $o ).

tff(pred_def_89499,type,
    v149078: ( state_type * $int ) > $o ).

tff(pred_def_89500,type,
    v149094: state_type > $o ).

tff(pred_def_89501,type,
    v149092: state_type > $o ).

tff(pred_def_89502,type,
    v149091: state_type > $o ).

tff(pred_def_89503,type,
    v149090: ( state_type * $int ) > $o ).

tff(pred_def_89504,type,
    v149088: ( state_type * $int ) > $o ).

tff(pred_def_89505,type,
    v148960: ( state_type * $int ) > $o ).

tff(pred_def_89506,type,
    v148958: ( state_type * $int ) > $o ).

tff(pred_def_89507,type,
    v148951: state_type > $o ).

tff(pred_def_89508,type,
    v148949: state_type > $o ).

tff(pred_def_89509,type,
    v148947: state_type > $o ).

tff(pred_def_89510,type,
    v148945: state_type > $o ).

tff(pred_def_89511,type,
    v148943: state_type > $o ).

tff(pred_def_89512,type,
    v148941: state_type > $o ).

tff(pred_def_89513,type,
    v149114: ( state_type * $int ) > $o ).

tff(pred_def_89514,type,
    v149112: ( state_type * $int ) > $o ).

tff(pred_def_89515,type,
    v149135: state_type > $o ).

tff(pred_def_89516,type,
    v149133: state_type > $o ).

tff(pred_def_89517,type,
    v149131: state_type > $o ).

tff(pred_def_89518,type,
    v149129: state_type > $o ).

tff(pred_def_89519,type,
    v149127: state_type > $o ).

tff(pred_def_89520,type,
    v149145: state_type > $o ).

tff(pred_def_89521,type,
    v149143: state_type > $o ).

tff(pred_def_89522,type,
    v149141: state_type > $o ).

tff(pred_def_89523,type,
    v149139: state_type > $o ).

tff(pred_def_89524,type,
    v149137: state_type > $o ).

tff(pred_def_89525,type,
    v149150: ( state_type * $int ) > $o ).

tff(pred_def_89526,type,
    v149149: ( state_type * $int ) > $o ).

tff(pred_def_89527,type,
    v149147: ( state_type * $int ) > $o ).

tff(pred_def_89528,type,
    v149160: state_type > $o ).

tff(pred_def_89529,type,
    v149158: state_type > $o ).

tff(pred_def_89530,type,
    v149166: state_type > $o ).

tff(pred_def_89531,type,
    v149164: state_type > $o ).

tff(pred_def_89532,type,
    v149180: state_type > $o ).

tff(pred_def_89533,type,
    v149178: state_type > $o ).

tff(pred_def_89534,type,
    v149176: state_type > $o ).

tff(pred_def_89535,type,
    v149174: state_type > $o ).

tff(pred_def_89536,type,
    v149172: state_type > $o ).

tff(pred_def_89537,type,
    v149170: state_type > $o ).

tff(pred_def_89538,type,
    v149168: state_type > $o ).

tff(pred_def_89539,type,
    v149184: state_type > $o ).

tff(pred_def_89540,type,
    v149182: state_type > $o ).

tff(pred_def_89541,type,
    v149162: state_type > $o ).

tff(pred_def_89542,type,
    v149190: state_type > $o ).

tff(pred_def_89543,type,
    v149192: state_type > $o ).

tff(pred_def_89544,type,
    v149188: state_type > $o ).

tff(pred_def_89545,type,
    v149187: state_type > $o ).

tff(pred_def_89546,type,
    v149198: state_type > $o ).

tff(pred_def_89547,type,
    v149199: state_type > $o ).

tff(pred_def_89548,type,
    v149195: state_type > $o ).

tff(pred_def_89549,type,
    v149197: state_type > $o ).

tff(pred_def_89550,type,
    v149205: state_type > $o ).

tff(pred_def_89551,type,
    v149203: state_type > $o ).

tff(pred_def_89552,type,
    v149207: state_type > $o ).

tff(pred_def_89553,type,
    v149156: state_type > $o ).

tff(pred_def_89554,type,
    v149154: state_type > $o ).

tff(pred_def_89555,type,
    v149152: state_type > $o ).

tff(pred_def_89556,type,
    v149214: state_type > $o ).

tff(pred_def_89557,type,
    v149212: state_type > $o ).

tff(pred_def_89558,type,
    v149211: state_type > $o ).

tff(pred_def_89559,type,
    v149210: state_type > $o ).

tff(pred_def_89560,type,
    v149222: state_type > $o ).

tff(pred_def_89561,type,
    v149223: state_type > $o ).

tff(pred_def_89562,type,
    v149221: state_type > $o ).

tff(pred_def_89563,type,
    v149218: ( state_type * $int ) > $o ).

tff(pred_def_89564,type,
    v149220: ( state_type * $int ) > $o ).

tff(pred_def_89565,type,
    v149209: ( state_type * $int ) > $o ).

tff(pred_def_89566,type,
    v149125: ( state_type * $int ) > $o ).

tff(pred_def_89567,type,
    v149123: ( state_type * $int ) > $o ).

tff(pred_def_89568,type,
    v149121: ( state_type * $int ) > $o ).

tff(pred_def_89569,type,
    v149233: state_type > $o ).

tff(pred_def_89570,type,
    v149231: state_type > $o ).

tff(pred_def_89571,type,
    v149230: state_type > $o ).

tff(pred_def_89572,type,
    v149229: ( state_type * $int ) > $o ).

tff(pred_def_89573,type,
    v149227: ( state_type * $int ) > $o ).

tff(pred_def_89574,type,
    v149243: state_type > $o ).

tff(pred_def_89575,type,
    v149241: state_type > $o ).

tff(pred_def_89576,type,
    v149240: state_type > $o ).

tff(pred_def_89577,type,
    v149239: ( state_type * $int ) > $o ).

tff(pred_def_89578,type,
    v149237: ( state_type * $int ) > $o ).

tff(pred_def_89579,type,
    v149253: state_type > $o ).

tff(pred_def_89580,type,
    v149251: state_type > $o ).

tff(pred_def_89581,type,
    v149250: state_type > $o ).

tff(pred_def_89582,type,
    v149249: ( state_type * $int ) > $o ).

tff(pred_def_89583,type,
    v149247: ( state_type * $int ) > $o ).

tff(pred_def_89584,type,
    v149119: ( state_type * $int ) > $o ).

tff(pred_def_89585,type,
    v149117: ( state_type * $int ) > $o ).

tff(pred_def_89586,type,
    v149110: state_type > $o ).

tff(pred_def_89587,type,
    v149108: state_type > $o ).

tff(pred_def_89588,type,
    v149106: state_type > $o ).

tff(pred_def_89589,type,
    v149104: state_type > $o ).

tff(pred_def_89590,type,
    v149102: state_type > $o ).

tff(pred_def_89591,type,
    v149100: state_type > $o ).

tff(pred_def_89592,type,
    v149273: ( state_type * $int ) > $o ).

tff(pred_def_89593,type,
    v149271: ( state_type * $int ) > $o ).

tff(pred_def_89594,type,
    v149294: state_type > $o ).

tff(pred_def_89595,type,
    v149292: state_type > $o ).

tff(pred_def_89596,type,
    v149290: state_type > $o ).

tff(pred_def_89597,type,
    v149288: state_type > $o ).

tff(pred_def_89598,type,
    v149286: state_type > $o ).

tff(pred_def_89599,type,
    v149304: state_type > $o ).

tff(pred_def_89600,type,
    v149302: state_type > $o ).

tff(pred_def_89601,type,
    v149300: state_type > $o ).

tff(pred_def_89602,type,
    v149298: state_type > $o ).

tff(pred_def_89603,type,
    v149296: state_type > $o ).

tff(pred_def_89604,type,
    v149309: ( state_type * $int ) > $o ).

tff(pred_def_89605,type,
    v149308: ( state_type * $int ) > $o ).

tff(pred_def_89606,type,
    v149306: ( state_type * $int ) > $o ).

tff(pred_def_89607,type,
    v149319: state_type > $o ).

tff(pred_def_89608,type,
    v149317: state_type > $o ).

tff(pred_def_89609,type,
    v149325: state_type > $o ).

tff(pred_def_89610,type,
    v149323: state_type > $o ).

tff(pred_def_89611,type,
    v149339: state_type > $o ).

tff(pred_def_89612,type,
    v149337: state_type > $o ).

tff(pred_def_89613,type,
    v149335: state_type > $o ).

tff(pred_def_89614,type,
    v149333: state_type > $o ).

tff(pred_def_89615,type,
    v149331: state_type > $o ).

tff(pred_def_89616,type,
    v149329: state_type > $o ).

tff(pred_def_89617,type,
    v149327: state_type > $o ).

tff(pred_def_89618,type,
    v149343: state_type > $o ).

tff(pred_def_89619,type,
    v149341: state_type > $o ).

tff(pred_def_89620,type,
    v149321: state_type > $o ).

tff(pred_def_89621,type,
    v149349: state_type > $o ).

tff(pred_def_89622,type,
    v149351: state_type > $o ).

tff(pred_def_89623,type,
    v149347: state_type > $o ).

tff(pred_def_89624,type,
    v149346: state_type > $o ).

tff(pred_def_89625,type,
    v149357: state_type > $o ).

tff(pred_def_89626,type,
    v149358: state_type > $o ).

tff(pred_def_89627,type,
    v149354: state_type > $o ).

tff(pred_def_89628,type,
    v149356: state_type > $o ).

tff(pred_def_89629,type,
    v149364: state_type > $o ).

tff(pred_def_89630,type,
    v149362: state_type > $o ).

tff(pred_def_89631,type,
    v149366: state_type > $o ).

tff(pred_def_89632,type,
    v149315: state_type > $o ).

tff(pred_def_89633,type,
    v149313: state_type > $o ).

tff(pred_def_89634,type,
    v149311: state_type > $o ).

tff(pred_def_89635,type,
    v149373: state_type > $o ).

tff(pred_def_89636,type,
    v149371: state_type > $o ).

tff(pred_def_89637,type,
    v149370: state_type > $o ).

tff(pred_def_89638,type,
    v149369: state_type > $o ).

tff(pred_def_89639,type,
    v149381: state_type > $o ).

tff(pred_def_89640,type,
    v149382: state_type > $o ).

tff(pred_def_89641,type,
    v149380: state_type > $o ).

tff(pred_def_89642,type,
    v149377: ( state_type * $int ) > $o ).

tff(pred_def_89643,type,
    v149379: ( state_type * $int ) > $o ).

tff(pred_def_89644,type,
    v149368: ( state_type * $int ) > $o ).

tff(pred_def_89645,type,
    v149284: ( state_type * $int ) > $o ).

tff(pred_def_89646,type,
    v149282: ( state_type * $int ) > $o ).

tff(pred_def_89647,type,
    v149280: ( state_type * $int ) > $o ).

tff(pred_def_89648,type,
    v149392: state_type > $o ).

tff(pred_def_89649,type,
    v149390: state_type > $o ).

tff(pred_def_89650,type,
    v149389: state_type > $o ).

tff(pred_def_89651,type,
    v149388: ( state_type * $int ) > $o ).

tff(pred_def_89652,type,
    v149386: ( state_type * $int ) > $o ).

tff(pred_def_89653,type,
    v149402: state_type > $o ).

tff(pred_def_89654,type,
    v149400: state_type > $o ).

tff(pred_def_89655,type,
    v149399: state_type > $o ).

tff(pred_def_89656,type,
    v149398: ( state_type * $int ) > $o ).

tff(pred_def_89657,type,
    v149396: ( state_type * $int ) > $o ).

tff(pred_def_89658,type,
    v149412: state_type > $o ).

tff(pred_def_89659,type,
    v149410: state_type > $o ).

tff(pred_def_89660,type,
    v149409: state_type > $o ).

tff(pred_def_89661,type,
    v149408: ( state_type * $int ) > $o ).

tff(pred_def_89662,type,
    v149406: ( state_type * $int ) > $o ).

tff(pred_def_89663,type,
    v149278: ( state_type * $int ) > $o ).

tff(pred_def_89664,type,
    v149276: ( state_type * $int ) > $o ).

tff(pred_def_89665,type,
    v149269: state_type > $o ).

tff(pred_def_89666,type,
    v149267: state_type > $o ).

tff(pred_def_89667,type,
    v149265: state_type > $o ).

tff(pred_def_89668,type,
    v149263: state_type > $o ).

tff(pred_def_89669,type,
    v149261: state_type > $o ).

tff(pred_def_89670,type,
    v149259: state_type > $o ).

tff(pred_def_89671,type,
    v149432: ( state_type * $int ) > $o ).

tff(pred_def_89672,type,
    v149430: ( state_type * $int ) > $o ).

tff(pred_def_89673,type,
    v149453: state_type > $o ).

tff(pred_def_89674,type,
    v149451: state_type > $o ).

tff(pred_def_89675,type,
    v149449: state_type > $o ).

tff(pred_def_89676,type,
    v149447: state_type > $o ).

tff(pred_def_89677,type,
    v149445: state_type > $o ).

tff(pred_def_89678,type,
    v149463: state_type > $o ).

tff(pred_def_89679,type,
    v149461: state_type > $o ).

tff(pred_def_89680,type,
    v149459: state_type > $o ).

tff(pred_def_89681,type,
    v149457: state_type > $o ).

tff(pred_def_89682,type,
    v149455: state_type > $o ).

tff(pred_def_89683,type,
    v149468: ( state_type * $int ) > $o ).

tff(pred_def_89684,type,
    v149467: ( state_type * $int ) > $o ).

tff(pred_def_89685,type,
    v149465: ( state_type * $int ) > $o ).

tff(pred_def_89686,type,
    v149478: state_type > $o ).

tff(pred_def_89687,type,
    v149476: state_type > $o ).

tff(pred_def_89688,type,
    v149484: state_type > $o ).

tff(pred_def_89689,type,
    v149482: state_type > $o ).

tff(pred_def_89690,type,
    v149498: state_type > $o ).

tff(pred_def_89691,type,
    v149496: state_type > $o ).

tff(pred_def_89692,type,
    v149494: state_type > $o ).

tff(pred_def_89693,type,
    v149492: state_type > $o ).

tff(pred_def_89694,type,
    v149490: state_type > $o ).

tff(pred_def_89695,type,
    v149488: state_type > $o ).

tff(pred_def_89696,type,
    v149486: state_type > $o ).

tff(pred_def_89697,type,
    v149502: state_type > $o ).

tff(pred_def_89698,type,
    v149500: state_type > $o ).

tff(pred_def_89699,type,
    v149480: state_type > $o ).

tff(pred_def_89700,type,
    v149508: state_type > $o ).

tff(pred_def_89701,type,
    v149510: state_type > $o ).

tff(pred_def_89702,type,
    v149506: state_type > $o ).

tff(pred_def_89703,type,
    v149505: state_type > $o ).

tff(pred_def_89704,type,
    v149516: state_type > $o ).

tff(pred_def_89705,type,
    v149517: state_type > $o ).

tff(pred_def_89706,type,
    v149513: state_type > $o ).

tff(pred_def_89707,type,
    v149515: state_type > $o ).

tff(pred_def_89708,type,
    v149523: state_type > $o ).

tff(pred_def_89709,type,
    v149521: state_type > $o ).

tff(pred_def_89710,type,
    v149525: state_type > $o ).

tff(pred_def_89711,type,
    v149474: state_type > $o ).

tff(pred_def_89712,type,
    v149472: state_type > $o ).

tff(pred_def_89713,type,
    v149470: state_type > $o ).

tff(pred_def_89714,type,
    v149532: state_type > $o ).

tff(pred_def_89715,type,
    v149530: state_type > $o ).

tff(pred_def_89716,type,
    v149529: state_type > $o ).

tff(pred_def_89717,type,
    v149528: state_type > $o ).

tff(pred_def_89718,type,
    v149540: state_type > $o ).

tff(pred_def_89719,type,
    v149541: state_type > $o ).

tff(pred_def_89720,type,
    v149539: state_type > $o ).

tff(pred_def_89721,type,
    v149536: ( state_type * $int ) > $o ).

tff(pred_def_89722,type,
    v149538: ( state_type * $int ) > $o ).

tff(pred_def_89723,type,
    v149527: ( state_type * $int ) > $o ).

tff(pred_def_89724,type,
    v149443: ( state_type * $int ) > $o ).

tff(pred_def_89725,type,
    v149441: ( state_type * $int ) > $o ).

tff(pred_def_89726,type,
    v149439: ( state_type * $int ) > $o ).

tff(pred_def_89727,type,
    v149551: state_type > $o ).

tff(pred_def_89728,type,
    v149549: state_type > $o ).

tff(pred_def_89729,type,
    v149548: state_type > $o ).

tff(pred_def_89730,type,
    v149547: ( state_type * $int ) > $o ).

tff(pred_def_89731,type,
    v149545: ( state_type * $int ) > $o ).

tff(pred_def_89732,type,
    v149561: state_type > $o ).

tff(pred_def_89733,type,
    v149559: state_type > $o ).

tff(pred_def_89734,type,
    v149558: state_type > $o ).

tff(pred_def_89735,type,
    v149557: ( state_type * $int ) > $o ).

tff(pred_def_89736,type,
    v149555: ( state_type * $int ) > $o ).

tff(pred_def_89737,type,
    v149571: state_type > $o ).

tff(pred_def_89738,type,
    v149569: state_type > $o ).

tff(pred_def_89739,type,
    v149568: state_type > $o ).

tff(pred_def_89740,type,
    v149567: ( state_type * $int ) > $o ).

tff(pred_def_89741,type,
    v149565: ( state_type * $int ) > $o ).

tff(pred_def_89742,type,
    v149437: ( state_type * $int ) > $o ).

tff(pred_def_89743,type,
    v149435: ( state_type * $int ) > $o ).

tff(pred_def_89744,type,
    v149428: state_type > $o ).

tff(pred_def_89745,type,
    v149426: state_type > $o ).

tff(pred_def_89746,type,
    v149424: state_type > $o ).

tff(pred_def_89747,type,
    v149422: state_type > $o ).

tff(pred_def_89748,type,
    v149420: state_type > $o ).

tff(pred_def_89749,type,
    v149418: state_type > $o ).

tff(pred_def_89750,type,
    v149591: ( state_type * $int ) > $o ).

tff(pred_def_89751,type,
    v149589: ( state_type * $int ) > $o ).

tff(pred_def_89752,type,
    v149612: state_type > $o ).

tff(pred_def_89753,type,
    v149610: state_type > $o ).

tff(pred_def_89754,type,
    v149608: state_type > $o ).

tff(pred_def_89755,type,
    v149606: state_type > $o ).

tff(pred_def_89756,type,
    v149604: state_type > $o ).

tff(pred_def_89757,type,
    v149622: state_type > $o ).

tff(pred_def_89758,type,
    v149620: state_type > $o ).

tff(pred_def_89759,type,
    v149618: state_type > $o ).

tff(pred_def_89760,type,
    v149616: state_type > $o ).

tff(pred_def_89761,type,
    v149614: state_type > $o ).

tff(pred_def_89762,type,
    v149627: ( state_type * $int ) > $o ).

tff(pred_def_89763,type,
    v149626: ( state_type * $int ) > $o ).

tff(pred_def_89764,type,
    v149624: ( state_type * $int ) > $o ).

tff(pred_def_89765,type,
    v149637: state_type > $o ).

tff(pred_def_89766,type,
    v149635: state_type > $o ).

tff(pred_def_89767,type,
    v149643: state_type > $o ).

tff(pred_def_89768,type,
    v149641: state_type > $o ).

tff(pred_def_89769,type,
    v149657: state_type > $o ).

tff(pred_def_89770,type,
    v149655: state_type > $o ).

tff(pred_def_89771,type,
    v149653: state_type > $o ).

tff(pred_def_89772,type,
    v149651: state_type > $o ).

tff(pred_def_89773,type,
    v149649: state_type > $o ).

tff(pred_def_89774,type,
    v149647: state_type > $o ).

tff(pred_def_89775,type,
    v149645: state_type > $o ).

tff(pred_def_89776,type,
    v149661: state_type > $o ).

tff(pred_def_89777,type,
    v149659: state_type > $o ).

tff(pred_def_89778,type,
    v149639: state_type > $o ).

tff(pred_def_89779,type,
    v149667: state_type > $o ).

tff(pred_def_89780,type,
    v149669: state_type > $o ).

tff(pred_def_89781,type,
    v149665: state_type > $o ).

tff(pred_def_89782,type,
    v149664: state_type > $o ).

tff(pred_def_89783,type,
    v149675: state_type > $o ).

tff(pred_def_89784,type,
    v149676: state_type > $o ).

tff(pred_def_89785,type,
    v149672: state_type > $o ).

tff(pred_def_89786,type,
    v149674: state_type > $o ).

tff(pred_def_89787,type,
    v149682: state_type > $o ).

tff(pred_def_89788,type,
    v149680: state_type > $o ).

tff(pred_def_89789,type,
    v149684: state_type > $o ).

tff(pred_def_89790,type,
    v149633: state_type > $o ).

tff(pred_def_89791,type,
    v149631: state_type > $o ).

tff(pred_def_89792,type,
    v149629: state_type > $o ).

tff(pred_def_89793,type,
    v149691: state_type > $o ).

tff(pred_def_89794,type,
    v149689: state_type > $o ).

tff(pred_def_89795,type,
    v149688: state_type > $o ).

tff(pred_def_89796,type,
    v149687: state_type > $o ).

tff(pred_def_89797,type,
    v149699: state_type > $o ).

tff(pred_def_89798,type,
    v149700: state_type > $o ).

tff(pred_def_89799,type,
    v149698: state_type > $o ).

tff(pred_def_89800,type,
    v149695: ( state_type * $int ) > $o ).

tff(pred_def_89801,type,
    v149697: ( state_type * $int ) > $o ).

tff(pred_def_89802,type,
    v149686: ( state_type * $int ) > $o ).

tff(pred_def_89803,type,
    v149602: ( state_type * $int ) > $o ).

tff(pred_def_89804,type,
    v149600: ( state_type * $int ) > $o ).

tff(pred_def_89805,type,
    v149598: ( state_type * $int ) > $o ).

tff(pred_def_89806,type,
    v149710: state_type > $o ).

tff(pred_def_89807,type,
    v149708: state_type > $o ).

tff(pred_def_89808,type,
    v149707: state_type > $o ).

tff(pred_def_89809,type,
    v149706: ( state_type * $int ) > $o ).

tff(pred_def_89810,type,
    v149704: ( state_type * $int ) > $o ).

tff(pred_def_89811,type,
    v149720: state_type > $o ).

tff(pred_def_89812,type,
    v149718: state_type > $o ).

tff(pred_def_89813,type,
    v149717: state_type > $o ).

tff(pred_def_89814,type,
    v149716: ( state_type * $int ) > $o ).

tff(pred_def_89815,type,
    v149714: ( state_type * $int ) > $o ).

tff(pred_def_89816,type,
    v149730: state_type > $o ).

tff(pred_def_89817,type,
    v149728: state_type > $o ).

tff(pred_def_89818,type,
    v149727: state_type > $o ).

tff(pred_def_89819,type,
    v149726: ( state_type * $int ) > $o ).

tff(pred_def_89820,type,
    v149724: ( state_type * $int ) > $o ).

tff(pred_def_89821,type,
    v149596: ( state_type * $int ) > $o ).

tff(pred_def_89822,type,
    v149594: ( state_type * $int ) > $o ).

tff(pred_def_89823,type,
    v149587: state_type > $o ).

tff(pred_def_89824,type,
    v149585: state_type > $o ).

tff(pred_def_89825,type,
    v149583: state_type > $o ).

tff(pred_def_89826,type,
    v149581: state_type > $o ).

tff(pred_def_89827,type,
    v149579: state_type > $o ).

tff(pred_def_89828,type,
    v149577: state_type > $o ).

tff(pred_def_89829,type,
    v149736: ( state_type * $int ) > $o ).

tff(pred_def_89830,type,
    v149744: state_type > $o ).

tff(pred_def_89831,type,
    v149743: state_type > $o ).

tff(pred_def_89832,type,
    v149742: state_type > $o ).

tff(pred_def_89833,type,
    v149741: state_type > $o ).

tff(pred_def_89834,type,
    v149740: state_type > $o ).

tff(pred_def_89835,type,
    v149739: state_type > $o ).

tff(pred_def_89836,type,
    v149751: state_type > $o ).

tff(pred_def_89837,type,
    v149750: state_type > $o ).

tff(pred_def_89838,type,
    v149753: state_type > $o ).

tff(pred_def_89839,type,
    v149752: state_type > $o ).

tff(pred_def_89840,type,
    v149749: state_type > $o ).

tff(pred_def_89841,type,
    v149748: state_type > $o ).

tff(pred_def_89842,type,
    v149747: state_type > $o ).

tff(pred_def_89843,type,
    v149746: state_type > $o ).

tff(pred_def_89844,type,
    v149759: state_type > $o ).

tff(pred_def_89845,type,
    v149757: state_type > $o ).

tff(pred_def_89846,type,
    v149756: state_type > $o ).

tff(pred_def_89847,type,
    v149755: ( state_type * $int ) > $o ).

tff(pred_def_89848,type,
    v149773: state_type > $o ).

tff(pred_def_89849,type,
    v149771: state_type > $o ).

tff(pred_def_89850,type,
    v149777: state_type > $o ).

tff(pred_def_89851,type,
    v149775: state_type > $o ).

tff(pred_def_89852,type,
    v149783: state_type > $o ).

tff(pred_def_89853,type,
    v149785: state_type > $o ).

tff(pred_def_89854,type,
    v149789: state_type > $o ).

tff(pred_def_89855,type,
    v149788: state_type > $o ).

tff(pred_def_89856,type,
    v149787: state_type > $o ).

tff(pred_def_89857,type,
    v149793: state_type > $o ).

tff(pred_def_89858,type,
    v149792: state_type > $o ).

tff(pred_def_89859,type,
    v149791: state_type > $o ).

tff(pred_def_89860,type,
    v149767: state_type > $o ).

tff(pred_def_89861,type,
    v149790: state_type > $o ).

tff(pred_def_89862,type,
    v149781: state_type > $o ).

tff(pred_def_89863,type,
    v149779: state_type > $o ).

tff(pred_def_89864,type,
    v149797: state_type > $o ).

tff(pred_def_89865,type,
    v149795: state_type > $o ).

tff(pred_def_89866,type,
    v149804: state_type > $o ).

tff(pred_def_89867,type,
    v149802: state_type > $o ).

tff(pred_def_89868,type,
    v149801: state_type > $o ).

tff(pred_def_89869,type,
    v149800: state_type > $o ).

tff(pred_def_89870,type,
    v149812: state_type > $o ).

tff(pred_def_89871,type,
    v149813: state_type > $o ).

tff(pred_def_89872,type,
    v149811: state_type > $o ).

tff(pred_def_89873,type,
    v149808: state_type > $o ).

tff(pred_def_89874,type,
    v149810: state_type > $o ).

tff(pred_def_89875,type,
    v149769: state_type > $o ).

tff(pred_def_89876,type,
    v149765: state_type > $o ).

tff(pred_def_89877,type,
    v149825: state_type > $o ).

tff(pred_def_89878,type,
    v149823: state_type > $o ).

tff(pred_def_89879,type,
    v149829: state_type > $o ).

tff(pred_def_89880,type,
    v149827: state_type > $o ).

tff(pred_def_89881,type,
    v149837: state_type > $o ).

tff(pred_def_89882,type,
    v149835: state_type > $o ).

tff(pred_def_89883,type,
    v149840: state_type > $o ).

tff(pred_def_89884,type,
    v149844: state_type > $o ).

tff(pred_def_89885,type,
    v149843: state_type > $o ).

tff(pred_def_89886,type,
    v149842: state_type > $o ).

tff(pred_def_89887,type,
    v149848: state_type > $o ).

tff(pred_def_89888,type,
    v149847: state_type > $o ).

tff(pred_def_89889,type,
    v149846: state_type > $o ).

tff(pred_def_89890,type,
    v149819: state_type > $o ).

tff(pred_def_89891,type,
    v149845: state_type > $o ).

tff(pred_def_89892,type,
    v149833: state_type > $o ).

tff(pred_def_89893,type,
    v149831: state_type > $o ).

tff(pred_def_89894,type,
    v149852: state_type > $o ).

tff(pred_def_89895,type,
    v149850: state_type > $o ).

tff(pred_def_89896,type,
    v149859: state_type > $o ).

tff(pred_def_89897,type,
    v149857: state_type > $o ).

tff(pred_def_89898,type,
    v149856: state_type > $o ).

tff(pred_def_89899,type,
    v149855: state_type > $o ).

tff(pred_def_89900,type,
    v149867: state_type > $o ).

tff(pred_def_89901,type,
    v149868: state_type > $o ).

tff(pred_def_89902,type,
    v149866: state_type > $o ).

tff(pred_def_89903,type,
    v149863: state_type > $o ).

tff(pred_def_89904,type,
    v149865: state_type > $o ).

tff(pred_def_89905,type,
    v149821: state_type > $o ).

tff(pred_def_89906,type,
    v149817: state_type > $o ).

tff(pred_def_89907,type,
    v149763: state_type > $o ).

tff(pred_def_89908,type,
    v149875: state_type > $o ).

tff(pred_def_89909,type,
    v149878: state_type > $o ).

tff(pred_def_89910,type,
    v149877: state_type > $o ).

tff(pred_def_89911,type,
    v149876: ( state_type * $int ) > $o ).

tff(pred_def_89912,type,
    v149874: ( state_type * $int ) > $o ).

tff(pred_def_89913,type,
    v149873: ( state_type * $int ) > $o ).

tff(pred_def_89914,type,
    v2876: ( state_type * $int ) > $o ).

tff(pred_def_89915,type,
    v2874: ( state_type * $int ) > $o ).

tff(pred_def_89916,type,
    v149885: state_type > $o ).

tff(pred_def_89917,type,
    v149886: state_type > $o ).

tff(pred_def_89918,type,
    v149884: state_type > $o ).

tff(pred_def_89919,type,
    v149887: state_type > $o ).

tff(pred_def_89920,type,
    v149883: state_type > $o ).

tff(pred_def_89921,type,
    v149888: state_type > $o ).

tff(pred_def_89922,type,
    v149882: state_type > $o ).

tff(pred_def_89923,type,
    v149881: state_type > $o ).

tff(pred_def_89924,type,
    v149880: state_type > $o ).

tff(pred_def_89925,type,
    v2870: state_type > $o ).

tff(pred_def_89926,type,
    v2866: state_type > $o ).

tff(pred_def_89927,type,
    v149892: state_type > $o ).

tff(pred_def_89928,type,
    v149891: ( state_type * $int ) > $o ).

tff(pred_def_89929,type,
    v149890: ( state_type * $int ) > $o ).

tff(pred_def_89930,type,
    v149896: state_type > $o ).

tff(pred_def_89931,type,
    v149895: ( state_type * $int ) > $o ).

tff(pred_def_89932,type,
    v149894: ( state_type * $int ) > $o ).

tff(pred_def_89933,type,
    v2815: ( state_type * $int ) > $o ).

tff(pred_def_89934,type,
    v149893: ( state_type * $int ) > $o ).

tff(pred_def_89935,type,
    v149889: ( state_type * $int ) > $o ).

tff(pred_def_89936,type,
    v2829: ( state_type * $int ) > $o ).

tff(pred_def_89937,type,
    v2827: ( state_type * $int ) > $o ).

tff(pred_def_89938,type,
    v149900: state_type > $o ).

tff(pred_def_89939,type,
    v149898: state_type > $o ).

tff(pred_def_89940,type,
    v149907: state_type > $o ).

tff(pred_def_89941,type,
    v149905: state_type > $o ).

tff(pred_def_89942,type,
    v149904: state_type > $o ).

tff(pred_def_89943,type,
    v149903: state_type > $o ).

tff(pred_def_89944,type,
    v149915: state_type > $o ).

tff(pred_def_89945,type,
    v149916: state_type > $o ).

tff(pred_def_89946,type,
    v149914: state_type > $o ).

tff(pred_def_89947,type,
    v149911: ( state_type * $int ) > $o ).

tff(pred_def_89948,type,
    v149913: ( state_type * $int ) > $o ).

tff(pred_def_89949,type,
    v149902: ( state_type * $int ) > $o ).

tff(pred_def_89950,type,
    v2817: ( state_type * $int ) > $o ).

tff(pred_def_89951,type,
    v149920: state_type > $o ).

tff(pred_def_89952,type,
    v2811: state_type > $o ).

tff(pred_def_89953,type,
    v149926: state_type > $o ).

tff(pred_def_89954,type,
    v149924: state_type > $o ).

tff(pred_def_89955,type,
    v149923: state_type > $o ).

tff(pred_def_89956,type,
    v149922: ( state_type * $int ) > $o ).

tff(pred_def_89957,type,
    v149934: state_type > $o ).

tff(pred_def_89958,type,
    v149932: state_type > $o ).

tff(pred_def_89959,type,
    v149931: state_type > $o ).

tff(pred_def_89960,type,
    v149930: ( state_type * $int ) > $o ).

tff(pred_def_89961,type,
    v149942: state_type > $o ).

tff(pred_def_89962,type,
    v149940: state_type > $o ).

tff(pred_def_89963,type,
    v149939: state_type > $o ).

tff(pred_def_89964,type,
    v149938: ( state_type * $int ) > $o ).

tff(pred_def_89965,type,
    v149950: state_type > $o ).

tff(pred_def_89966,type,
    v149948: state_type > $o ).

tff(pred_def_89967,type,
    v149947: state_type > $o ).

tff(pred_def_89968,type,
    v149946: ( state_type * $int ) > $o ).

tff(pred_def_89969,type,
    v149958: state_type > $o ).

tff(pred_def_89970,type,
    v149956: state_type > $o ).

tff(pred_def_89971,type,
    v149955: state_type > $o ).

tff(pred_def_89972,type,
    v149954: ( state_type * $int ) > $o ).

tff(pred_def_89973,type,
    v149966: state_type > $o ).

tff(pred_def_89974,type,
    v149964: state_type > $o ).

tff(pred_def_89975,type,
    v149963: state_type > $o ).

tff(pred_def_89976,type,
    v149962: ( state_type * $int ) > $o ).

tff(pred_def_89977,type,
    v149974: state_type > $o ).

tff(pred_def_89978,type,
    v149972: state_type > $o ).

tff(pred_def_89979,type,
    v149971: state_type > $o ).

tff(pred_def_89980,type,
    v149970: ( state_type * $int ) > $o ).

tff(pred_def_89981,type,
    v149982: state_type > $o ).

tff(pred_def_89982,type,
    v149980: state_type > $o ).

tff(pred_def_89983,type,
    v149979: state_type > $o ).

tff(pred_def_89984,type,
    v149978: ( state_type * $int ) > $o ).

tff(pred_def_89985,type,
    v149990: state_type > $o ).

tff(pred_def_89986,type,
    v149988: state_type > $o ).

tff(pred_def_89987,type,
    v149987: state_type > $o ).

tff(pred_def_89988,type,
    v149986: ( state_type * $int ) > $o ).

tff(pred_def_89989,type,
    v149998: state_type > $o ).

tff(pred_def_89990,type,
    v149996: state_type > $o ).

tff(pred_def_89991,type,
    v149995: state_type > $o ).

tff(pred_def_89992,type,
    v149994: ( state_type * $int ) > $o ).

tff(pred_def_89993,type,
    v150006: state_type > $o ).

tff(pred_def_89994,type,
    v150004: state_type > $o ).

tff(pred_def_89995,type,
    v150003: state_type > $o ).

tff(pred_def_89996,type,
    v150002: ( state_type * $int ) > $o ).

tff(pred_def_89997,type,
    v150014: state_type > $o ).

tff(pred_def_89998,type,
    v150012: state_type > $o ).

tff(pred_def_89999,type,
    v150011: state_type > $o ).

tff(pred_def_90000,type,
    v150010: ( state_type * $int ) > $o ).

tff(pred_def_90001,type,
    v150022: state_type > $o ).

tff(pred_def_90002,type,
    v150020: state_type > $o ).

tff(pred_def_90003,type,
    v150019: state_type > $o ).

tff(pred_def_90004,type,
    v150018: ( state_type * $int ) > $o ).

tff(pred_def_90005,type,
    v150030: state_type > $o ).

tff(pred_def_90006,type,
    v150028: state_type > $o ).

tff(pred_def_90007,type,
    v150027: state_type > $o ).

tff(pred_def_90008,type,
    v150026: ( state_type * $int ) > $o ).

tff(pred_def_90009,type,
    v150038: state_type > $o ).

tff(pred_def_90010,type,
    v150036: state_type > $o ).

tff(pred_def_90011,type,
    v150035: state_type > $o ).

tff(pred_def_90012,type,
    v150034: ( state_type * $int ) > $o ).

tff(pred_def_90013,type,
    v150046: state_type > $o ).

tff(pred_def_90014,type,
    v150044: state_type > $o ).

tff(pred_def_90015,type,
    v150043: state_type > $o ).

tff(pred_def_90016,type,
    v150042: ( state_type * $int ) > $o ).

tff(pred_def_90017,type,
    v150054: state_type > $o ).

tff(pred_def_90018,type,
    v150052: state_type > $o ).

tff(pred_def_90019,type,
    v150051: state_type > $o ).

tff(pred_def_90020,type,
    v150050: ( state_type * $int ) > $o ).

tff(pred_def_90021,type,
    v150062: state_type > $o ).

tff(pred_def_90022,type,
    v150060: state_type > $o ).

tff(pred_def_90023,type,
    v150059: state_type > $o ).

tff(pred_def_90024,type,
    v150058: ( state_type * $int ) > $o ).

tff(pred_def_90025,type,
    v150070: state_type > $o ).

tff(pred_def_90026,type,
    v150068: state_type > $o ).

tff(pred_def_90027,type,
    v150067: state_type > $o ).

tff(pred_def_90028,type,
    v150066: ( state_type * $int ) > $o ).

tff(pred_def_90029,type,
    v150078: state_type > $o ).

tff(pred_def_90030,type,
    v150076: state_type > $o ).

tff(pred_def_90031,type,
    v150075: state_type > $o ).

tff(pred_def_90032,type,
    v150074: ( state_type * $int ) > $o ).

tff(pred_def_90033,type,
    v150086: state_type > $o ).

tff(pred_def_90034,type,
    v150084: state_type > $o ).

tff(pred_def_90035,type,
    v150083: state_type > $o ).

tff(pred_def_90036,type,
    v150082: ( state_type * $int ) > $o ).

tff(pred_def_90037,type,
    v150094: state_type > $o ).

tff(pred_def_90038,type,
    v150092: state_type > $o ).

tff(pred_def_90039,type,
    v150091: state_type > $o ).

tff(pred_def_90040,type,
    v150090: ( state_type * $int ) > $o ).

tff(pred_def_90041,type,
    v150102: state_type > $o ).

tff(pred_def_90042,type,
    v150100: state_type > $o ).

tff(pred_def_90043,type,
    v150099: state_type > $o ).

tff(pred_def_90044,type,
    v150098: ( state_type * $int ) > $o ).

tff(pred_def_90045,type,
    v150110: state_type > $o ).

tff(pred_def_90046,type,
    v150108: state_type > $o ).

tff(pred_def_90047,type,
    v150107: state_type > $o ).

tff(pred_def_90048,type,
    v150106: ( state_type * $int ) > $o ).

tff(pred_def_90049,type,
    v150118: state_type > $o ).

tff(pred_def_90050,type,
    v150116: state_type > $o ).

tff(pred_def_90051,type,
    v150115: state_type > $o ).

tff(pred_def_90052,type,
    v150114: ( state_type * $int ) > $o ).

tff(pred_def_90053,type,
    v150126: state_type > $o ).

tff(pred_def_90054,type,
    v150124: state_type > $o ).

tff(pred_def_90055,type,
    v150123: state_type > $o ).

tff(pred_def_90056,type,
    v150122: ( state_type * $int ) > $o ).

tff(pred_def_90057,type,
    v150134: state_type > $o ).

tff(pred_def_90058,type,
    v150132: state_type > $o ).

tff(pred_def_90059,type,
    v150131: state_type > $o ).

tff(pred_def_90060,type,
    v150130: ( state_type * $int ) > $o ).

tff(pred_def_90061,type,
    v150142: state_type > $o ).

tff(pred_def_90062,type,
    v150140: state_type > $o ).

tff(pred_def_90063,type,
    v150139: state_type > $o ).

tff(pred_def_90064,type,
    v150138: ( state_type * $int ) > $o ).

tff(pred_def_90065,type,
    v150150: state_type > $o ).

tff(pred_def_90066,type,
    v150148: state_type > $o ).

tff(pred_def_90067,type,
    v150147: state_type > $o ).

tff(pred_def_90068,type,
    v150146: ( state_type * $int ) > $o ).

tff(pred_def_90069,type,
    v150158: state_type > $o ).

tff(pred_def_90070,type,
    v150156: state_type > $o ).

tff(pred_def_90071,type,
    v150155: state_type > $o ).

tff(pred_def_90072,type,
    v150154: ( state_type * $int ) > $o ).

tff(pred_def_90073,type,
    v150166: state_type > $o ).

tff(pred_def_90074,type,
    v150164: state_type > $o ).

tff(pred_def_90075,type,
    v150163: state_type > $o ).

tff(pred_def_90076,type,
    v150162: ( state_type * $int ) > $o ).

tff(pred_def_90077,type,
    v150174: state_type > $o ).

tff(pred_def_90078,type,
    v150172: state_type > $o ).

tff(pred_def_90079,type,
    v150171: state_type > $o ).

tff(pred_def_90080,type,
    v150170: ( state_type * $int ) > $o ).

tff(pred_def_90081,type,
    v150186: state_type > $o ).

tff(pred_def_90082,type,
    v150184: state_type > $o ).

tff(pred_def_90083,type,
    v150183: state_type > $o ).

tff(pred_def_90084,type,
    v150182: ( state_type * $int ) > $o ).

tff(pred_def_90085,type,
    v150194: state_type > $o ).

tff(pred_def_90086,type,
    v150192: state_type > $o ).

tff(pred_def_90087,type,
    v150191: state_type > $o ).

tff(pred_def_90088,type,
    v150190: ( state_type * $int ) > $o ).

tff(pred_def_90089,type,
    v150180: state_type > $o ).

tff(pred_def_90090,type,
    v150178: state_type > $o ).

tff(pred_def_90091,type,
    v150199: state_type > $o ).

tff(pred_def_90092,type,
    v150200: state_type > $o ).

tff(pred_def_90093,type,
    v150202: state_type > $o ).

tff(pred_def_90094,type,
    v2042: state_type > $o ).

tff(pred_def_90095,type,
    v150212: state_type > $o ).

tff(pred_def_90096,type,
    v150210: state_type > $o ).

tff(pred_def_90097,type,
    v150216: state_type > $o ).

tff(pred_def_90098,type,
    v150214: state_type > $o ).

tff(pred_def_90099,type,
    v150223: ( state_type * $int ) > $o ).

tff(pred_def_90100,type,
    v150204: state_type > $o ).

tff(pred_def_90101,type,
    v150224: state_type > $o ).

tff(pred_def_90102,type,
    v150222: ( state_type * $int ) > $o ).

tff(pred_def_90103,type,
    v150220: ( state_type * $int ) > $o ).

tff(pred_def_90104,type,
    v150218: ( state_type * $int ) > $o ).

tff(pred_def_90105,type,
    v150228: state_type > $o ).

tff(pred_def_90106,type,
    v150226: state_type > $o ).

tff(pred_def_90107,type,
    v150235: state_type > $o ).

tff(pred_def_90108,type,
    v150233: state_type > $o ).

tff(pred_def_90109,type,
    v150232: state_type > $o ).

tff(pred_def_90110,type,
    v150231: state_type > $o ).

tff(pred_def_90111,type,
    v150243: state_type > $o ).

tff(pred_def_90112,type,
    v150244: state_type > $o ).

tff(pred_def_90113,type,
    v150242: state_type > $o ).

tff(pred_def_90114,type,
    v150239: ( state_type * $int ) > $o ).

tff(pred_def_90115,type,
    v150241: ( state_type * $int ) > $o ).

tff(pred_def_90116,type,
    v150230: ( state_type * $int ) > $o ).

tff(pred_def_90117,type,
    v150208: ( state_type * $int ) > $o ).

tff(pred_def_90118,type,
    v150206: ( state_type * $int ) > $o ).

tff(pred_def_90119,type,
    v150253: state_type > $o ).

tff(pred_def_90120,type,
    v150251: state_type > $o ).

tff(pred_def_90121,type,
    v150250: state_type > $o ).

tff(pred_def_90122,type,
    v150249: ( state_type * $int ) > $o ).

tff(pred_def_90123,type,
    v150263: state_type > $o ).

tff(pred_def_90124,type,
    v150261: state_type > $o ).

tff(pred_def_90125,type,
    v150260: state_type > $o ).

tff(pred_def_90126,type,
    v150259: ( state_type * $int ) > $o ).

tff(pred_def_90127,type,
    v150257: state_type > $o ).

tff(pred_def_90128,type,
    v150267: state_type > $o ).

tff(pred_def_90129,type,
    v150269: state_type > $o ).

tff(pred_def_90130,type,
    v150268: state_type > $o ).

tff(pred_def_90131,type,
    v150275: state_type > $o ).

tff(pred_def_90132,type,
    v150273: state_type > $o ).

tff(pred_def_90133,type,
    v150272: state_type > $o ).

tff(pred_def_90134,type,
    v150271: ( state_type * $int ) > $o ).

tff(pred_def_90135,type,
    v150279: state_type > $o ).

tff(pred_def_90136,type,
    v1045: state_type > $o ).

tff(pred_def_90137,type,
    v1043: state_type > $o ).

tff(pred_def_90138,type,
    v1041: state_type > $o ).

tff(pred_def_90139,type,
    v1039: state_type > $o ).

tff(pred_def_90140,type,
    v150283: state_type > $o ).

tff(pred_def_90141,type,
    v150281: state_type > $o ).

tff(pred_def_90142,type,
    v150290: state_type > $o ).

tff(pred_def_90143,type,
    v150288: state_type > $o ).

tff(pred_def_90144,type,
    v150287: state_type > $o ).

tff(pred_def_90145,type,
    v150286: state_type > $o ).

tff(pred_def_90146,type,
    v150298: state_type > $o ).

tff(pred_def_90147,type,
    v150299: state_type > $o ).

tff(pred_def_90148,type,
    v150297: state_type > $o ).

tff(pred_def_90149,type,
    v150294: state_type > $o ).

tff(pred_def_90150,type,
    v150296: state_type > $o ).

tff(pred_def_90151,type,
    v1029: state_type > $o ).

tff(pred_def_90152,type,
    v1027: state_type > $o ).

tff(pred_def_90153,type,
    v150304: state_type > $o ).

tff(pred_def_90154,type,
    v150303: state_type > $o ).

tff(pred_def_90155,type,
    v1003: state_type > $o ).

tff(pred_def_90156,type,
    v150305: state_type > $o ).

tff(pred_def_90157,type,
    v1023: state_type > $o ).

tff(pred_def_90158,type,
    v1021: state_type > $o ).

tff(pred_def_90159,type,
    v1019: state_type > $o ).

tff(pred_def_90160,type,
    v1017: state_type > $o ).

tff(pred_def_90161,type,
    v150309: state_type > $o ).

tff(pred_def_90162,type,
    v150307: state_type > $o ).

tff(pred_def_90163,type,
    v150316: state_type > $o ).

tff(pred_def_90164,type,
    v150314: state_type > $o ).

tff(pred_def_90165,type,
    v150313: state_type > $o ).

tff(pred_def_90166,type,
    v150312: state_type > $o ).

tff(pred_def_90167,type,
    v150324: state_type > $o ).

tff(pred_def_90168,type,
    v150325: state_type > $o ).

tff(pred_def_90169,type,
    v150323: state_type > $o ).

tff(pred_def_90170,type,
    v150320: state_type > $o ).

tff(pred_def_90171,type,
    v150322: state_type > $o ).

tff(pred_def_90172,type,
    v1007: state_type > $o ).

tff(pred_def_90173,type,
    v1005: state_type > $o ).

tff(pred_def_90174,type,
    v150334: state_type > $o ).

tff(pred_def_90175,type,
    v150332: state_type > $o ).

tff(pred_def_90176,type,
    v150331: state_type > $o ).

tff(pred_def_90177,type,
    v150330: ( state_type * $int ) > $o ).

tff(pred_def_90178,type,
    v150339: state_type > $o ).

tff(pred_def_90179,type,
    v150341: state_type > $o ).

tff(pred_def_90180,type,
    v150344: state_type > $o ).

tff(pred_def_90181,type,
    v150346: state_type > $o ).

tff(pred_def_90182,type,
    v150352: state_type > $o ).

tff(pred_def_90183,type,
    v150350: state_type > $o ).

tff(pred_def_90184,type,
    v150349: state_type > $o ).

tff(pred_def_90185,type,
    v150348: ( state_type * $int ) > $o ).

tff(pred_def_90186,type,
    v150360: state_type > $o ).

tff(pred_def_90187,type,
    v150358: state_type > $o ).

tff(pred_def_90188,type,
    v150357: state_type > $o ).

tff(pred_def_90189,type,
    v150356: ( state_type * $int ) > $o ).

tff(pred_def_90190,type,
    v150368: state_type > $o ).

tff(pred_def_90191,type,
    v150366: state_type > $o ).

tff(pred_def_90192,type,
    v150365: state_type > $o ).

tff(pred_def_90193,type,
    v150364: ( state_type * $int ) > $o ).

tff(pred_def_90194,type,
    v150376: state_type > $o ).

tff(pred_def_90195,type,
    v150374: state_type > $o ).

tff(pred_def_90196,type,
    v150373: state_type > $o ).

tff(pred_def_90197,type,
    v150372: ( state_type * $int ) > $o ).

tff(pred_def_90198,type,
    v150384: state_type > $o ).

tff(pred_def_90199,type,
    v150382: state_type > $o ).

tff(pred_def_90200,type,
    v150381: state_type > $o ).

tff(pred_def_90201,type,
    v150380: ( state_type * $int ) > $o ).

tff(pred_def_90202,type,
    v150392: state_type > $o ).

tff(pred_def_90203,type,
    v150390: state_type > $o ).

tff(pred_def_90204,type,
    v150389: state_type > $o ).

tff(pred_def_90205,type,
    v150388: ( state_type * $int ) > $o ).

tff(pred_def_90206,type,
    v150400: state_type > $o ).

tff(pred_def_90207,type,
    v150398: state_type > $o ).

tff(pred_def_90208,type,
    v150397: state_type > $o ).

tff(pred_def_90209,type,
    v150396: ( state_type * $int ) > $o ).

tff(pred_def_90210,type,
    v150408: state_type > $o ).

tff(pred_def_90211,type,
    v150406: state_type > $o ).

tff(pred_def_90212,type,
    v150405: state_type > $o ).

tff(pred_def_90213,type,
    v150404: ( state_type * $int ) > $o ).

tff(pred_def_90214,type,
    v150416: state_type > $o ).

tff(pred_def_90215,type,
    v150414: state_type > $o ).

tff(pred_def_90216,type,
    v150413: state_type > $o ).

tff(pred_def_90217,type,
    v150412: ( state_type * $int ) > $o ).

tff(pred_def_90218,type,
    v150424: state_type > $o ).

tff(pred_def_90219,type,
    v150422: state_type > $o ).

tff(pred_def_90220,type,
    v150421: state_type > $o ).

tff(pred_def_90221,type,
    v150420: ( state_type * $int ) > $o ).

tff(pred_def_90222,type,
    v150432: state_type > $o ).

tff(pred_def_90223,type,
    v150430: state_type > $o ).

tff(pred_def_90224,type,
    v150429: state_type > $o ).

tff(pred_def_90225,type,
    v150428: ( state_type * $int ) > $o ).

tff(pred_def_90226,type,
    v150440: state_type > $o ).

tff(pred_def_90227,type,
    v150438: state_type > $o ).

tff(pred_def_90228,type,
    v150437: state_type > $o ).

tff(pred_def_90229,type,
    v150436: ( state_type * $int ) > $o ).

tff(pred_def_90230,type,
    v150448: state_type > $o ).

tff(pred_def_90231,type,
    v150446: state_type > $o ).

tff(pred_def_90232,type,
    v150445: state_type > $o ).

tff(pred_def_90233,type,
    v150444: ( state_type * $int ) > $o ).

tff(pred_def_90234,type,
    v150456: state_type > $o ).

tff(pred_def_90235,type,
    v150454: state_type > $o ).

tff(pred_def_90236,type,
    v150453: state_type > $o ).

tff(pred_def_90237,type,
    v150452: ( state_type * $int ) > $o ).

tff(pred_def_90238,type,
    v150464: state_type > $o ).

tff(pred_def_90239,type,
    v150462: state_type > $o ).

tff(pred_def_90240,type,
    v150461: state_type > $o ).

tff(pred_def_90241,type,
    v150460: ( state_type * $int ) > $o ).

tff(pred_def_90242,type,
    v150472: state_type > $o ).

tff(pred_def_90243,type,
    v150470: state_type > $o ).

tff(pred_def_90244,type,
    v150469: state_type > $o ).

tff(pred_def_90245,type,
    v150468: ( state_type * $int ) > $o ).

tff(pred_def_90246,type,
    v150476: state_type > $o ).

tff(pred_def_90247,type,
    v150482: state_type > $o ).

tff(pred_def_90248,type,
    v150480: state_type > $o ).

tff(pred_def_90249,type,
    v150487: state_type > $o ).

tff(pred_def_90250,type,
    v150490: state_type > $o ).

tff(pred_def_90251,type,
    v150491: state_type > $o ).

tff(pred_def_90252,type,
    v150489: state_type > $o ).

tff(pred_def_90253,type,
    v150497: state_type > $o ).

tff(pred_def_90254,type,
    v150495: state_type > $o ).

tff(pred_def_90255,type,
    v150494: state_type > $o ).

tff(pred_def_90256,type,
    v150493: ( state_type * $int ) > $o ).

tff(pred_def_90257,type,
    v150484: state_type > $o ).

tff(pred_def_90258,type,
    v150502: state_type > $o ).

tff(pred_def_90259,type,
    v150503: state_type > $o ).

tff(pred_def_90260,type,
    v150501: state_type > $o ).

tff(pred_def_90261,type,
    v150478: state_type > $o ).

tff(pred_def_90262,type,
    v150509: state_type > $o ).

tff(pred_def_90263,type,
    v150510: state_type > $o ).

tff(pred_def_90264,type,
    v150516: state_type > $o ).

tff(pred_def_90265,type,
    v150514: state_type > $o ).

tff(pred_def_90266,type,
    v150513: state_type > $o ).

tff(pred_def_90267,type,
    v150512: ( state_type * $int ) > $o ).

tff(pred_def_90268,type,
    v150506: state_type > $o ).

tff(pred_def_90269,type,
    v150521: state_type > $o ).

tff(pred_def_90270,type,
    v150522: state_type > $o ).

tff(pred_def_90271,type,
    v150520: state_type > $o ).

tff(pred_def_90272,type,
    v150524: state_type > $o ).

tff(pred_def_90273,type,
    v150525: state_type > $o ).

tff(pred_def_90274,type,
    v150531: state_type > $o ).

tff(pred_def_90275,type,
    v150529: state_type > $o ).

tff(pred_def_90276,type,
    v150528: state_type > $o ).

tff(pred_def_90277,type,
    v150527: ( state_type * $int ) > $o ).

tff(pred_def_90278,type,
    v150539: state_type > $o ).

tff(pred_def_90279,type,
    v150537: state_type > $o ).

tff(pred_def_90280,type,
    v150536: state_type > $o ).

tff(pred_def_90281,type,
    v150535: ( state_type * $int ) > $o ).

tff(pred_def_90282,type,
    v150547: state_type > $o ).

tff(pred_def_90283,type,
    v150545: state_type > $o ).

tff(pred_def_90284,type,
    v150544: state_type > $o ).

tff(pred_def_90285,type,
    v150543: ( state_type * $int ) > $o ).

tff(pred_def_90286,type,
    v150555: state_type > $o ).

tff(pred_def_90287,type,
    v150553: state_type > $o ).

tff(pred_def_90288,type,
    v150552: state_type > $o ).

tff(pred_def_90289,type,
    v150551: ( state_type * $int ) > $o ).

tff(pred_def_90290,type,
    v150563: state_type > $o ).

tff(pred_def_90291,type,
    v150561: state_type > $o ).

tff(pred_def_90292,type,
    v150560: state_type > $o ).

tff(pred_def_90293,type,
    v150559: ( state_type * $int ) > $o ).

tff(pred_def_90294,type,
    v150571: state_type > $o ).

tff(pred_def_90295,type,
    v150569: state_type > $o ).

tff(pred_def_90296,type,
    v150568: state_type > $o ).

tff(pred_def_90297,type,
    v150567: ( state_type * $int ) > $o ).

tff(pred_def_90298,type,
    v150579: state_type > $o ).

tff(pred_def_90299,type,
    v150577: state_type > $o ).

tff(pred_def_90300,type,
    v150576: state_type > $o ).

tff(pred_def_90301,type,
    v150575: ( state_type * $int ) > $o ).

tff(pred_def_90302,type,
    v150587: state_type > $o ).

tff(pred_def_90303,type,
    v150585: state_type > $o ).

tff(pred_def_90304,type,
    v150584: state_type > $o ).

tff(pred_def_90305,type,
    v150583: ( state_type * $int ) > $o ).

tff(pred_def_90306,type,
    v150595: state_type > $o ).

tff(pred_def_90307,type,
    v150593: state_type > $o ).

tff(pred_def_90308,type,
    v150592: state_type > $o ).

tff(pred_def_90309,type,
    v150591: ( state_type * $int ) > $o ).

tff(pred_def_90310,type,
    v150603: state_type > $o ).

tff(pred_def_90311,type,
    v150601: state_type > $o ).

tff(pred_def_90312,type,
    v150600: state_type > $o ).

tff(pred_def_90313,type,
    v150599: ( state_type * $int ) > $o ).

tff(pred_def_90314,type,
    v150611: state_type > $o ).

tff(pred_def_90315,type,
    v150609: state_type > $o ).

tff(pred_def_90316,type,
    v150608: state_type > $o ).

tff(pred_def_90317,type,
    v150607: ( state_type * $int ) > $o ).

tff(pred_def_90318,type,
    v150619: state_type > $o ).

tff(pred_def_90319,type,
    v150617: state_type > $o ).

tff(pred_def_90320,type,
    v150616: state_type > $o ).

tff(pred_def_90321,type,
    v150615: ( state_type * $int ) > $o ).

tff(pred_def_90322,type,
    v150627: state_type > $o ).

tff(pred_def_90323,type,
    v150625: state_type > $o ).

tff(pred_def_90324,type,
    v150624: state_type > $o ).

tff(pred_def_90325,type,
    v150623: ( state_type * $int ) > $o ).

tff(pred_def_90326,type,
    v150635: state_type > $o ).

tff(pred_def_90327,type,
    v150633: state_type > $o ).

tff(pred_def_90328,type,
    v150632: state_type > $o ).

tff(pred_def_90329,type,
    v150631: ( state_type * $int ) > $o ).

tff(pred_def_90330,type,
    v150643: state_type > $o ).

tff(pred_def_90331,type,
    v150641: state_type > $o ).

tff(pred_def_90332,type,
    v150640: state_type > $o ).

tff(pred_def_90333,type,
    v150639: ( state_type * $int ) > $o ).

tff(pred_def_90334,type,
    v150651: state_type > $o ).

tff(pred_def_90335,type,
    v150649: state_type > $o ).

tff(pred_def_90336,type,
    v150648: state_type > $o ).

tff(pred_def_90337,type,
    v150647: ( state_type * $int ) > $o ).

tff(pred_def_90338,type,
    v150659: state_type > $o ).

tff(pred_def_90339,type,
    v150657: state_type > $o ).

tff(pred_def_90340,type,
    v150656: state_type > $o ).

tff(pred_def_90341,type,
    v150655: ( state_type * $int ) > $o ).

tff(pred_def_90342,type,
    v150667: state_type > $o ).

tff(pred_def_90343,type,
    v150665: state_type > $o ).

tff(pred_def_90344,type,
    v150664: state_type > $o ).

tff(pred_def_90345,type,
    v150663: ( state_type * $int ) > $o ).

tff(pred_def_90346,type,
    v150675: state_type > $o ).

tff(pred_def_90347,type,
    v150673: state_type > $o ).

tff(pred_def_90348,type,
    v150672: state_type > $o ).

tff(pred_def_90349,type,
    v150671: ( state_type * $int ) > $o ).

tff(pred_def_90350,type,
    v150682: state_type > $o ).

tff(pred_def_90351,type,
    v150681: state_type > $o ).

tff(pred_def_90352,type,
    v150683: state_type > $o ).

tff(pred_def_90353,type,
    v150680: state_type > $o ).

tff(pred_def_90354,type,
    v150686: state_type > $o ).

tff(pred_def_90355,type,
    v150685: state_type > $o ).

tff(pred_def_90356,type,
    v150684: state_type > $o ).

tff(pred_def_90357,type,
    v150679: state_type > $o ).

tff(pred_def_90358,type,
    v150688: state_type > $o ).

tff(pred_def_90359,type,
    v150689: state_type > $o ).

tff(pred_def_90360,type,
    v150687: state_type > $o ).

tff(pred_def_90361,type,
    v150693: state_type > $o ).

tff(pred_def_90362,type,
    v150694: state_type > $o ).

tff(pred_def_90363,type,
    v150692: state_type > $o ).

tff(pred_def_90364,type,
    v150695: state_type > $o ).

tff(pred_def_90365,type,
    v150691: state_type > $o ).

tff(pred_def_90366,type,
    v150696: state_type > $o ).

tff(pred_def_90367,type,
    v775: ( state_type * $int ) > $o ).

tff(pred_def_90368,type,
    v773: ( state_type * $int ) > $o ).

tff(pred_def_90369,type,
    v771: ( state_type * $int ) > $o ).

tff(pred_def_90370,type,
    v150706: ( state_type * $int ) > $o ).

tff(pred_def_90371,type,
    v150704: ( state_type * $int ) > $o ).

tff(pred_def_90372,type,
    v150702: ( state_type * $int ) > $o ).

tff(pred_def_90373,type,
    v150700: ( state_type * $int ) > $o ).

tff(pred_def_90374,type,
    v150698: ( state_type * $int ) > $o ).

tff(pred_def_90375,type,
    v150707: ( state_type * $int ) > $o ).

tff(pred_def_90376,type,
    v769: ( state_type * $int ) > $o ).

tff(pred_def_90377,type,
    v150711: state_type > $o ).

tff(pred_def_90378,type,
    v150712: state_type > $o ).

tff(pred_def_90379,type,
    v150710: state_type > $o ).

tff(pred_def_90380,type,
    v150713: state_type > $o ).

tff(pred_def_90381,type,
    v150709: state_type > $o ).

tff(pred_def_90382,type,
    v150714: state_type > $o ).

tff(pred_def_90383,type,
    v150718: state_type > $o ).

tff(pred_def_90384,type,
    v150719: state_type > $o ).

tff(pred_def_90385,type,
    v150717: state_type > $o ).

tff(pred_def_90386,type,
    v150720: state_type > $o ).

tff(pred_def_90387,type,
    v150716: state_type > $o ).

tff(pred_def_90388,type,
    v150721: state_type > $o ).

tff(pred_def_90389,type,
    v150725: state_type > $o ).

tff(pred_def_90390,type,
    v150726: state_type > $o ).

tff(pred_def_90391,type,
    v150724: state_type > $o ).

tff(pred_def_90392,type,
    v150727: state_type > $o ).

tff(pred_def_90393,type,
    v150723: state_type > $o ).

tff(pred_def_90394,type,
    v150728: state_type > $o ).

tff(pred_def_90395,type,
    v150732: state_type > $o ).

tff(pred_def_90396,type,
    v150733: state_type > $o ).

tff(pred_def_90397,type,
    v150731: state_type > $o ).

tff(pred_def_90398,type,
    v150734: state_type > $o ).

tff(pred_def_90399,type,
    v150730: state_type > $o ).

tff(pred_def_90400,type,
    v150735: state_type > $o ).

tff(pred_def_90401,type,
    v150739: state_type > $o ).

tff(pred_def_90402,type,
    v150740: state_type > $o ).

tff(pred_def_90403,type,
    v150738: state_type > $o ).

tff(pred_def_90404,type,
    v150741: state_type > $o ).

tff(pred_def_90405,type,
    v150737: state_type > $o ).

tff(pred_def_90406,type,
    v150742: state_type > $o ).

tff(pred_def_90407,type,
    v150746: state_type > $o ).

tff(pred_def_90408,type,
    v150747: state_type > $o ).

tff(pred_def_90409,type,
    v150745: state_type > $o ).

tff(pred_def_90410,type,
    v150748: state_type > $o ).

tff(pred_def_90411,type,
    v150744: state_type > $o ).

tff(pred_def_90412,type,
    v150749: state_type > $o ).

tff(pred_def_90413,type,
    v150753: state_type > $o ).

tff(pred_def_90414,type,
    v150754: state_type > $o ).

tff(pred_def_90415,type,
    v150752: state_type > $o ).

tff(pred_def_90416,type,
    v150755: state_type > $o ).

tff(pred_def_90417,type,
    v150751: state_type > $o ).

tff(pred_def_90418,type,
    v150756: state_type > $o ).

tff(pred_def_90419,type,
    v150758: state_type > $o ).

tff(pred_def_90420,type,
    v763: ( state_type * $int ) > $o ).

tff(pred_def_90421,type,
    v150760: state_type > $o ).

tff(pred_def_90422,type,
    v150762: state_type > $o ).

tff(pred_def_90423,type,
    v150764: state_type > $o ).

tff(pred_def_90424,type,
    v150766: state_type > $o ).

tff(pred_def_90425,type,
    v150768: state_type > $o ).

tff(pred_def_90426,type,
    v150770: state_type > $o ).

tff(pred_def_90427,type,
    v150772: state_type > $o ).

tff(pred_def_90428,type,
    v761: ( state_type * $int ) > $o ).

tff(pred_def_90429,type,
    v759: ( state_type * $int ) > $o ).

tff(pred_def_90430,type,
    v757: ( state_type * $int ) > $o ).

tff(pred_def_90431,type,
    v150776: state_type > $o ).

tff(pred_def_90432,type,
    v150774: state_type > $o ).

tff(pred_def_90433,type,
    v150783: state_type > $o ).

tff(pred_def_90434,type,
    v150781: state_type > $o ).

tff(pred_def_90435,type,
    v150780: state_type > $o ).

tff(pred_def_90436,type,
    v150779: state_type > $o ).

tff(pred_def_90437,type,
    v150791: state_type > $o ).

tff(pred_def_90438,type,
    v150792: state_type > $o ).

tff(pred_def_90439,type,
    v150790: state_type > $o ).

tff(pred_def_90440,type,
    v150787: ( state_type * $int ) > $o ).

tff(pred_def_90441,type,
    v150789: ( state_type * $int ) > $o ).

tff(pred_def_90442,type,
    v747: ( state_type * $int ) > $o ).

tff(pred_def_90443,type,
    v745: ( state_type * $int ) > $o ).

tff(pred_def_90444,type,
    v130432: state_type > $o ).

tff(pred_def_90445,type,
    v741: state_type > $o ).

tff(pred_def_90446,type,
    v150798: state_type > $o ).

tff(pred_def_90447,type,
    v150802: state_type > $o ).

tff(pred_def_90448,type,
    v150801: state_type > $o ).

tff(pred_def_90449,type,
    v150800: state_type > $o ).

tff(pred_def_90450,type,
    v150809: state_type > $o ).

tff(pred_def_90451,type,
    v150808: state_type > $o ).

tff(pred_def_90452,type,
    v150807: state_type > $o ).

tff(pred_def_90453,type,
    v150810: state_type > $o ).

tff(pred_def_90454,type,
    v150806: state_type > $o ).

tff(pred_def_90455,type,
    v150811: state_type > $o ).

tff(pred_def_90456,type,
    v150805: state_type > $o ).

tff(pred_def_90457,type,
    v150814: state_type > $o ).

tff(pred_def_90458,type,
    v150815: state_type > $o ).

tff(pred_def_90459,type,
    v150813: state_type > $o ).

tff(pred_def_90460,type,
    v150816: state_type > $o ).

tff(pred_def_90461,type,
    v150812: state_type > $o ).

tff(pred_def_90462,type,
    v150819: state_type > $o ).

tff(pred_def_90463,type,
    v150820: state_type > $o ).

tff(pred_def_90464,type,
    v150818: state_type > $o ).

tff(pred_def_90465,type,
    v150821: state_type > $o ).

tff(pred_def_90466,type,
    v150817: state_type > $o ).

tff(pred_def_90467,type,
    v150803: ( state_type * $int ) > $o ).

tff(pred_def_90468,type,
    v150824: state_type > $o ).

tff(pred_def_90469,type,
    v150825: state_type > $o ).

tff(pred_def_90470,type,
    v150823: state_type > $o ).

tff(pred_def_90471,type,
    v150834: state_type > $o ).

tff(pred_def_90472,type,
    v150833: state_type > $o ).

tff(pred_def_90473,type,
    v150832: state_type > $o ).

tff(pred_def_90474,type,
    v150831: state_type > $o ).

tff(pred_def_90475,type,
    v150830: state_type > $o ).

tff(pred_def_90476,type,
    v150829: state_type > $o ).

tff(pred_def_90477,type,
    v150835: state_type > $o ).

tff(pred_def_90478,type,
    v150828: state_type > $o ).

tff(pred_def_90479,type,
    v150838: state_type > $o ).

tff(pred_def_90480,type,
    v150837: state_type > $o ).

tff(pred_def_90481,type,
    v150839: state_type > $o ).

tff(pred_def_90482,type,
    v150836: state_type > $o ).

tff(pred_def_90483,type,
    v150841: state_type > $o ).

tff(pred_def_90484,type,
    v150842: state_type > $o ).

tff(pred_def_90485,type,
    v150840: state_type > $o ).

tff(pred_def_90486,type,
    v150826: ( state_type * $int ) > $o ).

tff(pred_def_90487,type,
    v150822: ( state_type * $int ) > $o ).

tff(pred_def_90488,type,
    v168: ( state_type * $int ) > $o ).

tff(pred_def_90489,type,
    v166: ( state_type * $int ) > $o ).

tff(pred_def_90490,type,
    v164: ( state_type * $int ) > $o ).

tff(pred_def_90491,type,
    v162: ( state_type * $int ) > $o ).

tff(pred_def_90492,type,
    v150846: state_type > $o ).

tff(pred_def_90493,type,
    v150844: state_type > $o ).

tff(pred_def_90494,type,
    v150853: state_type > $o ).

tff(pred_def_90495,type,
    v150851: state_type > $o ).

tff(pred_def_90496,type,
    v150850: state_type > $o ).

tff(pred_def_90497,type,
    v150849: state_type > $o ).

tff(pred_def_90498,type,
    v150861: state_type > $o ).

tff(pred_def_90499,type,
    v150862: state_type > $o ).

tff(pred_def_90500,type,
    v150860: state_type > $o ).

tff(pred_def_90501,type,
    v150857: ( state_type * $int ) > $o ).

tff(pred_def_90502,type,
    v150859: ( state_type * $int ) > $o ).

tff(pred_def_90503,type,
    v140: ( state_type * $int ) > $o ).

tff(pred_def_90504,type,
    v138: ( state_type * $int ) > $o ).

tff(pred_def_90505,type,
    v150870: state_type > $o ).

tff(pred_def_90506,type,
    v150871: state_type > $o ).

tff(pred_def_90507,type,
    v150872: state_type > $o ).

tff(pred_def_90508,type,
    v150873: state_type > $o ).

tff(pred_def_90509,type,
    v150874: state_type > $o ).

tff(pred_def_90510,type,
    v150875: state_type > $o ).

tff(pred_def_90511,type,
    v150876: state_type > $o ).

tff(pred_def_90512,type,
    v150877: state_type > $o ).

tff(pred_def_90513,type,
    v150878: state_type > $o ).

tff(pred_def_90514,type,
    v150879: state_type > $o ).

tff(pred_def_90515,type,
    v150880: state_type > $o ).

tff(pred_def_90516,type,
    v150881: state_type > $o ).

tff(pred_def_90517,type,
    v150882: state_type > $o ).

tff(pred_def_90518,type,
    v150883: state_type > $o ).

tff(pred_def_90519,type,
    v150884: state_type > $o ).

tff(pred_def_90520,type,
    v150885: state_type > $o ).

tff(pred_def_90521,type,
    v150868: ( state_type * $int ) > $o ).

tff(pred_def_90522,type,
    v150902: ( state_type * $int ) > $o ).

tff(pred_def_90523,type,
    v150901: state_type > $o ).

tff(pred_def_90524,type,
    v150900: state_type > $o ).

tff(pred_def_90525,type,
    v150899: state_type > $o ).

tff(pred_def_90526,type,
    v150898: state_type > $o ).

tff(pred_def_90527,type,
    v150897: state_type > $o ).

tff(pred_def_90528,type,
    v150896: state_type > $o ).

tff(pred_def_90529,type,
    v150895: state_type > $o ).

tff(pred_def_90530,type,
    v150894: state_type > $o ).

tff(pred_def_90531,type,
    v150893: state_type > $o ).

tff(pred_def_90532,type,
    v150892: state_type > $o ).

tff(pred_def_90533,type,
    v150891: state_type > $o ).

tff(pred_def_90534,type,
    v150890: state_type > $o ).

tff(pred_def_90535,type,
    v150889: state_type > $o ).

tff(pred_def_90536,type,
    v150888: state_type > $o ).

tff(pred_def_90537,type,
    v150866: state_type > $o ).

tff(pred_def_90538,type,
    v150907: state_type > $o ).

tff(pred_def_90539,type,
    v150906: state_type > $o ).

tff(pred_def_90540,type,
    v150905: ( state_type * $int ) > $o ).

tff(pred_def_90541,type,
    v150904: ( state_type * $int ) > $o ).

tff(pred_def_90542,type,
    v150921: state_type > $o ).

tff(pred_def_90543,type,
    v150920: state_type > $o ).

tff(pred_def_90544,type,
    v150922: state_type > $o ).

tff(pred_def_90545,type,
    v150919: state_type > $o ).

tff(pred_def_90546,type,
    v150918: state_type > $o ).

tff(pred_def_90547,type,
    v150926: state_type > $o ).

tff(pred_def_90548,type,
    v150925: state_type > $o ).

tff(pred_def_90549,type,
    v150927: state_type > $o ).

tff(pred_def_90550,type,
    v150924: state_type > $o ).

tff(pred_def_90551,type,
    v150923: state_type > $o ).

tff(pred_def_90552,type,
    v150917: state_type > $o ).

tff(pred_def_90553,type,
    v150931: state_type > $o ).

tff(pred_def_90554,type,
    v150930: state_type > $o ).

tff(pred_def_90555,type,
    v150932: state_type > $o ).

tff(pred_def_90556,type,
    v150929: state_type > $o ).

tff(pred_def_90557,type,
    v150928: state_type > $o ).

tff(pred_def_90558,type,
    v150916: state_type > $o ).

tff(pred_def_90559,type,
    v150936: state_type > $o ).

tff(pred_def_90560,type,
    v150935: state_type > $o ).

tff(pred_def_90561,type,
    v150937: state_type > $o ).

tff(pred_def_90562,type,
    v150934: state_type > $o ).

tff(pred_def_90563,type,
    v150933: state_type > $o ).

tff(pred_def_90564,type,
    v150915: state_type > $o ).

tff(pred_def_90565,type,
    v150913: state_type > $o ).

tff(pred_def_90566,type,
    v150938: state_type > $o ).

tff(pred_def_90567,type,
    v150912: state_type > $o ).

tff(pred_def_90568,type,
    v150939: state_type > $o ).

tff(pred_def_90569,type,
    v150911: state_type > $o ).

tff(pred_def_90570,type,
    v150910: state_type > $o ).

tff(pred_def_90571,type,
    v150909: state_type > $o ).

tff(pred_def_90572,type,
    v150908: ( state_type * $int ) > $o ).

tff(pred_def_90573,type,
    v132: ( state_type * $int ) > $o ).

tff(pred_def_90574,type,
    v130: ( state_type * $int ) > $o ).

tff(pred_def_90575,type,
    v150946: ( state_type * $int ) > $o ).

tff(pred_def_90576,type,
    v150945: ( state_type * $int ) > $o ).

tff(pred_def_90577,type,
    v150944: ( state_type * $int ) > $o ).

tff(pred_def_90578,type,
    v150943: ( state_type * $int ) > $o ).

tff(pred_def_90579,type,
    v150942: ( state_type * $int ) > $o ).

tff(pred_def_90580,type,
    v150941: ( state_type * $int ) > $o ).

tff(pred_def_90581,type,
    v126: ( state_type * $int ) > $o ).

tff(pred_def_90582,type,
    v150963: ( state_type * $int ) > $o ).

tff(pred_def_90583,type,
    v150962: state_type > $o ).

tff(pred_def_90584,type,
    v150961: state_type > $o ).

tff(pred_def_90585,type,
    v150960: state_type > $o ).

tff(pred_def_90586,type,
    v150959: state_type > $o ).

tff(pred_def_90587,type,
    v150958: state_type > $o ).

tff(pred_def_90588,type,
    v150957: state_type > $o ).

tff(pred_def_90589,type,
    v150956: state_type > $o ).

tff(pred_def_90590,type,
    v150955: state_type > $o ).

tff(pred_def_90591,type,
    v150954: state_type > $o ).

tff(pred_def_90592,type,
    v150953: state_type > $o ).

tff(pred_def_90593,type,
    v150952: state_type > $o ).

tff(pred_def_90594,type,
    v150951: state_type > $o ).

tff(pred_def_90595,type,
    v150950: state_type > $o ).

tff(pred_def_90596,type,
    v150949: state_type > $o ).

tff(pred_def_90597,type,
    v124: state_type > $o ).

tff(pred_def_90598,type,
    v150971: ( state_type * $int ) > $o ).

tff(pred_def_90599,type,
    v150969: ( state_type * $int ) > $o ).

tff(pred_def_90600,type,
    v150967: ( state_type * $int ) > $o ).

tff(pred_def_90601,type,
    v150977: state_type > $o ).

tff(pred_def_90602,type,
    v150975: state_type > $o ).

tff(pred_def_90603,type,
    v150973: state_type > $o ).

tff(pred_def_90604,type,
    v150996: ( state_type * $int ) > $o ).

tff(pred_def_90605,type,
    v150995: state_type > $o ).

tff(pred_def_90606,type,
    v150994: state_type > $o ).

tff(pred_def_90607,type,
    v150993: state_type > $o ).

tff(pred_def_90608,type,
    v150992: state_type > $o ).

tff(pred_def_90609,type,
    v150991: state_type > $o ).

tff(pred_def_90610,type,
    v150990: state_type > $o ).

tff(pred_def_90611,type,
    v150989: state_type > $o ).

tff(pred_def_90612,type,
    v150988: state_type > $o ).

tff(pred_def_90613,type,
    v150987: state_type > $o ).

tff(pred_def_90614,type,
    v150986: state_type > $o ).

tff(pred_def_90615,type,
    v150985: state_type > $o ).

tff(pred_def_90616,type,
    v150984: state_type > $o ).

tff(pred_def_90617,type,
    v150983: state_type > $o ).

tff(pred_def_90618,type,
    v150982: state_type > $o ).

tff(pred_def_90619,type,
    v150980: state_type > $o ).

tff(pred_def_90620,type,
    v150997: state_type > $o ).

tff(pred_def_90621,type,
    v150979: state_type > $o ).

tff(pred_def_90622,type,
    v151000: state_type > $o ).

tff(pred_def_90623,type,
    v151008: state_type > $o ).

tff(pred_def_90624,type,
    v151007: state_type > $o ).

tff(pred_def_90625,type,
    v151009: state_type > $o ).

tff(pred_def_90626,type,
    v151006: state_type > $o ).

tff(pred_def_90627,type,
    v151005: state_type > $o ).

tff(pred_def_90628,type,
    v151013: state_type > $o ).

tff(pred_def_90629,type,
    v151012: state_type > $o ).

tff(pred_def_90630,type,
    v151014: state_type > $o ).

tff(pred_def_90631,type,
    v151011: state_type > $o ).

tff(pred_def_90632,type,
    v151010: state_type > $o ).

tff(pred_def_90633,type,
    v151004: state_type > $o ).

tff(pred_def_90634,type,
    v151018: state_type > $o ).

tff(pred_def_90635,type,
    v151017: state_type > $o ).

tff(pred_def_90636,type,
    v151019: state_type > $o ).

tff(pred_def_90637,type,
    v151016: state_type > $o ).

tff(pred_def_90638,type,
    v151015: state_type > $o ).

tff(pred_def_90639,type,
    v151003: state_type > $o ).

tff(pred_def_90640,type,
    v151001: state_type > $o ).

tff(pred_def_90641,type,
    v150999: state_type > $o ).

tff(pred_def_90642,type,
    v151021: ( state_type * $int ) > $o ).

tff(pred_def_90643,type,
    v151020: state_type > $o ).

tff(pred_def_90644,type,
    v150998: state_type > $o ).

tff(pred_def_90645,type,
    v150965: ( state_type * $int ) > $o ).

tff(pred_def_90646,type,
    v151027: ( state_type * $int ) > $o ).

tff(pred_def_90647,type,
    v151025: ( state_type * $int ) > $o ).

tff(pred_def_90648,type,
    v151023: ( state_type * $int ) > $o ).

tff(pred_def_90649,type,
    v151033: state_type > $o ).

tff(pred_def_90650,type,
    v151031: state_type > $o ).

tff(pred_def_90651,type,
    v151029: state_type > $o ).

tff(pred_def_90652,type,
    v151052: ( state_type * $int ) > $o ).

tff(pred_def_90653,type,
    v151051: state_type > $o ).

tff(pred_def_90654,type,
    v151050: state_type > $o ).

tff(pred_def_90655,type,
    v151049: state_type > $o ).

tff(pred_def_90656,type,
    v151048: state_type > $o ).

tff(pred_def_90657,type,
    v151047: state_type > $o ).

tff(pred_def_90658,type,
    v151046: state_type > $o ).

tff(pred_def_90659,type,
    v151045: state_type > $o ).

tff(pred_def_90660,type,
    v151044: state_type > $o ).

tff(pred_def_90661,type,
    v151043: state_type > $o ).

tff(pred_def_90662,type,
    v151042: state_type > $o ).

tff(pred_def_90663,type,
    v151041: state_type > $o ).

tff(pred_def_90664,type,
    v151040: state_type > $o ).

tff(pred_def_90665,type,
    v151039: state_type > $o ).

tff(pred_def_90666,type,
    v151038: state_type > $o ).

tff(pred_def_90667,type,
    v151036: state_type > $o ).

tff(pred_def_90668,type,
    v151053: state_type > $o ).

tff(pred_def_90669,type,
    v151035: state_type > $o ).

tff(pred_def_90670,type,
    v151056: state_type > $o ).

tff(pred_def_90671,type,
    v151064: state_type > $o ).

tff(pred_def_90672,type,
    v151063: state_type > $o ).

tff(pred_def_90673,type,
    v151065: state_type > $o ).

tff(pred_def_90674,type,
    v151062: state_type > $o ).

tff(pred_def_90675,type,
    v151061: state_type > $o ).

tff(pred_def_90676,type,
    v151069: state_type > $o ).

tff(pred_def_90677,type,
    v151068: state_type > $o ).

tff(pred_def_90678,type,
    v151070: state_type > $o ).

tff(pred_def_90679,type,
    v151067: state_type > $o ).

tff(pred_def_90680,type,
    v151066: state_type > $o ).

tff(pred_def_90681,type,
    v151060: state_type > $o ).

tff(pred_def_90682,type,
    v151074: state_type > $o ).

tff(pred_def_90683,type,
    v151073: state_type > $o ).

tff(pred_def_90684,type,
    v151075: state_type > $o ).

tff(pred_def_90685,type,
    v151072: state_type > $o ).

tff(pred_def_90686,type,
    v151071: state_type > $o ).

tff(pred_def_90687,type,
    v151059: state_type > $o ).

tff(pred_def_90688,type,
    v151057: state_type > $o ).

tff(pred_def_90689,type,
    v151055: state_type > $o ).

tff(pred_def_90690,type,
    v151077: ( state_type * $int ) > $o ).

tff(pred_def_90691,type,
    v151076: state_type > $o ).

tff(pred_def_90692,type,
    v151054: state_type > $o ).

tff(pred_def_90693,type,
    v151083: ( state_type * $int ) > $o ).

tff(pred_def_90694,type,
    v151081: ( state_type * $int ) > $o ).

tff(pred_def_90695,type,
    v151079: ( state_type * $int ) > $o ).

tff(pred_def_90696,type,
    v151089: state_type > $o ).

tff(pred_def_90697,type,
    v151087: state_type > $o ).

tff(pred_def_90698,type,
    v151085: state_type > $o ).

tff(pred_def_90699,type,
    v151108: ( state_type * $int ) > $o ).

tff(pred_def_90700,type,
    v151107: state_type > $o ).

tff(pred_def_90701,type,
    v151106: state_type > $o ).

tff(pred_def_90702,type,
    v151105: state_type > $o ).

tff(pred_def_90703,type,
    v151104: state_type > $o ).

tff(pred_def_90704,type,
    v151103: state_type > $o ).

tff(pred_def_90705,type,
    v151102: state_type > $o ).

tff(pred_def_90706,type,
    v151101: state_type > $o ).

tff(pred_def_90707,type,
    v151100: state_type > $o ).

tff(pred_def_90708,type,
    v151099: state_type > $o ).

tff(pred_def_90709,type,
    v151098: state_type > $o ).

tff(pred_def_90710,type,
    v151097: state_type > $o ).

tff(pred_def_90711,type,
    v151096: state_type > $o ).

tff(pred_def_90712,type,
    v151095: state_type > $o ).

tff(pred_def_90713,type,
    v151094: state_type > $o ).

tff(pred_def_90714,type,
    v151092: state_type > $o ).

tff(pred_def_90715,type,
    v151109: state_type > $o ).

tff(pred_def_90716,type,
    v151091: state_type > $o ).

tff(pred_def_90717,type,
    v151112: state_type > $o ).

tff(pred_def_90718,type,
    v151120: state_type > $o ).

tff(pred_def_90719,type,
    v151119: state_type > $o ).

tff(pred_def_90720,type,
    v151121: state_type > $o ).

tff(pred_def_90721,type,
    v151118: state_type > $o ).

tff(pred_def_90722,type,
    v151117: state_type > $o ).

tff(pred_def_90723,type,
    v151125: state_type > $o ).

tff(pred_def_90724,type,
    v151124: state_type > $o ).

tff(pred_def_90725,type,
    v151126: state_type > $o ).

tff(pred_def_90726,type,
    v151123: state_type > $o ).

tff(pred_def_90727,type,
    v151122: state_type > $o ).

tff(pred_def_90728,type,
    v151116: state_type > $o ).

tff(pred_def_90729,type,
    v151130: state_type > $o ).

tff(pred_def_90730,type,
    v151129: state_type > $o ).

tff(pred_def_90731,type,
    v151131: state_type > $o ).

tff(pred_def_90732,type,
    v151128: state_type > $o ).

tff(pred_def_90733,type,
    v151127: state_type > $o ).

tff(pred_def_90734,type,
    v151115: state_type > $o ).

tff(pred_def_90735,type,
    v151113: state_type > $o ).

tff(pred_def_90736,type,
    v151111: state_type > $o ).

tff(pred_def_90737,type,
    v151133: ( state_type * $int ) > $o ).

tff(pred_def_90738,type,
    v151132: state_type > $o ).

tff(pred_def_90739,type,
    v151110: state_type > $o ).

tff(pred_def_90740,type,
    v151139: ( state_type * $int ) > $o ).

tff(pred_def_90741,type,
    v151137: ( state_type * $int ) > $o ).

tff(pred_def_90742,type,
    v151135: ( state_type * $int ) > $o ).

tff(pred_def_90743,type,
    v151145: state_type > $o ).

tff(pred_def_90744,type,
    v151143: state_type > $o ).

tff(pred_def_90745,type,
    v151141: state_type > $o ).

tff(pred_def_90746,type,
    v151164: ( state_type * $int ) > $o ).

tff(pred_def_90747,type,
    v151163: state_type > $o ).

tff(pred_def_90748,type,
    v151162: state_type > $o ).

tff(pred_def_90749,type,
    v151161: state_type > $o ).

tff(pred_def_90750,type,
    v151160: state_type > $o ).

tff(pred_def_90751,type,
    v151159: state_type > $o ).

tff(pred_def_90752,type,
    v151158: state_type > $o ).

tff(pred_def_90753,type,
    v151157: state_type > $o ).

tff(pred_def_90754,type,
    v151156: state_type > $o ).

tff(pred_def_90755,type,
    v151155: state_type > $o ).

tff(pred_def_90756,type,
    v151154: state_type > $o ).

tff(pred_def_90757,type,
    v151153: state_type > $o ).

tff(pred_def_90758,type,
    v151152: state_type > $o ).

tff(pred_def_90759,type,
    v151151: state_type > $o ).

tff(pred_def_90760,type,
    v151150: state_type > $o ).

tff(pred_def_90761,type,
    v151148: state_type > $o ).

tff(pred_def_90762,type,
    v151165: state_type > $o ).

tff(pred_def_90763,type,
    v151147: state_type > $o ).

tff(pred_def_90764,type,
    v151168: state_type > $o ).

tff(pred_def_90765,type,
    v151176: state_type > $o ).

tff(pred_def_90766,type,
    v151175: state_type > $o ).

tff(pred_def_90767,type,
    v151177: state_type > $o ).

tff(pred_def_90768,type,
    v151174: state_type > $o ).

tff(pred_def_90769,type,
    v151173: state_type > $o ).

tff(pred_def_90770,type,
    v151181: state_type > $o ).

tff(pred_def_90771,type,
    v151180: state_type > $o ).

tff(pred_def_90772,type,
    v151182: state_type > $o ).

tff(pred_def_90773,type,
    v151179: state_type > $o ).

tff(pred_def_90774,type,
    v151178: state_type > $o ).

tff(pred_def_90775,type,
    v151172: state_type > $o ).

tff(pred_def_90776,type,
    v151186: state_type > $o ).

tff(pred_def_90777,type,
    v151185: state_type > $o ).

tff(pred_def_90778,type,
    v151187: state_type > $o ).

tff(pred_def_90779,type,
    v151184: state_type > $o ).

tff(pred_def_90780,type,
    v151183: state_type > $o ).

tff(pred_def_90781,type,
    v151171: state_type > $o ).

tff(pred_def_90782,type,
    v151169: state_type > $o ).

tff(pred_def_90783,type,
    v151167: state_type > $o ).

tff(pred_def_90784,type,
    v151189: ( state_type * $int ) > $o ).

tff(pred_def_90785,type,
    v151188: state_type > $o ).

tff(pred_def_90786,type,
    v151166: state_type > $o ).

tff(pred_def_90787,type,
    v151195: ( state_type * $int ) > $o ).

tff(pred_def_90788,type,
    v151193: ( state_type * $int ) > $o ).

tff(pred_def_90789,type,
    v151191: ( state_type * $int ) > $o ).

tff(pred_def_90790,type,
    v151201: state_type > $o ).

tff(pred_def_90791,type,
    v151199: state_type > $o ).

tff(pred_def_90792,type,
    v151197: state_type > $o ).

tff(pred_def_90793,type,
    v151220: ( state_type * $int ) > $o ).

tff(pred_def_90794,type,
    v151219: state_type > $o ).

tff(pred_def_90795,type,
    v151218: state_type > $o ).

tff(pred_def_90796,type,
    v151217: state_type > $o ).

tff(pred_def_90797,type,
    v151216: state_type > $o ).

tff(pred_def_90798,type,
    v151215: state_type > $o ).

tff(pred_def_90799,type,
    v151214: state_type > $o ).

tff(pred_def_90800,type,
    v151213: state_type > $o ).

tff(pred_def_90801,type,
    v151212: state_type > $o ).

tff(pred_def_90802,type,
    v151211: state_type > $o ).

tff(pred_def_90803,type,
    v151210: state_type > $o ).

tff(pred_def_90804,type,
    v151209: state_type > $o ).

tff(pred_def_90805,type,
    v151208: state_type > $o ).

tff(pred_def_90806,type,
    v151207: state_type > $o ).

tff(pred_def_90807,type,
    v151206: state_type > $o ).

tff(pred_def_90808,type,
    v151204: state_type > $o ).

tff(pred_def_90809,type,
    v151221: state_type > $o ).

tff(pred_def_90810,type,
    v151203: state_type > $o ).

tff(pred_def_90811,type,
    v151224: state_type > $o ).

tff(pred_def_90812,type,
    v151232: state_type > $o ).

tff(pred_def_90813,type,
    v151231: state_type > $o ).

tff(pred_def_90814,type,
    v151233: state_type > $o ).

tff(pred_def_90815,type,
    v151230: state_type > $o ).

tff(pred_def_90816,type,
    v151229: state_type > $o ).

tff(pred_def_90817,type,
    v151237: state_type > $o ).

tff(pred_def_90818,type,
    v151236: state_type > $o ).

tff(pred_def_90819,type,
    v151238: state_type > $o ).

tff(pred_def_90820,type,
    v151235: state_type > $o ).

tff(pred_def_90821,type,
    v151234: state_type > $o ).

tff(pred_def_90822,type,
    v151228: state_type > $o ).

tff(pred_def_90823,type,
    v151242: state_type > $o ).

tff(pred_def_90824,type,
    v151241: state_type > $o ).

tff(pred_def_90825,type,
    v151243: state_type > $o ).

tff(pred_def_90826,type,
    v151240: state_type > $o ).

tff(pred_def_90827,type,
    v151239: state_type > $o ).

tff(pred_def_90828,type,
    v151227: state_type > $o ).

tff(pred_def_90829,type,
    v151225: state_type > $o ).

tff(pred_def_90830,type,
    v151223: state_type > $o ).

tff(pred_def_90831,type,
    v151245: ( state_type * $int ) > $o ).

tff(pred_def_90832,type,
    v151244: state_type > $o ).

tff(pred_def_90833,type,
    v151222: state_type > $o ).

tff(pred_def_90834,type,
    v151251: ( state_type * $int ) > $o ).

tff(pred_def_90835,type,
    v151249: ( state_type * $int ) > $o ).

tff(pred_def_90836,type,
    v151247: ( state_type * $int ) > $o ).

tff(pred_def_90837,type,
    v151257: state_type > $o ).

tff(pred_def_90838,type,
    v151255: state_type > $o ).

tff(pred_def_90839,type,
    v151253: state_type > $o ).

tff(pred_def_90840,type,
    v151276: ( state_type * $int ) > $o ).

tff(pred_def_90841,type,
    v151275: state_type > $o ).

tff(pred_def_90842,type,
    v151274: state_type > $o ).

tff(pred_def_90843,type,
    v151273: state_type > $o ).

tff(pred_def_90844,type,
    v151272: state_type > $o ).

tff(pred_def_90845,type,
    v151271: state_type > $o ).

tff(pred_def_90846,type,
    v151270: state_type > $o ).

tff(pred_def_90847,type,
    v151269: state_type > $o ).

tff(pred_def_90848,type,
    v151268: state_type > $o ).

tff(pred_def_90849,type,
    v151267: state_type > $o ).

tff(pred_def_90850,type,
    v151266: state_type > $o ).

tff(pred_def_90851,type,
    v151265: state_type > $o ).

tff(pred_def_90852,type,
    v151264: state_type > $o ).

tff(pred_def_90853,type,
    v151263: state_type > $o ).

tff(pred_def_90854,type,
    v151262: state_type > $o ).

tff(pred_def_90855,type,
    v151260: state_type > $o ).

tff(pred_def_90856,type,
    v151277: state_type > $o ).

tff(pred_def_90857,type,
    v151259: state_type > $o ).

tff(pred_def_90858,type,
    v151280: state_type > $o ).

tff(pred_def_90859,type,
    v151288: state_type > $o ).

tff(pred_def_90860,type,
    v151287: state_type > $o ).

tff(pred_def_90861,type,
    v151289: state_type > $o ).

tff(pred_def_90862,type,
    v151286: state_type > $o ).

tff(pred_def_90863,type,
    v151285: state_type > $o ).

tff(pred_def_90864,type,
    v151293: state_type > $o ).

tff(pred_def_90865,type,
    v151292: state_type > $o ).

tff(pred_def_90866,type,
    v151294: state_type > $o ).

tff(pred_def_90867,type,
    v151291: state_type > $o ).

tff(pred_def_90868,type,
    v151290: state_type > $o ).

tff(pred_def_90869,type,
    v151284: state_type > $o ).

tff(pred_def_90870,type,
    v151298: state_type > $o ).

tff(pred_def_90871,type,
    v151297: state_type > $o ).

tff(pred_def_90872,type,
    v151299: state_type > $o ).

tff(pred_def_90873,type,
    v151296: state_type > $o ).

tff(pred_def_90874,type,
    v151295: state_type > $o ).

tff(pred_def_90875,type,
    v151283: state_type > $o ).

tff(pred_def_90876,type,
    v151281: state_type > $o ).

tff(pred_def_90877,type,
    v151279: state_type > $o ).

tff(pred_def_90878,type,
    v151301: ( state_type * $int ) > $o ).

tff(pred_def_90879,type,
    v151300: state_type > $o ).

tff(pred_def_90880,type,
    v151278: state_type > $o ).

tff(pred_def_90881,type,
    v151307: ( state_type * $int ) > $o ).

tff(pred_def_90882,type,
    v151305: ( state_type * $int ) > $o ).

tff(pred_def_90883,type,
    v151303: ( state_type * $int ) > $o ).

tff(pred_def_90884,type,
    v151313: state_type > $o ).

tff(pred_def_90885,type,
    v151311: state_type > $o ).

tff(pred_def_90886,type,
    v151309: state_type > $o ).

tff(pred_def_90887,type,
    v151332: ( state_type * $int ) > $o ).

tff(pred_def_90888,type,
    v151331: state_type > $o ).

tff(pred_def_90889,type,
    v151330: state_type > $o ).

tff(pred_def_90890,type,
    v151329: state_type > $o ).

tff(pred_def_90891,type,
    v151328: state_type > $o ).

tff(pred_def_90892,type,
    v151327: state_type > $o ).

tff(pred_def_90893,type,
    v151326: state_type > $o ).

tff(pred_def_90894,type,
    v151325: state_type > $o ).

tff(pred_def_90895,type,
    v151324: state_type > $o ).

tff(pred_def_90896,type,
    v151323: state_type > $o ).

tff(pred_def_90897,type,
    v151322: state_type > $o ).

tff(pred_def_90898,type,
    v151321: state_type > $o ).

tff(pred_def_90899,type,
    v151320: state_type > $o ).

tff(pred_def_90900,type,
    v151319: state_type > $o ).

tff(pred_def_90901,type,
    v151318: state_type > $o ).

tff(pred_def_90902,type,
    v151316: state_type > $o ).

tff(pred_def_90903,type,
    v151333: state_type > $o ).

tff(pred_def_90904,type,
    v151315: state_type > $o ).

tff(pred_def_90905,type,
    v151336: state_type > $o ).

tff(pred_def_90906,type,
    v151344: state_type > $o ).

tff(pred_def_90907,type,
    v151343: state_type > $o ).

tff(pred_def_90908,type,
    v151345: state_type > $o ).

tff(pred_def_90909,type,
    v151342: state_type > $o ).

tff(pred_def_90910,type,
    v151341: state_type > $o ).

tff(pred_def_90911,type,
    v151349: state_type > $o ).

tff(pred_def_90912,type,
    v151348: state_type > $o ).

tff(pred_def_90913,type,
    v151350: state_type > $o ).

tff(pred_def_90914,type,
    v151347: state_type > $o ).

tff(pred_def_90915,type,
    v151346: state_type > $o ).

tff(pred_def_90916,type,
    v151340: state_type > $o ).

tff(pred_def_90917,type,
    v151354: state_type > $o ).

tff(pred_def_90918,type,
    v151353: state_type > $o ).

tff(pred_def_90919,type,
    v151355: state_type > $o ).

tff(pred_def_90920,type,
    v151352: state_type > $o ).

tff(pred_def_90921,type,
    v151351: state_type > $o ).

tff(pred_def_90922,type,
    v151339: state_type > $o ).

tff(pred_def_90923,type,
    v151337: state_type > $o ).

tff(pred_def_90924,type,
    v151335: state_type > $o ).

tff(pred_def_90925,type,
    v151357: ( state_type * $int ) > $o ).

tff(pred_def_90926,type,
    v151356: state_type > $o ).

tff(pred_def_90927,type,
    v151334: state_type > $o ).

tff(pred_def_90928,type,
    v151363: ( state_type * $int ) > $o ).

tff(pred_def_90929,type,
    v151361: ( state_type * $int ) > $o ).

tff(pred_def_90930,type,
    v151359: ( state_type * $int ) > $o ).

tff(pred_def_90931,type,
    v151369: state_type > $o ).

tff(pred_def_90932,type,
    v151367: state_type > $o ).

tff(pred_def_90933,type,
    v151365: state_type > $o ).

tff(pred_def_90934,type,
    v151388: ( state_type * $int ) > $o ).

tff(pred_def_90935,type,
    v151387: state_type > $o ).

tff(pred_def_90936,type,
    v151386: state_type > $o ).

tff(pred_def_90937,type,
    v151385: state_type > $o ).

tff(pred_def_90938,type,
    v151384: state_type > $o ).

tff(pred_def_90939,type,
    v151383: state_type > $o ).

tff(pred_def_90940,type,
    v151382: state_type > $o ).

tff(pred_def_90941,type,
    v151381: state_type > $o ).

tff(pred_def_90942,type,
    v151380: state_type > $o ).

tff(pred_def_90943,type,
    v151379: state_type > $o ).

tff(pred_def_90944,type,
    v151378: state_type > $o ).

tff(pred_def_90945,type,
    v151377: state_type > $o ).

tff(pred_def_90946,type,
    v151376: state_type > $o ).

tff(pred_def_90947,type,
    v151375: state_type > $o ).

tff(pred_def_90948,type,
    v151374: state_type > $o ).

tff(pred_def_90949,type,
    v151372: state_type > $o ).

tff(pred_def_90950,type,
    v151389: state_type > $o ).

tff(pred_def_90951,type,
    v151371: state_type > $o ).

tff(pred_def_90952,type,
    v151392: state_type > $o ).

tff(pred_def_90953,type,
    v151400: state_type > $o ).

tff(pred_def_90954,type,
    v151399: state_type > $o ).

tff(pred_def_90955,type,
    v151401: state_type > $o ).

tff(pred_def_90956,type,
    v151398: state_type > $o ).

tff(pred_def_90957,type,
    v151397: state_type > $o ).

tff(pred_def_90958,type,
    v151405: state_type > $o ).

tff(pred_def_90959,type,
    v151404: state_type > $o ).

tff(pred_def_90960,type,
    v151406: state_type > $o ).

tff(pred_def_90961,type,
    v151403: state_type > $o ).

tff(pred_def_90962,type,
    v151402: state_type > $o ).

tff(pred_def_90963,type,
    v151396: state_type > $o ).

tff(pred_def_90964,type,
    v151410: state_type > $o ).

tff(pred_def_90965,type,
    v151409: state_type > $o ).

tff(pred_def_90966,type,
    v151411: state_type > $o ).

tff(pred_def_90967,type,
    v151408: state_type > $o ).

tff(pred_def_90968,type,
    v151407: state_type > $o ).

tff(pred_def_90969,type,
    v151395: state_type > $o ).

tff(pred_def_90970,type,
    v151393: state_type > $o ).

tff(pred_def_90971,type,
    v151391: state_type > $o ).

tff(pred_def_90972,type,
    v151413: ( state_type * $int ) > $o ).

tff(pred_def_90973,type,
    v151412: state_type > $o ).

tff(pred_def_90974,type,
    v151390: state_type > $o ).

tff(pred_def_90975,type,
    v151416: state_type > $o ).

tff(pred_def_90976,type,
    v151417: state_type > $o ).

tff(pred_def_90977,type,
    v151415: state_type > $o ).

tff(pred_def_90978,type,
    v122: ( state_type * $int ) > $o ).

tff(pred_def_90979,type,
    v151420: state_type > $o ).

tff(pred_def_90980,type,
    v151421: state_type > $o ).

tff(pred_def_90981,type,
    v151419: state_type > $o ).

tff(pred_def_90982,type,
    v151422: state_type > $o ).

tff(pred_def_90983,type,
    v151425: state_type > $o ).

tff(pred_def_90984,type,
    v151426: state_type > $o ).

tff(pred_def_90985,type,
    v151424: state_type > $o ).

tff(pred_def_90986,type,
    v151427: state_type > $o ).

tff(pred_def_90987,type,
    v151430: state_type > $o ).

tff(pred_def_90988,type,
    v151431: state_type > $o ).

tff(pred_def_90989,type,
    v151429: state_type > $o ).

tff(pred_def_90990,type,
    v151432: state_type > $o ).

tff(pred_def_90991,type,
    v151435: state_type > $o ).

tff(pred_def_90992,type,
    v151436: state_type > $o ).

tff(pred_def_90993,type,
    v151434: state_type > $o ).

tff(pred_def_90994,type,
    v151437: state_type > $o ).

tff(pred_def_90995,type,
    v151440: state_type > $o ).

tff(pred_def_90996,type,
    v151441: state_type > $o ).

tff(pred_def_90997,type,
    v151439: state_type > $o ).

tff(pred_def_90998,type,
    v151442: state_type > $o ).

tff(pred_def_90999,type,
    v151445: state_type > $o ).

tff(pred_def_91000,type,
    v151446: state_type > $o ).

tff(pred_def_91001,type,
    v151444: state_type > $o ).

tff(pred_def_91002,type,
    v151447: state_type > $o ).

tff(pred_def_91003,type,
    v151450: state_type > $o ).

tff(pred_def_91004,type,
    v151451: state_type > $o ).

tff(pred_def_91005,type,
    v151449: state_type > $o ).

tff(pred_def_91006,type,
    v151452: state_type > $o ).

tff(pred_def_91007,type,
    v151457: state_type > $o ).

tff(pred_def_91008,type,
    v151456: state_type > $o ).

tff(pred_def_91009,type,
    v151455: state_type > $o ).

tff(pred_def_91010,type,
    v151454: ( state_type * $int ) > $o ).

tff(pred_def_91011,type,
    v114: state_type > $o ).

tff(pred_def_91012,type,
    v151460: state_type > $o ).

tff(pred_def_91013,type,
    v112: state_type > $o ).

tff(pred_def_91014,type,
    v151463: state_type > $o ).

tff(pred_def_91015,type,
    v151465: ( state_type * $int ) > $o ).

tff(pred_def_91016,type,
    v151467: state_type > $o ).

tff(pred_def_91017,type,
    v82: ( state_type * $int ) > $o ).

tff(pred_def_91018,type,
    v151469: state_type > $o ).

tff(pred_def_91019,type,
    v151481: state_type > $o ).

tff(pred_def_91020,type,
    v151480: state_type > $o ).

tff(pred_def_91021,type,
    v151479: state_type > $o ).

tff(pred_def_91022,type,
    v151482: state_type > $o ).

tff(pred_def_91023,type,
    v151478: state_type > $o ).

tff(pred_def_91024,type,
    v151477: state_type > $o ).

tff(pred_def_91025,type,
    v151483: state_type > $o ).

tff(pred_def_91026,type,
    v151476: state_type > $o ).

tff(pred_def_91027,type,
    v151475: state_type > $o ).

tff(pred_def_91028,type,
    v151474: state_type > $o ).

tff(pred_def_91029,type,
    v151473: state_type > $o ).

tff(pred_def_91030,type,
    v151485: state_type > $o ).

tff(pred_def_91031,type,
    v151484: state_type > $o ).

tff(pred_def_91032,type,
    v151472: state_type > $o ).

tff(pred_def_91033,type,
    v151488: state_type > $o ).

tff(pred_def_91034,type,
    v151487: state_type > $o ).

tff(pred_def_91035,type,
    v151489: state_type > $o ).

tff(pred_def_91036,type,
    v151486: state_type > $o ).

tff(pred_def_91037,type,
    v151492: state_type > $o ).

tff(pred_def_91038,type,
    v151491: state_type > $o ).

tff(pred_def_91039,type,
    v151493: state_type > $o ).

tff(pred_def_91040,type,
    v151490: state_type > $o ).

tff(pred_def_91041,type,
    v151496: state_type > $o ).

tff(pred_def_91042,type,
    v151495: state_type > $o ).

tff(pred_def_91043,type,
    v151497: state_type > $o ).

tff(pred_def_91044,type,
    v151494: state_type > $o ).

tff(pred_def_91045,type,
    v151470: ( state_type * $int ) > $o ).

tff(pred_def_91046,type,
    v151468: ( state_type * $int ) > $o ).

tff(pred_def_91047,type,
    v110: ( state_type * $int ) > $o ).

tff(pred_def_91048,type,
    v108: ( state_type * $int ) > $o ).

tff(pred_def_91049,type,
    v106: ( state_type * $int ) > $o ).

tff(pred_def_91050,type,
    v104: ( state_type * $int ) > $o ).

tff(pred_def_91051,type,
    v151503: state_type > $o ).

tff(pred_def_91052,type,
    v151501: state_type > $o ).

tff(pred_def_91053,type,
    v151499: state_type > $o ).

tff(pred_def_91054,type,
    v151510: state_type > $o ).

tff(pred_def_91055,type,
    v151508: state_type > $o ).

tff(pred_def_91056,type,
    v151507: state_type > $o ).

tff(pred_def_91057,type,
    v151506: state_type > $o ).

tff(pred_def_91058,type,
    v151518: state_type > $o ).

tff(pred_def_91059,type,
    v151519: state_type > $o ).

tff(pred_def_91060,type,
    v151517: state_type > $o ).

tff(pred_def_91061,type,
    v151514: ( state_type * $int ) > $o ).

tff(pred_def_91062,type,
    v151516: ( state_type * $int ) > $o ).

tff(pred_def_91063,type,
    v86: ( state_type * $int ) > $o ).

tff(pred_def_91064,type,
    v84: ( state_type * $int ) > $o ).

tff(pred_def_91065,type,
    v80: state_type > $o ).

tff(pred_def_91066,type,
    v78: state_type > $o ).

tff(pred_def_91067,type,
    v151536: state_type > $o ).

tff(pred_def_91068,type,
    v151534: state_type > $o ).

tff(pred_def_91069,type,
    v151540: state_type > $o ).

tff(pred_def_91070,type,
    v151538: state_type > $o ).

tff(pred_def_91071,type,
    v151552: state_type > $o ).

tff(pred_def_91072,type,
    v151554: state_type > $o ).

tff(pred_def_91073,type,
    v151550: state_type > $o ).

tff(pred_def_91074,type,
    v151557: state_type > $o ).

tff(pred_def_91075,type,
    v151559: ( state_type * $int ) > $o ).

tff(pred_def_91076,type,
    v151561: ( state_type * $int ) > $o ).

tff(pred_def_91077,type,
    v151563: state_type > $o ).

tff(pred_def_91078,type,
    v151566: state_type > $o ).

tff(pred_def_91079,type,
    v151565: state_type > $o ).

tff(pred_def_91080,type,
    v151564: ( state_type * $int ) > $o ).

tff(pred_def_91081,type,
    v151528: ( state_type * $int ) > $o ).

tff(pred_def_91082,type,
    v151568: state_type > $o ).

tff(pred_def_91083,type,
    v151580: state_type > $o ).

tff(pred_def_91084,type,
    v151579: state_type > $o ).

tff(pred_def_91085,type,
    v151578: state_type > $o ).

tff(pred_def_91086,type,
    v151581: state_type > $o ).

tff(pred_def_91087,type,
    v151577: state_type > $o ).

tff(pred_def_91088,type,
    v151576: state_type > $o ).

tff(pred_def_91089,type,
    v151582: state_type > $o ).

tff(pred_def_91090,type,
    v151575: state_type > $o ).

tff(pred_def_91091,type,
    v151574: state_type > $o ).

tff(pred_def_91092,type,
    v151573: state_type > $o ).

tff(pred_def_91093,type,
    v151572: state_type > $o ).

tff(pred_def_91094,type,
    v151584: state_type > $o ).

tff(pred_def_91095,type,
    v151583: state_type > $o ).

tff(pred_def_91096,type,
    v151571: state_type > $o ).

tff(pred_def_91097,type,
    v151587: state_type > $o ).

tff(pred_def_91098,type,
    v151586: state_type > $o ).

tff(pred_def_91099,type,
    v151588: state_type > $o ).

tff(pred_def_91100,type,
    v151585: state_type > $o ).

tff(pred_def_91101,type,
    v151591: state_type > $o ).

tff(pred_def_91102,type,
    v151590: state_type > $o ).

tff(pred_def_91103,type,
    v151592: state_type > $o ).

tff(pred_def_91104,type,
    v151589: state_type > $o ).

tff(pred_def_91105,type,
    v151595: state_type > $o ).

tff(pred_def_91106,type,
    v151594: state_type > $o ).

tff(pred_def_91107,type,
    v151596: state_type > $o ).

tff(pred_def_91108,type,
    v151593: state_type > $o ).

tff(pred_def_91109,type,
    v151569: ( state_type * $int ) > $o ).

tff(pred_def_91110,type,
    v151567: ( state_type * $int ) > $o ).

tff(pred_def_91111,type,
    v151548: ( state_type * $int ) > $o ).

tff(pred_def_91112,type,
    v151546: ( state_type * $int ) > $o ).

tff(pred_def_91113,type,
    v151544: ( state_type * $int ) > $o ).

tff(pred_def_91114,type,
    v151542: ( state_type * $int ) > $o ).

tff(pred_def_91115,type,
    v151600: state_type > $o ).

tff(pred_def_91116,type,
    v151598: state_type > $o ).

tff(pred_def_91117,type,
    v151607: state_type > $o ).

tff(pred_def_91118,type,
    v151605: state_type > $o ).

tff(pred_def_91119,type,
    v151604: state_type > $o ).

tff(pred_def_91120,type,
    v151603: state_type > $o ).

tff(pred_def_91121,type,
    v151615: state_type > $o ).

tff(pred_def_91122,type,
    v151616: state_type > $o ).

tff(pred_def_91123,type,
    v151614: state_type > $o ).

tff(pred_def_91124,type,
    v151611: ( state_type * $int ) > $o ).

tff(pred_def_91125,type,
    v151613: ( state_type * $int ) > $o ).

tff(pred_def_91126,type,
    v151532: ( state_type * $int ) > $o ).

tff(pred_def_91127,type,
    v151530: ( state_type * $int ) > $o ).

tff(pred_def_91128,type,
    v151526: state_type > $o ).

tff(pred_def_91129,type,
    v151524: state_type > $o ).

tff(pred_def_91130,type,
    v151637: state_type > $o ).

tff(pred_def_91131,type,
    v151635: state_type > $o ).

tff(pred_def_91132,type,
    v151633: state_type > $o ).

tff(pred_def_91133,type,
    v151631: state_type > $o ).

tff(pred_def_91134,type,
    v151645: state_type > $o ).

tff(pred_def_91135,type,
    v151643: state_type > $o ).

tff(pred_def_91136,type,
    v151641: state_type > $o ).

tff(pred_def_91137,type,
    v151639: state_type > $o ).

tff(pred_def_91138,type,
    v151657: state_type > $o ).

tff(pred_def_91139,type,
    v151659: state_type > $o ).

tff(pred_def_91140,type,
    v151655: state_type > $o ).

tff(pred_def_91141,type,
    v151662: state_type > $o ).

tff(pred_def_91142,type,
    v151664: ( state_type * $int ) > $o ).

tff(pred_def_91143,type,
    v151666: state_type > $o ).

tff(pred_def_91144,type,
    v151625: ( state_type * $int ) > $o ).

tff(pred_def_91145,type,
    v151668: state_type > $o ).

tff(pred_def_91146,type,
    v151680: state_type > $o ).

tff(pred_def_91147,type,
    v151679: state_type > $o ).

tff(pred_def_91148,type,
    v151678: state_type > $o ).

tff(pred_def_91149,type,
    v151681: state_type > $o ).

tff(pred_def_91150,type,
    v151677: state_type > $o ).

tff(pred_def_91151,type,
    v151676: state_type > $o ).

tff(pred_def_91152,type,
    v151682: state_type > $o ).

tff(pred_def_91153,type,
    v151675: state_type > $o ).

tff(pred_def_91154,type,
    v151674: state_type > $o ).

tff(pred_def_91155,type,
    v151673: state_type > $o ).

tff(pred_def_91156,type,
    v151672: state_type > $o ).

tff(pred_def_91157,type,
    v151684: state_type > $o ).

tff(pred_def_91158,type,
    v151683: state_type > $o ).

tff(pred_def_91159,type,
    v151671: state_type > $o ).

tff(pred_def_91160,type,
    v151687: state_type > $o ).

tff(pred_def_91161,type,
    v151686: state_type > $o ).

tff(pred_def_91162,type,
    v151688: state_type > $o ).

tff(pred_def_91163,type,
    v151685: state_type > $o ).

tff(pred_def_91164,type,
    v151691: state_type > $o ).

tff(pred_def_91165,type,
    v151690: state_type > $o ).

tff(pred_def_91166,type,
    v151692: state_type > $o ).

tff(pred_def_91167,type,
    v151689: state_type > $o ).

tff(pred_def_91168,type,
    v151695: state_type > $o ).

tff(pred_def_91169,type,
    v151694: state_type > $o ).

tff(pred_def_91170,type,
    v151696: state_type > $o ).

tff(pred_def_91171,type,
    v151693: state_type > $o ).

tff(pred_def_91172,type,
    v151669: ( state_type * $int ) > $o ).

tff(pred_def_91173,type,
    v151667: ( state_type * $int ) > $o ).

tff(pred_def_91174,type,
    v151653: ( state_type * $int ) > $o ).

tff(pred_def_91175,type,
    v151651: ( state_type * $int ) > $o ).

tff(pred_def_91176,type,
    v151649: ( state_type * $int ) > $o ).

tff(pred_def_91177,type,
    v151647: ( state_type * $int ) > $o ).

tff(pred_def_91178,type,
    v151702: state_type > $o ).

tff(pred_def_91179,type,
    v151700: state_type > $o ).

tff(pred_def_91180,type,
    v151698: state_type > $o ).

tff(pred_def_91181,type,
    v151709: state_type > $o ).

tff(pred_def_91182,type,
    v151707: state_type > $o ).

tff(pred_def_91183,type,
    v151706: state_type > $o ).

tff(pred_def_91184,type,
    v151705: state_type > $o ).

tff(pred_def_91185,type,
    v151717: state_type > $o ).

tff(pred_def_91186,type,
    v151718: state_type > $o ).

tff(pred_def_91187,type,
    v151716: state_type > $o ).

tff(pred_def_91188,type,
    v151713: ( state_type * $int ) > $o ).

tff(pred_def_91189,type,
    v151715: ( state_type * $int ) > $o ).

tff(pred_def_91190,type,
    v151629: ( state_type * $int ) > $o ).

tff(pred_def_91191,type,
    v151627: ( state_type * $int ) > $o ).

tff(pred_def_91192,type,
    v151623: state_type > $o ).

tff(pred_def_91193,type,
    v151621: state_type > $o ).

tff(pred_def_91194,type,
    v151735: state_type > $o ).

tff(pred_def_91195,type,
    v151733: state_type > $o ).

tff(pred_def_91196,type,
    v151739: state_type > $o ).

tff(pred_def_91197,type,
    v151737: state_type > $o ).

tff(pred_def_91198,type,
    v151751: state_type > $o ).

tff(pred_def_91199,type,
    v151753: state_type > $o ).

tff(pred_def_91200,type,
    v151749: state_type > $o ).

tff(pred_def_91201,type,
    v151756: state_type > $o ).

tff(pred_def_91202,type,
    v151758: ( state_type * $int ) > $o ).

tff(pred_def_91203,type,
    v151760: ( state_type * $int ) > $o ).

tff(pred_def_91204,type,
    v151762: state_type > $o ).

tff(pred_def_91205,type,
    v151765: state_type > $o ).

tff(pred_def_91206,type,
    v151764: state_type > $o ).

tff(pred_def_91207,type,
    v151763: ( state_type * $int ) > $o ).

tff(pred_def_91208,type,
    v151727: ( state_type * $int ) > $o ).

tff(pred_def_91209,type,
    v151767: state_type > $o ).

tff(pred_def_91210,type,
    v151779: state_type > $o ).

tff(pred_def_91211,type,
    v151778: state_type > $o ).

tff(pred_def_91212,type,
    v151777: state_type > $o ).

tff(pred_def_91213,type,
    v151780: state_type > $o ).

tff(pred_def_91214,type,
    v151776: state_type > $o ).

tff(pred_def_91215,type,
    v151775: state_type > $o ).

tff(pred_def_91216,type,
    v151781: state_type > $o ).

tff(pred_def_91217,type,
    v151774: state_type > $o ).

tff(pred_def_91218,type,
    v151773: state_type > $o ).

tff(pred_def_91219,type,
    v151772: state_type > $o ).

tff(pred_def_91220,type,
    v151771: state_type > $o ).

tff(pred_def_91221,type,
    v151783: state_type > $o ).

tff(pred_def_91222,type,
    v151782: state_type > $o ).

tff(pred_def_91223,type,
    v151770: state_type > $o ).

tff(pred_def_91224,type,
    v151786: state_type > $o ).

tff(pred_def_91225,type,
    v151785: state_type > $o ).

tff(pred_def_91226,type,
    v151787: state_type > $o ).

tff(pred_def_91227,type,
    v151784: state_type > $o ).

tff(pred_def_91228,type,
    v151790: state_type > $o ).

tff(pred_def_91229,type,
    v151789: state_type > $o ).

tff(pred_def_91230,type,
    v151791: state_type > $o ).

tff(pred_def_91231,type,
    v151788: state_type > $o ).

tff(pred_def_91232,type,
    v151794: state_type > $o ).

tff(pred_def_91233,type,
    v151793: state_type > $o ).

tff(pred_def_91234,type,
    v151795: state_type > $o ).

tff(pred_def_91235,type,
    v151792: state_type > $o ).

tff(pred_def_91236,type,
    v151768: ( state_type * $int ) > $o ).

tff(pred_def_91237,type,
    v151766: ( state_type * $int ) > $o ).

tff(pred_def_91238,type,
    v151747: ( state_type * $int ) > $o ).

tff(pred_def_91239,type,
    v151745: ( state_type * $int ) > $o ).

tff(pred_def_91240,type,
    v151743: ( state_type * $int ) > $o ).

tff(pred_def_91241,type,
    v151741: ( state_type * $int ) > $o ).

tff(pred_def_91242,type,
    v151799: state_type > $o ).

tff(pred_def_91243,type,
    v151797: state_type > $o ).

tff(pred_def_91244,type,
    v151806: state_type > $o ).

tff(pred_def_91245,type,
    v151804: state_type > $o ).

tff(pred_def_91246,type,
    v151803: state_type > $o ).

tff(pred_def_91247,type,
    v151802: state_type > $o ).

tff(pred_def_91248,type,
    v151814: state_type > $o ).

tff(pred_def_91249,type,
    v151815: state_type > $o ).

tff(pred_def_91250,type,
    v151813: state_type > $o ).

tff(pred_def_91251,type,
    v151810: ( state_type * $int ) > $o ).

tff(pred_def_91252,type,
    v151812: ( state_type * $int ) > $o ).

tff(pred_def_91253,type,
    v151731: ( state_type * $int ) > $o ).

tff(pred_def_91254,type,
    v151729: ( state_type * $int ) > $o ).

tff(pred_def_91255,type,
    v151725: state_type > $o ).

tff(pred_def_91256,type,
    v151723: state_type > $o ).

tff(pred_def_91257,type,
    v151836: state_type > $o ).

tff(pred_def_91258,type,
    v151834: state_type > $o ).

tff(pred_def_91259,type,
    v151832: state_type > $o ).

tff(pred_def_91260,type,
    v151830: state_type > $o ).

tff(pred_def_91261,type,
    v151844: state_type > $o ).

tff(pred_def_91262,type,
    v151842: state_type > $o ).

tff(pred_def_91263,type,
    v151840: state_type > $o ).

tff(pred_def_91264,type,
    v151838: state_type > $o ).

tff(pred_def_91265,type,
    v151856: state_type > $o ).

tff(pred_def_91266,type,
    v151858: state_type > $o ).

tff(pred_def_91267,type,
    v151854: state_type > $o ).

tff(pred_def_91268,type,
    v151861: state_type > $o ).

tff(pred_def_91269,type,
    v151863: ( state_type * $int ) > $o ).

tff(pred_def_91270,type,
    v151865: state_type > $o ).

tff(pred_def_91271,type,
    v151824: ( state_type * $int ) > $o ).

tff(pred_def_91272,type,
    v151867: state_type > $o ).

tff(pred_def_91273,type,
    v151879: state_type > $o ).

tff(pred_def_91274,type,
    v151878: state_type > $o ).

tff(pred_def_91275,type,
    v151877: state_type > $o ).

tff(pred_def_91276,type,
    v151880: state_type > $o ).

tff(pred_def_91277,type,
    v151876: state_type > $o ).

tff(pred_def_91278,type,
    v151875: state_type > $o ).

tff(pred_def_91279,type,
    v151881: state_type > $o ).

tff(pred_def_91280,type,
    v151874: state_type > $o ).

tff(pred_def_91281,type,
    v151873: state_type > $o ).

tff(pred_def_91282,type,
    v151872: state_type > $o ).

tff(pred_def_91283,type,
    v151871: state_type > $o ).

tff(pred_def_91284,type,
    v151883: state_type > $o ).

tff(pred_def_91285,type,
    v151882: state_type > $o ).

tff(pred_def_91286,type,
    v151870: state_type > $o ).

tff(pred_def_91287,type,
    v151886: state_type > $o ).

tff(pred_def_91288,type,
    v151885: state_type > $o ).

tff(pred_def_91289,type,
    v151887: state_type > $o ).

tff(pred_def_91290,type,
    v151884: state_type > $o ).

tff(pred_def_91291,type,
    v151890: state_type > $o ).

tff(pred_def_91292,type,
    v151889: state_type > $o ).

tff(pred_def_91293,type,
    v151891: state_type > $o ).

tff(pred_def_91294,type,
    v151888: state_type > $o ).

tff(pred_def_91295,type,
    v151894: state_type > $o ).

tff(pred_def_91296,type,
    v151893: state_type > $o ).

tff(pred_def_91297,type,
    v151895: state_type > $o ).

tff(pred_def_91298,type,
    v151892: state_type > $o ).

tff(pred_def_91299,type,
    v151868: ( state_type * $int ) > $o ).

tff(pred_def_91300,type,
    v151866: ( state_type * $int ) > $o ).

tff(pred_def_91301,type,
    v151852: ( state_type * $int ) > $o ).

tff(pred_def_91302,type,
    v151850: ( state_type * $int ) > $o ).

tff(pred_def_91303,type,
    v151848: ( state_type * $int ) > $o ).

tff(pred_def_91304,type,
    v151846: ( state_type * $int ) > $o ).

tff(pred_def_91305,type,
    v151901: state_type > $o ).

tff(pred_def_91306,type,
    v151899: state_type > $o ).

tff(pred_def_91307,type,
    v151897: state_type > $o ).

tff(pred_def_91308,type,
    v151908: state_type > $o ).

tff(pred_def_91309,type,
    v151906: state_type > $o ).

tff(pred_def_91310,type,
    v151905: state_type > $o ).

tff(pred_def_91311,type,
    v151904: state_type > $o ).

tff(pred_def_91312,type,
    v151916: state_type > $o ).

tff(pred_def_91313,type,
    v151917: state_type > $o ).

tff(pred_def_91314,type,
    v151915: state_type > $o ).

tff(pred_def_91315,type,
    v151912: ( state_type * $int ) > $o ).

tff(pred_def_91316,type,
    v151914: ( state_type * $int ) > $o ).

tff(pred_def_91317,type,
    v151828: ( state_type * $int ) > $o ).

tff(pred_def_91318,type,
    v151826: ( state_type * $int ) > $o ).

tff(pred_def_91319,type,
    v151822: state_type > $o ).

tff(pred_def_91320,type,
    v151820: state_type > $o ).

tff(pred_def_91321,type,
    v151934: state_type > $o ).

tff(pred_def_91322,type,
    v151932: state_type > $o ).

tff(pred_def_91323,type,
    v151938: state_type > $o ).

tff(pred_def_91324,type,
    v151936: state_type > $o ).

tff(pred_def_91325,type,
    v151950: state_type > $o ).

tff(pred_def_91326,type,
    v151952: state_type > $o ).

tff(pred_def_91327,type,
    v151948: state_type > $o ).

tff(pred_def_91328,type,
    v151955: state_type > $o ).

tff(pred_def_91329,type,
    v151957: ( state_type * $int ) > $o ).

tff(pred_def_91330,type,
    v151959: ( state_type * $int ) > $o ).

tff(pred_def_91331,type,
    v151961: state_type > $o ).

tff(pred_def_91332,type,
    v151964: state_type > $o ).

tff(pred_def_91333,type,
    v151963: state_type > $o ).

tff(pred_def_91334,type,
    v151962: ( state_type * $int ) > $o ).

tff(pred_def_91335,type,
    v151926: ( state_type * $int ) > $o ).

tff(pred_def_91336,type,
    v151966: state_type > $o ).

tff(pred_def_91337,type,
    v151978: state_type > $o ).

tff(pred_def_91338,type,
    v151977: state_type > $o ).

tff(pred_def_91339,type,
    v151976: state_type > $o ).

tff(pred_def_91340,type,
    v151979: state_type > $o ).

tff(pred_def_91341,type,
    v151975: state_type > $o ).

tff(pred_def_91342,type,
    v151974: state_type > $o ).

tff(pred_def_91343,type,
    v151980: state_type > $o ).

tff(pred_def_91344,type,
    v151973: state_type > $o ).

tff(pred_def_91345,type,
    v151972: state_type > $o ).

tff(pred_def_91346,type,
    v151971: state_type > $o ).

tff(pred_def_91347,type,
    v151970: state_type > $o ).

tff(pred_def_91348,type,
    v151982: state_type > $o ).

tff(pred_def_91349,type,
    v151981: state_type > $o ).

tff(pred_def_91350,type,
    v151969: state_type > $o ).

tff(pred_def_91351,type,
    v151985: state_type > $o ).

tff(pred_def_91352,type,
    v151984: state_type > $o ).

tff(pred_def_91353,type,
    v151986: state_type > $o ).

tff(pred_def_91354,type,
    v151983: state_type > $o ).

tff(pred_def_91355,type,
    v151989: state_type > $o ).

tff(pred_def_91356,type,
    v151988: state_type > $o ).

tff(pred_def_91357,type,
    v151990: state_type > $o ).

tff(pred_def_91358,type,
    v151987: state_type > $o ).

tff(pred_def_91359,type,
    v151993: state_type > $o ).

tff(pred_def_91360,type,
    v151992: state_type > $o ).

tff(pred_def_91361,type,
    v151994: state_type > $o ).

tff(pred_def_91362,type,
    v151991: state_type > $o ).

tff(pred_def_91363,type,
    v151967: ( state_type * $int ) > $o ).

tff(pred_def_91364,type,
    v151965: ( state_type * $int ) > $o ).

tff(pred_def_91365,type,
    v151946: ( state_type * $int ) > $o ).

tff(pred_def_91366,type,
    v151944: ( state_type * $int ) > $o ).

tff(pred_def_91367,type,
    v151942: ( state_type * $int ) > $o ).

tff(pred_def_91368,type,
    v151940: ( state_type * $int ) > $o ).

tff(pred_def_91369,type,
    v151998: state_type > $o ).

tff(pred_def_91370,type,
    v151996: state_type > $o ).

tff(pred_def_91371,type,
    v152005: state_type > $o ).

tff(pred_def_91372,type,
    v152003: state_type > $o ).

tff(pred_def_91373,type,
    v152002: state_type > $o ).

tff(pred_def_91374,type,
    v152001: state_type > $o ).

tff(pred_def_91375,type,
    v152013: state_type > $o ).

tff(pred_def_91376,type,
    v152014: state_type > $o ).

tff(pred_def_91377,type,
    v152012: state_type > $o ).

tff(pred_def_91378,type,
    v152009: ( state_type * $int ) > $o ).

tff(pred_def_91379,type,
    v152011: ( state_type * $int ) > $o ).

tff(pred_def_91380,type,
    v151930: ( state_type * $int ) > $o ).

tff(pred_def_91381,type,
    v151928: ( state_type * $int ) > $o ).

tff(pred_def_91382,type,
    v151924: state_type > $o ).

tff(pred_def_91383,type,
    v151922: state_type > $o ).

tff(pred_def_91384,type,
    v152035: state_type > $o ).

tff(pred_def_91385,type,
    v152033: state_type > $o ).

tff(pred_def_91386,type,
    v152031: state_type > $o ).

tff(pred_def_91387,type,
    v152029: state_type > $o ).

tff(pred_def_91388,type,
    v152043: state_type > $o ).

tff(pred_def_91389,type,
    v152041: state_type > $o ).

tff(pred_def_91390,type,
    v152039: state_type > $o ).

tff(pred_def_91391,type,
    v152037: state_type > $o ).

tff(pred_def_91392,type,
    v152055: state_type > $o ).

tff(pred_def_91393,type,
    v152057: state_type > $o ).

tff(pred_def_91394,type,
    v152053: state_type > $o ).

tff(pred_def_91395,type,
    v152060: state_type > $o ).

tff(pred_def_91396,type,
    v152062: ( state_type * $int ) > $o ).

tff(pred_def_91397,type,
    v152064: state_type > $o ).

tff(pred_def_91398,type,
    v152023: ( state_type * $int ) > $o ).

tff(pred_def_91399,type,
    v152066: state_type > $o ).

tff(pred_def_91400,type,
    v152078: state_type > $o ).

tff(pred_def_91401,type,
    v152077: state_type > $o ).

tff(pred_def_91402,type,
    v152076: state_type > $o ).

tff(pred_def_91403,type,
    v152079: state_type > $o ).

tff(pred_def_91404,type,
    v152075: state_type > $o ).

tff(pred_def_91405,type,
    v152074: state_type > $o ).

tff(pred_def_91406,type,
    v152080: state_type > $o ).

tff(pred_def_91407,type,
    v152073: state_type > $o ).

tff(pred_def_91408,type,
    v152072: state_type > $o ).

tff(pred_def_91409,type,
    v152071: state_type > $o ).

tff(pred_def_91410,type,
    v152070: state_type > $o ).

tff(pred_def_91411,type,
    v152082: state_type > $o ).

tff(pred_def_91412,type,
    v152081: state_type > $o ).

tff(pred_def_91413,type,
    v152069: state_type > $o ).

tff(pred_def_91414,type,
    v152085: state_type > $o ).

tff(pred_def_91415,type,
    v152084: state_type > $o ).

tff(pred_def_91416,type,
    v152086: state_type > $o ).

tff(pred_def_91417,type,
    v152083: state_type > $o ).

tff(pred_def_91418,type,
    v152089: state_type > $o ).

tff(pred_def_91419,type,
    v152088: state_type > $o ).

tff(pred_def_91420,type,
    v152090: state_type > $o ).

tff(pred_def_91421,type,
    v152087: state_type > $o ).

tff(pred_def_91422,type,
    v152093: state_type > $o ).

tff(pred_def_91423,type,
    v152092: state_type > $o ).

tff(pred_def_91424,type,
    v152094: state_type > $o ).

tff(pred_def_91425,type,
    v152091: state_type > $o ).

tff(pred_def_91426,type,
    v152067: ( state_type * $int ) > $o ).

tff(pred_def_91427,type,
    v152065: ( state_type * $int ) > $o ).

tff(pred_def_91428,type,
    v152051: ( state_type * $int ) > $o ).

tff(pred_def_91429,type,
    v152049: ( state_type * $int ) > $o ).

tff(pred_def_91430,type,
    v152047: ( state_type * $int ) > $o ).

tff(pred_def_91431,type,
    v152045: ( state_type * $int ) > $o ).

tff(pred_def_91432,type,
    v152100: state_type > $o ).

tff(pred_def_91433,type,
    v152098: state_type > $o ).

tff(pred_def_91434,type,
    v152096: state_type > $o ).

tff(pred_def_91435,type,
    v152107: state_type > $o ).

tff(pred_def_91436,type,
    v152105: state_type > $o ).

tff(pred_def_91437,type,
    v152104: state_type > $o ).

tff(pred_def_91438,type,
    v152103: state_type > $o ).

tff(pred_def_91439,type,
    v152115: state_type > $o ).

tff(pred_def_91440,type,
    v152116: state_type > $o ).

tff(pred_def_91441,type,
    v152114: state_type > $o ).

tff(pred_def_91442,type,
    v152111: ( state_type * $int ) > $o ).

tff(pred_def_91443,type,
    v152113: ( state_type * $int ) > $o ).

tff(pred_def_91444,type,
    v152027: ( state_type * $int ) > $o ).

tff(pred_def_91445,type,
    v152025: ( state_type * $int ) > $o ).

tff(pred_def_91446,type,
    v152021: state_type > $o ).

tff(pred_def_91447,type,
    v152019: state_type > $o ).

tff(pred_def_91448,type,
    v152133: state_type > $o ).

tff(pred_def_91449,type,
    v152131: state_type > $o ).

tff(pred_def_91450,type,
    v152137: state_type > $o ).

tff(pred_def_91451,type,
    v152135: state_type > $o ).

tff(pred_def_91452,type,
    v152149: state_type > $o ).

tff(pred_def_91453,type,
    v152151: state_type > $o ).

tff(pred_def_91454,type,
    v152147: state_type > $o ).

tff(pred_def_91455,type,
    v152154: state_type > $o ).

tff(pred_def_91456,type,
    v152156: ( state_type * $int ) > $o ).

tff(pred_def_91457,type,
    v152158: ( state_type * $int ) > $o ).

tff(pred_def_91458,type,
    v152160: state_type > $o ).

tff(pred_def_91459,type,
    v152163: state_type > $o ).

tff(pred_def_91460,type,
    v152162: state_type > $o ).

tff(pred_def_91461,type,
    v152161: ( state_type * $int ) > $o ).

tff(pred_def_91462,type,
    v152125: ( state_type * $int ) > $o ).

tff(pred_def_91463,type,
    v152165: state_type > $o ).

tff(pred_def_91464,type,
    v152177: state_type > $o ).

tff(pred_def_91465,type,
    v152176: state_type > $o ).

tff(pred_def_91466,type,
    v152175: state_type > $o ).

tff(pred_def_91467,type,
    v152178: state_type > $o ).

tff(pred_def_91468,type,
    v152174: state_type > $o ).

tff(pred_def_91469,type,
    v152173: state_type > $o ).

tff(pred_def_91470,type,
    v152179: state_type > $o ).

tff(pred_def_91471,type,
    v152172: state_type > $o ).

tff(pred_def_91472,type,
    v152171: state_type > $o ).

tff(pred_def_91473,type,
    v152170: state_type > $o ).

tff(pred_def_91474,type,
    v152169: state_type > $o ).

tff(pred_def_91475,type,
    v152181: state_type > $o ).

tff(pred_def_91476,type,
    v152180: state_type > $o ).

tff(pred_def_91477,type,
    v152168: state_type > $o ).

tff(pred_def_91478,type,
    v152184: state_type > $o ).

tff(pred_def_91479,type,
    v152183: state_type > $o ).

tff(pred_def_91480,type,
    v152185: state_type > $o ).

tff(pred_def_91481,type,
    v152182: state_type > $o ).

tff(pred_def_91482,type,
    v152188: state_type > $o ).

tff(pred_def_91483,type,
    v152187: state_type > $o ).

tff(pred_def_91484,type,
    v152189: state_type > $o ).

tff(pred_def_91485,type,
    v152186: state_type > $o ).

tff(pred_def_91486,type,
    v152192: state_type > $o ).

tff(pred_def_91487,type,
    v152191: state_type > $o ).

tff(pred_def_91488,type,
    v152193: state_type > $o ).

tff(pred_def_91489,type,
    v152190: state_type > $o ).

tff(pred_def_91490,type,
    v152166: ( state_type * $int ) > $o ).

tff(pred_def_91491,type,
    v152164: ( state_type * $int ) > $o ).

tff(pred_def_91492,type,
    v152145: ( state_type * $int ) > $o ).

tff(pred_def_91493,type,
    v152143: ( state_type * $int ) > $o ).

tff(pred_def_91494,type,
    v152141: ( state_type * $int ) > $o ).

tff(pred_def_91495,type,
    v152139: ( state_type * $int ) > $o ).

tff(pred_def_91496,type,
    v152197: state_type > $o ).

tff(pred_def_91497,type,
    v152195: state_type > $o ).

tff(pred_def_91498,type,
    v152204: state_type > $o ).

tff(pred_def_91499,type,
    v152202: state_type > $o ).

tff(pred_def_91500,type,
    v152201: state_type > $o ).

tff(pred_def_91501,type,
    v152200: state_type > $o ).

tff(pred_def_91502,type,
    v152212: state_type > $o ).

tff(pred_def_91503,type,
    v152213: state_type > $o ).

tff(pred_def_91504,type,
    v152211: state_type > $o ).

tff(pred_def_91505,type,
    v152208: ( state_type * $int ) > $o ).

tff(pred_def_91506,type,
    v152210: ( state_type * $int ) > $o ).

tff(pred_def_91507,type,
    v152129: ( state_type * $int ) > $o ).

tff(pred_def_91508,type,
    v152127: ( state_type * $int ) > $o ).

tff(pred_def_91509,type,
    v152123: state_type > $o ).

tff(pred_def_91510,type,
    v152121: state_type > $o ).

tff(pred_def_91511,type,
    v152234: state_type > $o ).

tff(pred_def_91512,type,
    v152232: state_type > $o ).

tff(pred_def_91513,type,
    v152230: state_type > $o ).

tff(pred_def_91514,type,
    v152228: state_type > $o ).

tff(pred_def_91515,type,
    v152242: state_type > $o ).

tff(pred_def_91516,type,
    v152240: state_type > $o ).

tff(pred_def_91517,type,
    v152238: state_type > $o ).

tff(pred_def_91518,type,
    v152236: state_type > $o ).

tff(pred_def_91519,type,
    v152254: state_type > $o ).

tff(pred_def_91520,type,
    v152256: state_type > $o ).

tff(pred_def_91521,type,
    v152252: state_type > $o ).

tff(pred_def_91522,type,
    v152259: state_type > $o ).

tff(pred_def_91523,type,
    v152261: ( state_type * $int ) > $o ).

tff(pred_def_91524,type,
    v152263: state_type > $o ).

tff(pred_def_91525,type,
    v152222: ( state_type * $int ) > $o ).

tff(pred_def_91526,type,
    v152265: state_type > $o ).

tff(pred_def_91527,type,
    v152277: state_type > $o ).

tff(pred_def_91528,type,
    v152276: state_type > $o ).

tff(pred_def_91529,type,
    v152275: state_type > $o ).

tff(pred_def_91530,type,
    v152278: state_type > $o ).

tff(pred_def_91531,type,
    v152274: state_type > $o ).

tff(pred_def_91532,type,
    v152273: state_type > $o ).

tff(pred_def_91533,type,
    v152279: state_type > $o ).

tff(pred_def_91534,type,
    v152272: state_type > $o ).

tff(pred_def_91535,type,
    v152271: state_type > $o ).

tff(pred_def_91536,type,
    v152270: state_type > $o ).

tff(pred_def_91537,type,
    v152269: state_type > $o ).

tff(pred_def_91538,type,
    v152281: state_type > $o ).

tff(pred_def_91539,type,
    v152280: state_type > $o ).

tff(pred_def_91540,type,
    v152268: state_type > $o ).

tff(pred_def_91541,type,
    v152284: state_type > $o ).

tff(pred_def_91542,type,
    v152283: state_type > $o ).

tff(pred_def_91543,type,
    v152285: state_type > $o ).

tff(pred_def_91544,type,
    v152282: state_type > $o ).

tff(pred_def_91545,type,
    v152288: state_type > $o ).

tff(pred_def_91546,type,
    v152287: state_type > $o ).

tff(pred_def_91547,type,
    v152289: state_type > $o ).

tff(pred_def_91548,type,
    v152286: state_type > $o ).

tff(pred_def_91549,type,
    v152292: state_type > $o ).

tff(pred_def_91550,type,
    v152291: state_type > $o ).

tff(pred_def_91551,type,
    v152293: state_type > $o ).

tff(pred_def_91552,type,
    v152290: state_type > $o ).

tff(pred_def_91553,type,
    v152266: ( state_type * $int ) > $o ).

tff(pred_def_91554,type,
    v152264: ( state_type * $int ) > $o ).

tff(pred_def_91555,type,
    v152250: ( state_type * $int ) > $o ).

tff(pred_def_91556,type,
    v152248: ( state_type * $int ) > $o ).

tff(pred_def_91557,type,
    v152246: ( state_type * $int ) > $o ).

tff(pred_def_91558,type,
    v152244: ( state_type * $int ) > $o ).

tff(pred_def_91559,type,
    v152299: state_type > $o ).

tff(pred_def_91560,type,
    v152297: state_type > $o ).

tff(pred_def_91561,type,
    v152295: state_type > $o ).

tff(pred_def_91562,type,
    v152306: state_type > $o ).

tff(pred_def_91563,type,
    v152304: state_type > $o ).

tff(pred_def_91564,type,
    v152303: state_type > $o ).

tff(pred_def_91565,type,
    v152302: state_type > $o ).

tff(pred_def_91566,type,
    v152314: state_type > $o ).

tff(pred_def_91567,type,
    v152315: state_type > $o ).

tff(pred_def_91568,type,
    v152313: state_type > $o ).

tff(pred_def_91569,type,
    v152310: ( state_type * $int ) > $o ).

tff(pred_def_91570,type,
    v152312: ( state_type * $int ) > $o ).

tff(pred_def_91571,type,
    v152226: ( state_type * $int ) > $o ).

tff(pred_def_91572,type,
    v152224: ( state_type * $int ) > $o ).

tff(pred_def_91573,type,
    v152220: state_type > $o ).

tff(pred_def_91574,type,
    v152218: state_type > $o ).

tff(pred_def_91575,type,
    v152332: state_type > $o ).

tff(pred_def_91576,type,
    v152330: state_type > $o ).

tff(pred_def_91577,type,
    v152336: state_type > $o ).

tff(pred_def_91578,type,
    v152334: state_type > $o ).

tff(pred_def_91579,type,
    v152348: state_type > $o ).

tff(pred_def_91580,type,
    v152350: state_type > $o ).

tff(pred_def_91581,type,
    v152346: state_type > $o ).

tff(pred_def_91582,type,
    v152353: state_type > $o ).

tff(pred_def_91583,type,
    v152355: ( state_type * $int ) > $o ).

tff(pred_def_91584,type,
    v152357: ( state_type * $int ) > $o ).

tff(pred_def_91585,type,
    v152359: state_type > $o ).

tff(pred_def_91586,type,
    v152362: state_type > $o ).

tff(pred_def_91587,type,
    v152361: state_type > $o ).

tff(pred_def_91588,type,
    v152360: ( state_type * $int ) > $o ).

tff(pred_def_91589,type,
    v152324: ( state_type * $int ) > $o ).

tff(pred_def_91590,type,
    v152364: state_type > $o ).

tff(pred_def_91591,type,
    v152376: state_type > $o ).

tff(pred_def_91592,type,
    v152375: state_type > $o ).

tff(pred_def_91593,type,
    v152374: state_type > $o ).

tff(pred_def_91594,type,
    v152377: state_type > $o ).

tff(pred_def_91595,type,
    v152373: state_type > $o ).

tff(pred_def_91596,type,
    v152372: state_type > $o ).

tff(pred_def_91597,type,
    v152378: state_type > $o ).

tff(pred_def_91598,type,
    v152371: state_type > $o ).

tff(pred_def_91599,type,
    v152370: state_type > $o ).

tff(pred_def_91600,type,
    v152369: state_type > $o ).

tff(pred_def_91601,type,
    v152368: state_type > $o ).

tff(pred_def_91602,type,
    v152380: state_type > $o ).

tff(pred_def_91603,type,
    v152379: state_type > $o ).

tff(pred_def_91604,type,
    v152367: state_type > $o ).

tff(pred_def_91605,type,
    v152383: state_type > $o ).

tff(pred_def_91606,type,
    v152382: state_type > $o ).

tff(pred_def_91607,type,
    v152384: state_type > $o ).

tff(pred_def_91608,type,
    v152381: state_type > $o ).

tff(pred_def_91609,type,
    v152387: state_type > $o ).

tff(pred_def_91610,type,
    v152386: state_type > $o ).

tff(pred_def_91611,type,
    v152388: state_type > $o ).

tff(pred_def_91612,type,
    v152385: state_type > $o ).

tff(pred_def_91613,type,
    v152391: state_type > $o ).

tff(pred_def_91614,type,
    v152390: state_type > $o ).

tff(pred_def_91615,type,
    v152392: state_type > $o ).

tff(pred_def_91616,type,
    v152389: state_type > $o ).

tff(pred_def_91617,type,
    v152365: ( state_type * $int ) > $o ).

tff(pred_def_91618,type,
    v152363: ( state_type * $int ) > $o ).

tff(pred_def_91619,type,
    v152344: ( state_type * $int ) > $o ).

tff(pred_def_91620,type,
    v152342: ( state_type * $int ) > $o ).

tff(pred_def_91621,type,
    v152340: ( state_type * $int ) > $o ).

tff(pred_def_91622,type,
    v152338: ( state_type * $int ) > $o ).

tff(pred_def_91623,type,
    v152396: state_type > $o ).

tff(pred_def_91624,type,
    v152394: state_type > $o ).

tff(pred_def_91625,type,
    v152403: state_type > $o ).

tff(pred_def_91626,type,
    v152401: state_type > $o ).

tff(pred_def_91627,type,
    v152400: state_type > $o ).

tff(pred_def_91628,type,
    v152399: state_type > $o ).

tff(pred_def_91629,type,
    v152411: state_type > $o ).

tff(pred_def_91630,type,
    v152412: state_type > $o ).

tff(pred_def_91631,type,
    v152410: state_type > $o ).

tff(pred_def_91632,type,
    v152407: ( state_type * $int ) > $o ).

tff(pred_def_91633,type,
    v152409: ( state_type * $int ) > $o ).

tff(pred_def_91634,type,
    v152328: ( state_type * $int ) > $o ).

tff(pred_def_91635,type,
    v152326: ( state_type * $int ) > $o ).

tff(pred_def_91636,type,
    v152322: state_type > $o ).

tff(pred_def_91637,type,
    v152320: state_type > $o ).

tff(pred_def_91638,type,
    v152433: state_type > $o ).

tff(pred_def_91639,type,
    v152431: state_type > $o ).

tff(pred_def_91640,type,
    v152429: state_type > $o ).

tff(pred_def_91641,type,
    v152427: state_type > $o ).

tff(pred_def_91642,type,
    v152441: state_type > $o ).

tff(pred_def_91643,type,
    v152439: state_type > $o ).

tff(pred_def_91644,type,
    v152437: state_type > $o ).

tff(pred_def_91645,type,
    v152435: state_type > $o ).

tff(pred_def_91646,type,
    v152453: state_type > $o ).

tff(pred_def_91647,type,
    v152455: state_type > $o ).

tff(pred_def_91648,type,
    v152451: state_type > $o ).

tff(pred_def_91649,type,
    v152458: state_type > $o ).

tff(pred_def_91650,type,
    v152460: ( state_type * $int ) > $o ).

tff(pred_def_91651,type,
    v152462: state_type > $o ).

tff(pred_def_91652,type,
    v152421: ( state_type * $int ) > $o ).

tff(pred_def_91653,type,
    v152464: state_type > $o ).

tff(pred_def_91654,type,
    v152476: state_type > $o ).

tff(pred_def_91655,type,
    v152475: state_type > $o ).

tff(pred_def_91656,type,
    v152474: state_type > $o ).

tff(pred_def_91657,type,
    v152477: state_type > $o ).

tff(pred_def_91658,type,
    v152473: state_type > $o ).

tff(pred_def_91659,type,
    v152472: state_type > $o ).

tff(pred_def_91660,type,
    v152478: state_type > $o ).

tff(pred_def_91661,type,
    v152471: state_type > $o ).

tff(pred_def_91662,type,
    v152470: state_type > $o ).

tff(pred_def_91663,type,
    v152469: state_type > $o ).

tff(pred_def_91664,type,
    v152468: state_type > $o ).

tff(pred_def_91665,type,
    v152480: state_type > $o ).

tff(pred_def_91666,type,
    v152479: state_type > $o ).

tff(pred_def_91667,type,
    v152467: state_type > $o ).

tff(pred_def_91668,type,
    v152483: state_type > $o ).

tff(pred_def_91669,type,
    v152482: state_type > $o ).

tff(pred_def_91670,type,
    v152484: state_type > $o ).

tff(pred_def_91671,type,
    v152481: state_type > $o ).

tff(pred_def_91672,type,
    v152487: state_type > $o ).

tff(pred_def_91673,type,
    v152486: state_type > $o ).

tff(pred_def_91674,type,
    v152488: state_type > $o ).

tff(pred_def_91675,type,
    v152485: state_type > $o ).

tff(pred_def_91676,type,
    v152491: state_type > $o ).

tff(pred_def_91677,type,
    v152490: state_type > $o ).

tff(pred_def_91678,type,
    v152492: state_type > $o ).

tff(pred_def_91679,type,
    v152489: state_type > $o ).

tff(pred_def_91680,type,
    v152465: ( state_type * $int ) > $o ).

tff(pred_def_91681,type,
    v152463: ( state_type * $int ) > $o ).

tff(pred_def_91682,type,
    v152449: ( state_type * $int ) > $o ).

tff(pred_def_91683,type,
    v152447: ( state_type * $int ) > $o ).

tff(pred_def_91684,type,
    v152445: ( state_type * $int ) > $o ).

tff(pred_def_91685,type,
    v152443: ( state_type * $int ) > $o ).

tff(pred_def_91686,type,
    v152498: state_type > $o ).

tff(pred_def_91687,type,
    v152496: state_type > $o ).

tff(pred_def_91688,type,
    v152494: state_type > $o ).

tff(pred_def_91689,type,
    v152505: state_type > $o ).

tff(pred_def_91690,type,
    v152503: state_type > $o ).

tff(pred_def_91691,type,
    v152502: state_type > $o ).

tff(pred_def_91692,type,
    v152501: state_type > $o ).

tff(pred_def_91693,type,
    v152513: state_type > $o ).

tff(pred_def_91694,type,
    v152514: state_type > $o ).

tff(pred_def_91695,type,
    v152512: state_type > $o ).

tff(pred_def_91696,type,
    v152509: ( state_type * $int ) > $o ).

tff(pred_def_91697,type,
    v152511: ( state_type * $int ) > $o ).

tff(pred_def_91698,type,
    v152425: ( state_type * $int ) > $o ).

tff(pred_def_91699,type,
    v152423: ( state_type * $int ) > $o ).

tff(pred_def_91700,type,
    v152419: state_type > $o ).

tff(pred_def_91701,type,
    v152417: state_type > $o ).

tff(pred_def_91702,type,
    v152531: state_type > $o ).

tff(pred_def_91703,type,
    v152529: state_type > $o ).

tff(pred_def_91704,type,
    v152535: state_type > $o ).

tff(pred_def_91705,type,
    v152533: state_type > $o ).

tff(pred_def_91706,type,
    v152547: state_type > $o ).

tff(pred_def_91707,type,
    v152549: state_type > $o ).

tff(pred_def_91708,type,
    v152545: state_type > $o ).

tff(pred_def_91709,type,
    v152552: state_type > $o ).

tff(pred_def_91710,type,
    v152554: ( state_type * $int ) > $o ).

tff(pred_def_91711,type,
    v152556: ( state_type * $int ) > $o ).

tff(pred_def_91712,type,
    v152558: state_type > $o ).

tff(pred_def_91713,type,
    v152561: state_type > $o ).

tff(pred_def_91714,type,
    v152560: state_type > $o ).

tff(pred_def_91715,type,
    v152559: ( state_type * $int ) > $o ).

tff(pred_def_91716,type,
    v152523: ( state_type * $int ) > $o ).

tff(pred_def_91717,type,
    v152563: state_type > $o ).

tff(pred_def_91718,type,
    v152575: state_type > $o ).

tff(pred_def_91719,type,
    v152574: state_type > $o ).

tff(pred_def_91720,type,
    v152573: state_type > $o ).

tff(pred_def_91721,type,
    v152576: state_type > $o ).

tff(pred_def_91722,type,
    v152572: state_type > $o ).

tff(pred_def_91723,type,
    v152571: state_type > $o ).

tff(pred_def_91724,type,
    v152577: state_type > $o ).

tff(pred_def_91725,type,
    v152570: state_type > $o ).

tff(pred_def_91726,type,
    v152569: state_type > $o ).

tff(pred_def_91727,type,
    v152568: state_type > $o ).

tff(pred_def_91728,type,
    v152567: state_type > $o ).

tff(pred_def_91729,type,
    v152579: state_type > $o ).

tff(pred_def_91730,type,
    v152578: state_type > $o ).

tff(pred_def_91731,type,
    v152566: state_type > $o ).

tff(pred_def_91732,type,
    v152582: state_type > $o ).

tff(pred_def_91733,type,
    v152581: state_type > $o ).

tff(pred_def_91734,type,
    v152583: state_type > $o ).

tff(pred_def_91735,type,
    v152580: state_type > $o ).

tff(pred_def_91736,type,
    v152586: state_type > $o ).

tff(pred_def_91737,type,
    v152585: state_type > $o ).

tff(pred_def_91738,type,
    v152587: state_type > $o ).

tff(pred_def_91739,type,
    v152584: state_type > $o ).

tff(pred_def_91740,type,
    v152590: state_type > $o ).

tff(pred_def_91741,type,
    v152589: state_type > $o ).

tff(pred_def_91742,type,
    v152591: state_type > $o ).

tff(pred_def_91743,type,
    v152588: state_type > $o ).

tff(pred_def_91744,type,
    v152564: ( state_type * $int ) > $o ).

tff(pred_def_91745,type,
    v152562: ( state_type * $int ) > $o ).

tff(pred_def_91746,type,
    v152543: ( state_type * $int ) > $o ).

tff(pred_def_91747,type,
    v152541: ( state_type * $int ) > $o ).

tff(pred_def_91748,type,
    v152539: ( state_type * $int ) > $o ).

tff(pred_def_91749,type,
    v152537: ( state_type * $int ) > $o ).

tff(pred_def_91750,type,
    v152595: state_type > $o ).

tff(pred_def_91751,type,
    v152593: state_type > $o ).

tff(pred_def_91752,type,
    v152602: state_type > $o ).

tff(pred_def_91753,type,
    v152600: state_type > $o ).

tff(pred_def_91754,type,
    v152599: state_type > $o ).

tff(pred_def_91755,type,
    v152598: state_type > $o ).

tff(pred_def_91756,type,
    v152610: state_type > $o ).

tff(pred_def_91757,type,
    v152611: state_type > $o ).

tff(pred_def_91758,type,
    v152609: state_type > $o ).

tff(pred_def_91759,type,
    v152606: ( state_type * $int ) > $o ).

tff(pred_def_91760,type,
    v152608: ( state_type * $int ) > $o ).

tff(pred_def_91761,type,
    v152527: ( state_type * $int ) > $o ).

tff(pred_def_91762,type,
    v152525: ( state_type * $int ) > $o ).

tff(pred_def_91763,type,
    v152521: state_type > $o ).

tff(pred_def_91764,type,
    v152519: state_type > $o ).

tff(pred_def_91765,type,
    v152632: state_type > $o ).

tff(pred_def_91766,type,
    v152630: state_type > $o ).

tff(pred_def_91767,type,
    v152628: state_type > $o ).

tff(pred_def_91768,type,
    v152626: state_type > $o ).

tff(pred_def_91769,type,
    v152640: state_type > $o ).

tff(pred_def_91770,type,
    v152638: state_type > $o ).

tff(pred_def_91771,type,
    v152636: state_type > $o ).

tff(pred_def_91772,type,
    v152634: state_type > $o ).

tff(pred_def_91773,type,
    v152652: state_type > $o ).

tff(pred_def_91774,type,
    v152654: state_type > $o ).

tff(pred_def_91775,type,
    v152650: state_type > $o ).

tff(pred_def_91776,type,
    v152657: state_type > $o ).

tff(pred_def_91777,type,
    v152659: ( state_type * $int ) > $o ).

tff(pred_def_91778,type,
    v152661: state_type > $o ).

tff(pred_def_91779,type,
    v152620: ( state_type * $int ) > $o ).

tff(pred_def_91780,type,
    v152663: state_type > $o ).

tff(pred_def_91781,type,
    v152675: state_type > $o ).

tff(pred_def_91782,type,
    v152674: state_type > $o ).

tff(pred_def_91783,type,
    v152673: state_type > $o ).

tff(pred_def_91784,type,
    v152676: state_type > $o ).

tff(pred_def_91785,type,
    v152672: state_type > $o ).

tff(pred_def_91786,type,
    v152671: state_type > $o ).

tff(pred_def_91787,type,
    v152677: state_type > $o ).

tff(pred_def_91788,type,
    v152670: state_type > $o ).

tff(pred_def_91789,type,
    v152669: state_type > $o ).

tff(pred_def_91790,type,
    v152668: state_type > $o ).

tff(pred_def_91791,type,
    v152667: state_type > $o ).

tff(pred_def_91792,type,
    v152679: state_type > $o ).

tff(pred_def_91793,type,
    v152678: state_type > $o ).

tff(pred_def_91794,type,
    v152666: state_type > $o ).

tff(pred_def_91795,type,
    v152682: state_type > $o ).

tff(pred_def_91796,type,
    v152681: state_type > $o ).

tff(pred_def_91797,type,
    v152683: state_type > $o ).

tff(pred_def_91798,type,
    v152680: state_type > $o ).

tff(pred_def_91799,type,
    v152686: state_type > $o ).

tff(pred_def_91800,type,
    v152685: state_type > $o ).

tff(pred_def_91801,type,
    v152687: state_type > $o ).

tff(pred_def_91802,type,
    v152684: state_type > $o ).

tff(pred_def_91803,type,
    v152690: state_type > $o ).

tff(pred_def_91804,type,
    v152689: state_type > $o ).

tff(pred_def_91805,type,
    v152691: state_type > $o ).

tff(pred_def_91806,type,
    v152688: state_type > $o ).

tff(pred_def_91807,type,
    v152664: ( state_type * $int ) > $o ).

tff(pred_def_91808,type,
    v152662: ( state_type * $int ) > $o ).

tff(pred_def_91809,type,
    v152648: ( state_type * $int ) > $o ).

tff(pred_def_91810,type,
    v152646: ( state_type * $int ) > $o ).

tff(pred_def_91811,type,
    v152644: ( state_type * $int ) > $o ).

tff(pred_def_91812,type,
    v152642: ( state_type * $int ) > $o ).

tff(pred_def_91813,type,
    v152697: state_type > $o ).

tff(pred_def_91814,type,
    v152695: state_type > $o ).

tff(pred_def_91815,type,
    v152693: state_type > $o ).

tff(pred_def_91816,type,
    v152704: state_type > $o ).

tff(pred_def_91817,type,
    v152702: state_type > $o ).

tff(pred_def_91818,type,
    v152701: state_type > $o ).

tff(pred_def_91819,type,
    v152700: state_type > $o ).

tff(pred_def_91820,type,
    v152712: state_type > $o ).

tff(pred_def_91821,type,
    v152713: state_type > $o ).

tff(pred_def_91822,type,
    v152711: state_type > $o ).

tff(pred_def_91823,type,
    v152708: ( state_type * $int ) > $o ).

tff(pred_def_91824,type,
    v152710: ( state_type * $int ) > $o ).

tff(pred_def_91825,type,
    v152624: ( state_type * $int ) > $o ).

tff(pred_def_91826,type,
    v152622: ( state_type * $int ) > $o ).

tff(pred_def_91827,type,
    v152618: state_type > $o ).

tff(pred_def_91828,type,
    v152616: state_type > $o ).

tff(pred_def_91829,type,
    v152730: state_type > $o ).

tff(pred_def_91830,type,
    v152728: state_type > $o ).

tff(pred_def_91831,type,
    v152734: state_type > $o ).

tff(pred_def_91832,type,
    v152732: state_type > $o ).

tff(pred_def_91833,type,
    v152746: state_type > $o ).

tff(pred_def_91834,type,
    v152748: state_type > $o ).

tff(pred_def_91835,type,
    v152744: state_type > $o ).

tff(pred_def_91836,type,
    v152751: state_type > $o ).

tff(pred_def_91837,type,
    v152753: ( state_type * $int ) > $o ).

tff(pred_def_91838,type,
    v152755: ( state_type * $int ) > $o ).

tff(pred_def_91839,type,
    v152757: state_type > $o ).

tff(pred_def_91840,type,
    v152760: state_type > $o ).

tff(pred_def_91841,type,
    v152759: state_type > $o ).

tff(pred_def_91842,type,
    v152758: ( state_type * $int ) > $o ).

tff(pred_def_91843,type,
    v152722: ( state_type * $int ) > $o ).

tff(pred_def_91844,type,
    v152762: state_type > $o ).

tff(pred_def_91845,type,
    v152774: state_type > $o ).

tff(pred_def_91846,type,
    v152773: state_type > $o ).

tff(pred_def_91847,type,
    v152772: state_type > $o ).

tff(pred_def_91848,type,
    v152775: state_type > $o ).

tff(pred_def_91849,type,
    v152771: state_type > $o ).

tff(pred_def_91850,type,
    v152770: state_type > $o ).

tff(pred_def_91851,type,
    v152776: state_type > $o ).

tff(pred_def_91852,type,
    v152769: state_type > $o ).

tff(pred_def_91853,type,
    v152768: state_type > $o ).

tff(pred_def_91854,type,
    v152767: state_type > $o ).

tff(pred_def_91855,type,
    v152766: state_type > $o ).

tff(pred_def_91856,type,
    v152778: state_type > $o ).

tff(pred_def_91857,type,
    v152777: state_type > $o ).

tff(pred_def_91858,type,
    v152765: state_type > $o ).

tff(pred_def_91859,type,
    v152781: state_type > $o ).

tff(pred_def_91860,type,
    v152780: state_type > $o ).

tff(pred_def_91861,type,
    v152782: state_type > $o ).

tff(pred_def_91862,type,
    v152779: state_type > $o ).

tff(pred_def_91863,type,
    v152785: state_type > $o ).

tff(pred_def_91864,type,
    v152784: state_type > $o ).

tff(pred_def_91865,type,
    v152786: state_type > $o ).

tff(pred_def_91866,type,
    v152783: state_type > $o ).

tff(pred_def_91867,type,
    v152789: state_type > $o ).

tff(pred_def_91868,type,
    v152788: state_type > $o ).

tff(pred_def_91869,type,
    v152790: state_type > $o ).

tff(pred_def_91870,type,
    v152787: state_type > $o ).

tff(pred_def_91871,type,
    v152763: ( state_type * $int ) > $o ).

tff(pred_def_91872,type,
    v152761: ( state_type * $int ) > $o ).

tff(pred_def_91873,type,
    v152742: ( state_type * $int ) > $o ).

tff(pred_def_91874,type,
    v152740: ( state_type * $int ) > $o ).

tff(pred_def_91875,type,
    v152738: ( state_type * $int ) > $o ).

tff(pred_def_91876,type,
    v152736: ( state_type * $int ) > $o ).

tff(pred_def_91877,type,
    v152794: state_type > $o ).

tff(pred_def_91878,type,
    v152792: state_type > $o ).

tff(pred_def_91879,type,
    v152801: state_type > $o ).

tff(pred_def_91880,type,
    v152799: state_type > $o ).

tff(pred_def_91881,type,
    v152798: state_type > $o ).

tff(pred_def_91882,type,
    v152797: state_type > $o ).

tff(pred_def_91883,type,
    v152809: state_type > $o ).

tff(pred_def_91884,type,
    v152810: state_type > $o ).

tff(pred_def_91885,type,
    v152808: state_type > $o ).

tff(pred_def_91886,type,
    v152805: ( state_type * $int ) > $o ).

tff(pred_def_91887,type,
    v152807: ( state_type * $int ) > $o ).

tff(pred_def_91888,type,
    v152726: ( state_type * $int ) > $o ).

tff(pred_def_91889,type,
    v152724: ( state_type * $int ) > $o ).

tff(pred_def_91890,type,
    v152720: state_type > $o ).

tff(pred_def_91891,type,
    v152718: state_type > $o ).

tff(pred_def_91892,type,
    v152831: state_type > $o ).

tff(pred_def_91893,type,
    v152829: state_type > $o ).

tff(pred_def_91894,type,
    v152827: state_type > $o ).

tff(pred_def_91895,type,
    v152825: state_type > $o ).

tff(pred_def_91896,type,
    v152839: state_type > $o ).

tff(pred_def_91897,type,
    v152837: state_type > $o ).

tff(pred_def_91898,type,
    v152835: state_type > $o ).

tff(pred_def_91899,type,
    v152833: state_type > $o ).

tff(pred_def_91900,type,
    v152851: state_type > $o ).

tff(pred_def_91901,type,
    v152853: state_type > $o ).

tff(pred_def_91902,type,
    v152849: state_type > $o ).

tff(pred_def_91903,type,
    v152856: state_type > $o ).

tff(pred_def_91904,type,
    v152858: ( state_type * $int ) > $o ).

tff(pred_def_91905,type,
    v152860: state_type > $o ).

tff(pred_def_91906,type,
    v152819: ( state_type * $int ) > $o ).

tff(pred_def_91907,type,
    v152862: state_type > $o ).

tff(pred_def_91908,type,
    v152874: state_type > $o ).

tff(pred_def_91909,type,
    v152873: state_type > $o ).

tff(pred_def_91910,type,
    v152872: state_type > $o ).

tff(pred_def_91911,type,
    v152875: state_type > $o ).

tff(pred_def_91912,type,
    v152871: state_type > $o ).

tff(pred_def_91913,type,
    v152870: state_type > $o ).

tff(pred_def_91914,type,
    v152876: state_type > $o ).

tff(pred_def_91915,type,
    v152869: state_type > $o ).

tff(pred_def_91916,type,
    v152868: state_type > $o ).

tff(pred_def_91917,type,
    v152867: state_type > $o ).

tff(pred_def_91918,type,
    v152866: state_type > $o ).

tff(pred_def_91919,type,
    v152878: state_type > $o ).

tff(pred_def_91920,type,
    v152877: state_type > $o ).

tff(pred_def_91921,type,
    v152865: state_type > $o ).

tff(pred_def_91922,type,
    v152881: state_type > $o ).

tff(pred_def_91923,type,
    v152880: state_type > $o ).

tff(pred_def_91924,type,
    v152882: state_type > $o ).

tff(pred_def_91925,type,
    v152879: state_type > $o ).

tff(pred_def_91926,type,
    v152885: state_type > $o ).

tff(pred_def_91927,type,
    v152884: state_type > $o ).

tff(pred_def_91928,type,
    v152886: state_type > $o ).

tff(pred_def_91929,type,
    v152883: state_type > $o ).

tff(pred_def_91930,type,
    v152889: state_type > $o ).

tff(pred_def_91931,type,
    v152888: state_type > $o ).

tff(pred_def_91932,type,
    v152890: state_type > $o ).

tff(pred_def_91933,type,
    v152887: state_type > $o ).

tff(pred_def_91934,type,
    v152863: ( state_type * $int ) > $o ).

tff(pred_def_91935,type,
    v152861: ( state_type * $int ) > $o ).

tff(pred_def_91936,type,
    v152847: ( state_type * $int ) > $o ).

tff(pred_def_91937,type,
    v152845: ( state_type * $int ) > $o ).

tff(pred_def_91938,type,
    v152843: ( state_type * $int ) > $o ).

tff(pred_def_91939,type,
    v152841: ( state_type * $int ) > $o ).

tff(pred_def_91940,type,
    v152896: state_type > $o ).

tff(pred_def_91941,type,
    v152894: state_type > $o ).

tff(pred_def_91942,type,
    v152892: state_type > $o ).

tff(pred_def_91943,type,
    v152903: state_type > $o ).

tff(pred_def_91944,type,
    v152901: state_type > $o ).

tff(pred_def_91945,type,
    v152900: state_type > $o ).

tff(pred_def_91946,type,
    v152899: state_type > $o ).

tff(pred_def_91947,type,
    v152911: state_type > $o ).

tff(pred_def_91948,type,
    v152912: state_type > $o ).

tff(pred_def_91949,type,
    v152910: state_type > $o ).

tff(pred_def_91950,type,
    v152907: ( state_type * $int ) > $o ).

tff(pred_def_91951,type,
    v152909: ( state_type * $int ) > $o ).

tff(pred_def_91952,type,
    v152823: ( state_type * $int ) > $o ).

tff(pred_def_91953,type,
    v152821: ( state_type * $int ) > $o ).

tff(pred_def_91954,type,
    v152817: state_type > $o ).

tff(pred_def_91955,type,
    v152815: state_type > $o ).

tff(pred_def_91956,type,
    v152929: state_type > $o ).

tff(pred_def_91957,type,
    v152927: state_type > $o ).

tff(pred_def_91958,type,
    v152933: state_type > $o ).

tff(pred_def_91959,type,
    v152931: state_type > $o ).

tff(pred_def_91960,type,
    v152945: state_type > $o ).

tff(pred_def_91961,type,
    v152947: state_type > $o ).

tff(pred_def_91962,type,
    v152943: state_type > $o ).

tff(pred_def_91963,type,
    v152950: state_type > $o ).

tff(pred_def_91964,type,
    v152952: ( state_type * $int ) > $o ).

tff(pred_def_91965,type,
    v152954: ( state_type * $int ) > $o ).

tff(pred_def_91966,type,
    v152956: state_type > $o ).

tff(pred_def_91967,type,
    v152959: state_type > $o ).

tff(pred_def_91968,type,
    v152958: state_type > $o ).

tff(pred_def_91969,type,
    v152957: ( state_type * $int ) > $o ).

tff(pred_def_91970,type,
    v152921: ( state_type * $int ) > $o ).

tff(pred_def_91971,type,
    v152961: state_type > $o ).

tff(pred_def_91972,type,
    v152973: state_type > $o ).

tff(pred_def_91973,type,
    v152972: state_type > $o ).

tff(pred_def_91974,type,
    v152971: state_type > $o ).

tff(pred_def_91975,type,
    v152974: state_type > $o ).

tff(pred_def_91976,type,
    v152970: state_type > $o ).

tff(pred_def_91977,type,
    v152969: state_type > $o ).

tff(pred_def_91978,type,
    v152975: state_type > $o ).

tff(pred_def_91979,type,
    v152968: state_type > $o ).

tff(pred_def_91980,type,
    v152967: state_type > $o ).

tff(pred_def_91981,type,
    v152966: state_type > $o ).

tff(pred_def_91982,type,
    v152965: state_type > $o ).

tff(pred_def_91983,type,
    v152977: state_type > $o ).

tff(pred_def_91984,type,
    v152976: state_type > $o ).

tff(pred_def_91985,type,
    v152964: state_type > $o ).

tff(pred_def_91986,type,
    v152980: state_type > $o ).

tff(pred_def_91987,type,
    v152979: state_type > $o ).

tff(pred_def_91988,type,
    v152981: state_type > $o ).

tff(pred_def_91989,type,
    v152978: state_type > $o ).

tff(pred_def_91990,type,
    v152984: state_type > $o ).

tff(pred_def_91991,type,
    v152983: state_type > $o ).

tff(pred_def_91992,type,
    v152985: state_type > $o ).

tff(pred_def_91993,type,
    v152982: state_type > $o ).

tff(pred_def_91994,type,
    v152988: state_type > $o ).

tff(pred_def_91995,type,
    v152987: state_type > $o ).

tff(pred_def_91996,type,
    v152989: state_type > $o ).

tff(pred_def_91997,type,
    v152986: state_type > $o ).

tff(pred_def_91998,type,
    v152962: ( state_type * $int ) > $o ).

tff(pred_def_91999,type,
    v152960: ( state_type * $int ) > $o ).

tff(pred_def_92000,type,
    v152941: ( state_type * $int ) > $o ).

tff(pred_def_92001,type,
    v152939: ( state_type * $int ) > $o ).

tff(pred_def_92002,type,
    v152937: ( state_type * $int ) > $o ).

tff(pred_def_92003,type,
    v152935: ( state_type * $int ) > $o ).

tff(pred_def_92004,type,
    v152993: state_type > $o ).

tff(pred_def_92005,type,
    v152991: state_type > $o ).

tff(pred_def_92006,type,
    v153000: state_type > $o ).

tff(pred_def_92007,type,
    v152998: state_type > $o ).

tff(pred_def_92008,type,
    v152997: state_type > $o ).

tff(pred_def_92009,type,
    v152996: state_type > $o ).

tff(pred_def_92010,type,
    v153008: state_type > $o ).

tff(pred_def_92011,type,
    v153009: state_type > $o ).

tff(pred_def_92012,type,
    v153007: state_type > $o ).

tff(pred_def_92013,type,
    v153004: ( state_type * $int ) > $o ).

tff(pred_def_92014,type,
    v153006: ( state_type * $int ) > $o ).

tff(pred_def_92015,type,
    v152925: ( state_type * $int ) > $o ).

tff(pred_def_92016,type,
    v152923: ( state_type * $int ) > $o ).

tff(pred_def_92017,type,
    v152919: state_type > $o ).

tff(pred_def_92018,type,
    v152917: state_type > $o ).

tff(pred_def_92019,type,
    v153030: state_type > $o ).

tff(pred_def_92020,type,
    v153028: state_type > $o ).

tff(pred_def_92021,type,
    v153026: state_type > $o ).

tff(pred_def_92022,type,
    v153024: state_type > $o ).

tff(pred_def_92023,type,
    v153038: state_type > $o ).

tff(pred_def_92024,type,
    v153036: state_type > $o ).

tff(pred_def_92025,type,
    v153034: state_type > $o ).

tff(pred_def_92026,type,
    v153032: state_type > $o ).

tff(pred_def_92027,type,
    v153050: state_type > $o ).

tff(pred_def_92028,type,
    v153052: state_type > $o ).

tff(pred_def_92029,type,
    v153048: state_type > $o ).

tff(pred_def_92030,type,
    v153055: state_type > $o ).

tff(pred_def_92031,type,
    v153057: ( state_type * $int ) > $o ).

tff(pred_def_92032,type,
    v153059: state_type > $o ).

tff(pred_def_92033,type,
    v153018: ( state_type * $int ) > $o ).

tff(pred_def_92034,type,
    v153061: state_type > $o ).

tff(pred_def_92035,type,
    v153073: state_type > $o ).

tff(pred_def_92036,type,
    v153072: state_type > $o ).

tff(pred_def_92037,type,
    v153071: state_type > $o ).

tff(pred_def_92038,type,
    v153074: state_type > $o ).

tff(pred_def_92039,type,
    v153070: state_type > $o ).

tff(pred_def_92040,type,
    v153069: state_type > $o ).

tff(pred_def_92041,type,
    v153075: state_type > $o ).

tff(pred_def_92042,type,
    v153068: state_type > $o ).

tff(pred_def_92043,type,
    v153067: state_type > $o ).

tff(pred_def_92044,type,
    v153066: state_type > $o ).

tff(pred_def_92045,type,
    v153065: state_type > $o ).

tff(pred_def_92046,type,
    v153077: state_type > $o ).

tff(pred_def_92047,type,
    v153076: state_type > $o ).

tff(pred_def_92048,type,
    v153064: state_type > $o ).

tff(pred_def_92049,type,
    v153080: state_type > $o ).

tff(pred_def_92050,type,
    v153079: state_type > $o ).

tff(pred_def_92051,type,
    v153081: state_type > $o ).

tff(pred_def_92052,type,
    v153078: state_type > $o ).

tff(pred_def_92053,type,
    v153084: state_type > $o ).

tff(pred_def_92054,type,
    v153083: state_type > $o ).

tff(pred_def_92055,type,
    v153085: state_type > $o ).

tff(pred_def_92056,type,
    v153082: state_type > $o ).

tff(pred_def_92057,type,
    v153088: state_type > $o ).

tff(pred_def_92058,type,
    v153087: state_type > $o ).

tff(pred_def_92059,type,
    v153089: state_type > $o ).

tff(pred_def_92060,type,
    v153086: state_type > $o ).

tff(pred_def_92061,type,
    v153062: ( state_type * $int ) > $o ).

tff(pred_def_92062,type,
    v153060: ( state_type * $int ) > $o ).

tff(pred_def_92063,type,
    v153046: ( state_type * $int ) > $o ).

tff(pred_def_92064,type,
    v153044: ( state_type * $int ) > $o ).

tff(pred_def_92065,type,
    v153042: ( state_type * $int ) > $o ).

tff(pred_def_92066,type,
    v153040: ( state_type * $int ) > $o ).

tff(pred_def_92067,type,
    v153095: state_type > $o ).

tff(pred_def_92068,type,
    v153093: state_type > $o ).

tff(pred_def_92069,type,
    v153091: state_type > $o ).

tff(pred_def_92070,type,
    v153102: state_type > $o ).

tff(pred_def_92071,type,
    v153100: state_type > $o ).

tff(pred_def_92072,type,
    v153099: state_type > $o ).

tff(pred_def_92073,type,
    v153098: state_type > $o ).

tff(pred_def_92074,type,
    v153110: state_type > $o ).

tff(pred_def_92075,type,
    v153111: state_type > $o ).

tff(pred_def_92076,type,
    v153109: state_type > $o ).

tff(pred_def_92077,type,
    v153106: ( state_type * $int ) > $o ).

tff(pred_def_92078,type,
    v153108: ( state_type * $int ) > $o ).

tff(pred_def_92079,type,
    v153022: ( state_type * $int ) > $o ).

tff(pred_def_92080,type,
    v153020: ( state_type * $int ) > $o ).

tff(pred_def_92081,type,
    v153016: state_type > $o ).

tff(pred_def_92082,type,
    v153014: state_type > $o ).

tff(pred_def_92083,type,
    v153128: state_type > $o ).

tff(pred_def_92084,type,
    v153126: state_type > $o ).

tff(pred_def_92085,type,
    v153132: state_type > $o ).

tff(pred_def_92086,type,
    v153130: state_type > $o ).

tff(pred_def_92087,type,
    v153144: state_type > $o ).

tff(pred_def_92088,type,
    v153146: state_type > $o ).

tff(pred_def_92089,type,
    v153142: state_type > $o ).

tff(pred_def_92090,type,
    v153149: state_type > $o ).

tff(pred_def_92091,type,
    v153151: ( state_type * $int ) > $o ).

tff(pred_def_92092,type,
    v153153: ( state_type * $int ) > $o ).

tff(pred_def_92093,type,
    v153155: state_type > $o ).

tff(pred_def_92094,type,
    v153158: state_type > $o ).

tff(pred_def_92095,type,
    v153157: state_type > $o ).

tff(pred_def_92096,type,
    v153156: ( state_type * $int ) > $o ).

tff(pred_def_92097,type,
    v153120: ( state_type * $int ) > $o ).

tff(pred_def_92098,type,
    v153160: state_type > $o ).

tff(pred_def_92099,type,
    v153172: state_type > $o ).

tff(pred_def_92100,type,
    v153171: state_type > $o ).

tff(pred_def_92101,type,
    v153170: state_type > $o ).

tff(pred_def_92102,type,
    v153173: state_type > $o ).

tff(pred_def_92103,type,
    v153169: state_type > $o ).

tff(pred_def_92104,type,
    v153168: state_type > $o ).

tff(pred_def_92105,type,
    v153174: state_type > $o ).

tff(pred_def_92106,type,
    v153167: state_type > $o ).

tff(pred_def_92107,type,
    v153166: state_type > $o ).

tff(pred_def_92108,type,
    v153165: state_type > $o ).

tff(pred_def_92109,type,
    v153164: state_type > $o ).

tff(pred_def_92110,type,
    v153176: state_type > $o ).

tff(pred_def_92111,type,
    v153175: state_type > $o ).

tff(pred_def_92112,type,
    v153163: state_type > $o ).

tff(pred_def_92113,type,
    v153179: state_type > $o ).

tff(pred_def_92114,type,
    v153178: state_type > $o ).

tff(pred_def_92115,type,
    v153180: state_type > $o ).

tff(pred_def_92116,type,
    v153177: state_type > $o ).

tff(pred_def_92117,type,
    v153183: state_type > $o ).

tff(pred_def_92118,type,
    v153182: state_type > $o ).

tff(pred_def_92119,type,
    v153184: state_type > $o ).

tff(pred_def_92120,type,
    v153181: state_type > $o ).

tff(pred_def_92121,type,
    v153187: state_type > $o ).

tff(pred_def_92122,type,
    v153186: state_type > $o ).

tff(pred_def_92123,type,
    v153188: state_type > $o ).

tff(pred_def_92124,type,
    v153185: state_type > $o ).

tff(pred_def_92125,type,
    v153161: ( state_type * $int ) > $o ).

tff(pred_def_92126,type,
    v153159: ( state_type * $int ) > $o ).

tff(pred_def_92127,type,
    v153140: ( state_type * $int ) > $o ).

tff(pred_def_92128,type,
    v153138: ( state_type * $int ) > $o ).

tff(pred_def_92129,type,
    v153136: ( state_type * $int ) > $o ).

tff(pred_def_92130,type,
    v153134: ( state_type * $int ) > $o ).

tff(pred_def_92131,type,
    v153192: state_type > $o ).

tff(pred_def_92132,type,
    v153190: state_type > $o ).

tff(pred_def_92133,type,
    v153199: state_type > $o ).

tff(pred_def_92134,type,
    v153197: state_type > $o ).

tff(pred_def_92135,type,
    v153196: state_type > $o ).

tff(pred_def_92136,type,
    v153195: state_type > $o ).

tff(pred_def_92137,type,
    v153207: state_type > $o ).

tff(pred_def_92138,type,
    v153208: state_type > $o ).

tff(pred_def_92139,type,
    v153206: state_type > $o ).

tff(pred_def_92140,type,
    v153203: ( state_type * $int ) > $o ).

tff(pred_def_92141,type,
    v153205: ( state_type * $int ) > $o ).

tff(pred_def_92142,type,
    v153124: ( state_type * $int ) > $o ).

tff(pred_def_92143,type,
    v153122: ( state_type * $int ) > $o ).

tff(pred_def_92144,type,
    v153118: state_type > $o ).

tff(pred_def_92145,type,
    v153116: state_type > $o ).

tff(pred_def_92146,type,
    v153229: state_type > $o ).

tff(pred_def_92147,type,
    v153227: state_type > $o ).

tff(pred_def_92148,type,
    v153225: state_type > $o ).

tff(pred_def_92149,type,
    v153223: state_type > $o ).

tff(pred_def_92150,type,
    v153237: state_type > $o ).

tff(pred_def_92151,type,
    v153235: state_type > $o ).

tff(pred_def_92152,type,
    v153233: state_type > $o ).

tff(pred_def_92153,type,
    v153231: state_type > $o ).

tff(pred_def_92154,type,
    v153249: state_type > $o ).

tff(pred_def_92155,type,
    v153251: state_type > $o ).

tff(pred_def_92156,type,
    v153247: state_type > $o ).

tff(pred_def_92157,type,
    v153254: state_type > $o ).

tff(pred_def_92158,type,
    v153256: ( state_type * $int ) > $o ).

tff(pred_def_92159,type,
    v153258: state_type > $o ).

tff(pred_def_92160,type,
    v153217: ( state_type * $int ) > $o ).

tff(pred_def_92161,type,
    v153260: state_type > $o ).

tff(pred_def_92162,type,
    v153272: state_type > $o ).

tff(pred_def_92163,type,
    v153271: state_type > $o ).

tff(pred_def_92164,type,
    v153270: state_type > $o ).

tff(pred_def_92165,type,
    v153273: state_type > $o ).

tff(pred_def_92166,type,
    v153269: state_type > $o ).

tff(pred_def_92167,type,
    v153268: state_type > $o ).

tff(pred_def_92168,type,
    v153274: state_type > $o ).

tff(pred_def_92169,type,
    v153267: state_type > $o ).

tff(pred_def_92170,type,
    v153266: state_type > $o ).

tff(pred_def_92171,type,
    v153265: state_type > $o ).

tff(pred_def_92172,type,
    v153264: state_type > $o ).

tff(pred_def_92173,type,
    v153276: state_type > $o ).

tff(pred_def_92174,type,
    v153275: state_type > $o ).

tff(pred_def_92175,type,
    v153263: state_type > $o ).

tff(pred_def_92176,type,
    v153279: state_type > $o ).

tff(pred_def_92177,type,
    v153278: state_type > $o ).

tff(pred_def_92178,type,
    v153280: state_type > $o ).

tff(pred_def_92179,type,
    v153277: state_type > $o ).

tff(pred_def_92180,type,
    v153283: state_type > $o ).

tff(pred_def_92181,type,
    v153282: state_type > $o ).

tff(pred_def_92182,type,
    v153284: state_type > $o ).

tff(pred_def_92183,type,
    v153281: state_type > $o ).

tff(pred_def_92184,type,
    v153287: state_type > $o ).

tff(pred_def_92185,type,
    v153286: state_type > $o ).

tff(pred_def_92186,type,
    v153288: state_type > $o ).

tff(pred_def_92187,type,
    v153285: state_type > $o ).

tff(pred_def_92188,type,
    v153261: ( state_type * $int ) > $o ).

tff(pred_def_92189,type,
    v153259: ( state_type * $int ) > $o ).

tff(pred_def_92190,type,
    v153245: ( state_type * $int ) > $o ).

tff(pred_def_92191,type,
    v153243: ( state_type * $int ) > $o ).

tff(pred_def_92192,type,
    v153241: ( state_type * $int ) > $o ).

tff(pred_def_92193,type,
    v153239: ( state_type * $int ) > $o ).

tff(pred_def_92194,type,
    v153294: state_type > $o ).

tff(pred_def_92195,type,
    v153292: state_type > $o ).

tff(pred_def_92196,type,
    v153290: state_type > $o ).

tff(pred_def_92197,type,
    v153301: state_type > $o ).

tff(pred_def_92198,type,
    v153299: state_type > $o ).

tff(pred_def_92199,type,
    v153298: state_type > $o ).

tff(pred_def_92200,type,
    v153297: state_type > $o ).

tff(pred_def_92201,type,
    v153309: state_type > $o ).

tff(pred_def_92202,type,
    v153310: state_type > $o ).

tff(pred_def_92203,type,
    v153308: state_type > $o ).

tff(pred_def_92204,type,
    v153305: ( state_type * $int ) > $o ).

tff(pred_def_92205,type,
    v153307: ( state_type * $int ) > $o ).

tff(pred_def_92206,type,
    v153221: ( state_type * $int ) > $o ).

tff(pred_def_92207,type,
    v153219: ( state_type * $int ) > $o ).

tff(pred_def_92208,type,
    v153215: state_type > $o ).

tff(pred_def_92209,type,
    v153213: state_type > $o ).

tff(pred_def_92210,type,
    v153327: state_type > $o ).

tff(pred_def_92211,type,
    v153325: state_type > $o ).

tff(pred_def_92212,type,
    v153331: state_type > $o ).

tff(pred_def_92213,type,
    v153329: state_type > $o ).

tff(pred_def_92214,type,
    v153343: state_type > $o ).

tff(pred_def_92215,type,
    v153345: state_type > $o ).

tff(pred_def_92216,type,
    v153341: state_type > $o ).

tff(pred_def_92217,type,
    v153348: state_type > $o ).

tff(pred_def_92218,type,
    v153350: ( state_type * $int ) > $o ).

tff(pred_def_92219,type,
    v153352: ( state_type * $int ) > $o ).

tff(pred_def_92220,type,
    v153354: state_type > $o ).

tff(pred_def_92221,type,
    v153357: state_type > $o ).

tff(pred_def_92222,type,
    v153356: state_type > $o ).

tff(pred_def_92223,type,
    v153355: ( state_type * $int ) > $o ).

tff(pred_def_92224,type,
    v153319: ( state_type * $int ) > $o ).

tff(pred_def_92225,type,
    v153359: state_type > $o ).

tff(pred_def_92226,type,
    v153371: state_type > $o ).

tff(pred_def_92227,type,
    v153370: state_type > $o ).

tff(pred_def_92228,type,
    v153369: state_type > $o ).

tff(pred_def_92229,type,
    v153372: state_type > $o ).

tff(pred_def_92230,type,
    v153368: state_type > $o ).

tff(pred_def_92231,type,
    v153367: state_type > $o ).

tff(pred_def_92232,type,
    v153373: state_type > $o ).

tff(pred_def_92233,type,
    v153366: state_type > $o ).

tff(pred_def_92234,type,
    v153365: state_type > $o ).

tff(pred_def_92235,type,
    v153364: state_type > $o ).

tff(pred_def_92236,type,
    v153363: state_type > $o ).

tff(pred_def_92237,type,
    v153375: state_type > $o ).

tff(pred_def_92238,type,
    v153374: state_type > $o ).

tff(pred_def_92239,type,
    v153362: state_type > $o ).

tff(pred_def_92240,type,
    v153378: state_type > $o ).

tff(pred_def_92241,type,
    v153377: state_type > $o ).

tff(pred_def_92242,type,
    v153379: state_type > $o ).

tff(pred_def_92243,type,
    v153376: state_type > $o ).

tff(pred_def_92244,type,
    v153382: state_type > $o ).

tff(pred_def_92245,type,
    v153381: state_type > $o ).

tff(pred_def_92246,type,
    v153383: state_type > $o ).

tff(pred_def_92247,type,
    v153380: state_type > $o ).

tff(pred_def_92248,type,
    v153386: state_type > $o ).

tff(pred_def_92249,type,
    v153385: state_type > $o ).

tff(pred_def_92250,type,
    v153387: state_type > $o ).

tff(pred_def_92251,type,
    v153384: state_type > $o ).

tff(pred_def_92252,type,
    v153360: ( state_type * $int ) > $o ).

tff(pred_def_92253,type,
    v153358: ( state_type * $int ) > $o ).

tff(pred_def_92254,type,
    v153339: ( state_type * $int ) > $o ).

tff(pred_def_92255,type,
    v153337: ( state_type * $int ) > $o ).

tff(pred_def_92256,type,
    v153335: ( state_type * $int ) > $o ).

tff(pred_def_92257,type,
    v153333: ( state_type * $int ) > $o ).

tff(pred_def_92258,type,
    v153391: state_type > $o ).

tff(pred_def_92259,type,
    v153389: state_type > $o ).

tff(pred_def_92260,type,
    v153398: state_type > $o ).

tff(pred_def_92261,type,
    v153396: state_type > $o ).

tff(pred_def_92262,type,
    v153395: state_type > $o ).

tff(pred_def_92263,type,
    v153394: state_type > $o ).

tff(pred_def_92264,type,
    v153406: state_type > $o ).

tff(pred_def_92265,type,
    v153407: state_type > $o ).

tff(pred_def_92266,type,
    v153405: state_type > $o ).

tff(pred_def_92267,type,
    v153402: ( state_type * $int ) > $o ).

tff(pred_def_92268,type,
    v153404: ( state_type * $int ) > $o ).

tff(pred_def_92269,type,
    v153323: ( state_type * $int ) > $o ).

tff(pred_def_92270,type,
    v153321: ( state_type * $int ) > $o ).

tff(pred_def_92271,type,
    v153317: state_type > $o ).

tff(pred_def_92272,type,
    v153315: state_type > $o ).

tff(pred_def_92273,type,
    v153428: state_type > $o ).

tff(pred_def_92274,type,
    v153426: state_type > $o ).

tff(pred_def_92275,type,
    v153424: state_type > $o ).

tff(pred_def_92276,type,
    v153422: state_type > $o ).

tff(pred_def_92277,type,
    v153436: state_type > $o ).

tff(pred_def_92278,type,
    v153434: state_type > $o ).

tff(pred_def_92279,type,
    v153432: state_type > $o ).

tff(pred_def_92280,type,
    v153430: state_type > $o ).

tff(pred_def_92281,type,
    v153448: state_type > $o ).

tff(pred_def_92282,type,
    v153450: state_type > $o ).

tff(pred_def_92283,type,
    v153446: state_type > $o ).

tff(pred_def_92284,type,
    v153453: state_type > $o ).

tff(pred_def_92285,type,
    v153455: ( state_type * $int ) > $o ).

tff(pred_def_92286,type,
    v153457: state_type > $o ).

tff(pred_def_92287,type,
    v153416: ( state_type * $int ) > $o ).

tff(pred_def_92288,type,
    v153459: state_type > $o ).

tff(pred_def_92289,type,
    v153471: state_type > $o ).

tff(pred_def_92290,type,
    v153470: state_type > $o ).

tff(pred_def_92291,type,
    v153469: state_type > $o ).

tff(pred_def_92292,type,
    v153472: state_type > $o ).

tff(pred_def_92293,type,
    v153468: state_type > $o ).

tff(pred_def_92294,type,
    v153467: state_type > $o ).

tff(pred_def_92295,type,
    v153473: state_type > $o ).

tff(pred_def_92296,type,
    v153466: state_type > $o ).

tff(pred_def_92297,type,
    v153465: state_type > $o ).

tff(pred_def_92298,type,
    v153464: state_type > $o ).

tff(pred_def_92299,type,
    v153463: state_type > $o ).

tff(pred_def_92300,type,
    v153475: state_type > $o ).

tff(pred_def_92301,type,
    v153474: state_type > $o ).

tff(pred_def_92302,type,
    v153462: state_type > $o ).

tff(pred_def_92303,type,
    v153478: state_type > $o ).

tff(pred_def_92304,type,
    v153477: state_type > $o ).

tff(pred_def_92305,type,
    v153479: state_type > $o ).

tff(pred_def_92306,type,
    v153476: state_type > $o ).

tff(pred_def_92307,type,
    v153482: state_type > $o ).

tff(pred_def_92308,type,
    v153481: state_type > $o ).

tff(pred_def_92309,type,
    v153483: state_type > $o ).

tff(pred_def_92310,type,
    v153480: state_type > $o ).

tff(pred_def_92311,type,
    v153486: state_type > $o ).

tff(pred_def_92312,type,
    v153485: state_type > $o ).

tff(pred_def_92313,type,
    v153487: state_type > $o ).

tff(pred_def_92314,type,
    v153484: state_type > $o ).

tff(pred_def_92315,type,
    v153460: ( state_type * $int ) > $o ).

tff(pred_def_92316,type,
    v153458: ( state_type * $int ) > $o ).

tff(pred_def_92317,type,
    v153444: ( state_type * $int ) > $o ).

tff(pred_def_92318,type,
    v153442: ( state_type * $int ) > $o ).

tff(pred_def_92319,type,
    v153440: ( state_type * $int ) > $o ).

tff(pred_def_92320,type,
    v153438: ( state_type * $int ) > $o ).

tff(pred_def_92321,type,
    v153493: state_type > $o ).

tff(pred_def_92322,type,
    v153491: state_type > $o ).

tff(pred_def_92323,type,
    v153489: state_type > $o ).

tff(pred_def_92324,type,
    v153500: state_type > $o ).

tff(pred_def_92325,type,
    v153498: state_type > $o ).

tff(pred_def_92326,type,
    v153497: state_type > $o ).

tff(pred_def_92327,type,
    v153496: state_type > $o ).

tff(pred_def_92328,type,
    v153508: state_type > $o ).

tff(pred_def_92329,type,
    v153509: state_type > $o ).

tff(pred_def_92330,type,
    v153507: state_type > $o ).

tff(pred_def_92331,type,
    v153504: ( state_type * $int ) > $o ).

tff(pred_def_92332,type,
    v153506: ( state_type * $int ) > $o ).

tff(pred_def_92333,type,
    v153420: ( state_type * $int ) > $o ).

tff(pred_def_92334,type,
    v153418: ( state_type * $int ) > $o ).

tff(pred_def_92335,type,
    v153414: state_type > $o ).

tff(pred_def_92336,type,
    v153412: state_type > $o ).

tff(pred_def_92337,type,
    v153526: state_type > $o ).

tff(pred_def_92338,type,
    v153524: state_type > $o ).

tff(pred_def_92339,type,
    v153530: state_type > $o ).

tff(pred_def_92340,type,
    v153528: state_type > $o ).

tff(pred_def_92341,type,
    v153542: state_type > $o ).

tff(pred_def_92342,type,
    v153544: state_type > $o ).

tff(pred_def_92343,type,
    v153540: state_type > $o ).

tff(pred_def_92344,type,
    v153547: state_type > $o ).

tff(pred_def_92345,type,
    v153549: ( state_type * $int ) > $o ).

tff(pred_def_92346,type,
    v153551: ( state_type * $int ) > $o ).

tff(pred_def_92347,type,
    v153553: state_type > $o ).

tff(pred_def_92348,type,
    v153556: state_type > $o ).

tff(pred_def_92349,type,
    v153555: state_type > $o ).

tff(pred_def_92350,type,
    v153554: ( state_type * $int ) > $o ).

tff(pred_def_92351,type,
    v153518: ( state_type * $int ) > $o ).

tff(pred_def_92352,type,
    v153558: state_type > $o ).

tff(pred_def_92353,type,
    v153570: state_type > $o ).

tff(pred_def_92354,type,
    v153569: state_type > $o ).

tff(pred_def_92355,type,
    v153568: state_type > $o ).

tff(pred_def_92356,type,
    v153571: state_type > $o ).

tff(pred_def_92357,type,
    v153567: state_type > $o ).

tff(pred_def_92358,type,
    v153566: state_type > $o ).

tff(pred_def_92359,type,
    v153572: state_type > $o ).

tff(pred_def_92360,type,
    v153565: state_type > $o ).

tff(pred_def_92361,type,
    v153564: state_type > $o ).

tff(pred_def_92362,type,
    v153563: state_type > $o ).

tff(pred_def_92363,type,
    v153562: state_type > $o ).

tff(pred_def_92364,type,
    v153574: state_type > $o ).

tff(pred_def_92365,type,
    v153573: state_type > $o ).

tff(pred_def_92366,type,
    v153561: state_type > $o ).

tff(pred_def_92367,type,
    v153577: state_type > $o ).

tff(pred_def_92368,type,
    v153576: state_type > $o ).

tff(pred_def_92369,type,
    v153578: state_type > $o ).

tff(pred_def_92370,type,
    v153575: state_type > $o ).

tff(pred_def_92371,type,
    v153581: state_type > $o ).

tff(pred_def_92372,type,
    v153580: state_type > $o ).

tff(pred_def_92373,type,
    v153582: state_type > $o ).

tff(pred_def_92374,type,
    v153579: state_type > $o ).

tff(pred_def_92375,type,
    v153585: state_type > $o ).

tff(pred_def_92376,type,
    v153584: state_type > $o ).

tff(pred_def_92377,type,
    v153586: state_type > $o ).

tff(pred_def_92378,type,
    v153583: state_type > $o ).

tff(pred_def_92379,type,
    v153559: ( state_type * $int ) > $o ).

tff(pred_def_92380,type,
    v153557: ( state_type * $int ) > $o ).

tff(pred_def_92381,type,
    v153538: ( state_type * $int ) > $o ).

tff(pred_def_92382,type,
    v153536: ( state_type * $int ) > $o ).

tff(pred_def_92383,type,
    v153534: ( state_type * $int ) > $o ).

tff(pred_def_92384,type,
    v153532: ( state_type * $int ) > $o ).

tff(pred_def_92385,type,
    v153590: state_type > $o ).

tff(pred_def_92386,type,
    v153588: state_type > $o ).

tff(pred_def_92387,type,
    v153597: state_type > $o ).

tff(pred_def_92388,type,
    v153595: state_type > $o ).

tff(pred_def_92389,type,
    v153594: state_type > $o ).

tff(pred_def_92390,type,
    v153593: state_type > $o ).

tff(pred_def_92391,type,
    v153605: state_type > $o ).

tff(pred_def_92392,type,
    v153606: state_type > $o ).

tff(pred_def_92393,type,
    v153604: state_type > $o ).

tff(pred_def_92394,type,
    v153601: ( state_type * $int ) > $o ).

tff(pred_def_92395,type,
    v153603: ( state_type * $int ) > $o ).

tff(pred_def_92396,type,
    v153522: ( state_type * $int ) > $o ).

tff(pred_def_92397,type,
    v153520: ( state_type * $int ) > $o ).

tff(pred_def_92398,type,
    v153516: state_type > $o ).

tff(pred_def_92399,type,
    v153514: state_type > $o ).

tff(pred_def_92400,type,
    v153627: state_type > $o ).

tff(pred_def_92401,type,
    v153625: state_type > $o ).

tff(pred_def_92402,type,
    v153623: state_type > $o ).

tff(pred_def_92403,type,
    v153621: state_type > $o ).

tff(pred_def_92404,type,
    v153635: state_type > $o ).

tff(pred_def_92405,type,
    v153633: state_type > $o ).

tff(pred_def_92406,type,
    v153631: state_type > $o ).

tff(pred_def_92407,type,
    v153629: state_type > $o ).

tff(pred_def_92408,type,
    v153647: state_type > $o ).

tff(pred_def_92409,type,
    v153649: state_type > $o ).

tff(pred_def_92410,type,
    v153645: state_type > $o ).

tff(pred_def_92411,type,
    v153652: state_type > $o ).

tff(pred_def_92412,type,
    v153654: ( state_type * $int ) > $o ).

tff(pred_def_92413,type,
    v153656: state_type > $o ).

tff(pred_def_92414,type,
    v153615: ( state_type * $int ) > $o ).

tff(pred_def_92415,type,
    v153658: state_type > $o ).

tff(pred_def_92416,type,
    v153670: state_type > $o ).

tff(pred_def_92417,type,
    v153669: state_type > $o ).

tff(pred_def_92418,type,
    v153668: state_type > $o ).

tff(pred_def_92419,type,
    v153671: state_type > $o ).

tff(pred_def_92420,type,
    v153667: state_type > $o ).

tff(pred_def_92421,type,
    v153666: state_type > $o ).

tff(pred_def_92422,type,
    v153672: state_type > $o ).

tff(pred_def_92423,type,
    v153665: state_type > $o ).

tff(pred_def_92424,type,
    v153664: state_type > $o ).

tff(pred_def_92425,type,
    v153663: state_type > $o ).

tff(pred_def_92426,type,
    v153662: state_type > $o ).

tff(pred_def_92427,type,
    v153674: state_type > $o ).

tff(pred_def_92428,type,
    v153673: state_type > $o ).

tff(pred_def_92429,type,
    v153661: state_type > $o ).

tff(pred_def_92430,type,
    v153677: state_type > $o ).

tff(pred_def_92431,type,
    v153676: state_type > $o ).

tff(pred_def_92432,type,
    v153678: state_type > $o ).

tff(pred_def_92433,type,
    v153675: state_type > $o ).

tff(pred_def_92434,type,
    v153681: state_type > $o ).

tff(pred_def_92435,type,
    v153680: state_type > $o ).

tff(pred_def_92436,type,
    v153682: state_type > $o ).

tff(pred_def_92437,type,
    v153679: state_type > $o ).

tff(pred_def_92438,type,
    v153685: state_type > $o ).

tff(pred_def_92439,type,
    v153684: state_type > $o ).

tff(pred_def_92440,type,
    v153686: state_type > $o ).

tff(pred_def_92441,type,
    v153683: state_type > $o ).

tff(pred_def_92442,type,
    v153659: ( state_type * $int ) > $o ).

tff(pred_def_92443,type,
    v153657: ( state_type * $int ) > $o ).

tff(pred_def_92444,type,
    v153643: ( state_type * $int ) > $o ).

tff(pred_def_92445,type,
    v153641: ( state_type * $int ) > $o ).

tff(pred_def_92446,type,
    v153639: ( state_type * $int ) > $o ).

tff(pred_def_92447,type,
    v153637: ( state_type * $int ) > $o ).

tff(pred_def_92448,type,
    v153692: state_type > $o ).

tff(pred_def_92449,type,
    v153690: state_type > $o ).

tff(pred_def_92450,type,
    v153688: state_type > $o ).

tff(pred_def_92451,type,
    v153699: state_type > $o ).

tff(pred_def_92452,type,
    v153697: state_type > $o ).

tff(pred_def_92453,type,
    v153696: state_type > $o ).

tff(pred_def_92454,type,
    v153695: state_type > $o ).

tff(pred_def_92455,type,
    v153707: state_type > $o ).

tff(pred_def_92456,type,
    v153708: state_type > $o ).

tff(pred_def_92457,type,
    v153706: state_type > $o ).

tff(pred_def_92458,type,
    v153703: ( state_type * $int ) > $o ).

tff(pred_def_92459,type,
    v153705: ( state_type * $int ) > $o ).

tff(pred_def_92460,type,
    v153619: ( state_type * $int ) > $o ).

tff(pred_def_92461,type,
    v153617: ( state_type * $int ) > $o ).

tff(pred_def_92462,type,
    v153613: state_type > $o ).

tff(pred_def_92463,type,
    v153611: state_type > $o ).

tff(pred_def_92464,type,
    v153725: state_type > $o ).

tff(pred_def_92465,type,
    v153723: state_type > $o ).

tff(pred_def_92466,type,
    v153729: state_type > $o ).

tff(pred_def_92467,type,
    v153727: state_type > $o ).

tff(pred_def_92468,type,
    v153741: state_type > $o ).

tff(pred_def_92469,type,
    v153743: state_type > $o ).

tff(pred_def_92470,type,
    v153739: state_type > $o ).

tff(pred_def_92471,type,
    v153746: state_type > $o ).

tff(pred_def_92472,type,
    v153748: ( state_type * $int ) > $o ).

tff(pred_def_92473,type,
    v153750: ( state_type * $int ) > $o ).

tff(pred_def_92474,type,
    v153752: state_type > $o ).

tff(pred_def_92475,type,
    v153755: state_type > $o ).

tff(pred_def_92476,type,
    v153754: state_type > $o ).

tff(pred_def_92477,type,
    v153753: ( state_type * $int ) > $o ).

tff(pred_def_92478,type,
    v153717: ( state_type * $int ) > $o ).

tff(pred_def_92479,type,
    v153757: state_type > $o ).

tff(pred_def_92480,type,
    v153769: state_type > $o ).

tff(pred_def_92481,type,
    v153768: state_type > $o ).

tff(pred_def_92482,type,
    v153767: state_type > $o ).

tff(pred_def_92483,type,
    v153770: state_type > $o ).

tff(pred_def_92484,type,
    v153766: state_type > $o ).

tff(pred_def_92485,type,
    v153765: state_type > $o ).

tff(pred_def_92486,type,
    v153771: state_type > $o ).

tff(pred_def_92487,type,
    v153764: state_type > $o ).

tff(pred_def_92488,type,
    v153763: state_type > $o ).

tff(pred_def_92489,type,
    v153762: state_type > $o ).

tff(pred_def_92490,type,
    v153761: state_type > $o ).

tff(pred_def_92491,type,
    v153773: state_type > $o ).

tff(pred_def_92492,type,
    v153772: state_type > $o ).

tff(pred_def_92493,type,
    v153760: state_type > $o ).

tff(pred_def_92494,type,
    v153776: state_type > $o ).

tff(pred_def_92495,type,
    v153775: state_type > $o ).

tff(pred_def_92496,type,
    v153777: state_type > $o ).

tff(pred_def_92497,type,
    v153774: state_type > $o ).

tff(pred_def_92498,type,
    v153780: state_type > $o ).

tff(pred_def_92499,type,
    v153779: state_type > $o ).

tff(pred_def_92500,type,
    v153781: state_type > $o ).

tff(pred_def_92501,type,
    v153778: state_type > $o ).

tff(pred_def_92502,type,
    v153784: state_type > $o ).

tff(pred_def_92503,type,
    v153783: state_type > $o ).

tff(pred_def_92504,type,
    v153785: state_type > $o ).

tff(pred_def_92505,type,
    v153782: state_type > $o ).

tff(pred_def_92506,type,
    v153758: ( state_type * $int ) > $o ).

tff(pred_def_92507,type,
    v153756: ( state_type * $int ) > $o ).

tff(pred_def_92508,type,
    v153737: ( state_type * $int ) > $o ).

tff(pred_def_92509,type,
    v153735: ( state_type * $int ) > $o ).

tff(pred_def_92510,type,
    v153733: ( state_type * $int ) > $o ).

tff(pred_def_92511,type,
    v153731: ( state_type * $int ) > $o ).

tff(pred_def_92512,type,
    v153789: state_type > $o ).

tff(pred_def_92513,type,
    v153787: state_type > $o ).

tff(pred_def_92514,type,
    v153796: state_type > $o ).

tff(pred_def_92515,type,
    v153794: state_type > $o ).

tff(pred_def_92516,type,
    v153793: state_type > $o ).

tff(pred_def_92517,type,
    v153792: state_type > $o ).

tff(pred_def_92518,type,
    v153804: state_type > $o ).

tff(pred_def_92519,type,
    v153805: state_type > $o ).

tff(pred_def_92520,type,
    v153803: state_type > $o ).

tff(pred_def_92521,type,
    v153800: ( state_type * $int ) > $o ).

tff(pred_def_92522,type,
    v153802: ( state_type * $int ) > $o ).

tff(pred_def_92523,type,
    v153721: ( state_type * $int ) > $o ).

tff(pred_def_92524,type,
    v153719: ( state_type * $int ) > $o ).

tff(pred_def_92525,type,
    v153715: state_type > $o ).

tff(pred_def_92526,type,
    v153713: state_type > $o ).

tff(pred_def_92527,type,
    v153826: state_type > $o ).

tff(pred_def_92528,type,
    v153824: state_type > $o ).

tff(pred_def_92529,type,
    v153822: state_type > $o ).

tff(pred_def_92530,type,
    v153820: state_type > $o ).

tff(pred_def_92531,type,
    v153834: state_type > $o ).

tff(pred_def_92532,type,
    v153832: state_type > $o ).

tff(pred_def_92533,type,
    v153830: state_type > $o ).

tff(pred_def_92534,type,
    v153828: state_type > $o ).

tff(pred_def_92535,type,
    v153846: state_type > $o ).

tff(pred_def_92536,type,
    v153848: state_type > $o ).

tff(pred_def_92537,type,
    v153844: state_type > $o ).

tff(pred_def_92538,type,
    v153851: state_type > $o ).

tff(pred_def_92539,type,
    v153853: ( state_type * $int ) > $o ).

tff(pred_def_92540,type,
    v153855: state_type > $o ).

tff(pred_def_92541,type,
    v153814: ( state_type * $int ) > $o ).

tff(pred_def_92542,type,
    v153857: state_type > $o ).

tff(pred_def_92543,type,
    v153869: state_type > $o ).

tff(pred_def_92544,type,
    v153868: state_type > $o ).

tff(pred_def_92545,type,
    v153867: state_type > $o ).

tff(pred_def_92546,type,
    v153870: state_type > $o ).

tff(pred_def_92547,type,
    v153866: state_type > $o ).

tff(pred_def_92548,type,
    v153865: state_type > $o ).

tff(pred_def_92549,type,
    v153871: state_type > $o ).

tff(pred_def_92550,type,
    v153864: state_type > $o ).

tff(pred_def_92551,type,
    v153863: state_type > $o ).

tff(pred_def_92552,type,
    v153862: state_type > $o ).

tff(pred_def_92553,type,
    v153861: state_type > $o ).

tff(pred_def_92554,type,
    v153873: state_type > $o ).

tff(pred_def_92555,type,
    v153872: state_type > $o ).

tff(pred_def_92556,type,
    v153860: state_type > $o ).

tff(pred_def_92557,type,
    v153876: state_type > $o ).

tff(pred_def_92558,type,
    v153875: state_type > $o ).

tff(pred_def_92559,type,
    v153877: state_type > $o ).

tff(pred_def_92560,type,
    v153874: state_type > $o ).

tff(pred_def_92561,type,
    v153880: state_type > $o ).

tff(pred_def_92562,type,
    v153879: state_type > $o ).

tff(pred_def_92563,type,
    v153881: state_type > $o ).

tff(pred_def_92564,type,
    v153878: state_type > $o ).

tff(pred_def_92565,type,
    v153884: state_type > $o ).

tff(pred_def_92566,type,
    v153883: state_type > $o ).

tff(pred_def_92567,type,
    v153885: state_type > $o ).

tff(pred_def_92568,type,
    v153882: state_type > $o ).

tff(pred_def_92569,type,
    v153858: ( state_type * $int ) > $o ).

tff(pred_def_92570,type,
    v153856: ( state_type * $int ) > $o ).

tff(pred_def_92571,type,
    v153842: ( state_type * $int ) > $o ).

tff(pred_def_92572,type,
    v153840: ( state_type * $int ) > $o ).

tff(pred_def_92573,type,
    v153838: ( state_type * $int ) > $o ).

tff(pred_def_92574,type,
    v153836: ( state_type * $int ) > $o ).

tff(pred_def_92575,type,
    v153891: state_type > $o ).

tff(pred_def_92576,type,
    v153889: state_type > $o ).

tff(pred_def_92577,type,
    v153887: state_type > $o ).

tff(pred_def_92578,type,
    v153898: state_type > $o ).

tff(pred_def_92579,type,
    v153896: state_type > $o ).

tff(pred_def_92580,type,
    v153895: state_type > $o ).

tff(pred_def_92581,type,
    v153894: state_type > $o ).

tff(pred_def_92582,type,
    v153906: state_type > $o ).

tff(pred_def_92583,type,
    v153907: state_type > $o ).

tff(pred_def_92584,type,
    v153905: state_type > $o ).

tff(pred_def_92585,type,
    v153902: ( state_type * $int ) > $o ).

tff(pred_def_92586,type,
    v153904: ( state_type * $int ) > $o ).

tff(pred_def_92587,type,
    v153818: ( state_type * $int ) > $o ).

tff(pred_def_92588,type,
    v153816: ( state_type * $int ) > $o ).

tff(pred_def_92589,type,
    v153812: state_type > $o ).

tff(pred_def_92590,type,
    v153810: state_type > $o ).

tff(pred_def_92591,type,
    v153924: state_type > $o ).

tff(pred_def_92592,type,
    v153922: state_type > $o ).

tff(pred_def_92593,type,
    v153928: state_type > $o ).

tff(pred_def_92594,type,
    v153926: state_type > $o ).

tff(pred_def_92595,type,
    v153940: state_type > $o ).

tff(pred_def_92596,type,
    v153942: state_type > $o ).

tff(pred_def_92597,type,
    v153938: state_type > $o ).

tff(pred_def_92598,type,
    v153945: state_type > $o ).

tff(pred_def_92599,type,
    v153947: ( state_type * $int ) > $o ).

tff(pred_def_92600,type,
    v153949: ( state_type * $int ) > $o ).

tff(pred_def_92601,type,
    v153951: state_type > $o ).

tff(pred_def_92602,type,
    v153954: state_type > $o ).

tff(pred_def_92603,type,
    v153953: state_type > $o ).

tff(pred_def_92604,type,
    v153952: ( state_type * $int ) > $o ).

tff(pred_def_92605,type,
    v153916: ( state_type * $int ) > $o ).

tff(pred_def_92606,type,
    v153956: state_type > $o ).

tff(pred_def_92607,type,
    v153968: state_type > $o ).

tff(pred_def_92608,type,
    v153967: state_type > $o ).

tff(pred_def_92609,type,
    v153966: state_type > $o ).

tff(pred_def_92610,type,
    v153969: state_type > $o ).

tff(pred_def_92611,type,
    v153965: state_type > $o ).

tff(pred_def_92612,type,
    v153964: state_type > $o ).

tff(pred_def_92613,type,
    v153970: state_type > $o ).

tff(pred_def_92614,type,
    v153963: state_type > $o ).

tff(pred_def_92615,type,
    v153962: state_type > $o ).

tff(pred_def_92616,type,
    v153961: state_type > $o ).

tff(pred_def_92617,type,
    v153960: state_type > $o ).

tff(pred_def_92618,type,
    v153972: state_type > $o ).

tff(pred_def_92619,type,
    v153971: state_type > $o ).

tff(pred_def_92620,type,
    v153959: state_type > $o ).

tff(pred_def_92621,type,
    v153975: state_type > $o ).

tff(pred_def_92622,type,
    v153974: state_type > $o ).

tff(pred_def_92623,type,
    v153976: state_type > $o ).

tff(pred_def_92624,type,
    v153973: state_type > $o ).

tff(pred_def_92625,type,
    v153979: state_type > $o ).

tff(pred_def_92626,type,
    v153978: state_type > $o ).

tff(pred_def_92627,type,
    v153980: state_type > $o ).

tff(pred_def_92628,type,
    v153977: state_type > $o ).

tff(pred_def_92629,type,
    v153983: state_type > $o ).

tff(pred_def_92630,type,
    v153982: state_type > $o ).

tff(pred_def_92631,type,
    v153984: state_type > $o ).

tff(pred_def_92632,type,
    v153981: state_type > $o ).

tff(pred_def_92633,type,
    v153957: ( state_type * $int ) > $o ).

tff(pred_def_92634,type,
    v153955: ( state_type * $int ) > $o ).

tff(pred_def_92635,type,
    v153936: ( state_type * $int ) > $o ).

tff(pred_def_92636,type,
    v153934: ( state_type * $int ) > $o ).

tff(pred_def_92637,type,
    v153932: ( state_type * $int ) > $o ).

tff(pred_def_92638,type,
    v153930: ( state_type * $int ) > $o ).

tff(pred_def_92639,type,
    v153988: state_type > $o ).

tff(pred_def_92640,type,
    v153986: state_type > $o ).

tff(pred_def_92641,type,
    v153995: state_type > $o ).

tff(pred_def_92642,type,
    v153993: state_type > $o ).

tff(pred_def_92643,type,
    v153992: state_type > $o ).

tff(pred_def_92644,type,
    v153991: state_type > $o ).

tff(pred_def_92645,type,
    v154003: state_type > $o ).

tff(pred_def_92646,type,
    v154004: state_type > $o ).

tff(pred_def_92647,type,
    v154002: state_type > $o ).

tff(pred_def_92648,type,
    v153999: ( state_type * $int ) > $o ).

tff(pred_def_92649,type,
    v154001: ( state_type * $int ) > $o ).

tff(pred_def_92650,type,
    v153920: ( state_type * $int ) > $o ).

tff(pred_def_92651,type,
    v153918: ( state_type * $int ) > $o ).

tff(pred_def_92652,type,
    v153914: state_type > $o ).

tff(pred_def_92653,type,
    v153912: state_type > $o ).

tff(pred_def_92654,type,
    v154025: state_type > $o ).

tff(pred_def_92655,type,
    v154023: state_type > $o ).

tff(pred_def_92656,type,
    v154021: state_type > $o ).

tff(pred_def_92657,type,
    v154019: state_type > $o ).

tff(pred_def_92658,type,
    v154033: state_type > $o ).

tff(pred_def_92659,type,
    v154031: state_type > $o ).

tff(pred_def_92660,type,
    v154029: state_type > $o ).

tff(pred_def_92661,type,
    v154027: state_type > $o ).

tff(pred_def_92662,type,
    v154045: state_type > $o ).

tff(pred_def_92663,type,
    v154047: state_type > $o ).

tff(pred_def_92664,type,
    v154043: state_type > $o ).

tff(pred_def_92665,type,
    v154050: state_type > $o ).

tff(pred_def_92666,type,
    v154052: ( state_type * $int ) > $o ).

tff(pred_def_92667,type,
    v154054: state_type > $o ).

tff(pred_def_92668,type,
    v154013: ( state_type * $int ) > $o ).

tff(pred_def_92669,type,
    v154056: state_type > $o ).

tff(pred_def_92670,type,
    v154068: state_type > $o ).

tff(pred_def_92671,type,
    v154067: state_type > $o ).

tff(pred_def_92672,type,
    v154066: state_type > $o ).

tff(pred_def_92673,type,
    v154069: state_type > $o ).

tff(pred_def_92674,type,
    v154065: state_type > $o ).

tff(pred_def_92675,type,
    v154064: state_type > $o ).

tff(pred_def_92676,type,
    v154070: state_type > $o ).

tff(pred_def_92677,type,
    v154063: state_type > $o ).

tff(pred_def_92678,type,
    v154062: state_type > $o ).

tff(pred_def_92679,type,
    v154061: state_type > $o ).

tff(pred_def_92680,type,
    v154060: state_type > $o ).

tff(pred_def_92681,type,
    v154072: state_type > $o ).

tff(pred_def_92682,type,
    v154071: state_type > $o ).

tff(pred_def_92683,type,
    v154059: state_type > $o ).

tff(pred_def_92684,type,
    v154075: state_type > $o ).

tff(pred_def_92685,type,
    v154074: state_type > $o ).

tff(pred_def_92686,type,
    v154076: state_type > $o ).

tff(pred_def_92687,type,
    v154073: state_type > $o ).

tff(pred_def_92688,type,
    v154079: state_type > $o ).

tff(pred_def_92689,type,
    v154078: state_type > $o ).

tff(pred_def_92690,type,
    v154080: state_type > $o ).

tff(pred_def_92691,type,
    v154077: state_type > $o ).

tff(pred_def_92692,type,
    v154083: state_type > $o ).

tff(pred_def_92693,type,
    v154082: state_type > $o ).

tff(pred_def_92694,type,
    v154084: state_type > $o ).

tff(pred_def_92695,type,
    v154081: state_type > $o ).

tff(pred_def_92696,type,
    v154057: ( state_type * $int ) > $o ).

tff(pred_def_92697,type,
    v154055: ( state_type * $int ) > $o ).

tff(pred_def_92698,type,
    v154041: ( state_type * $int ) > $o ).

tff(pred_def_92699,type,
    v154039: ( state_type * $int ) > $o ).

tff(pred_def_92700,type,
    v154037: ( state_type * $int ) > $o ).

tff(pred_def_92701,type,
    v154035: ( state_type * $int ) > $o ).

tff(pred_def_92702,type,
    v154090: state_type > $o ).

tff(pred_def_92703,type,
    v154088: state_type > $o ).

tff(pred_def_92704,type,
    v154086: state_type > $o ).

tff(pred_def_92705,type,
    v154097: state_type > $o ).

tff(pred_def_92706,type,
    v154095: state_type > $o ).

tff(pred_def_92707,type,
    v154094: state_type > $o ).

tff(pred_def_92708,type,
    v154093: state_type > $o ).

tff(pred_def_92709,type,
    v154105: state_type > $o ).

tff(pred_def_92710,type,
    v154106: state_type > $o ).

tff(pred_def_92711,type,
    v154104: state_type > $o ).

tff(pred_def_92712,type,
    v154101: ( state_type * $int ) > $o ).

tff(pred_def_92713,type,
    v154103: ( state_type * $int ) > $o ).

tff(pred_def_92714,type,
    v154017: ( state_type * $int ) > $o ).

tff(pred_def_92715,type,
    v154015: ( state_type * $int ) > $o ).

tff(pred_def_92716,type,
    v154011: state_type > $o ).

tff(pred_def_92717,type,
    v154009: state_type > $o ).

tff(pred_def_92718,type,
    v154123: state_type > $o ).

tff(pred_def_92719,type,
    v154121: state_type > $o ).

tff(pred_def_92720,type,
    v154127: state_type > $o ).

tff(pred_def_92721,type,
    v154125: state_type > $o ).

tff(pred_def_92722,type,
    v154139: state_type > $o ).

tff(pred_def_92723,type,
    v154141: state_type > $o ).

tff(pred_def_92724,type,
    v154137: state_type > $o ).

tff(pred_def_92725,type,
    v154144: state_type > $o ).

tff(pred_def_92726,type,
    v154146: ( state_type * $int ) > $o ).

tff(pred_def_92727,type,
    v154148: ( state_type * $int ) > $o ).

tff(pred_def_92728,type,
    v154150: state_type > $o ).

tff(pred_def_92729,type,
    v154153: state_type > $o ).

tff(pred_def_92730,type,
    v154152: state_type > $o ).

tff(pred_def_92731,type,
    v154151: ( state_type * $int ) > $o ).

tff(pred_def_92732,type,
    v154115: ( state_type * $int ) > $o ).

tff(pred_def_92733,type,
    v154155: state_type > $o ).

tff(pred_def_92734,type,
    v154167: state_type > $o ).

tff(pred_def_92735,type,
    v154166: state_type > $o ).

tff(pred_def_92736,type,
    v154165: state_type > $o ).

tff(pred_def_92737,type,
    v154168: state_type > $o ).

tff(pred_def_92738,type,
    v154164: state_type > $o ).

tff(pred_def_92739,type,
    v154163: state_type > $o ).

tff(pred_def_92740,type,
    v154169: state_type > $o ).

tff(pred_def_92741,type,
    v154162: state_type > $o ).

tff(pred_def_92742,type,
    v154161: state_type > $o ).

tff(pred_def_92743,type,
    v154160: state_type > $o ).

tff(pred_def_92744,type,
    v154159: state_type > $o ).

tff(pred_def_92745,type,
    v154171: state_type > $o ).

tff(pred_def_92746,type,
    v154170: state_type > $o ).

tff(pred_def_92747,type,
    v154158: state_type > $o ).

tff(pred_def_92748,type,
    v154174: state_type > $o ).

tff(pred_def_92749,type,
    v154173: state_type > $o ).

tff(pred_def_92750,type,
    v154175: state_type > $o ).

tff(pred_def_92751,type,
    v154172: state_type > $o ).

tff(pred_def_92752,type,
    v154178: state_type > $o ).

tff(pred_def_92753,type,
    v154177: state_type > $o ).

tff(pred_def_92754,type,
    v154179: state_type > $o ).

tff(pred_def_92755,type,
    v154176: state_type > $o ).

tff(pred_def_92756,type,
    v154182: state_type > $o ).

tff(pred_def_92757,type,
    v154181: state_type > $o ).

tff(pred_def_92758,type,
    v154183: state_type > $o ).

tff(pred_def_92759,type,
    v154180: state_type > $o ).

tff(pred_def_92760,type,
    v154156: ( state_type * $int ) > $o ).

tff(pred_def_92761,type,
    v154154: ( state_type * $int ) > $o ).

tff(pred_def_92762,type,
    v154135: ( state_type * $int ) > $o ).

tff(pred_def_92763,type,
    v154133: ( state_type * $int ) > $o ).

tff(pred_def_92764,type,
    v154131: ( state_type * $int ) > $o ).

tff(pred_def_92765,type,
    v154129: ( state_type * $int ) > $o ).

tff(pred_def_92766,type,
    v154187: state_type > $o ).

tff(pred_def_92767,type,
    v154185: state_type > $o ).

tff(pred_def_92768,type,
    v154194: state_type > $o ).

tff(pred_def_92769,type,
    v154192: state_type > $o ).

tff(pred_def_92770,type,
    v154191: state_type > $o ).

tff(pred_def_92771,type,
    v154190: state_type > $o ).

tff(pred_def_92772,type,
    v154202: state_type > $o ).

tff(pred_def_92773,type,
    v154203: state_type > $o ).

tff(pred_def_92774,type,
    v154201: state_type > $o ).

tff(pred_def_92775,type,
    v154198: ( state_type * $int ) > $o ).

tff(pred_def_92776,type,
    v154200: ( state_type * $int ) > $o ).

tff(pred_def_92777,type,
    v154119: ( state_type * $int ) > $o ).

tff(pred_def_92778,type,
    v154117: ( state_type * $int ) > $o ).

tff(pred_def_92779,type,
    v154113: state_type > $o ).

tff(pred_def_92780,type,
    v154111: state_type > $o ).

tff(pred_def_92781,type,
    v154224: state_type > $o ).

tff(pred_def_92782,type,
    v154222: state_type > $o ).

tff(pred_def_92783,type,
    v154220: state_type > $o ).

tff(pred_def_92784,type,
    v154218: state_type > $o ).

tff(pred_def_92785,type,
    v154232: state_type > $o ).

tff(pred_def_92786,type,
    v154230: state_type > $o ).

tff(pred_def_92787,type,
    v154228: state_type > $o ).

tff(pred_def_92788,type,
    v154226: state_type > $o ).

tff(pred_def_92789,type,
    v154244: state_type > $o ).

tff(pred_def_92790,type,
    v154246: state_type > $o ).

tff(pred_def_92791,type,
    v154242: state_type > $o ).

tff(pred_def_92792,type,
    v154249: state_type > $o ).

tff(pred_def_92793,type,
    v154251: ( state_type * $int ) > $o ).

tff(pred_def_92794,type,
    v154253: state_type > $o ).

tff(pred_def_92795,type,
    v154212: ( state_type * $int ) > $o ).

tff(pred_def_92796,type,
    v154255: state_type > $o ).

tff(pred_def_92797,type,
    v154267: state_type > $o ).

tff(pred_def_92798,type,
    v154266: state_type > $o ).

tff(pred_def_92799,type,
    v154265: state_type > $o ).

tff(pred_def_92800,type,
    v154268: state_type > $o ).

tff(pred_def_92801,type,
    v154264: state_type > $o ).

tff(pred_def_92802,type,
    v154263: state_type > $o ).

tff(pred_def_92803,type,
    v154269: state_type > $o ).

tff(pred_def_92804,type,
    v154262: state_type > $o ).

tff(pred_def_92805,type,
    v154261: state_type > $o ).

tff(pred_def_92806,type,
    v154260: state_type > $o ).

tff(pred_def_92807,type,
    v154259: state_type > $o ).

tff(pred_def_92808,type,
    v154271: state_type > $o ).

tff(pred_def_92809,type,
    v154270: state_type > $o ).

tff(pred_def_92810,type,
    v154258: state_type > $o ).

tff(pred_def_92811,type,
    v154274: state_type > $o ).

tff(pred_def_92812,type,
    v154273: state_type > $o ).

tff(pred_def_92813,type,
    v154275: state_type > $o ).

tff(pred_def_92814,type,
    v154272: state_type > $o ).

tff(pred_def_92815,type,
    v154278: state_type > $o ).

tff(pred_def_92816,type,
    v154277: state_type > $o ).

tff(pred_def_92817,type,
    v154279: state_type > $o ).

tff(pred_def_92818,type,
    v154276: state_type > $o ).

tff(pred_def_92819,type,
    v154282: state_type > $o ).

tff(pred_def_92820,type,
    v154281: state_type > $o ).

tff(pred_def_92821,type,
    v154283: state_type > $o ).

tff(pred_def_92822,type,
    v154280: state_type > $o ).

tff(pred_def_92823,type,
    v154256: ( state_type * $int ) > $o ).

tff(pred_def_92824,type,
    v154254: ( state_type * $int ) > $o ).

tff(pred_def_92825,type,
    v154240: ( state_type * $int ) > $o ).

tff(pred_def_92826,type,
    v154238: ( state_type * $int ) > $o ).

tff(pred_def_92827,type,
    v154236: ( state_type * $int ) > $o ).

tff(pred_def_92828,type,
    v154234: ( state_type * $int ) > $o ).

tff(pred_def_92829,type,
    v154289: state_type > $o ).

tff(pred_def_92830,type,
    v154287: state_type > $o ).

tff(pred_def_92831,type,
    v154285: state_type > $o ).

tff(pred_def_92832,type,
    v154296: state_type > $o ).

tff(pred_def_92833,type,
    v154294: state_type > $o ).

tff(pred_def_92834,type,
    v154293: state_type > $o ).

tff(pred_def_92835,type,
    v154292: state_type > $o ).

tff(pred_def_92836,type,
    v154304: state_type > $o ).

tff(pred_def_92837,type,
    v154305: state_type > $o ).

tff(pred_def_92838,type,
    v154303: state_type > $o ).

tff(pred_def_92839,type,
    v154300: ( state_type * $int ) > $o ).

tff(pred_def_92840,type,
    v154302: ( state_type * $int ) > $o ).

tff(pred_def_92841,type,
    v154216: ( state_type * $int ) > $o ).

tff(pred_def_92842,type,
    v154214: ( state_type * $int ) > $o ).

tff(pred_def_92843,type,
    v154210: state_type > $o ).

tff(pred_def_92844,type,
    v154208: state_type > $o ).

tff(pred_def_92845,type,
    v154322: state_type > $o ).

tff(pred_def_92846,type,
    v154320: state_type > $o ).

tff(pred_def_92847,type,
    v154326: state_type > $o ).

tff(pred_def_92848,type,
    v154324: state_type > $o ).

tff(pred_def_92849,type,
    v154338: state_type > $o ).

tff(pred_def_92850,type,
    v154340: state_type > $o ).

tff(pred_def_92851,type,
    v154336: state_type > $o ).

tff(pred_def_92852,type,
    v154343: state_type > $o ).

tff(pred_def_92853,type,
    v154345: ( state_type * $int ) > $o ).

tff(pred_def_92854,type,
    v154347: ( state_type * $int ) > $o ).

tff(pred_def_92855,type,
    v154349: state_type > $o ).

tff(pred_def_92856,type,
    v154352: state_type > $o ).

tff(pred_def_92857,type,
    v154351: state_type > $o ).

tff(pred_def_92858,type,
    v154350: ( state_type * $int ) > $o ).

tff(pred_def_92859,type,
    v154314: ( state_type * $int ) > $o ).

tff(pred_def_92860,type,
    v154354: state_type > $o ).

tff(pred_def_92861,type,
    v154366: state_type > $o ).

tff(pred_def_92862,type,
    v154365: state_type > $o ).

tff(pred_def_92863,type,
    v154364: state_type > $o ).

tff(pred_def_92864,type,
    v154367: state_type > $o ).

tff(pred_def_92865,type,
    v154363: state_type > $o ).

tff(pred_def_92866,type,
    v154362: state_type > $o ).

tff(pred_def_92867,type,
    v154368: state_type > $o ).

tff(pred_def_92868,type,
    v154361: state_type > $o ).

tff(pred_def_92869,type,
    v154360: state_type > $o ).

tff(pred_def_92870,type,
    v154359: state_type > $o ).

tff(pred_def_92871,type,
    v154358: state_type > $o ).

tff(pred_def_92872,type,
    v154370: state_type > $o ).

tff(pred_def_92873,type,
    v154369: state_type > $o ).

tff(pred_def_92874,type,
    v154357: state_type > $o ).

tff(pred_def_92875,type,
    v154373: state_type > $o ).

tff(pred_def_92876,type,
    v154372: state_type > $o ).

tff(pred_def_92877,type,
    v154374: state_type > $o ).

tff(pred_def_92878,type,
    v154371: state_type > $o ).

tff(pred_def_92879,type,
    v154377: state_type > $o ).

tff(pred_def_92880,type,
    v154376: state_type > $o ).

tff(pred_def_92881,type,
    v154378: state_type > $o ).

tff(pred_def_92882,type,
    v154375: state_type > $o ).

tff(pred_def_92883,type,
    v154381: state_type > $o ).

tff(pred_def_92884,type,
    v154380: state_type > $o ).

tff(pred_def_92885,type,
    v154382: state_type > $o ).

tff(pred_def_92886,type,
    v154379: state_type > $o ).

tff(pred_def_92887,type,
    v154355: ( state_type * $int ) > $o ).

tff(pred_def_92888,type,
    v154353: ( state_type * $int ) > $o ).

tff(pred_def_92889,type,
    v154334: ( state_type * $int ) > $o ).

tff(pred_def_92890,type,
    v154332: ( state_type * $int ) > $o ).

tff(pred_def_92891,type,
    v154330: ( state_type * $int ) > $o ).

tff(pred_def_92892,type,
    v154328: ( state_type * $int ) > $o ).

tff(pred_def_92893,type,
    v154386: state_type > $o ).

tff(pred_def_92894,type,
    v154384: state_type > $o ).

tff(pred_def_92895,type,
    v154393: state_type > $o ).

tff(pred_def_92896,type,
    v154391: state_type > $o ).

tff(pred_def_92897,type,
    v154390: state_type > $o ).

tff(pred_def_92898,type,
    v154389: state_type > $o ).

tff(pred_def_92899,type,
    v154401: state_type > $o ).

tff(pred_def_92900,type,
    v154402: state_type > $o ).

tff(pred_def_92901,type,
    v154400: state_type > $o ).

tff(pred_def_92902,type,
    v154397: ( state_type * $int ) > $o ).

tff(pred_def_92903,type,
    v154399: ( state_type * $int ) > $o ).

tff(pred_def_92904,type,
    v154318: ( state_type * $int ) > $o ).

tff(pred_def_92905,type,
    v154316: ( state_type * $int ) > $o ).

tff(pred_def_92906,type,
    v154312: state_type > $o ).

tff(pred_def_92907,type,
    v154310: state_type > $o ).

tff(pred_def_92908,type,
    v154423: state_type > $o ).

tff(pred_def_92909,type,
    v154421: state_type > $o ).

tff(pred_def_92910,type,
    v154419: state_type > $o ).

tff(pred_def_92911,type,
    v154417: state_type > $o ).

tff(pred_def_92912,type,
    v154431: state_type > $o ).

tff(pred_def_92913,type,
    v154429: state_type > $o ).

tff(pred_def_92914,type,
    v154427: state_type > $o ).

tff(pred_def_92915,type,
    v154425: state_type > $o ).

tff(pred_def_92916,type,
    v154443: state_type > $o ).

tff(pred_def_92917,type,
    v154445: state_type > $o ).

tff(pred_def_92918,type,
    v154441: state_type > $o ).

tff(pred_def_92919,type,
    v154448: state_type > $o ).

tff(pred_def_92920,type,
    v154450: ( state_type * $int ) > $o ).

tff(pred_def_92921,type,
    v154452: state_type > $o ).

tff(pred_def_92922,type,
    v154411: ( state_type * $int ) > $o ).

tff(pred_def_92923,type,
    v154454: state_type > $o ).

tff(pred_def_92924,type,
    v154466: state_type > $o ).

tff(pred_def_92925,type,
    v154465: state_type > $o ).

tff(pred_def_92926,type,
    v154464: state_type > $o ).

tff(pred_def_92927,type,
    v154467: state_type > $o ).

tff(pred_def_92928,type,
    v154463: state_type > $o ).

tff(pred_def_92929,type,
    v154462: state_type > $o ).

tff(pred_def_92930,type,
    v154468: state_type > $o ).

tff(pred_def_92931,type,
    v154461: state_type > $o ).

tff(pred_def_92932,type,
    v154460: state_type > $o ).

tff(pred_def_92933,type,
    v154459: state_type > $o ).

tff(pred_def_92934,type,
    v154458: state_type > $o ).

tff(pred_def_92935,type,
    v154470: state_type > $o ).

tff(pred_def_92936,type,
    v154469: state_type > $o ).

tff(pred_def_92937,type,
    v154457: state_type > $o ).

tff(pred_def_92938,type,
    v154473: state_type > $o ).

tff(pred_def_92939,type,
    v154472: state_type > $o ).

tff(pred_def_92940,type,
    v154474: state_type > $o ).

tff(pred_def_92941,type,
    v154471: state_type > $o ).

tff(pred_def_92942,type,
    v154477: state_type > $o ).

tff(pred_def_92943,type,
    v154476: state_type > $o ).

tff(pred_def_92944,type,
    v154478: state_type > $o ).

tff(pred_def_92945,type,
    v154475: state_type > $o ).

tff(pred_def_92946,type,
    v154481: state_type > $o ).

tff(pred_def_92947,type,
    v154480: state_type > $o ).

tff(pred_def_92948,type,
    v154482: state_type > $o ).

tff(pred_def_92949,type,
    v154479: state_type > $o ).

tff(pred_def_92950,type,
    v154455: ( state_type * $int ) > $o ).

tff(pred_def_92951,type,
    v154453: ( state_type * $int ) > $o ).

tff(pred_def_92952,type,
    v154439: ( state_type * $int ) > $o ).

tff(pred_def_92953,type,
    v154437: ( state_type * $int ) > $o ).

tff(pred_def_92954,type,
    v154435: ( state_type * $int ) > $o ).

tff(pred_def_92955,type,
    v154433: ( state_type * $int ) > $o ).

tff(pred_def_92956,type,
    v154488: state_type > $o ).

tff(pred_def_92957,type,
    v154486: state_type > $o ).

tff(pred_def_92958,type,
    v154484: state_type > $o ).

tff(pred_def_92959,type,
    v154495: state_type > $o ).

tff(pred_def_92960,type,
    v154493: state_type > $o ).

tff(pred_def_92961,type,
    v154492: state_type > $o ).

tff(pred_def_92962,type,
    v154491: state_type > $o ).

tff(pred_def_92963,type,
    v154503: state_type > $o ).

tff(pred_def_92964,type,
    v154504: state_type > $o ).

tff(pred_def_92965,type,
    v154502: state_type > $o ).

tff(pred_def_92966,type,
    v154499: ( state_type * $int ) > $o ).

tff(pred_def_92967,type,
    v154501: ( state_type * $int ) > $o ).

tff(pred_def_92968,type,
    v154415: ( state_type * $int ) > $o ).

tff(pred_def_92969,type,
    v154413: ( state_type * $int ) > $o ).

tff(pred_def_92970,type,
    v154409: state_type > $o ).

tff(pred_def_92971,type,
    v154407: state_type > $o ).

tff(pred_def_92972,type,
    v154521: state_type > $o ).

tff(pred_def_92973,type,
    v154519: state_type > $o ).

tff(pred_def_92974,type,
    v154525: state_type > $o ).

tff(pred_def_92975,type,
    v154523: state_type > $o ).

tff(pred_def_92976,type,
    v154537: state_type > $o ).

tff(pred_def_92977,type,
    v154539: state_type > $o ).

tff(pred_def_92978,type,
    v154535: state_type > $o ).

tff(pred_def_92979,type,
    v154542: state_type > $o ).

tff(pred_def_92980,type,
    v154544: ( state_type * $int ) > $o ).

tff(pred_def_92981,type,
    v154546: ( state_type * $int ) > $o ).

tff(pred_def_92982,type,
    v154548: state_type > $o ).

tff(pred_def_92983,type,
    v154551: state_type > $o ).

tff(pred_def_92984,type,
    v154550: state_type > $o ).

tff(pred_def_92985,type,
    v154549: ( state_type * $int ) > $o ).

tff(pred_def_92986,type,
    v154513: ( state_type * $int ) > $o ).

tff(pred_def_92987,type,
    v154553: state_type > $o ).

tff(pred_def_92988,type,
    v154565: state_type > $o ).

tff(pred_def_92989,type,
    v154564: state_type > $o ).

tff(pred_def_92990,type,
    v154563: state_type > $o ).

tff(pred_def_92991,type,
    v154566: state_type > $o ).

tff(pred_def_92992,type,
    v154562: state_type > $o ).

tff(pred_def_92993,type,
    v154561: state_type > $o ).

tff(pred_def_92994,type,
    v154567: state_type > $o ).

tff(pred_def_92995,type,
    v154560: state_type > $o ).

tff(pred_def_92996,type,
    v154559: state_type > $o ).

tff(pred_def_92997,type,
    v154558: state_type > $o ).

tff(pred_def_92998,type,
    v154557: state_type > $o ).

tff(pred_def_92999,type,
    v154569: state_type > $o ).

tff(pred_def_93000,type,
    v154568: state_type > $o ).

tff(pred_def_93001,type,
    v154556: state_type > $o ).

tff(pred_def_93002,type,
    v154572: state_type > $o ).

tff(pred_def_93003,type,
    v154571: state_type > $o ).

tff(pred_def_93004,type,
    v154573: state_type > $o ).

tff(pred_def_93005,type,
    v154570: state_type > $o ).

tff(pred_def_93006,type,
    v154576: state_type > $o ).

tff(pred_def_93007,type,
    v154575: state_type > $o ).

tff(pred_def_93008,type,
    v154577: state_type > $o ).

tff(pred_def_93009,type,
    v154574: state_type > $o ).

tff(pred_def_93010,type,
    v154580: state_type > $o ).

tff(pred_def_93011,type,
    v154579: state_type > $o ).

tff(pred_def_93012,type,
    v154581: state_type > $o ).

tff(pred_def_93013,type,
    v154578: state_type > $o ).

tff(pred_def_93014,type,
    v154554: ( state_type * $int ) > $o ).

tff(pred_def_93015,type,
    v154552: ( state_type * $int ) > $o ).

tff(pred_def_93016,type,
    v154533: ( state_type * $int ) > $o ).

tff(pred_def_93017,type,
    v154531: ( state_type * $int ) > $o ).

tff(pred_def_93018,type,
    v154529: ( state_type * $int ) > $o ).

tff(pred_def_93019,type,
    v154527: ( state_type * $int ) > $o ).

tff(pred_def_93020,type,
    v154585: state_type > $o ).

tff(pred_def_93021,type,
    v154583: state_type > $o ).

tff(pred_def_93022,type,
    v154592: state_type > $o ).

tff(pred_def_93023,type,
    v154590: state_type > $o ).

tff(pred_def_93024,type,
    v154589: state_type > $o ).

tff(pred_def_93025,type,
    v154588: state_type > $o ).

tff(pred_def_93026,type,
    v154600: state_type > $o ).

tff(pred_def_93027,type,
    v154601: state_type > $o ).

tff(pred_def_93028,type,
    v154599: state_type > $o ).

tff(pred_def_93029,type,
    v154596: ( state_type * $int ) > $o ).

tff(pred_def_93030,type,
    v154598: ( state_type * $int ) > $o ).

tff(pred_def_93031,type,
    v154517: ( state_type * $int ) > $o ).

tff(pred_def_93032,type,
    v154515: ( state_type * $int ) > $o ).

tff(pred_def_93033,type,
    v154511: state_type > $o ).

tff(pred_def_93034,type,
    v154509: state_type > $o ).

tff(pred_def_93035,type,
    v154630: state_type > $o ).

tff(pred_def_93036,type,
    v154628: state_type > $o ).

tff(pred_def_93037,type,
    v154634: state_type > $o ).

tff(pred_def_93038,type,
    v154632: state_type > $o ).

tff(pred_def_93039,type,
    v154644: state_type > $o ).

tff(pred_def_93040,type,
    v154653: state_type > $o ).

tff(pred_def_93041,type,
    v154651: state_type > $o ).

tff(pred_def_93042,type,
    v154649: state_type > $o ).

tff(pred_def_93043,type,
    v154647: state_type > $o ).

tff(pred_def_93044,type,
    v154659: state_type > $o ).

tff(pred_def_93045,type,
    v154658: state_type > $o ).

tff(pred_def_93046,type,
    v154657: state_type > $o ).

tff(pred_def_93047,type,
    v154656: state_type > $o ).

tff(pred_def_93048,type,
    v154655: state_type > $o ).

tff(pred_def_93049,type,
    v154622: state_type > $o ).

tff(pred_def_93050,type,
    v154642: state_type > $o ).

tff(pred_def_93051,type,
    v154640: state_type > $o ).

tff(pred_def_93052,type,
    v154638: state_type > $o ).

tff(pred_def_93053,type,
    v154636: state_type > $o ).

tff(pred_def_93054,type,
    v154663: state_type > $o ).

tff(pred_def_93055,type,
    v154661: state_type > $o ).

tff(pred_def_93056,type,
    v154670: state_type > $o ).

tff(pred_def_93057,type,
    v154668: state_type > $o ).

tff(pred_def_93058,type,
    v154667: state_type > $o ).

tff(pred_def_93059,type,
    v154666: state_type > $o ).

tff(pred_def_93060,type,
    v154678: state_type > $o ).

tff(pred_def_93061,type,
    v154679: state_type > $o ).

tff(pred_def_93062,type,
    v154677: state_type > $o ).

tff(pred_def_93063,type,
    v154674: state_type > $o ).

tff(pred_def_93064,type,
    v154676: state_type > $o ).

tff(pred_def_93065,type,
    v154626: state_type > $o ).

tff(pred_def_93066,type,
    v154624: state_type > $o ).

tff(pred_def_93067,type,
    v154687: state_type > $o ).

tff(pred_def_93068,type,
    v154685: state_type > $o ).

tff(pred_def_93069,type,
    v154683: state_type > $o ).

tff(pred_def_93070,type,
    v154690: ( state_type * $int ) > $o ).

tff(pred_def_93071,type,
    v154699: state_type > $o ).

tff(pred_def_93072,type,
    v154697: state_type > $o ).

tff(pred_def_93073,type,
    v154695: state_type > $o ).

tff(pred_def_93074,type,
    v154693: state_type > $o ).

tff(pred_def_93075,type,
    v154728: ( state_type * $int ) > $o ).

tff(pred_def_93076,type,
    v154727: state_type > $o ).

tff(pred_def_93077,type,
    v154726: state_type > $o ).

tff(pred_def_93078,type,
    v154725: state_type > $o ).

tff(pred_def_93079,type,
    v154724: state_type > $o ).

tff(pred_def_93080,type,
    v154723: state_type > $o ).

tff(pred_def_93081,type,
    v154722: state_type > $o ).

tff(pred_def_93082,type,
    v154721: state_type > $o ).

tff(pred_def_93083,type,
    v154720: state_type > $o ).

tff(pred_def_93084,type,
    v154719: state_type > $o ).

tff(pred_def_93085,type,
    v154718: state_type > $o ).

tff(pred_def_93086,type,
    v154717: state_type > $o ).

tff(pred_def_93087,type,
    v154716: state_type > $o ).

tff(pred_def_93088,type,
    v154715: state_type > $o ).

tff(pred_def_93089,type,
    v154714: state_type > $o ).

tff(pred_def_93090,type,
    v154712: state_type > $o ).

tff(pred_def_93091,type,
    v154729: state_type > $o ).

tff(pred_def_93092,type,
    v154711: state_type > $o ).

tff(pred_def_93093,type,
    v154738: state_type > $o ).

tff(pred_def_93094,type,
    v154737: state_type > $o ).

tff(pred_def_93095,type,
    v154736: state_type > $o ).

tff(pred_def_93096,type,
    v154735: state_type > $o ).

tff(pred_def_93097,type,
    v154734: state_type > $o ).

tff(pred_def_93098,type,
    v154733: state_type > $o ).

tff(pred_def_93099,type,
    v154731: state_type > $o ).

tff(pred_def_93100,type,
    v154730: state_type > $o ).

tff(pred_def_93101,type,
    v154710: state_type > $o ).

tff(pred_def_93102,type,
    v154709: state_type > $o ).

tff(pred_def_93103,type,
    v154739: state_type > $o ).

tff(pred_def_93104,type,
    v154708: state_type > $o ).

tff(pred_def_93105,type,
    v154740: state_type > $o ).

tff(pred_def_93106,type,
    v154707: state_type > $o ).

tff(pred_def_93107,type,
    v154741: state_type > $o ).

tff(pred_def_93108,type,
    v154706: state_type > $o ).

tff(pred_def_93109,type,
    v154705: state_type > $o ).

tff(pred_def_93110,type,
    v154704: state_type > $o ).

tff(pred_def_93111,type,
    v154742: state_type > $o ).

tff(pred_def_93112,type,
    v154703: state_type > $o ).

tff(pred_def_93113,type,
    v154758: state_type > $o ).

tff(pred_def_93114,type,
    v154757: state_type > $o ).

tff(pred_def_93115,type,
    v154756: state_type > $o ).

tff(pred_def_93116,type,
    v154755: state_type > $o ).

tff(pred_def_93117,type,
    v154754: state_type > $o ).

tff(pred_def_93118,type,
    v154753: state_type > $o ).

tff(pred_def_93119,type,
    v154752: state_type > $o ).

tff(pred_def_93120,type,
    v154751: state_type > $o ).

tff(pred_def_93121,type,
    v154750: state_type > $o ).

tff(pred_def_93122,type,
    v154749: state_type > $o ).

tff(pred_def_93123,type,
    v154748: state_type > $o ).

tff(pred_def_93124,type,
    v154747: state_type > $o ).

tff(pred_def_93125,type,
    v154746: state_type > $o ).

tff(pred_def_93126,type,
    v154745: state_type > $o ).

tff(pred_def_93127,type,
    v154743: state_type > $o ).

tff(pred_def_93128,type,
    v154702: state_type > $o ).

tff(pred_def_93129,type,
    v154759: state_type > $o ).

tff(pred_def_93130,type,
    v154701: state_type > $o ).

tff(pred_def_93131,type,
    v154760: state_type > $o ).

tff(pred_def_93132,type,
    v154766: state_type > $o ).

tff(pred_def_93133,type,
    v154765: state_type > $o ).

tff(pred_def_93134,type,
    v154769: state_type > $o ).

tff(pred_def_93135,type,
    v154768: state_type > $o ).

tff(pred_def_93136,type,
    v154767: state_type > $o ).

tff(pred_def_93137,type,
    v154764: state_type > $o ).

tff(pred_def_93138,type,
    v154771: state_type > $o ).

tff(pred_def_93139,type,
    v154770: state_type > $o ).

tff(pred_def_93140,type,
    v154763: state_type > $o ).

tff(pred_def_93141,type,
    v154772: state_type > $o ).

tff(pred_def_93142,type,
    v154762: state_type > $o ).

tff(pred_def_93143,type,
    v154774: state_type > $o ).

tff(pred_def_93144,type,
    v154775: state_type > $o ).

tff(pred_def_93145,type,
    v154773: state_type > $o ).

tff(pred_def_93146,type,
    v154782: state_type > $o ).

tff(pred_def_93147,type,
    v154780: state_type > $o ).

tff(pred_def_93148,type,
    v154779: state_type > $o ).

tff(pred_def_93149,type,
    v154778: ( state_type * $int ) > $o ).

tff(pred_def_93150,type,
    v70: state_type > $o ).

tff(pred_def_93151,type,
    v154788: state_type > $o ).

tff(pred_def_93152,type,
    v154791: state_type > $o ).

tff(pred_def_93153,type,
    v154790: state_type > $o ).

tff(pred_def_93154,type,
    v154792: state_type > $o ).

tff(pred_def_93155,type,
    v154789: state_type > $o ).

tff(pred_def_93156,type,
    v154787: state_type > $o ).

tff(pred_def_93157,type,
    v154795: state_type > $o ).

tff(pred_def_93158,type,
    v154796: state_type > $o ).

tff(pred_def_93159,type,
    v154794: state_type > $o ).

tff(pred_def_93160,type,
    v154797: state_type > $o ).

tff(pred_def_93161,type,
    v154793: state_type > $o ).

tff(pred_def_93162,type,
    v154803: state_type > $o ).

tff(pred_def_93163,type,
    v154801: state_type > $o ).

tff(pred_def_93164,type,
    v154800: state_type > $o ).

tff(pred_def_93165,type,
    v154799: ( state_type * $int ) > $o ).

tff(pred_def_93166,type,
    v154808: state_type > $o ).

tff(pred_def_93167,type,
    v154809: state_type > $o ).

tff(pred_def_93168,type,
    v154807: state_type > $o ).

tff(pred_def_93169,type,
    v154814: state_type > $o ).

tff(pred_def_93170,type,
    v154813: state_type > $o ).

tff(pred_def_93171,type,
    v154812: state_type > $o ).

tff(pred_def_93172,type,
    v154811: state_type > $o ).

tff(pred_def_93173,type,
    v154810: state_type > $o ).

tff(pred_def_93174,type,
    v154820: state_type > $o ).

tff(pred_def_93175,type,
    v154818: state_type > $o ).

tff(pred_def_93176,type,
    v154817: state_type > $o ).

tff(pred_def_93177,type,
    v154816: ( state_type * $int ) > $o ).

tff(pred_def_93178,type,
    v154824: state_type > $o ).

tff(pred_def_93179,type,
    v154826: state_type > $o ).

tff(pred_def_93180,type,
    v154825: state_type > $o ).

tff(pred_def_93181,type,
    v154832: state_type > $o ).

tff(pred_def_93182,type,
    v154830: state_type > $o ).

tff(pred_def_93183,type,
    v154829: state_type > $o ).

tff(pred_def_93184,type,
    v154828: ( state_type * $int ) > $o ).

tff(pred_def_93185,type,
    v154837: state_type > $o ).

tff(pred_def_93186,type,
    v154836: state_type > $o ).

tff(pred_def_93187,type,
    v154840: state_type > $o ).

tff(pred_def_93188,type,
    v154839: state_type > $o ).

tff(pred_def_93189,type,
    v154843: state_type > $o ).

tff(pred_def_93190,type,
    v154842: ( state_type * $int ) > $o ).

tff(pred_def_93191,type,
    v154845: state_type > $o ).

tff(pred_def_93192,type,
    v154844: ( state_type * $int ) > $o ).

tff(pred_def_93193,type,
    v154841: ( state_type * $int ) > $o ).

tff(pred_def_93194,type,
    v154838: ( state_type * $int ) > $o ).

tff(pred_def_93195,type,
    v6: ( state_type * $int ) > $o ).

tff(pred_def_93196,type,
    v154853: ( state_type * $int ) > $o ).

tff(pred_def_93197,type,
    v154852: state_type > $o ).

tff(pred_def_93198,type,
    v154855: state_type > $o ).

tff(pred_def_93199,type,
    v154857: state_type > $o ).

tff(pred_def_93200,type,
    v154858: state_type > $o ).

tff(pred_def_93201,type,
    v154856: state_type > $o ).

tff(pred_def_93202,type,
    v154854: state_type > $o ).

tff(pred_def_93203,type,
    v154851: state_type > $o ).

tff(pred_def_93204,type,
    v154860: state_type > $o ).

tff(pred_def_93205,type,
    v154863: state_type > $o ).

tff(pred_def_93206,type,
    v154866: state_type > $o ).

tff(pred_def_93207,type,
    v154867: state_type > $o ).

tff(pred_def_93208,type,
    v154865: state_type > $o ).

tff(pred_def_93209,type,
    v154864: state_type > $o ).

tff(pred_def_93210,type,
    v154862: state_type > $o ).

tff(pred_def_93211,type,
    v154861: state_type > $o ).

tff(pred_def_93212,type,
    v154859: state_type > $o ).

tff(pred_def_93213,type,
    v154850: state_type > $o ).

tff(pred_def_93214,type,
    v154870: state_type > $o ).

tff(pred_def_93215,type,
    v154869: state_type > $o ).

tff(pred_def_93216,type,
    v154868: state_type > $o ).

tff(pred_def_93217,type,
    v154848: state_type > $o ).

tff(pred_def_93218,type,
    v154847: state_type > $o ).

tff(pred_def_93219,type,
    v4: state_type > $o ).

tff(pred_def_93220,type,
    reachableState: state_type > $o ).

tff(pathAxiom_49,axiom,
    nextState(constB49,constB50) ).

tff(pathAxiom_48,axiom,
    nextState(constB48,constB49) ).

tff(pathAxiom_47,axiom,
    nextState(constB47,constB48) ).

tff(pathAxiom_46,axiom,
    nextState(constB46,constB47) ).

tff(pathAxiom_45,axiom,
    nextState(constB45,constB46) ).

tff(pathAxiom_44,axiom,
    nextState(constB44,constB45) ).

tff(pathAxiom_43,axiom,
    nextState(constB43,constB44) ).

tff(pathAxiom_42,axiom,
    nextState(constB42,constB43) ).

tff(pathAxiom_41,axiom,
    nextState(constB41,constB42) ).

tff(pathAxiom_40,axiom,
    nextState(constB40,constB41) ).

tff(pathAxiom_39,axiom,
    nextState(constB39,constB40) ).

tff(pathAxiom_38,axiom,
    nextState(constB38,constB39) ).

tff(pathAxiom_37,axiom,
    nextState(constB37,constB38) ).

tff(pathAxiom_36,axiom,
    nextState(constB36,constB37) ).

tff(pathAxiom_35,axiom,
    nextState(constB35,constB36) ).

tff(pathAxiom_34,axiom,
    nextState(constB34,constB35) ).

tff(pathAxiom_33,axiom,
    nextState(constB33,constB34) ).

tff(pathAxiom_32,axiom,
    nextState(constB32,constB33) ).

tff(pathAxiom_31,axiom,
    nextState(constB31,constB32) ).

tff(pathAxiom_30,axiom,
    nextState(constB30,constB31) ).

tff(pathAxiom_29,axiom,
    nextState(constB29,constB30) ).

tff(pathAxiom_28,axiom,
    nextState(constB28,constB29) ).

tff(pathAxiom_27,axiom,
    nextState(constB27,constB28) ).

tff(pathAxiom_26,axiom,
    nextState(constB26,constB27) ).

tff(pathAxiom_25,axiom,
    nextState(constB25,constB26) ).

tff(pathAxiom_24,axiom,
    nextState(constB24,constB25) ).

tff(pathAxiom_23,axiom,
    nextState(constB23,constB24) ).

tff(pathAxiom_22,axiom,
    nextState(constB22,constB23) ).

tff(pathAxiom_21,axiom,
    nextState(constB21,constB22) ).

tff(pathAxiom_20,axiom,
    nextState(constB20,constB21) ).

tff(pathAxiom_19,axiom,
    nextState(constB19,constB20) ).

tff(pathAxiom_18,axiom,
    nextState(constB18,constB19) ).

tff(pathAxiom_17,axiom,
    nextState(constB17,constB18) ).

tff(pathAxiom_16,axiom,
    nextState(constB16,constB17) ).

tff(pathAxiom_15,axiom,
    nextState(constB15,constB16) ).

tff(pathAxiom_14,axiom,
    nextState(constB14,constB15) ).

tff(pathAxiom_13,axiom,
    nextState(constB13,constB14) ).

tff(pathAxiom_12,axiom,
    nextState(constB12,constB13) ).

tff(pathAxiom_11,axiom,
    nextState(constB11,constB12) ).

tff(pathAxiom_10,axiom,
    nextState(constB10,constB11) ).

tff(pathAxiom_9,axiom,
    nextState(constB9,constB10) ).

tff(pathAxiom_8,axiom,
    nextState(constB8,constB9) ).

tff(pathAxiom_7,axiom,
    nextState(constB7,constB8) ).

tff(pathAxiom_6,axiom,
    nextState(constB6,constB7) ).

tff(pathAxiom_5,axiom,
    nextState(constB5,constB6) ).

tff(pathAxiom_4,axiom,
    nextState(constB4,constB5) ).

tff(pathAxiom_3,axiom,
    nextState(constB3,constB4) ).

tff(pathAxiom_2,axiom,
    nextState(constB2,constB3) ).

tff(pathAxiom_1,axiom,
    nextState(constB1,constB2) ).

tff(pathAxiom,axiom,
    nextState(constB0,constB1) ).

tff(reachableStateAxiom_52,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( reachableState(VarCurr)
        & reachableState(VarNext) ) ) ).

tff(reachableStateAxiom_51,axiom,
    ! [VarState: state_type] :
      ( reachableState(VarState)
     => ( ( constB0 = VarState )
        | ( constB1 = VarState )
        | ( constB2 = VarState )
        | ( constB3 = VarState )
        | ( constB4 = VarState )
        | ( constB5 = VarState )
        | ( constB6 = VarState )
        | ( constB7 = VarState )
        | ( constB8 = VarState )
        | ( constB9 = VarState )
        | ( constB10 = VarState )
        | ( constB11 = VarState )
        | ( constB12 = VarState )
        | ( constB13 = VarState )
        | ( constB14 = VarState )
        | ( constB15 = VarState )
        | ( constB16 = VarState )
        | ( constB17 = VarState )
        | ( constB18 = VarState )
        | ( constB19 = VarState )
        | ( constB20 = VarState )
        | ( constB21 = VarState )
        | ( constB22 = VarState )
        | ( constB23 = VarState )
        | ( constB24 = VarState )
        | ( constB25 = VarState )
        | ( constB26 = VarState )
        | ( constB27 = VarState )
        | ( constB28 = VarState )
        | ( constB29 = VarState )
        | ( constB30 = VarState )
        | ( constB31 = VarState )
        | ( constB32 = VarState )
        | ( constB33 = VarState )
        | ( constB34 = VarState )
        | ( constB35 = VarState )
        | ( constB36 = VarState )
        | ( constB37 = VarState )
        | ( constB38 = VarState )
        | ( constB39 = VarState )
        | ( constB40 = VarState )
        | ( constB41 = VarState )
        | ( constB42 = VarState )
        | ( constB43 = VarState )
        | ( constB44 = VarState )
        | ( constB45 = VarState )
        | ( constB46 = VarState )
        | ( constB47 = VarState )
        | ( constB48 = VarState )
        | ( constB49 = VarState )
        | ( constB50 = VarState ) ) ) ).

tff(reachableStateAxiom_50,axiom,
    reachableState(constB50) ).

tff(reachableStateAxiom_49,axiom,
    reachableState(constB49) ).

tff(reachableStateAxiom_48,axiom,
    reachableState(constB48) ).

tff(reachableStateAxiom_47,axiom,
    reachableState(constB47) ).

tff(reachableStateAxiom_46,axiom,
    reachableState(constB46) ).

tff(reachableStateAxiom_45,axiom,
    reachableState(constB45) ).

tff(reachableStateAxiom_44,axiom,
    reachableState(constB44) ).

tff(reachableStateAxiom_43,axiom,
    reachableState(constB43) ).

tff(reachableStateAxiom_42,axiom,
    reachableState(constB42) ).

tff(reachableStateAxiom_41,axiom,
    reachableState(constB41) ).

tff(reachableStateAxiom_40,axiom,
    reachableState(constB40) ).

tff(reachableStateAxiom_39,axiom,
    reachableState(constB39) ).

tff(reachableStateAxiom_38,axiom,
    reachableState(constB38) ).

tff(reachableStateAxiom_37,axiom,
    reachableState(constB37) ).

tff(reachableStateAxiom_36,axiom,
    reachableState(constB36) ).

tff(reachableStateAxiom_35,axiom,
    reachableState(constB35) ).

tff(reachableStateAxiom_34,axiom,
    reachableState(constB34) ).

tff(reachableStateAxiom_33,axiom,
    reachableState(constB33) ).

tff(reachableStateAxiom_32,axiom,
    reachableState(constB32) ).

tff(reachableStateAxiom_31,axiom,
    reachableState(constB31) ).

tff(reachableStateAxiom_30,axiom,
    reachableState(constB30) ).

tff(reachableStateAxiom_29,axiom,
    reachableState(constB29) ).

tff(reachableStateAxiom_28,axiom,
    reachableState(constB28) ).

tff(reachableStateAxiom_27,axiom,
    reachableState(constB27) ).

tff(reachableStateAxiom_26,axiom,
    reachableState(constB26) ).

tff(reachableStateAxiom_25,axiom,
    reachableState(constB25) ).

tff(reachableStateAxiom_24,axiom,
    reachableState(constB24) ).

tff(reachableStateAxiom_23,axiom,
    reachableState(constB23) ).

tff(reachableStateAxiom_22,axiom,
    reachableState(constB22) ).

tff(reachableStateAxiom_21,axiom,
    reachableState(constB21) ).

tff(reachableStateAxiom_20,axiom,
    reachableState(constB20) ).

tff(reachableStateAxiom_19,axiom,
    reachableState(constB19) ).

tff(reachableStateAxiom_18,axiom,
    reachableState(constB18) ).

tff(reachableStateAxiom_17,axiom,
    reachableState(constB17) ).

tff(reachableStateAxiom_16,axiom,
    reachableState(constB16) ).

tff(reachableStateAxiom_15,axiom,
    reachableState(constB15) ).

tff(reachableStateAxiom_14,axiom,
    reachableState(constB14) ).

tff(reachableStateAxiom_13,axiom,
    reachableState(constB13) ).

tff(reachableStateAxiom_12,axiom,
    reachableState(constB12) ).

tff(reachableStateAxiom_11,axiom,
    reachableState(constB11) ).

tff(reachableStateAxiom_10,axiom,
    reachableState(constB10) ).

tff(reachableStateAxiom_9,axiom,
    reachableState(constB9) ).

tff(reachableStateAxiom_8,axiom,
    reachableState(constB8) ).

tff(reachableStateAxiom_7,axiom,
    reachableState(constB7) ).

tff(reachableStateAxiom_6,axiom,
    reachableState(constB6) ).

tff(reachableStateAxiom_5,axiom,
    reachableState(constB5) ).

tff(reachableStateAxiom_4,axiom,
    reachableState(constB4) ).

tff(reachableStateAxiom_3,axiom,
    reachableState(constB3) ).

tff(reachableStateAxiom_2,axiom,
    reachableState(constB2) ).

tff(reachableStateAxiom_1,axiom,
    reachableState(constB1) ).

tff(reachableStateAxiom,axiom,
    reachableState(constB0) ).

tff(clock_toggling,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1(VarCurr)
      <=> ~ v1(VarNext) ) ) ).

tff(clock_pattern,axiom,
    ~ v1(constB0) ).

tff(addAssertion,conjecture,
    ! [VarCurr: state_type] :
      ( reachableState(VarCurr)
     => v4(VarCurr) ) ).

tff(writeUnaryOperator_11893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4(VarCurr)
    <=> v154847(VarCurr) ) ).

tff(writeUnaryOperator_11892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154847(VarCurr)
    <=> v154848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20766,axiom,
    ! [VarCurr: state_type] :
      ( v154848(VarCurr)
    <=> ( v154850(VarCurr)
        & v154868(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7474,axiom,
    ! [VarCurr: state_type] :
      ( v154868(VarCurr)
    <=> ( v154869(VarCurr)
        | v154853(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7473,axiom,
    ! [VarCurr: state_type] :
      ( v154869(VarCurr)
    <=> ( v154870(VarCurr)
        | v154853(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7472,axiom,
    ! [VarCurr: state_type] :
      ( v154870(VarCurr)
    <=> ( v154853(VarCurr,0)
        | v154853(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20765,axiom,
    ! [VarCurr: state_type] :
      ( v154850(VarCurr)
    <=> ( v154851(VarCurr)
        | v154859(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20764,axiom,
    ! [VarCurr: state_type] :
      ( v154859(VarCurr)
    <=> ( v154860(VarCurr)
        | v154861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20763,axiom,
    ! [VarCurr: state_type] :
      ( v154861(VarCurr)
    <=> ( v154852(VarCurr)
        & v154862(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20762,axiom,
    ! [VarCurr: state_type] :
      ( v154862(VarCurr)
    <=> ( v154863(VarCurr)
        | v154864(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20761,axiom,
    ! [VarCurr: state_type] :
      ( v154864(VarCurr)
    <=> ( v154855(VarCurr)
        & v154865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20760,axiom,
    ! [VarCurr: state_type] :
      ( v154865(VarCurr)
    <=> ( v154866(VarCurr)
        | v154867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20759,axiom,
    ! [VarCurr: state_type] :
      ( v154867(VarCurr)
    <=> ( v154853(VarCurr,0)
        & v154858(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7471,axiom,
    ! [VarCurr: state_type] :
      ( v154866(VarCurr)
    <=> ( v154857(VarCurr)
        & v154853(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7470,axiom,
    ! [VarCurr: state_type] :
      ( v154863(VarCurr)
    <=> ( v154853(VarCurr,2)
        & v154856(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7469,axiom,
    ! [VarCurr: state_type] :
      ( v154860(VarCurr)
    <=> ( v154853(VarCurr,3)
        & v154854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20758,axiom,
    ! [VarCurr: state_type] :
      ( v154851(VarCurr)
    <=> ( v154852(VarCurr)
        & v154854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20757,axiom,
    ! [VarCurr: state_type] :
      ( v154854(VarCurr)
    <=> ( v154855(VarCurr)
        & v154856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20756,axiom,
    ! [VarCurr: state_type] :
      ( v154856(VarCurr)
    <=> ( v154857(VarCurr)
        & v154858(VarCurr) ) ) ).

tff(writeUnaryOperator_11891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154858(VarCurr)
    <=> v154853(VarCurr,1) ) ).

tff(writeUnaryOperator_11890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154857(VarCurr)
    <=> v154853(VarCurr,0) ) ).

tff(writeUnaryOperator_11889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154855(VarCurr)
    <=> v154853(VarCurr,2) ) ).

tff(writeUnaryOperator_11888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154852(VarCurr)
    <=> v154853(VarCurr,3) ) ).

tff(addAssignment_86259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v154853(VarCurr,B)
      <=> v6(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154836(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v6(VarCurr,B)
          <=> v154838(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1782,axiom,
    ! [VarCurr: state_type] :
      ( v154836(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v6(VarCurr,B)
          <=> b0001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154839(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v154838(VarCurr,B)
          <=> v154841(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1781,axiom,
    ! [VarCurr: state_type] :
      ( v154839(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v154838(VarCurr,B)
          <=> b0010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v154841(VarCurr,B)
          <=> v154844(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1780,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v154841(VarCurr,B)
          <=> v154842(VarCurr,B) ) ) ) ).

tff(addAssignment_86258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v154844(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_86257,axiom,
    ! [VarCurr: state_type] :
      ( v154844(VarCurr,2)
    <=> v154845(VarCurr) ) ).

tff(addAssignment_86256,axiom,
    ! [VarCurr: state_type] :
      ( v154844(VarCurr,3)
    <=> v83122(VarCurr,0) ) ).

tff(writeUnaryOperator_11887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154845(VarCurr)
    <=> v83122(VarCurr,0) ) ).

tff(addAssignment_86255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v154842(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_86254,axiom,
    ! [VarCurr: state_type] :
      ( v154842(VarCurr,2)
    <=> v154843(VarCurr) ) ).

tff(addAssignment_86253,axiom,
    ! [VarCurr: state_type] :
      ( v154842(VarCurr,3)
    <=> v83122(VarCurr,1) ) ).

tff(writeUnaryOperator_11886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154843(VarCurr)
    <=> v83122(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20755,axiom,
    ! [VarCurr: state_type] :
      ( v154839(VarCurr)
    <=> ( v154840(VarCurr)
        & v111516(VarCurr) ) ) ).

tff(writeUnaryOperator_11885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154840(VarCurr)
    <=> v8(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20754,axiom,
    ! [VarCurr: state_type] :
      ( v154836(VarCurr)
    <=> ( v154837(VarCurr)
        & v110850(VarCurr) ) ) ).

tff(writeUnaryOperator_11884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154837(VarCurr)
    <=> v8(VarCurr,3) ) ).

tff(addAssignment_86252,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,3)
    <=> v10(VarCurr,3) ) ).

tff(addAssignment_86251,axiom,
    ! [VarCurr: state_type] :
      ( v10(VarCurr,3)
    <=> v12(VarCurr,3) ) ).

tff(addAssignment_86250,axiom,
    ! [VarNext: state_type] :
      ( v12(VarNext,3)
    <=> v154828(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_2301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154829(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154828(VarNext,B)
            <=> v12(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2301,axiom,
    ! [VarNext: state_type] :
      ( v154829(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154828(VarNext,B)
          <=> v140281(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154829(VarNext)
      <=> v154830(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154830(VarNext)
      <=> ( v154832(VarNext)
          & v140266(VarNext) ) ) ) ).

tff(writeUnaryOperator_11883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154832(VarNext)
      <=> v140275(VarNext) ) ) ).

tff(addAssignment_86249,axiom,
    ! [VarCurr: state_type] :
      ( v62(VarCurr,3)
    <=> v64(VarCurr,3) ) ).

tff(addAssignment_86248,axiom,
    ! [VarCurr: state_type] :
      ( v64(VarCurr,3)
    <=> v66(VarCurr,3) ) ).

tff(addAssignment_86247,axiom,
    ! [VarCurr: state_type] :
      ( v66(VarCurr,3)
    <=> v140264(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7468,axiom,
    ! [VarCurr: state_type] :
      ( v68(VarCurr,3)
    <=> ( v154824(VarCurr)
        | v154825(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7467,axiom,
    ! [VarCurr: state_type] :
      ( v154825(VarCurr)
    <=> ( v8(VarCurr,3)
        & v154826(VarCurr) ) ) ).

tff(writeUnaryOperator_11882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154826(VarCurr)
    <=> v82954(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7466,axiom,
    ! [VarCurr: state_type] :
      ( v154824(VarCurr)
    <=> ( v8(VarCurr,2)
        & v83096(VarCurr) ) ) ).

tff(addAssignment_86246,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,2)
    <=> v10(VarCurr,2) ) ).

tff(addAssignment_86245,axiom,
    ! [VarCurr: state_type] :
      ( v10(VarCurr,2)
    <=> v12(VarCurr,2) ) ).

tff(addAssignment_86244,axiom,
    ! [VarNext: state_type] :
      ( v12(VarNext,2)
    <=> v154816(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154817(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154816(VarNext,B)
            <=> v12(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2300,axiom,
    ! [VarNext: state_type] :
      ( v154817(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154816(VarNext,B)
          <=> v140281(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154817(VarNext)
      <=> v154818(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154818(VarNext)
      <=> ( v154820(VarNext)
          & v140266(VarNext) ) ) ) ).

tff(writeUnaryOperator_11881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154820(VarNext)
      <=> v140275(VarNext) ) ) ).

tff(addAssignment_86243,axiom,
    ! [VarCurr: state_type] :
      ( v62(VarCurr,2)
    <=> v64(VarCurr,2) ) ).

tff(addAssignment_86242,axiom,
    ! [VarCurr: state_type] :
      ( v64(VarCurr,2)
    <=> v66(VarCurr,2) ) ).

tff(addAssignment_86241,axiom,
    ! [VarCurr: state_type] :
      ( v66(VarCurr,2)
    <=> v140264(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7465,axiom,
    ! [VarCurr: state_type] :
      ( v68(VarCurr,2)
    <=> ( v154807(VarCurr)
        | v154810(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7464,axiom,
    ! [VarCurr: state_type] :
      ( v154810(VarCurr)
    <=> ( v8(VarCurr,2)
        & v154811(VarCurr) ) ) ).

tff(writeUnaryOperator_11880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154811(VarCurr)
    <=> v154812(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20749,axiom,
    ! [VarCurr: state_type] :
      ( v154812(VarCurr)
    <=> ( v83096(VarCurr)
        | v154813(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20748,axiom,
    ! [VarCurr: state_type] :
      ( v154813(VarCurr)
    <=> ( v154814(VarCurr)
        & v83211(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7463,axiom,
    ! [VarCurr: state_type] :
      ( v154814(VarCurr)
    <=> ( v84121(VarCurr,0)
        | v84121(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20747,axiom,
    ! [VarCurr: state_type] :
      ( v154807(VarCurr)
    <=> ( v154808(VarCurr)
        & v154809(VarCurr) ) ) ).

tff(writeUnaryOperator_11879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154809(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7462,axiom,
    ! [VarCurr: state_type] :
      ( v154808(VarCurr)
    <=> ( v8(VarCurr,1)
        & v82954(VarCurr) ) ) ).

tff(addAssignment_86240,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,1)
    <=> v10(VarCurr,1) ) ).

tff(addAssignment_86239,axiom,
    ! [VarCurr: state_type] :
      ( v10(VarCurr,1)
    <=> v12(VarCurr,1) ) ).

tff(addAssignment_86238,axiom,
    ! [VarNext: state_type] :
      ( v12(VarNext,1)
    <=> v154799(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154800(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154799(VarNext,B)
            <=> v12(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2299,axiom,
    ! [VarNext: state_type] :
      ( v154800(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154799(VarNext,B)
          <=> v140281(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154800(VarNext)
      <=> v154801(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154801(VarNext)
      <=> ( v154803(VarNext)
          & v140266(VarNext) ) ) ) ).

tff(writeUnaryOperator_11878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154803(VarNext)
      <=> v140275(VarNext) ) ) ).

tff(addAssignment_86237,axiom,
    ! [VarCurr: state_type] :
      ( v62(VarCurr,1)
    <=> v64(VarCurr,1) ) ).

tff(addAssignment_86236,axiom,
    ! [VarCurr: state_type] :
      ( v64(VarCurr,1)
    <=> v66(VarCurr,1) ) ).

tff(addAssignment_86235,axiom,
    ! [VarCurr: state_type] :
      ( v66(VarCurr,1)
    <=> v140264(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_7461,axiom,
    ! [VarCurr: state_type] :
      ( v68(VarCurr,1)
    <=> ( v154787(VarCurr)
        | v154793(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20744,axiom,
    ! [VarCurr: state_type] :
      ( v154793(VarCurr)
    <=> ( v154794(VarCurr)
        & v154797(VarCurr) ) ) ).

tff(writeUnaryOperator_11877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154797(VarCurr)
    <=> v82958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20743,axiom,
    ! [VarCurr: state_type] :
      ( v154794(VarCurr)
    <=> ( v154795(VarCurr)
        & v154796(VarCurr) ) ) ).

tff(writeUnaryOperator_11876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154796(VarCurr)
    <=> v140253(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7460,axiom,
    ! [VarCurr: state_type] :
      ( v154795(VarCurr)
    <=> ( v8(VarCurr,1)
        & v779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20742,axiom,
    ! [VarCurr: state_type] :
      ( v154787(VarCurr)
    <=> ( v154788(VarCurr)
        | v154789(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20741,axiom,
    ! [VarCurr: state_type] :
      ( v154789(VarCurr)
    <=> ( v154790(VarCurr)
        & v154792(VarCurr) ) ) ).

tff(writeUnaryOperator_11875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154792(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7459,axiom,
    ! [VarCurr: state_type] :
      ( v154790(VarCurr)
    <=> ( v8(VarCurr,1)
        & v154791(VarCurr) ) ) ).

tff(writeUnaryOperator_11874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154791(VarCurr)
    <=> v82954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20740,axiom,
    ! [VarCurr: state_type] :
      ( v154788(VarCurr)
    <=> ( v8(VarCurr,0)
        & v74(VarCurr) ) ) ).

tff(writeUnaryOperator_11873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8(VarCurr,0)
    <=> v70(VarCurr) ) ).

tff(addAssignment_86234,axiom,
    ! [VarCurr: state_type] :
      ( v70(VarCurr)
    <=> v10(VarCurr,0) ) ).

tff(addAssignment_86233,axiom,
    ! [VarCurr: state_type] :
      ( v10(VarCurr,0)
    <=> v12(VarCurr,0) ) ).

tff(addAssignment_86232,axiom,
    ! [VarNext: state_type] :
      ( v12(VarNext,0)
    <=> v154778(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154779(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154778(VarNext,B)
            <=> v12(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2298,axiom,
    ! [VarNext: state_type] :
      ( v154779(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154778(VarNext,B)
          <=> v140281(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154779(VarNext)
      <=> v154780(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154780(VarNext)
      <=> ( v154782(VarNext)
          & v140266(VarNext) ) ) ) ).

tff(writeUnaryOperator_11872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154782(VarNext)
      <=> v140275(VarNext) ) ) ).

tff(addAssignment_86231,axiom,
    ! [VarCurr: state_type] :
      ( v62(VarCurr,0)
    <=> v64(VarCurr,0) ) ).

tff(addAssignment_86230,axiom,
    ! [VarCurr: state_type] :
      ( v64(VarCurr,0)
    <=> v66(VarCurr,0) ) ).

tff(addAssignment_86229,axiom,
    ! [VarCurr: state_type] :
      ( v66(VarCurr,0)
    <=> v140264(VarCurr,0) ) ).

tff(writeUnaryOperator_11871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v72(VarCurr)
    <=> v68(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20737,axiom,
    ! [VarCurr: state_type] :
      ( v68(VarCurr,0)
    <=> ( v154762(VarCurr)
        | v154773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20736,axiom,
    ! [VarCurr: state_type] :
      ( v154773(VarCurr)
    <=> ( v154774(VarCurr)
        & v154775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20735,axiom,
    ! [VarCurr: state_type] :
      ( v154775(VarCurr)
    <=> ( v140253(VarCurr)
        | v82958(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7458,axiom,
    ! [VarCurr: state_type] :
      ( v154774(VarCurr)
    <=> ( v8(VarCurr,4)
        & v779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20734,axiom,
    ! [VarCurr: state_type] :
      ( v154762(VarCurr)
    <=> ( v154763(VarCurr)
        | v154772(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7457,axiom,
    ! [VarCurr: state_type] :
      ( v154772(VarCurr)
    <=> ( v8(VarCurr,3)
        & v82954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20733,axiom,
    ! [VarCurr: state_type] :
      ( v154763(VarCurr)
    <=> ( v154764(VarCurr)
        | v154770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20732,axiom,
    ! [VarCurr: state_type] :
      ( v154770(VarCurr)
    <=> ( v154771(VarCurr)
        & v140253(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7456,axiom,
    ! [VarCurr: state_type] :
      ( v154771(VarCurr)
    <=> ( v8(VarCurr,1)
        & v779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20731,axiom,
    ! [VarCurr: state_type] :
      ( v154764(VarCurr)
    <=> ( v154765(VarCurr)
        | v154767(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7455,axiom,
    ! [VarCurr: state_type] :
      ( v154767(VarCurr)
    <=> ( v8(VarCurr,2)
        & v154768(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20730,axiom,
    ! [VarCurr: state_type] :
      ( v154768(VarCurr)
    <=> ( v154769(VarCurr)
        & v83211(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7454,axiom,
    ! [VarCurr: state_type] :
      ( v154769(VarCurr)
    <=> ( v84121(VarCurr,0)
        | v84121(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20729,axiom,
    ! [VarCurr: state_type] :
      ( v154765(VarCurr)
    <=> ( v8(VarCurr,0)
        & v154766(VarCurr) ) ) ).

tff(writeUnaryOperator_11870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154766(VarCurr)
    <=> v74(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20728,axiom,
    ! [VarCurr: state_type] :
      ( v74(VarCurr)
    <=> ( v154701(VarCurr)
        & v154760(VarCurr) ) ) ).

tff(writeUnaryOperator_11869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154760(VarCurr)
    <=> v154693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20727,axiom,
    ! [VarCurr: state_type] :
      ( v154701(VarCurr)
    <=> ( v154702(VarCurr)
        & v154759(VarCurr) ) ) ).

tff(writeUnaryOperator_11868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154759(VarCurr)
    <=> v108897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20726,axiom,
    ! [VarCurr: state_type] :
      ( v154702(VarCurr)
    <=> ( v154703(VarCurr)
        & v154743(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7453,axiom,
    ! [VarCurr: state_type] :
      ( v154743(VarCurr)
    <=> ( v154745(VarCurr)
        | v154690(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7452,axiom,
    ! [VarCurr: state_type] :
      ( v154745(VarCurr)
    <=> ( v154746(VarCurr)
        | v154690(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7451,axiom,
    ! [VarCurr: state_type] :
      ( v154746(VarCurr)
    <=> ( v154747(VarCurr)
        | v154690(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7450,axiom,
    ! [VarCurr: state_type] :
      ( v154747(VarCurr)
    <=> ( v154748(VarCurr)
        | v154690(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7449,axiom,
    ! [VarCurr: state_type] :
      ( v154748(VarCurr)
    <=> ( v154749(VarCurr)
        | v154690(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7448,axiom,
    ! [VarCurr: state_type] :
      ( v154749(VarCurr)
    <=> ( v154750(VarCurr)
        | v154690(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7447,axiom,
    ! [VarCurr: state_type] :
      ( v154750(VarCurr)
    <=> ( v154751(VarCurr)
        | v154690(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7446,axiom,
    ! [VarCurr: state_type] :
      ( v154751(VarCurr)
    <=> ( v154752(VarCurr)
        | v154690(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7445,axiom,
    ! [VarCurr: state_type] :
      ( v154752(VarCurr)
    <=> ( v154753(VarCurr)
        | v154690(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7444,axiom,
    ! [VarCurr: state_type] :
      ( v154753(VarCurr)
    <=> ( v154754(VarCurr)
        | v154690(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7443,axiom,
    ! [VarCurr: state_type] :
      ( v154754(VarCurr)
    <=> ( v154755(VarCurr)
        | v154690(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7442,axiom,
    ! [VarCurr: state_type] :
      ( v154755(VarCurr)
    <=> ( v154756(VarCurr)
        | v154690(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7441,axiom,
    ! [VarCurr: state_type] :
      ( v154756(VarCurr)
    <=> ( v154757(VarCurr)
        | v154690(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7440,axiom,
    ! [VarCurr: state_type] :
      ( v154757(VarCurr)
    <=> ( v154758(VarCurr)
        | v154690(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7439,axiom,
    ! [VarCurr: state_type] :
      ( v154758(VarCurr)
    <=> ( v154690(VarCurr,0)
        | v154690(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20725,axiom,
    ! [VarCurr: state_type] :
      ( v154703(VarCurr)
    <=> ( v154704(VarCurr)
        & v154742(VarCurr) ) ) ).

tff(writeUnaryOperator_11867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154742(VarCurr)
    <=> v127180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20724,axiom,
    ! [VarCurr: state_type] :
      ( v154704(VarCurr)
    <=> ( v154705(VarCurr)
        & v154683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20723,axiom,
    ! [VarCurr: state_type] :
      ( v154705(VarCurr)
    <=> ( v154706(VarCurr)
        & v141351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20722,axiom,
    ! [VarCurr: state_type] :
      ( v154706(VarCurr)
    <=> ( v154707(VarCurr)
        & v154741(VarCurr) ) ) ).

tff(writeUnaryOperator_11866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154741(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20721,axiom,
    ! [VarCurr: state_type] :
      ( v154707(VarCurr)
    <=> ( v154708(VarCurr)
        & v154740(VarCurr) ) ) ).

tff(writeUnaryOperator_11865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154740(VarCurr)
    <=> v154622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20720,axiom,
    ! [VarCurr: state_type] :
      ( v154708(VarCurr)
    <=> ( v154709(VarCurr)
        & v154739(VarCurr) ) ) ).

tff(writeUnaryOperator_11864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154739(VarCurr)
    <=> v128492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20719,axiom,
    ! [VarCurr: state_type] :
      ( v154709(VarCurr)
    <=> ( v154710(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20718,axiom,
    ! [VarCurr: state_type] :
      ( v154710(VarCurr)
    <=> ( v154711(VarCurr)
        & v154730(VarCurr) ) ) ).

tff(writeUnaryOperator_11863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154730(VarCurr)
    <=> v154731(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7438,axiom,
    ! [VarCurr: state_type] :
      ( v154731(VarCurr)
    <=> ( v154733(VarCurr)
        | v103376(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7437,axiom,
    ! [VarCurr: state_type] :
      ( v154733(VarCurr)
    <=> ( v154734(VarCurr)
        | v103376(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7436,axiom,
    ! [VarCurr: state_type] :
      ( v154734(VarCurr)
    <=> ( v154735(VarCurr)
        | v103376(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7435,axiom,
    ! [VarCurr: state_type] :
      ( v154735(VarCurr)
    <=> ( v154736(VarCurr)
        | v103376(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7434,axiom,
    ! [VarCurr: state_type] :
      ( v154736(VarCurr)
    <=> ( v154737(VarCurr)
        | v103376(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7433,axiom,
    ! [VarCurr: state_type] :
      ( v154737(VarCurr)
    <=> ( v154738(VarCurr)
        | v103376(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7432,axiom,
    ! [VarCurr: state_type] :
      ( v154738(VarCurr)
    <=> ( v103376(VarCurr,0)
        | v103376(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20717,axiom,
    ! [VarCurr: state_type] :
      ( v154711(VarCurr)
    <=> ( v154712(VarCurr)
        & v154729(VarCurr) ) ) ).

tff(writeUnaryOperator_11862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154729(VarCurr)
    <=> v111693(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7431,axiom,
    ! [VarCurr: state_type] :
      ( v154712(VarCurr)
    <=> ( v154714(VarCurr)
        | v154728(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7430,axiom,
    ! [VarCurr: state_type] :
      ( v154714(VarCurr)
    <=> ( v154715(VarCurr)
        | v154728(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7429,axiom,
    ! [VarCurr: state_type] :
      ( v154715(VarCurr)
    <=> ( v154716(VarCurr)
        | v154728(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7428,axiom,
    ! [VarCurr: state_type] :
      ( v154716(VarCurr)
    <=> ( v154717(VarCurr)
        | v154728(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7427,axiom,
    ! [VarCurr: state_type] :
      ( v154717(VarCurr)
    <=> ( v154718(VarCurr)
        | v154728(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7426,axiom,
    ! [VarCurr: state_type] :
      ( v154718(VarCurr)
    <=> ( v154719(VarCurr)
        | v154728(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7425,axiom,
    ! [VarCurr: state_type] :
      ( v154719(VarCurr)
    <=> ( v154720(VarCurr)
        | v154728(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7424,axiom,
    ! [VarCurr: state_type] :
      ( v154720(VarCurr)
    <=> ( v154721(VarCurr)
        | v154728(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7423,axiom,
    ! [VarCurr: state_type] :
      ( v154721(VarCurr)
    <=> ( v154722(VarCurr)
        | v154728(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7422,axiom,
    ! [VarCurr: state_type] :
      ( v154722(VarCurr)
    <=> ( v154723(VarCurr)
        | v154728(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7421,axiom,
    ! [VarCurr: state_type] :
      ( v154723(VarCurr)
    <=> ( v154724(VarCurr)
        | v154728(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7420,axiom,
    ! [VarCurr: state_type] :
      ( v154724(VarCurr)
    <=> ( v154725(VarCurr)
        | v154728(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7419,axiom,
    ! [VarCurr: state_type] :
      ( v154725(VarCurr)
    <=> ( v154726(VarCurr)
        | v154728(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7418,axiom,
    ! [VarCurr: state_type] :
      ( v154726(VarCurr)
    <=> ( v154727(VarCurr)
        | v154728(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7417,axiom,
    ! [VarCurr: state_type] :
      ( v154727(VarCurr)
    <=> ( v154728(VarCurr,0)
        | v154728(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v154728(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v109659(VarCurr,B) ) ) ) ).

tff(addAssignment_86228,axiom,
    ! [VarCurr: state_type] :
      ( v154693(VarCurr)
    <=> v154695(VarCurr) ) ).

tff(addAssignment_86227,axiom,
    ! [VarCurr: state_type] :
      ( v154695(VarCurr)
    <=> v154697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20716,axiom,
    ! [VarCurr: state_type] :
      ( v154697(VarCurr)
    <=> ( v97325(VarCurr)
        | v154699(VarCurr) ) ) ).

tff(writeUnaryOperator_11861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154699(VarCurr)
    <=> v129477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v154690(VarCurr,B)
      <=> ( v113109(VarCurr,B)
          & v85708(VarCurr,B) ) ) ) ).

tff(addAssignment_86226,axiom,
    ! [VarCurr: state_type] :
      ( v154683(VarCurr)
    <=> v154685(VarCurr) ) ).

tff(addAssignment_86225,axiom,
    ! [VarCurr: state_type] :
      ( v154685(VarCurr)
    <=> v154687(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2423,axiom,
    ! [VarCurr: state_type] :
      ( v154687(VarCurr)
    <=> ( ( v97186(VarCurr,4)
        <=> v97254(VarCurr,4) )
        & ( v97186(VarCurr,3)
        <=> v97254(VarCurr,3) )
        & ( v97186(VarCurr,2)
        <=> v97254(VarCurr,2) )
        & ( v97186(VarCurr,1)
        <=> v97254(VarCurr,1) )
        & ( v97186(VarCurr,0)
        <=> v97254(VarCurr,0) ) ) ) ).

tff(addAssignment_86224,axiom,
    ! [VarCurr: state_type] :
      ( v154622(VarCurr)
    <=> v154624(VarCurr) ) ).

tff(addAssignment_86223,axiom,
    ! [VarCurr: state_type] :
      ( v154624(VarCurr)
    <=> v154626(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154666(VarNext)
       => ( v154626(VarNext)
        <=> v154626(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2297,axiom,
    ! [VarNext: state_type] :
      ( v154666(VarNext)
     => ( v154626(VarNext)
      <=> v154676(VarNext) ) ) ).

tff(addAssignment_86222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154676(VarNext)
      <=> v154674(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154677(VarCurr)
     => ( v154674(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1779,axiom,
    ! [VarCurr: state_type] :
      ( v154677(VarCurr)
     => ( v154674(VarCurr)
      <=> v154636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20715,axiom,
    ! [VarCurr: state_type] :
      ( v154677(VarCurr)
    <=> ( v154678(VarCurr)
        & v154679(VarCurr) ) ) ).

tff(writeUnaryOperator_11860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154679(VarCurr)
    <=> v154632(VarCurr) ) ).

tff(writeUnaryOperator_11859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154678(VarCurr)
    <=> v154628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154666(VarNext)
      <=> v154667(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154667(VarNext)
      <=> ( v154668(VarNext)
          & v154661(VarNext) ) ) ) ).

tff(writeUnaryOperator_11858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154668(VarNext)
      <=> v154670(VarNext) ) ) ).

tff(addAssignment_86221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154670(VarNext)
      <=> v154661(VarCurr) ) ) ).

tff(addAssignment_86220,axiom,
    ! [VarCurr: state_type] :
      ( v154661(VarCurr)
    <=> v154663(VarCurr) ) ).

tff(addAssignment_86219,axiom,
    ! [VarCurr: state_type] :
      ( v154663(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_86218,axiom,
    ! [VarCurr: state_type] :
      ( v154636(VarCurr)
    <=> v154638(VarCurr) ) ).

tff(addAssignment_86217,axiom,
    ! [VarCurr: state_type] :
      ( v154638(VarCurr)
    <=> v154640(VarCurr) ) ).

tff(addAssignment_86216,axiom,
    ! [VarCurr: state_type] :
      ( v154640(VarCurr)
    <=> v154642(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154644(VarCurr)
     => ( v154642(VarCurr)
      <=> v154655(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1778,axiom,
    ! [VarCurr: state_type] :
      ( v154644(VarCurr)
     => ( v154642(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154656(VarCurr)
     => ( v154655(VarCurr)
      <=> v154622(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1777,axiom,
    ! [VarCurr: state_type] :
      ( v154656(VarCurr)
     => ( v154655(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20712,axiom,
    ! [VarCurr: state_type] :
      ( v154656(VarCurr)
    <=> ( v154657(VarCurr)
        | v154647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20711,axiom,
    ! [VarCurr: state_type] :
      ( v154657(VarCurr)
    <=> ( v154658(VarCurr)
        | v89618(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20710,axiom,
    ! [VarCurr: state_type] :
      ( v154658(VarCurr)
    <=> ( v140253(VarCurr)
        | v154659(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7416,axiom,
    ! [VarCurr: state_type] :
      ( v154659(VarCurr)
    <=> ( v82958(VarCurr)
        & v8(VarCurr,4) ) ) ).

tff(addAssignment_86215,axiom,
    ! [VarCurr: state_type] :
      ( v154647(VarCurr)
    <=> v154649(VarCurr) ) ).

tff(addAssignment_86214,axiom,
    ! [VarCurr: state_type] :
      ( v154649(VarCurr)
    <=> v154651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20709,axiom,
    ! [VarCurr: state_type] :
      ( v154651(VarCurr)
    <=> ( v154653(VarCurr)
        & v32546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7415,axiom,
    ! [VarCurr: state_type] :
      ( v154653(VarCurr)
    <=> ( v96905(VarCurr)
        | v89674(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20708,axiom,
    ! [VarCurr: state_type] :
      ( v154644(VarCurr)
    <=> ( v82954(VarCurr)
        & v779(VarCurr) ) ) ).

tff(addAssignment_86213,axiom,
    ! [VarCurr: state_type] :
      ( v154632(VarCurr)
    <=> v154634(VarCurr) ) ).

tff(addAssignment_86212,axiom,
    ! [VarCurr: state_type] :
      ( v154634(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_86211,axiom,
    ! [VarCurr: state_type] :
      ( v154628(VarCurr)
    <=> v154630(VarCurr) ) ).

tff(addAssignment_86210,axiom,
    ! [VarCurr: state_type] :
      ( v154630(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7414,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,15)
    <=> ( v154407(VarCurr)
        & v154509(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7413,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,14)
    <=> ( v154208(VarCurr)
        & v154310(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7412,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,13)
    <=> ( v154009(VarCurr)
        & v154111(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7411,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,12)
    <=> ( v153810(VarCurr)
        & v153912(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7410,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,11)
    <=> ( v153611(VarCurr)
        & v153713(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7409,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,10)
    <=> ( v153412(VarCurr)
        & v153514(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7408,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,9)
    <=> ( v153213(VarCurr)
        & v153315(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7407,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,8)
    <=> ( v153014(VarCurr)
        & v153116(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7406,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,7)
    <=> ( v152815(VarCurr)
        & v152917(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7405,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,6)
    <=> ( v152616(VarCurr)
        & v152718(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7404,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,5)
    <=> ( v152417(VarCurr)
        & v152519(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7403,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,4)
    <=> ( v152218(VarCurr)
        & v152320(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7402,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,3)
    <=> ( v152019(VarCurr)
        & v152121(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7401,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,2)
    <=> ( v151820(VarCurr)
        & v151922(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7400,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,1)
    <=> ( v151621(VarCurr)
        & v151723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20707,axiom,
    ! [VarCurr: state_type] :
      ( v76(VarCurr,0)
    <=> ( v78(VarCurr)
        & v151524(VarCurr) ) ) ).

tff(addAssignment_86209,axiom,
    ! [VarCurr: state_type] :
      ( v154509(VarCurr)
    <=> v154511(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2422,axiom,
    ! [VarCurr: state_type] :
      ( v154511(VarCurr)
    <=> ( ( v154513(VarCurr,4)
        <=> $false )
        & ( v154513(VarCurr,3)
        <=> $false )
        & ( v154513(VarCurr,2)
        <=> $false )
        & ( v154513(VarCurr,1)
        <=> $false )
        & ( v154513(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154513(VarCurr,B)
      <=> v154515(VarCurr,B) ) ) ).

tff(addAssignment_86207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154515(VarCurr,B)
      <=> v154517(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154588(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154517(VarNext,B)
            <=> v154517(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2296,axiom,
    ! [VarNext: state_type] :
      ( v154588(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154517(VarNext,B)
          <=> v154598(VarNext,B) ) ) ) ).

tff(addAssignment_86206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154598(VarNext,B)
          <=> v154596(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154599(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154596(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1776,axiom,
    ! [VarCurr: state_type] :
      ( v154599(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154596(VarCurr,B)
          <=> v154527(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20706,axiom,
    ! [VarCurr: state_type] :
      ( v154599(VarCurr)
    <=> ( v154600(VarCurr)
        & v154601(VarCurr) ) ) ).

tff(writeUnaryOperator_11857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154601(VarCurr)
    <=> v154523(VarCurr) ) ).

tff(writeUnaryOperator_11856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154600(VarCurr)
    <=> v154519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154588(VarNext)
      <=> v154589(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154589(VarNext)
      <=> ( v154590(VarNext)
          & v154583(VarNext) ) ) ) ).

tff(writeUnaryOperator_11855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154590(VarNext)
      <=> v154592(VarNext) ) ) ).

tff(addAssignment_86205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154592(VarNext)
      <=> v154583(VarCurr) ) ) ).

tff(addAssignment_86204,axiom,
    ! [VarCurr: state_type] :
      ( v154583(VarCurr)
    <=> v154585(VarCurr) ) ).

tff(addAssignment_86203,axiom,
    ! [VarCurr: state_type] :
      ( v154585(VarCurr)
    <=> v154488(VarCurr) ) ).

tff(addAssignment_86202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154527(VarCurr,B)
      <=> v154529(VarCurr,B) ) ) ).

tff(addAssignment_86201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154529(VarCurr,B)
      <=> v154531(VarCurr,B) ) ) ).

tff(addAssignment_86200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154531(VarCurr,B)
      <=> v154533(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154548(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154533(VarCurr,B)
          <=> v154552(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1775,axiom,
    ! [VarCurr: state_type] :
      ( v154548(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154533(VarCurr,B)
          <=> v154549(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154552(VarCurr,B)
          <=> v154554(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1774,axiom,
    ! [VarCurr: state_type] :
      ( v154553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154552(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86199,axiom,
    ! [VarCurr: state_type] :
      ( v154554(VarCurr,0)
    <=> v154580(VarCurr) ) ).

tff(addAssignment_86198,axiom,
    ! [VarCurr: state_type] :
      ( v154554(VarCurr,1)
    <=> v154578(VarCurr) ) ).

tff(addAssignment_86197,axiom,
    ! [VarCurr: state_type] :
      ( v154554(VarCurr,2)
    <=> v154574(VarCurr) ) ).

tff(addAssignment_86196,axiom,
    ! [VarCurr: state_type] :
      ( v154554(VarCurr,3)
    <=> v154570(VarCurr) ) ).

tff(addAssignment_86195,axiom,
    ! [VarCurr: state_type] :
      ( v154554(VarCurr,4)
    <=> v154556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20703,axiom,
    ! [VarCurr: state_type] :
      ( v154578(VarCurr)
    <=> ( v154579(VarCurr)
        & v154581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20702,axiom,
    ! [VarCurr: state_type] :
      ( v154581(VarCurr)
    <=> ( v154513(VarCurr,0)
        | v154565(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7399,axiom,
    ! [VarCurr: state_type] :
      ( v154579(VarCurr)
    <=> ( v154580(VarCurr)
        | v154513(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154580(VarCurr)
    <=> v154513(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20701,axiom,
    ! [VarCurr: state_type] :
      ( v154574(VarCurr)
    <=> ( v154575(VarCurr)
        & v154577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20700,axiom,
    ! [VarCurr: state_type] :
      ( v154577(VarCurr)
    <=> ( v154563(VarCurr)
        | v154566(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7398,axiom,
    ! [VarCurr: state_type] :
      ( v154575(VarCurr)
    <=> ( v154576(VarCurr)
        | v154513(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154576(VarCurr)
    <=> v154563(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20699,axiom,
    ! [VarCurr: state_type] :
      ( v154570(VarCurr)
    <=> ( v154571(VarCurr)
        & v154573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20698,axiom,
    ! [VarCurr: state_type] :
      ( v154573(VarCurr)
    <=> ( v154561(VarCurr)
        | v154567(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7397,axiom,
    ! [VarCurr: state_type] :
      ( v154571(VarCurr)
    <=> ( v154572(VarCurr)
        | v154513(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154572(VarCurr)
    <=> v154561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20697,axiom,
    ! [VarCurr: state_type] :
      ( v154556(VarCurr)
    <=> ( v154557(VarCurr)
        & v154568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20696,axiom,
    ! [VarCurr: state_type] :
      ( v154568(VarCurr)
    <=> ( v154559(VarCurr)
        | v154569(VarCurr) ) ) ).

tff(writeUnaryOperator_11851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154569(VarCurr)
    <=> v154513(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7396,axiom,
    ! [VarCurr: state_type] :
      ( v154557(VarCurr)
    <=> ( v154558(VarCurr)
        | v154513(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154558(VarCurr)
    <=> v154559(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7395,axiom,
    ! [VarCurr: state_type] :
      ( v154559(VarCurr)
    <=> ( v154513(VarCurr,3)
        | v154560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20695,axiom,
    ! [VarCurr: state_type] :
      ( v154560(VarCurr)
    <=> ( v154561(VarCurr)
        & v154567(VarCurr) ) ) ).

tff(writeUnaryOperator_11849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154567(VarCurr)
    <=> v154513(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7394,axiom,
    ! [VarCurr: state_type] :
      ( v154561(VarCurr)
    <=> ( v154513(VarCurr,2)
        | v154562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20694,axiom,
    ! [VarCurr: state_type] :
      ( v154562(VarCurr)
    <=> ( v154563(VarCurr)
        & v154566(VarCurr) ) ) ).

tff(writeUnaryOperator_11848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154566(VarCurr)
    <=> v154513(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7393,axiom,
    ! [VarCurr: state_type] :
      ( v154563(VarCurr)
    <=> ( v154513(VarCurr,1)
        | v154564(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20693,axiom,
    ! [VarCurr: state_type] :
      ( v154564(VarCurr)
    <=> ( v154513(VarCurr,0)
        & v154565(VarCurr) ) ) ).

tff(writeUnaryOperator_11847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154565(VarCurr)
    <=> v154513(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2421,axiom,
    ! [VarCurr: state_type] :
      ( v154553(VarCurr)
    <=> ( ( v154513(VarCurr,4)
        <=> $false )
        & ( v154513(VarCurr,3)
        <=> $false )
        & ( v154513(VarCurr,2)
        <=> $false )
        & ( v154513(VarCurr,1)
        <=> $false )
        & ( v154513(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154550(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154549(VarCurr,B)
          <=> v154546(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1773,axiom,
    ! [VarCurr: state_type] :
      ( v154550(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154549(VarCurr,B)
          <=> v154544(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20692,axiom,
    ! [VarCurr: state_type] :
      ( v154550(VarCurr)
    <=> ( v154551(VarCurr)
        | v154539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20691,axiom,
    ! [VarCurr: state_type] :
      ( v154551(VarCurr)
    <=> ( v154542(VarCurr)
        & v154537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20690,axiom,
    ! [VarCurr: state_type] :
      ( v154548(VarCurr)
    <=> ( v154535(VarCurr)
        & v154448(VarCurr) ) ) ).

tff(addAssignment_86194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154546(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_86193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154544(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_86192,axiom,
    ! [VarCurr: state_type] :
      ( v154542(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20689,axiom,
    ! [VarCurr: state_type] :
      ( v154535(VarCurr)
    <=> ( v154537(VarCurr)
        | v154539(VarCurr) ) ) ).

tff(addAssignment_86191,axiom,
    ! [VarCurr: state_type] :
      ( v154539(VarCurr)
    <=> v110563(VarCurr,15) ) ).

tff(addAssignment_86190,axiom,
    ! [VarCurr: state_type] :
      ( v154537(VarCurr)
    <=> v108901(VarCurr,15) ) ).

tff(addAssignment_86189,axiom,
    ! [VarCurr: state_type] :
      ( v154523(VarCurr)
    <=> v154525(VarCurr) ) ).

tff(addAssignment_86188,axiom,
    ! [VarCurr: state_type] :
      ( v154525(VarCurr)
    <=> v154429(VarCurr) ) ).

tff(addAssignment_86187,axiom,
    ! [VarCurr: state_type] :
      ( v154519(VarCurr)
    <=> v154521(VarCurr) ) ).

tff(addAssignment_86186,axiom,
    ! [VarCurr: state_type] :
      ( v154521(VarCurr)
    <=> v154421(VarCurr) ) ).

tff(addAssignment_86185,axiom,
    ! [VarCurr: state_type] :
      ( v154407(VarCurr)
    <=> v154409(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2420,axiom,
    ! [VarCurr: state_type] :
      ( v154409(VarCurr)
    <=> ( ( v154411(VarCurr,4)
        <=> $false )
        & ( v154411(VarCurr,3)
        <=> $false )
        & ( v154411(VarCurr,2)
        <=> $false )
        & ( v154411(VarCurr,1)
        <=> $false )
        & ( v154411(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154411(VarCurr,B)
      <=> v154413(VarCurr,B) ) ) ).

tff(addAssignment_86183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154413(VarCurr,B)
      <=> v154415(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154491(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154415(VarNext,B)
            <=> v154415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2295,axiom,
    ! [VarNext: state_type] :
      ( v154491(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154415(VarNext,B)
          <=> v154501(VarNext,B) ) ) ) ).

tff(addAssignment_86182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154501(VarNext,B)
          <=> v154499(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154502(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154499(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1772,axiom,
    ! [VarCurr: state_type] :
      ( v154502(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154499(VarCurr,B)
          <=> v154433(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20688,axiom,
    ! [VarCurr: state_type] :
      ( v154502(VarCurr)
    <=> ( v154503(VarCurr)
        & v154504(VarCurr) ) ) ).

tff(writeUnaryOperator_11846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154504(VarCurr)
    <=> v154425(VarCurr) ) ).

tff(writeUnaryOperator_11845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154503(VarCurr)
    <=> v154417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154491(VarNext)
      <=> v154492(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154492(VarNext)
      <=> ( v154493(VarNext)
          & v154484(VarNext) ) ) ) ).

tff(writeUnaryOperator_11844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154493(VarNext)
      <=> v154495(VarNext) ) ) ).

tff(addAssignment_86181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154495(VarNext)
      <=> v154484(VarCurr) ) ) ).

tff(addAssignment_86180,axiom,
    ! [VarCurr: state_type] :
      ( v154484(VarCurr)
    <=> v154486(VarCurr) ) ).

tff(addAssignment_86179,axiom,
    ! [VarCurr: state_type] :
      ( v154486(VarCurr)
    <=> v154488(VarCurr) ) ).

tff(addAssignment_86178,axiom,
    ! [VarCurr: state_type] :
      ( v154488(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_86177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154433(VarCurr,B)
      <=> v154435(VarCurr,B) ) ) ).

tff(addAssignment_86176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154435(VarCurr,B)
      <=> v154437(VarCurr,B) ) ) ).

tff(addAssignment_86175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154437(VarCurr,B)
      <=> v154439(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154452(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154439(VarCurr,B)
          <=> v154453(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1771,axiom,
    ! [VarCurr: state_type] :
      ( v154452(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154439(VarCurr,B)
          <=> v154450(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154454(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154453(VarCurr,B)
          <=> v154455(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1770,axiom,
    ! [VarCurr: state_type] :
      ( v154454(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154453(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86174,axiom,
    ! [VarCurr: state_type] :
      ( v154455(VarCurr,0)
    <=> v154481(VarCurr) ) ).

tff(addAssignment_86173,axiom,
    ! [VarCurr: state_type] :
      ( v154455(VarCurr,1)
    <=> v154479(VarCurr) ) ).

tff(addAssignment_86172,axiom,
    ! [VarCurr: state_type] :
      ( v154455(VarCurr,2)
    <=> v154475(VarCurr) ) ).

tff(addAssignment_86171,axiom,
    ! [VarCurr: state_type] :
      ( v154455(VarCurr,3)
    <=> v154471(VarCurr) ) ).

tff(addAssignment_86170,axiom,
    ! [VarCurr: state_type] :
      ( v154455(VarCurr,4)
    <=> v154457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20685,axiom,
    ! [VarCurr: state_type] :
      ( v154479(VarCurr)
    <=> ( v154480(VarCurr)
        & v154482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20684,axiom,
    ! [VarCurr: state_type] :
      ( v154482(VarCurr)
    <=> ( v154411(VarCurr,0)
        | v154466(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7392,axiom,
    ! [VarCurr: state_type] :
      ( v154480(VarCurr)
    <=> ( v154481(VarCurr)
        | v154411(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154481(VarCurr)
    <=> v154411(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20683,axiom,
    ! [VarCurr: state_type] :
      ( v154475(VarCurr)
    <=> ( v154476(VarCurr)
        & v154478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20682,axiom,
    ! [VarCurr: state_type] :
      ( v154478(VarCurr)
    <=> ( v154464(VarCurr)
        | v154467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7391,axiom,
    ! [VarCurr: state_type] :
      ( v154476(VarCurr)
    <=> ( v154477(VarCurr)
        | v154411(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154477(VarCurr)
    <=> v154464(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20681,axiom,
    ! [VarCurr: state_type] :
      ( v154471(VarCurr)
    <=> ( v154472(VarCurr)
        & v154474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20680,axiom,
    ! [VarCurr: state_type] :
      ( v154474(VarCurr)
    <=> ( v154462(VarCurr)
        | v154468(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7390,axiom,
    ! [VarCurr: state_type] :
      ( v154472(VarCurr)
    <=> ( v154473(VarCurr)
        | v154411(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154473(VarCurr)
    <=> v154462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20679,axiom,
    ! [VarCurr: state_type] :
      ( v154457(VarCurr)
    <=> ( v154458(VarCurr)
        & v154469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20678,axiom,
    ! [VarCurr: state_type] :
      ( v154469(VarCurr)
    <=> ( v154460(VarCurr)
        | v154470(VarCurr) ) ) ).

tff(writeUnaryOperator_11840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154470(VarCurr)
    <=> v154411(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7389,axiom,
    ! [VarCurr: state_type] :
      ( v154458(VarCurr)
    <=> ( v154459(VarCurr)
        | v154411(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154459(VarCurr)
    <=> v154460(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7388,axiom,
    ! [VarCurr: state_type] :
      ( v154460(VarCurr)
    <=> ( v154411(VarCurr,3)
        | v154461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20677,axiom,
    ! [VarCurr: state_type] :
      ( v154461(VarCurr)
    <=> ( v154462(VarCurr)
        & v154468(VarCurr) ) ) ).

tff(writeUnaryOperator_11838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154468(VarCurr)
    <=> v154411(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7387,axiom,
    ! [VarCurr: state_type] :
      ( v154462(VarCurr)
    <=> ( v154411(VarCurr,2)
        | v154463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20676,axiom,
    ! [VarCurr: state_type] :
      ( v154463(VarCurr)
    <=> ( v154464(VarCurr)
        & v154467(VarCurr) ) ) ).

tff(writeUnaryOperator_11837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154467(VarCurr)
    <=> v154411(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7386,axiom,
    ! [VarCurr: state_type] :
      ( v154464(VarCurr)
    <=> ( v154411(VarCurr,1)
        | v154465(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20675,axiom,
    ! [VarCurr: state_type] :
      ( v154465(VarCurr)
    <=> ( v154411(VarCurr,0)
        & v154466(VarCurr) ) ) ).

tff(writeUnaryOperator_11836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154466(VarCurr)
    <=> v154411(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2419,axiom,
    ! [VarCurr: state_type] :
      ( v154454(VarCurr)
    <=> ( ( v154411(VarCurr,4)
        <=> $false )
        & ( v154411(VarCurr,3)
        <=> $false )
        & ( v154411(VarCurr,2)
        <=> $false )
        & ( v154411(VarCurr,1)
        <=> $false )
        & ( v154411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20674,axiom,
    ! [VarCurr: state_type] :
      ( v154452(VarCurr)
    <=> ( v154441(VarCurr)
        & v154448(VarCurr) ) ) ).

tff(addAssignment_86169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154450(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_86168,axiom,
    ! [VarCurr: state_type] :
      ( v154448(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20673,axiom,
    ! [VarCurr: state_type] :
      ( v154441(VarCurr)
    <=> ( v154443(VarCurr)
        | v154445(VarCurr) ) ) ).

tff(addAssignment_86167,axiom,
    ! [VarCurr: state_type] :
      ( v154445(VarCurr)
    <=> v110583(VarCurr,15) ) ).

tff(addAssignment_86166,axiom,
    ! [VarCurr: state_type] :
      ( v154443(VarCurr)
    <=> v116(VarCurr,15) ) ).

tff(addAssignment_86165,axiom,
    ! [VarCurr: state_type] :
      ( v154425(VarCurr)
    <=> v154427(VarCurr) ) ).

tff(addAssignment_86164,axiom,
    ! [VarCurr: state_type] :
      ( v154427(VarCurr)
    <=> v154429(VarCurr) ) ).

tff(addAssignment_86163,axiom,
    ! [VarCurr: state_type] :
      ( v154429(VarCurr)
    <=> v154431(VarCurr) ) ).

tff(addAssignment_86162,axiom,
    ! [VarCurr: state_type] :
      ( v154431(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_86161,axiom,
    ! [VarCurr: state_type] :
      ( v154417(VarCurr)
    <=> v154419(VarCurr) ) ).

tff(addAssignment_86160,axiom,
    ! [VarCurr: state_type] :
      ( v154419(VarCurr)
    <=> v154421(VarCurr) ) ).

tff(addAssignment_86159,axiom,
    ! [VarCurr: state_type] :
      ( v154421(VarCurr)
    <=> v154423(VarCurr) ) ).

tff(addAssignment_86158,axiom,
    ! [VarCurr: state_type] :
      ( v154423(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_86157,axiom,
    ! [VarCurr: state_type] :
      ( v154310(VarCurr)
    <=> v154312(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2418,axiom,
    ! [VarCurr: state_type] :
      ( v154312(VarCurr)
    <=> ( ( v154314(VarCurr,4)
        <=> $false )
        & ( v154314(VarCurr,3)
        <=> $false )
        & ( v154314(VarCurr,2)
        <=> $false )
        & ( v154314(VarCurr,1)
        <=> $false )
        & ( v154314(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154314(VarCurr,B)
      <=> v154316(VarCurr,B) ) ) ).

tff(addAssignment_86155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154316(VarCurr,B)
      <=> v154318(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154389(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154318(VarNext,B)
            <=> v154318(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2294,axiom,
    ! [VarNext: state_type] :
      ( v154389(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154318(VarNext,B)
          <=> v154399(VarNext,B) ) ) ) ).

tff(addAssignment_86154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154399(VarNext,B)
          <=> v154397(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154400(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154397(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1769,axiom,
    ! [VarCurr: state_type] :
      ( v154400(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154397(VarCurr,B)
          <=> v154328(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20672,axiom,
    ! [VarCurr: state_type] :
      ( v154400(VarCurr)
    <=> ( v154401(VarCurr)
        & v154402(VarCurr) ) ) ).

tff(writeUnaryOperator_11835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154402(VarCurr)
    <=> v154324(VarCurr) ) ).

tff(writeUnaryOperator_11834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154401(VarCurr)
    <=> v154320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154389(VarNext)
      <=> v154390(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154390(VarNext)
      <=> ( v154391(VarNext)
          & v154384(VarNext) ) ) ) ).

tff(writeUnaryOperator_11833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154391(VarNext)
      <=> v154393(VarNext) ) ) ).

tff(addAssignment_86153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154393(VarNext)
      <=> v154384(VarCurr) ) ) ).

tff(addAssignment_86152,axiom,
    ! [VarCurr: state_type] :
      ( v154384(VarCurr)
    <=> v154386(VarCurr) ) ).

tff(addAssignment_86151,axiom,
    ! [VarCurr: state_type] :
      ( v154386(VarCurr)
    <=> v154289(VarCurr) ) ).

tff(addAssignment_86150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154328(VarCurr,B)
      <=> v154330(VarCurr,B) ) ) ).

tff(addAssignment_86149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154330(VarCurr,B)
      <=> v154332(VarCurr,B) ) ) ).

tff(addAssignment_86148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154332(VarCurr,B)
      <=> v154334(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154349(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154334(VarCurr,B)
          <=> v154353(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1768,axiom,
    ! [VarCurr: state_type] :
      ( v154349(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154334(VarCurr,B)
          <=> v154350(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154353(VarCurr,B)
          <=> v154355(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1767,axiom,
    ! [VarCurr: state_type] :
      ( v154354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154353(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86147,axiom,
    ! [VarCurr: state_type] :
      ( v154355(VarCurr,0)
    <=> v154381(VarCurr) ) ).

tff(addAssignment_86146,axiom,
    ! [VarCurr: state_type] :
      ( v154355(VarCurr,1)
    <=> v154379(VarCurr) ) ).

tff(addAssignment_86145,axiom,
    ! [VarCurr: state_type] :
      ( v154355(VarCurr,2)
    <=> v154375(VarCurr) ) ).

tff(addAssignment_86144,axiom,
    ! [VarCurr: state_type] :
      ( v154355(VarCurr,3)
    <=> v154371(VarCurr) ) ).

tff(addAssignment_86143,axiom,
    ! [VarCurr: state_type] :
      ( v154355(VarCurr,4)
    <=> v154357(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20669,axiom,
    ! [VarCurr: state_type] :
      ( v154379(VarCurr)
    <=> ( v154380(VarCurr)
        & v154382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20668,axiom,
    ! [VarCurr: state_type] :
      ( v154382(VarCurr)
    <=> ( v154314(VarCurr,0)
        | v154366(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7385,axiom,
    ! [VarCurr: state_type] :
      ( v154380(VarCurr)
    <=> ( v154381(VarCurr)
        | v154314(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154381(VarCurr)
    <=> v154314(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20667,axiom,
    ! [VarCurr: state_type] :
      ( v154375(VarCurr)
    <=> ( v154376(VarCurr)
        & v154378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20666,axiom,
    ! [VarCurr: state_type] :
      ( v154378(VarCurr)
    <=> ( v154364(VarCurr)
        | v154367(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7384,axiom,
    ! [VarCurr: state_type] :
      ( v154376(VarCurr)
    <=> ( v154377(VarCurr)
        | v154314(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154377(VarCurr)
    <=> v154364(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20665,axiom,
    ! [VarCurr: state_type] :
      ( v154371(VarCurr)
    <=> ( v154372(VarCurr)
        & v154374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20664,axiom,
    ! [VarCurr: state_type] :
      ( v154374(VarCurr)
    <=> ( v154362(VarCurr)
        | v154368(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7383,axiom,
    ! [VarCurr: state_type] :
      ( v154372(VarCurr)
    <=> ( v154373(VarCurr)
        | v154314(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154373(VarCurr)
    <=> v154362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20663,axiom,
    ! [VarCurr: state_type] :
      ( v154357(VarCurr)
    <=> ( v154358(VarCurr)
        & v154369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20662,axiom,
    ! [VarCurr: state_type] :
      ( v154369(VarCurr)
    <=> ( v154360(VarCurr)
        | v154370(VarCurr) ) ) ).

tff(writeUnaryOperator_11829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154370(VarCurr)
    <=> v154314(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7382,axiom,
    ! [VarCurr: state_type] :
      ( v154358(VarCurr)
    <=> ( v154359(VarCurr)
        | v154314(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154359(VarCurr)
    <=> v154360(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7381,axiom,
    ! [VarCurr: state_type] :
      ( v154360(VarCurr)
    <=> ( v154314(VarCurr,3)
        | v154361(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20661,axiom,
    ! [VarCurr: state_type] :
      ( v154361(VarCurr)
    <=> ( v154362(VarCurr)
        & v154368(VarCurr) ) ) ).

tff(writeUnaryOperator_11827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154368(VarCurr)
    <=> v154314(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7380,axiom,
    ! [VarCurr: state_type] :
      ( v154362(VarCurr)
    <=> ( v154314(VarCurr,2)
        | v154363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20660,axiom,
    ! [VarCurr: state_type] :
      ( v154363(VarCurr)
    <=> ( v154364(VarCurr)
        & v154367(VarCurr) ) ) ).

tff(writeUnaryOperator_11826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154367(VarCurr)
    <=> v154314(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7379,axiom,
    ! [VarCurr: state_type] :
      ( v154364(VarCurr)
    <=> ( v154314(VarCurr,1)
        | v154365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20659,axiom,
    ! [VarCurr: state_type] :
      ( v154365(VarCurr)
    <=> ( v154314(VarCurr,0)
        & v154366(VarCurr) ) ) ).

tff(writeUnaryOperator_11825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154366(VarCurr)
    <=> v154314(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2417,axiom,
    ! [VarCurr: state_type] :
      ( v154354(VarCurr)
    <=> ( ( v154314(VarCurr,4)
        <=> $false )
        & ( v154314(VarCurr,3)
        <=> $false )
        & ( v154314(VarCurr,2)
        <=> $false )
        & ( v154314(VarCurr,1)
        <=> $false )
        & ( v154314(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154350(VarCurr,B)
          <=> v154347(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1766,axiom,
    ! [VarCurr: state_type] :
      ( v154351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154350(VarCurr,B)
          <=> v154345(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20658,axiom,
    ! [VarCurr: state_type] :
      ( v154351(VarCurr)
    <=> ( v154352(VarCurr)
        | v154340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20657,axiom,
    ! [VarCurr: state_type] :
      ( v154352(VarCurr)
    <=> ( v154343(VarCurr)
        & v154338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20656,axiom,
    ! [VarCurr: state_type] :
      ( v154349(VarCurr)
    <=> ( v154336(VarCurr)
        & v154249(VarCurr) ) ) ).

tff(addAssignment_86142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154347(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_86141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154345(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_86140,axiom,
    ! [VarCurr: state_type] :
      ( v154343(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20655,axiom,
    ! [VarCurr: state_type] :
      ( v154336(VarCurr)
    <=> ( v154338(VarCurr)
        | v154340(VarCurr) ) ) ).

tff(addAssignment_86139,axiom,
    ! [VarCurr: state_type] :
      ( v154340(VarCurr)
    <=> v110563(VarCurr,14) ) ).

tff(addAssignment_86138,axiom,
    ! [VarCurr: state_type] :
      ( v154338(VarCurr)
    <=> v108901(VarCurr,14) ) ).

tff(addAssignment_86137,axiom,
    ! [VarCurr: state_type] :
      ( v154324(VarCurr)
    <=> v154326(VarCurr) ) ).

tff(addAssignment_86136,axiom,
    ! [VarCurr: state_type] :
      ( v154326(VarCurr)
    <=> v154230(VarCurr) ) ).

tff(addAssignment_86135,axiom,
    ! [VarCurr: state_type] :
      ( v154320(VarCurr)
    <=> v154322(VarCurr) ) ).

tff(addAssignment_86134,axiom,
    ! [VarCurr: state_type] :
      ( v154322(VarCurr)
    <=> v154222(VarCurr) ) ).

tff(addAssignment_86133,axiom,
    ! [VarCurr: state_type] :
      ( v154208(VarCurr)
    <=> v154210(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2416,axiom,
    ! [VarCurr: state_type] :
      ( v154210(VarCurr)
    <=> ( ( v154212(VarCurr,4)
        <=> $false )
        & ( v154212(VarCurr,3)
        <=> $false )
        & ( v154212(VarCurr,2)
        <=> $false )
        & ( v154212(VarCurr,1)
        <=> $false )
        & ( v154212(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154212(VarCurr,B)
      <=> v154214(VarCurr,B) ) ) ).

tff(addAssignment_86131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154214(VarCurr,B)
      <=> v154216(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154292(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154216(VarNext,B)
            <=> v154216(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2293,axiom,
    ! [VarNext: state_type] :
      ( v154292(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154216(VarNext,B)
          <=> v154302(VarNext,B) ) ) ) ).

tff(addAssignment_86130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154302(VarNext,B)
          <=> v154300(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154303(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154300(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1765,axiom,
    ! [VarCurr: state_type] :
      ( v154303(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154300(VarCurr,B)
          <=> v154234(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20654,axiom,
    ! [VarCurr: state_type] :
      ( v154303(VarCurr)
    <=> ( v154304(VarCurr)
        & v154305(VarCurr) ) ) ).

tff(writeUnaryOperator_11824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154305(VarCurr)
    <=> v154226(VarCurr) ) ).

tff(writeUnaryOperator_11823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154304(VarCurr)
    <=> v154218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154292(VarNext)
      <=> v154293(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154293(VarNext)
      <=> ( v154294(VarNext)
          & v154285(VarNext) ) ) ) ).

tff(writeUnaryOperator_11822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154294(VarNext)
      <=> v154296(VarNext) ) ) ).

tff(addAssignment_86129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154296(VarNext)
      <=> v154285(VarCurr) ) ) ).

tff(addAssignment_86128,axiom,
    ! [VarCurr: state_type] :
      ( v154285(VarCurr)
    <=> v154287(VarCurr) ) ).

tff(addAssignment_86127,axiom,
    ! [VarCurr: state_type] :
      ( v154287(VarCurr)
    <=> v154289(VarCurr) ) ).

tff(addAssignment_86126,axiom,
    ! [VarCurr: state_type] :
      ( v154289(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_86125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154234(VarCurr,B)
      <=> v154236(VarCurr,B) ) ) ).

tff(addAssignment_86124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154236(VarCurr,B)
      <=> v154238(VarCurr,B) ) ) ).

tff(addAssignment_86123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154238(VarCurr,B)
      <=> v154240(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154253(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154240(VarCurr,B)
          <=> v154254(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1764,axiom,
    ! [VarCurr: state_type] :
      ( v154253(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154240(VarCurr,B)
          <=> v154251(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154255(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154254(VarCurr,B)
          <=> v154256(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1763,axiom,
    ! [VarCurr: state_type] :
      ( v154255(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154254(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86122,axiom,
    ! [VarCurr: state_type] :
      ( v154256(VarCurr,0)
    <=> v154282(VarCurr) ) ).

tff(addAssignment_86121,axiom,
    ! [VarCurr: state_type] :
      ( v154256(VarCurr,1)
    <=> v154280(VarCurr) ) ).

tff(addAssignment_86120,axiom,
    ! [VarCurr: state_type] :
      ( v154256(VarCurr,2)
    <=> v154276(VarCurr) ) ).

tff(addAssignment_86119,axiom,
    ! [VarCurr: state_type] :
      ( v154256(VarCurr,3)
    <=> v154272(VarCurr) ) ).

tff(addAssignment_86118,axiom,
    ! [VarCurr: state_type] :
      ( v154256(VarCurr,4)
    <=> v154258(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20651,axiom,
    ! [VarCurr: state_type] :
      ( v154280(VarCurr)
    <=> ( v154281(VarCurr)
        & v154283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20650,axiom,
    ! [VarCurr: state_type] :
      ( v154283(VarCurr)
    <=> ( v154212(VarCurr,0)
        | v154267(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7378,axiom,
    ! [VarCurr: state_type] :
      ( v154281(VarCurr)
    <=> ( v154282(VarCurr)
        | v154212(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154282(VarCurr)
    <=> v154212(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20649,axiom,
    ! [VarCurr: state_type] :
      ( v154276(VarCurr)
    <=> ( v154277(VarCurr)
        & v154279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20648,axiom,
    ! [VarCurr: state_type] :
      ( v154279(VarCurr)
    <=> ( v154265(VarCurr)
        | v154268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7377,axiom,
    ! [VarCurr: state_type] :
      ( v154277(VarCurr)
    <=> ( v154278(VarCurr)
        | v154212(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154278(VarCurr)
    <=> v154265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20647,axiom,
    ! [VarCurr: state_type] :
      ( v154272(VarCurr)
    <=> ( v154273(VarCurr)
        & v154275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20646,axiom,
    ! [VarCurr: state_type] :
      ( v154275(VarCurr)
    <=> ( v154263(VarCurr)
        | v154269(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7376,axiom,
    ! [VarCurr: state_type] :
      ( v154273(VarCurr)
    <=> ( v154274(VarCurr)
        | v154212(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154274(VarCurr)
    <=> v154263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20645,axiom,
    ! [VarCurr: state_type] :
      ( v154258(VarCurr)
    <=> ( v154259(VarCurr)
        & v154270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20644,axiom,
    ! [VarCurr: state_type] :
      ( v154270(VarCurr)
    <=> ( v154261(VarCurr)
        | v154271(VarCurr) ) ) ).

tff(writeUnaryOperator_11818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154271(VarCurr)
    <=> v154212(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7375,axiom,
    ! [VarCurr: state_type] :
      ( v154259(VarCurr)
    <=> ( v154260(VarCurr)
        | v154212(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154260(VarCurr)
    <=> v154261(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7374,axiom,
    ! [VarCurr: state_type] :
      ( v154261(VarCurr)
    <=> ( v154212(VarCurr,3)
        | v154262(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20643,axiom,
    ! [VarCurr: state_type] :
      ( v154262(VarCurr)
    <=> ( v154263(VarCurr)
        & v154269(VarCurr) ) ) ).

tff(writeUnaryOperator_11816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154269(VarCurr)
    <=> v154212(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7373,axiom,
    ! [VarCurr: state_type] :
      ( v154263(VarCurr)
    <=> ( v154212(VarCurr,2)
        | v154264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20642,axiom,
    ! [VarCurr: state_type] :
      ( v154264(VarCurr)
    <=> ( v154265(VarCurr)
        & v154268(VarCurr) ) ) ).

tff(writeUnaryOperator_11815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154268(VarCurr)
    <=> v154212(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7372,axiom,
    ! [VarCurr: state_type] :
      ( v154265(VarCurr)
    <=> ( v154212(VarCurr,1)
        | v154266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20641,axiom,
    ! [VarCurr: state_type] :
      ( v154266(VarCurr)
    <=> ( v154212(VarCurr,0)
        & v154267(VarCurr) ) ) ).

tff(writeUnaryOperator_11814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154267(VarCurr)
    <=> v154212(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2415,axiom,
    ! [VarCurr: state_type] :
      ( v154255(VarCurr)
    <=> ( ( v154212(VarCurr,4)
        <=> $false )
        & ( v154212(VarCurr,3)
        <=> $false )
        & ( v154212(VarCurr,2)
        <=> $false )
        & ( v154212(VarCurr,1)
        <=> $false )
        & ( v154212(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20640,axiom,
    ! [VarCurr: state_type] :
      ( v154253(VarCurr)
    <=> ( v154242(VarCurr)
        & v154249(VarCurr) ) ) ).

tff(addAssignment_86117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154251(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_86116,axiom,
    ! [VarCurr: state_type] :
      ( v154249(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20639,axiom,
    ! [VarCurr: state_type] :
      ( v154242(VarCurr)
    <=> ( v154244(VarCurr)
        | v154246(VarCurr) ) ) ).

tff(addAssignment_86115,axiom,
    ! [VarCurr: state_type] :
      ( v154246(VarCurr)
    <=> v110583(VarCurr,14) ) ).

tff(addAssignment_86114,axiom,
    ! [VarCurr: state_type] :
      ( v154244(VarCurr)
    <=> v116(VarCurr,14) ) ).

tff(addAssignment_86113,axiom,
    ! [VarCurr: state_type] :
      ( v154226(VarCurr)
    <=> v154228(VarCurr) ) ).

tff(addAssignment_86112,axiom,
    ! [VarCurr: state_type] :
      ( v154228(VarCurr)
    <=> v154230(VarCurr) ) ).

tff(addAssignment_86111,axiom,
    ! [VarCurr: state_type] :
      ( v154230(VarCurr)
    <=> v154232(VarCurr) ) ).

tff(addAssignment_86110,axiom,
    ! [VarCurr: state_type] :
      ( v154232(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_86109,axiom,
    ! [VarCurr: state_type] :
      ( v154218(VarCurr)
    <=> v154220(VarCurr) ) ).

tff(addAssignment_86108,axiom,
    ! [VarCurr: state_type] :
      ( v154220(VarCurr)
    <=> v154222(VarCurr) ) ).

tff(addAssignment_86107,axiom,
    ! [VarCurr: state_type] :
      ( v154222(VarCurr)
    <=> v154224(VarCurr) ) ).

tff(addAssignment_86106,axiom,
    ! [VarCurr: state_type] :
      ( v154224(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_86105,axiom,
    ! [VarCurr: state_type] :
      ( v154111(VarCurr)
    <=> v154113(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2414,axiom,
    ! [VarCurr: state_type] :
      ( v154113(VarCurr)
    <=> ( ( v154115(VarCurr,4)
        <=> $false )
        & ( v154115(VarCurr,3)
        <=> $false )
        & ( v154115(VarCurr,2)
        <=> $false )
        & ( v154115(VarCurr,1)
        <=> $false )
        & ( v154115(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154115(VarCurr,B)
      <=> v154117(VarCurr,B) ) ) ).

tff(addAssignment_86103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154117(VarCurr,B)
      <=> v154119(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154190(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154119(VarNext,B)
            <=> v154119(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2292,axiom,
    ! [VarNext: state_type] :
      ( v154190(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154119(VarNext,B)
          <=> v154200(VarNext,B) ) ) ) ).

tff(addAssignment_86102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154200(VarNext,B)
          <=> v154198(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154198(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1762,axiom,
    ! [VarCurr: state_type] :
      ( v154201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154198(VarCurr,B)
          <=> v154129(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20638,axiom,
    ! [VarCurr: state_type] :
      ( v154201(VarCurr)
    <=> ( v154202(VarCurr)
        & v154203(VarCurr) ) ) ).

tff(writeUnaryOperator_11813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154203(VarCurr)
    <=> v154125(VarCurr) ) ).

tff(writeUnaryOperator_11812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154202(VarCurr)
    <=> v154121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154190(VarNext)
      <=> v154191(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154191(VarNext)
      <=> ( v154192(VarNext)
          & v154185(VarNext) ) ) ) ).

tff(writeUnaryOperator_11811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154192(VarNext)
      <=> v154194(VarNext) ) ) ).

tff(addAssignment_86101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154194(VarNext)
      <=> v154185(VarCurr) ) ) ).

tff(addAssignment_86100,axiom,
    ! [VarCurr: state_type] :
      ( v154185(VarCurr)
    <=> v154187(VarCurr) ) ).

tff(addAssignment_86099,axiom,
    ! [VarCurr: state_type] :
      ( v154187(VarCurr)
    <=> v154090(VarCurr) ) ).

tff(addAssignment_86098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154129(VarCurr,B)
      <=> v154131(VarCurr,B) ) ) ).

tff(addAssignment_86097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154131(VarCurr,B)
      <=> v154133(VarCurr,B) ) ) ).

tff(addAssignment_86096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154133(VarCurr,B)
      <=> v154135(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154150(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154135(VarCurr,B)
          <=> v154154(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1761,axiom,
    ! [VarCurr: state_type] :
      ( v154150(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154135(VarCurr,B)
          <=> v154151(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154155(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154154(VarCurr,B)
          <=> v154156(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1760,axiom,
    ! [VarCurr: state_type] :
      ( v154155(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154154(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86095,axiom,
    ! [VarCurr: state_type] :
      ( v154156(VarCurr,0)
    <=> v154182(VarCurr) ) ).

tff(addAssignment_86094,axiom,
    ! [VarCurr: state_type] :
      ( v154156(VarCurr,1)
    <=> v154180(VarCurr) ) ).

tff(addAssignment_86093,axiom,
    ! [VarCurr: state_type] :
      ( v154156(VarCurr,2)
    <=> v154176(VarCurr) ) ).

tff(addAssignment_86092,axiom,
    ! [VarCurr: state_type] :
      ( v154156(VarCurr,3)
    <=> v154172(VarCurr) ) ).

tff(addAssignment_86091,axiom,
    ! [VarCurr: state_type] :
      ( v154156(VarCurr,4)
    <=> v154158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20635,axiom,
    ! [VarCurr: state_type] :
      ( v154180(VarCurr)
    <=> ( v154181(VarCurr)
        & v154183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20634,axiom,
    ! [VarCurr: state_type] :
      ( v154183(VarCurr)
    <=> ( v154115(VarCurr,0)
        | v154167(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7371,axiom,
    ! [VarCurr: state_type] :
      ( v154181(VarCurr)
    <=> ( v154182(VarCurr)
        | v154115(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154182(VarCurr)
    <=> v154115(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20633,axiom,
    ! [VarCurr: state_type] :
      ( v154176(VarCurr)
    <=> ( v154177(VarCurr)
        & v154179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20632,axiom,
    ! [VarCurr: state_type] :
      ( v154179(VarCurr)
    <=> ( v154165(VarCurr)
        | v154168(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7370,axiom,
    ! [VarCurr: state_type] :
      ( v154177(VarCurr)
    <=> ( v154178(VarCurr)
        | v154115(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154178(VarCurr)
    <=> v154165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20631,axiom,
    ! [VarCurr: state_type] :
      ( v154172(VarCurr)
    <=> ( v154173(VarCurr)
        & v154175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20630,axiom,
    ! [VarCurr: state_type] :
      ( v154175(VarCurr)
    <=> ( v154163(VarCurr)
        | v154169(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7369,axiom,
    ! [VarCurr: state_type] :
      ( v154173(VarCurr)
    <=> ( v154174(VarCurr)
        | v154115(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154174(VarCurr)
    <=> v154163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20629,axiom,
    ! [VarCurr: state_type] :
      ( v154158(VarCurr)
    <=> ( v154159(VarCurr)
        & v154170(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20628,axiom,
    ! [VarCurr: state_type] :
      ( v154170(VarCurr)
    <=> ( v154161(VarCurr)
        | v154171(VarCurr) ) ) ).

tff(writeUnaryOperator_11807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154171(VarCurr)
    <=> v154115(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7368,axiom,
    ! [VarCurr: state_type] :
      ( v154159(VarCurr)
    <=> ( v154160(VarCurr)
        | v154115(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154160(VarCurr)
    <=> v154161(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7367,axiom,
    ! [VarCurr: state_type] :
      ( v154161(VarCurr)
    <=> ( v154115(VarCurr,3)
        | v154162(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20627,axiom,
    ! [VarCurr: state_type] :
      ( v154162(VarCurr)
    <=> ( v154163(VarCurr)
        & v154169(VarCurr) ) ) ).

tff(writeUnaryOperator_11805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154169(VarCurr)
    <=> v154115(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7366,axiom,
    ! [VarCurr: state_type] :
      ( v154163(VarCurr)
    <=> ( v154115(VarCurr,2)
        | v154164(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20626,axiom,
    ! [VarCurr: state_type] :
      ( v154164(VarCurr)
    <=> ( v154165(VarCurr)
        & v154168(VarCurr) ) ) ).

tff(writeUnaryOperator_11804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154168(VarCurr)
    <=> v154115(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7365,axiom,
    ! [VarCurr: state_type] :
      ( v154165(VarCurr)
    <=> ( v154115(VarCurr,1)
        | v154166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20625,axiom,
    ! [VarCurr: state_type] :
      ( v154166(VarCurr)
    <=> ( v154115(VarCurr,0)
        & v154167(VarCurr) ) ) ).

tff(writeUnaryOperator_11803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154167(VarCurr)
    <=> v154115(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2413,axiom,
    ! [VarCurr: state_type] :
      ( v154155(VarCurr)
    <=> ( ( v154115(VarCurr,4)
        <=> $false )
        & ( v154115(VarCurr,3)
        <=> $false )
        & ( v154115(VarCurr,2)
        <=> $false )
        & ( v154115(VarCurr,1)
        <=> $false )
        & ( v154115(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154152(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154151(VarCurr,B)
          <=> v154148(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1759,axiom,
    ! [VarCurr: state_type] :
      ( v154152(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154151(VarCurr,B)
          <=> v154146(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20624,axiom,
    ! [VarCurr: state_type] :
      ( v154152(VarCurr)
    <=> ( v154153(VarCurr)
        | v154141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20623,axiom,
    ! [VarCurr: state_type] :
      ( v154153(VarCurr)
    <=> ( v154144(VarCurr)
        & v154139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20622,axiom,
    ! [VarCurr: state_type] :
      ( v154150(VarCurr)
    <=> ( v154137(VarCurr)
        & v154050(VarCurr) ) ) ).

tff(addAssignment_86090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154148(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_86089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154146(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_86088,axiom,
    ! [VarCurr: state_type] :
      ( v154144(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20621,axiom,
    ! [VarCurr: state_type] :
      ( v154137(VarCurr)
    <=> ( v154139(VarCurr)
        | v154141(VarCurr) ) ) ).

tff(addAssignment_86087,axiom,
    ! [VarCurr: state_type] :
      ( v154141(VarCurr)
    <=> v110563(VarCurr,13) ) ).

tff(addAssignment_86086,axiom,
    ! [VarCurr: state_type] :
      ( v154139(VarCurr)
    <=> v108901(VarCurr,13) ) ).

tff(addAssignment_86085,axiom,
    ! [VarCurr: state_type] :
      ( v154125(VarCurr)
    <=> v154127(VarCurr) ) ).

tff(addAssignment_86084,axiom,
    ! [VarCurr: state_type] :
      ( v154127(VarCurr)
    <=> v154031(VarCurr) ) ).

tff(addAssignment_86083,axiom,
    ! [VarCurr: state_type] :
      ( v154121(VarCurr)
    <=> v154123(VarCurr) ) ).

tff(addAssignment_86082,axiom,
    ! [VarCurr: state_type] :
      ( v154123(VarCurr)
    <=> v154023(VarCurr) ) ).

tff(addAssignment_86081,axiom,
    ! [VarCurr: state_type] :
      ( v154009(VarCurr)
    <=> v154011(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2412,axiom,
    ! [VarCurr: state_type] :
      ( v154011(VarCurr)
    <=> ( ( v154013(VarCurr,4)
        <=> $false )
        & ( v154013(VarCurr,3)
        <=> $false )
        & ( v154013(VarCurr,2)
        <=> $false )
        & ( v154013(VarCurr,1)
        <=> $false )
        & ( v154013(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154013(VarCurr,B)
      <=> v154015(VarCurr,B) ) ) ).

tff(addAssignment_86079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154015(VarCurr,B)
      <=> v154017(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154093(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v154017(VarNext,B)
            <=> v154017(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2291,axiom,
    ! [VarNext: state_type] :
      ( v154093(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154017(VarNext,B)
          <=> v154103(VarNext,B) ) ) ) ).

tff(addAssignment_86078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154103(VarNext,B)
          <=> v154101(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154104(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154101(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1758,axiom,
    ! [VarCurr: state_type] :
      ( v154104(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154101(VarCurr,B)
          <=> v154035(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20620,axiom,
    ! [VarCurr: state_type] :
      ( v154104(VarCurr)
    <=> ( v154105(VarCurr)
        & v154106(VarCurr) ) ) ).

tff(writeUnaryOperator_11802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154106(VarCurr)
    <=> v154027(VarCurr) ) ).

tff(writeUnaryOperator_11801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154105(VarCurr)
    <=> v154019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154093(VarNext)
      <=> v154094(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154094(VarNext)
      <=> ( v154095(VarNext)
          & v154086(VarNext) ) ) ) ).

tff(writeUnaryOperator_11800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v154095(VarNext)
      <=> v154097(VarNext) ) ) ).

tff(addAssignment_86077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v154097(VarNext)
      <=> v154086(VarCurr) ) ) ).

tff(addAssignment_86076,axiom,
    ! [VarCurr: state_type] :
      ( v154086(VarCurr)
    <=> v154088(VarCurr) ) ).

tff(addAssignment_86075,axiom,
    ! [VarCurr: state_type] :
      ( v154088(VarCurr)
    <=> v154090(VarCurr) ) ).

tff(addAssignment_86074,axiom,
    ! [VarCurr: state_type] :
      ( v154090(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_86073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154035(VarCurr,B)
      <=> v154037(VarCurr,B) ) ) ).

tff(addAssignment_86072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154037(VarCurr,B)
      <=> v154039(VarCurr,B) ) ) ).

tff(addAssignment_86071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154039(VarCurr,B)
      <=> v154041(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154054(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154041(VarCurr,B)
          <=> v154055(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1757,axiom,
    ! [VarCurr: state_type] :
      ( v154054(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154041(VarCurr,B)
          <=> v154052(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154056(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154055(VarCurr,B)
          <=> v154057(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1756,axiom,
    ! [VarCurr: state_type] :
      ( v154056(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154055(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86070,axiom,
    ! [VarCurr: state_type] :
      ( v154057(VarCurr,0)
    <=> v154083(VarCurr) ) ).

tff(addAssignment_86069,axiom,
    ! [VarCurr: state_type] :
      ( v154057(VarCurr,1)
    <=> v154081(VarCurr) ) ).

tff(addAssignment_86068,axiom,
    ! [VarCurr: state_type] :
      ( v154057(VarCurr,2)
    <=> v154077(VarCurr) ) ).

tff(addAssignment_86067,axiom,
    ! [VarCurr: state_type] :
      ( v154057(VarCurr,3)
    <=> v154073(VarCurr) ) ).

tff(addAssignment_86066,axiom,
    ! [VarCurr: state_type] :
      ( v154057(VarCurr,4)
    <=> v154059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20617,axiom,
    ! [VarCurr: state_type] :
      ( v154081(VarCurr)
    <=> ( v154082(VarCurr)
        & v154084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20616,axiom,
    ! [VarCurr: state_type] :
      ( v154084(VarCurr)
    <=> ( v154013(VarCurr,0)
        | v154068(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7364,axiom,
    ! [VarCurr: state_type] :
      ( v154082(VarCurr)
    <=> ( v154083(VarCurr)
        | v154013(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154083(VarCurr)
    <=> v154013(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20615,axiom,
    ! [VarCurr: state_type] :
      ( v154077(VarCurr)
    <=> ( v154078(VarCurr)
        & v154080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20614,axiom,
    ! [VarCurr: state_type] :
      ( v154080(VarCurr)
    <=> ( v154066(VarCurr)
        | v154069(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7363,axiom,
    ! [VarCurr: state_type] :
      ( v154078(VarCurr)
    <=> ( v154079(VarCurr)
        | v154013(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154079(VarCurr)
    <=> v154066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20613,axiom,
    ! [VarCurr: state_type] :
      ( v154073(VarCurr)
    <=> ( v154074(VarCurr)
        & v154076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20612,axiom,
    ! [VarCurr: state_type] :
      ( v154076(VarCurr)
    <=> ( v154064(VarCurr)
        | v154070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7362,axiom,
    ! [VarCurr: state_type] :
      ( v154074(VarCurr)
    <=> ( v154075(VarCurr)
        | v154013(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154075(VarCurr)
    <=> v154064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20611,axiom,
    ! [VarCurr: state_type] :
      ( v154059(VarCurr)
    <=> ( v154060(VarCurr)
        & v154071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20610,axiom,
    ! [VarCurr: state_type] :
      ( v154071(VarCurr)
    <=> ( v154062(VarCurr)
        | v154072(VarCurr) ) ) ).

tff(writeUnaryOperator_11796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154072(VarCurr)
    <=> v154013(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7361,axiom,
    ! [VarCurr: state_type] :
      ( v154060(VarCurr)
    <=> ( v154061(VarCurr)
        | v154013(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154061(VarCurr)
    <=> v154062(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7360,axiom,
    ! [VarCurr: state_type] :
      ( v154062(VarCurr)
    <=> ( v154013(VarCurr,3)
        | v154063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20609,axiom,
    ! [VarCurr: state_type] :
      ( v154063(VarCurr)
    <=> ( v154064(VarCurr)
        & v154070(VarCurr) ) ) ).

tff(writeUnaryOperator_11794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154070(VarCurr)
    <=> v154013(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7359,axiom,
    ! [VarCurr: state_type] :
      ( v154064(VarCurr)
    <=> ( v154013(VarCurr,2)
        | v154065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20608,axiom,
    ! [VarCurr: state_type] :
      ( v154065(VarCurr)
    <=> ( v154066(VarCurr)
        & v154069(VarCurr) ) ) ).

tff(writeUnaryOperator_11793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154069(VarCurr)
    <=> v154013(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7358,axiom,
    ! [VarCurr: state_type] :
      ( v154066(VarCurr)
    <=> ( v154013(VarCurr,1)
        | v154067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20607,axiom,
    ! [VarCurr: state_type] :
      ( v154067(VarCurr)
    <=> ( v154013(VarCurr,0)
        & v154068(VarCurr) ) ) ).

tff(writeUnaryOperator_11792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154068(VarCurr)
    <=> v154013(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2411,axiom,
    ! [VarCurr: state_type] :
      ( v154056(VarCurr)
    <=> ( ( v154013(VarCurr,4)
        <=> $false )
        & ( v154013(VarCurr,3)
        <=> $false )
        & ( v154013(VarCurr,2)
        <=> $false )
        & ( v154013(VarCurr,1)
        <=> $false )
        & ( v154013(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20606,axiom,
    ! [VarCurr: state_type] :
      ( v154054(VarCurr)
    <=> ( v154043(VarCurr)
        & v154050(VarCurr) ) ) ).

tff(addAssignment_86065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v154052(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_86064,axiom,
    ! [VarCurr: state_type] :
      ( v154050(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20605,axiom,
    ! [VarCurr: state_type] :
      ( v154043(VarCurr)
    <=> ( v154045(VarCurr)
        | v154047(VarCurr) ) ) ).

tff(addAssignment_86063,axiom,
    ! [VarCurr: state_type] :
      ( v154047(VarCurr)
    <=> v110583(VarCurr,13) ) ).

tff(addAssignment_86062,axiom,
    ! [VarCurr: state_type] :
      ( v154045(VarCurr)
    <=> v116(VarCurr,13) ) ).

tff(addAssignment_86061,axiom,
    ! [VarCurr: state_type] :
      ( v154027(VarCurr)
    <=> v154029(VarCurr) ) ).

tff(addAssignment_86060,axiom,
    ! [VarCurr: state_type] :
      ( v154029(VarCurr)
    <=> v154031(VarCurr) ) ).

tff(addAssignment_86059,axiom,
    ! [VarCurr: state_type] :
      ( v154031(VarCurr)
    <=> v154033(VarCurr) ) ).

tff(addAssignment_86058,axiom,
    ! [VarCurr: state_type] :
      ( v154033(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_86057,axiom,
    ! [VarCurr: state_type] :
      ( v154019(VarCurr)
    <=> v154021(VarCurr) ) ).

tff(addAssignment_86056,axiom,
    ! [VarCurr: state_type] :
      ( v154021(VarCurr)
    <=> v154023(VarCurr) ) ).

tff(addAssignment_86055,axiom,
    ! [VarCurr: state_type] :
      ( v154023(VarCurr)
    <=> v154025(VarCurr) ) ).

tff(addAssignment_86054,axiom,
    ! [VarCurr: state_type] :
      ( v154025(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_86053,axiom,
    ! [VarCurr: state_type] :
      ( v153912(VarCurr)
    <=> v153914(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2410,axiom,
    ! [VarCurr: state_type] :
      ( v153914(VarCurr)
    <=> ( ( v153916(VarCurr,4)
        <=> $false )
        & ( v153916(VarCurr,3)
        <=> $false )
        & ( v153916(VarCurr,2)
        <=> $false )
        & ( v153916(VarCurr,1)
        <=> $false )
        & ( v153916(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153916(VarCurr,B)
      <=> v153918(VarCurr,B) ) ) ).

tff(addAssignment_86051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153918(VarCurr,B)
      <=> v153920(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153991(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153920(VarNext,B)
            <=> v153920(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2290,axiom,
    ! [VarNext: state_type] :
      ( v153991(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153920(VarNext,B)
          <=> v154001(VarNext,B) ) ) ) ).

tff(addAssignment_86050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v154001(VarNext,B)
          <=> v153999(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153999(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1755,axiom,
    ! [VarCurr: state_type] :
      ( v154002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153999(VarCurr,B)
          <=> v153930(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20604,axiom,
    ! [VarCurr: state_type] :
      ( v154002(VarCurr)
    <=> ( v154003(VarCurr)
        & v154004(VarCurr) ) ) ).

tff(writeUnaryOperator_11791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154004(VarCurr)
    <=> v153926(VarCurr) ) ).

tff(writeUnaryOperator_11790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v154003(VarCurr)
    <=> v153922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153991(VarNext)
      <=> v153992(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153992(VarNext)
      <=> ( v153993(VarNext)
          & v153986(VarNext) ) ) ) ).

tff(writeUnaryOperator_11789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153993(VarNext)
      <=> v153995(VarNext) ) ) ).

tff(addAssignment_86049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153995(VarNext)
      <=> v153986(VarCurr) ) ) ).

tff(addAssignment_86048,axiom,
    ! [VarCurr: state_type] :
      ( v153986(VarCurr)
    <=> v153988(VarCurr) ) ).

tff(addAssignment_86047,axiom,
    ! [VarCurr: state_type] :
      ( v153988(VarCurr)
    <=> v153891(VarCurr) ) ).

tff(addAssignment_86046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153930(VarCurr,B)
      <=> v153932(VarCurr,B) ) ) ).

tff(addAssignment_86045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153932(VarCurr,B)
      <=> v153934(VarCurr,B) ) ) ).

tff(addAssignment_86044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153934(VarCurr,B)
      <=> v153936(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153936(VarCurr,B)
          <=> v153955(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1754,axiom,
    ! [VarCurr: state_type] :
      ( v153951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153936(VarCurr,B)
          <=> v153952(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153955(VarCurr,B)
          <=> v153957(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1753,axiom,
    ! [VarCurr: state_type] :
      ( v153956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153955(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86043,axiom,
    ! [VarCurr: state_type] :
      ( v153957(VarCurr,0)
    <=> v153983(VarCurr) ) ).

tff(addAssignment_86042,axiom,
    ! [VarCurr: state_type] :
      ( v153957(VarCurr,1)
    <=> v153981(VarCurr) ) ).

tff(addAssignment_86041,axiom,
    ! [VarCurr: state_type] :
      ( v153957(VarCurr,2)
    <=> v153977(VarCurr) ) ).

tff(addAssignment_86040,axiom,
    ! [VarCurr: state_type] :
      ( v153957(VarCurr,3)
    <=> v153973(VarCurr) ) ).

tff(addAssignment_86039,axiom,
    ! [VarCurr: state_type] :
      ( v153957(VarCurr,4)
    <=> v153959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20601,axiom,
    ! [VarCurr: state_type] :
      ( v153981(VarCurr)
    <=> ( v153982(VarCurr)
        & v153984(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20600,axiom,
    ! [VarCurr: state_type] :
      ( v153984(VarCurr)
    <=> ( v153916(VarCurr,0)
        | v153968(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7357,axiom,
    ! [VarCurr: state_type] :
      ( v153982(VarCurr)
    <=> ( v153983(VarCurr)
        | v153916(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153983(VarCurr)
    <=> v153916(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20599,axiom,
    ! [VarCurr: state_type] :
      ( v153977(VarCurr)
    <=> ( v153978(VarCurr)
        & v153980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20598,axiom,
    ! [VarCurr: state_type] :
      ( v153980(VarCurr)
    <=> ( v153966(VarCurr)
        | v153969(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7356,axiom,
    ! [VarCurr: state_type] :
      ( v153978(VarCurr)
    <=> ( v153979(VarCurr)
        | v153916(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153979(VarCurr)
    <=> v153966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20597,axiom,
    ! [VarCurr: state_type] :
      ( v153973(VarCurr)
    <=> ( v153974(VarCurr)
        & v153976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20596,axiom,
    ! [VarCurr: state_type] :
      ( v153976(VarCurr)
    <=> ( v153964(VarCurr)
        | v153970(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7355,axiom,
    ! [VarCurr: state_type] :
      ( v153974(VarCurr)
    <=> ( v153975(VarCurr)
        | v153916(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153975(VarCurr)
    <=> v153964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20595,axiom,
    ! [VarCurr: state_type] :
      ( v153959(VarCurr)
    <=> ( v153960(VarCurr)
        & v153971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20594,axiom,
    ! [VarCurr: state_type] :
      ( v153971(VarCurr)
    <=> ( v153962(VarCurr)
        | v153972(VarCurr) ) ) ).

tff(writeUnaryOperator_11785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153972(VarCurr)
    <=> v153916(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7354,axiom,
    ! [VarCurr: state_type] :
      ( v153960(VarCurr)
    <=> ( v153961(VarCurr)
        | v153916(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153961(VarCurr)
    <=> v153962(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7353,axiom,
    ! [VarCurr: state_type] :
      ( v153962(VarCurr)
    <=> ( v153916(VarCurr,3)
        | v153963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20593,axiom,
    ! [VarCurr: state_type] :
      ( v153963(VarCurr)
    <=> ( v153964(VarCurr)
        & v153970(VarCurr) ) ) ).

tff(writeUnaryOperator_11783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153970(VarCurr)
    <=> v153916(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7352,axiom,
    ! [VarCurr: state_type] :
      ( v153964(VarCurr)
    <=> ( v153916(VarCurr,2)
        | v153965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20592,axiom,
    ! [VarCurr: state_type] :
      ( v153965(VarCurr)
    <=> ( v153966(VarCurr)
        & v153969(VarCurr) ) ) ).

tff(writeUnaryOperator_11782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153969(VarCurr)
    <=> v153916(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7351,axiom,
    ! [VarCurr: state_type] :
      ( v153966(VarCurr)
    <=> ( v153916(VarCurr,1)
        | v153967(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20591,axiom,
    ! [VarCurr: state_type] :
      ( v153967(VarCurr)
    <=> ( v153916(VarCurr,0)
        & v153968(VarCurr) ) ) ).

tff(writeUnaryOperator_11781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153968(VarCurr)
    <=> v153916(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2409,axiom,
    ! [VarCurr: state_type] :
      ( v153956(VarCurr)
    <=> ( ( v153916(VarCurr,4)
        <=> $false )
        & ( v153916(VarCurr,3)
        <=> $false )
        & ( v153916(VarCurr,2)
        <=> $false )
        & ( v153916(VarCurr,1)
        <=> $false )
        & ( v153916(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153953(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153952(VarCurr,B)
          <=> v153949(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1752,axiom,
    ! [VarCurr: state_type] :
      ( v153953(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153952(VarCurr,B)
          <=> v153947(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20590,axiom,
    ! [VarCurr: state_type] :
      ( v153953(VarCurr)
    <=> ( v153954(VarCurr)
        | v153942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20589,axiom,
    ! [VarCurr: state_type] :
      ( v153954(VarCurr)
    <=> ( v153945(VarCurr)
        & v153940(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20588,axiom,
    ! [VarCurr: state_type] :
      ( v153951(VarCurr)
    <=> ( v153938(VarCurr)
        & v153851(VarCurr) ) ) ).

tff(addAssignment_86038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153949(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_86037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153947(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_86036,axiom,
    ! [VarCurr: state_type] :
      ( v153945(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20587,axiom,
    ! [VarCurr: state_type] :
      ( v153938(VarCurr)
    <=> ( v153940(VarCurr)
        | v153942(VarCurr) ) ) ).

tff(addAssignment_86035,axiom,
    ! [VarCurr: state_type] :
      ( v153942(VarCurr)
    <=> v110563(VarCurr,12) ) ).

tff(addAssignment_86034,axiom,
    ! [VarCurr: state_type] :
      ( v153940(VarCurr)
    <=> v108901(VarCurr,12) ) ).

tff(addAssignment_86033,axiom,
    ! [VarCurr: state_type] :
      ( v153926(VarCurr)
    <=> v153928(VarCurr) ) ).

tff(addAssignment_86032,axiom,
    ! [VarCurr: state_type] :
      ( v153928(VarCurr)
    <=> v153832(VarCurr) ) ).

tff(addAssignment_86031,axiom,
    ! [VarCurr: state_type] :
      ( v153922(VarCurr)
    <=> v153924(VarCurr) ) ).

tff(addAssignment_86030,axiom,
    ! [VarCurr: state_type] :
      ( v153924(VarCurr)
    <=> v153824(VarCurr) ) ).

tff(addAssignment_86029,axiom,
    ! [VarCurr: state_type] :
      ( v153810(VarCurr)
    <=> v153812(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2408,axiom,
    ! [VarCurr: state_type] :
      ( v153812(VarCurr)
    <=> ( ( v153814(VarCurr,4)
        <=> $false )
        & ( v153814(VarCurr,3)
        <=> $false )
        & ( v153814(VarCurr,2)
        <=> $false )
        & ( v153814(VarCurr,1)
        <=> $false )
        & ( v153814(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153814(VarCurr,B)
      <=> v153816(VarCurr,B) ) ) ).

tff(addAssignment_86027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153816(VarCurr,B)
      <=> v153818(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153894(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153818(VarNext,B)
            <=> v153818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2289,axiom,
    ! [VarNext: state_type] :
      ( v153894(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153818(VarNext,B)
          <=> v153904(VarNext,B) ) ) ) ).

tff(addAssignment_86026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153904(VarNext,B)
          <=> v153902(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153902(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1751,axiom,
    ! [VarCurr: state_type] :
      ( v153905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153902(VarCurr,B)
          <=> v153836(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20586,axiom,
    ! [VarCurr: state_type] :
      ( v153905(VarCurr)
    <=> ( v153906(VarCurr)
        & v153907(VarCurr) ) ) ).

tff(writeUnaryOperator_11780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153907(VarCurr)
    <=> v153828(VarCurr) ) ).

tff(writeUnaryOperator_11779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153906(VarCurr)
    <=> v153820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153894(VarNext)
      <=> v153895(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153895(VarNext)
      <=> ( v153896(VarNext)
          & v153887(VarNext) ) ) ) ).

tff(writeUnaryOperator_11778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153896(VarNext)
      <=> v153898(VarNext) ) ) ).

tff(addAssignment_86025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153898(VarNext)
      <=> v153887(VarCurr) ) ) ).

tff(addAssignment_86024,axiom,
    ! [VarCurr: state_type] :
      ( v153887(VarCurr)
    <=> v153889(VarCurr) ) ).

tff(addAssignment_86023,axiom,
    ! [VarCurr: state_type] :
      ( v153889(VarCurr)
    <=> v153891(VarCurr) ) ).

tff(addAssignment_86022,axiom,
    ! [VarCurr: state_type] :
      ( v153891(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_86021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153836(VarCurr,B)
      <=> v153838(VarCurr,B) ) ) ).

tff(addAssignment_86020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153838(VarCurr,B)
      <=> v153840(VarCurr,B) ) ) ).

tff(addAssignment_86019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153840(VarCurr,B)
      <=> v153842(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153842(VarCurr,B)
          <=> v153856(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1750,axiom,
    ! [VarCurr: state_type] :
      ( v153855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153842(VarCurr,B)
          <=> v153853(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153856(VarCurr,B)
          <=> v153858(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1749,axiom,
    ! [VarCurr: state_type] :
      ( v153857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153856(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_86018,axiom,
    ! [VarCurr: state_type] :
      ( v153858(VarCurr,0)
    <=> v153884(VarCurr) ) ).

tff(addAssignment_86017,axiom,
    ! [VarCurr: state_type] :
      ( v153858(VarCurr,1)
    <=> v153882(VarCurr) ) ).

tff(addAssignment_86016,axiom,
    ! [VarCurr: state_type] :
      ( v153858(VarCurr,2)
    <=> v153878(VarCurr) ) ).

tff(addAssignment_86015,axiom,
    ! [VarCurr: state_type] :
      ( v153858(VarCurr,3)
    <=> v153874(VarCurr) ) ).

tff(addAssignment_86014,axiom,
    ! [VarCurr: state_type] :
      ( v153858(VarCurr,4)
    <=> v153860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20583,axiom,
    ! [VarCurr: state_type] :
      ( v153882(VarCurr)
    <=> ( v153883(VarCurr)
        & v153885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20582,axiom,
    ! [VarCurr: state_type] :
      ( v153885(VarCurr)
    <=> ( v153814(VarCurr,0)
        | v153869(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7350,axiom,
    ! [VarCurr: state_type] :
      ( v153883(VarCurr)
    <=> ( v153884(VarCurr)
        | v153814(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153884(VarCurr)
    <=> v153814(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20581,axiom,
    ! [VarCurr: state_type] :
      ( v153878(VarCurr)
    <=> ( v153879(VarCurr)
        & v153881(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20580,axiom,
    ! [VarCurr: state_type] :
      ( v153881(VarCurr)
    <=> ( v153867(VarCurr)
        | v153870(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7349,axiom,
    ! [VarCurr: state_type] :
      ( v153879(VarCurr)
    <=> ( v153880(VarCurr)
        | v153814(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153880(VarCurr)
    <=> v153867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20579,axiom,
    ! [VarCurr: state_type] :
      ( v153874(VarCurr)
    <=> ( v153875(VarCurr)
        & v153877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20578,axiom,
    ! [VarCurr: state_type] :
      ( v153877(VarCurr)
    <=> ( v153865(VarCurr)
        | v153871(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7348,axiom,
    ! [VarCurr: state_type] :
      ( v153875(VarCurr)
    <=> ( v153876(VarCurr)
        | v153814(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153876(VarCurr)
    <=> v153865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20577,axiom,
    ! [VarCurr: state_type] :
      ( v153860(VarCurr)
    <=> ( v153861(VarCurr)
        & v153872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20576,axiom,
    ! [VarCurr: state_type] :
      ( v153872(VarCurr)
    <=> ( v153863(VarCurr)
        | v153873(VarCurr) ) ) ).

tff(writeUnaryOperator_11774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153873(VarCurr)
    <=> v153814(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7347,axiom,
    ! [VarCurr: state_type] :
      ( v153861(VarCurr)
    <=> ( v153862(VarCurr)
        | v153814(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153862(VarCurr)
    <=> v153863(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7346,axiom,
    ! [VarCurr: state_type] :
      ( v153863(VarCurr)
    <=> ( v153814(VarCurr,3)
        | v153864(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20575,axiom,
    ! [VarCurr: state_type] :
      ( v153864(VarCurr)
    <=> ( v153865(VarCurr)
        & v153871(VarCurr) ) ) ).

tff(writeUnaryOperator_11772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153871(VarCurr)
    <=> v153814(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7345,axiom,
    ! [VarCurr: state_type] :
      ( v153865(VarCurr)
    <=> ( v153814(VarCurr,2)
        | v153866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20574,axiom,
    ! [VarCurr: state_type] :
      ( v153866(VarCurr)
    <=> ( v153867(VarCurr)
        & v153870(VarCurr) ) ) ).

tff(writeUnaryOperator_11771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153870(VarCurr)
    <=> v153814(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7344,axiom,
    ! [VarCurr: state_type] :
      ( v153867(VarCurr)
    <=> ( v153814(VarCurr,1)
        | v153868(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20573,axiom,
    ! [VarCurr: state_type] :
      ( v153868(VarCurr)
    <=> ( v153814(VarCurr,0)
        & v153869(VarCurr) ) ) ).

tff(writeUnaryOperator_11770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153869(VarCurr)
    <=> v153814(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2407,axiom,
    ! [VarCurr: state_type] :
      ( v153857(VarCurr)
    <=> ( ( v153814(VarCurr,4)
        <=> $false )
        & ( v153814(VarCurr,3)
        <=> $false )
        & ( v153814(VarCurr,2)
        <=> $false )
        & ( v153814(VarCurr,1)
        <=> $false )
        & ( v153814(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20572,axiom,
    ! [VarCurr: state_type] :
      ( v153855(VarCurr)
    <=> ( v153844(VarCurr)
        & v153851(VarCurr) ) ) ).

tff(addAssignment_86013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153853(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_86012,axiom,
    ! [VarCurr: state_type] :
      ( v153851(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20571,axiom,
    ! [VarCurr: state_type] :
      ( v153844(VarCurr)
    <=> ( v153846(VarCurr)
        | v153848(VarCurr) ) ) ).

tff(addAssignment_86011,axiom,
    ! [VarCurr: state_type] :
      ( v153848(VarCurr)
    <=> v110583(VarCurr,12) ) ).

tff(addAssignment_86010,axiom,
    ! [VarCurr: state_type] :
      ( v153846(VarCurr)
    <=> v116(VarCurr,12) ) ).

tff(addAssignment_86009,axiom,
    ! [VarCurr: state_type] :
      ( v153828(VarCurr)
    <=> v153830(VarCurr) ) ).

tff(addAssignment_86008,axiom,
    ! [VarCurr: state_type] :
      ( v153830(VarCurr)
    <=> v153832(VarCurr) ) ).

tff(addAssignment_86007,axiom,
    ! [VarCurr: state_type] :
      ( v153832(VarCurr)
    <=> v153834(VarCurr) ) ).

tff(addAssignment_86006,axiom,
    ! [VarCurr: state_type] :
      ( v153834(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_86005,axiom,
    ! [VarCurr: state_type] :
      ( v153820(VarCurr)
    <=> v153822(VarCurr) ) ).

tff(addAssignment_86004,axiom,
    ! [VarCurr: state_type] :
      ( v153822(VarCurr)
    <=> v153824(VarCurr) ) ).

tff(addAssignment_86003,axiom,
    ! [VarCurr: state_type] :
      ( v153824(VarCurr)
    <=> v153826(VarCurr) ) ).

tff(addAssignment_86002,axiom,
    ! [VarCurr: state_type] :
      ( v153826(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_86001,axiom,
    ! [VarCurr: state_type] :
      ( v153713(VarCurr)
    <=> v153715(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2406,axiom,
    ! [VarCurr: state_type] :
      ( v153715(VarCurr)
    <=> ( ( v153717(VarCurr,4)
        <=> $false )
        & ( v153717(VarCurr,3)
        <=> $false )
        & ( v153717(VarCurr,2)
        <=> $false )
        & ( v153717(VarCurr,1)
        <=> $false )
        & ( v153717(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_86000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153717(VarCurr,B)
      <=> v153719(VarCurr,B) ) ) ).

tff(addAssignment_85999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153719(VarCurr,B)
      <=> v153721(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153792(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153721(VarNext,B)
            <=> v153721(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2288,axiom,
    ! [VarNext: state_type] :
      ( v153792(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153721(VarNext,B)
          <=> v153802(VarNext,B) ) ) ) ).

tff(addAssignment_85998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153802(VarNext,B)
          <=> v153800(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153800(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1748,axiom,
    ! [VarCurr: state_type] :
      ( v153803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153800(VarCurr,B)
          <=> v153731(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20570,axiom,
    ! [VarCurr: state_type] :
      ( v153803(VarCurr)
    <=> ( v153804(VarCurr)
        & v153805(VarCurr) ) ) ).

tff(writeUnaryOperator_11769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153805(VarCurr)
    <=> v153727(VarCurr) ) ).

tff(writeUnaryOperator_11768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153804(VarCurr)
    <=> v153723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153792(VarNext)
      <=> v153793(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153793(VarNext)
      <=> ( v153794(VarNext)
          & v153787(VarNext) ) ) ) ).

tff(writeUnaryOperator_11767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153794(VarNext)
      <=> v153796(VarNext) ) ) ).

tff(addAssignment_85997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153796(VarNext)
      <=> v153787(VarCurr) ) ) ).

tff(addAssignment_85996,axiom,
    ! [VarCurr: state_type] :
      ( v153787(VarCurr)
    <=> v153789(VarCurr) ) ).

tff(addAssignment_85995,axiom,
    ! [VarCurr: state_type] :
      ( v153789(VarCurr)
    <=> v153692(VarCurr) ) ).

tff(addAssignment_85994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153731(VarCurr,B)
      <=> v153733(VarCurr,B) ) ) ).

tff(addAssignment_85993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153733(VarCurr,B)
      <=> v153735(VarCurr,B) ) ) ).

tff(addAssignment_85992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153735(VarCurr,B)
      <=> v153737(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153752(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153737(VarCurr,B)
          <=> v153756(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1747,axiom,
    ! [VarCurr: state_type] :
      ( v153752(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153737(VarCurr,B)
          <=> v153753(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153757(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153756(VarCurr,B)
          <=> v153758(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1746,axiom,
    ! [VarCurr: state_type] :
      ( v153757(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153756(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85991,axiom,
    ! [VarCurr: state_type] :
      ( v153758(VarCurr,0)
    <=> v153784(VarCurr) ) ).

tff(addAssignment_85990,axiom,
    ! [VarCurr: state_type] :
      ( v153758(VarCurr,1)
    <=> v153782(VarCurr) ) ).

tff(addAssignment_85989,axiom,
    ! [VarCurr: state_type] :
      ( v153758(VarCurr,2)
    <=> v153778(VarCurr) ) ).

tff(addAssignment_85988,axiom,
    ! [VarCurr: state_type] :
      ( v153758(VarCurr,3)
    <=> v153774(VarCurr) ) ).

tff(addAssignment_85987,axiom,
    ! [VarCurr: state_type] :
      ( v153758(VarCurr,4)
    <=> v153760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20567,axiom,
    ! [VarCurr: state_type] :
      ( v153782(VarCurr)
    <=> ( v153783(VarCurr)
        & v153785(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20566,axiom,
    ! [VarCurr: state_type] :
      ( v153785(VarCurr)
    <=> ( v153717(VarCurr,0)
        | v153769(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7343,axiom,
    ! [VarCurr: state_type] :
      ( v153783(VarCurr)
    <=> ( v153784(VarCurr)
        | v153717(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153784(VarCurr)
    <=> v153717(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20565,axiom,
    ! [VarCurr: state_type] :
      ( v153778(VarCurr)
    <=> ( v153779(VarCurr)
        & v153781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20564,axiom,
    ! [VarCurr: state_type] :
      ( v153781(VarCurr)
    <=> ( v153767(VarCurr)
        | v153770(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7342,axiom,
    ! [VarCurr: state_type] :
      ( v153779(VarCurr)
    <=> ( v153780(VarCurr)
        | v153717(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153780(VarCurr)
    <=> v153767(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20563,axiom,
    ! [VarCurr: state_type] :
      ( v153774(VarCurr)
    <=> ( v153775(VarCurr)
        & v153777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20562,axiom,
    ! [VarCurr: state_type] :
      ( v153777(VarCurr)
    <=> ( v153765(VarCurr)
        | v153771(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7341,axiom,
    ! [VarCurr: state_type] :
      ( v153775(VarCurr)
    <=> ( v153776(VarCurr)
        | v153717(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153776(VarCurr)
    <=> v153765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20561,axiom,
    ! [VarCurr: state_type] :
      ( v153760(VarCurr)
    <=> ( v153761(VarCurr)
        & v153772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20560,axiom,
    ! [VarCurr: state_type] :
      ( v153772(VarCurr)
    <=> ( v153763(VarCurr)
        | v153773(VarCurr) ) ) ).

tff(writeUnaryOperator_11763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153773(VarCurr)
    <=> v153717(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7340,axiom,
    ! [VarCurr: state_type] :
      ( v153761(VarCurr)
    <=> ( v153762(VarCurr)
        | v153717(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153762(VarCurr)
    <=> v153763(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7339,axiom,
    ! [VarCurr: state_type] :
      ( v153763(VarCurr)
    <=> ( v153717(VarCurr,3)
        | v153764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20559,axiom,
    ! [VarCurr: state_type] :
      ( v153764(VarCurr)
    <=> ( v153765(VarCurr)
        & v153771(VarCurr) ) ) ).

tff(writeUnaryOperator_11761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153771(VarCurr)
    <=> v153717(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7338,axiom,
    ! [VarCurr: state_type] :
      ( v153765(VarCurr)
    <=> ( v153717(VarCurr,2)
        | v153766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20558,axiom,
    ! [VarCurr: state_type] :
      ( v153766(VarCurr)
    <=> ( v153767(VarCurr)
        & v153770(VarCurr) ) ) ).

tff(writeUnaryOperator_11760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153770(VarCurr)
    <=> v153717(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7337,axiom,
    ! [VarCurr: state_type] :
      ( v153767(VarCurr)
    <=> ( v153717(VarCurr,1)
        | v153768(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20557,axiom,
    ! [VarCurr: state_type] :
      ( v153768(VarCurr)
    <=> ( v153717(VarCurr,0)
        & v153769(VarCurr) ) ) ).

tff(writeUnaryOperator_11759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153769(VarCurr)
    <=> v153717(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2405,axiom,
    ! [VarCurr: state_type] :
      ( v153757(VarCurr)
    <=> ( ( v153717(VarCurr,4)
        <=> $false )
        & ( v153717(VarCurr,3)
        <=> $false )
        & ( v153717(VarCurr,2)
        <=> $false )
        & ( v153717(VarCurr,1)
        <=> $false )
        & ( v153717(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153754(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153753(VarCurr,B)
          <=> v153750(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1745,axiom,
    ! [VarCurr: state_type] :
      ( v153754(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153753(VarCurr,B)
          <=> v153748(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20556,axiom,
    ! [VarCurr: state_type] :
      ( v153754(VarCurr)
    <=> ( v153755(VarCurr)
        | v153743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20555,axiom,
    ! [VarCurr: state_type] :
      ( v153755(VarCurr)
    <=> ( v153746(VarCurr)
        & v153741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20554,axiom,
    ! [VarCurr: state_type] :
      ( v153752(VarCurr)
    <=> ( v153739(VarCurr)
        & v153652(VarCurr) ) ) ).

tff(addAssignment_85986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153750(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153748(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85984,axiom,
    ! [VarCurr: state_type] :
      ( v153746(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20553,axiom,
    ! [VarCurr: state_type] :
      ( v153739(VarCurr)
    <=> ( v153741(VarCurr)
        | v153743(VarCurr) ) ) ).

tff(addAssignment_85983,axiom,
    ! [VarCurr: state_type] :
      ( v153743(VarCurr)
    <=> v110563(VarCurr,11) ) ).

tff(addAssignment_85982,axiom,
    ! [VarCurr: state_type] :
      ( v153741(VarCurr)
    <=> v108901(VarCurr,11) ) ).

tff(addAssignment_85981,axiom,
    ! [VarCurr: state_type] :
      ( v153727(VarCurr)
    <=> v153729(VarCurr) ) ).

tff(addAssignment_85980,axiom,
    ! [VarCurr: state_type] :
      ( v153729(VarCurr)
    <=> v153633(VarCurr) ) ).

tff(addAssignment_85979,axiom,
    ! [VarCurr: state_type] :
      ( v153723(VarCurr)
    <=> v153725(VarCurr) ) ).

tff(addAssignment_85978,axiom,
    ! [VarCurr: state_type] :
      ( v153725(VarCurr)
    <=> v153625(VarCurr) ) ).

tff(addAssignment_85977,axiom,
    ! [VarCurr: state_type] :
      ( v153611(VarCurr)
    <=> v153613(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2404,axiom,
    ! [VarCurr: state_type] :
      ( v153613(VarCurr)
    <=> ( ( v153615(VarCurr,4)
        <=> $false )
        & ( v153615(VarCurr,3)
        <=> $false )
        & ( v153615(VarCurr,2)
        <=> $false )
        & ( v153615(VarCurr,1)
        <=> $false )
        & ( v153615(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153615(VarCurr,B)
      <=> v153617(VarCurr,B) ) ) ).

tff(addAssignment_85975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153617(VarCurr,B)
      <=> v153619(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153695(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153619(VarNext,B)
            <=> v153619(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2287,axiom,
    ! [VarNext: state_type] :
      ( v153695(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153619(VarNext,B)
          <=> v153705(VarNext,B) ) ) ) ).

tff(addAssignment_85974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153705(VarNext,B)
          <=> v153703(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153703(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1744,axiom,
    ! [VarCurr: state_type] :
      ( v153706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153703(VarCurr,B)
          <=> v153637(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20552,axiom,
    ! [VarCurr: state_type] :
      ( v153706(VarCurr)
    <=> ( v153707(VarCurr)
        & v153708(VarCurr) ) ) ).

tff(writeUnaryOperator_11758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153708(VarCurr)
    <=> v153629(VarCurr) ) ).

tff(writeUnaryOperator_11757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153707(VarCurr)
    <=> v153621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153695(VarNext)
      <=> v153696(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153696(VarNext)
      <=> ( v153697(VarNext)
          & v153688(VarNext) ) ) ) ).

tff(writeUnaryOperator_11756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153697(VarNext)
      <=> v153699(VarNext) ) ) ).

tff(addAssignment_85973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153699(VarNext)
      <=> v153688(VarCurr) ) ) ).

tff(addAssignment_85972,axiom,
    ! [VarCurr: state_type] :
      ( v153688(VarCurr)
    <=> v153690(VarCurr) ) ).

tff(addAssignment_85971,axiom,
    ! [VarCurr: state_type] :
      ( v153690(VarCurr)
    <=> v153692(VarCurr) ) ).

tff(addAssignment_85970,axiom,
    ! [VarCurr: state_type] :
      ( v153692(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153637(VarCurr,B)
      <=> v153639(VarCurr,B) ) ) ).

tff(addAssignment_85968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153639(VarCurr,B)
      <=> v153641(VarCurr,B) ) ) ).

tff(addAssignment_85967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153641(VarCurr,B)
      <=> v153643(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153656(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153643(VarCurr,B)
          <=> v153657(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1743,axiom,
    ! [VarCurr: state_type] :
      ( v153656(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153643(VarCurr,B)
          <=> v153654(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153658(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153657(VarCurr,B)
          <=> v153659(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1742,axiom,
    ! [VarCurr: state_type] :
      ( v153658(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153657(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85966,axiom,
    ! [VarCurr: state_type] :
      ( v153659(VarCurr,0)
    <=> v153685(VarCurr) ) ).

tff(addAssignment_85965,axiom,
    ! [VarCurr: state_type] :
      ( v153659(VarCurr,1)
    <=> v153683(VarCurr) ) ).

tff(addAssignment_85964,axiom,
    ! [VarCurr: state_type] :
      ( v153659(VarCurr,2)
    <=> v153679(VarCurr) ) ).

tff(addAssignment_85963,axiom,
    ! [VarCurr: state_type] :
      ( v153659(VarCurr,3)
    <=> v153675(VarCurr) ) ).

tff(addAssignment_85962,axiom,
    ! [VarCurr: state_type] :
      ( v153659(VarCurr,4)
    <=> v153661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20549,axiom,
    ! [VarCurr: state_type] :
      ( v153683(VarCurr)
    <=> ( v153684(VarCurr)
        & v153686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20548,axiom,
    ! [VarCurr: state_type] :
      ( v153686(VarCurr)
    <=> ( v153615(VarCurr,0)
        | v153670(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7336,axiom,
    ! [VarCurr: state_type] :
      ( v153684(VarCurr)
    <=> ( v153685(VarCurr)
        | v153615(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153685(VarCurr)
    <=> v153615(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20547,axiom,
    ! [VarCurr: state_type] :
      ( v153679(VarCurr)
    <=> ( v153680(VarCurr)
        & v153682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20546,axiom,
    ! [VarCurr: state_type] :
      ( v153682(VarCurr)
    <=> ( v153668(VarCurr)
        | v153671(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7335,axiom,
    ! [VarCurr: state_type] :
      ( v153680(VarCurr)
    <=> ( v153681(VarCurr)
        | v153615(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153681(VarCurr)
    <=> v153668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20545,axiom,
    ! [VarCurr: state_type] :
      ( v153675(VarCurr)
    <=> ( v153676(VarCurr)
        & v153678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20544,axiom,
    ! [VarCurr: state_type] :
      ( v153678(VarCurr)
    <=> ( v153666(VarCurr)
        | v153672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7334,axiom,
    ! [VarCurr: state_type] :
      ( v153676(VarCurr)
    <=> ( v153677(VarCurr)
        | v153615(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153677(VarCurr)
    <=> v153666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20543,axiom,
    ! [VarCurr: state_type] :
      ( v153661(VarCurr)
    <=> ( v153662(VarCurr)
        & v153673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20542,axiom,
    ! [VarCurr: state_type] :
      ( v153673(VarCurr)
    <=> ( v153664(VarCurr)
        | v153674(VarCurr) ) ) ).

tff(writeUnaryOperator_11752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153674(VarCurr)
    <=> v153615(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7333,axiom,
    ! [VarCurr: state_type] :
      ( v153662(VarCurr)
    <=> ( v153663(VarCurr)
        | v153615(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153663(VarCurr)
    <=> v153664(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7332,axiom,
    ! [VarCurr: state_type] :
      ( v153664(VarCurr)
    <=> ( v153615(VarCurr,3)
        | v153665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20541,axiom,
    ! [VarCurr: state_type] :
      ( v153665(VarCurr)
    <=> ( v153666(VarCurr)
        & v153672(VarCurr) ) ) ).

tff(writeUnaryOperator_11750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153672(VarCurr)
    <=> v153615(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7331,axiom,
    ! [VarCurr: state_type] :
      ( v153666(VarCurr)
    <=> ( v153615(VarCurr,2)
        | v153667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20540,axiom,
    ! [VarCurr: state_type] :
      ( v153667(VarCurr)
    <=> ( v153668(VarCurr)
        & v153671(VarCurr) ) ) ).

tff(writeUnaryOperator_11749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153671(VarCurr)
    <=> v153615(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7330,axiom,
    ! [VarCurr: state_type] :
      ( v153668(VarCurr)
    <=> ( v153615(VarCurr,1)
        | v153669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20539,axiom,
    ! [VarCurr: state_type] :
      ( v153669(VarCurr)
    <=> ( v153615(VarCurr,0)
        & v153670(VarCurr) ) ) ).

tff(writeUnaryOperator_11748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153670(VarCurr)
    <=> v153615(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2403,axiom,
    ! [VarCurr: state_type] :
      ( v153658(VarCurr)
    <=> ( ( v153615(VarCurr,4)
        <=> $false )
        & ( v153615(VarCurr,3)
        <=> $false )
        & ( v153615(VarCurr,2)
        <=> $false )
        & ( v153615(VarCurr,1)
        <=> $false )
        & ( v153615(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20538,axiom,
    ! [VarCurr: state_type] :
      ( v153656(VarCurr)
    <=> ( v153645(VarCurr)
        & v153652(VarCurr) ) ) ).

tff(addAssignment_85961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153654(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85960,axiom,
    ! [VarCurr: state_type] :
      ( v153652(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20537,axiom,
    ! [VarCurr: state_type] :
      ( v153645(VarCurr)
    <=> ( v153647(VarCurr)
        | v153649(VarCurr) ) ) ).

tff(addAssignment_85959,axiom,
    ! [VarCurr: state_type] :
      ( v153649(VarCurr)
    <=> v110583(VarCurr,11) ) ).

tff(addAssignment_85958,axiom,
    ! [VarCurr: state_type] :
      ( v153647(VarCurr)
    <=> v116(VarCurr,11) ) ).

tff(addAssignment_85957,axiom,
    ! [VarCurr: state_type] :
      ( v153629(VarCurr)
    <=> v153631(VarCurr) ) ).

tff(addAssignment_85956,axiom,
    ! [VarCurr: state_type] :
      ( v153631(VarCurr)
    <=> v153633(VarCurr) ) ).

tff(addAssignment_85955,axiom,
    ! [VarCurr: state_type] :
      ( v153633(VarCurr)
    <=> v153635(VarCurr) ) ).

tff(addAssignment_85954,axiom,
    ! [VarCurr: state_type] :
      ( v153635(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85953,axiom,
    ! [VarCurr: state_type] :
      ( v153621(VarCurr)
    <=> v153623(VarCurr) ) ).

tff(addAssignment_85952,axiom,
    ! [VarCurr: state_type] :
      ( v153623(VarCurr)
    <=> v153625(VarCurr) ) ).

tff(addAssignment_85951,axiom,
    ! [VarCurr: state_type] :
      ( v153625(VarCurr)
    <=> v153627(VarCurr) ) ).

tff(addAssignment_85950,axiom,
    ! [VarCurr: state_type] :
      ( v153627(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85949,axiom,
    ! [VarCurr: state_type] :
      ( v153514(VarCurr)
    <=> v153516(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2402,axiom,
    ! [VarCurr: state_type] :
      ( v153516(VarCurr)
    <=> ( ( v153518(VarCurr,4)
        <=> $false )
        & ( v153518(VarCurr,3)
        <=> $false )
        & ( v153518(VarCurr,2)
        <=> $false )
        & ( v153518(VarCurr,1)
        <=> $false )
        & ( v153518(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153518(VarCurr,B)
      <=> v153520(VarCurr,B) ) ) ).

tff(addAssignment_85947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153520(VarCurr,B)
      <=> v153522(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153593(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153522(VarNext,B)
            <=> v153522(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2286,axiom,
    ! [VarNext: state_type] :
      ( v153593(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153522(VarNext,B)
          <=> v153603(VarNext,B) ) ) ) ).

tff(addAssignment_85946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153603(VarNext,B)
          <=> v153601(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153604(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153601(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1741,axiom,
    ! [VarCurr: state_type] :
      ( v153604(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153601(VarCurr,B)
          <=> v153532(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20536,axiom,
    ! [VarCurr: state_type] :
      ( v153604(VarCurr)
    <=> ( v153605(VarCurr)
        & v153606(VarCurr) ) ) ).

tff(writeUnaryOperator_11747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153606(VarCurr)
    <=> v153528(VarCurr) ) ).

tff(writeUnaryOperator_11746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153605(VarCurr)
    <=> v153524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153593(VarNext)
      <=> v153594(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153594(VarNext)
      <=> ( v153595(VarNext)
          & v153588(VarNext) ) ) ) ).

tff(writeUnaryOperator_11745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153595(VarNext)
      <=> v153597(VarNext) ) ) ).

tff(addAssignment_85945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153597(VarNext)
      <=> v153588(VarCurr) ) ) ).

tff(addAssignment_85944,axiom,
    ! [VarCurr: state_type] :
      ( v153588(VarCurr)
    <=> v153590(VarCurr) ) ).

tff(addAssignment_85943,axiom,
    ! [VarCurr: state_type] :
      ( v153590(VarCurr)
    <=> v153493(VarCurr) ) ).

tff(addAssignment_85942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153532(VarCurr,B)
      <=> v153534(VarCurr,B) ) ) ).

tff(addAssignment_85941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153534(VarCurr,B)
      <=> v153536(VarCurr,B) ) ) ).

tff(addAssignment_85940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153536(VarCurr,B)
      <=> v153538(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153538(VarCurr,B)
          <=> v153557(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1740,axiom,
    ! [VarCurr: state_type] :
      ( v153553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153538(VarCurr,B)
          <=> v153554(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153557(VarCurr,B)
          <=> v153559(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1739,axiom,
    ! [VarCurr: state_type] :
      ( v153558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153557(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85939,axiom,
    ! [VarCurr: state_type] :
      ( v153559(VarCurr,0)
    <=> v153585(VarCurr) ) ).

tff(addAssignment_85938,axiom,
    ! [VarCurr: state_type] :
      ( v153559(VarCurr,1)
    <=> v153583(VarCurr) ) ).

tff(addAssignment_85937,axiom,
    ! [VarCurr: state_type] :
      ( v153559(VarCurr,2)
    <=> v153579(VarCurr) ) ).

tff(addAssignment_85936,axiom,
    ! [VarCurr: state_type] :
      ( v153559(VarCurr,3)
    <=> v153575(VarCurr) ) ).

tff(addAssignment_85935,axiom,
    ! [VarCurr: state_type] :
      ( v153559(VarCurr,4)
    <=> v153561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20533,axiom,
    ! [VarCurr: state_type] :
      ( v153583(VarCurr)
    <=> ( v153584(VarCurr)
        & v153586(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20532,axiom,
    ! [VarCurr: state_type] :
      ( v153586(VarCurr)
    <=> ( v153518(VarCurr,0)
        | v153570(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7329,axiom,
    ! [VarCurr: state_type] :
      ( v153584(VarCurr)
    <=> ( v153585(VarCurr)
        | v153518(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153585(VarCurr)
    <=> v153518(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20531,axiom,
    ! [VarCurr: state_type] :
      ( v153579(VarCurr)
    <=> ( v153580(VarCurr)
        & v153582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20530,axiom,
    ! [VarCurr: state_type] :
      ( v153582(VarCurr)
    <=> ( v153568(VarCurr)
        | v153571(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7328,axiom,
    ! [VarCurr: state_type] :
      ( v153580(VarCurr)
    <=> ( v153581(VarCurr)
        | v153518(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153581(VarCurr)
    <=> v153568(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20529,axiom,
    ! [VarCurr: state_type] :
      ( v153575(VarCurr)
    <=> ( v153576(VarCurr)
        & v153578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20528,axiom,
    ! [VarCurr: state_type] :
      ( v153578(VarCurr)
    <=> ( v153566(VarCurr)
        | v153572(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7327,axiom,
    ! [VarCurr: state_type] :
      ( v153576(VarCurr)
    <=> ( v153577(VarCurr)
        | v153518(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153577(VarCurr)
    <=> v153566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20527,axiom,
    ! [VarCurr: state_type] :
      ( v153561(VarCurr)
    <=> ( v153562(VarCurr)
        & v153573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20526,axiom,
    ! [VarCurr: state_type] :
      ( v153573(VarCurr)
    <=> ( v153564(VarCurr)
        | v153574(VarCurr) ) ) ).

tff(writeUnaryOperator_11741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153574(VarCurr)
    <=> v153518(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7326,axiom,
    ! [VarCurr: state_type] :
      ( v153562(VarCurr)
    <=> ( v153563(VarCurr)
        | v153518(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153563(VarCurr)
    <=> v153564(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7325,axiom,
    ! [VarCurr: state_type] :
      ( v153564(VarCurr)
    <=> ( v153518(VarCurr,3)
        | v153565(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20525,axiom,
    ! [VarCurr: state_type] :
      ( v153565(VarCurr)
    <=> ( v153566(VarCurr)
        & v153572(VarCurr) ) ) ).

tff(writeUnaryOperator_11739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153572(VarCurr)
    <=> v153518(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7324,axiom,
    ! [VarCurr: state_type] :
      ( v153566(VarCurr)
    <=> ( v153518(VarCurr,2)
        | v153567(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20524,axiom,
    ! [VarCurr: state_type] :
      ( v153567(VarCurr)
    <=> ( v153568(VarCurr)
        & v153571(VarCurr) ) ) ).

tff(writeUnaryOperator_11738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153571(VarCurr)
    <=> v153518(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7323,axiom,
    ! [VarCurr: state_type] :
      ( v153568(VarCurr)
    <=> ( v153518(VarCurr,1)
        | v153569(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20523,axiom,
    ! [VarCurr: state_type] :
      ( v153569(VarCurr)
    <=> ( v153518(VarCurr,0)
        & v153570(VarCurr) ) ) ).

tff(writeUnaryOperator_11737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153570(VarCurr)
    <=> v153518(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2401,axiom,
    ! [VarCurr: state_type] :
      ( v153558(VarCurr)
    <=> ( ( v153518(VarCurr,4)
        <=> $false )
        & ( v153518(VarCurr,3)
        <=> $false )
        & ( v153518(VarCurr,2)
        <=> $false )
        & ( v153518(VarCurr,1)
        <=> $false )
        & ( v153518(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153555(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153554(VarCurr,B)
          <=> v153551(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1738,axiom,
    ! [VarCurr: state_type] :
      ( v153555(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153554(VarCurr,B)
          <=> v153549(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20522,axiom,
    ! [VarCurr: state_type] :
      ( v153555(VarCurr)
    <=> ( v153556(VarCurr)
        | v153544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20521,axiom,
    ! [VarCurr: state_type] :
      ( v153556(VarCurr)
    <=> ( v153547(VarCurr)
        & v153542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20520,axiom,
    ! [VarCurr: state_type] :
      ( v153553(VarCurr)
    <=> ( v153540(VarCurr)
        & v153453(VarCurr) ) ) ).

tff(addAssignment_85934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153551(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153549(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85932,axiom,
    ! [VarCurr: state_type] :
      ( v153547(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20519,axiom,
    ! [VarCurr: state_type] :
      ( v153540(VarCurr)
    <=> ( v153542(VarCurr)
        | v153544(VarCurr) ) ) ).

tff(addAssignment_85931,axiom,
    ! [VarCurr: state_type] :
      ( v153544(VarCurr)
    <=> v110563(VarCurr,10) ) ).

tff(addAssignment_85930,axiom,
    ! [VarCurr: state_type] :
      ( v153542(VarCurr)
    <=> v108901(VarCurr,10) ) ).

tff(addAssignment_85929,axiom,
    ! [VarCurr: state_type] :
      ( v153528(VarCurr)
    <=> v153530(VarCurr) ) ).

tff(addAssignment_85928,axiom,
    ! [VarCurr: state_type] :
      ( v153530(VarCurr)
    <=> v153434(VarCurr) ) ).

tff(addAssignment_85927,axiom,
    ! [VarCurr: state_type] :
      ( v153524(VarCurr)
    <=> v153526(VarCurr) ) ).

tff(addAssignment_85926,axiom,
    ! [VarCurr: state_type] :
      ( v153526(VarCurr)
    <=> v153426(VarCurr) ) ).

tff(addAssignment_85925,axiom,
    ! [VarCurr: state_type] :
      ( v153412(VarCurr)
    <=> v153414(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2400,axiom,
    ! [VarCurr: state_type] :
      ( v153414(VarCurr)
    <=> ( ( v153416(VarCurr,4)
        <=> $false )
        & ( v153416(VarCurr,3)
        <=> $false )
        & ( v153416(VarCurr,2)
        <=> $false )
        & ( v153416(VarCurr,1)
        <=> $false )
        & ( v153416(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153416(VarCurr,B)
      <=> v153418(VarCurr,B) ) ) ).

tff(addAssignment_85923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153418(VarCurr,B)
      <=> v153420(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153496(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153420(VarNext,B)
            <=> v153420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2285,axiom,
    ! [VarNext: state_type] :
      ( v153496(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153420(VarNext,B)
          <=> v153506(VarNext,B) ) ) ) ).

tff(addAssignment_85922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153506(VarNext,B)
          <=> v153504(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153507(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153504(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1737,axiom,
    ! [VarCurr: state_type] :
      ( v153507(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153504(VarCurr,B)
          <=> v153438(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20518,axiom,
    ! [VarCurr: state_type] :
      ( v153507(VarCurr)
    <=> ( v153508(VarCurr)
        & v153509(VarCurr) ) ) ).

tff(writeUnaryOperator_11736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153509(VarCurr)
    <=> v153430(VarCurr) ) ).

tff(writeUnaryOperator_11735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153508(VarCurr)
    <=> v153422(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153496(VarNext)
      <=> v153497(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153497(VarNext)
      <=> ( v153498(VarNext)
          & v153489(VarNext) ) ) ) ).

tff(writeUnaryOperator_11734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153498(VarNext)
      <=> v153500(VarNext) ) ) ).

tff(addAssignment_85921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153500(VarNext)
      <=> v153489(VarCurr) ) ) ).

tff(addAssignment_85920,axiom,
    ! [VarCurr: state_type] :
      ( v153489(VarCurr)
    <=> v153491(VarCurr) ) ).

tff(addAssignment_85919,axiom,
    ! [VarCurr: state_type] :
      ( v153491(VarCurr)
    <=> v153493(VarCurr) ) ).

tff(addAssignment_85918,axiom,
    ! [VarCurr: state_type] :
      ( v153493(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153438(VarCurr,B)
      <=> v153440(VarCurr,B) ) ) ).

tff(addAssignment_85916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153440(VarCurr,B)
      <=> v153442(VarCurr,B) ) ) ).

tff(addAssignment_85915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153442(VarCurr,B)
      <=> v153444(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153457(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153444(VarCurr,B)
          <=> v153458(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1736,axiom,
    ! [VarCurr: state_type] :
      ( v153457(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153444(VarCurr,B)
          <=> v153455(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153459(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153458(VarCurr,B)
          <=> v153460(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1735,axiom,
    ! [VarCurr: state_type] :
      ( v153459(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153458(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85914,axiom,
    ! [VarCurr: state_type] :
      ( v153460(VarCurr,0)
    <=> v153486(VarCurr) ) ).

tff(addAssignment_85913,axiom,
    ! [VarCurr: state_type] :
      ( v153460(VarCurr,1)
    <=> v153484(VarCurr) ) ).

tff(addAssignment_85912,axiom,
    ! [VarCurr: state_type] :
      ( v153460(VarCurr,2)
    <=> v153480(VarCurr) ) ).

tff(addAssignment_85911,axiom,
    ! [VarCurr: state_type] :
      ( v153460(VarCurr,3)
    <=> v153476(VarCurr) ) ).

tff(addAssignment_85910,axiom,
    ! [VarCurr: state_type] :
      ( v153460(VarCurr,4)
    <=> v153462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20515,axiom,
    ! [VarCurr: state_type] :
      ( v153484(VarCurr)
    <=> ( v153485(VarCurr)
        & v153487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20514,axiom,
    ! [VarCurr: state_type] :
      ( v153487(VarCurr)
    <=> ( v153416(VarCurr,0)
        | v153471(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7322,axiom,
    ! [VarCurr: state_type] :
      ( v153485(VarCurr)
    <=> ( v153486(VarCurr)
        | v153416(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153486(VarCurr)
    <=> v153416(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20513,axiom,
    ! [VarCurr: state_type] :
      ( v153480(VarCurr)
    <=> ( v153481(VarCurr)
        & v153483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20512,axiom,
    ! [VarCurr: state_type] :
      ( v153483(VarCurr)
    <=> ( v153469(VarCurr)
        | v153472(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7321,axiom,
    ! [VarCurr: state_type] :
      ( v153481(VarCurr)
    <=> ( v153482(VarCurr)
        | v153416(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153482(VarCurr)
    <=> v153469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20511,axiom,
    ! [VarCurr: state_type] :
      ( v153476(VarCurr)
    <=> ( v153477(VarCurr)
        & v153479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20510,axiom,
    ! [VarCurr: state_type] :
      ( v153479(VarCurr)
    <=> ( v153467(VarCurr)
        | v153473(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7320,axiom,
    ! [VarCurr: state_type] :
      ( v153477(VarCurr)
    <=> ( v153478(VarCurr)
        | v153416(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153478(VarCurr)
    <=> v153467(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20509,axiom,
    ! [VarCurr: state_type] :
      ( v153462(VarCurr)
    <=> ( v153463(VarCurr)
        & v153474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20508,axiom,
    ! [VarCurr: state_type] :
      ( v153474(VarCurr)
    <=> ( v153465(VarCurr)
        | v153475(VarCurr) ) ) ).

tff(writeUnaryOperator_11730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153475(VarCurr)
    <=> v153416(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7319,axiom,
    ! [VarCurr: state_type] :
      ( v153463(VarCurr)
    <=> ( v153464(VarCurr)
        | v153416(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153464(VarCurr)
    <=> v153465(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7318,axiom,
    ! [VarCurr: state_type] :
      ( v153465(VarCurr)
    <=> ( v153416(VarCurr,3)
        | v153466(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20507,axiom,
    ! [VarCurr: state_type] :
      ( v153466(VarCurr)
    <=> ( v153467(VarCurr)
        & v153473(VarCurr) ) ) ).

tff(writeUnaryOperator_11728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153473(VarCurr)
    <=> v153416(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7317,axiom,
    ! [VarCurr: state_type] :
      ( v153467(VarCurr)
    <=> ( v153416(VarCurr,2)
        | v153468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20506,axiom,
    ! [VarCurr: state_type] :
      ( v153468(VarCurr)
    <=> ( v153469(VarCurr)
        & v153472(VarCurr) ) ) ).

tff(writeUnaryOperator_11727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153472(VarCurr)
    <=> v153416(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7316,axiom,
    ! [VarCurr: state_type] :
      ( v153469(VarCurr)
    <=> ( v153416(VarCurr,1)
        | v153470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20505,axiom,
    ! [VarCurr: state_type] :
      ( v153470(VarCurr)
    <=> ( v153416(VarCurr,0)
        & v153471(VarCurr) ) ) ).

tff(writeUnaryOperator_11726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153471(VarCurr)
    <=> v153416(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2399,axiom,
    ! [VarCurr: state_type] :
      ( v153459(VarCurr)
    <=> ( ( v153416(VarCurr,4)
        <=> $false )
        & ( v153416(VarCurr,3)
        <=> $false )
        & ( v153416(VarCurr,2)
        <=> $false )
        & ( v153416(VarCurr,1)
        <=> $false )
        & ( v153416(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20504,axiom,
    ! [VarCurr: state_type] :
      ( v153457(VarCurr)
    <=> ( v153446(VarCurr)
        & v153453(VarCurr) ) ) ).

tff(addAssignment_85909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153455(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85908,axiom,
    ! [VarCurr: state_type] :
      ( v153453(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20503,axiom,
    ! [VarCurr: state_type] :
      ( v153446(VarCurr)
    <=> ( v153448(VarCurr)
        | v153450(VarCurr) ) ) ).

tff(addAssignment_85907,axiom,
    ! [VarCurr: state_type] :
      ( v153450(VarCurr)
    <=> v110583(VarCurr,10) ) ).

tff(addAssignment_85906,axiom,
    ! [VarCurr: state_type] :
      ( v153448(VarCurr)
    <=> v116(VarCurr,10) ) ).

tff(addAssignment_85905,axiom,
    ! [VarCurr: state_type] :
      ( v153430(VarCurr)
    <=> v153432(VarCurr) ) ).

tff(addAssignment_85904,axiom,
    ! [VarCurr: state_type] :
      ( v153432(VarCurr)
    <=> v153434(VarCurr) ) ).

tff(addAssignment_85903,axiom,
    ! [VarCurr: state_type] :
      ( v153434(VarCurr)
    <=> v153436(VarCurr) ) ).

tff(addAssignment_85902,axiom,
    ! [VarCurr: state_type] :
      ( v153436(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85901,axiom,
    ! [VarCurr: state_type] :
      ( v153422(VarCurr)
    <=> v153424(VarCurr) ) ).

tff(addAssignment_85900,axiom,
    ! [VarCurr: state_type] :
      ( v153424(VarCurr)
    <=> v153426(VarCurr) ) ).

tff(addAssignment_85899,axiom,
    ! [VarCurr: state_type] :
      ( v153426(VarCurr)
    <=> v153428(VarCurr) ) ).

tff(addAssignment_85898,axiom,
    ! [VarCurr: state_type] :
      ( v153428(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85897,axiom,
    ! [VarCurr: state_type] :
      ( v153315(VarCurr)
    <=> v153317(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2398,axiom,
    ! [VarCurr: state_type] :
      ( v153317(VarCurr)
    <=> ( ( v153319(VarCurr,4)
        <=> $false )
        & ( v153319(VarCurr,3)
        <=> $false )
        & ( v153319(VarCurr,2)
        <=> $false )
        & ( v153319(VarCurr,1)
        <=> $false )
        & ( v153319(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153319(VarCurr,B)
      <=> v153321(VarCurr,B) ) ) ).

tff(addAssignment_85895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153321(VarCurr,B)
      <=> v153323(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153394(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153323(VarNext,B)
            <=> v153323(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2284,axiom,
    ! [VarNext: state_type] :
      ( v153394(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153323(VarNext,B)
          <=> v153404(VarNext,B) ) ) ) ).

tff(addAssignment_85894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153404(VarNext,B)
          <=> v153402(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153405(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153402(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1734,axiom,
    ! [VarCurr: state_type] :
      ( v153405(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153402(VarCurr,B)
          <=> v153333(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20502,axiom,
    ! [VarCurr: state_type] :
      ( v153405(VarCurr)
    <=> ( v153406(VarCurr)
        & v153407(VarCurr) ) ) ).

tff(writeUnaryOperator_11725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153407(VarCurr)
    <=> v153329(VarCurr) ) ).

tff(writeUnaryOperator_11724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153406(VarCurr)
    <=> v153325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153394(VarNext)
      <=> v153395(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153395(VarNext)
      <=> ( v153396(VarNext)
          & v153389(VarNext) ) ) ) ).

tff(writeUnaryOperator_11723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153396(VarNext)
      <=> v153398(VarNext) ) ) ).

tff(addAssignment_85893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153398(VarNext)
      <=> v153389(VarCurr) ) ) ).

tff(addAssignment_85892,axiom,
    ! [VarCurr: state_type] :
      ( v153389(VarCurr)
    <=> v153391(VarCurr) ) ).

tff(addAssignment_85891,axiom,
    ! [VarCurr: state_type] :
      ( v153391(VarCurr)
    <=> v153294(VarCurr) ) ).

tff(addAssignment_85890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153333(VarCurr,B)
      <=> v153335(VarCurr,B) ) ) ).

tff(addAssignment_85889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153335(VarCurr,B)
      <=> v153337(VarCurr,B) ) ) ).

tff(addAssignment_85888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153337(VarCurr,B)
      <=> v153339(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153339(VarCurr,B)
          <=> v153358(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1733,axiom,
    ! [VarCurr: state_type] :
      ( v153354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153339(VarCurr,B)
          <=> v153355(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153358(VarCurr,B)
          <=> v153360(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1732,axiom,
    ! [VarCurr: state_type] :
      ( v153359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153358(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85887,axiom,
    ! [VarCurr: state_type] :
      ( v153360(VarCurr,0)
    <=> v153386(VarCurr) ) ).

tff(addAssignment_85886,axiom,
    ! [VarCurr: state_type] :
      ( v153360(VarCurr,1)
    <=> v153384(VarCurr) ) ).

tff(addAssignment_85885,axiom,
    ! [VarCurr: state_type] :
      ( v153360(VarCurr,2)
    <=> v153380(VarCurr) ) ).

tff(addAssignment_85884,axiom,
    ! [VarCurr: state_type] :
      ( v153360(VarCurr,3)
    <=> v153376(VarCurr) ) ).

tff(addAssignment_85883,axiom,
    ! [VarCurr: state_type] :
      ( v153360(VarCurr,4)
    <=> v153362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20499,axiom,
    ! [VarCurr: state_type] :
      ( v153384(VarCurr)
    <=> ( v153385(VarCurr)
        & v153387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20498,axiom,
    ! [VarCurr: state_type] :
      ( v153387(VarCurr)
    <=> ( v153319(VarCurr,0)
        | v153371(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7315,axiom,
    ! [VarCurr: state_type] :
      ( v153385(VarCurr)
    <=> ( v153386(VarCurr)
        | v153319(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153386(VarCurr)
    <=> v153319(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20497,axiom,
    ! [VarCurr: state_type] :
      ( v153380(VarCurr)
    <=> ( v153381(VarCurr)
        & v153383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20496,axiom,
    ! [VarCurr: state_type] :
      ( v153383(VarCurr)
    <=> ( v153369(VarCurr)
        | v153372(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7314,axiom,
    ! [VarCurr: state_type] :
      ( v153381(VarCurr)
    <=> ( v153382(VarCurr)
        | v153319(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153382(VarCurr)
    <=> v153369(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20495,axiom,
    ! [VarCurr: state_type] :
      ( v153376(VarCurr)
    <=> ( v153377(VarCurr)
        & v153379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20494,axiom,
    ! [VarCurr: state_type] :
      ( v153379(VarCurr)
    <=> ( v153367(VarCurr)
        | v153373(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7313,axiom,
    ! [VarCurr: state_type] :
      ( v153377(VarCurr)
    <=> ( v153378(VarCurr)
        | v153319(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153378(VarCurr)
    <=> v153367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20493,axiom,
    ! [VarCurr: state_type] :
      ( v153362(VarCurr)
    <=> ( v153363(VarCurr)
        & v153374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20492,axiom,
    ! [VarCurr: state_type] :
      ( v153374(VarCurr)
    <=> ( v153365(VarCurr)
        | v153375(VarCurr) ) ) ).

tff(writeUnaryOperator_11719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153375(VarCurr)
    <=> v153319(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7312,axiom,
    ! [VarCurr: state_type] :
      ( v153363(VarCurr)
    <=> ( v153364(VarCurr)
        | v153319(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153364(VarCurr)
    <=> v153365(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7311,axiom,
    ! [VarCurr: state_type] :
      ( v153365(VarCurr)
    <=> ( v153319(VarCurr,3)
        | v153366(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20491,axiom,
    ! [VarCurr: state_type] :
      ( v153366(VarCurr)
    <=> ( v153367(VarCurr)
        & v153373(VarCurr) ) ) ).

tff(writeUnaryOperator_11717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153373(VarCurr)
    <=> v153319(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7310,axiom,
    ! [VarCurr: state_type] :
      ( v153367(VarCurr)
    <=> ( v153319(VarCurr,2)
        | v153368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20490,axiom,
    ! [VarCurr: state_type] :
      ( v153368(VarCurr)
    <=> ( v153369(VarCurr)
        & v153372(VarCurr) ) ) ).

tff(writeUnaryOperator_11716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153372(VarCurr)
    <=> v153319(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7309,axiom,
    ! [VarCurr: state_type] :
      ( v153369(VarCurr)
    <=> ( v153319(VarCurr,1)
        | v153370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20489,axiom,
    ! [VarCurr: state_type] :
      ( v153370(VarCurr)
    <=> ( v153319(VarCurr,0)
        & v153371(VarCurr) ) ) ).

tff(writeUnaryOperator_11715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153371(VarCurr)
    <=> v153319(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2397,axiom,
    ! [VarCurr: state_type] :
      ( v153359(VarCurr)
    <=> ( ( v153319(VarCurr,4)
        <=> $false )
        & ( v153319(VarCurr,3)
        <=> $false )
        & ( v153319(VarCurr,2)
        <=> $false )
        & ( v153319(VarCurr,1)
        <=> $false )
        & ( v153319(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153356(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153355(VarCurr,B)
          <=> v153352(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1731,axiom,
    ! [VarCurr: state_type] :
      ( v153356(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153355(VarCurr,B)
          <=> v153350(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20488,axiom,
    ! [VarCurr: state_type] :
      ( v153356(VarCurr)
    <=> ( v153357(VarCurr)
        | v153345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20487,axiom,
    ! [VarCurr: state_type] :
      ( v153357(VarCurr)
    <=> ( v153348(VarCurr)
        & v153343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20486,axiom,
    ! [VarCurr: state_type] :
      ( v153354(VarCurr)
    <=> ( v153341(VarCurr)
        & v153254(VarCurr) ) ) ).

tff(addAssignment_85882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153352(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153350(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85880,axiom,
    ! [VarCurr: state_type] :
      ( v153348(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20485,axiom,
    ! [VarCurr: state_type] :
      ( v153341(VarCurr)
    <=> ( v153343(VarCurr)
        | v153345(VarCurr) ) ) ).

tff(addAssignment_85879,axiom,
    ! [VarCurr: state_type] :
      ( v153345(VarCurr)
    <=> v110563(VarCurr,9) ) ).

tff(addAssignment_85878,axiom,
    ! [VarCurr: state_type] :
      ( v153343(VarCurr)
    <=> v108901(VarCurr,9) ) ).

tff(addAssignment_85877,axiom,
    ! [VarCurr: state_type] :
      ( v153329(VarCurr)
    <=> v153331(VarCurr) ) ).

tff(addAssignment_85876,axiom,
    ! [VarCurr: state_type] :
      ( v153331(VarCurr)
    <=> v153235(VarCurr) ) ).

tff(addAssignment_85875,axiom,
    ! [VarCurr: state_type] :
      ( v153325(VarCurr)
    <=> v153327(VarCurr) ) ).

tff(addAssignment_85874,axiom,
    ! [VarCurr: state_type] :
      ( v153327(VarCurr)
    <=> v153227(VarCurr) ) ).

tff(addAssignment_85873,axiom,
    ! [VarCurr: state_type] :
      ( v153213(VarCurr)
    <=> v153215(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2396,axiom,
    ! [VarCurr: state_type] :
      ( v153215(VarCurr)
    <=> ( ( v153217(VarCurr,4)
        <=> $false )
        & ( v153217(VarCurr,3)
        <=> $false )
        & ( v153217(VarCurr,2)
        <=> $false )
        & ( v153217(VarCurr,1)
        <=> $false )
        & ( v153217(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153217(VarCurr,B)
      <=> v153219(VarCurr,B) ) ) ).

tff(addAssignment_85871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153219(VarCurr,B)
      <=> v153221(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153297(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153221(VarNext,B)
            <=> v153221(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2283,axiom,
    ! [VarNext: state_type] :
      ( v153297(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153221(VarNext,B)
          <=> v153307(VarNext,B) ) ) ) ).

tff(addAssignment_85870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153307(VarNext,B)
          <=> v153305(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153308(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153305(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1730,axiom,
    ! [VarCurr: state_type] :
      ( v153308(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153305(VarCurr,B)
          <=> v153239(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20484,axiom,
    ! [VarCurr: state_type] :
      ( v153308(VarCurr)
    <=> ( v153309(VarCurr)
        & v153310(VarCurr) ) ) ).

tff(writeUnaryOperator_11714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153310(VarCurr)
    <=> v153231(VarCurr) ) ).

tff(writeUnaryOperator_11713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153309(VarCurr)
    <=> v153223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153297(VarNext)
      <=> v153298(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153298(VarNext)
      <=> ( v153299(VarNext)
          & v153290(VarNext) ) ) ) ).

tff(writeUnaryOperator_11712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153299(VarNext)
      <=> v153301(VarNext) ) ) ).

tff(addAssignment_85869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153301(VarNext)
      <=> v153290(VarCurr) ) ) ).

tff(addAssignment_85868,axiom,
    ! [VarCurr: state_type] :
      ( v153290(VarCurr)
    <=> v153292(VarCurr) ) ).

tff(addAssignment_85867,axiom,
    ! [VarCurr: state_type] :
      ( v153292(VarCurr)
    <=> v153294(VarCurr) ) ).

tff(addAssignment_85866,axiom,
    ! [VarCurr: state_type] :
      ( v153294(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153239(VarCurr,B)
      <=> v153241(VarCurr,B) ) ) ).

tff(addAssignment_85864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153241(VarCurr,B)
      <=> v153243(VarCurr,B) ) ) ).

tff(addAssignment_85863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153243(VarCurr,B)
      <=> v153245(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153258(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153245(VarCurr,B)
          <=> v153259(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1729,axiom,
    ! [VarCurr: state_type] :
      ( v153258(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153245(VarCurr,B)
          <=> v153256(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153260(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153259(VarCurr,B)
          <=> v153261(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1728,axiom,
    ! [VarCurr: state_type] :
      ( v153260(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153259(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85862,axiom,
    ! [VarCurr: state_type] :
      ( v153261(VarCurr,0)
    <=> v153287(VarCurr) ) ).

tff(addAssignment_85861,axiom,
    ! [VarCurr: state_type] :
      ( v153261(VarCurr,1)
    <=> v153285(VarCurr) ) ).

tff(addAssignment_85860,axiom,
    ! [VarCurr: state_type] :
      ( v153261(VarCurr,2)
    <=> v153281(VarCurr) ) ).

tff(addAssignment_85859,axiom,
    ! [VarCurr: state_type] :
      ( v153261(VarCurr,3)
    <=> v153277(VarCurr) ) ).

tff(addAssignment_85858,axiom,
    ! [VarCurr: state_type] :
      ( v153261(VarCurr,4)
    <=> v153263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20481,axiom,
    ! [VarCurr: state_type] :
      ( v153285(VarCurr)
    <=> ( v153286(VarCurr)
        & v153288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20480,axiom,
    ! [VarCurr: state_type] :
      ( v153288(VarCurr)
    <=> ( v153217(VarCurr,0)
        | v153272(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7308,axiom,
    ! [VarCurr: state_type] :
      ( v153286(VarCurr)
    <=> ( v153287(VarCurr)
        | v153217(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153287(VarCurr)
    <=> v153217(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20479,axiom,
    ! [VarCurr: state_type] :
      ( v153281(VarCurr)
    <=> ( v153282(VarCurr)
        & v153284(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20478,axiom,
    ! [VarCurr: state_type] :
      ( v153284(VarCurr)
    <=> ( v153270(VarCurr)
        | v153273(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7307,axiom,
    ! [VarCurr: state_type] :
      ( v153282(VarCurr)
    <=> ( v153283(VarCurr)
        | v153217(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153283(VarCurr)
    <=> v153270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20477,axiom,
    ! [VarCurr: state_type] :
      ( v153277(VarCurr)
    <=> ( v153278(VarCurr)
        & v153280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20476,axiom,
    ! [VarCurr: state_type] :
      ( v153280(VarCurr)
    <=> ( v153268(VarCurr)
        | v153274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7306,axiom,
    ! [VarCurr: state_type] :
      ( v153278(VarCurr)
    <=> ( v153279(VarCurr)
        | v153217(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153279(VarCurr)
    <=> v153268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20475,axiom,
    ! [VarCurr: state_type] :
      ( v153263(VarCurr)
    <=> ( v153264(VarCurr)
        & v153275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20474,axiom,
    ! [VarCurr: state_type] :
      ( v153275(VarCurr)
    <=> ( v153266(VarCurr)
        | v153276(VarCurr) ) ) ).

tff(writeUnaryOperator_11708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153276(VarCurr)
    <=> v153217(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7305,axiom,
    ! [VarCurr: state_type] :
      ( v153264(VarCurr)
    <=> ( v153265(VarCurr)
        | v153217(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153265(VarCurr)
    <=> v153266(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7304,axiom,
    ! [VarCurr: state_type] :
      ( v153266(VarCurr)
    <=> ( v153217(VarCurr,3)
        | v153267(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20473,axiom,
    ! [VarCurr: state_type] :
      ( v153267(VarCurr)
    <=> ( v153268(VarCurr)
        & v153274(VarCurr) ) ) ).

tff(writeUnaryOperator_11706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153274(VarCurr)
    <=> v153217(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7303,axiom,
    ! [VarCurr: state_type] :
      ( v153268(VarCurr)
    <=> ( v153217(VarCurr,2)
        | v153269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20472,axiom,
    ! [VarCurr: state_type] :
      ( v153269(VarCurr)
    <=> ( v153270(VarCurr)
        & v153273(VarCurr) ) ) ).

tff(writeUnaryOperator_11705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153273(VarCurr)
    <=> v153217(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7302,axiom,
    ! [VarCurr: state_type] :
      ( v153270(VarCurr)
    <=> ( v153217(VarCurr,1)
        | v153271(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20471,axiom,
    ! [VarCurr: state_type] :
      ( v153271(VarCurr)
    <=> ( v153217(VarCurr,0)
        & v153272(VarCurr) ) ) ).

tff(writeUnaryOperator_11704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153272(VarCurr)
    <=> v153217(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2395,axiom,
    ! [VarCurr: state_type] :
      ( v153260(VarCurr)
    <=> ( ( v153217(VarCurr,4)
        <=> $false )
        & ( v153217(VarCurr,3)
        <=> $false )
        & ( v153217(VarCurr,2)
        <=> $false )
        & ( v153217(VarCurr,1)
        <=> $false )
        & ( v153217(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20470,axiom,
    ! [VarCurr: state_type] :
      ( v153258(VarCurr)
    <=> ( v153247(VarCurr)
        & v153254(VarCurr) ) ) ).

tff(addAssignment_85857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153256(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85856,axiom,
    ! [VarCurr: state_type] :
      ( v153254(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20469,axiom,
    ! [VarCurr: state_type] :
      ( v153247(VarCurr)
    <=> ( v153249(VarCurr)
        | v153251(VarCurr) ) ) ).

tff(addAssignment_85855,axiom,
    ! [VarCurr: state_type] :
      ( v153251(VarCurr)
    <=> v110583(VarCurr,9) ) ).

tff(addAssignment_85854,axiom,
    ! [VarCurr: state_type] :
      ( v153249(VarCurr)
    <=> v116(VarCurr,9) ) ).

tff(addAssignment_85853,axiom,
    ! [VarCurr: state_type] :
      ( v153231(VarCurr)
    <=> v153233(VarCurr) ) ).

tff(addAssignment_85852,axiom,
    ! [VarCurr: state_type] :
      ( v153233(VarCurr)
    <=> v153235(VarCurr) ) ).

tff(addAssignment_85851,axiom,
    ! [VarCurr: state_type] :
      ( v153235(VarCurr)
    <=> v153237(VarCurr) ) ).

tff(addAssignment_85850,axiom,
    ! [VarCurr: state_type] :
      ( v153237(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85849,axiom,
    ! [VarCurr: state_type] :
      ( v153223(VarCurr)
    <=> v153225(VarCurr) ) ).

tff(addAssignment_85848,axiom,
    ! [VarCurr: state_type] :
      ( v153225(VarCurr)
    <=> v153227(VarCurr) ) ).

tff(addAssignment_85847,axiom,
    ! [VarCurr: state_type] :
      ( v153227(VarCurr)
    <=> v153229(VarCurr) ) ).

tff(addAssignment_85846,axiom,
    ! [VarCurr: state_type] :
      ( v153229(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85845,axiom,
    ! [VarCurr: state_type] :
      ( v153116(VarCurr)
    <=> v153118(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2394,axiom,
    ! [VarCurr: state_type] :
      ( v153118(VarCurr)
    <=> ( ( v153120(VarCurr,4)
        <=> $false )
        & ( v153120(VarCurr,3)
        <=> $false )
        & ( v153120(VarCurr,2)
        <=> $false )
        & ( v153120(VarCurr,1)
        <=> $false )
        & ( v153120(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153120(VarCurr,B)
      <=> v153122(VarCurr,B) ) ) ).

tff(addAssignment_85843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153122(VarCurr,B)
      <=> v153124(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153195(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153124(VarNext,B)
            <=> v153124(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2282,axiom,
    ! [VarNext: state_type] :
      ( v153195(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153124(VarNext,B)
          <=> v153205(VarNext,B) ) ) ) ).

tff(addAssignment_85842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153205(VarNext,B)
          <=> v153203(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153206(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153203(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1727,axiom,
    ! [VarCurr: state_type] :
      ( v153206(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153203(VarCurr,B)
          <=> v153134(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20468,axiom,
    ! [VarCurr: state_type] :
      ( v153206(VarCurr)
    <=> ( v153207(VarCurr)
        & v153208(VarCurr) ) ) ).

tff(writeUnaryOperator_11703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153208(VarCurr)
    <=> v153130(VarCurr) ) ).

tff(writeUnaryOperator_11702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153207(VarCurr)
    <=> v153126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153195(VarNext)
      <=> v153196(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153196(VarNext)
      <=> ( v153197(VarNext)
          & v153190(VarNext) ) ) ) ).

tff(writeUnaryOperator_11701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153197(VarNext)
      <=> v153199(VarNext) ) ) ).

tff(addAssignment_85841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153199(VarNext)
      <=> v153190(VarCurr) ) ) ).

tff(addAssignment_85840,axiom,
    ! [VarCurr: state_type] :
      ( v153190(VarCurr)
    <=> v153192(VarCurr) ) ).

tff(addAssignment_85839,axiom,
    ! [VarCurr: state_type] :
      ( v153192(VarCurr)
    <=> v153095(VarCurr) ) ).

tff(addAssignment_85838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153134(VarCurr,B)
      <=> v153136(VarCurr,B) ) ) ).

tff(addAssignment_85837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153136(VarCurr,B)
      <=> v153138(VarCurr,B) ) ) ).

tff(addAssignment_85836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153138(VarCurr,B)
      <=> v153140(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153155(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153140(VarCurr,B)
          <=> v153159(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1726,axiom,
    ! [VarCurr: state_type] :
      ( v153155(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153140(VarCurr,B)
          <=> v153156(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153160(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153159(VarCurr,B)
          <=> v153161(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1725,axiom,
    ! [VarCurr: state_type] :
      ( v153160(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153159(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85835,axiom,
    ! [VarCurr: state_type] :
      ( v153161(VarCurr,0)
    <=> v153187(VarCurr) ) ).

tff(addAssignment_85834,axiom,
    ! [VarCurr: state_type] :
      ( v153161(VarCurr,1)
    <=> v153185(VarCurr) ) ).

tff(addAssignment_85833,axiom,
    ! [VarCurr: state_type] :
      ( v153161(VarCurr,2)
    <=> v153181(VarCurr) ) ).

tff(addAssignment_85832,axiom,
    ! [VarCurr: state_type] :
      ( v153161(VarCurr,3)
    <=> v153177(VarCurr) ) ).

tff(addAssignment_85831,axiom,
    ! [VarCurr: state_type] :
      ( v153161(VarCurr,4)
    <=> v153163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20465,axiom,
    ! [VarCurr: state_type] :
      ( v153185(VarCurr)
    <=> ( v153186(VarCurr)
        & v153188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20464,axiom,
    ! [VarCurr: state_type] :
      ( v153188(VarCurr)
    <=> ( v153120(VarCurr,0)
        | v153172(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7301,axiom,
    ! [VarCurr: state_type] :
      ( v153186(VarCurr)
    <=> ( v153187(VarCurr)
        | v153120(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153187(VarCurr)
    <=> v153120(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20463,axiom,
    ! [VarCurr: state_type] :
      ( v153181(VarCurr)
    <=> ( v153182(VarCurr)
        & v153184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20462,axiom,
    ! [VarCurr: state_type] :
      ( v153184(VarCurr)
    <=> ( v153170(VarCurr)
        | v153173(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7300,axiom,
    ! [VarCurr: state_type] :
      ( v153182(VarCurr)
    <=> ( v153183(VarCurr)
        | v153120(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153183(VarCurr)
    <=> v153170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20461,axiom,
    ! [VarCurr: state_type] :
      ( v153177(VarCurr)
    <=> ( v153178(VarCurr)
        & v153180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20460,axiom,
    ! [VarCurr: state_type] :
      ( v153180(VarCurr)
    <=> ( v153168(VarCurr)
        | v153174(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7299,axiom,
    ! [VarCurr: state_type] :
      ( v153178(VarCurr)
    <=> ( v153179(VarCurr)
        | v153120(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153179(VarCurr)
    <=> v153168(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20459,axiom,
    ! [VarCurr: state_type] :
      ( v153163(VarCurr)
    <=> ( v153164(VarCurr)
        & v153175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20458,axiom,
    ! [VarCurr: state_type] :
      ( v153175(VarCurr)
    <=> ( v153166(VarCurr)
        | v153176(VarCurr) ) ) ).

tff(writeUnaryOperator_11697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153176(VarCurr)
    <=> v153120(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7298,axiom,
    ! [VarCurr: state_type] :
      ( v153164(VarCurr)
    <=> ( v153165(VarCurr)
        | v153120(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153165(VarCurr)
    <=> v153166(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7297,axiom,
    ! [VarCurr: state_type] :
      ( v153166(VarCurr)
    <=> ( v153120(VarCurr,3)
        | v153167(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20457,axiom,
    ! [VarCurr: state_type] :
      ( v153167(VarCurr)
    <=> ( v153168(VarCurr)
        & v153174(VarCurr) ) ) ).

tff(writeUnaryOperator_11695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153174(VarCurr)
    <=> v153120(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7296,axiom,
    ! [VarCurr: state_type] :
      ( v153168(VarCurr)
    <=> ( v153120(VarCurr,2)
        | v153169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20456,axiom,
    ! [VarCurr: state_type] :
      ( v153169(VarCurr)
    <=> ( v153170(VarCurr)
        & v153173(VarCurr) ) ) ).

tff(writeUnaryOperator_11694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153173(VarCurr)
    <=> v153120(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7295,axiom,
    ! [VarCurr: state_type] :
      ( v153170(VarCurr)
    <=> ( v153120(VarCurr,1)
        | v153171(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20455,axiom,
    ! [VarCurr: state_type] :
      ( v153171(VarCurr)
    <=> ( v153120(VarCurr,0)
        & v153172(VarCurr) ) ) ).

tff(writeUnaryOperator_11693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153172(VarCurr)
    <=> v153120(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2393,axiom,
    ! [VarCurr: state_type] :
      ( v153160(VarCurr)
    <=> ( ( v153120(VarCurr,4)
        <=> $false )
        & ( v153120(VarCurr,3)
        <=> $false )
        & ( v153120(VarCurr,2)
        <=> $false )
        & ( v153120(VarCurr,1)
        <=> $false )
        & ( v153120(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153157(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153156(VarCurr,B)
          <=> v153153(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1724,axiom,
    ! [VarCurr: state_type] :
      ( v153157(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153156(VarCurr,B)
          <=> v153151(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20454,axiom,
    ! [VarCurr: state_type] :
      ( v153157(VarCurr)
    <=> ( v153158(VarCurr)
        | v153146(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20453,axiom,
    ! [VarCurr: state_type] :
      ( v153158(VarCurr)
    <=> ( v153149(VarCurr)
        & v153144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20452,axiom,
    ! [VarCurr: state_type] :
      ( v153155(VarCurr)
    <=> ( v153142(VarCurr)
        & v153055(VarCurr) ) ) ).

tff(addAssignment_85830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153153(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153151(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85828,axiom,
    ! [VarCurr: state_type] :
      ( v153149(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20451,axiom,
    ! [VarCurr: state_type] :
      ( v153142(VarCurr)
    <=> ( v153144(VarCurr)
        | v153146(VarCurr) ) ) ).

tff(addAssignment_85827,axiom,
    ! [VarCurr: state_type] :
      ( v153146(VarCurr)
    <=> v110563(VarCurr,8) ) ).

tff(addAssignment_85826,axiom,
    ! [VarCurr: state_type] :
      ( v153144(VarCurr)
    <=> v108901(VarCurr,8) ) ).

tff(addAssignment_85825,axiom,
    ! [VarCurr: state_type] :
      ( v153130(VarCurr)
    <=> v153132(VarCurr) ) ).

tff(addAssignment_85824,axiom,
    ! [VarCurr: state_type] :
      ( v153132(VarCurr)
    <=> v153036(VarCurr) ) ).

tff(addAssignment_85823,axiom,
    ! [VarCurr: state_type] :
      ( v153126(VarCurr)
    <=> v153128(VarCurr) ) ).

tff(addAssignment_85822,axiom,
    ! [VarCurr: state_type] :
      ( v153128(VarCurr)
    <=> v153028(VarCurr) ) ).

tff(addAssignment_85821,axiom,
    ! [VarCurr: state_type] :
      ( v153014(VarCurr)
    <=> v153016(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2392,axiom,
    ! [VarCurr: state_type] :
      ( v153016(VarCurr)
    <=> ( ( v153018(VarCurr,4)
        <=> $false )
        & ( v153018(VarCurr,3)
        <=> $false )
        & ( v153018(VarCurr,2)
        <=> $false )
        & ( v153018(VarCurr,1)
        <=> $false )
        & ( v153018(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153018(VarCurr,B)
      <=> v153020(VarCurr,B) ) ) ).

tff(addAssignment_85819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153020(VarCurr,B)
      <=> v153022(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153098(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v153022(VarNext,B)
            <=> v153022(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2281,axiom,
    ! [VarNext: state_type] :
      ( v153098(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153022(VarNext,B)
          <=> v153108(VarNext,B) ) ) ) ).

tff(addAssignment_85818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153108(VarNext,B)
          <=> v153106(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153109(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153106(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1723,axiom,
    ! [VarCurr: state_type] :
      ( v153109(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153106(VarCurr,B)
          <=> v153040(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20450,axiom,
    ! [VarCurr: state_type] :
      ( v153109(VarCurr)
    <=> ( v153110(VarCurr)
        & v153111(VarCurr) ) ) ).

tff(writeUnaryOperator_11692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153111(VarCurr)
    <=> v153032(VarCurr) ) ).

tff(writeUnaryOperator_11691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153110(VarCurr)
    <=> v153024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153098(VarNext)
      <=> v153099(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153099(VarNext)
      <=> ( v153100(VarNext)
          & v153091(VarNext) ) ) ) ).

tff(writeUnaryOperator_11690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v153100(VarNext)
      <=> v153102(VarNext) ) ) ).

tff(addAssignment_85817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153102(VarNext)
      <=> v153091(VarCurr) ) ) ).

tff(addAssignment_85816,axiom,
    ! [VarCurr: state_type] :
      ( v153091(VarCurr)
    <=> v153093(VarCurr) ) ).

tff(addAssignment_85815,axiom,
    ! [VarCurr: state_type] :
      ( v153093(VarCurr)
    <=> v153095(VarCurr) ) ).

tff(addAssignment_85814,axiom,
    ! [VarCurr: state_type] :
      ( v153095(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153040(VarCurr,B)
      <=> v153042(VarCurr,B) ) ) ).

tff(addAssignment_85812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153042(VarCurr,B)
      <=> v153044(VarCurr,B) ) ) ).

tff(addAssignment_85811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153044(VarCurr,B)
      <=> v153046(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153046(VarCurr,B)
          <=> v153060(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1722,axiom,
    ! [VarCurr: state_type] :
      ( v153059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153046(VarCurr,B)
          <=> v153057(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153061(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153060(VarCurr,B)
          <=> v153062(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1721,axiom,
    ! [VarCurr: state_type] :
      ( v153061(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153060(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85810,axiom,
    ! [VarCurr: state_type] :
      ( v153062(VarCurr,0)
    <=> v153088(VarCurr) ) ).

tff(addAssignment_85809,axiom,
    ! [VarCurr: state_type] :
      ( v153062(VarCurr,1)
    <=> v153086(VarCurr) ) ).

tff(addAssignment_85808,axiom,
    ! [VarCurr: state_type] :
      ( v153062(VarCurr,2)
    <=> v153082(VarCurr) ) ).

tff(addAssignment_85807,axiom,
    ! [VarCurr: state_type] :
      ( v153062(VarCurr,3)
    <=> v153078(VarCurr) ) ).

tff(addAssignment_85806,axiom,
    ! [VarCurr: state_type] :
      ( v153062(VarCurr,4)
    <=> v153064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20447,axiom,
    ! [VarCurr: state_type] :
      ( v153086(VarCurr)
    <=> ( v153087(VarCurr)
        & v153089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20446,axiom,
    ! [VarCurr: state_type] :
      ( v153089(VarCurr)
    <=> ( v153018(VarCurr,0)
        | v153073(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7294,axiom,
    ! [VarCurr: state_type] :
      ( v153087(VarCurr)
    <=> ( v153088(VarCurr)
        | v153018(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153088(VarCurr)
    <=> v153018(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20445,axiom,
    ! [VarCurr: state_type] :
      ( v153082(VarCurr)
    <=> ( v153083(VarCurr)
        & v153085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20444,axiom,
    ! [VarCurr: state_type] :
      ( v153085(VarCurr)
    <=> ( v153071(VarCurr)
        | v153074(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7293,axiom,
    ! [VarCurr: state_type] :
      ( v153083(VarCurr)
    <=> ( v153084(VarCurr)
        | v153018(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153084(VarCurr)
    <=> v153071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20443,axiom,
    ! [VarCurr: state_type] :
      ( v153078(VarCurr)
    <=> ( v153079(VarCurr)
        & v153081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20442,axiom,
    ! [VarCurr: state_type] :
      ( v153081(VarCurr)
    <=> ( v153069(VarCurr)
        | v153075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7292,axiom,
    ! [VarCurr: state_type] :
      ( v153079(VarCurr)
    <=> ( v153080(VarCurr)
        | v153018(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153080(VarCurr)
    <=> v153069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20441,axiom,
    ! [VarCurr: state_type] :
      ( v153064(VarCurr)
    <=> ( v153065(VarCurr)
        & v153076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20440,axiom,
    ! [VarCurr: state_type] :
      ( v153076(VarCurr)
    <=> ( v153067(VarCurr)
        | v153077(VarCurr) ) ) ).

tff(writeUnaryOperator_11686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153077(VarCurr)
    <=> v153018(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7291,axiom,
    ! [VarCurr: state_type] :
      ( v153065(VarCurr)
    <=> ( v153066(VarCurr)
        | v153018(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153066(VarCurr)
    <=> v153067(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7290,axiom,
    ! [VarCurr: state_type] :
      ( v153067(VarCurr)
    <=> ( v153018(VarCurr,3)
        | v153068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20439,axiom,
    ! [VarCurr: state_type] :
      ( v153068(VarCurr)
    <=> ( v153069(VarCurr)
        & v153075(VarCurr) ) ) ).

tff(writeUnaryOperator_11684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153075(VarCurr)
    <=> v153018(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7289,axiom,
    ! [VarCurr: state_type] :
      ( v153069(VarCurr)
    <=> ( v153018(VarCurr,2)
        | v153070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20438,axiom,
    ! [VarCurr: state_type] :
      ( v153070(VarCurr)
    <=> ( v153071(VarCurr)
        & v153074(VarCurr) ) ) ).

tff(writeUnaryOperator_11683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153074(VarCurr)
    <=> v153018(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7288,axiom,
    ! [VarCurr: state_type] :
      ( v153071(VarCurr)
    <=> ( v153018(VarCurr,1)
        | v153072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20437,axiom,
    ! [VarCurr: state_type] :
      ( v153072(VarCurr)
    <=> ( v153018(VarCurr,0)
        & v153073(VarCurr) ) ) ).

tff(writeUnaryOperator_11682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153073(VarCurr)
    <=> v153018(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2391,axiom,
    ! [VarCurr: state_type] :
      ( v153061(VarCurr)
    <=> ( ( v153018(VarCurr,4)
        <=> $false )
        & ( v153018(VarCurr,3)
        <=> $false )
        & ( v153018(VarCurr,2)
        <=> $false )
        & ( v153018(VarCurr,1)
        <=> $false )
        & ( v153018(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20436,axiom,
    ! [VarCurr: state_type] :
      ( v153059(VarCurr)
    <=> ( v153048(VarCurr)
        & v153055(VarCurr) ) ) ).

tff(addAssignment_85805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v153057(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85804,axiom,
    ! [VarCurr: state_type] :
      ( v153055(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20435,axiom,
    ! [VarCurr: state_type] :
      ( v153048(VarCurr)
    <=> ( v153050(VarCurr)
        | v153052(VarCurr) ) ) ).

tff(addAssignment_85803,axiom,
    ! [VarCurr: state_type] :
      ( v153052(VarCurr)
    <=> v110583(VarCurr,8) ) ).

tff(addAssignment_85802,axiom,
    ! [VarCurr: state_type] :
      ( v153050(VarCurr)
    <=> v116(VarCurr,8) ) ).

tff(addAssignment_85801,axiom,
    ! [VarCurr: state_type] :
      ( v153032(VarCurr)
    <=> v153034(VarCurr) ) ).

tff(addAssignment_85800,axiom,
    ! [VarCurr: state_type] :
      ( v153034(VarCurr)
    <=> v153036(VarCurr) ) ).

tff(addAssignment_85799,axiom,
    ! [VarCurr: state_type] :
      ( v153036(VarCurr)
    <=> v153038(VarCurr) ) ).

tff(addAssignment_85798,axiom,
    ! [VarCurr: state_type] :
      ( v153038(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85797,axiom,
    ! [VarCurr: state_type] :
      ( v153024(VarCurr)
    <=> v153026(VarCurr) ) ).

tff(addAssignment_85796,axiom,
    ! [VarCurr: state_type] :
      ( v153026(VarCurr)
    <=> v153028(VarCurr) ) ).

tff(addAssignment_85795,axiom,
    ! [VarCurr: state_type] :
      ( v153028(VarCurr)
    <=> v153030(VarCurr) ) ).

tff(addAssignment_85794,axiom,
    ! [VarCurr: state_type] :
      ( v153030(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85793,axiom,
    ! [VarCurr: state_type] :
      ( v152917(VarCurr)
    <=> v152919(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2390,axiom,
    ! [VarCurr: state_type] :
      ( v152919(VarCurr)
    <=> ( ( v152921(VarCurr,4)
        <=> $false )
        & ( v152921(VarCurr,3)
        <=> $false )
        & ( v152921(VarCurr,2)
        <=> $false )
        & ( v152921(VarCurr,1)
        <=> $false )
        & ( v152921(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152921(VarCurr,B)
      <=> v152923(VarCurr,B) ) ) ).

tff(addAssignment_85791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152923(VarCurr,B)
      <=> v152925(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152996(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152925(VarNext,B)
            <=> v152925(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2280,axiom,
    ! [VarNext: state_type] :
      ( v152996(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152925(VarNext,B)
          <=> v153006(VarNext,B) ) ) ) ).

tff(addAssignment_85790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153006(VarNext,B)
          <=> v153004(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153007(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153004(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1720,axiom,
    ! [VarCurr: state_type] :
      ( v153007(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v153004(VarCurr,B)
          <=> v152935(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20434,axiom,
    ! [VarCurr: state_type] :
      ( v153007(VarCurr)
    <=> ( v153008(VarCurr)
        & v153009(VarCurr) ) ) ).

tff(writeUnaryOperator_11681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153009(VarCurr)
    <=> v152931(VarCurr) ) ).

tff(writeUnaryOperator_11680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v153008(VarCurr)
    <=> v152927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152996(VarNext)
      <=> v152997(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152997(VarNext)
      <=> ( v152998(VarNext)
          & v152991(VarNext) ) ) ) ).

tff(writeUnaryOperator_11679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152998(VarNext)
      <=> v153000(VarNext) ) ) ).

tff(addAssignment_85789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v153000(VarNext)
      <=> v152991(VarCurr) ) ) ).

tff(addAssignment_85788,axiom,
    ! [VarCurr: state_type] :
      ( v152991(VarCurr)
    <=> v152993(VarCurr) ) ).

tff(addAssignment_85787,axiom,
    ! [VarCurr: state_type] :
      ( v152993(VarCurr)
    <=> v152896(VarCurr) ) ).

tff(addAssignment_85786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152935(VarCurr,B)
      <=> v152937(VarCurr,B) ) ) ).

tff(addAssignment_85785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152937(VarCurr,B)
      <=> v152939(VarCurr,B) ) ) ).

tff(addAssignment_85784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152939(VarCurr,B)
      <=> v152941(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152941(VarCurr,B)
          <=> v152960(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1719,axiom,
    ! [VarCurr: state_type] :
      ( v152956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152941(VarCurr,B)
          <=> v152957(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152960(VarCurr,B)
          <=> v152962(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1718,axiom,
    ! [VarCurr: state_type] :
      ( v152961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152960(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85783,axiom,
    ! [VarCurr: state_type] :
      ( v152962(VarCurr,0)
    <=> v152988(VarCurr) ) ).

tff(addAssignment_85782,axiom,
    ! [VarCurr: state_type] :
      ( v152962(VarCurr,1)
    <=> v152986(VarCurr) ) ).

tff(addAssignment_85781,axiom,
    ! [VarCurr: state_type] :
      ( v152962(VarCurr,2)
    <=> v152982(VarCurr) ) ).

tff(addAssignment_85780,axiom,
    ! [VarCurr: state_type] :
      ( v152962(VarCurr,3)
    <=> v152978(VarCurr) ) ).

tff(addAssignment_85779,axiom,
    ! [VarCurr: state_type] :
      ( v152962(VarCurr,4)
    <=> v152964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20431,axiom,
    ! [VarCurr: state_type] :
      ( v152986(VarCurr)
    <=> ( v152987(VarCurr)
        & v152989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20430,axiom,
    ! [VarCurr: state_type] :
      ( v152989(VarCurr)
    <=> ( v152921(VarCurr,0)
        | v152973(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7287,axiom,
    ! [VarCurr: state_type] :
      ( v152987(VarCurr)
    <=> ( v152988(VarCurr)
        | v152921(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152988(VarCurr)
    <=> v152921(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20429,axiom,
    ! [VarCurr: state_type] :
      ( v152982(VarCurr)
    <=> ( v152983(VarCurr)
        & v152985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20428,axiom,
    ! [VarCurr: state_type] :
      ( v152985(VarCurr)
    <=> ( v152971(VarCurr)
        | v152974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7286,axiom,
    ! [VarCurr: state_type] :
      ( v152983(VarCurr)
    <=> ( v152984(VarCurr)
        | v152921(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152984(VarCurr)
    <=> v152971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20427,axiom,
    ! [VarCurr: state_type] :
      ( v152978(VarCurr)
    <=> ( v152979(VarCurr)
        & v152981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20426,axiom,
    ! [VarCurr: state_type] :
      ( v152981(VarCurr)
    <=> ( v152969(VarCurr)
        | v152975(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7285,axiom,
    ! [VarCurr: state_type] :
      ( v152979(VarCurr)
    <=> ( v152980(VarCurr)
        | v152921(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152980(VarCurr)
    <=> v152969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20425,axiom,
    ! [VarCurr: state_type] :
      ( v152964(VarCurr)
    <=> ( v152965(VarCurr)
        & v152976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20424,axiom,
    ! [VarCurr: state_type] :
      ( v152976(VarCurr)
    <=> ( v152967(VarCurr)
        | v152977(VarCurr) ) ) ).

tff(writeUnaryOperator_11675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152977(VarCurr)
    <=> v152921(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7284,axiom,
    ! [VarCurr: state_type] :
      ( v152965(VarCurr)
    <=> ( v152966(VarCurr)
        | v152921(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152966(VarCurr)
    <=> v152967(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7283,axiom,
    ! [VarCurr: state_type] :
      ( v152967(VarCurr)
    <=> ( v152921(VarCurr,3)
        | v152968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20423,axiom,
    ! [VarCurr: state_type] :
      ( v152968(VarCurr)
    <=> ( v152969(VarCurr)
        & v152975(VarCurr) ) ) ).

tff(writeUnaryOperator_11673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152975(VarCurr)
    <=> v152921(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7282,axiom,
    ! [VarCurr: state_type] :
      ( v152969(VarCurr)
    <=> ( v152921(VarCurr,2)
        | v152970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20422,axiom,
    ! [VarCurr: state_type] :
      ( v152970(VarCurr)
    <=> ( v152971(VarCurr)
        & v152974(VarCurr) ) ) ).

tff(writeUnaryOperator_11672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152974(VarCurr)
    <=> v152921(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7281,axiom,
    ! [VarCurr: state_type] :
      ( v152971(VarCurr)
    <=> ( v152921(VarCurr,1)
        | v152972(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20421,axiom,
    ! [VarCurr: state_type] :
      ( v152972(VarCurr)
    <=> ( v152921(VarCurr,0)
        & v152973(VarCurr) ) ) ).

tff(writeUnaryOperator_11671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152973(VarCurr)
    <=> v152921(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2389,axiom,
    ! [VarCurr: state_type] :
      ( v152961(VarCurr)
    <=> ( ( v152921(VarCurr,4)
        <=> $false )
        & ( v152921(VarCurr,3)
        <=> $false )
        & ( v152921(VarCurr,2)
        <=> $false )
        & ( v152921(VarCurr,1)
        <=> $false )
        & ( v152921(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152957(VarCurr,B)
          <=> v152954(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1717,axiom,
    ! [VarCurr: state_type] :
      ( v152958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152957(VarCurr,B)
          <=> v152952(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20420,axiom,
    ! [VarCurr: state_type] :
      ( v152958(VarCurr)
    <=> ( v152959(VarCurr)
        | v152947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20419,axiom,
    ! [VarCurr: state_type] :
      ( v152959(VarCurr)
    <=> ( v152950(VarCurr)
        & v152945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20418,axiom,
    ! [VarCurr: state_type] :
      ( v152956(VarCurr)
    <=> ( v152943(VarCurr)
        & v152856(VarCurr) ) ) ).

tff(addAssignment_85778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152954(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152952(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85776,axiom,
    ! [VarCurr: state_type] :
      ( v152950(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20417,axiom,
    ! [VarCurr: state_type] :
      ( v152943(VarCurr)
    <=> ( v152945(VarCurr)
        | v152947(VarCurr) ) ) ).

tff(addAssignment_85775,axiom,
    ! [VarCurr: state_type] :
      ( v152947(VarCurr)
    <=> v110563(VarCurr,7) ) ).

tff(addAssignment_85774,axiom,
    ! [VarCurr: state_type] :
      ( v152945(VarCurr)
    <=> v108901(VarCurr,7) ) ).

tff(addAssignment_85773,axiom,
    ! [VarCurr: state_type] :
      ( v152931(VarCurr)
    <=> v152933(VarCurr) ) ).

tff(addAssignment_85772,axiom,
    ! [VarCurr: state_type] :
      ( v152933(VarCurr)
    <=> v152837(VarCurr) ) ).

tff(addAssignment_85771,axiom,
    ! [VarCurr: state_type] :
      ( v152927(VarCurr)
    <=> v152929(VarCurr) ) ).

tff(addAssignment_85770,axiom,
    ! [VarCurr: state_type] :
      ( v152929(VarCurr)
    <=> v152829(VarCurr) ) ).

tff(addAssignment_85769,axiom,
    ! [VarCurr: state_type] :
      ( v152815(VarCurr)
    <=> v152817(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2388,axiom,
    ! [VarCurr: state_type] :
      ( v152817(VarCurr)
    <=> ( ( v152819(VarCurr,4)
        <=> $false )
        & ( v152819(VarCurr,3)
        <=> $false )
        & ( v152819(VarCurr,2)
        <=> $false )
        & ( v152819(VarCurr,1)
        <=> $false )
        & ( v152819(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152819(VarCurr,B)
      <=> v152821(VarCurr,B) ) ) ).

tff(addAssignment_85767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152821(VarCurr,B)
      <=> v152823(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152899(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152823(VarNext,B)
            <=> v152823(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2279,axiom,
    ! [VarNext: state_type] :
      ( v152899(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152823(VarNext,B)
          <=> v152909(VarNext,B) ) ) ) ).

tff(addAssignment_85766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152909(VarNext,B)
          <=> v152907(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152910(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152907(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1716,axiom,
    ! [VarCurr: state_type] :
      ( v152910(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152907(VarCurr,B)
          <=> v152841(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20416,axiom,
    ! [VarCurr: state_type] :
      ( v152910(VarCurr)
    <=> ( v152911(VarCurr)
        & v152912(VarCurr) ) ) ).

tff(writeUnaryOperator_11670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152912(VarCurr)
    <=> v152833(VarCurr) ) ).

tff(writeUnaryOperator_11669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152911(VarCurr)
    <=> v152825(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152899(VarNext)
      <=> v152900(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152900(VarNext)
      <=> ( v152901(VarNext)
          & v152892(VarNext) ) ) ) ).

tff(writeUnaryOperator_11668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152901(VarNext)
      <=> v152903(VarNext) ) ) ).

tff(addAssignment_85765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152903(VarNext)
      <=> v152892(VarCurr) ) ) ).

tff(addAssignment_85764,axiom,
    ! [VarCurr: state_type] :
      ( v152892(VarCurr)
    <=> v152894(VarCurr) ) ).

tff(addAssignment_85763,axiom,
    ! [VarCurr: state_type] :
      ( v152894(VarCurr)
    <=> v152896(VarCurr) ) ).

tff(addAssignment_85762,axiom,
    ! [VarCurr: state_type] :
      ( v152896(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152841(VarCurr,B)
      <=> v152843(VarCurr,B) ) ) ).

tff(addAssignment_85760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152843(VarCurr,B)
      <=> v152845(VarCurr,B) ) ) ).

tff(addAssignment_85759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152845(VarCurr,B)
      <=> v152847(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152847(VarCurr,B)
          <=> v152861(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1715,axiom,
    ! [VarCurr: state_type] :
      ( v152860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152847(VarCurr,B)
          <=> v152858(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152862(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152861(VarCurr,B)
          <=> v152863(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1714,axiom,
    ! [VarCurr: state_type] :
      ( v152862(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152861(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85758,axiom,
    ! [VarCurr: state_type] :
      ( v152863(VarCurr,0)
    <=> v152889(VarCurr) ) ).

tff(addAssignment_85757,axiom,
    ! [VarCurr: state_type] :
      ( v152863(VarCurr,1)
    <=> v152887(VarCurr) ) ).

tff(addAssignment_85756,axiom,
    ! [VarCurr: state_type] :
      ( v152863(VarCurr,2)
    <=> v152883(VarCurr) ) ).

tff(addAssignment_85755,axiom,
    ! [VarCurr: state_type] :
      ( v152863(VarCurr,3)
    <=> v152879(VarCurr) ) ).

tff(addAssignment_85754,axiom,
    ! [VarCurr: state_type] :
      ( v152863(VarCurr,4)
    <=> v152865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20413,axiom,
    ! [VarCurr: state_type] :
      ( v152887(VarCurr)
    <=> ( v152888(VarCurr)
        & v152890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20412,axiom,
    ! [VarCurr: state_type] :
      ( v152890(VarCurr)
    <=> ( v152819(VarCurr,0)
        | v152874(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7280,axiom,
    ! [VarCurr: state_type] :
      ( v152888(VarCurr)
    <=> ( v152889(VarCurr)
        | v152819(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152889(VarCurr)
    <=> v152819(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20411,axiom,
    ! [VarCurr: state_type] :
      ( v152883(VarCurr)
    <=> ( v152884(VarCurr)
        & v152886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20410,axiom,
    ! [VarCurr: state_type] :
      ( v152886(VarCurr)
    <=> ( v152872(VarCurr)
        | v152875(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7279,axiom,
    ! [VarCurr: state_type] :
      ( v152884(VarCurr)
    <=> ( v152885(VarCurr)
        | v152819(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152885(VarCurr)
    <=> v152872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20409,axiom,
    ! [VarCurr: state_type] :
      ( v152879(VarCurr)
    <=> ( v152880(VarCurr)
        & v152882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20408,axiom,
    ! [VarCurr: state_type] :
      ( v152882(VarCurr)
    <=> ( v152870(VarCurr)
        | v152876(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7278,axiom,
    ! [VarCurr: state_type] :
      ( v152880(VarCurr)
    <=> ( v152881(VarCurr)
        | v152819(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152881(VarCurr)
    <=> v152870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20407,axiom,
    ! [VarCurr: state_type] :
      ( v152865(VarCurr)
    <=> ( v152866(VarCurr)
        & v152877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20406,axiom,
    ! [VarCurr: state_type] :
      ( v152877(VarCurr)
    <=> ( v152868(VarCurr)
        | v152878(VarCurr) ) ) ).

tff(writeUnaryOperator_11664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152878(VarCurr)
    <=> v152819(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7277,axiom,
    ! [VarCurr: state_type] :
      ( v152866(VarCurr)
    <=> ( v152867(VarCurr)
        | v152819(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152867(VarCurr)
    <=> v152868(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7276,axiom,
    ! [VarCurr: state_type] :
      ( v152868(VarCurr)
    <=> ( v152819(VarCurr,3)
        | v152869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20405,axiom,
    ! [VarCurr: state_type] :
      ( v152869(VarCurr)
    <=> ( v152870(VarCurr)
        & v152876(VarCurr) ) ) ).

tff(writeUnaryOperator_11662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152876(VarCurr)
    <=> v152819(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7275,axiom,
    ! [VarCurr: state_type] :
      ( v152870(VarCurr)
    <=> ( v152819(VarCurr,2)
        | v152871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20404,axiom,
    ! [VarCurr: state_type] :
      ( v152871(VarCurr)
    <=> ( v152872(VarCurr)
        & v152875(VarCurr) ) ) ).

tff(writeUnaryOperator_11661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152875(VarCurr)
    <=> v152819(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7274,axiom,
    ! [VarCurr: state_type] :
      ( v152872(VarCurr)
    <=> ( v152819(VarCurr,1)
        | v152873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20403,axiom,
    ! [VarCurr: state_type] :
      ( v152873(VarCurr)
    <=> ( v152819(VarCurr,0)
        & v152874(VarCurr) ) ) ).

tff(writeUnaryOperator_11660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152874(VarCurr)
    <=> v152819(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2387,axiom,
    ! [VarCurr: state_type] :
      ( v152862(VarCurr)
    <=> ( ( v152819(VarCurr,4)
        <=> $false )
        & ( v152819(VarCurr,3)
        <=> $false )
        & ( v152819(VarCurr,2)
        <=> $false )
        & ( v152819(VarCurr,1)
        <=> $false )
        & ( v152819(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20402,axiom,
    ! [VarCurr: state_type] :
      ( v152860(VarCurr)
    <=> ( v152849(VarCurr)
        & v152856(VarCurr) ) ) ).

tff(addAssignment_85753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152858(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85752,axiom,
    ! [VarCurr: state_type] :
      ( v152856(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20401,axiom,
    ! [VarCurr: state_type] :
      ( v152849(VarCurr)
    <=> ( v152851(VarCurr)
        | v152853(VarCurr) ) ) ).

tff(addAssignment_85751,axiom,
    ! [VarCurr: state_type] :
      ( v152853(VarCurr)
    <=> v110583(VarCurr,7) ) ).

tff(addAssignment_85750,axiom,
    ! [VarCurr: state_type] :
      ( v152851(VarCurr)
    <=> v116(VarCurr,7) ) ).

tff(addAssignment_85749,axiom,
    ! [VarCurr: state_type] :
      ( v152833(VarCurr)
    <=> v152835(VarCurr) ) ).

tff(addAssignment_85748,axiom,
    ! [VarCurr: state_type] :
      ( v152835(VarCurr)
    <=> v152837(VarCurr) ) ).

tff(addAssignment_85747,axiom,
    ! [VarCurr: state_type] :
      ( v152837(VarCurr)
    <=> v152839(VarCurr) ) ).

tff(addAssignment_85746,axiom,
    ! [VarCurr: state_type] :
      ( v152839(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85745,axiom,
    ! [VarCurr: state_type] :
      ( v152825(VarCurr)
    <=> v152827(VarCurr) ) ).

tff(addAssignment_85744,axiom,
    ! [VarCurr: state_type] :
      ( v152827(VarCurr)
    <=> v152829(VarCurr) ) ).

tff(addAssignment_85743,axiom,
    ! [VarCurr: state_type] :
      ( v152829(VarCurr)
    <=> v152831(VarCurr) ) ).

tff(addAssignment_85742,axiom,
    ! [VarCurr: state_type] :
      ( v152831(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85741,axiom,
    ! [VarCurr: state_type] :
      ( v152718(VarCurr)
    <=> v152720(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2386,axiom,
    ! [VarCurr: state_type] :
      ( v152720(VarCurr)
    <=> ( ( v152722(VarCurr,4)
        <=> $false )
        & ( v152722(VarCurr,3)
        <=> $false )
        & ( v152722(VarCurr,2)
        <=> $false )
        & ( v152722(VarCurr,1)
        <=> $false )
        & ( v152722(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152722(VarCurr,B)
      <=> v152724(VarCurr,B) ) ) ).

tff(addAssignment_85739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152724(VarCurr,B)
      <=> v152726(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152797(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152726(VarNext,B)
            <=> v152726(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2278,axiom,
    ! [VarNext: state_type] :
      ( v152797(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152726(VarNext,B)
          <=> v152807(VarNext,B) ) ) ) ).

tff(addAssignment_85738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152807(VarNext,B)
          <=> v152805(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152808(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152805(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1713,axiom,
    ! [VarCurr: state_type] :
      ( v152808(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152805(VarCurr,B)
          <=> v152736(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20400,axiom,
    ! [VarCurr: state_type] :
      ( v152808(VarCurr)
    <=> ( v152809(VarCurr)
        & v152810(VarCurr) ) ) ).

tff(writeUnaryOperator_11659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152810(VarCurr)
    <=> v152732(VarCurr) ) ).

tff(writeUnaryOperator_11658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152809(VarCurr)
    <=> v152728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152797(VarNext)
      <=> v152798(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152798(VarNext)
      <=> ( v152799(VarNext)
          & v152792(VarNext) ) ) ) ).

tff(writeUnaryOperator_11657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152799(VarNext)
      <=> v152801(VarNext) ) ) ).

tff(addAssignment_85737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152801(VarNext)
      <=> v152792(VarCurr) ) ) ).

tff(addAssignment_85736,axiom,
    ! [VarCurr: state_type] :
      ( v152792(VarCurr)
    <=> v152794(VarCurr) ) ).

tff(addAssignment_85735,axiom,
    ! [VarCurr: state_type] :
      ( v152794(VarCurr)
    <=> v152697(VarCurr) ) ).

tff(addAssignment_85734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152736(VarCurr,B)
      <=> v152738(VarCurr,B) ) ) ).

tff(addAssignment_85733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152738(VarCurr,B)
      <=> v152740(VarCurr,B) ) ) ).

tff(addAssignment_85732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152740(VarCurr,B)
      <=> v152742(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152757(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152742(VarCurr,B)
          <=> v152761(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1712,axiom,
    ! [VarCurr: state_type] :
      ( v152757(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152742(VarCurr,B)
          <=> v152758(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152761(VarCurr,B)
          <=> v152763(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1711,axiom,
    ! [VarCurr: state_type] :
      ( v152762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152761(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85731,axiom,
    ! [VarCurr: state_type] :
      ( v152763(VarCurr,0)
    <=> v152789(VarCurr) ) ).

tff(addAssignment_85730,axiom,
    ! [VarCurr: state_type] :
      ( v152763(VarCurr,1)
    <=> v152787(VarCurr) ) ).

tff(addAssignment_85729,axiom,
    ! [VarCurr: state_type] :
      ( v152763(VarCurr,2)
    <=> v152783(VarCurr) ) ).

tff(addAssignment_85728,axiom,
    ! [VarCurr: state_type] :
      ( v152763(VarCurr,3)
    <=> v152779(VarCurr) ) ).

tff(addAssignment_85727,axiom,
    ! [VarCurr: state_type] :
      ( v152763(VarCurr,4)
    <=> v152765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20397,axiom,
    ! [VarCurr: state_type] :
      ( v152787(VarCurr)
    <=> ( v152788(VarCurr)
        & v152790(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20396,axiom,
    ! [VarCurr: state_type] :
      ( v152790(VarCurr)
    <=> ( v152722(VarCurr,0)
        | v152774(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7273,axiom,
    ! [VarCurr: state_type] :
      ( v152788(VarCurr)
    <=> ( v152789(VarCurr)
        | v152722(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152789(VarCurr)
    <=> v152722(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20395,axiom,
    ! [VarCurr: state_type] :
      ( v152783(VarCurr)
    <=> ( v152784(VarCurr)
        & v152786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20394,axiom,
    ! [VarCurr: state_type] :
      ( v152786(VarCurr)
    <=> ( v152772(VarCurr)
        | v152775(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7272,axiom,
    ! [VarCurr: state_type] :
      ( v152784(VarCurr)
    <=> ( v152785(VarCurr)
        | v152722(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152785(VarCurr)
    <=> v152772(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20393,axiom,
    ! [VarCurr: state_type] :
      ( v152779(VarCurr)
    <=> ( v152780(VarCurr)
        & v152782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20392,axiom,
    ! [VarCurr: state_type] :
      ( v152782(VarCurr)
    <=> ( v152770(VarCurr)
        | v152776(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7271,axiom,
    ! [VarCurr: state_type] :
      ( v152780(VarCurr)
    <=> ( v152781(VarCurr)
        | v152722(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152781(VarCurr)
    <=> v152770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20391,axiom,
    ! [VarCurr: state_type] :
      ( v152765(VarCurr)
    <=> ( v152766(VarCurr)
        & v152777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20390,axiom,
    ! [VarCurr: state_type] :
      ( v152777(VarCurr)
    <=> ( v152768(VarCurr)
        | v152778(VarCurr) ) ) ).

tff(writeUnaryOperator_11653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152778(VarCurr)
    <=> v152722(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7270,axiom,
    ! [VarCurr: state_type] :
      ( v152766(VarCurr)
    <=> ( v152767(VarCurr)
        | v152722(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152767(VarCurr)
    <=> v152768(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7269,axiom,
    ! [VarCurr: state_type] :
      ( v152768(VarCurr)
    <=> ( v152722(VarCurr,3)
        | v152769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20389,axiom,
    ! [VarCurr: state_type] :
      ( v152769(VarCurr)
    <=> ( v152770(VarCurr)
        & v152776(VarCurr) ) ) ).

tff(writeUnaryOperator_11651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152776(VarCurr)
    <=> v152722(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7268,axiom,
    ! [VarCurr: state_type] :
      ( v152770(VarCurr)
    <=> ( v152722(VarCurr,2)
        | v152771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20388,axiom,
    ! [VarCurr: state_type] :
      ( v152771(VarCurr)
    <=> ( v152772(VarCurr)
        & v152775(VarCurr) ) ) ).

tff(writeUnaryOperator_11650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152775(VarCurr)
    <=> v152722(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7267,axiom,
    ! [VarCurr: state_type] :
      ( v152772(VarCurr)
    <=> ( v152722(VarCurr,1)
        | v152773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20387,axiom,
    ! [VarCurr: state_type] :
      ( v152773(VarCurr)
    <=> ( v152722(VarCurr,0)
        & v152774(VarCurr) ) ) ).

tff(writeUnaryOperator_11649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152774(VarCurr)
    <=> v152722(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2385,axiom,
    ! [VarCurr: state_type] :
      ( v152762(VarCurr)
    <=> ( ( v152722(VarCurr,4)
        <=> $false )
        & ( v152722(VarCurr,3)
        <=> $false )
        & ( v152722(VarCurr,2)
        <=> $false )
        & ( v152722(VarCurr,1)
        <=> $false )
        & ( v152722(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152759(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152758(VarCurr,B)
          <=> v152755(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1710,axiom,
    ! [VarCurr: state_type] :
      ( v152759(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152758(VarCurr,B)
          <=> v152753(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20386,axiom,
    ! [VarCurr: state_type] :
      ( v152759(VarCurr)
    <=> ( v152760(VarCurr)
        | v152748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20385,axiom,
    ! [VarCurr: state_type] :
      ( v152760(VarCurr)
    <=> ( v152751(VarCurr)
        & v152746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20384,axiom,
    ! [VarCurr: state_type] :
      ( v152757(VarCurr)
    <=> ( v152744(VarCurr)
        & v152657(VarCurr) ) ) ).

tff(addAssignment_85726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152755(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152753(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85724,axiom,
    ! [VarCurr: state_type] :
      ( v152751(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20383,axiom,
    ! [VarCurr: state_type] :
      ( v152744(VarCurr)
    <=> ( v152746(VarCurr)
        | v152748(VarCurr) ) ) ).

tff(addAssignment_85723,axiom,
    ! [VarCurr: state_type] :
      ( v152748(VarCurr)
    <=> v110563(VarCurr,6) ) ).

tff(addAssignment_85722,axiom,
    ! [VarCurr: state_type] :
      ( v152746(VarCurr)
    <=> v108901(VarCurr,6) ) ).

tff(addAssignment_85721,axiom,
    ! [VarCurr: state_type] :
      ( v152732(VarCurr)
    <=> v152734(VarCurr) ) ).

tff(addAssignment_85720,axiom,
    ! [VarCurr: state_type] :
      ( v152734(VarCurr)
    <=> v152638(VarCurr) ) ).

tff(addAssignment_85719,axiom,
    ! [VarCurr: state_type] :
      ( v152728(VarCurr)
    <=> v152730(VarCurr) ) ).

tff(addAssignment_85718,axiom,
    ! [VarCurr: state_type] :
      ( v152730(VarCurr)
    <=> v152630(VarCurr) ) ).

tff(addAssignment_85717,axiom,
    ! [VarCurr: state_type] :
      ( v152616(VarCurr)
    <=> v152618(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2384,axiom,
    ! [VarCurr: state_type] :
      ( v152618(VarCurr)
    <=> ( ( v152620(VarCurr,4)
        <=> $false )
        & ( v152620(VarCurr,3)
        <=> $false )
        & ( v152620(VarCurr,2)
        <=> $false )
        & ( v152620(VarCurr,1)
        <=> $false )
        & ( v152620(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152620(VarCurr,B)
      <=> v152622(VarCurr,B) ) ) ).

tff(addAssignment_85715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152622(VarCurr,B)
      <=> v152624(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152700(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152624(VarNext,B)
            <=> v152624(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2277,axiom,
    ! [VarNext: state_type] :
      ( v152700(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152624(VarNext,B)
          <=> v152710(VarNext,B) ) ) ) ).

tff(addAssignment_85714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152710(VarNext,B)
          <=> v152708(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152711(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152708(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1709,axiom,
    ! [VarCurr: state_type] :
      ( v152711(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152708(VarCurr,B)
          <=> v152642(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20382,axiom,
    ! [VarCurr: state_type] :
      ( v152711(VarCurr)
    <=> ( v152712(VarCurr)
        & v152713(VarCurr) ) ) ).

tff(writeUnaryOperator_11648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152713(VarCurr)
    <=> v152634(VarCurr) ) ).

tff(writeUnaryOperator_11647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152712(VarCurr)
    <=> v152626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152700(VarNext)
      <=> v152701(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152701(VarNext)
      <=> ( v152702(VarNext)
          & v152693(VarNext) ) ) ) ).

tff(writeUnaryOperator_11646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152702(VarNext)
      <=> v152704(VarNext) ) ) ).

tff(addAssignment_85713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152704(VarNext)
      <=> v152693(VarCurr) ) ) ).

tff(addAssignment_85712,axiom,
    ! [VarCurr: state_type] :
      ( v152693(VarCurr)
    <=> v152695(VarCurr) ) ).

tff(addAssignment_85711,axiom,
    ! [VarCurr: state_type] :
      ( v152695(VarCurr)
    <=> v152697(VarCurr) ) ).

tff(addAssignment_85710,axiom,
    ! [VarCurr: state_type] :
      ( v152697(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152642(VarCurr,B)
      <=> v152644(VarCurr,B) ) ) ).

tff(addAssignment_85708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152644(VarCurr,B)
      <=> v152646(VarCurr,B) ) ) ).

tff(addAssignment_85707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152646(VarCurr,B)
      <=> v152648(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152661(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152648(VarCurr,B)
          <=> v152662(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1708,axiom,
    ! [VarCurr: state_type] :
      ( v152661(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152648(VarCurr,B)
          <=> v152659(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152663(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152662(VarCurr,B)
          <=> v152664(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1707,axiom,
    ! [VarCurr: state_type] :
      ( v152663(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152662(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85706,axiom,
    ! [VarCurr: state_type] :
      ( v152664(VarCurr,0)
    <=> v152690(VarCurr) ) ).

tff(addAssignment_85705,axiom,
    ! [VarCurr: state_type] :
      ( v152664(VarCurr,1)
    <=> v152688(VarCurr) ) ).

tff(addAssignment_85704,axiom,
    ! [VarCurr: state_type] :
      ( v152664(VarCurr,2)
    <=> v152684(VarCurr) ) ).

tff(addAssignment_85703,axiom,
    ! [VarCurr: state_type] :
      ( v152664(VarCurr,3)
    <=> v152680(VarCurr) ) ).

tff(addAssignment_85702,axiom,
    ! [VarCurr: state_type] :
      ( v152664(VarCurr,4)
    <=> v152666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20379,axiom,
    ! [VarCurr: state_type] :
      ( v152688(VarCurr)
    <=> ( v152689(VarCurr)
        & v152691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20378,axiom,
    ! [VarCurr: state_type] :
      ( v152691(VarCurr)
    <=> ( v152620(VarCurr,0)
        | v152675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7266,axiom,
    ! [VarCurr: state_type] :
      ( v152689(VarCurr)
    <=> ( v152690(VarCurr)
        | v152620(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152690(VarCurr)
    <=> v152620(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20377,axiom,
    ! [VarCurr: state_type] :
      ( v152684(VarCurr)
    <=> ( v152685(VarCurr)
        & v152687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20376,axiom,
    ! [VarCurr: state_type] :
      ( v152687(VarCurr)
    <=> ( v152673(VarCurr)
        | v152676(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7265,axiom,
    ! [VarCurr: state_type] :
      ( v152685(VarCurr)
    <=> ( v152686(VarCurr)
        | v152620(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152686(VarCurr)
    <=> v152673(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20375,axiom,
    ! [VarCurr: state_type] :
      ( v152680(VarCurr)
    <=> ( v152681(VarCurr)
        & v152683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20374,axiom,
    ! [VarCurr: state_type] :
      ( v152683(VarCurr)
    <=> ( v152671(VarCurr)
        | v152677(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7264,axiom,
    ! [VarCurr: state_type] :
      ( v152681(VarCurr)
    <=> ( v152682(VarCurr)
        | v152620(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152682(VarCurr)
    <=> v152671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20373,axiom,
    ! [VarCurr: state_type] :
      ( v152666(VarCurr)
    <=> ( v152667(VarCurr)
        & v152678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20372,axiom,
    ! [VarCurr: state_type] :
      ( v152678(VarCurr)
    <=> ( v152669(VarCurr)
        | v152679(VarCurr) ) ) ).

tff(writeUnaryOperator_11642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152679(VarCurr)
    <=> v152620(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7263,axiom,
    ! [VarCurr: state_type] :
      ( v152667(VarCurr)
    <=> ( v152668(VarCurr)
        | v152620(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152668(VarCurr)
    <=> v152669(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7262,axiom,
    ! [VarCurr: state_type] :
      ( v152669(VarCurr)
    <=> ( v152620(VarCurr,3)
        | v152670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20371,axiom,
    ! [VarCurr: state_type] :
      ( v152670(VarCurr)
    <=> ( v152671(VarCurr)
        & v152677(VarCurr) ) ) ).

tff(writeUnaryOperator_11640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152677(VarCurr)
    <=> v152620(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7261,axiom,
    ! [VarCurr: state_type] :
      ( v152671(VarCurr)
    <=> ( v152620(VarCurr,2)
        | v152672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20370,axiom,
    ! [VarCurr: state_type] :
      ( v152672(VarCurr)
    <=> ( v152673(VarCurr)
        & v152676(VarCurr) ) ) ).

tff(writeUnaryOperator_11639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152676(VarCurr)
    <=> v152620(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7260,axiom,
    ! [VarCurr: state_type] :
      ( v152673(VarCurr)
    <=> ( v152620(VarCurr,1)
        | v152674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20369,axiom,
    ! [VarCurr: state_type] :
      ( v152674(VarCurr)
    <=> ( v152620(VarCurr,0)
        & v152675(VarCurr) ) ) ).

tff(writeUnaryOperator_11638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152675(VarCurr)
    <=> v152620(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2383,axiom,
    ! [VarCurr: state_type] :
      ( v152663(VarCurr)
    <=> ( ( v152620(VarCurr,4)
        <=> $false )
        & ( v152620(VarCurr,3)
        <=> $false )
        & ( v152620(VarCurr,2)
        <=> $false )
        & ( v152620(VarCurr,1)
        <=> $false )
        & ( v152620(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20368,axiom,
    ! [VarCurr: state_type] :
      ( v152661(VarCurr)
    <=> ( v152650(VarCurr)
        & v152657(VarCurr) ) ) ).

tff(addAssignment_85701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152659(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85700,axiom,
    ! [VarCurr: state_type] :
      ( v152657(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20367,axiom,
    ! [VarCurr: state_type] :
      ( v152650(VarCurr)
    <=> ( v152652(VarCurr)
        | v152654(VarCurr) ) ) ).

tff(addAssignment_85699,axiom,
    ! [VarCurr: state_type] :
      ( v152654(VarCurr)
    <=> v110583(VarCurr,6) ) ).

tff(addAssignment_85698,axiom,
    ! [VarCurr: state_type] :
      ( v152652(VarCurr)
    <=> v116(VarCurr,6) ) ).

tff(addAssignment_85697,axiom,
    ! [VarCurr: state_type] :
      ( v152634(VarCurr)
    <=> v152636(VarCurr) ) ).

tff(addAssignment_85696,axiom,
    ! [VarCurr: state_type] :
      ( v152636(VarCurr)
    <=> v152638(VarCurr) ) ).

tff(addAssignment_85695,axiom,
    ! [VarCurr: state_type] :
      ( v152638(VarCurr)
    <=> v152640(VarCurr) ) ).

tff(addAssignment_85694,axiom,
    ! [VarCurr: state_type] :
      ( v152640(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85693,axiom,
    ! [VarCurr: state_type] :
      ( v152626(VarCurr)
    <=> v152628(VarCurr) ) ).

tff(addAssignment_85692,axiom,
    ! [VarCurr: state_type] :
      ( v152628(VarCurr)
    <=> v152630(VarCurr) ) ).

tff(addAssignment_85691,axiom,
    ! [VarCurr: state_type] :
      ( v152630(VarCurr)
    <=> v152632(VarCurr) ) ).

tff(addAssignment_85690,axiom,
    ! [VarCurr: state_type] :
      ( v152632(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85689,axiom,
    ! [VarCurr: state_type] :
      ( v152519(VarCurr)
    <=> v152521(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2382,axiom,
    ! [VarCurr: state_type] :
      ( v152521(VarCurr)
    <=> ( ( v152523(VarCurr,4)
        <=> $false )
        & ( v152523(VarCurr,3)
        <=> $false )
        & ( v152523(VarCurr,2)
        <=> $false )
        & ( v152523(VarCurr,1)
        <=> $false )
        & ( v152523(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152523(VarCurr,B)
      <=> v152525(VarCurr,B) ) ) ).

tff(addAssignment_85687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152525(VarCurr,B)
      <=> v152527(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152598(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152527(VarNext,B)
            <=> v152527(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2276,axiom,
    ! [VarNext: state_type] :
      ( v152598(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152527(VarNext,B)
          <=> v152608(VarNext,B) ) ) ) ).

tff(addAssignment_85686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152608(VarNext,B)
          <=> v152606(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152609(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152606(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1706,axiom,
    ! [VarCurr: state_type] :
      ( v152609(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152606(VarCurr,B)
          <=> v152537(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20366,axiom,
    ! [VarCurr: state_type] :
      ( v152609(VarCurr)
    <=> ( v152610(VarCurr)
        & v152611(VarCurr) ) ) ).

tff(writeUnaryOperator_11637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152611(VarCurr)
    <=> v152533(VarCurr) ) ).

tff(writeUnaryOperator_11636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152610(VarCurr)
    <=> v152529(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152598(VarNext)
      <=> v152599(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152599(VarNext)
      <=> ( v152600(VarNext)
          & v152593(VarNext) ) ) ) ).

tff(writeUnaryOperator_11635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152600(VarNext)
      <=> v152602(VarNext) ) ) ).

tff(addAssignment_85685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152602(VarNext)
      <=> v152593(VarCurr) ) ) ).

tff(addAssignment_85684,axiom,
    ! [VarCurr: state_type] :
      ( v152593(VarCurr)
    <=> v152595(VarCurr) ) ).

tff(addAssignment_85683,axiom,
    ! [VarCurr: state_type] :
      ( v152595(VarCurr)
    <=> v152498(VarCurr) ) ).

tff(addAssignment_85682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152537(VarCurr,B)
      <=> v152539(VarCurr,B) ) ) ).

tff(addAssignment_85681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152539(VarCurr,B)
      <=> v152541(VarCurr,B) ) ) ).

tff(addAssignment_85680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152541(VarCurr,B)
      <=> v152543(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152543(VarCurr,B)
          <=> v152562(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1705,axiom,
    ! [VarCurr: state_type] :
      ( v152558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152543(VarCurr,B)
          <=> v152559(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152562(VarCurr,B)
          <=> v152564(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1704,axiom,
    ! [VarCurr: state_type] :
      ( v152563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152562(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85679,axiom,
    ! [VarCurr: state_type] :
      ( v152564(VarCurr,0)
    <=> v152590(VarCurr) ) ).

tff(addAssignment_85678,axiom,
    ! [VarCurr: state_type] :
      ( v152564(VarCurr,1)
    <=> v152588(VarCurr) ) ).

tff(addAssignment_85677,axiom,
    ! [VarCurr: state_type] :
      ( v152564(VarCurr,2)
    <=> v152584(VarCurr) ) ).

tff(addAssignment_85676,axiom,
    ! [VarCurr: state_type] :
      ( v152564(VarCurr,3)
    <=> v152580(VarCurr) ) ).

tff(addAssignment_85675,axiom,
    ! [VarCurr: state_type] :
      ( v152564(VarCurr,4)
    <=> v152566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20363,axiom,
    ! [VarCurr: state_type] :
      ( v152588(VarCurr)
    <=> ( v152589(VarCurr)
        & v152591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20362,axiom,
    ! [VarCurr: state_type] :
      ( v152591(VarCurr)
    <=> ( v152523(VarCurr,0)
        | v152575(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7259,axiom,
    ! [VarCurr: state_type] :
      ( v152589(VarCurr)
    <=> ( v152590(VarCurr)
        | v152523(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152590(VarCurr)
    <=> v152523(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20361,axiom,
    ! [VarCurr: state_type] :
      ( v152584(VarCurr)
    <=> ( v152585(VarCurr)
        & v152587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20360,axiom,
    ! [VarCurr: state_type] :
      ( v152587(VarCurr)
    <=> ( v152573(VarCurr)
        | v152576(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7258,axiom,
    ! [VarCurr: state_type] :
      ( v152585(VarCurr)
    <=> ( v152586(VarCurr)
        | v152523(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152586(VarCurr)
    <=> v152573(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20359,axiom,
    ! [VarCurr: state_type] :
      ( v152580(VarCurr)
    <=> ( v152581(VarCurr)
        & v152583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20358,axiom,
    ! [VarCurr: state_type] :
      ( v152583(VarCurr)
    <=> ( v152571(VarCurr)
        | v152577(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7257,axiom,
    ! [VarCurr: state_type] :
      ( v152581(VarCurr)
    <=> ( v152582(VarCurr)
        | v152523(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152582(VarCurr)
    <=> v152571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20357,axiom,
    ! [VarCurr: state_type] :
      ( v152566(VarCurr)
    <=> ( v152567(VarCurr)
        & v152578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20356,axiom,
    ! [VarCurr: state_type] :
      ( v152578(VarCurr)
    <=> ( v152569(VarCurr)
        | v152579(VarCurr) ) ) ).

tff(writeUnaryOperator_11631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152579(VarCurr)
    <=> v152523(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7256,axiom,
    ! [VarCurr: state_type] :
      ( v152567(VarCurr)
    <=> ( v152568(VarCurr)
        | v152523(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152568(VarCurr)
    <=> v152569(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7255,axiom,
    ! [VarCurr: state_type] :
      ( v152569(VarCurr)
    <=> ( v152523(VarCurr,3)
        | v152570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20355,axiom,
    ! [VarCurr: state_type] :
      ( v152570(VarCurr)
    <=> ( v152571(VarCurr)
        & v152577(VarCurr) ) ) ).

tff(writeUnaryOperator_11629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152577(VarCurr)
    <=> v152523(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7254,axiom,
    ! [VarCurr: state_type] :
      ( v152571(VarCurr)
    <=> ( v152523(VarCurr,2)
        | v152572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20354,axiom,
    ! [VarCurr: state_type] :
      ( v152572(VarCurr)
    <=> ( v152573(VarCurr)
        & v152576(VarCurr) ) ) ).

tff(writeUnaryOperator_11628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152576(VarCurr)
    <=> v152523(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7253,axiom,
    ! [VarCurr: state_type] :
      ( v152573(VarCurr)
    <=> ( v152523(VarCurr,1)
        | v152574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20353,axiom,
    ! [VarCurr: state_type] :
      ( v152574(VarCurr)
    <=> ( v152523(VarCurr,0)
        & v152575(VarCurr) ) ) ).

tff(writeUnaryOperator_11627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152575(VarCurr)
    <=> v152523(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2381,axiom,
    ! [VarCurr: state_type] :
      ( v152563(VarCurr)
    <=> ( ( v152523(VarCurr,4)
        <=> $false )
        & ( v152523(VarCurr,3)
        <=> $false )
        & ( v152523(VarCurr,2)
        <=> $false )
        & ( v152523(VarCurr,1)
        <=> $false )
        & ( v152523(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152559(VarCurr,B)
          <=> v152556(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1703,axiom,
    ! [VarCurr: state_type] :
      ( v152560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152559(VarCurr,B)
          <=> v152554(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20352,axiom,
    ! [VarCurr: state_type] :
      ( v152560(VarCurr)
    <=> ( v152561(VarCurr)
        | v152549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20351,axiom,
    ! [VarCurr: state_type] :
      ( v152561(VarCurr)
    <=> ( v152552(VarCurr)
        & v152547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20350,axiom,
    ! [VarCurr: state_type] :
      ( v152558(VarCurr)
    <=> ( v152545(VarCurr)
        & v152458(VarCurr) ) ) ).

tff(addAssignment_85674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152556(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152554(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85672,axiom,
    ! [VarCurr: state_type] :
      ( v152552(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20349,axiom,
    ! [VarCurr: state_type] :
      ( v152545(VarCurr)
    <=> ( v152547(VarCurr)
        | v152549(VarCurr) ) ) ).

tff(addAssignment_85671,axiom,
    ! [VarCurr: state_type] :
      ( v152549(VarCurr)
    <=> v110563(VarCurr,5) ) ).

tff(addAssignment_85670,axiom,
    ! [VarCurr: state_type] :
      ( v152547(VarCurr)
    <=> v108901(VarCurr,5) ) ).

tff(addAssignment_85669,axiom,
    ! [VarCurr: state_type] :
      ( v152533(VarCurr)
    <=> v152535(VarCurr) ) ).

tff(addAssignment_85668,axiom,
    ! [VarCurr: state_type] :
      ( v152535(VarCurr)
    <=> v152439(VarCurr) ) ).

tff(addAssignment_85667,axiom,
    ! [VarCurr: state_type] :
      ( v152529(VarCurr)
    <=> v152531(VarCurr) ) ).

tff(addAssignment_85666,axiom,
    ! [VarCurr: state_type] :
      ( v152531(VarCurr)
    <=> v152431(VarCurr) ) ).

tff(addAssignment_85665,axiom,
    ! [VarCurr: state_type] :
      ( v152417(VarCurr)
    <=> v152419(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2380,axiom,
    ! [VarCurr: state_type] :
      ( v152419(VarCurr)
    <=> ( ( v152421(VarCurr,4)
        <=> $false )
        & ( v152421(VarCurr,3)
        <=> $false )
        & ( v152421(VarCurr,2)
        <=> $false )
        & ( v152421(VarCurr,1)
        <=> $false )
        & ( v152421(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152421(VarCurr,B)
      <=> v152423(VarCurr,B) ) ) ).

tff(addAssignment_85663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152423(VarCurr,B)
      <=> v152425(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152501(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152425(VarNext,B)
            <=> v152425(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2275,axiom,
    ! [VarNext: state_type] :
      ( v152501(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152425(VarNext,B)
          <=> v152511(VarNext,B) ) ) ) ).

tff(addAssignment_85662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152511(VarNext,B)
          <=> v152509(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152512(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152509(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1702,axiom,
    ! [VarCurr: state_type] :
      ( v152512(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152509(VarCurr,B)
          <=> v152443(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20348,axiom,
    ! [VarCurr: state_type] :
      ( v152512(VarCurr)
    <=> ( v152513(VarCurr)
        & v152514(VarCurr) ) ) ).

tff(writeUnaryOperator_11626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152514(VarCurr)
    <=> v152435(VarCurr) ) ).

tff(writeUnaryOperator_11625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152513(VarCurr)
    <=> v152427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152501(VarNext)
      <=> v152502(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152502(VarNext)
      <=> ( v152503(VarNext)
          & v152494(VarNext) ) ) ) ).

tff(writeUnaryOperator_11624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152503(VarNext)
      <=> v152505(VarNext) ) ) ).

tff(addAssignment_85661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152505(VarNext)
      <=> v152494(VarCurr) ) ) ).

tff(addAssignment_85660,axiom,
    ! [VarCurr: state_type] :
      ( v152494(VarCurr)
    <=> v152496(VarCurr) ) ).

tff(addAssignment_85659,axiom,
    ! [VarCurr: state_type] :
      ( v152496(VarCurr)
    <=> v152498(VarCurr) ) ).

tff(addAssignment_85658,axiom,
    ! [VarCurr: state_type] :
      ( v152498(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152443(VarCurr,B)
      <=> v152445(VarCurr,B) ) ) ).

tff(addAssignment_85656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152445(VarCurr,B)
      <=> v152447(VarCurr,B) ) ) ).

tff(addAssignment_85655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152447(VarCurr,B)
      <=> v152449(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152449(VarCurr,B)
          <=> v152463(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1701,axiom,
    ! [VarCurr: state_type] :
      ( v152462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152449(VarCurr,B)
          <=> v152460(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152464(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152463(VarCurr,B)
          <=> v152465(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1700,axiom,
    ! [VarCurr: state_type] :
      ( v152464(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152463(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85654,axiom,
    ! [VarCurr: state_type] :
      ( v152465(VarCurr,0)
    <=> v152491(VarCurr) ) ).

tff(addAssignment_85653,axiom,
    ! [VarCurr: state_type] :
      ( v152465(VarCurr,1)
    <=> v152489(VarCurr) ) ).

tff(addAssignment_85652,axiom,
    ! [VarCurr: state_type] :
      ( v152465(VarCurr,2)
    <=> v152485(VarCurr) ) ).

tff(addAssignment_85651,axiom,
    ! [VarCurr: state_type] :
      ( v152465(VarCurr,3)
    <=> v152481(VarCurr) ) ).

tff(addAssignment_85650,axiom,
    ! [VarCurr: state_type] :
      ( v152465(VarCurr,4)
    <=> v152467(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20345,axiom,
    ! [VarCurr: state_type] :
      ( v152489(VarCurr)
    <=> ( v152490(VarCurr)
        & v152492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20344,axiom,
    ! [VarCurr: state_type] :
      ( v152492(VarCurr)
    <=> ( v152421(VarCurr,0)
        | v152476(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7252,axiom,
    ! [VarCurr: state_type] :
      ( v152490(VarCurr)
    <=> ( v152491(VarCurr)
        | v152421(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152491(VarCurr)
    <=> v152421(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20343,axiom,
    ! [VarCurr: state_type] :
      ( v152485(VarCurr)
    <=> ( v152486(VarCurr)
        & v152488(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20342,axiom,
    ! [VarCurr: state_type] :
      ( v152488(VarCurr)
    <=> ( v152474(VarCurr)
        | v152477(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7251,axiom,
    ! [VarCurr: state_type] :
      ( v152486(VarCurr)
    <=> ( v152487(VarCurr)
        | v152421(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152487(VarCurr)
    <=> v152474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20341,axiom,
    ! [VarCurr: state_type] :
      ( v152481(VarCurr)
    <=> ( v152482(VarCurr)
        & v152484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20340,axiom,
    ! [VarCurr: state_type] :
      ( v152484(VarCurr)
    <=> ( v152472(VarCurr)
        | v152478(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7250,axiom,
    ! [VarCurr: state_type] :
      ( v152482(VarCurr)
    <=> ( v152483(VarCurr)
        | v152421(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152483(VarCurr)
    <=> v152472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20339,axiom,
    ! [VarCurr: state_type] :
      ( v152467(VarCurr)
    <=> ( v152468(VarCurr)
        & v152479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20338,axiom,
    ! [VarCurr: state_type] :
      ( v152479(VarCurr)
    <=> ( v152470(VarCurr)
        | v152480(VarCurr) ) ) ).

tff(writeUnaryOperator_11620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152480(VarCurr)
    <=> v152421(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7249,axiom,
    ! [VarCurr: state_type] :
      ( v152468(VarCurr)
    <=> ( v152469(VarCurr)
        | v152421(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152469(VarCurr)
    <=> v152470(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7248,axiom,
    ! [VarCurr: state_type] :
      ( v152470(VarCurr)
    <=> ( v152421(VarCurr,3)
        | v152471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20337,axiom,
    ! [VarCurr: state_type] :
      ( v152471(VarCurr)
    <=> ( v152472(VarCurr)
        & v152478(VarCurr) ) ) ).

tff(writeUnaryOperator_11618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152478(VarCurr)
    <=> v152421(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7247,axiom,
    ! [VarCurr: state_type] :
      ( v152472(VarCurr)
    <=> ( v152421(VarCurr,2)
        | v152473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20336,axiom,
    ! [VarCurr: state_type] :
      ( v152473(VarCurr)
    <=> ( v152474(VarCurr)
        & v152477(VarCurr) ) ) ).

tff(writeUnaryOperator_11617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152477(VarCurr)
    <=> v152421(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7246,axiom,
    ! [VarCurr: state_type] :
      ( v152474(VarCurr)
    <=> ( v152421(VarCurr,1)
        | v152475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20335,axiom,
    ! [VarCurr: state_type] :
      ( v152475(VarCurr)
    <=> ( v152421(VarCurr,0)
        & v152476(VarCurr) ) ) ).

tff(writeUnaryOperator_11616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152476(VarCurr)
    <=> v152421(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2379,axiom,
    ! [VarCurr: state_type] :
      ( v152464(VarCurr)
    <=> ( ( v152421(VarCurr,4)
        <=> $false )
        & ( v152421(VarCurr,3)
        <=> $false )
        & ( v152421(VarCurr,2)
        <=> $false )
        & ( v152421(VarCurr,1)
        <=> $false )
        & ( v152421(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20334,axiom,
    ! [VarCurr: state_type] :
      ( v152462(VarCurr)
    <=> ( v152451(VarCurr)
        & v152458(VarCurr) ) ) ).

tff(addAssignment_85649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152460(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85648,axiom,
    ! [VarCurr: state_type] :
      ( v152458(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20333,axiom,
    ! [VarCurr: state_type] :
      ( v152451(VarCurr)
    <=> ( v152453(VarCurr)
        | v152455(VarCurr) ) ) ).

tff(addAssignment_85647,axiom,
    ! [VarCurr: state_type] :
      ( v152455(VarCurr)
    <=> v110583(VarCurr,5) ) ).

tff(addAssignment_85646,axiom,
    ! [VarCurr: state_type] :
      ( v152453(VarCurr)
    <=> v116(VarCurr,5) ) ).

tff(addAssignment_85645,axiom,
    ! [VarCurr: state_type] :
      ( v152435(VarCurr)
    <=> v152437(VarCurr) ) ).

tff(addAssignment_85644,axiom,
    ! [VarCurr: state_type] :
      ( v152437(VarCurr)
    <=> v152439(VarCurr) ) ).

tff(addAssignment_85643,axiom,
    ! [VarCurr: state_type] :
      ( v152439(VarCurr)
    <=> v152441(VarCurr) ) ).

tff(addAssignment_85642,axiom,
    ! [VarCurr: state_type] :
      ( v152441(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85641,axiom,
    ! [VarCurr: state_type] :
      ( v152427(VarCurr)
    <=> v152429(VarCurr) ) ).

tff(addAssignment_85640,axiom,
    ! [VarCurr: state_type] :
      ( v152429(VarCurr)
    <=> v152431(VarCurr) ) ).

tff(addAssignment_85639,axiom,
    ! [VarCurr: state_type] :
      ( v152431(VarCurr)
    <=> v152433(VarCurr) ) ).

tff(addAssignment_85638,axiom,
    ! [VarCurr: state_type] :
      ( v152433(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85637,axiom,
    ! [VarCurr: state_type] :
      ( v152320(VarCurr)
    <=> v152322(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2378,axiom,
    ! [VarCurr: state_type] :
      ( v152322(VarCurr)
    <=> ( ( v152324(VarCurr,4)
        <=> $false )
        & ( v152324(VarCurr,3)
        <=> $false )
        & ( v152324(VarCurr,2)
        <=> $false )
        & ( v152324(VarCurr,1)
        <=> $false )
        & ( v152324(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152324(VarCurr,B)
      <=> v152326(VarCurr,B) ) ) ).

tff(addAssignment_85635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152326(VarCurr,B)
      <=> v152328(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152399(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152328(VarNext,B)
            <=> v152328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2274,axiom,
    ! [VarNext: state_type] :
      ( v152399(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152328(VarNext,B)
          <=> v152409(VarNext,B) ) ) ) ).

tff(addAssignment_85634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152409(VarNext,B)
          <=> v152407(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152410(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152407(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1699,axiom,
    ! [VarCurr: state_type] :
      ( v152410(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152407(VarCurr,B)
          <=> v152338(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20332,axiom,
    ! [VarCurr: state_type] :
      ( v152410(VarCurr)
    <=> ( v152411(VarCurr)
        & v152412(VarCurr) ) ) ).

tff(writeUnaryOperator_11615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152412(VarCurr)
    <=> v152334(VarCurr) ) ).

tff(writeUnaryOperator_11614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152411(VarCurr)
    <=> v152330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152399(VarNext)
      <=> v152400(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152400(VarNext)
      <=> ( v152401(VarNext)
          & v152394(VarNext) ) ) ) ).

tff(writeUnaryOperator_11613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152401(VarNext)
      <=> v152403(VarNext) ) ) ).

tff(addAssignment_85633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152403(VarNext)
      <=> v152394(VarCurr) ) ) ).

tff(addAssignment_85632,axiom,
    ! [VarCurr: state_type] :
      ( v152394(VarCurr)
    <=> v152396(VarCurr) ) ).

tff(addAssignment_85631,axiom,
    ! [VarCurr: state_type] :
      ( v152396(VarCurr)
    <=> v152299(VarCurr) ) ).

tff(addAssignment_85630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152338(VarCurr,B)
      <=> v152340(VarCurr,B) ) ) ).

tff(addAssignment_85629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152340(VarCurr,B)
      <=> v152342(VarCurr,B) ) ) ).

tff(addAssignment_85628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152342(VarCurr,B)
      <=> v152344(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152344(VarCurr,B)
          <=> v152363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1698,axiom,
    ! [VarCurr: state_type] :
      ( v152359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152344(VarCurr,B)
          <=> v152360(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152364(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152363(VarCurr,B)
          <=> v152365(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1697,axiom,
    ! [VarCurr: state_type] :
      ( v152364(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152363(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85627,axiom,
    ! [VarCurr: state_type] :
      ( v152365(VarCurr,0)
    <=> v152391(VarCurr) ) ).

tff(addAssignment_85626,axiom,
    ! [VarCurr: state_type] :
      ( v152365(VarCurr,1)
    <=> v152389(VarCurr) ) ).

tff(addAssignment_85625,axiom,
    ! [VarCurr: state_type] :
      ( v152365(VarCurr,2)
    <=> v152385(VarCurr) ) ).

tff(addAssignment_85624,axiom,
    ! [VarCurr: state_type] :
      ( v152365(VarCurr,3)
    <=> v152381(VarCurr) ) ).

tff(addAssignment_85623,axiom,
    ! [VarCurr: state_type] :
      ( v152365(VarCurr,4)
    <=> v152367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20329,axiom,
    ! [VarCurr: state_type] :
      ( v152389(VarCurr)
    <=> ( v152390(VarCurr)
        & v152392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20328,axiom,
    ! [VarCurr: state_type] :
      ( v152392(VarCurr)
    <=> ( v152324(VarCurr,0)
        | v152376(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7245,axiom,
    ! [VarCurr: state_type] :
      ( v152390(VarCurr)
    <=> ( v152391(VarCurr)
        | v152324(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152391(VarCurr)
    <=> v152324(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20327,axiom,
    ! [VarCurr: state_type] :
      ( v152385(VarCurr)
    <=> ( v152386(VarCurr)
        & v152388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20326,axiom,
    ! [VarCurr: state_type] :
      ( v152388(VarCurr)
    <=> ( v152374(VarCurr)
        | v152377(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7244,axiom,
    ! [VarCurr: state_type] :
      ( v152386(VarCurr)
    <=> ( v152387(VarCurr)
        | v152324(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152387(VarCurr)
    <=> v152374(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20325,axiom,
    ! [VarCurr: state_type] :
      ( v152381(VarCurr)
    <=> ( v152382(VarCurr)
        & v152384(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20324,axiom,
    ! [VarCurr: state_type] :
      ( v152384(VarCurr)
    <=> ( v152372(VarCurr)
        | v152378(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7243,axiom,
    ! [VarCurr: state_type] :
      ( v152382(VarCurr)
    <=> ( v152383(VarCurr)
        | v152324(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152383(VarCurr)
    <=> v152372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20323,axiom,
    ! [VarCurr: state_type] :
      ( v152367(VarCurr)
    <=> ( v152368(VarCurr)
        & v152379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20322,axiom,
    ! [VarCurr: state_type] :
      ( v152379(VarCurr)
    <=> ( v152370(VarCurr)
        | v152380(VarCurr) ) ) ).

tff(writeUnaryOperator_11609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152380(VarCurr)
    <=> v152324(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7242,axiom,
    ! [VarCurr: state_type] :
      ( v152368(VarCurr)
    <=> ( v152369(VarCurr)
        | v152324(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152369(VarCurr)
    <=> v152370(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7241,axiom,
    ! [VarCurr: state_type] :
      ( v152370(VarCurr)
    <=> ( v152324(VarCurr,3)
        | v152371(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20321,axiom,
    ! [VarCurr: state_type] :
      ( v152371(VarCurr)
    <=> ( v152372(VarCurr)
        & v152378(VarCurr) ) ) ).

tff(writeUnaryOperator_11607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152378(VarCurr)
    <=> v152324(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7240,axiom,
    ! [VarCurr: state_type] :
      ( v152372(VarCurr)
    <=> ( v152324(VarCurr,2)
        | v152373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20320,axiom,
    ! [VarCurr: state_type] :
      ( v152373(VarCurr)
    <=> ( v152374(VarCurr)
        & v152377(VarCurr) ) ) ).

tff(writeUnaryOperator_11606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152377(VarCurr)
    <=> v152324(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7239,axiom,
    ! [VarCurr: state_type] :
      ( v152374(VarCurr)
    <=> ( v152324(VarCurr,1)
        | v152375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20319,axiom,
    ! [VarCurr: state_type] :
      ( v152375(VarCurr)
    <=> ( v152324(VarCurr,0)
        & v152376(VarCurr) ) ) ).

tff(writeUnaryOperator_11605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152376(VarCurr)
    <=> v152324(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2377,axiom,
    ! [VarCurr: state_type] :
      ( v152364(VarCurr)
    <=> ( ( v152324(VarCurr,4)
        <=> $false )
        & ( v152324(VarCurr,3)
        <=> $false )
        & ( v152324(VarCurr,2)
        <=> $false )
        & ( v152324(VarCurr,1)
        <=> $false )
        & ( v152324(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152361(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152360(VarCurr,B)
          <=> v152357(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1696,axiom,
    ! [VarCurr: state_type] :
      ( v152361(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152360(VarCurr,B)
          <=> v152355(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20318,axiom,
    ! [VarCurr: state_type] :
      ( v152361(VarCurr)
    <=> ( v152362(VarCurr)
        | v152350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20317,axiom,
    ! [VarCurr: state_type] :
      ( v152362(VarCurr)
    <=> ( v152353(VarCurr)
        & v152348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20316,axiom,
    ! [VarCurr: state_type] :
      ( v152359(VarCurr)
    <=> ( v152346(VarCurr)
        & v152259(VarCurr) ) ) ).

tff(addAssignment_85622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152357(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152355(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85620,axiom,
    ! [VarCurr: state_type] :
      ( v152353(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20315,axiom,
    ! [VarCurr: state_type] :
      ( v152346(VarCurr)
    <=> ( v152348(VarCurr)
        | v152350(VarCurr) ) ) ).

tff(addAssignment_85619,axiom,
    ! [VarCurr: state_type] :
      ( v152350(VarCurr)
    <=> v110563(VarCurr,4) ) ).

tff(addAssignment_85618,axiom,
    ! [VarCurr: state_type] :
      ( v152348(VarCurr)
    <=> v108901(VarCurr,4) ) ).

tff(addAssignment_85617,axiom,
    ! [VarCurr: state_type] :
      ( v152334(VarCurr)
    <=> v152336(VarCurr) ) ).

tff(addAssignment_85616,axiom,
    ! [VarCurr: state_type] :
      ( v152336(VarCurr)
    <=> v152240(VarCurr) ) ).

tff(addAssignment_85615,axiom,
    ! [VarCurr: state_type] :
      ( v152330(VarCurr)
    <=> v152332(VarCurr) ) ).

tff(addAssignment_85614,axiom,
    ! [VarCurr: state_type] :
      ( v152332(VarCurr)
    <=> v152232(VarCurr) ) ).

tff(addAssignment_85613,axiom,
    ! [VarCurr: state_type] :
      ( v152218(VarCurr)
    <=> v152220(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2376,axiom,
    ! [VarCurr: state_type] :
      ( v152220(VarCurr)
    <=> ( ( v152222(VarCurr,4)
        <=> $false )
        & ( v152222(VarCurr,3)
        <=> $false )
        & ( v152222(VarCurr,2)
        <=> $false )
        & ( v152222(VarCurr,1)
        <=> $false )
        & ( v152222(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152222(VarCurr,B)
      <=> v152224(VarCurr,B) ) ) ).

tff(addAssignment_85611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152224(VarCurr,B)
      <=> v152226(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152302(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152226(VarNext,B)
            <=> v152226(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2273,axiom,
    ! [VarNext: state_type] :
      ( v152302(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152226(VarNext,B)
          <=> v152312(VarNext,B) ) ) ) ).

tff(addAssignment_85610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152312(VarNext,B)
          <=> v152310(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152313(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152310(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1695,axiom,
    ! [VarCurr: state_type] :
      ( v152313(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152310(VarCurr,B)
          <=> v152244(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20314,axiom,
    ! [VarCurr: state_type] :
      ( v152313(VarCurr)
    <=> ( v152314(VarCurr)
        & v152315(VarCurr) ) ) ).

tff(writeUnaryOperator_11604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152315(VarCurr)
    <=> v152236(VarCurr) ) ).

tff(writeUnaryOperator_11603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152314(VarCurr)
    <=> v152228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152302(VarNext)
      <=> v152303(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152303(VarNext)
      <=> ( v152304(VarNext)
          & v152295(VarNext) ) ) ) ).

tff(writeUnaryOperator_11602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152304(VarNext)
      <=> v152306(VarNext) ) ) ).

tff(addAssignment_85609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152306(VarNext)
      <=> v152295(VarCurr) ) ) ).

tff(addAssignment_85608,axiom,
    ! [VarCurr: state_type] :
      ( v152295(VarCurr)
    <=> v152297(VarCurr) ) ).

tff(addAssignment_85607,axiom,
    ! [VarCurr: state_type] :
      ( v152297(VarCurr)
    <=> v152299(VarCurr) ) ).

tff(addAssignment_85606,axiom,
    ! [VarCurr: state_type] :
      ( v152299(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152244(VarCurr,B)
      <=> v152246(VarCurr,B) ) ) ).

tff(addAssignment_85604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152246(VarCurr,B)
      <=> v152248(VarCurr,B) ) ) ).

tff(addAssignment_85603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152248(VarCurr,B)
      <=> v152250(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152250(VarCurr,B)
          <=> v152264(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1694,axiom,
    ! [VarCurr: state_type] :
      ( v152263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152250(VarCurr,B)
          <=> v152261(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152265(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152264(VarCurr,B)
          <=> v152266(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1693,axiom,
    ! [VarCurr: state_type] :
      ( v152265(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152264(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85602,axiom,
    ! [VarCurr: state_type] :
      ( v152266(VarCurr,0)
    <=> v152292(VarCurr) ) ).

tff(addAssignment_85601,axiom,
    ! [VarCurr: state_type] :
      ( v152266(VarCurr,1)
    <=> v152290(VarCurr) ) ).

tff(addAssignment_85600,axiom,
    ! [VarCurr: state_type] :
      ( v152266(VarCurr,2)
    <=> v152286(VarCurr) ) ).

tff(addAssignment_85599,axiom,
    ! [VarCurr: state_type] :
      ( v152266(VarCurr,3)
    <=> v152282(VarCurr) ) ).

tff(addAssignment_85598,axiom,
    ! [VarCurr: state_type] :
      ( v152266(VarCurr,4)
    <=> v152268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20311,axiom,
    ! [VarCurr: state_type] :
      ( v152290(VarCurr)
    <=> ( v152291(VarCurr)
        & v152293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20310,axiom,
    ! [VarCurr: state_type] :
      ( v152293(VarCurr)
    <=> ( v152222(VarCurr,0)
        | v152277(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7238,axiom,
    ! [VarCurr: state_type] :
      ( v152291(VarCurr)
    <=> ( v152292(VarCurr)
        | v152222(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152292(VarCurr)
    <=> v152222(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20309,axiom,
    ! [VarCurr: state_type] :
      ( v152286(VarCurr)
    <=> ( v152287(VarCurr)
        & v152289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20308,axiom,
    ! [VarCurr: state_type] :
      ( v152289(VarCurr)
    <=> ( v152275(VarCurr)
        | v152278(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7237,axiom,
    ! [VarCurr: state_type] :
      ( v152287(VarCurr)
    <=> ( v152288(VarCurr)
        | v152222(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152288(VarCurr)
    <=> v152275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20307,axiom,
    ! [VarCurr: state_type] :
      ( v152282(VarCurr)
    <=> ( v152283(VarCurr)
        & v152285(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20306,axiom,
    ! [VarCurr: state_type] :
      ( v152285(VarCurr)
    <=> ( v152273(VarCurr)
        | v152279(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7236,axiom,
    ! [VarCurr: state_type] :
      ( v152283(VarCurr)
    <=> ( v152284(VarCurr)
        | v152222(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152284(VarCurr)
    <=> v152273(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20305,axiom,
    ! [VarCurr: state_type] :
      ( v152268(VarCurr)
    <=> ( v152269(VarCurr)
        & v152280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20304,axiom,
    ! [VarCurr: state_type] :
      ( v152280(VarCurr)
    <=> ( v152271(VarCurr)
        | v152281(VarCurr) ) ) ).

tff(writeUnaryOperator_11598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152281(VarCurr)
    <=> v152222(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7235,axiom,
    ! [VarCurr: state_type] :
      ( v152269(VarCurr)
    <=> ( v152270(VarCurr)
        | v152222(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152270(VarCurr)
    <=> v152271(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7234,axiom,
    ! [VarCurr: state_type] :
      ( v152271(VarCurr)
    <=> ( v152222(VarCurr,3)
        | v152272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20303,axiom,
    ! [VarCurr: state_type] :
      ( v152272(VarCurr)
    <=> ( v152273(VarCurr)
        & v152279(VarCurr) ) ) ).

tff(writeUnaryOperator_11596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152279(VarCurr)
    <=> v152222(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7233,axiom,
    ! [VarCurr: state_type] :
      ( v152273(VarCurr)
    <=> ( v152222(VarCurr,2)
        | v152274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20302,axiom,
    ! [VarCurr: state_type] :
      ( v152274(VarCurr)
    <=> ( v152275(VarCurr)
        & v152278(VarCurr) ) ) ).

tff(writeUnaryOperator_11595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152278(VarCurr)
    <=> v152222(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7232,axiom,
    ! [VarCurr: state_type] :
      ( v152275(VarCurr)
    <=> ( v152222(VarCurr,1)
        | v152276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20301,axiom,
    ! [VarCurr: state_type] :
      ( v152276(VarCurr)
    <=> ( v152222(VarCurr,0)
        & v152277(VarCurr) ) ) ).

tff(writeUnaryOperator_11594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152277(VarCurr)
    <=> v152222(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2375,axiom,
    ! [VarCurr: state_type] :
      ( v152265(VarCurr)
    <=> ( ( v152222(VarCurr,4)
        <=> $false )
        & ( v152222(VarCurr,3)
        <=> $false )
        & ( v152222(VarCurr,2)
        <=> $false )
        & ( v152222(VarCurr,1)
        <=> $false )
        & ( v152222(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20300,axiom,
    ! [VarCurr: state_type] :
      ( v152263(VarCurr)
    <=> ( v152252(VarCurr)
        & v152259(VarCurr) ) ) ).

tff(addAssignment_85597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152261(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85596,axiom,
    ! [VarCurr: state_type] :
      ( v152259(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20299,axiom,
    ! [VarCurr: state_type] :
      ( v152252(VarCurr)
    <=> ( v152254(VarCurr)
        | v152256(VarCurr) ) ) ).

tff(addAssignment_85595,axiom,
    ! [VarCurr: state_type] :
      ( v152256(VarCurr)
    <=> v110583(VarCurr,4) ) ).

tff(addAssignment_85594,axiom,
    ! [VarCurr: state_type] :
      ( v152254(VarCurr)
    <=> v116(VarCurr,4) ) ).

tff(addAssignment_85593,axiom,
    ! [VarCurr: state_type] :
      ( v152236(VarCurr)
    <=> v152238(VarCurr) ) ).

tff(addAssignment_85592,axiom,
    ! [VarCurr: state_type] :
      ( v152238(VarCurr)
    <=> v152240(VarCurr) ) ).

tff(addAssignment_85591,axiom,
    ! [VarCurr: state_type] :
      ( v152240(VarCurr)
    <=> v152242(VarCurr) ) ).

tff(addAssignment_85590,axiom,
    ! [VarCurr: state_type] :
      ( v152242(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85589,axiom,
    ! [VarCurr: state_type] :
      ( v152228(VarCurr)
    <=> v152230(VarCurr) ) ).

tff(addAssignment_85588,axiom,
    ! [VarCurr: state_type] :
      ( v152230(VarCurr)
    <=> v152232(VarCurr) ) ).

tff(addAssignment_85587,axiom,
    ! [VarCurr: state_type] :
      ( v152232(VarCurr)
    <=> v152234(VarCurr) ) ).

tff(addAssignment_85586,axiom,
    ! [VarCurr: state_type] :
      ( v152234(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85585,axiom,
    ! [VarCurr: state_type] :
      ( v152121(VarCurr)
    <=> v152123(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2374,axiom,
    ! [VarCurr: state_type] :
      ( v152123(VarCurr)
    <=> ( ( v152125(VarCurr,4)
        <=> $false )
        & ( v152125(VarCurr,3)
        <=> $false )
        & ( v152125(VarCurr,2)
        <=> $false )
        & ( v152125(VarCurr,1)
        <=> $false )
        & ( v152125(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152125(VarCurr,B)
      <=> v152127(VarCurr,B) ) ) ).

tff(addAssignment_85583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152127(VarCurr,B)
      <=> v152129(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152200(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152129(VarNext,B)
            <=> v152129(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2272,axiom,
    ! [VarNext: state_type] :
      ( v152200(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152129(VarNext,B)
          <=> v152210(VarNext,B) ) ) ) ).

tff(addAssignment_85582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152210(VarNext,B)
          <=> v152208(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152211(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152208(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1692,axiom,
    ! [VarCurr: state_type] :
      ( v152211(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152208(VarCurr,B)
          <=> v152139(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20298,axiom,
    ! [VarCurr: state_type] :
      ( v152211(VarCurr)
    <=> ( v152212(VarCurr)
        & v152213(VarCurr) ) ) ).

tff(writeUnaryOperator_11593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152213(VarCurr)
    <=> v152135(VarCurr) ) ).

tff(writeUnaryOperator_11592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152212(VarCurr)
    <=> v152131(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152200(VarNext)
      <=> v152201(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152201(VarNext)
      <=> ( v152202(VarNext)
          & v152195(VarNext) ) ) ) ).

tff(writeUnaryOperator_11591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152202(VarNext)
      <=> v152204(VarNext) ) ) ).

tff(addAssignment_85581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152204(VarNext)
      <=> v152195(VarCurr) ) ) ).

tff(addAssignment_85580,axiom,
    ! [VarCurr: state_type] :
      ( v152195(VarCurr)
    <=> v152197(VarCurr) ) ).

tff(addAssignment_85579,axiom,
    ! [VarCurr: state_type] :
      ( v152197(VarCurr)
    <=> v152100(VarCurr) ) ).

tff(addAssignment_85578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152139(VarCurr,B)
      <=> v152141(VarCurr,B) ) ) ).

tff(addAssignment_85577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152141(VarCurr,B)
      <=> v152143(VarCurr,B) ) ) ).

tff(addAssignment_85576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152143(VarCurr,B)
      <=> v152145(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152160(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152145(VarCurr,B)
          <=> v152164(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1691,axiom,
    ! [VarCurr: state_type] :
      ( v152160(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152145(VarCurr,B)
          <=> v152161(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152165(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152164(VarCurr,B)
          <=> v152166(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1690,axiom,
    ! [VarCurr: state_type] :
      ( v152165(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152164(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85575,axiom,
    ! [VarCurr: state_type] :
      ( v152166(VarCurr,0)
    <=> v152192(VarCurr) ) ).

tff(addAssignment_85574,axiom,
    ! [VarCurr: state_type] :
      ( v152166(VarCurr,1)
    <=> v152190(VarCurr) ) ).

tff(addAssignment_85573,axiom,
    ! [VarCurr: state_type] :
      ( v152166(VarCurr,2)
    <=> v152186(VarCurr) ) ).

tff(addAssignment_85572,axiom,
    ! [VarCurr: state_type] :
      ( v152166(VarCurr,3)
    <=> v152182(VarCurr) ) ).

tff(addAssignment_85571,axiom,
    ! [VarCurr: state_type] :
      ( v152166(VarCurr,4)
    <=> v152168(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20295,axiom,
    ! [VarCurr: state_type] :
      ( v152190(VarCurr)
    <=> ( v152191(VarCurr)
        & v152193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20294,axiom,
    ! [VarCurr: state_type] :
      ( v152193(VarCurr)
    <=> ( v152125(VarCurr,0)
        | v152177(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7231,axiom,
    ! [VarCurr: state_type] :
      ( v152191(VarCurr)
    <=> ( v152192(VarCurr)
        | v152125(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152192(VarCurr)
    <=> v152125(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20293,axiom,
    ! [VarCurr: state_type] :
      ( v152186(VarCurr)
    <=> ( v152187(VarCurr)
        & v152189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20292,axiom,
    ! [VarCurr: state_type] :
      ( v152189(VarCurr)
    <=> ( v152175(VarCurr)
        | v152178(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7230,axiom,
    ! [VarCurr: state_type] :
      ( v152187(VarCurr)
    <=> ( v152188(VarCurr)
        | v152125(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152188(VarCurr)
    <=> v152175(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20291,axiom,
    ! [VarCurr: state_type] :
      ( v152182(VarCurr)
    <=> ( v152183(VarCurr)
        & v152185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20290,axiom,
    ! [VarCurr: state_type] :
      ( v152185(VarCurr)
    <=> ( v152173(VarCurr)
        | v152179(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7229,axiom,
    ! [VarCurr: state_type] :
      ( v152183(VarCurr)
    <=> ( v152184(VarCurr)
        | v152125(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152184(VarCurr)
    <=> v152173(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20289,axiom,
    ! [VarCurr: state_type] :
      ( v152168(VarCurr)
    <=> ( v152169(VarCurr)
        & v152180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20288,axiom,
    ! [VarCurr: state_type] :
      ( v152180(VarCurr)
    <=> ( v152171(VarCurr)
        | v152181(VarCurr) ) ) ).

tff(writeUnaryOperator_11587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152181(VarCurr)
    <=> v152125(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7228,axiom,
    ! [VarCurr: state_type] :
      ( v152169(VarCurr)
    <=> ( v152170(VarCurr)
        | v152125(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152170(VarCurr)
    <=> v152171(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7227,axiom,
    ! [VarCurr: state_type] :
      ( v152171(VarCurr)
    <=> ( v152125(VarCurr,3)
        | v152172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20287,axiom,
    ! [VarCurr: state_type] :
      ( v152172(VarCurr)
    <=> ( v152173(VarCurr)
        & v152179(VarCurr) ) ) ).

tff(writeUnaryOperator_11585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152179(VarCurr)
    <=> v152125(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7226,axiom,
    ! [VarCurr: state_type] :
      ( v152173(VarCurr)
    <=> ( v152125(VarCurr,2)
        | v152174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20286,axiom,
    ! [VarCurr: state_type] :
      ( v152174(VarCurr)
    <=> ( v152175(VarCurr)
        & v152178(VarCurr) ) ) ).

tff(writeUnaryOperator_11584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152178(VarCurr)
    <=> v152125(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7225,axiom,
    ! [VarCurr: state_type] :
      ( v152175(VarCurr)
    <=> ( v152125(VarCurr,1)
        | v152176(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20285,axiom,
    ! [VarCurr: state_type] :
      ( v152176(VarCurr)
    <=> ( v152125(VarCurr,0)
        & v152177(VarCurr) ) ) ).

tff(writeUnaryOperator_11583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152177(VarCurr)
    <=> v152125(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2373,axiom,
    ! [VarCurr: state_type] :
      ( v152165(VarCurr)
    <=> ( ( v152125(VarCurr,4)
        <=> $false )
        & ( v152125(VarCurr,3)
        <=> $false )
        & ( v152125(VarCurr,2)
        <=> $false )
        & ( v152125(VarCurr,1)
        <=> $false )
        & ( v152125(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152162(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152161(VarCurr,B)
          <=> v152158(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1689,axiom,
    ! [VarCurr: state_type] :
      ( v152162(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152161(VarCurr,B)
          <=> v152156(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20284,axiom,
    ! [VarCurr: state_type] :
      ( v152162(VarCurr)
    <=> ( v152163(VarCurr)
        | v152151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20283,axiom,
    ! [VarCurr: state_type] :
      ( v152163(VarCurr)
    <=> ( v152154(VarCurr)
        & v152149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20282,axiom,
    ! [VarCurr: state_type] :
      ( v152160(VarCurr)
    <=> ( v152147(VarCurr)
        & v152060(VarCurr) ) ) ).

tff(addAssignment_85570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152158(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152156(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85568,axiom,
    ! [VarCurr: state_type] :
      ( v152154(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20281,axiom,
    ! [VarCurr: state_type] :
      ( v152147(VarCurr)
    <=> ( v152149(VarCurr)
        | v152151(VarCurr) ) ) ).

tff(addAssignment_85567,axiom,
    ! [VarCurr: state_type] :
      ( v152151(VarCurr)
    <=> v110563(VarCurr,3) ) ).

tff(addAssignment_85566,axiom,
    ! [VarCurr: state_type] :
      ( v152149(VarCurr)
    <=> v108901(VarCurr,3) ) ).

tff(addAssignment_85565,axiom,
    ! [VarCurr: state_type] :
      ( v152135(VarCurr)
    <=> v152137(VarCurr) ) ).

tff(addAssignment_85564,axiom,
    ! [VarCurr: state_type] :
      ( v152137(VarCurr)
    <=> v152041(VarCurr) ) ).

tff(addAssignment_85563,axiom,
    ! [VarCurr: state_type] :
      ( v152131(VarCurr)
    <=> v152133(VarCurr) ) ).

tff(addAssignment_85562,axiom,
    ! [VarCurr: state_type] :
      ( v152133(VarCurr)
    <=> v152033(VarCurr) ) ).

tff(addAssignment_85561,axiom,
    ! [VarCurr: state_type] :
      ( v152019(VarCurr)
    <=> v152021(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2372,axiom,
    ! [VarCurr: state_type] :
      ( v152021(VarCurr)
    <=> ( ( v152023(VarCurr,4)
        <=> $false )
        & ( v152023(VarCurr,3)
        <=> $false )
        & ( v152023(VarCurr,2)
        <=> $false )
        & ( v152023(VarCurr,1)
        <=> $false )
        & ( v152023(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152023(VarCurr,B)
      <=> v152025(VarCurr,B) ) ) ).

tff(addAssignment_85559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152025(VarCurr,B)
      <=> v152027(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152103(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v152027(VarNext,B)
            <=> v152027(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2271,axiom,
    ! [VarNext: state_type] :
      ( v152103(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152027(VarNext,B)
          <=> v152113(VarNext,B) ) ) ) ).

tff(addAssignment_85558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152113(VarNext,B)
          <=> v152111(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152114(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152111(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1688,axiom,
    ! [VarCurr: state_type] :
      ( v152114(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152111(VarCurr,B)
          <=> v152045(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20280,axiom,
    ! [VarCurr: state_type] :
      ( v152114(VarCurr)
    <=> ( v152115(VarCurr)
        & v152116(VarCurr) ) ) ).

tff(writeUnaryOperator_11582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152116(VarCurr)
    <=> v152037(VarCurr) ) ).

tff(writeUnaryOperator_11581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152115(VarCurr)
    <=> v152029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152103(VarNext)
      <=> v152104(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152104(VarNext)
      <=> ( v152105(VarNext)
          & v152096(VarNext) ) ) ) ).

tff(writeUnaryOperator_11580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152105(VarNext)
      <=> v152107(VarNext) ) ) ).

tff(addAssignment_85557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152107(VarNext)
      <=> v152096(VarCurr) ) ) ).

tff(addAssignment_85556,axiom,
    ! [VarCurr: state_type] :
      ( v152096(VarCurr)
    <=> v152098(VarCurr) ) ).

tff(addAssignment_85555,axiom,
    ! [VarCurr: state_type] :
      ( v152098(VarCurr)
    <=> v152100(VarCurr) ) ).

tff(addAssignment_85554,axiom,
    ! [VarCurr: state_type] :
      ( v152100(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152045(VarCurr,B)
      <=> v152047(VarCurr,B) ) ) ).

tff(addAssignment_85552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152047(VarCurr,B)
      <=> v152049(VarCurr,B) ) ) ).

tff(addAssignment_85551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152049(VarCurr,B)
      <=> v152051(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152064(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152051(VarCurr,B)
          <=> v152065(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1687,axiom,
    ! [VarCurr: state_type] :
      ( v152064(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152051(VarCurr,B)
          <=> v152062(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152066(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152065(VarCurr,B)
          <=> v152067(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1686,axiom,
    ! [VarCurr: state_type] :
      ( v152066(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152065(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85550,axiom,
    ! [VarCurr: state_type] :
      ( v152067(VarCurr,0)
    <=> v152093(VarCurr) ) ).

tff(addAssignment_85549,axiom,
    ! [VarCurr: state_type] :
      ( v152067(VarCurr,1)
    <=> v152091(VarCurr) ) ).

tff(addAssignment_85548,axiom,
    ! [VarCurr: state_type] :
      ( v152067(VarCurr,2)
    <=> v152087(VarCurr) ) ).

tff(addAssignment_85547,axiom,
    ! [VarCurr: state_type] :
      ( v152067(VarCurr,3)
    <=> v152083(VarCurr) ) ).

tff(addAssignment_85546,axiom,
    ! [VarCurr: state_type] :
      ( v152067(VarCurr,4)
    <=> v152069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20277,axiom,
    ! [VarCurr: state_type] :
      ( v152091(VarCurr)
    <=> ( v152092(VarCurr)
        & v152094(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20276,axiom,
    ! [VarCurr: state_type] :
      ( v152094(VarCurr)
    <=> ( v152023(VarCurr,0)
        | v152078(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7224,axiom,
    ! [VarCurr: state_type] :
      ( v152092(VarCurr)
    <=> ( v152093(VarCurr)
        | v152023(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152093(VarCurr)
    <=> v152023(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20275,axiom,
    ! [VarCurr: state_type] :
      ( v152087(VarCurr)
    <=> ( v152088(VarCurr)
        & v152090(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20274,axiom,
    ! [VarCurr: state_type] :
      ( v152090(VarCurr)
    <=> ( v152076(VarCurr)
        | v152079(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7223,axiom,
    ! [VarCurr: state_type] :
      ( v152088(VarCurr)
    <=> ( v152089(VarCurr)
        | v152023(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152089(VarCurr)
    <=> v152076(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20273,axiom,
    ! [VarCurr: state_type] :
      ( v152083(VarCurr)
    <=> ( v152084(VarCurr)
        & v152086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20272,axiom,
    ! [VarCurr: state_type] :
      ( v152086(VarCurr)
    <=> ( v152074(VarCurr)
        | v152080(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7222,axiom,
    ! [VarCurr: state_type] :
      ( v152084(VarCurr)
    <=> ( v152085(VarCurr)
        | v152023(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152085(VarCurr)
    <=> v152074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20271,axiom,
    ! [VarCurr: state_type] :
      ( v152069(VarCurr)
    <=> ( v152070(VarCurr)
        & v152081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20270,axiom,
    ! [VarCurr: state_type] :
      ( v152081(VarCurr)
    <=> ( v152072(VarCurr)
        | v152082(VarCurr) ) ) ).

tff(writeUnaryOperator_11576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152082(VarCurr)
    <=> v152023(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7221,axiom,
    ! [VarCurr: state_type] :
      ( v152070(VarCurr)
    <=> ( v152071(VarCurr)
        | v152023(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152071(VarCurr)
    <=> v152072(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7220,axiom,
    ! [VarCurr: state_type] :
      ( v152072(VarCurr)
    <=> ( v152023(VarCurr,3)
        | v152073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20269,axiom,
    ! [VarCurr: state_type] :
      ( v152073(VarCurr)
    <=> ( v152074(VarCurr)
        & v152080(VarCurr) ) ) ).

tff(writeUnaryOperator_11574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152080(VarCurr)
    <=> v152023(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7219,axiom,
    ! [VarCurr: state_type] :
      ( v152074(VarCurr)
    <=> ( v152023(VarCurr,2)
        | v152075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20268,axiom,
    ! [VarCurr: state_type] :
      ( v152075(VarCurr)
    <=> ( v152076(VarCurr)
        & v152079(VarCurr) ) ) ).

tff(writeUnaryOperator_11573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152079(VarCurr)
    <=> v152023(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7218,axiom,
    ! [VarCurr: state_type] :
      ( v152076(VarCurr)
    <=> ( v152023(VarCurr,1)
        | v152077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20267,axiom,
    ! [VarCurr: state_type] :
      ( v152077(VarCurr)
    <=> ( v152023(VarCurr,0)
        & v152078(VarCurr) ) ) ).

tff(writeUnaryOperator_11572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152078(VarCurr)
    <=> v152023(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2371,axiom,
    ! [VarCurr: state_type] :
      ( v152066(VarCurr)
    <=> ( ( v152023(VarCurr,4)
        <=> $false )
        & ( v152023(VarCurr,3)
        <=> $false )
        & ( v152023(VarCurr,2)
        <=> $false )
        & ( v152023(VarCurr,1)
        <=> $false )
        & ( v152023(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20266,axiom,
    ! [VarCurr: state_type] :
      ( v152064(VarCurr)
    <=> ( v152053(VarCurr)
        & v152060(VarCurr) ) ) ).

tff(addAssignment_85545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v152062(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85544,axiom,
    ! [VarCurr: state_type] :
      ( v152060(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20265,axiom,
    ! [VarCurr: state_type] :
      ( v152053(VarCurr)
    <=> ( v152055(VarCurr)
        | v152057(VarCurr) ) ) ).

tff(addAssignment_85543,axiom,
    ! [VarCurr: state_type] :
      ( v152057(VarCurr)
    <=> v110583(VarCurr,3) ) ).

tff(addAssignment_85542,axiom,
    ! [VarCurr: state_type] :
      ( v152055(VarCurr)
    <=> v116(VarCurr,3) ) ).

tff(addAssignment_85541,axiom,
    ! [VarCurr: state_type] :
      ( v152037(VarCurr)
    <=> v152039(VarCurr) ) ).

tff(addAssignment_85540,axiom,
    ! [VarCurr: state_type] :
      ( v152039(VarCurr)
    <=> v152041(VarCurr) ) ).

tff(addAssignment_85539,axiom,
    ! [VarCurr: state_type] :
      ( v152041(VarCurr)
    <=> v152043(VarCurr) ) ).

tff(addAssignment_85538,axiom,
    ! [VarCurr: state_type] :
      ( v152043(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85537,axiom,
    ! [VarCurr: state_type] :
      ( v152029(VarCurr)
    <=> v152031(VarCurr) ) ).

tff(addAssignment_85536,axiom,
    ! [VarCurr: state_type] :
      ( v152031(VarCurr)
    <=> v152033(VarCurr) ) ).

tff(addAssignment_85535,axiom,
    ! [VarCurr: state_type] :
      ( v152033(VarCurr)
    <=> v152035(VarCurr) ) ).

tff(addAssignment_85534,axiom,
    ! [VarCurr: state_type] :
      ( v152035(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85533,axiom,
    ! [VarCurr: state_type] :
      ( v151922(VarCurr)
    <=> v151924(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2370,axiom,
    ! [VarCurr: state_type] :
      ( v151924(VarCurr)
    <=> ( ( v151926(VarCurr,4)
        <=> $false )
        & ( v151926(VarCurr,3)
        <=> $false )
        & ( v151926(VarCurr,2)
        <=> $false )
        & ( v151926(VarCurr,1)
        <=> $false )
        & ( v151926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151926(VarCurr,B)
      <=> v151928(VarCurr,B) ) ) ).

tff(addAssignment_85531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151928(VarCurr,B)
      <=> v151930(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152001(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v151930(VarNext,B)
            <=> v151930(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2270,axiom,
    ! [VarNext: state_type] :
      ( v152001(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151930(VarNext,B)
          <=> v152011(VarNext,B) ) ) ) ).

tff(addAssignment_85530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152011(VarNext,B)
          <=> v152009(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152009(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1685,axiom,
    ! [VarCurr: state_type] :
      ( v152012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v152009(VarCurr,B)
          <=> v151940(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20264,axiom,
    ! [VarCurr: state_type] :
      ( v152012(VarCurr)
    <=> ( v152013(VarCurr)
        & v152014(VarCurr) ) ) ).

tff(writeUnaryOperator_11571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152014(VarCurr)
    <=> v151936(VarCurr) ) ).

tff(writeUnaryOperator_11570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v152013(VarCurr)
    <=> v151932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152001(VarNext)
      <=> v152002(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152002(VarNext)
      <=> ( v152003(VarNext)
          & v151996(VarNext) ) ) ) ).

tff(writeUnaryOperator_11569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v152003(VarNext)
      <=> v152005(VarNext) ) ) ).

tff(addAssignment_85529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v152005(VarNext)
      <=> v151996(VarCurr) ) ) ).

tff(addAssignment_85528,axiom,
    ! [VarCurr: state_type] :
      ( v151996(VarCurr)
    <=> v151998(VarCurr) ) ).

tff(addAssignment_85527,axiom,
    ! [VarCurr: state_type] :
      ( v151998(VarCurr)
    <=> v151901(VarCurr) ) ).

tff(addAssignment_85526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151940(VarCurr,B)
      <=> v151942(VarCurr,B) ) ) ).

tff(addAssignment_85525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151942(VarCurr,B)
      <=> v151944(VarCurr,B) ) ) ).

tff(addAssignment_85524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151944(VarCurr,B)
      <=> v151946(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151946(VarCurr,B)
          <=> v151965(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1684,axiom,
    ! [VarCurr: state_type] :
      ( v151961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151946(VarCurr,B)
          <=> v151962(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151966(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151965(VarCurr,B)
          <=> v151967(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1683,axiom,
    ! [VarCurr: state_type] :
      ( v151966(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151965(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85523,axiom,
    ! [VarCurr: state_type] :
      ( v151967(VarCurr,0)
    <=> v151993(VarCurr) ) ).

tff(addAssignment_85522,axiom,
    ! [VarCurr: state_type] :
      ( v151967(VarCurr,1)
    <=> v151991(VarCurr) ) ).

tff(addAssignment_85521,axiom,
    ! [VarCurr: state_type] :
      ( v151967(VarCurr,2)
    <=> v151987(VarCurr) ) ).

tff(addAssignment_85520,axiom,
    ! [VarCurr: state_type] :
      ( v151967(VarCurr,3)
    <=> v151983(VarCurr) ) ).

tff(addAssignment_85519,axiom,
    ! [VarCurr: state_type] :
      ( v151967(VarCurr,4)
    <=> v151969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20261,axiom,
    ! [VarCurr: state_type] :
      ( v151991(VarCurr)
    <=> ( v151992(VarCurr)
        & v151994(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20260,axiom,
    ! [VarCurr: state_type] :
      ( v151994(VarCurr)
    <=> ( v151926(VarCurr,0)
        | v151978(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7217,axiom,
    ! [VarCurr: state_type] :
      ( v151992(VarCurr)
    <=> ( v151993(VarCurr)
        | v151926(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151993(VarCurr)
    <=> v151926(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20259,axiom,
    ! [VarCurr: state_type] :
      ( v151987(VarCurr)
    <=> ( v151988(VarCurr)
        & v151990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20258,axiom,
    ! [VarCurr: state_type] :
      ( v151990(VarCurr)
    <=> ( v151976(VarCurr)
        | v151979(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7216,axiom,
    ! [VarCurr: state_type] :
      ( v151988(VarCurr)
    <=> ( v151989(VarCurr)
        | v151926(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151989(VarCurr)
    <=> v151976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20257,axiom,
    ! [VarCurr: state_type] :
      ( v151983(VarCurr)
    <=> ( v151984(VarCurr)
        & v151986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20256,axiom,
    ! [VarCurr: state_type] :
      ( v151986(VarCurr)
    <=> ( v151974(VarCurr)
        | v151980(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7215,axiom,
    ! [VarCurr: state_type] :
      ( v151984(VarCurr)
    <=> ( v151985(VarCurr)
        | v151926(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151985(VarCurr)
    <=> v151974(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20255,axiom,
    ! [VarCurr: state_type] :
      ( v151969(VarCurr)
    <=> ( v151970(VarCurr)
        & v151981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20254,axiom,
    ! [VarCurr: state_type] :
      ( v151981(VarCurr)
    <=> ( v151972(VarCurr)
        | v151982(VarCurr) ) ) ).

tff(writeUnaryOperator_11565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151982(VarCurr)
    <=> v151926(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7214,axiom,
    ! [VarCurr: state_type] :
      ( v151970(VarCurr)
    <=> ( v151971(VarCurr)
        | v151926(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151971(VarCurr)
    <=> v151972(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7213,axiom,
    ! [VarCurr: state_type] :
      ( v151972(VarCurr)
    <=> ( v151926(VarCurr,3)
        | v151973(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20253,axiom,
    ! [VarCurr: state_type] :
      ( v151973(VarCurr)
    <=> ( v151974(VarCurr)
        & v151980(VarCurr) ) ) ).

tff(writeUnaryOperator_11563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151980(VarCurr)
    <=> v151926(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7212,axiom,
    ! [VarCurr: state_type] :
      ( v151974(VarCurr)
    <=> ( v151926(VarCurr,2)
        | v151975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20252,axiom,
    ! [VarCurr: state_type] :
      ( v151975(VarCurr)
    <=> ( v151976(VarCurr)
        & v151979(VarCurr) ) ) ).

tff(writeUnaryOperator_11562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151979(VarCurr)
    <=> v151926(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7211,axiom,
    ! [VarCurr: state_type] :
      ( v151976(VarCurr)
    <=> ( v151926(VarCurr,1)
        | v151977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20251,axiom,
    ! [VarCurr: state_type] :
      ( v151977(VarCurr)
    <=> ( v151926(VarCurr,0)
        & v151978(VarCurr) ) ) ).

tff(writeUnaryOperator_11561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151978(VarCurr)
    <=> v151926(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2369,axiom,
    ! [VarCurr: state_type] :
      ( v151966(VarCurr)
    <=> ( ( v151926(VarCurr,4)
        <=> $false )
        & ( v151926(VarCurr,3)
        <=> $false )
        & ( v151926(VarCurr,2)
        <=> $false )
        & ( v151926(VarCurr,1)
        <=> $false )
        & ( v151926(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151963(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151962(VarCurr,B)
          <=> v151959(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1682,axiom,
    ! [VarCurr: state_type] :
      ( v151963(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151962(VarCurr,B)
          <=> v151957(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20250,axiom,
    ! [VarCurr: state_type] :
      ( v151963(VarCurr)
    <=> ( v151964(VarCurr)
        | v151952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20249,axiom,
    ! [VarCurr: state_type] :
      ( v151964(VarCurr)
    <=> ( v151955(VarCurr)
        & v151950(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20248,axiom,
    ! [VarCurr: state_type] :
      ( v151961(VarCurr)
    <=> ( v151948(VarCurr)
        & v151861(VarCurr) ) ) ).

tff(addAssignment_85518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151959(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151957(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85516,axiom,
    ! [VarCurr: state_type] :
      ( v151955(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20247,axiom,
    ! [VarCurr: state_type] :
      ( v151948(VarCurr)
    <=> ( v151950(VarCurr)
        | v151952(VarCurr) ) ) ).

tff(addAssignment_85515,axiom,
    ! [VarCurr: state_type] :
      ( v151952(VarCurr)
    <=> v110563(VarCurr,2) ) ).

tff(addAssignment_85514,axiom,
    ! [VarCurr: state_type] :
      ( v151950(VarCurr)
    <=> v108901(VarCurr,2) ) ).

tff(addAssignment_85513,axiom,
    ! [VarCurr: state_type] :
      ( v151936(VarCurr)
    <=> v151938(VarCurr) ) ).

tff(addAssignment_85512,axiom,
    ! [VarCurr: state_type] :
      ( v151938(VarCurr)
    <=> v151842(VarCurr) ) ).

tff(addAssignment_85511,axiom,
    ! [VarCurr: state_type] :
      ( v151932(VarCurr)
    <=> v151934(VarCurr) ) ).

tff(addAssignment_85510,axiom,
    ! [VarCurr: state_type] :
      ( v151934(VarCurr)
    <=> v151834(VarCurr) ) ).

tff(addAssignment_85509,axiom,
    ! [VarCurr: state_type] :
      ( v151820(VarCurr)
    <=> v151822(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2368,axiom,
    ! [VarCurr: state_type] :
      ( v151822(VarCurr)
    <=> ( ( v151824(VarCurr,4)
        <=> $false )
        & ( v151824(VarCurr,3)
        <=> $false )
        & ( v151824(VarCurr,2)
        <=> $false )
        & ( v151824(VarCurr,1)
        <=> $false )
        & ( v151824(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151824(VarCurr,B)
      <=> v151826(VarCurr,B) ) ) ).

tff(addAssignment_85507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151826(VarCurr,B)
      <=> v151828(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151904(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v151828(VarNext,B)
            <=> v151828(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2269,axiom,
    ! [VarNext: state_type] :
      ( v151904(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151828(VarNext,B)
          <=> v151914(VarNext,B) ) ) ) ).

tff(addAssignment_85506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151914(VarNext,B)
          <=> v151912(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151915(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151912(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1681,axiom,
    ! [VarCurr: state_type] :
      ( v151915(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151912(VarCurr,B)
          <=> v151846(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20246,axiom,
    ! [VarCurr: state_type] :
      ( v151915(VarCurr)
    <=> ( v151916(VarCurr)
        & v151917(VarCurr) ) ) ).

tff(writeUnaryOperator_11560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151917(VarCurr)
    <=> v151838(VarCurr) ) ).

tff(writeUnaryOperator_11559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151916(VarCurr)
    <=> v151830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151904(VarNext)
      <=> v151905(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151905(VarNext)
      <=> ( v151906(VarNext)
          & v151897(VarNext) ) ) ) ).

tff(writeUnaryOperator_11558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151906(VarNext)
      <=> v151908(VarNext) ) ) ).

tff(addAssignment_85505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151908(VarNext)
      <=> v151897(VarCurr) ) ) ).

tff(addAssignment_85504,axiom,
    ! [VarCurr: state_type] :
      ( v151897(VarCurr)
    <=> v151899(VarCurr) ) ).

tff(addAssignment_85503,axiom,
    ! [VarCurr: state_type] :
      ( v151899(VarCurr)
    <=> v151901(VarCurr) ) ).

tff(addAssignment_85502,axiom,
    ! [VarCurr: state_type] :
      ( v151901(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151846(VarCurr,B)
      <=> v151848(VarCurr,B) ) ) ).

tff(addAssignment_85500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151848(VarCurr,B)
      <=> v151850(VarCurr,B) ) ) ).

tff(addAssignment_85499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151850(VarCurr,B)
      <=> v151852(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151865(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151852(VarCurr,B)
          <=> v151866(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1680,axiom,
    ! [VarCurr: state_type] :
      ( v151865(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151852(VarCurr,B)
          <=> v151863(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151867(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151866(VarCurr,B)
          <=> v151868(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1679,axiom,
    ! [VarCurr: state_type] :
      ( v151867(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151866(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85498,axiom,
    ! [VarCurr: state_type] :
      ( v151868(VarCurr,0)
    <=> v151894(VarCurr) ) ).

tff(addAssignment_85497,axiom,
    ! [VarCurr: state_type] :
      ( v151868(VarCurr,1)
    <=> v151892(VarCurr) ) ).

tff(addAssignment_85496,axiom,
    ! [VarCurr: state_type] :
      ( v151868(VarCurr,2)
    <=> v151888(VarCurr) ) ).

tff(addAssignment_85495,axiom,
    ! [VarCurr: state_type] :
      ( v151868(VarCurr,3)
    <=> v151884(VarCurr) ) ).

tff(addAssignment_85494,axiom,
    ! [VarCurr: state_type] :
      ( v151868(VarCurr,4)
    <=> v151870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20243,axiom,
    ! [VarCurr: state_type] :
      ( v151892(VarCurr)
    <=> ( v151893(VarCurr)
        & v151895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20242,axiom,
    ! [VarCurr: state_type] :
      ( v151895(VarCurr)
    <=> ( v151824(VarCurr,0)
        | v151879(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7210,axiom,
    ! [VarCurr: state_type] :
      ( v151893(VarCurr)
    <=> ( v151894(VarCurr)
        | v151824(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151894(VarCurr)
    <=> v151824(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20241,axiom,
    ! [VarCurr: state_type] :
      ( v151888(VarCurr)
    <=> ( v151889(VarCurr)
        & v151891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20240,axiom,
    ! [VarCurr: state_type] :
      ( v151891(VarCurr)
    <=> ( v151877(VarCurr)
        | v151880(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7209,axiom,
    ! [VarCurr: state_type] :
      ( v151889(VarCurr)
    <=> ( v151890(VarCurr)
        | v151824(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151890(VarCurr)
    <=> v151877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20239,axiom,
    ! [VarCurr: state_type] :
      ( v151884(VarCurr)
    <=> ( v151885(VarCurr)
        & v151887(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20238,axiom,
    ! [VarCurr: state_type] :
      ( v151887(VarCurr)
    <=> ( v151875(VarCurr)
        | v151881(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7208,axiom,
    ! [VarCurr: state_type] :
      ( v151885(VarCurr)
    <=> ( v151886(VarCurr)
        | v151824(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151886(VarCurr)
    <=> v151875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20237,axiom,
    ! [VarCurr: state_type] :
      ( v151870(VarCurr)
    <=> ( v151871(VarCurr)
        & v151882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20236,axiom,
    ! [VarCurr: state_type] :
      ( v151882(VarCurr)
    <=> ( v151873(VarCurr)
        | v151883(VarCurr) ) ) ).

tff(writeUnaryOperator_11554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151883(VarCurr)
    <=> v151824(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7207,axiom,
    ! [VarCurr: state_type] :
      ( v151871(VarCurr)
    <=> ( v151872(VarCurr)
        | v151824(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151872(VarCurr)
    <=> v151873(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7206,axiom,
    ! [VarCurr: state_type] :
      ( v151873(VarCurr)
    <=> ( v151824(VarCurr,3)
        | v151874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20235,axiom,
    ! [VarCurr: state_type] :
      ( v151874(VarCurr)
    <=> ( v151875(VarCurr)
        & v151881(VarCurr) ) ) ).

tff(writeUnaryOperator_11552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151881(VarCurr)
    <=> v151824(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7205,axiom,
    ! [VarCurr: state_type] :
      ( v151875(VarCurr)
    <=> ( v151824(VarCurr,2)
        | v151876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20234,axiom,
    ! [VarCurr: state_type] :
      ( v151876(VarCurr)
    <=> ( v151877(VarCurr)
        & v151880(VarCurr) ) ) ).

tff(writeUnaryOperator_11551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151880(VarCurr)
    <=> v151824(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7204,axiom,
    ! [VarCurr: state_type] :
      ( v151877(VarCurr)
    <=> ( v151824(VarCurr,1)
        | v151878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20233,axiom,
    ! [VarCurr: state_type] :
      ( v151878(VarCurr)
    <=> ( v151824(VarCurr,0)
        & v151879(VarCurr) ) ) ).

tff(writeUnaryOperator_11550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151879(VarCurr)
    <=> v151824(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2367,axiom,
    ! [VarCurr: state_type] :
      ( v151867(VarCurr)
    <=> ( ( v151824(VarCurr,4)
        <=> $false )
        & ( v151824(VarCurr,3)
        <=> $false )
        & ( v151824(VarCurr,2)
        <=> $false )
        & ( v151824(VarCurr,1)
        <=> $false )
        & ( v151824(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20232,axiom,
    ! [VarCurr: state_type] :
      ( v151865(VarCurr)
    <=> ( v151854(VarCurr)
        & v151861(VarCurr) ) ) ).

tff(addAssignment_85493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151863(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85492,axiom,
    ! [VarCurr: state_type] :
      ( v151861(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20231,axiom,
    ! [VarCurr: state_type] :
      ( v151854(VarCurr)
    <=> ( v151856(VarCurr)
        | v151858(VarCurr) ) ) ).

tff(addAssignment_85491,axiom,
    ! [VarCurr: state_type] :
      ( v151858(VarCurr)
    <=> v110583(VarCurr,2) ) ).

tff(addAssignment_85490,axiom,
    ! [VarCurr: state_type] :
      ( v151856(VarCurr)
    <=> v116(VarCurr,2) ) ).

tff(addAssignment_85489,axiom,
    ! [VarCurr: state_type] :
      ( v151838(VarCurr)
    <=> v151840(VarCurr) ) ).

tff(addAssignment_85488,axiom,
    ! [VarCurr: state_type] :
      ( v151840(VarCurr)
    <=> v151842(VarCurr) ) ).

tff(addAssignment_85487,axiom,
    ! [VarCurr: state_type] :
      ( v151842(VarCurr)
    <=> v151844(VarCurr) ) ).

tff(addAssignment_85486,axiom,
    ! [VarCurr: state_type] :
      ( v151844(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85485,axiom,
    ! [VarCurr: state_type] :
      ( v151830(VarCurr)
    <=> v151832(VarCurr) ) ).

tff(addAssignment_85484,axiom,
    ! [VarCurr: state_type] :
      ( v151832(VarCurr)
    <=> v151834(VarCurr) ) ).

tff(addAssignment_85483,axiom,
    ! [VarCurr: state_type] :
      ( v151834(VarCurr)
    <=> v151836(VarCurr) ) ).

tff(addAssignment_85482,axiom,
    ! [VarCurr: state_type] :
      ( v151836(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85481,axiom,
    ! [VarCurr: state_type] :
      ( v151723(VarCurr)
    <=> v151725(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2366,axiom,
    ! [VarCurr: state_type] :
      ( v151725(VarCurr)
    <=> ( ( v151727(VarCurr,4)
        <=> $false )
        & ( v151727(VarCurr,3)
        <=> $false )
        & ( v151727(VarCurr,2)
        <=> $false )
        & ( v151727(VarCurr,1)
        <=> $false )
        & ( v151727(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151727(VarCurr,B)
      <=> v151729(VarCurr,B) ) ) ).

tff(addAssignment_85479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151729(VarCurr,B)
      <=> v151731(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151802(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v151731(VarNext,B)
            <=> v151731(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2268,axiom,
    ! [VarNext: state_type] :
      ( v151802(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151731(VarNext,B)
          <=> v151812(VarNext,B) ) ) ) ).

tff(addAssignment_85478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151812(VarNext,B)
          <=> v151810(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151813(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151810(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1678,axiom,
    ! [VarCurr: state_type] :
      ( v151813(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151810(VarCurr,B)
          <=> v151741(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20230,axiom,
    ! [VarCurr: state_type] :
      ( v151813(VarCurr)
    <=> ( v151814(VarCurr)
        & v151815(VarCurr) ) ) ).

tff(writeUnaryOperator_11549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151815(VarCurr)
    <=> v151737(VarCurr) ) ).

tff(writeUnaryOperator_11548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151814(VarCurr)
    <=> v151733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151802(VarNext)
      <=> v151803(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151803(VarNext)
      <=> ( v151804(VarNext)
          & v151797(VarNext) ) ) ) ).

tff(writeUnaryOperator_11547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151804(VarNext)
      <=> v151806(VarNext) ) ) ).

tff(addAssignment_85477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151806(VarNext)
      <=> v151797(VarCurr) ) ) ).

tff(addAssignment_85476,axiom,
    ! [VarCurr: state_type] :
      ( v151797(VarCurr)
    <=> v151799(VarCurr) ) ).

tff(addAssignment_85475,axiom,
    ! [VarCurr: state_type] :
      ( v151799(VarCurr)
    <=> v151702(VarCurr) ) ).

tff(addAssignment_85474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151741(VarCurr,B)
      <=> v151743(VarCurr,B) ) ) ).

tff(addAssignment_85473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151743(VarCurr,B)
      <=> v151745(VarCurr,B) ) ) ).

tff(addAssignment_85472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151745(VarCurr,B)
      <=> v151747(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151747(VarCurr,B)
          <=> v151766(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1677,axiom,
    ! [VarCurr: state_type] :
      ( v151762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151747(VarCurr,B)
          <=> v151763(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151767(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151766(VarCurr,B)
          <=> v151768(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1676,axiom,
    ! [VarCurr: state_type] :
      ( v151767(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151766(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85471,axiom,
    ! [VarCurr: state_type] :
      ( v151768(VarCurr,0)
    <=> v151794(VarCurr) ) ).

tff(addAssignment_85470,axiom,
    ! [VarCurr: state_type] :
      ( v151768(VarCurr,1)
    <=> v151792(VarCurr) ) ).

tff(addAssignment_85469,axiom,
    ! [VarCurr: state_type] :
      ( v151768(VarCurr,2)
    <=> v151788(VarCurr) ) ).

tff(addAssignment_85468,axiom,
    ! [VarCurr: state_type] :
      ( v151768(VarCurr,3)
    <=> v151784(VarCurr) ) ).

tff(addAssignment_85467,axiom,
    ! [VarCurr: state_type] :
      ( v151768(VarCurr,4)
    <=> v151770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20227,axiom,
    ! [VarCurr: state_type] :
      ( v151792(VarCurr)
    <=> ( v151793(VarCurr)
        & v151795(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20226,axiom,
    ! [VarCurr: state_type] :
      ( v151795(VarCurr)
    <=> ( v151727(VarCurr,0)
        | v151779(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7203,axiom,
    ! [VarCurr: state_type] :
      ( v151793(VarCurr)
    <=> ( v151794(VarCurr)
        | v151727(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151794(VarCurr)
    <=> v151727(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20225,axiom,
    ! [VarCurr: state_type] :
      ( v151788(VarCurr)
    <=> ( v151789(VarCurr)
        & v151791(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20224,axiom,
    ! [VarCurr: state_type] :
      ( v151791(VarCurr)
    <=> ( v151777(VarCurr)
        | v151780(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7202,axiom,
    ! [VarCurr: state_type] :
      ( v151789(VarCurr)
    <=> ( v151790(VarCurr)
        | v151727(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151790(VarCurr)
    <=> v151777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20223,axiom,
    ! [VarCurr: state_type] :
      ( v151784(VarCurr)
    <=> ( v151785(VarCurr)
        & v151787(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20222,axiom,
    ! [VarCurr: state_type] :
      ( v151787(VarCurr)
    <=> ( v151775(VarCurr)
        | v151781(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7201,axiom,
    ! [VarCurr: state_type] :
      ( v151785(VarCurr)
    <=> ( v151786(VarCurr)
        | v151727(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151786(VarCurr)
    <=> v151775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20221,axiom,
    ! [VarCurr: state_type] :
      ( v151770(VarCurr)
    <=> ( v151771(VarCurr)
        & v151782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20220,axiom,
    ! [VarCurr: state_type] :
      ( v151782(VarCurr)
    <=> ( v151773(VarCurr)
        | v151783(VarCurr) ) ) ).

tff(writeUnaryOperator_11543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151783(VarCurr)
    <=> v151727(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7200,axiom,
    ! [VarCurr: state_type] :
      ( v151771(VarCurr)
    <=> ( v151772(VarCurr)
        | v151727(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151772(VarCurr)
    <=> v151773(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7199,axiom,
    ! [VarCurr: state_type] :
      ( v151773(VarCurr)
    <=> ( v151727(VarCurr,3)
        | v151774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20219,axiom,
    ! [VarCurr: state_type] :
      ( v151774(VarCurr)
    <=> ( v151775(VarCurr)
        & v151781(VarCurr) ) ) ).

tff(writeUnaryOperator_11541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151781(VarCurr)
    <=> v151727(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7198,axiom,
    ! [VarCurr: state_type] :
      ( v151775(VarCurr)
    <=> ( v151727(VarCurr,2)
        | v151776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20218,axiom,
    ! [VarCurr: state_type] :
      ( v151776(VarCurr)
    <=> ( v151777(VarCurr)
        & v151780(VarCurr) ) ) ).

tff(writeUnaryOperator_11540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151780(VarCurr)
    <=> v151727(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7197,axiom,
    ! [VarCurr: state_type] :
      ( v151777(VarCurr)
    <=> ( v151727(VarCurr,1)
        | v151778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20217,axiom,
    ! [VarCurr: state_type] :
      ( v151778(VarCurr)
    <=> ( v151727(VarCurr,0)
        & v151779(VarCurr) ) ) ).

tff(writeUnaryOperator_11539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151779(VarCurr)
    <=> v151727(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2365,axiom,
    ! [VarCurr: state_type] :
      ( v151767(VarCurr)
    <=> ( ( v151727(VarCurr,4)
        <=> $false )
        & ( v151727(VarCurr,3)
        <=> $false )
        & ( v151727(VarCurr,2)
        <=> $false )
        & ( v151727(VarCurr,1)
        <=> $false )
        & ( v151727(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151763(VarCurr,B)
          <=> v151760(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1675,axiom,
    ! [VarCurr: state_type] :
      ( v151764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151763(VarCurr,B)
          <=> v151758(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20216,axiom,
    ! [VarCurr: state_type] :
      ( v151764(VarCurr)
    <=> ( v151765(VarCurr)
        | v151753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20215,axiom,
    ! [VarCurr: state_type] :
      ( v151765(VarCurr)
    <=> ( v151756(VarCurr)
        & v151751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20214,axiom,
    ! [VarCurr: state_type] :
      ( v151762(VarCurr)
    <=> ( v151749(VarCurr)
        & v151662(VarCurr) ) ) ).

tff(addAssignment_85466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151760(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151758(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85464,axiom,
    ! [VarCurr: state_type] :
      ( v151756(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20213,axiom,
    ! [VarCurr: state_type] :
      ( v151749(VarCurr)
    <=> ( v151751(VarCurr)
        | v151753(VarCurr) ) ) ).

tff(addAssignment_85463,axiom,
    ! [VarCurr: state_type] :
      ( v151753(VarCurr)
    <=> v110563(VarCurr,1) ) ).

tff(addAssignment_85462,axiom,
    ! [VarCurr: state_type] :
      ( v151751(VarCurr)
    <=> v108901(VarCurr,1) ) ).

tff(addAssignment_85461,axiom,
    ! [VarCurr: state_type] :
      ( v151737(VarCurr)
    <=> v151739(VarCurr) ) ).

tff(addAssignment_85460,axiom,
    ! [VarCurr: state_type] :
      ( v151739(VarCurr)
    <=> v151643(VarCurr) ) ).

tff(addAssignment_85459,axiom,
    ! [VarCurr: state_type] :
      ( v151733(VarCurr)
    <=> v151735(VarCurr) ) ).

tff(addAssignment_85458,axiom,
    ! [VarCurr: state_type] :
      ( v151735(VarCurr)
    <=> v151635(VarCurr) ) ).

tff(addAssignment_85457,axiom,
    ! [VarCurr: state_type] :
      ( v151621(VarCurr)
    <=> v151623(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2364,axiom,
    ! [VarCurr: state_type] :
      ( v151623(VarCurr)
    <=> ( ( v151625(VarCurr,4)
        <=> $false )
        & ( v151625(VarCurr,3)
        <=> $false )
        & ( v151625(VarCurr,2)
        <=> $false )
        & ( v151625(VarCurr,1)
        <=> $false )
        & ( v151625(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151625(VarCurr,B)
      <=> v151627(VarCurr,B) ) ) ).

tff(addAssignment_85455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151627(VarCurr,B)
      <=> v151629(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151705(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v151629(VarNext,B)
            <=> v151629(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2267,axiom,
    ! [VarNext: state_type] :
      ( v151705(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151629(VarNext,B)
          <=> v151715(VarNext,B) ) ) ) ).

tff(addAssignment_85454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151715(VarNext,B)
          <=> v151713(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151716(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151713(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1674,axiom,
    ! [VarCurr: state_type] :
      ( v151716(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151713(VarCurr,B)
          <=> v151647(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20212,axiom,
    ! [VarCurr: state_type] :
      ( v151716(VarCurr)
    <=> ( v151717(VarCurr)
        & v151718(VarCurr) ) ) ).

tff(writeUnaryOperator_11538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151718(VarCurr)
    <=> v151639(VarCurr) ) ).

tff(writeUnaryOperator_11537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151717(VarCurr)
    <=> v151631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151705(VarNext)
      <=> v151706(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151706(VarNext)
      <=> ( v151707(VarNext)
          & v151698(VarNext) ) ) ) ).

tff(writeUnaryOperator_11536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151707(VarNext)
      <=> v151709(VarNext) ) ) ).

tff(addAssignment_85453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151709(VarNext)
      <=> v151698(VarCurr) ) ) ).

tff(addAssignment_85452,axiom,
    ! [VarCurr: state_type] :
      ( v151698(VarCurr)
    <=> v151700(VarCurr) ) ).

tff(addAssignment_85451,axiom,
    ! [VarCurr: state_type] :
      ( v151700(VarCurr)
    <=> v151702(VarCurr) ) ).

tff(addAssignment_85450,axiom,
    ! [VarCurr: state_type] :
      ( v151702(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151647(VarCurr,B)
      <=> v151649(VarCurr,B) ) ) ).

tff(addAssignment_85448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151649(VarCurr,B)
      <=> v151651(VarCurr,B) ) ) ).

tff(addAssignment_85447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151651(VarCurr,B)
      <=> v151653(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151653(VarCurr,B)
          <=> v151667(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1673,axiom,
    ! [VarCurr: state_type] :
      ( v151666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151653(VarCurr,B)
          <=> v151664(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151667(VarCurr,B)
          <=> v151669(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1672,axiom,
    ! [VarCurr: state_type] :
      ( v151668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151667(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85446,axiom,
    ! [VarCurr: state_type] :
      ( v151669(VarCurr,0)
    <=> v151695(VarCurr) ) ).

tff(addAssignment_85445,axiom,
    ! [VarCurr: state_type] :
      ( v151669(VarCurr,1)
    <=> v151693(VarCurr) ) ).

tff(addAssignment_85444,axiom,
    ! [VarCurr: state_type] :
      ( v151669(VarCurr,2)
    <=> v151689(VarCurr) ) ).

tff(addAssignment_85443,axiom,
    ! [VarCurr: state_type] :
      ( v151669(VarCurr,3)
    <=> v151685(VarCurr) ) ).

tff(addAssignment_85442,axiom,
    ! [VarCurr: state_type] :
      ( v151669(VarCurr,4)
    <=> v151671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20209,axiom,
    ! [VarCurr: state_type] :
      ( v151693(VarCurr)
    <=> ( v151694(VarCurr)
        & v151696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20208,axiom,
    ! [VarCurr: state_type] :
      ( v151696(VarCurr)
    <=> ( v151625(VarCurr,0)
        | v151680(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7196,axiom,
    ! [VarCurr: state_type] :
      ( v151694(VarCurr)
    <=> ( v151695(VarCurr)
        | v151625(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151695(VarCurr)
    <=> v151625(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20207,axiom,
    ! [VarCurr: state_type] :
      ( v151689(VarCurr)
    <=> ( v151690(VarCurr)
        & v151692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20206,axiom,
    ! [VarCurr: state_type] :
      ( v151692(VarCurr)
    <=> ( v151678(VarCurr)
        | v151681(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7195,axiom,
    ! [VarCurr: state_type] :
      ( v151690(VarCurr)
    <=> ( v151691(VarCurr)
        | v151625(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151691(VarCurr)
    <=> v151678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20205,axiom,
    ! [VarCurr: state_type] :
      ( v151685(VarCurr)
    <=> ( v151686(VarCurr)
        & v151688(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20204,axiom,
    ! [VarCurr: state_type] :
      ( v151688(VarCurr)
    <=> ( v151676(VarCurr)
        | v151682(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7194,axiom,
    ! [VarCurr: state_type] :
      ( v151686(VarCurr)
    <=> ( v151687(VarCurr)
        | v151625(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151687(VarCurr)
    <=> v151676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20203,axiom,
    ! [VarCurr: state_type] :
      ( v151671(VarCurr)
    <=> ( v151672(VarCurr)
        & v151683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20202,axiom,
    ! [VarCurr: state_type] :
      ( v151683(VarCurr)
    <=> ( v151674(VarCurr)
        | v151684(VarCurr) ) ) ).

tff(writeUnaryOperator_11532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151684(VarCurr)
    <=> v151625(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7193,axiom,
    ! [VarCurr: state_type] :
      ( v151672(VarCurr)
    <=> ( v151673(VarCurr)
        | v151625(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151673(VarCurr)
    <=> v151674(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7192,axiom,
    ! [VarCurr: state_type] :
      ( v151674(VarCurr)
    <=> ( v151625(VarCurr,3)
        | v151675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20201,axiom,
    ! [VarCurr: state_type] :
      ( v151675(VarCurr)
    <=> ( v151676(VarCurr)
        & v151682(VarCurr) ) ) ).

tff(writeUnaryOperator_11530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151682(VarCurr)
    <=> v151625(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7191,axiom,
    ! [VarCurr: state_type] :
      ( v151676(VarCurr)
    <=> ( v151625(VarCurr,2)
        | v151677(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20200,axiom,
    ! [VarCurr: state_type] :
      ( v151677(VarCurr)
    <=> ( v151678(VarCurr)
        & v151681(VarCurr) ) ) ).

tff(writeUnaryOperator_11529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151681(VarCurr)
    <=> v151625(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7190,axiom,
    ! [VarCurr: state_type] :
      ( v151678(VarCurr)
    <=> ( v151625(VarCurr,1)
        | v151679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20199,axiom,
    ! [VarCurr: state_type] :
      ( v151679(VarCurr)
    <=> ( v151625(VarCurr,0)
        & v151680(VarCurr) ) ) ).

tff(writeUnaryOperator_11528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151680(VarCurr)
    <=> v151625(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2363,axiom,
    ! [VarCurr: state_type] :
      ( v151668(VarCurr)
    <=> ( ( v151625(VarCurr,4)
        <=> $false )
        & ( v151625(VarCurr,3)
        <=> $false )
        & ( v151625(VarCurr,2)
        <=> $false )
        & ( v151625(VarCurr,1)
        <=> $false )
        & ( v151625(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20198,axiom,
    ! [VarCurr: state_type] :
      ( v151666(VarCurr)
    <=> ( v151655(VarCurr)
        & v151662(VarCurr) ) ) ).

tff(addAssignment_85441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151664(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85440,axiom,
    ! [VarCurr: state_type] :
      ( v151662(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20197,axiom,
    ! [VarCurr: state_type] :
      ( v151655(VarCurr)
    <=> ( v151657(VarCurr)
        | v151659(VarCurr) ) ) ).

tff(addAssignment_85439,axiom,
    ! [VarCurr: state_type] :
      ( v151659(VarCurr)
    <=> v110583(VarCurr,1) ) ).

tff(addAssignment_85438,axiom,
    ! [VarCurr: state_type] :
      ( v151657(VarCurr)
    <=> v116(VarCurr,1) ) ).

tff(addAssignment_85437,axiom,
    ! [VarCurr: state_type] :
      ( v151639(VarCurr)
    <=> v151641(VarCurr) ) ).

tff(addAssignment_85436,axiom,
    ! [VarCurr: state_type] :
      ( v151641(VarCurr)
    <=> v151643(VarCurr) ) ).

tff(addAssignment_85435,axiom,
    ! [VarCurr: state_type] :
      ( v151643(VarCurr)
    <=> v151645(VarCurr) ) ).

tff(addAssignment_85434,axiom,
    ! [VarCurr: state_type] :
      ( v151645(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_85433,axiom,
    ! [VarCurr: state_type] :
      ( v151631(VarCurr)
    <=> v151633(VarCurr) ) ).

tff(addAssignment_85432,axiom,
    ! [VarCurr: state_type] :
      ( v151633(VarCurr)
    <=> v151635(VarCurr) ) ).

tff(addAssignment_85431,axiom,
    ! [VarCurr: state_type] :
      ( v151635(VarCurr)
    <=> v151637(VarCurr) ) ).

tff(addAssignment_85430,axiom,
    ! [VarCurr: state_type] :
      ( v151637(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_85429,axiom,
    ! [VarCurr: state_type] :
      ( v151524(VarCurr)
    <=> v151526(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2362,axiom,
    ! [VarCurr: state_type] :
      ( v151526(VarCurr)
    <=> ( ( v151528(VarCurr,4)
        <=> $false )
        & ( v151528(VarCurr,3)
        <=> $false )
        & ( v151528(VarCurr,2)
        <=> $false )
        & ( v151528(VarCurr,1)
        <=> $false )
        & ( v151528(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151528(VarCurr,B)
      <=> v151530(VarCurr,B) ) ) ).

tff(addAssignment_85427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151530(VarCurr,B)
      <=> v151532(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151603(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v151532(VarNext,B)
            <=> v151532(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2266,axiom,
    ! [VarNext: state_type] :
      ( v151603(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151532(VarNext,B)
          <=> v151613(VarNext,B) ) ) ) ).

tff(addAssignment_85426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151613(VarNext,B)
          <=> v151611(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151614(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151611(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1671,axiom,
    ! [VarCurr: state_type] :
      ( v151614(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151611(VarCurr,B)
          <=> v151542(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20196,axiom,
    ! [VarCurr: state_type] :
      ( v151614(VarCurr)
    <=> ( v151615(VarCurr)
        & v151616(VarCurr) ) ) ).

tff(writeUnaryOperator_11527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151616(VarCurr)
    <=> v151538(VarCurr) ) ).

tff(writeUnaryOperator_11526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151615(VarCurr)
    <=> v151534(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151603(VarNext)
      <=> v151604(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151604(VarNext)
      <=> ( v151605(VarNext)
          & v151598(VarNext) ) ) ) ).

tff(writeUnaryOperator_11525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151605(VarNext)
      <=> v151607(VarNext) ) ) ).

tff(addAssignment_85425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151607(VarNext)
      <=> v151598(VarCurr) ) ) ).

tff(addAssignment_85424,axiom,
    ! [VarCurr: state_type] :
      ( v151598(VarCurr)
    <=> v151600(VarCurr) ) ).

tff(addAssignment_85423,axiom,
    ! [VarCurr: state_type] :
      ( v151600(VarCurr)
    <=> v151503(VarCurr) ) ).

tff(addAssignment_85422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151542(VarCurr,B)
      <=> v151544(VarCurr,B) ) ) ).

tff(addAssignment_85421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151544(VarCurr,B)
      <=> v151546(VarCurr,B) ) ) ).

tff(addAssignment_85420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151546(VarCurr,B)
      <=> v151548(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151548(VarCurr,B)
          <=> v151567(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1670,axiom,
    ! [VarCurr: state_type] :
      ( v151563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151548(VarCurr,B)
          <=> v151564(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151568(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151567(VarCurr,B)
          <=> v151569(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1669,axiom,
    ! [VarCurr: state_type] :
      ( v151568(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151567(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85419,axiom,
    ! [VarCurr: state_type] :
      ( v151569(VarCurr,0)
    <=> v151595(VarCurr) ) ).

tff(addAssignment_85418,axiom,
    ! [VarCurr: state_type] :
      ( v151569(VarCurr,1)
    <=> v151593(VarCurr) ) ).

tff(addAssignment_85417,axiom,
    ! [VarCurr: state_type] :
      ( v151569(VarCurr,2)
    <=> v151589(VarCurr) ) ).

tff(addAssignment_85416,axiom,
    ! [VarCurr: state_type] :
      ( v151569(VarCurr,3)
    <=> v151585(VarCurr) ) ).

tff(addAssignment_85415,axiom,
    ! [VarCurr: state_type] :
      ( v151569(VarCurr,4)
    <=> v151571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20193,axiom,
    ! [VarCurr: state_type] :
      ( v151593(VarCurr)
    <=> ( v151594(VarCurr)
        & v151596(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20192,axiom,
    ! [VarCurr: state_type] :
      ( v151596(VarCurr)
    <=> ( v151528(VarCurr,0)
        | v151580(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7189,axiom,
    ! [VarCurr: state_type] :
      ( v151594(VarCurr)
    <=> ( v151595(VarCurr)
        | v151528(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151595(VarCurr)
    <=> v151528(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20191,axiom,
    ! [VarCurr: state_type] :
      ( v151589(VarCurr)
    <=> ( v151590(VarCurr)
        & v151592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20190,axiom,
    ! [VarCurr: state_type] :
      ( v151592(VarCurr)
    <=> ( v151578(VarCurr)
        | v151581(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7188,axiom,
    ! [VarCurr: state_type] :
      ( v151590(VarCurr)
    <=> ( v151591(VarCurr)
        | v151528(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151591(VarCurr)
    <=> v151578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20189,axiom,
    ! [VarCurr: state_type] :
      ( v151585(VarCurr)
    <=> ( v151586(VarCurr)
        & v151588(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20188,axiom,
    ! [VarCurr: state_type] :
      ( v151588(VarCurr)
    <=> ( v151576(VarCurr)
        | v151582(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7187,axiom,
    ! [VarCurr: state_type] :
      ( v151586(VarCurr)
    <=> ( v151587(VarCurr)
        | v151528(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151587(VarCurr)
    <=> v151576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20187,axiom,
    ! [VarCurr: state_type] :
      ( v151571(VarCurr)
    <=> ( v151572(VarCurr)
        & v151583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20186,axiom,
    ! [VarCurr: state_type] :
      ( v151583(VarCurr)
    <=> ( v151574(VarCurr)
        | v151584(VarCurr) ) ) ).

tff(writeUnaryOperator_11521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151584(VarCurr)
    <=> v151528(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7186,axiom,
    ! [VarCurr: state_type] :
      ( v151572(VarCurr)
    <=> ( v151573(VarCurr)
        | v151528(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151573(VarCurr)
    <=> v151574(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7185,axiom,
    ! [VarCurr: state_type] :
      ( v151574(VarCurr)
    <=> ( v151528(VarCurr,3)
        | v151575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20185,axiom,
    ! [VarCurr: state_type] :
      ( v151575(VarCurr)
    <=> ( v151576(VarCurr)
        & v151582(VarCurr) ) ) ).

tff(writeUnaryOperator_11519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151582(VarCurr)
    <=> v151528(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7184,axiom,
    ! [VarCurr: state_type] :
      ( v151576(VarCurr)
    <=> ( v151528(VarCurr,2)
        | v151577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20184,axiom,
    ! [VarCurr: state_type] :
      ( v151577(VarCurr)
    <=> ( v151578(VarCurr)
        & v151581(VarCurr) ) ) ).

tff(writeUnaryOperator_11518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151581(VarCurr)
    <=> v151528(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7183,axiom,
    ! [VarCurr: state_type] :
      ( v151578(VarCurr)
    <=> ( v151528(VarCurr,1)
        | v151579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20183,axiom,
    ! [VarCurr: state_type] :
      ( v151579(VarCurr)
    <=> ( v151528(VarCurr,0)
        & v151580(VarCurr) ) ) ).

tff(writeUnaryOperator_11517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151580(VarCurr)
    <=> v151528(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2361,axiom,
    ! [VarCurr: state_type] :
      ( v151568(VarCurr)
    <=> ( ( v151528(VarCurr,4)
        <=> $false )
        & ( v151528(VarCurr,3)
        <=> $false )
        & ( v151528(VarCurr,2)
        <=> $false )
        & ( v151528(VarCurr,1)
        <=> $false )
        & ( v151528(VarCurr,0)
        <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151565(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151564(VarCurr,B)
          <=> v151561(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1668,axiom,
    ! [VarCurr: state_type] :
      ( v151565(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151564(VarCurr,B)
          <=> v151559(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20182,axiom,
    ! [VarCurr: state_type] :
      ( v151565(VarCurr)
    <=> ( v151566(VarCurr)
        | v151554(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20181,axiom,
    ! [VarCurr: state_type] :
      ( v151566(VarCurr)
    <=> ( v151557(VarCurr)
        & v151552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20180,axiom,
    ! [VarCurr: state_type] :
      ( v151563(VarCurr)
    <=> ( v151550(VarCurr)
        & v151463(VarCurr) ) ) ).

tff(addAssignment_85414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151561(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_85413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151559(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_85412,axiom,
    ! [VarCurr: state_type] :
      ( v151557(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20179,axiom,
    ! [VarCurr: state_type] :
      ( v151550(VarCurr)
    <=> ( v151552(VarCurr)
        | v151554(VarCurr) ) ) ).

tff(addAssignment_85411,axiom,
    ! [VarCurr: state_type] :
      ( v151554(VarCurr)
    <=> v110563(VarCurr,0) ) ).

tff(addAssignment_85410,axiom,
    ! [VarCurr: state_type] :
      ( v151552(VarCurr)
    <=> v108901(VarCurr,0) ) ).

tff(addAssignment_85409,axiom,
    ! [VarCurr: state_type] :
      ( v151538(VarCurr)
    <=> v151540(VarCurr) ) ).

tff(addAssignment_85408,axiom,
    ! [VarCurr: state_type] :
      ( v151540(VarCurr)
    <=> v100(VarCurr) ) ).

tff(addAssignment_85407,axiom,
    ! [VarCurr: state_type] :
      ( v151534(VarCurr)
    <=> v151536(VarCurr) ) ).

tff(addAssignment_85406,axiom,
    ! [VarCurr: state_type] :
      ( v151536(VarCurr)
    <=> v92(VarCurr) ) ).

tff(addAssignment_85405,axiom,
    ! [VarCurr: state_type] :
      ( v78(VarCurr)
    <=> v80(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2360,axiom,
    ! [VarCurr: state_type] :
      ( v80(VarCurr)
    <=> ( ( v82(VarCurr,4)
        <=> $false )
        & ( v82(VarCurr,3)
        <=> $false )
        & ( v82(VarCurr,2)
        <=> $false )
        & ( v82(VarCurr,1)
        <=> $false )
        & ( v82(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_85404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v82(VarCurr,B)
      <=> v84(VarCurr,B) ) ) ).

tff(addAssignment_85403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84(VarCurr,B)
      <=> v86(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151506(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v86(VarNext,B)
            <=> v86(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2265,axiom,
    ! [VarNext: state_type] :
      ( v151506(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v86(VarNext,B)
          <=> v151516(VarNext,B) ) ) ) ).

tff(addAssignment_85402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151516(VarNext,B)
          <=> v151514(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151517(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151514(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1667,axiom,
    ! [VarCurr: state_type] :
      ( v151517(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151514(VarCurr,B)
          <=> v104(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20178,axiom,
    ! [VarCurr: state_type] :
      ( v151517(VarCurr)
    <=> ( v151518(VarCurr)
        & v151519(VarCurr) ) ) ).

tff(writeUnaryOperator_11516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151519(VarCurr)
    <=> v96(VarCurr) ) ).

tff(writeUnaryOperator_11515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151518(VarCurr)
    <=> v88(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151506(VarNext)
      <=> v151507(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151507(VarNext)
      <=> ( v151508(VarNext)
          & v151499(VarNext) ) ) ) ).

tff(writeUnaryOperator_11514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v151508(VarNext)
      <=> v151510(VarNext) ) ) ).

tff(addAssignment_85401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v151510(VarNext)
      <=> v151499(VarCurr) ) ) ).

tff(addAssignment_85400,axiom,
    ! [VarCurr: state_type] :
      ( v151499(VarCurr)
    <=> v151501(VarCurr) ) ).

tff(addAssignment_85399,axiom,
    ! [VarCurr: state_type] :
      ( v151501(VarCurr)
    <=> v151503(VarCurr) ) ).

tff(addAssignment_85398,axiom,
    ! [VarCurr: state_type] :
      ( v151503(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_85397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104(VarCurr,B)
      <=> v106(VarCurr,B) ) ) ).

tff(addAssignment_85396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106(VarCurr,B)
      <=> v108(VarCurr,B) ) ) ).

tff(addAssignment_85395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108(VarCurr,B)
      <=> v110(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151467(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v110(VarCurr,B)
          <=> v151468(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1666,axiom,
    ! [VarCurr: state_type] :
      ( v151467(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v110(VarCurr,B)
          <=> v151465(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151469(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151468(VarCurr,B)
          <=> v151470(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1665,axiom,
    ! [VarCurr: state_type] :
      ( v151469(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v151468(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_85394,axiom,
    ! [VarCurr: state_type] :
      ( v151470(VarCurr,0)
    <=> v151496(VarCurr) ) ).

tff(addAssignment_85393,axiom,
    ! [VarCurr: state_type] :
      ( v151470(VarCurr,1)
    <=> v151494(VarCurr) ) ).

tff(addAssignment_85392,axiom,
    ! [VarCurr: state_type] :
      ( v151470(VarCurr,2)
    <=> v151490(VarCurr) ) ).

tff(addAssignment_85391,axiom,
    ! [VarCurr: state_type] :
      ( v151470(VarCurr,3)
    <=> v151486(VarCurr) ) ).

tff(addAssignment_85390,axiom,
    ! [VarCurr: state_type] :
      ( v151470(VarCurr,4)
    <=> v151472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20175,axiom,
    ! [VarCurr: state_type] :
      ( v151494(VarCurr)
    <=> ( v151495(VarCurr)
        & v151497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20174,axiom,
    ! [VarCurr: state_type] :
      ( v151497(VarCurr)
    <=> ( v82(VarCurr,0)
        | v151481(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7182,axiom,
    ! [VarCurr: state_type] :
      ( v151495(VarCurr)
    <=> ( v151496(VarCurr)
        | v82(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151496(VarCurr)
    <=> v82(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20173,axiom,
    ! [VarCurr: state_type] :
      ( v151490(VarCurr)
    <=> ( v151491(VarCurr)
        & v151493(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20172,axiom,
    ! [VarCurr: state_type] :
      ( v151493(VarCurr)
    <=> ( v151479(VarCurr)
        | v151482(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7181,axiom,
    ! [VarCurr: state_type] :
      ( v151491(VarCurr)
    <=> ( v151492(VarCurr)
        | v82(VarCurr,2) ) ) ).

tff(writeUnaryOperator_11512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151492(VarCurr)
    <=> v151479(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20171,axiom,
    ! [VarCurr: state_type] :
      ( v151486(VarCurr)
    <=> ( v151487(VarCurr)
        & v151489(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20170,axiom,
    ! [VarCurr: state_type] :
      ( v151489(VarCurr)
    <=> ( v151477(VarCurr)
        | v151483(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7180,axiom,
    ! [VarCurr: state_type] :
      ( v151487(VarCurr)
    <=> ( v151488(VarCurr)
        | v82(VarCurr,3) ) ) ).

tff(writeUnaryOperator_11511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151488(VarCurr)
    <=> v151477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20169,axiom,
    ! [VarCurr: state_type] :
      ( v151472(VarCurr)
    <=> ( v151473(VarCurr)
        & v151484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20168,axiom,
    ! [VarCurr: state_type] :
      ( v151484(VarCurr)
    <=> ( v151475(VarCurr)
        | v151485(VarCurr) ) ) ).

tff(writeUnaryOperator_11510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151485(VarCurr)
    <=> v82(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_7179,axiom,
    ! [VarCurr: state_type] :
      ( v151473(VarCurr)
    <=> ( v151474(VarCurr)
        | v82(VarCurr,4) ) ) ).

tff(writeUnaryOperator_11509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151474(VarCurr)
    <=> v151475(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7178,axiom,
    ! [VarCurr: state_type] :
      ( v151475(VarCurr)
    <=> ( v82(VarCurr,3)
        | v151476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20167,axiom,
    ! [VarCurr: state_type] :
      ( v151476(VarCurr)
    <=> ( v151477(VarCurr)
        & v151483(VarCurr) ) ) ).

tff(writeUnaryOperator_11508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151483(VarCurr)
    <=> v82(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_7177,axiom,
    ! [VarCurr: state_type] :
      ( v151477(VarCurr)
    <=> ( v82(VarCurr,2)
        | v151478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20166,axiom,
    ! [VarCurr: state_type] :
      ( v151478(VarCurr)
    <=> ( v151479(VarCurr)
        & v151482(VarCurr) ) ) ).

tff(writeUnaryOperator_11507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151482(VarCurr)
    <=> v82(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_7176,axiom,
    ! [VarCurr: state_type] :
      ( v151479(VarCurr)
    <=> ( v82(VarCurr,1)
        | v151480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20165,axiom,
    ! [VarCurr: state_type] :
      ( v151480(VarCurr)
    <=> ( v82(VarCurr,0)
        & v151481(VarCurr) ) ) ).

tff(writeUnaryOperator_11506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151481(VarCurr)
    <=> v82(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_2359,axiom,
    ! [VarCurr: state_type] :
      ( v151469(VarCurr)
    <=> ( ( v82(VarCurr,4)
        <=> $false )
        & ( v82(VarCurr,3)
        <=> $false )
        & ( v82(VarCurr,2)
        <=> $false )
        & ( v82(VarCurr,1)
        <=> $false )
        & ( v82(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20164,axiom,
    ! [VarCurr: state_type] :
      ( v151467(VarCurr)
    <=> ( v112(VarCurr)
        & v151463(VarCurr) ) ) ).

tff(addAssignment_85389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v151465(VarCurr,B)
      <=> v139349(VarCurr,B) ) ) ).

tff(addAssignment_85388,axiom,
    ! [VarCurr: state_type] :
      ( v151463(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20163,axiom,
    ! [VarCurr: state_type] :
      ( v112(VarCurr)
    <=> ( v114(VarCurr)
        | v151460(VarCurr) ) ) ).

tff(addAssignment_85387,axiom,
    ! [VarCurr: state_type] :
      ( v151460(VarCurr)
    <=> v110583(VarCurr,0) ) ).

tff(addAssignment_85386,axiom,
    ! [VarCurr: state_type] :
      ( v114(VarCurr)
    <=> v116(VarCurr,0) ) ).

tff(addAssignment_85385,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,0)
    <=> v110288(VarCurr,0) ) ).

tff(addAssignment_85384,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,0)
    <=> v110267(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_7175,axiom,
    ! [VarCurr: state_type] :
      ( v118(VarCurr)
    <=> ( v102028(VarCurr)
        | v120(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v120(VarCurr,B)
      <=> ( v122(VarCurr,B)
          & v151454(VarCurr,B) ) ) ) ).

tff(addAssignment_85383,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,0)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85382,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,1)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85381,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,2)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85380,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,3)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85379,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,4)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85378,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,5)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85377,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,6)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85376,axiom,
    ! [VarCurr: state_type] :
      ( v151454(VarCurr,7)
    <=> v151455(VarCurr) ) ).

tff(addAssignment_85375,axiom,
    ! [VarCurr: state_type] :
      ( v151455(VarCurr)
    <=> v151456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20162,axiom,
    ! [VarCurr: state_type] :
      ( v151456(VarCurr)
    <=> ( v151457(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeUnaryOperator_11505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151457(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7174,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,7)
    <=> ( v151449(VarCurr)
        & v151452(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2358,axiom,
    ! [VarCurr: state_type] :
      ( v151452(VarCurr)
    <=> ( ( v150965(VarCurr,7)
        <=> $true )
        & ( v150965(VarCurr,6)
        <=> $false )
        & ( v150965(VarCurr,5)
        <=> $false )
        & ( v150965(VarCurr,4)
        <=> $false )
        & ( v150965(VarCurr,3)
        <=> $false )
        & ( v150965(VarCurr,2)
        <=> $false )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20161,axiom,
    ! [VarCurr: state_type] :
      ( v151449(VarCurr)
    <=> ( v151450(VarCurr)
        | v151451(VarCurr) ) ) ).

tff(writeUnaryOperator_11504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151451(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151450(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7173,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,6)
    <=> ( v151444(VarCurr)
        & v151447(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2357,axiom,
    ! [VarCurr: state_type] :
      ( v151447(VarCurr)
    <=> ( ( v150965(VarCurr,6)
        <=> $true )
        & ( v150965(VarCurr,5)
        <=> $false )
        & ( v150965(VarCurr,4)
        <=> $false )
        & ( v150965(VarCurr,3)
        <=> $false )
        & ( v150965(VarCurr,2)
        <=> $false )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20160,axiom,
    ! [VarCurr: state_type] :
      ( v151444(VarCurr)
    <=> ( v151445(VarCurr)
        | v151446(VarCurr) ) ) ).

tff(writeUnaryOperator_11502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151446(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151445(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7172,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,5)
    <=> ( v151439(VarCurr)
        & v151442(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2356,axiom,
    ! [VarCurr: state_type] :
      ( v151442(VarCurr)
    <=> ( ( v150965(VarCurr,5)
        <=> $true )
        & ( v150965(VarCurr,4)
        <=> $false )
        & ( v150965(VarCurr,3)
        <=> $false )
        & ( v150965(VarCurr,2)
        <=> $false )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20159,axiom,
    ! [VarCurr: state_type] :
      ( v151439(VarCurr)
    <=> ( v151440(VarCurr)
        | v151441(VarCurr) ) ) ).

tff(writeUnaryOperator_11500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151441(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151440(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7171,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,4)
    <=> ( v151434(VarCurr)
        & v151437(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2355,axiom,
    ! [VarCurr: state_type] :
      ( v151437(VarCurr)
    <=> ( ( v150965(VarCurr,4)
        <=> $true )
        & ( v150965(VarCurr,3)
        <=> $false )
        & ( v150965(VarCurr,2)
        <=> $false )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20158,axiom,
    ! [VarCurr: state_type] :
      ( v151434(VarCurr)
    <=> ( v151435(VarCurr)
        | v151436(VarCurr) ) ) ).

tff(writeUnaryOperator_11498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151436(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151435(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7170,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,3)
    <=> ( v151429(VarCurr)
        & v151432(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2354,axiom,
    ! [VarCurr: state_type] :
      ( v151432(VarCurr)
    <=> ( ( v150965(VarCurr,3)
        <=> $true )
        & ( v150965(VarCurr,2)
        <=> $false )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20157,axiom,
    ! [VarCurr: state_type] :
      ( v151429(VarCurr)
    <=> ( v151430(VarCurr)
        | v151431(VarCurr) ) ) ).

tff(writeUnaryOperator_11496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151431(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151430(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7169,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,2)
    <=> ( v151424(VarCurr)
        & v151427(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2353,axiom,
    ! [VarCurr: state_type] :
      ( v151427(VarCurr)
    <=> ( ( v150965(VarCurr,2)
        <=> $true )
        & ( v150965(VarCurr,1)
        <=> $false )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20156,axiom,
    ! [VarCurr: state_type] :
      ( v151424(VarCurr)
    <=> ( v151425(VarCurr)
        | v151426(VarCurr) ) ) ).

tff(writeUnaryOperator_11494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151426(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151425(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7168,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,1)
    <=> ( v151419(VarCurr)
        & v151422(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2352,axiom,
    ! [VarCurr: state_type] :
      ( v151422(VarCurr)
    <=> ( ( v150965(VarCurr,1)
        <=> $true )
        & ( v150965(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20155,axiom,
    ! [VarCurr: state_type] :
      ( v151419(VarCurr)
    <=> ( v151420(VarCurr)
        | v151421(VarCurr) ) ) ).

tff(writeUnaryOperator_11492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151421(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151420(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20154,axiom,
    ! [VarCurr: state_type] :
      ( v122(VarCurr,0)
    <=> ( v151415(VarCurr)
        & v150965(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20153,axiom,
    ! [VarCurr: state_type] :
      ( v151415(VarCurr)
    <=> ( v151416(VarCurr)
        | v151417(VarCurr) ) ) ).

tff(writeUnaryOperator_11490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151417(VarCurr)
    <=> v138098(VarCurr) ) ).

tff(writeUnaryOperator_11489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151416(VarCurr)
    <=> v124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7167,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,7)
    <=> ( v151371(VarCurr)
        & v151390(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20152,axiom,
    ! [VarCurr: state_type] :
      ( v151390(VarCurr)
    <=> ( v151391(VarCurr)
        | v151412(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2351,axiom,
    ! [VarCurr: state_type] :
      ( v151412(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151413(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151413(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151413(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151413(VarCurr,0) ) ) ) ).

tff(addAssignment_85374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151413(VarCurr,B)
      <=> v151359(VarCurr,B) ) ) ).

tff(addAssignment_85373,axiom,
    ! [VarCurr: state_type] :
      ( v151413(VarCurr,3)
    <=> v151365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20151,axiom,
    ! [VarCurr: state_type] :
      ( v151391(VarCurr)
    <=> ( v151392(VarCurr)
        | v151393(VarCurr) ) ) ).

tff(writeUnaryOperator_11488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151393(VarCurr)
    <=> v151395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20150,axiom,
    ! [VarCurr: state_type] :
      ( v151395(VarCurr)
    <=> ( v151396(VarCurr)
        & v151407(VarCurr) ) ) ).

tff(writeUnaryOperator_11487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151407(VarCurr)
    <=> v151408(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20149,axiom,
    ! [VarCurr: state_type] :
      ( v151408(VarCurr)
    <=> ( v151409(VarCurr)
        & v151411(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7166,axiom,
    ! [VarCurr: state_type] :
      ( v151411(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151359(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20148,axiom,
    ! [VarCurr: state_type] :
      ( v151409(VarCurr)
    <=> ( v135621(VarCurr)
        | v151410(VarCurr) ) ) ).

tff(writeUnaryOperator_11486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151410(VarCurr)
    <=> v151359(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20147,axiom,
    ! [VarCurr: state_type] :
      ( v151396(VarCurr)
    <=> ( v151397(VarCurr)
        & v151402(VarCurr) ) ) ).

tff(writeUnaryOperator_11485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151402(VarCurr)
    <=> v151403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20146,axiom,
    ! [VarCurr: state_type] :
      ( v151403(VarCurr)
    <=> ( v151404(VarCurr)
        & v151406(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7165,axiom,
    ! [VarCurr: state_type] :
      ( v151406(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151359(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20145,axiom,
    ! [VarCurr: state_type] :
      ( v151404(VarCurr)
    <=> ( v135615(VarCurr)
        | v151405(VarCurr) ) ) ).

tff(writeUnaryOperator_11484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151405(VarCurr)
    <=> v151359(VarCurr,1) ) ).

tff(writeUnaryOperator_11483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151397(VarCurr)
    <=> v151398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20144,axiom,
    ! [VarCurr: state_type] :
      ( v151398(VarCurr)
    <=> ( v151399(VarCurr)
        & v151401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20143,axiom,
    ! [VarCurr: state_type] :
      ( v151401(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151359(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20142,axiom,
    ! [VarCurr: state_type] :
      ( v151399(VarCurr)
    <=> ( v135609(VarCurr)
        | v151400(VarCurr) ) ) ).

tff(writeUnaryOperator_11482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151400(VarCurr)
    <=> v151359(VarCurr,0) ) ).

tff(writeUnaryOperator_11481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151392(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20141,axiom,
    ! [VarCurr: state_type] :
      ( v151371(VarCurr)
    <=> ( v151372(VarCurr)
        & v151389(VarCurr) ) ) ).

tff(writeUnaryOperator_11480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151389(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7164,axiom,
    ! [VarCurr: state_type] :
      ( v151372(VarCurr)
    <=> ( v151374(VarCurr)
        | v151388(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7163,axiom,
    ! [VarCurr: state_type] :
      ( v151374(VarCurr)
    <=> ( v151375(VarCurr)
        | v151388(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7162,axiom,
    ! [VarCurr: state_type] :
      ( v151375(VarCurr)
    <=> ( v151376(VarCurr)
        | v151388(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7161,axiom,
    ! [VarCurr: state_type] :
      ( v151376(VarCurr)
    <=> ( v151377(VarCurr)
        | v151388(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7160,axiom,
    ! [VarCurr: state_type] :
      ( v151377(VarCurr)
    <=> ( v151378(VarCurr)
        | v151388(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7159,axiom,
    ! [VarCurr: state_type] :
      ( v151378(VarCurr)
    <=> ( v151379(VarCurr)
        | v151388(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7158,axiom,
    ! [VarCurr: state_type] :
      ( v151379(VarCurr)
    <=> ( v151380(VarCurr)
        | v151388(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7157,axiom,
    ! [VarCurr: state_type] :
      ( v151380(VarCurr)
    <=> ( v151381(VarCurr)
        | v151388(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7156,axiom,
    ! [VarCurr: state_type] :
      ( v151381(VarCurr)
    <=> ( v151382(VarCurr)
        | v151388(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7155,axiom,
    ! [VarCurr: state_type] :
      ( v151382(VarCurr)
    <=> ( v151383(VarCurr)
        | v151388(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7154,axiom,
    ! [VarCurr: state_type] :
      ( v151383(VarCurr)
    <=> ( v151384(VarCurr)
        | v151388(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7153,axiom,
    ! [VarCurr: state_type] :
      ( v151384(VarCurr)
    <=> ( v151385(VarCurr)
        | v151388(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7152,axiom,
    ! [VarCurr: state_type] :
      ( v151385(VarCurr)
    <=> ( v151386(VarCurr)
        | v151388(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7151,axiom,
    ! [VarCurr: state_type] :
      ( v151386(VarCurr)
    <=> ( v151387(VarCurr)
        | v151388(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7150,axiom,
    ! [VarCurr: state_type] :
      ( v151387(VarCurr)
    <=> ( v151388(VarCurr,0)
        | v151388(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151388(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137993(VarCurr,B) ) ) ) ).

tff(addAssignment_85372,axiom,
    ! [VarCurr: state_type] :
      ( v151365(VarCurr)
    <=> v151367(VarCurr) ) ).

tff(addAssignment_85371,axiom,
    ! [VarCurr: state_type] :
      ( v151367(VarCurr)
    <=> v151369(VarCurr) ) ).

tff(addAssignment_85370,axiom,
    ! [VarCurr: state_type] :
      ( v151369(VarCurr)
    <=> v85282(VarCurr,6) ) ).

tff(addAssignment_85369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151359(VarCurr,B)
      <=> v151361(VarCurr,B) ) ) ).

tff(addAssignment_85368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151361(VarCurr,B)
      <=> v151363(VarCurr,B) ) ) ).

tff(addAssignment_85367,axiom,
    ! [VarCurr: state_type] :
      ( ( v151363(VarCurr,2)
      <=> v85282(VarCurr,5) )
      & ( v151363(VarCurr,1)
      <=> v85282(VarCurr,4) )
      & ( v151363(VarCurr,0)
      <=> v85282(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7149,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,6)
    <=> ( v151315(VarCurr)
        & v151334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20140,axiom,
    ! [VarCurr: state_type] :
      ( v151334(VarCurr)
    <=> ( v151335(VarCurr)
        | v151356(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2350,axiom,
    ! [VarCurr: state_type] :
      ( v151356(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151357(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151357(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151357(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151357(VarCurr,0) ) ) ) ).

tff(addAssignment_85366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151357(VarCurr,B)
      <=> v151303(VarCurr,B) ) ) ).

tff(addAssignment_85365,axiom,
    ! [VarCurr: state_type] :
      ( v151357(VarCurr,3)
    <=> v151309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20139,axiom,
    ! [VarCurr: state_type] :
      ( v151335(VarCurr)
    <=> ( v151336(VarCurr)
        | v151337(VarCurr) ) ) ).

tff(writeUnaryOperator_11479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151337(VarCurr)
    <=> v151339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20138,axiom,
    ! [VarCurr: state_type] :
      ( v151339(VarCurr)
    <=> ( v151340(VarCurr)
        & v151351(VarCurr) ) ) ).

tff(writeUnaryOperator_11478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151351(VarCurr)
    <=> v151352(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20137,axiom,
    ! [VarCurr: state_type] :
      ( v151352(VarCurr)
    <=> ( v151353(VarCurr)
        & v151355(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7148,axiom,
    ! [VarCurr: state_type] :
      ( v151355(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151303(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20136,axiom,
    ! [VarCurr: state_type] :
      ( v151353(VarCurr)
    <=> ( v135621(VarCurr)
        | v151354(VarCurr) ) ) ).

tff(writeUnaryOperator_11477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151354(VarCurr)
    <=> v151303(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20135,axiom,
    ! [VarCurr: state_type] :
      ( v151340(VarCurr)
    <=> ( v151341(VarCurr)
        & v151346(VarCurr) ) ) ).

tff(writeUnaryOperator_11476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151346(VarCurr)
    <=> v151347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20134,axiom,
    ! [VarCurr: state_type] :
      ( v151347(VarCurr)
    <=> ( v151348(VarCurr)
        & v151350(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7147,axiom,
    ! [VarCurr: state_type] :
      ( v151350(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151303(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20133,axiom,
    ! [VarCurr: state_type] :
      ( v151348(VarCurr)
    <=> ( v135615(VarCurr)
        | v151349(VarCurr) ) ) ).

tff(writeUnaryOperator_11475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151349(VarCurr)
    <=> v151303(VarCurr,1) ) ).

tff(writeUnaryOperator_11474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151341(VarCurr)
    <=> v151342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20132,axiom,
    ! [VarCurr: state_type] :
      ( v151342(VarCurr)
    <=> ( v151343(VarCurr)
        & v151345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20131,axiom,
    ! [VarCurr: state_type] :
      ( v151345(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151303(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20130,axiom,
    ! [VarCurr: state_type] :
      ( v151343(VarCurr)
    <=> ( v135609(VarCurr)
        | v151344(VarCurr) ) ) ).

tff(writeUnaryOperator_11473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151344(VarCurr)
    <=> v151303(VarCurr,0) ) ).

tff(writeUnaryOperator_11472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151336(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20129,axiom,
    ! [VarCurr: state_type] :
      ( v151315(VarCurr)
    <=> ( v151316(VarCurr)
        & v151333(VarCurr) ) ) ).

tff(writeUnaryOperator_11471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151333(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7146,axiom,
    ! [VarCurr: state_type] :
      ( v151316(VarCurr)
    <=> ( v151318(VarCurr)
        | v151332(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7145,axiom,
    ! [VarCurr: state_type] :
      ( v151318(VarCurr)
    <=> ( v151319(VarCurr)
        | v151332(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7144,axiom,
    ! [VarCurr: state_type] :
      ( v151319(VarCurr)
    <=> ( v151320(VarCurr)
        | v151332(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7143,axiom,
    ! [VarCurr: state_type] :
      ( v151320(VarCurr)
    <=> ( v151321(VarCurr)
        | v151332(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7142,axiom,
    ! [VarCurr: state_type] :
      ( v151321(VarCurr)
    <=> ( v151322(VarCurr)
        | v151332(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7141,axiom,
    ! [VarCurr: state_type] :
      ( v151322(VarCurr)
    <=> ( v151323(VarCurr)
        | v151332(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7140,axiom,
    ! [VarCurr: state_type] :
      ( v151323(VarCurr)
    <=> ( v151324(VarCurr)
        | v151332(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7139,axiom,
    ! [VarCurr: state_type] :
      ( v151324(VarCurr)
    <=> ( v151325(VarCurr)
        | v151332(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7138,axiom,
    ! [VarCurr: state_type] :
      ( v151325(VarCurr)
    <=> ( v151326(VarCurr)
        | v151332(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7137,axiom,
    ! [VarCurr: state_type] :
      ( v151326(VarCurr)
    <=> ( v151327(VarCurr)
        | v151332(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7136,axiom,
    ! [VarCurr: state_type] :
      ( v151327(VarCurr)
    <=> ( v151328(VarCurr)
        | v151332(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7135,axiom,
    ! [VarCurr: state_type] :
      ( v151328(VarCurr)
    <=> ( v151329(VarCurr)
        | v151332(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7134,axiom,
    ! [VarCurr: state_type] :
      ( v151329(VarCurr)
    <=> ( v151330(VarCurr)
        | v151332(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7133,axiom,
    ! [VarCurr: state_type] :
      ( v151330(VarCurr)
    <=> ( v151331(VarCurr)
        | v151332(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7132,axiom,
    ! [VarCurr: state_type] :
      ( v151331(VarCurr)
    <=> ( v151332(VarCurr,0)
        | v151332(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151332(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137912(VarCurr,B) ) ) ) ).

tff(addAssignment_85364,axiom,
    ! [VarCurr: state_type] :
      ( v151309(VarCurr)
    <=> v151311(VarCurr) ) ).

tff(addAssignment_85363,axiom,
    ! [VarCurr: state_type] :
      ( v151311(VarCurr)
    <=> v151313(VarCurr) ) ).

tff(addAssignment_85362,axiom,
    ! [VarCurr: state_type] :
      ( v151313(VarCurr)
    <=> v85260(VarCurr,6) ) ).

tff(addAssignment_85361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151303(VarCurr,B)
      <=> v151305(VarCurr,B) ) ) ).

tff(addAssignment_85360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151305(VarCurr,B)
      <=> v151307(VarCurr,B) ) ) ).

tff(addAssignment_85359,axiom,
    ! [VarCurr: state_type] :
      ( ( v151307(VarCurr,2)
      <=> v85260(VarCurr,5) )
      & ( v151307(VarCurr,1)
      <=> v85260(VarCurr,4) )
      & ( v151307(VarCurr,0)
      <=> v85260(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7131,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,5)
    <=> ( v151259(VarCurr)
        & v151278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20128,axiom,
    ! [VarCurr: state_type] :
      ( v151278(VarCurr)
    <=> ( v151279(VarCurr)
        | v151300(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2349,axiom,
    ! [VarCurr: state_type] :
      ( v151300(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151301(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151301(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151301(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151301(VarCurr,0) ) ) ) ).

tff(addAssignment_85358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151301(VarCurr,B)
      <=> v151247(VarCurr,B) ) ) ).

tff(addAssignment_85357,axiom,
    ! [VarCurr: state_type] :
      ( v151301(VarCurr,3)
    <=> v151253(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20127,axiom,
    ! [VarCurr: state_type] :
      ( v151279(VarCurr)
    <=> ( v151280(VarCurr)
        | v151281(VarCurr) ) ) ).

tff(writeUnaryOperator_11470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151281(VarCurr)
    <=> v151283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20126,axiom,
    ! [VarCurr: state_type] :
      ( v151283(VarCurr)
    <=> ( v151284(VarCurr)
        & v151295(VarCurr) ) ) ).

tff(writeUnaryOperator_11469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151295(VarCurr)
    <=> v151296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20125,axiom,
    ! [VarCurr: state_type] :
      ( v151296(VarCurr)
    <=> ( v151297(VarCurr)
        & v151299(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7130,axiom,
    ! [VarCurr: state_type] :
      ( v151299(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151247(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20124,axiom,
    ! [VarCurr: state_type] :
      ( v151297(VarCurr)
    <=> ( v135621(VarCurr)
        | v151298(VarCurr) ) ) ).

tff(writeUnaryOperator_11468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151298(VarCurr)
    <=> v151247(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20123,axiom,
    ! [VarCurr: state_type] :
      ( v151284(VarCurr)
    <=> ( v151285(VarCurr)
        & v151290(VarCurr) ) ) ).

tff(writeUnaryOperator_11467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151290(VarCurr)
    <=> v151291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20122,axiom,
    ! [VarCurr: state_type] :
      ( v151291(VarCurr)
    <=> ( v151292(VarCurr)
        & v151294(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7129,axiom,
    ! [VarCurr: state_type] :
      ( v151294(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151247(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20121,axiom,
    ! [VarCurr: state_type] :
      ( v151292(VarCurr)
    <=> ( v135615(VarCurr)
        | v151293(VarCurr) ) ) ).

tff(writeUnaryOperator_11466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151293(VarCurr)
    <=> v151247(VarCurr,1) ) ).

tff(writeUnaryOperator_11465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151285(VarCurr)
    <=> v151286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20120,axiom,
    ! [VarCurr: state_type] :
      ( v151286(VarCurr)
    <=> ( v151287(VarCurr)
        & v151289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20119,axiom,
    ! [VarCurr: state_type] :
      ( v151289(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151247(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20118,axiom,
    ! [VarCurr: state_type] :
      ( v151287(VarCurr)
    <=> ( v135609(VarCurr)
        | v151288(VarCurr) ) ) ).

tff(writeUnaryOperator_11464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151288(VarCurr)
    <=> v151247(VarCurr,0) ) ).

tff(writeUnaryOperator_11463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151280(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20117,axiom,
    ! [VarCurr: state_type] :
      ( v151259(VarCurr)
    <=> ( v151260(VarCurr)
        & v151277(VarCurr) ) ) ).

tff(writeUnaryOperator_11462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151277(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7128,axiom,
    ! [VarCurr: state_type] :
      ( v151260(VarCurr)
    <=> ( v151262(VarCurr)
        | v151276(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7127,axiom,
    ! [VarCurr: state_type] :
      ( v151262(VarCurr)
    <=> ( v151263(VarCurr)
        | v151276(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7126,axiom,
    ! [VarCurr: state_type] :
      ( v151263(VarCurr)
    <=> ( v151264(VarCurr)
        | v151276(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7125,axiom,
    ! [VarCurr: state_type] :
      ( v151264(VarCurr)
    <=> ( v151265(VarCurr)
        | v151276(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7124,axiom,
    ! [VarCurr: state_type] :
      ( v151265(VarCurr)
    <=> ( v151266(VarCurr)
        | v151276(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7123,axiom,
    ! [VarCurr: state_type] :
      ( v151266(VarCurr)
    <=> ( v151267(VarCurr)
        | v151276(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7122,axiom,
    ! [VarCurr: state_type] :
      ( v151267(VarCurr)
    <=> ( v151268(VarCurr)
        | v151276(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7121,axiom,
    ! [VarCurr: state_type] :
      ( v151268(VarCurr)
    <=> ( v151269(VarCurr)
        | v151276(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7120,axiom,
    ! [VarCurr: state_type] :
      ( v151269(VarCurr)
    <=> ( v151270(VarCurr)
        | v151276(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7119,axiom,
    ! [VarCurr: state_type] :
      ( v151270(VarCurr)
    <=> ( v151271(VarCurr)
        | v151276(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7118,axiom,
    ! [VarCurr: state_type] :
      ( v151271(VarCurr)
    <=> ( v151272(VarCurr)
        | v151276(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7117,axiom,
    ! [VarCurr: state_type] :
      ( v151272(VarCurr)
    <=> ( v151273(VarCurr)
        | v151276(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7116,axiom,
    ! [VarCurr: state_type] :
      ( v151273(VarCurr)
    <=> ( v151274(VarCurr)
        | v151276(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7115,axiom,
    ! [VarCurr: state_type] :
      ( v151274(VarCurr)
    <=> ( v151275(VarCurr)
        | v151276(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7114,axiom,
    ! [VarCurr: state_type] :
      ( v151275(VarCurr)
    <=> ( v151276(VarCurr,0)
        | v151276(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151276(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137831(VarCurr,B) ) ) ) ).

tff(addAssignment_85356,axiom,
    ! [VarCurr: state_type] :
      ( v151253(VarCurr)
    <=> v151255(VarCurr) ) ).

tff(addAssignment_85355,axiom,
    ! [VarCurr: state_type] :
      ( v151255(VarCurr)
    <=> v151257(VarCurr) ) ).

tff(addAssignment_85354,axiom,
    ! [VarCurr: state_type] :
      ( v151257(VarCurr)
    <=> v85238(VarCurr,6) ) ).

tff(addAssignment_85353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151247(VarCurr,B)
      <=> v151249(VarCurr,B) ) ) ).

tff(addAssignment_85352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151249(VarCurr,B)
      <=> v151251(VarCurr,B) ) ) ).

tff(addAssignment_85351,axiom,
    ! [VarCurr: state_type] :
      ( ( v151251(VarCurr,2)
      <=> v85238(VarCurr,5) )
      & ( v151251(VarCurr,1)
      <=> v85238(VarCurr,4) )
      & ( v151251(VarCurr,0)
      <=> v85238(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7113,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,4)
    <=> ( v151203(VarCurr)
        & v151222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20116,axiom,
    ! [VarCurr: state_type] :
      ( v151222(VarCurr)
    <=> ( v151223(VarCurr)
        | v151244(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2348,axiom,
    ! [VarCurr: state_type] :
      ( v151244(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151245(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151245(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151245(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151245(VarCurr,0) ) ) ) ).

tff(addAssignment_85350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151245(VarCurr,B)
      <=> v151191(VarCurr,B) ) ) ).

tff(addAssignment_85349,axiom,
    ! [VarCurr: state_type] :
      ( v151245(VarCurr,3)
    <=> v151197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20115,axiom,
    ! [VarCurr: state_type] :
      ( v151223(VarCurr)
    <=> ( v151224(VarCurr)
        | v151225(VarCurr) ) ) ).

tff(writeUnaryOperator_11461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151225(VarCurr)
    <=> v151227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20114,axiom,
    ! [VarCurr: state_type] :
      ( v151227(VarCurr)
    <=> ( v151228(VarCurr)
        & v151239(VarCurr) ) ) ).

tff(writeUnaryOperator_11460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151239(VarCurr)
    <=> v151240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20113,axiom,
    ! [VarCurr: state_type] :
      ( v151240(VarCurr)
    <=> ( v151241(VarCurr)
        & v151243(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7112,axiom,
    ! [VarCurr: state_type] :
      ( v151243(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151191(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20112,axiom,
    ! [VarCurr: state_type] :
      ( v151241(VarCurr)
    <=> ( v135621(VarCurr)
        | v151242(VarCurr) ) ) ).

tff(writeUnaryOperator_11459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151242(VarCurr)
    <=> v151191(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20111,axiom,
    ! [VarCurr: state_type] :
      ( v151228(VarCurr)
    <=> ( v151229(VarCurr)
        & v151234(VarCurr) ) ) ).

tff(writeUnaryOperator_11458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151234(VarCurr)
    <=> v151235(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20110,axiom,
    ! [VarCurr: state_type] :
      ( v151235(VarCurr)
    <=> ( v151236(VarCurr)
        & v151238(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7111,axiom,
    ! [VarCurr: state_type] :
      ( v151238(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151191(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20109,axiom,
    ! [VarCurr: state_type] :
      ( v151236(VarCurr)
    <=> ( v135615(VarCurr)
        | v151237(VarCurr) ) ) ).

tff(writeUnaryOperator_11457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151237(VarCurr)
    <=> v151191(VarCurr,1) ) ).

tff(writeUnaryOperator_11456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151229(VarCurr)
    <=> v151230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20108,axiom,
    ! [VarCurr: state_type] :
      ( v151230(VarCurr)
    <=> ( v151231(VarCurr)
        & v151233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20107,axiom,
    ! [VarCurr: state_type] :
      ( v151233(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151191(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20106,axiom,
    ! [VarCurr: state_type] :
      ( v151231(VarCurr)
    <=> ( v135609(VarCurr)
        | v151232(VarCurr) ) ) ).

tff(writeUnaryOperator_11455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151232(VarCurr)
    <=> v151191(VarCurr,0) ) ).

tff(writeUnaryOperator_11454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151224(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20105,axiom,
    ! [VarCurr: state_type] :
      ( v151203(VarCurr)
    <=> ( v151204(VarCurr)
        & v151221(VarCurr) ) ) ).

tff(writeUnaryOperator_11453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151221(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7110,axiom,
    ! [VarCurr: state_type] :
      ( v151204(VarCurr)
    <=> ( v151206(VarCurr)
        | v151220(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7109,axiom,
    ! [VarCurr: state_type] :
      ( v151206(VarCurr)
    <=> ( v151207(VarCurr)
        | v151220(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7108,axiom,
    ! [VarCurr: state_type] :
      ( v151207(VarCurr)
    <=> ( v151208(VarCurr)
        | v151220(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7107,axiom,
    ! [VarCurr: state_type] :
      ( v151208(VarCurr)
    <=> ( v151209(VarCurr)
        | v151220(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7106,axiom,
    ! [VarCurr: state_type] :
      ( v151209(VarCurr)
    <=> ( v151210(VarCurr)
        | v151220(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7105,axiom,
    ! [VarCurr: state_type] :
      ( v151210(VarCurr)
    <=> ( v151211(VarCurr)
        | v151220(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7104,axiom,
    ! [VarCurr: state_type] :
      ( v151211(VarCurr)
    <=> ( v151212(VarCurr)
        | v151220(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7103,axiom,
    ! [VarCurr: state_type] :
      ( v151212(VarCurr)
    <=> ( v151213(VarCurr)
        | v151220(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7102,axiom,
    ! [VarCurr: state_type] :
      ( v151213(VarCurr)
    <=> ( v151214(VarCurr)
        | v151220(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7101,axiom,
    ! [VarCurr: state_type] :
      ( v151214(VarCurr)
    <=> ( v151215(VarCurr)
        | v151220(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7100,axiom,
    ! [VarCurr: state_type] :
      ( v151215(VarCurr)
    <=> ( v151216(VarCurr)
        | v151220(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7099,axiom,
    ! [VarCurr: state_type] :
      ( v151216(VarCurr)
    <=> ( v151217(VarCurr)
        | v151220(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7098,axiom,
    ! [VarCurr: state_type] :
      ( v151217(VarCurr)
    <=> ( v151218(VarCurr)
        | v151220(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7097,axiom,
    ! [VarCurr: state_type] :
      ( v151218(VarCurr)
    <=> ( v151219(VarCurr)
        | v151220(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7096,axiom,
    ! [VarCurr: state_type] :
      ( v151219(VarCurr)
    <=> ( v151220(VarCurr,0)
        | v151220(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151220(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137750(VarCurr,B) ) ) ) ).

tff(addAssignment_85348,axiom,
    ! [VarCurr: state_type] :
      ( v151197(VarCurr)
    <=> v151199(VarCurr) ) ).

tff(addAssignment_85347,axiom,
    ! [VarCurr: state_type] :
      ( v151199(VarCurr)
    <=> v151201(VarCurr) ) ).

tff(addAssignment_85346,axiom,
    ! [VarCurr: state_type] :
      ( v151201(VarCurr)
    <=> v85216(VarCurr,6) ) ).

tff(addAssignment_85345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151191(VarCurr,B)
      <=> v151193(VarCurr,B) ) ) ).

tff(addAssignment_85344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151193(VarCurr,B)
      <=> v151195(VarCurr,B) ) ) ).

tff(addAssignment_85343,axiom,
    ! [VarCurr: state_type] :
      ( ( v151195(VarCurr,2)
      <=> v85216(VarCurr,5) )
      & ( v151195(VarCurr,1)
      <=> v85216(VarCurr,4) )
      & ( v151195(VarCurr,0)
      <=> v85216(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7095,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,3)
    <=> ( v151147(VarCurr)
        & v151166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20104,axiom,
    ! [VarCurr: state_type] :
      ( v151166(VarCurr)
    <=> ( v151167(VarCurr)
        | v151188(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2347,axiom,
    ! [VarCurr: state_type] :
      ( v151188(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151189(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151189(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151189(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151189(VarCurr,0) ) ) ) ).

tff(addAssignment_85342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151189(VarCurr,B)
      <=> v151135(VarCurr,B) ) ) ).

tff(addAssignment_85341,axiom,
    ! [VarCurr: state_type] :
      ( v151189(VarCurr,3)
    <=> v151141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20103,axiom,
    ! [VarCurr: state_type] :
      ( v151167(VarCurr)
    <=> ( v151168(VarCurr)
        | v151169(VarCurr) ) ) ).

tff(writeUnaryOperator_11452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151169(VarCurr)
    <=> v151171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20102,axiom,
    ! [VarCurr: state_type] :
      ( v151171(VarCurr)
    <=> ( v151172(VarCurr)
        & v151183(VarCurr) ) ) ).

tff(writeUnaryOperator_11451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151183(VarCurr)
    <=> v151184(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20101,axiom,
    ! [VarCurr: state_type] :
      ( v151184(VarCurr)
    <=> ( v151185(VarCurr)
        & v151187(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7094,axiom,
    ! [VarCurr: state_type] :
      ( v151187(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151135(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20100,axiom,
    ! [VarCurr: state_type] :
      ( v151185(VarCurr)
    <=> ( v135621(VarCurr)
        | v151186(VarCurr) ) ) ).

tff(writeUnaryOperator_11450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151186(VarCurr)
    <=> v151135(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20099,axiom,
    ! [VarCurr: state_type] :
      ( v151172(VarCurr)
    <=> ( v151173(VarCurr)
        & v151178(VarCurr) ) ) ).

tff(writeUnaryOperator_11449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151178(VarCurr)
    <=> v151179(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20098,axiom,
    ! [VarCurr: state_type] :
      ( v151179(VarCurr)
    <=> ( v151180(VarCurr)
        & v151182(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7093,axiom,
    ! [VarCurr: state_type] :
      ( v151182(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151135(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20097,axiom,
    ! [VarCurr: state_type] :
      ( v151180(VarCurr)
    <=> ( v135615(VarCurr)
        | v151181(VarCurr) ) ) ).

tff(writeUnaryOperator_11448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151181(VarCurr)
    <=> v151135(VarCurr,1) ) ).

tff(writeUnaryOperator_11447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151173(VarCurr)
    <=> v151174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20096,axiom,
    ! [VarCurr: state_type] :
      ( v151174(VarCurr)
    <=> ( v151175(VarCurr)
        & v151177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20095,axiom,
    ! [VarCurr: state_type] :
      ( v151177(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151135(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20094,axiom,
    ! [VarCurr: state_type] :
      ( v151175(VarCurr)
    <=> ( v135609(VarCurr)
        | v151176(VarCurr) ) ) ).

tff(writeUnaryOperator_11446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151176(VarCurr)
    <=> v151135(VarCurr,0) ) ).

tff(writeUnaryOperator_11445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151168(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20093,axiom,
    ! [VarCurr: state_type] :
      ( v151147(VarCurr)
    <=> ( v151148(VarCurr)
        & v151165(VarCurr) ) ) ).

tff(writeUnaryOperator_11444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151165(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7092,axiom,
    ! [VarCurr: state_type] :
      ( v151148(VarCurr)
    <=> ( v151150(VarCurr)
        | v151164(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7091,axiom,
    ! [VarCurr: state_type] :
      ( v151150(VarCurr)
    <=> ( v151151(VarCurr)
        | v151164(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7090,axiom,
    ! [VarCurr: state_type] :
      ( v151151(VarCurr)
    <=> ( v151152(VarCurr)
        | v151164(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7089,axiom,
    ! [VarCurr: state_type] :
      ( v151152(VarCurr)
    <=> ( v151153(VarCurr)
        | v151164(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7088,axiom,
    ! [VarCurr: state_type] :
      ( v151153(VarCurr)
    <=> ( v151154(VarCurr)
        | v151164(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7087,axiom,
    ! [VarCurr: state_type] :
      ( v151154(VarCurr)
    <=> ( v151155(VarCurr)
        | v151164(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7086,axiom,
    ! [VarCurr: state_type] :
      ( v151155(VarCurr)
    <=> ( v151156(VarCurr)
        | v151164(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7085,axiom,
    ! [VarCurr: state_type] :
      ( v151156(VarCurr)
    <=> ( v151157(VarCurr)
        | v151164(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7084,axiom,
    ! [VarCurr: state_type] :
      ( v151157(VarCurr)
    <=> ( v151158(VarCurr)
        | v151164(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7083,axiom,
    ! [VarCurr: state_type] :
      ( v151158(VarCurr)
    <=> ( v151159(VarCurr)
        | v151164(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7082,axiom,
    ! [VarCurr: state_type] :
      ( v151159(VarCurr)
    <=> ( v151160(VarCurr)
        | v151164(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7081,axiom,
    ! [VarCurr: state_type] :
      ( v151160(VarCurr)
    <=> ( v151161(VarCurr)
        | v151164(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7080,axiom,
    ! [VarCurr: state_type] :
      ( v151161(VarCurr)
    <=> ( v151162(VarCurr)
        | v151164(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7079,axiom,
    ! [VarCurr: state_type] :
      ( v151162(VarCurr)
    <=> ( v151163(VarCurr)
        | v151164(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7078,axiom,
    ! [VarCurr: state_type] :
      ( v151163(VarCurr)
    <=> ( v151164(VarCurr,0)
        | v151164(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151164(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137669(VarCurr,B) ) ) ) ).

tff(addAssignment_85340,axiom,
    ! [VarCurr: state_type] :
      ( v151141(VarCurr)
    <=> v151143(VarCurr) ) ).

tff(addAssignment_85339,axiom,
    ! [VarCurr: state_type] :
      ( v151143(VarCurr)
    <=> v151145(VarCurr) ) ).

tff(addAssignment_85338,axiom,
    ! [VarCurr: state_type] :
      ( v151145(VarCurr)
    <=> v85194(VarCurr,6) ) ).

tff(addAssignment_85337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151135(VarCurr,B)
      <=> v151137(VarCurr,B) ) ) ).

tff(addAssignment_85336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151137(VarCurr,B)
      <=> v151139(VarCurr,B) ) ) ).

tff(addAssignment_85335,axiom,
    ! [VarCurr: state_type] :
      ( ( v151139(VarCurr,2)
      <=> v85194(VarCurr,5) )
      & ( v151139(VarCurr,1)
      <=> v85194(VarCurr,4) )
      & ( v151139(VarCurr,0)
      <=> v85194(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7077,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,2)
    <=> ( v151091(VarCurr)
        & v151110(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20092,axiom,
    ! [VarCurr: state_type] :
      ( v151110(VarCurr)
    <=> ( v151111(VarCurr)
        | v151132(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2346,axiom,
    ! [VarCurr: state_type] :
      ( v151132(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151133(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151133(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151133(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151133(VarCurr,0) ) ) ) ).

tff(addAssignment_85334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151133(VarCurr,B)
      <=> v151079(VarCurr,B) ) ) ).

tff(addAssignment_85333,axiom,
    ! [VarCurr: state_type] :
      ( v151133(VarCurr,3)
    <=> v151085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20091,axiom,
    ! [VarCurr: state_type] :
      ( v151111(VarCurr)
    <=> ( v151112(VarCurr)
        | v151113(VarCurr) ) ) ).

tff(writeUnaryOperator_11443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151113(VarCurr)
    <=> v151115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20090,axiom,
    ! [VarCurr: state_type] :
      ( v151115(VarCurr)
    <=> ( v151116(VarCurr)
        & v151127(VarCurr) ) ) ).

tff(writeUnaryOperator_11442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151127(VarCurr)
    <=> v151128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20089,axiom,
    ! [VarCurr: state_type] :
      ( v151128(VarCurr)
    <=> ( v151129(VarCurr)
        & v151131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7076,axiom,
    ! [VarCurr: state_type] :
      ( v151131(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151079(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20088,axiom,
    ! [VarCurr: state_type] :
      ( v151129(VarCurr)
    <=> ( v135621(VarCurr)
        | v151130(VarCurr) ) ) ).

tff(writeUnaryOperator_11441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151130(VarCurr)
    <=> v151079(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20087,axiom,
    ! [VarCurr: state_type] :
      ( v151116(VarCurr)
    <=> ( v151117(VarCurr)
        & v151122(VarCurr) ) ) ).

tff(writeUnaryOperator_11440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151122(VarCurr)
    <=> v151123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20086,axiom,
    ! [VarCurr: state_type] :
      ( v151123(VarCurr)
    <=> ( v151124(VarCurr)
        & v151126(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7075,axiom,
    ! [VarCurr: state_type] :
      ( v151126(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151079(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20085,axiom,
    ! [VarCurr: state_type] :
      ( v151124(VarCurr)
    <=> ( v135615(VarCurr)
        | v151125(VarCurr) ) ) ).

tff(writeUnaryOperator_11439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151125(VarCurr)
    <=> v151079(VarCurr,1) ) ).

tff(writeUnaryOperator_11438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151117(VarCurr)
    <=> v151118(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20084,axiom,
    ! [VarCurr: state_type] :
      ( v151118(VarCurr)
    <=> ( v151119(VarCurr)
        & v151121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20083,axiom,
    ! [VarCurr: state_type] :
      ( v151121(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151079(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20082,axiom,
    ! [VarCurr: state_type] :
      ( v151119(VarCurr)
    <=> ( v135609(VarCurr)
        | v151120(VarCurr) ) ) ).

tff(writeUnaryOperator_11437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151120(VarCurr)
    <=> v151079(VarCurr,0) ) ).

tff(writeUnaryOperator_11436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151112(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20081,axiom,
    ! [VarCurr: state_type] :
      ( v151091(VarCurr)
    <=> ( v151092(VarCurr)
        & v151109(VarCurr) ) ) ).

tff(writeUnaryOperator_11435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151109(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7074,axiom,
    ! [VarCurr: state_type] :
      ( v151092(VarCurr)
    <=> ( v151094(VarCurr)
        | v151108(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7073,axiom,
    ! [VarCurr: state_type] :
      ( v151094(VarCurr)
    <=> ( v151095(VarCurr)
        | v151108(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7072,axiom,
    ! [VarCurr: state_type] :
      ( v151095(VarCurr)
    <=> ( v151096(VarCurr)
        | v151108(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7071,axiom,
    ! [VarCurr: state_type] :
      ( v151096(VarCurr)
    <=> ( v151097(VarCurr)
        | v151108(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7070,axiom,
    ! [VarCurr: state_type] :
      ( v151097(VarCurr)
    <=> ( v151098(VarCurr)
        | v151108(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7069,axiom,
    ! [VarCurr: state_type] :
      ( v151098(VarCurr)
    <=> ( v151099(VarCurr)
        | v151108(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7068,axiom,
    ! [VarCurr: state_type] :
      ( v151099(VarCurr)
    <=> ( v151100(VarCurr)
        | v151108(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7067,axiom,
    ! [VarCurr: state_type] :
      ( v151100(VarCurr)
    <=> ( v151101(VarCurr)
        | v151108(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7066,axiom,
    ! [VarCurr: state_type] :
      ( v151101(VarCurr)
    <=> ( v151102(VarCurr)
        | v151108(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7065,axiom,
    ! [VarCurr: state_type] :
      ( v151102(VarCurr)
    <=> ( v151103(VarCurr)
        | v151108(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7064,axiom,
    ! [VarCurr: state_type] :
      ( v151103(VarCurr)
    <=> ( v151104(VarCurr)
        | v151108(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7063,axiom,
    ! [VarCurr: state_type] :
      ( v151104(VarCurr)
    <=> ( v151105(VarCurr)
        | v151108(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7062,axiom,
    ! [VarCurr: state_type] :
      ( v151105(VarCurr)
    <=> ( v151106(VarCurr)
        | v151108(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7061,axiom,
    ! [VarCurr: state_type] :
      ( v151106(VarCurr)
    <=> ( v151107(VarCurr)
        | v151108(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7060,axiom,
    ! [VarCurr: state_type] :
      ( v151107(VarCurr)
    <=> ( v151108(VarCurr,0)
        | v151108(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151108(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137588(VarCurr,B) ) ) ) ).

tff(addAssignment_85332,axiom,
    ! [VarCurr: state_type] :
      ( v151085(VarCurr)
    <=> v151087(VarCurr) ) ).

tff(addAssignment_85331,axiom,
    ! [VarCurr: state_type] :
      ( v151087(VarCurr)
    <=> v151089(VarCurr) ) ).

tff(addAssignment_85330,axiom,
    ! [VarCurr: state_type] :
      ( v151089(VarCurr)
    <=> v85172(VarCurr,6) ) ).

tff(addAssignment_85329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151079(VarCurr,B)
      <=> v151081(VarCurr,B) ) ) ).

tff(addAssignment_85328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151081(VarCurr,B)
      <=> v151083(VarCurr,B) ) ) ).

tff(addAssignment_85327,axiom,
    ! [VarCurr: state_type] :
      ( ( v151083(VarCurr,2)
      <=> v85172(VarCurr,5) )
      & ( v151083(VarCurr,1)
      <=> v85172(VarCurr,4) )
      & ( v151083(VarCurr,0)
      <=> v85172(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7059,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,1)
    <=> ( v151035(VarCurr)
        & v151054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20080,axiom,
    ! [VarCurr: state_type] :
      ( v151054(VarCurr)
    <=> ( v151055(VarCurr)
        | v151076(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2345,axiom,
    ! [VarCurr: state_type] :
      ( v151076(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151077(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151077(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151077(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151077(VarCurr,0) ) ) ) ).

tff(addAssignment_85326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151077(VarCurr,B)
      <=> v151023(VarCurr,B) ) ) ).

tff(addAssignment_85325,axiom,
    ! [VarCurr: state_type] :
      ( v151077(VarCurr,3)
    <=> v151029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20079,axiom,
    ! [VarCurr: state_type] :
      ( v151055(VarCurr)
    <=> ( v151056(VarCurr)
        | v151057(VarCurr) ) ) ).

tff(writeUnaryOperator_11434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151057(VarCurr)
    <=> v151059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20078,axiom,
    ! [VarCurr: state_type] :
      ( v151059(VarCurr)
    <=> ( v151060(VarCurr)
        & v151071(VarCurr) ) ) ).

tff(writeUnaryOperator_11433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151071(VarCurr)
    <=> v151072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20077,axiom,
    ! [VarCurr: state_type] :
      ( v151072(VarCurr)
    <=> ( v151073(VarCurr)
        & v151075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7058,axiom,
    ! [VarCurr: state_type] :
      ( v151075(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v151023(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20076,axiom,
    ! [VarCurr: state_type] :
      ( v151073(VarCurr)
    <=> ( v135621(VarCurr)
        | v151074(VarCurr) ) ) ).

tff(writeUnaryOperator_11432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151074(VarCurr)
    <=> v151023(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20075,axiom,
    ! [VarCurr: state_type] :
      ( v151060(VarCurr)
    <=> ( v151061(VarCurr)
        & v151066(VarCurr) ) ) ).

tff(writeUnaryOperator_11431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151066(VarCurr)
    <=> v151067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20074,axiom,
    ! [VarCurr: state_type] :
      ( v151067(VarCurr)
    <=> ( v151068(VarCurr)
        & v151070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7057,axiom,
    ! [VarCurr: state_type] :
      ( v151070(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v151023(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20073,axiom,
    ! [VarCurr: state_type] :
      ( v151068(VarCurr)
    <=> ( v135615(VarCurr)
        | v151069(VarCurr) ) ) ).

tff(writeUnaryOperator_11430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151069(VarCurr)
    <=> v151023(VarCurr,1) ) ).

tff(writeUnaryOperator_11429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151061(VarCurr)
    <=> v151062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20072,axiom,
    ! [VarCurr: state_type] :
      ( v151062(VarCurr)
    <=> ( v151063(VarCurr)
        & v151065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20071,axiom,
    ! [VarCurr: state_type] :
      ( v151065(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v151023(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20070,axiom,
    ! [VarCurr: state_type] :
      ( v151063(VarCurr)
    <=> ( v135609(VarCurr)
        | v151064(VarCurr) ) ) ).

tff(writeUnaryOperator_11428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151064(VarCurr)
    <=> v151023(VarCurr,0) ) ).

tff(writeUnaryOperator_11427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151056(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20069,axiom,
    ! [VarCurr: state_type] :
      ( v151035(VarCurr)
    <=> ( v151036(VarCurr)
        & v151053(VarCurr) ) ) ).

tff(writeUnaryOperator_11426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151053(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7056,axiom,
    ! [VarCurr: state_type] :
      ( v151036(VarCurr)
    <=> ( v151038(VarCurr)
        | v151052(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7055,axiom,
    ! [VarCurr: state_type] :
      ( v151038(VarCurr)
    <=> ( v151039(VarCurr)
        | v151052(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7054,axiom,
    ! [VarCurr: state_type] :
      ( v151039(VarCurr)
    <=> ( v151040(VarCurr)
        | v151052(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7053,axiom,
    ! [VarCurr: state_type] :
      ( v151040(VarCurr)
    <=> ( v151041(VarCurr)
        | v151052(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7052,axiom,
    ! [VarCurr: state_type] :
      ( v151041(VarCurr)
    <=> ( v151042(VarCurr)
        | v151052(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7051,axiom,
    ! [VarCurr: state_type] :
      ( v151042(VarCurr)
    <=> ( v151043(VarCurr)
        | v151052(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7050,axiom,
    ! [VarCurr: state_type] :
      ( v151043(VarCurr)
    <=> ( v151044(VarCurr)
        | v151052(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7049,axiom,
    ! [VarCurr: state_type] :
      ( v151044(VarCurr)
    <=> ( v151045(VarCurr)
        | v151052(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7048,axiom,
    ! [VarCurr: state_type] :
      ( v151045(VarCurr)
    <=> ( v151046(VarCurr)
        | v151052(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7047,axiom,
    ! [VarCurr: state_type] :
      ( v151046(VarCurr)
    <=> ( v151047(VarCurr)
        | v151052(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7046,axiom,
    ! [VarCurr: state_type] :
      ( v151047(VarCurr)
    <=> ( v151048(VarCurr)
        | v151052(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7045,axiom,
    ! [VarCurr: state_type] :
      ( v151048(VarCurr)
    <=> ( v151049(VarCurr)
        | v151052(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7044,axiom,
    ! [VarCurr: state_type] :
      ( v151049(VarCurr)
    <=> ( v151050(VarCurr)
        | v151052(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7043,axiom,
    ! [VarCurr: state_type] :
      ( v151050(VarCurr)
    <=> ( v151051(VarCurr)
        | v151052(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7042,axiom,
    ! [VarCurr: state_type] :
      ( v151051(VarCurr)
    <=> ( v151052(VarCurr,0)
        | v151052(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v151052(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v137507(VarCurr,B) ) ) ) ).

tff(addAssignment_85324,axiom,
    ! [VarCurr: state_type] :
      ( v151029(VarCurr)
    <=> v151031(VarCurr) ) ).

tff(addAssignment_85323,axiom,
    ! [VarCurr: state_type] :
      ( v151031(VarCurr)
    <=> v151033(VarCurr) ) ).

tff(addAssignment_85322,axiom,
    ! [VarCurr: state_type] :
      ( v151033(VarCurr)
    <=> v85150(VarCurr,6) ) ).

tff(addAssignment_85321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151023(VarCurr,B)
      <=> v151025(VarCurr,B) ) ) ).

tff(addAssignment_85320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151025(VarCurr,B)
      <=> v151027(VarCurr,B) ) ) ).

tff(addAssignment_85319,axiom,
    ! [VarCurr: state_type] :
      ( ( v151027(VarCurr,2)
      <=> v85150(VarCurr,5) )
      & ( v151027(VarCurr,1)
      <=> v85150(VarCurr,4) )
      & ( v151027(VarCurr,0)
      <=> v85150(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20068,axiom,
    ! [VarCurr: state_type] :
      ( v150965(VarCurr,0)
    <=> ( v150979(VarCurr)
        & v150998(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20067,axiom,
    ! [VarCurr: state_type] :
      ( v150998(VarCurr)
    <=> ( v150999(VarCurr)
        | v151020(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2344,axiom,
    ! [VarCurr: state_type] :
      ( v151020(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v151021(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v151021(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v151021(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v151021(VarCurr,0) ) ) ) ).

tff(addAssignment_85318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v151021(VarCurr,B)
      <=> v150967(VarCurr,B) ) ) ).

tff(addAssignment_85317,axiom,
    ! [VarCurr: state_type] :
      ( v151021(VarCurr,3)
    <=> v150973(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20066,axiom,
    ! [VarCurr: state_type] :
      ( v150999(VarCurr)
    <=> ( v151000(VarCurr)
        | v151001(VarCurr) ) ) ).

tff(writeUnaryOperator_11425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151001(VarCurr)
    <=> v151003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20065,axiom,
    ! [VarCurr: state_type] :
      ( v151003(VarCurr)
    <=> ( v151004(VarCurr)
        & v151015(VarCurr) ) ) ).

tff(writeUnaryOperator_11424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151015(VarCurr)
    <=> v151016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20064,axiom,
    ! [VarCurr: state_type] :
      ( v151016(VarCurr)
    <=> ( v151017(VarCurr)
        & v151019(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7041,axiom,
    ! [VarCurr: state_type] :
      ( v151019(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v150967(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20063,axiom,
    ! [VarCurr: state_type] :
      ( v151017(VarCurr)
    <=> ( v135621(VarCurr)
        | v151018(VarCurr) ) ) ).

tff(writeUnaryOperator_11423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151018(VarCurr)
    <=> v150967(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20062,axiom,
    ! [VarCurr: state_type] :
      ( v151004(VarCurr)
    <=> ( v151005(VarCurr)
        & v151010(VarCurr) ) ) ).

tff(writeUnaryOperator_11422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151010(VarCurr)
    <=> v151011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20061,axiom,
    ! [VarCurr: state_type] :
      ( v151011(VarCurr)
    <=> ( v151012(VarCurr)
        & v151014(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7040,axiom,
    ! [VarCurr: state_type] :
      ( v151014(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v150967(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20060,axiom,
    ! [VarCurr: state_type] :
      ( v151012(VarCurr)
    <=> ( v135615(VarCurr)
        | v151013(VarCurr) ) ) ).

tff(writeUnaryOperator_11421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151013(VarCurr)
    <=> v150967(VarCurr,1) ) ).

tff(writeUnaryOperator_11420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151005(VarCurr)
    <=> v151006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20059,axiom,
    ! [VarCurr: state_type] :
      ( v151006(VarCurr)
    <=> ( v151007(VarCurr)
        & v151009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20058,axiom,
    ! [VarCurr: state_type] :
      ( v151009(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v150967(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20057,axiom,
    ! [VarCurr: state_type] :
      ( v151007(VarCurr)
    <=> ( v135609(VarCurr)
        | v151008(VarCurr) ) ) ).

tff(writeUnaryOperator_11419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151008(VarCurr)
    <=> v150967(VarCurr,0) ) ).

tff(writeUnaryOperator_11418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v151000(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20056,axiom,
    ! [VarCurr: state_type] :
      ( v150979(VarCurr)
    <=> ( v150980(VarCurr)
        & v150997(VarCurr) ) ) ).

tff(writeUnaryOperator_11417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150997(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_7039,axiom,
    ! [VarCurr: state_type] :
      ( v150980(VarCurr)
    <=> ( v150982(VarCurr)
        | v150996(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7038,axiom,
    ! [VarCurr: state_type] :
      ( v150982(VarCurr)
    <=> ( v150983(VarCurr)
        | v150996(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7037,axiom,
    ! [VarCurr: state_type] :
      ( v150983(VarCurr)
    <=> ( v150984(VarCurr)
        | v150996(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7036,axiom,
    ! [VarCurr: state_type] :
      ( v150984(VarCurr)
    <=> ( v150985(VarCurr)
        | v150996(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7035,axiom,
    ! [VarCurr: state_type] :
      ( v150985(VarCurr)
    <=> ( v150986(VarCurr)
        | v150996(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7034,axiom,
    ! [VarCurr: state_type] :
      ( v150986(VarCurr)
    <=> ( v150987(VarCurr)
        | v150996(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7033,axiom,
    ! [VarCurr: state_type] :
      ( v150987(VarCurr)
    <=> ( v150988(VarCurr)
        | v150996(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7032,axiom,
    ! [VarCurr: state_type] :
      ( v150988(VarCurr)
    <=> ( v150989(VarCurr)
        | v150996(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7031,axiom,
    ! [VarCurr: state_type] :
      ( v150989(VarCurr)
    <=> ( v150990(VarCurr)
        | v150996(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7030,axiom,
    ! [VarCurr: state_type] :
      ( v150990(VarCurr)
    <=> ( v150991(VarCurr)
        | v150996(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7029,axiom,
    ! [VarCurr: state_type] :
      ( v150991(VarCurr)
    <=> ( v150992(VarCurr)
        | v150996(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7028,axiom,
    ! [VarCurr: state_type] :
      ( v150992(VarCurr)
    <=> ( v150993(VarCurr)
        | v150996(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7027,axiom,
    ! [VarCurr: state_type] :
      ( v150993(VarCurr)
    <=> ( v150994(VarCurr)
        | v150996(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7026,axiom,
    ! [VarCurr: state_type] :
      ( v150994(VarCurr)
    <=> ( v150995(VarCurr)
        | v150996(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7025,axiom,
    ! [VarCurr: state_type] :
      ( v150995(VarCurr)
    <=> ( v150996(VarCurr,0)
        | v150996(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150996(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v84909(VarCurr,B) ) ) ) ).

tff(addAssignment_85316,axiom,
    ! [VarCurr: state_type] :
      ( v150973(VarCurr)
    <=> v150975(VarCurr) ) ).

tff(addAssignment_85315,axiom,
    ! [VarCurr: state_type] :
      ( v150975(VarCurr)
    <=> v150977(VarCurr) ) ).

tff(addAssignment_85314,axiom,
    ! [VarCurr: state_type] :
      ( v150977(VarCurr)
    <=> v85128(VarCurr,6) ) ).

tff(addAssignment_85313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v150967(VarCurr,B)
      <=> v150969(VarCurr,B) ) ) ).

tff(addAssignment_85312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v150969(VarCurr,B)
      <=> v150971(VarCurr,B) ) ) ).

tff(addAssignment_85311,axiom,
    ! [VarCurr: state_type] :
      ( ( v150971(VarCurr,2)
      <=> v85128(VarCurr,5) )
      & ( v150971(VarCurr,1)
      <=> v85128(VarCurr,4) )
      & ( v150971(VarCurr,0)
      <=> v85128(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7024,axiom,
    ! [VarCurr: state_type] :
      ( v124(VarCurr)
    <=> ( v150949(VarCurr)
        | v150963(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7023,axiom,
    ! [VarCurr: state_type] :
      ( v150949(VarCurr)
    <=> ( v150950(VarCurr)
        | v150963(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7022,axiom,
    ! [VarCurr: state_type] :
      ( v150950(VarCurr)
    <=> ( v150951(VarCurr)
        | v150963(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7021,axiom,
    ! [VarCurr: state_type] :
      ( v150951(VarCurr)
    <=> ( v150952(VarCurr)
        | v150963(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7020,axiom,
    ! [VarCurr: state_type] :
      ( v150952(VarCurr)
    <=> ( v150953(VarCurr)
        | v150963(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7019,axiom,
    ! [VarCurr: state_type] :
      ( v150953(VarCurr)
    <=> ( v150954(VarCurr)
        | v150963(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7018,axiom,
    ! [VarCurr: state_type] :
      ( v150954(VarCurr)
    <=> ( v150955(VarCurr)
        | v150963(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7017,axiom,
    ! [VarCurr: state_type] :
      ( v150955(VarCurr)
    <=> ( v150956(VarCurr)
        | v150963(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7016,axiom,
    ! [VarCurr: state_type] :
      ( v150956(VarCurr)
    <=> ( v150957(VarCurr)
        | v150963(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7015,axiom,
    ! [VarCurr: state_type] :
      ( v150957(VarCurr)
    <=> ( v150958(VarCurr)
        | v150963(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7014,axiom,
    ! [VarCurr: state_type] :
      ( v150958(VarCurr)
    <=> ( v150959(VarCurr)
        | v150963(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7013,axiom,
    ! [VarCurr: state_type] :
      ( v150959(VarCurr)
    <=> ( v150960(VarCurr)
        | v150963(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7012,axiom,
    ! [VarCurr: state_type] :
      ( v150960(VarCurr)
    <=> ( v150961(VarCurr)
        | v150963(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7011,axiom,
    ! [VarCurr: state_type] :
      ( v150961(VarCurr)
    <=> ( v150962(VarCurr)
        | v150963(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7010,axiom,
    ! [VarCurr: state_type] :
      ( v150962(VarCurr)
    <=> ( v150963(VarCurr,0)
        | v150963(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150963(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v126(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v126(VarCurr,B)
      <=> ( v150941(VarCurr,B)
          | v139151(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150941(VarCurr,B)
      <=> ( v150942(VarCurr,B)
          | v139014(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150942(VarCurr,B)
      <=> ( v150943(VarCurr,B)
          | v138877(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150943(VarCurr,B)
      <=> ( v150944(VarCurr,B)
          | v138740(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150944(VarCurr,B)
      <=> ( v150945(VarCurr,B)
          | v138603(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150945(VarCurr,B)
      <=> ( v150946(VarCurr,B)
          | v138466(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150946(VarCurr,B)
      <=> ( v128(VarCurr,B)
          | v138307(VarCurr,B) ) ) ) ).

tff(addAssignment_85310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128(VarCurr,B)
      <=> v130(VarCurr,B) ) ) ).

tff(addAssignment_85309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v130(VarCurr,B)
      <=> v132(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v132(VarCurr,B)
      <=> ( v150904(VarCurr,B)
          & v150908(VarCurr,B) ) ) ) ).

tff(addAssignment_85308,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,0)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85307,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,1)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85306,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,2)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85305,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,3)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85304,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,4)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85303,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,5)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85302,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,6)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85301,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,7)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85300,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,8)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85299,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,9)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85298,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,10)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85297,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,11)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85296,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,12)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85295,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,13)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85294,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,14)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85293,axiom,
    ! [VarCurr: state_type] :
      ( v150908(VarCurr,15)
    <=> v150909(VarCurr) ) ).

tff(addAssignment_85292,axiom,
    ! [VarCurr: state_type] :
      ( v150909(VarCurr)
    <=> v150910(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20055,axiom,
    ! [VarCurr: state_type] :
      ( v150910(VarCurr)
    <=> ( v150911(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20054,axiom,
    ! [VarCurr: state_type] :
      ( v150911(VarCurr)
    <=> ( v150912(VarCurr)
        & v150939(VarCurr) ) ) ).

tff(writeUnaryOperator_11416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150939(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20053,axiom,
    ! [VarCurr: state_type] :
      ( v150912(VarCurr)
    <=> ( v150913(VarCurr)
        & v150938(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20052,axiom,
    ! [VarCurr: state_type] :
      ( v150938(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_11415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150913(VarCurr)
    <=> v150915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20051,axiom,
    ! [VarCurr: state_type] :
      ( v150915(VarCurr)
    <=> ( v150916(VarCurr)
        & v150933(VarCurr) ) ) ).

tff(writeUnaryOperator_11414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150933(VarCurr)
    <=> v150934(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20050,axiom,
    ! [VarCurr: state_type] :
      ( v150934(VarCurr)
    <=> ( v150935(VarCurr)
        & v150937(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7009,axiom,
    ! [VarCurr: state_type] :
      ( v150937(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109486(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20049,axiom,
    ! [VarCurr: state_type] :
      ( v150935(VarCurr)
    <=> ( v138404(VarCurr)
        | v150936(VarCurr) ) ) ).

tff(writeUnaryOperator_11413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150936(VarCurr)
    <=> v109486(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20048,axiom,
    ! [VarCurr: state_type] :
      ( v150916(VarCurr)
    <=> ( v150917(VarCurr)
        & v150928(VarCurr) ) ) ).

tff(writeUnaryOperator_11412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150928(VarCurr)
    <=> v150929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20047,axiom,
    ! [VarCurr: state_type] :
      ( v150929(VarCurr)
    <=> ( v150930(VarCurr)
        & v150932(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7008,axiom,
    ! [VarCurr: state_type] :
      ( v150932(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109486(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20046,axiom,
    ! [VarCurr: state_type] :
      ( v150930(VarCurr)
    <=> ( v138398(VarCurr)
        | v150931(VarCurr) ) ) ).

tff(writeUnaryOperator_11411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150931(VarCurr)
    <=> v109486(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20045,axiom,
    ! [VarCurr: state_type] :
      ( v150917(VarCurr)
    <=> ( v150918(VarCurr)
        & v150923(VarCurr) ) ) ).

tff(writeUnaryOperator_11410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150923(VarCurr)
    <=> v150924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20044,axiom,
    ! [VarCurr: state_type] :
      ( v150924(VarCurr)
    <=> ( v150925(VarCurr)
        & v150927(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7007,axiom,
    ! [VarCurr: state_type] :
      ( v150927(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109486(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20043,axiom,
    ! [VarCurr: state_type] :
      ( v150925(VarCurr)
    <=> ( v138392(VarCurr)
        | v150926(VarCurr) ) ) ).

tff(writeUnaryOperator_11409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150926(VarCurr)
    <=> v109486(VarCurr,4) ) ).

tff(writeUnaryOperator_11408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150918(VarCurr)
    <=> v150919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20042,axiom,
    ! [VarCurr: state_type] :
      ( v150919(VarCurr)
    <=> ( v150920(VarCurr)
        & v150922(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7006,axiom,
    ! [VarCurr: state_type] :
      ( v150922(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109486(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20041,axiom,
    ! [VarCurr: state_type] :
      ( v150920(VarCurr)
    <=> ( v138386(VarCurr)
        | v150921(VarCurr) ) ) ).

tff(writeUnaryOperator_11407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150921(VarCurr)
    <=> v109486(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150904(VarCurr,B)
      <=> ( v150905(VarCurr,B)
          & v127712(VarCurr,B) ) ) ) ).

tff(addAssignment_85291,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,0)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85290,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,1)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85289,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,2)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85288,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,3)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85287,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,4)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85286,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,5)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85285,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,6)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85284,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,7)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85283,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,8)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85282,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,9)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85281,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,10)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85280,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,11)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85279,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,12)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85278,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,13)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85277,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,14)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85276,axiom,
    ! [VarCurr: state_type] :
      ( v150905(VarCurr,15)
    <=> v150906(VarCurr) ) ).

tff(addAssignment_85275,axiom,
    ! [VarCurr: state_type] :
      ( v150906(VarCurr)
    <=> v150907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20040,axiom,
    ! [VarCurr: state_type] :
      ( v150907(VarCurr)
    <=> ( v134(VarCurr,0)
        & v150866(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7005,axiom,
    ! [VarCurr: state_type] :
      ( v150866(VarCurr)
    <=> ( v150888(VarCurr)
        | v150902(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7004,axiom,
    ! [VarCurr: state_type] :
      ( v150888(VarCurr)
    <=> ( v150889(VarCurr)
        | v150902(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7003,axiom,
    ! [VarCurr: state_type] :
      ( v150889(VarCurr)
    <=> ( v150890(VarCurr)
        | v150902(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7002,axiom,
    ! [VarCurr: state_type] :
      ( v150890(VarCurr)
    <=> ( v150891(VarCurr)
        | v150902(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7001,axiom,
    ! [VarCurr: state_type] :
      ( v150891(VarCurr)
    <=> ( v150892(VarCurr)
        | v150902(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7000,axiom,
    ! [VarCurr: state_type] :
      ( v150892(VarCurr)
    <=> ( v150893(VarCurr)
        | v150902(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6999,axiom,
    ! [VarCurr: state_type] :
      ( v150893(VarCurr)
    <=> ( v150894(VarCurr)
        | v150902(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6998,axiom,
    ! [VarCurr: state_type] :
      ( v150894(VarCurr)
    <=> ( v150895(VarCurr)
        | v150902(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6997,axiom,
    ! [VarCurr: state_type] :
      ( v150895(VarCurr)
    <=> ( v150896(VarCurr)
        | v150902(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6996,axiom,
    ! [VarCurr: state_type] :
      ( v150896(VarCurr)
    <=> ( v150897(VarCurr)
        | v150902(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6995,axiom,
    ! [VarCurr: state_type] :
      ( v150897(VarCurr)
    <=> ( v150898(VarCurr)
        | v150902(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6994,axiom,
    ! [VarCurr: state_type] :
      ( v150898(VarCurr)
    <=> ( v150899(VarCurr)
        | v150902(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6993,axiom,
    ! [VarCurr: state_type] :
      ( v150899(VarCurr)
    <=> ( v150900(VarCurr)
        | v150902(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6992,axiom,
    ! [VarCurr: state_type] :
      ( v150900(VarCurr)
    <=> ( v150901(VarCurr)
        | v150902(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6991,axiom,
    ! [VarCurr: state_type] :
      ( v150901(VarCurr)
    <=> ( v150902(VarCurr,0)
        | v150902(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v150902(VarCurr,B)
      <=> ( v150868(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_85274,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,0)
    <=> v150885(VarCurr) ) ).

tff(addAssignment_85273,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,1)
    <=> v150884(VarCurr) ) ).

tff(addAssignment_85272,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,2)
    <=> v150883(VarCurr) ) ).

tff(addAssignment_85271,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,3)
    <=> v150882(VarCurr) ) ).

tff(addAssignment_85270,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,4)
    <=> v150881(VarCurr) ) ).

tff(addAssignment_85269,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,5)
    <=> v150880(VarCurr) ) ).

tff(addAssignment_85268,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,6)
    <=> v150879(VarCurr) ) ).

tff(addAssignment_85267,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,7)
    <=> v150878(VarCurr) ) ).

tff(addAssignment_85266,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,8)
    <=> v150877(VarCurr) ) ).

tff(addAssignment_85265,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,9)
    <=> v150876(VarCurr) ) ).

tff(addAssignment_85264,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,10)
    <=> v150875(VarCurr) ) ).

tff(addAssignment_85263,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,11)
    <=> v150874(VarCurr) ) ).

tff(addAssignment_85262,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,12)
    <=> v150873(VarCurr) ) ).

tff(addAssignment_85261,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,13)
    <=> v150872(VarCurr) ) ).

tff(addAssignment_85260,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,14)
    <=> v150871(VarCurr) ) ).

tff(addAssignment_85259,axiom,
    ! [VarCurr: state_type] :
      ( v150868(VarCurr,15)
    <=> v150870(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2343,axiom,
    ! [VarCurr: state_type] :
      ( v150885(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2342,axiom,
    ! [VarCurr: state_type] :
      ( v150884(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2341,axiom,
    ! [VarCurr: state_type] :
      ( v150883(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2340,axiom,
    ! [VarCurr: state_type] :
      ( v150882(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2339,axiom,
    ! [VarCurr: state_type] :
      ( v150881(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2338,axiom,
    ! [VarCurr: state_type] :
      ( v150880(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2337,axiom,
    ! [VarCurr: state_type] :
      ( v150879(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2336,axiom,
    ! [VarCurr: state_type] :
      ( v150878(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $false )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2335,axiom,
    ! [VarCurr: state_type] :
      ( v150877(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2334,axiom,
    ! [VarCurr: state_type] :
      ( v150876(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2333,axiom,
    ! [VarCurr: state_type] :
      ( v150875(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2332,axiom,
    ! [VarCurr: state_type] :
      ( v150874(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $false )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2331,axiom,
    ! [VarCurr: state_type] :
      ( v150873(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2330,axiom,
    ! [VarCurr: state_type] :
      ( v150872(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $false )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2329,axiom,
    ! [VarCurr: state_type] :
      ( v150871(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2328,axiom,
    ! [VarCurr: state_type] :
      ( v150870(VarCurr)
    <=> ( ( v109486(VarCurr,6)
        <=> $true )
        & ( v109486(VarCurr,5)
        <=> $true )
        & ( v109486(VarCurr,4)
        <=> $true )
        & ( v109486(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_85258,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,0)
    <=> v89340(VarCurr,0) ) ).

tff(addAssignment_85257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v136(VarCurr,B)
      <=> v138(VarCurr,B) ) ) ).

tff(addAssignment_85256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v138(VarCurr,B)
      <=> v140(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150849(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v140(VarNext,B)
            <=> v140(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2264,axiom,
    ! [VarNext: state_type] :
      ( v150849(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v140(VarNext,B)
          <=> v150859(VarNext,B) ) ) ) ).

tff(addAssignment_85255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v150859(VarNext,B)
          <=> v150857(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v150857(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1664,axiom,
    ! [VarCurr: state_type] :
      ( v150860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v150857(VarCurr,B)
          <=> v162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20039,axiom,
    ! [VarCurr: state_type] :
      ( v150860(VarCurr)
    <=> ( v150861(VarCurr)
        & v150862(VarCurr) ) ) ).

tff(writeUnaryOperator_11406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150862(VarCurr)
    <=> v152(VarCurr) ) ).

tff(writeUnaryOperator_11405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150861(VarCurr)
    <=> v142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150849(VarNext)
      <=> v150850(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150850(VarNext)
      <=> ( v150851(VarNext)
          & v150844(VarNext) ) ) ) ).

tff(writeUnaryOperator_11404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150851(VarNext)
      <=> v150853(VarNext) ) ) ).

tff(addAssignment_85254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150853(VarNext)
      <=> v150844(VarCurr) ) ) ).

tff(addAssignment_85253,axiom,
    ! [VarCurr: state_type] :
      ( v150844(VarCurr)
    <=> v150846(VarCurr) ) ).

tff(addAssignment_85252,axiom,
    ! [VarCurr: state_type] :
      ( v150846(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_85251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v162(VarCurr,B)
      <=> v164(VarCurr,B) ) ) ).

tff(addAssignment_85250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v164(VarCurr,B)
      <=> v166(VarCurr,B) ) ) ).

tff(addAssignment_85249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v166(VarCurr,B)
      <=> v168(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v168(VarCurr,B)
          <=> v150822(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1663,axiom,
    ! [VarCurr: state_type] :
      ( v150800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v168(VarCurr,B)
          <=> v150803(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v150822(VarCurr,B)
          <=> v136(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1662,axiom,
    ! [VarCurr: state_type] :
      ( v150823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v150822(VarCurr,B)
          <=> v150826(VarCurr,B) ) ) ) ).

tff(addAssignment_85248,axiom,
    ! [VarCurr: state_type] :
      ( v150826(VarCurr,0)
    <=> v150819(VarCurr) ) ).

tff(addAssignment_85247,axiom,
    ! [VarCurr: state_type] :
      ( v150826(VarCurr,1)
    <=> v150840(VarCurr) ) ).

tff(addAssignment_85246,axiom,
    ! [VarCurr: state_type] :
      ( v150826(VarCurr,2)
    <=> v150836(VarCurr) ) ).

tff(addAssignment_85245,axiom,
    ! [VarCurr: state_type] :
      ( v150826(VarCurr,3)
    <=> v150828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20036,axiom,
    ! [VarCurr: state_type] :
      ( v150840(VarCurr)
    <=> ( v150841(VarCurr)
        & v150842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20035,axiom,
    ! [VarCurr: state_type] :
      ( v150842(VarCurr)
    <=> ( v136(VarCurr,0)
        | v150820(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6990,axiom,
    ! [VarCurr: state_type] :
      ( v150841(VarCurr)
    <=> ( v150819(VarCurr)
        | v136(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20034,axiom,
    ! [VarCurr: state_type] :
      ( v150836(VarCurr)
    <=> ( v150837(VarCurr)
        & v150839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20033,axiom,
    ! [VarCurr: state_type] :
      ( v150839(VarCurr)
    <=> ( v150815(VarCurr)
        | v150833(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6989,axiom,
    ! [VarCurr: state_type] :
      ( v150837(VarCurr)
    <=> ( v136(VarCurr,2)
        | v150838(VarCurr) ) ) ).

tff(writeUnaryOperator_11403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150838(VarCurr)
    <=> v150833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20032,axiom,
    ! [VarCurr: state_type] :
      ( v150828(VarCurr)
    <=> ( v150829(VarCurr)
        & v150835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20031,axiom,
    ! [VarCurr: state_type] :
      ( v150835(VarCurr)
    <=> ( v150810(VarCurr)
        | v150831(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6988,axiom,
    ! [VarCurr: state_type] :
      ( v150829(VarCurr)
    <=> ( v136(VarCurr,3)
        | v150830(VarCurr) ) ) ).

tff(writeUnaryOperator_11402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150830(VarCurr)
    <=> v150831(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6987,axiom,
    ! [VarCurr: state_type] :
      ( v150831(VarCurr)
    <=> ( v136(VarCurr,2)
        | v150832(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20030,axiom,
    ! [VarCurr: state_type] :
      ( v150832(VarCurr)
    <=> ( v150815(VarCurr)
        & v150833(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6986,axiom,
    ! [VarCurr: state_type] :
      ( v150833(VarCurr)
    <=> ( v136(VarCurr,1)
        | v150834(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20029,axiom,
    ! [VarCurr: state_type] :
      ( v150834(VarCurr)
    <=> ( v136(VarCurr,0)
        & v150820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20028,axiom,
    ! [VarCurr: state_type] :
      ( v150823(VarCurr)
    <=> ( v150824(VarCurr)
        & v150825(VarCurr) ) ) ).

tff(writeUnaryOperator_11401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150825(VarCurr)
    <=> v170(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6985,axiom,
    ! [VarCurr: state_type] :
      ( v150824(VarCurr)
    <=> ( v109144(VarCurr)
        | v89383(VarCurr,7) ) ) ).

tff(addAssignment_85244,axiom,
    ! [VarCurr: state_type] :
      ( v150803(VarCurr,0)
    <=> v150819(VarCurr) ) ).

tff(addAssignment_85243,axiom,
    ! [VarCurr: state_type] :
      ( v150803(VarCurr,1)
    <=> v150817(VarCurr) ) ).

tff(addAssignment_85242,axiom,
    ! [VarCurr: state_type] :
      ( v150803(VarCurr,2)
    <=> v150812(VarCurr) ) ).

tff(addAssignment_85241,axiom,
    ! [VarCurr: state_type] :
      ( v150803(VarCurr,3)
    <=> v150805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20027,axiom,
    ! [VarCurr: state_type] :
      ( v150817(VarCurr)
    <=> ( v150818(VarCurr)
        & v150821(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6984,axiom,
    ! [VarCurr: state_type] :
      ( v150821(VarCurr)
    <=> ( v136(VarCurr,0)
        | v136(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20026,axiom,
    ! [VarCurr: state_type] :
      ( v150818(VarCurr)
    <=> ( v150819(VarCurr)
        | v150820(VarCurr) ) ) ).

tff(writeUnaryOperator_11400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150820(VarCurr)
    <=> v136(VarCurr,1) ) ).

tff(writeUnaryOperator_11399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150819(VarCurr)
    <=> v136(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20025,axiom,
    ! [VarCurr: state_type] :
      ( v150812(VarCurr)
    <=> ( v150813(VarCurr)
        & v150816(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6983,axiom,
    ! [VarCurr: state_type] :
      ( v150816(VarCurr)
    <=> ( v150809(VarCurr)
        | v136(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20024,axiom,
    ! [VarCurr: state_type] :
      ( v150813(VarCurr)
    <=> ( v150814(VarCurr)
        | v150815(VarCurr) ) ) ).

tff(writeUnaryOperator_11398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150815(VarCurr)
    <=> v136(VarCurr,2) ) ).

tff(writeUnaryOperator_11397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150814(VarCurr)
    <=> v150809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20023,axiom,
    ! [VarCurr: state_type] :
      ( v150805(VarCurr)
    <=> ( v150806(VarCurr)
        & v150811(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6982,axiom,
    ! [VarCurr: state_type] :
      ( v150811(VarCurr)
    <=> ( v150808(VarCurr)
        | v136(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20022,axiom,
    ! [VarCurr: state_type] :
      ( v150806(VarCurr)
    <=> ( v150807(VarCurr)
        | v150810(VarCurr) ) ) ).

tff(writeUnaryOperator_11396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150810(VarCurr)
    <=> v136(VarCurr,3) ) ).

tff(writeUnaryOperator_11395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150807(VarCurr)
    <=> v150808(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6981,axiom,
    ! [VarCurr: state_type] :
      ( v150808(VarCurr)
    <=> ( v150809(VarCurr)
        & v136(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6980,axiom,
    ! [VarCurr: state_type] :
      ( v150809(VarCurr)
    <=> ( v136(VarCurr,0)
        & v136(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20021,axiom,
    ! [VarCurr: state_type] :
      ( v150800(VarCurr)
    <=> ( v170(VarCurr)
        & v150801(VarCurr) ) ) ).

tff(writeUnaryOperator_11394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150801(VarCurr)
    <=> v150802(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6979,axiom,
    ! [VarCurr: state_type] :
      ( v150802(VarCurr)
    <=> ( v109144(VarCurr)
        | v89383(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20020,axiom,
    ! [VarCurr: state_type] :
      ( v170(VarCurr)
    <=> ( v172(VarCurr)
        & v150798(VarCurr) ) ) ).

tff(writeUnaryOperator_11393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150798(VarCurr)
    <=> v741(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6978,axiom,
    ! [VarCurr: state_type] :
      ( v741(VarCurr)
    <=> ( v130432(VarCurr)
        & v743(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6977,axiom,
    ! [VarCurr: state_type] :
      ( v130432(VarCurr)
    <=> ( v130425(VarCurr)
        & v743(VarCurr,6) ) ) ).

tff(addAssignment_85240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v743(VarCurr,B)
      <=> v745(VarCurr,B) ) ) ).

tff(addAssignment_85239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v745(VarCurr,B)
      <=> v747(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150779(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v747(VarNext,B)
            <=> v747(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2263,axiom,
    ! [VarNext: state_type] :
      ( v150779(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v747(VarNext,B)
          <=> v150789(VarNext,B) ) ) ) ).

tff(addAssignment_85238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v150789(VarNext,B)
          <=> v150787(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150790(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v150787(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1661,axiom,
    ! [VarCurr: state_type] :
      ( v150790(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v150787(VarCurr,B)
          <=> v757(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20019,axiom,
    ! [VarCurr: state_type] :
      ( v150790(VarCurr)
    <=> ( v150791(VarCurr)
        & v150792(VarCurr) ) ) ).

tff(writeUnaryOperator_11392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150792(VarCurr)
    <=> v753(VarCurr) ) ).

tff(writeUnaryOperator_11391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150791(VarCurr)
    <=> v749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150779(VarNext)
      <=> v150780(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150780(VarNext)
      <=> ( v150781(VarNext)
          & v150774(VarNext) ) ) ) ).

tff(writeUnaryOperator_11390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150781(VarNext)
      <=> v150783(VarNext) ) ) ).

tff(addAssignment_85237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150783(VarNext)
      <=> v150774(VarCurr) ) ) ).

tff(addAssignment_85236,axiom,
    ! [VarCurr: state_type] :
      ( v150774(VarCurr)
    <=> v150776(VarCurr) ) ).

tff(addAssignment_85235,axiom,
    ! [VarCurr: state_type] :
      ( v150776(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_85234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v757(VarCurr,B)
      <=> v759(VarCurr,B) ) ) ).

tff(addAssignment_85233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v759(VarCurr,B)
      <=> v761(VarCurr,B) ) ) ).

tff(addAssignment_85232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v761(VarCurr,B)
      <=> v763(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130427(VarCurr)
     => ( v763(VarCurr,7)
      <=> v150772(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_184,axiom,
    ! [VarCurr: state_type] :
      ( v130427(VarCurr)
     => ( v763(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,7)
     => ( v150772(VarCurr)
      <=> v743(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1660,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,7)
     => ( v150772(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130420(VarCurr)
     => ( v763(VarCurr,6)
      <=> v150770(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_183,axiom,
    ! [VarCurr: state_type] :
      ( v130420(VarCurr)
     => ( v763(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,6)
     => ( v150770(VarCurr)
      <=> v743(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1659,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,6)
     => ( v150770(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130413(VarCurr)
     => ( v763(VarCurr,5)
      <=> v150768(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_182,axiom,
    ! [VarCurr: state_type] :
      ( v130413(VarCurr)
     => ( v763(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,5)
     => ( v150768(VarCurr)
      <=> v743(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1658,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,5)
     => ( v150768(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130404(VarCurr)
     => ( v763(VarCurr,4)
      <=> v150766(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_181,axiom,
    ! [VarCurr: state_type] :
      ( v130404(VarCurr)
     => ( v763(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,4)
     => ( v150766(VarCurr)
      <=> v743(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1657,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,4)
     => ( v150766(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130440(VarCurr)
     => ( v763(VarCurr,3)
      <=> v150764(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_180,axiom,
    ! [VarCurr: state_type] :
      ( v130440(VarCurr)
     => ( v763(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,3)
     => ( v150764(VarCurr)
      <=> v743(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1656,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,3)
     => ( v150764(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130434(VarCurr)
     => ( v763(VarCurr,2)
      <=> v150762(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_179,axiom,
    ! [VarCurr: state_type] :
      ( v130434(VarCurr)
     => ( v763(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,2)
     => ( v150762(VarCurr)
      <=> v743(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1655,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,2)
     => ( v150762(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130446(VarCurr)
     => ( v763(VarCurr,1)
      <=> v150760(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_178,axiom,
    ! [VarCurr: state_type] :
      ( v130446(VarCurr)
     => ( v763(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,1)
     => ( v150760(VarCurr)
      <=> v743(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1654,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,1)
     => ( v150760(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v765(VarCurr)
     => ( v763(VarCurr,0)
      <=> v150758(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1653,axiom,
    ! [VarCurr: state_type] :
      ( v765(VarCurr)
     => ( v763(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v769(VarCurr,0)
     => ( v150758(VarCurr)
      <=> v743(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1652,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,0)
     => ( v150758(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_85231,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,7)
    <=> v150707(VarCurr,7) ) ).

tff(addAssignment_85230,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,7)
    <=> v150700(VarCurr,7) ) ).

tff(addAssignment_85229,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,7)
    <=> v150702(VarCurr,7) ) ).

tff(addAssignment_85228,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,7)
    <=> v150704(VarCurr,7) ) ).

tff(addAssignment_85227,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,7)
    <=> v150706(VarCurr,7) ) ).

tff(addAssignment_85226,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,7)
    <=> v141172(VarCurr,7) ) ).

tff(addAssignment_85225,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,7)
    <=> v141174(VarCurr,7) ) ).

tff(addAssignment_85224,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,7)
    <=> v773(VarCurr,7) ) ).

tff(addAssignment_85223,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,7)
    <=> v775(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_6976,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,7)
    <=> ( v150751(VarCurr)
        & v150756(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2327,axiom,
    ! [VarCurr: state_type] :
      ( v150756(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20016,axiom,
    ! [VarCurr: state_type] :
      ( v150751(VarCurr)
    <=> ( v150752(VarCurr)
        & v150755(VarCurr) ) ) ).

tff(writeUnaryOperator_11389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150755(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20015,axiom,
    ! [VarCurr: state_type] :
      ( v150752(VarCurr)
    <=> ( v150753(VarCurr)
        & v150754(VarCurr) ) ) ).

tff(writeUnaryOperator_11388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150754(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20014,axiom,
    ! [VarCurr: state_type] :
      ( v150753(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85222,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,6)
    <=> v150707(VarCurr,6) ) ).

tff(addAssignment_85221,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,6)
    <=> v150700(VarCurr,6) ) ).

tff(addAssignment_85220,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,6)
    <=> v150702(VarCurr,6) ) ).

tff(addAssignment_85219,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,6)
    <=> v150704(VarCurr,6) ) ).

tff(addAssignment_85218,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,6)
    <=> v150706(VarCurr,6) ) ).

tff(addAssignment_85217,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,6)
    <=> v141172(VarCurr,6) ) ).

tff(addAssignment_85216,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,6)
    <=> v141174(VarCurr,6) ) ).

tff(addAssignment_85215,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,6)
    <=> v773(VarCurr,6) ) ).

tff(addAssignment_85214,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,6)
    <=> v775(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_6975,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,6)
    <=> ( v150744(VarCurr)
        & v150749(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2326,axiom,
    ! [VarCurr: state_type] :
      ( v150749(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20013,axiom,
    ! [VarCurr: state_type] :
      ( v150744(VarCurr)
    <=> ( v150745(VarCurr)
        & v150748(VarCurr) ) ) ).

tff(writeUnaryOperator_11387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150748(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20012,axiom,
    ! [VarCurr: state_type] :
      ( v150745(VarCurr)
    <=> ( v150746(VarCurr)
        & v150747(VarCurr) ) ) ).

tff(writeUnaryOperator_11386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150747(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20011,axiom,
    ! [VarCurr: state_type] :
      ( v150746(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85213,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,5)
    <=> v150707(VarCurr,5) ) ).

tff(addAssignment_85212,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,5)
    <=> v150700(VarCurr,5) ) ).

tff(addAssignment_85211,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,5)
    <=> v150702(VarCurr,5) ) ).

tff(addAssignment_85210,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,5)
    <=> v150704(VarCurr,5) ) ).

tff(addAssignment_85209,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,5)
    <=> v150706(VarCurr,5) ) ).

tff(addAssignment_85208,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,5)
    <=> v141172(VarCurr,5) ) ).

tff(addAssignment_85207,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,5)
    <=> v141174(VarCurr,5) ) ).

tff(addAssignment_85206,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,5)
    <=> v773(VarCurr,5) ) ).

tff(addAssignment_85205,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,5)
    <=> v775(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6974,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,5)
    <=> ( v150737(VarCurr)
        & v150742(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2325,axiom,
    ! [VarCurr: state_type] :
      ( v150742(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20010,axiom,
    ! [VarCurr: state_type] :
      ( v150737(VarCurr)
    <=> ( v150738(VarCurr)
        & v150741(VarCurr) ) ) ).

tff(writeUnaryOperator_11385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150741(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20009,axiom,
    ! [VarCurr: state_type] :
      ( v150738(VarCurr)
    <=> ( v150739(VarCurr)
        & v150740(VarCurr) ) ) ).

tff(writeUnaryOperator_11384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150740(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20008,axiom,
    ! [VarCurr: state_type] :
      ( v150739(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85204,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,4)
    <=> v150707(VarCurr,4) ) ).

tff(addAssignment_85203,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,4)
    <=> v150700(VarCurr,4) ) ).

tff(addAssignment_85202,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,4)
    <=> v150702(VarCurr,4) ) ).

tff(addAssignment_85201,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,4)
    <=> v150704(VarCurr,4) ) ).

tff(addAssignment_85200,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,4)
    <=> v150706(VarCurr,4) ) ).

tff(addAssignment_85199,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,4)
    <=> v141172(VarCurr,4) ) ).

tff(addAssignment_85198,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,4)
    <=> v141174(VarCurr,4) ) ).

tff(addAssignment_85197,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,4)
    <=> v773(VarCurr,4) ) ).

tff(addAssignment_85196,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,4)
    <=> v775(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6973,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,4)
    <=> ( v150730(VarCurr)
        & v150735(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2324,axiom,
    ! [VarCurr: state_type] :
      ( v150735(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20007,axiom,
    ! [VarCurr: state_type] :
      ( v150730(VarCurr)
    <=> ( v150731(VarCurr)
        & v150734(VarCurr) ) ) ).

tff(writeUnaryOperator_11383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150734(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20006,axiom,
    ! [VarCurr: state_type] :
      ( v150731(VarCurr)
    <=> ( v150732(VarCurr)
        & v150733(VarCurr) ) ) ).

tff(writeUnaryOperator_11382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150733(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20005,axiom,
    ! [VarCurr: state_type] :
      ( v150732(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85195,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,3)
    <=> v150707(VarCurr,3) ) ).

tff(addAssignment_85194,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,3)
    <=> v150700(VarCurr,3) ) ).

tff(addAssignment_85193,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,3)
    <=> v150702(VarCurr,3) ) ).

tff(addAssignment_85192,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,3)
    <=> v150704(VarCurr,3) ) ).

tff(addAssignment_85191,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,3)
    <=> v150706(VarCurr,3) ) ).

tff(addAssignment_85190,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,3)
    <=> v141172(VarCurr,3) ) ).

tff(addAssignment_85189,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,3)
    <=> v141174(VarCurr,3) ) ).

tff(addAssignment_85188,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,3)
    <=> v773(VarCurr,3) ) ).

tff(addAssignment_85187,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,3)
    <=> v775(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6972,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,3)
    <=> ( v150723(VarCurr)
        & v150728(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2323,axiom,
    ! [VarCurr: state_type] :
      ( v150728(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20004,axiom,
    ! [VarCurr: state_type] :
      ( v150723(VarCurr)
    <=> ( v150724(VarCurr)
        & v150727(VarCurr) ) ) ).

tff(writeUnaryOperator_11381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150727(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20003,axiom,
    ! [VarCurr: state_type] :
      ( v150724(VarCurr)
    <=> ( v150725(VarCurr)
        & v150726(VarCurr) ) ) ).

tff(writeUnaryOperator_11380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150726(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20002,axiom,
    ! [VarCurr: state_type] :
      ( v150725(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85186,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,2)
    <=> v150707(VarCurr,2) ) ).

tff(addAssignment_85185,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,2)
    <=> v150700(VarCurr,2) ) ).

tff(addAssignment_85184,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,2)
    <=> v150702(VarCurr,2) ) ).

tff(addAssignment_85183,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,2)
    <=> v150704(VarCurr,2) ) ).

tff(addAssignment_85182,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,2)
    <=> v150706(VarCurr,2) ) ).

tff(addAssignment_85181,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,2)
    <=> v141172(VarCurr,2) ) ).

tff(addAssignment_85180,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,2)
    <=> v141174(VarCurr,2) ) ).

tff(addAssignment_85179,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,2)
    <=> v773(VarCurr,2) ) ).

tff(addAssignment_85178,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,2)
    <=> v775(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6971,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,2)
    <=> ( v150716(VarCurr)
        & v150721(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2322,axiom,
    ! [VarCurr: state_type] :
      ( v150721(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20001,axiom,
    ! [VarCurr: state_type] :
      ( v150716(VarCurr)
    <=> ( v150717(VarCurr)
        & v150720(VarCurr) ) ) ).

tff(writeUnaryOperator_11379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150720(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20000,axiom,
    ! [VarCurr: state_type] :
      ( v150717(VarCurr)
    <=> ( v150718(VarCurr)
        & v150719(VarCurr) ) ) ).

tff(writeUnaryOperator_11378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150719(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19999,axiom,
    ! [VarCurr: state_type] :
      ( v150718(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85177,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,1)
    <=> v150707(VarCurr,1) ) ).

tff(addAssignment_85176,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,1)
    <=> v150700(VarCurr,1) ) ).

tff(addAssignment_85175,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,1)
    <=> v150702(VarCurr,1) ) ).

tff(addAssignment_85174,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,1)
    <=> v150704(VarCurr,1) ) ).

tff(addAssignment_85173,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,1)
    <=> v150706(VarCurr,1) ) ).

tff(addAssignment_85172,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,1)
    <=> v141172(VarCurr,1) ) ).

tff(addAssignment_85171,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,1)
    <=> v141174(VarCurr,1) ) ).

tff(addAssignment_85170,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,1)
    <=> v773(VarCurr,1) ) ).

tff(addAssignment_85169,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,1)
    <=> v775(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6970,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,1)
    <=> ( v150709(VarCurr)
        & v150714(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2321,axiom,
    ! [VarCurr: state_type] :
      ( v150714(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19998,axiom,
    ! [VarCurr: state_type] :
      ( v150709(VarCurr)
    <=> ( v150710(VarCurr)
        & v150713(VarCurr) ) ) ).

tff(writeUnaryOperator_11377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150713(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19997,axiom,
    ! [VarCurr: state_type] :
      ( v150710(VarCurr)
    <=> ( v150711(VarCurr)
        & v150712(VarCurr) ) ) ).

tff(writeUnaryOperator_11376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150712(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19996,axiom,
    ! [VarCurr: state_type] :
      ( v150711(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(addAssignment_85168,axiom,
    ! [VarCurr: state_type] :
      ( v769(VarCurr,0)
    <=> v150707(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v150707(VarCurr,B)
      <=> ( v771(VarCurr,B)
          | v150698(VarCurr,B) ) ) ) ).

tff(addAssignment_85167,axiom,
    ! [VarCurr: state_type] :
      ( v150698(VarCurr,0)
    <=> v150700(VarCurr,0) ) ).

tff(addAssignment_85166,axiom,
    ! [VarCurr: state_type] :
      ( v150700(VarCurr,0)
    <=> v150702(VarCurr,0) ) ).

tff(addAssignment_85165,axiom,
    ! [VarCurr: state_type] :
      ( v150702(VarCurr,0)
    <=> v150704(VarCurr,0) ) ).

tff(addAssignment_85164,axiom,
    ! [VarCurr: state_type] :
      ( v150704(VarCurr,0)
    <=> v150706(VarCurr,0) ) ).

tff(addAssignment_85163,axiom,
    ! [VarCurr: state_type] :
      ( v150706(VarCurr,0)
    <=> v141172(VarCurr,0) ) ).

tff(addAssignment_85162,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,0)
    <=> v141174(VarCurr,0) ) ).

tff(addAssignment_85161,axiom,
    ! [VarCurr: state_type] :
      ( v771(VarCurr,0)
    <=> v773(VarCurr,0) ) ).

tff(addAssignment_85160,axiom,
    ! [VarCurr: state_type] :
      ( v773(VarCurr,0)
    <=> v775(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19995,axiom,
    ! [VarCurr: state_type] :
      ( v775(VarCurr,0)
    <=> ( v150691(VarCurr)
        & v150696(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2320,axiom,
    ! [VarCurr: state_type] :
      ( v150696(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19994,axiom,
    ! [VarCurr: state_type] :
      ( v150691(VarCurr)
    <=> ( v150692(VarCurr)
        & v150695(VarCurr) ) ) ).

tff(writeUnaryOperator_11375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150695(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19993,axiom,
    ! [VarCurr: state_type] :
      ( v150692(VarCurr)
    <=> ( v150693(VarCurr)
        & v150694(VarCurr) ) ) ).

tff(writeUnaryOperator_11374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150694(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19992,axiom,
    ! [VarCurr: state_type] :
      ( v150693(VarCurr)
    <=> ( v777(VarCurr)
        & v5218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19991,axiom,
    ! [VarCurr: state_type] :
      ( v777(VarCurr)
    <=> ( v150679(VarCurr)
        | v150687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19990,axiom,
    ! [VarCurr: state_type] :
      ( v150687(VarCurr)
    <=> ( v150688(VarCurr)
        & v150689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19989,axiom,
    ! [VarCurr: state_type] :
      ( v150689(VarCurr)
    <=> ( v140253(VarCurr)
        | v82958(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6969,axiom,
    ! [VarCurr: state_type] :
      ( v150688(VarCurr)
    <=> ( v8(VarCurr,4)
        & v779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19988,axiom,
    ! [VarCurr: state_type] :
      ( v150679(VarCurr)
    <=> ( v150680(VarCurr)
        | v150684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19987,axiom,
    ! [VarCurr: state_type] :
      ( v150684(VarCurr)
    <=> ( v150685(VarCurr)
        & v83211(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6968,axiom,
    ! [VarCurr: state_type] :
      ( v150685(VarCurr)
    <=> ( v8(VarCurr,2)
        & v150686(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6967,axiom,
    ! [VarCurr: state_type] :
      ( v150686(VarCurr)
    <=> ( v84121(VarCurr,0)
        | v84121(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19986,axiom,
    ! [VarCurr: state_type] :
      ( v150680(VarCurr)
    <=> ( v150681(VarCurr)
        | v150683(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6966,axiom,
    ! [VarCurr: state_type] :
      ( v150683(VarCurr)
    <=> ( v8(VarCurr,3)
        & v82954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19985,axiom,
    ! [VarCurr: state_type] :
      ( v150681(VarCurr)
    <=> ( v150682(VarCurr)
        & v140253(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6965,axiom,
    ! [VarCurr: state_type] :
      ( v150682(VarCurr)
    <=> ( v8(VarCurr,1)
        & v779(VarCurr) ) ) ).

tff(addAssignment_85159,axiom,
    ! [VarCurr: state_type] :
      ( v779(VarCurr)
    <=> v781(VarCurr,14) ) ).

tff(addAssignment_85158,axiom,
    ! [VarCurr: state_type] :
      ( v781(VarCurr,14)
    <=> v783(VarCurr,14) ) ).

tff(addAssignment_85157,axiom,
    ! [VarCurr: state_type] :
      ( v783(VarCurr,14)
    <=> v5329(VarCurr,14) ) ).

tff(addAssignment_85156,axiom,
    ! [VarCurr: state_type] :
      ( v5324(VarCurr,14)
    <=> v5326(VarCurr,14) ) ).

tff(addAssignment_85155,axiom,
    ! [VarCurr: state_type] :
      ( v5326(VarCurr,14)
    <=> v5328(VarCurr,14) ) ).

tff(addAssignment_85154,axiom,
    ! [VarNext: state_type] :
      ( v5328(VarNext,14)
    <=> v150671(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150672(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150671(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2262,axiom,
    ! [VarNext: state_type] :
      ( v150672(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150671(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150672(VarNext)
      <=> v150673(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150673(VarNext)
      <=> ( v150675(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_11373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150675(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_85153,axiom,
    ! [VarCurr: state_type] :
      ( v103020(VarCurr,14)
    <=> v103022(VarCurr,14) ) ).

tff(addAssignment_85152,axiom,
    ! [VarCurr: state_type] :
      ( v103022(VarCurr,14)
    <=> v103031(VarCurr,14) ) ).

tff(addAssignment_85151,axiom,
    ! [VarCurr: state_type] :
      ( v103024(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85150,axiom,
    ! [VarCurr: state_type] :
      ( v5318(VarCurr,14)
    <=> v5320(VarCurr,14) ) ).

tff(addAssignment_85149,axiom,
    ! [VarCurr: state_type] :
      ( v5320(VarCurr,14)
    <=> v5322(VarCurr,14) ) ).

tff(addAssignment_85148,axiom,
    ! [VarNext: state_type] :
      ( v5322(VarNext,14)
    <=> v150663(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150664(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150663(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2261,axiom,
    ! [VarNext: state_type] :
      ( v150664(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150663(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150664(VarNext)
      <=> v150665(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150665(VarNext)
      <=> ( v150667(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_11372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150667(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_85147,axiom,
    ! [VarCurr: state_type] :
      ( v102970(VarCurr,14)
    <=> v102972(VarCurr,14) ) ).

tff(addAssignment_85146,axiom,
    ! [VarCurr: state_type] :
      ( v102972(VarCurr,14)
    <=> v102981(VarCurr,14) ) ).

tff(addAssignment_85145,axiom,
    ! [VarCurr: state_type] :
      ( v102974(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85144,axiom,
    ! [VarCurr: state_type] :
      ( v5311(VarCurr,14)
    <=> v5313(VarCurr,14) ) ).

tff(addAssignment_85143,axiom,
    ! [VarCurr: state_type] :
      ( v5313(VarCurr,14)
    <=> v5315(VarCurr,14) ) ).

tff(addAssignment_85142,axiom,
    ! [VarNext: state_type] :
      ( v5315(VarNext,14)
    <=> v150655(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150656(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150655(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2260,axiom,
    ! [VarNext: state_type] :
      ( v150656(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150655(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150656(VarNext)
      <=> v150657(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150657(VarNext)
      <=> ( v150659(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_11371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150659(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_85141,axiom,
    ! [VarCurr: state_type] :
      ( v102920(VarCurr,14)
    <=> v102922(VarCurr,14) ) ).

tff(addAssignment_85140,axiom,
    ! [VarCurr: state_type] :
      ( v102922(VarCurr,14)
    <=> v102931(VarCurr,14) ) ).

tff(addAssignment_85139,axiom,
    ! [VarCurr: state_type] :
      ( v102924(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85138,axiom,
    ! [VarCurr: state_type] :
      ( v5304(VarCurr,14)
    <=> v5306(VarCurr,14) ) ).

tff(addAssignment_85137,axiom,
    ! [VarCurr: state_type] :
      ( v5306(VarCurr,14)
    <=> v5308(VarCurr,14) ) ).

tff(addAssignment_85136,axiom,
    ! [VarNext: state_type] :
      ( v5308(VarNext,14)
    <=> v150647(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150648(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150647(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2259,axiom,
    ! [VarNext: state_type] :
      ( v150648(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150647(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150648(VarNext)
      <=> v150649(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150649(VarNext)
      <=> ( v150651(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_11370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150651(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_85135,axiom,
    ! [VarCurr: state_type] :
      ( v102870(VarCurr,14)
    <=> v102872(VarCurr,14) ) ).

tff(addAssignment_85134,axiom,
    ! [VarCurr: state_type] :
      ( v102872(VarCurr,14)
    <=> v102881(VarCurr,14) ) ).

tff(addAssignment_85133,axiom,
    ! [VarCurr: state_type] :
      ( v102874(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85132,axiom,
    ! [VarCurr: state_type] :
      ( v5297(VarCurr,14)
    <=> v5299(VarCurr,14) ) ).

tff(addAssignment_85131,axiom,
    ! [VarCurr: state_type] :
      ( v5299(VarCurr,14)
    <=> v5301(VarCurr,14) ) ).

tff(addAssignment_85130,axiom,
    ! [VarNext: state_type] :
      ( v5301(VarNext,14)
    <=> v150639(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150640(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150639(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2258,axiom,
    ! [VarNext: state_type] :
      ( v150640(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150639(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150640(VarNext)
      <=> v150641(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150641(VarNext)
      <=> ( v150643(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_11369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150643(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_85129,axiom,
    ! [VarCurr: state_type] :
      ( v102820(VarCurr,14)
    <=> v102822(VarCurr,14) ) ).

tff(addAssignment_85128,axiom,
    ! [VarCurr: state_type] :
      ( v102822(VarCurr,14)
    <=> v102831(VarCurr,14) ) ).

tff(addAssignment_85127,axiom,
    ! [VarCurr: state_type] :
      ( v102824(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85126,axiom,
    ! [VarCurr: state_type] :
      ( v5290(VarCurr,14)
    <=> v5292(VarCurr,14) ) ).

tff(addAssignment_85125,axiom,
    ! [VarCurr: state_type] :
      ( v5292(VarCurr,14)
    <=> v5294(VarCurr,14) ) ).

tff(addAssignment_85124,axiom,
    ! [VarNext: state_type] :
      ( v5294(VarNext,14)
    <=> v150631(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150632(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150631(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2257,axiom,
    ! [VarNext: state_type] :
      ( v150632(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150631(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150632(VarNext)
      <=> v150633(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150633(VarNext)
      <=> ( v150635(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_11368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150635(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_85123,axiom,
    ! [VarCurr: state_type] :
      ( v102770(VarCurr,14)
    <=> v102772(VarCurr,14) ) ).

tff(addAssignment_85122,axiom,
    ! [VarCurr: state_type] :
      ( v102772(VarCurr,14)
    <=> v102781(VarCurr,14) ) ).

tff(addAssignment_85121,axiom,
    ! [VarCurr: state_type] :
      ( v102774(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85120,axiom,
    ! [VarCurr: state_type] :
      ( v5283(VarCurr,14)
    <=> v5285(VarCurr,14) ) ).

tff(addAssignment_85119,axiom,
    ! [VarCurr: state_type] :
      ( v5285(VarCurr,14)
    <=> v5287(VarCurr,14) ) ).

tff(addAssignment_85118,axiom,
    ! [VarNext: state_type] :
      ( v5287(VarNext,14)
    <=> v150623(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150624(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150623(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2256,axiom,
    ! [VarNext: state_type] :
      ( v150624(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150623(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150624(VarNext)
      <=> v150625(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150625(VarNext)
      <=> ( v150627(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_11367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150627(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_85117,axiom,
    ! [VarCurr: state_type] :
      ( v102720(VarCurr,14)
    <=> v102722(VarCurr,14) ) ).

tff(addAssignment_85116,axiom,
    ! [VarCurr: state_type] :
      ( v102722(VarCurr,14)
    <=> v102731(VarCurr,14) ) ).

tff(addAssignment_85115,axiom,
    ! [VarCurr: state_type] :
      ( v102724(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85114,axiom,
    ! [VarCurr: state_type] :
      ( v5276(VarCurr,14)
    <=> v5278(VarCurr,14) ) ).

tff(addAssignment_85113,axiom,
    ! [VarCurr: state_type] :
      ( v5278(VarCurr,14)
    <=> v5280(VarCurr,14) ) ).

tff(addAssignment_85112,axiom,
    ! [VarNext: state_type] :
      ( v5280(VarNext,14)
    <=> v150615(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150616(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150615(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2255,axiom,
    ! [VarNext: state_type] :
      ( v150616(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150615(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150616(VarNext)
      <=> v150617(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150617(VarNext)
      <=> ( v150619(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_11366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150619(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_85111,axiom,
    ! [VarCurr: state_type] :
      ( v102670(VarCurr,14)
    <=> v102672(VarCurr,14) ) ).

tff(addAssignment_85110,axiom,
    ! [VarCurr: state_type] :
      ( v102672(VarCurr,14)
    <=> v102681(VarCurr,14) ) ).

tff(addAssignment_85109,axiom,
    ! [VarCurr: state_type] :
      ( v102674(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85108,axiom,
    ! [VarCurr: state_type] :
      ( v5269(VarCurr,14)
    <=> v5271(VarCurr,14) ) ).

tff(addAssignment_85107,axiom,
    ! [VarCurr: state_type] :
      ( v5271(VarCurr,14)
    <=> v5273(VarCurr,14) ) ).

tff(addAssignment_85106,axiom,
    ! [VarNext: state_type] :
      ( v5273(VarNext,14)
    <=> v150607(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150608(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150607(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2254,axiom,
    ! [VarNext: state_type] :
      ( v150608(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150607(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150608(VarNext)
      <=> v150609(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150609(VarNext)
      <=> ( v150611(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_11365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150611(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_85105,axiom,
    ! [VarCurr: state_type] :
      ( v102620(VarCurr,14)
    <=> v102622(VarCurr,14) ) ).

tff(addAssignment_85104,axiom,
    ! [VarCurr: state_type] :
      ( v102622(VarCurr,14)
    <=> v102631(VarCurr,14) ) ).

tff(addAssignment_85103,axiom,
    ! [VarCurr: state_type] :
      ( v102624(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85102,axiom,
    ! [VarCurr: state_type] :
      ( v5262(VarCurr,14)
    <=> v5264(VarCurr,14) ) ).

tff(addAssignment_85101,axiom,
    ! [VarCurr: state_type] :
      ( v5264(VarCurr,14)
    <=> v5266(VarCurr,14) ) ).

tff(addAssignment_85100,axiom,
    ! [VarNext: state_type] :
      ( v5266(VarNext,14)
    <=> v150599(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150600(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150599(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2253,axiom,
    ! [VarNext: state_type] :
      ( v150600(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150599(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150600(VarNext)
      <=> v150601(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150601(VarNext)
      <=> ( v150603(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_11364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150603(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_85099,axiom,
    ! [VarCurr: state_type] :
      ( v102570(VarCurr,14)
    <=> v102572(VarCurr,14) ) ).

tff(addAssignment_85098,axiom,
    ! [VarCurr: state_type] :
      ( v102572(VarCurr,14)
    <=> v102581(VarCurr,14) ) ).

tff(addAssignment_85097,axiom,
    ! [VarCurr: state_type] :
      ( v102574(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85096,axiom,
    ! [VarCurr: state_type] :
      ( v5255(VarCurr,14)
    <=> v5257(VarCurr,14) ) ).

tff(addAssignment_85095,axiom,
    ! [VarCurr: state_type] :
      ( v5257(VarCurr,14)
    <=> v5259(VarCurr,14) ) ).

tff(addAssignment_85094,axiom,
    ! [VarNext: state_type] :
      ( v5259(VarNext,14)
    <=> v150591(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150592(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150591(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2252,axiom,
    ! [VarNext: state_type] :
      ( v150592(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150591(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150592(VarNext)
      <=> v150593(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150593(VarNext)
      <=> ( v150595(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_11363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150595(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_85093,axiom,
    ! [VarCurr: state_type] :
      ( v102520(VarCurr,14)
    <=> v102522(VarCurr,14) ) ).

tff(addAssignment_85092,axiom,
    ! [VarCurr: state_type] :
      ( v102522(VarCurr,14)
    <=> v102531(VarCurr,14) ) ).

tff(addAssignment_85091,axiom,
    ! [VarCurr: state_type] :
      ( v102524(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85090,axiom,
    ! [VarCurr: state_type] :
      ( v5248(VarCurr,14)
    <=> v5250(VarCurr,14) ) ).

tff(addAssignment_85089,axiom,
    ! [VarCurr: state_type] :
      ( v5250(VarCurr,14)
    <=> v5252(VarCurr,14) ) ).

tff(addAssignment_85088,axiom,
    ! [VarNext: state_type] :
      ( v5252(VarNext,14)
    <=> v150583(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150584(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150583(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2251,axiom,
    ! [VarNext: state_type] :
      ( v150584(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150583(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150584(VarNext)
      <=> v150585(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150585(VarNext)
      <=> ( v150587(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_11362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150587(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_85087,axiom,
    ! [VarCurr: state_type] :
      ( v102470(VarCurr,14)
    <=> v102472(VarCurr,14) ) ).

tff(addAssignment_85086,axiom,
    ! [VarCurr: state_type] :
      ( v102472(VarCurr,14)
    <=> v102481(VarCurr,14) ) ).

tff(addAssignment_85085,axiom,
    ! [VarCurr: state_type] :
      ( v102474(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85084,axiom,
    ! [VarCurr: state_type] :
      ( v5241(VarCurr,14)
    <=> v5243(VarCurr,14) ) ).

tff(addAssignment_85083,axiom,
    ! [VarCurr: state_type] :
      ( v5243(VarCurr,14)
    <=> v5245(VarCurr,14) ) ).

tff(addAssignment_85082,axiom,
    ! [VarNext: state_type] :
      ( v5245(VarNext,14)
    <=> v150575(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150576(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150575(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2250,axiom,
    ! [VarNext: state_type] :
      ( v150576(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150575(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150576(VarNext)
      <=> v150577(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150577(VarNext)
      <=> ( v150579(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_11361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150579(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_85081,axiom,
    ! [VarCurr: state_type] :
      ( v102420(VarCurr,14)
    <=> v102422(VarCurr,14) ) ).

tff(addAssignment_85080,axiom,
    ! [VarCurr: state_type] :
      ( v102422(VarCurr,14)
    <=> v102431(VarCurr,14) ) ).

tff(addAssignment_85079,axiom,
    ! [VarCurr: state_type] :
      ( v102424(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85078,axiom,
    ! [VarCurr: state_type] :
      ( v5234(VarCurr,14)
    <=> v5236(VarCurr,14) ) ).

tff(addAssignment_85077,axiom,
    ! [VarCurr: state_type] :
      ( v5236(VarCurr,14)
    <=> v5238(VarCurr,14) ) ).

tff(addAssignment_85076,axiom,
    ! [VarNext: state_type] :
      ( v5238(VarNext,14)
    <=> v150567(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150568(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150567(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2249,axiom,
    ! [VarNext: state_type] :
      ( v150568(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150567(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150568(VarNext)
      <=> v150569(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150569(VarNext)
      <=> ( v150571(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_11360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150571(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_85075,axiom,
    ! [VarCurr: state_type] :
      ( v102370(VarCurr,14)
    <=> v102372(VarCurr,14) ) ).

tff(addAssignment_85074,axiom,
    ! [VarCurr: state_type] :
      ( v102372(VarCurr,14)
    <=> v102381(VarCurr,14) ) ).

tff(addAssignment_85073,axiom,
    ! [VarCurr: state_type] :
      ( v102374(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85072,axiom,
    ! [VarCurr: state_type] :
      ( v5227(VarCurr,14)
    <=> v5229(VarCurr,14) ) ).

tff(addAssignment_85071,axiom,
    ! [VarCurr: state_type] :
      ( v5229(VarCurr,14)
    <=> v5231(VarCurr,14) ) ).

tff(addAssignment_85070,axiom,
    ! [VarNext: state_type] :
      ( v5231(VarNext,14)
    <=> v150559(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150560(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150559(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2248,axiom,
    ! [VarNext: state_type] :
      ( v150560(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150559(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150560(VarNext)
      <=> v150561(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150561(VarNext)
      <=> ( v150563(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_11359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150563(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_85069,axiom,
    ! [VarCurr: state_type] :
      ( v102320(VarCurr,14)
    <=> v102322(VarCurr,14) ) ).

tff(addAssignment_85068,axiom,
    ! [VarCurr: state_type] :
      ( v102322(VarCurr,14)
    <=> v102331(VarCurr,14) ) ).

tff(addAssignment_85067,axiom,
    ! [VarCurr: state_type] :
      ( v102324(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85066,axiom,
    ! [VarCurr: state_type] :
      ( v5220(VarCurr,14)
    <=> v5222(VarCurr,14) ) ).

tff(addAssignment_85065,axiom,
    ! [VarCurr: state_type] :
      ( v5222(VarCurr,14)
    <=> v5224(VarCurr,14) ) ).

tff(addAssignment_85064,axiom,
    ! [VarNext: state_type] :
      ( v5224(VarNext,14)
    <=> v150551(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150552(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150551(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2247,axiom,
    ! [VarNext: state_type] :
      ( v150552(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150551(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150552(VarNext)
      <=> v150553(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150553(VarNext)
      <=> ( v150555(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_11358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150555(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_85063,axiom,
    ! [VarCurr: state_type] :
      ( v102270(VarCurr,14)
    <=> v102272(VarCurr,14) ) ).

tff(addAssignment_85062,axiom,
    ! [VarCurr: state_type] :
      ( v102272(VarCurr,14)
    <=> v102281(VarCurr,14) ) ).

tff(addAssignment_85061,axiom,
    ! [VarCurr: state_type] :
      ( v102274(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85060,axiom,
    ! [VarCurr: state_type] :
      ( v884(VarCurr,14)
    <=> v886(VarCurr,14) ) ).

tff(addAssignment_85059,axiom,
    ! [VarCurr: state_type] :
      ( v886(VarCurr,14)
    <=> v888(VarCurr,14) ) ).

tff(addAssignment_85058,axiom,
    ! [VarNext: state_type] :
      ( v888(VarNext,14)
    <=> v150543(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150544(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v150543(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2246,axiom,
    ! [VarNext: state_type] :
      ( v150544(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v150543(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150544(VarNext)
      <=> v150545(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150545(VarNext)
      <=> ( v150547(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_11357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150547(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_85057,axiom,
    ! [VarCurr: state_type] :
      ( v898(VarCurr,14)
    <=> v900(VarCurr,14) ) ).

tff(addAssignment_85056,axiom,
    ! [VarCurr: state_type] :
      ( v900(VarCurr,14)
    <=> v102231(VarCurr,14) ) ).

tff(addAssignment_85055,axiom,
    ! [VarCurr: state_type] :
      ( v902(VarCurr,14)
    <=> v904(VarCurr,14) ) ).

tff(addAssignment_85054,axiom,
    ! [VarCurr: state_type] :
      ( v904(VarCurr,14)
    <=> v906(VarCurr,14) ) ).

tff(addAssignment_85053,axiom,
    ! [VarCurr: state_type] :
      ( v906(VarCurr,14)
    <=> v908(VarCurr,14) ) ).

tff(addAssignment_85052,axiom,
    ! [VarCurr: state_type] :
      ( v908(VarCurr,14)
    <=> v910(VarCurr,14) ) ).

tff(addAssignment_85051,axiom,
    ! [VarCurr: state_type] :
      ( v910(VarCurr,14)
    <=> v912(VarCurr,13) ) ).

tff(addAssignment_85050,axiom,
    ! [VarCurr: state_type] :
      ( v912(VarCurr,13)
    <=> v914(VarCurr,13) ) ).

tff(addAssignment_85049,axiom,
    ! [VarNext: state_type] :
      ( v914(VarNext,13)
    <=> v150535(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_2245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150536(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v150535(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2245,axiom,
    ! [VarNext: state_type] :
      ( v150536(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v150535(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150536(VarNext)
      <=> v150537(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150537(VarNext)
      <=> ( v150539(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_11356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150539(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_85048,axiom,
    ! [VarCurr: state_type] :
      ( v932(VarCurr,13)
    <=> v934(VarCurr,13) ) ).

tff(addAssignment_85047,axiom,
    ! [VarCurr: state_type] :
      ( v934(VarCurr,13)
    <=> v5598(VarCurr,13) ) ).

tff(addAssignment_85046,axiom,
    ! [VarCurr: state_type] :
      ( v936(VarCurr,13)
    <=> v938(VarCurr,13) ) ).

tff(addAssignment_85045,axiom,
    ! [VarCurr: state_type] :
      ( v938(VarCurr,13)
    <=> v5589(VarCurr,13) ) ).

tff(addAssignment_85044,axiom,
    ! [VarCurr: state_type] :
      ( v940(VarCurr)
    <=> v942(VarCurr,2) ) ).

tff(addAssignment_85043,axiom,
    ! [VarCurr: state_type] :
      ( v942(VarCurr,2)
    <=> v944(VarCurr,2) ) ).

tff(addAssignment_85042,axiom,
    ! [VarNext: state_type] :
      ( v944(VarNext,2)
    <=> v150527(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150528(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v150527(VarNext,B)
            <=> v944(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2244,axiom,
    ! [VarNext: state_type] :
      ( v150528(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v150527(VarNext,B)
          <=> v140553(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150528(VarNext)
      <=> v150529(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150529(VarNext)
      <=> ( v150531(VarNext)
          & v140538(VarNext) ) ) ) ).

tff(writeUnaryOperator_11355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150531(VarNext)
      <=> v140547(VarNext) ) ) ).

tff(addAssignment_85041,axiom,
    ! [VarCurr: state_type] :
      ( v954(VarCurr,2)
    <=> v956(VarCurr,2) ) ).

tff(addAssignment_85040,axiom,
    ! [VarCurr: state_type] :
      ( v956(VarCurr,2)
    <=> v958(VarCurr,2) ) ).

tff(addAssignment_85039,axiom,
    ! [VarCurr: state_type] :
      ( v958(VarCurr,2)
    <=> v140533(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19946,axiom,
    ! [VarCurr: state_type] :
      ( v960(VarCurr)
    <=> ( v150524(VarCurr)
        & v150525(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1047(VarCurr)
     => ( v150525(VarCurr)
      <=> v140535(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1651,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
     => ( v150525(VarCurr)
      <=> v150478(VarCurr) ) ) ).

tff(writeUnaryOperator_11354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150524(VarCurr)
    <=> v962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19945,axiom,
    ! [VarCurr: state_type] :
      ( v140535(VarCurr)
    <=> ( v150520(VarCurr)
        | v150506(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19944,axiom,
    ! [VarCurr: state_type] :
      ( v150520(VarCurr)
    <=> ( v150521(VarCurr)
        & v150522(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2319,axiom,
    ! [VarCurr: state_type] :
      ( v150522(VarCurr)
    <=> ( ( v59955(VarCurr,1)
        <=> $false )
        & ( v59955(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19943,axiom,
    ! [VarCurr: state_type] :
      ( v150521(VarCurr)
    <=> ( v150480(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(addAssignment_85038,axiom,
    ! [VarCurr: state_type] :
      ( v150506(VarCurr)
    <=> v942(VarCurr,5) ) ).

tff(addAssignment_85037,axiom,
    ! [VarCurr: state_type] :
      ( v942(VarCurr,5)
    <=> v944(VarCurr,5) ) ).

tff(addAssignment_85036,axiom,
    ! [VarNext: state_type] :
      ( v944(VarNext,5)
    <=> v150512(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_2243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150513(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v150512(VarNext,B)
            <=> v944(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2243,axiom,
    ! [VarNext: state_type] :
      ( v150513(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v150512(VarNext,B)
          <=> v140553(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150513(VarNext)
      <=> v150514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150514(VarNext)
      <=> ( v150516(VarNext)
          & v140538(VarNext) ) ) ) ).

tff(writeUnaryOperator_11353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150516(VarNext)
      <=> v140547(VarNext) ) ) ).

tff(addAssignment_85035,axiom,
    ! [VarCurr: state_type] :
      ( v954(VarCurr,5)
    <=> v956(VarCurr,5) ) ).

tff(addAssignment_85034,axiom,
    ! [VarCurr: state_type] :
      ( v956(VarCurr,5)
    <=> v958(VarCurr,5) ) ).

tff(addAssignment_85033,axiom,
    ! [VarCurr: state_type] :
      ( v958(VarCurr,5)
    <=> v140533(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19940,axiom,
    ! [VarCurr: state_type] :
      ( v140534(VarCurr)
    <=> ( v150509(VarCurr)
        & v150510(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2318,axiom,
    ! [VarCurr: state_type] :
      ( v150510(VarCurr)
    <=> ( ( v59955(VarCurr,1)
        <=> $false )
        & ( v59955(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19939,axiom,
    ! [VarCurr: state_type] :
      ( v150509(VarCurr)
    <=> ( v150480(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19938,axiom,
    ! [VarCurr: state_type] :
      ( v150478(VarCurr)
    <=> ( v150501(VarCurr)
        | v150484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19937,axiom,
    ! [VarCurr: state_type] :
      ( v150501(VarCurr)
    <=> ( v150502(VarCurr)
        & v150503(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2317,axiom,
    ! [VarCurr: state_type] :
      ( v150503(VarCurr)
    <=> ( ( v59955(VarCurr,1)
        <=> $true )
        & ( v59955(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19936,axiom,
    ! [VarCurr: state_type] :
      ( v150502(VarCurr)
    <=> ( v150480(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(addAssignment_85032,axiom,
    ! [VarCurr: state_type] :
      ( v150484(VarCurr)
    <=> v942(VarCurr,3) ) ).

tff(addAssignment_85031,axiom,
    ! [VarCurr: state_type] :
      ( v942(VarCurr,3)
    <=> v944(VarCurr,3) ) ).

tff(addAssignment_85030,axiom,
    ! [VarNext: state_type] :
      ( v944(VarNext,3)
    <=> v150493(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_2242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150494(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v150493(VarNext,B)
            <=> v944(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2242,axiom,
    ! [VarNext: state_type] :
      ( v150494(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v150493(VarNext,B)
          <=> v140553(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150494(VarNext)
      <=> v150495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150495(VarNext)
      <=> ( v150497(VarNext)
          & v140538(VarNext) ) ) ) ).

tff(writeUnaryOperator_11352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150497(VarNext)
      <=> v140547(VarNext) ) ) ).

tff(addAssignment_85029,axiom,
    ! [VarCurr: state_type] :
      ( v954(VarCurr,3)
    <=> v956(VarCurr,3) ) ).

tff(addAssignment_85028,axiom,
    ! [VarCurr: state_type] :
      ( v956(VarCurr,3)
    <=> v958(VarCurr,3) ) ).

tff(addAssignment_85027,axiom,
    ! [VarCurr: state_type] :
      ( v958(VarCurr,3)
    <=> v140533(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19933,axiom,
    ! [VarCurr: state_type] :
      ( v140536(VarCurr)
    <=> ( v150489(VarCurr)
        | v150487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19932,axiom,
    ! [VarCurr: state_type] :
      ( v150489(VarCurr)
    <=> ( v150490(VarCurr)
        & v150491(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2316,axiom,
    ! [VarCurr: state_type] :
      ( v150491(VarCurr)
    <=> ( ( v59955(VarCurr,1)
        <=> $true )
        & ( v59955(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19931,axiom,
    ! [VarCurr: state_type] :
      ( v150490(VarCurr)
    <=> ( v150480(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(addAssignment_85026,axiom,
    ! [VarCurr: state_type] :
      ( v150487(VarCurr)
    <=> v942(VarCurr,4) ) ).

tff(addAssignment_85025,axiom,
    ! [VarCurr: state_type] :
      ( v942(VarCurr,4)
    <=> v944(VarCurr,4) ) ).

tff(addAssignment_85024,axiom,
    ! [VarCurr: state_type] :
      ( v150480(VarCurr)
    <=> v150482(VarCurr) ) ).

tff(addAssignment_85023,axiom,
    ! [VarCurr: state_type] :
      ( v150482(VarCurr)
    <=> v90990(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6964,axiom,
    ! [VarCurr: state_type] :
      ( v962(VarCurr)
    <=> ( v964(VarCurr,10)
        & v150476(VarCurr) ) ) ).

tff(writeUnaryOperator_11351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150476(VarCurr)
    <=> v5773(VarCurr) ) ).

tff(addAssignment_85022,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,10)
    <=> v966(VarCurr,10) ) ).

tff(addAssignment_85021,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,10)
    <=> v5526(VarCurr,10) ) ).

tff(addAssignment_85020,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,10)
    <=> v5523(VarCurr,10) ) ).

tff(addAssignment_85019,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,10)
    <=> v5525(VarCurr,10) ) ).

tff(addAssignment_85018,axiom,
    ! [VarNext: state_type] :
      ( v5525(VarNext,10)
    <=> v150468(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150469(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150468(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2241,axiom,
    ! [VarNext: state_type] :
      ( v150469(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150468(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150469(VarNext)
      <=> v150470(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150470(VarNext)
      <=> ( v150472(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_11350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150472(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_85017,axiom,
    ! [VarCurr: state_type] :
      ( v83988(VarCurr,10)
    <=> v83990(VarCurr,10) ) ).

tff(addAssignment_85016,axiom,
    ! [VarCurr: state_type] :
      ( v83990(VarCurr,10)
    <=> v83999(VarCurr,10) ) ).

tff(addAssignment_85015,axiom,
    ! [VarCurr: state_type] :
      ( v83992(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_85014,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,10)
    <=> v5516(VarCurr,10) ) ).

tff(addAssignment_85013,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,10)
    <=> v5518(VarCurr,10) ) ).

tff(addAssignment_85012,axiom,
    ! [VarNext: state_type] :
      ( v5518(VarNext,10)
    <=> v150460(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150461(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150460(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2240,axiom,
    ! [VarNext: state_type] :
      ( v150461(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150460(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150461(VarNext)
      <=> v150462(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150462(VarNext)
      <=> ( v150464(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_11349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150464(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_85011,axiom,
    ! [VarCurr: state_type] :
      ( v83938(VarCurr,10)
    <=> v83940(VarCurr,10) ) ).

tff(addAssignment_85010,axiom,
    ! [VarCurr: state_type] :
      ( v83940(VarCurr,10)
    <=> v83949(VarCurr,10) ) ).

tff(addAssignment_85009,axiom,
    ! [VarCurr: state_type] :
      ( v83942(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_85008,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,10)
    <=> v5509(VarCurr,10) ) ).

tff(addAssignment_85007,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,10)
    <=> v5511(VarCurr,10) ) ).

tff(addAssignment_85006,axiom,
    ! [VarNext: state_type] :
      ( v5511(VarNext,10)
    <=> v150452(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150453(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150452(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2239,axiom,
    ! [VarNext: state_type] :
      ( v150453(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150452(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150453(VarNext)
      <=> v150454(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150454(VarNext)
      <=> ( v150456(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_11348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150456(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_85005,axiom,
    ! [VarCurr: state_type] :
      ( v83888(VarCurr,10)
    <=> v83890(VarCurr,10) ) ).

tff(addAssignment_85004,axiom,
    ! [VarCurr: state_type] :
      ( v83890(VarCurr,10)
    <=> v83899(VarCurr,10) ) ).

tff(addAssignment_85003,axiom,
    ! [VarCurr: state_type] :
      ( v83892(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_85002,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,10)
    <=> v5502(VarCurr,10) ) ).

tff(addAssignment_85001,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,10)
    <=> v5504(VarCurr,10) ) ).

tff(addAssignment_85000,axiom,
    ! [VarNext: state_type] :
      ( v5504(VarNext,10)
    <=> v150444(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150445(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150444(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2238,axiom,
    ! [VarNext: state_type] :
      ( v150445(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150444(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150445(VarNext)
      <=> v150446(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150446(VarNext)
      <=> ( v150448(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_11347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150448(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_84999,axiom,
    ! [VarCurr: state_type] :
      ( v83838(VarCurr,10)
    <=> v83840(VarCurr,10) ) ).

tff(addAssignment_84998,axiom,
    ! [VarCurr: state_type] :
      ( v83840(VarCurr,10)
    <=> v83849(VarCurr,10) ) ).

tff(addAssignment_84997,axiom,
    ! [VarCurr: state_type] :
      ( v83842(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84996,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,10)
    <=> v5495(VarCurr,10) ) ).

tff(addAssignment_84995,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,10)
    <=> v5497(VarCurr,10) ) ).

tff(addAssignment_84994,axiom,
    ! [VarNext: state_type] :
      ( v5497(VarNext,10)
    <=> v150436(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150437(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150436(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2237,axiom,
    ! [VarNext: state_type] :
      ( v150437(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150436(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150437(VarNext)
      <=> v150438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150438(VarNext)
      <=> ( v150440(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_11346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150440(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_84993,axiom,
    ! [VarCurr: state_type] :
      ( v83788(VarCurr,10)
    <=> v83790(VarCurr,10) ) ).

tff(addAssignment_84992,axiom,
    ! [VarCurr: state_type] :
      ( v83790(VarCurr,10)
    <=> v83799(VarCurr,10) ) ).

tff(addAssignment_84991,axiom,
    ! [VarCurr: state_type] :
      ( v83792(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84990,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,10)
    <=> v5489(VarCurr,10) ) ).

tff(addAssignment_84989,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,10)
    <=> v5491(VarCurr,10) ) ).

tff(addAssignment_84988,axiom,
    ! [VarNext: state_type] :
      ( v5491(VarNext,10)
    <=> v150428(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150429(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150428(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2236,axiom,
    ! [VarNext: state_type] :
      ( v150429(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150428(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150429(VarNext)
      <=> v150430(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150430(VarNext)
      <=> ( v150432(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_11345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150432(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_84987,axiom,
    ! [VarCurr: state_type] :
      ( v83738(VarCurr,10)
    <=> v83740(VarCurr,10) ) ).

tff(addAssignment_84986,axiom,
    ! [VarCurr: state_type] :
      ( v83740(VarCurr,10)
    <=> v83749(VarCurr,10) ) ).

tff(addAssignment_84985,axiom,
    ! [VarCurr: state_type] :
      ( v83742(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84984,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,10)
    <=> v5482(VarCurr,10) ) ).

tff(addAssignment_84983,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,10)
    <=> v5484(VarCurr,10) ) ).

tff(addAssignment_84982,axiom,
    ! [VarNext: state_type] :
      ( v5484(VarNext,10)
    <=> v150420(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150421(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150420(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2235,axiom,
    ! [VarNext: state_type] :
      ( v150421(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150420(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150421(VarNext)
      <=> v150422(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150422(VarNext)
      <=> ( v150424(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_11344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150424(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_84981,axiom,
    ! [VarCurr: state_type] :
      ( v83688(VarCurr,10)
    <=> v83690(VarCurr,10) ) ).

tff(addAssignment_84980,axiom,
    ! [VarCurr: state_type] :
      ( v83690(VarCurr,10)
    <=> v83699(VarCurr,10) ) ).

tff(addAssignment_84979,axiom,
    ! [VarCurr: state_type] :
      ( v83692(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84978,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,10)
    <=> v5475(VarCurr,10) ) ).

tff(addAssignment_84977,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,10)
    <=> v5477(VarCurr,10) ) ).

tff(addAssignment_84976,axiom,
    ! [VarNext: state_type] :
      ( v5477(VarNext,10)
    <=> v150412(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150413(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150412(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2234,axiom,
    ! [VarNext: state_type] :
      ( v150413(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150412(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150413(VarNext)
      <=> v150414(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150414(VarNext)
      <=> ( v150416(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_11343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150416(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_84975,axiom,
    ! [VarCurr: state_type] :
      ( v83638(VarCurr,10)
    <=> v83640(VarCurr,10) ) ).

tff(addAssignment_84974,axiom,
    ! [VarCurr: state_type] :
      ( v83640(VarCurr,10)
    <=> v83649(VarCurr,10) ) ).

tff(addAssignment_84973,axiom,
    ! [VarCurr: state_type] :
      ( v83642(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84972,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,10)
    <=> v5468(VarCurr,10) ) ).

tff(addAssignment_84971,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,10)
    <=> v5470(VarCurr,10) ) ).

tff(addAssignment_84970,axiom,
    ! [VarNext: state_type] :
      ( v5470(VarNext,10)
    <=> v150404(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150405(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150404(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2233,axiom,
    ! [VarNext: state_type] :
      ( v150405(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150404(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150405(VarNext)
      <=> v150406(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150406(VarNext)
      <=> ( v150408(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_11342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150408(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_84969,axiom,
    ! [VarCurr: state_type] :
      ( v83588(VarCurr,10)
    <=> v83590(VarCurr,10) ) ).

tff(addAssignment_84968,axiom,
    ! [VarCurr: state_type] :
      ( v83590(VarCurr,10)
    <=> v83599(VarCurr,10) ) ).

tff(addAssignment_84967,axiom,
    ! [VarCurr: state_type] :
      ( v83592(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84966,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,10)
    <=> v5461(VarCurr,10) ) ).

tff(addAssignment_84965,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,10)
    <=> v5463(VarCurr,10) ) ).

tff(addAssignment_84964,axiom,
    ! [VarNext: state_type] :
      ( v5463(VarNext,10)
    <=> v150396(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150397(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150396(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2232,axiom,
    ! [VarNext: state_type] :
      ( v150397(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150396(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150397(VarNext)
      <=> v150398(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150398(VarNext)
      <=> ( v150400(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_11341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150400(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_84963,axiom,
    ! [VarCurr: state_type] :
      ( v83538(VarCurr,10)
    <=> v83540(VarCurr,10) ) ).

tff(addAssignment_84962,axiom,
    ! [VarCurr: state_type] :
      ( v83540(VarCurr,10)
    <=> v83549(VarCurr,10) ) ).

tff(addAssignment_84961,axiom,
    ! [VarCurr: state_type] :
      ( v83542(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84960,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,10)
    <=> v5454(VarCurr,10) ) ).

tff(addAssignment_84959,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,10)
    <=> v5456(VarCurr,10) ) ).

tff(addAssignment_84958,axiom,
    ! [VarNext: state_type] :
      ( v5456(VarNext,10)
    <=> v150388(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150389(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150388(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2231,axiom,
    ! [VarNext: state_type] :
      ( v150389(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150388(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150389(VarNext)
      <=> v150390(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150390(VarNext)
      <=> ( v150392(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_11340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150392(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_84957,axiom,
    ! [VarCurr: state_type] :
      ( v83488(VarCurr,10)
    <=> v83490(VarCurr,10) ) ).

tff(addAssignment_84956,axiom,
    ! [VarCurr: state_type] :
      ( v83490(VarCurr,10)
    <=> v83499(VarCurr,10) ) ).

tff(addAssignment_84955,axiom,
    ! [VarCurr: state_type] :
      ( v83492(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84954,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,10)
    <=> v5447(VarCurr,10) ) ).

tff(addAssignment_84953,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,10)
    <=> v5449(VarCurr,10) ) ).

tff(addAssignment_84952,axiom,
    ! [VarNext: state_type] :
      ( v5449(VarNext,10)
    <=> v150380(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150381(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150380(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2230,axiom,
    ! [VarNext: state_type] :
      ( v150381(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150380(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150381(VarNext)
      <=> v150382(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150382(VarNext)
      <=> ( v150384(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_11339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150384(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_84951,axiom,
    ! [VarCurr: state_type] :
      ( v83438(VarCurr,10)
    <=> v83440(VarCurr,10) ) ).

tff(addAssignment_84950,axiom,
    ! [VarCurr: state_type] :
      ( v83440(VarCurr,10)
    <=> v83449(VarCurr,10) ) ).

tff(addAssignment_84949,axiom,
    ! [VarCurr: state_type] :
      ( v83442(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84948,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,10)
    <=> v5440(VarCurr,10) ) ).

tff(addAssignment_84947,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,10)
    <=> v5442(VarCurr,10) ) ).

tff(addAssignment_84946,axiom,
    ! [VarNext: state_type] :
      ( v5442(VarNext,10)
    <=> v150372(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150373(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150372(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2229,axiom,
    ! [VarNext: state_type] :
      ( v150373(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150372(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150373(VarNext)
      <=> v150374(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150374(VarNext)
      <=> ( v150376(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_11338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150376(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_84945,axiom,
    ! [VarCurr: state_type] :
      ( v83388(VarCurr,10)
    <=> v83390(VarCurr,10) ) ).

tff(addAssignment_84944,axiom,
    ! [VarCurr: state_type] :
      ( v83390(VarCurr,10)
    <=> v83399(VarCurr,10) ) ).

tff(addAssignment_84943,axiom,
    ! [VarCurr: state_type] :
      ( v83392(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84942,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,10)
    <=> v5433(VarCurr,10) ) ).

tff(addAssignment_84941,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,10)
    <=> v5435(VarCurr,10) ) ).

tff(addAssignment_84940,axiom,
    ! [VarNext: state_type] :
      ( v5435(VarNext,10)
    <=> v150364(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150365(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150364(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2228,axiom,
    ! [VarNext: state_type] :
      ( v150365(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150364(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150365(VarNext)
      <=> v150366(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150366(VarNext)
      <=> ( v150368(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_11337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150368(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_84939,axiom,
    ! [VarCurr: state_type] :
      ( v83338(VarCurr,10)
    <=> v83340(VarCurr,10) ) ).

tff(addAssignment_84938,axiom,
    ! [VarCurr: state_type] :
      ( v83340(VarCurr,10)
    <=> v83349(VarCurr,10) ) ).

tff(addAssignment_84937,axiom,
    ! [VarCurr: state_type] :
      ( v83342(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84936,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,10)
    <=> v5426(VarCurr,10) ) ).

tff(addAssignment_84935,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,10)
    <=> v5428(VarCurr,10) ) ).

tff(addAssignment_84934,axiom,
    ! [VarNext: state_type] :
      ( v5428(VarNext,10)
    <=> v150356(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150357(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150356(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2227,axiom,
    ! [VarNext: state_type] :
      ( v150357(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150356(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150357(VarNext)
      <=> v150358(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150358(VarNext)
      <=> ( v150360(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_11336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150360(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_84933,axiom,
    ! [VarCurr: state_type] :
      ( v83288(VarCurr,10)
    <=> v83290(VarCurr,10) ) ).

tff(addAssignment_84932,axiom,
    ! [VarCurr: state_type] :
      ( v83290(VarCurr,10)
    <=> v83299(VarCurr,10) ) ).

tff(addAssignment_84931,axiom,
    ! [VarCurr: state_type] :
      ( v83292(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84930,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,10)
    <=> v5420(VarCurr,10) ) ).

tff(addAssignment_84929,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,10)
    <=> v5422(VarCurr,10) ) ).

tff(addAssignment_84928,axiom,
    ! [VarNext: state_type] :
      ( v5422(VarNext,10)
    <=> v150348(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150349(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v150348(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2226,axiom,
    ! [VarNext: state_type] :
      ( v150349(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v150348(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150349(VarNext)
      <=> v150350(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150350(VarNext)
      <=> ( v150352(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_11335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150352(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_84927,axiom,
    ! [VarCurr: state_type] :
      ( v82920(VarCurr,10)
    <=> v82922(VarCurr,10) ) ).

tff(addAssignment_84926,axiom,
    ! [VarCurr: state_type] :
      ( v82922(VarCurr,10)
    <=> v83246(VarCurr,10) ) ).

tff(addAssignment_84925,axiom,
    ! [VarCurr: state_type] :
      ( v82924(VarCurr,10)
    <=> v82926(VarCurr,10) ) ).

tff(addAssignment_84924,axiom,
    ! [VarCurr: state_type] :
      ( v82926(VarCurr,10)
    <=> v82928(VarCurr,10) ) ).

tff(addAssignment_84923,axiom,
    ! [VarCurr: state_type] :
      ( v82928(VarCurr,10)
    <=> v82930(VarCurr,10) ) ).

tff(addAssignment_84922,axiom,
    ! [VarCurr: state_type] :
      ( v82930(VarCurr,10)
    <=> v82932(VarCurr,10) ) ).

tff(addAssignment_84921,axiom,
    ! [VarCurr: state_type] :
      ( v82932(VarCurr,10)
    <=> v83008(VarCurr,10) ) ).

tff(addAssignment_84920,axiom,
    ! [VarCurr: state_type] :
      ( v83021(VarCurr)
    <=> v150344(VarCurr) ) ).

tff(addAssignment_84919,axiom,
    ! [VarCurr: state_type] :
      ( v150344(VarCurr)
    <=> v150346(VarCurr) ) ).

tff(addAssignment_84918,axiom,
    ! [VarCurr: state_type] :
      ( v83020(VarCurr)
    <=> v150339(VarCurr) ) ).

tff(addAssignment_84917,axiom,
    ! [VarCurr: state_type] :
      ( v150339(VarCurr)
    <=> v150341(VarCurr) ) ).

tff(addAssignment_84916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v970(VarCurr,B)
      <=> v972(VarCurr,B) ) ) ).

tff(addAssignment_84915,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v972(VarNext,B)
      <=> v150330(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150331(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v150330(VarNext,B)
            <=> v972(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2225,axiom,
    ! [VarNext: state_type] :
      ( v150331(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v150330(VarNext,B)
          <=> v135334(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150331(VarNext)
      <=> v150332(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150332(VarNext)
      <=> ( v150334(VarNext)
          & v135319(VarNext) ) ) ) ).

tff(writeUnaryOperator_11334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150334(VarNext)
      <=> v135328(VarNext) ) ) ).

tff(addAssignment_84914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v990(VarCurr,B)
      <=> v992(VarCurr,B) ) ) ).

tff(addAssignment_84913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v992(VarCurr,B)
      <=> v994(VarCurr,B) ) ) ).

tff(addAssignment_84912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v994(VarCurr,B)
      <=> v996(VarCurr,B) ) ) ).

tff(addAssignment_84911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v996(VarCurr,B)
      <=> v135260(VarCurr,B) ) ) ).

tff(addAssignment_84910,axiom,
    ! [VarCurr: state_type] :
      ( v999(VarCurr)
    <=> v1001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19896,axiom,
    ! [VarCurr: state_type] :
      ( v1001(VarCurr)
    <=> ( v1003(VarCurr)
        & v1025(VarCurr) ) ) ).

tff(addAssignment_84909,axiom,
    ! [VarCurr: state_type] :
      ( v1003(VarCurr)
    <=> v1005(VarCurr) ) ).

tff(addAssignment_84908,axiom,
    ! [VarCurr: state_type] :
      ( v1005(VarCurr)
    <=> v1007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150312(VarNext)
       => ( v1007(VarNext)
        <=> v1007(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2224,axiom,
    ! [VarNext: state_type] :
      ( v150312(VarNext)
     => ( v1007(VarNext)
      <=> v150322(VarNext) ) ) ).

tff(addAssignment_84907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150322(VarNext)
      <=> v150320(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150323(VarCurr)
     => ( v150320(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1650,axiom,
    ! [VarCurr: state_type] :
      ( v150323(VarCurr)
     => ( v150320(VarCurr)
      <=> v1017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19895,axiom,
    ! [VarCurr: state_type] :
      ( v150323(VarCurr)
    <=> ( v150324(VarCurr)
        & v150325(VarCurr) ) ) ).

tff(writeUnaryOperator_11333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150325(VarCurr)
    <=> v1013(VarCurr) ) ).

tff(writeUnaryOperator_11332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150324(VarCurr)
    <=> v1009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150312(VarNext)
      <=> v150313(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150313(VarNext)
      <=> ( v150314(VarNext)
          & v150307(VarNext) ) ) ) ).

tff(writeUnaryOperator_11331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150314(VarNext)
      <=> v150316(VarNext) ) ) ).

tff(addAssignment_84906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150316(VarNext)
      <=> v150307(VarCurr) ) ) ).

tff(addAssignment_84905,axiom,
    ! [VarCurr: state_type] :
      ( v150307(VarCurr)
    <=> v150309(VarCurr) ) ).

tff(addAssignment_84904,axiom,
    ! [VarCurr: state_type] :
      ( v150309(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_84903,axiom,
    ! [VarCurr: state_type] :
      ( v1017(VarCurr)
    <=> v1019(VarCurr) ) ).

tff(addAssignment_84902,axiom,
    ! [VarCurr: state_type] :
      ( v1019(VarCurr)
    <=> v1021(VarCurr) ) ).

tff(addAssignment_84901,axiom,
    ! [VarCurr: state_type] :
      ( v1021(VarCurr)
    <=> v1023(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150303(VarCurr)
     => ( v1023(VarCurr)
      <=> v1003(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1649,axiom,
    ! [VarCurr: state_type] :
      ( v150303(VarCurr)
     => ( v1023(VarCurr)
      <=> v150305(VarCurr) ) ) ).

tff(writeUnaryOperator_11330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150305(VarCurr)
    <=> v1003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19892,axiom,
    ! [VarCurr: state_type] :
      ( v150303(VarCurr)
    <=> ( v150304(VarCurr)
        | v140614(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19891,axiom,
    ! [VarCurr: state_type] :
      ( v150304(VarCurr)
    <=> ( v1025(VarCurr)
        | v140592(VarCurr) ) ) ).

tff(addAssignment_84900,axiom,
    ! [VarCurr: state_type] :
      ( v1025(VarCurr)
    <=> v1027(VarCurr) ) ).

tff(addAssignment_84899,axiom,
    ! [VarCurr: state_type] :
      ( v1027(VarCurr)
    <=> v1029(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150286(VarNext)
       => ( v1029(VarNext)
        <=> v1029(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2223,axiom,
    ! [VarNext: state_type] :
      ( v150286(VarNext)
     => ( v1029(VarNext)
      <=> v150296(VarNext) ) ) ).

tff(addAssignment_84898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150296(VarNext)
      <=> v150294(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150297(VarCurr)
     => ( v150294(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1648,axiom,
    ! [VarCurr: state_type] :
      ( v150297(VarCurr)
     => ( v150294(VarCurr)
      <=> v1039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19890,axiom,
    ! [VarCurr: state_type] :
      ( v150297(VarCurr)
    <=> ( v150298(VarCurr)
        & v150299(VarCurr) ) ) ).

tff(writeUnaryOperator_11329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150299(VarCurr)
    <=> v1035(VarCurr) ) ).

tff(writeUnaryOperator_11328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150298(VarCurr)
    <=> v1031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150286(VarNext)
      <=> v150287(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150287(VarNext)
      <=> ( v150288(VarNext)
          & v150281(VarNext) ) ) ) ).

tff(writeUnaryOperator_11327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150288(VarNext)
      <=> v150290(VarNext) ) ) ).

tff(addAssignment_84897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150290(VarNext)
      <=> v150281(VarCurr) ) ) ).

tff(addAssignment_84896,axiom,
    ! [VarCurr: state_type] :
      ( v150281(VarCurr)
    <=> v150283(VarCurr) ) ).

tff(addAssignment_84895,axiom,
    ! [VarCurr: state_type] :
      ( v150283(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_84894,axiom,
    ! [VarCurr: state_type] :
      ( v1039(VarCurr)
    <=> v1041(VarCurr) ) ).

tff(addAssignment_84893,axiom,
    ! [VarCurr: state_type] :
      ( v1041(VarCurr)
    <=> v1043(VarCurr) ) ).

tff(addAssignment_84892,axiom,
    ! [VarCurr: state_type] :
      ( v1043(VarCurr)
    <=> v1045(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1047(VarCurr)
     => ( v1045(VarCurr)
      <=> v2036(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1647,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
     => ( v1045(VarCurr)
      <=> v150279(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6963,axiom,
    ! [VarCurr: state_type] :
      ( v150279(VarCurr)
    <=> ( v2036(VarCurr)
        & v59955(VarCurr,1) ) ) ).

tff(addAssignment_84891,axiom,
    ! [VarCurr: state_type] :
      ( v59955(VarCurr,1)
    <=> v59957(VarCurr,1) ) ).

tff(addAssignment_84890,axiom,
    ! [VarCurr: state_type] :
      ( v59957(VarCurr,1)
    <=> v59959(VarCurr,1) ) ).

tff(addAssignment_84889,axiom,
    ! [VarNext: state_type] :
      ( v59959(VarNext,1)
    <=> v150271(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150272(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v150271(VarNext,B)
            <=> v59959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2222,axiom,
    ! [VarNext: state_type] :
      ( v150272(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v150271(VarNext,B)
          <=> v60012(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150272(VarNext)
      <=> v150273(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150273(VarNext)
      <=> ( v150275(VarNext)
          & v59997(VarNext) ) ) ) ).

tff(writeUnaryOperator_11326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150275(VarNext)
      <=> v60006(VarNext) ) ) ).

tff(addAssignment_84888,axiom,
    ! [VarCurr: state_type] :
      ( v59969(VarCurr,1)
    <=> v59971(VarCurr,1) ) ).

tff(addAssignment_84887,axiom,
    ! [VarCurr: state_type] :
      ( v59971(VarCurr,1)
    <=> v59988(VarCurr,1) ) ).

tff(addAssignment_84886,axiom,
    ! [VarCurr: state_type] :
      ( v59973(VarCurr,1)
    <=> v59975(VarCurr,1) ) ).

tff(addAssignment_84885,axiom,
    ! [VarCurr: state_type] :
      ( v59975(VarCurr,1)
    <=> v59976(VarCurr,1) ) ).

tff(addAssignment_84884,axiom,
    ! [VarCurr: state_type] :
      ( v2036(VarCurr)
    <=> v2038(VarCurr) ) ).

tff(addAssignment_84883,axiom,
    ! [VarCurr: state_type] :
      ( v2038(VarCurr)
    <=> v2040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19885,axiom,
    ! [VarCurr: state_type] :
      ( v2040(VarCurr)
    <=> ( v150267(VarCurr)
        | v150268(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19884,axiom,
    ! [VarCurr: state_type] :
      ( v150268(VarCurr)
    <=> ( v10059(VarCurr)
        & v150269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19883,axiom,
    ! [VarCurr: state_type] :
      ( v150269(VarCurr)
    <=> ( v150224(VarCurr)
        | v150257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19882,axiom,
    ! [VarCurr: state_type] :
      ( v150267(VarCurr)
    <=> ( v2042(VarCurr)
        | v150204(VarCurr) ) ) ).

tff(addAssignment_84882,axiom,
    ! [VarCurr: state_type] :
      ( v150257(VarCurr)
    <=> v150206(VarCurr,0) ) ).

tff(addAssignment_84881,axiom,
    ! [VarCurr: state_type] :
      ( v150206(VarCurr,0)
    <=> v150208(VarCurr,0) ) ).

tff(addAssignment_84880,axiom,
    ! [VarNext: state_type] :
      ( v150208(VarNext,0)
    <=> v150259(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150260(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v150259(VarNext,B)
            <=> v150208(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2221,axiom,
    ! [VarNext: state_type] :
      ( v150260(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150259(VarNext,B)
          <=> v150241(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150260(VarNext)
      <=> v150261(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150261(VarNext)
      <=> ( v150263(VarNext)
          & v150226(VarNext) ) ) ) ).

tff(writeUnaryOperator_11325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150263(VarNext)
      <=> v150235(VarNext) ) ) ).

tff(addAssignment_84879,axiom,
    ! [VarCurr: state_type] :
      ( v150218(VarCurr,0)
    <=> v150220(VarCurr,0) ) ).

tff(addAssignment_84878,axiom,
    ! [VarCurr: state_type] :
      ( v150220(VarCurr,0)
    <=> v150222(VarCurr,0) ) ).

tff(addAssignment_84877,axiom,
    ! [VarCurr: state_type] :
      ( v150222(VarCurr,0)
    <=> v150223(VarCurr,0) ) ).

tff(addAssignment_84876,axiom,
    ! [VarCurr: state_type] :
      ( v150224(VarCurr)
    <=> v150206(VarCurr,1) ) ).

tff(addAssignment_84875,axiom,
    ! [VarCurr: state_type] :
      ( v150206(VarCurr,1)
    <=> v150208(VarCurr,1) ) ).

tff(addAssignment_84874,axiom,
    ! [VarNext: state_type] :
      ( v150208(VarNext,1)
    <=> v150249(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150250(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v150249(VarNext,B)
            <=> v150208(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2220,axiom,
    ! [VarNext: state_type] :
      ( v150250(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150249(VarNext,B)
          <=> v150241(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150250(VarNext)
      <=> v150251(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150251(VarNext)
      <=> ( v150253(VarNext)
          & v150226(VarNext) ) ) ) ).

tff(writeUnaryOperator_11324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150253(VarNext)
      <=> v150235(VarNext) ) ) ).

tff(addAssignment_84873,axiom,
    ! [VarCurr: state_type] :
      ( v150218(VarCurr,1)
    <=> v150220(VarCurr,1) ) ).

tff(addAssignment_84872,axiom,
    ! [VarCurr: state_type] :
      ( v150220(VarCurr,1)
    <=> v150222(VarCurr,1) ) ).

tff(addAssignment_84871,axiom,
    ! [VarCurr: state_type] :
      ( v150222(VarCurr,1)
    <=> v150223(VarCurr,1) ) ).

tff(addAssignment_84870,axiom,
    ! [VarCurr: state_type] :
      ( v150204(VarCurr)
    <=> v150206(VarCurr,2) ) ).

tff(addAssignment_84869,axiom,
    ! [VarCurr: state_type] :
      ( v150206(VarCurr,2)
    <=> v150208(VarCurr,2) ) ).

tff(addAssignment_84868,axiom,
    ! [VarNext: state_type] :
      ( v150208(VarNext,2)
    <=> v150230(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150231(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v150230(VarNext,B)
            <=> v150208(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2219,axiom,
    ! [VarNext: state_type] :
      ( v150231(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150230(VarNext,B)
          <=> v150241(VarNext,B) ) ) ) ).

tff(addAssignment_84867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150241(VarNext,B)
          <=> v150239(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150242(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150239(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1646,axiom,
    ! [VarCurr: state_type] :
      ( v150242(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v150239(VarCurr,B)
          <=> v150218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19877,axiom,
    ! [VarCurr: state_type] :
      ( v150242(VarCurr)
    <=> ( v150243(VarCurr)
        & v150244(VarCurr) ) ) ).

tff(writeUnaryOperator_11323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150244(VarCurr)
    <=> v150214(VarCurr) ) ).

tff(writeUnaryOperator_11322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150243(VarCurr)
    <=> v150210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150231(VarNext)
      <=> v150232(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150232(VarNext)
      <=> ( v150233(VarNext)
          & v150226(VarNext) ) ) ) ).

tff(writeUnaryOperator_11321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150233(VarNext)
      <=> v150235(VarNext) ) ) ).

tff(addAssignment_84866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150235(VarNext)
      <=> v150226(VarCurr) ) ) ).

tff(addAssignment_84865,axiom,
    ! [VarCurr: state_type] :
      ( v150226(VarCurr)
    <=> v150228(VarCurr) ) ).

tff(addAssignment_84864,axiom,
    ! [VarCurr: state_type] :
      ( v150228(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_84863,axiom,
    ! [VarCurr: state_type] :
      ( v150218(VarCurr,2)
    <=> v150220(VarCurr,2) ) ).

tff(addAssignment_84862,axiom,
    ! [VarCurr: state_type] :
      ( v150220(VarCurr,2)
    <=> v150222(VarCurr,2) ) ).

tff(addAssignment_84861,axiom,
    ! [VarCurr: state_type] :
      ( v150222(VarCurr,2)
    <=> v150223(VarCurr,2) ) ).

tff(addAssignment_84860,axiom,
    ! [VarCurr: state_type] :
      ( v150223(VarCurr,0)
    <=> v150224(VarCurr) ) ).

tff(addAssignment_84859,axiom,
    ! [VarCurr: state_type] :
      ( v150223(VarCurr,1)
    <=> v150204(VarCurr) ) ).

tff(addAssignment_84858,axiom,
    ! [VarCurr: state_type] :
      ( v150223(VarCurr,2)
    <=> v2042(VarCurr) ) ).

tff(addAssignment_84857,axiom,
    ! [VarCurr: state_type] :
      ( v150214(VarCurr)
    <=> v150216(VarCurr) ) ).

tff(addAssignment_84856,axiom,
    ! [VarCurr: state_type] :
      ( v150216(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_84855,axiom,
    ! [VarCurr: state_type] :
      ( v150210(VarCurr)
    <=> v150212(VarCurr) ) ).

tff(addAssignment_84854,axiom,
    ! [VarCurr: state_type] :
      ( v150212(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19874,axiom,
    ! [VarCurr: state_type] :
      ( v2042(VarCurr)
    <=> ( v2044(VarCurr)
        & v150202(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2315,axiom,
    ! [VarCurr: state_type] :
      ( v150202(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $false )
        & ( v2200(VarCurr,9)
        <=> $false )
        & ( v2200(VarCurr,8)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19873,axiom,
    ! [VarCurr: state_type] :
      ( v2044(VarCurr)
    <=> ( v150199(VarCurr)
        & v150200(VarCurr) ) ) ).

tff(writeUnaryOperator_11320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v150200(VarCurr)
    <=> v150178(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2314,axiom,
    ! [VarCurr: state_type] :
      ( v150199(VarCurr)
    <=> ( ( v2046(VarCurr,7)
        <=> v2200(VarCurr,7) )
        & ( v2046(VarCurr,6)
        <=> v2200(VarCurr,6) )
        & ( v2046(VarCurr,5)
        <=> v2200(VarCurr,5) )
        & ( v2046(VarCurr,4)
        <=> v2200(VarCurr,4) )
        & ( v2046(VarCurr,3)
        <=> v2200(VarCurr,3) )
        & ( v2046(VarCurr,2)
        <=> v2200(VarCurr,2) )
        & ( v2046(VarCurr,1)
        <=> v2200(VarCurr,1) )
        & ( v2046(VarCurr,0)
        <=> v2200(VarCurr,0) ) ) ) ).

tff(addAssignment_84853,axiom,
    ! [VarCurr: state_type] :
      ( v150178(VarCurr)
    <=> v150180(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2313,axiom,
    ! [VarCurr: state_type] :
      ( v150180(VarCurr)
    <=> ( ( v2204(VarCurr,5)
        <=> v2813(VarCurr,5) )
        & ( v2204(VarCurr,4)
        <=> v2813(VarCurr,4) )
        & ( v2204(VarCurr,3)
        <=> v2813(VarCurr,3) )
        & ( v2204(VarCurr,2)
        <=> v2813(VarCurr,2) )
        & ( v2204(VarCurr,1)
        <=> v2813(VarCurr,1) )
        & ( v2204(VarCurr,0)
        <=> v2813(VarCurr,0) ) ) ) ).

tff(addAssignment_84852,axiom,
    ! [VarCurr: state_type] :
      ( v2813(VarCurr,5)
    <=> v2815(VarCurr,5) ) ).

tff(addAssignment_84851,axiom,
    ! [VarCurr: state_type] :
      ( v2815(VarCurr,5)
    <=> v2817(VarCurr,5) ) ).

tff(addAssignment_84850,axiom,
    ! [VarNext: state_type] :
      ( v2817(VarNext,5)
    <=> v150190(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_2218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150191(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v150190(VarNext,B)
            <=> v2817(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2218,axiom,
    ! [VarNext: state_type] :
      ( v150191(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v150190(VarNext,B)
          <=> v149913(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150191(VarNext)
      <=> v150192(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150192(VarNext)
      <=> ( v150194(VarNext)
          & v149898(VarNext) ) ) ) ).

tff(writeUnaryOperator_11319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150194(VarNext)
      <=> v149907(VarNext) ) ) ).

tff(addAssignment_84849,axiom,
    ! [VarCurr: state_type] :
      ( v2827(VarCurr,5)
    <=> v2829(VarCurr,5) ) ).

tff(addAssignment_84848,axiom,
    ! [VarCurr: state_type] :
      ( v2829(VarCurr,5)
    <=> v149889(VarCurr,5) ) ).

tff(addAssignment_84847,axiom,
    ! [VarCurr: state_type] :
      ( v2831(VarCurr,5)
    <=> v2833(VarCurr,5) ) ).

tff(addAssignment_84846,axiom,
    ! [VarCurr: state_type] :
      ( v2833(VarCurr,5)
    <=> v2834(VarCurr,5) ) ).

tff(addAssignment_84845,axiom,
    ! [VarCurr: state_type] :
      ( v2204(VarCurr,5)
    <=> v2206(VarCurr,5) ) ).

tff(addAssignment_84844,axiom,
    ! [VarCurr: state_type] :
      ( v2206(VarCurr,5)
    <=> v2208(VarCurr,5) ) ).

tff(addAssignment_84843,axiom,
    ! [VarNext: state_type] :
      ( v2208(VarNext,5)
    <=> v150182(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_2217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150183(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v150182(VarNext,B)
            <=> v2208(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2217,axiom,
    ! [VarNext: state_type] :
      ( v150183(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v150182(VarNext,B)
          <=> v2295(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150183(VarNext)
      <=> v150184(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150184(VarNext)
      <=> ( v150186(VarNext)
          & v2278(VarNext) ) ) ) ).

tff(writeUnaryOperator_11318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150186(VarNext)
      <=> v2289(VarNext) ) ) ).

tff(addAssignment_84842,axiom,
    ! [VarCurr: state_type] :
      ( v2226(VarCurr,5)
    <=> v2228(VarCurr,5) ) ).

tff(addAssignment_84841,axiom,
    ! [VarCurr: state_type] :
      ( v2228(VarCurr,5)
    <=> v2269(VarCurr,5) ) ).

tff(addAssignment_84840,axiom,
    ! [VarCurr: state_type] :
      ( v2230(VarCurr,5)
    <=> v2232(VarCurr,5) ) ).

tff(addAssignment_84839,axiom,
    ! [VarCurr: state_type] :
      ( v2232(VarCurr,5)
    <=> v2234(VarCurr,5) ) ).

tff(addAssignment_84838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2200(VarCurr,B)
      <=> v2202(VarCurr,B) ) ) ).

tff(addAssignment_84837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2202(VarCurr,B)
      <=> v143640(VarCurr,B) ) ) ).

tff(addAssignment_84836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143585(VarCurr,B)
      <=> v143587(VarCurr,B) ) ) ).

tff(addAssignment_84835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143587(VarCurr,B)
      <=> v143589(VarCurr,B) ) ) ).

tff(addAssignment_84834,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143589(VarNext,B)
      <=> v150170(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150171(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150170(VarNext,B)
            <=> v143589(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2216,axiom,
    ! [VarNext: state_type] :
      ( v150171(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150170(VarNext,B)
          <=> v143634(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150171(VarNext)
      <=> v150172(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150172(VarNext)
      <=> ( v150174(VarNext)
          & v143619(VarNext) ) ) ) ).

tff(writeUnaryOperator_11317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150174(VarNext)
      <=> v143628(VarNext) ) ) ).

tff(addAssignment_84833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143599(VarCurr,B)
      <=> v143601(VarCurr,B) ) ) ).

tff(addAssignment_84832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143601(VarCurr,B)
      <=> v143610(VarCurr,B) ) ) ).

tff(addAssignment_84831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143603(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143528(VarCurr,B)
      <=> v143530(VarCurr,B) ) ) ).

tff(addAssignment_84829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143530(VarCurr,B)
      <=> v143532(VarCurr,B) ) ) ).

tff(addAssignment_84828,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143532(VarNext,B)
      <=> v150162(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150163(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150162(VarNext,B)
            <=> v143532(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2215,axiom,
    ! [VarNext: state_type] :
      ( v150163(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150162(VarNext,B)
          <=> v143577(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150163(VarNext)
      <=> v150164(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150164(VarNext)
      <=> ( v150166(VarNext)
          & v143562(VarNext) ) ) ) ).

tff(writeUnaryOperator_11316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150166(VarNext)
      <=> v143571(VarNext) ) ) ).

tff(addAssignment_84827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143542(VarCurr,B)
      <=> v143544(VarCurr,B) ) ) ).

tff(addAssignment_84826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143544(VarCurr,B)
      <=> v143553(VarCurr,B) ) ) ).

tff(addAssignment_84825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143546(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143471(VarCurr,B)
      <=> v143473(VarCurr,B) ) ) ).

tff(addAssignment_84823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143473(VarCurr,B)
      <=> v143475(VarCurr,B) ) ) ).

tff(addAssignment_84822,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143475(VarNext,B)
      <=> v150154(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150155(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150154(VarNext,B)
            <=> v143475(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2214,axiom,
    ! [VarNext: state_type] :
      ( v150155(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150154(VarNext,B)
          <=> v143520(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150155(VarNext)
      <=> v150156(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150156(VarNext)
      <=> ( v150158(VarNext)
          & v143505(VarNext) ) ) ) ).

tff(writeUnaryOperator_11315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150158(VarNext)
      <=> v143514(VarNext) ) ) ).

tff(addAssignment_84821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143485(VarCurr,B)
      <=> v143487(VarCurr,B) ) ) ).

tff(addAssignment_84820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143487(VarCurr,B)
      <=> v143496(VarCurr,B) ) ) ).

tff(addAssignment_84819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143489(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143414(VarCurr,B)
      <=> v143416(VarCurr,B) ) ) ).

tff(addAssignment_84817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143416(VarCurr,B)
      <=> v143418(VarCurr,B) ) ) ).

tff(addAssignment_84816,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143418(VarNext,B)
      <=> v150146(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150147(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150146(VarNext,B)
            <=> v143418(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2213,axiom,
    ! [VarNext: state_type] :
      ( v150147(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150146(VarNext,B)
          <=> v143463(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150147(VarNext)
      <=> v150148(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150148(VarNext)
      <=> ( v150150(VarNext)
          & v143448(VarNext) ) ) ) ).

tff(writeUnaryOperator_11314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150150(VarNext)
      <=> v143457(VarNext) ) ) ).

tff(addAssignment_84815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143428(VarCurr,B)
      <=> v143430(VarCurr,B) ) ) ).

tff(addAssignment_84814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143430(VarCurr,B)
      <=> v143439(VarCurr,B) ) ) ).

tff(addAssignment_84813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143432(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143357(VarCurr,B)
      <=> v143359(VarCurr,B) ) ) ).

tff(addAssignment_84811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143359(VarCurr,B)
      <=> v143361(VarCurr,B) ) ) ).

tff(addAssignment_84810,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143361(VarNext,B)
      <=> v150138(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150139(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150138(VarNext,B)
            <=> v143361(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2212,axiom,
    ! [VarNext: state_type] :
      ( v150139(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150138(VarNext,B)
          <=> v143406(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150139(VarNext)
      <=> v150140(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150140(VarNext)
      <=> ( v150142(VarNext)
          & v143391(VarNext) ) ) ) ).

tff(writeUnaryOperator_11313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150142(VarNext)
      <=> v143400(VarNext) ) ) ).

tff(addAssignment_84809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143371(VarCurr,B)
      <=> v143373(VarCurr,B) ) ) ).

tff(addAssignment_84808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143373(VarCurr,B)
      <=> v143382(VarCurr,B) ) ) ).

tff(addAssignment_84807,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143375(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143300(VarCurr,B)
      <=> v143302(VarCurr,B) ) ) ).

tff(addAssignment_84805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143302(VarCurr,B)
      <=> v143304(VarCurr,B) ) ) ).

tff(addAssignment_84804,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143304(VarNext,B)
      <=> v150130(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150131(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150130(VarNext,B)
            <=> v143304(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2211,axiom,
    ! [VarNext: state_type] :
      ( v150131(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150130(VarNext,B)
          <=> v143349(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150131(VarNext)
      <=> v150132(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150132(VarNext)
      <=> ( v150134(VarNext)
          & v143334(VarNext) ) ) ) ).

tff(writeUnaryOperator_11312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150134(VarNext)
      <=> v143343(VarNext) ) ) ).

tff(addAssignment_84803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143314(VarCurr,B)
      <=> v143316(VarCurr,B) ) ) ).

tff(addAssignment_84802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143316(VarCurr,B)
      <=> v143325(VarCurr,B) ) ) ).

tff(addAssignment_84801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143318(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143243(VarCurr,B)
      <=> v143245(VarCurr,B) ) ) ).

tff(addAssignment_84799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143245(VarCurr,B)
      <=> v143247(VarCurr,B) ) ) ).

tff(addAssignment_84798,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143247(VarNext,B)
      <=> v150122(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150123(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150122(VarNext,B)
            <=> v143247(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2210,axiom,
    ! [VarNext: state_type] :
      ( v150123(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150122(VarNext,B)
          <=> v143292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150123(VarNext)
      <=> v150124(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150124(VarNext)
      <=> ( v150126(VarNext)
          & v143277(VarNext) ) ) ) ).

tff(writeUnaryOperator_11311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150126(VarNext)
      <=> v143286(VarNext) ) ) ).

tff(addAssignment_84797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143257(VarCurr,B)
      <=> v143259(VarCurr,B) ) ) ).

tff(addAssignment_84796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143259(VarCurr,B)
      <=> v143268(VarCurr,B) ) ) ).

tff(addAssignment_84795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143261(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143186(VarCurr,B)
      <=> v143188(VarCurr,B) ) ) ).

tff(addAssignment_84793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143188(VarCurr,B)
      <=> v143190(VarCurr,B) ) ) ).

tff(addAssignment_84792,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143190(VarNext,B)
      <=> v150114(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150115(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150114(VarNext,B)
            <=> v143190(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2209,axiom,
    ! [VarNext: state_type] :
      ( v150115(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150114(VarNext,B)
          <=> v143235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150115(VarNext)
      <=> v150116(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19853,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150116(VarNext)
      <=> ( v150118(VarNext)
          & v143220(VarNext) ) ) ) ).

tff(writeUnaryOperator_11310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150118(VarNext)
      <=> v143229(VarNext) ) ) ).

tff(addAssignment_84791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143200(VarCurr,B)
      <=> v143202(VarCurr,B) ) ) ).

tff(addAssignment_84790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143202(VarCurr,B)
      <=> v143211(VarCurr,B) ) ) ).

tff(addAssignment_84789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143204(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143129(VarCurr,B)
      <=> v143131(VarCurr,B) ) ) ).

tff(addAssignment_84787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143131(VarCurr,B)
      <=> v143133(VarCurr,B) ) ) ).

tff(addAssignment_84786,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143133(VarNext,B)
      <=> v150106(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150107(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150106(VarNext,B)
            <=> v143133(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2208,axiom,
    ! [VarNext: state_type] :
      ( v150107(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150106(VarNext,B)
          <=> v143178(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150107(VarNext)
      <=> v150108(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19851,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150108(VarNext)
      <=> ( v150110(VarNext)
          & v143163(VarNext) ) ) ) ).

tff(writeUnaryOperator_11309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150110(VarNext)
      <=> v143172(VarNext) ) ) ).

tff(addAssignment_84785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143143(VarCurr,B)
      <=> v143145(VarCurr,B) ) ) ).

tff(addAssignment_84784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143145(VarCurr,B)
      <=> v143154(VarCurr,B) ) ) ).

tff(addAssignment_84783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143147(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143072(VarCurr,B)
      <=> v143074(VarCurr,B) ) ) ).

tff(addAssignment_84781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143074(VarCurr,B)
      <=> v143076(VarCurr,B) ) ) ).

tff(addAssignment_84780,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143076(VarNext,B)
      <=> v150098(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150099(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150098(VarNext,B)
            <=> v143076(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2207,axiom,
    ! [VarNext: state_type] :
      ( v150099(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150098(VarNext,B)
          <=> v143121(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150099(VarNext)
      <=> v150100(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150100(VarNext)
      <=> ( v150102(VarNext)
          & v143106(VarNext) ) ) ) ).

tff(writeUnaryOperator_11308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150102(VarNext)
      <=> v143115(VarNext) ) ) ).

tff(addAssignment_84779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143086(VarCurr,B)
      <=> v143088(VarCurr,B) ) ) ).

tff(addAssignment_84778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143088(VarCurr,B)
      <=> v143097(VarCurr,B) ) ) ).

tff(addAssignment_84777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143090(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143015(VarCurr,B)
      <=> v143017(VarCurr,B) ) ) ).

tff(addAssignment_84775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143017(VarCurr,B)
      <=> v143019(VarCurr,B) ) ) ).

tff(addAssignment_84774,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143019(VarNext,B)
      <=> v150090(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150091(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150090(VarNext,B)
            <=> v143019(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2206,axiom,
    ! [VarNext: state_type] :
      ( v150091(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150090(VarNext,B)
          <=> v143064(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150091(VarNext)
      <=> v150092(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150092(VarNext)
      <=> ( v150094(VarNext)
          & v143049(VarNext) ) ) ) ).

tff(writeUnaryOperator_11307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150094(VarNext)
      <=> v143058(VarNext) ) ) ).

tff(addAssignment_84773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143029(VarCurr,B)
      <=> v143031(VarCurr,B) ) ) ).

tff(addAssignment_84772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143031(VarCurr,B)
      <=> v143040(VarCurr,B) ) ) ).

tff(addAssignment_84771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v143033(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142958(VarCurr,B)
      <=> v142960(VarCurr,B) ) ) ).

tff(addAssignment_84769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142960(VarCurr,B)
      <=> v142962(VarCurr,B) ) ) ).

tff(addAssignment_84768,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142962(VarNext,B)
      <=> v150082(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150083(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150082(VarNext,B)
            <=> v142962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2205,axiom,
    ! [VarNext: state_type] :
      ( v150083(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150082(VarNext,B)
          <=> v143007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150083(VarNext)
      <=> v150084(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150084(VarNext)
      <=> ( v150086(VarNext)
          & v142992(VarNext) ) ) ) ).

tff(writeUnaryOperator_11306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150086(VarNext)
      <=> v143001(VarNext) ) ) ).

tff(addAssignment_84767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142972(VarCurr,B)
      <=> v142974(VarCurr,B) ) ) ).

tff(addAssignment_84766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142974(VarCurr,B)
      <=> v142983(VarCurr,B) ) ) ).

tff(addAssignment_84765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142976(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142901(VarCurr,B)
      <=> v142903(VarCurr,B) ) ) ).

tff(addAssignment_84763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142903(VarCurr,B)
      <=> v142905(VarCurr,B) ) ) ).

tff(addAssignment_84762,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142905(VarNext,B)
      <=> v150074(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150075(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150074(VarNext,B)
            <=> v142905(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2204,axiom,
    ! [VarNext: state_type] :
      ( v150075(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150074(VarNext,B)
          <=> v142950(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150075(VarNext)
      <=> v150076(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150076(VarNext)
      <=> ( v150078(VarNext)
          & v142935(VarNext) ) ) ) ).

tff(writeUnaryOperator_11305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150078(VarNext)
      <=> v142944(VarNext) ) ) ).

tff(addAssignment_84761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142915(VarCurr,B)
      <=> v142917(VarCurr,B) ) ) ).

tff(addAssignment_84760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142917(VarCurr,B)
      <=> v142926(VarCurr,B) ) ) ).

tff(addAssignment_84759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142919(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142844(VarCurr,B)
      <=> v142846(VarCurr,B) ) ) ).

tff(addAssignment_84757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142846(VarCurr,B)
      <=> v142848(VarCurr,B) ) ) ).

tff(addAssignment_84756,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142848(VarNext,B)
      <=> v150066(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150067(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150066(VarNext,B)
            <=> v142848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2203,axiom,
    ! [VarNext: state_type] :
      ( v150067(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150066(VarNext,B)
          <=> v142893(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150067(VarNext)
      <=> v150068(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150068(VarNext)
      <=> ( v150070(VarNext)
          & v142878(VarNext) ) ) ) ).

tff(writeUnaryOperator_11304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150070(VarNext)
      <=> v142887(VarNext) ) ) ).

tff(addAssignment_84755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142858(VarCurr,B)
      <=> v142860(VarCurr,B) ) ) ).

tff(addAssignment_84754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142860(VarCurr,B)
      <=> v142869(VarCurr,B) ) ) ).

tff(addAssignment_84753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142862(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84752,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142787(VarCurr,B)
      <=> v142789(VarCurr,B) ) ) ).

tff(addAssignment_84751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142789(VarCurr,B)
      <=> v142791(VarCurr,B) ) ) ).

tff(addAssignment_84750,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142791(VarNext,B)
      <=> v150058(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150059(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150058(VarNext,B)
            <=> v142791(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2202,axiom,
    ! [VarNext: state_type] :
      ( v150059(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150058(VarNext,B)
          <=> v142836(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150059(VarNext)
      <=> v150060(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150060(VarNext)
      <=> ( v150062(VarNext)
          & v142821(VarNext) ) ) ) ).

tff(writeUnaryOperator_11303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150062(VarNext)
      <=> v142830(VarNext) ) ) ).

tff(addAssignment_84749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142801(VarCurr,B)
      <=> v142803(VarCurr,B) ) ) ).

tff(addAssignment_84748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142803(VarCurr,B)
      <=> v142812(VarCurr,B) ) ) ).

tff(addAssignment_84747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142805(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142730(VarCurr,B)
      <=> v142732(VarCurr,B) ) ) ).

tff(addAssignment_84745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142732(VarCurr,B)
      <=> v142734(VarCurr,B) ) ) ).

tff(addAssignment_84744,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142734(VarNext,B)
      <=> v150050(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150051(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150050(VarNext,B)
            <=> v142734(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2201,axiom,
    ! [VarNext: state_type] :
      ( v150051(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150050(VarNext,B)
          <=> v142779(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150051(VarNext)
      <=> v150052(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150052(VarNext)
      <=> ( v150054(VarNext)
          & v142764(VarNext) ) ) ) ).

tff(writeUnaryOperator_11302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150054(VarNext)
      <=> v142773(VarNext) ) ) ).

tff(addAssignment_84743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142744(VarCurr,B)
      <=> v142746(VarCurr,B) ) ) ).

tff(addAssignment_84742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142746(VarCurr,B)
      <=> v142755(VarCurr,B) ) ) ).

tff(addAssignment_84741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142748(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142674(VarCurr,B)
      <=> v142676(VarCurr,B) ) ) ).

tff(addAssignment_84739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142676(VarCurr,B)
      <=> v142678(VarCurr,B) ) ) ).

tff(addAssignment_84738,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142678(VarNext,B)
      <=> v150042(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150043(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150042(VarNext,B)
            <=> v142678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2200,axiom,
    ! [VarNext: state_type] :
      ( v150043(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150042(VarNext,B)
          <=> v142723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150043(VarNext)
      <=> v150044(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150044(VarNext)
      <=> ( v150046(VarNext)
          & v142708(VarNext) ) ) ) ).

tff(writeUnaryOperator_11301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150046(VarNext)
      <=> v142717(VarNext) ) ) ).

tff(addAssignment_84737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142688(VarCurr,B)
      <=> v142690(VarCurr,B) ) ) ).

tff(addAssignment_84736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142690(VarCurr,B)
      <=> v142699(VarCurr,B) ) ) ).

tff(addAssignment_84735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142692(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142618(VarCurr,B)
      <=> v142620(VarCurr,B) ) ) ).

tff(addAssignment_84733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142620(VarCurr,B)
      <=> v142622(VarCurr,B) ) ) ).

tff(addAssignment_84732,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142622(VarNext,B)
      <=> v150034(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150035(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150034(VarNext,B)
            <=> v142622(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2199,axiom,
    ! [VarNext: state_type] :
      ( v150035(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150034(VarNext,B)
          <=> v142667(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150035(VarNext)
      <=> v150036(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150036(VarNext)
      <=> ( v150038(VarNext)
          & v142652(VarNext) ) ) ) ).

tff(writeUnaryOperator_11300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150038(VarNext)
      <=> v142661(VarNext) ) ) ).

tff(addAssignment_84731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142632(VarCurr,B)
      <=> v142634(VarCurr,B) ) ) ).

tff(addAssignment_84730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142634(VarCurr,B)
      <=> v142643(VarCurr,B) ) ) ).

tff(addAssignment_84729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142636(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142562(VarCurr,B)
      <=> v142564(VarCurr,B) ) ) ).

tff(addAssignment_84727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142564(VarCurr,B)
      <=> v142566(VarCurr,B) ) ) ).

tff(addAssignment_84726,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142566(VarNext,B)
      <=> v150026(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150027(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150026(VarNext,B)
            <=> v142566(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2198,axiom,
    ! [VarNext: state_type] :
      ( v150027(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150026(VarNext,B)
          <=> v142611(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150027(VarNext)
      <=> v150028(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150028(VarNext)
      <=> ( v150030(VarNext)
          & v142596(VarNext) ) ) ) ).

tff(writeUnaryOperator_11299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150030(VarNext)
      <=> v142605(VarNext) ) ) ).

tff(addAssignment_84725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142576(VarCurr,B)
      <=> v142578(VarCurr,B) ) ) ).

tff(addAssignment_84724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142578(VarCurr,B)
      <=> v142587(VarCurr,B) ) ) ).

tff(addAssignment_84723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142580(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142506(VarCurr,B)
      <=> v142508(VarCurr,B) ) ) ).

tff(addAssignment_84721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142508(VarCurr,B)
      <=> v142510(VarCurr,B) ) ) ).

tff(addAssignment_84720,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142510(VarNext,B)
      <=> v150018(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150019(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150018(VarNext,B)
            <=> v142510(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2197,axiom,
    ! [VarNext: state_type] :
      ( v150019(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150018(VarNext,B)
          <=> v142555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150019(VarNext)
      <=> v150020(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150020(VarNext)
      <=> ( v150022(VarNext)
          & v142540(VarNext) ) ) ) ).

tff(writeUnaryOperator_11298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150022(VarNext)
      <=> v142549(VarNext) ) ) ).

tff(addAssignment_84719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142520(VarCurr,B)
      <=> v142522(VarCurr,B) ) ) ).

tff(addAssignment_84718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142522(VarCurr,B)
      <=> v142531(VarCurr,B) ) ) ).

tff(addAssignment_84717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142524(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142450(VarCurr,B)
      <=> v142452(VarCurr,B) ) ) ).

tff(addAssignment_84715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142452(VarCurr,B)
      <=> v142454(VarCurr,B) ) ) ).

tff(addAssignment_84714,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142454(VarNext,B)
      <=> v150010(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150011(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150010(VarNext,B)
            <=> v142454(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2196,axiom,
    ! [VarNext: state_type] :
      ( v150011(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150010(VarNext,B)
          <=> v142499(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150011(VarNext)
      <=> v150012(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150012(VarNext)
      <=> ( v150014(VarNext)
          & v142484(VarNext) ) ) ) ).

tff(writeUnaryOperator_11297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150014(VarNext)
      <=> v142493(VarNext) ) ) ).

tff(addAssignment_84713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142464(VarCurr,B)
      <=> v142466(VarCurr,B) ) ) ).

tff(addAssignment_84712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142466(VarCurr,B)
      <=> v142475(VarCurr,B) ) ) ).

tff(addAssignment_84711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142468(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142394(VarCurr,B)
      <=> v142396(VarCurr,B) ) ) ).

tff(addAssignment_84709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142396(VarCurr,B)
      <=> v142398(VarCurr,B) ) ) ).

tff(addAssignment_84708,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142398(VarNext,B)
      <=> v150002(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150003(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v150002(VarNext,B)
            <=> v142398(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2195,axiom,
    ! [VarNext: state_type] :
      ( v150003(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v150002(VarNext,B)
          <=> v142443(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150003(VarNext)
      <=> v150004(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v150004(VarNext)
      <=> ( v150006(VarNext)
          & v142428(VarNext) ) ) ) ).

tff(writeUnaryOperator_11296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v150006(VarNext)
      <=> v142437(VarNext) ) ) ).

tff(addAssignment_84707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142408(VarCurr,B)
      <=> v142410(VarCurr,B) ) ) ).

tff(addAssignment_84706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142410(VarCurr,B)
      <=> v142419(VarCurr,B) ) ) ).

tff(addAssignment_84705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142412(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142338(VarCurr,B)
      <=> v142340(VarCurr,B) ) ) ).

tff(addAssignment_84703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142340(VarCurr,B)
      <=> v142342(VarCurr,B) ) ) ).

tff(addAssignment_84702,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142342(VarNext,B)
      <=> v149994(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149995(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149994(VarNext,B)
            <=> v142342(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2194,axiom,
    ! [VarNext: state_type] :
      ( v149995(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149994(VarNext,B)
          <=> v142387(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149995(VarNext)
      <=> v149996(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149996(VarNext)
      <=> ( v149998(VarNext)
          & v142372(VarNext) ) ) ) ).

tff(writeUnaryOperator_11295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149998(VarNext)
      <=> v142381(VarNext) ) ) ).

tff(addAssignment_84701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142352(VarCurr,B)
      <=> v142354(VarCurr,B) ) ) ).

tff(addAssignment_84700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142354(VarCurr,B)
      <=> v142363(VarCurr,B) ) ) ).

tff(addAssignment_84699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142356(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142282(VarCurr,B)
      <=> v142284(VarCurr,B) ) ) ).

tff(addAssignment_84697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142284(VarCurr,B)
      <=> v142286(VarCurr,B) ) ) ).

tff(addAssignment_84696,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142286(VarNext,B)
      <=> v149986(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149987(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149986(VarNext,B)
            <=> v142286(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2193,axiom,
    ! [VarNext: state_type] :
      ( v149987(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149986(VarNext,B)
          <=> v142331(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149987(VarNext)
      <=> v149988(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149988(VarNext)
      <=> ( v149990(VarNext)
          & v142316(VarNext) ) ) ) ).

tff(writeUnaryOperator_11294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149990(VarNext)
      <=> v142325(VarNext) ) ) ).

tff(addAssignment_84695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142296(VarCurr,B)
      <=> v142298(VarCurr,B) ) ) ).

tff(addAssignment_84694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142298(VarCurr,B)
      <=> v142307(VarCurr,B) ) ) ).

tff(addAssignment_84693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142300(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142226(VarCurr,B)
      <=> v142228(VarCurr,B) ) ) ).

tff(addAssignment_84691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142228(VarCurr,B)
      <=> v142230(VarCurr,B) ) ) ).

tff(addAssignment_84690,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142230(VarNext,B)
      <=> v149978(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149979(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149978(VarNext,B)
            <=> v142230(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2192,axiom,
    ! [VarNext: state_type] :
      ( v149979(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149978(VarNext,B)
          <=> v142275(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149979(VarNext)
      <=> v149980(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149980(VarNext)
      <=> ( v149982(VarNext)
          & v142260(VarNext) ) ) ) ).

tff(writeUnaryOperator_11293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149982(VarNext)
      <=> v142269(VarNext) ) ) ).

tff(addAssignment_84689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142240(VarCurr,B)
      <=> v142242(VarCurr,B) ) ) ).

tff(addAssignment_84688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142242(VarCurr,B)
      <=> v142251(VarCurr,B) ) ) ).

tff(addAssignment_84687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142244(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142170(VarCurr,B)
      <=> v142172(VarCurr,B) ) ) ).

tff(addAssignment_84685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142172(VarCurr,B)
      <=> v142174(VarCurr,B) ) ) ).

tff(addAssignment_84684,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142174(VarNext,B)
      <=> v149970(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149971(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149970(VarNext,B)
            <=> v142174(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2191,axiom,
    ! [VarNext: state_type] :
      ( v149971(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149970(VarNext,B)
          <=> v142219(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149971(VarNext)
      <=> v149972(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149972(VarNext)
      <=> ( v149974(VarNext)
          & v142204(VarNext) ) ) ) ).

tff(writeUnaryOperator_11292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149974(VarNext)
      <=> v142213(VarNext) ) ) ).

tff(addAssignment_84683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142184(VarCurr,B)
      <=> v142186(VarCurr,B) ) ) ).

tff(addAssignment_84682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142186(VarCurr,B)
      <=> v142195(VarCurr,B) ) ) ).

tff(addAssignment_84681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142188(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142114(VarCurr,B)
      <=> v142116(VarCurr,B) ) ) ).

tff(addAssignment_84679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142116(VarCurr,B)
      <=> v142118(VarCurr,B) ) ) ).

tff(addAssignment_84678,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142118(VarNext,B)
      <=> v149962(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149963(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149962(VarNext,B)
            <=> v142118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2190,axiom,
    ! [VarNext: state_type] :
      ( v149963(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149962(VarNext,B)
          <=> v142163(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149963(VarNext)
      <=> v149964(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149964(VarNext)
      <=> ( v149966(VarNext)
          & v142148(VarNext) ) ) ) ).

tff(writeUnaryOperator_11291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149966(VarNext)
      <=> v142157(VarNext) ) ) ).

tff(addAssignment_84677,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142128(VarCurr,B)
      <=> v142130(VarCurr,B) ) ) ).

tff(addAssignment_84676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142130(VarCurr,B)
      <=> v142139(VarCurr,B) ) ) ).

tff(addAssignment_84675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142132(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142058(VarCurr,B)
      <=> v142060(VarCurr,B) ) ) ).

tff(addAssignment_84673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142060(VarCurr,B)
      <=> v142062(VarCurr,B) ) ) ).

tff(addAssignment_84672,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142062(VarNext,B)
      <=> v149954(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149955(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149954(VarNext,B)
            <=> v142062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2189,axiom,
    ! [VarNext: state_type] :
      ( v149955(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149954(VarNext,B)
          <=> v142107(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149955(VarNext)
      <=> v149956(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149956(VarNext)
      <=> ( v149958(VarNext)
          & v142092(VarNext) ) ) ) ).

tff(writeUnaryOperator_11290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149958(VarNext)
      <=> v142101(VarNext) ) ) ).

tff(addAssignment_84671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142072(VarCurr,B)
      <=> v142074(VarCurr,B) ) ) ).

tff(addAssignment_84670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142074(VarCurr,B)
      <=> v142083(VarCurr,B) ) ) ).

tff(addAssignment_84669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142076(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142002(VarCurr,B)
      <=> v142004(VarCurr,B) ) ) ).

tff(addAssignment_84667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142004(VarCurr,B)
      <=> v142006(VarCurr,B) ) ) ).

tff(addAssignment_84666,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142006(VarNext,B)
      <=> v149946(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149946(VarNext,B)
            <=> v142006(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2188,axiom,
    ! [VarNext: state_type] :
      ( v149947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149946(VarNext,B)
          <=> v142051(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149947(VarNext)
      <=> v149948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149948(VarNext)
      <=> ( v149950(VarNext)
          & v142036(VarNext) ) ) ) ).

tff(writeUnaryOperator_11289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149950(VarNext)
      <=> v142045(VarNext) ) ) ).

tff(addAssignment_84665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142016(VarCurr,B)
      <=> v142018(VarCurr,B) ) ) ).

tff(addAssignment_84664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142018(VarCurr,B)
      <=> v142027(VarCurr,B) ) ) ).

tff(addAssignment_84663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v142020(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141946(VarCurr,B)
      <=> v141948(VarCurr,B) ) ) ).

tff(addAssignment_84661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141948(VarCurr,B)
      <=> v141950(VarCurr,B) ) ) ).

tff(addAssignment_84660,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141950(VarNext,B)
      <=> v149938(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149939(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149938(VarNext,B)
            <=> v141950(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2187,axiom,
    ! [VarNext: state_type] :
      ( v149939(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149938(VarNext,B)
          <=> v141995(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149939(VarNext)
      <=> v149940(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149940(VarNext)
      <=> ( v149942(VarNext)
          & v141980(VarNext) ) ) ) ).

tff(writeUnaryOperator_11288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149942(VarNext)
      <=> v141989(VarNext) ) ) ).

tff(addAssignment_84659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141960(VarCurr,B)
      <=> v141962(VarCurr,B) ) ) ).

tff(addAssignment_84658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141962(VarCurr,B)
      <=> v141971(VarCurr,B) ) ) ).

tff(addAssignment_84657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141964(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141890(VarCurr,B)
      <=> v141892(VarCurr,B) ) ) ).

tff(addAssignment_84655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141892(VarCurr,B)
      <=> v141894(VarCurr,B) ) ) ).

tff(addAssignment_84654,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141894(VarNext,B)
      <=> v149930(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149931(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149930(VarNext,B)
            <=> v141894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2186,axiom,
    ! [VarNext: state_type] :
      ( v149931(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149930(VarNext,B)
          <=> v141939(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149931(VarNext)
      <=> v149932(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149932(VarNext)
      <=> ( v149934(VarNext)
          & v141924(VarNext) ) ) ) ).

tff(writeUnaryOperator_11287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149934(VarNext)
      <=> v141933(VarNext) ) ) ).

tff(addAssignment_84653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141904(VarCurr,B)
      <=> v141906(VarCurr,B) ) ) ).

tff(addAssignment_84652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141906(VarCurr,B)
      <=> v141915(VarCurr,B) ) ) ).

tff(addAssignment_84651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141908(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_84650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2302(VarCurr,B)
      <=> v2304(VarCurr,B) ) ) ).

tff(addAssignment_84649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2304(VarCurr,B)
      <=> v2306(VarCurr,B) ) ) ).

tff(addAssignment_84648,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2306(VarNext,B)
      <=> v149922(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149923(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v149922(VarNext,B)
            <=> v2306(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2185,axiom,
    ! [VarNext: state_type] :
      ( v149923(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v149922(VarNext,B)
          <=> v141883(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149923(VarNext)
      <=> v149924(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149924(VarNext)
      <=> ( v149926(VarNext)
          & v141868(VarNext) ) ) ) ).

tff(writeUnaryOperator_11286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149926(VarNext)
      <=> v141877(VarNext) ) ) ).

tff(addAssignment_84647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2316(VarCurr,B)
      <=> v2318(VarCurr,B) ) ) ).

tff(addAssignment_84646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2318(VarCurr,B)
      <=> v141859(VarCurr,B) ) ) ).

tff(addAssignment_84645,axiom,
    ! [VarCurr: state_type] :
      ( v2809(VarCurr)
    <=> v2811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19804,axiom,
    ! [VarCurr: state_type] :
      ( v2811(VarCurr)
    <=> ( v149920(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2312,axiom,
    ! [VarCurr: state_type] :
      ( v149920(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_84644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2813(VarCurr,B)
      <=> v2815(VarCurr,B) ) ) ).

tff(addAssignment_84643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2815(VarCurr,B)
      <=> v2817(VarCurr,B) ) ) ).

tff(addAssignment_84642,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2817(VarNext,B)
      <=> v149902(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149903(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v149902(VarNext,B)
            <=> v2817(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2184,axiom,
    ! [VarNext: state_type] :
      ( v149903(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v149902(VarNext,B)
          <=> v149913(VarNext,B) ) ) ) ).

tff(addAssignment_84641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v149913(VarNext,B)
          <=> v149911(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149914(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v149911(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1645,axiom,
    ! [VarCurr: state_type] :
      ( v149914(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v149911(VarCurr,B)
          <=> v2827(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19803,axiom,
    ! [VarCurr: state_type] :
      ( v149914(VarCurr)
    <=> ( v149915(VarCurr)
        & v149916(VarCurr) ) ) ).

tff(writeUnaryOperator_11285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149916(VarCurr)
    <=> v2823(VarCurr) ) ).

tff(writeUnaryOperator_11284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149915(VarCurr)
    <=> v2819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149903(VarNext)
      <=> v149904(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149904(VarNext)
      <=> ( v149905(VarNext)
          & v149898(VarNext) ) ) ) ).

tff(writeUnaryOperator_11283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149905(VarNext)
      <=> v149907(VarNext) ) ) ).

tff(addAssignment_84640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149907(VarNext)
      <=> v149898(VarCurr) ) ) ).

tff(addAssignment_84639,axiom,
    ! [VarCurr: state_type] :
      ( v149898(VarCurr)
    <=> v149900(VarCurr) ) ).

tff(addAssignment_84638,axiom,
    ! [VarCurr: state_type] :
      ( v149900(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_84637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2827(VarCurr,B)
      <=> v2829(VarCurr,B) ) ) ).

tff(addAssignment_84636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2829(VarCurr,B)
      <=> v149889(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v149889(VarCurr,B)
      <=> ( v149890(VarCurr,B)
          | v149893(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v149893(VarCurr,B)
      <=> ( v2815(VarCurr,B)
          & v149894(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_11282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v149894(VarCurr,B)
      <=> ~ v149895(VarCurr,B) ) ) ).

tff(addAssignment_84635,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,0)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84634,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,1)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84633,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,2)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84632,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,3)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84631,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,4)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84630,axiom,
    ! [VarCurr: state_type] :
      ( v149895(VarCurr,5)
    <=> v149896(VarCurr) ) ).

tff(addAssignment_84629,axiom,
    ! [VarCurr: state_type] :
      ( v149896(VarCurr)
    <=> v2866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v149890(VarCurr,B)
      <=> ( v2831(VarCurr,B)
          & v149891(VarCurr,B) ) ) ) ).

tff(addAssignment_84628,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,0)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84627,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,1)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84626,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,2)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84625,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,3)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84624,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,4)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84623,axiom,
    ! [VarCurr: state_type] :
      ( v149891(VarCurr,5)
    <=> v149892(VarCurr) ) ).

tff(addAssignment_84622,axiom,
    ! [VarCurr: state_type] :
      ( v149892(VarCurr)
    <=> v2866(VarCurr) ) ).

tff(addAssignment_84621,axiom,
    ! [VarCurr: state_type] :
      ( v2866(VarCurr)
    <=> v2868(VarCurr) ) ).

tff(addAssignment_84620,axiom,
    ! [VarCurr: state_type] :
      ( v2868(VarCurr)
    <=> v2870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19800,axiom,
    ! [VarCurr: state_type] :
      ( v2870(VarCurr)
    <=> ( v149880(VarCurr)
        | v89669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19799,axiom,
    ! [VarCurr: state_type] :
      ( v149880(VarCurr)
    <=> ( v149881(VarCurr)
        | v4516(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19798,axiom,
    ! [VarCurr: state_type] :
      ( v149881(VarCurr)
    <=> ( v149882(VarCurr)
        | v141763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19797,axiom,
    ! [VarCurr: state_type] :
      ( v149882(VarCurr)
    <=> ( v149883(VarCurr)
        | v149888(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2311,axiom,
    ! [VarCurr: state_type] :
      ( v149888(VarCurr)
    <=> ( ( v141749(VarCurr,2)
        <=> $false )
        & ( v141749(VarCurr,1)
        <=> $true )
        & ( v141749(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19796,axiom,
    ! [VarCurr: state_type] :
      ( v149883(VarCurr)
    <=> ( v149884(VarCurr)
        | v149887(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2310,axiom,
    ! [VarCurr: state_type] :
      ( v149887(VarCurr)
    <=> ( ( v141737(VarCurr,2)
        <=> $false )
        & ( v141737(VarCurr,1)
        <=> $true )
        & ( v141737(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19795,axiom,
    ! [VarCurr: state_type] :
      ( v149884(VarCurr)
    <=> ( v149885(VarCurr)
        | v149886(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2309,axiom,
    ! [VarCurr: state_type] :
      ( v149886(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $true )
        & ( v2872(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2308,axiom,
    ! [VarCurr: state_type] :
      ( v149885(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $true )
        & ( v2872(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_84619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v2872(VarCurr,B)
      <=> v2874(VarCurr,B) ) ) ).

tff(addAssignment_84618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v2874(VarCurr,B)
      <=> v2876(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v2876(VarCurr,B)
          <=> v149873(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1644,axiom,
    ! [VarCurr: state_type] :
      ( v2878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v2876(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addZeroExtensionConstraint_56,axiom,
    ! [VarCurr: state_type] : ~ v149873(VarCurr,2) ).

tff(addAssignment_84617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v149873(VarCurr,B)
      <=> v149874(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v149874(VarCurr,B)
          <=> v149876(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1643,axiom,
    ! [VarCurr: state_type] :
      ( v149875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v149874(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v149876(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1642,axiom,
    ! [VarCurr: state_type] :
      ( v149877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v149876(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19794,axiom,
    ! [VarCurr: state_type] :
      ( v149877(VarCurr)
    <=> ( v126727(VarCurr)
        & v149878(VarCurr) ) ) ).

tff(writeUnaryOperator_11281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149878(VarCurr)
    <=> v149763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19793,axiom,
    ! [VarCurr: state_type] :
      ( v149875(VarCurr)
    <=> ( v126727(VarCurr)
        & v149763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19792,axiom,
    ! [VarCurr: state_type] :
      ( v149763(VarCurr)
    <=> ( v149765(VarCurr)
        & v149817(VarCurr) ) ) ).

tff(addAssignment_84616,axiom,
    ! [VarCurr: state_type] :
      ( v149817(VarCurr)
    <=> v149819(VarCurr) ) ).

tff(addAssignment_84615,axiom,
    ! [VarCurr: state_type] :
      ( v149819(VarCurr)
    <=> v149821(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149855(VarNext)
       => ( v149821(VarNext)
        <=> v149821(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2183,axiom,
    ! [VarNext: state_type] :
      ( v149855(VarNext)
     => ( v149821(VarNext)
      <=> v149865(VarNext) ) ) ).

tff(addAssignment_84614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149865(VarNext)
      <=> v149863(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149866(VarCurr)
     => ( v149863(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1641,axiom,
    ! [VarCurr: state_type] :
      ( v149866(VarCurr)
     => ( v149863(VarCurr)
      <=> v149831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19791,axiom,
    ! [VarCurr: state_type] :
      ( v149866(VarCurr)
    <=> ( v149867(VarCurr)
        & v149868(VarCurr) ) ) ).

tff(writeUnaryOperator_11280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149868(VarCurr)
    <=> v149827(VarCurr) ) ).

tff(writeUnaryOperator_11279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149867(VarCurr)
    <=> v149823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149855(VarNext)
      <=> v149856(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149856(VarNext)
      <=> ( v149857(VarNext)
          & v149850(VarNext) ) ) ) ).

tff(writeUnaryOperator_11278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149857(VarNext)
      <=> v149859(VarNext) ) ) ).

tff(addAssignment_84613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149859(VarNext)
      <=> v149850(VarCurr) ) ) ).

tff(addAssignment_84612,axiom,
    ! [VarCurr: state_type] :
      ( v149850(VarCurr)
    <=> v149852(VarCurr) ) ).

tff(addAssignment_84611,axiom,
    ! [VarCurr: state_type] :
      ( v149852(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_84610,axiom,
    ! [VarCurr: state_type] :
      ( v149831(VarCurr)
    <=> v149833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19788,axiom,
    ! [VarCurr: state_type] :
      ( v149833(VarCurr)
    <=> ( v149842(VarCurr)
        | v149845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19787,axiom,
    ! [VarCurr: state_type] :
      ( v149845(VarCurr)
    <=> ( v149819(VarCurr)
        & v149846(VarCurr) ) ) ).

tff(writeUnaryOperator_11277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149846(VarCurr)
    <=> v149847(VarCurr) ) ).

tff(addAssignment_84609,axiom,
    ! [VarCurr: state_type] :
      ( v149847(VarCurr)
    <=> v149848(VarCurr) ) ).

tff(addAssignment_84608,axiom,
    ! [VarCurr: state_type] :
      ( v149848(VarCurr)
    <=> v149840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19786,axiom,
    ! [VarCurr: state_type] :
      ( v149842(VarCurr)
    <=> ( v149835(VarCurr)
        & v149843(VarCurr) ) ) ).

tff(addAssignment_84607,axiom,
    ! [VarCurr: state_type] :
      ( v149843(VarCurr)
    <=> v149844(VarCurr) ) ).

tff(addAssignment_84606,axiom,
    ! [VarCurr: state_type] :
      ( v149844(VarCurr)
    <=> v149840(VarCurr) ) ).

tff(addAssignment_84605,axiom,
    ! [VarCurr: state_type] :
      ( v149840(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_84604,axiom,
    ! [VarCurr: state_type] :
      ( v149835(VarCurr)
    <=> v149837(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6962,axiom,
    ! [VarCurr: state_type] :
      ( v149837(VarCurr)
    <=> ( v110699(VarCurr)
        | v108899(VarCurr,15) ) ) ).

tff(addAssignment_84603,axiom,
    ! [VarCurr: state_type] :
      ( v149827(VarCurr)
    <=> v149829(VarCurr) ) ).

tff(addAssignment_84602,axiom,
    ! [VarCurr: state_type] :
      ( v149829(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_84601,axiom,
    ! [VarCurr: state_type] :
      ( v149823(VarCurr)
    <=> v149825(VarCurr) ) ).

tff(addAssignment_84600,axiom,
    ! [VarCurr: state_type] :
      ( v149825(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_84599,axiom,
    ! [VarCurr: state_type] :
      ( v149765(VarCurr)
    <=> v149767(VarCurr) ) ).

tff(addAssignment_84598,axiom,
    ! [VarCurr: state_type] :
      ( v149767(VarCurr)
    <=> v149769(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149800(VarNext)
       => ( v149769(VarNext)
        <=> v149769(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2182,axiom,
    ! [VarNext: state_type] :
      ( v149800(VarNext)
     => ( v149769(VarNext)
      <=> v149810(VarNext) ) ) ).

tff(addAssignment_84597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149810(VarNext)
      <=> v149808(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149811(VarCurr)
     => ( v149808(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1640,axiom,
    ! [VarCurr: state_type] :
      ( v149811(VarCurr)
     => ( v149808(VarCurr)
      <=> v149779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19785,axiom,
    ! [VarCurr: state_type] :
      ( v149811(VarCurr)
    <=> ( v149812(VarCurr)
        & v149813(VarCurr) ) ) ).

tff(writeUnaryOperator_11276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149813(VarCurr)
    <=> v149775(VarCurr) ) ).

tff(writeUnaryOperator_11275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149812(VarCurr)
    <=> v149771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149800(VarNext)
      <=> v149801(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149801(VarNext)
      <=> ( v149802(VarNext)
          & v149795(VarNext) ) ) ) ).

tff(writeUnaryOperator_11274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149802(VarNext)
      <=> v149804(VarNext) ) ) ).

tff(addAssignment_84596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149804(VarNext)
      <=> v149795(VarCurr) ) ) ).

tff(addAssignment_84595,axiom,
    ! [VarCurr: state_type] :
      ( v149795(VarCurr)
    <=> v149797(VarCurr) ) ).

tff(addAssignment_84594,axiom,
    ! [VarCurr: state_type] :
      ( v149797(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_84593,axiom,
    ! [VarCurr: state_type] :
      ( v149779(VarCurr)
    <=> v149781(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19782,axiom,
    ! [VarCurr: state_type] :
      ( v149781(VarCurr)
    <=> ( v149787(VarCurr)
        | v149790(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19781,axiom,
    ! [VarCurr: state_type] :
      ( v149790(VarCurr)
    <=> ( v149767(VarCurr)
        & v149791(VarCurr) ) ) ).

tff(writeUnaryOperator_11273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149791(VarCurr)
    <=> v149792(VarCurr) ) ).

tff(addAssignment_84592,axiom,
    ! [VarCurr: state_type] :
      ( v149792(VarCurr)
    <=> v149793(VarCurr) ) ).

tff(addAssignment_84591,axiom,
    ! [VarCurr: state_type] :
      ( v149793(VarCurr)
    <=> v149785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19780,axiom,
    ! [VarCurr: state_type] :
      ( v149787(VarCurr)
    <=> ( v149783(VarCurr)
        & v149788(VarCurr) ) ) ).

tff(addAssignment_84590,axiom,
    ! [VarCurr: state_type] :
      ( v149788(VarCurr)
    <=> v149789(VarCurr) ) ).

tff(addAssignment_84589,axiom,
    ! [VarCurr: state_type] :
      ( v149789(VarCurr)
    <=> v149785(VarCurr) ) ).

tff(addAssignment_84588,axiom,
    ! [VarCurr: state_type] :
      ( v149785(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_84587,axiom,
    ! [VarCurr: state_type] :
      ( v149783(VarCurr)
    <=> v83072(VarCurr) ) ).

tff(addAssignment_84586,axiom,
    ! [VarCurr: state_type] :
      ( v149775(VarCurr)
    <=> v149777(VarCurr) ) ).

tff(addAssignment_84585,axiom,
    ! [VarCurr: state_type] :
      ( v149777(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_84584,axiom,
    ! [VarCurr: state_type] :
      ( v149771(VarCurr)
    <=> v149773(VarCurr) ) ).

tff(addAssignment_84583,axiom,
    ! [VarCurr: state_type] :
      ( v149773(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_84582,axiom,
    ! [VarCurr: state_type] :
      ( v2878(VarCurr)
    <=> v2880(VarCurr,2) ) ).

tff(addAssignment_84581,axiom,
    ! [VarCurr: state_type] :
      ( v2880(VarCurr,2)
    <=> v2882(VarCurr,2) ) ).

tff(addAssignment_84580,axiom,
    ! [VarNext: state_type] :
      ( v2882(VarNext,2)
    <=> v149755(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149756(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v149755(VarNext,B)
            <=> v2882(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2181,axiom,
    ! [VarNext: state_type] :
      ( v149756(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v149755(VarNext,B)
          <=> v112511(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149756(VarNext)
      <=> v149757(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149757(VarNext)
      <=> ( v149759(VarNext)
          & v112496(VarNext) ) ) ) ).

tff(writeUnaryOperator_11272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149759(VarNext)
      <=> v112505(VarNext) ) ) ).

tff(addAssignment_84579,axiom,
    ! [VarCurr: state_type] :
      ( v2892(VarCurr,2)
    <=> v2894(VarCurr,2) ) ).

tff(addAssignment_84578,axiom,
    ! [VarCurr: state_type] :
      ( v2894(VarCurr,2)
    <=> v112487(VarCurr,2) ) ).

tff(addAssignment_84577,axiom,
    ! [VarCurr: state_type] :
      ( v2896(VarCurr,2)
    <=> v112484(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19777,axiom,
    ! [VarCurr: state_type] :
      ( v2898(VarCurr)
    <=> ( v149746(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19776,axiom,
    ! [VarCurr: state_type] :
      ( v149746(VarCurr)
    <=> ( v149747(VarCurr)
        | v82954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19775,axiom,
    ! [VarCurr: state_type] :
      ( v149747(VarCurr)
    <=> ( v149748(VarCurr)
        | v86877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19774,axiom,
    ! [VarCurr: state_type] :
      ( v149748(VarCurr)
    <=> ( v149749(VarCurr)
        | v101501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19773,axiom,
    ! [VarCurr: state_type] :
      ( v149749(VarCurr)
    <=> ( v149750(VarCurr)
        | v149752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19772,axiom,
    ! [VarCurr: state_type] :
      ( v149752(VarCurr)
    <=> ( v84899(VarCurr)
        & v149753(VarCurr) ) ) ).

tff(writeUnaryOperator_11271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149753(VarCurr)
    <=> v89409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19771,axiom,
    ! [VarCurr: state_type] :
      ( v149750(VarCurr)
    <=> ( v118(VarCurr)
        & v149751(VarCurr) ) ) ).

tff(writeUnaryOperator_11270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149751(VarCurr)
    <=> v2900(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6961,axiom,
    ! [VarCurr: state_type] :
      ( v2900(VarCurr)
    <=> ( v149739(VarCurr)
        | v2902(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6960,axiom,
    ! [VarCurr: state_type] :
      ( v149739(VarCurr)
    <=> ( v149740(VarCurr)
        | v2902(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6959,axiom,
    ! [VarCurr: state_type] :
      ( v149740(VarCurr)
    <=> ( v149741(VarCurr)
        | v2902(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6958,axiom,
    ! [VarCurr: state_type] :
      ( v149741(VarCurr)
    <=> ( v149742(VarCurr)
        | v2902(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6957,axiom,
    ! [VarCurr: state_type] :
      ( v149742(VarCurr)
    <=> ( v149743(VarCurr)
        | v2902(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6956,axiom,
    ! [VarCurr: state_type] :
      ( v149743(VarCurr)
    <=> ( v149744(VarCurr)
        | v2902(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6955,axiom,
    ! [VarCurr: state_type] :
      ( v149744(VarCurr)
    <=> ( v2902(VarCurr,0)
        | v2902(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2902(VarCurr,B)
      <=> ( v2904(VarCurr,B)
          & v149736(VarCurr,B) ) ) ) ).

tff(addAssignment_84576,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,0)
    <=> v149577(VarCurr) ) ).

tff(addAssignment_84575,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,1)
    <=> v149418(VarCurr) ) ).

tff(addAssignment_84574,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,2)
    <=> v149259(VarCurr) ) ).

tff(addAssignment_84573,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,3)
    <=> v149100(VarCurr) ) ).

tff(addAssignment_84572,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,4)
    <=> v148941(VarCurr) ) ).

tff(addAssignment_84571,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,5)
    <=> v148782(VarCurr) ) ).

tff(addAssignment_84570,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,6)
    <=> v148623(VarCurr) ) ).

tff(addAssignment_84569,axiom,
    ! [VarCurr: state_type] :
      ( v149736(VarCurr,7)
    <=> v146577(VarCurr) ) ).

tff(addAssignment_84568,axiom,
    ! [VarCurr: state_type] :
      ( v149577(VarCurr)
    <=> v149579(VarCurr) ) ).

tff(addAssignment_84567,axiom,
    ! [VarCurr: state_type] :
      ( v149579(VarCurr)
    <=> v149581(VarCurr) ) ).

tff(addAssignment_84566,axiom,
    ! [VarCurr: state_type] :
      ( v149581(VarCurr)
    <=> v149583(VarCurr) ) ).

tff(addAssignment_84565,axiom,
    ! [VarCurr: state_type] :
      ( v149583(VarCurr)
    <=> v149585(VarCurr) ) ).

tff(addAssignment_84564,axiom,
    ! [VarCurr: state_type] :
      ( v149585(VarCurr)
    <=> v149587(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2307,axiom,
    ! [VarCurr: state_type] :
      ( v149587(VarCurr)
    <=> ( ( v149589(VarCurr,31)
        <=> v149594(VarCurr,31) )
        & ( v149589(VarCurr,30)
        <=> v149594(VarCurr,30) )
        & ( v149589(VarCurr,29)
        <=> v149594(VarCurr,29) )
        & ( v149589(VarCurr,28)
        <=> v149594(VarCurr,28) )
        & ( v149589(VarCurr,27)
        <=> v149594(VarCurr,27) )
        & ( v149589(VarCurr,26)
        <=> v149594(VarCurr,26) )
        & ( v149589(VarCurr,25)
        <=> v149594(VarCurr,25) )
        & ( v149589(VarCurr,24)
        <=> v149594(VarCurr,24) )
        & ( v149589(VarCurr,23)
        <=> v149594(VarCurr,23) )
        & ( v149589(VarCurr,22)
        <=> v149594(VarCurr,22) )
        & ( v149589(VarCurr,21)
        <=> v149594(VarCurr,21) )
        & ( v149589(VarCurr,20)
        <=> v149594(VarCurr,20) )
        & ( v149589(VarCurr,19)
        <=> v149594(VarCurr,19) )
        & ( v149589(VarCurr,18)
        <=> v149594(VarCurr,18) )
        & ( v149589(VarCurr,17)
        <=> v149594(VarCurr,17) )
        & ( v149589(VarCurr,16)
        <=> v149594(VarCurr,16) )
        & ( v149589(VarCurr,15)
        <=> v149594(VarCurr,15) )
        & ( v149589(VarCurr,14)
        <=> v149594(VarCurr,14) )
        & ( v149589(VarCurr,13)
        <=> v149594(VarCurr,13) )
        & ( v149589(VarCurr,12)
        <=> v149594(VarCurr,12) )
        & ( v149589(VarCurr,11)
        <=> v149594(VarCurr,11) )
        & ( v149589(VarCurr,10)
        <=> v149594(VarCurr,10) )
        & ( v149589(VarCurr,9)
        <=> v149594(VarCurr,9) )
        & ( v149589(VarCurr,8)
        <=> v149594(VarCurr,8) )
        & ( v149589(VarCurr,7)
        <=> v149594(VarCurr,7) )
        & ( v149589(VarCurr,6)
        <=> v149594(VarCurr,6) )
        & ( v149589(VarCurr,5)
        <=> v149594(VarCurr,5) )
        & ( v149589(VarCurr,4)
        <=> v149594(VarCurr,4) )
        & ( v149589(VarCurr,3)
        <=> v149594(VarCurr,3) )
        & ( v149589(VarCurr,2)
        <=> v149594(VarCurr,2) )
        & ( v149589(VarCurr,1)
        <=> v149594(VarCurr,1) )
        & ( v149589(VarCurr,0)
        <=> v149594(VarCurr,0) ) ) ) ).

tff(addAssignment_84563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149594(VarCurr,B)
      <=> v149596(VarCurr,B) ) ) ).

tff(addAssignment_84562,axiom,
    ! [VarCurr: state_type] :
      ( ( v149596(VarCurr,8)
      <=> v149724(VarCurr,10) )
      & ( v149596(VarCurr,7)
      <=> v149724(VarCurr,9) )
      & ( v149596(VarCurr,6)
      <=> v149724(VarCurr,8) )
      & ( v149596(VarCurr,5)
      <=> v149724(VarCurr,7) )
      & ( v149596(VarCurr,4)
      <=> v149724(VarCurr,6) )
      & ( v149596(VarCurr,3)
      <=> v149724(VarCurr,5) )
      & ( v149596(VarCurr,2)
      <=> v149724(VarCurr,4) )
      & ( v149596(VarCurr,1)
      <=> v149724(VarCurr,3) )
      & ( v149596(VarCurr,0)
      <=> v149724(VarCurr,2) ) ) ).

tff(addAssignment_84561,axiom,
    ! [VarCurr: state_type] :
      ( ( v149596(VarCurr,23)
      <=> v149714(VarCurr,14) )
      & ( v149596(VarCurr,22)
      <=> v149714(VarCurr,13) )
      & ( v149596(VarCurr,21)
      <=> v149714(VarCurr,12) )
      & ( v149596(VarCurr,20)
      <=> v149714(VarCurr,11) )
      & ( v149596(VarCurr,19)
      <=> v149714(VarCurr,10) )
      & ( v149596(VarCurr,18)
      <=> v149714(VarCurr,9) )
      & ( v149596(VarCurr,17)
      <=> v149714(VarCurr,8) )
      & ( v149596(VarCurr,16)
      <=> v149714(VarCurr,7) )
      & ( v149596(VarCurr,15)
      <=> v149714(VarCurr,6) )
      & ( v149596(VarCurr,14)
      <=> v149714(VarCurr,5) )
      & ( v149596(VarCurr,13)
      <=> v149714(VarCurr,4) )
      & ( v149596(VarCurr,12)
      <=> v149714(VarCurr,3) )
      & ( v149596(VarCurr,11)
      <=> v149714(VarCurr,2) )
      & ( v149596(VarCurr,10)
      <=> v149714(VarCurr,1) )
      & ( v149596(VarCurr,9)
      <=> v149714(VarCurr,0) ) ) ).

tff(addAssignment_84560,axiom,
    ! [VarCurr: state_type] :
      ( ( v149596(VarCurr,26)
      <=> v149704(VarCurr,2) )
      & ( v149596(VarCurr,25)
      <=> v149704(VarCurr,1) )
      & ( v149596(VarCurr,24)
      <=> v149704(VarCurr,0) ) ) ).

tff(addAssignment_84559,axiom,
    ! [VarCurr: state_type] :
      ( ( v149596(VarCurr,30)
      <=> v149598(VarCurr,3) )
      & ( v149596(VarCurr,29)
      <=> v149598(VarCurr,2) )
      & ( v149596(VarCurr,28)
      <=> v149598(VarCurr,1) )
      & ( v149596(VarCurr,27)
      <=> v149598(VarCurr,0) ) ) ).

tff(addAssignment_84558,axiom,
    ! [VarCurr: state_type] :
      ( v149596(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149724(VarCurr,B)
      <=> v149600(VarCurr,B) ) ) ).

tff(addAssignment_84556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149600(VarCurr,B)
      <=> v149602(VarCurr,B) ) ) ).

tff(addAssignment_84555,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149602(VarNext,B)
      <=> v149726(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149727(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149726(VarNext,B)
            <=> v149602(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2180,axiom,
    ! [VarNext: state_type] :
      ( v149727(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149726(VarNext,B)
          <=> v149697(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149727(VarNext)
      <=> v149728(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149728(VarNext)
      <=> ( v149730(VarNext)
          & v149629(VarNext) ) ) ) ).

tff(writeUnaryOperator_11269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149730(VarNext)
      <=> v149691(VarNext) ) ) ).

tff(addAssignment_84554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149624(VarCurr,B)
      <=> v149626(VarCurr,B) ) ) ).

tff(addAssignment_84553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149626(VarCurr,B)
      <=> v149627(VarCurr,B) ) ) ).

tff(addAssignment_84552,axiom,
    ! [VarCurr: state_type] :
      ( ( v149714(VarCurr,14)
      <=> v149600(VarCurr,25) )
      & ( v149714(VarCurr,13)
      <=> v149600(VarCurr,24) )
      & ( v149714(VarCurr,12)
      <=> v149600(VarCurr,23) )
      & ( v149714(VarCurr,11)
      <=> v149600(VarCurr,22) )
      & ( v149714(VarCurr,10)
      <=> v149600(VarCurr,21) )
      & ( v149714(VarCurr,9)
      <=> v149600(VarCurr,20) )
      & ( v149714(VarCurr,8)
      <=> v149600(VarCurr,19) )
      & ( v149714(VarCurr,7)
      <=> v149600(VarCurr,18) )
      & ( v149714(VarCurr,6)
      <=> v149600(VarCurr,17) )
      & ( v149714(VarCurr,5)
      <=> v149600(VarCurr,16) )
      & ( v149714(VarCurr,4)
      <=> v149600(VarCurr,15) )
      & ( v149714(VarCurr,3)
      <=> v149600(VarCurr,14) )
      & ( v149714(VarCurr,2)
      <=> v149600(VarCurr,13) )
      & ( v149714(VarCurr,1)
      <=> v149600(VarCurr,12) )
      & ( v149714(VarCurr,0)
      <=> v149600(VarCurr,11) ) ) ).

tff(addAssignment_84551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149600(VarCurr,B)
      <=> v149602(VarCurr,B) ) ) ).

tff(addAssignment_84550,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149602(VarNext,B)
      <=> v149716(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149717(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149716(VarNext,B)
            <=> v149602(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2179,axiom,
    ! [VarNext: state_type] :
      ( v149717(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149716(VarNext,B)
          <=> v149697(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149717(VarNext)
      <=> v149718(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149718(VarNext)
      <=> ( v149720(VarNext)
          & v149629(VarNext) ) ) ) ).

tff(writeUnaryOperator_11268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149720(VarNext)
      <=> v149691(VarNext) ) ) ).

tff(addAssignment_84549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149624(VarCurr,B)
      <=> v149626(VarCurr,B) ) ) ).

tff(addAssignment_84548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149626(VarCurr,B)
      <=> v149627(VarCurr,B) ) ) ).

tff(addAssignment_84547,axiom,
    ! [VarCurr: state_type] :
      ( ( v149704(VarCurr,2)
      <=> v149600(VarCurr,28) )
      & ( v149704(VarCurr,1)
      <=> v149600(VarCurr,27) )
      & ( v149704(VarCurr,0)
      <=> v149600(VarCurr,26) ) ) ).

tff(addAssignment_84546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149600(VarCurr,B)
      <=> v149602(VarCurr,B) ) ) ).

tff(addAssignment_84545,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149602(VarNext,B)
      <=> v149706(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149707(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149706(VarNext,B)
            <=> v149602(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2178,axiom,
    ! [VarNext: state_type] :
      ( v149707(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149706(VarNext,B)
          <=> v149697(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149707(VarNext)
      <=> v149708(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149708(VarNext)
      <=> ( v149710(VarNext)
          & v149629(VarNext) ) ) ) ).

tff(writeUnaryOperator_11267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149710(VarNext)
      <=> v149691(VarNext) ) ) ).

tff(addAssignment_84544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149624(VarCurr,B)
      <=> v149626(VarCurr,B) ) ) ).

tff(addAssignment_84543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149626(VarCurr,B)
      <=> v149627(VarCurr,B) ) ) ).

tff(addAssignment_84542,axiom,
    ! [VarCurr: state_type] :
      ( ( v149598(VarCurr,3)
      <=> v149600(VarCurr,32) )
      & ( v149598(VarCurr,2)
      <=> v149600(VarCurr,31) )
      & ( v149598(VarCurr,1)
      <=> v149600(VarCurr,30) )
      & ( v149598(VarCurr,0)
      <=> v149600(VarCurr,29) ) ) ).

tff(addAssignment_84541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149600(VarCurr,B)
      <=> v149602(VarCurr,B) ) ) ).

tff(addAssignment_84540,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149602(VarNext,B)
      <=> v149686(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149687(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149686(VarNext,B)
            <=> v149602(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2177,axiom,
    ! [VarNext: state_type] :
      ( v149687(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149686(VarNext,B)
          <=> v149697(VarNext,B) ) ) ) ).

tff(addAssignment_84539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149697(VarNext,B)
          <=> v149695(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149695(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1639,axiom,
    ! [VarCurr: state_type] :
      ( v149698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149695(VarCurr,B)
          <=> v149624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19764,axiom,
    ! [VarCurr: state_type] :
      ( v149698(VarCurr)
    <=> ( v149699(VarCurr)
        & v149700(VarCurr) ) ) ).

tff(writeUnaryOperator_11266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149700(VarCurr)
    <=> v149614(VarCurr) ) ).

tff(writeUnaryOperator_11265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149699(VarCurr)
    <=> v149604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149687(VarNext)
      <=> v149688(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149688(VarNext)
      <=> ( v149689(VarNext)
          & v149629(VarNext) ) ) ) ).

tff(writeUnaryOperator_11264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149689(VarNext)
      <=> v149691(VarNext) ) ) ).

tff(addAssignment_84538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149691(VarNext)
      <=> v149629(VarCurr) ) ) ).

tff(addAssignment_84537,axiom,
    ! [VarCurr: state_type] :
      ( v149629(VarCurr)
    <=> v149631(VarCurr) ) ).

tff(addAssignment_84536,axiom,
    ! [VarCurr: state_type] :
      ( v149631(VarCurr)
    <=> v149633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19761,axiom,
    ! [VarCurr: state_type] :
      ( v149633(VarCurr)
    <=> ( v149684(VarCurr)
        | v149680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19760,axiom,
    ! [VarCurr: state_type] :
      ( v149684(VarCurr)
    <=> ( v149635(VarCurr)
        & v149639(VarCurr) ) ) ).

tff(addAssignment_84535,axiom,
    ! [VarCurr: state_type] :
      ( v149680(VarCurr)
    <=> v149682(VarCurr) ) ).

tff(addAssignment_84534,axiom,
    ! [VarCurr: state_type] :
      ( v149682(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149664(VarNext)
       => ( v149639(VarNext)
        <=> v149639(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2176,axiom,
    ! [VarNext: state_type] :
      ( v149664(VarNext)
     => ( v149639(VarNext)
      <=> v149674(VarNext) ) ) ).

tff(addAssignment_84533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149674(VarNext)
      <=> v149672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19759,axiom,
    ! [VarCurr: state_type] :
      ( v149672(VarCurr)
    <=> ( v149675(VarCurr)
        & v149676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19758,axiom,
    ! [VarCurr: state_type] :
      ( v149676(VarCurr)
    <=> ( v149645(VarCurr)
        | v149659(VarCurr) ) ) ).

tff(writeUnaryOperator_11263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149675(VarCurr)
    <=> v149641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149664(VarNext)
      <=> v149665(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149665(VarNext)
      <=> ( v149667(VarNext)
          & v149669(VarNext) ) ) ) ).

tff(writeUnaryOperator_11262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149669(VarCurr)
    <=> v149635(VarCurr) ) ).

tff(addAssignment_84532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149667(VarNext)
      <=> v149635(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_291,axiom,
    ( v149639(constB0)
  <=> $true ) ).

tff(addAssignment_84531,axiom,
    ! [VarCurr: state_type] :
      ( v149659(VarCurr)
    <=> v149661(VarCurr) ) ).

tff(addAssignment_84530,axiom,
    ! [VarCurr: state_type] :
      ( v149661(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84529,axiom,
    ! [VarCurr: state_type] :
      ( v149645(VarCurr)
    <=> v149647(VarCurr) ) ).

tff(addAssignment_84528,axiom,
    ! [VarCurr: state_type] :
      ( v149647(VarCurr)
    <=> v149649(VarCurr) ) ).

tff(addAssignment_84527,axiom,
    ! [VarCurr: state_type] :
      ( v149649(VarCurr)
    <=> v149651(VarCurr) ) ).

tff(addAssignment_84526,axiom,
    ! [VarCurr: state_type] :
      ( v149651(VarCurr)
    <=> v149653(VarCurr) ) ).

tff(addAssignment_84525,axiom,
    ! [VarCurr: state_type] :
      ( v149653(VarCurr)
    <=> v149655(VarCurr) ) ).

tff(addAssignment_84524,axiom,
    ! [VarCurr: state_type] :
      ( v149655(VarCurr)
    <=> v149657(VarCurr) ) ).

tff(addAssignment_84523,axiom,
    ! [VarCurr: state_type] :
      ( v149657(VarCurr)
    <=> v2940(VarCurr) ) ).

tff(addAssignment_84522,axiom,
    ! [VarCurr: state_type] :
      ( v149641(VarCurr)
    <=> v149643(VarCurr) ) ).

tff(addAssignment_84521,axiom,
    ! [VarCurr: state_type] :
      ( v149643(VarCurr)
    <=> $false ) ).

tff(addAssignment_84520,axiom,
    ! [VarCurr: state_type] :
      ( v149635(VarCurr)
    <=> v149637(VarCurr) ) ).

tff(addAssignment_84519,axiom,
    ! [VarCurr: state_type] :
      ( v149637(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149624(VarCurr,B)
      <=> v149626(VarCurr,B) ) ) ).

tff(addAssignment_84517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149626(VarCurr,B)
      <=> v149627(VarCurr,B) ) ) ).

tff(addAssignment_84516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v149627(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84515,axiom,
    ! [VarCurr: state_type] :
      ( ( v149627(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v149627(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v149627(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v149627(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v149627(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v149627(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v149627(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v149627(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v149627(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v149627(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v149627(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v149627(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v149627(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v149627(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v149627(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84514,axiom,
    ! [VarCurr: state_type] :
      ( ( v149627(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v149627(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v149627(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84513,axiom,
    ! [VarCurr: state_type] :
      ( ( v149627(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v149627(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v149627(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v149627(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84512,axiom,
    ! [VarCurr: state_type] :
      ( v149614(VarCurr)
    <=> v149616(VarCurr) ) ).

tff(addAssignment_84511,axiom,
    ! [VarCurr: state_type] :
      ( v149616(VarCurr)
    <=> v149618(VarCurr) ) ).

tff(addAssignment_84510,axiom,
    ! [VarCurr: state_type] :
      ( v149618(VarCurr)
    <=> v149620(VarCurr) ) ).

tff(addAssignment_84509,axiom,
    ! [VarCurr: state_type] :
      ( v149620(VarCurr)
    <=> v149622(VarCurr) ) ).

tff(addAssignment_84508,axiom,
    ! [VarCurr: state_type] :
      ( v149622(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84507,axiom,
    ! [VarCurr: state_type] :
      ( v149604(VarCurr)
    <=> v149606(VarCurr) ) ).

tff(addAssignment_84506,axiom,
    ! [VarCurr: state_type] :
      ( v149606(VarCurr)
    <=> v149608(VarCurr) ) ).

tff(addAssignment_84505,axiom,
    ! [VarCurr: state_type] :
      ( v149608(VarCurr)
    <=> v149610(VarCurr) ) ).

tff(addAssignment_84504,axiom,
    ! [VarCurr: state_type] :
      ( v149610(VarCurr)
    <=> v149612(VarCurr) ) ).

tff(addAssignment_84503,axiom,
    ! [VarCurr: state_type] :
      ( v149612(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149589(VarCurr,B)
      <=> v149591(VarCurr,B) ) ) ).

tff(addAssignment_84501,axiom,
    ! [VarCurr: state_type] :
      ( v149591(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84500,axiom,
    ! [VarCurr: state_type] :
      ( ( v149591(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v149591(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v149591(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v149591(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v149591(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v149591(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v149591(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v149591(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84499,axiom,
    ! [VarCurr: state_type] :
      ( ( v149591(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v149591(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v149591(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v149591(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v149591(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v149591(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v149591(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v149591(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v149591(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v149591(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v149591(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v149591(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v149591(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v149591(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v149591(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84498,axiom,
    ! [VarCurr: state_type] :
      ( ( v149591(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v149591(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v149591(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84497,axiom,
    ! [VarCurr: state_type] :
      ( ( v149591(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v149591(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v149591(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v149591(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84496,axiom,
    ! [VarCurr: state_type] :
      ( v149591(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84495,axiom,
    ! [VarCurr: state_type] :
      ( v149418(VarCurr)
    <=> v149420(VarCurr) ) ).

tff(addAssignment_84494,axiom,
    ! [VarCurr: state_type] :
      ( v149420(VarCurr)
    <=> v149422(VarCurr) ) ).

tff(addAssignment_84493,axiom,
    ! [VarCurr: state_type] :
      ( v149422(VarCurr)
    <=> v149424(VarCurr) ) ).

tff(addAssignment_84492,axiom,
    ! [VarCurr: state_type] :
      ( v149424(VarCurr)
    <=> v149426(VarCurr) ) ).

tff(addAssignment_84491,axiom,
    ! [VarCurr: state_type] :
      ( v149426(VarCurr)
    <=> v149428(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2306,axiom,
    ! [VarCurr: state_type] :
      ( v149428(VarCurr)
    <=> ( ( v149430(VarCurr,31)
        <=> v149435(VarCurr,31) )
        & ( v149430(VarCurr,30)
        <=> v149435(VarCurr,30) )
        & ( v149430(VarCurr,29)
        <=> v149435(VarCurr,29) )
        & ( v149430(VarCurr,28)
        <=> v149435(VarCurr,28) )
        & ( v149430(VarCurr,27)
        <=> v149435(VarCurr,27) )
        & ( v149430(VarCurr,26)
        <=> v149435(VarCurr,26) )
        & ( v149430(VarCurr,25)
        <=> v149435(VarCurr,25) )
        & ( v149430(VarCurr,24)
        <=> v149435(VarCurr,24) )
        & ( v149430(VarCurr,23)
        <=> v149435(VarCurr,23) )
        & ( v149430(VarCurr,22)
        <=> v149435(VarCurr,22) )
        & ( v149430(VarCurr,21)
        <=> v149435(VarCurr,21) )
        & ( v149430(VarCurr,20)
        <=> v149435(VarCurr,20) )
        & ( v149430(VarCurr,19)
        <=> v149435(VarCurr,19) )
        & ( v149430(VarCurr,18)
        <=> v149435(VarCurr,18) )
        & ( v149430(VarCurr,17)
        <=> v149435(VarCurr,17) )
        & ( v149430(VarCurr,16)
        <=> v149435(VarCurr,16) )
        & ( v149430(VarCurr,15)
        <=> v149435(VarCurr,15) )
        & ( v149430(VarCurr,14)
        <=> v149435(VarCurr,14) )
        & ( v149430(VarCurr,13)
        <=> v149435(VarCurr,13) )
        & ( v149430(VarCurr,12)
        <=> v149435(VarCurr,12) )
        & ( v149430(VarCurr,11)
        <=> v149435(VarCurr,11) )
        & ( v149430(VarCurr,10)
        <=> v149435(VarCurr,10) )
        & ( v149430(VarCurr,9)
        <=> v149435(VarCurr,9) )
        & ( v149430(VarCurr,8)
        <=> v149435(VarCurr,8) )
        & ( v149430(VarCurr,7)
        <=> v149435(VarCurr,7) )
        & ( v149430(VarCurr,6)
        <=> v149435(VarCurr,6) )
        & ( v149430(VarCurr,5)
        <=> v149435(VarCurr,5) )
        & ( v149430(VarCurr,4)
        <=> v149435(VarCurr,4) )
        & ( v149430(VarCurr,3)
        <=> v149435(VarCurr,3) )
        & ( v149430(VarCurr,2)
        <=> v149435(VarCurr,2) )
        & ( v149430(VarCurr,1)
        <=> v149435(VarCurr,1) )
        & ( v149430(VarCurr,0)
        <=> v149435(VarCurr,0) ) ) ) ).

tff(addAssignment_84490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149435(VarCurr,B)
      <=> v149437(VarCurr,B) ) ) ).

tff(addAssignment_84489,axiom,
    ! [VarCurr: state_type] :
      ( ( v149437(VarCurr,8)
      <=> v149565(VarCurr,10) )
      & ( v149437(VarCurr,7)
      <=> v149565(VarCurr,9) )
      & ( v149437(VarCurr,6)
      <=> v149565(VarCurr,8) )
      & ( v149437(VarCurr,5)
      <=> v149565(VarCurr,7) )
      & ( v149437(VarCurr,4)
      <=> v149565(VarCurr,6) )
      & ( v149437(VarCurr,3)
      <=> v149565(VarCurr,5) )
      & ( v149437(VarCurr,2)
      <=> v149565(VarCurr,4) )
      & ( v149437(VarCurr,1)
      <=> v149565(VarCurr,3) )
      & ( v149437(VarCurr,0)
      <=> v149565(VarCurr,2) ) ) ).

tff(addAssignment_84488,axiom,
    ! [VarCurr: state_type] :
      ( ( v149437(VarCurr,23)
      <=> v149555(VarCurr,14) )
      & ( v149437(VarCurr,22)
      <=> v149555(VarCurr,13) )
      & ( v149437(VarCurr,21)
      <=> v149555(VarCurr,12) )
      & ( v149437(VarCurr,20)
      <=> v149555(VarCurr,11) )
      & ( v149437(VarCurr,19)
      <=> v149555(VarCurr,10) )
      & ( v149437(VarCurr,18)
      <=> v149555(VarCurr,9) )
      & ( v149437(VarCurr,17)
      <=> v149555(VarCurr,8) )
      & ( v149437(VarCurr,16)
      <=> v149555(VarCurr,7) )
      & ( v149437(VarCurr,15)
      <=> v149555(VarCurr,6) )
      & ( v149437(VarCurr,14)
      <=> v149555(VarCurr,5) )
      & ( v149437(VarCurr,13)
      <=> v149555(VarCurr,4) )
      & ( v149437(VarCurr,12)
      <=> v149555(VarCurr,3) )
      & ( v149437(VarCurr,11)
      <=> v149555(VarCurr,2) )
      & ( v149437(VarCurr,10)
      <=> v149555(VarCurr,1) )
      & ( v149437(VarCurr,9)
      <=> v149555(VarCurr,0) ) ) ).

tff(addAssignment_84487,axiom,
    ! [VarCurr: state_type] :
      ( ( v149437(VarCurr,26)
      <=> v149545(VarCurr,2) )
      & ( v149437(VarCurr,25)
      <=> v149545(VarCurr,1) )
      & ( v149437(VarCurr,24)
      <=> v149545(VarCurr,0) ) ) ).

tff(addAssignment_84486,axiom,
    ! [VarCurr: state_type] :
      ( ( v149437(VarCurr,30)
      <=> v149439(VarCurr,3) )
      & ( v149437(VarCurr,29)
      <=> v149439(VarCurr,2) )
      & ( v149437(VarCurr,28)
      <=> v149439(VarCurr,1) )
      & ( v149437(VarCurr,27)
      <=> v149439(VarCurr,0) ) ) ).

tff(addAssignment_84485,axiom,
    ! [VarCurr: state_type] :
      ( v149437(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149565(VarCurr,B)
      <=> v149441(VarCurr,B) ) ) ).

tff(addAssignment_84483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149441(VarCurr,B)
      <=> v149443(VarCurr,B) ) ) ).

tff(addAssignment_84482,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149443(VarNext,B)
      <=> v149567(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149568(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149567(VarNext,B)
            <=> v149443(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2175,axiom,
    ! [VarNext: state_type] :
      ( v149568(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149567(VarNext,B)
          <=> v149538(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149568(VarNext)
      <=> v149569(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149569(VarNext)
      <=> ( v149571(VarNext)
          & v149470(VarNext) ) ) ) ).

tff(writeUnaryOperator_11261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149571(VarNext)
      <=> v149532(VarNext) ) ) ).

tff(addAssignment_84481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149465(VarCurr,B)
      <=> v149467(VarCurr,B) ) ) ).

tff(addAssignment_84480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149467(VarCurr,B)
      <=> v149468(VarCurr,B) ) ) ).

tff(addAssignment_84479,axiom,
    ! [VarCurr: state_type] :
      ( ( v149555(VarCurr,14)
      <=> v149441(VarCurr,25) )
      & ( v149555(VarCurr,13)
      <=> v149441(VarCurr,24) )
      & ( v149555(VarCurr,12)
      <=> v149441(VarCurr,23) )
      & ( v149555(VarCurr,11)
      <=> v149441(VarCurr,22) )
      & ( v149555(VarCurr,10)
      <=> v149441(VarCurr,21) )
      & ( v149555(VarCurr,9)
      <=> v149441(VarCurr,20) )
      & ( v149555(VarCurr,8)
      <=> v149441(VarCurr,19) )
      & ( v149555(VarCurr,7)
      <=> v149441(VarCurr,18) )
      & ( v149555(VarCurr,6)
      <=> v149441(VarCurr,17) )
      & ( v149555(VarCurr,5)
      <=> v149441(VarCurr,16) )
      & ( v149555(VarCurr,4)
      <=> v149441(VarCurr,15) )
      & ( v149555(VarCurr,3)
      <=> v149441(VarCurr,14) )
      & ( v149555(VarCurr,2)
      <=> v149441(VarCurr,13) )
      & ( v149555(VarCurr,1)
      <=> v149441(VarCurr,12) )
      & ( v149555(VarCurr,0)
      <=> v149441(VarCurr,11) ) ) ).

tff(addAssignment_84478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149441(VarCurr,B)
      <=> v149443(VarCurr,B) ) ) ).

tff(addAssignment_84477,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149443(VarNext,B)
      <=> v149557(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149557(VarNext,B)
            <=> v149443(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2174,axiom,
    ! [VarNext: state_type] :
      ( v149558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149557(VarNext,B)
          <=> v149538(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149558(VarNext)
      <=> v149559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149559(VarNext)
      <=> ( v149561(VarNext)
          & v149470(VarNext) ) ) ) ).

tff(writeUnaryOperator_11260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149561(VarNext)
      <=> v149532(VarNext) ) ) ).

tff(addAssignment_84476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149465(VarCurr,B)
      <=> v149467(VarCurr,B) ) ) ).

tff(addAssignment_84475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149467(VarCurr,B)
      <=> v149468(VarCurr,B) ) ) ).

tff(addAssignment_84474,axiom,
    ! [VarCurr: state_type] :
      ( ( v149545(VarCurr,2)
      <=> v149441(VarCurr,28) )
      & ( v149545(VarCurr,1)
      <=> v149441(VarCurr,27) )
      & ( v149545(VarCurr,0)
      <=> v149441(VarCurr,26) ) ) ).

tff(addAssignment_84473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149441(VarCurr,B)
      <=> v149443(VarCurr,B) ) ) ).

tff(addAssignment_84472,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149443(VarNext,B)
      <=> v149547(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149548(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149547(VarNext,B)
            <=> v149443(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2173,axiom,
    ! [VarNext: state_type] :
      ( v149548(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149547(VarNext,B)
          <=> v149538(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149548(VarNext)
      <=> v149549(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149549(VarNext)
      <=> ( v149551(VarNext)
          & v149470(VarNext) ) ) ) ).

tff(writeUnaryOperator_11259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149551(VarNext)
      <=> v149532(VarNext) ) ) ).

tff(addAssignment_84471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149465(VarCurr,B)
      <=> v149467(VarCurr,B) ) ) ).

tff(addAssignment_84470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149467(VarCurr,B)
      <=> v149468(VarCurr,B) ) ) ).

tff(addAssignment_84469,axiom,
    ! [VarCurr: state_type] :
      ( ( v149439(VarCurr,3)
      <=> v149441(VarCurr,32) )
      & ( v149439(VarCurr,2)
      <=> v149441(VarCurr,31) )
      & ( v149439(VarCurr,1)
      <=> v149441(VarCurr,30) )
      & ( v149439(VarCurr,0)
      <=> v149441(VarCurr,29) ) ) ).

tff(addAssignment_84468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149441(VarCurr,B)
      <=> v149443(VarCurr,B) ) ) ).

tff(addAssignment_84467,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149443(VarNext,B)
      <=> v149527(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149528(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149527(VarNext,B)
            <=> v149443(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2172,axiom,
    ! [VarNext: state_type] :
      ( v149528(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149527(VarNext,B)
          <=> v149538(VarNext,B) ) ) ) ).

tff(addAssignment_84466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149538(VarNext,B)
          <=> v149536(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149539(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149536(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1638,axiom,
    ! [VarCurr: state_type] :
      ( v149539(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149536(VarCurr,B)
          <=> v149465(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19749,axiom,
    ! [VarCurr: state_type] :
      ( v149539(VarCurr)
    <=> ( v149540(VarCurr)
        & v149541(VarCurr) ) ) ).

tff(writeUnaryOperator_11258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149541(VarCurr)
    <=> v149455(VarCurr) ) ).

tff(writeUnaryOperator_11257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149540(VarCurr)
    <=> v149445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149528(VarNext)
      <=> v149529(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149529(VarNext)
      <=> ( v149530(VarNext)
          & v149470(VarNext) ) ) ) ).

tff(writeUnaryOperator_11256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149530(VarNext)
      <=> v149532(VarNext) ) ) ).

tff(addAssignment_84465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149532(VarNext)
      <=> v149470(VarCurr) ) ) ).

tff(addAssignment_84464,axiom,
    ! [VarCurr: state_type] :
      ( v149470(VarCurr)
    <=> v149472(VarCurr) ) ).

tff(addAssignment_84463,axiom,
    ! [VarCurr: state_type] :
      ( v149472(VarCurr)
    <=> v149474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19746,axiom,
    ! [VarCurr: state_type] :
      ( v149474(VarCurr)
    <=> ( v149525(VarCurr)
        | v149521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19745,axiom,
    ! [VarCurr: state_type] :
      ( v149525(VarCurr)
    <=> ( v149476(VarCurr)
        & v149480(VarCurr) ) ) ).

tff(addAssignment_84462,axiom,
    ! [VarCurr: state_type] :
      ( v149521(VarCurr)
    <=> v149523(VarCurr) ) ).

tff(addAssignment_84461,axiom,
    ! [VarCurr: state_type] :
      ( v149523(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149505(VarNext)
       => ( v149480(VarNext)
        <=> v149480(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2171,axiom,
    ! [VarNext: state_type] :
      ( v149505(VarNext)
     => ( v149480(VarNext)
      <=> v149515(VarNext) ) ) ).

tff(addAssignment_84460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149515(VarNext)
      <=> v149513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19744,axiom,
    ! [VarCurr: state_type] :
      ( v149513(VarCurr)
    <=> ( v149516(VarCurr)
        & v149517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19743,axiom,
    ! [VarCurr: state_type] :
      ( v149517(VarCurr)
    <=> ( v149486(VarCurr)
        | v149500(VarCurr) ) ) ).

tff(writeUnaryOperator_11255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149516(VarCurr)
    <=> v149482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149505(VarNext)
      <=> v149506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149506(VarNext)
      <=> ( v149508(VarNext)
          & v149510(VarNext) ) ) ) ).

tff(writeUnaryOperator_11254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149510(VarCurr)
    <=> v149476(VarCurr) ) ).

tff(addAssignment_84459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149508(VarNext)
      <=> v149476(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_290,axiom,
    ( v149480(constB0)
  <=> $true ) ).

tff(addAssignment_84458,axiom,
    ! [VarCurr: state_type] :
      ( v149500(VarCurr)
    <=> v149502(VarCurr) ) ).

tff(addAssignment_84457,axiom,
    ! [VarCurr: state_type] :
      ( v149502(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84456,axiom,
    ! [VarCurr: state_type] :
      ( v149486(VarCurr)
    <=> v149488(VarCurr) ) ).

tff(addAssignment_84455,axiom,
    ! [VarCurr: state_type] :
      ( v149488(VarCurr)
    <=> v149490(VarCurr) ) ).

tff(addAssignment_84454,axiom,
    ! [VarCurr: state_type] :
      ( v149490(VarCurr)
    <=> v149492(VarCurr) ) ).

tff(addAssignment_84453,axiom,
    ! [VarCurr: state_type] :
      ( v149492(VarCurr)
    <=> v149494(VarCurr) ) ).

tff(addAssignment_84452,axiom,
    ! [VarCurr: state_type] :
      ( v149494(VarCurr)
    <=> v149496(VarCurr) ) ).

tff(addAssignment_84451,axiom,
    ! [VarCurr: state_type] :
      ( v149496(VarCurr)
    <=> v149498(VarCurr) ) ).

tff(addAssignment_84450,axiom,
    ! [VarCurr: state_type] :
      ( v149498(VarCurr)
    <=> v146343(VarCurr) ) ).

tff(addAssignment_84449,axiom,
    ! [VarCurr: state_type] :
      ( v149482(VarCurr)
    <=> v149484(VarCurr) ) ).

tff(addAssignment_84448,axiom,
    ! [VarCurr: state_type] :
      ( v149484(VarCurr)
    <=> $false ) ).

tff(addAssignment_84447,axiom,
    ! [VarCurr: state_type] :
      ( v149476(VarCurr)
    <=> v149478(VarCurr) ) ).

tff(addAssignment_84446,axiom,
    ! [VarCurr: state_type] :
      ( v149478(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149465(VarCurr,B)
      <=> v149467(VarCurr,B) ) ) ).

tff(addAssignment_84444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149467(VarCurr,B)
      <=> v149468(VarCurr,B) ) ) ).

tff(addAssignment_84443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v149468(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84442,axiom,
    ! [VarCurr: state_type] :
      ( ( v149468(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v149468(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v149468(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v149468(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v149468(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v149468(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v149468(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v149468(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v149468(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v149468(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v149468(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v149468(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v149468(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v149468(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v149468(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84441,axiom,
    ! [VarCurr: state_type] :
      ( ( v149468(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v149468(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v149468(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84440,axiom,
    ! [VarCurr: state_type] :
      ( ( v149468(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v149468(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v149468(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v149468(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84439,axiom,
    ! [VarCurr: state_type] :
      ( v149455(VarCurr)
    <=> v149457(VarCurr) ) ).

tff(addAssignment_84438,axiom,
    ! [VarCurr: state_type] :
      ( v149457(VarCurr)
    <=> v149459(VarCurr) ) ).

tff(addAssignment_84437,axiom,
    ! [VarCurr: state_type] :
      ( v149459(VarCurr)
    <=> v149461(VarCurr) ) ).

tff(addAssignment_84436,axiom,
    ! [VarCurr: state_type] :
      ( v149461(VarCurr)
    <=> v149463(VarCurr) ) ).

tff(addAssignment_84435,axiom,
    ! [VarCurr: state_type] :
      ( v149463(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84434,axiom,
    ! [VarCurr: state_type] :
      ( v149445(VarCurr)
    <=> v149447(VarCurr) ) ).

tff(addAssignment_84433,axiom,
    ! [VarCurr: state_type] :
      ( v149447(VarCurr)
    <=> v149449(VarCurr) ) ).

tff(addAssignment_84432,axiom,
    ! [VarCurr: state_type] :
      ( v149449(VarCurr)
    <=> v149451(VarCurr) ) ).

tff(addAssignment_84431,axiom,
    ! [VarCurr: state_type] :
      ( v149451(VarCurr)
    <=> v149453(VarCurr) ) ).

tff(addAssignment_84430,axiom,
    ! [VarCurr: state_type] :
      ( v149453(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149430(VarCurr,B)
      <=> v149432(VarCurr,B) ) ) ).

tff(addAssignment_84428,axiom,
    ! [VarCurr: state_type] :
      ( v149432(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84427,axiom,
    ! [VarCurr: state_type] :
      ( ( v149432(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v149432(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v149432(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v149432(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v149432(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v149432(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v149432(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v149432(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84426,axiom,
    ! [VarCurr: state_type] :
      ( ( v149432(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v149432(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v149432(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v149432(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v149432(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v149432(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v149432(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v149432(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v149432(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v149432(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v149432(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v149432(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v149432(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v149432(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v149432(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84425,axiom,
    ! [VarCurr: state_type] :
      ( ( v149432(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v149432(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v149432(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84424,axiom,
    ! [VarCurr: state_type] :
      ( ( v149432(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v149432(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v149432(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v149432(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84423,axiom,
    ! [VarCurr: state_type] :
      ( v149432(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84422,axiom,
    ! [VarCurr: state_type] :
      ( v149259(VarCurr)
    <=> v149261(VarCurr) ) ).

tff(addAssignment_84421,axiom,
    ! [VarCurr: state_type] :
      ( v149261(VarCurr)
    <=> v149263(VarCurr) ) ).

tff(addAssignment_84420,axiom,
    ! [VarCurr: state_type] :
      ( v149263(VarCurr)
    <=> v149265(VarCurr) ) ).

tff(addAssignment_84419,axiom,
    ! [VarCurr: state_type] :
      ( v149265(VarCurr)
    <=> v149267(VarCurr) ) ).

tff(addAssignment_84418,axiom,
    ! [VarCurr: state_type] :
      ( v149267(VarCurr)
    <=> v149269(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2305,axiom,
    ! [VarCurr: state_type] :
      ( v149269(VarCurr)
    <=> ( ( v149271(VarCurr,31)
        <=> v149276(VarCurr,31) )
        & ( v149271(VarCurr,30)
        <=> v149276(VarCurr,30) )
        & ( v149271(VarCurr,29)
        <=> v149276(VarCurr,29) )
        & ( v149271(VarCurr,28)
        <=> v149276(VarCurr,28) )
        & ( v149271(VarCurr,27)
        <=> v149276(VarCurr,27) )
        & ( v149271(VarCurr,26)
        <=> v149276(VarCurr,26) )
        & ( v149271(VarCurr,25)
        <=> v149276(VarCurr,25) )
        & ( v149271(VarCurr,24)
        <=> v149276(VarCurr,24) )
        & ( v149271(VarCurr,23)
        <=> v149276(VarCurr,23) )
        & ( v149271(VarCurr,22)
        <=> v149276(VarCurr,22) )
        & ( v149271(VarCurr,21)
        <=> v149276(VarCurr,21) )
        & ( v149271(VarCurr,20)
        <=> v149276(VarCurr,20) )
        & ( v149271(VarCurr,19)
        <=> v149276(VarCurr,19) )
        & ( v149271(VarCurr,18)
        <=> v149276(VarCurr,18) )
        & ( v149271(VarCurr,17)
        <=> v149276(VarCurr,17) )
        & ( v149271(VarCurr,16)
        <=> v149276(VarCurr,16) )
        & ( v149271(VarCurr,15)
        <=> v149276(VarCurr,15) )
        & ( v149271(VarCurr,14)
        <=> v149276(VarCurr,14) )
        & ( v149271(VarCurr,13)
        <=> v149276(VarCurr,13) )
        & ( v149271(VarCurr,12)
        <=> v149276(VarCurr,12) )
        & ( v149271(VarCurr,11)
        <=> v149276(VarCurr,11) )
        & ( v149271(VarCurr,10)
        <=> v149276(VarCurr,10) )
        & ( v149271(VarCurr,9)
        <=> v149276(VarCurr,9) )
        & ( v149271(VarCurr,8)
        <=> v149276(VarCurr,8) )
        & ( v149271(VarCurr,7)
        <=> v149276(VarCurr,7) )
        & ( v149271(VarCurr,6)
        <=> v149276(VarCurr,6) )
        & ( v149271(VarCurr,5)
        <=> v149276(VarCurr,5) )
        & ( v149271(VarCurr,4)
        <=> v149276(VarCurr,4) )
        & ( v149271(VarCurr,3)
        <=> v149276(VarCurr,3) )
        & ( v149271(VarCurr,2)
        <=> v149276(VarCurr,2) )
        & ( v149271(VarCurr,1)
        <=> v149276(VarCurr,1) )
        & ( v149271(VarCurr,0)
        <=> v149276(VarCurr,0) ) ) ) ).

tff(addAssignment_84417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149276(VarCurr,B)
      <=> v149278(VarCurr,B) ) ) ).

tff(addAssignment_84416,axiom,
    ! [VarCurr: state_type] :
      ( ( v149278(VarCurr,8)
      <=> v149406(VarCurr,10) )
      & ( v149278(VarCurr,7)
      <=> v149406(VarCurr,9) )
      & ( v149278(VarCurr,6)
      <=> v149406(VarCurr,8) )
      & ( v149278(VarCurr,5)
      <=> v149406(VarCurr,7) )
      & ( v149278(VarCurr,4)
      <=> v149406(VarCurr,6) )
      & ( v149278(VarCurr,3)
      <=> v149406(VarCurr,5) )
      & ( v149278(VarCurr,2)
      <=> v149406(VarCurr,4) )
      & ( v149278(VarCurr,1)
      <=> v149406(VarCurr,3) )
      & ( v149278(VarCurr,0)
      <=> v149406(VarCurr,2) ) ) ).

tff(addAssignment_84415,axiom,
    ! [VarCurr: state_type] :
      ( ( v149278(VarCurr,23)
      <=> v149396(VarCurr,14) )
      & ( v149278(VarCurr,22)
      <=> v149396(VarCurr,13) )
      & ( v149278(VarCurr,21)
      <=> v149396(VarCurr,12) )
      & ( v149278(VarCurr,20)
      <=> v149396(VarCurr,11) )
      & ( v149278(VarCurr,19)
      <=> v149396(VarCurr,10) )
      & ( v149278(VarCurr,18)
      <=> v149396(VarCurr,9) )
      & ( v149278(VarCurr,17)
      <=> v149396(VarCurr,8) )
      & ( v149278(VarCurr,16)
      <=> v149396(VarCurr,7) )
      & ( v149278(VarCurr,15)
      <=> v149396(VarCurr,6) )
      & ( v149278(VarCurr,14)
      <=> v149396(VarCurr,5) )
      & ( v149278(VarCurr,13)
      <=> v149396(VarCurr,4) )
      & ( v149278(VarCurr,12)
      <=> v149396(VarCurr,3) )
      & ( v149278(VarCurr,11)
      <=> v149396(VarCurr,2) )
      & ( v149278(VarCurr,10)
      <=> v149396(VarCurr,1) )
      & ( v149278(VarCurr,9)
      <=> v149396(VarCurr,0) ) ) ).

tff(addAssignment_84414,axiom,
    ! [VarCurr: state_type] :
      ( ( v149278(VarCurr,26)
      <=> v149386(VarCurr,2) )
      & ( v149278(VarCurr,25)
      <=> v149386(VarCurr,1) )
      & ( v149278(VarCurr,24)
      <=> v149386(VarCurr,0) ) ) ).

tff(addAssignment_84413,axiom,
    ! [VarCurr: state_type] :
      ( ( v149278(VarCurr,30)
      <=> v149280(VarCurr,3) )
      & ( v149278(VarCurr,29)
      <=> v149280(VarCurr,2) )
      & ( v149278(VarCurr,28)
      <=> v149280(VarCurr,1) )
      & ( v149278(VarCurr,27)
      <=> v149280(VarCurr,0) ) ) ).

tff(addAssignment_84412,axiom,
    ! [VarCurr: state_type] :
      ( v149278(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149406(VarCurr,B)
      <=> v149282(VarCurr,B) ) ) ).

tff(addAssignment_84410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149282(VarCurr,B)
      <=> v149284(VarCurr,B) ) ) ).

tff(addAssignment_84409,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149284(VarNext,B)
      <=> v149408(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149409(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149408(VarNext,B)
            <=> v149284(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2170,axiom,
    ! [VarNext: state_type] :
      ( v149409(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149408(VarNext,B)
          <=> v149379(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149409(VarNext)
      <=> v149410(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149410(VarNext)
      <=> ( v149412(VarNext)
          & v149311(VarNext) ) ) ) ).

tff(writeUnaryOperator_11253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149412(VarNext)
      <=> v149373(VarNext) ) ) ).

tff(addAssignment_84408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149306(VarCurr,B)
      <=> v149308(VarCurr,B) ) ) ).

tff(addAssignment_84407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149308(VarCurr,B)
      <=> v149309(VarCurr,B) ) ) ).

tff(addAssignment_84406,axiom,
    ! [VarCurr: state_type] :
      ( ( v149396(VarCurr,14)
      <=> v149282(VarCurr,25) )
      & ( v149396(VarCurr,13)
      <=> v149282(VarCurr,24) )
      & ( v149396(VarCurr,12)
      <=> v149282(VarCurr,23) )
      & ( v149396(VarCurr,11)
      <=> v149282(VarCurr,22) )
      & ( v149396(VarCurr,10)
      <=> v149282(VarCurr,21) )
      & ( v149396(VarCurr,9)
      <=> v149282(VarCurr,20) )
      & ( v149396(VarCurr,8)
      <=> v149282(VarCurr,19) )
      & ( v149396(VarCurr,7)
      <=> v149282(VarCurr,18) )
      & ( v149396(VarCurr,6)
      <=> v149282(VarCurr,17) )
      & ( v149396(VarCurr,5)
      <=> v149282(VarCurr,16) )
      & ( v149396(VarCurr,4)
      <=> v149282(VarCurr,15) )
      & ( v149396(VarCurr,3)
      <=> v149282(VarCurr,14) )
      & ( v149396(VarCurr,2)
      <=> v149282(VarCurr,13) )
      & ( v149396(VarCurr,1)
      <=> v149282(VarCurr,12) )
      & ( v149396(VarCurr,0)
      <=> v149282(VarCurr,11) ) ) ).

tff(addAssignment_84405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149282(VarCurr,B)
      <=> v149284(VarCurr,B) ) ) ).

tff(addAssignment_84404,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149284(VarNext,B)
      <=> v149398(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149399(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149398(VarNext,B)
            <=> v149284(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2169,axiom,
    ! [VarNext: state_type] :
      ( v149399(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149398(VarNext,B)
          <=> v149379(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149399(VarNext)
      <=> v149400(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149400(VarNext)
      <=> ( v149402(VarNext)
          & v149311(VarNext) ) ) ) ).

tff(writeUnaryOperator_11252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149402(VarNext)
      <=> v149373(VarNext) ) ) ).

tff(addAssignment_84403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149306(VarCurr,B)
      <=> v149308(VarCurr,B) ) ) ).

tff(addAssignment_84402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149308(VarCurr,B)
      <=> v149309(VarCurr,B) ) ) ).

tff(addAssignment_84401,axiom,
    ! [VarCurr: state_type] :
      ( ( v149386(VarCurr,2)
      <=> v149282(VarCurr,28) )
      & ( v149386(VarCurr,1)
      <=> v149282(VarCurr,27) )
      & ( v149386(VarCurr,0)
      <=> v149282(VarCurr,26) ) ) ).

tff(addAssignment_84400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149282(VarCurr,B)
      <=> v149284(VarCurr,B) ) ) ).

tff(addAssignment_84399,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149284(VarNext,B)
      <=> v149388(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149389(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149388(VarNext,B)
            <=> v149284(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2168,axiom,
    ! [VarNext: state_type] :
      ( v149389(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149388(VarNext,B)
          <=> v149379(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19736,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149389(VarNext)
      <=> v149390(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149390(VarNext)
      <=> ( v149392(VarNext)
          & v149311(VarNext) ) ) ) ).

tff(writeUnaryOperator_11251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149392(VarNext)
      <=> v149373(VarNext) ) ) ).

tff(addAssignment_84398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149306(VarCurr,B)
      <=> v149308(VarCurr,B) ) ) ).

tff(addAssignment_84397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149308(VarCurr,B)
      <=> v149309(VarCurr,B) ) ) ).

tff(addAssignment_84396,axiom,
    ! [VarCurr: state_type] :
      ( ( v149280(VarCurr,3)
      <=> v149282(VarCurr,32) )
      & ( v149280(VarCurr,2)
      <=> v149282(VarCurr,31) )
      & ( v149280(VarCurr,1)
      <=> v149282(VarCurr,30) )
      & ( v149280(VarCurr,0)
      <=> v149282(VarCurr,29) ) ) ).

tff(addAssignment_84395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149282(VarCurr,B)
      <=> v149284(VarCurr,B) ) ) ).

tff(addAssignment_84394,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149284(VarNext,B)
      <=> v149368(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149369(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149368(VarNext,B)
            <=> v149284(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2167,axiom,
    ! [VarNext: state_type] :
      ( v149369(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149368(VarNext,B)
          <=> v149379(VarNext,B) ) ) ) ).

tff(addAssignment_84393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149379(VarNext,B)
          <=> v149377(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149377(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1637,axiom,
    ! [VarCurr: state_type] :
      ( v149380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149377(VarCurr,B)
          <=> v149306(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19734,axiom,
    ! [VarCurr: state_type] :
      ( v149380(VarCurr)
    <=> ( v149381(VarCurr)
        & v149382(VarCurr) ) ) ).

tff(writeUnaryOperator_11250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149382(VarCurr)
    <=> v149296(VarCurr) ) ).

tff(writeUnaryOperator_11249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149381(VarCurr)
    <=> v149286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149369(VarNext)
      <=> v149370(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149370(VarNext)
      <=> ( v149371(VarNext)
          & v149311(VarNext) ) ) ) ).

tff(writeUnaryOperator_11248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149371(VarNext)
      <=> v149373(VarNext) ) ) ).

tff(addAssignment_84392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149373(VarNext)
      <=> v149311(VarCurr) ) ) ).

tff(addAssignment_84391,axiom,
    ! [VarCurr: state_type] :
      ( v149311(VarCurr)
    <=> v149313(VarCurr) ) ).

tff(addAssignment_84390,axiom,
    ! [VarCurr: state_type] :
      ( v149313(VarCurr)
    <=> v149315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19731,axiom,
    ! [VarCurr: state_type] :
      ( v149315(VarCurr)
    <=> ( v149366(VarCurr)
        | v149362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19730,axiom,
    ! [VarCurr: state_type] :
      ( v149366(VarCurr)
    <=> ( v149317(VarCurr)
        & v149321(VarCurr) ) ) ).

tff(addAssignment_84389,axiom,
    ! [VarCurr: state_type] :
      ( v149362(VarCurr)
    <=> v149364(VarCurr) ) ).

tff(addAssignment_84388,axiom,
    ! [VarCurr: state_type] :
      ( v149364(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149346(VarNext)
       => ( v149321(VarNext)
        <=> v149321(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2166,axiom,
    ! [VarNext: state_type] :
      ( v149346(VarNext)
     => ( v149321(VarNext)
      <=> v149356(VarNext) ) ) ).

tff(addAssignment_84387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149356(VarNext)
      <=> v149354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19729,axiom,
    ! [VarCurr: state_type] :
      ( v149354(VarCurr)
    <=> ( v149357(VarCurr)
        & v149358(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19728,axiom,
    ! [VarCurr: state_type] :
      ( v149358(VarCurr)
    <=> ( v149327(VarCurr)
        | v149341(VarCurr) ) ) ).

tff(writeUnaryOperator_11247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149357(VarCurr)
    <=> v149323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149346(VarNext)
      <=> v149347(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149347(VarNext)
      <=> ( v149349(VarNext)
          & v149351(VarNext) ) ) ) ).

tff(writeUnaryOperator_11246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149351(VarCurr)
    <=> v149317(VarCurr) ) ).

tff(addAssignment_84386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149349(VarNext)
      <=> v149317(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_289,axiom,
    ( v149321(constB0)
  <=> $true ) ).

tff(addAssignment_84385,axiom,
    ! [VarCurr: state_type] :
      ( v149341(VarCurr)
    <=> v149343(VarCurr) ) ).

tff(addAssignment_84384,axiom,
    ! [VarCurr: state_type] :
      ( v149343(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84383,axiom,
    ! [VarCurr: state_type] :
      ( v149327(VarCurr)
    <=> v149329(VarCurr) ) ).

tff(addAssignment_84382,axiom,
    ! [VarCurr: state_type] :
      ( v149329(VarCurr)
    <=> v149331(VarCurr) ) ).

tff(addAssignment_84381,axiom,
    ! [VarCurr: state_type] :
      ( v149331(VarCurr)
    <=> v149333(VarCurr) ) ).

tff(addAssignment_84380,axiom,
    ! [VarCurr: state_type] :
      ( v149333(VarCurr)
    <=> v149335(VarCurr) ) ).

tff(addAssignment_84379,axiom,
    ! [VarCurr: state_type] :
      ( v149335(VarCurr)
    <=> v149337(VarCurr) ) ).

tff(addAssignment_84378,axiom,
    ! [VarCurr: state_type] :
      ( v149337(VarCurr)
    <=> v149339(VarCurr) ) ).

tff(addAssignment_84377,axiom,
    ! [VarCurr: state_type] :
      ( v149339(VarCurr)
    <=> v146358(VarCurr) ) ).

tff(addAssignment_84376,axiom,
    ! [VarCurr: state_type] :
      ( v149323(VarCurr)
    <=> v149325(VarCurr) ) ).

tff(addAssignment_84375,axiom,
    ! [VarCurr: state_type] :
      ( v149325(VarCurr)
    <=> $false ) ).

tff(addAssignment_84374,axiom,
    ! [VarCurr: state_type] :
      ( v149317(VarCurr)
    <=> v149319(VarCurr) ) ).

tff(addAssignment_84373,axiom,
    ! [VarCurr: state_type] :
      ( v149319(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149306(VarCurr,B)
      <=> v149308(VarCurr,B) ) ) ).

tff(addAssignment_84371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149308(VarCurr,B)
      <=> v149309(VarCurr,B) ) ) ).

tff(addAssignment_84370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v149309(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84369,axiom,
    ! [VarCurr: state_type] :
      ( ( v149309(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v149309(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v149309(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v149309(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v149309(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v149309(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v149309(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v149309(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v149309(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v149309(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v149309(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v149309(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v149309(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v149309(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v149309(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84368,axiom,
    ! [VarCurr: state_type] :
      ( ( v149309(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v149309(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v149309(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84367,axiom,
    ! [VarCurr: state_type] :
      ( ( v149309(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v149309(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v149309(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v149309(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84366,axiom,
    ! [VarCurr: state_type] :
      ( v149296(VarCurr)
    <=> v149298(VarCurr) ) ).

tff(addAssignment_84365,axiom,
    ! [VarCurr: state_type] :
      ( v149298(VarCurr)
    <=> v149300(VarCurr) ) ).

tff(addAssignment_84364,axiom,
    ! [VarCurr: state_type] :
      ( v149300(VarCurr)
    <=> v149302(VarCurr) ) ).

tff(addAssignment_84363,axiom,
    ! [VarCurr: state_type] :
      ( v149302(VarCurr)
    <=> v149304(VarCurr) ) ).

tff(addAssignment_84362,axiom,
    ! [VarCurr: state_type] :
      ( v149304(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84361,axiom,
    ! [VarCurr: state_type] :
      ( v149286(VarCurr)
    <=> v149288(VarCurr) ) ).

tff(addAssignment_84360,axiom,
    ! [VarCurr: state_type] :
      ( v149288(VarCurr)
    <=> v149290(VarCurr) ) ).

tff(addAssignment_84359,axiom,
    ! [VarCurr: state_type] :
      ( v149290(VarCurr)
    <=> v149292(VarCurr) ) ).

tff(addAssignment_84358,axiom,
    ! [VarCurr: state_type] :
      ( v149292(VarCurr)
    <=> v149294(VarCurr) ) ).

tff(addAssignment_84357,axiom,
    ! [VarCurr: state_type] :
      ( v149294(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149271(VarCurr,B)
      <=> v149273(VarCurr,B) ) ) ).

tff(addAssignment_84355,axiom,
    ! [VarCurr: state_type] :
      ( v149273(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84354,axiom,
    ! [VarCurr: state_type] :
      ( ( v149273(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v149273(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v149273(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v149273(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v149273(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v149273(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v149273(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v149273(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84353,axiom,
    ! [VarCurr: state_type] :
      ( ( v149273(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v149273(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v149273(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v149273(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v149273(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v149273(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v149273(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v149273(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v149273(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v149273(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v149273(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v149273(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v149273(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v149273(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v149273(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84352,axiom,
    ! [VarCurr: state_type] :
      ( ( v149273(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v149273(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v149273(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84351,axiom,
    ! [VarCurr: state_type] :
      ( ( v149273(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v149273(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v149273(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v149273(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84350,axiom,
    ! [VarCurr: state_type] :
      ( v149273(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84349,axiom,
    ! [VarCurr: state_type] :
      ( v149100(VarCurr)
    <=> v149102(VarCurr) ) ).

tff(addAssignment_84348,axiom,
    ! [VarCurr: state_type] :
      ( v149102(VarCurr)
    <=> v149104(VarCurr) ) ).

tff(addAssignment_84347,axiom,
    ! [VarCurr: state_type] :
      ( v149104(VarCurr)
    <=> v149106(VarCurr) ) ).

tff(addAssignment_84346,axiom,
    ! [VarCurr: state_type] :
      ( v149106(VarCurr)
    <=> v149108(VarCurr) ) ).

tff(addAssignment_84345,axiom,
    ! [VarCurr: state_type] :
      ( v149108(VarCurr)
    <=> v149110(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2304,axiom,
    ! [VarCurr: state_type] :
      ( v149110(VarCurr)
    <=> ( ( v149112(VarCurr,31)
        <=> v149117(VarCurr,31) )
        & ( v149112(VarCurr,30)
        <=> v149117(VarCurr,30) )
        & ( v149112(VarCurr,29)
        <=> v149117(VarCurr,29) )
        & ( v149112(VarCurr,28)
        <=> v149117(VarCurr,28) )
        & ( v149112(VarCurr,27)
        <=> v149117(VarCurr,27) )
        & ( v149112(VarCurr,26)
        <=> v149117(VarCurr,26) )
        & ( v149112(VarCurr,25)
        <=> v149117(VarCurr,25) )
        & ( v149112(VarCurr,24)
        <=> v149117(VarCurr,24) )
        & ( v149112(VarCurr,23)
        <=> v149117(VarCurr,23) )
        & ( v149112(VarCurr,22)
        <=> v149117(VarCurr,22) )
        & ( v149112(VarCurr,21)
        <=> v149117(VarCurr,21) )
        & ( v149112(VarCurr,20)
        <=> v149117(VarCurr,20) )
        & ( v149112(VarCurr,19)
        <=> v149117(VarCurr,19) )
        & ( v149112(VarCurr,18)
        <=> v149117(VarCurr,18) )
        & ( v149112(VarCurr,17)
        <=> v149117(VarCurr,17) )
        & ( v149112(VarCurr,16)
        <=> v149117(VarCurr,16) )
        & ( v149112(VarCurr,15)
        <=> v149117(VarCurr,15) )
        & ( v149112(VarCurr,14)
        <=> v149117(VarCurr,14) )
        & ( v149112(VarCurr,13)
        <=> v149117(VarCurr,13) )
        & ( v149112(VarCurr,12)
        <=> v149117(VarCurr,12) )
        & ( v149112(VarCurr,11)
        <=> v149117(VarCurr,11) )
        & ( v149112(VarCurr,10)
        <=> v149117(VarCurr,10) )
        & ( v149112(VarCurr,9)
        <=> v149117(VarCurr,9) )
        & ( v149112(VarCurr,8)
        <=> v149117(VarCurr,8) )
        & ( v149112(VarCurr,7)
        <=> v149117(VarCurr,7) )
        & ( v149112(VarCurr,6)
        <=> v149117(VarCurr,6) )
        & ( v149112(VarCurr,5)
        <=> v149117(VarCurr,5) )
        & ( v149112(VarCurr,4)
        <=> v149117(VarCurr,4) )
        & ( v149112(VarCurr,3)
        <=> v149117(VarCurr,3) )
        & ( v149112(VarCurr,2)
        <=> v149117(VarCurr,2) )
        & ( v149112(VarCurr,1)
        <=> v149117(VarCurr,1) )
        & ( v149112(VarCurr,0)
        <=> v149117(VarCurr,0) ) ) ) ).

tff(addAssignment_84344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149117(VarCurr,B)
      <=> v149119(VarCurr,B) ) ) ).

tff(addAssignment_84343,axiom,
    ! [VarCurr: state_type] :
      ( ( v149119(VarCurr,8)
      <=> v149247(VarCurr,10) )
      & ( v149119(VarCurr,7)
      <=> v149247(VarCurr,9) )
      & ( v149119(VarCurr,6)
      <=> v149247(VarCurr,8) )
      & ( v149119(VarCurr,5)
      <=> v149247(VarCurr,7) )
      & ( v149119(VarCurr,4)
      <=> v149247(VarCurr,6) )
      & ( v149119(VarCurr,3)
      <=> v149247(VarCurr,5) )
      & ( v149119(VarCurr,2)
      <=> v149247(VarCurr,4) )
      & ( v149119(VarCurr,1)
      <=> v149247(VarCurr,3) )
      & ( v149119(VarCurr,0)
      <=> v149247(VarCurr,2) ) ) ).

tff(addAssignment_84342,axiom,
    ! [VarCurr: state_type] :
      ( ( v149119(VarCurr,23)
      <=> v149237(VarCurr,14) )
      & ( v149119(VarCurr,22)
      <=> v149237(VarCurr,13) )
      & ( v149119(VarCurr,21)
      <=> v149237(VarCurr,12) )
      & ( v149119(VarCurr,20)
      <=> v149237(VarCurr,11) )
      & ( v149119(VarCurr,19)
      <=> v149237(VarCurr,10) )
      & ( v149119(VarCurr,18)
      <=> v149237(VarCurr,9) )
      & ( v149119(VarCurr,17)
      <=> v149237(VarCurr,8) )
      & ( v149119(VarCurr,16)
      <=> v149237(VarCurr,7) )
      & ( v149119(VarCurr,15)
      <=> v149237(VarCurr,6) )
      & ( v149119(VarCurr,14)
      <=> v149237(VarCurr,5) )
      & ( v149119(VarCurr,13)
      <=> v149237(VarCurr,4) )
      & ( v149119(VarCurr,12)
      <=> v149237(VarCurr,3) )
      & ( v149119(VarCurr,11)
      <=> v149237(VarCurr,2) )
      & ( v149119(VarCurr,10)
      <=> v149237(VarCurr,1) )
      & ( v149119(VarCurr,9)
      <=> v149237(VarCurr,0) ) ) ).

tff(addAssignment_84341,axiom,
    ! [VarCurr: state_type] :
      ( ( v149119(VarCurr,26)
      <=> v149227(VarCurr,2) )
      & ( v149119(VarCurr,25)
      <=> v149227(VarCurr,1) )
      & ( v149119(VarCurr,24)
      <=> v149227(VarCurr,0) ) ) ).

tff(addAssignment_84340,axiom,
    ! [VarCurr: state_type] :
      ( ( v149119(VarCurr,30)
      <=> v149121(VarCurr,3) )
      & ( v149119(VarCurr,29)
      <=> v149121(VarCurr,2) )
      & ( v149119(VarCurr,28)
      <=> v149121(VarCurr,1) )
      & ( v149119(VarCurr,27)
      <=> v149121(VarCurr,0) ) ) ).

tff(addAssignment_84339,axiom,
    ! [VarCurr: state_type] :
      ( v149119(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149247(VarCurr,B)
      <=> v149123(VarCurr,B) ) ) ).

tff(addAssignment_84337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149123(VarCurr,B)
      <=> v149125(VarCurr,B) ) ) ).

tff(addAssignment_84336,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149125(VarNext,B)
      <=> v149249(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149250(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149249(VarNext,B)
            <=> v149125(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2165,axiom,
    ! [VarNext: state_type] :
      ( v149250(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149249(VarNext,B)
          <=> v149220(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149250(VarNext)
      <=> v149251(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149251(VarNext)
      <=> ( v149253(VarNext)
          & v149152(VarNext) ) ) ) ).

tff(writeUnaryOperator_11245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149253(VarNext)
      <=> v149214(VarNext) ) ) ).

tff(addAssignment_84335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149147(VarCurr,B)
      <=> v149149(VarCurr,B) ) ) ).

tff(addAssignment_84334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149149(VarCurr,B)
      <=> v149150(VarCurr,B) ) ) ).

tff(addAssignment_84333,axiom,
    ! [VarCurr: state_type] :
      ( ( v149237(VarCurr,14)
      <=> v149123(VarCurr,25) )
      & ( v149237(VarCurr,13)
      <=> v149123(VarCurr,24) )
      & ( v149237(VarCurr,12)
      <=> v149123(VarCurr,23) )
      & ( v149237(VarCurr,11)
      <=> v149123(VarCurr,22) )
      & ( v149237(VarCurr,10)
      <=> v149123(VarCurr,21) )
      & ( v149237(VarCurr,9)
      <=> v149123(VarCurr,20) )
      & ( v149237(VarCurr,8)
      <=> v149123(VarCurr,19) )
      & ( v149237(VarCurr,7)
      <=> v149123(VarCurr,18) )
      & ( v149237(VarCurr,6)
      <=> v149123(VarCurr,17) )
      & ( v149237(VarCurr,5)
      <=> v149123(VarCurr,16) )
      & ( v149237(VarCurr,4)
      <=> v149123(VarCurr,15) )
      & ( v149237(VarCurr,3)
      <=> v149123(VarCurr,14) )
      & ( v149237(VarCurr,2)
      <=> v149123(VarCurr,13) )
      & ( v149237(VarCurr,1)
      <=> v149123(VarCurr,12) )
      & ( v149237(VarCurr,0)
      <=> v149123(VarCurr,11) ) ) ).

tff(addAssignment_84332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149123(VarCurr,B)
      <=> v149125(VarCurr,B) ) ) ).

tff(addAssignment_84331,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149125(VarNext,B)
      <=> v149239(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149240(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149239(VarNext,B)
            <=> v149125(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2164,axiom,
    ! [VarNext: state_type] :
      ( v149240(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149239(VarNext,B)
          <=> v149220(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149240(VarNext)
      <=> v149241(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149241(VarNext)
      <=> ( v149243(VarNext)
          & v149152(VarNext) ) ) ) ).

tff(writeUnaryOperator_11244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149243(VarNext)
      <=> v149214(VarNext) ) ) ).

tff(addAssignment_84330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149147(VarCurr,B)
      <=> v149149(VarCurr,B) ) ) ).

tff(addAssignment_84329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v149149(VarCurr,B)
      <=> v149150(VarCurr,B) ) ) ).

tff(addAssignment_84328,axiom,
    ! [VarCurr: state_type] :
      ( ( v149227(VarCurr,2)
      <=> v149123(VarCurr,28) )
      & ( v149227(VarCurr,1)
      <=> v149123(VarCurr,27) )
      & ( v149227(VarCurr,0)
      <=> v149123(VarCurr,26) ) ) ).

tff(addAssignment_84327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149123(VarCurr,B)
      <=> v149125(VarCurr,B) ) ) ).

tff(addAssignment_84326,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149125(VarNext,B)
      <=> v149229(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149230(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149229(VarNext,B)
            <=> v149125(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2163,axiom,
    ! [VarNext: state_type] :
      ( v149230(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149229(VarNext,B)
          <=> v149220(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149230(VarNext)
      <=> v149231(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149231(VarNext)
      <=> ( v149233(VarNext)
          & v149152(VarNext) ) ) ) ).

tff(writeUnaryOperator_11243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149233(VarNext)
      <=> v149214(VarNext) ) ) ).

tff(addAssignment_84325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149147(VarCurr,B)
      <=> v149149(VarCurr,B) ) ) ).

tff(addAssignment_84324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v149149(VarCurr,B)
      <=> v149150(VarCurr,B) ) ) ).

tff(addAssignment_84323,axiom,
    ! [VarCurr: state_type] :
      ( ( v149121(VarCurr,3)
      <=> v149123(VarCurr,32) )
      & ( v149121(VarCurr,2)
      <=> v149123(VarCurr,31) )
      & ( v149121(VarCurr,1)
      <=> v149123(VarCurr,30) )
      & ( v149121(VarCurr,0)
      <=> v149123(VarCurr,29) ) ) ).

tff(addAssignment_84322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149123(VarCurr,B)
      <=> v149125(VarCurr,B) ) ) ).

tff(addAssignment_84321,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149125(VarNext,B)
      <=> v149209(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149210(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149209(VarNext,B)
            <=> v149125(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2162,axiom,
    ! [VarNext: state_type] :
      ( v149210(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149209(VarNext,B)
          <=> v149220(VarNext,B) ) ) ) ).

tff(addAssignment_84320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149220(VarNext,B)
          <=> v149218(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149221(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149218(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1636,axiom,
    ! [VarCurr: state_type] :
      ( v149221(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149218(VarCurr,B)
          <=> v149147(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19719,axiom,
    ! [VarCurr: state_type] :
      ( v149221(VarCurr)
    <=> ( v149222(VarCurr)
        & v149223(VarCurr) ) ) ).

tff(writeUnaryOperator_11242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149223(VarCurr)
    <=> v149137(VarCurr) ) ).

tff(writeUnaryOperator_11241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149222(VarCurr)
    <=> v149127(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149210(VarNext)
      <=> v149211(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149211(VarNext)
      <=> ( v149212(VarNext)
          & v149152(VarNext) ) ) ) ).

tff(writeUnaryOperator_11240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149212(VarNext)
      <=> v149214(VarNext) ) ) ).

tff(addAssignment_84319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149214(VarNext)
      <=> v149152(VarCurr) ) ) ).

tff(addAssignment_84318,axiom,
    ! [VarCurr: state_type] :
      ( v149152(VarCurr)
    <=> v149154(VarCurr) ) ).

tff(addAssignment_84317,axiom,
    ! [VarCurr: state_type] :
      ( v149154(VarCurr)
    <=> v149156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19716,axiom,
    ! [VarCurr: state_type] :
      ( v149156(VarCurr)
    <=> ( v149207(VarCurr)
        | v149203(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19715,axiom,
    ! [VarCurr: state_type] :
      ( v149207(VarCurr)
    <=> ( v149158(VarCurr)
        & v149162(VarCurr) ) ) ).

tff(addAssignment_84316,axiom,
    ! [VarCurr: state_type] :
      ( v149203(VarCurr)
    <=> v149205(VarCurr) ) ).

tff(addAssignment_84315,axiom,
    ! [VarCurr: state_type] :
      ( v149205(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149187(VarNext)
       => ( v149162(VarNext)
        <=> v149162(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2161,axiom,
    ! [VarNext: state_type] :
      ( v149187(VarNext)
     => ( v149162(VarNext)
      <=> v149197(VarNext) ) ) ).

tff(addAssignment_84314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149197(VarNext)
      <=> v149195(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19714,axiom,
    ! [VarCurr: state_type] :
      ( v149195(VarCurr)
    <=> ( v149198(VarCurr)
        & v149199(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19713,axiom,
    ! [VarCurr: state_type] :
      ( v149199(VarCurr)
    <=> ( v149168(VarCurr)
        | v149182(VarCurr) ) ) ).

tff(writeUnaryOperator_11239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149198(VarCurr)
    <=> v149164(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149187(VarNext)
      <=> v149188(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149188(VarNext)
      <=> ( v149190(VarNext)
          & v149192(VarNext) ) ) ) ).

tff(writeUnaryOperator_11238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149192(VarCurr)
    <=> v149158(VarCurr) ) ).

tff(addAssignment_84313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149190(VarNext)
      <=> v149158(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_288,axiom,
    ( v149162(constB0)
  <=> $true ) ).

tff(addAssignment_84312,axiom,
    ! [VarCurr: state_type] :
      ( v149182(VarCurr)
    <=> v149184(VarCurr) ) ).

tff(addAssignment_84311,axiom,
    ! [VarCurr: state_type] :
      ( v149184(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84310,axiom,
    ! [VarCurr: state_type] :
      ( v149168(VarCurr)
    <=> v149170(VarCurr) ) ).

tff(addAssignment_84309,axiom,
    ! [VarCurr: state_type] :
      ( v149170(VarCurr)
    <=> v149172(VarCurr) ) ).

tff(addAssignment_84308,axiom,
    ! [VarCurr: state_type] :
      ( v149172(VarCurr)
    <=> v149174(VarCurr) ) ).

tff(addAssignment_84307,axiom,
    ! [VarCurr: state_type] :
      ( v149174(VarCurr)
    <=> v149176(VarCurr) ) ).

tff(addAssignment_84306,axiom,
    ! [VarCurr: state_type] :
      ( v149176(VarCurr)
    <=> v149178(VarCurr) ) ).

tff(addAssignment_84305,axiom,
    ! [VarCurr: state_type] :
      ( v149178(VarCurr)
    <=> v149180(VarCurr) ) ).

tff(addAssignment_84304,axiom,
    ! [VarCurr: state_type] :
      ( v149180(VarCurr)
    <=> v146374(VarCurr) ) ).

tff(addAssignment_84303,axiom,
    ! [VarCurr: state_type] :
      ( v149164(VarCurr)
    <=> v149166(VarCurr) ) ).

tff(addAssignment_84302,axiom,
    ! [VarCurr: state_type] :
      ( v149166(VarCurr)
    <=> $false ) ).

tff(addAssignment_84301,axiom,
    ! [VarCurr: state_type] :
      ( v149158(VarCurr)
    <=> v149160(VarCurr) ) ).

tff(addAssignment_84300,axiom,
    ! [VarCurr: state_type] :
      ( v149160(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149147(VarCurr,B)
      <=> v149149(VarCurr,B) ) ) ).

tff(addAssignment_84298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v149149(VarCurr,B)
      <=> v149150(VarCurr,B) ) ) ).

tff(addAssignment_84297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v149150(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84296,axiom,
    ! [VarCurr: state_type] :
      ( ( v149150(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v149150(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v149150(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v149150(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v149150(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v149150(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v149150(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v149150(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v149150(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v149150(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v149150(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v149150(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v149150(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v149150(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v149150(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84295,axiom,
    ! [VarCurr: state_type] :
      ( ( v149150(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v149150(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v149150(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84294,axiom,
    ! [VarCurr: state_type] :
      ( ( v149150(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v149150(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v149150(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v149150(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84293,axiom,
    ! [VarCurr: state_type] :
      ( v149137(VarCurr)
    <=> v149139(VarCurr) ) ).

tff(addAssignment_84292,axiom,
    ! [VarCurr: state_type] :
      ( v149139(VarCurr)
    <=> v149141(VarCurr) ) ).

tff(addAssignment_84291,axiom,
    ! [VarCurr: state_type] :
      ( v149141(VarCurr)
    <=> v149143(VarCurr) ) ).

tff(addAssignment_84290,axiom,
    ! [VarCurr: state_type] :
      ( v149143(VarCurr)
    <=> v149145(VarCurr) ) ).

tff(addAssignment_84289,axiom,
    ! [VarCurr: state_type] :
      ( v149145(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84288,axiom,
    ! [VarCurr: state_type] :
      ( v149127(VarCurr)
    <=> v149129(VarCurr) ) ).

tff(addAssignment_84287,axiom,
    ! [VarCurr: state_type] :
      ( v149129(VarCurr)
    <=> v149131(VarCurr) ) ).

tff(addAssignment_84286,axiom,
    ! [VarCurr: state_type] :
      ( v149131(VarCurr)
    <=> v149133(VarCurr) ) ).

tff(addAssignment_84285,axiom,
    ! [VarCurr: state_type] :
      ( v149133(VarCurr)
    <=> v149135(VarCurr) ) ).

tff(addAssignment_84284,axiom,
    ! [VarCurr: state_type] :
      ( v149135(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v149112(VarCurr,B)
      <=> v149114(VarCurr,B) ) ) ).

tff(addAssignment_84282,axiom,
    ! [VarCurr: state_type] :
      ( v149114(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84281,axiom,
    ! [VarCurr: state_type] :
      ( ( v149114(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v149114(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v149114(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v149114(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v149114(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v149114(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v149114(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v149114(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84280,axiom,
    ! [VarCurr: state_type] :
      ( ( v149114(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v149114(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v149114(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v149114(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v149114(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v149114(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v149114(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v149114(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v149114(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v149114(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v149114(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v149114(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v149114(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v149114(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v149114(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84279,axiom,
    ! [VarCurr: state_type] :
      ( ( v149114(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v149114(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v149114(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84278,axiom,
    ! [VarCurr: state_type] :
      ( ( v149114(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v149114(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v149114(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v149114(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84277,axiom,
    ! [VarCurr: state_type] :
      ( v149114(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84276,axiom,
    ! [VarCurr: state_type] :
      ( v148941(VarCurr)
    <=> v148943(VarCurr) ) ).

tff(addAssignment_84275,axiom,
    ! [VarCurr: state_type] :
      ( v148943(VarCurr)
    <=> v148945(VarCurr) ) ).

tff(addAssignment_84274,axiom,
    ! [VarCurr: state_type] :
      ( v148945(VarCurr)
    <=> v148947(VarCurr) ) ).

tff(addAssignment_84273,axiom,
    ! [VarCurr: state_type] :
      ( v148947(VarCurr)
    <=> v148949(VarCurr) ) ).

tff(addAssignment_84272,axiom,
    ! [VarCurr: state_type] :
      ( v148949(VarCurr)
    <=> v148951(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2303,axiom,
    ! [VarCurr: state_type] :
      ( v148951(VarCurr)
    <=> ( ( v148953(VarCurr,31)
        <=> v148958(VarCurr,31) )
        & ( v148953(VarCurr,30)
        <=> v148958(VarCurr,30) )
        & ( v148953(VarCurr,29)
        <=> v148958(VarCurr,29) )
        & ( v148953(VarCurr,28)
        <=> v148958(VarCurr,28) )
        & ( v148953(VarCurr,27)
        <=> v148958(VarCurr,27) )
        & ( v148953(VarCurr,26)
        <=> v148958(VarCurr,26) )
        & ( v148953(VarCurr,25)
        <=> v148958(VarCurr,25) )
        & ( v148953(VarCurr,24)
        <=> v148958(VarCurr,24) )
        & ( v148953(VarCurr,23)
        <=> v148958(VarCurr,23) )
        & ( v148953(VarCurr,22)
        <=> v148958(VarCurr,22) )
        & ( v148953(VarCurr,21)
        <=> v148958(VarCurr,21) )
        & ( v148953(VarCurr,20)
        <=> v148958(VarCurr,20) )
        & ( v148953(VarCurr,19)
        <=> v148958(VarCurr,19) )
        & ( v148953(VarCurr,18)
        <=> v148958(VarCurr,18) )
        & ( v148953(VarCurr,17)
        <=> v148958(VarCurr,17) )
        & ( v148953(VarCurr,16)
        <=> v148958(VarCurr,16) )
        & ( v148953(VarCurr,15)
        <=> v148958(VarCurr,15) )
        & ( v148953(VarCurr,14)
        <=> v148958(VarCurr,14) )
        & ( v148953(VarCurr,13)
        <=> v148958(VarCurr,13) )
        & ( v148953(VarCurr,12)
        <=> v148958(VarCurr,12) )
        & ( v148953(VarCurr,11)
        <=> v148958(VarCurr,11) )
        & ( v148953(VarCurr,10)
        <=> v148958(VarCurr,10) )
        & ( v148953(VarCurr,9)
        <=> v148958(VarCurr,9) )
        & ( v148953(VarCurr,8)
        <=> v148958(VarCurr,8) )
        & ( v148953(VarCurr,7)
        <=> v148958(VarCurr,7) )
        & ( v148953(VarCurr,6)
        <=> v148958(VarCurr,6) )
        & ( v148953(VarCurr,5)
        <=> v148958(VarCurr,5) )
        & ( v148953(VarCurr,4)
        <=> v148958(VarCurr,4) )
        & ( v148953(VarCurr,3)
        <=> v148958(VarCurr,3) )
        & ( v148953(VarCurr,2)
        <=> v148958(VarCurr,2) )
        & ( v148953(VarCurr,1)
        <=> v148958(VarCurr,1) )
        & ( v148953(VarCurr,0)
        <=> v148958(VarCurr,0) ) ) ) ).

tff(addAssignment_84271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148958(VarCurr,B)
      <=> v148960(VarCurr,B) ) ) ).

tff(addAssignment_84270,axiom,
    ! [VarCurr: state_type] :
      ( ( v148960(VarCurr,8)
      <=> v149088(VarCurr,10) )
      & ( v148960(VarCurr,7)
      <=> v149088(VarCurr,9) )
      & ( v148960(VarCurr,6)
      <=> v149088(VarCurr,8) )
      & ( v148960(VarCurr,5)
      <=> v149088(VarCurr,7) )
      & ( v148960(VarCurr,4)
      <=> v149088(VarCurr,6) )
      & ( v148960(VarCurr,3)
      <=> v149088(VarCurr,5) )
      & ( v148960(VarCurr,2)
      <=> v149088(VarCurr,4) )
      & ( v148960(VarCurr,1)
      <=> v149088(VarCurr,3) )
      & ( v148960(VarCurr,0)
      <=> v149088(VarCurr,2) ) ) ).

tff(addAssignment_84269,axiom,
    ! [VarCurr: state_type] :
      ( ( v148960(VarCurr,23)
      <=> v149078(VarCurr,14) )
      & ( v148960(VarCurr,22)
      <=> v149078(VarCurr,13) )
      & ( v148960(VarCurr,21)
      <=> v149078(VarCurr,12) )
      & ( v148960(VarCurr,20)
      <=> v149078(VarCurr,11) )
      & ( v148960(VarCurr,19)
      <=> v149078(VarCurr,10) )
      & ( v148960(VarCurr,18)
      <=> v149078(VarCurr,9) )
      & ( v148960(VarCurr,17)
      <=> v149078(VarCurr,8) )
      & ( v148960(VarCurr,16)
      <=> v149078(VarCurr,7) )
      & ( v148960(VarCurr,15)
      <=> v149078(VarCurr,6) )
      & ( v148960(VarCurr,14)
      <=> v149078(VarCurr,5) )
      & ( v148960(VarCurr,13)
      <=> v149078(VarCurr,4) )
      & ( v148960(VarCurr,12)
      <=> v149078(VarCurr,3) )
      & ( v148960(VarCurr,11)
      <=> v149078(VarCurr,2) )
      & ( v148960(VarCurr,10)
      <=> v149078(VarCurr,1) )
      & ( v148960(VarCurr,9)
      <=> v149078(VarCurr,0) ) ) ).

tff(addAssignment_84268,axiom,
    ! [VarCurr: state_type] :
      ( ( v148960(VarCurr,26)
      <=> v149068(VarCurr,2) )
      & ( v148960(VarCurr,25)
      <=> v149068(VarCurr,1) )
      & ( v148960(VarCurr,24)
      <=> v149068(VarCurr,0) ) ) ).

tff(addAssignment_84267,axiom,
    ! [VarCurr: state_type] :
      ( ( v148960(VarCurr,30)
      <=> v148962(VarCurr,3) )
      & ( v148960(VarCurr,29)
      <=> v148962(VarCurr,2) )
      & ( v148960(VarCurr,28)
      <=> v148962(VarCurr,1) )
      & ( v148960(VarCurr,27)
      <=> v148962(VarCurr,0) ) ) ).

tff(addAssignment_84266,axiom,
    ! [VarCurr: state_type] :
      ( v148960(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v149088(VarCurr,B)
      <=> v148964(VarCurr,B) ) ) ).

tff(addAssignment_84264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148964(VarCurr,B)
      <=> v148966(VarCurr,B) ) ) ).

tff(addAssignment_84263,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148966(VarNext,B)
      <=> v149090(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149091(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149090(VarNext,B)
            <=> v148966(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2160,axiom,
    ! [VarNext: state_type] :
      ( v149091(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149090(VarNext,B)
          <=> v149061(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149091(VarNext)
      <=> v149092(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149092(VarNext)
      <=> ( v149094(VarNext)
          & v148993(VarNext) ) ) ) ).

tff(writeUnaryOperator_11237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149094(VarNext)
      <=> v149055(VarNext) ) ) ).

tff(addAssignment_84262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148988(VarCurr,B)
      <=> v148990(VarCurr,B) ) ) ).

tff(addAssignment_84261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148990(VarCurr,B)
      <=> v148991(VarCurr,B) ) ) ).

tff(addAssignment_84260,axiom,
    ! [VarCurr: state_type] :
      ( ( v149078(VarCurr,14)
      <=> v148964(VarCurr,25) )
      & ( v149078(VarCurr,13)
      <=> v148964(VarCurr,24) )
      & ( v149078(VarCurr,12)
      <=> v148964(VarCurr,23) )
      & ( v149078(VarCurr,11)
      <=> v148964(VarCurr,22) )
      & ( v149078(VarCurr,10)
      <=> v148964(VarCurr,21) )
      & ( v149078(VarCurr,9)
      <=> v148964(VarCurr,20) )
      & ( v149078(VarCurr,8)
      <=> v148964(VarCurr,19) )
      & ( v149078(VarCurr,7)
      <=> v148964(VarCurr,18) )
      & ( v149078(VarCurr,6)
      <=> v148964(VarCurr,17) )
      & ( v149078(VarCurr,5)
      <=> v148964(VarCurr,16) )
      & ( v149078(VarCurr,4)
      <=> v148964(VarCurr,15) )
      & ( v149078(VarCurr,3)
      <=> v148964(VarCurr,14) )
      & ( v149078(VarCurr,2)
      <=> v148964(VarCurr,13) )
      & ( v149078(VarCurr,1)
      <=> v148964(VarCurr,12) )
      & ( v149078(VarCurr,0)
      <=> v148964(VarCurr,11) ) ) ).

tff(addAssignment_84259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148964(VarCurr,B)
      <=> v148966(VarCurr,B) ) ) ).

tff(addAssignment_84258,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148966(VarNext,B)
      <=> v149080(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149081(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149080(VarNext,B)
            <=> v148966(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2159,axiom,
    ! [VarNext: state_type] :
      ( v149081(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149080(VarNext,B)
          <=> v149061(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149081(VarNext)
      <=> v149082(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149082(VarNext)
      <=> ( v149084(VarNext)
          & v148993(VarNext) ) ) ) ).

tff(writeUnaryOperator_11236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149084(VarNext)
      <=> v149055(VarNext) ) ) ).

tff(addAssignment_84257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148988(VarCurr,B)
      <=> v148990(VarCurr,B) ) ) ).

tff(addAssignment_84256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148990(VarCurr,B)
      <=> v148991(VarCurr,B) ) ) ).

tff(addAssignment_84255,axiom,
    ! [VarCurr: state_type] :
      ( ( v149068(VarCurr,2)
      <=> v148964(VarCurr,28) )
      & ( v149068(VarCurr,1)
      <=> v148964(VarCurr,27) )
      & ( v149068(VarCurr,0)
      <=> v148964(VarCurr,26) ) ) ).

tff(addAssignment_84254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148964(VarCurr,B)
      <=> v148966(VarCurr,B) ) ) ).

tff(addAssignment_84253,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148966(VarNext,B)
      <=> v149070(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149071(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149070(VarNext,B)
            <=> v148966(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2158,axiom,
    ! [VarNext: state_type] :
      ( v149071(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149070(VarNext,B)
          <=> v149061(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149071(VarNext)
      <=> v149072(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149072(VarNext)
      <=> ( v149074(VarNext)
          & v148993(VarNext) ) ) ) ).

tff(writeUnaryOperator_11235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149074(VarNext)
      <=> v149055(VarNext) ) ) ).

tff(addAssignment_84252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148988(VarCurr,B)
      <=> v148990(VarCurr,B) ) ) ).

tff(addAssignment_84251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148990(VarCurr,B)
      <=> v148991(VarCurr,B) ) ) ).

tff(addAssignment_84250,axiom,
    ! [VarCurr: state_type] :
      ( ( v148962(VarCurr,3)
      <=> v148964(VarCurr,32) )
      & ( v148962(VarCurr,2)
      <=> v148964(VarCurr,31) )
      & ( v148962(VarCurr,1)
      <=> v148964(VarCurr,30) )
      & ( v148962(VarCurr,0)
      <=> v148964(VarCurr,29) ) ) ).

tff(addAssignment_84249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148964(VarCurr,B)
      <=> v148966(VarCurr,B) ) ) ).

tff(addAssignment_84248,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148966(VarNext,B)
      <=> v149050(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149051(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v149050(VarNext,B)
            <=> v148966(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2157,axiom,
    ! [VarNext: state_type] :
      ( v149051(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149050(VarNext,B)
          <=> v149061(VarNext,B) ) ) ) ).

tff(addAssignment_84247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149061(VarNext,B)
          <=> v149059(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149062(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149059(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1635,axiom,
    ! [VarCurr: state_type] :
      ( v149062(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v149059(VarCurr,B)
          <=> v148988(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19704,axiom,
    ! [VarCurr: state_type] :
      ( v149062(VarCurr)
    <=> ( v149063(VarCurr)
        & v149064(VarCurr) ) ) ).

tff(writeUnaryOperator_11234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149064(VarCurr)
    <=> v148978(VarCurr) ) ).

tff(writeUnaryOperator_11233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149063(VarCurr)
    <=> v148968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149051(VarNext)
      <=> v149052(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149052(VarNext)
      <=> ( v149053(VarNext)
          & v148993(VarNext) ) ) ) ).

tff(writeUnaryOperator_11232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149053(VarNext)
      <=> v149055(VarNext) ) ) ).

tff(addAssignment_84246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149055(VarNext)
      <=> v148993(VarCurr) ) ) ).

tff(addAssignment_84245,axiom,
    ! [VarCurr: state_type] :
      ( v148993(VarCurr)
    <=> v148995(VarCurr) ) ).

tff(addAssignment_84244,axiom,
    ! [VarCurr: state_type] :
      ( v148995(VarCurr)
    <=> v148997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19701,axiom,
    ! [VarCurr: state_type] :
      ( v148997(VarCurr)
    <=> ( v149048(VarCurr)
        | v149044(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19700,axiom,
    ! [VarCurr: state_type] :
      ( v149048(VarCurr)
    <=> ( v148999(VarCurr)
        & v149003(VarCurr) ) ) ).

tff(addAssignment_84243,axiom,
    ! [VarCurr: state_type] :
      ( v149044(VarCurr)
    <=> v149046(VarCurr) ) ).

tff(addAssignment_84242,axiom,
    ! [VarCurr: state_type] :
      ( v149046(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v149028(VarNext)
       => ( v149003(VarNext)
        <=> v149003(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2156,axiom,
    ! [VarNext: state_type] :
      ( v149028(VarNext)
     => ( v149003(VarNext)
      <=> v149038(VarNext) ) ) ).

tff(addAssignment_84241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149038(VarNext)
      <=> v149036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19699,axiom,
    ! [VarCurr: state_type] :
      ( v149036(VarCurr)
    <=> ( v149039(VarCurr)
        & v149040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19698,axiom,
    ! [VarCurr: state_type] :
      ( v149040(VarCurr)
    <=> ( v149009(VarCurr)
        | v149023(VarCurr) ) ) ).

tff(writeUnaryOperator_11231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149039(VarCurr)
    <=> v149005(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149028(VarNext)
      <=> v149029(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149029(VarNext)
      <=> ( v149031(VarNext)
          & v149033(VarNext) ) ) ) ).

tff(writeUnaryOperator_11230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v149033(VarCurr)
    <=> v148999(VarCurr) ) ).

tff(addAssignment_84240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v149031(VarNext)
      <=> v148999(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_287,axiom,
    ( v149003(constB0)
  <=> $true ) ).

tff(addAssignment_84239,axiom,
    ! [VarCurr: state_type] :
      ( v149023(VarCurr)
    <=> v149025(VarCurr) ) ).

tff(addAssignment_84238,axiom,
    ! [VarCurr: state_type] :
      ( v149025(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84237,axiom,
    ! [VarCurr: state_type] :
      ( v149009(VarCurr)
    <=> v149011(VarCurr) ) ).

tff(addAssignment_84236,axiom,
    ! [VarCurr: state_type] :
      ( v149011(VarCurr)
    <=> v149013(VarCurr) ) ).

tff(addAssignment_84235,axiom,
    ! [VarCurr: state_type] :
      ( v149013(VarCurr)
    <=> v149015(VarCurr) ) ).

tff(addAssignment_84234,axiom,
    ! [VarCurr: state_type] :
      ( v149015(VarCurr)
    <=> v149017(VarCurr) ) ).

tff(addAssignment_84233,axiom,
    ! [VarCurr: state_type] :
      ( v149017(VarCurr)
    <=> v149019(VarCurr) ) ).

tff(addAssignment_84232,axiom,
    ! [VarCurr: state_type] :
      ( v149019(VarCurr)
    <=> v149021(VarCurr) ) ).

tff(addAssignment_84231,axiom,
    ! [VarCurr: state_type] :
      ( v149021(VarCurr)
    <=> v146390(VarCurr) ) ).

tff(addAssignment_84230,axiom,
    ! [VarCurr: state_type] :
      ( v149005(VarCurr)
    <=> v149007(VarCurr) ) ).

tff(addAssignment_84229,axiom,
    ! [VarCurr: state_type] :
      ( v149007(VarCurr)
    <=> $false ) ).

tff(addAssignment_84228,axiom,
    ! [VarCurr: state_type] :
      ( v148999(VarCurr)
    <=> v149001(VarCurr) ) ).

tff(addAssignment_84227,axiom,
    ! [VarCurr: state_type] :
      ( v149001(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148988(VarCurr,B)
      <=> v148990(VarCurr,B) ) ) ).

tff(addAssignment_84225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148990(VarCurr,B)
      <=> v148991(VarCurr,B) ) ) ).

tff(addAssignment_84224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v148991(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84223,axiom,
    ! [VarCurr: state_type] :
      ( ( v148991(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v148991(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v148991(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v148991(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v148991(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v148991(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v148991(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v148991(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v148991(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v148991(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v148991(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v148991(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v148991(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v148991(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v148991(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84222,axiom,
    ! [VarCurr: state_type] :
      ( ( v148991(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v148991(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v148991(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84221,axiom,
    ! [VarCurr: state_type] :
      ( ( v148991(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v148991(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v148991(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v148991(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84220,axiom,
    ! [VarCurr: state_type] :
      ( v148978(VarCurr)
    <=> v148980(VarCurr) ) ).

tff(addAssignment_84219,axiom,
    ! [VarCurr: state_type] :
      ( v148980(VarCurr)
    <=> v148982(VarCurr) ) ).

tff(addAssignment_84218,axiom,
    ! [VarCurr: state_type] :
      ( v148982(VarCurr)
    <=> v148984(VarCurr) ) ).

tff(addAssignment_84217,axiom,
    ! [VarCurr: state_type] :
      ( v148984(VarCurr)
    <=> v148986(VarCurr) ) ).

tff(addAssignment_84216,axiom,
    ! [VarCurr: state_type] :
      ( v148986(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84215,axiom,
    ! [VarCurr: state_type] :
      ( v148968(VarCurr)
    <=> v148970(VarCurr) ) ).

tff(addAssignment_84214,axiom,
    ! [VarCurr: state_type] :
      ( v148970(VarCurr)
    <=> v148972(VarCurr) ) ).

tff(addAssignment_84213,axiom,
    ! [VarCurr: state_type] :
      ( v148972(VarCurr)
    <=> v148974(VarCurr) ) ).

tff(addAssignment_84212,axiom,
    ! [VarCurr: state_type] :
      ( v148974(VarCurr)
    <=> v148976(VarCurr) ) ).

tff(addAssignment_84211,axiom,
    ! [VarCurr: state_type] :
      ( v148976(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148953(VarCurr,B)
      <=> v148955(VarCurr,B) ) ) ).

tff(addAssignment_84209,axiom,
    ! [VarCurr: state_type] :
      ( v148955(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84208,axiom,
    ! [VarCurr: state_type] :
      ( ( v148955(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v148955(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v148955(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v148955(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v148955(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v148955(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v148955(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v148955(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84207,axiom,
    ! [VarCurr: state_type] :
      ( ( v148955(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v148955(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v148955(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v148955(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v148955(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v148955(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v148955(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v148955(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v148955(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v148955(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v148955(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v148955(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v148955(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v148955(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v148955(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84206,axiom,
    ! [VarCurr: state_type] :
      ( ( v148955(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v148955(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v148955(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84205,axiom,
    ! [VarCurr: state_type] :
      ( ( v148955(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v148955(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v148955(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v148955(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84204,axiom,
    ! [VarCurr: state_type] :
      ( v148955(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84203,axiom,
    ! [VarCurr: state_type] :
      ( v148782(VarCurr)
    <=> v148784(VarCurr) ) ).

tff(addAssignment_84202,axiom,
    ! [VarCurr: state_type] :
      ( v148784(VarCurr)
    <=> v148786(VarCurr) ) ).

tff(addAssignment_84201,axiom,
    ! [VarCurr: state_type] :
      ( v148786(VarCurr)
    <=> v148788(VarCurr) ) ).

tff(addAssignment_84200,axiom,
    ! [VarCurr: state_type] :
      ( v148788(VarCurr)
    <=> v148790(VarCurr) ) ).

tff(addAssignment_84199,axiom,
    ! [VarCurr: state_type] :
      ( v148790(VarCurr)
    <=> v148792(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2302,axiom,
    ! [VarCurr: state_type] :
      ( v148792(VarCurr)
    <=> ( ( v148794(VarCurr,31)
        <=> v148799(VarCurr,31) )
        & ( v148794(VarCurr,30)
        <=> v148799(VarCurr,30) )
        & ( v148794(VarCurr,29)
        <=> v148799(VarCurr,29) )
        & ( v148794(VarCurr,28)
        <=> v148799(VarCurr,28) )
        & ( v148794(VarCurr,27)
        <=> v148799(VarCurr,27) )
        & ( v148794(VarCurr,26)
        <=> v148799(VarCurr,26) )
        & ( v148794(VarCurr,25)
        <=> v148799(VarCurr,25) )
        & ( v148794(VarCurr,24)
        <=> v148799(VarCurr,24) )
        & ( v148794(VarCurr,23)
        <=> v148799(VarCurr,23) )
        & ( v148794(VarCurr,22)
        <=> v148799(VarCurr,22) )
        & ( v148794(VarCurr,21)
        <=> v148799(VarCurr,21) )
        & ( v148794(VarCurr,20)
        <=> v148799(VarCurr,20) )
        & ( v148794(VarCurr,19)
        <=> v148799(VarCurr,19) )
        & ( v148794(VarCurr,18)
        <=> v148799(VarCurr,18) )
        & ( v148794(VarCurr,17)
        <=> v148799(VarCurr,17) )
        & ( v148794(VarCurr,16)
        <=> v148799(VarCurr,16) )
        & ( v148794(VarCurr,15)
        <=> v148799(VarCurr,15) )
        & ( v148794(VarCurr,14)
        <=> v148799(VarCurr,14) )
        & ( v148794(VarCurr,13)
        <=> v148799(VarCurr,13) )
        & ( v148794(VarCurr,12)
        <=> v148799(VarCurr,12) )
        & ( v148794(VarCurr,11)
        <=> v148799(VarCurr,11) )
        & ( v148794(VarCurr,10)
        <=> v148799(VarCurr,10) )
        & ( v148794(VarCurr,9)
        <=> v148799(VarCurr,9) )
        & ( v148794(VarCurr,8)
        <=> v148799(VarCurr,8) )
        & ( v148794(VarCurr,7)
        <=> v148799(VarCurr,7) )
        & ( v148794(VarCurr,6)
        <=> v148799(VarCurr,6) )
        & ( v148794(VarCurr,5)
        <=> v148799(VarCurr,5) )
        & ( v148794(VarCurr,4)
        <=> v148799(VarCurr,4) )
        & ( v148794(VarCurr,3)
        <=> v148799(VarCurr,3) )
        & ( v148794(VarCurr,2)
        <=> v148799(VarCurr,2) )
        & ( v148794(VarCurr,1)
        <=> v148799(VarCurr,1) )
        & ( v148794(VarCurr,0)
        <=> v148799(VarCurr,0) ) ) ) ).

tff(addAssignment_84198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148799(VarCurr,B)
      <=> v148801(VarCurr,B) ) ) ).

tff(addAssignment_84197,axiom,
    ! [VarCurr: state_type] :
      ( ( v148801(VarCurr,8)
      <=> v148929(VarCurr,10) )
      & ( v148801(VarCurr,7)
      <=> v148929(VarCurr,9) )
      & ( v148801(VarCurr,6)
      <=> v148929(VarCurr,8) )
      & ( v148801(VarCurr,5)
      <=> v148929(VarCurr,7) )
      & ( v148801(VarCurr,4)
      <=> v148929(VarCurr,6) )
      & ( v148801(VarCurr,3)
      <=> v148929(VarCurr,5) )
      & ( v148801(VarCurr,2)
      <=> v148929(VarCurr,4) )
      & ( v148801(VarCurr,1)
      <=> v148929(VarCurr,3) )
      & ( v148801(VarCurr,0)
      <=> v148929(VarCurr,2) ) ) ).

tff(addAssignment_84196,axiom,
    ! [VarCurr: state_type] :
      ( ( v148801(VarCurr,23)
      <=> v148919(VarCurr,14) )
      & ( v148801(VarCurr,22)
      <=> v148919(VarCurr,13) )
      & ( v148801(VarCurr,21)
      <=> v148919(VarCurr,12) )
      & ( v148801(VarCurr,20)
      <=> v148919(VarCurr,11) )
      & ( v148801(VarCurr,19)
      <=> v148919(VarCurr,10) )
      & ( v148801(VarCurr,18)
      <=> v148919(VarCurr,9) )
      & ( v148801(VarCurr,17)
      <=> v148919(VarCurr,8) )
      & ( v148801(VarCurr,16)
      <=> v148919(VarCurr,7) )
      & ( v148801(VarCurr,15)
      <=> v148919(VarCurr,6) )
      & ( v148801(VarCurr,14)
      <=> v148919(VarCurr,5) )
      & ( v148801(VarCurr,13)
      <=> v148919(VarCurr,4) )
      & ( v148801(VarCurr,12)
      <=> v148919(VarCurr,3) )
      & ( v148801(VarCurr,11)
      <=> v148919(VarCurr,2) )
      & ( v148801(VarCurr,10)
      <=> v148919(VarCurr,1) )
      & ( v148801(VarCurr,9)
      <=> v148919(VarCurr,0) ) ) ).

tff(addAssignment_84195,axiom,
    ! [VarCurr: state_type] :
      ( ( v148801(VarCurr,26)
      <=> v148909(VarCurr,2) )
      & ( v148801(VarCurr,25)
      <=> v148909(VarCurr,1) )
      & ( v148801(VarCurr,24)
      <=> v148909(VarCurr,0) ) ) ).

tff(addAssignment_84194,axiom,
    ! [VarCurr: state_type] :
      ( ( v148801(VarCurr,30)
      <=> v148803(VarCurr,3) )
      & ( v148801(VarCurr,29)
      <=> v148803(VarCurr,2) )
      & ( v148801(VarCurr,28)
      <=> v148803(VarCurr,1) )
      & ( v148801(VarCurr,27)
      <=> v148803(VarCurr,0) ) ) ).

tff(addAssignment_84193,axiom,
    ! [VarCurr: state_type] :
      ( v148801(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148929(VarCurr,B)
      <=> v148805(VarCurr,B) ) ) ).

tff(addAssignment_84191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148805(VarCurr,B)
      <=> v148807(VarCurr,B) ) ) ).

tff(addAssignment_84190,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148807(VarNext,B)
      <=> v148931(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148932(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148931(VarNext,B)
            <=> v148807(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2155,axiom,
    ! [VarNext: state_type] :
      ( v148932(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148931(VarNext,B)
          <=> v148902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148932(VarNext)
      <=> v148933(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148933(VarNext)
      <=> ( v148935(VarNext)
          & v148834(VarNext) ) ) ) ).

tff(writeUnaryOperator_11229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148935(VarNext)
      <=> v148896(VarNext) ) ) ).

tff(addAssignment_84189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148829(VarCurr,B)
      <=> v148831(VarCurr,B) ) ) ).

tff(addAssignment_84188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148831(VarCurr,B)
      <=> v148832(VarCurr,B) ) ) ).

tff(addAssignment_84187,axiom,
    ! [VarCurr: state_type] :
      ( ( v148919(VarCurr,14)
      <=> v148805(VarCurr,25) )
      & ( v148919(VarCurr,13)
      <=> v148805(VarCurr,24) )
      & ( v148919(VarCurr,12)
      <=> v148805(VarCurr,23) )
      & ( v148919(VarCurr,11)
      <=> v148805(VarCurr,22) )
      & ( v148919(VarCurr,10)
      <=> v148805(VarCurr,21) )
      & ( v148919(VarCurr,9)
      <=> v148805(VarCurr,20) )
      & ( v148919(VarCurr,8)
      <=> v148805(VarCurr,19) )
      & ( v148919(VarCurr,7)
      <=> v148805(VarCurr,18) )
      & ( v148919(VarCurr,6)
      <=> v148805(VarCurr,17) )
      & ( v148919(VarCurr,5)
      <=> v148805(VarCurr,16) )
      & ( v148919(VarCurr,4)
      <=> v148805(VarCurr,15) )
      & ( v148919(VarCurr,3)
      <=> v148805(VarCurr,14) )
      & ( v148919(VarCurr,2)
      <=> v148805(VarCurr,13) )
      & ( v148919(VarCurr,1)
      <=> v148805(VarCurr,12) )
      & ( v148919(VarCurr,0)
      <=> v148805(VarCurr,11) ) ) ).

tff(addAssignment_84186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148805(VarCurr,B)
      <=> v148807(VarCurr,B) ) ) ).

tff(addAssignment_84185,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148807(VarNext,B)
      <=> v148921(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148922(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148921(VarNext,B)
            <=> v148807(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2154,axiom,
    ! [VarNext: state_type] :
      ( v148922(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148921(VarNext,B)
          <=> v148902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148922(VarNext)
      <=> v148923(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148923(VarNext)
      <=> ( v148925(VarNext)
          & v148834(VarNext) ) ) ) ).

tff(writeUnaryOperator_11228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148925(VarNext)
      <=> v148896(VarNext) ) ) ).

tff(addAssignment_84184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148829(VarCurr,B)
      <=> v148831(VarCurr,B) ) ) ).

tff(addAssignment_84183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148831(VarCurr,B)
      <=> v148832(VarCurr,B) ) ) ).

tff(addAssignment_84182,axiom,
    ! [VarCurr: state_type] :
      ( ( v148909(VarCurr,2)
      <=> v148805(VarCurr,28) )
      & ( v148909(VarCurr,1)
      <=> v148805(VarCurr,27) )
      & ( v148909(VarCurr,0)
      <=> v148805(VarCurr,26) ) ) ).

tff(addAssignment_84181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148805(VarCurr,B)
      <=> v148807(VarCurr,B) ) ) ).

tff(addAssignment_84180,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148807(VarNext,B)
      <=> v148911(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148912(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148911(VarNext,B)
            <=> v148807(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2153,axiom,
    ! [VarNext: state_type] :
      ( v148912(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148911(VarNext,B)
          <=> v148902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148912(VarNext)
      <=> v148913(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148913(VarNext)
      <=> ( v148915(VarNext)
          & v148834(VarNext) ) ) ) ).

tff(writeUnaryOperator_11227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148915(VarNext)
      <=> v148896(VarNext) ) ) ).

tff(addAssignment_84179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148829(VarCurr,B)
      <=> v148831(VarCurr,B) ) ) ).

tff(addAssignment_84178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148831(VarCurr,B)
      <=> v148832(VarCurr,B) ) ) ).

tff(addAssignment_84177,axiom,
    ! [VarCurr: state_type] :
      ( ( v148803(VarCurr,3)
      <=> v148805(VarCurr,32) )
      & ( v148803(VarCurr,2)
      <=> v148805(VarCurr,31) )
      & ( v148803(VarCurr,1)
      <=> v148805(VarCurr,30) )
      & ( v148803(VarCurr,0)
      <=> v148805(VarCurr,29) ) ) ).

tff(addAssignment_84176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148805(VarCurr,B)
      <=> v148807(VarCurr,B) ) ) ).

tff(addAssignment_84175,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148807(VarNext,B)
      <=> v148891(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148892(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148891(VarNext,B)
            <=> v148807(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2152,axiom,
    ! [VarNext: state_type] :
      ( v148892(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148891(VarNext,B)
          <=> v148902(VarNext,B) ) ) ) ).

tff(addAssignment_84174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148902(VarNext,B)
          <=> v148900(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148900(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1634,axiom,
    ! [VarCurr: state_type] :
      ( v148903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148900(VarCurr,B)
          <=> v148829(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19689,axiom,
    ! [VarCurr: state_type] :
      ( v148903(VarCurr)
    <=> ( v148904(VarCurr)
        & v148905(VarCurr) ) ) ).

tff(writeUnaryOperator_11226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148905(VarCurr)
    <=> v148819(VarCurr) ) ).

tff(writeUnaryOperator_11225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148904(VarCurr)
    <=> v148809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148892(VarNext)
      <=> v148893(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148893(VarNext)
      <=> ( v148894(VarNext)
          & v148834(VarNext) ) ) ) ).

tff(writeUnaryOperator_11224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148894(VarNext)
      <=> v148896(VarNext) ) ) ).

tff(addAssignment_84173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148896(VarNext)
      <=> v148834(VarCurr) ) ) ).

tff(addAssignment_84172,axiom,
    ! [VarCurr: state_type] :
      ( v148834(VarCurr)
    <=> v148836(VarCurr) ) ).

tff(addAssignment_84171,axiom,
    ! [VarCurr: state_type] :
      ( v148836(VarCurr)
    <=> v148838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19686,axiom,
    ! [VarCurr: state_type] :
      ( v148838(VarCurr)
    <=> ( v148889(VarCurr)
        | v148885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19685,axiom,
    ! [VarCurr: state_type] :
      ( v148889(VarCurr)
    <=> ( v148840(VarCurr)
        & v148844(VarCurr) ) ) ).

tff(addAssignment_84170,axiom,
    ! [VarCurr: state_type] :
      ( v148885(VarCurr)
    <=> v148887(VarCurr) ) ).

tff(addAssignment_84169,axiom,
    ! [VarCurr: state_type] :
      ( v148887(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148869(VarNext)
       => ( v148844(VarNext)
        <=> v148844(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2151,axiom,
    ! [VarNext: state_type] :
      ( v148869(VarNext)
     => ( v148844(VarNext)
      <=> v148879(VarNext) ) ) ).

tff(addAssignment_84168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148879(VarNext)
      <=> v148877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19684,axiom,
    ! [VarCurr: state_type] :
      ( v148877(VarCurr)
    <=> ( v148880(VarCurr)
        & v148881(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19683,axiom,
    ! [VarCurr: state_type] :
      ( v148881(VarCurr)
    <=> ( v148850(VarCurr)
        | v148864(VarCurr) ) ) ).

tff(writeUnaryOperator_11223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148880(VarCurr)
    <=> v148846(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148869(VarNext)
      <=> v148870(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148870(VarNext)
      <=> ( v148872(VarNext)
          & v148874(VarNext) ) ) ) ).

tff(writeUnaryOperator_11222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148874(VarCurr)
    <=> v148840(VarCurr) ) ).

tff(addAssignment_84167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148872(VarNext)
      <=> v148840(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_286,axiom,
    ( v148844(constB0)
  <=> $true ) ).

tff(addAssignment_84166,axiom,
    ! [VarCurr: state_type] :
      ( v148864(VarCurr)
    <=> v148866(VarCurr) ) ).

tff(addAssignment_84165,axiom,
    ! [VarCurr: state_type] :
      ( v148866(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84164,axiom,
    ! [VarCurr: state_type] :
      ( v148850(VarCurr)
    <=> v148852(VarCurr) ) ).

tff(addAssignment_84163,axiom,
    ! [VarCurr: state_type] :
      ( v148852(VarCurr)
    <=> v148854(VarCurr) ) ).

tff(addAssignment_84162,axiom,
    ! [VarCurr: state_type] :
      ( v148854(VarCurr)
    <=> v148856(VarCurr) ) ).

tff(addAssignment_84161,axiom,
    ! [VarCurr: state_type] :
      ( v148856(VarCurr)
    <=> v148858(VarCurr) ) ).

tff(addAssignment_84160,axiom,
    ! [VarCurr: state_type] :
      ( v148858(VarCurr)
    <=> v148860(VarCurr) ) ).

tff(addAssignment_84159,axiom,
    ! [VarCurr: state_type] :
      ( v148860(VarCurr)
    <=> v148862(VarCurr) ) ).

tff(addAssignment_84158,axiom,
    ! [VarCurr: state_type] :
      ( v148862(VarCurr)
    <=> v146406(VarCurr) ) ).

tff(addAssignment_84157,axiom,
    ! [VarCurr: state_type] :
      ( v148846(VarCurr)
    <=> v148848(VarCurr) ) ).

tff(addAssignment_84156,axiom,
    ! [VarCurr: state_type] :
      ( v148848(VarCurr)
    <=> $false ) ).

tff(addAssignment_84155,axiom,
    ! [VarCurr: state_type] :
      ( v148840(VarCurr)
    <=> v148842(VarCurr) ) ).

tff(addAssignment_84154,axiom,
    ! [VarCurr: state_type] :
      ( v148842(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148829(VarCurr,B)
      <=> v148831(VarCurr,B) ) ) ).

tff(addAssignment_84152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148831(VarCurr,B)
      <=> v148832(VarCurr,B) ) ) ).

tff(addAssignment_84151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v148832(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84150,axiom,
    ! [VarCurr: state_type] :
      ( ( v148832(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v148832(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v148832(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v148832(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v148832(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v148832(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v148832(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v148832(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v148832(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v148832(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v148832(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v148832(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v148832(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v148832(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v148832(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84149,axiom,
    ! [VarCurr: state_type] :
      ( ( v148832(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v148832(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v148832(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84148,axiom,
    ! [VarCurr: state_type] :
      ( ( v148832(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v148832(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v148832(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v148832(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84147,axiom,
    ! [VarCurr: state_type] :
      ( v148819(VarCurr)
    <=> v148821(VarCurr) ) ).

tff(addAssignment_84146,axiom,
    ! [VarCurr: state_type] :
      ( v148821(VarCurr)
    <=> v148823(VarCurr) ) ).

tff(addAssignment_84145,axiom,
    ! [VarCurr: state_type] :
      ( v148823(VarCurr)
    <=> v148825(VarCurr) ) ).

tff(addAssignment_84144,axiom,
    ! [VarCurr: state_type] :
      ( v148825(VarCurr)
    <=> v148827(VarCurr) ) ).

tff(addAssignment_84143,axiom,
    ! [VarCurr: state_type] :
      ( v148827(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84142,axiom,
    ! [VarCurr: state_type] :
      ( v148809(VarCurr)
    <=> v148811(VarCurr) ) ).

tff(addAssignment_84141,axiom,
    ! [VarCurr: state_type] :
      ( v148811(VarCurr)
    <=> v148813(VarCurr) ) ).

tff(addAssignment_84140,axiom,
    ! [VarCurr: state_type] :
      ( v148813(VarCurr)
    <=> v148815(VarCurr) ) ).

tff(addAssignment_84139,axiom,
    ! [VarCurr: state_type] :
      ( v148815(VarCurr)
    <=> v148817(VarCurr) ) ).

tff(addAssignment_84138,axiom,
    ! [VarCurr: state_type] :
      ( v148817(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148794(VarCurr,B)
      <=> v148796(VarCurr,B) ) ) ).

tff(addAssignment_84136,axiom,
    ! [VarCurr: state_type] :
      ( v148796(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84135,axiom,
    ! [VarCurr: state_type] :
      ( ( v148796(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v148796(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v148796(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v148796(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v148796(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v148796(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v148796(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v148796(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84134,axiom,
    ! [VarCurr: state_type] :
      ( ( v148796(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v148796(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v148796(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v148796(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v148796(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v148796(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v148796(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v148796(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v148796(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v148796(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v148796(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v148796(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v148796(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v148796(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v148796(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84133,axiom,
    ! [VarCurr: state_type] :
      ( ( v148796(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v148796(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v148796(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84132,axiom,
    ! [VarCurr: state_type] :
      ( ( v148796(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v148796(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v148796(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v148796(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84131,axiom,
    ! [VarCurr: state_type] :
      ( v148796(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84130,axiom,
    ! [VarCurr: state_type] :
      ( v148623(VarCurr)
    <=> v148625(VarCurr) ) ).

tff(addAssignment_84129,axiom,
    ! [VarCurr: state_type] :
      ( v148625(VarCurr)
    <=> v148627(VarCurr) ) ).

tff(addAssignment_84128,axiom,
    ! [VarCurr: state_type] :
      ( v148627(VarCurr)
    <=> v148629(VarCurr) ) ).

tff(addAssignment_84127,axiom,
    ! [VarCurr: state_type] :
      ( v148629(VarCurr)
    <=> v148631(VarCurr) ) ).

tff(addAssignment_84126,axiom,
    ! [VarCurr: state_type] :
      ( v148631(VarCurr)
    <=> v148633(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2301,axiom,
    ! [VarCurr: state_type] :
      ( v148633(VarCurr)
    <=> ( ( v148635(VarCurr,31)
        <=> v148640(VarCurr,31) )
        & ( v148635(VarCurr,30)
        <=> v148640(VarCurr,30) )
        & ( v148635(VarCurr,29)
        <=> v148640(VarCurr,29) )
        & ( v148635(VarCurr,28)
        <=> v148640(VarCurr,28) )
        & ( v148635(VarCurr,27)
        <=> v148640(VarCurr,27) )
        & ( v148635(VarCurr,26)
        <=> v148640(VarCurr,26) )
        & ( v148635(VarCurr,25)
        <=> v148640(VarCurr,25) )
        & ( v148635(VarCurr,24)
        <=> v148640(VarCurr,24) )
        & ( v148635(VarCurr,23)
        <=> v148640(VarCurr,23) )
        & ( v148635(VarCurr,22)
        <=> v148640(VarCurr,22) )
        & ( v148635(VarCurr,21)
        <=> v148640(VarCurr,21) )
        & ( v148635(VarCurr,20)
        <=> v148640(VarCurr,20) )
        & ( v148635(VarCurr,19)
        <=> v148640(VarCurr,19) )
        & ( v148635(VarCurr,18)
        <=> v148640(VarCurr,18) )
        & ( v148635(VarCurr,17)
        <=> v148640(VarCurr,17) )
        & ( v148635(VarCurr,16)
        <=> v148640(VarCurr,16) )
        & ( v148635(VarCurr,15)
        <=> v148640(VarCurr,15) )
        & ( v148635(VarCurr,14)
        <=> v148640(VarCurr,14) )
        & ( v148635(VarCurr,13)
        <=> v148640(VarCurr,13) )
        & ( v148635(VarCurr,12)
        <=> v148640(VarCurr,12) )
        & ( v148635(VarCurr,11)
        <=> v148640(VarCurr,11) )
        & ( v148635(VarCurr,10)
        <=> v148640(VarCurr,10) )
        & ( v148635(VarCurr,9)
        <=> v148640(VarCurr,9) )
        & ( v148635(VarCurr,8)
        <=> v148640(VarCurr,8) )
        & ( v148635(VarCurr,7)
        <=> v148640(VarCurr,7) )
        & ( v148635(VarCurr,6)
        <=> v148640(VarCurr,6) )
        & ( v148635(VarCurr,5)
        <=> v148640(VarCurr,5) )
        & ( v148635(VarCurr,4)
        <=> v148640(VarCurr,4) )
        & ( v148635(VarCurr,3)
        <=> v148640(VarCurr,3) )
        & ( v148635(VarCurr,2)
        <=> v148640(VarCurr,2) )
        & ( v148635(VarCurr,1)
        <=> v148640(VarCurr,1) )
        & ( v148635(VarCurr,0)
        <=> v148640(VarCurr,0) ) ) ) ).

tff(addAssignment_84125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148640(VarCurr,B)
      <=> v148642(VarCurr,B) ) ) ).

tff(addAssignment_84124,axiom,
    ! [VarCurr: state_type] :
      ( ( v148642(VarCurr,8)
      <=> v148770(VarCurr,10) )
      & ( v148642(VarCurr,7)
      <=> v148770(VarCurr,9) )
      & ( v148642(VarCurr,6)
      <=> v148770(VarCurr,8) )
      & ( v148642(VarCurr,5)
      <=> v148770(VarCurr,7) )
      & ( v148642(VarCurr,4)
      <=> v148770(VarCurr,6) )
      & ( v148642(VarCurr,3)
      <=> v148770(VarCurr,5) )
      & ( v148642(VarCurr,2)
      <=> v148770(VarCurr,4) )
      & ( v148642(VarCurr,1)
      <=> v148770(VarCurr,3) )
      & ( v148642(VarCurr,0)
      <=> v148770(VarCurr,2) ) ) ).

tff(addAssignment_84123,axiom,
    ! [VarCurr: state_type] :
      ( ( v148642(VarCurr,23)
      <=> v148760(VarCurr,14) )
      & ( v148642(VarCurr,22)
      <=> v148760(VarCurr,13) )
      & ( v148642(VarCurr,21)
      <=> v148760(VarCurr,12) )
      & ( v148642(VarCurr,20)
      <=> v148760(VarCurr,11) )
      & ( v148642(VarCurr,19)
      <=> v148760(VarCurr,10) )
      & ( v148642(VarCurr,18)
      <=> v148760(VarCurr,9) )
      & ( v148642(VarCurr,17)
      <=> v148760(VarCurr,8) )
      & ( v148642(VarCurr,16)
      <=> v148760(VarCurr,7) )
      & ( v148642(VarCurr,15)
      <=> v148760(VarCurr,6) )
      & ( v148642(VarCurr,14)
      <=> v148760(VarCurr,5) )
      & ( v148642(VarCurr,13)
      <=> v148760(VarCurr,4) )
      & ( v148642(VarCurr,12)
      <=> v148760(VarCurr,3) )
      & ( v148642(VarCurr,11)
      <=> v148760(VarCurr,2) )
      & ( v148642(VarCurr,10)
      <=> v148760(VarCurr,1) )
      & ( v148642(VarCurr,9)
      <=> v148760(VarCurr,0) ) ) ).

tff(addAssignment_84122,axiom,
    ! [VarCurr: state_type] :
      ( ( v148642(VarCurr,26)
      <=> v148750(VarCurr,2) )
      & ( v148642(VarCurr,25)
      <=> v148750(VarCurr,1) )
      & ( v148642(VarCurr,24)
      <=> v148750(VarCurr,0) ) ) ).

tff(addAssignment_84121,axiom,
    ! [VarCurr: state_type] :
      ( ( v148642(VarCurr,30)
      <=> v148644(VarCurr,3) )
      & ( v148642(VarCurr,29)
      <=> v148644(VarCurr,2) )
      & ( v148642(VarCurr,28)
      <=> v148644(VarCurr,1) )
      & ( v148642(VarCurr,27)
      <=> v148644(VarCurr,0) ) ) ).

tff(addAssignment_84120,axiom,
    ! [VarCurr: state_type] :
      ( v148642(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148770(VarCurr,B)
      <=> v148646(VarCurr,B) ) ) ).

tff(addAssignment_84118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148646(VarCurr,B)
      <=> v148648(VarCurr,B) ) ) ).

tff(addAssignment_84117,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148648(VarNext,B)
      <=> v148772(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148773(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148772(VarNext,B)
            <=> v148648(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2150,axiom,
    ! [VarNext: state_type] :
      ( v148773(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148772(VarNext,B)
          <=> v148743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148773(VarNext)
      <=> v148774(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148774(VarNext)
      <=> ( v148776(VarNext)
          & v148675(VarNext) ) ) ) ).

tff(writeUnaryOperator_11221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148776(VarNext)
      <=> v148737(VarNext) ) ) ).

tff(addAssignment_84116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148670(VarCurr,B)
      <=> v148672(VarCurr,B) ) ) ).

tff(addAssignment_84115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148672(VarCurr,B)
      <=> v148673(VarCurr,B) ) ) ).

tff(addAssignment_84114,axiom,
    ! [VarCurr: state_type] :
      ( ( v148760(VarCurr,14)
      <=> v148646(VarCurr,25) )
      & ( v148760(VarCurr,13)
      <=> v148646(VarCurr,24) )
      & ( v148760(VarCurr,12)
      <=> v148646(VarCurr,23) )
      & ( v148760(VarCurr,11)
      <=> v148646(VarCurr,22) )
      & ( v148760(VarCurr,10)
      <=> v148646(VarCurr,21) )
      & ( v148760(VarCurr,9)
      <=> v148646(VarCurr,20) )
      & ( v148760(VarCurr,8)
      <=> v148646(VarCurr,19) )
      & ( v148760(VarCurr,7)
      <=> v148646(VarCurr,18) )
      & ( v148760(VarCurr,6)
      <=> v148646(VarCurr,17) )
      & ( v148760(VarCurr,5)
      <=> v148646(VarCurr,16) )
      & ( v148760(VarCurr,4)
      <=> v148646(VarCurr,15) )
      & ( v148760(VarCurr,3)
      <=> v148646(VarCurr,14) )
      & ( v148760(VarCurr,2)
      <=> v148646(VarCurr,13) )
      & ( v148760(VarCurr,1)
      <=> v148646(VarCurr,12) )
      & ( v148760(VarCurr,0)
      <=> v148646(VarCurr,11) ) ) ).

tff(addAssignment_84113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148646(VarCurr,B)
      <=> v148648(VarCurr,B) ) ) ).

tff(addAssignment_84112,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148648(VarNext,B)
      <=> v148762(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148763(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148762(VarNext,B)
            <=> v148648(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2149,axiom,
    ! [VarNext: state_type] :
      ( v148763(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148762(VarNext,B)
          <=> v148743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148763(VarNext)
      <=> v148764(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148764(VarNext)
      <=> ( v148766(VarNext)
          & v148675(VarNext) ) ) ) ).

tff(writeUnaryOperator_11220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148766(VarNext)
      <=> v148737(VarNext) ) ) ).

tff(addAssignment_84111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148670(VarCurr,B)
      <=> v148672(VarCurr,B) ) ) ).

tff(addAssignment_84110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148672(VarCurr,B)
      <=> v148673(VarCurr,B) ) ) ).

tff(addAssignment_84109,axiom,
    ! [VarCurr: state_type] :
      ( ( v148750(VarCurr,2)
      <=> v148646(VarCurr,28) )
      & ( v148750(VarCurr,1)
      <=> v148646(VarCurr,27) )
      & ( v148750(VarCurr,0)
      <=> v148646(VarCurr,26) ) ) ).

tff(addAssignment_84108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148646(VarCurr,B)
      <=> v148648(VarCurr,B) ) ) ).

tff(addAssignment_84107,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148648(VarNext,B)
      <=> v148752(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148753(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148752(VarNext,B)
            <=> v148648(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2148,axiom,
    ! [VarNext: state_type] :
      ( v148753(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148752(VarNext,B)
          <=> v148743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148753(VarNext)
      <=> v148754(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148754(VarNext)
      <=> ( v148756(VarNext)
          & v148675(VarNext) ) ) ) ).

tff(writeUnaryOperator_11219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148756(VarNext)
      <=> v148737(VarNext) ) ) ).

tff(addAssignment_84106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148670(VarCurr,B)
      <=> v148672(VarCurr,B) ) ) ).

tff(addAssignment_84105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148672(VarCurr,B)
      <=> v148673(VarCurr,B) ) ) ).

tff(addAssignment_84104,axiom,
    ! [VarCurr: state_type] :
      ( ( v148644(VarCurr,3)
      <=> v148646(VarCurr,32) )
      & ( v148644(VarCurr,2)
      <=> v148646(VarCurr,31) )
      & ( v148644(VarCurr,1)
      <=> v148646(VarCurr,30) )
      & ( v148644(VarCurr,0)
      <=> v148646(VarCurr,29) ) ) ).

tff(addAssignment_84103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148646(VarCurr,B)
      <=> v148648(VarCurr,B) ) ) ).

tff(addAssignment_84102,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148648(VarNext,B)
      <=> v148732(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148733(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148732(VarNext,B)
            <=> v148648(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2147,axiom,
    ! [VarNext: state_type] :
      ( v148733(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148732(VarNext,B)
          <=> v148743(VarNext,B) ) ) ) ).

tff(addAssignment_84101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148743(VarNext,B)
          <=> v148741(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148741(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1633,axiom,
    ! [VarCurr: state_type] :
      ( v148744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148741(VarCurr,B)
          <=> v148670(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19674,axiom,
    ! [VarCurr: state_type] :
      ( v148744(VarCurr)
    <=> ( v148745(VarCurr)
        & v148746(VarCurr) ) ) ).

tff(writeUnaryOperator_11218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148746(VarCurr)
    <=> v148660(VarCurr) ) ).

tff(writeUnaryOperator_11217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148745(VarCurr)
    <=> v148650(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148733(VarNext)
      <=> v148734(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148734(VarNext)
      <=> ( v148735(VarNext)
          & v148675(VarNext) ) ) ) ).

tff(writeUnaryOperator_11216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148735(VarNext)
      <=> v148737(VarNext) ) ) ).

tff(addAssignment_84100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148737(VarNext)
      <=> v148675(VarCurr) ) ) ).

tff(addAssignment_84099,axiom,
    ! [VarCurr: state_type] :
      ( v148675(VarCurr)
    <=> v148677(VarCurr) ) ).

tff(addAssignment_84098,axiom,
    ! [VarCurr: state_type] :
      ( v148677(VarCurr)
    <=> v148679(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19671,axiom,
    ! [VarCurr: state_type] :
      ( v148679(VarCurr)
    <=> ( v148730(VarCurr)
        | v148726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19670,axiom,
    ! [VarCurr: state_type] :
      ( v148730(VarCurr)
    <=> ( v148681(VarCurr)
        & v148685(VarCurr) ) ) ).

tff(addAssignment_84097,axiom,
    ! [VarCurr: state_type] :
      ( v148726(VarCurr)
    <=> v148728(VarCurr) ) ).

tff(addAssignment_84096,axiom,
    ! [VarCurr: state_type] :
      ( v148728(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148710(VarNext)
       => ( v148685(VarNext)
        <=> v148685(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2146,axiom,
    ! [VarNext: state_type] :
      ( v148710(VarNext)
     => ( v148685(VarNext)
      <=> v148720(VarNext) ) ) ).

tff(addAssignment_84095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148720(VarNext)
      <=> v148718(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19669,axiom,
    ! [VarCurr: state_type] :
      ( v148718(VarCurr)
    <=> ( v148721(VarCurr)
        & v148722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19668,axiom,
    ! [VarCurr: state_type] :
      ( v148722(VarCurr)
    <=> ( v148691(VarCurr)
        | v148705(VarCurr) ) ) ).

tff(writeUnaryOperator_11215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148721(VarCurr)
    <=> v148687(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148710(VarNext)
      <=> v148711(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148711(VarNext)
      <=> ( v148713(VarNext)
          & v148715(VarNext) ) ) ) ).

tff(writeUnaryOperator_11214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148715(VarCurr)
    <=> v148681(VarCurr) ) ).

tff(addAssignment_84094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148713(VarNext)
      <=> v148681(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_285,axiom,
    ( v148685(constB0)
  <=> $true ) ).

tff(addAssignment_84093,axiom,
    ! [VarCurr: state_type] :
      ( v148705(VarCurr)
    <=> v148707(VarCurr) ) ).

tff(addAssignment_84092,axiom,
    ! [VarCurr: state_type] :
      ( v148707(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_84091,axiom,
    ! [VarCurr: state_type] :
      ( v148691(VarCurr)
    <=> v148693(VarCurr) ) ).

tff(addAssignment_84090,axiom,
    ! [VarCurr: state_type] :
      ( v148693(VarCurr)
    <=> v148695(VarCurr) ) ).

tff(addAssignment_84089,axiom,
    ! [VarCurr: state_type] :
      ( v148695(VarCurr)
    <=> v148697(VarCurr) ) ).

tff(addAssignment_84088,axiom,
    ! [VarCurr: state_type] :
      ( v148697(VarCurr)
    <=> v148699(VarCurr) ) ).

tff(addAssignment_84087,axiom,
    ! [VarCurr: state_type] :
      ( v148699(VarCurr)
    <=> v148701(VarCurr) ) ).

tff(addAssignment_84086,axiom,
    ! [VarCurr: state_type] :
      ( v148701(VarCurr)
    <=> v148703(VarCurr) ) ).

tff(addAssignment_84085,axiom,
    ! [VarCurr: state_type] :
      ( v148703(VarCurr)
    <=> v146422(VarCurr) ) ).

tff(addAssignment_84084,axiom,
    ! [VarCurr: state_type] :
      ( v148687(VarCurr)
    <=> v148689(VarCurr) ) ).

tff(addAssignment_84083,axiom,
    ! [VarCurr: state_type] :
      ( v148689(VarCurr)
    <=> $false ) ).

tff(addAssignment_84082,axiom,
    ! [VarCurr: state_type] :
      ( v148681(VarCurr)
    <=> v148683(VarCurr) ) ).

tff(addAssignment_84081,axiom,
    ! [VarCurr: state_type] :
      ( v148683(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_84080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148670(VarCurr,B)
      <=> v148672(VarCurr,B) ) ) ).

tff(addAssignment_84079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148672(VarCurr,B)
      <=> v148673(VarCurr,B) ) ) ).

tff(addAssignment_84078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v148673(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_84077,axiom,
    ! [VarCurr: state_type] :
      ( ( v148673(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v148673(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v148673(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v148673(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v148673(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v148673(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v148673(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v148673(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v148673(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v148673(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v148673(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v148673(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v148673(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v148673(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v148673(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_84076,axiom,
    ! [VarCurr: state_type] :
      ( ( v148673(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v148673(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v148673(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_84075,axiom,
    ! [VarCurr: state_type] :
      ( ( v148673(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v148673(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v148673(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v148673(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_84074,axiom,
    ! [VarCurr: state_type] :
      ( v148660(VarCurr)
    <=> v148662(VarCurr) ) ).

tff(addAssignment_84073,axiom,
    ! [VarCurr: state_type] :
      ( v148662(VarCurr)
    <=> v148664(VarCurr) ) ).

tff(addAssignment_84072,axiom,
    ! [VarCurr: state_type] :
      ( v148664(VarCurr)
    <=> v148666(VarCurr) ) ).

tff(addAssignment_84071,axiom,
    ! [VarCurr: state_type] :
      ( v148666(VarCurr)
    <=> v148668(VarCurr) ) ).

tff(addAssignment_84070,axiom,
    ! [VarCurr: state_type] :
      ( v148668(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_84069,axiom,
    ! [VarCurr: state_type] :
      ( v148650(VarCurr)
    <=> v148652(VarCurr) ) ).

tff(addAssignment_84068,axiom,
    ! [VarCurr: state_type] :
      ( v148652(VarCurr)
    <=> v148654(VarCurr) ) ).

tff(addAssignment_84067,axiom,
    ! [VarCurr: state_type] :
      ( v148654(VarCurr)
    <=> v148656(VarCurr) ) ).

tff(addAssignment_84066,axiom,
    ! [VarCurr: state_type] :
      ( v148656(VarCurr)
    <=> v148658(VarCurr) ) ).

tff(addAssignment_84065,axiom,
    ! [VarCurr: state_type] :
      ( v148658(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_84064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148635(VarCurr,B)
      <=> v148637(VarCurr,B) ) ) ).

tff(addAssignment_84063,axiom,
    ! [VarCurr: state_type] :
      ( v148637(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_84062,axiom,
    ! [VarCurr: state_type] :
      ( ( v148637(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v148637(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v148637(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v148637(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v148637(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v148637(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v148637(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v148637(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_84061,axiom,
    ! [VarCurr: state_type] :
      ( ( v148637(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v148637(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v148637(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v148637(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v148637(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v148637(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v148637(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v148637(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v148637(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v148637(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v148637(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v148637(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v148637(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v148637(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v148637(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_84060,axiom,
    ! [VarCurr: state_type] :
      ( ( v148637(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v148637(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v148637(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_84059,axiom,
    ! [VarCurr: state_type] :
      ( ( v148637(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v148637(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v148637(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v148637(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_84058,axiom,
    ! [VarCurr: state_type] :
      ( v148637(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84057,axiom,
    ! [VarCurr: state_type] :
      ( v146577(VarCurr)
    <=> v146579(VarCurr) ) ).

tff(addAssignment_84056,axiom,
    ! [VarCurr: state_type] :
      ( v146579(VarCurr)
    <=> v146581(VarCurr) ) ).

tff(addAssignment_84055,axiom,
    ! [VarCurr: state_type] :
      ( v146581(VarCurr)
    <=> v146583(VarCurr) ) ).

tff(addAssignment_84054,axiom,
    ! [VarCurr: state_type] :
      ( v146583(VarCurr)
    <=> v146585(VarCurr) ) ).

tff(addAssignment_84053,axiom,
    ! [VarCurr: state_type] :
      ( v146585(VarCurr)
    <=> v146587(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2300,axiom,
    ! [VarCurr: state_type] :
      ( v146587(VarCurr)
    <=> ( ( v146589(VarCurr,31)
        <=> v148414(VarCurr,31) )
        & ( v146589(VarCurr,30)
        <=> v148414(VarCurr,30) )
        & ( v146589(VarCurr,29)
        <=> v148414(VarCurr,29) )
        & ( v146589(VarCurr,28)
        <=> v148414(VarCurr,28) )
        & ( v146589(VarCurr,27)
        <=> v148414(VarCurr,27) )
        & ( v146589(VarCurr,26)
        <=> v148414(VarCurr,26) )
        & ( v146589(VarCurr,25)
        <=> v148414(VarCurr,25) )
        & ( v146589(VarCurr,24)
        <=> v148414(VarCurr,24) )
        & ( v146589(VarCurr,23)
        <=> v148414(VarCurr,23) )
        & ( v146589(VarCurr,22)
        <=> v148414(VarCurr,22) )
        & ( v146589(VarCurr,21)
        <=> v148414(VarCurr,21) )
        & ( v146589(VarCurr,20)
        <=> v148414(VarCurr,20) )
        & ( v146589(VarCurr,19)
        <=> v148414(VarCurr,19) )
        & ( v146589(VarCurr,18)
        <=> v148414(VarCurr,18) )
        & ( v146589(VarCurr,17)
        <=> v148414(VarCurr,17) )
        & ( v146589(VarCurr,16)
        <=> v148414(VarCurr,16) )
        & ( v146589(VarCurr,15)
        <=> v148414(VarCurr,15) )
        & ( v146589(VarCurr,14)
        <=> v148414(VarCurr,14) )
        & ( v146589(VarCurr,13)
        <=> v148414(VarCurr,13) )
        & ( v146589(VarCurr,12)
        <=> v148414(VarCurr,12) )
        & ( v146589(VarCurr,11)
        <=> v148414(VarCurr,11) )
        & ( v146589(VarCurr,10)
        <=> v148414(VarCurr,10) )
        & ( v146589(VarCurr,9)
        <=> v148414(VarCurr,9) )
        & ( v146589(VarCurr,8)
        <=> v148414(VarCurr,8) )
        & ( v146589(VarCurr,7)
        <=> v148414(VarCurr,7) )
        & ( v146589(VarCurr,6)
        <=> v148414(VarCurr,6) )
        & ( v146589(VarCurr,5)
        <=> v148414(VarCurr,5) )
        & ( v146589(VarCurr,4)
        <=> v148414(VarCurr,4) )
        & ( v146589(VarCurr,3)
        <=> v148414(VarCurr,3) )
        & ( v146589(VarCurr,2)
        <=> v148414(VarCurr,2) )
        & ( v146589(VarCurr,1)
        <=> v148414(VarCurr,1) )
        & ( v146589(VarCurr,0)
        <=> v148414(VarCurr,0) ) ) ) ).

tff(addAssignment_84052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v148414(VarCurr,B)
      <=> v148416(VarCurr,B) ) ) ).

tff(addAssignment_84051,axiom,
    ! [VarCurr: state_type] :
      ( ( v148416(VarCurr,8)
      <=> v148595(VarCurr,10) )
      & ( v148416(VarCurr,7)
      <=> v148595(VarCurr,9) )
      & ( v148416(VarCurr,6)
      <=> v148595(VarCurr,8) )
      & ( v148416(VarCurr,5)
      <=> v148595(VarCurr,7) )
      & ( v148416(VarCurr,4)
      <=> v148595(VarCurr,6) )
      & ( v148416(VarCurr,3)
      <=> v148595(VarCurr,5) )
      & ( v148416(VarCurr,2)
      <=> v148595(VarCurr,4) )
      & ( v148416(VarCurr,1)
      <=> v148595(VarCurr,3) )
      & ( v148416(VarCurr,0)
      <=> v148595(VarCurr,2) ) ) ).

tff(addAssignment_84050,axiom,
    ! [VarCurr: state_type] :
      ( ( v148416(VarCurr,23)
      <=> v148569(VarCurr,14) )
      & ( v148416(VarCurr,22)
      <=> v148569(VarCurr,13) )
      & ( v148416(VarCurr,21)
      <=> v148569(VarCurr,12) )
      & ( v148416(VarCurr,20)
      <=> v148569(VarCurr,11) )
      & ( v148416(VarCurr,19)
      <=> v148569(VarCurr,10) )
      & ( v148416(VarCurr,18)
      <=> v148569(VarCurr,9) )
      & ( v148416(VarCurr,17)
      <=> v148569(VarCurr,8) )
      & ( v148416(VarCurr,16)
      <=> v148569(VarCurr,7) )
      & ( v148416(VarCurr,15)
      <=> v148569(VarCurr,6) )
      & ( v148416(VarCurr,14)
      <=> v148569(VarCurr,5) )
      & ( v148416(VarCurr,13)
      <=> v148569(VarCurr,4) )
      & ( v148416(VarCurr,12)
      <=> v148569(VarCurr,3) )
      & ( v148416(VarCurr,11)
      <=> v148569(VarCurr,2) )
      & ( v148416(VarCurr,10)
      <=> v148569(VarCurr,1) )
      & ( v148416(VarCurr,9)
      <=> v148569(VarCurr,0) ) ) ).

tff(addAssignment_84049,axiom,
    ! [VarCurr: state_type] :
      ( ( v148416(VarCurr,26)
      <=> v148543(VarCurr,2) )
      & ( v148416(VarCurr,25)
      <=> v148543(VarCurr,1) )
      & ( v148416(VarCurr,24)
      <=> v148543(VarCurr,0) ) ) ).

tff(addAssignment_84048,axiom,
    ! [VarCurr: state_type] :
      ( ( v148416(VarCurr,30)
      <=> v148418(VarCurr,3) )
      & ( v148416(VarCurr,29)
      <=> v148418(VarCurr,2) )
      & ( v148416(VarCurr,28)
      <=> v148418(VarCurr,1) )
      & ( v148416(VarCurr,27)
      <=> v148418(VarCurr,0) ) ) ).

tff(addAssignment_84047,axiom,
    ! [VarCurr: state_type] :
      ( v148416(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_84046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148595(VarCurr,B)
      <=> v148420(VarCurr,B) ) ) ).

tff(addAssignment_84045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148420(VarCurr,B)
      <=> v148422(VarCurr,B) ) ) ).

tff(addAssignment_84044,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148422(VarNext,B)
      <=> v148613(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148614(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148613(VarNext,B)
            <=> v148422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2145,axiom,
    ! [VarNext: state_type] :
      ( v148614(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148613(VarNext,B)
          <=> v148536(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148614(VarNext)
      <=> v148615(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148615(VarNext)
      <=> ( v148617(VarNext)
          & v148468(VarNext) ) ) ) ).

tff(writeUnaryOperator_11213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148617(VarNext)
      <=> v148530(VarNext) ) ) ).

tff(addAssignment_84043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148444(VarCurr,B)
      <=> v148446(VarCurr,B) ) ) ).

tff(addAssignment_84042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148446(VarCurr,B)
      <=> v148463(VarCurr,B) ) ) ).

tff(addAssignment_84041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148466(VarCurr,B)
      <=> v148235(VarCurr,B) ) ) ).

tff(addAssignment_84040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148235(VarCurr,B)
      <=> v148237(VarCurr,B) ) ) ).

tff(addAssignment_84039,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148237(VarNext,B)
      <=> v148605(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148606(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v148605(VarNext,B)
            <=> v148237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2144,axiom,
    ! [VarNext: state_type] :
      ( v148606(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148605(VarNext,B)
          <=> v148328(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148606(VarNext)
      <=> v148607(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148607(VarNext)
      <=> ( v148609(VarNext)
          & v148270(VarNext) ) ) ) ).

tff(writeUnaryOperator_11212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148609(VarNext)
      <=> v148322(VarNext) ) ) ).

tff(addAssignment_84038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148259(VarCurr,B)
      <=> v148261(VarCurr,B) ) ) ).

tff(addAssignment_84037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148261(VarCurr,B)
      <=> v148264(VarCurr,B) ) ) ).

tff(addAssignment_84036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148268(VarCurr,B)
      <=> v148599(VarCurr,B) ) ) ).

tff(addAssignment_84035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148599(VarCurr,B)
      <=> v148601(VarCurr,B) ) ) ).

tff(addAssignment_84034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148601(VarCurr,B)
      <=> v148603(VarCurr,B) ) ) ).

tff(addAssignment_84033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148603(VarCurr,B)
      <=> v148040(VarCurr,B) ) ) ).

tff(addAssignment_84032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148040(VarCurr,B)
      <=> v148042(VarCurr,B) ) ) ).

tff(addAssignment_84031,axiom,
    ! [VarCurr: state_type] :
      ( ( v148569(VarCurr,14)
      <=> v148420(VarCurr,25) )
      & ( v148569(VarCurr,13)
      <=> v148420(VarCurr,24) )
      & ( v148569(VarCurr,12)
      <=> v148420(VarCurr,23) )
      & ( v148569(VarCurr,11)
      <=> v148420(VarCurr,22) )
      & ( v148569(VarCurr,10)
      <=> v148420(VarCurr,21) )
      & ( v148569(VarCurr,9)
      <=> v148420(VarCurr,20) )
      & ( v148569(VarCurr,8)
      <=> v148420(VarCurr,19) )
      & ( v148569(VarCurr,7)
      <=> v148420(VarCurr,18) )
      & ( v148569(VarCurr,6)
      <=> v148420(VarCurr,17) )
      & ( v148569(VarCurr,5)
      <=> v148420(VarCurr,16) )
      & ( v148569(VarCurr,4)
      <=> v148420(VarCurr,15) )
      & ( v148569(VarCurr,3)
      <=> v148420(VarCurr,14) )
      & ( v148569(VarCurr,2)
      <=> v148420(VarCurr,13) )
      & ( v148569(VarCurr,1)
      <=> v148420(VarCurr,12) )
      & ( v148569(VarCurr,0)
      <=> v148420(VarCurr,11) ) ) ).

tff(addAssignment_84030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148420(VarCurr,B)
      <=> v148422(VarCurr,B) ) ) ).

tff(addAssignment_84029,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148422(VarNext,B)
      <=> v148587(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148588(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148587(VarNext,B)
            <=> v148422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2143,axiom,
    ! [VarNext: state_type] :
      ( v148588(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148587(VarNext,B)
          <=> v148536(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148588(VarNext)
      <=> v148589(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148589(VarNext)
      <=> ( v148591(VarNext)
          & v148468(VarNext) ) ) ) ).

tff(writeUnaryOperator_11211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148591(VarNext)
      <=> v148530(VarNext) ) ) ).

tff(addAssignment_84028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148444(VarCurr,B)
      <=> v148446(VarCurr,B) ) ) ).

tff(addAssignment_84027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148446(VarCurr,B)
      <=> v148463(VarCurr,B) ) ) ).

tff(addAssignment_84026,axiom,
    ! [VarCurr: state_type] :
      ( ( v148465(VarCurr,14)
      <=> v148235(VarCurr,25) )
      & ( v148465(VarCurr,13)
      <=> v148235(VarCurr,24) )
      & ( v148465(VarCurr,12)
      <=> v148235(VarCurr,23) )
      & ( v148465(VarCurr,11)
      <=> v148235(VarCurr,22) )
      & ( v148465(VarCurr,10)
      <=> v148235(VarCurr,21) )
      & ( v148465(VarCurr,9)
      <=> v148235(VarCurr,20) )
      & ( v148465(VarCurr,8)
      <=> v148235(VarCurr,19) )
      & ( v148465(VarCurr,7)
      <=> v148235(VarCurr,18) )
      & ( v148465(VarCurr,6)
      <=> v148235(VarCurr,17) )
      & ( v148465(VarCurr,5)
      <=> v148235(VarCurr,16) )
      & ( v148465(VarCurr,4)
      <=> v148235(VarCurr,15) )
      & ( v148465(VarCurr,3)
      <=> v148235(VarCurr,14) )
      & ( v148465(VarCurr,2)
      <=> v148235(VarCurr,13) )
      & ( v148465(VarCurr,1)
      <=> v148235(VarCurr,12) )
      & ( v148465(VarCurr,0)
      <=> v148235(VarCurr,11) ) ) ).

tff(addAssignment_84025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148235(VarCurr,B)
      <=> v148237(VarCurr,B) ) ) ).

tff(addAssignment_84024,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148237(VarNext,B)
      <=> v148579(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148580(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v148579(VarNext,B)
            <=> v148237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2142,axiom,
    ! [VarNext: state_type] :
      ( v148580(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148579(VarNext,B)
          <=> v148328(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148580(VarNext)
      <=> v148581(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148581(VarNext)
      <=> ( v148583(VarNext)
          & v148270(VarNext) ) ) ) ).

tff(writeUnaryOperator_11210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148583(VarNext)
      <=> v148322(VarNext) ) ) ).

tff(addAssignment_84023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148259(VarCurr,B)
      <=> v148261(VarCurr,B) ) ) ).

tff(addAssignment_84022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148261(VarCurr,B)
      <=> v148264(VarCurr,B) ) ) ).

tff(addAssignment_84021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v148267(VarCurr,B)
      <=> v148573(VarCurr,B) ) ) ).

tff(addAssignment_84020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v148573(VarCurr,B)
      <=> v148575(VarCurr,B) ) ) ).

tff(addAssignment_84019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v148575(VarCurr,B)
      <=> v148577(VarCurr,B) ) ) ).

tff(addAssignment_84018,axiom,
    ! [VarCurr: state_type] :
      ( ( v148577(VarCurr,14)
      <=> v148040(VarCurr,25) )
      & ( v148577(VarCurr,13)
      <=> v148040(VarCurr,24) )
      & ( v148577(VarCurr,12)
      <=> v148040(VarCurr,23) )
      & ( v148577(VarCurr,11)
      <=> v148040(VarCurr,22) )
      & ( v148577(VarCurr,10)
      <=> v148040(VarCurr,21) )
      & ( v148577(VarCurr,9)
      <=> v148040(VarCurr,20) )
      & ( v148577(VarCurr,8)
      <=> v148040(VarCurr,19) )
      & ( v148577(VarCurr,7)
      <=> v148040(VarCurr,18) )
      & ( v148577(VarCurr,6)
      <=> v148040(VarCurr,17) )
      & ( v148577(VarCurr,5)
      <=> v148040(VarCurr,16) )
      & ( v148577(VarCurr,4)
      <=> v148040(VarCurr,15) )
      & ( v148577(VarCurr,3)
      <=> v148040(VarCurr,14) )
      & ( v148577(VarCurr,2)
      <=> v148040(VarCurr,13) )
      & ( v148577(VarCurr,1)
      <=> v148040(VarCurr,12) )
      & ( v148577(VarCurr,0)
      <=> v148040(VarCurr,11) ) ) ).

tff(addAssignment_84017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v148040(VarCurr,B)
      <=> v148042(VarCurr,B) ) ) ).

tff(addAssignment_84016,axiom,
    ! [VarCurr: state_type] :
      ( ( v148543(VarCurr,2)
      <=> v148420(VarCurr,28) )
      & ( v148543(VarCurr,1)
      <=> v148420(VarCurr,27) )
      & ( v148543(VarCurr,0)
      <=> v148420(VarCurr,26) ) ) ).

tff(addAssignment_84015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148420(VarCurr,B)
      <=> v148422(VarCurr,B) ) ) ).

tff(addAssignment_84014,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148422(VarNext,B)
      <=> v148561(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148562(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148561(VarNext,B)
            <=> v148422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2141,axiom,
    ! [VarNext: state_type] :
      ( v148562(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148561(VarNext,B)
          <=> v148536(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148562(VarNext)
      <=> v148563(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148563(VarNext)
      <=> ( v148565(VarNext)
          & v148468(VarNext) ) ) ) ).

tff(writeUnaryOperator_11209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148565(VarNext)
      <=> v148530(VarNext) ) ) ).

tff(addAssignment_84013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148444(VarCurr,B)
      <=> v148446(VarCurr,B) ) ) ).

tff(addAssignment_84012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148446(VarCurr,B)
      <=> v148463(VarCurr,B) ) ) ).

tff(addAssignment_84011,axiom,
    ! [VarCurr: state_type] :
      ( ( v148464(VarCurr,2)
      <=> v148235(VarCurr,28) )
      & ( v148464(VarCurr,1)
      <=> v148235(VarCurr,27) )
      & ( v148464(VarCurr,0)
      <=> v148235(VarCurr,26) ) ) ).

tff(addAssignment_84010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148235(VarCurr,B)
      <=> v148237(VarCurr,B) ) ) ).

tff(addAssignment_84009,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148237(VarNext,B)
      <=> v148553(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148554(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v148553(VarNext,B)
            <=> v148237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2140,axiom,
    ! [VarNext: state_type] :
      ( v148554(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148553(VarNext,B)
          <=> v148328(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148554(VarNext)
      <=> v148555(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148555(VarNext)
      <=> ( v148557(VarNext)
          & v148270(VarNext) ) ) ) ).

tff(writeUnaryOperator_11208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148557(VarNext)
      <=> v148322(VarNext) ) ) ).

tff(addAssignment_84008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148259(VarCurr,B)
      <=> v148261(VarCurr,B) ) ) ).

tff(addAssignment_84007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v148261(VarCurr,B)
      <=> v148264(VarCurr,B) ) ) ).

tff(addAssignment_84006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v148266(VarCurr,B)
      <=> v148547(VarCurr,B) ) ) ).

tff(addAssignment_84005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v148547(VarCurr,B)
      <=> v148549(VarCurr,B) ) ) ).

tff(addAssignment_84004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v148549(VarCurr,B)
      <=> v148551(VarCurr,B) ) ) ).

tff(addAssignment_84003,axiom,
    ! [VarCurr: state_type] :
      ( ( v148551(VarCurr,2)
      <=> v3948(VarCurr,13) )
      & ( v148551(VarCurr,1)
      <=> v3948(VarCurr,12) )
      & ( v148551(VarCurr,0)
      <=> v3948(VarCurr,11) ) ) ).

tff(addAssignment_84002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_84001,axiom,
    ! [VarCurr: state_type] :
      ( ( v148418(VarCurr,3)
      <=> v148420(VarCurr,32) )
      & ( v148418(VarCurr,2)
      <=> v148420(VarCurr,31) )
      & ( v148418(VarCurr,1)
      <=> v148420(VarCurr,30) )
      & ( v148418(VarCurr,0)
      <=> v148420(VarCurr,29) ) ) ).

tff(addAssignment_84000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148420(VarCurr,B)
      <=> v148422(VarCurr,B) ) ) ).

tff(addAssignment_83999,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148422(VarNext,B)
      <=> v148525(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148526(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v148525(VarNext,B)
            <=> v148422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2139,axiom,
    ! [VarNext: state_type] :
      ( v148526(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148525(VarNext,B)
          <=> v148536(VarNext,B) ) ) ) ).

tff(addAssignment_83998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148536(VarNext,B)
          <=> v148534(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148537(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148534(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1632,axiom,
    ! [VarCurr: state_type] :
      ( v148537(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v148534(VarCurr,B)
          <=> v148444(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19653,axiom,
    ! [VarCurr: state_type] :
      ( v148537(VarCurr)
    <=> ( v148538(VarCurr)
        & v148539(VarCurr) ) ) ).

tff(writeUnaryOperator_11207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148539(VarCurr)
    <=> v148434(VarCurr) ) ).

tff(writeUnaryOperator_11206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148538(VarCurr)
    <=> v148424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148526(VarNext)
      <=> v148527(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148527(VarNext)
      <=> ( v148528(VarNext)
          & v148468(VarNext) ) ) ) ).

tff(writeUnaryOperator_11205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148528(VarNext)
      <=> v148530(VarNext) ) ) ).

tff(addAssignment_83997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148530(VarNext)
      <=> v148468(VarCurr) ) ) ).

tff(addAssignment_83996,axiom,
    ! [VarCurr: state_type] :
      ( v148468(VarCurr)
    <=> v148470(VarCurr) ) ).

tff(addAssignment_83995,axiom,
    ! [VarCurr: state_type] :
      ( v148470(VarCurr)
    <=> v148472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19650,axiom,
    ! [VarCurr: state_type] :
      ( v148472(VarCurr)
    <=> ( v148523(VarCurr)
        | v148519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19649,axiom,
    ! [VarCurr: state_type] :
      ( v148523(VarCurr)
    <=> ( v148474(VarCurr)
        & v148478(VarCurr) ) ) ).

tff(addAssignment_83994,axiom,
    ! [VarCurr: state_type] :
      ( v148519(VarCurr)
    <=> v148521(VarCurr) ) ).

tff(addAssignment_83993,axiom,
    ! [VarCurr: state_type] :
      ( v148521(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148503(VarNext)
       => ( v148478(VarNext)
        <=> v148478(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2138,axiom,
    ! [VarNext: state_type] :
      ( v148503(VarNext)
     => ( v148478(VarNext)
      <=> v148513(VarNext) ) ) ).

tff(addAssignment_83992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148513(VarNext)
      <=> v148511(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19648,axiom,
    ! [VarCurr: state_type] :
      ( v148511(VarCurr)
    <=> ( v148514(VarCurr)
        & v148515(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19647,axiom,
    ! [VarCurr: state_type] :
      ( v148515(VarCurr)
    <=> ( v148484(VarCurr)
        | v148498(VarCurr) ) ) ).

tff(writeUnaryOperator_11204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148514(VarCurr)
    <=> v148480(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148503(VarNext)
      <=> v148504(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148504(VarNext)
      <=> ( v148506(VarNext)
          & v148508(VarNext) ) ) ) ).

tff(writeUnaryOperator_11203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148508(VarCurr)
    <=> v148474(VarCurr) ) ).

tff(addAssignment_83991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148506(VarNext)
      <=> v148474(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_284,axiom,
    ( v148478(constB0)
  <=> $true ) ).

tff(addAssignment_83990,axiom,
    ! [VarCurr: state_type] :
      ( v148498(VarCurr)
    <=> v148500(VarCurr) ) ).

tff(addAssignment_83989,axiom,
    ! [VarCurr: state_type] :
      ( v148500(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83988,axiom,
    ! [VarCurr: state_type] :
      ( v148484(VarCurr)
    <=> v148486(VarCurr) ) ).

tff(addAssignment_83987,axiom,
    ! [VarCurr: state_type] :
      ( v148486(VarCurr)
    <=> v148488(VarCurr) ) ).

tff(addAssignment_83986,axiom,
    ! [VarCurr: state_type] :
      ( v148488(VarCurr)
    <=> v148490(VarCurr) ) ).

tff(addAssignment_83985,axiom,
    ! [VarCurr: state_type] :
      ( v148490(VarCurr)
    <=> v148492(VarCurr) ) ).

tff(addAssignment_83984,axiom,
    ! [VarCurr: state_type] :
      ( v148492(VarCurr)
    <=> v148494(VarCurr) ) ).

tff(addAssignment_83983,axiom,
    ! [VarCurr: state_type] :
      ( v148494(VarCurr)
    <=> v148496(VarCurr) ) ).

tff(addAssignment_83982,axiom,
    ! [VarCurr: state_type] :
      ( v148496(VarCurr)
    <=> v146438(VarCurr) ) ).

tff(addAssignment_83981,axiom,
    ! [VarCurr: state_type] :
      ( v148480(VarCurr)
    <=> v148482(VarCurr) ) ).

tff(addAssignment_83980,axiom,
    ! [VarCurr: state_type] :
      ( v148482(VarCurr)
    <=> $false ) ).

tff(addAssignment_83979,axiom,
    ! [VarCurr: state_type] :
      ( v148474(VarCurr)
    <=> v148476(VarCurr) ) ).

tff(addAssignment_83978,axiom,
    ! [VarCurr: state_type] :
      ( v148476(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148444(VarCurr,B)
      <=> v148446(VarCurr,B) ) ) ).

tff(addAssignment_83976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148446(VarCurr,B)
      <=> v148463(VarCurr,B) ) ) ).

tff(addAssignment_83975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v148463(VarCurr,B)
      <=> v148466(VarCurr,B) ) ) ).

tff(addAssignment_83974,axiom,
    ! [VarCurr: state_type] :
      ( ( v148463(VarCurr,25)
      <=> v148465(VarCurr,14) )
      & ( v148463(VarCurr,24)
      <=> v148465(VarCurr,13) )
      & ( v148463(VarCurr,23)
      <=> v148465(VarCurr,12) )
      & ( v148463(VarCurr,22)
      <=> v148465(VarCurr,11) )
      & ( v148463(VarCurr,21)
      <=> v148465(VarCurr,10) )
      & ( v148463(VarCurr,20)
      <=> v148465(VarCurr,9) )
      & ( v148463(VarCurr,19)
      <=> v148465(VarCurr,8) )
      & ( v148463(VarCurr,18)
      <=> v148465(VarCurr,7) )
      & ( v148463(VarCurr,17)
      <=> v148465(VarCurr,6) )
      & ( v148463(VarCurr,16)
      <=> v148465(VarCurr,5) )
      & ( v148463(VarCurr,15)
      <=> v148465(VarCurr,4) )
      & ( v148463(VarCurr,14)
      <=> v148465(VarCurr,3) )
      & ( v148463(VarCurr,13)
      <=> v148465(VarCurr,2) )
      & ( v148463(VarCurr,12)
      <=> v148465(VarCurr,1) )
      & ( v148463(VarCurr,11)
      <=> v148465(VarCurr,0) ) ) ).

tff(addAssignment_83973,axiom,
    ! [VarCurr: state_type] :
      ( ( v148463(VarCurr,28)
      <=> v148464(VarCurr,2) )
      & ( v148463(VarCurr,27)
      <=> v148464(VarCurr,1) )
      & ( v148463(VarCurr,26)
      <=> v148464(VarCurr,0) ) ) ).

tff(addAssignment_83972,axiom,
    ! [VarCurr: state_type] :
      ( ( v148463(VarCurr,32)
      <=> v148448(VarCurr,3) )
      & ( v148463(VarCurr,31)
      <=> v148448(VarCurr,2) )
      & ( v148463(VarCurr,30)
      <=> v148448(VarCurr,1) )
      & ( v148463(VarCurr,29)
      <=> v148448(VarCurr,0) ) ) ).

tff(addAssignment_83971,axiom,
    ! [VarCurr: state_type] :
      ( ( v148448(VarCurr,3)
      <=> v148235(VarCurr,32) )
      & ( v148448(VarCurr,2)
      <=> v148235(VarCurr,31) )
      & ( v148448(VarCurr,1)
      <=> v148235(VarCurr,30) )
      & ( v148448(VarCurr,0)
      <=> v148235(VarCurr,29) ) ) ).

tff(addAssignment_83970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148235(VarCurr,B)
      <=> v148237(VarCurr,B) ) ) ).

tff(addAssignment_83969,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148237(VarNext,B)
      <=> v148456(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148457(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v148456(VarNext,B)
            <=> v148237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2137,axiom,
    ! [VarNext: state_type] :
      ( v148457(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148456(VarNext,B)
          <=> v148328(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148457(VarNext)
      <=> v148458(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148458(VarNext)
      <=> ( v148460(VarNext)
          & v148270(VarNext) ) ) ) ).

tff(writeUnaryOperator_11202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148460(VarNext)
      <=> v148322(VarNext) ) ) ).

tff(addAssignment_83968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148259(VarCurr,B)
      <=> v148261(VarCurr,B) ) ) ).

tff(addAssignment_83967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v148261(VarCurr,B)
      <=> v148264(VarCurr,B) ) ) ).

tff(addAssignment_83966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v148265(VarCurr,B)
      <=> v148453(VarCurr,B) ) ) ).

tff(addAssignment_83965,axiom,
    ! [VarCurr: state_type] :
      ( v148265(VarCurr,3)
    <=> v148451(VarCurr) ) ).

tff(addAssignment_83964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v148453(VarCurr,B)
      <=> v100104(VarCurr,B) ) ) ).

tff(addAssignment_83963,axiom,
    ! [VarCurr: state_type] :
      ( v148451(VarCurr)
    <=> v100261(VarCurr) ) ).

tff(addAssignment_83962,axiom,
    ! [VarCurr: state_type] :
      ( v148434(VarCurr)
    <=> v148436(VarCurr) ) ).

tff(addAssignment_83961,axiom,
    ! [VarCurr: state_type] :
      ( v148436(VarCurr)
    <=> v148438(VarCurr) ) ).

tff(addAssignment_83960,axiom,
    ! [VarCurr: state_type] :
      ( v148438(VarCurr)
    <=> v148440(VarCurr) ) ).

tff(addAssignment_83959,axiom,
    ! [VarCurr: state_type] :
      ( v148440(VarCurr)
    <=> v148442(VarCurr) ) ).

tff(addAssignment_83958,axiom,
    ! [VarCurr: state_type] :
      ( v148442(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83957,axiom,
    ! [VarCurr: state_type] :
      ( v148424(VarCurr)
    <=> v148426(VarCurr) ) ).

tff(addAssignment_83956,axiom,
    ! [VarCurr: state_type] :
      ( v148426(VarCurr)
    <=> v148428(VarCurr) ) ).

tff(addAssignment_83955,axiom,
    ! [VarCurr: state_type] :
      ( v148428(VarCurr)
    <=> v148430(VarCurr) ) ).

tff(addAssignment_83954,axiom,
    ! [VarCurr: state_type] :
      ( v148430(VarCurr)
    <=> v148432(VarCurr) ) ).

tff(addAssignment_83953,axiom,
    ! [VarCurr: state_type] :
      ( v148432(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v146589(VarCurr,B)
      <=> v146591(VarCurr,B) ) ) ).

tff(addAssignment_83951,axiom,
    ! [VarCurr: state_type] :
      ( v146591(VarCurr,0)
    <=> v148213(VarCurr) ) ).

tff(addAssignment_83950,axiom,
    ! [VarCurr: state_type] :
      ( ( v146591(VarCurr,8)
      <=> v148123(VarCurr,10) )
      & ( v146591(VarCurr,7)
      <=> v148123(VarCurr,9) )
      & ( v146591(VarCurr,6)
      <=> v148123(VarCurr,8) )
      & ( v146591(VarCurr,5)
      <=> v148123(VarCurr,7) )
      & ( v146591(VarCurr,4)
      <=> v148123(VarCurr,6) )
      & ( v146591(VarCurr,3)
      <=> v148123(VarCurr,5) )
      & ( v146591(VarCurr,2)
      <=> v148123(VarCurr,4) )
      & ( v146591(VarCurr,1)
      <=> v148123(VarCurr,3) ) ) ).

tff(addAssignment_83949,axiom,
    ! [VarCurr: state_type] :
      ( ( v146591(VarCurr,23)
      <=> v148029(VarCurr,14) )
      & ( v146591(VarCurr,22)
      <=> v148029(VarCurr,13) )
      & ( v146591(VarCurr,21)
      <=> v148029(VarCurr,12) )
      & ( v146591(VarCurr,20)
      <=> v148029(VarCurr,11) )
      & ( v146591(VarCurr,19)
      <=> v148029(VarCurr,10) )
      & ( v146591(VarCurr,18)
      <=> v148029(VarCurr,9) )
      & ( v146591(VarCurr,17)
      <=> v148029(VarCurr,8) )
      & ( v146591(VarCurr,16)
      <=> v148029(VarCurr,7) )
      & ( v146591(VarCurr,15)
      <=> v148029(VarCurr,6) )
      & ( v146591(VarCurr,14)
      <=> v148029(VarCurr,5) )
      & ( v146591(VarCurr,13)
      <=> v148029(VarCurr,4) )
      & ( v146591(VarCurr,12)
      <=> v148029(VarCurr,3) )
      & ( v146591(VarCurr,11)
      <=> v148029(VarCurr,2) )
      & ( v146591(VarCurr,10)
      <=> v148029(VarCurr,1) )
      & ( v146591(VarCurr,9)
      <=> v148029(VarCurr,0) ) ) ).

tff(addAssignment_83948,axiom,
    ! [VarCurr: state_type] :
      ( ( v146591(VarCurr,26)
      <=> v147943(VarCurr,2) )
      & ( v146591(VarCurr,25)
      <=> v147943(VarCurr,1) )
      & ( v146591(VarCurr,24)
      <=> v147943(VarCurr,0) ) ) ).

tff(addAssignment_83947,axiom,
    ! [VarCurr: state_type] :
      ( ( v146591(VarCurr,30)
      <=> v146593(VarCurr,3) )
      & ( v146591(VarCurr,29)
      <=> v146593(VarCurr,2) )
      & ( v146591(VarCurr,28)
      <=> v146593(VarCurr,1) )
      & ( v146591(VarCurr,27)
      <=> v146593(VarCurr,0) ) ) ).

tff(addAssignment_83946,axiom,
    ! [VarCurr: state_type] :
      ( v146591(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_83945,axiom,
    ! [VarCurr: state_type] :
      ( v148213(VarCurr)
    <=> v148215(VarCurr) ) ).

tff(addAssignment_83944,axiom,
    ! [VarCurr: state_type] :
      ( v148215(VarCurr)
    <=> v148217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19642,axiom,
    ! [VarCurr: state_type] :
      ( v148217(VarCurr)
    <=> ( v148219(VarCurr)
        & v148336(VarCurr) ) ) ).

tff(addAssignment_83943,axiom,
    ! [VarCurr: state_type] :
      ( v148336(VarCurr)
    <=> v148338(VarCurr) ) ).

tff(addAssignment_83942,axiom,
    ! [VarCurr: state_type] :
      ( v148338(VarCurr)
    <=> v148123(VarCurr,2) ) ).

tff(addAssignment_83941,axiom,
    ! [VarCurr: state_type] :
      ( v148123(VarCurr,2)
    <=> v146595(VarCurr,2) ) ).

tff(addAssignment_83940,axiom,
    ! [VarCurr: state_type] :
      ( v146595(VarCurr,2)
    <=> v146597(VarCurr,2) ) ).

tff(addAssignment_83939,axiom,
    ! [VarCurr: state_type] :
      ( v146597(VarCurr,2)
    <=> v147911(VarCurr,2) ) ).

tff(addAssignment_83938,axiom,
    ! [VarCurr: state_type] :
      ( v147787(VarCurr,2)
    <=> v147789(VarCurr,2) ) ).

tff(addAssignment_83937,axiom,
    ! [VarCurr: state_type] :
      ( v147789(VarCurr,2)
    <=> v147896(VarCurr,2) ) ).

tff(addAssignment_83936,axiom,
    ! [VarCurr: state_type] :
      ( v147900(VarCurr,2)
    <=> v147793(VarCurr,2) ) ).

tff(addAssignment_83935,axiom,
    ! [VarCurr: state_type] :
      ( v147793(VarCurr,2)
    <=> v147795(VarCurr,2) ) ).

tff(addAssignment_83934,axiom,
    ! [VarNext: state_type] :
      ( v147795(VarNext,2)
    <=> v148404(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148405(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148404(VarNext,B)
            <=> v147795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2136,axiom,
    ! [VarNext: state_type] :
      ( v148405(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148404(VarNext,B)
          <=> v147890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148405(VarNext)
      <=> v148406(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148406(VarNext)
      <=> ( v148408(VarNext)
          & v147822(VarNext) ) ) ) ).

tff(writeUnaryOperator_11201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148408(VarNext)
      <=> v147884(VarNext) ) ) ).

tff(addAssignment_83933,axiom,
    ! [VarCurr: state_type] :
      ( v147817(VarCurr,2)
    <=> v147819(VarCurr,2) ) ).

tff(addAssignment_83932,axiom,
    ! [VarCurr: state_type] :
      ( v147819(VarCurr,2)
    <=> v147820(VarCurr,2) ) ).

tff(addAssignment_83931,axiom,
    ! [VarCurr: state_type] :
      ( v147662(VarCurr,2)
    <=> v147664(VarCurr,2) ) ).

tff(addAssignment_83930,axiom,
    ! [VarCurr: state_type] :
      ( v147664(VarCurr,2)
    <=> v147771(VarCurr,2) ) ).

tff(addAssignment_83929,axiom,
    ! [VarCurr: state_type] :
      ( v147775(VarCurr,2)
    <=> v147668(VarCurr,2) ) ).

tff(addAssignment_83928,axiom,
    ! [VarCurr: state_type] :
      ( v147668(VarCurr,2)
    <=> v147670(VarCurr,2) ) ).

tff(addAssignment_83927,axiom,
    ! [VarNext: state_type] :
      ( v147670(VarNext,2)
    <=> v148396(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148397(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148396(VarNext,B)
            <=> v147670(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2135,axiom,
    ! [VarNext: state_type] :
      ( v148397(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148396(VarNext,B)
          <=> v147765(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148397(VarNext)
      <=> v148398(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148398(VarNext)
      <=> ( v148400(VarNext)
          & v147697(VarNext) ) ) ) ).

tff(writeUnaryOperator_11200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148400(VarNext)
      <=> v147759(VarNext) ) ) ).

tff(addAssignment_83926,axiom,
    ! [VarCurr: state_type] :
      ( v147692(VarCurr,2)
    <=> v147694(VarCurr,2) ) ).

tff(addAssignment_83925,axiom,
    ! [VarCurr: state_type] :
      ( v147694(VarCurr,2)
    <=> v147695(VarCurr,2) ) ).

tff(addAssignment_83924,axiom,
    ! [VarCurr: state_type] :
      ( v147537(VarCurr,2)
    <=> v147539(VarCurr,2) ) ).

tff(addAssignment_83923,axiom,
    ! [VarCurr: state_type] :
      ( v147539(VarCurr,2)
    <=> v147646(VarCurr,2) ) ).

tff(addAssignment_83922,axiom,
    ! [VarCurr: state_type] :
      ( v147650(VarCurr,2)
    <=> v147543(VarCurr,2) ) ).

tff(addAssignment_83921,axiom,
    ! [VarCurr: state_type] :
      ( v147543(VarCurr,2)
    <=> v147545(VarCurr,2) ) ).

tff(addAssignment_83920,axiom,
    ! [VarNext: state_type] :
      ( v147545(VarNext,2)
    <=> v148388(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148389(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148388(VarNext,B)
            <=> v147545(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2134,axiom,
    ! [VarNext: state_type] :
      ( v148389(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148388(VarNext,B)
          <=> v147640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148389(VarNext)
      <=> v148390(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148390(VarNext)
      <=> ( v148392(VarNext)
          & v147572(VarNext) ) ) ) ).

tff(writeUnaryOperator_11199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148392(VarNext)
      <=> v147634(VarNext) ) ) ).

tff(addAssignment_83919,axiom,
    ! [VarCurr: state_type] :
      ( v147567(VarCurr,2)
    <=> v147569(VarCurr,2) ) ).

tff(addAssignment_83918,axiom,
    ! [VarCurr: state_type] :
      ( v147569(VarCurr,2)
    <=> v147570(VarCurr,2) ) ).

tff(addAssignment_83917,axiom,
    ! [VarCurr: state_type] :
      ( v147412(VarCurr,2)
    <=> v147414(VarCurr,2) ) ).

tff(addAssignment_83916,axiom,
    ! [VarCurr: state_type] :
      ( v147414(VarCurr,2)
    <=> v147521(VarCurr,2) ) ).

tff(addAssignment_83915,axiom,
    ! [VarCurr: state_type] :
      ( v147525(VarCurr,2)
    <=> v147418(VarCurr,2) ) ).

tff(addAssignment_83914,axiom,
    ! [VarCurr: state_type] :
      ( v147418(VarCurr,2)
    <=> v147420(VarCurr,2) ) ).

tff(addAssignment_83913,axiom,
    ! [VarNext: state_type] :
      ( v147420(VarNext,2)
    <=> v148380(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148381(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148380(VarNext,B)
            <=> v147420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2133,axiom,
    ! [VarNext: state_type] :
      ( v148381(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148380(VarNext,B)
          <=> v147515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148381(VarNext)
      <=> v148382(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148382(VarNext)
      <=> ( v148384(VarNext)
          & v147447(VarNext) ) ) ) ).

tff(writeUnaryOperator_11198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148384(VarNext)
      <=> v147509(VarNext) ) ) ).

tff(addAssignment_83912,axiom,
    ! [VarCurr: state_type] :
      ( v147442(VarCurr,2)
    <=> v147444(VarCurr,2) ) ).

tff(addAssignment_83911,axiom,
    ! [VarCurr: state_type] :
      ( v147444(VarCurr,2)
    <=> v147445(VarCurr,2) ) ).

tff(addAssignment_83910,axiom,
    ! [VarCurr: state_type] :
      ( v147287(VarCurr,2)
    <=> v147289(VarCurr,2) ) ).

tff(addAssignment_83909,axiom,
    ! [VarCurr: state_type] :
      ( v147289(VarCurr,2)
    <=> v147396(VarCurr,2) ) ).

tff(addAssignment_83908,axiom,
    ! [VarCurr: state_type] :
      ( v147400(VarCurr,2)
    <=> v147293(VarCurr,2) ) ).

tff(addAssignment_83907,axiom,
    ! [VarCurr: state_type] :
      ( v147293(VarCurr,2)
    <=> v147295(VarCurr,2) ) ).

tff(addAssignment_83906,axiom,
    ! [VarNext: state_type] :
      ( v147295(VarNext,2)
    <=> v148372(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148373(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148372(VarNext,B)
            <=> v147295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2132,axiom,
    ! [VarNext: state_type] :
      ( v148373(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148372(VarNext,B)
          <=> v147390(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148373(VarNext)
      <=> v148374(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148374(VarNext)
      <=> ( v148376(VarNext)
          & v147322(VarNext) ) ) ) ).

tff(writeUnaryOperator_11197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148376(VarNext)
      <=> v147384(VarNext) ) ) ).

tff(addAssignment_83905,axiom,
    ! [VarCurr: state_type] :
      ( v147317(VarCurr,2)
    <=> v147319(VarCurr,2) ) ).

tff(addAssignment_83904,axiom,
    ! [VarCurr: state_type] :
      ( v147319(VarCurr,2)
    <=> v147320(VarCurr,2) ) ).

tff(addAssignment_83903,axiom,
    ! [VarCurr: state_type] :
      ( v147162(VarCurr,2)
    <=> v147164(VarCurr,2) ) ).

tff(addAssignment_83902,axiom,
    ! [VarCurr: state_type] :
      ( v147164(VarCurr,2)
    <=> v147271(VarCurr,2) ) ).

tff(addAssignment_83901,axiom,
    ! [VarCurr: state_type] :
      ( v147275(VarCurr,2)
    <=> v147168(VarCurr,2) ) ).

tff(addAssignment_83900,axiom,
    ! [VarCurr: state_type] :
      ( v147168(VarCurr,2)
    <=> v147170(VarCurr,2) ) ).

tff(addAssignment_83899,axiom,
    ! [VarNext: state_type] :
      ( v147170(VarNext,2)
    <=> v148364(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148365(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148364(VarNext,B)
            <=> v147170(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2131,axiom,
    ! [VarNext: state_type] :
      ( v148365(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148364(VarNext,B)
          <=> v147265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148365(VarNext)
      <=> v148366(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148366(VarNext)
      <=> ( v148368(VarNext)
          & v147197(VarNext) ) ) ) ).

tff(writeUnaryOperator_11196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148368(VarNext)
      <=> v147259(VarNext) ) ) ).

tff(addAssignment_83898,axiom,
    ! [VarCurr: state_type] :
      ( v147192(VarCurr,2)
    <=> v147194(VarCurr,2) ) ).

tff(addAssignment_83897,axiom,
    ! [VarCurr: state_type] :
      ( v147194(VarCurr,2)
    <=> v147195(VarCurr,2) ) ).

tff(addAssignment_83896,axiom,
    ! [VarCurr: state_type] :
      ( v147037(VarCurr,2)
    <=> v147039(VarCurr,2) ) ).

tff(addAssignment_83895,axiom,
    ! [VarCurr: state_type] :
      ( v147039(VarCurr,2)
    <=> v147146(VarCurr,2) ) ).

tff(addAssignment_83894,axiom,
    ! [VarCurr: state_type] :
      ( v147150(VarCurr,2)
    <=> v147043(VarCurr,2) ) ).

tff(addAssignment_83893,axiom,
    ! [VarCurr: state_type] :
      ( v147043(VarCurr,2)
    <=> v147045(VarCurr,2) ) ).

tff(addAssignment_83892,axiom,
    ! [VarNext: state_type] :
      ( v147045(VarNext,2)
    <=> v148356(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148357(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148356(VarNext,B)
            <=> v147045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2130,axiom,
    ! [VarNext: state_type] :
      ( v148357(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148356(VarNext,B)
          <=> v147140(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148357(VarNext)
      <=> v148358(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148358(VarNext)
      <=> ( v148360(VarNext)
          & v147072(VarNext) ) ) ) ).

tff(writeUnaryOperator_11195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148360(VarNext)
      <=> v147134(VarNext) ) ) ).

tff(addAssignment_83891,axiom,
    ! [VarCurr: state_type] :
      ( v147067(VarCurr,2)
    <=> v147069(VarCurr,2) ) ).

tff(addAssignment_83890,axiom,
    ! [VarCurr: state_type] :
      ( v147069(VarCurr,2)
    <=> v147070(VarCurr,2) ) ).

tff(addAssignment_83889,axiom,
    ! [VarCurr: state_type] :
      ( v146599(VarCurr,2)
    <=> v146601(VarCurr,2) ) ).

tff(addAssignment_83888,axiom,
    ! [VarCurr: state_type] :
      ( v146601(VarCurr,2)
    <=> v146808(VarCurr,2) ) ).

tff(addAssignment_83887,axiom,
    ! [VarCurr: state_type] :
      ( v146812(VarCurr,2)
    <=> v146605(VarCurr,2) ) ).

tff(addAssignment_83886,axiom,
    ! [VarCurr: state_type] :
      ( v146605(VarCurr,2)
    <=> v146607(VarCurr,2) ) ).

tff(addAssignment_83885,axiom,
    ! [VarNext: state_type] :
      ( v146607(VarNext,2)
    <=> v148348(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148349(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148348(VarNext,B)
            <=> v146607(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2129,axiom,
    ! [VarNext: state_type] :
      ( v148349(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148348(VarNext,B)
          <=> v146802(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148349(VarNext)
      <=> v148350(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148350(VarNext)
      <=> ( v148352(VarNext)
          & v146730(VarNext) ) ) ) ).

tff(writeUnaryOperator_11194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148352(VarNext)
      <=> v146796(VarNext) ) ) ).

tff(addAssignment_83884,axiom,
    ! [VarCurr: state_type] :
      ( v146637(VarCurr,2)
    <=> v146639(VarCurr,2) ) ).

tff(addAssignment_83883,axiom,
    ! [VarCurr: state_type] :
      ( v146639(VarCurr,2)
    <=> v146724(VarCurr,2) ) ).

tff(addAssignment_83882,axiom,
    ! [VarCurr: state_type] :
      ( v146728(VarCurr,2)
    <=> v146643(VarCurr,2) ) ).

tff(addAssignment_83881,axiom,
    ! [VarCurr: state_type] :
      ( v146643(VarCurr,2)
    <=> v146645(VarCurr,2) ) ).

tff(addAssignment_83880,axiom,
    ! [VarNext: state_type] :
      ( v146645(VarNext,2)
    <=> v148340(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148341(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148340(VarNext,B)
            <=> v146645(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2128,axiom,
    ! [VarNext: state_type] :
      ( v148341(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148340(VarNext,B)
          <=> v146718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148341(VarNext)
      <=> v148342(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148342(VarNext)
      <=> ( v148344(VarNext)
          & v146683(VarNext) ) ) ) ).

tff(writeUnaryOperator_11193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148344(VarNext)
      <=> v146712(VarNext) ) ) ).

tff(addAssignment_83879,axiom,
    ! [VarCurr: state_type] :
      ( v146667(VarCurr,2)
    <=> v146669(VarCurr,2) ) ).

tff(addAssignment_83878,axiom,
    ! [VarCurr: state_type] :
      ( v146669(VarCurr,2)
    <=> v146677(VarCurr,2) ) ).

tff(addAssignment_83877,axiom,
    ! [VarCurr: state_type] :
      ( v146681(VarCurr,2)
    <=> v148128(VarCurr,2) ) ).

tff(addAssignment_83876,axiom,
    ! [VarCurr: state_type] :
      ( v148128(VarCurr,2)
    <=> v148130(VarCurr,2) ) ).

tff(addAssignment_83875,axiom,
    ! [VarCurr: state_type] :
      ( v148130(VarCurr,2)
    <=> v148132(VarCurr,2) ) ).

tff(addAssignment_83874,axiom,
    ! [VarCurr: state_type] :
      ( v148132(VarCurr,2)
    <=> v148040(VarCurr,28) ) ).

tff(addAssignment_83873,axiom,
    ! [VarCurr: state_type] :
      ( v148040(VarCurr,28)
    <=> v148042(VarCurr,28) ) ).

tff(addAssignment_83872,axiom,
    ! [VarCurr: state_type] :
      ( v148219(VarCurr)
    <=> v148221(VarCurr) ) ).

tff(addAssignment_83871,axiom,
    ! [VarCurr: state_type] :
      ( v148221(VarCurr)
    <=> v148223(VarCurr) ) ).

tff(addAssignment_83870,axiom,
    ! [VarCurr: state_type] :
      ( v148223(VarCurr)
    <=> v148225(VarCurr) ) ).

tff(addAssignment_83869,axiom,
    ! [VarCurr: state_type] :
      ( v148225(VarCurr)
    <=> v148227(VarCurr) ) ).

tff(writeUnaryOperator_11192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148227(VarCurr)
    <=> v148229(VarCurr) ) ).

tff(addAssignment_83868,axiom,
    ! [VarCurr: state_type] :
      ( v148229(VarCurr)
    <=> v148231(VarCurr) ) ).

tff(addAssignment_83867,axiom,
    ! [VarCurr: state_type] :
      ( v148231(VarCurr)
    <=> v148233(VarCurr) ) ).

tff(addAssignment_83866,axiom,
    ! [VarCurr: state_type] :
      ( v148233(VarCurr)
    <=> v148235(VarCurr,33) ) ).

tff(addAssignment_83865,axiom,
    ! [VarCurr: state_type] :
      ( v148235(VarCurr,33)
    <=> v148237(VarCurr,33) ) ).

tff(addAssignment_83864,axiom,
    ! [VarNext: state_type] :
      ( v148237(VarNext,33)
    <=> v148317(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_2127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148318(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v148317(VarNext,B)
            <=> v148237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2127,axiom,
    ! [VarNext: state_type] :
      ( v148318(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148317(VarNext,B)
          <=> v148328(VarNext,B) ) ) ) ).

tff(addAssignment_83863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148328(VarNext,B)
          <=> v148326(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148326(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1631,axiom,
    ! [VarCurr: state_type] :
      ( v148329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v148326(VarCurr,B)
          <=> v148259(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19623,axiom,
    ! [VarCurr: state_type] :
      ( v148329(VarCurr)
    <=> ( v148330(VarCurr)
        & v148331(VarCurr) ) ) ).

tff(writeUnaryOperator_11191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148331(VarCurr)
    <=> v148249(VarCurr) ) ).

tff(writeUnaryOperator_11190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148330(VarCurr)
    <=> v148239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148318(VarNext)
      <=> v148319(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148319(VarNext)
      <=> ( v148320(VarNext)
          & v148270(VarNext) ) ) ) ).

tff(writeUnaryOperator_11189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148320(VarNext)
      <=> v148322(VarNext) ) ) ).

tff(addAssignment_83862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148322(VarNext)
      <=> v148270(VarCurr) ) ) ).

tff(addAssignment_83861,axiom,
    ! [VarCurr: state_type] :
      ( v148270(VarCurr)
    <=> v148272(VarCurr) ) ).

tff(addAssignment_83860,axiom,
    ! [VarCurr: state_type] :
      ( v148272(VarCurr)
    <=> v148274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19620,axiom,
    ! [VarCurr: state_type] :
      ( v148274(VarCurr)
    <=> ( v148315(VarCurr)
        | v148311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19619,axiom,
    ! [VarCurr: state_type] :
      ( v148315(VarCurr)
    <=> ( v148276(VarCurr)
        & v148280(VarCurr) ) ) ).

tff(addAssignment_83859,axiom,
    ! [VarCurr: state_type] :
      ( v148311(VarCurr)
    <=> v148313(VarCurr) ) ).

tff(addAssignment_83858,axiom,
    ! [VarCurr: state_type] :
      ( v148313(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148295(VarNext)
       => ( v148280(VarNext)
        <=> v148280(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2126,axiom,
    ! [VarNext: state_type] :
      ( v148295(VarNext)
     => ( v148280(VarNext)
      <=> v148305(VarNext) ) ) ).

tff(addAssignment_83857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148305(VarNext)
      <=> v148303(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19618,axiom,
    ! [VarCurr: state_type] :
      ( v148303(VarCurr)
    <=> ( v148306(VarCurr)
        & v148307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19617,axiom,
    ! [VarCurr: state_type] :
      ( v148307(VarCurr)
    <=> ( v148286(VarCurr)
        | v148290(VarCurr) ) ) ).

tff(writeUnaryOperator_11188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148306(VarCurr)
    <=> v148282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148295(VarNext)
      <=> v148296(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148296(VarNext)
      <=> ( v148298(VarNext)
          & v148300(VarNext) ) ) ) ).

tff(writeUnaryOperator_11187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v148300(VarCurr)
    <=> v148276(VarCurr) ) ).

tff(addAssignment_83856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148298(VarNext)
      <=> v148276(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_283,axiom,
    ( v148280(constB0)
  <=> $true ) ).

tff(addAssignment_83855,axiom,
    ! [VarCurr: state_type] :
      ( v148290(VarCurr)
    <=> v148292(VarCurr) ) ).

tff(addAssignment_83854,axiom,
    ! [VarCurr: state_type] :
      ( v148292(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83853,axiom,
    ! [VarCurr: state_type] :
      ( v148286(VarCurr)
    <=> v148288(VarCurr) ) ).

tff(addAssignment_83852,axiom,
    ! [VarCurr: state_type] :
      ( v148288(VarCurr)
    <=> $true ) ).

tff(addAssignment_83851,axiom,
    ! [VarCurr: state_type] :
      ( v148282(VarCurr)
    <=> v148284(VarCurr) ) ).

tff(addAssignment_83850,axiom,
    ! [VarCurr: state_type] :
      ( v148284(VarCurr)
    <=> $false ) ).

tff(addAssignment_83849,axiom,
    ! [VarCurr: state_type] :
      ( v148276(VarCurr)
    <=> v148278(VarCurr) ) ).

tff(addAssignment_83848,axiom,
    ! [VarCurr: state_type] :
      ( v148278(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83847,axiom,
    ! [VarCurr: state_type] :
      ( v148259(VarCurr,33)
    <=> v148261(VarCurr,33) ) ).

tff(addAssignment_83846,axiom,
    ! [VarCurr: state_type] :
      ( v148261(VarCurr,33)
    <=> v148264(VarCurr,33) ) ).

tff(addAssignment_83845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v148264(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_83844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v148264(VarCurr,B)
      <=> v148268(VarCurr,B) ) ) ).

tff(addAssignment_83843,axiom,
    ! [VarCurr: state_type] :
      ( ( v148264(VarCurr,25)
      <=> v148267(VarCurr,14) )
      & ( v148264(VarCurr,24)
      <=> v148267(VarCurr,13) )
      & ( v148264(VarCurr,23)
      <=> v148267(VarCurr,12) )
      & ( v148264(VarCurr,22)
      <=> v148267(VarCurr,11) )
      & ( v148264(VarCurr,21)
      <=> v148267(VarCurr,10) )
      & ( v148264(VarCurr,20)
      <=> v148267(VarCurr,9) )
      & ( v148264(VarCurr,19)
      <=> v148267(VarCurr,8) )
      & ( v148264(VarCurr,18)
      <=> v148267(VarCurr,7) )
      & ( v148264(VarCurr,17)
      <=> v148267(VarCurr,6) )
      & ( v148264(VarCurr,16)
      <=> v148267(VarCurr,5) )
      & ( v148264(VarCurr,15)
      <=> v148267(VarCurr,4) )
      & ( v148264(VarCurr,14)
      <=> v148267(VarCurr,3) )
      & ( v148264(VarCurr,13)
      <=> v148267(VarCurr,2) )
      & ( v148264(VarCurr,12)
      <=> v148267(VarCurr,1) )
      & ( v148264(VarCurr,11)
      <=> v148267(VarCurr,0) ) ) ).

tff(addAssignment_83842,axiom,
    ! [VarCurr: state_type] :
      ( ( v148264(VarCurr,28)
      <=> v148266(VarCurr,2) )
      & ( v148264(VarCurr,27)
      <=> v148266(VarCurr,1) )
      & ( v148264(VarCurr,26)
      <=> v148266(VarCurr,0) ) ) ).

tff(addAssignment_83841,axiom,
    ! [VarCurr: state_type] :
      ( ( v148264(VarCurr,32)
      <=> v148265(VarCurr,3) )
      & ( v148264(VarCurr,31)
      <=> v148265(VarCurr,2) )
      & ( v148264(VarCurr,30)
      <=> v148265(VarCurr,1) )
      & ( v148264(VarCurr,29)
      <=> v148265(VarCurr,0) ) ) ).

tff(addAssignment_83840,axiom,
    ! [VarCurr: state_type] :
      ( v148264(VarCurr,33)
    <=> v148263(VarCurr) ) ).

tff(addAssignment_83839,axiom,
    ! [VarCurr: state_type] :
      ( v148263(VarCurr)
    <=> v132032(VarCurr) ) ).

tff(addAssignment_83838,axiom,
    ! [VarCurr: state_type] :
      ( v148249(VarCurr)
    <=> v148251(VarCurr) ) ).

tff(addAssignment_83837,axiom,
    ! [VarCurr: state_type] :
      ( v148251(VarCurr)
    <=> v148253(VarCurr) ) ).

tff(addAssignment_83836,axiom,
    ! [VarCurr: state_type] :
      ( v148253(VarCurr)
    <=> v148255(VarCurr) ) ).

tff(addAssignment_83835,axiom,
    ! [VarCurr: state_type] :
      ( v148255(VarCurr)
    <=> v148257(VarCurr) ) ).

tff(addAssignment_83834,axiom,
    ! [VarCurr: state_type] :
      ( v148257(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83833,axiom,
    ! [VarCurr: state_type] :
      ( v148239(VarCurr)
    <=> v148241(VarCurr) ) ).

tff(addAssignment_83832,axiom,
    ! [VarCurr: state_type] :
      ( v148241(VarCurr)
    <=> v148243(VarCurr) ) ).

tff(addAssignment_83831,axiom,
    ! [VarCurr: state_type] :
      ( v148243(VarCurr)
    <=> v148245(VarCurr) ) ).

tff(addAssignment_83830,axiom,
    ! [VarCurr: state_type] :
      ( v148245(VarCurr)
    <=> v148247(VarCurr) ) ).

tff(addAssignment_83829,axiom,
    ! [VarCurr: state_type] :
      ( v148247(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v148123(VarCurr,B)
      <=> v146595(VarCurr,B) ) ) ).

tff(addAssignment_83827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146595(VarCurr,B)
      <=> v146597(VarCurr,B) ) ) ).

tff(addAssignment_83826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146597(VarCurr,B)
      <=> v147911(VarCurr,B) ) ) ).

tff(addAssignment_83825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147787(VarCurr,B)
      <=> v147789(VarCurr,B) ) ) ).

tff(addAssignment_83824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147789(VarCurr,B)
      <=> v147896(VarCurr,B) ) ) ).

tff(addAssignment_83823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147900(VarCurr,B)
      <=> v147793(VarCurr,B) ) ) ).

tff(addAssignment_83822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147793(VarCurr,B)
      <=> v147795(VarCurr,B) ) ) ).

tff(addAssignment_83821,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147795(VarNext,B)
      <=> v148205(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148206(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148205(VarNext,B)
            <=> v147795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2125,axiom,
    ! [VarNext: state_type] :
      ( v148206(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148205(VarNext,B)
          <=> v147890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148206(VarNext)
      <=> v148207(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148207(VarNext)
      <=> ( v148209(VarNext)
          & v147822(VarNext) ) ) ) ).

tff(writeUnaryOperator_11186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148209(VarNext)
      <=> v147884(VarNext) ) ) ).

tff(addAssignment_83820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147817(VarCurr,B)
      <=> v147819(VarCurr,B) ) ) ).

tff(addAssignment_83819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147819(VarCurr,B)
      <=> v147820(VarCurr,B) ) ) ).

tff(addAssignment_83818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147662(VarCurr,B)
      <=> v147664(VarCurr,B) ) ) ).

tff(addAssignment_83817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147664(VarCurr,B)
      <=> v147771(VarCurr,B) ) ) ).

tff(addAssignment_83816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147775(VarCurr,B)
      <=> v147668(VarCurr,B) ) ) ).

tff(addAssignment_83815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147668(VarCurr,B)
      <=> v147670(VarCurr,B) ) ) ).

tff(addAssignment_83814,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147670(VarNext,B)
      <=> v148196(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148197(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148196(VarNext,B)
            <=> v147670(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2124,axiom,
    ! [VarNext: state_type] :
      ( v148197(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148196(VarNext,B)
          <=> v147765(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148197(VarNext)
      <=> v148198(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148198(VarNext)
      <=> ( v148200(VarNext)
          & v147697(VarNext) ) ) ) ).

tff(writeUnaryOperator_11185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148200(VarNext)
      <=> v147759(VarNext) ) ) ).

tff(addAssignment_83813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147692(VarCurr,B)
      <=> v147694(VarCurr,B) ) ) ).

tff(addAssignment_83812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147694(VarCurr,B)
      <=> v147695(VarCurr,B) ) ) ).

tff(addAssignment_83811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147537(VarCurr,B)
      <=> v147539(VarCurr,B) ) ) ).

tff(addAssignment_83810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147539(VarCurr,B)
      <=> v147646(VarCurr,B) ) ) ).

tff(addAssignment_83809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147650(VarCurr,B)
      <=> v147543(VarCurr,B) ) ) ).

tff(addAssignment_83808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147543(VarCurr,B)
      <=> v147545(VarCurr,B) ) ) ).

tff(addAssignment_83807,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147545(VarNext,B)
      <=> v148187(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148188(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148187(VarNext,B)
            <=> v147545(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2123,axiom,
    ! [VarNext: state_type] :
      ( v148188(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148187(VarNext,B)
          <=> v147640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148188(VarNext)
      <=> v148189(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148189(VarNext)
      <=> ( v148191(VarNext)
          & v147572(VarNext) ) ) ) ).

tff(writeUnaryOperator_11184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148191(VarNext)
      <=> v147634(VarNext) ) ) ).

tff(addAssignment_83806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147567(VarCurr,B)
      <=> v147569(VarCurr,B) ) ) ).

tff(addAssignment_83805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147569(VarCurr,B)
      <=> v147570(VarCurr,B) ) ) ).

tff(addAssignment_83804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147412(VarCurr,B)
      <=> v147414(VarCurr,B) ) ) ).

tff(addAssignment_83803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147414(VarCurr,B)
      <=> v147521(VarCurr,B) ) ) ).

tff(addAssignment_83802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147525(VarCurr,B)
      <=> v147418(VarCurr,B) ) ) ).

tff(addAssignment_83801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147418(VarCurr,B)
      <=> v147420(VarCurr,B) ) ) ).

tff(addAssignment_83800,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147420(VarNext,B)
      <=> v148178(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148179(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148178(VarNext,B)
            <=> v147420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2122,axiom,
    ! [VarNext: state_type] :
      ( v148179(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148178(VarNext,B)
          <=> v147515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148179(VarNext)
      <=> v148180(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148180(VarNext)
      <=> ( v148182(VarNext)
          & v147447(VarNext) ) ) ) ).

tff(writeUnaryOperator_11183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148182(VarNext)
      <=> v147509(VarNext) ) ) ).

tff(addAssignment_83799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147442(VarCurr,B)
      <=> v147444(VarCurr,B) ) ) ).

tff(addAssignment_83798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147444(VarCurr,B)
      <=> v147445(VarCurr,B) ) ) ).

tff(addAssignment_83797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147287(VarCurr,B)
      <=> v147289(VarCurr,B) ) ) ).

tff(addAssignment_83796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147289(VarCurr,B)
      <=> v147396(VarCurr,B) ) ) ).

tff(addAssignment_83795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147400(VarCurr,B)
      <=> v147293(VarCurr,B) ) ) ).

tff(addAssignment_83794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147293(VarCurr,B)
      <=> v147295(VarCurr,B) ) ) ).

tff(addAssignment_83793,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147295(VarNext,B)
      <=> v148169(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148170(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148169(VarNext,B)
            <=> v147295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2121,axiom,
    ! [VarNext: state_type] :
      ( v148170(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148169(VarNext,B)
          <=> v147390(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148170(VarNext)
      <=> v148171(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148171(VarNext)
      <=> ( v148173(VarNext)
          & v147322(VarNext) ) ) ) ).

tff(writeUnaryOperator_11182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148173(VarNext)
      <=> v147384(VarNext) ) ) ).

tff(addAssignment_83792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147317(VarCurr,B)
      <=> v147319(VarCurr,B) ) ) ).

tff(addAssignment_83791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147319(VarCurr,B)
      <=> v147320(VarCurr,B) ) ) ).

tff(addAssignment_83790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147162(VarCurr,B)
      <=> v147164(VarCurr,B) ) ) ).

tff(addAssignment_83789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147164(VarCurr,B)
      <=> v147271(VarCurr,B) ) ) ).

tff(addAssignment_83788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147275(VarCurr,B)
      <=> v147168(VarCurr,B) ) ) ).

tff(addAssignment_83787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147168(VarCurr,B)
      <=> v147170(VarCurr,B) ) ) ).

tff(addAssignment_83786,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147170(VarNext,B)
      <=> v148160(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148161(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148160(VarNext,B)
            <=> v147170(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2120,axiom,
    ! [VarNext: state_type] :
      ( v148161(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148160(VarNext,B)
          <=> v147265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148161(VarNext)
      <=> v148162(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148162(VarNext)
      <=> ( v148164(VarNext)
          & v147197(VarNext) ) ) ) ).

tff(writeUnaryOperator_11181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148164(VarNext)
      <=> v147259(VarNext) ) ) ).

tff(addAssignment_83785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147192(VarCurr,B)
      <=> v147194(VarCurr,B) ) ) ).

tff(addAssignment_83784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147194(VarCurr,B)
      <=> v147195(VarCurr,B) ) ) ).

tff(addAssignment_83783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147037(VarCurr,B)
      <=> v147039(VarCurr,B) ) ) ).

tff(addAssignment_83782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147039(VarCurr,B)
      <=> v147146(VarCurr,B) ) ) ).

tff(addAssignment_83781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147150(VarCurr,B)
      <=> v147043(VarCurr,B) ) ) ).

tff(addAssignment_83780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147043(VarCurr,B)
      <=> v147045(VarCurr,B) ) ) ).

tff(addAssignment_83779,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147045(VarNext,B)
      <=> v148151(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148152(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148151(VarNext,B)
            <=> v147045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2119,axiom,
    ! [VarNext: state_type] :
      ( v148152(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148151(VarNext,B)
          <=> v147140(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148152(VarNext)
      <=> v148153(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148153(VarNext)
      <=> ( v148155(VarNext)
          & v147072(VarNext) ) ) ) ).

tff(writeUnaryOperator_11180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148155(VarNext)
      <=> v147134(VarNext) ) ) ).

tff(addAssignment_83778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147067(VarCurr,B)
      <=> v147069(VarCurr,B) ) ) ).

tff(addAssignment_83777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v147069(VarCurr,B)
      <=> v147070(VarCurr,B) ) ) ).

tff(addAssignment_83776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146599(VarCurr,B)
      <=> v146601(VarCurr,B) ) ) ).

tff(addAssignment_83775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146601(VarCurr,B)
      <=> v146808(VarCurr,B) ) ) ).

tff(addAssignment_83774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146812(VarCurr,B)
      <=> v146605(VarCurr,B) ) ) ).

tff(addAssignment_83773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146605(VarCurr,B)
      <=> v146607(VarCurr,B) ) ) ).

tff(addAssignment_83772,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146607(VarNext,B)
      <=> v148142(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148143(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148142(VarNext,B)
            <=> v146607(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2118,axiom,
    ! [VarNext: state_type] :
      ( v148143(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148142(VarNext,B)
          <=> v146802(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148143(VarNext)
      <=> v148144(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148144(VarNext)
      <=> ( v148146(VarNext)
          & v146730(VarNext) ) ) ) ).

tff(writeUnaryOperator_11179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148146(VarNext)
      <=> v146796(VarNext) ) ) ).

tff(addAssignment_83771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146637(VarCurr,B)
      <=> v146639(VarCurr,B) ) ) ).

tff(addAssignment_83770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146639(VarCurr,B)
      <=> v146724(VarCurr,B) ) ) ).

tff(addAssignment_83769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146728(VarCurr,B)
      <=> v146643(VarCurr,B) ) ) ).

tff(addAssignment_83768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146643(VarCurr,B)
      <=> v146645(VarCurr,B) ) ) ).

tff(addAssignment_83767,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146645(VarNext,B)
      <=> v148134(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148135(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148134(VarNext,B)
            <=> v146645(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2117,axiom,
    ! [VarNext: state_type] :
      ( v148135(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148134(VarNext,B)
          <=> v146718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148135(VarNext)
      <=> v148136(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148136(VarNext)
      <=> ( v148138(VarNext)
          & v146683(VarNext) ) ) ) ).

tff(writeUnaryOperator_11178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148138(VarNext)
      <=> v146712(VarNext) ) ) ).

tff(addAssignment_83766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146667(VarCurr,B)
      <=> v146669(VarCurr,B) ) ) ).

tff(addAssignment_83765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146669(VarCurr,B)
      <=> v146677(VarCurr,B) ) ) ).

tff(addAssignment_83764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v146681(VarCurr,B)
      <=> v148128(VarCurr,B) ) ) ).

tff(addAssignment_83763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v148128(VarCurr,B)
      <=> v148130(VarCurr,B) ) ) ).

tff(addAssignment_83762,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v148130(VarCurr,B)
      <=> v148132(VarCurr,B) ) ) ).

tff(addAssignment_83761,axiom,
    ! [VarCurr: state_type] :
      ( ( v148132(VarCurr,10)
      <=> v148040(VarCurr,36) )
      & ( v148132(VarCurr,9)
      <=> v148040(VarCurr,35) )
      & ( v148132(VarCurr,8)
      <=> v148040(VarCurr,34) )
      & ( v148132(VarCurr,7)
      <=> v148040(VarCurr,33) )
      & ( v148132(VarCurr,6)
      <=> v148040(VarCurr,32) )
      & ( v148132(VarCurr,5)
      <=> v148040(VarCurr,31) )
      & ( v148132(VarCurr,4)
      <=> v148040(VarCurr,30) )
      & ( v148132(VarCurr,3)
      <=> v148040(VarCurr,29) ) ) ).

tff(addAssignment_83760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,37)
        & ~ $less(B,29) )
     => ( v148040(VarCurr,B)
      <=> v148042(VarCurr,B) ) ) ).

tff(addAssignment_83759,axiom,
    ! [VarCurr: state_type] :
      ( ( v148029(VarCurr,14)
      <=> v146595(VarCurr,25) )
      & ( v148029(VarCurr,13)
      <=> v146595(VarCurr,24) )
      & ( v148029(VarCurr,12)
      <=> v146595(VarCurr,23) )
      & ( v148029(VarCurr,11)
      <=> v146595(VarCurr,22) )
      & ( v148029(VarCurr,10)
      <=> v146595(VarCurr,21) )
      & ( v148029(VarCurr,9)
      <=> v146595(VarCurr,20) )
      & ( v148029(VarCurr,8)
      <=> v146595(VarCurr,19) )
      & ( v148029(VarCurr,7)
      <=> v146595(VarCurr,18) )
      & ( v148029(VarCurr,6)
      <=> v146595(VarCurr,17) )
      & ( v148029(VarCurr,5)
      <=> v146595(VarCurr,16) )
      & ( v148029(VarCurr,4)
      <=> v146595(VarCurr,15) )
      & ( v148029(VarCurr,3)
      <=> v146595(VarCurr,14) )
      & ( v148029(VarCurr,2)
      <=> v146595(VarCurr,13) )
      & ( v148029(VarCurr,1)
      <=> v146595(VarCurr,12) )
      & ( v148029(VarCurr,0)
      <=> v146595(VarCurr,11) ) ) ).

tff(addAssignment_83758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146595(VarCurr,B)
      <=> v146597(VarCurr,B) ) ) ).

tff(addAssignment_83757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146597(VarCurr,B)
      <=> v147911(VarCurr,B) ) ) ).

tff(addAssignment_83756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147787(VarCurr,B)
      <=> v147789(VarCurr,B) ) ) ).

tff(addAssignment_83755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147789(VarCurr,B)
      <=> v147896(VarCurr,B) ) ) ).

tff(addAssignment_83754,axiom,
    ! [VarCurr: state_type] :
      ( ( v147899(VarCurr,14)
      <=> v147793(VarCurr,25) )
      & ( v147899(VarCurr,13)
      <=> v147793(VarCurr,24) )
      & ( v147899(VarCurr,12)
      <=> v147793(VarCurr,23) )
      & ( v147899(VarCurr,11)
      <=> v147793(VarCurr,22) )
      & ( v147899(VarCurr,10)
      <=> v147793(VarCurr,21) )
      & ( v147899(VarCurr,9)
      <=> v147793(VarCurr,20) )
      & ( v147899(VarCurr,8)
      <=> v147793(VarCurr,19) )
      & ( v147899(VarCurr,7)
      <=> v147793(VarCurr,18) )
      & ( v147899(VarCurr,6)
      <=> v147793(VarCurr,17) )
      & ( v147899(VarCurr,5)
      <=> v147793(VarCurr,16) )
      & ( v147899(VarCurr,4)
      <=> v147793(VarCurr,15) )
      & ( v147899(VarCurr,3)
      <=> v147793(VarCurr,14) )
      & ( v147899(VarCurr,2)
      <=> v147793(VarCurr,13) )
      & ( v147899(VarCurr,1)
      <=> v147793(VarCurr,12) )
      & ( v147899(VarCurr,0)
      <=> v147793(VarCurr,11) ) ) ).

tff(addAssignment_83753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147793(VarCurr,B)
      <=> v147795(VarCurr,B) ) ) ).

tff(addAssignment_83752,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147795(VarNext,B)
      <=> v148115(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148116(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148115(VarNext,B)
            <=> v147795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2116,axiom,
    ! [VarNext: state_type] :
      ( v148116(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148115(VarNext,B)
          <=> v147890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148116(VarNext)
      <=> v148117(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148117(VarNext)
      <=> ( v148119(VarNext)
          & v147822(VarNext) ) ) ) ).

tff(writeUnaryOperator_11177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148119(VarNext)
      <=> v147884(VarNext) ) ) ).

tff(addAssignment_83751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147817(VarCurr,B)
      <=> v147819(VarCurr,B) ) ) ).

tff(addAssignment_83750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147819(VarCurr,B)
      <=> v147820(VarCurr,B) ) ) ).

tff(addAssignment_83749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147662(VarCurr,B)
      <=> v147664(VarCurr,B) ) ) ).

tff(addAssignment_83748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147664(VarCurr,B)
      <=> v147771(VarCurr,B) ) ) ).

tff(addAssignment_83747,axiom,
    ! [VarCurr: state_type] :
      ( ( v147774(VarCurr,14)
      <=> v147668(VarCurr,25) )
      & ( v147774(VarCurr,13)
      <=> v147668(VarCurr,24) )
      & ( v147774(VarCurr,12)
      <=> v147668(VarCurr,23) )
      & ( v147774(VarCurr,11)
      <=> v147668(VarCurr,22) )
      & ( v147774(VarCurr,10)
      <=> v147668(VarCurr,21) )
      & ( v147774(VarCurr,9)
      <=> v147668(VarCurr,20) )
      & ( v147774(VarCurr,8)
      <=> v147668(VarCurr,19) )
      & ( v147774(VarCurr,7)
      <=> v147668(VarCurr,18) )
      & ( v147774(VarCurr,6)
      <=> v147668(VarCurr,17) )
      & ( v147774(VarCurr,5)
      <=> v147668(VarCurr,16) )
      & ( v147774(VarCurr,4)
      <=> v147668(VarCurr,15) )
      & ( v147774(VarCurr,3)
      <=> v147668(VarCurr,14) )
      & ( v147774(VarCurr,2)
      <=> v147668(VarCurr,13) )
      & ( v147774(VarCurr,1)
      <=> v147668(VarCurr,12) )
      & ( v147774(VarCurr,0)
      <=> v147668(VarCurr,11) ) ) ).

tff(addAssignment_83746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147668(VarCurr,B)
      <=> v147670(VarCurr,B) ) ) ).

tff(addAssignment_83745,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147670(VarNext,B)
      <=> v148106(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148107(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148106(VarNext,B)
            <=> v147670(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2115,axiom,
    ! [VarNext: state_type] :
      ( v148107(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148106(VarNext,B)
          <=> v147765(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148107(VarNext)
      <=> v148108(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148108(VarNext)
      <=> ( v148110(VarNext)
          & v147697(VarNext) ) ) ) ).

tff(writeUnaryOperator_11176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148110(VarNext)
      <=> v147759(VarNext) ) ) ).

tff(addAssignment_83744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147692(VarCurr,B)
      <=> v147694(VarCurr,B) ) ) ).

tff(addAssignment_83743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147694(VarCurr,B)
      <=> v147695(VarCurr,B) ) ) ).

tff(addAssignment_83742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147537(VarCurr,B)
      <=> v147539(VarCurr,B) ) ) ).

tff(addAssignment_83741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147539(VarCurr,B)
      <=> v147646(VarCurr,B) ) ) ).

tff(addAssignment_83740,axiom,
    ! [VarCurr: state_type] :
      ( ( v147649(VarCurr,14)
      <=> v147543(VarCurr,25) )
      & ( v147649(VarCurr,13)
      <=> v147543(VarCurr,24) )
      & ( v147649(VarCurr,12)
      <=> v147543(VarCurr,23) )
      & ( v147649(VarCurr,11)
      <=> v147543(VarCurr,22) )
      & ( v147649(VarCurr,10)
      <=> v147543(VarCurr,21) )
      & ( v147649(VarCurr,9)
      <=> v147543(VarCurr,20) )
      & ( v147649(VarCurr,8)
      <=> v147543(VarCurr,19) )
      & ( v147649(VarCurr,7)
      <=> v147543(VarCurr,18) )
      & ( v147649(VarCurr,6)
      <=> v147543(VarCurr,17) )
      & ( v147649(VarCurr,5)
      <=> v147543(VarCurr,16) )
      & ( v147649(VarCurr,4)
      <=> v147543(VarCurr,15) )
      & ( v147649(VarCurr,3)
      <=> v147543(VarCurr,14) )
      & ( v147649(VarCurr,2)
      <=> v147543(VarCurr,13) )
      & ( v147649(VarCurr,1)
      <=> v147543(VarCurr,12) )
      & ( v147649(VarCurr,0)
      <=> v147543(VarCurr,11) ) ) ).

tff(addAssignment_83739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147543(VarCurr,B)
      <=> v147545(VarCurr,B) ) ) ).

tff(addAssignment_83738,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147545(VarNext,B)
      <=> v148097(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148098(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148097(VarNext,B)
            <=> v147545(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2114,axiom,
    ! [VarNext: state_type] :
      ( v148098(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148097(VarNext,B)
          <=> v147640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148098(VarNext)
      <=> v148099(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148099(VarNext)
      <=> ( v148101(VarNext)
          & v147572(VarNext) ) ) ) ).

tff(writeUnaryOperator_11175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148101(VarNext)
      <=> v147634(VarNext) ) ) ).

tff(addAssignment_83737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147567(VarCurr,B)
      <=> v147569(VarCurr,B) ) ) ).

tff(addAssignment_83736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147569(VarCurr,B)
      <=> v147570(VarCurr,B) ) ) ).

tff(addAssignment_83735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147412(VarCurr,B)
      <=> v147414(VarCurr,B) ) ) ).

tff(addAssignment_83734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147414(VarCurr,B)
      <=> v147521(VarCurr,B) ) ) ).

tff(addAssignment_83733,axiom,
    ! [VarCurr: state_type] :
      ( ( v147524(VarCurr,14)
      <=> v147418(VarCurr,25) )
      & ( v147524(VarCurr,13)
      <=> v147418(VarCurr,24) )
      & ( v147524(VarCurr,12)
      <=> v147418(VarCurr,23) )
      & ( v147524(VarCurr,11)
      <=> v147418(VarCurr,22) )
      & ( v147524(VarCurr,10)
      <=> v147418(VarCurr,21) )
      & ( v147524(VarCurr,9)
      <=> v147418(VarCurr,20) )
      & ( v147524(VarCurr,8)
      <=> v147418(VarCurr,19) )
      & ( v147524(VarCurr,7)
      <=> v147418(VarCurr,18) )
      & ( v147524(VarCurr,6)
      <=> v147418(VarCurr,17) )
      & ( v147524(VarCurr,5)
      <=> v147418(VarCurr,16) )
      & ( v147524(VarCurr,4)
      <=> v147418(VarCurr,15) )
      & ( v147524(VarCurr,3)
      <=> v147418(VarCurr,14) )
      & ( v147524(VarCurr,2)
      <=> v147418(VarCurr,13) )
      & ( v147524(VarCurr,1)
      <=> v147418(VarCurr,12) )
      & ( v147524(VarCurr,0)
      <=> v147418(VarCurr,11) ) ) ).

tff(addAssignment_83732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147418(VarCurr,B)
      <=> v147420(VarCurr,B) ) ) ).

tff(addAssignment_83731,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147420(VarNext,B)
      <=> v148088(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148089(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148088(VarNext,B)
            <=> v147420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2113,axiom,
    ! [VarNext: state_type] :
      ( v148089(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148088(VarNext,B)
          <=> v147515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148089(VarNext)
      <=> v148090(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148090(VarNext)
      <=> ( v148092(VarNext)
          & v147447(VarNext) ) ) ) ).

tff(writeUnaryOperator_11174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148092(VarNext)
      <=> v147509(VarNext) ) ) ).

tff(addAssignment_83730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147442(VarCurr,B)
      <=> v147444(VarCurr,B) ) ) ).

tff(addAssignment_83729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147444(VarCurr,B)
      <=> v147445(VarCurr,B) ) ) ).

tff(addAssignment_83728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147287(VarCurr,B)
      <=> v147289(VarCurr,B) ) ) ).

tff(addAssignment_83727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147289(VarCurr,B)
      <=> v147396(VarCurr,B) ) ) ).

tff(addAssignment_83726,axiom,
    ! [VarCurr: state_type] :
      ( ( v147399(VarCurr,14)
      <=> v147293(VarCurr,25) )
      & ( v147399(VarCurr,13)
      <=> v147293(VarCurr,24) )
      & ( v147399(VarCurr,12)
      <=> v147293(VarCurr,23) )
      & ( v147399(VarCurr,11)
      <=> v147293(VarCurr,22) )
      & ( v147399(VarCurr,10)
      <=> v147293(VarCurr,21) )
      & ( v147399(VarCurr,9)
      <=> v147293(VarCurr,20) )
      & ( v147399(VarCurr,8)
      <=> v147293(VarCurr,19) )
      & ( v147399(VarCurr,7)
      <=> v147293(VarCurr,18) )
      & ( v147399(VarCurr,6)
      <=> v147293(VarCurr,17) )
      & ( v147399(VarCurr,5)
      <=> v147293(VarCurr,16) )
      & ( v147399(VarCurr,4)
      <=> v147293(VarCurr,15) )
      & ( v147399(VarCurr,3)
      <=> v147293(VarCurr,14) )
      & ( v147399(VarCurr,2)
      <=> v147293(VarCurr,13) )
      & ( v147399(VarCurr,1)
      <=> v147293(VarCurr,12) )
      & ( v147399(VarCurr,0)
      <=> v147293(VarCurr,11) ) ) ).

tff(addAssignment_83725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147293(VarCurr,B)
      <=> v147295(VarCurr,B) ) ) ).

tff(addAssignment_83724,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147295(VarNext,B)
      <=> v148079(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148080(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148079(VarNext,B)
            <=> v147295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2112,axiom,
    ! [VarNext: state_type] :
      ( v148080(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148079(VarNext,B)
          <=> v147390(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148080(VarNext)
      <=> v148081(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148081(VarNext)
      <=> ( v148083(VarNext)
          & v147322(VarNext) ) ) ) ).

tff(writeUnaryOperator_11173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148083(VarNext)
      <=> v147384(VarNext) ) ) ).

tff(addAssignment_83723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147317(VarCurr,B)
      <=> v147319(VarCurr,B) ) ) ).

tff(addAssignment_83722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147319(VarCurr,B)
      <=> v147320(VarCurr,B) ) ) ).

tff(addAssignment_83721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147162(VarCurr,B)
      <=> v147164(VarCurr,B) ) ) ).

tff(addAssignment_83720,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147164(VarCurr,B)
      <=> v147271(VarCurr,B) ) ) ).

tff(addAssignment_83719,axiom,
    ! [VarCurr: state_type] :
      ( ( v147274(VarCurr,14)
      <=> v147168(VarCurr,25) )
      & ( v147274(VarCurr,13)
      <=> v147168(VarCurr,24) )
      & ( v147274(VarCurr,12)
      <=> v147168(VarCurr,23) )
      & ( v147274(VarCurr,11)
      <=> v147168(VarCurr,22) )
      & ( v147274(VarCurr,10)
      <=> v147168(VarCurr,21) )
      & ( v147274(VarCurr,9)
      <=> v147168(VarCurr,20) )
      & ( v147274(VarCurr,8)
      <=> v147168(VarCurr,19) )
      & ( v147274(VarCurr,7)
      <=> v147168(VarCurr,18) )
      & ( v147274(VarCurr,6)
      <=> v147168(VarCurr,17) )
      & ( v147274(VarCurr,5)
      <=> v147168(VarCurr,16) )
      & ( v147274(VarCurr,4)
      <=> v147168(VarCurr,15) )
      & ( v147274(VarCurr,3)
      <=> v147168(VarCurr,14) )
      & ( v147274(VarCurr,2)
      <=> v147168(VarCurr,13) )
      & ( v147274(VarCurr,1)
      <=> v147168(VarCurr,12) )
      & ( v147274(VarCurr,0)
      <=> v147168(VarCurr,11) ) ) ).

tff(addAssignment_83718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147168(VarCurr,B)
      <=> v147170(VarCurr,B) ) ) ).

tff(addAssignment_83717,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147170(VarNext,B)
      <=> v148070(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148071(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148070(VarNext,B)
            <=> v147170(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2111,axiom,
    ! [VarNext: state_type] :
      ( v148071(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148070(VarNext,B)
          <=> v147265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148071(VarNext)
      <=> v148072(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148072(VarNext)
      <=> ( v148074(VarNext)
          & v147197(VarNext) ) ) ) ).

tff(writeUnaryOperator_11172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148074(VarNext)
      <=> v147259(VarNext) ) ) ).

tff(addAssignment_83716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147192(VarCurr,B)
      <=> v147194(VarCurr,B) ) ) ).

tff(addAssignment_83715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147194(VarCurr,B)
      <=> v147195(VarCurr,B) ) ) ).

tff(addAssignment_83714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147037(VarCurr,B)
      <=> v147039(VarCurr,B) ) ) ).

tff(addAssignment_83713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147039(VarCurr,B)
      <=> v147146(VarCurr,B) ) ) ).

tff(addAssignment_83712,axiom,
    ! [VarCurr: state_type] :
      ( ( v147149(VarCurr,14)
      <=> v147043(VarCurr,25) )
      & ( v147149(VarCurr,13)
      <=> v147043(VarCurr,24) )
      & ( v147149(VarCurr,12)
      <=> v147043(VarCurr,23) )
      & ( v147149(VarCurr,11)
      <=> v147043(VarCurr,22) )
      & ( v147149(VarCurr,10)
      <=> v147043(VarCurr,21) )
      & ( v147149(VarCurr,9)
      <=> v147043(VarCurr,20) )
      & ( v147149(VarCurr,8)
      <=> v147043(VarCurr,19) )
      & ( v147149(VarCurr,7)
      <=> v147043(VarCurr,18) )
      & ( v147149(VarCurr,6)
      <=> v147043(VarCurr,17) )
      & ( v147149(VarCurr,5)
      <=> v147043(VarCurr,16) )
      & ( v147149(VarCurr,4)
      <=> v147043(VarCurr,15) )
      & ( v147149(VarCurr,3)
      <=> v147043(VarCurr,14) )
      & ( v147149(VarCurr,2)
      <=> v147043(VarCurr,13) )
      & ( v147149(VarCurr,1)
      <=> v147043(VarCurr,12) )
      & ( v147149(VarCurr,0)
      <=> v147043(VarCurr,11) ) ) ).

tff(addAssignment_83711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147043(VarCurr,B)
      <=> v147045(VarCurr,B) ) ) ).

tff(addAssignment_83710,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147045(VarNext,B)
      <=> v148061(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148062(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148061(VarNext,B)
            <=> v147045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2110,axiom,
    ! [VarNext: state_type] :
      ( v148062(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148061(VarNext,B)
          <=> v147140(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148062(VarNext)
      <=> v148063(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148063(VarNext)
      <=> ( v148065(VarNext)
          & v147072(VarNext) ) ) ) ).

tff(writeUnaryOperator_11171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148065(VarNext)
      <=> v147134(VarNext) ) ) ).

tff(addAssignment_83709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147067(VarCurr,B)
      <=> v147069(VarCurr,B) ) ) ).

tff(addAssignment_83708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v147069(VarCurr,B)
      <=> v147070(VarCurr,B) ) ) ).

tff(addAssignment_83707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146599(VarCurr,B)
      <=> v146601(VarCurr,B) ) ) ).

tff(addAssignment_83706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146601(VarCurr,B)
      <=> v146808(VarCurr,B) ) ) ).

tff(addAssignment_83705,axiom,
    ! [VarCurr: state_type] :
      ( ( v146811(VarCurr,14)
      <=> v146605(VarCurr,25) )
      & ( v146811(VarCurr,13)
      <=> v146605(VarCurr,24) )
      & ( v146811(VarCurr,12)
      <=> v146605(VarCurr,23) )
      & ( v146811(VarCurr,11)
      <=> v146605(VarCurr,22) )
      & ( v146811(VarCurr,10)
      <=> v146605(VarCurr,21) )
      & ( v146811(VarCurr,9)
      <=> v146605(VarCurr,20) )
      & ( v146811(VarCurr,8)
      <=> v146605(VarCurr,19) )
      & ( v146811(VarCurr,7)
      <=> v146605(VarCurr,18) )
      & ( v146811(VarCurr,6)
      <=> v146605(VarCurr,17) )
      & ( v146811(VarCurr,5)
      <=> v146605(VarCurr,16) )
      & ( v146811(VarCurr,4)
      <=> v146605(VarCurr,15) )
      & ( v146811(VarCurr,3)
      <=> v146605(VarCurr,14) )
      & ( v146811(VarCurr,2)
      <=> v146605(VarCurr,13) )
      & ( v146811(VarCurr,1)
      <=> v146605(VarCurr,12) )
      & ( v146811(VarCurr,0)
      <=> v146605(VarCurr,11) ) ) ).

tff(addAssignment_83704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146605(VarCurr,B)
      <=> v146607(VarCurr,B) ) ) ).

tff(addAssignment_83703,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146607(VarNext,B)
      <=> v148052(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148053(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148052(VarNext,B)
            <=> v146607(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2109,axiom,
    ! [VarNext: state_type] :
      ( v148053(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148052(VarNext,B)
          <=> v146802(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148053(VarNext)
      <=> v148054(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148054(VarNext)
      <=> ( v148056(VarNext)
          & v146730(VarNext) ) ) ) ).

tff(writeUnaryOperator_11170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148056(VarNext)
      <=> v146796(VarNext) ) ) ).

tff(addAssignment_83702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146637(VarCurr,B)
      <=> v146639(VarCurr,B) ) ) ).

tff(addAssignment_83701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146639(VarCurr,B)
      <=> v146724(VarCurr,B) ) ) ).

tff(addAssignment_83700,axiom,
    ! [VarCurr: state_type] :
      ( ( v146727(VarCurr,14)
      <=> v146643(VarCurr,25) )
      & ( v146727(VarCurr,13)
      <=> v146643(VarCurr,24) )
      & ( v146727(VarCurr,12)
      <=> v146643(VarCurr,23) )
      & ( v146727(VarCurr,11)
      <=> v146643(VarCurr,22) )
      & ( v146727(VarCurr,10)
      <=> v146643(VarCurr,21) )
      & ( v146727(VarCurr,9)
      <=> v146643(VarCurr,20) )
      & ( v146727(VarCurr,8)
      <=> v146643(VarCurr,19) )
      & ( v146727(VarCurr,7)
      <=> v146643(VarCurr,18) )
      & ( v146727(VarCurr,6)
      <=> v146643(VarCurr,17) )
      & ( v146727(VarCurr,5)
      <=> v146643(VarCurr,16) )
      & ( v146727(VarCurr,4)
      <=> v146643(VarCurr,15) )
      & ( v146727(VarCurr,3)
      <=> v146643(VarCurr,14) )
      & ( v146727(VarCurr,2)
      <=> v146643(VarCurr,13) )
      & ( v146727(VarCurr,1)
      <=> v146643(VarCurr,12) )
      & ( v146727(VarCurr,0)
      <=> v146643(VarCurr,11) ) ) ).

tff(addAssignment_83699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146643(VarCurr,B)
      <=> v146645(VarCurr,B) ) ) ).

tff(addAssignment_83698,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146645(VarNext,B)
      <=> v148044(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148045(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148044(VarNext,B)
            <=> v146645(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2108,axiom,
    ! [VarNext: state_type] :
      ( v148045(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148044(VarNext,B)
          <=> v146718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148045(VarNext)
      <=> v148046(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148046(VarNext)
      <=> ( v148048(VarNext)
          & v146683(VarNext) ) ) ) ).

tff(writeUnaryOperator_11169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148048(VarNext)
      <=> v146712(VarNext) ) ) ).

tff(addAssignment_83697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146667(VarCurr,B)
      <=> v146669(VarCurr,B) ) ) ).

tff(addAssignment_83696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v146669(VarCurr,B)
      <=> v146677(VarCurr,B) ) ) ).

tff(addAssignment_83695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v146680(VarCurr,B)
      <=> v148034(VarCurr,B) ) ) ).

tff(addAssignment_83694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v148034(VarCurr,B)
      <=> v148036(VarCurr,B) ) ) ).

tff(addAssignment_83693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v148036(VarCurr,B)
      <=> v148038(VarCurr,B) ) ) ).

tff(addAssignment_83692,axiom,
    ! [VarCurr: state_type] :
      ( ( v148038(VarCurr,14)
      <=> v148040(VarCurr,51) )
      & ( v148038(VarCurr,13)
      <=> v148040(VarCurr,50) )
      & ( v148038(VarCurr,12)
      <=> v148040(VarCurr,49) )
      & ( v148038(VarCurr,11)
      <=> v148040(VarCurr,48) )
      & ( v148038(VarCurr,10)
      <=> v148040(VarCurr,47) )
      & ( v148038(VarCurr,9)
      <=> v148040(VarCurr,46) )
      & ( v148038(VarCurr,8)
      <=> v148040(VarCurr,45) )
      & ( v148038(VarCurr,7)
      <=> v148040(VarCurr,44) )
      & ( v148038(VarCurr,6)
      <=> v148040(VarCurr,43) )
      & ( v148038(VarCurr,5)
      <=> v148040(VarCurr,42) )
      & ( v148038(VarCurr,4)
      <=> v148040(VarCurr,41) )
      & ( v148038(VarCurr,3)
      <=> v148040(VarCurr,40) )
      & ( v148038(VarCurr,2)
      <=> v148040(VarCurr,39) )
      & ( v148038(VarCurr,1)
      <=> v148040(VarCurr,38) )
      & ( v148038(VarCurr,0)
      <=> v148040(VarCurr,37) ) ) ).

tff(addAssignment_83691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,37) )
     => ( v148040(VarCurr,B)
      <=> v148042(VarCurr,B) ) ) ).

tff(addAssignment_83690,axiom,
    ! [VarCurr: state_type] :
      ( ( v147943(VarCurr,2)
      <=> v146595(VarCurr,28) )
      & ( v147943(VarCurr,1)
      <=> v146595(VarCurr,27) )
      & ( v147943(VarCurr,0)
      <=> v146595(VarCurr,26) ) ) ).

tff(addAssignment_83689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146595(VarCurr,B)
      <=> v146597(VarCurr,B) ) ) ).

tff(addAssignment_83688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146597(VarCurr,B)
      <=> v147911(VarCurr,B) ) ) ).

tff(addAssignment_83687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147787(VarCurr,B)
      <=> v147789(VarCurr,B) ) ) ).

tff(addAssignment_83686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147789(VarCurr,B)
      <=> v147896(VarCurr,B) ) ) ).

tff(addAssignment_83685,axiom,
    ! [VarCurr: state_type] :
      ( ( v147898(VarCurr,2)
      <=> v147793(VarCurr,28) )
      & ( v147898(VarCurr,1)
      <=> v147793(VarCurr,27) )
      & ( v147898(VarCurr,0)
      <=> v147793(VarCurr,26) ) ) ).

tff(addAssignment_83684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147793(VarCurr,B)
      <=> v147795(VarCurr,B) ) ) ).

tff(addAssignment_83683,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147795(VarNext,B)
      <=> v148021(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148022(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148021(VarNext,B)
            <=> v147795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2107,axiom,
    ! [VarNext: state_type] :
      ( v148022(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148021(VarNext,B)
          <=> v147890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148022(VarNext)
      <=> v148023(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148023(VarNext)
      <=> ( v148025(VarNext)
          & v147822(VarNext) ) ) ) ).

tff(writeUnaryOperator_11168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148025(VarNext)
      <=> v147884(VarNext) ) ) ).

tff(addAssignment_83682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147817(VarCurr,B)
      <=> v147819(VarCurr,B) ) ) ).

tff(addAssignment_83681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147819(VarCurr,B)
      <=> v147820(VarCurr,B) ) ) ).

tff(addAssignment_83680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147662(VarCurr,B)
      <=> v147664(VarCurr,B) ) ) ).

tff(addAssignment_83679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147664(VarCurr,B)
      <=> v147771(VarCurr,B) ) ) ).

tff(addAssignment_83678,axiom,
    ! [VarCurr: state_type] :
      ( ( v147773(VarCurr,2)
      <=> v147668(VarCurr,28) )
      & ( v147773(VarCurr,1)
      <=> v147668(VarCurr,27) )
      & ( v147773(VarCurr,0)
      <=> v147668(VarCurr,26) ) ) ).

tff(addAssignment_83677,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147668(VarCurr,B)
      <=> v147670(VarCurr,B) ) ) ).

tff(addAssignment_83676,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147670(VarNext,B)
      <=> v148012(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148013(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148012(VarNext,B)
            <=> v147670(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2106,axiom,
    ! [VarNext: state_type] :
      ( v148013(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148012(VarNext,B)
          <=> v147765(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148013(VarNext)
      <=> v148014(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148014(VarNext)
      <=> ( v148016(VarNext)
          & v147697(VarNext) ) ) ) ).

tff(writeUnaryOperator_11167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148016(VarNext)
      <=> v147759(VarNext) ) ) ).

tff(addAssignment_83675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147692(VarCurr,B)
      <=> v147694(VarCurr,B) ) ) ).

tff(addAssignment_83674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147694(VarCurr,B)
      <=> v147695(VarCurr,B) ) ) ).

tff(addAssignment_83673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147537(VarCurr,B)
      <=> v147539(VarCurr,B) ) ) ).

tff(addAssignment_83672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147539(VarCurr,B)
      <=> v147646(VarCurr,B) ) ) ).

tff(addAssignment_83671,axiom,
    ! [VarCurr: state_type] :
      ( ( v147648(VarCurr,2)
      <=> v147543(VarCurr,28) )
      & ( v147648(VarCurr,1)
      <=> v147543(VarCurr,27) )
      & ( v147648(VarCurr,0)
      <=> v147543(VarCurr,26) ) ) ).

tff(addAssignment_83670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147543(VarCurr,B)
      <=> v147545(VarCurr,B) ) ) ).

tff(addAssignment_83669,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147545(VarNext,B)
      <=> v148003(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148004(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v148003(VarNext,B)
            <=> v147545(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2105,axiom,
    ! [VarNext: state_type] :
      ( v148004(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v148003(VarNext,B)
          <=> v147640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148004(VarNext)
      <=> v148005(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v148005(VarNext)
      <=> ( v148007(VarNext)
          & v147572(VarNext) ) ) ) ).

tff(writeUnaryOperator_11166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v148007(VarNext)
      <=> v147634(VarNext) ) ) ).

tff(addAssignment_83668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147567(VarCurr,B)
      <=> v147569(VarCurr,B) ) ) ).

tff(addAssignment_83667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147569(VarCurr,B)
      <=> v147570(VarCurr,B) ) ) ).

tff(addAssignment_83666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147412(VarCurr,B)
      <=> v147414(VarCurr,B) ) ) ).

tff(addAssignment_83665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147414(VarCurr,B)
      <=> v147521(VarCurr,B) ) ) ).

tff(addAssignment_83664,axiom,
    ! [VarCurr: state_type] :
      ( ( v147523(VarCurr,2)
      <=> v147418(VarCurr,28) )
      & ( v147523(VarCurr,1)
      <=> v147418(VarCurr,27) )
      & ( v147523(VarCurr,0)
      <=> v147418(VarCurr,26) ) ) ).

tff(addAssignment_83663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147418(VarCurr,B)
      <=> v147420(VarCurr,B) ) ) ).

tff(addAssignment_83662,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147420(VarNext,B)
      <=> v147994(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147995(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147994(VarNext,B)
            <=> v147420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2104,axiom,
    ! [VarNext: state_type] :
      ( v147995(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147994(VarNext,B)
          <=> v147515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147995(VarNext)
      <=> v147996(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147996(VarNext)
      <=> ( v147998(VarNext)
          & v147447(VarNext) ) ) ) ).

tff(writeUnaryOperator_11165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147998(VarNext)
      <=> v147509(VarNext) ) ) ).

tff(addAssignment_83661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147442(VarCurr,B)
      <=> v147444(VarCurr,B) ) ) ).

tff(addAssignment_83660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147444(VarCurr,B)
      <=> v147445(VarCurr,B) ) ) ).

tff(addAssignment_83659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147287(VarCurr,B)
      <=> v147289(VarCurr,B) ) ) ).

tff(addAssignment_83658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147289(VarCurr,B)
      <=> v147396(VarCurr,B) ) ) ).

tff(addAssignment_83657,axiom,
    ! [VarCurr: state_type] :
      ( ( v147398(VarCurr,2)
      <=> v147293(VarCurr,28) )
      & ( v147398(VarCurr,1)
      <=> v147293(VarCurr,27) )
      & ( v147398(VarCurr,0)
      <=> v147293(VarCurr,26) ) ) ).

tff(addAssignment_83656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147293(VarCurr,B)
      <=> v147295(VarCurr,B) ) ) ).

tff(addAssignment_83655,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147295(VarNext,B)
      <=> v147985(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147986(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147985(VarNext,B)
            <=> v147295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2103,axiom,
    ! [VarNext: state_type] :
      ( v147986(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147985(VarNext,B)
          <=> v147390(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147986(VarNext)
      <=> v147987(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147987(VarNext)
      <=> ( v147989(VarNext)
          & v147322(VarNext) ) ) ) ).

tff(writeUnaryOperator_11164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147989(VarNext)
      <=> v147384(VarNext) ) ) ).

tff(addAssignment_83654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147317(VarCurr,B)
      <=> v147319(VarCurr,B) ) ) ).

tff(addAssignment_83653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147319(VarCurr,B)
      <=> v147320(VarCurr,B) ) ) ).

tff(addAssignment_83652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147162(VarCurr,B)
      <=> v147164(VarCurr,B) ) ) ).

tff(addAssignment_83651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147164(VarCurr,B)
      <=> v147271(VarCurr,B) ) ) ).

tff(addAssignment_83650,axiom,
    ! [VarCurr: state_type] :
      ( ( v147273(VarCurr,2)
      <=> v147168(VarCurr,28) )
      & ( v147273(VarCurr,1)
      <=> v147168(VarCurr,27) )
      & ( v147273(VarCurr,0)
      <=> v147168(VarCurr,26) ) ) ).

tff(addAssignment_83649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147168(VarCurr,B)
      <=> v147170(VarCurr,B) ) ) ).

tff(addAssignment_83648,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147170(VarNext,B)
      <=> v147976(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147977(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147976(VarNext,B)
            <=> v147170(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2102,axiom,
    ! [VarNext: state_type] :
      ( v147977(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147976(VarNext,B)
          <=> v147265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147977(VarNext)
      <=> v147978(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147978(VarNext)
      <=> ( v147980(VarNext)
          & v147197(VarNext) ) ) ) ).

tff(writeUnaryOperator_11163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147980(VarNext)
      <=> v147259(VarNext) ) ) ).

tff(addAssignment_83647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147192(VarCurr,B)
      <=> v147194(VarCurr,B) ) ) ).

tff(addAssignment_83646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147194(VarCurr,B)
      <=> v147195(VarCurr,B) ) ) ).

tff(addAssignment_83645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147037(VarCurr,B)
      <=> v147039(VarCurr,B) ) ) ).

tff(addAssignment_83644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147039(VarCurr,B)
      <=> v147146(VarCurr,B) ) ) ).

tff(addAssignment_83643,axiom,
    ! [VarCurr: state_type] :
      ( ( v147148(VarCurr,2)
      <=> v147043(VarCurr,28) )
      & ( v147148(VarCurr,1)
      <=> v147043(VarCurr,27) )
      & ( v147148(VarCurr,0)
      <=> v147043(VarCurr,26) ) ) ).

tff(addAssignment_83642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147043(VarCurr,B)
      <=> v147045(VarCurr,B) ) ) ).

tff(addAssignment_83641,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147045(VarNext,B)
      <=> v147967(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147968(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147967(VarNext,B)
            <=> v147045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2101,axiom,
    ! [VarNext: state_type] :
      ( v147968(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147967(VarNext,B)
          <=> v147140(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147968(VarNext)
      <=> v147969(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147969(VarNext)
      <=> ( v147971(VarNext)
          & v147072(VarNext) ) ) ) ).

tff(writeUnaryOperator_11162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147971(VarNext)
      <=> v147134(VarNext) ) ) ).

tff(addAssignment_83640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147067(VarCurr,B)
      <=> v147069(VarCurr,B) ) ) ).

tff(addAssignment_83639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v147069(VarCurr,B)
      <=> v147070(VarCurr,B) ) ) ).

tff(addAssignment_83638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146599(VarCurr,B)
      <=> v146601(VarCurr,B) ) ) ).

tff(addAssignment_83637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146601(VarCurr,B)
      <=> v146808(VarCurr,B) ) ) ).

tff(addAssignment_83636,axiom,
    ! [VarCurr: state_type] :
      ( ( v146810(VarCurr,2)
      <=> v146605(VarCurr,28) )
      & ( v146810(VarCurr,1)
      <=> v146605(VarCurr,27) )
      & ( v146810(VarCurr,0)
      <=> v146605(VarCurr,26) ) ) ).

tff(addAssignment_83635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146605(VarCurr,B)
      <=> v146607(VarCurr,B) ) ) ).

tff(addAssignment_83634,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146607(VarNext,B)
      <=> v147958(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147959(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147958(VarNext,B)
            <=> v146607(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2100,axiom,
    ! [VarNext: state_type] :
      ( v147959(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147958(VarNext,B)
          <=> v146802(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147959(VarNext)
      <=> v147960(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147960(VarNext)
      <=> ( v147962(VarNext)
          & v146730(VarNext) ) ) ) ).

tff(writeUnaryOperator_11161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147962(VarNext)
      <=> v146796(VarNext) ) ) ).

tff(addAssignment_83633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146637(VarCurr,B)
      <=> v146639(VarCurr,B) ) ) ).

tff(addAssignment_83632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146639(VarCurr,B)
      <=> v146724(VarCurr,B) ) ) ).

tff(addAssignment_83631,axiom,
    ! [VarCurr: state_type] :
      ( ( v146726(VarCurr,2)
      <=> v146643(VarCurr,28) )
      & ( v146726(VarCurr,1)
      <=> v146643(VarCurr,27) )
      & ( v146726(VarCurr,0)
      <=> v146643(VarCurr,26) ) ) ).

tff(addAssignment_83630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146643(VarCurr,B)
      <=> v146645(VarCurr,B) ) ) ).

tff(addAssignment_83629,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146645(VarNext,B)
      <=> v147950(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147951(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147950(VarNext,B)
            <=> v146645(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2099,axiom,
    ! [VarNext: state_type] :
      ( v147951(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147950(VarNext,B)
          <=> v146718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147951(VarNext)
      <=> v147952(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147952(VarNext)
      <=> ( v147954(VarNext)
          & v146683(VarNext) ) ) ) ).

tff(writeUnaryOperator_11160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147954(VarNext)
      <=> v146712(VarNext) ) ) ).

tff(addAssignment_83628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146667(VarCurr,B)
      <=> v146669(VarCurr,B) ) ) ).

tff(addAssignment_83627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v146669(VarCurr,B)
      <=> v146677(VarCurr,B) ) ) ).

tff(addAssignment_83626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v146679(VarCurr,B)
      <=> v147948(VarCurr,B) ) ) ).

tff(addAssignment_83625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v147948(VarCurr,B)
      <=> v108927(VarCurr,B) ) ) ).

tff(addAssignment_83624,axiom,
    ! [VarCurr: state_type] :
      ( ( v146593(VarCurr,3)
      <=> v146595(VarCurr,32) )
      & ( v146593(VarCurr,2)
      <=> v146595(VarCurr,31) )
      & ( v146593(VarCurr,1)
      <=> v146595(VarCurr,30) )
      & ( v146593(VarCurr,0)
      <=> v146595(VarCurr,29) ) ) ).

tff(addAssignment_83623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146595(VarCurr,B)
      <=> v146597(VarCurr,B) ) ) ).

tff(addAssignment_83622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146597(VarCurr,B)
      <=> v147911(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147911(VarCurr,B)
      <=> ( v147912(VarCurr,B)
          | v147939(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147939(VarCurr,B)
      <=> ( v147787(VarCurr,B)
          & v147940(VarCurr,B) ) ) ) ).

tff(addAssignment_83621,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,0)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83620,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,1)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83619,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,2)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83618,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,3)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83617,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,4)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83616,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,5)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83615,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,6)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83614,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,7)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83613,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,8)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83612,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,9)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83611,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,10)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83610,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,11)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83609,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,12)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83608,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,13)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83607,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,14)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83606,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,15)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83605,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,16)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83604,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,17)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83603,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,18)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83602,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,19)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83601,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,20)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83600,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,21)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83599,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,22)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83598,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,23)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83597,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,24)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83596,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,25)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83595,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,26)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83594,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,27)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83593,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,28)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83592,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,29)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83591,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,30)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83590,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,31)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83589,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,32)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83588,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,33)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83587,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,34)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83586,axiom,
    ! [VarCurr: state_type] :
      ( v147940(VarCurr,35)
    <=> v147941(VarCurr) ) ).

tff(addAssignment_83585,axiom,
    ! [VarCurr: state_type] :
      ( v147941(VarCurr)
    <=> v147902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147912(VarCurr,B)
      <=> ( v147913(VarCurr,B)
          | v147936(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147936(VarCurr,B)
      <=> ( v147662(VarCurr,B)
          & v147937(VarCurr,B) ) ) ) ).

tff(addAssignment_83584,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,0)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83583,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,1)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83582,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,2)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83581,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,3)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83580,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,4)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83579,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,5)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83578,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,6)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83577,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,7)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83576,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,8)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83575,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,9)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83574,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,10)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83573,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,11)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83572,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,12)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83571,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,13)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83570,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,14)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83569,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,15)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83568,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,16)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83567,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,17)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83566,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,18)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83565,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,19)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83564,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,20)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83563,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,21)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83562,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,22)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83561,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,23)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83560,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,24)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83559,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,25)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83558,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,26)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83557,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,27)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83556,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,28)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83555,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,29)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83554,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,30)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83553,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,31)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83552,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,32)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83551,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,33)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83550,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,34)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83549,axiom,
    ! [VarCurr: state_type] :
      ( v147937(VarCurr,35)
    <=> v147938(VarCurr) ) ).

tff(addAssignment_83548,axiom,
    ! [VarCurr: state_type] :
      ( v147938(VarCurr)
    <=> v147777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147913(VarCurr,B)
      <=> ( v147914(VarCurr,B)
          | v147933(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147933(VarCurr,B)
      <=> ( v147537(VarCurr,B)
          & v147934(VarCurr,B) ) ) ) ).

tff(addAssignment_83547,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,0)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83546,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,1)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83545,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,2)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83544,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,3)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83543,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,4)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83542,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,5)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83541,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,6)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83540,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,7)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83539,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,8)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83538,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,9)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83537,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,10)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83536,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,11)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83535,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,12)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83534,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,13)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83533,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,14)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83532,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,15)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83531,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,16)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83530,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,17)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83529,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,18)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83528,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,19)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83527,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,20)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83526,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,21)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83525,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,22)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83524,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,23)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83523,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,24)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83522,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,25)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83521,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,26)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83520,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,27)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83519,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,28)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83518,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,29)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83517,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,30)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83516,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,31)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83515,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,32)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83514,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,33)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83513,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,34)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83512,axiom,
    ! [VarCurr: state_type] :
      ( v147934(VarCurr,35)
    <=> v147935(VarCurr) ) ).

tff(addAssignment_83511,axiom,
    ! [VarCurr: state_type] :
      ( v147935(VarCurr)
    <=> v147652(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147914(VarCurr,B)
      <=> ( v147915(VarCurr,B)
          | v147930(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147930(VarCurr,B)
      <=> ( v147412(VarCurr,B)
          & v147931(VarCurr,B) ) ) ) ).

tff(addAssignment_83510,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,0)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83509,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,1)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83508,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,2)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83507,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,3)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83506,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,4)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83505,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,5)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83504,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,6)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83503,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,7)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83502,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,8)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83501,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,9)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83500,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,10)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83499,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,11)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83498,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,12)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83497,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,13)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83496,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,14)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83495,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,15)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83494,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,16)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83493,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,17)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83492,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,18)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83491,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,19)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83490,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,20)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83489,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,21)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83488,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,22)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83487,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,23)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83486,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,24)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83485,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,25)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83484,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,26)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83483,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,27)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83482,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,28)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83481,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,29)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83480,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,30)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83479,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,31)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83478,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,32)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83477,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,33)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83476,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,34)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83475,axiom,
    ! [VarCurr: state_type] :
      ( v147931(VarCurr,35)
    <=> v147932(VarCurr) ) ).

tff(addAssignment_83474,axiom,
    ! [VarCurr: state_type] :
      ( v147932(VarCurr)
    <=> v147527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147915(VarCurr,B)
      <=> ( v147916(VarCurr,B)
          | v147927(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147927(VarCurr,B)
      <=> ( v147287(VarCurr,B)
          & v147928(VarCurr,B) ) ) ) ).

tff(addAssignment_83473,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,0)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83472,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,1)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83471,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,2)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83470,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,3)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83469,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,4)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83468,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,5)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83467,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,6)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83466,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,7)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83465,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,8)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83464,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,9)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83463,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,10)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83462,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,11)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83461,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,12)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83460,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,13)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83459,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,14)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83458,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,15)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83457,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,16)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83456,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,17)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83455,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,18)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83454,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,19)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83453,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,20)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83452,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,21)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83451,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,22)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83450,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,23)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83449,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,24)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83448,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,25)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83447,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,26)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83446,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,27)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83445,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,28)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83444,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,29)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83443,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,30)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83442,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,31)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83441,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,32)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83440,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,33)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83439,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,34)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83438,axiom,
    ! [VarCurr: state_type] :
      ( v147928(VarCurr,35)
    <=> v147929(VarCurr) ) ).

tff(addAssignment_83437,axiom,
    ! [VarCurr: state_type] :
      ( v147929(VarCurr)
    <=> v147402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147916(VarCurr,B)
      <=> ( v147917(VarCurr,B)
          | v147924(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147924(VarCurr,B)
      <=> ( v147162(VarCurr,B)
          & v147925(VarCurr,B) ) ) ) ).

tff(addAssignment_83436,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,0)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83435,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,1)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83434,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,2)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83433,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,3)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83432,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,4)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83431,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,5)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83430,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,6)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83429,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,7)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83428,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,8)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83427,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,9)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83426,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,10)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83425,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,11)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83424,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,12)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83423,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,13)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83422,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,14)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83421,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,15)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83420,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,16)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83419,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,17)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83418,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,18)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83417,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,19)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83416,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,20)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83415,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,21)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83414,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,22)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83413,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,23)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83412,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,24)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83411,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,25)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83410,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,26)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83409,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,27)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83408,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,28)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83407,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,29)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83406,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,30)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83405,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,31)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83404,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,32)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83403,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,33)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83402,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,34)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83401,axiom,
    ! [VarCurr: state_type] :
      ( v147925(VarCurr,35)
    <=> v147926(VarCurr) ) ).

tff(addAssignment_83400,axiom,
    ! [VarCurr: state_type] :
      ( v147926(VarCurr)
    <=> v147277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147917(VarCurr,B)
      <=> ( v147918(VarCurr,B)
          | v147921(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147921(VarCurr,B)
      <=> ( v147037(VarCurr,B)
          & v147922(VarCurr,B) ) ) ) ).

tff(addAssignment_83399,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,0)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83398,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,1)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83397,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,2)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83396,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,3)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83395,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,4)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83394,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,5)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83393,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,6)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83392,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,7)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83391,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,8)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83390,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,9)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83389,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,10)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83388,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,11)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83387,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,12)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83386,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,13)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83385,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,14)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83384,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,15)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83383,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,16)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83382,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,17)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83381,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,18)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83380,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,19)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83379,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,20)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83378,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,21)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83377,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,22)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83376,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,23)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83375,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,24)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83374,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,25)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83373,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,26)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83372,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,27)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83371,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,28)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83370,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,29)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83369,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,30)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83368,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,31)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83367,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,32)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83366,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,33)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83365,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,34)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83364,axiom,
    ! [VarCurr: state_type] :
      ( v147922(VarCurr,35)
    <=> v147923(VarCurr) ) ).

tff(addAssignment_83363,axiom,
    ! [VarCurr: state_type] :
      ( v147923(VarCurr)
    <=> v147152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v147918(VarCurr,B)
      <=> ( v146599(VarCurr,B)
          & v147919(VarCurr,B) ) ) ) ).

tff(addAssignment_83362,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,0)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83361,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,1)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83360,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,2)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83359,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,3)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83358,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,4)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83357,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,5)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83356,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,6)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83355,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,7)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83354,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,8)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83353,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,9)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83352,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,10)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83351,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,11)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83350,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,12)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83349,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,13)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83348,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,14)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83347,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,15)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83346,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,16)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83345,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,17)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83344,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,18)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83343,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,19)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83342,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,20)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83341,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,21)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83340,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,22)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83339,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,23)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83338,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,24)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83337,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,25)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83336,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,26)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83335,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,27)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83334,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,28)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83333,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,29)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83332,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,30)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83331,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,31)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83330,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,32)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83329,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,33)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83328,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,34)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83327,axiom,
    ! [VarCurr: state_type] :
      ( v147919(VarCurr,35)
    <=> v147920(VarCurr) ) ).

tff(addAssignment_83326,axiom,
    ! [VarCurr: state_type] :
      ( v147920(VarCurr)
    <=> v146814(VarCurr) ) ).

tff(addAssignment_83325,axiom,
    ! [VarCurr: state_type] :
      ( v147902(VarCurr)
    <=> v147904(VarCurr) ) ).

tff(addAssignment_83324,axiom,
    ! [VarCurr: state_type] :
      ( v147904(VarCurr)
    <=> v147906(VarCurr) ) ).

tff(addAssignment_83323,axiom,
    ! [VarCurr: state_type] :
      ( v147906(VarCurr)
    <=> v147908(VarCurr) ) ).

tff(addAssignment_83322,axiom,
    ! [VarCurr: state_type] :
      ( v147908(VarCurr)
    <=> v147910(VarCurr) ) ).

tff(addAssignment_83321,axiom,
    ! [VarCurr: state_type] :
      ( v147910(VarCurr)
    <=> v146824(VarCurr,7) ) ).

tff(addAssignment_83320,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,7)
    <=> v146826(VarCurr,7) ) ).

tff(addAssignment_83319,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,7)
    <=> v146828(VarCurr,7) ) ).

tff(addAssignment_83318,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,7)
    <=> v146830(VarCurr,7) ) ).

tff(addAssignment_83317,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,7)
    <=> v147035(VarCurr,7) ) ).

tff(addAssignment_83316,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,7)
    <=> v146834(VarCurr,7) ) ).

tff(addAssignment_83315,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,7)
    <=> v146836(VarCurr,7) ) ).

tff(addAssignment_83314,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,7)
    <=> v147000(VarCurr,7) ) ).

tff(addAssignment_83313,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,7)
    <=> v146991(VarCurr,7) ) ).

tff(addAssignment_83312,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,7)
    <=> v146972(VarCurr,7) ) ).

tff(addAssignment_83311,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,7)
    <=> v146953(VarCurr,7) ) ).

tff(addAssignment_83310,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,7)
    <=> v146934(VarCurr,7) ) ).

tff(addAssignment_83309,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,7)
    <=> v146915(VarCurr,7) ) ).

tff(addAssignment_83308,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,7)
    <=> v146896(VarCurr,7) ) ).

tff(addAssignment_83307,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,7)
    <=> v146877(VarCurr,7) ) ).

tff(addAssignment_83306,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,7)
    <=> v146858(VarCurr,7) ) ).

tff(addAssignment_83305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147787(VarCurr,B)
      <=> v147789(VarCurr,B) ) ) ).

tff(addAssignment_83304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147789(VarCurr,B)
      <=> v147896(VarCurr,B) ) ) ).

tff(addAssignment_83303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147896(VarCurr,B)
      <=> v147900(VarCurr,B) ) ) ).

tff(addAssignment_83302,axiom,
    ! [VarCurr: state_type] :
      ( ( v147896(VarCurr,25)
      <=> v147899(VarCurr,14) )
      & ( v147896(VarCurr,24)
      <=> v147899(VarCurr,13) )
      & ( v147896(VarCurr,23)
      <=> v147899(VarCurr,12) )
      & ( v147896(VarCurr,22)
      <=> v147899(VarCurr,11) )
      & ( v147896(VarCurr,21)
      <=> v147899(VarCurr,10) )
      & ( v147896(VarCurr,20)
      <=> v147899(VarCurr,9) )
      & ( v147896(VarCurr,19)
      <=> v147899(VarCurr,8) )
      & ( v147896(VarCurr,18)
      <=> v147899(VarCurr,7) )
      & ( v147896(VarCurr,17)
      <=> v147899(VarCurr,6) )
      & ( v147896(VarCurr,16)
      <=> v147899(VarCurr,5) )
      & ( v147896(VarCurr,15)
      <=> v147899(VarCurr,4) )
      & ( v147896(VarCurr,14)
      <=> v147899(VarCurr,3) )
      & ( v147896(VarCurr,13)
      <=> v147899(VarCurr,2) )
      & ( v147896(VarCurr,12)
      <=> v147899(VarCurr,1) )
      & ( v147896(VarCurr,11)
      <=> v147899(VarCurr,0) ) ) ).

tff(addAssignment_83301,axiom,
    ! [VarCurr: state_type] :
      ( ( v147896(VarCurr,28)
      <=> v147898(VarCurr,2) )
      & ( v147896(VarCurr,27)
      <=> v147898(VarCurr,1) )
      & ( v147896(VarCurr,26)
      <=> v147898(VarCurr,0) ) ) ).

tff(addAssignment_83300,axiom,
    ! [VarCurr: state_type] :
      ( ( v147896(VarCurr,32)
      <=> v147791(VarCurr,3) )
      & ( v147896(VarCurr,31)
      <=> v147791(VarCurr,2) )
      & ( v147896(VarCurr,30)
      <=> v147791(VarCurr,1) )
      & ( v147896(VarCurr,29)
      <=> v147791(VarCurr,0) ) ) ).

tff(addAssignment_83299,axiom,
    ! [VarCurr: state_type] :
      ( ( v147896(VarCurr,35)
      <=> v147897(VarCurr,2) )
      & ( v147896(VarCurr,34)
      <=> v147897(VarCurr,1) )
      & ( v147896(VarCurr,33)
      <=> v147897(VarCurr,0) ) ) ).

tff(addAssignment_83298,axiom,
    ! [VarCurr: state_type] :
      ( ( v147791(VarCurr,3)
      <=> v147793(VarCurr,32) )
      & ( v147791(VarCurr,2)
      <=> v147793(VarCurr,31) )
      & ( v147791(VarCurr,1)
      <=> v147793(VarCurr,30) )
      & ( v147791(VarCurr,0)
      <=> v147793(VarCurr,29) ) ) ).

tff(addAssignment_83297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147793(VarCurr,B)
      <=> v147795(VarCurr,B) ) ) ).

tff(addAssignment_83296,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147795(VarNext,B)
      <=> v147879(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147880(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147879(VarNext,B)
            <=> v147795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2098,axiom,
    ! [VarNext: state_type] :
      ( v147880(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147879(VarNext,B)
          <=> v147890(VarNext,B) ) ) ) ).

tff(addAssignment_83295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147890(VarNext,B)
          <=> v147888(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147891(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147888(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1630,axiom,
    ! [VarCurr: state_type] :
      ( v147891(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147888(VarCurr,B)
          <=> v147817(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19560,axiom,
    ! [VarCurr: state_type] :
      ( v147891(VarCurr)
    <=> ( v147892(VarCurr)
        & v147893(VarCurr) ) ) ).

tff(writeUnaryOperator_11159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147893(VarCurr)
    <=> v147807(VarCurr) ) ).

tff(writeUnaryOperator_11158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147892(VarCurr)
    <=> v147797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147880(VarNext)
      <=> v147881(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147881(VarNext)
      <=> ( v147882(VarNext)
          & v147822(VarNext) ) ) ) ).

tff(writeUnaryOperator_11157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147882(VarNext)
      <=> v147884(VarNext) ) ) ).

tff(addAssignment_83294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147884(VarNext)
      <=> v147822(VarCurr) ) ) ).

tff(addAssignment_83293,axiom,
    ! [VarCurr: state_type] :
      ( v147822(VarCurr)
    <=> v147824(VarCurr) ) ).

tff(addAssignment_83292,axiom,
    ! [VarCurr: state_type] :
      ( v147824(VarCurr)
    <=> v147826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19557,axiom,
    ! [VarCurr: state_type] :
      ( v147826(VarCurr)
    <=> ( v147877(VarCurr)
        | v147873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19556,axiom,
    ! [VarCurr: state_type] :
      ( v147877(VarCurr)
    <=> ( v147828(VarCurr)
        & v147832(VarCurr) ) ) ).

tff(addAssignment_83291,axiom,
    ! [VarCurr: state_type] :
      ( v147873(VarCurr)
    <=> v147875(VarCurr) ) ).

tff(addAssignment_83290,axiom,
    ! [VarCurr: state_type] :
      ( v147875(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147857(VarNext)
       => ( v147832(VarNext)
        <=> v147832(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2097,axiom,
    ! [VarNext: state_type] :
      ( v147857(VarNext)
     => ( v147832(VarNext)
      <=> v147867(VarNext) ) ) ).

tff(addAssignment_83289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147867(VarNext)
      <=> v147865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19555,axiom,
    ! [VarCurr: state_type] :
      ( v147865(VarCurr)
    <=> ( v147868(VarCurr)
        & v147869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19554,axiom,
    ! [VarCurr: state_type] :
      ( v147869(VarCurr)
    <=> ( v147838(VarCurr)
        | v147852(VarCurr) ) ) ).

tff(writeUnaryOperator_11156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147868(VarCurr)
    <=> v147834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147857(VarNext)
      <=> v147858(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147858(VarNext)
      <=> ( v147860(VarNext)
          & v147862(VarNext) ) ) ) ).

tff(writeUnaryOperator_11155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147862(VarCurr)
    <=> v147828(VarCurr) ) ).

tff(addAssignment_83288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147860(VarNext)
      <=> v147828(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_282,axiom,
    ( v147832(constB0)
  <=> $true ) ).

tff(addAssignment_83287,axiom,
    ! [VarCurr: state_type] :
      ( v147852(VarCurr)
    <=> v147854(VarCurr) ) ).

tff(addAssignment_83286,axiom,
    ! [VarCurr: state_type] :
      ( v147854(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83285,axiom,
    ! [VarCurr: state_type] :
      ( v147838(VarCurr)
    <=> v147840(VarCurr) ) ).

tff(addAssignment_83284,axiom,
    ! [VarCurr: state_type] :
      ( v147840(VarCurr)
    <=> v147842(VarCurr) ) ).

tff(addAssignment_83283,axiom,
    ! [VarCurr: state_type] :
      ( v147842(VarCurr)
    <=> v147844(VarCurr) ) ).

tff(addAssignment_83282,axiom,
    ! [VarCurr: state_type] :
      ( v147844(VarCurr)
    <=> v147846(VarCurr) ) ).

tff(addAssignment_83281,axiom,
    ! [VarCurr: state_type] :
      ( v147846(VarCurr)
    <=> v147848(VarCurr) ) ).

tff(addAssignment_83280,axiom,
    ! [VarCurr: state_type] :
      ( v147848(VarCurr)
    <=> v147850(VarCurr) ) ).

tff(addAssignment_83279,axiom,
    ! [VarCurr: state_type] :
      ( v147850(VarCurr)
    <=> v141260(VarCurr) ) ).

tff(addAssignment_83278,axiom,
    ! [VarCurr: state_type] :
      ( v147834(VarCurr)
    <=> v147836(VarCurr) ) ).

tff(addAssignment_83277,axiom,
    ! [VarCurr: state_type] :
      ( v147836(VarCurr)
    <=> $false ) ).

tff(addAssignment_83276,axiom,
    ! [VarCurr: state_type] :
      ( v147828(VarCurr)
    <=> v147830(VarCurr) ) ).

tff(addAssignment_83275,axiom,
    ! [VarCurr: state_type] :
      ( v147830(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147817(VarCurr,B)
      <=> v147819(VarCurr,B) ) ) ).

tff(addAssignment_83273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147819(VarCurr,B)
      <=> v147820(VarCurr,B) ) ) ).

tff(addAssignment_83272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147820(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_83271,axiom,
    ! [VarCurr: state_type] :
      ( ( v147820(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147820(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147820(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147820(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147820(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147820(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147820(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147820(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147820(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147820(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147820(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147820(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147820(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147820(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147820(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_83270,axiom,
    ! [VarCurr: state_type] :
      ( ( v147820(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147820(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147820(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_83269,axiom,
    ! [VarCurr: state_type] :
      ( ( v147820(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147820(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147820(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147820(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_83268,axiom,
    ! [VarCurr: state_type] :
      ( ( v147820(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147820(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147820(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_83267,axiom,
    ! [VarCurr: state_type] :
      ( v147807(VarCurr)
    <=> v147809(VarCurr) ) ).

tff(addAssignment_83266,axiom,
    ! [VarCurr: state_type] :
      ( v147809(VarCurr)
    <=> v147811(VarCurr) ) ).

tff(addAssignment_83265,axiom,
    ! [VarCurr: state_type] :
      ( v147811(VarCurr)
    <=> v147813(VarCurr) ) ).

tff(addAssignment_83264,axiom,
    ! [VarCurr: state_type] :
      ( v147813(VarCurr)
    <=> v147815(VarCurr) ) ).

tff(addAssignment_83263,axiom,
    ! [VarCurr: state_type] :
      ( v147815(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83262,axiom,
    ! [VarCurr: state_type] :
      ( v147797(VarCurr)
    <=> v147799(VarCurr) ) ).

tff(addAssignment_83261,axiom,
    ! [VarCurr: state_type] :
      ( v147799(VarCurr)
    <=> v147801(VarCurr) ) ).

tff(addAssignment_83260,axiom,
    ! [VarCurr: state_type] :
      ( v147801(VarCurr)
    <=> v147803(VarCurr) ) ).

tff(addAssignment_83259,axiom,
    ! [VarCurr: state_type] :
      ( v147803(VarCurr)
    <=> v147805(VarCurr) ) ).

tff(addAssignment_83258,axiom,
    ! [VarCurr: state_type] :
      ( v147805(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83257,axiom,
    ! [VarCurr: state_type] :
      ( v147777(VarCurr)
    <=> v147779(VarCurr) ) ).

tff(addAssignment_83256,axiom,
    ! [VarCurr: state_type] :
      ( v147779(VarCurr)
    <=> v147781(VarCurr) ) ).

tff(addAssignment_83255,axiom,
    ! [VarCurr: state_type] :
      ( v147781(VarCurr)
    <=> v147783(VarCurr) ) ).

tff(addAssignment_83254,axiom,
    ! [VarCurr: state_type] :
      ( v147783(VarCurr)
    <=> v147785(VarCurr) ) ).

tff(addAssignment_83253,axiom,
    ! [VarCurr: state_type] :
      ( v147785(VarCurr)
    <=> v146824(VarCurr,6) ) ).

tff(addAssignment_83252,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,6)
    <=> v146826(VarCurr,6) ) ).

tff(addAssignment_83251,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,6)
    <=> v146828(VarCurr,6) ) ).

tff(addAssignment_83250,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,6)
    <=> v146830(VarCurr,6) ) ).

tff(addAssignment_83249,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,6)
    <=> v147035(VarCurr,6) ) ).

tff(addAssignment_83248,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,6)
    <=> v146834(VarCurr,6) ) ).

tff(addAssignment_83247,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,6)
    <=> v146836(VarCurr,6) ) ).

tff(addAssignment_83246,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,6)
    <=> v147000(VarCurr,6) ) ).

tff(addAssignment_83245,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,6)
    <=> v146991(VarCurr,6) ) ).

tff(addAssignment_83244,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,6)
    <=> v146972(VarCurr,6) ) ).

tff(addAssignment_83243,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,6)
    <=> v146953(VarCurr,6) ) ).

tff(addAssignment_83242,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,6)
    <=> v146934(VarCurr,6) ) ).

tff(addAssignment_83241,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,6)
    <=> v146915(VarCurr,6) ) ).

tff(addAssignment_83240,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,6)
    <=> v146896(VarCurr,6) ) ).

tff(addAssignment_83239,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,6)
    <=> v146877(VarCurr,6) ) ).

tff(addAssignment_83238,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,6)
    <=> v146858(VarCurr,6) ) ).

tff(addAssignment_83237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147662(VarCurr,B)
      <=> v147664(VarCurr,B) ) ) ).

tff(addAssignment_83236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147664(VarCurr,B)
      <=> v147771(VarCurr,B) ) ) ).

tff(addAssignment_83235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147771(VarCurr,B)
      <=> v147775(VarCurr,B) ) ) ).

tff(addAssignment_83234,axiom,
    ! [VarCurr: state_type] :
      ( ( v147771(VarCurr,25)
      <=> v147774(VarCurr,14) )
      & ( v147771(VarCurr,24)
      <=> v147774(VarCurr,13) )
      & ( v147771(VarCurr,23)
      <=> v147774(VarCurr,12) )
      & ( v147771(VarCurr,22)
      <=> v147774(VarCurr,11) )
      & ( v147771(VarCurr,21)
      <=> v147774(VarCurr,10) )
      & ( v147771(VarCurr,20)
      <=> v147774(VarCurr,9) )
      & ( v147771(VarCurr,19)
      <=> v147774(VarCurr,8) )
      & ( v147771(VarCurr,18)
      <=> v147774(VarCurr,7) )
      & ( v147771(VarCurr,17)
      <=> v147774(VarCurr,6) )
      & ( v147771(VarCurr,16)
      <=> v147774(VarCurr,5) )
      & ( v147771(VarCurr,15)
      <=> v147774(VarCurr,4) )
      & ( v147771(VarCurr,14)
      <=> v147774(VarCurr,3) )
      & ( v147771(VarCurr,13)
      <=> v147774(VarCurr,2) )
      & ( v147771(VarCurr,12)
      <=> v147774(VarCurr,1) )
      & ( v147771(VarCurr,11)
      <=> v147774(VarCurr,0) ) ) ).

tff(addAssignment_83233,axiom,
    ! [VarCurr: state_type] :
      ( ( v147771(VarCurr,28)
      <=> v147773(VarCurr,2) )
      & ( v147771(VarCurr,27)
      <=> v147773(VarCurr,1) )
      & ( v147771(VarCurr,26)
      <=> v147773(VarCurr,0) ) ) ).

tff(addAssignment_83232,axiom,
    ! [VarCurr: state_type] :
      ( ( v147771(VarCurr,32)
      <=> v147666(VarCurr,3) )
      & ( v147771(VarCurr,31)
      <=> v147666(VarCurr,2) )
      & ( v147771(VarCurr,30)
      <=> v147666(VarCurr,1) )
      & ( v147771(VarCurr,29)
      <=> v147666(VarCurr,0) ) ) ).

tff(addAssignment_83231,axiom,
    ! [VarCurr: state_type] :
      ( ( v147771(VarCurr,35)
      <=> v147772(VarCurr,2) )
      & ( v147771(VarCurr,34)
      <=> v147772(VarCurr,1) )
      & ( v147771(VarCurr,33)
      <=> v147772(VarCurr,0) ) ) ).

tff(addAssignment_83230,axiom,
    ! [VarCurr: state_type] :
      ( ( v147666(VarCurr,3)
      <=> v147668(VarCurr,32) )
      & ( v147666(VarCurr,2)
      <=> v147668(VarCurr,31) )
      & ( v147666(VarCurr,1)
      <=> v147668(VarCurr,30) )
      & ( v147666(VarCurr,0)
      <=> v147668(VarCurr,29) ) ) ).

tff(addAssignment_83229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147668(VarCurr,B)
      <=> v147670(VarCurr,B) ) ) ).

tff(addAssignment_83228,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147670(VarNext,B)
      <=> v147754(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147755(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147754(VarNext,B)
            <=> v147670(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2096,axiom,
    ! [VarNext: state_type] :
      ( v147755(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147754(VarNext,B)
          <=> v147765(VarNext,B) ) ) ) ).

tff(addAssignment_83227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147765(VarNext,B)
          <=> v147763(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147766(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147763(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1629,axiom,
    ! [VarCurr: state_type] :
      ( v147766(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147763(VarCurr,B)
          <=> v147692(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19551,axiom,
    ! [VarCurr: state_type] :
      ( v147766(VarCurr)
    <=> ( v147767(VarCurr)
        & v147768(VarCurr) ) ) ).

tff(writeUnaryOperator_11154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147768(VarCurr)
    <=> v147682(VarCurr) ) ).

tff(writeUnaryOperator_11153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147767(VarCurr)
    <=> v147672(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147755(VarNext)
      <=> v147756(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147756(VarNext)
      <=> ( v147757(VarNext)
          & v147697(VarNext) ) ) ) ).

tff(writeUnaryOperator_11152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147757(VarNext)
      <=> v147759(VarNext) ) ) ).

tff(addAssignment_83226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147759(VarNext)
      <=> v147697(VarCurr) ) ) ).

tff(addAssignment_83225,axiom,
    ! [VarCurr: state_type] :
      ( v147697(VarCurr)
    <=> v147699(VarCurr) ) ).

tff(addAssignment_83224,axiom,
    ! [VarCurr: state_type] :
      ( v147699(VarCurr)
    <=> v147701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19548,axiom,
    ! [VarCurr: state_type] :
      ( v147701(VarCurr)
    <=> ( v147752(VarCurr)
        | v147748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19547,axiom,
    ! [VarCurr: state_type] :
      ( v147752(VarCurr)
    <=> ( v147703(VarCurr)
        & v147707(VarCurr) ) ) ).

tff(addAssignment_83223,axiom,
    ! [VarCurr: state_type] :
      ( v147748(VarCurr)
    <=> v147750(VarCurr) ) ).

tff(addAssignment_83222,axiom,
    ! [VarCurr: state_type] :
      ( v147750(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147732(VarNext)
       => ( v147707(VarNext)
        <=> v147707(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2095,axiom,
    ! [VarNext: state_type] :
      ( v147732(VarNext)
     => ( v147707(VarNext)
      <=> v147742(VarNext) ) ) ).

tff(addAssignment_83221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147742(VarNext)
      <=> v147740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19546,axiom,
    ! [VarCurr: state_type] :
      ( v147740(VarCurr)
    <=> ( v147743(VarCurr)
        & v147744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19545,axiom,
    ! [VarCurr: state_type] :
      ( v147744(VarCurr)
    <=> ( v147713(VarCurr)
        | v147727(VarCurr) ) ) ).

tff(writeUnaryOperator_11151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147743(VarCurr)
    <=> v147709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147732(VarNext)
      <=> v147733(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147733(VarNext)
      <=> ( v147735(VarNext)
          & v147737(VarNext) ) ) ) ).

tff(writeUnaryOperator_11150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147737(VarCurr)
    <=> v147703(VarCurr) ) ).

tff(addAssignment_83220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147735(VarNext)
      <=> v147703(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_281,axiom,
    ( v147707(constB0)
  <=> $true ) ).

tff(addAssignment_83219,axiom,
    ! [VarCurr: state_type] :
      ( v147727(VarCurr)
    <=> v147729(VarCurr) ) ).

tff(addAssignment_83218,axiom,
    ! [VarCurr: state_type] :
      ( v147729(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83217,axiom,
    ! [VarCurr: state_type] :
      ( v147713(VarCurr)
    <=> v147715(VarCurr) ) ).

tff(addAssignment_83216,axiom,
    ! [VarCurr: state_type] :
      ( v147715(VarCurr)
    <=> v147717(VarCurr) ) ).

tff(addAssignment_83215,axiom,
    ! [VarCurr: state_type] :
      ( v147717(VarCurr)
    <=> v147719(VarCurr) ) ).

tff(addAssignment_83214,axiom,
    ! [VarCurr: state_type] :
      ( v147719(VarCurr)
    <=> v147721(VarCurr) ) ).

tff(addAssignment_83213,axiom,
    ! [VarCurr: state_type] :
      ( v147721(VarCurr)
    <=> v147723(VarCurr) ) ).

tff(addAssignment_83212,axiom,
    ! [VarCurr: state_type] :
      ( v147723(VarCurr)
    <=> v147725(VarCurr) ) ).

tff(addAssignment_83211,axiom,
    ! [VarCurr: state_type] :
      ( v147725(VarCurr)
    <=> v141246(VarCurr) ) ).

tff(addAssignment_83210,axiom,
    ! [VarCurr: state_type] :
      ( v147709(VarCurr)
    <=> v147711(VarCurr) ) ).

tff(addAssignment_83209,axiom,
    ! [VarCurr: state_type] :
      ( v147711(VarCurr)
    <=> $false ) ).

tff(addAssignment_83208,axiom,
    ! [VarCurr: state_type] :
      ( v147703(VarCurr)
    <=> v147705(VarCurr) ) ).

tff(addAssignment_83207,axiom,
    ! [VarCurr: state_type] :
      ( v147705(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147692(VarCurr,B)
      <=> v147694(VarCurr,B) ) ) ).

tff(addAssignment_83205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147694(VarCurr,B)
      <=> v147695(VarCurr,B) ) ) ).

tff(addAssignment_83204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147695(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_83203,axiom,
    ! [VarCurr: state_type] :
      ( ( v147695(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147695(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147695(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147695(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147695(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147695(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147695(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147695(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147695(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147695(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147695(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147695(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147695(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147695(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147695(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_83202,axiom,
    ! [VarCurr: state_type] :
      ( ( v147695(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147695(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147695(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_83201,axiom,
    ! [VarCurr: state_type] :
      ( ( v147695(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147695(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147695(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147695(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_83200,axiom,
    ! [VarCurr: state_type] :
      ( ( v147695(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147695(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147695(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_83199,axiom,
    ! [VarCurr: state_type] :
      ( v147682(VarCurr)
    <=> v147684(VarCurr) ) ).

tff(addAssignment_83198,axiom,
    ! [VarCurr: state_type] :
      ( v147684(VarCurr)
    <=> v147686(VarCurr) ) ).

tff(addAssignment_83197,axiom,
    ! [VarCurr: state_type] :
      ( v147686(VarCurr)
    <=> v147688(VarCurr) ) ).

tff(addAssignment_83196,axiom,
    ! [VarCurr: state_type] :
      ( v147688(VarCurr)
    <=> v147690(VarCurr) ) ).

tff(addAssignment_83195,axiom,
    ! [VarCurr: state_type] :
      ( v147690(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83194,axiom,
    ! [VarCurr: state_type] :
      ( v147672(VarCurr)
    <=> v147674(VarCurr) ) ).

tff(addAssignment_83193,axiom,
    ! [VarCurr: state_type] :
      ( v147674(VarCurr)
    <=> v147676(VarCurr) ) ).

tff(addAssignment_83192,axiom,
    ! [VarCurr: state_type] :
      ( v147676(VarCurr)
    <=> v147678(VarCurr) ) ).

tff(addAssignment_83191,axiom,
    ! [VarCurr: state_type] :
      ( v147678(VarCurr)
    <=> v147680(VarCurr) ) ).

tff(addAssignment_83190,axiom,
    ! [VarCurr: state_type] :
      ( v147680(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83189,axiom,
    ! [VarCurr: state_type] :
      ( v147652(VarCurr)
    <=> v147654(VarCurr) ) ).

tff(addAssignment_83188,axiom,
    ! [VarCurr: state_type] :
      ( v147654(VarCurr)
    <=> v147656(VarCurr) ) ).

tff(addAssignment_83187,axiom,
    ! [VarCurr: state_type] :
      ( v147656(VarCurr)
    <=> v147658(VarCurr) ) ).

tff(addAssignment_83186,axiom,
    ! [VarCurr: state_type] :
      ( v147658(VarCurr)
    <=> v147660(VarCurr) ) ).

tff(addAssignment_83185,axiom,
    ! [VarCurr: state_type] :
      ( v147660(VarCurr)
    <=> v146824(VarCurr,5) ) ).

tff(addAssignment_83184,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,5)
    <=> v146826(VarCurr,5) ) ).

tff(addAssignment_83183,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,5)
    <=> v146828(VarCurr,5) ) ).

tff(addAssignment_83182,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,5)
    <=> v146830(VarCurr,5) ) ).

tff(addAssignment_83181,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,5)
    <=> v147035(VarCurr,5) ) ).

tff(addAssignment_83180,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,5)
    <=> v146834(VarCurr,5) ) ).

tff(addAssignment_83179,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,5)
    <=> v146836(VarCurr,5) ) ).

tff(addAssignment_83178,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,5)
    <=> v147000(VarCurr,5) ) ).

tff(addAssignment_83177,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,5)
    <=> v146991(VarCurr,5) ) ).

tff(addAssignment_83176,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,5)
    <=> v146972(VarCurr,5) ) ).

tff(addAssignment_83175,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,5)
    <=> v146953(VarCurr,5) ) ).

tff(addAssignment_83174,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,5)
    <=> v146934(VarCurr,5) ) ).

tff(addAssignment_83173,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,5)
    <=> v146915(VarCurr,5) ) ).

tff(addAssignment_83172,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,5)
    <=> v146896(VarCurr,5) ) ).

tff(addAssignment_83171,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,5)
    <=> v146877(VarCurr,5) ) ).

tff(addAssignment_83170,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,5)
    <=> v146858(VarCurr,5) ) ).

tff(addAssignment_83169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147537(VarCurr,B)
      <=> v147539(VarCurr,B) ) ) ).

tff(addAssignment_83168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147539(VarCurr,B)
      <=> v147646(VarCurr,B) ) ) ).

tff(addAssignment_83167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147646(VarCurr,B)
      <=> v147650(VarCurr,B) ) ) ).

tff(addAssignment_83166,axiom,
    ! [VarCurr: state_type] :
      ( ( v147646(VarCurr,25)
      <=> v147649(VarCurr,14) )
      & ( v147646(VarCurr,24)
      <=> v147649(VarCurr,13) )
      & ( v147646(VarCurr,23)
      <=> v147649(VarCurr,12) )
      & ( v147646(VarCurr,22)
      <=> v147649(VarCurr,11) )
      & ( v147646(VarCurr,21)
      <=> v147649(VarCurr,10) )
      & ( v147646(VarCurr,20)
      <=> v147649(VarCurr,9) )
      & ( v147646(VarCurr,19)
      <=> v147649(VarCurr,8) )
      & ( v147646(VarCurr,18)
      <=> v147649(VarCurr,7) )
      & ( v147646(VarCurr,17)
      <=> v147649(VarCurr,6) )
      & ( v147646(VarCurr,16)
      <=> v147649(VarCurr,5) )
      & ( v147646(VarCurr,15)
      <=> v147649(VarCurr,4) )
      & ( v147646(VarCurr,14)
      <=> v147649(VarCurr,3) )
      & ( v147646(VarCurr,13)
      <=> v147649(VarCurr,2) )
      & ( v147646(VarCurr,12)
      <=> v147649(VarCurr,1) )
      & ( v147646(VarCurr,11)
      <=> v147649(VarCurr,0) ) ) ).

tff(addAssignment_83165,axiom,
    ! [VarCurr: state_type] :
      ( ( v147646(VarCurr,28)
      <=> v147648(VarCurr,2) )
      & ( v147646(VarCurr,27)
      <=> v147648(VarCurr,1) )
      & ( v147646(VarCurr,26)
      <=> v147648(VarCurr,0) ) ) ).

tff(addAssignment_83164,axiom,
    ! [VarCurr: state_type] :
      ( ( v147646(VarCurr,32)
      <=> v147541(VarCurr,3) )
      & ( v147646(VarCurr,31)
      <=> v147541(VarCurr,2) )
      & ( v147646(VarCurr,30)
      <=> v147541(VarCurr,1) )
      & ( v147646(VarCurr,29)
      <=> v147541(VarCurr,0) ) ) ).

tff(addAssignment_83163,axiom,
    ! [VarCurr: state_type] :
      ( ( v147646(VarCurr,35)
      <=> v147647(VarCurr,2) )
      & ( v147646(VarCurr,34)
      <=> v147647(VarCurr,1) )
      & ( v147646(VarCurr,33)
      <=> v147647(VarCurr,0) ) ) ).

tff(addAssignment_83162,axiom,
    ! [VarCurr: state_type] :
      ( ( v147541(VarCurr,3)
      <=> v147543(VarCurr,32) )
      & ( v147541(VarCurr,2)
      <=> v147543(VarCurr,31) )
      & ( v147541(VarCurr,1)
      <=> v147543(VarCurr,30) )
      & ( v147541(VarCurr,0)
      <=> v147543(VarCurr,29) ) ) ).

tff(addAssignment_83161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147543(VarCurr,B)
      <=> v147545(VarCurr,B) ) ) ).

tff(addAssignment_83160,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147545(VarNext,B)
      <=> v147629(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147630(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147629(VarNext,B)
            <=> v147545(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2094,axiom,
    ! [VarNext: state_type] :
      ( v147630(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147629(VarNext,B)
          <=> v147640(VarNext,B) ) ) ) ).

tff(addAssignment_83159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147640(VarNext,B)
          <=> v147638(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147641(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147638(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1628,axiom,
    ! [VarCurr: state_type] :
      ( v147641(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147638(VarCurr,B)
          <=> v147567(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19542,axiom,
    ! [VarCurr: state_type] :
      ( v147641(VarCurr)
    <=> ( v147642(VarCurr)
        & v147643(VarCurr) ) ) ).

tff(writeUnaryOperator_11149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147643(VarCurr)
    <=> v147557(VarCurr) ) ).

tff(writeUnaryOperator_11148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147642(VarCurr)
    <=> v147547(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147630(VarNext)
      <=> v147631(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147631(VarNext)
      <=> ( v147632(VarNext)
          & v147572(VarNext) ) ) ) ).

tff(writeUnaryOperator_11147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147632(VarNext)
      <=> v147634(VarNext) ) ) ).

tff(addAssignment_83158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147634(VarNext)
      <=> v147572(VarCurr) ) ) ).

tff(addAssignment_83157,axiom,
    ! [VarCurr: state_type] :
      ( v147572(VarCurr)
    <=> v147574(VarCurr) ) ).

tff(addAssignment_83156,axiom,
    ! [VarCurr: state_type] :
      ( v147574(VarCurr)
    <=> v147576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19539,axiom,
    ! [VarCurr: state_type] :
      ( v147576(VarCurr)
    <=> ( v147627(VarCurr)
        | v147623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19538,axiom,
    ! [VarCurr: state_type] :
      ( v147627(VarCurr)
    <=> ( v147578(VarCurr)
        & v147582(VarCurr) ) ) ).

tff(addAssignment_83155,axiom,
    ! [VarCurr: state_type] :
      ( v147623(VarCurr)
    <=> v147625(VarCurr) ) ).

tff(addAssignment_83154,axiom,
    ! [VarCurr: state_type] :
      ( v147625(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147607(VarNext)
       => ( v147582(VarNext)
        <=> v147582(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2093,axiom,
    ! [VarNext: state_type] :
      ( v147607(VarNext)
     => ( v147582(VarNext)
      <=> v147617(VarNext) ) ) ).

tff(addAssignment_83153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147617(VarNext)
      <=> v147615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19537,axiom,
    ! [VarCurr: state_type] :
      ( v147615(VarCurr)
    <=> ( v147618(VarCurr)
        & v147619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19536,axiom,
    ! [VarCurr: state_type] :
      ( v147619(VarCurr)
    <=> ( v147588(VarCurr)
        | v147602(VarCurr) ) ) ).

tff(writeUnaryOperator_11146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147618(VarCurr)
    <=> v147584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147607(VarNext)
      <=> v147608(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147608(VarNext)
      <=> ( v147610(VarNext)
          & v147612(VarNext) ) ) ) ).

tff(writeUnaryOperator_11145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147612(VarCurr)
    <=> v147578(VarCurr) ) ).

tff(addAssignment_83152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147610(VarNext)
      <=> v147578(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_280,axiom,
    ( v147582(constB0)
  <=> $true ) ).

tff(addAssignment_83151,axiom,
    ! [VarCurr: state_type] :
      ( v147602(VarCurr)
    <=> v147604(VarCurr) ) ).

tff(addAssignment_83150,axiom,
    ! [VarCurr: state_type] :
      ( v147604(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83149,axiom,
    ! [VarCurr: state_type] :
      ( v147588(VarCurr)
    <=> v147590(VarCurr) ) ).

tff(addAssignment_83148,axiom,
    ! [VarCurr: state_type] :
      ( v147590(VarCurr)
    <=> v147592(VarCurr) ) ).

tff(addAssignment_83147,axiom,
    ! [VarCurr: state_type] :
      ( v147592(VarCurr)
    <=> v147594(VarCurr) ) ).

tff(addAssignment_83146,axiom,
    ! [VarCurr: state_type] :
      ( v147594(VarCurr)
    <=> v147596(VarCurr) ) ).

tff(addAssignment_83145,axiom,
    ! [VarCurr: state_type] :
      ( v147596(VarCurr)
    <=> v147598(VarCurr) ) ).

tff(addAssignment_83144,axiom,
    ! [VarCurr: state_type] :
      ( v147598(VarCurr)
    <=> v147600(VarCurr) ) ).

tff(addAssignment_83143,axiom,
    ! [VarCurr: state_type] :
      ( v147600(VarCurr)
    <=> v141232(VarCurr) ) ).

tff(addAssignment_83142,axiom,
    ! [VarCurr: state_type] :
      ( v147584(VarCurr)
    <=> v147586(VarCurr) ) ).

tff(addAssignment_83141,axiom,
    ! [VarCurr: state_type] :
      ( v147586(VarCurr)
    <=> $false ) ).

tff(addAssignment_83140,axiom,
    ! [VarCurr: state_type] :
      ( v147578(VarCurr)
    <=> v147580(VarCurr) ) ).

tff(addAssignment_83139,axiom,
    ! [VarCurr: state_type] :
      ( v147580(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147567(VarCurr,B)
      <=> v147569(VarCurr,B) ) ) ).

tff(addAssignment_83137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147569(VarCurr,B)
      <=> v147570(VarCurr,B) ) ) ).

tff(addAssignment_83136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147570(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_83135,axiom,
    ! [VarCurr: state_type] :
      ( ( v147570(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147570(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147570(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147570(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147570(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147570(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147570(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147570(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147570(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147570(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147570(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147570(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147570(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147570(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147570(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_83134,axiom,
    ! [VarCurr: state_type] :
      ( ( v147570(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147570(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147570(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_83133,axiom,
    ! [VarCurr: state_type] :
      ( ( v147570(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147570(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147570(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147570(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_83132,axiom,
    ! [VarCurr: state_type] :
      ( ( v147570(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147570(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147570(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_83131,axiom,
    ! [VarCurr: state_type] :
      ( v147557(VarCurr)
    <=> v147559(VarCurr) ) ).

tff(addAssignment_83130,axiom,
    ! [VarCurr: state_type] :
      ( v147559(VarCurr)
    <=> v147561(VarCurr) ) ).

tff(addAssignment_83129,axiom,
    ! [VarCurr: state_type] :
      ( v147561(VarCurr)
    <=> v147563(VarCurr) ) ).

tff(addAssignment_83128,axiom,
    ! [VarCurr: state_type] :
      ( v147563(VarCurr)
    <=> v147565(VarCurr) ) ).

tff(addAssignment_83127,axiom,
    ! [VarCurr: state_type] :
      ( v147565(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83126,axiom,
    ! [VarCurr: state_type] :
      ( v147547(VarCurr)
    <=> v147549(VarCurr) ) ).

tff(addAssignment_83125,axiom,
    ! [VarCurr: state_type] :
      ( v147549(VarCurr)
    <=> v147551(VarCurr) ) ).

tff(addAssignment_83124,axiom,
    ! [VarCurr: state_type] :
      ( v147551(VarCurr)
    <=> v147553(VarCurr) ) ).

tff(addAssignment_83123,axiom,
    ! [VarCurr: state_type] :
      ( v147553(VarCurr)
    <=> v147555(VarCurr) ) ).

tff(addAssignment_83122,axiom,
    ! [VarCurr: state_type] :
      ( v147555(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83121,axiom,
    ! [VarCurr: state_type] :
      ( v147527(VarCurr)
    <=> v147529(VarCurr) ) ).

tff(addAssignment_83120,axiom,
    ! [VarCurr: state_type] :
      ( v147529(VarCurr)
    <=> v147531(VarCurr) ) ).

tff(addAssignment_83119,axiom,
    ! [VarCurr: state_type] :
      ( v147531(VarCurr)
    <=> v147533(VarCurr) ) ).

tff(addAssignment_83118,axiom,
    ! [VarCurr: state_type] :
      ( v147533(VarCurr)
    <=> v147535(VarCurr) ) ).

tff(addAssignment_83117,axiom,
    ! [VarCurr: state_type] :
      ( v147535(VarCurr)
    <=> v146824(VarCurr,4) ) ).

tff(addAssignment_83116,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,4)
    <=> v146826(VarCurr,4) ) ).

tff(addAssignment_83115,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,4)
    <=> v146828(VarCurr,4) ) ).

tff(addAssignment_83114,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,4)
    <=> v146830(VarCurr,4) ) ).

tff(addAssignment_83113,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,4)
    <=> v147035(VarCurr,4) ) ).

tff(addAssignment_83112,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,4)
    <=> v146834(VarCurr,4) ) ).

tff(addAssignment_83111,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,4)
    <=> v146836(VarCurr,4) ) ).

tff(addAssignment_83110,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,4)
    <=> v147000(VarCurr,4) ) ).

tff(addAssignment_83109,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,4)
    <=> v146991(VarCurr,4) ) ).

tff(addAssignment_83108,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,4)
    <=> v146972(VarCurr,4) ) ).

tff(addAssignment_83107,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,4)
    <=> v146953(VarCurr,4) ) ).

tff(addAssignment_83106,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,4)
    <=> v146934(VarCurr,4) ) ).

tff(addAssignment_83105,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,4)
    <=> v146915(VarCurr,4) ) ).

tff(addAssignment_83104,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,4)
    <=> v146896(VarCurr,4) ) ).

tff(addAssignment_83103,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,4)
    <=> v146877(VarCurr,4) ) ).

tff(addAssignment_83102,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,4)
    <=> v146858(VarCurr,4) ) ).

tff(addAssignment_83101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147412(VarCurr,B)
      <=> v147414(VarCurr,B) ) ) ).

tff(addAssignment_83100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147414(VarCurr,B)
      <=> v147521(VarCurr,B) ) ) ).

tff(addAssignment_83099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147521(VarCurr,B)
      <=> v147525(VarCurr,B) ) ) ).

tff(addAssignment_83098,axiom,
    ! [VarCurr: state_type] :
      ( ( v147521(VarCurr,25)
      <=> v147524(VarCurr,14) )
      & ( v147521(VarCurr,24)
      <=> v147524(VarCurr,13) )
      & ( v147521(VarCurr,23)
      <=> v147524(VarCurr,12) )
      & ( v147521(VarCurr,22)
      <=> v147524(VarCurr,11) )
      & ( v147521(VarCurr,21)
      <=> v147524(VarCurr,10) )
      & ( v147521(VarCurr,20)
      <=> v147524(VarCurr,9) )
      & ( v147521(VarCurr,19)
      <=> v147524(VarCurr,8) )
      & ( v147521(VarCurr,18)
      <=> v147524(VarCurr,7) )
      & ( v147521(VarCurr,17)
      <=> v147524(VarCurr,6) )
      & ( v147521(VarCurr,16)
      <=> v147524(VarCurr,5) )
      & ( v147521(VarCurr,15)
      <=> v147524(VarCurr,4) )
      & ( v147521(VarCurr,14)
      <=> v147524(VarCurr,3) )
      & ( v147521(VarCurr,13)
      <=> v147524(VarCurr,2) )
      & ( v147521(VarCurr,12)
      <=> v147524(VarCurr,1) )
      & ( v147521(VarCurr,11)
      <=> v147524(VarCurr,0) ) ) ).

tff(addAssignment_83097,axiom,
    ! [VarCurr: state_type] :
      ( ( v147521(VarCurr,28)
      <=> v147523(VarCurr,2) )
      & ( v147521(VarCurr,27)
      <=> v147523(VarCurr,1) )
      & ( v147521(VarCurr,26)
      <=> v147523(VarCurr,0) ) ) ).

tff(addAssignment_83096,axiom,
    ! [VarCurr: state_type] :
      ( ( v147521(VarCurr,32)
      <=> v147416(VarCurr,3) )
      & ( v147521(VarCurr,31)
      <=> v147416(VarCurr,2) )
      & ( v147521(VarCurr,30)
      <=> v147416(VarCurr,1) )
      & ( v147521(VarCurr,29)
      <=> v147416(VarCurr,0) ) ) ).

tff(addAssignment_83095,axiom,
    ! [VarCurr: state_type] :
      ( ( v147521(VarCurr,35)
      <=> v147522(VarCurr,2) )
      & ( v147521(VarCurr,34)
      <=> v147522(VarCurr,1) )
      & ( v147521(VarCurr,33)
      <=> v147522(VarCurr,0) ) ) ).

tff(addAssignment_83094,axiom,
    ! [VarCurr: state_type] :
      ( ( v147416(VarCurr,3)
      <=> v147418(VarCurr,32) )
      & ( v147416(VarCurr,2)
      <=> v147418(VarCurr,31) )
      & ( v147416(VarCurr,1)
      <=> v147418(VarCurr,30) )
      & ( v147416(VarCurr,0)
      <=> v147418(VarCurr,29) ) ) ).

tff(addAssignment_83093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147418(VarCurr,B)
      <=> v147420(VarCurr,B) ) ) ).

tff(addAssignment_83092,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147420(VarNext,B)
      <=> v147504(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147505(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147504(VarNext,B)
            <=> v147420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2092,axiom,
    ! [VarNext: state_type] :
      ( v147505(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147504(VarNext,B)
          <=> v147515(VarNext,B) ) ) ) ).

tff(addAssignment_83091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147515(VarNext,B)
          <=> v147513(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147513(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1627,axiom,
    ! [VarCurr: state_type] :
      ( v147516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147513(VarCurr,B)
          <=> v147442(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19533,axiom,
    ! [VarCurr: state_type] :
      ( v147516(VarCurr)
    <=> ( v147517(VarCurr)
        & v147518(VarCurr) ) ) ).

tff(writeUnaryOperator_11144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147518(VarCurr)
    <=> v147432(VarCurr) ) ).

tff(writeUnaryOperator_11143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147517(VarCurr)
    <=> v147422(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147505(VarNext)
      <=> v147506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147506(VarNext)
      <=> ( v147507(VarNext)
          & v147447(VarNext) ) ) ) ).

tff(writeUnaryOperator_11142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147507(VarNext)
      <=> v147509(VarNext) ) ) ).

tff(addAssignment_83090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147509(VarNext)
      <=> v147447(VarCurr) ) ) ).

tff(addAssignment_83089,axiom,
    ! [VarCurr: state_type] :
      ( v147447(VarCurr)
    <=> v147449(VarCurr) ) ).

tff(addAssignment_83088,axiom,
    ! [VarCurr: state_type] :
      ( v147449(VarCurr)
    <=> v147451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19530,axiom,
    ! [VarCurr: state_type] :
      ( v147451(VarCurr)
    <=> ( v147502(VarCurr)
        | v147498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19529,axiom,
    ! [VarCurr: state_type] :
      ( v147502(VarCurr)
    <=> ( v147453(VarCurr)
        & v147457(VarCurr) ) ) ).

tff(addAssignment_83087,axiom,
    ! [VarCurr: state_type] :
      ( v147498(VarCurr)
    <=> v147500(VarCurr) ) ).

tff(addAssignment_83086,axiom,
    ! [VarCurr: state_type] :
      ( v147500(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147482(VarNext)
       => ( v147457(VarNext)
        <=> v147457(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2091,axiom,
    ! [VarNext: state_type] :
      ( v147482(VarNext)
     => ( v147457(VarNext)
      <=> v147492(VarNext) ) ) ).

tff(addAssignment_83085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147492(VarNext)
      <=> v147490(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19528,axiom,
    ! [VarCurr: state_type] :
      ( v147490(VarCurr)
    <=> ( v147493(VarCurr)
        & v147494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19527,axiom,
    ! [VarCurr: state_type] :
      ( v147494(VarCurr)
    <=> ( v147463(VarCurr)
        | v147477(VarCurr) ) ) ).

tff(writeUnaryOperator_11141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147493(VarCurr)
    <=> v147459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147482(VarNext)
      <=> v147483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147483(VarNext)
      <=> ( v147485(VarNext)
          & v147487(VarNext) ) ) ) ).

tff(writeUnaryOperator_11140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147487(VarCurr)
    <=> v147453(VarCurr) ) ).

tff(addAssignment_83084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147485(VarNext)
      <=> v147453(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_279,axiom,
    ( v147457(constB0)
  <=> $true ) ).

tff(addAssignment_83083,axiom,
    ! [VarCurr: state_type] :
      ( v147477(VarCurr)
    <=> v147479(VarCurr) ) ).

tff(addAssignment_83082,axiom,
    ! [VarCurr: state_type] :
      ( v147479(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83081,axiom,
    ! [VarCurr: state_type] :
      ( v147463(VarCurr)
    <=> v147465(VarCurr) ) ).

tff(addAssignment_83080,axiom,
    ! [VarCurr: state_type] :
      ( v147465(VarCurr)
    <=> v147467(VarCurr) ) ).

tff(addAssignment_83079,axiom,
    ! [VarCurr: state_type] :
      ( v147467(VarCurr)
    <=> v147469(VarCurr) ) ).

tff(addAssignment_83078,axiom,
    ! [VarCurr: state_type] :
      ( v147469(VarCurr)
    <=> v147471(VarCurr) ) ).

tff(addAssignment_83077,axiom,
    ! [VarCurr: state_type] :
      ( v147471(VarCurr)
    <=> v147473(VarCurr) ) ).

tff(addAssignment_83076,axiom,
    ! [VarCurr: state_type] :
      ( v147473(VarCurr)
    <=> v147475(VarCurr) ) ).

tff(addAssignment_83075,axiom,
    ! [VarCurr: state_type] :
      ( v147475(VarCurr)
    <=> v141218(VarCurr) ) ).

tff(addAssignment_83074,axiom,
    ! [VarCurr: state_type] :
      ( v147459(VarCurr)
    <=> v147461(VarCurr) ) ).

tff(addAssignment_83073,axiom,
    ! [VarCurr: state_type] :
      ( v147461(VarCurr)
    <=> $false ) ).

tff(addAssignment_83072,axiom,
    ! [VarCurr: state_type] :
      ( v147453(VarCurr)
    <=> v147455(VarCurr) ) ).

tff(addAssignment_83071,axiom,
    ! [VarCurr: state_type] :
      ( v147455(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147442(VarCurr,B)
      <=> v147444(VarCurr,B) ) ) ).

tff(addAssignment_83069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147444(VarCurr,B)
      <=> v147445(VarCurr,B) ) ) ).

tff(addAssignment_83068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147445(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_83067,axiom,
    ! [VarCurr: state_type] :
      ( ( v147445(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147445(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147445(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147445(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147445(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147445(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147445(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147445(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147445(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147445(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147445(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147445(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147445(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147445(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147445(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_83066,axiom,
    ! [VarCurr: state_type] :
      ( ( v147445(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147445(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147445(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_83065,axiom,
    ! [VarCurr: state_type] :
      ( ( v147445(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147445(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147445(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147445(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_83064,axiom,
    ! [VarCurr: state_type] :
      ( ( v147445(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147445(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147445(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_83063,axiom,
    ! [VarCurr: state_type] :
      ( v147432(VarCurr)
    <=> v147434(VarCurr) ) ).

tff(addAssignment_83062,axiom,
    ! [VarCurr: state_type] :
      ( v147434(VarCurr)
    <=> v147436(VarCurr) ) ).

tff(addAssignment_83061,axiom,
    ! [VarCurr: state_type] :
      ( v147436(VarCurr)
    <=> v147438(VarCurr) ) ).

tff(addAssignment_83060,axiom,
    ! [VarCurr: state_type] :
      ( v147438(VarCurr)
    <=> v147440(VarCurr) ) ).

tff(addAssignment_83059,axiom,
    ! [VarCurr: state_type] :
      ( v147440(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_83058,axiom,
    ! [VarCurr: state_type] :
      ( v147422(VarCurr)
    <=> v147424(VarCurr) ) ).

tff(addAssignment_83057,axiom,
    ! [VarCurr: state_type] :
      ( v147424(VarCurr)
    <=> v147426(VarCurr) ) ).

tff(addAssignment_83056,axiom,
    ! [VarCurr: state_type] :
      ( v147426(VarCurr)
    <=> v147428(VarCurr) ) ).

tff(addAssignment_83055,axiom,
    ! [VarCurr: state_type] :
      ( v147428(VarCurr)
    <=> v147430(VarCurr) ) ).

tff(addAssignment_83054,axiom,
    ! [VarCurr: state_type] :
      ( v147430(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_83053,axiom,
    ! [VarCurr: state_type] :
      ( v147402(VarCurr)
    <=> v147404(VarCurr) ) ).

tff(addAssignment_83052,axiom,
    ! [VarCurr: state_type] :
      ( v147404(VarCurr)
    <=> v147406(VarCurr) ) ).

tff(addAssignment_83051,axiom,
    ! [VarCurr: state_type] :
      ( v147406(VarCurr)
    <=> v147408(VarCurr) ) ).

tff(addAssignment_83050,axiom,
    ! [VarCurr: state_type] :
      ( v147408(VarCurr)
    <=> v147410(VarCurr) ) ).

tff(addAssignment_83049,axiom,
    ! [VarCurr: state_type] :
      ( v147410(VarCurr)
    <=> v146824(VarCurr,3) ) ).

tff(addAssignment_83048,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,3)
    <=> v146826(VarCurr,3) ) ).

tff(addAssignment_83047,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,3)
    <=> v146828(VarCurr,3) ) ).

tff(addAssignment_83046,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,3)
    <=> v146830(VarCurr,3) ) ).

tff(addAssignment_83045,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,3)
    <=> v147035(VarCurr,3) ) ).

tff(addAssignment_83044,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,3)
    <=> v146834(VarCurr,3) ) ).

tff(addAssignment_83043,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,3)
    <=> v146836(VarCurr,3) ) ).

tff(addAssignment_83042,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,3)
    <=> v147000(VarCurr,3) ) ).

tff(addAssignment_83041,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,3)
    <=> v146991(VarCurr,3) ) ).

tff(addAssignment_83040,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,3)
    <=> v146972(VarCurr,3) ) ).

tff(addAssignment_83039,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,3)
    <=> v146953(VarCurr,3) ) ).

tff(addAssignment_83038,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,3)
    <=> v146934(VarCurr,3) ) ).

tff(addAssignment_83037,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,3)
    <=> v146915(VarCurr,3) ) ).

tff(addAssignment_83036,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,3)
    <=> v146896(VarCurr,3) ) ).

tff(addAssignment_83035,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,3)
    <=> v146877(VarCurr,3) ) ).

tff(addAssignment_83034,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,3)
    <=> v146858(VarCurr,3) ) ).

tff(addAssignment_83033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147287(VarCurr,B)
      <=> v147289(VarCurr,B) ) ) ).

tff(addAssignment_83032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147289(VarCurr,B)
      <=> v147396(VarCurr,B) ) ) ).

tff(addAssignment_83031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147396(VarCurr,B)
      <=> v147400(VarCurr,B) ) ) ).

tff(addAssignment_83030,axiom,
    ! [VarCurr: state_type] :
      ( ( v147396(VarCurr,25)
      <=> v147399(VarCurr,14) )
      & ( v147396(VarCurr,24)
      <=> v147399(VarCurr,13) )
      & ( v147396(VarCurr,23)
      <=> v147399(VarCurr,12) )
      & ( v147396(VarCurr,22)
      <=> v147399(VarCurr,11) )
      & ( v147396(VarCurr,21)
      <=> v147399(VarCurr,10) )
      & ( v147396(VarCurr,20)
      <=> v147399(VarCurr,9) )
      & ( v147396(VarCurr,19)
      <=> v147399(VarCurr,8) )
      & ( v147396(VarCurr,18)
      <=> v147399(VarCurr,7) )
      & ( v147396(VarCurr,17)
      <=> v147399(VarCurr,6) )
      & ( v147396(VarCurr,16)
      <=> v147399(VarCurr,5) )
      & ( v147396(VarCurr,15)
      <=> v147399(VarCurr,4) )
      & ( v147396(VarCurr,14)
      <=> v147399(VarCurr,3) )
      & ( v147396(VarCurr,13)
      <=> v147399(VarCurr,2) )
      & ( v147396(VarCurr,12)
      <=> v147399(VarCurr,1) )
      & ( v147396(VarCurr,11)
      <=> v147399(VarCurr,0) ) ) ).

tff(addAssignment_83029,axiom,
    ! [VarCurr: state_type] :
      ( ( v147396(VarCurr,28)
      <=> v147398(VarCurr,2) )
      & ( v147396(VarCurr,27)
      <=> v147398(VarCurr,1) )
      & ( v147396(VarCurr,26)
      <=> v147398(VarCurr,0) ) ) ).

tff(addAssignment_83028,axiom,
    ! [VarCurr: state_type] :
      ( ( v147396(VarCurr,32)
      <=> v147291(VarCurr,3) )
      & ( v147396(VarCurr,31)
      <=> v147291(VarCurr,2) )
      & ( v147396(VarCurr,30)
      <=> v147291(VarCurr,1) )
      & ( v147396(VarCurr,29)
      <=> v147291(VarCurr,0) ) ) ).

tff(addAssignment_83027,axiom,
    ! [VarCurr: state_type] :
      ( ( v147396(VarCurr,35)
      <=> v147397(VarCurr,2) )
      & ( v147396(VarCurr,34)
      <=> v147397(VarCurr,1) )
      & ( v147396(VarCurr,33)
      <=> v147397(VarCurr,0) ) ) ).

tff(addAssignment_83026,axiom,
    ! [VarCurr: state_type] :
      ( ( v147291(VarCurr,3)
      <=> v147293(VarCurr,32) )
      & ( v147291(VarCurr,2)
      <=> v147293(VarCurr,31) )
      & ( v147291(VarCurr,1)
      <=> v147293(VarCurr,30) )
      & ( v147291(VarCurr,0)
      <=> v147293(VarCurr,29) ) ) ).

tff(addAssignment_83025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147293(VarCurr,B)
      <=> v147295(VarCurr,B) ) ) ).

tff(addAssignment_83024,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147295(VarNext,B)
      <=> v147379(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147380(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147379(VarNext,B)
            <=> v147295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2090,axiom,
    ! [VarNext: state_type] :
      ( v147380(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147379(VarNext,B)
          <=> v147390(VarNext,B) ) ) ) ).

tff(addAssignment_83023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147390(VarNext,B)
          <=> v147388(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147391(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147388(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1626,axiom,
    ! [VarCurr: state_type] :
      ( v147391(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147388(VarCurr,B)
          <=> v147317(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19524,axiom,
    ! [VarCurr: state_type] :
      ( v147391(VarCurr)
    <=> ( v147392(VarCurr)
        & v147393(VarCurr) ) ) ).

tff(writeUnaryOperator_11139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147393(VarCurr)
    <=> v147307(VarCurr) ) ).

tff(writeUnaryOperator_11138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147392(VarCurr)
    <=> v147297(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147380(VarNext)
      <=> v147381(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147381(VarNext)
      <=> ( v147382(VarNext)
          & v147322(VarNext) ) ) ) ).

tff(writeUnaryOperator_11137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147382(VarNext)
      <=> v147384(VarNext) ) ) ).

tff(addAssignment_83022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147384(VarNext)
      <=> v147322(VarCurr) ) ) ).

tff(addAssignment_83021,axiom,
    ! [VarCurr: state_type] :
      ( v147322(VarCurr)
    <=> v147324(VarCurr) ) ).

tff(addAssignment_83020,axiom,
    ! [VarCurr: state_type] :
      ( v147324(VarCurr)
    <=> v147326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19521,axiom,
    ! [VarCurr: state_type] :
      ( v147326(VarCurr)
    <=> ( v147377(VarCurr)
        | v147373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19520,axiom,
    ! [VarCurr: state_type] :
      ( v147377(VarCurr)
    <=> ( v147328(VarCurr)
        & v147332(VarCurr) ) ) ).

tff(addAssignment_83019,axiom,
    ! [VarCurr: state_type] :
      ( v147373(VarCurr)
    <=> v147375(VarCurr) ) ).

tff(addAssignment_83018,axiom,
    ! [VarCurr: state_type] :
      ( v147375(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147357(VarNext)
       => ( v147332(VarNext)
        <=> v147332(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2089,axiom,
    ! [VarNext: state_type] :
      ( v147357(VarNext)
     => ( v147332(VarNext)
      <=> v147367(VarNext) ) ) ).

tff(addAssignment_83017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147367(VarNext)
      <=> v147365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19519,axiom,
    ! [VarCurr: state_type] :
      ( v147365(VarCurr)
    <=> ( v147368(VarCurr)
        & v147369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19518,axiom,
    ! [VarCurr: state_type] :
      ( v147369(VarCurr)
    <=> ( v147338(VarCurr)
        | v147352(VarCurr) ) ) ).

tff(writeUnaryOperator_11136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147368(VarCurr)
    <=> v147334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147357(VarNext)
      <=> v147358(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147358(VarNext)
      <=> ( v147360(VarNext)
          & v147362(VarNext) ) ) ) ).

tff(writeUnaryOperator_11135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147362(VarCurr)
    <=> v147328(VarCurr) ) ).

tff(addAssignment_83016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147360(VarNext)
      <=> v147328(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_278,axiom,
    ( v147332(constB0)
  <=> $true ) ).

tff(addAssignment_83015,axiom,
    ! [VarCurr: state_type] :
      ( v147352(VarCurr)
    <=> v147354(VarCurr) ) ).

tff(addAssignment_83014,axiom,
    ! [VarCurr: state_type] :
      ( v147354(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_83013,axiom,
    ! [VarCurr: state_type] :
      ( v147338(VarCurr)
    <=> v147340(VarCurr) ) ).

tff(addAssignment_83012,axiom,
    ! [VarCurr: state_type] :
      ( v147340(VarCurr)
    <=> v147342(VarCurr) ) ).

tff(addAssignment_83011,axiom,
    ! [VarCurr: state_type] :
      ( v147342(VarCurr)
    <=> v147344(VarCurr) ) ).

tff(addAssignment_83010,axiom,
    ! [VarCurr: state_type] :
      ( v147344(VarCurr)
    <=> v147346(VarCurr) ) ).

tff(addAssignment_83009,axiom,
    ! [VarCurr: state_type] :
      ( v147346(VarCurr)
    <=> v147348(VarCurr) ) ).

tff(addAssignment_83008,axiom,
    ! [VarCurr: state_type] :
      ( v147348(VarCurr)
    <=> v147350(VarCurr) ) ).

tff(addAssignment_83007,axiom,
    ! [VarCurr: state_type] :
      ( v147350(VarCurr)
    <=> v141204(VarCurr) ) ).

tff(addAssignment_83006,axiom,
    ! [VarCurr: state_type] :
      ( v147334(VarCurr)
    <=> v147336(VarCurr) ) ).

tff(addAssignment_83005,axiom,
    ! [VarCurr: state_type] :
      ( v147336(VarCurr)
    <=> $false ) ).

tff(addAssignment_83004,axiom,
    ! [VarCurr: state_type] :
      ( v147328(VarCurr)
    <=> v147330(VarCurr) ) ).

tff(addAssignment_83003,axiom,
    ! [VarCurr: state_type] :
      ( v147330(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_83002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147317(VarCurr,B)
      <=> v147319(VarCurr,B) ) ) ).

tff(addAssignment_83001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147319(VarCurr,B)
      <=> v147320(VarCurr,B) ) ) ).

tff(addAssignment_83000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147320(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_82999,axiom,
    ! [VarCurr: state_type] :
      ( ( v147320(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147320(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147320(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147320(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147320(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147320(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147320(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147320(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147320(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147320(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147320(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147320(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147320(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147320(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147320(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_82998,axiom,
    ! [VarCurr: state_type] :
      ( ( v147320(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147320(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147320(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_82997,axiom,
    ! [VarCurr: state_type] :
      ( ( v147320(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147320(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147320(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147320(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_82996,axiom,
    ! [VarCurr: state_type] :
      ( ( v147320(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147320(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147320(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_82995,axiom,
    ! [VarCurr: state_type] :
      ( v147307(VarCurr)
    <=> v147309(VarCurr) ) ).

tff(addAssignment_82994,axiom,
    ! [VarCurr: state_type] :
      ( v147309(VarCurr)
    <=> v147311(VarCurr) ) ).

tff(addAssignment_82993,axiom,
    ! [VarCurr: state_type] :
      ( v147311(VarCurr)
    <=> v147313(VarCurr) ) ).

tff(addAssignment_82992,axiom,
    ! [VarCurr: state_type] :
      ( v147313(VarCurr)
    <=> v147315(VarCurr) ) ).

tff(addAssignment_82991,axiom,
    ! [VarCurr: state_type] :
      ( v147315(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_82990,axiom,
    ! [VarCurr: state_type] :
      ( v147297(VarCurr)
    <=> v147299(VarCurr) ) ).

tff(addAssignment_82989,axiom,
    ! [VarCurr: state_type] :
      ( v147299(VarCurr)
    <=> v147301(VarCurr) ) ).

tff(addAssignment_82988,axiom,
    ! [VarCurr: state_type] :
      ( v147301(VarCurr)
    <=> v147303(VarCurr) ) ).

tff(addAssignment_82987,axiom,
    ! [VarCurr: state_type] :
      ( v147303(VarCurr)
    <=> v147305(VarCurr) ) ).

tff(addAssignment_82986,axiom,
    ! [VarCurr: state_type] :
      ( v147305(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_82985,axiom,
    ! [VarCurr: state_type] :
      ( v147277(VarCurr)
    <=> v147279(VarCurr) ) ).

tff(addAssignment_82984,axiom,
    ! [VarCurr: state_type] :
      ( v147279(VarCurr)
    <=> v147281(VarCurr) ) ).

tff(addAssignment_82983,axiom,
    ! [VarCurr: state_type] :
      ( v147281(VarCurr)
    <=> v147283(VarCurr) ) ).

tff(addAssignment_82982,axiom,
    ! [VarCurr: state_type] :
      ( v147283(VarCurr)
    <=> v147285(VarCurr) ) ).

tff(addAssignment_82981,axiom,
    ! [VarCurr: state_type] :
      ( v147285(VarCurr)
    <=> v146824(VarCurr,2) ) ).

tff(addAssignment_82980,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,2)
    <=> v146826(VarCurr,2) ) ).

tff(addAssignment_82979,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,2)
    <=> v146828(VarCurr,2) ) ).

tff(addAssignment_82978,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,2)
    <=> v146830(VarCurr,2) ) ).

tff(addAssignment_82977,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,2)
    <=> v147035(VarCurr,2) ) ).

tff(addAssignment_82976,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,2)
    <=> v146834(VarCurr,2) ) ).

tff(addAssignment_82975,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,2)
    <=> v146836(VarCurr,2) ) ).

tff(addAssignment_82974,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,2)
    <=> v147000(VarCurr,2) ) ).

tff(addAssignment_82973,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,2)
    <=> v146991(VarCurr,2) ) ).

tff(addAssignment_82972,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,2)
    <=> v146972(VarCurr,2) ) ).

tff(addAssignment_82971,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,2)
    <=> v146953(VarCurr,2) ) ).

tff(addAssignment_82970,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,2)
    <=> v146934(VarCurr,2) ) ).

tff(addAssignment_82969,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,2)
    <=> v146915(VarCurr,2) ) ).

tff(addAssignment_82968,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,2)
    <=> v146896(VarCurr,2) ) ).

tff(addAssignment_82967,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,2)
    <=> v146877(VarCurr,2) ) ).

tff(addAssignment_82966,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,2)
    <=> v146858(VarCurr,2) ) ).

tff(addAssignment_82965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147162(VarCurr,B)
      <=> v147164(VarCurr,B) ) ) ).

tff(addAssignment_82964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147164(VarCurr,B)
      <=> v147271(VarCurr,B) ) ) ).

tff(addAssignment_82963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147271(VarCurr,B)
      <=> v147275(VarCurr,B) ) ) ).

tff(addAssignment_82962,axiom,
    ! [VarCurr: state_type] :
      ( ( v147271(VarCurr,25)
      <=> v147274(VarCurr,14) )
      & ( v147271(VarCurr,24)
      <=> v147274(VarCurr,13) )
      & ( v147271(VarCurr,23)
      <=> v147274(VarCurr,12) )
      & ( v147271(VarCurr,22)
      <=> v147274(VarCurr,11) )
      & ( v147271(VarCurr,21)
      <=> v147274(VarCurr,10) )
      & ( v147271(VarCurr,20)
      <=> v147274(VarCurr,9) )
      & ( v147271(VarCurr,19)
      <=> v147274(VarCurr,8) )
      & ( v147271(VarCurr,18)
      <=> v147274(VarCurr,7) )
      & ( v147271(VarCurr,17)
      <=> v147274(VarCurr,6) )
      & ( v147271(VarCurr,16)
      <=> v147274(VarCurr,5) )
      & ( v147271(VarCurr,15)
      <=> v147274(VarCurr,4) )
      & ( v147271(VarCurr,14)
      <=> v147274(VarCurr,3) )
      & ( v147271(VarCurr,13)
      <=> v147274(VarCurr,2) )
      & ( v147271(VarCurr,12)
      <=> v147274(VarCurr,1) )
      & ( v147271(VarCurr,11)
      <=> v147274(VarCurr,0) ) ) ).

tff(addAssignment_82961,axiom,
    ! [VarCurr: state_type] :
      ( ( v147271(VarCurr,28)
      <=> v147273(VarCurr,2) )
      & ( v147271(VarCurr,27)
      <=> v147273(VarCurr,1) )
      & ( v147271(VarCurr,26)
      <=> v147273(VarCurr,0) ) ) ).

tff(addAssignment_82960,axiom,
    ! [VarCurr: state_type] :
      ( ( v147271(VarCurr,32)
      <=> v147166(VarCurr,3) )
      & ( v147271(VarCurr,31)
      <=> v147166(VarCurr,2) )
      & ( v147271(VarCurr,30)
      <=> v147166(VarCurr,1) )
      & ( v147271(VarCurr,29)
      <=> v147166(VarCurr,0) ) ) ).

tff(addAssignment_82959,axiom,
    ! [VarCurr: state_type] :
      ( ( v147271(VarCurr,35)
      <=> v147272(VarCurr,2) )
      & ( v147271(VarCurr,34)
      <=> v147272(VarCurr,1) )
      & ( v147271(VarCurr,33)
      <=> v147272(VarCurr,0) ) ) ).

tff(addAssignment_82958,axiom,
    ! [VarCurr: state_type] :
      ( ( v147166(VarCurr,3)
      <=> v147168(VarCurr,32) )
      & ( v147166(VarCurr,2)
      <=> v147168(VarCurr,31) )
      & ( v147166(VarCurr,1)
      <=> v147168(VarCurr,30) )
      & ( v147166(VarCurr,0)
      <=> v147168(VarCurr,29) ) ) ).

tff(addAssignment_82957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147168(VarCurr,B)
      <=> v147170(VarCurr,B) ) ) ).

tff(addAssignment_82956,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147170(VarNext,B)
      <=> v147254(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147254(VarNext,B)
            <=> v147170(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2088,axiom,
    ! [VarNext: state_type] :
      ( v147255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147254(VarNext,B)
          <=> v147265(VarNext,B) ) ) ) ).

tff(addAssignment_82955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147265(VarNext,B)
          <=> v147263(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147266(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147263(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1625,axiom,
    ! [VarCurr: state_type] :
      ( v147266(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147263(VarCurr,B)
          <=> v147192(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19515,axiom,
    ! [VarCurr: state_type] :
      ( v147266(VarCurr)
    <=> ( v147267(VarCurr)
        & v147268(VarCurr) ) ) ).

tff(writeUnaryOperator_11134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147268(VarCurr)
    <=> v147182(VarCurr) ) ).

tff(writeUnaryOperator_11133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147267(VarCurr)
    <=> v147172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147255(VarNext)
      <=> v147256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147256(VarNext)
      <=> ( v147257(VarNext)
          & v147197(VarNext) ) ) ) ).

tff(writeUnaryOperator_11132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147257(VarNext)
      <=> v147259(VarNext) ) ) ).

tff(addAssignment_82954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147259(VarNext)
      <=> v147197(VarCurr) ) ) ).

tff(addAssignment_82953,axiom,
    ! [VarCurr: state_type] :
      ( v147197(VarCurr)
    <=> v147199(VarCurr) ) ).

tff(addAssignment_82952,axiom,
    ! [VarCurr: state_type] :
      ( v147199(VarCurr)
    <=> v147201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19512,axiom,
    ! [VarCurr: state_type] :
      ( v147201(VarCurr)
    <=> ( v147252(VarCurr)
        | v147248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19511,axiom,
    ! [VarCurr: state_type] :
      ( v147252(VarCurr)
    <=> ( v147203(VarCurr)
        & v147207(VarCurr) ) ) ).

tff(addAssignment_82951,axiom,
    ! [VarCurr: state_type] :
      ( v147248(VarCurr)
    <=> v147250(VarCurr) ) ).

tff(addAssignment_82950,axiom,
    ! [VarCurr: state_type] :
      ( v147250(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147232(VarNext)
       => ( v147207(VarNext)
        <=> v147207(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2087,axiom,
    ! [VarNext: state_type] :
      ( v147232(VarNext)
     => ( v147207(VarNext)
      <=> v147242(VarNext) ) ) ).

tff(addAssignment_82949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147242(VarNext)
      <=> v147240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19510,axiom,
    ! [VarCurr: state_type] :
      ( v147240(VarCurr)
    <=> ( v147243(VarCurr)
        & v147244(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19509,axiom,
    ! [VarCurr: state_type] :
      ( v147244(VarCurr)
    <=> ( v147213(VarCurr)
        | v147227(VarCurr) ) ) ).

tff(writeUnaryOperator_11131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147243(VarCurr)
    <=> v147209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147232(VarNext)
      <=> v147233(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147233(VarNext)
      <=> ( v147235(VarNext)
          & v147237(VarNext) ) ) ) ).

tff(writeUnaryOperator_11130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147237(VarCurr)
    <=> v147203(VarCurr) ) ).

tff(addAssignment_82948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147235(VarNext)
      <=> v147203(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_277,axiom,
    ( v147207(constB0)
  <=> $true ) ).

tff(addAssignment_82947,axiom,
    ! [VarCurr: state_type] :
      ( v147227(VarCurr)
    <=> v147229(VarCurr) ) ).

tff(addAssignment_82946,axiom,
    ! [VarCurr: state_type] :
      ( v147229(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_82945,axiom,
    ! [VarCurr: state_type] :
      ( v147213(VarCurr)
    <=> v147215(VarCurr) ) ).

tff(addAssignment_82944,axiom,
    ! [VarCurr: state_type] :
      ( v147215(VarCurr)
    <=> v147217(VarCurr) ) ).

tff(addAssignment_82943,axiom,
    ! [VarCurr: state_type] :
      ( v147217(VarCurr)
    <=> v147219(VarCurr) ) ).

tff(addAssignment_82942,axiom,
    ! [VarCurr: state_type] :
      ( v147219(VarCurr)
    <=> v147221(VarCurr) ) ).

tff(addAssignment_82941,axiom,
    ! [VarCurr: state_type] :
      ( v147221(VarCurr)
    <=> v147223(VarCurr) ) ).

tff(addAssignment_82940,axiom,
    ! [VarCurr: state_type] :
      ( v147223(VarCurr)
    <=> v147225(VarCurr) ) ).

tff(addAssignment_82939,axiom,
    ! [VarCurr: state_type] :
      ( v147225(VarCurr)
    <=> v141190(VarCurr) ) ).

tff(addAssignment_82938,axiom,
    ! [VarCurr: state_type] :
      ( v147209(VarCurr)
    <=> v147211(VarCurr) ) ).

tff(addAssignment_82937,axiom,
    ! [VarCurr: state_type] :
      ( v147211(VarCurr)
    <=> $false ) ).

tff(addAssignment_82936,axiom,
    ! [VarCurr: state_type] :
      ( v147203(VarCurr)
    <=> v147205(VarCurr) ) ).

tff(addAssignment_82935,axiom,
    ! [VarCurr: state_type] :
      ( v147205(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_82934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147192(VarCurr,B)
      <=> v147194(VarCurr,B) ) ) ).

tff(addAssignment_82933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147194(VarCurr,B)
      <=> v147195(VarCurr,B) ) ) ).

tff(addAssignment_82932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147195(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_82931,axiom,
    ! [VarCurr: state_type] :
      ( ( v147195(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147195(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147195(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147195(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147195(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147195(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147195(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147195(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147195(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147195(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147195(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147195(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147195(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147195(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147195(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_82930,axiom,
    ! [VarCurr: state_type] :
      ( ( v147195(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147195(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147195(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_82929,axiom,
    ! [VarCurr: state_type] :
      ( ( v147195(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147195(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147195(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147195(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_82928,axiom,
    ! [VarCurr: state_type] :
      ( ( v147195(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147195(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147195(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_82927,axiom,
    ! [VarCurr: state_type] :
      ( v147182(VarCurr)
    <=> v147184(VarCurr) ) ).

tff(addAssignment_82926,axiom,
    ! [VarCurr: state_type] :
      ( v147184(VarCurr)
    <=> v147186(VarCurr) ) ).

tff(addAssignment_82925,axiom,
    ! [VarCurr: state_type] :
      ( v147186(VarCurr)
    <=> v147188(VarCurr) ) ).

tff(addAssignment_82924,axiom,
    ! [VarCurr: state_type] :
      ( v147188(VarCurr)
    <=> v147190(VarCurr) ) ).

tff(addAssignment_82923,axiom,
    ! [VarCurr: state_type] :
      ( v147190(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_82922,axiom,
    ! [VarCurr: state_type] :
      ( v147172(VarCurr)
    <=> v147174(VarCurr) ) ).

tff(addAssignment_82921,axiom,
    ! [VarCurr: state_type] :
      ( v147174(VarCurr)
    <=> v147176(VarCurr) ) ).

tff(addAssignment_82920,axiom,
    ! [VarCurr: state_type] :
      ( v147176(VarCurr)
    <=> v147178(VarCurr) ) ).

tff(addAssignment_82919,axiom,
    ! [VarCurr: state_type] :
      ( v147178(VarCurr)
    <=> v147180(VarCurr) ) ).

tff(addAssignment_82918,axiom,
    ! [VarCurr: state_type] :
      ( v147180(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_82917,axiom,
    ! [VarCurr: state_type] :
      ( v147152(VarCurr)
    <=> v147154(VarCurr) ) ).

tff(addAssignment_82916,axiom,
    ! [VarCurr: state_type] :
      ( v147154(VarCurr)
    <=> v147156(VarCurr) ) ).

tff(addAssignment_82915,axiom,
    ! [VarCurr: state_type] :
      ( v147156(VarCurr)
    <=> v147158(VarCurr) ) ).

tff(addAssignment_82914,axiom,
    ! [VarCurr: state_type] :
      ( v147158(VarCurr)
    <=> v147160(VarCurr) ) ).

tff(addAssignment_82913,axiom,
    ! [VarCurr: state_type] :
      ( v147160(VarCurr)
    <=> v146824(VarCurr,1) ) ).

tff(addAssignment_82912,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,1)
    <=> v146826(VarCurr,1) ) ).

tff(addAssignment_82911,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,1)
    <=> v146828(VarCurr,1) ) ).

tff(addAssignment_82910,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,1)
    <=> v146830(VarCurr,1) ) ).

tff(addAssignment_82909,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,1)
    <=> v147035(VarCurr,1) ) ).

tff(addAssignment_82908,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,1)
    <=> v146834(VarCurr,1) ) ).

tff(addAssignment_82907,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,1)
    <=> v146836(VarCurr,1) ) ).

tff(addAssignment_82906,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,1)
    <=> v147000(VarCurr,1) ) ).

tff(addAssignment_82905,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,1)
    <=> v146991(VarCurr,1) ) ).

tff(addAssignment_82904,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,1)
    <=> v146972(VarCurr,1) ) ).

tff(addAssignment_82903,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,1)
    <=> v146953(VarCurr,1) ) ).

tff(addAssignment_82902,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,1)
    <=> v146934(VarCurr,1) ) ).

tff(addAssignment_82901,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,1)
    <=> v146915(VarCurr,1) ) ).

tff(addAssignment_82900,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,1)
    <=> v146896(VarCurr,1) ) ).

tff(addAssignment_82899,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,1)
    <=> v146877(VarCurr,1) ) ).

tff(addAssignment_82898,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,1)
    <=> v146858(VarCurr,1) ) ).

tff(addAssignment_82897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147037(VarCurr,B)
      <=> v147039(VarCurr,B) ) ) ).

tff(addAssignment_82896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147039(VarCurr,B)
      <=> v147146(VarCurr,B) ) ) ).

tff(addAssignment_82895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147146(VarCurr,B)
      <=> v147150(VarCurr,B) ) ) ).

tff(addAssignment_82894,axiom,
    ! [VarCurr: state_type] :
      ( ( v147146(VarCurr,25)
      <=> v147149(VarCurr,14) )
      & ( v147146(VarCurr,24)
      <=> v147149(VarCurr,13) )
      & ( v147146(VarCurr,23)
      <=> v147149(VarCurr,12) )
      & ( v147146(VarCurr,22)
      <=> v147149(VarCurr,11) )
      & ( v147146(VarCurr,21)
      <=> v147149(VarCurr,10) )
      & ( v147146(VarCurr,20)
      <=> v147149(VarCurr,9) )
      & ( v147146(VarCurr,19)
      <=> v147149(VarCurr,8) )
      & ( v147146(VarCurr,18)
      <=> v147149(VarCurr,7) )
      & ( v147146(VarCurr,17)
      <=> v147149(VarCurr,6) )
      & ( v147146(VarCurr,16)
      <=> v147149(VarCurr,5) )
      & ( v147146(VarCurr,15)
      <=> v147149(VarCurr,4) )
      & ( v147146(VarCurr,14)
      <=> v147149(VarCurr,3) )
      & ( v147146(VarCurr,13)
      <=> v147149(VarCurr,2) )
      & ( v147146(VarCurr,12)
      <=> v147149(VarCurr,1) )
      & ( v147146(VarCurr,11)
      <=> v147149(VarCurr,0) ) ) ).

tff(addAssignment_82893,axiom,
    ! [VarCurr: state_type] :
      ( ( v147146(VarCurr,28)
      <=> v147148(VarCurr,2) )
      & ( v147146(VarCurr,27)
      <=> v147148(VarCurr,1) )
      & ( v147146(VarCurr,26)
      <=> v147148(VarCurr,0) ) ) ).

tff(addAssignment_82892,axiom,
    ! [VarCurr: state_type] :
      ( ( v147146(VarCurr,32)
      <=> v147041(VarCurr,3) )
      & ( v147146(VarCurr,31)
      <=> v147041(VarCurr,2) )
      & ( v147146(VarCurr,30)
      <=> v147041(VarCurr,1) )
      & ( v147146(VarCurr,29)
      <=> v147041(VarCurr,0) ) ) ).

tff(addAssignment_82891,axiom,
    ! [VarCurr: state_type] :
      ( ( v147146(VarCurr,35)
      <=> v147147(VarCurr,2) )
      & ( v147146(VarCurr,34)
      <=> v147147(VarCurr,1) )
      & ( v147146(VarCurr,33)
      <=> v147147(VarCurr,0) ) ) ).

tff(addAssignment_82890,axiom,
    ! [VarCurr: state_type] :
      ( ( v147041(VarCurr,3)
      <=> v147043(VarCurr,32) )
      & ( v147041(VarCurr,2)
      <=> v147043(VarCurr,31) )
      & ( v147041(VarCurr,1)
      <=> v147043(VarCurr,30) )
      & ( v147041(VarCurr,0)
      <=> v147043(VarCurr,29) ) ) ).

tff(addAssignment_82889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147043(VarCurr,B)
      <=> v147045(VarCurr,B) ) ) ).

tff(addAssignment_82888,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147045(VarNext,B)
      <=> v147129(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147130(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v147129(VarNext,B)
            <=> v147045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2086,axiom,
    ! [VarNext: state_type] :
      ( v147130(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147129(VarNext,B)
          <=> v147140(VarNext,B) ) ) ) ).

tff(addAssignment_82887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147140(VarNext,B)
          <=> v147138(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147141(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147138(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1624,axiom,
    ! [VarCurr: state_type] :
      ( v147141(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v147138(VarCurr,B)
          <=> v147067(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19506,axiom,
    ! [VarCurr: state_type] :
      ( v147141(VarCurr)
    <=> ( v147142(VarCurr)
        & v147143(VarCurr) ) ) ).

tff(writeUnaryOperator_11129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147143(VarCurr)
    <=> v147057(VarCurr) ) ).

tff(writeUnaryOperator_11128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147142(VarCurr)
    <=> v147047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147130(VarNext)
      <=> v147131(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147131(VarNext)
      <=> ( v147132(VarNext)
          & v147072(VarNext) ) ) ) ).

tff(writeUnaryOperator_11127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147132(VarNext)
      <=> v147134(VarNext) ) ) ).

tff(addAssignment_82886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147134(VarNext)
      <=> v147072(VarCurr) ) ) ).

tff(addAssignment_82885,axiom,
    ! [VarCurr: state_type] :
      ( v147072(VarCurr)
    <=> v147074(VarCurr) ) ).

tff(addAssignment_82884,axiom,
    ! [VarCurr: state_type] :
      ( v147074(VarCurr)
    <=> v147076(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19503,axiom,
    ! [VarCurr: state_type] :
      ( v147076(VarCurr)
    <=> ( v147127(VarCurr)
        | v147123(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19502,axiom,
    ! [VarCurr: state_type] :
      ( v147127(VarCurr)
    <=> ( v147078(VarCurr)
        & v147082(VarCurr) ) ) ).

tff(addAssignment_82883,axiom,
    ! [VarCurr: state_type] :
      ( v147123(VarCurr)
    <=> v147125(VarCurr) ) ).

tff(addAssignment_82882,axiom,
    ! [VarCurr: state_type] :
      ( v147125(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v147107(VarNext)
       => ( v147082(VarNext)
        <=> v147082(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2085,axiom,
    ! [VarNext: state_type] :
      ( v147107(VarNext)
     => ( v147082(VarNext)
      <=> v147117(VarNext) ) ) ).

tff(addAssignment_82881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147117(VarNext)
      <=> v147115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19501,axiom,
    ! [VarCurr: state_type] :
      ( v147115(VarCurr)
    <=> ( v147118(VarCurr)
        & v147119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19500,axiom,
    ! [VarCurr: state_type] :
      ( v147119(VarCurr)
    <=> ( v147088(VarCurr)
        | v147102(VarCurr) ) ) ).

tff(writeUnaryOperator_11126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147118(VarCurr)
    <=> v147084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147107(VarNext)
      <=> v147108(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147108(VarNext)
      <=> ( v147110(VarNext)
          & v147112(VarNext) ) ) ) ).

tff(writeUnaryOperator_11125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147112(VarCurr)
    <=> v147078(VarCurr) ) ).

tff(addAssignment_82880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v147110(VarNext)
      <=> v147078(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_276,axiom,
    ( v147082(constB0)
  <=> $true ) ).

tff(addAssignment_82879,axiom,
    ! [VarCurr: state_type] :
      ( v147102(VarCurr)
    <=> v147104(VarCurr) ) ).

tff(addAssignment_82878,axiom,
    ! [VarCurr: state_type] :
      ( v147104(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_82877,axiom,
    ! [VarCurr: state_type] :
      ( v147088(VarCurr)
    <=> v147090(VarCurr) ) ).

tff(addAssignment_82876,axiom,
    ! [VarCurr: state_type] :
      ( v147090(VarCurr)
    <=> v147092(VarCurr) ) ).

tff(addAssignment_82875,axiom,
    ! [VarCurr: state_type] :
      ( v147092(VarCurr)
    <=> v147094(VarCurr) ) ).

tff(addAssignment_82874,axiom,
    ! [VarCurr: state_type] :
      ( v147094(VarCurr)
    <=> v147096(VarCurr) ) ).

tff(addAssignment_82873,axiom,
    ! [VarCurr: state_type] :
      ( v147096(VarCurr)
    <=> v147098(VarCurr) ) ).

tff(addAssignment_82872,axiom,
    ! [VarCurr: state_type] :
      ( v147098(VarCurr)
    <=> v147100(VarCurr) ) ).

tff(addAssignment_82871,axiom,
    ! [VarCurr: state_type] :
      ( v147100(VarCurr)
    <=> v141177(VarCurr) ) ).

tff(addAssignment_82870,axiom,
    ! [VarCurr: state_type] :
      ( v147084(VarCurr)
    <=> v147086(VarCurr) ) ).

tff(addAssignment_82869,axiom,
    ! [VarCurr: state_type] :
      ( v147086(VarCurr)
    <=> $false ) ).

tff(addAssignment_82868,axiom,
    ! [VarCurr: state_type] :
      ( v147078(VarCurr)
    <=> v147080(VarCurr) ) ).

tff(addAssignment_82867,axiom,
    ! [VarCurr: state_type] :
      ( v147080(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_82866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147067(VarCurr,B)
      <=> v147069(VarCurr,B) ) ) ).

tff(addAssignment_82865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v147069(VarCurr,B)
      <=> v147070(VarCurr,B) ) ) ).

tff(addAssignment_82864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v147070(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_82863,axiom,
    ! [VarCurr: state_type] :
      ( ( v147070(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v147070(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v147070(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v147070(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v147070(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v147070(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v147070(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v147070(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v147070(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v147070(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v147070(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v147070(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v147070(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v147070(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v147070(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_82862,axiom,
    ! [VarCurr: state_type] :
      ( ( v147070(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v147070(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v147070(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_82861,axiom,
    ! [VarCurr: state_type] :
      ( ( v147070(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v147070(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v147070(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v147070(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_82860,axiom,
    ! [VarCurr: state_type] :
      ( ( v147070(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v147070(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v147070(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_82859,axiom,
    ! [VarCurr: state_type] :
      ( v147057(VarCurr)
    <=> v147059(VarCurr) ) ).

tff(addAssignment_82858,axiom,
    ! [VarCurr: state_type] :
      ( v147059(VarCurr)
    <=> v147061(VarCurr) ) ).

tff(addAssignment_82857,axiom,
    ! [VarCurr: state_type] :
      ( v147061(VarCurr)
    <=> v147063(VarCurr) ) ).

tff(addAssignment_82856,axiom,
    ! [VarCurr: state_type] :
      ( v147063(VarCurr)
    <=> v147065(VarCurr) ) ).

tff(addAssignment_82855,axiom,
    ! [VarCurr: state_type] :
      ( v147065(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_82854,axiom,
    ! [VarCurr: state_type] :
      ( v147047(VarCurr)
    <=> v147049(VarCurr) ) ).

tff(addAssignment_82853,axiom,
    ! [VarCurr: state_type] :
      ( v147049(VarCurr)
    <=> v147051(VarCurr) ) ).

tff(addAssignment_82852,axiom,
    ! [VarCurr: state_type] :
      ( v147051(VarCurr)
    <=> v147053(VarCurr) ) ).

tff(addAssignment_82851,axiom,
    ! [VarCurr: state_type] :
      ( v147053(VarCurr)
    <=> v147055(VarCurr) ) ).

tff(addAssignment_82850,axiom,
    ! [VarCurr: state_type] :
      ( v147055(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_82849,axiom,
    ! [VarCurr: state_type] :
      ( v146814(VarCurr)
    <=> v146816(VarCurr) ) ).

tff(addAssignment_82848,axiom,
    ! [VarCurr: state_type] :
      ( v146816(VarCurr)
    <=> v146818(VarCurr) ) ).

tff(addAssignment_82847,axiom,
    ! [VarCurr: state_type] :
      ( v146818(VarCurr)
    <=> v146820(VarCurr) ) ).

tff(addAssignment_82846,axiom,
    ! [VarCurr: state_type] :
      ( v146820(VarCurr)
    <=> v146822(VarCurr) ) ).

tff(addAssignment_82845,axiom,
    ! [VarCurr: state_type] :
      ( v146822(VarCurr)
    <=> v146824(VarCurr,0) ) ).

tff(addAssignment_82844,axiom,
    ! [VarCurr: state_type] :
      ( v146824(VarCurr,0)
    <=> v146826(VarCurr,0) ) ).

tff(addAssignment_82843,axiom,
    ! [VarCurr: state_type] :
      ( v146826(VarCurr,0)
    <=> v146828(VarCurr,0) ) ).

tff(addAssignment_82842,axiom,
    ! [VarCurr: state_type] :
      ( v146828(VarCurr,0)
    <=> v146830(VarCurr,0) ) ).

tff(addAssignment_82841,axiom,
    ! [VarCurr: state_type] :
      ( v146830(VarCurr,0)
    <=> v147035(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v147035(VarCurr,B)
          <=> v130646(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1623,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v147035(VarCurr,B)
          <=> v146832(VarCurr,B) ) ) ) ).

tff(addAssignment_82840,axiom,
    ! [VarCurr: state_type] :
      ( v146832(VarCurr,0)
    <=> v146834(VarCurr,0) ) ).

tff(addAssignment_82839,axiom,
    ! [VarCurr: state_type] :
      ( v146834(VarCurr,0)
    <=> v146836(VarCurr,0) ) ).

tff(addAssignment_82838,axiom,
    ! [VarCurr: state_type] :
      ( v146836(VarCurr,0)
    <=> v147000(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147000(VarCurr,B)
      <=> ( v147001(VarCurr,B)
          | v147032(VarCurr,B) ) ) ) ).

tff(addAssignment_82837,axiom,
    ! [VarCurr: state_type] :
      ( v147032(VarCurr,0)
    <=> v147033(VarCurr) ) ).

tff(addAssignment_82836,axiom,
    ! [VarCurr: state_type] :
      ( ( v147032(VarCurr,7)
      <=> $false )
      & ( v147032(VarCurr,6)
      <=> $false )
      & ( v147032(VarCurr,5)
      <=> $false )
      & ( v147032(VarCurr,4)
      <=> $false )
      & ( v147032(VarCurr,3)
      <=> $false )
      & ( v147032(VarCurr,2)
      <=> $false )
      & ( v147032(VarCurr,1)
      <=> $false ) ) ).

tff(writeUnaryOperator_11124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v147033(VarCurr)
    <=> v147034(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6954,axiom,
    ! [VarCurr: state_type] :
      ( v147034(VarCurr)
    <=> ( v112971(VarCurr)
        | v84975(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147001(VarCurr,B)
      <=> ( v147002(VarCurr,B)
          | v147029(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147029(VarCurr,B)
      <=> ( v147030(VarCurr,B)
          & v146982(VarCurr,B) ) ) ) ).

tff(addAssignment_82835,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,0)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82834,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,1)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82833,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,2)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82832,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,3)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82831,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,4)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82830,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,5)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82829,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,6)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82828,axiom,
    ! [VarCurr: state_type] :
      ( v147030(VarCurr,7)
    <=> v147031(VarCurr) ) ).

tff(addAssignment_82827,axiom,
    ! [VarCurr: state_type] :
      ( v147031(VarCurr)
    <=> v84975(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147002(VarCurr,B)
      <=> ( v147003(VarCurr,B)
          | v147026(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147026(VarCurr,B)
      <=> ( v147027(VarCurr,B)
          & v146963(VarCurr,B) ) ) ) ).

tff(addAssignment_82826,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,0)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82825,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,1)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82824,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,2)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82823,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,3)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82822,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,4)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82821,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,5)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82820,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,6)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82819,axiom,
    ! [VarCurr: state_type] :
      ( v147027(VarCurr,7)
    <=> v147028(VarCurr) ) ).

tff(addAssignment_82818,axiom,
    ! [VarCurr: state_type] :
      ( v147028(VarCurr)
    <=> v84975(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147003(VarCurr,B)
      <=> ( v147004(VarCurr,B)
          | v147023(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147023(VarCurr,B)
      <=> ( v147024(VarCurr,B)
          & v146944(VarCurr,B) ) ) ) ).

tff(addAssignment_82817,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,0)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82816,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,1)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82815,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,2)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82814,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,3)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82813,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,4)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82812,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,5)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82811,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,6)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82810,axiom,
    ! [VarCurr: state_type] :
      ( v147024(VarCurr,7)
    <=> v147025(VarCurr) ) ).

tff(addAssignment_82809,axiom,
    ! [VarCurr: state_type] :
      ( v147025(VarCurr)
    <=> v84975(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147004(VarCurr,B)
      <=> ( v147005(VarCurr,B)
          | v147020(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147020(VarCurr,B)
      <=> ( v147021(VarCurr,B)
          & v146925(VarCurr,B) ) ) ) ).

tff(addAssignment_82808,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,0)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82807,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,1)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82806,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,2)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82805,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,3)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82804,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,4)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82803,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,5)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82802,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,6)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82801,axiom,
    ! [VarCurr: state_type] :
      ( v147021(VarCurr,7)
    <=> v147022(VarCurr) ) ).

tff(addAssignment_82800,axiom,
    ! [VarCurr: state_type] :
      ( v147022(VarCurr)
    <=> v84975(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147005(VarCurr,B)
      <=> ( v147006(VarCurr,B)
          | v147017(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147017(VarCurr,B)
      <=> ( v147018(VarCurr,B)
          & v146906(VarCurr,B) ) ) ) ).

tff(addAssignment_82799,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,0)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82798,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,1)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82797,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,2)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82796,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,3)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82795,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,4)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82794,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,5)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82793,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,6)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82792,axiom,
    ! [VarCurr: state_type] :
      ( v147018(VarCurr,7)
    <=> v147019(VarCurr) ) ).

tff(addAssignment_82791,axiom,
    ! [VarCurr: state_type] :
      ( v147019(VarCurr)
    <=> v84975(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147006(VarCurr,B)
      <=> ( v147007(VarCurr,B)
          | v147014(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147014(VarCurr,B)
      <=> ( v147015(VarCurr,B)
          & v146887(VarCurr,B) ) ) ) ).

tff(addAssignment_82790,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,0)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82789,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,1)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82788,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,2)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82787,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,3)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82786,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,4)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82785,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,5)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82784,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,6)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82783,axiom,
    ! [VarCurr: state_type] :
      ( v147015(VarCurr,7)
    <=> v147016(VarCurr) ) ).

tff(addAssignment_82782,axiom,
    ! [VarCurr: state_type] :
      ( v147016(VarCurr)
    <=> v84975(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147007(VarCurr,B)
      <=> ( v147008(VarCurr,B)
          | v147011(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147011(VarCurr,B)
      <=> ( v147012(VarCurr,B)
          & v146868(VarCurr,B) ) ) ) ).

tff(addAssignment_82781,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,0)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82780,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,1)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82779,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,2)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82778,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,3)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82777,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,4)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82776,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,5)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82775,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,6)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82774,axiom,
    ! [VarCurr: state_type] :
      ( v147012(VarCurr,7)
    <=> v147013(VarCurr) ) ).

tff(addAssignment_82773,axiom,
    ! [VarCurr: state_type] :
      ( v147013(VarCurr)
    <=> v84975(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v147008(VarCurr,B)
      <=> ( v147009(VarCurr,B)
          & v146838(VarCurr,B) ) ) ) ).

tff(addAssignment_82772,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,0)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82771,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,1)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82770,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,2)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82769,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,3)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82768,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,4)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82767,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,5)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82766,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,6)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82765,axiom,
    ! [VarCurr: state_type] :
      ( v147009(VarCurr,7)
    <=> v147010(VarCurr) ) ).

tff(addAssignment_82764,axiom,
    ! [VarCurr: state_type] :
      ( v147010(VarCurr)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_82763,axiom,
    ! [VarCurr: state_type] :
      ( v146982(VarCurr,0)
    <=> v146991(VarCurr,0) ) ).

tff(addAssignment_82762,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,0)
    <=> v146999(VarCurr) ) ).

tff(addAssignment_82761,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,1)
    <=> v146998(VarCurr) ) ).

tff(addAssignment_82760,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,2)
    <=> v146997(VarCurr) ) ).

tff(addAssignment_82759,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,3)
    <=> v146996(VarCurr) ) ).

tff(addAssignment_82758,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,4)
    <=> v146995(VarCurr) ) ).

tff(addAssignment_82757,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,5)
    <=> v146994(VarCurr) ) ).

tff(addAssignment_82756,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,6)
    <=> v146993(VarCurr) ) ).

tff(addAssignment_82755,axiom,
    ! [VarCurr: state_type] :
      ( v146991(VarCurr,7)
    <=> v146992(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2299,axiom,
    ! [VarCurr: state_type] :
      ( v146999(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $false )
        & ( v85128(VarCurr,10)
        <=> $false )
        & ( v85128(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2298,axiom,
    ! [VarCurr: state_type] :
      ( v146998(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $false )
        & ( v85128(VarCurr,10)
        <=> $false )
        & ( v85128(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2297,axiom,
    ! [VarCurr: state_type] :
      ( v146997(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $false )
        & ( v85128(VarCurr,10)
        <=> $true )
        & ( v85128(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2296,axiom,
    ! [VarCurr: state_type] :
      ( v146996(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $false )
        & ( v85128(VarCurr,10)
        <=> $true )
        & ( v85128(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2295,axiom,
    ! [VarCurr: state_type] :
      ( v146995(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $true )
        & ( v85128(VarCurr,10)
        <=> $false )
        & ( v85128(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2294,axiom,
    ! [VarCurr: state_type] :
      ( v146994(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $true )
        & ( v85128(VarCurr,10)
        <=> $false )
        & ( v85128(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2293,axiom,
    ! [VarCurr: state_type] :
      ( v146993(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $true )
        & ( v85128(VarCurr,10)
        <=> $true )
        & ( v85128(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2292,axiom,
    ! [VarCurr: state_type] :
      ( v146992(VarCurr)
    <=> ( ( v85128(VarCurr,11)
        <=> $true )
        & ( v85128(VarCurr,10)
        <=> $true )
        & ( v85128(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85128(VarCurr,B)
      <=> v85130(VarCurr,B) ) ) ).

tff(addAssignment_82753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85130(VarCurr,B)
      <=> v85132(VarCurr,B) ) ) ).

tff(addAssignment_82752,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85132(VarNext,B)
      <=> v146984(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146985(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146984(VarNext,B)
            <=> v85132(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2084,axiom,
    ! [VarNext: state_type] :
      ( v146985(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146984(VarNext,B)
          <=> v85678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146985(VarNext)
      <=> v146986(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146986(VarNext)
      <=> ( v146988(VarNext)
          & v85663(VarNext) ) ) ) ).

tff(writeUnaryOperator_11123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146988(VarNext)
      <=> v85672(VarNext) ) ) ).

tff(addAssignment_82751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85142(VarCurr,B)
      <=> v85144(VarCurr,B) ) ) ).

tff(addAssignment_82750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85144(VarCurr,B)
      <=> v85654(VarCurr,B) ) ) ).

tff(addAssignment_82749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85146(VarCurr,B)
      <=> v85148(VarCurr,B) ) ) ).

tff(addAssignment_82748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85148(VarCurr,B)
      <=> v85646(VarCurr,B) ) ) ).

tff(addAssignment_82747,axiom,
    ! [VarCurr: state_type] :
      ( v146963(VarCurr,0)
    <=> v146972(VarCurr,0) ) ).

tff(addAssignment_82746,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,0)
    <=> v146980(VarCurr) ) ).

tff(addAssignment_82745,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,1)
    <=> v146979(VarCurr) ) ).

tff(addAssignment_82744,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,2)
    <=> v146978(VarCurr) ) ).

tff(addAssignment_82743,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,3)
    <=> v146977(VarCurr) ) ).

tff(addAssignment_82742,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,4)
    <=> v146976(VarCurr) ) ).

tff(addAssignment_82741,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,5)
    <=> v146975(VarCurr) ) ).

tff(addAssignment_82740,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,6)
    <=> v146974(VarCurr) ) ).

tff(addAssignment_82739,axiom,
    ! [VarCurr: state_type] :
      ( v146972(VarCurr,7)
    <=> v146973(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2291,axiom,
    ! [VarCurr: state_type] :
      ( v146980(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $false )
        & ( v85150(VarCurr,10)
        <=> $false )
        & ( v85150(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2290,axiom,
    ! [VarCurr: state_type] :
      ( v146979(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $false )
        & ( v85150(VarCurr,10)
        <=> $false )
        & ( v85150(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2289,axiom,
    ! [VarCurr: state_type] :
      ( v146978(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $false )
        & ( v85150(VarCurr,10)
        <=> $true )
        & ( v85150(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2288,axiom,
    ! [VarCurr: state_type] :
      ( v146977(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $false )
        & ( v85150(VarCurr,10)
        <=> $true )
        & ( v85150(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2287,axiom,
    ! [VarCurr: state_type] :
      ( v146976(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $true )
        & ( v85150(VarCurr,10)
        <=> $false )
        & ( v85150(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2286,axiom,
    ! [VarCurr: state_type] :
      ( v146975(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $true )
        & ( v85150(VarCurr,10)
        <=> $false )
        & ( v85150(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2285,axiom,
    ! [VarCurr: state_type] :
      ( v146974(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $true )
        & ( v85150(VarCurr,10)
        <=> $true )
        & ( v85150(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2284,axiom,
    ! [VarCurr: state_type] :
      ( v146973(VarCurr)
    <=> ( ( v85150(VarCurr,11)
        <=> $true )
        & ( v85150(VarCurr,10)
        <=> $true )
        & ( v85150(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85150(VarCurr,B)
      <=> v85152(VarCurr,B) ) ) ).

tff(addAssignment_82737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85152(VarCurr,B)
      <=> v85154(VarCurr,B) ) ) ).

tff(addAssignment_82736,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85154(VarNext,B)
      <=> v146965(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146966(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146965(VarNext,B)
            <=> v85154(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2083,axiom,
    ! [VarNext: state_type] :
      ( v146966(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146965(VarNext,B)
          <=> v85640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146966(VarNext)
      <=> v146967(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146967(VarNext)
      <=> ( v146969(VarNext)
          & v85625(VarNext) ) ) ) ).

tff(writeUnaryOperator_11122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146969(VarNext)
      <=> v85634(VarNext) ) ) ).

tff(addAssignment_82735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85164(VarCurr,B)
      <=> v85166(VarCurr,B) ) ) ).

tff(addAssignment_82734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85166(VarCurr,B)
      <=> v85616(VarCurr,B) ) ) ).

tff(addAssignment_82733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85168(VarCurr,B)
      <=> v85170(VarCurr,B) ) ) ).

tff(addAssignment_82732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85170(VarCurr,B)
      <=> v85607(VarCurr,B) ) ) ).

tff(addAssignment_82731,axiom,
    ! [VarCurr: state_type] :
      ( v146944(VarCurr,0)
    <=> v146953(VarCurr,0) ) ).

tff(addAssignment_82730,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,0)
    <=> v146961(VarCurr) ) ).

tff(addAssignment_82729,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,1)
    <=> v146960(VarCurr) ) ).

tff(addAssignment_82728,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,2)
    <=> v146959(VarCurr) ) ).

tff(addAssignment_82727,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,3)
    <=> v146958(VarCurr) ) ).

tff(addAssignment_82726,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,4)
    <=> v146957(VarCurr) ) ).

tff(addAssignment_82725,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,5)
    <=> v146956(VarCurr) ) ).

tff(addAssignment_82724,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,6)
    <=> v146955(VarCurr) ) ).

tff(addAssignment_82723,axiom,
    ! [VarCurr: state_type] :
      ( v146953(VarCurr,7)
    <=> v146954(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2283,axiom,
    ! [VarCurr: state_type] :
      ( v146961(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $false )
        & ( v85172(VarCurr,10)
        <=> $false )
        & ( v85172(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2282,axiom,
    ! [VarCurr: state_type] :
      ( v146960(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $false )
        & ( v85172(VarCurr,10)
        <=> $false )
        & ( v85172(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2281,axiom,
    ! [VarCurr: state_type] :
      ( v146959(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $false )
        & ( v85172(VarCurr,10)
        <=> $true )
        & ( v85172(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2280,axiom,
    ! [VarCurr: state_type] :
      ( v146958(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $false )
        & ( v85172(VarCurr,10)
        <=> $true )
        & ( v85172(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2279,axiom,
    ! [VarCurr: state_type] :
      ( v146957(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $true )
        & ( v85172(VarCurr,10)
        <=> $false )
        & ( v85172(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2278,axiom,
    ! [VarCurr: state_type] :
      ( v146956(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $true )
        & ( v85172(VarCurr,10)
        <=> $false )
        & ( v85172(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2277,axiom,
    ! [VarCurr: state_type] :
      ( v146955(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $true )
        & ( v85172(VarCurr,10)
        <=> $true )
        & ( v85172(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2276,axiom,
    ! [VarCurr: state_type] :
      ( v146954(VarCurr)
    <=> ( ( v85172(VarCurr,11)
        <=> $true )
        & ( v85172(VarCurr,10)
        <=> $true )
        & ( v85172(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85172(VarCurr,B)
      <=> v85174(VarCurr,B) ) ) ).

tff(addAssignment_82721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85174(VarCurr,B)
      <=> v85176(VarCurr,B) ) ) ).

tff(addAssignment_82720,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85176(VarNext,B)
      <=> v146946(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146946(VarNext,B)
            <=> v85176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2082,axiom,
    ! [VarNext: state_type] :
      ( v146947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146946(VarNext,B)
          <=> v85601(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146947(VarNext)
      <=> v146948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146948(VarNext)
      <=> ( v146950(VarNext)
          & v85586(VarNext) ) ) ) ).

tff(writeUnaryOperator_11121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146950(VarNext)
      <=> v85595(VarNext) ) ) ).

tff(addAssignment_82719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85186(VarCurr,B)
      <=> v85188(VarCurr,B) ) ) ).

tff(addAssignment_82718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85188(VarCurr,B)
      <=> v85577(VarCurr,B) ) ) ).

tff(addAssignment_82717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85190(VarCurr,B)
      <=> v85192(VarCurr,B) ) ) ).

tff(addAssignment_82716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85192(VarCurr,B)
      <=> v85568(VarCurr,B) ) ) ).

tff(addAssignment_82715,axiom,
    ! [VarCurr: state_type] :
      ( v146925(VarCurr,0)
    <=> v146934(VarCurr,0) ) ).

tff(addAssignment_82714,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,0)
    <=> v146942(VarCurr) ) ).

tff(addAssignment_82713,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,1)
    <=> v146941(VarCurr) ) ).

tff(addAssignment_82712,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,2)
    <=> v146940(VarCurr) ) ).

tff(addAssignment_82711,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,3)
    <=> v146939(VarCurr) ) ).

tff(addAssignment_82710,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,4)
    <=> v146938(VarCurr) ) ).

tff(addAssignment_82709,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,5)
    <=> v146937(VarCurr) ) ).

tff(addAssignment_82708,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,6)
    <=> v146936(VarCurr) ) ).

tff(addAssignment_82707,axiom,
    ! [VarCurr: state_type] :
      ( v146934(VarCurr,7)
    <=> v146935(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2275,axiom,
    ! [VarCurr: state_type] :
      ( v146942(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $false )
        & ( v85194(VarCurr,10)
        <=> $false )
        & ( v85194(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2274,axiom,
    ! [VarCurr: state_type] :
      ( v146941(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $false )
        & ( v85194(VarCurr,10)
        <=> $false )
        & ( v85194(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2273,axiom,
    ! [VarCurr: state_type] :
      ( v146940(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $false )
        & ( v85194(VarCurr,10)
        <=> $true )
        & ( v85194(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2272,axiom,
    ! [VarCurr: state_type] :
      ( v146939(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $false )
        & ( v85194(VarCurr,10)
        <=> $true )
        & ( v85194(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2271,axiom,
    ! [VarCurr: state_type] :
      ( v146938(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $true )
        & ( v85194(VarCurr,10)
        <=> $false )
        & ( v85194(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2270,axiom,
    ! [VarCurr: state_type] :
      ( v146937(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $true )
        & ( v85194(VarCurr,10)
        <=> $false )
        & ( v85194(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2269,axiom,
    ! [VarCurr: state_type] :
      ( v146936(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $true )
        & ( v85194(VarCurr,10)
        <=> $true )
        & ( v85194(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2268,axiom,
    ! [VarCurr: state_type] :
      ( v146935(VarCurr)
    <=> ( ( v85194(VarCurr,11)
        <=> $true )
        & ( v85194(VarCurr,10)
        <=> $true )
        & ( v85194(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85194(VarCurr,B)
      <=> v85196(VarCurr,B) ) ) ).

tff(addAssignment_82705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85196(VarCurr,B)
      <=> v85198(VarCurr,B) ) ) ).

tff(addAssignment_82704,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85198(VarNext,B)
      <=> v146927(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146928(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146927(VarNext,B)
            <=> v85198(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2081,axiom,
    ! [VarNext: state_type] :
      ( v146928(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146927(VarNext,B)
          <=> v85562(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146928(VarNext)
      <=> v146929(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146929(VarNext)
      <=> ( v146931(VarNext)
          & v85547(VarNext) ) ) ) ).

tff(writeUnaryOperator_11120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146931(VarNext)
      <=> v85556(VarNext) ) ) ).

tff(addAssignment_82703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85208(VarCurr,B)
      <=> v85210(VarCurr,B) ) ) ).

tff(addAssignment_82702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85210(VarCurr,B)
      <=> v85538(VarCurr,B) ) ) ).

tff(addAssignment_82701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85212(VarCurr,B)
      <=> v85214(VarCurr,B) ) ) ).

tff(addAssignment_82700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85214(VarCurr,B)
      <=> v85529(VarCurr,B) ) ) ).

tff(addAssignment_82699,axiom,
    ! [VarCurr: state_type] :
      ( v146906(VarCurr,0)
    <=> v146915(VarCurr,0) ) ).

tff(addAssignment_82698,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,0)
    <=> v146923(VarCurr) ) ).

tff(addAssignment_82697,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,1)
    <=> v146922(VarCurr) ) ).

tff(addAssignment_82696,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,2)
    <=> v146921(VarCurr) ) ).

tff(addAssignment_82695,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,3)
    <=> v146920(VarCurr) ) ).

tff(addAssignment_82694,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,4)
    <=> v146919(VarCurr) ) ).

tff(addAssignment_82693,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,5)
    <=> v146918(VarCurr) ) ).

tff(addAssignment_82692,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,6)
    <=> v146917(VarCurr) ) ).

tff(addAssignment_82691,axiom,
    ! [VarCurr: state_type] :
      ( v146915(VarCurr,7)
    <=> v146916(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2267,axiom,
    ! [VarCurr: state_type] :
      ( v146923(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $false )
        & ( v85216(VarCurr,10)
        <=> $false )
        & ( v85216(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2266,axiom,
    ! [VarCurr: state_type] :
      ( v146922(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $false )
        & ( v85216(VarCurr,10)
        <=> $false )
        & ( v85216(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2265,axiom,
    ! [VarCurr: state_type] :
      ( v146921(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $false )
        & ( v85216(VarCurr,10)
        <=> $true )
        & ( v85216(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2264,axiom,
    ! [VarCurr: state_type] :
      ( v146920(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $false )
        & ( v85216(VarCurr,10)
        <=> $true )
        & ( v85216(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2263,axiom,
    ! [VarCurr: state_type] :
      ( v146919(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $true )
        & ( v85216(VarCurr,10)
        <=> $false )
        & ( v85216(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2262,axiom,
    ! [VarCurr: state_type] :
      ( v146918(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $true )
        & ( v85216(VarCurr,10)
        <=> $false )
        & ( v85216(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2261,axiom,
    ! [VarCurr: state_type] :
      ( v146917(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $true )
        & ( v85216(VarCurr,10)
        <=> $true )
        & ( v85216(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2260,axiom,
    ! [VarCurr: state_type] :
      ( v146916(VarCurr)
    <=> ( ( v85216(VarCurr,11)
        <=> $true )
        & ( v85216(VarCurr,10)
        <=> $true )
        & ( v85216(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85216(VarCurr,B)
      <=> v85218(VarCurr,B) ) ) ).

tff(addAssignment_82689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85218(VarCurr,B)
      <=> v85220(VarCurr,B) ) ) ).

tff(addAssignment_82688,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85220(VarNext,B)
      <=> v146908(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146909(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146908(VarNext,B)
            <=> v85220(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2080,axiom,
    ! [VarNext: state_type] :
      ( v146909(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146908(VarNext,B)
          <=> v85523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146909(VarNext)
      <=> v146910(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146910(VarNext)
      <=> ( v146912(VarNext)
          & v85508(VarNext) ) ) ) ).

tff(writeUnaryOperator_11119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146912(VarNext)
      <=> v85517(VarNext) ) ) ).

tff(addAssignment_82687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85230(VarCurr,B)
      <=> v85232(VarCurr,B) ) ) ).

tff(addAssignment_82686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85232(VarCurr,B)
      <=> v85499(VarCurr,B) ) ) ).

tff(addAssignment_82685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85234(VarCurr,B)
      <=> v85236(VarCurr,B) ) ) ).

tff(addAssignment_82684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85236(VarCurr,B)
      <=> v85490(VarCurr,B) ) ) ).

tff(addAssignment_82683,axiom,
    ! [VarCurr: state_type] :
      ( v146887(VarCurr,0)
    <=> v146896(VarCurr,0) ) ).

tff(addAssignment_82682,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,0)
    <=> v146904(VarCurr) ) ).

tff(addAssignment_82681,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,1)
    <=> v146903(VarCurr) ) ).

tff(addAssignment_82680,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,2)
    <=> v146902(VarCurr) ) ).

tff(addAssignment_82679,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,3)
    <=> v146901(VarCurr) ) ).

tff(addAssignment_82678,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,4)
    <=> v146900(VarCurr) ) ).

tff(addAssignment_82677,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,5)
    <=> v146899(VarCurr) ) ).

tff(addAssignment_82676,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,6)
    <=> v146898(VarCurr) ) ).

tff(addAssignment_82675,axiom,
    ! [VarCurr: state_type] :
      ( v146896(VarCurr,7)
    <=> v146897(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2259,axiom,
    ! [VarCurr: state_type] :
      ( v146904(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $false )
        & ( v85238(VarCurr,10)
        <=> $false )
        & ( v85238(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2258,axiom,
    ! [VarCurr: state_type] :
      ( v146903(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $false )
        & ( v85238(VarCurr,10)
        <=> $false )
        & ( v85238(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2257,axiom,
    ! [VarCurr: state_type] :
      ( v146902(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $false )
        & ( v85238(VarCurr,10)
        <=> $true )
        & ( v85238(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2256,axiom,
    ! [VarCurr: state_type] :
      ( v146901(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $false )
        & ( v85238(VarCurr,10)
        <=> $true )
        & ( v85238(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2255,axiom,
    ! [VarCurr: state_type] :
      ( v146900(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $true )
        & ( v85238(VarCurr,10)
        <=> $false )
        & ( v85238(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2254,axiom,
    ! [VarCurr: state_type] :
      ( v146899(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $true )
        & ( v85238(VarCurr,10)
        <=> $false )
        & ( v85238(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2253,axiom,
    ! [VarCurr: state_type] :
      ( v146898(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $true )
        & ( v85238(VarCurr,10)
        <=> $true )
        & ( v85238(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2252,axiom,
    ! [VarCurr: state_type] :
      ( v146897(VarCurr)
    <=> ( ( v85238(VarCurr,11)
        <=> $true )
        & ( v85238(VarCurr,10)
        <=> $true )
        & ( v85238(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85238(VarCurr,B)
      <=> v85240(VarCurr,B) ) ) ).

tff(addAssignment_82673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85240(VarCurr,B)
      <=> v85242(VarCurr,B) ) ) ).

tff(addAssignment_82672,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85242(VarNext,B)
      <=> v146889(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146890(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146889(VarNext,B)
            <=> v85242(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2079,axiom,
    ! [VarNext: state_type] :
      ( v146890(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146889(VarNext,B)
          <=> v85484(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146890(VarNext)
      <=> v146891(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146891(VarNext)
      <=> ( v146893(VarNext)
          & v85469(VarNext) ) ) ) ).

tff(writeUnaryOperator_11118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146893(VarNext)
      <=> v85478(VarNext) ) ) ).

tff(addAssignment_82671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85252(VarCurr,B)
      <=> v85254(VarCurr,B) ) ) ).

tff(addAssignment_82670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85254(VarCurr,B)
      <=> v85460(VarCurr,B) ) ) ).

tff(addAssignment_82669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85256(VarCurr,B)
      <=> v85258(VarCurr,B) ) ) ).

tff(addAssignment_82668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85258(VarCurr,B)
      <=> v85451(VarCurr,B) ) ) ).

tff(addAssignment_82667,axiom,
    ! [VarCurr: state_type] :
      ( v146868(VarCurr,0)
    <=> v146877(VarCurr,0) ) ).

tff(addAssignment_82666,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,0)
    <=> v146885(VarCurr) ) ).

tff(addAssignment_82665,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,1)
    <=> v146884(VarCurr) ) ).

tff(addAssignment_82664,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,2)
    <=> v146883(VarCurr) ) ).

tff(addAssignment_82663,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,3)
    <=> v146882(VarCurr) ) ).

tff(addAssignment_82662,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,4)
    <=> v146881(VarCurr) ) ).

tff(addAssignment_82661,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,5)
    <=> v146880(VarCurr) ) ).

tff(addAssignment_82660,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,6)
    <=> v146879(VarCurr) ) ).

tff(addAssignment_82659,axiom,
    ! [VarCurr: state_type] :
      ( v146877(VarCurr,7)
    <=> v146878(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2251,axiom,
    ! [VarCurr: state_type] :
      ( v146885(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $false )
        & ( v85260(VarCurr,10)
        <=> $false )
        & ( v85260(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2250,axiom,
    ! [VarCurr: state_type] :
      ( v146884(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $false )
        & ( v85260(VarCurr,10)
        <=> $false )
        & ( v85260(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2249,axiom,
    ! [VarCurr: state_type] :
      ( v146883(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $false )
        & ( v85260(VarCurr,10)
        <=> $true )
        & ( v85260(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2248,axiom,
    ! [VarCurr: state_type] :
      ( v146882(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $false )
        & ( v85260(VarCurr,10)
        <=> $true )
        & ( v85260(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2247,axiom,
    ! [VarCurr: state_type] :
      ( v146881(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $true )
        & ( v85260(VarCurr,10)
        <=> $false )
        & ( v85260(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2246,axiom,
    ! [VarCurr: state_type] :
      ( v146880(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $true )
        & ( v85260(VarCurr,10)
        <=> $false )
        & ( v85260(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2245,axiom,
    ! [VarCurr: state_type] :
      ( v146879(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $true )
        & ( v85260(VarCurr,10)
        <=> $true )
        & ( v85260(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2244,axiom,
    ! [VarCurr: state_type] :
      ( v146878(VarCurr)
    <=> ( ( v85260(VarCurr,11)
        <=> $true )
        & ( v85260(VarCurr,10)
        <=> $true )
        & ( v85260(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85260(VarCurr,B)
      <=> v85262(VarCurr,B) ) ) ).

tff(addAssignment_82657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85262(VarCurr,B)
      <=> v85264(VarCurr,B) ) ) ).

tff(addAssignment_82656,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85264(VarNext,B)
      <=> v146870(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146871(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146870(VarNext,B)
            <=> v85264(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2078,axiom,
    ! [VarNext: state_type] :
      ( v146871(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146870(VarNext,B)
          <=> v85445(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146871(VarNext)
      <=> v146872(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146872(VarNext)
      <=> ( v146874(VarNext)
          & v85430(VarNext) ) ) ) ).

tff(writeUnaryOperator_11117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146874(VarNext)
      <=> v85439(VarNext) ) ) ).

tff(addAssignment_82655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85274(VarCurr,B)
      <=> v85276(VarCurr,B) ) ) ).

tff(addAssignment_82654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85276(VarCurr,B)
      <=> v85421(VarCurr,B) ) ) ).

tff(addAssignment_82653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85278(VarCurr,B)
      <=> v85280(VarCurr,B) ) ) ).

tff(addAssignment_82652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85280(VarCurr,B)
      <=> v85412(VarCurr,B) ) ) ).

tff(addAssignment_82651,axiom,
    ! [VarCurr: state_type] :
      ( v146838(VarCurr,0)
    <=> v146858(VarCurr,0) ) ).

tff(addAssignment_82650,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,0)
    <=> v146866(VarCurr) ) ).

tff(addAssignment_82649,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,1)
    <=> v146865(VarCurr) ) ).

tff(addAssignment_82648,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,2)
    <=> v146864(VarCurr) ) ).

tff(addAssignment_82647,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,3)
    <=> v146863(VarCurr) ) ).

tff(addAssignment_82646,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,4)
    <=> v146862(VarCurr) ) ).

tff(addAssignment_82645,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,5)
    <=> v146861(VarCurr) ) ).

tff(addAssignment_82644,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,6)
    <=> v146860(VarCurr) ) ).

tff(addAssignment_82643,axiom,
    ! [VarCurr: state_type] :
      ( v146858(VarCurr,7)
    <=> v146859(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2243,axiom,
    ! [VarCurr: state_type] :
      ( v146866(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $false )
        & ( v85282(VarCurr,10)
        <=> $false )
        & ( v85282(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2242,axiom,
    ! [VarCurr: state_type] :
      ( v146865(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $false )
        & ( v85282(VarCurr,10)
        <=> $false )
        & ( v85282(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2241,axiom,
    ! [VarCurr: state_type] :
      ( v146864(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $false )
        & ( v85282(VarCurr,10)
        <=> $true )
        & ( v85282(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2240,axiom,
    ! [VarCurr: state_type] :
      ( v146863(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $false )
        & ( v85282(VarCurr,10)
        <=> $true )
        & ( v85282(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2239,axiom,
    ! [VarCurr: state_type] :
      ( v146862(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $true )
        & ( v85282(VarCurr,10)
        <=> $false )
        & ( v85282(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2238,axiom,
    ! [VarCurr: state_type] :
      ( v146861(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $true )
        & ( v85282(VarCurr,10)
        <=> $false )
        & ( v85282(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2237,axiom,
    ! [VarCurr: state_type] :
      ( v146860(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $true )
        & ( v85282(VarCurr,10)
        <=> $true )
        & ( v85282(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2236,axiom,
    ! [VarCurr: state_type] :
      ( v146859(VarCurr)
    <=> ( ( v85282(VarCurr,11)
        <=> $true )
        & ( v85282(VarCurr,10)
        <=> $true )
        & ( v85282(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_82642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85282(VarCurr,B)
      <=> v85284(VarCurr,B) ) ) ).

tff(addAssignment_82641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85284(VarCurr,B)
      <=> v85286(VarCurr,B) ) ) ).

tff(addAssignment_82640,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85286(VarNext,B)
      <=> v146851(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146852(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v146851(VarNext,B)
            <=> v85286(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2077,axiom,
    ! [VarNext: state_type] :
      ( v146852(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v146851(VarNext,B)
          <=> v85406(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146852(VarNext)
      <=> v146853(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146853(VarNext)
      <=> ( v146855(VarNext)
          & v85391(VarNext) ) ) ) ).

tff(writeUnaryOperator_11116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146855(VarNext)
      <=> v85400(VarNext) ) ) ).

tff(addAssignment_82639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85296(VarCurr,B)
      <=> v85298(VarCurr,B) ) ) ).

tff(addAssignment_82638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85298(VarCurr,B)
      <=> v85382(VarCurr,B) ) ) ).

tff(addAssignment_82637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85300(VarCurr,B)
      <=> v85302(VarCurr,B) ) ) ).

tff(addAssignment_82636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85302(VarCurr,B)
      <=> v85304(VarCurr,B) ) ) ).

tff(addAssignment_82635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v85304(VarCurr,B)
      <=> v85371(VarCurr,B) ) ) ).

tff(addAssignment_82634,axiom,
    ! [VarCurr: state_type] :
      ( v85372(VarCurr,0)
    <=> v146847(VarCurr) ) ).

tff(addAssignment_82633,axiom,
    ! [VarCurr: state_type] :
      ( v85372(VarCurr,1)
    <=> v146844(VarCurr) ) ).

tff(addAssignment_82632,axiom,
    ! [VarCurr: state_type] :
      ( v85372(VarCurr,2)
    <=> v146841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19481,axiom,
    ! [VarCurr: state_type] :
      ( v146847(VarCurr)
    <=> ( v146848(VarCurr)
        | v141260(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19480,axiom,
    ! [VarCurr: state_type] :
      ( v146848(VarCurr)
    <=> ( v146849(VarCurr)
        | v141232(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19479,axiom,
    ! [VarCurr: state_type] :
      ( v146849(VarCurr)
    <=> ( v141177(VarCurr)
        | v141204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19478,axiom,
    ! [VarCurr: state_type] :
      ( v146844(VarCurr)
    <=> ( v146845(VarCurr)
        | v141260(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19477,axiom,
    ! [VarCurr: state_type] :
      ( v146845(VarCurr)
    <=> ( v146846(VarCurr)
        | v141246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19476,axiom,
    ! [VarCurr: state_type] :
      ( v146846(VarCurr)
    <=> ( v141190(VarCurr)
        | v141204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19475,axiom,
    ! [VarCurr: state_type] :
      ( v146841(VarCurr)
    <=> ( v146842(VarCurr)
        | v141260(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19474,axiom,
    ! [VarCurr: state_type] :
      ( v146842(VarCurr)
    <=> ( v146843(VarCurr)
        | v141246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19473,axiom,
    ! [VarCurr: state_type] :
      ( v146843(VarCurr)
    <=> ( v141218(VarCurr)
        | v141232(VarCurr) ) ) ).

tff(addAssignment_82631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146599(VarCurr,B)
      <=> v146601(VarCurr,B) ) ) ).

tff(addAssignment_82630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146601(VarCurr,B)
      <=> v146808(VarCurr,B) ) ) ).

tff(addAssignment_82629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v146808(VarCurr,B)
      <=> v146812(VarCurr,B) ) ) ).

tff(addAssignment_82628,axiom,
    ! [VarCurr: state_type] :
      ( ( v146808(VarCurr,25)
      <=> v146811(VarCurr,14) )
      & ( v146808(VarCurr,24)
      <=> v146811(VarCurr,13) )
      & ( v146808(VarCurr,23)
      <=> v146811(VarCurr,12) )
      & ( v146808(VarCurr,22)
      <=> v146811(VarCurr,11) )
      & ( v146808(VarCurr,21)
      <=> v146811(VarCurr,10) )
      & ( v146808(VarCurr,20)
      <=> v146811(VarCurr,9) )
      & ( v146808(VarCurr,19)
      <=> v146811(VarCurr,8) )
      & ( v146808(VarCurr,18)
      <=> v146811(VarCurr,7) )
      & ( v146808(VarCurr,17)
      <=> v146811(VarCurr,6) )
      & ( v146808(VarCurr,16)
      <=> v146811(VarCurr,5) )
      & ( v146808(VarCurr,15)
      <=> v146811(VarCurr,4) )
      & ( v146808(VarCurr,14)
      <=> v146811(VarCurr,3) )
      & ( v146808(VarCurr,13)
      <=> v146811(VarCurr,2) )
      & ( v146808(VarCurr,12)
      <=> v146811(VarCurr,1) )
      & ( v146808(VarCurr,11)
      <=> v146811(VarCurr,0) ) ) ).

tff(addAssignment_82627,axiom,
    ! [VarCurr: state_type] :
      ( ( v146808(VarCurr,28)
      <=> v146810(VarCurr,2) )
      & ( v146808(VarCurr,27)
      <=> v146810(VarCurr,1) )
      & ( v146808(VarCurr,26)
      <=> v146810(VarCurr,0) ) ) ).

tff(addAssignment_82626,axiom,
    ! [VarCurr: state_type] :
      ( ( v146808(VarCurr,32)
      <=> v146603(VarCurr,3) )
      & ( v146808(VarCurr,31)
      <=> v146603(VarCurr,2) )
      & ( v146808(VarCurr,30)
      <=> v146603(VarCurr,1) )
      & ( v146808(VarCurr,29)
      <=> v146603(VarCurr,0) ) ) ).

tff(addAssignment_82625,axiom,
    ! [VarCurr: state_type] :
      ( ( v146808(VarCurr,35)
      <=> v146809(VarCurr,2) )
      & ( v146808(VarCurr,34)
      <=> v146809(VarCurr,1) )
      & ( v146808(VarCurr,33)
      <=> v146809(VarCurr,0) ) ) ).

tff(addAssignment_82624,axiom,
    ! [VarCurr: state_type] :
      ( ( v146603(VarCurr,3)
      <=> v146605(VarCurr,32) )
      & ( v146603(VarCurr,2)
      <=> v146605(VarCurr,31) )
      & ( v146603(VarCurr,1)
      <=> v146605(VarCurr,30) )
      & ( v146603(VarCurr,0)
      <=> v146605(VarCurr,29) ) ) ).

tff(addAssignment_82623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146605(VarCurr,B)
      <=> v146607(VarCurr,B) ) ) ).

tff(addAssignment_82622,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146607(VarNext,B)
      <=> v146791(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146792(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v146791(VarNext,B)
            <=> v146607(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2076,axiom,
    ! [VarNext: state_type] :
      ( v146792(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146791(VarNext,B)
          <=> v146802(VarNext,B) ) ) ) ).

tff(addAssignment_82621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146802(VarNext,B)
          <=> v146800(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146800(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1622,axiom,
    ! [VarCurr: state_type] :
      ( v146803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146800(VarCurr,B)
          <=> v146637(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19472,axiom,
    ! [VarCurr: state_type] :
      ( v146803(VarCurr)
    <=> ( v146804(VarCurr)
        & v146805(VarCurr) ) ) ).

tff(writeUnaryOperator_11115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146805(VarCurr)
    <=> v146623(VarCurr) ) ).

tff(writeUnaryOperator_11114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146804(VarCurr)
    <=> v146609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146792(VarNext)
      <=> v146793(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146793(VarNext)
      <=> ( v146794(VarNext)
          & v146730(VarNext) ) ) ) ).

tff(writeUnaryOperator_11113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146794(VarNext)
      <=> v146796(VarNext) ) ) ).

tff(addAssignment_82620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146796(VarNext)
      <=> v146730(VarCurr) ) ) ).

tff(addAssignment_82619,axiom,
    ! [VarCurr: state_type] :
      ( v146730(VarCurr)
    <=> v146732(VarCurr) ) ).

tff(addAssignment_82618,axiom,
    ! [VarCurr: state_type] :
      ( v146732(VarCurr)
    <=> v146734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19469,axiom,
    ! [VarCurr: state_type] :
      ( v146734(VarCurr)
    <=> ( v146789(VarCurr)
        | v146785(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19468,axiom,
    ! [VarCurr: state_type] :
      ( v146789(VarCurr)
    <=> ( v146736(VarCurr)
        & v146740(VarCurr) ) ) ).

tff(addAssignment_82617,axiom,
    ! [VarCurr: state_type] :
      ( v146785(VarCurr)
    <=> v146787(VarCurr) ) ).

tff(addAssignment_82616,axiom,
    ! [VarCurr: state_type] :
      ( v146787(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146769(VarNext)
       => ( v146740(VarNext)
        <=> v146740(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2075,axiom,
    ! [VarNext: state_type] :
      ( v146769(VarNext)
     => ( v146740(VarNext)
      <=> v146779(VarNext) ) ) ).

tff(addAssignment_82615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146779(VarNext)
      <=> v146777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19467,axiom,
    ! [VarCurr: state_type] :
      ( v146777(VarCurr)
    <=> ( v146780(VarCurr)
        & v146781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19466,axiom,
    ! [VarCurr: state_type] :
      ( v146781(VarCurr)
    <=> ( v146746(VarCurr)
        | v146760(VarCurr) ) ) ).

tff(writeUnaryOperator_11112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146780(VarCurr)
    <=> v146742(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146769(VarNext)
      <=> v146770(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146770(VarNext)
      <=> ( v146772(VarNext)
          & v146774(VarNext) ) ) ) ).

tff(writeUnaryOperator_11111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146774(VarCurr)
    <=> v146736(VarCurr) ) ).

tff(addAssignment_82614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146772(VarNext)
      <=> v146736(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_275,axiom,
    ( v146740(constB0)
  <=> $true ) ).

tff(addAssignment_82613,axiom,
    ! [VarCurr: state_type] :
      ( v146760(VarCurr)
    <=> v146762(VarCurr) ) ).

tff(addAssignment_82612,axiom,
    ! [VarCurr: state_type] :
      ( v146762(VarCurr)
    <=> v146764(VarCurr) ) ).

tff(addAssignment_82611,axiom,
    ! [VarCurr: state_type] :
      ( v146764(VarCurr)
    <=> v146766(VarCurr) ) ).

tff(addAssignment_82610,axiom,
    ! [VarCurr: state_type] :
      ( v146766(VarCurr)
    <=> v130329(VarCurr) ) ).

tff(addAssignment_82609,axiom,
    ! [VarCurr: state_type] :
      ( v146746(VarCurr)
    <=> v146748(VarCurr) ) ).

tff(addAssignment_82608,axiom,
    ! [VarCurr: state_type] :
      ( v146748(VarCurr)
    <=> v146750(VarCurr) ) ).

tff(addAssignment_82607,axiom,
    ! [VarCurr: state_type] :
      ( v146750(VarCurr)
    <=> v146752(VarCurr) ) ).

tff(addAssignment_82606,axiom,
    ! [VarCurr: state_type] :
      ( v146752(VarCurr)
    <=> v146754(VarCurr) ) ).

tff(addAssignment_82605,axiom,
    ! [VarCurr: state_type] :
      ( v146754(VarCurr)
    <=> v146756(VarCurr) ) ).

tff(addAssignment_82604,axiom,
    ! [VarCurr: state_type] :
      ( v146756(VarCurr)
    <=> v146758(VarCurr) ) ).

tff(addAssignment_82603,axiom,
    ! [VarCurr: state_type] :
      ( v146758(VarCurr)
    <=> v5187(VarCurr) ) ).

tff(addAssignment_82602,axiom,
    ! [VarCurr: state_type] :
      ( v146742(VarCurr)
    <=> v146744(VarCurr) ) ).

tff(addAssignment_82601,axiom,
    ! [VarCurr: state_type] :
      ( v146744(VarCurr)
    <=> $false ) ).

tff(addAssignment_82600,axiom,
    ! [VarCurr: state_type] :
      ( v146736(VarCurr)
    <=> v146738(VarCurr) ) ).

tff(addAssignment_82599,axiom,
    ! [VarCurr: state_type] :
      ( v146738(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_82598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146637(VarCurr,B)
      <=> v146639(VarCurr,B) ) ) ).

tff(addAssignment_82597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146639(VarCurr,B)
      <=> v146724(VarCurr,B) ) ) ).

tff(addAssignment_82596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v146724(VarCurr,B)
      <=> v146728(VarCurr,B) ) ) ).

tff(addAssignment_82595,axiom,
    ! [VarCurr: state_type] :
      ( ( v146724(VarCurr,25)
      <=> v146727(VarCurr,14) )
      & ( v146724(VarCurr,24)
      <=> v146727(VarCurr,13) )
      & ( v146724(VarCurr,23)
      <=> v146727(VarCurr,12) )
      & ( v146724(VarCurr,22)
      <=> v146727(VarCurr,11) )
      & ( v146724(VarCurr,21)
      <=> v146727(VarCurr,10) )
      & ( v146724(VarCurr,20)
      <=> v146727(VarCurr,9) )
      & ( v146724(VarCurr,19)
      <=> v146727(VarCurr,8) )
      & ( v146724(VarCurr,18)
      <=> v146727(VarCurr,7) )
      & ( v146724(VarCurr,17)
      <=> v146727(VarCurr,6) )
      & ( v146724(VarCurr,16)
      <=> v146727(VarCurr,5) )
      & ( v146724(VarCurr,15)
      <=> v146727(VarCurr,4) )
      & ( v146724(VarCurr,14)
      <=> v146727(VarCurr,3) )
      & ( v146724(VarCurr,13)
      <=> v146727(VarCurr,2) )
      & ( v146724(VarCurr,12)
      <=> v146727(VarCurr,1) )
      & ( v146724(VarCurr,11)
      <=> v146727(VarCurr,0) ) ) ).

tff(addAssignment_82594,axiom,
    ! [VarCurr: state_type] :
      ( ( v146724(VarCurr,28)
      <=> v146726(VarCurr,2) )
      & ( v146724(VarCurr,27)
      <=> v146726(VarCurr,1) )
      & ( v146724(VarCurr,26)
      <=> v146726(VarCurr,0) ) ) ).

tff(addAssignment_82593,axiom,
    ! [VarCurr: state_type] :
      ( ( v146724(VarCurr,32)
      <=> v146641(VarCurr,3) )
      & ( v146724(VarCurr,31)
      <=> v146641(VarCurr,2) )
      & ( v146724(VarCurr,30)
      <=> v146641(VarCurr,1) )
      & ( v146724(VarCurr,29)
      <=> v146641(VarCurr,0) ) ) ).

tff(addAssignment_82592,axiom,
    ! [VarCurr: state_type] :
      ( ( v146724(VarCurr,35)
      <=> v146725(VarCurr,2) )
      & ( v146724(VarCurr,34)
      <=> v146725(VarCurr,1) )
      & ( v146724(VarCurr,33)
      <=> v146725(VarCurr,0) ) ) ).

tff(addAssignment_82591,axiom,
    ! [VarCurr: state_type] :
      ( ( v146641(VarCurr,3)
      <=> v146643(VarCurr,32) )
      & ( v146641(VarCurr,2)
      <=> v146643(VarCurr,31) )
      & ( v146641(VarCurr,1)
      <=> v146643(VarCurr,30) )
      & ( v146641(VarCurr,0)
      <=> v146643(VarCurr,29) ) ) ).

tff(addAssignment_82590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146643(VarCurr,B)
      <=> v146645(VarCurr,B) ) ) ).

tff(addAssignment_82589,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146645(VarNext,B)
      <=> v146707(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146708(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v146707(VarNext,B)
            <=> v146645(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2074,axiom,
    ! [VarNext: state_type] :
      ( v146708(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146707(VarNext,B)
          <=> v146718(VarNext,B) ) ) ) ).

tff(addAssignment_82588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146718(VarNext,B)
          <=> v146716(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146719(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146716(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1621,axiom,
    ! [VarCurr: state_type] :
      ( v146719(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v146716(VarCurr,B)
          <=> v146667(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19463,axiom,
    ! [VarCurr: state_type] :
      ( v146719(VarCurr)
    <=> ( v146720(VarCurr)
        & v146721(VarCurr) ) ) ).

tff(writeUnaryOperator_11110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146721(VarCurr)
    <=> v146657(VarCurr) ) ).

tff(writeUnaryOperator_11109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146720(VarCurr)
    <=> v146647(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146708(VarNext)
      <=> v146709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146709(VarNext)
      <=> ( v146710(VarNext)
          & v146683(VarNext) ) ) ) ).

tff(writeUnaryOperator_11108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146710(VarNext)
      <=> v146712(VarNext) ) ) ).

tff(addAssignment_82587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146712(VarNext)
      <=> v146683(VarCurr) ) ) ).

tff(addAssignment_82586,axiom,
    ! [VarCurr: state_type] :
      ( v146683(VarCurr)
    <=> v146685(VarCurr) ) ).

tff(addAssignment_82585,axiom,
    ! [VarCurr: state_type] :
      ( v146685(VarCurr)
    <=> v146687(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19460,axiom,
    ! [VarCurr: state_type] :
      ( v146687(VarCurr)
    <=> ( v146705(VarCurr)
        | v146697(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19459,axiom,
    ! [VarCurr: state_type] :
      ( v146705(VarCurr)
    <=> ( v146689(VarCurr)
        & v146695(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_274,axiom,
    ( v146695(constB0)
  <=> $true ) ).

tff(addAssignment_82584,axiom,
    ! [VarCurr: state_type] :
      ( v146697(VarCurr)
    <=> v146699(VarCurr) ) ).

tff(addAssignment_82583,axiom,
    ! [VarCurr: state_type] :
      ( v146699(VarCurr)
    <=> v146701(VarCurr) ) ).

tff(addAssignment_82582,axiom,
    ! [VarCurr: state_type] :
      ( v146701(VarCurr)
    <=> v146703(VarCurr) ) ).

tff(addAssignment_82581,axiom,
    ! [VarCurr: state_type] :
      ( v146703(VarCurr)
    <=> v130264(VarCurr) ) ).

tff(addAssignment_82580,axiom,
    ! [VarCurr: state_type] :
      ( v146689(VarCurr)
    <=> v146691(VarCurr) ) ).

tff(addAssignment_82579,axiom,
    ! [VarCurr: state_type] :
      ( v146691(VarCurr)
    <=> v146693(VarCurr) ) ).

tff(addAssignment_82578,axiom,
    ! [VarCurr: state_type] :
      ( v146693(VarCurr)
    <=> v130252(VarCurr) ) ).

tff(addAssignment_82577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146667(VarCurr,B)
      <=> v146669(VarCurr,B) ) ) ).

tff(addAssignment_82576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v146669(VarCurr,B)
      <=> v146677(VarCurr,B) ) ) ).

tff(addAssignment_82575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v146677(VarCurr,B)
      <=> v146681(VarCurr,B) ) ) ).

tff(addAssignment_82574,axiom,
    ! [VarCurr: state_type] :
      ( ( v146677(VarCurr,25)
      <=> v146680(VarCurr,14) )
      & ( v146677(VarCurr,24)
      <=> v146680(VarCurr,13) )
      & ( v146677(VarCurr,23)
      <=> v146680(VarCurr,12) )
      & ( v146677(VarCurr,22)
      <=> v146680(VarCurr,11) )
      & ( v146677(VarCurr,21)
      <=> v146680(VarCurr,10) )
      & ( v146677(VarCurr,20)
      <=> v146680(VarCurr,9) )
      & ( v146677(VarCurr,19)
      <=> v146680(VarCurr,8) )
      & ( v146677(VarCurr,18)
      <=> v146680(VarCurr,7) )
      & ( v146677(VarCurr,17)
      <=> v146680(VarCurr,6) )
      & ( v146677(VarCurr,16)
      <=> v146680(VarCurr,5) )
      & ( v146677(VarCurr,15)
      <=> v146680(VarCurr,4) )
      & ( v146677(VarCurr,14)
      <=> v146680(VarCurr,3) )
      & ( v146677(VarCurr,13)
      <=> v146680(VarCurr,2) )
      & ( v146677(VarCurr,12)
      <=> v146680(VarCurr,1) )
      & ( v146677(VarCurr,11)
      <=> v146680(VarCurr,0) ) ) ).

tff(addAssignment_82573,axiom,
    ! [VarCurr: state_type] :
      ( ( v146677(VarCurr,28)
      <=> v146679(VarCurr,2) )
      & ( v146677(VarCurr,27)
      <=> v146679(VarCurr,1) )
      & ( v146677(VarCurr,26)
      <=> v146679(VarCurr,0) ) ) ).

tff(addAssignment_82572,axiom,
    ! [VarCurr: state_type] :
      ( ( v146677(VarCurr,32)
      <=> v146671(VarCurr,3) )
      & ( v146677(VarCurr,31)
      <=> v146671(VarCurr,2) )
      & ( v146677(VarCurr,30)
      <=> v146671(VarCurr,1) )
      & ( v146677(VarCurr,29)
      <=> v146671(VarCurr,0) ) ) ).

tff(addAssignment_82571,axiom,
    ! [VarCurr: state_type] :
      ( ( v146677(VarCurr,35)
      <=> v146678(VarCurr,2) )
      & ( v146677(VarCurr,34)
      <=> v146678(VarCurr,1) )
      & ( v146677(VarCurr,33)
      <=> v146678(VarCurr,0) ) ) ).

tff(addAssignment_82570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v146671(VarCurr,B)
      <=> v146675(VarCurr,B) ) ) ).

tff(addAssignment_82569,axiom,
    ! [VarCurr: state_type] :
      ( v146671(VarCurr,3)
    <=> v146673(VarCurr) ) ).

tff(addAssignment_82568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v146675(VarCurr,B)
      <=> v85342(VarCurr,B) ) ) ).

tff(addAssignment_82567,axiom,
    ! [VarCurr: state_type] :
      ( v146673(VarCurr)
    <=> v85332(VarCurr) ) ).

tff(addAssignment_82566,axiom,
    ! [VarCurr: state_type] :
      ( v146657(VarCurr)
    <=> v146659(VarCurr) ) ).

tff(addAssignment_82565,axiom,
    ! [VarCurr: state_type] :
      ( v146659(VarCurr)
    <=> v146661(VarCurr) ) ).

tff(addAssignment_82564,axiom,
    ! [VarCurr: state_type] :
      ( v146661(VarCurr)
    <=> v146663(VarCurr) ) ).

tff(addAssignment_82563,axiom,
    ! [VarCurr: state_type] :
      ( v146663(VarCurr)
    <=> v146665(VarCurr) ) ).

tff(addAssignment_82562,axiom,
    ! [VarCurr: state_type] :
      ( v146665(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_82561,axiom,
    ! [VarCurr: state_type] :
      ( v146647(VarCurr)
    <=> v146649(VarCurr) ) ).

tff(addAssignment_82560,axiom,
    ! [VarCurr: state_type] :
      ( v146649(VarCurr)
    <=> v146651(VarCurr) ) ).

tff(addAssignment_82559,axiom,
    ! [VarCurr: state_type] :
      ( v146651(VarCurr)
    <=> v146653(VarCurr) ) ).

tff(addAssignment_82558,axiom,
    ! [VarCurr: state_type] :
      ( v146653(VarCurr)
    <=> v146655(VarCurr) ) ).

tff(addAssignment_82557,axiom,
    ! [VarCurr: state_type] :
      ( v146655(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_82556,axiom,
    ! [VarCurr: state_type] :
      ( v146623(VarCurr)
    <=> v146625(VarCurr) ) ).

tff(addAssignment_82555,axiom,
    ! [VarCurr: state_type] :
      ( v146625(VarCurr)
    <=> v146627(VarCurr) ) ).

tff(addAssignment_82554,axiom,
    ! [VarCurr: state_type] :
      ( v146627(VarCurr)
    <=> v146629(VarCurr) ) ).

tff(addAssignment_82553,axiom,
    ! [VarCurr: state_type] :
      ( v146629(VarCurr)
    <=> v146631(VarCurr) ) ).

tff(addAssignment_82552,axiom,
    ! [VarCurr: state_type] :
      ( v146631(VarCurr)
    <=> v146633(VarCurr) ) ).

tff(addAssignment_82551,axiom,
    ! [VarCurr: state_type] :
      ( v146633(VarCurr)
    <=> v146635(VarCurr) ) ).

tff(addAssignment_82550,axiom,
    ! [VarCurr: state_type] :
      ( v146635(VarCurr)
    <=> v130192(VarCurr) ) ).

tff(addAssignment_82549,axiom,
    ! [VarCurr: state_type] :
      ( v146609(VarCurr)
    <=> v146611(VarCurr) ) ).

tff(addAssignment_82548,axiom,
    ! [VarCurr: state_type] :
      ( v146611(VarCurr)
    <=> v146613(VarCurr) ) ).

tff(addAssignment_82547,axiom,
    ! [VarCurr: state_type] :
      ( v146613(VarCurr)
    <=> v146615(VarCurr) ) ).

tff(addAssignment_82546,axiom,
    ! [VarCurr: state_type] :
      ( v146615(VarCurr)
    <=> v146617(VarCurr) ) ).

tff(addAssignment_82545,axiom,
    ! [VarCurr: state_type] :
      ( v146617(VarCurr)
    <=> v146619(VarCurr) ) ).

tff(addAssignment_82544,axiom,
    ! [VarCurr: state_type] :
      ( v146619(VarCurr)
    <=> v146621(VarCurr) ) ).

tff(addAssignment_82543,axiom,
    ! [VarCurr: state_type] :
      ( v146621(VarCurr)
    <=> v130176(VarCurr) ) ).

tff(addAssignment_82542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2904(VarCurr,B)
      <=> v2906(VarCurr,B) ) ) ).

tff(addAssignment_82541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2906(VarCurr,B)
      <=> v2908(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2908(VarCurr,B)
      <=> ( v2910(VarCurr,B)
          & v146575(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_11107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146575(VarCurr,B)
      <=> ~ v146492(VarCurr,B) ) ) ).

tff(addAssignment_82540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146492(VarCurr,B)
      <=> v146494(VarCurr,B) ) ) ).

tff(addAssignment_82539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146494(VarCurr,B)
      <=> v146496(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v146496(VarNext,B)
            <=> v146496(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2073,axiom,
    ! [VarNext: state_type] :
      ( v146558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146496(VarNext,B)
          <=> v146568(VarNext,B) ) ) ) ).

tff(addAssignment_82538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146568(VarNext,B)
          <=> v146566(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146566(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1620,axiom,
    ! [VarCurr: state_type] :
      ( v146569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146566(VarCurr,B)
          <=> v146506(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19458,axiom,
    ! [VarCurr: state_type] :
      ( v146569(VarCurr)
    <=> ( v146570(VarCurr)
        & v146571(VarCurr) ) ) ).

tff(writeUnaryOperator_11106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146571(VarCurr)
    <=> v146502(VarCurr) ) ).

tff(writeUnaryOperator_11105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146570(VarCurr)
    <=> v146498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146558(VarNext)
      <=> v146559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146559(VarNext)
      <=> ( v146560(VarNext)
          & v146553(VarNext) ) ) ) ).

tff(writeUnaryOperator_11104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146560(VarNext)
      <=> v146562(VarNext) ) ) ).

tff(addAssignment_82537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146562(VarNext)
      <=> v146553(VarCurr) ) ) ).

tff(addAssignment_82536,axiom,
    ! [VarCurr: state_type] :
      ( v146553(VarCurr)
    <=> v146555(VarCurr) ) ).

tff(addAssignment_82535,axiom,
    ! [VarCurr: state_type] :
      ( v146555(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_82534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146506(VarCurr,B)
      <=> v146508(VarCurr,B) ) ) ).

tff(addAssignment_82533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146508(VarCurr,B)
      <=> v146510(VarCurr,B) ) ) ).

tff(addAssignment_82532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146510(VarCurr,B)
      <=> v146512(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,7)
     => ( v146512(VarCurr,7)
      <=> v146551(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_177,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,7)
     => ( v146512(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,7)
     => ( v146551(VarCurr)
      <=> v146492(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1619,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,7)
     => ( v146551(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,6)
     => ( v146512(VarCurr,6)
      <=> v146549(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_176,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,6)
     => ( v146512(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,6)
     => ( v146549(VarCurr)
      <=> v146492(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1618,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,6)
     => ( v146549(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,5)
     => ( v146512(VarCurr,5)
      <=> v146547(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_175,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,5)
     => ( v146512(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,5)
     => ( v146547(VarCurr)
      <=> v146492(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1617,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,5)
     => ( v146547(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,4)
     => ( v146512(VarCurr,4)
      <=> v146545(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_174,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,4)
     => ( v146512(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,4)
     => ( v146545(VarCurr)
      <=> v146492(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1616,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,4)
     => ( v146545(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,3)
     => ( v146512(VarCurr,3)
      <=> v146543(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_173,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,3)
     => ( v146512(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,3)
     => ( v146543(VarCurr)
      <=> v146492(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1615,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,3)
     => ( v146543(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,2)
     => ( v146512(VarCurr,2)
      <=> v146541(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_172,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,2)
     => ( v146512(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,2)
     => ( v146541(VarCurr)
      <=> v146492(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1614,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,2)
     => ( v146541(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,1)
     => ( v146512(VarCurr,1)
      <=> v146539(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_171,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,1)
     => ( v146512(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,1)
     => ( v146539(VarCurr)
      <=> v146492(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1613,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,1)
     => ( v146539(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146514(VarCurr,0)
     => ( v146512(VarCurr,0)
      <=> v146537(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1612,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,0)
     => ( v146512(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,0)
     => ( v146537(VarCurr)
      <=> v146492(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1611,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,0)
     => ( v146537(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_82531,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,7)
    <=> v146516(VarCurr,7) ) ).

tff(addAssignment_82530,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,7)
    <=> v146518(VarCurr,7) ) ).

tff(addAssignment_82529,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,7)
    <=> v146519(VarCurr,7) ) ).

tff(addAssignment_82528,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,6)
    <=> v146516(VarCurr,6) ) ).

tff(addAssignment_82527,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,6)
    <=> v146518(VarCurr,6) ) ).

tff(addAssignment_82526,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,6)
    <=> v146519(VarCurr,6) ) ).

tff(addAssignment_82525,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,5)
    <=> v146516(VarCurr,5) ) ).

tff(addAssignment_82524,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,5)
    <=> v146518(VarCurr,5) ) ).

tff(addAssignment_82523,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,5)
    <=> v146519(VarCurr,5) ) ).

tff(addAssignment_82522,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,4)
    <=> v146516(VarCurr,4) ) ).

tff(addAssignment_82521,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,4)
    <=> v146518(VarCurr,4) ) ).

tff(addAssignment_82520,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,4)
    <=> v146519(VarCurr,4) ) ).

tff(addAssignment_82519,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,3)
    <=> v146516(VarCurr,3) ) ).

tff(addAssignment_82518,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,3)
    <=> v146518(VarCurr,3) ) ).

tff(addAssignment_82517,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,3)
    <=> v146519(VarCurr,3) ) ).

tff(addAssignment_82516,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,2)
    <=> v146516(VarCurr,2) ) ).

tff(addAssignment_82515,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,2)
    <=> v146518(VarCurr,2) ) ).

tff(addAssignment_82514,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,2)
    <=> v146519(VarCurr,2) ) ).

tff(addAssignment_82513,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,1)
    <=> v146516(VarCurr,1) ) ).

tff(addAssignment_82512,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,1)
    <=> v146518(VarCurr,1) ) ).

tff(addAssignment_82511,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,1)
    <=> v146519(VarCurr,1) ) ).

tff(addAssignment_82510,axiom,
    ! [VarCurr: state_type] :
      ( v146514(VarCurr,0)
    <=> v146516(VarCurr,0) ) ).

tff(addAssignment_82509,axiom,
    ! [VarCurr: state_type] :
      ( v146516(VarCurr,0)
    <=> v146518(VarCurr,0) ) ).

tff(addAssignment_82508,axiom,
    ! [VarCurr: state_type] :
      ( v146518(VarCurr,0)
    <=> v146519(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146519(VarCurr,B)
      <=> ( v146520(VarCurr,B)
          | v146531(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146531(VarCurr,B)
      <=> ( v146532(VarCurr,B)
          & v130065(VarCurr,B) ) ) ) ).

tff(addAssignment_82507,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,0)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82506,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,1)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82505,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,2)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82504,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,3)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82503,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,4)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82502,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,5)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82501,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,6)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82500,axiom,
    ! [VarCurr: state_type] :
      ( v146532(VarCurr,7)
    <=> v146533(VarCurr) ) ).

tff(addAssignment_82499,axiom,
    ! [VarCurr: state_type] :
      ( v146533(VarCurr)
    <=> v146534(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6953,axiom,
    ! [VarCurr: state_type] :
      ( v146534(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v146535(VarCurr) ) ) ).

tff(writeUnaryOperator_11103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146535(VarCurr)
    <=> v100445(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146520(VarCurr,B)
      <=> ( v146521(VarCurr,B)
          | v146526(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146526(VarCurr,B)
      <=> ( v146527(VarCurr,B)
          & v130054(VarCurr,B) ) ) ) ).

tff(addAssignment_82498,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,0)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82497,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,1)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82496,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,2)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82495,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,3)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82494,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,4)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82493,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,5)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82492,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,6)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82491,axiom,
    ! [VarCurr: state_type] :
      ( v146527(VarCurr,7)
    <=> v146528(VarCurr) ) ).

tff(addAssignment_82490,axiom,
    ! [VarCurr: state_type] :
      ( v146528(VarCurr)
    <=> v146529(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6952,axiom,
    ! [VarCurr: state_type] :
      ( v146529(VarCurr)
    <=> ( v100203(VarCurr,1)
        & v146530(VarCurr) ) ) ).

tff(writeUnaryOperator_11102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146530(VarCurr)
    <=> v100229(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146521(VarCurr,B)
      <=> ( v146522(VarCurr,B)
          & v130054(VarCurr,B) ) ) ) ).

tff(addAssignment_82489,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,0)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82488,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,1)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82487,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,2)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82486,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,3)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82485,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,4)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82484,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,5)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82483,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,6)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82482,axiom,
    ! [VarCurr: state_type] :
      ( v146522(VarCurr,7)
    <=> v146523(VarCurr) ) ).

tff(addAssignment_82481,axiom,
    ! [VarCurr: state_type] :
      ( v146523(VarCurr)
    <=> v146524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19455,axiom,
    ! [VarCurr: state_type] :
      ( v146524(VarCurr)
    <=> ( v100203(VarCurr,0)
        & v146525(VarCurr) ) ) ).

tff(writeUnaryOperator_11101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146525(VarCurr)
    <=> v100229(VarCurr,15) ) ).

tff(addAssignment_82480,axiom,
    ! [VarCurr: state_type] :
      ( v146502(VarCurr)
    <=> v146504(VarCurr) ) ).

tff(addAssignment_82479,axiom,
    ! [VarCurr: state_type] :
      ( v146504(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_82478,axiom,
    ! [VarCurr: state_type] :
      ( v146498(VarCurr)
    <=> v146500(VarCurr) ) ).

tff(addAssignment_82477,axiom,
    ! [VarCurr: state_type] :
      ( v146500(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_82476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2910(VarCurr,B)
      <=> v2912(VarCurr,B) ) ) ).

tff(addAssignment_82475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2912(VarCurr,B)
      <=> v2914(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146475(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2914(VarNext,B)
            <=> v2914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2072,axiom,
    ! [VarNext: state_type] :
      ( v146475(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2914(VarNext,B)
          <=> v146485(VarNext,B) ) ) ) ).

tff(addAssignment_82474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146485(VarNext,B)
          <=> v146483(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146486(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146483(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1610,axiom,
    ! [VarCurr: state_type] :
      ( v146486(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146483(VarCurr,B)
          <=> v2932(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19454,axiom,
    ! [VarCurr: state_type] :
      ( v146486(VarCurr)
    <=> ( v146487(VarCurr)
        & v146488(VarCurr) ) ) ).

tff(writeUnaryOperator_11100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146488(VarCurr)
    <=> v2924(VarCurr) ) ).

tff(writeUnaryOperator_11099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146487(VarCurr)
    <=> v2916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146475(VarNext)
      <=> v146476(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146476(VarNext)
      <=> ( v146477(VarNext)
          & v146470(VarNext) ) ) ) ).

tff(writeUnaryOperator_11098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146477(VarNext)
      <=> v146479(VarNext) ) ) ).

tff(addAssignment_82473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146479(VarNext)
      <=> v146470(VarCurr) ) ) ).

tff(addAssignment_82472,axiom,
    ! [VarCurr: state_type] :
      ( v146470(VarCurr)
    <=> v146472(VarCurr) ) ).

tff(addAssignment_82471,axiom,
    ! [VarCurr: state_type] :
      ( v146472(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_82470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2932(VarCurr,B)
      <=> v2934(VarCurr,B) ) ) ).

tff(addAssignment_82469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2934(VarCurr,B)
      <=> v2936(VarCurr,B) ) ) ).

tff(addAssignment_82468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2936(VarCurr,B)
      <=> v2938(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146438(VarCurr)
     => ( v2938(VarCurr,7)
      <=> v146468(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_170,axiom,
    ! [VarCurr: state_type] :
      ( v146438(VarCurr)
     => ( v2938(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,7)
     => ( v146468(VarCurr)
      <=> v2910(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1609,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,7)
     => ( v146468(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146422(VarCurr)
     => ( v2938(VarCurr,6)
      <=> v146466(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_169,axiom,
    ! [VarCurr: state_type] :
      ( v146422(VarCurr)
     => ( v2938(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,6)
     => ( v146466(VarCurr)
      <=> v2910(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1608,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,6)
     => ( v146466(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146406(VarCurr)
     => ( v2938(VarCurr,5)
      <=> v146464(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_168,axiom,
    ! [VarCurr: state_type] :
      ( v146406(VarCurr)
     => ( v2938(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,5)
     => ( v146464(VarCurr)
      <=> v2910(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1607,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,5)
     => ( v146464(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146390(VarCurr)
     => ( v2938(VarCurr,4)
      <=> v146462(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_167,axiom,
    ! [VarCurr: state_type] :
      ( v146390(VarCurr)
     => ( v2938(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,4)
     => ( v146462(VarCurr)
      <=> v2910(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1606,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,4)
     => ( v146462(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146374(VarCurr)
     => ( v2938(VarCurr,3)
      <=> v146460(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_166,axiom,
    ! [VarCurr: state_type] :
      ( v146374(VarCurr)
     => ( v2938(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,3)
     => ( v146460(VarCurr)
      <=> v2910(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1605,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,3)
     => ( v146460(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146358(VarCurr)
     => ( v2938(VarCurr,2)
      <=> v146458(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_165,axiom,
    ! [VarCurr: state_type] :
      ( v146358(VarCurr)
     => ( v2938(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,2)
     => ( v146458(VarCurr)
      <=> v2910(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1604,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,2)
     => ( v146458(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146343(VarCurr)
     => ( v2938(VarCurr,1)
      <=> v146456(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_164,axiom,
    ! [VarCurr: state_type] :
      ( v146343(VarCurr)
     => ( v2938(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,1)
     => ( v146456(VarCurr)
      <=> v2910(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1603,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,1)
     => ( v146456(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2940(VarCurr)
     => ( v2938(VarCurr,0)
      <=> v146454(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1602,axiom,
    ! [VarCurr: state_type] :
      ( v2940(VarCurr)
     => ( v2938(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4085(VarCurr,0)
     => ( v146454(VarCurr)
      <=> v2910(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1601,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,0)
     => ( v146454(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_82467,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,7)
    <=> v4087(VarCurr,7) ) ).

tff(addAssignment_82466,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,7)
    <=> v4089(VarCurr,7) ) ).

tff(addAssignment_82465,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,7)
    <=> v4091(VarCurr,7) ) ).

tff(addAssignment_82464,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,7)
    <=> v146340(VarCurr,7) ) ).

tff(addAssignment_82463,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,7)
    <=> v146339(VarCurr,7) ) ).

tff(addAssignment_82462,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,7)
    <=> v146317(VarCurr,7) ) ).

tff(addAssignment_82461,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,7)
    <=> v89582(VarCurr,15) ) ).

tff(addAssignment_82460,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,15)
    <=> v89584(VarCurr,15) ) ).

tff(addAssignment_82459,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,15)
    <=> v146446(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_2071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146447(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146446(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2071,axiom,
    ! [VarNext: state_type] :
      ( v146447(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146446(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146447(VarNext)
      <=> v146448(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146448(VarNext)
      <=> ( v146450(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146450(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82458,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,15)
    <=> v89604(VarCurr,15) ) ).

tff(addAssignment_82457,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,15)
    <=> v97153(VarCurr,15) ) ).

tff(addAssignment_82456,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,15)
    <=> v89607(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19449,axiom,
    ! [VarCurr: state_type] :
      ( v146438(VarCurr)
    <=> ( v146440(VarCurr)
        & v146444(VarCurr) ) ) ).

tff(writeUnaryOperator_11096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146444(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19448,axiom,
    ! [VarCurr: state_type] :
      ( v146440(VarCurr)
    <=> ( v146441(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19447,axiom,
    ! [VarCurr: state_type] :
      ( v146441(VarCurr)
    <=> ( v146442(VarCurr)
        & v146443(VarCurr) ) ) ).

tff(addAssignment_82455,axiom,
    ! [VarCurr: state_type] :
      ( v146443(VarCurr)
    <=> v98670(VarCurr) ) ).

tff(writeUnaryOperator_11095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146442(VarCurr)
    <=> v2910(VarCurr,7) ) ).

tff(addAssignment_82454,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,6)
    <=> v4087(VarCurr,6) ) ).

tff(addAssignment_82453,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,6)
    <=> v4089(VarCurr,6) ) ).

tff(addAssignment_82452,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,6)
    <=> v4091(VarCurr,6) ) ).

tff(addAssignment_82451,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,6)
    <=> v146340(VarCurr,6) ) ).

tff(addAssignment_82450,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,6)
    <=> v146339(VarCurr,6) ) ).

tff(addAssignment_82449,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,6)
    <=> v146317(VarCurr,6) ) ).

tff(addAssignment_82448,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,6)
    <=> v89582(VarCurr,14) ) ).

tff(addAssignment_82447,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,14)
    <=> v89584(VarCurr,14) ) ).

tff(addAssignment_82446,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,14)
    <=> v146430(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_2070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146431(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146430(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2070,axiom,
    ! [VarNext: state_type] :
      ( v146431(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146430(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146431(VarNext)
      <=> v146432(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146432(VarNext)
      <=> ( v146434(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146434(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82445,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,14)
    <=> v89604(VarCurr,14) ) ).

tff(addAssignment_82444,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,14)
    <=> v97153(VarCurr,14) ) ).

tff(addAssignment_82443,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,14)
    <=> v89607(VarCurr,14) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19444,axiom,
    ! [VarCurr: state_type] :
      ( v146422(VarCurr)
    <=> ( v146424(VarCurr)
        & v146428(VarCurr) ) ) ).

tff(writeUnaryOperator_11093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146428(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19443,axiom,
    ! [VarCurr: state_type] :
      ( v146424(VarCurr)
    <=> ( v146425(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19442,axiom,
    ! [VarCurr: state_type] :
      ( v146425(VarCurr)
    <=> ( v146426(VarCurr)
        & v146427(VarCurr) ) ) ).

tff(addAssignment_82442,axiom,
    ! [VarCurr: state_type] :
      ( v146427(VarCurr)
    <=> v98671(VarCurr) ) ).

tff(writeUnaryOperator_11092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146426(VarCurr)
    <=> v2910(VarCurr,6) ) ).

tff(addAssignment_82441,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,5)
    <=> v4087(VarCurr,5) ) ).

tff(addAssignment_82440,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,5)
    <=> v4089(VarCurr,5) ) ).

tff(addAssignment_82439,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,5)
    <=> v4091(VarCurr,5) ) ).

tff(addAssignment_82438,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,5)
    <=> v146340(VarCurr,5) ) ).

tff(addAssignment_82437,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,5)
    <=> v146339(VarCurr,5) ) ).

tff(addAssignment_82436,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,5)
    <=> v146317(VarCurr,5) ) ).

tff(addAssignment_82435,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,5)
    <=> v89582(VarCurr,13) ) ).

tff(addAssignment_82434,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,13)
    <=> v89584(VarCurr,13) ) ).

tff(addAssignment_82433,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,13)
    <=> v146414(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_2069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146415(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146414(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2069,axiom,
    ! [VarNext: state_type] :
      ( v146415(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146414(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146415(VarNext)
      <=> v146416(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146416(VarNext)
      <=> ( v146418(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146418(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82432,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,13)
    <=> v89604(VarCurr,13) ) ).

tff(addAssignment_82431,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,13)
    <=> v97153(VarCurr,13) ) ).

tff(addAssignment_82430,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,13)
    <=> v89607(VarCurr,13) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19439,axiom,
    ! [VarCurr: state_type] :
      ( v146406(VarCurr)
    <=> ( v146408(VarCurr)
        & v146412(VarCurr) ) ) ).

tff(writeUnaryOperator_11090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146412(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19438,axiom,
    ! [VarCurr: state_type] :
      ( v146408(VarCurr)
    <=> ( v146409(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19437,axiom,
    ! [VarCurr: state_type] :
      ( v146409(VarCurr)
    <=> ( v146410(VarCurr)
        & v146411(VarCurr) ) ) ).

tff(addAssignment_82429,axiom,
    ! [VarCurr: state_type] :
      ( v146411(VarCurr)
    <=> v98672(VarCurr) ) ).

tff(writeUnaryOperator_11089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146410(VarCurr)
    <=> v2910(VarCurr,5) ) ).

tff(addAssignment_82428,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,4)
    <=> v4087(VarCurr,4) ) ).

tff(addAssignment_82427,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,4)
    <=> v4089(VarCurr,4) ) ).

tff(addAssignment_82426,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,4)
    <=> v4091(VarCurr,4) ) ).

tff(addAssignment_82425,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,4)
    <=> v146340(VarCurr,4) ) ).

tff(addAssignment_82424,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,4)
    <=> v146339(VarCurr,4) ) ).

tff(addAssignment_82423,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,4)
    <=> v146317(VarCurr,4) ) ).

tff(addAssignment_82422,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,4)
    <=> v89582(VarCurr,12) ) ).

tff(addAssignment_82421,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,12)
    <=> v89584(VarCurr,12) ) ).

tff(addAssignment_82420,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,12)
    <=> v146398(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_2068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146399(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146398(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2068,axiom,
    ! [VarNext: state_type] :
      ( v146399(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146398(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146399(VarNext)
      <=> v146400(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146400(VarNext)
      <=> ( v146402(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146402(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82419,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,12)
    <=> v89604(VarCurr,12) ) ).

tff(addAssignment_82418,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,12)
    <=> v97153(VarCurr,12) ) ).

tff(addAssignment_82417,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,12)
    <=> v89607(VarCurr,12) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19434,axiom,
    ! [VarCurr: state_type] :
      ( v146390(VarCurr)
    <=> ( v146392(VarCurr)
        & v146396(VarCurr) ) ) ).

tff(writeUnaryOperator_11087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146396(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19433,axiom,
    ! [VarCurr: state_type] :
      ( v146392(VarCurr)
    <=> ( v146393(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19432,axiom,
    ! [VarCurr: state_type] :
      ( v146393(VarCurr)
    <=> ( v146394(VarCurr)
        & v146395(VarCurr) ) ) ).

tff(addAssignment_82416,axiom,
    ! [VarCurr: state_type] :
      ( v146395(VarCurr)
    <=> v98673(VarCurr) ) ).

tff(writeUnaryOperator_11086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146394(VarCurr)
    <=> v2910(VarCurr,4) ) ).

tff(addAssignment_82415,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,3)
    <=> v4087(VarCurr,3) ) ).

tff(addAssignment_82414,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,3)
    <=> v4089(VarCurr,3) ) ).

tff(addAssignment_82413,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,3)
    <=> v4091(VarCurr,3) ) ).

tff(addAssignment_82412,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,3)
    <=> v146340(VarCurr,3) ) ).

tff(addAssignment_82411,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,3)
    <=> v146339(VarCurr,3) ) ).

tff(addAssignment_82410,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,3)
    <=> v146317(VarCurr,3) ) ).

tff(addAssignment_82409,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,3)
    <=> v89582(VarCurr,11) ) ).

tff(addAssignment_82408,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,11)
    <=> v89584(VarCurr,11) ) ).

tff(addAssignment_82407,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,11)
    <=> v146382(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_2067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146383(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146382(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2067,axiom,
    ! [VarNext: state_type] :
      ( v146383(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146382(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146383(VarNext)
      <=> v146384(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146384(VarNext)
      <=> ( v146386(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146386(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82406,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,11)
    <=> v89604(VarCurr,11) ) ).

tff(addAssignment_82405,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,11)
    <=> v97153(VarCurr,11) ) ).

tff(addAssignment_82404,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,11)
    <=> v89607(VarCurr,11) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19429,axiom,
    ! [VarCurr: state_type] :
      ( v146374(VarCurr)
    <=> ( v146376(VarCurr)
        & v146380(VarCurr) ) ) ).

tff(writeUnaryOperator_11084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146380(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19428,axiom,
    ! [VarCurr: state_type] :
      ( v146376(VarCurr)
    <=> ( v146377(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19427,axiom,
    ! [VarCurr: state_type] :
      ( v146377(VarCurr)
    <=> ( v146378(VarCurr)
        & v146379(VarCurr) ) ) ).

tff(addAssignment_82403,axiom,
    ! [VarCurr: state_type] :
      ( v146379(VarCurr)
    <=> v98674(VarCurr) ) ).

tff(writeUnaryOperator_11083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146378(VarCurr)
    <=> v2910(VarCurr,3) ) ).

tff(addAssignment_82402,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,2)
    <=> v4087(VarCurr,2) ) ).

tff(addAssignment_82401,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,2)
    <=> v4089(VarCurr,2) ) ).

tff(addAssignment_82400,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,2)
    <=> v4091(VarCurr,2) ) ).

tff(addAssignment_82399,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,2)
    <=> v146340(VarCurr,2) ) ).

tff(addAssignment_82398,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,2)
    <=> v146339(VarCurr,2) ) ).

tff(addAssignment_82397,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,2)
    <=> v146317(VarCurr,2) ) ).

tff(addAssignment_82396,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,2)
    <=> v89582(VarCurr,10) ) ).

tff(addAssignment_82395,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,10)
    <=> v89584(VarCurr,10) ) ).

tff(addAssignment_82394,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,10)
    <=> v146366(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_2066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146367(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146366(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2066,axiom,
    ! [VarNext: state_type] :
      ( v146367(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146366(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146367(VarNext)
      <=> v146368(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146368(VarNext)
      <=> ( v146370(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146370(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82393,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,10)
    <=> v89604(VarCurr,10) ) ).

tff(addAssignment_82392,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,10)
    <=> v97153(VarCurr,10) ) ).

tff(addAssignment_82391,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,10)
    <=> v89607(VarCurr,10) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19424,axiom,
    ! [VarCurr: state_type] :
      ( v146358(VarCurr)
    <=> ( v146360(VarCurr)
        & v146364(VarCurr) ) ) ).

tff(writeUnaryOperator_11081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146364(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19423,axiom,
    ! [VarCurr: state_type] :
      ( v146360(VarCurr)
    <=> ( v146361(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19422,axiom,
    ! [VarCurr: state_type] :
      ( v146361(VarCurr)
    <=> ( v146362(VarCurr)
        & v146363(VarCurr) ) ) ).

tff(addAssignment_82390,axiom,
    ! [VarCurr: state_type] :
      ( v146363(VarCurr)
    <=> v98675(VarCurr) ) ).

tff(writeUnaryOperator_11080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146362(VarCurr)
    <=> v2910(VarCurr,2) ) ).

tff(addAssignment_82389,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,1)
    <=> v4087(VarCurr,1) ) ).

tff(addAssignment_82388,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,1)
    <=> v4089(VarCurr,1) ) ).

tff(addAssignment_82387,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,1)
    <=> v4091(VarCurr,1) ) ).

tff(addAssignment_82386,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,1)
    <=> v146340(VarCurr,1) ) ).

tff(addAssignment_82385,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,1)
    <=> v146339(VarCurr,1) ) ).

tff(addAssignment_82384,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,1)
    <=> v146317(VarCurr,1) ) ).

tff(addAssignment_82383,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,1)
    <=> v89582(VarCurr,9) ) ).

tff(addAssignment_82382,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,9)
    <=> v89584(VarCurr,9) ) ).

tff(addAssignment_82381,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,9)
    <=> v146350(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_2065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146351(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146350(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2065,axiom,
    ! [VarNext: state_type] :
      ( v146351(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146350(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146351(VarNext)
      <=> v146352(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146352(VarNext)
      <=> ( v146354(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146354(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82380,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,9)
    <=> v89604(VarCurr,9) ) ).

tff(addAssignment_82379,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,9)
    <=> v97153(VarCurr,9) ) ).

tff(addAssignment_82378,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,9)
    <=> v89607(VarCurr,9) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19419,axiom,
    ! [VarCurr: state_type] :
      ( v146343(VarCurr)
    <=> ( v146345(VarCurr)
        & v146348(VarCurr) ) ) ).

tff(writeUnaryOperator_11078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146348(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19418,axiom,
    ! [VarCurr: state_type] :
      ( v146345(VarCurr)
    <=> ( v146346(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19417,axiom,
    ! [VarCurr: state_type] :
      ( v146346(VarCurr)
    <=> ( v146347(VarCurr)
        & v2910(VarCurr,0) ) ) ).

tff(writeUnaryOperator_11077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146347(VarCurr)
    <=> v2910(VarCurr,1) ) ).

tff(addAssignment_82377,axiom,
    ! [VarCurr: state_type] :
      ( v4085(VarCurr,0)
    <=> v4087(VarCurr,0) ) ).

tff(addAssignment_82376,axiom,
    ! [VarCurr: state_type] :
      ( v4087(VarCurr,0)
    <=> v4089(VarCurr,0) ) ).

tff(addAssignment_82375,axiom,
    ! [VarCurr: state_type] :
      ( v4089(VarCurr,0)
    <=> v4091(VarCurr,0) ) ).

tff(addAssignment_82374,axiom,
    ! [VarCurr: state_type] :
      ( v4091(VarCurr,0)
    <=> v146340(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146341(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146340(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1600,axiom,
    ! [VarCurr: state_type] :
      ( v146341(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v146340(VarCurr,B)
          <=> v89608(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19416,axiom,
    ! [VarCurr: state_type] :
      ( v146341(VarCurr)
    <=> ( v4093(VarCurr)
        | v89523(VarCurr) ) ) ).

tff(addAssignment_82373,axiom,
    ! [VarCurr: state_type] :
      ( v89608(VarCurr,0)
    <=> v146339(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146339(VarCurr,B)
      <=> ( v146306(VarCurr,B)
          | v146316(VarCurr,B) ) ) ) ).

tff(addAssignment_82372,axiom,
    ! [VarCurr: state_type] :
      ( v146316(VarCurr,0)
    <=> v146317(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146317(VarCurr,B)
      <=> ( v146318(VarCurr,B)
          | v146333(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146333(VarCurr,B)
      <=> ( v146334(VarCurr,B)
          & v129844(VarCurr,B) ) ) ) ).

tff(addAssignment_82371,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,0)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82370,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,1)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82369,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,2)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82368,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,3)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82367,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,4)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82366,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,5)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82365,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,6)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82364,axiom,
    ! [VarCurr: state_type] :
      ( v146334(VarCurr,7)
    <=> v146335(VarCurr) ) ).

tff(addAssignment_82363,axiom,
    ! [VarCurr: state_type] :
      ( v146335(VarCurr)
    <=> v146336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19415,axiom,
    ! [VarCurr: state_type] :
      ( v146336(VarCurr)
    <=> ( v146337(VarCurr)
        & v100734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19414,axiom,
    ! [VarCurr: state_type] :
      ( v146337(VarCurr)
    <=> ( v146338(VarCurr)
        & v4093(VarCurr) ) ) ).

tff(writeUnaryOperator_11076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146338(VarCurr)
    <=> v97411(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146318(VarCurr,B)
      <=> ( v146319(VarCurr,B)
          | v146326(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146326(VarCurr,B)
      <=> ( v146327(VarCurr,B)
          & v129833(VarCurr,B) ) ) ) ).

tff(addAssignment_82362,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,0)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82361,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,1)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82360,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,2)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82359,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,3)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82358,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,4)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82357,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,5)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82356,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,6)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82355,axiom,
    ! [VarCurr: state_type] :
      ( v146327(VarCurr,7)
    <=> v146328(VarCurr) ) ).

tff(addAssignment_82354,axiom,
    ! [VarCurr: state_type] :
      ( v146328(VarCurr)
    <=> v146329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19413,axiom,
    ! [VarCurr: state_type] :
      ( v146329(VarCurr)
    <=> ( v146330(VarCurr)
        & v146332(VarCurr) ) ) ).

tff(writeUnaryOperator_11075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146332(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6951,axiom,
    ! [VarCurr: state_type] :
      ( v146330(VarCurr)
    <=> ( v146331(VarCurr)
        & v129767(VarCurr,1) ) ) ).

tff(writeUnaryOperator_11074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146331(VarCurr)
    <=> v129784(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v146319(VarCurr,B)
      <=> ( v146320(VarCurr,B)
          & v129773(VarCurr,B) ) ) ) ).

tff(addAssignment_82353,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,0)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82352,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,1)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82351,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,2)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82350,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,3)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82349,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,4)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82348,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,5)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82347,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,6)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82346,axiom,
    ! [VarCurr: state_type] :
      ( v146320(VarCurr,7)
    <=> v146321(VarCurr) ) ).

tff(addAssignment_82345,axiom,
    ! [VarCurr: state_type] :
      ( v146321(VarCurr)
    <=> v146322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19412,axiom,
    ! [VarCurr: state_type] :
      ( v146322(VarCurr)
    <=> ( v146323(VarCurr)
        & v146325(VarCurr) ) ) ).

tff(writeUnaryOperator_11073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146325(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19411,axiom,
    ! [VarCurr: state_type] :
      ( v146323(VarCurr)
    <=> ( v146324(VarCurr)
        & v129767(VarCurr,0) ) ) ).

tff(writeUnaryOperator_11072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146324(VarCurr)
    <=> v97184(VarCurr,15) ) ).

tff(addAssignment_82344,axiom,
    ! [VarCurr: state_type] :
      ( v146306(VarCurr,0)
    <=> v89582(VarCurr,8) ) ).

tff(addAssignment_82343,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,8)
    <=> v89584(VarCurr,8) ) ).

tff(addAssignment_82342,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,8)
    <=> v146308(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_2064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146309(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v146308(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2064,axiom,
    ! [VarNext: state_type] :
      ( v146309(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v146308(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146309(VarNext)
      <=> v146310(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v146310(VarNext)
      <=> ( v146312(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_11071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v146312(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_82341,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,8)
    <=> v89604(VarCurr,8) ) ).

tff(addAssignment_82340,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,8)
    <=> v97153(VarCurr,8) ) ).

tff(addAssignment_82339,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,8)
    <=> v89607(VarCurr,8) ) ).

tff(addAssignment_82338,axiom,
    ! [VarCurr: state_type] :
      ( v4093(VarCurr)
    <=> v4095(VarCurr) ) ).

tff(addAssignment_82337,axiom,
    ! [VarCurr: state_type] :
      ( v4095(VarCurr)
    <=> v4097(VarCurr) ) ).

tff(addAssignment_82336,axiom,
    ! [VarCurr: state_type] :
      ( v4097(VarCurr)
    <=> v4099(VarCurr) ) ).

tff(addAssignment_82335,axiom,
    ! [VarCurr: state_type] :
      ( v4099(VarCurr)
    <=> v4101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19408,axiom,
    ! [VarCurr: state_type] :
      ( v4101(VarCurr)
    <=> ( v146297(VarCurr)
        & v89674(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19407,axiom,
    ! [VarCurr: state_type] :
      ( v146297(VarCurr)
    <=> ( v146298(VarCurr)
        | v146300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19406,axiom,
    ! [VarCurr: state_type] :
      ( v146300(VarCurr)
    <=> ( v146301(VarCurr)
        & v146303(VarCurr) ) ) ).

tff(writeUnaryOperator_11070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146303(VarCurr)
    <=> v94333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19405,axiom,
    ! [VarCurr: state_type] :
      ( v146301(VarCurr)
    <=> ( v4513(VarCurr)
        & v146302(VarCurr) ) ) ).

tff(writeUnaryOperator_11069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146302(VarCurr)
    <=> v89720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19404,axiom,
    ! [VarCurr: state_type] :
      ( v146298(VarCurr)
    <=> ( v4103(VarCurr)
        & v146299(VarCurr) ) ) ).

tff(writeUnaryOperator_11068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146299(VarCurr)
    <=> v4513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19403,axiom,
    ! [VarCurr: state_type] :
      ( v4103(VarCurr)
    <=> ( v146265(VarCurr)
        & v146295(VarCurr) ) ) ).

tff(writeUnaryOperator_11067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146295(VarCurr)
    <=> v2040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19402,axiom,
    ! [VarCurr: state_type] :
      ( v146265(VarCurr)
    <=> ( v146266(VarCurr)
        & v146294(VarCurr) ) ) ).

tff(writeUnaryOperator_11066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v146294(VarCurr)
    <=> v2044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19401,axiom,
    ! [VarCurr: state_type] :
      ( v146266(VarCurr)
    <=> ( v146267(VarCurr)
        & v146280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19400,axiom,
    ! [VarCurr: state_type] :
      ( v146280(VarCurr)
    <=> ( v146281(VarCurr)
        | v10059(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6950,axiom,
    ! [VarCurr: state_type] :
      ( v146281(VarCurr)
    <=> ( v146283(VarCurr)
        & v145999(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6949,axiom,
    ! [VarCurr: state_type] :
      ( v146283(VarCurr)
    <=> ( v146284(VarCurr)
        & v145999(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6948,axiom,
    ! [VarCurr: state_type] :
      ( v146284(VarCurr)
    <=> ( v146285(VarCurr)
        & v145999(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6947,axiom,
    ! [VarCurr: state_type] :
      ( v146285(VarCurr)
    <=> ( v146286(VarCurr)
        & v145999(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6946,axiom,
    ! [VarCurr: state_type] :
      ( v146286(VarCurr)
    <=> ( v146287(VarCurr)
        & v145999(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6945,axiom,
    ! [VarCurr: state_type] :
      ( v146287(VarCurr)
    <=> ( v146288(VarCurr)
        & v145999(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6944,axiom,
    ! [VarCurr: state_type] :
      ( v146288(VarCurr)
    <=> ( v146289(VarCurr)
        & v145999(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6943,axiom,
    ! [VarCurr: state_type] :
      ( v146289(VarCurr)
    <=> ( v146290(VarCurr)
        & v145999(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6942,axiom,
    ! [VarCurr: state_type] :
      ( v146290(VarCurr)
    <=> ( v146291(VarCurr)
        & v145999(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6941,axiom,
    ! [VarCurr: state_type] :
      ( v146291(VarCurr)
    <=> ( v146292(VarCurr)
        & v145999(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6940,axiom,
    ! [VarCurr: state_type] :
      ( v146292(VarCurr)
    <=> ( v146293(VarCurr)
        & v145999(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6939,axiom,
    ! [VarCurr: state_type] :
      ( v146293(VarCurr)
    <=> ( v145999(VarCurr,0)
        & v145999(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6938,axiom,
    ! [VarCurr: state_type] :
      ( v146267(VarCurr)
    <=> ( v146269(VarCurr)
        & v4105(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6937,axiom,
    ! [VarCurr: state_type] :
      ( v146269(VarCurr)
    <=> ( v146270(VarCurr)
        & v4105(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6936,axiom,
    ! [VarCurr: state_type] :
      ( v146270(VarCurr)
    <=> ( v146271(VarCurr)
        & v4105(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6935,axiom,
    ! [VarCurr: state_type] :
      ( v146271(VarCurr)
    <=> ( v146272(VarCurr)
        & v4105(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6934,axiom,
    ! [VarCurr: state_type] :
      ( v146272(VarCurr)
    <=> ( v146273(VarCurr)
        & v4105(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6933,axiom,
    ! [VarCurr: state_type] :
      ( v146273(VarCurr)
    <=> ( v146274(VarCurr)
        & v4105(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6932,axiom,
    ! [VarCurr: state_type] :
      ( v146274(VarCurr)
    <=> ( v146275(VarCurr)
        & v4105(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6931,axiom,
    ! [VarCurr: state_type] :
      ( v146275(VarCurr)
    <=> ( v146276(VarCurr)
        & v4105(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6930,axiom,
    ! [VarCurr: state_type] :
      ( v146276(VarCurr)
    <=> ( v146277(VarCurr)
        & v4105(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6929,axiom,
    ! [VarCurr: state_type] :
      ( v146277(VarCurr)
    <=> ( v146278(VarCurr)
        & v4105(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6928,axiom,
    ! [VarCurr: state_type] :
      ( v146278(VarCurr)
    <=> ( v146279(VarCurr)
        & v4105(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6927,axiom,
    ! [VarCurr: state_type] :
      ( v146279(VarCurr)
    <=> ( v4105(VarCurr,0)
        & v4105(VarCurr,1) ) ) ).

tff(addAssignment_82334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v145999(VarCurr,B)
      <=> v146001(VarCurr,B) ) ) ).

tff(addAssignment_82333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v146001(VarCurr,B)
      <=> v146003(VarCurr,B) ) ) ).

tff(addAssignment_82332,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,12)
    <=> v146245(VarCurr) ) ).

tff(addAssignment_82331,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,11)
    <=> v146225(VarCurr) ) ).

tff(addAssignment_82330,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,10)
    <=> v146205(VarCurr) ) ).

tff(addAssignment_82329,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,9)
    <=> v146185(VarCurr) ) ).

tff(addAssignment_82328,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,8)
    <=> v146165(VarCurr) ) ).

tff(addAssignment_82327,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,7)
    <=> v146145(VarCurr) ) ).

tff(addAssignment_82326,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,6)
    <=> v146125(VarCurr) ) ).

tff(addAssignment_82325,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,5)
    <=> v146105(VarCurr) ) ).

tff(addAssignment_82324,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,4)
    <=> v146085(VarCurr) ) ).

tff(addAssignment_82323,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,3)
    <=> v146065(VarCurr) ) ).

tff(addAssignment_82322,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,2)
    <=> v146045(VarCurr) ) ).

tff(addAssignment_82321,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,1)
    <=> v146025(VarCurr) ) ).

tff(addAssignment_82320,axiom,
    ! [VarCurr: state_type] :
      ( v146003(VarCurr,0)
    <=> v146005(VarCurr) ) ).

tff(addAssignment_82319,axiom,
    ! [VarCurr: state_type] :
      ( v146245(VarCurr)
    <=> v146247(VarCurr) ) ).

tff(addAssignment_82318,axiom,
    ! [VarCurr: state_type] :
      ( v146247(VarCurr)
    <=> v146249(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2235,axiom,
    ! [VarCurr: state_type] :
      ( v146249(VarCurr)
    <=> ( ( v146251(VarCurr,11)
        <=> v146255(VarCurr,11) )
        & ( v146251(VarCurr,10)
        <=> v146255(VarCurr,10) )
        & ( v146251(VarCurr,9)
        <=> v146255(VarCurr,9) )
        & ( v146251(VarCurr,8)
        <=> v146255(VarCurr,8) )
        & ( v146251(VarCurr,7)
        <=> v146255(VarCurr,7) )
        & ( v146251(VarCurr,6)
        <=> v146255(VarCurr,6) )
        & ( v146251(VarCurr,5)
        <=> v146255(VarCurr,5) )
        & ( v146251(VarCurr,4)
        <=> v146255(VarCurr,4) )
        & ( v146251(VarCurr,3)
        <=> v146255(VarCurr,3) )
        & ( v146251(VarCurr,2)
        <=> v146255(VarCurr,2) )
        & ( v146251(VarCurr,1)
        <=> v146255(VarCurr,1) )
        & ( v146251(VarCurr,0)
        <=> v146255(VarCurr,0) ) ) ) ).

tff(addAssignment_82317,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146255(VarCurr,B)
      <=> v146257(VarCurr,B) ) ) ).

tff(addAssignment_82316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146257(VarCurr,B)
      <=> v146261(VarCurr,B) ) ) ).

tff(addAssignment_82315,axiom,
    ! [VarCurr: state_type] :
      ( ( v146257(VarCurr,11)
      <=> v146259(VarCurr,5) )
      & ( v146257(VarCurr,10)
      <=> v146259(VarCurr,4) )
      & ( v146257(VarCurr,9)
      <=> v146259(VarCurr,3) )
      & ( v146257(VarCurr,8)
      <=> v146259(VarCurr,2) )
      & ( v146257(VarCurr,7)
      <=> v146259(VarCurr,1) )
      & ( v146257(VarCurr,6)
      <=> v146259(VarCurr,0) ) ) ).

tff(addAssignment_82314,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,0)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82313,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,1)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82312,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,2)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82311,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,3)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82310,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,4)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82309,axiom,
    ! [VarCurr: state_type] :
      ( v146261(VarCurr,5)
    <=> v146262(VarCurr) ) ).

tff(addAssignment_82308,axiom,
    ! [VarCurr: state_type] :
      ( v146262(VarCurr)
    <=> v96202(VarCurr,0) ) ).

tff(addAssignment_82307,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,0)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82306,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,1)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82305,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,2)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82304,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,3)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82303,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,4)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82302,axiom,
    ! [VarCurr: state_type] :
      ( v146259(VarCurr,5)
    <=> v146260(VarCurr) ) ).

tff(addAssignment_82301,axiom,
    ! [VarCurr: state_type] :
      ( v146260(VarCurr)
    <=> v96202(VarCurr,1) ) ).

tff(addAssignment_82300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146251(VarCurr,B)
      <=> v146253(VarCurr,B) ) ) ).

tff(addAssignment_82299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146253(VarCurr,B)
      <=> v28105(VarCurr,B) ) ) ).

tff(addAssignment_82298,axiom,
    ! [VarCurr: state_type] :
      ( v146225(VarCurr)
    <=> v146227(VarCurr) ) ).

tff(addAssignment_82297,axiom,
    ! [VarCurr: state_type] :
      ( v146227(VarCurr)
    <=> v146229(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2234,axiom,
    ! [VarCurr: state_type] :
      ( v146229(VarCurr)
    <=> ( ( v146231(VarCurr,11)
        <=> v146235(VarCurr,11) )
        & ( v146231(VarCurr,10)
        <=> v146235(VarCurr,10) )
        & ( v146231(VarCurr,9)
        <=> v146235(VarCurr,9) )
        & ( v146231(VarCurr,8)
        <=> v146235(VarCurr,8) )
        & ( v146231(VarCurr,7)
        <=> v146235(VarCurr,7) )
        & ( v146231(VarCurr,6)
        <=> v146235(VarCurr,6) )
        & ( v146231(VarCurr,5)
        <=> v146235(VarCurr,5) )
        & ( v146231(VarCurr,4)
        <=> v146235(VarCurr,4) )
        & ( v146231(VarCurr,3)
        <=> v146235(VarCurr,3) )
        & ( v146231(VarCurr,2)
        <=> v146235(VarCurr,2) )
        & ( v146231(VarCurr,1)
        <=> v146235(VarCurr,1) )
        & ( v146231(VarCurr,0)
        <=> v146235(VarCurr,0) ) ) ) ).

tff(addAssignment_82296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146235(VarCurr,B)
      <=> v146237(VarCurr,B) ) ) ).

tff(addAssignment_82295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146237(VarCurr,B)
      <=> v146241(VarCurr,B) ) ) ).

tff(addAssignment_82294,axiom,
    ! [VarCurr: state_type] :
      ( ( v146237(VarCurr,11)
      <=> v146239(VarCurr,5) )
      & ( v146237(VarCurr,10)
      <=> v146239(VarCurr,4) )
      & ( v146237(VarCurr,9)
      <=> v146239(VarCurr,3) )
      & ( v146237(VarCurr,8)
      <=> v146239(VarCurr,2) )
      & ( v146237(VarCurr,7)
      <=> v146239(VarCurr,1) )
      & ( v146237(VarCurr,6)
      <=> v146239(VarCurr,0) ) ) ).

tff(addAssignment_82293,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,0)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82292,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,1)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82291,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,2)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82290,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,3)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82289,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,4)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82288,axiom,
    ! [VarCurr: state_type] :
      ( v146241(VarCurr,5)
    <=> v146242(VarCurr) ) ).

tff(addAssignment_82287,axiom,
    ! [VarCurr: state_type] :
      ( v146242(VarCurr)
    <=> v96167(VarCurr,0) ) ).

tff(addAssignment_82286,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,0)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82285,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,1)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82284,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,2)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82283,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,3)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82282,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,4)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82281,axiom,
    ! [VarCurr: state_type] :
      ( v146239(VarCurr,5)
    <=> v146240(VarCurr) ) ).

tff(addAssignment_82280,axiom,
    ! [VarCurr: state_type] :
      ( v146240(VarCurr)
    <=> v96167(VarCurr,1) ) ).

tff(addAssignment_82279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146231(VarCurr,B)
      <=> v146233(VarCurr,B) ) ) ).

tff(addAssignment_82278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146233(VarCurr,B)
      <=> v26555(VarCurr,B) ) ) ).

tff(addAssignment_82277,axiom,
    ! [VarCurr: state_type] :
      ( v146205(VarCurr)
    <=> v146207(VarCurr) ) ).

tff(addAssignment_82276,axiom,
    ! [VarCurr: state_type] :
      ( v146207(VarCurr)
    <=> v146209(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2233,axiom,
    ! [VarCurr: state_type] :
      ( v146209(VarCurr)
    <=> ( ( v146211(VarCurr,11)
        <=> v146215(VarCurr,11) )
        & ( v146211(VarCurr,10)
        <=> v146215(VarCurr,10) )
        & ( v146211(VarCurr,9)
        <=> v146215(VarCurr,9) )
        & ( v146211(VarCurr,8)
        <=> v146215(VarCurr,8) )
        & ( v146211(VarCurr,7)
        <=> v146215(VarCurr,7) )
        & ( v146211(VarCurr,6)
        <=> v146215(VarCurr,6) )
        & ( v146211(VarCurr,5)
        <=> v146215(VarCurr,5) )
        & ( v146211(VarCurr,4)
        <=> v146215(VarCurr,4) )
        & ( v146211(VarCurr,3)
        <=> v146215(VarCurr,3) )
        & ( v146211(VarCurr,2)
        <=> v146215(VarCurr,2) )
        & ( v146211(VarCurr,1)
        <=> v146215(VarCurr,1) )
        & ( v146211(VarCurr,0)
        <=> v146215(VarCurr,0) ) ) ) ).

tff(addAssignment_82275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146215(VarCurr,B)
      <=> v146217(VarCurr,B) ) ) ).

tff(addAssignment_82274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146217(VarCurr,B)
      <=> v146221(VarCurr,B) ) ) ).

tff(addAssignment_82273,axiom,
    ! [VarCurr: state_type] :
      ( ( v146217(VarCurr,11)
      <=> v146219(VarCurr,5) )
      & ( v146217(VarCurr,10)
      <=> v146219(VarCurr,4) )
      & ( v146217(VarCurr,9)
      <=> v146219(VarCurr,3) )
      & ( v146217(VarCurr,8)
      <=> v146219(VarCurr,2) )
      & ( v146217(VarCurr,7)
      <=> v146219(VarCurr,1) )
      & ( v146217(VarCurr,6)
      <=> v146219(VarCurr,0) ) ) ).

tff(addAssignment_82272,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,0)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82271,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,1)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82270,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,2)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82269,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,3)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82268,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,4)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82267,axiom,
    ! [VarCurr: state_type] :
      ( v146221(VarCurr,5)
    <=> v146222(VarCurr) ) ).

tff(addAssignment_82266,axiom,
    ! [VarCurr: state_type] :
      ( v146222(VarCurr)
    <=> v96132(VarCurr,0) ) ).

tff(addAssignment_82265,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,0)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82264,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,1)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82263,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,2)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82262,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,3)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82261,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,4)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82260,axiom,
    ! [VarCurr: state_type] :
      ( v146219(VarCurr,5)
    <=> v146220(VarCurr) ) ).

tff(addAssignment_82259,axiom,
    ! [VarCurr: state_type] :
      ( v146220(VarCurr)
    <=> v96132(VarCurr,1) ) ).

tff(addAssignment_82258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146211(VarCurr,B)
      <=> v146213(VarCurr,B) ) ) ).

tff(addAssignment_82257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146213(VarCurr,B)
      <=> v25005(VarCurr,B) ) ) ).

tff(addAssignment_82256,axiom,
    ! [VarCurr: state_type] :
      ( v146185(VarCurr)
    <=> v146187(VarCurr) ) ).

tff(addAssignment_82255,axiom,
    ! [VarCurr: state_type] :
      ( v146187(VarCurr)
    <=> v146189(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2232,axiom,
    ! [VarCurr: state_type] :
      ( v146189(VarCurr)
    <=> ( ( v146191(VarCurr,11)
        <=> v146195(VarCurr,11) )
        & ( v146191(VarCurr,10)
        <=> v146195(VarCurr,10) )
        & ( v146191(VarCurr,9)
        <=> v146195(VarCurr,9) )
        & ( v146191(VarCurr,8)
        <=> v146195(VarCurr,8) )
        & ( v146191(VarCurr,7)
        <=> v146195(VarCurr,7) )
        & ( v146191(VarCurr,6)
        <=> v146195(VarCurr,6) )
        & ( v146191(VarCurr,5)
        <=> v146195(VarCurr,5) )
        & ( v146191(VarCurr,4)
        <=> v146195(VarCurr,4) )
        & ( v146191(VarCurr,3)
        <=> v146195(VarCurr,3) )
        & ( v146191(VarCurr,2)
        <=> v146195(VarCurr,2) )
        & ( v146191(VarCurr,1)
        <=> v146195(VarCurr,1) )
        & ( v146191(VarCurr,0)
        <=> v146195(VarCurr,0) ) ) ) ).

tff(addAssignment_82254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146195(VarCurr,B)
      <=> v146197(VarCurr,B) ) ) ).

tff(addAssignment_82253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146197(VarCurr,B)
      <=> v146201(VarCurr,B) ) ) ).

tff(addAssignment_82252,axiom,
    ! [VarCurr: state_type] :
      ( ( v146197(VarCurr,11)
      <=> v146199(VarCurr,5) )
      & ( v146197(VarCurr,10)
      <=> v146199(VarCurr,4) )
      & ( v146197(VarCurr,9)
      <=> v146199(VarCurr,3) )
      & ( v146197(VarCurr,8)
      <=> v146199(VarCurr,2) )
      & ( v146197(VarCurr,7)
      <=> v146199(VarCurr,1) )
      & ( v146197(VarCurr,6)
      <=> v146199(VarCurr,0) ) ) ).

tff(addAssignment_82251,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,0)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82250,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,1)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82249,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,2)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82248,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,3)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82247,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,4)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82246,axiom,
    ! [VarCurr: state_type] :
      ( v146201(VarCurr,5)
    <=> v146202(VarCurr) ) ).

tff(addAssignment_82245,axiom,
    ! [VarCurr: state_type] :
      ( v146202(VarCurr)
    <=> v96097(VarCurr,0) ) ).

tff(addAssignment_82244,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,0)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82243,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,1)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82242,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,2)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82241,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,3)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82240,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,4)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82239,axiom,
    ! [VarCurr: state_type] :
      ( v146199(VarCurr,5)
    <=> v146200(VarCurr) ) ).

tff(addAssignment_82238,axiom,
    ! [VarCurr: state_type] :
      ( v146200(VarCurr)
    <=> v96097(VarCurr,1) ) ).

tff(addAssignment_82237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146191(VarCurr,B)
      <=> v146193(VarCurr,B) ) ) ).

tff(addAssignment_82236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146193(VarCurr,B)
      <=> v23455(VarCurr,B) ) ) ).

tff(addAssignment_82235,axiom,
    ! [VarCurr: state_type] :
      ( v146165(VarCurr)
    <=> v146167(VarCurr) ) ).

tff(addAssignment_82234,axiom,
    ! [VarCurr: state_type] :
      ( v146167(VarCurr)
    <=> v146169(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2231,axiom,
    ! [VarCurr: state_type] :
      ( v146169(VarCurr)
    <=> ( ( v146171(VarCurr,11)
        <=> v146175(VarCurr,11) )
        & ( v146171(VarCurr,10)
        <=> v146175(VarCurr,10) )
        & ( v146171(VarCurr,9)
        <=> v146175(VarCurr,9) )
        & ( v146171(VarCurr,8)
        <=> v146175(VarCurr,8) )
        & ( v146171(VarCurr,7)
        <=> v146175(VarCurr,7) )
        & ( v146171(VarCurr,6)
        <=> v146175(VarCurr,6) )
        & ( v146171(VarCurr,5)
        <=> v146175(VarCurr,5) )
        & ( v146171(VarCurr,4)
        <=> v146175(VarCurr,4) )
        & ( v146171(VarCurr,3)
        <=> v146175(VarCurr,3) )
        & ( v146171(VarCurr,2)
        <=> v146175(VarCurr,2) )
        & ( v146171(VarCurr,1)
        <=> v146175(VarCurr,1) )
        & ( v146171(VarCurr,0)
        <=> v146175(VarCurr,0) ) ) ) ).

tff(addAssignment_82233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146175(VarCurr,B)
      <=> v146177(VarCurr,B) ) ) ).

tff(addAssignment_82232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146177(VarCurr,B)
      <=> v146181(VarCurr,B) ) ) ).

tff(addAssignment_82231,axiom,
    ! [VarCurr: state_type] :
      ( ( v146177(VarCurr,11)
      <=> v146179(VarCurr,5) )
      & ( v146177(VarCurr,10)
      <=> v146179(VarCurr,4) )
      & ( v146177(VarCurr,9)
      <=> v146179(VarCurr,3) )
      & ( v146177(VarCurr,8)
      <=> v146179(VarCurr,2) )
      & ( v146177(VarCurr,7)
      <=> v146179(VarCurr,1) )
      & ( v146177(VarCurr,6)
      <=> v146179(VarCurr,0) ) ) ).

tff(addAssignment_82230,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,0)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82229,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,1)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82228,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,2)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82227,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,3)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82226,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,4)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82225,axiom,
    ! [VarCurr: state_type] :
      ( v146181(VarCurr,5)
    <=> v146182(VarCurr) ) ).

tff(addAssignment_82224,axiom,
    ! [VarCurr: state_type] :
      ( v146182(VarCurr)
    <=> v96062(VarCurr,0) ) ).

tff(addAssignment_82223,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,0)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82222,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,1)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82221,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,2)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82220,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,3)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82219,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,4)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82218,axiom,
    ! [VarCurr: state_type] :
      ( v146179(VarCurr,5)
    <=> v146180(VarCurr) ) ).

tff(addAssignment_82217,axiom,
    ! [VarCurr: state_type] :
      ( v146180(VarCurr)
    <=> v96062(VarCurr,1) ) ).

tff(addAssignment_82216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146171(VarCurr,B)
      <=> v146173(VarCurr,B) ) ) ).

tff(addAssignment_82215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146173(VarCurr,B)
      <=> v21905(VarCurr,B) ) ) ).

tff(addAssignment_82214,axiom,
    ! [VarCurr: state_type] :
      ( v146145(VarCurr)
    <=> v146147(VarCurr) ) ).

tff(addAssignment_82213,axiom,
    ! [VarCurr: state_type] :
      ( v146147(VarCurr)
    <=> v146149(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2230,axiom,
    ! [VarCurr: state_type] :
      ( v146149(VarCurr)
    <=> ( ( v146151(VarCurr,11)
        <=> v146155(VarCurr,11) )
        & ( v146151(VarCurr,10)
        <=> v146155(VarCurr,10) )
        & ( v146151(VarCurr,9)
        <=> v146155(VarCurr,9) )
        & ( v146151(VarCurr,8)
        <=> v146155(VarCurr,8) )
        & ( v146151(VarCurr,7)
        <=> v146155(VarCurr,7) )
        & ( v146151(VarCurr,6)
        <=> v146155(VarCurr,6) )
        & ( v146151(VarCurr,5)
        <=> v146155(VarCurr,5) )
        & ( v146151(VarCurr,4)
        <=> v146155(VarCurr,4) )
        & ( v146151(VarCurr,3)
        <=> v146155(VarCurr,3) )
        & ( v146151(VarCurr,2)
        <=> v146155(VarCurr,2) )
        & ( v146151(VarCurr,1)
        <=> v146155(VarCurr,1) )
        & ( v146151(VarCurr,0)
        <=> v146155(VarCurr,0) ) ) ) ).

tff(addAssignment_82212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146155(VarCurr,B)
      <=> v146157(VarCurr,B) ) ) ).

tff(addAssignment_82211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146157(VarCurr,B)
      <=> v146161(VarCurr,B) ) ) ).

tff(addAssignment_82210,axiom,
    ! [VarCurr: state_type] :
      ( ( v146157(VarCurr,11)
      <=> v146159(VarCurr,5) )
      & ( v146157(VarCurr,10)
      <=> v146159(VarCurr,4) )
      & ( v146157(VarCurr,9)
      <=> v146159(VarCurr,3) )
      & ( v146157(VarCurr,8)
      <=> v146159(VarCurr,2) )
      & ( v146157(VarCurr,7)
      <=> v146159(VarCurr,1) )
      & ( v146157(VarCurr,6)
      <=> v146159(VarCurr,0) ) ) ).

tff(addAssignment_82209,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,0)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82208,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,1)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82207,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,2)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82206,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,3)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82205,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,4)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82204,axiom,
    ! [VarCurr: state_type] :
      ( v146161(VarCurr,5)
    <=> v146162(VarCurr) ) ).

tff(addAssignment_82203,axiom,
    ! [VarCurr: state_type] :
      ( v146162(VarCurr)
    <=> v96027(VarCurr,0) ) ).

tff(addAssignment_82202,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,0)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82201,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,1)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82200,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,2)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82199,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,3)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82198,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,4)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82197,axiom,
    ! [VarCurr: state_type] :
      ( v146159(VarCurr,5)
    <=> v146160(VarCurr) ) ).

tff(addAssignment_82196,axiom,
    ! [VarCurr: state_type] :
      ( v146160(VarCurr)
    <=> v96027(VarCurr,1) ) ).

tff(addAssignment_82195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146151(VarCurr,B)
      <=> v146153(VarCurr,B) ) ) ).

tff(addAssignment_82194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146153(VarCurr,B)
      <=> v20355(VarCurr,B) ) ) ).

tff(addAssignment_82193,axiom,
    ! [VarCurr: state_type] :
      ( v146125(VarCurr)
    <=> v146127(VarCurr) ) ).

tff(addAssignment_82192,axiom,
    ! [VarCurr: state_type] :
      ( v146127(VarCurr)
    <=> v146129(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2229,axiom,
    ! [VarCurr: state_type] :
      ( v146129(VarCurr)
    <=> ( ( v146131(VarCurr,11)
        <=> v146135(VarCurr,11) )
        & ( v146131(VarCurr,10)
        <=> v146135(VarCurr,10) )
        & ( v146131(VarCurr,9)
        <=> v146135(VarCurr,9) )
        & ( v146131(VarCurr,8)
        <=> v146135(VarCurr,8) )
        & ( v146131(VarCurr,7)
        <=> v146135(VarCurr,7) )
        & ( v146131(VarCurr,6)
        <=> v146135(VarCurr,6) )
        & ( v146131(VarCurr,5)
        <=> v146135(VarCurr,5) )
        & ( v146131(VarCurr,4)
        <=> v146135(VarCurr,4) )
        & ( v146131(VarCurr,3)
        <=> v146135(VarCurr,3) )
        & ( v146131(VarCurr,2)
        <=> v146135(VarCurr,2) )
        & ( v146131(VarCurr,1)
        <=> v146135(VarCurr,1) )
        & ( v146131(VarCurr,0)
        <=> v146135(VarCurr,0) ) ) ) ).

tff(addAssignment_82191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146135(VarCurr,B)
      <=> v146137(VarCurr,B) ) ) ).

tff(addAssignment_82190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146137(VarCurr,B)
      <=> v146141(VarCurr,B) ) ) ).

tff(addAssignment_82189,axiom,
    ! [VarCurr: state_type] :
      ( ( v146137(VarCurr,11)
      <=> v146139(VarCurr,5) )
      & ( v146137(VarCurr,10)
      <=> v146139(VarCurr,4) )
      & ( v146137(VarCurr,9)
      <=> v146139(VarCurr,3) )
      & ( v146137(VarCurr,8)
      <=> v146139(VarCurr,2) )
      & ( v146137(VarCurr,7)
      <=> v146139(VarCurr,1) )
      & ( v146137(VarCurr,6)
      <=> v146139(VarCurr,0) ) ) ).

tff(addAssignment_82188,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,0)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82187,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,1)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82186,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,2)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82185,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,3)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82184,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,4)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82183,axiom,
    ! [VarCurr: state_type] :
      ( v146141(VarCurr,5)
    <=> v146142(VarCurr) ) ).

tff(addAssignment_82182,axiom,
    ! [VarCurr: state_type] :
      ( v146142(VarCurr)
    <=> v95992(VarCurr,0) ) ).

tff(addAssignment_82181,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,0)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82180,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,1)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82179,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,2)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82178,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,3)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82177,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,4)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82176,axiom,
    ! [VarCurr: state_type] :
      ( v146139(VarCurr,5)
    <=> v146140(VarCurr) ) ).

tff(addAssignment_82175,axiom,
    ! [VarCurr: state_type] :
      ( v146140(VarCurr)
    <=> v95992(VarCurr,1) ) ).

tff(addAssignment_82174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146131(VarCurr,B)
      <=> v146133(VarCurr,B) ) ) ).

tff(addAssignment_82173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146133(VarCurr,B)
      <=> v18805(VarCurr,B) ) ) ).

tff(addAssignment_82172,axiom,
    ! [VarCurr: state_type] :
      ( v146105(VarCurr)
    <=> v146107(VarCurr) ) ).

tff(addAssignment_82171,axiom,
    ! [VarCurr: state_type] :
      ( v146107(VarCurr)
    <=> v146109(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2228,axiom,
    ! [VarCurr: state_type] :
      ( v146109(VarCurr)
    <=> ( ( v146111(VarCurr,11)
        <=> v146115(VarCurr,11) )
        & ( v146111(VarCurr,10)
        <=> v146115(VarCurr,10) )
        & ( v146111(VarCurr,9)
        <=> v146115(VarCurr,9) )
        & ( v146111(VarCurr,8)
        <=> v146115(VarCurr,8) )
        & ( v146111(VarCurr,7)
        <=> v146115(VarCurr,7) )
        & ( v146111(VarCurr,6)
        <=> v146115(VarCurr,6) )
        & ( v146111(VarCurr,5)
        <=> v146115(VarCurr,5) )
        & ( v146111(VarCurr,4)
        <=> v146115(VarCurr,4) )
        & ( v146111(VarCurr,3)
        <=> v146115(VarCurr,3) )
        & ( v146111(VarCurr,2)
        <=> v146115(VarCurr,2) )
        & ( v146111(VarCurr,1)
        <=> v146115(VarCurr,1) )
        & ( v146111(VarCurr,0)
        <=> v146115(VarCurr,0) ) ) ) ).

tff(addAssignment_82170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146115(VarCurr,B)
      <=> v146117(VarCurr,B) ) ) ).

tff(addAssignment_82169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146117(VarCurr,B)
      <=> v146121(VarCurr,B) ) ) ).

tff(addAssignment_82168,axiom,
    ! [VarCurr: state_type] :
      ( ( v146117(VarCurr,11)
      <=> v146119(VarCurr,5) )
      & ( v146117(VarCurr,10)
      <=> v146119(VarCurr,4) )
      & ( v146117(VarCurr,9)
      <=> v146119(VarCurr,3) )
      & ( v146117(VarCurr,8)
      <=> v146119(VarCurr,2) )
      & ( v146117(VarCurr,7)
      <=> v146119(VarCurr,1) )
      & ( v146117(VarCurr,6)
      <=> v146119(VarCurr,0) ) ) ).

tff(addAssignment_82167,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,0)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82166,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,1)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82165,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,2)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82164,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,3)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82163,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,4)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82162,axiom,
    ! [VarCurr: state_type] :
      ( v146121(VarCurr,5)
    <=> v146122(VarCurr) ) ).

tff(addAssignment_82161,axiom,
    ! [VarCurr: state_type] :
      ( v146122(VarCurr)
    <=> v95957(VarCurr,0) ) ).

tff(addAssignment_82160,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,0)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82159,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,1)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82158,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,2)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82157,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,3)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82156,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,4)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82155,axiom,
    ! [VarCurr: state_type] :
      ( v146119(VarCurr,5)
    <=> v146120(VarCurr) ) ).

tff(addAssignment_82154,axiom,
    ! [VarCurr: state_type] :
      ( v146120(VarCurr)
    <=> v95957(VarCurr,1) ) ).

tff(addAssignment_82153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146111(VarCurr,B)
      <=> v146113(VarCurr,B) ) ) ).

tff(addAssignment_82152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146113(VarCurr,B)
      <=> v17255(VarCurr,B) ) ) ).

tff(addAssignment_82151,axiom,
    ! [VarCurr: state_type] :
      ( v146085(VarCurr)
    <=> v146087(VarCurr) ) ).

tff(addAssignment_82150,axiom,
    ! [VarCurr: state_type] :
      ( v146087(VarCurr)
    <=> v146089(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2227,axiom,
    ! [VarCurr: state_type] :
      ( v146089(VarCurr)
    <=> ( ( v146091(VarCurr,11)
        <=> v146095(VarCurr,11) )
        & ( v146091(VarCurr,10)
        <=> v146095(VarCurr,10) )
        & ( v146091(VarCurr,9)
        <=> v146095(VarCurr,9) )
        & ( v146091(VarCurr,8)
        <=> v146095(VarCurr,8) )
        & ( v146091(VarCurr,7)
        <=> v146095(VarCurr,7) )
        & ( v146091(VarCurr,6)
        <=> v146095(VarCurr,6) )
        & ( v146091(VarCurr,5)
        <=> v146095(VarCurr,5) )
        & ( v146091(VarCurr,4)
        <=> v146095(VarCurr,4) )
        & ( v146091(VarCurr,3)
        <=> v146095(VarCurr,3) )
        & ( v146091(VarCurr,2)
        <=> v146095(VarCurr,2) )
        & ( v146091(VarCurr,1)
        <=> v146095(VarCurr,1) )
        & ( v146091(VarCurr,0)
        <=> v146095(VarCurr,0) ) ) ) ).

tff(addAssignment_82149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146095(VarCurr,B)
      <=> v146097(VarCurr,B) ) ) ).

tff(addAssignment_82148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146097(VarCurr,B)
      <=> v146101(VarCurr,B) ) ) ).

tff(addAssignment_82147,axiom,
    ! [VarCurr: state_type] :
      ( ( v146097(VarCurr,11)
      <=> v146099(VarCurr,5) )
      & ( v146097(VarCurr,10)
      <=> v146099(VarCurr,4) )
      & ( v146097(VarCurr,9)
      <=> v146099(VarCurr,3) )
      & ( v146097(VarCurr,8)
      <=> v146099(VarCurr,2) )
      & ( v146097(VarCurr,7)
      <=> v146099(VarCurr,1) )
      & ( v146097(VarCurr,6)
      <=> v146099(VarCurr,0) ) ) ).

tff(addAssignment_82146,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,0)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82145,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,1)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82144,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,2)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82143,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,3)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82142,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,4)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82141,axiom,
    ! [VarCurr: state_type] :
      ( v146101(VarCurr,5)
    <=> v146102(VarCurr) ) ).

tff(addAssignment_82140,axiom,
    ! [VarCurr: state_type] :
      ( v146102(VarCurr)
    <=> v95922(VarCurr,0) ) ).

tff(addAssignment_82139,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,0)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82138,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,1)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82137,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,2)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82136,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,3)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82135,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,4)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82134,axiom,
    ! [VarCurr: state_type] :
      ( v146099(VarCurr,5)
    <=> v146100(VarCurr) ) ).

tff(addAssignment_82133,axiom,
    ! [VarCurr: state_type] :
      ( v146100(VarCurr)
    <=> v95922(VarCurr,1) ) ).

tff(addAssignment_82132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146091(VarCurr,B)
      <=> v146093(VarCurr,B) ) ) ).

tff(addAssignment_82131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146093(VarCurr,B)
      <=> v15705(VarCurr,B) ) ) ).

tff(addAssignment_82130,axiom,
    ! [VarCurr: state_type] :
      ( v146065(VarCurr)
    <=> v146067(VarCurr) ) ).

tff(addAssignment_82129,axiom,
    ! [VarCurr: state_type] :
      ( v146067(VarCurr)
    <=> v146069(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2226,axiom,
    ! [VarCurr: state_type] :
      ( v146069(VarCurr)
    <=> ( ( v146071(VarCurr,11)
        <=> v146075(VarCurr,11) )
        & ( v146071(VarCurr,10)
        <=> v146075(VarCurr,10) )
        & ( v146071(VarCurr,9)
        <=> v146075(VarCurr,9) )
        & ( v146071(VarCurr,8)
        <=> v146075(VarCurr,8) )
        & ( v146071(VarCurr,7)
        <=> v146075(VarCurr,7) )
        & ( v146071(VarCurr,6)
        <=> v146075(VarCurr,6) )
        & ( v146071(VarCurr,5)
        <=> v146075(VarCurr,5) )
        & ( v146071(VarCurr,4)
        <=> v146075(VarCurr,4) )
        & ( v146071(VarCurr,3)
        <=> v146075(VarCurr,3) )
        & ( v146071(VarCurr,2)
        <=> v146075(VarCurr,2) )
        & ( v146071(VarCurr,1)
        <=> v146075(VarCurr,1) )
        & ( v146071(VarCurr,0)
        <=> v146075(VarCurr,0) ) ) ) ).

tff(addAssignment_82128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146075(VarCurr,B)
      <=> v146077(VarCurr,B) ) ) ).

tff(addAssignment_82127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146077(VarCurr,B)
      <=> v146081(VarCurr,B) ) ) ).

tff(addAssignment_82126,axiom,
    ! [VarCurr: state_type] :
      ( ( v146077(VarCurr,11)
      <=> v146079(VarCurr,5) )
      & ( v146077(VarCurr,10)
      <=> v146079(VarCurr,4) )
      & ( v146077(VarCurr,9)
      <=> v146079(VarCurr,3) )
      & ( v146077(VarCurr,8)
      <=> v146079(VarCurr,2) )
      & ( v146077(VarCurr,7)
      <=> v146079(VarCurr,1) )
      & ( v146077(VarCurr,6)
      <=> v146079(VarCurr,0) ) ) ).

tff(addAssignment_82125,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,0)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82124,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,1)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82123,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,2)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82122,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,3)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82121,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,4)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82120,axiom,
    ! [VarCurr: state_type] :
      ( v146081(VarCurr,5)
    <=> v146082(VarCurr) ) ).

tff(addAssignment_82119,axiom,
    ! [VarCurr: state_type] :
      ( v146082(VarCurr)
    <=> v95887(VarCurr,0) ) ).

tff(addAssignment_82118,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,0)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82117,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,1)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82116,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,2)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82115,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,3)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82114,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,4)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82113,axiom,
    ! [VarCurr: state_type] :
      ( v146079(VarCurr,5)
    <=> v146080(VarCurr) ) ).

tff(addAssignment_82112,axiom,
    ! [VarCurr: state_type] :
      ( v146080(VarCurr)
    <=> v95887(VarCurr,1) ) ).

tff(addAssignment_82111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146071(VarCurr,B)
      <=> v146073(VarCurr,B) ) ) ).

tff(addAssignment_82110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146073(VarCurr,B)
      <=> v14155(VarCurr,B) ) ) ).

tff(addAssignment_82109,axiom,
    ! [VarCurr: state_type] :
      ( v146045(VarCurr)
    <=> v146047(VarCurr) ) ).

tff(addAssignment_82108,axiom,
    ! [VarCurr: state_type] :
      ( v146047(VarCurr)
    <=> v146049(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2225,axiom,
    ! [VarCurr: state_type] :
      ( v146049(VarCurr)
    <=> ( ( v146051(VarCurr,11)
        <=> v146055(VarCurr,11) )
        & ( v146051(VarCurr,10)
        <=> v146055(VarCurr,10) )
        & ( v146051(VarCurr,9)
        <=> v146055(VarCurr,9) )
        & ( v146051(VarCurr,8)
        <=> v146055(VarCurr,8) )
        & ( v146051(VarCurr,7)
        <=> v146055(VarCurr,7) )
        & ( v146051(VarCurr,6)
        <=> v146055(VarCurr,6) )
        & ( v146051(VarCurr,5)
        <=> v146055(VarCurr,5) )
        & ( v146051(VarCurr,4)
        <=> v146055(VarCurr,4) )
        & ( v146051(VarCurr,3)
        <=> v146055(VarCurr,3) )
        & ( v146051(VarCurr,2)
        <=> v146055(VarCurr,2) )
        & ( v146051(VarCurr,1)
        <=> v146055(VarCurr,1) )
        & ( v146051(VarCurr,0)
        <=> v146055(VarCurr,0) ) ) ) ).

tff(addAssignment_82107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146055(VarCurr,B)
      <=> v146057(VarCurr,B) ) ) ).

tff(addAssignment_82106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146057(VarCurr,B)
      <=> v146061(VarCurr,B) ) ) ).

tff(addAssignment_82105,axiom,
    ! [VarCurr: state_type] :
      ( ( v146057(VarCurr,11)
      <=> v146059(VarCurr,5) )
      & ( v146057(VarCurr,10)
      <=> v146059(VarCurr,4) )
      & ( v146057(VarCurr,9)
      <=> v146059(VarCurr,3) )
      & ( v146057(VarCurr,8)
      <=> v146059(VarCurr,2) )
      & ( v146057(VarCurr,7)
      <=> v146059(VarCurr,1) )
      & ( v146057(VarCurr,6)
      <=> v146059(VarCurr,0) ) ) ).

tff(addAssignment_82104,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,0)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82103,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,1)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82102,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,2)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82101,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,3)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82100,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,4)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82099,axiom,
    ! [VarCurr: state_type] :
      ( v146061(VarCurr,5)
    <=> v146062(VarCurr) ) ).

tff(addAssignment_82098,axiom,
    ! [VarCurr: state_type] :
      ( v146062(VarCurr)
    <=> v95852(VarCurr,0) ) ).

tff(addAssignment_82097,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,0)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82096,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,1)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82095,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,2)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82094,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,3)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82093,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,4)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82092,axiom,
    ! [VarCurr: state_type] :
      ( v146059(VarCurr,5)
    <=> v146060(VarCurr) ) ).

tff(addAssignment_82091,axiom,
    ! [VarCurr: state_type] :
      ( v146060(VarCurr)
    <=> v95852(VarCurr,1) ) ).

tff(addAssignment_82090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146051(VarCurr,B)
      <=> v146053(VarCurr,B) ) ) ).

tff(addAssignment_82089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146053(VarCurr,B)
      <=> v12605(VarCurr,B) ) ) ).

tff(addAssignment_82088,axiom,
    ! [VarCurr: state_type] :
      ( v146025(VarCurr)
    <=> v146027(VarCurr) ) ).

tff(addAssignment_82087,axiom,
    ! [VarCurr: state_type] :
      ( v146027(VarCurr)
    <=> v146029(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2224,axiom,
    ! [VarCurr: state_type] :
      ( v146029(VarCurr)
    <=> ( ( v146031(VarCurr,11)
        <=> v146035(VarCurr,11) )
        & ( v146031(VarCurr,10)
        <=> v146035(VarCurr,10) )
        & ( v146031(VarCurr,9)
        <=> v146035(VarCurr,9) )
        & ( v146031(VarCurr,8)
        <=> v146035(VarCurr,8) )
        & ( v146031(VarCurr,7)
        <=> v146035(VarCurr,7) )
        & ( v146031(VarCurr,6)
        <=> v146035(VarCurr,6) )
        & ( v146031(VarCurr,5)
        <=> v146035(VarCurr,5) )
        & ( v146031(VarCurr,4)
        <=> v146035(VarCurr,4) )
        & ( v146031(VarCurr,3)
        <=> v146035(VarCurr,3) )
        & ( v146031(VarCurr,2)
        <=> v146035(VarCurr,2) )
        & ( v146031(VarCurr,1)
        <=> v146035(VarCurr,1) )
        & ( v146031(VarCurr,0)
        <=> v146035(VarCurr,0) ) ) ) ).

tff(addAssignment_82086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146035(VarCurr,B)
      <=> v146037(VarCurr,B) ) ) ).

tff(addAssignment_82085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146037(VarCurr,B)
      <=> v146041(VarCurr,B) ) ) ).

tff(addAssignment_82084,axiom,
    ! [VarCurr: state_type] :
      ( ( v146037(VarCurr,11)
      <=> v146039(VarCurr,5) )
      & ( v146037(VarCurr,10)
      <=> v146039(VarCurr,4) )
      & ( v146037(VarCurr,9)
      <=> v146039(VarCurr,3) )
      & ( v146037(VarCurr,8)
      <=> v146039(VarCurr,2) )
      & ( v146037(VarCurr,7)
      <=> v146039(VarCurr,1) )
      & ( v146037(VarCurr,6)
      <=> v146039(VarCurr,0) ) ) ).

tff(addAssignment_82083,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,0)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82082,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,1)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82081,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,2)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82080,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,3)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82079,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,4)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82078,axiom,
    ! [VarCurr: state_type] :
      ( v146041(VarCurr,5)
    <=> v146042(VarCurr) ) ).

tff(addAssignment_82077,axiom,
    ! [VarCurr: state_type] :
      ( v146042(VarCurr)
    <=> v95815(VarCurr,0) ) ).

tff(addAssignment_82076,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,0)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82075,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,1)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82074,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,2)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82073,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,3)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82072,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,4)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82071,axiom,
    ! [VarCurr: state_type] :
      ( v146039(VarCurr,5)
    <=> v146040(VarCurr) ) ).

tff(addAssignment_82070,axiom,
    ! [VarCurr: state_type] :
      ( v146040(VarCurr)
    <=> v95815(VarCurr,1) ) ).

tff(addAssignment_82069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146031(VarCurr,B)
      <=> v146033(VarCurr,B) ) ) ).

tff(addAssignment_82068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146033(VarCurr,B)
      <=> v11055(VarCurr,B) ) ) ).

tff(addAssignment_82067,axiom,
    ! [VarCurr: state_type] :
      ( v146005(VarCurr)
    <=> v146007(VarCurr) ) ).

tff(addAssignment_82066,axiom,
    ! [VarCurr: state_type] :
      ( v146007(VarCurr)
    <=> v146009(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2223,axiom,
    ! [VarCurr: state_type] :
      ( v146009(VarCurr)
    <=> ( ( v146011(VarCurr,11)
        <=> v146015(VarCurr,11) )
        & ( v146011(VarCurr,10)
        <=> v146015(VarCurr,10) )
        & ( v146011(VarCurr,9)
        <=> v146015(VarCurr,9) )
        & ( v146011(VarCurr,8)
        <=> v146015(VarCurr,8) )
        & ( v146011(VarCurr,7)
        <=> v146015(VarCurr,7) )
        & ( v146011(VarCurr,6)
        <=> v146015(VarCurr,6) )
        & ( v146011(VarCurr,5)
        <=> v146015(VarCurr,5) )
        & ( v146011(VarCurr,4)
        <=> v146015(VarCurr,4) )
        & ( v146011(VarCurr,3)
        <=> v146015(VarCurr,3) )
        & ( v146011(VarCurr,2)
        <=> v146015(VarCurr,2) )
        & ( v146011(VarCurr,1)
        <=> v146015(VarCurr,1) )
        & ( v146011(VarCurr,0)
        <=> v146015(VarCurr,0) ) ) ) ).

tff(addAssignment_82065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146015(VarCurr,B)
      <=> v146017(VarCurr,B) ) ) ).

tff(addAssignment_82064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v146017(VarCurr,B)
      <=> v146021(VarCurr,B) ) ) ).

tff(addAssignment_82063,axiom,
    ! [VarCurr: state_type] :
      ( ( v146017(VarCurr,11)
      <=> v146019(VarCurr,5) )
      & ( v146017(VarCurr,10)
      <=> v146019(VarCurr,4) )
      & ( v146017(VarCurr,9)
      <=> v146019(VarCurr,3) )
      & ( v146017(VarCurr,8)
      <=> v146019(VarCurr,2) )
      & ( v146017(VarCurr,7)
      <=> v146019(VarCurr,1) )
      & ( v146017(VarCurr,6)
      <=> v146019(VarCurr,0) ) ) ).

tff(addAssignment_82062,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,0)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82061,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,1)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82060,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,2)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82059,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,3)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82058,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,4)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82057,axiom,
    ! [VarCurr: state_type] :
      ( v146021(VarCurr,5)
    <=> v146022(VarCurr) ) ).

tff(addAssignment_82056,axiom,
    ! [VarCurr: state_type] :
      ( v146022(VarCurr)
    <=> v95770(VarCurr,0) ) ).

tff(addAssignment_82055,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,0)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82054,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,1)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82053,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,2)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82052,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,3)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82051,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,4)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82050,axiom,
    ! [VarCurr: state_type] :
      ( v146019(VarCurr,5)
    <=> v146020(VarCurr) ) ).

tff(addAssignment_82049,axiom,
    ! [VarCurr: state_type] :
      ( v146020(VarCurr)
    <=> v95770(VarCurr,1) ) ).

tff(addAssignment_82048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146011(VarCurr,B)
      <=> v146013(VarCurr,B) ) ) ).

tff(addAssignment_82047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v146013(VarCurr,B)
      <=> v9099(VarCurr,B) ) ) ).

tff(addAssignment_82046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v4105(VarCurr,B)
      <=> v4107(VarCurr,B) ) ) ).

tff(addAssignment_82045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v4107(VarCurr,B)
      <=> v4109(VarCurr,B) ) ) ).

tff(addAssignment_82044,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,12)
    <=> v145979(VarCurr) ) ).

tff(addAssignment_82043,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,11)
    <=> v145959(VarCurr) ) ).

tff(addAssignment_82042,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,10)
    <=> v145939(VarCurr) ) ).

tff(addAssignment_82041,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,9)
    <=> v145919(VarCurr) ) ).

tff(addAssignment_82040,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,8)
    <=> v145899(VarCurr) ) ).

tff(addAssignment_82039,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,7)
    <=> v145879(VarCurr) ) ).

tff(addAssignment_82038,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,6)
    <=> v145859(VarCurr) ) ).

tff(addAssignment_82037,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,5)
    <=> v145839(VarCurr) ) ).

tff(addAssignment_82036,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,4)
    <=> v145819(VarCurr) ) ).

tff(addAssignment_82035,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,3)
    <=> v145799(VarCurr) ) ).

tff(addAssignment_82034,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,2)
    <=> v145779(VarCurr) ) ).

tff(addAssignment_82033,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,1)
    <=> v145759(VarCurr) ) ).

tff(addAssignment_82032,axiom,
    ! [VarCurr: state_type] :
      ( v4109(VarCurr,0)
    <=> v4111(VarCurr) ) ).

tff(addAssignment_82031,axiom,
    ! [VarCurr: state_type] :
      ( v145979(VarCurr)
    <=> v145981(VarCurr) ) ).

tff(addAssignment_82030,axiom,
    ! [VarCurr: state_type] :
      ( v145981(VarCurr)
    <=> v145983(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2222,axiom,
    ! [VarCurr: state_type] :
      ( v145983(VarCurr)
    <=> ( ( v145985(VarCurr,11)
        <=> v145989(VarCurr,11) )
        & ( v145985(VarCurr,10)
        <=> v145989(VarCurr,10) )
        & ( v145985(VarCurr,9)
        <=> v145989(VarCurr,9) )
        & ( v145985(VarCurr,8)
        <=> v145989(VarCurr,8) )
        & ( v145985(VarCurr,7)
        <=> v145989(VarCurr,7) )
        & ( v145985(VarCurr,6)
        <=> v145989(VarCurr,6) )
        & ( v145985(VarCurr,5)
        <=> v145989(VarCurr,5) )
        & ( v145985(VarCurr,4)
        <=> v145989(VarCurr,4) )
        & ( v145985(VarCurr,3)
        <=> v145989(VarCurr,3) )
        & ( v145985(VarCurr,2)
        <=> v145989(VarCurr,2) )
        & ( v145985(VarCurr,1)
        <=> v145989(VarCurr,1) )
        & ( v145985(VarCurr,0)
        <=> v145989(VarCurr,0) ) ) ) ).

tff(addAssignment_82029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145989(VarCurr,B)
      <=> v145991(VarCurr,B) ) ) ).

tff(addAssignment_82028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145991(VarCurr,B)
      <=> v145995(VarCurr,B) ) ) ).

tff(addAssignment_82027,axiom,
    ! [VarCurr: state_type] :
      ( ( v145991(VarCurr,11)
      <=> v145993(VarCurr,5) )
      & ( v145991(VarCurr,10)
      <=> v145993(VarCurr,4) )
      & ( v145991(VarCurr,9)
      <=> v145993(VarCurr,3) )
      & ( v145991(VarCurr,8)
      <=> v145993(VarCurr,2) )
      & ( v145991(VarCurr,7)
      <=> v145993(VarCurr,1) )
      & ( v145991(VarCurr,6)
      <=> v145993(VarCurr,0) ) ) ).

tff(addAssignment_82026,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,0)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82025,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,1)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82024,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,2)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82023,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,3)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82022,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,4)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82021,axiom,
    ! [VarCurr: state_type] :
      ( v145995(VarCurr,5)
    <=> v145996(VarCurr) ) ).

tff(addAssignment_82020,axiom,
    ! [VarCurr: state_type] :
      ( v145996(VarCurr)
    <=> v95693(VarCurr,0) ) ).

tff(addAssignment_82019,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,0)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82018,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,1)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82017,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,2)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82016,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,3)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82015,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,4)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82014,axiom,
    ! [VarCurr: state_type] :
      ( v145993(VarCurr,5)
    <=> v145994(VarCurr) ) ).

tff(addAssignment_82013,axiom,
    ! [VarCurr: state_type] :
      ( v145994(VarCurr)
    <=> v95693(VarCurr,1) ) ).

tff(addAssignment_82012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145985(VarCurr,B)
      <=> v145987(VarCurr,B) ) ) ).

tff(addAssignment_82011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145987(VarCurr,B)
      <=> v49399(VarCurr,B) ) ) ).

tff(addAssignment_82010,axiom,
    ! [VarCurr: state_type] :
      ( v145959(VarCurr)
    <=> v145961(VarCurr) ) ).

tff(addAssignment_82009,axiom,
    ! [VarCurr: state_type] :
      ( v145961(VarCurr)
    <=> v145963(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2221,axiom,
    ! [VarCurr: state_type] :
      ( v145963(VarCurr)
    <=> ( ( v145965(VarCurr,11)
        <=> v145969(VarCurr,11) )
        & ( v145965(VarCurr,10)
        <=> v145969(VarCurr,10) )
        & ( v145965(VarCurr,9)
        <=> v145969(VarCurr,9) )
        & ( v145965(VarCurr,8)
        <=> v145969(VarCurr,8) )
        & ( v145965(VarCurr,7)
        <=> v145969(VarCurr,7) )
        & ( v145965(VarCurr,6)
        <=> v145969(VarCurr,6) )
        & ( v145965(VarCurr,5)
        <=> v145969(VarCurr,5) )
        & ( v145965(VarCurr,4)
        <=> v145969(VarCurr,4) )
        & ( v145965(VarCurr,3)
        <=> v145969(VarCurr,3) )
        & ( v145965(VarCurr,2)
        <=> v145969(VarCurr,2) )
        & ( v145965(VarCurr,1)
        <=> v145969(VarCurr,1) )
        & ( v145965(VarCurr,0)
        <=> v145969(VarCurr,0) ) ) ) ).

tff(addAssignment_82008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145969(VarCurr,B)
      <=> v145971(VarCurr,B) ) ) ).

tff(addAssignment_82007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145971(VarCurr,B)
      <=> v145975(VarCurr,B) ) ) ).

tff(addAssignment_82006,axiom,
    ! [VarCurr: state_type] :
      ( ( v145971(VarCurr,11)
      <=> v145973(VarCurr,5) )
      & ( v145971(VarCurr,10)
      <=> v145973(VarCurr,4) )
      & ( v145971(VarCurr,9)
      <=> v145973(VarCurr,3) )
      & ( v145971(VarCurr,8)
      <=> v145973(VarCurr,2) )
      & ( v145971(VarCurr,7)
      <=> v145973(VarCurr,1) )
      & ( v145971(VarCurr,6)
      <=> v145973(VarCurr,0) ) ) ).

tff(addAssignment_82005,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,0)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_82004,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,1)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_82003,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,2)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_82002,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,3)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_82001,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,4)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_82000,axiom,
    ! [VarCurr: state_type] :
      ( v145975(VarCurr,5)
    <=> v145976(VarCurr) ) ).

tff(addAssignment_81999,axiom,
    ! [VarCurr: state_type] :
      ( v145976(VarCurr)
    <=> v95650(VarCurr,0) ) ).

tff(addAssignment_81998,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,0)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81997,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,1)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81996,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,2)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81995,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,3)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81994,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,4)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81993,axiom,
    ! [VarCurr: state_type] :
      ( v145973(VarCurr,5)
    <=> v145974(VarCurr) ) ).

tff(addAssignment_81992,axiom,
    ! [VarCurr: state_type] :
      ( v145974(VarCurr)
    <=> v95650(VarCurr,1) ) ).

tff(addAssignment_81991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145965(VarCurr,B)
      <=> v145967(VarCurr,B) ) ) ).

tff(addAssignment_81990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145967(VarCurr,B)
      <=> v47849(VarCurr,B) ) ) ).

tff(addAssignment_81989,axiom,
    ! [VarCurr: state_type] :
      ( v145939(VarCurr)
    <=> v145941(VarCurr) ) ).

tff(addAssignment_81988,axiom,
    ! [VarCurr: state_type] :
      ( v145941(VarCurr)
    <=> v145943(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2220,axiom,
    ! [VarCurr: state_type] :
      ( v145943(VarCurr)
    <=> ( ( v145945(VarCurr,11)
        <=> v145949(VarCurr,11) )
        & ( v145945(VarCurr,10)
        <=> v145949(VarCurr,10) )
        & ( v145945(VarCurr,9)
        <=> v145949(VarCurr,9) )
        & ( v145945(VarCurr,8)
        <=> v145949(VarCurr,8) )
        & ( v145945(VarCurr,7)
        <=> v145949(VarCurr,7) )
        & ( v145945(VarCurr,6)
        <=> v145949(VarCurr,6) )
        & ( v145945(VarCurr,5)
        <=> v145949(VarCurr,5) )
        & ( v145945(VarCurr,4)
        <=> v145949(VarCurr,4) )
        & ( v145945(VarCurr,3)
        <=> v145949(VarCurr,3) )
        & ( v145945(VarCurr,2)
        <=> v145949(VarCurr,2) )
        & ( v145945(VarCurr,1)
        <=> v145949(VarCurr,1) )
        & ( v145945(VarCurr,0)
        <=> v145949(VarCurr,0) ) ) ) ).

tff(addAssignment_81987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145949(VarCurr,B)
      <=> v145951(VarCurr,B) ) ) ).

tff(addAssignment_81986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145951(VarCurr,B)
      <=> v145955(VarCurr,B) ) ) ).

tff(addAssignment_81985,axiom,
    ! [VarCurr: state_type] :
      ( ( v145951(VarCurr,11)
      <=> v145953(VarCurr,5) )
      & ( v145951(VarCurr,10)
      <=> v145953(VarCurr,4) )
      & ( v145951(VarCurr,9)
      <=> v145953(VarCurr,3) )
      & ( v145951(VarCurr,8)
      <=> v145953(VarCurr,2) )
      & ( v145951(VarCurr,7)
      <=> v145953(VarCurr,1) )
      & ( v145951(VarCurr,6)
      <=> v145953(VarCurr,0) ) ) ).

tff(addAssignment_81984,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,0)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81983,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,1)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81982,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,2)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81981,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,3)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81980,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,4)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81979,axiom,
    ! [VarCurr: state_type] :
      ( v145955(VarCurr,5)
    <=> v145956(VarCurr) ) ).

tff(addAssignment_81978,axiom,
    ! [VarCurr: state_type] :
      ( v145956(VarCurr)
    <=> v95607(VarCurr,0) ) ).

tff(addAssignment_81977,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,0)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81976,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,1)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81975,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,2)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81974,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,3)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81973,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,4)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81972,axiom,
    ! [VarCurr: state_type] :
      ( v145953(VarCurr,5)
    <=> v145954(VarCurr) ) ).

tff(addAssignment_81971,axiom,
    ! [VarCurr: state_type] :
      ( v145954(VarCurr)
    <=> v95607(VarCurr,1) ) ).

tff(addAssignment_81970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145945(VarCurr,B)
      <=> v145947(VarCurr,B) ) ) ).

tff(addAssignment_81969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145947(VarCurr,B)
      <=> v46299(VarCurr,B) ) ) ).

tff(addAssignment_81968,axiom,
    ! [VarCurr: state_type] :
      ( v145919(VarCurr)
    <=> v145921(VarCurr) ) ).

tff(addAssignment_81967,axiom,
    ! [VarCurr: state_type] :
      ( v145921(VarCurr)
    <=> v145923(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2219,axiom,
    ! [VarCurr: state_type] :
      ( v145923(VarCurr)
    <=> ( ( v145925(VarCurr,11)
        <=> v145929(VarCurr,11) )
        & ( v145925(VarCurr,10)
        <=> v145929(VarCurr,10) )
        & ( v145925(VarCurr,9)
        <=> v145929(VarCurr,9) )
        & ( v145925(VarCurr,8)
        <=> v145929(VarCurr,8) )
        & ( v145925(VarCurr,7)
        <=> v145929(VarCurr,7) )
        & ( v145925(VarCurr,6)
        <=> v145929(VarCurr,6) )
        & ( v145925(VarCurr,5)
        <=> v145929(VarCurr,5) )
        & ( v145925(VarCurr,4)
        <=> v145929(VarCurr,4) )
        & ( v145925(VarCurr,3)
        <=> v145929(VarCurr,3) )
        & ( v145925(VarCurr,2)
        <=> v145929(VarCurr,2) )
        & ( v145925(VarCurr,1)
        <=> v145929(VarCurr,1) )
        & ( v145925(VarCurr,0)
        <=> v145929(VarCurr,0) ) ) ) ).

tff(addAssignment_81966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145929(VarCurr,B)
      <=> v145931(VarCurr,B) ) ) ).

tff(addAssignment_81965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145931(VarCurr,B)
      <=> v145935(VarCurr,B) ) ) ).

tff(addAssignment_81964,axiom,
    ! [VarCurr: state_type] :
      ( ( v145931(VarCurr,11)
      <=> v145933(VarCurr,5) )
      & ( v145931(VarCurr,10)
      <=> v145933(VarCurr,4) )
      & ( v145931(VarCurr,9)
      <=> v145933(VarCurr,3) )
      & ( v145931(VarCurr,8)
      <=> v145933(VarCurr,2) )
      & ( v145931(VarCurr,7)
      <=> v145933(VarCurr,1) )
      & ( v145931(VarCurr,6)
      <=> v145933(VarCurr,0) ) ) ).

tff(addAssignment_81963,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,0)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81962,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,1)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81961,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,2)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81960,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,3)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81959,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,4)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81958,axiom,
    ! [VarCurr: state_type] :
      ( v145935(VarCurr,5)
    <=> v145936(VarCurr) ) ).

tff(addAssignment_81957,axiom,
    ! [VarCurr: state_type] :
      ( v145936(VarCurr)
    <=> v95564(VarCurr,0) ) ).

tff(addAssignment_81956,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,0)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81955,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,1)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81954,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,2)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81953,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,3)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81952,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,4)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81951,axiom,
    ! [VarCurr: state_type] :
      ( v145933(VarCurr,5)
    <=> v145934(VarCurr) ) ).

tff(addAssignment_81950,axiom,
    ! [VarCurr: state_type] :
      ( v145934(VarCurr)
    <=> v95564(VarCurr,1) ) ).

tff(addAssignment_81949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145925(VarCurr,B)
      <=> v145927(VarCurr,B) ) ) ).

tff(addAssignment_81948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145927(VarCurr,B)
      <=> v44749(VarCurr,B) ) ) ).

tff(addAssignment_81947,axiom,
    ! [VarCurr: state_type] :
      ( v145899(VarCurr)
    <=> v145901(VarCurr) ) ).

tff(addAssignment_81946,axiom,
    ! [VarCurr: state_type] :
      ( v145901(VarCurr)
    <=> v145903(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2218,axiom,
    ! [VarCurr: state_type] :
      ( v145903(VarCurr)
    <=> ( ( v145905(VarCurr,11)
        <=> v145909(VarCurr,11) )
        & ( v145905(VarCurr,10)
        <=> v145909(VarCurr,10) )
        & ( v145905(VarCurr,9)
        <=> v145909(VarCurr,9) )
        & ( v145905(VarCurr,8)
        <=> v145909(VarCurr,8) )
        & ( v145905(VarCurr,7)
        <=> v145909(VarCurr,7) )
        & ( v145905(VarCurr,6)
        <=> v145909(VarCurr,6) )
        & ( v145905(VarCurr,5)
        <=> v145909(VarCurr,5) )
        & ( v145905(VarCurr,4)
        <=> v145909(VarCurr,4) )
        & ( v145905(VarCurr,3)
        <=> v145909(VarCurr,3) )
        & ( v145905(VarCurr,2)
        <=> v145909(VarCurr,2) )
        & ( v145905(VarCurr,1)
        <=> v145909(VarCurr,1) )
        & ( v145905(VarCurr,0)
        <=> v145909(VarCurr,0) ) ) ) ).

tff(addAssignment_81945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145909(VarCurr,B)
      <=> v145911(VarCurr,B) ) ) ).

tff(addAssignment_81944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145911(VarCurr,B)
      <=> v145915(VarCurr,B) ) ) ).

tff(addAssignment_81943,axiom,
    ! [VarCurr: state_type] :
      ( ( v145911(VarCurr,11)
      <=> v145913(VarCurr,5) )
      & ( v145911(VarCurr,10)
      <=> v145913(VarCurr,4) )
      & ( v145911(VarCurr,9)
      <=> v145913(VarCurr,3) )
      & ( v145911(VarCurr,8)
      <=> v145913(VarCurr,2) )
      & ( v145911(VarCurr,7)
      <=> v145913(VarCurr,1) )
      & ( v145911(VarCurr,6)
      <=> v145913(VarCurr,0) ) ) ).

tff(addAssignment_81942,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,0)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81941,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,1)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81940,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,2)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81939,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,3)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81938,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,4)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81937,axiom,
    ! [VarCurr: state_type] :
      ( v145915(VarCurr,5)
    <=> v145916(VarCurr) ) ).

tff(addAssignment_81936,axiom,
    ! [VarCurr: state_type] :
      ( v145916(VarCurr)
    <=> v95521(VarCurr,0) ) ).

tff(addAssignment_81935,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,0)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81934,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,1)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81933,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,2)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81932,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,3)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81931,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,4)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81930,axiom,
    ! [VarCurr: state_type] :
      ( v145913(VarCurr,5)
    <=> v145914(VarCurr) ) ).

tff(addAssignment_81929,axiom,
    ! [VarCurr: state_type] :
      ( v145914(VarCurr)
    <=> v95521(VarCurr,1) ) ).

tff(addAssignment_81928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145905(VarCurr,B)
      <=> v145907(VarCurr,B) ) ) ).

tff(addAssignment_81927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145907(VarCurr,B)
      <=> v43199(VarCurr,B) ) ) ).

tff(addAssignment_81926,axiom,
    ! [VarCurr: state_type] :
      ( v145879(VarCurr)
    <=> v145881(VarCurr) ) ).

tff(addAssignment_81925,axiom,
    ! [VarCurr: state_type] :
      ( v145881(VarCurr)
    <=> v145883(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2217,axiom,
    ! [VarCurr: state_type] :
      ( v145883(VarCurr)
    <=> ( ( v145885(VarCurr,11)
        <=> v145889(VarCurr,11) )
        & ( v145885(VarCurr,10)
        <=> v145889(VarCurr,10) )
        & ( v145885(VarCurr,9)
        <=> v145889(VarCurr,9) )
        & ( v145885(VarCurr,8)
        <=> v145889(VarCurr,8) )
        & ( v145885(VarCurr,7)
        <=> v145889(VarCurr,7) )
        & ( v145885(VarCurr,6)
        <=> v145889(VarCurr,6) )
        & ( v145885(VarCurr,5)
        <=> v145889(VarCurr,5) )
        & ( v145885(VarCurr,4)
        <=> v145889(VarCurr,4) )
        & ( v145885(VarCurr,3)
        <=> v145889(VarCurr,3) )
        & ( v145885(VarCurr,2)
        <=> v145889(VarCurr,2) )
        & ( v145885(VarCurr,1)
        <=> v145889(VarCurr,1) )
        & ( v145885(VarCurr,0)
        <=> v145889(VarCurr,0) ) ) ) ).

tff(addAssignment_81924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145889(VarCurr,B)
      <=> v145891(VarCurr,B) ) ) ).

tff(addAssignment_81923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145891(VarCurr,B)
      <=> v145895(VarCurr,B) ) ) ).

tff(addAssignment_81922,axiom,
    ! [VarCurr: state_type] :
      ( ( v145891(VarCurr,11)
      <=> v145893(VarCurr,5) )
      & ( v145891(VarCurr,10)
      <=> v145893(VarCurr,4) )
      & ( v145891(VarCurr,9)
      <=> v145893(VarCurr,3) )
      & ( v145891(VarCurr,8)
      <=> v145893(VarCurr,2) )
      & ( v145891(VarCurr,7)
      <=> v145893(VarCurr,1) )
      & ( v145891(VarCurr,6)
      <=> v145893(VarCurr,0) ) ) ).

tff(addAssignment_81921,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,0)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81920,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,1)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81919,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,2)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81918,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,3)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81917,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,4)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81916,axiom,
    ! [VarCurr: state_type] :
      ( v145895(VarCurr,5)
    <=> v145896(VarCurr) ) ).

tff(addAssignment_81915,axiom,
    ! [VarCurr: state_type] :
      ( v145896(VarCurr)
    <=> v95478(VarCurr,0) ) ).

tff(addAssignment_81914,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,0)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81913,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,1)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81912,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,2)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81911,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,3)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81910,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,4)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81909,axiom,
    ! [VarCurr: state_type] :
      ( v145893(VarCurr,5)
    <=> v145894(VarCurr) ) ).

tff(addAssignment_81908,axiom,
    ! [VarCurr: state_type] :
      ( v145894(VarCurr)
    <=> v95478(VarCurr,1) ) ).

tff(addAssignment_81907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145885(VarCurr,B)
      <=> v145887(VarCurr,B) ) ) ).

tff(addAssignment_81906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145887(VarCurr,B)
      <=> v41649(VarCurr,B) ) ) ).

tff(addAssignment_81905,axiom,
    ! [VarCurr: state_type] :
      ( v145859(VarCurr)
    <=> v145861(VarCurr) ) ).

tff(addAssignment_81904,axiom,
    ! [VarCurr: state_type] :
      ( v145861(VarCurr)
    <=> v145863(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2216,axiom,
    ! [VarCurr: state_type] :
      ( v145863(VarCurr)
    <=> ( ( v145865(VarCurr,11)
        <=> v145869(VarCurr,11) )
        & ( v145865(VarCurr,10)
        <=> v145869(VarCurr,10) )
        & ( v145865(VarCurr,9)
        <=> v145869(VarCurr,9) )
        & ( v145865(VarCurr,8)
        <=> v145869(VarCurr,8) )
        & ( v145865(VarCurr,7)
        <=> v145869(VarCurr,7) )
        & ( v145865(VarCurr,6)
        <=> v145869(VarCurr,6) )
        & ( v145865(VarCurr,5)
        <=> v145869(VarCurr,5) )
        & ( v145865(VarCurr,4)
        <=> v145869(VarCurr,4) )
        & ( v145865(VarCurr,3)
        <=> v145869(VarCurr,3) )
        & ( v145865(VarCurr,2)
        <=> v145869(VarCurr,2) )
        & ( v145865(VarCurr,1)
        <=> v145869(VarCurr,1) )
        & ( v145865(VarCurr,0)
        <=> v145869(VarCurr,0) ) ) ) ).

tff(addAssignment_81903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145869(VarCurr,B)
      <=> v145871(VarCurr,B) ) ) ).

tff(addAssignment_81902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145871(VarCurr,B)
      <=> v145875(VarCurr,B) ) ) ).

tff(addAssignment_81901,axiom,
    ! [VarCurr: state_type] :
      ( ( v145871(VarCurr,11)
      <=> v145873(VarCurr,5) )
      & ( v145871(VarCurr,10)
      <=> v145873(VarCurr,4) )
      & ( v145871(VarCurr,9)
      <=> v145873(VarCurr,3) )
      & ( v145871(VarCurr,8)
      <=> v145873(VarCurr,2) )
      & ( v145871(VarCurr,7)
      <=> v145873(VarCurr,1) )
      & ( v145871(VarCurr,6)
      <=> v145873(VarCurr,0) ) ) ).

tff(addAssignment_81900,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,0)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81899,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,1)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81898,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,2)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81897,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,3)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81896,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,4)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81895,axiom,
    ! [VarCurr: state_type] :
      ( v145875(VarCurr,5)
    <=> v145876(VarCurr) ) ).

tff(addAssignment_81894,axiom,
    ! [VarCurr: state_type] :
      ( v145876(VarCurr)
    <=> v95435(VarCurr,0) ) ).

tff(addAssignment_81893,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,0)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81892,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,1)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81891,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,2)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81890,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,3)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81889,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,4)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81888,axiom,
    ! [VarCurr: state_type] :
      ( v145873(VarCurr,5)
    <=> v145874(VarCurr) ) ).

tff(addAssignment_81887,axiom,
    ! [VarCurr: state_type] :
      ( v145874(VarCurr)
    <=> v95435(VarCurr,1) ) ).

tff(addAssignment_81886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145865(VarCurr,B)
      <=> v145867(VarCurr,B) ) ) ).

tff(addAssignment_81885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145867(VarCurr,B)
      <=> v40099(VarCurr,B) ) ) ).

tff(addAssignment_81884,axiom,
    ! [VarCurr: state_type] :
      ( v145839(VarCurr)
    <=> v145841(VarCurr) ) ).

tff(addAssignment_81883,axiom,
    ! [VarCurr: state_type] :
      ( v145841(VarCurr)
    <=> v145843(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2215,axiom,
    ! [VarCurr: state_type] :
      ( v145843(VarCurr)
    <=> ( ( v145845(VarCurr,11)
        <=> v145849(VarCurr,11) )
        & ( v145845(VarCurr,10)
        <=> v145849(VarCurr,10) )
        & ( v145845(VarCurr,9)
        <=> v145849(VarCurr,9) )
        & ( v145845(VarCurr,8)
        <=> v145849(VarCurr,8) )
        & ( v145845(VarCurr,7)
        <=> v145849(VarCurr,7) )
        & ( v145845(VarCurr,6)
        <=> v145849(VarCurr,6) )
        & ( v145845(VarCurr,5)
        <=> v145849(VarCurr,5) )
        & ( v145845(VarCurr,4)
        <=> v145849(VarCurr,4) )
        & ( v145845(VarCurr,3)
        <=> v145849(VarCurr,3) )
        & ( v145845(VarCurr,2)
        <=> v145849(VarCurr,2) )
        & ( v145845(VarCurr,1)
        <=> v145849(VarCurr,1) )
        & ( v145845(VarCurr,0)
        <=> v145849(VarCurr,0) ) ) ) ).

tff(addAssignment_81882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145849(VarCurr,B)
      <=> v145851(VarCurr,B) ) ) ).

tff(addAssignment_81881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145851(VarCurr,B)
      <=> v145855(VarCurr,B) ) ) ).

tff(addAssignment_81880,axiom,
    ! [VarCurr: state_type] :
      ( ( v145851(VarCurr,11)
      <=> v145853(VarCurr,5) )
      & ( v145851(VarCurr,10)
      <=> v145853(VarCurr,4) )
      & ( v145851(VarCurr,9)
      <=> v145853(VarCurr,3) )
      & ( v145851(VarCurr,8)
      <=> v145853(VarCurr,2) )
      & ( v145851(VarCurr,7)
      <=> v145853(VarCurr,1) )
      & ( v145851(VarCurr,6)
      <=> v145853(VarCurr,0) ) ) ).

tff(addAssignment_81879,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,0)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81878,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,1)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81877,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,2)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81876,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,3)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81875,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,4)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81874,axiom,
    ! [VarCurr: state_type] :
      ( v145855(VarCurr,5)
    <=> v145856(VarCurr) ) ).

tff(addAssignment_81873,axiom,
    ! [VarCurr: state_type] :
      ( v145856(VarCurr)
    <=> v95392(VarCurr,0) ) ).

tff(addAssignment_81872,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,0)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81871,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,1)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81870,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,2)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81869,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,3)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81868,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,4)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81867,axiom,
    ! [VarCurr: state_type] :
      ( v145853(VarCurr,5)
    <=> v145854(VarCurr) ) ).

tff(addAssignment_81866,axiom,
    ! [VarCurr: state_type] :
      ( v145854(VarCurr)
    <=> v95392(VarCurr,1) ) ).

tff(addAssignment_81865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145845(VarCurr,B)
      <=> v145847(VarCurr,B) ) ) ).

tff(addAssignment_81864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145847(VarCurr,B)
      <=> v38549(VarCurr,B) ) ) ).

tff(addAssignment_81863,axiom,
    ! [VarCurr: state_type] :
      ( v145819(VarCurr)
    <=> v145821(VarCurr) ) ).

tff(addAssignment_81862,axiom,
    ! [VarCurr: state_type] :
      ( v145821(VarCurr)
    <=> v145823(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2214,axiom,
    ! [VarCurr: state_type] :
      ( v145823(VarCurr)
    <=> ( ( v145825(VarCurr,11)
        <=> v145829(VarCurr,11) )
        & ( v145825(VarCurr,10)
        <=> v145829(VarCurr,10) )
        & ( v145825(VarCurr,9)
        <=> v145829(VarCurr,9) )
        & ( v145825(VarCurr,8)
        <=> v145829(VarCurr,8) )
        & ( v145825(VarCurr,7)
        <=> v145829(VarCurr,7) )
        & ( v145825(VarCurr,6)
        <=> v145829(VarCurr,6) )
        & ( v145825(VarCurr,5)
        <=> v145829(VarCurr,5) )
        & ( v145825(VarCurr,4)
        <=> v145829(VarCurr,4) )
        & ( v145825(VarCurr,3)
        <=> v145829(VarCurr,3) )
        & ( v145825(VarCurr,2)
        <=> v145829(VarCurr,2) )
        & ( v145825(VarCurr,1)
        <=> v145829(VarCurr,1) )
        & ( v145825(VarCurr,0)
        <=> v145829(VarCurr,0) ) ) ) ).

tff(addAssignment_81861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145829(VarCurr,B)
      <=> v145831(VarCurr,B) ) ) ).

tff(addAssignment_81860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145831(VarCurr,B)
      <=> v145835(VarCurr,B) ) ) ).

tff(addAssignment_81859,axiom,
    ! [VarCurr: state_type] :
      ( ( v145831(VarCurr,11)
      <=> v145833(VarCurr,5) )
      & ( v145831(VarCurr,10)
      <=> v145833(VarCurr,4) )
      & ( v145831(VarCurr,9)
      <=> v145833(VarCurr,3) )
      & ( v145831(VarCurr,8)
      <=> v145833(VarCurr,2) )
      & ( v145831(VarCurr,7)
      <=> v145833(VarCurr,1) )
      & ( v145831(VarCurr,6)
      <=> v145833(VarCurr,0) ) ) ).

tff(addAssignment_81858,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,0)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81857,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,1)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81856,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,2)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81855,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,3)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81854,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,4)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81853,axiom,
    ! [VarCurr: state_type] :
      ( v145835(VarCurr,5)
    <=> v145836(VarCurr) ) ).

tff(addAssignment_81852,axiom,
    ! [VarCurr: state_type] :
      ( v145836(VarCurr)
    <=> v95349(VarCurr,0) ) ).

tff(addAssignment_81851,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,0)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81850,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,1)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81849,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,2)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81848,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,3)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81847,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,4)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81846,axiom,
    ! [VarCurr: state_type] :
      ( v145833(VarCurr,5)
    <=> v145834(VarCurr) ) ).

tff(addAssignment_81845,axiom,
    ! [VarCurr: state_type] :
      ( v145834(VarCurr)
    <=> v95349(VarCurr,1) ) ).

tff(addAssignment_81844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145825(VarCurr,B)
      <=> v145827(VarCurr,B) ) ) ).

tff(addAssignment_81843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145827(VarCurr,B)
      <=> v36999(VarCurr,B) ) ) ).

tff(addAssignment_81842,axiom,
    ! [VarCurr: state_type] :
      ( v145799(VarCurr)
    <=> v145801(VarCurr) ) ).

tff(addAssignment_81841,axiom,
    ! [VarCurr: state_type] :
      ( v145801(VarCurr)
    <=> v145803(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2213,axiom,
    ! [VarCurr: state_type] :
      ( v145803(VarCurr)
    <=> ( ( v145805(VarCurr,11)
        <=> v145809(VarCurr,11) )
        & ( v145805(VarCurr,10)
        <=> v145809(VarCurr,10) )
        & ( v145805(VarCurr,9)
        <=> v145809(VarCurr,9) )
        & ( v145805(VarCurr,8)
        <=> v145809(VarCurr,8) )
        & ( v145805(VarCurr,7)
        <=> v145809(VarCurr,7) )
        & ( v145805(VarCurr,6)
        <=> v145809(VarCurr,6) )
        & ( v145805(VarCurr,5)
        <=> v145809(VarCurr,5) )
        & ( v145805(VarCurr,4)
        <=> v145809(VarCurr,4) )
        & ( v145805(VarCurr,3)
        <=> v145809(VarCurr,3) )
        & ( v145805(VarCurr,2)
        <=> v145809(VarCurr,2) )
        & ( v145805(VarCurr,1)
        <=> v145809(VarCurr,1) )
        & ( v145805(VarCurr,0)
        <=> v145809(VarCurr,0) ) ) ) ).

tff(addAssignment_81840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145809(VarCurr,B)
      <=> v145811(VarCurr,B) ) ) ).

tff(addAssignment_81839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145811(VarCurr,B)
      <=> v145815(VarCurr,B) ) ) ).

tff(addAssignment_81838,axiom,
    ! [VarCurr: state_type] :
      ( ( v145811(VarCurr,11)
      <=> v145813(VarCurr,5) )
      & ( v145811(VarCurr,10)
      <=> v145813(VarCurr,4) )
      & ( v145811(VarCurr,9)
      <=> v145813(VarCurr,3) )
      & ( v145811(VarCurr,8)
      <=> v145813(VarCurr,2) )
      & ( v145811(VarCurr,7)
      <=> v145813(VarCurr,1) )
      & ( v145811(VarCurr,6)
      <=> v145813(VarCurr,0) ) ) ).

tff(addAssignment_81837,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,0)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81836,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,1)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81835,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,2)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81834,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,3)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81833,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,4)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81832,axiom,
    ! [VarCurr: state_type] :
      ( v145815(VarCurr,5)
    <=> v145816(VarCurr) ) ).

tff(addAssignment_81831,axiom,
    ! [VarCurr: state_type] :
      ( v145816(VarCurr)
    <=> v95306(VarCurr,0) ) ).

tff(addAssignment_81830,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,0)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81829,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,1)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81828,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,2)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81827,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,3)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81826,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,4)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81825,axiom,
    ! [VarCurr: state_type] :
      ( v145813(VarCurr,5)
    <=> v145814(VarCurr) ) ).

tff(addAssignment_81824,axiom,
    ! [VarCurr: state_type] :
      ( v145814(VarCurr)
    <=> v95306(VarCurr,1) ) ).

tff(addAssignment_81823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145805(VarCurr,B)
      <=> v145807(VarCurr,B) ) ) ).

tff(addAssignment_81822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145807(VarCurr,B)
      <=> v35449(VarCurr,B) ) ) ).

tff(addAssignment_81821,axiom,
    ! [VarCurr: state_type] :
      ( v145779(VarCurr)
    <=> v145781(VarCurr) ) ).

tff(addAssignment_81820,axiom,
    ! [VarCurr: state_type] :
      ( v145781(VarCurr)
    <=> v145783(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2212,axiom,
    ! [VarCurr: state_type] :
      ( v145783(VarCurr)
    <=> ( ( v145785(VarCurr,11)
        <=> v145789(VarCurr,11) )
        & ( v145785(VarCurr,10)
        <=> v145789(VarCurr,10) )
        & ( v145785(VarCurr,9)
        <=> v145789(VarCurr,9) )
        & ( v145785(VarCurr,8)
        <=> v145789(VarCurr,8) )
        & ( v145785(VarCurr,7)
        <=> v145789(VarCurr,7) )
        & ( v145785(VarCurr,6)
        <=> v145789(VarCurr,6) )
        & ( v145785(VarCurr,5)
        <=> v145789(VarCurr,5) )
        & ( v145785(VarCurr,4)
        <=> v145789(VarCurr,4) )
        & ( v145785(VarCurr,3)
        <=> v145789(VarCurr,3) )
        & ( v145785(VarCurr,2)
        <=> v145789(VarCurr,2) )
        & ( v145785(VarCurr,1)
        <=> v145789(VarCurr,1) )
        & ( v145785(VarCurr,0)
        <=> v145789(VarCurr,0) ) ) ) ).

tff(addAssignment_81819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145789(VarCurr,B)
      <=> v145791(VarCurr,B) ) ) ).

tff(addAssignment_81818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145791(VarCurr,B)
      <=> v145795(VarCurr,B) ) ) ).

tff(addAssignment_81817,axiom,
    ! [VarCurr: state_type] :
      ( ( v145791(VarCurr,11)
      <=> v145793(VarCurr,5) )
      & ( v145791(VarCurr,10)
      <=> v145793(VarCurr,4) )
      & ( v145791(VarCurr,9)
      <=> v145793(VarCurr,3) )
      & ( v145791(VarCurr,8)
      <=> v145793(VarCurr,2) )
      & ( v145791(VarCurr,7)
      <=> v145793(VarCurr,1) )
      & ( v145791(VarCurr,6)
      <=> v145793(VarCurr,0) ) ) ).

tff(addAssignment_81816,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,0)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81815,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,1)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81814,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,2)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81813,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,3)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81812,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,4)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81811,axiom,
    ! [VarCurr: state_type] :
      ( v145795(VarCurr,5)
    <=> v145796(VarCurr) ) ).

tff(addAssignment_81810,axiom,
    ! [VarCurr: state_type] :
      ( v145796(VarCurr)
    <=> v95263(VarCurr,0) ) ).

tff(addAssignment_81809,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,0)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81808,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,1)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81807,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,2)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81806,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,3)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81805,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,4)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81804,axiom,
    ! [VarCurr: state_type] :
      ( v145793(VarCurr,5)
    <=> v145794(VarCurr) ) ).

tff(addAssignment_81803,axiom,
    ! [VarCurr: state_type] :
      ( v145794(VarCurr)
    <=> v95263(VarCurr,1) ) ).

tff(addAssignment_81802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145785(VarCurr,B)
      <=> v145787(VarCurr,B) ) ) ).

tff(addAssignment_81801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145787(VarCurr,B)
      <=> v8510(VarCurr,B) ) ) ).

tff(addAssignment_81800,axiom,
    ! [VarCurr: state_type] :
      ( v145759(VarCurr)
    <=> v145761(VarCurr) ) ).

tff(addAssignment_81799,axiom,
    ! [VarCurr: state_type] :
      ( v145761(VarCurr)
    <=> v145763(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2211,axiom,
    ! [VarCurr: state_type] :
      ( v145763(VarCurr)
    <=> ( ( v145765(VarCurr,11)
        <=> v145769(VarCurr,11) )
        & ( v145765(VarCurr,10)
        <=> v145769(VarCurr,10) )
        & ( v145765(VarCurr,9)
        <=> v145769(VarCurr,9) )
        & ( v145765(VarCurr,8)
        <=> v145769(VarCurr,8) )
        & ( v145765(VarCurr,7)
        <=> v145769(VarCurr,7) )
        & ( v145765(VarCurr,6)
        <=> v145769(VarCurr,6) )
        & ( v145765(VarCurr,5)
        <=> v145769(VarCurr,5) )
        & ( v145765(VarCurr,4)
        <=> v145769(VarCurr,4) )
        & ( v145765(VarCurr,3)
        <=> v145769(VarCurr,3) )
        & ( v145765(VarCurr,2)
        <=> v145769(VarCurr,2) )
        & ( v145765(VarCurr,1)
        <=> v145769(VarCurr,1) )
        & ( v145765(VarCurr,0)
        <=> v145769(VarCurr,0) ) ) ) ).

tff(addAssignment_81798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145769(VarCurr,B)
      <=> v145771(VarCurr,B) ) ) ).

tff(addAssignment_81797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145771(VarCurr,B)
      <=> v145775(VarCurr,B) ) ) ).

tff(addAssignment_81796,axiom,
    ! [VarCurr: state_type] :
      ( ( v145771(VarCurr,11)
      <=> v145773(VarCurr,5) )
      & ( v145771(VarCurr,10)
      <=> v145773(VarCurr,4) )
      & ( v145771(VarCurr,9)
      <=> v145773(VarCurr,3) )
      & ( v145771(VarCurr,8)
      <=> v145773(VarCurr,2) )
      & ( v145771(VarCurr,7)
      <=> v145773(VarCurr,1) )
      & ( v145771(VarCurr,6)
      <=> v145773(VarCurr,0) ) ) ).

tff(addAssignment_81795,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,0)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81794,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,1)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81793,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,2)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81792,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,3)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81791,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,4)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81790,axiom,
    ! [VarCurr: state_type] :
      ( v145775(VarCurr,5)
    <=> v145776(VarCurr) ) ).

tff(addAssignment_81789,axiom,
    ! [VarCurr: state_type] :
      ( v145776(VarCurr)
    <=> v95214(VarCurr,0) ) ).

tff(addAssignment_81788,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,0)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81787,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,1)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81786,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,2)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81785,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,3)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81784,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,4)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81783,axiom,
    ! [VarCurr: state_type] :
      ( v145773(VarCurr,5)
    <=> v145774(VarCurr) ) ).

tff(addAssignment_81782,axiom,
    ! [VarCurr: state_type] :
      ( v145774(VarCurr)
    <=> v95214(VarCurr,1) ) ).

tff(addAssignment_81781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145765(VarCurr,B)
      <=> v145767(VarCurr,B) ) ) ).

tff(addAssignment_81780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145767(VarCurr,B)
      <=> v6242(VarCurr,B) ) ) ).

tff(addAssignment_81779,axiom,
    ! [VarCurr: state_type] :
      ( v4111(VarCurr)
    <=> v4113(VarCurr) ) ).

tff(addAssignment_81778,axiom,
    ! [VarCurr: state_type] :
      ( v4113(VarCurr)
    <=> v4115(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2210,axiom,
    ! [VarCurr: state_type] :
      ( v4115(VarCurr)
    <=> ( ( v4117(VarCurr,11)
        <=> v145749(VarCurr,11) )
        & ( v4117(VarCurr,10)
        <=> v145749(VarCurr,10) )
        & ( v4117(VarCurr,9)
        <=> v145749(VarCurr,9) )
        & ( v4117(VarCurr,8)
        <=> v145749(VarCurr,8) )
        & ( v4117(VarCurr,7)
        <=> v145749(VarCurr,7) )
        & ( v4117(VarCurr,6)
        <=> v145749(VarCurr,6) )
        & ( v4117(VarCurr,5)
        <=> v145749(VarCurr,5) )
        & ( v4117(VarCurr,4)
        <=> v145749(VarCurr,4) )
        & ( v4117(VarCurr,3)
        <=> v145749(VarCurr,3) )
        & ( v4117(VarCurr,2)
        <=> v145749(VarCurr,2) )
        & ( v4117(VarCurr,1)
        <=> v145749(VarCurr,1) )
        & ( v4117(VarCurr,0)
        <=> v145749(VarCurr,0) ) ) ) ).

tff(addAssignment_81777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145749(VarCurr,B)
      <=> v145751(VarCurr,B) ) ) ).

tff(addAssignment_81776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v145751(VarCurr,B)
      <=> v145755(VarCurr,B) ) ) ).

tff(addAssignment_81775,axiom,
    ! [VarCurr: state_type] :
      ( ( v145751(VarCurr,11)
      <=> v145753(VarCurr,5) )
      & ( v145751(VarCurr,10)
      <=> v145753(VarCurr,4) )
      & ( v145751(VarCurr,9)
      <=> v145753(VarCurr,3) )
      & ( v145751(VarCurr,8)
      <=> v145753(VarCurr,2) )
      & ( v145751(VarCurr,7)
      <=> v145753(VarCurr,1) )
      & ( v145751(VarCurr,6)
      <=> v145753(VarCurr,0) ) ) ).

tff(addAssignment_81774,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,0)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81773,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,1)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81772,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,2)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81771,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,3)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81770,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,4)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81769,axiom,
    ! [VarCurr: state_type] :
      ( v145755(VarCurr,5)
    <=> v145756(VarCurr) ) ).

tff(addAssignment_81768,axiom,
    ! [VarCurr: state_type] :
      ( v145756(VarCurr)
    <=> v94838(VarCurr,0) ) ).

tff(addAssignment_81767,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,0)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81766,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,1)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81765,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,2)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81764,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,3)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81763,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,4)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81762,axiom,
    ! [VarCurr: state_type] :
      ( v145753(VarCurr,5)
    <=> v145754(VarCurr) ) ).

tff(addAssignment_81761,axiom,
    ! [VarCurr: state_type] :
      ( v145754(VarCurr)
    <=> v94838(VarCurr,1) ) ).

tff(addAssignment_81760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4117(VarCurr,B)
      <=> v4119(VarCurr,B) ) ) ).

tff(addAssignment_81759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4119(VarCurr,B)
      <=> v4121(VarCurr,B) ) ) ).

tff(addAssignment_81758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4121(VarCurr,B)
      <=> v4123(VarCurr,B) ) ) ).

tff(addAssignment_81757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4123(VarCurr,B)
      <=> v4125(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4125(VarCurr,B)
      <=> ( v145726(VarCurr,B)
          | v145745(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145745(VarCurr,B)
      <=> ( v145597(VarCurr,B)
          & v145746(VarCurr,B) ) ) ) ).

tff(addAssignment_81756,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,0)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81755,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,1)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81754,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,2)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81753,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,3)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81752,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,4)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81751,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,5)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81750,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,6)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81749,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,7)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81748,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,8)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81747,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,9)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81746,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,10)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81745,axiom,
    ! [VarCurr: state_type] :
      ( v145746(VarCurr,11)
    <=> v145747(VarCurr) ) ).

tff(addAssignment_81744,axiom,
    ! [VarCurr: state_type] :
      ( v145747(VarCurr)
    <=> v145716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145726(VarCurr,B)
      <=> ( v145727(VarCurr,B)
          | v145742(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145742(VarCurr,B)
      <=> ( v145446(VarCurr,B)
          & v145743(VarCurr,B) ) ) ) ).

tff(addAssignment_81743,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,0)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81742,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,1)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81741,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,2)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81740,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,3)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81739,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,4)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81738,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,5)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81737,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,6)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81736,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,7)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81735,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,8)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81734,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,9)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81733,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,10)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81732,axiom,
    ! [VarCurr: state_type] :
      ( v145743(VarCurr,11)
    <=> v145744(VarCurr) ) ).

tff(addAssignment_81731,axiom,
    ! [VarCurr: state_type] :
      ( v145744(VarCurr)
    <=> v145566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145727(VarCurr,B)
      <=> ( v145728(VarCurr,B)
          | v145739(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145739(VarCurr,B)
      <=> ( v145295(VarCurr,B)
          & v145740(VarCurr,B) ) ) ) ).

tff(addAssignment_81730,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,0)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81729,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,1)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81728,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,2)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81727,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,3)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81726,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,4)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81725,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,5)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81724,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,6)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81723,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,7)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81722,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,8)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81721,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,9)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81720,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,10)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81719,axiom,
    ! [VarCurr: state_type] :
      ( v145740(VarCurr,11)
    <=> v145741(VarCurr) ) ).

tff(addAssignment_81718,axiom,
    ! [VarCurr: state_type] :
      ( v145741(VarCurr)
    <=> v145415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145728(VarCurr,B)
      <=> ( v145729(VarCurr,B)
          | v145736(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145736(VarCurr,B)
      <=> ( v145144(VarCurr,B)
          & v145737(VarCurr,B) ) ) ) ).

tff(addAssignment_81717,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,0)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81716,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,1)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81715,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,2)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81714,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,3)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81713,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,4)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81712,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,5)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81711,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,6)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81710,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,7)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81709,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,8)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81708,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,9)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81707,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,10)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81706,axiom,
    ! [VarCurr: state_type] :
      ( v145737(VarCurr,11)
    <=> v145738(VarCurr) ) ).

tff(addAssignment_81705,axiom,
    ! [VarCurr: state_type] :
      ( v145738(VarCurr)
    <=> v145264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145729(VarCurr,B)
      <=> ( v145730(VarCurr,B)
          | v145733(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145733(VarCurr,B)
      <=> ( v144982(VarCurr,B)
          & v145734(VarCurr,B) ) ) ) ).

tff(addAssignment_81704,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,0)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81703,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,1)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81702,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,2)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81701,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,3)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81700,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,4)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81699,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,5)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81698,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,6)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81697,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,7)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81696,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,8)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81695,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,9)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81694,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,10)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81693,axiom,
    ! [VarCurr: state_type] :
      ( v145734(VarCurr,11)
    <=> v145735(VarCurr) ) ).

tff(addAssignment_81692,axiom,
    ! [VarCurr: state_type] :
      ( v145735(VarCurr)
    <=> v145113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145730(VarCurr,B)
      <=> ( v4127(VarCurr,B)
          & v145731(VarCurr,B) ) ) ) ).

tff(addAssignment_81691,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,0)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81690,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,1)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81689,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,2)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81688,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,3)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81687,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,4)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81686,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,5)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81685,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,6)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81684,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,7)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81683,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,8)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81682,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,9)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81681,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,10)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81680,axiom,
    ! [VarCurr: state_type] :
      ( v145731(VarCurr,11)
    <=> v145732(VarCurr) ) ).

tff(addAssignment_81679,axiom,
    ! [VarCurr: state_type] :
      ( v145732(VarCurr)
    <=> v144690(VarCurr) ) ).

tff(addAssignment_81678,axiom,
    ! [VarCurr: state_type] :
      ( v145716(VarCurr)
    <=> v145718(VarCurr) ) ).

tff(addAssignment_81677,axiom,
    ! [VarCurr: state_type] :
      ( v145718(VarCurr)
    <=> v145720(VarCurr) ) ).

tff(addAssignment_81676,axiom,
    ! [VarCurr: state_type] :
      ( v145720(VarCurr)
    <=> v145722(VarCurr) ) ).

tff(addAssignment_81675,axiom,
    ! [VarCurr: state_type] :
      ( v145722(VarCurr)
    <=> v145724(VarCurr) ) ).

tff(addAssignment_81674,axiom,
    ! [VarCurr: state_type] :
      ( v145724(VarCurr)
    <=> v144783(VarCurr) ) ).

tff(addAssignment_81673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145597(VarCurr,B)
      <=> v145599(VarCurr,B) ) ) ).

tff(addAssignment_81672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145599(VarCurr,B)
      <=> v145601(VarCurr,B) ) ) ).

tff(addAssignment_81671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145601(VarCurr,B)
      <=> v145603(VarCurr,B) ) ) ).

tff(addAssignment_81670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145603(VarCurr,B)
      <=> v145605(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145699(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v145605(VarNext,B)
            <=> v145605(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2063,axiom,
    ! [VarNext: state_type] :
      ( v145699(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145605(VarNext,B)
          <=> v145709(VarNext,B) ) ) ) ).

tff(addAssignment_81669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145709(VarNext,B)
          <=> v145707(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145707(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1599,axiom,
    ! [VarCurr: state_type] :
      ( v145710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145707(VarCurr,B)
          <=> v145627(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19399,axiom,
    ! [VarCurr: state_type] :
      ( v145710(VarCurr)
    <=> ( v145711(VarCurr)
        & v145712(VarCurr) ) ) ).

tff(writeUnaryOperator_11065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145712(VarCurr)
    <=> v145617(VarCurr) ) ).

tff(writeUnaryOperator_11064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145711(VarCurr)
    <=> v145607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145699(VarNext)
      <=> v145700(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145700(VarNext)
      <=> ( v145701(VarNext)
          & v145631(VarNext) ) ) ) ).

tff(writeUnaryOperator_11063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145701(VarNext)
      <=> v145703(VarNext) ) ) ).

tff(addAssignment_81668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145703(VarNext)
      <=> v145631(VarCurr) ) ) ).

tff(addAssignment_81667,axiom,
    ! [VarCurr: state_type] :
      ( v145631(VarCurr)
    <=> v145633(VarCurr) ) ).

tff(addAssignment_81666,axiom,
    ! [VarCurr: state_type] :
      ( v145633(VarCurr)
    <=> v145635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19396,axiom,
    ! [VarCurr: state_type] :
      ( v145635(VarCurr)
    <=> ( v145696(VarCurr)
        | v145692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19395,axiom,
    ! [VarCurr: state_type] :
      ( v145696(VarCurr)
    <=> ( v145637(VarCurr)
        & v145641(VarCurr) ) ) ).

tff(addAssignment_81665,axiom,
    ! [VarCurr: state_type] :
      ( v145692(VarCurr)
    <=> v145694(VarCurr) ) ).

tff(addAssignment_81664,axiom,
    ! [VarCurr: state_type] :
      ( v145694(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145676(VarNext)
       => ( v145641(VarNext)
        <=> v145641(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2062,axiom,
    ! [VarNext: state_type] :
      ( v145676(VarNext)
     => ( v145641(VarNext)
      <=> v145686(VarNext) ) ) ).

tff(addAssignment_81663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145686(VarNext)
      <=> v145684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19394,axiom,
    ! [VarCurr: state_type] :
      ( v145684(VarCurr)
    <=> ( v145687(VarCurr)
        & v145688(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19393,axiom,
    ! [VarCurr: state_type] :
      ( v145688(VarCurr)
    <=> ( v145647(VarCurr)
        | v145671(VarCurr) ) ) ).

tff(writeUnaryOperator_11062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145687(VarCurr)
    <=> v145643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145676(VarNext)
      <=> v145677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145677(VarNext)
      <=> ( v145679(VarNext)
          & v145681(VarNext) ) ) ) ).

tff(writeUnaryOperator_11061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145681(VarCurr)
    <=> v145637(VarCurr) ) ).

tff(addAssignment_81662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145679(VarNext)
      <=> v145637(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_273,axiom,
    ( v145641(constB0)
  <=> $true ) ).

tff(addAssignment_81661,axiom,
    ! [VarCurr: state_type] :
      ( v145671(VarCurr)
    <=> v145673(VarCurr) ) ).

tff(addAssignment_81660,axiom,
    ! [VarCurr: state_type] :
      ( v145673(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81659,axiom,
    ! [VarCurr: state_type] :
      ( v145647(VarCurr)
    <=> v145649(VarCurr) ) ).

tff(addAssignment_81658,axiom,
    ! [VarCurr: state_type] :
      ( v145649(VarCurr)
    <=> v144957(VarCurr) ) ).

tff(addAssignment_81657,axiom,
    ! [VarCurr: state_type] :
      ( v144957(VarCurr)
    <=> v145652(VarCurr) ) ).

tff(addAssignment_81656,axiom,
    ! [VarCurr: state_type] :
      ( v145652(VarCurr)
    <=> v145654(VarCurr) ) ).

tff(writeUnaryOperator_11060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145654(VarCurr)
    <=> v145668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19390,axiom,
    ! [VarCurr: state_type] :
      ( v145668(VarCurr)
    <=> ( v145669(VarCurr)
        | v145664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19389,axiom,
    ! [VarCurr: state_type] :
      ( v145669(VarCurr)
    <=> ( v145656(VarCurr)
        | v145660(VarCurr) ) ) ).

tff(addAssignment_81655,axiom,
    ! [VarCurr: state_type] :
      ( v145664(VarCurr)
    <=> v145666(VarCurr) ) ).

tff(addAssignment_81654,axiom,
    ! [VarCurr: state_type] :
      ( v145666(VarCurr)
    <=> v145046(VarCurr,2) ) ).

tff(addAssignment_81653,axiom,
    ! [VarCurr: state_type] :
      ( v145660(VarCurr)
    <=> v145662(VarCurr) ) ).

tff(addAssignment_81652,axiom,
    ! [VarCurr: state_type] :
      ( v145662(VarCurr)
    <=> v144620(VarCurr,1) ) ).

tff(addAssignment_81651,axiom,
    ! [VarCurr: state_type] :
      ( v145656(VarCurr)
    <=> v145658(VarCurr) ) ).

tff(addAssignment_81650,axiom,
    ! [VarCurr: state_type] :
      ( v145658(VarCurr)
    <=> v145046(VarCurr,0) ) ).

tff(addAssignment_81649,axiom,
    ! [VarCurr: state_type] :
      ( v145643(VarCurr)
    <=> v145645(VarCurr) ) ).

tff(addAssignment_81648,axiom,
    ! [VarCurr: state_type] :
      ( v145645(VarCurr)
    <=> $false ) ).

tff(addAssignment_81647,axiom,
    ! [VarCurr: state_type] :
      ( v145637(VarCurr)
    <=> v145639(VarCurr) ) ).

tff(addAssignment_81646,axiom,
    ! [VarCurr: state_type] :
      ( v145639(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145627(VarCurr,B)
      <=> v145629(VarCurr,B) ) ) ).

tff(addAssignment_81644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145629(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81643,axiom,
    ! [VarCurr: state_type] :
      ( v145617(VarCurr)
    <=> v145619(VarCurr) ) ).

tff(addAssignment_81642,axiom,
    ! [VarCurr: state_type] :
      ( v145619(VarCurr)
    <=> v145621(VarCurr) ) ).

tff(addAssignment_81641,axiom,
    ! [VarCurr: state_type] :
      ( v145621(VarCurr)
    <=> v145623(VarCurr) ) ).

tff(addAssignment_81640,axiom,
    ! [VarCurr: state_type] :
      ( v145623(VarCurr)
    <=> v145625(VarCurr) ) ).

tff(addAssignment_81639,axiom,
    ! [VarCurr: state_type] :
      ( v145625(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81638,axiom,
    ! [VarCurr: state_type] :
      ( v145607(VarCurr)
    <=> v145609(VarCurr) ) ).

tff(addAssignment_81637,axiom,
    ! [VarCurr: state_type] :
      ( v145609(VarCurr)
    <=> v145611(VarCurr) ) ).

tff(addAssignment_81636,axiom,
    ! [VarCurr: state_type] :
      ( v145611(VarCurr)
    <=> v145613(VarCurr) ) ).

tff(addAssignment_81635,axiom,
    ! [VarCurr: state_type] :
      ( v145613(VarCurr)
    <=> v145615(VarCurr) ) ).

tff(addAssignment_81634,axiom,
    ! [VarCurr: state_type] :
      ( v145615(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_81633,axiom,
    ! [VarCurr: state_type] :
      ( v145566(VarCurr)
    <=> v145568(VarCurr) ) ).

tff(addAssignment_81632,axiom,
    ! [VarCurr: state_type] :
      ( v145568(VarCurr)
    <=> v145570(VarCurr) ) ).

tff(addAssignment_81631,axiom,
    ! [VarCurr: state_type] :
      ( v145570(VarCurr)
    <=> v145572(VarCurr) ) ).

tff(addAssignment_81630,axiom,
    ! [VarCurr: state_type] :
      ( v145572(VarCurr)
    <=> v145574(VarCurr) ) ).

tff(addAssignment_81629,axiom,
    ! [VarCurr: state_type] :
      ( v145574(VarCurr)
    <=> v145576(VarCurr) ) ).

tff(addAssignment_81628,axiom,
    ! [VarCurr: state_type] :
      ( v145576(VarCurr)
    <=> v145578(VarCurr) ) ).

tff(addAssignment_81627,axiom,
    ! [VarCurr: state_type] :
      ( v145578(VarCurr)
    <=> v145580(VarCurr) ) ).

tff(writeUnaryOperator_11059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145580(VarCurr)
    <=> v145594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19388,axiom,
    ! [VarCurr: state_type] :
      ( v145594(VarCurr)
    <=> ( v145595(VarCurr)
        | v145590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19387,axiom,
    ! [VarCurr: state_type] :
      ( v145595(VarCurr)
    <=> ( v145582(VarCurr)
        | v145586(VarCurr) ) ) ).

tff(addAssignment_81626,axiom,
    ! [VarCurr: state_type] :
      ( v145590(VarCurr)
    <=> v145592(VarCurr) ) ).

tff(addAssignment_81625,axiom,
    ! [VarCurr: state_type] :
      ( v145592(VarCurr)
    <=> v144793(VarCurr,2) ) ).

tff(addAssignment_81624,axiom,
    ! [VarCurr: state_type] :
      ( v145586(VarCurr)
    <=> v145588(VarCurr) ) ).

tff(addAssignment_81623,axiom,
    ! [VarCurr: state_type] :
      ( v145588(VarCurr)
    <=> v144710(VarCurr,1) ) ).

tff(addAssignment_81622,axiom,
    ! [VarCurr: state_type] :
      ( v145582(VarCurr)
    <=> v145584(VarCurr) ) ).

tff(addAssignment_81621,axiom,
    ! [VarCurr: state_type] :
      ( v145584(VarCurr)
    <=> v144710(VarCurr,0) ) ).

tff(addAssignment_81620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145446(VarCurr,B)
      <=> v145448(VarCurr,B) ) ) ).

tff(addAssignment_81619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145448(VarCurr,B)
      <=> v145450(VarCurr,B) ) ) ).

tff(addAssignment_81618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145450(VarCurr,B)
      <=> v145452(VarCurr,B) ) ) ).

tff(addAssignment_81617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145452(VarCurr,B)
      <=> v145454(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145549(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v145454(VarNext,B)
            <=> v145454(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2061,axiom,
    ! [VarNext: state_type] :
      ( v145549(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145454(VarNext,B)
          <=> v145559(VarNext,B) ) ) ) ).

tff(addAssignment_81616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145559(VarNext,B)
          <=> v145557(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145557(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1598,axiom,
    ! [VarCurr: state_type] :
      ( v145560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145557(VarCurr,B)
          <=> v145476(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19386,axiom,
    ! [VarCurr: state_type] :
      ( v145560(VarCurr)
    <=> ( v145561(VarCurr)
        & v145562(VarCurr) ) ) ).

tff(writeUnaryOperator_11058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145562(VarCurr)
    <=> v145466(VarCurr) ) ).

tff(writeUnaryOperator_11057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145561(VarCurr)
    <=> v145456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145549(VarNext)
      <=> v145550(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145550(VarNext)
      <=> ( v145551(VarNext)
          & v145480(VarNext) ) ) ) ).

tff(writeUnaryOperator_11056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145551(VarNext)
      <=> v145553(VarNext) ) ) ).

tff(addAssignment_81615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145553(VarNext)
      <=> v145480(VarCurr) ) ) ).

tff(addAssignment_81614,axiom,
    ! [VarCurr: state_type] :
      ( v145480(VarCurr)
    <=> v145482(VarCurr) ) ).

tff(addAssignment_81613,axiom,
    ! [VarCurr: state_type] :
      ( v145482(VarCurr)
    <=> v145484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19383,axiom,
    ! [VarCurr: state_type] :
      ( v145484(VarCurr)
    <=> ( v145546(VarCurr)
        | v145542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19382,axiom,
    ! [VarCurr: state_type] :
      ( v145546(VarCurr)
    <=> ( v145486(VarCurr)
        & v145490(VarCurr) ) ) ).

tff(addAssignment_81612,axiom,
    ! [VarCurr: state_type] :
      ( v145542(VarCurr)
    <=> v145544(VarCurr) ) ).

tff(addAssignment_81611,axiom,
    ! [VarCurr: state_type] :
      ( v145544(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145526(VarNext)
       => ( v145490(VarNext)
        <=> v145490(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2060,axiom,
    ! [VarNext: state_type] :
      ( v145526(VarNext)
     => ( v145490(VarNext)
      <=> v145536(VarNext) ) ) ).

tff(addAssignment_81610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145536(VarNext)
      <=> v145534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19381,axiom,
    ! [VarCurr: state_type] :
      ( v145534(VarCurr)
    <=> ( v145537(VarCurr)
        & v145538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19380,axiom,
    ! [VarCurr: state_type] :
      ( v145538(VarCurr)
    <=> ( v145496(VarCurr)
        | v145521(VarCurr) ) ) ).

tff(writeUnaryOperator_11055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145537(VarCurr)
    <=> v145492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145526(VarNext)
      <=> v145527(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19378,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145527(VarNext)
      <=> ( v145529(VarNext)
          & v145531(VarNext) ) ) ) ).

tff(writeUnaryOperator_11054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145531(VarCurr)
    <=> v145486(VarCurr) ) ).

tff(addAssignment_81609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145529(VarNext)
      <=> v145486(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_272,axiom,
    ( v145490(constB0)
  <=> $true ) ).

tff(addAssignment_81608,axiom,
    ! [VarCurr: state_type] :
      ( v145521(VarCurr)
    <=> v145523(VarCurr) ) ).

tff(addAssignment_81607,axiom,
    ! [VarCurr: state_type] :
      ( v145523(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81606,axiom,
    ! [VarCurr: state_type] :
      ( v145496(VarCurr)
    <=> v145498(VarCurr) ) ).

tff(addAssignment_81605,axiom,
    ! [VarCurr: state_type] :
      ( v145498(VarCurr)
    <=> v145500(VarCurr) ) ).

tff(addAssignment_81604,axiom,
    ! [VarCurr: state_type] :
      ( v145500(VarCurr)
    <=> v145502(VarCurr) ) ).

tff(addAssignment_81603,axiom,
    ! [VarCurr: state_type] :
      ( v145502(VarCurr)
    <=> v145504(VarCurr) ) ).

tff(writeUnaryOperator_11053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145504(VarCurr)
    <=> v145518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19377,axiom,
    ! [VarCurr: state_type] :
      ( v145518(VarCurr)
    <=> ( v145519(VarCurr)
        | v145514(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19376,axiom,
    ! [VarCurr: state_type] :
      ( v145519(VarCurr)
    <=> ( v145506(VarCurr)
        | v145510(VarCurr) ) ) ).

tff(addAssignment_81602,axiom,
    ! [VarCurr: state_type] :
      ( v145514(VarCurr)
    <=> v145516(VarCurr) ) ).

tff(addAssignment_81601,axiom,
    ! [VarCurr: state_type] :
      ( v145516(VarCurr)
    <=> v145046(VarCurr,2) ) ).

tff(addAssignment_81600,axiom,
    ! [VarCurr: state_type] :
      ( v145046(VarCurr,2)
    <=> v145048(VarCurr,2) ) ).

tff(addAssignment_81599,axiom,
    ! [VarCurr: state_type] :
      ( v145048(VarCurr,2)
    <=> v145050(VarCurr,2) ) ).

tff(addAssignment_81598,axiom,
    ! [VarCurr: state_type] :
      ( v145050(VarCurr,2)
    <=> v145055(VarCurr,2) ) ).

tff(addAssignment_81597,axiom,
    ! [VarCurr: state_type] :
      ( v145052(VarCurr,2)
    <=> v145054(VarCurr,2) ) ).

tff(addAssignment_81596,axiom,
    ! [VarCurr: state_type] :
      ( v145054(VarCurr,2)
    <=> v144620(VarCurr,2) ) ).

tff(addAssignment_81595,axiom,
    ! [VarCurr: state_type] :
      ( v145510(VarCurr)
    <=> v145512(VarCurr) ) ).

tff(addAssignment_81594,axiom,
    ! [VarCurr: state_type] :
      ( v145512(VarCurr)
    <=> v144620(VarCurr,1) ) ).

tff(addAssignment_81593,axiom,
    ! [VarCurr: state_type] :
      ( v145506(VarCurr)
    <=> v145508(VarCurr) ) ).

tff(addAssignment_81592,axiom,
    ! [VarCurr: state_type] :
      ( v145508(VarCurr)
    <=> v144620(VarCurr,0) ) ).

tff(addAssignment_81591,axiom,
    ! [VarCurr: state_type] :
      ( v145492(VarCurr)
    <=> v145494(VarCurr) ) ).

tff(addAssignment_81590,axiom,
    ! [VarCurr: state_type] :
      ( v145494(VarCurr)
    <=> $false ) ).

tff(addAssignment_81589,axiom,
    ! [VarCurr: state_type] :
      ( v145486(VarCurr)
    <=> v145488(VarCurr) ) ).

tff(addAssignment_81588,axiom,
    ! [VarCurr: state_type] :
      ( v145488(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145476(VarCurr,B)
      <=> v145478(VarCurr,B) ) ) ).

tff(addAssignment_81586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145478(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81585,axiom,
    ! [VarCurr: state_type] :
      ( v145466(VarCurr)
    <=> v145468(VarCurr) ) ).

tff(addAssignment_81584,axiom,
    ! [VarCurr: state_type] :
      ( v145468(VarCurr)
    <=> v145470(VarCurr) ) ).

tff(addAssignment_81583,axiom,
    ! [VarCurr: state_type] :
      ( v145470(VarCurr)
    <=> v145472(VarCurr) ) ).

tff(addAssignment_81582,axiom,
    ! [VarCurr: state_type] :
      ( v145472(VarCurr)
    <=> v145474(VarCurr) ) ).

tff(addAssignment_81581,axiom,
    ! [VarCurr: state_type] :
      ( v145474(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81580,axiom,
    ! [VarCurr: state_type] :
      ( v145456(VarCurr)
    <=> v145458(VarCurr) ) ).

tff(addAssignment_81579,axiom,
    ! [VarCurr: state_type] :
      ( v145458(VarCurr)
    <=> v145460(VarCurr) ) ).

tff(addAssignment_81578,axiom,
    ! [VarCurr: state_type] :
      ( v145460(VarCurr)
    <=> v145462(VarCurr) ) ).

tff(addAssignment_81577,axiom,
    ! [VarCurr: state_type] :
      ( v145462(VarCurr)
    <=> v145464(VarCurr) ) ).

tff(addAssignment_81576,axiom,
    ! [VarCurr: state_type] :
      ( v145464(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_81575,axiom,
    ! [VarCurr: state_type] :
      ( v145415(VarCurr)
    <=> v145417(VarCurr) ) ).

tff(addAssignment_81574,axiom,
    ! [VarCurr: state_type] :
      ( v145417(VarCurr)
    <=> v145419(VarCurr) ) ).

tff(addAssignment_81573,axiom,
    ! [VarCurr: state_type] :
      ( v145419(VarCurr)
    <=> v145421(VarCurr) ) ).

tff(addAssignment_81572,axiom,
    ! [VarCurr: state_type] :
      ( v145421(VarCurr)
    <=> v145423(VarCurr) ) ).

tff(addAssignment_81571,axiom,
    ! [VarCurr: state_type] :
      ( v145423(VarCurr)
    <=> v145425(VarCurr) ) ).

tff(addAssignment_81570,axiom,
    ! [VarCurr: state_type] :
      ( v145425(VarCurr)
    <=> v145427(VarCurr) ) ).

tff(addAssignment_81569,axiom,
    ! [VarCurr: state_type] :
      ( v145427(VarCurr)
    <=> v145429(VarCurr) ) ).

tff(writeUnaryOperator_11052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145429(VarCurr)
    <=> v145443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19375,axiom,
    ! [VarCurr: state_type] :
      ( v145443(VarCurr)
    <=> ( v145444(VarCurr)
        | v145439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19374,axiom,
    ! [VarCurr: state_type] :
      ( v145444(VarCurr)
    <=> ( v145431(VarCurr)
        | v145435(VarCurr) ) ) ).

tff(addAssignment_81568,axiom,
    ! [VarCurr: state_type] :
      ( v145439(VarCurr)
    <=> v145441(VarCurr) ) ).

tff(addAssignment_81567,axiom,
    ! [VarCurr: state_type] :
      ( v145441(VarCurr)
    <=> v144710(VarCurr,2) ) ).

tff(addAssignment_81566,axiom,
    ! [VarCurr: state_type] :
      ( v145435(VarCurr)
    <=> v145437(VarCurr) ) ).

tff(addAssignment_81565,axiom,
    ! [VarCurr: state_type] :
      ( v145437(VarCurr)
    <=> v144793(VarCurr,1) ) ).

tff(addAssignment_81564,axiom,
    ! [VarCurr: state_type] :
      ( v145431(VarCurr)
    <=> v145433(VarCurr) ) ).

tff(addAssignment_81563,axiom,
    ! [VarCurr: state_type] :
      ( v145433(VarCurr)
    <=> v144793(VarCurr,0) ) ).

tff(addAssignment_81562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145295(VarCurr,B)
      <=> v145297(VarCurr,B) ) ) ).

tff(addAssignment_81561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145297(VarCurr,B)
      <=> v145299(VarCurr,B) ) ) ).

tff(addAssignment_81560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145299(VarCurr,B)
      <=> v145301(VarCurr,B) ) ) ).

tff(addAssignment_81559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145301(VarCurr,B)
      <=> v145303(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145398(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v145303(VarNext,B)
            <=> v145303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2059,axiom,
    ! [VarNext: state_type] :
      ( v145398(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145303(VarNext,B)
          <=> v145408(VarNext,B) ) ) ) ).

tff(addAssignment_81558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145408(VarNext,B)
          <=> v145406(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145409(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145406(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1597,axiom,
    ! [VarCurr: state_type] :
      ( v145409(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145406(VarCurr,B)
          <=> v145325(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19373,axiom,
    ! [VarCurr: state_type] :
      ( v145409(VarCurr)
    <=> ( v145410(VarCurr)
        & v145411(VarCurr) ) ) ).

tff(writeUnaryOperator_11051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145411(VarCurr)
    <=> v145315(VarCurr) ) ).

tff(writeUnaryOperator_11050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145410(VarCurr)
    <=> v145305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145398(VarNext)
      <=> v145399(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145399(VarNext)
      <=> ( v145400(VarNext)
          & v145329(VarNext) ) ) ) ).

tff(writeUnaryOperator_11049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145400(VarNext)
      <=> v145402(VarNext) ) ) ).

tff(addAssignment_81557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145402(VarNext)
      <=> v145329(VarCurr) ) ) ).

tff(addAssignment_81556,axiom,
    ! [VarCurr: state_type] :
      ( v145329(VarCurr)
    <=> v145331(VarCurr) ) ).

tff(addAssignment_81555,axiom,
    ! [VarCurr: state_type] :
      ( v145331(VarCurr)
    <=> v145333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19370,axiom,
    ! [VarCurr: state_type] :
      ( v145333(VarCurr)
    <=> ( v145395(VarCurr)
        | v145391(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19369,axiom,
    ! [VarCurr: state_type] :
      ( v145395(VarCurr)
    <=> ( v145335(VarCurr)
        & v145339(VarCurr) ) ) ).

tff(addAssignment_81554,axiom,
    ! [VarCurr: state_type] :
      ( v145391(VarCurr)
    <=> v145393(VarCurr) ) ).

tff(addAssignment_81553,axiom,
    ! [VarCurr: state_type] :
      ( v145393(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145375(VarNext)
       => ( v145339(VarNext)
        <=> v145339(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2058,axiom,
    ! [VarNext: state_type] :
      ( v145375(VarNext)
     => ( v145339(VarNext)
      <=> v145385(VarNext) ) ) ).

tff(addAssignment_81552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145385(VarNext)
      <=> v145383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19368,axiom,
    ! [VarCurr: state_type] :
      ( v145383(VarCurr)
    <=> ( v145386(VarCurr)
        & v145387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19367,axiom,
    ! [VarCurr: state_type] :
      ( v145387(VarCurr)
    <=> ( v145345(VarCurr)
        | v145370(VarCurr) ) ) ).

tff(writeUnaryOperator_11048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145386(VarCurr)
    <=> v145341(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145375(VarNext)
      <=> v145376(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145376(VarNext)
      <=> ( v145378(VarNext)
          & v145380(VarNext) ) ) ) ).

tff(writeUnaryOperator_11047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145380(VarCurr)
    <=> v145335(VarCurr) ) ).

tff(addAssignment_81551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145378(VarNext)
      <=> v145335(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_271,axiom,
    ( v145339(constB0)
  <=> $true ) ).

tff(addAssignment_81550,axiom,
    ! [VarCurr: state_type] :
      ( v145370(VarCurr)
    <=> v145372(VarCurr) ) ).

tff(addAssignment_81549,axiom,
    ! [VarCurr: state_type] :
      ( v145372(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81548,axiom,
    ! [VarCurr: state_type] :
      ( v145345(VarCurr)
    <=> v145347(VarCurr) ) ).

tff(addAssignment_81547,axiom,
    ! [VarCurr: state_type] :
      ( v145347(VarCurr)
    <=> v145349(VarCurr) ) ).

tff(addAssignment_81546,axiom,
    ! [VarCurr: state_type] :
      ( v145349(VarCurr)
    <=> v145351(VarCurr) ) ).

tff(addAssignment_81545,axiom,
    ! [VarCurr: state_type] :
      ( v145351(VarCurr)
    <=> v145353(VarCurr) ) ).

tff(writeUnaryOperator_11046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145353(VarCurr)
    <=> v145367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19364,axiom,
    ! [VarCurr: state_type] :
      ( v145367(VarCurr)
    <=> ( v145368(VarCurr)
        | v145363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19363,axiom,
    ! [VarCurr: state_type] :
      ( v145368(VarCurr)
    <=> ( v145355(VarCurr)
        | v145359(VarCurr) ) ) ).

tff(addAssignment_81544,axiom,
    ! [VarCurr: state_type] :
      ( v145363(VarCurr)
    <=> v145365(VarCurr) ) ).

tff(addAssignment_81543,axiom,
    ! [VarCurr: state_type] :
      ( v145365(VarCurr)
    <=> v144620(VarCurr,2) ) ).

tff(addAssignment_81542,axiom,
    ! [VarCurr: state_type] :
      ( v145359(VarCurr)
    <=> v145361(VarCurr) ) ).

tff(addAssignment_81541,axiom,
    ! [VarCurr: state_type] :
      ( v145361(VarCurr)
    <=> v145046(VarCurr,1) ) ).

tff(addAssignment_81540,axiom,
    ! [VarCurr: state_type] :
      ( v145355(VarCurr)
    <=> v145357(VarCurr) ) ).

tff(addAssignment_81539,axiom,
    ! [VarCurr: state_type] :
      ( v145357(VarCurr)
    <=> v145046(VarCurr,0) ) ).

tff(addAssignment_81538,axiom,
    ! [VarCurr: state_type] :
      ( v145341(VarCurr)
    <=> v145343(VarCurr) ) ).

tff(addAssignment_81537,axiom,
    ! [VarCurr: state_type] :
      ( v145343(VarCurr)
    <=> $false ) ).

tff(addAssignment_81536,axiom,
    ! [VarCurr: state_type] :
      ( v145335(VarCurr)
    <=> v145337(VarCurr) ) ).

tff(addAssignment_81535,axiom,
    ! [VarCurr: state_type] :
      ( v145337(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145325(VarCurr,B)
      <=> v145327(VarCurr,B) ) ) ).

tff(addAssignment_81533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145327(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81532,axiom,
    ! [VarCurr: state_type] :
      ( v145315(VarCurr)
    <=> v145317(VarCurr) ) ).

tff(addAssignment_81531,axiom,
    ! [VarCurr: state_type] :
      ( v145317(VarCurr)
    <=> v145319(VarCurr) ) ).

tff(addAssignment_81530,axiom,
    ! [VarCurr: state_type] :
      ( v145319(VarCurr)
    <=> v145321(VarCurr) ) ).

tff(addAssignment_81529,axiom,
    ! [VarCurr: state_type] :
      ( v145321(VarCurr)
    <=> v145323(VarCurr) ) ).

tff(addAssignment_81528,axiom,
    ! [VarCurr: state_type] :
      ( v145323(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81527,axiom,
    ! [VarCurr: state_type] :
      ( v145305(VarCurr)
    <=> v145307(VarCurr) ) ).

tff(addAssignment_81526,axiom,
    ! [VarCurr: state_type] :
      ( v145307(VarCurr)
    <=> v145309(VarCurr) ) ).

tff(addAssignment_81525,axiom,
    ! [VarCurr: state_type] :
      ( v145309(VarCurr)
    <=> v145311(VarCurr) ) ).

tff(addAssignment_81524,axiom,
    ! [VarCurr: state_type] :
      ( v145311(VarCurr)
    <=> v145313(VarCurr) ) ).

tff(addAssignment_81523,axiom,
    ! [VarCurr: state_type] :
      ( v145313(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_81522,axiom,
    ! [VarCurr: state_type] :
      ( v145264(VarCurr)
    <=> v145266(VarCurr) ) ).

tff(addAssignment_81521,axiom,
    ! [VarCurr: state_type] :
      ( v145266(VarCurr)
    <=> v145268(VarCurr) ) ).

tff(addAssignment_81520,axiom,
    ! [VarCurr: state_type] :
      ( v145268(VarCurr)
    <=> v145270(VarCurr) ) ).

tff(addAssignment_81519,axiom,
    ! [VarCurr: state_type] :
      ( v145270(VarCurr)
    <=> v145272(VarCurr) ) ).

tff(addAssignment_81518,axiom,
    ! [VarCurr: state_type] :
      ( v145272(VarCurr)
    <=> v145274(VarCurr) ) ).

tff(addAssignment_81517,axiom,
    ! [VarCurr: state_type] :
      ( v145274(VarCurr)
    <=> v145276(VarCurr) ) ).

tff(addAssignment_81516,axiom,
    ! [VarCurr: state_type] :
      ( v145276(VarCurr)
    <=> v145278(VarCurr) ) ).

tff(writeUnaryOperator_11045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145278(VarCurr)
    <=> v145292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19362,axiom,
    ! [VarCurr: state_type] :
      ( v145292(VarCurr)
    <=> ( v145293(VarCurr)
        | v145288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19361,axiom,
    ! [VarCurr: state_type] :
      ( v145293(VarCurr)
    <=> ( v145280(VarCurr)
        | v145284(VarCurr) ) ) ).

tff(addAssignment_81515,axiom,
    ! [VarCurr: state_type] :
      ( v145288(VarCurr)
    <=> v145290(VarCurr) ) ).

tff(addAssignment_81514,axiom,
    ! [VarCurr: state_type] :
      ( v145290(VarCurr)
    <=> v144710(VarCurr,2) ) ).

tff(addAssignment_81513,axiom,
    ! [VarCurr: state_type] :
      ( v145284(VarCurr)
    <=> v145286(VarCurr) ) ).

tff(addAssignment_81512,axiom,
    ! [VarCurr: state_type] :
      ( v145286(VarCurr)
    <=> v144793(VarCurr,1) ) ).

tff(addAssignment_81511,axiom,
    ! [VarCurr: state_type] :
      ( v144793(VarCurr,1)
    <=> v144795(VarCurr,1) ) ).

tff(addAssignment_81510,axiom,
    ! [VarCurr: state_type] :
      ( v144795(VarCurr,1)
    <=> v144797(VarCurr,1) ) ).

tff(addAssignment_81509,axiom,
    ! [VarCurr: state_type] :
      ( v144797(VarCurr,1)
    <=> v144802(VarCurr,1) ) ).

tff(addAssignment_81508,axiom,
    ! [VarCurr: state_type] :
      ( v144799(VarCurr,1)
    <=> v144801(VarCurr,1) ) ).

tff(addAssignment_81507,axiom,
    ! [VarCurr: state_type] :
      ( v144801(VarCurr,1)
    <=> v144710(VarCurr,1) ) ).

tff(addAssignment_81506,axiom,
    ! [VarCurr: state_type] :
      ( v145280(VarCurr)
    <=> v145282(VarCurr) ) ).

tff(addAssignment_81505,axiom,
    ! [VarCurr: state_type] :
      ( v145282(VarCurr)
    <=> v144710(VarCurr,0) ) ).

tff(addAssignment_81504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145144(VarCurr,B)
      <=> v145146(VarCurr,B) ) ) ).

tff(addAssignment_81503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145146(VarCurr,B)
      <=> v145148(VarCurr,B) ) ) ).

tff(addAssignment_81502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145148(VarCurr,B)
      <=> v145150(VarCurr,B) ) ) ).

tff(addAssignment_81501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145150(VarCurr,B)
      <=> v145152(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145247(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v145152(VarNext,B)
            <=> v145152(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2057,axiom,
    ! [VarNext: state_type] :
      ( v145247(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145152(VarNext,B)
          <=> v145257(VarNext,B) ) ) ) ).

tff(addAssignment_81500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145257(VarNext,B)
          <=> v145255(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145258(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145255(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1596,axiom,
    ! [VarCurr: state_type] :
      ( v145258(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145255(VarCurr,B)
          <=> v145174(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19360,axiom,
    ! [VarCurr: state_type] :
      ( v145258(VarCurr)
    <=> ( v145259(VarCurr)
        & v145260(VarCurr) ) ) ).

tff(writeUnaryOperator_11044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145260(VarCurr)
    <=> v145164(VarCurr) ) ).

tff(writeUnaryOperator_11043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145259(VarCurr)
    <=> v145154(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145247(VarNext)
      <=> v145248(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145248(VarNext)
      <=> ( v145249(VarNext)
          & v145178(VarNext) ) ) ) ).

tff(writeUnaryOperator_11042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145249(VarNext)
      <=> v145251(VarNext) ) ) ).

tff(addAssignment_81499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145251(VarNext)
      <=> v145178(VarCurr) ) ) ).

tff(addAssignment_81498,axiom,
    ! [VarCurr: state_type] :
      ( v145178(VarCurr)
    <=> v145180(VarCurr) ) ).

tff(addAssignment_81497,axiom,
    ! [VarCurr: state_type] :
      ( v145180(VarCurr)
    <=> v145182(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19357,axiom,
    ! [VarCurr: state_type] :
      ( v145182(VarCurr)
    <=> ( v145244(VarCurr)
        | v145240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19356,axiom,
    ! [VarCurr: state_type] :
      ( v145244(VarCurr)
    <=> ( v145184(VarCurr)
        & v145188(VarCurr) ) ) ).

tff(addAssignment_81496,axiom,
    ! [VarCurr: state_type] :
      ( v145240(VarCurr)
    <=> v145242(VarCurr) ) ).

tff(addAssignment_81495,axiom,
    ! [VarCurr: state_type] :
      ( v145242(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145224(VarNext)
       => ( v145188(VarNext)
        <=> v145188(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2056,axiom,
    ! [VarNext: state_type] :
      ( v145224(VarNext)
     => ( v145188(VarNext)
      <=> v145234(VarNext) ) ) ).

tff(addAssignment_81494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145234(VarNext)
      <=> v145232(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19355,axiom,
    ! [VarCurr: state_type] :
      ( v145232(VarCurr)
    <=> ( v145235(VarCurr)
        & v145236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19354,axiom,
    ! [VarCurr: state_type] :
      ( v145236(VarCurr)
    <=> ( v145194(VarCurr)
        | v145219(VarCurr) ) ) ).

tff(writeUnaryOperator_11041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145235(VarCurr)
    <=> v145190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145224(VarNext)
      <=> v145225(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145225(VarNext)
      <=> ( v145227(VarNext)
          & v145229(VarNext) ) ) ) ).

tff(writeUnaryOperator_11040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145229(VarCurr)
    <=> v145184(VarCurr) ) ).

tff(addAssignment_81493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145227(VarNext)
      <=> v145184(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_270,axiom,
    ( v145188(constB0)
  <=> $true ) ).

tff(addAssignment_81492,axiom,
    ! [VarCurr: state_type] :
      ( v145219(VarCurr)
    <=> v145221(VarCurr) ) ).

tff(addAssignment_81491,axiom,
    ! [VarCurr: state_type] :
      ( v145221(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81490,axiom,
    ! [VarCurr: state_type] :
      ( v145194(VarCurr)
    <=> v145196(VarCurr) ) ).

tff(addAssignment_81489,axiom,
    ! [VarCurr: state_type] :
      ( v145196(VarCurr)
    <=> v145198(VarCurr) ) ).

tff(addAssignment_81488,axiom,
    ! [VarCurr: state_type] :
      ( v145198(VarCurr)
    <=> v145200(VarCurr) ) ).

tff(addAssignment_81487,axiom,
    ! [VarCurr: state_type] :
      ( v145200(VarCurr)
    <=> v145202(VarCurr) ) ).

tff(writeUnaryOperator_11039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145202(VarCurr)
    <=> v145216(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19351,axiom,
    ! [VarCurr: state_type] :
      ( v145216(VarCurr)
    <=> ( v145217(VarCurr)
        | v145212(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19350,axiom,
    ! [VarCurr: state_type] :
      ( v145217(VarCurr)
    <=> ( v145204(VarCurr)
        | v145208(VarCurr) ) ) ).

tff(addAssignment_81486,axiom,
    ! [VarCurr: state_type] :
      ( v145212(VarCurr)
    <=> v145214(VarCurr) ) ).

tff(addAssignment_81485,axiom,
    ! [VarCurr: state_type] :
      ( v145214(VarCurr)
    <=> v144620(VarCurr,2) ) ).

tff(addAssignment_81484,axiom,
    ! [VarCurr: state_type] :
      ( v145208(VarCurr)
    <=> v145210(VarCurr) ) ).

tff(addAssignment_81483,axiom,
    ! [VarCurr: state_type] :
      ( v145210(VarCurr)
    <=> v145046(VarCurr,1) ) ).

tff(addAssignment_81482,axiom,
    ! [VarCurr: state_type] :
      ( v145046(VarCurr,1)
    <=> v145048(VarCurr,1) ) ).

tff(addAssignment_81481,axiom,
    ! [VarCurr: state_type] :
      ( v145048(VarCurr,1)
    <=> v145050(VarCurr,1) ) ).

tff(addAssignment_81480,axiom,
    ! [VarCurr: state_type] :
      ( v145050(VarCurr,1)
    <=> v145055(VarCurr,1) ) ).

tff(addAssignment_81479,axiom,
    ! [VarCurr: state_type] :
      ( v145052(VarCurr,1)
    <=> v145054(VarCurr,1) ) ).

tff(addAssignment_81478,axiom,
    ! [VarCurr: state_type] :
      ( v145054(VarCurr,1)
    <=> v144620(VarCurr,1) ) ).

tff(addAssignment_81477,axiom,
    ! [VarCurr: state_type] :
      ( v145204(VarCurr)
    <=> v145206(VarCurr) ) ).

tff(addAssignment_81476,axiom,
    ! [VarCurr: state_type] :
      ( v145206(VarCurr)
    <=> v144620(VarCurr,0) ) ).

tff(addAssignment_81475,axiom,
    ! [VarCurr: state_type] :
      ( v145190(VarCurr)
    <=> v145192(VarCurr) ) ).

tff(addAssignment_81474,axiom,
    ! [VarCurr: state_type] :
      ( v145192(VarCurr)
    <=> $false ) ).

tff(addAssignment_81473,axiom,
    ! [VarCurr: state_type] :
      ( v145184(VarCurr)
    <=> v145186(VarCurr) ) ).

tff(addAssignment_81472,axiom,
    ! [VarCurr: state_type] :
      ( v145186(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145174(VarCurr,B)
      <=> v145176(VarCurr,B) ) ) ).

tff(addAssignment_81470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145176(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81469,axiom,
    ! [VarCurr: state_type] :
      ( v145164(VarCurr)
    <=> v145166(VarCurr) ) ).

tff(addAssignment_81468,axiom,
    ! [VarCurr: state_type] :
      ( v145166(VarCurr)
    <=> v145168(VarCurr) ) ).

tff(addAssignment_81467,axiom,
    ! [VarCurr: state_type] :
      ( v145168(VarCurr)
    <=> v145170(VarCurr) ) ).

tff(addAssignment_81466,axiom,
    ! [VarCurr: state_type] :
      ( v145170(VarCurr)
    <=> v145172(VarCurr) ) ).

tff(addAssignment_81465,axiom,
    ! [VarCurr: state_type] :
      ( v145172(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81464,axiom,
    ! [VarCurr: state_type] :
      ( v145154(VarCurr)
    <=> v145156(VarCurr) ) ).

tff(addAssignment_81463,axiom,
    ! [VarCurr: state_type] :
      ( v145156(VarCurr)
    <=> v145158(VarCurr) ) ).

tff(addAssignment_81462,axiom,
    ! [VarCurr: state_type] :
      ( v145158(VarCurr)
    <=> v145160(VarCurr) ) ).

tff(addAssignment_81461,axiom,
    ! [VarCurr: state_type] :
      ( v145160(VarCurr)
    <=> v145162(VarCurr) ) ).

tff(addAssignment_81460,axiom,
    ! [VarCurr: state_type] :
      ( v145162(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_81459,axiom,
    ! [VarCurr: state_type] :
      ( v145113(VarCurr)
    <=> v145115(VarCurr) ) ).

tff(addAssignment_81458,axiom,
    ! [VarCurr: state_type] :
      ( v145115(VarCurr)
    <=> v145117(VarCurr) ) ).

tff(addAssignment_81457,axiom,
    ! [VarCurr: state_type] :
      ( v145117(VarCurr)
    <=> v145119(VarCurr) ) ).

tff(addAssignment_81456,axiom,
    ! [VarCurr: state_type] :
      ( v145119(VarCurr)
    <=> v145121(VarCurr) ) ).

tff(addAssignment_81455,axiom,
    ! [VarCurr: state_type] :
      ( v145121(VarCurr)
    <=> v145123(VarCurr) ) ).

tff(addAssignment_81454,axiom,
    ! [VarCurr: state_type] :
      ( v145123(VarCurr)
    <=> v145125(VarCurr) ) ).

tff(addAssignment_81453,axiom,
    ! [VarCurr: state_type] :
      ( v145125(VarCurr)
    <=> v145127(VarCurr) ) ).

tff(writeUnaryOperator_11038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145127(VarCurr)
    <=> v145141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19349,axiom,
    ! [VarCurr: state_type] :
      ( v145141(VarCurr)
    <=> ( v145142(VarCurr)
        | v145137(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19348,axiom,
    ! [VarCurr: state_type] :
      ( v145142(VarCurr)
    <=> ( v145129(VarCurr)
        | v145133(VarCurr) ) ) ).

tff(addAssignment_81452,axiom,
    ! [VarCurr: state_type] :
      ( v145137(VarCurr)
    <=> v145139(VarCurr) ) ).

tff(addAssignment_81451,axiom,
    ! [VarCurr: state_type] :
      ( v145139(VarCurr)
    <=> v144710(VarCurr,2) ) ).

tff(addAssignment_81450,axiom,
    ! [VarCurr: state_type] :
      ( v145133(VarCurr)
    <=> v145135(VarCurr) ) ).

tff(addAssignment_81449,axiom,
    ! [VarCurr: state_type] :
      ( v145135(VarCurr)
    <=> v144710(VarCurr,1) ) ).

tff(addAssignment_81448,axiom,
    ! [VarCurr: state_type] :
      ( v145129(VarCurr)
    <=> v145131(VarCurr) ) ).

tff(addAssignment_81447,axiom,
    ! [VarCurr: state_type] :
      ( v145131(VarCurr)
    <=> v144793(VarCurr,0) ) ).

tff(addAssignment_81446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144982(VarCurr,B)
      <=> v144984(VarCurr,B) ) ) ).

tff(addAssignment_81445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144984(VarCurr,B)
      <=> v144986(VarCurr,B) ) ) ).

tff(addAssignment_81444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144986(VarCurr,B)
      <=> v144988(VarCurr,B) ) ) ).

tff(addAssignment_81443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144988(VarCurr,B)
      <=> v144990(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145096(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v144990(VarNext,B)
            <=> v144990(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2055,axiom,
    ! [VarNext: state_type] :
      ( v145096(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144990(VarNext,B)
          <=> v145106(VarNext,B) ) ) ) ).

tff(addAssignment_81442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145106(VarNext,B)
          <=> v145104(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145104(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1595,axiom,
    ! [VarCurr: state_type] :
      ( v145107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v145104(VarCurr,B)
          <=> v145012(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19347,axiom,
    ! [VarCurr: state_type] :
      ( v145107(VarCurr)
    <=> ( v145108(VarCurr)
        & v145109(VarCurr) ) ) ).

tff(writeUnaryOperator_11037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145109(VarCurr)
    <=> v145002(VarCurr) ) ).

tff(writeUnaryOperator_11036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145108(VarCurr)
    <=> v144992(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145096(VarNext)
      <=> v145097(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145097(VarNext)
      <=> ( v145098(VarNext)
          & v145016(VarNext) ) ) ) ).

tff(writeUnaryOperator_11035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145098(VarNext)
      <=> v145100(VarNext) ) ) ).

tff(addAssignment_81441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145100(VarNext)
      <=> v145016(VarCurr) ) ) ).

tff(addAssignment_81440,axiom,
    ! [VarCurr: state_type] :
      ( v145016(VarCurr)
    <=> v145018(VarCurr) ) ).

tff(addAssignment_81439,axiom,
    ! [VarCurr: state_type] :
      ( v145018(VarCurr)
    <=> v145020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19344,axiom,
    ! [VarCurr: state_type] :
      ( v145020(VarCurr)
    <=> ( v145093(VarCurr)
        | v145089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19343,axiom,
    ! [VarCurr: state_type] :
      ( v145093(VarCurr)
    <=> ( v145022(VarCurr)
        & v145026(VarCurr) ) ) ).

tff(addAssignment_81438,axiom,
    ! [VarCurr: state_type] :
      ( v145089(VarCurr)
    <=> v145091(VarCurr) ) ).

tff(addAssignment_81437,axiom,
    ! [VarCurr: state_type] :
      ( v145091(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v145073(VarNext)
       => ( v145026(VarNext)
        <=> v145026(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2054,axiom,
    ! [VarNext: state_type] :
      ( v145073(VarNext)
     => ( v145026(VarNext)
      <=> v145083(VarNext) ) ) ).

tff(addAssignment_81436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145083(VarNext)
      <=> v145081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19342,axiom,
    ! [VarCurr: state_type] :
      ( v145081(VarCurr)
    <=> ( v145084(VarCurr)
        & v145085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19341,axiom,
    ! [VarCurr: state_type] :
      ( v145085(VarCurr)
    <=> ( v145032(VarCurr)
        | v145068(VarCurr) ) ) ).

tff(writeUnaryOperator_11034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145084(VarCurr)
    <=> v145028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145073(VarNext)
      <=> v145074(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145074(VarNext)
      <=> ( v145076(VarNext)
          & v145078(VarNext) ) ) ) ).

tff(writeUnaryOperator_11033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145078(VarCurr)
    <=> v145022(VarCurr) ) ).

tff(addAssignment_81435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v145076(VarNext)
      <=> v145022(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_269,axiom,
    ( v145026(constB0)
  <=> $true ) ).

tff(addAssignment_81434,axiom,
    ! [VarCurr: state_type] :
      ( v145068(VarCurr)
    <=> v145070(VarCurr) ) ).

tff(addAssignment_81433,axiom,
    ! [VarCurr: state_type] :
      ( v145070(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81432,axiom,
    ! [VarCurr: state_type] :
      ( v145032(VarCurr)
    <=> v145034(VarCurr) ) ).

tff(addAssignment_81431,axiom,
    ! [VarCurr: state_type] :
      ( v145034(VarCurr)
    <=> v145036(VarCurr) ) ).

tff(addAssignment_81430,axiom,
    ! [VarCurr: state_type] :
      ( v145036(VarCurr)
    <=> v145038(VarCurr) ) ).

tff(addAssignment_81429,axiom,
    ! [VarCurr: state_type] :
      ( v145038(VarCurr)
    <=> v145040(VarCurr) ) ).

tff(writeUnaryOperator_11032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v145040(VarCurr)
    <=> v145065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19338,axiom,
    ! [VarCurr: state_type] :
      ( v145065(VarCurr)
    <=> ( v145066(VarCurr)
        | v145061(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19337,axiom,
    ! [VarCurr: state_type] :
      ( v145066(VarCurr)
    <=> ( v145042(VarCurr)
        | v145057(VarCurr) ) ) ).

tff(addAssignment_81428,axiom,
    ! [VarCurr: state_type] :
      ( v145061(VarCurr)
    <=> v145063(VarCurr) ) ).

tff(addAssignment_81427,axiom,
    ! [VarCurr: state_type] :
      ( v145063(VarCurr)
    <=> v144620(VarCurr,2) ) ).

tff(addAssignment_81426,axiom,
    ! [VarCurr: state_type] :
      ( v145057(VarCurr)
    <=> v145059(VarCurr) ) ).

tff(addAssignment_81425,axiom,
    ! [VarCurr: state_type] :
      ( v145059(VarCurr)
    <=> v144620(VarCurr,1) ) ).

tff(addAssignment_81424,axiom,
    ! [VarCurr: state_type] :
      ( v145042(VarCurr)
    <=> v145044(VarCurr) ) ).

tff(addAssignment_81423,axiom,
    ! [VarCurr: state_type] :
      ( v145044(VarCurr)
    <=> v145046(VarCurr,0) ) ).

tff(addAssignment_81422,axiom,
    ! [VarCurr: state_type] :
      ( v145046(VarCurr,0)
    <=> v145048(VarCurr,0) ) ).

tff(addAssignment_81421,axiom,
    ! [VarCurr: state_type] :
      ( v145048(VarCurr,0)
    <=> v145050(VarCurr,0) ) ).

tff(addAssignment_81420,axiom,
    ! [VarCurr: state_type] :
      ( v145050(VarCurr,0)
    <=> v145055(VarCurr,0) ) ).

tff(writeUnaryOperator_11031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v145055(VarCurr,B)
      <=> ~ v145052(VarCurr,B) ) ) ).

tff(addAssignment_81419,axiom,
    ! [VarCurr: state_type] :
      ( v145052(VarCurr,0)
    <=> v145054(VarCurr,0) ) ).

tff(addAssignment_81418,axiom,
    ! [VarCurr: state_type] :
      ( v145054(VarCurr,0)
    <=> v144620(VarCurr,0) ) ).

tff(addAssignment_81417,axiom,
    ! [VarCurr: state_type] :
      ( v145028(VarCurr)
    <=> v145030(VarCurr) ) ).

tff(addAssignment_81416,axiom,
    ! [VarCurr: state_type] :
      ( v145030(VarCurr)
    <=> $false ) ).

tff(addAssignment_81415,axiom,
    ! [VarCurr: state_type] :
      ( v145022(VarCurr)
    <=> v145024(VarCurr) ) ).

tff(addAssignment_81414,axiom,
    ! [VarCurr: state_type] :
      ( v145024(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145012(VarCurr,B)
      <=> v145014(VarCurr,B) ) ) ).

tff(addAssignment_81412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v145014(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81411,axiom,
    ! [VarCurr: state_type] :
      ( v145002(VarCurr)
    <=> v145004(VarCurr) ) ).

tff(addAssignment_81410,axiom,
    ! [VarCurr: state_type] :
      ( v145004(VarCurr)
    <=> v145006(VarCurr) ) ).

tff(addAssignment_81409,axiom,
    ! [VarCurr: state_type] :
      ( v145006(VarCurr)
    <=> v145008(VarCurr) ) ).

tff(addAssignment_81408,axiom,
    ! [VarCurr: state_type] :
      ( v145008(VarCurr)
    <=> v145010(VarCurr) ) ).

tff(addAssignment_81407,axiom,
    ! [VarCurr: state_type] :
      ( v145010(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81406,axiom,
    ! [VarCurr: state_type] :
      ( v144992(VarCurr)
    <=> v144994(VarCurr) ) ).

tff(addAssignment_81405,axiom,
    ! [VarCurr: state_type] :
      ( v144994(VarCurr)
    <=> v144996(VarCurr) ) ).

tff(addAssignment_81404,axiom,
    ! [VarCurr: state_type] :
      ( v144996(VarCurr)
    <=> v144998(VarCurr) ) ).

tff(addAssignment_81403,axiom,
    ! [VarCurr: state_type] :
      ( v144998(VarCurr)
    <=> v145000(VarCurr) ) ).

tff(addAssignment_81402,axiom,
    ! [VarCurr: state_type] :
      ( v145000(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_81401,axiom,
    ! [VarCurr: state_type] :
      ( v144690(VarCurr)
    <=> v144692(VarCurr) ) ).

tff(addAssignment_81400,axiom,
    ! [VarCurr: state_type] :
      ( v144692(VarCurr)
    <=> v144694(VarCurr) ) ).

tff(addAssignment_81399,axiom,
    ! [VarCurr: state_type] :
      ( v144694(VarCurr)
    <=> v144696(VarCurr) ) ).

tff(addAssignment_81398,axiom,
    ! [VarCurr: state_type] :
      ( v144696(VarCurr)
    <=> v144698(VarCurr) ) ).

tff(addAssignment_81397,axiom,
    ! [VarCurr: state_type] :
      ( v144698(VarCurr)
    <=> v144700(VarCurr) ) ).

tff(addAssignment_81396,axiom,
    ! [VarCurr: state_type] :
      ( v144700(VarCurr)
    <=> v144702(VarCurr) ) ).

tff(addAssignment_81395,axiom,
    ! [VarCurr: state_type] :
      ( v144702(VarCurr)
    <=> v144704(VarCurr) ) ).

tff(writeUnaryOperator_11030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144704(VarCurr)
    <=> v144979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19336,axiom,
    ! [VarCurr: state_type] :
      ( v144979(VarCurr)
    <=> ( v144980(VarCurr)
        | v144975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19335,axiom,
    ! [VarCurr: state_type] :
      ( v144980(VarCurr)
    <=> ( v144706(VarCurr)
        | v144971(VarCurr) ) ) ).

tff(addAssignment_81394,axiom,
    ! [VarCurr: state_type] :
      ( v144975(VarCurr)
    <=> v144977(VarCurr) ) ).

tff(addAssignment_81393,axiom,
    ! [VarCurr: state_type] :
      ( v144977(VarCurr)
    <=> v144710(VarCurr,2) ) ).

tff(addAssignment_81392,axiom,
    ! [VarCurr: state_type] :
      ( v144971(VarCurr)
    <=> v144973(VarCurr) ) ).

tff(addAssignment_81391,axiom,
    ! [VarCurr: state_type] :
      ( v144973(VarCurr)
    <=> v144710(VarCurr,1) ) ).

tff(addAssignment_81390,axiom,
    ! [VarCurr: state_type] :
      ( v144706(VarCurr)
    <=> v144708(VarCurr) ) ).

tff(addAssignment_81389,axiom,
    ! [VarCurr: state_type] :
      ( v144708(VarCurr)
    <=> v144710(VarCurr,0) ) ).

tff(addAssignment_81388,axiom,
    ! [VarCurr: state_type] :
      ( v144710(VarCurr,0)
    <=> v144622(VarCurr,3) ) ).

tff(addAssignment_81387,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,3)
    <=> v144624(VarCurr,3) ) ).

tff(addAssignment_81386,axiom,
    ! [VarNext: state_type] :
      ( v144624(VarNext,3)
    <=> v144963(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_2053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144964(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v144963(VarNext,B)
            <=> v144624(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2053,axiom,
    ! [VarNext: state_type] :
      ( v144964(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144963(VarNext,B)
          <=> v144935(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144964(VarNext)
      <=> v144965(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144965(VarNext)
      <=> ( v144967(VarNext)
          & v144877(VarNext) ) ) ) ).

tff(writeUnaryOperator_11029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144967(VarNext)
      <=> v144929(VarNext) ) ) ).

tff(addAssignment_81385,axiom,
    ! [VarCurr: state_type] :
      ( v144734(VarCurr,3)
    <=> v144736(VarCurr,3) ) ).

tff(addAssignment_81384,axiom,
    ! [VarCurr: state_type] :
      ( v144736(VarCurr,3)
    <=> v144874(VarCurr,3) ) ).

tff(addAssignment_81383,axiom,
    ! [VarCurr: state_type] :
      ( v144738(VarCurr,0)
    <=> v144740(VarCurr,0) ) ).

tff(addAssignment_81382,axiom,
    ! [VarCurr: state_type] :
      ( v144740(VarCurr,0)
    <=> v144742(VarCurr,0) ) ).

tff(addAssignment_81381,axiom,
    ! [VarCurr: state_type] :
      ( v144742(VarCurr,0)
    <=> v144873(VarCurr,0) ) ).

tff(addAssignment_81380,axiom,
    ! [VarCurr: state_type] :
      ( v144810(VarCurr,0)
    <=> v144812(VarCurr,0) ) ).

tff(addAssignment_81379,axiom,
    ! [VarCurr: state_type] :
      ( v144812(VarCurr,0)
    <=> v144814(VarCurr,0) ) ).

tff(addAssignment_81378,axiom,
    ! [VarCurr: state_type] :
      ( v144814(VarCurr,0)
    <=> v144816(VarCurr,0) ) ).

tff(addAssignment_81377,axiom,
    ! [VarCurr: state_type] :
      ( v144816(VarCurr,0)
    <=> v144818(VarCurr,0) ) ).

tff(addAssignment_81376,axiom,
    ! [VarCurr: state_type] :
      ( v144818(VarCurr,0)
    <=> v144828(VarCurr,0) ) ).

tff(addAssignment_81375,axiom,
    ! [VarCurr: state_type] :
      ( v144744(VarCurr,0)
    <=> v144746(VarCurr,0) ) ).

tff(addAssignment_81374,axiom,
    ! [VarCurr: state_type] :
      ( v144746(VarCurr,0)
    <=> v144807(VarCurr,0) ) ).

tff(addAssignment_81373,axiom,
    ! [VarCurr: state_type] :
      ( v144748(VarCurr)
    <=> v4185(VarCurr,2) ) ).

tff(addAssignment_81372,axiom,
    ! [VarCurr: state_type] :
      ( v4185(VarCurr,2)
    <=> v4187(VarCurr,2) ) ).

tff(addAssignment_81371,axiom,
    ! [VarCurr: state_type] :
      ( v4187(VarCurr,2)
    <=> v144286(VarCurr,2) ) ).

tff(addAssignment_81370,axiom,
    ! [VarCurr: state_type] :
      ( v4189(VarCurr,2)
    <=> v4191(VarCurr,2) ) ).

tff(addAssignment_81369,axiom,
    ! [VarCurr: state_type] :
      ( v4191(VarCurr,2)
    <=> v144283(VarCurr,2) ) ).

tff(addAssignment_81368,axiom,
    ! [VarCurr: state_type] :
      ( v144284(VarCurr)
    <=> v144751(VarCurr,1) ) ).

tff(addAssignment_81367,axiom,
    ! [VarCurr: state_type] :
      ( v144751(VarCurr,1)
    <=> v144753(VarCurr,1) ) ).

tff(addAssignment_81366,axiom,
    ! [VarCurr: state_type] :
      ( v144753(VarCurr,1)
    <=> v144961(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v144961(VarCurr,B)
      <=> ( v144755(VarCurr,B)
          | v144761(VarCurr,B) ) ) ) ).

tff(addAssignment_81365,axiom,
    ! [VarCurr: state_type] :
      ( v144761(VarCurr,1)
    <=> v144763(VarCurr,1) ) ).

tff(addAssignment_81364,axiom,
    ! [VarCurr: state_type] :
      ( v144763(VarCurr,1)
    <=> v144959(VarCurr,1) ) ).

tff(addAssignment_81363,axiom,
    ! [VarCurr: state_type] :
      ( v144959(VarCurr,0)
    <=> v144960(VarCurr) ) ).

tff(addAssignment_81362,axiom,
    ! [VarCurr: state_type] :
      ( v144959(VarCurr,1)
    <=> v144765(VarCurr) ) ).

tff(addAssignment_81361,axiom,
    ! [VarCurr: state_type] :
      ( v144765(VarCurr)
    <=> v144767(VarCurr,1) ) ).

tff(addAssignment_81360,axiom,
    ! [VarCurr: state_type] :
      ( v144767(VarCurr,1)
    <=> v144769(VarCurr,1) ) ).

tff(addAssignment_81359,axiom,
    ! [VarCurr: state_type] :
      ( v144769(VarCurr,1)
    <=> v144958(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v144958(VarCurr,B)
      <=> ( v144771(VarCurr,B)
          & v144779(VarCurr,B) ) ) ) ).

tff(addAssignment_81358,axiom,
    ! [VarCurr: state_type] :
      ( v144779(VarCurr,1)
    <=> v144781(VarCurr,1) ) ).

tff(addAssignment_81357,axiom,
    ! [VarCurr: state_type] :
      ( v144781(VarCurr,1)
    <=> v144956(VarCurr,1) ) ).

tff(addAssignment_81356,axiom,
    ! [VarCurr: state_type] :
      ( v144956(VarCurr,0)
    <=> v144957(VarCurr) ) ).

tff(addAssignment_81355,axiom,
    ! [VarCurr: state_type] :
      ( v144956(VarCurr,1)
    <=> v144783(VarCurr) ) ).

tff(addAssignment_81354,axiom,
    ! [VarCurr: state_type] :
      ( v144783(VarCurr)
    <=> v144785(VarCurr) ) ).

tff(addAssignment_81353,axiom,
    ! [VarCurr: state_type] :
      ( v144785(VarCurr)
    <=> v144787(VarCurr) ) ).

tff(writeUnaryOperator_11028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144787(VarCurr)
    <=> v144954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19332,axiom,
    ! [VarCurr: state_type] :
      ( v144954(VarCurr)
    <=> ( v144955(VarCurr)
        | v144942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19331,axiom,
    ! [VarCurr: state_type] :
      ( v144955(VarCurr)
    <=> ( v144789(VarCurr)
        | v144804(VarCurr) ) ) ).

tff(addAssignment_81352,axiom,
    ! [VarCurr: state_type] :
      ( v144942(VarCurr)
    <=> v144944(VarCurr) ) ).

tff(addAssignment_81351,axiom,
    ! [VarCurr: state_type] :
      ( v144944(VarCurr)
    <=> v144793(VarCurr,2) ) ).

tff(addAssignment_81350,axiom,
    ! [VarCurr: state_type] :
      ( v144793(VarCurr,2)
    <=> v144795(VarCurr,2) ) ).

tff(addAssignment_81349,axiom,
    ! [VarCurr: state_type] :
      ( v144795(VarCurr,2)
    <=> v144797(VarCurr,2) ) ).

tff(addAssignment_81348,axiom,
    ! [VarCurr: state_type] :
      ( v144797(VarCurr,2)
    <=> v144802(VarCurr,2) ) ).

tff(addAssignment_81347,axiom,
    ! [VarCurr: state_type] :
      ( v144799(VarCurr,2)
    <=> v144801(VarCurr,2) ) ).

tff(addAssignment_81346,axiom,
    ! [VarCurr: state_type] :
      ( v144801(VarCurr,2)
    <=> v144710(VarCurr,2) ) ).

tff(addAssignment_81345,axiom,
    ! [VarCurr: state_type] :
      ( v144710(VarCurr,2)
    <=> v144622(VarCurr,5) ) ).

tff(addAssignment_81344,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,5)
    <=> v144624(VarCurr,5) ) ).

tff(addAssignment_81343,axiom,
    ! [VarNext: state_type] :
      ( v144624(VarNext,5)
    <=> v144946(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_2052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v144946(VarNext,B)
            <=> v144624(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2052,axiom,
    ! [VarNext: state_type] :
      ( v144947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144946(VarNext,B)
          <=> v144935(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144947(VarNext)
      <=> v144948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144948(VarNext)
      <=> ( v144950(VarNext)
          & v144877(VarNext) ) ) ) ).

tff(writeUnaryOperator_11027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144950(VarNext)
      <=> v144929(VarNext) ) ) ).

tff(addAssignment_81342,axiom,
    ! [VarCurr: state_type] :
      ( v144734(VarCurr,5)
    <=> v144736(VarCurr,5) ) ).

tff(addAssignment_81341,axiom,
    ! [VarCurr: state_type] :
      ( v144736(VarCurr,5)
    <=> v144874(VarCurr,5) ) ).

tff(addAssignment_81340,axiom,
    ! [VarCurr: state_type] :
      ( v144738(VarCurr,2)
    <=> v144740(VarCurr,2) ) ).

tff(addAssignment_81339,axiom,
    ! [VarCurr: state_type] :
      ( v144740(VarCurr,2)
    <=> v144742(VarCurr,2) ) ).

tff(addAssignment_81338,axiom,
    ! [VarCurr: state_type] :
      ( v144742(VarCurr,2)
    <=> v144873(VarCurr,2) ) ).

tff(addAssignment_81337,axiom,
    ! [VarCurr: state_type] :
      ( v144810(VarCurr,2)
    <=> v144812(VarCurr,2) ) ).

tff(addAssignment_81336,axiom,
    ! [VarCurr: state_type] :
      ( v144812(VarCurr,2)
    <=> v144814(VarCurr,2) ) ).

tff(addAssignment_81335,axiom,
    ! [VarCurr: state_type] :
      ( v144814(VarCurr,2)
    <=> v144816(VarCurr,2) ) ).

tff(addAssignment_81334,axiom,
    ! [VarCurr: state_type] :
      ( v144816(VarCurr,2)
    <=> v144818(VarCurr,2) ) ).

tff(addAssignment_81333,axiom,
    ! [VarCurr: state_type] :
      ( v144818(VarCurr,2)
    <=> v144828(VarCurr,2) ) ).

tff(addAssignment_81332,axiom,
    ! [VarCurr: state_type] :
      ( v144820(VarCurr,2)
    <=> v144822(VarCurr,2) ) ).

tff(addAssignment_81331,axiom,
    ! [VarCurr: state_type] :
      ( v144822(VarCurr,2)
    <=> v144823(VarCurr,2) ) ).

tff(addAssignment_81330,axiom,
    ! [VarCurr: state_type] :
      ( v144744(VarCurr,2)
    <=> v144746(VarCurr,2) ) ).

tff(addAssignment_81329,axiom,
    ! [VarCurr: state_type] :
      ( v144746(VarCurr,2)
    <=> v144807(VarCurr,2) ) ).

tff(addAssignment_81328,axiom,
    ! [VarCurr: state_type] :
      ( v144804(VarCurr)
    <=> v144806(VarCurr) ) ).

tff(addAssignment_81327,axiom,
    ! [VarCurr: state_type] :
      ( v144806(VarCurr)
    <=> v144710(VarCurr,1) ) ).

tff(addAssignment_81326,axiom,
    ! [VarCurr: state_type] :
      ( v144710(VarCurr,1)
    <=> v144622(VarCurr,4) ) ).

tff(addAssignment_81325,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,4)
    <=> v144624(VarCurr,4) ) ).

tff(addAssignment_81324,axiom,
    ! [VarNext: state_type] :
      ( v144624(VarNext,4)
    <=> v144924(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_2051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144925(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v144924(VarNext,B)
            <=> v144624(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2051,axiom,
    ! [VarNext: state_type] :
      ( v144925(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144924(VarNext,B)
          <=> v144935(VarNext,B) ) ) ) ).

tff(addAssignment_81323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144935(VarNext,B)
          <=> v144933(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144933(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1594,axiom,
    ! [VarCurr: state_type] :
      ( v144936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v144933(VarCurr,B)
          <=> v144734(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19328,axiom,
    ! [VarCurr: state_type] :
      ( v144936(VarCurr)
    <=> ( v144937(VarCurr)
        & v144938(VarCurr) ) ) ).

tff(writeUnaryOperator_11026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144938(VarCurr)
    <=> v144724(VarCurr) ) ).

tff(writeUnaryOperator_11025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144937(VarCurr)
    <=> v144712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144925(VarNext)
      <=> v144926(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144926(VarNext)
      <=> ( v144927(VarNext)
          & v144877(VarNext) ) ) ) ).

tff(writeUnaryOperator_11024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144927(VarNext)
      <=> v144929(VarNext) ) ) ).

tff(addAssignment_81322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144929(VarNext)
      <=> v144877(VarCurr) ) ) ).

tff(addAssignment_81321,axiom,
    ! [VarCurr: state_type] :
      ( v144877(VarCurr)
    <=> v144879(VarCurr) ) ).

tff(addAssignment_81320,axiom,
    ! [VarCurr: state_type] :
      ( v144879(VarCurr)
    <=> v144881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19325,axiom,
    ! [VarCurr: state_type] :
      ( v144881(VarCurr)
    <=> ( v144922(VarCurr)
        | v144918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19324,axiom,
    ! [VarCurr: state_type] :
      ( v144922(VarCurr)
    <=> ( v144883(VarCurr)
        & v144887(VarCurr) ) ) ).

tff(addAssignment_81319,axiom,
    ! [VarCurr: state_type] :
      ( v144918(VarCurr)
    <=> v144920(VarCurr) ) ).

tff(addAssignment_81318,axiom,
    ! [VarCurr: state_type] :
      ( v144920(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144902(VarNext)
       => ( v144887(VarNext)
        <=> v144887(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2050,axiom,
    ! [VarNext: state_type] :
      ( v144902(VarNext)
     => ( v144887(VarNext)
      <=> v144912(VarNext) ) ) ).

tff(addAssignment_81317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144912(VarNext)
      <=> v144910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19323,axiom,
    ! [VarCurr: state_type] :
      ( v144910(VarCurr)
    <=> ( v144913(VarCurr)
        & v144914(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19322,axiom,
    ! [VarCurr: state_type] :
      ( v144914(VarCurr)
    <=> ( v144893(VarCurr)
        | v144897(VarCurr) ) ) ).

tff(writeUnaryOperator_11023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144913(VarCurr)
    <=> v144889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144902(VarNext)
      <=> v144903(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144903(VarNext)
      <=> ( v144905(VarNext)
          & v144907(VarNext) ) ) ) ).

tff(writeUnaryOperator_11022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144907(VarCurr)
    <=> v144883(VarCurr) ) ).

tff(addAssignment_81316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144905(VarNext)
      <=> v144883(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_268,axiom,
    ( v144887(constB0)
  <=> $true ) ).

tff(addAssignment_81315,axiom,
    ! [VarCurr: state_type] :
      ( v144897(VarCurr)
    <=> v144899(VarCurr) ) ).

tff(addAssignment_81314,axiom,
    ! [VarCurr: state_type] :
      ( v144899(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81313,axiom,
    ! [VarCurr: state_type] :
      ( v144893(VarCurr)
    <=> v144895(VarCurr) ) ).

tff(addAssignment_81312,axiom,
    ! [VarCurr: state_type] :
      ( v144895(VarCurr)
    <=> $true ) ).

tff(addAssignment_81311,axiom,
    ! [VarCurr: state_type] :
      ( v144889(VarCurr)
    <=> v144891(VarCurr) ) ).

tff(addAssignment_81310,axiom,
    ! [VarCurr: state_type] :
      ( v144891(VarCurr)
    <=> $false ) ).

tff(addAssignment_81309,axiom,
    ! [VarCurr: state_type] :
      ( v144883(VarCurr)
    <=> v144885(VarCurr) ) ).

tff(addAssignment_81308,axiom,
    ! [VarCurr: state_type] :
      ( v144885(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81307,axiom,
    ! [VarCurr: state_type] :
      ( v144734(VarCurr,4)
    <=> v144736(VarCurr,4) ) ).

tff(addAssignment_81306,axiom,
    ! [VarCurr: state_type] :
      ( v144736(VarCurr,4)
    <=> v144874(VarCurr,4) ) ).

tff(addAssignment_81305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144874(VarCurr,B)
      <=> v144875(VarCurr,B) ) ) ).

tff(addAssignment_81304,axiom,
    ! [VarCurr: state_type] :
      ( ( v144874(VarCurr,5)
      <=> v144738(VarCurr,2) )
      & ( v144874(VarCurr,4)
      <=> v144738(VarCurr,1) )
      & ( v144874(VarCurr,3)
      <=> v144738(VarCurr,0) ) ) ).

tff(addAssignment_81303,axiom,
    ! [VarCurr: state_type] :
      ( v144738(VarCurr,1)
    <=> v144740(VarCurr,1) ) ).

tff(addAssignment_81302,axiom,
    ! [VarCurr: state_type] :
      ( v144740(VarCurr,1)
    <=> v144742(VarCurr,1) ) ).

tff(addAssignment_81301,axiom,
    ! [VarCurr: state_type] :
      ( v144742(VarCurr,1)
    <=> v144873(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144873(VarCurr,B)
      <=> ( v144744(VarCurr,B)
          & v144810(VarCurr,B) ) ) ) ).

tff(addAssignment_81300,axiom,
    ! [VarCurr: state_type] :
      ( v144810(VarCurr,1)
    <=> v144812(VarCurr,1) ) ).

tff(addAssignment_81299,axiom,
    ! [VarCurr: state_type] :
      ( v144812(VarCurr,1)
    <=> v144814(VarCurr,1) ) ).

tff(addAssignment_81298,axiom,
    ! [VarCurr: state_type] :
      ( v144814(VarCurr,1)
    <=> v144816(VarCurr,1) ) ).

tff(addAssignment_81297,axiom,
    ! [VarCurr: state_type] :
      ( v144816(VarCurr,1)
    <=> v144818(VarCurr,1) ) ).

tff(addAssignment_81296,axiom,
    ! [VarCurr: state_type] :
      ( v144818(VarCurr,1)
    <=> v144828(VarCurr,1) ) ).

tff(addAssignment_81295,axiom,
    ! [VarCurr: state_type] :
      ( v144828(VarCurr,0)
    <=> v144868(VarCurr) ) ).

tff(addAssignment_81294,axiom,
    ! [VarCurr: state_type] :
      ( v144828(VarCurr,1)
    <=> v144863(VarCurr) ) ).

tff(addAssignment_81293,axiom,
    ! [VarCurr: state_type] :
      ( v144828(VarCurr,2)
    <=> v144858(VarCurr) ) ).

tff(addAssignment_81292,axiom,
    ! [VarCurr: state_type] :
      ( v144828(VarCurr,3)
    <=> v144830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19319,axiom,
    ! [VarCurr: state_type] :
      ( v144868(VarCurr)
    <=> ( v144869(VarCurr)
        & v144872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19318,axiom,
    ! [VarCurr: state_type] :
      ( v144872(VarCurr)
    <=> ( v144820(VarCurr,0)
        | v144838(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19317,axiom,
    ! [VarCurr: state_type] :
      ( v144869(VarCurr)
    <=> ( v144870(VarCurr)
        | v144871(VarCurr) ) ) ).

tff(writeUnaryOperator_11021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144871(VarCurr)
    <=> v144838(VarCurr,0) ) ).

tff(writeUnaryOperator_11020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144870(VarCurr)
    <=> v144820(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19316,axiom,
    ! [VarCurr: state_type] :
      ( v144863(VarCurr)
    <=> ( v144864(VarCurr)
        & v144867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19315,axiom,
    ! [VarCurr: state_type] :
      ( v144867(VarCurr)
    <=> ( v144837(VarCurr)
        | v144839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19314,axiom,
    ! [VarCurr: state_type] :
      ( v144864(VarCurr)
    <=> ( v144865(VarCurr)
        | v144866(VarCurr) ) ) ).

tff(writeUnaryOperator_11019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144866(VarCurr)
    <=> v144839(VarCurr) ) ).

tff(writeUnaryOperator_11018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144865(VarCurr)
    <=> v144837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19313,axiom,
    ! [VarCurr: state_type] :
      ( v144858(VarCurr)
    <=> ( v144859(VarCurr)
        & v144862(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19312,axiom,
    ! [VarCurr: state_type] :
      ( v144862(VarCurr)
    <=> ( v144835(VarCurr)
        | v144845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19311,axiom,
    ! [VarCurr: state_type] :
      ( v144859(VarCurr)
    <=> ( v144860(VarCurr)
        | v144861(VarCurr) ) ) ).

tff(writeUnaryOperator_11017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144861(VarCurr)
    <=> v144845(VarCurr) ) ).

tff(writeUnaryOperator_11016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144860(VarCurr)
    <=> v144835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19310,axiom,
    ! [VarCurr: state_type] :
      ( v144830(VarCurr)
    <=> ( v144831(VarCurr)
        & v144857(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19309,axiom,
    ! [VarCurr: state_type] :
      ( v144857(VarCurr)
    <=> ( v144833(VarCurr)
        | v144852(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19308,axiom,
    ! [VarCurr: state_type] :
      ( v144831(VarCurr)
    <=> ( v144832(VarCurr)
        | v144851(VarCurr) ) ) ).

tff(writeUnaryOperator_11015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144851(VarCurr)
    <=> v144852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19307,axiom,
    ! [VarCurr: state_type] :
      ( v144852(VarCurr)
    <=> ( v144853(VarCurr)
        & v144856(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6926,axiom,
    ! [VarCurr: state_type] :
      ( v144856(VarCurr)
    <=> ( v144820(VarCurr,3)
        | v144838(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19306,axiom,
    ! [VarCurr: state_type] :
      ( v144853(VarCurr)
    <=> ( v144854(VarCurr)
        | v144855(VarCurr) ) ) ).

tff(writeUnaryOperator_11014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144855(VarCurr)
    <=> v144838(VarCurr,3) ) ).

tff(writeUnaryOperator_11013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144854(VarCurr)
    <=> v144820(VarCurr,3) ) ).

tff(writeUnaryOperator_11012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144832(VarCurr)
    <=> v144833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19305,axiom,
    ! [VarCurr: state_type] :
      ( v144833(VarCurr)
    <=> ( v144834(VarCurr)
        | v144850(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6925,axiom,
    ! [VarCurr: state_type] :
      ( v144850(VarCurr)
    <=> ( v144820(VarCurr,2)
        & v144838(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19304,axiom,
    ! [VarCurr: state_type] :
      ( v144834(VarCurr)
    <=> ( v144835(VarCurr)
        & v144845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19303,axiom,
    ! [VarCurr: state_type] :
      ( v144845(VarCurr)
    <=> ( v144846(VarCurr)
        & v144849(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6924,axiom,
    ! [VarCurr: state_type] :
      ( v144849(VarCurr)
    <=> ( v144820(VarCurr,2)
        | v144838(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19302,axiom,
    ! [VarCurr: state_type] :
      ( v144846(VarCurr)
    <=> ( v144847(VarCurr)
        | v144848(VarCurr) ) ) ).

tff(writeUnaryOperator_11011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144848(VarCurr)
    <=> v144838(VarCurr,2) ) ).

tff(writeUnaryOperator_11010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144847(VarCurr)
    <=> v144820(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19301,axiom,
    ! [VarCurr: state_type] :
      ( v144835(VarCurr)
    <=> ( v144836(VarCurr)
        | v144844(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6923,axiom,
    ! [VarCurr: state_type] :
      ( v144844(VarCurr)
    <=> ( v144820(VarCurr,1)
        & v144838(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19300,axiom,
    ! [VarCurr: state_type] :
      ( v144836(VarCurr)
    <=> ( v144837(VarCurr)
        & v144839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19299,axiom,
    ! [VarCurr: state_type] :
      ( v144839(VarCurr)
    <=> ( v144840(VarCurr)
        & v144843(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6922,axiom,
    ! [VarCurr: state_type] :
      ( v144843(VarCurr)
    <=> ( v144820(VarCurr,1)
        | v144838(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19298,axiom,
    ! [VarCurr: state_type] :
      ( v144840(VarCurr)
    <=> ( v144841(VarCurr)
        | v144842(VarCurr) ) ) ).

tff(writeUnaryOperator_11009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144842(VarCurr)
    <=> v144838(VarCurr,1) ) ).

tff(writeUnaryOperator_11008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144841(VarCurr)
    <=> v144820(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19297,axiom,
    ! [VarCurr: state_type] :
      ( v144837(VarCurr)
    <=> ( v144820(VarCurr,0)
        & v144838(VarCurr,0) ) ) ).

tff(addAssignment_81291,axiom,
    ! [VarCurr: state_type] :
      ( v144838(VarCurr,0)
    <=> v144825(VarCurr) ) ).

tff(addAssignment_81290,axiom,
    ! [VarCurr: state_type] :
      ( ( v144838(VarCurr,3)
      <=> $false )
      & ( v144838(VarCurr,2)
      <=> $false )
      & ( v144838(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_81289,axiom,
    ! [VarCurr: state_type] :
      ( v144825(VarCurr)
    <=> v144827(VarCurr) ) ).

tff(addAssignment_81288,axiom,
    ! [VarCurr: state_type] :
      ( v144827(VarCurr)
    <=> v144775(VarCurr) ) ).

tff(addAssignment_81287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v144820(VarCurr,B)
      <=> v144822(VarCurr,B) ) ) ).

tff(addAssignment_81286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v144822(VarCurr,B)
      <=> v144823(VarCurr,B) ) ) ).

tff(addAssignment_81285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144823(VarCurr,B)
      <=> v144710(VarCurr,B) ) ) ).

tff(addAssignment_81284,axiom,
    ! [VarCurr: state_type] :
      ( v144823(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_81283,axiom,
    ! [VarCurr: state_type] :
      ( v144744(VarCurr,1)
    <=> v144746(VarCurr,1) ) ).

tff(addAssignment_81282,axiom,
    ! [VarCurr: state_type] :
      ( v144746(VarCurr,1)
    <=> v144807(VarCurr,1) ) ).

tff(addAssignment_81281,axiom,
    ! [VarCurr: state_type] :
      ( v144807(VarCurr,0)
    <=> v144808(VarCurr) ) ).

tff(addAssignment_81280,axiom,
    ! [VarCurr: state_type] :
      ( v144807(VarCurr,1)
    <=> v144808(VarCurr) ) ).

tff(addAssignment_81279,axiom,
    ! [VarCurr: state_type] :
      ( v144807(VarCurr,2)
    <=> v144808(VarCurr) ) ).

tff(addAssignment_81278,axiom,
    ! [VarCurr: state_type] :
      ( v144808(VarCurr)
    <=> v144748(VarCurr) ) ).

tff(addAssignment_81277,axiom,
    ! [VarCurr: state_type] :
      ( v144789(VarCurr)
    <=> v144791(VarCurr) ) ).

tff(addAssignment_81276,axiom,
    ! [VarCurr: state_type] :
      ( v144791(VarCurr)
    <=> v144793(VarCurr,0) ) ).

tff(addAssignment_81275,axiom,
    ! [VarCurr: state_type] :
      ( v144793(VarCurr,0)
    <=> v144795(VarCurr,0) ) ).

tff(addAssignment_81274,axiom,
    ! [VarCurr: state_type] :
      ( v144795(VarCurr,0)
    <=> v144797(VarCurr,0) ) ).

tff(addAssignment_81273,axiom,
    ! [VarCurr: state_type] :
      ( v144797(VarCurr,0)
    <=> v144802(VarCurr,0) ) ).

tff(writeUnaryOperator_11007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144802(VarCurr,B)
      <=> ~ v144799(VarCurr,B) ) ) ).

tff(addAssignment_81272,axiom,
    ! [VarCurr: state_type] :
      ( v144799(VarCurr,0)
    <=> v144801(VarCurr,0) ) ).

tff(addAssignment_81271,axiom,
    ! [VarCurr: state_type] :
      ( v144801(VarCurr,0)
    <=> v144710(VarCurr,0) ) ).

tff(addAssignment_81270,axiom,
    ! [VarCurr: state_type] :
      ( v144771(VarCurr,1)
    <=> v144773(VarCurr,1) ) ).

tff(addAssignment_81269,axiom,
    ! [VarCurr: state_type] :
      ( v144773(VarCurr,1)
    <=> v144776(VarCurr,1) ) ).

tff(addAssignment_81268,axiom,
    ! [VarCurr: state_type] :
      ( v144776(VarCurr,0)
    <=> v144777(VarCurr) ) ).

tff(addAssignment_81267,axiom,
    ! [VarCurr: state_type] :
      ( v144776(VarCurr,1)
    <=> v144775(VarCurr) ) ).

tff(addAssignment_81266,axiom,
    ! [VarCurr: state_type] :
      ( v144775(VarCurr)
    <=> v7230(VarCurr,0) ) ).

tff(addAssignment_81265,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,0)
    <=> v7232(VarCurr,0) ) ).

tff(addAssignment_81264,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,0)
    <=> v7234(VarCurr,0) ) ).

tff(addAssignment_81263,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,0)
    <=> v34455(VarCurr,0) ) ).

tff(addAssignment_81262,axiom,
    ! [VarCurr: state_type] :
      ( v144755(VarCurr,1)
    <=> v144757(VarCurr,1) ) ).

tff(addAssignment_81261,axiom,
    ! [VarCurr: state_type] :
      ( v144757(VarCurr,1)
    <=> v144758(VarCurr,1) ) ).

tff(addAssignment_81260,axiom,
    ! [VarCurr: state_type] :
      ( v144758(VarCurr,0)
    <=> v144759(VarCurr) ) ).

tff(addAssignment_81259,axiom,
    ! [VarCurr: state_type] :
      ( v144758(VarCurr,1)
    <=> v144759(VarCurr) ) ).

tff(addAssignment_81258,axiom,
    ! [VarCurr: state_type] :
      ( v144759(VarCurr)
    <=> v4193(VarCurr) ) ).

tff(addAssignment_81257,axiom,
    ! [VarCurr: state_type] :
      ( v144724(VarCurr)
    <=> v144726(VarCurr) ) ).

tff(addAssignment_81256,axiom,
    ! [VarCurr: state_type] :
      ( v144726(VarCurr)
    <=> v144728(VarCurr) ) ).

tff(addAssignment_81255,axiom,
    ! [VarCurr: state_type] :
      ( v144728(VarCurr)
    <=> v144730(VarCurr) ) ).

tff(addAssignment_81254,axiom,
    ! [VarCurr: state_type] :
      ( v144730(VarCurr)
    <=> v144732(VarCurr) ) ).

tff(addAssignment_81253,axiom,
    ! [VarCurr: state_type] :
      ( v144732(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_81252,axiom,
    ! [VarCurr: state_type] :
      ( v144712(VarCurr)
    <=> v144714(VarCurr) ) ).

tff(addAssignment_81251,axiom,
    ! [VarCurr: state_type] :
      ( v144714(VarCurr)
    <=> v144716(VarCurr) ) ).

tff(addAssignment_81250,axiom,
    ! [VarCurr: state_type] :
      ( v144716(VarCurr)
    <=> v144718(VarCurr) ) ).

tff(addAssignment_81249,axiom,
    ! [VarCurr: state_type] :
      ( v144718(VarCurr)
    <=> v144720(VarCurr) ) ).

tff(addAssignment_81248,axiom,
    ! [VarCurr: state_type] :
      ( v144720(VarCurr)
    <=> v144722(VarCurr) ) ).

tff(addAssignment_81247,axiom,
    ! [VarCurr: state_type] :
      ( v144722(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_81246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4127(VarCurr,B)
      <=> v4129(VarCurr,B) ) ) ).

tff(addAssignment_81245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4129(VarCurr,B)
      <=> v4131(VarCurr,B) ) ) ).

tff(addAssignment_81244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4131(VarCurr,B)
      <=> v4133(VarCurr,B) ) ) ).

tff(addAssignment_81243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4133(VarCurr,B)
      <=> v4135(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144673(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v4135(VarNext,B)
            <=> v4135(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2049,axiom,
    ! [VarNext: state_type] :
      ( v144673(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v4135(VarNext,B)
          <=> v144683(VarNext,B) ) ) ) ).

tff(addAssignment_81242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144683(VarNext,B)
          <=> v144681(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144684(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144681(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1593,axiom,
    ! [VarCurr: state_type] :
      ( v144684(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144681(VarCurr,B)
          <=> v4169(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19296,axiom,
    ! [VarCurr: state_type] :
      ( v144684(VarCurr)
    <=> ( v144685(VarCurr)
        & v144686(VarCurr) ) ) ).

tff(writeUnaryOperator_11006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144686(VarCurr)
    <=> v4153(VarCurr) ) ).

tff(writeUnaryOperator_11005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144685(VarCurr)
    <=> v4137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144673(VarNext)
      <=> v144674(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144674(VarNext)
      <=> ( v144675(VarNext)
          & v144588(VarNext) ) ) ) ).

tff(writeUnaryOperator_11004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144675(VarNext)
      <=> v144677(VarNext) ) ) ).

tff(addAssignment_81241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144677(VarNext)
      <=> v144588(VarCurr) ) ) ).

tff(addAssignment_81240,axiom,
    ! [VarCurr: state_type] :
      ( v144588(VarCurr)
    <=> v144590(VarCurr) ) ).

tff(addAssignment_81239,axiom,
    ! [VarCurr: state_type] :
      ( v144590(VarCurr)
    <=> v144592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19293,axiom,
    ! [VarCurr: state_type] :
      ( v144592(VarCurr)
    <=> ( v144670(VarCurr)
        | v144662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19292,axiom,
    ! [VarCurr: state_type] :
      ( v144670(VarCurr)
    <=> ( v144594(VarCurr)
        & v144600(VarCurr) ) ) ).

tff(addAssignment_81238,axiom,
    ! [VarCurr: state_type] :
      ( v144662(VarCurr)
    <=> v144664(VarCurr) ) ).

tff(addAssignment_81237,axiom,
    ! [VarCurr: state_type] :
      ( v144664(VarCurr)
    <=> v144666(VarCurr) ) ).

tff(addAssignment_81236,axiom,
    ! [VarCurr: state_type] :
      ( v144666(VarCurr)
    <=> v144668(VarCurr) ) ).

tff(addAssignment_81235,axiom,
    ! [VarCurr: state_type] :
      ( v144668(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144646(VarNext)
       => ( v144600(VarNext)
        <=> v144600(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2048,axiom,
    ! [VarNext: state_type] :
      ( v144646(VarNext)
     => ( v144600(VarNext)
      <=> v144656(VarNext) ) ) ).

tff(addAssignment_81234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144656(VarNext)
      <=> v144654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19291,axiom,
    ! [VarCurr: state_type] :
      ( v144654(VarCurr)
    <=> ( v144657(VarCurr)
        & v144658(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19290,axiom,
    ! [VarCurr: state_type] :
      ( v144658(VarCurr)
    <=> ( v144606(VarCurr)
        | v144637(VarCurr) ) ) ).

tff(writeUnaryOperator_11003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144657(VarCurr)
    <=> v144602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144646(VarNext)
      <=> v144647(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144647(VarNext)
      <=> ( v144649(VarNext)
          & v144651(VarNext) ) ) ) ).

tff(writeUnaryOperator_11002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144651(VarCurr)
    <=> v144594(VarCurr) ) ).

tff(addAssignment_81233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144649(VarNext)
      <=> v144594(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_267,axiom,
    ( v144600(constB0)
  <=> $true ) ).

tff(addAssignment_81232,axiom,
    ! [VarCurr: state_type] :
      ( v144637(VarCurr)
    <=> v144639(VarCurr) ) ).

tff(addAssignment_81231,axiom,
    ! [VarCurr: state_type] :
      ( v144639(VarCurr)
    <=> v144641(VarCurr) ) ).

tff(addAssignment_81230,axiom,
    ! [VarCurr: state_type] :
      ( v144641(VarCurr)
    <=> v144643(VarCurr) ) ).

tff(addAssignment_81229,axiom,
    ! [VarCurr: state_type] :
      ( v144643(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_81228,axiom,
    ! [VarCurr: state_type] :
      ( v144606(VarCurr)
    <=> v144608(VarCurr) ) ).

tff(addAssignment_81227,axiom,
    ! [VarCurr: state_type] :
      ( v144608(VarCurr)
    <=> v144610(VarCurr) ) ).

tff(addAssignment_81226,axiom,
    ! [VarCurr: state_type] :
      ( v144610(VarCurr)
    <=> v144612(VarCurr) ) ).

tff(addAssignment_81225,axiom,
    ! [VarCurr: state_type] :
      ( v144612(VarCurr)
    <=> v144614(VarCurr) ) ).

tff(writeUnaryOperator_11001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144614(VarCurr)
    <=> v144634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19287,axiom,
    ! [VarCurr: state_type] :
      ( v144634(VarCurr)
    <=> ( v144635(VarCurr)
        | v144630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19286,axiom,
    ! [VarCurr: state_type] :
      ( v144635(VarCurr)
    <=> ( v144616(VarCurr)
        | v144626(VarCurr) ) ) ).

tff(addAssignment_81224,axiom,
    ! [VarCurr: state_type] :
      ( v144630(VarCurr)
    <=> v144632(VarCurr) ) ).

tff(addAssignment_81223,axiom,
    ! [VarCurr: state_type] :
      ( v144632(VarCurr)
    <=> v144620(VarCurr,2) ) ).

tff(addAssignment_81222,axiom,
    ! [VarCurr: state_type] :
      ( v144620(VarCurr,2)
    <=> v144622(VarCurr,2) ) ).

tff(addAssignment_81221,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,2)
    <=> v144624(VarCurr,2) ) ).

tff(addAssignment_81220,axiom,
    ! [VarCurr: state_type] :
      ( v144626(VarCurr)
    <=> v144628(VarCurr) ) ).

tff(addAssignment_81219,axiom,
    ! [VarCurr: state_type] :
      ( v144628(VarCurr)
    <=> v144620(VarCurr,1) ) ).

tff(addAssignment_81218,axiom,
    ! [VarCurr: state_type] :
      ( v144620(VarCurr,1)
    <=> v144622(VarCurr,1) ) ).

tff(addAssignment_81217,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,1)
    <=> v144624(VarCurr,1) ) ).

tff(addAssignment_81216,axiom,
    ! [VarCurr: state_type] :
      ( v144616(VarCurr)
    <=> v144618(VarCurr) ) ).

tff(addAssignment_81215,axiom,
    ! [VarCurr: state_type] :
      ( v144618(VarCurr)
    <=> v144620(VarCurr,0) ) ).

tff(addAssignment_81214,axiom,
    ! [VarCurr: state_type] :
      ( v144620(VarCurr,0)
    <=> v144622(VarCurr,0) ) ).

tff(addAssignment_81213,axiom,
    ! [VarCurr: state_type] :
      ( v144622(VarCurr,0)
    <=> v144624(VarCurr,0) ) ).

tff(addAssignment_81212,axiom,
    ! [VarCurr: state_type] :
      ( v144602(VarCurr)
    <=> v144604(VarCurr) ) ).

tff(addAssignment_81211,axiom,
    ! [VarCurr: state_type] :
      ( v144604(VarCurr)
    <=> $false ) ).

tff(addAssignment_81210,axiom,
    ! [VarCurr: state_type] :
      ( v144594(VarCurr)
    <=> v144596(VarCurr) ) ).

tff(addAssignment_81209,axiom,
    ! [VarCurr: state_type] :
      ( v144596(VarCurr)
    <=> v144598(VarCurr) ) ).

tff(addAssignment_81208,axiom,
    ! [VarCurr: state_type] :
      ( v144598(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_81207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4169(VarCurr,B)
      <=> v4171(VarCurr,B) ) ) ).

tff(addAssignment_81206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4171(VarCurr,B)
      <=> v4173(VarCurr,B) ) ) ).

tff(addAssignment_81205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4173(VarCurr,B)
      <=> v4175(VarCurr,B) ) ) ).

tff(addAssignment_81204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4175(VarCurr,B)
      <=> v4177(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4177(VarCurr,B)
      <=> ( v4179(VarCurr,B)
          & v144290(VarCurr,B) ) ) ) ).

tff(addAssignment_81203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144290(VarCurr,B)
      <=> v144292(VarCurr,B) ) ) ).

tff(addAssignment_81202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144292(VarCurr,B)
      <=> v144294(VarCurr,B) ) ) ).

tff(addAssignment_81201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144294(VarCurr,B)
      <=> v6324(VarCurr,B) ) ) ).

tff(addAssignment_81200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6324(VarCurr,B)
      <=> v144296(VarCurr,B) ) ) ).

tff(addAssignment_81199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144296(VarCurr,B)
      <=> v144298(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144298(VarCurr,B)
      <=> ( v144580(VarCurr,B)
          | v144583(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144583(VarCurr,B)
      <=> ( v144572(VarCurr,B)
          & v144584(VarCurr,B) ) ) ) ).

tff(addAssignment_81198,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,0)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81197,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,1)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81196,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,2)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81195,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,3)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81194,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,4)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81193,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,5)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81192,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,6)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81191,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,7)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81190,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,8)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81189,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,9)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81188,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,10)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81187,axiom,
    ! [VarCurr: state_type] :
      ( v144584(VarCurr,11)
    <=> v144585(VarCurr) ) ).

tff(addAssignment_81186,axiom,
    ! [VarCurr: state_type] :
      ( v144585(VarCurr)
    <=> v144576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144580(VarCurr,B)
      <=> ( v144300(VarCurr,B)
          & v144581(VarCurr,B) ) ) ) ).

tff(addAssignment_81185,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,0)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81184,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,1)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81183,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,2)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81182,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,3)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81181,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,4)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81180,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,5)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81179,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,6)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81178,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,7)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81177,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,8)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81176,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,9)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81175,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,10)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81174,axiom,
    ! [VarCurr: state_type] :
      ( v144581(VarCurr,11)
    <=> v144582(VarCurr) ) ).

tff(addAssignment_81173,axiom,
    ! [VarCurr: state_type] :
      ( v144582(VarCurr)
    <=> v144568(VarCurr) ) ).

tff(addAssignment_81172,axiom,
    ! [VarCurr: state_type] :
      ( v144576(VarCurr)
    <=> v144578(VarCurr) ) ).

tff(addAssignment_81171,axiom,
    ! [VarCurr: state_type] :
      ( v144578(VarCurr)
    <=> v7021(VarCurr,0) ) ).

tff(addAssignment_81170,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,0)
    <=> v7023(VarCurr,0) ) ).

tff(addAssignment_81169,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,0)
    <=> v6623(VarCurr,0) ) ).

tff(addAssignment_81168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144572(VarCurr,B)
      <=> v144574(VarCurr,B) ) ) ).

tff(addAssignment_81167,axiom,
    ! [VarCurr: state_type] :
      ( ( v144574(VarCurr,11)
      <=> v6334(VarCurr,23) )
      & ( v144574(VarCurr,10)
      <=> v6334(VarCurr,22) )
      & ( v144574(VarCurr,9)
      <=> v6334(VarCurr,21) )
      & ( v144574(VarCurr,8)
      <=> v6334(VarCurr,20) )
      & ( v144574(VarCurr,7)
      <=> v6334(VarCurr,19) )
      & ( v144574(VarCurr,6)
      <=> v6334(VarCurr,18) )
      & ( v144574(VarCurr,5)
      <=> v6334(VarCurr,17) )
      & ( v144574(VarCurr,4)
      <=> v6334(VarCurr,16) )
      & ( v144574(VarCurr,3)
      <=> v6334(VarCurr,15) )
      & ( v144574(VarCurr,2)
      <=> v6334(VarCurr,14) )
      & ( v144574(VarCurr,1)
      <=> v6334(VarCurr,13) )
      & ( v144574(VarCurr,0)
      <=> v6334(VarCurr,12) ) ) ).

tff(addAssignment_81166,axiom,
    ! [VarCurr: state_type] :
      ( v144568(VarCurr)
    <=> v144570(VarCurr) ) ).

tff(addAssignment_81165,axiom,
    ! [VarCurr: state_type] :
      ( v144570(VarCurr)
    <=> v6617(VarCurr,0) ) ).

tff(addAssignment_81164,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,0)
    <=> v6619(VarCurr,0) ) ).

tff(addAssignment_81163,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,0)
    <=> v6621(VarCurr,0) ) ).

tff(addAssignment_81162,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,0)
    <=> v6747(VarCurr,0) ) ).

tff(addAssignment_81161,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,0)
    <=> v6690(VarCurr,0) ) ).

tff(addAssignment_81160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144300(VarCurr,B)
      <=> v144302(VarCurr,B) ) ) ).

tff(addAssignment_81159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144302(VarCurr,B)
      <=> v6334(VarCurr,B) ) ) ).

tff(addAssignment_81158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_81157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_81156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6338(VarCurr,B)
      <=> v144304(VarCurr,B) ) ) ).

tff(addAssignment_81155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144304(VarCurr,B)
      <=> v144306(VarCurr,B) ) ) ).

tff(addAssignment_81154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144306(VarCurr,B)
      <=> v144308(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144551(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v144308(VarNext,B)
            <=> v144308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2047,axiom,
    ! [VarNext: state_type] :
      ( v144551(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144308(VarNext,B)
          <=> v144561(VarNext,B) ) ) ) ).

tff(addAssignment_81153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144561(VarNext,B)
          <=> v144559(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144562(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144559(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1592,axiom,
    ! [VarCurr: state_type] :
      ( v144562(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v144559(VarCurr,B)
          <=> v144338(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19285,axiom,
    ! [VarCurr: state_type] :
      ( v144562(VarCurr)
    <=> ( v144563(VarCurr)
        & v144564(VarCurr) ) ) ).

tff(writeUnaryOperator_11000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144564(VarCurr)
    <=> v144324(VarCurr) ) ).

tff(writeUnaryOperator_10999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144563(VarCurr)
    <=> v144310(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144551(VarNext)
      <=> v144552(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144552(VarNext)
      <=> ( v144553(VarNext)
          & v144526(VarNext) ) ) ) ).

tff(writeUnaryOperator_10998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144553(VarNext)
      <=> v144555(VarNext) ) ) ).

tff(addAssignment_81152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144555(VarNext)
      <=> v144526(VarCurr) ) ) ).

tff(addAssignment_81151,axiom,
    ! [VarCurr: state_type] :
      ( v144526(VarCurr)
    <=> v144528(VarCurr) ) ).

tff(addAssignment_81150,axiom,
    ! [VarCurr: state_type] :
      ( v144528(VarCurr)
    <=> v144530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19282,axiom,
    ! [VarCurr: state_type] :
      ( v144530(VarCurr)
    <=> ( v144548(VarCurr)
        | v144540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19281,axiom,
    ! [VarCurr: state_type] :
      ( v144548(VarCurr)
    <=> ( v144532(VarCurr)
        & v144538(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_266,axiom,
    ( v144538(constB0)
  <=> $true ) ).

tff(addAssignment_81149,axiom,
    ! [VarCurr: state_type] :
      ( v144540(VarCurr)
    <=> v144542(VarCurr) ) ).

tff(addAssignment_81148,axiom,
    ! [VarCurr: state_type] :
      ( v144542(VarCurr)
    <=> v144544(VarCurr) ) ).

tff(addAssignment_81147,axiom,
    ! [VarCurr: state_type] :
      ( v144544(VarCurr)
    <=> v144546(VarCurr) ) ).

tff(addAssignment_81146,axiom,
    ! [VarCurr: state_type] :
      ( v144546(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_81145,axiom,
    ! [VarCurr: state_type] :
      ( v144532(VarCurr)
    <=> v144534(VarCurr) ) ).

tff(addAssignment_81144,axiom,
    ! [VarCurr: state_type] :
      ( v144534(VarCurr)
    <=> v144536(VarCurr) ) ).

tff(addAssignment_81143,axiom,
    ! [VarCurr: state_type] :
      ( v144536(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_81142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144338(VarCurr,B)
      <=> v144340(VarCurr,B) ) ) ).

tff(addAssignment_81141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144340(VarCurr,B)
      <=> v144342(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144342(VarCurr,B)
      <=> ( v144511(VarCurr,B)
          | v144522(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144522(VarCurr,B)
      <=> ( v144475(VarCurr,B)
          & v144523(VarCurr,B) ) ) ) ).

tff(addAssignment_81140,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,0)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81139,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,1)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81138,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,2)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81137,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,3)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81136,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,4)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81135,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,5)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81134,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,6)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81133,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,7)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81132,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,8)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81131,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,9)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81130,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,10)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81129,axiom,
    ! [VarCurr: state_type] :
      ( v144523(VarCurr,11)
    <=> v144524(VarCurr) ) ).

tff(addAssignment_81128,axiom,
    ! [VarCurr: state_type] :
      ( v144524(VarCurr)
    <=> v144485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144511(VarCurr,B)
      <=> ( v144512(VarCurr,B)
          | v144519(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144519(VarCurr,B)
      <=> ( v144439(VarCurr,B)
          & v144520(VarCurr,B) ) ) ) ).

tff(addAssignment_81127,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,0)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81126,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,1)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81125,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,2)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81124,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,3)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81123,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,4)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81122,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,5)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81121,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,6)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81120,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,7)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81119,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,8)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81118,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,9)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81117,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,10)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81116,axiom,
    ! [VarCurr: state_type] :
      ( v144520(VarCurr,11)
    <=> v144521(VarCurr) ) ).

tff(addAssignment_81115,axiom,
    ! [VarCurr: state_type] :
      ( v144521(VarCurr)
    <=> v144449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144512(VarCurr,B)
      <=> ( v144513(VarCurr,B)
          | v144516(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144516(VarCurr,B)
      <=> ( v144392(VarCurr,B)
          & v144517(VarCurr,B) ) ) ) ).

tff(addAssignment_81114,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,0)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81113,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,1)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81112,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,2)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81111,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,3)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81110,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,4)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81109,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,5)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81108,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,6)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81107,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,7)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81106,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,8)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81105,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,9)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81104,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,10)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81103,axiom,
    ! [VarCurr: state_type] :
      ( v144517(VarCurr,11)
    <=> v144518(VarCurr) ) ).

tff(addAssignment_81102,axiom,
    ! [VarCurr: state_type] :
      ( v144518(VarCurr)
    <=> v144402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144513(VarCurr,B)
      <=> ( v144344(VarCurr,B)
          & v144514(VarCurr,B) ) ) ) ).

tff(addAssignment_81101,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,0)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81100,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,1)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81099,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,2)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81098,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,3)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81097,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,4)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81096,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,5)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81095,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,6)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81094,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,7)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81093,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,8)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81092,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,9)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81091,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,10)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81090,axiom,
    ! [VarCurr: state_type] :
      ( v144514(VarCurr,11)
    <=> v144515(VarCurr) ) ).

tff(addAssignment_81089,axiom,
    ! [VarCurr: state_type] :
      ( v144515(VarCurr)
    <=> v144354(VarCurr) ) ).

tff(addAssignment_81088,axiom,
    ! [VarCurr: state_type] :
      ( v144485(VarCurr)
    <=> v144487(VarCurr) ) ).

tff(addAssignment_81087,axiom,
    ! [VarCurr: state_type] :
      ( v144487(VarCurr)
    <=> v144489(VarCurr) ) ).

tff(addAssignment_81086,axiom,
    ! [VarCurr: state_type] :
      ( v144489(VarCurr)
    <=> v144491(VarCurr) ) ).

tff(addAssignment_81085,axiom,
    ! [VarCurr: state_type] :
      ( v144491(VarCurr)
    <=> v144493(VarCurr) ) ).

tff(addAssignment_81084,axiom,
    ! [VarCurr: state_type] :
      ( v144493(VarCurr)
    <=> v144495(VarCurr) ) ).

tff(addAssignment_81083,axiom,
    ! [VarCurr: state_type] :
      ( v144495(VarCurr)
    <=> v144497(VarCurr) ) ).

tff(addAssignment_81082,axiom,
    ! [VarCurr: state_type] :
      ( v144497(VarCurr)
    <=> v144499(VarCurr) ) ).

tff(writeUnaryOperator_10997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144499(VarCurr)
    <=> v144509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19280,axiom,
    ! [VarCurr: state_type] :
      ( v144509(VarCurr)
    <=> ( v144501(VarCurr)
        | v144505(VarCurr) ) ) ).

tff(addAssignment_81081,axiom,
    ! [VarCurr: state_type] :
      ( v144505(VarCurr)
    <=> v144507(VarCurr) ) ).

tff(addAssignment_81080,axiom,
    ! [VarCurr: state_type] :
      ( v144507(VarCurr)
    <=> v144422(VarCurr,1) ) ).

tff(addAssignment_81079,axiom,
    ! [VarCurr: state_type] :
      ( v144501(VarCurr)
    <=> v144503(VarCurr) ) ).

tff(addAssignment_81078,axiom,
    ! [VarCurr: state_type] :
      ( v144503(VarCurr)
    <=> v144422(VarCurr,0) ) ).

tff(addAssignment_81077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144475(VarCurr,B)
      <=> v144477(VarCurr,B) ) ) ).

tff(addAssignment_81076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144477(VarCurr,B)
      <=> v144479(VarCurr,B) ) ) ).

tff(addAssignment_81075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144479(VarCurr,B)
      <=> v144481(VarCurr,B) ) ) ).

tff(addAssignment_81074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144481(VarCurr,B)
      <=> v144483(VarCurr,B) ) ) ).

tff(addAssignment_81073,axiom,
    ! [VarCurr: state_type] :
      ( v144449(VarCurr)
    <=> v144451(VarCurr) ) ).

tff(addAssignment_81072,axiom,
    ! [VarCurr: state_type] :
      ( v144451(VarCurr)
    <=> v144453(VarCurr) ) ).

tff(addAssignment_81071,axiom,
    ! [VarCurr: state_type] :
      ( v144453(VarCurr)
    <=> v144455(VarCurr) ) ).

tff(addAssignment_81070,axiom,
    ! [VarCurr: state_type] :
      ( v144455(VarCurr)
    <=> v144457(VarCurr) ) ).

tff(addAssignment_81069,axiom,
    ! [VarCurr: state_type] :
      ( v144457(VarCurr)
    <=> v144459(VarCurr) ) ).

tff(addAssignment_81068,axiom,
    ! [VarCurr: state_type] :
      ( v144459(VarCurr)
    <=> v144461(VarCurr) ) ).

tff(addAssignment_81067,axiom,
    ! [VarCurr: state_type] :
      ( v144461(VarCurr)
    <=> v144463(VarCurr) ) ).

tff(writeUnaryOperator_10996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144463(VarCurr)
    <=> v144473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19279,axiom,
    ! [VarCurr: state_type] :
      ( v144473(VarCurr)
    <=> ( v144465(VarCurr)
        | v144469(VarCurr) ) ) ).

tff(addAssignment_81066,axiom,
    ! [VarCurr: state_type] :
      ( v144469(VarCurr)
    <=> v144471(VarCurr) ) ).

tff(addAssignment_81065,axiom,
    ! [VarCurr: state_type] :
      ( v144471(VarCurr)
    <=> v144422(VarCurr,1) ) ).

tff(addAssignment_81064,axiom,
    ! [VarCurr: state_type] :
      ( v144422(VarCurr,1)
    <=> v144424(VarCurr,1) ) ).

tff(addAssignment_81063,axiom,
    ! [VarCurr: state_type] :
      ( v144424(VarCurr,1)
    <=> v144426(VarCurr,1) ) ).

tff(addAssignment_81062,axiom,
    ! [VarCurr: state_type] :
      ( v144426(VarCurr,1)
    <=> v144431(VarCurr,1) ) ).

tff(addAssignment_81061,axiom,
    ! [VarCurr: state_type] :
      ( v144428(VarCurr,1)
    <=> v144430(VarCurr,1) ) ).

tff(addAssignment_81060,axiom,
    ! [VarCurr: state_type] :
      ( v144430(VarCurr,1)
    <=> v144374(VarCurr,1) ) ).

tff(addAssignment_81059,axiom,
    ! [VarCurr: state_type] :
      ( v144465(VarCurr)
    <=> v144467(VarCurr) ) ).

tff(addAssignment_81058,axiom,
    ! [VarCurr: state_type] :
      ( v144467(VarCurr)
    <=> v144374(VarCurr,0) ) ).

tff(addAssignment_81057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144439(VarCurr,B)
      <=> v144441(VarCurr,B) ) ) ).

tff(addAssignment_81056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144441(VarCurr,B)
      <=> v144443(VarCurr,B) ) ) ).

tff(addAssignment_81055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144443(VarCurr,B)
      <=> v144445(VarCurr,B) ) ) ).

tff(addAssignment_81054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144445(VarCurr,B)
      <=> v144447(VarCurr,B) ) ) ).

tff(addAssignment_81053,axiom,
    ! [VarCurr: state_type] :
      ( v144402(VarCurr)
    <=> v144404(VarCurr) ) ).

tff(addAssignment_81052,axiom,
    ! [VarCurr: state_type] :
      ( v144404(VarCurr)
    <=> v144406(VarCurr) ) ).

tff(addAssignment_81051,axiom,
    ! [VarCurr: state_type] :
      ( v144406(VarCurr)
    <=> v144408(VarCurr) ) ).

tff(addAssignment_81050,axiom,
    ! [VarCurr: state_type] :
      ( v144408(VarCurr)
    <=> v144410(VarCurr) ) ).

tff(addAssignment_81049,axiom,
    ! [VarCurr: state_type] :
      ( v144410(VarCurr)
    <=> v144412(VarCurr) ) ).

tff(addAssignment_81048,axiom,
    ! [VarCurr: state_type] :
      ( v144412(VarCurr)
    <=> v144414(VarCurr) ) ).

tff(addAssignment_81047,axiom,
    ! [VarCurr: state_type] :
      ( v144414(VarCurr)
    <=> v144416(VarCurr) ) ).

tff(writeUnaryOperator_10995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144416(VarCurr)
    <=> v144437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19278,axiom,
    ! [VarCurr: state_type] :
      ( v144437(VarCurr)
    <=> ( v144418(VarCurr)
        | v144433(VarCurr) ) ) ).

tff(addAssignment_81046,axiom,
    ! [VarCurr: state_type] :
      ( v144433(VarCurr)
    <=> v144435(VarCurr) ) ).

tff(addAssignment_81045,axiom,
    ! [VarCurr: state_type] :
      ( v144435(VarCurr)
    <=> v144374(VarCurr,1) ) ).

tff(addAssignment_81044,axiom,
    ! [VarCurr: state_type] :
      ( v144418(VarCurr)
    <=> v144420(VarCurr) ) ).

tff(addAssignment_81043,axiom,
    ! [VarCurr: state_type] :
      ( v144420(VarCurr)
    <=> v144422(VarCurr,0) ) ).

tff(addAssignment_81042,axiom,
    ! [VarCurr: state_type] :
      ( v144422(VarCurr,0)
    <=> v144424(VarCurr,0) ) ).

tff(addAssignment_81041,axiom,
    ! [VarCurr: state_type] :
      ( v144424(VarCurr,0)
    <=> v144426(VarCurr,0) ) ).

tff(addAssignment_81040,axiom,
    ! [VarCurr: state_type] :
      ( v144426(VarCurr,0)
    <=> v144431(VarCurr,0) ) ).

tff(writeUnaryOperator_10994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v144431(VarCurr,B)
      <=> ~ v144428(VarCurr,B) ) ) ).

tff(addAssignment_81039,axiom,
    ! [VarCurr: state_type] :
      ( v144428(VarCurr,0)
    <=> v144430(VarCurr,0) ) ).

tff(addAssignment_81038,axiom,
    ! [VarCurr: state_type] :
      ( v144430(VarCurr,0)
    <=> v144374(VarCurr,0) ) ).

tff(addAssignment_81037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144392(VarCurr,B)
      <=> v144394(VarCurr,B) ) ) ).

tff(addAssignment_81036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144394(VarCurr,B)
      <=> v144396(VarCurr,B) ) ) ).

tff(addAssignment_81035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144396(VarCurr,B)
      <=> v144398(VarCurr,B) ) ) ).

tff(addAssignment_81034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144398(VarCurr,B)
      <=> v144400(VarCurr,B) ) ) ).

tff(addAssignment_81033,axiom,
    ! [VarCurr: state_type] :
      ( v144354(VarCurr)
    <=> v144356(VarCurr) ) ).

tff(addAssignment_81032,axiom,
    ! [VarCurr: state_type] :
      ( v144356(VarCurr)
    <=> v144358(VarCurr) ) ).

tff(addAssignment_81031,axiom,
    ! [VarCurr: state_type] :
      ( v144358(VarCurr)
    <=> v144360(VarCurr) ) ).

tff(addAssignment_81030,axiom,
    ! [VarCurr: state_type] :
      ( v144360(VarCurr)
    <=> v144362(VarCurr) ) ).

tff(addAssignment_81029,axiom,
    ! [VarCurr: state_type] :
      ( v144362(VarCurr)
    <=> v144364(VarCurr) ) ).

tff(addAssignment_81028,axiom,
    ! [VarCurr: state_type] :
      ( v144364(VarCurr)
    <=> v144366(VarCurr) ) ).

tff(addAssignment_81027,axiom,
    ! [VarCurr: state_type] :
      ( v144366(VarCurr)
    <=> v144368(VarCurr) ) ).

tff(writeUnaryOperator_10993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144368(VarCurr)
    <=> v144390(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19277,axiom,
    ! [VarCurr: state_type] :
      ( v144390(VarCurr)
    <=> ( v144370(VarCurr)
        | v144386(VarCurr) ) ) ).

tff(addAssignment_81026,axiom,
    ! [VarCurr: state_type] :
      ( v144386(VarCurr)
    <=> v144388(VarCurr) ) ).

tff(addAssignment_81025,axiom,
    ! [VarCurr: state_type] :
      ( v144388(VarCurr)
    <=> v144374(VarCurr,1) ) ).

tff(addAssignment_81024,axiom,
    ! [VarCurr: state_type] :
      ( v144374(VarCurr,1)
    <=> v144376(VarCurr,1) ) ).

tff(addAssignment_81023,axiom,
    ! [VarCurr: state_type] :
      ( v144376(VarCurr,1)
    <=> v144378(VarCurr,1) ) ).

tff(addAssignment_81022,axiom,
    ! [VarCurr: state_type] :
      ( v144378(VarCurr,1)
    <=> v144380(VarCurr,1) ) ).

tff(addAssignment_81021,axiom,
    ! [VarCurr: state_type] :
      ( v144380(VarCurr,1)
    <=> v144382(VarCurr,1) ) ).

tff(addAssignment_81020,axiom,
    ! [VarCurr: state_type] :
      ( v144382(VarCurr,1)
    <=> v144384(VarCurr,1) ) ).

tff(addAssignment_81019,axiom,
    ! [VarCurr: state_type] :
      ( v144370(VarCurr)
    <=> v144372(VarCurr) ) ).

tff(addAssignment_81018,axiom,
    ! [VarCurr: state_type] :
      ( v144372(VarCurr)
    <=> v144374(VarCurr,0) ) ).

tff(addAssignment_81017,axiom,
    ! [VarCurr: state_type] :
      ( v144374(VarCurr,0)
    <=> v144376(VarCurr,0) ) ).

tff(addAssignment_81016,axiom,
    ! [VarCurr: state_type] :
      ( v144376(VarCurr,0)
    <=> v144378(VarCurr,0) ) ).

tff(addAssignment_81015,axiom,
    ! [VarCurr: state_type] :
      ( v144378(VarCurr,0)
    <=> v144380(VarCurr,0) ) ).

tff(addAssignment_81014,axiom,
    ! [VarCurr: state_type] :
      ( v144380(VarCurr,0)
    <=> v144382(VarCurr,0) ) ).

tff(addAssignment_81013,axiom,
    ! [VarCurr: state_type] :
      ( v144382(VarCurr,0)
    <=> v144384(VarCurr,0) ) ).

tff(addAssignment_81012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144344(VarCurr,B)
      <=> v144346(VarCurr,B) ) ) ).

tff(addAssignment_81011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144346(VarCurr,B)
      <=> v144348(VarCurr,B) ) ) ).

tff(addAssignment_81010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144348(VarCurr,B)
      <=> v144350(VarCurr,B) ) ) ).

tff(addAssignment_81009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v144350(VarCurr,B)
      <=> v144352(VarCurr,B) ) ) ).

tff(addAssignment_81008,axiom,
    ! [VarCurr: state_type] :
      ( v144324(VarCurr)
    <=> v144326(VarCurr) ) ).

tff(addAssignment_81007,axiom,
    ! [VarCurr: state_type] :
      ( v144326(VarCurr)
    <=> v144328(VarCurr) ) ).

tff(addAssignment_81006,axiom,
    ! [VarCurr: state_type] :
      ( v144328(VarCurr)
    <=> v144330(VarCurr) ) ).

tff(addAssignment_81005,axiom,
    ! [VarCurr: state_type] :
      ( v144330(VarCurr)
    <=> v144332(VarCurr) ) ).

tff(addAssignment_81004,axiom,
    ! [VarCurr: state_type] :
      ( v144332(VarCurr)
    <=> v144334(VarCurr) ) ).

tff(addAssignment_81003,axiom,
    ! [VarCurr: state_type] :
      ( v144334(VarCurr)
    <=> v144336(VarCurr) ) ).

tff(addAssignment_81002,axiom,
    ! [VarCurr: state_type] :
      ( v144336(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_81001,axiom,
    ! [VarCurr: state_type] :
      ( v144310(VarCurr)
    <=> v144312(VarCurr) ) ).

tff(addAssignment_81000,axiom,
    ! [VarCurr: state_type] :
      ( v144312(VarCurr)
    <=> v144314(VarCurr) ) ).

tff(addAssignment_80999,axiom,
    ! [VarCurr: state_type] :
      ( v144314(VarCurr)
    <=> v144316(VarCurr) ) ).

tff(addAssignment_80998,axiom,
    ! [VarCurr: state_type] :
      ( v144316(VarCurr)
    <=> v144318(VarCurr) ) ).

tff(addAssignment_80997,axiom,
    ! [VarCurr: state_type] :
      ( v144318(VarCurr)
    <=> v144320(VarCurr) ) ).

tff(addAssignment_80996,axiom,
    ! [VarCurr: state_type] :
      ( v144320(VarCurr)
    <=> v144322(VarCurr) ) ).

tff(addAssignment_80995,axiom,
    ! [VarCurr: state_type] :
      ( v144322(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_80994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v4179(VarCurr,B)
      <=> v4181(VarCurr,B) ) ) ).

tff(addAssignment_80993,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,0)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80992,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,1)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80991,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,2)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80990,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,3)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80989,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,4)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80988,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,5)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80987,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,6)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80986,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,7)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80985,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,8)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80984,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,9)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80983,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,10)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80982,axiom,
    ! [VarCurr: state_type] :
      ( v4181(VarCurr,11)
    <=> v144288(VarCurr) ) ).

tff(addAssignment_80981,axiom,
    ! [VarCurr: state_type] :
      ( v144288(VarCurr)
    <=> v4183(VarCurr) ) ).

tff(addAssignment_80980,axiom,
    ! [VarCurr: state_type] :
      ( v4183(VarCurr)
    <=> v4185(VarCurr,0) ) ).

tff(addAssignment_80979,axiom,
    ! [VarCurr: state_type] :
      ( v4185(VarCurr,0)
    <=> v4187(VarCurr,0) ) ).

tff(addAssignment_80978,axiom,
    ! [VarCurr: state_type] :
      ( v4187(VarCurr,0)
    <=> v144286(VarCurr,0) ) ).

tff(writeUnaryOperator_10992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144286(VarCurr,B)
      <=> ~ v4189(VarCurr,B) ) ) ).

tff(addAssignment_80977,axiom,
    ! [VarCurr: state_type] :
      ( v4189(VarCurr,0)
    <=> v4191(VarCurr,0) ) ).

tff(addAssignment_80976,axiom,
    ! [VarCurr: state_type] :
      ( v4191(VarCurr,0)
    <=> v144283(VarCurr,0) ) ).

tff(addAssignment_80975,axiom,
    ! [VarCurr: state_type] :
      ( v144283(VarCurr,0)
    <=> v4193(VarCurr) ) ).

tff(addAssignment_80974,axiom,
    ! [VarCurr: state_type] :
      ( v144283(VarCurr,1)
    <=> v144285(VarCurr) ) ).

tff(addAssignment_80973,axiom,
    ! [VarCurr: state_type] :
      ( v144283(VarCurr,2)
    <=> v144284(VarCurr) ) ).

tff(addAssignment_80972,axiom,
    ! [VarCurr: state_type] :
      ( v4193(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_80971,axiom,
    ! [VarCurr: state_type] :
      ( v4195(VarCurr)
    <=> v4197(VarCurr) ) ).

tff(addAssignment_80970,axiom,
    ! [VarCurr: state_type] :
      ( v4197(VarCurr)
    <=> v4199(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19276,axiom,
    ! [VarCurr: state_type] :
      ( v4199(VarCurr)
    <=> ( v144277(VarCurr)
        & v144282(VarCurr) ) ) ).

tff(writeUnaryOperator_10991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144282(VarCurr)
    <=> v8422(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19275,axiom,
    ! [VarCurr: state_type] :
      ( v144277(VarCurr)
    <=> ( v144278(VarCurr)
        & v144281(VarCurr) ) ) ).

tff(writeUnaryOperator_10990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144281(VarCurr)
    <=> v8312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19274,axiom,
    ! [VarCurr: state_type] :
      ( v144278(VarCurr)
    <=> ( v144279(VarCurr)
        & v144280(VarCurr) ) ) ).

tff(writeUnaryOperator_10989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144280(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2209,axiom,
    ! [VarCurr: state_type] :
      ( v144279(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_80969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4201(VarCurr,B)
      <=> v4203(VarCurr,B) ) ) ).

tff(addAssignment_80968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4203(VarCurr,B)
      <=> v4205(VarCurr,B) ) ) ).

tff(addAssignment_80967,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4205(VarNext,B)
      <=> v144259(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144260(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v144259(VarNext,B)
            <=> v4205(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2046,axiom,
    ! [VarNext: state_type] :
      ( v144260(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v144259(VarNext,B)
          <=> v144270(VarNext,B) ) ) ) ).

tff(addAssignment_80966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v144270(VarNext,B)
          <=> v144268(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144271(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v144268(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1591,axiom,
    ! [VarCurr: state_type] :
      ( v144271(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v144268(VarCurr,B)
          <=> v4215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19273,axiom,
    ! [VarCurr: state_type] :
      ( v144271(VarCurr)
    <=> ( v144272(VarCurr)
        & v144273(VarCurr) ) ) ).

tff(writeUnaryOperator_10988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144273(VarCurr)
    <=> v4211(VarCurr) ) ).

tff(writeUnaryOperator_10987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144272(VarCurr)
    <=> v4207(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144260(VarNext)
      <=> v144261(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144261(VarNext)
      <=> ( v144262(VarNext)
          & v144255(VarNext) ) ) ) ).

tff(writeUnaryOperator_10986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144262(VarNext)
      <=> v144264(VarNext) ) ) ).

tff(addAssignment_80965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144264(VarNext)
      <=> v144255(VarCurr) ) ) ).

tff(addAssignment_80964,axiom,
    ! [VarCurr: state_type] :
      ( v144255(VarCurr)
    <=> v144257(VarCurr) ) ).

tff(addAssignment_80963,axiom,
    ! [VarCurr: state_type] :
      ( v144257(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4215(VarCurr,B)
      <=> v4217(VarCurr,B) ) ) ).

tff(addAssignment_80961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4217(VarCurr,B)
      <=> v144246(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v144246(VarCurr,B)
      <=> ( v144247(VarCurr,B)
          | v144250(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v144250(VarCurr,B)
      <=> ( v4203(VarCurr,B)
          & v144251(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v144251(VarCurr,B)
      <=> ~ v144252(VarCurr,B) ) ) ).

tff(addAssignment_80960,axiom,
    ! [VarCurr: state_type] :
      ( v144252(VarCurr,0)
    <=> v144253(VarCurr) ) ).

tff(addAssignment_80959,axiom,
    ! [VarCurr: state_type] :
      ( v144252(VarCurr,1)
    <=> v144253(VarCurr) ) ).

tff(addAssignment_80958,axiom,
    ! [VarCurr: state_type] :
      ( v144252(VarCurr,2)
    <=> v144253(VarCurr) ) ).

tff(addAssignment_80957,axiom,
    ! [VarCurr: state_type] :
      ( v144252(VarCurr,3)
    <=> v144253(VarCurr) ) ).

tff(addAssignment_80956,axiom,
    ! [VarCurr: state_type] :
      ( v144253(VarCurr)
    <=> v144245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v144247(VarCurr,B)
      <=> ( v4219(VarCurr,B)
          & v144248(VarCurr,B) ) ) ) ).

tff(addAssignment_80955,axiom,
    ! [VarCurr: state_type] :
      ( v144248(VarCurr,0)
    <=> v144249(VarCurr) ) ).

tff(addAssignment_80954,axiom,
    ! [VarCurr: state_type] :
      ( v144248(VarCurr,1)
    <=> v144249(VarCurr) ) ).

tff(addAssignment_80953,axiom,
    ! [VarCurr: state_type] :
      ( v144248(VarCurr,2)
    <=> v144249(VarCurr) ) ).

tff(addAssignment_80952,axiom,
    ! [VarCurr: state_type] :
      ( v144248(VarCurr,3)
    <=> v144249(VarCurr) ) ).

tff(addAssignment_80951,axiom,
    ! [VarCurr: state_type] :
      ( v144249(VarCurr)
    <=> v144245(VarCurr) ) ).

tff(addAssignment_80950,axiom,
    ! [VarCurr: state_type] :
      ( v144245(VarCurr)
    <=> v32577(VarCurr) ) ).

tff(addAssignment_80949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4219(VarCurr,B)
      <=> v144243(VarCurr,B) ) ) ).

tff(addAssignment_80948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144243(VarCurr,B)
      <=> v4221(VarCurr,B) ) ) ).

tff(addAssignment_80947,axiom,
    ! [VarCurr: state_type] :
      ( v144243(VarCurr,3)
    <=> v4221(VarCurr,7) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4223(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4221(VarCurr,B)
          <=> v144174(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1590,axiom,
    ! [VarCurr: state_type] :
      ( v4223(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4221(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144174(VarCurr,B)
          <=> v144190(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1589,axiom,
    ! [VarCurr: state_type] :
      ( v144175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144174(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144191(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144190(VarCurr,B)
          <=> v144198(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1588,axiom,
    ! [VarCurr: state_type] :
      ( v144191(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144190(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144199(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144198(VarCurr,B)
          <=> v144215(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1587,axiom,
    ! [VarCurr: state_type] :
      ( v144199(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144198(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144216(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144215(VarCurr,B)
          <=> v144219(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1586,axiom,
    ! [VarCurr: state_type] :
      ( v144216(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144215(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144219(VarCurr,B)
          <=> v144223(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1585,axiom,
    ! [VarCurr: state_type] :
      ( v144220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144219(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144224(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144223(VarCurr,B)
          <=> v144227(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1584,axiom,
    ! [VarCurr: state_type] :
      ( v144224(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144223(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144228(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144227(VarCurr,B)
          <=> v144233(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1583,axiom,
    ! [VarCurr: state_type] :
      ( v144228(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144227(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144234(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144233(VarCurr,B)
          <=> v144238(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1582,axiom,
    ! [VarCurr: state_type] :
      ( v144234(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144233(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144238(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1581,axiom,
    ! [VarCurr: state_type] :
      ( v144239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144238(VarCurr,B)
          <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19270,axiom,
    ! [VarCurr: state_type] :
      ( v144239(VarCurr)
    <=> ( v144240(VarCurr)
        & v144242(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2208,axiom,
    ! [VarCurr: state_type] :
      ( v144242(VarCurr)
    <=> ( ( v2363(VarCurr,2)
        <=> $false )
        & ( v2363(VarCurr,1)
        <=> $false )
        & ( v2363(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19269,axiom,
    ! [VarCurr: state_type] :
      ( v144240(VarCurr)
    <=> ( v144241(VarCurr)
        & v4223(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2207,axiom,
    ! [VarCurr: state_type] :
      ( v144241(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19268,axiom,
    ! [VarCurr: state_type] :
      ( v144234(VarCurr)
    <=> ( v144235(VarCurr)
        | v144236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19267,axiom,
    ! [VarCurr: state_type] :
      ( v144236(VarCurr)
    <=> ( v144237(VarCurr)
        & v33714(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2206,axiom,
    ! [VarCurr: state_type] :
      ( v144237(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19266,axiom,
    ! [VarCurr: state_type] :
      ( v144235(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19265,axiom,
    ! [VarCurr: state_type] :
      ( v144228(VarCurr)
    <=> ( v144229(VarCurr)
        | v33912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19264,axiom,
    ! [VarCurr: state_type] :
      ( v144229(VarCurr)
    <=> ( v144230(VarCurr)
        | v33810(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19263,axiom,
    ! [VarCurr: state_type] :
      ( v144230(VarCurr)
    <=> ( v144231(VarCurr)
        & v32548(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19262,axiom,
    ! [VarCurr: state_type] :
      ( v144231(VarCurr)
    <=> ( v32579(VarCurr)
        & v144232(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2205,axiom,
    ! [VarCurr: state_type] :
      ( v144232(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19261,axiom,
    ! [VarCurr: state_type] :
      ( v144224(VarCurr)
    <=> ( v144225(VarCurr)
        & v33448(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19260,axiom,
    ! [VarCurr: state_type] :
      ( v144225(VarCurr)
    <=> ( v32579(VarCurr)
        & v144226(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2204,axiom,
    ! [VarCurr: state_type] :
      ( v144226(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19259,axiom,
    ! [VarCurr: state_type] :
      ( v144220(VarCurr)
    <=> ( v144221(VarCurr)
        & v33180(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19258,axiom,
    ! [VarCurr: state_type] :
      ( v144221(VarCurr)
    <=> ( v32579(VarCurr)
        & v144222(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2203,axiom,
    ! [VarCurr: state_type] :
      ( v144222(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19257,axiom,
    ! [VarCurr: state_type] :
      ( v144216(VarCurr)
    <=> ( v144217(VarCurr)
        & v32728(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19256,axiom,
    ! [VarCurr: state_type] :
      ( v144217(VarCurr)
    <=> ( v32579(VarCurr)
        & v144218(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2202,axiom,
    ! [VarCurr: state_type] :
      ( v144218(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19255,axiom,
    ! [VarCurr: state_type] :
      ( v144199(VarCurr)
    <=> ( v144200(VarCurr)
        | v33778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19254,axiom,
    ! [VarCurr: state_type] :
      ( v144200(VarCurr)
    <=> ( v32579(VarCurr)
        & v144201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19253,axiom,
    ! [VarCurr: state_type] :
      ( v144201(VarCurr)
    <=> ( v144202(VarCurr)
        | v144213(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19252,axiom,
    ! [VarCurr: state_type] :
      ( v144213(VarCurr)
    <=> ( v144214(VarCurr)
        & v32570(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2201,axiom,
    ! [VarCurr: state_type] :
      ( v144214(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19251,axiom,
    ! [VarCurr: state_type] :
      ( v144202(VarCurr)
    <=> ( v144203(VarCurr)
        | v144211(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19250,axiom,
    ! [VarCurr: state_type] :
      ( v144211(VarCurr)
    <=> ( v144212(VarCurr)
        & v33470(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2200,axiom,
    ! [VarCurr: state_type] :
      ( v144212(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19249,axiom,
    ! [VarCurr: state_type] :
      ( v144203(VarCurr)
    <=> ( v144204(VarCurr)
        | v144209(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19248,axiom,
    ! [VarCurr: state_type] :
      ( v144209(VarCurr)
    <=> ( v144210(VarCurr)
        & v33202(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2199,axiom,
    ! [VarCurr: state_type] :
      ( v144210(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19247,axiom,
    ! [VarCurr: state_type] :
      ( v144204(VarCurr)
    <=> ( v144205(VarCurr)
        | v144207(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19246,axiom,
    ! [VarCurr: state_type] :
      ( v144207(VarCurr)
    <=> ( v144208(VarCurr)
        & v32750(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2198,axiom,
    ! [VarCurr: state_type] :
      ( v144208(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19245,axiom,
    ! [VarCurr: state_type] :
      ( v144205(VarCurr)
    <=> ( v144206(VarCurr)
        & v32633(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2197,axiom,
    ! [VarCurr: state_type] :
      ( v144206(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19244,axiom,
    ! [VarCurr: state_type] :
      ( v144191(VarCurr)
    <=> ( v144192(VarCurr)
        & v144194(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19243,axiom,
    ! [VarCurr: state_type] :
      ( v144194(VarCurr)
    <=> ( v144195(VarCurr)
        | v144197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19242,axiom,
    ! [VarCurr: state_type] :
      ( v144197(VarCurr)
    <=> ( v32581(VarCurr)
        & v144116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19241,axiom,
    ! [VarCurr: state_type] :
      ( v144195(VarCurr)
    <=> ( v32524(VarCurr,0)
        & v144196(VarCurr) ) ) ).

tff(writeUnaryOperator_10984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144196(VarCurr)
    <=> v144057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19240,axiom,
    ! [VarCurr: state_type] :
      ( v144192(VarCurr)
    <=> ( v144193(VarCurr)
        & v4228(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2196,axiom,
    ! [VarCurr: state_type] :
      ( v144193(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19239,axiom,
    ! [VarCurr: state_type] :
      ( v144175(VarCurr)
    <=> ( v144176(VarCurr)
        | v33802(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19238,axiom,
    ! [VarCurr: state_type] :
      ( v144176(VarCurr)
    <=> ( v144177(VarCurr)
        & v144179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19237,axiom,
    ! [VarCurr: state_type] :
      ( v144179(VarCurr)
    <=> ( v144180(VarCurr)
        | v144188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19236,axiom,
    ! [VarCurr: state_type] :
      ( v144188(VarCurr)
    <=> ( v144189(VarCurr)
        & v32633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19235,axiom,
    ! [VarCurr: state_type] :
      ( v144189(VarCurr)
    <=> ( v32581(VarCurr)
        & v144116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19234,axiom,
    ! [VarCurr: state_type] :
      ( v144180(VarCurr)
    <=> ( v144181(VarCurr)
        | v144185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19233,axiom,
    ! [VarCurr: state_type] :
      ( v144185(VarCurr)
    <=> ( v144186(VarCurr)
        & v32633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19232,axiom,
    ! [VarCurr: state_type] :
      ( v144186(VarCurr)
    <=> ( v32524(VarCurr,0)
        & v144187(VarCurr) ) ) ).

tff(writeUnaryOperator_10983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144187(VarCurr)
    <=> v144057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19231,axiom,
    ! [VarCurr: state_type] :
      ( v144181(VarCurr)
    <=> ( v144182(VarCurr)
        | v144183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19230,axiom,
    ! [VarCurr: state_type] :
      ( v144183(VarCurr)
    <=> ( v32581(VarCurr)
        & v144184(VarCurr) ) ) ).

tff(writeUnaryOperator_10982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144184(VarCurr)
    <=> v144116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19229,axiom,
    ! [VarCurr: state_type] :
      ( v144182(VarCurr)
    <=> ( v32524(VarCurr,0)
        & v144057(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19228,axiom,
    ! [VarCurr: state_type] :
      ( v144177(VarCurr)
    <=> ( v144178(VarCurr)
        & v4228(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2195,axiom,
    ! [VarCurr: state_type] :
      ( v144178(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_80946,axiom,
    ! [VarCurr: state_type] :
      ( v144116(VarCurr)
    <=> v32875(VarCurr,2) ) ).

tff(addAssignment_80945,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,2)
    <=> v32885(VarCurr,2) ) ).

tff(addAssignment_80944,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,2)
    <=> v32879(VarCurr,1) ) ).

tff(addAssignment_80943,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,1)
    <=> v32881(VarCurr,1) ) ).

tff(addAssignment_80942,axiom,
    ! [VarNext: state_type] :
      ( v32881(VarNext,1)
    <=> v144156(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144157(VarNext)
       => ! [B: $int] :
            ( ( $less(B,30)
              & ~ $less(B,0) )
           => ( v144156(VarNext,B)
            <=> v32881(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2045,axiom,
    ! [VarNext: state_type] :
      ( v144157(VarNext)
     => ! [B: $int] :
          ( ( $less(B,30)
            & ~ $less(B,0) )
         => ( v144156(VarNext,B)
          <=> v144167(VarNext,B) ) ) ) ).

tff(addAssignment_80941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,30)
            & ~ $less(B,0) )
         => ( v144167(VarNext,B)
          <=> v144165(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144168(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,30)
            & ~ $less(B,0) )
         => ( v144165(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1580,axiom,
    ! [VarCurr: state_type] :
      ( v144168(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,30)
            & ~ $less(B,0) )
         => ( v144165(VarCurr,B)
          <=> v144126(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19227,axiom,
    ! [VarCurr: state_type] :
      ( v144168(VarCurr)
    <=> ( v144169(VarCurr)
        & v144170(VarCurr) ) ) ).

tff(writeUnaryOperator_10981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144170(VarCurr)
    <=> v144122(VarCurr) ) ).

tff(writeUnaryOperator_10980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144169(VarCurr)
    <=> v144118(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144157(VarNext)
      <=> v144158(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144158(VarNext)
      <=> ( v144159(VarNext)
          & v144152(VarNext) ) ) ) ).

tff(writeUnaryOperator_10979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144159(VarNext)
      <=> v144161(VarNext) ) ) ).

tff(addAssignment_80940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144161(VarNext)
      <=> v144152(VarCurr) ) ) ).

tff(addAssignment_80939,axiom,
    ! [VarCurr: state_type] :
      ( v144152(VarCurr)
    <=> v144154(VarCurr) ) ).

tff(addAssignment_80938,axiom,
    ! [VarCurr: state_type] :
      ( v144154(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80937,axiom,
    ! [VarCurr: state_type] :
      ( v144126(VarCurr,1)
    <=> v144128(VarCurr,1) ) ).

tff(addAssignment_80936,axiom,
    ! [VarCurr: state_type] :
      ( v144128(VarCurr,1)
    <=> v144142(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,0) )
     => ( v144142(VarCurr,B)
      <=> ( v144143(VarCurr,B)
          | v144146(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2121,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,0) )
     => ( v144146(VarCurr,B)
      <=> ( v32879(VarCurr,B)
          & v144147(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,0) )
     => ( v144147(VarCurr,B)
      <=> ~ v144148(VarCurr,B) ) ) ).

tff(addAssignment_80935,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,0)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80934,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,1)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80933,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,2)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80932,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,3)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80931,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,4)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80930,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,5)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80929,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,6)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80928,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,7)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80927,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,8)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80926,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,9)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80925,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,10)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80924,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,11)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80923,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,12)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80922,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,13)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80921,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,14)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80920,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,15)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80919,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,16)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80918,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,17)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80917,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,18)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80916,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,19)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80915,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,20)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80914,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,21)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80913,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,22)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80912,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,23)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80911,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,24)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80910,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,25)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80909,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,26)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80908,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,27)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80907,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,28)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80906,axiom,
    ! [VarCurr: state_type] :
      ( v144148(VarCurr,29)
    <=> v144149(VarCurr) ) ).

tff(addAssignment_80905,axiom,
    ! [VarCurr: state_type] :
      ( v144149(VarCurr)
    <=> v144136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,0) )
     => ( v144143(VarCurr,B)
      <=> ( v144130(VarCurr,B)
          & v144144(VarCurr,B) ) ) ) ).

tff(addAssignment_80904,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,0)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80903,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,1)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80902,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,2)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80901,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,3)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80900,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,4)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80899,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,5)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80898,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,6)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80897,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,7)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80896,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,8)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80895,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,9)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80894,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,10)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80893,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,11)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80892,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,12)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80891,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,13)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80890,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,14)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80889,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,15)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80888,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,16)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80887,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,17)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80886,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,18)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80885,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,19)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80884,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,20)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80883,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,21)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80882,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,22)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80881,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,23)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80880,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,24)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80879,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,25)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80878,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,26)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80877,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,27)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80876,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,28)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80875,axiom,
    ! [VarCurr: state_type] :
      ( v144144(VarCurr,29)
    <=> v144145(VarCurr) ) ).

tff(addAssignment_80874,axiom,
    ! [VarCurr: state_type] :
      ( v144145(VarCurr)
    <=> v144136(VarCurr) ) ).

tff(addAssignment_80873,axiom,
    ! [VarCurr: state_type] :
      ( v144136(VarCurr)
    <=> v144138(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19224,axiom,
    ! [VarCurr: state_type] :
      ( v144138(VarCurr)
    <=> ( v2354(VarCurr)
        & v144141(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2194,axiom,
    ! [VarCurr: state_type] :
      ( v144141(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $true )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2144,axiom,
    ~ b0111010110000(12) ).

tff(bitBlastConstant_2143,axiom,
    b0111010110000(11) ).

tff(bitBlastConstant_2142,axiom,
    b0111010110000(10) ).

tff(bitBlastConstant_2141,axiom,
    b0111010110000(9) ).

tff(bitBlastConstant_2140,axiom,
    ~ b0111010110000(8) ).

tff(bitBlastConstant_2139,axiom,
    b0111010110000(7) ).

tff(bitBlastConstant_2138,axiom,
    ~ b0111010110000(6) ).

tff(bitBlastConstant_2137,axiom,
    b0111010110000(5) ).

tff(bitBlastConstant_2136,axiom,
    b0111010110000(4) ).

tff(bitBlastConstant_2135,axiom,
    ~ b0111010110000(3) ).

tff(bitBlastConstant_2134,axiom,
    ~ b0111010110000(2) ).

tff(bitBlastConstant_2133,axiom,
    ~ b0111010110000(1) ).

tff(bitBlastConstant_2132,axiom,
    ~ b0111010110000(0) ).

tff(addAssignment_80872,axiom,
    ! [VarCurr: state_type] :
      ( v144130(VarCurr,1)
    <=> v144134(VarCurr,1) ) ).

tff(addAssignment_80871,axiom,
    ! [VarCurr: state_type] :
      ( v144134(VarCurr,0)
    <=> v144132(VarCurr,0) ) ).

tff(addAssignment_80870,axiom,
    ! [VarCurr: state_type] :
      ( ( v144134(VarCurr,29)
      <=> v144132(VarCurr,30) )
      & ( v144134(VarCurr,28)
      <=> v144132(VarCurr,29) )
      & ( v144134(VarCurr,27)
      <=> v144132(VarCurr,28) )
      & ( v144134(VarCurr,26)
      <=> v144132(VarCurr,27) )
      & ( v144134(VarCurr,25)
      <=> v144132(VarCurr,26) )
      & ( v144134(VarCurr,24)
      <=> v144132(VarCurr,25) )
      & ( v144134(VarCurr,23)
      <=> v144132(VarCurr,24) )
      & ( v144134(VarCurr,22)
      <=> v144132(VarCurr,23) )
      & ( v144134(VarCurr,21)
      <=> v144132(VarCurr,22) )
      & ( v144134(VarCurr,20)
      <=> v144132(VarCurr,21) )
      & ( v144134(VarCurr,19)
      <=> v144132(VarCurr,20) )
      & ( v144134(VarCurr,18)
      <=> v144132(VarCurr,19) )
      & ( v144134(VarCurr,17)
      <=> v144132(VarCurr,18) )
      & ( v144134(VarCurr,16)
      <=> v144132(VarCurr,17) )
      & ( v144134(VarCurr,15)
      <=> v144132(VarCurr,16) )
      & ( v144134(VarCurr,14)
      <=> v144132(VarCurr,15) )
      & ( v144134(VarCurr,13)
      <=> v144132(VarCurr,14) )
      & ( v144134(VarCurr,12)
      <=> v144132(VarCurr,13) )
      & ( v144134(VarCurr,11)
      <=> v144132(VarCurr,12) )
      & ( v144134(VarCurr,10)
      <=> v144132(VarCurr,11) )
      & ( v144134(VarCurr,9)
      <=> v144132(VarCurr,10) )
      & ( v144134(VarCurr,8)
      <=> v144132(VarCurr,9) )
      & ( v144134(VarCurr,7)
      <=> v144132(VarCurr,8) )
      & ( v144134(VarCurr,6)
      <=> v144132(VarCurr,7) )
      & ( v144134(VarCurr,5)
      <=> v144132(VarCurr,6) )
      & ( v144134(VarCurr,4)
      <=> v144132(VarCurr,5) )
      & ( v144134(VarCurr,3)
      <=> v144132(VarCurr,4) )
      & ( v144134(VarCurr,2)
      <=> v144132(VarCurr,3) )
      & ( v144134(VarCurr,1)
      <=> v144132(VarCurr,2) ) ) ).

tff(addAssignment_80869,axiom,
    ! [VarCurr: state_type] :
      ( v144132(VarCurr,2)
    <=> v144133(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6921,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,0)
    <=> ( v2363(VarCurr,32)
      <~> v32883(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6920,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,1)
    <=> ( v2363(VarCurr,33)
      <~> v32883(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6919,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,2)
    <=> ( v2363(VarCurr,34)
      <~> v32883(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6918,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,3)
    <=> ( v2363(VarCurr,35)
      <~> v32883(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6917,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,4)
    <=> ( v2363(VarCurr,36)
      <~> v32883(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6916,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,5)
    <=> ( v2363(VarCurr,37)
      <~> v32883(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6915,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,6)
    <=> ( v2363(VarCurr,38)
      <~> v32883(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6914,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,7)
    <=> ( v2363(VarCurr,39)
      <~> v32883(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6913,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,8)
    <=> ( v2363(VarCurr,40)
      <~> v32883(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6912,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,9)
    <=> ( v2363(VarCurr,41)
      <~> v32883(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6911,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,10)
    <=> ( v2363(VarCurr,42)
      <~> v32883(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6910,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,11)
    <=> ( v2363(VarCurr,43)
      <~> v32883(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6909,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,12)
    <=> ( v2363(VarCurr,44)
      <~> v32883(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6908,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,13)
    <=> ( v2363(VarCurr,45)
      <~> v32883(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6907,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,14)
    <=> ( v2363(VarCurr,46)
      <~> v32883(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6906,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,15)
    <=> ( v2363(VarCurr,47)
      <~> v32883(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6905,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,16)
    <=> ( v2363(VarCurr,48)
      <~> v32883(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6904,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,17)
    <=> ( v2363(VarCurr,49)
      <~> v32883(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6903,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,18)
    <=> ( v2363(VarCurr,50)
      <~> v32883(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6902,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,19)
    <=> ( v2363(VarCurr,51)
      <~> v32883(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6901,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,20)
    <=> ( v2363(VarCurr,52)
      <~> v32883(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6900,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,21)
    <=> ( v2363(VarCurr,53)
      <~> v32883(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6899,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,22)
    <=> ( v2363(VarCurr,54)
      <~> v32883(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6898,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,23)
    <=> ( v2363(VarCurr,55)
      <~> v32883(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6897,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,24)
    <=> ( v2363(VarCurr,56)
      <~> v32883(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6896,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,25)
    <=> ( v2363(VarCurr,57)
      <~> v32883(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6895,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,26)
    <=> ( v2363(VarCurr,58)
      <~> v32883(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6894,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,27)
    <=> ( v2363(VarCurr,59)
      <~> v32883(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6893,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,28)
    <=> ( v2363(VarCurr,60)
      <~> v32883(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6892,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,29)
    <=> ( v2363(VarCurr,61)
      <~> v32883(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6891,axiom,
    ! [VarCurr: state_type] :
      ( v144133(VarCurr,30)
    <=> ( v2363(VarCurr,62)
      <~> v32883(VarCurr,30) ) ) ).

tff(addAssignment_80868,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,2)
    <=> $true ) ).

tff(addAssignment_80867,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,34)
    <=> v2365(VarCurr,34) ) ).

tff(addAssignment_80866,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,34)
    <=> v1119(VarCurr,34) ) ).

tff(addAssignment_80865,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,34)
    <=> v1121(VarCurr,34) ) ).

tff(addAssignment_80864,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,34)
    <=> v1123(VarCurr,34) ) ).

tff(addAssignment_80863,axiom,
    ! [VarCurr: state_type] :
      ( v144122(VarCurr)
    <=> v144124(VarCurr) ) ).

tff(addAssignment_80862,axiom,
    ! [VarCurr: state_type] :
      ( v144124(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_80861,axiom,
    ! [VarCurr: state_type] :
      ( v144118(VarCurr)
    <=> v144120(VarCurr) ) ).

tff(addAssignment_80860,axiom,
    ! [VarCurr: state_type] :
      ( v144120(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_80859,axiom,
    ! [VarCurr: state_type] :
      ( v144057(VarCurr)
    <=> v144059(VarCurr,0) ) ).

tff(addAssignment_80858,axiom,
    ! [VarCurr: state_type] :
      ( v144059(VarCurr,0)
    <=> v144061(VarCurr,0) ) ).

tff(addAssignment_80857,axiom,
    ! [VarNext: state_type] :
      ( v144061(VarNext,0)
    <=> v144098(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144099(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v144098(VarNext,B)
            <=> v144061(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2044,axiom,
    ! [VarNext: state_type] :
      ( v144099(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144098(VarNext,B)
          <=> v144109(VarNext,B) ) ) ) ).

tff(addAssignment_80856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144109(VarNext,B)
          <=> v144107(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144110(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144107(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1579,axiom,
    ! [VarCurr: state_type] :
      ( v144110(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v144107(VarCurr,B)
          <=> v144071(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19223,axiom,
    ! [VarCurr: state_type] :
      ( v144110(VarCurr)
    <=> ( v144111(VarCurr)
        & v144112(VarCurr) ) ) ).

tff(writeUnaryOperator_10977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144112(VarCurr)
    <=> v144067(VarCurr) ) ).

tff(writeUnaryOperator_10976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144111(VarCurr)
    <=> v144063(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144099(VarNext)
      <=> v144100(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144100(VarNext)
      <=> ( v144101(VarNext)
          & v144094(VarNext) ) ) ) ).

tff(writeUnaryOperator_10975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144101(VarNext)
      <=> v144103(VarNext) ) ) ).

tff(addAssignment_80855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144103(VarNext)
      <=> v144094(VarCurr) ) ) ).

tff(addAssignment_80854,axiom,
    ! [VarCurr: state_type] :
      ( v144094(VarCurr)
    <=> v144096(VarCurr) ) ).

tff(addAssignment_80853,axiom,
    ! [VarCurr: state_type] :
      ( v144096(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80852,axiom,
    ! [VarCurr: state_type] :
      ( v144071(VarCurr,0)
    <=> v144073(VarCurr,0) ) ).

tff(addAssignment_80851,axiom,
    ! [VarCurr: state_type] :
      ( v144073(VarCurr,0)
    <=> v144085(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144085(VarCurr,B)
      <=> ( v144086(VarCurr,B)
          | v144089(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144089(VarCurr,B)
      <=> ( v144059(VarCurr,B)
          & v144090(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144090(VarCurr,B)
      <=> ~ v144091(VarCurr,B) ) ) ).

tff(addAssignment_80850,axiom,
    ! [VarCurr: state_type] :
      ( v144091(VarCurr,0)
    <=> v144092(VarCurr) ) ).

tff(addAssignment_80849,axiom,
    ! [VarCurr: state_type] :
      ( v144091(VarCurr,1)
    <=> v144092(VarCurr) ) ).

tff(addAssignment_80848,axiom,
    ! [VarCurr: state_type] :
      ( v144091(VarCurr,2)
    <=> v144092(VarCurr) ) ).

tff(addAssignment_80847,axiom,
    ! [VarCurr: state_type] :
      ( v144092(VarCurr)
    <=> v144079(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v144086(VarCurr,B)
      <=> ( v144075(VarCurr,B)
          & v144087(VarCurr,B) ) ) ) ).

tff(addAssignment_80846,axiom,
    ! [VarCurr: state_type] :
      ( v144087(VarCurr,0)
    <=> v144088(VarCurr) ) ).

tff(addAssignment_80845,axiom,
    ! [VarCurr: state_type] :
      ( v144087(VarCurr,1)
    <=> v144088(VarCurr) ) ).

tff(addAssignment_80844,axiom,
    ! [VarCurr: state_type] :
      ( v144087(VarCurr,2)
    <=> v144088(VarCurr) ) ).

tff(addAssignment_80843,axiom,
    ! [VarCurr: state_type] :
      ( v144088(VarCurr)
    <=> v144079(VarCurr) ) ).

tff(addAssignment_80842,axiom,
    ! [VarCurr: state_type] :
      ( v144079(VarCurr)
    <=> v144081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19220,axiom,
    ! [VarCurr: state_type] :
      ( v144081(VarCurr)
    <=> ( v2354(VarCurr)
        & v144084(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2193,axiom,
    ! [VarCurr: state_type] :
      ( v144084(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2131,axiom,
    ~ b0100000001000(12) ).

tff(bitBlastConstant_2130,axiom,
    b0100000001000(11) ).

tff(bitBlastConstant_2129,axiom,
    ~ b0100000001000(10) ).

tff(bitBlastConstant_2128,axiom,
    ~ b0100000001000(9) ).

tff(bitBlastConstant_2127,axiom,
    ~ b0100000001000(8) ).

tff(bitBlastConstant_2126,axiom,
    ~ b0100000001000(7) ).

tff(bitBlastConstant_2125,axiom,
    ~ b0100000001000(6) ).

tff(bitBlastConstant_2124,axiom,
    ~ b0100000001000(5) ).

tff(bitBlastConstant_2123,axiom,
    ~ b0100000001000(4) ).

tff(bitBlastConstant_2122,axiom,
    b0100000001000(3) ).

tff(bitBlastConstant_2121,axiom,
    ~ b0100000001000(2) ).

tff(bitBlastConstant_2120,axiom,
    ~ b0100000001000(1) ).

tff(bitBlastConstant_2119,axiom,
    ~ b0100000001000(0) ).

tff(addAssignment_80841,axiom,
    ! [VarCurr: state_type] :
      ( v144075(VarCurr,0)
    <=> v144077(VarCurr,0) ) ).

tff(addAssignment_80840,axiom,
    ! [VarCurr: state_type] :
      ( v144077(VarCurr,0)
    <=> v2363(VarCurr,0) ) ).

tff(addAssignment_80839,axiom,
    ! [VarCurr: state_type] :
      ( v144067(VarCurr)
    <=> v144069(VarCurr) ) ).

tff(addAssignment_80838,axiom,
    ! [VarCurr: state_type] :
      ( v144069(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_80837,axiom,
    ! [VarCurr: state_type] :
      ( v144063(VarCurr)
    <=> v144065(VarCurr) ) ).

tff(addAssignment_80836,axiom,
    ! [VarCurr: state_type] :
      ( v144065(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_80835,axiom,
    ! [VarCurr: state_type] :
      ( v4228(VarCurr)
    <=> v4230(VarCurr) ) ).

tff(addAssignment_80834,axiom,
    ! [VarCurr: state_type] :
      ( v4230(VarCurr)
    <=> v4232(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144040(VarNext)
       => ( v4232(VarNext)
        <=> v4232(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2043,axiom,
    ! [VarNext: state_type] :
      ( v144040(VarNext)
     => ( v4232(VarNext)
      <=> v144050(VarNext) ) ) ).

tff(addAssignment_80833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144050(VarNext)
      <=> v144048(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144051(VarCurr)
     => ( v144048(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1578,axiom,
    ! [VarCurr: state_type] :
      ( v144051(VarCurr)
     => ( v144048(VarCurr)
      <=> v4242(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19219,axiom,
    ! [VarCurr: state_type] :
      ( v144051(VarCurr)
    <=> ( v144052(VarCurr)
        & v144053(VarCurr) ) ) ).

tff(writeUnaryOperator_10973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144053(VarCurr)
    <=> v4238(VarCurr) ) ).

tff(writeUnaryOperator_10972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144052(VarCurr)
    <=> v4234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144040(VarNext)
      <=> v144041(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144041(VarNext)
      <=> ( v144042(VarNext)
          & v144035(VarNext) ) ) ) ).

tff(writeUnaryOperator_10971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v144042(VarNext)
      <=> v144044(VarNext) ) ) ).

tff(addAssignment_80832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v144044(VarNext)
      <=> v144035(VarCurr) ) ) ).

tff(addAssignment_80831,axiom,
    ! [VarCurr: state_type] :
      ( v144035(VarCurr)
    <=> v144037(VarCurr) ) ).

tff(addAssignment_80830,axiom,
    ! [VarCurr: state_type] :
      ( v144037(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80829,axiom,
    ! [VarCurr: state_type] :
      ( v4242(VarCurr)
    <=> v4244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19216,axiom,
    ! [VarCurr: state_type] :
      ( v4244(VarCurr)
    <=> ( v144027(VarCurr)
        | v144030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19215,axiom,
    ! [VarCurr: state_type] :
      ( v144030(VarCurr)
    <=> ( v4230(VarCurr)
        & v144031(VarCurr) ) ) ).

tff(writeUnaryOperator_10970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144031(VarCurr)
    <=> v144032(VarCurr) ) ).

tff(addAssignment_80828,axiom,
    ! [VarCurr: state_type] :
      ( v144032(VarCurr)
    <=> v144033(VarCurr) ) ).

tff(addAssignment_80827,axiom,
    ! [VarCurr: state_type] :
      ( v144033(VarCurr)
    <=> v144011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19214,axiom,
    ! [VarCurr: state_type] :
      ( v144027(VarCurr)
    <=> ( v4246(VarCurr)
        & v144028(VarCurr) ) ) ).

tff(addAssignment_80826,axiom,
    ! [VarCurr: state_type] :
      ( v144028(VarCurr)
    <=> v144029(VarCurr) ) ).

tff(addAssignment_80825,axiom,
    ! [VarCurr: state_type] :
      ( v144029(VarCurr)
    <=> v144011(VarCurr) ) ).

tff(addAssignment_80824,axiom,
    ! [VarCurr: state_type] :
      ( v144011(VarCurr)
    <=> v144013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19213,axiom,
    ! [VarCurr: state_type] :
      ( v144013(VarCurr)
    <=> ( v144016(VarCurr)
        | v144024(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19212,axiom,
    ! [VarCurr: state_type] :
      ( v144024(VarCurr)
    <=> ( v2354(VarCurr)
        & v144025(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2192,axiom,
    ! [VarCurr: state_type] :
      ( v144025(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2118,axiom,
    ~ b0100001000000(12) ).

tff(bitBlastConstant_2117,axiom,
    b0100001000000(11) ).

tff(bitBlastConstant_2116,axiom,
    ~ b0100001000000(10) ).

tff(bitBlastConstant_2115,axiom,
    ~ b0100001000000(9) ).

tff(bitBlastConstant_2114,axiom,
    ~ b0100001000000(8) ).

tff(bitBlastConstant_2113,axiom,
    ~ b0100001000000(7) ).

tff(bitBlastConstant_2112,axiom,
    b0100001000000(6) ).

tff(bitBlastConstant_2111,axiom,
    ~ b0100001000000(5) ).

tff(bitBlastConstant_2110,axiom,
    ~ b0100001000000(4) ).

tff(bitBlastConstant_2109,axiom,
    ~ b0100001000000(3) ).

tff(bitBlastConstant_2108,axiom,
    ~ b0100001000000(2) ).

tff(bitBlastConstant_2107,axiom,
    ~ b0100001000000(1) ).

tff(bitBlastConstant_2106,axiom,
    ~ b0100001000000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19211,axiom,
    ! [VarCurr: state_type] :
      ( v144016(VarCurr)
    <=> ( v144017(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19210,axiom,
    ! [VarCurr: state_type] :
      ( v144017(VarCurr)
    <=> ( v144018(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19209,axiom,
    ! [VarCurr: state_type] :
      ( v144018(VarCurr)
    <=> ( v144019(VarCurr)
        | v4280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19208,axiom,
    ! [VarCurr: state_type] :
      ( v144019(VarCurr)
    <=> ( v144020(VarCurr)
        | v4263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19207,axiom,
    ! [VarCurr: state_type] :
      ( v144020(VarCurr)
    <=> ( v144021(VarCurr)
        & v144023(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2191,axiom,
    ! [VarCurr: state_type] :
      ( v144023(VarCurr)
    <=> ( ( v4253(VarCurr,9)
        <=> $false )
        & ( v4253(VarCurr,8)
        <=> $false )
        & ( v4253(VarCurr,7)
        <=> $false )
        & ( v4253(VarCurr,6)
        <=> $false )
        & ( v4253(VarCurr,5)
        <=> $false )
        & ( v4253(VarCurr,4)
        <=> $false )
        & ( v4253(VarCurr,3)
        <=> $false )
        & ( v4253(VarCurr,2)
        <=> $false )
        & ( v4253(VarCurr,1)
        <=> $false )
        & ( v4253(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19206,axiom,
    ! [VarCurr: state_type] :
      ( v144021(VarCurr)
    <=> ( v4250(VarCurr)
        & v144022(VarCurr) ) ) ).

tff(writeUnaryOperator_10969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144022(VarCurr)
    <=> v4228(VarCurr) ) ).

tff(addAssignment_80823,axiom,
    ! [VarCurr: state_type] :
      ( v4246(VarCurr)
    <=> v4248(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144002(VarCurr)
     => ( v4248(VarCurr)
      <=> v144006(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1577,axiom,
    ! [VarCurr: state_type] :
      ( v144002(VarCurr)
     => ( v4248(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144007(VarCurr)
     => ( v144006(VarCurr)
      <=> v2363(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1576,axiom,
    ! [VarCurr: state_type] :
      ( v144007(VarCurr)
     => ( v144006(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19205,axiom,
    ! [VarCurr: state_type] :
      ( v144007(VarCurr)
    <=> ( v144008(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19204,axiom,
    ! [VarCurr: state_type] :
      ( v144008(VarCurr)
    <=> ( v144009(VarCurr)
        | v4280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19203,axiom,
    ! [VarCurr: state_type] :
      ( v144009(VarCurr)
    <=> ( v4263(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19202,axiom,
    ! [VarCurr: state_type] :
      ( v144002(VarCurr)
    <=> ( v144003(VarCurr)
        & v144005(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2190,axiom,
    ! [VarCurr: state_type] :
      ( v144005(VarCurr)
    <=> ( ( v4253(VarCurr,9)
        <=> $false )
        & ( v4253(VarCurr,8)
        <=> $false )
        & ( v4253(VarCurr,7)
        <=> $false )
        & ( v4253(VarCurr,6)
        <=> $false )
        & ( v4253(VarCurr,5)
        <=> $false )
        & ( v4253(VarCurr,4)
        <=> $false )
        & ( v4253(VarCurr,3)
        <=> $false )
        & ( v4253(VarCurr,2)
        <=> $false )
        & ( v4253(VarCurr,1)
        <=> $false )
        & ( v4253(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19201,axiom,
    ! [VarCurr: state_type] :
      ( v144003(VarCurr)
    <=> ( v4250(VarCurr)
        & v144004(VarCurr) ) ) ).

tff(writeUnaryOperator_10968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v144004(VarCurr)
    <=> v4228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19200,axiom,
    ! [VarCurr: state_type] :
      ( v4280(VarCurr)
    <=> ( v143997(VarCurr)
        | v4329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19199,axiom,
    ! [VarCurr: state_type] :
      ( v143997(VarCurr)
    <=> ( v143998(VarCurr)
        | v4283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19198,axiom,
    ! [VarCurr: state_type] :
      ( v143998(VarCurr)
    <=> ( v143999(VarCurr)
        & v2363(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19197,axiom,
    ! [VarCurr: state_type] :
      ( v143999(VarCurr)
    <=> ( v2354(VarCurr)
        & v144000(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2189,axiom,
    ! [VarCurr: state_type] :
      ( v144000(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19196,axiom,
    ! [VarCurr: state_type] :
      ( v4329(VarCurr)
    <=> ( v4331(VarCurr)
        | v143995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19195,axiom,
    ! [VarCurr: state_type] :
      ( v143995(VarCurr)
    <=> ( v143987(VarCurr)
        & v100731(VarCurr) ) ) ).

tff(addAssignment_80822,axiom,
    ! [VarCurr: state_type] :
      ( v143987(VarCurr)
    <=> v143989(VarCurr) ) ).

tff(addAssignment_80821,axiom,
    ! [VarCurr: state_type] :
      ( v143989(VarCurr)
    <=> v143991(VarCurr) ) ).

tff(addAssignment_80820,axiom,
    ! [VarCurr: state_type] :
      ( v143991(VarCurr)
    <=> v143993(VarCurr) ) ).

tff(addAssignment_80819,axiom,
    ! [VarCurr: state_type] :
      ( v143993(VarCurr)
    <=> v100808(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19194,axiom,
    ! [VarCurr: state_type] :
      ( v4331(VarCurr)
    <=> ( v143983(VarCurr)
        & v143985(VarCurr) ) ) ).

tff(writeUnaryOperator_10967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143985(VarCurr)
    <=> v4103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19193,axiom,
    ! [VarCurr: state_type] :
      ( v143983(VarCurr)
    <=> ( v4333(VarCurr)
        & v143984(VarCurr) ) ) ).

tff(writeUnaryOperator_10966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143984(VarCurr)
    <=> v4343(VarCurr) ) ).

tff(addAssignment_80818,axiom,
    ! [VarCurr: state_type] :
      ( v4333(VarCurr)
    <=> v4335(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143966(VarNext)
       => ( v4335(VarNext)
        <=> v4335(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2042,axiom,
    ! [VarNext: state_type] :
      ( v143966(VarNext)
     => ( v4335(VarNext)
      <=> v143976(VarNext) ) ) ).

tff(addAssignment_80817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143976(VarNext)
      <=> v143974(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143977(VarCurr)
     => ( v143974(VarCurr)
      <=> x84230(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1575,axiom,
    ! [VarCurr: state_type] :
      ( v143977(VarCurr)
     => ( v143974(VarCurr)
      <=> v4341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19192,axiom,
    ! [VarCurr: state_type] :
      ( v143977(VarCurr)
    <=> ( v143978(VarCurr)
        & v143979(VarCurr) ) ) ).

tff(writeUnaryOperator_10965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143979(VarCurr)
    <=> v4339(VarCurr) ) ).

tff(writeUnaryOperator_10964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143978(VarCurr)
    <=> v4337(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143966(VarNext)
      <=> v143967(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143967(VarNext)
      <=> ( v143968(VarNext)
          & v143963(VarNext) ) ) ) ).

tff(writeUnaryOperator_10963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143968(VarNext)
      <=> v143970(VarNext) ) ) ).

tff(addAssignment_80816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143970(VarNext)
      <=> v143963(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_265,axiom,
    ( v4335(constB0)
  <=> $false ) ).

tff(addAssignment_80815,axiom,
    ! [VarCurr: state_type] :
      ( v143963(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80814,axiom,
    ! [VarCurr: state_type] :
      ( v4341(VarCurr)
    <=> v4343(VarCurr) ) ).

tff(addAssignment_80813,axiom,
    ! [VarCurr: state_type] :
      ( v4343(VarCurr)
    <=> v4345(VarCurr) ) ).

tff(addAssignment_80812,axiom,
    ! [VarCurr: state_type] :
      ( v4345(VarCurr)
    <=> v4347(VarCurr) ) ).

tff(addAssignment_80811,axiom,
    ! [VarCurr: state_type] :
      ( v4347(VarCurr)
    <=> v4349(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143946(VarNext)
       => ( v4349(VarNext)
        <=> v4349(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2041,axiom,
    ! [VarNext: state_type] :
      ( v143946(VarNext)
     => ( v4349(VarNext)
      <=> v143956(VarNext) ) ) ).

tff(addAssignment_80810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143956(VarNext)
      <=> v143954(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143957(VarCurr)
     => ( v143954(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1574,axiom,
    ! [VarCurr: state_type] :
      ( v143957(VarCurr)
     => ( v143954(VarCurr)
      <=> v4375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19189,axiom,
    ! [VarCurr: state_type] :
      ( v143957(VarCurr)
    <=> ( v143958(VarCurr)
        & v143959(VarCurr) ) ) ).

tff(writeUnaryOperator_10962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143959(VarCurr)
    <=> v4366(VarCurr) ) ).

tff(writeUnaryOperator_10961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143958(VarCurr)
    <=> v4351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143946(VarNext)
      <=> v143947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143947(VarNext)
      <=> ( v143948(VarNext)
          & v143941(VarNext) ) ) ) ).

tff(writeUnaryOperator_10960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143948(VarNext)
      <=> v143950(VarNext) ) ) ).

tff(addAssignment_80809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143950(VarNext)
      <=> v143941(VarCurr) ) ) ).

tff(addAssignment_80808,axiom,
    ! [VarCurr: state_type] :
      ( v143941(VarCurr)
    <=> v143943(VarCurr) ) ).

tff(addAssignment_80807,axiom,
    ! [VarCurr: state_type] :
      ( v143943(VarCurr)
    <=> v4435(VarCurr) ) ).

tff(addAssignment_80806,axiom,
    ! [VarCurr: state_type] :
      ( v4375(VarCurr)
    <=> v4377(VarCurr) ) ).

tff(addAssignment_80805,axiom,
    ! [VarCurr: state_type] :
      ( v4377(VarCurr)
    <=> v4379(VarCurr) ) ).

tff(addAssignment_80804,axiom,
    ! [VarCurr: state_type] :
      ( v4379(VarCurr)
    <=> v4381(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143934(VarCurr)
     => ( v4381(VarCurr)
      <=> v143939(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1573,axiom,
    ! [VarCurr: state_type] :
      ( v143934(VarCurr)
     => ( v4381(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4511(VarCurr)
     => ( v143939(VarCurr)
      <=> v4345(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1572,axiom,
    ! [VarCurr: state_type] :
      ( v4511(VarCurr)
     => ( v143939(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19186,axiom,
    ! [VarCurr: state_type] :
      ( v143934(VarCurr)
    <=> ( v143935(VarCurr)
        & v143938(VarCurr) ) ) ).

tff(writeUnaryOperator_10959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143938(VarCurr)
    <=> v4386(VarCurr) ) ).

tff(writeUnaryOperator_10958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143935(VarCurr)
    <=> v143937(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6890,axiom,
    ! [VarCurr: state_type] :
      ( v143937(VarCurr)
    <=> ( v4383(VarCurr,1)
        & v4383(VarCurr,2) ) ) ).

tff(addAssignment_80803,axiom,
    ! [VarCurr: state_type] :
      ( v4511(VarCurr)
    <=> v4513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19185,axiom,
    ! [VarCurr: state_type] :
      ( v4513(VarCurr)
    <=> ( v143923(VarCurr)
        | v143931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19184,axiom,
    ! [VarCurr: state_type] :
      ( v143931(VarCurr)
    <=> ( v143913(VarCurr)
        & v143932(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2188,axiom,
    ! [VarCurr: state_type] :
      ( v143932(VarCurr)
    <=> ( ( v143848(VarCurr,3)
        <=> $false )
        & ( v143848(VarCurr,2)
        <=> $true )
        & ( v143848(VarCurr,1)
        <=> $true )
        & ( v143848(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19183,axiom,
    ! [VarCurr: state_type] :
      ( v143923(VarCurr)
    <=> ( v143924(VarCurr)
        | v143929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19182,axiom,
    ! [VarCurr: state_type] :
      ( v143929(VarCurr)
    <=> ( v143824(VarCurr)
        & v143930(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2187,axiom,
    ! [VarCurr: state_type] :
      ( v143930(VarCurr)
    <=> ( ( v143848(VarCurr,3)
        <=> $false )
        & ( v143848(VarCurr,2)
        <=> $true )
        & ( v143848(VarCurr,1)
        <=> $true )
        & ( v143848(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19181,axiom,
    ! [VarCurr: state_type] :
      ( v143924(VarCurr)
    <=> ( v143925(VarCurr)
        | v143927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19180,axiom,
    ! [VarCurr: state_type] :
      ( v143927(VarCurr)
    <=> ( v143800(VarCurr)
        & v143928(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2186,axiom,
    ! [VarCurr: state_type] :
      ( v143928(VarCurr)
    <=> ( ( v143848(VarCurr,3)
        <=> $false )
        & ( v143848(VarCurr,2)
        <=> $true )
        & ( v143848(VarCurr,1)
        <=> $false )
        & ( v143848(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19179,axiom,
    ! [VarCurr: state_type] :
      ( v143925(VarCurr)
    <=> ( v2044(VarCurr)
        & v143926(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2185,axiom,
    ! [VarCurr: state_type] :
      ( v143926(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $true )
        & ( v2200(VarCurr,9)
        <=> $false )
        & ( v2200(VarCurr,8)
        <=> $false ) ) ) ).

tff(addAssignment_80802,axiom,
    ! [VarCurr: state_type] :
      ( v143913(VarCurr)
    <=> v143802(VarCurr,0) ) ).

tff(addAssignment_80801,axiom,
    ! [VarCurr: state_type] :
      ( v143802(VarCurr,0)
    <=> v143804(VarCurr,0) ) ).

tff(addAssignment_80800,axiom,
    ! [VarNext: state_type] :
      ( v143804(VarNext,0)
    <=> v143915(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143916(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v143915(VarNext,B)
            <=> v143804(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2040,axiom,
    ! [VarNext: state_type] :
      ( v143916(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143915(VarNext,B)
          <=> v143841(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143916(VarNext)
      <=> v143917(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143917(VarNext)
      <=> ( v143919(VarNext)
          & v143826(VarNext) ) ) ) ).

tff(writeUnaryOperator_10957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143919(VarNext)
      <=> v143835(VarNext) ) ) ).

tff(addAssignment_80799,axiom,
    ! [VarCurr: state_type] :
      ( v143814(VarCurr,0)
    <=> v143816(VarCurr,0) ) ).

tff(addAssignment_80798,axiom,
    ! [VarCurr: state_type] :
      ( v143816(VarCurr,0)
    <=> v143818(VarCurr,0) ) ).

tff(addAssignment_80797,axiom,
    ! [VarCurr: state_type] :
      ( v143818(VarCurr,0)
    <=> v143823(VarCurr,0) ) ).

tff(addAssignment_80796,axiom,
    ! [VarCurr: state_type] :
      ( v143824(VarCurr)
    <=> v143802(VarCurr,1) ) ).

tff(addAssignment_80795,axiom,
    ! [VarCurr: state_type] :
      ( v143802(VarCurr,1)
    <=> v143804(VarCurr,1) ) ).

tff(addAssignment_80794,axiom,
    ! [VarNext: state_type] :
      ( v143804(VarNext,1)
    <=> v143905(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143906(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v143905(VarNext,B)
            <=> v143804(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2039,axiom,
    ! [VarNext: state_type] :
      ( v143906(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143905(VarNext,B)
          <=> v143841(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143906(VarNext)
      <=> v143907(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143907(VarNext)
      <=> ( v143909(VarNext)
          & v143826(VarNext) ) ) ) ).

tff(writeUnaryOperator_10956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143909(VarNext)
      <=> v143835(VarNext) ) ) ).

tff(addAssignment_80793,axiom,
    ! [VarCurr: state_type] :
      ( v143814(VarCurr,1)
    <=> v143816(VarCurr,1) ) ).

tff(addAssignment_80792,axiom,
    ! [VarCurr: state_type] :
      ( v143816(VarCurr,1)
    <=> v143818(VarCurr,1) ) ).

tff(addAssignment_80791,axiom,
    ! [VarCurr: state_type] :
      ( v143818(VarCurr,1)
    <=> v143823(VarCurr,1) ) ).

tff(addAssignment_80790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143848(VarCurr,B)
      <=> v143850(VarCurr,B) ) ) ).

tff(addAssignment_80789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143850(VarCurr,B)
      <=> v143852(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143887(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v143852(VarNext,B)
            <=> v143852(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2038,axiom,
    ! [VarNext: state_type] :
      ( v143887(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v143852(VarNext,B)
          <=> v143897(VarNext,B) ) ) ) ).

tff(addAssignment_80788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v143897(VarNext,B)
          <=> v143895(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143898(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v143895(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1571,axiom,
    ! [VarCurr: state_type] :
      ( v143898(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v143895(VarCurr,B)
          <=> v143862(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19174,axiom,
    ! [VarCurr: state_type] :
      ( v143898(VarCurr)
    <=> ( v143899(VarCurr)
        & v143900(VarCurr) ) ) ).

tff(writeUnaryOperator_10955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143900(VarCurr)
    <=> v143858(VarCurr) ) ).

tff(writeUnaryOperator_10954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143899(VarCurr)
    <=> v143854(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143887(VarNext)
      <=> v143888(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143888(VarNext)
      <=> ( v143889(VarNext)
          & v143882(VarNext) ) ) ) ).

tff(writeUnaryOperator_10953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143889(VarNext)
      <=> v143891(VarNext) ) ) ).

tff(addAssignment_80787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143891(VarNext)
      <=> v143882(VarCurr) ) ) ).

tff(addAssignment_80786,axiom,
    ! [VarCurr: state_type] :
      ( v143882(VarCurr)
    <=> v143884(VarCurr) ) ).

tff(addAssignment_80785,axiom,
    ! [VarCurr: state_type] :
      ( v143884(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143862(VarCurr,B)
      <=> v143864(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143864(VarCurr,B)
      <=> ( v143874(VarCurr,B)
          | v143877(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143877(VarCurr,B)
      <=> ( v143850(VarCurr,B)
          & v143878(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143878(VarCurr,B)
      <=> ~ v143879(VarCurr,B) ) ) ).

tff(addAssignment_80783,axiom,
    ! [VarCurr: state_type] :
      ( v143879(VarCurr,0)
    <=> v143880(VarCurr) ) ).

tff(addAssignment_80782,axiom,
    ! [VarCurr: state_type] :
      ( v143879(VarCurr,1)
    <=> v143880(VarCurr) ) ).

tff(addAssignment_80781,axiom,
    ! [VarCurr: state_type] :
      ( v143879(VarCurr,2)
    <=> v143880(VarCurr) ) ).

tff(addAssignment_80780,axiom,
    ! [VarCurr: state_type] :
      ( v143879(VarCurr,3)
    <=> v143880(VarCurr) ) ).

tff(addAssignment_80779,axiom,
    ! [VarCurr: state_type] :
      ( v143880(VarCurr)
    <=> v143868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v143874(VarCurr,B)
      <=> ( v143866(VarCurr,B)
          & v143875(VarCurr,B) ) ) ) ).

tff(addAssignment_80778,axiom,
    ! [VarCurr: state_type] :
      ( v143875(VarCurr,0)
    <=> v143876(VarCurr) ) ).

tff(addAssignment_80777,axiom,
    ! [VarCurr: state_type] :
      ( v143875(VarCurr,1)
    <=> v143876(VarCurr) ) ).

tff(addAssignment_80776,axiom,
    ! [VarCurr: state_type] :
      ( v143875(VarCurr,2)
    <=> v143876(VarCurr) ) ).

tff(addAssignment_80775,axiom,
    ! [VarCurr: state_type] :
      ( v143875(VarCurr,3)
    <=> v143876(VarCurr) ) ).

tff(addAssignment_80774,axiom,
    ! [VarCurr: state_type] :
      ( v143876(VarCurr)
    <=> v143868(VarCurr) ) ).

tff(addAssignment_80773,axiom,
    ! [VarCurr: state_type] :
      ( v143868(VarCurr)
    <=> v143870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19171,axiom,
    ! [VarCurr: state_type] :
      ( v143870(VarCurr)
    <=> ( v2044(VarCurr)
        & v143872(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2184,axiom,
    ! [VarCurr: state_type] :
      ( v143872(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $true ) ) ) ).

tff(addAssignment_80772,axiom,
    ! [VarCurr: state_type] :
      ( ( v143866(VarCurr,3)
      <=> v2200(VarCurr,11) )
      & ( v143866(VarCurr,2)
      <=> v2200(VarCurr,10) )
      & ( v143866(VarCurr,1)
      <=> v2200(VarCurr,9) )
      & ( v143866(VarCurr,0)
      <=> v2200(VarCurr,8) ) ) ).

tff(addAssignment_80771,axiom,
    ! [VarCurr: state_type] :
      ( v143858(VarCurr)
    <=> v143860(VarCurr) ) ).

tff(addAssignment_80770,axiom,
    ! [VarCurr: state_type] :
      ( v143860(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_80769,axiom,
    ! [VarCurr: state_type] :
      ( v143854(VarCurr)
    <=> v143856(VarCurr) ) ).

tff(addAssignment_80768,axiom,
    ! [VarCurr: state_type] :
      ( v143856(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_80767,axiom,
    ! [VarCurr: state_type] :
      ( v143800(VarCurr)
    <=> v143802(VarCurr,2) ) ).

tff(addAssignment_80766,axiom,
    ! [VarCurr: state_type] :
      ( v143802(VarCurr,2)
    <=> v143804(VarCurr,2) ) ).

tff(addAssignment_80765,axiom,
    ! [VarNext: state_type] :
      ( v143804(VarNext,2)
    <=> v143830(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143831(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v143830(VarNext,B)
            <=> v143804(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2037,axiom,
    ! [VarNext: state_type] :
      ( v143831(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143830(VarNext,B)
          <=> v143841(VarNext,B) ) ) ) ).

tff(addAssignment_80764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143841(VarNext,B)
          <=> v143839(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143842(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143839(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1570,axiom,
    ! [VarCurr: state_type] :
      ( v143842(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v143839(VarCurr,B)
          <=> v143814(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19170,axiom,
    ! [VarCurr: state_type] :
      ( v143842(VarCurr)
    <=> ( v143843(VarCurr)
        & v143844(VarCurr) ) ) ).

tff(writeUnaryOperator_10951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143844(VarCurr)
    <=> v143810(VarCurr) ) ).

tff(writeUnaryOperator_10950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143843(VarCurr)
    <=> v143806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143831(VarNext)
      <=> v143832(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143832(VarNext)
      <=> ( v143833(VarNext)
          & v143826(VarNext) ) ) ) ).

tff(writeUnaryOperator_10949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143833(VarNext)
      <=> v143835(VarNext) ) ) ).

tff(addAssignment_80763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143835(VarNext)
      <=> v143826(VarCurr) ) ) ).

tff(addAssignment_80762,axiom,
    ! [VarCurr: state_type] :
      ( v143826(VarCurr)
    <=> v143828(VarCurr) ) ).

tff(addAssignment_80761,axiom,
    ! [VarCurr: state_type] :
      ( v143828(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_80760,axiom,
    ! [VarCurr: state_type] :
      ( v143814(VarCurr,2)
    <=> v143816(VarCurr,2) ) ).

tff(addAssignment_80759,axiom,
    ! [VarCurr: state_type] :
      ( v143816(VarCurr,2)
    <=> v143818(VarCurr,2) ) ).

tff(addAssignment_80758,axiom,
    ! [VarCurr: state_type] :
      ( v143818(VarCurr,2)
    <=> v143823(VarCurr,2) ) ).

tff(addAssignment_80757,axiom,
    ! [VarCurr: state_type] :
      ( v143823(VarCurr,0)
    <=> v143824(VarCurr) ) ).

tff(addAssignment_80756,axiom,
    ! [VarCurr: state_type] :
      ( v143823(VarCurr,1)
    <=> v143800(VarCurr) ) ).

tff(addAssignment_80755,axiom,
    ! [VarCurr: state_type] :
      ( v143823(VarCurr,2)
    <=> v143820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19167,axiom,
    ! [VarCurr: state_type] :
      ( v143820(VarCurr)
    <=> ( v2044(VarCurr)
        & v143822(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2183,axiom,
    ! [VarCurr: state_type] :
      ( v143822(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $true ) ) ) ).

tff(addAssignment_80754,axiom,
    ! [VarCurr: state_type] :
      ( v143810(VarCurr)
    <=> v143812(VarCurr) ) ).

tff(addAssignment_80753,axiom,
    ! [VarCurr: state_type] :
      ( v143812(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_80752,axiom,
    ! [VarCurr: state_type] :
      ( v143806(VarCurr)
    <=> v143808(VarCurr) ) ).

tff(addAssignment_80751,axiom,
    ! [VarCurr: state_type] :
      ( v143808(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_80750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2200(VarCurr,B)
      <=> v2202(VarCurr,B) ) ) ).

tff(addAssignment_80749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2202(VarCurr,B)
      <=> v143640(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143640(VarCurr,B)
      <=> ( v143641(VarCurr,B)
          | v143795(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143795(VarCurr,B)
      <=> ( v143796(VarCurr,B)
          & v143585(VarCurr,B) ) ) ) ).

tff(addAssignment_80748,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,0)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80747,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,1)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80746,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,2)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80745,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,3)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80744,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,4)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80743,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,5)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80742,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,6)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80741,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,7)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80740,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,8)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80739,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,9)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80738,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,10)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80737,axiom,
    ! [VarCurr: state_type] :
      ( v143796(VarCurr,11)
    <=> v143797(VarCurr) ) ).

tff(addAssignment_80736,axiom,
    ! [VarCurr: state_type] :
      ( v143797(VarCurr)
    <=> v143798(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2182,axiom,
    ! [VarCurr: state_type] :
      ( v143798(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143641(VarCurr,B)
      <=> ( v143642(VarCurr,B)
          | v143791(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143791(VarCurr,B)
      <=> ( v143792(VarCurr,B)
          & v143528(VarCurr,B) ) ) ) ).

tff(addAssignment_80735,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,0)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80734,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,1)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80733,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,2)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80732,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,3)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80731,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,4)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80730,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,5)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80729,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,6)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80728,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,7)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80727,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,8)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80726,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,9)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80725,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,10)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80724,axiom,
    ! [VarCurr: state_type] :
      ( v143792(VarCurr,11)
    <=> v143793(VarCurr) ) ).

tff(addAssignment_80723,axiom,
    ! [VarCurr: state_type] :
      ( v143793(VarCurr)
    <=> v143794(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2181,axiom,
    ! [VarCurr: state_type] :
      ( v143794(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143642(VarCurr,B)
      <=> ( v143643(VarCurr,B)
          | v143787(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143787(VarCurr,B)
      <=> ( v143788(VarCurr,B)
          & v143471(VarCurr,B) ) ) ) ).

tff(addAssignment_80722,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,0)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80721,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,1)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80720,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,2)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80719,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,3)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80718,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,4)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80717,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,5)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80716,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,6)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80715,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,7)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80714,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,8)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80713,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,9)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80712,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,10)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80711,axiom,
    ! [VarCurr: state_type] :
      ( v143788(VarCurr,11)
    <=> v143789(VarCurr) ) ).

tff(addAssignment_80710,axiom,
    ! [VarCurr: state_type] :
      ( v143789(VarCurr)
    <=> v143790(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2180,axiom,
    ! [VarCurr: state_type] :
      ( v143790(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143643(VarCurr,B)
      <=> ( v143644(VarCurr,B)
          | v143783(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143783(VarCurr,B)
      <=> ( v143784(VarCurr,B)
          & v143414(VarCurr,B) ) ) ) ).

tff(addAssignment_80709,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,0)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80708,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,1)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80707,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,2)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80706,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,3)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80705,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,4)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80704,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,5)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80703,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,6)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80702,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,7)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80701,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,8)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80700,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,9)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80699,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,10)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80698,axiom,
    ! [VarCurr: state_type] :
      ( v143784(VarCurr,11)
    <=> v143785(VarCurr) ) ).

tff(addAssignment_80697,axiom,
    ! [VarCurr: state_type] :
      ( v143785(VarCurr)
    <=> v143786(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2179,axiom,
    ! [VarCurr: state_type] :
      ( v143786(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143644(VarCurr,B)
      <=> ( v143645(VarCurr,B)
          | v143779(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143779(VarCurr,B)
      <=> ( v143780(VarCurr,B)
          & v143357(VarCurr,B) ) ) ) ).

tff(addAssignment_80696,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,0)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80695,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,1)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80694,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,2)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80693,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,3)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80692,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,4)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80691,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,5)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80690,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,6)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80689,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,7)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80688,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,8)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80687,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,9)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80686,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,10)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80685,axiom,
    ! [VarCurr: state_type] :
      ( v143780(VarCurr,11)
    <=> v143781(VarCurr) ) ).

tff(addAssignment_80684,axiom,
    ! [VarCurr: state_type] :
      ( v143781(VarCurr)
    <=> v143782(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2178,axiom,
    ! [VarCurr: state_type] :
      ( v143782(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143645(VarCurr,B)
      <=> ( v143646(VarCurr,B)
          | v143775(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143775(VarCurr,B)
      <=> ( v143776(VarCurr,B)
          & v143300(VarCurr,B) ) ) ) ).

tff(addAssignment_80683,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,0)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80682,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,1)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80681,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,2)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80680,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,3)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80679,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,4)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80678,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,5)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80677,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,6)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80676,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,7)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80675,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,8)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80674,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,9)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80673,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,10)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80672,axiom,
    ! [VarCurr: state_type] :
      ( v143776(VarCurr,11)
    <=> v143777(VarCurr) ) ).

tff(addAssignment_80671,axiom,
    ! [VarCurr: state_type] :
      ( v143777(VarCurr)
    <=> v143778(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2177,axiom,
    ! [VarCurr: state_type] :
      ( v143778(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143646(VarCurr,B)
      <=> ( v143647(VarCurr,B)
          | v143771(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143771(VarCurr,B)
      <=> ( v143772(VarCurr,B)
          & v143243(VarCurr,B) ) ) ) ).

tff(addAssignment_80670,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,0)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80669,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,1)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80668,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,2)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80667,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,3)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80666,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,4)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80665,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,5)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80664,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,6)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80663,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,7)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80662,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,8)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80661,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,9)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80660,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,10)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80659,axiom,
    ! [VarCurr: state_type] :
      ( v143772(VarCurr,11)
    <=> v143773(VarCurr) ) ).

tff(addAssignment_80658,axiom,
    ! [VarCurr: state_type] :
      ( v143773(VarCurr)
    <=> v143774(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2176,axiom,
    ! [VarCurr: state_type] :
      ( v143774(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143647(VarCurr,B)
      <=> ( v143648(VarCurr,B)
          | v143767(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143767(VarCurr,B)
      <=> ( v143768(VarCurr,B)
          & v143186(VarCurr,B) ) ) ) ).

tff(addAssignment_80657,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,0)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80656,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,1)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80655,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,2)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80654,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,3)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80653,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,4)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80652,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,5)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80651,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,6)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80650,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,7)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80649,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,8)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80648,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,9)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80647,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,10)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80646,axiom,
    ! [VarCurr: state_type] :
      ( v143768(VarCurr,11)
    <=> v143769(VarCurr) ) ).

tff(addAssignment_80645,axiom,
    ! [VarCurr: state_type] :
      ( v143769(VarCurr)
    <=> v143770(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2175,axiom,
    ! [VarCurr: state_type] :
      ( v143770(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143648(VarCurr,B)
      <=> ( v143649(VarCurr,B)
          | v143763(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143763(VarCurr,B)
      <=> ( v143764(VarCurr,B)
          & v143129(VarCurr,B) ) ) ) ).

tff(addAssignment_80644,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,0)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80643,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,1)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80642,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,2)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80641,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,3)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80640,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,4)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80639,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,5)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80638,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,6)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80637,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,7)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80636,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,8)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80635,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,9)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80634,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,10)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80633,axiom,
    ! [VarCurr: state_type] :
      ( v143764(VarCurr,11)
    <=> v143765(VarCurr) ) ).

tff(addAssignment_80632,axiom,
    ! [VarCurr: state_type] :
      ( v143765(VarCurr)
    <=> v143766(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2174,axiom,
    ! [VarCurr: state_type] :
      ( v143766(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143649(VarCurr,B)
      <=> ( v143650(VarCurr,B)
          | v143759(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143759(VarCurr,B)
      <=> ( v143760(VarCurr,B)
          & v143072(VarCurr,B) ) ) ) ).

tff(addAssignment_80631,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,0)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80630,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,1)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80629,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,2)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80628,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,3)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80627,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,4)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80626,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,5)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80625,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,6)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80624,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,7)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80623,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,8)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80622,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,9)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80621,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,10)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80620,axiom,
    ! [VarCurr: state_type] :
      ( v143760(VarCurr,11)
    <=> v143761(VarCurr) ) ).

tff(addAssignment_80619,axiom,
    ! [VarCurr: state_type] :
      ( v143761(VarCurr)
    <=> v143762(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2173,axiom,
    ! [VarCurr: state_type] :
      ( v143762(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143650(VarCurr,B)
      <=> ( v143651(VarCurr,B)
          | v143755(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143755(VarCurr,B)
      <=> ( v143756(VarCurr,B)
          & v143015(VarCurr,B) ) ) ) ).

tff(addAssignment_80618,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,0)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80617,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,1)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80616,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,2)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80615,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,3)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80614,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,4)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80613,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,5)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80612,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,6)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80611,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,7)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80610,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,8)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80609,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,9)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80608,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,10)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80607,axiom,
    ! [VarCurr: state_type] :
      ( v143756(VarCurr,11)
    <=> v143757(VarCurr) ) ).

tff(addAssignment_80606,axiom,
    ! [VarCurr: state_type] :
      ( v143757(VarCurr)
    <=> v143758(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2172,axiom,
    ! [VarCurr: state_type] :
      ( v143758(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143651(VarCurr,B)
      <=> ( v143652(VarCurr,B)
          | v143751(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143751(VarCurr,B)
      <=> ( v143752(VarCurr,B)
          & v142958(VarCurr,B) ) ) ) ).

tff(addAssignment_80605,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,0)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80604,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,1)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80603,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,2)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80602,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,3)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80601,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,4)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80600,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,5)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80599,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,6)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80598,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,7)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80597,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,8)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80596,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,9)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80595,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,10)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80594,axiom,
    ! [VarCurr: state_type] :
      ( v143752(VarCurr,11)
    <=> v143753(VarCurr) ) ).

tff(addAssignment_80593,axiom,
    ! [VarCurr: state_type] :
      ( v143753(VarCurr)
    <=> v143754(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2171,axiom,
    ! [VarCurr: state_type] :
      ( v143754(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143652(VarCurr,B)
      <=> ( v143653(VarCurr,B)
          | v143747(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143747(VarCurr,B)
      <=> ( v143748(VarCurr,B)
          & v142901(VarCurr,B) ) ) ) ).

tff(addAssignment_80592,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,0)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80591,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,1)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80590,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,2)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80589,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,3)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80588,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,4)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80587,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,5)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80586,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,6)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80585,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,7)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80584,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,8)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80583,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,9)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80582,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,10)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80581,axiom,
    ! [VarCurr: state_type] :
      ( v143748(VarCurr,11)
    <=> v143749(VarCurr) ) ).

tff(addAssignment_80580,axiom,
    ! [VarCurr: state_type] :
      ( v143749(VarCurr)
    <=> v143750(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2170,axiom,
    ! [VarCurr: state_type] :
      ( v143750(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143653(VarCurr,B)
      <=> ( v143654(VarCurr,B)
          | v143743(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143743(VarCurr,B)
      <=> ( v143744(VarCurr,B)
          & v142844(VarCurr,B) ) ) ) ).

tff(addAssignment_80579,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,0)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80578,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,1)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80577,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,2)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80576,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,3)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80575,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,4)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80574,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,5)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80573,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,6)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80572,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,7)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80571,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,8)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80570,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,9)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80569,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,10)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80568,axiom,
    ! [VarCurr: state_type] :
      ( v143744(VarCurr,11)
    <=> v143745(VarCurr) ) ).

tff(addAssignment_80567,axiom,
    ! [VarCurr: state_type] :
      ( v143745(VarCurr)
    <=> v143746(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2169,axiom,
    ! [VarCurr: state_type] :
      ( v143746(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143654(VarCurr,B)
      <=> ( v143655(VarCurr,B)
          | v143739(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143739(VarCurr,B)
      <=> ( v143740(VarCurr,B)
          & v142787(VarCurr,B) ) ) ) ).

tff(addAssignment_80566,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,0)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80565,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,1)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80564,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,2)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80563,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,3)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80562,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,4)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80561,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,5)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80560,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,6)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80559,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,7)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80558,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,8)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80557,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,9)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80556,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,10)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80555,axiom,
    ! [VarCurr: state_type] :
      ( v143740(VarCurr,11)
    <=> v143741(VarCurr) ) ).

tff(addAssignment_80554,axiom,
    ! [VarCurr: state_type] :
      ( v143741(VarCurr)
    <=> v143742(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2168,axiom,
    ! [VarCurr: state_type] :
      ( v143742(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143655(VarCurr,B)
      <=> ( v143656(VarCurr,B)
          | v143735(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143735(VarCurr,B)
      <=> ( v143736(VarCurr,B)
          & v142730(VarCurr,B) ) ) ) ).

tff(addAssignment_80553,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,0)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80552,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,1)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80551,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,2)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80550,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,3)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80549,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,4)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80548,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,5)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80547,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,6)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80546,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,7)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80545,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,8)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80544,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,9)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80543,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,10)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80542,axiom,
    ! [VarCurr: state_type] :
      ( v143736(VarCurr,11)
    <=> v143737(VarCurr) ) ).

tff(addAssignment_80541,axiom,
    ! [VarCurr: state_type] :
      ( v143737(VarCurr)
    <=> v143738(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2167,axiom,
    ! [VarCurr: state_type] :
      ( v143738(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $true )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143656(VarCurr,B)
      <=> ( v143657(VarCurr,B)
          | v143731(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143731(VarCurr,B)
      <=> ( v143732(VarCurr,B)
          & v142674(VarCurr,B) ) ) ) ).

tff(addAssignment_80540,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,0)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80539,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,1)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80538,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,2)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80537,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,3)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80536,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,4)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80535,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,5)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80534,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,6)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80533,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,7)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80532,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,8)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80531,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,9)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80530,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,10)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80529,axiom,
    ! [VarCurr: state_type] :
      ( v143732(VarCurr,11)
    <=> v143733(VarCurr) ) ).

tff(addAssignment_80528,axiom,
    ! [VarCurr: state_type] :
      ( v143733(VarCurr)
    <=> v143734(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2166,axiom,
    ! [VarCurr: state_type] :
      ( v143734(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143657(VarCurr,B)
      <=> ( v143658(VarCurr,B)
          | v143727(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143727(VarCurr,B)
      <=> ( v143728(VarCurr,B)
          & v142618(VarCurr,B) ) ) ) ).

tff(addAssignment_80527,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,0)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80526,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,1)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80525,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,2)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80524,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,3)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80523,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,4)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80522,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,5)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80521,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,6)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80520,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,7)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80519,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,8)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80518,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,9)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80517,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,10)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80516,axiom,
    ! [VarCurr: state_type] :
      ( v143728(VarCurr,11)
    <=> v143729(VarCurr) ) ).

tff(addAssignment_80515,axiom,
    ! [VarCurr: state_type] :
      ( v143729(VarCurr)
    <=> v143730(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2165,axiom,
    ! [VarCurr: state_type] :
      ( v143730(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143658(VarCurr,B)
      <=> ( v143659(VarCurr,B)
          | v143723(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143723(VarCurr,B)
      <=> ( v143724(VarCurr,B)
          & v142562(VarCurr,B) ) ) ) ).

tff(addAssignment_80514,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,0)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80513,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,1)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80512,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,2)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80511,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,3)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80510,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,4)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80509,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,5)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80508,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,6)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80507,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,7)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80506,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,8)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80505,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,9)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80504,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,10)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80503,axiom,
    ! [VarCurr: state_type] :
      ( v143724(VarCurr,11)
    <=> v143725(VarCurr) ) ).

tff(addAssignment_80502,axiom,
    ! [VarCurr: state_type] :
      ( v143725(VarCurr)
    <=> v143726(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2164,axiom,
    ! [VarCurr: state_type] :
      ( v143726(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143659(VarCurr,B)
      <=> ( v143660(VarCurr,B)
          | v143719(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143719(VarCurr,B)
      <=> ( v143720(VarCurr,B)
          & v142506(VarCurr,B) ) ) ) ).

tff(addAssignment_80501,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,0)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80500,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,1)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80499,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,2)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80498,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,3)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80497,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,4)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80496,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,5)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80495,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,6)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80494,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,7)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80493,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,8)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80492,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,9)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80491,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,10)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80490,axiom,
    ! [VarCurr: state_type] :
      ( v143720(VarCurr,11)
    <=> v143721(VarCurr) ) ).

tff(addAssignment_80489,axiom,
    ! [VarCurr: state_type] :
      ( v143721(VarCurr)
    <=> v143722(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2163,axiom,
    ! [VarCurr: state_type] :
      ( v143722(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143660(VarCurr,B)
      <=> ( v143661(VarCurr,B)
          | v143715(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143715(VarCurr,B)
      <=> ( v143716(VarCurr,B)
          & v142450(VarCurr,B) ) ) ) ).

tff(addAssignment_80488,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,0)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80487,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,1)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80486,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,2)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80485,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,3)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80484,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,4)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80483,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,5)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80482,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,6)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80481,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,7)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80480,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,8)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80479,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,9)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80478,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,10)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80477,axiom,
    ! [VarCurr: state_type] :
      ( v143716(VarCurr,11)
    <=> v143717(VarCurr) ) ).

tff(addAssignment_80476,axiom,
    ! [VarCurr: state_type] :
      ( v143717(VarCurr)
    <=> v143718(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2162,axiom,
    ! [VarCurr: state_type] :
      ( v143718(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143661(VarCurr,B)
      <=> ( v143662(VarCurr,B)
          | v143711(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143711(VarCurr,B)
      <=> ( v143712(VarCurr,B)
          & v142394(VarCurr,B) ) ) ) ).

tff(addAssignment_80475,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,0)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80474,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,1)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80473,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,2)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80472,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,3)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80471,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,4)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80470,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,5)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80469,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,6)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80468,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,7)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80467,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,8)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80466,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,9)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80465,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,10)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80464,axiom,
    ! [VarCurr: state_type] :
      ( v143712(VarCurr,11)
    <=> v143713(VarCurr) ) ).

tff(addAssignment_80463,axiom,
    ! [VarCurr: state_type] :
      ( v143713(VarCurr)
    <=> v143714(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2161,axiom,
    ! [VarCurr: state_type] :
      ( v143714(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143662(VarCurr,B)
      <=> ( v143663(VarCurr,B)
          | v143707(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143707(VarCurr,B)
      <=> ( v143708(VarCurr,B)
          & v142338(VarCurr,B) ) ) ) ).

tff(addAssignment_80462,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,0)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80461,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,1)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80460,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,2)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80459,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,3)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80458,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,4)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80457,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,5)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80456,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,6)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80455,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,7)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80454,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,8)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80453,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,9)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80452,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,10)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80451,axiom,
    ! [VarCurr: state_type] :
      ( v143708(VarCurr,11)
    <=> v143709(VarCurr) ) ).

tff(addAssignment_80450,axiom,
    ! [VarCurr: state_type] :
      ( v143709(VarCurr)
    <=> v143710(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2160,axiom,
    ! [VarCurr: state_type] :
      ( v143710(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143663(VarCurr,B)
      <=> ( v143664(VarCurr,B)
          | v143703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143703(VarCurr,B)
      <=> ( v143704(VarCurr,B)
          & v142282(VarCurr,B) ) ) ) ).

tff(addAssignment_80449,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,0)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80448,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,1)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80447,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,2)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80446,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,3)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80445,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,4)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80444,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,5)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80443,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,6)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80442,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,7)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80441,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,8)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80440,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,9)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80439,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,10)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80438,axiom,
    ! [VarCurr: state_type] :
      ( v143704(VarCurr,11)
    <=> v143705(VarCurr) ) ).

tff(addAssignment_80437,axiom,
    ! [VarCurr: state_type] :
      ( v143705(VarCurr)
    <=> v143706(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2159,axiom,
    ! [VarCurr: state_type] :
      ( v143706(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $true )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143664(VarCurr,B)
      <=> ( v143665(VarCurr,B)
          | v143699(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143699(VarCurr,B)
      <=> ( v143700(VarCurr,B)
          & v142226(VarCurr,B) ) ) ) ).

tff(addAssignment_80436,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,0)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80435,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,1)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80434,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,2)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80433,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,3)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80432,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,4)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80431,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,5)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80430,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,6)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80429,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,7)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80428,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,8)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80427,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,9)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80426,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,10)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80425,axiom,
    ! [VarCurr: state_type] :
      ( v143700(VarCurr,11)
    <=> v143701(VarCurr) ) ).

tff(addAssignment_80424,axiom,
    ! [VarCurr: state_type] :
      ( v143701(VarCurr)
    <=> v143702(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2158,axiom,
    ! [VarCurr: state_type] :
      ( v143702(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143665(VarCurr,B)
      <=> ( v143666(VarCurr,B)
          | v143695(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143695(VarCurr,B)
      <=> ( v143696(VarCurr,B)
          & v142170(VarCurr,B) ) ) ) ).

tff(addAssignment_80423,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,0)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80422,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,1)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80421,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,2)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80420,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,3)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80419,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,4)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80418,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,5)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80417,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,6)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80416,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,7)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80415,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,8)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80414,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,9)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80413,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,10)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80412,axiom,
    ! [VarCurr: state_type] :
      ( v143696(VarCurr,11)
    <=> v143697(VarCurr) ) ).

tff(addAssignment_80411,axiom,
    ! [VarCurr: state_type] :
      ( v143697(VarCurr)
    <=> v143698(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2157,axiom,
    ! [VarCurr: state_type] :
      ( v143698(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143666(VarCurr,B)
      <=> ( v143667(VarCurr,B)
          | v143691(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143691(VarCurr,B)
      <=> ( v143692(VarCurr,B)
          & v142114(VarCurr,B) ) ) ) ).

tff(addAssignment_80410,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,0)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80409,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,1)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80408,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,2)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80407,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,3)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80406,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,4)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80405,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,5)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80404,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,6)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80403,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,7)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80402,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,8)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80401,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,9)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80400,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,10)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80399,axiom,
    ! [VarCurr: state_type] :
      ( v143692(VarCurr,11)
    <=> v143693(VarCurr) ) ).

tff(addAssignment_80398,axiom,
    ! [VarCurr: state_type] :
      ( v143693(VarCurr)
    <=> v143694(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2156,axiom,
    ! [VarCurr: state_type] :
      ( v143694(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143667(VarCurr,B)
      <=> ( v143668(VarCurr,B)
          | v143687(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143687(VarCurr,B)
      <=> ( v143688(VarCurr,B)
          & v142058(VarCurr,B) ) ) ) ).

tff(addAssignment_80397,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,0)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80396,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,1)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80395,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,2)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80394,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,3)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80393,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,4)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80392,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,5)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80391,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,6)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80390,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,7)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80389,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,8)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80388,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,9)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80387,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,10)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80386,axiom,
    ! [VarCurr: state_type] :
      ( v143688(VarCurr,11)
    <=> v143689(VarCurr) ) ).

tff(addAssignment_80385,axiom,
    ! [VarCurr: state_type] :
      ( v143689(VarCurr)
    <=> v143690(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2155,axiom,
    ! [VarCurr: state_type] :
      ( v143690(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $true )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143668(VarCurr,B)
      <=> ( v143669(VarCurr,B)
          | v143683(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143683(VarCurr,B)
      <=> ( v143684(VarCurr,B)
          & v142002(VarCurr,B) ) ) ) ).

tff(addAssignment_80384,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,0)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80383,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,1)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80382,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,2)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80381,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,3)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80380,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,4)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80379,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,5)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80378,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,6)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80377,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,7)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80376,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,8)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80375,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,9)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80374,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,10)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80373,axiom,
    ! [VarCurr: state_type] :
      ( v143684(VarCurr,11)
    <=> v143685(VarCurr) ) ).

tff(addAssignment_80372,axiom,
    ! [VarCurr: state_type] :
      ( v143685(VarCurr)
    <=> v143686(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2154,axiom,
    ! [VarCurr: state_type] :
      ( v143686(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143669(VarCurr,B)
      <=> ( v143670(VarCurr,B)
          | v143679(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143679(VarCurr,B)
      <=> ( v143680(VarCurr,B)
          & v141946(VarCurr,B) ) ) ) ).

tff(addAssignment_80371,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,0)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80370,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,1)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80369,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,2)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80368,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,3)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80367,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,4)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80366,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,5)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80365,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,6)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80364,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,7)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80363,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,8)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80362,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,9)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80361,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,10)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80360,axiom,
    ! [VarCurr: state_type] :
      ( v143680(VarCurr,11)
    <=> v143681(VarCurr) ) ).

tff(addAssignment_80359,axiom,
    ! [VarCurr: state_type] :
      ( v143681(VarCurr)
    <=> v143682(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2153,axiom,
    ! [VarCurr: state_type] :
      ( v143682(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $true )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143670(VarCurr,B)
      <=> ( v143671(VarCurr,B)
          | v143675(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143675(VarCurr,B)
      <=> ( v143676(VarCurr,B)
          & v141890(VarCurr,B) ) ) ) ).

tff(addAssignment_80358,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,0)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80357,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,1)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80356,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,2)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80355,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,3)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80354,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,4)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80353,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,5)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80352,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,6)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80351,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,7)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80350,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,8)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80349,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,9)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80348,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,10)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80347,axiom,
    ! [VarCurr: state_type] :
      ( v143676(VarCurr,11)
    <=> v143677(VarCurr) ) ).

tff(addAssignment_80346,axiom,
    ! [VarCurr: state_type] :
      ( v143677(VarCurr)
    <=> v143678(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2152,axiom,
    ! [VarCurr: state_type] :
      ( v143678(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143671(VarCurr,B)
      <=> ( v143672(VarCurr,B)
          & v2302(VarCurr,B) ) ) ) ).

tff(addAssignment_80345,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,0)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80344,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,1)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80343,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,2)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80342,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,3)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80341,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,4)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80340,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,5)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80339,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,6)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80338,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,7)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80337,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,8)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80336,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,9)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80335,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,10)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80334,axiom,
    ! [VarCurr: state_type] :
      ( v143672(VarCurr,11)
    <=> v143673(VarCurr) ) ).

tff(addAssignment_80333,axiom,
    ! [VarCurr: state_type] :
      ( v143673(VarCurr)
    <=> v143674(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2151,axiom,
    ! [VarCurr: state_type] :
      ( v143674(VarCurr)
    <=> ( ( v2204(VarCurr,4)
        <=> $false )
        & ( v2204(VarCurr,3)
        <=> $false )
        & ( v2204(VarCurr,2)
        <=> $false )
        & ( v2204(VarCurr,1)
        <=> $false )
        & ( v2204(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_80332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143585(VarCurr,B)
      <=> v143587(VarCurr,B) ) ) ).

tff(addAssignment_80331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143587(VarCurr,B)
      <=> v143589(VarCurr,B) ) ) ).

tff(addAssignment_80330,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143589(VarNext,B)
      <=> v143623(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143624(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143623(VarNext,B)
            <=> v143589(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2036,axiom,
    ! [VarNext: state_type] :
      ( v143624(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143623(VarNext,B)
          <=> v143634(VarNext,B) ) ) ) ).

tff(addAssignment_80329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143634(VarNext,B)
          <=> v143632(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143632(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1569,axiom,
    ! [VarCurr: state_type] :
      ( v143635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143632(VarCurr,B)
          <=> v143599(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19166,axiom,
    ! [VarCurr: state_type] :
      ( v143635(VarCurr)
    <=> ( v143636(VarCurr)
        & v143637(VarCurr) ) ) ).

tff(writeUnaryOperator_10948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143637(VarCurr)
    <=> v143595(VarCurr) ) ).

tff(writeUnaryOperator_10947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143636(VarCurr)
    <=> v143591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143624(VarNext)
      <=> v143625(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143625(VarNext)
      <=> ( v143626(VarNext)
          & v143619(VarNext) ) ) ) ).

tff(writeUnaryOperator_10946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143626(VarNext)
      <=> v143628(VarNext) ) ) ).

tff(addAssignment_80328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143628(VarNext)
      <=> v143619(VarCurr) ) ) ).

tff(addAssignment_80327,axiom,
    ! [VarCurr: state_type] :
      ( v143619(VarCurr)
    <=> v143621(VarCurr) ) ).

tff(addAssignment_80326,axiom,
    ! [VarCurr: state_type] :
      ( v143621(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143599(VarCurr,B)
      <=> v143601(VarCurr,B) ) ) ).

tff(addAssignment_80324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143601(VarCurr,B)
      <=> v143610(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143610(VarCurr,B)
      <=> ( v143611(VarCurr,B)
          | v143614(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143614(VarCurr,B)
      <=> ( v143587(VarCurr,B)
          & v143615(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143615(VarCurr,B)
      <=> ~ v143616(VarCurr,B) ) ) ).

tff(addAssignment_80323,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,0)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80322,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,1)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80321,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,2)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80320,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,3)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80319,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,4)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80318,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,5)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80317,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,6)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80316,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,7)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80315,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,8)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80314,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,9)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80313,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,10)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80312,axiom,
    ! [VarCurr: state_type] :
      ( v143616(VarCurr,11)
    <=> v143617(VarCurr) ) ).

tff(addAssignment_80311,axiom,
    ! [VarCurr: state_type] :
      ( v143617(VarCurr)
    <=> v143605(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143611(VarCurr,B)
      <=> ( v143603(VarCurr,B)
          & v143612(VarCurr,B) ) ) ) ).

tff(addAssignment_80310,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,0)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80309,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,1)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80308,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,2)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80307,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,3)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80306,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,4)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80305,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,5)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80304,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,6)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80303,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,7)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80302,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,8)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80301,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,9)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80300,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,10)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80299,axiom,
    ! [VarCurr: state_type] :
      ( v143612(VarCurr,11)
    <=> v143613(VarCurr) ) ).

tff(addAssignment_80298,axiom,
    ! [VarCurr: state_type] :
      ( v143613(VarCurr)
    <=> v143605(VarCurr) ) ).

tff(addAssignment_80297,axiom,
    ! [VarCurr: state_type] :
      ( v143605(VarCurr)
    <=> v143607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19163,axiom,
    ! [VarCurr: state_type] :
      ( v143607(VarCurr)
    <=> ( v143609(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2150,axiom,
    ! [VarCurr: state_type] :
      ( v143609(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2105,axiom,
    b11111(4) ).

tff(bitBlastConstant_2104,axiom,
    b11111(3) ).

tff(bitBlastConstant_2103,axiom,
    b11111(2) ).

tff(bitBlastConstant_2102,axiom,
    b11111(1) ).

tff(bitBlastConstant_2101,axiom,
    b11111(0) ).

tff(addAssignment_80296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143603(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80295,axiom,
    ! [VarCurr: state_type] :
      ( v143595(VarCurr)
    <=> v143597(VarCurr) ) ).

tff(addAssignment_80294,axiom,
    ! [VarCurr: state_type] :
      ( v143597(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80293,axiom,
    ! [VarCurr: state_type] :
      ( v143591(VarCurr)
    <=> v143593(VarCurr) ) ).

tff(addAssignment_80292,axiom,
    ! [VarCurr: state_type] :
      ( v143593(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143528(VarCurr,B)
      <=> v143530(VarCurr,B) ) ) ).

tff(addAssignment_80290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143530(VarCurr,B)
      <=> v143532(VarCurr,B) ) ) ).

tff(addAssignment_80289,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143532(VarNext,B)
      <=> v143566(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143567(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143566(VarNext,B)
            <=> v143532(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2035,axiom,
    ! [VarNext: state_type] :
      ( v143567(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143566(VarNext,B)
          <=> v143577(VarNext,B) ) ) ) ).

tff(addAssignment_80288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143577(VarNext,B)
          <=> v143575(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143578(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143575(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1568,axiom,
    ! [VarCurr: state_type] :
      ( v143578(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143575(VarCurr,B)
          <=> v143542(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19162,axiom,
    ! [VarCurr: state_type] :
      ( v143578(VarCurr)
    <=> ( v143579(VarCurr)
        & v143580(VarCurr) ) ) ).

tff(writeUnaryOperator_10944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143580(VarCurr)
    <=> v143538(VarCurr) ) ).

tff(writeUnaryOperator_10943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143579(VarCurr)
    <=> v143534(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143567(VarNext)
      <=> v143568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143568(VarNext)
      <=> ( v143569(VarNext)
          & v143562(VarNext) ) ) ) ).

tff(writeUnaryOperator_10942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143569(VarNext)
      <=> v143571(VarNext) ) ) ).

tff(addAssignment_80287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143571(VarNext)
      <=> v143562(VarCurr) ) ) ).

tff(addAssignment_80286,axiom,
    ! [VarCurr: state_type] :
      ( v143562(VarCurr)
    <=> v143564(VarCurr) ) ).

tff(addAssignment_80285,axiom,
    ! [VarCurr: state_type] :
      ( v143564(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143542(VarCurr,B)
      <=> v143544(VarCurr,B) ) ) ).

tff(addAssignment_80283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143544(VarCurr,B)
      <=> v143553(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143553(VarCurr,B)
      <=> ( v143554(VarCurr,B)
          | v143557(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143557(VarCurr,B)
      <=> ( v143530(VarCurr,B)
          & v143558(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143558(VarCurr,B)
      <=> ~ v143559(VarCurr,B) ) ) ).

tff(addAssignment_80282,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,0)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80281,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,1)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80280,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,2)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80279,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,3)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80278,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,4)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80277,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,5)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80276,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,6)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80275,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,7)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80274,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,8)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80273,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,9)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80272,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,10)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80271,axiom,
    ! [VarCurr: state_type] :
      ( v143559(VarCurr,11)
    <=> v143560(VarCurr) ) ).

tff(addAssignment_80270,axiom,
    ! [VarCurr: state_type] :
      ( v143560(VarCurr)
    <=> v143548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143554(VarCurr,B)
      <=> ( v143546(VarCurr,B)
          & v143555(VarCurr,B) ) ) ) ).

tff(addAssignment_80269,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,0)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80268,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,1)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80267,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,2)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80266,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,3)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80265,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,4)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80264,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,5)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80263,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,6)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80262,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,7)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80261,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,8)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80260,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,9)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80259,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,10)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80258,axiom,
    ! [VarCurr: state_type] :
      ( v143555(VarCurr,11)
    <=> v143556(VarCurr) ) ).

tff(addAssignment_80257,axiom,
    ! [VarCurr: state_type] :
      ( v143556(VarCurr)
    <=> v143548(VarCurr) ) ).

tff(addAssignment_80256,axiom,
    ! [VarCurr: state_type] :
      ( v143548(VarCurr)
    <=> v143550(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19159,axiom,
    ! [VarCurr: state_type] :
      ( v143550(VarCurr)
    <=> ( v143552(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2149,axiom,
    ! [VarCurr: state_type] :
      ( v143552(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2100,axiom,
    b11110(4) ).

tff(bitBlastConstant_2099,axiom,
    b11110(3) ).

tff(bitBlastConstant_2098,axiom,
    b11110(2) ).

tff(bitBlastConstant_2097,axiom,
    b11110(1) ).

tff(bitBlastConstant_2096,axiom,
    ~ b11110(0) ).

tff(addAssignment_80255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143546(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80254,axiom,
    ! [VarCurr: state_type] :
      ( v143538(VarCurr)
    <=> v143540(VarCurr) ) ).

tff(addAssignment_80253,axiom,
    ! [VarCurr: state_type] :
      ( v143540(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80252,axiom,
    ! [VarCurr: state_type] :
      ( v143534(VarCurr)
    <=> v143536(VarCurr) ) ).

tff(addAssignment_80251,axiom,
    ! [VarCurr: state_type] :
      ( v143536(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143471(VarCurr,B)
      <=> v143473(VarCurr,B) ) ) ).

tff(addAssignment_80249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143473(VarCurr,B)
      <=> v143475(VarCurr,B) ) ) ).

tff(addAssignment_80248,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143475(VarNext,B)
      <=> v143509(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143510(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143509(VarNext,B)
            <=> v143475(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2034,axiom,
    ! [VarNext: state_type] :
      ( v143510(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143509(VarNext,B)
          <=> v143520(VarNext,B) ) ) ) ).

tff(addAssignment_80247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143520(VarNext,B)
          <=> v143518(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143521(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143518(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1567,axiom,
    ! [VarCurr: state_type] :
      ( v143521(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143518(VarCurr,B)
          <=> v143485(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19158,axiom,
    ! [VarCurr: state_type] :
      ( v143521(VarCurr)
    <=> ( v143522(VarCurr)
        & v143523(VarCurr) ) ) ).

tff(writeUnaryOperator_10940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143523(VarCurr)
    <=> v143481(VarCurr) ) ).

tff(writeUnaryOperator_10939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143522(VarCurr)
    <=> v143477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143510(VarNext)
      <=> v143511(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143511(VarNext)
      <=> ( v143512(VarNext)
          & v143505(VarNext) ) ) ) ).

tff(writeUnaryOperator_10938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143512(VarNext)
      <=> v143514(VarNext) ) ) ).

tff(addAssignment_80246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143514(VarNext)
      <=> v143505(VarCurr) ) ) ).

tff(addAssignment_80245,axiom,
    ! [VarCurr: state_type] :
      ( v143505(VarCurr)
    <=> v143507(VarCurr) ) ).

tff(addAssignment_80244,axiom,
    ! [VarCurr: state_type] :
      ( v143507(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143485(VarCurr,B)
      <=> v143487(VarCurr,B) ) ) ).

tff(addAssignment_80242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143487(VarCurr,B)
      <=> v143496(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143496(VarCurr,B)
      <=> ( v143497(VarCurr,B)
          | v143500(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143500(VarCurr,B)
      <=> ( v143473(VarCurr,B)
          & v143501(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143501(VarCurr,B)
      <=> ~ v143502(VarCurr,B) ) ) ).

tff(addAssignment_80241,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,0)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80240,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,1)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80239,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,2)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80238,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,3)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80237,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,4)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80236,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,5)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80235,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,6)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80234,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,7)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80233,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,8)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80232,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,9)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80231,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,10)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80230,axiom,
    ! [VarCurr: state_type] :
      ( v143502(VarCurr,11)
    <=> v143503(VarCurr) ) ).

tff(addAssignment_80229,axiom,
    ! [VarCurr: state_type] :
      ( v143503(VarCurr)
    <=> v143491(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143497(VarCurr,B)
      <=> ( v143489(VarCurr,B)
          & v143498(VarCurr,B) ) ) ) ).

tff(addAssignment_80228,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,0)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80227,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,1)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80226,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,2)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80225,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,3)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80224,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,4)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80223,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,5)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80222,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,6)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80221,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,7)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80220,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,8)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80219,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,9)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80218,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,10)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80217,axiom,
    ! [VarCurr: state_type] :
      ( v143498(VarCurr,11)
    <=> v143499(VarCurr) ) ).

tff(addAssignment_80216,axiom,
    ! [VarCurr: state_type] :
      ( v143499(VarCurr)
    <=> v143491(VarCurr) ) ).

tff(addAssignment_80215,axiom,
    ! [VarCurr: state_type] :
      ( v143491(VarCurr)
    <=> v143493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19155,axiom,
    ! [VarCurr: state_type] :
      ( v143493(VarCurr)
    <=> ( v143495(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2148,axiom,
    ! [VarCurr: state_type] :
      ( v143495(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2095,axiom,
    b11101(4) ).

tff(bitBlastConstant_2094,axiom,
    b11101(3) ).

tff(bitBlastConstant_2093,axiom,
    b11101(2) ).

tff(bitBlastConstant_2092,axiom,
    ~ b11101(1) ).

tff(bitBlastConstant_2091,axiom,
    b11101(0) ).

tff(addAssignment_80214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143489(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80213,axiom,
    ! [VarCurr: state_type] :
      ( v143481(VarCurr)
    <=> v143483(VarCurr) ) ).

tff(addAssignment_80212,axiom,
    ! [VarCurr: state_type] :
      ( v143483(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80211,axiom,
    ! [VarCurr: state_type] :
      ( v143477(VarCurr)
    <=> v143479(VarCurr) ) ).

tff(addAssignment_80210,axiom,
    ! [VarCurr: state_type] :
      ( v143479(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143414(VarCurr,B)
      <=> v143416(VarCurr,B) ) ) ).

tff(addAssignment_80208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143416(VarCurr,B)
      <=> v143418(VarCurr,B) ) ) ).

tff(addAssignment_80207,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143418(VarNext,B)
      <=> v143452(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143453(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143452(VarNext,B)
            <=> v143418(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2033,axiom,
    ! [VarNext: state_type] :
      ( v143453(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143452(VarNext,B)
          <=> v143463(VarNext,B) ) ) ) ).

tff(addAssignment_80206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143463(VarNext,B)
          <=> v143461(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143464(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143461(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1566,axiom,
    ! [VarCurr: state_type] :
      ( v143464(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143461(VarCurr,B)
          <=> v143428(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19154,axiom,
    ! [VarCurr: state_type] :
      ( v143464(VarCurr)
    <=> ( v143465(VarCurr)
        & v143466(VarCurr) ) ) ).

tff(writeUnaryOperator_10936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143466(VarCurr)
    <=> v143424(VarCurr) ) ).

tff(writeUnaryOperator_10935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143465(VarCurr)
    <=> v143420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143453(VarNext)
      <=> v143454(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143454(VarNext)
      <=> ( v143455(VarNext)
          & v143448(VarNext) ) ) ) ).

tff(writeUnaryOperator_10934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143455(VarNext)
      <=> v143457(VarNext) ) ) ).

tff(addAssignment_80205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143457(VarNext)
      <=> v143448(VarCurr) ) ) ).

tff(addAssignment_80204,axiom,
    ! [VarCurr: state_type] :
      ( v143448(VarCurr)
    <=> v143450(VarCurr) ) ).

tff(addAssignment_80203,axiom,
    ! [VarCurr: state_type] :
      ( v143450(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143428(VarCurr,B)
      <=> v143430(VarCurr,B) ) ) ).

tff(addAssignment_80201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143430(VarCurr,B)
      <=> v143439(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143439(VarCurr,B)
      <=> ( v143440(VarCurr,B)
          | v143443(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143443(VarCurr,B)
      <=> ( v143416(VarCurr,B)
          & v143444(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143444(VarCurr,B)
      <=> ~ v143445(VarCurr,B) ) ) ).

tff(addAssignment_80200,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,0)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80199,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,1)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80198,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,2)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80197,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,3)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80196,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,4)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80195,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,5)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80194,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,6)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80193,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,7)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80192,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,8)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80191,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,9)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80190,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,10)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80189,axiom,
    ! [VarCurr: state_type] :
      ( v143445(VarCurr,11)
    <=> v143446(VarCurr) ) ).

tff(addAssignment_80188,axiom,
    ! [VarCurr: state_type] :
      ( v143446(VarCurr)
    <=> v143434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143440(VarCurr,B)
      <=> ( v143432(VarCurr,B)
          & v143441(VarCurr,B) ) ) ) ).

tff(addAssignment_80187,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,0)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80186,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,1)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80185,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,2)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80184,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,3)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80183,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,4)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80182,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,5)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80181,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,6)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80180,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,7)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80179,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,8)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80178,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,9)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80177,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,10)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80176,axiom,
    ! [VarCurr: state_type] :
      ( v143441(VarCurr,11)
    <=> v143442(VarCurr) ) ).

tff(addAssignment_80175,axiom,
    ! [VarCurr: state_type] :
      ( v143442(VarCurr)
    <=> v143434(VarCurr) ) ).

tff(addAssignment_80174,axiom,
    ! [VarCurr: state_type] :
      ( v143434(VarCurr)
    <=> v143436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19151,axiom,
    ! [VarCurr: state_type] :
      ( v143436(VarCurr)
    <=> ( v143438(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2147,axiom,
    ! [VarCurr: state_type] :
      ( v143438(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2090,axiom,
    b11100(4) ).

tff(bitBlastConstant_2089,axiom,
    b11100(3) ).

tff(bitBlastConstant_2088,axiom,
    b11100(2) ).

tff(bitBlastConstant_2087,axiom,
    ~ b11100(1) ).

tff(bitBlastConstant_2086,axiom,
    ~ b11100(0) ).

tff(addAssignment_80173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143432(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80172,axiom,
    ! [VarCurr: state_type] :
      ( v143424(VarCurr)
    <=> v143426(VarCurr) ) ).

tff(addAssignment_80171,axiom,
    ! [VarCurr: state_type] :
      ( v143426(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80170,axiom,
    ! [VarCurr: state_type] :
      ( v143420(VarCurr)
    <=> v143422(VarCurr) ) ).

tff(addAssignment_80169,axiom,
    ! [VarCurr: state_type] :
      ( v143422(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143357(VarCurr,B)
      <=> v143359(VarCurr,B) ) ) ).

tff(addAssignment_80167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143359(VarCurr,B)
      <=> v143361(VarCurr,B) ) ) ).

tff(addAssignment_80166,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143361(VarNext,B)
      <=> v143395(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143396(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143395(VarNext,B)
            <=> v143361(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2032,axiom,
    ! [VarNext: state_type] :
      ( v143396(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143395(VarNext,B)
          <=> v143406(VarNext,B) ) ) ) ).

tff(addAssignment_80165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143406(VarNext,B)
          <=> v143404(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143404(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1565,axiom,
    ! [VarCurr: state_type] :
      ( v143407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143404(VarCurr,B)
          <=> v143371(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19150,axiom,
    ! [VarCurr: state_type] :
      ( v143407(VarCurr)
    <=> ( v143408(VarCurr)
        & v143409(VarCurr) ) ) ).

tff(writeUnaryOperator_10932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143409(VarCurr)
    <=> v143367(VarCurr) ) ).

tff(writeUnaryOperator_10931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143408(VarCurr)
    <=> v143363(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143396(VarNext)
      <=> v143397(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143397(VarNext)
      <=> ( v143398(VarNext)
          & v143391(VarNext) ) ) ) ).

tff(writeUnaryOperator_10930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143398(VarNext)
      <=> v143400(VarNext) ) ) ).

tff(addAssignment_80164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143400(VarNext)
      <=> v143391(VarCurr) ) ) ).

tff(addAssignment_80163,axiom,
    ! [VarCurr: state_type] :
      ( v143391(VarCurr)
    <=> v143393(VarCurr) ) ).

tff(addAssignment_80162,axiom,
    ! [VarCurr: state_type] :
      ( v143393(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143371(VarCurr,B)
      <=> v143373(VarCurr,B) ) ) ).

tff(addAssignment_80160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143373(VarCurr,B)
      <=> v143382(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143382(VarCurr,B)
      <=> ( v143383(VarCurr,B)
          | v143386(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143386(VarCurr,B)
      <=> ( v143359(VarCurr,B)
          & v143387(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143387(VarCurr,B)
      <=> ~ v143388(VarCurr,B) ) ) ).

tff(addAssignment_80159,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,0)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80158,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,1)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80157,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,2)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80156,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,3)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80155,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,4)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80154,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,5)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80153,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,6)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80152,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,7)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80151,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,8)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80150,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,9)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80149,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,10)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80148,axiom,
    ! [VarCurr: state_type] :
      ( v143388(VarCurr,11)
    <=> v143389(VarCurr) ) ).

tff(addAssignment_80147,axiom,
    ! [VarCurr: state_type] :
      ( v143389(VarCurr)
    <=> v143377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143383(VarCurr,B)
      <=> ( v143375(VarCurr,B)
          & v143384(VarCurr,B) ) ) ) ).

tff(addAssignment_80146,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,0)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80145,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,1)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80144,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,2)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80143,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,3)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80142,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,4)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80141,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,5)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80140,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,6)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80139,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,7)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80138,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,8)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80137,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,9)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80136,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,10)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80135,axiom,
    ! [VarCurr: state_type] :
      ( v143384(VarCurr,11)
    <=> v143385(VarCurr) ) ).

tff(addAssignment_80134,axiom,
    ! [VarCurr: state_type] :
      ( v143385(VarCurr)
    <=> v143377(VarCurr) ) ).

tff(addAssignment_80133,axiom,
    ! [VarCurr: state_type] :
      ( v143377(VarCurr)
    <=> v143379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19147,axiom,
    ! [VarCurr: state_type] :
      ( v143379(VarCurr)
    <=> ( v143381(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2146,axiom,
    ! [VarCurr: state_type] :
      ( v143381(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2085,axiom,
    b11011(4) ).

tff(bitBlastConstant_2084,axiom,
    b11011(3) ).

tff(bitBlastConstant_2083,axiom,
    ~ b11011(2) ).

tff(bitBlastConstant_2082,axiom,
    b11011(1) ).

tff(bitBlastConstant_2081,axiom,
    b11011(0) ).

tff(addAssignment_80132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143375(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80131,axiom,
    ! [VarCurr: state_type] :
      ( v143367(VarCurr)
    <=> v143369(VarCurr) ) ).

tff(addAssignment_80130,axiom,
    ! [VarCurr: state_type] :
      ( v143369(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80129,axiom,
    ! [VarCurr: state_type] :
      ( v143363(VarCurr)
    <=> v143365(VarCurr) ) ).

tff(addAssignment_80128,axiom,
    ! [VarCurr: state_type] :
      ( v143365(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143300(VarCurr,B)
      <=> v143302(VarCurr,B) ) ) ).

tff(addAssignment_80126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143302(VarCurr,B)
      <=> v143304(VarCurr,B) ) ) ).

tff(addAssignment_80125,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143304(VarNext,B)
      <=> v143338(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2031,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143339(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143338(VarNext,B)
            <=> v143304(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2031,axiom,
    ! [VarNext: state_type] :
      ( v143339(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143338(VarNext,B)
          <=> v143349(VarNext,B) ) ) ) ).

tff(addAssignment_80124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143349(VarNext,B)
          <=> v143347(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143347(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1564,axiom,
    ! [VarCurr: state_type] :
      ( v143350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143347(VarCurr,B)
          <=> v143314(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19146,axiom,
    ! [VarCurr: state_type] :
      ( v143350(VarCurr)
    <=> ( v143351(VarCurr)
        & v143352(VarCurr) ) ) ).

tff(writeUnaryOperator_10928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143352(VarCurr)
    <=> v143310(VarCurr) ) ).

tff(writeUnaryOperator_10927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143351(VarCurr)
    <=> v143306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143339(VarNext)
      <=> v143340(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143340(VarNext)
      <=> ( v143341(VarNext)
          & v143334(VarNext) ) ) ) ).

tff(writeUnaryOperator_10926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143341(VarNext)
      <=> v143343(VarNext) ) ) ).

tff(addAssignment_80123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143343(VarNext)
      <=> v143334(VarCurr) ) ) ).

tff(addAssignment_80122,axiom,
    ! [VarCurr: state_type] :
      ( v143334(VarCurr)
    <=> v143336(VarCurr) ) ).

tff(addAssignment_80121,axiom,
    ! [VarCurr: state_type] :
      ( v143336(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143314(VarCurr,B)
      <=> v143316(VarCurr,B) ) ) ).

tff(addAssignment_80119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143316(VarCurr,B)
      <=> v143325(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143325(VarCurr,B)
      <=> ( v143326(VarCurr,B)
          | v143329(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143329(VarCurr,B)
      <=> ( v143302(VarCurr,B)
          & v143330(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143330(VarCurr,B)
      <=> ~ v143331(VarCurr,B) ) ) ).

tff(addAssignment_80118,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,0)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80117,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,1)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80116,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,2)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80115,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,3)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80114,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,4)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80113,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,5)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80112,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,6)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80111,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,7)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80110,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,8)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80109,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,9)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80108,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,10)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80107,axiom,
    ! [VarCurr: state_type] :
      ( v143331(VarCurr,11)
    <=> v143332(VarCurr) ) ).

tff(addAssignment_80106,axiom,
    ! [VarCurr: state_type] :
      ( v143332(VarCurr)
    <=> v143320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143326(VarCurr,B)
      <=> ( v143318(VarCurr,B)
          & v143327(VarCurr,B) ) ) ) ).

tff(addAssignment_80105,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,0)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80104,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,1)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80103,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,2)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80102,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,3)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80101,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,4)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80100,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,5)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80099,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,6)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80098,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,7)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80097,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,8)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80096,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,9)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80095,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,10)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80094,axiom,
    ! [VarCurr: state_type] :
      ( v143327(VarCurr,11)
    <=> v143328(VarCurr) ) ).

tff(addAssignment_80093,axiom,
    ! [VarCurr: state_type] :
      ( v143328(VarCurr)
    <=> v143320(VarCurr) ) ).

tff(addAssignment_80092,axiom,
    ! [VarCurr: state_type] :
      ( v143320(VarCurr)
    <=> v143322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19143,axiom,
    ! [VarCurr: state_type] :
      ( v143322(VarCurr)
    <=> ( v143324(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2145,axiom,
    ! [VarCurr: state_type] :
      ( v143324(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2080,axiom,
    b11010(4) ).

tff(bitBlastConstant_2079,axiom,
    b11010(3) ).

tff(bitBlastConstant_2078,axiom,
    ~ b11010(2) ).

tff(bitBlastConstant_2077,axiom,
    b11010(1) ).

tff(bitBlastConstant_2076,axiom,
    ~ b11010(0) ).

tff(addAssignment_80091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143318(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80090,axiom,
    ! [VarCurr: state_type] :
      ( v143310(VarCurr)
    <=> v143312(VarCurr) ) ).

tff(addAssignment_80089,axiom,
    ! [VarCurr: state_type] :
      ( v143312(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80088,axiom,
    ! [VarCurr: state_type] :
      ( v143306(VarCurr)
    <=> v143308(VarCurr) ) ).

tff(addAssignment_80087,axiom,
    ! [VarCurr: state_type] :
      ( v143308(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143243(VarCurr,B)
      <=> v143245(VarCurr,B) ) ) ).

tff(addAssignment_80085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143245(VarCurr,B)
      <=> v143247(VarCurr,B) ) ) ).

tff(addAssignment_80084,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143247(VarNext,B)
      <=> v143281(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143281(VarNext,B)
            <=> v143247(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2030,axiom,
    ! [VarNext: state_type] :
      ( v143282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143281(VarNext,B)
          <=> v143292(VarNext,B) ) ) ) ).

tff(addAssignment_80083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143292(VarNext,B)
          <=> v143290(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143290(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1563,axiom,
    ! [VarCurr: state_type] :
      ( v143293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143290(VarCurr,B)
          <=> v143257(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19142,axiom,
    ! [VarCurr: state_type] :
      ( v143293(VarCurr)
    <=> ( v143294(VarCurr)
        & v143295(VarCurr) ) ) ).

tff(writeUnaryOperator_10924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143295(VarCurr)
    <=> v143253(VarCurr) ) ).

tff(writeUnaryOperator_10923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143294(VarCurr)
    <=> v143249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143282(VarNext)
      <=> v143283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143283(VarNext)
      <=> ( v143284(VarNext)
          & v143277(VarNext) ) ) ) ).

tff(writeUnaryOperator_10922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143284(VarNext)
      <=> v143286(VarNext) ) ) ).

tff(addAssignment_80082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143286(VarNext)
      <=> v143277(VarCurr) ) ) ).

tff(addAssignment_80081,axiom,
    ! [VarCurr: state_type] :
      ( v143277(VarCurr)
    <=> v143279(VarCurr) ) ).

tff(addAssignment_80080,axiom,
    ! [VarCurr: state_type] :
      ( v143279(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143257(VarCurr,B)
      <=> v143259(VarCurr,B) ) ) ).

tff(addAssignment_80078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143259(VarCurr,B)
      <=> v143268(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143268(VarCurr,B)
      <=> ( v143269(VarCurr,B)
          | v143272(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143272(VarCurr,B)
      <=> ( v143245(VarCurr,B)
          & v143273(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143273(VarCurr,B)
      <=> ~ v143274(VarCurr,B) ) ) ).

tff(addAssignment_80077,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,0)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80076,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,1)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80075,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,2)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80074,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,3)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80073,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,4)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80072,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,5)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80071,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,6)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80070,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,7)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80069,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,8)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80068,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,9)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80067,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,10)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80066,axiom,
    ! [VarCurr: state_type] :
      ( v143274(VarCurr,11)
    <=> v143275(VarCurr) ) ).

tff(addAssignment_80065,axiom,
    ! [VarCurr: state_type] :
      ( v143275(VarCurr)
    <=> v143263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143269(VarCurr,B)
      <=> ( v143261(VarCurr,B)
          & v143270(VarCurr,B) ) ) ) ).

tff(addAssignment_80064,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,0)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80063,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,1)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80062,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,2)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80061,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,3)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80060,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,4)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80059,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,5)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80058,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,6)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80057,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,7)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80056,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,8)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80055,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,9)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80054,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,10)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80053,axiom,
    ! [VarCurr: state_type] :
      ( v143270(VarCurr,11)
    <=> v143271(VarCurr) ) ).

tff(addAssignment_80052,axiom,
    ! [VarCurr: state_type] :
      ( v143271(VarCurr)
    <=> v143263(VarCurr) ) ).

tff(addAssignment_80051,axiom,
    ! [VarCurr: state_type] :
      ( v143263(VarCurr)
    <=> v143265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19139,axiom,
    ! [VarCurr: state_type] :
      ( v143265(VarCurr)
    <=> ( v143267(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2144,axiom,
    ! [VarCurr: state_type] :
      ( v143267(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2075,axiom,
    b11001(4) ).

tff(bitBlastConstant_2074,axiom,
    b11001(3) ).

tff(bitBlastConstant_2073,axiom,
    ~ b11001(2) ).

tff(bitBlastConstant_2072,axiom,
    ~ b11001(1) ).

tff(bitBlastConstant_2071,axiom,
    b11001(0) ).

tff(addAssignment_80050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143261(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80049,axiom,
    ! [VarCurr: state_type] :
      ( v143253(VarCurr)
    <=> v143255(VarCurr) ) ).

tff(addAssignment_80048,axiom,
    ! [VarCurr: state_type] :
      ( v143255(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80047,axiom,
    ! [VarCurr: state_type] :
      ( v143249(VarCurr)
    <=> v143251(VarCurr) ) ).

tff(addAssignment_80046,axiom,
    ! [VarCurr: state_type] :
      ( v143251(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143186(VarCurr,B)
      <=> v143188(VarCurr,B) ) ) ).

tff(addAssignment_80044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143188(VarCurr,B)
      <=> v143190(VarCurr,B) ) ) ).

tff(addAssignment_80043,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143190(VarNext,B)
      <=> v143224(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143225(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143224(VarNext,B)
            <=> v143190(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2029,axiom,
    ! [VarNext: state_type] :
      ( v143225(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143224(VarNext,B)
          <=> v143235(VarNext,B) ) ) ) ).

tff(addAssignment_80042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143235(VarNext,B)
          <=> v143233(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143236(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143233(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1562,axiom,
    ! [VarCurr: state_type] :
      ( v143236(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143233(VarCurr,B)
          <=> v143200(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19138,axiom,
    ! [VarCurr: state_type] :
      ( v143236(VarCurr)
    <=> ( v143237(VarCurr)
        & v143238(VarCurr) ) ) ).

tff(writeUnaryOperator_10920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143238(VarCurr)
    <=> v143196(VarCurr) ) ).

tff(writeUnaryOperator_10919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143237(VarCurr)
    <=> v143192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143225(VarNext)
      <=> v143226(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143226(VarNext)
      <=> ( v143227(VarNext)
          & v143220(VarNext) ) ) ) ).

tff(writeUnaryOperator_10918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143227(VarNext)
      <=> v143229(VarNext) ) ) ).

tff(addAssignment_80041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143229(VarNext)
      <=> v143220(VarCurr) ) ) ).

tff(addAssignment_80040,axiom,
    ! [VarCurr: state_type] :
      ( v143220(VarCurr)
    <=> v143222(VarCurr) ) ).

tff(addAssignment_80039,axiom,
    ! [VarCurr: state_type] :
      ( v143222(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_80038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143200(VarCurr,B)
      <=> v143202(VarCurr,B) ) ) ).

tff(addAssignment_80037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143202(VarCurr,B)
      <=> v143211(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143211(VarCurr,B)
      <=> ( v143212(VarCurr,B)
          | v143215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143215(VarCurr,B)
      <=> ( v143188(VarCurr,B)
          & v143216(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143216(VarCurr,B)
      <=> ~ v143217(VarCurr,B) ) ) ).

tff(addAssignment_80036,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,0)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80035,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,1)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80034,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,2)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80033,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,3)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80032,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,4)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80031,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,5)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80030,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,6)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80029,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,7)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80028,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,8)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80027,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,9)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80026,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,10)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80025,axiom,
    ! [VarCurr: state_type] :
      ( v143217(VarCurr,11)
    <=> v143218(VarCurr) ) ).

tff(addAssignment_80024,axiom,
    ! [VarCurr: state_type] :
      ( v143218(VarCurr)
    <=> v143206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143212(VarCurr,B)
      <=> ( v143204(VarCurr,B)
          & v143213(VarCurr,B) ) ) ) ).

tff(addAssignment_80023,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,0)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80022,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,1)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80021,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,2)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80020,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,3)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80019,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,4)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80018,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,5)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80017,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,6)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80016,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,7)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80015,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,8)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80014,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,9)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80013,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,10)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80012,axiom,
    ! [VarCurr: state_type] :
      ( v143213(VarCurr,11)
    <=> v143214(VarCurr) ) ).

tff(addAssignment_80011,axiom,
    ! [VarCurr: state_type] :
      ( v143214(VarCurr)
    <=> v143206(VarCurr) ) ).

tff(addAssignment_80010,axiom,
    ! [VarCurr: state_type] :
      ( v143206(VarCurr)
    <=> v143208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19135,axiom,
    ! [VarCurr: state_type] :
      ( v143208(VarCurr)
    <=> ( v143210(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2143,axiom,
    ! [VarCurr: state_type] :
      ( v143210(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2070,axiom,
    b11000(4) ).

tff(bitBlastConstant_2069,axiom,
    b11000(3) ).

tff(bitBlastConstant_2068,axiom,
    ~ b11000(2) ).

tff(bitBlastConstant_2067,axiom,
    ~ b11000(1) ).

tff(bitBlastConstant_2066,axiom,
    ~ b11000(0) ).

tff(addAssignment_80009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143204(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_80008,axiom,
    ! [VarCurr: state_type] :
      ( v143196(VarCurr)
    <=> v143198(VarCurr) ) ).

tff(addAssignment_80007,axiom,
    ! [VarCurr: state_type] :
      ( v143198(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_80006,axiom,
    ! [VarCurr: state_type] :
      ( v143192(VarCurr)
    <=> v143194(VarCurr) ) ).

tff(addAssignment_80005,axiom,
    ! [VarCurr: state_type] :
      ( v143194(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_80004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143129(VarCurr,B)
      <=> v143131(VarCurr,B) ) ) ).

tff(addAssignment_80003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143131(VarCurr,B)
      <=> v143133(VarCurr,B) ) ) ).

tff(addAssignment_80002,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143133(VarNext,B)
      <=> v143167(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143168(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143167(VarNext,B)
            <=> v143133(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2028,axiom,
    ! [VarNext: state_type] :
      ( v143168(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143167(VarNext,B)
          <=> v143178(VarNext,B) ) ) ) ).

tff(addAssignment_80001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143178(VarNext,B)
          <=> v143176(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143179(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143176(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1561,axiom,
    ! [VarCurr: state_type] :
      ( v143179(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143176(VarCurr,B)
          <=> v143143(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19134,axiom,
    ! [VarCurr: state_type] :
      ( v143179(VarCurr)
    <=> ( v143180(VarCurr)
        & v143181(VarCurr) ) ) ).

tff(writeUnaryOperator_10916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143181(VarCurr)
    <=> v143139(VarCurr) ) ).

tff(writeUnaryOperator_10915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143180(VarCurr)
    <=> v143135(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143168(VarNext)
      <=> v143169(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143169(VarNext)
      <=> ( v143170(VarNext)
          & v143163(VarNext) ) ) ) ).

tff(writeUnaryOperator_10914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143170(VarNext)
      <=> v143172(VarNext) ) ) ).

tff(addAssignment_80000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143172(VarNext)
      <=> v143163(VarCurr) ) ) ).

tff(addAssignment_79999,axiom,
    ! [VarCurr: state_type] :
      ( v143163(VarCurr)
    <=> v143165(VarCurr) ) ).

tff(addAssignment_79998,axiom,
    ! [VarCurr: state_type] :
      ( v143165(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143143(VarCurr,B)
      <=> v143145(VarCurr,B) ) ) ).

tff(addAssignment_79996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143145(VarCurr,B)
      <=> v143154(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143154(VarCurr,B)
      <=> ( v143155(VarCurr,B)
          | v143158(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143158(VarCurr,B)
      <=> ( v143131(VarCurr,B)
          & v143159(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143159(VarCurr,B)
      <=> ~ v143160(VarCurr,B) ) ) ).

tff(addAssignment_79995,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,0)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79994,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,1)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79993,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,2)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79992,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,3)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79991,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,4)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79990,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,5)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79989,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,6)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79988,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,7)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79987,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,8)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79986,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,9)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79985,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,10)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79984,axiom,
    ! [VarCurr: state_type] :
      ( v143160(VarCurr,11)
    <=> v143161(VarCurr) ) ).

tff(addAssignment_79983,axiom,
    ! [VarCurr: state_type] :
      ( v143161(VarCurr)
    <=> v143149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143155(VarCurr,B)
      <=> ( v143147(VarCurr,B)
          & v143156(VarCurr,B) ) ) ) ).

tff(addAssignment_79982,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,0)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79981,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,1)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79980,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,2)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79979,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,3)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79978,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,4)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79977,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,5)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79976,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,6)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79975,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,7)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79974,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,8)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79973,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,9)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79972,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,10)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79971,axiom,
    ! [VarCurr: state_type] :
      ( v143156(VarCurr,11)
    <=> v143157(VarCurr) ) ).

tff(addAssignment_79970,axiom,
    ! [VarCurr: state_type] :
      ( v143157(VarCurr)
    <=> v143149(VarCurr) ) ).

tff(addAssignment_79969,axiom,
    ! [VarCurr: state_type] :
      ( v143149(VarCurr)
    <=> v143151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19131,axiom,
    ! [VarCurr: state_type] :
      ( v143151(VarCurr)
    <=> ( v143153(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2142,axiom,
    ! [VarCurr: state_type] :
      ( v143153(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2065,axiom,
    b10111(4) ).

tff(bitBlastConstant_2064,axiom,
    ~ b10111(3) ).

tff(bitBlastConstant_2063,axiom,
    b10111(2) ).

tff(bitBlastConstant_2062,axiom,
    b10111(1) ).

tff(bitBlastConstant_2061,axiom,
    b10111(0) ).

tff(addAssignment_79968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143147(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79967,axiom,
    ! [VarCurr: state_type] :
      ( v143139(VarCurr)
    <=> v143141(VarCurr) ) ).

tff(addAssignment_79966,axiom,
    ! [VarCurr: state_type] :
      ( v143141(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79965,axiom,
    ! [VarCurr: state_type] :
      ( v143135(VarCurr)
    <=> v143137(VarCurr) ) ).

tff(addAssignment_79964,axiom,
    ! [VarCurr: state_type] :
      ( v143137(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143072(VarCurr,B)
      <=> v143074(VarCurr,B) ) ) ).

tff(addAssignment_79962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143074(VarCurr,B)
      <=> v143076(VarCurr,B) ) ) ).

tff(addAssignment_79961,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143076(VarNext,B)
      <=> v143110(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143111(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143110(VarNext,B)
            <=> v143076(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2027,axiom,
    ! [VarNext: state_type] :
      ( v143111(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143110(VarNext,B)
          <=> v143121(VarNext,B) ) ) ) ).

tff(addAssignment_79960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143121(VarNext,B)
          <=> v143119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143119(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1560,axiom,
    ! [VarCurr: state_type] :
      ( v143122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143119(VarCurr,B)
          <=> v143086(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19130,axiom,
    ! [VarCurr: state_type] :
      ( v143122(VarCurr)
    <=> ( v143123(VarCurr)
        & v143124(VarCurr) ) ) ).

tff(writeUnaryOperator_10912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143124(VarCurr)
    <=> v143082(VarCurr) ) ).

tff(writeUnaryOperator_10911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143123(VarCurr)
    <=> v143078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143111(VarNext)
      <=> v143112(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143112(VarNext)
      <=> ( v143113(VarNext)
          & v143106(VarNext) ) ) ) ).

tff(writeUnaryOperator_10910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143113(VarNext)
      <=> v143115(VarNext) ) ) ).

tff(addAssignment_79959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143115(VarNext)
      <=> v143106(VarCurr) ) ) ).

tff(addAssignment_79958,axiom,
    ! [VarCurr: state_type] :
      ( v143106(VarCurr)
    <=> v143108(VarCurr) ) ).

tff(addAssignment_79957,axiom,
    ! [VarCurr: state_type] :
      ( v143108(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143086(VarCurr,B)
      <=> v143088(VarCurr,B) ) ) ).

tff(addAssignment_79955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143088(VarCurr,B)
      <=> v143097(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143097(VarCurr,B)
      <=> ( v143098(VarCurr,B)
          | v143101(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143101(VarCurr,B)
      <=> ( v143074(VarCurr,B)
          & v143102(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143102(VarCurr,B)
      <=> ~ v143103(VarCurr,B) ) ) ).

tff(addAssignment_79954,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,0)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79953,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,1)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79952,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,2)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79951,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,3)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79950,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,4)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79949,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,5)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79948,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,6)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79947,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,7)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79946,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,8)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79945,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,9)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79944,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,10)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79943,axiom,
    ! [VarCurr: state_type] :
      ( v143103(VarCurr,11)
    <=> v143104(VarCurr) ) ).

tff(addAssignment_79942,axiom,
    ! [VarCurr: state_type] :
      ( v143104(VarCurr)
    <=> v143092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143098(VarCurr,B)
      <=> ( v143090(VarCurr,B)
          & v143099(VarCurr,B) ) ) ) ).

tff(addAssignment_79941,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,0)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79940,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,1)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79939,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,2)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79938,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,3)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79937,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,4)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79936,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,5)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79935,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,6)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79934,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,7)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79933,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,8)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79932,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,9)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79931,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,10)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79930,axiom,
    ! [VarCurr: state_type] :
      ( v143099(VarCurr,11)
    <=> v143100(VarCurr) ) ).

tff(addAssignment_79929,axiom,
    ! [VarCurr: state_type] :
      ( v143100(VarCurr)
    <=> v143092(VarCurr) ) ).

tff(addAssignment_79928,axiom,
    ! [VarCurr: state_type] :
      ( v143092(VarCurr)
    <=> v143094(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19127,axiom,
    ! [VarCurr: state_type] :
      ( v143094(VarCurr)
    <=> ( v143096(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2141,axiom,
    ! [VarCurr: state_type] :
      ( v143096(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2060,axiom,
    b10110(4) ).

tff(bitBlastConstant_2059,axiom,
    ~ b10110(3) ).

tff(bitBlastConstant_2058,axiom,
    b10110(2) ).

tff(bitBlastConstant_2057,axiom,
    b10110(1) ).

tff(bitBlastConstant_2056,axiom,
    ~ b10110(0) ).

tff(addAssignment_79927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143090(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79926,axiom,
    ! [VarCurr: state_type] :
      ( v143082(VarCurr)
    <=> v143084(VarCurr) ) ).

tff(addAssignment_79925,axiom,
    ! [VarCurr: state_type] :
      ( v143084(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79924,axiom,
    ! [VarCurr: state_type] :
      ( v143078(VarCurr)
    <=> v143080(VarCurr) ) ).

tff(addAssignment_79923,axiom,
    ! [VarCurr: state_type] :
      ( v143080(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143015(VarCurr,B)
      <=> v143017(VarCurr,B) ) ) ).

tff(addAssignment_79921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143017(VarCurr,B)
      <=> v143019(VarCurr,B) ) ) ).

tff(addAssignment_79920,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143019(VarNext,B)
      <=> v143053(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143054(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v143053(VarNext,B)
            <=> v143019(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2026,axiom,
    ! [VarNext: state_type] :
      ( v143054(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143053(VarNext,B)
          <=> v143064(VarNext,B) ) ) ) ).

tff(addAssignment_79919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143064(VarNext,B)
          <=> v143062(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143065(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143062(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1559,axiom,
    ! [VarCurr: state_type] :
      ( v143065(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143062(VarCurr,B)
          <=> v143029(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19126,axiom,
    ! [VarCurr: state_type] :
      ( v143065(VarCurr)
    <=> ( v143066(VarCurr)
        & v143067(VarCurr) ) ) ).

tff(writeUnaryOperator_10908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143067(VarCurr)
    <=> v143025(VarCurr) ) ).

tff(writeUnaryOperator_10907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143066(VarCurr)
    <=> v143021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143054(VarNext)
      <=> v143055(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143055(VarNext)
      <=> ( v143056(VarNext)
          & v143049(VarNext) ) ) ) ).

tff(writeUnaryOperator_10906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v143056(VarNext)
      <=> v143058(VarNext) ) ) ).

tff(addAssignment_79918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143058(VarNext)
      <=> v143049(VarCurr) ) ) ).

tff(addAssignment_79917,axiom,
    ! [VarCurr: state_type] :
      ( v143049(VarCurr)
    <=> v143051(VarCurr) ) ).

tff(addAssignment_79916,axiom,
    ! [VarCurr: state_type] :
      ( v143051(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143029(VarCurr,B)
      <=> v143031(VarCurr,B) ) ) ).

tff(addAssignment_79914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143031(VarCurr,B)
      <=> v143040(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143040(VarCurr,B)
      <=> ( v143041(VarCurr,B)
          | v143044(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143044(VarCurr,B)
      <=> ( v143017(VarCurr,B)
          & v143045(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143045(VarCurr,B)
      <=> ~ v143046(VarCurr,B) ) ) ).

tff(addAssignment_79913,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,0)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79912,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,1)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79911,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,2)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79910,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,3)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79909,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,4)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79908,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,5)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79907,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,6)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79906,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,7)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79905,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,8)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79904,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,9)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79903,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,10)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79902,axiom,
    ! [VarCurr: state_type] :
      ( v143046(VarCurr,11)
    <=> v143047(VarCurr) ) ).

tff(addAssignment_79901,axiom,
    ! [VarCurr: state_type] :
      ( v143047(VarCurr)
    <=> v143035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v143041(VarCurr,B)
      <=> ( v143033(VarCurr,B)
          & v143042(VarCurr,B) ) ) ) ).

tff(addAssignment_79900,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,0)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79899,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,1)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79898,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,2)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79897,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,3)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79896,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,4)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79895,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,5)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79894,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,6)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79893,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,7)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79892,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,8)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79891,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,9)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79890,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,10)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79889,axiom,
    ! [VarCurr: state_type] :
      ( v143042(VarCurr,11)
    <=> v143043(VarCurr) ) ).

tff(addAssignment_79888,axiom,
    ! [VarCurr: state_type] :
      ( v143043(VarCurr)
    <=> v143035(VarCurr) ) ).

tff(addAssignment_79887,axiom,
    ! [VarCurr: state_type] :
      ( v143035(VarCurr)
    <=> v143037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19123,axiom,
    ! [VarCurr: state_type] :
      ( v143037(VarCurr)
    <=> ( v143039(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2140,axiom,
    ! [VarCurr: state_type] :
      ( v143039(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2055,axiom,
    b10101(4) ).

tff(bitBlastConstant_2054,axiom,
    ~ b10101(3) ).

tff(bitBlastConstant_2053,axiom,
    b10101(2) ).

tff(bitBlastConstant_2052,axiom,
    ~ b10101(1) ).

tff(bitBlastConstant_2051,axiom,
    b10101(0) ).

tff(addAssignment_79886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v143033(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79885,axiom,
    ! [VarCurr: state_type] :
      ( v143025(VarCurr)
    <=> v143027(VarCurr) ) ).

tff(addAssignment_79884,axiom,
    ! [VarCurr: state_type] :
      ( v143027(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79883,axiom,
    ! [VarCurr: state_type] :
      ( v143021(VarCurr)
    <=> v143023(VarCurr) ) ).

tff(addAssignment_79882,axiom,
    ! [VarCurr: state_type] :
      ( v143023(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142958(VarCurr,B)
      <=> v142960(VarCurr,B) ) ) ).

tff(addAssignment_79880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142960(VarCurr,B)
      <=> v142962(VarCurr,B) ) ) ).

tff(addAssignment_79879,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142962(VarNext,B)
      <=> v142996(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142997(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142996(VarNext,B)
            <=> v142962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2025,axiom,
    ! [VarNext: state_type] :
      ( v142997(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142996(VarNext,B)
          <=> v143007(VarNext,B) ) ) ) ).

tff(addAssignment_79878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143007(VarNext,B)
          <=> v143005(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143005(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1558,axiom,
    ! [VarCurr: state_type] :
      ( v143008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v143005(VarCurr,B)
          <=> v142972(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19122,axiom,
    ! [VarCurr: state_type] :
      ( v143008(VarCurr)
    <=> ( v143009(VarCurr)
        & v143010(VarCurr) ) ) ).

tff(writeUnaryOperator_10904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143010(VarCurr)
    <=> v142968(VarCurr) ) ).

tff(writeUnaryOperator_10903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v143009(VarCurr)
    <=> v142964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142997(VarNext)
      <=> v142998(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142998(VarNext)
      <=> ( v142999(VarNext)
          & v142992(VarNext) ) ) ) ).

tff(writeUnaryOperator_10902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142999(VarNext)
      <=> v143001(VarNext) ) ) ).

tff(addAssignment_79877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v143001(VarNext)
      <=> v142992(VarCurr) ) ) ).

tff(addAssignment_79876,axiom,
    ! [VarCurr: state_type] :
      ( v142992(VarCurr)
    <=> v142994(VarCurr) ) ).

tff(addAssignment_79875,axiom,
    ! [VarCurr: state_type] :
      ( v142994(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142972(VarCurr,B)
      <=> v142974(VarCurr,B) ) ) ).

tff(addAssignment_79873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142974(VarCurr,B)
      <=> v142983(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142983(VarCurr,B)
      <=> ( v142984(VarCurr,B)
          | v142987(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142987(VarCurr,B)
      <=> ( v142960(VarCurr,B)
          & v142988(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142988(VarCurr,B)
      <=> ~ v142989(VarCurr,B) ) ) ).

tff(addAssignment_79872,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,0)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79871,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,1)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79870,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,2)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79869,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,3)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79868,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,4)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79867,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,5)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79866,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,6)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79865,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,7)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79864,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,8)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79863,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,9)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79862,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,10)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79861,axiom,
    ! [VarCurr: state_type] :
      ( v142989(VarCurr,11)
    <=> v142990(VarCurr) ) ).

tff(addAssignment_79860,axiom,
    ! [VarCurr: state_type] :
      ( v142990(VarCurr)
    <=> v142978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142984(VarCurr,B)
      <=> ( v142976(VarCurr,B)
          & v142985(VarCurr,B) ) ) ) ).

tff(addAssignment_79859,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,0)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79858,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,1)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79857,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,2)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79856,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,3)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79855,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,4)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79854,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,5)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79853,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,6)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79852,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,7)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79851,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,8)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79850,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,9)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79849,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,10)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79848,axiom,
    ! [VarCurr: state_type] :
      ( v142985(VarCurr,11)
    <=> v142986(VarCurr) ) ).

tff(addAssignment_79847,axiom,
    ! [VarCurr: state_type] :
      ( v142986(VarCurr)
    <=> v142978(VarCurr) ) ).

tff(addAssignment_79846,axiom,
    ! [VarCurr: state_type] :
      ( v142978(VarCurr)
    <=> v142980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19119,axiom,
    ! [VarCurr: state_type] :
      ( v142980(VarCurr)
    <=> ( v142982(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2139,axiom,
    ! [VarCurr: state_type] :
      ( v142982(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2050,axiom,
    b10100(4) ).

tff(bitBlastConstant_2049,axiom,
    ~ b10100(3) ).

tff(bitBlastConstant_2048,axiom,
    b10100(2) ).

tff(bitBlastConstant_2047,axiom,
    ~ b10100(1) ).

tff(bitBlastConstant_2046,axiom,
    ~ b10100(0) ).

tff(addAssignment_79845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142976(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79844,axiom,
    ! [VarCurr: state_type] :
      ( v142968(VarCurr)
    <=> v142970(VarCurr) ) ).

tff(addAssignment_79843,axiom,
    ! [VarCurr: state_type] :
      ( v142970(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79842,axiom,
    ! [VarCurr: state_type] :
      ( v142964(VarCurr)
    <=> v142966(VarCurr) ) ).

tff(addAssignment_79841,axiom,
    ! [VarCurr: state_type] :
      ( v142966(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142901(VarCurr,B)
      <=> v142903(VarCurr,B) ) ) ).

tff(addAssignment_79839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142903(VarCurr,B)
      <=> v142905(VarCurr,B) ) ) ).

tff(addAssignment_79838,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142905(VarNext,B)
      <=> v142939(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142940(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142939(VarNext,B)
            <=> v142905(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2024,axiom,
    ! [VarNext: state_type] :
      ( v142940(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142939(VarNext,B)
          <=> v142950(VarNext,B) ) ) ) ).

tff(addAssignment_79837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142950(VarNext,B)
          <=> v142948(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142948(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1557,axiom,
    ! [VarCurr: state_type] :
      ( v142951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142948(VarCurr,B)
          <=> v142915(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19118,axiom,
    ! [VarCurr: state_type] :
      ( v142951(VarCurr)
    <=> ( v142952(VarCurr)
        & v142953(VarCurr) ) ) ).

tff(writeUnaryOperator_10900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142953(VarCurr)
    <=> v142911(VarCurr) ) ).

tff(writeUnaryOperator_10899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142952(VarCurr)
    <=> v142907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142940(VarNext)
      <=> v142941(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142941(VarNext)
      <=> ( v142942(VarNext)
          & v142935(VarNext) ) ) ) ).

tff(writeUnaryOperator_10898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142942(VarNext)
      <=> v142944(VarNext) ) ) ).

tff(addAssignment_79836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142944(VarNext)
      <=> v142935(VarCurr) ) ) ).

tff(addAssignment_79835,axiom,
    ! [VarCurr: state_type] :
      ( v142935(VarCurr)
    <=> v142937(VarCurr) ) ).

tff(addAssignment_79834,axiom,
    ! [VarCurr: state_type] :
      ( v142937(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142915(VarCurr,B)
      <=> v142917(VarCurr,B) ) ) ).

tff(addAssignment_79832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142917(VarCurr,B)
      <=> v142926(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142926(VarCurr,B)
      <=> ( v142927(VarCurr,B)
          | v142930(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142930(VarCurr,B)
      <=> ( v142903(VarCurr,B)
          & v142931(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142931(VarCurr,B)
      <=> ~ v142932(VarCurr,B) ) ) ).

tff(addAssignment_79831,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,0)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79830,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,1)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79829,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,2)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79828,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,3)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79827,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,4)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79826,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,5)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79825,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,6)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79824,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,7)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79823,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,8)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79822,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,9)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79821,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,10)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79820,axiom,
    ! [VarCurr: state_type] :
      ( v142932(VarCurr,11)
    <=> v142933(VarCurr) ) ).

tff(addAssignment_79819,axiom,
    ! [VarCurr: state_type] :
      ( v142933(VarCurr)
    <=> v142921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142927(VarCurr,B)
      <=> ( v142919(VarCurr,B)
          & v142928(VarCurr,B) ) ) ) ).

tff(addAssignment_79818,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,0)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79817,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,1)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79816,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,2)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79815,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,3)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79814,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,4)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79813,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,5)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79812,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,6)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79811,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,7)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79810,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,8)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79809,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,9)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79808,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,10)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79807,axiom,
    ! [VarCurr: state_type] :
      ( v142928(VarCurr,11)
    <=> v142929(VarCurr) ) ).

tff(addAssignment_79806,axiom,
    ! [VarCurr: state_type] :
      ( v142929(VarCurr)
    <=> v142921(VarCurr) ) ).

tff(addAssignment_79805,axiom,
    ! [VarCurr: state_type] :
      ( v142921(VarCurr)
    <=> v142923(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19115,axiom,
    ! [VarCurr: state_type] :
      ( v142923(VarCurr)
    <=> ( v142925(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2138,axiom,
    ! [VarCurr: state_type] :
      ( v142925(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2045,axiom,
    b10011(4) ).

tff(bitBlastConstant_2044,axiom,
    ~ b10011(3) ).

tff(bitBlastConstant_2043,axiom,
    ~ b10011(2) ).

tff(bitBlastConstant_2042,axiom,
    b10011(1) ).

tff(bitBlastConstant_2041,axiom,
    b10011(0) ).

tff(addAssignment_79804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142919(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79803,axiom,
    ! [VarCurr: state_type] :
      ( v142911(VarCurr)
    <=> v142913(VarCurr) ) ).

tff(addAssignment_79802,axiom,
    ! [VarCurr: state_type] :
      ( v142913(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79801,axiom,
    ! [VarCurr: state_type] :
      ( v142907(VarCurr)
    <=> v142909(VarCurr) ) ).

tff(addAssignment_79800,axiom,
    ! [VarCurr: state_type] :
      ( v142909(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142844(VarCurr,B)
      <=> v142846(VarCurr,B) ) ) ).

tff(addAssignment_79798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142846(VarCurr,B)
      <=> v142848(VarCurr,B) ) ) ).

tff(addAssignment_79797,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142848(VarNext,B)
      <=> v142882(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142883(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142882(VarNext,B)
            <=> v142848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2023,axiom,
    ! [VarNext: state_type] :
      ( v142883(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142882(VarNext,B)
          <=> v142893(VarNext,B) ) ) ) ).

tff(addAssignment_79796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142893(VarNext,B)
          <=> v142891(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142894(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142891(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1556,axiom,
    ! [VarCurr: state_type] :
      ( v142894(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142891(VarCurr,B)
          <=> v142858(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19114,axiom,
    ! [VarCurr: state_type] :
      ( v142894(VarCurr)
    <=> ( v142895(VarCurr)
        & v142896(VarCurr) ) ) ).

tff(writeUnaryOperator_10896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142896(VarCurr)
    <=> v142854(VarCurr) ) ).

tff(writeUnaryOperator_10895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142895(VarCurr)
    <=> v142850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142883(VarNext)
      <=> v142884(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142884(VarNext)
      <=> ( v142885(VarNext)
          & v142878(VarNext) ) ) ) ).

tff(writeUnaryOperator_10894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142885(VarNext)
      <=> v142887(VarNext) ) ) ).

tff(addAssignment_79795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142887(VarNext)
      <=> v142878(VarCurr) ) ) ).

tff(addAssignment_79794,axiom,
    ! [VarCurr: state_type] :
      ( v142878(VarCurr)
    <=> v142880(VarCurr) ) ).

tff(addAssignment_79793,axiom,
    ! [VarCurr: state_type] :
      ( v142880(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142858(VarCurr,B)
      <=> v142860(VarCurr,B) ) ) ).

tff(addAssignment_79791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142860(VarCurr,B)
      <=> v142869(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142869(VarCurr,B)
      <=> ( v142870(VarCurr,B)
          | v142873(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142873(VarCurr,B)
      <=> ( v142846(VarCurr,B)
          & v142874(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142874(VarCurr,B)
      <=> ~ v142875(VarCurr,B) ) ) ).

tff(addAssignment_79790,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,0)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79789,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,1)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79788,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,2)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79787,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,3)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79786,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,4)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79785,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,5)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79784,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,6)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79783,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,7)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79782,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,8)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79781,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,9)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79780,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,10)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79779,axiom,
    ! [VarCurr: state_type] :
      ( v142875(VarCurr,11)
    <=> v142876(VarCurr) ) ).

tff(addAssignment_79778,axiom,
    ! [VarCurr: state_type] :
      ( v142876(VarCurr)
    <=> v142864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142870(VarCurr,B)
      <=> ( v142862(VarCurr,B)
          & v142871(VarCurr,B) ) ) ) ).

tff(addAssignment_79777,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,0)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79776,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,1)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79775,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,2)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79774,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,3)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79773,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,4)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79772,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,5)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79771,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,6)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79770,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,7)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79769,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,8)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79768,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,9)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79767,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,10)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79766,axiom,
    ! [VarCurr: state_type] :
      ( v142871(VarCurr,11)
    <=> v142872(VarCurr) ) ).

tff(addAssignment_79765,axiom,
    ! [VarCurr: state_type] :
      ( v142872(VarCurr)
    <=> v142864(VarCurr) ) ).

tff(addAssignment_79764,axiom,
    ! [VarCurr: state_type] :
      ( v142864(VarCurr)
    <=> v142866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19111,axiom,
    ! [VarCurr: state_type] :
      ( v142866(VarCurr)
    <=> ( v142868(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2137,axiom,
    ! [VarCurr: state_type] :
      ( v142868(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2040,axiom,
    b10010(4) ).

tff(bitBlastConstant_2039,axiom,
    ~ b10010(3) ).

tff(bitBlastConstant_2038,axiom,
    ~ b10010(2) ).

tff(bitBlastConstant_2037,axiom,
    b10010(1) ).

tff(bitBlastConstant_2036,axiom,
    ~ b10010(0) ).

tff(addAssignment_79763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142862(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79762,axiom,
    ! [VarCurr: state_type] :
      ( v142854(VarCurr)
    <=> v142856(VarCurr) ) ).

tff(addAssignment_79761,axiom,
    ! [VarCurr: state_type] :
      ( v142856(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79760,axiom,
    ! [VarCurr: state_type] :
      ( v142850(VarCurr)
    <=> v142852(VarCurr) ) ).

tff(addAssignment_79759,axiom,
    ! [VarCurr: state_type] :
      ( v142852(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142787(VarCurr,B)
      <=> v142789(VarCurr,B) ) ) ).

tff(addAssignment_79757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142789(VarCurr,B)
      <=> v142791(VarCurr,B) ) ) ).

tff(addAssignment_79756,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142791(VarNext,B)
      <=> v142825(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142826(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142825(VarNext,B)
            <=> v142791(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2022,axiom,
    ! [VarNext: state_type] :
      ( v142826(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142825(VarNext,B)
          <=> v142836(VarNext,B) ) ) ) ).

tff(addAssignment_79755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142836(VarNext,B)
          <=> v142834(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142837(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142834(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1555,axiom,
    ! [VarCurr: state_type] :
      ( v142837(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142834(VarCurr,B)
          <=> v142801(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19110,axiom,
    ! [VarCurr: state_type] :
      ( v142837(VarCurr)
    <=> ( v142838(VarCurr)
        & v142839(VarCurr) ) ) ).

tff(writeUnaryOperator_10892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142839(VarCurr)
    <=> v142797(VarCurr) ) ).

tff(writeUnaryOperator_10891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142838(VarCurr)
    <=> v142793(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142826(VarNext)
      <=> v142827(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142827(VarNext)
      <=> ( v142828(VarNext)
          & v142821(VarNext) ) ) ) ).

tff(writeUnaryOperator_10890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142828(VarNext)
      <=> v142830(VarNext) ) ) ).

tff(addAssignment_79754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142830(VarNext)
      <=> v142821(VarCurr) ) ) ).

tff(addAssignment_79753,axiom,
    ! [VarCurr: state_type] :
      ( v142821(VarCurr)
    <=> v142823(VarCurr) ) ).

tff(addAssignment_79752,axiom,
    ! [VarCurr: state_type] :
      ( v142823(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142801(VarCurr,B)
      <=> v142803(VarCurr,B) ) ) ).

tff(addAssignment_79750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142803(VarCurr,B)
      <=> v142812(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142812(VarCurr,B)
      <=> ( v142813(VarCurr,B)
          | v142816(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142816(VarCurr,B)
      <=> ( v142789(VarCurr,B)
          & v142817(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142817(VarCurr,B)
      <=> ~ v142818(VarCurr,B) ) ) ).

tff(addAssignment_79749,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,0)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79748,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,1)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79747,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,2)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79746,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,3)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79745,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,4)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79744,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,5)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79743,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,6)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79742,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,7)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79741,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,8)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79740,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,9)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79739,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,10)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79738,axiom,
    ! [VarCurr: state_type] :
      ( v142818(VarCurr,11)
    <=> v142819(VarCurr) ) ).

tff(addAssignment_79737,axiom,
    ! [VarCurr: state_type] :
      ( v142819(VarCurr)
    <=> v142807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142813(VarCurr,B)
      <=> ( v142805(VarCurr,B)
          & v142814(VarCurr,B) ) ) ) ).

tff(addAssignment_79736,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,0)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79735,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,1)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79734,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,2)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79733,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,3)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79732,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,4)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79731,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,5)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79730,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,6)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79729,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,7)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79728,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,8)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79727,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,9)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79726,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,10)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79725,axiom,
    ! [VarCurr: state_type] :
      ( v142814(VarCurr,11)
    <=> v142815(VarCurr) ) ).

tff(addAssignment_79724,axiom,
    ! [VarCurr: state_type] :
      ( v142815(VarCurr)
    <=> v142807(VarCurr) ) ).

tff(addAssignment_79723,axiom,
    ! [VarCurr: state_type] :
      ( v142807(VarCurr)
    <=> v142809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19107,axiom,
    ! [VarCurr: state_type] :
      ( v142809(VarCurr)
    <=> ( v142811(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2136,axiom,
    ! [VarCurr: state_type] :
      ( v142811(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_2035,axiom,
    b10001(4) ).

tff(bitBlastConstant_2034,axiom,
    ~ b10001(3) ).

tff(bitBlastConstant_2033,axiom,
    ~ b10001(2) ).

tff(bitBlastConstant_2032,axiom,
    ~ b10001(1) ).

tff(bitBlastConstant_2031,axiom,
    b10001(0) ).

tff(addAssignment_79722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142805(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79721,axiom,
    ! [VarCurr: state_type] :
      ( v142797(VarCurr)
    <=> v142799(VarCurr) ) ).

tff(addAssignment_79720,axiom,
    ! [VarCurr: state_type] :
      ( v142799(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79719,axiom,
    ! [VarCurr: state_type] :
      ( v142793(VarCurr)
    <=> v142795(VarCurr) ) ).

tff(addAssignment_79718,axiom,
    ! [VarCurr: state_type] :
      ( v142795(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142730(VarCurr,B)
      <=> v142732(VarCurr,B) ) ) ).

tff(addAssignment_79716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142732(VarCurr,B)
      <=> v142734(VarCurr,B) ) ) ).

tff(addAssignment_79715,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142734(VarNext,B)
      <=> v142768(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142769(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142768(VarNext,B)
            <=> v142734(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2021,axiom,
    ! [VarNext: state_type] :
      ( v142769(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142768(VarNext,B)
          <=> v142779(VarNext,B) ) ) ) ).

tff(addAssignment_79714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142779(VarNext,B)
          <=> v142777(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142780(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142777(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1554,axiom,
    ! [VarCurr: state_type] :
      ( v142780(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142777(VarCurr,B)
          <=> v142744(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19106,axiom,
    ! [VarCurr: state_type] :
      ( v142780(VarCurr)
    <=> ( v142781(VarCurr)
        & v142782(VarCurr) ) ) ).

tff(writeUnaryOperator_10888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142782(VarCurr)
    <=> v142740(VarCurr) ) ).

tff(writeUnaryOperator_10887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142781(VarCurr)
    <=> v142736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142769(VarNext)
      <=> v142770(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142770(VarNext)
      <=> ( v142771(VarNext)
          & v142764(VarNext) ) ) ) ).

tff(writeUnaryOperator_10886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142771(VarNext)
      <=> v142773(VarNext) ) ) ).

tff(addAssignment_79713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142773(VarNext)
      <=> v142764(VarCurr) ) ) ).

tff(addAssignment_79712,axiom,
    ! [VarCurr: state_type] :
      ( v142764(VarCurr)
    <=> v142766(VarCurr) ) ).

tff(addAssignment_79711,axiom,
    ! [VarCurr: state_type] :
      ( v142766(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142744(VarCurr,B)
      <=> v142746(VarCurr,B) ) ) ).

tff(addAssignment_79709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142746(VarCurr,B)
      <=> v142755(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142755(VarCurr,B)
      <=> ( v142756(VarCurr,B)
          | v142759(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142759(VarCurr,B)
      <=> ( v142732(VarCurr,B)
          & v142760(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142760(VarCurr,B)
      <=> ~ v142761(VarCurr,B) ) ) ).

tff(addAssignment_79708,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,0)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79707,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,1)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79706,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,2)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79705,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,3)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79704,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,4)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79703,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,5)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79702,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,6)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79701,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,7)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79700,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,8)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79699,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,9)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79698,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,10)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79697,axiom,
    ! [VarCurr: state_type] :
      ( v142761(VarCurr,11)
    <=> v142762(VarCurr) ) ).

tff(addAssignment_79696,axiom,
    ! [VarCurr: state_type] :
      ( v142762(VarCurr)
    <=> v142750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142756(VarCurr,B)
      <=> ( v142748(VarCurr,B)
          & v142757(VarCurr,B) ) ) ) ).

tff(addAssignment_79695,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,0)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79694,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,1)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79693,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,2)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79692,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,3)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79691,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,4)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79690,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,5)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79689,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,6)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79688,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,7)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79687,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,8)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79686,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,9)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79685,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,10)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79684,axiom,
    ! [VarCurr: state_type] :
      ( v142757(VarCurr,11)
    <=> v142758(VarCurr) ) ).

tff(addAssignment_79683,axiom,
    ! [VarCurr: state_type] :
      ( v142758(VarCurr)
    <=> v142750(VarCurr) ) ).

tff(addAssignment_79682,axiom,
    ! [VarCurr: state_type] :
      ( v142750(VarCurr)
    <=> v142752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19103,axiom,
    ! [VarCurr: state_type] :
      ( v142752(VarCurr)
    <=> ( v142754(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2135,axiom,
    ! [VarCurr: state_type] :
      ( v142754(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $true )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142748(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79680,axiom,
    ! [VarCurr: state_type] :
      ( v142740(VarCurr)
    <=> v142742(VarCurr) ) ).

tff(addAssignment_79679,axiom,
    ! [VarCurr: state_type] :
      ( v142742(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79678,axiom,
    ! [VarCurr: state_type] :
      ( v142736(VarCurr)
    <=> v142738(VarCurr) ) ).

tff(addAssignment_79677,axiom,
    ! [VarCurr: state_type] :
      ( v142738(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142674(VarCurr,B)
      <=> v142676(VarCurr,B) ) ) ).

tff(addAssignment_79675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142676(VarCurr,B)
      <=> v142678(VarCurr,B) ) ) ).

tff(addAssignment_79674,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142678(VarNext,B)
      <=> v142712(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2020,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142713(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142712(VarNext,B)
            <=> v142678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2020,axiom,
    ! [VarNext: state_type] :
      ( v142713(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142712(VarNext,B)
          <=> v142723(VarNext,B) ) ) ) ).

tff(addAssignment_79673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142723(VarNext,B)
          <=> v142721(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142721(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1553,axiom,
    ! [VarCurr: state_type] :
      ( v142724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142721(VarCurr,B)
          <=> v142688(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19102,axiom,
    ! [VarCurr: state_type] :
      ( v142724(VarCurr)
    <=> ( v142725(VarCurr)
        & v142726(VarCurr) ) ) ).

tff(writeUnaryOperator_10884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142726(VarCurr)
    <=> v142684(VarCurr) ) ).

tff(writeUnaryOperator_10883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142725(VarCurr)
    <=> v142680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142713(VarNext)
      <=> v142714(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142714(VarNext)
      <=> ( v142715(VarNext)
          & v142708(VarNext) ) ) ) ).

tff(writeUnaryOperator_10882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142715(VarNext)
      <=> v142717(VarNext) ) ) ).

tff(addAssignment_79672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142717(VarNext)
      <=> v142708(VarCurr) ) ) ).

tff(addAssignment_79671,axiom,
    ! [VarCurr: state_type] :
      ( v142708(VarCurr)
    <=> v142710(VarCurr) ) ).

tff(addAssignment_79670,axiom,
    ! [VarCurr: state_type] :
      ( v142710(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142688(VarCurr,B)
      <=> v142690(VarCurr,B) ) ) ).

tff(addAssignment_79668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142690(VarCurr,B)
      <=> v142699(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142699(VarCurr,B)
      <=> ( v142700(VarCurr,B)
          | v142703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142703(VarCurr,B)
      <=> ( v142676(VarCurr,B)
          & v142704(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142704(VarCurr,B)
      <=> ~ v142705(VarCurr,B) ) ) ).

tff(addAssignment_79667,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,0)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79666,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,1)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79665,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,2)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79664,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,3)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79663,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,4)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79662,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,5)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79661,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,6)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79660,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,7)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79659,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,8)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79658,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,9)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79657,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,10)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79656,axiom,
    ! [VarCurr: state_type] :
      ( v142705(VarCurr,11)
    <=> v142706(VarCurr) ) ).

tff(addAssignment_79655,axiom,
    ! [VarCurr: state_type] :
      ( v142706(VarCurr)
    <=> v142694(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142700(VarCurr,B)
      <=> ( v142692(VarCurr,B)
          & v142701(VarCurr,B) ) ) ) ).

tff(addAssignment_79654,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,0)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79653,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,1)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79652,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,2)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79651,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,3)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79650,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,4)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79649,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,5)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79648,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,6)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79647,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,7)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79646,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,8)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79645,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,9)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79644,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,10)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79643,axiom,
    ! [VarCurr: state_type] :
      ( v142701(VarCurr,11)
    <=> v142702(VarCurr) ) ).

tff(addAssignment_79642,axiom,
    ! [VarCurr: state_type] :
      ( v142702(VarCurr)
    <=> v142694(VarCurr) ) ).

tff(addAssignment_79641,axiom,
    ! [VarCurr: state_type] :
      ( v142694(VarCurr)
    <=> v142696(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19099,axiom,
    ! [VarCurr: state_type] :
      ( v142696(VarCurr)
    <=> ( v142698(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2134,axiom,
    ! [VarCurr: state_type] :
      ( v142698(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142692(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79639,axiom,
    ! [VarCurr: state_type] :
      ( v142684(VarCurr)
    <=> v142686(VarCurr) ) ).

tff(addAssignment_79638,axiom,
    ! [VarCurr: state_type] :
      ( v142686(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79637,axiom,
    ! [VarCurr: state_type] :
      ( v142680(VarCurr)
    <=> v142682(VarCurr) ) ).

tff(addAssignment_79636,axiom,
    ! [VarCurr: state_type] :
      ( v142682(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142618(VarCurr,B)
      <=> v142620(VarCurr,B) ) ) ).

tff(addAssignment_79634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142620(VarCurr,B)
      <=> v142622(VarCurr,B) ) ) ).

tff(addAssignment_79633,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142622(VarNext,B)
      <=> v142656(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142657(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142656(VarNext,B)
            <=> v142622(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2019,axiom,
    ! [VarNext: state_type] :
      ( v142657(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142656(VarNext,B)
          <=> v142667(VarNext,B) ) ) ) ).

tff(addAssignment_79632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142667(VarNext,B)
          <=> v142665(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142665(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1552,axiom,
    ! [VarCurr: state_type] :
      ( v142668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142665(VarCurr,B)
          <=> v142632(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19098,axiom,
    ! [VarCurr: state_type] :
      ( v142668(VarCurr)
    <=> ( v142669(VarCurr)
        & v142670(VarCurr) ) ) ).

tff(writeUnaryOperator_10880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142670(VarCurr)
    <=> v142628(VarCurr) ) ).

tff(writeUnaryOperator_10879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142669(VarCurr)
    <=> v142624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142657(VarNext)
      <=> v142658(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142658(VarNext)
      <=> ( v142659(VarNext)
          & v142652(VarNext) ) ) ) ).

tff(writeUnaryOperator_10878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142659(VarNext)
      <=> v142661(VarNext) ) ) ).

tff(addAssignment_79631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142661(VarNext)
      <=> v142652(VarCurr) ) ) ).

tff(addAssignment_79630,axiom,
    ! [VarCurr: state_type] :
      ( v142652(VarCurr)
    <=> v142654(VarCurr) ) ).

tff(addAssignment_79629,axiom,
    ! [VarCurr: state_type] :
      ( v142654(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142632(VarCurr,B)
      <=> v142634(VarCurr,B) ) ) ).

tff(addAssignment_79627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142634(VarCurr,B)
      <=> v142643(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142643(VarCurr,B)
      <=> ( v142644(VarCurr,B)
          | v142647(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142647(VarCurr,B)
      <=> ( v142620(VarCurr,B)
          & v142648(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142648(VarCurr,B)
      <=> ~ v142649(VarCurr,B) ) ) ).

tff(addAssignment_79626,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,0)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79625,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,1)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79624,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,2)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79623,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,3)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79622,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,4)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79621,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,5)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79620,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,6)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79619,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,7)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79618,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,8)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79617,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,9)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79616,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,10)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79615,axiom,
    ! [VarCurr: state_type] :
      ( v142649(VarCurr,11)
    <=> v142650(VarCurr) ) ).

tff(addAssignment_79614,axiom,
    ! [VarCurr: state_type] :
      ( v142650(VarCurr)
    <=> v142638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142644(VarCurr,B)
      <=> ( v142636(VarCurr,B)
          & v142645(VarCurr,B) ) ) ) ).

tff(addAssignment_79613,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,0)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79612,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,1)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79611,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,2)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79610,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,3)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79609,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,4)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79608,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,5)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79607,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,6)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79606,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,7)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79605,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,8)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79604,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,9)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79603,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,10)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79602,axiom,
    ! [VarCurr: state_type] :
      ( v142645(VarCurr,11)
    <=> v142646(VarCurr) ) ).

tff(addAssignment_79601,axiom,
    ! [VarCurr: state_type] :
      ( v142646(VarCurr)
    <=> v142638(VarCurr) ) ).

tff(addAssignment_79600,axiom,
    ! [VarCurr: state_type] :
      ( v142638(VarCurr)
    <=> v142640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19095,axiom,
    ! [VarCurr: state_type] :
      ( v142640(VarCurr)
    <=> ( v142642(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2133,axiom,
    ! [VarCurr: state_type] :
      ( v142642(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142636(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79598,axiom,
    ! [VarCurr: state_type] :
      ( v142628(VarCurr)
    <=> v142630(VarCurr) ) ).

tff(addAssignment_79597,axiom,
    ! [VarCurr: state_type] :
      ( v142630(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79596,axiom,
    ! [VarCurr: state_type] :
      ( v142624(VarCurr)
    <=> v142626(VarCurr) ) ).

tff(addAssignment_79595,axiom,
    ! [VarCurr: state_type] :
      ( v142626(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142562(VarCurr,B)
      <=> v142564(VarCurr,B) ) ) ).

tff(addAssignment_79593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142564(VarCurr,B)
      <=> v142566(VarCurr,B) ) ) ).

tff(addAssignment_79592,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142566(VarNext,B)
      <=> v142600(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142601(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142600(VarNext,B)
            <=> v142566(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2018,axiom,
    ! [VarNext: state_type] :
      ( v142601(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142600(VarNext,B)
          <=> v142611(VarNext,B) ) ) ) ).

tff(addAssignment_79591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142611(VarNext,B)
          <=> v142609(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142612(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142609(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1551,axiom,
    ! [VarCurr: state_type] :
      ( v142612(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142609(VarCurr,B)
          <=> v142576(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19094,axiom,
    ! [VarCurr: state_type] :
      ( v142612(VarCurr)
    <=> ( v142613(VarCurr)
        & v142614(VarCurr) ) ) ).

tff(writeUnaryOperator_10876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142614(VarCurr)
    <=> v142572(VarCurr) ) ).

tff(writeUnaryOperator_10875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142613(VarCurr)
    <=> v142568(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142601(VarNext)
      <=> v142602(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142602(VarNext)
      <=> ( v142603(VarNext)
          & v142596(VarNext) ) ) ) ).

tff(writeUnaryOperator_10874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142603(VarNext)
      <=> v142605(VarNext) ) ) ).

tff(addAssignment_79590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142605(VarNext)
      <=> v142596(VarCurr) ) ) ).

tff(addAssignment_79589,axiom,
    ! [VarCurr: state_type] :
      ( v142596(VarCurr)
    <=> v142598(VarCurr) ) ).

tff(addAssignment_79588,axiom,
    ! [VarCurr: state_type] :
      ( v142598(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142576(VarCurr,B)
      <=> v142578(VarCurr,B) ) ) ).

tff(addAssignment_79586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142578(VarCurr,B)
      <=> v142587(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142587(VarCurr,B)
      <=> ( v142588(VarCurr,B)
          | v142591(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142591(VarCurr,B)
      <=> ( v142564(VarCurr,B)
          & v142592(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142592(VarCurr,B)
      <=> ~ v142593(VarCurr,B) ) ) ).

tff(addAssignment_79585,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,0)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79584,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,1)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79583,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,2)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79582,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,3)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79581,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,4)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79580,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,5)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79579,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,6)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79578,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,7)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79577,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,8)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79576,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,9)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79575,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,10)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79574,axiom,
    ! [VarCurr: state_type] :
      ( v142593(VarCurr,11)
    <=> v142594(VarCurr) ) ).

tff(addAssignment_79573,axiom,
    ! [VarCurr: state_type] :
      ( v142594(VarCurr)
    <=> v142582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142588(VarCurr,B)
      <=> ( v142580(VarCurr,B)
          & v142589(VarCurr,B) ) ) ) ).

tff(addAssignment_79572,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,0)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79571,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,1)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79570,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,2)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79569,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,3)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79568,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,4)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79567,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,5)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79566,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,6)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79565,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,7)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79564,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,8)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79563,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,9)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79562,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,10)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79561,axiom,
    ! [VarCurr: state_type] :
      ( v142589(VarCurr,11)
    <=> v142590(VarCurr) ) ).

tff(addAssignment_79560,axiom,
    ! [VarCurr: state_type] :
      ( v142590(VarCurr)
    <=> v142582(VarCurr) ) ).

tff(addAssignment_79559,axiom,
    ! [VarCurr: state_type] :
      ( v142582(VarCurr)
    <=> v142584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19091,axiom,
    ! [VarCurr: state_type] :
      ( v142584(VarCurr)
    <=> ( v142586(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2132,axiom,
    ! [VarCurr: state_type] :
      ( v142586(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142580(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79557,axiom,
    ! [VarCurr: state_type] :
      ( v142572(VarCurr)
    <=> v142574(VarCurr) ) ).

tff(addAssignment_79556,axiom,
    ! [VarCurr: state_type] :
      ( v142574(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79555,axiom,
    ! [VarCurr: state_type] :
      ( v142568(VarCurr)
    <=> v142570(VarCurr) ) ).

tff(addAssignment_79554,axiom,
    ! [VarCurr: state_type] :
      ( v142570(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142506(VarCurr,B)
      <=> v142508(VarCurr,B) ) ) ).

tff(addAssignment_79552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142508(VarCurr,B)
      <=> v142510(VarCurr,B) ) ) ).

tff(addAssignment_79551,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142510(VarNext,B)
      <=> v142544(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142544(VarNext,B)
            <=> v142510(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2017,axiom,
    ! [VarNext: state_type] :
      ( v142545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142544(VarNext,B)
          <=> v142555(VarNext,B) ) ) ) ).

tff(addAssignment_79550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142555(VarNext,B)
          <=> v142553(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142553(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1550,axiom,
    ! [VarCurr: state_type] :
      ( v142556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142553(VarCurr,B)
          <=> v142520(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19090,axiom,
    ! [VarCurr: state_type] :
      ( v142556(VarCurr)
    <=> ( v142557(VarCurr)
        & v142558(VarCurr) ) ) ).

tff(writeUnaryOperator_10872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142558(VarCurr)
    <=> v142516(VarCurr) ) ).

tff(writeUnaryOperator_10871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142557(VarCurr)
    <=> v142512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142545(VarNext)
      <=> v142546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142546(VarNext)
      <=> ( v142547(VarNext)
          & v142540(VarNext) ) ) ) ).

tff(writeUnaryOperator_10870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142547(VarNext)
      <=> v142549(VarNext) ) ) ).

tff(addAssignment_79549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142549(VarNext)
      <=> v142540(VarCurr) ) ) ).

tff(addAssignment_79548,axiom,
    ! [VarCurr: state_type] :
      ( v142540(VarCurr)
    <=> v142542(VarCurr) ) ).

tff(addAssignment_79547,axiom,
    ! [VarCurr: state_type] :
      ( v142542(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142520(VarCurr,B)
      <=> v142522(VarCurr,B) ) ) ).

tff(addAssignment_79545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142522(VarCurr,B)
      <=> v142531(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142531(VarCurr,B)
      <=> ( v142532(VarCurr,B)
          | v142535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142535(VarCurr,B)
      <=> ( v142508(VarCurr,B)
          & v142536(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142536(VarCurr,B)
      <=> ~ v142537(VarCurr,B) ) ) ).

tff(addAssignment_79544,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,0)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79543,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,1)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79542,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,2)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79541,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,3)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79540,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,4)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79539,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,5)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79538,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,6)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79537,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,7)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79536,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,8)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79535,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,9)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79534,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,10)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79533,axiom,
    ! [VarCurr: state_type] :
      ( v142537(VarCurr,11)
    <=> v142538(VarCurr) ) ).

tff(addAssignment_79532,axiom,
    ! [VarCurr: state_type] :
      ( v142538(VarCurr)
    <=> v142526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142532(VarCurr,B)
      <=> ( v142524(VarCurr,B)
          & v142533(VarCurr,B) ) ) ) ).

tff(addAssignment_79531,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,0)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79530,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,1)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79529,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,2)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79528,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,3)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79527,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,4)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79526,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,5)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79525,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,6)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79524,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,7)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79523,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,8)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79522,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,9)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79521,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,10)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79520,axiom,
    ! [VarCurr: state_type] :
      ( v142533(VarCurr,11)
    <=> v142534(VarCurr) ) ).

tff(addAssignment_79519,axiom,
    ! [VarCurr: state_type] :
      ( v142534(VarCurr)
    <=> v142526(VarCurr) ) ).

tff(addAssignment_79518,axiom,
    ! [VarCurr: state_type] :
      ( v142526(VarCurr)
    <=> v142528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19087,axiom,
    ! [VarCurr: state_type] :
      ( v142528(VarCurr)
    <=> ( v142530(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2131,axiom,
    ! [VarCurr: state_type] :
      ( v142530(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142524(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79516,axiom,
    ! [VarCurr: state_type] :
      ( v142516(VarCurr)
    <=> v142518(VarCurr) ) ).

tff(addAssignment_79515,axiom,
    ! [VarCurr: state_type] :
      ( v142518(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79514,axiom,
    ! [VarCurr: state_type] :
      ( v142512(VarCurr)
    <=> v142514(VarCurr) ) ).

tff(addAssignment_79513,axiom,
    ! [VarCurr: state_type] :
      ( v142514(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142450(VarCurr,B)
      <=> v142452(VarCurr,B) ) ) ).

tff(addAssignment_79511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142452(VarCurr,B)
      <=> v142454(VarCurr,B) ) ) ).

tff(addAssignment_79510,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142454(VarNext,B)
      <=> v142488(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142489(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142488(VarNext,B)
            <=> v142454(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2016,axiom,
    ! [VarNext: state_type] :
      ( v142489(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142488(VarNext,B)
          <=> v142499(VarNext,B) ) ) ) ).

tff(addAssignment_79509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142499(VarNext,B)
          <=> v142497(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142497(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1549,axiom,
    ! [VarCurr: state_type] :
      ( v142500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142497(VarCurr,B)
          <=> v142464(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19086,axiom,
    ! [VarCurr: state_type] :
      ( v142500(VarCurr)
    <=> ( v142501(VarCurr)
        & v142502(VarCurr) ) ) ).

tff(writeUnaryOperator_10868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142502(VarCurr)
    <=> v142460(VarCurr) ) ).

tff(writeUnaryOperator_10867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142501(VarCurr)
    <=> v142456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142489(VarNext)
      <=> v142490(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142490(VarNext)
      <=> ( v142491(VarNext)
          & v142484(VarNext) ) ) ) ).

tff(writeUnaryOperator_10866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142491(VarNext)
      <=> v142493(VarNext) ) ) ).

tff(addAssignment_79508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142493(VarNext)
      <=> v142484(VarCurr) ) ) ).

tff(addAssignment_79507,axiom,
    ! [VarCurr: state_type] :
      ( v142484(VarCurr)
    <=> v142486(VarCurr) ) ).

tff(addAssignment_79506,axiom,
    ! [VarCurr: state_type] :
      ( v142486(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142464(VarCurr,B)
      <=> v142466(VarCurr,B) ) ) ).

tff(addAssignment_79504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142466(VarCurr,B)
      <=> v142475(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142475(VarCurr,B)
      <=> ( v142476(VarCurr,B)
          | v142479(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142479(VarCurr,B)
      <=> ( v142452(VarCurr,B)
          & v142480(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142480(VarCurr,B)
      <=> ~ v142481(VarCurr,B) ) ) ).

tff(addAssignment_79503,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,0)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79502,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,1)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79501,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,2)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79500,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,3)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79499,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,4)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79498,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,5)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79497,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,6)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79496,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,7)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79495,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,8)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79494,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,9)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79493,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,10)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79492,axiom,
    ! [VarCurr: state_type] :
      ( v142481(VarCurr,11)
    <=> v142482(VarCurr) ) ).

tff(addAssignment_79491,axiom,
    ! [VarCurr: state_type] :
      ( v142482(VarCurr)
    <=> v142470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142476(VarCurr,B)
      <=> ( v142468(VarCurr,B)
          & v142477(VarCurr,B) ) ) ) ).

tff(addAssignment_79490,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,0)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79489,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,1)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79488,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,2)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79487,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,3)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79486,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,4)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79485,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,5)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79484,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,6)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79483,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,7)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79482,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,8)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79481,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,9)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79480,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,10)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79479,axiom,
    ! [VarCurr: state_type] :
      ( v142477(VarCurr,11)
    <=> v142478(VarCurr) ) ).

tff(addAssignment_79478,axiom,
    ! [VarCurr: state_type] :
      ( v142478(VarCurr)
    <=> v142470(VarCurr) ) ).

tff(addAssignment_79477,axiom,
    ! [VarCurr: state_type] :
      ( v142470(VarCurr)
    <=> v142472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19083,axiom,
    ! [VarCurr: state_type] :
      ( v142472(VarCurr)
    <=> ( v142474(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2130,axiom,
    ! [VarCurr: state_type] :
      ( v142474(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142468(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79475,axiom,
    ! [VarCurr: state_type] :
      ( v142460(VarCurr)
    <=> v142462(VarCurr) ) ).

tff(addAssignment_79474,axiom,
    ! [VarCurr: state_type] :
      ( v142462(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79473,axiom,
    ! [VarCurr: state_type] :
      ( v142456(VarCurr)
    <=> v142458(VarCurr) ) ).

tff(addAssignment_79472,axiom,
    ! [VarCurr: state_type] :
      ( v142458(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142394(VarCurr,B)
      <=> v142396(VarCurr,B) ) ) ).

tff(addAssignment_79470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142396(VarCurr,B)
      <=> v142398(VarCurr,B) ) ) ).

tff(addAssignment_79469,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142398(VarNext,B)
      <=> v142432(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142433(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142432(VarNext,B)
            <=> v142398(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2015,axiom,
    ! [VarNext: state_type] :
      ( v142433(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142432(VarNext,B)
          <=> v142443(VarNext,B) ) ) ) ).

tff(addAssignment_79468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142443(VarNext,B)
          <=> v142441(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142444(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142441(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1548,axiom,
    ! [VarCurr: state_type] :
      ( v142444(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142441(VarCurr,B)
          <=> v142408(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19082,axiom,
    ! [VarCurr: state_type] :
      ( v142444(VarCurr)
    <=> ( v142445(VarCurr)
        & v142446(VarCurr) ) ) ).

tff(writeUnaryOperator_10864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142446(VarCurr)
    <=> v142404(VarCurr) ) ).

tff(writeUnaryOperator_10863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142445(VarCurr)
    <=> v142400(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142433(VarNext)
      <=> v142434(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142434(VarNext)
      <=> ( v142435(VarNext)
          & v142428(VarNext) ) ) ) ).

tff(writeUnaryOperator_10862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142435(VarNext)
      <=> v142437(VarNext) ) ) ).

tff(addAssignment_79467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142437(VarNext)
      <=> v142428(VarCurr) ) ) ).

tff(addAssignment_79466,axiom,
    ! [VarCurr: state_type] :
      ( v142428(VarCurr)
    <=> v142430(VarCurr) ) ).

tff(addAssignment_79465,axiom,
    ! [VarCurr: state_type] :
      ( v142430(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142408(VarCurr,B)
      <=> v142410(VarCurr,B) ) ) ).

tff(addAssignment_79463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142410(VarCurr,B)
      <=> v142419(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142419(VarCurr,B)
      <=> ( v142420(VarCurr,B)
          | v142423(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142423(VarCurr,B)
      <=> ( v142396(VarCurr,B)
          & v142424(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142424(VarCurr,B)
      <=> ~ v142425(VarCurr,B) ) ) ).

tff(addAssignment_79462,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,0)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79461,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,1)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79460,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,2)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79459,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,3)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79458,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,4)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79457,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,5)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79456,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,6)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79455,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,7)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79454,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,8)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79453,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,9)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79452,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,10)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79451,axiom,
    ! [VarCurr: state_type] :
      ( v142425(VarCurr,11)
    <=> v142426(VarCurr) ) ).

tff(addAssignment_79450,axiom,
    ! [VarCurr: state_type] :
      ( v142426(VarCurr)
    <=> v142414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142420(VarCurr,B)
      <=> ( v142412(VarCurr,B)
          & v142421(VarCurr,B) ) ) ) ).

tff(addAssignment_79449,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,0)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79448,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,1)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79447,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,2)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79446,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,3)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79445,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,4)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79444,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,5)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79443,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,6)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79442,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,7)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79441,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,8)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79440,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,9)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79439,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,10)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79438,axiom,
    ! [VarCurr: state_type] :
      ( v142421(VarCurr,11)
    <=> v142422(VarCurr) ) ).

tff(addAssignment_79437,axiom,
    ! [VarCurr: state_type] :
      ( v142422(VarCurr)
    <=> v142414(VarCurr) ) ).

tff(addAssignment_79436,axiom,
    ! [VarCurr: state_type] :
      ( v142414(VarCurr)
    <=> v142416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19079,axiom,
    ! [VarCurr: state_type] :
      ( v142416(VarCurr)
    <=> ( v142418(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2129,axiom,
    ! [VarCurr: state_type] :
      ( v142418(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142412(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79434,axiom,
    ! [VarCurr: state_type] :
      ( v142404(VarCurr)
    <=> v142406(VarCurr) ) ).

tff(addAssignment_79433,axiom,
    ! [VarCurr: state_type] :
      ( v142406(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79432,axiom,
    ! [VarCurr: state_type] :
      ( v142400(VarCurr)
    <=> v142402(VarCurr) ) ).

tff(addAssignment_79431,axiom,
    ! [VarCurr: state_type] :
      ( v142402(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142338(VarCurr,B)
      <=> v142340(VarCurr,B) ) ) ).

tff(addAssignment_79429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142340(VarCurr,B)
      <=> v142342(VarCurr,B) ) ) ).

tff(addAssignment_79428,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142342(VarNext,B)
      <=> v142376(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142377(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142376(VarNext,B)
            <=> v142342(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2014,axiom,
    ! [VarNext: state_type] :
      ( v142377(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142376(VarNext,B)
          <=> v142387(VarNext,B) ) ) ) ).

tff(addAssignment_79427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142387(VarNext,B)
          <=> v142385(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142388(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142385(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1547,axiom,
    ! [VarCurr: state_type] :
      ( v142388(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142385(VarCurr,B)
          <=> v142352(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19078,axiom,
    ! [VarCurr: state_type] :
      ( v142388(VarCurr)
    <=> ( v142389(VarCurr)
        & v142390(VarCurr) ) ) ).

tff(writeUnaryOperator_10860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142390(VarCurr)
    <=> v142348(VarCurr) ) ).

tff(writeUnaryOperator_10859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142389(VarCurr)
    <=> v142344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142377(VarNext)
      <=> v142378(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142378(VarNext)
      <=> ( v142379(VarNext)
          & v142372(VarNext) ) ) ) ).

tff(writeUnaryOperator_10858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142379(VarNext)
      <=> v142381(VarNext) ) ) ).

tff(addAssignment_79426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142381(VarNext)
      <=> v142372(VarCurr) ) ) ).

tff(addAssignment_79425,axiom,
    ! [VarCurr: state_type] :
      ( v142372(VarCurr)
    <=> v142374(VarCurr) ) ).

tff(addAssignment_79424,axiom,
    ! [VarCurr: state_type] :
      ( v142374(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142352(VarCurr,B)
      <=> v142354(VarCurr,B) ) ) ).

tff(addAssignment_79422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142354(VarCurr,B)
      <=> v142363(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142363(VarCurr,B)
      <=> ( v142364(VarCurr,B)
          | v142367(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142367(VarCurr,B)
      <=> ( v142340(VarCurr,B)
          & v142368(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142368(VarCurr,B)
      <=> ~ v142369(VarCurr,B) ) ) ).

tff(addAssignment_79421,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,0)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79420,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,1)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79419,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,2)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79418,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,3)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79417,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,4)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79416,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,5)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79415,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,6)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79414,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,7)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79413,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,8)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79412,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,9)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79411,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,10)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79410,axiom,
    ! [VarCurr: state_type] :
      ( v142369(VarCurr,11)
    <=> v142370(VarCurr) ) ).

tff(addAssignment_79409,axiom,
    ! [VarCurr: state_type] :
      ( v142370(VarCurr)
    <=> v142358(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142364(VarCurr,B)
      <=> ( v142356(VarCurr,B)
          & v142365(VarCurr,B) ) ) ) ).

tff(addAssignment_79408,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,0)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79407,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,1)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79406,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,2)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79405,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,3)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79404,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,4)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79403,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,5)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79402,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,6)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79401,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,7)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79400,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,8)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79399,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,9)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79398,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,10)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79397,axiom,
    ! [VarCurr: state_type] :
      ( v142365(VarCurr,11)
    <=> v142366(VarCurr) ) ).

tff(addAssignment_79396,axiom,
    ! [VarCurr: state_type] :
      ( v142366(VarCurr)
    <=> v142358(VarCurr) ) ).

tff(addAssignment_79395,axiom,
    ! [VarCurr: state_type] :
      ( v142358(VarCurr)
    <=> v142360(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19075,axiom,
    ! [VarCurr: state_type] :
      ( v142360(VarCurr)
    <=> ( v142362(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2128,axiom,
    ! [VarCurr: state_type] :
      ( v142362(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142356(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79393,axiom,
    ! [VarCurr: state_type] :
      ( v142348(VarCurr)
    <=> v142350(VarCurr) ) ).

tff(addAssignment_79392,axiom,
    ! [VarCurr: state_type] :
      ( v142350(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79391,axiom,
    ! [VarCurr: state_type] :
      ( v142344(VarCurr)
    <=> v142346(VarCurr) ) ).

tff(addAssignment_79390,axiom,
    ! [VarCurr: state_type] :
      ( v142346(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142282(VarCurr,B)
      <=> v142284(VarCurr,B) ) ) ).

tff(addAssignment_79388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142284(VarCurr,B)
      <=> v142286(VarCurr,B) ) ) ).

tff(addAssignment_79387,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142286(VarNext,B)
      <=> v142320(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142321(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142320(VarNext,B)
            <=> v142286(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2013,axiom,
    ! [VarNext: state_type] :
      ( v142321(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142320(VarNext,B)
          <=> v142331(VarNext,B) ) ) ) ).

tff(addAssignment_79386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142331(VarNext,B)
          <=> v142329(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142332(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142329(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1546,axiom,
    ! [VarCurr: state_type] :
      ( v142332(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142329(VarCurr,B)
          <=> v142296(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19074,axiom,
    ! [VarCurr: state_type] :
      ( v142332(VarCurr)
    <=> ( v142333(VarCurr)
        & v142334(VarCurr) ) ) ).

tff(writeUnaryOperator_10856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142334(VarCurr)
    <=> v142292(VarCurr) ) ).

tff(writeUnaryOperator_10855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142333(VarCurr)
    <=> v142288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142321(VarNext)
      <=> v142322(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142322(VarNext)
      <=> ( v142323(VarNext)
          & v142316(VarNext) ) ) ) ).

tff(writeUnaryOperator_10854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142323(VarNext)
      <=> v142325(VarNext) ) ) ).

tff(addAssignment_79385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142325(VarNext)
      <=> v142316(VarCurr) ) ) ).

tff(addAssignment_79384,axiom,
    ! [VarCurr: state_type] :
      ( v142316(VarCurr)
    <=> v142318(VarCurr) ) ).

tff(addAssignment_79383,axiom,
    ! [VarCurr: state_type] :
      ( v142318(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142296(VarCurr,B)
      <=> v142298(VarCurr,B) ) ) ).

tff(addAssignment_79381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142298(VarCurr,B)
      <=> v142307(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1981,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142307(VarCurr,B)
      <=> ( v142308(VarCurr,B)
          | v142311(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142311(VarCurr,B)
      <=> ( v142284(VarCurr,B)
          & v142312(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142312(VarCurr,B)
      <=> ~ v142313(VarCurr,B) ) ) ).

tff(addAssignment_79380,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,0)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79379,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,1)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79378,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,2)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79377,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,3)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79376,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,4)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79375,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,5)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79374,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,6)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79373,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,7)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79372,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,8)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79371,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,9)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79370,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,10)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79369,axiom,
    ! [VarCurr: state_type] :
      ( v142313(VarCurr,11)
    <=> v142314(VarCurr) ) ).

tff(addAssignment_79368,axiom,
    ! [VarCurr: state_type] :
      ( v142314(VarCurr)
    <=> v142302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142308(VarCurr,B)
      <=> ( v142300(VarCurr,B)
          & v142309(VarCurr,B) ) ) ) ).

tff(addAssignment_79367,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,0)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79366,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,1)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79365,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,2)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79364,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,3)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79363,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,4)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79362,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,5)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79361,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,6)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79360,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,7)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79359,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,8)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79358,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,9)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79357,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,10)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79356,axiom,
    ! [VarCurr: state_type] :
      ( v142309(VarCurr,11)
    <=> v142310(VarCurr) ) ).

tff(addAssignment_79355,axiom,
    ! [VarCurr: state_type] :
      ( v142310(VarCurr)
    <=> v142302(VarCurr) ) ).

tff(addAssignment_79354,axiom,
    ! [VarCurr: state_type] :
      ( v142302(VarCurr)
    <=> v142304(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19071,axiom,
    ! [VarCurr: state_type] :
      ( v142304(VarCurr)
    <=> ( v142306(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2127,axiom,
    ! [VarCurr: state_type] :
      ( v142306(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $true )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142300(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79352,axiom,
    ! [VarCurr: state_type] :
      ( v142292(VarCurr)
    <=> v142294(VarCurr) ) ).

tff(addAssignment_79351,axiom,
    ! [VarCurr: state_type] :
      ( v142294(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79350,axiom,
    ! [VarCurr: state_type] :
      ( v142288(VarCurr)
    <=> v142290(VarCurr) ) ).

tff(addAssignment_79349,axiom,
    ! [VarCurr: state_type] :
      ( v142290(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142226(VarCurr,B)
      <=> v142228(VarCurr,B) ) ) ).

tff(addAssignment_79347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142228(VarCurr,B)
      <=> v142230(VarCurr,B) ) ) ).

tff(addAssignment_79346,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142230(VarNext,B)
      <=> v142264(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142265(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142264(VarNext,B)
            <=> v142230(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2012,axiom,
    ! [VarNext: state_type] :
      ( v142265(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142264(VarNext,B)
          <=> v142275(VarNext,B) ) ) ) ).

tff(addAssignment_79345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142275(VarNext,B)
          <=> v142273(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142276(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142273(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1545,axiom,
    ! [VarCurr: state_type] :
      ( v142276(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142273(VarCurr,B)
          <=> v142240(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19070,axiom,
    ! [VarCurr: state_type] :
      ( v142276(VarCurr)
    <=> ( v142277(VarCurr)
        & v142278(VarCurr) ) ) ).

tff(writeUnaryOperator_10852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142278(VarCurr)
    <=> v142236(VarCurr) ) ).

tff(writeUnaryOperator_10851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142277(VarCurr)
    <=> v142232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142265(VarNext)
      <=> v142266(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142266(VarNext)
      <=> ( v142267(VarNext)
          & v142260(VarNext) ) ) ) ).

tff(writeUnaryOperator_10850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142267(VarNext)
      <=> v142269(VarNext) ) ) ).

tff(addAssignment_79344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142269(VarNext)
      <=> v142260(VarCurr) ) ) ).

tff(addAssignment_79343,axiom,
    ! [VarCurr: state_type] :
      ( v142260(VarCurr)
    <=> v142262(VarCurr) ) ).

tff(addAssignment_79342,axiom,
    ! [VarCurr: state_type] :
      ( v142262(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142240(VarCurr,B)
      <=> v142242(VarCurr,B) ) ) ).

tff(addAssignment_79340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142242(VarCurr,B)
      <=> v142251(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142251(VarCurr,B)
      <=> ( v142252(VarCurr,B)
          | v142255(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142255(VarCurr,B)
      <=> ( v142228(VarCurr,B)
          & v142256(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142256(VarCurr,B)
      <=> ~ v142257(VarCurr,B) ) ) ).

tff(addAssignment_79339,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,0)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79338,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,1)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79337,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,2)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79336,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,3)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79335,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,4)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79334,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,5)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79333,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,6)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79332,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,7)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79331,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,8)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79330,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,9)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79329,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,10)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79328,axiom,
    ! [VarCurr: state_type] :
      ( v142257(VarCurr,11)
    <=> v142258(VarCurr) ) ).

tff(addAssignment_79327,axiom,
    ! [VarCurr: state_type] :
      ( v142258(VarCurr)
    <=> v142246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142252(VarCurr,B)
      <=> ( v142244(VarCurr,B)
          & v142253(VarCurr,B) ) ) ) ).

tff(addAssignment_79326,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,0)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79325,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,1)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79324,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,2)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79323,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,3)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79322,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,4)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79321,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,5)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79320,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,6)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79319,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,7)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79318,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,8)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79317,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,9)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79316,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,10)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79315,axiom,
    ! [VarCurr: state_type] :
      ( v142253(VarCurr,11)
    <=> v142254(VarCurr) ) ).

tff(addAssignment_79314,axiom,
    ! [VarCurr: state_type] :
      ( v142254(VarCurr)
    <=> v142246(VarCurr) ) ).

tff(addAssignment_79313,axiom,
    ! [VarCurr: state_type] :
      ( v142246(VarCurr)
    <=> v142248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19067,axiom,
    ! [VarCurr: state_type] :
      ( v142248(VarCurr)
    <=> ( v142250(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2126,axiom,
    ! [VarCurr: state_type] :
      ( v142250(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142244(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79311,axiom,
    ! [VarCurr: state_type] :
      ( v142236(VarCurr)
    <=> v142238(VarCurr) ) ).

tff(addAssignment_79310,axiom,
    ! [VarCurr: state_type] :
      ( v142238(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79309,axiom,
    ! [VarCurr: state_type] :
      ( v142232(VarCurr)
    <=> v142234(VarCurr) ) ).

tff(addAssignment_79308,axiom,
    ! [VarCurr: state_type] :
      ( v142234(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142170(VarCurr,B)
      <=> v142172(VarCurr,B) ) ) ).

tff(addAssignment_79306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142172(VarCurr,B)
      <=> v142174(VarCurr,B) ) ) ).

tff(addAssignment_79305,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142174(VarNext,B)
      <=> v142208(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142209(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142208(VarNext,B)
            <=> v142174(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2011,axiom,
    ! [VarNext: state_type] :
      ( v142209(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142208(VarNext,B)
          <=> v142219(VarNext,B) ) ) ) ).

tff(addAssignment_79304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142219(VarNext,B)
          <=> v142217(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142217(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1544,axiom,
    ! [VarCurr: state_type] :
      ( v142220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142217(VarCurr,B)
          <=> v142184(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19066,axiom,
    ! [VarCurr: state_type] :
      ( v142220(VarCurr)
    <=> ( v142221(VarCurr)
        & v142222(VarCurr) ) ) ).

tff(writeUnaryOperator_10848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142222(VarCurr)
    <=> v142180(VarCurr) ) ).

tff(writeUnaryOperator_10847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142221(VarCurr)
    <=> v142176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142209(VarNext)
      <=> v142210(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142210(VarNext)
      <=> ( v142211(VarNext)
          & v142204(VarNext) ) ) ) ).

tff(writeUnaryOperator_10846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142211(VarNext)
      <=> v142213(VarNext) ) ) ).

tff(addAssignment_79303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142213(VarNext)
      <=> v142204(VarCurr) ) ) ).

tff(addAssignment_79302,axiom,
    ! [VarCurr: state_type] :
      ( v142204(VarCurr)
    <=> v142206(VarCurr) ) ).

tff(addAssignment_79301,axiom,
    ! [VarCurr: state_type] :
      ( v142206(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142184(VarCurr,B)
      <=> v142186(VarCurr,B) ) ) ).

tff(addAssignment_79299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142186(VarCurr,B)
      <=> v142195(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142195(VarCurr,B)
      <=> ( v142196(VarCurr,B)
          | v142199(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142199(VarCurr,B)
      <=> ( v142172(VarCurr,B)
          & v142200(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142200(VarCurr,B)
      <=> ~ v142201(VarCurr,B) ) ) ).

tff(addAssignment_79298,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,0)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79297,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,1)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79296,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,2)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79295,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,3)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79294,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,4)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79293,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,5)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79292,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,6)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79291,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,7)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79290,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,8)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79289,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,9)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79288,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,10)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79287,axiom,
    ! [VarCurr: state_type] :
      ( v142201(VarCurr,11)
    <=> v142202(VarCurr) ) ).

tff(addAssignment_79286,axiom,
    ! [VarCurr: state_type] :
      ( v142202(VarCurr)
    <=> v142190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142196(VarCurr,B)
      <=> ( v142188(VarCurr,B)
          & v142197(VarCurr,B) ) ) ) ).

tff(addAssignment_79285,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,0)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79284,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,1)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79283,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,2)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79282,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,3)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79281,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,4)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79280,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,5)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79279,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,6)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79278,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,7)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79277,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,8)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79276,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,9)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79275,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,10)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79274,axiom,
    ! [VarCurr: state_type] :
      ( v142197(VarCurr,11)
    <=> v142198(VarCurr) ) ).

tff(addAssignment_79273,axiom,
    ! [VarCurr: state_type] :
      ( v142198(VarCurr)
    <=> v142190(VarCurr) ) ).

tff(addAssignment_79272,axiom,
    ! [VarCurr: state_type] :
      ( v142190(VarCurr)
    <=> v142192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19063,axiom,
    ! [VarCurr: state_type] :
      ( v142192(VarCurr)
    <=> ( v142194(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2125,axiom,
    ! [VarCurr: state_type] :
      ( v142194(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142188(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79270,axiom,
    ! [VarCurr: state_type] :
      ( v142180(VarCurr)
    <=> v142182(VarCurr) ) ).

tff(addAssignment_79269,axiom,
    ! [VarCurr: state_type] :
      ( v142182(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79268,axiom,
    ! [VarCurr: state_type] :
      ( v142176(VarCurr)
    <=> v142178(VarCurr) ) ).

tff(addAssignment_79267,axiom,
    ! [VarCurr: state_type] :
      ( v142178(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142114(VarCurr,B)
      <=> v142116(VarCurr,B) ) ) ).

tff(addAssignment_79265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142116(VarCurr,B)
      <=> v142118(VarCurr,B) ) ) ).

tff(addAssignment_79264,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142118(VarNext,B)
      <=> v142152(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142153(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142152(VarNext,B)
            <=> v142118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2010,axiom,
    ! [VarNext: state_type] :
      ( v142153(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142152(VarNext,B)
          <=> v142163(VarNext,B) ) ) ) ).

tff(addAssignment_79263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142163(VarNext,B)
          <=> v142161(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142164(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142161(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1543,axiom,
    ! [VarCurr: state_type] :
      ( v142164(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142161(VarCurr,B)
          <=> v142128(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19062,axiom,
    ! [VarCurr: state_type] :
      ( v142164(VarCurr)
    <=> ( v142165(VarCurr)
        & v142166(VarCurr) ) ) ).

tff(writeUnaryOperator_10844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142166(VarCurr)
    <=> v142124(VarCurr) ) ).

tff(writeUnaryOperator_10843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142165(VarCurr)
    <=> v142120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142153(VarNext)
      <=> v142154(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142154(VarNext)
      <=> ( v142155(VarNext)
          & v142148(VarNext) ) ) ) ).

tff(writeUnaryOperator_10842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142155(VarNext)
      <=> v142157(VarNext) ) ) ).

tff(addAssignment_79262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142157(VarNext)
      <=> v142148(VarCurr) ) ) ).

tff(addAssignment_79261,axiom,
    ! [VarCurr: state_type] :
      ( v142148(VarCurr)
    <=> v142150(VarCurr) ) ).

tff(addAssignment_79260,axiom,
    ! [VarCurr: state_type] :
      ( v142150(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142128(VarCurr,B)
      <=> v142130(VarCurr,B) ) ) ).

tff(addAssignment_79258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142130(VarCurr,B)
      <=> v142139(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142139(VarCurr,B)
      <=> ( v142140(VarCurr,B)
          | v142143(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142143(VarCurr,B)
      <=> ( v142116(VarCurr,B)
          & v142144(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142144(VarCurr,B)
      <=> ~ v142145(VarCurr,B) ) ) ).

tff(addAssignment_79257,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,0)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79256,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,1)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79255,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,2)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79254,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,3)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79253,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,4)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79252,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,5)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79251,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,6)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79250,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,7)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79249,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,8)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79248,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,9)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79247,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,10)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79246,axiom,
    ! [VarCurr: state_type] :
      ( v142145(VarCurr,11)
    <=> v142146(VarCurr) ) ).

tff(addAssignment_79245,axiom,
    ! [VarCurr: state_type] :
      ( v142146(VarCurr)
    <=> v142134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142140(VarCurr,B)
      <=> ( v142132(VarCurr,B)
          & v142141(VarCurr,B) ) ) ) ).

tff(addAssignment_79244,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,0)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79243,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,1)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79242,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,2)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79241,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,3)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79240,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,4)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79239,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,5)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79238,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,6)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79237,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,7)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79236,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,8)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79235,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,9)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79234,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,10)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79233,axiom,
    ! [VarCurr: state_type] :
      ( v142141(VarCurr,11)
    <=> v142142(VarCurr) ) ).

tff(addAssignment_79232,axiom,
    ! [VarCurr: state_type] :
      ( v142142(VarCurr)
    <=> v142134(VarCurr) ) ).

tff(addAssignment_79231,axiom,
    ! [VarCurr: state_type] :
      ( v142134(VarCurr)
    <=> v142136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19059,axiom,
    ! [VarCurr: state_type] :
      ( v142136(VarCurr)
    <=> ( v142138(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2124,axiom,
    ! [VarCurr: state_type] :
      ( v142138(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142132(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79229,axiom,
    ! [VarCurr: state_type] :
      ( v142124(VarCurr)
    <=> v142126(VarCurr) ) ).

tff(addAssignment_79228,axiom,
    ! [VarCurr: state_type] :
      ( v142126(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79227,axiom,
    ! [VarCurr: state_type] :
      ( v142120(VarCurr)
    <=> v142122(VarCurr) ) ).

tff(addAssignment_79226,axiom,
    ! [VarCurr: state_type] :
      ( v142122(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142058(VarCurr,B)
      <=> v142060(VarCurr,B) ) ) ).

tff(addAssignment_79224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142060(VarCurr,B)
      <=> v142062(VarCurr,B) ) ) ).

tff(addAssignment_79223,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142062(VarNext,B)
      <=> v142096(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142097(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142096(VarNext,B)
            <=> v142062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2009,axiom,
    ! [VarNext: state_type] :
      ( v142097(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142096(VarNext,B)
          <=> v142107(VarNext,B) ) ) ) ).

tff(addAssignment_79222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142107(VarNext,B)
          <=> v142105(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142105(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1542,axiom,
    ! [VarCurr: state_type] :
      ( v142108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142105(VarCurr,B)
          <=> v142072(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19058,axiom,
    ! [VarCurr: state_type] :
      ( v142108(VarCurr)
    <=> ( v142109(VarCurr)
        & v142110(VarCurr) ) ) ).

tff(writeUnaryOperator_10840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142110(VarCurr)
    <=> v142068(VarCurr) ) ).

tff(writeUnaryOperator_10839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142109(VarCurr)
    <=> v142064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142097(VarNext)
      <=> v142098(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142098(VarNext)
      <=> ( v142099(VarNext)
          & v142092(VarNext) ) ) ) ).

tff(writeUnaryOperator_10838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142099(VarNext)
      <=> v142101(VarNext) ) ) ).

tff(addAssignment_79221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142101(VarNext)
      <=> v142092(VarCurr) ) ) ).

tff(addAssignment_79220,axiom,
    ! [VarCurr: state_type] :
      ( v142092(VarCurr)
    <=> v142094(VarCurr) ) ).

tff(addAssignment_79219,axiom,
    ! [VarCurr: state_type] :
      ( v142094(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142072(VarCurr,B)
      <=> v142074(VarCurr,B) ) ) ).

tff(addAssignment_79217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142074(VarCurr,B)
      <=> v142083(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142083(VarCurr,B)
      <=> ( v142084(VarCurr,B)
          | v142087(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142087(VarCurr,B)
      <=> ( v142060(VarCurr,B)
          & v142088(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142088(VarCurr,B)
      <=> ~ v142089(VarCurr,B) ) ) ).

tff(addAssignment_79216,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,0)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79215,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,1)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79214,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,2)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79213,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,3)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79212,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,4)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79211,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,5)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79210,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,6)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79209,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,7)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79208,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,8)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79207,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,9)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79206,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,10)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79205,axiom,
    ! [VarCurr: state_type] :
      ( v142089(VarCurr,11)
    <=> v142090(VarCurr) ) ).

tff(addAssignment_79204,axiom,
    ! [VarCurr: state_type] :
      ( v142090(VarCurr)
    <=> v142078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142084(VarCurr,B)
      <=> ( v142076(VarCurr,B)
          & v142085(VarCurr,B) ) ) ) ).

tff(addAssignment_79203,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,0)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79202,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,1)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79201,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,2)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79200,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,3)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79199,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,4)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79198,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,5)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79197,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,6)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79196,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,7)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79195,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,8)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79194,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,9)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79193,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,10)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79192,axiom,
    ! [VarCurr: state_type] :
      ( v142085(VarCurr,11)
    <=> v142086(VarCurr) ) ).

tff(addAssignment_79191,axiom,
    ! [VarCurr: state_type] :
      ( v142086(VarCurr)
    <=> v142078(VarCurr) ) ).

tff(addAssignment_79190,axiom,
    ! [VarCurr: state_type] :
      ( v142078(VarCurr)
    <=> v142080(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19055,axiom,
    ! [VarCurr: state_type] :
      ( v142080(VarCurr)
    <=> ( v142082(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2123,axiom,
    ! [VarCurr: state_type] :
      ( v142082(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $true )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142076(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79188,axiom,
    ! [VarCurr: state_type] :
      ( v142068(VarCurr)
    <=> v142070(VarCurr) ) ).

tff(addAssignment_79187,axiom,
    ! [VarCurr: state_type] :
      ( v142070(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79186,axiom,
    ! [VarCurr: state_type] :
      ( v142064(VarCurr)
    <=> v142066(VarCurr) ) ).

tff(addAssignment_79185,axiom,
    ! [VarCurr: state_type] :
      ( v142066(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142002(VarCurr,B)
      <=> v142004(VarCurr,B) ) ) ).

tff(addAssignment_79183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142004(VarCurr,B)
      <=> v142006(VarCurr,B) ) ) ).

tff(addAssignment_79182,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142006(VarNext,B)
      <=> v142040(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142041(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v142040(VarNext,B)
            <=> v142006(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2008,axiom,
    ! [VarNext: state_type] :
      ( v142041(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142040(VarNext,B)
          <=> v142051(VarNext,B) ) ) ) ).

tff(addAssignment_79181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142051(VarNext,B)
          <=> v142049(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142052(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142049(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1541,axiom,
    ! [VarCurr: state_type] :
      ( v142052(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v142049(VarCurr,B)
          <=> v142016(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19054,axiom,
    ! [VarCurr: state_type] :
      ( v142052(VarCurr)
    <=> ( v142053(VarCurr)
        & v142054(VarCurr) ) ) ).

tff(writeUnaryOperator_10836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142054(VarCurr)
    <=> v142012(VarCurr) ) ).

tff(writeUnaryOperator_10835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v142053(VarCurr)
    <=> v142008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142041(VarNext)
      <=> v142042(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142042(VarNext)
      <=> ( v142043(VarNext)
          & v142036(VarNext) ) ) ) ).

tff(writeUnaryOperator_10834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v142043(VarNext)
      <=> v142045(VarNext) ) ) ).

tff(addAssignment_79180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v142045(VarNext)
      <=> v142036(VarCurr) ) ) ).

tff(addAssignment_79179,axiom,
    ! [VarCurr: state_type] :
      ( v142036(VarCurr)
    <=> v142038(VarCurr) ) ).

tff(addAssignment_79178,axiom,
    ! [VarCurr: state_type] :
      ( v142038(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142016(VarCurr,B)
      <=> v142018(VarCurr,B) ) ) ).

tff(addAssignment_79176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142018(VarCurr,B)
      <=> v142027(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142027(VarCurr,B)
      <=> ( v142028(VarCurr,B)
          | v142031(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142031(VarCurr,B)
      <=> ( v142004(VarCurr,B)
          & v142032(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142032(VarCurr,B)
      <=> ~ v142033(VarCurr,B) ) ) ).

tff(addAssignment_79175,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,0)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79174,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,1)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79173,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,2)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79172,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,3)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79171,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,4)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79170,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,5)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79169,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,6)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79168,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,7)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79167,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,8)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79166,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,9)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79165,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,10)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79164,axiom,
    ! [VarCurr: state_type] :
      ( v142033(VarCurr,11)
    <=> v142034(VarCurr) ) ).

tff(addAssignment_79163,axiom,
    ! [VarCurr: state_type] :
      ( v142034(VarCurr)
    <=> v142022(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v142028(VarCurr,B)
      <=> ( v142020(VarCurr,B)
          & v142029(VarCurr,B) ) ) ) ).

tff(addAssignment_79162,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,0)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79161,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,1)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79160,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,2)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79159,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,3)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79158,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,4)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79157,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,5)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79156,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,6)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79155,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,7)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79154,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,8)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79153,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,9)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79152,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,10)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79151,axiom,
    ! [VarCurr: state_type] :
      ( v142029(VarCurr,11)
    <=> v142030(VarCurr) ) ).

tff(addAssignment_79150,axiom,
    ! [VarCurr: state_type] :
      ( v142030(VarCurr)
    <=> v142022(VarCurr) ) ).

tff(addAssignment_79149,axiom,
    ! [VarCurr: state_type] :
      ( v142022(VarCurr)
    <=> v142024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19051,axiom,
    ! [VarCurr: state_type] :
      ( v142024(VarCurr)
    <=> ( v142026(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2122,axiom,
    ! [VarCurr: state_type] :
      ( v142026(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v142020(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79147,axiom,
    ! [VarCurr: state_type] :
      ( v142012(VarCurr)
    <=> v142014(VarCurr) ) ).

tff(addAssignment_79146,axiom,
    ! [VarCurr: state_type] :
      ( v142014(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79145,axiom,
    ! [VarCurr: state_type] :
      ( v142008(VarCurr)
    <=> v142010(VarCurr) ) ).

tff(addAssignment_79144,axiom,
    ! [VarCurr: state_type] :
      ( v142010(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141946(VarCurr,B)
      <=> v141948(VarCurr,B) ) ) ).

tff(addAssignment_79142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141948(VarCurr,B)
      <=> v141950(VarCurr,B) ) ) ).

tff(addAssignment_79141,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141950(VarNext,B)
      <=> v141984(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141985(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v141984(VarNext,B)
            <=> v141950(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2007,axiom,
    ! [VarNext: state_type] :
      ( v141985(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141984(VarNext,B)
          <=> v141995(VarNext,B) ) ) ) ).

tff(addAssignment_79140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141995(VarNext,B)
          <=> v141993(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141996(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141993(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1540,axiom,
    ! [VarCurr: state_type] :
      ( v141996(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141993(VarCurr,B)
          <=> v141960(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19050,axiom,
    ! [VarCurr: state_type] :
      ( v141996(VarCurr)
    <=> ( v141997(VarCurr)
        & v141998(VarCurr) ) ) ).

tff(writeUnaryOperator_10832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141998(VarCurr)
    <=> v141956(VarCurr) ) ).

tff(writeUnaryOperator_10831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141997(VarCurr)
    <=> v141952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141985(VarNext)
      <=> v141986(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141986(VarNext)
      <=> ( v141987(VarNext)
          & v141980(VarNext) ) ) ) ).

tff(writeUnaryOperator_10830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141987(VarNext)
      <=> v141989(VarNext) ) ) ).

tff(addAssignment_79139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141989(VarNext)
      <=> v141980(VarCurr) ) ) ).

tff(addAssignment_79138,axiom,
    ! [VarCurr: state_type] :
      ( v141980(VarCurr)
    <=> v141982(VarCurr) ) ).

tff(addAssignment_79137,axiom,
    ! [VarCurr: state_type] :
      ( v141982(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141960(VarCurr,B)
      <=> v141962(VarCurr,B) ) ) ).

tff(addAssignment_79135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141962(VarCurr,B)
      <=> v141971(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141971(VarCurr,B)
      <=> ( v141972(VarCurr,B)
          | v141975(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141975(VarCurr,B)
      <=> ( v141948(VarCurr,B)
          & v141976(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141976(VarCurr,B)
      <=> ~ v141977(VarCurr,B) ) ) ).

tff(addAssignment_79134,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,0)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79133,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,1)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79132,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,2)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79131,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,3)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79130,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,4)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79129,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,5)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79128,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,6)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79127,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,7)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79126,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,8)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79125,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,9)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79124,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,10)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79123,axiom,
    ! [VarCurr: state_type] :
      ( v141977(VarCurr,11)
    <=> v141978(VarCurr) ) ).

tff(addAssignment_79122,axiom,
    ! [VarCurr: state_type] :
      ( v141978(VarCurr)
    <=> v141966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141972(VarCurr,B)
      <=> ( v141964(VarCurr,B)
          & v141973(VarCurr,B) ) ) ) ).

tff(addAssignment_79121,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,0)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79120,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,1)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79119,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,2)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79118,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,3)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79117,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,4)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79116,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,5)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79115,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,6)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79114,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,7)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79113,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,8)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79112,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,9)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79111,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,10)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79110,axiom,
    ! [VarCurr: state_type] :
      ( v141973(VarCurr,11)
    <=> v141974(VarCurr) ) ).

tff(addAssignment_79109,axiom,
    ! [VarCurr: state_type] :
      ( v141974(VarCurr)
    <=> v141966(VarCurr) ) ).

tff(addAssignment_79108,axiom,
    ! [VarCurr: state_type] :
      ( v141966(VarCurr)
    <=> v141968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19047,axiom,
    ! [VarCurr: state_type] :
      ( v141968(VarCurr)
    <=> ( v141970(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2121,axiom,
    ! [VarCurr: state_type] :
      ( v141970(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $true )
        & ( v2813(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141964(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79106,axiom,
    ! [VarCurr: state_type] :
      ( v141956(VarCurr)
    <=> v141958(VarCurr) ) ).

tff(addAssignment_79105,axiom,
    ! [VarCurr: state_type] :
      ( v141958(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79104,axiom,
    ! [VarCurr: state_type] :
      ( v141952(VarCurr)
    <=> v141954(VarCurr) ) ).

tff(addAssignment_79103,axiom,
    ! [VarCurr: state_type] :
      ( v141954(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141890(VarCurr,B)
      <=> v141892(VarCurr,B) ) ) ).

tff(addAssignment_79101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141892(VarCurr,B)
      <=> v141894(VarCurr,B) ) ) ).

tff(addAssignment_79100,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141894(VarNext,B)
      <=> v141928(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141929(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v141928(VarNext,B)
            <=> v141894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2006,axiom,
    ! [VarNext: state_type] :
      ( v141929(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141928(VarNext,B)
          <=> v141939(VarNext,B) ) ) ) ).

tff(addAssignment_79099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141939(VarNext,B)
          <=> v141937(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141940(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141937(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1539,axiom,
    ! [VarCurr: state_type] :
      ( v141940(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141937(VarCurr,B)
          <=> v141904(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19046,axiom,
    ! [VarCurr: state_type] :
      ( v141940(VarCurr)
    <=> ( v141941(VarCurr)
        & v141942(VarCurr) ) ) ).

tff(writeUnaryOperator_10828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141942(VarCurr)
    <=> v141900(VarCurr) ) ).

tff(writeUnaryOperator_10827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141941(VarCurr)
    <=> v141896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141929(VarNext)
      <=> v141930(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141930(VarNext)
      <=> ( v141931(VarNext)
          & v141924(VarNext) ) ) ) ).

tff(writeUnaryOperator_10826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141931(VarNext)
      <=> v141933(VarNext) ) ) ).

tff(addAssignment_79098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141933(VarNext)
      <=> v141924(VarCurr) ) ) ).

tff(addAssignment_79097,axiom,
    ! [VarCurr: state_type] :
      ( v141924(VarCurr)
    <=> v141926(VarCurr) ) ).

tff(addAssignment_79096,axiom,
    ! [VarCurr: state_type] :
      ( v141926(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141904(VarCurr,B)
      <=> v141906(VarCurr,B) ) ) ).

tff(addAssignment_79094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141906(VarCurr,B)
      <=> v141915(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141915(VarCurr,B)
      <=> ( v141916(VarCurr,B)
          | v141919(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141919(VarCurr,B)
      <=> ( v141892(VarCurr,B)
          & v141920(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141920(VarCurr,B)
      <=> ~ v141921(VarCurr,B) ) ) ).

tff(addAssignment_79093,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,0)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79092,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,1)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79091,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,2)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79090,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,3)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79089,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,4)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79088,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,5)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79087,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,6)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79086,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,7)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79085,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,8)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79084,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,9)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79083,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,10)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79082,axiom,
    ! [VarCurr: state_type] :
      ( v141921(VarCurr,11)
    <=> v141922(VarCurr) ) ).

tff(addAssignment_79081,axiom,
    ! [VarCurr: state_type] :
      ( v141922(VarCurr)
    <=> v141910(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141916(VarCurr,B)
      <=> ( v141908(VarCurr,B)
          & v141917(VarCurr,B) ) ) ) ).

tff(addAssignment_79080,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,0)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79079,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,1)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79078,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,2)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79077,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,3)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79076,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,4)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79075,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,5)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79074,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,6)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79073,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,7)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79072,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,8)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79071,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,9)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79070,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,10)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79069,axiom,
    ! [VarCurr: state_type] :
      ( v141917(VarCurr,11)
    <=> v141918(VarCurr) ) ).

tff(addAssignment_79068,axiom,
    ! [VarCurr: state_type] :
      ( v141918(VarCurr)
    <=> v141910(VarCurr) ) ).

tff(addAssignment_79067,axiom,
    ! [VarCurr: state_type] :
      ( v141910(VarCurr)
    <=> v141912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19043,axiom,
    ! [VarCurr: state_type] :
      ( v141912(VarCurr)
    <=> ( v141914(VarCurr)
        & v2868(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2120,axiom,
    ! [VarCurr: state_type] :
      ( v141914(VarCurr)
    <=> ( ( v2813(VarCurr,4)
        <=> $false )
        & ( v2813(VarCurr,3)
        <=> $false )
        & ( v2813(VarCurr,2)
        <=> $false )
        & ( v2813(VarCurr,1)
        <=> $false )
        & ( v2813(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_79066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v141908(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79065,axiom,
    ! [VarCurr: state_type] :
      ( v141900(VarCurr)
    <=> v141902(VarCurr) ) ).

tff(addAssignment_79064,axiom,
    ! [VarCurr: state_type] :
      ( v141902(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_79063,axiom,
    ! [VarCurr: state_type] :
      ( v141896(VarCurr)
    <=> v141898(VarCurr) ) ).

tff(addAssignment_79062,axiom,
    ! [VarCurr: state_type] :
      ( v141898(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_79061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2302(VarCurr,B)
      <=> v2304(VarCurr,B) ) ) ).

tff(addAssignment_79060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2304(VarCurr,B)
      <=> v2306(VarCurr,B) ) ) ).

tff(addAssignment_79059,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2306(VarNext,B)
      <=> v141872(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_2005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141873(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v141872(VarNext,B)
            <=> v2306(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2005,axiom,
    ! [VarNext: state_type] :
      ( v141873(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141872(VarNext,B)
          <=> v141883(VarNext,B) ) ) ) ).

tff(addAssignment_79058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141883(VarNext,B)
          <=> v141881(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141884(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141881(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1538,axiom,
    ! [VarCurr: state_type] :
      ( v141884(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v141881(VarCurr,B)
          <=> v2316(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19042,axiom,
    ! [VarCurr: state_type] :
      ( v141884(VarCurr)
    <=> ( v141885(VarCurr)
        & v141886(VarCurr) ) ) ).

tff(writeUnaryOperator_10824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141886(VarCurr)
    <=> v2312(VarCurr) ) ).

tff(writeUnaryOperator_10823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141885(VarCurr)
    <=> v2308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141873(VarNext)
      <=> v141874(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141874(VarNext)
      <=> ( v141875(VarNext)
          & v141868(VarNext) ) ) ) ).

tff(writeUnaryOperator_10822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141875(VarNext)
      <=> v141877(VarNext) ) ) ).

tff(addAssignment_79057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141877(VarNext)
      <=> v141868(VarCurr) ) ) ).

tff(addAssignment_79056,axiom,
    ! [VarCurr: state_type] :
      ( v141868(VarCurr)
    <=> v141870(VarCurr) ) ).

tff(addAssignment_79055,axiom,
    ! [VarCurr: state_type] :
      ( v141870(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_79054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2316(VarCurr,B)
      <=> v2318(VarCurr,B) ) ) ).

tff(addAssignment_79053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2318(VarCurr,B)
      <=> v141859(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141859(VarCurr,B)
      <=> ( v141860(VarCurr,B)
          | v141863(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141863(VarCurr,B)
      <=> ( v2304(VarCurr,B)
          & v141864(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141864(VarCurr,B)
      <=> ~ v141865(VarCurr,B) ) ) ).

tff(addAssignment_79052,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,0)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79051,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,1)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79050,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,2)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79049,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,3)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79048,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,4)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79047,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,5)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79046,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,6)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79045,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,7)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79044,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,8)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79043,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,9)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79042,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,10)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79041,axiom,
    ! [VarCurr: state_type] :
      ( v141865(VarCurr,11)
    <=> v141866(VarCurr) ) ).

tff(addAssignment_79040,axiom,
    ! [VarCurr: state_type] :
      ( v141866(VarCurr)
    <=> v2809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v141860(VarCurr,B)
      <=> ( v2320(VarCurr,B)
          & v141861(VarCurr,B) ) ) ) ).

tff(addAssignment_79039,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,0)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79038,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,1)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79037,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,2)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79036,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,3)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79035,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,4)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79034,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,5)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79033,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,6)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79032,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,7)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79031,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,8)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79030,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,9)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79029,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,10)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79028,axiom,
    ! [VarCurr: state_type] :
      ( v141861(VarCurr,11)
    <=> v141862(VarCurr) ) ).

tff(addAssignment_79027,axiom,
    ! [VarCurr: state_type] :
      ( v141862(VarCurr)
    <=> v2809(VarCurr) ) ).

tff(addAssignment_79026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2320(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_79025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2322(VarCurr,B)
      <=> v2324(VarCurr,B) ) ) ).

tff(addAssignment_79024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2324(VarCurr,B)
      <=> v2622(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v2623(VarCurr,B)
          <=> v141845(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1537,axiom,
    ! [VarCurr: state_type] :
      ( v4516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v2623(VarCurr,B)
          <=> v141844(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89669(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141845(VarCurr,B)
          <=> v141846(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1536,axiom,
    ! [VarCurr: state_type] :
      ( v89669(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141845(VarCurr,B)
          <=> b0011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141846(VarCurr,B)
          <=> v141848(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1535,axiom,
    ! [VarCurr: state_type] :
      ( v141847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141846(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141849(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141848(VarCurr,B)
          <=> v141850(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1534,axiom,
    ! [VarCurr: state_type] :
      ( v141849(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141848(VarCurr,B)
          <=> b0001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141850(VarCurr,B)
          <=> v141854(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1533,axiom,
    ! [VarCurr: state_type] :
      ( v141851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141850(VarCurr,B)
          <=> b0010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141854(VarCurr,B)
          <=> v141858(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1532,axiom,
    ! [VarCurr: state_type] :
      ( v141855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141854(VarCurr,B)
          <=> b0001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141763(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141858(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1531,axiom,
    ! [VarCurr: state_type] :
      ( v141763(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v141858(VarCurr,B)
          <=> b1000(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19039,axiom,
    ! [VarCurr: state_type] :
      ( v141855(VarCurr)
    <=> ( v141856(VarCurr)
        | v141857(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2119,axiom,
    ! [VarCurr: state_type] :
      ( v141857(VarCurr)
    <=> ( ( v141749(VarCurr,2)
        <=> $false )
        & ( v141749(VarCurr,1)
        <=> $true )
        & ( v141749(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2118,axiom,
    ! [VarCurr: state_type] :
      ( v141856(VarCurr)
    <=> ( ( v141737(VarCurr,2)
        <=> $false )
        & ( v141737(VarCurr,1)
        <=> $true )
        & ( v141737(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19038,axiom,
    ! [VarCurr: state_type] :
      ( v141851(VarCurr)
    <=> ( v141852(VarCurr)
        & v141853(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2117,axiom,
    ! [VarCurr: state_type] :
      ( v141853(VarCurr)
    <=> ( ( v141749(VarCurr,2)
        <=> $false )
        & ( v141749(VarCurr,1)
        <=> $true )
        & ( v141749(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2116,axiom,
    ! [VarCurr: state_type] :
      ( v141852(VarCurr)
    <=> ( ( v141737(VarCurr,2)
        <=> $false )
        & ( v141737(VarCurr,1)
        <=> $true )
        & ( v141737(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2115,axiom,
    ! [VarCurr: state_type] :
      ( v141849(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $true )
        & ( v2872(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2114,axiom,
    ! [VarCurr: state_type] :
      ( v141847(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $true )
        & ( v2872(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_79023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v141844(VarCurr,B)
      <=> v141663(VarCurr,B) ) ) ).

tff(addAssignment_79022,axiom,
    ! [VarCurr: state_type] :
      ( ( v141844(VarCurr,3)
      <=> $false )
      & ( v141844(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19037,axiom,
    ! [VarCurr: state_type] :
      ( v141763(VarCurr)
    <=> ( v141765(VarCurr)
        & v141841(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19036,axiom,
    ! [VarCurr: state_type] :
      ( v141841(VarCurr)
    <=> ( v141826(VarCurr)
        | v141842(VarCurr) ) ) ).

tff(writeUnaryOperator_10820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141842(VarCurr)
    <=> v4574(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19035,axiom,
    ! [VarCurr: state_type] :
      ( v141826(VarCurr)
    <=> ( v141828(VarCurr)
        & v141839(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2113,axiom,
    ! [VarCurr: state_type] :
      ( v141839(VarCurr)
    <=> ( ( v141663(VarCurr,1)
        <=> $false )
        & ( v141663(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19034,axiom,
    ! [VarCurr: state_type] :
      ( v141828(VarCurr)
    <=> ( v141829(VarCurr)
        & v141838(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2112,axiom,
    ! [VarCurr: state_type] :
      ( v141838(VarCurr)
    <=> ( ( v141749(VarCurr,2)
        <=> $false )
        & ( v141749(VarCurr,1)
        <=> $false )
        & ( v141749(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19033,axiom,
    ! [VarCurr: state_type] :
      ( v141829(VarCurr)
    <=> ( v141830(VarCurr)
        & v141837(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2111,axiom,
    ! [VarCurr: state_type] :
      ( v141837(VarCurr)
    <=> ( ( v141737(VarCurr,2)
        <=> $false )
        & ( v141737(VarCurr,1)
        <=> $false )
        & ( v141737(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19032,axiom,
    ! [VarCurr: state_type] :
      ( v141830(VarCurr)
    <=> ( v141831(VarCurr)
        & v141836(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2110,axiom,
    ! [VarCurr: state_type] :
      ( v141836(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $false )
        & ( v2872(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19031,axiom,
    ! [VarCurr: state_type] :
      ( v141831(VarCurr)
    <=> ( v141832(VarCurr)
        & v141835(VarCurr) ) ) ).

tff(writeUnaryOperator_10819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141835(VarCurr)
    <=> v100731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19030,axiom,
    ! [VarCurr: state_type] :
      ( v141832(VarCurr)
    <=> ( v141833(VarCurr)
        & v141834(VarCurr) ) ) ).

tff(writeUnaryOperator_10818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141834(VarCurr)
    <=> v84191(VarCurr) ) ).

tff(writeUnaryOperator_10817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141833(VarCurr)
    <=> v4516(VarCurr) ) ).

tff(addAssignment_79021,axiom,
    ! [VarCurr: state_type] :
      ( v141765(VarCurr)
    <=> v141767(VarCurr,0) ) ).

tff(addAssignment_79020,axiom,
    ! [VarCurr: state_type] :
      ( v141767(VarCurr,0)
    <=> v141769(VarCurr,0) ) ).

tff(addAssignment_79019,axiom,
    ! [VarNext: state_type] :
      ( v141769(VarNext,0)
    <=> v141808(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141809(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v141808(VarNext,B)
            <=> v141769(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2004,axiom,
    ! [VarNext: state_type] :
      ( v141809(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141808(VarNext,B)
          <=> v141819(VarNext,B) ) ) ) ).

tff(addAssignment_79018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141819(VarNext,B)
          <=> v141817(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141820(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141817(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1530,axiom,
    ! [VarCurr: state_type] :
      ( v141820(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141817(VarCurr,B)
          <=> v141779(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19029,axiom,
    ! [VarCurr: state_type] :
      ( v141820(VarCurr)
    <=> ( v141821(VarCurr)
        & v141822(VarCurr) ) ) ).

tff(writeUnaryOperator_10816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141822(VarCurr)
    <=> v141775(VarCurr) ) ).

tff(writeUnaryOperator_10815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141821(VarCurr)
    <=> v141771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141809(VarNext)
      <=> v141810(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141810(VarNext)
      <=> ( v141811(VarNext)
          & v141804(VarNext) ) ) ) ).

tff(writeUnaryOperator_10814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141811(VarNext)
      <=> v141813(VarNext) ) ) ).

tff(addAssignment_79017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141813(VarNext)
      <=> v141804(VarCurr) ) ) ).

tff(addAssignment_79016,axiom,
    ! [VarCurr: state_type] :
      ( v141804(VarCurr)
    <=> v141806(VarCurr) ) ).

tff(addAssignment_79015,axiom,
    ! [VarCurr: state_type] :
      ( v141806(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_79014,axiom,
    ! [VarCurr: state_type] :
      ( v141779(VarCurr,0)
    <=> v141781(VarCurr,0) ) ).

tff(addAssignment_79013,axiom,
    ! [VarCurr: state_type] :
      ( v141781(VarCurr,0)
    <=> v141783(VarCurr,0) ) ).

tff(addAssignment_79012,axiom,
    ! [VarCurr: state_type] :
      ( v141783(VarCurr,0)
    <=> v141801(VarCurr,0) ) ).

tff(addAssignment_79011,axiom,
    ! [VarCurr: state_type] :
      ( v141801(VarCurr,0)
    <=> v141785(VarCurr) ) ).

tff(addAssignment_79010,axiom,
    ! [VarCurr: state_type] :
      ( v141801(VarCurr,1)
    <=> v141802(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141794(VarCurr)
     => ( v141785(VarCurr)
      <=> v141798(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1529,axiom,
    ! [VarCurr: state_type] :
      ( v141794(VarCurr)
     => ( v141785(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141799(VarCurr)
     => ( v141798(VarCurr)
      <=> v141765(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1528,axiom,
    ! [VarCurr: state_type] :
      ( v141799(VarCurr)
     => ( v141798(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19026,axiom,
    ! [VarCurr: state_type] :
      ( v141799(VarCurr)
    <=> ( v141763(VarCurr)
        | v141800(VarCurr) ) ) ).

tff(writeUnaryOperator_10813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141800(VarCurr)
    <=> v4574(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19025,axiom,
    ! [VarCurr: state_type] :
      ( v141794(VarCurr)
    <=> ( v141795(VarCurr)
        | v141797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19024,axiom,
    ! [VarCurr: state_type] :
      ( v141797(VarCurr)
    <=> ( v96319(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19023,axiom,
    ! [VarCurr: state_type] :
      ( v141795(VarCurr)
    <=> ( v141787(VarCurr)
        & v141796(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2109,axiom,
    ! [VarCurr: state_type] :
      ( v141796(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $true )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2030,axiom,
    ~ b0100100001000(12) ).

tff(bitBlastConstant_2029,axiom,
    b0100100001000(11) ).

tff(bitBlastConstant_2028,axiom,
    ~ b0100100001000(10) ).

tff(bitBlastConstant_2027,axiom,
    ~ b0100100001000(9) ).

tff(bitBlastConstant_2026,axiom,
    b0100100001000(8) ).

tff(bitBlastConstant_2025,axiom,
    ~ b0100100001000(7) ).

tff(bitBlastConstant_2024,axiom,
    ~ b0100100001000(6) ).

tff(bitBlastConstant_2023,axiom,
    ~ b0100100001000(5) ).

tff(bitBlastConstant_2022,axiom,
    ~ b0100100001000(4) ).

tff(bitBlastConstant_2021,axiom,
    b0100100001000(3) ).

tff(bitBlastConstant_2020,axiom,
    ~ b0100100001000(2) ).

tff(bitBlastConstant_2019,axiom,
    ~ b0100100001000(1) ).

tff(bitBlastConstant_2018,axiom,
    ~ b0100100001000(0) ).

tff(addAssignment_79009,axiom,
    ! [VarCurr: state_type] :
      ( v141787(VarCurr)
    <=> v141789(VarCurr) ) ).

tff(addAssignment_79008,axiom,
    ! [VarCurr: state_type] :
      ( v141789(VarCurr)
    <=> v141791(VarCurr) ) ).

tff(addAssignment_79007,axiom,
    ! [VarCurr: state_type] :
      ( v141791(VarCurr)
    <=> v1121(VarCurr,78) ) ).

tff(addAssignment_79006,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,78)
    <=> v1123(VarCurr,78) ) ).

tff(addAssignment_79005,axiom,
    ! [VarCurr: state_type] :
      ( v141775(VarCurr)
    <=> v141777(VarCurr) ) ).

tff(addAssignment_79004,axiom,
    ! [VarCurr: state_type] :
      ( v141777(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_79003,axiom,
    ! [VarCurr: state_type] :
      ( v141771(VarCurr)
    <=> v141773(VarCurr) ) ).

tff(addAssignment_79002,axiom,
    ! [VarCurr: state_type] :
      ( v141773(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_79001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v141749(VarCurr,B)
      <=> v141751(VarCurr,B) ) ) ).

tff(addAssignment_79000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v141751(VarCurr,B)
      <=> v141753(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141753(VarCurr,B)
          <=> v141755(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1527,axiom,
    ! [VarCurr: state_type] :
      ( v112688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141753(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addZeroExtensionConstraint_55,axiom,
    ! [VarCurr: state_type] : ~ v141755(VarCurr,2) ).

tff(addAssignment_78999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v141755(VarCurr,B)
      <=> v141756(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141756(VarCurr,B)
          <=> v141757(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1526,axiom,
    ! [VarCurr: state_type] :
      ( v112698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141756(VarCurr,B)
          <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_54,axiom,
    ! [VarCurr: state_type] : ~ v141757(VarCurr,1) ).

tff(addAssignment_78998,axiom,
    ! [VarCurr: state_type] :
      ( v141757(VarCurr,0)
    <=> v141758(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141759(VarCurr)
     => ( v141758(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1525,axiom,
    ! [VarCurr: state_type] :
      ( v141759(VarCurr)
     => ( v141758(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19022,axiom,
    ! [VarCurr: state_type] :
      ( v141759(VarCurr)
    <=> ( v112518(VarCurr)
        | v141760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19021,axiom,
    ! [VarCurr: state_type] :
      ( v141760(VarCurr)
    <=> ( v141761(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19020,axiom,
    ! [VarCurr: state_type] :
      ( v141761(VarCurr)
    <=> ( v88615(VarCurr)
        | v88661(VarCurr) ) ) ).

tff(addAssignment_78997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v141737(VarCurr,B)
      <=> v141739(VarCurr,B) ) ) ).

tff(addAssignment_78996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v141739(VarCurr,B)
      <=> v141741(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141741(VarCurr,B)
          <=> v141743(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1524,axiom,
    ! [VarCurr: state_type] :
      ( v84295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141741(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141743(VarCurr,B)
          <=> v141745(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1523,axiom,
    ! [VarCurr: state_type] :
      ( v141744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141743(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112483(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141745(VarCurr,B)
          <=> v141746(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1522,axiom,
    ! [VarCurr: state_type] :
      ( v112483(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141745(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addZeroExtensionConstraint_53,axiom,
    ! [VarCurr: state_type] : ~ v141746(VarCurr,2) ).

tff(addAssignment_78995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v141746(VarCurr,B)
      <=> v141747(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126767(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141747(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1521,axiom,
    ! [VarCurr: state_type] :
      ( v126767(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141747(VarCurr,B)
          <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19019,axiom,
    ! [VarCurr: state_type] :
      ( v141744(VarCurr)
    <=> ( v111651(VarCurr)
        | v112645(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141663(VarCurr,B)
          <=> v141735(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1520,axiom,
    ! [VarCurr: state_type] :
      ( v10059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141663(VarCurr,B)
          <=> v141731(VarCurr,B) ) ) ) ).

tff(addAssignment_78994,axiom,
    ! [VarCurr: state_type] :
      ( v141735(VarCurr,0)
    <=> v141665(VarCurr) ) ).

tff(addAssignment_78993,axiom,
    ! [VarCurr: state_type] :
      ( v141735(VarCurr,1)
    <=> $false ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141731(VarCurr,B)
          <=> v141732(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1519,axiom,
    ! [VarCurr: state_type] :
      ( v141665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141731(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141732(VarCurr,B)
          <=> v141733(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1518,axiom,
    ! [VarCurr: state_type] :
      ( v141688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141732(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(addZeroExtensionConstraint_52,axiom,
    ! [VarCurr: state_type] : ~ v141733(VarCurr,1) ).

tff(addAssignment_78992,axiom,
    ! [VarCurr: state_type] :
      ( v141733(VarCurr,0)
    <=> v141734(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141721(VarCurr)
     => ( v141734(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1517,axiom,
    ! [VarCurr: state_type] :
      ( v141721(VarCurr)
     => ( v141734(VarCurr)
      <=> $true ) ) ).

tff(addAssignment_78991,axiom,
    ! [VarCurr: state_type] :
      ( v141721(VarCurr)
    <=> v141667(VarCurr,0) ) ).

tff(addAssignment_78990,axiom,
    ! [VarCurr: state_type] :
      ( v141667(VarCurr,0)
    <=> v141669(VarCurr,0) ) ).

tff(addAssignment_78989,axiom,
    ! [VarNext: state_type] :
      ( v141669(VarNext,0)
    <=> v141723(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_2003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141724(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v141723(VarNext,B)
            <=> v141669(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2003,axiom,
    ! [VarNext: state_type] :
      ( v141724(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141723(VarNext,B)
          <=> v141705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141724(VarNext)
      <=> v141725(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141725(VarNext)
      <=> ( v141727(VarNext)
          & v141690(VarNext) ) ) ) ).

tff(writeUnaryOperator_10812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141727(VarNext)
      <=> v141699(VarNext) ) ) ).

tff(addAssignment_78988,axiom,
    ! [VarCurr: state_type] :
      ( v141679(VarCurr,0)
    <=> v141681(VarCurr,0) ) ).

tff(addAssignment_78987,axiom,
    ! [VarCurr: state_type] :
      ( v141681(VarCurr,0)
    <=> v141683(VarCurr,0) ) ).

tff(addAssignment_78986,axiom,
    ! [VarCurr: state_type] :
      ( v141683(VarCurr,0)
    <=> v141687(VarCurr,0) ) ).

tff(addAssignment_78985,axiom,
    ! [VarCurr: state_type] :
      ( v141688(VarCurr)
    <=> v141667(VarCurr,1) ) ).

tff(addAssignment_78984,axiom,
    ! [VarCurr: state_type] :
      ( v141667(VarCurr,1)
    <=> v141669(VarCurr,1) ) ).

tff(addAssignment_78983,axiom,
    ! [VarNext: state_type] :
      ( v141669(VarNext,1)
    <=> v141713(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_2002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141714(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v141713(VarNext,B)
            <=> v141669(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2002,axiom,
    ! [VarNext: state_type] :
      ( v141714(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141713(VarNext,B)
          <=> v141705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141714(VarNext)
      <=> v141715(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141715(VarNext)
      <=> ( v141717(VarNext)
          & v141690(VarNext) ) ) ) ).

tff(writeUnaryOperator_10811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141717(VarNext)
      <=> v141699(VarNext) ) ) ).

tff(addAssignment_78982,axiom,
    ! [VarCurr: state_type] :
      ( v141679(VarCurr,1)
    <=> v141681(VarCurr,1) ) ).

tff(addAssignment_78981,axiom,
    ! [VarCurr: state_type] :
      ( v141681(VarCurr,1)
    <=> v141683(VarCurr,1) ) ).

tff(addAssignment_78980,axiom,
    ! [VarCurr: state_type] :
      ( v141683(VarCurr,1)
    <=> v141687(VarCurr,1) ) ).

tff(addAssignment_78979,axiom,
    ! [VarCurr: state_type] :
      ( v141665(VarCurr)
    <=> v141667(VarCurr,2) ) ).

tff(addAssignment_78978,axiom,
    ! [VarCurr: state_type] :
      ( v141667(VarCurr,2)
    <=> v141669(VarCurr,2) ) ).

tff(addAssignment_78977,axiom,
    ! [VarNext: state_type] :
      ( v141669(VarNext,2)
    <=> v141694(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_2001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141695(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v141694(VarNext,B)
            <=> v141669(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2001,axiom,
    ! [VarNext: state_type] :
      ( v141695(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141694(VarNext,B)
          <=> v141705(VarNext,B) ) ) ) ).

tff(addAssignment_78976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141705(VarNext,B)
          <=> v141703(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141703(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1516,axiom,
    ! [VarCurr: state_type] :
      ( v141706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v141703(VarCurr,B)
          <=> v141679(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19014,axiom,
    ! [VarCurr: state_type] :
      ( v141706(VarCurr)
    <=> ( v141707(VarCurr)
        & v141708(VarCurr) ) ) ).

tff(writeUnaryOperator_10810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141708(VarCurr)
    <=> v141675(VarCurr) ) ).

tff(writeUnaryOperator_10809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141707(VarCurr)
    <=> v141671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141695(VarNext)
      <=> v141696(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141696(VarNext)
      <=> ( v141697(VarNext)
          & v141690(VarNext) ) ) ) ).

tff(writeUnaryOperator_10808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141697(VarNext)
      <=> v141699(VarNext) ) ) ).

tff(addAssignment_78975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141699(VarNext)
      <=> v141690(VarCurr) ) ) ).

tff(addAssignment_78974,axiom,
    ! [VarCurr: state_type] :
      ( v141690(VarCurr)
    <=> v141692(VarCurr) ) ).

tff(addAssignment_78973,axiom,
    ! [VarCurr: state_type] :
      ( v141692(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_78972,axiom,
    ! [VarCurr: state_type] :
      ( v141679(VarCurr,2)
    <=> v141681(VarCurr,2) ) ).

tff(addAssignment_78971,axiom,
    ! [VarCurr: state_type] :
      ( v141681(VarCurr,2)
    <=> v141683(VarCurr,2) ) ).

tff(addAssignment_78970,axiom,
    ! [VarCurr: state_type] :
      ( v141683(VarCurr,2)
    <=> v141687(VarCurr,2) ) ).

tff(addAssignment_78969,axiom,
    ! [VarCurr: state_type] :
      ( v141687(VarCurr,0)
    <=> v141688(VarCurr) ) ).

tff(addAssignment_78968,axiom,
    ! [VarCurr: state_type] :
      ( v141687(VarCurr,1)
    <=> v141665(VarCurr) ) ).

tff(addAssignment_78967,axiom,
    ! [VarCurr: state_type] :
      ( v141687(VarCurr,2)
    <=> v141685(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2108,axiom,
    ! [VarCurr: state_type] :
      ( v141685(VarCurr)
    <=> ( ( v2872(VarCurr,2)
        <=> $false )
        & ( v2872(VarCurr,1)
        <=> $true )
        & ( v2872(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_78966,axiom,
    ! [VarCurr: state_type] :
      ( v141675(VarCurr)
    <=> v141677(VarCurr) ) ).

tff(addAssignment_78965,axiom,
    ! [VarCurr: state_type] :
      ( v141677(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_78964,axiom,
    ! [VarCurr: state_type] :
      ( v141671(VarCurr)
    <=> v141673(VarCurr) ) ).

tff(addAssignment_78963,axiom,
    ! [VarCurr: state_type] :
      ( v141673(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19011,axiom,
    ! [VarCurr: state_type] :
      ( v4516(VarCurr)
    <=> ( v141660(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19010,axiom,
    ! [VarCurr: state_type] :
      ( v141660(VarCurr)
    <=> ( v4518(VarCurr)
        & v141661(VarCurr) ) ) ).

tff(writeUnaryOperator_10807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141661(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(addAssignment_78962,axiom,
    ! [VarCurr: state_type] :
      ( v4518(VarCurr)
    <=> v4520(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141643(VarNext)
       => ( v4520(VarNext)
        <=> v4520(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2000,axiom,
    ! [VarNext: state_type] :
      ( v141643(VarNext)
     => ( v4520(VarNext)
      <=> v141653(VarNext) ) ) ).

tff(addAssignment_78961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141653(VarNext)
      <=> v141651(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141654(VarCurr)
     => ( v141651(VarCurr)
      <=> x84230(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1515,axiom,
    ! [VarCurr: state_type] :
      ( v141654(VarCurr)
     => ( v141651(VarCurr)
      <=> v4526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19009,axiom,
    ! [VarCurr: state_type] :
      ( v141654(VarCurr)
    <=> ( v141655(VarCurr)
        & v141656(VarCurr) ) ) ).

tff(writeUnaryOperator_10806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141656(VarCurr)
    <=> v4524(VarCurr) ) ).

tff(writeUnaryOperator_10805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141655(VarCurr)
    <=> v4522(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141643(VarNext)
      <=> v141644(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141644(VarNext)
      <=> ( v141645(VarNext)
          & v141640(VarNext) ) ) ) ).

tff(writeUnaryOperator_10804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141645(VarNext)
      <=> v141647(VarNext) ) ) ).

tff(addAssignment_78960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141647(VarNext)
      <=> v141640(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_264,axiom,
    ( v4520(constB0)
  <=> $false ) ).

tff(addAssignment_78959,axiom,
    ! [VarCurr: state_type] :
      ( v141640(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_78958,axiom,
    ! [VarCurr: state_type] :
      ( v4526(VarCurr)
    <=> v4528(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2107,axiom,
    ! [VarCurr: state_type] :
      ( v4528(VarCurr)
    <=> ( ( v4530(VarCurr,5)
        <=> $false )
        & ( v4530(VarCurr,4)
        <=> $false )
        & ( v4530(VarCurr,3)
        <=> $false )
        & ( v4530(VarCurr,2)
        <=> $false )
        & ( v4530(VarCurr,1)
        <=> $false )
        & ( v4530(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_78957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4530(VarCurr,B)
      <=> v4532(VarCurr,B) ) ) ).

tff(addAssignment_78956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4532(VarCurr,B)
      <=> v4534(VarCurr,B) ) ) ).

tff(addAssignment_78955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4534(VarCurr,B)
      <=> v4536(VarCurr,B) ) ) ).

tff(addAssignment_78954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4536(VarCurr,B)
      <=> v4538(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141622(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v4538(VarNext,B)
            <=> v4538(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1999,axiom,
    ! [VarNext: state_type] :
      ( v141622(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4538(VarNext,B)
          <=> v141632(VarNext,B) ) ) ) ).

tff(addAssignment_78953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141632(VarNext,B)
          <=> v141630(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141633(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141630(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1514,axiom,
    ! [VarCurr: state_type] :
      ( v141633(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141630(VarCurr,B)
          <=> v4560(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19006,axiom,
    ! [VarCurr: state_type] :
      ( v141633(VarCurr)
    <=> ( v141634(VarCurr)
        & v141635(VarCurr) ) ) ).

tff(writeUnaryOperator_10803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141635(VarCurr)
    <=> v4551(VarCurr) ) ).

tff(writeUnaryOperator_10802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141634(VarCurr)
    <=> v4540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141622(VarNext)
      <=> v141623(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141623(VarNext)
      <=> ( v141624(VarNext)
          & v141617(VarNext) ) ) ) ).

tff(writeUnaryOperator_10801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141624(VarNext)
      <=> v141626(VarNext) ) ) ).

tff(addAssignment_78952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141626(VarNext)
      <=> v141617(VarCurr) ) ) ).

tff(addAssignment_78951,axiom,
    ! [VarCurr: state_type] :
      ( v141617(VarCurr)
    <=> v141619(VarCurr) ) ).

tff(addAssignment_78950,axiom,
    ! [VarCurr: state_type] :
      ( v141619(VarCurr)
    <=> v94921(VarCurr) ) ).

tff(addAssignment_78949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4560(VarCurr,B)
      <=> v4562(VarCurr,B) ) ) ).

tff(addAssignment_78948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4562(VarCurr,B)
      <=> v4564(VarCurr,B) ) ) ).

tff(addAssignment_78947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4564(VarCurr,B)
      <=> v4566(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4566(VarCurr,B)
      <=> ( v141543(VarCurr,B)
          & v141545(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5040(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141545(VarCurr,B)
          <=> v141581(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1513,axiom,
    ! [VarCurr: state_type] :
      ( v5040(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141545(VarCurr,B)
          <=> v141546(VarCurr,B) ) ) ) ).

tff(addAssignment_78946,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,0)
    <=> v141614(VarCurr) ) ).

tff(addAssignment_78945,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,1)
    <=> v141612(VarCurr) ) ).

tff(addAssignment_78944,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,2)
    <=> v141608(VarCurr) ) ).

tff(addAssignment_78943,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,3)
    <=> v141604(VarCurr) ) ).

tff(addAssignment_78942,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,4)
    <=> v141600(VarCurr) ) ).

tff(addAssignment_78941,axiom,
    ! [VarCurr: state_type] :
      ( v141581(VarCurr,5)
    <=> v141583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19003,axiom,
    ! [VarCurr: state_type] :
      ( v141612(VarCurr)
    <=> ( v141613(VarCurr)
        & v141615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19002,axiom,
    ! [VarCurr: state_type] :
      ( v141615(VarCurr)
    <=> ( v4534(VarCurr,0)
        | v141594(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6889,axiom,
    ! [VarCurr: state_type] :
      ( v141613(VarCurr)
    <=> ( v141614(VarCurr)
        | v4534(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141614(VarCurr)
    <=> v4534(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19001,axiom,
    ! [VarCurr: state_type] :
      ( v141608(VarCurr)
    <=> ( v141609(VarCurr)
        & v141611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19000,axiom,
    ! [VarCurr: state_type] :
      ( v141611(VarCurr)
    <=> ( v141592(VarCurr)
        | v141595(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6888,axiom,
    ! [VarCurr: state_type] :
      ( v141609(VarCurr)
    <=> ( v141610(VarCurr)
        | v4534(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141610(VarCurr)
    <=> v141592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18999,axiom,
    ! [VarCurr: state_type] :
      ( v141604(VarCurr)
    <=> ( v141605(VarCurr)
        & v141607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18998,axiom,
    ! [VarCurr: state_type] :
      ( v141607(VarCurr)
    <=> ( v141590(VarCurr)
        | v141596(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6887,axiom,
    ! [VarCurr: state_type] :
      ( v141605(VarCurr)
    <=> ( v141606(VarCurr)
        | v4534(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141606(VarCurr)
    <=> v141590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18997,axiom,
    ! [VarCurr: state_type] :
      ( v141600(VarCurr)
    <=> ( v141601(VarCurr)
        & v141603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18996,axiom,
    ! [VarCurr: state_type] :
      ( v141603(VarCurr)
    <=> ( v141588(VarCurr)
        | v141597(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6886,axiom,
    ! [VarCurr: state_type] :
      ( v141601(VarCurr)
    <=> ( v141602(VarCurr)
        | v4534(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141602(VarCurr)
    <=> v141588(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18995,axiom,
    ! [VarCurr: state_type] :
      ( v141583(VarCurr)
    <=> ( v141584(VarCurr)
        & v141598(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18994,axiom,
    ! [VarCurr: state_type] :
      ( v141598(VarCurr)
    <=> ( v141586(VarCurr)
        | v141599(VarCurr) ) ) ).

tff(writeUnaryOperator_10796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141599(VarCurr)
    <=> v4534(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6885,axiom,
    ! [VarCurr: state_type] :
      ( v141584(VarCurr)
    <=> ( v141585(VarCurr)
        | v4534(VarCurr,5) ) ) ).

tff(writeUnaryOperator_10795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141585(VarCurr)
    <=> v141586(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6884,axiom,
    ! [VarCurr: state_type] :
      ( v141586(VarCurr)
    <=> ( v4534(VarCurr,4)
        | v141587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18993,axiom,
    ! [VarCurr: state_type] :
      ( v141587(VarCurr)
    <=> ( v141588(VarCurr)
        & v141597(VarCurr) ) ) ).

tff(writeUnaryOperator_10794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141597(VarCurr)
    <=> v4534(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6883,axiom,
    ! [VarCurr: state_type] :
      ( v141588(VarCurr)
    <=> ( v4534(VarCurr,3)
        | v141589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18992,axiom,
    ! [VarCurr: state_type] :
      ( v141589(VarCurr)
    <=> ( v141590(VarCurr)
        & v141596(VarCurr) ) ) ).

tff(writeUnaryOperator_10793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141596(VarCurr)
    <=> v4534(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6882,axiom,
    ! [VarCurr: state_type] :
      ( v141590(VarCurr)
    <=> ( v4534(VarCurr,2)
        | v141591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18991,axiom,
    ! [VarCurr: state_type] :
      ( v141591(VarCurr)
    <=> ( v141592(VarCurr)
        & v141595(VarCurr) ) ) ).

tff(writeUnaryOperator_10792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141595(VarCurr)
    <=> v4534(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6881,axiom,
    ! [VarCurr: state_type] :
      ( v141592(VarCurr)
    <=> ( v4534(VarCurr,1)
        | v141593(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18990,axiom,
    ! [VarCurr: state_type] :
      ( v141593(VarCurr)
    <=> ( v4534(VarCurr,0)
        & v141594(VarCurr) ) ) ).

tff(writeUnaryOperator_10791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141594(VarCurr)
    <=> v4534(VarCurr,1) ) ).

tff(addAssignment_78940,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,0)
    <=> v141579(VarCurr) ) ).

tff(addAssignment_78939,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,1)
    <=> v141577(VarCurr) ) ).

tff(addAssignment_78938,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,2)
    <=> v141573(VarCurr) ) ).

tff(addAssignment_78937,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,3)
    <=> v141569(VarCurr) ) ).

tff(addAssignment_78936,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,4)
    <=> v141565(VarCurr) ) ).

tff(addAssignment_78935,axiom,
    ! [VarCurr: state_type] :
      ( v141546(VarCurr,5)
    <=> v141548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18989,axiom,
    ! [VarCurr: state_type] :
      ( v141577(VarCurr)
    <=> ( v141578(VarCurr)
        & v141580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18988,axiom,
    ! [VarCurr: state_type] :
      ( v141580(VarCurr)
    <=> ( v5043(VarCurr,0)
        | v141559(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6880,axiom,
    ! [VarCurr: state_type] :
      ( v141578(VarCurr)
    <=> ( v141579(VarCurr)
        | v5043(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141579(VarCurr)
    <=> v5043(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18987,axiom,
    ! [VarCurr: state_type] :
      ( v141573(VarCurr)
    <=> ( v141574(VarCurr)
        & v141576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18986,axiom,
    ! [VarCurr: state_type] :
      ( v141576(VarCurr)
    <=> ( v141557(VarCurr)
        | v141560(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6879,axiom,
    ! [VarCurr: state_type] :
      ( v141574(VarCurr)
    <=> ( v141575(VarCurr)
        | v5043(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141575(VarCurr)
    <=> v141557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18985,axiom,
    ! [VarCurr: state_type] :
      ( v141569(VarCurr)
    <=> ( v141570(VarCurr)
        & v141572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18984,axiom,
    ! [VarCurr: state_type] :
      ( v141572(VarCurr)
    <=> ( v141555(VarCurr)
        | v141561(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6878,axiom,
    ! [VarCurr: state_type] :
      ( v141570(VarCurr)
    <=> ( v141571(VarCurr)
        | v5043(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141571(VarCurr)
    <=> v141555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18983,axiom,
    ! [VarCurr: state_type] :
      ( v141565(VarCurr)
    <=> ( v141566(VarCurr)
        & v141568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18982,axiom,
    ! [VarCurr: state_type] :
      ( v141568(VarCurr)
    <=> ( v141553(VarCurr)
        | v141562(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6877,axiom,
    ! [VarCurr: state_type] :
      ( v141566(VarCurr)
    <=> ( v141567(VarCurr)
        | v5043(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141567(VarCurr)
    <=> v141553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18981,axiom,
    ! [VarCurr: state_type] :
      ( v141548(VarCurr)
    <=> ( v141549(VarCurr)
        & v141563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18980,axiom,
    ! [VarCurr: state_type] :
      ( v141563(VarCurr)
    <=> ( v141551(VarCurr)
        | v141564(VarCurr) ) ) ).

tff(writeUnaryOperator_10786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141564(VarCurr)
    <=> v5043(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6876,axiom,
    ! [VarCurr: state_type] :
      ( v141549(VarCurr)
    <=> ( v141550(VarCurr)
        | v5043(VarCurr,5) ) ) ).

tff(writeUnaryOperator_10785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141550(VarCurr)
    <=> v141551(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6875,axiom,
    ! [VarCurr: state_type] :
      ( v141551(VarCurr)
    <=> ( v5043(VarCurr,4)
        | v141552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18979,axiom,
    ! [VarCurr: state_type] :
      ( v141552(VarCurr)
    <=> ( v141553(VarCurr)
        & v141562(VarCurr) ) ) ).

tff(writeUnaryOperator_10784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141562(VarCurr)
    <=> v5043(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6874,axiom,
    ! [VarCurr: state_type] :
      ( v141553(VarCurr)
    <=> ( v5043(VarCurr,3)
        | v141554(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18978,axiom,
    ! [VarCurr: state_type] :
      ( v141554(VarCurr)
    <=> ( v141555(VarCurr)
        & v141561(VarCurr) ) ) ).

tff(writeUnaryOperator_10783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141561(VarCurr)
    <=> v5043(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6873,axiom,
    ! [VarCurr: state_type] :
      ( v141555(VarCurr)
    <=> ( v5043(VarCurr,2)
        | v141556(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18977,axiom,
    ! [VarCurr: state_type] :
      ( v141556(VarCurr)
    <=> ( v141557(VarCurr)
        & v141560(VarCurr) ) ) ).

tff(writeUnaryOperator_10782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141560(VarCurr)
    <=> v5043(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6872,axiom,
    ! [VarCurr: state_type] :
      ( v141557(VarCurr)
    <=> ( v5043(VarCurr,1)
        | v141558(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18976,axiom,
    ! [VarCurr: state_type] :
      ( v141558(VarCurr)
    <=> ( v5043(VarCurr,0)
        & v141559(VarCurr) ) ) ).

tff(writeUnaryOperator_10781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141559(VarCurr)
    <=> v5043(VarCurr,1) ) ).

tff(addAssignment_78934,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,0)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78933,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,1)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78932,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,2)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78931,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,3)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78930,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,4)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78929,axiom,
    ! [VarCurr: state_type] :
      ( v141543(VarCurr,5)
    <=> v141544(VarCurr) ) ).

tff(addAssignment_78928,axiom,
    ! [VarCurr: state_type] :
      ( v141544(VarCurr)
    <=> v4568(VarCurr) ) ).

tff(addAssignment_78927,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,5)
    <=> v5045(VarCurr,5) ) ).

tff(addAssignment_78926,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,5)
    <=> v5047(VarCurr,5) ) ).

tff(addAssignment_78925,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,5)
    <=> v141459(VarCurr,5) ) ).

tff(addAssignment_78924,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,5)
    <=> v141390(VarCurr,5) ) ).

tff(addAssignment_78923,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,5)
    <=> v141458(VarCurr,5) ) ).

tff(addAssignment_78922,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,5)
    <=> v141394(VarCurr,5) ) ).

tff(addAssignment_78921,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,5)
    <=> v141396(VarCurr,5) ) ).

tff(addAssignment_78920,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,5)
    <=> v141535(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141536(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141535(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1998,axiom,
    ! [VarNext: state_type] :
      ( v141536(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141535(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141536(VarNext)
      <=> v141537(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141537(VarNext)
      <=> ( v141539(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141539(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78919,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,5)
    <=> v141410(VarCurr,5) ) ).

tff(addAssignment_78918,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,5)
    <=> v141428(VarCurr,5) ) ).

tff(addAssignment_78917,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,5)
    <=> v141414(VarCurr,5) ) ).

tff(addAssignment_78916,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,5)
    <=> v141416(VarCurr,5) ) ).

tff(addAssignment_78915,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,5)
    <=> v2363(VarCurr,5) ) ).

tff(addAssignment_78914,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,5)
    <=> v5116(VarCurr,5) ) ).

tff(addAssignment_78913,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,5)
    <=> v5057(VarCurr,5) ) ).

tff(addAssignment_78912,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,5)
    <=> v5059(VarCurr,5) ) ).

tff(addAssignment_78911,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,5)
    <=> v141527(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141528(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141527(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1997,axiom,
    ! [VarNext: state_type] :
      ( v141528(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141527(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141528(VarNext)
      <=> v141529(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141529(VarNext)
      <=> ( v141531(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141531(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78910,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,5)
    <=> v5071(VarCurr,5) ) ).

tff(addAssignment_78909,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,5)
    <=> v5085(VarCurr,5) ) ).

tff(addAssignment_78908,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,5)
    <=> v5075(VarCurr,5) ) ).

tff(addAssignment_78907,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,5)
    <=> v5077(VarCurr,5) ) ).

tff(addAssignment_78906,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,4)
    <=> v5045(VarCurr,4) ) ).

tff(addAssignment_78905,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,4)
    <=> v5047(VarCurr,4) ) ).

tff(addAssignment_78904,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,4)
    <=> v141459(VarCurr,4) ) ).

tff(addAssignment_78903,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,4)
    <=> v141390(VarCurr,4) ) ).

tff(addAssignment_78902,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,4)
    <=> v141458(VarCurr,4) ) ).

tff(addAssignment_78901,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,4)
    <=> v141394(VarCurr,4) ) ).

tff(addAssignment_78900,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,4)
    <=> v141396(VarCurr,4) ) ).

tff(addAssignment_78899,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,4)
    <=> v141519(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141520(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141519(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1996,axiom,
    ! [VarNext: state_type] :
      ( v141520(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141519(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141520(VarNext)
      <=> v141521(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141521(VarNext)
      <=> ( v141523(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141523(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78898,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,4)
    <=> v141410(VarCurr,4) ) ).

tff(addAssignment_78897,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,4)
    <=> v141428(VarCurr,4) ) ).

tff(addAssignment_78896,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,4)
    <=> v141414(VarCurr,4) ) ).

tff(addAssignment_78895,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,4)
    <=> v141416(VarCurr,4) ) ).

tff(addAssignment_78894,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,4)
    <=> v2363(VarCurr,4) ) ).

tff(addAssignment_78893,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,4)
    <=> v5116(VarCurr,4) ) ).

tff(addAssignment_78892,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,4)
    <=> v5057(VarCurr,4) ) ).

tff(addAssignment_78891,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,4)
    <=> v5059(VarCurr,4) ) ).

tff(addAssignment_78890,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,4)
    <=> v141511(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141512(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141511(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1995,axiom,
    ! [VarNext: state_type] :
      ( v141512(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141511(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141512(VarNext)
      <=> v141513(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141513(VarNext)
      <=> ( v141515(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141515(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78889,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,4)
    <=> v5071(VarCurr,4) ) ).

tff(addAssignment_78888,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,4)
    <=> v5085(VarCurr,4) ) ).

tff(addAssignment_78887,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,4)
    <=> v5075(VarCurr,4) ) ).

tff(addAssignment_78886,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,4)
    <=> v5077(VarCurr,4) ) ).

tff(addAssignment_78885,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,3)
    <=> v5045(VarCurr,3) ) ).

tff(addAssignment_78884,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,3)
    <=> v5047(VarCurr,3) ) ).

tff(addAssignment_78883,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,3)
    <=> v141459(VarCurr,3) ) ).

tff(addAssignment_78882,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,3)
    <=> v141390(VarCurr,3) ) ).

tff(addAssignment_78881,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,3)
    <=> v141458(VarCurr,3) ) ).

tff(addAssignment_78880,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,3)
    <=> v141394(VarCurr,3) ) ).

tff(addAssignment_78879,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,3)
    <=> v141396(VarCurr,3) ) ).

tff(addAssignment_78878,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,3)
    <=> v141503(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141504(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141503(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1994,axiom,
    ! [VarNext: state_type] :
      ( v141504(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141503(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141504(VarNext)
      <=> v141505(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141505(VarNext)
      <=> ( v141507(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141507(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78877,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,3)
    <=> v141410(VarCurr,3) ) ).

tff(addAssignment_78876,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,3)
    <=> v141428(VarCurr,3) ) ).

tff(addAssignment_78875,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,3)
    <=> v141414(VarCurr,3) ) ).

tff(addAssignment_78874,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,3)
    <=> v141416(VarCurr,3) ) ).

tff(addAssignment_78873,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,3)
    <=> v2363(VarCurr,3) ) ).

tff(addAssignment_78872,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,3)
    <=> v5116(VarCurr,3) ) ).

tff(addAssignment_78871,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,3)
    <=> v5057(VarCurr,3) ) ).

tff(addAssignment_78870,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,3)
    <=> v5059(VarCurr,3) ) ).

tff(addAssignment_78869,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,3)
    <=> v141495(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141496(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141495(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1993,axiom,
    ! [VarNext: state_type] :
      ( v141496(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141495(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141496(VarNext)
      <=> v141497(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141497(VarNext)
      <=> ( v141499(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141499(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78868,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,3)
    <=> v5071(VarCurr,3) ) ).

tff(addAssignment_78867,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,3)
    <=> v5085(VarCurr,3) ) ).

tff(addAssignment_78866,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,3)
    <=> v5075(VarCurr,3) ) ).

tff(addAssignment_78865,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,3)
    <=> v5077(VarCurr,3) ) ).

tff(addAssignment_78864,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,2)
    <=> v5045(VarCurr,2) ) ).

tff(addAssignment_78863,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,2)
    <=> v5047(VarCurr,2) ) ).

tff(addAssignment_78862,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,2)
    <=> v141459(VarCurr,2) ) ).

tff(addAssignment_78861,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,2)
    <=> v141390(VarCurr,2) ) ).

tff(addAssignment_78860,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,2)
    <=> v141458(VarCurr,2) ) ).

tff(addAssignment_78859,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,2)
    <=> v141394(VarCurr,2) ) ).

tff(addAssignment_78858,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,2)
    <=> v141396(VarCurr,2) ) ).

tff(addAssignment_78857,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,2)
    <=> v141487(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141488(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141487(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1992,axiom,
    ! [VarNext: state_type] :
      ( v141488(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141487(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141488(VarNext)
      <=> v141489(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141489(VarNext)
      <=> ( v141491(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141491(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78856,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,2)
    <=> v141410(VarCurr,2) ) ).

tff(addAssignment_78855,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,2)
    <=> v141428(VarCurr,2) ) ).

tff(addAssignment_78854,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,2)
    <=> v141414(VarCurr,2) ) ).

tff(addAssignment_78853,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,2)
    <=> v141416(VarCurr,2) ) ).

tff(addAssignment_78852,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,2)
    <=> v2363(VarCurr,2) ) ).

tff(addAssignment_78851,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,2)
    <=> v5116(VarCurr,2) ) ).

tff(addAssignment_78850,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,2)
    <=> v5057(VarCurr,2) ) ).

tff(addAssignment_78849,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,2)
    <=> v5059(VarCurr,2) ) ).

tff(addAssignment_78848,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,2)
    <=> v141479(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141480(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141479(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1991,axiom,
    ! [VarNext: state_type] :
      ( v141480(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141479(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141480(VarNext)
      <=> v141481(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141481(VarNext)
      <=> ( v141483(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141483(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78847,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,2)
    <=> v5071(VarCurr,2) ) ).

tff(addAssignment_78846,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,2)
    <=> v5085(VarCurr,2) ) ).

tff(addAssignment_78845,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,2)
    <=> v5075(VarCurr,2) ) ).

tff(addAssignment_78844,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,2)
    <=> v5077(VarCurr,2) ) ).

tff(addAssignment_78843,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,1)
    <=> v5045(VarCurr,1) ) ).

tff(addAssignment_78842,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,1)
    <=> v5047(VarCurr,1) ) ).

tff(addAssignment_78841,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,1)
    <=> v141459(VarCurr,1) ) ).

tff(addAssignment_78840,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,1)
    <=> v141390(VarCurr,1) ) ).

tff(addAssignment_78839,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,1)
    <=> v141458(VarCurr,1) ) ).

tff(addAssignment_78838,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,1)
    <=> v141394(VarCurr,1) ) ).

tff(addAssignment_78837,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,1)
    <=> v141396(VarCurr,1) ) ).

tff(addAssignment_78836,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,1)
    <=> v141471(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141472(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141471(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1990,axiom,
    ! [VarNext: state_type] :
      ( v141472(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141471(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141472(VarNext)
      <=> v141473(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141473(VarNext)
      <=> ( v141475(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141475(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78835,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,1)
    <=> v141410(VarCurr,1) ) ).

tff(addAssignment_78834,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,1)
    <=> v141428(VarCurr,1) ) ).

tff(addAssignment_78833,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,1)
    <=> v141414(VarCurr,1) ) ).

tff(addAssignment_78832,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,1)
    <=> v141416(VarCurr,1) ) ).

tff(addAssignment_78831,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,1)
    <=> v2363(VarCurr,1) ) ).

tff(addAssignment_78830,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,1)
    <=> v5116(VarCurr,1) ) ).

tff(addAssignment_78829,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,1)
    <=> v5057(VarCurr,1) ) ).

tff(addAssignment_78828,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,1)
    <=> v5059(VarCurr,1) ) ).

tff(addAssignment_78827,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,1)
    <=> v141463(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141464(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141463(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1989,axiom,
    ! [VarNext: state_type] :
      ( v141464(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141463(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141464(VarNext)
      <=> v141465(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141465(VarNext)
      <=> ( v141467(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141467(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78826,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,1)
    <=> v5071(VarCurr,1) ) ).

tff(addAssignment_78825,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,1)
    <=> v5085(VarCurr,1) ) ).

tff(addAssignment_78824,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,1)
    <=> v5075(VarCurr,1) ) ).

tff(addAssignment_78823,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,1)
    <=> v5077(VarCurr,1) ) ).

tff(addAssignment_78822,axiom,
    ! [VarCurr: state_type] :
      ( v5043(VarCurr,0)
    <=> v5045(VarCurr,0) ) ).

tff(addAssignment_78821,axiom,
    ! [VarCurr: state_type] :
      ( v5045(VarCurr,0)
    <=> v5047(VarCurr,0) ) ).

tff(addAssignment_78820,axiom,
    ! [VarCurr: state_type] :
      ( v5047(VarCurr,0)
    <=> v141459(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141460(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141459(VarCurr,B)
          <=> v141388(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1512,axiom,
    ! [VarCurr: state_type] :
      ( v141460(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141459(VarCurr,B)
          <=> v5053(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18955,axiom,
    ! [VarCurr: state_type] :
      ( v141460(VarCurr)
    <=> ( v5049(VarCurr)
        & v141461(VarCurr) ) ) ).

tff(writeUnaryOperator_10770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141461(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(addAssignment_78819,axiom,
    ! [VarCurr: state_type] :
      ( v141388(VarCurr,0)
    <=> v141390(VarCurr,0) ) ).

tff(addAssignment_78818,axiom,
    ! [VarCurr: state_type] :
      ( v141390(VarCurr,0)
    <=> v141458(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141458(VarCurr,B)
      <=> ( v141392(VarCurr,B)
        <~> b101010(B) ) ) ) ).

tff(addAssignment_78817,axiom,
    ! [VarCurr: state_type] :
      ( v141392(VarCurr,0)
    <=> v141394(VarCurr,0) ) ).

tff(addAssignment_78816,axiom,
    ! [VarCurr: state_type] :
      ( v141394(VarCurr,0)
    <=> v141396(VarCurr,0) ) ).

tff(addAssignment_78815,axiom,
    ! [VarNext: state_type] :
      ( v141396(VarNext,0)
    <=> v141441(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141442(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141441(VarNext,B)
            <=> v141396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1988,axiom,
    ! [VarNext: state_type] :
      ( v141442(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141441(VarNext,B)
          <=> v141452(VarNext,B) ) ) ) ).

tff(addAssignment_78814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141452(VarNext,B)
          <=> v141450(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141453(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141450(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1511,axiom,
    ! [VarCurr: state_type] :
      ( v141453(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141450(VarCurr,B)
          <=> v141408(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18954,axiom,
    ! [VarCurr: state_type] :
      ( v141453(VarCurr)
    <=> ( v141454(VarCurr)
        & v141455(VarCurr) ) ) ).

tff(writeUnaryOperator_10769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141455(VarCurr)
    <=> v141404(VarCurr) ) ).

tff(writeUnaryOperator_10768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141454(VarCurr)
    <=> v141398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141442(VarNext)
      <=> v141443(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141443(VarNext)
      <=> ( v141444(VarNext)
          & v141437(VarNext) ) ) ) ).

tff(writeUnaryOperator_10767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141444(VarNext)
      <=> v141446(VarNext) ) ) ).

tff(addAssignment_78813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141446(VarNext)
      <=> v141437(VarCurr) ) ) ).

tff(addAssignment_78812,axiom,
    ! [VarCurr: state_type] :
      ( v141437(VarCurr)
    <=> v141439(VarCurr) ) ).

tff(addAssignment_78811,axiom,
    ! [VarCurr: state_type] :
      ( v141439(VarCurr)
    <=> v4435(VarCurr) ) ).

tff(addAssignment_78810,axiom,
    ! [VarCurr: state_type] :
      ( v141408(VarCurr,0)
    <=> v141410(VarCurr,0) ) ).

tff(addAssignment_78809,axiom,
    ! [VarCurr: state_type] :
      ( v141410(VarCurr,0)
    <=> v141428(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141428(VarCurr,B)
      <=> ( v141429(VarCurr,B)
          | v141432(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141432(VarCurr,B)
      <=> ( v141394(VarCurr,B)
          & v141433(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141433(VarCurr,B)
      <=> ~ v141434(VarCurr,B) ) ) ).

tff(addAssignment_78808,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,0)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78807,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,1)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78806,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,2)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78805,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,3)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78804,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,4)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78803,axiom,
    ! [VarCurr: state_type] :
      ( v141434(VarCurr,5)
    <=> v141435(VarCurr) ) ).

tff(addAssignment_78802,axiom,
    ! [VarCurr: state_type] :
      ( v141435(VarCurr)
    <=> v141418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141429(VarCurr,B)
      <=> ( v141412(VarCurr,B)
          & v141430(VarCurr,B) ) ) ) ).

tff(addAssignment_78801,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,0)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78800,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,1)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78799,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,2)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78798,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,3)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78797,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,4)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78796,axiom,
    ! [VarCurr: state_type] :
      ( v141430(VarCurr,5)
    <=> v141431(VarCurr) ) ).

tff(addAssignment_78795,axiom,
    ! [VarCurr: state_type] :
      ( v141431(VarCurr)
    <=> v141418(VarCurr) ) ).

tff(addAssignment_78794,axiom,
    ! [VarCurr: state_type] :
      ( v141418(VarCurr)
    <=> v141420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18951,axiom,
    ! [VarCurr: state_type] :
      ( v141420(VarCurr)
    <=> ( v141422(VarCurr)
        & v141427(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2106,axiom,
    ! [VarCurr: state_type] :
      ( v141427(VarCurr)
    <=> ( ( v141424(VarCurr,12)
        <=> $false )
        & ( v141424(VarCurr,11)
        <=> $true )
        & ( v141424(VarCurr,10)
        <=> $false )
        & ( v141424(VarCurr,9)
        <=> $false )
        & ( v141424(VarCurr,8)
        <=> $false )
        & ( v141424(VarCurr,7)
        <=> $true )
        & ( v141424(VarCurr,6)
        <=> $false )
        & ( v141424(VarCurr,5)
        <=> $true )
        & ( v141424(VarCurr,4)
        <=> $true )
        & ( v141424(VarCurr,3)
        <=> $false )
        & ( v141424(VarCurr,2)
        <=> $false )
        & ( v141424(VarCurr,1)
        <=> $false )
        & ( v141424(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_2017,axiom,
    ~ b0100010110000(12) ).

tff(bitBlastConstant_2016,axiom,
    b0100010110000(11) ).

tff(bitBlastConstant_2015,axiom,
    ~ b0100010110000(10) ).

tff(bitBlastConstant_2014,axiom,
    ~ b0100010110000(9) ).

tff(bitBlastConstant_2013,axiom,
    ~ b0100010110000(8) ).

tff(bitBlastConstant_2012,axiom,
    b0100010110000(7) ).

tff(bitBlastConstant_2011,axiom,
    ~ b0100010110000(6) ).

tff(bitBlastConstant_2010,axiom,
    b0100010110000(5) ).

tff(bitBlastConstant_2009,axiom,
    b0100010110000(4) ).

tff(bitBlastConstant_2008,axiom,
    ~ b0100010110000(3) ).

tff(bitBlastConstant_2007,axiom,
    ~ b0100010110000(2) ).

tff(bitBlastConstant_2006,axiom,
    ~ b0100010110000(1) ).

tff(bitBlastConstant_2005,axiom,
    ~ b0100010110000(0) ).

tff(addAssignment_78793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v141424(VarCurr,B)
      <=> v2358(VarCurr,B) ) ) ).

tff(addAssignment_78792,axiom,
    ! [VarCurr: state_type] :
      ( v141422(VarCurr)
    <=> v2354(VarCurr) ) ).

tff(addAssignment_78791,axiom,
    ! [VarCurr: state_type] :
      ( v141412(VarCurr,0)
    <=> v141414(VarCurr,0) ) ).

tff(addAssignment_78790,axiom,
    ! [VarCurr: state_type] :
      ( v141414(VarCurr,0)
    <=> v141416(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v141416(VarCurr,B)
      <=> ( v4408(VarCurr,B)
        <~> b101010(B) ) ) ) ).

tff(bitBlastConstant_2004,axiom,
    b101010(5) ).

tff(bitBlastConstant_2003,axiom,
    ~ b101010(4) ).

tff(bitBlastConstant_2002,axiom,
    b101010(3) ).

tff(bitBlastConstant_2001,axiom,
    ~ b101010(2) ).

tff(bitBlastConstant_2000,axiom,
    b101010(1) ).

tff(bitBlastConstant_1999,axiom,
    ~ b101010(0) ).

tff(addAssignment_78789,axiom,
    ! [VarCurr: state_type] :
      ( v141404(VarCurr)
    <=> v141406(VarCurr) ) ).

tff(addAssignment_78788,axiom,
    ! [VarCurr: state_type] :
      ( v141406(VarCurr)
    <=> v4370(VarCurr) ) ).

tff(addAssignment_78787,axiom,
    ! [VarCurr: state_type] :
      ( v141398(VarCurr)
    <=> v141400(VarCurr) ) ).

tff(addAssignment_78786,axiom,
    ! [VarCurr: state_type] :
      ( v141400(VarCurr)
    <=> v141402(VarCurr) ) ).

tff(addAssignment_78785,axiom,
    ! [VarCurr: state_type] :
      ( v141402(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_78784,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,0)
    <=> v5116(VarCurr,0) ) ).

tff(addAssignment_78783,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,0)
    <=> v5057(VarCurr,0) ) ).

tff(addAssignment_78782,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,0)
    <=> v5059(VarCurr,0) ) ).

tff(addAssignment_78781,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,0)
    <=> v141380(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141381(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v141380(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1987,axiom,
    ! [VarNext: state_type] :
      ( v141381(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v141380(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141381(VarNext)
      <=> v141382(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141382(VarNext)
      <=> ( v141384(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_10765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141384(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_78780,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,0)
    <=> v5071(VarCurr,0) ) ).

tff(addAssignment_78779,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,0)
    <=> v5085(VarCurr,0) ) ).

tff(addAssignment_78778,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,0)
    <=> v5075(VarCurr,0) ) ).

tff(addAssignment_78777,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,0)
    <=> v5077(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18948,axiom,
    ! [VarCurr: state_type] :
      ( v5049(VarCurr)
    <=> ( v5051(VarCurr)
        & v5118(VarCurr) ) ) ).

tff(addAssignment_78776,axiom,
    ! [VarCurr: state_type] :
      ( v5118(VarCurr)
    <=> v5120(VarCurr,1) ) ).

tff(addAssignment_78775,axiom,
    ! [VarCurr: state_type] :
      ( v5120(VarCurr,1)
    <=> v5122(VarCurr,1) ) ).

tff(addAssignment_78774,axiom,
    ! [VarNext: state_type] :
      ( v5122(VarNext,1)
    <=> v141371(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141372(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v141371(VarNext,B)
            <=> v5122(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1986,axiom,
    ! [VarNext: state_type] :
      ( v141372(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v141371(VarNext,B)
          <=> v128519(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141372(VarNext)
      <=> v141373(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141373(VarNext)
      <=> ( v141375(VarNext)
          & v128504(VarNext) ) ) ) ).

tff(writeUnaryOperator_10764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141375(VarNext)
      <=> v128513(VarNext) ) ) ).

tff(addAssignment_78773,axiom,
    ! [VarCurr: state_type] :
      ( v5132(VarCurr,1)
    <=> v5134(VarCurr,1) ) ).

tff(addAssignment_78772,axiom,
    ! [VarCurr: state_type] :
      ( v5134(VarCurr,1)
    <=> v5136(VarCurr,1) ) ).

tff(addAssignment_78771,axiom,
    ! [VarCurr: state_type] :
      ( v5136(VarCurr,1)
    <=> v128502(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18945,axiom,
    ! [VarCurr: state_type] :
      ( v5138(VarCurr)
    <=> ( v5140(VarCurr)
        & v141361(VarCurr) ) ) ).

tff(addAssignment_78770,axiom,
    ! [VarCurr: state_type] :
      ( v141361(VarCurr)
    <=> v141363(VarCurr) ) ).

tff(addAssignment_78769,axiom,
    ! [VarCurr: state_type] :
      ( v141363(VarCurr)
    <=> v141365(VarCurr) ) ).

tff(addAssignment_78768,axiom,
    ! [VarCurr: state_type] :
      ( v141365(VarCurr)
    <=> v141367(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2105,axiom,
    ! [VarCurr: state_type] :
      ( v141367(VarCurr)
    <=> ( ( v968(VarCurr,4)
        <=> v83042(VarCurr,4) )
        & ( v968(VarCurr,3)
        <=> v83042(VarCurr,3) )
        & ( v968(VarCurr,2)
        <=> v83042(VarCurr,2) )
        & ( v968(VarCurr,1)
        <=> v83042(VarCurr,1) )
        & ( v968(VarCurr,0)
        <=> v83042(VarCurr,0) ) ) ) ).

tff(addAssignment_78767,axiom,
    ! [VarCurr: state_type] :
      ( v5140(VarCurr)
    <=> v5142(VarCurr) ) ).

tff(addAssignment_78766,axiom,
    ! [VarCurr: state_type] :
      ( v5142(VarCurr)
    <=> v5144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18944,axiom,
    ! [VarCurr: state_type] :
      ( v5144(VarCurr)
    <=> ( v141355(VarCurr)
        & v141358(VarCurr) ) ) ).

tff(writeUnaryOperator_10763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141358(VarCurr)
    <=> v141359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18943,axiom,
    ! [VarCurr: state_type] :
      ( v141359(VarCurr)
    <=> ( v86885(VarCurr)
        | v135825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18942,axiom,
    ! [VarCurr: state_type] :
      ( v141355(VarCurr)
    <=> ( v141356(VarCurr)
        & v109663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18941,axiom,
    ! [VarCurr: state_type] :
      ( v141356(VarCurr)
    <=> ( v141357(VarCurr)
        & v141351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18940,axiom,
    ! [VarCurr: state_type] :
      ( v141357(VarCurr)
    <=> ( v5146(VarCurr)
        & v141322(VarCurr) ) ) ).

tff(addAssignment_78765,axiom,
    ! [VarCurr: state_type] :
      ( v141351(VarCurr)
    <=> v141353(VarCurr) ) ).

tff(addAssignment_78764,axiom,
    ! [VarCurr: state_type] :
      ( v141353(VarCurr)
    <=> v101225(VarCurr) ) ).

tff(addAssignment_78763,axiom,
    ! [VarCurr: state_type] :
      ( v141322(VarCurr)
    <=> v141324(VarCurr) ) ).

tff(addAssignment_78762,axiom,
    ! [VarCurr: state_type] :
      ( v141324(VarCurr)
    <=> v141326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18939,axiom,
    ! [VarCurr: state_type] :
      ( v141326(VarCurr)
    <=> ( v141328(VarCurr)
        & v141339(VarCurr) ) ) ).

tff(writeUnaryOperator_10762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141339(VarCurr)
    <=> v141341(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6871,axiom,
    ! [VarCurr: state_type] :
      ( v141341(VarCurr)
    <=> ( v141343(VarCurr)
        | v743(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6870,axiom,
    ! [VarCurr: state_type] :
      ( v141343(VarCurr)
    <=> ( v141344(VarCurr)
        | v743(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6869,axiom,
    ! [VarCurr: state_type] :
      ( v141344(VarCurr)
    <=> ( v141345(VarCurr)
        | v743(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6868,axiom,
    ! [VarCurr: state_type] :
      ( v141345(VarCurr)
    <=> ( v141346(VarCurr)
        | v743(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6867,axiom,
    ! [VarCurr: state_type] :
      ( v141346(VarCurr)
    <=> ( v141347(VarCurr)
        | v743(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6866,axiom,
    ! [VarCurr: state_type] :
      ( v141347(VarCurr)
    <=> ( v141348(VarCurr)
        | v743(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6865,axiom,
    ! [VarCurr: state_type] :
      ( v141348(VarCurr)
    <=> ( v743(VarCurr,0)
        | v743(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141328(VarCurr)
    <=> v141330(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6864,axiom,
    ! [VarCurr: state_type] :
      ( v141330(VarCurr)
    <=> ( v141332(VarCurr)
        | v89419(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6863,axiom,
    ! [VarCurr: state_type] :
      ( v141332(VarCurr)
    <=> ( v141333(VarCurr)
        | v89419(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6862,axiom,
    ! [VarCurr: state_type] :
      ( v141333(VarCurr)
    <=> ( v141334(VarCurr)
        | v89419(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6861,axiom,
    ! [VarCurr: state_type] :
      ( v141334(VarCurr)
    <=> ( v141335(VarCurr)
        | v89419(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6860,axiom,
    ! [VarCurr: state_type] :
      ( v141335(VarCurr)
    <=> ( v141336(VarCurr)
        | v89419(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6859,axiom,
    ! [VarCurr: state_type] :
      ( v141336(VarCurr)
    <=> ( v141337(VarCurr)
        | v89419(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6858,axiom,
    ! [VarCurr: state_type] :
      ( v141337(VarCurr)
    <=> ( v89419(VarCurr,0)
        | v89419(VarCurr,1) ) ) ).

tff(addAssignment_78761,axiom,
    ! [VarCurr: state_type] :
      ( v5146(VarCurr)
    <=> v5148(VarCurr) ) ).

tff(addAssignment_78760,axiom,
    ! [VarCurr: state_type] :
      ( v5148(VarCurr)
    <=> v5150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18938,axiom,
    ! [VarCurr: state_type] :
      ( v5150(VarCurr)
    <=> ( v5152(VarCurr)
        & v5163(VarCurr) ) ) ).

tff(writeUnaryOperator_10760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5163(VarCurr)
    <=> v141312(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6857,axiom,
    ! [VarCurr: state_type] :
      ( v141312(VarCurr)
    <=> ( v141314(VarCurr)
        | v5165(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6856,axiom,
    ! [VarCurr: state_type] :
      ( v141314(VarCurr)
    <=> ( v141315(VarCurr)
        | v5165(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6855,axiom,
    ! [VarCurr: state_type] :
      ( v141315(VarCurr)
    <=> ( v141316(VarCurr)
        | v5165(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6854,axiom,
    ! [VarCurr: state_type] :
      ( v141316(VarCurr)
    <=> ( v141317(VarCurr)
        | v5165(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6853,axiom,
    ! [VarCurr: state_type] :
      ( v141317(VarCurr)
    <=> ( v141318(VarCurr)
        | v5165(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6852,axiom,
    ! [VarCurr: state_type] :
      ( v141318(VarCurr)
    <=> ( v141319(VarCurr)
        | v5165(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6851,axiom,
    ! [VarCurr: state_type] :
      ( v141319(VarCurr)
    <=> ( v5165(VarCurr,0)
        | v5165(VarCurr,1) ) ) ).

tff(addAssignment_78759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v5165(VarCurr,B)
      <=> v5167(VarCurr,B) ) ) ).

tff(addAssignment_78758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v5167(VarCurr,B)
      <=> v5169(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1985,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141295(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v5169(VarNext,B)
            <=> v5169(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1985,axiom,
    ! [VarNext: state_type] :
      ( v141295(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v5169(VarNext,B)
          <=> v141305(VarNext,B) ) ) ) ).

tff(addAssignment_78757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v141305(VarNext,B)
          <=> v141303(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141306(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v141303(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1510,axiom,
    ! [VarCurr: state_type] :
      ( v141306(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v141303(VarCurr,B)
          <=> v5179(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18937,axiom,
    ! [VarCurr: state_type] :
      ( v141306(VarCurr)
    <=> ( v141307(VarCurr)
        & v141308(VarCurr) ) ) ).

tff(writeUnaryOperator_10759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141308(VarCurr)
    <=> v5175(VarCurr) ) ).

tff(writeUnaryOperator_10758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141307(VarCurr)
    <=> v5171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141295(VarNext)
      <=> v141296(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141296(VarNext)
      <=> ( v141297(VarNext)
          & v141290(VarNext) ) ) ) ).

tff(writeUnaryOperator_10757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141297(VarNext)
      <=> v141299(VarNext) ) ) ).

tff(addAssignment_78756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141299(VarNext)
      <=> v141290(VarCurr) ) ) ).

tff(addAssignment_78755,axiom,
    ! [VarCurr: state_type] :
      ( v141290(VarCurr)
    <=> v141292(VarCurr) ) ).

tff(addAssignment_78754,axiom,
    ! [VarCurr: state_type] :
      ( v141292(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_78753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v5179(VarCurr,B)
      <=> v5181(VarCurr,B) ) ) ).

tff(addAssignment_78752,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v5181(VarCurr,B)
      <=> v5183(VarCurr,B) ) ) ).

tff(addAssignment_78751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v5183(VarCurr,B)
      <=> v5185(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141260(VarCurr)
     => ( v5185(VarCurr,7)
      <=> v141288(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_163,axiom,
    ! [VarCurr: state_type] :
      ( v141260(VarCurr)
     => ( v5185(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,7)
     => ( v141288(VarCurr)
      <=> v5165(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1509,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,7)
     => ( v141288(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141246(VarCurr)
     => ( v5185(VarCurr,6)
      <=> v141286(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_162,axiom,
    ! [VarCurr: state_type] :
      ( v141246(VarCurr)
     => ( v5185(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,6)
     => ( v141286(VarCurr)
      <=> v5165(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1508,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,6)
     => ( v141286(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141232(VarCurr)
     => ( v5185(VarCurr,5)
      <=> v141284(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_161,axiom,
    ! [VarCurr: state_type] :
      ( v141232(VarCurr)
     => ( v5185(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,5)
     => ( v141284(VarCurr)
      <=> v5165(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1507,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,5)
     => ( v141284(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141218(VarCurr)
     => ( v5185(VarCurr,4)
      <=> v141282(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_160,axiom,
    ! [VarCurr: state_type] :
      ( v141218(VarCurr)
     => ( v5185(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,4)
     => ( v141282(VarCurr)
      <=> v5165(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1506,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,4)
     => ( v141282(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141204(VarCurr)
     => ( v5185(VarCurr,3)
      <=> v141280(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_159,axiom,
    ! [VarCurr: state_type] :
      ( v141204(VarCurr)
     => ( v5185(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,3)
     => ( v141280(VarCurr)
      <=> v5165(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1505,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,3)
     => ( v141280(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141190(VarCurr)
     => ( v5185(VarCurr,2)
      <=> v141278(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_158,axiom,
    ! [VarCurr: state_type] :
      ( v141190(VarCurr)
     => ( v5185(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,2)
     => ( v141278(VarCurr)
      <=> v5165(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1504,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,2)
     => ( v141278(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141177(VarCurr)
     => ( v5185(VarCurr,1)
      <=> v141276(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_157,axiom,
    ! [VarCurr: state_type] :
      ( v141177(VarCurr)
     => ( v5185(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,1)
     => ( v141276(VarCurr)
      <=> v5165(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1503,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,1)
     => ( v141276(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5187(VarCurr)
     => ( v5185(VarCurr,0)
      <=> v141274(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1502,axiom,
    ! [VarCurr: state_type] :
      ( v5187(VarCurr)
     => ( v5185(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5210(VarCurr,0)
     => ( v141274(VarCurr)
      <=> v5165(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1501,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,0)
     => ( v141274(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_78750,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,7)
    <=> v141175(VarCurr,7) ) ).

tff(addAssignment_78749,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,7)
    <=> v141164(VarCurr,7) ) ).

tff(addAssignment_78748,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,7)
    <=> v141166(VarCurr,7) ) ).

tff(addAssignment_78747,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,7)
    <=> v141168(VarCurr,7) ) ).

tff(addAssignment_78746,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,7)
    <=> v141170(VarCurr,7) ) ).

tff(addAssignment_78745,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,7)
    <=> v141172(VarCurr,15) ) ).

tff(addAssignment_78744,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,15)
    <=> v141174(VarCurr,15) ) ).

tff(addAssignment_78743,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,7)
    <=> v5214(VarCurr,7) ) ).

tff(addAssignment_78742,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,7)
    <=> v5216(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_6850,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,7)
    <=> ( v141266(VarCurr)
        & v141272(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2104,axiom,
    ! [VarCurr: state_type] :
      ( v141272(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18934,axiom,
    ! [VarCurr: state_type] :
      ( v141266(VarCurr)
    <=> ( v141267(VarCurr)
        & v141271(VarCurr) ) ) ).

tff(writeUnaryOperator_10756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141271(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18933,axiom,
    ! [VarCurr: state_type] :
      ( v141267(VarCurr)
    <=> ( v141268(VarCurr)
        & v141270(VarCurr) ) ) ).

tff(writeUnaryOperator_10755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141270(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18932,axiom,
    ! [VarCurr: state_type] :
      ( v141268(VarCurr)
    <=> ( v777(VarCurr)
        & v141269(VarCurr) ) ) ).

tff(writeUnaryOperator_10754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141269(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18931,axiom,
    ! [VarCurr: state_type] :
      ( v141260(VarCurr)
    <=> ( v141262(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18930,axiom,
    ! [VarCurr: state_type] :
      ( v141262(VarCurr)
    <=> ( v141263(VarCurr)
        & v141264(VarCurr) ) ) ).

tff(addAssignment_78741,axiom,
    ! [VarCurr: state_type] :
      ( v141264(VarCurr)
    <=> v84944(VarCurr) ) ).

tff(writeUnaryOperator_10753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141263(VarCurr)
    <=> v5165(VarCurr,7) ) ).

tff(addAssignment_78740,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,6)
    <=> v141175(VarCurr,6) ) ).

tff(addAssignment_78739,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,6)
    <=> v141164(VarCurr,6) ) ).

tff(addAssignment_78738,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,6)
    <=> v141166(VarCurr,6) ) ).

tff(addAssignment_78737,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,6)
    <=> v141168(VarCurr,6) ) ).

tff(addAssignment_78736,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,6)
    <=> v141170(VarCurr,6) ) ).

tff(addAssignment_78735,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,6)
    <=> v141172(VarCurr,14) ) ).

tff(addAssignment_78734,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,14)
    <=> v141174(VarCurr,14) ) ).

tff(addAssignment_78733,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,6)
    <=> v5214(VarCurr,6) ) ).

tff(addAssignment_78732,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,6)
    <=> v5216(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_6849,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,6)
    <=> ( v141252(VarCurr)
        & v141258(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2103,axiom,
    ! [VarCurr: state_type] :
      ( v141258(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18929,axiom,
    ! [VarCurr: state_type] :
      ( v141252(VarCurr)
    <=> ( v141253(VarCurr)
        & v141257(VarCurr) ) ) ).

tff(writeUnaryOperator_10752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141257(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18928,axiom,
    ! [VarCurr: state_type] :
      ( v141253(VarCurr)
    <=> ( v141254(VarCurr)
        & v141256(VarCurr) ) ) ).

tff(writeUnaryOperator_10751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141256(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18927,axiom,
    ! [VarCurr: state_type] :
      ( v141254(VarCurr)
    <=> ( v777(VarCurr)
        & v141255(VarCurr) ) ) ).

tff(writeUnaryOperator_10750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141255(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18926,axiom,
    ! [VarCurr: state_type] :
      ( v141246(VarCurr)
    <=> ( v141248(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18925,axiom,
    ! [VarCurr: state_type] :
      ( v141248(VarCurr)
    <=> ( v141249(VarCurr)
        & v141250(VarCurr) ) ) ).

tff(addAssignment_78731,axiom,
    ! [VarCurr: state_type] :
      ( v141250(VarCurr)
    <=> v84945(VarCurr) ) ).

tff(writeUnaryOperator_10749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141249(VarCurr)
    <=> v5165(VarCurr,6) ) ).

tff(addAssignment_78730,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,5)
    <=> v141175(VarCurr,5) ) ).

tff(addAssignment_78729,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,5)
    <=> v141164(VarCurr,5) ) ).

tff(addAssignment_78728,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,5)
    <=> v141166(VarCurr,5) ) ).

tff(addAssignment_78727,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,5)
    <=> v141168(VarCurr,5) ) ).

tff(addAssignment_78726,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,5)
    <=> v141170(VarCurr,5) ) ).

tff(addAssignment_78725,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,5)
    <=> v141172(VarCurr,13) ) ).

tff(addAssignment_78724,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,13)
    <=> v141174(VarCurr,13) ) ).

tff(addAssignment_78723,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,5)
    <=> v5214(VarCurr,5) ) ).

tff(addAssignment_78722,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,5)
    <=> v5216(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6848,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,5)
    <=> ( v141238(VarCurr)
        & v141244(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2102,axiom,
    ! [VarCurr: state_type] :
      ( v141244(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18924,axiom,
    ! [VarCurr: state_type] :
      ( v141238(VarCurr)
    <=> ( v141239(VarCurr)
        & v141243(VarCurr) ) ) ).

tff(writeUnaryOperator_10748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141243(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18923,axiom,
    ! [VarCurr: state_type] :
      ( v141239(VarCurr)
    <=> ( v141240(VarCurr)
        & v141242(VarCurr) ) ) ).

tff(writeUnaryOperator_10747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141242(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18922,axiom,
    ! [VarCurr: state_type] :
      ( v141240(VarCurr)
    <=> ( v777(VarCurr)
        & v141241(VarCurr) ) ) ).

tff(writeUnaryOperator_10746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141241(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18921,axiom,
    ! [VarCurr: state_type] :
      ( v141232(VarCurr)
    <=> ( v141234(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18920,axiom,
    ! [VarCurr: state_type] :
      ( v141234(VarCurr)
    <=> ( v141235(VarCurr)
        & v141236(VarCurr) ) ) ).

tff(addAssignment_78721,axiom,
    ! [VarCurr: state_type] :
      ( v141236(VarCurr)
    <=> v84946(VarCurr) ) ).

tff(writeUnaryOperator_10745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141235(VarCurr)
    <=> v5165(VarCurr,5) ) ).

tff(addAssignment_78720,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,4)
    <=> v141175(VarCurr,4) ) ).

tff(addAssignment_78719,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,4)
    <=> v141164(VarCurr,4) ) ).

tff(addAssignment_78718,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,4)
    <=> v141166(VarCurr,4) ) ).

tff(addAssignment_78717,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,4)
    <=> v141168(VarCurr,4) ) ).

tff(addAssignment_78716,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,4)
    <=> v141170(VarCurr,4) ) ).

tff(addAssignment_78715,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,4)
    <=> v141172(VarCurr,12) ) ).

tff(addAssignment_78714,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,12)
    <=> v141174(VarCurr,12) ) ).

tff(addAssignment_78713,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,4)
    <=> v5214(VarCurr,4) ) ).

tff(addAssignment_78712,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,4)
    <=> v5216(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6847,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,4)
    <=> ( v141224(VarCurr)
        & v141230(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2101,axiom,
    ! [VarCurr: state_type] :
      ( v141230(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18919,axiom,
    ! [VarCurr: state_type] :
      ( v141224(VarCurr)
    <=> ( v141225(VarCurr)
        & v141229(VarCurr) ) ) ).

tff(writeUnaryOperator_10744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141229(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18918,axiom,
    ! [VarCurr: state_type] :
      ( v141225(VarCurr)
    <=> ( v141226(VarCurr)
        & v141228(VarCurr) ) ) ).

tff(writeUnaryOperator_10743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141228(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18917,axiom,
    ! [VarCurr: state_type] :
      ( v141226(VarCurr)
    <=> ( v777(VarCurr)
        & v141227(VarCurr) ) ) ).

tff(writeUnaryOperator_10742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141227(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18916,axiom,
    ! [VarCurr: state_type] :
      ( v141218(VarCurr)
    <=> ( v141220(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18915,axiom,
    ! [VarCurr: state_type] :
      ( v141220(VarCurr)
    <=> ( v141221(VarCurr)
        & v141222(VarCurr) ) ) ).

tff(addAssignment_78711,axiom,
    ! [VarCurr: state_type] :
      ( v141222(VarCurr)
    <=> v84947(VarCurr) ) ).

tff(writeUnaryOperator_10741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141221(VarCurr)
    <=> v5165(VarCurr,4) ) ).

tff(addAssignment_78710,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,3)
    <=> v141175(VarCurr,3) ) ).

tff(addAssignment_78709,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,3)
    <=> v141164(VarCurr,3) ) ).

tff(addAssignment_78708,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,3)
    <=> v141166(VarCurr,3) ) ).

tff(addAssignment_78707,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,3)
    <=> v141168(VarCurr,3) ) ).

tff(addAssignment_78706,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,3)
    <=> v141170(VarCurr,3) ) ).

tff(addAssignment_78705,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,3)
    <=> v141172(VarCurr,11) ) ).

tff(addAssignment_78704,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,11)
    <=> v141174(VarCurr,11) ) ).

tff(addAssignment_78703,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,3)
    <=> v5214(VarCurr,3) ) ).

tff(addAssignment_78702,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,3)
    <=> v5216(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6846,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,3)
    <=> ( v141210(VarCurr)
        & v141216(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2100,axiom,
    ! [VarCurr: state_type] :
      ( v141216(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18914,axiom,
    ! [VarCurr: state_type] :
      ( v141210(VarCurr)
    <=> ( v141211(VarCurr)
        & v141215(VarCurr) ) ) ).

tff(writeUnaryOperator_10740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141215(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18913,axiom,
    ! [VarCurr: state_type] :
      ( v141211(VarCurr)
    <=> ( v141212(VarCurr)
        & v141214(VarCurr) ) ) ).

tff(writeUnaryOperator_10739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141214(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18912,axiom,
    ! [VarCurr: state_type] :
      ( v141212(VarCurr)
    <=> ( v777(VarCurr)
        & v141213(VarCurr) ) ) ).

tff(writeUnaryOperator_10738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141213(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18911,axiom,
    ! [VarCurr: state_type] :
      ( v141204(VarCurr)
    <=> ( v141206(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18910,axiom,
    ! [VarCurr: state_type] :
      ( v141206(VarCurr)
    <=> ( v141207(VarCurr)
        & v141208(VarCurr) ) ) ).

tff(addAssignment_78701,axiom,
    ! [VarCurr: state_type] :
      ( v141208(VarCurr)
    <=> v84948(VarCurr) ) ).

tff(writeUnaryOperator_10737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141207(VarCurr)
    <=> v5165(VarCurr,3) ) ).

tff(addAssignment_78700,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,2)
    <=> v141175(VarCurr,2) ) ).

tff(addAssignment_78699,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,2)
    <=> v141164(VarCurr,2) ) ).

tff(addAssignment_78698,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,2)
    <=> v141166(VarCurr,2) ) ).

tff(addAssignment_78697,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,2)
    <=> v141168(VarCurr,2) ) ).

tff(addAssignment_78696,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,2)
    <=> v141170(VarCurr,2) ) ).

tff(addAssignment_78695,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,2)
    <=> v141172(VarCurr,10) ) ).

tff(addAssignment_78694,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,10)
    <=> v141174(VarCurr,10) ) ).

tff(addAssignment_78693,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,2)
    <=> v5214(VarCurr,2) ) ).

tff(addAssignment_78692,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,2)
    <=> v5216(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6845,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,2)
    <=> ( v141196(VarCurr)
        & v141202(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2099,axiom,
    ! [VarCurr: state_type] :
      ( v141202(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18909,axiom,
    ! [VarCurr: state_type] :
      ( v141196(VarCurr)
    <=> ( v141197(VarCurr)
        & v141201(VarCurr) ) ) ).

tff(writeUnaryOperator_10736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141201(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18908,axiom,
    ! [VarCurr: state_type] :
      ( v141197(VarCurr)
    <=> ( v141198(VarCurr)
        & v141200(VarCurr) ) ) ).

tff(writeUnaryOperator_10735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141200(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18907,axiom,
    ! [VarCurr: state_type] :
      ( v141198(VarCurr)
    <=> ( v777(VarCurr)
        & v141199(VarCurr) ) ) ).

tff(writeUnaryOperator_10734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141199(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18906,axiom,
    ! [VarCurr: state_type] :
      ( v141190(VarCurr)
    <=> ( v141192(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18905,axiom,
    ! [VarCurr: state_type] :
      ( v141192(VarCurr)
    <=> ( v141193(VarCurr)
        & v141194(VarCurr) ) ) ).

tff(addAssignment_78691,axiom,
    ! [VarCurr: state_type] :
      ( v141194(VarCurr)
    <=> v84949(VarCurr) ) ).

tff(writeUnaryOperator_10733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141193(VarCurr)
    <=> v5165(VarCurr,2) ) ).

tff(addAssignment_78690,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,1)
    <=> v141175(VarCurr,1) ) ).

tff(addAssignment_78689,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,1)
    <=> v141164(VarCurr,1) ) ).

tff(addAssignment_78688,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,1)
    <=> v141166(VarCurr,1) ) ).

tff(addAssignment_78687,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,1)
    <=> v141168(VarCurr,1) ) ).

tff(addAssignment_78686,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,1)
    <=> v141170(VarCurr,1) ) ).

tff(addAssignment_78685,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,1)
    <=> v141172(VarCurr,9) ) ).

tff(addAssignment_78684,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,9)
    <=> v141174(VarCurr,9) ) ).

tff(addAssignment_78683,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,1)
    <=> v5214(VarCurr,1) ) ).

tff(addAssignment_78682,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,1)
    <=> v5216(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6844,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,1)
    <=> ( v141182(VarCurr)
        & v141188(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2098,axiom,
    ! [VarCurr: state_type] :
      ( v141188(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18904,axiom,
    ! [VarCurr: state_type] :
      ( v141182(VarCurr)
    <=> ( v141183(VarCurr)
        & v141187(VarCurr) ) ) ).

tff(writeUnaryOperator_10732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141187(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18903,axiom,
    ! [VarCurr: state_type] :
      ( v141183(VarCurr)
    <=> ( v141184(VarCurr)
        & v141186(VarCurr) ) ) ).

tff(writeUnaryOperator_10731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141186(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18902,axiom,
    ! [VarCurr: state_type] :
      ( v141184(VarCurr)
    <=> ( v777(VarCurr)
        & v141185(VarCurr) ) ) ).

tff(writeUnaryOperator_10730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141185(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18901,axiom,
    ! [VarCurr: state_type] :
      ( v141177(VarCurr)
    <=> ( v141179(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18900,axiom,
    ! [VarCurr: state_type] :
      ( v141179(VarCurr)
    <=> ( v141180(VarCurr)
        & v5165(VarCurr,0) ) ) ).

tff(writeUnaryOperator_10729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141180(VarCurr)
    <=> v5165(VarCurr,1) ) ).

tff(addAssignment_78681,axiom,
    ! [VarCurr: state_type] :
      ( v5210(VarCurr,0)
    <=> v141175(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v141175(VarCurr,B)
      <=> ( v5212(VarCurr,B)
          | v141162(VarCurr,B) ) ) ) ).

tff(addAssignment_78680,axiom,
    ! [VarCurr: state_type] :
      ( v141162(VarCurr,0)
    <=> v141164(VarCurr,0) ) ).

tff(addAssignment_78679,axiom,
    ! [VarCurr: state_type] :
      ( v141164(VarCurr,0)
    <=> v141166(VarCurr,0) ) ).

tff(addAssignment_78678,axiom,
    ! [VarCurr: state_type] :
      ( v141166(VarCurr,0)
    <=> v141168(VarCurr,0) ) ).

tff(addAssignment_78677,axiom,
    ! [VarCurr: state_type] :
      ( v141168(VarCurr,0)
    <=> v141170(VarCurr,0) ) ).

tff(addAssignment_78676,axiom,
    ! [VarCurr: state_type] :
      ( v141170(VarCurr,0)
    <=> v141172(VarCurr,8) ) ).

tff(addAssignment_78675,axiom,
    ! [VarCurr: state_type] :
      ( v141172(VarCurr,8)
    <=> v141174(VarCurr,8) ) ).

tff(addAssignment_78674,axiom,
    ! [VarCurr: state_type] :
      ( v5212(VarCurr,0)
    <=> v5214(VarCurr,0) ) ).

tff(addAssignment_78673,axiom,
    ! [VarCurr: state_type] :
      ( v5214(VarCurr,0)
    <=> v5216(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18899,axiom,
    ! [VarCurr: state_type] :
      ( v5216(VarCurr,0)
    <=> ( v141154(VarCurr)
        & v141160(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2097,axiom,
    ! [VarCurr: state_type] :
      ( v141160(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18898,axiom,
    ! [VarCurr: state_type] :
      ( v141154(VarCurr)
    <=> ( v141155(VarCurr)
        & v141159(VarCurr) ) ) ).

tff(writeUnaryOperator_10728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141159(VarCurr)
    <=> v779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18897,axiom,
    ! [VarCurr: state_type] :
      ( v141155(VarCurr)
    <=> ( v141156(VarCurr)
        & v141158(VarCurr) ) ) ).

tff(writeUnaryOperator_10727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141158(VarCurr)
    <=> v5414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18896,axiom,
    ! [VarCurr: state_type] :
      ( v141156(VarCurr)
    <=> ( v777(VarCurr)
        & v141157(VarCurr) ) ) ).

tff(writeUnaryOperator_10726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141157(VarCurr)
    <=> v5218(VarCurr) ) ).

tff(addAssignment_78672,axiom,
    ! [VarCurr: state_type] :
      ( v5414(VarCurr)
    <=> v781(VarCurr,5) ) ).

tff(addAssignment_78671,axiom,
    ! [VarCurr: state_type] :
      ( v781(VarCurr,5)
    <=> v783(VarCurr,5) ) ).

tff(addAssignment_78670,axiom,
    ! [VarCurr: state_type] :
      ( v783(VarCurr,5)
    <=> v5329(VarCurr,5) ) ).

tff(addAssignment_78669,axiom,
    ! [VarCurr: state_type] :
      ( v5324(VarCurr,5)
    <=> v5326(VarCurr,5) ) ).

tff(addAssignment_78668,axiom,
    ! [VarCurr: state_type] :
      ( v5326(VarCurr,5)
    <=> v5328(VarCurr,5) ) ).

tff(addAssignment_78667,axiom,
    ! [VarNext: state_type] :
      ( v5328(VarNext,5)
    <=> v141146(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141147(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141146(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1984,axiom,
    ! [VarNext: state_type] :
      ( v141147(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141146(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141147(VarNext)
      <=> v141148(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141148(VarNext)
      <=> ( v141150(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_10725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141150(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_78666,axiom,
    ! [VarCurr: state_type] :
      ( v103020(VarCurr,5)
    <=> v103022(VarCurr,5) ) ).

tff(addAssignment_78665,axiom,
    ! [VarCurr: state_type] :
      ( v103022(VarCurr,5)
    <=> v103031(VarCurr,5) ) ).

tff(addAssignment_78664,axiom,
    ! [VarCurr: state_type] :
      ( v103024(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78663,axiom,
    ! [VarCurr: state_type] :
      ( v5318(VarCurr,5)
    <=> v5320(VarCurr,5) ) ).

tff(addAssignment_78662,axiom,
    ! [VarCurr: state_type] :
      ( v5320(VarCurr,5)
    <=> v5322(VarCurr,5) ) ).

tff(addAssignment_78661,axiom,
    ! [VarNext: state_type] :
      ( v5322(VarNext,5)
    <=> v141138(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141139(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141138(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1983,axiom,
    ! [VarNext: state_type] :
      ( v141139(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141138(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141139(VarNext)
      <=> v141140(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141140(VarNext)
      <=> ( v141142(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_10724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141142(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_78660,axiom,
    ! [VarCurr: state_type] :
      ( v102970(VarCurr,5)
    <=> v102972(VarCurr,5) ) ).

tff(addAssignment_78659,axiom,
    ! [VarCurr: state_type] :
      ( v102972(VarCurr,5)
    <=> v102981(VarCurr,5) ) ).

tff(addAssignment_78658,axiom,
    ! [VarCurr: state_type] :
      ( v102974(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78657,axiom,
    ! [VarCurr: state_type] :
      ( v5311(VarCurr,5)
    <=> v5313(VarCurr,5) ) ).

tff(addAssignment_78656,axiom,
    ! [VarCurr: state_type] :
      ( v5313(VarCurr,5)
    <=> v5315(VarCurr,5) ) ).

tff(addAssignment_78655,axiom,
    ! [VarNext: state_type] :
      ( v5315(VarNext,5)
    <=> v141130(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141131(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141130(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1982,axiom,
    ! [VarNext: state_type] :
      ( v141131(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141130(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141131(VarNext)
      <=> v141132(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141132(VarNext)
      <=> ( v141134(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_10723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141134(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_78654,axiom,
    ! [VarCurr: state_type] :
      ( v102920(VarCurr,5)
    <=> v102922(VarCurr,5) ) ).

tff(addAssignment_78653,axiom,
    ! [VarCurr: state_type] :
      ( v102922(VarCurr,5)
    <=> v102931(VarCurr,5) ) ).

tff(addAssignment_78652,axiom,
    ! [VarCurr: state_type] :
      ( v102924(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78651,axiom,
    ! [VarCurr: state_type] :
      ( v5304(VarCurr,5)
    <=> v5306(VarCurr,5) ) ).

tff(addAssignment_78650,axiom,
    ! [VarCurr: state_type] :
      ( v5306(VarCurr,5)
    <=> v5308(VarCurr,5) ) ).

tff(addAssignment_78649,axiom,
    ! [VarNext: state_type] :
      ( v5308(VarNext,5)
    <=> v141122(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141123(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141122(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1981,axiom,
    ! [VarNext: state_type] :
      ( v141123(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141122(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141123(VarNext)
      <=> v141124(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141124(VarNext)
      <=> ( v141126(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_10722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141126(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_78648,axiom,
    ! [VarCurr: state_type] :
      ( v102870(VarCurr,5)
    <=> v102872(VarCurr,5) ) ).

tff(addAssignment_78647,axiom,
    ! [VarCurr: state_type] :
      ( v102872(VarCurr,5)
    <=> v102881(VarCurr,5) ) ).

tff(addAssignment_78646,axiom,
    ! [VarCurr: state_type] :
      ( v102874(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78645,axiom,
    ! [VarCurr: state_type] :
      ( v5297(VarCurr,5)
    <=> v5299(VarCurr,5) ) ).

tff(addAssignment_78644,axiom,
    ! [VarCurr: state_type] :
      ( v5299(VarCurr,5)
    <=> v5301(VarCurr,5) ) ).

tff(addAssignment_78643,axiom,
    ! [VarNext: state_type] :
      ( v5301(VarNext,5)
    <=> v141114(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141115(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141114(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1980,axiom,
    ! [VarNext: state_type] :
      ( v141115(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141114(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141115(VarNext)
      <=> v141116(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141116(VarNext)
      <=> ( v141118(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_10721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141118(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_78642,axiom,
    ! [VarCurr: state_type] :
      ( v102820(VarCurr,5)
    <=> v102822(VarCurr,5) ) ).

tff(addAssignment_78641,axiom,
    ! [VarCurr: state_type] :
      ( v102822(VarCurr,5)
    <=> v102831(VarCurr,5) ) ).

tff(addAssignment_78640,axiom,
    ! [VarCurr: state_type] :
      ( v102824(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78639,axiom,
    ! [VarCurr: state_type] :
      ( v5290(VarCurr,5)
    <=> v5292(VarCurr,5) ) ).

tff(addAssignment_78638,axiom,
    ! [VarCurr: state_type] :
      ( v5292(VarCurr,5)
    <=> v5294(VarCurr,5) ) ).

tff(addAssignment_78637,axiom,
    ! [VarNext: state_type] :
      ( v5294(VarNext,5)
    <=> v141106(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141107(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141106(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1979,axiom,
    ! [VarNext: state_type] :
      ( v141107(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141106(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141107(VarNext)
      <=> v141108(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141108(VarNext)
      <=> ( v141110(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_10720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141110(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_78636,axiom,
    ! [VarCurr: state_type] :
      ( v102770(VarCurr,5)
    <=> v102772(VarCurr,5) ) ).

tff(addAssignment_78635,axiom,
    ! [VarCurr: state_type] :
      ( v102772(VarCurr,5)
    <=> v102781(VarCurr,5) ) ).

tff(addAssignment_78634,axiom,
    ! [VarCurr: state_type] :
      ( v102774(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78633,axiom,
    ! [VarCurr: state_type] :
      ( v5283(VarCurr,5)
    <=> v5285(VarCurr,5) ) ).

tff(addAssignment_78632,axiom,
    ! [VarCurr: state_type] :
      ( v5285(VarCurr,5)
    <=> v5287(VarCurr,5) ) ).

tff(addAssignment_78631,axiom,
    ! [VarNext: state_type] :
      ( v5287(VarNext,5)
    <=> v141098(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141099(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141098(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1978,axiom,
    ! [VarNext: state_type] :
      ( v141099(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141098(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141099(VarNext)
      <=> v141100(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141100(VarNext)
      <=> ( v141102(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_10719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141102(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_78630,axiom,
    ! [VarCurr: state_type] :
      ( v102720(VarCurr,5)
    <=> v102722(VarCurr,5) ) ).

tff(addAssignment_78629,axiom,
    ! [VarCurr: state_type] :
      ( v102722(VarCurr,5)
    <=> v102731(VarCurr,5) ) ).

tff(addAssignment_78628,axiom,
    ! [VarCurr: state_type] :
      ( v102724(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78627,axiom,
    ! [VarCurr: state_type] :
      ( v5276(VarCurr,5)
    <=> v5278(VarCurr,5) ) ).

tff(addAssignment_78626,axiom,
    ! [VarCurr: state_type] :
      ( v5278(VarCurr,5)
    <=> v5280(VarCurr,5) ) ).

tff(addAssignment_78625,axiom,
    ! [VarNext: state_type] :
      ( v5280(VarNext,5)
    <=> v141090(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141091(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141090(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1977,axiom,
    ! [VarNext: state_type] :
      ( v141091(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141090(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141091(VarNext)
      <=> v141092(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141092(VarNext)
      <=> ( v141094(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_10718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141094(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_78624,axiom,
    ! [VarCurr: state_type] :
      ( v102670(VarCurr,5)
    <=> v102672(VarCurr,5) ) ).

tff(addAssignment_78623,axiom,
    ! [VarCurr: state_type] :
      ( v102672(VarCurr,5)
    <=> v102681(VarCurr,5) ) ).

tff(addAssignment_78622,axiom,
    ! [VarCurr: state_type] :
      ( v102674(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78621,axiom,
    ! [VarCurr: state_type] :
      ( v5269(VarCurr,5)
    <=> v5271(VarCurr,5) ) ).

tff(addAssignment_78620,axiom,
    ! [VarCurr: state_type] :
      ( v5271(VarCurr,5)
    <=> v5273(VarCurr,5) ) ).

tff(addAssignment_78619,axiom,
    ! [VarNext: state_type] :
      ( v5273(VarNext,5)
    <=> v141082(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141083(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141082(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1976,axiom,
    ! [VarNext: state_type] :
      ( v141083(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141082(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141083(VarNext)
      <=> v141084(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141084(VarNext)
      <=> ( v141086(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_10717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141086(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_78618,axiom,
    ! [VarCurr: state_type] :
      ( v102620(VarCurr,5)
    <=> v102622(VarCurr,5) ) ).

tff(addAssignment_78617,axiom,
    ! [VarCurr: state_type] :
      ( v102622(VarCurr,5)
    <=> v102631(VarCurr,5) ) ).

tff(addAssignment_78616,axiom,
    ! [VarCurr: state_type] :
      ( v102624(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78615,axiom,
    ! [VarCurr: state_type] :
      ( v5262(VarCurr,5)
    <=> v5264(VarCurr,5) ) ).

tff(addAssignment_78614,axiom,
    ! [VarCurr: state_type] :
      ( v5264(VarCurr,5)
    <=> v5266(VarCurr,5) ) ).

tff(addAssignment_78613,axiom,
    ! [VarNext: state_type] :
      ( v5266(VarNext,5)
    <=> v141074(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141075(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141074(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1975,axiom,
    ! [VarNext: state_type] :
      ( v141075(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141074(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141075(VarNext)
      <=> v141076(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141076(VarNext)
      <=> ( v141078(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_10716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141078(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_78612,axiom,
    ! [VarCurr: state_type] :
      ( v102570(VarCurr,5)
    <=> v102572(VarCurr,5) ) ).

tff(addAssignment_78611,axiom,
    ! [VarCurr: state_type] :
      ( v102572(VarCurr,5)
    <=> v102581(VarCurr,5) ) ).

tff(addAssignment_78610,axiom,
    ! [VarCurr: state_type] :
      ( v102574(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78609,axiom,
    ! [VarCurr: state_type] :
      ( v5255(VarCurr,5)
    <=> v5257(VarCurr,5) ) ).

tff(addAssignment_78608,axiom,
    ! [VarCurr: state_type] :
      ( v5257(VarCurr,5)
    <=> v5259(VarCurr,5) ) ).

tff(addAssignment_78607,axiom,
    ! [VarNext: state_type] :
      ( v5259(VarNext,5)
    <=> v141066(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141067(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141066(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1974,axiom,
    ! [VarNext: state_type] :
      ( v141067(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141066(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141067(VarNext)
      <=> v141068(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141068(VarNext)
      <=> ( v141070(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_10715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141070(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_78606,axiom,
    ! [VarCurr: state_type] :
      ( v102520(VarCurr,5)
    <=> v102522(VarCurr,5) ) ).

tff(addAssignment_78605,axiom,
    ! [VarCurr: state_type] :
      ( v102522(VarCurr,5)
    <=> v102531(VarCurr,5) ) ).

tff(addAssignment_78604,axiom,
    ! [VarCurr: state_type] :
      ( v102524(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78603,axiom,
    ! [VarCurr: state_type] :
      ( v5248(VarCurr,5)
    <=> v5250(VarCurr,5) ) ).

tff(addAssignment_78602,axiom,
    ! [VarCurr: state_type] :
      ( v5250(VarCurr,5)
    <=> v5252(VarCurr,5) ) ).

tff(addAssignment_78601,axiom,
    ! [VarNext: state_type] :
      ( v5252(VarNext,5)
    <=> v141058(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141059(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141058(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1973,axiom,
    ! [VarNext: state_type] :
      ( v141059(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141058(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141059(VarNext)
      <=> v141060(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141060(VarNext)
      <=> ( v141062(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_10714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141062(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_78600,axiom,
    ! [VarCurr: state_type] :
      ( v102470(VarCurr,5)
    <=> v102472(VarCurr,5) ) ).

tff(addAssignment_78599,axiom,
    ! [VarCurr: state_type] :
      ( v102472(VarCurr,5)
    <=> v102481(VarCurr,5) ) ).

tff(addAssignment_78598,axiom,
    ! [VarCurr: state_type] :
      ( v102474(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78597,axiom,
    ! [VarCurr: state_type] :
      ( v5241(VarCurr,5)
    <=> v5243(VarCurr,5) ) ).

tff(addAssignment_78596,axiom,
    ! [VarCurr: state_type] :
      ( v5243(VarCurr,5)
    <=> v5245(VarCurr,5) ) ).

tff(addAssignment_78595,axiom,
    ! [VarNext: state_type] :
      ( v5245(VarNext,5)
    <=> v141050(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141051(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141050(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1972,axiom,
    ! [VarNext: state_type] :
      ( v141051(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141050(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141051(VarNext)
      <=> v141052(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141052(VarNext)
      <=> ( v141054(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_10713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141054(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_78594,axiom,
    ! [VarCurr: state_type] :
      ( v102420(VarCurr,5)
    <=> v102422(VarCurr,5) ) ).

tff(addAssignment_78593,axiom,
    ! [VarCurr: state_type] :
      ( v102422(VarCurr,5)
    <=> v102431(VarCurr,5) ) ).

tff(addAssignment_78592,axiom,
    ! [VarCurr: state_type] :
      ( v102424(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78591,axiom,
    ! [VarCurr: state_type] :
      ( v5234(VarCurr,5)
    <=> v5236(VarCurr,5) ) ).

tff(addAssignment_78590,axiom,
    ! [VarCurr: state_type] :
      ( v5236(VarCurr,5)
    <=> v5238(VarCurr,5) ) ).

tff(addAssignment_78589,axiom,
    ! [VarNext: state_type] :
      ( v5238(VarNext,5)
    <=> v141042(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141043(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141042(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1971,axiom,
    ! [VarNext: state_type] :
      ( v141043(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141042(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141043(VarNext)
      <=> v141044(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141044(VarNext)
      <=> ( v141046(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_10712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141046(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_78588,axiom,
    ! [VarCurr: state_type] :
      ( v102370(VarCurr,5)
    <=> v102372(VarCurr,5) ) ).

tff(addAssignment_78587,axiom,
    ! [VarCurr: state_type] :
      ( v102372(VarCurr,5)
    <=> v102381(VarCurr,5) ) ).

tff(addAssignment_78586,axiom,
    ! [VarCurr: state_type] :
      ( v102374(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78585,axiom,
    ! [VarCurr: state_type] :
      ( v5227(VarCurr,5)
    <=> v5229(VarCurr,5) ) ).

tff(addAssignment_78584,axiom,
    ! [VarCurr: state_type] :
      ( v5229(VarCurr,5)
    <=> v5231(VarCurr,5) ) ).

tff(addAssignment_78583,axiom,
    ! [VarNext: state_type] :
      ( v5231(VarNext,5)
    <=> v141034(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141035(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141034(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1970,axiom,
    ! [VarNext: state_type] :
      ( v141035(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141034(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141035(VarNext)
      <=> v141036(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141036(VarNext)
      <=> ( v141038(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_10711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141038(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_78582,axiom,
    ! [VarCurr: state_type] :
      ( v102320(VarCurr,5)
    <=> v102322(VarCurr,5) ) ).

tff(addAssignment_78581,axiom,
    ! [VarCurr: state_type] :
      ( v102322(VarCurr,5)
    <=> v102331(VarCurr,5) ) ).

tff(addAssignment_78580,axiom,
    ! [VarCurr: state_type] :
      ( v102324(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78579,axiom,
    ! [VarCurr: state_type] :
      ( v5220(VarCurr,5)
    <=> v5222(VarCurr,5) ) ).

tff(addAssignment_78578,axiom,
    ! [VarCurr: state_type] :
      ( v5222(VarCurr,5)
    <=> v5224(VarCurr,5) ) ).

tff(addAssignment_78577,axiom,
    ! [VarNext: state_type] :
      ( v5224(VarNext,5)
    <=> v141026(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141027(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141026(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1969,axiom,
    ! [VarNext: state_type] :
      ( v141027(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141026(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141027(VarNext)
      <=> v141028(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141028(VarNext)
      <=> ( v141030(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_10710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141030(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_78576,axiom,
    ! [VarCurr: state_type] :
      ( v102270(VarCurr,5)
    <=> v102272(VarCurr,5) ) ).

tff(addAssignment_78575,axiom,
    ! [VarCurr: state_type] :
      ( v102272(VarCurr,5)
    <=> v102281(VarCurr,5) ) ).

tff(addAssignment_78574,axiom,
    ! [VarCurr: state_type] :
      ( v102274(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_78573,axiom,
    ! [VarCurr: state_type] :
      ( v884(VarCurr,5)
    <=> v886(VarCurr,5) ) ).

tff(addAssignment_78572,axiom,
    ! [VarCurr: state_type] :
      ( v886(VarCurr,5)
    <=> v888(VarCurr,5) ) ).

tff(addAssignment_78571,axiom,
    ! [VarNext: state_type] :
      ( v888(VarNext,5)
    <=> v141018(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141019(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v141018(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1968,axiom,
    ! [VarNext: state_type] :
      ( v141019(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v141018(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141019(VarNext)
      <=> v141020(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141020(VarNext)
      <=> ( v141022(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_10709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141022(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_78570,axiom,
    ! [VarCurr: state_type] :
      ( v898(VarCurr,5)
    <=> v900(VarCurr,5) ) ).

tff(addAssignment_78569,axiom,
    ! [VarCurr: state_type] :
      ( v900(VarCurr,5)
    <=> v102231(VarCurr,5) ) ).

tff(addAssignment_78568,axiom,
    ! [VarCurr: state_type] :
      ( v5687(VarCurr)
    <=> v5689(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18861,axiom,
    ! [VarCurr: state_type] :
      ( v5689(VarCurr)
    <=> ( v141016(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2096,axiom,
    ! [VarCurr: state_type] :
      ( v141016(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_78567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5693(VarCurr,B)
      <=> v5695(VarCurr,B) ) ) ).

tff(addAssignment_78566,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5695(VarNext,B)
      <=> v141008(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141009(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v141008(VarNext,B)
            <=> v5695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1967,axiom,
    ! [VarNext: state_type] :
      ( v141009(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v141008(VarNext,B)
          <=> v109698(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141009(VarNext)
      <=> v141010(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v141010(VarNext)
      <=> ( v141012(VarNext)
          & v109683(VarNext) ) ) ) ).

tff(writeUnaryOperator_10708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v141012(VarNext)
      <=> v109692(VarNext) ) ) ).

tff(addAssignment_78565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5705(VarCurr,B)
      <=> v5707(VarCurr,B) ) ) ).

tff(addAssignment_78564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5707(VarCurr,B)
      <=> v109674(VarCurr,B) ) ) ).

tff(addAssignment_78563,axiom,
    ! [VarCurr: state_type] :
      ( v5743(VarCurr)
    <=> v5745(VarCurr) ) ).

tff(addAssignment_78562,axiom,
    ! [VarCurr: state_type] :
      ( v5745(VarCurr)
    <=> v5747(VarCurr) ) ).

tff(addAssignment_78561,axiom,
    ! [VarCurr: state_type] :
      ( v5747(VarCurr)
    <=> v5749(VarCurr) ) ).

tff(addAssignment_78560,axiom,
    ! [VarCurr: state_type] :
      ( v5749(VarCurr)
    <=> v5751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18858,axiom,
    ! [VarCurr: state_type] :
      ( v5751(VarCurr)
    <=> ( v140996(VarCurr)
        & v141005(VarCurr) ) ) ).

tff(writeUnaryOperator_10707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141005(VarCurr)
    <=> v141006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18857,axiom,
    ! [VarCurr: state_type] :
      ( v141006(VarCurr)
    <=> ( v140570(VarCurr)
        | v96423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18856,axiom,
    ! [VarCurr: state_type] :
      ( v140996(VarCurr)
    <=> ( v5753(VarCurr)
        & v140997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18855,axiom,
    ! [VarCurr: state_type] :
      ( v140997(VarCurr)
    <=> ( v140998(VarCurr)
        | v141002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18854,axiom,
    ! [VarCurr: state_type] :
      ( v141002(VarCurr)
    <=> ( v140532(VarCurr)
        & v141003(VarCurr) ) ) ).

tff(writeUnaryOperator_10706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141003(VarCurr)
    <=> v141004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18853,axiom,
    ! [VarCurr: state_type] :
      ( v141004(VarCurr)
    <=> ( v140560(VarCurr)
        | v82909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18852,axiom,
    ! [VarCurr: state_type] :
      ( v140998(VarCurr)
    <=> ( v140999(VarCurr)
        & v141000(VarCurr) ) ) ).

tff(writeUnaryOperator_10705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v141000(VarCurr)
    <=> v141001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18851,axiom,
    ! [VarCurr: state_type] :
      ( v141001(VarCurr)
    <=> ( v82909(VarCurr)
        | v140532(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18850,axiom,
    ! [VarCurr: state_type] :
      ( v140999(VarCurr)
    <=> ( v5801(VarCurr)
        | v82153(VarCurr) ) ) ).

tff(addAssignment_78559,axiom,
    ! [VarCurr: state_type] :
      ( v140570(VarCurr)
    <=> v140572(VarCurr) ) ).

tff(addAssignment_78558,axiom,
    ! [VarCurr: state_type] :
      ( v140572(VarCurr)
    <=> v140574(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140979(VarNext)
       => ( v140574(VarNext)
        <=> v140574(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1966,axiom,
    ! [VarNext: state_type] :
      ( v140979(VarNext)
     => ( v140574(VarNext)
      <=> v140989(VarNext) ) ) ).

tff(addAssignment_78557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140989(VarNext)
      <=> v140987(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140990(VarCurr)
     => ( v140987(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1500,axiom,
    ! [VarCurr: state_type] :
      ( v140990(VarCurr)
     => ( v140987(VarCurr)
      <=> v140584(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18849,axiom,
    ! [VarCurr: state_type] :
      ( v140990(VarCurr)
    <=> ( v140991(VarCurr)
        & v140992(VarCurr) ) ) ).

tff(writeUnaryOperator_10704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140992(VarCurr)
    <=> v140580(VarCurr) ) ).

tff(writeUnaryOperator_10703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140991(VarCurr)
    <=> v140576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140979(VarNext)
      <=> v140980(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140980(VarNext)
      <=> ( v140981(VarNext)
          & v140974(VarNext) ) ) ) ).

tff(writeUnaryOperator_10702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140981(VarNext)
      <=> v140983(VarNext) ) ) ).

tff(addAssignment_78556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140983(VarNext)
      <=> v140974(VarCurr) ) ) ).

tff(addAssignment_78555,axiom,
    ! [VarCurr: state_type] :
      ( v140974(VarCurr)
    <=> v140976(VarCurr) ) ).

tff(addAssignment_78554,axiom,
    ! [VarCurr: state_type] :
      ( v140976(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78553,axiom,
    ! [VarCurr: state_type] :
      ( v140584(VarCurr)
    <=> v140586(VarCurr) ) ).

tff(addAssignment_78552,axiom,
    ! [VarCurr: state_type] :
      ( v140586(VarCurr)
    <=> v140588(VarCurr) ) ).

tff(addAssignment_78551,axiom,
    ! [VarCurr: state_type] :
      ( v140588(VarCurr)
    <=> v140590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140592(VarCurr)
     => ( v140590(VarCurr)
      <=> v140972(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1499,axiom,
    ! [VarCurr: state_type] :
      ( v140592(VarCurr)
     => ( v140590(VarCurr)
      <=> v140858(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140614(VarCurr)
     => ( v140972(VarCurr)
      <=> v962(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1498,axiom,
    ! [VarCurr: state_type] :
      ( v140614(VarCurr)
     => ( v140972(VarCurr)
      <=> v140915(VarCurr) ) ) ).

tff(addAssignment_78550,axiom,
    ! [VarCurr: state_type] :
      ( v140915(VarCurr)
    <=> v140917(VarCurr,0) ) ).

tff(addAssignment_78549,axiom,
    ! [VarCurr: state_type] :
      ( v140917(VarCurr,0)
    <=> v140919(VarCurr,0) ) ).

tff(addAssignment_78548,axiom,
    ! [VarNext: state_type] :
      ( v140919(VarNext,0)
    <=> v140954(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140955(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140954(VarNext,B)
            <=> v140919(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1965,axiom,
    ! [VarNext: state_type] :
      ( v140955(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140954(VarNext,B)
          <=> v140965(VarNext,B) ) ) ) ).

tff(addAssignment_78547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140965(VarNext,B)
          <=> v140963(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140966(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140963(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1497,axiom,
    ! [VarCurr: state_type] :
      ( v140966(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140963(VarCurr,B)
          <=> v140929(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18846,axiom,
    ! [VarCurr: state_type] :
      ( v140966(VarCurr)
    <=> ( v140967(VarCurr)
        & v140968(VarCurr) ) ) ).

tff(writeUnaryOperator_10701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140968(VarCurr)
    <=> v140925(VarCurr) ) ).

tff(writeUnaryOperator_10700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140967(VarCurr)
    <=> v140921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140955(VarNext)
      <=> v140956(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140956(VarNext)
      <=> ( v140957(VarNext)
          & v140950(VarNext) ) ) ) ).

tff(writeUnaryOperator_10699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140957(VarNext)
      <=> v140959(VarNext) ) ) ).

tff(addAssignment_78546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140959(VarNext)
      <=> v140950(VarCurr) ) ) ).

tff(addAssignment_78545,axiom,
    ! [VarCurr: state_type] :
      ( v140950(VarCurr)
    <=> v140952(VarCurr) ) ).

tff(addAssignment_78544,axiom,
    ! [VarCurr: state_type] :
      ( v140952(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78543,axiom,
    ! [VarCurr: state_type] :
      ( v140929(VarCurr,0)
    <=> v140931(VarCurr,0) ) ).

tff(addAssignment_78542,axiom,
    ! [VarCurr: state_type] :
      ( v140931(VarCurr,0)
    <=> v140941(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140941(VarCurr,B)
      <=> ( v140942(VarCurr,B)
          | v140945(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140945(VarCurr,B)
      <=> ( v140917(VarCurr,B)
          & v140946(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140946(VarCurr,B)
      <=> ~ v140947(VarCurr,B) ) ) ).

tff(addAssignment_78541,axiom,
    ! [VarCurr: state_type] :
      ( v140947(VarCurr,0)
    <=> v140948(VarCurr) ) ).

tff(addAssignment_78540,axiom,
    ! [VarCurr: state_type] :
      ( v140947(VarCurr,1)
    <=> v140948(VarCurr) ) ).

tff(addAssignment_78539,axiom,
    ! [VarCurr: state_type] :
      ( v140947(VarCurr,2)
    <=> v140948(VarCurr) ) ).

tff(addAssignment_78538,axiom,
    ! [VarCurr: state_type] :
      ( v140947(VarCurr,3)
    <=> v140948(VarCurr) ) ).

tff(addAssignment_78537,axiom,
    ! [VarCurr: state_type] :
      ( v140947(VarCurr,4)
    <=> v140948(VarCurr) ) ).

tff(addAssignment_78536,axiom,
    ! [VarCurr: state_type] :
      ( v140948(VarCurr)
    <=> v140940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140942(VarCurr,B)
      <=> ( v140933(VarCurr,B)
          & v140943(VarCurr,B) ) ) ) ).

tff(addAssignment_78535,axiom,
    ! [VarCurr: state_type] :
      ( v140943(VarCurr,0)
    <=> v140944(VarCurr) ) ).

tff(addAssignment_78534,axiom,
    ! [VarCurr: state_type] :
      ( v140943(VarCurr,1)
    <=> v140944(VarCurr) ) ).

tff(addAssignment_78533,axiom,
    ! [VarCurr: state_type] :
      ( v140943(VarCurr,2)
    <=> v140944(VarCurr) ) ).

tff(addAssignment_78532,axiom,
    ! [VarCurr: state_type] :
      ( v140943(VarCurr,3)
    <=> v140944(VarCurr) ) ).

tff(addAssignment_78531,axiom,
    ! [VarCurr: state_type] :
      ( v140943(VarCurr,4)
    <=> v140944(VarCurr) ) ).

tff(addAssignment_78530,axiom,
    ! [VarCurr: state_type] :
      ( v140944(VarCurr)
    <=> v140940(VarCurr) ) ).

tff(addAssignment_78529,axiom,
    ! [VarCurr: state_type] :
      ( v140940(VarCurr)
    <=> v140750(VarCurr) ) ).

tff(addAssignment_78528,axiom,
    ! [VarCurr: state_type] :
      ( v140933(VarCurr,0)
    <=> v140936(VarCurr,0) ) ).

tff(addAssignment_78527,axiom,
    ! [VarCurr: state_type] :
      ( v140936(VarCurr,0)
    <=> v140935(VarCurr) ) ).

tff(addAssignment_78526,axiom,
    ! [VarCurr: state_type] :
      ( ( v140936(VarCurr,3)
      <=> v140938(VarCurr,2) )
      & ( v140936(VarCurr,2)
      <=> v140938(VarCurr,1) )
      & ( v140936(VarCurr,1)
      <=> v140938(VarCurr,0) ) ) ).

tff(addAssignment_78525,axiom,
    ! [VarCurr: state_type] :
      ( v140936(VarCurr,4)
    <=> v140937(VarCurr) ) ).

tff(addAssignment_78524,axiom,
    ! [VarCurr: state_type] :
      ( v140935(VarCurr)
    <=> v140752(VarCurr,0) ) ).

tff(addAssignment_78523,axiom,
    ! [VarCurr: state_type] :
      ( v140752(VarCurr,0)
    <=> v140754(VarCurr,0) ) ).

tff(addAssignment_78522,axiom,
    ! [VarCurr: state_type] :
      ( v140925(VarCurr)
    <=> v140927(VarCurr) ) ).

tff(addAssignment_78521,axiom,
    ! [VarCurr: state_type] :
      ( v140927(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78520,axiom,
    ! [VarCurr: state_type] :
      ( v140921(VarCurr)
    <=> v140923(VarCurr) ) ).

tff(addAssignment_78519,axiom,
    ! [VarCurr: state_type] :
      ( v140923(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78518,axiom,
    ! [VarCurr: state_type] :
      ( v140858(VarCurr)
    <=> v140860(VarCurr,0) ) ).

tff(addAssignment_78517,axiom,
    ! [VarCurr: state_type] :
      ( v140860(VarCurr,0)
    <=> v140862(VarCurr,0) ) ).

tff(addAssignment_78516,axiom,
    ! [VarNext: state_type] :
      ( v140862(VarNext,0)
    <=> v140897(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140898(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140897(VarNext,B)
            <=> v140862(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1964,axiom,
    ! [VarNext: state_type] :
      ( v140898(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140897(VarNext,B)
          <=> v140908(VarNext,B) ) ) ) ).

tff(addAssignment_78515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140908(VarNext,B)
          <=> v140906(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140909(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140906(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1496,axiom,
    ! [VarCurr: state_type] :
      ( v140909(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140906(VarCurr,B)
          <=> v140872(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18843,axiom,
    ! [VarCurr: state_type] :
      ( v140909(VarCurr)
    <=> ( v140910(VarCurr)
        & v140911(VarCurr) ) ) ).

tff(writeUnaryOperator_10697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140911(VarCurr)
    <=> v140868(VarCurr) ) ).

tff(writeUnaryOperator_10696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140910(VarCurr)
    <=> v140864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140898(VarNext)
      <=> v140899(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140899(VarNext)
      <=> ( v140900(VarNext)
          & v140893(VarNext) ) ) ) ).

tff(writeUnaryOperator_10695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140900(VarNext)
      <=> v140902(VarNext) ) ) ).

tff(addAssignment_78514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140902(VarNext)
      <=> v140893(VarCurr) ) ) ).

tff(addAssignment_78513,axiom,
    ! [VarCurr: state_type] :
      ( v140893(VarCurr)
    <=> v140895(VarCurr) ) ).

tff(addAssignment_78512,axiom,
    ! [VarCurr: state_type] :
      ( v140895(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78511,axiom,
    ! [VarCurr: state_type] :
      ( v140872(VarCurr,0)
    <=> v140874(VarCurr,0) ) ).

tff(addAssignment_78510,axiom,
    ! [VarCurr: state_type] :
      ( v140874(VarCurr,0)
    <=> v140884(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140884(VarCurr,B)
      <=> ( v140885(VarCurr,B)
          | v140888(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140888(VarCurr,B)
      <=> ( v140860(VarCurr,B)
          & v140889(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140889(VarCurr,B)
      <=> ~ v140890(VarCurr,B) ) ) ).

tff(addAssignment_78509,axiom,
    ! [VarCurr: state_type] :
      ( v140890(VarCurr,0)
    <=> v140891(VarCurr) ) ).

tff(addAssignment_78508,axiom,
    ! [VarCurr: state_type] :
      ( v140890(VarCurr,1)
    <=> v140891(VarCurr) ) ).

tff(addAssignment_78507,axiom,
    ! [VarCurr: state_type] :
      ( v140890(VarCurr,2)
    <=> v140891(VarCurr) ) ).

tff(addAssignment_78506,axiom,
    ! [VarCurr: state_type] :
      ( v140890(VarCurr,3)
    <=> v140891(VarCurr) ) ).

tff(addAssignment_78505,axiom,
    ! [VarCurr: state_type] :
      ( v140890(VarCurr,4)
    <=> v140891(VarCurr) ) ).

tff(addAssignment_78504,axiom,
    ! [VarCurr: state_type] :
      ( v140891(VarCurr)
    <=> v140883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v140885(VarCurr,B)
      <=> ( v140876(VarCurr,B)
          & v140886(VarCurr,B) ) ) ) ).

tff(addAssignment_78503,axiom,
    ! [VarCurr: state_type] :
      ( v140886(VarCurr,0)
    <=> v140887(VarCurr) ) ).

tff(addAssignment_78502,axiom,
    ! [VarCurr: state_type] :
      ( v140886(VarCurr,1)
    <=> v140887(VarCurr) ) ).

tff(addAssignment_78501,axiom,
    ! [VarCurr: state_type] :
      ( v140886(VarCurr,2)
    <=> v140887(VarCurr) ) ).

tff(addAssignment_78500,axiom,
    ! [VarCurr: state_type] :
      ( v140886(VarCurr,3)
    <=> v140887(VarCurr) ) ).

tff(addAssignment_78499,axiom,
    ! [VarCurr: state_type] :
      ( v140886(VarCurr,4)
    <=> v140887(VarCurr) ) ).

tff(addAssignment_78498,axiom,
    ! [VarCurr: state_type] :
      ( v140887(VarCurr)
    <=> v140883(VarCurr) ) ).

tff(addAssignment_78497,axiom,
    ! [VarCurr: state_type] :
      ( v140883(VarCurr)
    <=> v140660(VarCurr) ) ).

tff(addAssignment_78496,axiom,
    ! [VarCurr: state_type] :
      ( v140876(VarCurr,0)
    <=> v140879(VarCurr,0) ) ).

tff(addAssignment_78495,axiom,
    ! [VarCurr: state_type] :
      ( v140879(VarCurr,0)
    <=> v140878(VarCurr) ) ).

tff(addAssignment_78494,axiom,
    ! [VarCurr: state_type] :
      ( ( v140879(VarCurr,3)
      <=> v140881(VarCurr,2) )
      & ( v140879(VarCurr,2)
      <=> v140881(VarCurr,1) )
      & ( v140879(VarCurr,1)
      <=> v140881(VarCurr,0) ) ) ).

tff(addAssignment_78493,axiom,
    ! [VarCurr: state_type] :
      ( v140879(VarCurr,4)
    <=> v140880(VarCurr) ) ).

tff(addAssignment_78492,axiom,
    ! [VarCurr: state_type] :
      ( v140878(VarCurr)
    <=> v140662(VarCurr,0) ) ).

tff(addAssignment_78491,axiom,
    ! [VarCurr: state_type] :
      ( v140662(VarCurr,0)
    <=> v140664(VarCurr,0) ) ).

tff(addAssignment_78490,axiom,
    ! [VarCurr: state_type] :
      ( v140868(VarCurr)
    <=> v140870(VarCurr) ) ).

tff(addAssignment_78489,axiom,
    ! [VarCurr: state_type] :
      ( v140870(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78488,axiom,
    ! [VarCurr: state_type] :
      ( v140864(VarCurr)
    <=> v140866(VarCurr) ) ).

tff(addAssignment_78487,axiom,
    ! [VarCurr: state_type] :
      ( v140866(VarCurr)
    <=> v920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18840,axiom,
    ! [VarCurr: state_type] :
      ( v140592(VarCurr)
    <=> ( v140846(VarCurr)
        & v140854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18839,axiom,
    ! [VarCurr: state_type] :
      ( v140854(VarCurr)
    <=> ( v140855(VarCurr)
        | v140856(VarCurr) ) ) ).

tff(writeUnaryOperator_10693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140856(VarCurr)
    <=> v140728(VarCurr) ) ).

tff(writeUnaryOperator_10692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140855(VarCurr)
    <=> v140706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18838,axiom,
    ! [VarCurr: state_type] :
      ( v140846(VarCurr)
    <=> ( v140847(VarCurr)
        & v140638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18837,axiom,
    ! [VarCurr: state_type] :
      ( v140847(VarCurr)
    <=> ( v140848(VarCurr)
        | v140851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18836,axiom,
    ! [VarCurr: state_type] :
      ( v140851(VarCurr)
    <=> ( v140852(VarCurr)
        & v140594(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18835,axiom,
    ! [VarCurr: state_type] :
      ( v140852(VarCurr)
    <=> ( v2036(VarCurr)
        & v140853(VarCurr) ) ) ).

tff(writeUnaryOperator_10691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140853(VarCurr)
    <=> v1025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18834,axiom,
    ! [VarCurr: state_type] :
      ( v140848(VarCurr)
    <=> ( v140849(VarCurr)
        & v140850(VarCurr) ) ) ).

tff(writeUnaryOperator_10690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140850(VarCurr)
    <=> v1025(VarCurr) ) ).

tff(writeUnaryOperator_10689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140849(VarCurr)
    <=> v2036(VarCurr) ) ).

tff(addAssignment_78486,axiom,
    ! [VarCurr: state_type] :
      ( v140706(VarCurr)
    <=> v140708(VarCurr) ) ).

tff(addAssignment_78485,axiom,
    ! [VarCurr: state_type] :
      ( v140708(VarCurr)
    <=> v140710(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140829(VarNext)
       => ( v140710(VarNext)
        <=> v140710(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1963,axiom,
    ! [VarNext: state_type] :
      ( v140829(VarNext)
     => ( v140710(VarNext)
      <=> v140839(VarNext) ) ) ).

tff(addAssignment_78484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140839(VarNext)
      <=> v140837(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140840(VarCurr)
     => ( v140837(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1495,axiom,
    ! [VarCurr: state_type] :
      ( v140840(VarCurr)
     => ( v140837(VarCurr)
      <=> v140720(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18833,axiom,
    ! [VarCurr: state_type] :
      ( v140840(VarCurr)
    <=> ( v140841(VarCurr)
        & v140842(VarCurr) ) ) ).

tff(writeUnaryOperator_10688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140842(VarCurr)
    <=> v140716(VarCurr) ) ).

tff(writeUnaryOperator_10687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140841(VarCurr)
    <=> v140712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140829(VarNext)
      <=> v140830(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140830(VarNext)
      <=> ( v140831(VarNext)
          & v140824(VarNext) ) ) ) ).

tff(writeUnaryOperator_10686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140831(VarNext)
      <=> v140833(VarNext) ) ) ).

tff(addAssignment_78483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140833(VarNext)
      <=> v140824(VarCurr) ) ) ).

tff(addAssignment_78482,axiom,
    ! [VarCurr: state_type] :
      ( v140824(VarCurr)
    <=> v140826(VarCurr) ) ).

tff(addAssignment_78481,axiom,
    ! [VarCurr: state_type] :
      ( v140826(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78480,axiom,
    ! [VarCurr: state_type] :
      ( v140720(VarCurr)
    <=> v140722(VarCurr) ) ).

tff(addAssignment_78479,axiom,
    ! [VarCurr: state_type] :
      ( v140722(VarCurr)
    <=> v140724(VarCurr) ) ).

tff(addAssignment_78478,axiom,
    ! [VarCurr: state_type] :
      ( v140724(VarCurr)
    <=> v140726(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140818(VarCurr)
     => ( v140726(VarCurr)
      <=> v140820(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1494,axiom,
    ! [VarCurr: state_type] :
      ( v140818(VarCurr)
     => ( v140726(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140821(VarCurr)
     => ( v140820(VarCurr)
      <=> v140706(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1493,axiom,
    ! [VarCurr: state_type] :
      ( v140821(VarCurr)
     => ( v140820(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18830,axiom,
    ! [VarCurr: state_type] :
      ( v140821(VarCurr)
    <=> ( v140638(VarCurr)
        & v140822(VarCurr) ) ) ).

tff(writeUnaryOperator_10685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140822(VarCurr)
    <=> v140728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18829,axiom,
    ! [VarCurr: state_type] :
      ( v140818(VarCurr)
    <=> ( v140728(VarCurr)
        & v140819(VarCurr) ) ) ).

tff(writeUnaryOperator_10684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140819(VarCurr)
    <=> v140638(VarCurr) ) ).

tff(addAssignment_78477,axiom,
    ! [VarCurr: state_type] :
      ( v140728(VarCurr)
    <=> v140730(VarCurr) ) ).

tff(addAssignment_78476,axiom,
    ! [VarCurr: state_type] :
      ( v140730(VarCurr)
    <=> v140732(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140801(VarNext)
       => ( v140732(VarNext)
        <=> v140732(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1962,axiom,
    ! [VarNext: state_type] :
      ( v140801(VarNext)
     => ( v140732(VarNext)
      <=> v140811(VarNext) ) ) ).

tff(addAssignment_78475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140811(VarNext)
      <=> v140809(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140812(VarCurr)
     => ( v140809(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1492,axiom,
    ! [VarCurr: state_type] :
      ( v140812(VarCurr)
     => ( v140809(VarCurr)
      <=> v140742(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18828,axiom,
    ! [VarCurr: state_type] :
      ( v140812(VarCurr)
    <=> ( v140813(VarCurr)
        & v140814(VarCurr) ) ) ).

tff(writeUnaryOperator_10683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140814(VarCurr)
    <=> v140738(VarCurr) ) ).

tff(writeUnaryOperator_10682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140813(VarCurr)
    <=> v140734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140801(VarNext)
      <=> v140802(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140802(VarNext)
      <=> ( v140803(VarNext)
          & v140796(VarNext) ) ) ) ).

tff(writeUnaryOperator_10681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140803(VarNext)
      <=> v140805(VarNext) ) ) ).

tff(addAssignment_78474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140805(VarNext)
      <=> v140796(VarCurr) ) ) ).

tff(addAssignment_78473,axiom,
    ! [VarCurr: state_type] :
      ( v140796(VarCurr)
    <=> v140798(VarCurr) ) ).

tff(addAssignment_78472,axiom,
    ! [VarCurr: state_type] :
      ( v140798(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78471,axiom,
    ! [VarCurr: state_type] :
      ( v140742(VarCurr)
    <=> v140744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18825,axiom,
    ! [VarCurr: state_type] :
      ( v140744(VarCurr)
    <=> ( v140780(VarCurr)
        | v140787(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18824,axiom,
    ! [VarCurr: state_type] :
      ( v140787(VarCurr)
    <=> ( v140788(VarCurr)
        & v140792(VarCurr) ) ) ).

tff(writeUnaryOperator_10680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140792(VarCurr)
    <=> v140793(VarCurr) ) ).

tff(addAssignment_78470,axiom,
    ! [VarCurr: state_type] :
      ( v140793(VarCurr)
    <=> v140794(VarCurr) ) ).

tff(addAssignment_78469,axiom,
    ! [VarCurr: state_type] :
      ( v140794(VarCurr)
    <=> v140756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18823,axiom,
    ! [VarCurr: state_type] :
      ( v140788(VarCurr)
    <=> ( v140730(VarCurr)
        & v140789(VarCurr) ) ) ).

tff(writeUnaryOperator_10679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140789(VarCurr)
    <=> v140790(VarCurr) ) ).

tff(addAssignment_78468,axiom,
    ! [VarCurr: state_type] :
      ( v140790(VarCurr)
    <=> v140791(VarCurr) ) ).

tff(addAssignment_78467,axiom,
    ! [VarCurr: state_type] :
      ( v140791(VarCurr)
    <=> v140748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18822,axiom,
    ! [VarCurr: state_type] :
      ( v140780(VarCurr)
    <=> ( v140781(VarCurr)
        & v140784(VarCurr) ) ) ).

tff(writeUnaryOperator_10678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140784(VarCurr)
    <=> v140785(VarCurr) ) ).

tff(addAssignment_78466,axiom,
    ! [VarCurr: state_type] :
      ( v140785(VarCurr)
    <=> v140786(VarCurr) ) ).

tff(addAssignment_78465,axiom,
    ! [VarCurr: state_type] :
      ( v140786(VarCurr)
    <=> v140756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18821,axiom,
    ! [VarCurr: state_type] :
      ( v140781(VarCurr)
    <=> ( v140746(VarCurr)
        & v140782(VarCurr) ) ) ).

tff(addAssignment_78464,axiom,
    ! [VarCurr: state_type] :
      ( v140782(VarCurr)
    <=> v140783(VarCurr) ) ).

tff(addAssignment_78463,axiom,
    ! [VarCurr: state_type] :
      ( v140783(VarCurr)
    <=> v140748(VarCurr) ) ).

tff(addAssignment_78462,axiom,
    ! [VarCurr: state_type] :
      ( v140756(VarCurr)
    <=> v140758(VarCurr) ) ).

tff(addAssignment_78461,axiom,
    ! [VarCurr: state_type] :
      ( v140758(VarCurr)
    <=> v140596(VarCurr,0) ) ).

tff(addAssignment_78460,axiom,
    ! [VarCurr: state_type] :
      ( v140596(VarCurr,0)
    <=> v140598(VarCurr,0) ) ).

tff(addAssignment_78459,axiom,
    ! [VarNext: state_type] :
      ( v140598(VarNext,0)
    <=> v140772(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140773(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v140772(VarNext,B)
            <=> v140598(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1961,axiom,
    ! [VarNext: state_type] :
      ( v140773(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v140772(VarNext,B)
          <=> v140631(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140773(VarNext)
      <=> v140774(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140774(VarNext)
      <=> ( v140776(VarNext)
          & v140616(VarNext) ) ) ) ).

tff(writeUnaryOperator_10677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140776(VarNext)
      <=> v140625(VarNext) ) ) ).

tff(addAssignment_78458,axiom,
    ! [VarCurr: state_type] :
      ( v140608(VarCurr,0)
    <=> v140610(VarCurr,0) ) ).

tff(addAssignment_78457,axiom,
    ! [VarCurr: state_type] :
      ( v140610(VarCurr,0)
    <=> v140612(VarCurr,0) ) ).

tff(addAssignment_78456,axiom,
    ! [VarCurr: state_type] :
      ( v140612(VarCurr,0)
    <=> v140613(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18818,axiom,
    ! [VarCurr: state_type] :
      ( v140614(VarCurr)
    <=> ( v140761(VarCurr)
        & v140769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18817,axiom,
    ! [VarCurr: state_type] :
      ( v140769(VarCurr)
    <=> ( v140706(VarCurr)
        | v140770(VarCurr) ) ) ).

tff(writeUnaryOperator_10676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140770(VarCurr)
    <=> v140638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18816,axiom,
    ! [VarCurr: state_type] :
      ( v140761(VarCurr)
    <=> ( v140762(VarCurr)
        & v140728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18815,axiom,
    ! [VarCurr: state_type] :
      ( v140762(VarCurr)
    <=> ( v140763(VarCurr)
        | v140766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18814,axiom,
    ! [VarCurr: state_type] :
      ( v140766(VarCurr)
    <=> ( v140767(VarCurr)
        & v140758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18813,axiom,
    ! [VarCurr: state_type] :
      ( v140767(VarCurr)
    <=> ( v2036(VarCurr)
        & v140768(VarCurr) ) ) ).

tff(writeUnaryOperator_10675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140768(VarCurr)
    <=> v1025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18812,axiom,
    ! [VarCurr: state_type] :
      ( v140763(VarCurr)
    <=> ( v140764(VarCurr)
        & v140765(VarCurr) ) ) ).

tff(writeUnaryOperator_10674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140765(VarCurr)
    <=> v1025(VarCurr) ) ).

tff(writeUnaryOperator_10673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140764(VarCurr)
    <=> v2036(VarCurr) ) ).

tff(addAssignment_78455,axiom,
    ! [VarCurr: state_type] :
      ( v140748(VarCurr)
    <=> v140750(VarCurr) ) ).

tff(addAssignment_78454,axiom,
    ! [VarCurr: state_type] :
      ( v140750(VarCurr)
    <=> v140752(VarCurr,5) ) ).

tff(addAssignment_78453,axiom,
    ! [VarCurr: state_type] :
      ( v140752(VarCurr,5)
    <=> v140754(VarCurr,5) ) ).

tff(addAssignment_78452,axiom,
    ! [VarCurr: state_type] :
      ( v140746(VarCurr)
    <=> $true ) ).

tff(addAssignment_78451,axiom,
    ! [VarCurr: state_type] :
      ( v140738(VarCurr)
    <=> v140740(VarCurr) ) ).

tff(addAssignment_78450,axiom,
    ! [VarCurr: state_type] :
      ( v140740(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78449,axiom,
    ! [VarCurr: state_type] :
      ( v140734(VarCurr)
    <=> v140736(VarCurr) ) ).

tff(addAssignment_78448,axiom,
    ! [VarCurr: state_type] :
      ( v140736(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78447,axiom,
    ! [VarCurr: state_type] :
      ( v140716(VarCurr)
    <=> v140718(VarCurr) ) ).

tff(addAssignment_78446,axiom,
    ! [VarCurr: state_type] :
      ( v140718(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78445,axiom,
    ! [VarCurr: state_type] :
      ( v140712(VarCurr)
    <=> v140714(VarCurr) ) ).

tff(addAssignment_78444,axiom,
    ! [VarCurr: state_type] :
      ( v140714(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78443,axiom,
    ! [VarCurr: state_type] :
      ( v140638(VarCurr)
    <=> v140640(VarCurr) ) ).

tff(addAssignment_78442,axiom,
    ! [VarCurr: state_type] :
      ( v140640(VarCurr)
    <=> v140642(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140689(VarNext)
       => ( v140642(VarNext)
        <=> v140642(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1960,axiom,
    ! [VarNext: state_type] :
      ( v140689(VarNext)
     => ( v140642(VarNext)
      <=> v140699(VarNext) ) ) ).

tff(addAssignment_78441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140699(VarNext)
      <=> v140697(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140700(VarCurr)
     => ( v140697(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1491,axiom,
    ! [VarCurr: state_type] :
      ( v140700(VarCurr)
     => ( v140697(VarCurr)
      <=> v140652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18811,axiom,
    ! [VarCurr: state_type] :
      ( v140700(VarCurr)
    <=> ( v140701(VarCurr)
        & v140702(VarCurr) ) ) ).

tff(writeUnaryOperator_10672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140702(VarCurr)
    <=> v140648(VarCurr) ) ).

tff(writeUnaryOperator_10671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140701(VarCurr)
    <=> v140644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140689(VarNext)
      <=> v140690(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140690(VarNext)
      <=> ( v140691(VarNext)
          & v140684(VarNext) ) ) ) ).

tff(writeUnaryOperator_10670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140691(VarNext)
      <=> v140693(VarNext) ) ) ).

tff(addAssignment_78440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140693(VarNext)
      <=> v140684(VarCurr) ) ) ).

tff(addAssignment_78439,axiom,
    ! [VarCurr: state_type] :
      ( v140684(VarCurr)
    <=> v140686(VarCurr) ) ).

tff(addAssignment_78438,axiom,
    ! [VarCurr: state_type] :
      ( v140686(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78437,axiom,
    ! [VarCurr: state_type] :
      ( v140652(VarCurr)
    <=> v140654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18808,axiom,
    ! [VarCurr: state_type] :
      ( v140654(VarCurr)
    <=> ( v140668(VarCurr)
        | v140675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18807,axiom,
    ! [VarCurr: state_type] :
      ( v140675(VarCurr)
    <=> ( v140676(VarCurr)
        & v140680(VarCurr) ) ) ).

tff(writeUnaryOperator_10669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140680(VarCurr)
    <=> v140681(VarCurr) ) ).

tff(addAssignment_78436,axiom,
    ! [VarCurr: state_type] :
      ( v140681(VarCurr)
    <=> v140682(VarCurr) ) ).

tff(addAssignment_78435,axiom,
    ! [VarCurr: state_type] :
      ( v140682(VarCurr)
    <=> v140666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18806,axiom,
    ! [VarCurr: state_type] :
      ( v140676(VarCurr)
    <=> ( v140640(VarCurr)
        & v140677(VarCurr) ) ) ).

tff(writeUnaryOperator_10668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140677(VarCurr)
    <=> v140678(VarCurr) ) ).

tff(addAssignment_78434,axiom,
    ! [VarCurr: state_type] :
      ( v140678(VarCurr)
    <=> v140679(VarCurr) ) ).

tff(addAssignment_78433,axiom,
    ! [VarCurr: state_type] :
      ( v140679(VarCurr)
    <=> v140658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18805,axiom,
    ! [VarCurr: state_type] :
      ( v140668(VarCurr)
    <=> ( v140669(VarCurr)
        & v140672(VarCurr) ) ) ).

tff(writeUnaryOperator_10667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140672(VarCurr)
    <=> v140673(VarCurr) ) ).

tff(addAssignment_78432,axiom,
    ! [VarCurr: state_type] :
      ( v140673(VarCurr)
    <=> v140674(VarCurr) ) ).

tff(addAssignment_78431,axiom,
    ! [VarCurr: state_type] :
      ( v140674(VarCurr)
    <=> v140666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18804,axiom,
    ! [VarCurr: state_type] :
      ( v140669(VarCurr)
    <=> ( v140656(VarCurr)
        & v140670(VarCurr) ) ) ).

tff(addAssignment_78430,axiom,
    ! [VarCurr: state_type] :
      ( v140670(VarCurr)
    <=> v140671(VarCurr) ) ).

tff(addAssignment_78429,axiom,
    ! [VarCurr: state_type] :
      ( v140671(VarCurr)
    <=> v140658(VarCurr) ) ).

tff(addAssignment_78428,axiom,
    ! [VarCurr: state_type] :
      ( v140666(VarCurr)
    <=> v140594(VarCurr) ) ).

tff(addAssignment_78427,axiom,
    ! [VarCurr: state_type] :
      ( v140658(VarCurr)
    <=> v140660(VarCurr) ) ).

tff(addAssignment_78426,axiom,
    ! [VarCurr: state_type] :
      ( v140660(VarCurr)
    <=> v140662(VarCurr,5) ) ).

tff(addAssignment_78425,axiom,
    ! [VarCurr: state_type] :
      ( v140662(VarCurr,5)
    <=> v140664(VarCurr,5) ) ).

tff(addAssignment_78424,axiom,
    ! [VarCurr: state_type] :
      ( v140656(VarCurr)
    <=> $true ) ).

tff(addAssignment_78423,axiom,
    ! [VarCurr: state_type] :
      ( v140648(VarCurr)
    <=> v140650(VarCurr) ) ).

tff(addAssignment_78422,axiom,
    ! [VarCurr: state_type] :
      ( v140650(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78421,axiom,
    ! [VarCurr: state_type] :
      ( v140644(VarCurr)
    <=> v140646(VarCurr) ) ).

tff(addAssignment_78420,axiom,
    ! [VarCurr: state_type] :
      ( v140646(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78419,axiom,
    ! [VarCurr: state_type] :
      ( v140594(VarCurr)
    <=> v140596(VarCurr,1) ) ).

tff(addAssignment_78418,axiom,
    ! [VarCurr: state_type] :
      ( v140596(VarCurr,1)
    <=> v140598(VarCurr,1) ) ).

tff(addAssignment_78417,axiom,
    ! [VarNext: state_type] :
      ( v140598(VarNext,1)
    <=> v140620(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140621(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v140620(VarNext,B)
            <=> v140598(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1959,axiom,
    ! [VarNext: state_type] :
      ( v140621(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v140620(VarNext,B)
          <=> v140631(VarNext,B) ) ) ) ).

tff(addAssignment_78416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v140631(VarNext,B)
          <=> v140629(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140632(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v140629(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1490,axiom,
    ! [VarCurr: state_type] :
      ( v140632(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v140629(VarCurr,B)
          <=> v140608(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18803,axiom,
    ! [VarCurr: state_type] :
      ( v140632(VarCurr)
    <=> ( v140633(VarCurr)
        & v140634(VarCurr) ) ) ).

tff(writeUnaryOperator_10666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140634(VarCurr)
    <=> v140604(VarCurr) ) ).

tff(writeUnaryOperator_10665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140633(VarCurr)
    <=> v140600(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140621(VarNext)
      <=> v140622(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140622(VarNext)
      <=> ( v140623(VarNext)
          & v140616(VarNext) ) ) ) ).

tff(writeUnaryOperator_10664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140623(VarNext)
      <=> v140625(VarNext) ) ) ).

tff(addAssignment_78415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140625(VarNext)
      <=> v140616(VarCurr) ) ) ).

tff(addAssignment_78414,axiom,
    ! [VarCurr: state_type] :
      ( v140616(VarCurr)
    <=> v140618(VarCurr) ) ).

tff(addAssignment_78413,axiom,
    ! [VarCurr: state_type] :
      ( v140618(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78412,axiom,
    ! [VarCurr: state_type] :
      ( v140608(VarCurr,1)
    <=> v140610(VarCurr,1) ) ).

tff(addAssignment_78411,axiom,
    ! [VarCurr: state_type] :
      ( v140610(VarCurr,1)
    <=> v140612(VarCurr,1) ) ).

tff(addAssignment_78410,axiom,
    ! [VarCurr: state_type] :
      ( v140612(VarCurr,1)
    <=> v140613(VarCurr,1) ) ).

tff(addAssignment_78409,axiom,
    ! [VarCurr: state_type] :
      ( v140613(VarCurr,0)
    <=> v140614(VarCurr) ) ).

tff(addAssignment_78408,axiom,
    ! [VarCurr: state_type] :
      ( v140613(VarCurr,1)
    <=> v140592(VarCurr) ) ).

tff(addAssignment_78407,axiom,
    ! [VarCurr: state_type] :
      ( v140604(VarCurr)
    <=> v140606(VarCurr) ) ).

tff(addAssignment_78406,axiom,
    ! [VarCurr: state_type] :
      ( v140606(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78405,axiom,
    ! [VarCurr: state_type] :
      ( v140600(VarCurr)
    <=> v140602(VarCurr) ) ).

tff(addAssignment_78404,axiom,
    ! [VarCurr: state_type] :
      ( v140602(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78403,axiom,
    ! [VarCurr: state_type] :
      ( v140580(VarCurr)
    <=> v140582(VarCurr) ) ).

tff(addAssignment_78402,axiom,
    ! [VarCurr: state_type] :
      ( v140582(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_78401,axiom,
    ! [VarCurr: state_type] :
      ( v140576(VarCurr)
    <=> v140578(VarCurr) ) ).

tff(addAssignment_78400,axiom,
    ! [VarCurr: state_type] :
      ( v140578(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_78399,axiom,
    ! [VarCurr: state_type] :
      ( v140560(VarCurr)
    <=> v5755(VarCurr,0) ) ).

tff(addAssignment_78398,axiom,
    ! [VarCurr: state_type] :
      ( v5755(VarCurr,0)
    <=> v5757(VarCurr,0) ) ).

tff(addAssignment_78397,axiom,
    ! [VarNext: state_type] :
      ( v5757(VarNext,0)
    <=> v140562(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140563(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140562(VarNext,B)
            <=> v5757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1958,axiom,
    ! [VarNext: state_type] :
      ( v140563(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140562(VarNext,B)
          <=> v5794(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140563(VarNext)
      <=> v140564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140564(VarNext)
      <=> ( v140566(VarNext)
          & v5779(VarNext) ) ) ) ).

tff(writeUnaryOperator_10663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140566(VarNext)
      <=> v5788(VarNext) ) ) ).

tff(addAssignment_78396,axiom,
    ! [VarCurr: state_type] :
      ( v5767(VarCurr,0)
    <=> v5769(VarCurr,0) ) ).

tff(addAssignment_78395,axiom,
    ! [VarCurr: state_type] :
      ( v5769(VarCurr,0)
    <=> v5771(VarCurr,0) ) ).

tff(addAssignment_78394,axiom,
    ! [VarCurr: state_type] :
      ( v5771(VarCurr,0)
    <=> v5772(VarCurr,0) ) ).

tff(addAssignment_78393,axiom,
    ! [VarCurr: state_type] :
      ( v140532(VarCurr)
    <=> v942(VarCurr,1) ) ).

tff(addAssignment_78392,axiom,
    ! [VarCurr: state_type] :
      ( v942(VarCurr,1)
    <=> v944(VarCurr,1) ) ).

tff(addAssignment_78391,axiom,
    ! [VarNext: state_type] :
      ( v944(VarNext,1)
    <=> v140542(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140543(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v140542(VarNext,B)
            <=> v944(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1957,axiom,
    ! [VarNext: state_type] :
      ( v140543(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v140542(VarNext,B)
          <=> v140553(VarNext,B) ) ) ) ).

tff(addAssignment_78390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v140553(VarNext,B)
          <=> v140551(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140554(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v140551(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1489,axiom,
    ! [VarCurr: state_type] :
      ( v140554(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v140551(VarCurr,B)
          <=> v954(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18798,axiom,
    ! [VarCurr: state_type] :
      ( v140554(VarCurr)
    <=> ( v140555(VarCurr)
        & v140556(VarCurr) ) ) ).

tff(writeUnaryOperator_10662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140556(VarCurr)
    <=> v950(VarCurr) ) ).

tff(writeUnaryOperator_10661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140555(VarCurr)
    <=> v946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140543(VarNext)
      <=> v140544(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140544(VarNext)
      <=> ( v140545(VarNext)
          & v140538(VarNext) ) ) ) ).

tff(writeUnaryOperator_10660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140545(VarNext)
      <=> v140547(VarNext) ) ) ).

tff(addAssignment_78389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140547(VarNext)
      <=> v140538(VarCurr) ) ) ).

tff(addAssignment_78388,axiom,
    ! [VarCurr: state_type] :
      ( v140538(VarCurr)
    <=> v140540(VarCurr) ) ).

tff(addAssignment_78387,axiom,
    ! [VarCurr: state_type] :
      ( v140540(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_78386,axiom,
    ! [VarCurr: state_type] :
      ( v954(VarCurr,1)
    <=> v956(VarCurr,1) ) ).

tff(addAssignment_78385,axiom,
    ! [VarCurr: state_type] :
      ( v956(VarCurr,1)
    <=> v958(VarCurr,1) ) ).

tff(addAssignment_78384,axiom,
    ! [VarCurr: state_type] :
      ( v958(VarCurr,1)
    <=> v140533(VarCurr,1) ) ).

tff(addAssignment_78383,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,0)
    <=> v96669(VarCurr) ) ).

tff(addAssignment_78382,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,1)
    <=> v940(VarCurr) ) ).

tff(addAssignment_78381,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,2)
    <=> v960(VarCurr) ) ).

tff(addAssignment_78380,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,3)
    <=> v140536(VarCurr) ) ).

tff(addAssignment_78379,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,4)
    <=> v140535(VarCurr) ) ).

tff(addAssignment_78378,axiom,
    ! [VarCurr: state_type] :
      ( v140533(VarCurr,5)
    <=> v140534(VarCurr) ) ).

tff(addAssignment_78377,axiom,
    ! [VarCurr: state_type] :
      ( v82909(VarCurr)
    <=> v5755(VarCurr,3) ) ).

tff(addAssignment_78376,axiom,
    ! [VarCurr: state_type] :
      ( v5755(VarCurr,3)
    <=> v5757(VarCurr,3) ) ).

tff(addAssignment_78375,axiom,
    ! [VarNext: state_type] :
      ( v5757(VarNext,3)
    <=> v140524(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140525(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140524(VarNext,B)
            <=> v5757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1956,axiom,
    ! [VarNext: state_type] :
      ( v140525(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140524(VarNext,B)
          <=> v5794(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140525(VarNext)
      <=> v140526(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140526(VarNext)
      <=> ( v140528(VarNext)
          & v5779(VarNext) ) ) ) ).

tff(writeUnaryOperator_10659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140528(VarNext)
      <=> v5788(VarNext) ) ) ).

tff(addAssignment_78374,axiom,
    ! [VarCurr: state_type] :
      ( v5767(VarCurr,3)
    <=> v5769(VarCurr,3) ) ).

tff(addAssignment_78373,axiom,
    ! [VarCurr: state_type] :
      ( v5769(VarCurr,3)
    <=> v5771(VarCurr,3) ) ).

tff(addAssignment_78372,axiom,
    ! [VarCurr: state_type] :
      ( v5771(VarCurr,3)
    <=> v5772(VarCurr,3) ) ).

tff(addAssignment_78371,axiom,
    ! [VarCurr: state_type] :
      ( v5773(VarCurr)
    <=> v964(VarCurr,18) ) ).

tff(addAssignment_78370,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,18)
    <=> v966(VarCurr,18) ) ).

tff(addAssignment_78369,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,18)
    <=> v5526(VarCurr,18) ) ).

tff(addAssignment_78368,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,18)
    <=> v5523(VarCurr,18) ) ).

tff(addAssignment_78367,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,18)
    <=> v5525(VarCurr,18) ) ).

tff(addAssignment_78366,axiom,
    ! [VarNext: state_type] :
      ( v5525(VarNext,18)
    <=> v140516(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140517(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140516(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1955,axiom,
    ! [VarNext: state_type] :
      ( v140517(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140516(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140517(VarNext)
      <=> v140518(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140518(VarNext)
      <=> ( v140520(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_10658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140520(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_78365,axiom,
    ! [VarCurr: state_type] :
      ( v83988(VarCurr,18)
    <=> v83990(VarCurr,18) ) ).

tff(addAssignment_78364,axiom,
    ! [VarCurr: state_type] :
      ( v83990(VarCurr,18)
    <=> v83999(VarCurr,18) ) ).

tff(addAssignment_78363,axiom,
    ! [VarCurr: state_type] :
      ( v83992(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78362,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,18)
    <=> v5516(VarCurr,18) ) ).

tff(addAssignment_78361,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,18)
    <=> v5518(VarCurr,18) ) ).

tff(addAssignment_78360,axiom,
    ! [VarNext: state_type] :
      ( v5518(VarNext,18)
    <=> v140508(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140509(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140508(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1954,axiom,
    ! [VarNext: state_type] :
      ( v140509(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140508(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140509(VarNext)
      <=> v140510(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140510(VarNext)
      <=> ( v140512(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_10657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140512(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_78359,axiom,
    ! [VarCurr: state_type] :
      ( v83938(VarCurr,18)
    <=> v83940(VarCurr,18) ) ).

tff(addAssignment_78358,axiom,
    ! [VarCurr: state_type] :
      ( v83940(VarCurr,18)
    <=> v83949(VarCurr,18) ) ).

tff(addAssignment_78357,axiom,
    ! [VarCurr: state_type] :
      ( v83942(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78356,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,18)
    <=> v5509(VarCurr,18) ) ).

tff(addAssignment_78355,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,18)
    <=> v5511(VarCurr,18) ) ).

tff(addAssignment_78354,axiom,
    ! [VarNext: state_type] :
      ( v5511(VarNext,18)
    <=> v140500(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140501(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140500(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1953,axiom,
    ! [VarNext: state_type] :
      ( v140501(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140500(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140501(VarNext)
      <=> v140502(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140502(VarNext)
      <=> ( v140504(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_10656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140504(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_78353,axiom,
    ! [VarCurr: state_type] :
      ( v83888(VarCurr,18)
    <=> v83890(VarCurr,18) ) ).

tff(addAssignment_78352,axiom,
    ! [VarCurr: state_type] :
      ( v83890(VarCurr,18)
    <=> v83899(VarCurr,18) ) ).

tff(addAssignment_78351,axiom,
    ! [VarCurr: state_type] :
      ( v83892(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78350,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,18)
    <=> v5502(VarCurr,18) ) ).

tff(addAssignment_78349,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,18)
    <=> v5504(VarCurr,18) ) ).

tff(addAssignment_78348,axiom,
    ! [VarNext: state_type] :
      ( v5504(VarNext,18)
    <=> v140492(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140493(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140492(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1952,axiom,
    ! [VarNext: state_type] :
      ( v140493(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140492(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140493(VarNext)
      <=> v140494(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140494(VarNext)
      <=> ( v140496(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_10655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140496(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_78347,axiom,
    ! [VarCurr: state_type] :
      ( v83838(VarCurr,18)
    <=> v83840(VarCurr,18) ) ).

tff(addAssignment_78346,axiom,
    ! [VarCurr: state_type] :
      ( v83840(VarCurr,18)
    <=> v83849(VarCurr,18) ) ).

tff(addAssignment_78345,axiom,
    ! [VarCurr: state_type] :
      ( v83842(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78344,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,18)
    <=> v5495(VarCurr,18) ) ).

tff(addAssignment_78343,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,18)
    <=> v5497(VarCurr,18) ) ).

tff(addAssignment_78342,axiom,
    ! [VarNext: state_type] :
      ( v5497(VarNext,18)
    <=> v140484(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140485(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140484(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1951,axiom,
    ! [VarNext: state_type] :
      ( v140485(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140484(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140485(VarNext)
      <=> v140486(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140486(VarNext)
      <=> ( v140488(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_10654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140488(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_78341,axiom,
    ! [VarCurr: state_type] :
      ( v83788(VarCurr,18)
    <=> v83790(VarCurr,18) ) ).

tff(addAssignment_78340,axiom,
    ! [VarCurr: state_type] :
      ( v83790(VarCurr,18)
    <=> v83799(VarCurr,18) ) ).

tff(addAssignment_78339,axiom,
    ! [VarCurr: state_type] :
      ( v83792(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78338,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,18)
    <=> v5489(VarCurr,18) ) ).

tff(addAssignment_78337,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,18)
    <=> v5491(VarCurr,18) ) ).

tff(addAssignment_78336,axiom,
    ! [VarNext: state_type] :
      ( v5491(VarNext,18)
    <=> v140476(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140477(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140476(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1950,axiom,
    ! [VarNext: state_type] :
      ( v140477(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140476(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140477(VarNext)
      <=> v140478(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140478(VarNext)
      <=> ( v140480(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_10653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140480(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_78335,axiom,
    ! [VarCurr: state_type] :
      ( v83738(VarCurr,18)
    <=> v83740(VarCurr,18) ) ).

tff(addAssignment_78334,axiom,
    ! [VarCurr: state_type] :
      ( v83740(VarCurr,18)
    <=> v83749(VarCurr,18) ) ).

tff(addAssignment_78333,axiom,
    ! [VarCurr: state_type] :
      ( v83742(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78332,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,18)
    <=> v5482(VarCurr,18) ) ).

tff(addAssignment_78331,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,18)
    <=> v5484(VarCurr,18) ) ).

tff(addAssignment_78330,axiom,
    ! [VarNext: state_type] :
      ( v5484(VarNext,18)
    <=> v140468(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140469(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140468(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1949,axiom,
    ! [VarNext: state_type] :
      ( v140469(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140468(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140469(VarNext)
      <=> v140470(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140470(VarNext)
      <=> ( v140472(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_10652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140472(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_78329,axiom,
    ! [VarCurr: state_type] :
      ( v83688(VarCurr,18)
    <=> v83690(VarCurr,18) ) ).

tff(addAssignment_78328,axiom,
    ! [VarCurr: state_type] :
      ( v83690(VarCurr,18)
    <=> v83699(VarCurr,18) ) ).

tff(addAssignment_78327,axiom,
    ! [VarCurr: state_type] :
      ( v83692(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78326,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,18)
    <=> v5475(VarCurr,18) ) ).

tff(addAssignment_78325,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,18)
    <=> v5477(VarCurr,18) ) ).

tff(addAssignment_78324,axiom,
    ! [VarNext: state_type] :
      ( v5477(VarNext,18)
    <=> v140460(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140461(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140460(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1948,axiom,
    ! [VarNext: state_type] :
      ( v140461(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140460(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140461(VarNext)
      <=> v140462(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140462(VarNext)
      <=> ( v140464(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_10651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140464(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_78323,axiom,
    ! [VarCurr: state_type] :
      ( v83638(VarCurr,18)
    <=> v83640(VarCurr,18) ) ).

tff(addAssignment_78322,axiom,
    ! [VarCurr: state_type] :
      ( v83640(VarCurr,18)
    <=> v83649(VarCurr,18) ) ).

tff(addAssignment_78321,axiom,
    ! [VarCurr: state_type] :
      ( v83642(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78320,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,18)
    <=> v5468(VarCurr,18) ) ).

tff(addAssignment_78319,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,18)
    <=> v5470(VarCurr,18) ) ).

tff(addAssignment_78318,axiom,
    ! [VarNext: state_type] :
      ( v5470(VarNext,18)
    <=> v140452(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140453(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140452(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1947,axiom,
    ! [VarNext: state_type] :
      ( v140453(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140452(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140453(VarNext)
      <=> v140454(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140454(VarNext)
      <=> ( v140456(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_10650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140456(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_78317,axiom,
    ! [VarCurr: state_type] :
      ( v83588(VarCurr,18)
    <=> v83590(VarCurr,18) ) ).

tff(addAssignment_78316,axiom,
    ! [VarCurr: state_type] :
      ( v83590(VarCurr,18)
    <=> v83599(VarCurr,18) ) ).

tff(addAssignment_78315,axiom,
    ! [VarCurr: state_type] :
      ( v83592(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78314,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,18)
    <=> v5461(VarCurr,18) ) ).

tff(addAssignment_78313,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,18)
    <=> v5463(VarCurr,18) ) ).

tff(addAssignment_78312,axiom,
    ! [VarNext: state_type] :
      ( v5463(VarNext,18)
    <=> v140444(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140445(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140444(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1946,axiom,
    ! [VarNext: state_type] :
      ( v140445(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140444(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140445(VarNext)
      <=> v140446(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140446(VarNext)
      <=> ( v140448(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_10649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140448(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_78311,axiom,
    ! [VarCurr: state_type] :
      ( v83538(VarCurr,18)
    <=> v83540(VarCurr,18) ) ).

tff(addAssignment_78310,axiom,
    ! [VarCurr: state_type] :
      ( v83540(VarCurr,18)
    <=> v83549(VarCurr,18) ) ).

tff(addAssignment_78309,axiom,
    ! [VarCurr: state_type] :
      ( v83542(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78308,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,18)
    <=> v5454(VarCurr,18) ) ).

tff(addAssignment_78307,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,18)
    <=> v5456(VarCurr,18) ) ).

tff(addAssignment_78306,axiom,
    ! [VarNext: state_type] :
      ( v5456(VarNext,18)
    <=> v140436(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140437(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140436(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1945,axiom,
    ! [VarNext: state_type] :
      ( v140437(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140436(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140437(VarNext)
      <=> v140438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140438(VarNext)
      <=> ( v140440(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_10648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140440(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_78305,axiom,
    ! [VarCurr: state_type] :
      ( v83488(VarCurr,18)
    <=> v83490(VarCurr,18) ) ).

tff(addAssignment_78304,axiom,
    ! [VarCurr: state_type] :
      ( v83490(VarCurr,18)
    <=> v83499(VarCurr,18) ) ).

tff(addAssignment_78303,axiom,
    ! [VarCurr: state_type] :
      ( v83492(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78302,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,18)
    <=> v5447(VarCurr,18) ) ).

tff(addAssignment_78301,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,18)
    <=> v5449(VarCurr,18) ) ).

tff(addAssignment_78300,axiom,
    ! [VarNext: state_type] :
      ( v5449(VarNext,18)
    <=> v140428(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140429(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140428(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1944,axiom,
    ! [VarNext: state_type] :
      ( v140429(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140428(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140429(VarNext)
      <=> v140430(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140430(VarNext)
      <=> ( v140432(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_10647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140432(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_78299,axiom,
    ! [VarCurr: state_type] :
      ( v83438(VarCurr,18)
    <=> v83440(VarCurr,18) ) ).

tff(addAssignment_78298,axiom,
    ! [VarCurr: state_type] :
      ( v83440(VarCurr,18)
    <=> v83449(VarCurr,18) ) ).

tff(addAssignment_78297,axiom,
    ! [VarCurr: state_type] :
      ( v83442(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78296,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,18)
    <=> v5440(VarCurr,18) ) ).

tff(addAssignment_78295,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,18)
    <=> v5442(VarCurr,18) ) ).

tff(addAssignment_78294,axiom,
    ! [VarNext: state_type] :
      ( v5442(VarNext,18)
    <=> v140420(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140421(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140420(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1943,axiom,
    ! [VarNext: state_type] :
      ( v140421(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140420(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140421(VarNext)
      <=> v140422(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140422(VarNext)
      <=> ( v140424(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_10646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140424(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_78293,axiom,
    ! [VarCurr: state_type] :
      ( v83388(VarCurr,18)
    <=> v83390(VarCurr,18) ) ).

tff(addAssignment_78292,axiom,
    ! [VarCurr: state_type] :
      ( v83390(VarCurr,18)
    <=> v83399(VarCurr,18) ) ).

tff(addAssignment_78291,axiom,
    ! [VarCurr: state_type] :
      ( v83392(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78290,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,18)
    <=> v5433(VarCurr,18) ) ).

tff(addAssignment_78289,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,18)
    <=> v5435(VarCurr,18) ) ).

tff(addAssignment_78288,axiom,
    ! [VarNext: state_type] :
      ( v5435(VarNext,18)
    <=> v140412(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140413(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140412(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1942,axiom,
    ! [VarNext: state_type] :
      ( v140413(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140412(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140413(VarNext)
      <=> v140414(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140414(VarNext)
      <=> ( v140416(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_10645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140416(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_78287,axiom,
    ! [VarCurr: state_type] :
      ( v83338(VarCurr,18)
    <=> v83340(VarCurr,18) ) ).

tff(addAssignment_78286,axiom,
    ! [VarCurr: state_type] :
      ( v83340(VarCurr,18)
    <=> v83349(VarCurr,18) ) ).

tff(addAssignment_78285,axiom,
    ! [VarCurr: state_type] :
      ( v83342(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78284,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,18)
    <=> v5426(VarCurr,18) ) ).

tff(addAssignment_78283,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,18)
    <=> v5428(VarCurr,18) ) ).

tff(addAssignment_78282,axiom,
    ! [VarNext: state_type] :
      ( v5428(VarNext,18)
    <=> v140404(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140405(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140404(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1941,axiom,
    ! [VarNext: state_type] :
      ( v140405(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140404(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140405(VarNext)
      <=> v140406(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140406(VarNext)
      <=> ( v140408(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_10644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140408(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_78281,axiom,
    ! [VarCurr: state_type] :
      ( v83288(VarCurr,18)
    <=> v83290(VarCurr,18) ) ).

tff(addAssignment_78280,axiom,
    ! [VarCurr: state_type] :
      ( v83290(VarCurr,18)
    <=> v83299(VarCurr,18) ) ).

tff(addAssignment_78279,axiom,
    ! [VarCurr: state_type] :
      ( v83292(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78278,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,18)
    <=> v5420(VarCurr,18) ) ).

tff(addAssignment_78277,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,18)
    <=> v5422(VarCurr,18) ) ).

tff(addAssignment_78276,axiom,
    ! [VarNext: state_type] :
      ( v5422(VarNext,18)
    <=> v140396(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140397(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140396(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1940,axiom,
    ! [VarNext: state_type] :
      ( v140397(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140396(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140397(VarNext)
      <=> v140398(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140398(VarNext)
      <=> ( v140400(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_10643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140400(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_78275,axiom,
    ! [VarCurr: state_type] :
      ( v82920(VarCurr,18)
    <=> v82922(VarCurr,18) ) ).

tff(addAssignment_78274,axiom,
    ! [VarCurr: state_type] :
      ( v82922(VarCurr,18)
    <=> v83246(VarCurr,18) ) ).

tff(addAssignment_78273,axiom,
    ! [VarCurr: state_type] :
      ( v82924(VarCurr,18)
    <=> v82926(VarCurr,18) ) ).

tff(addAssignment_78272,axiom,
    ! [VarCurr: state_type] :
      ( v82926(VarCurr,18)
    <=> v82928(VarCurr,18) ) ).

tff(addAssignment_78271,axiom,
    ! [VarCurr: state_type] :
      ( v82928(VarCurr,18)
    <=> v82930(VarCurr,18) ) ).

tff(addAssignment_78270,axiom,
    ! [VarCurr: state_type] :
      ( v82930(VarCurr,18)
    <=> v82932(VarCurr,18) ) ).

tff(addAssignment_78269,axiom,
    ! [VarCurr: state_type] :
      ( v82932(VarCurr,18)
    <=> v83008(VarCurr,18) ) ).

tff(addAssignment_78268,axiom,
    ! [VarCurr: state_type] :
      ( v82934(VarCurr)
    <=> v82936(VarCurr) ) ).

tff(addAssignment_78267,axiom,
    ! [VarCurr: state_type] :
      ( v82936(VarCurr)
    <=> v82938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140379(VarNext)
       => ( v82938(VarNext)
        <=> v82938(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1939,axiom,
    ! [VarNext: state_type] :
      ( v140379(VarNext)
     => ( v82938(VarNext)
      <=> v140389(VarNext) ) ) ).

tff(addAssignment_78266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140389(VarNext)
      <=> v140387(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140390(VarCurr)
     => ( v140387(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1488,axiom,
    ! [VarCurr: state_type] :
      ( v140390(VarCurr)
     => ( v140387(VarCurr)
      <=> v82948(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18761,axiom,
    ! [VarCurr: state_type] :
      ( v140390(VarCurr)
    <=> ( v140391(VarCurr)
        & v140392(VarCurr) ) ) ).

tff(writeUnaryOperator_10642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140392(VarCurr)
    <=> v82944(VarCurr) ) ).

tff(writeUnaryOperator_10641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140391(VarCurr)
    <=> v82940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140379(VarNext)
      <=> v140380(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140380(VarNext)
      <=> ( v140381(VarNext)
          & v140374(VarNext) ) ) ) ).

tff(writeUnaryOperator_10640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140381(VarNext)
      <=> v140383(VarNext) ) ) ).

tff(addAssignment_78265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140383(VarNext)
      <=> v140374(VarCurr) ) ) ).

tff(addAssignment_78264,axiom,
    ! [VarCurr: state_type] :
      ( v140374(VarCurr)
    <=> v140376(VarCurr) ) ).

tff(addAssignment_78263,axiom,
    ! [VarCurr: state_type] :
      ( v140376(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78262,axiom,
    ! [VarCurr: state_type] :
      ( v82948(VarCurr)
    <=> v82950(VarCurr) ) ).

tff(addAssignment_78261,axiom,
    ! [VarCurr: state_type] :
      ( v82950(VarCurr)
    <=> v82952(VarCurr) ) ).

tff(addAssignment_78260,axiom,
    ! [VarCurr: state_type] :
      ( v82952(VarCurr)
    <=> v82954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18758,axiom,
    ! [VarCurr: state_type] :
      ( v82954(VarCurr)
    <=> ( v140364(VarCurr)
        & v140367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18757,axiom,
    ! [VarCurr: state_type] :
      ( v140367(VarCurr)
    <=> ( v140368(VarCurr)
        | v140371(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2095,axiom,
    ! [VarCurr: state_type] :
      ( v140371(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v140372(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v140372(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v140372(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v140372(VarCurr,0) ) ) ) ).

tff(addAssignment_78259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v140372(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_78258,axiom,
    ! [VarCurr: state_type] :
      ( v140372(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18756,axiom,
    ! [VarCurr: state_type] :
      ( v140368(VarCurr)
    <=> ( v140369(VarCurr)
        | v140370(VarCurr) ) ) ).

tff(writeUnaryOperator_10639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140370(VarCurr)
    <=> v140049(VarCurr) ) ).

tff(writeUnaryOperator_10638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140369(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18755,axiom,
    ! [VarCurr: state_type] :
      ( v140364(VarCurr)
    <=> ( v140365(VarCurr)
        & v135529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18754,axiom,
    ! [VarCurr: state_type] :
      ( v140365(VarCurr)
    <=> ( v140366(VarCurr)
        & v140339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18753,axiom,
    ! [VarCurr: state_type] :
      ( v140366(VarCurr)
    <=> ( v82956(VarCurr)
        & v140314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18752,axiom,
    ! [VarCurr: state_type] :
      ( v140339(VarCurr)
    <=> ( v140341(VarCurr)
        | v140361(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6843,axiom,
    ! [VarCurr: state_type] :
      ( v140361(VarCurr)
    <=> ( v140362(VarCurr)
        & v133661(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_2094,axiom,
    ! [VarCurr: state_type] :
      ( v140362(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18751,axiom,
    ! [VarCurr: state_type] :
      ( v140341(VarCurr)
    <=> ( v140342(VarCurr)
        | v140359(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6842,axiom,
    ! [VarCurr: state_type] :
      ( v140359(VarCurr)
    <=> ( v140360(VarCurr)
        & v133661(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_2093,axiom,
    ! [VarCurr: state_type] :
      ( v140360(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18750,axiom,
    ! [VarCurr: state_type] :
      ( v140342(VarCurr)
    <=> ( v140343(VarCurr)
        | v140357(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6841,axiom,
    ! [VarCurr: state_type] :
      ( v140357(VarCurr)
    <=> ( v140358(VarCurr)
        & v133661(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_2092,axiom,
    ! [VarCurr: state_type] :
      ( v140358(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18749,axiom,
    ! [VarCurr: state_type] :
      ( v140343(VarCurr)
    <=> ( v140344(VarCurr)
        | v140355(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6840,axiom,
    ! [VarCurr: state_type] :
      ( v140355(VarCurr)
    <=> ( v140356(VarCurr)
        & v133661(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_2091,axiom,
    ! [VarCurr: state_type] :
      ( v140356(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18748,axiom,
    ! [VarCurr: state_type] :
      ( v140344(VarCurr)
    <=> ( v140345(VarCurr)
        | v140353(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6839,axiom,
    ! [VarCurr: state_type] :
      ( v140353(VarCurr)
    <=> ( v140354(VarCurr)
        & v133661(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_2090,axiom,
    ! [VarCurr: state_type] :
      ( v140354(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18747,axiom,
    ! [VarCurr: state_type] :
      ( v140345(VarCurr)
    <=> ( v140346(VarCurr)
        | v140351(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6838,axiom,
    ! [VarCurr: state_type] :
      ( v140351(VarCurr)
    <=> ( v140352(VarCurr)
        & v133661(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_2089,axiom,
    ! [VarCurr: state_type] :
      ( v140352(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18746,axiom,
    ! [VarCurr: state_type] :
      ( v140346(VarCurr)
    <=> ( v140347(VarCurr)
        | v140349(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6837,axiom,
    ! [VarCurr: state_type] :
      ( v140349(VarCurr)
    <=> ( v140350(VarCurr)
        & v133661(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_2088,axiom,
    ! [VarCurr: state_type] :
      ( v140350(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18745,axiom,
    ! [VarCurr: state_type] :
      ( v140347(VarCurr)
    <=> ( v140348(VarCurr)
        & v133661(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_2087,axiom,
    ! [VarCurr: state_type] :
      ( v140348(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18744,axiom,
    ! [VarCurr: state_type] :
      ( v140314(VarCurr)
    <=> ( v140316(VarCurr)
        | v140336(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6836,axiom,
    ! [VarCurr: state_type] :
      ( v140336(VarCurr)
    <=> ( v140337(VarCurr)
        & v89156(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_2086,axiom,
    ! [VarCurr: state_type] :
      ( v140337(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18743,axiom,
    ! [VarCurr: state_type] :
      ( v140316(VarCurr)
    <=> ( v140317(VarCurr)
        | v140334(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6835,axiom,
    ! [VarCurr: state_type] :
      ( v140334(VarCurr)
    <=> ( v140335(VarCurr)
        & v89156(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_2085,axiom,
    ! [VarCurr: state_type] :
      ( v140335(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18742,axiom,
    ! [VarCurr: state_type] :
      ( v140317(VarCurr)
    <=> ( v140318(VarCurr)
        | v140332(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6834,axiom,
    ! [VarCurr: state_type] :
      ( v140332(VarCurr)
    <=> ( v140333(VarCurr)
        & v89156(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_2084,axiom,
    ! [VarCurr: state_type] :
      ( v140333(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18741,axiom,
    ! [VarCurr: state_type] :
      ( v140318(VarCurr)
    <=> ( v140319(VarCurr)
        | v140330(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6833,axiom,
    ! [VarCurr: state_type] :
      ( v140330(VarCurr)
    <=> ( v140331(VarCurr)
        & v89156(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_2083,axiom,
    ! [VarCurr: state_type] :
      ( v140331(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18740,axiom,
    ! [VarCurr: state_type] :
      ( v140319(VarCurr)
    <=> ( v140320(VarCurr)
        | v140328(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6832,axiom,
    ! [VarCurr: state_type] :
      ( v140328(VarCurr)
    <=> ( v140329(VarCurr)
        & v89156(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_2082,axiom,
    ! [VarCurr: state_type] :
      ( v140329(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18739,axiom,
    ! [VarCurr: state_type] :
      ( v140320(VarCurr)
    <=> ( v140321(VarCurr)
        | v140326(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6831,axiom,
    ! [VarCurr: state_type] :
      ( v140326(VarCurr)
    <=> ( v140327(VarCurr)
        & v89156(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_2081,axiom,
    ! [VarCurr: state_type] :
      ( v140327(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18738,axiom,
    ! [VarCurr: state_type] :
      ( v140321(VarCurr)
    <=> ( v140322(VarCurr)
        | v140324(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6830,axiom,
    ! [VarCurr: state_type] :
      ( v140324(VarCurr)
    <=> ( v140325(VarCurr)
        & v89156(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_2080,axiom,
    ! [VarCurr: state_type] :
      ( v140325(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18737,axiom,
    ! [VarCurr: state_type] :
      ( v140322(VarCurr)
    <=> ( v140323(VarCurr)
        & v89156(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_2079,axiom,
    ! [VarCurr: state_type] :
      ( v140323(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18736,axiom,
    ! [VarCurr: state_type] :
      ( v82956(VarCurr)
    <=> ( v140300(VarCurr)
        & v140305(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6829,axiom,
    ! [VarCurr: state_type] :
      ( v140305(VarCurr)
    <=> ( v140307(VarCurr)
        | v140288(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6828,axiom,
    ! [VarCurr: state_type] :
      ( v140307(VarCurr)
    <=> ( v140308(VarCurr)
        | v140288(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6827,axiom,
    ! [VarCurr: state_type] :
      ( v140308(VarCurr)
    <=> ( v140309(VarCurr)
        | v140288(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6826,axiom,
    ! [VarCurr: state_type] :
      ( v140309(VarCurr)
    <=> ( v140310(VarCurr)
        | v140288(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6825,axiom,
    ! [VarCurr: state_type] :
      ( v140310(VarCurr)
    <=> ( v140311(VarCurr)
        | v140288(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6824,axiom,
    ! [VarCurr: state_type] :
      ( v140311(VarCurr)
    <=> ( v140312(VarCurr)
        | v140288(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6823,axiom,
    ! [VarCurr: state_type] :
      ( v140312(VarCurr)
    <=> ( v140288(VarCurr,0)
        | v140288(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18735,axiom,
    ! [VarCurr: state_type] :
      ( v140300(VarCurr)
    <=> ( v74(VarCurr)
        & v140301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18734,axiom,
    ! [VarCurr: state_type] :
      ( v140301(VarCurr)
    <=> ( v140302(VarCurr)
        | v140303(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6822,axiom,
    ! [VarCurr: state_type] :
      ( v140303(VarCurr)
    <=> ( v8(VarCurr,4)
        & v140304(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18733,axiom,
    ! [VarCurr: state_type] :
      ( v140304(VarCurr)
    <=> ( v84583(VarCurr)
        | v89527(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6821,axiom,
    ! [VarCurr: state_type] :
      ( v140302(VarCurr)
    <=> ( v8(VarCurr,1)
        | v8(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v140288(VarCurr,B)
      <=> ( v140290(VarCurr,B)
          & v89154(VarCurr,B) ) ) ) ).

tff(addAssignment_78257,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,0)
    <=> v140298(VarCurr) ) ).

tff(addAssignment_78256,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,1)
    <=> v140297(VarCurr) ) ).

tff(addAssignment_78255,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,2)
    <=> v140296(VarCurr) ) ).

tff(addAssignment_78254,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,3)
    <=> v140295(VarCurr) ) ).

tff(addAssignment_78253,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,4)
    <=> v140294(VarCurr) ) ).

tff(addAssignment_78252,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,5)
    <=> v140293(VarCurr) ) ).

tff(addAssignment_78251,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,6)
    <=> v140292(VarCurr) ) ).

tff(addAssignment_78250,axiom,
    ! [VarCurr: state_type] :
      ( v140290(VarCurr,7)
    <=> v140291(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2078,axiom,
    ! [VarCurr: state_type] :
      ( v140298(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2077,axiom,
    ! [VarCurr: state_type] :
      ( v140297(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2076,axiom,
    ! [VarCurr: state_type] :
      ( v140296(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2075,axiom,
    ! [VarCurr: state_type] :
      ( v140295(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2074,axiom,
    ! [VarCurr: state_type] :
      ( v140294(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2073,axiom,
    ! [VarCurr: state_type] :
      ( v140293(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2072,axiom,
    ! [VarCurr: state_type] :
      ( v140292(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2071,axiom,
    ! [VarCurr: state_type] :
      ( v140291(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_78249,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,4)
    <=> v10(VarCurr,4) ) ).

tff(addAssignment_78248,axiom,
    ! [VarCurr: state_type] :
      ( v10(VarCurr,4)
    <=> v12(VarCurr,4) ) ).

tff(addAssignment_78247,axiom,
    ! [VarNext: state_type] :
      ( v12(VarNext,4)
    <=> v140270(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140271(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140270(VarNext,B)
            <=> v12(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1938,axiom,
    ! [VarNext: state_type] :
      ( v140271(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140270(VarNext,B)
          <=> v140281(VarNext,B) ) ) ) ).

tff(addAssignment_78246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140281(VarNext,B)
          <=> v140279(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140282(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140279(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1487,axiom,
    ! [VarCurr: state_type] :
      ( v140282(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140279(VarCurr,B)
          <=> v62(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18732,axiom,
    ! [VarCurr: state_type] :
      ( v140282(VarCurr)
    <=> ( v140283(VarCurr)
        & v140284(VarCurr) ) ) ).

tff(writeUnaryOperator_10637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140284(VarCurr)
    <=> v38(VarCurr) ) ).

tff(writeUnaryOperator_10636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140283(VarCurr)
    <=> v14(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140271(VarNext)
      <=> v140272(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140272(VarNext)
      <=> ( v140273(VarNext)
          & v140266(VarNext) ) ) ) ).

tff(writeUnaryOperator_10635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140273(VarNext)
      <=> v140275(VarNext) ) ) ).

tff(addAssignment_78245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140275(VarNext)
      <=> v140266(VarCurr) ) ) ).

tff(addAssignment_78244,axiom,
    ! [VarCurr: state_type] :
      ( v140266(VarCurr)
    <=> v140268(VarCurr) ) ).

tff(addAssignment_78243,axiom,
    ! [VarCurr: state_type] :
      ( v140268(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78242,axiom,
    ! [VarCurr: state_type] :
      ( v62(VarCurr,4)
    <=> v64(VarCurr,4) ) ).

tff(addAssignment_78241,axiom,
    ! [VarCurr: state_type] :
      ( v64(VarCurr,4)
    <=> v66(VarCurr,4) ) ).

tff(addAssignment_78240,axiom,
    ! [VarCurr: state_type] :
      ( v66(VarCurr,4)
    <=> v140264(VarCurr,4) ) ).

tff(addAssignment_78239,axiom,
    ! [VarCurr: state_type] :
      ( v140264(VarCurr,0)
    <=> v72(VarCurr) ) ).

tff(addAssignment_78238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,1) )
     => ( v140264(VarCurr,B)
      <=> v68(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6820,axiom,
    ! [VarCurr: state_type] :
      ( v68(VarCurr,4)
    <=> ( v140257(VarCurr)
        | v140259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18729,axiom,
    ! [VarCurr: state_type] :
      ( v140259(VarCurr)
    <=> ( v140260(VarCurr)
        & v140263(VarCurr) ) ) ).

tff(writeUnaryOperator_10634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140263(VarCurr)
    <=> v82958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18728,axiom,
    ! [VarCurr: state_type] :
      ( v140260(VarCurr)
    <=> ( v140261(VarCurr)
        & v140262(VarCurr) ) ) ).

tff(writeUnaryOperator_10633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140262(VarCurr)
    <=> v140253(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6819,axiom,
    ! [VarCurr: state_type] :
      ( v140261(VarCurr)
    <=> ( v8(VarCurr,4)
        & v779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18727,axiom,
    ! [VarCurr: state_type] :
      ( v140257(VarCurr)
    <=> ( v140258(VarCurr)
        & v82958(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6818,axiom,
    ! [VarCurr: state_type] :
      ( v140258(VarCurr)
    <=> ( v8(VarCurr,1)
        & v779(VarCurr) ) ) ).

tff(addAssignment_78237,axiom,
    ! [VarCurr: state_type] :
      ( v140253(VarCurr)
    <=> v140255(VarCurr) ) ).

tff(addAssignment_78236,axiom,
    ! [VarCurr: state_type] :
      ( v140255(VarCurr)
    <=> v96418(VarCurr) ) ).

tff(addAssignment_78235,axiom,
    ! [VarCurr: state_type] :
      ( v82958(VarCurr)
    <=> v82960(VarCurr) ) ).

tff(addAssignment_78234,axiom,
    ! [VarCurr: state_type] :
      ( v82960(VarCurr)
    <=> v82962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18726,axiom,
    ! [VarCurr: state_type] :
      ( v82962(VarCurr)
    <=> ( v140251(VarCurr)
        & v5776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18725,axiom,
    ! [VarCurr: state_type] :
      ( v140251(VarCurr)
    <=> ( v1001(VarCurr)
        & v940(VarCurr) ) ) ).

tff(addAssignment_78233,axiom,
    ! [VarCurr: state_type] :
      ( v5776(VarCurr)
    <=> v964(VarCurr,19) ) ).

tff(addAssignment_78232,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,19)
    <=> v966(VarCurr,19) ) ).

tff(addAssignment_78231,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,19)
    <=> v5526(VarCurr,19) ) ).

tff(addAssignment_78230,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,19)
    <=> v5523(VarCurr,19) ) ).

tff(addAssignment_78229,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,19)
    <=> v5525(VarCurr,19) ) ).

tff(addAssignment_78228,axiom,
    ! [VarNext: state_type] :
      ( v5525(VarNext,19)
    <=> v140243(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140244(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140243(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1937,axiom,
    ! [VarNext: state_type] :
      ( v140244(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140243(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140244(VarNext)
      <=> v140245(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140245(VarNext)
      <=> ( v140247(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_10632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140247(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_78227,axiom,
    ! [VarCurr: state_type] :
      ( v83988(VarCurr,19)
    <=> v83990(VarCurr,19) ) ).

tff(addAssignment_78226,axiom,
    ! [VarCurr: state_type] :
      ( v83990(VarCurr,19)
    <=> v83999(VarCurr,19) ) ).

tff(addAssignment_78225,axiom,
    ! [VarCurr: state_type] :
      ( v83992(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78224,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,19)
    <=> v5516(VarCurr,19) ) ).

tff(addAssignment_78223,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,19)
    <=> v5518(VarCurr,19) ) ).

tff(addAssignment_78222,axiom,
    ! [VarNext: state_type] :
      ( v5518(VarNext,19)
    <=> v140235(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140236(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140235(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1936,axiom,
    ! [VarNext: state_type] :
      ( v140236(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140235(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140236(VarNext)
      <=> v140237(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140237(VarNext)
      <=> ( v140239(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_10631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140239(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_78221,axiom,
    ! [VarCurr: state_type] :
      ( v83938(VarCurr,19)
    <=> v83940(VarCurr,19) ) ).

tff(addAssignment_78220,axiom,
    ! [VarCurr: state_type] :
      ( v83940(VarCurr,19)
    <=> v83949(VarCurr,19) ) ).

tff(addAssignment_78219,axiom,
    ! [VarCurr: state_type] :
      ( v83942(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78218,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,19)
    <=> v5509(VarCurr,19) ) ).

tff(addAssignment_78217,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,19)
    <=> v5511(VarCurr,19) ) ).

tff(addAssignment_78216,axiom,
    ! [VarNext: state_type] :
      ( v5511(VarNext,19)
    <=> v140227(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140227(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1935,axiom,
    ! [VarNext: state_type] :
      ( v140228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140227(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140228(VarNext)
      <=> v140229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140229(VarNext)
      <=> ( v140231(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_10630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140231(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_78215,axiom,
    ! [VarCurr: state_type] :
      ( v83888(VarCurr,19)
    <=> v83890(VarCurr,19) ) ).

tff(addAssignment_78214,axiom,
    ! [VarCurr: state_type] :
      ( v83890(VarCurr,19)
    <=> v83899(VarCurr,19) ) ).

tff(addAssignment_78213,axiom,
    ! [VarCurr: state_type] :
      ( v83892(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78212,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,19)
    <=> v5502(VarCurr,19) ) ).

tff(addAssignment_78211,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,19)
    <=> v5504(VarCurr,19) ) ).

tff(addAssignment_78210,axiom,
    ! [VarNext: state_type] :
      ( v5504(VarNext,19)
    <=> v140219(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140220(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140219(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1934,axiom,
    ! [VarNext: state_type] :
      ( v140220(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140219(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140220(VarNext)
      <=> v140221(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140221(VarNext)
      <=> ( v140223(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_10629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140223(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_78209,axiom,
    ! [VarCurr: state_type] :
      ( v83838(VarCurr,19)
    <=> v83840(VarCurr,19) ) ).

tff(addAssignment_78208,axiom,
    ! [VarCurr: state_type] :
      ( v83840(VarCurr,19)
    <=> v83849(VarCurr,19) ) ).

tff(addAssignment_78207,axiom,
    ! [VarCurr: state_type] :
      ( v83842(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78206,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,19)
    <=> v5495(VarCurr,19) ) ).

tff(addAssignment_78205,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,19)
    <=> v5497(VarCurr,19) ) ).

tff(addAssignment_78204,axiom,
    ! [VarNext: state_type] :
      ( v5497(VarNext,19)
    <=> v140211(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140212(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140211(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1933,axiom,
    ! [VarNext: state_type] :
      ( v140212(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140211(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140212(VarNext)
      <=> v140213(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140213(VarNext)
      <=> ( v140215(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_10628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140215(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_78203,axiom,
    ! [VarCurr: state_type] :
      ( v83788(VarCurr,19)
    <=> v83790(VarCurr,19) ) ).

tff(addAssignment_78202,axiom,
    ! [VarCurr: state_type] :
      ( v83790(VarCurr,19)
    <=> v83799(VarCurr,19) ) ).

tff(addAssignment_78201,axiom,
    ! [VarCurr: state_type] :
      ( v83792(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78200,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,19)
    <=> v5489(VarCurr,19) ) ).

tff(addAssignment_78199,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,19)
    <=> v5491(VarCurr,19) ) ).

tff(addAssignment_78198,axiom,
    ! [VarNext: state_type] :
      ( v5491(VarNext,19)
    <=> v140203(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140204(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140203(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1932,axiom,
    ! [VarNext: state_type] :
      ( v140204(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140203(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140204(VarNext)
      <=> v140205(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140205(VarNext)
      <=> ( v140207(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_10627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140207(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_78197,axiom,
    ! [VarCurr: state_type] :
      ( v83738(VarCurr,19)
    <=> v83740(VarCurr,19) ) ).

tff(addAssignment_78196,axiom,
    ! [VarCurr: state_type] :
      ( v83740(VarCurr,19)
    <=> v83749(VarCurr,19) ) ).

tff(addAssignment_78195,axiom,
    ! [VarCurr: state_type] :
      ( v83742(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78194,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,19)
    <=> v5482(VarCurr,19) ) ).

tff(addAssignment_78193,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,19)
    <=> v5484(VarCurr,19) ) ).

tff(addAssignment_78192,axiom,
    ! [VarNext: state_type] :
      ( v5484(VarNext,19)
    <=> v140195(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140196(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140195(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1931,axiom,
    ! [VarNext: state_type] :
      ( v140196(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140195(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140196(VarNext)
      <=> v140197(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140197(VarNext)
      <=> ( v140199(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_10626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140199(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_78191,axiom,
    ! [VarCurr: state_type] :
      ( v83688(VarCurr,19)
    <=> v83690(VarCurr,19) ) ).

tff(addAssignment_78190,axiom,
    ! [VarCurr: state_type] :
      ( v83690(VarCurr,19)
    <=> v83699(VarCurr,19) ) ).

tff(addAssignment_78189,axiom,
    ! [VarCurr: state_type] :
      ( v83692(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78188,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,19)
    <=> v5475(VarCurr,19) ) ).

tff(addAssignment_78187,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,19)
    <=> v5477(VarCurr,19) ) ).

tff(addAssignment_78186,axiom,
    ! [VarNext: state_type] :
      ( v5477(VarNext,19)
    <=> v140187(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140188(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140187(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1930,axiom,
    ! [VarNext: state_type] :
      ( v140188(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140187(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140188(VarNext)
      <=> v140189(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140189(VarNext)
      <=> ( v140191(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_10625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140191(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_78185,axiom,
    ! [VarCurr: state_type] :
      ( v83638(VarCurr,19)
    <=> v83640(VarCurr,19) ) ).

tff(addAssignment_78184,axiom,
    ! [VarCurr: state_type] :
      ( v83640(VarCurr,19)
    <=> v83649(VarCurr,19) ) ).

tff(addAssignment_78183,axiom,
    ! [VarCurr: state_type] :
      ( v83642(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78182,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,19)
    <=> v5468(VarCurr,19) ) ).

tff(addAssignment_78181,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,19)
    <=> v5470(VarCurr,19) ) ).

tff(addAssignment_78180,axiom,
    ! [VarNext: state_type] :
      ( v5470(VarNext,19)
    <=> v140179(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140180(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140179(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1929,axiom,
    ! [VarNext: state_type] :
      ( v140180(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140179(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140180(VarNext)
      <=> v140181(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140181(VarNext)
      <=> ( v140183(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_10624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140183(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_78179,axiom,
    ! [VarCurr: state_type] :
      ( v83588(VarCurr,19)
    <=> v83590(VarCurr,19) ) ).

tff(addAssignment_78178,axiom,
    ! [VarCurr: state_type] :
      ( v83590(VarCurr,19)
    <=> v83599(VarCurr,19) ) ).

tff(addAssignment_78177,axiom,
    ! [VarCurr: state_type] :
      ( v83592(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78176,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,19)
    <=> v5461(VarCurr,19) ) ).

tff(addAssignment_78175,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,19)
    <=> v5463(VarCurr,19) ) ).

tff(addAssignment_78174,axiom,
    ! [VarNext: state_type] :
      ( v5463(VarNext,19)
    <=> v140171(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140172(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140171(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1928,axiom,
    ! [VarNext: state_type] :
      ( v140172(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140171(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140172(VarNext)
      <=> v140173(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140173(VarNext)
      <=> ( v140175(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_10623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140175(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_78173,axiom,
    ! [VarCurr: state_type] :
      ( v83538(VarCurr,19)
    <=> v83540(VarCurr,19) ) ).

tff(addAssignment_78172,axiom,
    ! [VarCurr: state_type] :
      ( v83540(VarCurr,19)
    <=> v83549(VarCurr,19) ) ).

tff(addAssignment_78171,axiom,
    ! [VarCurr: state_type] :
      ( v83542(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78170,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,19)
    <=> v5454(VarCurr,19) ) ).

tff(addAssignment_78169,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,19)
    <=> v5456(VarCurr,19) ) ).

tff(addAssignment_78168,axiom,
    ! [VarNext: state_type] :
      ( v5456(VarNext,19)
    <=> v140163(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140163(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1927,axiom,
    ! [VarNext: state_type] :
      ( v140164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140163(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140164(VarNext)
      <=> v140165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140165(VarNext)
      <=> ( v140167(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_10622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140167(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_78167,axiom,
    ! [VarCurr: state_type] :
      ( v83488(VarCurr,19)
    <=> v83490(VarCurr,19) ) ).

tff(addAssignment_78166,axiom,
    ! [VarCurr: state_type] :
      ( v83490(VarCurr,19)
    <=> v83499(VarCurr,19) ) ).

tff(addAssignment_78165,axiom,
    ! [VarCurr: state_type] :
      ( v83492(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78164,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,19)
    <=> v5447(VarCurr,19) ) ).

tff(addAssignment_78163,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,19)
    <=> v5449(VarCurr,19) ) ).

tff(addAssignment_78162,axiom,
    ! [VarNext: state_type] :
      ( v5449(VarNext,19)
    <=> v140155(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140156(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140155(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1926,axiom,
    ! [VarNext: state_type] :
      ( v140156(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140155(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140156(VarNext)
      <=> v140157(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140157(VarNext)
      <=> ( v140159(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_10621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140159(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_78161,axiom,
    ! [VarCurr: state_type] :
      ( v83438(VarCurr,19)
    <=> v83440(VarCurr,19) ) ).

tff(addAssignment_78160,axiom,
    ! [VarCurr: state_type] :
      ( v83440(VarCurr,19)
    <=> v83449(VarCurr,19) ) ).

tff(addAssignment_78159,axiom,
    ! [VarCurr: state_type] :
      ( v83442(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78158,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,19)
    <=> v5440(VarCurr,19) ) ).

tff(addAssignment_78157,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,19)
    <=> v5442(VarCurr,19) ) ).

tff(addAssignment_78156,axiom,
    ! [VarNext: state_type] :
      ( v5442(VarNext,19)
    <=> v140147(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140148(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140147(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1925,axiom,
    ! [VarNext: state_type] :
      ( v140148(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140147(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140148(VarNext)
      <=> v140149(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140149(VarNext)
      <=> ( v140151(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_10620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140151(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_78155,axiom,
    ! [VarCurr: state_type] :
      ( v83388(VarCurr,19)
    <=> v83390(VarCurr,19) ) ).

tff(addAssignment_78154,axiom,
    ! [VarCurr: state_type] :
      ( v83390(VarCurr,19)
    <=> v83399(VarCurr,19) ) ).

tff(addAssignment_78153,axiom,
    ! [VarCurr: state_type] :
      ( v83392(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78152,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,19)
    <=> v5433(VarCurr,19) ) ).

tff(addAssignment_78151,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,19)
    <=> v5435(VarCurr,19) ) ).

tff(addAssignment_78150,axiom,
    ! [VarNext: state_type] :
      ( v5435(VarNext,19)
    <=> v140139(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140140(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140139(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1924,axiom,
    ! [VarNext: state_type] :
      ( v140140(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140139(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140140(VarNext)
      <=> v140141(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140141(VarNext)
      <=> ( v140143(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_10619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140143(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_78149,axiom,
    ! [VarCurr: state_type] :
      ( v83338(VarCurr,19)
    <=> v83340(VarCurr,19) ) ).

tff(addAssignment_78148,axiom,
    ! [VarCurr: state_type] :
      ( v83340(VarCurr,19)
    <=> v83349(VarCurr,19) ) ).

tff(addAssignment_78147,axiom,
    ! [VarCurr: state_type] :
      ( v83342(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78146,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,19)
    <=> v5426(VarCurr,19) ) ).

tff(addAssignment_78145,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,19)
    <=> v5428(VarCurr,19) ) ).

tff(addAssignment_78144,axiom,
    ! [VarNext: state_type] :
      ( v5428(VarNext,19)
    <=> v140131(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140132(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140131(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1923,axiom,
    ! [VarNext: state_type] :
      ( v140132(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140131(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140132(VarNext)
      <=> v140133(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140133(VarNext)
      <=> ( v140135(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_10618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140135(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_78143,axiom,
    ! [VarCurr: state_type] :
      ( v83288(VarCurr,19)
    <=> v83290(VarCurr,19) ) ).

tff(addAssignment_78142,axiom,
    ! [VarCurr: state_type] :
      ( v83290(VarCurr,19)
    <=> v83299(VarCurr,19) ) ).

tff(addAssignment_78141,axiom,
    ! [VarCurr: state_type] :
      ( v83292(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_78140,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,19)
    <=> v5420(VarCurr,19) ) ).

tff(addAssignment_78139,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,19)
    <=> v5422(VarCurr,19) ) ).

tff(addAssignment_78138,axiom,
    ! [VarNext: state_type] :
      ( v5422(VarNext,19)
    <=> v140123(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140124(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v140123(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1922,axiom,
    ! [VarNext: state_type] :
      ( v140124(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v140123(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140124(VarNext)
      <=> v140125(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140125(VarNext)
      <=> ( v140127(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_10617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140127(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_78137,axiom,
    ! [VarCurr: state_type] :
      ( v82920(VarCurr,19)
    <=> v82922(VarCurr,19) ) ).

tff(addAssignment_78136,axiom,
    ! [VarCurr: state_type] :
      ( v82922(VarCurr,19)
    <=> v83246(VarCurr,19) ) ).

tff(addAssignment_78135,axiom,
    ! [VarCurr: state_type] :
      ( v83038(VarCurr)
    <=> v83040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18692,axiom,
    ! [VarCurr: state_type] :
      ( v83040(VarCurr)
    <=> ( v140121(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2070,axiom,
    ! [VarCurr: state_type] :
      ( v140121(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_78134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83042(VarCurr,B)
      <=> v83044(VarCurr,B) ) ) ).

tff(addAssignment_78133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83044(VarCurr,B)
      <=> v83046(VarCurr,B) ) ) ).

tff(addAssignment_78132,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83046(VarNext,B)
      <=> v140113(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140114(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v140113(VarNext,B)
            <=> v83046(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1921,axiom,
    ! [VarNext: state_type] :
      ( v140114(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v140113(VarNext,B)
          <=> v135414(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140114(VarNext)
      <=> v140115(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140115(VarNext)
      <=> ( v140117(VarNext)
          & v135399(VarNext) ) ) ) ).

tff(writeUnaryOperator_10616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140117(VarNext)
      <=> v135408(VarNext) ) ) ).

tff(addAssignment_78131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83056(VarCurr,B)
      <=> v83058(VarCurr,B) ) ) ).

tff(addAssignment_78130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83058(VarCurr,B)
      <=> v83060(VarCurr,B) ) ) ).

tff(addAssignment_78129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83060(VarCurr,B)
      <=> v83062(VarCurr,B) ) ) ).

tff(addAssignment_78128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v83062(VarCurr,B)
      <=> v135340(VarCurr,B) ) ) ).

tff(addAssignment_78127,axiom,
    ! [VarCurr: state_type] :
      ( v83064(VarCurr)
    <=> v83066(VarCurr) ) ).

tff(addAssignment_78126,axiom,
    ! [VarCurr: state_type] :
      ( v83066(VarCurr)
    <=> v83068(VarCurr) ) ).

tff(addAssignment_78125,axiom,
    ! [VarCurr: state_type] :
      ( v83068(VarCurr)
    <=> v83070(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18689,axiom,
    ! [VarCurr: state_type] :
      ( v83070(VarCurr)
    <=> ( v140110(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18688,axiom,
    ! [VarCurr: state_type] :
      ( v140110(VarCurr)
    <=> ( v2878(VarCurr)
        & v140111(VarCurr) ) ) ).

tff(writeUnaryOperator_10615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140111(VarCurr)
    <=> v83072(VarCurr) ) ).

tff(addAssignment_78124,axiom,
    ! [VarCurr: state_type] :
      ( v83072(VarCurr)
    <=> v83074(VarCurr) ) ).

tff(addAssignment_78123,axiom,
    ! [VarCurr: state_type] :
      ( v83074(VarCurr)
    <=> v83076(VarCurr) ) ).

tff(addAssignment_78122,axiom,
    ! [VarCurr: state_type] :
      ( v83076(VarCurr)
    <=> v83078(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140093(VarNext)
       => ( v83078(VarNext)
        <=> v83078(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1920,axiom,
    ! [VarNext: state_type] :
      ( v140093(VarNext)
     => ( v83078(VarNext)
      <=> v140103(VarNext) ) ) ).

tff(addAssignment_78121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140103(VarNext)
      <=> v140101(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140104(VarCurr)
     => ( v140101(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1486,axiom,
    ! [VarCurr: state_type] :
      ( v140104(VarCurr)
     => ( v140101(VarCurr)
      <=> v83088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18687,axiom,
    ! [VarCurr: state_type] :
      ( v140104(VarCurr)
    <=> ( v140105(VarCurr)
        & v140106(VarCurr) ) ) ).

tff(writeUnaryOperator_10614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140106(VarCurr)
    <=> v83084(VarCurr) ) ).

tff(writeUnaryOperator_10613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140105(VarCurr)
    <=> v83080(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140093(VarNext)
      <=> v140094(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140094(VarNext)
      <=> ( v140095(VarNext)
          & v140088(VarNext) ) ) ) ).

tff(writeUnaryOperator_10612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v140095(VarNext)
      <=> v140097(VarNext) ) ) ).

tff(addAssignment_78120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v140097(VarNext)
      <=> v140088(VarCurr) ) ) ).

tff(addAssignment_78119,axiom,
    ! [VarCurr: state_type] :
      ( v140088(VarCurr)
    <=> v140090(VarCurr) ) ).

tff(addAssignment_78118,axiom,
    ! [VarCurr: state_type] :
      ( v140090(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78117,axiom,
    ! [VarCurr: state_type] :
      ( v83088(VarCurr)
    <=> v83090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18684,axiom,
    ! [VarCurr: state_type] :
      ( v83090(VarCurr)
    <=> ( v140080(VarCurr)
        | v140083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18683,axiom,
    ! [VarCurr: state_type] :
      ( v140083(VarCurr)
    <=> ( v83076(VarCurr)
        & v140084(VarCurr) ) ) ).

tff(writeUnaryOperator_10611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140084(VarCurr)
    <=> v140085(VarCurr) ) ).

tff(addAssignment_78116,axiom,
    ! [VarCurr: state_type] :
      ( v140085(VarCurr)
    <=> v140086(VarCurr) ) ).

tff(addAssignment_78115,axiom,
    ! [VarCurr: state_type] :
      ( v140086(VarCurr)
    <=> v140078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18682,axiom,
    ! [VarCurr: state_type] :
      ( v140080(VarCurr)
    <=> ( v83092(VarCurr)
        & v140081(VarCurr) ) ) ).

tff(addAssignment_78114,axiom,
    ! [VarCurr: state_type] :
      ( v140081(VarCurr)
    <=> v140082(VarCurr) ) ).

tff(addAssignment_78113,axiom,
    ! [VarCurr: state_type] :
      ( v140082(VarCurr)
    <=> v140078(VarCurr) ) ).

tff(addAssignment_78112,axiom,
    ! [VarCurr: state_type] :
      ( v140078(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_78111,axiom,
    ! [VarCurr: state_type] :
      ( v83092(VarCurr)
    <=> v83094(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83096(VarCurr)
     => ( v83094(VarCurr)
      <=> v140075(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1485,axiom,
    ! [VarCurr: state_type] :
      ( v83096(VarCurr)
     => ( v83094(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140076(VarCurr)
     => ( v140075(VarCurr)
      <=> v140069(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1484,axiom,
    ! [VarCurr: state_type] :
      ( v140076(VarCurr)
     => ( v140075(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18681,axiom,
    ! [VarCurr: state_type] :
      ( v140076(VarCurr)
    <=> ( v86877(VarCurr)
        | v82954(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140071(VarCurr)
     => ( v140069(VarCurr)
      <=> v140072(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1483,axiom,
    ! [VarCurr: state_type] :
      ( v140071(VarCurr)
     => ( v140069(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84897(VarCurr)
     => ( v140072(VarCurr)
      <=> v140073(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1482,axiom,
    ! [VarCurr: state_type] :
      ( v84897(VarCurr)
     => ( v140072(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101501(VarCurr)
     => ( v140073(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1481,axiom,
    ! [VarCurr: state_type] :
      ( v101501(VarCurr)
     => ( v140073(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18680,axiom,
    ! [VarCurr: state_type] :
      ( v140071(VarCurr)
    <=> ( v101598(VarCurr)
        & v101501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18679,axiom,
    ! [VarCurr: state_type] :
      ( v83096(VarCurr)
    <=> ( v140042(VarCurr)
        & v140044(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18678,axiom,
    ! [VarCurr: state_type] :
      ( v140044(VarCurr)
    <=> ( v140045(VarCurr)
        | v140066(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2069,axiom,
    ! [VarCurr: state_type] :
      ( v140066(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v140067(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v140067(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v140067(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v140067(VarCurr,0) ) ) ) ).

tff(addAssignment_78110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v140067(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_78109,axiom,
    ! [VarCurr: state_type] :
      ( v140067(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18677,axiom,
    ! [VarCurr: state_type] :
      ( v140045(VarCurr)
    <=> ( v140046(VarCurr)
        | v140047(VarCurr) ) ) ).

tff(writeUnaryOperator_10610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140047(VarCurr)
    <=> v140049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18676,axiom,
    ! [VarCurr: state_type] :
      ( v140049(VarCurr)
    <=> ( v140050(VarCurr)
        & v140061(VarCurr) ) ) ).

tff(writeUnaryOperator_10609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140061(VarCurr)
    <=> v140062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18675,axiom,
    ! [VarCurr: state_type] :
      ( v140062(VarCurr)
    <=> ( v140063(VarCurr)
        & v140065(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6817,axiom,
    ! [VarCurr: state_type] :
      ( v140065(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v101570(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18674,axiom,
    ! [VarCurr: state_type] :
      ( v140063(VarCurr)
    <=> ( v135621(VarCurr)
        | v140064(VarCurr) ) ) ).

tff(writeUnaryOperator_10608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140064(VarCurr)
    <=> v101570(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18673,axiom,
    ! [VarCurr: state_type] :
      ( v140050(VarCurr)
    <=> ( v140051(VarCurr)
        & v140056(VarCurr) ) ) ).

tff(writeUnaryOperator_10607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140056(VarCurr)
    <=> v140057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18672,axiom,
    ! [VarCurr: state_type] :
      ( v140057(VarCurr)
    <=> ( v140058(VarCurr)
        & v140060(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6816,axiom,
    ! [VarCurr: state_type] :
      ( v140060(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v101570(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18671,axiom,
    ! [VarCurr: state_type] :
      ( v140058(VarCurr)
    <=> ( v135615(VarCurr)
        | v140059(VarCurr) ) ) ).

tff(writeUnaryOperator_10606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140059(VarCurr)
    <=> v101570(VarCurr,1) ) ).

tff(writeUnaryOperator_10605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140051(VarCurr)
    <=> v140052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18670,axiom,
    ! [VarCurr: state_type] :
      ( v140052(VarCurr)
    <=> ( v140053(VarCurr)
        & v140055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18669,axiom,
    ! [VarCurr: state_type] :
      ( v140055(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v101570(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18668,axiom,
    ! [VarCurr: state_type] :
      ( v140053(VarCurr)
    <=> ( v135609(VarCurr)
        | v140054(VarCurr) ) ) ).

tff(writeUnaryOperator_10604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140054(VarCurr)
    <=> v101570(VarCurr,0) ) ).

tff(writeUnaryOperator_10603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v140046(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18667,axiom,
    ! [VarCurr: state_type] :
      ( v140042(VarCurr)
    <=> ( v140043(VarCurr)
        & v140017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18666,axiom,
    ! [VarCurr: state_type] :
      ( v140043(VarCurr)
    <=> ( v83098(VarCurr)
        & v139992(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18665,axiom,
    ! [VarCurr: state_type] :
      ( v140017(VarCurr)
    <=> ( v140019(VarCurr)
        | v140039(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6815,axiom,
    ! [VarCurr: state_type] :
      ( v140039(VarCurr)
    <=> ( v140040(VarCurr)
        & v101258(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_2068,axiom,
    ! [VarCurr: state_type] :
      ( v140040(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18664,axiom,
    ! [VarCurr: state_type] :
      ( v140019(VarCurr)
    <=> ( v140020(VarCurr)
        | v140037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6814,axiom,
    ! [VarCurr: state_type] :
      ( v140037(VarCurr)
    <=> ( v140038(VarCurr)
        & v101258(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_2067,axiom,
    ! [VarCurr: state_type] :
      ( v140038(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18663,axiom,
    ! [VarCurr: state_type] :
      ( v140020(VarCurr)
    <=> ( v140021(VarCurr)
        | v140035(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6813,axiom,
    ! [VarCurr: state_type] :
      ( v140035(VarCurr)
    <=> ( v140036(VarCurr)
        & v101258(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_2066,axiom,
    ! [VarCurr: state_type] :
      ( v140036(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18662,axiom,
    ! [VarCurr: state_type] :
      ( v140021(VarCurr)
    <=> ( v140022(VarCurr)
        | v140033(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6812,axiom,
    ! [VarCurr: state_type] :
      ( v140033(VarCurr)
    <=> ( v140034(VarCurr)
        & v101258(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_2065,axiom,
    ! [VarCurr: state_type] :
      ( v140034(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18661,axiom,
    ! [VarCurr: state_type] :
      ( v140022(VarCurr)
    <=> ( v140023(VarCurr)
        | v140031(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6811,axiom,
    ! [VarCurr: state_type] :
      ( v140031(VarCurr)
    <=> ( v140032(VarCurr)
        & v101258(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_2064,axiom,
    ! [VarCurr: state_type] :
      ( v140032(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18660,axiom,
    ! [VarCurr: state_type] :
      ( v140023(VarCurr)
    <=> ( v140024(VarCurr)
        | v140029(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6810,axiom,
    ! [VarCurr: state_type] :
      ( v140029(VarCurr)
    <=> ( v140030(VarCurr)
        & v101258(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_2063,axiom,
    ! [VarCurr: state_type] :
      ( v140030(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18659,axiom,
    ! [VarCurr: state_type] :
      ( v140024(VarCurr)
    <=> ( v140025(VarCurr)
        | v140027(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6809,axiom,
    ! [VarCurr: state_type] :
      ( v140027(VarCurr)
    <=> ( v140028(VarCurr)
        & v101258(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_2062,axiom,
    ! [VarCurr: state_type] :
      ( v140028(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18658,axiom,
    ! [VarCurr: state_type] :
      ( v140025(VarCurr)
    <=> ( v140026(VarCurr)
        & v101258(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_2061,axiom,
    ! [VarCurr: state_type] :
      ( v140026(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18657,axiom,
    ! [VarCurr: state_type] :
      ( v139992(VarCurr)
    <=> ( v139994(VarCurr)
        | v140014(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6808,axiom,
    ! [VarCurr: state_type] :
      ( v140014(VarCurr)
    <=> ( v140015(VarCurr)
        & v101469(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_2060,axiom,
    ! [VarCurr: state_type] :
      ( v140015(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18656,axiom,
    ! [VarCurr: state_type] :
      ( v139994(VarCurr)
    <=> ( v139995(VarCurr)
        | v140012(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6807,axiom,
    ! [VarCurr: state_type] :
      ( v140012(VarCurr)
    <=> ( v140013(VarCurr)
        & v101469(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_2059,axiom,
    ! [VarCurr: state_type] :
      ( v140013(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18655,axiom,
    ! [VarCurr: state_type] :
      ( v139995(VarCurr)
    <=> ( v139996(VarCurr)
        | v140010(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6806,axiom,
    ! [VarCurr: state_type] :
      ( v140010(VarCurr)
    <=> ( v140011(VarCurr)
        & v101469(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_2058,axiom,
    ! [VarCurr: state_type] :
      ( v140011(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18654,axiom,
    ! [VarCurr: state_type] :
      ( v139996(VarCurr)
    <=> ( v139997(VarCurr)
        | v140008(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6805,axiom,
    ! [VarCurr: state_type] :
      ( v140008(VarCurr)
    <=> ( v140009(VarCurr)
        & v101469(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_2057,axiom,
    ! [VarCurr: state_type] :
      ( v140009(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18653,axiom,
    ! [VarCurr: state_type] :
      ( v139997(VarCurr)
    <=> ( v139998(VarCurr)
        | v140006(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6804,axiom,
    ! [VarCurr: state_type] :
      ( v140006(VarCurr)
    <=> ( v140007(VarCurr)
        & v101469(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_2056,axiom,
    ! [VarCurr: state_type] :
      ( v140007(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18652,axiom,
    ! [VarCurr: state_type] :
      ( v139998(VarCurr)
    <=> ( v139999(VarCurr)
        | v140004(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6803,axiom,
    ! [VarCurr: state_type] :
      ( v140004(VarCurr)
    <=> ( v140005(VarCurr)
        & v101469(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_2055,axiom,
    ! [VarCurr: state_type] :
      ( v140005(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18651,axiom,
    ! [VarCurr: state_type] :
      ( v139999(VarCurr)
    <=> ( v140000(VarCurr)
        | v140002(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6802,axiom,
    ! [VarCurr: state_type] :
      ( v140002(VarCurr)
    <=> ( v140003(VarCurr)
        & v101469(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_2054,axiom,
    ! [VarCurr: state_type] :
      ( v140003(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18650,axiom,
    ! [VarCurr: state_type] :
      ( v140000(VarCurr)
    <=> ( v140001(VarCurr)
        & v101469(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_2053,axiom,
    ! [VarCurr: state_type] :
      ( v140001(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18649,axiom,
    ! [VarCurr: state_type] :
      ( v83098(VarCurr)
    <=> ( v139982(VarCurr)
        & v139990(VarCurr) ) ) ).

tff(writeUnaryOperator_10602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139990(VarCurr)
    <=> v88420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18648,axiom,
    ! [VarCurr: state_type] :
      ( v139982(VarCurr)
    <=> ( v139983(VarCurr)
        & v139989(VarCurr) ) ) ).

tff(writeUnaryOperator_10601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139989(VarCurr)
    <=> v84187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18647,axiom,
    ! [VarCurr: state_type] :
      ( v139983(VarCurr)
    <=> ( v139984(VarCurr)
        & v139988(VarCurr) ) ) ).

tff(writeUnaryOperator_10600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139988(VarCurr)
    <=> v127280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18646,axiom,
    ! [VarCurr: state_type] :
      ( v139984(VarCurr)
    <=> ( v139985(VarCurr)
        & v139987(VarCurr) ) ) ).

tff(writeUnaryOperator_10599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139987(VarCurr)
    <=> v97353(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6801,axiom,
    ! [VarCurr: state_type] :
      ( v139985(VarCurr)
    <=> ( v139986(VarCurr)
        & v8(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18645,axiom,
    ! [VarCurr: state_type] :
      ( v139986(VarCurr)
    <=> ( v74(VarCurr)
        & v83100(VarCurr) ) ) ).

tff(addAssignment_78108,axiom,
    ! [VarCurr: state_type] :
      ( v83100(VarCurr)
    <=> v83102(VarCurr) ) ).

tff(addAssignment_78107,axiom,
    ! [VarCurr: state_type] :
      ( v83102(VarCurr)
    <=> v83104(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139965(VarNext)
       => ( v83104(VarNext)
        <=> v83104(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1919,axiom,
    ! [VarNext: state_type] :
      ( v139965(VarNext)
     => ( v83104(VarNext)
      <=> v139975(VarNext) ) ) ).

tff(addAssignment_78106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139975(VarNext)
      <=> v139973(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139976(VarCurr)
     => ( v139973(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1480,axiom,
    ! [VarCurr: state_type] :
      ( v139976(VarCurr)
     => ( v139973(VarCurr)
      <=> v83114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18644,axiom,
    ! [VarCurr: state_type] :
      ( v139976(VarCurr)
    <=> ( v139977(VarCurr)
        & v139978(VarCurr) ) ) ).

tff(writeUnaryOperator_10598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139978(VarCurr)
    <=> v83110(VarCurr) ) ).

tff(writeUnaryOperator_10597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139977(VarCurr)
    <=> v83106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139965(VarNext)
      <=> v139966(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139966(VarNext)
      <=> ( v139967(VarNext)
          & v139960(VarNext) ) ) ) ).

tff(writeUnaryOperator_10596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139967(VarNext)
      <=> v139969(VarNext) ) ) ).

tff(addAssignment_78105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139969(VarNext)
      <=> v139960(VarCurr) ) ) ).

tff(addAssignment_78104,axiom,
    ! [VarCurr: state_type] :
      ( v139960(VarCurr)
    <=> v139962(VarCurr) ) ).

tff(addAssignment_78103,axiom,
    ! [VarCurr: state_type] :
      ( v139962(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78102,axiom,
    ! [VarCurr: state_type] :
      ( v83114(VarCurr)
    <=> v83116(VarCurr) ) ).

tff(addAssignment_78101,axiom,
    ! [VarCurr: state_type] :
      ( v83116(VarCurr)
    <=> v83118(VarCurr) ) ).

tff(addAssignment_78100,axiom,
    ! [VarCurr: state_type] :
      ( v83118(VarCurr)
    <=> v83120(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139953(VarCurr)
     => ( v83120(VarCurr)
      <=> v139958(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1479,axiom,
    ! [VarCurr: state_type] :
      ( v139953(VarCurr)
     => ( v83120(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83096(VarCurr)
     => ( v139958(VarCurr)
      <=> v83100(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1478,axiom,
    ! [VarCurr: state_type] :
      ( v83096(VarCurr)
     => ( v139958(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18641,axiom,
    ! [VarCurr: state_type] :
      ( v139953(VarCurr)
    <=> ( v139954(VarCurr)
        & v139955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18640,axiom,
    ! [VarCurr: state_type] :
      ( v139955(VarCurr)
    <=> ( v139956(VarCurr)
        | v139957(VarCurr) ) ) ).

tff(writeUnaryOperator_10595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139957(VarCurr)
    <=> v1051(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6800,axiom,
    ! [VarCurr: state_type] :
      ( v139956(VarCurr)
    <=> ( v1051(VarCurr)
        & v83122(VarCurr,2) ) ) ).

tff(addAssignment_78099,axiom,
    ! [VarCurr: state_type] :
      ( v139954(VarCurr)
    <=> v83152(VarCurr) ) ).

tff(addAssignment_78098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83124(VarCurr,B)
      <=> v83126(VarCurr,B) ) ) ).

tff(addAssignment_78097,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83126(VarNext,B)
      <=> v139945(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139946(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v139945(VarNext,B)
            <=> v83126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1918,axiom,
    ! [VarNext: state_type] :
      ( v139946(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v139945(VarNext,B)
          <=> v139938(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139946(VarNext)
      <=> v139947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139947(VarNext)
      <=> ( v139949(VarNext)
          & v139923(VarNext) ) ) ) ).

tff(writeUnaryOperator_10594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139949(VarNext)
      <=> v139932(VarNext) ) ) ).

tff(addAssignment_78096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83136(VarCurr,B)
      <=> v83138(VarCurr,B) ) ) ).

tff(addAssignment_78095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83138(VarCurr,B)
      <=> v139914(VarCurr,B) ) ) ).

tff(addAssignment_78094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83140(VarCurr,B)
      <=> v83142(VarCurr,B) ) ) ).

tff(addAssignment_78093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83142(VarCurr,B)
      <=> v83143(VarCurr,B) ) ) ).

tff(addAssignment_78092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v83122(VarCurr,B)
      <=> v83124(VarCurr,B) ) ) ).

tff(addAssignment_78091,axiom,
    ! [VarCurr: state_type] :
      ( v83124(VarCurr,2)
    <=> v83126(VarCurr,2) ) ).

tff(addAssignment_78090,axiom,
    ! [VarNext: state_type] :
      ( v83126(VarNext,2)
    <=> v139927(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139928(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v139927(VarNext,B)
            <=> v83126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1917,axiom,
    ! [VarNext: state_type] :
      ( v139928(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v139927(VarNext,B)
          <=> v139938(VarNext,B) ) ) ) ).

tff(addAssignment_78089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v139938(VarNext,B)
          <=> v139936(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139939(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v139936(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1477,axiom,
    ! [VarCurr: state_type] :
      ( v139939(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v139936(VarCurr,B)
          <=> v83136(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18637,axiom,
    ! [VarCurr: state_type] :
      ( v139939(VarCurr)
    <=> ( v139940(VarCurr)
        & v139941(VarCurr) ) ) ).

tff(writeUnaryOperator_10593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139941(VarCurr)
    <=> v83132(VarCurr) ) ).

tff(writeUnaryOperator_10592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139940(VarCurr)
    <=> v83128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139928(VarNext)
      <=> v139929(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139929(VarNext)
      <=> ( v139930(VarNext)
          & v139923(VarNext) ) ) ) ).

tff(writeUnaryOperator_10591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139930(VarNext)
      <=> v139932(VarNext) ) ) ).

tff(addAssignment_78088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139932(VarNext)
      <=> v139923(VarCurr) ) ) ).

tff(addAssignment_78087,axiom,
    ! [VarCurr: state_type] :
      ( v139923(VarCurr)
    <=> v139925(VarCurr) ) ).

tff(addAssignment_78086,axiom,
    ! [VarCurr: state_type] :
      ( v139925(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78085,axiom,
    ! [VarCurr: state_type] :
      ( v83136(VarCurr,2)
    <=> v83138(VarCurr,2) ) ).

tff(addAssignment_78084,axiom,
    ! [VarCurr: state_type] :
      ( v83138(VarCurr,2)
    <=> v139914(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139914(VarCurr,B)
      <=> ( v139915(VarCurr,B)
          | v139918(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139918(VarCurr,B)
      <=> ( v83124(VarCurr,B)
          & v139919(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139919(VarCurr,B)
      <=> ~ v139920(VarCurr,B) ) ) ).

tff(addAssignment_78083,axiom,
    ! [VarCurr: state_type] :
      ( v139920(VarCurr,0)
    <=> v139921(VarCurr) ) ).

tff(addAssignment_78082,axiom,
    ! [VarCurr: state_type] :
      ( v139920(VarCurr,1)
    <=> v139921(VarCurr) ) ).

tff(addAssignment_78081,axiom,
    ! [VarCurr: state_type] :
      ( v139920(VarCurr,2)
    <=> v139921(VarCurr) ) ).

tff(addAssignment_78080,axiom,
    ! [VarCurr: state_type] :
      ( v139921(VarCurr)
    <=> v83161(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139915(VarCurr,B)
      <=> ( v83140(VarCurr,B)
          & v139916(VarCurr,B) ) ) ) ).

tff(addAssignment_78079,axiom,
    ! [VarCurr: state_type] :
      ( v139916(VarCurr,0)
    <=> v139917(VarCurr) ) ).

tff(addAssignment_78078,axiom,
    ! [VarCurr: state_type] :
      ( v139916(VarCurr,1)
    <=> v139917(VarCurr) ) ).

tff(addAssignment_78077,axiom,
    ! [VarCurr: state_type] :
      ( v139916(VarCurr,2)
    <=> v139917(VarCurr) ) ).

tff(addAssignment_78076,axiom,
    ! [VarCurr: state_type] :
      ( v139917(VarCurr)
    <=> v83161(VarCurr) ) ).

tff(addAssignment_78075,axiom,
    ! [VarCurr: state_type] :
      ( v83161(VarCurr)
    <=> v83163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18634,axiom,
    ! [VarCurr: state_type] :
      ( v83163(VarCurr)
    <=> ( v139901(VarCurr)
        & v139913(VarCurr) ) ) ).

tff(writeUnaryOperator_10589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139913(VarCurr)
    <=> v84297(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18633,axiom,
    ! [VarCurr: state_type] :
      ( v139901(VarCurr)
    <=> ( v139902(VarCurr)
        & v139910(VarCurr) ) ) ).

tff(writeUnaryOperator_10588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139910(VarCurr)
    <=> v139911(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6799,axiom,
    ! [VarCurr: state_type] :
      ( v139911(VarCurr)
    <=> ( v84297(VarCurr,2)
        & v139912(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2052,axiom,
    ! [VarCurr: state_type] :
      ( v139912(VarCurr)
    <=> ( ( v83122(VarCurr,2)
        <=> $false )
        & ( v83122(VarCurr,1)
        <=> $false )
        & ( v83122(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18632,axiom,
    ! [VarCurr: state_type] :
      ( v139902(VarCurr)
    <=> ( v139903(VarCurr)
        & v139909(VarCurr) ) ) ).

tff(writeUnaryOperator_10587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139909(VarCurr)
    <=> v84295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18631,axiom,
    ! [VarCurr: state_type] :
      ( v139903(VarCurr)
    <=> ( v139904(VarCurr)
        & v84185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18630,axiom,
    ! [VarCurr: state_type] :
      ( v139904(VarCurr)
    <=> ( v139905(VarCurr)
        | v139907(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6798,axiom,
    ! [VarCurr: state_type] :
      ( v139907(VarCurr)
    <=> ( v83159(VarCurr)
        | v83122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18629,axiom,
    ! [VarCurr: state_type] :
      ( v139905(VarCurr)
    <=> ( v83165(VarCurr)
        & v139906(VarCurr) ) ) ).

tff(writeUnaryOperator_10586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139906(VarCurr)
    <=> v84099(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18628,axiom,
    ! [VarCurr: state_type] :
      ( v84295(VarCurr)
    <=> ( v139874(VarCurr)
        & v139883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6797,axiom,
    ! [VarCurr: state_type] :
      ( v139883(VarCurr)
    <=> ( v139885(VarCurr)
        | v139899(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6796,axiom,
    ! [VarCurr: state_type] :
      ( v139885(VarCurr)
    <=> ( v139886(VarCurr)
        | v139899(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6795,axiom,
    ! [VarCurr: state_type] :
      ( v139886(VarCurr)
    <=> ( v139887(VarCurr)
        | v139899(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6794,axiom,
    ! [VarCurr: state_type] :
      ( v139887(VarCurr)
    <=> ( v139888(VarCurr)
        | v139899(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6793,axiom,
    ! [VarCurr: state_type] :
      ( v139888(VarCurr)
    <=> ( v139889(VarCurr)
        | v139899(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6792,axiom,
    ! [VarCurr: state_type] :
      ( v139889(VarCurr)
    <=> ( v139890(VarCurr)
        | v139899(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6791,axiom,
    ! [VarCurr: state_type] :
      ( v139890(VarCurr)
    <=> ( v139891(VarCurr)
        | v139899(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6790,axiom,
    ! [VarCurr: state_type] :
      ( v139891(VarCurr)
    <=> ( v139892(VarCurr)
        | v139899(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6789,axiom,
    ! [VarCurr: state_type] :
      ( v139892(VarCurr)
    <=> ( v139893(VarCurr)
        | v139899(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6788,axiom,
    ! [VarCurr: state_type] :
      ( v139893(VarCurr)
    <=> ( v139894(VarCurr)
        | v139899(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6787,axiom,
    ! [VarCurr: state_type] :
      ( v139894(VarCurr)
    <=> ( v139895(VarCurr)
        | v139899(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6786,axiom,
    ! [VarCurr: state_type] :
      ( v139895(VarCurr)
    <=> ( v139896(VarCurr)
        | v139899(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6785,axiom,
    ! [VarCurr: state_type] :
      ( v139896(VarCurr)
    <=> ( v139897(VarCurr)
        | v139899(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6784,axiom,
    ! [VarCurr: state_type] :
      ( v139897(VarCurr)
    <=> ( v139898(VarCurr)
        | v139899(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6783,axiom,
    ! [VarCurr: state_type] :
      ( v139898(VarCurr)
    <=> ( v139899(VarCurr,0)
        | v139899(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139899(VarCurr,B)
      <=> ( v115141(VarCurr,B)
          & v85708(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18627,axiom,
    ! [VarCurr: state_type] :
      ( v139874(VarCurr)
    <=> ( v139875(VarCurr)
        & v139882(VarCurr) ) ) ).

tff(writeUnaryOperator_10585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139882(VarCurr)
    <=> v111651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18626,axiom,
    ! [VarCurr: state_type] :
      ( v139875(VarCurr)
    <=> ( v139876(VarCurr)
        & v139877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18625,axiom,
    ! [VarCurr: state_type] :
      ( v139877(VarCurr)
    <=> ( v139878(VarCurr)
        | v139881(VarCurr) ) ) ).

tff(writeUnaryOperator_10584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139881(VarCurr)
    <=> v139820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18624,axiom,
    ! [VarCurr: state_type] :
      ( v139878(VarCurr)
    <=> ( v139879(VarCurr)
        & v139880(VarCurr) ) ) ).

tff(writeUnaryOperator_10583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139880(VarCurr)
    <=> v126727(VarCurr) ) ).

tff(writeUnaryOperator_10582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139879(VarCurr)
    <=> v2878(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6782,axiom,
    ! [VarCurr: state_type] :
      ( v139876(VarCurr)
    <=> ( v84297(VarCurr,3)
        & v88418(VarCurr) ) ) ).

tff(addAssignment_78074,axiom,
    ! [VarCurr: state_type] :
      ( v84297(VarCurr,3)
    <=> v89072(VarCurr,3) ) ).

tff(addAssignment_78073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84299(VarCurr,B)
      <=> v84301(VarCurr,B) ) ) ).

tff(addAssignment_78072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84301(VarCurr,B)
      <=> v84303(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139857(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v84303(VarNext,B)
            <=> v84303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1916,axiom,
    ! [VarNext: state_type] :
      ( v139857(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v84303(VarNext,B)
          <=> v139867(VarNext,B) ) ) ) ).

tff(addAssignment_78071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139867(VarNext,B)
          <=> v139865(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139868(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139865(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1476,axiom,
    ! [VarCurr: state_type] :
      ( v139868(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139865(VarCurr,B)
          <=> v84313(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18623,axiom,
    ! [VarCurr: state_type] :
      ( v139868(VarCurr)
    <=> ( v139869(VarCurr)
        & v139870(VarCurr) ) ) ).

tff(writeUnaryOperator_10581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139870(VarCurr)
    <=> v84309(VarCurr) ) ).

tff(writeUnaryOperator_10580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139869(VarCurr)
    <=> v84305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139857(VarNext)
      <=> v139858(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139858(VarNext)
      <=> ( v139859(VarNext)
          & v139852(VarNext) ) ) ) ).

tff(writeUnaryOperator_10579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139859(VarNext)
      <=> v139861(VarNext) ) ) ).

tff(addAssignment_78070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139861(VarNext)
      <=> v139852(VarCurr) ) ) ).

tff(addAssignment_78069,axiom,
    ! [VarCurr: state_type] :
      ( v139852(VarCurr)
    <=> v139854(VarCurr) ) ).

tff(addAssignment_78068,axiom,
    ! [VarCurr: state_type] :
      ( v139854(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84313(VarCurr,B)
      <=> v84315(VarCurr,B) ) ) ).

tff(addAssignment_78066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84315(VarCurr,B)
      <=> v84317(VarCurr,B) ) ) ).

tff(addAssignment_78065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v84317(VarCurr,B)
      <=> v84319(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139794(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v84319(VarCurr,B)
          <=> v84299(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1475,axiom,
    ! [VarCurr: state_type] :
      ( v139794(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v84319(VarCurr,B)
          <=> v139846(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges7,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v139801(VarCurr)
        & ~ v139807(VarCurr)
        & ~ v139809(VarCurr)
        & ~ v139811(VarCurr)
        & ~ v139836(VarCurr)
        & ~ v139837(VarCurr)
        & ~ v139838(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> $false ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges6,axiom,
    ! [VarCurr: state_type] :
      ( v139838(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> b00001(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges5,axiom,
    ! [VarCurr: state_type] :
      ( v139837(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> b00110(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_6,axiom,
    ! [VarCurr: state_type] :
      ( v139836(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> v139848(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_6,axiom,
    ! [VarCurr: state_type] :
      ( v139811(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> b00100(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_11,axiom,
    ! [VarCurr: state_type] :
      ( v139809(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> b00011(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_21,axiom,
    ! [VarCurr: state_type] :
      ( v139807(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> b00010(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_21,axiom,
    ! [VarCurr: state_type] :
      ( v139801(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139846(VarCurr,B)
          <=> v139847(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139848(VarCurr,B)
          <=> b00010(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1474,axiom,
    ! [VarCurr: state_type] :
      ( v88815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139848(VarCurr,B)
          <=> v139849(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84321(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139849(VarCurr,B)
          <=> v139850(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1473,axiom,
    ! [VarCurr: state_type] :
      ( v84321(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139849(VarCurr,B)
          <=> b00101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139850(VarCurr,B)
          <=> b00001(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1472,axiom,
    ! [VarCurr: state_type] :
      ( v84488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139850(VarCurr,B)
          <=> $false ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_20,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84321(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139847(VarCurr,B)
          <=> b00001(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_20,axiom,
    ! [VarCurr: state_type] :
      ( v84321(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139847(VarCurr,B)
          <=> b00101(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18620,axiom,
    ! [VarCurr: state_type] :
      ( v139794(VarCurr)
    <=> ( v139795(VarCurr)
        | v139839(VarCurr) ) ) ).

tff(writeUnaryOperator_10578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139839(VarCurr)
    <=> v139840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18619,axiom,
    ! [VarCurr: state_type] :
      ( v139840(VarCurr)
    <=> ( v139841(VarCurr)
        | v88734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18618,axiom,
    ! [VarCurr: state_type] :
      ( v139841(VarCurr)
    <=> ( v139842(VarCurr)
        | v88687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18617,axiom,
    ! [VarCurr: state_type] :
      ( v139842(VarCurr)
    <=> ( v139843(VarCurr)
        | v88805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18616,axiom,
    ! [VarCurr: state_type] :
      ( v139843(VarCurr)
    <=> ( v139844(VarCurr)
        | v139835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18615,axiom,
    ! [VarCurr: state_type] :
      ( v139844(VarCurr)
    <=> ( v139845(VarCurr)
        | v139748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18614,axiom,
    ! [VarCurr: state_type] :
      ( v139845(VarCurr)
    <=> ( v139806(VarCurr)
        | v139557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18613,axiom,
    ! [VarCurr: state_type] :
      ( v139795(VarCurr)
    <=> ( v139796(VarCurr)
        | v139838(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18612,axiom,
    ! [VarCurr: state_type] :
      ( v139838(VarCurr)
    <=> ( v88811(VarCurr)
        & v88734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18611,axiom,
    ! [VarCurr: state_type] :
      ( v139796(VarCurr)
    <=> ( v139797(VarCurr)
        | v139837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18610,axiom,
    ! [VarCurr: state_type] :
      ( v139837(VarCurr)
    <=> ( v88686(VarCurr)
        & v88687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18609,axiom,
    ! [VarCurr: state_type] :
      ( v139797(VarCurr)
    <=> ( v139798(VarCurr)
        | v139836(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18608,axiom,
    ! [VarCurr: state_type] :
      ( v139836(VarCurr)
    <=> ( v88394(VarCurr)
        & v88805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18607,axiom,
    ! [VarCurr: state_type] :
      ( v139798(VarCurr)
    <=> ( v139799(VarCurr)
        | v139811(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18606,axiom,
    ! [VarCurr: state_type] :
      ( v139811(VarCurr)
    <=> ( v139812(VarCurr)
        & v139835(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2051,axiom,
    ! [VarCurr: state_type] :
      ( v139835(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18605,axiom,
    ! [VarCurr: state_type] :
      ( v139812(VarCurr)
    <=> ( v139813(VarCurr)
        & v139834(VarCurr) ) ) ).

tff(writeUnaryOperator_10577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139834(VarCurr)
    <=> v111651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18604,axiom,
    ! [VarCurr: state_type] :
      ( v139813(VarCurr)
    <=> ( v88418(VarCurr)
        & v139814(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18603,axiom,
    ! [VarCurr: state_type] :
      ( v139814(VarCurr)
    <=> ( v139815(VarCurr)
        | v139818(VarCurr) ) ) ).

tff(writeUnaryOperator_10576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139818(VarCurr)
    <=> v139820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18602,axiom,
    ! [VarCurr: state_type] :
      ( v139820(VarCurr)
    <=> ( v139821(VarCurr)
        & v139830(VarCurr) ) ) ).

tff(writeUnaryOperator_10575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139830(VarCurr)
    <=> v139831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18601,axiom,
    ! [VarCurr: state_type] :
      ( v139831(VarCurr)
    <=> ( v139832(VarCurr)
        & v139833(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6781,axiom,
    ! [VarCurr: state_type] :
      ( v139833(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v126737(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18600,axiom,
    ! [VarCurr: state_type] :
      ( v139832(VarCurr)
    <=> ( v88904(VarCurr)
        | v126934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18599,axiom,
    ! [VarCurr: state_type] :
      ( v139821(VarCurr)
    <=> ( v139822(VarCurr)
        & v139826(VarCurr) ) ) ).

tff(writeUnaryOperator_10574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139826(VarCurr)
    <=> v139827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18598,axiom,
    ! [VarCurr: state_type] :
      ( v139827(VarCurr)
    <=> ( v139828(VarCurr)
        & v139829(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6780,axiom,
    ! [VarCurr: state_type] :
      ( v139829(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v126737(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18597,axiom,
    ! [VarCurr: state_type] :
      ( v139828(VarCurr)
    <=> ( v88897(VarCurr)
        | v126928(VarCurr) ) ) ).

tff(writeUnaryOperator_10573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139822(VarCurr)
    <=> v139823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18596,axiom,
    ! [VarCurr: state_type] :
      ( v139823(VarCurr)
    <=> ( v139824(VarCurr)
        & v139825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18595,axiom,
    ! [VarCurr: state_type] :
      ( v139825(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v126737(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18594,axiom,
    ! [VarCurr: state_type] :
      ( v139824(VarCurr)
    <=> ( v88915(VarCurr)
        | v126922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18593,axiom,
    ! [VarCurr: state_type] :
      ( v139815(VarCurr)
    <=> ( v139816(VarCurr)
        & v139817(VarCurr) ) ) ).

tff(writeUnaryOperator_10572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139817(VarCurr)
    <=> v126727(VarCurr) ) ).

tff(writeUnaryOperator_10571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139816(VarCurr)
    <=> v2878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18592,axiom,
    ! [VarCurr: state_type] :
      ( v139799(VarCurr)
    <=> ( v139800(VarCurr)
        | v139809(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18591,axiom,
    ! [VarCurr: state_type] :
      ( v139809(VarCurr)
    <=> ( v139810(VarCurr)
        & v139748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18590,axiom,
    ! [VarCurr: state_type] :
      ( v139810(VarCurr)
    <=> ( v139561(VarCurr)
        & v139572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18589,axiom,
    ! [VarCurr: state_type] :
      ( v139800(VarCurr)
    <=> ( v139801(VarCurr)
        | v139807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18588,axiom,
    ! [VarCurr: state_type] :
      ( v139807(VarCurr)
    <=> ( v139808(VarCurr)
        & v139557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18587,axiom,
    ! [VarCurr: state_type] :
      ( v139808(VarCurr)
    <=> ( v84553(VarCurr)
        | v84321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18586,axiom,
    ! [VarCurr: state_type] :
      ( v139801(VarCurr)
    <=> ( v139802(VarCurr)
        & v139806(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2050,axiom,
    ! [VarCurr: state_type] :
      ( v139806(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18585,axiom,
    ! [VarCurr: state_type] :
      ( v139802(VarCurr)
    <=> ( v84321(VarCurr)
        | v139803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18584,axiom,
    ! [VarCurr: state_type] :
      ( v139803(VarCurr)
    <=> ( v139804(VarCurr)
        & v139805(VarCurr) ) ) ).

tff(writeUnaryOperator_10570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139805(VarCurr)
    <=> v84321(VarCurr) ) ).

tff(writeUnaryOperator_10569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139804(VarCurr)
    <=> v84488(VarCurr) ) ).

tff(addAssignment_78064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139327(VarCurr,B)
      <=> v139329(VarCurr,B) ) ) ).

tff(addAssignment_78063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139329(VarCurr,B)
      <=> v139331(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139777(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v139331(VarNext,B)
            <=> v139331(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1915,axiom,
    ! [VarNext: state_type] :
      ( v139777(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139331(VarNext,B)
          <=> v139787(VarNext,B) ) ) ) ).

tff(addAssignment_78062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139787(VarNext,B)
          <=> v139785(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139788(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139785(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1471,axiom,
    ! [VarCurr: state_type] :
      ( v139788(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139785(VarCurr,B)
          <=> v139341(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18583,axiom,
    ! [VarCurr: state_type] :
      ( v139788(VarCurr)
    <=> ( v139789(VarCurr)
        & v139790(VarCurr) ) ) ).

tff(writeUnaryOperator_10568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139790(VarCurr)
    <=> v139337(VarCurr) ) ).

tff(writeUnaryOperator_10567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139789(VarCurr)
    <=> v139333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139777(VarNext)
      <=> v139778(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139778(VarNext)
      <=> ( v139779(VarNext)
          & v139772(VarNext) ) ) ) ).

tff(writeUnaryOperator_10566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139779(VarNext)
      <=> v139781(VarNext) ) ) ).

tff(addAssignment_78061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139781(VarNext)
      <=> v139772(VarCurr) ) ) ).

tff(addAssignment_78060,axiom,
    ! [VarCurr: state_type] :
      ( v139772(VarCurr)
    <=> v139774(VarCurr) ) ).

tff(addAssignment_78059,axiom,
    ! [VarCurr: state_type] :
      ( v139774(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139341(VarCurr,B)
      <=> v139343(VarCurr,B) ) ) ).

tff(addAssignment_78057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139343(VarCurr,B)
      <=> v139345(VarCurr,B) ) ) ).

tff(addAssignment_78056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139345(VarCurr,B)
      <=> v139347(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139347(VarCurr,B)
          <=> v139327(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1470,axiom,
    ! [VarCurr: state_type] :
      ( v139556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139347(VarCurr,B)
          <=> v139749(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_19,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139557(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139749(VarCurr,B)
          <=> v139750(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_19,axiom,
    ! [VarCurr: state_type] :
      ( v139557(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139749(VarCurr,B)
          <=> $false ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_18,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139750(VarCurr,B)
          <=> v139751(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_18,axiom,
    ! [VarCurr: state_type] :
      ( v139560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139750(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_78055,axiom,
    ! [VarCurr: state_type] :
      ( v139751(VarCurr,0)
    <=> v139585(VarCurr) ) ).

tff(addAssignment_78054,axiom,
    ! [VarCurr: state_type] :
      ( v139751(VarCurr,1)
    <=> v139768(VarCurr) ) ).

tff(addAssignment_78053,axiom,
    ! [VarCurr: state_type] :
      ( v139751(VarCurr,2)
    <=> v139764(VarCurr) ) ).

tff(addAssignment_78052,axiom,
    ! [VarCurr: state_type] :
      ( v139751(VarCurr,3)
    <=> v139760(VarCurr) ) ).

tff(addAssignment_78051,axiom,
    ! [VarCurr: state_type] :
      ( v139751(VarCurr,4)
    <=> v139753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18580,axiom,
    ! [VarCurr: state_type] :
      ( v139768(VarCurr)
    <=> ( v139769(VarCurr)
        & v139770(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6779,axiom,
    ! [VarCurr: state_type] :
      ( v139770(VarCurr)
    <=> ( v139327(VarCurr,0)
        | v139327(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18579,axiom,
    ! [VarCurr: state_type] :
      ( v139769(VarCurr)
    <=> ( v139585(VarCurr)
        | v139610(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18578,axiom,
    ! [VarCurr: state_type] :
      ( v139764(VarCurr)
    <=> ( v139765(VarCurr)
        & v139767(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6778,axiom,
    ! [VarCurr: state_type] :
      ( v139767(VarCurr)
    <=> ( v139327(VarCurr,2)
        | v139758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18577,axiom,
    ! [VarCurr: state_type] :
      ( v139765(VarCurr)
    <=> ( v139617(VarCurr)
        | v139766(VarCurr) ) ) ).

tff(writeUnaryOperator_10565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139766(VarCurr)
    <=> v139758(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18576,axiom,
    ! [VarCurr: state_type] :
      ( v139760(VarCurr)
    <=> ( v139761(VarCurr)
        & v139763(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6777,axiom,
    ! [VarCurr: state_type] :
      ( v139763(VarCurr)
    <=> ( v139327(VarCurr,3)
        | v139757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18575,axiom,
    ! [VarCurr: state_type] :
      ( v139761(VarCurr)
    <=> ( v139624(VarCurr)
        | v139762(VarCurr) ) ) ).

tff(writeUnaryOperator_10564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139762(VarCurr)
    <=> v139757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18574,axiom,
    ! [VarCurr: state_type] :
      ( v139753(VarCurr)
    <=> ( v139754(VarCurr)
        & v139759(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6776,axiom,
    ! [VarCurr: state_type] :
      ( v139759(VarCurr)
    <=> ( v139327(VarCurr,4)
        | v139756(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18573,axiom,
    ! [VarCurr: state_type] :
      ( v139754(VarCurr)
    <=> ( v139631(VarCurr)
        | v139755(VarCurr) ) ) ).

tff(writeUnaryOperator_10563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139755(VarCurr)
    <=> v139756(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6775,axiom,
    ! [VarCurr: state_type] :
      ( v139756(VarCurr)
    <=> ( v139327(VarCurr,3)
        & v139757(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6774,axiom,
    ! [VarCurr: state_type] :
      ( v139757(VarCurr)
    <=> ( v139327(VarCurr,2)
        & v139758(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6773,axiom,
    ! [VarCurr: state_type] :
      ( v139758(VarCurr)
    <=> ( v139327(VarCurr,0)
        & v139327(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18572,axiom,
    ! [VarCurr: state_type] :
      ( v139556(VarCurr)
    <=> ( v139557(VarCurr)
        | v139558(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18571,axiom,
    ! [VarCurr: state_type] :
      ( v139558(VarCurr)
    <=> ( v139559(VarCurr)
        & v139748(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2049,axiom,
    ! [VarCurr: state_type] :
      ( v139748(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18570,axiom,
    ! [VarCurr: state_type] :
      ( v139559(VarCurr)
    <=> ( v139560(VarCurr)
        | v139747(VarCurr) ) ) ).

tff(writeUnaryOperator_10562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139747(VarCurr)
    <=> v139572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18569,axiom,
    ! [VarCurr: state_type] :
      ( v139560(VarCurr)
    <=> ( v139561(VarCurr)
        & v139572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18568,axiom,
    ! [VarCurr: state_type] :
      ( v139572(VarCurr)
    <=> ( v139573(VarCurr)
        & v139691(VarCurr) ) ) ).

tff(writeUnaryOperator_10561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139691(VarCurr)
    <=> v139693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18567,axiom,
    ! [VarCurr: state_type] :
      ( v139693(VarCurr)
    <=> ( v139694(VarCurr)
        | v139746(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6772,axiom,
    ! [VarCurr: state_type] :
      ( v139746(VarCurr)
    <=> ( v139631(VarCurr)
        & v139702(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18566,axiom,
    ! [VarCurr: state_type] :
      ( v139694(VarCurr)
    <=> ( v139695(VarCurr)
        & v139741(VarCurr) ) ) ).

tff(writeUnaryOperator_10560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139741(VarCurr)
    <=> v139742(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18565,axiom,
    ! [VarCurr: state_type] :
      ( v139742(VarCurr)
    <=> ( v139743(VarCurr)
        & v139745(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6771,axiom,
    ! [VarCurr: state_type] :
      ( v139745(VarCurr)
    <=> ( v139327(VarCurr,4)
        | v139702(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18564,axiom,
    ! [VarCurr: state_type] :
      ( v139743(VarCurr)
    <=> ( v139631(VarCurr)
        | v139744(VarCurr) ) ) ).

tff(writeUnaryOperator_10559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139744(VarCurr)
    <=> v139702(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18563,axiom,
    ! [VarCurr: state_type] :
      ( v139695(VarCurr)
    <=> ( v139696(VarCurr)
        | v139740(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6770,axiom,
    ! [VarCurr: state_type] :
      ( v139740(VarCurr)
    <=> ( v139624(VarCurr)
        & v139702(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18562,axiom,
    ! [VarCurr: state_type] :
      ( v139696(VarCurr)
    <=> ( v139697(VarCurr)
        & v139735(VarCurr) ) ) ).

tff(writeUnaryOperator_10558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139735(VarCurr)
    <=> v139736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18561,axiom,
    ! [VarCurr: state_type] :
      ( v139736(VarCurr)
    <=> ( v139737(VarCurr)
        & v139739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6769,axiom,
    ! [VarCurr: state_type] :
      ( v139739(VarCurr)
    <=> ( v139327(VarCurr,3)
        | v139702(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18560,axiom,
    ! [VarCurr: state_type] :
      ( v139737(VarCurr)
    <=> ( v139624(VarCurr)
        | v139738(VarCurr) ) ) ).

tff(writeUnaryOperator_10557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139738(VarCurr)
    <=> v139702(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18559,axiom,
    ! [VarCurr: state_type] :
      ( v139697(VarCurr)
    <=> ( v139698(VarCurr)
        | v139734(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6768,axiom,
    ! [VarCurr: state_type] :
      ( v139734(VarCurr)
    <=> ( v139617(VarCurr)
        & v139702(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18558,axiom,
    ! [VarCurr: state_type] :
      ( v139698(VarCurr)
    <=> ( v139699(VarCurr)
        & v139729(VarCurr) ) ) ).

tff(writeUnaryOperator_10556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139729(VarCurr)
    <=> v139730(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18557,axiom,
    ! [VarCurr: state_type] :
      ( v139730(VarCurr)
    <=> ( v139731(VarCurr)
        & v139733(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6767,axiom,
    ! [VarCurr: state_type] :
      ( v139733(VarCurr)
    <=> ( v139327(VarCurr,2)
        | v139702(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18556,axiom,
    ! [VarCurr: state_type] :
      ( v139731(VarCurr)
    <=> ( v139617(VarCurr)
        | v139732(VarCurr) ) ) ).

tff(writeUnaryOperator_10555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139732(VarCurr)
    <=> v139702(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18555,axiom,
    ! [VarCurr: state_type] :
      ( v139699(VarCurr)
    <=> ( v139700(VarCurr)
        | v139728(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6766,axiom,
    ! [VarCurr: state_type] :
      ( v139728(VarCurr)
    <=> ( v139610(VarCurr)
        & v139702(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18554,axiom,
    ! [VarCurr: state_type] :
      ( v139700(VarCurr)
    <=> ( v139701(VarCurr)
        & v139723(VarCurr) ) ) ).

tff(writeUnaryOperator_10554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139723(VarCurr)
    <=> v139724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18553,axiom,
    ! [VarCurr: state_type] :
      ( v139724(VarCurr)
    <=> ( v139725(VarCurr)
        & v139727(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6765,axiom,
    ! [VarCurr: state_type] :
      ( v139727(VarCurr)
    <=> ( v139327(VarCurr,1)
        | v139702(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18552,axiom,
    ! [VarCurr: state_type] :
      ( v139725(VarCurr)
    <=> ( v139610(VarCurr)
        | v139726(VarCurr) ) ) ).

tff(writeUnaryOperator_10553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139726(VarCurr)
    <=> v139702(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18551,axiom,
    ! [VarCurr: state_type] :
      ( v139701(VarCurr)
    <=> ( v139585(VarCurr)
        & v139702(VarCurr,0) ) ) ).

tff(addAssignment_78050,axiom,
    ! [VarCurr: state_type] :
      ( v139702(VarCurr,0)
    <=> v139349(VarCurr,0) ) ).

tff(addAssignment_78049,axiom,
    ! [VarCurr: state_type] :
      ( v139702(VarCurr,1)
    <=> v139721(VarCurr) ) ).

tff(addAssignment_78048,axiom,
    ! [VarCurr: state_type] :
      ( v139702(VarCurr,2)
    <=> v139719(VarCurr) ) ).

tff(addAssignment_78047,axiom,
    ! [VarCurr: state_type] :
      ( v139702(VarCurr,3)
    <=> v139715(VarCurr) ) ).

tff(addAssignment_78046,axiom,
    ! [VarCurr: state_type] :
      ( v139702(VarCurr,4)
    <=> v139704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18550,axiom,
    ! [VarCurr: state_type] :
      ( v139719(VarCurr)
    <=> ( v139720(VarCurr)
        & v139722(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6764,axiom,
    ! [VarCurr: state_type] :
      ( v139722(VarCurr)
    <=> ( v139349(VarCurr,1)
        | v139711(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6763,axiom,
    ! [VarCurr: state_type] :
      ( v139720(VarCurr)
    <=> ( v139721(VarCurr)
        | v139349(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139721(VarCurr)
    <=> v139349(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18549,axiom,
    ! [VarCurr: state_type] :
      ( v139715(VarCurr)
    <=> ( v139716(VarCurr)
        & v139718(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18548,axiom,
    ! [VarCurr: state_type] :
      ( v139718(VarCurr)
    <=> ( v139709(VarCurr)
        | v139712(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6762,axiom,
    ! [VarCurr: state_type] :
      ( v139716(VarCurr)
    <=> ( v139717(VarCurr)
        | v139349(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139717(VarCurr)
    <=> v139709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18547,axiom,
    ! [VarCurr: state_type] :
      ( v139704(VarCurr)
    <=> ( v139705(VarCurr)
        & v139713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18546,axiom,
    ! [VarCurr: state_type] :
      ( v139713(VarCurr)
    <=> ( v139707(VarCurr)
        | v139714(VarCurr) ) ) ).

tff(writeUnaryOperator_10550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139714(VarCurr)
    <=> v139349(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6761,axiom,
    ! [VarCurr: state_type] :
      ( v139705(VarCurr)
    <=> ( v139706(VarCurr)
        | v139349(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139706(VarCurr)
    <=> v139707(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6760,axiom,
    ! [VarCurr: state_type] :
      ( v139707(VarCurr)
    <=> ( v139349(VarCurr,3)
        | v139708(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18545,axiom,
    ! [VarCurr: state_type] :
      ( v139708(VarCurr)
    <=> ( v139709(VarCurr)
        & v139712(VarCurr) ) ) ).

tff(writeUnaryOperator_10548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139712(VarCurr)
    <=> v139349(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6759,axiom,
    ! [VarCurr: state_type] :
      ( v139709(VarCurr)
    <=> ( v139349(VarCurr,2)
        | v139710(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6758,axiom,
    ! [VarCurr: state_type] :
      ( v139710(VarCurr)
    <=> ( v139349(VarCurr,1)
        & v139711(VarCurr) ) ) ).

tff(writeUnaryOperator_10547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139711(VarCurr)
    <=> v139349(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18544,axiom,
    ! [VarCurr: state_type] :
      ( v139573(VarCurr)
    <=> ( v139574(VarCurr)
        & v139635(VarCurr) ) ) ).

tff(writeUnaryOperator_10546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139635(VarCurr)
    <=> v139637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18543,axiom,
    ! [VarCurr: state_type] :
      ( v139637(VarCurr)
    <=> ( v139638(VarCurr)
        | v139690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6757,axiom,
    ! [VarCurr: state_type] :
      ( v139690(VarCurr)
    <=> ( v139631(VarCurr)
        & v139646(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18542,axiom,
    ! [VarCurr: state_type] :
      ( v139638(VarCurr)
    <=> ( v139639(VarCurr)
        & v139685(VarCurr) ) ) ).

tff(writeUnaryOperator_10545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139685(VarCurr)
    <=> v139686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18541,axiom,
    ! [VarCurr: state_type] :
      ( v139686(VarCurr)
    <=> ( v139687(VarCurr)
        & v139689(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6756,axiom,
    ! [VarCurr: state_type] :
      ( v139689(VarCurr)
    <=> ( v139327(VarCurr,4)
        | v139646(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18540,axiom,
    ! [VarCurr: state_type] :
      ( v139687(VarCurr)
    <=> ( v139631(VarCurr)
        | v139688(VarCurr) ) ) ).

tff(writeUnaryOperator_10544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139688(VarCurr)
    <=> v139646(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18539,axiom,
    ! [VarCurr: state_type] :
      ( v139639(VarCurr)
    <=> ( v139640(VarCurr)
        | v139684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6755,axiom,
    ! [VarCurr: state_type] :
      ( v139684(VarCurr)
    <=> ( v139624(VarCurr)
        & v139646(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18538,axiom,
    ! [VarCurr: state_type] :
      ( v139640(VarCurr)
    <=> ( v139641(VarCurr)
        & v139679(VarCurr) ) ) ).

tff(writeUnaryOperator_10543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139679(VarCurr)
    <=> v139680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18537,axiom,
    ! [VarCurr: state_type] :
      ( v139680(VarCurr)
    <=> ( v139681(VarCurr)
        & v139683(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6754,axiom,
    ! [VarCurr: state_type] :
      ( v139683(VarCurr)
    <=> ( v139327(VarCurr,3)
        | v139646(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18536,axiom,
    ! [VarCurr: state_type] :
      ( v139681(VarCurr)
    <=> ( v139624(VarCurr)
        | v139682(VarCurr) ) ) ).

tff(writeUnaryOperator_10542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139682(VarCurr)
    <=> v139646(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18535,axiom,
    ! [VarCurr: state_type] :
      ( v139641(VarCurr)
    <=> ( v139642(VarCurr)
        | v139678(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6753,axiom,
    ! [VarCurr: state_type] :
      ( v139678(VarCurr)
    <=> ( v139617(VarCurr)
        & v139646(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18534,axiom,
    ! [VarCurr: state_type] :
      ( v139642(VarCurr)
    <=> ( v139643(VarCurr)
        & v139673(VarCurr) ) ) ).

tff(writeUnaryOperator_10541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139673(VarCurr)
    <=> v139674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18533,axiom,
    ! [VarCurr: state_type] :
      ( v139674(VarCurr)
    <=> ( v139675(VarCurr)
        & v139677(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6752,axiom,
    ! [VarCurr: state_type] :
      ( v139677(VarCurr)
    <=> ( v139327(VarCurr,2)
        | v139646(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18532,axiom,
    ! [VarCurr: state_type] :
      ( v139675(VarCurr)
    <=> ( v139617(VarCurr)
        | v139676(VarCurr) ) ) ).

tff(writeUnaryOperator_10540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139676(VarCurr)
    <=> v139646(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18531,axiom,
    ! [VarCurr: state_type] :
      ( v139643(VarCurr)
    <=> ( v139644(VarCurr)
        | v139672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6751,axiom,
    ! [VarCurr: state_type] :
      ( v139672(VarCurr)
    <=> ( v139610(VarCurr)
        & v139646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18530,axiom,
    ! [VarCurr: state_type] :
      ( v139644(VarCurr)
    <=> ( v139645(VarCurr)
        & v139667(VarCurr) ) ) ).

tff(writeUnaryOperator_10539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139667(VarCurr)
    <=> v139668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18529,axiom,
    ! [VarCurr: state_type] :
      ( v139668(VarCurr)
    <=> ( v139669(VarCurr)
        & v139671(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6750,axiom,
    ! [VarCurr: state_type] :
      ( v139671(VarCurr)
    <=> ( v139327(VarCurr,1)
        | v139646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18528,axiom,
    ! [VarCurr: state_type] :
      ( v139669(VarCurr)
    <=> ( v139610(VarCurr)
        | v139670(VarCurr) ) ) ).

tff(writeUnaryOperator_10538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139670(VarCurr)
    <=> v139646(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18527,axiom,
    ! [VarCurr: state_type] :
      ( v139645(VarCurr)
    <=> ( v139585(VarCurr)
        & v139646(VarCurr,0) ) ) ).

tff(addAssignment_78045,axiom,
    ! [VarCurr: state_type] :
      ( v139646(VarCurr,0)
    <=> v113152(VarCurr,0) ) ).

tff(addAssignment_78044,axiom,
    ! [VarCurr: state_type] :
      ( v139646(VarCurr,1)
    <=> v139665(VarCurr) ) ).

tff(addAssignment_78043,axiom,
    ! [VarCurr: state_type] :
      ( v139646(VarCurr,2)
    <=> v139663(VarCurr) ) ).

tff(addAssignment_78042,axiom,
    ! [VarCurr: state_type] :
      ( v139646(VarCurr,3)
    <=> v139659(VarCurr) ) ).

tff(addAssignment_78041,axiom,
    ! [VarCurr: state_type] :
      ( v139646(VarCurr,4)
    <=> v139648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18526,axiom,
    ! [VarCurr: state_type] :
      ( v139663(VarCurr)
    <=> ( v139664(VarCurr)
        & v139666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6749,axiom,
    ! [VarCurr: state_type] :
      ( v139666(VarCurr)
    <=> ( v113152(VarCurr,1)
        | v139655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6748,axiom,
    ! [VarCurr: state_type] :
      ( v139664(VarCurr)
    <=> ( v139665(VarCurr)
        | v113152(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139665(VarCurr)
    <=> v113152(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18525,axiom,
    ! [VarCurr: state_type] :
      ( v139659(VarCurr)
    <=> ( v139660(VarCurr)
        & v139662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18524,axiom,
    ! [VarCurr: state_type] :
      ( v139662(VarCurr)
    <=> ( v139653(VarCurr)
        | v139656(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6747,axiom,
    ! [VarCurr: state_type] :
      ( v139660(VarCurr)
    <=> ( v139661(VarCurr)
        | v113152(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139661(VarCurr)
    <=> v139653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18523,axiom,
    ! [VarCurr: state_type] :
      ( v139648(VarCurr)
    <=> ( v139649(VarCurr)
        & v139657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18522,axiom,
    ! [VarCurr: state_type] :
      ( v139657(VarCurr)
    <=> ( v139651(VarCurr)
        | v139658(VarCurr) ) ) ).

tff(writeUnaryOperator_10535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139658(VarCurr)
    <=> v113152(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6746,axiom,
    ! [VarCurr: state_type] :
      ( v139649(VarCurr)
    <=> ( v139650(VarCurr)
        | v113152(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139650(VarCurr)
    <=> v139651(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6745,axiom,
    ! [VarCurr: state_type] :
      ( v139651(VarCurr)
    <=> ( v113152(VarCurr,3)
        | v139652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18521,axiom,
    ! [VarCurr: state_type] :
      ( v139652(VarCurr)
    <=> ( v139653(VarCurr)
        & v139656(VarCurr) ) ) ).

tff(writeUnaryOperator_10533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139656(VarCurr)
    <=> v113152(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6744,axiom,
    ! [VarCurr: state_type] :
      ( v139653(VarCurr)
    <=> ( v113152(VarCurr,2)
        | v139654(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6743,axiom,
    ! [VarCurr: state_type] :
      ( v139654(VarCurr)
    <=> ( v113152(VarCurr,1)
        & v139655(VarCurr) ) ) ).

tff(writeUnaryOperator_10532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139655(VarCurr)
    <=> v113152(VarCurr,2) ) ).

tff(writeUnaryOperator_10531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139574(VarCurr)
    <=> v139576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18520,axiom,
    ! [VarCurr: state_type] :
      ( v139576(VarCurr)
    <=> ( v139577(VarCurr)
        | v139634(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6742,axiom,
    ! [VarCurr: state_type] :
      ( v139634(VarCurr)
    <=> ( v139631(VarCurr)
        & v139586(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18519,axiom,
    ! [VarCurr: state_type] :
      ( v139577(VarCurr)
    <=> ( v139578(VarCurr)
        & v139628(VarCurr) ) ) ).

tff(writeUnaryOperator_10530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139628(VarCurr)
    <=> v139629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18518,axiom,
    ! [VarCurr: state_type] :
      ( v139629(VarCurr)
    <=> ( v139630(VarCurr)
        & v139633(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6741,axiom,
    ! [VarCurr: state_type] :
      ( v139633(VarCurr)
    <=> ( v139327(VarCurr,4)
        | v139586(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18517,axiom,
    ! [VarCurr: state_type] :
      ( v139630(VarCurr)
    <=> ( v139631(VarCurr)
        | v139632(VarCurr) ) ) ).

tff(writeUnaryOperator_10529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139632(VarCurr)
    <=> v139586(VarCurr,4) ) ).

tff(writeUnaryOperator_10528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139631(VarCurr)
    <=> v139327(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18516,axiom,
    ! [VarCurr: state_type] :
      ( v139578(VarCurr)
    <=> ( v139579(VarCurr)
        | v139627(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6740,axiom,
    ! [VarCurr: state_type] :
      ( v139627(VarCurr)
    <=> ( v139624(VarCurr)
        & v139586(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18515,axiom,
    ! [VarCurr: state_type] :
      ( v139579(VarCurr)
    <=> ( v139580(VarCurr)
        & v139621(VarCurr) ) ) ).

tff(writeUnaryOperator_10527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139621(VarCurr)
    <=> v139622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18514,axiom,
    ! [VarCurr: state_type] :
      ( v139622(VarCurr)
    <=> ( v139623(VarCurr)
        & v139626(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6739,axiom,
    ! [VarCurr: state_type] :
      ( v139626(VarCurr)
    <=> ( v139327(VarCurr,3)
        | v139586(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18513,axiom,
    ! [VarCurr: state_type] :
      ( v139623(VarCurr)
    <=> ( v139624(VarCurr)
        | v139625(VarCurr) ) ) ).

tff(writeUnaryOperator_10526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139625(VarCurr)
    <=> v139586(VarCurr,3) ) ).

tff(writeUnaryOperator_10525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139624(VarCurr)
    <=> v139327(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18512,axiom,
    ! [VarCurr: state_type] :
      ( v139580(VarCurr)
    <=> ( v139581(VarCurr)
        | v139620(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6738,axiom,
    ! [VarCurr: state_type] :
      ( v139620(VarCurr)
    <=> ( v139617(VarCurr)
        & v139586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18511,axiom,
    ! [VarCurr: state_type] :
      ( v139581(VarCurr)
    <=> ( v139582(VarCurr)
        & v139614(VarCurr) ) ) ).

tff(writeUnaryOperator_10524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139614(VarCurr)
    <=> v139615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18510,axiom,
    ! [VarCurr: state_type] :
      ( v139615(VarCurr)
    <=> ( v139616(VarCurr)
        & v139619(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6737,axiom,
    ! [VarCurr: state_type] :
      ( v139619(VarCurr)
    <=> ( v139327(VarCurr,2)
        | v139586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18509,axiom,
    ! [VarCurr: state_type] :
      ( v139616(VarCurr)
    <=> ( v139617(VarCurr)
        | v139618(VarCurr) ) ) ).

tff(writeUnaryOperator_10523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139618(VarCurr)
    <=> v139586(VarCurr,2) ) ).

tff(writeUnaryOperator_10522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139617(VarCurr)
    <=> v139327(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18508,axiom,
    ! [VarCurr: state_type] :
      ( v139582(VarCurr)
    <=> ( v139583(VarCurr)
        | v139613(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6736,axiom,
    ! [VarCurr: state_type] :
      ( v139613(VarCurr)
    <=> ( v139610(VarCurr)
        & v139586(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18507,axiom,
    ! [VarCurr: state_type] :
      ( v139583(VarCurr)
    <=> ( v139584(VarCurr)
        & v139607(VarCurr) ) ) ).

tff(writeUnaryOperator_10521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139607(VarCurr)
    <=> v139608(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18506,axiom,
    ! [VarCurr: state_type] :
      ( v139608(VarCurr)
    <=> ( v139609(VarCurr)
        & v139612(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6735,axiom,
    ! [VarCurr: state_type] :
      ( v139612(VarCurr)
    <=> ( v139327(VarCurr,1)
        | v139586(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18505,axiom,
    ! [VarCurr: state_type] :
      ( v139609(VarCurr)
    <=> ( v139610(VarCurr)
        | v139611(VarCurr) ) ) ).

tff(writeUnaryOperator_10520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139611(VarCurr)
    <=> v139586(VarCurr,1) ) ).

tff(writeUnaryOperator_10519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139610(VarCurr)
    <=> v139327(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18504,axiom,
    ! [VarCurr: state_type] :
      ( v139584(VarCurr)
    <=> ( v139585(VarCurr)
        & v139586(VarCurr,0) ) ) ).

tff(addAssignment_78040,axiom,
    ! [VarCurr: state_type] :
      ( v139586(VarCurr,0)
    <=> v113946(VarCurr,0) ) ).

tff(addAssignment_78039,axiom,
    ! [VarCurr: state_type] :
      ( v139586(VarCurr,1)
    <=> v139605(VarCurr) ) ).

tff(addAssignment_78038,axiom,
    ! [VarCurr: state_type] :
      ( v139586(VarCurr,2)
    <=> v139603(VarCurr) ) ).

tff(addAssignment_78037,axiom,
    ! [VarCurr: state_type] :
      ( v139586(VarCurr,3)
    <=> v139599(VarCurr) ) ).

tff(addAssignment_78036,axiom,
    ! [VarCurr: state_type] :
      ( v139586(VarCurr,4)
    <=> v139588(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18503,axiom,
    ! [VarCurr: state_type] :
      ( v139603(VarCurr)
    <=> ( v139604(VarCurr)
        & v139606(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6734,axiom,
    ! [VarCurr: state_type] :
      ( v139606(VarCurr)
    <=> ( v113946(VarCurr,1)
        | v139595(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6733,axiom,
    ! [VarCurr: state_type] :
      ( v139604(VarCurr)
    <=> ( v139605(VarCurr)
        | v113946(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139605(VarCurr)
    <=> v113946(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18502,axiom,
    ! [VarCurr: state_type] :
      ( v139599(VarCurr)
    <=> ( v139600(VarCurr)
        & v139602(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18501,axiom,
    ! [VarCurr: state_type] :
      ( v139602(VarCurr)
    <=> ( v139593(VarCurr)
        | v139596(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6732,axiom,
    ! [VarCurr: state_type] :
      ( v139600(VarCurr)
    <=> ( v139601(VarCurr)
        | v113946(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139601(VarCurr)
    <=> v139593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18500,axiom,
    ! [VarCurr: state_type] :
      ( v139588(VarCurr)
    <=> ( v139589(VarCurr)
        & v139597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18499,axiom,
    ! [VarCurr: state_type] :
      ( v139597(VarCurr)
    <=> ( v139591(VarCurr)
        | v139598(VarCurr) ) ) ).

tff(writeUnaryOperator_10516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139598(VarCurr)
    <=> v113946(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6731,axiom,
    ! [VarCurr: state_type] :
      ( v139589(VarCurr)
    <=> ( v139590(VarCurr)
        | v113946(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139590(VarCurr)
    <=> v139591(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6730,axiom,
    ! [VarCurr: state_type] :
      ( v139591(VarCurr)
    <=> ( v113946(VarCurr,3)
        | v139592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18498,axiom,
    ! [VarCurr: state_type] :
      ( v139592(VarCurr)
    <=> ( v139593(VarCurr)
        & v139596(VarCurr) ) ) ).

tff(writeUnaryOperator_10514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139596(VarCurr)
    <=> v113946(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6729,axiom,
    ! [VarCurr: state_type] :
      ( v139593(VarCurr)
    <=> ( v113946(VarCurr,2)
        | v139594(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6728,axiom,
    ! [VarCurr: state_type] :
      ( v139594(VarCurr)
    <=> ( v113946(VarCurr,1)
        & v139595(VarCurr) ) ) ).

tff(writeUnaryOperator_10513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139595(VarCurr)
    <=> v113946(VarCurr,2) ) ).

tff(writeUnaryOperator_10512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139585(VarCurr)
    <=> v139327(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18497,axiom,
    ! [VarCurr: state_type] :
      ( v139561(VarCurr)
    <=> ( v139562(VarCurr)
        & v139571(VarCurr) ) ) ).

tff(writeUnaryOperator_10511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139571(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18496,axiom,
    ! [VarCurr: state_type] :
      ( v139562(VarCurr)
    <=> ( v139563(VarCurr)
        & v139570(VarCurr) ) ) ).

tff(writeUnaryOperator_10510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139570(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18495,axiom,
    ! [VarCurr: state_type] :
      ( v139563(VarCurr)
    <=> ( v139564(VarCurr)
        & v139569(VarCurr) ) ) ).

tff(writeUnaryOperator_10509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139569(VarCurr)
    <=> v82954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18494,axiom,
    ! [VarCurr: state_type] :
      ( v139564(VarCurr)
    <=> ( v139565(VarCurr)
        & v139568(VarCurr) ) ) ).

tff(writeUnaryOperator_10508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139568(VarCurr)
    <=> v83096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18493,axiom,
    ! [VarCurr: state_type] :
      ( v139565(VarCurr)
    <=> ( v139566(VarCurr)
        & v139567(VarCurr) ) ) ).

tff(writeUnaryOperator_10507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139567(VarCurr)
    <=> v101501(VarCurr) ) ).

tff(writeUnaryOperator_10506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139566(VarCurr)
    <=> v84897(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2048,axiom,
    ! [VarCurr: state_type] :
      ( v139557(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_78035,axiom,
    ! [VarCurr: state_type] :
      ( v139349(VarCurr,4)
    <=> v139351(VarCurr,4) ) ).

tff(writeUnaryOperator_10505,axiom,
    ! [VarCurr: state_type] :
      ( ( v139349(VarCurr,3)
      <=> ~ v139543(VarCurr,1) )
      & ( v139349(VarCurr,2)
      <=> ~ v139543(VarCurr,0) ) ) ).

tff(addAssignment_78034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139349(VarCurr,B)
      <=> v139351(VarCurr,B) ) ) ).

tff(addAssignment_78033,axiom,
    ! [VarCurr: state_type] :
      ( ( v139543(VarCurr,1)
      <=> v139351(VarCurr,3) )
      & ( v139543(VarCurr,0)
      <=> v139351(VarCurr,2) ) ) ).

tff(addAssignment_78032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139351(VarCurr,B)
      <=> v139353(VarCurr,B) ) ) ).

tff(addAssignment_78031,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139353(VarNext,B)
      <=> v139547(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139548(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v139547(VarNext,B)
            <=> v139353(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1914,axiom,
    ! [VarNext: state_type] :
      ( v139548(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139547(VarNext,B)
          <=> v139528(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139548(VarNext)
      <=> v139549(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139549(VarNext)
      <=> ( v139551(VarNext)
          & v139513(VarNext) ) ) ) ).

tff(writeUnaryOperator_10504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139551(VarNext)
      <=> v139522(VarNext) ) ) ).

tff(addAssignment_78030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139363(VarCurr,B)
      <=> v139365(VarCurr,B) ) ) ).

tff(addAssignment_78029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139365(VarCurr,B)
      <=> v139504(VarCurr,B) ) ) ).

tff(addAssignment_78028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139367(VarCurr,B)
      <=> v139494(VarCurr,B) ) ) ).

tff(writeUnaryOperator_10503,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v139495(VarCurr,1)
      <=> v139369(VarCurr,3) )
      & ( ~ v139495(VarCurr,0)
      <=> v139369(VarCurr,2) ) ) ).

tff(addAssignment_78027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v139369(VarCurr,B)
      <=> v139371(VarCurr,B) ) ) ).

tff(addAssignment_78026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139351(VarCurr,B)
      <=> v139353(VarCurr,B) ) ) ).

tff(addAssignment_78025,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139353(VarNext,B)
      <=> v139535(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139536(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v139535(VarNext,B)
            <=> v139353(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1913,axiom,
    ! [VarNext: state_type] :
      ( v139536(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139535(VarNext,B)
          <=> v139528(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139536(VarNext)
      <=> v139537(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139537(VarNext)
      <=> ( v139539(VarNext)
          & v139513(VarNext) ) ) ) ).

tff(writeUnaryOperator_10502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139539(VarNext)
      <=> v139522(VarNext) ) ) ).

tff(addAssignment_78024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139363(VarCurr,B)
      <=> v139365(VarCurr,B) ) ) ).

tff(addAssignment_78023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139365(VarCurr,B)
      <=> v139504(VarCurr,B) ) ) ).

tff(addAssignment_78022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139367(VarCurr,B)
      <=> v139494(VarCurr,B) ) ) ).

tff(addAssignment_78021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139369(VarCurr,B)
      <=> v139371(VarCurr,B) ) ) ).

tff(addAssignment_78020,axiom,
    ! [VarCurr: state_type] :
      ( v139351(VarCurr,4)
    <=> v139353(VarCurr,4) ) ).

tff(addAssignment_78019,axiom,
    ! [VarNext: state_type] :
      ( v139353(VarNext,4)
    <=> v139517(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139518(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v139517(VarNext,B)
            <=> v139353(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1912,axiom,
    ! [VarNext: state_type] :
      ( v139518(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139517(VarNext,B)
          <=> v139528(VarNext,B) ) ) ) ).

tff(addAssignment_78018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139528(VarNext,B)
          <=> v139526(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139529(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139526(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1469,axiom,
    ! [VarCurr: state_type] :
      ( v139529(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139526(VarCurr,B)
          <=> v139363(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18488,axiom,
    ! [VarCurr: state_type] :
      ( v139529(VarCurr)
    <=> ( v139530(VarCurr)
        & v139531(VarCurr) ) ) ).

tff(writeUnaryOperator_10501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139531(VarCurr)
    <=> v139359(VarCurr) ) ).

tff(writeUnaryOperator_10500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139530(VarCurr)
    <=> v139355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139518(VarNext)
      <=> v139519(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139519(VarNext)
      <=> ( v139520(VarNext)
          & v139513(VarNext) ) ) ) ).

tff(writeUnaryOperator_10499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v139520(VarNext)
      <=> v139522(VarNext) ) ) ).

tff(addAssignment_78017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v139522(VarNext)
      <=> v139513(VarCurr) ) ) ).

tff(addAssignment_78016,axiom,
    ! [VarCurr: state_type] :
      ( v139513(VarCurr)
    <=> v139515(VarCurr) ) ).

tff(addAssignment_78015,axiom,
    ! [VarCurr: state_type] :
      ( v139515(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_78014,axiom,
    ! [VarCurr: state_type] :
      ( v139363(VarCurr,4)
    <=> v139365(VarCurr,4) ) ).

tff(addAssignment_78013,axiom,
    ! [VarCurr: state_type] :
      ( v139365(VarCurr,4)
    <=> v139504(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139504(VarCurr,B)
      <=> ( v139505(VarCurr,B)
          | v139508(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139508(VarCurr,B)
      <=> ( v139351(VarCurr,B)
          & v139509(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_10498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139509(VarCurr,B)
      <=> ~ v139510(VarCurr,B) ) ) ).

tff(addAssignment_78012,axiom,
    ! [VarCurr: state_type] :
      ( v139510(VarCurr,0)
    <=> v139511(VarCurr) ) ).

tff(addAssignment_78011,axiom,
    ! [VarCurr: state_type] :
      ( v139510(VarCurr,1)
    <=> v139511(VarCurr) ) ).

tff(addAssignment_78010,axiom,
    ! [VarCurr: state_type] :
      ( v139510(VarCurr,2)
    <=> v139511(VarCurr) ) ).

tff(addAssignment_78009,axiom,
    ! [VarCurr: state_type] :
      ( v139510(VarCurr,3)
    <=> v139511(VarCurr) ) ).

tff(addAssignment_78008,axiom,
    ! [VarCurr: state_type] :
      ( v139510(VarCurr,4)
    <=> v139511(VarCurr) ) ).

tff(addAssignment_78007,axiom,
    ! [VarCurr: state_type] :
      ( v139511(VarCurr)
    <=> v139497(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v139505(VarCurr,B)
      <=> ( v139367(VarCurr,B)
          & v139506(VarCurr,B) ) ) ) ).

tff(addAssignment_78006,axiom,
    ! [VarCurr: state_type] :
      ( v139506(VarCurr,0)
    <=> v139507(VarCurr) ) ).

tff(addAssignment_78005,axiom,
    ! [VarCurr: state_type] :
      ( v139506(VarCurr,1)
    <=> v139507(VarCurr) ) ).

tff(addAssignment_78004,axiom,
    ! [VarCurr: state_type] :
      ( v139506(VarCurr,2)
    <=> v139507(VarCurr) ) ).

tff(addAssignment_78003,axiom,
    ! [VarCurr: state_type] :
      ( v139506(VarCurr,3)
    <=> v139507(VarCurr) ) ).

tff(addAssignment_78002,axiom,
    ! [VarCurr: state_type] :
      ( v139506(VarCurr,4)
    <=> v139507(VarCurr) ) ).

tff(addAssignment_78001,axiom,
    ! [VarCurr: state_type] :
      ( v139507(VarCurr)
    <=> v139497(VarCurr) ) ).

tff(addAssignment_78000,axiom,
    ! [VarCurr: state_type] :
      ( v139497(VarCurr)
    <=> v139499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18485,axiom,
    ! [VarCurr: state_type] :
      ( v139499(VarCurr)
    <=> ( v139501(VarCurr)
        | v139502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18484,axiom,
    ! [VarCurr: state_type] :
      ( v139502(VarCurr)
    <=> ( v1729(VarCurr)
        & v139503(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2047,axiom,
    ! [VarCurr: state_type] :
      ( v139503(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18483,axiom,
    ! [VarCurr: state_type] :
      ( v139501(VarCurr)
    <=> ( v113667(VarCurr)
        | v113488(VarCurr) ) ) ).

tff(addAssignment_77999,axiom,
    ! [VarCurr: state_type] :
      ( v139367(VarCurr,4)
    <=> v139494(VarCurr,4) ) ).

tff(addAssignment_77998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v139494(VarCurr,B)
      <=> v139369(VarCurr,B) ) ) ).

tff(addAssignment_77997,axiom,
    ! [VarCurr: state_type] :
      ( ( v139494(VarCurr,3)
      <=> v139495(VarCurr,1) )
      & ( v139494(VarCurr,2)
      <=> v139495(VarCurr,0) ) ) ).

tff(addAssignment_77996,axiom,
    ! [VarCurr: state_type] :
      ( v139494(VarCurr,4)
    <=> v139369(VarCurr,4) ) ).

tff(addAssignment_77995,axiom,
    ! [VarCurr: state_type] :
      ( v139369(VarCurr,4)
    <=> v139371(VarCurr,4) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139372(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139371(VarCurr,B)
          <=> v139374(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1468,axiom,
    ! [VarCurr: state_type] :
      ( v139372(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139371(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113667(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139374(VarCurr,B)
          <=> v139434(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1467,axiom,
    ! [VarCurr: state_type] :
      ( v113667(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139374(VarCurr,B)
          <=> v139375(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139434(VarCurr,B)
          <=> v139349(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1466,axiom,
    ! [VarCurr: state_type] :
      ( v113488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v139434(VarCurr,B)
          <=> v139435(VarCurr,B) ) ) ) ).

tff(addAssignment_77994,axiom,
    ! [VarCurr: state_type] :
      ( v139435(VarCurr,0)
    <=> v139489(VarCurr) ) ).

tff(addAssignment_77993,axiom,
    ! [VarCurr: state_type] :
      ( v139435(VarCurr,1)
    <=> v139484(VarCurr) ) ).

tff(addAssignment_77992,axiom,
    ! [VarCurr: state_type] :
      ( v139435(VarCurr,2)
    <=> v139479(VarCurr) ) ).

tff(addAssignment_77991,axiom,
    ! [VarCurr: state_type] :
      ( v139435(VarCurr,3)
    <=> v139474(VarCurr) ) ).

tff(addAssignment_77990,axiom,
    ! [VarCurr: state_type] :
      ( v139435(VarCurr,4)
    <=> v139437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18482,axiom,
    ! [VarCurr: state_type] :
      ( v139489(VarCurr)
    <=> ( v139490(VarCurr)
        & v139493(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18481,axiom,
    ! [VarCurr: state_type] :
      ( v139493(VarCurr)
    <=> ( v139447(VarCurr,0)
        | v139448(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18480,axiom,
    ! [VarCurr: state_type] :
      ( v139490(VarCurr)
    <=> ( v139491(VarCurr)
        | v139492(VarCurr) ) ) ).

tff(writeUnaryOperator_10497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139492(VarCurr)
    <=> v139448(VarCurr,0) ) ).

tff(writeUnaryOperator_10496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139491(VarCurr)
    <=> v139447(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18479,axiom,
    ! [VarCurr: state_type] :
      ( v139484(VarCurr)
    <=> ( v139485(VarCurr)
        & v139488(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18478,axiom,
    ! [VarCurr: state_type] :
      ( v139488(VarCurr)
    <=> ( v139446(VarCurr)
        | v139449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18477,axiom,
    ! [VarCurr: state_type] :
      ( v139485(VarCurr)
    <=> ( v139486(VarCurr)
        | v139487(VarCurr) ) ) ).

tff(writeUnaryOperator_10495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139487(VarCurr)
    <=> v139449(VarCurr) ) ).

tff(writeUnaryOperator_10494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139486(VarCurr)
    <=> v139446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18476,axiom,
    ! [VarCurr: state_type] :
      ( v139479(VarCurr)
    <=> ( v139480(VarCurr)
        & v139483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18475,axiom,
    ! [VarCurr: state_type] :
      ( v139483(VarCurr)
    <=> ( v139444(VarCurr)
        | v139455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18474,axiom,
    ! [VarCurr: state_type] :
      ( v139480(VarCurr)
    <=> ( v139481(VarCurr)
        | v139482(VarCurr) ) ) ).

tff(writeUnaryOperator_10493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139482(VarCurr)
    <=> v139455(VarCurr) ) ).

tff(writeUnaryOperator_10492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139481(VarCurr)
    <=> v139444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18473,axiom,
    ! [VarCurr: state_type] :
      ( v139474(VarCurr)
    <=> ( v139475(VarCurr)
        & v139478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18472,axiom,
    ! [VarCurr: state_type] :
      ( v139478(VarCurr)
    <=> ( v139442(VarCurr)
        | v139461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18471,axiom,
    ! [VarCurr: state_type] :
      ( v139475(VarCurr)
    <=> ( v139476(VarCurr)
        | v139477(VarCurr) ) ) ).

tff(writeUnaryOperator_10491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139477(VarCurr)
    <=> v139461(VarCurr) ) ).

tff(writeUnaryOperator_10490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139476(VarCurr)
    <=> v139442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18470,axiom,
    ! [VarCurr: state_type] :
      ( v139437(VarCurr)
    <=> ( v139438(VarCurr)
        & v139473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18469,axiom,
    ! [VarCurr: state_type] :
      ( v139473(VarCurr)
    <=> ( v139440(VarCurr)
        | v139468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18468,axiom,
    ! [VarCurr: state_type] :
      ( v139438(VarCurr)
    <=> ( v139439(VarCurr)
        | v139467(VarCurr) ) ) ).

tff(writeUnaryOperator_10489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139467(VarCurr)
    <=> v139468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18467,axiom,
    ! [VarCurr: state_type] :
      ( v139468(VarCurr)
    <=> ( v139469(VarCurr)
        & v139472(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6727,axiom,
    ! [VarCurr: state_type] :
      ( v139472(VarCurr)
    <=> ( v139447(VarCurr,4)
        | v139448(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18466,axiom,
    ! [VarCurr: state_type] :
      ( v139469(VarCurr)
    <=> ( v139470(VarCurr)
        | v139471(VarCurr) ) ) ).

tff(writeUnaryOperator_10488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139471(VarCurr)
    <=> v139448(VarCurr,4) ) ).

tff(writeUnaryOperator_10487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139470(VarCurr)
    <=> v139447(VarCurr,4) ) ).

tff(writeUnaryOperator_10486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139439(VarCurr)
    <=> v139440(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18465,axiom,
    ! [VarCurr: state_type] :
      ( v139440(VarCurr)
    <=> ( v139441(VarCurr)
        | v139466(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6726,axiom,
    ! [VarCurr: state_type] :
      ( v139466(VarCurr)
    <=> ( v139447(VarCurr,3)
        & v139448(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18464,axiom,
    ! [VarCurr: state_type] :
      ( v139441(VarCurr)
    <=> ( v139442(VarCurr)
        & v139461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18463,axiom,
    ! [VarCurr: state_type] :
      ( v139461(VarCurr)
    <=> ( v139462(VarCurr)
        & v139465(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6725,axiom,
    ! [VarCurr: state_type] :
      ( v139465(VarCurr)
    <=> ( v139447(VarCurr,3)
        | v139448(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18462,axiom,
    ! [VarCurr: state_type] :
      ( v139462(VarCurr)
    <=> ( v139463(VarCurr)
        | v139464(VarCurr) ) ) ).

tff(writeUnaryOperator_10485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139464(VarCurr)
    <=> v139448(VarCurr,3) ) ).

tff(writeUnaryOperator_10484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139463(VarCurr)
    <=> v139447(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18461,axiom,
    ! [VarCurr: state_type] :
      ( v139442(VarCurr)
    <=> ( v139443(VarCurr)
        | v139460(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6724,axiom,
    ! [VarCurr: state_type] :
      ( v139460(VarCurr)
    <=> ( v139447(VarCurr,2)
        & v139448(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18460,axiom,
    ! [VarCurr: state_type] :
      ( v139443(VarCurr)
    <=> ( v139444(VarCurr)
        & v139455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18459,axiom,
    ! [VarCurr: state_type] :
      ( v139455(VarCurr)
    <=> ( v139456(VarCurr)
        & v139459(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6723,axiom,
    ! [VarCurr: state_type] :
      ( v139459(VarCurr)
    <=> ( v139447(VarCurr,2)
        | v139448(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18458,axiom,
    ! [VarCurr: state_type] :
      ( v139456(VarCurr)
    <=> ( v139457(VarCurr)
        | v139458(VarCurr) ) ) ).

tff(writeUnaryOperator_10483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139458(VarCurr)
    <=> v139448(VarCurr,2) ) ).

tff(writeUnaryOperator_10482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139457(VarCurr)
    <=> v139447(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18457,axiom,
    ! [VarCurr: state_type] :
      ( v139444(VarCurr)
    <=> ( v139445(VarCurr)
        | v139454(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6722,axiom,
    ! [VarCurr: state_type] :
      ( v139454(VarCurr)
    <=> ( v139447(VarCurr,1)
        & v139448(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18456,axiom,
    ! [VarCurr: state_type] :
      ( v139445(VarCurr)
    <=> ( v139446(VarCurr)
        & v139449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18455,axiom,
    ! [VarCurr: state_type] :
      ( v139449(VarCurr)
    <=> ( v139450(VarCurr)
        & v139453(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6721,axiom,
    ! [VarCurr: state_type] :
      ( v139453(VarCurr)
    <=> ( v139447(VarCurr,1)
        | v139448(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18454,axiom,
    ! [VarCurr: state_type] :
      ( v139450(VarCurr)
    <=> ( v139451(VarCurr)
        | v139452(VarCurr) ) ) ).

tff(writeUnaryOperator_10481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139452(VarCurr)
    <=> v139448(VarCurr,1) ) ).

tff(writeUnaryOperator_10480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139451(VarCurr)
    <=> v139447(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18453,axiom,
    ! [VarCurr: state_type] :
      ( v139446(VarCurr)
    <=> ( v139447(VarCurr,0)
        & v139448(VarCurr,0) ) ) ).

tff(addAssignment_77989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v139448(VarCurr,B)
      <=> v113478(VarCurr,B) ) ) ).

tff(addAssignment_77988,axiom,
    ! [VarCurr: state_type] :
      ( v139448(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_77987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v139447(VarCurr,B)
      <=> v113633(VarCurr,B) ) ) ).

tff(addAssignment_77986,axiom,
    ! [VarCurr: state_type] :
      ( v139447(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_77985,axiom,
    ! [VarCurr: state_type] :
      ( v139375(VarCurr,0)
    <=> v139429(VarCurr) ) ).

tff(addAssignment_77984,axiom,
    ! [VarCurr: state_type] :
      ( v139375(VarCurr,1)
    <=> v139424(VarCurr) ) ).

tff(addAssignment_77983,axiom,
    ! [VarCurr: state_type] :
      ( v139375(VarCurr,2)
    <=> v139419(VarCurr) ) ).

tff(addAssignment_77982,axiom,
    ! [VarCurr: state_type] :
      ( v139375(VarCurr,3)
    <=> v139414(VarCurr) ) ).

tff(addAssignment_77981,axiom,
    ! [VarCurr: state_type] :
      ( v139375(VarCurr,4)
    <=> v139377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18452,axiom,
    ! [VarCurr: state_type] :
      ( v139429(VarCurr)
    <=> ( v139430(VarCurr)
        & v139433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18451,axiom,
    ! [VarCurr: state_type] :
      ( v139433(VarCurr)
    <=> ( v139387(VarCurr,0)
        | v139388(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18450,axiom,
    ! [VarCurr: state_type] :
      ( v139430(VarCurr)
    <=> ( v139431(VarCurr)
        | v139432(VarCurr) ) ) ).

tff(writeUnaryOperator_10479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139432(VarCurr)
    <=> v139388(VarCurr,0) ) ).

tff(writeUnaryOperator_10478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139431(VarCurr)
    <=> v139387(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18449,axiom,
    ! [VarCurr: state_type] :
      ( v139424(VarCurr)
    <=> ( v139425(VarCurr)
        & v139428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18448,axiom,
    ! [VarCurr: state_type] :
      ( v139428(VarCurr)
    <=> ( v139386(VarCurr)
        | v139389(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18447,axiom,
    ! [VarCurr: state_type] :
      ( v139425(VarCurr)
    <=> ( v139426(VarCurr)
        | v139427(VarCurr) ) ) ).

tff(writeUnaryOperator_10477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139427(VarCurr)
    <=> v139389(VarCurr) ) ).

tff(writeUnaryOperator_10476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139426(VarCurr)
    <=> v139386(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18446,axiom,
    ! [VarCurr: state_type] :
      ( v139419(VarCurr)
    <=> ( v139420(VarCurr)
        & v139423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18445,axiom,
    ! [VarCurr: state_type] :
      ( v139423(VarCurr)
    <=> ( v139384(VarCurr)
        | v139395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18444,axiom,
    ! [VarCurr: state_type] :
      ( v139420(VarCurr)
    <=> ( v139421(VarCurr)
        | v139422(VarCurr) ) ) ).

tff(writeUnaryOperator_10475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139422(VarCurr)
    <=> v139395(VarCurr) ) ).

tff(writeUnaryOperator_10474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139421(VarCurr)
    <=> v139384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18443,axiom,
    ! [VarCurr: state_type] :
      ( v139414(VarCurr)
    <=> ( v139415(VarCurr)
        & v139418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18442,axiom,
    ! [VarCurr: state_type] :
      ( v139418(VarCurr)
    <=> ( v139382(VarCurr)
        | v139401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18441,axiom,
    ! [VarCurr: state_type] :
      ( v139415(VarCurr)
    <=> ( v139416(VarCurr)
        | v139417(VarCurr) ) ) ).

tff(writeUnaryOperator_10473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139417(VarCurr)
    <=> v139401(VarCurr) ) ).

tff(writeUnaryOperator_10472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139416(VarCurr)
    <=> v139382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18440,axiom,
    ! [VarCurr: state_type] :
      ( v139377(VarCurr)
    <=> ( v139378(VarCurr)
        & v139413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18439,axiom,
    ! [VarCurr: state_type] :
      ( v139413(VarCurr)
    <=> ( v139380(VarCurr)
        | v139408(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18438,axiom,
    ! [VarCurr: state_type] :
      ( v139378(VarCurr)
    <=> ( v139379(VarCurr)
        | v139407(VarCurr) ) ) ).

tff(writeUnaryOperator_10471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139407(VarCurr)
    <=> v139408(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18437,axiom,
    ! [VarCurr: state_type] :
      ( v139408(VarCurr)
    <=> ( v139409(VarCurr)
        & v139412(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6720,axiom,
    ! [VarCurr: state_type] :
      ( v139412(VarCurr)
    <=> ( v139387(VarCurr,4)
        | v139388(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18436,axiom,
    ! [VarCurr: state_type] :
      ( v139409(VarCurr)
    <=> ( v139410(VarCurr)
        | v139411(VarCurr) ) ) ).

tff(writeUnaryOperator_10470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139411(VarCurr)
    <=> v139388(VarCurr,4) ) ).

tff(writeUnaryOperator_10469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139410(VarCurr)
    <=> v139387(VarCurr,4) ) ).

tff(writeUnaryOperator_10468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139379(VarCurr)
    <=> v139380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18435,axiom,
    ! [VarCurr: state_type] :
      ( v139380(VarCurr)
    <=> ( v139381(VarCurr)
        | v139406(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6719,axiom,
    ! [VarCurr: state_type] :
      ( v139406(VarCurr)
    <=> ( v139387(VarCurr,3)
        & v139388(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18434,axiom,
    ! [VarCurr: state_type] :
      ( v139381(VarCurr)
    <=> ( v139382(VarCurr)
        & v139401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18433,axiom,
    ! [VarCurr: state_type] :
      ( v139401(VarCurr)
    <=> ( v139402(VarCurr)
        & v139405(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6718,axiom,
    ! [VarCurr: state_type] :
      ( v139405(VarCurr)
    <=> ( v139387(VarCurr,3)
        | v139388(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18432,axiom,
    ! [VarCurr: state_type] :
      ( v139402(VarCurr)
    <=> ( v139403(VarCurr)
        | v139404(VarCurr) ) ) ).

tff(writeUnaryOperator_10467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139404(VarCurr)
    <=> v139388(VarCurr,3) ) ).

tff(writeUnaryOperator_10466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139403(VarCurr)
    <=> v139387(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18431,axiom,
    ! [VarCurr: state_type] :
      ( v139382(VarCurr)
    <=> ( v139383(VarCurr)
        | v139400(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6717,axiom,
    ! [VarCurr: state_type] :
      ( v139400(VarCurr)
    <=> ( v139387(VarCurr,2)
        & v139388(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18430,axiom,
    ! [VarCurr: state_type] :
      ( v139383(VarCurr)
    <=> ( v139384(VarCurr)
        & v139395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18429,axiom,
    ! [VarCurr: state_type] :
      ( v139395(VarCurr)
    <=> ( v139396(VarCurr)
        & v139399(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6716,axiom,
    ! [VarCurr: state_type] :
      ( v139399(VarCurr)
    <=> ( v139387(VarCurr,2)
        | v139388(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18428,axiom,
    ! [VarCurr: state_type] :
      ( v139396(VarCurr)
    <=> ( v139397(VarCurr)
        | v139398(VarCurr) ) ) ).

tff(writeUnaryOperator_10465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139398(VarCurr)
    <=> v139388(VarCurr,2) ) ).

tff(writeUnaryOperator_10464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139397(VarCurr)
    <=> v139387(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18427,axiom,
    ! [VarCurr: state_type] :
      ( v139384(VarCurr)
    <=> ( v139385(VarCurr)
        | v139394(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6715,axiom,
    ! [VarCurr: state_type] :
      ( v139394(VarCurr)
    <=> ( v139387(VarCurr,1)
        & v139388(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18426,axiom,
    ! [VarCurr: state_type] :
      ( v139385(VarCurr)
    <=> ( v139386(VarCurr)
        & v139389(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18425,axiom,
    ! [VarCurr: state_type] :
      ( v139389(VarCurr)
    <=> ( v139390(VarCurr)
        & v139393(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6714,axiom,
    ! [VarCurr: state_type] :
      ( v139393(VarCurr)
    <=> ( v139387(VarCurr,1)
        | v139388(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18424,axiom,
    ! [VarCurr: state_type] :
      ( v139390(VarCurr)
    <=> ( v139391(VarCurr)
        | v139392(VarCurr) ) ) ).

tff(writeUnaryOperator_10463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139392(VarCurr)
    <=> v139388(VarCurr,1) ) ).

tff(writeUnaryOperator_10462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139391(VarCurr)
    <=> v139387(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18423,axiom,
    ! [VarCurr: state_type] :
      ( v139386(VarCurr)
    <=> ( v139387(VarCurr,0)
        & v139388(VarCurr,0) ) ) ).

tff(addAssignment_77980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v139388(VarCurr,B)
      <=> v113657(VarCurr,B) ) ) ).

tff(addAssignment_77979,axiom,
    ! [VarCurr: state_type] :
      ( v139388(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_77978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v139387(VarCurr,B)
      <=> v113458(VarCurr,B) ) ) ).

tff(addAssignment_77977,axiom,
    ! [VarCurr: state_type] :
      ( v139387(VarCurr,4)
    <=> $false ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18422,axiom,
    ! [VarCurr: state_type] :
      ( v139372(VarCurr)
    <=> ( v1729(VarCurr)
        & v139373(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2046,axiom,
    ! [VarCurr: state_type] :
      ( v139373(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1998,axiom,
    ~ b0000010001000(12) ).

tff(bitBlastConstant_1997,axiom,
    ~ b0000010001000(11) ).

tff(bitBlastConstant_1996,axiom,
    ~ b0000010001000(10) ).

tff(bitBlastConstant_1995,axiom,
    ~ b0000010001000(9) ).

tff(bitBlastConstant_1994,axiom,
    ~ b0000010001000(8) ).

tff(bitBlastConstant_1993,axiom,
    b0000010001000(7) ).

tff(bitBlastConstant_1992,axiom,
    ~ b0000010001000(6) ).

tff(bitBlastConstant_1991,axiom,
    ~ b0000010001000(5) ).

tff(bitBlastConstant_1990,axiom,
    ~ b0000010001000(4) ).

tff(bitBlastConstant_1989,axiom,
    b0000010001000(3) ).

tff(bitBlastConstant_1988,axiom,
    ~ b0000010001000(2) ).

tff(bitBlastConstant_1987,axiom,
    ~ b0000010001000(1) ).

tff(bitBlastConstant_1986,axiom,
    ~ b0000010001000(0) ).

tff(addAssignment_77976,axiom,
    ! [VarCurr: state_type] :
      ( v139359(VarCurr)
    <=> v139361(VarCurr) ) ).

tff(addAssignment_77975,axiom,
    ! [VarCurr: state_type] :
      ( v139361(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_77974,axiom,
    ! [VarCurr: state_type] :
      ( v139355(VarCurr)
    <=> v139357(VarCurr) ) ).

tff(addAssignment_77973,axiom,
    ! [VarCurr: state_type] :
      ( v139357(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_77972,axiom,
    ! [VarCurr: state_type] :
      ( v139337(VarCurr)
    <=> v139339(VarCurr) ) ).

tff(addAssignment_77971,axiom,
    ! [VarCurr: state_type] :
      ( v139339(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_77970,axiom,
    ! [VarCurr: state_type] :
      ( v139333(VarCurr)
    <=> v139335(VarCurr) ) ).

tff(addAssignment_77969,axiom,
    ! [VarCurr: state_type] :
      ( v139335(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18421,axiom,
    ! [VarCurr: state_type] :
      ( v84897(VarCurr)
    <=> ( v118(VarCurr)
        | v84899(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6713,axiom,
    ! [VarCurr: state_type] :
      ( v84899(VarCurr)
    <=> ( v102045(VarCurr)
        | v84901(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84901(VarCurr,B)
      <=> ( v84903(VarCurr,B)
          & v139320(VarCurr,B) ) ) ) ).

tff(addAssignment_77968,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,0)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77967,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,1)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77966,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,2)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77965,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,3)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77964,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,4)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77963,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,5)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77962,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,6)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77961,axiom,
    ! [VarCurr: state_type] :
      ( v139320(VarCurr,7)
    <=> v139321(VarCurr) ) ).

tff(addAssignment_77960,axiom,
    ! [VarCurr: state_type] :
      ( v139321(VarCurr)
    <=> v139322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18420,axiom,
    ! [VarCurr: state_type] :
      ( v139322(VarCurr)
    <=> ( v139323(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeUnaryOperator_10461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139323(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6712,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,7)
    <=> ( v139316(VarCurr)
        & v139318(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2045,axiom,
    ! [VarCurr: state_type] :
      ( v139318(VarCurr)
    <=> ( ( v138148(VarCurr,7)
        <=> $true )
        & ( v138148(VarCurr,6)
        <=> $false )
        & ( v138148(VarCurr,5)
        <=> $false )
        & ( v138148(VarCurr,4)
        <=> $false )
        & ( v138148(VarCurr,3)
        <=> $false )
        & ( v138148(VarCurr,2)
        <=> $false )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1985,axiom,
    b10000000(7) ).

tff(bitBlastConstant_1984,axiom,
    ~ b10000000(6) ).

tff(bitBlastConstant_1983,axiom,
    ~ b10000000(5) ).

tff(bitBlastConstant_1982,axiom,
    ~ b10000000(4) ).

tff(bitBlastConstant_1981,axiom,
    ~ b10000000(3) ).

tff(bitBlastConstant_1980,axiom,
    ~ b10000000(2) ).

tff(bitBlastConstant_1979,axiom,
    ~ b10000000(1) ).

tff(bitBlastConstant_1978,axiom,
    ~ b10000000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18419,axiom,
    ! [VarCurr: state_type] :
      ( v139316(VarCurr)
    <=> ( v139317(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139317(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6711,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,6)
    <=> ( v139312(VarCurr)
        & v139314(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2044,axiom,
    ! [VarCurr: state_type] :
      ( v139314(VarCurr)
    <=> ( ( v138148(VarCurr,6)
        <=> $true )
        & ( v138148(VarCurr,5)
        <=> $false )
        & ( v138148(VarCurr,4)
        <=> $false )
        & ( v138148(VarCurr,3)
        <=> $false )
        & ( v138148(VarCurr,2)
        <=> $false )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18418,axiom,
    ! [VarCurr: state_type] :
      ( v139312(VarCurr)
    <=> ( v139313(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139313(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6710,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,5)
    <=> ( v139308(VarCurr)
        & v139310(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2043,axiom,
    ! [VarCurr: state_type] :
      ( v139310(VarCurr)
    <=> ( ( v138148(VarCurr,5)
        <=> $true )
        & ( v138148(VarCurr,4)
        <=> $false )
        & ( v138148(VarCurr,3)
        <=> $false )
        & ( v138148(VarCurr,2)
        <=> $false )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18417,axiom,
    ! [VarCurr: state_type] :
      ( v139308(VarCurr)
    <=> ( v139309(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139309(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6709,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,4)
    <=> ( v139304(VarCurr)
        & v139306(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2042,axiom,
    ! [VarCurr: state_type] :
      ( v139306(VarCurr)
    <=> ( ( v138148(VarCurr,4)
        <=> $true )
        & ( v138148(VarCurr,3)
        <=> $false )
        & ( v138148(VarCurr,2)
        <=> $false )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18416,axiom,
    ! [VarCurr: state_type] :
      ( v139304(VarCurr)
    <=> ( v139305(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139305(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6708,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,3)
    <=> ( v139300(VarCurr)
        & v139302(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2041,axiom,
    ! [VarCurr: state_type] :
      ( v139302(VarCurr)
    <=> ( ( v138148(VarCurr,3)
        <=> $true )
        & ( v138148(VarCurr,2)
        <=> $false )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18415,axiom,
    ! [VarCurr: state_type] :
      ( v139300(VarCurr)
    <=> ( v139301(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139301(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6707,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,2)
    <=> ( v139296(VarCurr)
        & v139298(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2040,axiom,
    ! [VarCurr: state_type] :
      ( v139298(VarCurr)
    <=> ( ( v138148(VarCurr,2)
        <=> $true )
        & ( v138148(VarCurr,1)
        <=> $false )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18414,axiom,
    ! [VarCurr: state_type] :
      ( v139296(VarCurr)
    <=> ( v139297(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139297(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6706,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,1)
    <=> ( v139292(VarCurr)
        & v139294(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2039,axiom,
    ! [VarCurr: state_type] :
      ( v139294(VarCurr)
    <=> ( ( v138148(VarCurr,1)
        <=> $true )
        & ( v138148(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18413,axiom,
    ! [VarCurr: state_type] :
      ( v139292(VarCurr)
    <=> ( v139293(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139293(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18412,axiom,
    ! [VarCurr: state_type] :
      ( v84903(VarCurr,0)
    <=> ( v139289(VarCurr)
        & v138148(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18411,axiom,
    ! [VarCurr: state_type] :
      ( v139289(VarCurr)
    <=> ( v139290(VarCurr)
        | v138098(VarCurr) ) ) ).

tff(writeUnaryOperator_10453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139290(VarCurr)
    <=> v84905(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6705,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,7)
    <=> ( v139244(VarCurr)
        & v139263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18410,axiom,
    ! [VarCurr: state_type] :
      ( v139263(VarCurr)
    <=> ( v139264(VarCurr)
        | v139285(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2038,axiom,
    ! [VarCurr: state_type] :
      ( v139285(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v139286(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v139286(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v139286(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v139286(VarCurr,0) ) ) ) ).

tff(addAssignment_77959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139286(VarCurr,B)
      <=> v139232(VarCurr,B) ) ) ).

tff(addAssignment_77958,axiom,
    ! [VarCurr: state_type] :
      ( v139286(VarCurr,3)
    <=> v139238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18409,axiom,
    ! [VarCurr: state_type] :
      ( v139264(VarCurr)
    <=> ( v139265(VarCurr)
        | v139266(VarCurr) ) ) ).

tff(writeUnaryOperator_10452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139266(VarCurr)
    <=> v139268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18408,axiom,
    ! [VarCurr: state_type] :
      ( v139268(VarCurr)
    <=> ( v139269(VarCurr)
        & v139280(VarCurr) ) ) ).

tff(writeUnaryOperator_10451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139280(VarCurr)
    <=> v139281(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18407,axiom,
    ! [VarCurr: state_type] :
      ( v139281(VarCurr)
    <=> ( v139282(VarCurr)
        & v139284(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6704,axiom,
    ! [VarCurr: state_type] :
      ( v139284(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v139232(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18406,axiom,
    ! [VarCurr: state_type] :
      ( v139282(VarCurr)
    <=> ( v135621(VarCurr)
        | v139283(VarCurr) ) ) ).

tff(writeUnaryOperator_10450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139283(VarCurr)
    <=> v139232(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18405,axiom,
    ! [VarCurr: state_type] :
      ( v139269(VarCurr)
    <=> ( v139270(VarCurr)
        & v139275(VarCurr) ) ) ).

tff(writeUnaryOperator_10449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139275(VarCurr)
    <=> v139276(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18404,axiom,
    ! [VarCurr: state_type] :
      ( v139276(VarCurr)
    <=> ( v139277(VarCurr)
        & v139279(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6703,axiom,
    ! [VarCurr: state_type] :
      ( v139279(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v139232(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18403,axiom,
    ! [VarCurr: state_type] :
      ( v139277(VarCurr)
    <=> ( v135615(VarCurr)
        | v139278(VarCurr) ) ) ).

tff(writeUnaryOperator_10448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139278(VarCurr)
    <=> v139232(VarCurr,1) ) ).

tff(writeUnaryOperator_10447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139270(VarCurr)
    <=> v139271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18402,axiom,
    ! [VarCurr: state_type] :
      ( v139271(VarCurr)
    <=> ( v139272(VarCurr)
        & v139274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18401,axiom,
    ! [VarCurr: state_type] :
      ( v139274(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v139232(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18400,axiom,
    ! [VarCurr: state_type] :
      ( v139272(VarCurr)
    <=> ( v135609(VarCurr)
        | v139273(VarCurr) ) ) ).

tff(writeUnaryOperator_10446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139273(VarCurr)
    <=> v139232(VarCurr,0) ) ).

tff(writeUnaryOperator_10445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139265(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18399,axiom,
    ! [VarCurr: state_type] :
      ( v139244(VarCurr)
    <=> ( v139245(VarCurr)
        & v139262(VarCurr) ) ) ).

tff(writeUnaryOperator_10444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139262(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6702,axiom,
    ! [VarCurr: state_type] :
      ( v139245(VarCurr)
    <=> ( v139247(VarCurr)
        | v139261(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6701,axiom,
    ! [VarCurr: state_type] :
      ( v139247(VarCurr)
    <=> ( v139248(VarCurr)
        | v139261(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6700,axiom,
    ! [VarCurr: state_type] :
      ( v139248(VarCurr)
    <=> ( v139249(VarCurr)
        | v139261(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6699,axiom,
    ! [VarCurr: state_type] :
      ( v139249(VarCurr)
    <=> ( v139250(VarCurr)
        | v139261(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6698,axiom,
    ! [VarCurr: state_type] :
      ( v139250(VarCurr)
    <=> ( v139251(VarCurr)
        | v139261(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6697,axiom,
    ! [VarCurr: state_type] :
      ( v139251(VarCurr)
    <=> ( v139252(VarCurr)
        | v139261(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6696,axiom,
    ! [VarCurr: state_type] :
      ( v139252(VarCurr)
    <=> ( v139253(VarCurr)
        | v139261(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6695,axiom,
    ! [VarCurr: state_type] :
      ( v139253(VarCurr)
    <=> ( v139254(VarCurr)
        | v139261(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6694,axiom,
    ! [VarCurr: state_type] :
      ( v139254(VarCurr)
    <=> ( v139255(VarCurr)
        | v139261(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6693,axiom,
    ! [VarCurr: state_type] :
      ( v139255(VarCurr)
    <=> ( v139256(VarCurr)
        | v139261(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6692,axiom,
    ! [VarCurr: state_type] :
      ( v139256(VarCurr)
    <=> ( v139257(VarCurr)
        | v139261(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6691,axiom,
    ! [VarCurr: state_type] :
      ( v139257(VarCurr)
    <=> ( v139258(VarCurr)
        | v139261(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6690,axiom,
    ! [VarCurr: state_type] :
      ( v139258(VarCurr)
    <=> ( v139259(VarCurr)
        | v139261(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6689,axiom,
    ! [VarCurr: state_type] :
      ( v139259(VarCurr)
    <=> ( v139260(VarCurr)
        | v139261(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6688,axiom,
    ! [VarCurr: state_type] :
      ( v139260(VarCurr)
    <=> ( v139261(VarCurr,0)
        | v139261(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139261(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v139151(VarCurr,B) ) ) ) ).

tff(addAssignment_77957,axiom,
    ! [VarCurr: state_type] :
      ( v139238(VarCurr)
    <=> v139240(VarCurr) ) ).

tff(addAssignment_77956,axiom,
    ! [VarCurr: state_type] :
      ( v139240(VarCurr)
    <=> v139242(VarCurr) ) ).

tff(addAssignment_77955,axiom,
    ! [VarCurr: state_type] :
      ( v139242(VarCurr)
    <=> v89253(VarCurr,6) ) ).

tff(addAssignment_77954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139232(VarCurr,B)
      <=> v139234(VarCurr,B) ) ) ).

tff(addAssignment_77953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139234(VarCurr,B)
      <=> v139236(VarCurr,B) ) ) ).

tff(addAssignment_77952,axiom,
    ! [VarCurr: state_type] :
      ( ( v139236(VarCurr,2)
      <=> v89253(VarCurr,5) )
      & ( v139236(VarCurr,1)
      <=> v89253(VarCurr,4) )
      & ( v139236(VarCurr,0)
      <=> v89253(VarCurr,3) ) ) ).

tff(addAssignment_77951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139151(VarCurr,B)
      <=> v139153(VarCurr,B) ) ) ).

tff(addAssignment_77950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139153(VarCurr,B)
      <=> v139155(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139155(VarCurr,B)
      <=> ( v139195(VarCurr,B)
          & v139199(VarCurr,B) ) ) ) ).

tff(addAssignment_77949,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,0)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77948,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,1)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77947,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,2)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77946,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,3)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77945,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,4)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77944,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,5)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77943,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,6)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77942,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,7)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77941,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,8)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77940,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,9)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77939,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,10)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77938,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,11)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77937,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,12)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77936,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,13)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77935,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,14)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77934,axiom,
    ! [VarCurr: state_type] :
      ( v139199(VarCurr,15)
    <=> v139200(VarCurr) ) ).

tff(addAssignment_77933,axiom,
    ! [VarCurr: state_type] :
      ( v139200(VarCurr)
    <=> v139201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18398,axiom,
    ! [VarCurr: state_type] :
      ( v139201(VarCurr)
    <=> ( v139202(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18397,axiom,
    ! [VarCurr: state_type] :
      ( v139202(VarCurr)
    <=> ( v139203(VarCurr)
        & v139230(VarCurr) ) ) ).

tff(writeUnaryOperator_10443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139230(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18396,axiom,
    ! [VarCurr: state_type] :
      ( v139203(VarCurr)
    <=> ( v139204(VarCurr)
        & v139229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18395,axiom,
    ! [VarCurr: state_type] :
      ( v139229(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139204(VarCurr)
    <=> v139206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18394,axiom,
    ! [VarCurr: state_type] :
      ( v139206(VarCurr)
    <=> ( v139207(VarCurr)
        & v139224(VarCurr) ) ) ).

tff(writeUnaryOperator_10441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139224(VarCurr)
    <=> v139225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18393,axiom,
    ! [VarCurr: state_type] :
      ( v139225(VarCurr)
    <=> ( v139226(VarCurr)
        & v139228(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6687,axiom,
    ! [VarCurr: state_type] :
      ( v139228(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v89253(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18392,axiom,
    ! [VarCurr: state_type] :
      ( v139226(VarCurr)
    <=> ( v138404(VarCurr)
        | v139227(VarCurr) ) ) ).

tff(writeUnaryOperator_10440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139227(VarCurr)
    <=> v89253(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18391,axiom,
    ! [VarCurr: state_type] :
      ( v139207(VarCurr)
    <=> ( v139208(VarCurr)
        & v139219(VarCurr) ) ) ).

tff(writeUnaryOperator_10439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139219(VarCurr)
    <=> v139220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18390,axiom,
    ! [VarCurr: state_type] :
      ( v139220(VarCurr)
    <=> ( v139221(VarCurr)
        & v139223(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6686,axiom,
    ! [VarCurr: state_type] :
      ( v139223(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v89253(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18389,axiom,
    ! [VarCurr: state_type] :
      ( v139221(VarCurr)
    <=> ( v138398(VarCurr)
        | v139222(VarCurr) ) ) ).

tff(writeUnaryOperator_10438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139222(VarCurr)
    <=> v89253(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18388,axiom,
    ! [VarCurr: state_type] :
      ( v139208(VarCurr)
    <=> ( v139209(VarCurr)
        & v139214(VarCurr) ) ) ).

tff(writeUnaryOperator_10437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139214(VarCurr)
    <=> v139215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18387,axiom,
    ! [VarCurr: state_type] :
      ( v139215(VarCurr)
    <=> ( v139216(VarCurr)
        & v139218(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6685,axiom,
    ! [VarCurr: state_type] :
      ( v139218(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v89253(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18386,axiom,
    ! [VarCurr: state_type] :
      ( v139216(VarCurr)
    <=> ( v138392(VarCurr)
        | v139217(VarCurr) ) ) ).

tff(writeUnaryOperator_10436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139217(VarCurr)
    <=> v89253(VarCurr,4) ) ).

tff(writeUnaryOperator_10435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139209(VarCurr)
    <=> v139210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18385,axiom,
    ! [VarCurr: state_type] :
      ( v139210(VarCurr)
    <=> ( v139211(VarCurr)
        & v139213(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6684,axiom,
    ! [VarCurr: state_type] :
      ( v139213(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v89253(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18384,axiom,
    ! [VarCurr: state_type] :
      ( v139211(VarCurr)
    <=> ( v138386(VarCurr)
        | v139212(VarCurr) ) ) ).

tff(writeUnaryOperator_10434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139212(VarCurr)
    <=> v89253(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139195(VarCurr,B)
      <=> ( v139196(VarCurr,B)
          & v127999(VarCurr,B) ) ) ) ).

tff(addAssignment_77932,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,0)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77931,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,1)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77930,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,2)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77929,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,3)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77928,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,4)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77927,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,5)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77926,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,6)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77925,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,7)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77924,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,8)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77923,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,9)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77922,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,10)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77921,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,11)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77920,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,12)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77919,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,13)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77918,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,14)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77917,axiom,
    ! [VarCurr: state_type] :
      ( v139196(VarCurr,15)
    <=> v139197(VarCurr) ) ).

tff(addAssignment_77916,axiom,
    ! [VarCurr: state_type] :
      ( v139197(VarCurr)
    <=> v139198(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6683,axiom,
    ! [VarCurr: state_type] :
      ( v139198(VarCurr)
    <=> ( v134(VarCurr,7)
        & v139157(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6682,axiom,
    ! [VarCurr: state_type] :
      ( v139157(VarCurr)
    <=> ( v139179(VarCurr)
        | v139193(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6681,axiom,
    ! [VarCurr: state_type] :
      ( v139179(VarCurr)
    <=> ( v139180(VarCurr)
        | v139193(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6680,axiom,
    ! [VarCurr: state_type] :
      ( v139180(VarCurr)
    <=> ( v139181(VarCurr)
        | v139193(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6679,axiom,
    ! [VarCurr: state_type] :
      ( v139181(VarCurr)
    <=> ( v139182(VarCurr)
        | v139193(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6678,axiom,
    ! [VarCurr: state_type] :
      ( v139182(VarCurr)
    <=> ( v139183(VarCurr)
        | v139193(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6677,axiom,
    ! [VarCurr: state_type] :
      ( v139183(VarCurr)
    <=> ( v139184(VarCurr)
        | v139193(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6676,axiom,
    ! [VarCurr: state_type] :
      ( v139184(VarCurr)
    <=> ( v139185(VarCurr)
        | v139193(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6675,axiom,
    ! [VarCurr: state_type] :
      ( v139185(VarCurr)
    <=> ( v139186(VarCurr)
        | v139193(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6674,axiom,
    ! [VarCurr: state_type] :
      ( v139186(VarCurr)
    <=> ( v139187(VarCurr)
        | v139193(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6673,axiom,
    ! [VarCurr: state_type] :
      ( v139187(VarCurr)
    <=> ( v139188(VarCurr)
        | v139193(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6672,axiom,
    ! [VarCurr: state_type] :
      ( v139188(VarCurr)
    <=> ( v139189(VarCurr)
        | v139193(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6671,axiom,
    ! [VarCurr: state_type] :
      ( v139189(VarCurr)
    <=> ( v139190(VarCurr)
        | v139193(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6670,axiom,
    ! [VarCurr: state_type] :
      ( v139190(VarCurr)
    <=> ( v139191(VarCurr)
        | v139193(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6669,axiom,
    ! [VarCurr: state_type] :
      ( v139191(VarCurr)
    <=> ( v139192(VarCurr)
        | v139193(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6668,axiom,
    ! [VarCurr: state_type] :
      ( v139192(VarCurr)
    <=> ( v139193(VarCurr,0)
        | v139193(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139193(VarCurr,B)
      <=> ( v139159(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77915,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,0)
    <=> v139176(VarCurr) ) ).

tff(addAssignment_77914,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,1)
    <=> v139175(VarCurr) ) ).

tff(addAssignment_77913,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,2)
    <=> v139174(VarCurr) ) ).

tff(addAssignment_77912,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,3)
    <=> v139173(VarCurr) ) ).

tff(addAssignment_77911,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,4)
    <=> v139172(VarCurr) ) ).

tff(addAssignment_77910,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,5)
    <=> v139171(VarCurr) ) ).

tff(addAssignment_77909,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,6)
    <=> v139170(VarCurr) ) ).

tff(addAssignment_77908,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,7)
    <=> v139169(VarCurr) ) ).

tff(addAssignment_77907,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,8)
    <=> v139168(VarCurr) ) ).

tff(addAssignment_77906,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,9)
    <=> v139167(VarCurr) ) ).

tff(addAssignment_77905,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,10)
    <=> v139166(VarCurr) ) ).

tff(addAssignment_77904,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,11)
    <=> v139165(VarCurr) ) ).

tff(addAssignment_77903,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,12)
    <=> v139164(VarCurr) ) ).

tff(addAssignment_77902,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,13)
    <=> v139163(VarCurr) ) ).

tff(addAssignment_77901,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,14)
    <=> v139162(VarCurr) ) ).

tff(addAssignment_77900,axiom,
    ! [VarCurr: state_type] :
      ( v139159(VarCurr,15)
    <=> v139161(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2037,axiom,
    ! [VarCurr: state_type] :
      ( v139176(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2036,axiom,
    ! [VarCurr: state_type] :
      ( v139175(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2035,axiom,
    ! [VarCurr: state_type] :
      ( v139174(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2034,axiom,
    ! [VarCurr: state_type] :
      ( v139173(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2033,axiom,
    ! [VarCurr: state_type] :
      ( v139172(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2032,axiom,
    ! [VarCurr: state_type] :
      ( v139171(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2031,axiom,
    ! [VarCurr: state_type] :
      ( v139170(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2030,axiom,
    ! [VarCurr: state_type] :
      ( v139169(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $false )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2029,axiom,
    ! [VarCurr: state_type] :
      ( v139168(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2028,axiom,
    ! [VarCurr: state_type] :
      ( v139167(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2027,axiom,
    ! [VarCurr: state_type] :
      ( v139166(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2026,axiom,
    ! [VarCurr: state_type] :
      ( v139165(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $false )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2025,axiom,
    ! [VarCurr: state_type] :
      ( v139164(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2024,axiom,
    ! [VarCurr: state_type] :
      ( v139163(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $false )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2023,axiom,
    ! [VarCurr: state_type] :
      ( v139162(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2022,axiom,
    ! [VarCurr: state_type] :
      ( v139161(VarCurr)
    <=> ( ( v89253(VarCurr,6)
        <=> $true )
        & ( v89253(VarCurr,5)
        <=> $true )
        & ( v89253(VarCurr,4)
        <=> $true )
        & ( v89253(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6667,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,6)
    <=> ( v139107(VarCurr)
        & v139126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18383,axiom,
    ! [VarCurr: state_type] :
      ( v139126(VarCurr)
    <=> ( v139127(VarCurr)
        | v139148(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2021,axiom,
    ! [VarCurr: state_type] :
      ( v139148(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v139149(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v139149(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v139149(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v139149(VarCurr,0) ) ) ) ).

tff(addAssignment_77899,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139149(VarCurr,B)
      <=> v139095(VarCurr,B) ) ) ).

tff(addAssignment_77898,axiom,
    ! [VarCurr: state_type] :
      ( v139149(VarCurr,3)
    <=> v139101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18382,axiom,
    ! [VarCurr: state_type] :
      ( v139127(VarCurr)
    <=> ( v139128(VarCurr)
        | v139129(VarCurr) ) ) ).

tff(writeUnaryOperator_10433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139129(VarCurr)
    <=> v139131(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18381,axiom,
    ! [VarCurr: state_type] :
      ( v139131(VarCurr)
    <=> ( v139132(VarCurr)
        & v139143(VarCurr) ) ) ).

tff(writeUnaryOperator_10432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139143(VarCurr)
    <=> v139144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18380,axiom,
    ! [VarCurr: state_type] :
      ( v139144(VarCurr)
    <=> ( v139145(VarCurr)
        & v139147(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6666,axiom,
    ! [VarCurr: state_type] :
      ( v139147(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v139095(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18379,axiom,
    ! [VarCurr: state_type] :
      ( v139145(VarCurr)
    <=> ( v135621(VarCurr)
        | v139146(VarCurr) ) ) ).

tff(writeUnaryOperator_10431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139146(VarCurr)
    <=> v139095(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18378,axiom,
    ! [VarCurr: state_type] :
      ( v139132(VarCurr)
    <=> ( v139133(VarCurr)
        & v139138(VarCurr) ) ) ).

tff(writeUnaryOperator_10430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139138(VarCurr)
    <=> v139139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18377,axiom,
    ! [VarCurr: state_type] :
      ( v139139(VarCurr)
    <=> ( v139140(VarCurr)
        & v139142(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6665,axiom,
    ! [VarCurr: state_type] :
      ( v139142(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v139095(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18376,axiom,
    ! [VarCurr: state_type] :
      ( v139140(VarCurr)
    <=> ( v135615(VarCurr)
        | v139141(VarCurr) ) ) ).

tff(writeUnaryOperator_10429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139141(VarCurr)
    <=> v139095(VarCurr,1) ) ).

tff(writeUnaryOperator_10428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139133(VarCurr)
    <=> v139134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18375,axiom,
    ! [VarCurr: state_type] :
      ( v139134(VarCurr)
    <=> ( v139135(VarCurr)
        & v139137(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18374,axiom,
    ! [VarCurr: state_type] :
      ( v139137(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v139095(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18373,axiom,
    ! [VarCurr: state_type] :
      ( v139135(VarCurr)
    <=> ( v135609(VarCurr)
        | v139136(VarCurr) ) ) ).

tff(writeUnaryOperator_10427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139136(VarCurr)
    <=> v139095(VarCurr,0) ) ).

tff(writeUnaryOperator_10426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139128(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18372,axiom,
    ! [VarCurr: state_type] :
      ( v139107(VarCurr)
    <=> ( v139108(VarCurr)
        & v139125(VarCurr) ) ) ).

tff(writeUnaryOperator_10425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139125(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6664,axiom,
    ! [VarCurr: state_type] :
      ( v139108(VarCurr)
    <=> ( v139110(VarCurr)
        | v139124(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6663,axiom,
    ! [VarCurr: state_type] :
      ( v139110(VarCurr)
    <=> ( v139111(VarCurr)
        | v139124(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6662,axiom,
    ! [VarCurr: state_type] :
      ( v139111(VarCurr)
    <=> ( v139112(VarCurr)
        | v139124(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6661,axiom,
    ! [VarCurr: state_type] :
      ( v139112(VarCurr)
    <=> ( v139113(VarCurr)
        | v139124(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6660,axiom,
    ! [VarCurr: state_type] :
      ( v139113(VarCurr)
    <=> ( v139114(VarCurr)
        | v139124(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6659,axiom,
    ! [VarCurr: state_type] :
      ( v139114(VarCurr)
    <=> ( v139115(VarCurr)
        | v139124(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6658,axiom,
    ! [VarCurr: state_type] :
      ( v139115(VarCurr)
    <=> ( v139116(VarCurr)
        | v139124(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6657,axiom,
    ! [VarCurr: state_type] :
      ( v139116(VarCurr)
    <=> ( v139117(VarCurr)
        | v139124(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6656,axiom,
    ! [VarCurr: state_type] :
      ( v139117(VarCurr)
    <=> ( v139118(VarCurr)
        | v139124(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6655,axiom,
    ! [VarCurr: state_type] :
      ( v139118(VarCurr)
    <=> ( v139119(VarCurr)
        | v139124(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6654,axiom,
    ! [VarCurr: state_type] :
      ( v139119(VarCurr)
    <=> ( v139120(VarCurr)
        | v139124(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6653,axiom,
    ! [VarCurr: state_type] :
      ( v139120(VarCurr)
    <=> ( v139121(VarCurr)
        | v139124(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6652,axiom,
    ! [VarCurr: state_type] :
      ( v139121(VarCurr)
    <=> ( v139122(VarCurr)
        | v139124(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6651,axiom,
    ! [VarCurr: state_type] :
      ( v139122(VarCurr)
    <=> ( v139123(VarCurr)
        | v139124(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6650,axiom,
    ! [VarCurr: state_type] :
      ( v139123(VarCurr)
    <=> ( v139124(VarCurr,0)
        | v139124(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139124(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v139014(VarCurr,B) ) ) ) ).

tff(addAssignment_77897,axiom,
    ! [VarCurr: state_type] :
      ( v139101(VarCurr)
    <=> v139103(VarCurr) ) ).

tff(addAssignment_77896,axiom,
    ! [VarCurr: state_type] :
      ( v139103(VarCurr)
    <=> v139105(VarCurr) ) ).

tff(addAssignment_77895,axiom,
    ! [VarCurr: state_type] :
      ( v139105(VarCurr)
    <=> v109114(VarCurr,6) ) ).

tff(addAssignment_77894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139095(VarCurr,B)
      <=> v139097(VarCurr,B) ) ) ).

tff(addAssignment_77893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139097(VarCurr,B)
      <=> v139099(VarCurr,B) ) ) ).

tff(addAssignment_77892,axiom,
    ! [VarCurr: state_type] :
      ( ( v139099(VarCurr,2)
      <=> v109114(VarCurr,5) )
      & ( v139099(VarCurr,1)
      <=> v109114(VarCurr,4) )
      & ( v139099(VarCurr,0)
      <=> v109114(VarCurr,3) ) ) ).

tff(addAssignment_77891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139014(VarCurr,B)
      <=> v139016(VarCurr,B) ) ) ).

tff(addAssignment_77890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139016(VarCurr,B)
      <=> v139018(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139018(VarCurr,B)
      <=> ( v139058(VarCurr,B)
          & v139062(VarCurr,B) ) ) ) ).

tff(addAssignment_77889,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,0)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77888,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,1)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77887,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,2)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77886,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,3)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77885,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,4)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77884,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,5)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77883,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,6)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77882,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,7)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77881,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,8)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77880,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,9)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77879,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,10)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77878,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,11)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77877,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,12)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77876,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,13)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77875,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,14)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77874,axiom,
    ! [VarCurr: state_type] :
      ( v139062(VarCurr,15)
    <=> v139063(VarCurr) ) ).

tff(addAssignment_77873,axiom,
    ! [VarCurr: state_type] :
      ( v139063(VarCurr)
    <=> v139064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18371,axiom,
    ! [VarCurr: state_type] :
      ( v139064(VarCurr)
    <=> ( v139065(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18370,axiom,
    ! [VarCurr: state_type] :
      ( v139065(VarCurr)
    <=> ( v139066(VarCurr)
        & v139093(VarCurr) ) ) ).

tff(writeUnaryOperator_10424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139093(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18369,axiom,
    ! [VarCurr: state_type] :
      ( v139066(VarCurr)
    <=> ( v139067(VarCurr)
        & v139092(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18368,axiom,
    ! [VarCurr: state_type] :
      ( v139092(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139067(VarCurr)
    <=> v139069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18367,axiom,
    ! [VarCurr: state_type] :
      ( v139069(VarCurr)
    <=> ( v139070(VarCurr)
        & v139087(VarCurr) ) ) ).

tff(writeUnaryOperator_10422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139087(VarCurr)
    <=> v139088(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18366,axiom,
    ! [VarCurr: state_type] :
      ( v139088(VarCurr)
    <=> ( v139089(VarCurr)
        & v139091(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6649,axiom,
    ! [VarCurr: state_type] :
      ( v139091(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109114(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18365,axiom,
    ! [VarCurr: state_type] :
      ( v139089(VarCurr)
    <=> ( v138404(VarCurr)
        | v139090(VarCurr) ) ) ).

tff(writeUnaryOperator_10421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139090(VarCurr)
    <=> v109114(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18364,axiom,
    ! [VarCurr: state_type] :
      ( v139070(VarCurr)
    <=> ( v139071(VarCurr)
        & v139082(VarCurr) ) ) ).

tff(writeUnaryOperator_10420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139082(VarCurr)
    <=> v139083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18363,axiom,
    ! [VarCurr: state_type] :
      ( v139083(VarCurr)
    <=> ( v139084(VarCurr)
        & v139086(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6648,axiom,
    ! [VarCurr: state_type] :
      ( v139086(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109114(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18362,axiom,
    ! [VarCurr: state_type] :
      ( v139084(VarCurr)
    <=> ( v138398(VarCurr)
        | v139085(VarCurr) ) ) ).

tff(writeUnaryOperator_10419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139085(VarCurr)
    <=> v109114(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18361,axiom,
    ! [VarCurr: state_type] :
      ( v139071(VarCurr)
    <=> ( v139072(VarCurr)
        & v139077(VarCurr) ) ) ).

tff(writeUnaryOperator_10418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139077(VarCurr)
    <=> v139078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18360,axiom,
    ! [VarCurr: state_type] :
      ( v139078(VarCurr)
    <=> ( v139079(VarCurr)
        & v139081(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6647,axiom,
    ! [VarCurr: state_type] :
      ( v139081(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109114(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18359,axiom,
    ! [VarCurr: state_type] :
      ( v139079(VarCurr)
    <=> ( v138392(VarCurr)
        | v139080(VarCurr) ) ) ).

tff(writeUnaryOperator_10417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139080(VarCurr)
    <=> v109114(VarCurr,4) ) ).

tff(writeUnaryOperator_10416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139072(VarCurr)
    <=> v139073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18358,axiom,
    ! [VarCurr: state_type] :
      ( v139073(VarCurr)
    <=> ( v139074(VarCurr)
        & v139076(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6646,axiom,
    ! [VarCurr: state_type] :
      ( v139076(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109114(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18357,axiom,
    ! [VarCurr: state_type] :
      ( v139074(VarCurr)
    <=> ( v138386(VarCurr)
        | v139075(VarCurr) ) ) ).

tff(writeUnaryOperator_10415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139075(VarCurr)
    <=> v109114(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139058(VarCurr,B)
      <=> ( v139059(VarCurr,B)
          & v127974(VarCurr,B) ) ) ) ).

tff(addAssignment_77872,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,0)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77871,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,1)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77870,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,2)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77869,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,3)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77868,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,4)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77867,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,5)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77866,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,6)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77865,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,7)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77864,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,8)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77863,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,9)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77862,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,10)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77861,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,11)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77860,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,12)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77859,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,13)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77858,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,14)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77857,axiom,
    ! [VarCurr: state_type] :
      ( v139059(VarCurr,15)
    <=> v139060(VarCurr) ) ).

tff(addAssignment_77856,axiom,
    ! [VarCurr: state_type] :
      ( v139060(VarCurr)
    <=> v139061(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6645,axiom,
    ! [VarCurr: state_type] :
      ( v139061(VarCurr)
    <=> ( v134(VarCurr,6)
        & v139020(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6644,axiom,
    ! [VarCurr: state_type] :
      ( v139020(VarCurr)
    <=> ( v139042(VarCurr)
        | v139056(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6643,axiom,
    ! [VarCurr: state_type] :
      ( v139042(VarCurr)
    <=> ( v139043(VarCurr)
        | v139056(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6642,axiom,
    ! [VarCurr: state_type] :
      ( v139043(VarCurr)
    <=> ( v139044(VarCurr)
        | v139056(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6641,axiom,
    ! [VarCurr: state_type] :
      ( v139044(VarCurr)
    <=> ( v139045(VarCurr)
        | v139056(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6640,axiom,
    ! [VarCurr: state_type] :
      ( v139045(VarCurr)
    <=> ( v139046(VarCurr)
        | v139056(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6639,axiom,
    ! [VarCurr: state_type] :
      ( v139046(VarCurr)
    <=> ( v139047(VarCurr)
        | v139056(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6638,axiom,
    ! [VarCurr: state_type] :
      ( v139047(VarCurr)
    <=> ( v139048(VarCurr)
        | v139056(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6637,axiom,
    ! [VarCurr: state_type] :
      ( v139048(VarCurr)
    <=> ( v139049(VarCurr)
        | v139056(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6636,axiom,
    ! [VarCurr: state_type] :
      ( v139049(VarCurr)
    <=> ( v139050(VarCurr)
        | v139056(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6635,axiom,
    ! [VarCurr: state_type] :
      ( v139050(VarCurr)
    <=> ( v139051(VarCurr)
        | v139056(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6634,axiom,
    ! [VarCurr: state_type] :
      ( v139051(VarCurr)
    <=> ( v139052(VarCurr)
        | v139056(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6633,axiom,
    ! [VarCurr: state_type] :
      ( v139052(VarCurr)
    <=> ( v139053(VarCurr)
        | v139056(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6632,axiom,
    ! [VarCurr: state_type] :
      ( v139053(VarCurr)
    <=> ( v139054(VarCurr)
        | v139056(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6631,axiom,
    ! [VarCurr: state_type] :
      ( v139054(VarCurr)
    <=> ( v139055(VarCurr)
        | v139056(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6630,axiom,
    ! [VarCurr: state_type] :
      ( v139055(VarCurr)
    <=> ( v139056(VarCurr,0)
        | v139056(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v139056(VarCurr,B)
      <=> ( v139022(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77855,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,0)
    <=> v139039(VarCurr) ) ).

tff(addAssignment_77854,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,1)
    <=> v139038(VarCurr) ) ).

tff(addAssignment_77853,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,2)
    <=> v139037(VarCurr) ) ).

tff(addAssignment_77852,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,3)
    <=> v139036(VarCurr) ) ).

tff(addAssignment_77851,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,4)
    <=> v139035(VarCurr) ) ).

tff(addAssignment_77850,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,5)
    <=> v139034(VarCurr) ) ).

tff(addAssignment_77849,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,6)
    <=> v139033(VarCurr) ) ).

tff(addAssignment_77848,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,7)
    <=> v139032(VarCurr) ) ).

tff(addAssignment_77847,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,8)
    <=> v139031(VarCurr) ) ).

tff(addAssignment_77846,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,9)
    <=> v139030(VarCurr) ) ).

tff(addAssignment_77845,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,10)
    <=> v139029(VarCurr) ) ).

tff(addAssignment_77844,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,11)
    <=> v139028(VarCurr) ) ).

tff(addAssignment_77843,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,12)
    <=> v139027(VarCurr) ) ).

tff(addAssignment_77842,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,13)
    <=> v139026(VarCurr) ) ).

tff(addAssignment_77841,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,14)
    <=> v139025(VarCurr) ) ).

tff(addAssignment_77840,axiom,
    ! [VarCurr: state_type] :
      ( v139022(VarCurr,15)
    <=> v139024(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2020,axiom,
    ! [VarCurr: state_type] :
      ( v139039(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2019,axiom,
    ! [VarCurr: state_type] :
      ( v139038(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2018,axiom,
    ! [VarCurr: state_type] :
      ( v139037(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2017,axiom,
    ! [VarCurr: state_type] :
      ( v139036(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2016,axiom,
    ! [VarCurr: state_type] :
      ( v139035(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2015,axiom,
    ! [VarCurr: state_type] :
      ( v139034(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2014,axiom,
    ! [VarCurr: state_type] :
      ( v139033(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2013,axiom,
    ! [VarCurr: state_type] :
      ( v139032(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $false )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2012,axiom,
    ! [VarCurr: state_type] :
      ( v139031(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2011,axiom,
    ! [VarCurr: state_type] :
      ( v139030(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2010,axiom,
    ! [VarCurr: state_type] :
      ( v139029(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2009,axiom,
    ! [VarCurr: state_type] :
      ( v139028(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $false )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2008,axiom,
    ! [VarCurr: state_type] :
      ( v139027(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2007,axiom,
    ! [VarCurr: state_type] :
      ( v139026(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $false )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2006,axiom,
    ! [VarCurr: state_type] :
      ( v139025(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2005,axiom,
    ! [VarCurr: state_type] :
      ( v139024(VarCurr)
    <=> ( ( v109114(VarCurr,6)
        <=> $true )
        & ( v109114(VarCurr,5)
        <=> $true )
        & ( v109114(VarCurr,4)
        <=> $true )
        & ( v109114(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6629,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,5)
    <=> ( v138970(VarCurr)
        & v138989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18356,axiom,
    ! [VarCurr: state_type] :
      ( v138989(VarCurr)
    <=> ( v138990(VarCurr)
        | v139011(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_2004,axiom,
    ! [VarCurr: state_type] :
      ( v139011(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v139012(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v139012(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v139012(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v139012(VarCurr,0) ) ) ) ).

tff(addAssignment_77839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v139012(VarCurr,B)
      <=> v138958(VarCurr,B) ) ) ).

tff(addAssignment_77838,axiom,
    ! [VarCurr: state_type] :
      ( v139012(VarCurr,3)
    <=> v138964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18355,axiom,
    ! [VarCurr: state_type] :
      ( v138990(VarCurr)
    <=> ( v138991(VarCurr)
        | v138992(VarCurr) ) ) ).

tff(writeUnaryOperator_10414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138992(VarCurr)
    <=> v138994(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18354,axiom,
    ! [VarCurr: state_type] :
      ( v138994(VarCurr)
    <=> ( v138995(VarCurr)
        & v139006(VarCurr) ) ) ).

tff(writeUnaryOperator_10413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139006(VarCurr)
    <=> v139007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18353,axiom,
    ! [VarCurr: state_type] :
      ( v139007(VarCurr)
    <=> ( v139008(VarCurr)
        & v139010(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6628,axiom,
    ! [VarCurr: state_type] :
      ( v139010(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138958(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18352,axiom,
    ! [VarCurr: state_type] :
      ( v139008(VarCurr)
    <=> ( v135621(VarCurr)
        | v139009(VarCurr) ) ) ).

tff(writeUnaryOperator_10412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139009(VarCurr)
    <=> v138958(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18351,axiom,
    ! [VarCurr: state_type] :
      ( v138995(VarCurr)
    <=> ( v138996(VarCurr)
        & v139001(VarCurr) ) ) ).

tff(writeUnaryOperator_10411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139001(VarCurr)
    <=> v139002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18350,axiom,
    ! [VarCurr: state_type] :
      ( v139002(VarCurr)
    <=> ( v139003(VarCurr)
        & v139005(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6627,axiom,
    ! [VarCurr: state_type] :
      ( v139005(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138958(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18349,axiom,
    ! [VarCurr: state_type] :
      ( v139003(VarCurr)
    <=> ( v135615(VarCurr)
        | v139004(VarCurr) ) ) ).

tff(writeUnaryOperator_10410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v139004(VarCurr)
    <=> v138958(VarCurr,1) ) ).

tff(writeUnaryOperator_10409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138996(VarCurr)
    <=> v138997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18348,axiom,
    ! [VarCurr: state_type] :
      ( v138997(VarCurr)
    <=> ( v138998(VarCurr)
        & v139000(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18347,axiom,
    ! [VarCurr: state_type] :
      ( v139000(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138958(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18346,axiom,
    ! [VarCurr: state_type] :
      ( v138998(VarCurr)
    <=> ( v135609(VarCurr)
        | v138999(VarCurr) ) ) ).

tff(writeUnaryOperator_10408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138999(VarCurr)
    <=> v138958(VarCurr,0) ) ).

tff(writeUnaryOperator_10407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138991(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18345,axiom,
    ! [VarCurr: state_type] :
      ( v138970(VarCurr)
    <=> ( v138971(VarCurr)
        & v138988(VarCurr) ) ) ).

tff(writeUnaryOperator_10406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138988(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6626,axiom,
    ! [VarCurr: state_type] :
      ( v138971(VarCurr)
    <=> ( v138973(VarCurr)
        | v138987(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6625,axiom,
    ! [VarCurr: state_type] :
      ( v138973(VarCurr)
    <=> ( v138974(VarCurr)
        | v138987(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6624,axiom,
    ! [VarCurr: state_type] :
      ( v138974(VarCurr)
    <=> ( v138975(VarCurr)
        | v138987(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6623,axiom,
    ! [VarCurr: state_type] :
      ( v138975(VarCurr)
    <=> ( v138976(VarCurr)
        | v138987(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6622,axiom,
    ! [VarCurr: state_type] :
      ( v138976(VarCurr)
    <=> ( v138977(VarCurr)
        | v138987(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6621,axiom,
    ! [VarCurr: state_type] :
      ( v138977(VarCurr)
    <=> ( v138978(VarCurr)
        | v138987(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6620,axiom,
    ! [VarCurr: state_type] :
      ( v138978(VarCurr)
    <=> ( v138979(VarCurr)
        | v138987(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6619,axiom,
    ! [VarCurr: state_type] :
      ( v138979(VarCurr)
    <=> ( v138980(VarCurr)
        | v138987(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6618,axiom,
    ! [VarCurr: state_type] :
      ( v138980(VarCurr)
    <=> ( v138981(VarCurr)
        | v138987(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6617,axiom,
    ! [VarCurr: state_type] :
      ( v138981(VarCurr)
    <=> ( v138982(VarCurr)
        | v138987(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6616,axiom,
    ! [VarCurr: state_type] :
      ( v138982(VarCurr)
    <=> ( v138983(VarCurr)
        | v138987(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6615,axiom,
    ! [VarCurr: state_type] :
      ( v138983(VarCurr)
    <=> ( v138984(VarCurr)
        | v138987(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6614,axiom,
    ! [VarCurr: state_type] :
      ( v138984(VarCurr)
    <=> ( v138985(VarCurr)
        | v138987(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6613,axiom,
    ! [VarCurr: state_type] :
      ( v138985(VarCurr)
    <=> ( v138986(VarCurr)
        | v138987(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6612,axiom,
    ! [VarCurr: state_type] :
      ( v138986(VarCurr)
    <=> ( v138987(VarCurr,0)
        | v138987(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138987(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138877(VarCurr,B) ) ) ) ).

tff(addAssignment_77837,axiom,
    ! [VarCurr: state_type] :
      ( v138964(VarCurr)
    <=> v138966(VarCurr) ) ).

tff(addAssignment_77836,axiom,
    ! [VarCurr: state_type] :
      ( v138966(VarCurr)
    <=> v138968(VarCurr) ) ).

tff(addAssignment_77835,axiom,
    ! [VarCurr: state_type] :
      ( v138968(VarCurr)
    <=> v109181(VarCurr,6) ) ).

tff(addAssignment_77834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138958(VarCurr,B)
      <=> v138960(VarCurr,B) ) ) ).

tff(addAssignment_77833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138960(VarCurr,B)
      <=> v138962(VarCurr,B) ) ) ).

tff(addAssignment_77832,axiom,
    ! [VarCurr: state_type] :
      ( ( v138962(VarCurr,2)
      <=> v109181(VarCurr,5) )
      & ( v138962(VarCurr,1)
      <=> v109181(VarCurr,4) )
      & ( v138962(VarCurr,0)
      <=> v109181(VarCurr,3) ) ) ).

tff(addAssignment_77831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138877(VarCurr,B)
      <=> v138879(VarCurr,B) ) ) ).

tff(addAssignment_77830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138879(VarCurr,B)
      <=> v138881(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138881(VarCurr,B)
      <=> ( v138921(VarCurr,B)
          & v138925(VarCurr,B) ) ) ) ).

tff(addAssignment_77829,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,0)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77828,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,1)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77827,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,2)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77826,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,3)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77825,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,4)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77824,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,5)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77823,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,6)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77822,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,7)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77821,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,8)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77820,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,9)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77819,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,10)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77818,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,11)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77817,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,12)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77816,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,13)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77815,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,14)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77814,axiom,
    ! [VarCurr: state_type] :
      ( v138925(VarCurr,15)
    <=> v138926(VarCurr) ) ).

tff(addAssignment_77813,axiom,
    ! [VarCurr: state_type] :
      ( v138926(VarCurr)
    <=> v138927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18344,axiom,
    ! [VarCurr: state_type] :
      ( v138927(VarCurr)
    <=> ( v138928(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18343,axiom,
    ! [VarCurr: state_type] :
      ( v138928(VarCurr)
    <=> ( v138929(VarCurr)
        & v138956(VarCurr) ) ) ).

tff(writeUnaryOperator_10405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138956(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18342,axiom,
    ! [VarCurr: state_type] :
      ( v138929(VarCurr)
    <=> ( v138930(VarCurr)
        & v138955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18341,axiom,
    ! [VarCurr: state_type] :
      ( v138955(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138930(VarCurr)
    <=> v138932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18340,axiom,
    ! [VarCurr: state_type] :
      ( v138932(VarCurr)
    <=> ( v138933(VarCurr)
        & v138950(VarCurr) ) ) ).

tff(writeUnaryOperator_10403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138950(VarCurr)
    <=> v138951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18339,axiom,
    ! [VarCurr: state_type] :
      ( v138951(VarCurr)
    <=> ( v138952(VarCurr)
        & v138954(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6611,axiom,
    ! [VarCurr: state_type] :
      ( v138954(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109181(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18338,axiom,
    ! [VarCurr: state_type] :
      ( v138952(VarCurr)
    <=> ( v138404(VarCurr)
        | v138953(VarCurr) ) ) ).

tff(writeUnaryOperator_10402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138953(VarCurr)
    <=> v109181(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18337,axiom,
    ! [VarCurr: state_type] :
      ( v138933(VarCurr)
    <=> ( v138934(VarCurr)
        & v138945(VarCurr) ) ) ).

tff(writeUnaryOperator_10401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138945(VarCurr)
    <=> v138946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18336,axiom,
    ! [VarCurr: state_type] :
      ( v138946(VarCurr)
    <=> ( v138947(VarCurr)
        & v138949(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6610,axiom,
    ! [VarCurr: state_type] :
      ( v138949(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109181(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18335,axiom,
    ! [VarCurr: state_type] :
      ( v138947(VarCurr)
    <=> ( v138398(VarCurr)
        | v138948(VarCurr) ) ) ).

tff(writeUnaryOperator_10400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138948(VarCurr)
    <=> v109181(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18334,axiom,
    ! [VarCurr: state_type] :
      ( v138934(VarCurr)
    <=> ( v138935(VarCurr)
        & v138940(VarCurr) ) ) ).

tff(writeUnaryOperator_10399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138940(VarCurr)
    <=> v138941(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18333,axiom,
    ! [VarCurr: state_type] :
      ( v138941(VarCurr)
    <=> ( v138942(VarCurr)
        & v138944(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6609,axiom,
    ! [VarCurr: state_type] :
      ( v138944(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109181(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18332,axiom,
    ! [VarCurr: state_type] :
      ( v138942(VarCurr)
    <=> ( v138392(VarCurr)
        | v138943(VarCurr) ) ) ).

tff(writeUnaryOperator_10398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138943(VarCurr)
    <=> v109181(VarCurr,4) ) ).

tff(writeUnaryOperator_10397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138935(VarCurr)
    <=> v138936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18331,axiom,
    ! [VarCurr: state_type] :
      ( v138936(VarCurr)
    <=> ( v138937(VarCurr)
        & v138939(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6608,axiom,
    ! [VarCurr: state_type] :
      ( v138939(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109181(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18330,axiom,
    ! [VarCurr: state_type] :
      ( v138937(VarCurr)
    <=> ( v138386(VarCurr)
        | v138938(VarCurr) ) ) ).

tff(writeUnaryOperator_10396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138938(VarCurr)
    <=> v109181(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138921(VarCurr,B)
      <=> ( v138922(VarCurr,B)
          & v127949(VarCurr,B) ) ) ) ).

tff(addAssignment_77812,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,0)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77811,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,1)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77810,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,2)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77809,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,3)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77808,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,4)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77807,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,5)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77806,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,6)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77805,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,7)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77804,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,8)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77803,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,9)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77802,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,10)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77801,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,11)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77800,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,12)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77799,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,13)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77798,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,14)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77797,axiom,
    ! [VarCurr: state_type] :
      ( v138922(VarCurr,15)
    <=> v138923(VarCurr) ) ).

tff(addAssignment_77796,axiom,
    ! [VarCurr: state_type] :
      ( v138923(VarCurr)
    <=> v138924(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6607,axiom,
    ! [VarCurr: state_type] :
      ( v138924(VarCurr)
    <=> ( v134(VarCurr,5)
        & v138883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6606,axiom,
    ! [VarCurr: state_type] :
      ( v138883(VarCurr)
    <=> ( v138905(VarCurr)
        | v138919(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6605,axiom,
    ! [VarCurr: state_type] :
      ( v138905(VarCurr)
    <=> ( v138906(VarCurr)
        | v138919(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6604,axiom,
    ! [VarCurr: state_type] :
      ( v138906(VarCurr)
    <=> ( v138907(VarCurr)
        | v138919(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6603,axiom,
    ! [VarCurr: state_type] :
      ( v138907(VarCurr)
    <=> ( v138908(VarCurr)
        | v138919(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6602,axiom,
    ! [VarCurr: state_type] :
      ( v138908(VarCurr)
    <=> ( v138909(VarCurr)
        | v138919(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6601,axiom,
    ! [VarCurr: state_type] :
      ( v138909(VarCurr)
    <=> ( v138910(VarCurr)
        | v138919(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6600,axiom,
    ! [VarCurr: state_type] :
      ( v138910(VarCurr)
    <=> ( v138911(VarCurr)
        | v138919(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6599,axiom,
    ! [VarCurr: state_type] :
      ( v138911(VarCurr)
    <=> ( v138912(VarCurr)
        | v138919(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6598,axiom,
    ! [VarCurr: state_type] :
      ( v138912(VarCurr)
    <=> ( v138913(VarCurr)
        | v138919(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6597,axiom,
    ! [VarCurr: state_type] :
      ( v138913(VarCurr)
    <=> ( v138914(VarCurr)
        | v138919(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6596,axiom,
    ! [VarCurr: state_type] :
      ( v138914(VarCurr)
    <=> ( v138915(VarCurr)
        | v138919(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6595,axiom,
    ! [VarCurr: state_type] :
      ( v138915(VarCurr)
    <=> ( v138916(VarCurr)
        | v138919(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6594,axiom,
    ! [VarCurr: state_type] :
      ( v138916(VarCurr)
    <=> ( v138917(VarCurr)
        | v138919(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6593,axiom,
    ! [VarCurr: state_type] :
      ( v138917(VarCurr)
    <=> ( v138918(VarCurr)
        | v138919(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6592,axiom,
    ! [VarCurr: state_type] :
      ( v138918(VarCurr)
    <=> ( v138919(VarCurr,0)
        | v138919(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138919(VarCurr,B)
      <=> ( v138885(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77795,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,0)
    <=> v138902(VarCurr) ) ).

tff(addAssignment_77794,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,1)
    <=> v138901(VarCurr) ) ).

tff(addAssignment_77793,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,2)
    <=> v138900(VarCurr) ) ).

tff(addAssignment_77792,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,3)
    <=> v138899(VarCurr) ) ).

tff(addAssignment_77791,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,4)
    <=> v138898(VarCurr) ) ).

tff(addAssignment_77790,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,5)
    <=> v138897(VarCurr) ) ).

tff(addAssignment_77789,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,6)
    <=> v138896(VarCurr) ) ).

tff(addAssignment_77788,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,7)
    <=> v138895(VarCurr) ) ).

tff(addAssignment_77787,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,8)
    <=> v138894(VarCurr) ) ).

tff(addAssignment_77786,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,9)
    <=> v138893(VarCurr) ) ).

tff(addAssignment_77785,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,10)
    <=> v138892(VarCurr) ) ).

tff(addAssignment_77784,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,11)
    <=> v138891(VarCurr) ) ).

tff(addAssignment_77783,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,12)
    <=> v138890(VarCurr) ) ).

tff(addAssignment_77782,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,13)
    <=> v138889(VarCurr) ) ).

tff(addAssignment_77781,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,14)
    <=> v138888(VarCurr) ) ).

tff(addAssignment_77780,axiom,
    ! [VarCurr: state_type] :
      ( v138885(VarCurr,15)
    <=> v138887(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_2003,axiom,
    ! [VarCurr: state_type] :
      ( v138902(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2002,axiom,
    ! [VarCurr: state_type] :
      ( v138901(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2001,axiom,
    ! [VarCurr: state_type] :
      ( v138900(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_2000,axiom,
    ! [VarCurr: state_type] :
      ( v138899(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1999,axiom,
    ! [VarCurr: state_type] :
      ( v138898(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1998,axiom,
    ! [VarCurr: state_type] :
      ( v138897(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1997,axiom,
    ! [VarCurr: state_type] :
      ( v138896(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1996,axiom,
    ! [VarCurr: state_type] :
      ( v138895(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $false )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1995,axiom,
    ! [VarCurr: state_type] :
      ( v138894(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1994,axiom,
    ! [VarCurr: state_type] :
      ( v138893(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1993,axiom,
    ! [VarCurr: state_type] :
      ( v138892(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1992,axiom,
    ! [VarCurr: state_type] :
      ( v138891(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $false )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1991,axiom,
    ! [VarCurr: state_type] :
      ( v138890(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1990,axiom,
    ! [VarCurr: state_type] :
      ( v138889(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $false )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1989,axiom,
    ! [VarCurr: state_type] :
      ( v138888(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1988,axiom,
    ! [VarCurr: state_type] :
      ( v138887(VarCurr)
    <=> ( ( v109181(VarCurr,6)
        <=> $true )
        & ( v109181(VarCurr,5)
        <=> $true )
        & ( v109181(VarCurr,4)
        <=> $true )
        & ( v109181(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6591,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,4)
    <=> ( v138833(VarCurr)
        & v138852(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18329,axiom,
    ! [VarCurr: state_type] :
      ( v138852(VarCurr)
    <=> ( v138853(VarCurr)
        | v138874(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1987,axiom,
    ! [VarCurr: state_type] :
      ( v138874(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v138875(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v138875(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v138875(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v138875(VarCurr,0) ) ) ) ).

tff(addAssignment_77779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138875(VarCurr,B)
      <=> v138821(VarCurr,B) ) ) ).

tff(addAssignment_77778,axiom,
    ! [VarCurr: state_type] :
      ( v138875(VarCurr,3)
    <=> v138827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18328,axiom,
    ! [VarCurr: state_type] :
      ( v138853(VarCurr)
    <=> ( v138854(VarCurr)
        | v138855(VarCurr) ) ) ).

tff(writeUnaryOperator_10395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138855(VarCurr)
    <=> v138857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18327,axiom,
    ! [VarCurr: state_type] :
      ( v138857(VarCurr)
    <=> ( v138858(VarCurr)
        & v138869(VarCurr) ) ) ).

tff(writeUnaryOperator_10394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138869(VarCurr)
    <=> v138870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18326,axiom,
    ! [VarCurr: state_type] :
      ( v138870(VarCurr)
    <=> ( v138871(VarCurr)
        & v138873(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6590,axiom,
    ! [VarCurr: state_type] :
      ( v138873(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138821(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18325,axiom,
    ! [VarCurr: state_type] :
      ( v138871(VarCurr)
    <=> ( v135621(VarCurr)
        | v138872(VarCurr) ) ) ).

tff(writeUnaryOperator_10393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138872(VarCurr)
    <=> v138821(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18324,axiom,
    ! [VarCurr: state_type] :
      ( v138858(VarCurr)
    <=> ( v138859(VarCurr)
        & v138864(VarCurr) ) ) ).

tff(writeUnaryOperator_10392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138864(VarCurr)
    <=> v138865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18323,axiom,
    ! [VarCurr: state_type] :
      ( v138865(VarCurr)
    <=> ( v138866(VarCurr)
        & v138868(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6589,axiom,
    ! [VarCurr: state_type] :
      ( v138868(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138821(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18322,axiom,
    ! [VarCurr: state_type] :
      ( v138866(VarCurr)
    <=> ( v135615(VarCurr)
        | v138867(VarCurr) ) ) ).

tff(writeUnaryOperator_10391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138867(VarCurr)
    <=> v138821(VarCurr,1) ) ).

tff(writeUnaryOperator_10390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138859(VarCurr)
    <=> v138860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18321,axiom,
    ! [VarCurr: state_type] :
      ( v138860(VarCurr)
    <=> ( v138861(VarCurr)
        & v138863(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18320,axiom,
    ! [VarCurr: state_type] :
      ( v138863(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138821(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18319,axiom,
    ! [VarCurr: state_type] :
      ( v138861(VarCurr)
    <=> ( v135609(VarCurr)
        | v138862(VarCurr) ) ) ).

tff(writeUnaryOperator_10389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138862(VarCurr)
    <=> v138821(VarCurr,0) ) ).

tff(writeUnaryOperator_10388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138854(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18318,axiom,
    ! [VarCurr: state_type] :
      ( v138833(VarCurr)
    <=> ( v138834(VarCurr)
        & v138851(VarCurr) ) ) ).

tff(writeUnaryOperator_10387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138851(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6588,axiom,
    ! [VarCurr: state_type] :
      ( v138834(VarCurr)
    <=> ( v138836(VarCurr)
        | v138850(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6587,axiom,
    ! [VarCurr: state_type] :
      ( v138836(VarCurr)
    <=> ( v138837(VarCurr)
        | v138850(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6586,axiom,
    ! [VarCurr: state_type] :
      ( v138837(VarCurr)
    <=> ( v138838(VarCurr)
        | v138850(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6585,axiom,
    ! [VarCurr: state_type] :
      ( v138838(VarCurr)
    <=> ( v138839(VarCurr)
        | v138850(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6584,axiom,
    ! [VarCurr: state_type] :
      ( v138839(VarCurr)
    <=> ( v138840(VarCurr)
        | v138850(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6583,axiom,
    ! [VarCurr: state_type] :
      ( v138840(VarCurr)
    <=> ( v138841(VarCurr)
        | v138850(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6582,axiom,
    ! [VarCurr: state_type] :
      ( v138841(VarCurr)
    <=> ( v138842(VarCurr)
        | v138850(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6581,axiom,
    ! [VarCurr: state_type] :
      ( v138842(VarCurr)
    <=> ( v138843(VarCurr)
        | v138850(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6580,axiom,
    ! [VarCurr: state_type] :
      ( v138843(VarCurr)
    <=> ( v138844(VarCurr)
        | v138850(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6579,axiom,
    ! [VarCurr: state_type] :
      ( v138844(VarCurr)
    <=> ( v138845(VarCurr)
        | v138850(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6578,axiom,
    ! [VarCurr: state_type] :
      ( v138845(VarCurr)
    <=> ( v138846(VarCurr)
        | v138850(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6577,axiom,
    ! [VarCurr: state_type] :
      ( v138846(VarCurr)
    <=> ( v138847(VarCurr)
        | v138850(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6576,axiom,
    ! [VarCurr: state_type] :
      ( v138847(VarCurr)
    <=> ( v138848(VarCurr)
        | v138850(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6575,axiom,
    ! [VarCurr: state_type] :
      ( v138848(VarCurr)
    <=> ( v138849(VarCurr)
        | v138850(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6574,axiom,
    ! [VarCurr: state_type] :
      ( v138849(VarCurr)
    <=> ( v138850(VarCurr,0)
        | v138850(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138850(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138740(VarCurr,B) ) ) ) ).

tff(addAssignment_77777,axiom,
    ! [VarCurr: state_type] :
      ( v138827(VarCurr)
    <=> v138829(VarCurr) ) ).

tff(addAssignment_77776,axiom,
    ! [VarCurr: state_type] :
      ( v138829(VarCurr)
    <=> v138831(VarCurr) ) ).

tff(addAssignment_77775,axiom,
    ! [VarCurr: state_type] :
      ( v138831(VarCurr)
    <=> v109242(VarCurr,6) ) ).

tff(addAssignment_77774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138821(VarCurr,B)
      <=> v138823(VarCurr,B) ) ) ).

tff(addAssignment_77773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138823(VarCurr,B)
      <=> v138825(VarCurr,B) ) ) ).

tff(addAssignment_77772,axiom,
    ! [VarCurr: state_type] :
      ( ( v138825(VarCurr,2)
      <=> v109242(VarCurr,5) )
      & ( v138825(VarCurr,1)
      <=> v109242(VarCurr,4) )
      & ( v138825(VarCurr,0)
      <=> v109242(VarCurr,3) ) ) ).

tff(addAssignment_77771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138740(VarCurr,B)
      <=> v138742(VarCurr,B) ) ) ).

tff(addAssignment_77770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138742(VarCurr,B)
      <=> v138744(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138744(VarCurr,B)
      <=> ( v138784(VarCurr,B)
          & v138788(VarCurr,B) ) ) ) ).

tff(addAssignment_77769,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,0)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77768,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,1)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77767,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,2)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77766,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,3)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77765,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,4)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77764,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,5)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77763,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,6)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77762,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,7)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77761,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,8)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77760,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,9)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77759,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,10)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77758,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,11)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77757,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,12)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77756,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,13)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77755,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,14)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77754,axiom,
    ! [VarCurr: state_type] :
      ( v138788(VarCurr,15)
    <=> v138789(VarCurr) ) ).

tff(addAssignment_77753,axiom,
    ! [VarCurr: state_type] :
      ( v138789(VarCurr)
    <=> v138790(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18317,axiom,
    ! [VarCurr: state_type] :
      ( v138790(VarCurr)
    <=> ( v138791(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18316,axiom,
    ! [VarCurr: state_type] :
      ( v138791(VarCurr)
    <=> ( v138792(VarCurr)
        & v138819(VarCurr) ) ) ).

tff(writeUnaryOperator_10386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138819(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18315,axiom,
    ! [VarCurr: state_type] :
      ( v138792(VarCurr)
    <=> ( v138793(VarCurr)
        & v138818(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18314,axiom,
    ! [VarCurr: state_type] :
      ( v138818(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138793(VarCurr)
    <=> v138795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18313,axiom,
    ! [VarCurr: state_type] :
      ( v138795(VarCurr)
    <=> ( v138796(VarCurr)
        & v138813(VarCurr) ) ) ).

tff(writeUnaryOperator_10384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138813(VarCurr)
    <=> v138814(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18312,axiom,
    ! [VarCurr: state_type] :
      ( v138814(VarCurr)
    <=> ( v138815(VarCurr)
        & v138817(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6573,axiom,
    ! [VarCurr: state_type] :
      ( v138817(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109242(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18311,axiom,
    ! [VarCurr: state_type] :
      ( v138815(VarCurr)
    <=> ( v138404(VarCurr)
        | v138816(VarCurr) ) ) ).

tff(writeUnaryOperator_10383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138816(VarCurr)
    <=> v109242(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18310,axiom,
    ! [VarCurr: state_type] :
      ( v138796(VarCurr)
    <=> ( v138797(VarCurr)
        & v138808(VarCurr) ) ) ).

tff(writeUnaryOperator_10382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138808(VarCurr)
    <=> v138809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18309,axiom,
    ! [VarCurr: state_type] :
      ( v138809(VarCurr)
    <=> ( v138810(VarCurr)
        & v138812(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6572,axiom,
    ! [VarCurr: state_type] :
      ( v138812(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109242(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18308,axiom,
    ! [VarCurr: state_type] :
      ( v138810(VarCurr)
    <=> ( v138398(VarCurr)
        | v138811(VarCurr) ) ) ).

tff(writeUnaryOperator_10381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138811(VarCurr)
    <=> v109242(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18307,axiom,
    ! [VarCurr: state_type] :
      ( v138797(VarCurr)
    <=> ( v138798(VarCurr)
        & v138803(VarCurr) ) ) ).

tff(writeUnaryOperator_10380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138803(VarCurr)
    <=> v138804(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18306,axiom,
    ! [VarCurr: state_type] :
      ( v138804(VarCurr)
    <=> ( v138805(VarCurr)
        & v138807(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6571,axiom,
    ! [VarCurr: state_type] :
      ( v138807(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109242(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18305,axiom,
    ! [VarCurr: state_type] :
      ( v138805(VarCurr)
    <=> ( v138392(VarCurr)
        | v138806(VarCurr) ) ) ).

tff(writeUnaryOperator_10379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138806(VarCurr)
    <=> v109242(VarCurr,4) ) ).

tff(writeUnaryOperator_10378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138798(VarCurr)
    <=> v138799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18304,axiom,
    ! [VarCurr: state_type] :
      ( v138799(VarCurr)
    <=> ( v138800(VarCurr)
        & v138802(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6570,axiom,
    ! [VarCurr: state_type] :
      ( v138802(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109242(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18303,axiom,
    ! [VarCurr: state_type] :
      ( v138800(VarCurr)
    <=> ( v138386(VarCurr)
        | v138801(VarCurr) ) ) ).

tff(writeUnaryOperator_10377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138801(VarCurr)
    <=> v109242(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138784(VarCurr,B)
      <=> ( v138785(VarCurr,B)
          & v127924(VarCurr,B) ) ) ) ).

tff(addAssignment_77752,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,0)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77751,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,1)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77750,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,2)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77749,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,3)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77748,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,4)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77747,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,5)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77746,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,6)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77745,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,7)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77744,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,8)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77743,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,9)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77742,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,10)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77741,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,11)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77740,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,12)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77739,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,13)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77738,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,14)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77737,axiom,
    ! [VarCurr: state_type] :
      ( v138785(VarCurr,15)
    <=> v138786(VarCurr) ) ).

tff(addAssignment_77736,axiom,
    ! [VarCurr: state_type] :
      ( v138786(VarCurr)
    <=> v138787(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6569,axiom,
    ! [VarCurr: state_type] :
      ( v138787(VarCurr)
    <=> ( v134(VarCurr,4)
        & v138746(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6568,axiom,
    ! [VarCurr: state_type] :
      ( v138746(VarCurr)
    <=> ( v138768(VarCurr)
        | v138782(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6567,axiom,
    ! [VarCurr: state_type] :
      ( v138768(VarCurr)
    <=> ( v138769(VarCurr)
        | v138782(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6566,axiom,
    ! [VarCurr: state_type] :
      ( v138769(VarCurr)
    <=> ( v138770(VarCurr)
        | v138782(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6565,axiom,
    ! [VarCurr: state_type] :
      ( v138770(VarCurr)
    <=> ( v138771(VarCurr)
        | v138782(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6564,axiom,
    ! [VarCurr: state_type] :
      ( v138771(VarCurr)
    <=> ( v138772(VarCurr)
        | v138782(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6563,axiom,
    ! [VarCurr: state_type] :
      ( v138772(VarCurr)
    <=> ( v138773(VarCurr)
        | v138782(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6562,axiom,
    ! [VarCurr: state_type] :
      ( v138773(VarCurr)
    <=> ( v138774(VarCurr)
        | v138782(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6561,axiom,
    ! [VarCurr: state_type] :
      ( v138774(VarCurr)
    <=> ( v138775(VarCurr)
        | v138782(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6560,axiom,
    ! [VarCurr: state_type] :
      ( v138775(VarCurr)
    <=> ( v138776(VarCurr)
        | v138782(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6559,axiom,
    ! [VarCurr: state_type] :
      ( v138776(VarCurr)
    <=> ( v138777(VarCurr)
        | v138782(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6558,axiom,
    ! [VarCurr: state_type] :
      ( v138777(VarCurr)
    <=> ( v138778(VarCurr)
        | v138782(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6557,axiom,
    ! [VarCurr: state_type] :
      ( v138778(VarCurr)
    <=> ( v138779(VarCurr)
        | v138782(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6556,axiom,
    ! [VarCurr: state_type] :
      ( v138779(VarCurr)
    <=> ( v138780(VarCurr)
        | v138782(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6555,axiom,
    ! [VarCurr: state_type] :
      ( v138780(VarCurr)
    <=> ( v138781(VarCurr)
        | v138782(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6554,axiom,
    ! [VarCurr: state_type] :
      ( v138781(VarCurr)
    <=> ( v138782(VarCurr,0)
        | v138782(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138782(VarCurr,B)
      <=> ( v138748(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77735,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,0)
    <=> v138765(VarCurr) ) ).

tff(addAssignment_77734,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,1)
    <=> v138764(VarCurr) ) ).

tff(addAssignment_77733,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,2)
    <=> v138763(VarCurr) ) ).

tff(addAssignment_77732,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,3)
    <=> v138762(VarCurr) ) ).

tff(addAssignment_77731,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,4)
    <=> v138761(VarCurr) ) ).

tff(addAssignment_77730,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,5)
    <=> v138760(VarCurr) ) ).

tff(addAssignment_77729,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,6)
    <=> v138759(VarCurr) ) ).

tff(addAssignment_77728,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,7)
    <=> v138758(VarCurr) ) ).

tff(addAssignment_77727,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,8)
    <=> v138757(VarCurr) ) ).

tff(addAssignment_77726,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,9)
    <=> v138756(VarCurr) ) ).

tff(addAssignment_77725,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,10)
    <=> v138755(VarCurr) ) ).

tff(addAssignment_77724,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,11)
    <=> v138754(VarCurr) ) ).

tff(addAssignment_77723,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,12)
    <=> v138753(VarCurr) ) ).

tff(addAssignment_77722,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,13)
    <=> v138752(VarCurr) ) ).

tff(addAssignment_77721,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,14)
    <=> v138751(VarCurr) ) ).

tff(addAssignment_77720,axiom,
    ! [VarCurr: state_type] :
      ( v138748(VarCurr,15)
    <=> v138750(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1986,axiom,
    ! [VarCurr: state_type] :
      ( v138765(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1985,axiom,
    ! [VarCurr: state_type] :
      ( v138764(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1984,axiom,
    ! [VarCurr: state_type] :
      ( v138763(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1983,axiom,
    ! [VarCurr: state_type] :
      ( v138762(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1982,axiom,
    ! [VarCurr: state_type] :
      ( v138761(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1981,axiom,
    ! [VarCurr: state_type] :
      ( v138760(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1980,axiom,
    ! [VarCurr: state_type] :
      ( v138759(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1979,axiom,
    ! [VarCurr: state_type] :
      ( v138758(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $false )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1978,axiom,
    ! [VarCurr: state_type] :
      ( v138757(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1977,axiom,
    ! [VarCurr: state_type] :
      ( v138756(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1976,axiom,
    ! [VarCurr: state_type] :
      ( v138755(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1975,axiom,
    ! [VarCurr: state_type] :
      ( v138754(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $false )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1974,axiom,
    ! [VarCurr: state_type] :
      ( v138753(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1973,axiom,
    ! [VarCurr: state_type] :
      ( v138752(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $false )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1972,axiom,
    ! [VarCurr: state_type] :
      ( v138751(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1971,axiom,
    ! [VarCurr: state_type] :
      ( v138750(VarCurr)
    <=> ( ( v109242(VarCurr,6)
        <=> $true )
        & ( v109242(VarCurr,5)
        <=> $true )
        & ( v109242(VarCurr,4)
        <=> $true )
        & ( v109242(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6553,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,3)
    <=> ( v138696(VarCurr)
        & v138715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18302,axiom,
    ! [VarCurr: state_type] :
      ( v138715(VarCurr)
    <=> ( v138716(VarCurr)
        | v138737(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1970,axiom,
    ! [VarCurr: state_type] :
      ( v138737(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v138738(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v138738(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v138738(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v138738(VarCurr,0) ) ) ) ).

tff(addAssignment_77719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138738(VarCurr,B)
      <=> v138684(VarCurr,B) ) ) ).

tff(addAssignment_77718,axiom,
    ! [VarCurr: state_type] :
      ( v138738(VarCurr,3)
    <=> v138690(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18301,axiom,
    ! [VarCurr: state_type] :
      ( v138716(VarCurr)
    <=> ( v138717(VarCurr)
        | v138718(VarCurr) ) ) ).

tff(writeUnaryOperator_10376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138718(VarCurr)
    <=> v138720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18300,axiom,
    ! [VarCurr: state_type] :
      ( v138720(VarCurr)
    <=> ( v138721(VarCurr)
        & v138732(VarCurr) ) ) ).

tff(writeUnaryOperator_10375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138732(VarCurr)
    <=> v138733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18299,axiom,
    ! [VarCurr: state_type] :
      ( v138733(VarCurr)
    <=> ( v138734(VarCurr)
        & v138736(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6552,axiom,
    ! [VarCurr: state_type] :
      ( v138736(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138684(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18298,axiom,
    ! [VarCurr: state_type] :
      ( v138734(VarCurr)
    <=> ( v135621(VarCurr)
        | v138735(VarCurr) ) ) ).

tff(writeUnaryOperator_10374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138735(VarCurr)
    <=> v138684(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18297,axiom,
    ! [VarCurr: state_type] :
      ( v138721(VarCurr)
    <=> ( v138722(VarCurr)
        & v138727(VarCurr) ) ) ).

tff(writeUnaryOperator_10373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138727(VarCurr)
    <=> v138728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18296,axiom,
    ! [VarCurr: state_type] :
      ( v138728(VarCurr)
    <=> ( v138729(VarCurr)
        & v138731(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6551,axiom,
    ! [VarCurr: state_type] :
      ( v138731(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138684(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18295,axiom,
    ! [VarCurr: state_type] :
      ( v138729(VarCurr)
    <=> ( v135615(VarCurr)
        | v138730(VarCurr) ) ) ).

tff(writeUnaryOperator_10372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138730(VarCurr)
    <=> v138684(VarCurr,1) ) ).

tff(writeUnaryOperator_10371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138722(VarCurr)
    <=> v138723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18294,axiom,
    ! [VarCurr: state_type] :
      ( v138723(VarCurr)
    <=> ( v138724(VarCurr)
        & v138726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18293,axiom,
    ! [VarCurr: state_type] :
      ( v138726(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138684(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18292,axiom,
    ! [VarCurr: state_type] :
      ( v138724(VarCurr)
    <=> ( v135609(VarCurr)
        | v138725(VarCurr) ) ) ).

tff(writeUnaryOperator_10370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138725(VarCurr)
    <=> v138684(VarCurr,0) ) ).

tff(writeUnaryOperator_10369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138717(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18291,axiom,
    ! [VarCurr: state_type] :
      ( v138696(VarCurr)
    <=> ( v138697(VarCurr)
        & v138714(VarCurr) ) ) ).

tff(writeUnaryOperator_10368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138714(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6550,axiom,
    ! [VarCurr: state_type] :
      ( v138697(VarCurr)
    <=> ( v138699(VarCurr)
        | v138713(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6549,axiom,
    ! [VarCurr: state_type] :
      ( v138699(VarCurr)
    <=> ( v138700(VarCurr)
        | v138713(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6548,axiom,
    ! [VarCurr: state_type] :
      ( v138700(VarCurr)
    <=> ( v138701(VarCurr)
        | v138713(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6547,axiom,
    ! [VarCurr: state_type] :
      ( v138701(VarCurr)
    <=> ( v138702(VarCurr)
        | v138713(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6546,axiom,
    ! [VarCurr: state_type] :
      ( v138702(VarCurr)
    <=> ( v138703(VarCurr)
        | v138713(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6545,axiom,
    ! [VarCurr: state_type] :
      ( v138703(VarCurr)
    <=> ( v138704(VarCurr)
        | v138713(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6544,axiom,
    ! [VarCurr: state_type] :
      ( v138704(VarCurr)
    <=> ( v138705(VarCurr)
        | v138713(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6543,axiom,
    ! [VarCurr: state_type] :
      ( v138705(VarCurr)
    <=> ( v138706(VarCurr)
        | v138713(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6542,axiom,
    ! [VarCurr: state_type] :
      ( v138706(VarCurr)
    <=> ( v138707(VarCurr)
        | v138713(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6541,axiom,
    ! [VarCurr: state_type] :
      ( v138707(VarCurr)
    <=> ( v138708(VarCurr)
        | v138713(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6540,axiom,
    ! [VarCurr: state_type] :
      ( v138708(VarCurr)
    <=> ( v138709(VarCurr)
        | v138713(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6539,axiom,
    ! [VarCurr: state_type] :
      ( v138709(VarCurr)
    <=> ( v138710(VarCurr)
        | v138713(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6538,axiom,
    ! [VarCurr: state_type] :
      ( v138710(VarCurr)
    <=> ( v138711(VarCurr)
        | v138713(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6537,axiom,
    ! [VarCurr: state_type] :
      ( v138711(VarCurr)
    <=> ( v138712(VarCurr)
        | v138713(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6536,axiom,
    ! [VarCurr: state_type] :
      ( v138712(VarCurr)
    <=> ( v138713(VarCurr,0)
        | v138713(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138713(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138603(VarCurr,B) ) ) ) ).

tff(addAssignment_77717,axiom,
    ! [VarCurr: state_type] :
      ( v138690(VarCurr)
    <=> v138692(VarCurr) ) ).

tff(addAssignment_77716,axiom,
    ! [VarCurr: state_type] :
      ( v138692(VarCurr)
    <=> v138694(VarCurr) ) ).

tff(addAssignment_77715,axiom,
    ! [VarCurr: state_type] :
      ( v138694(VarCurr)
    <=> v109303(VarCurr,6) ) ).

tff(addAssignment_77714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138684(VarCurr,B)
      <=> v138686(VarCurr,B) ) ) ).

tff(addAssignment_77713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138686(VarCurr,B)
      <=> v138688(VarCurr,B) ) ) ).

tff(addAssignment_77712,axiom,
    ! [VarCurr: state_type] :
      ( ( v138688(VarCurr,2)
      <=> v109303(VarCurr,5) )
      & ( v138688(VarCurr,1)
      <=> v109303(VarCurr,4) )
      & ( v138688(VarCurr,0)
      <=> v109303(VarCurr,3) ) ) ).

tff(addAssignment_77711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138603(VarCurr,B)
      <=> v138605(VarCurr,B) ) ) ).

tff(addAssignment_77710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138605(VarCurr,B)
      <=> v138607(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138607(VarCurr,B)
      <=> ( v138647(VarCurr,B)
          & v138651(VarCurr,B) ) ) ) ).

tff(addAssignment_77709,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,0)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77708,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,1)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77707,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,2)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77706,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,3)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77705,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,4)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77704,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,5)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77703,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,6)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77702,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,7)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77701,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,8)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77700,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,9)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77699,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,10)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77698,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,11)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77697,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,12)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77696,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,13)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77695,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,14)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77694,axiom,
    ! [VarCurr: state_type] :
      ( v138651(VarCurr,15)
    <=> v138652(VarCurr) ) ).

tff(addAssignment_77693,axiom,
    ! [VarCurr: state_type] :
      ( v138652(VarCurr)
    <=> v138653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18290,axiom,
    ! [VarCurr: state_type] :
      ( v138653(VarCurr)
    <=> ( v138654(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18289,axiom,
    ! [VarCurr: state_type] :
      ( v138654(VarCurr)
    <=> ( v138655(VarCurr)
        & v138682(VarCurr) ) ) ).

tff(writeUnaryOperator_10367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138682(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18288,axiom,
    ! [VarCurr: state_type] :
      ( v138655(VarCurr)
    <=> ( v138656(VarCurr)
        & v138681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18287,axiom,
    ! [VarCurr: state_type] :
      ( v138681(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138656(VarCurr)
    <=> v138658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18286,axiom,
    ! [VarCurr: state_type] :
      ( v138658(VarCurr)
    <=> ( v138659(VarCurr)
        & v138676(VarCurr) ) ) ).

tff(writeUnaryOperator_10365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138676(VarCurr)
    <=> v138677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18285,axiom,
    ! [VarCurr: state_type] :
      ( v138677(VarCurr)
    <=> ( v138678(VarCurr)
        & v138680(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6535,axiom,
    ! [VarCurr: state_type] :
      ( v138680(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109303(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18284,axiom,
    ! [VarCurr: state_type] :
      ( v138678(VarCurr)
    <=> ( v138404(VarCurr)
        | v138679(VarCurr) ) ) ).

tff(writeUnaryOperator_10364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138679(VarCurr)
    <=> v109303(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18283,axiom,
    ! [VarCurr: state_type] :
      ( v138659(VarCurr)
    <=> ( v138660(VarCurr)
        & v138671(VarCurr) ) ) ).

tff(writeUnaryOperator_10363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138671(VarCurr)
    <=> v138672(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18282,axiom,
    ! [VarCurr: state_type] :
      ( v138672(VarCurr)
    <=> ( v138673(VarCurr)
        & v138675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6534,axiom,
    ! [VarCurr: state_type] :
      ( v138675(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109303(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18281,axiom,
    ! [VarCurr: state_type] :
      ( v138673(VarCurr)
    <=> ( v138398(VarCurr)
        | v138674(VarCurr) ) ) ).

tff(writeUnaryOperator_10362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138674(VarCurr)
    <=> v109303(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18280,axiom,
    ! [VarCurr: state_type] :
      ( v138660(VarCurr)
    <=> ( v138661(VarCurr)
        & v138666(VarCurr) ) ) ).

tff(writeUnaryOperator_10361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138666(VarCurr)
    <=> v138667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18279,axiom,
    ! [VarCurr: state_type] :
      ( v138667(VarCurr)
    <=> ( v138668(VarCurr)
        & v138670(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6533,axiom,
    ! [VarCurr: state_type] :
      ( v138670(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109303(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18278,axiom,
    ! [VarCurr: state_type] :
      ( v138668(VarCurr)
    <=> ( v138392(VarCurr)
        | v138669(VarCurr) ) ) ).

tff(writeUnaryOperator_10360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138669(VarCurr)
    <=> v109303(VarCurr,4) ) ).

tff(writeUnaryOperator_10359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138661(VarCurr)
    <=> v138662(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18277,axiom,
    ! [VarCurr: state_type] :
      ( v138662(VarCurr)
    <=> ( v138663(VarCurr)
        & v138665(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6532,axiom,
    ! [VarCurr: state_type] :
      ( v138665(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109303(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18276,axiom,
    ! [VarCurr: state_type] :
      ( v138663(VarCurr)
    <=> ( v138386(VarCurr)
        | v138664(VarCurr) ) ) ).

tff(writeUnaryOperator_10358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138664(VarCurr)
    <=> v109303(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138647(VarCurr,B)
      <=> ( v138648(VarCurr,B)
          & v127899(VarCurr,B) ) ) ) ).

tff(addAssignment_77692,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,0)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77691,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,1)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77690,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,2)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77689,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,3)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77688,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,4)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77687,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,5)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77686,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,6)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77685,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,7)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77684,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,8)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77683,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,9)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77682,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,10)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77681,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,11)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77680,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,12)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77679,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,13)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77678,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,14)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77677,axiom,
    ! [VarCurr: state_type] :
      ( v138648(VarCurr,15)
    <=> v138649(VarCurr) ) ).

tff(addAssignment_77676,axiom,
    ! [VarCurr: state_type] :
      ( v138649(VarCurr)
    <=> v138650(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6531,axiom,
    ! [VarCurr: state_type] :
      ( v138650(VarCurr)
    <=> ( v134(VarCurr,3)
        & v138609(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6530,axiom,
    ! [VarCurr: state_type] :
      ( v138609(VarCurr)
    <=> ( v138631(VarCurr)
        | v138645(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6529,axiom,
    ! [VarCurr: state_type] :
      ( v138631(VarCurr)
    <=> ( v138632(VarCurr)
        | v138645(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6528,axiom,
    ! [VarCurr: state_type] :
      ( v138632(VarCurr)
    <=> ( v138633(VarCurr)
        | v138645(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6527,axiom,
    ! [VarCurr: state_type] :
      ( v138633(VarCurr)
    <=> ( v138634(VarCurr)
        | v138645(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6526,axiom,
    ! [VarCurr: state_type] :
      ( v138634(VarCurr)
    <=> ( v138635(VarCurr)
        | v138645(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6525,axiom,
    ! [VarCurr: state_type] :
      ( v138635(VarCurr)
    <=> ( v138636(VarCurr)
        | v138645(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6524,axiom,
    ! [VarCurr: state_type] :
      ( v138636(VarCurr)
    <=> ( v138637(VarCurr)
        | v138645(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6523,axiom,
    ! [VarCurr: state_type] :
      ( v138637(VarCurr)
    <=> ( v138638(VarCurr)
        | v138645(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6522,axiom,
    ! [VarCurr: state_type] :
      ( v138638(VarCurr)
    <=> ( v138639(VarCurr)
        | v138645(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6521,axiom,
    ! [VarCurr: state_type] :
      ( v138639(VarCurr)
    <=> ( v138640(VarCurr)
        | v138645(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6520,axiom,
    ! [VarCurr: state_type] :
      ( v138640(VarCurr)
    <=> ( v138641(VarCurr)
        | v138645(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6519,axiom,
    ! [VarCurr: state_type] :
      ( v138641(VarCurr)
    <=> ( v138642(VarCurr)
        | v138645(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6518,axiom,
    ! [VarCurr: state_type] :
      ( v138642(VarCurr)
    <=> ( v138643(VarCurr)
        | v138645(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6517,axiom,
    ! [VarCurr: state_type] :
      ( v138643(VarCurr)
    <=> ( v138644(VarCurr)
        | v138645(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6516,axiom,
    ! [VarCurr: state_type] :
      ( v138644(VarCurr)
    <=> ( v138645(VarCurr,0)
        | v138645(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138645(VarCurr,B)
      <=> ( v138611(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77675,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,0)
    <=> v138628(VarCurr) ) ).

tff(addAssignment_77674,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,1)
    <=> v138627(VarCurr) ) ).

tff(addAssignment_77673,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,2)
    <=> v138626(VarCurr) ) ).

tff(addAssignment_77672,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,3)
    <=> v138625(VarCurr) ) ).

tff(addAssignment_77671,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,4)
    <=> v138624(VarCurr) ) ).

tff(addAssignment_77670,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,5)
    <=> v138623(VarCurr) ) ).

tff(addAssignment_77669,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,6)
    <=> v138622(VarCurr) ) ).

tff(addAssignment_77668,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,7)
    <=> v138621(VarCurr) ) ).

tff(addAssignment_77667,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,8)
    <=> v138620(VarCurr) ) ).

tff(addAssignment_77666,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,9)
    <=> v138619(VarCurr) ) ).

tff(addAssignment_77665,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,10)
    <=> v138618(VarCurr) ) ).

tff(addAssignment_77664,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,11)
    <=> v138617(VarCurr) ) ).

tff(addAssignment_77663,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,12)
    <=> v138616(VarCurr) ) ).

tff(addAssignment_77662,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,13)
    <=> v138615(VarCurr) ) ).

tff(addAssignment_77661,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,14)
    <=> v138614(VarCurr) ) ).

tff(addAssignment_77660,axiom,
    ! [VarCurr: state_type] :
      ( v138611(VarCurr,15)
    <=> v138613(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1969,axiom,
    ! [VarCurr: state_type] :
      ( v138628(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1968,axiom,
    ! [VarCurr: state_type] :
      ( v138627(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1967,axiom,
    ! [VarCurr: state_type] :
      ( v138626(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1966,axiom,
    ! [VarCurr: state_type] :
      ( v138625(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1965,axiom,
    ! [VarCurr: state_type] :
      ( v138624(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1964,axiom,
    ! [VarCurr: state_type] :
      ( v138623(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1963,axiom,
    ! [VarCurr: state_type] :
      ( v138622(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1962,axiom,
    ! [VarCurr: state_type] :
      ( v138621(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $false )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1961,axiom,
    ! [VarCurr: state_type] :
      ( v138620(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1960,axiom,
    ! [VarCurr: state_type] :
      ( v138619(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1959,axiom,
    ! [VarCurr: state_type] :
      ( v138618(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1958,axiom,
    ! [VarCurr: state_type] :
      ( v138617(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $false )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1957,axiom,
    ! [VarCurr: state_type] :
      ( v138616(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1956,axiom,
    ! [VarCurr: state_type] :
      ( v138615(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $false )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1955,axiom,
    ! [VarCurr: state_type] :
      ( v138614(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1954,axiom,
    ! [VarCurr: state_type] :
      ( v138613(VarCurr)
    <=> ( ( v109303(VarCurr,6)
        <=> $true )
        & ( v109303(VarCurr,5)
        <=> $true )
        & ( v109303(VarCurr,4)
        <=> $true )
        & ( v109303(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6515,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,2)
    <=> ( v138559(VarCurr)
        & v138578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18275,axiom,
    ! [VarCurr: state_type] :
      ( v138578(VarCurr)
    <=> ( v138579(VarCurr)
        | v138600(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1953,axiom,
    ! [VarCurr: state_type] :
      ( v138600(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v138601(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v138601(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v138601(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v138601(VarCurr,0) ) ) ) ).

tff(addAssignment_77659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138601(VarCurr,B)
      <=> v138547(VarCurr,B) ) ) ).

tff(addAssignment_77658,axiom,
    ! [VarCurr: state_type] :
      ( v138601(VarCurr,3)
    <=> v138553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18274,axiom,
    ! [VarCurr: state_type] :
      ( v138579(VarCurr)
    <=> ( v138580(VarCurr)
        | v138581(VarCurr) ) ) ).

tff(writeUnaryOperator_10357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138581(VarCurr)
    <=> v138583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18273,axiom,
    ! [VarCurr: state_type] :
      ( v138583(VarCurr)
    <=> ( v138584(VarCurr)
        & v138595(VarCurr) ) ) ).

tff(writeUnaryOperator_10356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138595(VarCurr)
    <=> v138596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18272,axiom,
    ! [VarCurr: state_type] :
      ( v138596(VarCurr)
    <=> ( v138597(VarCurr)
        & v138599(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6514,axiom,
    ! [VarCurr: state_type] :
      ( v138599(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138547(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18271,axiom,
    ! [VarCurr: state_type] :
      ( v138597(VarCurr)
    <=> ( v135621(VarCurr)
        | v138598(VarCurr) ) ) ).

tff(writeUnaryOperator_10355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138598(VarCurr)
    <=> v138547(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18270,axiom,
    ! [VarCurr: state_type] :
      ( v138584(VarCurr)
    <=> ( v138585(VarCurr)
        & v138590(VarCurr) ) ) ).

tff(writeUnaryOperator_10354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138590(VarCurr)
    <=> v138591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18269,axiom,
    ! [VarCurr: state_type] :
      ( v138591(VarCurr)
    <=> ( v138592(VarCurr)
        & v138594(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6513,axiom,
    ! [VarCurr: state_type] :
      ( v138594(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138547(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18268,axiom,
    ! [VarCurr: state_type] :
      ( v138592(VarCurr)
    <=> ( v135615(VarCurr)
        | v138593(VarCurr) ) ) ).

tff(writeUnaryOperator_10353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138593(VarCurr)
    <=> v138547(VarCurr,1) ) ).

tff(writeUnaryOperator_10352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138585(VarCurr)
    <=> v138586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18267,axiom,
    ! [VarCurr: state_type] :
      ( v138586(VarCurr)
    <=> ( v138587(VarCurr)
        & v138589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18266,axiom,
    ! [VarCurr: state_type] :
      ( v138589(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138547(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18265,axiom,
    ! [VarCurr: state_type] :
      ( v138587(VarCurr)
    <=> ( v135609(VarCurr)
        | v138588(VarCurr) ) ) ).

tff(writeUnaryOperator_10351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138588(VarCurr)
    <=> v138547(VarCurr,0) ) ).

tff(writeUnaryOperator_10350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138580(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18264,axiom,
    ! [VarCurr: state_type] :
      ( v138559(VarCurr)
    <=> ( v138560(VarCurr)
        & v138577(VarCurr) ) ) ).

tff(writeUnaryOperator_10349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138577(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6512,axiom,
    ! [VarCurr: state_type] :
      ( v138560(VarCurr)
    <=> ( v138562(VarCurr)
        | v138576(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6511,axiom,
    ! [VarCurr: state_type] :
      ( v138562(VarCurr)
    <=> ( v138563(VarCurr)
        | v138576(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6510,axiom,
    ! [VarCurr: state_type] :
      ( v138563(VarCurr)
    <=> ( v138564(VarCurr)
        | v138576(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6509,axiom,
    ! [VarCurr: state_type] :
      ( v138564(VarCurr)
    <=> ( v138565(VarCurr)
        | v138576(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6508,axiom,
    ! [VarCurr: state_type] :
      ( v138565(VarCurr)
    <=> ( v138566(VarCurr)
        | v138576(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6507,axiom,
    ! [VarCurr: state_type] :
      ( v138566(VarCurr)
    <=> ( v138567(VarCurr)
        | v138576(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6506,axiom,
    ! [VarCurr: state_type] :
      ( v138567(VarCurr)
    <=> ( v138568(VarCurr)
        | v138576(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6505,axiom,
    ! [VarCurr: state_type] :
      ( v138568(VarCurr)
    <=> ( v138569(VarCurr)
        | v138576(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6504,axiom,
    ! [VarCurr: state_type] :
      ( v138569(VarCurr)
    <=> ( v138570(VarCurr)
        | v138576(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6503,axiom,
    ! [VarCurr: state_type] :
      ( v138570(VarCurr)
    <=> ( v138571(VarCurr)
        | v138576(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6502,axiom,
    ! [VarCurr: state_type] :
      ( v138571(VarCurr)
    <=> ( v138572(VarCurr)
        | v138576(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6501,axiom,
    ! [VarCurr: state_type] :
      ( v138572(VarCurr)
    <=> ( v138573(VarCurr)
        | v138576(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6500,axiom,
    ! [VarCurr: state_type] :
      ( v138573(VarCurr)
    <=> ( v138574(VarCurr)
        | v138576(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6499,axiom,
    ! [VarCurr: state_type] :
      ( v138574(VarCurr)
    <=> ( v138575(VarCurr)
        | v138576(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6498,axiom,
    ! [VarCurr: state_type] :
      ( v138575(VarCurr)
    <=> ( v138576(VarCurr,0)
        | v138576(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138576(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138466(VarCurr,B) ) ) ) ).

tff(addAssignment_77657,axiom,
    ! [VarCurr: state_type] :
      ( v138553(VarCurr)
    <=> v138555(VarCurr) ) ).

tff(addAssignment_77656,axiom,
    ! [VarCurr: state_type] :
      ( v138555(VarCurr)
    <=> v138557(VarCurr) ) ).

tff(addAssignment_77655,axiom,
    ! [VarCurr: state_type] :
      ( v138557(VarCurr)
    <=> v109364(VarCurr,6) ) ).

tff(addAssignment_77654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138547(VarCurr,B)
      <=> v138549(VarCurr,B) ) ) ).

tff(addAssignment_77653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138549(VarCurr,B)
      <=> v138551(VarCurr,B) ) ) ).

tff(addAssignment_77652,axiom,
    ! [VarCurr: state_type] :
      ( ( v138551(VarCurr,2)
      <=> v109364(VarCurr,5) )
      & ( v138551(VarCurr,1)
      <=> v109364(VarCurr,4) )
      & ( v138551(VarCurr,0)
      <=> v109364(VarCurr,3) ) ) ).

tff(addAssignment_77651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138466(VarCurr,B)
      <=> v138468(VarCurr,B) ) ) ).

tff(addAssignment_77650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138468(VarCurr,B)
      <=> v138470(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138470(VarCurr,B)
      <=> ( v138510(VarCurr,B)
          & v138514(VarCurr,B) ) ) ) ).

tff(addAssignment_77649,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,0)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77648,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,1)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77647,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,2)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77646,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,3)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77645,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,4)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77644,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,5)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77643,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,6)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77642,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,7)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77641,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,8)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77640,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,9)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77639,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,10)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77638,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,11)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77637,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,12)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77636,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,13)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77635,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,14)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77634,axiom,
    ! [VarCurr: state_type] :
      ( v138514(VarCurr,15)
    <=> v138515(VarCurr) ) ).

tff(addAssignment_77633,axiom,
    ! [VarCurr: state_type] :
      ( v138515(VarCurr)
    <=> v138516(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18263,axiom,
    ! [VarCurr: state_type] :
      ( v138516(VarCurr)
    <=> ( v138517(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18262,axiom,
    ! [VarCurr: state_type] :
      ( v138517(VarCurr)
    <=> ( v138518(VarCurr)
        & v138545(VarCurr) ) ) ).

tff(writeUnaryOperator_10348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138545(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18261,axiom,
    ! [VarCurr: state_type] :
      ( v138518(VarCurr)
    <=> ( v138519(VarCurr)
        & v138544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18260,axiom,
    ! [VarCurr: state_type] :
      ( v138544(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138519(VarCurr)
    <=> v138521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18259,axiom,
    ! [VarCurr: state_type] :
      ( v138521(VarCurr)
    <=> ( v138522(VarCurr)
        & v138539(VarCurr) ) ) ).

tff(writeUnaryOperator_10346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138539(VarCurr)
    <=> v138540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18258,axiom,
    ! [VarCurr: state_type] :
      ( v138540(VarCurr)
    <=> ( v138541(VarCurr)
        & v138543(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6497,axiom,
    ! [VarCurr: state_type] :
      ( v138543(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109364(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18257,axiom,
    ! [VarCurr: state_type] :
      ( v138541(VarCurr)
    <=> ( v138404(VarCurr)
        | v138542(VarCurr) ) ) ).

tff(writeUnaryOperator_10345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138542(VarCurr)
    <=> v109364(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18256,axiom,
    ! [VarCurr: state_type] :
      ( v138522(VarCurr)
    <=> ( v138523(VarCurr)
        & v138534(VarCurr) ) ) ).

tff(writeUnaryOperator_10344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138534(VarCurr)
    <=> v138535(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18255,axiom,
    ! [VarCurr: state_type] :
      ( v138535(VarCurr)
    <=> ( v138536(VarCurr)
        & v138538(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6496,axiom,
    ! [VarCurr: state_type] :
      ( v138538(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109364(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18254,axiom,
    ! [VarCurr: state_type] :
      ( v138536(VarCurr)
    <=> ( v138398(VarCurr)
        | v138537(VarCurr) ) ) ).

tff(writeUnaryOperator_10343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138537(VarCurr)
    <=> v109364(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18253,axiom,
    ! [VarCurr: state_type] :
      ( v138523(VarCurr)
    <=> ( v138524(VarCurr)
        & v138529(VarCurr) ) ) ).

tff(writeUnaryOperator_10342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138529(VarCurr)
    <=> v138530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18252,axiom,
    ! [VarCurr: state_type] :
      ( v138530(VarCurr)
    <=> ( v138531(VarCurr)
        & v138533(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6495,axiom,
    ! [VarCurr: state_type] :
      ( v138533(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109364(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18251,axiom,
    ! [VarCurr: state_type] :
      ( v138531(VarCurr)
    <=> ( v138392(VarCurr)
        | v138532(VarCurr) ) ) ).

tff(writeUnaryOperator_10341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138532(VarCurr)
    <=> v109364(VarCurr,4) ) ).

tff(writeUnaryOperator_10340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138524(VarCurr)
    <=> v138525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18250,axiom,
    ! [VarCurr: state_type] :
      ( v138525(VarCurr)
    <=> ( v138526(VarCurr)
        & v138528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6494,axiom,
    ! [VarCurr: state_type] :
      ( v138528(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109364(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18249,axiom,
    ! [VarCurr: state_type] :
      ( v138526(VarCurr)
    <=> ( v138386(VarCurr)
        | v138527(VarCurr) ) ) ).

tff(writeUnaryOperator_10339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138527(VarCurr)
    <=> v109364(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138510(VarCurr,B)
      <=> ( v138511(VarCurr,B)
          & v127874(VarCurr,B) ) ) ) ).

tff(addAssignment_77632,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,0)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77631,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,1)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77630,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,2)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77629,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,3)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77628,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,4)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77627,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,5)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77626,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,6)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77625,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,7)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77624,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,8)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77623,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,9)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77622,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,10)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77621,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,11)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77620,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,12)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77619,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,13)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77618,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,14)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77617,axiom,
    ! [VarCurr: state_type] :
      ( v138511(VarCurr,15)
    <=> v138512(VarCurr) ) ).

tff(addAssignment_77616,axiom,
    ! [VarCurr: state_type] :
      ( v138512(VarCurr)
    <=> v138513(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6493,axiom,
    ! [VarCurr: state_type] :
      ( v138513(VarCurr)
    <=> ( v134(VarCurr,2)
        & v138472(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6492,axiom,
    ! [VarCurr: state_type] :
      ( v138472(VarCurr)
    <=> ( v138494(VarCurr)
        | v138508(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6491,axiom,
    ! [VarCurr: state_type] :
      ( v138494(VarCurr)
    <=> ( v138495(VarCurr)
        | v138508(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6490,axiom,
    ! [VarCurr: state_type] :
      ( v138495(VarCurr)
    <=> ( v138496(VarCurr)
        | v138508(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6489,axiom,
    ! [VarCurr: state_type] :
      ( v138496(VarCurr)
    <=> ( v138497(VarCurr)
        | v138508(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6488,axiom,
    ! [VarCurr: state_type] :
      ( v138497(VarCurr)
    <=> ( v138498(VarCurr)
        | v138508(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6487,axiom,
    ! [VarCurr: state_type] :
      ( v138498(VarCurr)
    <=> ( v138499(VarCurr)
        | v138508(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6486,axiom,
    ! [VarCurr: state_type] :
      ( v138499(VarCurr)
    <=> ( v138500(VarCurr)
        | v138508(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6485,axiom,
    ! [VarCurr: state_type] :
      ( v138500(VarCurr)
    <=> ( v138501(VarCurr)
        | v138508(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6484,axiom,
    ! [VarCurr: state_type] :
      ( v138501(VarCurr)
    <=> ( v138502(VarCurr)
        | v138508(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6483,axiom,
    ! [VarCurr: state_type] :
      ( v138502(VarCurr)
    <=> ( v138503(VarCurr)
        | v138508(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6482,axiom,
    ! [VarCurr: state_type] :
      ( v138503(VarCurr)
    <=> ( v138504(VarCurr)
        | v138508(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6481,axiom,
    ! [VarCurr: state_type] :
      ( v138504(VarCurr)
    <=> ( v138505(VarCurr)
        | v138508(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6480,axiom,
    ! [VarCurr: state_type] :
      ( v138505(VarCurr)
    <=> ( v138506(VarCurr)
        | v138508(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6479,axiom,
    ! [VarCurr: state_type] :
      ( v138506(VarCurr)
    <=> ( v138507(VarCurr)
        | v138508(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6478,axiom,
    ! [VarCurr: state_type] :
      ( v138507(VarCurr)
    <=> ( v138508(VarCurr,0)
        | v138508(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138508(VarCurr,B)
      <=> ( v138474(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(addAssignment_77615,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,0)
    <=> v138491(VarCurr) ) ).

tff(addAssignment_77614,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,1)
    <=> v138490(VarCurr) ) ).

tff(addAssignment_77613,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,2)
    <=> v138489(VarCurr) ) ).

tff(addAssignment_77612,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,3)
    <=> v138488(VarCurr) ) ).

tff(addAssignment_77611,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,4)
    <=> v138487(VarCurr) ) ).

tff(addAssignment_77610,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,5)
    <=> v138486(VarCurr) ) ).

tff(addAssignment_77609,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,6)
    <=> v138485(VarCurr) ) ).

tff(addAssignment_77608,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,7)
    <=> v138484(VarCurr) ) ).

tff(addAssignment_77607,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,8)
    <=> v138483(VarCurr) ) ).

tff(addAssignment_77606,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,9)
    <=> v138482(VarCurr) ) ).

tff(addAssignment_77605,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,10)
    <=> v138481(VarCurr) ) ).

tff(addAssignment_77604,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,11)
    <=> v138480(VarCurr) ) ).

tff(addAssignment_77603,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,12)
    <=> v138479(VarCurr) ) ).

tff(addAssignment_77602,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,13)
    <=> v138478(VarCurr) ) ).

tff(addAssignment_77601,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,14)
    <=> v138477(VarCurr) ) ).

tff(addAssignment_77600,axiom,
    ! [VarCurr: state_type] :
      ( v138474(VarCurr,15)
    <=> v138476(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1952,axiom,
    ! [VarCurr: state_type] :
      ( v138491(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1951,axiom,
    ! [VarCurr: state_type] :
      ( v138490(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1950,axiom,
    ! [VarCurr: state_type] :
      ( v138489(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1949,axiom,
    ! [VarCurr: state_type] :
      ( v138488(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1948,axiom,
    ! [VarCurr: state_type] :
      ( v138487(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1947,axiom,
    ! [VarCurr: state_type] :
      ( v138486(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1946,axiom,
    ! [VarCurr: state_type] :
      ( v138485(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1945,axiom,
    ! [VarCurr: state_type] :
      ( v138484(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $false )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1944,axiom,
    ! [VarCurr: state_type] :
      ( v138483(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1943,axiom,
    ! [VarCurr: state_type] :
      ( v138482(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1942,axiom,
    ! [VarCurr: state_type] :
      ( v138481(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1941,axiom,
    ! [VarCurr: state_type] :
      ( v138480(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $false )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1940,axiom,
    ! [VarCurr: state_type] :
      ( v138479(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1939,axiom,
    ! [VarCurr: state_type] :
      ( v138478(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $false )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1938,axiom,
    ! [VarCurr: state_type] :
      ( v138477(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1937,axiom,
    ! [VarCurr: state_type] :
      ( v138476(VarCurr)
    <=> ( ( v109364(VarCurr,6)
        <=> $true )
        & ( v109364(VarCurr,5)
        <=> $true )
        & ( v109364(VarCurr,4)
        <=> $true )
        & ( v109364(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6477,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,1)
    <=> ( v138422(VarCurr)
        & v138441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18248,axiom,
    ! [VarCurr: state_type] :
      ( v138441(VarCurr)
    <=> ( v138442(VarCurr)
        | v138463(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1936,axiom,
    ! [VarCurr: state_type] :
      ( v138463(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v138464(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v138464(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v138464(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v138464(VarCurr,0) ) ) ) ).

tff(addAssignment_77599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138464(VarCurr,B)
      <=> v138410(VarCurr,B) ) ) ).

tff(addAssignment_77598,axiom,
    ! [VarCurr: state_type] :
      ( v138464(VarCurr,3)
    <=> v138416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18247,axiom,
    ! [VarCurr: state_type] :
      ( v138442(VarCurr)
    <=> ( v138443(VarCurr)
        | v138444(VarCurr) ) ) ).

tff(writeUnaryOperator_10338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138444(VarCurr)
    <=> v138446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18246,axiom,
    ! [VarCurr: state_type] :
      ( v138446(VarCurr)
    <=> ( v138447(VarCurr)
        & v138458(VarCurr) ) ) ).

tff(writeUnaryOperator_10337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138458(VarCurr)
    <=> v138459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18245,axiom,
    ! [VarCurr: state_type] :
      ( v138459(VarCurr)
    <=> ( v138460(VarCurr)
        & v138462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6476,axiom,
    ! [VarCurr: state_type] :
      ( v138462(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138410(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18244,axiom,
    ! [VarCurr: state_type] :
      ( v138460(VarCurr)
    <=> ( v135621(VarCurr)
        | v138461(VarCurr) ) ) ).

tff(writeUnaryOperator_10336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138461(VarCurr)
    <=> v138410(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18243,axiom,
    ! [VarCurr: state_type] :
      ( v138447(VarCurr)
    <=> ( v138448(VarCurr)
        & v138453(VarCurr) ) ) ).

tff(writeUnaryOperator_10335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138453(VarCurr)
    <=> v138454(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18242,axiom,
    ! [VarCurr: state_type] :
      ( v138454(VarCurr)
    <=> ( v138455(VarCurr)
        & v138457(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6475,axiom,
    ! [VarCurr: state_type] :
      ( v138457(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138410(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18241,axiom,
    ! [VarCurr: state_type] :
      ( v138455(VarCurr)
    <=> ( v135615(VarCurr)
        | v138456(VarCurr) ) ) ).

tff(writeUnaryOperator_10334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138456(VarCurr)
    <=> v138410(VarCurr,1) ) ).

tff(writeUnaryOperator_10333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138448(VarCurr)
    <=> v138449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18240,axiom,
    ! [VarCurr: state_type] :
      ( v138449(VarCurr)
    <=> ( v138450(VarCurr)
        & v138452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18239,axiom,
    ! [VarCurr: state_type] :
      ( v138452(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138410(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18238,axiom,
    ! [VarCurr: state_type] :
      ( v138450(VarCurr)
    <=> ( v135609(VarCurr)
        | v138451(VarCurr) ) ) ).

tff(writeUnaryOperator_10332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138451(VarCurr)
    <=> v138410(VarCurr,0) ) ).

tff(writeUnaryOperator_10331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138443(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18237,axiom,
    ! [VarCurr: state_type] :
      ( v138422(VarCurr)
    <=> ( v138423(VarCurr)
        & v138440(VarCurr) ) ) ).

tff(writeUnaryOperator_10330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138440(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6474,axiom,
    ! [VarCurr: state_type] :
      ( v138423(VarCurr)
    <=> ( v138425(VarCurr)
        | v138439(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6473,axiom,
    ! [VarCurr: state_type] :
      ( v138425(VarCurr)
    <=> ( v138426(VarCurr)
        | v138439(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6472,axiom,
    ! [VarCurr: state_type] :
      ( v138426(VarCurr)
    <=> ( v138427(VarCurr)
        | v138439(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6471,axiom,
    ! [VarCurr: state_type] :
      ( v138427(VarCurr)
    <=> ( v138428(VarCurr)
        | v138439(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6470,axiom,
    ! [VarCurr: state_type] :
      ( v138428(VarCurr)
    <=> ( v138429(VarCurr)
        | v138439(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6469,axiom,
    ! [VarCurr: state_type] :
      ( v138429(VarCurr)
    <=> ( v138430(VarCurr)
        | v138439(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6468,axiom,
    ! [VarCurr: state_type] :
      ( v138430(VarCurr)
    <=> ( v138431(VarCurr)
        | v138439(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6467,axiom,
    ! [VarCurr: state_type] :
      ( v138431(VarCurr)
    <=> ( v138432(VarCurr)
        | v138439(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6466,axiom,
    ! [VarCurr: state_type] :
      ( v138432(VarCurr)
    <=> ( v138433(VarCurr)
        | v138439(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6465,axiom,
    ! [VarCurr: state_type] :
      ( v138433(VarCurr)
    <=> ( v138434(VarCurr)
        | v138439(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6464,axiom,
    ! [VarCurr: state_type] :
      ( v138434(VarCurr)
    <=> ( v138435(VarCurr)
        | v138439(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6463,axiom,
    ! [VarCurr: state_type] :
      ( v138435(VarCurr)
    <=> ( v138436(VarCurr)
        | v138439(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6462,axiom,
    ! [VarCurr: state_type] :
      ( v138436(VarCurr)
    <=> ( v138437(VarCurr)
        | v138439(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6461,axiom,
    ! [VarCurr: state_type] :
      ( v138437(VarCurr)
    <=> ( v138438(VarCurr)
        | v138439(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6460,axiom,
    ! [VarCurr: state_type] :
      ( v138438(VarCurr)
    <=> ( v138439(VarCurr,0)
        | v138439(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138439(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138307(VarCurr,B) ) ) ) ).

tff(addAssignment_77597,axiom,
    ! [VarCurr: state_type] :
      ( v138416(VarCurr)
    <=> v138418(VarCurr) ) ).

tff(addAssignment_77596,axiom,
    ! [VarCurr: state_type] :
      ( v138418(VarCurr)
    <=> v138420(VarCurr) ) ).

tff(addAssignment_77595,axiom,
    ! [VarCurr: state_type] :
      ( v138420(VarCurr)
    <=> v109425(VarCurr,6) ) ).

tff(addAssignment_77594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138410(VarCurr,B)
      <=> v138412(VarCurr,B) ) ) ).

tff(addAssignment_77593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138412(VarCurr,B)
      <=> v138414(VarCurr,B) ) ) ).

tff(addAssignment_77592,axiom,
    ! [VarCurr: state_type] :
      ( ( v138414(VarCurr,2)
      <=> v109425(VarCurr,5) )
      & ( v138414(VarCurr,1)
      <=> v109425(VarCurr,4) )
      & ( v138414(VarCurr,0)
      <=> v109425(VarCurr,3) ) ) ).

tff(addAssignment_77591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138307(VarCurr,B)
      <=> v138309(VarCurr,B) ) ) ).

tff(addAssignment_77590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138309(VarCurr,B)
      <=> v138311(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138311(VarCurr,B)
      <=> ( v138369(VarCurr,B)
          & v138373(VarCurr,B) ) ) ) ).

tff(addAssignment_77589,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,0)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77588,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,1)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77587,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,2)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77586,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,3)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77585,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,4)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77584,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,5)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77583,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,6)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77582,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,7)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77581,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,8)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77580,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,9)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77579,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,10)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77578,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,11)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77577,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,12)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77576,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,13)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77575,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,14)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77574,axiom,
    ! [VarCurr: state_type] :
      ( v138373(VarCurr,15)
    <=> v138374(VarCurr) ) ).

tff(addAssignment_77573,axiom,
    ! [VarCurr: state_type] :
      ( v138374(VarCurr)
    <=> v138375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18236,axiom,
    ! [VarCurr: state_type] :
      ( v138375(VarCurr)
    <=> ( v138376(VarCurr)
        | v138367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18235,axiom,
    ! [VarCurr: state_type] :
      ( v138376(VarCurr)
    <=> ( v138377(VarCurr)
        & v138408(VarCurr) ) ) ).

tff(writeUnaryOperator_10329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138408(VarCurr)
    <=> v138365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18234,axiom,
    ! [VarCurr: state_type] :
      ( v138377(VarCurr)
    <=> ( v138378(VarCurr)
        & v138407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18233,axiom,
    ! [VarCurr: state_type] :
      ( v138407(VarCurr)
    <=> ( v138361(VarCurr)
        | v138363(VarCurr) ) ) ).

tff(writeUnaryOperator_10328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138378(VarCurr)
    <=> v138380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18232,axiom,
    ! [VarCurr: state_type] :
      ( v138380(VarCurr)
    <=> ( v138381(VarCurr)
        & v138401(VarCurr) ) ) ).

tff(writeUnaryOperator_10327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138401(VarCurr)
    <=> v138402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18231,axiom,
    ! [VarCurr: state_type] :
      ( v138402(VarCurr)
    <=> ( v138403(VarCurr)
        & v138406(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6459,axiom,
    ! [VarCurr: state_type] :
      ( v138406(VarCurr)
    <=> ( v138359(VarCurr,3)
        | v109425(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18230,axiom,
    ! [VarCurr: state_type] :
      ( v138403(VarCurr)
    <=> ( v138404(VarCurr)
        | v138405(VarCurr) ) ) ).

tff(writeUnaryOperator_10326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138405(VarCurr)
    <=> v109425(VarCurr,6) ) ).

tff(writeUnaryOperator_10325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138404(VarCurr)
    <=> v138359(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18229,axiom,
    ! [VarCurr: state_type] :
      ( v138381(VarCurr)
    <=> ( v138382(VarCurr)
        & v138395(VarCurr) ) ) ).

tff(writeUnaryOperator_10324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138395(VarCurr)
    <=> v138396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18228,axiom,
    ! [VarCurr: state_type] :
      ( v138396(VarCurr)
    <=> ( v138397(VarCurr)
        & v138400(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6458,axiom,
    ! [VarCurr: state_type] :
      ( v138400(VarCurr)
    <=> ( v138359(VarCurr,2)
        | v109425(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18227,axiom,
    ! [VarCurr: state_type] :
      ( v138397(VarCurr)
    <=> ( v138398(VarCurr)
        | v138399(VarCurr) ) ) ).

tff(writeUnaryOperator_10323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138399(VarCurr)
    <=> v109425(VarCurr,5) ) ).

tff(writeUnaryOperator_10322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138398(VarCurr)
    <=> v138359(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18226,axiom,
    ! [VarCurr: state_type] :
      ( v138382(VarCurr)
    <=> ( v138383(VarCurr)
        & v138389(VarCurr) ) ) ).

tff(writeUnaryOperator_10321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138389(VarCurr)
    <=> v138390(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18225,axiom,
    ! [VarCurr: state_type] :
      ( v138390(VarCurr)
    <=> ( v138391(VarCurr)
        & v138394(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6457,axiom,
    ! [VarCurr: state_type] :
      ( v138394(VarCurr)
    <=> ( v138359(VarCurr,1)
        | v109425(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18224,axiom,
    ! [VarCurr: state_type] :
      ( v138391(VarCurr)
    <=> ( v138392(VarCurr)
        | v138393(VarCurr) ) ) ).

tff(writeUnaryOperator_10320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138393(VarCurr)
    <=> v109425(VarCurr,4) ) ).

tff(writeUnaryOperator_10319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138392(VarCurr)
    <=> v138359(VarCurr,1) ) ).

tff(writeUnaryOperator_10318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138383(VarCurr)
    <=> v138384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18223,axiom,
    ! [VarCurr: state_type] :
      ( v138384(VarCurr)
    <=> ( v138385(VarCurr)
        & v138388(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6456,axiom,
    ! [VarCurr: state_type] :
      ( v138388(VarCurr)
    <=> ( v138359(VarCurr,0)
        | v109425(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18222,axiom,
    ! [VarCurr: state_type] :
      ( v138385(VarCurr)
    <=> ( v138386(VarCurr)
        | v138387(VarCurr) ) ) ).

tff(writeUnaryOperator_10317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138387(VarCurr)
    <=> v109425(VarCurr,3) ) ).

tff(writeUnaryOperator_10316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138386(VarCurr)
    <=> v138359(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138369(VarCurr,B)
      <=> ( v138370(VarCurr,B)
          & v127849(VarCurr,B) ) ) ) ).

tff(addAssignment_77572,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,0)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77571,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,1)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77570,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,2)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77569,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,3)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77568,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,4)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77567,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,5)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77566,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,6)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77565,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,7)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77564,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,8)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77563,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,9)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77562,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,10)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77561,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,11)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77560,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,12)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77559,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,13)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77558,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,14)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77557,axiom,
    ! [VarCurr: state_type] :
      ( v138370(VarCurr,15)
    <=> v138371(VarCurr) ) ).

tff(addAssignment_77556,axiom,
    ! [VarCurr: state_type] :
      ( v138371(VarCurr)
    <=> v138372(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6455,axiom,
    ! [VarCurr: state_type] :
      ( v138372(VarCurr)
    <=> ( v134(VarCurr,1)
        & v138313(VarCurr) ) ) ).

tff(addAssignment_77555,axiom,
    ! [VarCurr: state_type] :
      ( v138367(VarCurr)
    <=> v108828(VarCurr) ) ).

tff(addAssignment_77554,axiom,
    ! [VarCurr: state_type] :
      ( v138365(VarCurr)
    <=> v108820(VarCurr) ) ).

tff(addAssignment_77553,axiom,
    ! [VarCurr: state_type] :
      ( v138363(VarCurr)
    <=> v108816(VarCurr) ) ).

tff(addAssignment_77552,axiom,
    ! [VarCurr: state_type] :
      ( v138361(VarCurr)
    <=> v108812(VarCurr) ) ).

tff(addAssignment_77551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v138359(VarCurr,B)
      <=> v108824(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6454,axiom,
    ! [VarCurr: state_type] :
      ( v138313(VarCurr)
    <=> ( v138343(VarCurr)
        | v138357(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6453,axiom,
    ! [VarCurr: state_type] :
      ( v138343(VarCurr)
    <=> ( v138344(VarCurr)
        | v138357(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6452,axiom,
    ! [VarCurr: state_type] :
      ( v138344(VarCurr)
    <=> ( v138345(VarCurr)
        | v138357(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6451,axiom,
    ! [VarCurr: state_type] :
      ( v138345(VarCurr)
    <=> ( v138346(VarCurr)
        | v138357(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6450,axiom,
    ! [VarCurr: state_type] :
      ( v138346(VarCurr)
    <=> ( v138347(VarCurr)
        | v138357(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6449,axiom,
    ! [VarCurr: state_type] :
      ( v138347(VarCurr)
    <=> ( v138348(VarCurr)
        | v138357(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6448,axiom,
    ! [VarCurr: state_type] :
      ( v138348(VarCurr)
    <=> ( v138349(VarCurr)
        | v138357(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6447,axiom,
    ! [VarCurr: state_type] :
      ( v138349(VarCurr)
    <=> ( v138350(VarCurr)
        | v138357(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6446,axiom,
    ! [VarCurr: state_type] :
      ( v138350(VarCurr)
    <=> ( v138351(VarCurr)
        | v138357(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6445,axiom,
    ! [VarCurr: state_type] :
      ( v138351(VarCurr)
    <=> ( v138352(VarCurr)
        | v138357(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6444,axiom,
    ! [VarCurr: state_type] :
      ( v138352(VarCurr)
    <=> ( v138353(VarCurr)
        | v138357(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6443,axiom,
    ! [VarCurr: state_type] :
      ( v138353(VarCurr)
    <=> ( v138354(VarCurr)
        | v138357(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6442,axiom,
    ! [VarCurr: state_type] :
      ( v138354(VarCurr)
    <=> ( v138355(VarCurr)
        | v138357(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6441,axiom,
    ! [VarCurr: state_type] :
      ( v138355(VarCurr)
    <=> ( v138356(VarCurr)
        | v138357(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6440,axiom,
    ! [VarCurr: state_type] :
      ( v138356(VarCurr)
    <=> ( v138357(VarCurr,0)
        | v138357(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138357(VarCurr,B)
      <=> ( v138315(VarCurr,B)
          & v138334(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138334(VarCurr,B)
      <=> ( v138336(VarCurr,B)
          & v138340(VarCurr,B) ) ) ) ).

tff(addAssignment_77550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v138340(VarCurr,B)
      <=> v138338(VarCurr,B) ) ) ).

tff(addAssignment_77549,axiom,
    ! [VarCurr: state_type] :
      ( ( v138340(VarCurr,15)
      <=> v138338(VarCurr,7) )
      & ( v138340(VarCurr,14)
      <=> v138338(VarCurr,6) )
      & ( v138340(VarCurr,13)
      <=> v138338(VarCurr,5) )
      & ( v138340(VarCurr,12)
      <=> v138338(VarCurr,4) )
      & ( v138340(VarCurr,11)
      <=> v138338(VarCurr,3) )
      & ( v138340(VarCurr,10)
      <=> v138338(VarCurr,2) )
      & ( v138340(VarCurr,9)
      <=> v138338(VarCurr,1) )
      & ( v138340(VarCurr,8)
      <=> v138338(VarCurr,0) ) ) ).

tff(addAssignment_77548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v138338(VarCurr,B)
      <=> v137435(VarCurr,B) ) ) ).

tff(addAssignment_77547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138336(VarCurr,B)
      <=> v85706(VarCurr,B) ) ) ).

tff(addAssignment_77546,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,0)
    <=> v138332(VarCurr) ) ).

tff(addAssignment_77545,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,1)
    <=> v138331(VarCurr) ) ).

tff(addAssignment_77544,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,2)
    <=> v138330(VarCurr) ) ).

tff(addAssignment_77543,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,3)
    <=> v138329(VarCurr) ) ).

tff(addAssignment_77542,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,4)
    <=> v138328(VarCurr) ) ).

tff(addAssignment_77541,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,5)
    <=> v138327(VarCurr) ) ).

tff(addAssignment_77540,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,6)
    <=> v138326(VarCurr) ) ).

tff(addAssignment_77539,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,7)
    <=> v138325(VarCurr) ) ).

tff(addAssignment_77538,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,8)
    <=> v138324(VarCurr) ) ).

tff(addAssignment_77537,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,9)
    <=> v138323(VarCurr) ) ).

tff(addAssignment_77536,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,10)
    <=> v138322(VarCurr) ) ).

tff(addAssignment_77535,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,11)
    <=> v138321(VarCurr) ) ).

tff(addAssignment_77534,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,12)
    <=> v138320(VarCurr) ) ).

tff(addAssignment_77533,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,13)
    <=> v138319(VarCurr) ) ).

tff(addAssignment_77532,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,14)
    <=> v138318(VarCurr) ) ).

tff(addAssignment_77531,axiom,
    ! [VarCurr: state_type] :
      ( v138315(VarCurr,15)
    <=> v138317(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1935,axiom,
    ! [VarCurr: state_type] :
      ( v138332(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1934,axiom,
    ! [VarCurr: state_type] :
      ( v138331(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1933,axiom,
    ! [VarCurr: state_type] :
      ( v138330(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1932,axiom,
    ! [VarCurr: state_type] :
      ( v138329(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1931,axiom,
    ! [VarCurr: state_type] :
      ( v138328(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1930,axiom,
    ! [VarCurr: state_type] :
      ( v138327(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1929,axiom,
    ! [VarCurr: state_type] :
      ( v138326(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1928,axiom,
    ! [VarCurr: state_type] :
      ( v138325(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $false )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1927,axiom,
    ! [VarCurr: state_type] :
      ( v138324(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1926,axiom,
    ! [VarCurr: state_type] :
      ( v138323(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1925,axiom,
    ! [VarCurr: state_type] :
      ( v138322(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1924,axiom,
    ! [VarCurr: state_type] :
      ( v138321(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $false )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1923,axiom,
    ! [VarCurr: state_type] :
      ( v138320(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1922,axiom,
    ! [VarCurr: state_type] :
      ( v138319(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $false )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1921,axiom,
    ! [VarCurr: state_type] :
      ( v138318(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1920,axiom,
    ! [VarCurr: state_type] :
      ( v138317(VarCurr)
    <=> ( ( v109425(VarCurr,6)
        <=> $true )
        & ( v109425(VarCurr,5)
        <=> $true )
        & ( v109425(VarCurr,4)
        <=> $true )
        & ( v109425(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18221,axiom,
    ! [VarCurr: state_type] :
      ( v138148(VarCurr,0)
    <=> ( v138263(VarCurr)
        & v138282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18220,axiom,
    ! [VarCurr: state_type] :
      ( v138282(VarCurr)
    <=> ( v138283(VarCurr)
        | v138304(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1919,axiom,
    ! [VarCurr: state_type] :
      ( v138304(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v138305(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v138305(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v138305(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v138305(VarCurr,0) ) ) ) ).

tff(addAssignment_77530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138305(VarCurr,B)
      <=> v138251(VarCurr,B) ) ) ).

tff(addAssignment_77529,axiom,
    ! [VarCurr: state_type] :
      ( v138305(VarCurr,3)
    <=> v138257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18219,axiom,
    ! [VarCurr: state_type] :
      ( v138283(VarCurr)
    <=> ( v138284(VarCurr)
        | v138285(VarCurr) ) ) ).

tff(writeUnaryOperator_10315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138285(VarCurr)
    <=> v138287(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18218,axiom,
    ! [VarCurr: state_type] :
      ( v138287(VarCurr)
    <=> ( v138288(VarCurr)
        & v138299(VarCurr) ) ) ).

tff(writeUnaryOperator_10314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138299(VarCurr)
    <=> v138300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18217,axiom,
    ! [VarCurr: state_type] :
      ( v138300(VarCurr)
    <=> ( v138301(VarCurr)
        & v138303(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6439,axiom,
    ! [VarCurr: state_type] :
      ( v138303(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v138251(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18216,axiom,
    ! [VarCurr: state_type] :
      ( v138301(VarCurr)
    <=> ( v135621(VarCurr)
        | v138302(VarCurr) ) ) ).

tff(writeUnaryOperator_10313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138302(VarCurr)
    <=> v138251(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18215,axiom,
    ! [VarCurr: state_type] :
      ( v138288(VarCurr)
    <=> ( v138289(VarCurr)
        & v138294(VarCurr) ) ) ).

tff(writeUnaryOperator_10312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138294(VarCurr)
    <=> v138295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18214,axiom,
    ! [VarCurr: state_type] :
      ( v138295(VarCurr)
    <=> ( v138296(VarCurr)
        & v138298(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6438,axiom,
    ! [VarCurr: state_type] :
      ( v138298(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v138251(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18213,axiom,
    ! [VarCurr: state_type] :
      ( v138296(VarCurr)
    <=> ( v135615(VarCurr)
        | v138297(VarCurr) ) ) ).

tff(writeUnaryOperator_10311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138297(VarCurr)
    <=> v138251(VarCurr,1) ) ).

tff(writeUnaryOperator_10310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138289(VarCurr)
    <=> v138290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18212,axiom,
    ! [VarCurr: state_type] :
      ( v138290(VarCurr)
    <=> ( v138291(VarCurr)
        & v138293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18211,axiom,
    ! [VarCurr: state_type] :
      ( v138293(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v138251(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18210,axiom,
    ! [VarCurr: state_type] :
      ( v138291(VarCurr)
    <=> ( v135609(VarCurr)
        | v138292(VarCurr) ) ) ).

tff(writeUnaryOperator_10309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138292(VarCurr)
    <=> v138251(VarCurr,0) ) ).

tff(writeUnaryOperator_10308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138284(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18209,axiom,
    ! [VarCurr: state_type] :
      ( v138263(VarCurr)
    <=> ( v138264(VarCurr)
        & v138281(VarCurr) ) ) ).

tff(writeUnaryOperator_10307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138281(VarCurr)
    <=> v138150(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6437,axiom,
    ! [VarCurr: state_type] :
      ( v138264(VarCurr)
    <=> ( v138266(VarCurr)
        | v138280(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6436,axiom,
    ! [VarCurr: state_type] :
      ( v138266(VarCurr)
    <=> ( v138267(VarCurr)
        | v138280(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6435,axiom,
    ! [VarCurr: state_type] :
      ( v138267(VarCurr)
    <=> ( v138268(VarCurr)
        | v138280(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6434,axiom,
    ! [VarCurr: state_type] :
      ( v138268(VarCurr)
    <=> ( v138269(VarCurr)
        | v138280(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6433,axiom,
    ! [VarCurr: state_type] :
      ( v138269(VarCurr)
    <=> ( v138270(VarCurr)
        | v138280(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6432,axiom,
    ! [VarCurr: state_type] :
      ( v138270(VarCurr)
    <=> ( v138271(VarCurr)
        | v138280(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6431,axiom,
    ! [VarCurr: state_type] :
      ( v138271(VarCurr)
    <=> ( v138272(VarCurr)
        | v138280(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6430,axiom,
    ! [VarCurr: state_type] :
      ( v138272(VarCurr)
    <=> ( v138273(VarCurr)
        | v138280(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6429,axiom,
    ! [VarCurr: state_type] :
      ( v138273(VarCurr)
    <=> ( v138274(VarCurr)
        | v138280(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6428,axiom,
    ! [VarCurr: state_type] :
      ( v138274(VarCurr)
    <=> ( v138275(VarCurr)
        | v138280(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6427,axiom,
    ! [VarCurr: state_type] :
      ( v138275(VarCurr)
    <=> ( v138276(VarCurr)
        | v138280(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6426,axiom,
    ! [VarCurr: state_type] :
      ( v138276(VarCurr)
    <=> ( v138277(VarCurr)
        | v138280(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6425,axiom,
    ! [VarCurr: state_type] :
      ( v138277(VarCurr)
    <=> ( v138278(VarCurr)
        | v138280(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6424,axiom,
    ! [VarCurr: state_type] :
      ( v138278(VarCurr)
    <=> ( v138279(VarCurr)
        | v138280(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6423,axiom,
    ! [VarCurr: state_type] :
      ( v138279(VarCurr)
    <=> ( v138280(VarCurr,0)
        | v138280(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138280(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v128(VarCurr,B) ) ) ) ).

tff(addAssignment_77528,axiom,
    ! [VarCurr: state_type] :
      ( v138257(VarCurr)
    <=> v138259(VarCurr) ) ).

tff(addAssignment_77527,axiom,
    ! [VarCurr: state_type] :
      ( v138259(VarCurr)
    <=> v138261(VarCurr) ) ).

tff(addAssignment_77526,axiom,
    ! [VarCurr: state_type] :
      ( v138261(VarCurr)
    <=> v109486(VarCurr,6) ) ).

tff(addAssignment_77525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138251(VarCurr,B)
      <=> v138253(VarCurr,B) ) ) ).

tff(addAssignment_77524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v138253(VarCurr,B)
      <=> v138255(VarCurr,B) ) ) ).

tff(addAssignment_77523,axiom,
    ! [VarCurr: state_type] :
      ( ( v138255(VarCurr,2)
      <=> v109486(VarCurr,5) )
      & ( v138255(VarCurr,1)
      <=> v109486(VarCurr,4) )
      & ( v138255(VarCurr,0)
      <=> v109486(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18208,axiom,
    ! [VarCurr: state_type] :
      ( v138150(VarCurr)
    <=> ( v138232(VarCurr)
        | v135253(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6422,axiom,
    ! [VarCurr: state_type] :
      ( v138232(VarCurr)
    <=> ( v138233(VarCurr)
        | v84297(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18207,axiom,
    ! [VarCurr: state_type] :
      ( v138233(VarCurr)
    <=> ( v138234(VarCurr)
        | v127180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18206,axiom,
    ! [VarCurr: state_type] :
      ( v138234(VarCurr)
    <=> ( v138235(VarCurr)
        | v100727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18205,axiom,
    ! [VarCurr: state_type] :
      ( v138235(VarCurr)
    <=> ( v138236(VarCurr)
        | v128492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18204,axiom,
    ! [VarCurr: state_type] :
      ( v138236(VarCurr)
    <=> ( v138237(VarCurr)
        | v88420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18203,axiom,
    ! [VarCurr: state_type] :
      ( v138237(VarCurr)
    <=> ( v138238(VarCurr)
        | v108897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18202,axiom,
    ! [VarCurr: state_type] :
      ( v138238(VarCurr)
    <=> ( v138239(VarCurr)
        | v138248(VarCurr) ) ) ).

tff(writeUnaryOperator_10306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138248(VarCurr)
    <=> v138249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18201,axiom,
    ! [VarCurr: state_type] :
      ( v138249(VarCurr)
    <=> ( v84583(VarCurr)
        | v89527(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18200,axiom,
    ! [VarCurr: state_type] :
      ( v138239(VarCurr)
    <=> ( v138240(VarCurr)
        | v86879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18199,axiom,
    ! [VarCurr: state_type] :
      ( v138240(VarCurr)
    <=> ( v138241(VarCurr)
        | v128095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18198,axiom,
    ! [VarCurr: state_type] :
      ( v138241(VarCurr)
    <=> ( v138242(VarCurr)
        | v138247(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18197,axiom,
    ! [VarCurr: state_type] :
      ( v138247(VarCurr)
    <=> ( v138200(VarCurr)
        & v101598(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18196,axiom,
    ! [VarCurr: state_type] :
      ( v138242(VarCurr)
    <=> ( v138243(VarCurr)
        | v138246(VarCurr) ) ) ).

tff(writeUnaryOperator_10305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138246(VarCurr)
    <=> v109663(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18195,axiom,
    ! [VarCurr: state_type] :
      ( v138243(VarCurr)
    <=> ( v138244(VarCurr)
        | v138245(VarCurr) ) ) ).

tff(writeUnaryOperator_10304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138245(VarCurr)
    <=> v135529(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18194,axiom,
    ! [VarCurr: state_type] :
      ( v138244(VarCurr)
    <=> ( v111693(VarCurr)
        | v138152(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6421,axiom,
    ! [VarCurr: state_type] :
      ( v138200(VarCurr)
    <=> ( v138216(VarCurr)
        | v138230(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6420,axiom,
    ! [VarCurr: state_type] :
      ( v138216(VarCurr)
    <=> ( v138217(VarCurr)
        | v138230(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6419,axiom,
    ! [VarCurr: state_type] :
      ( v138217(VarCurr)
    <=> ( v138218(VarCurr)
        | v138230(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6418,axiom,
    ! [VarCurr: state_type] :
      ( v138218(VarCurr)
    <=> ( v138219(VarCurr)
        | v138230(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6417,axiom,
    ! [VarCurr: state_type] :
      ( v138219(VarCurr)
    <=> ( v138220(VarCurr)
        | v138230(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6416,axiom,
    ! [VarCurr: state_type] :
      ( v138220(VarCurr)
    <=> ( v138221(VarCurr)
        | v138230(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6415,axiom,
    ! [VarCurr: state_type] :
      ( v138221(VarCurr)
    <=> ( v138222(VarCurr)
        | v138230(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6414,axiom,
    ! [VarCurr: state_type] :
      ( v138222(VarCurr)
    <=> ( v138223(VarCurr)
        | v138230(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6413,axiom,
    ! [VarCurr: state_type] :
      ( v138223(VarCurr)
    <=> ( v138224(VarCurr)
        | v138230(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6412,axiom,
    ! [VarCurr: state_type] :
      ( v138224(VarCurr)
    <=> ( v138225(VarCurr)
        | v138230(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6411,axiom,
    ! [VarCurr: state_type] :
      ( v138225(VarCurr)
    <=> ( v138226(VarCurr)
        | v138230(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6410,axiom,
    ! [VarCurr: state_type] :
      ( v138226(VarCurr)
    <=> ( v138227(VarCurr)
        | v138230(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6409,axiom,
    ! [VarCurr: state_type] :
      ( v138227(VarCurr)
    <=> ( v138228(VarCurr)
        | v138230(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6408,axiom,
    ! [VarCurr: state_type] :
      ( v138228(VarCurr)
    <=> ( v138229(VarCurr)
        | v138230(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6407,axiom,
    ! [VarCurr: state_type] :
      ( v138229(VarCurr)
    <=> ( v138230(VarCurr,0)
        | v138230(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138230(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v138202(VarCurr,B) ) ) ) ).

tff(addAssignment_77522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138202(VarCurr,B)
      <=> v138204(VarCurr,B) ) ) ).

tff(addAssignment_77521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138204(VarCurr,B)
      <=> v138206(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138206(VarCurr,B)
      <=> ( v138208(VarCurr,B)
          | v138211(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1900,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138211(VarCurr,B)
      <=> ( v100441(VarCurr,B)
          & v138212(VarCurr,B) ) ) ) ).

tff(addAssignment_77520,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,0)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77519,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,1)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77518,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,2)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77517,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,3)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77516,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,4)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77515,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,5)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77514,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,6)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77513,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,7)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77512,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,8)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77511,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,9)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77510,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,10)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77509,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,11)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77508,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,12)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77507,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,13)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77506,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,14)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77505,axiom,
    ! [VarCurr: state_type] :
      ( v138212(VarCurr,15)
    <=> v138213(VarCurr) ) ).

tff(addAssignment_77504,axiom,
    ! [VarCurr: state_type] :
      ( v138213(VarCurr)
    <=> v100689(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1899,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138208(VarCurr,B)
      <=> ( v100217(VarCurr,B)
          & v138209(VarCurr,B) ) ) ) ).

tff(addAssignment_77503,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,0)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77502,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,1)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77501,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,2)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77500,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,3)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77499,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,4)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77498,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,5)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77497,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,6)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77496,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,7)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77495,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,8)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77494,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,9)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77493,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,10)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77492,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,11)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77491,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,12)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77490,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,13)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77489,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,14)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77488,axiom,
    ! [VarCurr: state_type] :
      ( v138209(VarCurr,15)
    <=> v138210(VarCurr) ) ).

tff(addAssignment_77487,axiom,
    ! [VarCurr: state_type] :
      ( v138210(VarCurr)
    <=> v100689(VarCurr,0) ) ).

tff(addAssignment_77486,axiom,
    ! [VarCurr: state_type] :
      ( v138152(VarCurr)
    <=> v138154(VarCurr) ) ).

tff(addAssignment_77485,axiom,
    ! [VarCurr: state_type] :
      ( v138154(VarCurr)
    <=> v138156(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v138183(VarNext)
       => ( v138156(VarNext)
        <=> v138156(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1911,axiom,
    ! [VarNext: state_type] :
      ( v138183(VarNext)
     => ( v138156(VarNext)
      <=> v138193(VarNext) ) ) ).

tff(addAssignment_77484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138193(VarNext)
      <=> v138191(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138194(VarCurr)
     => ( v138191(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1465,axiom,
    ! [VarCurr: state_type] :
      ( v138194(VarCurr)
     => ( v138191(VarCurr)
      <=> v138166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18193,axiom,
    ! [VarCurr: state_type] :
      ( v138194(VarCurr)
    <=> ( v138195(VarCurr)
        & v138196(VarCurr) ) ) ).

tff(writeUnaryOperator_10303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138196(VarCurr)
    <=> v138162(VarCurr) ) ).

tff(writeUnaryOperator_10302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138195(VarCurr)
    <=> v138158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138183(VarNext)
      <=> v138184(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138184(VarNext)
      <=> ( v138185(VarNext)
          & v138178(VarNext) ) ) ) ).

tff(writeUnaryOperator_10301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v138185(VarNext)
      <=> v138187(VarNext) ) ) ).

tff(addAssignment_77483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138187(VarNext)
      <=> v138178(VarCurr) ) ) ).

tff(addAssignment_77482,axiom,
    ! [VarCurr: state_type] :
      ( v138178(VarCurr)
    <=> v138180(VarCurr) ) ).

tff(addAssignment_77481,axiom,
    ! [VarCurr: state_type] :
      ( v138180(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_77480,axiom,
    ! [VarCurr: state_type] :
      ( v138166(VarCurr)
    <=> v138168(VarCurr) ) ).

tff(addAssignment_77479,axiom,
    ! [VarCurr: state_type] :
      ( v138168(VarCurr)
    <=> v138170(VarCurr) ) ).

tff(addAssignment_77478,axiom,
    ! [VarCurr: state_type] :
      ( v138170(VarCurr)
    <=> v138172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18190,axiom,
    ! [VarCurr: state_type] :
      ( v138172(VarCurr)
    <=> ( v138174(VarCurr)
        | v100727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18189,axiom,
    ! [VarCurr: state_type] :
      ( v138174(VarCurr)
    <=> ( v138175(VarCurr)
        | v138176(VarCurr) ) ) ).

tff(writeUnaryOperator_10300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138176(VarCurr)
    <=> v8(VarCurr,0) ) ).

tff(writeUnaryOperator_10299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138175(VarCurr)
    <=> v109663(VarCurr) ) ).

tff(addAssignment_77477,axiom,
    ! [VarCurr: state_type] :
      ( v138162(VarCurr)
    <=> v138164(VarCurr) ) ).

tff(addAssignment_77476,axiom,
    ! [VarCurr: state_type] :
      ( v138164(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_77475,axiom,
    ! [VarCurr: state_type] :
      ( v138158(VarCurr)
    <=> v138160(VarCurr) ) ).

tff(addAssignment_77474,axiom,
    ! [VarCurr: state_type] :
      ( v138160(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_77473,axiom,
    ! [VarCurr: state_type] :
      ( v138098(VarCurr)
    <=> v138100(VarCurr) ) ).

tff(addAssignment_77472,axiom,
    ! [VarCurr: state_type] :
      ( v138100(VarCurr)
    <=> v138102(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v138131(VarNext)
       => ( v138102(VarNext)
        <=> v138102(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1910,axiom,
    ! [VarNext: state_type] :
      ( v138131(VarNext)
     => ( v138102(VarNext)
      <=> v138141(VarNext) ) ) ).

tff(addAssignment_77471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138141(VarNext)
      <=> v138139(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138142(VarCurr)
     => ( v138139(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1464,axiom,
    ! [VarCurr: state_type] :
      ( v138142(VarCurr)
     => ( v138139(VarCurr)
      <=> v138112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18188,axiom,
    ! [VarCurr: state_type] :
      ( v138142(VarCurr)
    <=> ( v138143(VarCurr)
        & v138144(VarCurr) ) ) ).

tff(writeUnaryOperator_10298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138144(VarCurr)
    <=> v138108(VarCurr) ) ).

tff(writeUnaryOperator_10297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138143(VarCurr)
    <=> v138104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138131(VarNext)
      <=> v138132(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138132(VarNext)
      <=> ( v138133(VarNext)
          & v138126(VarNext) ) ) ) ).

tff(writeUnaryOperator_10296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v138133(VarNext)
      <=> v138135(VarNext) ) ) ).

tff(addAssignment_77470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v138135(VarNext)
      <=> v138126(VarCurr) ) ) ).

tff(addAssignment_77469,axiom,
    ! [VarCurr: state_type] :
      ( v138126(VarCurr)
    <=> v138128(VarCurr) ) ).

tff(addAssignment_77468,axiom,
    ! [VarCurr: state_type] :
      ( v138128(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_77467,axiom,
    ! [VarCurr: state_type] :
      ( v138112(VarCurr)
    <=> v138114(VarCurr) ) ).

tff(addAssignment_77466,axiom,
    ! [VarCurr: state_type] :
      ( v138114(VarCurr)
    <=> v138116(VarCurr) ) ).

tff(addAssignment_77465,axiom,
    ! [VarCurr: state_type] :
      ( v138116(VarCurr)
    <=> v138118(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138120(VarCurr)
     => ( v138118(VarCurr)
      <=> v138122(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1463,axiom,
    ! [VarCurr: state_type] :
      ( v138120(VarCurr)
     => ( v138118(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138123(VarCurr)
     => ( v138122(VarCurr)
      <=> v138098(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1462,axiom,
    ! [VarCurr: state_type] :
      ( v138123(VarCurr)
     => ( v138122(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18185,axiom,
    ! [VarCurr: state_type] :
      ( v138123(VarCurr)
    <=> ( v84899(VarCurr)
        & v138124(VarCurr) ) ) ).

tff(writeUnaryOperator_10295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138124(VarCurr)
    <=> v89409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18184,axiom,
    ! [VarCurr: state_type] :
      ( v138120(VarCurr)
    <=> ( v118(VarCurr)
        & v138121(VarCurr) ) ) ).

tff(writeUnaryOperator_10294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138121(VarCurr)
    <=> v2900(VarCurr) ) ).

tff(addAssignment_77464,axiom,
    ! [VarCurr: state_type] :
      ( v138108(VarCurr)
    <=> v138110(VarCurr) ) ).

tff(addAssignment_77463,axiom,
    ! [VarCurr: state_type] :
      ( v138110(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_77462,axiom,
    ! [VarCurr: state_type] :
      ( v138104(VarCurr)
    <=> v138106(VarCurr) ) ).

tff(addAssignment_77461,axiom,
    ! [VarCurr: state_type] :
      ( v138106(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6406,axiom,
    ! [VarCurr: state_type] :
      ( v84905(VarCurr)
    <=> ( v138082(VarCurr)
        | v138096(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6405,axiom,
    ! [VarCurr: state_type] :
      ( v138082(VarCurr)
    <=> ( v138083(VarCurr)
        | v138096(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6404,axiom,
    ! [VarCurr: state_type] :
      ( v138083(VarCurr)
    <=> ( v138084(VarCurr)
        | v138096(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6403,axiom,
    ! [VarCurr: state_type] :
      ( v138084(VarCurr)
    <=> ( v138085(VarCurr)
        | v138096(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6402,axiom,
    ! [VarCurr: state_type] :
      ( v138085(VarCurr)
    <=> ( v138086(VarCurr)
        | v138096(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6401,axiom,
    ! [VarCurr: state_type] :
      ( v138086(VarCurr)
    <=> ( v138087(VarCurr)
        | v138096(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6400,axiom,
    ! [VarCurr: state_type] :
      ( v138087(VarCurr)
    <=> ( v138088(VarCurr)
        | v138096(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6399,axiom,
    ! [VarCurr: state_type] :
      ( v138088(VarCurr)
    <=> ( v138089(VarCurr)
        | v138096(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6398,axiom,
    ! [VarCurr: state_type] :
      ( v138089(VarCurr)
    <=> ( v138090(VarCurr)
        | v138096(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6397,axiom,
    ! [VarCurr: state_type] :
      ( v138090(VarCurr)
    <=> ( v138091(VarCurr)
        | v138096(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6396,axiom,
    ! [VarCurr: state_type] :
      ( v138091(VarCurr)
    <=> ( v138092(VarCurr)
        | v138096(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6395,axiom,
    ! [VarCurr: state_type] :
      ( v138092(VarCurr)
    <=> ( v138093(VarCurr)
        | v138096(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6394,axiom,
    ! [VarCurr: state_type] :
      ( v138093(VarCurr)
    <=> ( v138094(VarCurr)
        | v138096(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6393,axiom,
    ! [VarCurr: state_type] :
      ( v138094(VarCurr)
    <=> ( v138095(VarCurr)
        | v138096(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6392,axiom,
    ! [VarCurr: state_type] :
      ( v138095(VarCurr)
    <=> ( v138096(VarCurr,0)
        | v138096(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1898,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138096(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v84907(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v84907(VarCurr,B)
      <=> ( v138074(VarCurr,B)
          | v137993(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138074(VarCurr,B)
      <=> ( v138075(VarCurr,B)
          | v137912(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138075(VarCurr,B)
      <=> ( v138076(VarCurr,B)
          | v137831(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138076(VarCurr,B)
      <=> ( v138077(VarCurr,B)
          | v137750(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138077(VarCurr,B)
      <=> ( v138078(VarCurr,B)
          | v137669(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138078(VarCurr,B)
      <=> ( v138079(VarCurr,B)
          | v137588(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138079(VarCurr,B)
      <=> ( v84909(VarCurr,B)
          | v137507(VarCurr,B) ) ) ) ).

tff(addAssignment_77460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137993(VarCurr,B)
      <=> v137995(VarCurr,B) ) ) ).

tff(addAssignment_77459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137995(VarCurr,B)
      <=> v137997(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137997(VarCurr,B)
      <=> ( v138037(VarCurr,B)
          & v138041(VarCurr,B) ) ) ) ).

tff(addAssignment_77458,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,0)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77457,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,1)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77456,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,2)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77455,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,3)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77454,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,4)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77453,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,5)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77452,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,6)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77451,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,7)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77450,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,8)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77449,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,9)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77448,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,10)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77447,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,11)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77446,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,12)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77445,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,13)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77444,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,14)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77443,axiom,
    ! [VarCurr: state_type] :
      ( v138041(VarCurr,15)
    <=> v138042(VarCurr) ) ).

tff(addAssignment_77442,axiom,
    ! [VarCurr: state_type] :
      ( v138042(VarCurr)
    <=> v138043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18183,axiom,
    ! [VarCurr: state_type] :
      ( v138043(VarCurr)
    <=> ( v138044(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18182,axiom,
    ! [VarCurr: state_type] :
      ( v138044(VarCurr)
    <=> ( v138045(VarCurr)
        & v138072(VarCurr) ) ) ).

tff(writeUnaryOperator_10293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138072(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18181,axiom,
    ! [VarCurr: state_type] :
      ( v138045(VarCurr)
    <=> ( v138046(VarCurr)
        & v138071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18180,axiom,
    ! [VarCurr: state_type] :
      ( v138071(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138046(VarCurr)
    <=> v138048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18179,axiom,
    ! [VarCurr: state_type] :
      ( v138048(VarCurr)
    <=> ( v138049(VarCurr)
        & v138066(VarCurr) ) ) ).

tff(writeUnaryOperator_10291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138066(VarCurr)
    <=> v138067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18178,axiom,
    ! [VarCurr: state_type] :
      ( v138067(VarCurr)
    <=> ( v138068(VarCurr)
        & v138070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6391,axiom,
    ! [VarCurr: state_type] :
      ( v138070(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85282(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18177,axiom,
    ! [VarCurr: state_type] :
      ( v138068(VarCurr)
    <=> ( v137501(VarCurr)
        | v138069(VarCurr) ) ) ).

tff(writeUnaryOperator_10290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138069(VarCurr)
    <=> v85282(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18176,axiom,
    ! [VarCurr: state_type] :
      ( v138049(VarCurr)
    <=> ( v138050(VarCurr)
        & v138061(VarCurr) ) ) ).

tff(writeUnaryOperator_10289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138061(VarCurr)
    <=> v138062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18175,axiom,
    ! [VarCurr: state_type] :
      ( v138062(VarCurr)
    <=> ( v138063(VarCurr)
        & v138065(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6390,axiom,
    ! [VarCurr: state_type] :
      ( v138065(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85282(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18174,axiom,
    ! [VarCurr: state_type] :
      ( v138063(VarCurr)
    <=> ( v137495(VarCurr)
        | v138064(VarCurr) ) ) ).

tff(writeUnaryOperator_10288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138064(VarCurr)
    <=> v85282(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18173,axiom,
    ! [VarCurr: state_type] :
      ( v138050(VarCurr)
    <=> ( v138051(VarCurr)
        & v138056(VarCurr) ) ) ).

tff(writeUnaryOperator_10287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138056(VarCurr)
    <=> v138057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18172,axiom,
    ! [VarCurr: state_type] :
      ( v138057(VarCurr)
    <=> ( v138058(VarCurr)
        & v138060(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6389,axiom,
    ! [VarCurr: state_type] :
      ( v138060(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85282(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18171,axiom,
    ! [VarCurr: state_type] :
      ( v138058(VarCurr)
    <=> ( v137489(VarCurr)
        | v138059(VarCurr) ) ) ).

tff(writeUnaryOperator_10286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138059(VarCurr)
    <=> v85282(VarCurr,4) ) ).

tff(writeUnaryOperator_10285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138051(VarCurr)
    <=> v138052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18170,axiom,
    ! [VarCurr: state_type] :
      ( v138052(VarCurr)
    <=> ( v138053(VarCurr)
        & v138055(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6388,axiom,
    ! [VarCurr: state_type] :
      ( v138055(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85282(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18169,axiom,
    ! [VarCurr: state_type] :
      ( v138053(VarCurr)
    <=> ( v137483(VarCurr)
        | v138054(VarCurr) ) ) ).

tff(writeUnaryOperator_10284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v138054(VarCurr)
    <=> v85282(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138037(VarCurr,B)
      <=> ( v138038(VarCurr,B)
          & v127595(VarCurr,B) ) ) ) ).

tff(addAssignment_77441,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,0)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77440,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,1)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77439,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,2)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77438,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,3)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77437,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,4)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77436,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,5)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77435,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,6)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77434,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,7)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77433,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,8)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77432,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,9)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77431,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,10)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77430,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,11)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77429,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,12)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77428,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,13)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77427,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,14)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77426,axiom,
    ! [VarCurr: state_type] :
      ( v138038(VarCurr,15)
    <=> v138039(VarCurr) ) ).

tff(addAssignment_77425,axiom,
    ! [VarCurr: state_type] :
      ( v138039(VarCurr)
    <=> v138040(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6387,axiom,
    ! [VarCurr: state_type] :
      ( v138040(VarCurr)
    <=> ( v84915(VarCurr,7)
        & v137999(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6386,axiom,
    ! [VarCurr: state_type] :
      ( v137999(VarCurr)
    <=> ( v138021(VarCurr)
        | v138035(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6385,axiom,
    ! [VarCurr: state_type] :
      ( v138021(VarCurr)
    <=> ( v138022(VarCurr)
        | v138035(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6384,axiom,
    ! [VarCurr: state_type] :
      ( v138022(VarCurr)
    <=> ( v138023(VarCurr)
        | v138035(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6383,axiom,
    ! [VarCurr: state_type] :
      ( v138023(VarCurr)
    <=> ( v138024(VarCurr)
        | v138035(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6382,axiom,
    ! [VarCurr: state_type] :
      ( v138024(VarCurr)
    <=> ( v138025(VarCurr)
        | v138035(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6381,axiom,
    ! [VarCurr: state_type] :
      ( v138025(VarCurr)
    <=> ( v138026(VarCurr)
        | v138035(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6380,axiom,
    ! [VarCurr: state_type] :
      ( v138026(VarCurr)
    <=> ( v138027(VarCurr)
        | v138035(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6379,axiom,
    ! [VarCurr: state_type] :
      ( v138027(VarCurr)
    <=> ( v138028(VarCurr)
        | v138035(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6378,axiom,
    ! [VarCurr: state_type] :
      ( v138028(VarCurr)
    <=> ( v138029(VarCurr)
        | v138035(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6377,axiom,
    ! [VarCurr: state_type] :
      ( v138029(VarCurr)
    <=> ( v138030(VarCurr)
        | v138035(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6376,axiom,
    ! [VarCurr: state_type] :
      ( v138030(VarCurr)
    <=> ( v138031(VarCurr)
        | v138035(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6375,axiom,
    ! [VarCurr: state_type] :
      ( v138031(VarCurr)
    <=> ( v138032(VarCurr)
        | v138035(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6374,axiom,
    ! [VarCurr: state_type] :
      ( v138032(VarCurr)
    <=> ( v138033(VarCurr)
        | v138035(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6373,axiom,
    ! [VarCurr: state_type] :
      ( v138033(VarCurr)
    <=> ( v138034(VarCurr)
        | v138035(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6372,axiom,
    ! [VarCurr: state_type] :
      ( v138034(VarCurr)
    <=> ( v138035(VarCurr,0)
        | v138035(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v138035(VarCurr,B)
      <=> ( v138001(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77424,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,0)
    <=> v138018(VarCurr) ) ).

tff(addAssignment_77423,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,1)
    <=> v138017(VarCurr) ) ).

tff(addAssignment_77422,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,2)
    <=> v138016(VarCurr) ) ).

tff(addAssignment_77421,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,3)
    <=> v138015(VarCurr) ) ).

tff(addAssignment_77420,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,4)
    <=> v138014(VarCurr) ) ).

tff(addAssignment_77419,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,5)
    <=> v138013(VarCurr) ) ).

tff(addAssignment_77418,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,6)
    <=> v138012(VarCurr) ) ).

tff(addAssignment_77417,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,7)
    <=> v138011(VarCurr) ) ).

tff(addAssignment_77416,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,8)
    <=> v138010(VarCurr) ) ).

tff(addAssignment_77415,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,9)
    <=> v138009(VarCurr) ) ).

tff(addAssignment_77414,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,10)
    <=> v138008(VarCurr) ) ).

tff(addAssignment_77413,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,11)
    <=> v138007(VarCurr) ) ).

tff(addAssignment_77412,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,12)
    <=> v138006(VarCurr) ) ).

tff(addAssignment_77411,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,13)
    <=> v138005(VarCurr) ) ).

tff(addAssignment_77410,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,14)
    <=> v138004(VarCurr) ) ).

tff(addAssignment_77409,axiom,
    ! [VarCurr: state_type] :
      ( v138001(VarCurr,15)
    <=> v138003(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1918,axiom,
    ! [VarCurr: state_type] :
      ( v138018(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1917,axiom,
    ! [VarCurr: state_type] :
      ( v138017(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1916,axiom,
    ! [VarCurr: state_type] :
      ( v138016(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1915,axiom,
    ! [VarCurr: state_type] :
      ( v138015(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1914,axiom,
    ! [VarCurr: state_type] :
      ( v138014(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1913,axiom,
    ! [VarCurr: state_type] :
      ( v138013(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1912,axiom,
    ! [VarCurr: state_type] :
      ( v138012(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1911,axiom,
    ! [VarCurr: state_type] :
      ( v138011(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $false )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1910,axiom,
    ! [VarCurr: state_type] :
      ( v138010(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1909,axiom,
    ! [VarCurr: state_type] :
      ( v138009(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1908,axiom,
    ! [VarCurr: state_type] :
      ( v138008(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1907,axiom,
    ! [VarCurr: state_type] :
      ( v138007(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $false )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1906,axiom,
    ! [VarCurr: state_type] :
      ( v138006(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1905,axiom,
    ! [VarCurr: state_type] :
      ( v138005(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $false )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1904,axiom,
    ! [VarCurr: state_type] :
      ( v138004(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1903,axiom,
    ! [VarCurr: state_type] :
      ( v138003(VarCurr)
    <=> ( ( v85282(VarCurr,6)
        <=> $true )
        & ( v85282(VarCurr,5)
        <=> $true )
        & ( v85282(VarCurr,4)
        <=> $true )
        & ( v85282(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137912(VarCurr,B)
      <=> v137914(VarCurr,B) ) ) ).

tff(addAssignment_77407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137914(VarCurr,B)
      <=> v137916(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137916(VarCurr,B)
      <=> ( v137956(VarCurr,B)
          & v137960(VarCurr,B) ) ) ) ).

tff(addAssignment_77406,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,0)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77405,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,1)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77404,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,2)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77403,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,3)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77402,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,4)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77401,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,5)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77400,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,6)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77399,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,7)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77398,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,8)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77397,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,9)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77396,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,10)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77395,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,11)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77394,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,12)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77393,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,13)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77392,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,14)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77391,axiom,
    ! [VarCurr: state_type] :
      ( v137960(VarCurr,15)
    <=> v137961(VarCurr) ) ).

tff(addAssignment_77390,axiom,
    ! [VarCurr: state_type] :
      ( v137961(VarCurr)
    <=> v137962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18168,axiom,
    ! [VarCurr: state_type] :
      ( v137962(VarCurr)
    <=> ( v137963(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18167,axiom,
    ! [VarCurr: state_type] :
      ( v137963(VarCurr)
    <=> ( v137964(VarCurr)
        & v137991(VarCurr) ) ) ).

tff(writeUnaryOperator_10283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137991(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18166,axiom,
    ! [VarCurr: state_type] :
      ( v137964(VarCurr)
    <=> ( v137965(VarCurr)
        & v137990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18165,axiom,
    ! [VarCurr: state_type] :
      ( v137990(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137965(VarCurr)
    <=> v137967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18164,axiom,
    ! [VarCurr: state_type] :
      ( v137967(VarCurr)
    <=> ( v137968(VarCurr)
        & v137985(VarCurr) ) ) ).

tff(writeUnaryOperator_10281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137985(VarCurr)
    <=> v137986(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18163,axiom,
    ! [VarCurr: state_type] :
      ( v137986(VarCurr)
    <=> ( v137987(VarCurr)
        & v137989(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6371,axiom,
    ! [VarCurr: state_type] :
      ( v137989(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85260(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18162,axiom,
    ! [VarCurr: state_type] :
      ( v137987(VarCurr)
    <=> ( v137501(VarCurr)
        | v137988(VarCurr) ) ) ).

tff(writeUnaryOperator_10280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137988(VarCurr)
    <=> v85260(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18161,axiom,
    ! [VarCurr: state_type] :
      ( v137968(VarCurr)
    <=> ( v137969(VarCurr)
        & v137980(VarCurr) ) ) ).

tff(writeUnaryOperator_10279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137980(VarCurr)
    <=> v137981(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18160,axiom,
    ! [VarCurr: state_type] :
      ( v137981(VarCurr)
    <=> ( v137982(VarCurr)
        & v137984(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6370,axiom,
    ! [VarCurr: state_type] :
      ( v137984(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85260(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18159,axiom,
    ! [VarCurr: state_type] :
      ( v137982(VarCurr)
    <=> ( v137495(VarCurr)
        | v137983(VarCurr) ) ) ).

tff(writeUnaryOperator_10278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137983(VarCurr)
    <=> v85260(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18158,axiom,
    ! [VarCurr: state_type] :
      ( v137969(VarCurr)
    <=> ( v137970(VarCurr)
        & v137975(VarCurr) ) ) ).

tff(writeUnaryOperator_10277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137975(VarCurr)
    <=> v137976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18157,axiom,
    ! [VarCurr: state_type] :
      ( v137976(VarCurr)
    <=> ( v137977(VarCurr)
        & v137979(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6369,axiom,
    ! [VarCurr: state_type] :
      ( v137979(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85260(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18156,axiom,
    ! [VarCurr: state_type] :
      ( v137977(VarCurr)
    <=> ( v137489(VarCurr)
        | v137978(VarCurr) ) ) ).

tff(writeUnaryOperator_10276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137978(VarCurr)
    <=> v85260(VarCurr,4) ) ).

tff(writeUnaryOperator_10275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137970(VarCurr)
    <=> v137971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18155,axiom,
    ! [VarCurr: state_type] :
      ( v137971(VarCurr)
    <=> ( v137972(VarCurr)
        & v137974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6368,axiom,
    ! [VarCurr: state_type] :
      ( v137974(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85260(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18154,axiom,
    ! [VarCurr: state_type] :
      ( v137972(VarCurr)
    <=> ( v137483(VarCurr)
        | v137973(VarCurr) ) ) ).

tff(writeUnaryOperator_10274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137973(VarCurr)
    <=> v85260(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137956(VarCurr,B)
      <=> ( v137957(VarCurr,B)
          & v127570(VarCurr,B) ) ) ) ).

tff(addAssignment_77389,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,0)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77388,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,1)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77387,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,2)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77386,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,3)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77385,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,4)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77384,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,5)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77383,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,6)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77382,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,7)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77381,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,8)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77380,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,9)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77379,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,10)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77378,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,11)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77377,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,12)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77376,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,13)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77375,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,14)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77374,axiom,
    ! [VarCurr: state_type] :
      ( v137957(VarCurr,15)
    <=> v137958(VarCurr) ) ).

tff(addAssignment_77373,axiom,
    ! [VarCurr: state_type] :
      ( v137958(VarCurr)
    <=> v137959(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6367,axiom,
    ! [VarCurr: state_type] :
      ( v137959(VarCurr)
    <=> ( v84915(VarCurr,6)
        & v137918(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6366,axiom,
    ! [VarCurr: state_type] :
      ( v137918(VarCurr)
    <=> ( v137940(VarCurr)
        | v137954(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6365,axiom,
    ! [VarCurr: state_type] :
      ( v137940(VarCurr)
    <=> ( v137941(VarCurr)
        | v137954(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6364,axiom,
    ! [VarCurr: state_type] :
      ( v137941(VarCurr)
    <=> ( v137942(VarCurr)
        | v137954(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6363,axiom,
    ! [VarCurr: state_type] :
      ( v137942(VarCurr)
    <=> ( v137943(VarCurr)
        | v137954(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6362,axiom,
    ! [VarCurr: state_type] :
      ( v137943(VarCurr)
    <=> ( v137944(VarCurr)
        | v137954(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6361,axiom,
    ! [VarCurr: state_type] :
      ( v137944(VarCurr)
    <=> ( v137945(VarCurr)
        | v137954(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6360,axiom,
    ! [VarCurr: state_type] :
      ( v137945(VarCurr)
    <=> ( v137946(VarCurr)
        | v137954(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6359,axiom,
    ! [VarCurr: state_type] :
      ( v137946(VarCurr)
    <=> ( v137947(VarCurr)
        | v137954(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6358,axiom,
    ! [VarCurr: state_type] :
      ( v137947(VarCurr)
    <=> ( v137948(VarCurr)
        | v137954(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6357,axiom,
    ! [VarCurr: state_type] :
      ( v137948(VarCurr)
    <=> ( v137949(VarCurr)
        | v137954(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6356,axiom,
    ! [VarCurr: state_type] :
      ( v137949(VarCurr)
    <=> ( v137950(VarCurr)
        | v137954(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6355,axiom,
    ! [VarCurr: state_type] :
      ( v137950(VarCurr)
    <=> ( v137951(VarCurr)
        | v137954(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6354,axiom,
    ! [VarCurr: state_type] :
      ( v137951(VarCurr)
    <=> ( v137952(VarCurr)
        | v137954(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6353,axiom,
    ! [VarCurr: state_type] :
      ( v137952(VarCurr)
    <=> ( v137953(VarCurr)
        | v137954(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6352,axiom,
    ! [VarCurr: state_type] :
      ( v137953(VarCurr)
    <=> ( v137954(VarCurr,0)
        | v137954(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137954(VarCurr,B)
      <=> ( v137920(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77372,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,0)
    <=> v137937(VarCurr) ) ).

tff(addAssignment_77371,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,1)
    <=> v137936(VarCurr) ) ).

tff(addAssignment_77370,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,2)
    <=> v137935(VarCurr) ) ).

tff(addAssignment_77369,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,3)
    <=> v137934(VarCurr) ) ).

tff(addAssignment_77368,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,4)
    <=> v137933(VarCurr) ) ).

tff(addAssignment_77367,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,5)
    <=> v137932(VarCurr) ) ).

tff(addAssignment_77366,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,6)
    <=> v137931(VarCurr) ) ).

tff(addAssignment_77365,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,7)
    <=> v137930(VarCurr) ) ).

tff(addAssignment_77364,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,8)
    <=> v137929(VarCurr) ) ).

tff(addAssignment_77363,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,9)
    <=> v137928(VarCurr) ) ).

tff(addAssignment_77362,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,10)
    <=> v137927(VarCurr) ) ).

tff(addAssignment_77361,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,11)
    <=> v137926(VarCurr) ) ).

tff(addAssignment_77360,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,12)
    <=> v137925(VarCurr) ) ).

tff(addAssignment_77359,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,13)
    <=> v137924(VarCurr) ) ).

tff(addAssignment_77358,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,14)
    <=> v137923(VarCurr) ) ).

tff(addAssignment_77357,axiom,
    ! [VarCurr: state_type] :
      ( v137920(VarCurr,15)
    <=> v137922(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1902,axiom,
    ! [VarCurr: state_type] :
      ( v137937(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1901,axiom,
    ! [VarCurr: state_type] :
      ( v137936(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1900,axiom,
    ! [VarCurr: state_type] :
      ( v137935(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1899,axiom,
    ! [VarCurr: state_type] :
      ( v137934(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1898,axiom,
    ! [VarCurr: state_type] :
      ( v137933(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1897,axiom,
    ! [VarCurr: state_type] :
      ( v137932(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1896,axiom,
    ! [VarCurr: state_type] :
      ( v137931(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1895,axiom,
    ! [VarCurr: state_type] :
      ( v137930(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $false )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1894,axiom,
    ! [VarCurr: state_type] :
      ( v137929(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1893,axiom,
    ! [VarCurr: state_type] :
      ( v137928(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1892,axiom,
    ! [VarCurr: state_type] :
      ( v137927(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1891,axiom,
    ! [VarCurr: state_type] :
      ( v137926(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $false )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1890,axiom,
    ! [VarCurr: state_type] :
      ( v137925(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1889,axiom,
    ! [VarCurr: state_type] :
      ( v137924(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $false )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1888,axiom,
    ! [VarCurr: state_type] :
      ( v137923(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1887,axiom,
    ! [VarCurr: state_type] :
      ( v137922(VarCurr)
    <=> ( ( v85260(VarCurr,6)
        <=> $true )
        & ( v85260(VarCurr,5)
        <=> $true )
        & ( v85260(VarCurr,4)
        <=> $true )
        & ( v85260(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137831(VarCurr,B)
      <=> v137833(VarCurr,B) ) ) ).

tff(addAssignment_77355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137833(VarCurr,B)
      <=> v137835(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137835(VarCurr,B)
      <=> ( v137875(VarCurr,B)
          & v137879(VarCurr,B) ) ) ) ).

tff(addAssignment_77354,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,0)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77353,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,1)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77352,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,2)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77351,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,3)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77350,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,4)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77349,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,5)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77348,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,6)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77347,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,7)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77346,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,8)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77345,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,9)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77344,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,10)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77343,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,11)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77342,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,12)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77341,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,13)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77340,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,14)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77339,axiom,
    ! [VarCurr: state_type] :
      ( v137879(VarCurr,15)
    <=> v137880(VarCurr) ) ).

tff(addAssignment_77338,axiom,
    ! [VarCurr: state_type] :
      ( v137880(VarCurr)
    <=> v137881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18153,axiom,
    ! [VarCurr: state_type] :
      ( v137881(VarCurr)
    <=> ( v137882(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18152,axiom,
    ! [VarCurr: state_type] :
      ( v137882(VarCurr)
    <=> ( v137883(VarCurr)
        & v137910(VarCurr) ) ) ).

tff(writeUnaryOperator_10273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137910(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18151,axiom,
    ! [VarCurr: state_type] :
      ( v137883(VarCurr)
    <=> ( v137884(VarCurr)
        & v137909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18150,axiom,
    ! [VarCurr: state_type] :
      ( v137909(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137884(VarCurr)
    <=> v137886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18149,axiom,
    ! [VarCurr: state_type] :
      ( v137886(VarCurr)
    <=> ( v137887(VarCurr)
        & v137904(VarCurr) ) ) ).

tff(writeUnaryOperator_10271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137904(VarCurr)
    <=> v137905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18148,axiom,
    ! [VarCurr: state_type] :
      ( v137905(VarCurr)
    <=> ( v137906(VarCurr)
        & v137908(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6351,axiom,
    ! [VarCurr: state_type] :
      ( v137908(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85238(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18147,axiom,
    ! [VarCurr: state_type] :
      ( v137906(VarCurr)
    <=> ( v137501(VarCurr)
        | v137907(VarCurr) ) ) ).

tff(writeUnaryOperator_10270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137907(VarCurr)
    <=> v85238(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18146,axiom,
    ! [VarCurr: state_type] :
      ( v137887(VarCurr)
    <=> ( v137888(VarCurr)
        & v137899(VarCurr) ) ) ).

tff(writeUnaryOperator_10269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137899(VarCurr)
    <=> v137900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18145,axiom,
    ! [VarCurr: state_type] :
      ( v137900(VarCurr)
    <=> ( v137901(VarCurr)
        & v137903(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6350,axiom,
    ! [VarCurr: state_type] :
      ( v137903(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85238(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18144,axiom,
    ! [VarCurr: state_type] :
      ( v137901(VarCurr)
    <=> ( v137495(VarCurr)
        | v137902(VarCurr) ) ) ).

tff(writeUnaryOperator_10268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137902(VarCurr)
    <=> v85238(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18143,axiom,
    ! [VarCurr: state_type] :
      ( v137888(VarCurr)
    <=> ( v137889(VarCurr)
        & v137894(VarCurr) ) ) ).

tff(writeUnaryOperator_10267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137894(VarCurr)
    <=> v137895(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18142,axiom,
    ! [VarCurr: state_type] :
      ( v137895(VarCurr)
    <=> ( v137896(VarCurr)
        & v137898(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6349,axiom,
    ! [VarCurr: state_type] :
      ( v137898(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85238(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18141,axiom,
    ! [VarCurr: state_type] :
      ( v137896(VarCurr)
    <=> ( v137489(VarCurr)
        | v137897(VarCurr) ) ) ).

tff(writeUnaryOperator_10266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137897(VarCurr)
    <=> v85238(VarCurr,4) ) ).

tff(writeUnaryOperator_10265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137889(VarCurr)
    <=> v137890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18140,axiom,
    ! [VarCurr: state_type] :
      ( v137890(VarCurr)
    <=> ( v137891(VarCurr)
        & v137893(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6348,axiom,
    ! [VarCurr: state_type] :
      ( v137893(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85238(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18139,axiom,
    ! [VarCurr: state_type] :
      ( v137891(VarCurr)
    <=> ( v137483(VarCurr)
        | v137892(VarCurr) ) ) ).

tff(writeUnaryOperator_10264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137892(VarCurr)
    <=> v85238(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1883,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137875(VarCurr,B)
      <=> ( v137876(VarCurr,B)
          & v127545(VarCurr,B) ) ) ) ).

tff(addAssignment_77337,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,0)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77336,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,1)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77335,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,2)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77334,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,3)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77333,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,4)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77332,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,5)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77331,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,6)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77330,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,7)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77329,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,8)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77328,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,9)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77327,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,10)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77326,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,11)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77325,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,12)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77324,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,13)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77323,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,14)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77322,axiom,
    ! [VarCurr: state_type] :
      ( v137876(VarCurr,15)
    <=> v137877(VarCurr) ) ).

tff(addAssignment_77321,axiom,
    ! [VarCurr: state_type] :
      ( v137877(VarCurr)
    <=> v137878(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6347,axiom,
    ! [VarCurr: state_type] :
      ( v137878(VarCurr)
    <=> ( v84915(VarCurr,5)
        & v137837(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6346,axiom,
    ! [VarCurr: state_type] :
      ( v137837(VarCurr)
    <=> ( v137859(VarCurr)
        | v137873(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6345,axiom,
    ! [VarCurr: state_type] :
      ( v137859(VarCurr)
    <=> ( v137860(VarCurr)
        | v137873(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6344,axiom,
    ! [VarCurr: state_type] :
      ( v137860(VarCurr)
    <=> ( v137861(VarCurr)
        | v137873(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6343,axiom,
    ! [VarCurr: state_type] :
      ( v137861(VarCurr)
    <=> ( v137862(VarCurr)
        | v137873(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6342,axiom,
    ! [VarCurr: state_type] :
      ( v137862(VarCurr)
    <=> ( v137863(VarCurr)
        | v137873(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6341,axiom,
    ! [VarCurr: state_type] :
      ( v137863(VarCurr)
    <=> ( v137864(VarCurr)
        | v137873(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6340,axiom,
    ! [VarCurr: state_type] :
      ( v137864(VarCurr)
    <=> ( v137865(VarCurr)
        | v137873(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6339,axiom,
    ! [VarCurr: state_type] :
      ( v137865(VarCurr)
    <=> ( v137866(VarCurr)
        | v137873(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6338,axiom,
    ! [VarCurr: state_type] :
      ( v137866(VarCurr)
    <=> ( v137867(VarCurr)
        | v137873(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6337,axiom,
    ! [VarCurr: state_type] :
      ( v137867(VarCurr)
    <=> ( v137868(VarCurr)
        | v137873(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6336,axiom,
    ! [VarCurr: state_type] :
      ( v137868(VarCurr)
    <=> ( v137869(VarCurr)
        | v137873(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6335,axiom,
    ! [VarCurr: state_type] :
      ( v137869(VarCurr)
    <=> ( v137870(VarCurr)
        | v137873(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6334,axiom,
    ! [VarCurr: state_type] :
      ( v137870(VarCurr)
    <=> ( v137871(VarCurr)
        | v137873(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6333,axiom,
    ! [VarCurr: state_type] :
      ( v137871(VarCurr)
    <=> ( v137872(VarCurr)
        | v137873(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6332,axiom,
    ! [VarCurr: state_type] :
      ( v137872(VarCurr)
    <=> ( v137873(VarCurr,0)
        | v137873(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137873(VarCurr,B)
      <=> ( v137839(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77320,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,0)
    <=> v137856(VarCurr) ) ).

tff(addAssignment_77319,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,1)
    <=> v137855(VarCurr) ) ).

tff(addAssignment_77318,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,2)
    <=> v137854(VarCurr) ) ).

tff(addAssignment_77317,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,3)
    <=> v137853(VarCurr) ) ).

tff(addAssignment_77316,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,4)
    <=> v137852(VarCurr) ) ).

tff(addAssignment_77315,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,5)
    <=> v137851(VarCurr) ) ).

tff(addAssignment_77314,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,6)
    <=> v137850(VarCurr) ) ).

tff(addAssignment_77313,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,7)
    <=> v137849(VarCurr) ) ).

tff(addAssignment_77312,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,8)
    <=> v137848(VarCurr) ) ).

tff(addAssignment_77311,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,9)
    <=> v137847(VarCurr) ) ).

tff(addAssignment_77310,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,10)
    <=> v137846(VarCurr) ) ).

tff(addAssignment_77309,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,11)
    <=> v137845(VarCurr) ) ).

tff(addAssignment_77308,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,12)
    <=> v137844(VarCurr) ) ).

tff(addAssignment_77307,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,13)
    <=> v137843(VarCurr) ) ).

tff(addAssignment_77306,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,14)
    <=> v137842(VarCurr) ) ).

tff(addAssignment_77305,axiom,
    ! [VarCurr: state_type] :
      ( v137839(VarCurr,15)
    <=> v137841(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1886,axiom,
    ! [VarCurr: state_type] :
      ( v137856(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1885,axiom,
    ! [VarCurr: state_type] :
      ( v137855(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1884,axiom,
    ! [VarCurr: state_type] :
      ( v137854(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1883,axiom,
    ! [VarCurr: state_type] :
      ( v137853(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1882,axiom,
    ! [VarCurr: state_type] :
      ( v137852(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1881,axiom,
    ! [VarCurr: state_type] :
      ( v137851(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1880,axiom,
    ! [VarCurr: state_type] :
      ( v137850(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1879,axiom,
    ! [VarCurr: state_type] :
      ( v137849(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $false )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1878,axiom,
    ! [VarCurr: state_type] :
      ( v137848(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1877,axiom,
    ! [VarCurr: state_type] :
      ( v137847(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1876,axiom,
    ! [VarCurr: state_type] :
      ( v137846(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1875,axiom,
    ! [VarCurr: state_type] :
      ( v137845(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $false )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1874,axiom,
    ! [VarCurr: state_type] :
      ( v137844(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1873,axiom,
    ! [VarCurr: state_type] :
      ( v137843(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $false )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1872,axiom,
    ! [VarCurr: state_type] :
      ( v137842(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1871,axiom,
    ! [VarCurr: state_type] :
      ( v137841(VarCurr)
    <=> ( ( v85238(VarCurr,6)
        <=> $true )
        & ( v85238(VarCurr,5)
        <=> $true )
        & ( v85238(VarCurr,4)
        <=> $true )
        & ( v85238(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137750(VarCurr,B)
      <=> v137752(VarCurr,B) ) ) ).

tff(addAssignment_77303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137752(VarCurr,B)
      <=> v137754(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137754(VarCurr,B)
      <=> ( v137794(VarCurr,B)
          & v137798(VarCurr,B) ) ) ) ).

tff(addAssignment_77302,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,0)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77301,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,1)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77300,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,2)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77299,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,3)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77298,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,4)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77297,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,5)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77296,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,6)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77295,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,7)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77294,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,8)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77293,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,9)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77292,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,10)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77291,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,11)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77290,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,12)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77289,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,13)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77288,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,14)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77287,axiom,
    ! [VarCurr: state_type] :
      ( v137798(VarCurr,15)
    <=> v137799(VarCurr) ) ).

tff(addAssignment_77286,axiom,
    ! [VarCurr: state_type] :
      ( v137799(VarCurr)
    <=> v137800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18138,axiom,
    ! [VarCurr: state_type] :
      ( v137800(VarCurr)
    <=> ( v137801(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18137,axiom,
    ! [VarCurr: state_type] :
      ( v137801(VarCurr)
    <=> ( v137802(VarCurr)
        & v137829(VarCurr) ) ) ).

tff(writeUnaryOperator_10263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137829(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18136,axiom,
    ! [VarCurr: state_type] :
      ( v137802(VarCurr)
    <=> ( v137803(VarCurr)
        & v137828(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18135,axiom,
    ! [VarCurr: state_type] :
      ( v137828(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137803(VarCurr)
    <=> v137805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18134,axiom,
    ! [VarCurr: state_type] :
      ( v137805(VarCurr)
    <=> ( v137806(VarCurr)
        & v137823(VarCurr) ) ) ).

tff(writeUnaryOperator_10261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137823(VarCurr)
    <=> v137824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18133,axiom,
    ! [VarCurr: state_type] :
      ( v137824(VarCurr)
    <=> ( v137825(VarCurr)
        & v137827(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6331,axiom,
    ! [VarCurr: state_type] :
      ( v137827(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85216(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18132,axiom,
    ! [VarCurr: state_type] :
      ( v137825(VarCurr)
    <=> ( v137501(VarCurr)
        | v137826(VarCurr) ) ) ).

tff(writeUnaryOperator_10260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137826(VarCurr)
    <=> v85216(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18131,axiom,
    ! [VarCurr: state_type] :
      ( v137806(VarCurr)
    <=> ( v137807(VarCurr)
        & v137818(VarCurr) ) ) ).

tff(writeUnaryOperator_10259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137818(VarCurr)
    <=> v137819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18130,axiom,
    ! [VarCurr: state_type] :
      ( v137819(VarCurr)
    <=> ( v137820(VarCurr)
        & v137822(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6330,axiom,
    ! [VarCurr: state_type] :
      ( v137822(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85216(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18129,axiom,
    ! [VarCurr: state_type] :
      ( v137820(VarCurr)
    <=> ( v137495(VarCurr)
        | v137821(VarCurr) ) ) ).

tff(writeUnaryOperator_10258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137821(VarCurr)
    <=> v85216(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18128,axiom,
    ! [VarCurr: state_type] :
      ( v137807(VarCurr)
    <=> ( v137808(VarCurr)
        & v137813(VarCurr) ) ) ).

tff(writeUnaryOperator_10257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137813(VarCurr)
    <=> v137814(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18127,axiom,
    ! [VarCurr: state_type] :
      ( v137814(VarCurr)
    <=> ( v137815(VarCurr)
        & v137817(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6329,axiom,
    ! [VarCurr: state_type] :
      ( v137817(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85216(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18126,axiom,
    ! [VarCurr: state_type] :
      ( v137815(VarCurr)
    <=> ( v137489(VarCurr)
        | v137816(VarCurr) ) ) ).

tff(writeUnaryOperator_10256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137816(VarCurr)
    <=> v85216(VarCurr,4) ) ).

tff(writeUnaryOperator_10255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137808(VarCurr)
    <=> v137809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18125,axiom,
    ! [VarCurr: state_type] :
      ( v137809(VarCurr)
    <=> ( v137810(VarCurr)
        & v137812(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6328,axiom,
    ! [VarCurr: state_type] :
      ( v137812(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85216(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18124,axiom,
    ! [VarCurr: state_type] :
      ( v137810(VarCurr)
    <=> ( v137483(VarCurr)
        | v137811(VarCurr) ) ) ).

tff(writeUnaryOperator_10254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137811(VarCurr)
    <=> v85216(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137794(VarCurr,B)
      <=> ( v137795(VarCurr,B)
          & v127520(VarCurr,B) ) ) ) ).

tff(addAssignment_77285,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,0)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77284,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,1)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77283,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,2)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77282,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,3)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77281,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,4)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77280,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,5)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77279,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,6)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77278,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,7)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77277,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,8)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77276,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,9)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77275,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,10)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77274,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,11)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77273,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,12)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77272,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,13)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77271,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,14)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77270,axiom,
    ! [VarCurr: state_type] :
      ( v137795(VarCurr,15)
    <=> v137796(VarCurr) ) ).

tff(addAssignment_77269,axiom,
    ! [VarCurr: state_type] :
      ( v137796(VarCurr)
    <=> v137797(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6327,axiom,
    ! [VarCurr: state_type] :
      ( v137797(VarCurr)
    <=> ( v84915(VarCurr,4)
        & v137756(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6326,axiom,
    ! [VarCurr: state_type] :
      ( v137756(VarCurr)
    <=> ( v137778(VarCurr)
        | v137792(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6325,axiom,
    ! [VarCurr: state_type] :
      ( v137778(VarCurr)
    <=> ( v137779(VarCurr)
        | v137792(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6324,axiom,
    ! [VarCurr: state_type] :
      ( v137779(VarCurr)
    <=> ( v137780(VarCurr)
        | v137792(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6323,axiom,
    ! [VarCurr: state_type] :
      ( v137780(VarCurr)
    <=> ( v137781(VarCurr)
        | v137792(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6322,axiom,
    ! [VarCurr: state_type] :
      ( v137781(VarCurr)
    <=> ( v137782(VarCurr)
        | v137792(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6321,axiom,
    ! [VarCurr: state_type] :
      ( v137782(VarCurr)
    <=> ( v137783(VarCurr)
        | v137792(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6320,axiom,
    ! [VarCurr: state_type] :
      ( v137783(VarCurr)
    <=> ( v137784(VarCurr)
        | v137792(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6319,axiom,
    ! [VarCurr: state_type] :
      ( v137784(VarCurr)
    <=> ( v137785(VarCurr)
        | v137792(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6318,axiom,
    ! [VarCurr: state_type] :
      ( v137785(VarCurr)
    <=> ( v137786(VarCurr)
        | v137792(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6317,axiom,
    ! [VarCurr: state_type] :
      ( v137786(VarCurr)
    <=> ( v137787(VarCurr)
        | v137792(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6316,axiom,
    ! [VarCurr: state_type] :
      ( v137787(VarCurr)
    <=> ( v137788(VarCurr)
        | v137792(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6315,axiom,
    ! [VarCurr: state_type] :
      ( v137788(VarCurr)
    <=> ( v137789(VarCurr)
        | v137792(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6314,axiom,
    ! [VarCurr: state_type] :
      ( v137789(VarCurr)
    <=> ( v137790(VarCurr)
        | v137792(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6313,axiom,
    ! [VarCurr: state_type] :
      ( v137790(VarCurr)
    <=> ( v137791(VarCurr)
        | v137792(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6312,axiom,
    ! [VarCurr: state_type] :
      ( v137791(VarCurr)
    <=> ( v137792(VarCurr,0)
        | v137792(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137792(VarCurr,B)
      <=> ( v137758(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77268,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,0)
    <=> v137775(VarCurr) ) ).

tff(addAssignment_77267,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,1)
    <=> v137774(VarCurr) ) ).

tff(addAssignment_77266,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,2)
    <=> v137773(VarCurr) ) ).

tff(addAssignment_77265,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,3)
    <=> v137772(VarCurr) ) ).

tff(addAssignment_77264,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,4)
    <=> v137771(VarCurr) ) ).

tff(addAssignment_77263,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,5)
    <=> v137770(VarCurr) ) ).

tff(addAssignment_77262,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,6)
    <=> v137769(VarCurr) ) ).

tff(addAssignment_77261,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,7)
    <=> v137768(VarCurr) ) ).

tff(addAssignment_77260,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,8)
    <=> v137767(VarCurr) ) ).

tff(addAssignment_77259,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,9)
    <=> v137766(VarCurr) ) ).

tff(addAssignment_77258,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,10)
    <=> v137765(VarCurr) ) ).

tff(addAssignment_77257,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,11)
    <=> v137764(VarCurr) ) ).

tff(addAssignment_77256,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,12)
    <=> v137763(VarCurr) ) ).

tff(addAssignment_77255,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,13)
    <=> v137762(VarCurr) ) ).

tff(addAssignment_77254,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,14)
    <=> v137761(VarCurr) ) ).

tff(addAssignment_77253,axiom,
    ! [VarCurr: state_type] :
      ( v137758(VarCurr,15)
    <=> v137760(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1870,axiom,
    ! [VarCurr: state_type] :
      ( v137775(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1869,axiom,
    ! [VarCurr: state_type] :
      ( v137774(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1868,axiom,
    ! [VarCurr: state_type] :
      ( v137773(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1867,axiom,
    ! [VarCurr: state_type] :
      ( v137772(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1866,axiom,
    ! [VarCurr: state_type] :
      ( v137771(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1865,axiom,
    ! [VarCurr: state_type] :
      ( v137770(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1864,axiom,
    ! [VarCurr: state_type] :
      ( v137769(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1863,axiom,
    ! [VarCurr: state_type] :
      ( v137768(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $false )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1862,axiom,
    ! [VarCurr: state_type] :
      ( v137767(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1861,axiom,
    ! [VarCurr: state_type] :
      ( v137766(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1860,axiom,
    ! [VarCurr: state_type] :
      ( v137765(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1859,axiom,
    ! [VarCurr: state_type] :
      ( v137764(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $false )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1858,axiom,
    ! [VarCurr: state_type] :
      ( v137763(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1857,axiom,
    ! [VarCurr: state_type] :
      ( v137762(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $false )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1856,axiom,
    ! [VarCurr: state_type] :
      ( v137761(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1855,axiom,
    ! [VarCurr: state_type] :
      ( v137760(VarCurr)
    <=> ( ( v85216(VarCurr,6)
        <=> $true )
        & ( v85216(VarCurr,5)
        <=> $true )
        & ( v85216(VarCurr,4)
        <=> $true )
        & ( v85216(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137669(VarCurr,B)
      <=> v137671(VarCurr,B) ) ) ).

tff(addAssignment_77251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137671(VarCurr,B)
      <=> v137673(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137673(VarCurr,B)
      <=> ( v137713(VarCurr,B)
          & v137717(VarCurr,B) ) ) ) ).

tff(addAssignment_77250,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,0)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77249,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,1)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77248,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,2)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77247,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,3)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77246,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,4)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77245,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,5)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77244,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,6)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77243,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,7)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77242,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,8)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77241,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,9)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77240,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,10)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77239,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,11)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77238,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,12)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77237,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,13)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77236,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,14)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77235,axiom,
    ! [VarCurr: state_type] :
      ( v137717(VarCurr,15)
    <=> v137718(VarCurr) ) ).

tff(addAssignment_77234,axiom,
    ! [VarCurr: state_type] :
      ( v137718(VarCurr)
    <=> v137719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18123,axiom,
    ! [VarCurr: state_type] :
      ( v137719(VarCurr)
    <=> ( v137720(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18122,axiom,
    ! [VarCurr: state_type] :
      ( v137720(VarCurr)
    <=> ( v137721(VarCurr)
        & v137748(VarCurr) ) ) ).

tff(writeUnaryOperator_10253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137748(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18121,axiom,
    ! [VarCurr: state_type] :
      ( v137721(VarCurr)
    <=> ( v137722(VarCurr)
        & v137747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18120,axiom,
    ! [VarCurr: state_type] :
      ( v137747(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137722(VarCurr)
    <=> v137724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18119,axiom,
    ! [VarCurr: state_type] :
      ( v137724(VarCurr)
    <=> ( v137725(VarCurr)
        & v137742(VarCurr) ) ) ).

tff(writeUnaryOperator_10251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137742(VarCurr)
    <=> v137743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18118,axiom,
    ! [VarCurr: state_type] :
      ( v137743(VarCurr)
    <=> ( v137744(VarCurr)
        & v137746(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6311,axiom,
    ! [VarCurr: state_type] :
      ( v137746(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85194(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18117,axiom,
    ! [VarCurr: state_type] :
      ( v137744(VarCurr)
    <=> ( v137501(VarCurr)
        | v137745(VarCurr) ) ) ).

tff(writeUnaryOperator_10250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137745(VarCurr)
    <=> v85194(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18116,axiom,
    ! [VarCurr: state_type] :
      ( v137725(VarCurr)
    <=> ( v137726(VarCurr)
        & v137737(VarCurr) ) ) ).

tff(writeUnaryOperator_10249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137737(VarCurr)
    <=> v137738(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18115,axiom,
    ! [VarCurr: state_type] :
      ( v137738(VarCurr)
    <=> ( v137739(VarCurr)
        & v137741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6310,axiom,
    ! [VarCurr: state_type] :
      ( v137741(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85194(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18114,axiom,
    ! [VarCurr: state_type] :
      ( v137739(VarCurr)
    <=> ( v137495(VarCurr)
        | v137740(VarCurr) ) ) ).

tff(writeUnaryOperator_10248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137740(VarCurr)
    <=> v85194(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18113,axiom,
    ! [VarCurr: state_type] :
      ( v137726(VarCurr)
    <=> ( v137727(VarCurr)
        & v137732(VarCurr) ) ) ).

tff(writeUnaryOperator_10247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137732(VarCurr)
    <=> v137733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18112,axiom,
    ! [VarCurr: state_type] :
      ( v137733(VarCurr)
    <=> ( v137734(VarCurr)
        & v137736(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6309,axiom,
    ! [VarCurr: state_type] :
      ( v137736(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85194(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18111,axiom,
    ! [VarCurr: state_type] :
      ( v137734(VarCurr)
    <=> ( v137489(VarCurr)
        | v137735(VarCurr) ) ) ).

tff(writeUnaryOperator_10246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137735(VarCurr)
    <=> v85194(VarCurr,4) ) ).

tff(writeUnaryOperator_10245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137727(VarCurr)
    <=> v137728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18110,axiom,
    ! [VarCurr: state_type] :
      ( v137728(VarCurr)
    <=> ( v137729(VarCurr)
        & v137731(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6308,axiom,
    ! [VarCurr: state_type] :
      ( v137731(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85194(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18109,axiom,
    ! [VarCurr: state_type] :
      ( v137729(VarCurr)
    <=> ( v137483(VarCurr)
        | v137730(VarCurr) ) ) ).

tff(writeUnaryOperator_10244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137730(VarCurr)
    <=> v85194(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137713(VarCurr,B)
      <=> ( v137714(VarCurr,B)
          & v127495(VarCurr,B) ) ) ) ).

tff(addAssignment_77233,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,0)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77232,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,1)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77231,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,2)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77230,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,3)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77229,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,4)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77228,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,5)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77227,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,6)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77226,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,7)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77225,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,8)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77224,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,9)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77223,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,10)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77222,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,11)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77221,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,12)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77220,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,13)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77219,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,14)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77218,axiom,
    ! [VarCurr: state_type] :
      ( v137714(VarCurr,15)
    <=> v137715(VarCurr) ) ).

tff(addAssignment_77217,axiom,
    ! [VarCurr: state_type] :
      ( v137715(VarCurr)
    <=> v137716(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6307,axiom,
    ! [VarCurr: state_type] :
      ( v137716(VarCurr)
    <=> ( v84915(VarCurr,3)
        & v137675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6306,axiom,
    ! [VarCurr: state_type] :
      ( v137675(VarCurr)
    <=> ( v137697(VarCurr)
        | v137711(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6305,axiom,
    ! [VarCurr: state_type] :
      ( v137697(VarCurr)
    <=> ( v137698(VarCurr)
        | v137711(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6304,axiom,
    ! [VarCurr: state_type] :
      ( v137698(VarCurr)
    <=> ( v137699(VarCurr)
        | v137711(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6303,axiom,
    ! [VarCurr: state_type] :
      ( v137699(VarCurr)
    <=> ( v137700(VarCurr)
        | v137711(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6302,axiom,
    ! [VarCurr: state_type] :
      ( v137700(VarCurr)
    <=> ( v137701(VarCurr)
        | v137711(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6301,axiom,
    ! [VarCurr: state_type] :
      ( v137701(VarCurr)
    <=> ( v137702(VarCurr)
        | v137711(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6300,axiom,
    ! [VarCurr: state_type] :
      ( v137702(VarCurr)
    <=> ( v137703(VarCurr)
        | v137711(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6299,axiom,
    ! [VarCurr: state_type] :
      ( v137703(VarCurr)
    <=> ( v137704(VarCurr)
        | v137711(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6298,axiom,
    ! [VarCurr: state_type] :
      ( v137704(VarCurr)
    <=> ( v137705(VarCurr)
        | v137711(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6297,axiom,
    ! [VarCurr: state_type] :
      ( v137705(VarCurr)
    <=> ( v137706(VarCurr)
        | v137711(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6296,axiom,
    ! [VarCurr: state_type] :
      ( v137706(VarCurr)
    <=> ( v137707(VarCurr)
        | v137711(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6295,axiom,
    ! [VarCurr: state_type] :
      ( v137707(VarCurr)
    <=> ( v137708(VarCurr)
        | v137711(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6294,axiom,
    ! [VarCurr: state_type] :
      ( v137708(VarCurr)
    <=> ( v137709(VarCurr)
        | v137711(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6293,axiom,
    ! [VarCurr: state_type] :
      ( v137709(VarCurr)
    <=> ( v137710(VarCurr)
        | v137711(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6292,axiom,
    ! [VarCurr: state_type] :
      ( v137710(VarCurr)
    <=> ( v137711(VarCurr,0)
        | v137711(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137711(VarCurr,B)
      <=> ( v137677(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77216,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,0)
    <=> v137694(VarCurr) ) ).

tff(addAssignment_77215,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,1)
    <=> v137693(VarCurr) ) ).

tff(addAssignment_77214,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,2)
    <=> v137692(VarCurr) ) ).

tff(addAssignment_77213,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,3)
    <=> v137691(VarCurr) ) ).

tff(addAssignment_77212,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,4)
    <=> v137690(VarCurr) ) ).

tff(addAssignment_77211,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,5)
    <=> v137689(VarCurr) ) ).

tff(addAssignment_77210,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,6)
    <=> v137688(VarCurr) ) ).

tff(addAssignment_77209,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,7)
    <=> v137687(VarCurr) ) ).

tff(addAssignment_77208,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,8)
    <=> v137686(VarCurr) ) ).

tff(addAssignment_77207,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,9)
    <=> v137685(VarCurr) ) ).

tff(addAssignment_77206,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,10)
    <=> v137684(VarCurr) ) ).

tff(addAssignment_77205,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,11)
    <=> v137683(VarCurr) ) ).

tff(addAssignment_77204,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,12)
    <=> v137682(VarCurr) ) ).

tff(addAssignment_77203,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,13)
    <=> v137681(VarCurr) ) ).

tff(addAssignment_77202,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,14)
    <=> v137680(VarCurr) ) ).

tff(addAssignment_77201,axiom,
    ! [VarCurr: state_type] :
      ( v137677(VarCurr,15)
    <=> v137679(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1854,axiom,
    ! [VarCurr: state_type] :
      ( v137694(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1853,axiom,
    ! [VarCurr: state_type] :
      ( v137693(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1852,axiom,
    ! [VarCurr: state_type] :
      ( v137692(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1851,axiom,
    ! [VarCurr: state_type] :
      ( v137691(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1850,axiom,
    ! [VarCurr: state_type] :
      ( v137690(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1849,axiom,
    ! [VarCurr: state_type] :
      ( v137689(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1848,axiom,
    ! [VarCurr: state_type] :
      ( v137688(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1847,axiom,
    ! [VarCurr: state_type] :
      ( v137687(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $false )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1846,axiom,
    ! [VarCurr: state_type] :
      ( v137686(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1845,axiom,
    ! [VarCurr: state_type] :
      ( v137685(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1844,axiom,
    ! [VarCurr: state_type] :
      ( v137684(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1843,axiom,
    ! [VarCurr: state_type] :
      ( v137683(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $false )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1842,axiom,
    ! [VarCurr: state_type] :
      ( v137682(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1841,axiom,
    ! [VarCurr: state_type] :
      ( v137681(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $false )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1840,axiom,
    ! [VarCurr: state_type] :
      ( v137680(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1839,axiom,
    ! [VarCurr: state_type] :
      ( v137679(VarCurr)
    <=> ( ( v85194(VarCurr,6)
        <=> $true )
        & ( v85194(VarCurr,5)
        <=> $true )
        & ( v85194(VarCurr,4)
        <=> $true )
        & ( v85194(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137588(VarCurr,B)
      <=> v137590(VarCurr,B) ) ) ).

tff(addAssignment_77199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137590(VarCurr,B)
      <=> v137592(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1875,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137592(VarCurr,B)
      <=> ( v137632(VarCurr,B)
          & v137636(VarCurr,B) ) ) ) ).

tff(addAssignment_77198,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,0)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77197,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,1)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77196,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,2)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77195,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,3)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77194,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,4)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77193,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,5)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77192,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,6)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77191,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,7)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77190,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,8)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77189,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,9)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77188,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,10)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77187,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,11)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77186,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,12)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77185,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,13)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77184,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,14)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77183,axiom,
    ! [VarCurr: state_type] :
      ( v137636(VarCurr,15)
    <=> v137637(VarCurr) ) ).

tff(addAssignment_77182,axiom,
    ! [VarCurr: state_type] :
      ( v137637(VarCurr)
    <=> v137638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18108,axiom,
    ! [VarCurr: state_type] :
      ( v137638(VarCurr)
    <=> ( v137639(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18107,axiom,
    ! [VarCurr: state_type] :
      ( v137639(VarCurr)
    <=> ( v137640(VarCurr)
        & v137667(VarCurr) ) ) ).

tff(writeUnaryOperator_10243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137667(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18106,axiom,
    ! [VarCurr: state_type] :
      ( v137640(VarCurr)
    <=> ( v137641(VarCurr)
        & v137666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18105,axiom,
    ! [VarCurr: state_type] :
      ( v137666(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137641(VarCurr)
    <=> v137643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18104,axiom,
    ! [VarCurr: state_type] :
      ( v137643(VarCurr)
    <=> ( v137644(VarCurr)
        & v137661(VarCurr) ) ) ).

tff(writeUnaryOperator_10241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137661(VarCurr)
    <=> v137662(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18103,axiom,
    ! [VarCurr: state_type] :
      ( v137662(VarCurr)
    <=> ( v137663(VarCurr)
        & v137665(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6291,axiom,
    ! [VarCurr: state_type] :
      ( v137665(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85172(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18102,axiom,
    ! [VarCurr: state_type] :
      ( v137663(VarCurr)
    <=> ( v137501(VarCurr)
        | v137664(VarCurr) ) ) ).

tff(writeUnaryOperator_10240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137664(VarCurr)
    <=> v85172(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18101,axiom,
    ! [VarCurr: state_type] :
      ( v137644(VarCurr)
    <=> ( v137645(VarCurr)
        & v137656(VarCurr) ) ) ).

tff(writeUnaryOperator_10239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137656(VarCurr)
    <=> v137657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18100,axiom,
    ! [VarCurr: state_type] :
      ( v137657(VarCurr)
    <=> ( v137658(VarCurr)
        & v137660(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6290,axiom,
    ! [VarCurr: state_type] :
      ( v137660(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85172(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18099,axiom,
    ! [VarCurr: state_type] :
      ( v137658(VarCurr)
    <=> ( v137495(VarCurr)
        | v137659(VarCurr) ) ) ).

tff(writeUnaryOperator_10238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137659(VarCurr)
    <=> v85172(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18098,axiom,
    ! [VarCurr: state_type] :
      ( v137645(VarCurr)
    <=> ( v137646(VarCurr)
        & v137651(VarCurr) ) ) ).

tff(writeUnaryOperator_10237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137651(VarCurr)
    <=> v137652(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18097,axiom,
    ! [VarCurr: state_type] :
      ( v137652(VarCurr)
    <=> ( v137653(VarCurr)
        & v137655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6289,axiom,
    ! [VarCurr: state_type] :
      ( v137655(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85172(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18096,axiom,
    ! [VarCurr: state_type] :
      ( v137653(VarCurr)
    <=> ( v137489(VarCurr)
        | v137654(VarCurr) ) ) ).

tff(writeUnaryOperator_10236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137654(VarCurr)
    <=> v85172(VarCurr,4) ) ).

tff(writeUnaryOperator_10235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137646(VarCurr)
    <=> v137647(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18095,axiom,
    ! [VarCurr: state_type] :
      ( v137647(VarCurr)
    <=> ( v137648(VarCurr)
        & v137650(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6288,axiom,
    ! [VarCurr: state_type] :
      ( v137650(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85172(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18094,axiom,
    ! [VarCurr: state_type] :
      ( v137648(VarCurr)
    <=> ( v137483(VarCurr)
        | v137649(VarCurr) ) ) ).

tff(writeUnaryOperator_10234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137649(VarCurr)
    <=> v85172(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137632(VarCurr,B)
      <=> ( v137633(VarCurr,B)
          & v127470(VarCurr,B) ) ) ) ).

tff(addAssignment_77181,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,0)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77180,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,1)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77179,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,2)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77178,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,3)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77177,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,4)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77176,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,5)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77175,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,6)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77174,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,7)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77173,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,8)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77172,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,9)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77171,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,10)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77170,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,11)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77169,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,12)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77168,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,13)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77167,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,14)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77166,axiom,
    ! [VarCurr: state_type] :
      ( v137633(VarCurr,15)
    <=> v137634(VarCurr) ) ).

tff(addAssignment_77165,axiom,
    ! [VarCurr: state_type] :
      ( v137634(VarCurr)
    <=> v137635(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6287,axiom,
    ! [VarCurr: state_type] :
      ( v137635(VarCurr)
    <=> ( v84915(VarCurr,2)
        & v137594(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6286,axiom,
    ! [VarCurr: state_type] :
      ( v137594(VarCurr)
    <=> ( v137616(VarCurr)
        | v137630(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6285,axiom,
    ! [VarCurr: state_type] :
      ( v137616(VarCurr)
    <=> ( v137617(VarCurr)
        | v137630(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6284,axiom,
    ! [VarCurr: state_type] :
      ( v137617(VarCurr)
    <=> ( v137618(VarCurr)
        | v137630(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6283,axiom,
    ! [VarCurr: state_type] :
      ( v137618(VarCurr)
    <=> ( v137619(VarCurr)
        | v137630(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6282,axiom,
    ! [VarCurr: state_type] :
      ( v137619(VarCurr)
    <=> ( v137620(VarCurr)
        | v137630(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6281,axiom,
    ! [VarCurr: state_type] :
      ( v137620(VarCurr)
    <=> ( v137621(VarCurr)
        | v137630(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6280,axiom,
    ! [VarCurr: state_type] :
      ( v137621(VarCurr)
    <=> ( v137622(VarCurr)
        | v137630(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6279,axiom,
    ! [VarCurr: state_type] :
      ( v137622(VarCurr)
    <=> ( v137623(VarCurr)
        | v137630(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6278,axiom,
    ! [VarCurr: state_type] :
      ( v137623(VarCurr)
    <=> ( v137624(VarCurr)
        | v137630(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6277,axiom,
    ! [VarCurr: state_type] :
      ( v137624(VarCurr)
    <=> ( v137625(VarCurr)
        | v137630(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6276,axiom,
    ! [VarCurr: state_type] :
      ( v137625(VarCurr)
    <=> ( v137626(VarCurr)
        | v137630(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6275,axiom,
    ! [VarCurr: state_type] :
      ( v137626(VarCurr)
    <=> ( v137627(VarCurr)
        | v137630(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6274,axiom,
    ! [VarCurr: state_type] :
      ( v137627(VarCurr)
    <=> ( v137628(VarCurr)
        | v137630(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6273,axiom,
    ! [VarCurr: state_type] :
      ( v137628(VarCurr)
    <=> ( v137629(VarCurr)
        | v137630(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6272,axiom,
    ! [VarCurr: state_type] :
      ( v137629(VarCurr)
    <=> ( v137630(VarCurr,0)
        | v137630(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137630(VarCurr,B)
      <=> ( v137596(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77164,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,0)
    <=> v137613(VarCurr) ) ).

tff(addAssignment_77163,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,1)
    <=> v137612(VarCurr) ) ).

tff(addAssignment_77162,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,2)
    <=> v137611(VarCurr) ) ).

tff(addAssignment_77161,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,3)
    <=> v137610(VarCurr) ) ).

tff(addAssignment_77160,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,4)
    <=> v137609(VarCurr) ) ).

tff(addAssignment_77159,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,5)
    <=> v137608(VarCurr) ) ).

tff(addAssignment_77158,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,6)
    <=> v137607(VarCurr) ) ).

tff(addAssignment_77157,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,7)
    <=> v137606(VarCurr) ) ).

tff(addAssignment_77156,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,8)
    <=> v137605(VarCurr) ) ).

tff(addAssignment_77155,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,9)
    <=> v137604(VarCurr) ) ).

tff(addAssignment_77154,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,10)
    <=> v137603(VarCurr) ) ).

tff(addAssignment_77153,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,11)
    <=> v137602(VarCurr) ) ).

tff(addAssignment_77152,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,12)
    <=> v137601(VarCurr) ) ).

tff(addAssignment_77151,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,13)
    <=> v137600(VarCurr) ) ).

tff(addAssignment_77150,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,14)
    <=> v137599(VarCurr) ) ).

tff(addAssignment_77149,axiom,
    ! [VarCurr: state_type] :
      ( v137596(VarCurr,15)
    <=> v137598(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1838,axiom,
    ! [VarCurr: state_type] :
      ( v137613(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1837,axiom,
    ! [VarCurr: state_type] :
      ( v137612(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1836,axiom,
    ! [VarCurr: state_type] :
      ( v137611(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1835,axiom,
    ! [VarCurr: state_type] :
      ( v137610(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1834,axiom,
    ! [VarCurr: state_type] :
      ( v137609(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1833,axiom,
    ! [VarCurr: state_type] :
      ( v137608(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1832,axiom,
    ! [VarCurr: state_type] :
      ( v137607(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1831,axiom,
    ! [VarCurr: state_type] :
      ( v137606(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $false )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1830,axiom,
    ! [VarCurr: state_type] :
      ( v137605(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1829,axiom,
    ! [VarCurr: state_type] :
      ( v137604(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1828,axiom,
    ! [VarCurr: state_type] :
      ( v137603(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1827,axiom,
    ! [VarCurr: state_type] :
      ( v137602(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $false )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1826,axiom,
    ! [VarCurr: state_type] :
      ( v137601(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1825,axiom,
    ! [VarCurr: state_type] :
      ( v137600(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $false )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1824,axiom,
    ! [VarCurr: state_type] :
      ( v137599(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1823,axiom,
    ! [VarCurr: state_type] :
      ( v137598(VarCurr)
    <=> ( ( v85172(VarCurr,6)
        <=> $true )
        & ( v85172(VarCurr,5)
        <=> $true )
        & ( v85172(VarCurr,4)
        <=> $true )
        & ( v85172(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137507(VarCurr,B)
      <=> v137509(VarCurr,B) ) ) ).

tff(addAssignment_77147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137509(VarCurr,B)
      <=> v137511(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137511(VarCurr,B)
      <=> ( v137551(VarCurr,B)
          & v137555(VarCurr,B) ) ) ) ).

tff(addAssignment_77146,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,0)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77145,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,1)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77144,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,2)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77143,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,3)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77142,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,4)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77141,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,5)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77140,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,6)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77139,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,7)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77138,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,8)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77137,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,9)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77136,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,10)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77135,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,11)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77134,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,12)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77133,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,13)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77132,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,14)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77131,axiom,
    ! [VarCurr: state_type] :
      ( v137555(VarCurr,15)
    <=> v137556(VarCurr) ) ).

tff(addAssignment_77130,axiom,
    ! [VarCurr: state_type] :
      ( v137556(VarCurr)
    <=> v137557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18093,axiom,
    ! [VarCurr: state_type] :
      ( v137557(VarCurr)
    <=> ( v137558(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18092,axiom,
    ! [VarCurr: state_type] :
      ( v137558(VarCurr)
    <=> ( v137559(VarCurr)
        & v137586(VarCurr) ) ) ).

tff(writeUnaryOperator_10233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137586(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18091,axiom,
    ! [VarCurr: state_type] :
      ( v137559(VarCurr)
    <=> ( v137560(VarCurr)
        & v137585(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18090,axiom,
    ! [VarCurr: state_type] :
      ( v137585(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137560(VarCurr)
    <=> v137562(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18089,axiom,
    ! [VarCurr: state_type] :
      ( v137562(VarCurr)
    <=> ( v137563(VarCurr)
        & v137580(VarCurr) ) ) ).

tff(writeUnaryOperator_10231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137580(VarCurr)
    <=> v137581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18088,axiom,
    ! [VarCurr: state_type] :
      ( v137581(VarCurr)
    <=> ( v137582(VarCurr)
        & v137584(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6271,axiom,
    ! [VarCurr: state_type] :
      ( v137584(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85150(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18087,axiom,
    ! [VarCurr: state_type] :
      ( v137582(VarCurr)
    <=> ( v137501(VarCurr)
        | v137583(VarCurr) ) ) ).

tff(writeUnaryOperator_10230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137583(VarCurr)
    <=> v85150(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18086,axiom,
    ! [VarCurr: state_type] :
      ( v137563(VarCurr)
    <=> ( v137564(VarCurr)
        & v137575(VarCurr) ) ) ).

tff(writeUnaryOperator_10229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137575(VarCurr)
    <=> v137576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18085,axiom,
    ! [VarCurr: state_type] :
      ( v137576(VarCurr)
    <=> ( v137577(VarCurr)
        & v137579(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6270,axiom,
    ! [VarCurr: state_type] :
      ( v137579(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85150(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18084,axiom,
    ! [VarCurr: state_type] :
      ( v137577(VarCurr)
    <=> ( v137495(VarCurr)
        | v137578(VarCurr) ) ) ).

tff(writeUnaryOperator_10228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137578(VarCurr)
    <=> v85150(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18083,axiom,
    ! [VarCurr: state_type] :
      ( v137564(VarCurr)
    <=> ( v137565(VarCurr)
        & v137570(VarCurr) ) ) ).

tff(writeUnaryOperator_10227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137570(VarCurr)
    <=> v137571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18082,axiom,
    ! [VarCurr: state_type] :
      ( v137571(VarCurr)
    <=> ( v137572(VarCurr)
        & v137574(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6269,axiom,
    ! [VarCurr: state_type] :
      ( v137574(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85150(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18081,axiom,
    ! [VarCurr: state_type] :
      ( v137572(VarCurr)
    <=> ( v137489(VarCurr)
        | v137573(VarCurr) ) ) ).

tff(writeUnaryOperator_10226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137573(VarCurr)
    <=> v85150(VarCurr,4) ) ).

tff(writeUnaryOperator_10225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137565(VarCurr)
    <=> v137566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18080,axiom,
    ! [VarCurr: state_type] :
      ( v137566(VarCurr)
    <=> ( v137567(VarCurr)
        & v137569(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6268,axiom,
    ! [VarCurr: state_type] :
      ( v137569(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85150(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18079,axiom,
    ! [VarCurr: state_type] :
      ( v137567(VarCurr)
    <=> ( v137483(VarCurr)
        | v137568(VarCurr) ) ) ).

tff(writeUnaryOperator_10224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137568(VarCurr)
    <=> v85150(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137551(VarCurr,B)
      <=> ( v137552(VarCurr,B)
          & v127445(VarCurr,B) ) ) ) ).

tff(addAssignment_77129,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,0)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77128,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,1)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77127,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,2)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77126,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,3)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77125,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,4)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77124,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,5)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77123,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,6)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77122,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,7)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77121,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,8)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77120,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,9)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77119,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,10)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77118,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,11)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77117,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,12)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77116,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,13)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77115,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,14)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77114,axiom,
    ! [VarCurr: state_type] :
      ( v137552(VarCurr,15)
    <=> v137553(VarCurr) ) ).

tff(addAssignment_77113,axiom,
    ! [VarCurr: state_type] :
      ( v137553(VarCurr)
    <=> v137554(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6267,axiom,
    ! [VarCurr: state_type] :
      ( v137554(VarCurr)
    <=> ( v84915(VarCurr,1)
        & v137513(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6266,axiom,
    ! [VarCurr: state_type] :
      ( v137513(VarCurr)
    <=> ( v137535(VarCurr)
        | v137549(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6265,axiom,
    ! [VarCurr: state_type] :
      ( v137535(VarCurr)
    <=> ( v137536(VarCurr)
        | v137549(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6264,axiom,
    ! [VarCurr: state_type] :
      ( v137536(VarCurr)
    <=> ( v137537(VarCurr)
        | v137549(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6263,axiom,
    ! [VarCurr: state_type] :
      ( v137537(VarCurr)
    <=> ( v137538(VarCurr)
        | v137549(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6262,axiom,
    ! [VarCurr: state_type] :
      ( v137538(VarCurr)
    <=> ( v137539(VarCurr)
        | v137549(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6261,axiom,
    ! [VarCurr: state_type] :
      ( v137539(VarCurr)
    <=> ( v137540(VarCurr)
        | v137549(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6260,axiom,
    ! [VarCurr: state_type] :
      ( v137540(VarCurr)
    <=> ( v137541(VarCurr)
        | v137549(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6259,axiom,
    ! [VarCurr: state_type] :
      ( v137541(VarCurr)
    <=> ( v137542(VarCurr)
        | v137549(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6258,axiom,
    ! [VarCurr: state_type] :
      ( v137542(VarCurr)
    <=> ( v137543(VarCurr)
        | v137549(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6257,axiom,
    ! [VarCurr: state_type] :
      ( v137543(VarCurr)
    <=> ( v137544(VarCurr)
        | v137549(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6256,axiom,
    ! [VarCurr: state_type] :
      ( v137544(VarCurr)
    <=> ( v137545(VarCurr)
        | v137549(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6255,axiom,
    ! [VarCurr: state_type] :
      ( v137545(VarCurr)
    <=> ( v137546(VarCurr)
        | v137549(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6254,axiom,
    ! [VarCurr: state_type] :
      ( v137546(VarCurr)
    <=> ( v137547(VarCurr)
        | v137549(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6253,axiom,
    ! [VarCurr: state_type] :
      ( v137547(VarCurr)
    <=> ( v137548(VarCurr)
        | v137549(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6252,axiom,
    ! [VarCurr: state_type] :
      ( v137548(VarCurr)
    <=> ( v137549(VarCurr,0)
        | v137549(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1870,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137549(VarCurr,B)
      <=> ( v137515(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(addAssignment_77112,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,0)
    <=> v137532(VarCurr) ) ).

tff(addAssignment_77111,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,1)
    <=> v137531(VarCurr) ) ).

tff(addAssignment_77110,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,2)
    <=> v137530(VarCurr) ) ).

tff(addAssignment_77109,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,3)
    <=> v137529(VarCurr) ) ).

tff(addAssignment_77108,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,4)
    <=> v137528(VarCurr) ) ).

tff(addAssignment_77107,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,5)
    <=> v137527(VarCurr) ) ).

tff(addAssignment_77106,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,6)
    <=> v137526(VarCurr) ) ).

tff(addAssignment_77105,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,7)
    <=> v137525(VarCurr) ) ).

tff(addAssignment_77104,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,8)
    <=> v137524(VarCurr) ) ).

tff(addAssignment_77103,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,9)
    <=> v137523(VarCurr) ) ).

tff(addAssignment_77102,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,10)
    <=> v137522(VarCurr) ) ).

tff(addAssignment_77101,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,11)
    <=> v137521(VarCurr) ) ).

tff(addAssignment_77100,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,12)
    <=> v137520(VarCurr) ) ).

tff(addAssignment_77099,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,13)
    <=> v137519(VarCurr) ) ).

tff(addAssignment_77098,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,14)
    <=> v137518(VarCurr) ) ).

tff(addAssignment_77097,axiom,
    ! [VarCurr: state_type] :
      ( v137515(VarCurr,15)
    <=> v137517(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1822,axiom,
    ! [VarCurr: state_type] :
      ( v137532(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1821,axiom,
    ! [VarCurr: state_type] :
      ( v137531(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1820,axiom,
    ! [VarCurr: state_type] :
      ( v137530(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1819,axiom,
    ! [VarCurr: state_type] :
      ( v137529(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1818,axiom,
    ! [VarCurr: state_type] :
      ( v137528(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1817,axiom,
    ! [VarCurr: state_type] :
      ( v137527(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1816,axiom,
    ! [VarCurr: state_type] :
      ( v137526(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1815,axiom,
    ! [VarCurr: state_type] :
      ( v137525(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $false )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1814,axiom,
    ! [VarCurr: state_type] :
      ( v137524(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1813,axiom,
    ! [VarCurr: state_type] :
      ( v137523(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1812,axiom,
    ! [VarCurr: state_type] :
      ( v137522(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1811,axiom,
    ! [VarCurr: state_type] :
      ( v137521(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $false )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1810,axiom,
    ! [VarCurr: state_type] :
      ( v137520(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1809,axiom,
    ! [VarCurr: state_type] :
      ( v137519(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $false )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1808,axiom,
    ! [VarCurr: state_type] :
      ( v137518(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1807,axiom,
    ! [VarCurr: state_type] :
      ( v137517(VarCurr)
    <=> ( ( v85150(VarCurr,6)
        <=> $true )
        & ( v85150(VarCurr,5)
        <=> $true )
        & ( v85150(VarCurr,4)
        <=> $true )
        & ( v85150(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_77096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v84909(VarCurr,B)
      <=> v84911(VarCurr,B) ) ) ).

tff(addAssignment_77095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v84911(VarCurr,B)
      <=> v84913(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v84913(VarCurr,B)
      <=> ( v137466(VarCurr,B)
          & v137470(VarCurr,B) ) ) ) ).

tff(addAssignment_77094,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,0)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77093,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,1)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77092,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,2)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77091,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,3)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77090,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,4)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77089,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,5)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77088,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,6)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77087,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,7)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77086,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,8)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77085,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,9)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77084,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,10)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77083,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,11)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77082,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,12)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77081,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,13)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77080,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,14)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77079,axiom,
    ! [VarCurr: state_type] :
      ( v137470(VarCurr,15)
    <=> v137471(VarCurr) ) ).

tff(addAssignment_77078,axiom,
    ! [VarCurr: state_type] :
      ( v137471(VarCurr)
    <=> v137472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18078,axiom,
    ! [VarCurr: state_type] :
      ( v137472(VarCurr)
    <=> ( v137473(VarCurr)
        | v137464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18077,axiom,
    ! [VarCurr: state_type] :
      ( v137473(VarCurr)
    <=> ( v137474(VarCurr)
        & v137505(VarCurr) ) ) ).

tff(writeUnaryOperator_10223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137505(VarCurr)
    <=> v137462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18076,axiom,
    ! [VarCurr: state_type] :
      ( v137474(VarCurr)
    <=> ( v137475(VarCurr)
        & v137504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18075,axiom,
    ! [VarCurr: state_type] :
      ( v137504(VarCurr)
    <=> ( v137458(VarCurr)
        | v137460(VarCurr) ) ) ).

tff(writeUnaryOperator_10222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137475(VarCurr)
    <=> v137477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18074,axiom,
    ! [VarCurr: state_type] :
      ( v137477(VarCurr)
    <=> ( v137478(VarCurr)
        & v137498(VarCurr) ) ) ).

tff(writeUnaryOperator_10221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137498(VarCurr)
    <=> v137499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18073,axiom,
    ! [VarCurr: state_type] :
      ( v137499(VarCurr)
    <=> ( v137500(VarCurr)
        & v137503(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6251,axiom,
    ! [VarCurr: state_type] :
      ( v137503(VarCurr)
    <=> ( v137456(VarCurr,3)
        | v85128(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18072,axiom,
    ! [VarCurr: state_type] :
      ( v137500(VarCurr)
    <=> ( v137501(VarCurr)
        | v137502(VarCurr) ) ) ).

tff(writeUnaryOperator_10220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137502(VarCurr)
    <=> v85128(VarCurr,6) ) ).

tff(writeUnaryOperator_10219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137501(VarCurr)
    <=> v137456(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18071,axiom,
    ! [VarCurr: state_type] :
      ( v137478(VarCurr)
    <=> ( v137479(VarCurr)
        & v137492(VarCurr) ) ) ).

tff(writeUnaryOperator_10218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137492(VarCurr)
    <=> v137493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18070,axiom,
    ! [VarCurr: state_type] :
      ( v137493(VarCurr)
    <=> ( v137494(VarCurr)
        & v137497(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6250,axiom,
    ! [VarCurr: state_type] :
      ( v137497(VarCurr)
    <=> ( v137456(VarCurr,2)
        | v85128(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18069,axiom,
    ! [VarCurr: state_type] :
      ( v137494(VarCurr)
    <=> ( v137495(VarCurr)
        | v137496(VarCurr) ) ) ).

tff(writeUnaryOperator_10217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137496(VarCurr)
    <=> v85128(VarCurr,5) ) ).

tff(writeUnaryOperator_10216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137495(VarCurr)
    <=> v137456(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18068,axiom,
    ! [VarCurr: state_type] :
      ( v137479(VarCurr)
    <=> ( v137480(VarCurr)
        & v137486(VarCurr) ) ) ).

tff(writeUnaryOperator_10215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137486(VarCurr)
    <=> v137487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18067,axiom,
    ! [VarCurr: state_type] :
      ( v137487(VarCurr)
    <=> ( v137488(VarCurr)
        & v137491(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6249,axiom,
    ! [VarCurr: state_type] :
      ( v137491(VarCurr)
    <=> ( v137456(VarCurr,1)
        | v85128(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18066,axiom,
    ! [VarCurr: state_type] :
      ( v137488(VarCurr)
    <=> ( v137489(VarCurr)
        | v137490(VarCurr) ) ) ).

tff(writeUnaryOperator_10214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137490(VarCurr)
    <=> v85128(VarCurr,4) ) ).

tff(writeUnaryOperator_10213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137489(VarCurr)
    <=> v137456(VarCurr,1) ) ).

tff(writeUnaryOperator_10212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137480(VarCurr)
    <=> v137481(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18065,axiom,
    ! [VarCurr: state_type] :
      ( v137481(VarCurr)
    <=> ( v137482(VarCurr)
        & v137485(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6248,axiom,
    ! [VarCurr: state_type] :
      ( v137485(VarCurr)
    <=> ( v137456(VarCurr,0)
        | v85128(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18064,axiom,
    ! [VarCurr: state_type] :
      ( v137482(VarCurr)
    <=> ( v137483(VarCurr)
        | v137484(VarCurr) ) ) ).

tff(writeUnaryOperator_10211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137484(VarCurr)
    <=> v85128(VarCurr,3) ) ).

tff(writeUnaryOperator_10210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137483(VarCurr)
    <=> v137456(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137466(VarCurr,B)
      <=> ( v137467(VarCurr,B)
          & v127420(VarCurr,B) ) ) ) ).

tff(addAssignment_77077,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,0)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77076,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,1)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77075,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,2)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77074,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,3)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77073,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,4)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77072,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,5)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77071,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,6)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77070,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,7)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77069,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,8)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77068,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,9)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77067,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,10)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77066,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,11)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77065,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,12)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77064,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,13)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77063,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,14)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77062,axiom,
    ! [VarCurr: state_type] :
      ( v137467(VarCurr,15)
    <=> v137468(VarCurr) ) ).

tff(addAssignment_77061,axiom,
    ! [VarCurr: state_type] :
      ( v137468(VarCurr)
    <=> v137469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18063,axiom,
    ! [VarCurr: state_type] :
      ( v137469(VarCurr)
    <=> ( v84915(VarCurr,0)
        & v85124(VarCurr) ) ) ).

tff(addAssignment_77060,axiom,
    ! [VarCurr: state_type] :
      ( v137464(VarCurr)
    <=> v108828(VarCurr) ) ).

tff(addAssignment_77059,axiom,
    ! [VarCurr: state_type] :
      ( v137462(VarCurr)
    <=> v108820(VarCurr) ) ).

tff(addAssignment_77058,axiom,
    ! [VarCurr: state_type] :
      ( v137460(VarCurr)
    <=> v108816(VarCurr) ) ).

tff(addAssignment_77057,axiom,
    ! [VarCurr: state_type] :
      ( v137458(VarCurr)
    <=> v108812(VarCurr) ) ).

tff(addAssignment_77056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v137456(VarCurr,B)
      <=> v108824(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6247,axiom,
    ! [VarCurr: state_type] :
      ( v85124(VarCurr)
    <=> ( v137440(VarCurr)
        | v137454(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6246,axiom,
    ! [VarCurr: state_type] :
      ( v137440(VarCurr)
    <=> ( v137441(VarCurr)
        | v137454(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6245,axiom,
    ! [VarCurr: state_type] :
      ( v137441(VarCurr)
    <=> ( v137442(VarCurr)
        | v137454(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6244,axiom,
    ! [VarCurr: state_type] :
      ( v137442(VarCurr)
    <=> ( v137443(VarCurr)
        | v137454(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6243,axiom,
    ! [VarCurr: state_type] :
      ( v137443(VarCurr)
    <=> ( v137444(VarCurr)
        | v137454(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6242,axiom,
    ! [VarCurr: state_type] :
      ( v137444(VarCurr)
    <=> ( v137445(VarCurr)
        | v137454(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6241,axiom,
    ! [VarCurr: state_type] :
      ( v137445(VarCurr)
    <=> ( v137446(VarCurr)
        | v137454(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6240,axiom,
    ! [VarCurr: state_type] :
      ( v137446(VarCurr)
    <=> ( v137447(VarCurr)
        | v137454(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6239,axiom,
    ! [VarCurr: state_type] :
      ( v137447(VarCurr)
    <=> ( v137448(VarCurr)
        | v137454(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6238,axiom,
    ! [VarCurr: state_type] :
      ( v137448(VarCurr)
    <=> ( v137449(VarCurr)
        | v137454(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6237,axiom,
    ! [VarCurr: state_type] :
      ( v137449(VarCurr)
    <=> ( v137450(VarCurr)
        | v137454(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6236,axiom,
    ! [VarCurr: state_type] :
      ( v137450(VarCurr)
    <=> ( v137451(VarCurr)
        | v137454(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6235,axiom,
    ! [VarCurr: state_type] :
      ( v137451(VarCurr)
    <=> ( v137452(VarCurr)
        | v137454(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6234,axiom,
    ! [VarCurr: state_type] :
      ( v137452(VarCurr)
    <=> ( v137453(VarCurr)
        | v137454(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6233,axiom,
    ! [VarCurr: state_type] :
      ( v137453(VarCurr)
    <=> ( v137454(VarCurr,0)
        | v137454(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137454(VarCurr,B)
      <=> ( v85126(VarCurr,B)
          & v85702(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v85702(VarCurr,B)
      <=> ( v85704(VarCurr,B)
          & v137437(VarCurr,B) ) ) ) ).

tff(addAssignment_77055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137437(VarCurr,B)
      <=> v137433(VarCurr,B) ) ) ).

tff(addAssignment_77054,axiom,
    ! [VarCurr: state_type] :
      ( ( v137437(VarCurr,15)
      <=> v137433(VarCurr,7) )
      & ( v137437(VarCurr,14)
      <=> v137433(VarCurr,6) )
      & ( v137437(VarCurr,13)
      <=> v137433(VarCurr,5) )
      & ( v137437(VarCurr,12)
      <=> v137433(VarCurr,4) )
      & ( v137437(VarCurr,11)
      <=> v137433(VarCurr,3) )
      & ( v137437(VarCurr,10)
      <=> v137433(VarCurr,2) )
      & ( v137437(VarCurr,9)
      <=> v137433(VarCurr,1) )
      & ( v137437(VarCurr,8)
      <=> v137433(VarCurr,0) ) ) ).

tff(addAssignment_77053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137433(VarCurr,B)
      <=> v137435(VarCurr,B) ) ) ).

tff(addAssignment_77052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137435(VarCurr,B)
      <=> v89154(VarCurr,B) ) ) ).

tff(addAssignment_77051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v85704(VarCurr,B)
      <=> v85706(VarCurr,B) ) ) ).

tff(addAssignment_77050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v85706(VarCurr,B)
      <=> v85708(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v85708(VarCurr,B)
      <=> ( v137425(VarCurr,B)
          & v137429(VarCurr,B) ) ) ) ).

tff(addAssignment_77049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137429(VarCurr,B)
      <=> v137431(VarCurr,B) ) ) ).

tff(addAssignment_77048,axiom,
    ! [VarCurr: state_type] :
      ( ( v137429(VarCurr,15)
      <=> v137430(VarCurr,7) )
      & ( v137429(VarCurr,14)
      <=> v137430(VarCurr,6) )
      & ( v137429(VarCurr,13)
      <=> v137430(VarCurr,5) )
      & ( v137429(VarCurr,12)
      <=> v137430(VarCurr,4) )
      & ( v137429(VarCurr,11)
      <=> v137430(VarCurr,3) )
      & ( v137429(VarCurr,10)
      <=> v137430(VarCurr,2) )
      & ( v137429(VarCurr,9)
      <=> v137430(VarCurr,1) )
      & ( v137429(VarCurr,8)
      <=> v137430(VarCurr,0) ) ) ).

tff(writeUnaryOperator_10209,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v137431(VarCurr,7)
      <=> v112522(VarCurr,15) )
      & ( ~ v137431(VarCurr,6)
      <=> v112522(VarCurr,14) )
      & ( ~ v137431(VarCurr,5)
      <=> v112522(VarCurr,13) )
      & ( ~ v137431(VarCurr,4)
      <=> v112522(VarCurr,12) )
      & ( ~ v137431(VarCurr,3)
      <=> v112522(VarCurr,11) )
      & ( ~ v137431(VarCurr,2)
      <=> v112522(VarCurr,10) )
      & ( ~ v137431(VarCurr,1)
      <=> v112522(VarCurr,9) )
      & ( ~ v137431(VarCurr,0)
      <=> v112522(VarCurr,8) ) ) ).

tff(writeUnaryOperator_10208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137430(VarCurr,B)
      <=> ~ v112522(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v137425(VarCurr,B)
      <=> ( v85710(VarCurr,B)
          & v137426(VarCurr,B) ) ) ) ).

tff(addAssignment_77047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137426(VarCurr,B)
      <=> v137428(VarCurr,B) ) ) ).

tff(addAssignment_77046,axiom,
    ! [VarCurr: state_type] :
      ( ( v137426(VarCurr,15)
      <=> v137427(VarCurr,7) )
      & ( v137426(VarCurr,14)
      <=> v137427(VarCurr,6) )
      & ( v137426(VarCurr,13)
      <=> v137427(VarCurr,5) )
      & ( v137426(VarCurr,12)
      <=> v137427(VarCurr,4) )
      & ( v137426(VarCurr,11)
      <=> v137427(VarCurr,3) )
      & ( v137426(VarCurr,10)
      <=> v137427(VarCurr,2) )
      & ( v137426(VarCurr,9)
      <=> v137427(VarCurr,1) )
      & ( v137426(VarCurr,8)
      <=> v137427(VarCurr,0) ) ) ).

tff(writeUnaryOperator_10207,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v137428(VarCurr,7)
      <=> v112753(VarCurr,15) )
      & ( ~ v137428(VarCurr,6)
      <=> v112753(VarCurr,14) )
      & ( ~ v137428(VarCurr,5)
      <=> v112753(VarCurr,13) )
      & ( ~ v137428(VarCurr,4)
      <=> v112753(VarCurr,12) )
      & ( ~ v137428(VarCurr,3)
      <=> v112753(VarCurr,11) )
      & ( ~ v137428(VarCurr,2)
      <=> v112753(VarCurr,10) )
      & ( ~ v137428(VarCurr,1)
      <=> v112753(VarCurr,9) )
      & ( ~ v137428(VarCurr,0)
      <=> v112753(VarCurr,8) ) ) ).

tff(writeUnaryOperator_10206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v137427(VarCurr,B)
      <=> ~ v112753(VarCurr,B) ) ) ).

tff(addAssignment_77045,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,15)
    <=> v137363(VarCurr) ) ).

tff(addAssignment_77044,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,14)
    <=> v137301(VarCurr) ) ).

tff(addAssignment_77043,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,13)
    <=> v137239(VarCurr) ) ).

tff(addAssignment_77042,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,12)
    <=> v137177(VarCurr) ) ).

tff(addAssignment_77041,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,11)
    <=> v137115(VarCurr) ) ).

tff(addAssignment_77040,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,10)
    <=> v137053(VarCurr) ) ).

tff(addAssignment_77039,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,9)
    <=> v136991(VarCurr) ) ).

tff(addAssignment_77038,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,8)
    <=> v136929(VarCurr) ) ).

tff(addAssignment_77037,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,7)
    <=> v136867(VarCurr) ) ).

tff(addAssignment_77036,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,6)
    <=> v136805(VarCurr) ) ).

tff(addAssignment_77035,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,5)
    <=> v136743(VarCurr) ) ).

tff(addAssignment_77034,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,4)
    <=> v136681(VarCurr) ) ).

tff(addAssignment_77033,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,3)
    <=> v136619(VarCurr) ) ).

tff(addAssignment_77032,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,2)
    <=> v136557(VarCurr) ) ).

tff(addAssignment_77031,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,1)
    <=> v136495(VarCurr) ) ).

tff(addAssignment_77030,axiom,
    ! [VarCurr: state_type] :
      ( v85710(VarCurr,0)
    <=> v85712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18062,axiom,
    ! [VarCurr: state_type] :
      ( v137363(VarCurr)
    <=> ( v125928(VarCurr,0)
        & v137365(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1806,axiom,
    ! [VarCurr: state_type] :
      ( v137365(VarCurr)
    <=> ( ( v137367(VarCurr,1)
        <=> $false )
        & ( v137367(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_77029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137367(VarCurr,B)
      <=> v137369(VarCurr,B) ) ) ).

tff(addAssignment_77028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137369(VarCurr,B)
      <=> v137371(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137406(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137371(VarNext,B)
            <=> v137371(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1909,axiom,
    ! [VarNext: state_type] :
      ( v137406(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137371(VarNext,B)
          <=> v137416(VarNext,B) ) ) ) ).

tff(addAssignment_77027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137416(VarNext,B)
          <=> v137414(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137414(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1461,axiom,
    ! [VarCurr: state_type] :
      ( v137417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137414(VarCurr,B)
          <=> v137381(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18061,axiom,
    ! [VarCurr: state_type] :
      ( v137417(VarCurr)
    <=> ( v137418(VarCurr)
        & v137419(VarCurr) ) ) ).

tff(writeUnaryOperator_10205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137419(VarCurr)
    <=> v137377(VarCurr) ) ).

tff(writeUnaryOperator_10204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137418(VarCurr)
    <=> v137373(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137406(VarNext)
      <=> v137407(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137407(VarNext)
      <=> ( v137408(VarNext)
          & v137401(VarNext) ) ) ) ).

tff(writeUnaryOperator_10203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137408(VarNext)
      <=> v137410(VarNext) ) ) ).

tff(addAssignment_77026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137410(VarNext)
      <=> v137401(VarCurr) ) ) ).

tff(addAssignment_77025,axiom,
    ! [VarCurr: state_type] :
      ( v137401(VarCurr)
    <=> v137403(VarCurr) ) ).

tff(addAssignment_77024,axiom,
    ! [VarCurr: state_type] :
      ( v137403(VarCurr)
    <=> v126408(VarCurr) ) ).

tff(addAssignment_77023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137381(VarCurr,B)
      <=> v137383(VarCurr,B) ) ) ).

tff(addAssignment_77022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137383(VarCurr,B)
      <=> v137385(VarCurr,B) ) ) ).

tff(addAssignment_77021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137385(VarCurr,B)
      <=> v137387(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137387(VarCurr,B)
          <=> v137392(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1460,axiom,
    ! [VarCurr: state_type] :
      ( v137389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137387(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137365(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137392(VarCurr,B)
          <=> v137393(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1459,axiom,
    ! [VarCurr: state_type] :
      ( v137365(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137392(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_77020,axiom,
    ! [VarCurr: state_type] :
      ( v137393(VarCurr,0)
    <=> v137397(VarCurr) ) ).

tff(addAssignment_77019,axiom,
    ! [VarCurr: state_type] :
      ( v137393(VarCurr,1)
    <=> v137395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18058,axiom,
    ! [VarCurr: state_type] :
      ( v137395(VarCurr)
    <=> ( v137396(VarCurr)
        & v137398(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18057,axiom,
    ! [VarCurr: state_type] :
      ( v137398(VarCurr)
    <=> ( v137367(VarCurr,0)
        | v137399(VarCurr) ) ) ).

tff(writeUnaryOperator_10202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137399(VarCurr)
    <=> v137367(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6232,axiom,
    ! [VarCurr: state_type] :
      ( v137396(VarCurr)
    <=> ( v137397(VarCurr)
        | v137367(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137397(VarCurr)
    <=> v137367(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6231,axiom,
    ! [VarCurr: state_type] :
      ( v137389(VarCurr)
    <=> ( v125928(VarCurr,3)
        & v126499(VarCurr) ) ) ).

tff(addAssignment_77018,axiom,
    ! [VarCurr: state_type] :
      ( v137377(VarCurr)
    <=> v137379(VarCurr) ) ).

tff(addAssignment_77017,axiom,
    ! [VarCurr: state_type] :
      ( v137379(VarCurr)
    <=> v125946(VarCurr) ) ).

tff(addAssignment_77016,axiom,
    ! [VarCurr: state_type] :
      ( v137373(VarCurr)
    <=> v137375(VarCurr) ) ).

tff(addAssignment_77015,axiom,
    ! [VarCurr: state_type] :
      ( v137375(VarCurr)
    <=> v125938(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18056,axiom,
    ! [VarCurr: state_type] :
      ( v137301(VarCurr)
    <=> ( v125127(VarCurr,0)
        & v137303(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1805,axiom,
    ! [VarCurr: state_type] :
      ( v137303(VarCurr)
    <=> ( ( v137305(VarCurr,1)
        <=> $false )
        & ( v137305(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_77014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137305(VarCurr,B)
      <=> v137307(VarCurr,B) ) ) ).

tff(addAssignment_77013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137307(VarCurr,B)
      <=> v137309(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137344(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137309(VarNext,B)
            <=> v137309(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1908,axiom,
    ! [VarNext: state_type] :
      ( v137344(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137309(VarNext,B)
          <=> v137354(VarNext,B) ) ) ) ).

tff(addAssignment_77012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137354(VarNext,B)
          <=> v137352(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137355(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137352(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1458,axiom,
    ! [VarCurr: state_type] :
      ( v137355(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137352(VarCurr,B)
          <=> v137319(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18055,axiom,
    ! [VarCurr: state_type] :
      ( v137355(VarCurr)
    <=> ( v137356(VarCurr)
        & v137357(VarCurr) ) ) ).

tff(writeUnaryOperator_10200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137357(VarCurr)
    <=> v137315(VarCurr) ) ).

tff(writeUnaryOperator_10199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137356(VarCurr)
    <=> v137311(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137344(VarNext)
      <=> v137345(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137345(VarNext)
      <=> ( v137346(VarNext)
          & v137339(VarNext) ) ) ) ).

tff(writeUnaryOperator_10198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137346(VarNext)
      <=> v137348(VarNext) ) ) ).

tff(addAssignment_77011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137348(VarNext)
      <=> v137339(VarCurr) ) ) ).

tff(addAssignment_77010,axiom,
    ! [VarCurr: state_type] :
      ( v137339(VarCurr)
    <=> v137341(VarCurr) ) ).

tff(addAssignment_77009,axiom,
    ! [VarCurr: state_type] :
      ( v137341(VarCurr)
    <=> v125607(VarCurr) ) ).

tff(addAssignment_77008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137319(VarCurr,B)
      <=> v137321(VarCurr,B) ) ) ).

tff(addAssignment_77007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137321(VarCurr,B)
      <=> v137323(VarCurr,B) ) ) ).

tff(addAssignment_77006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137323(VarCurr,B)
      <=> v137325(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137325(VarCurr,B)
          <=> v137330(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1457,axiom,
    ! [VarCurr: state_type] :
      ( v137327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137325(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137303(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137330(VarCurr,B)
          <=> v137331(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1456,axiom,
    ! [VarCurr: state_type] :
      ( v137303(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137330(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_77005,axiom,
    ! [VarCurr: state_type] :
      ( v137331(VarCurr,0)
    <=> v137335(VarCurr) ) ).

tff(addAssignment_77004,axiom,
    ! [VarCurr: state_type] :
      ( v137331(VarCurr,1)
    <=> v137333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18052,axiom,
    ! [VarCurr: state_type] :
      ( v137333(VarCurr)
    <=> ( v137334(VarCurr)
        & v137336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18051,axiom,
    ! [VarCurr: state_type] :
      ( v137336(VarCurr)
    <=> ( v137305(VarCurr,0)
        | v137337(VarCurr) ) ) ).

tff(writeUnaryOperator_10197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137337(VarCurr)
    <=> v137305(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6230,axiom,
    ! [VarCurr: state_type] :
      ( v137334(VarCurr)
    <=> ( v137335(VarCurr)
        | v137305(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137335(VarCurr)
    <=> v137305(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6229,axiom,
    ! [VarCurr: state_type] :
      ( v137327(VarCurr)
    <=> ( v125127(VarCurr,3)
        & v125698(VarCurr) ) ) ).

tff(addAssignment_77003,axiom,
    ! [VarCurr: state_type] :
      ( v137315(VarCurr)
    <=> v137317(VarCurr) ) ).

tff(addAssignment_77002,axiom,
    ! [VarCurr: state_type] :
      ( v137317(VarCurr)
    <=> v125145(VarCurr) ) ).

tff(addAssignment_77001,axiom,
    ! [VarCurr: state_type] :
      ( v137311(VarCurr)
    <=> v137313(VarCurr) ) ).

tff(addAssignment_77000,axiom,
    ! [VarCurr: state_type] :
      ( v137313(VarCurr)
    <=> v125137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18050,axiom,
    ! [VarCurr: state_type] :
      ( v137239(VarCurr)
    <=> ( v124326(VarCurr,0)
        & v137241(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1804,axiom,
    ! [VarCurr: state_type] :
      ( v137241(VarCurr)
    <=> ( ( v137243(VarCurr,1)
        <=> $false )
        & ( v137243(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137243(VarCurr,B)
      <=> v137245(VarCurr,B) ) ) ).

tff(addAssignment_76998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137245(VarCurr,B)
      <=> v137247(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137247(VarNext,B)
            <=> v137247(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1907,axiom,
    ! [VarNext: state_type] :
      ( v137282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137247(VarNext,B)
          <=> v137292(VarNext,B) ) ) ) ).

tff(addAssignment_76997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137292(VarNext,B)
          <=> v137290(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137290(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1455,axiom,
    ! [VarCurr: state_type] :
      ( v137293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137290(VarCurr,B)
          <=> v137257(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18049,axiom,
    ! [VarCurr: state_type] :
      ( v137293(VarCurr)
    <=> ( v137294(VarCurr)
        & v137295(VarCurr) ) ) ).

tff(writeUnaryOperator_10195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137295(VarCurr)
    <=> v137253(VarCurr) ) ).

tff(writeUnaryOperator_10194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137294(VarCurr)
    <=> v137249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137282(VarNext)
      <=> v137283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137283(VarNext)
      <=> ( v137284(VarNext)
          & v137277(VarNext) ) ) ) ).

tff(writeUnaryOperator_10193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137284(VarNext)
      <=> v137286(VarNext) ) ) ).

tff(addAssignment_76996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137286(VarNext)
      <=> v137277(VarCurr) ) ) ).

tff(addAssignment_76995,axiom,
    ! [VarCurr: state_type] :
      ( v137277(VarCurr)
    <=> v137279(VarCurr) ) ).

tff(addAssignment_76994,axiom,
    ! [VarCurr: state_type] :
      ( v137279(VarCurr)
    <=> v124806(VarCurr) ) ).

tff(addAssignment_76993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137257(VarCurr,B)
      <=> v137259(VarCurr,B) ) ) ).

tff(addAssignment_76992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137259(VarCurr,B)
      <=> v137261(VarCurr,B) ) ) ).

tff(addAssignment_76991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137261(VarCurr,B)
      <=> v137263(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137265(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137263(VarCurr,B)
          <=> v137268(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1454,axiom,
    ! [VarCurr: state_type] :
      ( v137265(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137263(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137241(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137268(VarCurr,B)
          <=> v137269(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1453,axiom,
    ! [VarCurr: state_type] :
      ( v137241(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137268(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76990,axiom,
    ! [VarCurr: state_type] :
      ( v137269(VarCurr,0)
    <=> v137273(VarCurr) ) ).

tff(addAssignment_76989,axiom,
    ! [VarCurr: state_type] :
      ( v137269(VarCurr,1)
    <=> v137271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18046,axiom,
    ! [VarCurr: state_type] :
      ( v137271(VarCurr)
    <=> ( v137272(VarCurr)
        & v137274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18045,axiom,
    ! [VarCurr: state_type] :
      ( v137274(VarCurr)
    <=> ( v137243(VarCurr,0)
        | v137275(VarCurr) ) ) ).

tff(writeUnaryOperator_10192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137275(VarCurr)
    <=> v137243(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6228,axiom,
    ! [VarCurr: state_type] :
      ( v137272(VarCurr)
    <=> ( v137273(VarCurr)
        | v137243(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137273(VarCurr)
    <=> v137243(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6227,axiom,
    ! [VarCurr: state_type] :
      ( v137265(VarCurr)
    <=> ( v124326(VarCurr,3)
        & v124897(VarCurr) ) ) ).

tff(addAssignment_76988,axiom,
    ! [VarCurr: state_type] :
      ( v137253(VarCurr)
    <=> v137255(VarCurr) ) ).

tff(addAssignment_76987,axiom,
    ! [VarCurr: state_type] :
      ( v137255(VarCurr)
    <=> v124344(VarCurr) ) ).

tff(addAssignment_76986,axiom,
    ! [VarCurr: state_type] :
      ( v137249(VarCurr)
    <=> v137251(VarCurr) ) ).

tff(addAssignment_76985,axiom,
    ! [VarCurr: state_type] :
      ( v137251(VarCurr)
    <=> v124336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18044,axiom,
    ! [VarCurr: state_type] :
      ( v137177(VarCurr)
    <=> ( v123525(VarCurr,0)
        & v137179(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1803,axiom,
    ! [VarCurr: state_type] :
      ( v137179(VarCurr)
    <=> ( ( v137181(VarCurr,1)
        <=> $false )
        & ( v137181(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137181(VarCurr,B)
      <=> v137183(VarCurr,B) ) ) ).

tff(addAssignment_76983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137183(VarCurr,B)
      <=> v137185(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137220(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137185(VarNext,B)
            <=> v137185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1906,axiom,
    ! [VarNext: state_type] :
      ( v137220(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137185(VarNext,B)
          <=> v137230(VarNext,B) ) ) ) ).

tff(addAssignment_76982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137230(VarNext,B)
          <=> v137228(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137231(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137228(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1452,axiom,
    ! [VarCurr: state_type] :
      ( v137231(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137228(VarCurr,B)
          <=> v137195(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18043,axiom,
    ! [VarCurr: state_type] :
      ( v137231(VarCurr)
    <=> ( v137232(VarCurr)
        & v137233(VarCurr) ) ) ).

tff(writeUnaryOperator_10190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137233(VarCurr)
    <=> v137191(VarCurr) ) ).

tff(writeUnaryOperator_10189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137232(VarCurr)
    <=> v137187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137220(VarNext)
      <=> v137221(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137221(VarNext)
      <=> ( v137222(VarNext)
          & v137215(VarNext) ) ) ) ).

tff(writeUnaryOperator_10188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137222(VarNext)
      <=> v137224(VarNext) ) ) ).

tff(addAssignment_76981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137224(VarNext)
      <=> v137215(VarCurr) ) ) ).

tff(addAssignment_76980,axiom,
    ! [VarCurr: state_type] :
      ( v137215(VarCurr)
    <=> v137217(VarCurr) ) ).

tff(addAssignment_76979,axiom,
    ! [VarCurr: state_type] :
      ( v137217(VarCurr)
    <=> v124005(VarCurr) ) ).

tff(addAssignment_76978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137195(VarCurr,B)
      <=> v137197(VarCurr,B) ) ) ).

tff(addAssignment_76977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137197(VarCurr,B)
      <=> v137199(VarCurr,B) ) ) ).

tff(addAssignment_76976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137199(VarCurr,B)
      <=> v137201(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137203(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137201(VarCurr,B)
          <=> v137206(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1451,axiom,
    ! [VarCurr: state_type] :
      ( v137203(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137201(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137179(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137206(VarCurr,B)
          <=> v137207(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1450,axiom,
    ! [VarCurr: state_type] :
      ( v137179(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137206(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76975,axiom,
    ! [VarCurr: state_type] :
      ( v137207(VarCurr,0)
    <=> v137211(VarCurr) ) ).

tff(addAssignment_76974,axiom,
    ! [VarCurr: state_type] :
      ( v137207(VarCurr,1)
    <=> v137209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18040,axiom,
    ! [VarCurr: state_type] :
      ( v137209(VarCurr)
    <=> ( v137210(VarCurr)
        & v137212(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18039,axiom,
    ! [VarCurr: state_type] :
      ( v137212(VarCurr)
    <=> ( v137181(VarCurr,0)
        | v137213(VarCurr) ) ) ).

tff(writeUnaryOperator_10187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137213(VarCurr)
    <=> v137181(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6226,axiom,
    ! [VarCurr: state_type] :
      ( v137210(VarCurr)
    <=> ( v137211(VarCurr)
        | v137181(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137211(VarCurr)
    <=> v137181(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6225,axiom,
    ! [VarCurr: state_type] :
      ( v137203(VarCurr)
    <=> ( v123525(VarCurr,3)
        & v124096(VarCurr) ) ) ).

tff(addAssignment_76973,axiom,
    ! [VarCurr: state_type] :
      ( v137191(VarCurr)
    <=> v137193(VarCurr) ) ).

tff(addAssignment_76972,axiom,
    ! [VarCurr: state_type] :
      ( v137193(VarCurr)
    <=> v123543(VarCurr) ) ).

tff(addAssignment_76971,axiom,
    ! [VarCurr: state_type] :
      ( v137187(VarCurr)
    <=> v137189(VarCurr) ) ).

tff(addAssignment_76970,axiom,
    ! [VarCurr: state_type] :
      ( v137189(VarCurr)
    <=> v123535(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18038,axiom,
    ! [VarCurr: state_type] :
      ( v137115(VarCurr)
    <=> ( v122724(VarCurr,0)
        & v137117(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1802,axiom,
    ! [VarCurr: state_type] :
      ( v137117(VarCurr)
    <=> ( ( v137119(VarCurr,1)
        <=> $false )
        & ( v137119(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137119(VarCurr,B)
      <=> v137121(VarCurr,B) ) ) ).

tff(addAssignment_76968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137121(VarCurr,B)
      <=> v137123(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137158(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137123(VarNext,B)
            <=> v137123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1905,axiom,
    ! [VarNext: state_type] :
      ( v137158(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137123(VarNext,B)
          <=> v137168(VarNext,B) ) ) ) ).

tff(addAssignment_76967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137168(VarNext,B)
          <=> v137166(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137169(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137166(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1449,axiom,
    ! [VarCurr: state_type] :
      ( v137169(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137166(VarCurr,B)
          <=> v137133(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18037,axiom,
    ! [VarCurr: state_type] :
      ( v137169(VarCurr)
    <=> ( v137170(VarCurr)
        & v137171(VarCurr) ) ) ).

tff(writeUnaryOperator_10185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137171(VarCurr)
    <=> v137129(VarCurr) ) ).

tff(writeUnaryOperator_10184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137170(VarCurr)
    <=> v137125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137158(VarNext)
      <=> v137159(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137159(VarNext)
      <=> ( v137160(VarNext)
          & v137153(VarNext) ) ) ) ).

tff(writeUnaryOperator_10183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137160(VarNext)
      <=> v137162(VarNext) ) ) ).

tff(addAssignment_76966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137162(VarNext)
      <=> v137153(VarCurr) ) ) ).

tff(addAssignment_76965,axiom,
    ! [VarCurr: state_type] :
      ( v137153(VarCurr)
    <=> v137155(VarCurr) ) ).

tff(addAssignment_76964,axiom,
    ! [VarCurr: state_type] :
      ( v137155(VarCurr)
    <=> v123204(VarCurr) ) ).

tff(addAssignment_76963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137133(VarCurr,B)
      <=> v137135(VarCurr,B) ) ) ).

tff(addAssignment_76962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137135(VarCurr,B)
      <=> v137137(VarCurr,B) ) ) ).

tff(addAssignment_76961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137137(VarCurr,B)
      <=> v137139(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137141(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137139(VarCurr,B)
          <=> v137144(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1448,axiom,
    ! [VarCurr: state_type] :
      ( v137141(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137139(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137117(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137144(VarCurr,B)
          <=> v137145(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1447,axiom,
    ! [VarCurr: state_type] :
      ( v137117(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137144(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76960,axiom,
    ! [VarCurr: state_type] :
      ( v137145(VarCurr,0)
    <=> v137149(VarCurr) ) ).

tff(addAssignment_76959,axiom,
    ! [VarCurr: state_type] :
      ( v137145(VarCurr,1)
    <=> v137147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18034,axiom,
    ! [VarCurr: state_type] :
      ( v137147(VarCurr)
    <=> ( v137148(VarCurr)
        & v137150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18033,axiom,
    ! [VarCurr: state_type] :
      ( v137150(VarCurr)
    <=> ( v137119(VarCurr,0)
        | v137151(VarCurr) ) ) ).

tff(writeUnaryOperator_10182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137151(VarCurr)
    <=> v137119(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6224,axiom,
    ! [VarCurr: state_type] :
      ( v137148(VarCurr)
    <=> ( v137149(VarCurr)
        | v137119(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137149(VarCurr)
    <=> v137119(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6223,axiom,
    ! [VarCurr: state_type] :
      ( v137141(VarCurr)
    <=> ( v122724(VarCurr,3)
        & v123295(VarCurr) ) ) ).

tff(addAssignment_76958,axiom,
    ! [VarCurr: state_type] :
      ( v137129(VarCurr)
    <=> v137131(VarCurr) ) ).

tff(addAssignment_76957,axiom,
    ! [VarCurr: state_type] :
      ( v137131(VarCurr)
    <=> v122742(VarCurr) ) ).

tff(addAssignment_76956,axiom,
    ! [VarCurr: state_type] :
      ( v137125(VarCurr)
    <=> v137127(VarCurr) ) ).

tff(addAssignment_76955,axiom,
    ! [VarCurr: state_type] :
      ( v137127(VarCurr)
    <=> v122734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18032,axiom,
    ! [VarCurr: state_type] :
      ( v137053(VarCurr)
    <=> ( v121923(VarCurr,0)
        & v137055(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1801,axiom,
    ! [VarCurr: state_type] :
      ( v137055(VarCurr)
    <=> ( ( v137057(VarCurr,1)
        <=> $false )
        & ( v137057(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137057(VarCurr,B)
      <=> v137059(VarCurr,B) ) ) ).

tff(addAssignment_76953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137059(VarCurr,B)
      <=> v137061(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137096(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v137061(VarNext,B)
            <=> v137061(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1904,axiom,
    ! [VarNext: state_type] :
      ( v137096(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137061(VarNext,B)
          <=> v137106(VarNext,B) ) ) ) ).

tff(addAssignment_76952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137106(VarNext,B)
          <=> v137104(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137104(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1446,axiom,
    ! [VarCurr: state_type] :
      ( v137107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137104(VarCurr,B)
          <=> v137071(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18031,axiom,
    ! [VarCurr: state_type] :
      ( v137107(VarCurr)
    <=> ( v137108(VarCurr)
        & v137109(VarCurr) ) ) ).

tff(writeUnaryOperator_10180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137109(VarCurr)
    <=> v137067(VarCurr) ) ).

tff(writeUnaryOperator_10179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137108(VarCurr)
    <=> v137063(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137096(VarNext)
      <=> v137097(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137097(VarNext)
      <=> ( v137098(VarNext)
          & v137091(VarNext) ) ) ) ).

tff(writeUnaryOperator_10178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137098(VarNext)
      <=> v137100(VarNext) ) ) ).

tff(addAssignment_76951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137100(VarNext)
      <=> v137091(VarCurr) ) ) ).

tff(addAssignment_76950,axiom,
    ! [VarCurr: state_type] :
      ( v137091(VarCurr)
    <=> v137093(VarCurr) ) ).

tff(addAssignment_76949,axiom,
    ! [VarCurr: state_type] :
      ( v137093(VarCurr)
    <=> v122403(VarCurr) ) ).

tff(addAssignment_76948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137071(VarCurr,B)
      <=> v137073(VarCurr,B) ) ) ).

tff(addAssignment_76947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137073(VarCurr,B)
      <=> v137075(VarCurr,B) ) ) ).

tff(addAssignment_76946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137075(VarCurr,B)
      <=> v137077(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137079(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137077(VarCurr,B)
          <=> v137082(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1445,axiom,
    ! [VarCurr: state_type] :
      ( v137079(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137077(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137055(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137082(VarCurr,B)
          <=> v137083(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1444,axiom,
    ! [VarCurr: state_type] :
      ( v137055(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137082(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76945,axiom,
    ! [VarCurr: state_type] :
      ( v137083(VarCurr,0)
    <=> v137087(VarCurr) ) ).

tff(addAssignment_76944,axiom,
    ! [VarCurr: state_type] :
      ( v137083(VarCurr,1)
    <=> v137085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18028,axiom,
    ! [VarCurr: state_type] :
      ( v137085(VarCurr)
    <=> ( v137086(VarCurr)
        & v137088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18027,axiom,
    ! [VarCurr: state_type] :
      ( v137088(VarCurr)
    <=> ( v137057(VarCurr,0)
        | v137089(VarCurr) ) ) ).

tff(writeUnaryOperator_10177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137089(VarCurr)
    <=> v137057(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6222,axiom,
    ! [VarCurr: state_type] :
      ( v137086(VarCurr)
    <=> ( v137087(VarCurr)
        | v137057(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137087(VarCurr)
    <=> v137057(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6221,axiom,
    ! [VarCurr: state_type] :
      ( v137079(VarCurr)
    <=> ( v121923(VarCurr,3)
        & v122494(VarCurr) ) ) ).

tff(addAssignment_76943,axiom,
    ! [VarCurr: state_type] :
      ( v137067(VarCurr)
    <=> v137069(VarCurr) ) ).

tff(addAssignment_76942,axiom,
    ! [VarCurr: state_type] :
      ( v137069(VarCurr)
    <=> v121941(VarCurr) ) ).

tff(addAssignment_76941,axiom,
    ! [VarCurr: state_type] :
      ( v137063(VarCurr)
    <=> v137065(VarCurr) ) ).

tff(addAssignment_76940,axiom,
    ! [VarCurr: state_type] :
      ( v137065(VarCurr)
    <=> v121933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18026,axiom,
    ! [VarCurr: state_type] :
      ( v136991(VarCurr)
    <=> ( v121122(VarCurr,0)
        & v136993(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1800,axiom,
    ! [VarCurr: state_type] :
      ( v136993(VarCurr)
    <=> ( ( v136995(VarCurr,1)
        <=> $false )
        & ( v136995(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136995(VarCurr,B)
      <=> v136997(VarCurr,B) ) ) ).

tff(addAssignment_76938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136997(VarCurr,B)
      <=> v136999(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137034(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136999(VarNext,B)
            <=> v136999(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1903,axiom,
    ! [VarNext: state_type] :
      ( v137034(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136999(VarNext,B)
          <=> v137044(VarNext,B) ) ) ) ).

tff(addAssignment_76937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137044(VarNext,B)
          <=> v137042(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137042(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1443,axiom,
    ! [VarCurr: state_type] :
      ( v137045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137042(VarCurr,B)
          <=> v137009(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18025,axiom,
    ! [VarCurr: state_type] :
      ( v137045(VarCurr)
    <=> ( v137046(VarCurr)
        & v137047(VarCurr) ) ) ).

tff(writeUnaryOperator_10175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137047(VarCurr)
    <=> v137005(VarCurr) ) ).

tff(writeUnaryOperator_10174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137046(VarCurr)
    <=> v137001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137034(VarNext)
      <=> v137035(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137035(VarNext)
      <=> ( v137036(VarNext)
          & v137029(VarNext) ) ) ) ).

tff(writeUnaryOperator_10173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v137036(VarNext)
      <=> v137038(VarNext) ) ) ).

tff(addAssignment_76936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v137038(VarNext)
      <=> v137029(VarCurr) ) ) ).

tff(addAssignment_76935,axiom,
    ! [VarCurr: state_type] :
      ( v137029(VarCurr)
    <=> v137031(VarCurr) ) ).

tff(addAssignment_76934,axiom,
    ! [VarCurr: state_type] :
      ( v137031(VarCurr)
    <=> v121602(VarCurr) ) ).

tff(addAssignment_76933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137009(VarCurr,B)
      <=> v137011(VarCurr,B) ) ) ).

tff(addAssignment_76932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137011(VarCurr,B)
      <=> v137013(VarCurr,B) ) ) ).

tff(addAssignment_76931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v137013(VarCurr,B)
      <=> v137015(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137017(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137015(VarCurr,B)
          <=> v137020(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1442,axiom,
    ! [VarCurr: state_type] :
      ( v137017(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137015(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136993(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137020(VarCurr,B)
          <=> v137021(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1441,axiom,
    ! [VarCurr: state_type] :
      ( v136993(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v137020(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76930,axiom,
    ! [VarCurr: state_type] :
      ( v137021(VarCurr,0)
    <=> v137025(VarCurr) ) ).

tff(addAssignment_76929,axiom,
    ! [VarCurr: state_type] :
      ( v137021(VarCurr,1)
    <=> v137023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18022,axiom,
    ! [VarCurr: state_type] :
      ( v137023(VarCurr)
    <=> ( v137024(VarCurr)
        & v137026(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18021,axiom,
    ! [VarCurr: state_type] :
      ( v137026(VarCurr)
    <=> ( v136995(VarCurr,0)
        | v137027(VarCurr) ) ) ).

tff(writeUnaryOperator_10172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137027(VarCurr)
    <=> v136995(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6220,axiom,
    ! [VarCurr: state_type] :
      ( v137024(VarCurr)
    <=> ( v137025(VarCurr)
        | v136995(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v137025(VarCurr)
    <=> v136995(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6219,axiom,
    ! [VarCurr: state_type] :
      ( v137017(VarCurr)
    <=> ( v121122(VarCurr,3)
        & v121693(VarCurr) ) ) ).

tff(addAssignment_76928,axiom,
    ! [VarCurr: state_type] :
      ( v137005(VarCurr)
    <=> v137007(VarCurr) ) ).

tff(addAssignment_76927,axiom,
    ! [VarCurr: state_type] :
      ( v137007(VarCurr)
    <=> v121140(VarCurr) ) ).

tff(addAssignment_76926,axiom,
    ! [VarCurr: state_type] :
      ( v137001(VarCurr)
    <=> v137003(VarCurr) ) ).

tff(addAssignment_76925,axiom,
    ! [VarCurr: state_type] :
      ( v137003(VarCurr)
    <=> v121132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18020,axiom,
    ! [VarCurr: state_type] :
      ( v136929(VarCurr)
    <=> ( v120320(VarCurr,0)
        & v136931(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1799,axiom,
    ! [VarCurr: state_type] :
      ( v136931(VarCurr)
    <=> ( ( v136933(VarCurr,1)
        <=> $false )
        & ( v136933(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136933(VarCurr,B)
      <=> v136935(VarCurr,B) ) ) ).

tff(addAssignment_76923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136935(VarCurr,B)
      <=> v136937(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136972(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136937(VarNext,B)
            <=> v136937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1902,axiom,
    ! [VarNext: state_type] :
      ( v136972(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136937(VarNext,B)
          <=> v136982(VarNext,B) ) ) ) ).

tff(addAssignment_76922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136982(VarNext,B)
          <=> v136980(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136983(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136980(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1440,axiom,
    ! [VarCurr: state_type] :
      ( v136983(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136980(VarCurr,B)
          <=> v136947(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18019,axiom,
    ! [VarCurr: state_type] :
      ( v136983(VarCurr)
    <=> ( v136984(VarCurr)
        & v136985(VarCurr) ) ) ).

tff(writeUnaryOperator_10170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136985(VarCurr)
    <=> v136943(VarCurr) ) ).

tff(writeUnaryOperator_10169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136984(VarCurr)
    <=> v136939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136972(VarNext)
      <=> v136973(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136973(VarNext)
      <=> ( v136974(VarNext)
          & v136967(VarNext) ) ) ) ).

tff(writeUnaryOperator_10168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136974(VarNext)
      <=> v136976(VarNext) ) ) ).

tff(addAssignment_76921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136976(VarNext)
      <=> v136967(VarCurr) ) ) ).

tff(addAssignment_76920,axiom,
    ! [VarCurr: state_type] :
      ( v136967(VarCurr)
    <=> v136969(VarCurr) ) ).

tff(addAssignment_76919,axiom,
    ! [VarCurr: state_type] :
      ( v136969(VarCurr)
    <=> v120800(VarCurr) ) ).

tff(addAssignment_76918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136947(VarCurr,B)
      <=> v136949(VarCurr,B) ) ) ).

tff(addAssignment_76917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136949(VarCurr,B)
      <=> v136951(VarCurr,B) ) ) ).

tff(addAssignment_76916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136951(VarCurr,B)
      <=> v136953(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136955(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136953(VarCurr,B)
          <=> v136958(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1439,axiom,
    ! [VarCurr: state_type] :
      ( v136955(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136953(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136931(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136958(VarCurr,B)
          <=> v136959(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1438,axiom,
    ! [VarCurr: state_type] :
      ( v136931(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136958(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76915,axiom,
    ! [VarCurr: state_type] :
      ( v136959(VarCurr,0)
    <=> v136963(VarCurr) ) ).

tff(addAssignment_76914,axiom,
    ! [VarCurr: state_type] :
      ( v136959(VarCurr,1)
    <=> v136961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18016,axiom,
    ! [VarCurr: state_type] :
      ( v136961(VarCurr)
    <=> ( v136962(VarCurr)
        & v136964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18015,axiom,
    ! [VarCurr: state_type] :
      ( v136964(VarCurr)
    <=> ( v136933(VarCurr,0)
        | v136965(VarCurr) ) ) ).

tff(writeUnaryOperator_10167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136965(VarCurr)
    <=> v136933(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6218,axiom,
    ! [VarCurr: state_type] :
      ( v136962(VarCurr)
    <=> ( v136963(VarCurr)
        | v136933(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136963(VarCurr)
    <=> v136933(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6217,axiom,
    ! [VarCurr: state_type] :
      ( v136955(VarCurr)
    <=> ( v120320(VarCurr,3)
        & v120892(VarCurr) ) ) ).

tff(addAssignment_76913,axiom,
    ! [VarCurr: state_type] :
      ( v136943(VarCurr)
    <=> v136945(VarCurr) ) ).

tff(addAssignment_76912,axiom,
    ! [VarCurr: state_type] :
      ( v136945(VarCurr)
    <=> v120338(VarCurr) ) ).

tff(addAssignment_76911,axiom,
    ! [VarCurr: state_type] :
      ( v136939(VarCurr)
    <=> v136941(VarCurr) ) ).

tff(addAssignment_76910,axiom,
    ! [VarCurr: state_type] :
      ( v136941(VarCurr)
    <=> v120330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18014,axiom,
    ! [VarCurr: state_type] :
      ( v136867(VarCurr)
    <=> ( v119519(VarCurr,0)
        & v136869(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1798,axiom,
    ! [VarCurr: state_type] :
      ( v136869(VarCurr)
    <=> ( ( v136871(VarCurr,1)
        <=> $false )
        & ( v136871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136871(VarCurr,B)
      <=> v136873(VarCurr,B) ) ) ).

tff(addAssignment_76908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136873(VarCurr,B)
      <=> v136875(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136910(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136875(VarNext,B)
            <=> v136875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1901,axiom,
    ! [VarNext: state_type] :
      ( v136910(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136875(VarNext,B)
          <=> v136920(VarNext,B) ) ) ) ).

tff(addAssignment_76907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136920(VarNext,B)
          <=> v136918(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136918(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1437,axiom,
    ! [VarCurr: state_type] :
      ( v136921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136918(VarCurr,B)
          <=> v136885(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18013,axiom,
    ! [VarCurr: state_type] :
      ( v136921(VarCurr)
    <=> ( v136922(VarCurr)
        & v136923(VarCurr) ) ) ).

tff(writeUnaryOperator_10165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136923(VarCurr)
    <=> v136881(VarCurr) ) ).

tff(writeUnaryOperator_10164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136922(VarCurr)
    <=> v136877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136910(VarNext)
      <=> v136911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136911(VarNext)
      <=> ( v136912(VarNext)
          & v136905(VarNext) ) ) ) ).

tff(writeUnaryOperator_10163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136912(VarNext)
      <=> v136914(VarNext) ) ) ).

tff(addAssignment_76906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136914(VarNext)
      <=> v136905(VarCurr) ) ) ).

tff(addAssignment_76905,axiom,
    ! [VarCurr: state_type] :
      ( v136905(VarCurr)
    <=> v136907(VarCurr) ) ).

tff(addAssignment_76904,axiom,
    ! [VarCurr: state_type] :
      ( v136907(VarCurr)
    <=> v119999(VarCurr) ) ).

tff(addAssignment_76903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136885(VarCurr,B)
      <=> v136887(VarCurr,B) ) ) ).

tff(addAssignment_76902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136887(VarCurr,B)
      <=> v136889(VarCurr,B) ) ) ).

tff(addAssignment_76901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136889(VarCurr,B)
      <=> v136891(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136893(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136891(VarCurr,B)
          <=> v136896(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1436,axiom,
    ! [VarCurr: state_type] :
      ( v136893(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136891(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136896(VarCurr,B)
          <=> v136897(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1435,axiom,
    ! [VarCurr: state_type] :
      ( v136869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136896(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76900,axiom,
    ! [VarCurr: state_type] :
      ( v136897(VarCurr,0)
    <=> v136901(VarCurr) ) ).

tff(addAssignment_76899,axiom,
    ! [VarCurr: state_type] :
      ( v136897(VarCurr,1)
    <=> v136899(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18010,axiom,
    ! [VarCurr: state_type] :
      ( v136899(VarCurr)
    <=> ( v136900(VarCurr)
        & v136902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18009,axiom,
    ! [VarCurr: state_type] :
      ( v136902(VarCurr)
    <=> ( v136871(VarCurr,0)
        | v136903(VarCurr) ) ) ).

tff(writeUnaryOperator_10162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136903(VarCurr)
    <=> v136871(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6216,axiom,
    ! [VarCurr: state_type] :
      ( v136900(VarCurr)
    <=> ( v136901(VarCurr)
        | v136871(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136901(VarCurr)
    <=> v136871(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6215,axiom,
    ! [VarCurr: state_type] :
      ( v136893(VarCurr)
    <=> ( v119519(VarCurr,3)
        & v120090(VarCurr) ) ) ).

tff(addAssignment_76898,axiom,
    ! [VarCurr: state_type] :
      ( v136881(VarCurr)
    <=> v136883(VarCurr) ) ).

tff(addAssignment_76897,axiom,
    ! [VarCurr: state_type] :
      ( v136883(VarCurr)
    <=> v119537(VarCurr) ) ).

tff(addAssignment_76896,axiom,
    ! [VarCurr: state_type] :
      ( v136877(VarCurr)
    <=> v136879(VarCurr) ) ).

tff(addAssignment_76895,axiom,
    ! [VarCurr: state_type] :
      ( v136879(VarCurr)
    <=> v119529(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18008,axiom,
    ! [VarCurr: state_type] :
      ( v136805(VarCurr)
    <=> ( v118718(VarCurr,0)
        & v136807(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1797,axiom,
    ! [VarCurr: state_type] :
      ( v136807(VarCurr)
    <=> ( ( v136809(VarCurr,1)
        <=> $false )
        & ( v136809(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136809(VarCurr,B)
      <=> v136811(VarCurr,B) ) ) ).

tff(addAssignment_76893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136811(VarCurr,B)
      <=> v136813(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136848(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136813(VarNext,B)
            <=> v136813(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1900,axiom,
    ! [VarNext: state_type] :
      ( v136848(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136813(VarNext,B)
          <=> v136858(VarNext,B) ) ) ) ).

tff(addAssignment_76892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136858(VarNext,B)
          <=> v136856(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136859(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136856(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1434,axiom,
    ! [VarCurr: state_type] :
      ( v136859(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136856(VarCurr,B)
          <=> v136823(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18007,axiom,
    ! [VarCurr: state_type] :
      ( v136859(VarCurr)
    <=> ( v136860(VarCurr)
        & v136861(VarCurr) ) ) ).

tff(writeUnaryOperator_10160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136861(VarCurr)
    <=> v136819(VarCurr) ) ).

tff(writeUnaryOperator_10159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136860(VarCurr)
    <=> v136815(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136848(VarNext)
      <=> v136849(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136849(VarNext)
      <=> ( v136850(VarNext)
          & v136843(VarNext) ) ) ) ).

tff(writeUnaryOperator_10158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136850(VarNext)
      <=> v136852(VarNext) ) ) ).

tff(addAssignment_76891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136852(VarNext)
      <=> v136843(VarCurr) ) ) ).

tff(addAssignment_76890,axiom,
    ! [VarCurr: state_type] :
      ( v136843(VarCurr)
    <=> v136845(VarCurr) ) ).

tff(addAssignment_76889,axiom,
    ! [VarCurr: state_type] :
      ( v136845(VarCurr)
    <=> v119198(VarCurr) ) ).

tff(addAssignment_76888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136823(VarCurr,B)
      <=> v136825(VarCurr,B) ) ) ).

tff(addAssignment_76887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136825(VarCurr,B)
      <=> v136827(VarCurr,B) ) ) ).

tff(addAssignment_76886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136827(VarCurr,B)
      <=> v136829(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136831(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136829(VarCurr,B)
          <=> v136834(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1433,axiom,
    ! [VarCurr: state_type] :
      ( v136831(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136829(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136807(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136834(VarCurr,B)
          <=> v136835(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1432,axiom,
    ! [VarCurr: state_type] :
      ( v136807(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136834(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76885,axiom,
    ! [VarCurr: state_type] :
      ( v136835(VarCurr,0)
    <=> v136839(VarCurr) ) ).

tff(addAssignment_76884,axiom,
    ! [VarCurr: state_type] :
      ( v136835(VarCurr,1)
    <=> v136837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18004,axiom,
    ! [VarCurr: state_type] :
      ( v136837(VarCurr)
    <=> ( v136838(VarCurr)
        & v136840(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18003,axiom,
    ! [VarCurr: state_type] :
      ( v136840(VarCurr)
    <=> ( v136809(VarCurr,0)
        | v136841(VarCurr) ) ) ).

tff(writeUnaryOperator_10157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136841(VarCurr)
    <=> v136809(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6214,axiom,
    ! [VarCurr: state_type] :
      ( v136838(VarCurr)
    <=> ( v136839(VarCurr)
        | v136809(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136839(VarCurr)
    <=> v136809(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6213,axiom,
    ! [VarCurr: state_type] :
      ( v136831(VarCurr)
    <=> ( v118718(VarCurr,3)
        & v119289(VarCurr) ) ) ).

tff(addAssignment_76883,axiom,
    ! [VarCurr: state_type] :
      ( v136819(VarCurr)
    <=> v136821(VarCurr) ) ).

tff(addAssignment_76882,axiom,
    ! [VarCurr: state_type] :
      ( v136821(VarCurr)
    <=> v118736(VarCurr) ) ).

tff(addAssignment_76881,axiom,
    ! [VarCurr: state_type] :
      ( v136815(VarCurr)
    <=> v136817(VarCurr) ) ).

tff(addAssignment_76880,axiom,
    ! [VarCurr: state_type] :
      ( v136817(VarCurr)
    <=> v118728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18002,axiom,
    ! [VarCurr: state_type] :
      ( v136743(VarCurr)
    <=> ( v117917(VarCurr,0)
        & v136745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1796,axiom,
    ! [VarCurr: state_type] :
      ( v136745(VarCurr)
    <=> ( ( v136747(VarCurr,1)
        <=> $false )
        & ( v136747(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136747(VarCurr,B)
      <=> v136749(VarCurr,B) ) ) ).

tff(addAssignment_76878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136749(VarCurr,B)
      <=> v136751(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136786(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136751(VarNext,B)
            <=> v136751(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1899,axiom,
    ! [VarNext: state_type] :
      ( v136786(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136751(VarNext,B)
          <=> v136796(VarNext,B) ) ) ) ).

tff(addAssignment_76877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136796(VarNext,B)
          <=> v136794(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136794(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1431,axiom,
    ! [VarCurr: state_type] :
      ( v136797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136794(VarCurr,B)
          <=> v136761(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18001,axiom,
    ! [VarCurr: state_type] :
      ( v136797(VarCurr)
    <=> ( v136798(VarCurr)
        & v136799(VarCurr) ) ) ).

tff(writeUnaryOperator_10155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136799(VarCurr)
    <=> v136757(VarCurr) ) ).

tff(writeUnaryOperator_10154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136798(VarCurr)
    <=> v136753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136786(VarNext)
      <=> v136787(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136787(VarNext)
      <=> ( v136788(VarNext)
          & v136781(VarNext) ) ) ) ).

tff(writeUnaryOperator_10153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136788(VarNext)
      <=> v136790(VarNext) ) ) ).

tff(addAssignment_76876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136790(VarNext)
      <=> v136781(VarCurr) ) ) ).

tff(addAssignment_76875,axiom,
    ! [VarCurr: state_type] :
      ( v136781(VarCurr)
    <=> v136783(VarCurr) ) ).

tff(addAssignment_76874,axiom,
    ! [VarCurr: state_type] :
      ( v136783(VarCurr)
    <=> v118397(VarCurr) ) ).

tff(addAssignment_76873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136761(VarCurr,B)
      <=> v136763(VarCurr,B) ) ) ).

tff(addAssignment_76872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136763(VarCurr,B)
      <=> v136765(VarCurr,B) ) ) ).

tff(addAssignment_76871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136765(VarCurr,B)
      <=> v136767(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136767(VarCurr,B)
          <=> v136772(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1430,axiom,
    ! [VarCurr: state_type] :
      ( v136769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136767(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136772(VarCurr,B)
          <=> v136773(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1429,axiom,
    ! [VarCurr: state_type] :
      ( v136745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136772(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76870,axiom,
    ! [VarCurr: state_type] :
      ( v136773(VarCurr,0)
    <=> v136777(VarCurr) ) ).

tff(addAssignment_76869,axiom,
    ! [VarCurr: state_type] :
      ( v136773(VarCurr,1)
    <=> v136775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17998,axiom,
    ! [VarCurr: state_type] :
      ( v136775(VarCurr)
    <=> ( v136776(VarCurr)
        & v136778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17997,axiom,
    ! [VarCurr: state_type] :
      ( v136778(VarCurr)
    <=> ( v136747(VarCurr,0)
        | v136779(VarCurr) ) ) ).

tff(writeUnaryOperator_10152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136779(VarCurr)
    <=> v136747(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6212,axiom,
    ! [VarCurr: state_type] :
      ( v136776(VarCurr)
    <=> ( v136777(VarCurr)
        | v136747(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136777(VarCurr)
    <=> v136747(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6211,axiom,
    ! [VarCurr: state_type] :
      ( v136769(VarCurr)
    <=> ( v117917(VarCurr,3)
        & v118488(VarCurr) ) ) ).

tff(addAssignment_76868,axiom,
    ! [VarCurr: state_type] :
      ( v136757(VarCurr)
    <=> v136759(VarCurr) ) ).

tff(addAssignment_76867,axiom,
    ! [VarCurr: state_type] :
      ( v136759(VarCurr)
    <=> v117935(VarCurr) ) ).

tff(addAssignment_76866,axiom,
    ! [VarCurr: state_type] :
      ( v136753(VarCurr)
    <=> v136755(VarCurr) ) ).

tff(addAssignment_76865,axiom,
    ! [VarCurr: state_type] :
      ( v136755(VarCurr)
    <=> v117927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17996,axiom,
    ! [VarCurr: state_type] :
      ( v136681(VarCurr)
    <=> ( v117116(VarCurr,0)
        & v136683(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1795,axiom,
    ! [VarCurr: state_type] :
      ( v136683(VarCurr)
    <=> ( ( v136685(VarCurr,1)
        <=> $false )
        & ( v136685(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136685(VarCurr,B)
      <=> v136687(VarCurr,B) ) ) ).

tff(addAssignment_76863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136687(VarCurr,B)
      <=> v136689(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136724(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136689(VarNext,B)
            <=> v136689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1898,axiom,
    ! [VarNext: state_type] :
      ( v136724(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136689(VarNext,B)
          <=> v136734(VarNext,B) ) ) ) ).

tff(addAssignment_76862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136734(VarNext,B)
          <=> v136732(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136732(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1428,axiom,
    ! [VarCurr: state_type] :
      ( v136735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136732(VarCurr,B)
          <=> v136699(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17995,axiom,
    ! [VarCurr: state_type] :
      ( v136735(VarCurr)
    <=> ( v136736(VarCurr)
        & v136737(VarCurr) ) ) ).

tff(writeUnaryOperator_10150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136737(VarCurr)
    <=> v136695(VarCurr) ) ).

tff(writeUnaryOperator_10149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136736(VarCurr)
    <=> v136691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136724(VarNext)
      <=> v136725(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136725(VarNext)
      <=> ( v136726(VarNext)
          & v136719(VarNext) ) ) ) ).

tff(writeUnaryOperator_10148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136726(VarNext)
      <=> v136728(VarNext) ) ) ).

tff(addAssignment_76861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136728(VarNext)
      <=> v136719(VarCurr) ) ) ).

tff(addAssignment_76860,axiom,
    ! [VarCurr: state_type] :
      ( v136719(VarCurr)
    <=> v136721(VarCurr) ) ).

tff(addAssignment_76859,axiom,
    ! [VarCurr: state_type] :
      ( v136721(VarCurr)
    <=> v117596(VarCurr) ) ).

tff(addAssignment_76858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136699(VarCurr,B)
      <=> v136701(VarCurr,B) ) ) ).

tff(addAssignment_76857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136701(VarCurr,B)
      <=> v136703(VarCurr,B) ) ) ).

tff(addAssignment_76856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136703(VarCurr,B)
      <=> v136705(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136705(VarCurr,B)
          <=> v136710(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1427,axiom,
    ! [VarCurr: state_type] :
      ( v136707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136705(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136683(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136710(VarCurr,B)
          <=> v136711(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1426,axiom,
    ! [VarCurr: state_type] :
      ( v136683(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136710(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76855,axiom,
    ! [VarCurr: state_type] :
      ( v136711(VarCurr,0)
    <=> v136715(VarCurr) ) ).

tff(addAssignment_76854,axiom,
    ! [VarCurr: state_type] :
      ( v136711(VarCurr,1)
    <=> v136713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17992,axiom,
    ! [VarCurr: state_type] :
      ( v136713(VarCurr)
    <=> ( v136714(VarCurr)
        & v136716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17991,axiom,
    ! [VarCurr: state_type] :
      ( v136716(VarCurr)
    <=> ( v136685(VarCurr,0)
        | v136717(VarCurr) ) ) ).

tff(writeUnaryOperator_10147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136717(VarCurr)
    <=> v136685(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6210,axiom,
    ! [VarCurr: state_type] :
      ( v136714(VarCurr)
    <=> ( v136715(VarCurr)
        | v136685(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136715(VarCurr)
    <=> v136685(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6209,axiom,
    ! [VarCurr: state_type] :
      ( v136707(VarCurr)
    <=> ( v117116(VarCurr,3)
        & v117687(VarCurr) ) ) ).

tff(addAssignment_76853,axiom,
    ! [VarCurr: state_type] :
      ( v136695(VarCurr)
    <=> v136697(VarCurr) ) ).

tff(addAssignment_76852,axiom,
    ! [VarCurr: state_type] :
      ( v136697(VarCurr)
    <=> v117134(VarCurr) ) ).

tff(addAssignment_76851,axiom,
    ! [VarCurr: state_type] :
      ( v136691(VarCurr)
    <=> v136693(VarCurr) ) ).

tff(addAssignment_76850,axiom,
    ! [VarCurr: state_type] :
      ( v136693(VarCurr)
    <=> v117126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17990,axiom,
    ! [VarCurr: state_type] :
      ( v136619(VarCurr)
    <=> ( v116309(VarCurr,0)
        & v136621(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1794,axiom,
    ! [VarCurr: state_type] :
      ( v136621(VarCurr)
    <=> ( ( v136623(VarCurr,1)
        <=> $false )
        & ( v136623(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136623(VarCurr,B)
      <=> v136625(VarCurr,B) ) ) ).

tff(addAssignment_76848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136625(VarCurr,B)
      <=> v136627(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136662(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136627(VarNext,B)
            <=> v136627(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1897,axiom,
    ! [VarNext: state_type] :
      ( v136662(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136627(VarNext,B)
          <=> v136672(VarNext,B) ) ) ) ).

tff(addAssignment_76847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136672(VarNext,B)
          <=> v136670(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136673(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136670(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1425,axiom,
    ! [VarCurr: state_type] :
      ( v136673(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136670(VarCurr,B)
          <=> v136637(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17989,axiom,
    ! [VarCurr: state_type] :
      ( v136673(VarCurr)
    <=> ( v136674(VarCurr)
        & v136675(VarCurr) ) ) ).

tff(writeUnaryOperator_10145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136675(VarCurr)
    <=> v136633(VarCurr) ) ).

tff(writeUnaryOperator_10144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136674(VarCurr)
    <=> v136629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136662(VarNext)
      <=> v136663(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136663(VarNext)
      <=> ( v136664(VarNext)
          & v136657(VarNext) ) ) ) ).

tff(writeUnaryOperator_10143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136664(VarNext)
      <=> v136666(VarNext) ) ) ).

tff(addAssignment_76846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136666(VarNext)
      <=> v136657(VarCurr) ) ) ).

tff(addAssignment_76845,axiom,
    ! [VarCurr: state_type] :
      ( v136657(VarCurr)
    <=> v136659(VarCurr) ) ).

tff(addAssignment_76844,axiom,
    ! [VarCurr: state_type] :
      ( v136659(VarCurr)
    <=> v116795(VarCurr) ) ).

tff(addAssignment_76843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136637(VarCurr,B)
      <=> v136639(VarCurr,B) ) ) ).

tff(addAssignment_76842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136639(VarCurr,B)
      <=> v136641(VarCurr,B) ) ) ).

tff(addAssignment_76841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136641(VarCurr,B)
      <=> v136643(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136643(VarCurr,B)
          <=> v136648(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1424,axiom,
    ! [VarCurr: state_type] :
      ( v136645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136643(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136648(VarCurr,B)
          <=> v136649(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1423,axiom,
    ! [VarCurr: state_type] :
      ( v136621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136648(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76840,axiom,
    ! [VarCurr: state_type] :
      ( v136649(VarCurr,0)
    <=> v136653(VarCurr) ) ).

tff(addAssignment_76839,axiom,
    ! [VarCurr: state_type] :
      ( v136649(VarCurr,1)
    <=> v136651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17986,axiom,
    ! [VarCurr: state_type] :
      ( v136651(VarCurr)
    <=> ( v136652(VarCurr)
        & v136654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17985,axiom,
    ! [VarCurr: state_type] :
      ( v136654(VarCurr)
    <=> ( v136623(VarCurr,0)
        | v136655(VarCurr) ) ) ).

tff(writeUnaryOperator_10142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136655(VarCurr)
    <=> v136623(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6208,axiom,
    ! [VarCurr: state_type] :
      ( v136652(VarCurr)
    <=> ( v136653(VarCurr)
        | v136623(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136653(VarCurr)
    <=> v136623(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6207,axiom,
    ! [VarCurr: state_type] :
      ( v136645(VarCurr)
    <=> ( v116309(VarCurr,3)
        & v116886(VarCurr) ) ) ).

tff(addAssignment_76838,axiom,
    ! [VarCurr: state_type] :
      ( v136633(VarCurr)
    <=> v136635(VarCurr) ) ).

tff(addAssignment_76837,axiom,
    ! [VarCurr: state_type] :
      ( v136635(VarCurr)
    <=> v116327(VarCurr) ) ).

tff(addAssignment_76836,axiom,
    ! [VarCurr: state_type] :
      ( v136629(VarCurr)
    <=> v136631(VarCurr) ) ).

tff(addAssignment_76835,axiom,
    ! [VarCurr: state_type] :
      ( v136631(VarCurr)
    <=> v116319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17984,axiom,
    ! [VarCurr: state_type] :
      ( v136557(VarCurr)
    <=> ( v115502(VarCurr,0)
        & v136559(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1793,axiom,
    ! [VarCurr: state_type] :
      ( v136559(VarCurr)
    <=> ( ( v136561(VarCurr,1)
        <=> $false )
        & ( v136561(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136561(VarCurr,B)
      <=> v136563(VarCurr,B) ) ) ).

tff(addAssignment_76833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136563(VarCurr,B)
      <=> v136565(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136600(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136565(VarNext,B)
            <=> v136565(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1896,axiom,
    ! [VarNext: state_type] :
      ( v136600(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136565(VarNext,B)
          <=> v136610(VarNext,B) ) ) ) ).

tff(addAssignment_76832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136610(VarNext,B)
          <=> v136608(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136611(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136608(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1422,axiom,
    ! [VarCurr: state_type] :
      ( v136611(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136608(VarCurr,B)
          <=> v136575(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17983,axiom,
    ! [VarCurr: state_type] :
      ( v136611(VarCurr)
    <=> ( v136612(VarCurr)
        & v136613(VarCurr) ) ) ).

tff(writeUnaryOperator_10140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136613(VarCurr)
    <=> v136571(VarCurr) ) ).

tff(writeUnaryOperator_10139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136612(VarCurr)
    <=> v136567(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136600(VarNext)
      <=> v136601(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136601(VarNext)
      <=> ( v136602(VarNext)
          & v136595(VarNext) ) ) ) ).

tff(writeUnaryOperator_10138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136602(VarNext)
      <=> v136604(VarNext) ) ) ).

tff(addAssignment_76831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136604(VarNext)
      <=> v136595(VarCurr) ) ) ).

tff(addAssignment_76830,axiom,
    ! [VarCurr: state_type] :
      ( v136595(VarCurr)
    <=> v136597(VarCurr) ) ).

tff(addAssignment_76829,axiom,
    ! [VarCurr: state_type] :
      ( v136597(VarCurr)
    <=> v115988(VarCurr) ) ).

tff(addAssignment_76828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136575(VarCurr,B)
      <=> v136577(VarCurr,B) ) ) ).

tff(addAssignment_76827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136577(VarCurr,B)
      <=> v136579(VarCurr,B) ) ) ).

tff(addAssignment_76826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136579(VarCurr,B)
      <=> v136581(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136583(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136581(VarCurr,B)
          <=> v136586(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1421,axiom,
    ! [VarCurr: state_type] :
      ( v136583(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136581(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136559(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136586(VarCurr,B)
          <=> v136587(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1420,axiom,
    ! [VarCurr: state_type] :
      ( v136559(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136586(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76825,axiom,
    ! [VarCurr: state_type] :
      ( v136587(VarCurr,0)
    <=> v136591(VarCurr) ) ).

tff(addAssignment_76824,axiom,
    ! [VarCurr: state_type] :
      ( v136587(VarCurr,1)
    <=> v136589(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17980,axiom,
    ! [VarCurr: state_type] :
      ( v136589(VarCurr)
    <=> ( v136590(VarCurr)
        & v136592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17979,axiom,
    ! [VarCurr: state_type] :
      ( v136592(VarCurr)
    <=> ( v136561(VarCurr,0)
        | v136593(VarCurr) ) ) ).

tff(writeUnaryOperator_10137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136593(VarCurr)
    <=> v136561(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6206,axiom,
    ! [VarCurr: state_type] :
      ( v136590(VarCurr)
    <=> ( v136591(VarCurr)
        | v136561(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136591(VarCurr)
    <=> v136561(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6205,axiom,
    ! [VarCurr: state_type] :
      ( v136583(VarCurr)
    <=> ( v115502(VarCurr,3)
        & v116079(VarCurr) ) ) ).

tff(addAssignment_76823,axiom,
    ! [VarCurr: state_type] :
      ( v136571(VarCurr)
    <=> v136573(VarCurr) ) ).

tff(addAssignment_76822,axiom,
    ! [VarCurr: state_type] :
      ( v136573(VarCurr)
    <=> v115520(VarCurr) ) ).

tff(addAssignment_76821,axiom,
    ! [VarCurr: state_type] :
      ( v136567(VarCurr)
    <=> v136569(VarCurr) ) ).

tff(addAssignment_76820,axiom,
    ! [VarCurr: state_type] :
      ( v136569(VarCurr)
    <=> v115512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17978,axiom,
    ! [VarCurr: state_type] :
      ( v136495(VarCurr)
    <=> ( v114489(VarCurr,0)
        & v136497(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1792,axiom,
    ! [VarCurr: state_type] :
      ( v136497(VarCurr)
    <=> ( ( v136499(VarCurr,1)
        <=> $false )
        & ( v136499(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136499(VarCurr,B)
      <=> v136501(VarCurr,B) ) ) ).

tff(addAssignment_76818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136501(VarCurr,B)
      <=> v136503(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136538(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136503(VarNext,B)
            <=> v136503(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1895,axiom,
    ! [VarNext: state_type] :
      ( v136538(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136503(VarNext,B)
          <=> v136548(VarNext,B) ) ) ) ).

tff(addAssignment_76817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136548(VarNext,B)
          <=> v136546(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136546(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1419,axiom,
    ! [VarCurr: state_type] :
      ( v136549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136546(VarCurr,B)
          <=> v136513(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17977,axiom,
    ! [VarCurr: state_type] :
      ( v136549(VarCurr)
    <=> ( v136550(VarCurr)
        & v136551(VarCurr) ) ) ).

tff(writeUnaryOperator_10135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136551(VarCurr)
    <=> v136509(VarCurr) ) ).

tff(writeUnaryOperator_10134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136550(VarCurr)
    <=> v136505(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136538(VarNext)
      <=> v136539(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136539(VarNext)
      <=> ( v136540(VarNext)
          & v136533(VarNext) ) ) ) ).

tff(writeUnaryOperator_10133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136540(VarNext)
      <=> v136542(VarNext) ) ) ).

tff(addAssignment_76816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136542(VarNext)
      <=> v136533(VarCurr) ) ) ).

tff(addAssignment_76815,axiom,
    ! [VarCurr: state_type] :
      ( v136533(VarCurr)
    <=> v136535(VarCurr) ) ).

tff(addAssignment_76814,axiom,
    ! [VarCurr: state_type] :
      ( v136535(VarCurr)
    <=> v115117(VarCurr) ) ).

tff(addAssignment_76813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136513(VarCurr,B)
      <=> v136515(VarCurr,B) ) ) ).

tff(addAssignment_76812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136515(VarCurr,B)
      <=> v136517(VarCurr,B) ) ) ).

tff(addAssignment_76811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136517(VarCurr,B)
      <=> v136519(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136521(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136519(VarCurr,B)
          <=> v136524(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1418,axiom,
    ! [VarCurr: state_type] :
      ( v136521(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136519(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136497(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136524(VarCurr,B)
          <=> v136525(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1417,axiom,
    ! [VarCurr: state_type] :
      ( v136497(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136524(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76810,axiom,
    ! [VarCurr: state_type] :
      ( v136525(VarCurr,0)
    <=> v136529(VarCurr) ) ).

tff(addAssignment_76809,axiom,
    ! [VarCurr: state_type] :
      ( v136525(VarCurr,1)
    <=> v136527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17974,axiom,
    ! [VarCurr: state_type] :
      ( v136527(VarCurr)
    <=> ( v136528(VarCurr)
        & v136530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17973,axiom,
    ! [VarCurr: state_type] :
      ( v136530(VarCurr)
    <=> ( v136499(VarCurr,0)
        | v136531(VarCurr) ) ) ).

tff(writeUnaryOperator_10132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136531(VarCurr)
    <=> v136499(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6204,axiom,
    ! [VarCurr: state_type] :
      ( v136528(VarCurr)
    <=> ( v136529(VarCurr)
        | v136499(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136529(VarCurr)
    <=> v136499(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6203,axiom,
    ! [VarCurr: state_type] :
      ( v136521(VarCurr)
    <=> ( v114489(VarCurr,3)
        & v115272(VarCurr) ) ) ).

tff(addAssignment_76808,axiom,
    ! [VarCurr: state_type] :
      ( v136509(VarCurr)
    <=> v136511(VarCurr) ) ).

tff(addAssignment_76807,axiom,
    ! [VarCurr: state_type] :
      ( v136511(VarCurr)
    <=> v114507(VarCurr) ) ).

tff(addAssignment_76806,axiom,
    ! [VarCurr: state_type] :
      ( v136505(VarCurr)
    <=> v136507(VarCurr) ) ).

tff(addAssignment_76805,axiom,
    ! [VarCurr: state_type] :
      ( v136507(VarCurr)
    <=> v114499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17972,axiom,
    ! [VarCurr: state_type] :
      ( v85712(VarCurr)
    <=> ( v85714(VarCurr,0)
        & v136435(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1791,axiom,
    ! [VarCurr: state_type] :
      ( v136435(VarCurr)
    <=> ( ( v136437(VarCurr,1)
        <=> $false )
        & ( v136437(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136437(VarCurr,B)
      <=> v136439(VarCurr,B) ) ) ).

tff(addAssignment_76803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136439(VarCurr,B)
      <=> v136441(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136476(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v136441(VarNext,B)
            <=> v136441(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1894,axiom,
    ! [VarNext: state_type] :
      ( v136476(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136441(VarNext,B)
          <=> v136486(VarNext,B) ) ) ) ).

tff(addAssignment_76802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136486(VarNext,B)
          <=> v136484(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136484(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1416,axiom,
    ! [VarCurr: state_type] :
      ( v136487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136484(VarCurr,B)
          <=> v136451(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17971,axiom,
    ! [VarCurr: state_type] :
      ( v136487(VarCurr)
    <=> ( v136488(VarCurr)
        & v136489(VarCurr) ) ) ).

tff(writeUnaryOperator_10130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136489(VarCurr)
    <=> v136447(VarCurr) ) ).

tff(writeUnaryOperator_10129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136488(VarCurr)
    <=> v136443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136476(VarNext)
      <=> v136477(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136477(VarNext)
      <=> ( v136478(VarNext)
          & v136471(VarNext) ) ) ) ).

tff(writeUnaryOperator_10128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136478(VarNext)
      <=> v136480(VarNext) ) ) ).

tff(addAssignment_76801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136480(VarNext)
      <=> v136471(VarCurr) ) ) ).

tff(addAssignment_76800,axiom,
    ! [VarCurr: state_type] :
      ( v136471(VarCurr)
    <=> v136473(VarCurr) ) ).

tff(addAssignment_76799,axiom,
    ! [VarCurr: state_type] :
      ( v136473(VarCurr)
    <=> v112783(VarCurr) ) ).

tff(addAssignment_76798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136451(VarCurr,B)
      <=> v136453(VarCurr,B) ) ) ).

tff(addAssignment_76797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136453(VarCurr,B)
      <=> v136455(VarCurr,B) ) ) ).

tff(addAssignment_76796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v136455(VarCurr,B)
      <=> v136457(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136459(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136457(VarCurr,B)
          <=> v136462(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1415,axiom,
    ! [VarCurr: state_type] :
      ( v136459(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136457(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136435(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136462(VarCurr,B)
          <=> v136463(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1414,axiom,
    ! [VarCurr: state_type] :
      ( v136435(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v136462(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_76795,axiom,
    ! [VarCurr: state_type] :
      ( v136463(VarCurr,0)
    <=> v136467(VarCurr) ) ).

tff(addAssignment_76794,axiom,
    ! [VarCurr: state_type] :
      ( v136463(VarCurr,1)
    <=> v136465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17968,axiom,
    ! [VarCurr: state_type] :
      ( v136465(VarCurr)
    <=> ( v136466(VarCurr)
        & v136468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17967,axiom,
    ! [VarCurr: state_type] :
      ( v136468(VarCurr)
    <=> ( v136437(VarCurr,0)
        | v136469(VarCurr) ) ) ).

tff(writeUnaryOperator_10127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136469(VarCurr)
    <=> v136437(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6202,axiom,
    ! [VarCurr: state_type] :
      ( v136466(VarCurr)
    <=> ( v136467(VarCurr)
        | v136437(VarCurr,1) ) ) ).

tff(writeUnaryOperator_10126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136467(VarCurr)
    <=> v136437(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6201,axiom,
    ! [VarCurr: state_type] :
      ( v136459(VarCurr)
    <=> ( v85714(VarCurr,3)
        & v112829(VarCurr) ) ) ).

tff(addAssignment_76793,axiom,
    ! [VarCurr: state_type] :
      ( v136447(VarCurr)
    <=> v136449(VarCurr) ) ).

tff(addAssignment_76792,axiom,
    ! [VarCurr: state_type] :
      ( v136449(VarCurr)
    <=> v85734(VarCurr) ) ).

tff(addAssignment_76791,axiom,
    ! [VarCurr: state_type] :
      ( v136443(VarCurr)
    <=> v136445(VarCurr) ) ).

tff(addAssignment_76790,axiom,
    ! [VarCurr: state_type] :
      ( v136445(VarCurr)
    <=> v85726(VarCurr) ) ).

tff(writeUnaryOperator_10125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85714(VarCurr,0)
    <=> v85716(VarCurr) ) ).

tff(addAssignment_76789,axiom,
    ! [VarCurr: state_type] :
      ( v85716(VarCurr)
    <=> v85718(VarCurr,0) ) ).

tff(addAssignment_76788,axiom,
    ! [VarCurr: state_type] :
      ( v85718(VarCurr,0)
    <=> v85720(VarCurr,0) ) ).

tff(addAssignment_76787,axiom,
    ! [VarNext: state_type] :
      ( v85720(VarNext,0)
    <=> v136426(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136427(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v136426(VarNext,B)
            <=> v85720(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1893,axiom,
    ! [VarNext: state_type] :
      ( v136427(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v136426(VarNext,B)
          <=> v112796(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136427(VarNext)
      <=> v136428(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136428(VarNext)
      <=> ( v136430(VarNext)
          & v112779(VarNext) ) ) ) ).

tff(writeUnaryOperator_10124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136430(VarNext)
      <=> v112790(VarNext) ) ) ).

tff(addAssignment_76786,axiom,
    ! [VarCurr: state_type] :
      ( v85738(VarCurr,0)
    <=> v85740(VarCurr,0) ) ).

tff(addAssignment_76785,axiom,
    ! [VarCurr: state_type] :
      ( v85740(VarCurr,0)
    <=> v85742(VarCurr,0) ) ).

tff(addAssignment_76784,axiom,
    ! [VarCurr: state_type] :
      ( v85742(VarCurr,0)
    <=> v112777(VarCurr,0) ) ).

tff(writeUnaryOperator_10123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85744(VarCurr)
    <=> v85746(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136407(VarCurr)
     => ( v85746(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1413,axiom,
    ! [VarCurr: state_type] :
      ( v136407(VarCurr)
     => ( v85746(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17964,axiom,
    ! [VarCurr: state_type] :
      ( v136407(VarCurr)
    <=> ( v136408(VarCurr)
        | v136419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17963,axiom,
    ! [VarCurr: state_type] :
      ( v136419(VarCurr)
    <=> ( v136420(VarCurr)
        & v136423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17962,axiom,
    ! [VarCurr: state_type] :
      ( v136423(VarCurr)
    <=> ( v127020(VarCurr)
        & v127023(VarCurr) ) ) ).

tff(writeUnaryOperator_10122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136420(VarCurr)
    <=> v136421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17961,axiom,
    ! [VarCurr: state_type] :
      ( v136421(VarCurr)
    <=> ( v136422(VarCurr)
        | v126997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17960,axiom,
    ! [VarCurr: state_type] :
      ( v136422(VarCurr)
    <=> ( v112761(VarCurr)
        | v112776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17959,axiom,
    ! [VarCurr: state_type] :
      ( v136408(VarCurr)
    <=> ( v136409(VarCurr)
        | v136415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17958,axiom,
    ! [VarCurr: state_type] :
      ( v136415(VarCurr)
    <=> ( v136416(VarCurr)
        & v136418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17957,axiom,
    ! [VarCurr: state_type] :
      ( v136418(VarCurr)
    <=> ( v126995(VarCurr)
        & v126997(VarCurr) ) ) ).

tff(writeUnaryOperator_10121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136416(VarCurr)
    <=> v136417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17956,axiom,
    ! [VarCurr: state_type] :
      ( v136417(VarCurr)
    <=> ( v112761(VarCurr)
        | v112776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17955,axiom,
    ! [VarCurr: state_type] :
      ( v136409(VarCurr)
    <=> ( v136410(VarCurr)
        | v136412(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17954,axiom,
    ! [VarCurr: state_type] :
      ( v136412(VarCurr)
    <=> ( v136413(VarCurr)
        & v136414(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17953,axiom,
    ! [VarCurr: state_type] :
      ( v136414(VarCurr)
    <=> ( v112768(VarCurr)
        & v112776(VarCurr) ) ) ).

tff(writeUnaryOperator_10120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136413(VarCurr)
    <=> v112761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17952,axiom,
    ! [VarCurr: state_type] :
      ( v136410(VarCurr)
    <=> ( v136411(VarCurr)
        & v112761(VarCurr) ) ) ).

tff(writeUnaryOperator_10119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136411(VarCurr)
    <=> v112759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17951,axiom,
    ! [VarCurr: state_type] :
      ( v85748(VarCurr)
    <=> ( v136404(VarCurr)
        & v136405(VarCurr) ) ) ).

tff(writeUnaryOperator_10118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136405(VarCurr)
    <=> v136402(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1790,axiom,
    ! [VarCurr: state_type] :
      ( v136404(VarCurr)
    <=> ( ( v85750(VarCurr,5)
        <=> $false )
        & ( v85750(VarCurr,4)
        <=> $false )
        & ( v85750(VarCurr,3)
        <=> $false )
        & ( v85750(VarCurr,2)
        <=> $false )
        & ( v85750(VarCurr,1)
        <=> $false )
        & ( v85750(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76783,axiom,
    ! [VarCurr: state_type] :
      ( v136402(VarCurr)
    <=> v115139(VarCurr,0) ) ).

tff(addAssignment_76782,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,0)
    <=> v115159(VarCurr,0) ) ).

tff(addAssignment_76781,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,0)
    <=> v115142(VarCurr,0) ) ).

tff(addAssignment_76780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85750(VarCurr,B)
      <=> v85752(VarCurr,B) ) ) ).

tff(addAssignment_76779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85752(VarCurr,B)
      <=> v85754(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136385(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v85754(VarNext,B)
            <=> v85754(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1892,axiom,
    ! [VarNext: state_type] :
      ( v136385(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v85754(VarNext,B)
          <=> v136395(VarNext,B) ) ) ) ).

tff(addAssignment_76778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v136395(VarNext,B)
          <=> v136393(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136396(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v136393(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1412,axiom,
    ! [VarCurr: state_type] :
      ( v136396(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v136393(VarCurr,B)
          <=> v85764(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17950,axiom,
    ! [VarCurr: state_type] :
      ( v136396(VarCurr)
    <=> ( v136397(VarCurr)
        & v136398(VarCurr) ) ) ).

tff(writeUnaryOperator_10117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136398(VarCurr)
    <=> v85760(VarCurr) ) ).

tff(writeUnaryOperator_10116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136397(VarCurr)
    <=> v85756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136385(VarNext)
      <=> v136386(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136386(VarNext)
      <=> ( v136387(VarNext)
          & v136380(VarNext) ) ) ) ).

tff(writeUnaryOperator_10115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v136387(VarNext)
      <=> v136389(VarNext) ) ) ).

tff(addAssignment_76777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v136389(VarNext)
      <=> v136380(VarCurr) ) ) ).

tff(addAssignment_76776,axiom,
    ! [VarCurr: state_type] :
      ( v136380(VarCurr)
    <=> v136382(VarCurr) ) ).

tff(addAssignment_76775,axiom,
    ! [VarCurr: state_type] :
      ( v136382(VarCurr)
    <=> v112783(VarCurr) ) ).

tff(addAssignment_76774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85764(VarCurr,B)
      <=> v85766(VarCurr,B) ) ) ).

tff(addAssignment_76773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85766(VarCurr,B)
      <=> v85768(VarCurr,B) ) ) ).

tff(addAssignment_76772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85768(VarCurr,B)
      <=> v85770(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85770(VarCurr,B)
      <=> ( v136207(VarCurr,B)
          & v136210(VarCurr,B) ) ) ) ).

tff(addAssignment_76771,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,0)
    <=> v136375(VarCurr) ) ).

tff(addAssignment_76770,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,1)
    <=> v136370(VarCurr) ) ).

tff(addAssignment_76769,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,2)
    <=> v136365(VarCurr) ) ).

tff(addAssignment_76768,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,3)
    <=> v136360(VarCurr) ) ).

tff(addAssignment_76767,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,4)
    <=> v136355(VarCurr) ) ).

tff(addAssignment_76766,axiom,
    ! [VarCurr: state_type] :
      ( v136210(VarCurr,5)
    <=> v136212(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17947,axiom,
    ! [VarCurr: state_type] :
      ( v136375(VarCurr)
    <=> ( v136376(VarCurr)
        & v136378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17946,axiom,
    ! [VarCurr: state_type] :
      ( v136378(VarCurr)
    <=> ( v136199(VarCurr,0)
        | v136224(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17945,axiom,
    ! [VarCurr: state_type] :
      ( v136376(VarCurr)
    <=> ( v136301(VarCurr)
        | v136377(VarCurr) ) ) ).

tff(writeUnaryOperator_10114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136377(VarCurr)
    <=> v136224(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17944,axiom,
    ! [VarCurr: state_type] :
      ( v136370(VarCurr)
    <=> ( v136371(VarCurr)
        & v136374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17943,axiom,
    ! [VarCurr: state_type] :
      ( v136374(VarCurr)
    <=> ( v136223(VarCurr)
        | v136295(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17942,axiom,
    ! [VarCurr: state_type] :
      ( v136371(VarCurr)
    <=> ( v136372(VarCurr)
        | v136373(VarCurr) ) ) ).

tff(writeUnaryOperator_10113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136373(VarCurr)
    <=> v136295(VarCurr) ) ).

tff(writeUnaryOperator_10112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136372(VarCurr)
    <=> v136223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17941,axiom,
    ! [VarCurr: state_type] :
      ( v136365(VarCurr)
    <=> ( v136366(VarCurr)
        & v136369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17940,axiom,
    ! [VarCurr: state_type] :
      ( v136369(VarCurr)
    <=> ( v136221(VarCurr)
        | v136306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17939,axiom,
    ! [VarCurr: state_type] :
      ( v136366(VarCurr)
    <=> ( v136367(VarCurr)
        | v136368(VarCurr) ) ) ).

tff(writeUnaryOperator_10111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136368(VarCurr)
    <=> v136306(VarCurr) ) ).

tff(writeUnaryOperator_10110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136367(VarCurr)
    <=> v136221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17938,axiom,
    ! [VarCurr: state_type] :
      ( v136360(VarCurr)
    <=> ( v136361(VarCurr)
        & v136364(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17937,axiom,
    ! [VarCurr: state_type] :
      ( v136364(VarCurr)
    <=> ( v136219(VarCurr)
        | v136318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17936,axiom,
    ! [VarCurr: state_type] :
      ( v136361(VarCurr)
    <=> ( v136362(VarCurr)
        | v136363(VarCurr) ) ) ).

tff(writeUnaryOperator_10109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136363(VarCurr)
    <=> v136318(VarCurr) ) ).

tff(writeUnaryOperator_10108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136362(VarCurr)
    <=> v136219(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17935,axiom,
    ! [VarCurr: state_type] :
      ( v136355(VarCurr)
    <=> ( v136356(VarCurr)
        & v136359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17934,axiom,
    ! [VarCurr: state_type] :
      ( v136359(VarCurr)
    <=> ( v136217(VarCurr)
        | v136330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17933,axiom,
    ! [VarCurr: state_type] :
      ( v136356(VarCurr)
    <=> ( v136357(VarCurr)
        | v136358(VarCurr) ) ) ).

tff(writeUnaryOperator_10107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136358(VarCurr)
    <=> v136330(VarCurr) ) ).

tff(writeUnaryOperator_10106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136357(VarCurr)
    <=> v136217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17932,axiom,
    ! [VarCurr: state_type] :
      ( v136212(VarCurr)
    <=> ( v136213(VarCurr)
        & v136354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17931,axiom,
    ! [VarCurr: state_type] :
      ( v136354(VarCurr)
    <=> ( v136215(VarCurr)
        | v136343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17930,axiom,
    ! [VarCurr: state_type] :
      ( v136213(VarCurr)
    <=> ( v136214(VarCurr)
        | v136342(VarCurr) ) ) ).

tff(writeUnaryOperator_10105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136342(VarCurr)
    <=> v136343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17929,axiom,
    ! [VarCurr: state_type] :
      ( v136343(VarCurr)
    <=> ( v136344(VarCurr)
        & v136353(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6200,axiom,
    ! [VarCurr: state_type] :
      ( v136353(VarCurr)
    <=> ( v136346(VarCurr)
        | v136224(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17928,axiom,
    ! [VarCurr: state_type] :
      ( v136344(VarCurr)
    <=> ( v136345(VarCurr)
        | v136352(VarCurr) ) ) ).

tff(writeUnaryOperator_10104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136352(VarCurr)
    <=> v136224(VarCurr,5) ) ).

tff(writeUnaryOperator_10103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136345(VarCurr)
    <=> v136346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17927,axiom,
    ! [VarCurr: state_type] :
      ( v136346(VarCurr)
    <=> ( v136347(VarCurr)
        & v136350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17926,axiom,
    ! [VarCurr: state_type] :
      ( v136350(VarCurr)
    <=> ( v136349(VarCurr)
        | v136351(VarCurr) ) ) ).

tff(writeUnaryOperator_10102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136351(VarCurr)
    <=> v136199(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6199,axiom,
    ! [VarCurr: state_type] :
      ( v136347(VarCurr)
    <=> ( v136348(VarCurr)
        | v136199(VarCurr,5) ) ) ).

tff(writeUnaryOperator_10101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136348(VarCurr)
    <=> v136349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17925,axiom,
    ! [VarCurr: state_type] :
      ( v136349(VarCurr)
    <=> ( v136336(VarCurr)
        & v136338(VarCurr) ) ) ).

tff(writeUnaryOperator_10100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136214(VarCurr)
    <=> v136215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17924,axiom,
    ! [VarCurr: state_type] :
      ( v136215(VarCurr)
    <=> ( v136216(VarCurr)
        | v136341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6198,axiom,
    ! [VarCurr: state_type] :
      ( v136341(VarCurr)
    <=> ( v136333(VarCurr)
        & v136224(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17923,axiom,
    ! [VarCurr: state_type] :
      ( v136216(VarCurr)
    <=> ( v136217(VarCurr)
        & v136330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17922,axiom,
    ! [VarCurr: state_type] :
      ( v136330(VarCurr)
    <=> ( v136331(VarCurr)
        & v136340(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6197,axiom,
    ! [VarCurr: state_type] :
      ( v136340(VarCurr)
    <=> ( v136333(VarCurr)
        | v136224(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17921,axiom,
    ! [VarCurr: state_type] :
      ( v136331(VarCurr)
    <=> ( v136332(VarCurr)
        | v136339(VarCurr) ) ) ).

tff(writeUnaryOperator_10099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136339(VarCurr)
    <=> v136224(VarCurr,4) ) ).

tff(writeUnaryOperator_10098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136332(VarCurr)
    <=> v136333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17920,axiom,
    ! [VarCurr: state_type] :
      ( v136333(VarCurr)
    <=> ( v136334(VarCurr)
        & v136337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17919,axiom,
    ! [VarCurr: state_type] :
      ( v136337(VarCurr)
    <=> ( v136336(VarCurr)
        | v136338(VarCurr) ) ) ).

tff(writeUnaryOperator_10097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136338(VarCurr)
    <=> v136199(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6196,axiom,
    ! [VarCurr: state_type] :
      ( v136334(VarCurr)
    <=> ( v136335(VarCurr)
        | v136199(VarCurr,4) ) ) ).

tff(writeUnaryOperator_10096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136335(VarCurr)
    <=> v136336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17918,axiom,
    ! [VarCurr: state_type] :
      ( v136336(VarCurr)
    <=> ( v136324(VarCurr)
        & v136326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17917,axiom,
    ! [VarCurr: state_type] :
      ( v136217(VarCurr)
    <=> ( v136218(VarCurr)
        | v136329(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6195,axiom,
    ! [VarCurr: state_type] :
      ( v136329(VarCurr)
    <=> ( v136321(VarCurr)
        & v136224(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17916,axiom,
    ! [VarCurr: state_type] :
      ( v136218(VarCurr)
    <=> ( v136219(VarCurr)
        & v136318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17915,axiom,
    ! [VarCurr: state_type] :
      ( v136318(VarCurr)
    <=> ( v136319(VarCurr)
        & v136328(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6194,axiom,
    ! [VarCurr: state_type] :
      ( v136328(VarCurr)
    <=> ( v136321(VarCurr)
        | v136224(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17914,axiom,
    ! [VarCurr: state_type] :
      ( v136319(VarCurr)
    <=> ( v136320(VarCurr)
        | v136327(VarCurr) ) ) ).

tff(writeUnaryOperator_10095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136327(VarCurr)
    <=> v136224(VarCurr,3) ) ).

tff(writeUnaryOperator_10094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136320(VarCurr)
    <=> v136321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17913,axiom,
    ! [VarCurr: state_type] :
      ( v136321(VarCurr)
    <=> ( v136322(VarCurr)
        & v136325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17912,axiom,
    ! [VarCurr: state_type] :
      ( v136325(VarCurr)
    <=> ( v136324(VarCurr)
        | v136326(VarCurr) ) ) ).

tff(writeUnaryOperator_10093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136326(VarCurr)
    <=> v136199(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6193,axiom,
    ! [VarCurr: state_type] :
      ( v136322(VarCurr)
    <=> ( v136323(VarCurr)
        | v136199(VarCurr,3) ) ) ).

tff(writeUnaryOperator_10092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136323(VarCurr)
    <=> v136324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17911,axiom,
    ! [VarCurr: state_type] :
      ( v136324(VarCurr)
    <=> ( v136312(VarCurr)
        & v136314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17910,axiom,
    ! [VarCurr: state_type] :
      ( v136219(VarCurr)
    <=> ( v136220(VarCurr)
        | v136317(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6192,axiom,
    ! [VarCurr: state_type] :
      ( v136317(VarCurr)
    <=> ( v136309(VarCurr)
        & v136224(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17909,axiom,
    ! [VarCurr: state_type] :
      ( v136220(VarCurr)
    <=> ( v136221(VarCurr)
        & v136306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17908,axiom,
    ! [VarCurr: state_type] :
      ( v136306(VarCurr)
    <=> ( v136307(VarCurr)
        & v136316(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6191,axiom,
    ! [VarCurr: state_type] :
      ( v136316(VarCurr)
    <=> ( v136309(VarCurr)
        | v136224(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17907,axiom,
    ! [VarCurr: state_type] :
      ( v136307(VarCurr)
    <=> ( v136308(VarCurr)
        | v136315(VarCurr) ) ) ).

tff(writeUnaryOperator_10091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136315(VarCurr)
    <=> v136224(VarCurr,2) ) ).

tff(writeUnaryOperator_10090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136308(VarCurr)
    <=> v136309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17906,axiom,
    ! [VarCurr: state_type] :
      ( v136309(VarCurr)
    <=> ( v136310(VarCurr)
        & v136313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17905,axiom,
    ! [VarCurr: state_type] :
      ( v136313(VarCurr)
    <=> ( v136312(VarCurr)
        | v136314(VarCurr) ) ) ).

tff(writeUnaryOperator_10089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136314(VarCurr)
    <=> v136199(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6190,axiom,
    ! [VarCurr: state_type] :
      ( v136310(VarCurr)
    <=> ( v136311(VarCurr)
        | v136199(VarCurr,2) ) ) ).

tff(writeUnaryOperator_10088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136311(VarCurr)
    <=> v136312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17904,axiom,
    ! [VarCurr: state_type] :
      ( v136312(VarCurr)
    <=> ( v136301(VarCurr)
        & v136302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17903,axiom,
    ! [VarCurr: state_type] :
      ( v136221(VarCurr)
    <=> ( v136222(VarCurr)
        | v136305(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6189,axiom,
    ! [VarCurr: state_type] :
      ( v136305(VarCurr)
    <=> ( v136298(VarCurr)
        & v136224(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17902,axiom,
    ! [VarCurr: state_type] :
      ( v136222(VarCurr)
    <=> ( v136223(VarCurr)
        & v136295(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17901,axiom,
    ! [VarCurr: state_type] :
      ( v136295(VarCurr)
    <=> ( v136296(VarCurr)
        & v136304(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6188,axiom,
    ! [VarCurr: state_type] :
      ( v136304(VarCurr)
    <=> ( v136298(VarCurr)
        | v136224(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17900,axiom,
    ! [VarCurr: state_type] :
      ( v136296(VarCurr)
    <=> ( v136297(VarCurr)
        | v136303(VarCurr) ) ) ).

tff(writeUnaryOperator_10087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136303(VarCurr)
    <=> v136224(VarCurr,1) ) ).

tff(writeUnaryOperator_10086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136297(VarCurr)
    <=> v136298(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17899,axiom,
    ! [VarCurr: state_type] :
      ( v136298(VarCurr)
    <=> ( v136299(VarCurr)
        & v136300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17898,axiom,
    ! [VarCurr: state_type] :
      ( v136300(VarCurr)
    <=> ( v136301(VarCurr)
        | v136302(VarCurr) ) ) ).

tff(writeUnaryOperator_10085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136302(VarCurr)
    <=> v136199(VarCurr,1) ) ).

tff(writeUnaryOperator_10084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136301(VarCurr)
    <=> v136199(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_6187,axiom,
    ! [VarCurr: state_type] :
      ( v136299(VarCurr)
    <=> ( v136199(VarCurr,0)
        | v136199(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17897,axiom,
    ! [VarCurr: state_type] :
      ( v136223(VarCurr)
    <=> ( v136199(VarCurr,0)
        & v136224(VarCurr,0) ) ) ).

tff(addAssignment_76765,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,0)
    <=> v136290(VarCurr) ) ).

tff(addAssignment_76764,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,1)
    <=> v136285(VarCurr) ) ).

tff(addAssignment_76763,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,2)
    <=> v136280(VarCurr) ) ).

tff(addAssignment_76762,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,3)
    <=> v136275(VarCurr) ) ).

tff(addAssignment_76761,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,4)
    <=> v136270(VarCurr) ) ).

tff(addAssignment_76760,axiom,
    ! [VarCurr: state_type] :
      ( v136224(VarCurr,5)
    <=> v136226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17896,axiom,
    ! [VarCurr: state_type] :
      ( v136290(VarCurr)
    <=> ( v136291(VarCurr)
        & v136294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17895,axiom,
    ! [VarCurr: state_type] :
      ( v136294(VarCurr)
    <=> ( v85750(VarCurr,0)
        | v136238(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17894,axiom,
    ! [VarCurr: state_type] :
      ( v136291(VarCurr)
    <=> ( v136292(VarCurr)
        | v136293(VarCurr) ) ) ).

tff(writeUnaryOperator_10083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136293(VarCurr)
    <=> v136238(VarCurr,0) ) ).

tff(writeUnaryOperator_10082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136292(VarCurr)
    <=> v85750(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17893,axiom,
    ! [VarCurr: state_type] :
      ( v136285(VarCurr)
    <=> ( v136286(VarCurr)
        & v136289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17892,axiom,
    ! [VarCurr: state_type] :
      ( v136289(VarCurr)
    <=> ( v136237(VarCurr)
        | v136239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17891,axiom,
    ! [VarCurr: state_type] :
      ( v136286(VarCurr)
    <=> ( v136287(VarCurr)
        | v136288(VarCurr) ) ) ).

tff(writeUnaryOperator_10081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136288(VarCurr)
    <=> v136239(VarCurr) ) ).

tff(writeUnaryOperator_10080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136287(VarCurr)
    <=> v136237(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17890,axiom,
    ! [VarCurr: state_type] :
      ( v136280(VarCurr)
    <=> ( v136281(VarCurr)
        & v136284(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17889,axiom,
    ! [VarCurr: state_type] :
      ( v136284(VarCurr)
    <=> ( v136235(VarCurr)
        | v136245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17888,axiom,
    ! [VarCurr: state_type] :
      ( v136281(VarCurr)
    <=> ( v136282(VarCurr)
        | v136283(VarCurr) ) ) ).

tff(writeUnaryOperator_10079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136283(VarCurr)
    <=> v136245(VarCurr) ) ).

tff(writeUnaryOperator_10078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136282(VarCurr)
    <=> v136235(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17887,axiom,
    ! [VarCurr: state_type] :
      ( v136275(VarCurr)
    <=> ( v136276(VarCurr)
        & v136279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17886,axiom,
    ! [VarCurr: state_type] :
      ( v136279(VarCurr)
    <=> ( v136233(VarCurr)
        | v136251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17885,axiom,
    ! [VarCurr: state_type] :
      ( v136276(VarCurr)
    <=> ( v136277(VarCurr)
        | v136278(VarCurr) ) ) ).

tff(writeUnaryOperator_10077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136278(VarCurr)
    <=> v136251(VarCurr) ) ).

tff(writeUnaryOperator_10076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136277(VarCurr)
    <=> v136233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17884,axiom,
    ! [VarCurr: state_type] :
      ( v136270(VarCurr)
    <=> ( v136271(VarCurr)
        & v136274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17883,axiom,
    ! [VarCurr: state_type] :
      ( v136274(VarCurr)
    <=> ( v136231(VarCurr)
        | v136257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17882,axiom,
    ! [VarCurr: state_type] :
      ( v136271(VarCurr)
    <=> ( v136272(VarCurr)
        | v136273(VarCurr) ) ) ).

tff(writeUnaryOperator_10075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136273(VarCurr)
    <=> v136257(VarCurr) ) ).

tff(writeUnaryOperator_10074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136272(VarCurr)
    <=> v136231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17881,axiom,
    ! [VarCurr: state_type] :
      ( v136226(VarCurr)
    <=> ( v136227(VarCurr)
        & v136269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17880,axiom,
    ! [VarCurr: state_type] :
      ( v136269(VarCurr)
    <=> ( v136229(VarCurr)
        | v136264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17879,axiom,
    ! [VarCurr: state_type] :
      ( v136227(VarCurr)
    <=> ( v136228(VarCurr)
        | v136263(VarCurr) ) ) ).

tff(writeUnaryOperator_10073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136263(VarCurr)
    <=> v136264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17878,axiom,
    ! [VarCurr: state_type] :
      ( v136264(VarCurr)
    <=> ( v136265(VarCurr)
        & v136268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6186,axiom,
    ! [VarCurr: state_type] :
      ( v136268(VarCurr)
    <=> ( v85750(VarCurr,5)
        | v136238(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17877,axiom,
    ! [VarCurr: state_type] :
      ( v136265(VarCurr)
    <=> ( v136266(VarCurr)
        | v136267(VarCurr) ) ) ).

tff(writeUnaryOperator_10072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136267(VarCurr)
    <=> v136238(VarCurr,5) ) ).

tff(writeUnaryOperator_10071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136266(VarCurr)
    <=> v85750(VarCurr,5) ) ).

tff(writeUnaryOperator_10070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136228(VarCurr)
    <=> v136229(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17876,axiom,
    ! [VarCurr: state_type] :
      ( v136229(VarCurr)
    <=> ( v136230(VarCurr)
        | v136262(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6185,axiom,
    ! [VarCurr: state_type] :
      ( v136262(VarCurr)
    <=> ( v85750(VarCurr,4)
        & v136238(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17875,axiom,
    ! [VarCurr: state_type] :
      ( v136230(VarCurr)
    <=> ( v136231(VarCurr)
        & v136257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17874,axiom,
    ! [VarCurr: state_type] :
      ( v136257(VarCurr)
    <=> ( v136258(VarCurr)
        & v136261(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6184,axiom,
    ! [VarCurr: state_type] :
      ( v136261(VarCurr)
    <=> ( v85750(VarCurr,4)
        | v136238(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17873,axiom,
    ! [VarCurr: state_type] :
      ( v136258(VarCurr)
    <=> ( v136259(VarCurr)
        | v136260(VarCurr) ) ) ).

tff(writeUnaryOperator_10069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136260(VarCurr)
    <=> v136238(VarCurr,4) ) ).

tff(writeUnaryOperator_10068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136259(VarCurr)
    <=> v85750(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17872,axiom,
    ! [VarCurr: state_type] :
      ( v136231(VarCurr)
    <=> ( v136232(VarCurr)
        | v136256(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6183,axiom,
    ! [VarCurr: state_type] :
      ( v136256(VarCurr)
    <=> ( v85750(VarCurr,3)
        & v136238(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17871,axiom,
    ! [VarCurr: state_type] :
      ( v136232(VarCurr)
    <=> ( v136233(VarCurr)
        & v136251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17870,axiom,
    ! [VarCurr: state_type] :
      ( v136251(VarCurr)
    <=> ( v136252(VarCurr)
        & v136255(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6182,axiom,
    ! [VarCurr: state_type] :
      ( v136255(VarCurr)
    <=> ( v85750(VarCurr,3)
        | v136238(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17869,axiom,
    ! [VarCurr: state_type] :
      ( v136252(VarCurr)
    <=> ( v136253(VarCurr)
        | v136254(VarCurr) ) ) ).

tff(writeUnaryOperator_10067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136254(VarCurr)
    <=> v136238(VarCurr,3) ) ).

tff(writeUnaryOperator_10066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136253(VarCurr)
    <=> v85750(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17868,axiom,
    ! [VarCurr: state_type] :
      ( v136233(VarCurr)
    <=> ( v136234(VarCurr)
        | v136250(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6181,axiom,
    ! [VarCurr: state_type] :
      ( v136250(VarCurr)
    <=> ( v85750(VarCurr,2)
        & v136238(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17867,axiom,
    ! [VarCurr: state_type] :
      ( v136234(VarCurr)
    <=> ( v136235(VarCurr)
        & v136245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17866,axiom,
    ! [VarCurr: state_type] :
      ( v136245(VarCurr)
    <=> ( v136246(VarCurr)
        & v136249(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6180,axiom,
    ! [VarCurr: state_type] :
      ( v136249(VarCurr)
    <=> ( v85750(VarCurr,2)
        | v136238(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17865,axiom,
    ! [VarCurr: state_type] :
      ( v136246(VarCurr)
    <=> ( v136247(VarCurr)
        | v136248(VarCurr) ) ) ).

tff(writeUnaryOperator_10065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136248(VarCurr)
    <=> v136238(VarCurr,2) ) ).

tff(writeUnaryOperator_10064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136247(VarCurr)
    <=> v85750(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17864,axiom,
    ! [VarCurr: state_type] :
      ( v136235(VarCurr)
    <=> ( v136236(VarCurr)
        | v136244(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6179,axiom,
    ! [VarCurr: state_type] :
      ( v136244(VarCurr)
    <=> ( v85750(VarCurr,1)
        & v136238(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17863,axiom,
    ! [VarCurr: state_type] :
      ( v136236(VarCurr)
    <=> ( v136237(VarCurr)
        & v136239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17862,axiom,
    ! [VarCurr: state_type] :
      ( v136239(VarCurr)
    <=> ( v136240(VarCurr)
        & v136243(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6178,axiom,
    ! [VarCurr: state_type] :
      ( v136243(VarCurr)
    <=> ( v85750(VarCurr,1)
        | v136238(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17861,axiom,
    ! [VarCurr: state_type] :
      ( v136240(VarCurr)
    <=> ( v136241(VarCurr)
        | v136242(VarCurr) ) ) ).

tff(writeUnaryOperator_10063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136242(VarCurr)
    <=> v136238(VarCurr,1) ) ).

tff(writeUnaryOperator_10062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136241(VarCurr)
    <=> v85750(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17860,axiom,
    ! [VarCurr: state_type] :
      ( v136237(VarCurr)
    <=> ( v85750(VarCurr,0)
        & v136238(VarCurr,0) ) ) ).

tff(addAssignment_76759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v136238(VarCurr,B)
      <=> v135990(VarCurr,B) ) ) ).

tff(addAssignment_76758,axiom,
    ! [VarCurr: state_type] :
      ( ( v136238(VarCurr,5)
      <=> $false )
      & ( v136238(VarCurr,4)
      <=> $false )
      & ( v136238(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_76757,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,0)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76756,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,1)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76755,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,2)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76754,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,3)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76753,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,4)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76752,axiom,
    ! [VarCurr: state_type] :
      ( v136207(VarCurr,5)
    <=> v136208(VarCurr) ) ).

tff(addAssignment_76751,axiom,
    ! [VarCurr: state_type] :
      ( v136208(VarCurr)
    <=> v136209(VarCurr) ) ).

tff(writeUnaryOperator_10061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136209(VarCurr)
    <=> v85772(VarCurr) ) ).

tff(addAssignment_76750,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,5)
    <=> v136200(VarCurr,5) ) ).

tff(addAssignment_76749,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,4)
    <=> v136200(VarCurr,4) ) ).

tff(addAssignment_76748,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,3)
    <=> v136200(VarCurr,3) ) ).

tff(addAssignment_76747,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,2)
    <=> v136200(VarCurr,2) ) ).

tff(addAssignment_76746,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,1)
    <=> v136200(VarCurr,1) ) ).

tff(addAssignment_76745,axiom,
    ! [VarCurr: state_type] :
      ( v136199(VarCurr,0)
    <=> v136200(VarCurr,0) ) ).

tff(addAssignment_76744,axiom,
    ! [VarCurr: state_type] :
      ( v136200(VarCurr,0)
    <=> v136201(VarCurr) ) ).

tff(addAssignment_76743,axiom,
    ! [VarCurr: state_type] :
      ( ( v136200(VarCurr,5)
      <=> $false )
      & ( v136200(VarCurr,4)
      <=> $false )
      & ( v136200(VarCurr,3)
      <=> $false )
      & ( v136200(VarCurr,2)
      <=> $false )
      & ( v136200(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17859,axiom,
    ! [VarCurr: state_type] :
      ( v136201(VarCurr)
    <=> ( v136202(VarCurr)
        | v113909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17858,axiom,
    ! [VarCurr: state_type] :
      ( v136202(VarCurr)
    <=> ( v136203(VarCurr)
        | v113105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17857,axiom,
    ! [VarCurr: state_type] :
      ( v136203(VarCurr)
    <=> ( v136204(VarCurr)
        | v113098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17856,axiom,
    ! [VarCurr: state_type] :
      ( v136204(VarCurr)
    <=> ( v136205(VarCurr)
        | v113808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17855,axiom,
    ! [VarCurr: state_type] :
      ( v136205(VarCurr)
    <=> ( v112938(VarCurr)
        | v113018(VarCurr) ) ) ).

tff(addAssignment_76742,axiom,
    ! [VarCurr: state_type] :
      ( v135990(VarCurr,2)
    <=> v136005(VarCurr,2) ) ).

tff(addAssignment_76741,axiom,
    ! [VarCurr: state_type] :
      ( v135990(VarCurr,1)
    <=> v136005(VarCurr,1) ) ).

tff(addAssignment_76740,axiom,
    ! [VarCurr: state_type] :
      ( v135990(VarCurr,0)
    <=> v136005(VarCurr,0) ) ).

tff(addAssignment_76739,axiom,
    ! [VarCurr: state_type] :
      ( v136005(VarCurr,0)
    <=> v136193(VarCurr) ) ).

tff(addAssignment_76738,axiom,
    ! [VarCurr: state_type] :
      ( v136005(VarCurr,1)
    <=> v136188(VarCurr) ) ).

tff(addAssignment_76737,axiom,
    ! [VarCurr: state_type] :
      ( v136005(VarCurr,2)
    <=> v136007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17854,axiom,
    ! [VarCurr: state_type] :
      ( v136193(VarCurr)
    <=> ( v136194(VarCurr)
        & v136197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17853,axiom,
    ! [VarCurr: state_type] :
      ( v136197(VarCurr)
    <=> ( v136013(VarCurr,0)
        | v136174(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17852,axiom,
    ! [VarCurr: state_type] :
      ( v136194(VarCurr)
    <=> ( v136195(VarCurr)
        | v136196(VarCurr) ) ) ).

tff(writeUnaryOperator_10060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136196(VarCurr)
    <=> v136174(VarCurr,0) ) ).

tff(writeUnaryOperator_10059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136195(VarCurr)
    <=> v136013(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17851,axiom,
    ! [VarCurr: state_type] :
      ( v136188(VarCurr)
    <=> ( v136189(VarCurr)
        & v136192(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17850,axiom,
    ! [VarCurr: state_type] :
      ( v136192(VarCurr)
    <=> ( v136012(VarCurr)
        | v136175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17849,axiom,
    ! [VarCurr: state_type] :
      ( v136189(VarCurr)
    <=> ( v136190(VarCurr)
        | v136191(VarCurr) ) ) ).

tff(writeUnaryOperator_10058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136191(VarCurr)
    <=> v136175(VarCurr) ) ).

tff(writeUnaryOperator_10057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136190(VarCurr)
    <=> v136012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17848,axiom,
    ! [VarCurr: state_type] :
      ( v136007(VarCurr)
    <=> ( v136008(VarCurr)
        & v136187(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17847,axiom,
    ! [VarCurr: state_type] :
      ( v136187(VarCurr)
    <=> ( v136010(VarCurr)
        | v136182(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17846,axiom,
    ! [VarCurr: state_type] :
      ( v136008(VarCurr)
    <=> ( v136009(VarCurr)
        | v136181(VarCurr) ) ) ).

tff(writeUnaryOperator_10056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136181(VarCurr)
    <=> v136182(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17845,axiom,
    ! [VarCurr: state_type] :
      ( v136182(VarCurr)
    <=> ( v136183(VarCurr)
        & v136186(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6177,axiom,
    ! [VarCurr: state_type] :
      ( v136186(VarCurr)
    <=> ( v136013(VarCurr,2)
        | v136174(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17844,axiom,
    ! [VarCurr: state_type] :
      ( v136183(VarCurr)
    <=> ( v136184(VarCurr)
        | v136185(VarCurr) ) ) ).

tff(writeUnaryOperator_10055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136185(VarCurr)
    <=> v136174(VarCurr,2) ) ).

tff(writeUnaryOperator_10054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136184(VarCurr)
    <=> v136013(VarCurr,2) ) ).

tff(writeUnaryOperator_10053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136009(VarCurr)
    <=> v136010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17843,axiom,
    ! [VarCurr: state_type] :
      ( v136010(VarCurr)
    <=> ( v136011(VarCurr)
        | v136180(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6176,axiom,
    ! [VarCurr: state_type] :
      ( v136180(VarCurr)
    <=> ( v136013(VarCurr,1)
        & v136174(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17842,axiom,
    ! [VarCurr: state_type] :
      ( v136011(VarCurr)
    <=> ( v136012(VarCurr)
        & v136175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17841,axiom,
    ! [VarCurr: state_type] :
      ( v136175(VarCurr)
    <=> ( v136176(VarCurr)
        & v136179(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6175,axiom,
    ! [VarCurr: state_type] :
      ( v136179(VarCurr)
    <=> ( v136013(VarCurr,1)
        | v136174(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17840,axiom,
    ! [VarCurr: state_type] :
      ( v136176(VarCurr)
    <=> ( v136177(VarCurr)
        | v136178(VarCurr) ) ) ).

tff(writeUnaryOperator_10052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136178(VarCurr)
    <=> v136174(VarCurr,1) ) ).

tff(writeUnaryOperator_10051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136177(VarCurr)
    <=> v136013(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17839,axiom,
    ! [VarCurr: state_type] :
      ( v136012(VarCurr)
    <=> ( v136013(VarCurr,0)
        & v136174(VarCurr,0) ) ) ).

tff(addAssignment_76736,axiom,
    ! [VarCurr: state_type] :
      ( v136174(VarCurr,0)
    <=> v136004(VarCurr) ) ).

tff(addAssignment_76735,axiom,
    ! [VarCurr: state_type] :
      ( ( v136174(VarCurr,2)
      <=> $false )
      & ( v136174(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76734,axiom,
    ! [VarCurr: state_type] :
      ( v136013(VarCurr,0)
    <=> v136169(VarCurr) ) ).

tff(addAssignment_76733,axiom,
    ! [VarCurr: state_type] :
      ( v136013(VarCurr,1)
    <=> v136164(VarCurr) ) ).

tff(addAssignment_76732,axiom,
    ! [VarCurr: state_type] :
      ( v136013(VarCurr,2)
    <=> v136015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17838,axiom,
    ! [VarCurr: state_type] :
      ( v136169(VarCurr)
    <=> ( v136170(VarCurr)
        & v136173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17837,axiom,
    ! [VarCurr: state_type] :
      ( v136173(VarCurr)
    <=> ( v136021(VarCurr,0)
        | v136150(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17836,axiom,
    ! [VarCurr: state_type] :
      ( v136170(VarCurr)
    <=> ( v136171(VarCurr)
        | v136172(VarCurr) ) ) ).

tff(writeUnaryOperator_10050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136172(VarCurr)
    <=> v136150(VarCurr,0) ) ).

tff(writeUnaryOperator_10049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136171(VarCurr)
    <=> v136021(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17835,axiom,
    ! [VarCurr: state_type] :
      ( v136164(VarCurr)
    <=> ( v136165(VarCurr)
        & v136168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17834,axiom,
    ! [VarCurr: state_type] :
      ( v136168(VarCurr)
    <=> ( v136020(VarCurr)
        | v136151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17833,axiom,
    ! [VarCurr: state_type] :
      ( v136165(VarCurr)
    <=> ( v136166(VarCurr)
        | v136167(VarCurr) ) ) ).

tff(writeUnaryOperator_10048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136167(VarCurr)
    <=> v136151(VarCurr) ) ).

tff(writeUnaryOperator_10047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136166(VarCurr)
    <=> v136020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17832,axiom,
    ! [VarCurr: state_type] :
      ( v136015(VarCurr)
    <=> ( v136016(VarCurr)
        & v136163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17831,axiom,
    ! [VarCurr: state_type] :
      ( v136163(VarCurr)
    <=> ( v136018(VarCurr)
        | v136158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17830,axiom,
    ! [VarCurr: state_type] :
      ( v136016(VarCurr)
    <=> ( v136017(VarCurr)
        | v136157(VarCurr) ) ) ).

tff(writeUnaryOperator_10046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136157(VarCurr)
    <=> v136158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17829,axiom,
    ! [VarCurr: state_type] :
      ( v136158(VarCurr)
    <=> ( v136159(VarCurr)
        & v136162(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6174,axiom,
    ! [VarCurr: state_type] :
      ( v136162(VarCurr)
    <=> ( v136021(VarCurr,2)
        | v136150(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17828,axiom,
    ! [VarCurr: state_type] :
      ( v136159(VarCurr)
    <=> ( v136160(VarCurr)
        | v136161(VarCurr) ) ) ).

tff(writeUnaryOperator_10045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136161(VarCurr)
    <=> v136150(VarCurr,2) ) ).

tff(writeUnaryOperator_10044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136160(VarCurr)
    <=> v136021(VarCurr,2) ) ).

tff(writeUnaryOperator_10043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136017(VarCurr)
    <=> v136018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17827,axiom,
    ! [VarCurr: state_type] :
      ( v136018(VarCurr)
    <=> ( v136019(VarCurr)
        | v136156(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6173,axiom,
    ! [VarCurr: state_type] :
      ( v136156(VarCurr)
    <=> ( v136021(VarCurr,1)
        & v136150(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17826,axiom,
    ! [VarCurr: state_type] :
      ( v136019(VarCurr)
    <=> ( v136020(VarCurr)
        & v136151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17825,axiom,
    ! [VarCurr: state_type] :
      ( v136151(VarCurr)
    <=> ( v136152(VarCurr)
        & v136155(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6172,axiom,
    ! [VarCurr: state_type] :
      ( v136155(VarCurr)
    <=> ( v136021(VarCurr,1)
        | v136150(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17824,axiom,
    ! [VarCurr: state_type] :
      ( v136152(VarCurr)
    <=> ( v136153(VarCurr)
        | v136154(VarCurr) ) ) ).

tff(writeUnaryOperator_10042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136154(VarCurr)
    <=> v136150(VarCurr,1) ) ).

tff(writeUnaryOperator_10041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136153(VarCurr)
    <=> v136021(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17823,axiom,
    ! [VarCurr: state_type] :
      ( v136020(VarCurr)
    <=> ( v136021(VarCurr,0)
        & v136150(VarCurr,0) ) ) ).

tff(addAssignment_76731,axiom,
    ! [VarCurr: state_type] :
      ( v136150(VarCurr,0)
    <=> v136002(VarCurr) ) ).

tff(addAssignment_76730,axiom,
    ! [VarCurr: state_type] :
      ( ( v136150(VarCurr,2)
      <=> $false )
      & ( v136150(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76729,axiom,
    ! [VarCurr: state_type] :
      ( v136021(VarCurr,0)
    <=> v136145(VarCurr) ) ).

tff(addAssignment_76728,axiom,
    ! [VarCurr: state_type] :
      ( v136021(VarCurr,1)
    <=> v136140(VarCurr) ) ).

tff(addAssignment_76727,axiom,
    ! [VarCurr: state_type] :
      ( v136021(VarCurr,2)
    <=> v136023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17822,axiom,
    ! [VarCurr: state_type] :
      ( v136145(VarCurr)
    <=> ( v136146(VarCurr)
        & v136149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17821,axiom,
    ! [VarCurr: state_type] :
      ( v136149(VarCurr)
    <=> ( v136029(VarCurr,0)
        | v136126(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17820,axiom,
    ! [VarCurr: state_type] :
      ( v136146(VarCurr)
    <=> ( v136147(VarCurr)
        | v136148(VarCurr) ) ) ).

tff(writeUnaryOperator_10040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136148(VarCurr)
    <=> v136126(VarCurr,0) ) ).

tff(writeUnaryOperator_10039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136147(VarCurr)
    <=> v136029(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17819,axiom,
    ! [VarCurr: state_type] :
      ( v136140(VarCurr)
    <=> ( v136141(VarCurr)
        & v136144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17818,axiom,
    ! [VarCurr: state_type] :
      ( v136144(VarCurr)
    <=> ( v136028(VarCurr)
        | v136127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17817,axiom,
    ! [VarCurr: state_type] :
      ( v136141(VarCurr)
    <=> ( v136142(VarCurr)
        | v136143(VarCurr) ) ) ).

tff(writeUnaryOperator_10038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136143(VarCurr)
    <=> v136127(VarCurr) ) ).

tff(writeUnaryOperator_10037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136142(VarCurr)
    <=> v136028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17816,axiom,
    ! [VarCurr: state_type] :
      ( v136023(VarCurr)
    <=> ( v136024(VarCurr)
        & v136139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17815,axiom,
    ! [VarCurr: state_type] :
      ( v136139(VarCurr)
    <=> ( v136026(VarCurr)
        | v136134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17814,axiom,
    ! [VarCurr: state_type] :
      ( v136024(VarCurr)
    <=> ( v136025(VarCurr)
        | v136133(VarCurr) ) ) ).

tff(writeUnaryOperator_10036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136133(VarCurr)
    <=> v136134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17813,axiom,
    ! [VarCurr: state_type] :
      ( v136134(VarCurr)
    <=> ( v136135(VarCurr)
        & v136138(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6171,axiom,
    ! [VarCurr: state_type] :
      ( v136138(VarCurr)
    <=> ( v136029(VarCurr,2)
        | v136126(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17812,axiom,
    ! [VarCurr: state_type] :
      ( v136135(VarCurr)
    <=> ( v136136(VarCurr)
        | v136137(VarCurr) ) ) ).

tff(writeUnaryOperator_10035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136137(VarCurr)
    <=> v136126(VarCurr,2) ) ).

tff(writeUnaryOperator_10034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136136(VarCurr)
    <=> v136029(VarCurr,2) ) ).

tff(writeUnaryOperator_10033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136025(VarCurr)
    <=> v136026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17811,axiom,
    ! [VarCurr: state_type] :
      ( v136026(VarCurr)
    <=> ( v136027(VarCurr)
        | v136132(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6170,axiom,
    ! [VarCurr: state_type] :
      ( v136132(VarCurr)
    <=> ( v136029(VarCurr,1)
        & v136126(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17810,axiom,
    ! [VarCurr: state_type] :
      ( v136027(VarCurr)
    <=> ( v136028(VarCurr)
        & v136127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17809,axiom,
    ! [VarCurr: state_type] :
      ( v136127(VarCurr)
    <=> ( v136128(VarCurr)
        & v136131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6169,axiom,
    ! [VarCurr: state_type] :
      ( v136131(VarCurr)
    <=> ( v136029(VarCurr,1)
        | v136126(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17808,axiom,
    ! [VarCurr: state_type] :
      ( v136128(VarCurr)
    <=> ( v136129(VarCurr)
        | v136130(VarCurr) ) ) ).

tff(writeUnaryOperator_10032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136130(VarCurr)
    <=> v136126(VarCurr,1) ) ).

tff(writeUnaryOperator_10031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136129(VarCurr)
    <=> v136029(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17807,axiom,
    ! [VarCurr: state_type] :
      ( v136028(VarCurr)
    <=> ( v136029(VarCurr,0)
        & v136126(VarCurr,0) ) ) ).

tff(addAssignment_76726,axiom,
    ! [VarCurr: state_type] :
      ( v136126(VarCurr,0)
    <=> v136000(VarCurr) ) ).

tff(addAssignment_76725,axiom,
    ! [VarCurr: state_type] :
      ( ( v136126(VarCurr,2)
      <=> $false )
      & ( v136126(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76724,axiom,
    ! [VarCurr: state_type] :
      ( v136029(VarCurr,0)
    <=> v136121(VarCurr) ) ).

tff(addAssignment_76723,axiom,
    ! [VarCurr: state_type] :
      ( v136029(VarCurr,1)
    <=> v136116(VarCurr) ) ).

tff(addAssignment_76722,axiom,
    ! [VarCurr: state_type] :
      ( v136029(VarCurr,2)
    <=> v136031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17806,axiom,
    ! [VarCurr: state_type] :
      ( v136121(VarCurr)
    <=> ( v136122(VarCurr)
        & v136125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17805,axiom,
    ! [VarCurr: state_type] :
      ( v136125(VarCurr)
    <=> ( v136037(VarCurr,0)
        | v136102(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17804,axiom,
    ! [VarCurr: state_type] :
      ( v136122(VarCurr)
    <=> ( v136123(VarCurr)
        | v136124(VarCurr) ) ) ).

tff(writeUnaryOperator_10030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136124(VarCurr)
    <=> v136102(VarCurr,0) ) ).

tff(writeUnaryOperator_10029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136123(VarCurr)
    <=> v136037(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17803,axiom,
    ! [VarCurr: state_type] :
      ( v136116(VarCurr)
    <=> ( v136117(VarCurr)
        & v136120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17802,axiom,
    ! [VarCurr: state_type] :
      ( v136120(VarCurr)
    <=> ( v136036(VarCurr)
        | v136103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17801,axiom,
    ! [VarCurr: state_type] :
      ( v136117(VarCurr)
    <=> ( v136118(VarCurr)
        | v136119(VarCurr) ) ) ).

tff(writeUnaryOperator_10028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136119(VarCurr)
    <=> v136103(VarCurr) ) ).

tff(writeUnaryOperator_10027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136118(VarCurr)
    <=> v136036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17800,axiom,
    ! [VarCurr: state_type] :
      ( v136031(VarCurr)
    <=> ( v136032(VarCurr)
        & v136115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17799,axiom,
    ! [VarCurr: state_type] :
      ( v136115(VarCurr)
    <=> ( v136034(VarCurr)
        | v136110(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17798,axiom,
    ! [VarCurr: state_type] :
      ( v136032(VarCurr)
    <=> ( v136033(VarCurr)
        | v136109(VarCurr) ) ) ).

tff(writeUnaryOperator_10026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136109(VarCurr)
    <=> v136110(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17797,axiom,
    ! [VarCurr: state_type] :
      ( v136110(VarCurr)
    <=> ( v136111(VarCurr)
        & v136114(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6168,axiom,
    ! [VarCurr: state_type] :
      ( v136114(VarCurr)
    <=> ( v136037(VarCurr,2)
        | v136102(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17796,axiom,
    ! [VarCurr: state_type] :
      ( v136111(VarCurr)
    <=> ( v136112(VarCurr)
        | v136113(VarCurr) ) ) ).

tff(writeUnaryOperator_10025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136113(VarCurr)
    <=> v136102(VarCurr,2) ) ).

tff(writeUnaryOperator_10024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136112(VarCurr)
    <=> v136037(VarCurr,2) ) ).

tff(writeUnaryOperator_10023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136033(VarCurr)
    <=> v136034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17795,axiom,
    ! [VarCurr: state_type] :
      ( v136034(VarCurr)
    <=> ( v136035(VarCurr)
        | v136108(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6167,axiom,
    ! [VarCurr: state_type] :
      ( v136108(VarCurr)
    <=> ( v136037(VarCurr,1)
        & v136102(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17794,axiom,
    ! [VarCurr: state_type] :
      ( v136035(VarCurr)
    <=> ( v136036(VarCurr)
        & v136103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17793,axiom,
    ! [VarCurr: state_type] :
      ( v136103(VarCurr)
    <=> ( v136104(VarCurr)
        & v136107(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6166,axiom,
    ! [VarCurr: state_type] :
      ( v136107(VarCurr)
    <=> ( v136037(VarCurr,1)
        | v136102(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17792,axiom,
    ! [VarCurr: state_type] :
      ( v136104(VarCurr)
    <=> ( v136105(VarCurr)
        | v136106(VarCurr) ) ) ).

tff(writeUnaryOperator_10022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136106(VarCurr)
    <=> v136102(VarCurr,1) ) ).

tff(writeUnaryOperator_10021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136105(VarCurr)
    <=> v136037(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17791,axiom,
    ! [VarCurr: state_type] :
      ( v136036(VarCurr)
    <=> ( v136037(VarCurr,0)
        & v136102(VarCurr,0) ) ) ).

tff(addAssignment_76721,axiom,
    ! [VarCurr: state_type] :
      ( v136102(VarCurr,0)
    <=> v135998(VarCurr) ) ).

tff(addAssignment_76720,axiom,
    ! [VarCurr: state_type] :
      ( ( v136102(VarCurr,2)
      <=> $false )
      & ( v136102(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76719,axiom,
    ! [VarCurr: state_type] :
      ( v136037(VarCurr,0)
    <=> v136097(VarCurr) ) ).

tff(addAssignment_76718,axiom,
    ! [VarCurr: state_type] :
      ( v136037(VarCurr,1)
    <=> v136092(VarCurr) ) ).

tff(addAssignment_76717,axiom,
    ! [VarCurr: state_type] :
      ( v136037(VarCurr,2)
    <=> v136039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17790,axiom,
    ! [VarCurr: state_type] :
      ( v136097(VarCurr)
    <=> ( v136098(VarCurr)
        & v136101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17789,axiom,
    ! [VarCurr: state_type] :
      ( v136101(VarCurr)
    <=> ( v136045(VarCurr,0)
        | v136078(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17788,axiom,
    ! [VarCurr: state_type] :
      ( v136098(VarCurr)
    <=> ( v136099(VarCurr)
        | v136100(VarCurr) ) ) ).

tff(writeUnaryOperator_10020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136100(VarCurr)
    <=> v136078(VarCurr,0) ) ).

tff(writeUnaryOperator_10019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136099(VarCurr)
    <=> v136045(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17787,axiom,
    ! [VarCurr: state_type] :
      ( v136092(VarCurr)
    <=> ( v136093(VarCurr)
        & v136096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17786,axiom,
    ! [VarCurr: state_type] :
      ( v136096(VarCurr)
    <=> ( v136044(VarCurr)
        | v136079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17785,axiom,
    ! [VarCurr: state_type] :
      ( v136093(VarCurr)
    <=> ( v136094(VarCurr)
        | v136095(VarCurr) ) ) ).

tff(writeUnaryOperator_10018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136095(VarCurr)
    <=> v136079(VarCurr) ) ).

tff(writeUnaryOperator_10017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136094(VarCurr)
    <=> v136044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17784,axiom,
    ! [VarCurr: state_type] :
      ( v136039(VarCurr)
    <=> ( v136040(VarCurr)
        & v136091(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17783,axiom,
    ! [VarCurr: state_type] :
      ( v136091(VarCurr)
    <=> ( v136042(VarCurr)
        | v136086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17782,axiom,
    ! [VarCurr: state_type] :
      ( v136040(VarCurr)
    <=> ( v136041(VarCurr)
        | v136085(VarCurr) ) ) ).

tff(writeUnaryOperator_10016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136085(VarCurr)
    <=> v136086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17781,axiom,
    ! [VarCurr: state_type] :
      ( v136086(VarCurr)
    <=> ( v136087(VarCurr)
        & v136090(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6165,axiom,
    ! [VarCurr: state_type] :
      ( v136090(VarCurr)
    <=> ( v136045(VarCurr,2)
        | v136078(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17780,axiom,
    ! [VarCurr: state_type] :
      ( v136087(VarCurr)
    <=> ( v136088(VarCurr)
        | v136089(VarCurr) ) ) ).

tff(writeUnaryOperator_10015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136089(VarCurr)
    <=> v136078(VarCurr,2) ) ).

tff(writeUnaryOperator_10014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136088(VarCurr)
    <=> v136045(VarCurr,2) ) ).

tff(writeUnaryOperator_10013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136041(VarCurr)
    <=> v136042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17779,axiom,
    ! [VarCurr: state_type] :
      ( v136042(VarCurr)
    <=> ( v136043(VarCurr)
        | v136084(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6164,axiom,
    ! [VarCurr: state_type] :
      ( v136084(VarCurr)
    <=> ( v136045(VarCurr,1)
        & v136078(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17778,axiom,
    ! [VarCurr: state_type] :
      ( v136043(VarCurr)
    <=> ( v136044(VarCurr)
        & v136079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17777,axiom,
    ! [VarCurr: state_type] :
      ( v136079(VarCurr)
    <=> ( v136080(VarCurr)
        & v136083(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6163,axiom,
    ! [VarCurr: state_type] :
      ( v136083(VarCurr)
    <=> ( v136045(VarCurr,1)
        | v136078(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17776,axiom,
    ! [VarCurr: state_type] :
      ( v136080(VarCurr)
    <=> ( v136081(VarCurr)
        | v136082(VarCurr) ) ) ).

tff(writeUnaryOperator_10012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136082(VarCurr)
    <=> v136078(VarCurr,1) ) ).

tff(writeUnaryOperator_10011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136081(VarCurr)
    <=> v136045(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17775,axiom,
    ! [VarCurr: state_type] :
      ( v136044(VarCurr)
    <=> ( v136045(VarCurr,0)
        & v136078(VarCurr,0) ) ) ).

tff(addAssignment_76716,axiom,
    ! [VarCurr: state_type] :
      ( v136078(VarCurr,0)
    <=> v135996(VarCurr) ) ).

tff(addAssignment_76715,axiom,
    ! [VarCurr: state_type] :
      ( ( v136078(VarCurr,2)
      <=> $false )
      & ( v136078(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76714,axiom,
    ! [VarCurr: state_type] :
      ( v136045(VarCurr,0)
    <=> v136073(VarCurr) ) ).

tff(addAssignment_76713,axiom,
    ! [VarCurr: state_type] :
      ( v136045(VarCurr,1)
    <=> v136068(VarCurr) ) ).

tff(addAssignment_76712,axiom,
    ! [VarCurr: state_type] :
      ( v136045(VarCurr,2)
    <=> v136047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17774,axiom,
    ! [VarCurr: state_type] :
      ( v136073(VarCurr)
    <=> ( v136074(VarCurr)
        & v136077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17773,axiom,
    ! [VarCurr: state_type] :
      ( v136077(VarCurr)
    <=> ( v136053(VarCurr,0)
        | v136054(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17772,axiom,
    ! [VarCurr: state_type] :
      ( v136074(VarCurr)
    <=> ( v136075(VarCurr)
        | v136076(VarCurr) ) ) ).

tff(writeUnaryOperator_10010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136076(VarCurr)
    <=> v136054(VarCurr,0) ) ).

tff(writeUnaryOperator_10009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136075(VarCurr)
    <=> v136053(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17771,axiom,
    ! [VarCurr: state_type] :
      ( v136068(VarCurr)
    <=> ( v136069(VarCurr)
        & v136072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17770,axiom,
    ! [VarCurr: state_type] :
      ( v136072(VarCurr)
    <=> ( v136052(VarCurr)
        | v136055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17769,axiom,
    ! [VarCurr: state_type] :
      ( v136069(VarCurr)
    <=> ( v136070(VarCurr)
        | v136071(VarCurr) ) ) ).

tff(writeUnaryOperator_10008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136071(VarCurr)
    <=> v136055(VarCurr) ) ).

tff(writeUnaryOperator_10007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136070(VarCurr)
    <=> v136052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17768,axiom,
    ! [VarCurr: state_type] :
      ( v136047(VarCurr)
    <=> ( v136048(VarCurr)
        & v136067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17767,axiom,
    ! [VarCurr: state_type] :
      ( v136067(VarCurr)
    <=> ( v136050(VarCurr)
        | v136062(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17766,axiom,
    ! [VarCurr: state_type] :
      ( v136048(VarCurr)
    <=> ( v136049(VarCurr)
        | v136061(VarCurr) ) ) ).

tff(writeUnaryOperator_10006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136061(VarCurr)
    <=> v136062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17765,axiom,
    ! [VarCurr: state_type] :
      ( v136062(VarCurr)
    <=> ( v136063(VarCurr)
        & v136066(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6162,axiom,
    ! [VarCurr: state_type] :
      ( v136066(VarCurr)
    <=> ( v136053(VarCurr,2)
        | v136054(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17764,axiom,
    ! [VarCurr: state_type] :
      ( v136063(VarCurr)
    <=> ( v136064(VarCurr)
        | v136065(VarCurr) ) ) ).

tff(writeUnaryOperator_10005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136065(VarCurr)
    <=> v136054(VarCurr,2) ) ).

tff(writeUnaryOperator_10004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136064(VarCurr)
    <=> v136053(VarCurr,2) ) ).

tff(writeUnaryOperator_10003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136049(VarCurr)
    <=> v136050(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17763,axiom,
    ! [VarCurr: state_type] :
      ( v136050(VarCurr)
    <=> ( v136051(VarCurr)
        | v136060(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6161,axiom,
    ! [VarCurr: state_type] :
      ( v136060(VarCurr)
    <=> ( v136053(VarCurr,1)
        & v136054(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17762,axiom,
    ! [VarCurr: state_type] :
      ( v136051(VarCurr)
    <=> ( v136052(VarCurr)
        & v136055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17761,axiom,
    ! [VarCurr: state_type] :
      ( v136055(VarCurr)
    <=> ( v136056(VarCurr)
        & v136059(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6160,axiom,
    ! [VarCurr: state_type] :
      ( v136059(VarCurr)
    <=> ( v136053(VarCurr,1)
        | v136054(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17760,axiom,
    ! [VarCurr: state_type] :
      ( v136056(VarCurr)
    <=> ( v136057(VarCurr)
        | v136058(VarCurr) ) ) ).

tff(writeUnaryOperator_10002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136058(VarCurr)
    <=> v136054(VarCurr,1) ) ).

tff(writeUnaryOperator_10001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v136057(VarCurr)
    <=> v136053(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17759,axiom,
    ! [VarCurr: state_type] :
      ( v136052(VarCurr)
    <=> ( v136053(VarCurr,0)
        & v136054(VarCurr,0) ) ) ).

tff(addAssignment_76711,axiom,
    ! [VarCurr: state_type] :
      ( v136054(VarCurr,0)
    <=> v135994(VarCurr) ) ).

tff(addAssignment_76710,axiom,
    ! [VarCurr: state_type] :
      ( ( v136054(VarCurr,2)
      <=> $false )
      & ( v136054(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76709,axiom,
    ! [VarCurr: state_type] :
      ( v136053(VarCurr,0)
    <=> v135992(VarCurr) ) ).

tff(addAssignment_76708,axiom,
    ! [VarCurr: state_type] :
      ( ( v136053(VarCurr,2)
      <=> $false )
      & ( v136053(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76707,axiom,
    ! [VarCurr: state_type] :
      ( v136004(VarCurr)
    <=> v114692(VarCurr,0) ) ).

tff(addAssignment_76706,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,0)
    <=> v114694(VarCurr,0) ) ).

tff(addAssignment_76705,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,0)
    <=> v114696(VarCurr,0) ) ).

tff(addAssignment_76704,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,0)
    <=> v114697(VarCurr,0) ) ).

tff(addAssignment_76703,axiom,
    ! [VarCurr: state_type] :
      ( v136002(VarCurr)
    <=> v114685(VarCurr,0) ) ).

tff(addAssignment_76702,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,0)
    <=> v114686(VarCurr,0) ) ).

tff(addAssignment_76701,axiom,
    ! [VarCurr: state_type] :
      ( v136000(VarCurr)
    <=> v114661(VarCurr,0) ) ).

tff(addAssignment_76700,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,0)
    <=> v114662(VarCurr,0) ) ).

tff(addAssignment_76699,axiom,
    ! [VarCurr: state_type] :
      ( v135998(VarCurr)
    <=> v114633(VarCurr,0) ) ).

tff(addAssignment_76698,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,0)
    <=> v114635(VarCurr,0) ) ).

tff(addAssignment_76697,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,0)
    <=> v114637(VarCurr,0) ) ).

tff(addAssignment_76696,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,0)
    <=> v114638(VarCurr,0) ) ).

tff(addAssignment_76695,axiom,
    ! [VarCurr: state_type] :
      ( v135996(VarCurr)
    <=> v114605(VarCurr,0) ) ).

tff(addAssignment_76694,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,0)
    <=> v114607(VarCurr,0) ) ).

tff(addAssignment_76693,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,0)
    <=> v114609(VarCurr,0) ) ).

tff(addAssignment_76692,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,0)
    <=> v114610(VarCurr,0) ) ).

tff(addAssignment_76691,axiom,
    ! [VarCurr: state_type] :
      ( v135994(VarCurr)
    <=> v114577(VarCurr,0) ) ).

tff(addAssignment_76690,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,0)
    <=> v114579(VarCurr,0) ) ).

tff(addAssignment_76689,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,0)
    <=> v114581(VarCurr,0) ) ).

tff(addAssignment_76688,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,0)
    <=> v114582(VarCurr,0) ) ).

tff(addAssignment_76687,axiom,
    ! [VarCurr: state_type] :
      ( v135992(VarCurr)
    <=> v114549(VarCurr,0) ) ).

tff(addAssignment_76686,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,0)
    <=> v114551(VarCurr,0) ) ).

tff(addAssignment_76685,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,0)
    <=> v114553(VarCurr,0) ) ).

tff(addAssignment_76684,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,0)
    <=> v114554(VarCurr,0) ) ).

tff(addAssignment_76683,axiom,
    ! [VarCurr: state_type] :
      ( v85772(VarCurr)
    <=> v85774(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17758,axiom,
    ! [VarCurr: state_type] :
      ( v85774(VarCurr)
    <=> ( v85776(VarCurr)
        & v135988(VarCurr) ) ) ).

tff(writeUnaryOperator_10000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135988(VarCurr)
    <=> v135958(VarCurr) ) ).

tff(addAssignment_76682,axiom,
    ! [VarCurr: state_type] :
      ( v135958(VarCurr)
    <=> v135960(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135971(VarNext)
       => ( v135960(VarNext)
        <=> v135960(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1891,axiom,
    ! [VarNext: state_type] :
      ( v135971(VarNext)
     => ( v135960(VarNext)
      <=> v135981(VarNext) ) ) ).

tff(addAssignment_76681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135981(VarNext)
      <=> v135979(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135982(VarCurr)
     => ( v135979(VarCurr)
      <=> x84230(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1411,axiom,
    ! [VarCurr: state_type] :
      ( v135982(VarCurr)
     => ( v135979(VarCurr)
      <=> v135966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17757,axiom,
    ! [VarCurr: state_type] :
      ( v135982(VarCurr)
    <=> ( v135983(VarCurr)
        & v135984(VarCurr) ) ) ).

tff(writeUnaryOperator_9999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135984(VarCurr)
    <=> v135964(VarCurr) ) ).

tff(writeUnaryOperator_9998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135983(VarCurr)
    <=> v135962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135971(VarNext)
      <=> v135972(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135972(VarNext)
      <=> ( v135973(VarNext)
          & v135968(VarNext) ) ) ) ).

tff(writeUnaryOperator_9997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135973(VarNext)
      <=> v135975(VarNext) ) ) ).

tff(addAssignment_76680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135975(VarNext)
      <=> v135968(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_263,axiom,
    ( v135960(constB0)
  <=> $false ) ).

tff(addAssignment_76679,axiom,
    ! [VarCurr: state_type] :
      ( v135968(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76678,axiom,
    ! [VarCurr: state_type] :
      ( v135966(VarCurr)
    <=> v85776(VarCurr) ) ).

tff(addAssignment_76677,axiom,
    ! [VarCurr: state_type] :
      ( v135964(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76676,axiom,
    ! [VarCurr: state_type] :
      ( v135962(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17754,axiom,
    ! [VarCurr: state_type] :
      ( v85776(VarCurr)
    <=> ( v135946(VarCurr)
        & v135956(VarCurr) ) ) ).

tff(writeUnaryOperator_9996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135956(VarCurr)
    <=> v5747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17753,axiom,
    ! [VarCurr: state_type] :
      ( v135946(VarCurr)
    <=> ( v135947(VarCurr)
        & v135955(VarCurr) ) ) ).

tff(writeUnaryOperator_9995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135955(VarCurr)
    <=> v86711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17752,axiom,
    ! [VarCurr: state_type] :
      ( v135947(VarCurr)
    <=> ( v135948(VarCurr)
        & v135954(VarCurr) ) ) ).

tff(writeUnaryOperator_9994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135954(VarCurr)
    <=> v85790(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17751,axiom,
    ! [VarCurr: state_type] :
      ( v135948(VarCurr)
    <=> ( v135949(VarCurr)
        & v135953(VarCurr) ) ) ).

tff(writeUnaryOperator_9993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135953(VarCurr)
    <=> v85786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17750,axiom,
    ! [VarCurr: state_type] :
      ( v135949(VarCurr)
    <=> ( v135950(VarCurr)
        & v135952(VarCurr) ) ) ).

tff(writeUnaryOperator_9992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135952(VarCurr)
    <=> v85782(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17749,axiom,
    ! [VarCurr: state_type] :
      ( v135950(VarCurr)
    <=> ( v5144(VarCurr)
        & v135951(VarCurr) ) ) ).

tff(writeUnaryOperator_9991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135951(VarCurr)
    <=> v85778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17748,axiom,
    ! [VarCurr: state_type] :
      ( v86711(VarCurr)
    <=> ( v86713(VarCurr)
        & v135944(VarCurr) ) ) ).

tff(writeUnaryOperator_9990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135944(VarCurr)
    <=> v135902(VarCurr) ) ).

tff(addAssignment_76675,axiom,
    ! [VarCurr: state_type] :
      ( v135902(VarCurr)
    <=> v135904(VarCurr) ) ).

tff(addAssignment_76674,axiom,
    ! [VarCurr: state_type] :
      ( v135904(VarCurr)
    <=> v135906(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135927(VarNext)
       => ( v135906(VarNext)
        <=> v135906(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1890,axiom,
    ! [VarNext: state_type] :
      ( v135927(VarNext)
     => ( v135906(VarNext)
      <=> v135937(VarNext) ) ) ).

tff(addAssignment_76673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135937(VarNext)
      <=> v135935(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135938(VarCurr)
     => ( v135935(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1410,axiom,
    ! [VarCurr: state_type] :
      ( v135938(VarCurr)
     => ( v135935(VarCurr)
      <=> v135916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17747,axiom,
    ! [VarCurr: state_type] :
      ( v135938(VarCurr)
    <=> ( v135939(VarCurr)
        & v135940(VarCurr) ) ) ).

tff(writeUnaryOperator_9989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135940(VarCurr)
    <=> v135912(VarCurr) ) ).

tff(writeUnaryOperator_9988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135939(VarCurr)
    <=> v135908(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135927(VarNext)
      <=> v135928(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135928(VarNext)
      <=> ( v135929(VarNext)
          & v135922(VarNext) ) ) ) ).

tff(writeUnaryOperator_9987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135929(VarNext)
      <=> v135931(VarNext) ) ) ).

tff(addAssignment_76672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135931(VarNext)
      <=> v135922(VarCurr) ) ) ).

tff(addAssignment_76671,axiom,
    ! [VarCurr: state_type] :
      ( v135922(VarCurr)
    <=> v135924(VarCurr) ) ).

tff(addAssignment_76670,axiom,
    ! [VarCurr: state_type] :
      ( v135924(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76669,axiom,
    ! [VarCurr: state_type] :
      ( v135916(VarCurr)
    <=> v135918(VarCurr) ) ).

tff(addAssignment_76668,axiom,
    ! [VarCurr: state_type] :
      ( v135918(VarCurr)
    <=> v135920(VarCurr) ) ).

tff(addAssignment_76667,axiom,
    ! [VarCurr: state_type] :
      ( v135920(VarCurr)
    <=> v86713(VarCurr) ) ).

tff(addAssignment_76666,axiom,
    ! [VarCurr: state_type] :
      ( v135912(VarCurr)
    <=> v135914(VarCurr) ) ).

tff(addAssignment_76665,axiom,
    ! [VarCurr: state_type] :
      ( v135914(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76664,axiom,
    ! [VarCurr: state_type] :
      ( v135908(VarCurr)
    <=> v135910(VarCurr) ) ).

tff(addAssignment_76663,axiom,
    ! [VarCurr: state_type] :
      ( v135910(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17744,axiom,
    ! [VarCurr: state_type] :
      ( v86713(VarCurr)
    <=> ( v135896(VarCurr)
        & v135186(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17743,axiom,
    ! [VarCurr: state_type] :
      ( v135896(VarCurr)
    <=> ( v135897(VarCurr)
        & v109663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17742,axiom,
    ! [VarCurr: state_type] :
      ( v135897(VarCurr)
    <=> ( v135898(VarCurr)
        & v135900(VarCurr) ) ) ).

tff(writeUnaryOperator_9986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135900(VarCurr)
    <=> v87198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17741,axiom,
    ! [VarCurr: state_type] :
      ( v135898(VarCurr)
    <=> ( v86715(VarCurr)
        & v135899(VarCurr) ) ) ).

tff(writeUnaryOperator_9985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135899(VarCurr)
    <=> v135825(VarCurr) ) ).

tff(addAssignment_76662,axiom,
    ! [VarCurr: state_type] :
      ( v135825(VarCurr)
    <=> v135827(VarCurr) ) ).

tff(addAssignment_76661,axiom,
    ! [VarCurr: state_type] :
      ( v135827(VarCurr)
    <=> v135829(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135879(VarNext)
       => ( v135829(VarNext)
        <=> v135829(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1889,axiom,
    ! [VarNext: state_type] :
      ( v135879(VarNext)
     => ( v135829(VarNext)
      <=> v135889(VarNext) ) ) ).

tff(addAssignment_76660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135889(VarNext)
      <=> v135887(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135890(VarCurr)
     => ( v135887(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1409,axiom,
    ! [VarCurr: state_type] :
      ( v135890(VarCurr)
     => ( v135887(VarCurr)
      <=> v135839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17740,axiom,
    ! [VarCurr: state_type] :
      ( v135890(VarCurr)
    <=> ( v135891(VarCurr)
        & v135892(VarCurr) ) ) ).

tff(writeUnaryOperator_9984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135892(VarCurr)
    <=> v135835(VarCurr) ) ).

tff(writeUnaryOperator_9983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135891(VarCurr)
    <=> v135831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135879(VarNext)
      <=> v135880(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135880(VarNext)
      <=> ( v135881(VarNext)
          & v135874(VarNext) ) ) ) ).

tff(writeUnaryOperator_9982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135881(VarNext)
      <=> v135883(VarNext) ) ) ).

tff(addAssignment_76659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135883(VarNext)
      <=> v135874(VarCurr) ) ) ).

tff(addAssignment_76658,axiom,
    ! [VarCurr: state_type] :
      ( v135874(VarCurr)
    <=> v135876(VarCurr) ) ).

tff(addAssignment_76657,axiom,
    ! [VarCurr: state_type] :
      ( v135876(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76656,axiom,
    ! [VarCurr: state_type] :
      ( v135839(VarCurr)
    <=> v135841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17737,axiom,
    ! [VarCurr: state_type] :
      ( v135841(VarCurr)
    <=> ( v135858(VarCurr)
        | v135865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17736,axiom,
    ! [VarCurr: state_type] :
      ( v135865(VarCurr)
    <=> ( v135866(VarCurr)
        & v135870(VarCurr) ) ) ).

tff(writeUnaryOperator_9981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135870(VarCurr)
    <=> v135871(VarCurr) ) ).

tff(addAssignment_76655,axiom,
    ! [VarCurr: state_type] :
      ( v135871(VarCurr)
    <=> v135872(VarCurr) ) ).

tff(addAssignment_76654,axiom,
    ! [VarCurr: state_type] :
      ( v135872(VarCurr)
    <=> v135847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17735,axiom,
    ! [VarCurr: state_type] :
      ( v135866(VarCurr)
    <=> ( v135827(VarCurr)
        & v135867(VarCurr) ) ) ).

tff(writeUnaryOperator_9980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135867(VarCurr)
    <=> v135868(VarCurr) ) ).

tff(addAssignment_76653,axiom,
    ! [VarCurr: state_type] :
      ( v135868(VarCurr)
    <=> v135869(VarCurr) ) ).

tff(addAssignment_76652,axiom,
    ! [VarCurr: state_type] :
      ( v135869(VarCurr)
    <=> v135845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17734,axiom,
    ! [VarCurr: state_type] :
      ( v135858(VarCurr)
    <=> ( v135859(VarCurr)
        & v135862(VarCurr) ) ) ).

tff(writeUnaryOperator_9979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135862(VarCurr)
    <=> v135863(VarCurr) ) ).

tff(addAssignment_76651,axiom,
    ! [VarCurr: state_type] :
      ( v135863(VarCurr)
    <=> v135864(VarCurr) ) ).

tff(addAssignment_76650,axiom,
    ! [VarCurr: state_type] :
      ( v135864(VarCurr)
    <=> v135847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17733,axiom,
    ! [VarCurr: state_type] :
      ( v135859(VarCurr)
    <=> ( v135843(VarCurr)
        & v135860(VarCurr) ) ) ).

tff(addAssignment_76649,axiom,
    ! [VarCurr: state_type] :
      ( v135860(VarCurr)
    <=> v135861(VarCurr) ) ).

tff(addAssignment_76648,axiom,
    ! [VarCurr: state_type] :
      ( v135861(VarCurr)
    <=> v135845(VarCurr) ) ).

tff(addAssignment_76647,axiom,
    ! [VarCurr: state_type] :
      ( v135847(VarCurr)
    <=> v135849(VarCurr) ) ).

tff(addAssignment_76646,axiom,
    ! [VarCurr: state_type] :
      ( v135849(VarCurr)
    <=> v135851(VarCurr) ) ).

tff(addAssignment_76645,axiom,
    ! [VarCurr: state_type] :
      ( v135851(VarCurr)
    <=> v135853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17732,axiom,
    ! [VarCurr: state_type] :
      ( v135853(VarCurr)
    <=> ( v135855(VarCurr)
        & v135856(VarCurr) ) ) ).

tff(writeUnaryOperator_9978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135856(VarCurr)
    <=> v82909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17731,axiom,
    ! [VarCurr: state_type] :
      ( v135855(VarCurr)
    <=> ( v5753(VarCurr)
        & v87178(VarCurr) ) ) ).

tff(addAssignment_76644,axiom,
    ! [VarCurr: state_type] :
      ( v135845(VarCurr)
    <=> v86909(VarCurr) ) ).

tff(addAssignment_76643,axiom,
    ! [VarCurr: state_type] :
      ( v135843(VarCurr)
    <=> $true ) ).

tff(addAssignment_76642,axiom,
    ! [VarCurr: state_type] :
      ( v135835(VarCurr)
    <=> v135837(VarCurr) ) ).

tff(addAssignment_76641,axiom,
    ! [VarCurr: state_type] :
      ( v135837(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76640,axiom,
    ! [VarCurr: state_type] :
      ( v135831(VarCurr)
    <=> v135833(VarCurr) ) ).

tff(addAssignment_76639,axiom,
    ! [VarCurr: state_type] :
      ( v135833(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17730,axiom,
    ! [VarCurr: state_type] :
      ( v86715(VarCurr)
    <=> ( v135733(VarCurr)
        & v86811(VarCurr) ) ) ).

tff(writeUnaryOperator_9977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135733(VarCurr)
    <=> v135735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17729,axiom,
    ! [VarCurr: state_type] :
      ( v135735(VarCurr)
    <=> ( v135736(VarCurr)
        | v135823(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6159,axiom,
    ! [VarCurr: state_type] :
      ( v135823(VarCurr)
    <=> ( v86754(VarCurr)
        & v135668(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17728,axiom,
    ! [VarCurr: state_type] :
      ( v135736(VarCurr)
    <=> ( v135737(VarCurr)
        & v135818(VarCurr) ) ) ).

tff(writeUnaryOperator_9976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135818(VarCurr)
    <=> v135819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17727,axiom,
    ! [VarCurr: state_type] :
      ( v135819(VarCurr)
    <=> ( v135820(VarCurr)
        & v135822(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6158,axiom,
    ! [VarCurr: state_type] :
      ( v135822(VarCurr)
    <=> ( v86717(VarCurr,11)
        | v135668(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17726,axiom,
    ! [VarCurr: state_type] :
      ( v135820(VarCurr)
    <=> ( v86754(VarCurr)
        | v135821(VarCurr) ) ) ).

tff(writeUnaryOperator_9975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135821(VarCurr)
    <=> v135668(VarCurr,11) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17725,axiom,
    ! [VarCurr: state_type] :
      ( v135737(VarCurr)
    <=> ( v135738(VarCurr)
        | v135817(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6157,axiom,
    ! [VarCurr: state_type] :
      ( v135817(VarCurr)
    <=> ( v86759(VarCurr)
        & v135668(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17724,axiom,
    ! [VarCurr: state_type] :
      ( v135738(VarCurr)
    <=> ( v135739(VarCurr)
        & v135812(VarCurr) ) ) ).

tff(writeUnaryOperator_9974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135812(VarCurr)
    <=> v135813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17723,axiom,
    ! [VarCurr: state_type] :
      ( v135813(VarCurr)
    <=> ( v135814(VarCurr)
        & v135816(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6156,axiom,
    ! [VarCurr: state_type] :
      ( v135816(VarCurr)
    <=> ( v86717(VarCurr,10)
        | v135668(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17722,axiom,
    ! [VarCurr: state_type] :
      ( v135814(VarCurr)
    <=> ( v86759(VarCurr)
        | v135815(VarCurr) ) ) ).

tff(writeUnaryOperator_9973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135815(VarCurr)
    <=> v135668(VarCurr,10) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17721,axiom,
    ! [VarCurr: state_type] :
      ( v135739(VarCurr)
    <=> ( v135740(VarCurr)
        | v135811(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6155,axiom,
    ! [VarCurr: state_type] :
      ( v135811(VarCurr)
    <=> ( v86764(VarCurr)
        & v135668(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17720,axiom,
    ! [VarCurr: state_type] :
      ( v135740(VarCurr)
    <=> ( v135741(VarCurr)
        & v135806(VarCurr) ) ) ).

tff(writeUnaryOperator_9972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135806(VarCurr)
    <=> v135807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17719,axiom,
    ! [VarCurr: state_type] :
      ( v135807(VarCurr)
    <=> ( v135808(VarCurr)
        & v135810(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6154,axiom,
    ! [VarCurr: state_type] :
      ( v135810(VarCurr)
    <=> ( v86717(VarCurr,9)
        | v135668(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17718,axiom,
    ! [VarCurr: state_type] :
      ( v135808(VarCurr)
    <=> ( v86764(VarCurr)
        | v135809(VarCurr) ) ) ).

tff(writeUnaryOperator_9971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135809(VarCurr)
    <=> v135668(VarCurr,9) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17717,axiom,
    ! [VarCurr: state_type] :
      ( v135741(VarCurr)
    <=> ( v135742(VarCurr)
        | v135805(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6153,axiom,
    ! [VarCurr: state_type] :
      ( v135805(VarCurr)
    <=> ( v86769(VarCurr)
        & v135668(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17716,axiom,
    ! [VarCurr: state_type] :
      ( v135742(VarCurr)
    <=> ( v135743(VarCurr)
        & v135800(VarCurr) ) ) ).

tff(writeUnaryOperator_9970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135800(VarCurr)
    <=> v135801(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17715,axiom,
    ! [VarCurr: state_type] :
      ( v135801(VarCurr)
    <=> ( v135802(VarCurr)
        & v135804(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6152,axiom,
    ! [VarCurr: state_type] :
      ( v135804(VarCurr)
    <=> ( v86717(VarCurr,8)
        | v135668(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17714,axiom,
    ! [VarCurr: state_type] :
      ( v135802(VarCurr)
    <=> ( v86769(VarCurr)
        | v135803(VarCurr) ) ) ).

tff(writeUnaryOperator_9969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135803(VarCurr)
    <=> v135668(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17713,axiom,
    ! [VarCurr: state_type] :
      ( v135743(VarCurr)
    <=> ( v135744(VarCurr)
        | v135799(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6151,axiom,
    ! [VarCurr: state_type] :
      ( v135799(VarCurr)
    <=> ( v86774(VarCurr)
        & v135668(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17712,axiom,
    ! [VarCurr: state_type] :
      ( v135744(VarCurr)
    <=> ( v135745(VarCurr)
        & v135794(VarCurr) ) ) ).

tff(writeUnaryOperator_9968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135794(VarCurr)
    <=> v135795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17711,axiom,
    ! [VarCurr: state_type] :
      ( v135795(VarCurr)
    <=> ( v135796(VarCurr)
        & v135798(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6150,axiom,
    ! [VarCurr: state_type] :
      ( v135798(VarCurr)
    <=> ( v86717(VarCurr,7)
        | v135668(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17710,axiom,
    ! [VarCurr: state_type] :
      ( v135796(VarCurr)
    <=> ( v86774(VarCurr)
        | v135797(VarCurr) ) ) ).

tff(writeUnaryOperator_9967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135797(VarCurr)
    <=> v135668(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17709,axiom,
    ! [VarCurr: state_type] :
      ( v135745(VarCurr)
    <=> ( v135746(VarCurr)
        | v135793(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6149,axiom,
    ! [VarCurr: state_type] :
      ( v135793(VarCurr)
    <=> ( v86779(VarCurr)
        & v135668(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17708,axiom,
    ! [VarCurr: state_type] :
      ( v135746(VarCurr)
    <=> ( v135747(VarCurr)
        & v135788(VarCurr) ) ) ).

tff(writeUnaryOperator_9966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135788(VarCurr)
    <=> v135789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17707,axiom,
    ! [VarCurr: state_type] :
      ( v135789(VarCurr)
    <=> ( v135790(VarCurr)
        & v135792(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6148,axiom,
    ! [VarCurr: state_type] :
      ( v135792(VarCurr)
    <=> ( v86717(VarCurr,6)
        | v135668(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17706,axiom,
    ! [VarCurr: state_type] :
      ( v135790(VarCurr)
    <=> ( v86779(VarCurr)
        | v135791(VarCurr) ) ) ).

tff(writeUnaryOperator_9965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135791(VarCurr)
    <=> v135668(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17705,axiom,
    ! [VarCurr: state_type] :
      ( v135747(VarCurr)
    <=> ( v135748(VarCurr)
        | v135787(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6147,axiom,
    ! [VarCurr: state_type] :
      ( v135787(VarCurr)
    <=> ( v86784(VarCurr)
        & v135668(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17704,axiom,
    ! [VarCurr: state_type] :
      ( v135748(VarCurr)
    <=> ( v135749(VarCurr)
        & v135782(VarCurr) ) ) ).

tff(writeUnaryOperator_9964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135782(VarCurr)
    <=> v135783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17703,axiom,
    ! [VarCurr: state_type] :
      ( v135783(VarCurr)
    <=> ( v135784(VarCurr)
        & v135786(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6146,axiom,
    ! [VarCurr: state_type] :
      ( v135786(VarCurr)
    <=> ( v86717(VarCurr,5)
        | v135668(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17702,axiom,
    ! [VarCurr: state_type] :
      ( v135784(VarCurr)
    <=> ( v86784(VarCurr)
        | v135785(VarCurr) ) ) ).

tff(writeUnaryOperator_9963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135785(VarCurr)
    <=> v135668(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17701,axiom,
    ! [VarCurr: state_type] :
      ( v135749(VarCurr)
    <=> ( v135750(VarCurr)
        | v135781(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6145,axiom,
    ! [VarCurr: state_type] :
      ( v135781(VarCurr)
    <=> ( v86789(VarCurr)
        & v135668(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17700,axiom,
    ! [VarCurr: state_type] :
      ( v135750(VarCurr)
    <=> ( v135751(VarCurr)
        & v135776(VarCurr) ) ) ).

tff(writeUnaryOperator_9962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135776(VarCurr)
    <=> v135777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17699,axiom,
    ! [VarCurr: state_type] :
      ( v135777(VarCurr)
    <=> ( v135778(VarCurr)
        & v135780(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6144,axiom,
    ! [VarCurr: state_type] :
      ( v135780(VarCurr)
    <=> ( v86717(VarCurr,4)
        | v135668(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17698,axiom,
    ! [VarCurr: state_type] :
      ( v135778(VarCurr)
    <=> ( v86789(VarCurr)
        | v135779(VarCurr) ) ) ).

tff(writeUnaryOperator_9961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135779(VarCurr)
    <=> v135668(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17697,axiom,
    ! [VarCurr: state_type] :
      ( v135751(VarCurr)
    <=> ( v135752(VarCurr)
        | v135775(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6143,axiom,
    ! [VarCurr: state_type] :
      ( v135775(VarCurr)
    <=> ( v86794(VarCurr)
        & v135668(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17696,axiom,
    ! [VarCurr: state_type] :
      ( v135752(VarCurr)
    <=> ( v135753(VarCurr)
        & v135770(VarCurr) ) ) ).

tff(writeUnaryOperator_9960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135770(VarCurr)
    <=> v135771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17695,axiom,
    ! [VarCurr: state_type] :
      ( v135771(VarCurr)
    <=> ( v135772(VarCurr)
        & v135774(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6142,axiom,
    ! [VarCurr: state_type] :
      ( v135774(VarCurr)
    <=> ( v86717(VarCurr,3)
        | v135668(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17694,axiom,
    ! [VarCurr: state_type] :
      ( v135772(VarCurr)
    <=> ( v86794(VarCurr)
        | v135773(VarCurr) ) ) ).

tff(writeUnaryOperator_9959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135773(VarCurr)
    <=> v135668(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17693,axiom,
    ! [VarCurr: state_type] :
      ( v135753(VarCurr)
    <=> ( v135754(VarCurr)
        | v135769(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6141,axiom,
    ! [VarCurr: state_type] :
      ( v135769(VarCurr)
    <=> ( v86799(VarCurr)
        & v135668(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17692,axiom,
    ! [VarCurr: state_type] :
      ( v135754(VarCurr)
    <=> ( v135755(VarCurr)
        & v135764(VarCurr) ) ) ).

tff(writeUnaryOperator_9958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135764(VarCurr)
    <=> v135765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17691,axiom,
    ! [VarCurr: state_type] :
      ( v135765(VarCurr)
    <=> ( v135766(VarCurr)
        & v135768(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6140,axiom,
    ! [VarCurr: state_type] :
      ( v135768(VarCurr)
    <=> ( v86717(VarCurr,2)
        | v135668(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17690,axiom,
    ! [VarCurr: state_type] :
      ( v135766(VarCurr)
    <=> ( v86799(VarCurr)
        | v135767(VarCurr) ) ) ).

tff(writeUnaryOperator_9957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135767(VarCurr)
    <=> v135668(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17689,axiom,
    ! [VarCurr: state_type] :
      ( v135755(VarCurr)
    <=> ( v135756(VarCurr)
        | v135763(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6139,axiom,
    ! [VarCurr: state_type] :
      ( v135763(VarCurr)
    <=> ( v86804(VarCurr)
        & v135668(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17688,axiom,
    ! [VarCurr: state_type] :
      ( v135756(VarCurr)
    <=> ( v135757(VarCurr)
        & v135758(VarCurr) ) ) ).

tff(writeUnaryOperator_9956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135758(VarCurr)
    <=> v135759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17687,axiom,
    ! [VarCurr: state_type] :
      ( v135759(VarCurr)
    <=> ( v135760(VarCurr)
        & v135762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6138,axiom,
    ! [VarCurr: state_type] :
      ( v135762(VarCurr)
    <=> ( v86717(VarCurr,1)
        | v135668(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17686,axiom,
    ! [VarCurr: state_type] :
      ( v135760(VarCurr)
    <=> ( v86804(VarCurr)
        | v135761(VarCurr) ) ) ).

tff(writeUnaryOperator_9955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135761(VarCurr)
    <=> v135668(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17685,axiom,
    ! [VarCurr: state_type] :
      ( v135757(VarCurr)
    <=> ( v86803(VarCurr)
        & v135668(VarCurr,0) ) ) ).

tff(writeUnaryOperator_9954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135668(VarCurr,B)
      <=> ~ v135670(VarCurr,B) ) ) ).

tff(addAssignment_76638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135670(VarCurr,B)
      <=> v135672(VarCurr,B) ) ) ).

tff(addAssignment_76637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135672(VarCurr,B)
      <=> v135674(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135715(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v135674(VarNext,B)
            <=> v135674(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1888,axiom,
    ! [VarNext: state_type] :
      ( v135715(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135674(VarNext,B)
          <=> v135725(VarNext,B) ) ) ) ).

tff(addAssignment_76636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135725(VarNext,B)
          <=> v135723(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135726(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135723(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1408,axiom,
    ! [VarCurr: state_type] :
      ( v135726(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135723(VarCurr,B)
          <=> v135684(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17684,axiom,
    ! [VarCurr: state_type] :
      ( v135726(VarCurr)
    <=> ( v135727(VarCurr)
        & v135728(VarCurr) ) ) ).

tff(writeUnaryOperator_9953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135728(VarCurr)
    <=> v135680(VarCurr) ) ).

tff(writeUnaryOperator_9952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135727(VarCurr)
    <=> v135676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135715(VarNext)
      <=> v135716(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135716(VarNext)
      <=> ( v135717(VarNext)
          & v135710(VarNext) ) ) ) ).

tff(writeUnaryOperator_9951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135717(VarNext)
      <=> v135719(VarNext) ) ) ).

tff(addAssignment_76635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135719(VarNext)
      <=> v135710(VarCurr) ) ) ).

tff(addAssignment_76634,axiom,
    ! [VarCurr: state_type] :
      ( v135710(VarCurr)
    <=> v135712(VarCurr) ) ).

tff(addAssignment_76633,axiom,
    ! [VarCurr: state_type] :
      ( v135712(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135684(VarCurr,B)
      <=> v135686(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135686(VarCurr,B)
      <=> ( v135702(VarCurr,B)
          | v135705(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135705(VarCurr,B)
      <=> ( v135672(VarCurr,B)
          & v135706(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135706(VarCurr,B)
      <=> ~ v135707(VarCurr,B) ) ) ).

tff(addAssignment_76631,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,0)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76630,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,1)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76629,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,2)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76628,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,3)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76627,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,4)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76626,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,5)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76625,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,6)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76624,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,7)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76623,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,8)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76622,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,9)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76621,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,10)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76620,axiom,
    ! [VarCurr: state_type] :
      ( v135707(VarCurr,11)
    <=> v135708(VarCurr) ) ).

tff(addAssignment_76619,axiom,
    ! [VarCurr: state_type] :
      ( v135708(VarCurr)
    <=> v135695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135702(VarCurr,B)
      <=> ( v135688(VarCurr,B)
          & v135703(VarCurr,B) ) ) ) ).

tff(addAssignment_76618,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,0)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76617,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,1)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76616,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,2)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76615,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,3)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76614,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,4)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76613,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,5)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76612,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,6)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76611,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,7)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76610,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,8)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76609,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,9)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76608,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,10)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76607,axiom,
    ! [VarCurr: state_type] :
      ( v135703(VarCurr,11)
    <=> v135704(VarCurr) ) ).

tff(addAssignment_76606,axiom,
    ! [VarCurr: state_type] :
      ( v135704(VarCurr)
    <=> v135695(VarCurr) ) ).

tff(addAssignment_76605,axiom,
    ! [VarCurr: state_type] :
      ( v135695(VarCurr)
    <=> v135697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17681,axiom,
    ! [VarCurr: state_type] :
      ( v135697(VarCurr)
    <=> ( v1729(VarCurr)
        & v135700(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1789,axiom,
    ! [VarCurr: state_type] :
      ( v135700(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1977,axiom,
    ~ b0000000011000(12) ).

tff(bitBlastConstant_1976,axiom,
    ~ b0000000011000(11) ).

tff(bitBlastConstant_1975,axiom,
    ~ b0000000011000(10) ).

tff(bitBlastConstant_1974,axiom,
    ~ b0000000011000(9) ).

tff(bitBlastConstant_1973,axiom,
    ~ b0000000011000(8) ).

tff(bitBlastConstant_1972,axiom,
    ~ b0000000011000(7) ).

tff(bitBlastConstant_1971,axiom,
    ~ b0000000011000(6) ).

tff(bitBlastConstant_1970,axiom,
    ~ b0000000011000(5) ).

tff(bitBlastConstant_1969,axiom,
    b0000000011000(4) ).

tff(bitBlastConstant_1968,axiom,
    b0000000011000(3) ).

tff(bitBlastConstant_1967,axiom,
    ~ b0000000011000(2) ).

tff(bitBlastConstant_1966,axiom,
    ~ b0000000011000(1) ).

tff(bitBlastConstant_1965,axiom,
    ~ b0000000011000(0) ).

tff(addAssignment_76604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135688(VarCurr,B)
      <=> v135690(VarCurr,B) ) ) ).

tff(writeUnaryOperator_9949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135690(VarCurr,B)
      <=> ~ v135692(VarCurr,B) ) ) ).

tff(addAssignment_76603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135692(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_76602,axiom,
    ! [VarCurr: state_type] :
      ( v135680(VarCurr)
    <=> v135682(VarCurr) ) ).

tff(addAssignment_76601,axiom,
    ! [VarCurr: state_type] :
      ( v135682(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76600,axiom,
    ! [VarCurr: state_type] :
      ( v135676(VarCurr)
    <=> v135678(VarCurr) ) ).

tff(addAssignment_76599,axiom,
    ! [VarCurr: state_type] :
      ( v135678(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_76598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v86717(VarCurr,B)
      <=> v86719(VarCurr,B) ) ) ).

tff(addAssignment_76597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v86719(VarCurr,B)
      <=> v86721(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135651(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v86721(VarNext,B)
            <=> v86721(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1887,axiom,
    ! [VarNext: state_type] :
      ( v135651(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v86721(VarNext,B)
          <=> v135661(VarNext,B) ) ) ) ).

tff(addAssignment_76596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135661(VarNext,B)
          <=> v135659(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135662(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135659(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1407,axiom,
    ! [VarCurr: state_type] :
      ( v135662(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v135659(VarCurr,B)
          <=> v86731(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17680,axiom,
    ! [VarCurr: state_type] :
      ( v135662(VarCurr)
    <=> ( v135663(VarCurr)
        & v135664(VarCurr) ) ) ).

tff(writeUnaryOperator_9948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135664(VarCurr)
    <=> v86727(VarCurr) ) ).

tff(writeUnaryOperator_9947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135663(VarCurr)
    <=> v86723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135651(VarNext)
      <=> v135652(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135652(VarNext)
      <=> ( v135653(VarNext)
          & v135646(VarNext) ) ) ) ).

tff(writeUnaryOperator_9946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135653(VarNext)
      <=> v135655(VarNext) ) ) ).

tff(addAssignment_76595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135655(VarNext)
      <=> v135646(VarCurr) ) ) ).

tff(addAssignment_76594,axiom,
    ! [VarCurr: state_type] :
      ( v135646(VarCurr)
    <=> v135648(VarCurr) ) ).

tff(addAssignment_76593,axiom,
    ! [VarCurr: state_type] :
      ( v135648(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v86731(VarCurr,B)
      <=> v86733(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v86733(VarCurr,B)
      <=> ( v135630(VarCurr,B)
          | v135637(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135637(VarCurr,B)
      <=> ( v135638(VarCurr,B)
          & v135642(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135642(VarCurr,B)
      <=> ~ v135643(VarCurr,B) ) ) ).

tff(addAssignment_76591,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,0)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76590,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,1)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76589,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,2)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76588,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,3)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76587,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,4)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76586,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,5)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76585,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,6)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76584,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,7)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76583,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,8)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76582,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,9)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76581,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,10)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76580,axiom,
    ! [VarCurr: state_type] :
      ( v135643(VarCurr,11)
    <=> v135644(VarCurr) ) ).

tff(addAssignment_76579,axiom,
    ! [VarCurr: state_type] :
      ( v135644(VarCurr)
    <=> v86873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135638(VarCurr,B)
      <=> ( v86719(VarCurr,B)
          & v135639(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135639(VarCurr,B)
      <=> ~ v135640(VarCurr,B) ) ) ).

tff(addAssignment_76578,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,0)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76577,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,1)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76576,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,2)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76575,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,3)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76574,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,4)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76573,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,5)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76572,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,6)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76571,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,7)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76570,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,8)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76569,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,9)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76568,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,10)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76567,axiom,
    ! [VarCurr: state_type] :
      ( v135640(VarCurr,11)
    <=> v135641(VarCurr) ) ).

tff(addAssignment_76566,axiom,
    ! [VarCurr: state_type] :
      ( v135641(VarCurr)
    <=> v86807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135630(VarCurr,B)
      <=> ( v135631(VarCurr,B)
          & v135634(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135634(VarCurr,B)
      <=> ~ v135635(VarCurr,B) ) ) ).

tff(addAssignment_76565,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,0)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76564,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,1)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76563,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,2)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76562,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,3)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76561,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,4)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76560,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,5)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76559,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,6)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76558,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,7)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76557,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,8)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76556,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,9)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76555,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,10)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76554,axiom,
    ! [VarCurr: state_type] :
      ( v135635(VarCurr,11)
    <=> v135636(VarCurr) ) ).

tff(addAssignment_76553,axiom,
    ! [VarCurr: state_type] :
      ( v135636(VarCurr)
    <=> v86873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v135631(VarCurr,B)
      <=> ( v86735(VarCurr,B)
          & v135632(VarCurr,B) ) ) ) ).

tff(addAssignment_76552,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,0)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76551,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,1)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76550,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,2)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76549,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,3)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76548,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,4)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76547,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,5)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76546,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,6)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76545,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,7)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76544,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,8)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76543,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,9)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76542,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,10)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76541,axiom,
    ! [VarCurr: state_type] :
      ( v135632(VarCurr,11)
    <=> v135633(VarCurr) ) ).

tff(addAssignment_76540,axiom,
    ! [VarCurr: state_type] :
      ( v135633(VarCurr)
    <=> v86807(VarCurr) ) ).

tff(addAssignment_76539,axiom,
    ! [VarCurr: state_type] :
      ( v86873(VarCurr)
    <=> v86875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17677,axiom,
    ! [VarCurr: state_type] :
      ( v86875(VarCurr)
    <=> ( v135627(VarCurr)
        | v135628(VarCurr) ) ) ).

tff(writeUnaryOperator_9942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135628(VarCurr)
    <=> v127624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17676,axiom,
    ! [VarCurr: state_type] :
      ( v135627(VarCurr)
    <=> ( v86877(VarCurr)
        & v86885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17675,axiom,
    ! [VarCurr: state_type] :
      ( v86877(VarCurr)
    <=> ( v135596(VarCurr)
        & v135599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17674,axiom,
    ! [VarCurr: state_type] :
      ( v135599(VarCurr)
    <=> ( v135600(VarCurr)
        | v135624(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1788,axiom,
    ! [VarCurr: state_type] :
      ( v135624(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v135625(VarCurr,3) )
        & ( v110754(VarCurr,2)
        <=> v135625(VarCurr,2) )
        & ( v110754(VarCurr,1)
        <=> v135625(VarCurr,1) )
        & ( v110754(VarCurr,0)
        <=> v135625(VarCurr,0) ) ) ) ).

tff(addAssignment_76538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v135625(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_76537,axiom,
    ! [VarCurr: state_type] :
      ( v135625(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17673,axiom,
    ! [VarCurr: state_type] :
      ( v135600(VarCurr)
    <=> ( v135601(VarCurr)
        | v135602(VarCurr) ) ) ).

tff(writeUnaryOperator_9941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135602(VarCurr)
    <=> v135604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17672,axiom,
    ! [VarCurr: state_type] :
      ( v135604(VarCurr)
    <=> ( v135605(VarCurr)
        & v135618(VarCurr) ) ) ).

tff(writeUnaryOperator_9940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135618(VarCurr)
    <=> v135619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17671,axiom,
    ! [VarCurr: state_type] :
      ( v135619(VarCurr)
    <=> ( v135620(VarCurr)
        & v135623(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6137,axiom,
    ! [VarCurr: state_type] :
      ( v135623(VarCurr)
    <=> ( v110754(VarCurr,2)
        | v88266(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17670,axiom,
    ! [VarCurr: state_type] :
      ( v135620(VarCurr)
    <=> ( v135621(VarCurr)
        | v135622(VarCurr) ) ) ).

tff(writeUnaryOperator_9939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135622(VarCurr)
    <=> v88266(VarCurr,2) ) ).

tff(writeUnaryOperator_9938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135621(VarCurr)
    <=> v110754(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17669,axiom,
    ! [VarCurr: state_type] :
      ( v135605(VarCurr)
    <=> ( v135606(VarCurr)
        & v135612(VarCurr) ) ) ).

tff(writeUnaryOperator_9937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135612(VarCurr)
    <=> v135613(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17668,axiom,
    ! [VarCurr: state_type] :
      ( v135613(VarCurr)
    <=> ( v135614(VarCurr)
        & v135617(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6136,axiom,
    ! [VarCurr: state_type] :
      ( v135617(VarCurr)
    <=> ( v110754(VarCurr,1)
        | v88266(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17667,axiom,
    ! [VarCurr: state_type] :
      ( v135614(VarCurr)
    <=> ( v135615(VarCurr)
        | v135616(VarCurr) ) ) ).

tff(writeUnaryOperator_9936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135616(VarCurr)
    <=> v88266(VarCurr,1) ) ).

tff(writeUnaryOperator_9935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135615(VarCurr)
    <=> v110754(VarCurr,1) ) ).

tff(writeUnaryOperator_9934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135606(VarCurr)
    <=> v135607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17666,axiom,
    ! [VarCurr: state_type] :
      ( v135607(VarCurr)
    <=> ( v135608(VarCurr)
        & v135611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17665,axiom,
    ! [VarCurr: state_type] :
      ( v135611(VarCurr)
    <=> ( v110754(VarCurr,0)
        | v88266(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17664,axiom,
    ! [VarCurr: state_type] :
      ( v135608(VarCurr)
    <=> ( v135609(VarCurr)
        | v135610(VarCurr) ) ) ).

tff(writeUnaryOperator_9933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135610(VarCurr)
    <=> v88266(VarCurr,0) ) ).

tff(writeUnaryOperator_9932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135609(VarCurr)
    <=> v110754(VarCurr,0) ) ).

tff(writeUnaryOperator_9931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135601(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17663,axiom,
    ! [VarCurr: state_type] :
      ( v135596(VarCurr)
    <=> ( v135597(VarCurr)
        & v135529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17662,axiom,
    ! [VarCurr: state_type] :
      ( v135597(VarCurr)
    <=> ( v135598(VarCurr)
        & v135504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17661,axiom,
    ! [VarCurr: state_type] :
      ( v135598(VarCurr)
    <=> ( v86879(VarCurr)
        & v135479(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1787,axiom,
    ! [VarCurr: state_type] :
      ( v135529(VarCurr)
    <=> ( ( v135531(VarCurr,1)
        <=> $false )
        & ( v135531(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v135531(VarCurr,B)
      <=> v135533(VarCurr,B) ) ) ).

tff(addAssignment_76535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v135533(VarCurr,B)
      <=> v135535(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135578(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v135535(VarNext,B)
            <=> v135535(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1886,axiom,
    ! [VarNext: state_type] :
      ( v135578(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135535(VarNext,B)
          <=> v135588(VarNext,B) ) ) ) ).

tff(addAssignment_76534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135588(VarNext,B)
          <=> v135586(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135589(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135586(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1406,axiom,
    ! [VarCurr: state_type] :
      ( v135589(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135586(VarCurr,B)
          <=> v135545(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17660,axiom,
    ! [VarCurr: state_type] :
      ( v135589(VarCurr)
    <=> ( v135590(VarCurr)
        & v135591(VarCurr) ) ) ).

tff(writeUnaryOperator_9930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135591(VarCurr)
    <=> v135541(VarCurr) ) ).

tff(writeUnaryOperator_9929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135590(VarCurr)
    <=> v135537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135578(VarNext)
      <=> v135579(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135579(VarNext)
      <=> ( v135580(VarNext)
          & v135573(VarNext) ) ) ) ).

tff(writeUnaryOperator_9928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135580(VarNext)
      <=> v135582(VarNext) ) ) ).

tff(addAssignment_76533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135582(VarNext)
      <=> v135573(VarCurr) ) ) ).

tff(addAssignment_76532,axiom,
    ! [VarCurr: state_type] :
      ( v135573(VarCurr)
    <=> v135575(VarCurr) ) ).

tff(addAssignment_76531,axiom,
    ! [VarCurr: state_type] :
      ( v135575(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v135545(VarCurr,B)
      <=> v135547(VarCurr,B) ) ) ).

tff(addAssignment_76529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v135547(VarCurr,B)
      <=> v135549(VarCurr,B) ) ) ).

tff(addAssignment_76528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v135549(VarCurr,B)
      <=> v135551(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135551(VarCurr,B)
          <=> v135562(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1405,axiom,
    ! [VarCurr: state_type] :
      ( v135553(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135551(VarCurr,B)
          <=> v135561(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135562(VarCurr,B)
          <=> v135564(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1404,axiom,
    ! [VarCurr: state_type] :
      ( v135563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135562(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88418(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135564(VarCurr,B)
          <=> v135531(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1403,axiom,
    ! [VarCurr: state_type] :
      ( v88418(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v135564(VarCurr,B)
          <=> v135565(VarCurr,B) ) ) ) ).

tff(addAssignment_76527,axiom,
    ! [VarCurr: state_type] :
      ( v135565(VarCurr,0)
    <=> v135569(VarCurr) ) ).

tff(addAssignment_76526,axiom,
    ! [VarCurr: state_type] :
      ( v135565(VarCurr,1)
    <=> v135567(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17657,axiom,
    ! [VarCurr: state_type] :
      ( v135567(VarCurr)
    <=> ( v135568(VarCurr)
        & v135570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17656,axiom,
    ! [VarCurr: state_type] :
      ( v135570(VarCurr)
    <=> ( v135531(VarCurr,0)
        | v135571(VarCurr) ) ) ).

tff(writeUnaryOperator_9927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135571(VarCurr)
    <=> v135531(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6135,axiom,
    ! [VarCurr: state_type] :
      ( v135568(VarCurr)
    <=> ( v135569(VarCurr)
        | v135531(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135569(VarCurr)
    <=> v135531(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_1786,axiom,
    ! [VarCurr: state_type] :
      ( v135563(VarCurr)
    <=> ( ( v135531(VarCurr,1)
        <=> $false )
        & ( v135531(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76525,axiom,
    ! [VarCurr: state_type] :
      ( v135561(VarCurr,0)
    <=> $true ) ).

tff(addAssignment_76524,axiom,
    ! [VarCurr: state_type] :
      ( v135561(VarCurr,1)
    <=> v1051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17655,axiom,
    ! [VarCurr: state_type] :
      ( v135553(VarCurr)
    <=> ( v135554(VarCurr)
        & v135529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17654,axiom,
    ! [VarCurr: state_type] :
      ( v135554(VarCurr)
    <=> ( v135555(VarCurr)
        | v82954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17653,axiom,
    ! [VarCurr: state_type] :
      ( v135555(VarCurr)
    <=> ( v135556(VarCurr)
        | v86877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17652,axiom,
    ! [VarCurr: state_type] :
      ( v135556(VarCurr)
    <=> ( v135557(VarCurr)
        | v135559(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17651,axiom,
    ! [VarCurr: state_type] :
      ( v135559(VarCurr)
    <=> ( v84899(VarCurr)
        & v135560(VarCurr) ) ) ).

tff(writeUnaryOperator_9925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135560(VarCurr)
    <=> v89409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17650,axiom,
    ! [VarCurr: state_type] :
      ( v135557(VarCurr)
    <=> ( v118(VarCurr)
        & v135558(VarCurr) ) ) ).

tff(writeUnaryOperator_9924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135558(VarCurr)
    <=> v2900(VarCurr) ) ).

tff(addAssignment_76523,axiom,
    ! [VarCurr: state_type] :
      ( v135541(VarCurr)
    <=> v135543(VarCurr) ) ).

tff(addAssignment_76522,axiom,
    ! [VarCurr: state_type] :
      ( v135543(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76521,axiom,
    ! [VarCurr: state_type] :
      ( v135537(VarCurr)
    <=> v135539(VarCurr) ) ).

tff(addAssignment_76520,axiom,
    ! [VarCurr: state_type] :
      ( v135539(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17649,axiom,
    ! [VarCurr: state_type] :
      ( v135504(VarCurr)
    <=> ( v135506(VarCurr)
        | v135526(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6134,axiom,
    ! [VarCurr: state_type] :
      ( v135526(VarCurr)
    <=> ( v135527(VarCurr)
        & v133661(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_1785,axiom,
    ! [VarCurr: state_type] :
      ( v135527(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17648,axiom,
    ! [VarCurr: state_type] :
      ( v135506(VarCurr)
    <=> ( v135507(VarCurr)
        | v135524(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6133,axiom,
    ! [VarCurr: state_type] :
      ( v135524(VarCurr)
    <=> ( v135525(VarCurr)
        & v133661(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_1784,axiom,
    ! [VarCurr: state_type] :
      ( v135525(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17647,axiom,
    ! [VarCurr: state_type] :
      ( v135507(VarCurr)
    <=> ( v135508(VarCurr)
        | v135522(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6132,axiom,
    ! [VarCurr: state_type] :
      ( v135522(VarCurr)
    <=> ( v135523(VarCurr)
        & v133661(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_1783,axiom,
    ! [VarCurr: state_type] :
      ( v135523(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17646,axiom,
    ! [VarCurr: state_type] :
      ( v135508(VarCurr)
    <=> ( v135509(VarCurr)
        | v135520(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6131,axiom,
    ! [VarCurr: state_type] :
      ( v135520(VarCurr)
    <=> ( v135521(VarCurr)
        & v133661(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_1782,axiom,
    ! [VarCurr: state_type] :
      ( v135521(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17645,axiom,
    ! [VarCurr: state_type] :
      ( v135509(VarCurr)
    <=> ( v135510(VarCurr)
        | v135518(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6130,axiom,
    ! [VarCurr: state_type] :
      ( v135518(VarCurr)
    <=> ( v135519(VarCurr)
        & v133661(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_1781,axiom,
    ! [VarCurr: state_type] :
      ( v135519(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17644,axiom,
    ! [VarCurr: state_type] :
      ( v135510(VarCurr)
    <=> ( v135511(VarCurr)
        | v135516(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6129,axiom,
    ! [VarCurr: state_type] :
      ( v135516(VarCurr)
    <=> ( v135517(VarCurr)
        & v133661(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_1780,axiom,
    ! [VarCurr: state_type] :
      ( v135517(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17643,axiom,
    ! [VarCurr: state_type] :
      ( v135511(VarCurr)
    <=> ( v135512(VarCurr)
        | v135514(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6128,axiom,
    ! [VarCurr: state_type] :
      ( v135514(VarCurr)
    <=> ( v135515(VarCurr)
        & v133661(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_1779,axiom,
    ! [VarCurr: state_type] :
      ( v135515(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17642,axiom,
    ! [VarCurr: state_type] :
      ( v135512(VarCurr)
    <=> ( v135513(VarCurr)
        & v133661(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_1778,axiom,
    ! [VarCurr: state_type] :
      ( v135513(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17641,axiom,
    ! [VarCurr: state_type] :
      ( v135479(VarCurr)
    <=> ( v135481(VarCurr)
        | v135501(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6127,axiom,
    ! [VarCurr: state_type] :
      ( v135501(VarCurr)
    <=> ( v135502(VarCurr)
        & v89156(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_1777,axiom,
    ! [VarCurr: state_type] :
      ( v135502(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17640,axiom,
    ! [VarCurr: state_type] :
      ( v135481(VarCurr)
    <=> ( v135482(VarCurr)
        | v135499(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6126,axiom,
    ! [VarCurr: state_type] :
      ( v135499(VarCurr)
    <=> ( v135500(VarCurr)
        & v89156(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_1776,axiom,
    ! [VarCurr: state_type] :
      ( v135500(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17639,axiom,
    ! [VarCurr: state_type] :
      ( v135482(VarCurr)
    <=> ( v135483(VarCurr)
        | v135497(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6125,axiom,
    ! [VarCurr: state_type] :
      ( v135497(VarCurr)
    <=> ( v135498(VarCurr)
        & v89156(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_1775,axiom,
    ! [VarCurr: state_type] :
      ( v135498(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17638,axiom,
    ! [VarCurr: state_type] :
      ( v135483(VarCurr)
    <=> ( v135484(VarCurr)
        | v135495(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6124,axiom,
    ! [VarCurr: state_type] :
      ( v135495(VarCurr)
    <=> ( v135496(VarCurr)
        & v89156(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_1774,axiom,
    ! [VarCurr: state_type] :
      ( v135496(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17637,axiom,
    ! [VarCurr: state_type] :
      ( v135484(VarCurr)
    <=> ( v135485(VarCurr)
        | v135493(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6123,axiom,
    ! [VarCurr: state_type] :
      ( v135493(VarCurr)
    <=> ( v135494(VarCurr)
        & v89156(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_1773,axiom,
    ! [VarCurr: state_type] :
      ( v135494(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17636,axiom,
    ! [VarCurr: state_type] :
      ( v135485(VarCurr)
    <=> ( v135486(VarCurr)
        | v135491(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6122,axiom,
    ! [VarCurr: state_type] :
      ( v135491(VarCurr)
    <=> ( v135492(VarCurr)
        & v89156(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_1772,axiom,
    ! [VarCurr: state_type] :
      ( v135492(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17635,axiom,
    ! [VarCurr: state_type] :
      ( v135486(VarCurr)
    <=> ( v135487(VarCurr)
        | v135489(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6121,axiom,
    ! [VarCurr: state_type] :
      ( v135489(VarCurr)
    <=> ( v135490(VarCurr)
        & v89156(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_1771,axiom,
    ! [VarCurr: state_type] :
      ( v135490(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17634,axiom,
    ! [VarCurr: state_type] :
      ( v135487(VarCurr)
    <=> ( v135488(VarCurr)
        & v89156(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_1770,axiom,
    ! [VarCurr: state_type] :
      ( v135488(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17633,axiom,
    ! [VarCurr: state_type] :
      ( v86879(VarCurr)
    <=> ( v135428(VarCurr)
        & v135477(VarCurr) ) ) ).

tff(writeUnaryOperator_9923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135477(VarCurr)
    <=> v135424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17632,axiom,
    ! [VarCurr: state_type] :
      ( v135428(VarCurr)
    <=> ( v135429(VarCurr)
        & v135476(VarCurr) ) ) ).

tff(writeUnaryOperator_9922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135476(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17631,axiom,
    ! [VarCurr: state_type] :
      ( v135429(VarCurr)
    <=> ( v135430(VarCurr)
        & v135475(VarCurr) ) ) ).

tff(writeUnaryOperator_9921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135475(VarCurr)
    <=> v135253(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17630,axiom,
    ! [VarCurr: state_type] :
      ( v135430(VarCurr)
    <=> ( v135431(VarCurr)
        & v135474(VarCurr) ) ) ).

tff(writeUnaryOperator_9920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135474(VarCurr)
    <=> v128492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17629,axiom,
    ! [VarCurr: state_type] :
      ( v135431(VarCurr)
    <=> ( v135432(VarCurr)
        & v135473(VarCurr) ) ) ).

tff(writeUnaryOperator_9919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135473(VarCurr)
    <=> v108897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17628,axiom,
    ! [VarCurr: state_type] :
      ( v135432(VarCurr)
    <=> ( v135433(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17627,axiom,
    ! [VarCurr: state_type] :
      ( v135433(VarCurr)
    <=> ( v135434(VarCurr)
        & v135472(VarCurr) ) ) ).

tff(writeUnaryOperator_9918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135472(VarCurr)
    <=> v135228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17626,axiom,
    ! [VarCurr: state_type] :
      ( v135434(VarCurr)
    <=> ( v135435(VarCurr)
        & v135186(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17625,axiom,
    ! [VarCurr: state_type] :
      ( v135435(VarCurr)
    <=> ( v135436(VarCurr)
        & v109663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17624,axiom,
    ! [VarCurr: state_type] :
      ( v135436(VarCurr)
    <=> ( v135437(VarCurr)
        & v135471(VarCurr) ) ) ).

tff(writeUnaryOperator_9917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135471(VarCurr)
    <=> v111693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17623,axiom,
    ! [VarCurr: state_type] :
      ( v135437(VarCurr)
    <=> ( v135438(VarCurr)
        & v135455(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6120,axiom,
    ! [VarCurr: state_type] :
      ( v135455(VarCurr)
    <=> ( v135457(VarCurr)
        | v89117(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6119,axiom,
    ! [VarCurr: state_type] :
      ( v135457(VarCurr)
    <=> ( v135458(VarCurr)
        | v89117(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6118,axiom,
    ! [VarCurr: state_type] :
      ( v135458(VarCurr)
    <=> ( v135459(VarCurr)
        | v89117(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6117,axiom,
    ! [VarCurr: state_type] :
      ( v135459(VarCurr)
    <=> ( v135460(VarCurr)
        | v89117(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6116,axiom,
    ! [VarCurr: state_type] :
      ( v135460(VarCurr)
    <=> ( v135461(VarCurr)
        | v89117(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6115,axiom,
    ! [VarCurr: state_type] :
      ( v135461(VarCurr)
    <=> ( v135462(VarCurr)
        | v89117(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6114,axiom,
    ! [VarCurr: state_type] :
      ( v135462(VarCurr)
    <=> ( v135463(VarCurr)
        | v89117(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6113,axiom,
    ! [VarCurr: state_type] :
      ( v135463(VarCurr)
    <=> ( v135464(VarCurr)
        | v89117(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6112,axiom,
    ! [VarCurr: state_type] :
      ( v135464(VarCurr)
    <=> ( v135465(VarCurr)
        | v89117(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6111,axiom,
    ! [VarCurr: state_type] :
      ( v135465(VarCurr)
    <=> ( v135466(VarCurr)
        | v89117(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6110,axiom,
    ! [VarCurr: state_type] :
      ( v135466(VarCurr)
    <=> ( v135467(VarCurr)
        | v89117(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6109,axiom,
    ! [VarCurr: state_type] :
      ( v135467(VarCurr)
    <=> ( v135468(VarCurr)
        | v89117(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6108,axiom,
    ! [VarCurr: state_type] :
      ( v135468(VarCurr)
    <=> ( v135469(VarCurr)
        | v89117(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6107,axiom,
    ! [VarCurr: state_type] :
      ( v135469(VarCurr)
    <=> ( v135470(VarCurr)
        | v89117(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6106,axiom,
    ! [VarCurr: state_type] :
      ( v135470(VarCurr)
    <=> ( v89117(VarCurr,0)
        | v89117(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6105,axiom,
    ! [VarCurr: state_type] :
      ( v135438(VarCurr)
    <=> ( v135440(VarCurr)
        | v135454(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6104,axiom,
    ! [VarCurr: state_type] :
      ( v135440(VarCurr)
    <=> ( v135441(VarCurr)
        | v135454(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6103,axiom,
    ! [VarCurr: state_type] :
      ( v135441(VarCurr)
    <=> ( v135442(VarCurr)
        | v135454(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6102,axiom,
    ! [VarCurr: state_type] :
      ( v135442(VarCurr)
    <=> ( v135443(VarCurr)
        | v135454(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6101,axiom,
    ! [VarCurr: state_type] :
      ( v135443(VarCurr)
    <=> ( v135444(VarCurr)
        | v135454(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6100,axiom,
    ! [VarCurr: state_type] :
      ( v135444(VarCurr)
    <=> ( v135445(VarCurr)
        | v135454(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6099,axiom,
    ! [VarCurr: state_type] :
      ( v135445(VarCurr)
    <=> ( v135446(VarCurr)
        | v135454(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6098,axiom,
    ! [VarCurr: state_type] :
      ( v135446(VarCurr)
    <=> ( v135447(VarCurr)
        | v135454(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6097,axiom,
    ! [VarCurr: state_type] :
      ( v135447(VarCurr)
    <=> ( v135448(VarCurr)
        | v135454(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6096,axiom,
    ! [VarCurr: state_type] :
      ( v135448(VarCurr)
    <=> ( v135449(VarCurr)
        | v135454(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6095,axiom,
    ! [VarCurr: state_type] :
      ( v135449(VarCurr)
    <=> ( v135450(VarCurr)
        | v135454(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6094,axiom,
    ! [VarCurr: state_type] :
      ( v135450(VarCurr)
    <=> ( v135451(VarCurr)
        | v135454(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6093,axiom,
    ! [VarCurr: state_type] :
      ( v135451(VarCurr)
    <=> ( v135452(VarCurr)
        | v135454(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6092,axiom,
    ! [VarCurr: state_type] :
      ( v135452(VarCurr)
    <=> ( v135453(VarCurr)
        | v135454(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6091,axiom,
    ! [VarCurr: state_type] :
      ( v135453(VarCurr)
    <=> ( v135454(VarCurr,0)
        | v135454(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v135454(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v86881(VarCurr,B) ) ) ) ).

tff(addAssignment_76519,axiom,
    ! [VarCurr: state_type] :
      ( v135424(VarCurr)
    <=> v135426(VarCurr) ) ).

tff(addAssignment_76518,axiom,
    ! [VarCurr: state_type] :
      ( v135426(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(addAssignment_76517,axiom,
    ! [VarCurr: state_type] :
      ( v135253(VarCurr)
    <=> v135255(VarCurr) ) ).

tff(addAssignment_76516,axiom,
    ! [VarCurr: state_type] :
      ( v135255(VarCurr)
    <=> v135257(VarCurr) ) ).

tff(addAssignment_76515,axiom,
    ! [VarCurr: state_type] :
      ( v135257(VarCurr)
    <=> v135259(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1769,axiom,
    ! [VarCurr: state_type] :
      ( v135259(VarCurr)
    <=> ( ( v968(VarCurr,4)
        <=> v135421(VarCurr,4) )
        & ( v968(VarCurr,3)
        <=> v135421(VarCurr,3) )
        & ( v968(VarCurr,2)
        <=> v135421(VarCurr,2) )
        & ( v968(VarCurr,1)
        <=> v135421(VarCurr,1) )
        & ( v968(VarCurr,0)
        <=> v135421(VarCurr,0) ) ) ) ).

tff(addAssignment_76514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135421(VarCurr,B)
      <=> v83042(VarCurr,B) ) ) ).

tff(addAssignment_76513,axiom,
    ! [VarCurr: state_type] :
      ( v135421(VarCurr,4)
    <=> v135422(VarCurr) ) ).

tff(writeUnaryOperator_9916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135422(VarCurr)
    <=> v83042(VarCurr,4) ) ).

tff(addAssignment_76512,axiom,
    ! [VarCurr: state_type] :
      ( v83042(VarCurr,4)
    <=> v83044(VarCurr,4) ) ).

tff(addAssignment_76511,axiom,
    ! [VarCurr: state_type] :
      ( v83044(VarCurr,4)
    <=> v83046(VarCurr,4) ) ).

tff(addAssignment_76510,axiom,
    ! [VarNext: state_type] :
      ( v83046(VarNext,4)
    <=> v135403(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135404(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v135403(VarNext,B)
            <=> v83046(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1885,axiom,
    ! [VarNext: state_type] :
      ( v135404(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135403(VarNext,B)
          <=> v135414(VarNext,B) ) ) ) ).

tff(addAssignment_76509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135414(VarNext,B)
          <=> v135412(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135415(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135412(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1402,axiom,
    ! [VarCurr: state_type] :
      ( v135415(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135412(VarCurr,B)
          <=> v83056(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17622,axiom,
    ! [VarCurr: state_type] :
      ( v135415(VarCurr)
    <=> ( v135416(VarCurr)
        & v135417(VarCurr) ) ) ).

tff(writeUnaryOperator_9915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135417(VarCurr)
    <=> v83052(VarCurr) ) ).

tff(writeUnaryOperator_9914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135416(VarCurr)
    <=> v83048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135404(VarNext)
      <=> v135405(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135405(VarNext)
      <=> ( v135406(VarNext)
          & v135399(VarNext) ) ) ) ).

tff(writeUnaryOperator_9913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135406(VarNext)
      <=> v135408(VarNext) ) ) ).

tff(addAssignment_76508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135408(VarNext)
      <=> v135399(VarCurr) ) ) ).

tff(addAssignment_76507,axiom,
    ! [VarCurr: state_type] :
      ( v135399(VarCurr)
    <=> v135401(VarCurr) ) ).

tff(addAssignment_76506,axiom,
    ! [VarCurr: state_type] :
      ( v135401(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_76505,axiom,
    ! [VarCurr: state_type] :
      ( v83056(VarCurr,4)
    <=> v83058(VarCurr,4) ) ).

tff(addAssignment_76504,axiom,
    ! [VarCurr: state_type] :
      ( v83058(VarCurr,4)
    <=> v83060(VarCurr,4) ) ).

tff(addAssignment_76503,axiom,
    ! [VarCurr: state_type] :
      ( v83060(VarCurr,4)
    <=> v83062(VarCurr,4) ) ).

tff(addAssignment_76502,axiom,
    ! [VarCurr: state_type] :
      ( v83062(VarCurr,4)
    <=> v135340(VarCurr,4) ) ).

tff(addAssignment_76501,axiom,
    ! [VarCurr: state_type] :
      ( v135340(VarCurr,0)
    <=> v135393(VarCurr) ) ).

tff(addAssignment_76500,axiom,
    ! [VarCurr: state_type] :
      ( v135340(VarCurr,1)
    <=> v135388(VarCurr) ) ).

tff(addAssignment_76499,axiom,
    ! [VarCurr: state_type] :
      ( v135340(VarCurr,2)
    <=> v135383(VarCurr) ) ).

tff(addAssignment_76498,axiom,
    ! [VarCurr: state_type] :
      ( v135340(VarCurr,3)
    <=> v135378(VarCurr) ) ).

tff(addAssignment_76497,axiom,
    ! [VarCurr: state_type] :
      ( v135340(VarCurr,4)
    <=> v135342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17619,axiom,
    ! [VarCurr: state_type] :
      ( v135393(VarCurr)
    <=> ( v135394(VarCurr)
        & v135397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17618,axiom,
    ! [VarCurr: state_type] :
      ( v135397(VarCurr)
    <=> ( v83042(VarCurr,0)
        | v135352(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17617,axiom,
    ! [VarCurr: state_type] :
      ( v135394(VarCurr)
    <=> ( v135395(VarCurr)
        | v135396(VarCurr) ) ) ).

tff(writeUnaryOperator_9912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135396(VarCurr)
    <=> v135352(VarCurr,0) ) ).

tff(writeUnaryOperator_9911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135395(VarCurr)
    <=> v83042(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17616,axiom,
    ! [VarCurr: state_type] :
      ( v135388(VarCurr)
    <=> ( v135389(VarCurr)
        & v135392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17615,axiom,
    ! [VarCurr: state_type] :
      ( v135392(VarCurr)
    <=> ( v135351(VarCurr)
        | v135353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17614,axiom,
    ! [VarCurr: state_type] :
      ( v135389(VarCurr)
    <=> ( v135390(VarCurr)
        | v135391(VarCurr) ) ) ).

tff(writeUnaryOperator_9910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135391(VarCurr)
    <=> v135353(VarCurr) ) ).

tff(writeUnaryOperator_9909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135390(VarCurr)
    <=> v135351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17613,axiom,
    ! [VarCurr: state_type] :
      ( v135383(VarCurr)
    <=> ( v135384(VarCurr)
        & v135387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17612,axiom,
    ! [VarCurr: state_type] :
      ( v135387(VarCurr)
    <=> ( v135349(VarCurr)
        | v135359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17611,axiom,
    ! [VarCurr: state_type] :
      ( v135384(VarCurr)
    <=> ( v135385(VarCurr)
        | v135386(VarCurr) ) ) ).

tff(writeUnaryOperator_9908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135386(VarCurr)
    <=> v135359(VarCurr) ) ).

tff(writeUnaryOperator_9907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135385(VarCurr)
    <=> v135349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17610,axiom,
    ! [VarCurr: state_type] :
      ( v135378(VarCurr)
    <=> ( v135379(VarCurr)
        & v135382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17609,axiom,
    ! [VarCurr: state_type] :
      ( v135382(VarCurr)
    <=> ( v135347(VarCurr)
        | v135365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17608,axiom,
    ! [VarCurr: state_type] :
      ( v135379(VarCurr)
    <=> ( v135380(VarCurr)
        | v135381(VarCurr) ) ) ).

tff(writeUnaryOperator_9906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135381(VarCurr)
    <=> v135365(VarCurr) ) ).

tff(writeUnaryOperator_9905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135380(VarCurr)
    <=> v135347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17607,axiom,
    ! [VarCurr: state_type] :
      ( v135342(VarCurr)
    <=> ( v135343(VarCurr)
        & v135377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17606,axiom,
    ! [VarCurr: state_type] :
      ( v135377(VarCurr)
    <=> ( v135345(VarCurr)
        | v135372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17605,axiom,
    ! [VarCurr: state_type] :
      ( v135343(VarCurr)
    <=> ( v135344(VarCurr)
        | v135371(VarCurr) ) ) ).

tff(writeUnaryOperator_9904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135371(VarCurr)
    <=> v135372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17604,axiom,
    ! [VarCurr: state_type] :
      ( v135372(VarCurr)
    <=> ( v135373(VarCurr)
        & v135376(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6090,axiom,
    ! [VarCurr: state_type] :
      ( v135376(VarCurr)
    <=> ( v83042(VarCurr,4)
        | v135352(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17603,axiom,
    ! [VarCurr: state_type] :
      ( v135373(VarCurr)
    <=> ( v135374(VarCurr)
        | v135375(VarCurr) ) ) ).

tff(writeUnaryOperator_9903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135375(VarCurr)
    <=> v135352(VarCurr,4) ) ).

tff(writeUnaryOperator_9902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135374(VarCurr)
    <=> v83042(VarCurr,4) ) ).

tff(writeUnaryOperator_9901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135344(VarCurr)
    <=> v135345(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17602,axiom,
    ! [VarCurr: state_type] :
      ( v135345(VarCurr)
    <=> ( v135346(VarCurr)
        | v135370(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6089,axiom,
    ! [VarCurr: state_type] :
      ( v135370(VarCurr)
    <=> ( v83042(VarCurr,3)
        & v135352(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17601,axiom,
    ! [VarCurr: state_type] :
      ( v135346(VarCurr)
    <=> ( v135347(VarCurr)
        & v135365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17600,axiom,
    ! [VarCurr: state_type] :
      ( v135365(VarCurr)
    <=> ( v135366(VarCurr)
        & v135369(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6088,axiom,
    ! [VarCurr: state_type] :
      ( v135369(VarCurr)
    <=> ( v83042(VarCurr,3)
        | v135352(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17599,axiom,
    ! [VarCurr: state_type] :
      ( v135366(VarCurr)
    <=> ( v135367(VarCurr)
        | v135368(VarCurr) ) ) ).

tff(writeUnaryOperator_9900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135368(VarCurr)
    <=> v135352(VarCurr,3) ) ).

tff(writeUnaryOperator_9899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135367(VarCurr)
    <=> v83042(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17598,axiom,
    ! [VarCurr: state_type] :
      ( v135347(VarCurr)
    <=> ( v135348(VarCurr)
        | v135364(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6087,axiom,
    ! [VarCurr: state_type] :
      ( v135364(VarCurr)
    <=> ( v83042(VarCurr,2)
        & v135352(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17597,axiom,
    ! [VarCurr: state_type] :
      ( v135348(VarCurr)
    <=> ( v135349(VarCurr)
        & v135359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17596,axiom,
    ! [VarCurr: state_type] :
      ( v135359(VarCurr)
    <=> ( v135360(VarCurr)
        & v135363(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6086,axiom,
    ! [VarCurr: state_type] :
      ( v135363(VarCurr)
    <=> ( v83042(VarCurr,2)
        | v135352(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17595,axiom,
    ! [VarCurr: state_type] :
      ( v135360(VarCurr)
    <=> ( v135361(VarCurr)
        | v135362(VarCurr) ) ) ).

tff(writeUnaryOperator_9898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135362(VarCurr)
    <=> v135352(VarCurr,2) ) ).

tff(writeUnaryOperator_9897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135361(VarCurr)
    <=> v83042(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17594,axiom,
    ! [VarCurr: state_type] :
      ( v135349(VarCurr)
    <=> ( v135350(VarCurr)
        | v135358(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6085,axiom,
    ! [VarCurr: state_type] :
      ( v135358(VarCurr)
    <=> ( v83042(VarCurr,1)
        & v135352(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17593,axiom,
    ! [VarCurr: state_type] :
      ( v135350(VarCurr)
    <=> ( v135351(VarCurr)
        & v135353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17592,axiom,
    ! [VarCurr: state_type] :
      ( v135353(VarCurr)
    <=> ( v135354(VarCurr)
        & v135357(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6084,axiom,
    ! [VarCurr: state_type] :
      ( v135357(VarCurr)
    <=> ( v83042(VarCurr,1)
        | v135352(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17591,axiom,
    ! [VarCurr: state_type] :
      ( v135354(VarCurr)
    <=> ( v135355(VarCurr)
        | v135356(VarCurr) ) ) ).

tff(writeUnaryOperator_9896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135356(VarCurr)
    <=> v135352(VarCurr,1) ) ).

tff(writeUnaryOperator_9895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135355(VarCurr)
    <=> v83042(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17590,axiom,
    ! [VarCurr: state_type] :
      ( v135351(VarCurr)
    <=> ( v83042(VarCurr,0)
        & v135352(VarCurr,0) ) ) ).

tff(addAssignment_76496,axiom,
    ! [VarCurr: state_type] :
      ( v135352(VarCurr,0)
    <=> v83064(VarCurr) ) ).

tff(addAssignment_76495,axiom,
    ! [VarCurr: state_type] :
      ( ( v135352(VarCurr,4)
      <=> $false )
      & ( v135352(VarCurr,3)
      <=> $false )
      & ( v135352(VarCurr,2)
      <=> $false )
      & ( v135352(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_76494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v968(VarCurr,B)
      <=> v970(VarCurr,B) ) ) ).

tff(addAssignment_76493,axiom,
    ! [VarCurr: state_type] :
      ( v970(VarCurr,4)
    <=> v972(VarCurr,4) ) ).

tff(addAssignment_76492,axiom,
    ! [VarNext: state_type] :
      ( v972(VarNext,4)
    <=> v135323(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135324(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v135323(VarNext,B)
            <=> v972(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1884,axiom,
    ! [VarNext: state_type] :
      ( v135324(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135323(VarNext,B)
          <=> v135334(VarNext,B) ) ) ) ).

tff(addAssignment_76491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135334(VarNext,B)
          <=> v135332(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135335(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135332(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1401,axiom,
    ! [VarCurr: state_type] :
      ( v135335(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v135332(VarCurr,B)
          <=> v990(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17589,axiom,
    ! [VarCurr: state_type] :
      ( v135335(VarCurr)
    <=> ( v135336(VarCurr)
        & v135337(VarCurr) ) ) ).

tff(writeUnaryOperator_9894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135337(VarCurr)
    <=> v982(VarCurr) ) ).

tff(writeUnaryOperator_9893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135336(VarCurr)
    <=> v974(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135324(VarNext)
      <=> v135325(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135325(VarNext)
      <=> ( v135326(VarNext)
          & v135319(VarNext) ) ) ) ).

tff(writeUnaryOperator_9892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135326(VarNext)
      <=> v135328(VarNext) ) ) ).

tff(addAssignment_76490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135328(VarNext)
      <=> v135319(VarCurr) ) ) ).

tff(addAssignment_76489,axiom,
    ! [VarCurr: state_type] :
      ( v135319(VarCurr)
    <=> v135321(VarCurr) ) ).

tff(addAssignment_76488,axiom,
    ! [VarCurr: state_type] :
      ( v135321(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_76487,axiom,
    ! [VarCurr: state_type] :
      ( v990(VarCurr,4)
    <=> v992(VarCurr,4) ) ).

tff(addAssignment_76486,axiom,
    ! [VarCurr: state_type] :
      ( v992(VarCurr,4)
    <=> v994(VarCurr,4) ) ).

tff(addAssignment_76485,axiom,
    ! [VarCurr: state_type] :
      ( v994(VarCurr,4)
    <=> v996(VarCurr,4) ) ).

tff(addAssignment_76484,axiom,
    ! [VarCurr: state_type] :
      ( v996(VarCurr,4)
    <=> v135260(VarCurr,4) ) ).

tff(addAssignment_76483,axiom,
    ! [VarCurr: state_type] :
      ( v135260(VarCurr,0)
    <=> v135313(VarCurr) ) ).

tff(addAssignment_76482,axiom,
    ! [VarCurr: state_type] :
      ( v135260(VarCurr,1)
    <=> v135308(VarCurr) ) ).

tff(addAssignment_76481,axiom,
    ! [VarCurr: state_type] :
      ( v135260(VarCurr,2)
    <=> v135303(VarCurr) ) ).

tff(addAssignment_76480,axiom,
    ! [VarCurr: state_type] :
      ( v135260(VarCurr,3)
    <=> v135298(VarCurr) ) ).

tff(addAssignment_76479,axiom,
    ! [VarCurr: state_type] :
      ( v135260(VarCurr,4)
    <=> v135262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17586,axiom,
    ! [VarCurr: state_type] :
      ( v135313(VarCurr)
    <=> ( v135314(VarCurr)
        & v135317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17585,axiom,
    ! [VarCurr: state_type] :
      ( v135317(VarCurr)
    <=> ( v968(VarCurr,0)
        | v135272(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17584,axiom,
    ! [VarCurr: state_type] :
      ( v135314(VarCurr)
    <=> ( v135315(VarCurr)
        | v135316(VarCurr) ) ) ).

tff(writeUnaryOperator_9891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135316(VarCurr)
    <=> v135272(VarCurr,0) ) ).

tff(writeUnaryOperator_9890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135315(VarCurr)
    <=> v968(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17583,axiom,
    ! [VarCurr: state_type] :
      ( v135308(VarCurr)
    <=> ( v135309(VarCurr)
        & v135312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17582,axiom,
    ! [VarCurr: state_type] :
      ( v135312(VarCurr)
    <=> ( v135271(VarCurr)
        | v135273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17581,axiom,
    ! [VarCurr: state_type] :
      ( v135309(VarCurr)
    <=> ( v135310(VarCurr)
        | v135311(VarCurr) ) ) ).

tff(writeUnaryOperator_9889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135311(VarCurr)
    <=> v135273(VarCurr) ) ).

tff(writeUnaryOperator_9888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135310(VarCurr)
    <=> v135271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17580,axiom,
    ! [VarCurr: state_type] :
      ( v135303(VarCurr)
    <=> ( v135304(VarCurr)
        & v135307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17579,axiom,
    ! [VarCurr: state_type] :
      ( v135307(VarCurr)
    <=> ( v135269(VarCurr)
        | v135279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17578,axiom,
    ! [VarCurr: state_type] :
      ( v135304(VarCurr)
    <=> ( v135305(VarCurr)
        | v135306(VarCurr) ) ) ).

tff(writeUnaryOperator_9887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135306(VarCurr)
    <=> v135279(VarCurr) ) ).

tff(writeUnaryOperator_9886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135305(VarCurr)
    <=> v135269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17577,axiom,
    ! [VarCurr: state_type] :
      ( v135298(VarCurr)
    <=> ( v135299(VarCurr)
        & v135302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17576,axiom,
    ! [VarCurr: state_type] :
      ( v135302(VarCurr)
    <=> ( v135267(VarCurr)
        | v135285(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17575,axiom,
    ! [VarCurr: state_type] :
      ( v135299(VarCurr)
    <=> ( v135300(VarCurr)
        | v135301(VarCurr) ) ) ).

tff(writeUnaryOperator_9885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135301(VarCurr)
    <=> v135285(VarCurr) ) ).

tff(writeUnaryOperator_9884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135300(VarCurr)
    <=> v135267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17574,axiom,
    ! [VarCurr: state_type] :
      ( v135262(VarCurr)
    <=> ( v135263(VarCurr)
        & v135297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17573,axiom,
    ! [VarCurr: state_type] :
      ( v135297(VarCurr)
    <=> ( v135265(VarCurr)
        | v135292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17572,axiom,
    ! [VarCurr: state_type] :
      ( v135263(VarCurr)
    <=> ( v135264(VarCurr)
        | v135291(VarCurr) ) ) ).

tff(writeUnaryOperator_9883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135291(VarCurr)
    <=> v135292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17571,axiom,
    ! [VarCurr: state_type] :
      ( v135292(VarCurr)
    <=> ( v135293(VarCurr)
        & v135296(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6083,axiom,
    ! [VarCurr: state_type] :
      ( v135296(VarCurr)
    <=> ( v968(VarCurr,4)
        | v135272(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17570,axiom,
    ! [VarCurr: state_type] :
      ( v135293(VarCurr)
    <=> ( v135294(VarCurr)
        | v135295(VarCurr) ) ) ).

tff(writeUnaryOperator_9882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135295(VarCurr)
    <=> v135272(VarCurr,4) ) ).

tff(writeUnaryOperator_9881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135294(VarCurr)
    <=> v968(VarCurr,4) ) ).

tff(writeUnaryOperator_9880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135264(VarCurr)
    <=> v135265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17569,axiom,
    ! [VarCurr: state_type] :
      ( v135265(VarCurr)
    <=> ( v135266(VarCurr)
        | v135290(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6082,axiom,
    ! [VarCurr: state_type] :
      ( v135290(VarCurr)
    <=> ( v968(VarCurr,3)
        & v135272(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17568,axiom,
    ! [VarCurr: state_type] :
      ( v135266(VarCurr)
    <=> ( v135267(VarCurr)
        & v135285(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17567,axiom,
    ! [VarCurr: state_type] :
      ( v135285(VarCurr)
    <=> ( v135286(VarCurr)
        & v135289(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6081,axiom,
    ! [VarCurr: state_type] :
      ( v135289(VarCurr)
    <=> ( v968(VarCurr,3)
        | v135272(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17566,axiom,
    ! [VarCurr: state_type] :
      ( v135286(VarCurr)
    <=> ( v135287(VarCurr)
        | v135288(VarCurr) ) ) ).

tff(writeUnaryOperator_9879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135288(VarCurr)
    <=> v135272(VarCurr,3) ) ).

tff(writeUnaryOperator_9878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135287(VarCurr)
    <=> v968(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17565,axiom,
    ! [VarCurr: state_type] :
      ( v135267(VarCurr)
    <=> ( v135268(VarCurr)
        | v135284(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6080,axiom,
    ! [VarCurr: state_type] :
      ( v135284(VarCurr)
    <=> ( v968(VarCurr,2)
        & v135272(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17564,axiom,
    ! [VarCurr: state_type] :
      ( v135268(VarCurr)
    <=> ( v135269(VarCurr)
        & v135279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17563,axiom,
    ! [VarCurr: state_type] :
      ( v135279(VarCurr)
    <=> ( v135280(VarCurr)
        & v135283(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6079,axiom,
    ! [VarCurr: state_type] :
      ( v135283(VarCurr)
    <=> ( v968(VarCurr,2)
        | v135272(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17562,axiom,
    ! [VarCurr: state_type] :
      ( v135280(VarCurr)
    <=> ( v135281(VarCurr)
        | v135282(VarCurr) ) ) ).

tff(writeUnaryOperator_9877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135282(VarCurr)
    <=> v135272(VarCurr,2) ) ).

tff(writeUnaryOperator_9876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135281(VarCurr)
    <=> v968(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17561,axiom,
    ! [VarCurr: state_type] :
      ( v135269(VarCurr)
    <=> ( v135270(VarCurr)
        | v135278(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6078,axiom,
    ! [VarCurr: state_type] :
      ( v135278(VarCurr)
    <=> ( v968(VarCurr,1)
        & v135272(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17560,axiom,
    ! [VarCurr: state_type] :
      ( v135270(VarCurr)
    <=> ( v135271(VarCurr)
        & v135273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17559,axiom,
    ! [VarCurr: state_type] :
      ( v135273(VarCurr)
    <=> ( v135274(VarCurr)
        & v135277(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6077,axiom,
    ! [VarCurr: state_type] :
      ( v135277(VarCurr)
    <=> ( v968(VarCurr,1)
        | v135272(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17558,axiom,
    ! [VarCurr: state_type] :
      ( v135274(VarCurr)
    <=> ( v135275(VarCurr)
        | v135276(VarCurr) ) ) ).

tff(writeUnaryOperator_9875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135276(VarCurr)
    <=> v135272(VarCurr,1) ) ).

tff(writeUnaryOperator_9874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135275(VarCurr)
    <=> v968(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17557,axiom,
    ! [VarCurr: state_type] :
      ( v135271(VarCurr)
    <=> ( v968(VarCurr,0)
        & v135272(VarCurr,0) ) ) ).

tff(addAssignment_76478,axiom,
    ! [VarCurr: state_type] :
      ( v135272(VarCurr,0)
    <=> v999(VarCurr) ) ).

tff(addAssignment_76477,axiom,
    ! [VarCurr: state_type] :
      ( ( v135272(VarCurr,4)
      <=> $false )
      & ( v135272(VarCurr,3)
      <=> $false )
      & ( v135272(VarCurr,2)
      <=> $false )
      & ( v135272(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17556,axiom,
    ! [VarCurr: state_type] :
      ( v135228(VarCurr)
    <=> ( v135230(VarCurr)
        | v135250(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6076,axiom,
    ! [VarCurr: state_type] :
      ( v135250(VarCurr)
    <=> ( v135251(VarCurr)
        & v103376(VarCurr,7) ) ) ).

tff(addBitVectorEqualityBitBlasted_1768,axiom,
    ! [VarCurr: state_type] :
      ( v135251(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17555,axiom,
    ! [VarCurr: state_type] :
      ( v135230(VarCurr)
    <=> ( v135231(VarCurr)
        | v135248(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6075,axiom,
    ! [VarCurr: state_type] :
      ( v135248(VarCurr)
    <=> ( v135249(VarCurr)
        & v103376(VarCurr,6) ) ) ).

tff(addBitVectorEqualityBitBlasted_1767,axiom,
    ! [VarCurr: state_type] :
      ( v135249(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17554,axiom,
    ! [VarCurr: state_type] :
      ( v135231(VarCurr)
    <=> ( v135232(VarCurr)
        | v135246(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6074,axiom,
    ! [VarCurr: state_type] :
      ( v135246(VarCurr)
    <=> ( v135247(VarCurr)
        & v103376(VarCurr,5) ) ) ).

tff(addBitVectorEqualityBitBlasted_1766,axiom,
    ! [VarCurr: state_type] :
      ( v135247(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17553,axiom,
    ! [VarCurr: state_type] :
      ( v135232(VarCurr)
    <=> ( v135233(VarCurr)
        | v135244(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6073,axiom,
    ! [VarCurr: state_type] :
      ( v135244(VarCurr)
    <=> ( v135245(VarCurr)
        & v103376(VarCurr,4) ) ) ).

tff(addBitVectorEqualityBitBlasted_1765,axiom,
    ! [VarCurr: state_type] :
      ( v135245(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17552,axiom,
    ! [VarCurr: state_type] :
      ( v135233(VarCurr)
    <=> ( v135234(VarCurr)
        | v135242(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6072,axiom,
    ! [VarCurr: state_type] :
      ( v135242(VarCurr)
    <=> ( v135243(VarCurr)
        & v103376(VarCurr,3) ) ) ).

tff(addBitVectorEqualityBitBlasted_1764,axiom,
    ! [VarCurr: state_type] :
      ( v135243(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17551,axiom,
    ! [VarCurr: state_type] :
      ( v135234(VarCurr)
    <=> ( v135235(VarCurr)
        | v135240(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6071,axiom,
    ! [VarCurr: state_type] :
      ( v135240(VarCurr)
    <=> ( v135241(VarCurr)
        & v103376(VarCurr,2) ) ) ).

tff(addBitVectorEqualityBitBlasted_1763,axiom,
    ! [VarCurr: state_type] :
      ( v135241(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17550,axiom,
    ! [VarCurr: state_type] :
      ( v135235(VarCurr)
    <=> ( v135236(VarCurr)
        | v135238(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6070,axiom,
    ! [VarCurr: state_type] :
      ( v135238(VarCurr)
    <=> ( v135239(VarCurr)
        & v103376(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_1762,axiom,
    ! [VarCurr: state_type] :
      ( v135239(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17549,axiom,
    ! [VarCurr: state_type] :
      ( v135236(VarCurr)
    <=> ( v135237(VarCurr)
        & v103376(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_1761,axiom,
    ! [VarCurr: state_type] :
      ( v135237(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76476,axiom,
    ! [VarCurr: state_type] :
      ( v135186(VarCurr)
    <=> v135188(VarCurr) ) ).

tff(addAssignment_76475,axiom,
    ! [VarCurr: state_type] :
      ( v135188(VarCurr)
    <=> v135190(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135211(VarNext)
       => ( v135190(VarNext)
        <=> v135190(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1883,axiom,
    ! [VarNext: state_type] :
      ( v135211(VarNext)
     => ( v135190(VarNext)
      <=> v135221(VarNext) ) ) ).

tff(addAssignment_76474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135221(VarNext)
      <=> v135219(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135222(VarCurr)
     => ( v135219(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1400,axiom,
    ! [VarCurr: state_type] :
      ( v135222(VarCurr)
     => ( v135219(VarCurr)
      <=> v135200(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17548,axiom,
    ! [VarCurr: state_type] :
      ( v135222(VarCurr)
    <=> ( v135223(VarCurr)
        & v135224(VarCurr) ) ) ).

tff(writeUnaryOperator_9873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135224(VarCurr)
    <=> v135196(VarCurr) ) ).

tff(writeUnaryOperator_9872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135223(VarCurr)
    <=> v135192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135211(VarNext)
      <=> v135212(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135212(VarNext)
      <=> ( v135213(VarNext)
          & v135206(VarNext) ) ) ) ).

tff(writeUnaryOperator_9871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135213(VarNext)
      <=> v135215(VarNext) ) ) ).

tff(addAssignment_76473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135215(VarNext)
      <=> v135206(VarCurr) ) ) ).

tff(addAssignment_76472,axiom,
    ! [VarCurr: state_type] :
      ( v135206(VarCurr)
    <=> v135208(VarCurr) ) ).

tff(addAssignment_76471,axiom,
    ! [VarCurr: state_type] :
      ( v135208(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76470,axiom,
    ! [VarCurr: state_type] :
      ( v135200(VarCurr)
    <=> v135202(VarCurr) ) ).

tff(addAssignment_76469,axiom,
    ! [VarCurr: state_type] :
      ( v135202(VarCurr)
    <=> v135204(VarCurr) ) ).

tff(addAssignment_76468,axiom,
    ! [VarCurr: state_type] :
      ( v135204(VarCurr)
    <=> v109663(VarCurr) ) ).

tff(addAssignment_76467,axiom,
    ! [VarCurr: state_type] :
      ( v135196(VarCurr)
    <=> v135198(VarCurr) ) ).

tff(addAssignment_76466,axiom,
    ! [VarCurr: state_type] :
      ( v135198(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76465,axiom,
    ! [VarCurr: state_type] :
      ( v135192(VarCurr)
    <=> v135194(VarCurr) ) ).

tff(addAssignment_76464,axiom,
    ! [VarCurr: state_type] :
      ( v135194(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v89117(VarCurr,B)
      <=> ( v135183(VarCurr,B)
          & v135184(VarCurr,B) ) ) ) ).

tff(addAssignment_76463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v135184(VarCurr,B)
      <=> v89154(VarCurr,B) ) ) ).

tff(addAssignment_76462,axiom,
    ! [VarCurr: state_type] :
      ( ( v135184(VarCurr,15)
      <=> v89154(VarCurr,7) )
      & ( v135184(VarCurr,14)
      <=> v89154(VarCurr,6) )
      & ( v135184(VarCurr,13)
      <=> v89154(VarCurr,5) )
      & ( v135184(VarCurr,12)
      <=> v89154(VarCurr,4) )
      & ( v135184(VarCurr,11)
      <=> v89154(VarCurr,3) )
      & ( v135184(VarCurr,10)
      <=> v89154(VarCurr,2) )
      & ( v135184(VarCurr,9)
      <=> v89154(VarCurr,1) )
      & ( v135184(VarCurr,8)
      <=> v89154(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v135183(VarCurr,B)
      <=> ( v89119(VarCurr,B)
          & v85708(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6069,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,7)
    <=> ( v135179(VarCurr)
        & v135181(VarCurr) ) ) ).

tff(writeUnaryOperator_9870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135181(VarCurr)
    <=> v103376(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_6068,axiom,
    ! [VarCurr: state_type] :
      ( v135179(VarCurr)
    <=> ( v135180(VarCurr)
        & v103183(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6067,axiom,
    ! [VarCurr: state_type] :
      ( v135180(VarCurr)
    <=> ( v89156(VarCurr,7)
        & v133661(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6066,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,6)
    <=> ( v135175(VarCurr)
        & v135177(VarCurr) ) ) ).

tff(writeUnaryOperator_9869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135177(VarCurr)
    <=> v103376(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_6065,axiom,
    ! [VarCurr: state_type] :
      ( v135175(VarCurr)
    <=> ( v135176(VarCurr)
        & v103183(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6064,axiom,
    ! [VarCurr: state_type] :
      ( v135176(VarCurr)
    <=> ( v89156(VarCurr,6)
        & v133661(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6063,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,5)
    <=> ( v135171(VarCurr)
        & v135173(VarCurr) ) ) ).

tff(writeUnaryOperator_9868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135173(VarCurr)
    <=> v103376(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_6062,axiom,
    ! [VarCurr: state_type] :
      ( v135171(VarCurr)
    <=> ( v135172(VarCurr)
        & v103183(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6061,axiom,
    ! [VarCurr: state_type] :
      ( v135172(VarCurr)
    <=> ( v89156(VarCurr,5)
        & v133661(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6060,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,4)
    <=> ( v135167(VarCurr)
        & v135169(VarCurr) ) ) ).

tff(writeUnaryOperator_9867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135169(VarCurr)
    <=> v103376(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_6059,axiom,
    ! [VarCurr: state_type] :
      ( v135167(VarCurr)
    <=> ( v135168(VarCurr)
        & v103183(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6058,axiom,
    ! [VarCurr: state_type] :
      ( v135168(VarCurr)
    <=> ( v89156(VarCurr,4)
        & v133661(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6057,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,3)
    <=> ( v135163(VarCurr)
        & v135165(VarCurr) ) ) ).

tff(writeUnaryOperator_9866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135165(VarCurr)
    <=> v103376(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6056,axiom,
    ! [VarCurr: state_type] :
      ( v135163(VarCurr)
    <=> ( v135164(VarCurr)
        & v103183(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6055,axiom,
    ! [VarCurr: state_type] :
      ( v135164(VarCurr)
    <=> ( v89156(VarCurr,3)
        & v133661(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6054,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,2)
    <=> ( v135159(VarCurr)
        & v135161(VarCurr) ) ) ).

tff(writeUnaryOperator_9865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135161(VarCurr)
    <=> v103376(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6053,axiom,
    ! [VarCurr: state_type] :
      ( v135159(VarCurr)
    <=> ( v135160(VarCurr)
        & v103183(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6052,axiom,
    ! [VarCurr: state_type] :
      ( v135160(VarCurr)
    <=> ( v89156(VarCurr,2)
        & v133661(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6051,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,1)
    <=> ( v135155(VarCurr)
        & v135157(VarCurr) ) ) ).

tff(writeUnaryOperator_9864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135157(VarCurr)
    <=> v103376(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_6050,axiom,
    ! [VarCurr: state_type] :
      ( v135155(VarCurr)
    <=> ( v135156(VarCurr)
        & v103183(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6049,axiom,
    ! [VarCurr: state_type] :
      ( v135156(VarCurr)
    <=> ( v89156(VarCurr,1)
        & v133661(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17545,axiom,
    ! [VarCurr: state_type] :
      ( v89154(VarCurr,0)
    <=> ( v135151(VarCurr)
        & v135153(VarCurr) ) ) ).

tff(writeUnaryOperator_9863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135153(VarCurr)
    <=> v103376(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17544,axiom,
    ! [VarCurr: state_type] :
      ( v135151(VarCurr)
    <=> ( v135152(VarCurr)
        & v103183(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17543,axiom,
    ! [VarCurr: state_type] :
      ( v135152(VarCurr)
    <=> ( v89156(VarCurr,0)
        & v133661(VarCurr,0) ) ) ).

tff(addAssignment_76461,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,7)
    <=> v135057(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1760,axiom,
    ! [VarCurr: state_type] :
      ( v135057(VarCurr)
    <=> ( ( v135059(VarCurr,3)
        <=> $false )
        & ( v135059(VarCurr,2)
        <=> $false )
        & ( v135059(VarCurr,1)
        <=> $false )
        & ( v135059(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135059(VarCurr,B)
      <=> v135061(VarCurr,B) ) ) ).

tff(addAssignment_76459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135061(VarCurr,B)
      <=> v135063(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135133(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v135063(VarNext,B)
            <=> v135063(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1882,axiom,
    ! [VarNext: state_type] :
      ( v135133(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135063(VarNext,B)
          <=> v135143(VarNext,B) ) ) ) ).

tff(addAssignment_76458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135143(VarNext,B)
          <=> v135141(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135144(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135141(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1399,axiom,
    ! [VarCurr: state_type] :
      ( v135144(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135141(VarCurr,B)
          <=> v135073(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17542,axiom,
    ! [VarCurr: state_type] :
      ( v135144(VarCurr)
    <=> ( v135145(VarCurr)
        & v135146(VarCurr) ) ) ).

tff(writeUnaryOperator_9862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135146(VarCurr)
    <=> v135069(VarCurr) ) ).

tff(writeUnaryOperator_9861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135145(VarCurr)
    <=> v135065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135133(VarNext)
      <=> v135134(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135134(VarNext)
      <=> ( v135135(VarNext)
          & v135128(VarNext) ) ) ) ).

tff(writeUnaryOperator_9860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135135(VarNext)
      <=> v135137(VarNext) ) ) ).

tff(addAssignment_76457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135137(VarNext)
      <=> v135128(VarCurr) ) ) ).

tff(addAssignment_76456,axiom,
    ! [VarCurr: state_type] :
      ( v135128(VarCurr)
    <=> v135130(VarCurr) ) ).

tff(addAssignment_76455,axiom,
    ! [VarCurr: state_type] :
      ( v135130(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_76454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135073(VarCurr,B)
      <=> v135075(VarCurr,B) ) ) ).

tff(addAssignment_76453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135075(VarCurr,B)
      <=> v135077(VarCurr,B) ) ) ).

tff(addAssignment_76452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135077(VarCurr,B)
      <=> v135079(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135079(VarCurr,B)
          <=> v135083(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1398,axiom,
    ! [VarCurr: state_type] :
      ( v108201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135079(VarCurr,B)
          <=> v135081(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135083(VarCurr,B)
          <=> v135103(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1397,axiom,
    ! [VarCurr: state_type] :
      ( v108208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135083(VarCurr,B)
          <=> v135084(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135104(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135103(VarCurr,B)
          <=> v135105(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1396,axiom,
    ! [VarCurr: state_type] :
      ( v135104(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135103(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135105(VarCurr,B)
          <=> v135059(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1395,axiom,
    ! [VarCurr: state_type] :
      ( v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v135105(VarCurr,B)
          <=> v135106(VarCurr,B) ) ) ) ).

tff(addAssignment_76451,axiom,
    ! [VarCurr: state_type] :
      ( v135106(VarCurr,0)
    <=> v135125(VarCurr) ) ).

tff(addAssignment_76450,axiom,
    ! [VarCurr: state_type] :
      ( v135106(VarCurr,1)
    <=> v135123(VarCurr) ) ).

tff(addAssignment_76449,axiom,
    ! [VarCurr: state_type] :
      ( v135106(VarCurr,2)
    <=> v135119(VarCurr) ) ).

tff(addAssignment_76448,axiom,
    ! [VarCurr: state_type] :
      ( v135106(VarCurr,3)
    <=> v135108(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17539,axiom,
    ! [VarCurr: state_type] :
      ( v135123(VarCurr)
    <=> ( v135124(VarCurr)
        & v135126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17538,axiom,
    ! [VarCurr: state_type] :
      ( v135126(VarCurr)
    <=> ( v135059(VarCurr,0)
        | v135115(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6048,axiom,
    ! [VarCurr: state_type] :
      ( v135124(VarCurr)
    <=> ( v135125(VarCurr)
        | v135059(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135125(VarCurr)
    <=> v135059(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17537,axiom,
    ! [VarCurr: state_type] :
      ( v135119(VarCurr)
    <=> ( v135120(VarCurr)
        & v135122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17536,axiom,
    ! [VarCurr: state_type] :
      ( v135122(VarCurr)
    <=> ( v135113(VarCurr)
        | v135116(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6047,axiom,
    ! [VarCurr: state_type] :
      ( v135120(VarCurr)
    <=> ( v135121(VarCurr)
        | v135059(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135121(VarCurr)
    <=> v135113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17535,axiom,
    ! [VarCurr: state_type] :
      ( v135108(VarCurr)
    <=> ( v135109(VarCurr)
        & v135117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17534,axiom,
    ! [VarCurr: state_type] :
      ( v135117(VarCurr)
    <=> ( v135111(VarCurr)
        | v135118(VarCurr) ) ) ).

tff(writeUnaryOperator_9857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135118(VarCurr)
    <=> v135059(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6046,axiom,
    ! [VarCurr: state_type] :
      ( v135109(VarCurr)
    <=> ( v135110(VarCurr)
        | v135059(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135110(VarCurr)
    <=> v135111(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6045,axiom,
    ! [VarCurr: state_type] :
      ( v135111(VarCurr)
    <=> ( v135059(VarCurr,2)
        | v135112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17533,axiom,
    ! [VarCurr: state_type] :
      ( v135112(VarCurr)
    <=> ( v135113(VarCurr)
        & v135116(VarCurr) ) ) ).

tff(writeUnaryOperator_9855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135116(VarCurr)
    <=> v135059(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6044,axiom,
    ! [VarCurr: state_type] :
      ( v135113(VarCurr)
    <=> ( v135059(VarCurr,1)
        | v135114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17532,axiom,
    ! [VarCurr: state_type] :
      ( v135114(VarCurr)
    <=> ( v135059(VarCurr,0)
        & v135115(VarCurr) ) ) ).

tff(writeUnaryOperator_9854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135115(VarCurr)
    <=> v135059(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1759,axiom,
    ! [VarCurr: state_type] :
      ( v135104(VarCurr)
    <=> ( ( v135059(VarCurr,3)
        <=> $false )
        & ( v135059(VarCurr,2)
        <=> $false )
        & ( v135059(VarCurr,1)
        <=> $false )
        & ( v135059(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76447,axiom,
    ! [VarCurr: state_type] :
      ( v135084(VarCurr,0)
    <=> v135100(VarCurr) ) ).

tff(addAssignment_76446,axiom,
    ! [VarCurr: state_type] :
      ( v135084(VarCurr,1)
    <=> v135098(VarCurr) ) ).

tff(addAssignment_76445,axiom,
    ! [VarCurr: state_type] :
      ( v135084(VarCurr,2)
    <=> v135093(VarCurr) ) ).

tff(addAssignment_76444,axiom,
    ! [VarCurr: state_type] :
      ( v135084(VarCurr,3)
    <=> v135086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17531,axiom,
    ! [VarCurr: state_type] :
      ( v135098(VarCurr)
    <=> ( v135099(VarCurr)
        & v135102(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6043,axiom,
    ! [VarCurr: state_type] :
      ( v135102(VarCurr)
    <=> ( v135081(VarCurr,0)
        | v135081(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17530,axiom,
    ! [VarCurr: state_type] :
      ( v135099(VarCurr)
    <=> ( v135100(VarCurr)
        | v135101(VarCurr) ) ) ).

tff(writeUnaryOperator_9853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135101(VarCurr)
    <=> v135081(VarCurr,1) ) ).

tff(writeUnaryOperator_9852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135100(VarCurr)
    <=> v135081(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17529,axiom,
    ! [VarCurr: state_type] :
      ( v135093(VarCurr)
    <=> ( v135094(VarCurr)
        & v135097(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6042,axiom,
    ! [VarCurr: state_type] :
      ( v135097(VarCurr)
    <=> ( v135090(VarCurr)
        | v135081(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17528,axiom,
    ! [VarCurr: state_type] :
      ( v135094(VarCurr)
    <=> ( v135095(VarCurr)
        | v135096(VarCurr) ) ) ).

tff(writeUnaryOperator_9851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135096(VarCurr)
    <=> v135081(VarCurr,2) ) ).

tff(writeUnaryOperator_9850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135095(VarCurr)
    <=> v135090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17527,axiom,
    ! [VarCurr: state_type] :
      ( v135086(VarCurr)
    <=> ( v135087(VarCurr)
        & v135092(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6041,axiom,
    ! [VarCurr: state_type] :
      ( v135092(VarCurr)
    <=> ( v135089(VarCurr)
        | v135081(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17526,axiom,
    ! [VarCurr: state_type] :
      ( v135087(VarCurr)
    <=> ( v135088(VarCurr)
        | v135091(VarCurr) ) ) ).

tff(writeUnaryOperator_9849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135091(VarCurr)
    <=> v135081(VarCurr,3) ) ).

tff(writeUnaryOperator_9848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135088(VarCurr)
    <=> v135089(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6040,axiom,
    ! [VarCurr: state_type] :
      ( v135089(VarCurr)
    <=> ( v135090(VarCurr)
        & v135081(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6039,axiom,
    ! [VarCurr: state_type] :
      ( v135090(VarCurr)
    <=> ( v135081(VarCurr,0)
        & v135081(VarCurr,1) ) ) ).

tff(addAssignment_76443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v135081(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76442,axiom,
    ! [VarCurr: state_type] :
      ( v135069(VarCurr)
    <=> v135071(VarCurr) ) ).

tff(addAssignment_76441,axiom,
    ! [VarCurr: state_type] :
      ( v135071(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_76440,axiom,
    ! [VarCurr: state_type] :
      ( v135065(VarCurr)
    <=> v135067(VarCurr) ) ).

tff(addAssignment_76439,axiom,
    ! [VarCurr: state_type] :
      ( v135067(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_76438,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,7)
    <=> v134994(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1758,axiom,
    ! [VarCurr: state_type] :
      ( v134994(VarCurr)
    <=> ( v134996(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76437,axiom,
    ! [VarCurr: state_type] :
      ( v134996(VarCurr)
    <=> v134998(VarCurr) ) ).

tff(addAssignment_76436,axiom,
    ! [VarCurr: state_type] :
      ( v134998(VarCurr)
    <=> v135000(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135039(VarNext)
       => ( v135000(VarNext)
        <=> v135000(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1881,axiom,
    ! [VarNext: state_type] :
      ( v135039(VarNext)
     => ( v135000(VarNext)
      <=> v135049(VarNext) ) ) ).

tff(addAssignment_76435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135049(VarNext)
      <=> v135047(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135050(VarCurr)
     => ( v135047(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1394,axiom,
    ! [VarCurr: state_type] :
      ( v135050(VarCurr)
     => ( v135047(VarCurr)
      <=> v135010(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17525,axiom,
    ! [VarCurr: state_type] :
      ( v135050(VarCurr)
    <=> ( v135051(VarCurr)
        & v135052(VarCurr) ) ) ).

tff(writeUnaryOperator_9847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135052(VarCurr)
    <=> v135006(VarCurr) ) ).

tff(writeUnaryOperator_9846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135051(VarCurr)
    <=> v135002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135039(VarNext)
      <=> v135040(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135040(VarNext)
      <=> ( v135041(VarNext)
          & v135034(VarNext) ) ) ) ).

tff(writeUnaryOperator_9845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135041(VarNext)
      <=> v135043(VarNext) ) ) ).

tff(addAssignment_76434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135043(VarNext)
      <=> v135034(VarCurr) ) ) ).

tff(addAssignment_76433,axiom,
    ! [VarCurr: state_type] :
      ( v135034(VarCurr)
    <=> v135036(VarCurr) ) ).

tff(addAssignment_76432,axiom,
    ! [VarCurr: state_type] :
      ( v135036(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_76431,axiom,
    ! [VarCurr: state_type] :
      ( v135010(VarCurr)
    <=> v135012(VarCurr) ) ).

tff(addAssignment_76430,axiom,
    ! [VarCurr: state_type] :
      ( v135012(VarCurr)
    <=> v135014(VarCurr) ) ).

tff(addAssignment_76429,axiom,
    ! [VarCurr: state_type] :
      ( v135014(VarCurr)
    <=> v135016(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135028(VarCurr)
     => ( v135016(VarCurr)
      <=> v135029(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1393,axiom,
    ! [VarCurr: state_type] :
      ( v135028(VarCurr)
     => ( v135016(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135030(VarCurr)
     => ( v135029(VarCurr)
      <=> v135031(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1392,axiom,
    ! [VarCurr: state_type] :
      ( v135030(VarCurr)
     => ( v135029(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v135031(VarCurr)
    <=> v134996(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1757,axiom,
    ! [VarCurr: state_type] :
      ( v135030(VarCurr)
    <=> ( v134996(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17522,axiom,
    ! [VarCurr: state_type] :
      ( v135028(VarCurr)
    <=> ( v135018(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(addAssignment_76428,axiom,
    ! [VarCurr: state_type] :
      ( v135018(VarCurr)
    <=> v108183(VarCurr,2) ) ).

tff(addAssignment_76427,axiom,
    ! [VarCurr: state_type] :
      ( v108183(VarCurr,2)
    <=> v108185(VarCurr,2) ) ).

tff(addAssignment_76426,axiom,
    ! [VarNext: state_type] :
      ( v108185(VarNext,2)
    <=> v135020(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135021(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v135020(VarNext,B)
            <=> v108185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1880,axiom,
    ! [VarNext: state_type] :
      ( v135021(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v135020(VarNext,B)
          <=> v108225(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135021(VarNext)
      <=> v135022(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v135022(VarNext)
      <=> ( v135024(VarNext)
          & v108210(VarNext) ) ) ) ).

tff(writeUnaryOperator_9843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v135024(VarNext)
      <=> v108219(VarNext) ) ) ).

tff(addAssignment_76425,axiom,
    ! [VarCurr: state_type] :
      ( v108195(VarCurr,2)
    <=> v108197(VarCurr,2) ) ).

tff(addAssignment_76424,axiom,
    ! [VarCurr: state_type] :
      ( v108197(VarCurr,2)
    <=> v108199(VarCurr,2) ) ).

tff(addAssignment_76423,axiom,
    ! [VarCurr: state_type] :
      ( v108199(VarCurr,2)
    <=> v108207(VarCurr,2) ) ).

tff(addAssignment_76422,axiom,
    ! [VarCurr: state_type] :
      ( v135006(VarCurr)
    <=> v135008(VarCurr) ) ).

tff(addAssignment_76421,axiom,
    ! [VarCurr: state_type] :
      ( v135008(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_76420,axiom,
    ! [VarCurr: state_type] :
      ( v135002(VarCurr)
    <=> v135004(VarCurr) ) ).

tff(addAssignment_76419,axiom,
    ! [VarCurr: state_type] :
      ( v135004(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_76418,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,6)
    <=> v134900(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1756,axiom,
    ! [VarCurr: state_type] :
      ( v134900(VarCurr)
    <=> ( ( v134902(VarCurr,3)
        <=> $false )
        & ( v134902(VarCurr,2)
        <=> $false )
        & ( v134902(VarCurr,1)
        <=> $false )
        & ( v134902(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134902(VarCurr,B)
      <=> v134904(VarCurr,B) ) ) ).

tff(addAssignment_76416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134904(VarCurr,B)
      <=> v134906(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134976(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134906(VarNext,B)
            <=> v134906(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1879,axiom,
    ! [VarNext: state_type] :
      ( v134976(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134906(VarNext,B)
          <=> v134986(VarNext,B) ) ) ) ).

tff(addAssignment_76415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134986(VarNext,B)
          <=> v134984(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134987(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134984(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1391,axiom,
    ! [VarCurr: state_type] :
      ( v134987(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134984(VarCurr,B)
          <=> v134916(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17519,axiom,
    ! [VarCurr: state_type] :
      ( v134987(VarCurr)
    <=> ( v134988(VarCurr)
        & v134989(VarCurr) ) ) ).

tff(writeUnaryOperator_9842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134989(VarCurr)
    <=> v134912(VarCurr) ) ).

tff(writeUnaryOperator_9841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134988(VarCurr)
    <=> v134908(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134976(VarNext)
      <=> v134977(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134977(VarNext)
      <=> ( v134978(VarNext)
          & v134971(VarNext) ) ) ) ).

tff(writeUnaryOperator_9840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134978(VarNext)
      <=> v134980(VarNext) ) ) ).

tff(addAssignment_76414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134980(VarNext)
      <=> v134971(VarCurr) ) ) ).

tff(addAssignment_76413,axiom,
    ! [VarCurr: state_type] :
      ( v134971(VarCurr)
    <=> v134973(VarCurr) ) ).

tff(addAssignment_76412,axiom,
    ! [VarCurr: state_type] :
      ( v134973(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_76411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134916(VarCurr,B)
      <=> v134918(VarCurr,B) ) ) ).

tff(addAssignment_76410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134918(VarCurr,B)
      <=> v134920(VarCurr,B) ) ) ).

tff(addAssignment_76409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134920(VarCurr,B)
      <=> v134922(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134922(VarCurr,B)
          <=> v134926(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1390,axiom,
    ! [VarCurr: state_type] :
      ( v107500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134922(VarCurr,B)
          <=> v134924(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107507(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134926(VarCurr,B)
          <=> v134946(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1389,axiom,
    ! [VarCurr: state_type] :
      ( v107507(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134926(VarCurr,B)
          <=> v134927(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134947(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134946(VarCurr,B)
          <=> v134948(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1388,axiom,
    ! [VarCurr: state_type] :
      ( v134947(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134946(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134948(VarCurr,B)
          <=> v134902(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1387,axiom,
    ! [VarCurr: state_type] :
      ( v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134948(VarCurr,B)
          <=> v134949(VarCurr,B) ) ) ) ).

tff(addAssignment_76408,axiom,
    ! [VarCurr: state_type] :
      ( v134949(VarCurr,0)
    <=> v134968(VarCurr) ) ).

tff(addAssignment_76407,axiom,
    ! [VarCurr: state_type] :
      ( v134949(VarCurr,1)
    <=> v134966(VarCurr) ) ).

tff(addAssignment_76406,axiom,
    ! [VarCurr: state_type] :
      ( v134949(VarCurr,2)
    <=> v134962(VarCurr) ) ).

tff(addAssignment_76405,axiom,
    ! [VarCurr: state_type] :
      ( v134949(VarCurr,3)
    <=> v134951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17516,axiom,
    ! [VarCurr: state_type] :
      ( v134966(VarCurr)
    <=> ( v134967(VarCurr)
        & v134969(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17515,axiom,
    ! [VarCurr: state_type] :
      ( v134969(VarCurr)
    <=> ( v134902(VarCurr,0)
        | v134958(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6038,axiom,
    ! [VarCurr: state_type] :
      ( v134967(VarCurr)
    <=> ( v134968(VarCurr)
        | v134902(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134968(VarCurr)
    <=> v134902(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17514,axiom,
    ! [VarCurr: state_type] :
      ( v134962(VarCurr)
    <=> ( v134963(VarCurr)
        & v134965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17513,axiom,
    ! [VarCurr: state_type] :
      ( v134965(VarCurr)
    <=> ( v134956(VarCurr)
        | v134959(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6037,axiom,
    ! [VarCurr: state_type] :
      ( v134963(VarCurr)
    <=> ( v134964(VarCurr)
        | v134902(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134964(VarCurr)
    <=> v134956(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17512,axiom,
    ! [VarCurr: state_type] :
      ( v134951(VarCurr)
    <=> ( v134952(VarCurr)
        & v134960(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17511,axiom,
    ! [VarCurr: state_type] :
      ( v134960(VarCurr)
    <=> ( v134954(VarCurr)
        | v134961(VarCurr) ) ) ).

tff(writeUnaryOperator_9837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134961(VarCurr)
    <=> v134902(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6036,axiom,
    ! [VarCurr: state_type] :
      ( v134952(VarCurr)
    <=> ( v134953(VarCurr)
        | v134902(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134953(VarCurr)
    <=> v134954(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6035,axiom,
    ! [VarCurr: state_type] :
      ( v134954(VarCurr)
    <=> ( v134902(VarCurr,2)
        | v134955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17510,axiom,
    ! [VarCurr: state_type] :
      ( v134955(VarCurr)
    <=> ( v134956(VarCurr)
        & v134959(VarCurr) ) ) ).

tff(writeUnaryOperator_9835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134959(VarCurr)
    <=> v134902(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6034,axiom,
    ! [VarCurr: state_type] :
      ( v134956(VarCurr)
    <=> ( v134902(VarCurr,1)
        | v134957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17509,axiom,
    ! [VarCurr: state_type] :
      ( v134957(VarCurr)
    <=> ( v134902(VarCurr,0)
        & v134958(VarCurr) ) ) ).

tff(writeUnaryOperator_9834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134958(VarCurr)
    <=> v134902(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1755,axiom,
    ! [VarCurr: state_type] :
      ( v134947(VarCurr)
    <=> ( ( v134902(VarCurr,3)
        <=> $false )
        & ( v134902(VarCurr,2)
        <=> $false )
        & ( v134902(VarCurr,1)
        <=> $false )
        & ( v134902(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76404,axiom,
    ! [VarCurr: state_type] :
      ( v134927(VarCurr,0)
    <=> v134943(VarCurr) ) ).

tff(addAssignment_76403,axiom,
    ! [VarCurr: state_type] :
      ( v134927(VarCurr,1)
    <=> v134941(VarCurr) ) ).

tff(addAssignment_76402,axiom,
    ! [VarCurr: state_type] :
      ( v134927(VarCurr,2)
    <=> v134936(VarCurr) ) ).

tff(addAssignment_76401,axiom,
    ! [VarCurr: state_type] :
      ( v134927(VarCurr,3)
    <=> v134929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17508,axiom,
    ! [VarCurr: state_type] :
      ( v134941(VarCurr)
    <=> ( v134942(VarCurr)
        & v134945(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6033,axiom,
    ! [VarCurr: state_type] :
      ( v134945(VarCurr)
    <=> ( v134924(VarCurr,0)
        | v134924(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17507,axiom,
    ! [VarCurr: state_type] :
      ( v134942(VarCurr)
    <=> ( v134943(VarCurr)
        | v134944(VarCurr) ) ) ).

tff(writeUnaryOperator_9833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134944(VarCurr)
    <=> v134924(VarCurr,1) ) ).

tff(writeUnaryOperator_9832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134943(VarCurr)
    <=> v134924(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17506,axiom,
    ! [VarCurr: state_type] :
      ( v134936(VarCurr)
    <=> ( v134937(VarCurr)
        & v134940(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6032,axiom,
    ! [VarCurr: state_type] :
      ( v134940(VarCurr)
    <=> ( v134933(VarCurr)
        | v134924(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17505,axiom,
    ! [VarCurr: state_type] :
      ( v134937(VarCurr)
    <=> ( v134938(VarCurr)
        | v134939(VarCurr) ) ) ).

tff(writeUnaryOperator_9831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134939(VarCurr)
    <=> v134924(VarCurr,2) ) ).

tff(writeUnaryOperator_9830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134938(VarCurr)
    <=> v134933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17504,axiom,
    ! [VarCurr: state_type] :
      ( v134929(VarCurr)
    <=> ( v134930(VarCurr)
        & v134935(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6031,axiom,
    ! [VarCurr: state_type] :
      ( v134935(VarCurr)
    <=> ( v134932(VarCurr)
        | v134924(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17503,axiom,
    ! [VarCurr: state_type] :
      ( v134930(VarCurr)
    <=> ( v134931(VarCurr)
        | v134934(VarCurr) ) ) ).

tff(writeUnaryOperator_9829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134934(VarCurr)
    <=> v134924(VarCurr,3) ) ).

tff(writeUnaryOperator_9828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134931(VarCurr)
    <=> v134932(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6030,axiom,
    ! [VarCurr: state_type] :
      ( v134932(VarCurr)
    <=> ( v134933(VarCurr)
        & v134924(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6029,axiom,
    ! [VarCurr: state_type] :
      ( v134933(VarCurr)
    <=> ( v134924(VarCurr,0)
        & v134924(VarCurr,1) ) ) ).

tff(addAssignment_76400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134924(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76399,axiom,
    ! [VarCurr: state_type] :
      ( v134912(VarCurr)
    <=> v134914(VarCurr) ) ).

tff(addAssignment_76398,axiom,
    ! [VarCurr: state_type] :
      ( v134914(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_76397,axiom,
    ! [VarCurr: state_type] :
      ( v134908(VarCurr)
    <=> v134910(VarCurr) ) ).

tff(addAssignment_76396,axiom,
    ! [VarCurr: state_type] :
      ( v134910(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_76395,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,6)
    <=> v134837(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1754,axiom,
    ! [VarCurr: state_type] :
      ( v134837(VarCurr)
    <=> ( v134839(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76394,axiom,
    ! [VarCurr: state_type] :
      ( v134839(VarCurr)
    <=> v134841(VarCurr) ) ).

tff(addAssignment_76393,axiom,
    ! [VarCurr: state_type] :
      ( v134841(VarCurr)
    <=> v134843(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134882(VarNext)
       => ( v134843(VarNext)
        <=> v134843(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1878,axiom,
    ! [VarNext: state_type] :
      ( v134882(VarNext)
     => ( v134843(VarNext)
      <=> v134892(VarNext) ) ) ).

tff(addAssignment_76392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134892(VarNext)
      <=> v134890(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134893(VarCurr)
     => ( v134890(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1386,axiom,
    ! [VarCurr: state_type] :
      ( v134893(VarCurr)
     => ( v134890(VarCurr)
      <=> v134853(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17502,axiom,
    ! [VarCurr: state_type] :
      ( v134893(VarCurr)
    <=> ( v134894(VarCurr)
        & v134895(VarCurr) ) ) ).

tff(writeUnaryOperator_9827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134895(VarCurr)
    <=> v134849(VarCurr) ) ).

tff(writeUnaryOperator_9826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134894(VarCurr)
    <=> v134845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134882(VarNext)
      <=> v134883(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134883(VarNext)
      <=> ( v134884(VarNext)
          & v134877(VarNext) ) ) ) ).

tff(writeUnaryOperator_9825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134884(VarNext)
      <=> v134886(VarNext) ) ) ).

tff(addAssignment_76391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134886(VarNext)
      <=> v134877(VarCurr) ) ) ).

tff(addAssignment_76390,axiom,
    ! [VarCurr: state_type] :
      ( v134877(VarCurr)
    <=> v134879(VarCurr) ) ).

tff(addAssignment_76389,axiom,
    ! [VarCurr: state_type] :
      ( v134879(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_76388,axiom,
    ! [VarCurr: state_type] :
      ( v134853(VarCurr)
    <=> v134855(VarCurr) ) ).

tff(addAssignment_76387,axiom,
    ! [VarCurr: state_type] :
      ( v134855(VarCurr)
    <=> v134857(VarCurr) ) ).

tff(addAssignment_76386,axiom,
    ! [VarCurr: state_type] :
      ( v134857(VarCurr)
    <=> v134859(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134871(VarCurr)
     => ( v134859(VarCurr)
      <=> v134872(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1385,axiom,
    ! [VarCurr: state_type] :
      ( v134871(VarCurr)
     => ( v134859(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134873(VarCurr)
     => ( v134872(VarCurr)
      <=> v134874(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1384,axiom,
    ! [VarCurr: state_type] :
      ( v134873(VarCurr)
     => ( v134872(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134874(VarCurr)
    <=> v134839(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1753,axiom,
    ! [VarCurr: state_type] :
      ( v134873(VarCurr)
    <=> ( v134839(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17499,axiom,
    ! [VarCurr: state_type] :
      ( v134871(VarCurr)
    <=> ( v134861(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(addAssignment_76385,axiom,
    ! [VarCurr: state_type] :
      ( v134861(VarCurr)
    <=> v107482(VarCurr,2) ) ).

tff(addAssignment_76384,axiom,
    ! [VarCurr: state_type] :
      ( v107482(VarCurr,2)
    <=> v107484(VarCurr,2) ) ).

tff(addAssignment_76383,axiom,
    ! [VarNext: state_type] :
      ( v107484(VarNext,2)
    <=> v134863(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134864(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134863(VarNext,B)
            <=> v107484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1877,axiom,
    ! [VarNext: state_type] :
      ( v134864(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134863(VarNext,B)
          <=> v107524(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134864(VarNext)
      <=> v134865(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134865(VarNext)
      <=> ( v134867(VarNext)
          & v107509(VarNext) ) ) ) ).

tff(writeUnaryOperator_9823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134867(VarNext)
      <=> v107518(VarNext) ) ) ).

tff(addAssignment_76382,axiom,
    ! [VarCurr: state_type] :
      ( v107494(VarCurr,2)
    <=> v107496(VarCurr,2) ) ).

tff(addAssignment_76381,axiom,
    ! [VarCurr: state_type] :
      ( v107496(VarCurr,2)
    <=> v107498(VarCurr,2) ) ).

tff(addAssignment_76380,axiom,
    ! [VarCurr: state_type] :
      ( v107498(VarCurr,2)
    <=> v107506(VarCurr,2) ) ).

tff(addAssignment_76379,axiom,
    ! [VarCurr: state_type] :
      ( v134849(VarCurr)
    <=> v134851(VarCurr) ) ).

tff(addAssignment_76378,axiom,
    ! [VarCurr: state_type] :
      ( v134851(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_76377,axiom,
    ! [VarCurr: state_type] :
      ( v134845(VarCurr)
    <=> v134847(VarCurr) ) ).

tff(addAssignment_76376,axiom,
    ! [VarCurr: state_type] :
      ( v134847(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_76375,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,5)
    <=> v134743(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1752,axiom,
    ! [VarCurr: state_type] :
      ( v134743(VarCurr)
    <=> ( ( v134745(VarCurr,3)
        <=> $false )
        & ( v134745(VarCurr,2)
        <=> $false )
        & ( v134745(VarCurr,1)
        <=> $false )
        & ( v134745(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134745(VarCurr,B)
      <=> v134747(VarCurr,B) ) ) ).

tff(addAssignment_76373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134747(VarCurr,B)
      <=> v134749(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134819(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134749(VarNext,B)
            <=> v134749(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1876,axiom,
    ! [VarNext: state_type] :
      ( v134819(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134749(VarNext,B)
          <=> v134829(VarNext,B) ) ) ) ).

tff(addAssignment_76372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134829(VarNext,B)
          <=> v134827(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134830(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134827(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1383,axiom,
    ! [VarCurr: state_type] :
      ( v134830(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134827(VarCurr,B)
          <=> v134759(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17496,axiom,
    ! [VarCurr: state_type] :
      ( v134830(VarCurr)
    <=> ( v134831(VarCurr)
        & v134832(VarCurr) ) ) ).

tff(writeUnaryOperator_9822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134832(VarCurr)
    <=> v134755(VarCurr) ) ).

tff(writeUnaryOperator_9821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134831(VarCurr)
    <=> v134751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134819(VarNext)
      <=> v134820(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134820(VarNext)
      <=> ( v134821(VarNext)
          & v134814(VarNext) ) ) ) ).

tff(writeUnaryOperator_9820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134821(VarNext)
      <=> v134823(VarNext) ) ) ).

tff(addAssignment_76371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134823(VarNext)
      <=> v134814(VarCurr) ) ) ).

tff(addAssignment_76370,axiom,
    ! [VarCurr: state_type] :
      ( v134814(VarCurr)
    <=> v134816(VarCurr) ) ).

tff(addAssignment_76369,axiom,
    ! [VarCurr: state_type] :
      ( v134816(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_76368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134759(VarCurr,B)
      <=> v134761(VarCurr,B) ) ) ).

tff(addAssignment_76367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134761(VarCurr,B)
      <=> v134763(VarCurr,B) ) ) ).

tff(addAssignment_76366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134763(VarCurr,B)
      <=> v134765(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134765(VarCurr,B)
          <=> v134769(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1382,axiom,
    ! [VarCurr: state_type] :
      ( v106799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134765(VarCurr,B)
          <=> v134767(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134769(VarCurr,B)
          <=> v134789(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1381,axiom,
    ! [VarCurr: state_type] :
      ( v106806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134769(VarCurr,B)
          <=> v134770(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134790(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134789(VarCurr,B)
          <=> v134791(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1380,axiom,
    ! [VarCurr: state_type] :
      ( v134790(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134789(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134791(VarCurr,B)
          <=> v134745(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1379,axiom,
    ! [VarCurr: state_type] :
      ( v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134791(VarCurr,B)
          <=> v134792(VarCurr,B) ) ) ) ).

tff(addAssignment_76365,axiom,
    ! [VarCurr: state_type] :
      ( v134792(VarCurr,0)
    <=> v134811(VarCurr) ) ).

tff(addAssignment_76364,axiom,
    ! [VarCurr: state_type] :
      ( v134792(VarCurr,1)
    <=> v134809(VarCurr) ) ).

tff(addAssignment_76363,axiom,
    ! [VarCurr: state_type] :
      ( v134792(VarCurr,2)
    <=> v134805(VarCurr) ) ).

tff(addAssignment_76362,axiom,
    ! [VarCurr: state_type] :
      ( v134792(VarCurr,3)
    <=> v134794(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17493,axiom,
    ! [VarCurr: state_type] :
      ( v134809(VarCurr)
    <=> ( v134810(VarCurr)
        & v134812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17492,axiom,
    ! [VarCurr: state_type] :
      ( v134812(VarCurr)
    <=> ( v134745(VarCurr,0)
        | v134801(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6028,axiom,
    ! [VarCurr: state_type] :
      ( v134810(VarCurr)
    <=> ( v134811(VarCurr)
        | v134745(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134811(VarCurr)
    <=> v134745(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17491,axiom,
    ! [VarCurr: state_type] :
      ( v134805(VarCurr)
    <=> ( v134806(VarCurr)
        & v134808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17490,axiom,
    ! [VarCurr: state_type] :
      ( v134808(VarCurr)
    <=> ( v134799(VarCurr)
        | v134802(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6027,axiom,
    ! [VarCurr: state_type] :
      ( v134806(VarCurr)
    <=> ( v134807(VarCurr)
        | v134745(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134807(VarCurr)
    <=> v134799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17489,axiom,
    ! [VarCurr: state_type] :
      ( v134794(VarCurr)
    <=> ( v134795(VarCurr)
        & v134803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17488,axiom,
    ! [VarCurr: state_type] :
      ( v134803(VarCurr)
    <=> ( v134797(VarCurr)
        | v134804(VarCurr) ) ) ).

tff(writeUnaryOperator_9817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134804(VarCurr)
    <=> v134745(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6026,axiom,
    ! [VarCurr: state_type] :
      ( v134795(VarCurr)
    <=> ( v134796(VarCurr)
        | v134745(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134796(VarCurr)
    <=> v134797(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6025,axiom,
    ! [VarCurr: state_type] :
      ( v134797(VarCurr)
    <=> ( v134745(VarCurr,2)
        | v134798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17487,axiom,
    ! [VarCurr: state_type] :
      ( v134798(VarCurr)
    <=> ( v134799(VarCurr)
        & v134802(VarCurr) ) ) ).

tff(writeUnaryOperator_9815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134802(VarCurr)
    <=> v134745(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6024,axiom,
    ! [VarCurr: state_type] :
      ( v134799(VarCurr)
    <=> ( v134745(VarCurr,1)
        | v134800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17486,axiom,
    ! [VarCurr: state_type] :
      ( v134800(VarCurr)
    <=> ( v134745(VarCurr,0)
        & v134801(VarCurr) ) ) ).

tff(writeUnaryOperator_9814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134801(VarCurr)
    <=> v134745(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1751,axiom,
    ! [VarCurr: state_type] :
      ( v134790(VarCurr)
    <=> ( ( v134745(VarCurr,3)
        <=> $false )
        & ( v134745(VarCurr,2)
        <=> $false )
        & ( v134745(VarCurr,1)
        <=> $false )
        & ( v134745(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76361,axiom,
    ! [VarCurr: state_type] :
      ( v134770(VarCurr,0)
    <=> v134786(VarCurr) ) ).

tff(addAssignment_76360,axiom,
    ! [VarCurr: state_type] :
      ( v134770(VarCurr,1)
    <=> v134784(VarCurr) ) ).

tff(addAssignment_76359,axiom,
    ! [VarCurr: state_type] :
      ( v134770(VarCurr,2)
    <=> v134779(VarCurr) ) ).

tff(addAssignment_76358,axiom,
    ! [VarCurr: state_type] :
      ( v134770(VarCurr,3)
    <=> v134772(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17485,axiom,
    ! [VarCurr: state_type] :
      ( v134784(VarCurr)
    <=> ( v134785(VarCurr)
        & v134788(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6023,axiom,
    ! [VarCurr: state_type] :
      ( v134788(VarCurr)
    <=> ( v134767(VarCurr,0)
        | v134767(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17484,axiom,
    ! [VarCurr: state_type] :
      ( v134785(VarCurr)
    <=> ( v134786(VarCurr)
        | v134787(VarCurr) ) ) ).

tff(writeUnaryOperator_9813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134787(VarCurr)
    <=> v134767(VarCurr,1) ) ).

tff(writeUnaryOperator_9812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134786(VarCurr)
    <=> v134767(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17483,axiom,
    ! [VarCurr: state_type] :
      ( v134779(VarCurr)
    <=> ( v134780(VarCurr)
        & v134783(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6022,axiom,
    ! [VarCurr: state_type] :
      ( v134783(VarCurr)
    <=> ( v134776(VarCurr)
        | v134767(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17482,axiom,
    ! [VarCurr: state_type] :
      ( v134780(VarCurr)
    <=> ( v134781(VarCurr)
        | v134782(VarCurr) ) ) ).

tff(writeUnaryOperator_9811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134782(VarCurr)
    <=> v134767(VarCurr,2) ) ).

tff(writeUnaryOperator_9810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134781(VarCurr)
    <=> v134776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17481,axiom,
    ! [VarCurr: state_type] :
      ( v134772(VarCurr)
    <=> ( v134773(VarCurr)
        & v134778(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6021,axiom,
    ! [VarCurr: state_type] :
      ( v134778(VarCurr)
    <=> ( v134775(VarCurr)
        | v134767(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17480,axiom,
    ! [VarCurr: state_type] :
      ( v134773(VarCurr)
    <=> ( v134774(VarCurr)
        | v134777(VarCurr) ) ) ).

tff(writeUnaryOperator_9809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134777(VarCurr)
    <=> v134767(VarCurr,3) ) ).

tff(writeUnaryOperator_9808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134774(VarCurr)
    <=> v134775(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6020,axiom,
    ! [VarCurr: state_type] :
      ( v134775(VarCurr)
    <=> ( v134776(VarCurr)
        & v134767(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6019,axiom,
    ! [VarCurr: state_type] :
      ( v134776(VarCurr)
    <=> ( v134767(VarCurr,0)
        & v134767(VarCurr,1) ) ) ).

tff(addAssignment_76357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134767(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76356,axiom,
    ! [VarCurr: state_type] :
      ( v134755(VarCurr)
    <=> v134757(VarCurr) ) ).

tff(addAssignment_76355,axiom,
    ! [VarCurr: state_type] :
      ( v134757(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_76354,axiom,
    ! [VarCurr: state_type] :
      ( v134751(VarCurr)
    <=> v134753(VarCurr) ) ).

tff(addAssignment_76353,axiom,
    ! [VarCurr: state_type] :
      ( v134753(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_76352,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,5)
    <=> v134680(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1750,axiom,
    ! [VarCurr: state_type] :
      ( v134680(VarCurr)
    <=> ( v134682(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76351,axiom,
    ! [VarCurr: state_type] :
      ( v134682(VarCurr)
    <=> v134684(VarCurr) ) ).

tff(addAssignment_76350,axiom,
    ! [VarCurr: state_type] :
      ( v134684(VarCurr)
    <=> v134686(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134725(VarNext)
       => ( v134686(VarNext)
        <=> v134686(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1875,axiom,
    ! [VarNext: state_type] :
      ( v134725(VarNext)
     => ( v134686(VarNext)
      <=> v134735(VarNext) ) ) ).

tff(addAssignment_76349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134735(VarNext)
      <=> v134733(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134736(VarCurr)
     => ( v134733(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1378,axiom,
    ! [VarCurr: state_type] :
      ( v134736(VarCurr)
     => ( v134733(VarCurr)
      <=> v134696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17479,axiom,
    ! [VarCurr: state_type] :
      ( v134736(VarCurr)
    <=> ( v134737(VarCurr)
        & v134738(VarCurr) ) ) ).

tff(writeUnaryOperator_9807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134738(VarCurr)
    <=> v134692(VarCurr) ) ).

tff(writeUnaryOperator_9806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134737(VarCurr)
    <=> v134688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134725(VarNext)
      <=> v134726(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134726(VarNext)
      <=> ( v134727(VarNext)
          & v134720(VarNext) ) ) ) ).

tff(writeUnaryOperator_9805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134727(VarNext)
      <=> v134729(VarNext) ) ) ).

tff(addAssignment_76348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134729(VarNext)
      <=> v134720(VarCurr) ) ) ).

tff(addAssignment_76347,axiom,
    ! [VarCurr: state_type] :
      ( v134720(VarCurr)
    <=> v134722(VarCurr) ) ).

tff(addAssignment_76346,axiom,
    ! [VarCurr: state_type] :
      ( v134722(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_76345,axiom,
    ! [VarCurr: state_type] :
      ( v134696(VarCurr)
    <=> v134698(VarCurr) ) ).

tff(addAssignment_76344,axiom,
    ! [VarCurr: state_type] :
      ( v134698(VarCurr)
    <=> v134700(VarCurr) ) ).

tff(addAssignment_76343,axiom,
    ! [VarCurr: state_type] :
      ( v134700(VarCurr)
    <=> v134702(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134714(VarCurr)
     => ( v134702(VarCurr)
      <=> v134715(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1377,axiom,
    ! [VarCurr: state_type] :
      ( v134714(VarCurr)
     => ( v134702(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134716(VarCurr)
     => ( v134715(VarCurr)
      <=> v134717(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1376,axiom,
    ! [VarCurr: state_type] :
      ( v134716(VarCurr)
     => ( v134715(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134717(VarCurr)
    <=> v134682(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1749,axiom,
    ! [VarCurr: state_type] :
      ( v134716(VarCurr)
    <=> ( v134682(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17476,axiom,
    ! [VarCurr: state_type] :
      ( v134714(VarCurr)
    <=> ( v134704(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(addAssignment_76342,axiom,
    ! [VarCurr: state_type] :
      ( v134704(VarCurr)
    <=> v106781(VarCurr,2) ) ).

tff(addAssignment_76341,axiom,
    ! [VarCurr: state_type] :
      ( v106781(VarCurr,2)
    <=> v106783(VarCurr,2) ) ).

tff(addAssignment_76340,axiom,
    ! [VarNext: state_type] :
      ( v106783(VarNext,2)
    <=> v134706(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134707(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134706(VarNext,B)
            <=> v106783(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1874,axiom,
    ! [VarNext: state_type] :
      ( v134707(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134706(VarNext,B)
          <=> v106823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134707(VarNext)
      <=> v134708(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134708(VarNext)
      <=> ( v134710(VarNext)
          & v106808(VarNext) ) ) ) ).

tff(writeUnaryOperator_9803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134710(VarNext)
      <=> v106817(VarNext) ) ) ).

tff(addAssignment_76339,axiom,
    ! [VarCurr: state_type] :
      ( v106793(VarCurr,2)
    <=> v106795(VarCurr,2) ) ).

tff(addAssignment_76338,axiom,
    ! [VarCurr: state_type] :
      ( v106795(VarCurr,2)
    <=> v106797(VarCurr,2) ) ).

tff(addAssignment_76337,axiom,
    ! [VarCurr: state_type] :
      ( v106797(VarCurr,2)
    <=> v106805(VarCurr,2) ) ).

tff(addAssignment_76336,axiom,
    ! [VarCurr: state_type] :
      ( v134692(VarCurr)
    <=> v134694(VarCurr) ) ).

tff(addAssignment_76335,axiom,
    ! [VarCurr: state_type] :
      ( v134694(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_76334,axiom,
    ! [VarCurr: state_type] :
      ( v134688(VarCurr)
    <=> v134690(VarCurr) ) ).

tff(addAssignment_76333,axiom,
    ! [VarCurr: state_type] :
      ( v134690(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_76332,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,4)
    <=> v134586(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1748,axiom,
    ! [VarCurr: state_type] :
      ( v134586(VarCurr)
    <=> ( ( v134588(VarCurr,3)
        <=> $false )
        & ( v134588(VarCurr,2)
        <=> $false )
        & ( v134588(VarCurr,1)
        <=> $false )
        & ( v134588(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134588(VarCurr,B)
      <=> v134590(VarCurr,B) ) ) ).

tff(addAssignment_76330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134590(VarCurr,B)
      <=> v134592(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134662(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134592(VarNext,B)
            <=> v134592(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1873,axiom,
    ! [VarNext: state_type] :
      ( v134662(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134592(VarNext,B)
          <=> v134672(VarNext,B) ) ) ) ).

tff(addAssignment_76329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134672(VarNext,B)
          <=> v134670(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134673(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134670(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1375,axiom,
    ! [VarCurr: state_type] :
      ( v134673(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134670(VarCurr,B)
          <=> v134602(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17473,axiom,
    ! [VarCurr: state_type] :
      ( v134673(VarCurr)
    <=> ( v134674(VarCurr)
        & v134675(VarCurr) ) ) ).

tff(writeUnaryOperator_9802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134675(VarCurr)
    <=> v134598(VarCurr) ) ).

tff(writeUnaryOperator_9801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134674(VarCurr)
    <=> v134594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134662(VarNext)
      <=> v134663(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134663(VarNext)
      <=> ( v134664(VarNext)
          & v134657(VarNext) ) ) ) ).

tff(writeUnaryOperator_9800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134664(VarNext)
      <=> v134666(VarNext) ) ) ).

tff(addAssignment_76328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134666(VarNext)
      <=> v134657(VarCurr) ) ) ).

tff(addAssignment_76327,axiom,
    ! [VarCurr: state_type] :
      ( v134657(VarCurr)
    <=> v134659(VarCurr) ) ).

tff(addAssignment_76326,axiom,
    ! [VarCurr: state_type] :
      ( v134659(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_76325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134602(VarCurr,B)
      <=> v134604(VarCurr,B) ) ) ).

tff(addAssignment_76324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134604(VarCurr,B)
      <=> v134606(VarCurr,B) ) ) ).

tff(addAssignment_76323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134606(VarCurr,B)
      <=> v134608(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106098(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134608(VarCurr,B)
          <=> v134612(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1374,axiom,
    ! [VarCurr: state_type] :
      ( v106098(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134608(VarCurr,B)
          <=> v134610(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134612(VarCurr,B)
          <=> v134632(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1373,axiom,
    ! [VarCurr: state_type] :
      ( v106105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134612(VarCurr,B)
          <=> v134613(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134633(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134632(VarCurr,B)
          <=> v134634(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1372,axiom,
    ! [VarCurr: state_type] :
      ( v134633(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134632(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134634(VarCurr,B)
          <=> v134588(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1371,axiom,
    ! [VarCurr: state_type] :
      ( v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134634(VarCurr,B)
          <=> v134635(VarCurr,B) ) ) ) ).

tff(addAssignment_76322,axiom,
    ! [VarCurr: state_type] :
      ( v134635(VarCurr,0)
    <=> v134654(VarCurr) ) ).

tff(addAssignment_76321,axiom,
    ! [VarCurr: state_type] :
      ( v134635(VarCurr,1)
    <=> v134652(VarCurr) ) ).

tff(addAssignment_76320,axiom,
    ! [VarCurr: state_type] :
      ( v134635(VarCurr,2)
    <=> v134648(VarCurr) ) ).

tff(addAssignment_76319,axiom,
    ! [VarCurr: state_type] :
      ( v134635(VarCurr,3)
    <=> v134637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17470,axiom,
    ! [VarCurr: state_type] :
      ( v134652(VarCurr)
    <=> ( v134653(VarCurr)
        & v134655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17469,axiom,
    ! [VarCurr: state_type] :
      ( v134655(VarCurr)
    <=> ( v134588(VarCurr,0)
        | v134644(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6018,axiom,
    ! [VarCurr: state_type] :
      ( v134653(VarCurr)
    <=> ( v134654(VarCurr)
        | v134588(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134654(VarCurr)
    <=> v134588(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17468,axiom,
    ! [VarCurr: state_type] :
      ( v134648(VarCurr)
    <=> ( v134649(VarCurr)
        & v134651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17467,axiom,
    ! [VarCurr: state_type] :
      ( v134651(VarCurr)
    <=> ( v134642(VarCurr)
        | v134645(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6017,axiom,
    ! [VarCurr: state_type] :
      ( v134649(VarCurr)
    <=> ( v134650(VarCurr)
        | v134588(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134650(VarCurr)
    <=> v134642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17466,axiom,
    ! [VarCurr: state_type] :
      ( v134637(VarCurr)
    <=> ( v134638(VarCurr)
        & v134646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17465,axiom,
    ! [VarCurr: state_type] :
      ( v134646(VarCurr)
    <=> ( v134640(VarCurr)
        | v134647(VarCurr) ) ) ).

tff(writeUnaryOperator_9797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134647(VarCurr)
    <=> v134588(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6016,axiom,
    ! [VarCurr: state_type] :
      ( v134638(VarCurr)
    <=> ( v134639(VarCurr)
        | v134588(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134639(VarCurr)
    <=> v134640(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6015,axiom,
    ! [VarCurr: state_type] :
      ( v134640(VarCurr)
    <=> ( v134588(VarCurr,2)
        | v134641(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17464,axiom,
    ! [VarCurr: state_type] :
      ( v134641(VarCurr)
    <=> ( v134642(VarCurr)
        & v134645(VarCurr) ) ) ).

tff(writeUnaryOperator_9795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134645(VarCurr)
    <=> v134588(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6014,axiom,
    ! [VarCurr: state_type] :
      ( v134642(VarCurr)
    <=> ( v134588(VarCurr,1)
        | v134643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17463,axiom,
    ! [VarCurr: state_type] :
      ( v134643(VarCurr)
    <=> ( v134588(VarCurr,0)
        & v134644(VarCurr) ) ) ).

tff(writeUnaryOperator_9794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134644(VarCurr)
    <=> v134588(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1747,axiom,
    ! [VarCurr: state_type] :
      ( v134633(VarCurr)
    <=> ( ( v134588(VarCurr,3)
        <=> $false )
        & ( v134588(VarCurr,2)
        <=> $false )
        & ( v134588(VarCurr,1)
        <=> $false )
        & ( v134588(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76318,axiom,
    ! [VarCurr: state_type] :
      ( v134613(VarCurr,0)
    <=> v134629(VarCurr) ) ).

tff(addAssignment_76317,axiom,
    ! [VarCurr: state_type] :
      ( v134613(VarCurr,1)
    <=> v134627(VarCurr) ) ).

tff(addAssignment_76316,axiom,
    ! [VarCurr: state_type] :
      ( v134613(VarCurr,2)
    <=> v134622(VarCurr) ) ).

tff(addAssignment_76315,axiom,
    ! [VarCurr: state_type] :
      ( v134613(VarCurr,3)
    <=> v134615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17462,axiom,
    ! [VarCurr: state_type] :
      ( v134627(VarCurr)
    <=> ( v134628(VarCurr)
        & v134631(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6013,axiom,
    ! [VarCurr: state_type] :
      ( v134631(VarCurr)
    <=> ( v134610(VarCurr,0)
        | v134610(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17461,axiom,
    ! [VarCurr: state_type] :
      ( v134628(VarCurr)
    <=> ( v134629(VarCurr)
        | v134630(VarCurr) ) ) ).

tff(writeUnaryOperator_9793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134630(VarCurr)
    <=> v134610(VarCurr,1) ) ).

tff(writeUnaryOperator_9792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134629(VarCurr)
    <=> v134610(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17460,axiom,
    ! [VarCurr: state_type] :
      ( v134622(VarCurr)
    <=> ( v134623(VarCurr)
        & v134626(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6012,axiom,
    ! [VarCurr: state_type] :
      ( v134626(VarCurr)
    <=> ( v134619(VarCurr)
        | v134610(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17459,axiom,
    ! [VarCurr: state_type] :
      ( v134623(VarCurr)
    <=> ( v134624(VarCurr)
        | v134625(VarCurr) ) ) ).

tff(writeUnaryOperator_9791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134625(VarCurr)
    <=> v134610(VarCurr,2) ) ).

tff(writeUnaryOperator_9790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134624(VarCurr)
    <=> v134619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17458,axiom,
    ! [VarCurr: state_type] :
      ( v134615(VarCurr)
    <=> ( v134616(VarCurr)
        & v134621(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6011,axiom,
    ! [VarCurr: state_type] :
      ( v134621(VarCurr)
    <=> ( v134618(VarCurr)
        | v134610(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17457,axiom,
    ! [VarCurr: state_type] :
      ( v134616(VarCurr)
    <=> ( v134617(VarCurr)
        | v134620(VarCurr) ) ) ).

tff(writeUnaryOperator_9789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134620(VarCurr)
    <=> v134610(VarCurr,3) ) ).

tff(writeUnaryOperator_9788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134617(VarCurr)
    <=> v134618(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6010,axiom,
    ! [VarCurr: state_type] :
      ( v134618(VarCurr)
    <=> ( v134619(VarCurr)
        & v134610(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6009,axiom,
    ! [VarCurr: state_type] :
      ( v134619(VarCurr)
    <=> ( v134610(VarCurr,0)
        & v134610(VarCurr,1) ) ) ).

tff(addAssignment_76314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134610(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76313,axiom,
    ! [VarCurr: state_type] :
      ( v134598(VarCurr)
    <=> v134600(VarCurr) ) ).

tff(addAssignment_76312,axiom,
    ! [VarCurr: state_type] :
      ( v134600(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_76311,axiom,
    ! [VarCurr: state_type] :
      ( v134594(VarCurr)
    <=> v134596(VarCurr) ) ).

tff(addAssignment_76310,axiom,
    ! [VarCurr: state_type] :
      ( v134596(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_76309,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,4)
    <=> v134523(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1746,axiom,
    ! [VarCurr: state_type] :
      ( v134523(VarCurr)
    <=> ( v134525(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76308,axiom,
    ! [VarCurr: state_type] :
      ( v134525(VarCurr)
    <=> v134527(VarCurr) ) ).

tff(addAssignment_76307,axiom,
    ! [VarCurr: state_type] :
      ( v134527(VarCurr)
    <=> v134529(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134568(VarNext)
       => ( v134529(VarNext)
        <=> v134529(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1872,axiom,
    ! [VarNext: state_type] :
      ( v134568(VarNext)
     => ( v134529(VarNext)
      <=> v134578(VarNext) ) ) ).

tff(addAssignment_76306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134578(VarNext)
      <=> v134576(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134579(VarCurr)
     => ( v134576(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1370,axiom,
    ! [VarCurr: state_type] :
      ( v134579(VarCurr)
     => ( v134576(VarCurr)
      <=> v134539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17456,axiom,
    ! [VarCurr: state_type] :
      ( v134579(VarCurr)
    <=> ( v134580(VarCurr)
        & v134581(VarCurr) ) ) ).

tff(writeUnaryOperator_9787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134581(VarCurr)
    <=> v134535(VarCurr) ) ).

tff(writeUnaryOperator_9786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134580(VarCurr)
    <=> v134531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134568(VarNext)
      <=> v134569(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134569(VarNext)
      <=> ( v134570(VarNext)
          & v134563(VarNext) ) ) ) ).

tff(writeUnaryOperator_9785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134570(VarNext)
      <=> v134572(VarNext) ) ) ).

tff(addAssignment_76305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134572(VarNext)
      <=> v134563(VarCurr) ) ) ).

tff(addAssignment_76304,axiom,
    ! [VarCurr: state_type] :
      ( v134563(VarCurr)
    <=> v134565(VarCurr) ) ).

tff(addAssignment_76303,axiom,
    ! [VarCurr: state_type] :
      ( v134565(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_76302,axiom,
    ! [VarCurr: state_type] :
      ( v134539(VarCurr)
    <=> v134541(VarCurr) ) ).

tff(addAssignment_76301,axiom,
    ! [VarCurr: state_type] :
      ( v134541(VarCurr)
    <=> v134543(VarCurr) ) ).

tff(addAssignment_76300,axiom,
    ! [VarCurr: state_type] :
      ( v134543(VarCurr)
    <=> v134545(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134557(VarCurr)
     => ( v134545(VarCurr)
      <=> v134558(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1369,axiom,
    ! [VarCurr: state_type] :
      ( v134557(VarCurr)
     => ( v134545(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134559(VarCurr)
     => ( v134558(VarCurr)
      <=> v134560(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1368,axiom,
    ! [VarCurr: state_type] :
      ( v134559(VarCurr)
     => ( v134558(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134560(VarCurr)
    <=> v134525(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1745,axiom,
    ! [VarCurr: state_type] :
      ( v134559(VarCurr)
    <=> ( v134525(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17453,axiom,
    ! [VarCurr: state_type] :
      ( v134557(VarCurr)
    <=> ( v134547(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(addAssignment_76299,axiom,
    ! [VarCurr: state_type] :
      ( v134547(VarCurr)
    <=> v106080(VarCurr,2) ) ).

tff(addAssignment_76298,axiom,
    ! [VarCurr: state_type] :
      ( v106080(VarCurr,2)
    <=> v106082(VarCurr,2) ) ).

tff(addAssignment_76297,axiom,
    ! [VarNext: state_type] :
      ( v106082(VarNext,2)
    <=> v134549(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134550(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134549(VarNext,B)
            <=> v106082(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1871,axiom,
    ! [VarNext: state_type] :
      ( v134550(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134549(VarNext,B)
          <=> v106122(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134550(VarNext)
      <=> v134551(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134551(VarNext)
      <=> ( v134553(VarNext)
          & v106107(VarNext) ) ) ) ).

tff(writeUnaryOperator_9783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134553(VarNext)
      <=> v106116(VarNext) ) ) ).

tff(addAssignment_76296,axiom,
    ! [VarCurr: state_type] :
      ( v106092(VarCurr,2)
    <=> v106094(VarCurr,2) ) ).

tff(addAssignment_76295,axiom,
    ! [VarCurr: state_type] :
      ( v106094(VarCurr,2)
    <=> v106096(VarCurr,2) ) ).

tff(addAssignment_76294,axiom,
    ! [VarCurr: state_type] :
      ( v106096(VarCurr,2)
    <=> v106104(VarCurr,2) ) ).

tff(addAssignment_76293,axiom,
    ! [VarCurr: state_type] :
      ( v134535(VarCurr)
    <=> v134537(VarCurr) ) ).

tff(addAssignment_76292,axiom,
    ! [VarCurr: state_type] :
      ( v134537(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_76291,axiom,
    ! [VarCurr: state_type] :
      ( v134531(VarCurr)
    <=> v134533(VarCurr) ) ).

tff(addAssignment_76290,axiom,
    ! [VarCurr: state_type] :
      ( v134533(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_76289,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,3)
    <=> v134429(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1744,axiom,
    ! [VarCurr: state_type] :
      ( v134429(VarCurr)
    <=> ( ( v134431(VarCurr,3)
        <=> $false )
        & ( v134431(VarCurr,2)
        <=> $false )
        & ( v134431(VarCurr,1)
        <=> $false )
        & ( v134431(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134431(VarCurr,B)
      <=> v134433(VarCurr,B) ) ) ).

tff(addAssignment_76287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134433(VarCurr,B)
      <=> v134435(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134505(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134435(VarNext,B)
            <=> v134435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1870,axiom,
    ! [VarNext: state_type] :
      ( v134505(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134435(VarNext,B)
          <=> v134515(VarNext,B) ) ) ) ).

tff(addAssignment_76286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134515(VarNext,B)
          <=> v134513(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134513(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1367,axiom,
    ! [VarCurr: state_type] :
      ( v134516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134513(VarCurr,B)
          <=> v134445(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17450,axiom,
    ! [VarCurr: state_type] :
      ( v134516(VarCurr)
    <=> ( v134517(VarCurr)
        & v134518(VarCurr) ) ) ).

tff(writeUnaryOperator_9782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134518(VarCurr)
    <=> v134441(VarCurr) ) ).

tff(writeUnaryOperator_9781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134517(VarCurr)
    <=> v134437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134505(VarNext)
      <=> v134506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134506(VarNext)
      <=> ( v134507(VarNext)
          & v134500(VarNext) ) ) ) ).

tff(writeUnaryOperator_9780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134507(VarNext)
      <=> v134509(VarNext) ) ) ).

tff(addAssignment_76285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134509(VarNext)
      <=> v134500(VarCurr) ) ) ).

tff(addAssignment_76284,axiom,
    ! [VarCurr: state_type] :
      ( v134500(VarCurr)
    <=> v134502(VarCurr) ) ).

tff(addAssignment_76283,axiom,
    ! [VarCurr: state_type] :
      ( v134502(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_76282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134445(VarCurr,B)
      <=> v134447(VarCurr,B) ) ) ).

tff(addAssignment_76281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134447(VarCurr,B)
      <=> v134449(VarCurr,B) ) ) ).

tff(addAssignment_76280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134449(VarCurr,B)
      <=> v134451(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105397(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134451(VarCurr,B)
          <=> v134455(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1366,axiom,
    ! [VarCurr: state_type] :
      ( v105397(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134451(VarCurr,B)
          <=> v134453(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134455(VarCurr,B)
          <=> v134475(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1365,axiom,
    ! [VarCurr: state_type] :
      ( v105404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134455(VarCurr,B)
          <=> v134456(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134476(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134475(VarCurr,B)
          <=> v134477(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1364,axiom,
    ! [VarCurr: state_type] :
      ( v134476(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134475(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134477(VarCurr,B)
          <=> v134431(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1363,axiom,
    ! [VarCurr: state_type] :
      ( v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134477(VarCurr,B)
          <=> v134478(VarCurr,B) ) ) ) ).

tff(addAssignment_76279,axiom,
    ! [VarCurr: state_type] :
      ( v134478(VarCurr,0)
    <=> v134497(VarCurr) ) ).

tff(addAssignment_76278,axiom,
    ! [VarCurr: state_type] :
      ( v134478(VarCurr,1)
    <=> v134495(VarCurr) ) ).

tff(addAssignment_76277,axiom,
    ! [VarCurr: state_type] :
      ( v134478(VarCurr,2)
    <=> v134491(VarCurr) ) ).

tff(addAssignment_76276,axiom,
    ! [VarCurr: state_type] :
      ( v134478(VarCurr,3)
    <=> v134480(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17447,axiom,
    ! [VarCurr: state_type] :
      ( v134495(VarCurr)
    <=> ( v134496(VarCurr)
        & v134498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17446,axiom,
    ! [VarCurr: state_type] :
      ( v134498(VarCurr)
    <=> ( v134431(VarCurr,0)
        | v134487(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6008,axiom,
    ! [VarCurr: state_type] :
      ( v134496(VarCurr)
    <=> ( v134497(VarCurr)
        | v134431(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134497(VarCurr)
    <=> v134431(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17445,axiom,
    ! [VarCurr: state_type] :
      ( v134491(VarCurr)
    <=> ( v134492(VarCurr)
        & v134494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17444,axiom,
    ! [VarCurr: state_type] :
      ( v134494(VarCurr)
    <=> ( v134485(VarCurr)
        | v134488(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6007,axiom,
    ! [VarCurr: state_type] :
      ( v134492(VarCurr)
    <=> ( v134493(VarCurr)
        | v134431(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134493(VarCurr)
    <=> v134485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17443,axiom,
    ! [VarCurr: state_type] :
      ( v134480(VarCurr)
    <=> ( v134481(VarCurr)
        & v134489(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17442,axiom,
    ! [VarCurr: state_type] :
      ( v134489(VarCurr)
    <=> ( v134483(VarCurr)
        | v134490(VarCurr) ) ) ).

tff(writeUnaryOperator_9777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134490(VarCurr)
    <=> v134431(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_6006,axiom,
    ! [VarCurr: state_type] :
      ( v134481(VarCurr)
    <=> ( v134482(VarCurr)
        | v134431(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134482(VarCurr)
    <=> v134483(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6005,axiom,
    ! [VarCurr: state_type] :
      ( v134483(VarCurr)
    <=> ( v134431(VarCurr,2)
        | v134484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17441,axiom,
    ! [VarCurr: state_type] :
      ( v134484(VarCurr)
    <=> ( v134485(VarCurr)
        & v134488(VarCurr) ) ) ).

tff(writeUnaryOperator_9775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134488(VarCurr)
    <=> v134431(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_6004,axiom,
    ! [VarCurr: state_type] :
      ( v134485(VarCurr)
    <=> ( v134431(VarCurr,1)
        | v134486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17440,axiom,
    ! [VarCurr: state_type] :
      ( v134486(VarCurr)
    <=> ( v134431(VarCurr,0)
        & v134487(VarCurr) ) ) ).

tff(writeUnaryOperator_9774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134487(VarCurr)
    <=> v134431(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1743,axiom,
    ! [VarCurr: state_type] :
      ( v134476(VarCurr)
    <=> ( ( v134431(VarCurr,3)
        <=> $false )
        & ( v134431(VarCurr,2)
        <=> $false )
        & ( v134431(VarCurr,1)
        <=> $false )
        & ( v134431(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76275,axiom,
    ! [VarCurr: state_type] :
      ( v134456(VarCurr,0)
    <=> v134472(VarCurr) ) ).

tff(addAssignment_76274,axiom,
    ! [VarCurr: state_type] :
      ( v134456(VarCurr,1)
    <=> v134470(VarCurr) ) ).

tff(addAssignment_76273,axiom,
    ! [VarCurr: state_type] :
      ( v134456(VarCurr,2)
    <=> v134465(VarCurr) ) ).

tff(addAssignment_76272,axiom,
    ! [VarCurr: state_type] :
      ( v134456(VarCurr,3)
    <=> v134458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17439,axiom,
    ! [VarCurr: state_type] :
      ( v134470(VarCurr)
    <=> ( v134471(VarCurr)
        & v134474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6003,axiom,
    ! [VarCurr: state_type] :
      ( v134474(VarCurr)
    <=> ( v134453(VarCurr,0)
        | v134453(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17438,axiom,
    ! [VarCurr: state_type] :
      ( v134471(VarCurr)
    <=> ( v134472(VarCurr)
        | v134473(VarCurr) ) ) ).

tff(writeUnaryOperator_9773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134473(VarCurr)
    <=> v134453(VarCurr,1) ) ).

tff(writeUnaryOperator_9772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134472(VarCurr)
    <=> v134453(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17437,axiom,
    ! [VarCurr: state_type] :
      ( v134465(VarCurr)
    <=> ( v134466(VarCurr)
        & v134469(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6002,axiom,
    ! [VarCurr: state_type] :
      ( v134469(VarCurr)
    <=> ( v134462(VarCurr)
        | v134453(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17436,axiom,
    ! [VarCurr: state_type] :
      ( v134466(VarCurr)
    <=> ( v134467(VarCurr)
        | v134468(VarCurr) ) ) ).

tff(writeUnaryOperator_9771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134468(VarCurr)
    <=> v134453(VarCurr,2) ) ).

tff(writeUnaryOperator_9770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134467(VarCurr)
    <=> v134462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17435,axiom,
    ! [VarCurr: state_type] :
      ( v134458(VarCurr)
    <=> ( v134459(VarCurr)
        & v134464(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6001,axiom,
    ! [VarCurr: state_type] :
      ( v134464(VarCurr)
    <=> ( v134461(VarCurr)
        | v134453(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17434,axiom,
    ! [VarCurr: state_type] :
      ( v134459(VarCurr)
    <=> ( v134460(VarCurr)
        | v134463(VarCurr) ) ) ).

tff(writeUnaryOperator_9769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134463(VarCurr)
    <=> v134453(VarCurr,3) ) ).

tff(writeUnaryOperator_9768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134460(VarCurr)
    <=> v134461(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_6000,axiom,
    ! [VarCurr: state_type] :
      ( v134461(VarCurr)
    <=> ( v134462(VarCurr)
        & v134453(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5999,axiom,
    ! [VarCurr: state_type] :
      ( v134462(VarCurr)
    <=> ( v134453(VarCurr,0)
        & v134453(VarCurr,1) ) ) ).

tff(addAssignment_76271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134453(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76270,axiom,
    ! [VarCurr: state_type] :
      ( v134441(VarCurr)
    <=> v134443(VarCurr) ) ).

tff(addAssignment_76269,axiom,
    ! [VarCurr: state_type] :
      ( v134443(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_76268,axiom,
    ! [VarCurr: state_type] :
      ( v134437(VarCurr)
    <=> v134439(VarCurr) ) ).

tff(addAssignment_76267,axiom,
    ! [VarCurr: state_type] :
      ( v134439(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_76266,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,3)
    <=> v134366(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1742,axiom,
    ! [VarCurr: state_type] :
      ( v134366(VarCurr)
    <=> ( v134368(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76265,axiom,
    ! [VarCurr: state_type] :
      ( v134368(VarCurr)
    <=> v134370(VarCurr) ) ).

tff(addAssignment_76264,axiom,
    ! [VarCurr: state_type] :
      ( v134370(VarCurr)
    <=> v134372(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134411(VarNext)
       => ( v134372(VarNext)
        <=> v134372(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1869,axiom,
    ! [VarNext: state_type] :
      ( v134411(VarNext)
     => ( v134372(VarNext)
      <=> v134421(VarNext) ) ) ).

tff(addAssignment_76263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134421(VarNext)
      <=> v134419(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134422(VarCurr)
     => ( v134419(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1362,axiom,
    ! [VarCurr: state_type] :
      ( v134422(VarCurr)
     => ( v134419(VarCurr)
      <=> v134382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17433,axiom,
    ! [VarCurr: state_type] :
      ( v134422(VarCurr)
    <=> ( v134423(VarCurr)
        & v134424(VarCurr) ) ) ).

tff(writeUnaryOperator_9767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134424(VarCurr)
    <=> v134378(VarCurr) ) ).

tff(writeUnaryOperator_9766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134423(VarCurr)
    <=> v134374(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134411(VarNext)
      <=> v134412(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134412(VarNext)
      <=> ( v134413(VarNext)
          & v134406(VarNext) ) ) ) ).

tff(writeUnaryOperator_9765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134413(VarNext)
      <=> v134415(VarNext) ) ) ).

tff(addAssignment_76262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134415(VarNext)
      <=> v134406(VarCurr) ) ) ).

tff(addAssignment_76261,axiom,
    ! [VarCurr: state_type] :
      ( v134406(VarCurr)
    <=> v134408(VarCurr) ) ).

tff(addAssignment_76260,axiom,
    ! [VarCurr: state_type] :
      ( v134408(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_76259,axiom,
    ! [VarCurr: state_type] :
      ( v134382(VarCurr)
    <=> v134384(VarCurr) ) ).

tff(addAssignment_76258,axiom,
    ! [VarCurr: state_type] :
      ( v134384(VarCurr)
    <=> v134386(VarCurr) ) ).

tff(addAssignment_76257,axiom,
    ! [VarCurr: state_type] :
      ( v134386(VarCurr)
    <=> v134388(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134400(VarCurr)
     => ( v134388(VarCurr)
      <=> v134401(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1361,axiom,
    ! [VarCurr: state_type] :
      ( v134400(VarCurr)
     => ( v134388(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134402(VarCurr)
     => ( v134401(VarCurr)
      <=> v134403(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1360,axiom,
    ! [VarCurr: state_type] :
      ( v134402(VarCurr)
     => ( v134401(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134403(VarCurr)
    <=> v134368(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1741,axiom,
    ! [VarCurr: state_type] :
      ( v134402(VarCurr)
    <=> ( v134368(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17430,axiom,
    ! [VarCurr: state_type] :
      ( v134400(VarCurr)
    <=> ( v134390(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(addAssignment_76256,axiom,
    ! [VarCurr: state_type] :
      ( v134390(VarCurr)
    <=> v105379(VarCurr,2) ) ).

tff(addAssignment_76255,axiom,
    ! [VarCurr: state_type] :
      ( v105379(VarCurr,2)
    <=> v105381(VarCurr,2) ) ).

tff(addAssignment_76254,axiom,
    ! [VarNext: state_type] :
      ( v105381(VarNext,2)
    <=> v134392(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134393(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134392(VarNext,B)
            <=> v105381(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1868,axiom,
    ! [VarNext: state_type] :
      ( v134393(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134392(VarNext,B)
          <=> v105421(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134393(VarNext)
      <=> v134394(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134394(VarNext)
      <=> ( v134396(VarNext)
          & v105406(VarNext) ) ) ) ).

tff(writeUnaryOperator_9763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134396(VarNext)
      <=> v105415(VarNext) ) ) ).

tff(addAssignment_76253,axiom,
    ! [VarCurr: state_type] :
      ( v105391(VarCurr,2)
    <=> v105393(VarCurr,2) ) ).

tff(addAssignment_76252,axiom,
    ! [VarCurr: state_type] :
      ( v105393(VarCurr,2)
    <=> v105395(VarCurr,2) ) ).

tff(addAssignment_76251,axiom,
    ! [VarCurr: state_type] :
      ( v105395(VarCurr,2)
    <=> v105403(VarCurr,2) ) ).

tff(addAssignment_76250,axiom,
    ! [VarCurr: state_type] :
      ( v134378(VarCurr)
    <=> v134380(VarCurr) ) ).

tff(addAssignment_76249,axiom,
    ! [VarCurr: state_type] :
      ( v134380(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_76248,axiom,
    ! [VarCurr: state_type] :
      ( v134374(VarCurr)
    <=> v134376(VarCurr) ) ).

tff(addAssignment_76247,axiom,
    ! [VarCurr: state_type] :
      ( v134376(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_76246,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,2)
    <=> v134272(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1740,axiom,
    ! [VarCurr: state_type] :
      ( v134272(VarCurr)
    <=> ( ( v134274(VarCurr,3)
        <=> $false )
        & ( v134274(VarCurr,2)
        <=> $false )
        & ( v134274(VarCurr,1)
        <=> $false )
        & ( v134274(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134274(VarCurr,B)
      <=> v134276(VarCurr,B) ) ) ).

tff(addAssignment_76244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134276(VarCurr,B)
      <=> v134278(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134348(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134278(VarNext,B)
            <=> v134278(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1867,axiom,
    ! [VarNext: state_type] :
      ( v134348(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134278(VarNext,B)
          <=> v134358(VarNext,B) ) ) ) ).

tff(addAssignment_76243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134358(VarNext,B)
          <=> v134356(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134356(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1359,axiom,
    ! [VarCurr: state_type] :
      ( v134359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134356(VarCurr,B)
          <=> v134288(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17427,axiom,
    ! [VarCurr: state_type] :
      ( v134359(VarCurr)
    <=> ( v134360(VarCurr)
        & v134361(VarCurr) ) ) ).

tff(writeUnaryOperator_9762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134361(VarCurr)
    <=> v134284(VarCurr) ) ).

tff(writeUnaryOperator_9761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134360(VarCurr)
    <=> v134280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134348(VarNext)
      <=> v134349(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134349(VarNext)
      <=> ( v134350(VarNext)
          & v134343(VarNext) ) ) ) ).

tff(writeUnaryOperator_9760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134350(VarNext)
      <=> v134352(VarNext) ) ) ).

tff(addAssignment_76242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134352(VarNext)
      <=> v134343(VarCurr) ) ) ).

tff(addAssignment_76241,axiom,
    ! [VarCurr: state_type] :
      ( v134343(VarCurr)
    <=> v134345(VarCurr) ) ).

tff(addAssignment_76240,axiom,
    ! [VarCurr: state_type] :
      ( v134345(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_76239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134288(VarCurr,B)
      <=> v134290(VarCurr,B) ) ) ).

tff(addAssignment_76238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134290(VarCurr,B)
      <=> v134292(VarCurr,B) ) ) ).

tff(addAssignment_76237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134292(VarCurr,B)
      <=> v134294(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104696(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134294(VarCurr,B)
          <=> v134298(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1358,axiom,
    ! [VarCurr: state_type] :
      ( v104696(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134294(VarCurr,B)
          <=> v134296(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134298(VarCurr,B)
          <=> v134318(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1357,axiom,
    ! [VarCurr: state_type] :
      ( v104703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134298(VarCurr,B)
          <=> v134299(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134319(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134318(VarCurr,B)
          <=> v134320(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1356,axiom,
    ! [VarCurr: state_type] :
      ( v134319(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134318(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134320(VarCurr,B)
          <=> v134274(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1355,axiom,
    ! [VarCurr: state_type] :
      ( v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134320(VarCurr,B)
          <=> v134321(VarCurr,B) ) ) ) ).

tff(addAssignment_76236,axiom,
    ! [VarCurr: state_type] :
      ( v134321(VarCurr,0)
    <=> v134340(VarCurr) ) ).

tff(addAssignment_76235,axiom,
    ! [VarCurr: state_type] :
      ( v134321(VarCurr,1)
    <=> v134338(VarCurr) ) ).

tff(addAssignment_76234,axiom,
    ! [VarCurr: state_type] :
      ( v134321(VarCurr,2)
    <=> v134334(VarCurr) ) ).

tff(addAssignment_76233,axiom,
    ! [VarCurr: state_type] :
      ( v134321(VarCurr,3)
    <=> v134323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17424,axiom,
    ! [VarCurr: state_type] :
      ( v134338(VarCurr)
    <=> ( v134339(VarCurr)
        & v134341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17423,axiom,
    ! [VarCurr: state_type] :
      ( v134341(VarCurr)
    <=> ( v134274(VarCurr,0)
        | v134330(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5998,axiom,
    ! [VarCurr: state_type] :
      ( v134339(VarCurr)
    <=> ( v134340(VarCurr)
        | v134274(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134340(VarCurr)
    <=> v134274(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17422,axiom,
    ! [VarCurr: state_type] :
      ( v134334(VarCurr)
    <=> ( v134335(VarCurr)
        & v134337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17421,axiom,
    ! [VarCurr: state_type] :
      ( v134337(VarCurr)
    <=> ( v134328(VarCurr)
        | v134331(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5997,axiom,
    ! [VarCurr: state_type] :
      ( v134335(VarCurr)
    <=> ( v134336(VarCurr)
        | v134274(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134336(VarCurr)
    <=> v134328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17420,axiom,
    ! [VarCurr: state_type] :
      ( v134323(VarCurr)
    <=> ( v134324(VarCurr)
        & v134332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17419,axiom,
    ! [VarCurr: state_type] :
      ( v134332(VarCurr)
    <=> ( v134326(VarCurr)
        | v134333(VarCurr) ) ) ).

tff(writeUnaryOperator_9757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134333(VarCurr)
    <=> v134274(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5996,axiom,
    ! [VarCurr: state_type] :
      ( v134324(VarCurr)
    <=> ( v134325(VarCurr)
        | v134274(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134325(VarCurr)
    <=> v134326(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5995,axiom,
    ! [VarCurr: state_type] :
      ( v134326(VarCurr)
    <=> ( v134274(VarCurr,2)
        | v134327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17418,axiom,
    ! [VarCurr: state_type] :
      ( v134327(VarCurr)
    <=> ( v134328(VarCurr)
        & v134331(VarCurr) ) ) ).

tff(writeUnaryOperator_9755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134331(VarCurr)
    <=> v134274(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5994,axiom,
    ! [VarCurr: state_type] :
      ( v134328(VarCurr)
    <=> ( v134274(VarCurr,1)
        | v134329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17417,axiom,
    ! [VarCurr: state_type] :
      ( v134329(VarCurr)
    <=> ( v134274(VarCurr,0)
        & v134330(VarCurr) ) ) ).

tff(writeUnaryOperator_9754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134330(VarCurr)
    <=> v134274(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1739,axiom,
    ! [VarCurr: state_type] :
      ( v134319(VarCurr)
    <=> ( ( v134274(VarCurr,3)
        <=> $false )
        & ( v134274(VarCurr,2)
        <=> $false )
        & ( v134274(VarCurr,1)
        <=> $false )
        & ( v134274(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76232,axiom,
    ! [VarCurr: state_type] :
      ( v134299(VarCurr,0)
    <=> v134315(VarCurr) ) ).

tff(addAssignment_76231,axiom,
    ! [VarCurr: state_type] :
      ( v134299(VarCurr,1)
    <=> v134313(VarCurr) ) ).

tff(addAssignment_76230,axiom,
    ! [VarCurr: state_type] :
      ( v134299(VarCurr,2)
    <=> v134308(VarCurr) ) ).

tff(addAssignment_76229,axiom,
    ! [VarCurr: state_type] :
      ( v134299(VarCurr,3)
    <=> v134301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17416,axiom,
    ! [VarCurr: state_type] :
      ( v134313(VarCurr)
    <=> ( v134314(VarCurr)
        & v134317(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5993,axiom,
    ! [VarCurr: state_type] :
      ( v134317(VarCurr)
    <=> ( v134296(VarCurr,0)
        | v134296(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17415,axiom,
    ! [VarCurr: state_type] :
      ( v134314(VarCurr)
    <=> ( v134315(VarCurr)
        | v134316(VarCurr) ) ) ).

tff(writeUnaryOperator_9753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134316(VarCurr)
    <=> v134296(VarCurr,1) ) ).

tff(writeUnaryOperator_9752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134315(VarCurr)
    <=> v134296(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17414,axiom,
    ! [VarCurr: state_type] :
      ( v134308(VarCurr)
    <=> ( v134309(VarCurr)
        & v134312(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5992,axiom,
    ! [VarCurr: state_type] :
      ( v134312(VarCurr)
    <=> ( v134305(VarCurr)
        | v134296(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17413,axiom,
    ! [VarCurr: state_type] :
      ( v134309(VarCurr)
    <=> ( v134310(VarCurr)
        | v134311(VarCurr) ) ) ).

tff(writeUnaryOperator_9751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134311(VarCurr)
    <=> v134296(VarCurr,2) ) ).

tff(writeUnaryOperator_9750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134310(VarCurr)
    <=> v134305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17412,axiom,
    ! [VarCurr: state_type] :
      ( v134301(VarCurr)
    <=> ( v134302(VarCurr)
        & v134307(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5991,axiom,
    ! [VarCurr: state_type] :
      ( v134307(VarCurr)
    <=> ( v134304(VarCurr)
        | v134296(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17411,axiom,
    ! [VarCurr: state_type] :
      ( v134302(VarCurr)
    <=> ( v134303(VarCurr)
        | v134306(VarCurr) ) ) ).

tff(writeUnaryOperator_9749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134306(VarCurr)
    <=> v134296(VarCurr,3) ) ).

tff(writeUnaryOperator_9748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134303(VarCurr)
    <=> v134304(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5990,axiom,
    ! [VarCurr: state_type] :
      ( v134304(VarCurr)
    <=> ( v134305(VarCurr)
        & v134296(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5989,axiom,
    ! [VarCurr: state_type] :
      ( v134305(VarCurr)
    <=> ( v134296(VarCurr,0)
        & v134296(VarCurr,1) ) ) ).

tff(addAssignment_76228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134296(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76227,axiom,
    ! [VarCurr: state_type] :
      ( v134284(VarCurr)
    <=> v134286(VarCurr) ) ).

tff(addAssignment_76226,axiom,
    ! [VarCurr: state_type] :
      ( v134286(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_76225,axiom,
    ! [VarCurr: state_type] :
      ( v134280(VarCurr)
    <=> v134282(VarCurr) ) ).

tff(addAssignment_76224,axiom,
    ! [VarCurr: state_type] :
      ( v134282(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_76223,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,2)
    <=> v134209(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1738,axiom,
    ! [VarCurr: state_type] :
      ( v134209(VarCurr)
    <=> ( v134211(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76222,axiom,
    ! [VarCurr: state_type] :
      ( v134211(VarCurr)
    <=> v134213(VarCurr) ) ).

tff(addAssignment_76221,axiom,
    ! [VarCurr: state_type] :
      ( v134213(VarCurr)
    <=> v134215(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134254(VarNext)
       => ( v134215(VarNext)
        <=> v134215(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1866,axiom,
    ! [VarNext: state_type] :
      ( v134254(VarNext)
     => ( v134215(VarNext)
      <=> v134264(VarNext) ) ) ).

tff(addAssignment_76220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134264(VarNext)
      <=> v134262(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134265(VarCurr)
     => ( v134262(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1354,axiom,
    ! [VarCurr: state_type] :
      ( v134265(VarCurr)
     => ( v134262(VarCurr)
      <=> v134225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17410,axiom,
    ! [VarCurr: state_type] :
      ( v134265(VarCurr)
    <=> ( v134266(VarCurr)
        & v134267(VarCurr) ) ) ).

tff(writeUnaryOperator_9747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134267(VarCurr)
    <=> v134221(VarCurr) ) ).

tff(writeUnaryOperator_9746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134266(VarCurr)
    <=> v134217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134254(VarNext)
      <=> v134255(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134255(VarNext)
      <=> ( v134256(VarNext)
          & v134249(VarNext) ) ) ) ).

tff(writeUnaryOperator_9745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134256(VarNext)
      <=> v134258(VarNext) ) ) ).

tff(addAssignment_76219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134258(VarNext)
      <=> v134249(VarCurr) ) ) ).

tff(addAssignment_76218,axiom,
    ! [VarCurr: state_type] :
      ( v134249(VarCurr)
    <=> v134251(VarCurr) ) ).

tff(addAssignment_76217,axiom,
    ! [VarCurr: state_type] :
      ( v134251(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_76216,axiom,
    ! [VarCurr: state_type] :
      ( v134225(VarCurr)
    <=> v134227(VarCurr) ) ).

tff(addAssignment_76215,axiom,
    ! [VarCurr: state_type] :
      ( v134227(VarCurr)
    <=> v134229(VarCurr) ) ).

tff(addAssignment_76214,axiom,
    ! [VarCurr: state_type] :
      ( v134229(VarCurr)
    <=> v134231(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134243(VarCurr)
     => ( v134231(VarCurr)
      <=> v134244(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1353,axiom,
    ! [VarCurr: state_type] :
      ( v134243(VarCurr)
     => ( v134231(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134245(VarCurr)
     => ( v134244(VarCurr)
      <=> v134246(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1352,axiom,
    ! [VarCurr: state_type] :
      ( v134245(VarCurr)
     => ( v134244(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134246(VarCurr)
    <=> v134211(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1737,axiom,
    ! [VarCurr: state_type] :
      ( v134245(VarCurr)
    <=> ( v134211(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17407,axiom,
    ! [VarCurr: state_type] :
      ( v134243(VarCurr)
    <=> ( v134233(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(addAssignment_76213,axiom,
    ! [VarCurr: state_type] :
      ( v134233(VarCurr)
    <=> v104678(VarCurr,2) ) ).

tff(addAssignment_76212,axiom,
    ! [VarCurr: state_type] :
      ( v104678(VarCurr,2)
    <=> v104680(VarCurr,2) ) ).

tff(addAssignment_76211,axiom,
    ! [VarNext: state_type] :
      ( v104680(VarNext,2)
    <=> v134235(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134236(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134235(VarNext,B)
            <=> v104680(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1865,axiom,
    ! [VarNext: state_type] :
      ( v134236(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134235(VarNext,B)
          <=> v104720(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134236(VarNext)
      <=> v134237(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134237(VarNext)
      <=> ( v134239(VarNext)
          & v104705(VarNext) ) ) ) ).

tff(writeUnaryOperator_9743,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134239(VarNext)
      <=> v104714(VarNext) ) ) ).

tff(addAssignment_76210,axiom,
    ! [VarCurr: state_type] :
      ( v104690(VarCurr,2)
    <=> v104692(VarCurr,2) ) ).

tff(addAssignment_76209,axiom,
    ! [VarCurr: state_type] :
      ( v104692(VarCurr,2)
    <=> v104694(VarCurr,2) ) ).

tff(addAssignment_76208,axiom,
    ! [VarCurr: state_type] :
      ( v104694(VarCurr,2)
    <=> v104702(VarCurr,2) ) ).

tff(addAssignment_76207,axiom,
    ! [VarCurr: state_type] :
      ( v134221(VarCurr)
    <=> v134223(VarCurr) ) ).

tff(addAssignment_76206,axiom,
    ! [VarCurr: state_type] :
      ( v134223(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_76205,axiom,
    ! [VarCurr: state_type] :
      ( v134217(VarCurr)
    <=> v134219(VarCurr) ) ).

tff(addAssignment_76204,axiom,
    ! [VarCurr: state_type] :
      ( v134219(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_76203,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,1)
    <=> v134115(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1736,axiom,
    ! [VarCurr: state_type] :
      ( v134115(VarCurr)
    <=> ( ( v134117(VarCurr,3)
        <=> $false )
        & ( v134117(VarCurr,2)
        <=> $false )
        & ( v134117(VarCurr,1)
        <=> $false )
        & ( v134117(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134117(VarCurr,B)
      <=> v134119(VarCurr,B) ) ) ).

tff(addAssignment_76201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134119(VarCurr,B)
      <=> v134121(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134191(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v134121(VarNext,B)
            <=> v134121(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1864,axiom,
    ! [VarNext: state_type] :
      ( v134191(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134121(VarNext,B)
          <=> v134201(VarNext,B) ) ) ) ).

tff(addAssignment_76200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134201(VarNext,B)
          <=> v134199(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134199(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1351,axiom,
    ! [VarCurr: state_type] :
      ( v134202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134199(VarCurr,B)
          <=> v134131(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17404,axiom,
    ! [VarCurr: state_type] :
      ( v134202(VarCurr)
    <=> ( v134203(VarCurr)
        & v134204(VarCurr) ) ) ).

tff(writeUnaryOperator_9742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134204(VarCurr)
    <=> v134127(VarCurr) ) ).

tff(writeUnaryOperator_9741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134203(VarCurr)
    <=> v134123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134191(VarNext)
      <=> v134192(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134192(VarNext)
      <=> ( v134193(VarNext)
          & v134186(VarNext) ) ) ) ).

tff(writeUnaryOperator_9740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134193(VarNext)
      <=> v134195(VarNext) ) ) ).

tff(addAssignment_76199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134195(VarNext)
      <=> v134186(VarCurr) ) ) ).

tff(addAssignment_76198,axiom,
    ! [VarCurr: state_type] :
      ( v134186(VarCurr)
    <=> v134188(VarCurr) ) ).

tff(addAssignment_76197,axiom,
    ! [VarCurr: state_type] :
      ( v134188(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_76196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134131(VarCurr,B)
      <=> v134133(VarCurr,B) ) ) ).

tff(addAssignment_76195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134133(VarCurr,B)
      <=> v134135(VarCurr,B) ) ) ).

tff(addAssignment_76194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134135(VarCurr,B)
      <=> v134137(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134137(VarCurr,B)
          <=> v134141(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1350,axiom,
    ! [VarCurr: state_type] :
      ( v103995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134137(VarCurr,B)
          <=> v134139(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134141(VarCurr,B)
          <=> v134161(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1349,axiom,
    ! [VarCurr: state_type] :
      ( v104002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134141(VarCurr,B)
          <=> v134142(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134162(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134161(VarCurr,B)
          <=> v134163(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1348,axiom,
    ! [VarCurr: state_type] :
      ( v134162(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134161(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134163(VarCurr,B)
          <=> v134117(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1347,axiom,
    ! [VarCurr: state_type] :
      ( v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134163(VarCurr,B)
          <=> v134164(VarCurr,B) ) ) ) ).

tff(addAssignment_76193,axiom,
    ! [VarCurr: state_type] :
      ( v134164(VarCurr,0)
    <=> v134183(VarCurr) ) ).

tff(addAssignment_76192,axiom,
    ! [VarCurr: state_type] :
      ( v134164(VarCurr,1)
    <=> v134181(VarCurr) ) ).

tff(addAssignment_76191,axiom,
    ! [VarCurr: state_type] :
      ( v134164(VarCurr,2)
    <=> v134177(VarCurr) ) ).

tff(addAssignment_76190,axiom,
    ! [VarCurr: state_type] :
      ( v134164(VarCurr,3)
    <=> v134166(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17401,axiom,
    ! [VarCurr: state_type] :
      ( v134181(VarCurr)
    <=> ( v134182(VarCurr)
        & v134184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17400,axiom,
    ! [VarCurr: state_type] :
      ( v134184(VarCurr)
    <=> ( v134117(VarCurr,0)
        | v134173(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5988,axiom,
    ! [VarCurr: state_type] :
      ( v134182(VarCurr)
    <=> ( v134183(VarCurr)
        | v134117(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134183(VarCurr)
    <=> v134117(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17399,axiom,
    ! [VarCurr: state_type] :
      ( v134177(VarCurr)
    <=> ( v134178(VarCurr)
        & v134180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17398,axiom,
    ! [VarCurr: state_type] :
      ( v134180(VarCurr)
    <=> ( v134171(VarCurr)
        | v134174(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5987,axiom,
    ! [VarCurr: state_type] :
      ( v134178(VarCurr)
    <=> ( v134179(VarCurr)
        | v134117(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134179(VarCurr)
    <=> v134171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17397,axiom,
    ! [VarCurr: state_type] :
      ( v134166(VarCurr)
    <=> ( v134167(VarCurr)
        & v134175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17396,axiom,
    ! [VarCurr: state_type] :
      ( v134175(VarCurr)
    <=> ( v134169(VarCurr)
        | v134176(VarCurr) ) ) ).

tff(writeUnaryOperator_9737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134176(VarCurr)
    <=> v134117(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5986,axiom,
    ! [VarCurr: state_type] :
      ( v134167(VarCurr)
    <=> ( v134168(VarCurr)
        | v134117(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134168(VarCurr)
    <=> v134169(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5985,axiom,
    ! [VarCurr: state_type] :
      ( v134169(VarCurr)
    <=> ( v134117(VarCurr,2)
        | v134170(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17395,axiom,
    ! [VarCurr: state_type] :
      ( v134170(VarCurr)
    <=> ( v134171(VarCurr)
        & v134174(VarCurr) ) ) ).

tff(writeUnaryOperator_9735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134174(VarCurr)
    <=> v134117(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5984,axiom,
    ! [VarCurr: state_type] :
      ( v134171(VarCurr)
    <=> ( v134117(VarCurr,1)
        | v134172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17394,axiom,
    ! [VarCurr: state_type] :
      ( v134172(VarCurr)
    <=> ( v134117(VarCurr,0)
        & v134173(VarCurr) ) ) ).

tff(writeUnaryOperator_9734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134173(VarCurr)
    <=> v134117(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1735,axiom,
    ! [VarCurr: state_type] :
      ( v134162(VarCurr)
    <=> ( ( v134117(VarCurr,3)
        <=> $false )
        & ( v134117(VarCurr,2)
        <=> $false )
        & ( v134117(VarCurr,1)
        <=> $false )
        & ( v134117(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76189,axiom,
    ! [VarCurr: state_type] :
      ( v134142(VarCurr,0)
    <=> v134158(VarCurr) ) ).

tff(addAssignment_76188,axiom,
    ! [VarCurr: state_type] :
      ( v134142(VarCurr,1)
    <=> v134156(VarCurr) ) ).

tff(addAssignment_76187,axiom,
    ! [VarCurr: state_type] :
      ( v134142(VarCurr,2)
    <=> v134151(VarCurr) ) ).

tff(addAssignment_76186,axiom,
    ! [VarCurr: state_type] :
      ( v134142(VarCurr,3)
    <=> v134144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17393,axiom,
    ! [VarCurr: state_type] :
      ( v134156(VarCurr)
    <=> ( v134157(VarCurr)
        & v134160(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5983,axiom,
    ! [VarCurr: state_type] :
      ( v134160(VarCurr)
    <=> ( v134139(VarCurr,0)
        | v134139(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17392,axiom,
    ! [VarCurr: state_type] :
      ( v134157(VarCurr)
    <=> ( v134158(VarCurr)
        | v134159(VarCurr) ) ) ).

tff(writeUnaryOperator_9733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134159(VarCurr)
    <=> v134139(VarCurr,1) ) ).

tff(writeUnaryOperator_9732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134158(VarCurr)
    <=> v134139(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17391,axiom,
    ! [VarCurr: state_type] :
      ( v134151(VarCurr)
    <=> ( v134152(VarCurr)
        & v134155(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5982,axiom,
    ! [VarCurr: state_type] :
      ( v134155(VarCurr)
    <=> ( v134148(VarCurr)
        | v134139(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17390,axiom,
    ! [VarCurr: state_type] :
      ( v134152(VarCurr)
    <=> ( v134153(VarCurr)
        | v134154(VarCurr) ) ) ).

tff(writeUnaryOperator_9731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134154(VarCurr)
    <=> v134139(VarCurr,2) ) ).

tff(writeUnaryOperator_9730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134153(VarCurr)
    <=> v134148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17389,axiom,
    ! [VarCurr: state_type] :
      ( v134144(VarCurr)
    <=> ( v134145(VarCurr)
        & v134150(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5981,axiom,
    ! [VarCurr: state_type] :
      ( v134150(VarCurr)
    <=> ( v134147(VarCurr)
        | v134139(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17388,axiom,
    ! [VarCurr: state_type] :
      ( v134145(VarCurr)
    <=> ( v134146(VarCurr)
        | v134149(VarCurr) ) ) ).

tff(writeUnaryOperator_9729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134149(VarCurr)
    <=> v134139(VarCurr,3) ) ).

tff(writeUnaryOperator_9728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134146(VarCurr)
    <=> v134147(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5980,axiom,
    ! [VarCurr: state_type] :
      ( v134147(VarCurr)
    <=> ( v134148(VarCurr)
        & v134139(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5979,axiom,
    ! [VarCurr: state_type] :
      ( v134148(VarCurr)
    <=> ( v134139(VarCurr,0)
        & v134139(VarCurr,1) ) ) ).

tff(addAssignment_76185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v134139(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76184,axiom,
    ! [VarCurr: state_type] :
      ( v134127(VarCurr)
    <=> v134129(VarCurr) ) ).

tff(addAssignment_76183,axiom,
    ! [VarCurr: state_type] :
      ( v134129(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_76182,axiom,
    ! [VarCurr: state_type] :
      ( v134123(VarCurr)
    <=> v134125(VarCurr) ) ).

tff(addAssignment_76181,axiom,
    ! [VarCurr: state_type] :
      ( v134125(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_76180,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,1)
    <=> v134052(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1734,axiom,
    ! [VarCurr: state_type] :
      ( v134052(VarCurr)
    <=> ( v134054(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76179,axiom,
    ! [VarCurr: state_type] :
      ( v134054(VarCurr)
    <=> v134056(VarCurr) ) ).

tff(addAssignment_76178,axiom,
    ! [VarCurr: state_type] :
      ( v134056(VarCurr)
    <=> v134058(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134097(VarNext)
       => ( v134058(VarNext)
        <=> v134058(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1863,axiom,
    ! [VarNext: state_type] :
      ( v134097(VarNext)
     => ( v134058(VarNext)
      <=> v134107(VarNext) ) ) ).

tff(addAssignment_76177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134107(VarNext)
      <=> v134105(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134108(VarCurr)
     => ( v134105(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1346,axiom,
    ! [VarCurr: state_type] :
      ( v134108(VarCurr)
     => ( v134105(VarCurr)
      <=> v134068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17387,axiom,
    ! [VarCurr: state_type] :
      ( v134108(VarCurr)
    <=> ( v134109(VarCurr)
        & v134110(VarCurr) ) ) ).

tff(writeUnaryOperator_9727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134110(VarCurr)
    <=> v134064(VarCurr) ) ).

tff(writeUnaryOperator_9726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134109(VarCurr)
    <=> v134060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134097(VarNext)
      <=> v134098(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134098(VarNext)
      <=> ( v134099(VarNext)
          & v134092(VarNext) ) ) ) ).

tff(writeUnaryOperator_9725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134099(VarNext)
      <=> v134101(VarNext) ) ) ).

tff(addAssignment_76176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134101(VarNext)
      <=> v134092(VarCurr) ) ) ).

tff(addAssignment_76175,axiom,
    ! [VarCurr: state_type] :
      ( v134092(VarCurr)
    <=> v134094(VarCurr) ) ).

tff(addAssignment_76174,axiom,
    ! [VarCurr: state_type] :
      ( v134094(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_76173,axiom,
    ! [VarCurr: state_type] :
      ( v134068(VarCurr)
    <=> v134070(VarCurr) ) ).

tff(addAssignment_76172,axiom,
    ! [VarCurr: state_type] :
      ( v134070(VarCurr)
    <=> v134072(VarCurr) ) ).

tff(addAssignment_76171,axiom,
    ! [VarCurr: state_type] :
      ( v134072(VarCurr)
    <=> v134074(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134086(VarCurr)
     => ( v134074(VarCurr)
      <=> v134087(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1345,axiom,
    ! [VarCurr: state_type] :
      ( v134086(VarCurr)
     => ( v134074(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134088(VarCurr)
     => ( v134087(VarCurr)
      <=> v134089(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1344,axiom,
    ! [VarCurr: state_type] :
      ( v134088(VarCurr)
     => ( v134087(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134089(VarCurr)
    <=> v134054(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1733,axiom,
    ! [VarCurr: state_type] :
      ( v134088(VarCurr)
    <=> ( v134054(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17384,axiom,
    ! [VarCurr: state_type] :
      ( v134086(VarCurr)
    <=> ( v134076(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(addAssignment_76170,axiom,
    ! [VarCurr: state_type] :
      ( v134076(VarCurr)
    <=> v103977(VarCurr,2) ) ).

tff(addAssignment_76169,axiom,
    ! [VarCurr: state_type] :
      ( v103977(VarCurr,2)
    <=> v103979(VarCurr,2) ) ).

tff(addAssignment_76168,axiom,
    ! [VarNext: state_type] :
      ( v103979(VarNext,2)
    <=> v134078(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134079(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v134078(VarNext,B)
            <=> v103979(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1862,axiom,
    ! [VarNext: state_type] :
      ( v134079(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v134078(VarNext,B)
          <=> v104019(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134079(VarNext)
      <=> v134080(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134080(VarNext)
      <=> ( v134082(VarNext)
          & v104004(VarNext) ) ) ) ).

tff(writeUnaryOperator_9723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134082(VarNext)
      <=> v104013(VarNext) ) ) ).

tff(addAssignment_76167,axiom,
    ! [VarCurr: state_type] :
      ( v103989(VarCurr,2)
    <=> v103991(VarCurr,2) ) ).

tff(addAssignment_76166,axiom,
    ! [VarCurr: state_type] :
      ( v103991(VarCurr,2)
    <=> v103993(VarCurr,2) ) ).

tff(addAssignment_76165,axiom,
    ! [VarCurr: state_type] :
      ( v103993(VarCurr,2)
    <=> v104001(VarCurr,2) ) ).

tff(addAssignment_76164,axiom,
    ! [VarCurr: state_type] :
      ( v134064(VarCurr)
    <=> v134066(VarCurr) ) ).

tff(addAssignment_76163,axiom,
    ! [VarCurr: state_type] :
      ( v134066(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_76162,axiom,
    ! [VarCurr: state_type] :
      ( v134060(VarCurr)
    <=> v134062(VarCurr) ) ).

tff(addAssignment_76161,axiom,
    ! [VarCurr: state_type] :
      ( v134062(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_76160,axiom,
    ! [VarCurr: state_type] :
      ( v133661(VarCurr,0)
    <=> v133663(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1732,axiom,
    ! [VarCurr: state_type] :
      ( v133663(VarCurr)
    <=> ( ( v133665(VarCurr,3)
        <=> $false )
        & ( v133665(VarCurr,2)
        <=> $false )
        & ( v133665(VarCurr,1)
        <=> $false )
        & ( v133665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133665(VarCurr,B)
      <=> v133667(VarCurr,B) ) ) ).

tff(addAssignment_76158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133667(VarCurr,B)
      <=> v133669(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134034(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v133669(VarNext,B)
            <=> v133669(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1861,axiom,
    ! [VarNext: state_type] :
      ( v134034(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133669(VarNext,B)
          <=> v134044(VarNext,B) ) ) ) ).

tff(addAssignment_76157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134044(VarNext,B)
          <=> v134042(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134042(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1343,axiom,
    ! [VarCurr: state_type] :
      ( v134045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134042(VarCurr,B)
          <=> v133679(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17381,axiom,
    ! [VarCurr: state_type] :
      ( v134045(VarCurr)
    <=> ( v134046(VarCurr)
        & v134047(VarCurr) ) ) ).

tff(writeUnaryOperator_9722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134047(VarCurr)
    <=> v133675(VarCurr) ) ).

tff(writeUnaryOperator_9721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134046(VarCurr)
    <=> v133671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134034(VarNext)
      <=> v134035(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134035(VarNext)
      <=> ( v134036(VarNext)
          & v134029(VarNext) ) ) ) ).

tff(writeUnaryOperator_9720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v134036(VarNext)
      <=> v134038(VarNext) ) ) ).

tff(addAssignment_76156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v134038(VarNext)
      <=> v134029(VarCurr) ) ) ).

tff(addAssignment_76155,axiom,
    ! [VarCurr: state_type] :
      ( v134029(VarCurr)
    <=> v134031(VarCurr) ) ).

tff(addAssignment_76154,axiom,
    ! [VarCurr: state_type] :
      ( v134031(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_76153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133679(VarCurr,B)
      <=> v133681(VarCurr,B) ) ) ).

tff(addAssignment_76152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133681(VarCurr,B)
      <=> v133683(VarCurr,B) ) ) ).

tff(addAssignment_76151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133683(VarCurr,B)
      <=> v133685(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101497(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133685(VarCurr,B)
          <=> v133984(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1342,axiom,
    ! [VarCurr: state_type] :
      ( v101497(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133685(VarCurr,B)
          <=> v133687(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103067(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133984(VarCurr,B)
          <=> v134004(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1341,axiom,
    ! [VarCurr: state_type] :
      ( v103067(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133984(VarCurr,B)
          <=> v133985(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134004(VarCurr,B)
          <=> v134006(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1340,axiom,
    ! [VarCurr: state_type] :
      ( v134005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134004(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134006(VarCurr,B)
          <=> v133665(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1339,axiom,
    ! [VarCurr: state_type] :
      ( v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v134006(VarCurr,B)
          <=> v134007(VarCurr,B) ) ) ) ).

tff(addAssignment_76150,axiom,
    ! [VarCurr: state_type] :
      ( v134007(VarCurr,0)
    <=> v134026(VarCurr) ) ).

tff(addAssignment_76149,axiom,
    ! [VarCurr: state_type] :
      ( v134007(VarCurr,1)
    <=> v134024(VarCurr) ) ).

tff(addAssignment_76148,axiom,
    ! [VarCurr: state_type] :
      ( v134007(VarCurr,2)
    <=> v134020(VarCurr) ) ).

tff(addAssignment_76147,axiom,
    ! [VarCurr: state_type] :
      ( v134007(VarCurr,3)
    <=> v134009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17378,axiom,
    ! [VarCurr: state_type] :
      ( v134024(VarCurr)
    <=> ( v134025(VarCurr)
        & v134027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17377,axiom,
    ! [VarCurr: state_type] :
      ( v134027(VarCurr)
    <=> ( v133665(VarCurr,0)
        | v134016(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5978,axiom,
    ! [VarCurr: state_type] :
      ( v134025(VarCurr)
    <=> ( v134026(VarCurr)
        | v133665(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134026(VarCurr)
    <=> v133665(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17376,axiom,
    ! [VarCurr: state_type] :
      ( v134020(VarCurr)
    <=> ( v134021(VarCurr)
        & v134023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17375,axiom,
    ! [VarCurr: state_type] :
      ( v134023(VarCurr)
    <=> ( v134014(VarCurr)
        | v134017(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5977,axiom,
    ! [VarCurr: state_type] :
      ( v134021(VarCurr)
    <=> ( v134022(VarCurr)
        | v133665(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134022(VarCurr)
    <=> v134014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17374,axiom,
    ! [VarCurr: state_type] :
      ( v134009(VarCurr)
    <=> ( v134010(VarCurr)
        & v134018(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17373,axiom,
    ! [VarCurr: state_type] :
      ( v134018(VarCurr)
    <=> ( v134012(VarCurr)
        | v134019(VarCurr) ) ) ).

tff(writeUnaryOperator_9717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134019(VarCurr)
    <=> v133665(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5976,axiom,
    ! [VarCurr: state_type] :
      ( v134010(VarCurr)
    <=> ( v134011(VarCurr)
        | v133665(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134011(VarCurr)
    <=> v134012(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5975,axiom,
    ! [VarCurr: state_type] :
      ( v134012(VarCurr)
    <=> ( v133665(VarCurr,2)
        | v134013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17372,axiom,
    ! [VarCurr: state_type] :
      ( v134013(VarCurr)
    <=> ( v134014(VarCurr)
        & v134017(VarCurr) ) ) ).

tff(writeUnaryOperator_9715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134017(VarCurr)
    <=> v133665(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5974,axiom,
    ! [VarCurr: state_type] :
      ( v134014(VarCurr)
    <=> ( v133665(VarCurr,1)
        | v134015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17371,axiom,
    ! [VarCurr: state_type] :
      ( v134015(VarCurr)
    <=> ( v133665(VarCurr,0)
        & v134016(VarCurr) ) ) ).

tff(writeUnaryOperator_9714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134016(VarCurr)
    <=> v133665(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_1731,axiom,
    ! [VarCurr: state_type] :
      ( v134005(VarCurr)
    <=> ( ( v133665(VarCurr,3)
        <=> $false )
        & ( v133665(VarCurr,2)
        <=> $false )
        & ( v133665(VarCurr,1)
        <=> $false )
        & ( v133665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_76146,axiom,
    ! [VarCurr: state_type] :
      ( v133985(VarCurr,0)
    <=> v134001(VarCurr) ) ).

tff(addAssignment_76145,axiom,
    ! [VarCurr: state_type] :
      ( v133985(VarCurr,1)
    <=> v133999(VarCurr) ) ).

tff(addAssignment_76144,axiom,
    ! [VarCurr: state_type] :
      ( v133985(VarCurr,2)
    <=> v133994(VarCurr) ) ).

tff(addAssignment_76143,axiom,
    ! [VarCurr: state_type] :
      ( v133985(VarCurr,3)
    <=> v133987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17370,axiom,
    ! [VarCurr: state_type] :
      ( v133999(VarCurr)
    <=> ( v134000(VarCurr)
        & v134003(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5973,axiom,
    ! [VarCurr: state_type] :
      ( v134003(VarCurr)
    <=> ( v133687(VarCurr,0)
        | v133687(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17369,axiom,
    ! [VarCurr: state_type] :
      ( v134000(VarCurr)
    <=> ( v134001(VarCurr)
        | v134002(VarCurr) ) ) ).

tff(writeUnaryOperator_9713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134002(VarCurr)
    <=> v133687(VarCurr,1) ) ).

tff(writeUnaryOperator_9712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134001(VarCurr)
    <=> v133687(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17368,axiom,
    ! [VarCurr: state_type] :
      ( v133994(VarCurr)
    <=> ( v133995(VarCurr)
        & v133998(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5972,axiom,
    ! [VarCurr: state_type] :
      ( v133998(VarCurr)
    <=> ( v133991(VarCurr)
        | v133687(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17367,axiom,
    ! [VarCurr: state_type] :
      ( v133995(VarCurr)
    <=> ( v133996(VarCurr)
        | v133997(VarCurr) ) ) ).

tff(writeUnaryOperator_9711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133997(VarCurr)
    <=> v133687(VarCurr,2) ) ).

tff(writeUnaryOperator_9710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133996(VarCurr)
    <=> v133991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17366,axiom,
    ! [VarCurr: state_type] :
      ( v133987(VarCurr)
    <=> ( v133988(VarCurr)
        & v133993(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5971,axiom,
    ! [VarCurr: state_type] :
      ( v133993(VarCurr)
    <=> ( v133990(VarCurr)
        | v133687(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17365,axiom,
    ! [VarCurr: state_type] :
      ( v133988(VarCurr)
    <=> ( v133989(VarCurr)
        | v133992(VarCurr) ) ) ).

tff(writeUnaryOperator_9709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133992(VarCurr)
    <=> v133687(VarCurr,3) ) ).

tff(writeUnaryOperator_9708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133989(VarCurr)
    <=> v133990(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5970,axiom,
    ! [VarCurr: state_type] :
      ( v133990(VarCurr)
    <=> ( v133991(VarCurr)
        & v133687(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5969,axiom,
    ! [VarCurr: state_type] :
      ( v133991(VarCurr)
    <=> ( v133687(VarCurr,0)
        & v133687(VarCurr,1) ) ) ).

tff(addAssignment_76142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133687(VarCurr,B)
      <=> v133689(VarCurr,B) ) ) ).

tff(addAssignment_76141,axiom,
    ! [VarCurr: state_type] :
      ( v133689(VarCurr,0)
    <=> v133978(VarCurr) ) ).

tff(addAssignment_76140,axiom,
    ! [VarCurr: state_type] :
      ( v133689(VarCurr,1)
    <=> v133973(VarCurr) ) ).

tff(addAssignment_76139,axiom,
    ! [VarCurr: state_type] :
      ( v133689(VarCurr,2)
    <=> v133968(VarCurr) ) ).

tff(addAssignment_76138,axiom,
    ! [VarCurr: state_type] :
      ( v133689(VarCurr,3)
    <=> v133849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17364,axiom,
    ! [VarCurr: state_type] :
      ( v133978(VarCurr)
    <=> ( v133979(VarCurr)
        & v133982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17363,axiom,
    ! [VarCurr: state_type] :
      ( v133982(VarCurr)
    <=> ( v133857(VarCurr,0)
        | v133947(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17362,axiom,
    ! [VarCurr: state_type] :
      ( v133979(VarCurr)
    <=> ( v133980(VarCurr)
        | v133981(VarCurr) ) ) ).

tff(writeUnaryOperator_9707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133981(VarCurr)
    <=> v133947(VarCurr,0) ) ).

tff(writeUnaryOperator_9706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133980(VarCurr)
    <=> v133857(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17361,axiom,
    ! [VarCurr: state_type] :
      ( v133973(VarCurr)
    <=> ( v133974(VarCurr)
        & v133977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17360,axiom,
    ! [VarCurr: state_type] :
      ( v133977(VarCurr)
    <=> ( v133856(VarCurr)
        | v133949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17359,axiom,
    ! [VarCurr: state_type] :
      ( v133974(VarCurr)
    <=> ( v133975(VarCurr)
        | v133976(VarCurr) ) ) ).

tff(writeUnaryOperator_9705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133976(VarCurr)
    <=> v133949(VarCurr) ) ).

tff(writeUnaryOperator_9704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133975(VarCurr)
    <=> v133856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17358,axiom,
    ! [VarCurr: state_type] :
      ( v133968(VarCurr)
    <=> ( v133969(VarCurr)
        & v133972(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17357,axiom,
    ! [VarCurr: state_type] :
      ( v133972(VarCurr)
    <=> ( v133854(VarCurr)
        | v133955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17356,axiom,
    ! [VarCurr: state_type] :
      ( v133969(VarCurr)
    <=> ( v133970(VarCurr)
        | v133971(VarCurr) ) ) ).

tff(writeUnaryOperator_9703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133971(VarCurr)
    <=> v133955(VarCurr) ) ).

tff(writeUnaryOperator_9702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133970(VarCurr)
    <=> v133854(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17355,axiom,
    ! [VarCurr: state_type] :
      ( v133849(VarCurr)
    <=> ( v133850(VarCurr)
        & v133967(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17354,axiom,
    ! [VarCurr: state_type] :
      ( v133967(VarCurr)
    <=> ( v133852(VarCurr)
        | v133962(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17353,axiom,
    ! [VarCurr: state_type] :
      ( v133850(VarCurr)
    <=> ( v133851(VarCurr)
        | v133961(VarCurr) ) ) ).

tff(writeUnaryOperator_9701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133961(VarCurr)
    <=> v133962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17352,axiom,
    ! [VarCurr: state_type] :
      ( v133962(VarCurr)
    <=> ( v133963(VarCurr)
        & v133966(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5968,axiom,
    ! [VarCurr: state_type] :
      ( v133966(VarCurr)
    <=> ( v133857(VarCurr,3)
        | v133947(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17351,axiom,
    ! [VarCurr: state_type] :
      ( v133963(VarCurr)
    <=> ( v133964(VarCurr)
        | v133965(VarCurr) ) ) ).

tff(writeUnaryOperator_9700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133965(VarCurr)
    <=> v133947(VarCurr,3) ) ).

tff(writeUnaryOperator_9699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133964(VarCurr)
    <=> v133857(VarCurr,3) ) ).

tff(writeUnaryOperator_9698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133851(VarCurr)
    <=> v133852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17350,axiom,
    ! [VarCurr: state_type] :
      ( v133852(VarCurr)
    <=> ( v133853(VarCurr)
        | v133960(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5967,axiom,
    ! [VarCurr: state_type] :
      ( v133960(VarCurr)
    <=> ( v133857(VarCurr,2)
        & v133947(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17349,axiom,
    ! [VarCurr: state_type] :
      ( v133853(VarCurr)
    <=> ( v133854(VarCurr)
        & v133955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17348,axiom,
    ! [VarCurr: state_type] :
      ( v133955(VarCurr)
    <=> ( v133956(VarCurr)
        & v133959(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5966,axiom,
    ! [VarCurr: state_type] :
      ( v133959(VarCurr)
    <=> ( v133857(VarCurr,2)
        | v133947(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17347,axiom,
    ! [VarCurr: state_type] :
      ( v133956(VarCurr)
    <=> ( v133957(VarCurr)
        | v133958(VarCurr) ) ) ).

tff(writeUnaryOperator_9697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133958(VarCurr)
    <=> v133947(VarCurr,2) ) ).

tff(writeUnaryOperator_9696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133957(VarCurr)
    <=> v133857(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17346,axiom,
    ! [VarCurr: state_type] :
      ( v133854(VarCurr)
    <=> ( v133855(VarCurr)
        | v133954(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5965,axiom,
    ! [VarCurr: state_type] :
      ( v133954(VarCurr)
    <=> ( v133857(VarCurr,1)
        & v133947(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17345,axiom,
    ! [VarCurr: state_type] :
      ( v133855(VarCurr)
    <=> ( v133856(VarCurr)
        & v133949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17344,axiom,
    ! [VarCurr: state_type] :
      ( v133949(VarCurr)
    <=> ( v133950(VarCurr)
        & v133953(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5964,axiom,
    ! [VarCurr: state_type] :
      ( v133953(VarCurr)
    <=> ( v133857(VarCurr,1)
        | v133947(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17343,axiom,
    ! [VarCurr: state_type] :
      ( v133950(VarCurr)
    <=> ( v133951(VarCurr)
        | v133952(VarCurr) ) ) ).

tff(writeUnaryOperator_9695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133952(VarCurr)
    <=> v133947(VarCurr,1) ) ).

tff(writeUnaryOperator_9694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133951(VarCurr)
    <=> v133857(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17342,axiom,
    ! [VarCurr: state_type] :
      ( v133856(VarCurr)
    <=> ( v133857(VarCurr,0)
        & v133947(VarCurr,0) ) ) ).

tff(addZeroExtensionConstraint_51,axiom,
    ! [VarCurr: state_type] : ~ v133947(VarCurr,2) ).

tff(addZeroExtensionConstraint_50,axiom,
    ! [VarCurr: state_type] : ~ v133947(VarCurr,3) ).

tff(addAssignment_76137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133947(VarCurr,B)
      <=> v133948(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133948(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1338,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133948(VarCurr,B)
          <=> $true ) ) ) ).

tff(addAssignment_76136,axiom,
    ! [VarCurr: state_type] :
      ( v133857(VarCurr,0)
    <=> v133942(VarCurr) ) ).

tff(addAssignment_76135,axiom,
    ! [VarCurr: state_type] :
      ( v133857(VarCurr,1)
    <=> v133937(VarCurr) ) ).

tff(addAssignment_76134,axiom,
    ! [VarCurr: state_type] :
      ( v133857(VarCurr,2)
    <=> v133932(VarCurr) ) ).

tff(addAssignment_76133,axiom,
    ! [VarCurr: state_type] :
      ( v133857(VarCurr,3)
    <=> v133859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17341,axiom,
    ! [VarCurr: state_type] :
      ( v133942(VarCurr)
    <=> ( v133943(VarCurr)
        & v133946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17340,axiom,
    ! [VarCurr: state_type] :
      ( v133946(VarCurr)
    <=> ( v133867(VarCurr,0)
        | v133912(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17339,axiom,
    ! [VarCurr: state_type] :
      ( v133943(VarCurr)
    <=> ( v133944(VarCurr)
        | v133945(VarCurr) ) ) ).

tff(writeUnaryOperator_9693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133945(VarCurr)
    <=> v133912(VarCurr,0) ) ).

tff(writeUnaryOperator_9692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133944(VarCurr)
    <=> v133867(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17338,axiom,
    ! [VarCurr: state_type] :
      ( v133937(VarCurr)
    <=> ( v133938(VarCurr)
        & v133941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17337,axiom,
    ! [VarCurr: state_type] :
      ( v133941(VarCurr)
    <=> ( v133866(VarCurr)
        | v133913(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17336,axiom,
    ! [VarCurr: state_type] :
      ( v133938(VarCurr)
    <=> ( v133939(VarCurr)
        | v133940(VarCurr) ) ) ).

tff(writeUnaryOperator_9691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133940(VarCurr)
    <=> v133913(VarCurr) ) ).

tff(writeUnaryOperator_9690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133939(VarCurr)
    <=> v133866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17335,axiom,
    ! [VarCurr: state_type] :
      ( v133932(VarCurr)
    <=> ( v133933(VarCurr)
        & v133936(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17334,axiom,
    ! [VarCurr: state_type] :
      ( v133936(VarCurr)
    <=> ( v133864(VarCurr)
        | v133919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17333,axiom,
    ! [VarCurr: state_type] :
      ( v133933(VarCurr)
    <=> ( v133934(VarCurr)
        | v133935(VarCurr) ) ) ).

tff(writeUnaryOperator_9689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133935(VarCurr)
    <=> v133919(VarCurr) ) ).

tff(writeUnaryOperator_9688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133934(VarCurr)
    <=> v133864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17332,axiom,
    ! [VarCurr: state_type] :
      ( v133859(VarCurr)
    <=> ( v133860(VarCurr)
        & v133931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17331,axiom,
    ! [VarCurr: state_type] :
      ( v133931(VarCurr)
    <=> ( v133862(VarCurr)
        | v133926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17330,axiom,
    ! [VarCurr: state_type] :
      ( v133860(VarCurr)
    <=> ( v133861(VarCurr)
        | v133925(VarCurr) ) ) ).

tff(writeUnaryOperator_9687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133925(VarCurr)
    <=> v133926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17329,axiom,
    ! [VarCurr: state_type] :
      ( v133926(VarCurr)
    <=> ( v133927(VarCurr)
        & v133930(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5963,axiom,
    ! [VarCurr: state_type] :
      ( v133930(VarCurr)
    <=> ( v133867(VarCurr,3)
        | v133912(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17328,axiom,
    ! [VarCurr: state_type] :
      ( v133927(VarCurr)
    <=> ( v133928(VarCurr)
        | v133929(VarCurr) ) ) ).

tff(writeUnaryOperator_9686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133929(VarCurr)
    <=> v133912(VarCurr,3) ) ).

tff(writeUnaryOperator_9685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133928(VarCurr)
    <=> v133867(VarCurr,3) ) ).

tff(writeUnaryOperator_9684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133861(VarCurr)
    <=> v133862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17327,axiom,
    ! [VarCurr: state_type] :
      ( v133862(VarCurr)
    <=> ( v133863(VarCurr)
        | v133924(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5962,axiom,
    ! [VarCurr: state_type] :
      ( v133924(VarCurr)
    <=> ( v133867(VarCurr,2)
        & v133912(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17326,axiom,
    ! [VarCurr: state_type] :
      ( v133863(VarCurr)
    <=> ( v133864(VarCurr)
        & v133919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17325,axiom,
    ! [VarCurr: state_type] :
      ( v133919(VarCurr)
    <=> ( v133920(VarCurr)
        & v133923(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5961,axiom,
    ! [VarCurr: state_type] :
      ( v133923(VarCurr)
    <=> ( v133867(VarCurr,2)
        | v133912(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17324,axiom,
    ! [VarCurr: state_type] :
      ( v133920(VarCurr)
    <=> ( v133921(VarCurr)
        | v133922(VarCurr) ) ) ).

tff(writeUnaryOperator_9683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133922(VarCurr)
    <=> v133912(VarCurr,2) ) ).

tff(writeUnaryOperator_9682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133921(VarCurr)
    <=> v133867(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17323,axiom,
    ! [VarCurr: state_type] :
      ( v133864(VarCurr)
    <=> ( v133865(VarCurr)
        | v133918(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5960,axiom,
    ! [VarCurr: state_type] :
      ( v133918(VarCurr)
    <=> ( v133867(VarCurr,1)
        & v133912(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17322,axiom,
    ! [VarCurr: state_type] :
      ( v133865(VarCurr)
    <=> ( v133866(VarCurr)
        & v133913(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17321,axiom,
    ! [VarCurr: state_type] :
      ( v133913(VarCurr)
    <=> ( v133914(VarCurr)
        & v133917(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5959,axiom,
    ! [VarCurr: state_type] :
      ( v133917(VarCurr)
    <=> ( v133867(VarCurr,1)
        | v133912(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17320,axiom,
    ! [VarCurr: state_type] :
      ( v133914(VarCurr)
    <=> ( v133915(VarCurr)
        | v133916(VarCurr) ) ) ).

tff(writeUnaryOperator_9681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133916(VarCurr)
    <=> v133912(VarCurr,1) ) ).

tff(writeUnaryOperator_9680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133915(VarCurr)
    <=> v133867(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17319,axiom,
    ! [VarCurr: state_type] :
      ( v133866(VarCurr)
    <=> ( v133867(VarCurr,0)
        & v133912(VarCurr,0) ) ) ).

tff(addAssignment_76132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133912(VarCurr,B)
      <=> v133774(VarCurr,B) ) ) ).

tff(addAssignment_76131,axiom,
    ! [VarCurr: state_type] :
      ( ( v133912(VarCurr,3)
      <=> $false )
      & ( v133912(VarCurr,2)
      <=> $false ) ) ).

tff(addAssignment_76130,axiom,
    ! [VarCurr: state_type] :
      ( v133867(VarCurr,0)
    <=> v133907(VarCurr) ) ).

tff(addAssignment_76129,axiom,
    ! [VarCurr: state_type] :
      ( v133867(VarCurr,1)
    <=> v133902(VarCurr) ) ).

tff(addAssignment_76128,axiom,
    ! [VarCurr: state_type] :
      ( v133867(VarCurr,2)
    <=> v133897(VarCurr) ) ).

tff(addAssignment_76127,axiom,
    ! [VarCurr: state_type] :
      ( v133867(VarCurr,3)
    <=> v133869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17318,axiom,
    ! [VarCurr: state_type] :
      ( v133907(VarCurr)
    <=> ( v133908(VarCurr)
        & v133911(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17317,axiom,
    ! [VarCurr: state_type] :
      ( v133911(VarCurr)
    <=> ( v133691(VarCurr,0)
        | v133877(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17316,axiom,
    ! [VarCurr: state_type] :
      ( v133908(VarCurr)
    <=> ( v133909(VarCurr)
        | v133910(VarCurr) ) ) ).

tff(writeUnaryOperator_9679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133910(VarCurr)
    <=> v133877(VarCurr,0) ) ).

tff(writeUnaryOperator_9678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133909(VarCurr)
    <=> v133691(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17315,axiom,
    ! [VarCurr: state_type] :
      ( v133902(VarCurr)
    <=> ( v133903(VarCurr)
        & v133906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17314,axiom,
    ! [VarCurr: state_type] :
      ( v133906(VarCurr)
    <=> ( v133876(VarCurr)
        | v133878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17313,axiom,
    ! [VarCurr: state_type] :
      ( v133903(VarCurr)
    <=> ( v133904(VarCurr)
        | v133905(VarCurr) ) ) ).

tff(writeUnaryOperator_9677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133905(VarCurr)
    <=> v133878(VarCurr) ) ).

tff(writeUnaryOperator_9676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133904(VarCurr)
    <=> v133876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17312,axiom,
    ! [VarCurr: state_type] :
      ( v133897(VarCurr)
    <=> ( v133898(VarCurr)
        & v133901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17311,axiom,
    ! [VarCurr: state_type] :
      ( v133901(VarCurr)
    <=> ( v133874(VarCurr)
        | v133884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17310,axiom,
    ! [VarCurr: state_type] :
      ( v133898(VarCurr)
    <=> ( v133899(VarCurr)
        | v133900(VarCurr) ) ) ).

tff(writeUnaryOperator_9675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133900(VarCurr)
    <=> v133884(VarCurr) ) ).

tff(writeUnaryOperator_9674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133899(VarCurr)
    <=> v133874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17309,axiom,
    ! [VarCurr: state_type] :
      ( v133869(VarCurr)
    <=> ( v133870(VarCurr)
        & v133896(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17308,axiom,
    ! [VarCurr: state_type] :
      ( v133896(VarCurr)
    <=> ( v133872(VarCurr)
        | v133891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17307,axiom,
    ! [VarCurr: state_type] :
      ( v133870(VarCurr)
    <=> ( v133871(VarCurr)
        | v133890(VarCurr) ) ) ).

tff(writeUnaryOperator_9673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133890(VarCurr)
    <=> v133891(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17306,axiom,
    ! [VarCurr: state_type] :
      ( v133891(VarCurr)
    <=> ( v133892(VarCurr)
        & v133895(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5958,axiom,
    ! [VarCurr: state_type] :
      ( v133895(VarCurr)
    <=> ( v133691(VarCurr,3)
        | v133877(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17305,axiom,
    ! [VarCurr: state_type] :
      ( v133892(VarCurr)
    <=> ( v133893(VarCurr)
        | v133894(VarCurr) ) ) ).

tff(writeUnaryOperator_9672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133894(VarCurr)
    <=> v133877(VarCurr,3) ) ).

tff(writeUnaryOperator_9671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133893(VarCurr)
    <=> v133691(VarCurr,3) ) ).

tff(writeUnaryOperator_9670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133871(VarCurr)
    <=> v133872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17304,axiom,
    ! [VarCurr: state_type] :
      ( v133872(VarCurr)
    <=> ( v133873(VarCurr)
        | v133889(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5957,axiom,
    ! [VarCurr: state_type] :
      ( v133889(VarCurr)
    <=> ( v133691(VarCurr,2)
        & v133877(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17303,axiom,
    ! [VarCurr: state_type] :
      ( v133873(VarCurr)
    <=> ( v133874(VarCurr)
        & v133884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17302,axiom,
    ! [VarCurr: state_type] :
      ( v133884(VarCurr)
    <=> ( v133885(VarCurr)
        & v133888(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5956,axiom,
    ! [VarCurr: state_type] :
      ( v133888(VarCurr)
    <=> ( v133691(VarCurr,2)
        | v133877(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17301,axiom,
    ! [VarCurr: state_type] :
      ( v133885(VarCurr)
    <=> ( v133886(VarCurr)
        | v133887(VarCurr) ) ) ).

tff(writeUnaryOperator_9669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133887(VarCurr)
    <=> v133877(VarCurr,2) ) ).

tff(writeUnaryOperator_9668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133886(VarCurr)
    <=> v133691(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17300,axiom,
    ! [VarCurr: state_type] :
      ( v133874(VarCurr)
    <=> ( v133875(VarCurr)
        | v133883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5955,axiom,
    ! [VarCurr: state_type] :
      ( v133883(VarCurr)
    <=> ( v133691(VarCurr,1)
        & v133877(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17299,axiom,
    ! [VarCurr: state_type] :
      ( v133875(VarCurr)
    <=> ( v133876(VarCurr)
        & v133878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17298,axiom,
    ! [VarCurr: state_type] :
      ( v133878(VarCurr)
    <=> ( v133879(VarCurr)
        & v133882(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5954,axiom,
    ! [VarCurr: state_type] :
      ( v133882(VarCurr)
    <=> ( v133691(VarCurr,1)
        | v133877(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17297,axiom,
    ! [VarCurr: state_type] :
      ( v133879(VarCurr)
    <=> ( v133880(VarCurr)
        | v133881(VarCurr) ) ) ).

tff(writeUnaryOperator_9667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133881(VarCurr)
    <=> v133877(VarCurr,1) ) ).

tff(writeUnaryOperator_9666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133880(VarCurr)
    <=> v133691(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17296,axiom,
    ! [VarCurr: state_type] :
      ( v133876(VarCurr)
    <=> ( v133691(VarCurr,0)
        & v133877(VarCurr,0) ) ) ).

tff(addAssignment_76126,axiom,
    ! [VarCurr: state_type] :
      ( ( v133877(VarCurr,2)
      <=> v114061(VarCurr,6) )
      & ( v133877(VarCurr,1)
      <=> v114061(VarCurr,5) )
      & ( v133877(VarCurr,0)
      <=> v114061(VarCurr,4) ) ) ).

tff(addAssignment_76125,axiom,
    ! [VarCurr: state_type] :
      ( v133877(VarCurr,3)
    <=> $false ) ).

tff(writeUnaryOperator_9665,axiom,
    ! [VarCurr: state_type] :
      ( v133774(VarCurr,1)
    <=> ~ v133835(VarCurr) ) ).

tff(addAssignment_76124,axiom,
    ! [VarCurr: state_type] :
      ( v133835(VarCurr)
    <=> v133776(VarCurr,1) ) ).

tff(addAssignment_76123,axiom,
    ! [VarCurr: state_type] :
      ( v133776(VarCurr,1)
    <=> v133778(VarCurr,1) ) ).

tff(addAssignment_76122,axiom,
    ! [VarNext: state_type] :
      ( v133778(VarNext,1)
    <=> v133839(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133840(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v133839(VarNext,B)
            <=> v133778(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1860,axiom,
    ! [VarNext: state_type] :
      ( v133840(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133839(VarNext,B)
          <=> v133828(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133840(VarNext)
      <=> v133841(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133841(VarNext)
      <=> ( v133843(VarNext)
          & v133813(VarNext) ) ) ) ).

tff(writeUnaryOperator_9664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133843(VarNext)
      <=> v133822(VarNext) ) ) ).

tff(addAssignment_76121,axiom,
    ! [VarCurr: state_type] :
      ( v133788(VarCurr,1)
    <=> v133790(VarCurr,1) ) ).

tff(addAssignment_76120,axiom,
    ! [VarCurr: state_type] :
      ( v133790(VarCurr,1)
    <=> v133804(VarCurr,1) ) ).

tff(addAssignment_76119,axiom,
    ! [VarCurr: state_type] :
      ( v133792(VarCurr,1)
    <=> v133795(VarCurr,1) ) ).

tff(writeUnaryOperator_9663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133796(VarCurr)
    <=> v133794(VarCurr,1) ) ).

tff(addAssignment_76118,axiom,
    ! [VarCurr: state_type] :
      ( v133794(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_76117,axiom,
    ! [VarCurr: state_type] :
      ( v133774(VarCurr,0)
    <=> v133776(VarCurr,0) ) ).

tff(addAssignment_76116,axiom,
    ! [VarCurr: state_type] :
      ( v133776(VarCurr,0)
    <=> v133778(VarCurr,0) ) ).

tff(addAssignment_76115,axiom,
    ! [VarNext: state_type] :
      ( v133778(VarNext,0)
    <=> v133817(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133818(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v133817(VarNext,B)
            <=> v133778(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1859,axiom,
    ! [VarNext: state_type] :
      ( v133818(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133817(VarNext,B)
          <=> v133828(VarNext,B) ) ) ) ).

tff(addAssignment_76114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133828(VarNext,B)
          <=> v133826(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133829(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133826(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1337,axiom,
    ! [VarCurr: state_type] :
      ( v133829(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v133826(VarCurr,B)
          <=> v133788(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17293,axiom,
    ! [VarCurr: state_type] :
      ( v133829(VarCurr)
    <=> ( v133830(VarCurr)
        & v133831(VarCurr) ) ) ).

tff(writeUnaryOperator_9662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133831(VarCurr)
    <=> v133784(VarCurr) ) ).

tff(writeUnaryOperator_9661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133830(VarCurr)
    <=> v133780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133818(VarNext)
      <=> v133819(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133819(VarNext)
      <=> ( v133820(VarNext)
          & v133813(VarNext) ) ) ) ).

tff(writeUnaryOperator_9660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133820(VarNext)
      <=> v133822(VarNext) ) ) ).

tff(addAssignment_76113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133822(VarNext)
      <=> v133813(VarCurr) ) ) ).

tff(addAssignment_76112,axiom,
    ! [VarCurr: state_type] :
      ( v133813(VarCurr)
    <=> v133815(VarCurr) ) ).

tff(addAssignment_76111,axiom,
    ! [VarCurr: state_type] :
      ( v133815(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76110,axiom,
    ! [VarCurr: state_type] :
      ( v133788(VarCurr,0)
    <=> v133790(VarCurr,0) ) ).

tff(addAssignment_76109,axiom,
    ! [VarCurr: state_type] :
      ( v133790(VarCurr,0)
    <=> v133804(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133804(VarCurr,B)
      <=> ( v133805(VarCurr,B)
          | v133808(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133808(VarCurr,B)
      <=> ( v133776(VarCurr,B)
          & v133809(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133809(VarCurr,B)
      <=> ~ v133810(VarCurr,B) ) ) ).

tff(addAssignment_76108,axiom,
    ! [VarCurr: state_type] :
      ( v133810(VarCurr,0)
    <=> v133811(VarCurr) ) ).

tff(addAssignment_76107,axiom,
    ! [VarCurr: state_type] :
      ( v133810(VarCurr,1)
    <=> v133811(VarCurr) ) ).

tff(addAssignment_76106,axiom,
    ! [VarCurr: state_type] :
      ( v133811(VarCurr)
    <=> v133798(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v133805(VarCurr,B)
      <=> ( v133792(VarCurr,B)
          & v133806(VarCurr,B) ) ) ) ).

tff(addAssignment_76105,axiom,
    ! [VarCurr: state_type] :
      ( v133806(VarCurr,0)
    <=> v133807(VarCurr) ) ).

tff(addAssignment_76104,axiom,
    ! [VarCurr: state_type] :
      ( v133806(VarCurr,1)
    <=> v133807(VarCurr) ) ).

tff(addAssignment_76103,axiom,
    ! [VarCurr: state_type] :
      ( v133807(VarCurr)
    <=> v133798(VarCurr) ) ).

tff(addAssignment_76102,axiom,
    ! [VarCurr: state_type] :
      ( v133798(VarCurr)
    <=> v133800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17290,axiom,
    ! [VarCurr: state_type] :
      ( v133800(VarCurr)
    <=> ( v1729(VarCurr)
        & v133803(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1730,axiom,
    ! [VarCurr: state_type] :
      ( v133803(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1964,axiom,
    ~ b0000011100000(12) ).

tff(bitBlastConstant_1963,axiom,
    ~ b0000011100000(11) ).

tff(bitBlastConstant_1962,axiom,
    ~ b0000011100000(10) ).

tff(bitBlastConstant_1961,axiom,
    ~ b0000011100000(9) ).

tff(bitBlastConstant_1960,axiom,
    ~ b0000011100000(8) ).

tff(bitBlastConstant_1959,axiom,
    b0000011100000(7) ).

tff(bitBlastConstant_1958,axiom,
    b0000011100000(6) ).

tff(bitBlastConstant_1957,axiom,
    b0000011100000(5) ).

tff(bitBlastConstant_1956,axiom,
    ~ b0000011100000(4) ).

tff(bitBlastConstant_1955,axiom,
    ~ b0000011100000(3) ).

tff(bitBlastConstant_1954,axiom,
    ~ b0000011100000(2) ).

tff(bitBlastConstant_1953,axiom,
    ~ b0000011100000(1) ).

tff(bitBlastConstant_1952,axiom,
    ~ b0000011100000(0) ).

tff(addAssignment_76101,axiom,
    ! [VarCurr: state_type] :
      ( v133792(VarCurr,0)
    <=> v133795(VarCurr,0) ) ).

tff(addAssignment_76100,axiom,
    ! [VarCurr: state_type] :
      ( v133795(VarCurr,0)
    <=> v133794(VarCurr,0) ) ).

tff(addAssignment_76099,axiom,
    ! [VarCurr: state_type] :
      ( v133795(VarCurr,1)
    <=> v133796(VarCurr) ) ).

tff(addAssignment_76098,axiom,
    ! [VarCurr: state_type] :
      ( v133794(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_76097,axiom,
    ! [VarCurr: state_type] :
      ( v133784(VarCurr)
    <=> v133786(VarCurr) ) ).

tff(addAssignment_76096,axiom,
    ! [VarCurr: state_type] :
      ( v133786(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76095,axiom,
    ! [VarCurr: state_type] :
      ( v133780(VarCurr)
    <=> v133782(VarCurr) ) ).

tff(addAssignment_76094,axiom,
    ! [VarCurr: state_type] :
      ( v133782(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_76093,axiom,
    ! [VarCurr: state_type] :
      ( v133691(VarCurr,3)
    <=> v133693(VarCurr,3) ) ).

tff(addAssignment_76092,axiom,
    ! [VarCurr: state_type] :
      ( v133693(VarCurr,3)
    <=> v133695(VarCurr,3) ) ).

tff(addAssignment_76091,axiom,
    ! [VarNext: state_type] :
      ( v133695(VarNext,3)
    <=> v133766(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133767(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v133766(VarNext,B)
            <=> v133695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1858,axiom,
    ! [VarNext: state_type] :
      ( v133767(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133766(VarNext,B)
          <=> v133743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133767(VarNext)
      <=> v133768(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133768(VarNext)
      <=> ( v133770(VarNext)
          & v133728(VarNext) ) ) ) ).

tff(writeUnaryOperator_9658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133770(VarNext)
      <=> v133737(VarNext) ) ) ).

tff(addAssignment_76090,axiom,
    ! [VarCurr: state_type] :
      ( v133705(VarCurr,3)
    <=> v133707(VarCurr,3) ) ).

tff(addAssignment_76089,axiom,
    ! [VarCurr: state_type] :
      ( v133707(VarCurr,3)
    <=> v133719(VarCurr,3) ) ).

tff(addAssignment_76088,axiom,
    ! [VarCurr: state_type] :
      ( v133709(VarCurr,3)
    <=> v133711(VarCurr,3) ) ).

tff(addAssignment_76087,axiom,
    ! [VarCurr: state_type] :
      ( v133711(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_76086,axiom,
    ! [VarCurr: state_type] :
      ( v133691(VarCurr,2)
    <=> v133693(VarCurr,2) ) ).

tff(addAssignment_76085,axiom,
    ! [VarCurr: state_type] :
      ( v133693(VarCurr,2)
    <=> v133695(VarCurr,2) ) ).

tff(addAssignment_76084,axiom,
    ! [VarNext: state_type] :
      ( v133695(VarNext,2)
    <=> v133758(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133759(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v133758(VarNext,B)
            <=> v133695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1857,axiom,
    ! [VarNext: state_type] :
      ( v133759(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133758(VarNext,B)
          <=> v133743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133759(VarNext)
      <=> v133760(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133760(VarNext)
      <=> ( v133762(VarNext)
          & v133728(VarNext) ) ) ) ).

tff(writeUnaryOperator_9657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133762(VarNext)
      <=> v133737(VarNext) ) ) ).

tff(addAssignment_76083,axiom,
    ! [VarCurr: state_type] :
      ( v133705(VarCurr,2)
    <=> v133707(VarCurr,2) ) ).

tff(addAssignment_76082,axiom,
    ! [VarCurr: state_type] :
      ( v133707(VarCurr,2)
    <=> v133719(VarCurr,2) ) ).

tff(addAssignment_76081,axiom,
    ! [VarCurr: state_type] :
      ( v133709(VarCurr,2)
    <=> v133711(VarCurr,2) ) ).

tff(addAssignment_76080,axiom,
    ! [VarCurr: state_type] :
      ( v133711(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_76079,axiom,
    ! [VarCurr: state_type] :
      ( v133691(VarCurr,1)
    <=> v133693(VarCurr,1) ) ).

tff(addAssignment_76078,axiom,
    ! [VarCurr: state_type] :
      ( v133693(VarCurr,1)
    <=> v133695(VarCurr,1) ) ).

tff(addAssignment_76077,axiom,
    ! [VarNext: state_type] :
      ( v133695(VarNext,1)
    <=> v133750(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133751(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v133750(VarNext,B)
            <=> v133695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1856,axiom,
    ! [VarNext: state_type] :
      ( v133751(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133750(VarNext,B)
          <=> v133743(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133751(VarNext)
      <=> v133752(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133752(VarNext)
      <=> ( v133754(VarNext)
          & v133728(VarNext) ) ) ) ).

tff(writeUnaryOperator_9656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133754(VarNext)
      <=> v133737(VarNext) ) ) ).

tff(addAssignment_76076,axiom,
    ! [VarCurr: state_type] :
      ( v133705(VarCurr,1)
    <=> v133707(VarCurr,1) ) ).

tff(addAssignment_76075,axiom,
    ! [VarCurr: state_type] :
      ( v133707(VarCurr,1)
    <=> v133719(VarCurr,1) ) ).

tff(addAssignment_76074,axiom,
    ! [VarCurr: state_type] :
      ( v133709(VarCurr,1)
    <=> v133711(VarCurr,1) ) ).

tff(addAssignment_76073,axiom,
    ! [VarCurr: state_type] :
      ( v133711(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_76072,axiom,
    ! [VarCurr: state_type] :
      ( v133691(VarCurr,0)
    <=> v133693(VarCurr,0) ) ).

tff(addAssignment_76071,axiom,
    ! [VarCurr: state_type] :
      ( v133693(VarCurr,0)
    <=> v133695(VarCurr,0) ) ).

tff(addAssignment_76070,axiom,
    ! [VarNext: state_type] :
      ( v133695(VarNext,0)
    <=> v133732(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133733(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v133732(VarNext,B)
            <=> v133695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1855,axiom,
    ! [VarNext: state_type] :
      ( v133733(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133732(VarNext,B)
          <=> v133743(VarNext,B) ) ) ) ).

tff(addAssignment_76069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133743(VarNext,B)
          <=> v133741(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133741(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1336,axiom,
    ! [VarCurr: state_type] :
      ( v133744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v133741(VarCurr,B)
          <=> v133705(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17283,axiom,
    ! [VarCurr: state_type] :
      ( v133744(VarCurr)
    <=> ( v133745(VarCurr)
        & v133746(VarCurr) ) ) ).

tff(writeUnaryOperator_9655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133746(VarCurr)
    <=> v133701(VarCurr) ) ).

tff(writeUnaryOperator_9654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133745(VarCurr)
    <=> v133697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133733(VarNext)
      <=> v133734(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133734(VarNext)
      <=> ( v133735(VarNext)
          & v133728(VarNext) ) ) ) ).

tff(writeUnaryOperator_9653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133735(VarNext)
      <=> v133737(VarNext) ) ) ).

tff(addAssignment_76068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133737(VarNext)
      <=> v133728(VarCurr) ) ) ).

tff(addAssignment_76067,axiom,
    ! [VarCurr: state_type] :
      ( v133728(VarCurr)
    <=> v133730(VarCurr) ) ).

tff(addAssignment_76066,axiom,
    ! [VarCurr: state_type] :
      ( v133730(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_76065,axiom,
    ! [VarCurr: state_type] :
      ( v133705(VarCurr,0)
    <=> v133707(VarCurr,0) ) ).

tff(addAssignment_76064,axiom,
    ! [VarCurr: state_type] :
      ( v133707(VarCurr,0)
    <=> v133719(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133719(VarCurr,B)
      <=> ( v133720(VarCurr,B)
          | v133723(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133723(VarCurr,B)
      <=> ( v133693(VarCurr,B)
          & v133724(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133724(VarCurr,B)
      <=> ~ v133725(VarCurr,B) ) ) ).

tff(addAssignment_76063,axiom,
    ! [VarCurr: state_type] :
      ( v133725(VarCurr,0)
    <=> v133726(VarCurr) ) ).

tff(addAssignment_76062,axiom,
    ! [VarCurr: state_type] :
      ( v133725(VarCurr,1)
    <=> v133726(VarCurr) ) ).

tff(addAssignment_76061,axiom,
    ! [VarCurr: state_type] :
      ( v133725(VarCurr,2)
    <=> v133726(VarCurr) ) ).

tff(addAssignment_76060,axiom,
    ! [VarCurr: state_type] :
      ( v133725(VarCurr,3)
    <=> v133726(VarCurr) ) ).

tff(addAssignment_76059,axiom,
    ! [VarCurr: state_type] :
      ( v133726(VarCurr)
    <=> v133713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v133720(VarCurr,B)
      <=> ( v133709(VarCurr,B)
          & v133721(VarCurr,B) ) ) ) ).

tff(addAssignment_76058,axiom,
    ! [VarCurr: state_type] :
      ( v133721(VarCurr,0)
    <=> v133722(VarCurr) ) ).

tff(addAssignment_76057,axiom,
    ! [VarCurr: state_type] :
      ( v133721(VarCurr,1)
    <=> v133722(VarCurr) ) ).

tff(addAssignment_76056,axiom,
    ! [VarCurr: state_type] :
      ( v133721(VarCurr,2)
    <=> v133722(VarCurr) ) ).

tff(addAssignment_76055,axiom,
    ! [VarCurr: state_type] :
      ( v133721(VarCurr,3)
    <=> v133722(VarCurr) ) ).

tff(addAssignment_76054,axiom,
    ! [VarCurr: state_type] :
      ( v133722(VarCurr)
    <=> v133713(VarCurr) ) ).

tff(addAssignment_76053,axiom,
    ! [VarCurr: state_type] :
      ( v133713(VarCurr)
    <=> v133715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17280,axiom,
    ! [VarCurr: state_type] :
      ( v133715(VarCurr)
    <=> ( v1729(VarCurr)
        & v133718(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1729,axiom,
    ! [VarCurr: state_type] :
      ( v133718(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1951,axiom,
    ~ b0000010011000(12) ).

tff(bitBlastConstant_1950,axiom,
    ~ b0000010011000(11) ).

tff(bitBlastConstant_1949,axiom,
    ~ b0000010011000(10) ).

tff(bitBlastConstant_1948,axiom,
    ~ b0000010011000(9) ).

tff(bitBlastConstant_1947,axiom,
    ~ b0000010011000(8) ).

tff(bitBlastConstant_1946,axiom,
    b0000010011000(7) ).

tff(bitBlastConstant_1945,axiom,
    ~ b0000010011000(6) ).

tff(bitBlastConstant_1944,axiom,
    ~ b0000010011000(5) ).

tff(bitBlastConstant_1943,axiom,
    b0000010011000(4) ).

tff(bitBlastConstant_1942,axiom,
    b0000010011000(3) ).

tff(bitBlastConstant_1941,axiom,
    ~ b0000010011000(2) ).

tff(bitBlastConstant_1940,axiom,
    ~ b0000010011000(1) ).

tff(bitBlastConstant_1939,axiom,
    ~ b0000010011000(0) ).

tff(addAssignment_76052,axiom,
    ! [VarCurr: state_type] :
      ( v133709(VarCurr,0)
    <=> v133711(VarCurr,0) ) ).

tff(addAssignment_76051,axiom,
    ! [VarCurr: state_type] :
      ( v133711(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_76050,axiom,
    ! [VarCurr: state_type] :
      ( v133701(VarCurr)
    <=> v133703(VarCurr) ) ).

tff(addAssignment_76049,axiom,
    ! [VarCurr: state_type] :
      ( v133703(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_76048,axiom,
    ! [VarCurr: state_type] :
      ( v133697(VarCurr)
    <=> v133699(VarCurr) ) ).

tff(addAssignment_76047,axiom,
    ! [VarCurr: state_type] :
      ( v133699(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_76046,axiom,
    ! [VarCurr: state_type] :
      ( v133675(VarCurr)
    <=> v133677(VarCurr) ) ).

tff(addAssignment_76045,axiom,
    ! [VarCurr: state_type] :
      ( v133677(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_76044,axiom,
    ! [VarCurr: state_type] :
      ( v133671(VarCurr)
    <=> v133673(VarCurr) ) ).

tff(addAssignment_76043,axiom,
    ! [VarCurr: state_type] :
      ( v133673(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_76042,axiom,
    ! [VarCurr: state_type] :
      ( v89156(VarCurr,0)
    <=> v89158(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1728,axiom,
    ! [VarCurr: state_type] :
      ( v89158(VarCurr)
    <=> ( v89160(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_76041,axiom,
    ! [VarCurr: state_type] :
      ( v89160(VarCurr)
    <=> v89162(VarCurr) ) ).

tff(addAssignment_76040,axiom,
    ! [VarCurr: state_type] :
      ( v89162(VarCurr)
    <=> v89164(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133643(VarNext)
       => ( v89164(VarNext)
        <=> v89164(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1854,axiom,
    ! [VarNext: state_type] :
      ( v133643(VarNext)
     => ( v89164(VarNext)
      <=> v133653(VarNext) ) ) ).

tff(addAssignment_76039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133653(VarNext)
      <=> v133651(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133654(VarCurr)
     => ( v133651(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1335,axiom,
    ! [VarCurr: state_type] :
      ( v133654(VarCurr)
     => ( v133651(VarCurr)
      <=> v89182(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17279,axiom,
    ! [VarCurr: state_type] :
      ( v133654(VarCurr)
    <=> ( v133655(VarCurr)
        & v133656(VarCurr) ) ) ).

tff(writeUnaryOperator_9651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133656(VarCurr)
    <=> v89174(VarCurr) ) ).

tff(writeUnaryOperator_9650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133655(VarCurr)
    <=> v89166(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133643(VarNext)
      <=> v133644(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133644(VarNext)
      <=> ( v133645(VarNext)
          & v133638(VarNext) ) ) ) ).

tff(writeUnaryOperator_9649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133645(VarNext)
      <=> v133647(VarNext) ) ) ).

tff(addAssignment_76038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133647(VarNext)
      <=> v133638(VarCurr) ) ) ).

tff(addAssignment_76037,axiom,
    ! [VarCurr: state_type] :
      ( v133638(VarCurr)
    <=> v133640(VarCurr) ) ).

tff(addAssignment_76036,axiom,
    ! [VarCurr: state_type] :
      ( v133640(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_76035,axiom,
    ! [VarCurr: state_type] :
      ( v89182(VarCurr)
    <=> v89184(VarCurr) ) ).

tff(addAssignment_76034,axiom,
    ! [VarCurr: state_type] :
      ( v89184(VarCurr)
    <=> v89186(VarCurr) ) ).

tff(addAssignment_76033,axiom,
    ! [VarCurr: state_type] :
      ( v89186(VarCurr)
    <=> v89188(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133632(VarCurr)
     => ( v89188(VarCurr)
      <=> v133633(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1334,axiom,
    ! [VarCurr: state_type] :
      ( v133632(VarCurr)
     => ( v89188(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133634(VarCurr)
     => ( v133633(VarCurr)
      <=> v133635(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1333,axiom,
    ! [VarCurr: state_type] :
      ( v133634(VarCurr)
     => ( v133633(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_9648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133635(VarCurr)
    <=> v89160(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1727,axiom,
    ! [VarCurr: state_type] :
      ( v133634(VarCurr)
    <=> ( v89160(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17276,axiom,
    ! [VarCurr: state_type] :
      ( v133632(VarCurr)
    <=> ( v89190(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(addAssignment_76032,axiom,
    ! [VarCurr: state_type] :
      ( v89190(VarCurr)
    <=> v89192(VarCurr,2) ) ).

tff(addAssignment_76031,axiom,
    ! [VarCurr: state_type] :
      ( v89192(VarCurr,2)
    <=> v89194(VarCurr,2) ) ).

tff(addAssignment_76030,axiom,
    ! [VarNext: state_type] :
      ( v89194(VarNext,2)
    <=> v133624(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1853,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133625(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v133624(VarNext,B)
            <=> v89194(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1853,axiom,
    ! [VarNext: state_type] :
      ( v133625(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v133624(VarNext,B)
          <=> v103084(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133625(VarNext)
      <=> v133626(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133626(VarNext)
      <=> ( v133628(VarNext)
          & v103069(VarNext) ) ) ) ).

tff(writeUnaryOperator_9647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133628(VarNext)
      <=> v103078(VarNext) ) ) ).

tff(addAssignment_76029,axiom,
    ! [VarCurr: state_type] :
      ( v89204(VarCurr,2)
    <=> v89206(VarCurr,2) ) ).

tff(addAssignment_76028,axiom,
    ! [VarCurr: state_type] :
      ( v89206(VarCurr,2)
    <=> v89208(VarCurr,2) ) ).

tff(addAssignment_76027,axiom,
    ! [VarCurr: state_type] :
      ( v89208(VarCurr,2)
    <=> v103066(VarCurr,2) ) ).

tff(addAssignment_76026,axiom,
    ! [VarCurr: state_type] :
      ( v89210(VarCurr)
    <=> v89212(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17273,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,0)
    <=> ( v133613(VarCurr)
        | v133621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17272,axiom,
    ! [VarCurr: state_type] :
      ( v133621(VarCurr)
    <=> ( v82954(VarCurr)
        & v133622(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1726,axiom,
    ! [VarCurr: state_type] :
      ( v133622(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17271,axiom,
    ! [VarCurr: state_type] :
      ( v133613(VarCurr)
    <=> ( v133614(VarCurr)
        | v133619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17270,axiom,
    ! [VarCurr: state_type] :
      ( v133619(VarCurr)
    <=> ( v86877(VarCurr)
        & v133620(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1725,axiom,
    ! [VarCurr: state_type] :
      ( v133620(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17269,axiom,
    ! [VarCurr: state_type] :
      ( v133614(VarCurr)
    <=> ( v133615(VarCurr)
        | v133617(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17268,axiom,
    ! [VarCurr: state_type] :
      ( v133617(VarCurr)
    <=> ( v84899(VarCurr)
        & v133618(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1724,axiom,
    ! [VarCurr: state_type] :
      ( v133618(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $false )
        & ( v89243(VarCurr,5)
        <=> $false )
        & ( v89243(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17267,axiom,
    ! [VarCurr: state_type] :
      ( v133615(VarCurr)
    <=> ( v118(VarCurr)
        & v133616(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1723,axiom,
    ! [VarCurr: state_type] :
      ( v133616(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $false )
        & ( v89214(VarCurr,5)
        <=> $false )
        & ( v89214(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_76025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v89243(VarCurr,B)
      <=> v89245(VarCurr,B) ) ) ).

tff(addAssignment_76024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v89245(VarCurr,B)
      <=> v89247(VarCurr,B) ) ) ).

tff(addAssignment_76023,axiom,
    ! [VarCurr: state_type] :
      ( ( v89247(VarCurr,6)
      <=> v109609(VarCurr,2) )
      & ( v89247(VarCurr,5)
      <=> v109609(VarCurr,1) )
      & ( v89247(VarCurr,4)
      <=> v109609(VarCurr,0) ) ) ).

tff(addAssignment_76022,axiom,
    ! [VarCurr: state_type] :
      ( v109486(VarCurr,5)
    <=> v109488(VarCurr,5) ) ).

tff(addAssignment_76021,axiom,
    ! [VarCurr: state_type] :
      ( v109488(VarCurr,5)
    <=> v109490(VarCurr,5) ) ).

tff(addAssignment_76020,axiom,
    ! [VarNext: state_type] :
      ( v109490(VarNext,5)
    <=> v133605(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133606(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133605(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1852,axiom,
    ! [VarNext: state_type] :
      ( v133606(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133605(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133606(VarNext)
      <=> v133607(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133607(VarNext)
      <=> ( v133609(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_9646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133609(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_76019,axiom,
    ! [VarCurr: state_type] :
      ( v109500(VarCurr,5)
    <=> v109502(VarCurr,5) ) ).

tff(addAssignment_76018,axiom,
    ! [VarCurr: state_type] :
      ( v109502(VarCurr,5)
    <=> v109515(VarCurr,5) ) ).

tff(addAssignment_76017,axiom,
    ! [VarCurr: state_type] :
      ( v109504(VarCurr,5)
    <=> v109506(VarCurr,5) ) ).

tff(addAssignment_76016,axiom,
    ! [VarCurr: state_type] :
      ( v109506(VarCurr,5)
    <=> v109507(VarCurr,5) ) ).

tff(addAssignment_76015,axiom,
    ! [VarCurr: state_type] :
      ( v109425(VarCurr,5)
    <=> v109427(VarCurr,5) ) ).

tff(addAssignment_76014,axiom,
    ! [VarCurr: state_type] :
      ( v109427(VarCurr,5)
    <=> v109429(VarCurr,5) ) ).

tff(addAssignment_76013,axiom,
    ! [VarNext: state_type] :
      ( v109429(VarNext,5)
    <=> v133597(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1851,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133598(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133597(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1851,axiom,
    ! [VarNext: state_type] :
      ( v133598(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133597(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133598(VarNext)
      <=> v133599(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133599(VarNext)
      <=> ( v133601(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133601(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_76012,axiom,
    ! [VarCurr: state_type] :
      ( v109439(VarCurr,5)
    <=> v109441(VarCurr,5) ) ).

tff(addAssignment_76011,axiom,
    ! [VarCurr: state_type] :
      ( v109441(VarCurr,5)
    <=> v109455(VarCurr,5) ) ).

tff(addAssignment_76010,axiom,
    ! [VarCurr: state_type] :
      ( v109443(VarCurr,5)
    <=> v109445(VarCurr,5) ) ).

tff(addAssignment_76009,axiom,
    ! [VarCurr: state_type] :
      ( v109445(VarCurr,5)
    <=> v109446(VarCurr,5) ) ).

tff(addAssignment_76008,axiom,
    ! [VarCurr: state_type] :
      ( v109364(VarCurr,5)
    <=> v109366(VarCurr,5) ) ).

tff(addAssignment_76007,axiom,
    ! [VarCurr: state_type] :
      ( v109366(VarCurr,5)
    <=> v109368(VarCurr,5) ) ).

tff(addAssignment_76006,axiom,
    ! [VarNext: state_type] :
      ( v109368(VarNext,5)
    <=> v133589(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133590(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133589(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1850,axiom,
    ! [VarNext: state_type] :
      ( v133590(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133589(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133590(VarNext)
      <=> v133591(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133591(VarNext)
      <=> ( v133593(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_9644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133593(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_76005,axiom,
    ! [VarCurr: state_type] :
      ( v109378(VarCurr,5)
    <=> v109380(VarCurr,5) ) ).

tff(addAssignment_76004,axiom,
    ! [VarCurr: state_type] :
      ( v109380(VarCurr,5)
    <=> v109394(VarCurr,5) ) ).

tff(addAssignment_76003,axiom,
    ! [VarCurr: state_type] :
      ( v109382(VarCurr,5)
    <=> v109384(VarCurr,5) ) ).

tff(addAssignment_76002,axiom,
    ! [VarCurr: state_type] :
      ( v109384(VarCurr,5)
    <=> v109385(VarCurr,5) ) ).

tff(addAssignment_76001,axiom,
    ! [VarCurr: state_type] :
      ( v109303(VarCurr,5)
    <=> v109305(VarCurr,5) ) ).

tff(addAssignment_76000,axiom,
    ! [VarCurr: state_type] :
      ( v109305(VarCurr,5)
    <=> v109307(VarCurr,5) ) ).

tff(addAssignment_75999,axiom,
    ! [VarNext: state_type] :
      ( v109307(VarNext,5)
    <=> v133581(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133582(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133581(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1849,axiom,
    ! [VarNext: state_type] :
      ( v133582(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133581(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133582(VarNext)
      <=> v133583(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133583(VarNext)
      <=> ( v133585(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_9643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133585(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_75998,axiom,
    ! [VarCurr: state_type] :
      ( v109317(VarCurr,5)
    <=> v109319(VarCurr,5) ) ).

tff(addAssignment_75997,axiom,
    ! [VarCurr: state_type] :
      ( v109319(VarCurr,5)
    <=> v109333(VarCurr,5) ) ).

tff(addAssignment_75996,axiom,
    ! [VarCurr: state_type] :
      ( v109321(VarCurr,5)
    <=> v109323(VarCurr,5) ) ).

tff(addAssignment_75995,axiom,
    ! [VarCurr: state_type] :
      ( v109323(VarCurr,5)
    <=> v109324(VarCurr,5) ) ).

tff(addAssignment_75994,axiom,
    ! [VarCurr: state_type] :
      ( v109242(VarCurr,5)
    <=> v109244(VarCurr,5) ) ).

tff(addAssignment_75993,axiom,
    ! [VarCurr: state_type] :
      ( v109244(VarCurr,5)
    <=> v109246(VarCurr,5) ) ).

tff(addAssignment_75992,axiom,
    ! [VarNext: state_type] :
      ( v109246(VarNext,5)
    <=> v133573(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133574(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133573(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1848,axiom,
    ! [VarNext: state_type] :
      ( v133574(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133573(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133574(VarNext)
      <=> v133575(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133575(VarNext)
      <=> ( v133577(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_9642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133577(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_75991,axiom,
    ! [VarCurr: state_type] :
      ( v109256(VarCurr,5)
    <=> v109258(VarCurr,5) ) ).

tff(addAssignment_75990,axiom,
    ! [VarCurr: state_type] :
      ( v109258(VarCurr,5)
    <=> v109272(VarCurr,5) ) ).

tff(addAssignment_75989,axiom,
    ! [VarCurr: state_type] :
      ( v109260(VarCurr,5)
    <=> v109262(VarCurr,5) ) ).

tff(addAssignment_75988,axiom,
    ! [VarCurr: state_type] :
      ( v109262(VarCurr,5)
    <=> v109263(VarCurr,5) ) ).

tff(addAssignment_75987,axiom,
    ! [VarCurr: state_type] :
      ( v109181(VarCurr,5)
    <=> v109183(VarCurr,5) ) ).

tff(addAssignment_75986,axiom,
    ! [VarCurr: state_type] :
      ( v109183(VarCurr,5)
    <=> v109185(VarCurr,5) ) ).

tff(addAssignment_75985,axiom,
    ! [VarNext: state_type] :
      ( v109185(VarNext,5)
    <=> v133565(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133566(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133565(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1847,axiom,
    ! [VarNext: state_type] :
      ( v133566(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133565(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133566(VarNext)
      <=> v133567(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133567(VarNext)
      <=> ( v133569(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_9641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133569(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_75984,axiom,
    ! [VarCurr: state_type] :
      ( v109195(VarCurr,5)
    <=> v109197(VarCurr,5) ) ).

tff(addAssignment_75983,axiom,
    ! [VarCurr: state_type] :
      ( v109197(VarCurr,5)
    <=> v109211(VarCurr,5) ) ).

tff(addAssignment_75982,axiom,
    ! [VarCurr: state_type] :
      ( v109199(VarCurr,5)
    <=> v109201(VarCurr,5) ) ).

tff(addAssignment_75981,axiom,
    ! [VarCurr: state_type] :
      ( v109201(VarCurr,5)
    <=> v109202(VarCurr,5) ) ).

tff(addAssignment_75980,axiom,
    ! [VarCurr: state_type] :
      ( v109114(VarCurr,5)
    <=> v109116(VarCurr,5) ) ).

tff(addAssignment_75979,axiom,
    ! [VarCurr: state_type] :
      ( v109116(VarCurr,5)
    <=> v109118(VarCurr,5) ) ).

tff(addAssignment_75978,axiom,
    ! [VarNext: state_type] :
      ( v109118(VarNext,5)
    <=> v133557(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133557(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1846,axiom,
    ! [VarNext: state_type] :
      ( v133558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133557(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133558(VarNext)
      <=> v133559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133559(VarNext)
      <=> ( v133561(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_9640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133561(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_75977,axiom,
    ! [VarCurr: state_type] :
      ( v109128(VarCurr,5)
    <=> v109130(VarCurr,5) ) ).

tff(addAssignment_75976,axiom,
    ! [VarCurr: state_type] :
      ( v109130(VarCurr,5)
    <=> v109150(VarCurr,5) ) ).

tff(addAssignment_75975,axiom,
    ! [VarCurr: state_type] :
      ( v109132(VarCurr,5)
    <=> v109134(VarCurr,5) ) ).

tff(addAssignment_75974,axiom,
    ! [VarCurr: state_type] :
      ( v109134(VarCurr,5)
    <=> v109135(VarCurr,5) ) ).

tff(addAssignment_75973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89253(VarCurr,B)
      <=> v89255(VarCurr,B) ) ) ).

tff(addAssignment_75972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89255(VarCurr,B)
      <=> v89257(VarCurr,B) ) ) ).

tff(addAssignment_75971,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89257(VarNext,B)
      <=> v133549(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133550(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v133549(VarNext,B)
            <=> v89257(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1845,axiom,
    ! [VarNext: state_type] :
      ( v133550(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v133549(VarNext,B)
          <=> v109107(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133550(VarNext)
      <=> v133551(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133551(VarNext)
      <=> ( v133553(VarNext)
          & v109092(VarNext) ) ) ) ).

tff(writeUnaryOperator_9639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133553(VarNext)
      <=> v109101(VarNext) ) ) ).

tff(addAssignment_75970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89267(VarCurr,B)
      <=> v89269(VarCurr,B) ) ) ).

tff(addAssignment_75969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89269(VarCurr,B)
      <=> v109083(VarCurr,B) ) ) ).

tff(addAssignment_75968,axiom,
    ! [VarCurr: state_type] :
      ( v89337(VarCurr)
    <=> v89339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17250,axiom,
    ! [VarCurr: state_type] :
      ( v89339(VarCurr)
    <=> ( v133544(VarCurr)
        | v133546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5953,axiom,
    ! [VarCurr: state_type] :
      ( v133546(VarCurr)
    <=> ( v109144(VarCurr)
        | v89383(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5952,axiom,
    ! [VarCurr: state_type] :
      ( v109144(VarCurr)
    <=> ( v109145(VarCurr)
        | v89383(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17249,axiom,
    ! [VarCurr: state_type] :
      ( v133544(VarCurr)
    <=> ( v133545(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_9638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133545(VarCurr)
    <=> v134(VarCurr,7) ) ).

tff(addAssignment_75967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89383(VarCurr,B)
      <=> v89385(VarCurr,B) ) ) ).

tff(addAssignment_75966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89385(VarCurr,B)
      <=> v89387(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133527(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v89387(VarNext,B)
            <=> v89387(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1844,axiom,
    ! [VarNext: state_type] :
      ( v133527(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v89387(VarNext,B)
          <=> v133537(VarNext,B) ) ) ) ).

tff(addAssignment_75965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v133537(VarNext,B)
          <=> v133535(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133538(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v133535(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1332,axiom,
    ! [VarCurr: state_type] :
      ( v133538(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v133535(VarCurr,B)
          <=> v89397(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17248,axiom,
    ! [VarCurr: state_type] :
      ( v133538(VarCurr)
    <=> ( v133539(VarCurr)
        & v133540(VarCurr) ) ) ).

tff(writeUnaryOperator_9637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133540(VarCurr)
    <=> v89393(VarCurr) ) ).

tff(writeUnaryOperator_9636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133539(VarCurr)
    <=> v89389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133527(VarNext)
      <=> v133528(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133528(VarNext)
      <=> ( v133529(VarNext)
          & v133522(VarNext) ) ) ) ).

tff(writeUnaryOperator_9635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133529(VarNext)
      <=> v133531(VarNext) ) ) ).

tff(addAssignment_75964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133531(VarNext)
      <=> v133522(VarCurr) ) ) ).

tff(addAssignment_75963,axiom,
    ! [VarCurr: state_type] :
      ( v133522(VarCurr)
    <=> v133524(VarCurr) ) ).

tff(addAssignment_75962,axiom,
    ! [VarCurr: state_type] :
      ( v133524(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_75961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89397(VarCurr,B)
      <=> v89399(VarCurr,B) ) ) ).

tff(addAssignment_75960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89399(VarCurr,B)
      <=> v89401(VarCurr,B) ) ) ).

tff(addAssignment_75959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89401(VarCurr,B)
      <=> v89403(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89403(VarCurr,B)
      <=> ( v89249(VarCurr,B)
          & v133518(VarCurr,B) ) ) ) ).

tff(addAssignment_75958,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,0)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75957,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,1)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75956,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,2)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75955,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,3)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75954,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,4)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75953,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,5)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75952,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,6)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75951,axiom,
    ! [VarCurr: state_type] :
      ( v133518(VarCurr,7)
    <=> v133519(VarCurr) ) ).

tff(addAssignment_75950,axiom,
    ! [VarCurr: state_type] :
      ( v133519(VarCurr)
    <=> v133520(VarCurr) ) ).

tff(writeUnaryOperator_9634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133520(VarCurr)
    <=> v89405(VarCurr) ) ).

tff(addAssignment_75949,axiom,
    ! [VarCurr: state_type] :
      ( v89405(VarCurr)
    <=> v89407(VarCurr) ) ).

tff(addAssignment_75948,axiom,
    ! [VarCurr: state_type] :
      ( v89407(VarCurr)
    <=> v89409(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5951,axiom,
    ! [VarCurr: state_type] :
      ( v89409(VarCurr)
    <=> ( v133511(VarCurr)
        | v89411(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5950,axiom,
    ! [VarCurr: state_type] :
      ( v133511(VarCurr)
    <=> ( v133512(VarCurr)
        | v89411(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5949,axiom,
    ! [VarCurr: state_type] :
      ( v133512(VarCurr)
    <=> ( v133513(VarCurr)
        | v89411(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5948,axiom,
    ! [VarCurr: state_type] :
      ( v133513(VarCurr)
    <=> ( v133514(VarCurr)
        | v89411(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5947,axiom,
    ! [VarCurr: state_type] :
      ( v133514(VarCurr)
    <=> ( v133515(VarCurr)
        | v89411(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5946,axiom,
    ! [VarCurr: state_type] :
      ( v133515(VarCurr)
    <=> ( v133516(VarCurr)
        | v89411(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5945,axiom,
    ! [VarCurr: state_type] :
      ( v133516(VarCurr)
    <=> ( v89411(VarCurr,0)
        | v89411(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89411(VarCurr,B)
      <=> ( v89413(VarCurr,B)
          & v133508(VarCurr,B) ) ) ) ).

tff(addAssignment_75947,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,0)
    <=> v133349(VarCurr) ) ).

tff(addAssignment_75946,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,1)
    <=> v133190(VarCurr) ) ).

tff(addAssignment_75945,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,2)
    <=> v133031(VarCurr) ) ).

tff(addAssignment_75944,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,3)
    <=> v132872(VarCurr) ) ).

tff(addAssignment_75943,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,4)
    <=> v132713(VarCurr) ) ).

tff(addAssignment_75942,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,5)
    <=> v132554(VarCurr) ) ).

tff(addAssignment_75941,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,6)
    <=> v132395(VarCurr) ) ).

tff(addAssignment_75940,axiom,
    ! [VarCurr: state_type] :
      ( v133508(VarCurr,7)
    <=> v130130(VarCurr) ) ).

tff(addAssignment_75939,axiom,
    ! [VarCurr: state_type] :
      ( v133349(VarCurr)
    <=> v133351(VarCurr) ) ).

tff(addAssignment_75938,axiom,
    ! [VarCurr: state_type] :
      ( v133351(VarCurr)
    <=> v133353(VarCurr) ) ).

tff(addAssignment_75937,axiom,
    ! [VarCurr: state_type] :
      ( v133353(VarCurr)
    <=> v133355(VarCurr) ) ).

tff(addAssignment_75936,axiom,
    ! [VarCurr: state_type] :
      ( v133355(VarCurr)
    <=> v133357(VarCurr) ) ).

tff(addAssignment_75935,axiom,
    ! [VarCurr: state_type] :
      ( v133357(VarCurr)
    <=> v133359(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1722,axiom,
    ! [VarCurr: state_type] :
      ( v133359(VarCurr)
    <=> ( ( v133361(VarCurr,31)
        <=> v133366(VarCurr,31) )
        & ( v133361(VarCurr,30)
        <=> v133366(VarCurr,30) )
        & ( v133361(VarCurr,29)
        <=> v133366(VarCurr,29) )
        & ( v133361(VarCurr,28)
        <=> v133366(VarCurr,28) )
        & ( v133361(VarCurr,27)
        <=> v133366(VarCurr,27) )
        & ( v133361(VarCurr,26)
        <=> v133366(VarCurr,26) )
        & ( v133361(VarCurr,25)
        <=> v133366(VarCurr,25) )
        & ( v133361(VarCurr,24)
        <=> v133366(VarCurr,24) )
        & ( v133361(VarCurr,23)
        <=> v133366(VarCurr,23) )
        & ( v133361(VarCurr,22)
        <=> v133366(VarCurr,22) )
        & ( v133361(VarCurr,21)
        <=> v133366(VarCurr,21) )
        & ( v133361(VarCurr,20)
        <=> v133366(VarCurr,20) )
        & ( v133361(VarCurr,19)
        <=> v133366(VarCurr,19) )
        & ( v133361(VarCurr,18)
        <=> v133366(VarCurr,18) )
        & ( v133361(VarCurr,17)
        <=> v133366(VarCurr,17) )
        & ( v133361(VarCurr,16)
        <=> v133366(VarCurr,16) )
        & ( v133361(VarCurr,15)
        <=> v133366(VarCurr,15) )
        & ( v133361(VarCurr,14)
        <=> v133366(VarCurr,14) )
        & ( v133361(VarCurr,13)
        <=> v133366(VarCurr,13) )
        & ( v133361(VarCurr,12)
        <=> v133366(VarCurr,12) )
        & ( v133361(VarCurr,11)
        <=> v133366(VarCurr,11) )
        & ( v133361(VarCurr,10)
        <=> v133366(VarCurr,10) )
        & ( v133361(VarCurr,9)
        <=> v133366(VarCurr,9) )
        & ( v133361(VarCurr,8)
        <=> v133366(VarCurr,8) )
        & ( v133361(VarCurr,7)
        <=> v133366(VarCurr,7) )
        & ( v133361(VarCurr,6)
        <=> v133366(VarCurr,6) )
        & ( v133361(VarCurr,5)
        <=> v133366(VarCurr,5) )
        & ( v133361(VarCurr,4)
        <=> v133366(VarCurr,4) )
        & ( v133361(VarCurr,3)
        <=> v133366(VarCurr,3) )
        & ( v133361(VarCurr,2)
        <=> v133366(VarCurr,2) )
        & ( v133361(VarCurr,1)
        <=> v133366(VarCurr,1) )
        & ( v133361(VarCurr,0)
        <=> v133366(VarCurr,0) ) ) ) ).

tff(addAssignment_75934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133366(VarCurr,B)
      <=> v133368(VarCurr,B) ) ) ).

tff(addAssignment_75933,axiom,
    ! [VarCurr: state_type] :
      ( ( v133368(VarCurr,8)
      <=> v133496(VarCurr,10) )
      & ( v133368(VarCurr,7)
      <=> v133496(VarCurr,9) )
      & ( v133368(VarCurr,6)
      <=> v133496(VarCurr,8) )
      & ( v133368(VarCurr,5)
      <=> v133496(VarCurr,7) )
      & ( v133368(VarCurr,4)
      <=> v133496(VarCurr,6) )
      & ( v133368(VarCurr,3)
      <=> v133496(VarCurr,5) )
      & ( v133368(VarCurr,2)
      <=> v133496(VarCurr,4) )
      & ( v133368(VarCurr,1)
      <=> v133496(VarCurr,3) )
      & ( v133368(VarCurr,0)
      <=> v133496(VarCurr,2) ) ) ).

tff(addAssignment_75932,axiom,
    ! [VarCurr: state_type] :
      ( ( v133368(VarCurr,23)
      <=> v133486(VarCurr,14) )
      & ( v133368(VarCurr,22)
      <=> v133486(VarCurr,13) )
      & ( v133368(VarCurr,21)
      <=> v133486(VarCurr,12) )
      & ( v133368(VarCurr,20)
      <=> v133486(VarCurr,11) )
      & ( v133368(VarCurr,19)
      <=> v133486(VarCurr,10) )
      & ( v133368(VarCurr,18)
      <=> v133486(VarCurr,9) )
      & ( v133368(VarCurr,17)
      <=> v133486(VarCurr,8) )
      & ( v133368(VarCurr,16)
      <=> v133486(VarCurr,7) )
      & ( v133368(VarCurr,15)
      <=> v133486(VarCurr,6) )
      & ( v133368(VarCurr,14)
      <=> v133486(VarCurr,5) )
      & ( v133368(VarCurr,13)
      <=> v133486(VarCurr,4) )
      & ( v133368(VarCurr,12)
      <=> v133486(VarCurr,3) )
      & ( v133368(VarCurr,11)
      <=> v133486(VarCurr,2) )
      & ( v133368(VarCurr,10)
      <=> v133486(VarCurr,1) )
      & ( v133368(VarCurr,9)
      <=> v133486(VarCurr,0) ) ) ).

tff(addAssignment_75931,axiom,
    ! [VarCurr: state_type] :
      ( ( v133368(VarCurr,26)
      <=> v133476(VarCurr,2) )
      & ( v133368(VarCurr,25)
      <=> v133476(VarCurr,1) )
      & ( v133368(VarCurr,24)
      <=> v133476(VarCurr,0) ) ) ).

tff(addAssignment_75930,axiom,
    ! [VarCurr: state_type] :
      ( ( v133368(VarCurr,30)
      <=> v133370(VarCurr,3) )
      & ( v133368(VarCurr,29)
      <=> v133370(VarCurr,2) )
      & ( v133368(VarCurr,28)
      <=> v133370(VarCurr,1) )
      & ( v133368(VarCurr,27)
      <=> v133370(VarCurr,0) ) ) ).

tff(addAssignment_75929,axiom,
    ! [VarCurr: state_type] :
      ( v133368(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133496(VarCurr,B)
      <=> v133372(VarCurr,B) ) ) ).

tff(addAssignment_75927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133372(VarCurr,B)
      <=> v133374(VarCurr,B) ) ) ).

tff(addAssignment_75926,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133374(VarNext,B)
      <=> v133498(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133499(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133498(VarNext,B)
            <=> v133374(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1843,axiom,
    ! [VarNext: state_type] :
      ( v133499(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133498(VarNext,B)
          <=> v133469(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133499(VarNext)
      <=> v133500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133500(VarNext)
      <=> ( v133502(VarNext)
          & v133401(VarNext) ) ) ) ).

tff(writeUnaryOperator_9633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133502(VarNext)
      <=> v133463(VarNext) ) ) ).

tff(addAssignment_75925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133396(VarCurr,B)
      <=> v133398(VarCurr,B) ) ) ).

tff(addAssignment_75924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133398(VarCurr,B)
      <=> v133399(VarCurr,B) ) ) ).

tff(addAssignment_75923,axiom,
    ! [VarCurr: state_type] :
      ( ( v133486(VarCurr,14)
      <=> v133372(VarCurr,25) )
      & ( v133486(VarCurr,13)
      <=> v133372(VarCurr,24) )
      & ( v133486(VarCurr,12)
      <=> v133372(VarCurr,23) )
      & ( v133486(VarCurr,11)
      <=> v133372(VarCurr,22) )
      & ( v133486(VarCurr,10)
      <=> v133372(VarCurr,21) )
      & ( v133486(VarCurr,9)
      <=> v133372(VarCurr,20) )
      & ( v133486(VarCurr,8)
      <=> v133372(VarCurr,19) )
      & ( v133486(VarCurr,7)
      <=> v133372(VarCurr,18) )
      & ( v133486(VarCurr,6)
      <=> v133372(VarCurr,17) )
      & ( v133486(VarCurr,5)
      <=> v133372(VarCurr,16) )
      & ( v133486(VarCurr,4)
      <=> v133372(VarCurr,15) )
      & ( v133486(VarCurr,3)
      <=> v133372(VarCurr,14) )
      & ( v133486(VarCurr,2)
      <=> v133372(VarCurr,13) )
      & ( v133486(VarCurr,1)
      <=> v133372(VarCurr,12) )
      & ( v133486(VarCurr,0)
      <=> v133372(VarCurr,11) ) ) ).

tff(addAssignment_75922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133372(VarCurr,B)
      <=> v133374(VarCurr,B) ) ) ).

tff(addAssignment_75921,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133374(VarNext,B)
      <=> v133488(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133489(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133488(VarNext,B)
            <=> v133374(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1842,axiom,
    ! [VarNext: state_type] :
      ( v133489(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133488(VarNext,B)
          <=> v133469(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133489(VarNext)
      <=> v133490(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133490(VarNext)
      <=> ( v133492(VarNext)
          & v133401(VarNext) ) ) ) ).

tff(writeUnaryOperator_9632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133492(VarNext)
      <=> v133463(VarNext) ) ) ).

tff(addAssignment_75920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133396(VarCurr,B)
      <=> v133398(VarCurr,B) ) ) ).

tff(addAssignment_75919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133398(VarCurr,B)
      <=> v133399(VarCurr,B) ) ) ).

tff(addAssignment_75918,axiom,
    ! [VarCurr: state_type] :
      ( ( v133476(VarCurr,2)
      <=> v133372(VarCurr,28) )
      & ( v133476(VarCurr,1)
      <=> v133372(VarCurr,27) )
      & ( v133476(VarCurr,0)
      <=> v133372(VarCurr,26) ) ) ).

tff(addAssignment_75917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133372(VarCurr,B)
      <=> v133374(VarCurr,B) ) ) ).

tff(addAssignment_75916,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133374(VarNext,B)
      <=> v133478(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133479(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133478(VarNext,B)
            <=> v133374(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1841,axiom,
    ! [VarNext: state_type] :
      ( v133479(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133478(VarNext,B)
          <=> v133469(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133479(VarNext)
      <=> v133480(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133480(VarNext)
      <=> ( v133482(VarNext)
          & v133401(VarNext) ) ) ) ).

tff(writeUnaryOperator_9631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133482(VarNext)
      <=> v133463(VarNext) ) ) ).

tff(addAssignment_75915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133396(VarCurr,B)
      <=> v133398(VarCurr,B) ) ) ).

tff(addAssignment_75914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133398(VarCurr,B)
      <=> v133399(VarCurr,B) ) ) ).

tff(addAssignment_75913,axiom,
    ! [VarCurr: state_type] :
      ( ( v133370(VarCurr,3)
      <=> v133372(VarCurr,32) )
      & ( v133370(VarCurr,2)
      <=> v133372(VarCurr,31) )
      & ( v133370(VarCurr,1)
      <=> v133372(VarCurr,30) )
      & ( v133370(VarCurr,0)
      <=> v133372(VarCurr,29) ) ) ).

tff(addAssignment_75912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133372(VarCurr,B)
      <=> v133374(VarCurr,B) ) ) ).

tff(addAssignment_75911,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133374(VarNext,B)
      <=> v133458(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133459(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133458(VarNext,B)
            <=> v133374(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1840,axiom,
    ! [VarNext: state_type] :
      ( v133459(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133458(VarNext,B)
          <=> v133469(VarNext,B) ) ) ) ).

tff(addAssignment_75910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133469(VarNext,B)
          <=> v133467(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133470(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133467(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1331,axiom,
    ! [VarCurr: state_type] :
      ( v133470(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133467(VarCurr,B)
          <=> v133396(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17239,axiom,
    ! [VarCurr: state_type] :
      ( v133470(VarCurr)
    <=> ( v133471(VarCurr)
        & v133472(VarCurr) ) ) ).

tff(writeUnaryOperator_9630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133472(VarCurr)
    <=> v133386(VarCurr) ) ).

tff(writeUnaryOperator_9629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133471(VarCurr)
    <=> v133376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133459(VarNext)
      <=> v133460(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133460(VarNext)
      <=> ( v133461(VarNext)
          & v133401(VarNext) ) ) ) ).

tff(writeUnaryOperator_9628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133461(VarNext)
      <=> v133463(VarNext) ) ) ).

tff(addAssignment_75909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133463(VarNext)
      <=> v133401(VarCurr) ) ) ).

tff(addAssignment_75908,axiom,
    ! [VarCurr: state_type] :
      ( v133401(VarCurr)
    <=> v133403(VarCurr) ) ).

tff(addAssignment_75907,axiom,
    ! [VarCurr: state_type] :
      ( v133403(VarCurr)
    <=> v133405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17236,axiom,
    ! [VarCurr: state_type] :
      ( v133405(VarCurr)
    <=> ( v133456(VarCurr)
        | v133452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17235,axiom,
    ! [VarCurr: state_type] :
      ( v133456(VarCurr)
    <=> ( v133407(VarCurr)
        & v133411(VarCurr) ) ) ).

tff(addAssignment_75906,axiom,
    ! [VarCurr: state_type] :
      ( v133452(VarCurr)
    <=> v133454(VarCurr) ) ).

tff(addAssignment_75905,axiom,
    ! [VarCurr: state_type] :
      ( v133454(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133436(VarNext)
       => ( v133411(VarNext)
        <=> v133411(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1839,axiom,
    ! [VarNext: state_type] :
      ( v133436(VarNext)
     => ( v133411(VarNext)
      <=> v133446(VarNext) ) ) ).

tff(addAssignment_75904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133446(VarNext)
      <=> v133444(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17234,axiom,
    ! [VarCurr: state_type] :
      ( v133444(VarCurr)
    <=> ( v133447(VarCurr)
        & v133448(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17233,axiom,
    ! [VarCurr: state_type] :
      ( v133448(VarCurr)
    <=> ( v133417(VarCurr)
        | v133431(VarCurr) ) ) ).

tff(writeUnaryOperator_9627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133447(VarCurr)
    <=> v133413(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133436(VarNext)
      <=> v133437(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133437(VarNext)
      <=> ( v133439(VarNext)
          & v133441(VarNext) ) ) ) ).

tff(writeUnaryOperator_9626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133441(VarCurr)
    <=> v133407(VarCurr) ) ).

tff(addAssignment_75903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133439(VarNext)
      <=> v133407(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_262,axiom,
    ( v133411(constB0)
  <=> $true ) ).

tff(addAssignment_75902,axiom,
    ! [VarCurr: state_type] :
      ( v133431(VarCurr)
    <=> v133433(VarCurr) ) ).

tff(addAssignment_75901,axiom,
    ! [VarCurr: state_type] :
      ( v133433(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75900,axiom,
    ! [VarCurr: state_type] :
      ( v133417(VarCurr)
    <=> v133419(VarCurr) ) ).

tff(addAssignment_75899,axiom,
    ! [VarCurr: state_type] :
      ( v133419(VarCurr)
    <=> v133421(VarCurr) ) ).

tff(addAssignment_75898,axiom,
    ! [VarCurr: state_type] :
      ( v133421(VarCurr)
    <=> v133423(VarCurr) ) ).

tff(addAssignment_75897,axiom,
    ! [VarCurr: state_type] :
      ( v133423(VarCurr)
    <=> v133425(VarCurr) ) ).

tff(addAssignment_75896,axiom,
    ! [VarCurr: state_type] :
      ( v133425(VarCurr)
    <=> v133427(VarCurr) ) ).

tff(addAssignment_75895,axiom,
    ! [VarCurr: state_type] :
      ( v133427(VarCurr)
    <=> v133429(VarCurr) ) ).

tff(addAssignment_75894,axiom,
    ! [VarCurr: state_type] :
      ( v133429(VarCurr)
    <=> v89441(VarCurr) ) ).

tff(addAssignment_75893,axiom,
    ! [VarCurr: state_type] :
      ( v133413(VarCurr)
    <=> v133415(VarCurr) ) ).

tff(addAssignment_75892,axiom,
    ! [VarCurr: state_type] :
      ( v133415(VarCurr)
    <=> $false ) ).

tff(addAssignment_75891,axiom,
    ! [VarCurr: state_type] :
      ( v133407(VarCurr)
    <=> v133409(VarCurr) ) ).

tff(addAssignment_75890,axiom,
    ! [VarCurr: state_type] :
      ( v133409(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133396(VarCurr,B)
      <=> v133398(VarCurr,B) ) ) ).

tff(addAssignment_75888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133398(VarCurr,B)
      <=> v133399(VarCurr,B) ) ) ).

tff(addAssignment_75887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v133399(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75886,axiom,
    ! [VarCurr: state_type] :
      ( ( v133399(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v133399(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v133399(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v133399(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v133399(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v133399(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v133399(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v133399(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v133399(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v133399(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v133399(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v133399(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v133399(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v133399(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v133399(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75885,axiom,
    ! [VarCurr: state_type] :
      ( ( v133399(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v133399(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v133399(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75884,axiom,
    ! [VarCurr: state_type] :
      ( ( v133399(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v133399(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v133399(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v133399(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75883,axiom,
    ! [VarCurr: state_type] :
      ( v133386(VarCurr)
    <=> v133388(VarCurr) ) ).

tff(addAssignment_75882,axiom,
    ! [VarCurr: state_type] :
      ( v133388(VarCurr)
    <=> v133390(VarCurr) ) ).

tff(addAssignment_75881,axiom,
    ! [VarCurr: state_type] :
      ( v133390(VarCurr)
    <=> v133392(VarCurr) ) ).

tff(addAssignment_75880,axiom,
    ! [VarCurr: state_type] :
      ( v133392(VarCurr)
    <=> v133394(VarCurr) ) ).

tff(addAssignment_75879,axiom,
    ! [VarCurr: state_type] :
      ( v133394(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75878,axiom,
    ! [VarCurr: state_type] :
      ( v133376(VarCurr)
    <=> v133378(VarCurr) ) ).

tff(addAssignment_75877,axiom,
    ! [VarCurr: state_type] :
      ( v133378(VarCurr)
    <=> v133380(VarCurr) ) ).

tff(addAssignment_75876,axiom,
    ! [VarCurr: state_type] :
      ( v133380(VarCurr)
    <=> v133382(VarCurr) ) ).

tff(addAssignment_75875,axiom,
    ! [VarCurr: state_type] :
      ( v133382(VarCurr)
    <=> v133384(VarCurr) ) ).

tff(addAssignment_75874,axiom,
    ! [VarCurr: state_type] :
      ( v133384(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133361(VarCurr,B)
      <=> v133363(VarCurr,B) ) ) ).

tff(addAssignment_75872,axiom,
    ! [VarCurr: state_type] :
      ( v133363(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75871,axiom,
    ! [VarCurr: state_type] :
      ( ( v133363(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v133363(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v133363(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v133363(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v133363(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v133363(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v133363(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v133363(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75870,axiom,
    ! [VarCurr: state_type] :
      ( ( v133363(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v133363(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v133363(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v133363(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v133363(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v133363(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v133363(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v133363(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v133363(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v133363(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v133363(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v133363(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v133363(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v133363(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v133363(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75869,axiom,
    ! [VarCurr: state_type] :
      ( ( v133363(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v133363(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v133363(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75868,axiom,
    ! [VarCurr: state_type] :
      ( ( v133363(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v133363(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v133363(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v133363(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75867,axiom,
    ! [VarCurr: state_type] :
      ( v133363(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75866,axiom,
    ! [VarCurr: state_type] :
      ( v133190(VarCurr)
    <=> v133192(VarCurr) ) ).

tff(addAssignment_75865,axiom,
    ! [VarCurr: state_type] :
      ( v133192(VarCurr)
    <=> v133194(VarCurr) ) ).

tff(addAssignment_75864,axiom,
    ! [VarCurr: state_type] :
      ( v133194(VarCurr)
    <=> v133196(VarCurr) ) ).

tff(addAssignment_75863,axiom,
    ! [VarCurr: state_type] :
      ( v133196(VarCurr)
    <=> v133198(VarCurr) ) ).

tff(addAssignment_75862,axiom,
    ! [VarCurr: state_type] :
      ( v133198(VarCurr)
    <=> v133200(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1721,axiom,
    ! [VarCurr: state_type] :
      ( v133200(VarCurr)
    <=> ( ( v133202(VarCurr,31)
        <=> v133207(VarCurr,31) )
        & ( v133202(VarCurr,30)
        <=> v133207(VarCurr,30) )
        & ( v133202(VarCurr,29)
        <=> v133207(VarCurr,29) )
        & ( v133202(VarCurr,28)
        <=> v133207(VarCurr,28) )
        & ( v133202(VarCurr,27)
        <=> v133207(VarCurr,27) )
        & ( v133202(VarCurr,26)
        <=> v133207(VarCurr,26) )
        & ( v133202(VarCurr,25)
        <=> v133207(VarCurr,25) )
        & ( v133202(VarCurr,24)
        <=> v133207(VarCurr,24) )
        & ( v133202(VarCurr,23)
        <=> v133207(VarCurr,23) )
        & ( v133202(VarCurr,22)
        <=> v133207(VarCurr,22) )
        & ( v133202(VarCurr,21)
        <=> v133207(VarCurr,21) )
        & ( v133202(VarCurr,20)
        <=> v133207(VarCurr,20) )
        & ( v133202(VarCurr,19)
        <=> v133207(VarCurr,19) )
        & ( v133202(VarCurr,18)
        <=> v133207(VarCurr,18) )
        & ( v133202(VarCurr,17)
        <=> v133207(VarCurr,17) )
        & ( v133202(VarCurr,16)
        <=> v133207(VarCurr,16) )
        & ( v133202(VarCurr,15)
        <=> v133207(VarCurr,15) )
        & ( v133202(VarCurr,14)
        <=> v133207(VarCurr,14) )
        & ( v133202(VarCurr,13)
        <=> v133207(VarCurr,13) )
        & ( v133202(VarCurr,12)
        <=> v133207(VarCurr,12) )
        & ( v133202(VarCurr,11)
        <=> v133207(VarCurr,11) )
        & ( v133202(VarCurr,10)
        <=> v133207(VarCurr,10) )
        & ( v133202(VarCurr,9)
        <=> v133207(VarCurr,9) )
        & ( v133202(VarCurr,8)
        <=> v133207(VarCurr,8) )
        & ( v133202(VarCurr,7)
        <=> v133207(VarCurr,7) )
        & ( v133202(VarCurr,6)
        <=> v133207(VarCurr,6) )
        & ( v133202(VarCurr,5)
        <=> v133207(VarCurr,5) )
        & ( v133202(VarCurr,4)
        <=> v133207(VarCurr,4) )
        & ( v133202(VarCurr,3)
        <=> v133207(VarCurr,3) )
        & ( v133202(VarCurr,2)
        <=> v133207(VarCurr,2) )
        & ( v133202(VarCurr,1)
        <=> v133207(VarCurr,1) )
        & ( v133202(VarCurr,0)
        <=> v133207(VarCurr,0) ) ) ) ).

tff(addAssignment_75861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133207(VarCurr,B)
      <=> v133209(VarCurr,B) ) ) ).

tff(addAssignment_75860,axiom,
    ! [VarCurr: state_type] :
      ( ( v133209(VarCurr,8)
      <=> v133337(VarCurr,10) )
      & ( v133209(VarCurr,7)
      <=> v133337(VarCurr,9) )
      & ( v133209(VarCurr,6)
      <=> v133337(VarCurr,8) )
      & ( v133209(VarCurr,5)
      <=> v133337(VarCurr,7) )
      & ( v133209(VarCurr,4)
      <=> v133337(VarCurr,6) )
      & ( v133209(VarCurr,3)
      <=> v133337(VarCurr,5) )
      & ( v133209(VarCurr,2)
      <=> v133337(VarCurr,4) )
      & ( v133209(VarCurr,1)
      <=> v133337(VarCurr,3) )
      & ( v133209(VarCurr,0)
      <=> v133337(VarCurr,2) ) ) ).

tff(addAssignment_75859,axiom,
    ! [VarCurr: state_type] :
      ( ( v133209(VarCurr,23)
      <=> v133327(VarCurr,14) )
      & ( v133209(VarCurr,22)
      <=> v133327(VarCurr,13) )
      & ( v133209(VarCurr,21)
      <=> v133327(VarCurr,12) )
      & ( v133209(VarCurr,20)
      <=> v133327(VarCurr,11) )
      & ( v133209(VarCurr,19)
      <=> v133327(VarCurr,10) )
      & ( v133209(VarCurr,18)
      <=> v133327(VarCurr,9) )
      & ( v133209(VarCurr,17)
      <=> v133327(VarCurr,8) )
      & ( v133209(VarCurr,16)
      <=> v133327(VarCurr,7) )
      & ( v133209(VarCurr,15)
      <=> v133327(VarCurr,6) )
      & ( v133209(VarCurr,14)
      <=> v133327(VarCurr,5) )
      & ( v133209(VarCurr,13)
      <=> v133327(VarCurr,4) )
      & ( v133209(VarCurr,12)
      <=> v133327(VarCurr,3) )
      & ( v133209(VarCurr,11)
      <=> v133327(VarCurr,2) )
      & ( v133209(VarCurr,10)
      <=> v133327(VarCurr,1) )
      & ( v133209(VarCurr,9)
      <=> v133327(VarCurr,0) ) ) ).

tff(addAssignment_75858,axiom,
    ! [VarCurr: state_type] :
      ( ( v133209(VarCurr,26)
      <=> v133317(VarCurr,2) )
      & ( v133209(VarCurr,25)
      <=> v133317(VarCurr,1) )
      & ( v133209(VarCurr,24)
      <=> v133317(VarCurr,0) ) ) ).

tff(addAssignment_75857,axiom,
    ! [VarCurr: state_type] :
      ( ( v133209(VarCurr,30)
      <=> v133211(VarCurr,3) )
      & ( v133209(VarCurr,29)
      <=> v133211(VarCurr,2) )
      & ( v133209(VarCurr,28)
      <=> v133211(VarCurr,1) )
      & ( v133209(VarCurr,27)
      <=> v133211(VarCurr,0) ) ) ).

tff(addAssignment_75856,axiom,
    ! [VarCurr: state_type] :
      ( v133209(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133337(VarCurr,B)
      <=> v133213(VarCurr,B) ) ) ).

tff(addAssignment_75854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133213(VarCurr,B)
      <=> v133215(VarCurr,B) ) ) ).

tff(addAssignment_75853,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133215(VarNext,B)
      <=> v133339(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133340(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133339(VarNext,B)
            <=> v133215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1838,axiom,
    ! [VarNext: state_type] :
      ( v133340(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133339(VarNext,B)
          <=> v133310(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133340(VarNext)
      <=> v133341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133341(VarNext)
      <=> ( v133343(VarNext)
          & v133242(VarNext) ) ) ) ).

tff(writeUnaryOperator_9625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133343(VarNext)
      <=> v133304(VarNext) ) ) ).

tff(addAssignment_75852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133237(VarCurr,B)
      <=> v133239(VarCurr,B) ) ) ).

tff(addAssignment_75851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133239(VarCurr,B)
      <=> v133240(VarCurr,B) ) ) ).

tff(addAssignment_75850,axiom,
    ! [VarCurr: state_type] :
      ( ( v133327(VarCurr,14)
      <=> v133213(VarCurr,25) )
      & ( v133327(VarCurr,13)
      <=> v133213(VarCurr,24) )
      & ( v133327(VarCurr,12)
      <=> v133213(VarCurr,23) )
      & ( v133327(VarCurr,11)
      <=> v133213(VarCurr,22) )
      & ( v133327(VarCurr,10)
      <=> v133213(VarCurr,21) )
      & ( v133327(VarCurr,9)
      <=> v133213(VarCurr,20) )
      & ( v133327(VarCurr,8)
      <=> v133213(VarCurr,19) )
      & ( v133327(VarCurr,7)
      <=> v133213(VarCurr,18) )
      & ( v133327(VarCurr,6)
      <=> v133213(VarCurr,17) )
      & ( v133327(VarCurr,5)
      <=> v133213(VarCurr,16) )
      & ( v133327(VarCurr,4)
      <=> v133213(VarCurr,15) )
      & ( v133327(VarCurr,3)
      <=> v133213(VarCurr,14) )
      & ( v133327(VarCurr,2)
      <=> v133213(VarCurr,13) )
      & ( v133327(VarCurr,1)
      <=> v133213(VarCurr,12) )
      & ( v133327(VarCurr,0)
      <=> v133213(VarCurr,11) ) ) ).

tff(addAssignment_75849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133213(VarCurr,B)
      <=> v133215(VarCurr,B) ) ) ).

tff(addAssignment_75848,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133215(VarNext,B)
      <=> v133329(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133330(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133329(VarNext,B)
            <=> v133215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1837,axiom,
    ! [VarNext: state_type] :
      ( v133330(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133329(VarNext,B)
          <=> v133310(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133330(VarNext)
      <=> v133331(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133331(VarNext)
      <=> ( v133333(VarNext)
          & v133242(VarNext) ) ) ) ).

tff(writeUnaryOperator_9624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133333(VarNext)
      <=> v133304(VarNext) ) ) ).

tff(addAssignment_75847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133237(VarCurr,B)
      <=> v133239(VarCurr,B) ) ) ).

tff(addAssignment_75846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133239(VarCurr,B)
      <=> v133240(VarCurr,B) ) ) ).

tff(addAssignment_75845,axiom,
    ! [VarCurr: state_type] :
      ( ( v133317(VarCurr,2)
      <=> v133213(VarCurr,28) )
      & ( v133317(VarCurr,1)
      <=> v133213(VarCurr,27) )
      & ( v133317(VarCurr,0)
      <=> v133213(VarCurr,26) ) ) ).

tff(addAssignment_75844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133213(VarCurr,B)
      <=> v133215(VarCurr,B) ) ) ).

tff(addAssignment_75843,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133215(VarNext,B)
      <=> v133319(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133320(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133319(VarNext,B)
            <=> v133215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1836,axiom,
    ! [VarNext: state_type] :
      ( v133320(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133319(VarNext,B)
          <=> v133310(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133320(VarNext)
      <=> v133321(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133321(VarNext)
      <=> ( v133323(VarNext)
          & v133242(VarNext) ) ) ) ).

tff(writeUnaryOperator_9623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133323(VarNext)
      <=> v133304(VarNext) ) ) ).

tff(addAssignment_75842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133237(VarCurr,B)
      <=> v133239(VarCurr,B) ) ) ).

tff(addAssignment_75841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133239(VarCurr,B)
      <=> v133240(VarCurr,B) ) ) ).

tff(addAssignment_75840,axiom,
    ! [VarCurr: state_type] :
      ( ( v133211(VarCurr,3)
      <=> v133213(VarCurr,32) )
      & ( v133211(VarCurr,2)
      <=> v133213(VarCurr,31) )
      & ( v133211(VarCurr,1)
      <=> v133213(VarCurr,30) )
      & ( v133211(VarCurr,0)
      <=> v133213(VarCurr,29) ) ) ).

tff(addAssignment_75839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133213(VarCurr,B)
      <=> v133215(VarCurr,B) ) ) ).

tff(addAssignment_75838,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133215(VarNext,B)
      <=> v133299(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133300(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133299(VarNext,B)
            <=> v133215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1835,axiom,
    ! [VarNext: state_type] :
      ( v133300(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133299(VarNext,B)
          <=> v133310(VarNext,B) ) ) ) ).

tff(addAssignment_75837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133310(VarNext,B)
          <=> v133308(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133311(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133308(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1330,axiom,
    ! [VarCurr: state_type] :
      ( v133311(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133308(VarCurr,B)
          <=> v133237(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17224,axiom,
    ! [VarCurr: state_type] :
      ( v133311(VarCurr)
    <=> ( v133312(VarCurr)
        & v133313(VarCurr) ) ) ).

tff(writeUnaryOperator_9622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133313(VarCurr)
    <=> v133227(VarCurr) ) ).

tff(writeUnaryOperator_9621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133312(VarCurr)
    <=> v133217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133300(VarNext)
      <=> v133301(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133301(VarNext)
      <=> ( v133302(VarNext)
          & v133242(VarNext) ) ) ) ).

tff(writeUnaryOperator_9620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133302(VarNext)
      <=> v133304(VarNext) ) ) ).

tff(addAssignment_75836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133304(VarNext)
      <=> v133242(VarCurr) ) ) ).

tff(addAssignment_75835,axiom,
    ! [VarCurr: state_type] :
      ( v133242(VarCurr)
    <=> v133244(VarCurr) ) ).

tff(addAssignment_75834,axiom,
    ! [VarCurr: state_type] :
      ( v133244(VarCurr)
    <=> v133246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17221,axiom,
    ! [VarCurr: state_type] :
      ( v133246(VarCurr)
    <=> ( v133297(VarCurr)
        | v133293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17220,axiom,
    ! [VarCurr: state_type] :
      ( v133297(VarCurr)
    <=> ( v133248(VarCurr)
        & v133252(VarCurr) ) ) ).

tff(addAssignment_75833,axiom,
    ! [VarCurr: state_type] :
      ( v133293(VarCurr)
    <=> v133295(VarCurr) ) ).

tff(addAssignment_75832,axiom,
    ! [VarCurr: state_type] :
      ( v133295(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133277(VarNext)
       => ( v133252(VarNext)
        <=> v133252(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1834,axiom,
    ! [VarNext: state_type] :
      ( v133277(VarNext)
     => ( v133252(VarNext)
      <=> v133287(VarNext) ) ) ).

tff(addAssignment_75831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133287(VarNext)
      <=> v133285(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17219,axiom,
    ! [VarCurr: state_type] :
      ( v133285(VarCurr)
    <=> ( v133288(VarCurr)
        & v133289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17218,axiom,
    ! [VarCurr: state_type] :
      ( v133289(VarCurr)
    <=> ( v133258(VarCurr)
        | v133272(VarCurr) ) ) ).

tff(writeUnaryOperator_9619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133288(VarCurr)
    <=> v133254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133277(VarNext)
      <=> v133278(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133278(VarNext)
      <=> ( v133280(VarNext)
          & v133282(VarNext) ) ) ) ).

tff(writeUnaryOperator_9618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133282(VarCurr)
    <=> v133248(VarCurr) ) ).

tff(addAssignment_75830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133280(VarNext)
      <=> v133248(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_261,axiom,
    ( v133252(constB0)
  <=> $true ) ).

tff(addAssignment_75829,axiom,
    ! [VarCurr: state_type] :
      ( v133272(VarCurr)
    <=> v133274(VarCurr) ) ).

tff(addAssignment_75828,axiom,
    ! [VarCurr: state_type] :
      ( v133274(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75827,axiom,
    ! [VarCurr: state_type] :
      ( v133258(VarCurr)
    <=> v133260(VarCurr) ) ).

tff(addAssignment_75826,axiom,
    ! [VarCurr: state_type] :
      ( v133260(VarCurr)
    <=> v133262(VarCurr) ) ).

tff(addAssignment_75825,axiom,
    ! [VarCurr: state_type] :
      ( v133262(VarCurr)
    <=> v133264(VarCurr) ) ).

tff(addAssignment_75824,axiom,
    ! [VarCurr: state_type] :
      ( v133264(VarCurr)
    <=> v133266(VarCurr) ) ).

tff(addAssignment_75823,axiom,
    ! [VarCurr: state_type] :
      ( v133266(VarCurr)
    <=> v133268(VarCurr) ) ).

tff(addAssignment_75822,axiom,
    ! [VarCurr: state_type] :
      ( v133268(VarCurr)
    <=> v133270(VarCurr) ) ).

tff(addAssignment_75821,axiom,
    ! [VarCurr: state_type] :
      ( v133270(VarCurr)
    <=> v129877(VarCurr) ) ).

tff(addAssignment_75820,axiom,
    ! [VarCurr: state_type] :
      ( v133254(VarCurr)
    <=> v133256(VarCurr) ) ).

tff(addAssignment_75819,axiom,
    ! [VarCurr: state_type] :
      ( v133256(VarCurr)
    <=> $false ) ).

tff(addAssignment_75818,axiom,
    ! [VarCurr: state_type] :
      ( v133248(VarCurr)
    <=> v133250(VarCurr) ) ).

tff(addAssignment_75817,axiom,
    ! [VarCurr: state_type] :
      ( v133250(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133237(VarCurr,B)
      <=> v133239(VarCurr,B) ) ) ).

tff(addAssignment_75815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133239(VarCurr,B)
      <=> v133240(VarCurr,B) ) ) ).

tff(addAssignment_75814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v133240(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75813,axiom,
    ! [VarCurr: state_type] :
      ( ( v133240(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v133240(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v133240(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v133240(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v133240(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v133240(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v133240(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v133240(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v133240(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v133240(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v133240(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v133240(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v133240(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v133240(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v133240(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75812,axiom,
    ! [VarCurr: state_type] :
      ( ( v133240(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v133240(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v133240(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75811,axiom,
    ! [VarCurr: state_type] :
      ( ( v133240(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v133240(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v133240(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v133240(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75810,axiom,
    ! [VarCurr: state_type] :
      ( v133227(VarCurr)
    <=> v133229(VarCurr) ) ).

tff(addAssignment_75809,axiom,
    ! [VarCurr: state_type] :
      ( v133229(VarCurr)
    <=> v133231(VarCurr) ) ).

tff(addAssignment_75808,axiom,
    ! [VarCurr: state_type] :
      ( v133231(VarCurr)
    <=> v133233(VarCurr) ) ).

tff(addAssignment_75807,axiom,
    ! [VarCurr: state_type] :
      ( v133233(VarCurr)
    <=> v133235(VarCurr) ) ).

tff(addAssignment_75806,axiom,
    ! [VarCurr: state_type] :
      ( v133235(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75805,axiom,
    ! [VarCurr: state_type] :
      ( v133217(VarCurr)
    <=> v133219(VarCurr) ) ).

tff(addAssignment_75804,axiom,
    ! [VarCurr: state_type] :
      ( v133219(VarCurr)
    <=> v133221(VarCurr) ) ).

tff(addAssignment_75803,axiom,
    ! [VarCurr: state_type] :
      ( v133221(VarCurr)
    <=> v133223(VarCurr) ) ).

tff(addAssignment_75802,axiom,
    ! [VarCurr: state_type] :
      ( v133223(VarCurr)
    <=> v133225(VarCurr) ) ).

tff(addAssignment_75801,axiom,
    ! [VarCurr: state_type] :
      ( v133225(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133202(VarCurr,B)
      <=> v133204(VarCurr,B) ) ) ).

tff(addAssignment_75799,axiom,
    ! [VarCurr: state_type] :
      ( v133204(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75798,axiom,
    ! [VarCurr: state_type] :
      ( ( v133204(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v133204(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v133204(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v133204(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v133204(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v133204(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v133204(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v133204(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75797,axiom,
    ! [VarCurr: state_type] :
      ( ( v133204(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v133204(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v133204(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v133204(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v133204(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v133204(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v133204(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v133204(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v133204(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v133204(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v133204(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v133204(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v133204(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v133204(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v133204(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75796,axiom,
    ! [VarCurr: state_type] :
      ( ( v133204(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v133204(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v133204(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75795,axiom,
    ! [VarCurr: state_type] :
      ( ( v133204(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v133204(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v133204(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v133204(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75794,axiom,
    ! [VarCurr: state_type] :
      ( v133204(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75793,axiom,
    ! [VarCurr: state_type] :
      ( v133031(VarCurr)
    <=> v133033(VarCurr) ) ).

tff(addAssignment_75792,axiom,
    ! [VarCurr: state_type] :
      ( v133033(VarCurr)
    <=> v133035(VarCurr) ) ).

tff(addAssignment_75791,axiom,
    ! [VarCurr: state_type] :
      ( v133035(VarCurr)
    <=> v133037(VarCurr) ) ).

tff(addAssignment_75790,axiom,
    ! [VarCurr: state_type] :
      ( v133037(VarCurr)
    <=> v133039(VarCurr) ) ).

tff(addAssignment_75789,axiom,
    ! [VarCurr: state_type] :
      ( v133039(VarCurr)
    <=> v133041(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1720,axiom,
    ! [VarCurr: state_type] :
      ( v133041(VarCurr)
    <=> ( ( v133043(VarCurr,31)
        <=> v133048(VarCurr,31) )
        & ( v133043(VarCurr,30)
        <=> v133048(VarCurr,30) )
        & ( v133043(VarCurr,29)
        <=> v133048(VarCurr,29) )
        & ( v133043(VarCurr,28)
        <=> v133048(VarCurr,28) )
        & ( v133043(VarCurr,27)
        <=> v133048(VarCurr,27) )
        & ( v133043(VarCurr,26)
        <=> v133048(VarCurr,26) )
        & ( v133043(VarCurr,25)
        <=> v133048(VarCurr,25) )
        & ( v133043(VarCurr,24)
        <=> v133048(VarCurr,24) )
        & ( v133043(VarCurr,23)
        <=> v133048(VarCurr,23) )
        & ( v133043(VarCurr,22)
        <=> v133048(VarCurr,22) )
        & ( v133043(VarCurr,21)
        <=> v133048(VarCurr,21) )
        & ( v133043(VarCurr,20)
        <=> v133048(VarCurr,20) )
        & ( v133043(VarCurr,19)
        <=> v133048(VarCurr,19) )
        & ( v133043(VarCurr,18)
        <=> v133048(VarCurr,18) )
        & ( v133043(VarCurr,17)
        <=> v133048(VarCurr,17) )
        & ( v133043(VarCurr,16)
        <=> v133048(VarCurr,16) )
        & ( v133043(VarCurr,15)
        <=> v133048(VarCurr,15) )
        & ( v133043(VarCurr,14)
        <=> v133048(VarCurr,14) )
        & ( v133043(VarCurr,13)
        <=> v133048(VarCurr,13) )
        & ( v133043(VarCurr,12)
        <=> v133048(VarCurr,12) )
        & ( v133043(VarCurr,11)
        <=> v133048(VarCurr,11) )
        & ( v133043(VarCurr,10)
        <=> v133048(VarCurr,10) )
        & ( v133043(VarCurr,9)
        <=> v133048(VarCurr,9) )
        & ( v133043(VarCurr,8)
        <=> v133048(VarCurr,8) )
        & ( v133043(VarCurr,7)
        <=> v133048(VarCurr,7) )
        & ( v133043(VarCurr,6)
        <=> v133048(VarCurr,6) )
        & ( v133043(VarCurr,5)
        <=> v133048(VarCurr,5) )
        & ( v133043(VarCurr,4)
        <=> v133048(VarCurr,4) )
        & ( v133043(VarCurr,3)
        <=> v133048(VarCurr,3) )
        & ( v133043(VarCurr,2)
        <=> v133048(VarCurr,2) )
        & ( v133043(VarCurr,1)
        <=> v133048(VarCurr,1) )
        & ( v133043(VarCurr,0)
        <=> v133048(VarCurr,0) ) ) ) ).

tff(addAssignment_75788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133048(VarCurr,B)
      <=> v133050(VarCurr,B) ) ) ).

tff(addAssignment_75787,axiom,
    ! [VarCurr: state_type] :
      ( ( v133050(VarCurr,8)
      <=> v133178(VarCurr,10) )
      & ( v133050(VarCurr,7)
      <=> v133178(VarCurr,9) )
      & ( v133050(VarCurr,6)
      <=> v133178(VarCurr,8) )
      & ( v133050(VarCurr,5)
      <=> v133178(VarCurr,7) )
      & ( v133050(VarCurr,4)
      <=> v133178(VarCurr,6) )
      & ( v133050(VarCurr,3)
      <=> v133178(VarCurr,5) )
      & ( v133050(VarCurr,2)
      <=> v133178(VarCurr,4) )
      & ( v133050(VarCurr,1)
      <=> v133178(VarCurr,3) )
      & ( v133050(VarCurr,0)
      <=> v133178(VarCurr,2) ) ) ).

tff(addAssignment_75786,axiom,
    ! [VarCurr: state_type] :
      ( ( v133050(VarCurr,23)
      <=> v133168(VarCurr,14) )
      & ( v133050(VarCurr,22)
      <=> v133168(VarCurr,13) )
      & ( v133050(VarCurr,21)
      <=> v133168(VarCurr,12) )
      & ( v133050(VarCurr,20)
      <=> v133168(VarCurr,11) )
      & ( v133050(VarCurr,19)
      <=> v133168(VarCurr,10) )
      & ( v133050(VarCurr,18)
      <=> v133168(VarCurr,9) )
      & ( v133050(VarCurr,17)
      <=> v133168(VarCurr,8) )
      & ( v133050(VarCurr,16)
      <=> v133168(VarCurr,7) )
      & ( v133050(VarCurr,15)
      <=> v133168(VarCurr,6) )
      & ( v133050(VarCurr,14)
      <=> v133168(VarCurr,5) )
      & ( v133050(VarCurr,13)
      <=> v133168(VarCurr,4) )
      & ( v133050(VarCurr,12)
      <=> v133168(VarCurr,3) )
      & ( v133050(VarCurr,11)
      <=> v133168(VarCurr,2) )
      & ( v133050(VarCurr,10)
      <=> v133168(VarCurr,1) )
      & ( v133050(VarCurr,9)
      <=> v133168(VarCurr,0) ) ) ).

tff(addAssignment_75785,axiom,
    ! [VarCurr: state_type] :
      ( ( v133050(VarCurr,26)
      <=> v133158(VarCurr,2) )
      & ( v133050(VarCurr,25)
      <=> v133158(VarCurr,1) )
      & ( v133050(VarCurr,24)
      <=> v133158(VarCurr,0) ) ) ).

tff(addAssignment_75784,axiom,
    ! [VarCurr: state_type] :
      ( ( v133050(VarCurr,30)
      <=> v133052(VarCurr,3) )
      & ( v133050(VarCurr,29)
      <=> v133052(VarCurr,2) )
      & ( v133050(VarCurr,28)
      <=> v133052(VarCurr,1) )
      & ( v133050(VarCurr,27)
      <=> v133052(VarCurr,0) ) ) ).

tff(addAssignment_75783,axiom,
    ! [VarCurr: state_type] :
      ( v133050(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133178(VarCurr,B)
      <=> v133054(VarCurr,B) ) ) ).

tff(addAssignment_75781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133054(VarCurr,B)
      <=> v133056(VarCurr,B) ) ) ).

tff(addAssignment_75780,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133056(VarNext,B)
      <=> v133180(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133181(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133180(VarNext,B)
            <=> v133056(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1833,axiom,
    ! [VarNext: state_type] :
      ( v133181(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133180(VarNext,B)
          <=> v133151(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133181(VarNext)
      <=> v133182(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133182(VarNext)
      <=> ( v133184(VarNext)
          & v133083(VarNext) ) ) ) ).

tff(writeUnaryOperator_9617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133184(VarNext)
      <=> v133145(VarNext) ) ) ).

tff(addAssignment_75779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133078(VarCurr,B)
      <=> v133080(VarCurr,B) ) ) ).

tff(addAssignment_75778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133080(VarCurr,B)
      <=> v133081(VarCurr,B) ) ) ).

tff(addAssignment_75777,axiom,
    ! [VarCurr: state_type] :
      ( ( v133168(VarCurr,14)
      <=> v133054(VarCurr,25) )
      & ( v133168(VarCurr,13)
      <=> v133054(VarCurr,24) )
      & ( v133168(VarCurr,12)
      <=> v133054(VarCurr,23) )
      & ( v133168(VarCurr,11)
      <=> v133054(VarCurr,22) )
      & ( v133168(VarCurr,10)
      <=> v133054(VarCurr,21) )
      & ( v133168(VarCurr,9)
      <=> v133054(VarCurr,20) )
      & ( v133168(VarCurr,8)
      <=> v133054(VarCurr,19) )
      & ( v133168(VarCurr,7)
      <=> v133054(VarCurr,18) )
      & ( v133168(VarCurr,6)
      <=> v133054(VarCurr,17) )
      & ( v133168(VarCurr,5)
      <=> v133054(VarCurr,16) )
      & ( v133168(VarCurr,4)
      <=> v133054(VarCurr,15) )
      & ( v133168(VarCurr,3)
      <=> v133054(VarCurr,14) )
      & ( v133168(VarCurr,2)
      <=> v133054(VarCurr,13) )
      & ( v133168(VarCurr,1)
      <=> v133054(VarCurr,12) )
      & ( v133168(VarCurr,0)
      <=> v133054(VarCurr,11) ) ) ).

tff(addAssignment_75776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133054(VarCurr,B)
      <=> v133056(VarCurr,B) ) ) ).

tff(addAssignment_75775,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133056(VarNext,B)
      <=> v133170(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133171(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133170(VarNext,B)
            <=> v133056(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1832,axiom,
    ! [VarNext: state_type] :
      ( v133171(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133170(VarNext,B)
          <=> v133151(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133171(VarNext)
      <=> v133172(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133172(VarNext)
      <=> ( v133174(VarNext)
          & v133083(VarNext) ) ) ) ).

tff(writeUnaryOperator_9616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133174(VarNext)
      <=> v133145(VarNext) ) ) ).

tff(addAssignment_75774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133078(VarCurr,B)
      <=> v133080(VarCurr,B) ) ) ).

tff(addAssignment_75773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v133080(VarCurr,B)
      <=> v133081(VarCurr,B) ) ) ).

tff(addAssignment_75772,axiom,
    ! [VarCurr: state_type] :
      ( ( v133158(VarCurr,2)
      <=> v133054(VarCurr,28) )
      & ( v133158(VarCurr,1)
      <=> v133054(VarCurr,27) )
      & ( v133158(VarCurr,0)
      <=> v133054(VarCurr,26) ) ) ).

tff(addAssignment_75771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133054(VarCurr,B)
      <=> v133056(VarCurr,B) ) ) ).

tff(addAssignment_75770,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133056(VarNext,B)
      <=> v133160(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133161(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133160(VarNext,B)
            <=> v133056(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1831,axiom,
    ! [VarNext: state_type] :
      ( v133161(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133160(VarNext,B)
          <=> v133151(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133161(VarNext)
      <=> v133162(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133162(VarNext)
      <=> ( v133164(VarNext)
          & v133083(VarNext) ) ) ) ).

tff(writeUnaryOperator_9615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133164(VarNext)
      <=> v133145(VarNext) ) ) ).

tff(addAssignment_75769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133078(VarCurr,B)
      <=> v133080(VarCurr,B) ) ) ).

tff(addAssignment_75768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v133080(VarCurr,B)
      <=> v133081(VarCurr,B) ) ) ).

tff(addAssignment_75767,axiom,
    ! [VarCurr: state_type] :
      ( ( v133052(VarCurr,3)
      <=> v133054(VarCurr,32) )
      & ( v133052(VarCurr,2)
      <=> v133054(VarCurr,31) )
      & ( v133052(VarCurr,1)
      <=> v133054(VarCurr,30) )
      & ( v133052(VarCurr,0)
      <=> v133054(VarCurr,29) ) ) ).

tff(addAssignment_75766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133054(VarCurr,B)
      <=> v133056(VarCurr,B) ) ) ).

tff(addAssignment_75765,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133056(VarNext,B)
      <=> v133140(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133141(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133140(VarNext,B)
            <=> v133056(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1830,axiom,
    ! [VarNext: state_type] :
      ( v133141(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133140(VarNext,B)
          <=> v133151(VarNext,B) ) ) ) ).

tff(addAssignment_75764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133151(VarNext,B)
          <=> v133149(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133152(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133149(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1329,axiom,
    ! [VarCurr: state_type] :
      ( v133152(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133149(VarCurr,B)
          <=> v133078(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17209,axiom,
    ! [VarCurr: state_type] :
      ( v133152(VarCurr)
    <=> ( v133153(VarCurr)
        & v133154(VarCurr) ) ) ).

tff(writeUnaryOperator_9614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133154(VarCurr)
    <=> v133068(VarCurr) ) ).

tff(writeUnaryOperator_9613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133153(VarCurr)
    <=> v133058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133141(VarNext)
      <=> v133142(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133142(VarNext)
      <=> ( v133143(VarNext)
          & v133083(VarNext) ) ) ) ).

tff(writeUnaryOperator_9612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133143(VarNext)
      <=> v133145(VarNext) ) ) ).

tff(addAssignment_75763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133145(VarNext)
      <=> v133083(VarCurr) ) ) ).

tff(addAssignment_75762,axiom,
    ! [VarCurr: state_type] :
      ( v133083(VarCurr)
    <=> v133085(VarCurr) ) ).

tff(addAssignment_75761,axiom,
    ! [VarCurr: state_type] :
      ( v133085(VarCurr)
    <=> v133087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17206,axiom,
    ! [VarCurr: state_type] :
      ( v133087(VarCurr)
    <=> ( v133138(VarCurr)
        | v133134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17205,axiom,
    ! [VarCurr: state_type] :
      ( v133138(VarCurr)
    <=> ( v133089(VarCurr)
        & v133093(VarCurr) ) ) ).

tff(addAssignment_75760,axiom,
    ! [VarCurr: state_type] :
      ( v133134(VarCurr)
    <=> v133136(VarCurr) ) ).

tff(addAssignment_75759,axiom,
    ! [VarCurr: state_type] :
      ( v133136(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133118(VarNext)
       => ( v133093(VarNext)
        <=> v133093(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1829,axiom,
    ! [VarNext: state_type] :
      ( v133118(VarNext)
     => ( v133093(VarNext)
      <=> v133128(VarNext) ) ) ).

tff(addAssignment_75758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133128(VarNext)
      <=> v133126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17204,axiom,
    ! [VarCurr: state_type] :
      ( v133126(VarCurr)
    <=> ( v133129(VarCurr)
        & v133130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17203,axiom,
    ! [VarCurr: state_type] :
      ( v133130(VarCurr)
    <=> ( v133099(VarCurr)
        | v133113(VarCurr) ) ) ).

tff(writeUnaryOperator_9611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133129(VarCurr)
    <=> v133095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133118(VarNext)
      <=> v133119(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133119(VarNext)
      <=> ( v133121(VarNext)
          & v133123(VarNext) ) ) ) ).

tff(writeUnaryOperator_9610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v133123(VarCurr)
    <=> v133089(VarCurr) ) ).

tff(addAssignment_75757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133121(VarNext)
      <=> v133089(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_260,axiom,
    ( v133093(constB0)
  <=> $true ) ).

tff(addAssignment_75756,axiom,
    ! [VarCurr: state_type] :
      ( v133113(VarCurr)
    <=> v133115(VarCurr) ) ).

tff(addAssignment_75755,axiom,
    ! [VarCurr: state_type] :
      ( v133115(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75754,axiom,
    ! [VarCurr: state_type] :
      ( v133099(VarCurr)
    <=> v133101(VarCurr) ) ).

tff(addAssignment_75753,axiom,
    ! [VarCurr: state_type] :
      ( v133101(VarCurr)
    <=> v133103(VarCurr) ) ).

tff(addAssignment_75752,axiom,
    ! [VarCurr: state_type] :
      ( v133103(VarCurr)
    <=> v133105(VarCurr) ) ).

tff(addAssignment_75751,axiom,
    ! [VarCurr: state_type] :
      ( v133105(VarCurr)
    <=> v133107(VarCurr) ) ).

tff(addAssignment_75750,axiom,
    ! [VarCurr: state_type] :
      ( v133107(VarCurr)
    <=> v133109(VarCurr) ) ).

tff(addAssignment_75749,axiom,
    ! [VarCurr: state_type] :
      ( v133109(VarCurr)
    <=> v133111(VarCurr) ) ).

tff(addAssignment_75748,axiom,
    ! [VarCurr: state_type] :
      ( v133111(VarCurr)
    <=> v129892(VarCurr) ) ).

tff(addAssignment_75747,axiom,
    ! [VarCurr: state_type] :
      ( v133095(VarCurr)
    <=> v133097(VarCurr) ) ).

tff(addAssignment_75746,axiom,
    ! [VarCurr: state_type] :
      ( v133097(VarCurr)
    <=> $false ) ).

tff(addAssignment_75745,axiom,
    ! [VarCurr: state_type] :
      ( v133089(VarCurr)
    <=> v133091(VarCurr) ) ).

tff(addAssignment_75744,axiom,
    ! [VarCurr: state_type] :
      ( v133091(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133078(VarCurr,B)
      <=> v133080(VarCurr,B) ) ) ).

tff(addAssignment_75742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v133080(VarCurr,B)
      <=> v133081(VarCurr,B) ) ) ).

tff(addAssignment_75741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v133081(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75740,axiom,
    ! [VarCurr: state_type] :
      ( ( v133081(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v133081(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v133081(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v133081(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v133081(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v133081(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v133081(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v133081(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v133081(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v133081(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v133081(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v133081(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v133081(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v133081(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v133081(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75739,axiom,
    ! [VarCurr: state_type] :
      ( ( v133081(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v133081(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v133081(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75738,axiom,
    ! [VarCurr: state_type] :
      ( ( v133081(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v133081(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v133081(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v133081(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75737,axiom,
    ! [VarCurr: state_type] :
      ( v133068(VarCurr)
    <=> v133070(VarCurr) ) ).

tff(addAssignment_75736,axiom,
    ! [VarCurr: state_type] :
      ( v133070(VarCurr)
    <=> v133072(VarCurr) ) ).

tff(addAssignment_75735,axiom,
    ! [VarCurr: state_type] :
      ( v133072(VarCurr)
    <=> v133074(VarCurr) ) ).

tff(addAssignment_75734,axiom,
    ! [VarCurr: state_type] :
      ( v133074(VarCurr)
    <=> v133076(VarCurr) ) ).

tff(addAssignment_75733,axiom,
    ! [VarCurr: state_type] :
      ( v133076(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75732,axiom,
    ! [VarCurr: state_type] :
      ( v133058(VarCurr)
    <=> v133060(VarCurr) ) ).

tff(addAssignment_75731,axiom,
    ! [VarCurr: state_type] :
      ( v133060(VarCurr)
    <=> v133062(VarCurr) ) ).

tff(addAssignment_75730,axiom,
    ! [VarCurr: state_type] :
      ( v133062(VarCurr)
    <=> v133064(VarCurr) ) ).

tff(addAssignment_75729,axiom,
    ! [VarCurr: state_type] :
      ( v133064(VarCurr)
    <=> v133066(VarCurr) ) ).

tff(addAssignment_75728,axiom,
    ! [VarCurr: state_type] :
      ( v133066(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v133043(VarCurr,B)
      <=> v133045(VarCurr,B) ) ) ).

tff(addAssignment_75726,axiom,
    ! [VarCurr: state_type] :
      ( v133045(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75725,axiom,
    ! [VarCurr: state_type] :
      ( ( v133045(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v133045(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v133045(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v133045(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v133045(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v133045(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v133045(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v133045(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75724,axiom,
    ! [VarCurr: state_type] :
      ( ( v133045(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v133045(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v133045(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v133045(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v133045(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v133045(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v133045(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v133045(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v133045(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v133045(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v133045(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v133045(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v133045(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v133045(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v133045(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75723,axiom,
    ! [VarCurr: state_type] :
      ( ( v133045(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v133045(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v133045(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75722,axiom,
    ! [VarCurr: state_type] :
      ( ( v133045(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v133045(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v133045(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v133045(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75721,axiom,
    ! [VarCurr: state_type] :
      ( v133045(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75720,axiom,
    ! [VarCurr: state_type] :
      ( v132872(VarCurr)
    <=> v132874(VarCurr) ) ).

tff(addAssignment_75719,axiom,
    ! [VarCurr: state_type] :
      ( v132874(VarCurr)
    <=> v132876(VarCurr) ) ).

tff(addAssignment_75718,axiom,
    ! [VarCurr: state_type] :
      ( v132876(VarCurr)
    <=> v132878(VarCurr) ) ).

tff(addAssignment_75717,axiom,
    ! [VarCurr: state_type] :
      ( v132878(VarCurr)
    <=> v132880(VarCurr) ) ).

tff(addAssignment_75716,axiom,
    ! [VarCurr: state_type] :
      ( v132880(VarCurr)
    <=> v132882(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1719,axiom,
    ! [VarCurr: state_type] :
      ( v132882(VarCurr)
    <=> ( ( v132884(VarCurr,31)
        <=> v132889(VarCurr,31) )
        & ( v132884(VarCurr,30)
        <=> v132889(VarCurr,30) )
        & ( v132884(VarCurr,29)
        <=> v132889(VarCurr,29) )
        & ( v132884(VarCurr,28)
        <=> v132889(VarCurr,28) )
        & ( v132884(VarCurr,27)
        <=> v132889(VarCurr,27) )
        & ( v132884(VarCurr,26)
        <=> v132889(VarCurr,26) )
        & ( v132884(VarCurr,25)
        <=> v132889(VarCurr,25) )
        & ( v132884(VarCurr,24)
        <=> v132889(VarCurr,24) )
        & ( v132884(VarCurr,23)
        <=> v132889(VarCurr,23) )
        & ( v132884(VarCurr,22)
        <=> v132889(VarCurr,22) )
        & ( v132884(VarCurr,21)
        <=> v132889(VarCurr,21) )
        & ( v132884(VarCurr,20)
        <=> v132889(VarCurr,20) )
        & ( v132884(VarCurr,19)
        <=> v132889(VarCurr,19) )
        & ( v132884(VarCurr,18)
        <=> v132889(VarCurr,18) )
        & ( v132884(VarCurr,17)
        <=> v132889(VarCurr,17) )
        & ( v132884(VarCurr,16)
        <=> v132889(VarCurr,16) )
        & ( v132884(VarCurr,15)
        <=> v132889(VarCurr,15) )
        & ( v132884(VarCurr,14)
        <=> v132889(VarCurr,14) )
        & ( v132884(VarCurr,13)
        <=> v132889(VarCurr,13) )
        & ( v132884(VarCurr,12)
        <=> v132889(VarCurr,12) )
        & ( v132884(VarCurr,11)
        <=> v132889(VarCurr,11) )
        & ( v132884(VarCurr,10)
        <=> v132889(VarCurr,10) )
        & ( v132884(VarCurr,9)
        <=> v132889(VarCurr,9) )
        & ( v132884(VarCurr,8)
        <=> v132889(VarCurr,8) )
        & ( v132884(VarCurr,7)
        <=> v132889(VarCurr,7) )
        & ( v132884(VarCurr,6)
        <=> v132889(VarCurr,6) )
        & ( v132884(VarCurr,5)
        <=> v132889(VarCurr,5) )
        & ( v132884(VarCurr,4)
        <=> v132889(VarCurr,4) )
        & ( v132884(VarCurr,3)
        <=> v132889(VarCurr,3) )
        & ( v132884(VarCurr,2)
        <=> v132889(VarCurr,2) )
        & ( v132884(VarCurr,1)
        <=> v132889(VarCurr,1) )
        & ( v132884(VarCurr,0)
        <=> v132889(VarCurr,0) ) ) ) ).

tff(addAssignment_75715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132889(VarCurr,B)
      <=> v132891(VarCurr,B) ) ) ).

tff(addAssignment_75714,axiom,
    ! [VarCurr: state_type] :
      ( ( v132891(VarCurr,8)
      <=> v133019(VarCurr,10) )
      & ( v132891(VarCurr,7)
      <=> v133019(VarCurr,9) )
      & ( v132891(VarCurr,6)
      <=> v133019(VarCurr,8) )
      & ( v132891(VarCurr,5)
      <=> v133019(VarCurr,7) )
      & ( v132891(VarCurr,4)
      <=> v133019(VarCurr,6) )
      & ( v132891(VarCurr,3)
      <=> v133019(VarCurr,5) )
      & ( v132891(VarCurr,2)
      <=> v133019(VarCurr,4) )
      & ( v132891(VarCurr,1)
      <=> v133019(VarCurr,3) )
      & ( v132891(VarCurr,0)
      <=> v133019(VarCurr,2) ) ) ).

tff(addAssignment_75713,axiom,
    ! [VarCurr: state_type] :
      ( ( v132891(VarCurr,23)
      <=> v133009(VarCurr,14) )
      & ( v132891(VarCurr,22)
      <=> v133009(VarCurr,13) )
      & ( v132891(VarCurr,21)
      <=> v133009(VarCurr,12) )
      & ( v132891(VarCurr,20)
      <=> v133009(VarCurr,11) )
      & ( v132891(VarCurr,19)
      <=> v133009(VarCurr,10) )
      & ( v132891(VarCurr,18)
      <=> v133009(VarCurr,9) )
      & ( v132891(VarCurr,17)
      <=> v133009(VarCurr,8) )
      & ( v132891(VarCurr,16)
      <=> v133009(VarCurr,7) )
      & ( v132891(VarCurr,15)
      <=> v133009(VarCurr,6) )
      & ( v132891(VarCurr,14)
      <=> v133009(VarCurr,5) )
      & ( v132891(VarCurr,13)
      <=> v133009(VarCurr,4) )
      & ( v132891(VarCurr,12)
      <=> v133009(VarCurr,3) )
      & ( v132891(VarCurr,11)
      <=> v133009(VarCurr,2) )
      & ( v132891(VarCurr,10)
      <=> v133009(VarCurr,1) )
      & ( v132891(VarCurr,9)
      <=> v133009(VarCurr,0) ) ) ).

tff(addAssignment_75712,axiom,
    ! [VarCurr: state_type] :
      ( ( v132891(VarCurr,26)
      <=> v132999(VarCurr,2) )
      & ( v132891(VarCurr,25)
      <=> v132999(VarCurr,1) )
      & ( v132891(VarCurr,24)
      <=> v132999(VarCurr,0) ) ) ).

tff(addAssignment_75711,axiom,
    ! [VarCurr: state_type] :
      ( ( v132891(VarCurr,30)
      <=> v132893(VarCurr,3) )
      & ( v132891(VarCurr,29)
      <=> v132893(VarCurr,2) )
      & ( v132891(VarCurr,28)
      <=> v132893(VarCurr,1) )
      & ( v132891(VarCurr,27)
      <=> v132893(VarCurr,0) ) ) ).

tff(addAssignment_75710,axiom,
    ! [VarCurr: state_type] :
      ( v132891(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v133019(VarCurr,B)
      <=> v132895(VarCurr,B) ) ) ).

tff(addAssignment_75708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132895(VarCurr,B)
      <=> v132897(VarCurr,B) ) ) ).

tff(addAssignment_75707,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132897(VarNext,B)
      <=> v133021(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133022(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133021(VarNext,B)
            <=> v132897(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1828,axiom,
    ! [VarNext: state_type] :
      ( v133022(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133021(VarNext,B)
          <=> v132992(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133022(VarNext)
      <=> v133023(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133023(VarNext)
      <=> ( v133025(VarNext)
          & v132924(VarNext) ) ) ) ).

tff(writeUnaryOperator_9609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133025(VarNext)
      <=> v132986(VarNext) ) ) ).

tff(addAssignment_75706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132919(VarCurr,B)
      <=> v132921(VarCurr,B) ) ) ).

tff(addAssignment_75705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132921(VarCurr,B)
      <=> v132922(VarCurr,B) ) ) ).

tff(addAssignment_75704,axiom,
    ! [VarCurr: state_type] :
      ( ( v133009(VarCurr,14)
      <=> v132895(VarCurr,25) )
      & ( v133009(VarCurr,13)
      <=> v132895(VarCurr,24) )
      & ( v133009(VarCurr,12)
      <=> v132895(VarCurr,23) )
      & ( v133009(VarCurr,11)
      <=> v132895(VarCurr,22) )
      & ( v133009(VarCurr,10)
      <=> v132895(VarCurr,21) )
      & ( v133009(VarCurr,9)
      <=> v132895(VarCurr,20) )
      & ( v133009(VarCurr,8)
      <=> v132895(VarCurr,19) )
      & ( v133009(VarCurr,7)
      <=> v132895(VarCurr,18) )
      & ( v133009(VarCurr,6)
      <=> v132895(VarCurr,17) )
      & ( v133009(VarCurr,5)
      <=> v132895(VarCurr,16) )
      & ( v133009(VarCurr,4)
      <=> v132895(VarCurr,15) )
      & ( v133009(VarCurr,3)
      <=> v132895(VarCurr,14) )
      & ( v133009(VarCurr,2)
      <=> v132895(VarCurr,13) )
      & ( v133009(VarCurr,1)
      <=> v132895(VarCurr,12) )
      & ( v133009(VarCurr,0)
      <=> v132895(VarCurr,11) ) ) ).

tff(addAssignment_75703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132895(VarCurr,B)
      <=> v132897(VarCurr,B) ) ) ).

tff(addAssignment_75702,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132897(VarNext,B)
      <=> v133011(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133012(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133011(VarNext,B)
            <=> v132897(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1827,axiom,
    ! [VarNext: state_type] :
      ( v133012(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133011(VarNext,B)
          <=> v132992(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133012(VarNext)
      <=> v133013(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133013(VarNext)
      <=> ( v133015(VarNext)
          & v132924(VarNext) ) ) ) ).

tff(writeUnaryOperator_9608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133015(VarNext)
      <=> v132986(VarNext) ) ) ).

tff(addAssignment_75701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132919(VarCurr,B)
      <=> v132921(VarCurr,B) ) ) ).

tff(addAssignment_75700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132921(VarCurr,B)
      <=> v132922(VarCurr,B) ) ) ).

tff(addAssignment_75699,axiom,
    ! [VarCurr: state_type] :
      ( ( v132999(VarCurr,2)
      <=> v132895(VarCurr,28) )
      & ( v132999(VarCurr,1)
      <=> v132895(VarCurr,27) )
      & ( v132999(VarCurr,0)
      <=> v132895(VarCurr,26) ) ) ).

tff(addAssignment_75698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132895(VarCurr,B)
      <=> v132897(VarCurr,B) ) ) ).

tff(addAssignment_75697,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132897(VarNext,B)
      <=> v133001(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v133001(VarNext,B)
            <=> v132897(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1826,axiom,
    ! [VarNext: state_type] :
      ( v133002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v133001(VarNext,B)
          <=> v132992(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133002(VarNext)
      <=> v133003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v133003(VarNext)
      <=> ( v133005(VarNext)
          & v132924(VarNext) ) ) ) ).

tff(writeUnaryOperator_9607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v133005(VarNext)
      <=> v132986(VarNext) ) ) ).

tff(addAssignment_75696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132919(VarCurr,B)
      <=> v132921(VarCurr,B) ) ) ).

tff(addAssignment_75695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132921(VarCurr,B)
      <=> v132922(VarCurr,B) ) ) ).

tff(addAssignment_75694,axiom,
    ! [VarCurr: state_type] :
      ( ( v132893(VarCurr,3)
      <=> v132895(VarCurr,32) )
      & ( v132893(VarCurr,2)
      <=> v132895(VarCurr,31) )
      & ( v132893(VarCurr,1)
      <=> v132895(VarCurr,30) )
      & ( v132893(VarCurr,0)
      <=> v132895(VarCurr,29) ) ) ).

tff(addAssignment_75693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132895(VarCurr,B)
      <=> v132897(VarCurr,B) ) ) ).

tff(addAssignment_75692,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132897(VarNext,B)
      <=> v132981(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132982(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132981(VarNext,B)
            <=> v132897(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1825,axiom,
    ! [VarNext: state_type] :
      ( v132982(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132981(VarNext,B)
          <=> v132992(VarNext,B) ) ) ) ).

tff(addAssignment_75691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132992(VarNext,B)
          <=> v132990(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132993(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132990(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1328,axiom,
    ! [VarCurr: state_type] :
      ( v132993(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132990(VarCurr,B)
          <=> v132919(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17194,axiom,
    ! [VarCurr: state_type] :
      ( v132993(VarCurr)
    <=> ( v132994(VarCurr)
        & v132995(VarCurr) ) ) ).

tff(writeUnaryOperator_9606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132995(VarCurr)
    <=> v132909(VarCurr) ) ).

tff(writeUnaryOperator_9605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132994(VarCurr)
    <=> v132899(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132982(VarNext)
      <=> v132983(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132983(VarNext)
      <=> ( v132984(VarNext)
          & v132924(VarNext) ) ) ) ).

tff(writeUnaryOperator_9604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132984(VarNext)
      <=> v132986(VarNext) ) ) ).

tff(addAssignment_75690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132986(VarNext)
      <=> v132924(VarCurr) ) ) ).

tff(addAssignment_75689,axiom,
    ! [VarCurr: state_type] :
      ( v132924(VarCurr)
    <=> v132926(VarCurr) ) ).

tff(addAssignment_75688,axiom,
    ! [VarCurr: state_type] :
      ( v132926(VarCurr)
    <=> v132928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17191,axiom,
    ! [VarCurr: state_type] :
      ( v132928(VarCurr)
    <=> ( v132979(VarCurr)
        | v132975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17190,axiom,
    ! [VarCurr: state_type] :
      ( v132979(VarCurr)
    <=> ( v132930(VarCurr)
        & v132934(VarCurr) ) ) ).

tff(addAssignment_75687,axiom,
    ! [VarCurr: state_type] :
      ( v132975(VarCurr)
    <=> v132977(VarCurr) ) ).

tff(addAssignment_75686,axiom,
    ! [VarCurr: state_type] :
      ( v132977(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132959(VarNext)
       => ( v132934(VarNext)
        <=> v132934(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1824,axiom,
    ! [VarNext: state_type] :
      ( v132959(VarNext)
     => ( v132934(VarNext)
      <=> v132969(VarNext) ) ) ).

tff(addAssignment_75685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132969(VarNext)
      <=> v132967(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17189,axiom,
    ! [VarCurr: state_type] :
      ( v132967(VarCurr)
    <=> ( v132970(VarCurr)
        & v132971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17188,axiom,
    ! [VarCurr: state_type] :
      ( v132971(VarCurr)
    <=> ( v132940(VarCurr)
        | v132954(VarCurr) ) ) ).

tff(writeUnaryOperator_9603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132970(VarCurr)
    <=> v132936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132959(VarNext)
      <=> v132960(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132960(VarNext)
      <=> ( v132962(VarNext)
          & v132964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132964(VarCurr)
    <=> v132930(VarCurr) ) ).

tff(addAssignment_75684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132962(VarNext)
      <=> v132930(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_259,axiom,
    ( v132934(constB0)
  <=> $true ) ).

tff(addAssignment_75683,axiom,
    ! [VarCurr: state_type] :
      ( v132954(VarCurr)
    <=> v132956(VarCurr) ) ).

tff(addAssignment_75682,axiom,
    ! [VarCurr: state_type] :
      ( v132956(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75681,axiom,
    ! [VarCurr: state_type] :
      ( v132940(VarCurr)
    <=> v132942(VarCurr) ) ).

tff(addAssignment_75680,axiom,
    ! [VarCurr: state_type] :
      ( v132942(VarCurr)
    <=> v132944(VarCurr) ) ).

tff(addAssignment_75679,axiom,
    ! [VarCurr: state_type] :
      ( v132944(VarCurr)
    <=> v132946(VarCurr) ) ).

tff(addAssignment_75678,axiom,
    ! [VarCurr: state_type] :
      ( v132946(VarCurr)
    <=> v132948(VarCurr) ) ).

tff(addAssignment_75677,axiom,
    ! [VarCurr: state_type] :
      ( v132948(VarCurr)
    <=> v132950(VarCurr) ) ).

tff(addAssignment_75676,axiom,
    ! [VarCurr: state_type] :
      ( v132950(VarCurr)
    <=> v132952(VarCurr) ) ).

tff(addAssignment_75675,axiom,
    ! [VarCurr: state_type] :
      ( v132952(VarCurr)
    <=> v129908(VarCurr) ) ).

tff(addAssignment_75674,axiom,
    ! [VarCurr: state_type] :
      ( v132936(VarCurr)
    <=> v132938(VarCurr) ) ).

tff(addAssignment_75673,axiom,
    ! [VarCurr: state_type] :
      ( v132938(VarCurr)
    <=> $false ) ).

tff(addAssignment_75672,axiom,
    ! [VarCurr: state_type] :
      ( v132930(VarCurr)
    <=> v132932(VarCurr) ) ).

tff(addAssignment_75671,axiom,
    ! [VarCurr: state_type] :
      ( v132932(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132919(VarCurr,B)
      <=> v132921(VarCurr,B) ) ) ).

tff(addAssignment_75669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132921(VarCurr,B)
      <=> v132922(VarCurr,B) ) ) ).

tff(addAssignment_75668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v132922(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75667,axiom,
    ! [VarCurr: state_type] :
      ( ( v132922(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v132922(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v132922(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v132922(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v132922(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v132922(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v132922(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v132922(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v132922(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v132922(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v132922(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v132922(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v132922(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v132922(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v132922(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75666,axiom,
    ! [VarCurr: state_type] :
      ( ( v132922(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v132922(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v132922(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75665,axiom,
    ! [VarCurr: state_type] :
      ( ( v132922(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v132922(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v132922(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v132922(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75664,axiom,
    ! [VarCurr: state_type] :
      ( v132909(VarCurr)
    <=> v132911(VarCurr) ) ).

tff(addAssignment_75663,axiom,
    ! [VarCurr: state_type] :
      ( v132911(VarCurr)
    <=> v132913(VarCurr) ) ).

tff(addAssignment_75662,axiom,
    ! [VarCurr: state_type] :
      ( v132913(VarCurr)
    <=> v132915(VarCurr) ) ).

tff(addAssignment_75661,axiom,
    ! [VarCurr: state_type] :
      ( v132915(VarCurr)
    <=> v132917(VarCurr) ) ).

tff(addAssignment_75660,axiom,
    ! [VarCurr: state_type] :
      ( v132917(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75659,axiom,
    ! [VarCurr: state_type] :
      ( v132899(VarCurr)
    <=> v132901(VarCurr) ) ).

tff(addAssignment_75658,axiom,
    ! [VarCurr: state_type] :
      ( v132901(VarCurr)
    <=> v132903(VarCurr) ) ).

tff(addAssignment_75657,axiom,
    ! [VarCurr: state_type] :
      ( v132903(VarCurr)
    <=> v132905(VarCurr) ) ).

tff(addAssignment_75656,axiom,
    ! [VarCurr: state_type] :
      ( v132905(VarCurr)
    <=> v132907(VarCurr) ) ).

tff(addAssignment_75655,axiom,
    ! [VarCurr: state_type] :
      ( v132907(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132884(VarCurr,B)
      <=> v132886(VarCurr,B) ) ) ).

tff(addAssignment_75653,axiom,
    ! [VarCurr: state_type] :
      ( v132886(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75652,axiom,
    ! [VarCurr: state_type] :
      ( ( v132886(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v132886(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v132886(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v132886(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v132886(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v132886(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v132886(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v132886(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75651,axiom,
    ! [VarCurr: state_type] :
      ( ( v132886(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v132886(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v132886(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v132886(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v132886(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v132886(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v132886(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v132886(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v132886(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v132886(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v132886(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v132886(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v132886(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v132886(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v132886(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75650,axiom,
    ! [VarCurr: state_type] :
      ( ( v132886(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v132886(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v132886(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75649,axiom,
    ! [VarCurr: state_type] :
      ( ( v132886(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v132886(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v132886(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v132886(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75648,axiom,
    ! [VarCurr: state_type] :
      ( v132886(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75647,axiom,
    ! [VarCurr: state_type] :
      ( v132713(VarCurr)
    <=> v132715(VarCurr) ) ).

tff(addAssignment_75646,axiom,
    ! [VarCurr: state_type] :
      ( v132715(VarCurr)
    <=> v132717(VarCurr) ) ).

tff(addAssignment_75645,axiom,
    ! [VarCurr: state_type] :
      ( v132717(VarCurr)
    <=> v132719(VarCurr) ) ).

tff(addAssignment_75644,axiom,
    ! [VarCurr: state_type] :
      ( v132719(VarCurr)
    <=> v132721(VarCurr) ) ).

tff(addAssignment_75643,axiom,
    ! [VarCurr: state_type] :
      ( v132721(VarCurr)
    <=> v132723(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1718,axiom,
    ! [VarCurr: state_type] :
      ( v132723(VarCurr)
    <=> ( ( v132725(VarCurr,31)
        <=> v132730(VarCurr,31) )
        & ( v132725(VarCurr,30)
        <=> v132730(VarCurr,30) )
        & ( v132725(VarCurr,29)
        <=> v132730(VarCurr,29) )
        & ( v132725(VarCurr,28)
        <=> v132730(VarCurr,28) )
        & ( v132725(VarCurr,27)
        <=> v132730(VarCurr,27) )
        & ( v132725(VarCurr,26)
        <=> v132730(VarCurr,26) )
        & ( v132725(VarCurr,25)
        <=> v132730(VarCurr,25) )
        & ( v132725(VarCurr,24)
        <=> v132730(VarCurr,24) )
        & ( v132725(VarCurr,23)
        <=> v132730(VarCurr,23) )
        & ( v132725(VarCurr,22)
        <=> v132730(VarCurr,22) )
        & ( v132725(VarCurr,21)
        <=> v132730(VarCurr,21) )
        & ( v132725(VarCurr,20)
        <=> v132730(VarCurr,20) )
        & ( v132725(VarCurr,19)
        <=> v132730(VarCurr,19) )
        & ( v132725(VarCurr,18)
        <=> v132730(VarCurr,18) )
        & ( v132725(VarCurr,17)
        <=> v132730(VarCurr,17) )
        & ( v132725(VarCurr,16)
        <=> v132730(VarCurr,16) )
        & ( v132725(VarCurr,15)
        <=> v132730(VarCurr,15) )
        & ( v132725(VarCurr,14)
        <=> v132730(VarCurr,14) )
        & ( v132725(VarCurr,13)
        <=> v132730(VarCurr,13) )
        & ( v132725(VarCurr,12)
        <=> v132730(VarCurr,12) )
        & ( v132725(VarCurr,11)
        <=> v132730(VarCurr,11) )
        & ( v132725(VarCurr,10)
        <=> v132730(VarCurr,10) )
        & ( v132725(VarCurr,9)
        <=> v132730(VarCurr,9) )
        & ( v132725(VarCurr,8)
        <=> v132730(VarCurr,8) )
        & ( v132725(VarCurr,7)
        <=> v132730(VarCurr,7) )
        & ( v132725(VarCurr,6)
        <=> v132730(VarCurr,6) )
        & ( v132725(VarCurr,5)
        <=> v132730(VarCurr,5) )
        & ( v132725(VarCurr,4)
        <=> v132730(VarCurr,4) )
        & ( v132725(VarCurr,3)
        <=> v132730(VarCurr,3) )
        & ( v132725(VarCurr,2)
        <=> v132730(VarCurr,2) )
        & ( v132725(VarCurr,1)
        <=> v132730(VarCurr,1) )
        & ( v132725(VarCurr,0)
        <=> v132730(VarCurr,0) ) ) ) ).

tff(addAssignment_75642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132730(VarCurr,B)
      <=> v132732(VarCurr,B) ) ) ).

tff(addAssignment_75641,axiom,
    ! [VarCurr: state_type] :
      ( ( v132732(VarCurr,8)
      <=> v132860(VarCurr,10) )
      & ( v132732(VarCurr,7)
      <=> v132860(VarCurr,9) )
      & ( v132732(VarCurr,6)
      <=> v132860(VarCurr,8) )
      & ( v132732(VarCurr,5)
      <=> v132860(VarCurr,7) )
      & ( v132732(VarCurr,4)
      <=> v132860(VarCurr,6) )
      & ( v132732(VarCurr,3)
      <=> v132860(VarCurr,5) )
      & ( v132732(VarCurr,2)
      <=> v132860(VarCurr,4) )
      & ( v132732(VarCurr,1)
      <=> v132860(VarCurr,3) )
      & ( v132732(VarCurr,0)
      <=> v132860(VarCurr,2) ) ) ).

tff(addAssignment_75640,axiom,
    ! [VarCurr: state_type] :
      ( ( v132732(VarCurr,23)
      <=> v132850(VarCurr,14) )
      & ( v132732(VarCurr,22)
      <=> v132850(VarCurr,13) )
      & ( v132732(VarCurr,21)
      <=> v132850(VarCurr,12) )
      & ( v132732(VarCurr,20)
      <=> v132850(VarCurr,11) )
      & ( v132732(VarCurr,19)
      <=> v132850(VarCurr,10) )
      & ( v132732(VarCurr,18)
      <=> v132850(VarCurr,9) )
      & ( v132732(VarCurr,17)
      <=> v132850(VarCurr,8) )
      & ( v132732(VarCurr,16)
      <=> v132850(VarCurr,7) )
      & ( v132732(VarCurr,15)
      <=> v132850(VarCurr,6) )
      & ( v132732(VarCurr,14)
      <=> v132850(VarCurr,5) )
      & ( v132732(VarCurr,13)
      <=> v132850(VarCurr,4) )
      & ( v132732(VarCurr,12)
      <=> v132850(VarCurr,3) )
      & ( v132732(VarCurr,11)
      <=> v132850(VarCurr,2) )
      & ( v132732(VarCurr,10)
      <=> v132850(VarCurr,1) )
      & ( v132732(VarCurr,9)
      <=> v132850(VarCurr,0) ) ) ).

tff(addAssignment_75639,axiom,
    ! [VarCurr: state_type] :
      ( ( v132732(VarCurr,26)
      <=> v132840(VarCurr,2) )
      & ( v132732(VarCurr,25)
      <=> v132840(VarCurr,1) )
      & ( v132732(VarCurr,24)
      <=> v132840(VarCurr,0) ) ) ).

tff(addAssignment_75638,axiom,
    ! [VarCurr: state_type] :
      ( ( v132732(VarCurr,30)
      <=> v132734(VarCurr,3) )
      & ( v132732(VarCurr,29)
      <=> v132734(VarCurr,2) )
      & ( v132732(VarCurr,28)
      <=> v132734(VarCurr,1) )
      & ( v132732(VarCurr,27)
      <=> v132734(VarCurr,0) ) ) ).

tff(addAssignment_75637,axiom,
    ! [VarCurr: state_type] :
      ( v132732(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132860(VarCurr,B)
      <=> v132736(VarCurr,B) ) ) ).

tff(addAssignment_75635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132736(VarCurr,B)
      <=> v132738(VarCurr,B) ) ) ).

tff(addAssignment_75634,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132738(VarNext,B)
      <=> v132862(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132863(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132862(VarNext,B)
            <=> v132738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1823,axiom,
    ! [VarNext: state_type] :
      ( v132863(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132862(VarNext,B)
          <=> v132833(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132863(VarNext)
      <=> v132864(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132864(VarNext)
      <=> ( v132866(VarNext)
          & v132765(VarNext) ) ) ) ).

tff(writeUnaryOperator_9601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132866(VarNext)
      <=> v132827(VarNext) ) ) ).

tff(addAssignment_75633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132760(VarCurr,B)
      <=> v132762(VarCurr,B) ) ) ).

tff(addAssignment_75632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132762(VarCurr,B)
      <=> v132763(VarCurr,B) ) ) ).

tff(addAssignment_75631,axiom,
    ! [VarCurr: state_type] :
      ( ( v132850(VarCurr,14)
      <=> v132736(VarCurr,25) )
      & ( v132850(VarCurr,13)
      <=> v132736(VarCurr,24) )
      & ( v132850(VarCurr,12)
      <=> v132736(VarCurr,23) )
      & ( v132850(VarCurr,11)
      <=> v132736(VarCurr,22) )
      & ( v132850(VarCurr,10)
      <=> v132736(VarCurr,21) )
      & ( v132850(VarCurr,9)
      <=> v132736(VarCurr,20) )
      & ( v132850(VarCurr,8)
      <=> v132736(VarCurr,19) )
      & ( v132850(VarCurr,7)
      <=> v132736(VarCurr,18) )
      & ( v132850(VarCurr,6)
      <=> v132736(VarCurr,17) )
      & ( v132850(VarCurr,5)
      <=> v132736(VarCurr,16) )
      & ( v132850(VarCurr,4)
      <=> v132736(VarCurr,15) )
      & ( v132850(VarCurr,3)
      <=> v132736(VarCurr,14) )
      & ( v132850(VarCurr,2)
      <=> v132736(VarCurr,13) )
      & ( v132850(VarCurr,1)
      <=> v132736(VarCurr,12) )
      & ( v132850(VarCurr,0)
      <=> v132736(VarCurr,11) ) ) ).

tff(addAssignment_75630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132736(VarCurr,B)
      <=> v132738(VarCurr,B) ) ) ).

tff(addAssignment_75629,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132738(VarNext,B)
      <=> v132852(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132853(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132852(VarNext,B)
            <=> v132738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1822,axiom,
    ! [VarNext: state_type] :
      ( v132853(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132852(VarNext,B)
          <=> v132833(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132853(VarNext)
      <=> v132854(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132854(VarNext)
      <=> ( v132856(VarNext)
          & v132765(VarNext) ) ) ) ).

tff(writeUnaryOperator_9600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132856(VarNext)
      <=> v132827(VarNext) ) ) ).

tff(addAssignment_75628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132760(VarCurr,B)
      <=> v132762(VarCurr,B) ) ) ).

tff(addAssignment_75627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132762(VarCurr,B)
      <=> v132763(VarCurr,B) ) ) ).

tff(addAssignment_75626,axiom,
    ! [VarCurr: state_type] :
      ( ( v132840(VarCurr,2)
      <=> v132736(VarCurr,28) )
      & ( v132840(VarCurr,1)
      <=> v132736(VarCurr,27) )
      & ( v132840(VarCurr,0)
      <=> v132736(VarCurr,26) ) ) ).

tff(addAssignment_75625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132736(VarCurr,B)
      <=> v132738(VarCurr,B) ) ) ).

tff(addAssignment_75624,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132738(VarNext,B)
      <=> v132842(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132843(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132842(VarNext,B)
            <=> v132738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1821,axiom,
    ! [VarNext: state_type] :
      ( v132843(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132842(VarNext,B)
          <=> v132833(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132843(VarNext)
      <=> v132844(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132844(VarNext)
      <=> ( v132846(VarNext)
          & v132765(VarNext) ) ) ) ).

tff(writeUnaryOperator_9599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132846(VarNext)
      <=> v132827(VarNext) ) ) ).

tff(addAssignment_75623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132760(VarCurr,B)
      <=> v132762(VarCurr,B) ) ) ).

tff(addAssignment_75622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132762(VarCurr,B)
      <=> v132763(VarCurr,B) ) ) ).

tff(addAssignment_75621,axiom,
    ! [VarCurr: state_type] :
      ( ( v132734(VarCurr,3)
      <=> v132736(VarCurr,32) )
      & ( v132734(VarCurr,2)
      <=> v132736(VarCurr,31) )
      & ( v132734(VarCurr,1)
      <=> v132736(VarCurr,30) )
      & ( v132734(VarCurr,0)
      <=> v132736(VarCurr,29) ) ) ).

tff(addAssignment_75620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132736(VarCurr,B)
      <=> v132738(VarCurr,B) ) ) ).

tff(addAssignment_75619,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132738(VarNext,B)
      <=> v132822(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132823(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132822(VarNext,B)
            <=> v132738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1820,axiom,
    ! [VarNext: state_type] :
      ( v132823(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132822(VarNext,B)
          <=> v132833(VarNext,B) ) ) ) ).

tff(addAssignment_75618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132833(VarNext,B)
          <=> v132831(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132831(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1327,axiom,
    ! [VarCurr: state_type] :
      ( v132834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132831(VarCurr,B)
          <=> v132760(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17179,axiom,
    ! [VarCurr: state_type] :
      ( v132834(VarCurr)
    <=> ( v132835(VarCurr)
        & v132836(VarCurr) ) ) ).

tff(writeUnaryOperator_9598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132836(VarCurr)
    <=> v132750(VarCurr) ) ).

tff(writeUnaryOperator_9597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132835(VarCurr)
    <=> v132740(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132823(VarNext)
      <=> v132824(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132824(VarNext)
      <=> ( v132825(VarNext)
          & v132765(VarNext) ) ) ) ).

tff(writeUnaryOperator_9596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132825(VarNext)
      <=> v132827(VarNext) ) ) ).

tff(addAssignment_75617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132827(VarNext)
      <=> v132765(VarCurr) ) ) ).

tff(addAssignment_75616,axiom,
    ! [VarCurr: state_type] :
      ( v132765(VarCurr)
    <=> v132767(VarCurr) ) ).

tff(addAssignment_75615,axiom,
    ! [VarCurr: state_type] :
      ( v132767(VarCurr)
    <=> v132769(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17176,axiom,
    ! [VarCurr: state_type] :
      ( v132769(VarCurr)
    <=> ( v132820(VarCurr)
        | v132816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17175,axiom,
    ! [VarCurr: state_type] :
      ( v132820(VarCurr)
    <=> ( v132771(VarCurr)
        & v132775(VarCurr) ) ) ).

tff(addAssignment_75614,axiom,
    ! [VarCurr: state_type] :
      ( v132816(VarCurr)
    <=> v132818(VarCurr) ) ).

tff(addAssignment_75613,axiom,
    ! [VarCurr: state_type] :
      ( v132818(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132800(VarNext)
       => ( v132775(VarNext)
        <=> v132775(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1819,axiom,
    ! [VarNext: state_type] :
      ( v132800(VarNext)
     => ( v132775(VarNext)
      <=> v132810(VarNext) ) ) ).

tff(addAssignment_75612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132810(VarNext)
      <=> v132808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17174,axiom,
    ! [VarCurr: state_type] :
      ( v132808(VarCurr)
    <=> ( v132811(VarCurr)
        & v132812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17173,axiom,
    ! [VarCurr: state_type] :
      ( v132812(VarCurr)
    <=> ( v132781(VarCurr)
        | v132795(VarCurr) ) ) ).

tff(writeUnaryOperator_9595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132811(VarCurr)
    <=> v132777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132800(VarNext)
      <=> v132801(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132801(VarNext)
      <=> ( v132803(VarNext)
          & v132805(VarNext) ) ) ) ).

tff(writeUnaryOperator_9594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132805(VarCurr)
    <=> v132771(VarCurr) ) ).

tff(addAssignment_75611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132803(VarNext)
      <=> v132771(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_258,axiom,
    ( v132775(constB0)
  <=> $true ) ).

tff(addAssignment_75610,axiom,
    ! [VarCurr: state_type] :
      ( v132795(VarCurr)
    <=> v132797(VarCurr) ) ).

tff(addAssignment_75609,axiom,
    ! [VarCurr: state_type] :
      ( v132797(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75608,axiom,
    ! [VarCurr: state_type] :
      ( v132781(VarCurr)
    <=> v132783(VarCurr) ) ).

tff(addAssignment_75607,axiom,
    ! [VarCurr: state_type] :
      ( v132783(VarCurr)
    <=> v132785(VarCurr) ) ).

tff(addAssignment_75606,axiom,
    ! [VarCurr: state_type] :
      ( v132785(VarCurr)
    <=> v132787(VarCurr) ) ).

tff(addAssignment_75605,axiom,
    ! [VarCurr: state_type] :
      ( v132787(VarCurr)
    <=> v132789(VarCurr) ) ).

tff(addAssignment_75604,axiom,
    ! [VarCurr: state_type] :
      ( v132789(VarCurr)
    <=> v132791(VarCurr) ) ).

tff(addAssignment_75603,axiom,
    ! [VarCurr: state_type] :
      ( v132791(VarCurr)
    <=> v132793(VarCurr) ) ).

tff(addAssignment_75602,axiom,
    ! [VarCurr: state_type] :
      ( v132793(VarCurr)
    <=> v129924(VarCurr) ) ).

tff(addAssignment_75601,axiom,
    ! [VarCurr: state_type] :
      ( v132777(VarCurr)
    <=> v132779(VarCurr) ) ).

tff(addAssignment_75600,axiom,
    ! [VarCurr: state_type] :
      ( v132779(VarCurr)
    <=> $false ) ).

tff(addAssignment_75599,axiom,
    ! [VarCurr: state_type] :
      ( v132771(VarCurr)
    <=> v132773(VarCurr) ) ).

tff(addAssignment_75598,axiom,
    ! [VarCurr: state_type] :
      ( v132773(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132760(VarCurr,B)
      <=> v132762(VarCurr,B) ) ) ).

tff(addAssignment_75596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132762(VarCurr,B)
      <=> v132763(VarCurr,B) ) ) ).

tff(addAssignment_75595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v132763(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75594,axiom,
    ! [VarCurr: state_type] :
      ( ( v132763(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v132763(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v132763(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v132763(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v132763(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v132763(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v132763(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v132763(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v132763(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v132763(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v132763(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v132763(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v132763(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v132763(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v132763(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75593,axiom,
    ! [VarCurr: state_type] :
      ( ( v132763(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v132763(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v132763(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75592,axiom,
    ! [VarCurr: state_type] :
      ( ( v132763(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v132763(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v132763(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v132763(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75591,axiom,
    ! [VarCurr: state_type] :
      ( v132750(VarCurr)
    <=> v132752(VarCurr) ) ).

tff(addAssignment_75590,axiom,
    ! [VarCurr: state_type] :
      ( v132752(VarCurr)
    <=> v132754(VarCurr) ) ).

tff(addAssignment_75589,axiom,
    ! [VarCurr: state_type] :
      ( v132754(VarCurr)
    <=> v132756(VarCurr) ) ).

tff(addAssignment_75588,axiom,
    ! [VarCurr: state_type] :
      ( v132756(VarCurr)
    <=> v132758(VarCurr) ) ).

tff(addAssignment_75587,axiom,
    ! [VarCurr: state_type] :
      ( v132758(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75586,axiom,
    ! [VarCurr: state_type] :
      ( v132740(VarCurr)
    <=> v132742(VarCurr) ) ).

tff(addAssignment_75585,axiom,
    ! [VarCurr: state_type] :
      ( v132742(VarCurr)
    <=> v132744(VarCurr) ) ).

tff(addAssignment_75584,axiom,
    ! [VarCurr: state_type] :
      ( v132744(VarCurr)
    <=> v132746(VarCurr) ) ).

tff(addAssignment_75583,axiom,
    ! [VarCurr: state_type] :
      ( v132746(VarCurr)
    <=> v132748(VarCurr) ) ).

tff(addAssignment_75582,axiom,
    ! [VarCurr: state_type] :
      ( v132748(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132725(VarCurr,B)
      <=> v132727(VarCurr,B) ) ) ).

tff(addAssignment_75580,axiom,
    ! [VarCurr: state_type] :
      ( v132727(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75579,axiom,
    ! [VarCurr: state_type] :
      ( ( v132727(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v132727(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v132727(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v132727(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v132727(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v132727(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v132727(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v132727(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75578,axiom,
    ! [VarCurr: state_type] :
      ( ( v132727(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v132727(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v132727(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v132727(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v132727(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v132727(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v132727(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v132727(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v132727(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v132727(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v132727(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v132727(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v132727(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v132727(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v132727(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75577,axiom,
    ! [VarCurr: state_type] :
      ( ( v132727(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v132727(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v132727(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75576,axiom,
    ! [VarCurr: state_type] :
      ( ( v132727(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v132727(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v132727(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v132727(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75575,axiom,
    ! [VarCurr: state_type] :
      ( v132727(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75574,axiom,
    ! [VarCurr: state_type] :
      ( v132554(VarCurr)
    <=> v132556(VarCurr) ) ).

tff(addAssignment_75573,axiom,
    ! [VarCurr: state_type] :
      ( v132556(VarCurr)
    <=> v132558(VarCurr) ) ).

tff(addAssignment_75572,axiom,
    ! [VarCurr: state_type] :
      ( v132558(VarCurr)
    <=> v132560(VarCurr) ) ).

tff(addAssignment_75571,axiom,
    ! [VarCurr: state_type] :
      ( v132560(VarCurr)
    <=> v132562(VarCurr) ) ).

tff(addAssignment_75570,axiom,
    ! [VarCurr: state_type] :
      ( v132562(VarCurr)
    <=> v132564(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1717,axiom,
    ! [VarCurr: state_type] :
      ( v132564(VarCurr)
    <=> ( ( v132566(VarCurr,31)
        <=> v132571(VarCurr,31) )
        & ( v132566(VarCurr,30)
        <=> v132571(VarCurr,30) )
        & ( v132566(VarCurr,29)
        <=> v132571(VarCurr,29) )
        & ( v132566(VarCurr,28)
        <=> v132571(VarCurr,28) )
        & ( v132566(VarCurr,27)
        <=> v132571(VarCurr,27) )
        & ( v132566(VarCurr,26)
        <=> v132571(VarCurr,26) )
        & ( v132566(VarCurr,25)
        <=> v132571(VarCurr,25) )
        & ( v132566(VarCurr,24)
        <=> v132571(VarCurr,24) )
        & ( v132566(VarCurr,23)
        <=> v132571(VarCurr,23) )
        & ( v132566(VarCurr,22)
        <=> v132571(VarCurr,22) )
        & ( v132566(VarCurr,21)
        <=> v132571(VarCurr,21) )
        & ( v132566(VarCurr,20)
        <=> v132571(VarCurr,20) )
        & ( v132566(VarCurr,19)
        <=> v132571(VarCurr,19) )
        & ( v132566(VarCurr,18)
        <=> v132571(VarCurr,18) )
        & ( v132566(VarCurr,17)
        <=> v132571(VarCurr,17) )
        & ( v132566(VarCurr,16)
        <=> v132571(VarCurr,16) )
        & ( v132566(VarCurr,15)
        <=> v132571(VarCurr,15) )
        & ( v132566(VarCurr,14)
        <=> v132571(VarCurr,14) )
        & ( v132566(VarCurr,13)
        <=> v132571(VarCurr,13) )
        & ( v132566(VarCurr,12)
        <=> v132571(VarCurr,12) )
        & ( v132566(VarCurr,11)
        <=> v132571(VarCurr,11) )
        & ( v132566(VarCurr,10)
        <=> v132571(VarCurr,10) )
        & ( v132566(VarCurr,9)
        <=> v132571(VarCurr,9) )
        & ( v132566(VarCurr,8)
        <=> v132571(VarCurr,8) )
        & ( v132566(VarCurr,7)
        <=> v132571(VarCurr,7) )
        & ( v132566(VarCurr,6)
        <=> v132571(VarCurr,6) )
        & ( v132566(VarCurr,5)
        <=> v132571(VarCurr,5) )
        & ( v132566(VarCurr,4)
        <=> v132571(VarCurr,4) )
        & ( v132566(VarCurr,3)
        <=> v132571(VarCurr,3) )
        & ( v132566(VarCurr,2)
        <=> v132571(VarCurr,2) )
        & ( v132566(VarCurr,1)
        <=> v132571(VarCurr,1) )
        & ( v132566(VarCurr,0)
        <=> v132571(VarCurr,0) ) ) ) ).

tff(addAssignment_75569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132571(VarCurr,B)
      <=> v132573(VarCurr,B) ) ) ).

tff(addAssignment_75568,axiom,
    ! [VarCurr: state_type] :
      ( ( v132573(VarCurr,8)
      <=> v132701(VarCurr,10) )
      & ( v132573(VarCurr,7)
      <=> v132701(VarCurr,9) )
      & ( v132573(VarCurr,6)
      <=> v132701(VarCurr,8) )
      & ( v132573(VarCurr,5)
      <=> v132701(VarCurr,7) )
      & ( v132573(VarCurr,4)
      <=> v132701(VarCurr,6) )
      & ( v132573(VarCurr,3)
      <=> v132701(VarCurr,5) )
      & ( v132573(VarCurr,2)
      <=> v132701(VarCurr,4) )
      & ( v132573(VarCurr,1)
      <=> v132701(VarCurr,3) )
      & ( v132573(VarCurr,0)
      <=> v132701(VarCurr,2) ) ) ).

tff(addAssignment_75567,axiom,
    ! [VarCurr: state_type] :
      ( ( v132573(VarCurr,23)
      <=> v132691(VarCurr,14) )
      & ( v132573(VarCurr,22)
      <=> v132691(VarCurr,13) )
      & ( v132573(VarCurr,21)
      <=> v132691(VarCurr,12) )
      & ( v132573(VarCurr,20)
      <=> v132691(VarCurr,11) )
      & ( v132573(VarCurr,19)
      <=> v132691(VarCurr,10) )
      & ( v132573(VarCurr,18)
      <=> v132691(VarCurr,9) )
      & ( v132573(VarCurr,17)
      <=> v132691(VarCurr,8) )
      & ( v132573(VarCurr,16)
      <=> v132691(VarCurr,7) )
      & ( v132573(VarCurr,15)
      <=> v132691(VarCurr,6) )
      & ( v132573(VarCurr,14)
      <=> v132691(VarCurr,5) )
      & ( v132573(VarCurr,13)
      <=> v132691(VarCurr,4) )
      & ( v132573(VarCurr,12)
      <=> v132691(VarCurr,3) )
      & ( v132573(VarCurr,11)
      <=> v132691(VarCurr,2) )
      & ( v132573(VarCurr,10)
      <=> v132691(VarCurr,1) )
      & ( v132573(VarCurr,9)
      <=> v132691(VarCurr,0) ) ) ).

tff(addAssignment_75566,axiom,
    ! [VarCurr: state_type] :
      ( ( v132573(VarCurr,26)
      <=> v132681(VarCurr,2) )
      & ( v132573(VarCurr,25)
      <=> v132681(VarCurr,1) )
      & ( v132573(VarCurr,24)
      <=> v132681(VarCurr,0) ) ) ).

tff(addAssignment_75565,axiom,
    ! [VarCurr: state_type] :
      ( ( v132573(VarCurr,30)
      <=> v132575(VarCurr,3) )
      & ( v132573(VarCurr,29)
      <=> v132575(VarCurr,2) )
      & ( v132573(VarCurr,28)
      <=> v132575(VarCurr,1) )
      & ( v132573(VarCurr,27)
      <=> v132575(VarCurr,0) ) ) ).

tff(addAssignment_75564,axiom,
    ! [VarCurr: state_type] :
      ( v132573(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132701(VarCurr,B)
      <=> v132577(VarCurr,B) ) ) ).

tff(addAssignment_75562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132577(VarCurr,B)
      <=> v132579(VarCurr,B) ) ) ).

tff(addAssignment_75561,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132579(VarNext,B)
      <=> v132703(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132704(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132703(VarNext,B)
            <=> v132579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1818,axiom,
    ! [VarNext: state_type] :
      ( v132704(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132703(VarNext,B)
          <=> v132674(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132704(VarNext)
      <=> v132705(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132705(VarNext)
      <=> ( v132707(VarNext)
          & v132606(VarNext) ) ) ) ).

tff(writeUnaryOperator_9593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132707(VarNext)
      <=> v132668(VarNext) ) ) ).

tff(addAssignment_75560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132601(VarCurr,B)
      <=> v132603(VarCurr,B) ) ) ).

tff(addAssignment_75559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132603(VarCurr,B)
      <=> v132604(VarCurr,B) ) ) ).

tff(addAssignment_75558,axiom,
    ! [VarCurr: state_type] :
      ( ( v132691(VarCurr,14)
      <=> v132577(VarCurr,25) )
      & ( v132691(VarCurr,13)
      <=> v132577(VarCurr,24) )
      & ( v132691(VarCurr,12)
      <=> v132577(VarCurr,23) )
      & ( v132691(VarCurr,11)
      <=> v132577(VarCurr,22) )
      & ( v132691(VarCurr,10)
      <=> v132577(VarCurr,21) )
      & ( v132691(VarCurr,9)
      <=> v132577(VarCurr,20) )
      & ( v132691(VarCurr,8)
      <=> v132577(VarCurr,19) )
      & ( v132691(VarCurr,7)
      <=> v132577(VarCurr,18) )
      & ( v132691(VarCurr,6)
      <=> v132577(VarCurr,17) )
      & ( v132691(VarCurr,5)
      <=> v132577(VarCurr,16) )
      & ( v132691(VarCurr,4)
      <=> v132577(VarCurr,15) )
      & ( v132691(VarCurr,3)
      <=> v132577(VarCurr,14) )
      & ( v132691(VarCurr,2)
      <=> v132577(VarCurr,13) )
      & ( v132691(VarCurr,1)
      <=> v132577(VarCurr,12) )
      & ( v132691(VarCurr,0)
      <=> v132577(VarCurr,11) ) ) ).

tff(addAssignment_75557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132577(VarCurr,B)
      <=> v132579(VarCurr,B) ) ) ).

tff(addAssignment_75556,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132579(VarNext,B)
      <=> v132693(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132694(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132693(VarNext,B)
            <=> v132579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1817,axiom,
    ! [VarNext: state_type] :
      ( v132694(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132693(VarNext,B)
          <=> v132674(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132694(VarNext)
      <=> v132695(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132695(VarNext)
      <=> ( v132697(VarNext)
          & v132606(VarNext) ) ) ) ).

tff(writeUnaryOperator_9592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132697(VarNext)
      <=> v132668(VarNext) ) ) ).

tff(addAssignment_75555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132601(VarCurr,B)
      <=> v132603(VarCurr,B) ) ) ).

tff(addAssignment_75554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132603(VarCurr,B)
      <=> v132604(VarCurr,B) ) ) ).

tff(addAssignment_75553,axiom,
    ! [VarCurr: state_type] :
      ( ( v132681(VarCurr,2)
      <=> v132577(VarCurr,28) )
      & ( v132681(VarCurr,1)
      <=> v132577(VarCurr,27) )
      & ( v132681(VarCurr,0)
      <=> v132577(VarCurr,26) ) ) ).

tff(addAssignment_75552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132577(VarCurr,B)
      <=> v132579(VarCurr,B) ) ) ).

tff(addAssignment_75551,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132579(VarNext,B)
      <=> v132683(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132684(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132683(VarNext,B)
            <=> v132579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1816,axiom,
    ! [VarNext: state_type] :
      ( v132684(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132683(VarNext,B)
          <=> v132674(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132684(VarNext)
      <=> v132685(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132685(VarNext)
      <=> ( v132687(VarNext)
          & v132606(VarNext) ) ) ) ).

tff(writeUnaryOperator_9591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132687(VarNext)
      <=> v132668(VarNext) ) ) ).

tff(addAssignment_75550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132601(VarCurr,B)
      <=> v132603(VarCurr,B) ) ) ).

tff(addAssignment_75549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132603(VarCurr,B)
      <=> v132604(VarCurr,B) ) ) ).

tff(addAssignment_75548,axiom,
    ! [VarCurr: state_type] :
      ( ( v132575(VarCurr,3)
      <=> v132577(VarCurr,32) )
      & ( v132575(VarCurr,2)
      <=> v132577(VarCurr,31) )
      & ( v132575(VarCurr,1)
      <=> v132577(VarCurr,30) )
      & ( v132575(VarCurr,0)
      <=> v132577(VarCurr,29) ) ) ).

tff(addAssignment_75547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132577(VarCurr,B)
      <=> v132579(VarCurr,B) ) ) ).

tff(addAssignment_75546,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132579(VarNext,B)
      <=> v132663(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132664(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132663(VarNext,B)
            <=> v132579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1815,axiom,
    ! [VarNext: state_type] :
      ( v132664(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132663(VarNext,B)
          <=> v132674(VarNext,B) ) ) ) ).

tff(addAssignment_75545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132674(VarNext,B)
          <=> v132672(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132675(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132672(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1326,axiom,
    ! [VarCurr: state_type] :
      ( v132675(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132672(VarCurr,B)
          <=> v132601(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17164,axiom,
    ! [VarCurr: state_type] :
      ( v132675(VarCurr)
    <=> ( v132676(VarCurr)
        & v132677(VarCurr) ) ) ).

tff(writeUnaryOperator_9590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132677(VarCurr)
    <=> v132591(VarCurr) ) ).

tff(writeUnaryOperator_9589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132676(VarCurr)
    <=> v132581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132664(VarNext)
      <=> v132665(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132665(VarNext)
      <=> ( v132666(VarNext)
          & v132606(VarNext) ) ) ) ).

tff(writeUnaryOperator_9588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132666(VarNext)
      <=> v132668(VarNext) ) ) ).

tff(addAssignment_75544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132668(VarNext)
      <=> v132606(VarCurr) ) ) ).

tff(addAssignment_75543,axiom,
    ! [VarCurr: state_type] :
      ( v132606(VarCurr)
    <=> v132608(VarCurr) ) ).

tff(addAssignment_75542,axiom,
    ! [VarCurr: state_type] :
      ( v132608(VarCurr)
    <=> v132610(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17161,axiom,
    ! [VarCurr: state_type] :
      ( v132610(VarCurr)
    <=> ( v132661(VarCurr)
        | v132657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17160,axiom,
    ! [VarCurr: state_type] :
      ( v132661(VarCurr)
    <=> ( v132612(VarCurr)
        & v132616(VarCurr) ) ) ).

tff(addAssignment_75541,axiom,
    ! [VarCurr: state_type] :
      ( v132657(VarCurr)
    <=> v132659(VarCurr) ) ).

tff(addAssignment_75540,axiom,
    ! [VarCurr: state_type] :
      ( v132659(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132641(VarNext)
       => ( v132616(VarNext)
        <=> v132616(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1814,axiom,
    ! [VarNext: state_type] :
      ( v132641(VarNext)
     => ( v132616(VarNext)
      <=> v132651(VarNext) ) ) ).

tff(addAssignment_75539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132651(VarNext)
      <=> v132649(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17159,axiom,
    ! [VarCurr: state_type] :
      ( v132649(VarCurr)
    <=> ( v132652(VarCurr)
        & v132653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17158,axiom,
    ! [VarCurr: state_type] :
      ( v132653(VarCurr)
    <=> ( v132622(VarCurr)
        | v132636(VarCurr) ) ) ).

tff(writeUnaryOperator_9587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132652(VarCurr)
    <=> v132618(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132641(VarNext)
      <=> v132642(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132642(VarNext)
      <=> ( v132644(VarNext)
          & v132646(VarNext) ) ) ) ).

tff(writeUnaryOperator_9586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132646(VarCurr)
    <=> v132612(VarCurr) ) ).

tff(addAssignment_75538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132644(VarNext)
      <=> v132612(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_257,axiom,
    ( v132616(constB0)
  <=> $true ) ).

tff(addAssignment_75537,axiom,
    ! [VarCurr: state_type] :
      ( v132636(VarCurr)
    <=> v132638(VarCurr) ) ).

tff(addAssignment_75536,axiom,
    ! [VarCurr: state_type] :
      ( v132638(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75535,axiom,
    ! [VarCurr: state_type] :
      ( v132622(VarCurr)
    <=> v132624(VarCurr) ) ).

tff(addAssignment_75534,axiom,
    ! [VarCurr: state_type] :
      ( v132624(VarCurr)
    <=> v132626(VarCurr) ) ).

tff(addAssignment_75533,axiom,
    ! [VarCurr: state_type] :
      ( v132626(VarCurr)
    <=> v132628(VarCurr) ) ).

tff(addAssignment_75532,axiom,
    ! [VarCurr: state_type] :
      ( v132628(VarCurr)
    <=> v132630(VarCurr) ) ).

tff(addAssignment_75531,axiom,
    ! [VarCurr: state_type] :
      ( v132630(VarCurr)
    <=> v132632(VarCurr) ) ).

tff(addAssignment_75530,axiom,
    ! [VarCurr: state_type] :
      ( v132632(VarCurr)
    <=> v132634(VarCurr) ) ).

tff(addAssignment_75529,axiom,
    ! [VarCurr: state_type] :
      ( v132634(VarCurr)
    <=> v129940(VarCurr) ) ).

tff(addAssignment_75528,axiom,
    ! [VarCurr: state_type] :
      ( v132618(VarCurr)
    <=> v132620(VarCurr) ) ).

tff(addAssignment_75527,axiom,
    ! [VarCurr: state_type] :
      ( v132620(VarCurr)
    <=> $false ) ).

tff(addAssignment_75526,axiom,
    ! [VarCurr: state_type] :
      ( v132612(VarCurr)
    <=> v132614(VarCurr) ) ).

tff(addAssignment_75525,axiom,
    ! [VarCurr: state_type] :
      ( v132614(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132601(VarCurr,B)
      <=> v132603(VarCurr,B) ) ) ).

tff(addAssignment_75523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132603(VarCurr,B)
      <=> v132604(VarCurr,B) ) ) ).

tff(addAssignment_75522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v132604(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75521,axiom,
    ! [VarCurr: state_type] :
      ( ( v132604(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v132604(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v132604(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v132604(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v132604(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v132604(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v132604(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v132604(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v132604(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v132604(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v132604(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v132604(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v132604(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v132604(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v132604(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75520,axiom,
    ! [VarCurr: state_type] :
      ( ( v132604(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v132604(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v132604(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75519,axiom,
    ! [VarCurr: state_type] :
      ( ( v132604(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v132604(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v132604(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v132604(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75518,axiom,
    ! [VarCurr: state_type] :
      ( v132591(VarCurr)
    <=> v132593(VarCurr) ) ).

tff(addAssignment_75517,axiom,
    ! [VarCurr: state_type] :
      ( v132593(VarCurr)
    <=> v132595(VarCurr) ) ).

tff(addAssignment_75516,axiom,
    ! [VarCurr: state_type] :
      ( v132595(VarCurr)
    <=> v132597(VarCurr) ) ).

tff(addAssignment_75515,axiom,
    ! [VarCurr: state_type] :
      ( v132597(VarCurr)
    <=> v132599(VarCurr) ) ).

tff(addAssignment_75514,axiom,
    ! [VarCurr: state_type] :
      ( v132599(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75513,axiom,
    ! [VarCurr: state_type] :
      ( v132581(VarCurr)
    <=> v132583(VarCurr) ) ).

tff(addAssignment_75512,axiom,
    ! [VarCurr: state_type] :
      ( v132583(VarCurr)
    <=> v132585(VarCurr) ) ).

tff(addAssignment_75511,axiom,
    ! [VarCurr: state_type] :
      ( v132585(VarCurr)
    <=> v132587(VarCurr) ) ).

tff(addAssignment_75510,axiom,
    ! [VarCurr: state_type] :
      ( v132587(VarCurr)
    <=> v132589(VarCurr) ) ).

tff(addAssignment_75509,axiom,
    ! [VarCurr: state_type] :
      ( v132589(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132566(VarCurr,B)
      <=> v132568(VarCurr,B) ) ) ).

tff(addAssignment_75507,axiom,
    ! [VarCurr: state_type] :
      ( v132568(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75506,axiom,
    ! [VarCurr: state_type] :
      ( ( v132568(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v132568(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v132568(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v132568(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v132568(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v132568(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v132568(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v132568(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75505,axiom,
    ! [VarCurr: state_type] :
      ( ( v132568(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v132568(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v132568(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v132568(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v132568(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v132568(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v132568(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v132568(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v132568(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v132568(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v132568(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v132568(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v132568(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v132568(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v132568(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75504,axiom,
    ! [VarCurr: state_type] :
      ( ( v132568(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v132568(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v132568(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75503,axiom,
    ! [VarCurr: state_type] :
      ( ( v132568(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v132568(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v132568(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v132568(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75502,axiom,
    ! [VarCurr: state_type] :
      ( v132568(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75501,axiom,
    ! [VarCurr: state_type] :
      ( v132395(VarCurr)
    <=> v132397(VarCurr) ) ).

tff(addAssignment_75500,axiom,
    ! [VarCurr: state_type] :
      ( v132397(VarCurr)
    <=> v132399(VarCurr) ) ).

tff(addAssignment_75499,axiom,
    ! [VarCurr: state_type] :
      ( v132399(VarCurr)
    <=> v132401(VarCurr) ) ).

tff(addAssignment_75498,axiom,
    ! [VarCurr: state_type] :
      ( v132401(VarCurr)
    <=> v132403(VarCurr) ) ).

tff(addAssignment_75497,axiom,
    ! [VarCurr: state_type] :
      ( v132403(VarCurr)
    <=> v132405(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1716,axiom,
    ! [VarCurr: state_type] :
      ( v132405(VarCurr)
    <=> ( ( v132407(VarCurr,31)
        <=> v132412(VarCurr,31) )
        & ( v132407(VarCurr,30)
        <=> v132412(VarCurr,30) )
        & ( v132407(VarCurr,29)
        <=> v132412(VarCurr,29) )
        & ( v132407(VarCurr,28)
        <=> v132412(VarCurr,28) )
        & ( v132407(VarCurr,27)
        <=> v132412(VarCurr,27) )
        & ( v132407(VarCurr,26)
        <=> v132412(VarCurr,26) )
        & ( v132407(VarCurr,25)
        <=> v132412(VarCurr,25) )
        & ( v132407(VarCurr,24)
        <=> v132412(VarCurr,24) )
        & ( v132407(VarCurr,23)
        <=> v132412(VarCurr,23) )
        & ( v132407(VarCurr,22)
        <=> v132412(VarCurr,22) )
        & ( v132407(VarCurr,21)
        <=> v132412(VarCurr,21) )
        & ( v132407(VarCurr,20)
        <=> v132412(VarCurr,20) )
        & ( v132407(VarCurr,19)
        <=> v132412(VarCurr,19) )
        & ( v132407(VarCurr,18)
        <=> v132412(VarCurr,18) )
        & ( v132407(VarCurr,17)
        <=> v132412(VarCurr,17) )
        & ( v132407(VarCurr,16)
        <=> v132412(VarCurr,16) )
        & ( v132407(VarCurr,15)
        <=> v132412(VarCurr,15) )
        & ( v132407(VarCurr,14)
        <=> v132412(VarCurr,14) )
        & ( v132407(VarCurr,13)
        <=> v132412(VarCurr,13) )
        & ( v132407(VarCurr,12)
        <=> v132412(VarCurr,12) )
        & ( v132407(VarCurr,11)
        <=> v132412(VarCurr,11) )
        & ( v132407(VarCurr,10)
        <=> v132412(VarCurr,10) )
        & ( v132407(VarCurr,9)
        <=> v132412(VarCurr,9) )
        & ( v132407(VarCurr,8)
        <=> v132412(VarCurr,8) )
        & ( v132407(VarCurr,7)
        <=> v132412(VarCurr,7) )
        & ( v132407(VarCurr,6)
        <=> v132412(VarCurr,6) )
        & ( v132407(VarCurr,5)
        <=> v132412(VarCurr,5) )
        & ( v132407(VarCurr,4)
        <=> v132412(VarCurr,4) )
        & ( v132407(VarCurr,3)
        <=> v132412(VarCurr,3) )
        & ( v132407(VarCurr,2)
        <=> v132412(VarCurr,2) )
        & ( v132407(VarCurr,1)
        <=> v132412(VarCurr,1) )
        & ( v132407(VarCurr,0)
        <=> v132412(VarCurr,0) ) ) ) ).

tff(addAssignment_75496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132412(VarCurr,B)
      <=> v132414(VarCurr,B) ) ) ).

tff(addAssignment_75495,axiom,
    ! [VarCurr: state_type] :
      ( ( v132414(VarCurr,8)
      <=> v132542(VarCurr,10) )
      & ( v132414(VarCurr,7)
      <=> v132542(VarCurr,9) )
      & ( v132414(VarCurr,6)
      <=> v132542(VarCurr,8) )
      & ( v132414(VarCurr,5)
      <=> v132542(VarCurr,7) )
      & ( v132414(VarCurr,4)
      <=> v132542(VarCurr,6) )
      & ( v132414(VarCurr,3)
      <=> v132542(VarCurr,5) )
      & ( v132414(VarCurr,2)
      <=> v132542(VarCurr,4) )
      & ( v132414(VarCurr,1)
      <=> v132542(VarCurr,3) )
      & ( v132414(VarCurr,0)
      <=> v132542(VarCurr,2) ) ) ).

tff(addAssignment_75494,axiom,
    ! [VarCurr: state_type] :
      ( ( v132414(VarCurr,23)
      <=> v132532(VarCurr,14) )
      & ( v132414(VarCurr,22)
      <=> v132532(VarCurr,13) )
      & ( v132414(VarCurr,21)
      <=> v132532(VarCurr,12) )
      & ( v132414(VarCurr,20)
      <=> v132532(VarCurr,11) )
      & ( v132414(VarCurr,19)
      <=> v132532(VarCurr,10) )
      & ( v132414(VarCurr,18)
      <=> v132532(VarCurr,9) )
      & ( v132414(VarCurr,17)
      <=> v132532(VarCurr,8) )
      & ( v132414(VarCurr,16)
      <=> v132532(VarCurr,7) )
      & ( v132414(VarCurr,15)
      <=> v132532(VarCurr,6) )
      & ( v132414(VarCurr,14)
      <=> v132532(VarCurr,5) )
      & ( v132414(VarCurr,13)
      <=> v132532(VarCurr,4) )
      & ( v132414(VarCurr,12)
      <=> v132532(VarCurr,3) )
      & ( v132414(VarCurr,11)
      <=> v132532(VarCurr,2) )
      & ( v132414(VarCurr,10)
      <=> v132532(VarCurr,1) )
      & ( v132414(VarCurr,9)
      <=> v132532(VarCurr,0) ) ) ).

tff(addAssignment_75493,axiom,
    ! [VarCurr: state_type] :
      ( ( v132414(VarCurr,26)
      <=> v132522(VarCurr,2) )
      & ( v132414(VarCurr,25)
      <=> v132522(VarCurr,1) )
      & ( v132414(VarCurr,24)
      <=> v132522(VarCurr,0) ) ) ).

tff(addAssignment_75492,axiom,
    ! [VarCurr: state_type] :
      ( ( v132414(VarCurr,30)
      <=> v132416(VarCurr,3) )
      & ( v132414(VarCurr,29)
      <=> v132416(VarCurr,2) )
      & ( v132414(VarCurr,28)
      <=> v132416(VarCurr,1) )
      & ( v132414(VarCurr,27)
      <=> v132416(VarCurr,0) ) ) ).

tff(addAssignment_75491,axiom,
    ! [VarCurr: state_type] :
      ( v132414(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132542(VarCurr,B)
      <=> v132418(VarCurr,B) ) ) ).

tff(addAssignment_75489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132418(VarCurr,B)
      <=> v132420(VarCurr,B) ) ) ).

tff(addAssignment_75488,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132420(VarNext,B)
      <=> v132544(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132544(VarNext,B)
            <=> v132420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1813,axiom,
    ! [VarNext: state_type] :
      ( v132545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132544(VarNext,B)
          <=> v132515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132545(VarNext)
      <=> v132546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132546(VarNext)
      <=> ( v132548(VarNext)
          & v132447(VarNext) ) ) ) ).

tff(writeUnaryOperator_9585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132548(VarNext)
      <=> v132509(VarNext) ) ) ).

tff(addAssignment_75487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132442(VarCurr,B)
      <=> v132444(VarCurr,B) ) ) ).

tff(addAssignment_75486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132444(VarCurr,B)
      <=> v132445(VarCurr,B) ) ) ).

tff(addAssignment_75485,axiom,
    ! [VarCurr: state_type] :
      ( ( v132532(VarCurr,14)
      <=> v132418(VarCurr,25) )
      & ( v132532(VarCurr,13)
      <=> v132418(VarCurr,24) )
      & ( v132532(VarCurr,12)
      <=> v132418(VarCurr,23) )
      & ( v132532(VarCurr,11)
      <=> v132418(VarCurr,22) )
      & ( v132532(VarCurr,10)
      <=> v132418(VarCurr,21) )
      & ( v132532(VarCurr,9)
      <=> v132418(VarCurr,20) )
      & ( v132532(VarCurr,8)
      <=> v132418(VarCurr,19) )
      & ( v132532(VarCurr,7)
      <=> v132418(VarCurr,18) )
      & ( v132532(VarCurr,6)
      <=> v132418(VarCurr,17) )
      & ( v132532(VarCurr,5)
      <=> v132418(VarCurr,16) )
      & ( v132532(VarCurr,4)
      <=> v132418(VarCurr,15) )
      & ( v132532(VarCurr,3)
      <=> v132418(VarCurr,14) )
      & ( v132532(VarCurr,2)
      <=> v132418(VarCurr,13) )
      & ( v132532(VarCurr,1)
      <=> v132418(VarCurr,12) )
      & ( v132532(VarCurr,0)
      <=> v132418(VarCurr,11) ) ) ).

tff(addAssignment_75484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132418(VarCurr,B)
      <=> v132420(VarCurr,B) ) ) ).

tff(addAssignment_75483,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132420(VarNext,B)
      <=> v132534(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132535(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132534(VarNext,B)
            <=> v132420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1812,axiom,
    ! [VarNext: state_type] :
      ( v132535(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132534(VarNext,B)
          <=> v132515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132535(VarNext)
      <=> v132536(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132536(VarNext)
      <=> ( v132538(VarNext)
          & v132447(VarNext) ) ) ) ).

tff(writeUnaryOperator_9584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132538(VarNext)
      <=> v132509(VarNext) ) ) ).

tff(addAssignment_75482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132442(VarCurr,B)
      <=> v132444(VarCurr,B) ) ) ).

tff(addAssignment_75481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132444(VarCurr,B)
      <=> v132445(VarCurr,B) ) ) ).

tff(addAssignment_75480,axiom,
    ! [VarCurr: state_type] :
      ( ( v132522(VarCurr,2)
      <=> v132418(VarCurr,28) )
      & ( v132522(VarCurr,1)
      <=> v132418(VarCurr,27) )
      & ( v132522(VarCurr,0)
      <=> v132418(VarCurr,26) ) ) ).

tff(addAssignment_75479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132418(VarCurr,B)
      <=> v132420(VarCurr,B) ) ) ).

tff(addAssignment_75478,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132420(VarNext,B)
      <=> v132524(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132525(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132524(VarNext,B)
            <=> v132420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1811,axiom,
    ! [VarNext: state_type] :
      ( v132525(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132524(VarNext,B)
          <=> v132515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132525(VarNext)
      <=> v132526(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132526(VarNext)
      <=> ( v132528(VarNext)
          & v132447(VarNext) ) ) ) ).

tff(writeUnaryOperator_9583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132528(VarNext)
      <=> v132509(VarNext) ) ) ).

tff(addAssignment_75477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132442(VarCurr,B)
      <=> v132444(VarCurr,B) ) ) ).

tff(addAssignment_75476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132444(VarCurr,B)
      <=> v132445(VarCurr,B) ) ) ).

tff(addAssignment_75475,axiom,
    ! [VarCurr: state_type] :
      ( ( v132416(VarCurr,3)
      <=> v132418(VarCurr,32) )
      & ( v132416(VarCurr,2)
      <=> v132418(VarCurr,31) )
      & ( v132416(VarCurr,1)
      <=> v132418(VarCurr,30) )
      & ( v132416(VarCurr,0)
      <=> v132418(VarCurr,29) ) ) ).

tff(addAssignment_75474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132418(VarCurr,B)
      <=> v132420(VarCurr,B) ) ) ).

tff(addAssignment_75473,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132420(VarNext,B)
      <=> v132504(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132505(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132504(VarNext,B)
            <=> v132420(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1810,axiom,
    ! [VarNext: state_type] :
      ( v132505(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132504(VarNext,B)
          <=> v132515(VarNext,B) ) ) ) ).

tff(addAssignment_75472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132515(VarNext,B)
          <=> v132513(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132513(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1325,axiom,
    ! [VarCurr: state_type] :
      ( v132516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132513(VarCurr,B)
          <=> v132442(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17149,axiom,
    ! [VarCurr: state_type] :
      ( v132516(VarCurr)
    <=> ( v132517(VarCurr)
        & v132518(VarCurr) ) ) ).

tff(writeUnaryOperator_9582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132518(VarCurr)
    <=> v132432(VarCurr) ) ).

tff(writeUnaryOperator_9581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132517(VarCurr)
    <=> v132422(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132505(VarNext)
      <=> v132506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132506(VarNext)
      <=> ( v132507(VarNext)
          & v132447(VarNext) ) ) ) ).

tff(writeUnaryOperator_9580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132507(VarNext)
      <=> v132509(VarNext) ) ) ).

tff(addAssignment_75471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132509(VarNext)
      <=> v132447(VarCurr) ) ) ).

tff(addAssignment_75470,axiom,
    ! [VarCurr: state_type] :
      ( v132447(VarCurr)
    <=> v132449(VarCurr) ) ).

tff(addAssignment_75469,axiom,
    ! [VarCurr: state_type] :
      ( v132449(VarCurr)
    <=> v132451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17146,axiom,
    ! [VarCurr: state_type] :
      ( v132451(VarCurr)
    <=> ( v132502(VarCurr)
        | v132498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17145,axiom,
    ! [VarCurr: state_type] :
      ( v132502(VarCurr)
    <=> ( v132453(VarCurr)
        & v132457(VarCurr) ) ) ).

tff(addAssignment_75468,axiom,
    ! [VarCurr: state_type] :
      ( v132498(VarCurr)
    <=> v132500(VarCurr) ) ).

tff(addAssignment_75467,axiom,
    ! [VarCurr: state_type] :
      ( v132500(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132482(VarNext)
       => ( v132457(VarNext)
        <=> v132457(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1809,axiom,
    ! [VarNext: state_type] :
      ( v132482(VarNext)
     => ( v132457(VarNext)
      <=> v132492(VarNext) ) ) ).

tff(addAssignment_75466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132492(VarNext)
      <=> v132490(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17144,axiom,
    ! [VarCurr: state_type] :
      ( v132490(VarCurr)
    <=> ( v132493(VarCurr)
        & v132494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17143,axiom,
    ! [VarCurr: state_type] :
      ( v132494(VarCurr)
    <=> ( v132463(VarCurr)
        | v132477(VarCurr) ) ) ).

tff(writeUnaryOperator_9579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132493(VarCurr)
    <=> v132459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132482(VarNext)
      <=> v132483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132483(VarNext)
      <=> ( v132485(VarNext)
          & v132487(VarNext) ) ) ) ).

tff(writeUnaryOperator_9578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132487(VarCurr)
    <=> v132453(VarCurr) ) ).

tff(addAssignment_75465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132485(VarNext)
      <=> v132453(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_256,axiom,
    ( v132457(constB0)
  <=> $true ) ).

tff(addAssignment_75464,axiom,
    ! [VarCurr: state_type] :
      ( v132477(VarCurr)
    <=> v132479(VarCurr) ) ).

tff(addAssignment_75463,axiom,
    ! [VarCurr: state_type] :
      ( v132479(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75462,axiom,
    ! [VarCurr: state_type] :
      ( v132463(VarCurr)
    <=> v132465(VarCurr) ) ).

tff(addAssignment_75461,axiom,
    ! [VarCurr: state_type] :
      ( v132465(VarCurr)
    <=> v132467(VarCurr) ) ).

tff(addAssignment_75460,axiom,
    ! [VarCurr: state_type] :
      ( v132467(VarCurr)
    <=> v132469(VarCurr) ) ).

tff(addAssignment_75459,axiom,
    ! [VarCurr: state_type] :
      ( v132469(VarCurr)
    <=> v132471(VarCurr) ) ).

tff(addAssignment_75458,axiom,
    ! [VarCurr: state_type] :
      ( v132471(VarCurr)
    <=> v132473(VarCurr) ) ).

tff(addAssignment_75457,axiom,
    ! [VarCurr: state_type] :
      ( v132473(VarCurr)
    <=> v132475(VarCurr) ) ).

tff(addAssignment_75456,axiom,
    ! [VarCurr: state_type] :
      ( v132475(VarCurr)
    <=> v129956(VarCurr) ) ).

tff(addAssignment_75455,axiom,
    ! [VarCurr: state_type] :
      ( v132459(VarCurr)
    <=> v132461(VarCurr) ) ).

tff(addAssignment_75454,axiom,
    ! [VarCurr: state_type] :
      ( v132461(VarCurr)
    <=> $false ) ).

tff(addAssignment_75453,axiom,
    ! [VarCurr: state_type] :
      ( v132453(VarCurr)
    <=> v132455(VarCurr) ) ).

tff(addAssignment_75452,axiom,
    ! [VarCurr: state_type] :
      ( v132455(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132442(VarCurr,B)
      <=> v132444(VarCurr,B) ) ) ).

tff(addAssignment_75450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132444(VarCurr,B)
      <=> v132445(VarCurr,B) ) ) ).

tff(addAssignment_75449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v132445(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75448,axiom,
    ! [VarCurr: state_type] :
      ( ( v132445(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v132445(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v132445(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v132445(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v132445(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v132445(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v132445(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v132445(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v132445(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v132445(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v132445(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v132445(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v132445(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v132445(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v132445(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75447,axiom,
    ! [VarCurr: state_type] :
      ( ( v132445(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v132445(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v132445(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75446,axiom,
    ! [VarCurr: state_type] :
      ( ( v132445(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v132445(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v132445(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v132445(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75445,axiom,
    ! [VarCurr: state_type] :
      ( v132432(VarCurr)
    <=> v132434(VarCurr) ) ).

tff(addAssignment_75444,axiom,
    ! [VarCurr: state_type] :
      ( v132434(VarCurr)
    <=> v132436(VarCurr) ) ).

tff(addAssignment_75443,axiom,
    ! [VarCurr: state_type] :
      ( v132436(VarCurr)
    <=> v132438(VarCurr) ) ).

tff(addAssignment_75442,axiom,
    ! [VarCurr: state_type] :
      ( v132438(VarCurr)
    <=> v132440(VarCurr) ) ).

tff(addAssignment_75441,axiom,
    ! [VarCurr: state_type] :
      ( v132440(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75440,axiom,
    ! [VarCurr: state_type] :
      ( v132422(VarCurr)
    <=> v132424(VarCurr) ) ).

tff(addAssignment_75439,axiom,
    ! [VarCurr: state_type] :
      ( v132424(VarCurr)
    <=> v132426(VarCurr) ) ).

tff(addAssignment_75438,axiom,
    ! [VarCurr: state_type] :
      ( v132426(VarCurr)
    <=> v132428(VarCurr) ) ).

tff(addAssignment_75437,axiom,
    ! [VarCurr: state_type] :
      ( v132428(VarCurr)
    <=> v132430(VarCurr) ) ).

tff(addAssignment_75436,axiom,
    ! [VarCurr: state_type] :
      ( v132430(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132407(VarCurr,B)
      <=> v132409(VarCurr,B) ) ) ).

tff(addAssignment_75434,axiom,
    ! [VarCurr: state_type] :
      ( v132409(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75433,axiom,
    ! [VarCurr: state_type] :
      ( ( v132409(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v132409(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v132409(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v132409(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v132409(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v132409(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v132409(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v132409(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75432,axiom,
    ! [VarCurr: state_type] :
      ( ( v132409(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v132409(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v132409(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v132409(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v132409(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v132409(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v132409(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v132409(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v132409(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v132409(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v132409(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v132409(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v132409(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v132409(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v132409(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75431,axiom,
    ! [VarCurr: state_type] :
      ( ( v132409(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v132409(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v132409(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75430,axiom,
    ! [VarCurr: state_type] :
      ( ( v132409(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v132409(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v132409(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v132409(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75429,axiom,
    ! [VarCurr: state_type] :
      ( v132409(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75428,axiom,
    ! [VarCurr: state_type] :
      ( v130130(VarCurr)
    <=> v130132(VarCurr) ) ).

tff(addAssignment_75427,axiom,
    ! [VarCurr: state_type] :
      ( v130132(VarCurr)
    <=> v130134(VarCurr) ) ).

tff(addAssignment_75426,axiom,
    ! [VarCurr: state_type] :
      ( v130134(VarCurr)
    <=> v130136(VarCurr) ) ).

tff(addAssignment_75425,axiom,
    ! [VarCurr: state_type] :
      ( v130136(VarCurr)
    <=> v130138(VarCurr) ) ).

tff(addAssignment_75424,axiom,
    ! [VarCurr: state_type] :
      ( v130138(VarCurr)
    <=> v130140(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1715,axiom,
    ! [VarCurr: state_type] :
      ( v130140(VarCurr)
    <=> ( ( v130142(VarCurr,31)
        <=> v132185(VarCurr,31) )
        & ( v130142(VarCurr,30)
        <=> v132185(VarCurr,30) )
        & ( v130142(VarCurr,29)
        <=> v132185(VarCurr,29) )
        & ( v130142(VarCurr,28)
        <=> v132185(VarCurr,28) )
        & ( v130142(VarCurr,27)
        <=> v132185(VarCurr,27) )
        & ( v130142(VarCurr,26)
        <=> v132185(VarCurr,26) )
        & ( v130142(VarCurr,25)
        <=> v132185(VarCurr,25) )
        & ( v130142(VarCurr,24)
        <=> v132185(VarCurr,24) )
        & ( v130142(VarCurr,23)
        <=> v132185(VarCurr,23) )
        & ( v130142(VarCurr,22)
        <=> v132185(VarCurr,22) )
        & ( v130142(VarCurr,21)
        <=> v132185(VarCurr,21) )
        & ( v130142(VarCurr,20)
        <=> v132185(VarCurr,20) )
        & ( v130142(VarCurr,19)
        <=> v132185(VarCurr,19) )
        & ( v130142(VarCurr,18)
        <=> v132185(VarCurr,18) )
        & ( v130142(VarCurr,17)
        <=> v132185(VarCurr,17) )
        & ( v130142(VarCurr,16)
        <=> v132185(VarCurr,16) )
        & ( v130142(VarCurr,15)
        <=> v132185(VarCurr,15) )
        & ( v130142(VarCurr,14)
        <=> v132185(VarCurr,14) )
        & ( v130142(VarCurr,13)
        <=> v132185(VarCurr,13) )
        & ( v130142(VarCurr,12)
        <=> v132185(VarCurr,12) )
        & ( v130142(VarCurr,11)
        <=> v132185(VarCurr,11) )
        & ( v130142(VarCurr,10)
        <=> v132185(VarCurr,10) )
        & ( v130142(VarCurr,9)
        <=> v132185(VarCurr,9) )
        & ( v130142(VarCurr,8)
        <=> v132185(VarCurr,8) )
        & ( v130142(VarCurr,7)
        <=> v132185(VarCurr,7) )
        & ( v130142(VarCurr,6)
        <=> v132185(VarCurr,6) )
        & ( v130142(VarCurr,5)
        <=> v132185(VarCurr,5) )
        & ( v130142(VarCurr,4)
        <=> v132185(VarCurr,4) )
        & ( v130142(VarCurr,3)
        <=> v132185(VarCurr,3) )
        & ( v130142(VarCurr,2)
        <=> v132185(VarCurr,2) )
        & ( v130142(VarCurr,1)
        <=> v132185(VarCurr,1) )
        & ( v130142(VarCurr,0)
        <=> v132185(VarCurr,0) ) ) ) ).

tff(addAssignment_75423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v132185(VarCurr,B)
      <=> v132187(VarCurr,B) ) ) ).

tff(addAssignment_75422,axiom,
    ! [VarCurr: state_type] :
      ( ( v132187(VarCurr,8)
      <=> v132367(VarCurr,10) )
      & ( v132187(VarCurr,7)
      <=> v132367(VarCurr,9) )
      & ( v132187(VarCurr,6)
      <=> v132367(VarCurr,8) )
      & ( v132187(VarCurr,5)
      <=> v132367(VarCurr,7) )
      & ( v132187(VarCurr,4)
      <=> v132367(VarCurr,6) )
      & ( v132187(VarCurr,3)
      <=> v132367(VarCurr,5) )
      & ( v132187(VarCurr,2)
      <=> v132367(VarCurr,4) )
      & ( v132187(VarCurr,1)
      <=> v132367(VarCurr,3) )
      & ( v132187(VarCurr,0)
      <=> v132367(VarCurr,2) ) ) ).

tff(addAssignment_75421,axiom,
    ! [VarCurr: state_type] :
      ( ( v132187(VarCurr,23)
      <=> v132341(VarCurr,14) )
      & ( v132187(VarCurr,22)
      <=> v132341(VarCurr,13) )
      & ( v132187(VarCurr,21)
      <=> v132341(VarCurr,12) )
      & ( v132187(VarCurr,20)
      <=> v132341(VarCurr,11) )
      & ( v132187(VarCurr,19)
      <=> v132341(VarCurr,10) )
      & ( v132187(VarCurr,18)
      <=> v132341(VarCurr,9) )
      & ( v132187(VarCurr,17)
      <=> v132341(VarCurr,8) )
      & ( v132187(VarCurr,16)
      <=> v132341(VarCurr,7) )
      & ( v132187(VarCurr,15)
      <=> v132341(VarCurr,6) )
      & ( v132187(VarCurr,14)
      <=> v132341(VarCurr,5) )
      & ( v132187(VarCurr,13)
      <=> v132341(VarCurr,4) )
      & ( v132187(VarCurr,12)
      <=> v132341(VarCurr,3) )
      & ( v132187(VarCurr,11)
      <=> v132341(VarCurr,2) )
      & ( v132187(VarCurr,10)
      <=> v132341(VarCurr,1) )
      & ( v132187(VarCurr,9)
      <=> v132341(VarCurr,0) ) ) ).

tff(addAssignment_75420,axiom,
    ! [VarCurr: state_type] :
      ( ( v132187(VarCurr,26)
      <=> v132315(VarCurr,2) )
      & ( v132187(VarCurr,25)
      <=> v132315(VarCurr,1) )
      & ( v132187(VarCurr,24)
      <=> v132315(VarCurr,0) ) ) ).

tff(addAssignment_75419,axiom,
    ! [VarCurr: state_type] :
      ( ( v132187(VarCurr,30)
      <=> v132189(VarCurr,3) )
      & ( v132187(VarCurr,29)
      <=> v132189(VarCurr,2) )
      & ( v132187(VarCurr,28)
      <=> v132189(VarCurr,1) )
      & ( v132187(VarCurr,27)
      <=> v132189(VarCurr,0) ) ) ).

tff(addAssignment_75418,axiom,
    ! [VarCurr: state_type] :
      ( v132187(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132367(VarCurr,B)
      <=> v132191(VarCurr,B) ) ) ).

tff(addAssignment_75416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132191(VarCurr,B)
      <=> v132193(VarCurr,B) ) ) ).

tff(addAssignment_75415,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132193(VarNext,B)
      <=> v132385(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132386(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132385(VarNext,B)
            <=> v132193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1808,axiom,
    ! [VarNext: state_type] :
      ( v132386(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132385(VarNext,B)
          <=> v132308(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132386(VarNext)
      <=> v132387(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132387(VarNext)
      <=> ( v132389(VarNext)
          & v132240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132389(VarNext)
      <=> v132302(VarNext) ) ) ).

tff(addAssignment_75414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132215(VarCurr,B)
      <=> v132217(VarCurr,B) ) ) ).

tff(addAssignment_75413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132217(VarCurr,B)
      <=> v132234(VarCurr,B) ) ) ).

tff(addAssignment_75412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132237(VarCurr,B)
      <=> v132002(VarCurr,B) ) ) ).

tff(addAssignment_75411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132002(VarCurr,B)
      <=> v132004(VarCurr,B) ) ) ).

tff(addAssignment_75410,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132004(VarNext,B)
      <=> v132377(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132378(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v132377(VarNext,B)
            <=> v132004(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1807,axiom,
    ! [VarNext: state_type] :
      ( v132378(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132377(VarNext,B)
          <=> v132099(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132378(VarNext)
      <=> v132379(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132379(VarNext)
      <=> ( v132381(VarNext)
          & v132041(VarNext) ) ) ) ).

tff(writeUnaryOperator_9576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132381(VarNext)
      <=> v132093(VarNext) ) ) ).

tff(addAssignment_75409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132026(VarCurr,B)
      <=> v132028(VarCurr,B) ) ) ).

tff(addAssignment_75408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132028(VarCurr,B)
      <=> v132035(VarCurr,B) ) ) ).

tff(addAssignment_75407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132039(VarCurr,B)
      <=> v132371(VarCurr,B) ) ) ).

tff(addAssignment_75406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132371(VarCurr,B)
      <=> v132373(VarCurr,B) ) ) ).

tff(addAssignment_75405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132373(VarCurr,B)
      <=> v132375(VarCurr,B) ) ) ).

tff(addAssignment_75404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132375(VarCurr,B)
      <=> v131807(VarCurr,B) ) ) ).

tff(addAssignment_75403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v131807(VarCurr,B)
      <=> v131809(VarCurr,B) ) ) ).

tff(addAssignment_75402,axiom,
    ! [VarCurr: state_type] :
      ( ( v132341(VarCurr,14)
      <=> v132191(VarCurr,25) )
      & ( v132341(VarCurr,13)
      <=> v132191(VarCurr,24) )
      & ( v132341(VarCurr,12)
      <=> v132191(VarCurr,23) )
      & ( v132341(VarCurr,11)
      <=> v132191(VarCurr,22) )
      & ( v132341(VarCurr,10)
      <=> v132191(VarCurr,21) )
      & ( v132341(VarCurr,9)
      <=> v132191(VarCurr,20) )
      & ( v132341(VarCurr,8)
      <=> v132191(VarCurr,19) )
      & ( v132341(VarCurr,7)
      <=> v132191(VarCurr,18) )
      & ( v132341(VarCurr,6)
      <=> v132191(VarCurr,17) )
      & ( v132341(VarCurr,5)
      <=> v132191(VarCurr,16) )
      & ( v132341(VarCurr,4)
      <=> v132191(VarCurr,15) )
      & ( v132341(VarCurr,3)
      <=> v132191(VarCurr,14) )
      & ( v132341(VarCurr,2)
      <=> v132191(VarCurr,13) )
      & ( v132341(VarCurr,1)
      <=> v132191(VarCurr,12) )
      & ( v132341(VarCurr,0)
      <=> v132191(VarCurr,11) ) ) ).

tff(addAssignment_75401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132191(VarCurr,B)
      <=> v132193(VarCurr,B) ) ) ).

tff(addAssignment_75400,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132193(VarNext,B)
      <=> v132359(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132360(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132359(VarNext,B)
            <=> v132193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1806,axiom,
    ! [VarNext: state_type] :
      ( v132360(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132359(VarNext,B)
          <=> v132308(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132360(VarNext)
      <=> v132361(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132361(VarNext)
      <=> ( v132363(VarNext)
          & v132240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132363(VarNext)
      <=> v132302(VarNext) ) ) ).

tff(addAssignment_75399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132215(VarCurr,B)
      <=> v132217(VarCurr,B) ) ) ).

tff(addAssignment_75398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132217(VarCurr,B)
      <=> v132234(VarCurr,B) ) ) ).

tff(addAssignment_75397,axiom,
    ! [VarCurr: state_type] :
      ( ( v132236(VarCurr,14)
      <=> v132002(VarCurr,25) )
      & ( v132236(VarCurr,13)
      <=> v132002(VarCurr,24) )
      & ( v132236(VarCurr,12)
      <=> v132002(VarCurr,23) )
      & ( v132236(VarCurr,11)
      <=> v132002(VarCurr,22) )
      & ( v132236(VarCurr,10)
      <=> v132002(VarCurr,21) )
      & ( v132236(VarCurr,9)
      <=> v132002(VarCurr,20) )
      & ( v132236(VarCurr,8)
      <=> v132002(VarCurr,19) )
      & ( v132236(VarCurr,7)
      <=> v132002(VarCurr,18) )
      & ( v132236(VarCurr,6)
      <=> v132002(VarCurr,17) )
      & ( v132236(VarCurr,5)
      <=> v132002(VarCurr,16) )
      & ( v132236(VarCurr,4)
      <=> v132002(VarCurr,15) )
      & ( v132236(VarCurr,3)
      <=> v132002(VarCurr,14) )
      & ( v132236(VarCurr,2)
      <=> v132002(VarCurr,13) )
      & ( v132236(VarCurr,1)
      <=> v132002(VarCurr,12) )
      & ( v132236(VarCurr,0)
      <=> v132002(VarCurr,11) ) ) ).

tff(addAssignment_75396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132002(VarCurr,B)
      <=> v132004(VarCurr,B) ) ) ).

tff(addAssignment_75395,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132004(VarNext,B)
      <=> v132351(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132352(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v132351(VarNext,B)
            <=> v132004(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1805,axiom,
    ! [VarNext: state_type] :
      ( v132352(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132351(VarNext,B)
          <=> v132099(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132352(VarNext)
      <=> v132353(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132353(VarNext)
      <=> ( v132355(VarNext)
          & v132041(VarNext) ) ) ) ).

tff(writeUnaryOperator_9574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132355(VarNext)
      <=> v132093(VarNext) ) ) ).

tff(addAssignment_75394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132026(VarCurr,B)
      <=> v132028(VarCurr,B) ) ) ).

tff(addAssignment_75393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v132028(VarCurr,B)
      <=> v132035(VarCurr,B) ) ) ).

tff(addAssignment_75392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v132038(VarCurr,B)
      <=> v132345(VarCurr,B) ) ) ).

tff(addAssignment_75391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v132345(VarCurr,B)
      <=> v132347(VarCurr,B) ) ) ).

tff(addAssignment_75390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v132347(VarCurr,B)
      <=> v132349(VarCurr,B) ) ) ).

tff(addAssignment_75389,axiom,
    ! [VarCurr: state_type] :
      ( ( v132349(VarCurr,14)
      <=> v131807(VarCurr,25) )
      & ( v132349(VarCurr,13)
      <=> v131807(VarCurr,24) )
      & ( v132349(VarCurr,12)
      <=> v131807(VarCurr,23) )
      & ( v132349(VarCurr,11)
      <=> v131807(VarCurr,22) )
      & ( v132349(VarCurr,10)
      <=> v131807(VarCurr,21) )
      & ( v132349(VarCurr,9)
      <=> v131807(VarCurr,20) )
      & ( v132349(VarCurr,8)
      <=> v131807(VarCurr,19) )
      & ( v132349(VarCurr,7)
      <=> v131807(VarCurr,18) )
      & ( v132349(VarCurr,6)
      <=> v131807(VarCurr,17) )
      & ( v132349(VarCurr,5)
      <=> v131807(VarCurr,16) )
      & ( v132349(VarCurr,4)
      <=> v131807(VarCurr,15) )
      & ( v132349(VarCurr,3)
      <=> v131807(VarCurr,14) )
      & ( v132349(VarCurr,2)
      <=> v131807(VarCurr,13) )
      & ( v132349(VarCurr,1)
      <=> v131807(VarCurr,12) )
      & ( v132349(VarCurr,0)
      <=> v131807(VarCurr,11) ) ) ).

tff(addAssignment_75388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131807(VarCurr,B)
      <=> v131809(VarCurr,B) ) ) ).

tff(addAssignment_75387,axiom,
    ! [VarCurr: state_type] :
      ( ( v132315(VarCurr,2)
      <=> v132191(VarCurr,28) )
      & ( v132315(VarCurr,1)
      <=> v132191(VarCurr,27) )
      & ( v132315(VarCurr,0)
      <=> v132191(VarCurr,26) ) ) ).

tff(addAssignment_75386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132191(VarCurr,B)
      <=> v132193(VarCurr,B) ) ) ).

tff(addAssignment_75385,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132193(VarNext,B)
      <=> v132333(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132334(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132333(VarNext,B)
            <=> v132193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1804,axiom,
    ! [VarNext: state_type] :
      ( v132334(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132333(VarNext,B)
          <=> v132308(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132334(VarNext)
      <=> v132335(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132335(VarNext)
      <=> ( v132337(VarNext)
          & v132240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132337(VarNext)
      <=> v132302(VarNext) ) ) ).

tff(addAssignment_75384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132215(VarCurr,B)
      <=> v132217(VarCurr,B) ) ) ).

tff(addAssignment_75383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132217(VarCurr,B)
      <=> v132234(VarCurr,B) ) ) ).

tff(addAssignment_75382,axiom,
    ! [VarCurr: state_type] :
      ( ( v132235(VarCurr,2)
      <=> v132002(VarCurr,28) )
      & ( v132235(VarCurr,1)
      <=> v132002(VarCurr,27) )
      & ( v132235(VarCurr,0)
      <=> v132002(VarCurr,26) ) ) ).

tff(addAssignment_75381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132002(VarCurr,B)
      <=> v132004(VarCurr,B) ) ) ).

tff(addAssignment_75380,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132004(VarNext,B)
      <=> v132325(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132326(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v132325(VarNext,B)
            <=> v132004(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1803,axiom,
    ! [VarNext: state_type] :
      ( v132326(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132325(VarNext,B)
          <=> v132099(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132326(VarNext)
      <=> v132327(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132327(VarNext)
      <=> ( v132329(VarNext)
          & v132041(VarNext) ) ) ) ).

tff(writeUnaryOperator_9572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132329(VarNext)
      <=> v132093(VarNext) ) ) ).

tff(addAssignment_75379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132026(VarCurr,B)
      <=> v132028(VarCurr,B) ) ) ).

tff(addAssignment_75378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v132028(VarCurr,B)
      <=> v132035(VarCurr,B) ) ) ).

tff(addAssignment_75377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v132037(VarCurr,B)
      <=> v132319(VarCurr,B) ) ) ).

tff(addAssignment_75376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v132319(VarCurr,B)
      <=> v132321(VarCurr,B) ) ) ).

tff(addAssignment_75375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v132321(VarCurr,B)
      <=> v132323(VarCurr,B) ) ) ).

tff(addAssignment_75374,axiom,
    ! [VarCurr: state_type] :
      ( ( v132323(VarCurr,2)
      <=> v3948(VarCurr,4) )
      & ( v132323(VarCurr,1)
      <=> v3948(VarCurr,3) )
      & ( v132323(VarCurr,0)
      <=> v3948(VarCurr,2) ) ) ).

tff(addAssignment_75373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_75372,axiom,
    ! [VarCurr: state_type] :
      ( ( v132189(VarCurr,3)
      <=> v132191(VarCurr,32) )
      & ( v132189(VarCurr,2)
      <=> v132191(VarCurr,31) )
      & ( v132189(VarCurr,1)
      <=> v132191(VarCurr,30) )
      & ( v132189(VarCurr,0)
      <=> v132191(VarCurr,29) ) ) ).

tff(addAssignment_75371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132191(VarCurr,B)
      <=> v132193(VarCurr,B) ) ) ).

tff(addAssignment_75370,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132193(VarNext,B)
      <=> v132297(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132298(VarNext)
       => ! [B: $int] :
            ( ( $less(B,33)
              & ~ $less(B,0) )
           => ( v132297(VarNext,B)
            <=> v132193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1802,axiom,
    ! [VarNext: state_type] :
      ( v132298(VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132297(VarNext,B)
          <=> v132308(VarNext,B) ) ) ) ).

tff(addAssignment_75369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132308(VarNext,B)
          <=> v132306(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132309(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132306(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1324,axiom,
    ! [VarCurr: state_type] :
      ( v132309(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,33)
            & ~ $less(B,0) )
         => ( v132306(VarCurr,B)
          <=> v132215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17128,axiom,
    ! [VarCurr: state_type] :
      ( v132309(VarCurr)
    <=> ( v132310(VarCurr)
        & v132311(VarCurr) ) ) ).

tff(writeUnaryOperator_9571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132311(VarCurr)
    <=> v132205(VarCurr) ) ).

tff(writeUnaryOperator_9570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132310(VarCurr)
    <=> v132195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132298(VarNext)
      <=> v132299(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132299(VarNext)
      <=> ( v132300(VarNext)
          & v132240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132300(VarNext)
      <=> v132302(VarNext) ) ) ).

tff(addAssignment_75368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132302(VarNext)
      <=> v132240(VarCurr) ) ) ).

tff(addAssignment_75367,axiom,
    ! [VarCurr: state_type] :
      ( v132240(VarCurr)
    <=> v132242(VarCurr) ) ).

tff(addAssignment_75366,axiom,
    ! [VarCurr: state_type] :
      ( v132242(VarCurr)
    <=> v132244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17125,axiom,
    ! [VarCurr: state_type] :
      ( v132244(VarCurr)
    <=> ( v132295(VarCurr)
        | v132291(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17124,axiom,
    ! [VarCurr: state_type] :
      ( v132295(VarCurr)
    <=> ( v132246(VarCurr)
        & v132250(VarCurr) ) ) ).

tff(addAssignment_75365,axiom,
    ! [VarCurr: state_type] :
      ( v132291(VarCurr)
    <=> v132293(VarCurr) ) ).

tff(addAssignment_75364,axiom,
    ! [VarCurr: state_type] :
      ( v132293(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132275(VarNext)
       => ( v132250(VarNext)
        <=> v132250(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1801,axiom,
    ! [VarNext: state_type] :
      ( v132275(VarNext)
     => ( v132250(VarNext)
      <=> v132285(VarNext) ) ) ).

tff(addAssignment_75363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132285(VarNext)
      <=> v132283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17123,axiom,
    ! [VarCurr: state_type] :
      ( v132283(VarCurr)
    <=> ( v132286(VarCurr)
        & v132287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17122,axiom,
    ! [VarCurr: state_type] :
      ( v132287(VarCurr)
    <=> ( v132256(VarCurr)
        | v132270(VarCurr) ) ) ).

tff(writeUnaryOperator_9568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132286(VarCurr)
    <=> v132252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132275(VarNext)
      <=> v132276(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132276(VarNext)
      <=> ( v132278(VarNext)
          & v132280(VarNext) ) ) ) ).

tff(writeUnaryOperator_9567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132280(VarCurr)
    <=> v132246(VarCurr) ) ).

tff(addAssignment_75362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132278(VarNext)
      <=> v132246(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_255,axiom,
    ( v132250(constB0)
  <=> $true ) ).

tff(addAssignment_75361,axiom,
    ! [VarCurr: state_type] :
      ( v132270(VarCurr)
    <=> v132272(VarCurr) ) ).

tff(addAssignment_75360,axiom,
    ! [VarCurr: state_type] :
      ( v132272(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75359,axiom,
    ! [VarCurr: state_type] :
      ( v132256(VarCurr)
    <=> v132258(VarCurr) ) ).

tff(addAssignment_75358,axiom,
    ! [VarCurr: state_type] :
      ( v132258(VarCurr)
    <=> v132260(VarCurr) ) ).

tff(addAssignment_75357,axiom,
    ! [VarCurr: state_type] :
      ( v132260(VarCurr)
    <=> v132262(VarCurr) ) ).

tff(addAssignment_75356,axiom,
    ! [VarCurr: state_type] :
      ( v132262(VarCurr)
    <=> v132264(VarCurr) ) ).

tff(addAssignment_75355,axiom,
    ! [VarCurr: state_type] :
      ( v132264(VarCurr)
    <=> v132266(VarCurr) ) ).

tff(addAssignment_75354,axiom,
    ! [VarCurr: state_type] :
      ( v132266(VarCurr)
    <=> v132268(VarCurr) ) ).

tff(addAssignment_75353,axiom,
    ! [VarCurr: state_type] :
      ( v132268(VarCurr)
    <=> v129972(VarCurr) ) ).

tff(addAssignment_75352,axiom,
    ! [VarCurr: state_type] :
      ( v132252(VarCurr)
    <=> v132254(VarCurr) ) ).

tff(addAssignment_75351,axiom,
    ! [VarCurr: state_type] :
      ( v132254(VarCurr)
    <=> $false ) ).

tff(addAssignment_75350,axiom,
    ! [VarCurr: state_type] :
      ( v132246(VarCurr)
    <=> v132248(VarCurr) ) ).

tff(addAssignment_75349,axiom,
    ! [VarCurr: state_type] :
      ( v132248(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132215(VarCurr,B)
      <=> v132217(VarCurr,B) ) ) ).

tff(addAssignment_75347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132217(VarCurr,B)
      <=> v132234(VarCurr,B) ) ) ).

tff(addAssignment_75346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v132234(VarCurr,B)
      <=> v132237(VarCurr,B) ) ) ).

tff(addAssignment_75345,axiom,
    ! [VarCurr: state_type] :
      ( ( v132234(VarCurr,25)
      <=> v132236(VarCurr,14) )
      & ( v132234(VarCurr,24)
      <=> v132236(VarCurr,13) )
      & ( v132234(VarCurr,23)
      <=> v132236(VarCurr,12) )
      & ( v132234(VarCurr,22)
      <=> v132236(VarCurr,11) )
      & ( v132234(VarCurr,21)
      <=> v132236(VarCurr,10) )
      & ( v132234(VarCurr,20)
      <=> v132236(VarCurr,9) )
      & ( v132234(VarCurr,19)
      <=> v132236(VarCurr,8) )
      & ( v132234(VarCurr,18)
      <=> v132236(VarCurr,7) )
      & ( v132234(VarCurr,17)
      <=> v132236(VarCurr,6) )
      & ( v132234(VarCurr,16)
      <=> v132236(VarCurr,5) )
      & ( v132234(VarCurr,15)
      <=> v132236(VarCurr,4) )
      & ( v132234(VarCurr,14)
      <=> v132236(VarCurr,3) )
      & ( v132234(VarCurr,13)
      <=> v132236(VarCurr,2) )
      & ( v132234(VarCurr,12)
      <=> v132236(VarCurr,1) )
      & ( v132234(VarCurr,11)
      <=> v132236(VarCurr,0) ) ) ).

tff(addAssignment_75344,axiom,
    ! [VarCurr: state_type] :
      ( ( v132234(VarCurr,28)
      <=> v132235(VarCurr,2) )
      & ( v132234(VarCurr,27)
      <=> v132235(VarCurr,1) )
      & ( v132234(VarCurr,26)
      <=> v132235(VarCurr,0) ) ) ).

tff(addAssignment_75343,axiom,
    ! [VarCurr: state_type] :
      ( ( v132234(VarCurr,32)
      <=> v132219(VarCurr,3) )
      & ( v132234(VarCurr,31)
      <=> v132219(VarCurr,2) )
      & ( v132234(VarCurr,30)
      <=> v132219(VarCurr,1) )
      & ( v132234(VarCurr,29)
      <=> v132219(VarCurr,0) ) ) ).

tff(addAssignment_75342,axiom,
    ! [VarCurr: state_type] :
      ( ( v132219(VarCurr,3)
      <=> v132002(VarCurr,32) )
      & ( v132219(VarCurr,2)
      <=> v132002(VarCurr,31) )
      & ( v132219(VarCurr,1)
      <=> v132002(VarCurr,30) )
      & ( v132219(VarCurr,0)
      <=> v132002(VarCurr,29) ) ) ).

tff(addAssignment_75341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132002(VarCurr,B)
      <=> v132004(VarCurr,B) ) ) ).

tff(addAssignment_75340,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132004(VarNext,B)
      <=> v132227(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v132227(VarNext,B)
            <=> v132004(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1800,axiom,
    ! [VarNext: state_type] :
      ( v132228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132227(VarNext,B)
          <=> v132099(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132228(VarNext)
      <=> v132229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132229(VarNext)
      <=> ( v132231(VarNext)
          & v132041(VarNext) ) ) ) ).

tff(writeUnaryOperator_9566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132231(VarNext)
      <=> v132093(VarNext) ) ) ).

tff(addAssignment_75339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132026(VarCurr,B)
      <=> v132028(VarCurr,B) ) ) ).

tff(addAssignment_75338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v132028(VarCurr,B)
      <=> v132035(VarCurr,B) ) ) ).

tff(addAssignment_75337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v132036(VarCurr,B)
      <=> v132224(VarCurr,B) ) ) ).

tff(addAssignment_75336,axiom,
    ! [VarCurr: state_type] :
      ( v132036(VarCurr,3)
    <=> v132222(VarCurr) ) ).

tff(addAssignment_75335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v132224(VarCurr,B)
      <=> v99949(VarCurr,B) ) ) ).

tff(addAssignment_75334,axiom,
    ! [VarCurr: state_type] :
      ( v132222(VarCurr)
    <=> v100236(VarCurr) ) ).

tff(addAssignment_75333,axiom,
    ! [VarCurr: state_type] :
      ( v132205(VarCurr)
    <=> v132207(VarCurr) ) ).

tff(addAssignment_75332,axiom,
    ! [VarCurr: state_type] :
      ( v132207(VarCurr)
    <=> v132209(VarCurr) ) ).

tff(addAssignment_75331,axiom,
    ! [VarCurr: state_type] :
      ( v132209(VarCurr)
    <=> v132211(VarCurr) ) ).

tff(addAssignment_75330,axiom,
    ! [VarCurr: state_type] :
      ( v132211(VarCurr)
    <=> v132213(VarCurr) ) ).

tff(addAssignment_75329,axiom,
    ! [VarCurr: state_type] :
      ( v132213(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75328,axiom,
    ! [VarCurr: state_type] :
      ( v132195(VarCurr)
    <=> v132197(VarCurr) ) ).

tff(addAssignment_75327,axiom,
    ! [VarCurr: state_type] :
      ( v132197(VarCurr)
    <=> v132199(VarCurr) ) ).

tff(addAssignment_75326,axiom,
    ! [VarCurr: state_type] :
      ( v132199(VarCurr)
    <=> v132201(VarCurr) ) ).

tff(addAssignment_75325,axiom,
    ! [VarCurr: state_type] :
      ( v132201(VarCurr)
    <=> v132203(VarCurr) ) ).

tff(addAssignment_75324,axiom,
    ! [VarCurr: state_type] :
      ( v132203(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v130142(VarCurr,B)
      <=> v130144(VarCurr,B) ) ) ).

tff(addAssignment_75322,axiom,
    ! [VarCurr: state_type] :
      ( v130144(VarCurr,0)
    <=> v131980(VarCurr) ) ).

tff(addAssignment_75321,axiom,
    ! [VarCurr: state_type] :
      ( ( v130144(VarCurr,8)
      <=> v131890(VarCurr,10) )
      & ( v130144(VarCurr,7)
      <=> v131890(VarCurr,9) )
      & ( v130144(VarCurr,6)
      <=> v131890(VarCurr,8) )
      & ( v130144(VarCurr,5)
      <=> v131890(VarCurr,7) )
      & ( v130144(VarCurr,4)
      <=> v131890(VarCurr,6) )
      & ( v130144(VarCurr,3)
      <=> v131890(VarCurr,5) )
      & ( v130144(VarCurr,2)
      <=> v131890(VarCurr,4) )
      & ( v130144(VarCurr,1)
      <=> v131890(VarCurr,3) ) ) ).

tff(addAssignment_75320,axiom,
    ! [VarCurr: state_type] :
      ( ( v130144(VarCurr,23)
      <=> v131796(VarCurr,14) )
      & ( v130144(VarCurr,22)
      <=> v131796(VarCurr,13) )
      & ( v130144(VarCurr,21)
      <=> v131796(VarCurr,12) )
      & ( v130144(VarCurr,20)
      <=> v131796(VarCurr,11) )
      & ( v130144(VarCurr,19)
      <=> v131796(VarCurr,10) )
      & ( v130144(VarCurr,18)
      <=> v131796(VarCurr,9) )
      & ( v130144(VarCurr,17)
      <=> v131796(VarCurr,8) )
      & ( v130144(VarCurr,16)
      <=> v131796(VarCurr,7) )
      & ( v130144(VarCurr,15)
      <=> v131796(VarCurr,6) )
      & ( v130144(VarCurr,14)
      <=> v131796(VarCurr,5) )
      & ( v130144(VarCurr,13)
      <=> v131796(VarCurr,4) )
      & ( v130144(VarCurr,12)
      <=> v131796(VarCurr,3) )
      & ( v130144(VarCurr,11)
      <=> v131796(VarCurr,2) )
      & ( v130144(VarCurr,10)
      <=> v131796(VarCurr,1) )
      & ( v130144(VarCurr,9)
      <=> v131796(VarCurr,0) ) ) ).

tff(addAssignment_75319,axiom,
    ! [VarCurr: state_type] :
      ( ( v130144(VarCurr,26)
      <=> v131710(VarCurr,2) )
      & ( v130144(VarCurr,25)
      <=> v131710(VarCurr,1) )
      & ( v130144(VarCurr,24)
      <=> v131710(VarCurr,0) ) ) ).

tff(addAssignment_75318,axiom,
    ! [VarCurr: state_type] :
      ( ( v130144(VarCurr,30)
      <=> v130146(VarCurr,3) )
      & ( v130144(VarCurr,29)
      <=> v130146(VarCurr,2) )
      & ( v130144(VarCurr,28)
      <=> v130146(VarCurr,1) )
      & ( v130144(VarCurr,27)
      <=> v130146(VarCurr,0) ) ) ).

tff(addAssignment_75317,axiom,
    ! [VarCurr: state_type] :
      ( v130144(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_75316,axiom,
    ! [VarCurr: state_type] :
      ( v131980(VarCurr)
    <=> v131982(VarCurr) ) ).

tff(addAssignment_75315,axiom,
    ! [VarCurr: state_type] :
      ( v131982(VarCurr)
    <=> v131984(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17117,axiom,
    ! [VarCurr: state_type] :
      ( v131984(VarCurr)
    <=> ( v131986(VarCurr)
        & v132107(VarCurr) ) ) ).

tff(addAssignment_75314,axiom,
    ! [VarCurr: state_type] :
      ( v132107(VarCurr)
    <=> v132109(VarCurr) ) ).

tff(addAssignment_75313,axiom,
    ! [VarCurr: state_type] :
      ( v132109(VarCurr)
    <=> v131890(VarCurr,2) ) ).

tff(addAssignment_75312,axiom,
    ! [VarCurr: state_type] :
      ( v131890(VarCurr,2)
    <=> v130148(VarCurr,2) ) ).

tff(addAssignment_75311,axiom,
    ! [VarCurr: state_type] :
      ( v130148(VarCurr,2)
    <=> v130150(VarCurr,2) ) ).

tff(addAssignment_75310,axiom,
    ! [VarCurr: state_type] :
      ( v130150(VarCurr,2)
    <=> v131678(VarCurr,2) ) ).

tff(addAssignment_75309,axiom,
    ! [VarCurr: state_type] :
      ( v131554(VarCurr,2)
    <=> v131556(VarCurr,2) ) ).

tff(addAssignment_75308,axiom,
    ! [VarCurr: state_type] :
      ( v131556(VarCurr,2)
    <=> v131663(VarCurr,2) ) ).

tff(addAssignment_75307,axiom,
    ! [VarCurr: state_type] :
      ( v131667(VarCurr,2)
    <=> v131560(VarCurr,2) ) ).

tff(addAssignment_75306,axiom,
    ! [VarCurr: state_type] :
      ( v131560(VarCurr,2)
    <=> v131562(VarCurr,2) ) ).

tff(addAssignment_75305,axiom,
    ! [VarNext: state_type] :
      ( v131562(VarNext,2)
    <=> v132175(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132176(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132175(VarNext,B)
            <=> v131562(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1799,axiom,
    ! [VarNext: state_type] :
      ( v132176(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132175(VarNext,B)
          <=> v131657(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132176(VarNext)
      <=> v132177(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132177(VarNext)
      <=> ( v132179(VarNext)
          & v131589(VarNext) ) ) ) ).

tff(writeUnaryOperator_9565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132179(VarNext)
      <=> v131651(VarNext) ) ) ).

tff(addAssignment_75304,axiom,
    ! [VarCurr: state_type] :
      ( v131584(VarCurr,2)
    <=> v131586(VarCurr,2) ) ).

tff(addAssignment_75303,axiom,
    ! [VarCurr: state_type] :
      ( v131586(VarCurr,2)
    <=> v131587(VarCurr,2) ) ).

tff(addAssignment_75302,axiom,
    ! [VarCurr: state_type] :
      ( v131429(VarCurr,2)
    <=> v131431(VarCurr,2) ) ).

tff(addAssignment_75301,axiom,
    ! [VarCurr: state_type] :
      ( v131431(VarCurr,2)
    <=> v131538(VarCurr,2) ) ).

tff(addAssignment_75300,axiom,
    ! [VarCurr: state_type] :
      ( v131542(VarCurr,2)
    <=> v131435(VarCurr,2) ) ).

tff(addAssignment_75299,axiom,
    ! [VarCurr: state_type] :
      ( v131435(VarCurr,2)
    <=> v131437(VarCurr,2) ) ).

tff(addAssignment_75298,axiom,
    ! [VarNext: state_type] :
      ( v131437(VarNext,2)
    <=> v132167(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132168(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132167(VarNext,B)
            <=> v131437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1798,axiom,
    ! [VarNext: state_type] :
      ( v132168(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132167(VarNext,B)
          <=> v131532(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132168(VarNext)
      <=> v132169(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132169(VarNext)
      <=> ( v132171(VarNext)
          & v131464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132171(VarNext)
      <=> v131526(VarNext) ) ) ).

tff(addAssignment_75297,axiom,
    ! [VarCurr: state_type] :
      ( v131459(VarCurr,2)
    <=> v131461(VarCurr,2) ) ).

tff(addAssignment_75296,axiom,
    ! [VarCurr: state_type] :
      ( v131461(VarCurr,2)
    <=> v131462(VarCurr,2) ) ).

tff(addAssignment_75295,axiom,
    ! [VarCurr: state_type] :
      ( v131304(VarCurr,2)
    <=> v131306(VarCurr,2) ) ).

tff(addAssignment_75294,axiom,
    ! [VarCurr: state_type] :
      ( v131306(VarCurr,2)
    <=> v131413(VarCurr,2) ) ).

tff(addAssignment_75293,axiom,
    ! [VarCurr: state_type] :
      ( v131417(VarCurr,2)
    <=> v131310(VarCurr,2) ) ).

tff(addAssignment_75292,axiom,
    ! [VarCurr: state_type] :
      ( v131310(VarCurr,2)
    <=> v131312(VarCurr,2) ) ).

tff(addAssignment_75291,axiom,
    ! [VarNext: state_type] :
      ( v131312(VarNext,2)
    <=> v132159(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132160(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132159(VarNext,B)
            <=> v131312(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1797,axiom,
    ! [VarNext: state_type] :
      ( v132160(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132159(VarNext,B)
          <=> v131407(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132160(VarNext)
      <=> v132161(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132161(VarNext)
      <=> ( v132163(VarNext)
          & v131339(VarNext) ) ) ) ).

tff(writeUnaryOperator_9563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132163(VarNext)
      <=> v131401(VarNext) ) ) ).

tff(addAssignment_75290,axiom,
    ! [VarCurr: state_type] :
      ( v131334(VarCurr,2)
    <=> v131336(VarCurr,2) ) ).

tff(addAssignment_75289,axiom,
    ! [VarCurr: state_type] :
      ( v131336(VarCurr,2)
    <=> v131337(VarCurr,2) ) ).

tff(addAssignment_75288,axiom,
    ! [VarCurr: state_type] :
      ( v131179(VarCurr,2)
    <=> v131181(VarCurr,2) ) ).

tff(addAssignment_75287,axiom,
    ! [VarCurr: state_type] :
      ( v131181(VarCurr,2)
    <=> v131288(VarCurr,2) ) ).

tff(addAssignment_75286,axiom,
    ! [VarCurr: state_type] :
      ( v131292(VarCurr,2)
    <=> v131185(VarCurr,2) ) ).

tff(addAssignment_75285,axiom,
    ! [VarCurr: state_type] :
      ( v131185(VarCurr,2)
    <=> v131187(VarCurr,2) ) ).

tff(addAssignment_75284,axiom,
    ! [VarNext: state_type] :
      ( v131187(VarNext,2)
    <=> v132151(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132152(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132151(VarNext,B)
            <=> v131187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1796,axiom,
    ! [VarNext: state_type] :
      ( v132152(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132151(VarNext,B)
          <=> v131282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132152(VarNext)
      <=> v132153(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132153(VarNext)
      <=> ( v132155(VarNext)
          & v131214(VarNext) ) ) ) ).

tff(writeUnaryOperator_9562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132155(VarNext)
      <=> v131276(VarNext) ) ) ).

tff(addAssignment_75283,axiom,
    ! [VarCurr: state_type] :
      ( v131209(VarCurr,2)
    <=> v131211(VarCurr,2) ) ).

tff(addAssignment_75282,axiom,
    ! [VarCurr: state_type] :
      ( v131211(VarCurr,2)
    <=> v131212(VarCurr,2) ) ).

tff(addAssignment_75281,axiom,
    ! [VarCurr: state_type] :
      ( v131054(VarCurr,2)
    <=> v131056(VarCurr,2) ) ).

tff(addAssignment_75280,axiom,
    ! [VarCurr: state_type] :
      ( v131056(VarCurr,2)
    <=> v131163(VarCurr,2) ) ).

tff(addAssignment_75279,axiom,
    ! [VarCurr: state_type] :
      ( v131167(VarCurr,2)
    <=> v131060(VarCurr,2) ) ).

tff(addAssignment_75278,axiom,
    ! [VarCurr: state_type] :
      ( v131060(VarCurr,2)
    <=> v131062(VarCurr,2) ) ).

tff(addAssignment_75277,axiom,
    ! [VarNext: state_type] :
      ( v131062(VarNext,2)
    <=> v132143(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132144(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132143(VarNext,B)
            <=> v131062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1795,axiom,
    ! [VarNext: state_type] :
      ( v132144(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132143(VarNext,B)
          <=> v131157(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132144(VarNext)
      <=> v132145(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132145(VarNext)
      <=> ( v132147(VarNext)
          & v131089(VarNext) ) ) ) ).

tff(writeUnaryOperator_9561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132147(VarNext)
      <=> v131151(VarNext) ) ) ).

tff(addAssignment_75276,axiom,
    ! [VarCurr: state_type] :
      ( v131084(VarCurr,2)
    <=> v131086(VarCurr,2) ) ).

tff(addAssignment_75275,axiom,
    ! [VarCurr: state_type] :
      ( v131086(VarCurr,2)
    <=> v131087(VarCurr,2) ) ).

tff(addAssignment_75274,axiom,
    ! [VarCurr: state_type] :
      ( v130929(VarCurr,2)
    <=> v130931(VarCurr,2) ) ).

tff(addAssignment_75273,axiom,
    ! [VarCurr: state_type] :
      ( v130931(VarCurr,2)
    <=> v131038(VarCurr,2) ) ).

tff(addAssignment_75272,axiom,
    ! [VarCurr: state_type] :
      ( v131042(VarCurr,2)
    <=> v130935(VarCurr,2) ) ).

tff(addAssignment_75271,axiom,
    ! [VarCurr: state_type] :
      ( v130935(VarCurr,2)
    <=> v130937(VarCurr,2) ) ).

tff(addAssignment_75270,axiom,
    ! [VarNext: state_type] :
      ( v130937(VarNext,2)
    <=> v132135(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132136(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132135(VarNext,B)
            <=> v130937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1794,axiom,
    ! [VarNext: state_type] :
      ( v132136(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132135(VarNext,B)
          <=> v131032(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132136(VarNext)
      <=> v132137(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132137(VarNext)
      <=> ( v132139(VarNext)
          & v130964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132139(VarNext)
      <=> v131026(VarNext) ) ) ).

tff(addAssignment_75269,axiom,
    ! [VarCurr: state_type] :
      ( v130959(VarCurr,2)
    <=> v130961(VarCurr,2) ) ).

tff(addAssignment_75268,axiom,
    ! [VarCurr: state_type] :
      ( v130961(VarCurr,2)
    <=> v130962(VarCurr,2) ) ).

tff(addAssignment_75267,axiom,
    ! [VarCurr: state_type] :
      ( v130804(VarCurr,2)
    <=> v130806(VarCurr,2) ) ).

tff(addAssignment_75266,axiom,
    ! [VarCurr: state_type] :
      ( v130806(VarCurr,2)
    <=> v130913(VarCurr,2) ) ).

tff(addAssignment_75265,axiom,
    ! [VarCurr: state_type] :
      ( v130917(VarCurr,2)
    <=> v130810(VarCurr,2) ) ).

tff(addAssignment_75264,axiom,
    ! [VarCurr: state_type] :
      ( v130810(VarCurr,2)
    <=> v130812(VarCurr,2) ) ).

tff(addAssignment_75263,axiom,
    ! [VarNext: state_type] :
      ( v130812(VarNext,2)
    <=> v132127(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132128(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132127(VarNext,B)
            <=> v130812(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1793,axiom,
    ! [VarNext: state_type] :
      ( v132128(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132127(VarNext,B)
          <=> v130907(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132128(VarNext)
      <=> v132129(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132129(VarNext)
      <=> ( v132131(VarNext)
          & v130839(VarNext) ) ) ) ).

tff(writeUnaryOperator_9559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132131(VarNext)
      <=> v130901(VarNext) ) ) ).

tff(addAssignment_75262,axiom,
    ! [VarCurr: state_type] :
      ( v130834(VarCurr,2)
    <=> v130836(VarCurr,2) ) ).

tff(addAssignment_75261,axiom,
    ! [VarCurr: state_type] :
      ( v130836(VarCurr,2)
    <=> v130837(VarCurr,2) ) ).

tff(addAssignment_75260,axiom,
    ! [VarCurr: state_type] :
      ( v130152(VarCurr,2)
    <=> v130154(VarCurr,2) ) ).

tff(addAssignment_75259,axiom,
    ! [VarCurr: state_type] :
      ( v130154(VarCurr,2)
    <=> v130371(VarCurr,2) ) ).

tff(addAssignment_75258,axiom,
    ! [VarCurr: state_type] :
      ( v130375(VarCurr,2)
    <=> v130158(VarCurr,2) ) ).

tff(addAssignment_75257,axiom,
    ! [VarCurr: state_type] :
      ( v130158(VarCurr,2)
    <=> v130160(VarCurr,2) ) ).

tff(addAssignment_75256,axiom,
    ! [VarNext: state_type] :
      ( v130160(VarNext,2)
    <=> v132119(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132120(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132119(VarNext,B)
            <=> v130160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1792,axiom,
    ! [VarNext: state_type] :
      ( v132120(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132119(VarNext,B)
          <=> v130365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132120(VarNext)
      <=> v132121(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132121(VarNext)
      <=> ( v132123(VarNext)
          & v130291(VarNext) ) ) ) ).

tff(writeUnaryOperator_9558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132123(VarNext)
      <=> v130359(VarNext) ) ) ).

tff(addAssignment_75255,axiom,
    ! [VarCurr: state_type] :
      ( v130194(VarCurr,2)
    <=> v130196(VarCurr,2) ) ).

tff(addAssignment_75254,axiom,
    ! [VarCurr: state_type] :
      ( v130196(VarCurr,2)
    <=> v130285(VarCurr,2) ) ).

tff(addAssignment_75253,axiom,
    ! [VarCurr: state_type] :
      ( v130289(VarCurr,2)
    <=> v130200(VarCurr,2) ) ).

tff(addAssignment_75252,axiom,
    ! [VarCurr: state_type] :
      ( v130200(VarCurr,2)
    <=> v130202(VarCurr,2) ) ).

tff(addAssignment_75251,axiom,
    ! [VarNext: state_type] :
      ( v130202(VarNext,2)
    <=> v132111(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132112(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v132111(VarNext,B)
            <=> v130202(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1791,axiom,
    ! [VarNext: state_type] :
      ( v132112(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v132111(VarNext,B)
          <=> v130279(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132112(VarNext)
      <=> v132113(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132113(VarNext)
      <=> ( v132115(VarNext)
          & v130240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132115(VarNext)
      <=> v130273(VarNext) ) ) ).

tff(addAssignment_75250,axiom,
    ! [VarCurr: state_type] :
      ( v130224(VarCurr,2)
    <=> v130226(VarCurr,2) ) ).

tff(addAssignment_75249,axiom,
    ! [VarCurr: state_type] :
      ( v130226(VarCurr,2)
    <=> v130234(VarCurr,2) ) ).

tff(addAssignment_75248,axiom,
    ! [VarCurr: state_type] :
      ( v130238(VarCurr,2)
    <=> v131895(VarCurr,2) ) ).

tff(addAssignment_75247,axiom,
    ! [VarCurr: state_type] :
      ( v131895(VarCurr,2)
    <=> v131897(VarCurr,2) ) ).

tff(addAssignment_75246,axiom,
    ! [VarCurr: state_type] :
      ( v131897(VarCurr,2)
    <=> v131899(VarCurr,2) ) ).

tff(addAssignment_75245,axiom,
    ! [VarCurr: state_type] :
      ( v131899(VarCurr,2)
    <=> v131807(VarCurr,28) ) ).

tff(addAssignment_75244,axiom,
    ! [VarCurr: state_type] :
      ( v131807(VarCurr,28)
    <=> v131809(VarCurr,28) ) ).

tff(addAssignment_75243,axiom,
    ! [VarCurr: state_type] :
      ( v131986(VarCurr)
    <=> v131988(VarCurr) ) ).

tff(addAssignment_75242,axiom,
    ! [VarCurr: state_type] :
      ( v131988(VarCurr)
    <=> v131990(VarCurr) ) ).

tff(addAssignment_75241,axiom,
    ! [VarCurr: state_type] :
      ( v131990(VarCurr)
    <=> v131992(VarCurr) ) ).

tff(addAssignment_75240,axiom,
    ! [VarCurr: state_type] :
      ( v131992(VarCurr)
    <=> v131994(VarCurr) ) ).

tff(writeUnaryOperator_9556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131994(VarCurr)
    <=> v131996(VarCurr) ) ).

tff(addAssignment_75239,axiom,
    ! [VarCurr: state_type] :
      ( v131996(VarCurr)
    <=> v131998(VarCurr) ) ).

tff(addAssignment_75238,axiom,
    ! [VarCurr: state_type] :
      ( v131998(VarCurr)
    <=> v132000(VarCurr) ) ).

tff(addAssignment_75237,axiom,
    ! [VarCurr: state_type] :
      ( v132000(VarCurr)
    <=> v132002(VarCurr,33) ) ).

tff(addAssignment_75236,axiom,
    ! [VarCurr: state_type] :
      ( v132002(VarCurr,33)
    <=> v132004(VarCurr,33) ) ).

tff(addAssignment_75235,axiom,
    ! [VarNext: state_type] :
      ( v132004(VarNext,33)
    <=> v132088(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_1790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132089(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v132088(VarNext,B)
            <=> v132004(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1790,axiom,
    ! [VarNext: state_type] :
      ( v132089(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132088(VarNext,B)
          <=> v132099(VarNext,B) ) ) ) ).

tff(addAssignment_75234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132099(VarNext,B)
          <=> v132097(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132097(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1323,axiom,
    ! [VarCurr: state_type] :
      ( v132100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v132097(VarCurr,B)
          <=> v132026(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17098,axiom,
    ! [VarCurr: state_type] :
      ( v132100(VarCurr)
    <=> ( v132101(VarCurr)
        & v132102(VarCurr) ) ) ).

tff(writeUnaryOperator_9555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132102(VarCurr)
    <=> v132016(VarCurr) ) ).

tff(writeUnaryOperator_9554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132101(VarCurr)
    <=> v132006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132089(VarNext)
      <=> v132090(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132090(VarNext)
      <=> ( v132091(VarNext)
          & v132041(VarNext) ) ) ) ).

tff(writeUnaryOperator_9553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132091(VarNext)
      <=> v132093(VarNext) ) ) ).

tff(addAssignment_75233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132093(VarNext)
      <=> v132041(VarCurr) ) ) ).

tff(addAssignment_75232,axiom,
    ! [VarCurr: state_type] :
      ( v132041(VarCurr)
    <=> v132043(VarCurr) ) ).

tff(addAssignment_75231,axiom,
    ! [VarCurr: state_type] :
      ( v132043(VarCurr)
    <=> v132045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17095,axiom,
    ! [VarCurr: state_type] :
      ( v132045(VarCurr)
    <=> ( v132086(VarCurr)
        | v132082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17094,axiom,
    ! [VarCurr: state_type] :
      ( v132086(VarCurr)
    <=> ( v132047(VarCurr)
        & v132051(VarCurr) ) ) ).

tff(addAssignment_75230,axiom,
    ! [VarCurr: state_type] :
      ( v132082(VarCurr)
    <=> v132084(VarCurr) ) ).

tff(addAssignment_75229,axiom,
    ! [VarCurr: state_type] :
      ( v132084(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v132066(VarNext)
       => ( v132051(VarNext)
        <=> v132051(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1789,axiom,
    ! [VarNext: state_type] :
      ( v132066(VarNext)
     => ( v132051(VarNext)
      <=> v132076(VarNext) ) ) ).

tff(addAssignment_75228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132076(VarNext)
      <=> v132074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17093,axiom,
    ! [VarCurr: state_type] :
      ( v132074(VarCurr)
    <=> ( v132077(VarCurr)
        & v132078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17092,axiom,
    ! [VarCurr: state_type] :
      ( v132078(VarCurr)
    <=> ( v132057(VarCurr)
        | v132061(VarCurr) ) ) ).

tff(writeUnaryOperator_9552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132077(VarCurr)
    <=> v132053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132066(VarNext)
      <=> v132067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132067(VarNext)
      <=> ( v132069(VarNext)
          & v132071(VarNext) ) ) ) ).

tff(writeUnaryOperator_9551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v132071(VarCurr)
    <=> v132047(VarCurr) ) ).

tff(addAssignment_75227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v132069(VarNext)
      <=> v132047(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_254,axiom,
    ( v132051(constB0)
  <=> $true ) ).

tff(addAssignment_75226,axiom,
    ! [VarCurr: state_type] :
      ( v132061(VarCurr)
    <=> v132063(VarCurr) ) ).

tff(addAssignment_75225,axiom,
    ! [VarCurr: state_type] :
      ( v132063(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_75224,axiom,
    ! [VarCurr: state_type] :
      ( v132057(VarCurr)
    <=> v132059(VarCurr) ) ).

tff(addAssignment_75223,axiom,
    ! [VarCurr: state_type] :
      ( v132059(VarCurr)
    <=> $true ) ).

tff(addAssignment_75222,axiom,
    ! [VarCurr: state_type] :
      ( v132053(VarCurr)
    <=> v132055(VarCurr) ) ).

tff(addAssignment_75221,axiom,
    ! [VarCurr: state_type] :
      ( v132055(VarCurr)
    <=> $false ) ).

tff(addAssignment_75220,axiom,
    ! [VarCurr: state_type] :
      ( v132047(VarCurr)
    <=> v132049(VarCurr) ) ).

tff(addAssignment_75219,axiom,
    ! [VarCurr: state_type] :
      ( v132049(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_75218,axiom,
    ! [VarCurr: state_type] :
      ( v132026(VarCurr,33)
    <=> v132028(VarCurr,33) ) ).

tff(addAssignment_75217,axiom,
    ! [VarCurr: state_type] :
      ( v132028(VarCurr,33)
    <=> v132035(VarCurr,33) ) ).

tff(addAssignment_75216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v132035(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_75215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,2) )
     => ( v132035(VarCurr,B)
      <=> v132039(VarCurr,B) ) ) ).

tff(addAssignment_75214,axiom,
    ! [VarCurr: state_type] :
      ( ( v132035(VarCurr,25)
      <=> v132038(VarCurr,14) )
      & ( v132035(VarCurr,24)
      <=> v132038(VarCurr,13) )
      & ( v132035(VarCurr,23)
      <=> v132038(VarCurr,12) )
      & ( v132035(VarCurr,22)
      <=> v132038(VarCurr,11) )
      & ( v132035(VarCurr,21)
      <=> v132038(VarCurr,10) )
      & ( v132035(VarCurr,20)
      <=> v132038(VarCurr,9) )
      & ( v132035(VarCurr,19)
      <=> v132038(VarCurr,8) )
      & ( v132035(VarCurr,18)
      <=> v132038(VarCurr,7) )
      & ( v132035(VarCurr,17)
      <=> v132038(VarCurr,6) )
      & ( v132035(VarCurr,16)
      <=> v132038(VarCurr,5) )
      & ( v132035(VarCurr,15)
      <=> v132038(VarCurr,4) )
      & ( v132035(VarCurr,14)
      <=> v132038(VarCurr,3) )
      & ( v132035(VarCurr,13)
      <=> v132038(VarCurr,2) )
      & ( v132035(VarCurr,12)
      <=> v132038(VarCurr,1) )
      & ( v132035(VarCurr,11)
      <=> v132038(VarCurr,0) ) ) ).

tff(addAssignment_75213,axiom,
    ! [VarCurr: state_type] :
      ( ( v132035(VarCurr,28)
      <=> v132037(VarCurr,2) )
      & ( v132035(VarCurr,27)
      <=> v132037(VarCurr,1) )
      & ( v132035(VarCurr,26)
      <=> v132037(VarCurr,0) ) ) ).

tff(addAssignment_75212,axiom,
    ! [VarCurr: state_type] :
      ( ( v132035(VarCurr,32)
      <=> v132036(VarCurr,3) )
      & ( v132035(VarCurr,31)
      <=> v132036(VarCurr,2) )
      & ( v132035(VarCurr,30)
      <=> v132036(VarCurr,1) )
      & ( v132035(VarCurr,29)
      <=> v132036(VarCurr,0) ) ) ).

tff(addAssignment_75211,axiom,
    ! [VarCurr: state_type] :
      ( v132035(VarCurr,33)
    <=> v132030(VarCurr) ) ).

tff(addAssignment_75210,axiom,
    ! [VarCurr: state_type] :
      ( v132030(VarCurr)
    <=> v132032(VarCurr) ) ).

tff(addAssignment_75209,axiom,
    ! [VarCurr: state_type] :
      ( v132032(VarCurr)
    <=> v132034(VarCurr) ) ).

tff(addAssignment_75208,axiom,
    ! [VarCurr: state_type] :
      ( v132034(VarCurr)
    <=> v1049(VarCurr) ) ).

tff(addAssignment_75207,axiom,
    ! [VarCurr: state_type] :
      ( v132016(VarCurr)
    <=> v132018(VarCurr) ) ).

tff(addAssignment_75206,axiom,
    ! [VarCurr: state_type] :
      ( v132018(VarCurr)
    <=> v132020(VarCurr) ) ).

tff(addAssignment_75205,axiom,
    ! [VarCurr: state_type] :
      ( v132020(VarCurr)
    <=> v132022(VarCurr) ) ).

tff(addAssignment_75204,axiom,
    ! [VarCurr: state_type] :
      ( v132022(VarCurr)
    <=> v132024(VarCurr) ) ).

tff(addAssignment_75203,axiom,
    ! [VarCurr: state_type] :
      ( v132024(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_75202,axiom,
    ! [VarCurr: state_type] :
      ( v132006(VarCurr)
    <=> v132008(VarCurr) ) ).

tff(addAssignment_75201,axiom,
    ! [VarCurr: state_type] :
      ( v132008(VarCurr)
    <=> v132010(VarCurr) ) ).

tff(addAssignment_75200,axiom,
    ! [VarCurr: state_type] :
      ( v132010(VarCurr)
    <=> v132012(VarCurr) ) ).

tff(addAssignment_75199,axiom,
    ! [VarCurr: state_type] :
      ( v132012(VarCurr)
    <=> v132014(VarCurr) ) ).

tff(addAssignment_75198,axiom,
    ! [VarCurr: state_type] :
      ( v132014(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_75197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131890(VarCurr,B)
      <=> v130148(VarCurr,B) ) ) ).

tff(addAssignment_75196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130148(VarCurr,B)
      <=> v130150(VarCurr,B) ) ) ).

tff(addAssignment_75195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130150(VarCurr,B)
      <=> v131678(VarCurr,B) ) ) ).

tff(addAssignment_75194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131554(VarCurr,B)
      <=> v131556(VarCurr,B) ) ) ).

tff(addAssignment_75193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131556(VarCurr,B)
      <=> v131663(VarCurr,B) ) ) ).

tff(addAssignment_75192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131667(VarCurr,B)
      <=> v131560(VarCurr,B) ) ) ).

tff(addAssignment_75191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131560(VarCurr,B)
      <=> v131562(VarCurr,B) ) ) ).

tff(addAssignment_75190,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131562(VarNext,B)
      <=> v131972(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131973(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131972(VarNext,B)
            <=> v131562(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1788,axiom,
    ! [VarNext: state_type] :
      ( v131973(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131972(VarNext,B)
          <=> v131657(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131973(VarNext)
      <=> v131974(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131974(VarNext)
      <=> ( v131976(VarNext)
          & v131589(VarNext) ) ) ) ).

tff(writeUnaryOperator_9550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131976(VarNext)
      <=> v131651(VarNext) ) ) ).

tff(addAssignment_75189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131584(VarCurr,B)
      <=> v131586(VarCurr,B) ) ) ).

tff(addAssignment_75188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131586(VarCurr,B)
      <=> v131587(VarCurr,B) ) ) ).

tff(addAssignment_75187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131429(VarCurr,B)
      <=> v131431(VarCurr,B) ) ) ).

tff(addAssignment_75186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131431(VarCurr,B)
      <=> v131538(VarCurr,B) ) ) ).

tff(addAssignment_75185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131542(VarCurr,B)
      <=> v131435(VarCurr,B) ) ) ).

tff(addAssignment_75184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131435(VarCurr,B)
      <=> v131437(VarCurr,B) ) ) ).

tff(addAssignment_75183,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131437(VarNext,B)
      <=> v131963(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131964(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131963(VarNext,B)
            <=> v131437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1787,axiom,
    ! [VarNext: state_type] :
      ( v131964(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131963(VarNext,B)
          <=> v131532(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131964(VarNext)
      <=> v131965(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131965(VarNext)
      <=> ( v131967(VarNext)
          & v131464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131967(VarNext)
      <=> v131526(VarNext) ) ) ).

tff(addAssignment_75182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131459(VarCurr,B)
      <=> v131461(VarCurr,B) ) ) ).

tff(addAssignment_75181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131461(VarCurr,B)
      <=> v131462(VarCurr,B) ) ) ).

tff(addAssignment_75180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131304(VarCurr,B)
      <=> v131306(VarCurr,B) ) ) ).

tff(addAssignment_75179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131306(VarCurr,B)
      <=> v131413(VarCurr,B) ) ) ).

tff(addAssignment_75178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131417(VarCurr,B)
      <=> v131310(VarCurr,B) ) ) ).

tff(addAssignment_75177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131310(VarCurr,B)
      <=> v131312(VarCurr,B) ) ) ).

tff(addAssignment_75176,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131312(VarNext,B)
      <=> v131954(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131955(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131954(VarNext,B)
            <=> v131312(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1786,axiom,
    ! [VarNext: state_type] :
      ( v131955(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131954(VarNext,B)
          <=> v131407(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131955(VarNext)
      <=> v131956(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131956(VarNext)
      <=> ( v131958(VarNext)
          & v131339(VarNext) ) ) ) ).

tff(writeUnaryOperator_9548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131958(VarNext)
      <=> v131401(VarNext) ) ) ).

tff(addAssignment_75175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131334(VarCurr,B)
      <=> v131336(VarCurr,B) ) ) ).

tff(addAssignment_75174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131336(VarCurr,B)
      <=> v131337(VarCurr,B) ) ) ).

tff(addAssignment_75173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131179(VarCurr,B)
      <=> v131181(VarCurr,B) ) ) ).

tff(addAssignment_75172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131181(VarCurr,B)
      <=> v131288(VarCurr,B) ) ) ).

tff(addAssignment_75171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131292(VarCurr,B)
      <=> v131185(VarCurr,B) ) ) ).

tff(addAssignment_75170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131185(VarCurr,B)
      <=> v131187(VarCurr,B) ) ) ).

tff(addAssignment_75169,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131187(VarNext,B)
      <=> v131945(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131946(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131945(VarNext,B)
            <=> v131187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1785,axiom,
    ! [VarNext: state_type] :
      ( v131946(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131945(VarNext,B)
          <=> v131282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131946(VarNext)
      <=> v131947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131947(VarNext)
      <=> ( v131949(VarNext)
          & v131214(VarNext) ) ) ) ).

tff(writeUnaryOperator_9547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131949(VarNext)
      <=> v131276(VarNext) ) ) ).

tff(addAssignment_75168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131209(VarCurr,B)
      <=> v131211(VarCurr,B) ) ) ).

tff(addAssignment_75167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131211(VarCurr,B)
      <=> v131212(VarCurr,B) ) ) ).

tff(addAssignment_75166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131054(VarCurr,B)
      <=> v131056(VarCurr,B) ) ) ).

tff(addAssignment_75165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131056(VarCurr,B)
      <=> v131163(VarCurr,B) ) ) ).

tff(addAssignment_75164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131167(VarCurr,B)
      <=> v131060(VarCurr,B) ) ) ).

tff(addAssignment_75163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131060(VarCurr,B)
      <=> v131062(VarCurr,B) ) ) ).

tff(addAssignment_75162,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131062(VarNext,B)
      <=> v131936(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131937(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131936(VarNext,B)
            <=> v131062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1784,axiom,
    ! [VarNext: state_type] :
      ( v131937(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131936(VarNext,B)
          <=> v131157(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131937(VarNext)
      <=> v131938(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131938(VarNext)
      <=> ( v131940(VarNext)
          & v131089(VarNext) ) ) ) ).

tff(writeUnaryOperator_9546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131940(VarNext)
      <=> v131151(VarNext) ) ) ).

tff(addAssignment_75161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131084(VarCurr,B)
      <=> v131086(VarCurr,B) ) ) ).

tff(addAssignment_75160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131086(VarCurr,B)
      <=> v131087(VarCurr,B) ) ) ).

tff(addAssignment_75159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130929(VarCurr,B)
      <=> v130931(VarCurr,B) ) ) ).

tff(addAssignment_75158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130931(VarCurr,B)
      <=> v131038(VarCurr,B) ) ) ).

tff(addAssignment_75157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131042(VarCurr,B)
      <=> v130935(VarCurr,B) ) ) ).

tff(addAssignment_75156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130935(VarCurr,B)
      <=> v130937(VarCurr,B) ) ) ).

tff(addAssignment_75155,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130937(VarNext,B)
      <=> v131927(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131928(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131927(VarNext,B)
            <=> v130937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1783,axiom,
    ! [VarNext: state_type] :
      ( v131928(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131927(VarNext,B)
          <=> v131032(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131928(VarNext)
      <=> v131929(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131929(VarNext)
      <=> ( v131931(VarNext)
          & v130964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131931(VarNext)
      <=> v131026(VarNext) ) ) ).

tff(addAssignment_75154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130959(VarCurr,B)
      <=> v130961(VarCurr,B) ) ) ).

tff(addAssignment_75153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130961(VarCurr,B)
      <=> v130962(VarCurr,B) ) ) ).

tff(addAssignment_75152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130804(VarCurr,B)
      <=> v130806(VarCurr,B) ) ) ).

tff(addAssignment_75151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130806(VarCurr,B)
      <=> v130913(VarCurr,B) ) ) ).

tff(addAssignment_75150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130917(VarCurr,B)
      <=> v130810(VarCurr,B) ) ) ).

tff(addAssignment_75149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130810(VarCurr,B)
      <=> v130812(VarCurr,B) ) ) ).

tff(addAssignment_75148,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130812(VarNext,B)
      <=> v131918(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131919(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131918(VarNext,B)
            <=> v130812(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1782,axiom,
    ! [VarNext: state_type] :
      ( v131919(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131918(VarNext,B)
          <=> v130907(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131919(VarNext)
      <=> v131920(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131920(VarNext)
      <=> ( v131922(VarNext)
          & v130839(VarNext) ) ) ) ).

tff(writeUnaryOperator_9544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131922(VarNext)
      <=> v130901(VarNext) ) ) ).

tff(addAssignment_75147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130834(VarCurr,B)
      <=> v130836(VarCurr,B) ) ) ).

tff(addAssignment_75146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130836(VarCurr,B)
      <=> v130837(VarCurr,B) ) ) ).

tff(addAssignment_75145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130152(VarCurr,B)
      <=> v130154(VarCurr,B) ) ) ).

tff(addAssignment_75144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130154(VarCurr,B)
      <=> v130371(VarCurr,B) ) ) ).

tff(addAssignment_75143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130375(VarCurr,B)
      <=> v130158(VarCurr,B) ) ) ).

tff(addAssignment_75142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130158(VarCurr,B)
      <=> v130160(VarCurr,B) ) ) ).

tff(addAssignment_75141,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130160(VarNext,B)
      <=> v131909(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131910(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131909(VarNext,B)
            <=> v130160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1781,axiom,
    ! [VarNext: state_type] :
      ( v131910(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131909(VarNext,B)
          <=> v130365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131910(VarNext)
      <=> v131911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131911(VarNext)
      <=> ( v131913(VarNext)
          & v130291(VarNext) ) ) ) ).

tff(writeUnaryOperator_9543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131913(VarNext)
      <=> v130359(VarNext) ) ) ).

tff(addAssignment_75140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130194(VarCurr,B)
      <=> v130196(VarCurr,B) ) ) ).

tff(addAssignment_75139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130196(VarCurr,B)
      <=> v130285(VarCurr,B) ) ) ).

tff(addAssignment_75138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130289(VarCurr,B)
      <=> v130200(VarCurr,B) ) ) ).

tff(addAssignment_75137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130200(VarCurr,B)
      <=> v130202(VarCurr,B) ) ) ).

tff(addAssignment_75136,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130202(VarNext,B)
      <=> v131901(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131902(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131901(VarNext,B)
            <=> v130202(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1780,axiom,
    ! [VarNext: state_type] :
      ( v131902(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131901(VarNext,B)
          <=> v130279(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131902(VarNext)
      <=> v131903(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131903(VarNext)
      <=> ( v131905(VarNext)
          & v130240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131905(VarNext)
      <=> v130273(VarNext) ) ) ).

tff(addAssignment_75135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130224(VarCurr,B)
      <=> v130226(VarCurr,B) ) ) ).

tff(addAssignment_75134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130226(VarCurr,B)
      <=> v130234(VarCurr,B) ) ) ).

tff(addAssignment_75133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v130238(VarCurr,B)
      <=> v131895(VarCurr,B) ) ) ).

tff(addAssignment_75132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131895(VarCurr,B)
      <=> v131897(VarCurr,B) ) ) ).

tff(addAssignment_75131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,3) )
     => ( v131897(VarCurr,B)
      <=> v131899(VarCurr,B) ) ) ).

tff(addAssignment_75130,axiom,
    ! [VarCurr: state_type] :
      ( ( v131899(VarCurr,10)
      <=> v131807(VarCurr,36) )
      & ( v131899(VarCurr,9)
      <=> v131807(VarCurr,35) )
      & ( v131899(VarCurr,8)
      <=> v131807(VarCurr,34) )
      & ( v131899(VarCurr,7)
      <=> v131807(VarCurr,33) )
      & ( v131899(VarCurr,6)
      <=> v131807(VarCurr,32) )
      & ( v131899(VarCurr,5)
      <=> v131807(VarCurr,31) )
      & ( v131899(VarCurr,4)
      <=> v131807(VarCurr,30) )
      & ( v131899(VarCurr,3)
      <=> v131807(VarCurr,29) ) ) ).

tff(addAssignment_75129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,37)
        & ~ $less(B,29) )
     => ( v131807(VarCurr,B)
      <=> v131809(VarCurr,B) ) ) ).

tff(addAssignment_75128,axiom,
    ! [VarCurr: state_type] :
      ( ( v131796(VarCurr,14)
      <=> v130148(VarCurr,25) )
      & ( v131796(VarCurr,13)
      <=> v130148(VarCurr,24) )
      & ( v131796(VarCurr,12)
      <=> v130148(VarCurr,23) )
      & ( v131796(VarCurr,11)
      <=> v130148(VarCurr,22) )
      & ( v131796(VarCurr,10)
      <=> v130148(VarCurr,21) )
      & ( v131796(VarCurr,9)
      <=> v130148(VarCurr,20) )
      & ( v131796(VarCurr,8)
      <=> v130148(VarCurr,19) )
      & ( v131796(VarCurr,7)
      <=> v130148(VarCurr,18) )
      & ( v131796(VarCurr,6)
      <=> v130148(VarCurr,17) )
      & ( v131796(VarCurr,5)
      <=> v130148(VarCurr,16) )
      & ( v131796(VarCurr,4)
      <=> v130148(VarCurr,15) )
      & ( v131796(VarCurr,3)
      <=> v130148(VarCurr,14) )
      & ( v131796(VarCurr,2)
      <=> v130148(VarCurr,13) )
      & ( v131796(VarCurr,1)
      <=> v130148(VarCurr,12) )
      & ( v131796(VarCurr,0)
      <=> v130148(VarCurr,11) ) ) ).

tff(addAssignment_75127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130148(VarCurr,B)
      <=> v130150(VarCurr,B) ) ) ).

tff(addAssignment_75126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130150(VarCurr,B)
      <=> v131678(VarCurr,B) ) ) ).

tff(addAssignment_75125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131554(VarCurr,B)
      <=> v131556(VarCurr,B) ) ) ).

tff(addAssignment_75124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131556(VarCurr,B)
      <=> v131663(VarCurr,B) ) ) ).

tff(addAssignment_75123,axiom,
    ! [VarCurr: state_type] :
      ( ( v131666(VarCurr,14)
      <=> v131560(VarCurr,25) )
      & ( v131666(VarCurr,13)
      <=> v131560(VarCurr,24) )
      & ( v131666(VarCurr,12)
      <=> v131560(VarCurr,23) )
      & ( v131666(VarCurr,11)
      <=> v131560(VarCurr,22) )
      & ( v131666(VarCurr,10)
      <=> v131560(VarCurr,21) )
      & ( v131666(VarCurr,9)
      <=> v131560(VarCurr,20) )
      & ( v131666(VarCurr,8)
      <=> v131560(VarCurr,19) )
      & ( v131666(VarCurr,7)
      <=> v131560(VarCurr,18) )
      & ( v131666(VarCurr,6)
      <=> v131560(VarCurr,17) )
      & ( v131666(VarCurr,5)
      <=> v131560(VarCurr,16) )
      & ( v131666(VarCurr,4)
      <=> v131560(VarCurr,15) )
      & ( v131666(VarCurr,3)
      <=> v131560(VarCurr,14) )
      & ( v131666(VarCurr,2)
      <=> v131560(VarCurr,13) )
      & ( v131666(VarCurr,1)
      <=> v131560(VarCurr,12) )
      & ( v131666(VarCurr,0)
      <=> v131560(VarCurr,11) ) ) ).

tff(addAssignment_75122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131560(VarCurr,B)
      <=> v131562(VarCurr,B) ) ) ).

tff(addAssignment_75121,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131562(VarNext,B)
      <=> v131882(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131883(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131882(VarNext,B)
            <=> v131562(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1779,axiom,
    ! [VarNext: state_type] :
      ( v131883(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131882(VarNext,B)
          <=> v131657(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131883(VarNext)
      <=> v131884(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131884(VarNext)
      <=> ( v131886(VarNext)
          & v131589(VarNext) ) ) ) ).

tff(writeUnaryOperator_9541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131886(VarNext)
      <=> v131651(VarNext) ) ) ).

tff(addAssignment_75120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131584(VarCurr,B)
      <=> v131586(VarCurr,B) ) ) ).

tff(addAssignment_75119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131586(VarCurr,B)
      <=> v131587(VarCurr,B) ) ) ).

tff(addAssignment_75118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131429(VarCurr,B)
      <=> v131431(VarCurr,B) ) ) ).

tff(addAssignment_75117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131431(VarCurr,B)
      <=> v131538(VarCurr,B) ) ) ).

tff(addAssignment_75116,axiom,
    ! [VarCurr: state_type] :
      ( ( v131541(VarCurr,14)
      <=> v131435(VarCurr,25) )
      & ( v131541(VarCurr,13)
      <=> v131435(VarCurr,24) )
      & ( v131541(VarCurr,12)
      <=> v131435(VarCurr,23) )
      & ( v131541(VarCurr,11)
      <=> v131435(VarCurr,22) )
      & ( v131541(VarCurr,10)
      <=> v131435(VarCurr,21) )
      & ( v131541(VarCurr,9)
      <=> v131435(VarCurr,20) )
      & ( v131541(VarCurr,8)
      <=> v131435(VarCurr,19) )
      & ( v131541(VarCurr,7)
      <=> v131435(VarCurr,18) )
      & ( v131541(VarCurr,6)
      <=> v131435(VarCurr,17) )
      & ( v131541(VarCurr,5)
      <=> v131435(VarCurr,16) )
      & ( v131541(VarCurr,4)
      <=> v131435(VarCurr,15) )
      & ( v131541(VarCurr,3)
      <=> v131435(VarCurr,14) )
      & ( v131541(VarCurr,2)
      <=> v131435(VarCurr,13) )
      & ( v131541(VarCurr,1)
      <=> v131435(VarCurr,12) )
      & ( v131541(VarCurr,0)
      <=> v131435(VarCurr,11) ) ) ).

tff(addAssignment_75115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131435(VarCurr,B)
      <=> v131437(VarCurr,B) ) ) ).

tff(addAssignment_75114,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131437(VarNext,B)
      <=> v131873(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131874(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131873(VarNext,B)
            <=> v131437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1778,axiom,
    ! [VarNext: state_type] :
      ( v131874(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131873(VarNext,B)
          <=> v131532(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131874(VarNext)
      <=> v131875(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131875(VarNext)
      <=> ( v131877(VarNext)
          & v131464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131877(VarNext)
      <=> v131526(VarNext) ) ) ).

tff(addAssignment_75113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131459(VarCurr,B)
      <=> v131461(VarCurr,B) ) ) ).

tff(addAssignment_75112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131461(VarCurr,B)
      <=> v131462(VarCurr,B) ) ) ).

tff(addAssignment_75111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131304(VarCurr,B)
      <=> v131306(VarCurr,B) ) ) ).

tff(addAssignment_75110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131306(VarCurr,B)
      <=> v131413(VarCurr,B) ) ) ).

tff(addAssignment_75109,axiom,
    ! [VarCurr: state_type] :
      ( ( v131416(VarCurr,14)
      <=> v131310(VarCurr,25) )
      & ( v131416(VarCurr,13)
      <=> v131310(VarCurr,24) )
      & ( v131416(VarCurr,12)
      <=> v131310(VarCurr,23) )
      & ( v131416(VarCurr,11)
      <=> v131310(VarCurr,22) )
      & ( v131416(VarCurr,10)
      <=> v131310(VarCurr,21) )
      & ( v131416(VarCurr,9)
      <=> v131310(VarCurr,20) )
      & ( v131416(VarCurr,8)
      <=> v131310(VarCurr,19) )
      & ( v131416(VarCurr,7)
      <=> v131310(VarCurr,18) )
      & ( v131416(VarCurr,6)
      <=> v131310(VarCurr,17) )
      & ( v131416(VarCurr,5)
      <=> v131310(VarCurr,16) )
      & ( v131416(VarCurr,4)
      <=> v131310(VarCurr,15) )
      & ( v131416(VarCurr,3)
      <=> v131310(VarCurr,14) )
      & ( v131416(VarCurr,2)
      <=> v131310(VarCurr,13) )
      & ( v131416(VarCurr,1)
      <=> v131310(VarCurr,12) )
      & ( v131416(VarCurr,0)
      <=> v131310(VarCurr,11) ) ) ).

tff(addAssignment_75108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131310(VarCurr,B)
      <=> v131312(VarCurr,B) ) ) ).

tff(addAssignment_75107,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131312(VarNext,B)
      <=> v131864(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131865(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131864(VarNext,B)
            <=> v131312(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1777,axiom,
    ! [VarNext: state_type] :
      ( v131865(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131864(VarNext,B)
          <=> v131407(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131865(VarNext)
      <=> v131866(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131866(VarNext)
      <=> ( v131868(VarNext)
          & v131339(VarNext) ) ) ) ).

tff(writeUnaryOperator_9539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131868(VarNext)
      <=> v131401(VarNext) ) ) ).

tff(addAssignment_75106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131334(VarCurr,B)
      <=> v131336(VarCurr,B) ) ) ).

tff(addAssignment_75105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131336(VarCurr,B)
      <=> v131337(VarCurr,B) ) ) ).

tff(addAssignment_75104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131179(VarCurr,B)
      <=> v131181(VarCurr,B) ) ) ).

tff(addAssignment_75103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131181(VarCurr,B)
      <=> v131288(VarCurr,B) ) ) ).

tff(addAssignment_75102,axiom,
    ! [VarCurr: state_type] :
      ( ( v131291(VarCurr,14)
      <=> v131185(VarCurr,25) )
      & ( v131291(VarCurr,13)
      <=> v131185(VarCurr,24) )
      & ( v131291(VarCurr,12)
      <=> v131185(VarCurr,23) )
      & ( v131291(VarCurr,11)
      <=> v131185(VarCurr,22) )
      & ( v131291(VarCurr,10)
      <=> v131185(VarCurr,21) )
      & ( v131291(VarCurr,9)
      <=> v131185(VarCurr,20) )
      & ( v131291(VarCurr,8)
      <=> v131185(VarCurr,19) )
      & ( v131291(VarCurr,7)
      <=> v131185(VarCurr,18) )
      & ( v131291(VarCurr,6)
      <=> v131185(VarCurr,17) )
      & ( v131291(VarCurr,5)
      <=> v131185(VarCurr,16) )
      & ( v131291(VarCurr,4)
      <=> v131185(VarCurr,15) )
      & ( v131291(VarCurr,3)
      <=> v131185(VarCurr,14) )
      & ( v131291(VarCurr,2)
      <=> v131185(VarCurr,13) )
      & ( v131291(VarCurr,1)
      <=> v131185(VarCurr,12) )
      & ( v131291(VarCurr,0)
      <=> v131185(VarCurr,11) ) ) ).

tff(addAssignment_75101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131185(VarCurr,B)
      <=> v131187(VarCurr,B) ) ) ).

tff(addAssignment_75100,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131187(VarNext,B)
      <=> v131855(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131856(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131855(VarNext,B)
            <=> v131187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1776,axiom,
    ! [VarNext: state_type] :
      ( v131856(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131855(VarNext,B)
          <=> v131282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131856(VarNext)
      <=> v131857(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131857(VarNext)
      <=> ( v131859(VarNext)
          & v131214(VarNext) ) ) ) ).

tff(writeUnaryOperator_9538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131859(VarNext)
      <=> v131276(VarNext) ) ) ).

tff(addAssignment_75099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131209(VarCurr,B)
      <=> v131211(VarCurr,B) ) ) ).

tff(addAssignment_75098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131211(VarCurr,B)
      <=> v131212(VarCurr,B) ) ) ).

tff(addAssignment_75097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131054(VarCurr,B)
      <=> v131056(VarCurr,B) ) ) ).

tff(addAssignment_75096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131056(VarCurr,B)
      <=> v131163(VarCurr,B) ) ) ).

tff(addAssignment_75095,axiom,
    ! [VarCurr: state_type] :
      ( ( v131166(VarCurr,14)
      <=> v131060(VarCurr,25) )
      & ( v131166(VarCurr,13)
      <=> v131060(VarCurr,24) )
      & ( v131166(VarCurr,12)
      <=> v131060(VarCurr,23) )
      & ( v131166(VarCurr,11)
      <=> v131060(VarCurr,22) )
      & ( v131166(VarCurr,10)
      <=> v131060(VarCurr,21) )
      & ( v131166(VarCurr,9)
      <=> v131060(VarCurr,20) )
      & ( v131166(VarCurr,8)
      <=> v131060(VarCurr,19) )
      & ( v131166(VarCurr,7)
      <=> v131060(VarCurr,18) )
      & ( v131166(VarCurr,6)
      <=> v131060(VarCurr,17) )
      & ( v131166(VarCurr,5)
      <=> v131060(VarCurr,16) )
      & ( v131166(VarCurr,4)
      <=> v131060(VarCurr,15) )
      & ( v131166(VarCurr,3)
      <=> v131060(VarCurr,14) )
      & ( v131166(VarCurr,2)
      <=> v131060(VarCurr,13) )
      & ( v131166(VarCurr,1)
      <=> v131060(VarCurr,12) )
      & ( v131166(VarCurr,0)
      <=> v131060(VarCurr,11) ) ) ).

tff(addAssignment_75094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131060(VarCurr,B)
      <=> v131062(VarCurr,B) ) ) ).

tff(addAssignment_75093,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131062(VarNext,B)
      <=> v131846(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131847(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131846(VarNext,B)
            <=> v131062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1775,axiom,
    ! [VarNext: state_type] :
      ( v131847(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131846(VarNext,B)
          <=> v131157(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131847(VarNext)
      <=> v131848(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131848(VarNext)
      <=> ( v131850(VarNext)
          & v131089(VarNext) ) ) ) ).

tff(writeUnaryOperator_9537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131850(VarNext)
      <=> v131151(VarNext) ) ) ).

tff(addAssignment_75092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131084(VarCurr,B)
      <=> v131086(VarCurr,B) ) ) ).

tff(addAssignment_75091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v131086(VarCurr,B)
      <=> v131087(VarCurr,B) ) ) ).

tff(addAssignment_75090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130929(VarCurr,B)
      <=> v130931(VarCurr,B) ) ) ).

tff(addAssignment_75089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130931(VarCurr,B)
      <=> v131038(VarCurr,B) ) ) ).

tff(addAssignment_75088,axiom,
    ! [VarCurr: state_type] :
      ( ( v131041(VarCurr,14)
      <=> v130935(VarCurr,25) )
      & ( v131041(VarCurr,13)
      <=> v130935(VarCurr,24) )
      & ( v131041(VarCurr,12)
      <=> v130935(VarCurr,23) )
      & ( v131041(VarCurr,11)
      <=> v130935(VarCurr,22) )
      & ( v131041(VarCurr,10)
      <=> v130935(VarCurr,21) )
      & ( v131041(VarCurr,9)
      <=> v130935(VarCurr,20) )
      & ( v131041(VarCurr,8)
      <=> v130935(VarCurr,19) )
      & ( v131041(VarCurr,7)
      <=> v130935(VarCurr,18) )
      & ( v131041(VarCurr,6)
      <=> v130935(VarCurr,17) )
      & ( v131041(VarCurr,5)
      <=> v130935(VarCurr,16) )
      & ( v131041(VarCurr,4)
      <=> v130935(VarCurr,15) )
      & ( v131041(VarCurr,3)
      <=> v130935(VarCurr,14) )
      & ( v131041(VarCurr,2)
      <=> v130935(VarCurr,13) )
      & ( v131041(VarCurr,1)
      <=> v130935(VarCurr,12) )
      & ( v131041(VarCurr,0)
      <=> v130935(VarCurr,11) ) ) ).

tff(addAssignment_75087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130935(VarCurr,B)
      <=> v130937(VarCurr,B) ) ) ).

tff(addAssignment_75086,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130937(VarNext,B)
      <=> v131837(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131838(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131837(VarNext,B)
            <=> v130937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1774,axiom,
    ! [VarNext: state_type] :
      ( v131838(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131837(VarNext,B)
          <=> v131032(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131838(VarNext)
      <=> v131839(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131839(VarNext)
      <=> ( v131841(VarNext)
          & v130964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131841(VarNext)
      <=> v131026(VarNext) ) ) ).

tff(addAssignment_75085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130959(VarCurr,B)
      <=> v130961(VarCurr,B) ) ) ).

tff(addAssignment_75084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130961(VarCurr,B)
      <=> v130962(VarCurr,B) ) ) ).

tff(addAssignment_75083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130804(VarCurr,B)
      <=> v130806(VarCurr,B) ) ) ).

tff(addAssignment_75082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130806(VarCurr,B)
      <=> v130913(VarCurr,B) ) ) ).

tff(addAssignment_75081,axiom,
    ! [VarCurr: state_type] :
      ( ( v130916(VarCurr,14)
      <=> v130810(VarCurr,25) )
      & ( v130916(VarCurr,13)
      <=> v130810(VarCurr,24) )
      & ( v130916(VarCurr,12)
      <=> v130810(VarCurr,23) )
      & ( v130916(VarCurr,11)
      <=> v130810(VarCurr,22) )
      & ( v130916(VarCurr,10)
      <=> v130810(VarCurr,21) )
      & ( v130916(VarCurr,9)
      <=> v130810(VarCurr,20) )
      & ( v130916(VarCurr,8)
      <=> v130810(VarCurr,19) )
      & ( v130916(VarCurr,7)
      <=> v130810(VarCurr,18) )
      & ( v130916(VarCurr,6)
      <=> v130810(VarCurr,17) )
      & ( v130916(VarCurr,5)
      <=> v130810(VarCurr,16) )
      & ( v130916(VarCurr,4)
      <=> v130810(VarCurr,15) )
      & ( v130916(VarCurr,3)
      <=> v130810(VarCurr,14) )
      & ( v130916(VarCurr,2)
      <=> v130810(VarCurr,13) )
      & ( v130916(VarCurr,1)
      <=> v130810(VarCurr,12) )
      & ( v130916(VarCurr,0)
      <=> v130810(VarCurr,11) ) ) ).

tff(addAssignment_75080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130810(VarCurr,B)
      <=> v130812(VarCurr,B) ) ) ).

tff(addAssignment_75079,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130812(VarNext,B)
      <=> v131828(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131829(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131828(VarNext,B)
            <=> v130812(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1773,axiom,
    ! [VarNext: state_type] :
      ( v131829(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131828(VarNext,B)
          <=> v130907(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131829(VarNext)
      <=> v131830(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131830(VarNext)
      <=> ( v131832(VarNext)
          & v130839(VarNext) ) ) ) ).

tff(writeUnaryOperator_9535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131832(VarNext)
      <=> v130901(VarNext) ) ) ).

tff(addAssignment_75078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130834(VarCurr,B)
      <=> v130836(VarCurr,B) ) ) ).

tff(addAssignment_75077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130836(VarCurr,B)
      <=> v130837(VarCurr,B) ) ) ).

tff(addAssignment_75076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130152(VarCurr,B)
      <=> v130154(VarCurr,B) ) ) ).

tff(addAssignment_75075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130154(VarCurr,B)
      <=> v130371(VarCurr,B) ) ) ).

tff(addAssignment_75074,axiom,
    ! [VarCurr: state_type] :
      ( ( v130374(VarCurr,14)
      <=> v130158(VarCurr,25) )
      & ( v130374(VarCurr,13)
      <=> v130158(VarCurr,24) )
      & ( v130374(VarCurr,12)
      <=> v130158(VarCurr,23) )
      & ( v130374(VarCurr,11)
      <=> v130158(VarCurr,22) )
      & ( v130374(VarCurr,10)
      <=> v130158(VarCurr,21) )
      & ( v130374(VarCurr,9)
      <=> v130158(VarCurr,20) )
      & ( v130374(VarCurr,8)
      <=> v130158(VarCurr,19) )
      & ( v130374(VarCurr,7)
      <=> v130158(VarCurr,18) )
      & ( v130374(VarCurr,6)
      <=> v130158(VarCurr,17) )
      & ( v130374(VarCurr,5)
      <=> v130158(VarCurr,16) )
      & ( v130374(VarCurr,4)
      <=> v130158(VarCurr,15) )
      & ( v130374(VarCurr,3)
      <=> v130158(VarCurr,14) )
      & ( v130374(VarCurr,2)
      <=> v130158(VarCurr,13) )
      & ( v130374(VarCurr,1)
      <=> v130158(VarCurr,12) )
      & ( v130374(VarCurr,0)
      <=> v130158(VarCurr,11) ) ) ).

tff(addAssignment_75073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130158(VarCurr,B)
      <=> v130160(VarCurr,B) ) ) ).

tff(addAssignment_75072,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130160(VarNext,B)
      <=> v131819(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131820(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131819(VarNext,B)
            <=> v130160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1772,axiom,
    ! [VarNext: state_type] :
      ( v131820(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131819(VarNext,B)
          <=> v130365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131820(VarNext)
      <=> v131821(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131821(VarNext)
      <=> ( v131823(VarNext)
          & v130291(VarNext) ) ) ) ).

tff(writeUnaryOperator_9534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131823(VarNext)
      <=> v130359(VarNext) ) ) ).

tff(addAssignment_75071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130194(VarCurr,B)
      <=> v130196(VarCurr,B) ) ) ).

tff(addAssignment_75070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130196(VarCurr,B)
      <=> v130285(VarCurr,B) ) ) ).

tff(addAssignment_75069,axiom,
    ! [VarCurr: state_type] :
      ( ( v130288(VarCurr,14)
      <=> v130200(VarCurr,25) )
      & ( v130288(VarCurr,13)
      <=> v130200(VarCurr,24) )
      & ( v130288(VarCurr,12)
      <=> v130200(VarCurr,23) )
      & ( v130288(VarCurr,11)
      <=> v130200(VarCurr,22) )
      & ( v130288(VarCurr,10)
      <=> v130200(VarCurr,21) )
      & ( v130288(VarCurr,9)
      <=> v130200(VarCurr,20) )
      & ( v130288(VarCurr,8)
      <=> v130200(VarCurr,19) )
      & ( v130288(VarCurr,7)
      <=> v130200(VarCurr,18) )
      & ( v130288(VarCurr,6)
      <=> v130200(VarCurr,17) )
      & ( v130288(VarCurr,5)
      <=> v130200(VarCurr,16) )
      & ( v130288(VarCurr,4)
      <=> v130200(VarCurr,15) )
      & ( v130288(VarCurr,3)
      <=> v130200(VarCurr,14) )
      & ( v130288(VarCurr,2)
      <=> v130200(VarCurr,13) )
      & ( v130288(VarCurr,1)
      <=> v130200(VarCurr,12) )
      & ( v130288(VarCurr,0)
      <=> v130200(VarCurr,11) ) ) ).

tff(addAssignment_75068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130200(VarCurr,B)
      <=> v130202(VarCurr,B) ) ) ).

tff(addAssignment_75067,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130202(VarNext,B)
      <=> v131811(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131812(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131811(VarNext,B)
            <=> v130202(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1771,axiom,
    ! [VarNext: state_type] :
      ( v131812(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131811(VarNext,B)
          <=> v130279(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131812(VarNext)
      <=> v131813(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131813(VarNext)
      <=> ( v131815(VarNext)
          & v130240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131815(VarNext)
      <=> v130273(VarNext) ) ) ).

tff(addAssignment_75066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130224(VarCurr,B)
      <=> v130226(VarCurr,B) ) ) ).

tff(addAssignment_75065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,11) )
     => ( v130226(VarCurr,B)
      <=> v130234(VarCurr,B) ) ) ).

tff(addAssignment_75064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v130237(VarCurr,B)
      <=> v131801(VarCurr,B) ) ) ).

tff(addAssignment_75063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v131801(VarCurr,B)
      <=> v131803(VarCurr,B) ) ) ).

tff(addAssignment_75062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v131803(VarCurr,B)
      <=> v131805(VarCurr,B) ) ) ).

tff(addAssignment_75061,axiom,
    ! [VarCurr: state_type] :
      ( ( v131805(VarCurr,14)
      <=> v131807(VarCurr,51) )
      & ( v131805(VarCurr,13)
      <=> v131807(VarCurr,50) )
      & ( v131805(VarCurr,12)
      <=> v131807(VarCurr,49) )
      & ( v131805(VarCurr,11)
      <=> v131807(VarCurr,48) )
      & ( v131805(VarCurr,10)
      <=> v131807(VarCurr,47) )
      & ( v131805(VarCurr,9)
      <=> v131807(VarCurr,46) )
      & ( v131805(VarCurr,8)
      <=> v131807(VarCurr,45) )
      & ( v131805(VarCurr,7)
      <=> v131807(VarCurr,44) )
      & ( v131805(VarCurr,6)
      <=> v131807(VarCurr,43) )
      & ( v131805(VarCurr,5)
      <=> v131807(VarCurr,42) )
      & ( v131805(VarCurr,4)
      <=> v131807(VarCurr,41) )
      & ( v131805(VarCurr,3)
      <=> v131807(VarCurr,40) )
      & ( v131805(VarCurr,2)
      <=> v131807(VarCurr,39) )
      & ( v131805(VarCurr,1)
      <=> v131807(VarCurr,38) )
      & ( v131805(VarCurr,0)
      <=> v131807(VarCurr,37) ) ) ).

tff(addAssignment_75060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,37) )
     => ( v131807(VarCurr,B)
      <=> v131809(VarCurr,B) ) ) ).

tff(addAssignment_75059,axiom,
    ! [VarCurr: state_type] :
      ( ( v131710(VarCurr,2)
      <=> v130148(VarCurr,28) )
      & ( v131710(VarCurr,1)
      <=> v130148(VarCurr,27) )
      & ( v131710(VarCurr,0)
      <=> v130148(VarCurr,26) ) ) ).

tff(addAssignment_75058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130148(VarCurr,B)
      <=> v130150(VarCurr,B) ) ) ).

tff(addAssignment_75057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130150(VarCurr,B)
      <=> v131678(VarCurr,B) ) ) ).

tff(addAssignment_75056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131554(VarCurr,B)
      <=> v131556(VarCurr,B) ) ) ).

tff(addAssignment_75055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131556(VarCurr,B)
      <=> v131663(VarCurr,B) ) ) ).

tff(addAssignment_75054,axiom,
    ! [VarCurr: state_type] :
      ( ( v131665(VarCurr,2)
      <=> v131560(VarCurr,28) )
      & ( v131665(VarCurr,1)
      <=> v131560(VarCurr,27) )
      & ( v131665(VarCurr,0)
      <=> v131560(VarCurr,26) ) ) ).

tff(addAssignment_75053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131560(VarCurr,B)
      <=> v131562(VarCurr,B) ) ) ).

tff(addAssignment_75052,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131562(VarNext,B)
      <=> v131788(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131789(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131788(VarNext,B)
            <=> v131562(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1770,axiom,
    ! [VarNext: state_type] :
      ( v131789(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131788(VarNext,B)
          <=> v131657(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131789(VarNext)
      <=> v131790(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131790(VarNext)
      <=> ( v131792(VarNext)
          & v131589(VarNext) ) ) ) ).

tff(writeUnaryOperator_9532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131792(VarNext)
      <=> v131651(VarNext) ) ) ).

tff(addAssignment_75051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131584(VarCurr,B)
      <=> v131586(VarCurr,B) ) ) ).

tff(addAssignment_75050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131586(VarCurr,B)
      <=> v131587(VarCurr,B) ) ) ).

tff(addAssignment_75049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131429(VarCurr,B)
      <=> v131431(VarCurr,B) ) ) ).

tff(addAssignment_75048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131431(VarCurr,B)
      <=> v131538(VarCurr,B) ) ) ).

tff(addAssignment_75047,axiom,
    ! [VarCurr: state_type] :
      ( ( v131540(VarCurr,2)
      <=> v131435(VarCurr,28) )
      & ( v131540(VarCurr,1)
      <=> v131435(VarCurr,27) )
      & ( v131540(VarCurr,0)
      <=> v131435(VarCurr,26) ) ) ).

tff(addAssignment_75046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131435(VarCurr,B)
      <=> v131437(VarCurr,B) ) ) ).

tff(addAssignment_75045,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131437(VarNext,B)
      <=> v131779(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131780(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131779(VarNext,B)
            <=> v131437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1769,axiom,
    ! [VarNext: state_type] :
      ( v131780(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131779(VarNext,B)
          <=> v131532(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131780(VarNext)
      <=> v131781(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131781(VarNext)
      <=> ( v131783(VarNext)
          & v131464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131783(VarNext)
      <=> v131526(VarNext) ) ) ).

tff(addAssignment_75044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131459(VarCurr,B)
      <=> v131461(VarCurr,B) ) ) ).

tff(addAssignment_75043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131461(VarCurr,B)
      <=> v131462(VarCurr,B) ) ) ).

tff(addAssignment_75042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131304(VarCurr,B)
      <=> v131306(VarCurr,B) ) ) ).

tff(addAssignment_75041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131306(VarCurr,B)
      <=> v131413(VarCurr,B) ) ) ).

tff(addAssignment_75040,axiom,
    ! [VarCurr: state_type] :
      ( ( v131415(VarCurr,2)
      <=> v131310(VarCurr,28) )
      & ( v131415(VarCurr,1)
      <=> v131310(VarCurr,27) )
      & ( v131415(VarCurr,0)
      <=> v131310(VarCurr,26) ) ) ).

tff(addAssignment_75039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131310(VarCurr,B)
      <=> v131312(VarCurr,B) ) ) ).

tff(addAssignment_75038,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131312(VarNext,B)
      <=> v131770(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131771(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131770(VarNext,B)
            <=> v131312(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1768,axiom,
    ! [VarNext: state_type] :
      ( v131771(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131770(VarNext,B)
          <=> v131407(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131771(VarNext)
      <=> v131772(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131772(VarNext)
      <=> ( v131774(VarNext)
          & v131339(VarNext) ) ) ) ).

tff(writeUnaryOperator_9530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131774(VarNext)
      <=> v131401(VarNext) ) ) ).

tff(addAssignment_75037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131334(VarCurr,B)
      <=> v131336(VarCurr,B) ) ) ).

tff(addAssignment_75036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131336(VarCurr,B)
      <=> v131337(VarCurr,B) ) ) ).

tff(addAssignment_75035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131179(VarCurr,B)
      <=> v131181(VarCurr,B) ) ) ).

tff(addAssignment_75034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131181(VarCurr,B)
      <=> v131288(VarCurr,B) ) ) ).

tff(addAssignment_75033,axiom,
    ! [VarCurr: state_type] :
      ( ( v131290(VarCurr,2)
      <=> v131185(VarCurr,28) )
      & ( v131290(VarCurr,1)
      <=> v131185(VarCurr,27) )
      & ( v131290(VarCurr,0)
      <=> v131185(VarCurr,26) ) ) ).

tff(addAssignment_75032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131185(VarCurr,B)
      <=> v131187(VarCurr,B) ) ) ).

tff(addAssignment_75031,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131187(VarNext,B)
      <=> v131761(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131762(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131761(VarNext,B)
            <=> v131187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1767,axiom,
    ! [VarNext: state_type] :
      ( v131762(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131761(VarNext,B)
          <=> v131282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131762(VarNext)
      <=> v131763(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131763(VarNext)
      <=> ( v131765(VarNext)
          & v131214(VarNext) ) ) ) ).

tff(writeUnaryOperator_9529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131765(VarNext)
      <=> v131276(VarNext) ) ) ).

tff(addAssignment_75030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131209(VarCurr,B)
      <=> v131211(VarCurr,B) ) ) ).

tff(addAssignment_75029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131211(VarCurr,B)
      <=> v131212(VarCurr,B) ) ) ).

tff(addAssignment_75028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131054(VarCurr,B)
      <=> v131056(VarCurr,B) ) ) ).

tff(addAssignment_75027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131056(VarCurr,B)
      <=> v131163(VarCurr,B) ) ) ).

tff(addAssignment_75026,axiom,
    ! [VarCurr: state_type] :
      ( ( v131165(VarCurr,2)
      <=> v131060(VarCurr,28) )
      & ( v131165(VarCurr,1)
      <=> v131060(VarCurr,27) )
      & ( v131165(VarCurr,0)
      <=> v131060(VarCurr,26) ) ) ).

tff(addAssignment_75025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131060(VarCurr,B)
      <=> v131062(VarCurr,B) ) ) ).

tff(addAssignment_75024,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131062(VarNext,B)
      <=> v131752(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131753(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131752(VarNext,B)
            <=> v131062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1766,axiom,
    ! [VarNext: state_type] :
      ( v131753(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131752(VarNext,B)
          <=> v131157(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131753(VarNext)
      <=> v131754(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131754(VarNext)
      <=> ( v131756(VarNext)
          & v131089(VarNext) ) ) ) ).

tff(writeUnaryOperator_9528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131756(VarNext)
      <=> v131151(VarNext) ) ) ).

tff(addAssignment_75023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131084(VarCurr,B)
      <=> v131086(VarCurr,B) ) ) ).

tff(addAssignment_75022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v131086(VarCurr,B)
      <=> v131087(VarCurr,B) ) ) ).

tff(addAssignment_75021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130929(VarCurr,B)
      <=> v130931(VarCurr,B) ) ) ).

tff(addAssignment_75020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130931(VarCurr,B)
      <=> v131038(VarCurr,B) ) ) ).

tff(addAssignment_75019,axiom,
    ! [VarCurr: state_type] :
      ( ( v131040(VarCurr,2)
      <=> v130935(VarCurr,28) )
      & ( v131040(VarCurr,1)
      <=> v130935(VarCurr,27) )
      & ( v131040(VarCurr,0)
      <=> v130935(VarCurr,26) ) ) ).

tff(addAssignment_75018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130935(VarCurr,B)
      <=> v130937(VarCurr,B) ) ) ).

tff(addAssignment_75017,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130937(VarNext,B)
      <=> v131743(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131744(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131743(VarNext,B)
            <=> v130937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1765,axiom,
    ! [VarNext: state_type] :
      ( v131744(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131743(VarNext,B)
          <=> v131032(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131744(VarNext)
      <=> v131745(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131745(VarNext)
      <=> ( v131747(VarNext)
          & v130964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131747(VarNext)
      <=> v131026(VarNext) ) ) ).

tff(addAssignment_75016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130959(VarCurr,B)
      <=> v130961(VarCurr,B) ) ) ).

tff(addAssignment_75015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130961(VarCurr,B)
      <=> v130962(VarCurr,B) ) ) ).

tff(addAssignment_75014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130804(VarCurr,B)
      <=> v130806(VarCurr,B) ) ) ).

tff(addAssignment_75013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130806(VarCurr,B)
      <=> v130913(VarCurr,B) ) ) ).

tff(addAssignment_75012,axiom,
    ! [VarCurr: state_type] :
      ( ( v130915(VarCurr,2)
      <=> v130810(VarCurr,28) )
      & ( v130915(VarCurr,1)
      <=> v130810(VarCurr,27) )
      & ( v130915(VarCurr,0)
      <=> v130810(VarCurr,26) ) ) ).

tff(addAssignment_75011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130810(VarCurr,B)
      <=> v130812(VarCurr,B) ) ) ).

tff(addAssignment_75010,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130812(VarNext,B)
      <=> v131734(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131735(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131734(VarNext,B)
            <=> v130812(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1764,axiom,
    ! [VarNext: state_type] :
      ( v131735(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131734(VarNext,B)
          <=> v130907(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131735(VarNext)
      <=> v131736(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131736(VarNext)
      <=> ( v131738(VarNext)
          & v130839(VarNext) ) ) ) ).

tff(writeUnaryOperator_9526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131738(VarNext)
      <=> v130901(VarNext) ) ) ).

tff(addAssignment_75009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130834(VarCurr,B)
      <=> v130836(VarCurr,B) ) ) ).

tff(addAssignment_75008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130836(VarCurr,B)
      <=> v130837(VarCurr,B) ) ) ).

tff(addAssignment_75007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130152(VarCurr,B)
      <=> v130154(VarCurr,B) ) ) ).

tff(addAssignment_75006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130154(VarCurr,B)
      <=> v130371(VarCurr,B) ) ) ).

tff(addAssignment_75005,axiom,
    ! [VarCurr: state_type] :
      ( ( v130373(VarCurr,2)
      <=> v130158(VarCurr,28) )
      & ( v130373(VarCurr,1)
      <=> v130158(VarCurr,27) )
      & ( v130373(VarCurr,0)
      <=> v130158(VarCurr,26) ) ) ).

tff(addAssignment_75004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130158(VarCurr,B)
      <=> v130160(VarCurr,B) ) ) ).

tff(addAssignment_75003,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130160(VarNext,B)
      <=> v131725(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131726(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131725(VarNext,B)
            <=> v130160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1763,axiom,
    ! [VarNext: state_type] :
      ( v131726(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131725(VarNext,B)
          <=> v130365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131726(VarNext)
      <=> v131727(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131727(VarNext)
      <=> ( v131729(VarNext)
          & v130291(VarNext) ) ) ) ).

tff(writeUnaryOperator_9525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131729(VarNext)
      <=> v130359(VarNext) ) ) ).

tff(addAssignment_75002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130194(VarCurr,B)
      <=> v130196(VarCurr,B) ) ) ).

tff(addAssignment_75001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130196(VarCurr,B)
      <=> v130285(VarCurr,B) ) ) ).

tff(addAssignment_75000,axiom,
    ! [VarCurr: state_type] :
      ( ( v130287(VarCurr,2)
      <=> v130200(VarCurr,28) )
      & ( v130287(VarCurr,1)
      <=> v130200(VarCurr,27) )
      & ( v130287(VarCurr,0)
      <=> v130200(VarCurr,26) ) ) ).

tff(addAssignment_74999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130200(VarCurr,B)
      <=> v130202(VarCurr,B) ) ) ).

tff(addAssignment_74998,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130202(VarNext,B)
      <=> v131717(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131718(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131717(VarNext,B)
            <=> v130202(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1762,axiom,
    ! [VarNext: state_type] :
      ( v131718(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131717(VarNext,B)
          <=> v130279(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131718(VarNext)
      <=> v131719(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131719(VarNext)
      <=> ( v131721(VarNext)
          & v130240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131721(VarNext)
      <=> v130273(VarNext) ) ) ).

tff(addAssignment_74997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130224(VarCurr,B)
      <=> v130226(VarCurr,B) ) ) ).

tff(addAssignment_74996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v130226(VarCurr,B)
      <=> v130234(VarCurr,B) ) ) ).

tff(addAssignment_74995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v130236(VarCurr,B)
      <=> v131715(VarCurr,B) ) ) ).

tff(addAssignment_74994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v131715(VarCurr,B)
      <=> v109045(VarCurr,B) ) ) ).

tff(addAssignment_74993,axiom,
    ! [VarCurr: state_type] :
      ( ( v130146(VarCurr,3)
      <=> v130148(VarCurr,32) )
      & ( v130146(VarCurr,2)
      <=> v130148(VarCurr,31) )
      & ( v130146(VarCurr,1)
      <=> v130148(VarCurr,30) )
      & ( v130146(VarCurr,0)
      <=> v130148(VarCurr,29) ) ) ).

tff(addAssignment_74992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130148(VarCurr,B)
      <=> v130150(VarCurr,B) ) ) ).

tff(addAssignment_74991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130150(VarCurr,B)
      <=> v131678(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131678(VarCurr,B)
      <=> ( v131679(VarCurr,B)
          | v131706(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131706(VarCurr,B)
      <=> ( v131554(VarCurr,B)
          & v131707(VarCurr,B) ) ) ) ).

tff(addAssignment_74990,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,0)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74989,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,1)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74988,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,2)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74987,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,3)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74986,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,4)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74985,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,5)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74984,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,6)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74983,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,7)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74982,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,8)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74981,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,9)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74980,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,10)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74979,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,11)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74978,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,12)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74977,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,13)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74976,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,14)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74975,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,15)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74974,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,16)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74973,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,17)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74972,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,18)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74971,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,19)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74970,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,20)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74969,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,21)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74968,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,22)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74967,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,23)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74966,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,24)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74965,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,25)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74964,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,26)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74963,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,27)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74962,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,28)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74961,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,29)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74960,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,30)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74959,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,31)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74958,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,32)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74957,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,33)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74956,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,34)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74955,axiom,
    ! [VarCurr: state_type] :
      ( v131707(VarCurr,35)
    <=> v131708(VarCurr) ) ).

tff(addAssignment_74954,axiom,
    ! [VarCurr: state_type] :
      ( v131708(VarCurr)
    <=> v131669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131679(VarCurr,B)
      <=> ( v131680(VarCurr,B)
          | v131703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131703(VarCurr,B)
      <=> ( v131429(VarCurr,B)
          & v131704(VarCurr,B) ) ) ) ).

tff(addAssignment_74953,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,0)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74952,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,1)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74951,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,2)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74950,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,3)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74949,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,4)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74948,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,5)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74947,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,6)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74946,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,7)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74945,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,8)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74944,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,9)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74943,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,10)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74942,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,11)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74941,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,12)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74940,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,13)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74939,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,14)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74938,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,15)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74937,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,16)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74936,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,17)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74935,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,18)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74934,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,19)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74933,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,20)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74932,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,21)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74931,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,22)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74930,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,23)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74929,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,24)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74928,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,25)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74927,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,26)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74926,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,27)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74925,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,28)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74924,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,29)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74923,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,30)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74922,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,31)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74921,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,32)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74920,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,33)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74919,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,34)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74918,axiom,
    ! [VarCurr: state_type] :
      ( v131704(VarCurr,35)
    <=> v131705(VarCurr) ) ).

tff(addAssignment_74917,axiom,
    ! [VarCurr: state_type] :
      ( v131705(VarCurr)
    <=> v131544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131680(VarCurr,B)
      <=> ( v131681(VarCurr,B)
          | v131700(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131700(VarCurr,B)
      <=> ( v131304(VarCurr,B)
          & v131701(VarCurr,B) ) ) ) ).

tff(addAssignment_74916,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,0)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74915,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,1)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74914,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,2)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74913,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,3)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74912,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,4)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74911,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,5)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74910,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,6)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74909,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,7)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74908,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,8)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74907,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,9)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74906,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,10)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74905,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,11)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74904,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,12)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74903,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,13)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74902,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,14)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74901,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,15)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74900,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,16)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74899,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,17)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74898,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,18)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74897,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,19)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74896,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,20)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74895,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,21)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74894,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,22)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74893,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,23)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74892,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,24)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74891,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,25)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74890,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,26)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74889,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,27)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74888,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,28)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74887,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,29)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74886,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,30)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74885,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,31)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74884,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,32)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74883,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,33)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74882,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,34)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74881,axiom,
    ! [VarCurr: state_type] :
      ( v131701(VarCurr,35)
    <=> v131702(VarCurr) ) ).

tff(addAssignment_74880,axiom,
    ! [VarCurr: state_type] :
      ( v131702(VarCurr)
    <=> v131419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131681(VarCurr,B)
      <=> ( v131682(VarCurr,B)
          | v131697(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131697(VarCurr,B)
      <=> ( v131179(VarCurr,B)
          & v131698(VarCurr,B) ) ) ) ).

tff(addAssignment_74879,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,0)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74878,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,1)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74877,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,2)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74876,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,3)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74875,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,4)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74874,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,5)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74873,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,6)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74872,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,7)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74871,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,8)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74870,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,9)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74869,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,10)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74868,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,11)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74867,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,12)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74866,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,13)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74865,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,14)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74864,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,15)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74863,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,16)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74862,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,17)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74861,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,18)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74860,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,19)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74859,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,20)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74858,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,21)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74857,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,22)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74856,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,23)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74855,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,24)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74854,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,25)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74853,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,26)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74852,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,27)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74851,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,28)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74850,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,29)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74849,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,30)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74848,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,31)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74847,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,32)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74846,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,33)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74845,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,34)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74844,axiom,
    ! [VarCurr: state_type] :
      ( v131698(VarCurr,35)
    <=> v131699(VarCurr) ) ).

tff(addAssignment_74843,axiom,
    ! [VarCurr: state_type] :
      ( v131699(VarCurr)
    <=> v131294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131682(VarCurr,B)
      <=> ( v131683(VarCurr,B)
          | v131694(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131694(VarCurr,B)
      <=> ( v131054(VarCurr,B)
          & v131695(VarCurr,B) ) ) ) ).

tff(addAssignment_74842,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,0)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74841,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,1)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74840,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,2)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74839,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,3)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74838,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,4)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74837,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,5)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74836,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,6)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74835,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,7)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74834,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,8)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74833,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,9)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74832,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,10)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74831,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,11)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74830,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,12)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74829,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,13)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74828,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,14)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74827,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,15)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74826,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,16)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74825,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,17)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74824,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,18)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74823,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,19)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74822,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,20)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74821,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,21)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74820,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,22)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74819,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,23)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74818,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,24)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74817,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,25)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74816,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,26)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74815,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,27)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74814,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,28)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74813,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,29)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74812,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,30)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74811,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,31)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74810,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,32)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74809,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,33)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74808,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,34)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74807,axiom,
    ! [VarCurr: state_type] :
      ( v131695(VarCurr,35)
    <=> v131696(VarCurr) ) ).

tff(addAssignment_74806,axiom,
    ! [VarCurr: state_type] :
      ( v131696(VarCurr)
    <=> v131169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131683(VarCurr,B)
      <=> ( v131684(VarCurr,B)
          | v131691(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131691(VarCurr,B)
      <=> ( v130929(VarCurr,B)
          & v131692(VarCurr,B) ) ) ) ).

tff(addAssignment_74805,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,0)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74804,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,1)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74803,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,2)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74802,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,3)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74801,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,4)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74800,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,5)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74799,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,6)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74798,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,7)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74797,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,8)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74796,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,9)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74795,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,10)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74794,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,11)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74793,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,12)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74792,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,13)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74791,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,14)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74790,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,15)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74789,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,16)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74788,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,17)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74787,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,18)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74786,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,19)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74785,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,20)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74784,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,21)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74783,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,22)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74782,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,23)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74781,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,24)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74780,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,25)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74779,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,26)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74778,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,27)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74777,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,28)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74776,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,29)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74775,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,30)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74774,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,31)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74773,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,32)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74772,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,33)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74771,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,34)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74770,axiom,
    ! [VarCurr: state_type] :
      ( v131692(VarCurr,35)
    <=> v131693(VarCurr) ) ).

tff(addAssignment_74769,axiom,
    ! [VarCurr: state_type] :
      ( v131693(VarCurr)
    <=> v131044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131684(VarCurr,B)
      <=> ( v131685(VarCurr,B)
          | v131688(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131688(VarCurr,B)
      <=> ( v130804(VarCurr,B)
          & v131689(VarCurr,B) ) ) ) ).

tff(addAssignment_74768,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,0)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74767,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,1)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74766,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,2)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74765,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,3)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74764,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,4)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74763,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,5)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74762,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,6)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74761,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,7)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74760,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,8)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74759,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,9)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74758,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,10)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74757,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,11)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74756,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,12)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74755,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,13)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74754,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,14)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74753,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,15)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74752,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,16)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74751,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,17)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74750,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,18)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74749,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,19)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74748,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,20)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74747,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,21)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74746,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,22)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74745,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,23)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74744,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,24)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74743,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,25)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74742,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,26)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74741,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,27)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74740,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,28)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74739,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,29)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74738,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,30)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74737,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,31)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74736,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,32)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74735,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,33)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74734,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,34)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74733,axiom,
    ! [VarCurr: state_type] :
      ( v131689(VarCurr,35)
    <=> v131690(VarCurr) ) ).

tff(addAssignment_74732,axiom,
    ! [VarCurr: state_type] :
      ( v131690(VarCurr)
    <=> v130919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v131685(VarCurr,B)
      <=> ( v130152(VarCurr,B)
          & v131686(VarCurr,B) ) ) ) ).

tff(addAssignment_74731,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,0)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74730,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,1)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74729,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,2)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74728,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,3)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74727,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,4)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74726,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,5)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74725,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,6)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74724,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,7)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74723,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,8)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74722,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,9)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74721,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,10)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74720,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,11)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74719,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,12)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74718,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,13)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74717,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,14)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74716,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,15)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74715,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,16)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74714,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,17)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74713,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,18)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74712,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,19)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74711,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,20)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74710,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,21)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74709,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,22)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74708,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,23)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74707,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,24)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74706,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,25)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74705,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,26)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74704,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,27)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74703,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,28)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74702,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,29)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74701,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,30)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74700,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,31)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74699,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,32)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74698,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,33)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74697,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,34)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74696,axiom,
    ! [VarCurr: state_type] :
      ( v131686(VarCurr,35)
    <=> v131687(VarCurr) ) ).

tff(addAssignment_74695,axiom,
    ! [VarCurr: state_type] :
      ( v131687(VarCurr)
    <=> v130377(VarCurr) ) ).

tff(addAssignment_74694,axiom,
    ! [VarCurr: state_type] :
      ( v131669(VarCurr)
    <=> v131671(VarCurr) ) ).

tff(addAssignment_74693,axiom,
    ! [VarCurr: state_type] :
      ( v131671(VarCurr)
    <=> v131673(VarCurr) ) ).

tff(addAssignment_74692,axiom,
    ! [VarCurr: state_type] :
      ( v131673(VarCurr)
    <=> v131675(VarCurr) ) ).

tff(addAssignment_74691,axiom,
    ! [VarCurr: state_type] :
      ( v131675(VarCurr)
    <=> v131677(VarCurr) ) ).

tff(addAssignment_74690,axiom,
    ! [VarCurr: state_type] :
      ( v131677(VarCurr)
    <=> v130387(VarCurr,7) ) ).

tff(addAssignment_74689,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,7)
    <=> v130389(VarCurr,7) ) ).

tff(addAssignment_74688,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,7)
    <=> v130391(VarCurr,7) ) ).

tff(addAssignment_74687,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,7)
    <=> v130393(VarCurr,7) ) ).

tff(addAssignment_74686,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,7)
    <=> v130802(VarCurr,7) ) ).

tff(addAssignment_74685,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,7)
    <=> v130793(VarCurr,7) ) ).

tff(addAssignment_74684,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,7)
    <=> v130397(VarCurr,7) ) ).

tff(addAssignment_74683,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,7)
    <=> v130399(VarCurr,7) ) ).

tff(addAssignment_74682,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,7)
    <=> v130610(VarCurr,7) ) ).

tff(addAssignment_74681,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,7)
    <=> v130601(VarCurr,7) ) ).

tff(addAssignment_74680,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,7)
    <=> v130582(VarCurr,7) ) ).

tff(addAssignment_74679,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,7)
    <=> v130563(VarCurr,7) ) ).

tff(addAssignment_74678,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,7)
    <=> v130544(VarCurr,7) ) ).

tff(addAssignment_74677,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,7)
    <=> v130525(VarCurr,7) ) ).

tff(addAssignment_74676,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,7)
    <=> v130506(VarCurr,7) ) ).

tff(addAssignment_74675,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,7)
    <=> v130487(VarCurr,7) ) ).

tff(addAssignment_74674,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,7)
    <=> v130468(VarCurr,7) ) ).

tff(addAssignment_74673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131554(VarCurr,B)
      <=> v131556(VarCurr,B) ) ) ).

tff(addAssignment_74672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131556(VarCurr,B)
      <=> v131663(VarCurr,B) ) ) ).

tff(addAssignment_74671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131663(VarCurr,B)
      <=> v131667(VarCurr,B) ) ) ).

tff(addAssignment_74670,axiom,
    ! [VarCurr: state_type] :
      ( ( v131663(VarCurr,25)
      <=> v131666(VarCurr,14) )
      & ( v131663(VarCurr,24)
      <=> v131666(VarCurr,13) )
      & ( v131663(VarCurr,23)
      <=> v131666(VarCurr,12) )
      & ( v131663(VarCurr,22)
      <=> v131666(VarCurr,11) )
      & ( v131663(VarCurr,21)
      <=> v131666(VarCurr,10) )
      & ( v131663(VarCurr,20)
      <=> v131666(VarCurr,9) )
      & ( v131663(VarCurr,19)
      <=> v131666(VarCurr,8) )
      & ( v131663(VarCurr,18)
      <=> v131666(VarCurr,7) )
      & ( v131663(VarCurr,17)
      <=> v131666(VarCurr,6) )
      & ( v131663(VarCurr,16)
      <=> v131666(VarCurr,5) )
      & ( v131663(VarCurr,15)
      <=> v131666(VarCurr,4) )
      & ( v131663(VarCurr,14)
      <=> v131666(VarCurr,3) )
      & ( v131663(VarCurr,13)
      <=> v131666(VarCurr,2) )
      & ( v131663(VarCurr,12)
      <=> v131666(VarCurr,1) )
      & ( v131663(VarCurr,11)
      <=> v131666(VarCurr,0) ) ) ).

tff(addAssignment_74669,axiom,
    ! [VarCurr: state_type] :
      ( ( v131663(VarCurr,28)
      <=> v131665(VarCurr,2) )
      & ( v131663(VarCurr,27)
      <=> v131665(VarCurr,1) )
      & ( v131663(VarCurr,26)
      <=> v131665(VarCurr,0) ) ) ).

tff(addAssignment_74668,axiom,
    ! [VarCurr: state_type] :
      ( ( v131663(VarCurr,32)
      <=> v131558(VarCurr,3) )
      & ( v131663(VarCurr,31)
      <=> v131558(VarCurr,2) )
      & ( v131663(VarCurr,30)
      <=> v131558(VarCurr,1) )
      & ( v131663(VarCurr,29)
      <=> v131558(VarCurr,0) ) ) ).

tff(addAssignment_74667,axiom,
    ! [VarCurr: state_type] :
      ( ( v131663(VarCurr,35)
      <=> v131664(VarCurr,2) )
      & ( v131663(VarCurr,34)
      <=> v131664(VarCurr,1) )
      & ( v131663(VarCurr,33)
      <=> v131664(VarCurr,0) ) ) ).

tff(addAssignment_74666,axiom,
    ! [VarCurr: state_type] :
      ( ( v131558(VarCurr,3)
      <=> v131560(VarCurr,32) )
      & ( v131558(VarCurr,2)
      <=> v131560(VarCurr,31) )
      & ( v131558(VarCurr,1)
      <=> v131560(VarCurr,30) )
      & ( v131558(VarCurr,0)
      <=> v131560(VarCurr,29) ) ) ).

tff(addAssignment_74665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131560(VarCurr,B)
      <=> v131562(VarCurr,B) ) ) ).

tff(addAssignment_74664,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131562(VarNext,B)
      <=> v131646(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131647(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131646(VarNext,B)
            <=> v131562(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1761,axiom,
    ! [VarNext: state_type] :
      ( v131647(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131646(VarNext,B)
          <=> v131657(VarNext,B) ) ) ) ).

tff(addAssignment_74663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131657(VarNext,B)
          <=> v131655(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131658(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131655(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1322,axiom,
    ! [VarCurr: state_type] :
      ( v131658(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131655(VarCurr,B)
          <=> v131584(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17035,axiom,
    ! [VarCurr: state_type] :
      ( v131658(VarCurr)
    <=> ( v131659(VarCurr)
        & v131660(VarCurr) ) ) ).

tff(writeUnaryOperator_9523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131660(VarCurr)
    <=> v131574(VarCurr) ) ).

tff(writeUnaryOperator_9522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131659(VarCurr)
    <=> v131564(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131647(VarNext)
      <=> v131648(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131648(VarNext)
      <=> ( v131649(VarNext)
          & v131589(VarNext) ) ) ) ).

tff(writeUnaryOperator_9521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131649(VarNext)
      <=> v131651(VarNext) ) ) ).

tff(addAssignment_74662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131651(VarNext)
      <=> v131589(VarCurr) ) ) ).

tff(addAssignment_74661,axiom,
    ! [VarCurr: state_type] :
      ( v131589(VarCurr)
    <=> v131591(VarCurr) ) ).

tff(addAssignment_74660,axiom,
    ! [VarCurr: state_type] :
      ( v131591(VarCurr)
    <=> v131593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17032,axiom,
    ! [VarCurr: state_type] :
      ( v131593(VarCurr)
    <=> ( v131644(VarCurr)
        | v131640(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17031,axiom,
    ! [VarCurr: state_type] :
      ( v131644(VarCurr)
    <=> ( v131595(VarCurr)
        & v131599(VarCurr) ) ) ).

tff(addAssignment_74659,axiom,
    ! [VarCurr: state_type] :
      ( v131640(VarCurr)
    <=> v131642(VarCurr) ) ).

tff(addAssignment_74658,axiom,
    ! [VarCurr: state_type] :
      ( v131642(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131624(VarNext)
       => ( v131599(VarNext)
        <=> v131599(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1760,axiom,
    ! [VarNext: state_type] :
      ( v131624(VarNext)
     => ( v131599(VarNext)
      <=> v131634(VarNext) ) ) ).

tff(addAssignment_74657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131634(VarNext)
      <=> v131632(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17030,axiom,
    ! [VarCurr: state_type] :
      ( v131632(VarCurr)
    <=> ( v131635(VarCurr)
        & v131636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17029,axiom,
    ! [VarCurr: state_type] :
      ( v131636(VarCurr)
    <=> ( v131605(VarCurr)
        | v131619(VarCurr) ) ) ).

tff(writeUnaryOperator_9520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131635(VarCurr)
    <=> v131601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131624(VarNext)
      <=> v131625(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131625(VarNext)
      <=> ( v131627(VarNext)
          & v131629(VarNext) ) ) ) ).

tff(writeUnaryOperator_9519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131629(VarCurr)
    <=> v131595(VarCurr) ) ).

tff(addAssignment_74656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131627(VarNext)
      <=> v131595(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_253,axiom,
    ( v131599(constB0)
  <=> $true ) ).

tff(addAssignment_74655,axiom,
    ! [VarCurr: state_type] :
      ( v131619(VarCurr)
    <=> v131621(VarCurr) ) ).

tff(addAssignment_74654,axiom,
    ! [VarCurr: state_type] :
      ( v131621(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74653,axiom,
    ! [VarCurr: state_type] :
      ( v131605(VarCurr)
    <=> v131607(VarCurr) ) ).

tff(addAssignment_74652,axiom,
    ! [VarCurr: state_type] :
      ( v131607(VarCurr)
    <=> v131609(VarCurr) ) ).

tff(addAssignment_74651,axiom,
    ! [VarCurr: state_type] :
      ( v131609(VarCurr)
    <=> v131611(VarCurr) ) ).

tff(addAssignment_74650,axiom,
    ! [VarCurr: state_type] :
      ( v131611(VarCurr)
    <=> v131613(VarCurr) ) ).

tff(addAssignment_74649,axiom,
    ! [VarCurr: state_type] :
      ( v131613(VarCurr)
    <=> v131615(VarCurr) ) ).

tff(addAssignment_74648,axiom,
    ! [VarCurr: state_type] :
      ( v131615(VarCurr)
    <=> v131617(VarCurr) ) ).

tff(addAssignment_74647,axiom,
    ! [VarCurr: state_type] :
      ( v131617(VarCurr)
    <=> v130427(VarCurr) ) ).

tff(addAssignment_74646,axiom,
    ! [VarCurr: state_type] :
      ( v131601(VarCurr)
    <=> v131603(VarCurr) ) ).

tff(addAssignment_74645,axiom,
    ! [VarCurr: state_type] :
      ( v131603(VarCurr)
    <=> $false ) ).

tff(addAssignment_74644,axiom,
    ! [VarCurr: state_type] :
      ( v131595(VarCurr)
    <=> v131597(VarCurr) ) ).

tff(addAssignment_74643,axiom,
    ! [VarCurr: state_type] :
      ( v131597(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131584(VarCurr,B)
      <=> v131586(VarCurr,B) ) ) ).

tff(addAssignment_74641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131586(VarCurr,B)
      <=> v131587(VarCurr,B) ) ) ).

tff(addAssignment_74640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131587(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74639,axiom,
    ! [VarCurr: state_type] :
      ( ( v131587(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v131587(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v131587(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v131587(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v131587(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v131587(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v131587(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v131587(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v131587(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v131587(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v131587(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v131587(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v131587(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v131587(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v131587(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74638,axiom,
    ! [VarCurr: state_type] :
      ( ( v131587(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v131587(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v131587(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74637,axiom,
    ! [VarCurr: state_type] :
      ( ( v131587(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v131587(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v131587(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v131587(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74636,axiom,
    ! [VarCurr: state_type] :
      ( ( v131587(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v131587(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v131587(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74635,axiom,
    ! [VarCurr: state_type] :
      ( v131574(VarCurr)
    <=> v131576(VarCurr) ) ).

tff(addAssignment_74634,axiom,
    ! [VarCurr: state_type] :
      ( v131576(VarCurr)
    <=> v131578(VarCurr) ) ).

tff(addAssignment_74633,axiom,
    ! [VarCurr: state_type] :
      ( v131578(VarCurr)
    <=> v131580(VarCurr) ) ).

tff(addAssignment_74632,axiom,
    ! [VarCurr: state_type] :
      ( v131580(VarCurr)
    <=> v131582(VarCurr) ) ).

tff(addAssignment_74631,axiom,
    ! [VarCurr: state_type] :
      ( v131582(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74630,axiom,
    ! [VarCurr: state_type] :
      ( v131564(VarCurr)
    <=> v131566(VarCurr) ) ).

tff(addAssignment_74629,axiom,
    ! [VarCurr: state_type] :
      ( v131566(VarCurr)
    <=> v131568(VarCurr) ) ).

tff(addAssignment_74628,axiom,
    ! [VarCurr: state_type] :
      ( v131568(VarCurr)
    <=> v131570(VarCurr) ) ).

tff(addAssignment_74627,axiom,
    ! [VarCurr: state_type] :
      ( v131570(VarCurr)
    <=> v131572(VarCurr) ) ).

tff(addAssignment_74626,axiom,
    ! [VarCurr: state_type] :
      ( v131572(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74625,axiom,
    ! [VarCurr: state_type] :
      ( v131544(VarCurr)
    <=> v131546(VarCurr) ) ).

tff(addAssignment_74624,axiom,
    ! [VarCurr: state_type] :
      ( v131546(VarCurr)
    <=> v131548(VarCurr) ) ).

tff(addAssignment_74623,axiom,
    ! [VarCurr: state_type] :
      ( v131548(VarCurr)
    <=> v131550(VarCurr) ) ).

tff(addAssignment_74622,axiom,
    ! [VarCurr: state_type] :
      ( v131550(VarCurr)
    <=> v131552(VarCurr) ) ).

tff(addAssignment_74621,axiom,
    ! [VarCurr: state_type] :
      ( v131552(VarCurr)
    <=> v130387(VarCurr,6) ) ).

tff(addAssignment_74620,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,6)
    <=> v130389(VarCurr,6) ) ).

tff(addAssignment_74619,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,6)
    <=> v130391(VarCurr,6) ) ).

tff(addAssignment_74618,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,6)
    <=> v130393(VarCurr,6) ) ).

tff(addAssignment_74617,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,6)
    <=> v130802(VarCurr,6) ) ).

tff(addAssignment_74616,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,6)
    <=> v130793(VarCurr,6) ) ).

tff(addAssignment_74615,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,6)
    <=> v130397(VarCurr,6) ) ).

tff(addAssignment_74614,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,6)
    <=> v130399(VarCurr,6) ) ).

tff(addAssignment_74613,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,6)
    <=> v130610(VarCurr,6) ) ).

tff(addAssignment_74612,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,6)
    <=> v130601(VarCurr,6) ) ).

tff(addAssignment_74611,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,6)
    <=> v130582(VarCurr,6) ) ).

tff(addAssignment_74610,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,6)
    <=> v130563(VarCurr,6) ) ).

tff(addAssignment_74609,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,6)
    <=> v130544(VarCurr,6) ) ).

tff(addAssignment_74608,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,6)
    <=> v130525(VarCurr,6) ) ).

tff(addAssignment_74607,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,6)
    <=> v130506(VarCurr,6) ) ).

tff(addAssignment_74606,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,6)
    <=> v130487(VarCurr,6) ) ).

tff(addAssignment_74605,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,6)
    <=> v130468(VarCurr,6) ) ).

tff(addAssignment_74604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131429(VarCurr,B)
      <=> v131431(VarCurr,B) ) ) ).

tff(addAssignment_74603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131431(VarCurr,B)
      <=> v131538(VarCurr,B) ) ) ).

tff(addAssignment_74602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131538(VarCurr,B)
      <=> v131542(VarCurr,B) ) ) ).

tff(addAssignment_74601,axiom,
    ! [VarCurr: state_type] :
      ( ( v131538(VarCurr,25)
      <=> v131541(VarCurr,14) )
      & ( v131538(VarCurr,24)
      <=> v131541(VarCurr,13) )
      & ( v131538(VarCurr,23)
      <=> v131541(VarCurr,12) )
      & ( v131538(VarCurr,22)
      <=> v131541(VarCurr,11) )
      & ( v131538(VarCurr,21)
      <=> v131541(VarCurr,10) )
      & ( v131538(VarCurr,20)
      <=> v131541(VarCurr,9) )
      & ( v131538(VarCurr,19)
      <=> v131541(VarCurr,8) )
      & ( v131538(VarCurr,18)
      <=> v131541(VarCurr,7) )
      & ( v131538(VarCurr,17)
      <=> v131541(VarCurr,6) )
      & ( v131538(VarCurr,16)
      <=> v131541(VarCurr,5) )
      & ( v131538(VarCurr,15)
      <=> v131541(VarCurr,4) )
      & ( v131538(VarCurr,14)
      <=> v131541(VarCurr,3) )
      & ( v131538(VarCurr,13)
      <=> v131541(VarCurr,2) )
      & ( v131538(VarCurr,12)
      <=> v131541(VarCurr,1) )
      & ( v131538(VarCurr,11)
      <=> v131541(VarCurr,0) ) ) ).

tff(addAssignment_74600,axiom,
    ! [VarCurr: state_type] :
      ( ( v131538(VarCurr,28)
      <=> v131540(VarCurr,2) )
      & ( v131538(VarCurr,27)
      <=> v131540(VarCurr,1) )
      & ( v131538(VarCurr,26)
      <=> v131540(VarCurr,0) ) ) ).

tff(addAssignment_74599,axiom,
    ! [VarCurr: state_type] :
      ( ( v131538(VarCurr,32)
      <=> v131433(VarCurr,3) )
      & ( v131538(VarCurr,31)
      <=> v131433(VarCurr,2) )
      & ( v131538(VarCurr,30)
      <=> v131433(VarCurr,1) )
      & ( v131538(VarCurr,29)
      <=> v131433(VarCurr,0) ) ) ).

tff(addAssignment_74598,axiom,
    ! [VarCurr: state_type] :
      ( ( v131538(VarCurr,35)
      <=> v131539(VarCurr,2) )
      & ( v131538(VarCurr,34)
      <=> v131539(VarCurr,1) )
      & ( v131538(VarCurr,33)
      <=> v131539(VarCurr,0) ) ) ).

tff(addAssignment_74597,axiom,
    ! [VarCurr: state_type] :
      ( ( v131433(VarCurr,3)
      <=> v131435(VarCurr,32) )
      & ( v131433(VarCurr,2)
      <=> v131435(VarCurr,31) )
      & ( v131433(VarCurr,1)
      <=> v131435(VarCurr,30) )
      & ( v131433(VarCurr,0)
      <=> v131435(VarCurr,29) ) ) ).

tff(addAssignment_74596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131435(VarCurr,B)
      <=> v131437(VarCurr,B) ) ) ).

tff(addAssignment_74595,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131437(VarNext,B)
      <=> v131521(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131522(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131521(VarNext,B)
            <=> v131437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1759,axiom,
    ! [VarNext: state_type] :
      ( v131522(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131521(VarNext,B)
          <=> v131532(VarNext,B) ) ) ) ).

tff(addAssignment_74594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131532(VarNext,B)
          <=> v131530(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131533(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131530(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1321,axiom,
    ! [VarCurr: state_type] :
      ( v131533(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131530(VarCurr,B)
          <=> v131459(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17026,axiom,
    ! [VarCurr: state_type] :
      ( v131533(VarCurr)
    <=> ( v131534(VarCurr)
        & v131535(VarCurr) ) ) ).

tff(writeUnaryOperator_9518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131535(VarCurr)
    <=> v131449(VarCurr) ) ).

tff(writeUnaryOperator_9517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131534(VarCurr)
    <=> v131439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131522(VarNext)
      <=> v131523(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131523(VarNext)
      <=> ( v131524(VarNext)
          & v131464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131524(VarNext)
      <=> v131526(VarNext) ) ) ).

tff(addAssignment_74593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131526(VarNext)
      <=> v131464(VarCurr) ) ) ).

tff(addAssignment_74592,axiom,
    ! [VarCurr: state_type] :
      ( v131464(VarCurr)
    <=> v131466(VarCurr) ) ).

tff(addAssignment_74591,axiom,
    ! [VarCurr: state_type] :
      ( v131466(VarCurr)
    <=> v131468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17023,axiom,
    ! [VarCurr: state_type] :
      ( v131468(VarCurr)
    <=> ( v131519(VarCurr)
        | v131515(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17022,axiom,
    ! [VarCurr: state_type] :
      ( v131519(VarCurr)
    <=> ( v131470(VarCurr)
        & v131474(VarCurr) ) ) ).

tff(addAssignment_74590,axiom,
    ! [VarCurr: state_type] :
      ( v131515(VarCurr)
    <=> v131517(VarCurr) ) ).

tff(addAssignment_74589,axiom,
    ! [VarCurr: state_type] :
      ( v131517(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131499(VarNext)
       => ( v131474(VarNext)
        <=> v131474(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1758,axiom,
    ! [VarNext: state_type] :
      ( v131499(VarNext)
     => ( v131474(VarNext)
      <=> v131509(VarNext) ) ) ).

tff(addAssignment_74588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131509(VarNext)
      <=> v131507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17021,axiom,
    ! [VarCurr: state_type] :
      ( v131507(VarCurr)
    <=> ( v131510(VarCurr)
        & v131511(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17020,axiom,
    ! [VarCurr: state_type] :
      ( v131511(VarCurr)
    <=> ( v131480(VarCurr)
        | v131494(VarCurr) ) ) ).

tff(writeUnaryOperator_9515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131510(VarCurr)
    <=> v131476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131499(VarNext)
      <=> v131500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131500(VarNext)
      <=> ( v131502(VarNext)
          & v131504(VarNext) ) ) ) ).

tff(writeUnaryOperator_9514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131504(VarCurr)
    <=> v131470(VarCurr) ) ).

tff(addAssignment_74587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131502(VarNext)
      <=> v131470(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_252,axiom,
    ( v131474(constB0)
  <=> $true ) ).

tff(addAssignment_74586,axiom,
    ! [VarCurr: state_type] :
      ( v131494(VarCurr)
    <=> v131496(VarCurr) ) ).

tff(addAssignment_74585,axiom,
    ! [VarCurr: state_type] :
      ( v131496(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74584,axiom,
    ! [VarCurr: state_type] :
      ( v131480(VarCurr)
    <=> v131482(VarCurr) ) ).

tff(addAssignment_74583,axiom,
    ! [VarCurr: state_type] :
      ( v131482(VarCurr)
    <=> v131484(VarCurr) ) ).

tff(addAssignment_74582,axiom,
    ! [VarCurr: state_type] :
      ( v131484(VarCurr)
    <=> v131486(VarCurr) ) ).

tff(addAssignment_74581,axiom,
    ! [VarCurr: state_type] :
      ( v131486(VarCurr)
    <=> v131488(VarCurr) ) ).

tff(addAssignment_74580,axiom,
    ! [VarCurr: state_type] :
      ( v131488(VarCurr)
    <=> v131490(VarCurr) ) ).

tff(addAssignment_74579,axiom,
    ! [VarCurr: state_type] :
      ( v131490(VarCurr)
    <=> v131492(VarCurr) ) ).

tff(addAssignment_74578,axiom,
    ! [VarCurr: state_type] :
      ( v131492(VarCurr)
    <=> v130420(VarCurr) ) ).

tff(addAssignment_74577,axiom,
    ! [VarCurr: state_type] :
      ( v131476(VarCurr)
    <=> v131478(VarCurr) ) ).

tff(addAssignment_74576,axiom,
    ! [VarCurr: state_type] :
      ( v131478(VarCurr)
    <=> $false ) ).

tff(addAssignment_74575,axiom,
    ! [VarCurr: state_type] :
      ( v131470(VarCurr)
    <=> v131472(VarCurr) ) ).

tff(addAssignment_74574,axiom,
    ! [VarCurr: state_type] :
      ( v131472(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131459(VarCurr,B)
      <=> v131461(VarCurr,B) ) ) ).

tff(addAssignment_74572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131461(VarCurr,B)
      <=> v131462(VarCurr,B) ) ) ).

tff(addAssignment_74571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131462(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74570,axiom,
    ! [VarCurr: state_type] :
      ( ( v131462(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v131462(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v131462(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v131462(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v131462(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v131462(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v131462(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v131462(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v131462(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v131462(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v131462(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v131462(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v131462(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v131462(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v131462(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74569,axiom,
    ! [VarCurr: state_type] :
      ( ( v131462(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v131462(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v131462(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74568,axiom,
    ! [VarCurr: state_type] :
      ( ( v131462(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v131462(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v131462(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v131462(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74567,axiom,
    ! [VarCurr: state_type] :
      ( ( v131462(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v131462(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v131462(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74566,axiom,
    ! [VarCurr: state_type] :
      ( v131449(VarCurr)
    <=> v131451(VarCurr) ) ).

tff(addAssignment_74565,axiom,
    ! [VarCurr: state_type] :
      ( v131451(VarCurr)
    <=> v131453(VarCurr) ) ).

tff(addAssignment_74564,axiom,
    ! [VarCurr: state_type] :
      ( v131453(VarCurr)
    <=> v131455(VarCurr) ) ).

tff(addAssignment_74563,axiom,
    ! [VarCurr: state_type] :
      ( v131455(VarCurr)
    <=> v131457(VarCurr) ) ).

tff(addAssignment_74562,axiom,
    ! [VarCurr: state_type] :
      ( v131457(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74561,axiom,
    ! [VarCurr: state_type] :
      ( v131439(VarCurr)
    <=> v131441(VarCurr) ) ).

tff(addAssignment_74560,axiom,
    ! [VarCurr: state_type] :
      ( v131441(VarCurr)
    <=> v131443(VarCurr) ) ).

tff(addAssignment_74559,axiom,
    ! [VarCurr: state_type] :
      ( v131443(VarCurr)
    <=> v131445(VarCurr) ) ).

tff(addAssignment_74558,axiom,
    ! [VarCurr: state_type] :
      ( v131445(VarCurr)
    <=> v131447(VarCurr) ) ).

tff(addAssignment_74557,axiom,
    ! [VarCurr: state_type] :
      ( v131447(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74556,axiom,
    ! [VarCurr: state_type] :
      ( v131419(VarCurr)
    <=> v131421(VarCurr) ) ).

tff(addAssignment_74555,axiom,
    ! [VarCurr: state_type] :
      ( v131421(VarCurr)
    <=> v131423(VarCurr) ) ).

tff(addAssignment_74554,axiom,
    ! [VarCurr: state_type] :
      ( v131423(VarCurr)
    <=> v131425(VarCurr) ) ).

tff(addAssignment_74553,axiom,
    ! [VarCurr: state_type] :
      ( v131425(VarCurr)
    <=> v131427(VarCurr) ) ).

tff(addAssignment_74552,axiom,
    ! [VarCurr: state_type] :
      ( v131427(VarCurr)
    <=> v130387(VarCurr,5) ) ).

tff(addAssignment_74551,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,5)
    <=> v130389(VarCurr,5) ) ).

tff(addAssignment_74550,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,5)
    <=> v130391(VarCurr,5) ) ).

tff(addAssignment_74549,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,5)
    <=> v130393(VarCurr,5) ) ).

tff(addAssignment_74548,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,5)
    <=> v130802(VarCurr,5) ) ).

tff(addAssignment_74547,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,5)
    <=> v130793(VarCurr,5) ) ).

tff(addAssignment_74546,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,5)
    <=> v130397(VarCurr,5) ) ).

tff(addAssignment_74545,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,5)
    <=> v130399(VarCurr,5) ) ).

tff(addAssignment_74544,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,5)
    <=> v130610(VarCurr,5) ) ).

tff(addAssignment_74543,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,5)
    <=> v130601(VarCurr,5) ) ).

tff(addAssignment_74542,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,5)
    <=> v130582(VarCurr,5) ) ).

tff(addAssignment_74541,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,5)
    <=> v130563(VarCurr,5) ) ).

tff(addAssignment_74540,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,5)
    <=> v130544(VarCurr,5) ) ).

tff(addAssignment_74539,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,5)
    <=> v130525(VarCurr,5) ) ).

tff(addAssignment_74538,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,5)
    <=> v130506(VarCurr,5) ) ).

tff(addAssignment_74537,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,5)
    <=> v130487(VarCurr,5) ) ).

tff(addAssignment_74536,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,5)
    <=> v130468(VarCurr,5) ) ).

tff(addAssignment_74535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131304(VarCurr,B)
      <=> v131306(VarCurr,B) ) ) ).

tff(addAssignment_74534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131306(VarCurr,B)
      <=> v131413(VarCurr,B) ) ) ).

tff(addAssignment_74533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131413(VarCurr,B)
      <=> v131417(VarCurr,B) ) ) ).

tff(addAssignment_74532,axiom,
    ! [VarCurr: state_type] :
      ( ( v131413(VarCurr,25)
      <=> v131416(VarCurr,14) )
      & ( v131413(VarCurr,24)
      <=> v131416(VarCurr,13) )
      & ( v131413(VarCurr,23)
      <=> v131416(VarCurr,12) )
      & ( v131413(VarCurr,22)
      <=> v131416(VarCurr,11) )
      & ( v131413(VarCurr,21)
      <=> v131416(VarCurr,10) )
      & ( v131413(VarCurr,20)
      <=> v131416(VarCurr,9) )
      & ( v131413(VarCurr,19)
      <=> v131416(VarCurr,8) )
      & ( v131413(VarCurr,18)
      <=> v131416(VarCurr,7) )
      & ( v131413(VarCurr,17)
      <=> v131416(VarCurr,6) )
      & ( v131413(VarCurr,16)
      <=> v131416(VarCurr,5) )
      & ( v131413(VarCurr,15)
      <=> v131416(VarCurr,4) )
      & ( v131413(VarCurr,14)
      <=> v131416(VarCurr,3) )
      & ( v131413(VarCurr,13)
      <=> v131416(VarCurr,2) )
      & ( v131413(VarCurr,12)
      <=> v131416(VarCurr,1) )
      & ( v131413(VarCurr,11)
      <=> v131416(VarCurr,0) ) ) ).

tff(addAssignment_74531,axiom,
    ! [VarCurr: state_type] :
      ( ( v131413(VarCurr,28)
      <=> v131415(VarCurr,2) )
      & ( v131413(VarCurr,27)
      <=> v131415(VarCurr,1) )
      & ( v131413(VarCurr,26)
      <=> v131415(VarCurr,0) ) ) ).

tff(addAssignment_74530,axiom,
    ! [VarCurr: state_type] :
      ( ( v131413(VarCurr,32)
      <=> v131308(VarCurr,3) )
      & ( v131413(VarCurr,31)
      <=> v131308(VarCurr,2) )
      & ( v131413(VarCurr,30)
      <=> v131308(VarCurr,1) )
      & ( v131413(VarCurr,29)
      <=> v131308(VarCurr,0) ) ) ).

tff(addAssignment_74529,axiom,
    ! [VarCurr: state_type] :
      ( ( v131413(VarCurr,35)
      <=> v131414(VarCurr,2) )
      & ( v131413(VarCurr,34)
      <=> v131414(VarCurr,1) )
      & ( v131413(VarCurr,33)
      <=> v131414(VarCurr,0) ) ) ).

tff(addAssignment_74528,axiom,
    ! [VarCurr: state_type] :
      ( ( v131308(VarCurr,3)
      <=> v131310(VarCurr,32) )
      & ( v131308(VarCurr,2)
      <=> v131310(VarCurr,31) )
      & ( v131308(VarCurr,1)
      <=> v131310(VarCurr,30) )
      & ( v131308(VarCurr,0)
      <=> v131310(VarCurr,29) ) ) ).

tff(addAssignment_74527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131310(VarCurr,B)
      <=> v131312(VarCurr,B) ) ) ).

tff(addAssignment_74526,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131312(VarNext,B)
      <=> v131396(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131397(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131396(VarNext,B)
            <=> v131312(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1757,axiom,
    ! [VarNext: state_type] :
      ( v131397(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131396(VarNext,B)
          <=> v131407(VarNext,B) ) ) ) ).

tff(addAssignment_74525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131407(VarNext,B)
          <=> v131405(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131405(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1320,axiom,
    ! [VarCurr: state_type] :
      ( v131408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131405(VarCurr,B)
          <=> v131334(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17017,axiom,
    ! [VarCurr: state_type] :
      ( v131408(VarCurr)
    <=> ( v131409(VarCurr)
        & v131410(VarCurr) ) ) ).

tff(writeUnaryOperator_9513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131410(VarCurr)
    <=> v131324(VarCurr) ) ).

tff(writeUnaryOperator_9512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131409(VarCurr)
    <=> v131314(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131397(VarNext)
      <=> v131398(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131398(VarNext)
      <=> ( v131399(VarNext)
          & v131339(VarNext) ) ) ) ).

tff(writeUnaryOperator_9511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131399(VarNext)
      <=> v131401(VarNext) ) ) ).

tff(addAssignment_74524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131401(VarNext)
      <=> v131339(VarCurr) ) ) ).

tff(addAssignment_74523,axiom,
    ! [VarCurr: state_type] :
      ( v131339(VarCurr)
    <=> v131341(VarCurr) ) ).

tff(addAssignment_74522,axiom,
    ! [VarCurr: state_type] :
      ( v131341(VarCurr)
    <=> v131343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17014,axiom,
    ! [VarCurr: state_type] :
      ( v131343(VarCurr)
    <=> ( v131394(VarCurr)
        | v131390(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17013,axiom,
    ! [VarCurr: state_type] :
      ( v131394(VarCurr)
    <=> ( v131345(VarCurr)
        & v131349(VarCurr) ) ) ).

tff(addAssignment_74521,axiom,
    ! [VarCurr: state_type] :
      ( v131390(VarCurr)
    <=> v131392(VarCurr) ) ).

tff(addAssignment_74520,axiom,
    ! [VarCurr: state_type] :
      ( v131392(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131374(VarNext)
       => ( v131349(VarNext)
        <=> v131349(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1756,axiom,
    ! [VarNext: state_type] :
      ( v131374(VarNext)
     => ( v131349(VarNext)
      <=> v131384(VarNext) ) ) ).

tff(addAssignment_74519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131384(VarNext)
      <=> v131382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17012,axiom,
    ! [VarCurr: state_type] :
      ( v131382(VarCurr)
    <=> ( v131385(VarCurr)
        & v131386(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17011,axiom,
    ! [VarCurr: state_type] :
      ( v131386(VarCurr)
    <=> ( v131355(VarCurr)
        | v131369(VarCurr) ) ) ).

tff(writeUnaryOperator_9510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131385(VarCurr)
    <=> v131351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131374(VarNext)
      <=> v131375(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131375(VarNext)
      <=> ( v131377(VarNext)
          & v131379(VarNext) ) ) ) ).

tff(writeUnaryOperator_9509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131379(VarCurr)
    <=> v131345(VarCurr) ) ).

tff(addAssignment_74518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131377(VarNext)
      <=> v131345(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_251,axiom,
    ( v131349(constB0)
  <=> $true ) ).

tff(addAssignment_74517,axiom,
    ! [VarCurr: state_type] :
      ( v131369(VarCurr)
    <=> v131371(VarCurr) ) ).

tff(addAssignment_74516,axiom,
    ! [VarCurr: state_type] :
      ( v131371(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74515,axiom,
    ! [VarCurr: state_type] :
      ( v131355(VarCurr)
    <=> v131357(VarCurr) ) ).

tff(addAssignment_74514,axiom,
    ! [VarCurr: state_type] :
      ( v131357(VarCurr)
    <=> v131359(VarCurr) ) ).

tff(addAssignment_74513,axiom,
    ! [VarCurr: state_type] :
      ( v131359(VarCurr)
    <=> v131361(VarCurr) ) ).

tff(addAssignment_74512,axiom,
    ! [VarCurr: state_type] :
      ( v131361(VarCurr)
    <=> v131363(VarCurr) ) ).

tff(addAssignment_74511,axiom,
    ! [VarCurr: state_type] :
      ( v131363(VarCurr)
    <=> v131365(VarCurr) ) ).

tff(addAssignment_74510,axiom,
    ! [VarCurr: state_type] :
      ( v131365(VarCurr)
    <=> v131367(VarCurr) ) ).

tff(addAssignment_74509,axiom,
    ! [VarCurr: state_type] :
      ( v131367(VarCurr)
    <=> v130413(VarCurr) ) ).

tff(addAssignment_74508,axiom,
    ! [VarCurr: state_type] :
      ( v131351(VarCurr)
    <=> v131353(VarCurr) ) ).

tff(addAssignment_74507,axiom,
    ! [VarCurr: state_type] :
      ( v131353(VarCurr)
    <=> $false ) ).

tff(addAssignment_74506,axiom,
    ! [VarCurr: state_type] :
      ( v131345(VarCurr)
    <=> v131347(VarCurr) ) ).

tff(addAssignment_74505,axiom,
    ! [VarCurr: state_type] :
      ( v131347(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131334(VarCurr,B)
      <=> v131336(VarCurr,B) ) ) ).

tff(addAssignment_74503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131336(VarCurr,B)
      <=> v131337(VarCurr,B) ) ) ).

tff(addAssignment_74502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131337(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74501,axiom,
    ! [VarCurr: state_type] :
      ( ( v131337(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v131337(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v131337(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v131337(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v131337(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v131337(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v131337(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v131337(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v131337(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v131337(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v131337(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v131337(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v131337(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v131337(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v131337(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74500,axiom,
    ! [VarCurr: state_type] :
      ( ( v131337(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v131337(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v131337(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74499,axiom,
    ! [VarCurr: state_type] :
      ( ( v131337(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v131337(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v131337(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v131337(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74498,axiom,
    ! [VarCurr: state_type] :
      ( ( v131337(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v131337(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v131337(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74497,axiom,
    ! [VarCurr: state_type] :
      ( v131324(VarCurr)
    <=> v131326(VarCurr) ) ).

tff(addAssignment_74496,axiom,
    ! [VarCurr: state_type] :
      ( v131326(VarCurr)
    <=> v131328(VarCurr) ) ).

tff(addAssignment_74495,axiom,
    ! [VarCurr: state_type] :
      ( v131328(VarCurr)
    <=> v131330(VarCurr) ) ).

tff(addAssignment_74494,axiom,
    ! [VarCurr: state_type] :
      ( v131330(VarCurr)
    <=> v131332(VarCurr) ) ).

tff(addAssignment_74493,axiom,
    ! [VarCurr: state_type] :
      ( v131332(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74492,axiom,
    ! [VarCurr: state_type] :
      ( v131314(VarCurr)
    <=> v131316(VarCurr) ) ).

tff(addAssignment_74491,axiom,
    ! [VarCurr: state_type] :
      ( v131316(VarCurr)
    <=> v131318(VarCurr) ) ).

tff(addAssignment_74490,axiom,
    ! [VarCurr: state_type] :
      ( v131318(VarCurr)
    <=> v131320(VarCurr) ) ).

tff(addAssignment_74489,axiom,
    ! [VarCurr: state_type] :
      ( v131320(VarCurr)
    <=> v131322(VarCurr) ) ).

tff(addAssignment_74488,axiom,
    ! [VarCurr: state_type] :
      ( v131322(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74487,axiom,
    ! [VarCurr: state_type] :
      ( v131294(VarCurr)
    <=> v131296(VarCurr) ) ).

tff(addAssignment_74486,axiom,
    ! [VarCurr: state_type] :
      ( v131296(VarCurr)
    <=> v131298(VarCurr) ) ).

tff(addAssignment_74485,axiom,
    ! [VarCurr: state_type] :
      ( v131298(VarCurr)
    <=> v131300(VarCurr) ) ).

tff(addAssignment_74484,axiom,
    ! [VarCurr: state_type] :
      ( v131300(VarCurr)
    <=> v131302(VarCurr) ) ).

tff(addAssignment_74483,axiom,
    ! [VarCurr: state_type] :
      ( v131302(VarCurr)
    <=> v130387(VarCurr,4) ) ).

tff(addAssignment_74482,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,4)
    <=> v130389(VarCurr,4) ) ).

tff(addAssignment_74481,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,4)
    <=> v130391(VarCurr,4) ) ).

tff(addAssignment_74480,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,4)
    <=> v130393(VarCurr,4) ) ).

tff(addAssignment_74479,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,4)
    <=> v130802(VarCurr,4) ) ).

tff(addAssignment_74478,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,4)
    <=> v130793(VarCurr,4) ) ).

tff(addAssignment_74477,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,4)
    <=> v130397(VarCurr,4) ) ).

tff(addAssignment_74476,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,4)
    <=> v130399(VarCurr,4) ) ).

tff(addAssignment_74475,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,4)
    <=> v130610(VarCurr,4) ) ).

tff(addAssignment_74474,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,4)
    <=> v130601(VarCurr,4) ) ).

tff(addAssignment_74473,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,4)
    <=> v130582(VarCurr,4) ) ).

tff(addAssignment_74472,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,4)
    <=> v130563(VarCurr,4) ) ).

tff(addAssignment_74471,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,4)
    <=> v130544(VarCurr,4) ) ).

tff(addAssignment_74470,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,4)
    <=> v130525(VarCurr,4) ) ).

tff(addAssignment_74469,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,4)
    <=> v130506(VarCurr,4) ) ).

tff(addAssignment_74468,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,4)
    <=> v130487(VarCurr,4) ) ).

tff(addAssignment_74467,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,4)
    <=> v130468(VarCurr,4) ) ).

tff(addAssignment_74466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131179(VarCurr,B)
      <=> v131181(VarCurr,B) ) ) ).

tff(addAssignment_74465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131181(VarCurr,B)
      <=> v131288(VarCurr,B) ) ) ).

tff(addAssignment_74464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131288(VarCurr,B)
      <=> v131292(VarCurr,B) ) ) ).

tff(addAssignment_74463,axiom,
    ! [VarCurr: state_type] :
      ( ( v131288(VarCurr,25)
      <=> v131291(VarCurr,14) )
      & ( v131288(VarCurr,24)
      <=> v131291(VarCurr,13) )
      & ( v131288(VarCurr,23)
      <=> v131291(VarCurr,12) )
      & ( v131288(VarCurr,22)
      <=> v131291(VarCurr,11) )
      & ( v131288(VarCurr,21)
      <=> v131291(VarCurr,10) )
      & ( v131288(VarCurr,20)
      <=> v131291(VarCurr,9) )
      & ( v131288(VarCurr,19)
      <=> v131291(VarCurr,8) )
      & ( v131288(VarCurr,18)
      <=> v131291(VarCurr,7) )
      & ( v131288(VarCurr,17)
      <=> v131291(VarCurr,6) )
      & ( v131288(VarCurr,16)
      <=> v131291(VarCurr,5) )
      & ( v131288(VarCurr,15)
      <=> v131291(VarCurr,4) )
      & ( v131288(VarCurr,14)
      <=> v131291(VarCurr,3) )
      & ( v131288(VarCurr,13)
      <=> v131291(VarCurr,2) )
      & ( v131288(VarCurr,12)
      <=> v131291(VarCurr,1) )
      & ( v131288(VarCurr,11)
      <=> v131291(VarCurr,0) ) ) ).

tff(addAssignment_74462,axiom,
    ! [VarCurr: state_type] :
      ( ( v131288(VarCurr,28)
      <=> v131290(VarCurr,2) )
      & ( v131288(VarCurr,27)
      <=> v131290(VarCurr,1) )
      & ( v131288(VarCurr,26)
      <=> v131290(VarCurr,0) ) ) ).

tff(addAssignment_74461,axiom,
    ! [VarCurr: state_type] :
      ( ( v131288(VarCurr,32)
      <=> v131183(VarCurr,3) )
      & ( v131288(VarCurr,31)
      <=> v131183(VarCurr,2) )
      & ( v131288(VarCurr,30)
      <=> v131183(VarCurr,1) )
      & ( v131288(VarCurr,29)
      <=> v131183(VarCurr,0) ) ) ).

tff(addAssignment_74460,axiom,
    ! [VarCurr: state_type] :
      ( ( v131288(VarCurr,35)
      <=> v131289(VarCurr,2) )
      & ( v131288(VarCurr,34)
      <=> v131289(VarCurr,1) )
      & ( v131288(VarCurr,33)
      <=> v131289(VarCurr,0) ) ) ).

tff(addAssignment_74459,axiom,
    ! [VarCurr: state_type] :
      ( ( v131183(VarCurr,3)
      <=> v131185(VarCurr,32) )
      & ( v131183(VarCurr,2)
      <=> v131185(VarCurr,31) )
      & ( v131183(VarCurr,1)
      <=> v131185(VarCurr,30) )
      & ( v131183(VarCurr,0)
      <=> v131185(VarCurr,29) ) ) ).

tff(addAssignment_74458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131185(VarCurr,B)
      <=> v131187(VarCurr,B) ) ) ).

tff(addAssignment_74457,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131187(VarNext,B)
      <=> v131271(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131272(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131271(VarNext,B)
            <=> v131187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1755,axiom,
    ! [VarNext: state_type] :
      ( v131272(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131271(VarNext,B)
          <=> v131282(VarNext,B) ) ) ) ).

tff(addAssignment_74456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131282(VarNext,B)
          <=> v131280(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131283(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131280(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1319,axiom,
    ! [VarCurr: state_type] :
      ( v131283(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131280(VarCurr,B)
          <=> v131209(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17008,axiom,
    ! [VarCurr: state_type] :
      ( v131283(VarCurr)
    <=> ( v131284(VarCurr)
        & v131285(VarCurr) ) ) ).

tff(writeUnaryOperator_9508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131285(VarCurr)
    <=> v131199(VarCurr) ) ).

tff(writeUnaryOperator_9507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131284(VarCurr)
    <=> v131189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131272(VarNext)
      <=> v131273(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131273(VarNext)
      <=> ( v131274(VarNext)
          & v131214(VarNext) ) ) ) ).

tff(writeUnaryOperator_9506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131274(VarNext)
      <=> v131276(VarNext) ) ) ).

tff(addAssignment_74455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131276(VarNext)
      <=> v131214(VarCurr) ) ) ).

tff(addAssignment_74454,axiom,
    ! [VarCurr: state_type] :
      ( v131214(VarCurr)
    <=> v131216(VarCurr) ) ).

tff(addAssignment_74453,axiom,
    ! [VarCurr: state_type] :
      ( v131216(VarCurr)
    <=> v131218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17005,axiom,
    ! [VarCurr: state_type] :
      ( v131218(VarCurr)
    <=> ( v131269(VarCurr)
        | v131265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17004,axiom,
    ! [VarCurr: state_type] :
      ( v131269(VarCurr)
    <=> ( v131220(VarCurr)
        & v131224(VarCurr) ) ) ).

tff(addAssignment_74452,axiom,
    ! [VarCurr: state_type] :
      ( v131265(VarCurr)
    <=> v131267(VarCurr) ) ).

tff(addAssignment_74451,axiom,
    ! [VarCurr: state_type] :
      ( v131267(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131249(VarNext)
       => ( v131224(VarNext)
        <=> v131224(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1754,axiom,
    ! [VarNext: state_type] :
      ( v131249(VarNext)
     => ( v131224(VarNext)
      <=> v131259(VarNext) ) ) ).

tff(addAssignment_74450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131259(VarNext)
      <=> v131257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17003,axiom,
    ! [VarCurr: state_type] :
      ( v131257(VarCurr)
    <=> ( v131260(VarCurr)
        & v131261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17002,axiom,
    ! [VarCurr: state_type] :
      ( v131261(VarCurr)
    <=> ( v131230(VarCurr)
        | v131244(VarCurr) ) ) ).

tff(writeUnaryOperator_9505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131260(VarCurr)
    <=> v131226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131249(VarNext)
      <=> v131250(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131250(VarNext)
      <=> ( v131252(VarNext)
          & v131254(VarNext) ) ) ) ).

tff(writeUnaryOperator_9504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131254(VarCurr)
    <=> v131220(VarCurr) ) ).

tff(addAssignment_74449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131252(VarNext)
      <=> v131220(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_250,axiom,
    ( v131224(constB0)
  <=> $true ) ).

tff(addAssignment_74448,axiom,
    ! [VarCurr: state_type] :
      ( v131244(VarCurr)
    <=> v131246(VarCurr) ) ).

tff(addAssignment_74447,axiom,
    ! [VarCurr: state_type] :
      ( v131246(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74446,axiom,
    ! [VarCurr: state_type] :
      ( v131230(VarCurr)
    <=> v131232(VarCurr) ) ).

tff(addAssignment_74445,axiom,
    ! [VarCurr: state_type] :
      ( v131232(VarCurr)
    <=> v131234(VarCurr) ) ).

tff(addAssignment_74444,axiom,
    ! [VarCurr: state_type] :
      ( v131234(VarCurr)
    <=> v131236(VarCurr) ) ).

tff(addAssignment_74443,axiom,
    ! [VarCurr: state_type] :
      ( v131236(VarCurr)
    <=> v131238(VarCurr) ) ).

tff(addAssignment_74442,axiom,
    ! [VarCurr: state_type] :
      ( v131238(VarCurr)
    <=> v131240(VarCurr) ) ).

tff(addAssignment_74441,axiom,
    ! [VarCurr: state_type] :
      ( v131240(VarCurr)
    <=> v131242(VarCurr) ) ).

tff(addAssignment_74440,axiom,
    ! [VarCurr: state_type] :
      ( v131242(VarCurr)
    <=> v130404(VarCurr) ) ).

tff(addAssignment_74439,axiom,
    ! [VarCurr: state_type] :
      ( v131226(VarCurr)
    <=> v131228(VarCurr) ) ).

tff(addAssignment_74438,axiom,
    ! [VarCurr: state_type] :
      ( v131228(VarCurr)
    <=> $false ) ).

tff(addAssignment_74437,axiom,
    ! [VarCurr: state_type] :
      ( v131220(VarCurr)
    <=> v131222(VarCurr) ) ).

tff(addAssignment_74436,axiom,
    ! [VarCurr: state_type] :
      ( v131222(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131209(VarCurr,B)
      <=> v131211(VarCurr,B) ) ) ).

tff(addAssignment_74434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131211(VarCurr,B)
      <=> v131212(VarCurr,B) ) ) ).

tff(addAssignment_74433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131212(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74432,axiom,
    ! [VarCurr: state_type] :
      ( ( v131212(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v131212(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v131212(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v131212(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v131212(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v131212(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v131212(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v131212(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v131212(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v131212(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v131212(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v131212(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v131212(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v131212(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v131212(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74431,axiom,
    ! [VarCurr: state_type] :
      ( ( v131212(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v131212(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v131212(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74430,axiom,
    ! [VarCurr: state_type] :
      ( ( v131212(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v131212(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v131212(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v131212(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74429,axiom,
    ! [VarCurr: state_type] :
      ( ( v131212(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v131212(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v131212(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74428,axiom,
    ! [VarCurr: state_type] :
      ( v131199(VarCurr)
    <=> v131201(VarCurr) ) ).

tff(addAssignment_74427,axiom,
    ! [VarCurr: state_type] :
      ( v131201(VarCurr)
    <=> v131203(VarCurr) ) ).

tff(addAssignment_74426,axiom,
    ! [VarCurr: state_type] :
      ( v131203(VarCurr)
    <=> v131205(VarCurr) ) ).

tff(addAssignment_74425,axiom,
    ! [VarCurr: state_type] :
      ( v131205(VarCurr)
    <=> v131207(VarCurr) ) ).

tff(addAssignment_74424,axiom,
    ! [VarCurr: state_type] :
      ( v131207(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74423,axiom,
    ! [VarCurr: state_type] :
      ( v131189(VarCurr)
    <=> v131191(VarCurr) ) ).

tff(addAssignment_74422,axiom,
    ! [VarCurr: state_type] :
      ( v131191(VarCurr)
    <=> v131193(VarCurr) ) ).

tff(addAssignment_74421,axiom,
    ! [VarCurr: state_type] :
      ( v131193(VarCurr)
    <=> v131195(VarCurr) ) ).

tff(addAssignment_74420,axiom,
    ! [VarCurr: state_type] :
      ( v131195(VarCurr)
    <=> v131197(VarCurr) ) ).

tff(addAssignment_74419,axiom,
    ! [VarCurr: state_type] :
      ( v131197(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74418,axiom,
    ! [VarCurr: state_type] :
      ( v131169(VarCurr)
    <=> v131171(VarCurr) ) ).

tff(addAssignment_74417,axiom,
    ! [VarCurr: state_type] :
      ( v131171(VarCurr)
    <=> v131173(VarCurr) ) ).

tff(addAssignment_74416,axiom,
    ! [VarCurr: state_type] :
      ( v131173(VarCurr)
    <=> v131175(VarCurr) ) ).

tff(addAssignment_74415,axiom,
    ! [VarCurr: state_type] :
      ( v131175(VarCurr)
    <=> v131177(VarCurr) ) ).

tff(addAssignment_74414,axiom,
    ! [VarCurr: state_type] :
      ( v131177(VarCurr)
    <=> v130387(VarCurr,3) ) ).

tff(addAssignment_74413,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,3)
    <=> v130389(VarCurr,3) ) ).

tff(addAssignment_74412,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,3)
    <=> v130391(VarCurr,3) ) ).

tff(addAssignment_74411,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,3)
    <=> v130393(VarCurr,3) ) ).

tff(addAssignment_74410,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,3)
    <=> v130802(VarCurr,3) ) ).

tff(addAssignment_74409,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,3)
    <=> v130793(VarCurr,3) ) ).

tff(addAssignment_74408,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,3)
    <=> v130397(VarCurr,3) ) ).

tff(addAssignment_74407,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,3)
    <=> v130399(VarCurr,3) ) ).

tff(addAssignment_74406,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,3)
    <=> v130610(VarCurr,3) ) ).

tff(addAssignment_74405,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,3)
    <=> v130601(VarCurr,3) ) ).

tff(addAssignment_74404,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,3)
    <=> v130582(VarCurr,3) ) ).

tff(addAssignment_74403,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,3)
    <=> v130563(VarCurr,3) ) ).

tff(addAssignment_74402,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,3)
    <=> v130544(VarCurr,3) ) ).

tff(addAssignment_74401,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,3)
    <=> v130525(VarCurr,3) ) ).

tff(addAssignment_74400,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,3)
    <=> v130506(VarCurr,3) ) ).

tff(addAssignment_74399,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,3)
    <=> v130487(VarCurr,3) ) ).

tff(addAssignment_74398,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,3)
    <=> v130468(VarCurr,3) ) ).

tff(addAssignment_74397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131054(VarCurr,B)
      <=> v131056(VarCurr,B) ) ) ).

tff(addAssignment_74396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131056(VarCurr,B)
      <=> v131163(VarCurr,B) ) ) ).

tff(addAssignment_74395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131163(VarCurr,B)
      <=> v131167(VarCurr,B) ) ) ).

tff(addAssignment_74394,axiom,
    ! [VarCurr: state_type] :
      ( ( v131163(VarCurr,25)
      <=> v131166(VarCurr,14) )
      & ( v131163(VarCurr,24)
      <=> v131166(VarCurr,13) )
      & ( v131163(VarCurr,23)
      <=> v131166(VarCurr,12) )
      & ( v131163(VarCurr,22)
      <=> v131166(VarCurr,11) )
      & ( v131163(VarCurr,21)
      <=> v131166(VarCurr,10) )
      & ( v131163(VarCurr,20)
      <=> v131166(VarCurr,9) )
      & ( v131163(VarCurr,19)
      <=> v131166(VarCurr,8) )
      & ( v131163(VarCurr,18)
      <=> v131166(VarCurr,7) )
      & ( v131163(VarCurr,17)
      <=> v131166(VarCurr,6) )
      & ( v131163(VarCurr,16)
      <=> v131166(VarCurr,5) )
      & ( v131163(VarCurr,15)
      <=> v131166(VarCurr,4) )
      & ( v131163(VarCurr,14)
      <=> v131166(VarCurr,3) )
      & ( v131163(VarCurr,13)
      <=> v131166(VarCurr,2) )
      & ( v131163(VarCurr,12)
      <=> v131166(VarCurr,1) )
      & ( v131163(VarCurr,11)
      <=> v131166(VarCurr,0) ) ) ).

tff(addAssignment_74393,axiom,
    ! [VarCurr: state_type] :
      ( ( v131163(VarCurr,28)
      <=> v131165(VarCurr,2) )
      & ( v131163(VarCurr,27)
      <=> v131165(VarCurr,1) )
      & ( v131163(VarCurr,26)
      <=> v131165(VarCurr,0) ) ) ).

tff(addAssignment_74392,axiom,
    ! [VarCurr: state_type] :
      ( ( v131163(VarCurr,32)
      <=> v131058(VarCurr,3) )
      & ( v131163(VarCurr,31)
      <=> v131058(VarCurr,2) )
      & ( v131163(VarCurr,30)
      <=> v131058(VarCurr,1) )
      & ( v131163(VarCurr,29)
      <=> v131058(VarCurr,0) ) ) ).

tff(addAssignment_74391,axiom,
    ! [VarCurr: state_type] :
      ( ( v131163(VarCurr,35)
      <=> v131164(VarCurr,2) )
      & ( v131163(VarCurr,34)
      <=> v131164(VarCurr,1) )
      & ( v131163(VarCurr,33)
      <=> v131164(VarCurr,0) ) ) ).

tff(addAssignment_74390,axiom,
    ! [VarCurr: state_type] :
      ( ( v131058(VarCurr,3)
      <=> v131060(VarCurr,32) )
      & ( v131058(VarCurr,2)
      <=> v131060(VarCurr,31) )
      & ( v131058(VarCurr,1)
      <=> v131060(VarCurr,30) )
      & ( v131058(VarCurr,0)
      <=> v131060(VarCurr,29) ) ) ).

tff(addAssignment_74389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131060(VarCurr,B)
      <=> v131062(VarCurr,B) ) ) ).

tff(addAssignment_74388,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131062(VarNext,B)
      <=> v131146(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131147(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131146(VarNext,B)
            <=> v131062(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1753,axiom,
    ! [VarNext: state_type] :
      ( v131147(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131146(VarNext,B)
          <=> v131157(VarNext,B) ) ) ) ).

tff(addAssignment_74387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131157(VarNext,B)
          <=> v131155(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131158(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131155(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1318,axiom,
    ! [VarCurr: state_type] :
      ( v131158(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131155(VarCurr,B)
          <=> v131084(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16999,axiom,
    ! [VarCurr: state_type] :
      ( v131158(VarCurr)
    <=> ( v131159(VarCurr)
        & v131160(VarCurr) ) ) ).

tff(writeUnaryOperator_9503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131160(VarCurr)
    <=> v131074(VarCurr) ) ).

tff(writeUnaryOperator_9502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131159(VarCurr)
    <=> v131064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131147(VarNext)
      <=> v131148(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131148(VarNext)
      <=> ( v131149(VarNext)
          & v131089(VarNext) ) ) ) ).

tff(writeUnaryOperator_9501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131149(VarNext)
      <=> v131151(VarNext) ) ) ).

tff(addAssignment_74386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131151(VarNext)
      <=> v131089(VarCurr) ) ) ).

tff(addAssignment_74385,axiom,
    ! [VarCurr: state_type] :
      ( v131089(VarCurr)
    <=> v131091(VarCurr) ) ).

tff(addAssignment_74384,axiom,
    ! [VarCurr: state_type] :
      ( v131091(VarCurr)
    <=> v131093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16996,axiom,
    ! [VarCurr: state_type] :
      ( v131093(VarCurr)
    <=> ( v131144(VarCurr)
        | v131140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16995,axiom,
    ! [VarCurr: state_type] :
      ( v131144(VarCurr)
    <=> ( v131095(VarCurr)
        & v131099(VarCurr) ) ) ).

tff(addAssignment_74383,axiom,
    ! [VarCurr: state_type] :
      ( v131140(VarCurr)
    <=> v131142(VarCurr) ) ).

tff(addAssignment_74382,axiom,
    ! [VarCurr: state_type] :
      ( v131142(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131124(VarNext)
       => ( v131099(VarNext)
        <=> v131099(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1752,axiom,
    ! [VarNext: state_type] :
      ( v131124(VarNext)
     => ( v131099(VarNext)
      <=> v131134(VarNext) ) ) ).

tff(addAssignment_74381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131134(VarNext)
      <=> v131132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16994,axiom,
    ! [VarCurr: state_type] :
      ( v131132(VarCurr)
    <=> ( v131135(VarCurr)
        & v131136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16993,axiom,
    ! [VarCurr: state_type] :
      ( v131136(VarCurr)
    <=> ( v131105(VarCurr)
        | v131119(VarCurr) ) ) ).

tff(writeUnaryOperator_9500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131135(VarCurr)
    <=> v131101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131124(VarNext)
      <=> v131125(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131125(VarNext)
      <=> ( v131127(VarNext)
          & v131129(VarNext) ) ) ) ).

tff(writeUnaryOperator_9499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131129(VarCurr)
    <=> v131095(VarCurr) ) ).

tff(addAssignment_74380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131127(VarNext)
      <=> v131095(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_249,axiom,
    ( v131099(constB0)
  <=> $true ) ).

tff(addAssignment_74379,axiom,
    ! [VarCurr: state_type] :
      ( v131119(VarCurr)
    <=> v131121(VarCurr) ) ).

tff(addAssignment_74378,axiom,
    ! [VarCurr: state_type] :
      ( v131121(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74377,axiom,
    ! [VarCurr: state_type] :
      ( v131105(VarCurr)
    <=> v131107(VarCurr) ) ).

tff(addAssignment_74376,axiom,
    ! [VarCurr: state_type] :
      ( v131107(VarCurr)
    <=> v131109(VarCurr) ) ).

tff(addAssignment_74375,axiom,
    ! [VarCurr: state_type] :
      ( v131109(VarCurr)
    <=> v131111(VarCurr) ) ).

tff(addAssignment_74374,axiom,
    ! [VarCurr: state_type] :
      ( v131111(VarCurr)
    <=> v131113(VarCurr) ) ).

tff(addAssignment_74373,axiom,
    ! [VarCurr: state_type] :
      ( v131113(VarCurr)
    <=> v131115(VarCurr) ) ).

tff(addAssignment_74372,axiom,
    ! [VarCurr: state_type] :
      ( v131115(VarCurr)
    <=> v131117(VarCurr) ) ).

tff(addAssignment_74371,axiom,
    ! [VarCurr: state_type] :
      ( v131117(VarCurr)
    <=> v130440(VarCurr) ) ).

tff(addAssignment_74370,axiom,
    ! [VarCurr: state_type] :
      ( v131101(VarCurr)
    <=> v131103(VarCurr) ) ).

tff(addAssignment_74369,axiom,
    ! [VarCurr: state_type] :
      ( v131103(VarCurr)
    <=> $false ) ).

tff(addAssignment_74368,axiom,
    ! [VarCurr: state_type] :
      ( v131095(VarCurr)
    <=> v131097(VarCurr) ) ).

tff(addAssignment_74367,axiom,
    ! [VarCurr: state_type] :
      ( v131097(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131084(VarCurr,B)
      <=> v131086(VarCurr,B) ) ) ).

tff(addAssignment_74365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v131086(VarCurr,B)
      <=> v131087(VarCurr,B) ) ) ).

tff(addAssignment_74364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131087(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74363,axiom,
    ! [VarCurr: state_type] :
      ( ( v131087(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v131087(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v131087(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v131087(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v131087(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v131087(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v131087(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v131087(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v131087(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v131087(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v131087(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v131087(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v131087(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v131087(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v131087(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74362,axiom,
    ! [VarCurr: state_type] :
      ( ( v131087(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v131087(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v131087(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74361,axiom,
    ! [VarCurr: state_type] :
      ( ( v131087(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v131087(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v131087(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v131087(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74360,axiom,
    ! [VarCurr: state_type] :
      ( ( v131087(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v131087(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v131087(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74359,axiom,
    ! [VarCurr: state_type] :
      ( v131074(VarCurr)
    <=> v131076(VarCurr) ) ).

tff(addAssignment_74358,axiom,
    ! [VarCurr: state_type] :
      ( v131076(VarCurr)
    <=> v131078(VarCurr) ) ).

tff(addAssignment_74357,axiom,
    ! [VarCurr: state_type] :
      ( v131078(VarCurr)
    <=> v131080(VarCurr) ) ).

tff(addAssignment_74356,axiom,
    ! [VarCurr: state_type] :
      ( v131080(VarCurr)
    <=> v131082(VarCurr) ) ).

tff(addAssignment_74355,axiom,
    ! [VarCurr: state_type] :
      ( v131082(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74354,axiom,
    ! [VarCurr: state_type] :
      ( v131064(VarCurr)
    <=> v131066(VarCurr) ) ).

tff(addAssignment_74353,axiom,
    ! [VarCurr: state_type] :
      ( v131066(VarCurr)
    <=> v131068(VarCurr) ) ).

tff(addAssignment_74352,axiom,
    ! [VarCurr: state_type] :
      ( v131068(VarCurr)
    <=> v131070(VarCurr) ) ).

tff(addAssignment_74351,axiom,
    ! [VarCurr: state_type] :
      ( v131070(VarCurr)
    <=> v131072(VarCurr) ) ).

tff(addAssignment_74350,axiom,
    ! [VarCurr: state_type] :
      ( v131072(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74349,axiom,
    ! [VarCurr: state_type] :
      ( v131044(VarCurr)
    <=> v131046(VarCurr) ) ).

tff(addAssignment_74348,axiom,
    ! [VarCurr: state_type] :
      ( v131046(VarCurr)
    <=> v131048(VarCurr) ) ).

tff(addAssignment_74347,axiom,
    ! [VarCurr: state_type] :
      ( v131048(VarCurr)
    <=> v131050(VarCurr) ) ).

tff(addAssignment_74346,axiom,
    ! [VarCurr: state_type] :
      ( v131050(VarCurr)
    <=> v131052(VarCurr) ) ).

tff(addAssignment_74345,axiom,
    ! [VarCurr: state_type] :
      ( v131052(VarCurr)
    <=> v130387(VarCurr,2) ) ).

tff(addAssignment_74344,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,2)
    <=> v130389(VarCurr,2) ) ).

tff(addAssignment_74343,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,2)
    <=> v130391(VarCurr,2) ) ).

tff(addAssignment_74342,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,2)
    <=> v130393(VarCurr,2) ) ).

tff(addAssignment_74341,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,2)
    <=> v130802(VarCurr,2) ) ).

tff(addAssignment_74340,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,2)
    <=> v130793(VarCurr,2) ) ).

tff(addAssignment_74339,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,2)
    <=> v130397(VarCurr,2) ) ).

tff(addAssignment_74338,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,2)
    <=> v130399(VarCurr,2) ) ).

tff(addAssignment_74337,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,2)
    <=> v130610(VarCurr,2) ) ).

tff(addAssignment_74336,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,2)
    <=> v130601(VarCurr,2) ) ).

tff(addAssignment_74335,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,2)
    <=> v130582(VarCurr,2) ) ).

tff(addAssignment_74334,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,2)
    <=> v130563(VarCurr,2) ) ).

tff(addAssignment_74333,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,2)
    <=> v130544(VarCurr,2) ) ).

tff(addAssignment_74332,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,2)
    <=> v130525(VarCurr,2) ) ).

tff(addAssignment_74331,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,2)
    <=> v130506(VarCurr,2) ) ).

tff(addAssignment_74330,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,2)
    <=> v130487(VarCurr,2) ) ).

tff(addAssignment_74329,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,2)
    <=> v130468(VarCurr,2) ) ).

tff(addAssignment_74328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130929(VarCurr,B)
      <=> v130931(VarCurr,B) ) ) ).

tff(addAssignment_74327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130931(VarCurr,B)
      <=> v131038(VarCurr,B) ) ) ).

tff(addAssignment_74326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v131038(VarCurr,B)
      <=> v131042(VarCurr,B) ) ) ).

tff(addAssignment_74325,axiom,
    ! [VarCurr: state_type] :
      ( ( v131038(VarCurr,25)
      <=> v131041(VarCurr,14) )
      & ( v131038(VarCurr,24)
      <=> v131041(VarCurr,13) )
      & ( v131038(VarCurr,23)
      <=> v131041(VarCurr,12) )
      & ( v131038(VarCurr,22)
      <=> v131041(VarCurr,11) )
      & ( v131038(VarCurr,21)
      <=> v131041(VarCurr,10) )
      & ( v131038(VarCurr,20)
      <=> v131041(VarCurr,9) )
      & ( v131038(VarCurr,19)
      <=> v131041(VarCurr,8) )
      & ( v131038(VarCurr,18)
      <=> v131041(VarCurr,7) )
      & ( v131038(VarCurr,17)
      <=> v131041(VarCurr,6) )
      & ( v131038(VarCurr,16)
      <=> v131041(VarCurr,5) )
      & ( v131038(VarCurr,15)
      <=> v131041(VarCurr,4) )
      & ( v131038(VarCurr,14)
      <=> v131041(VarCurr,3) )
      & ( v131038(VarCurr,13)
      <=> v131041(VarCurr,2) )
      & ( v131038(VarCurr,12)
      <=> v131041(VarCurr,1) )
      & ( v131038(VarCurr,11)
      <=> v131041(VarCurr,0) ) ) ).

tff(addAssignment_74324,axiom,
    ! [VarCurr: state_type] :
      ( ( v131038(VarCurr,28)
      <=> v131040(VarCurr,2) )
      & ( v131038(VarCurr,27)
      <=> v131040(VarCurr,1) )
      & ( v131038(VarCurr,26)
      <=> v131040(VarCurr,0) ) ) ).

tff(addAssignment_74323,axiom,
    ! [VarCurr: state_type] :
      ( ( v131038(VarCurr,32)
      <=> v130933(VarCurr,3) )
      & ( v131038(VarCurr,31)
      <=> v130933(VarCurr,2) )
      & ( v131038(VarCurr,30)
      <=> v130933(VarCurr,1) )
      & ( v131038(VarCurr,29)
      <=> v130933(VarCurr,0) ) ) ).

tff(addAssignment_74322,axiom,
    ! [VarCurr: state_type] :
      ( ( v131038(VarCurr,35)
      <=> v131039(VarCurr,2) )
      & ( v131038(VarCurr,34)
      <=> v131039(VarCurr,1) )
      & ( v131038(VarCurr,33)
      <=> v131039(VarCurr,0) ) ) ).

tff(addAssignment_74321,axiom,
    ! [VarCurr: state_type] :
      ( ( v130933(VarCurr,3)
      <=> v130935(VarCurr,32) )
      & ( v130933(VarCurr,2)
      <=> v130935(VarCurr,31) )
      & ( v130933(VarCurr,1)
      <=> v130935(VarCurr,30) )
      & ( v130933(VarCurr,0)
      <=> v130935(VarCurr,29) ) ) ).

tff(addAssignment_74320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130935(VarCurr,B)
      <=> v130937(VarCurr,B) ) ) ).

tff(addAssignment_74319,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130937(VarNext,B)
      <=> v131021(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131022(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v131021(VarNext,B)
            <=> v130937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1751,axiom,
    ! [VarNext: state_type] :
      ( v131022(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131021(VarNext,B)
          <=> v131032(VarNext,B) ) ) ) ).

tff(addAssignment_74318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131032(VarNext,B)
          <=> v131030(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131030(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1317,axiom,
    ! [VarCurr: state_type] :
      ( v131033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v131030(VarCurr,B)
          <=> v130959(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16990,axiom,
    ! [VarCurr: state_type] :
      ( v131033(VarCurr)
    <=> ( v131034(VarCurr)
        & v131035(VarCurr) ) ) ).

tff(writeUnaryOperator_9498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131035(VarCurr)
    <=> v130949(VarCurr) ) ).

tff(writeUnaryOperator_9497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131034(VarCurr)
    <=> v130939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131022(VarNext)
      <=> v131023(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131023(VarNext)
      <=> ( v131024(VarNext)
          & v130964(VarNext) ) ) ) ).

tff(writeUnaryOperator_9496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v131024(VarNext)
      <=> v131026(VarNext) ) ) ).

tff(addAssignment_74317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131026(VarNext)
      <=> v130964(VarCurr) ) ) ).

tff(addAssignment_74316,axiom,
    ! [VarCurr: state_type] :
      ( v130964(VarCurr)
    <=> v130966(VarCurr) ) ).

tff(addAssignment_74315,axiom,
    ! [VarCurr: state_type] :
      ( v130966(VarCurr)
    <=> v130968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16987,axiom,
    ! [VarCurr: state_type] :
      ( v130968(VarCurr)
    <=> ( v131019(VarCurr)
        | v131015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16986,axiom,
    ! [VarCurr: state_type] :
      ( v131019(VarCurr)
    <=> ( v130970(VarCurr)
        & v130974(VarCurr) ) ) ).

tff(addAssignment_74314,axiom,
    ! [VarCurr: state_type] :
      ( v131015(VarCurr)
    <=> v131017(VarCurr) ) ).

tff(addAssignment_74313,axiom,
    ! [VarCurr: state_type] :
      ( v131017(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130999(VarNext)
       => ( v130974(VarNext)
        <=> v130974(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1750,axiom,
    ! [VarNext: state_type] :
      ( v130999(VarNext)
     => ( v130974(VarNext)
      <=> v131009(VarNext) ) ) ).

tff(addAssignment_74312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131009(VarNext)
      <=> v131007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16985,axiom,
    ! [VarCurr: state_type] :
      ( v131007(VarCurr)
    <=> ( v131010(VarCurr)
        & v131011(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16984,axiom,
    ! [VarCurr: state_type] :
      ( v131011(VarCurr)
    <=> ( v130980(VarCurr)
        | v130994(VarCurr) ) ) ).

tff(writeUnaryOperator_9495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131010(VarCurr)
    <=> v130976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130999(VarNext)
      <=> v131000(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131000(VarNext)
      <=> ( v131002(VarNext)
          & v131004(VarNext) ) ) ) ).

tff(writeUnaryOperator_9494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v131004(VarCurr)
    <=> v130970(VarCurr) ) ).

tff(addAssignment_74311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v131002(VarNext)
      <=> v130970(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_248,axiom,
    ( v130974(constB0)
  <=> $true ) ).

tff(addAssignment_74310,axiom,
    ! [VarCurr: state_type] :
      ( v130994(VarCurr)
    <=> v130996(VarCurr) ) ).

tff(addAssignment_74309,axiom,
    ! [VarCurr: state_type] :
      ( v130996(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74308,axiom,
    ! [VarCurr: state_type] :
      ( v130980(VarCurr)
    <=> v130982(VarCurr) ) ).

tff(addAssignment_74307,axiom,
    ! [VarCurr: state_type] :
      ( v130982(VarCurr)
    <=> v130984(VarCurr) ) ).

tff(addAssignment_74306,axiom,
    ! [VarCurr: state_type] :
      ( v130984(VarCurr)
    <=> v130986(VarCurr) ) ).

tff(addAssignment_74305,axiom,
    ! [VarCurr: state_type] :
      ( v130986(VarCurr)
    <=> v130988(VarCurr) ) ).

tff(addAssignment_74304,axiom,
    ! [VarCurr: state_type] :
      ( v130988(VarCurr)
    <=> v130990(VarCurr) ) ).

tff(addAssignment_74303,axiom,
    ! [VarCurr: state_type] :
      ( v130990(VarCurr)
    <=> v130992(VarCurr) ) ).

tff(addAssignment_74302,axiom,
    ! [VarCurr: state_type] :
      ( v130992(VarCurr)
    <=> v130434(VarCurr) ) ).

tff(addAssignment_74301,axiom,
    ! [VarCurr: state_type] :
      ( v130976(VarCurr)
    <=> v130978(VarCurr) ) ).

tff(addAssignment_74300,axiom,
    ! [VarCurr: state_type] :
      ( v130978(VarCurr)
    <=> $false ) ).

tff(addAssignment_74299,axiom,
    ! [VarCurr: state_type] :
      ( v130970(VarCurr)
    <=> v130972(VarCurr) ) ).

tff(addAssignment_74298,axiom,
    ! [VarCurr: state_type] :
      ( v130972(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130959(VarCurr,B)
      <=> v130961(VarCurr,B) ) ) ).

tff(addAssignment_74296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130961(VarCurr,B)
      <=> v130962(VarCurr,B) ) ) ).

tff(addAssignment_74295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130962(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74294,axiom,
    ! [VarCurr: state_type] :
      ( ( v130962(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v130962(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v130962(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v130962(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v130962(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v130962(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v130962(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v130962(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v130962(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v130962(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v130962(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v130962(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v130962(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v130962(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v130962(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74293,axiom,
    ! [VarCurr: state_type] :
      ( ( v130962(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v130962(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v130962(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74292,axiom,
    ! [VarCurr: state_type] :
      ( ( v130962(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v130962(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v130962(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v130962(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74291,axiom,
    ! [VarCurr: state_type] :
      ( ( v130962(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v130962(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v130962(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74290,axiom,
    ! [VarCurr: state_type] :
      ( v130949(VarCurr)
    <=> v130951(VarCurr) ) ).

tff(addAssignment_74289,axiom,
    ! [VarCurr: state_type] :
      ( v130951(VarCurr)
    <=> v130953(VarCurr) ) ).

tff(addAssignment_74288,axiom,
    ! [VarCurr: state_type] :
      ( v130953(VarCurr)
    <=> v130955(VarCurr) ) ).

tff(addAssignment_74287,axiom,
    ! [VarCurr: state_type] :
      ( v130955(VarCurr)
    <=> v130957(VarCurr) ) ).

tff(addAssignment_74286,axiom,
    ! [VarCurr: state_type] :
      ( v130957(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74285,axiom,
    ! [VarCurr: state_type] :
      ( v130939(VarCurr)
    <=> v130941(VarCurr) ) ).

tff(addAssignment_74284,axiom,
    ! [VarCurr: state_type] :
      ( v130941(VarCurr)
    <=> v130943(VarCurr) ) ).

tff(addAssignment_74283,axiom,
    ! [VarCurr: state_type] :
      ( v130943(VarCurr)
    <=> v130945(VarCurr) ) ).

tff(addAssignment_74282,axiom,
    ! [VarCurr: state_type] :
      ( v130945(VarCurr)
    <=> v130947(VarCurr) ) ).

tff(addAssignment_74281,axiom,
    ! [VarCurr: state_type] :
      ( v130947(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74280,axiom,
    ! [VarCurr: state_type] :
      ( v130919(VarCurr)
    <=> v130921(VarCurr) ) ).

tff(addAssignment_74279,axiom,
    ! [VarCurr: state_type] :
      ( v130921(VarCurr)
    <=> v130923(VarCurr) ) ).

tff(addAssignment_74278,axiom,
    ! [VarCurr: state_type] :
      ( v130923(VarCurr)
    <=> v130925(VarCurr) ) ).

tff(addAssignment_74277,axiom,
    ! [VarCurr: state_type] :
      ( v130925(VarCurr)
    <=> v130927(VarCurr) ) ).

tff(addAssignment_74276,axiom,
    ! [VarCurr: state_type] :
      ( v130927(VarCurr)
    <=> v130387(VarCurr,1) ) ).

tff(addAssignment_74275,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,1)
    <=> v130389(VarCurr,1) ) ).

tff(addAssignment_74274,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,1)
    <=> v130391(VarCurr,1) ) ).

tff(addAssignment_74273,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,1)
    <=> v130393(VarCurr,1) ) ).

tff(addAssignment_74272,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,1)
    <=> v130802(VarCurr,1) ) ).

tff(addAssignment_74271,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,1)
    <=> v130793(VarCurr,1) ) ).

tff(addAssignment_74270,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,1)
    <=> v130397(VarCurr,1) ) ).

tff(addAssignment_74269,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,1)
    <=> v130399(VarCurr,1) ) ).

tff(addAssignment_74268,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,1)
    <=> v130610(VarCurr,1) ) ).

tff(addAssignment_74267,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,1)
    <=> v130601(VarCurr,1) ) ).

tff(addAssignment_74266,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,1)
    <=> v130582(VarCurr,1) ) ).

tff(addAssignment_74265,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,1)
    <=> v130563(VarCurr,1) ) ).

tff(addAssignment_74264,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,1)
    <=> v130544(VarCurr,1) ) ).

tff(addAssignment_74263,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,1)
    <=> v130525(VarCurr,1) ) ).

tff(addAssignment_74262,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,1)
    <=> v130506(VarCurr,1) ) ).

tff(addAssignment_74261,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,1)
    <=> v130487(VarCurr,1) ) ).

tff(addAssignment_74260,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,1)
    <=> v130468(VarCurr,1) ) ).

tff(addAssignment_74259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130804(VarCurr,B)
      <=> v130806(VarCurr,B) ) ) ).

tff(addAssignment_74258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130806(VarCurr,B)
      <=> v130913(VarCurr,B) ) ) ).

tff(addAssignment_74257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130913(VarCurr,B)
      <=> v130917(VarCurr,B) ) ) ).

tff(addAssignment_74256,axiom,
    ! [VarCurr: state_type] :
      ( ( v130913(VarCurr,25)
      <=> v130916(VarCurr,14) )
      & ( v130913(VarCurr,24)
      <=> v130916(VarCurr,13) )
      & ( v130913(VarCurr,23)
      <=> v130916(VarCurr,12) )
      & ( v130913(VarCurr,22)
      <=> v130916(VarCurr,11) )
      & ( v130913(VarCurr,21)
      <=> v130916(VarCurr,10) )
      & ( v130913(VarCurr,20)
      <=> v130916(VarCurr,9) )
      & ( v130913(VarCurr,19)
      <=> v130916(VarCurr,8) )
      & ( v130913(VarCurr,18)
      <=> v130916(VarCurr,7) )
      & ( v130913(VarCurr,17)
      <=> v130916(VarCurr,6) )
      & ( v130913(VarCurr,16)
      <=> v130916(VarCurr,5) )
      & ( v130913(VarCurr,15)
      <=> v130916(VarCurr,4) )
      & ( v130913(VarCurr,14)
      <=> v130916(VarCurr,3) )
      & ( v130913(VarCurr,13)
      <=> v130916(VarCurr,2) )
      & ( v130913(VarCurr,12)
      <=> v130916(VarCurr,1) )
      & ( v130913(VarCurr,11)
      <=> v130916(VarCurr,0) ) ) ).

tff(addAssignment_74255,axiom,
    ! [VarCurr: state_type] :
      ( ( v130913(VarCurr,28)
      <=> v130915(VarCurr,2) )
      & ( v130913(VarCurr,27)
      <=> v130915(VarCurr,1) )
      & ( v130913(VarCurr,26)
      <=> v130915(VarCurr,0) ) ) ).

tff(addAssignment_74254,axiom,
    ! [VarCurr: state_type] :
      ( ( v130913(VarCurr,32)
      <=> v130808(VarCurr,3) )
      & ( v130913(VarCurr,31)
      <=> v130808(VarCurr,2) )
      & ( v130913(VarCurr,30)
      <=> v130808(VarCurr,1) )
      & ( v130913(VarCurr,29)
      <=> v130808(VarCurr,0) ) ) ).

tff(addAssignment_74253,axiom,
    ! [VarCurr: state_type] :
      ( ( v130913(VarCurr,35)
      <=> v130914(VarCurr,2) )
      & ( v130913(VarCurr,34)
      <=> v130914(VarCurr,1) )
      & ( v130913(VarCurr,33)
      <=> v130914(VarCurr,0) ) ) ).

tff(addAssignment_74252,axiom,
    ! [VarCurr: state_type] :
      ( ( v130808(VarCurr,3)
      <=> v130810(VarCurr,32) )
      & ( v130808(VarCurr,2)
      <=> v130810(VarCurr,31) )
      & ( v130808(VarCurr,1)
      <=> v130810(VarCurr,30) )
      & ( v130808(VarCurr,0)
      <=> v130810(VarCurr,29) ) ) ).

tff(addAssignment_74251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130810(VarCurr,B)
      <=> v130812(VarCurr,B) ) ) ).

tff(addAssignment_74250,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130812(VarNext,B)
      <=> v130896(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130897(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v130896(VarNext,B)
            <=> v130812(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1749,axiom,
    ! [VarNext: state_type] :
      ( v130897(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130896(VarNext,B)
          <=> v130907(VarNext,B) ) ) ) ).

tff(addAssignment_74249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130907(VarNext,B)
          <=> v130905(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130908(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130905(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1316,axiom,
    ! [VarCurr: state_type] :
      ( v130908(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130905(VarCurr,B)
          <=> v130834(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16981,axiom,
    ! [VarCurr: state_type] :
      ( v130908(VarCurr)
    <=> ( v130909(VarCurr)
        & v130910(VarCurr) ) ) ).

tff(writeUnaryOperator_9493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130910(VarCurr)
    <=> v130824(VarCurr) ) ).

tff(writeUnaryOperator_9492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130909(VarCurr)
    <=> v130814(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130897(VarNext)
      <=> v130898(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130898(VarNext)
      <=> ( v130899(VarNext)
          & v130839(VarNext) ) ) ) ).

tff(writeUnaryOperator_9491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130899(VarNext)
      <=> v130901(VarNext) ) ) ).

tff(addAssignment_74248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130901(VarNext)
      <=> v130839(VarCurr) ) ) ).

tff(addAssignment_74247,axiom,
    ! [VarCurr: state_type] :
      ( v130839(VarCurr)
    <=> v130841(VarCurr) ) ).

tff(addAssignment_74246,axiom,
    ! [VarCurr: state_type] :
      ( v130841(VarCurr)
    <=> v130843(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16978,axiom,
    ! [VarCurr: state_type] :
      ( v130843(VarCurr)
    <=> ( v130894(VarCurr)
        | v130890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16977,axiom,
    ! [VarCurr: state_type] :
      ( v130894(VarCurr)
    <=> ( v130845(VarCurr)
        & v130849(VarCurr) ) ) ).

tff(addAssignment_74245,axiom,
    ! [VarCurr: state_type] :
      ( v130890(VarCurr)
    <=> v130892(VarCurr) ) ).

tff(addAssignment_74244,axiom,
    ! [VarCurr: state_type] :
      ( v130892(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130874(VarNext)
       => ( v130849(VarNext)
        <=> v130849(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1748,axiom,
    ! [VarNext: state_type] :
      ( v130874(VarNext)
     => ( v130849(VarNext)
      <=> v130884(VarNext) ) ) ).

tff(addAssignment_74243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130884(VarNext)
      <=> v130882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16976,axiom,
    ! [VarCurr: state_type] :
      ( v130882(VarCurr)
    <=> ( v130885(VarCurr)
        & v130886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16975,axiom,
    ! [VarCurr: state_type] :
      ( v130886(VarCurr)
    <=> ( v130855(VarCurr)
        | v130869(VarCurr) ) ) ).

tff(writeUnaryOperator_9490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130885(VarCurr)
    <=> v130851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130874(VarNext)
      <=> v130875(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130875(VarNext)
      <=> ( v130877(VarNext)
          & v130879(VarNext) ) ) ) ).

tff(writeUnaryOperator_9489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130879(VarCurr)
    <=> v130845(VarCurr) ) ).

tff(addAssignment_74242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130877(VarNext)
      <=> v130845(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_247,axiom,
    ( v130849(constB0)
  <=> $true ) ).

tff(addAssignment_74241,axiom,
    ! [VarCurr: state_type] :
      ( v130869(VarCurr)
    <=> v130871(VarCurr) ) ).

tff(addAssignment_74240,axiom,
    ! [VarCurr: state_type] :
      ( v130871(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_74239,axiom,
    ! [VarCurr: state_type] :
      ( v130855(VarCurr)
    <=> v130857(VarCurr) ) ).

tff(addAssignment_74238,axiom,
    ! [VarCurr: state_type] :
      ( v130857(VarCurr)
    <=> v130859(VarCurr) ) ).

tff(addAssignment_74237,axiom,
    ! [VarCurr: state_type] :
      ( v130859(VarCurr)
    <=> v130861(VarCurr) ) ).

tff(addAssignment_74236,axiom,
    ! [VarCurr: state_type] :
      ( v130861(VarCurr)
    <=> v130863(VarCurr) ) ).

tff(addAssignment_74235,axiom,
    ! [VarCurr: state_type] :
      ( v130863(VarCurr)
    <=> v130865(VarCurr) ) ).

tff(addAssignment_74234,axiom,
    ! [VarCurr: state_type] :
      ( v130865(VarCurr)
    <=> v130867(VarCurr) ) ).

tff(addAssignment_74233,axiom,
    ! [VarCurr: state_type] :
      ( v130867(VarCurr)
    <=> v130446(VarCurr) ) ).

tff(addAssignment_74232,axiom,
    ! [VarCurr: state_type] :
      ( v130851(VarCurr)
    <=> v130853(VarCurr) ) ).

tff(addAssignment_74231,axiom,
    ! [VarCurr: state_type] :
      ( v130853(VarCurr)
    <=> $false ) ).

tff(addAssignment_74230,axiom,
    ! [VarCurr: state_type] :
      ( v130845(VarCurr)
    <=> v130847(VarCurr) ) ).

tff(addAssignment_74229,axiom,
    ! [VarCurr: state_type] :
      ( v130847(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_74228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130834(VarCurr,B)
      <=> v130836(VarCurr,B) ) ) ).

tff(addAssignment_74227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130836(VarCurr,B)
      <=> v130837(VarCurr,B) ) ) ).

tff(addAssignment_74226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130837(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_74225,axiom,
    ! [VarCurr: state_type] :
      ( ( v130837(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v130837(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v130837(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v130837(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v130837(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v130837(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v130837(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v130837(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v130837(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v130837(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v130837(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v130837(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v130837(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v130837(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v130837(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_74224,axiom,
    ! [VarCurr: state_type] :
      ( ( v130837(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v130837(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v130837(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_74223,axiom,
    ! [VarCurr: state_type] :
      ( ( v130837(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v130837(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v130837(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v130837(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_74222,axiom,
    ! [VarCurr: state_type] :
      ( ( v130837(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v130837(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v130837(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_74221,axiom,
    ! [VarCurr: state_type] :
      ( v130824(VarCurr)
    <=> v130826(VarCurr) ) ).

tff(addAssignment_74220,axiom,
    ! [VarCurr: state_type] :
      ( v130826(VarCurr)
    <=> v130828(VarCurr) ) ).

tff(addAssignment_74219,axiom,
    ! [VarCurr: state_type] :
      ( v130828(VarCurr)
    <=> v130830(VarCurr) ) ).

tff(addAssignment_74218,axiom,
    ! [VarCurr: state_type] :
      ( v130830(VarCurr)
    <=> v130832(VarCurr) ) ).

tff(addAssignment_74217,axiom,
    ! [VarCurr: state_type] :
      ( v130832(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_74216,axiom,
    ! [VarCurr: state_type] :
      ( v130814(VarCurr)
    <=> v130816(VarCurr) ) ).

tff(addAssignment_74215,axiom,
    ! [VarCurr: state_type] :
      ( v130816(VarCurr)
    <=> v130818(VarCurr) ) ).

tff(addAssignment_74214,axiom,
    ! [VarCurr: state_type] :
      ( v130818(VarCurr)
    <=> v130820(VarCurr) ) ).

tff(addAssignment_74213,axiom,
    ! [VarCurr: state_type] :
      ( v130820(VarCurr)
    <=> v130822(VarCurr) ) ).

tff(addAssignment_74212,axiom,
    ! [VarCurr: state_type] :
      ( v130822(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_74211,axiom,
    ! [VarCurr: state_type] :
      ( v130377(VarCurr)
    <=> v130379(VarCurr) ) ).

tff(addAssignment_74210,axiom,
    ! [VarCurr: state_type] :
      ( v130379(VarCurr)
    <=> v130381(VarCurr) ) ).

tff(addAssignment_74209,axiom,
    ! [VarCurr: state_type] :
      ( v130381(VarCurr)
    <=> v130383(VarCurr) ) ).

tff(addAssignment_74208,axiom,
    ! [VarCurr: state_type] :
      ( v130383(VarCurr)
    <=> v130385(VarCurr) ) ).

tff(addAssignment_74207,axiom,
    ! [VarCurr: state_type] :
      ( v130385(VarCurr)
    <=> v130387(VarCurr,0) ) ).

tff(addAssignment_74206,axiom,
    ! [VarCurr: state_type] :
      ( v130387(VarCurr,0)
    <=> v130389(VarCurr,0) ) ).

tff(addAssignment_74205,axiom,
    ! [VarCurr: state_type] :
      ( v130389(VarCurr,0)
    <=> v130391(VarCurr,0) ) ).

tff(addAssignment_74204,axiom,
    ! [VarCurr: state_type] :
      ( v130391(VarCurr,0)
    <=> v130393(VarCurr,0) ) ).

tff(addAssignment_74203,axiom,
    ! [VarCurr: state_type] :
      ( v130393(VarCurr,0)
    <=> v130802(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130802(VarCurr,B)
          <=> v130646(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1315,axiom,
    ! [VarCurr: state_type] :
      ( v8(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130802(VarCurr,B)
          <=> v130395(VarCurr,B) ) ) ) ).

tff(addAssignment_74202,axiom,
    ! [VarCurr: state_type] :
      ( v130646(VarCurr,0)
    <=> v130793(VarCurr,0) ) ).

tff(addAssignment_74201,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,0)
    <=> v130801(VarCurr) ) ).

tff(addAssignment_74200,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,1)
    <=> v130800(VarCurr) ) ).

tff(addAssignment_74199,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,2)
    <=> v130799(VarCurr) ) ).

tff(addAssignment_74198,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,3)
    <=> v130798(VarCurr) ) ).

tff(addAssignment_74197,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,4)
    <=> v130797(VarCurr) ) ).

tff(addAssignment_74196,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,5)
    <=> v130796(VarCurr) ) ).

tff(addAssignment_74195,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,6)
    <=> v130795(VarCurr) ) ).

tff(addAssignment_74194,axiom,
    ! [VarCurr: state_type] :
      ( v130793(VarCurr,7)
    <=> v130794(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1714,axiom,
    ! [VarCurr: state_type] :
      ( v130801(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1713,axiom,
    ! [VarCurr: state_type] :
      ( v130800(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1712,axiom,
    ! [VarCurr: state_type] :
      ( v130799(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1711,axiom,
    ! [VarCurr: state_type] :
      ( v130798(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $false )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1710,axiom,
    ! [VarCurr: state_type] :
      ( v130797(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1709,axiom,
    ! [VarCurr: state_type] :
      ( v130796(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $false )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1708,axiom,
    ! [VarCurr: state_type] :
      ( v130795(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1707,axiom,
    ! [VarCurr: state_type] :
      ( v130794(VarCurr)
    <=> ( ( v82985(VarCurr,2)
        <=> $true )
        & ( v82985(VarCurr,1)
        <=> $true )
        & ( v82985(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_74193,axiom,
    ! [VarCurr: state_type] :
      ( ( v82985(VarCurr,2)
      <=> v781(VarCurr,4) )
      & ( v82985(VarCurr,1)
      <=> v781(VarCurr,3) )
      & ( v82985(VarCurr,0)
      <=> v781(VarCurr,2) ) ) ).

tff(addAssignment_74192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v781(VarCurr,B)
      <=> v783(VarCurr,B) ) ) ).

tff(addAssignment_74191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v783(VarCurr,B)
      <=> v5329(VarCurr,B) ) ) ).

tff(addAssignment_74190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5324(VarCurr,B)
      <=> v5326(VarCurr,B) ) ) ).

tff(addAssignment_74189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5326(VarCurr,B)
      <=> v5328(VarCurr,B) ) ) ).

tff(addAssignment_74188,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5328(VarNext,B)
      <=> v130786(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130787(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130786(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1747,axiom,
    ! [VarNext: state_type] :
      ( v130787(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130786(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130787(VarNext)
      <=> v130788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130788(VarNext)
      <=> ( v130790(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_9488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130790(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_74187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v103020(VarCurr,B)
      <=> v103022(VarCurr,B) ) ) ).

tff(addAssignment_74186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v103022(VarCurr,B)
      <=> v103031(VarCurr,B) ) ) ).

tff(addAssignment_74185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v103024(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5318(VarCurr,B)
      <=> v5320(VarCurr,B) ) ) ).

tff(addAssignment_74183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5320(VarCurr,B)
      <=> v5322(VarCurr,B) ) ) ).

tff(addAssignment_74182,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5322(VarNext,B)
      <=> v130778(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130779(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130778(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1746,axiom,
    ! [VarNext: state_type] :
      ( v130779(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130778(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130779(VarNext)
      <=> v130780(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130780(VarNext)
      <=> ( v130782(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_9487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130782(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_74181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102970(VarCurr,B)
      <=> v102972(VarCurr,B) ) ) ).

tff(addAssignment_74180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102972(VarCurr,B)
      <=> v102981(VarCurr,B) ) ) ).

tff(addAssignment_74179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102974(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5311(VarCurr,B)
      <=> v5313(VarCurr,B) ) ) ).

tff(addAssignment_74177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5313(VarCurr,B)
      <=> v5315(VarCurr,B) ) ) ).

tff(addAssignment_74176,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5315(VarNext,B)
      <=> v130770(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130771(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130770(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1745,axiom,
    ! [VarNext: state_type] :
      ( v130771(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130770(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130771(VarNext)
      <=> v130772(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130772(VarNext)
      <=> ( v130774(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_9486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130774(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_74175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102920(VarCurr,B)
      <=> v102922(VarCurr,B) ) ) ).

tff(addAssignment_74174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102922(VarCurr,B)
      <=> v102931(VarCurr,B) ) ) ).

tff(addAssignment_74173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102924(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5304(VarCurr,B)
      <=> v5306(VarCurr,B) ) ) ).

tff(addAssignment_74171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5306(VarCurr,B)
      <=> v5308(VarCurr,B) ) ) ).

tff(addAssignment_74170,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5308(VarNext,B)
      <=> v130762(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1744,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130763(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130762(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1744,axiom,
    ! [VarNext: state_type] :
      ( v130763(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130762(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130763(VarNext)
      <=> v130764(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130764(VarNext)
      <=> ( v130766(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_9485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130766(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_74169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102870(VarCurr,B)
      <=> v102872(VarCurr,B) ) ) ).

tff(addAssignment_74168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102872(VarCurr,B)
      <=> v102881(VarCurr,B) ) ) ).

tff(addAssignment_74167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102874(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5297(VarCurr,B)
      <=> v5299(VarCurr,B) ) ) ).

tff(addAssignment_74165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5299(VarCurr,B)
      <=> v5301(VarCurr,B) ) ) ).

tff(addAssignment_74164,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5301(VarNext,B)
      <=> v130754(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1743,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130755(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130754(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1743,axiom,
    ! [VarNext: state_type] :
      ( v130755(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130754(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130755(VarNext)
      <=> v130756(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130756(VarNext)
      <=> ( v130758(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_9484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130758(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_74163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102820(VarCurr,B)
      <=> v102822(VarCurr,B) ) ) ).

tff(addAssignment_74162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102822(VarCurr,B)
      <=> v102831(VarCurr,B) ) ) ).

tff(addAssignment_74161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102824(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5290(VarCurr,B)
      <=> v5292(VarCurr,B) ) ) ).

tff(addAssignment_74159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5292(VarCurr,B)
      <=> v5294(VarCurr,B) ) ) ).

tff(addAssignment_74158,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5294(VarNext,B)
      <=> v130746(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130747(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130746(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1742,axiom,
    ! [VarNext: state_type] :
      ( v130747(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130746(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130747(VarNext)
      <=> v130748(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130748(VarNext)
      <=> ( v130750(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_9483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130750(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_74157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102770(VarCurr,B)
      <=> v102772(VarCurr,B) ) ) ).

tff(addAssignment_74156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102772(VarCurr,B)
      <=> v102781(VarCurr,B) ) ) ).

tff(addAssignment_74155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102774(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5283(VarCurr,B)
      <=> v5285(VarCurr,B) ) ) ).

tff(addAssignment_74153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5285(VarCurr,B)
      <=> v5287(VarCurr,B) ) ) ).

tff(addAssignment_74152,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5287(VarNext,B)
      <=> v130738(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130739(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130738(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1741,axiom,
    ! [VarNext: state_type] :
      ( v130739(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130738(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130739(VarNext)
      <=> v130740(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130740(VarNext)
      <=> ( v130742(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_9482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130742(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_74151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102720(VarCurr,B)
      <=> v102722(VarCurr,B) ) ) ).

tff(addAssignment_74150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102722(VarCurr,B)
      <=> v102731(VarCurr,B) ) ) ).

tff(addAssignment_74149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102724(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5276(VarCurr,B)
      <=> v5278(VarCurr,B) ) ) ).

tff(addAssignment_74147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5278(VarCurr,B)
      <=> v5280(VarCurr,B) ) ) ).

tff(addAssignment_74146,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5280(VarNext,B)
      <=> v130730(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130731(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130730(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1740,axiom,
    ! [VarNext: state_type] :
      ( v130731(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130730(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130731(VarNext)
      <=> v130732(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130732(VarNext)
      <=> ( v130734(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_9481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130734(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_74145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102670(VarCurr,B)
      <=> v102672(VarCurr,B) ) ) ).

tff(addAssignment_74144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102672(VarCurr,B)
      <=> v102681(VarCurr,B) ) ) ).

tff(addAssignment_74143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102674(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5269(VarCurr,B)
      <=> v5271(VarCurr,B) ) ) ).

tff(addAssignment_74141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5271(VarCurr,B)
      <=> v5273(VarCurr,B) ) ) ).

tff(addAssignment_74140,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5273(VarNext,B)
      <=> v130722(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130723(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130722(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1739,axiom,
    ! [VarNext: state_type] :
      ( v130723(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130722(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130723(VarNext)
      <=> v130724(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130724(VarNext)
      <=> ( v130726(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_9480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130726(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_74139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102620(VarCurr,B)
      <=> v102622(VarCurr,B) ) ) ).

tff(addAssignment_74138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102622(VarCurr,B)
      <=> v102631(VarCurr,B) ) ) ).

tff(addAssignment_74137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102624(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5262(VarCurr,B)
      <=> v5264(VarCurr,B) ) ) ).

tff(addAssignment_74135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5264(VarCurr,B)
      <=> v5266(VarCurr,B) ) ) ).

tff(addAssignment_74134,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5266(VarNext,B)
      <=> v130714(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130715(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130714(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1738,axiom,
    ! [VarNext: state_type] :
      ( v130715(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130714(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130715(VarNext)
      <=> v130716(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130716(VarNext)
      <=> ( v130718(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_9479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130718(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_74133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102570(VarCurr,B)
      <=> v102572(VarCurr,B) ) ) ).

tff(addAssignment_74132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102572(VarCurr,B)
      <=> v102581(VarCurr,B) ) ) ).

tff(addAssignment_74131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102574(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5255(VarCurr,B)
      <=> v5257(VarCurr,B) ) ) ).

tff(addAssignment_74129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5257(VarCurr,B)
      <=> v5259(VarCurr,B) ) ) ).

tff(addAssignment_74128,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5259(VarNext,B)
      <=> v130706(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130707(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130706(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1737,axiom,
    ! [VarNext: state_type] :
      ( v130707(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130706(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130707(VarNext)
      <=> v130708(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130708(VarNext)
      <=> ( v130710(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_9478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130710(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_74127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102520(VarCurr,B)
      <=> v102522(VarCurr,B) ) ) ).

tff(addAssignment_74126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102522(VarCurr,B)
      <=> v102531(VarCurr,B) ) ) ).

tff(addAssignment_74125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102524(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5248(VarCurr,B)
      <=> v5250(VarCurr,B) ) ) ).

tff(addAssignment_74123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5250(VarCurr,B)
      <=> v5252(VarCurr,B) ) ) ).

tff(addAssignment_74122,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5252(VarNext,B)
      <=> v130698(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1736,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130699(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130698(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1736,axiom,
    ! [VarNext: state_type] :
      ( v130699(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130698(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130699(VarNext)
      <=> v130700(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130700(VarNext)
      <=> ( v130702(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_9477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130702(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_74121,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102470(VarCurr,B)
      <=> v102472(VarCurr,B) ) ) ).

tff(addAssignment_74120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102472(VarCurr,B)
      <=> v102481(VarCurr,B) ) ) ).

tff(addAssignment_74119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102474(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5241(VarCurr,B)
      <=> v5243(VarCurr,B) ) ) ).

tff(addAssignment_74117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5243(VarCurr,B)
      <=> v5245(VarCurr,B) ) ) ).

tff(addAssignment_74116,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5245(VarNext,B)
      <=> v130690(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130691(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130690(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1735,axiom,
    ! [VarNext: state_type] :
      ( v130691(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130690(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130691(VarNext)
      <=> v130692(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130692(VarNext)
      <=> ( v130694(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_9476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130694(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_74115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102420(VarCurr,B)
      <=> v102422(VarCurr,B) ) ) ).

tff(addAssignment_74114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102422(VarCurr,B)
      <=> v102431(VarCurr,B) ) ) ).

tff(addAssignment_74113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102424(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5234(VarCurr,B)
      <=> v5236(VarCurr,B) ) ) ).

tff(addAssignment_74111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5236(VarCurr,B)
      <=> v5238(VarCurr,B) ) ) ).

tff(addAssignment_74110,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5238(VarNext,B)
      <=> v130682(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130683(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130682(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1734,axiom,
    ! [VarNext: state_type] :
      ( v130683(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130682(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130683(VarNext)
      <=> v130684(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130684(VarNext)
      <=> ( v130686(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_9475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130686(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_74109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102370(VarCurr,B)
      <=> v102372(VarCurr,B) ) ) ).

tff(addAssignment_74108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102372(VarCurr,B)
      <=> v102381(VarCurr,B) ) ) ).

tff(addAssignment_74107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102374(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5227(VarCurr,B)
      <=> v5229(VarCurr,B) ) ) ).

tff(addAssignment_74105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5229(VarCurr,B)
      <=> v5231(VarCurr,B) ) ) ).

tff(addAssignment_74104,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5231(VarNext,B)
      <=> v130674(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130675(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130674(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1733,axiom,
    ! [VarNext: state_type] :
      ( v130675(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130674(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130675(VarNext)
      <=> v130676(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130676(VarNext)
      <=> ( v130678(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_9474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130678(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_74103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102320(VarCurr,B)
      <=> v102322(VarCurr,B) ) ) ).

tff(addAssignment_74102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102322(VarCurr,B)
      <=> v102331(VarCurr,B) ) ) ).

tff(addAssignment_74101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102324(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5220(VarCurr,B)
      <=> v5222(VarCurr,B) ) ) ).

tff(addAssignment_74099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5222(VarCurr,B)
      <=> v5224(VarCurr,B) ) ) ).

tff(addAssignment_74098,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v5224(VarNext,B)
      <=> v130666(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130667(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130666(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1732,axiom,
    ! [VarNext: state_type] :
      ( v130667(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130666(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130667(VarNext)
      <=> v130668(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130668(VarNext)
      <=> ( v130670(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_9473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130670(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_74097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102270(VarCurr,B)
      <=> v102272(VarCurr,B) ) ) ).

tff(addAssignment_74096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102272(VarCurr,B)
      <=> v102281(VarCurr,B) ) ) ).

tff(addAssignment_74095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v102274(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v884(VarCurr,B)
      <=> v886(VarCurr,B) ) ) ).

tff(addAssignment_74093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v886(VarCurr,B)
      <=> v888(VarCurr,B) ) ) ).

tff(addAssignment_74092,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v888(VarNext,B)
      <=> v130658(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130659(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v130658(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1731,axiom,
    ! [VarNext: state_type] :
      ( v130659(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v130658(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130659(VarNext)
      <=> v130660(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130660(VarNext)
      <=> ( v130662(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130662(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_74091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v898(VarCurr,B)
      <=> v900(VarCurr,B) ) ) ).

tff(addAssignment_74090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v900(VarCurr,B)
      <=> v102231(VarCurr,B) ) ) ).

tff(addAssignment_74089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v902(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_74088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v904(VarCurr,B)
      <=> v906(VarCurr,B) ) ) ).

tff(addAssignment_74087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v906(VarCurr,B)
      <=> v908(VarCurr,B) ) ) ).

tff(addAssignment_74086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v908(VarCurr,B)
      <=> v910(VarCurr,B) ) ) ).

tff(addAssignment_74085,axiom,
    ! [VarCurr: state_type] :
      ( ( v910(VarCurr,4)
      <=> v912(VarCurr,3) )
      & ( v910(VarCurr,3)
      <=> v912(VarCurr,2) )
      & ( v910(VarCurr,2)
      <=> v912(VarCurr,1) ) ) ).

tff(addAssignment_74084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v912(VarCurr,B)
      <=> v914(VarCurr,B) ) ) ).

tff(addAssignment_74083,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v914(VarNext,B)
      <=> v130650(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130651(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v130650(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1730,axiom,
    ! [VarNext: state_type] :
      ( v130651(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v130650(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130651(VarNext)
      <=> v130652(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130652(VarNext)
      <=> ( v130654(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_9471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130654(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_74082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v932(VarCurr,B)
      <=> v934(VarCurr,B) ) ) ).

tff(addAssignment_74081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v934(VarCurr,B)
      <=> v5598(VarCurr,B) ) ) ).

tff(addAssignment_74080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v936(VarCurr,B)
      <=> v938(VarCurr,B) ) ) ).

tff(addAssignment_74079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v938(VarCurr,B)
      <=> v5589(VarCurr,B) ) ) ).

tff(addAssignment_74078,axiom,
    ! [VarCurr: state_type] :
      ( ( v5594(VarCurr,2)
      <=> v964(VarCurr,7) )
      & ( v5594(VarCurr,1)
      <=> v964(VarCurr,6) )
      & ( v5594(VarCurr,0)
      <=> v964(VarCurr,5) ) ) ).

tff(addAssignment_74077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v964(VarCurr,B)
      <=> v966(VarCurr,B) ) ) ).

tff(addAssignment_74076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v966(VarCurr,B)
      <=> v5526(VarCurr,B) ) ) ).

tff(addAssignment_74075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5521(VarCurr,B)
      <=> v5523(VarCurr,B) ) ) ).

tff(addAssignment_74074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5523(VarCurr,B)
      <=> v5525(VarCurr,B) ) ) ).

tff(addAssignment_74073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5514(VarCurr,B)
      <=> v5516(VarCurr,B) ) ) ).

tff(addAssignment_74072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5516(VarCurr,B)
      <=> v5518(VarCurr,B) ) ) ).

tff(addAssignment_74071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5507(VarCurr,B)
      <=> v5509(VarCurr,B) ) ) ).

tff(addAssignment_74070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5509(VarCurr,B)
      <=> v5511(VarCurr,B) ) ) ).

tff(addAssignment_74069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5500(VarCurr,B)
      <=> v5502(VarCurr,B) ) ) ).

tff(addAssignment_74068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5502(VarCurr,B)
      <=> v5504(VarCurr,B) ) ) ).

tff(addAssignment_74067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5493(VarCurr,B)
      <=> v5495(VarCurr,B) ) ) ).

tff(addAssignment_74066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5495(VarCurr,B)
      <=> v5497(VarCurr,B) ) ) ).

tff(addAssignment_74065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5487(VarCurr,B)
      <=> v5489(VarCurr,B) ) ) ).

tff(addAssignment_74064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5489(VarCurr,B)
      <=> v5491(VarCurr,B) ) ) ).

tff(addAssignment_74063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5480(VarCurr,B)
      <=> v5482(VarCurr,B) ) ) ).

tff(addAssignment_74062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5482(VarCurr,B)
      <=> v5484(VarCurr,B) ) ) ).

tff(addAssignment_74061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5473(VarCurr,B)
      <=> v5475(VarCurr,B) ) ) ).

tff(addAssignment_74060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5475(VarCurr,B)
      <=> v5477(VarCurr,B) ) ) ).

tff(addAssignment_74059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5466(VarCurr,B)
      <=> v5468(VarCurr,B) ) ) ).

tff(addAssignment_74058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5468(VarCurr,B)
      <=> v5470(VarCurr,B) ) ) ).

tff(addAssignment_74057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5459(VarCurr,B)
      <=> v5461(VarCurr,B) ) ) ).

tff(addAssignment_74056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5461(VarCurr,B)
      <=> v5463(VarCurr,B) ) ) ).

tff(addAssignment_74055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5452(VarCurr,B)
      <=> v5454(VarCurr,B) ) ) ).

tff(addAssignment_74054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5454(VarCurr,B)
      <=> v5456(VarCurr,B) ) ) ).

tff(addAssignment_74053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5445(VarCurr,B)
      <=> v5447(VarCurr,B) ) ) ).

tff(addAssignment_74052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5447(VarCurr,B)
      <=> v5449(VarCurr,B) ) ) ).

tff(addAssignment_74051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5438(VarCurr,B)
      <=> v5440(VarCurr,B) ) ) ).

tff(addAssignment_74050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5440(VarCurr,B)
      <=> v5442(VarCurr,B) ) ) ).

tff(addAssignment_74049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5431(VarCurr,B)
      <=> v5433(VarCurr,B) ) ) ).

tff(addAssignment_74048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5433(VarCurr,B)
      <=> v5435(VarCurr,B) ) ) ).

tff(addAssignment_74047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5424(VarCurr,B)
      <=> v5426(VarCurr,B) ) ) ).

tff(addAssignment_74046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5426(VarCurr,B)
      <=> v5428(VarCurr,B) ) ) ).

tff(addAssignment_74045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5418(VarCurr,B)
      <=> v5420(VarCurr,B) ) ) ).

tff(addAssignment_74044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v5420(VarCurr,B)
      <=> v5422(VarCurr,B) ) ) ).

tff(addAssignment_74043,axiom,
    ! [VarCurr: state_type] :
      ( v130395(VarCurr,0)
    <=> v130397(VarCurr,0) ) ).

tff(addAssignment_74042,axiom,
    ! [VarCurr: state_type] :
      ( v130397(VarCurr,0)
    <=> v130399(VarCurr,0) ) ).

tff(addAssignment_74041,axiom,
    ! [VarCurr: state_type] :
      ( v130399(VarCurr,0)
    <=> v130610(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130610(VarCurr,B)
      <=> ( v130611(VarCurr,B)
          | v130642(VarCurr,B) ) ) ) ).

tff(addAssignment_74040,axiom,
    ! [VarCurr: state_type] :
      ( v130642(VarCurr,0)
    <=> v130643(VarCurr) ) ).

tff(addAssignment_74039,axiom,
    ! [VarCurr: state_type] :
      ( ( v130642(VarCurr,7)
      <=> $false )
      & ( v130642(VarCurr,6)
      <=> $false )
      & ( v130642(VarCurr,5)
      <=> $false )
      & ( v130642(VarCurr,4)
      <=> $false )
      & ( v130642(VarCurr,3)
      <=> $false )
      & ( v130642(VarCurr,2)
      <=> $false )
      & ( v130642(VarCurr,1)
      <=> $false ) ) ).

tff(writeUnaryOperator_9470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130643(VarCurr)
    <=> v130644(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5944,axiom,
    ! [VarCurr: state_type] :
      ( v130644(VarCurr)
    <=> ( v113051(VarCurr)
        | v89249(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130611(VarCurr,B)
      <=> ( v130612(VarCurr,B)
          | v130639(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130639(VarCurr,B)
      <=> ( v130640(VarCurr,B)
          & v130592(VarCurr,B) ) ) ) ).

tff(addAssignment_74038,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,0)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74037,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,1)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74036,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,2)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74035,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,3)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74034,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,4)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74033,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,5)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74032,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,6)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74031,axiom,
    ! [VarCurr: state_type] :
      ( v130640(VarCurr,7)
    <=> v130641(VarCurr) ) ).

tff(addAssignment_74030,axiom,
    ! [VarCurr: state_type] :
      ( v130641(VarCurr)
    <=> v89249(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130612(VarCurr,B)
      <=> ( v130613(VarCurr,B)
          | v130636(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130636(VarCurr,B)
      <=> ( v130637(VarCurr,B)
          & v130573(VarCurr,B) ) ) ) ).

tff(addAssignment_74029,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,0)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74028,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,1)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74027,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,2)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74026,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,3)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74025,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,4)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74024,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,5)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74023,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,6)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74022,axiom,
    ! [VarCurr: state_type] :
      ( v130637(VarCurr,7)
    <=> v130638(VarCurr) ) ).

tff(addAssignment_74021,axiom,
    ! [VarCurr: state_type] :
      ( v130638(VarCurr)
    <=> v89249(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130613(VarCurr,B)
      <=> ( v130614(VarCurr,B)
          | v130633(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130633(VarCurr,B)
      <=> ( v130634(VarCurr,B)
          & v130554(VarCurr,B) ) ) ) ).

tff(addAssignment_74020,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,0)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74019,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,1)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74018,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,2)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74017,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,3)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74016,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,4)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74015,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,5)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74014,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,6)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74013,axiom,
    ! [VarCurr: state_type] :
      ( v130634(VarCurr,7)
    <=> v130635(VarCurr) ) ).

tff(addAssignment_74012,axiom,
    ! [VarCurr: state_type] :
      ( v130635(VarCurr)
    <=> v89249(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130614(VarCurr,B)
      <=> ( v130615(VarCurr,B)
          | v130630(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130630(VarCurr,B)
      <=> ( v130631(VarCurr,B)
          & v130535(VarCurr,B) ) ) ) ).

tff(addAssignment_74011,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,0)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74010,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,1)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74009,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,2)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74008,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,3)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74007,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,4)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74006,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,5)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74005,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,6)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74004,axiom,
    ! [VarCurr: state_type] :
      ( v130631(VarCurr,7)
    <=> v130632(VarCurr) ) ).

tff(addAssignment_74003,axiom,
    ! [VarCurr: state_type] :
      ( v130632(VarCurr)
    <=> v89249(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130615(VarCurr,B)
      <=> ( v130616(VarCurr,B)
          | v130627(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130627(VarCurr,B)
      <=> ( v130628(VarCurr,B)
          & v130516(VarCurr,B) ) ) ) ).

tff(addAssignment_74002,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,0)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_74001,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,1)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_74000,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,2)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73999,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,3)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73998,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,4)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73997,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,5)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73996,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,6)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73995,axiom,
    ! [VarCurr: state_type] :
      ( v130628(VarCurr,7)
    <=> v130629(VarCurr) ) ).

tff(addAssignment_73994,axiom,
    ! [VarCurr: state_type] :
      ( v130629(VarCurr)
    <=> v89249(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130616(VarCurr,B)
      <=> ( v130617(VarCurr,B)
          | v130624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130624(VarCurr,B)
      <=> ( v130625(VarCurr,B)
          & v130497(VarCurr,B) ) ) ) ).

tff(addAssignment_73993,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,0)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73992,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,1)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73991,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,2)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73990,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,3)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73989,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,4)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73988,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,5)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73987,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,6)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73986,axiom,
    ! [VarCurr: state_type] :
      ( v130625(VarCurr,7)
    <=> v130626(VarCurr) ) ).

tff(addAssignment_73985,axiom,
    ! [VarCurr: state_type] :
      ( v130626(VarCurr)
    <=> v89249(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130617(VarCurr,B)
      <=> ( v130618(VarCurr,B)
          | v130621(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130621(VarCurr,B)
      <=> ( v130622(VarCurr,B)
          & v130478(VarCurr,B) ) ) ) ).

tff(addAssignment_73984,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,0)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73983,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,1)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73982,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,2)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73981,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,3)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73980,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,4)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73979,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,5)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73978,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,6)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73977,axiom,
    ! [VarCurr: state_type] :
      ( v130622(VarCurr,7)
    <=> v130623(VarCurr) ) ).

tff(addAssignment_73976,axiom,
    ! [VarCurr: state_type] :
      ( v130623(VarCurr)
    <=> v89249(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130618(VarCurr,B)
      <=> ( v130619(VarCurr,B)
          & v130401(VarCurr,B) ) ) ) ).

tff(addAssignment_73975,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,0)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73974,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,1)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73973,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,2)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73972,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,3)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73971,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,4)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73970,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,5)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73969,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,6)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73968,axiom,
    ! [VarCurr: state_type] :
      ( v130619(VarCurr,7)
    <=> v130620(VarCurr) ) ).

tff(addAssignment_73967,axiom,
    ! [VarCurr: state_type] :
      ( v130620(VarCurr)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_73966,axiom,
    ! [VarCurr: state_type] :
      ( v130592(VarCurr,0)
    <=> v130601(VarCurr,0) ) ).

tff(addAssignment_73965,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,0)
    <=> v130609(VarCurr) ) ).

tff(addAssignment_73964,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,1)
    <=> v130608(VarCurr) ) ).

tff(addAssignment_73963,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,2)
    <=> v130607(VarCurr) ) ).

tff(addAssignment_73962,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,3)
    <=> v130606(VarCurr) ) ).

tff(addAssignment_73961,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,4)
    <=> v130605(VarCurr) ) ).

tff(addAssignment_73960,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,5)
    <=> v130604(VarCurr) ) ).

tff(addAssignment_73959,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,6)
    <=> v130603(VarCurr) ) ).

tff(addAssignment_73958,axiom,
    ! [VarCurr: state_type] :
      ( v130601(VarCurr,7)
    <=> v130602(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1706,axiom,
    ! [VarCurr: state_type] :
      ( v130609(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $false )
        & ( v109486(VarCurr,10)
        <=> $false )
        & ( v109486(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1705,axiom,
    ! [VarCurr: state_type] :
      ( v130608(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $false )
        & ( v109486(VarCurr,10)
        <=> $false )
        & ( v109486(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1704,axiom,
    ! [VarCurr: state_type] :
      ( v130607(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $false )
        & ( v109486(VarCurr,10)
        <=> $true )
        & ( v109486(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1703,axiom,
    ! [VarCurr: state_type] :
      ( v130606(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $false )
        & ( v109486(VarCurr,10)
        <=> $true )
        & ( v109486(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1702,axiom,
    ! [VarCurr: state_type] :
      ( v130605(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $true )
        & ( v109486(VarCurr,10)
        <=> $false )
        & ( v109486(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1701,axiom,
    ! [VarCurr: state_type] :
      ( v130604(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $true )
        & ( v109486(VarCurr,10)
        <=> $false )
        & ( v109486(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1700,axiom,
    ! [VarCurr: state_type] :
      ( v130603(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $true )
        & ( v109486(VarCurr,10)
        <=> $true )
        & ( v109486(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1699,axiom,
    ! [VarCurr: state_type] :
      ( v130602(VarCurr)
    <=> ( ( v109486(VarCurr,11)
        <=> $true )
        & ( v109486(VarCurr,10)
        <=> $true )
        & ( v109486(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109486(VarCurr,B)
      <=> v109488(VarCurr,B) ) ) ).

tff(addAssignment_73956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109488(VarCurr,B)
      <=> v109490(VarCurr,B) ) ) ).

tff(addAssignment_73955,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109490(VarNext,B)
      <=> v130594(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130595(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130594(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1729,axiom,
    ! [VarNext: state_type] :
      ( v130595(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130594(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130595(VarNext)
      <=> v130596(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130596(VarNext)
      <=> ( v130598(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_9469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130598(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_73954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109500(VarCurr,B)
      <=> v109502(VarCurr,B) ) ) ).

tff(addAssignment_73953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109502(VarCurr,B)
      <=> v109515(VarCurr,B) ) ) ).

tff(addAssignment_73952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109504(VarCurr,B)
      <=> v109506(VarCurr,B) ) ) ).

tff(addAssignment_73951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109506(VarCurr,B)
      <=> v109507(VarCurr,B) ) ) ).

tff(addAssignment_73950,axiom,
    ! [VarCurr: state_type] :
      ( v130573(VarCurr,0)
    <=> v130582(VarCurr,0) ) ).

tff(addAssignment_73949,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,0)
    <=> v130590(VarCurr) ) ).

tff(addAssignment_73948,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,1)
    <=> v130589(VarCurr) ) ).

tff(addAssignment_73947,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,2)
    <=> v130588(VarCurr) ) ).

tff(addAssignment_73946,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,3)
    <=> v130587(VarCurr) ) ).

tff(addAssignment_73945,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,4)
    <=> v130586(VarCurr) ) ).

tff(addAssignment_73944,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,5)
    <=> v130585(VarCurr) ) ).

tff(addAssignment_73943,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,6)
    <=> v130584(VarCurr) ) ).

tff(addAssignment_73942,axiom,
    ! [VarCurr: state_type] :
      ( v130582(VarCurr,7)
    <=> v130583(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1698,axiom,
    ! [VarCurr: state_type] :
      ( v130590(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $false )
        & ( v109425(VarCurr,10)
        <=> $false )
        & ( v109425(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1697,axiom,
    ! [VarCurr: state_type] :
      ( v130589(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $false )
        & ( v109425(VarCurr,10)
        <=> $false )
        & ( v109425(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1696,axiom,
    ! [VarCurr: state_type] :
      ( v130588(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $false )
        & ( v109425(VarCurr,10)
        <=> $true )
        & ( v109425(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1695,axiom,
    ! [VarCurr: state_type] :
      ( v130587(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $false )
        & ( v109425(VarCurr,10)
        <=> $true )
        & ( v109425(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1694,axiom,
    ! [VarCurr: state_type] :
      ( v130586(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $true )
        & ( v109425(VarCurr,10)
        <=> $false )
        & ( v109425(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1693,axiom,
    ! [VarCurr: state_type] :
      ( v130585(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $true )
        & ( v109425(VarCurr,10)
        <=> $false )
        & ( v109425(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1692,axiom,
    ! [VarCurr: state_type] :
      ( v130584(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $true )
        & ( v109425(VarCurr,10)
        <=> $true )
        & ( v109425(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1691,axiom,
    ! [VarCurr: state_type] :
      ( v130583(VarCurr)
    <=> ( ( v109425(VarCurr,11)
        <=> $true )
        & ( v109425(VarCurr,10)
        <=> $true )
        & ( v109425(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109425(VarCurr,B)
      <=> v109427(VarCurr,B) ) ) ).

tff(addAssignment_73940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109427(VarCurr,B)
      <=> v109429(VarCurr,B) ) ) ).

tff(addAssignment_73939,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109429(VarNext,B)
      <=> v130575(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130576(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130575(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1728,axiom,
    ! [VarNext: state_type] :
      ( v130576(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130575(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130576(VarNext)
      <=> v130577(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130577(VarNext)
      <=> ( v130579(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130579(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_73938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109439(VarCurr,B)
      <=> v109441(VarCurr,B) ) ) ).

tff(addAssignment_73937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109441(VarCurr,B)
      <=> v109455(VarCurr,B) ) ) ).

tff(addAssignment_73936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109443(VarCurr,B)
      <=> v109445(VarCurr,B) ) ) ).

tff(addAssignment_73935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109445(VarCurr,B)
      <=> v109446(VarCurr,B) ) ) ).

tff(addAssignment_73934,axiom,
    ! [VarCurr: state_type] :
      ( v130554(VarCurr,0)
    <=> v130563(VarCurr,0) ) ).

tff(addAssignment_73933,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,0)
    <=> v130571(VarCurr) ) ).

tff(addAssignment_73932,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,1)
    <=> v130570(VarCurr) ) ).

tff(addAssignment_73931,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,2)
    <=> v130569(VarCurr) ) ).

tff(addAssignment_73930,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,3)
    <=> v130568(VarCurr) ) ).

tff(addAssignment_73929,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,4)
    <=> v130567(VarCurr) ) ).

tff(addAssignment_73928,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,5)
    <=> v130566(VarCurr) ) ).

tff(addAssignment_73927,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,6)
    <=> v130565(VarCurr) ) ).

tff(addAssignment_73926,axiom,
    ! [VarCurr: state_type] :
      ( v130563(VarCurr,7)
    <=> v130564(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1690,axiom,
    ! [VarCurr: state_type] :
      ( v130571(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $false )
        & ( v109364(VarCurr,10)
        <=> $false )
        & ( v109364(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1689,axiom,
    ! [VarCurr: state_type] :
      ( v130570(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $false )
        & ( v109364(VarCurr,10)
        <=> $false )
        & ( v109364(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1688,axiom,
    ! [VarCurr: state_type] :
      ( v130569(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $false )
        & ( v109364(VarCurr,10)
        <=> $true )
        & ( v109364(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1687,axiom,
    ! [VarCurr: state_type] :
      ( v130568(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $false )
        & ( v109364(VarCurr,10)
        <=> $true )
        & ( v109364(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1686,axiom,
    ! [VarCurr: state_type] :
      ( v130567(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $true )
        & ( v109364(VarCurr,10)
        <=> $false )
        & ( v109364(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1685,axiom,
    ! [VarCurr: state_type] :
      ( v130566(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $true )
        & ( v109364(VarCurr,10)
        <=> $false )
        & ( v109364(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1684,axiom,
    ! [VarCurr: state_type] :
      ( v130565(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $true )
        & ( v109364(VarCurr,10)
        <=> $true )
        & ( v109364(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1683,axiom,
    ! [VarCurr: state_type] :
      ( v130564(VarCurr)
    <=> ( ( v109364(VarCurr,11)
        <=> $true )
        & ( v109364(VarCurr,10)
        <=> $true )
        & ( v109364(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109364(VarCurr,B)
      <=> v109366(VarCurr,B) ) ) ).

tff(addAssignment_73924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109366(VarCurr,B)
      <=> v109368(VarCurr,B) ) ) ).

tff(addAssignment_73923,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109368(VarNext,B)
      <=> v130556(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130557(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130556(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1727,axiom,
    ! [VarNext: state_type] :
      ( v130557(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130556(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130557(VarNext)
      <=> v130558(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130558(VarNext)
      <=> ( v130560(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_9467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130560(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_73922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109378(VarCurr,B)
      <=> v109380(VarCurr,B) ) ) ).

tff(addAssignment_73921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109380(VarCurr,B)
      <=> v109394(VarCurr,B) ) ) ).

tff(addAssignment_73920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109382(VarCurr,B)
      <=> v109384(VarCurr,B) ) ) ).

tff(addAssignment_73919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109384(VarCurr,B)
      <=> v109385(VarCurr,B) ) ) ).

tff(addAssignment_73918,axiom,
    ! [VarCurr: state_type] :
      ( v130535(VarCurr,0)
    <=> v130544(VarCurr,0) ) ).

tff(addAssignment_73917,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,0)
    <=> v130552(VarCurr) ) ).

tff(addAssignment_73916,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,1)
    <=> v130551(VarCurr) ) ).

tff(addAssignment_73915,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,2)
    <=> v130550(VarCurr) ) ).

tff(addAssignment_73914,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,3)
    <=> v130549(VarCurr) ) ).

tff(addAssignment_73913,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,4)
    <=> v130548(VarCurr) ) ).

tff(addAssignment_73912,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,5)
    <=> v130547(VarCurr) ) ).

tff(addAssignment_73911,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,6)
    <=> v130546(VarCurr) ) ).

tff(addAssignment_73910,axiom,
    ! [VarCurr: state_type] :
      ( v130544(VarCurr,7)
    <=> v130545(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1682,axiom,
    ! [VarCurr: state_type] :
      ( v130552(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $false )
        & ( v109303(VarCurr,10)
        <=> $false )
        & ( v109303(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1681,axiom,
    ! [VarCurr: state_type] :
      ( v130551(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $false )
        & ( v109303(VarCurr,10)
        <=> $false )
        & ( v109303(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1680,axiom,
    ! [VarCurr: state_type] :
      ( v130550(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $false )
        & ( v109303(VarCurr,10)
        <=> $true )
        & ( v109303(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1679,axiom,
    ! [VarCurr: state_type] :
      ( v130549(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $false )
        & ( v109303(VarCurr,10)
        <=> $true )
        & ( v109303(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1678,axiom,
    ! [VarCurr: state_type] :
      ( v130548(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $true )
        & ( v109303(VarCurr,10)
        <=> $false )
        & ( v109303(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1677,axiom,
    ! [VarCurr: state_type] :
      ( v130547(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $true )
        & ( v109303(VarCurr,10)
        <=> $false )
        & ( v109303(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1676,axiom,
    ! [VarCurr: state_type] :
      ( v130546(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $true )
        & ( v109303(VarCurr,10)
        <=> $true )
        & ( v109303(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1675,axiom,
    ! [VarCurr: state_type] :
      ( v130545(VarCurr)
    <=> ( ( v109303(VarCurr,11)
        <=> $true )
        & ( v109303(VarCurr,10)
        <=> $true )
        & ( v109303(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109303(VarCurr,B)
      <=> v109305(VarCurr,B) ) ) ).

tff(addAssignment_73908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109305(VarCurr,B)
      <=> v109307(VarCurr,B) ) ) ).

tff(addAssignment_73907,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109307(VarNext,B)
      <=> v130537(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130538(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130537(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1726,axiom,
    ! [VarNext: state_type] :
      ( v130538(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130537(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130538(VarNext)
      <=> v130539(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130539(VarNext)
      <=> ( v130541(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_9466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130541(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_73906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109317(VarCurr,B)
      <=> v109319(VarCurr,B) ) ) ).

tff(addAssignment_73905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109319(VarCurr,B)
      <=> v109333(VarCurr,B) ) ) ).

tff(addAssignment_73904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109321(VarCurr,B)
      <=> v109323(VarCurr,B) ) ) ).

tff(addAssignment_73903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109323(VarCurr,B)
      <=> v109324(VarCurr,B) ) ) ).

tff(addAssignment_73902,axiom,
    ! [VarCurr: state_type] :
      ( v130516(VarCurr,0)
    <=> v130525(VarCurr,0) ) ).

tff(addAssignment_73901,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,0)
    <=> v130533(VarCurr) ) ).

tff(addAssignment_73900,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,1)
    <=> v130532(VarCurr) ) ).

tff(addAssignment_73899,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,2)
    <=> v130531(VarCurr) ) ).

tff(addAssignment_73898,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,3)
    <=> v130530(VarCurr) ) ).

tff(addAssignment_73897,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,4)
    <=> v130529(VarCurr) ) ).

tff(addAssignment_73896,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,5)
    <=> v130528(VarCurr) ) ).

tff(addAssignment_73895,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,6)
    <=> v130527(VarCurr) ) ).

tff(addAssignment_73894,axiom,
    ! [VarCurr: state_type] :
      ( v130525(VarCurr,7)
    <=> v130526(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1674,axiom,
    ! [VarCurr: state_type] :
      ( v130533(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $false )
        & ( v109242(VarCurr,10)
        <=> $false )
        & ( v109242(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1673,axiom,
    ! [VarCurr: state_type] :
      ( v130532(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $false )
        & ( v109242(VarCurr,10)
        <=> $false )
        & ( v109242(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1672,axiom,
    ! [VarCurr: state_type] :
      ( v130531(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $false )
        & ( v109242(VarCurr,10)
        <=> $true )
        & ( v109242(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1671,axiom,
    ! [VarCurr: state_type] :
      ( v130530(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $false )
        & ( v109242(VarCurr,10)
        <=> $true )
        & ( v109242(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1670,axiom,
    ! [VarCurr: state_type] :
      ( v130529(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $true )
        & ( v109242(VarCurr,10)
        <=> $false )
        & ( v109242(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1669,axiom,
    ! [VarCurr: state_type] :
      ( v130528(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $true )
        & ( v109242(VarCurr,10)
        <=> $false )
        & ( v109242(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1668,axiom,
    ! [VarCurr: state_type] :
      ( v130527(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $true )
        & ( v109242(VarCurr,10)
        <=> $true )
        & ( v109242(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1667,axiom,
    ! [VarCurr: state_type] :
      ( v130526(VarCurr)
    <=> ( ( v109242(VarCurr,11)
        <=> $true )
        & ( v109242(VarCurr,10)
        <=> $true )
        & ( v109242(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109242(VarCurr,B)
      <=> v109244(VarCurr,B) ) ) ).

tff(addAssignment_73892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109244(VarCurr,B)
      <=> v109246(VarCurr,B) ) ) ).

tff(addAssignment_73891,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109246(VarNext,B)
      <=> v130518(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130519(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130518(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1725,axiom,
    ! [VarNext: state_type] :
      ( v130519(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130518(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130519(VarNext)
      <=> v130520(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130520(VarNext)
      <=> ( v130522(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_9465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130522(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_73890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109256(VarCurr,B)
      <=> v109258(VarCurr,B) ) ) ).

tff(addAssignment_73889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109258(VarCurr,B)
      <=> v109272(VarCurr,B) ) ) ).

tff(addAssignment_73888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109260(VarCurr,B)
      <=> v109262(VarCurr,B) ) ) ).

tff(addAssignment_73887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109262(VarCurr,B)
      <=> v109263(VarCurr,B) ) ) ).

tff(addAssignment_73886,axiom,
    ! [VarCurr: state_type] :
      ( v130497(VarCurr,0)
    <=> v130506(VarCurr,0) ) ).

tff(addAssignment_73885,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,0)
    <=> v130514(VarCurr) ) ).

tff(addAssignment_73884,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,1)
    <=> v130513(VarCurr) ) ).

tff(addAssignment_73883,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,2)
    <=> v130512(VarCurr) ) ).

tff(addAssignment_73882,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,3)
    <=> v130511(VarCurr) ) ).

tff(addAssignment_73881,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,4)
    <=> v130510(VarCurr) ) ).

tff(addAssignment_73880,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,5)
    <=> v130509(VarCurr) ) ).

tff(addAssignment_73879,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,6)
    <=> v130508(VarCurr) ) ).

tff(addAssignment_73878,axiom,
    ! [VarCurr: state_type] :
      ( v130506(VarCurr,7)
    <=> v130507(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1666,axiom,
    ! [VarCurr: state_type] :
      ( v130514(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $false )
        & ( v109181(VarCurr,10)
        <=> $false )
        & ( v109181(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1665,axiom,
    ! [VarCurr: state_type] :
      ( v130513(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $false )
        & ( v109181(VarCurr,10)
        <=> $false )
        & ( v109181(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1664,axiom,
    ! [VarCurr: state_type] :
      ( v130512(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $false )
        & ( v109181(VarCurr,10)
        <=> $true )
        & ( v109181(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1663,axiom,
    ! [VarCurr: state_type] :
      ( v130511(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $false )
        & ( v109181(VarCurr,10)
        <=> $true )
        & ( v109181(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1662,axiom,
    ! [VarCurr: state_type] :
      ( v130510(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $true )
        & ( v109181(VarCurr,10)
        <=> $false )
        & ( v109181(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1661,axiom,
    ! [VarCurr: state_type] :
      ( v130509(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $true )
        & ( v109181(VarCurr,10)
        <=> $false )
        & ( v109181(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1660,axiom,
    ! [VarCurr: state_type] :
      ( v130508(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $true )
        & ( v109181(VarCurr,10)
        <=> $true )
        & ( v109181(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1659,axiom,
    ! [VarCurr: state_type] :
      ( v130507(VarCurr)
    <=> ( ( v109181(VarCurr,11)
        <=> $true )
        & ( v109181(VarCurr,10)
        <=> $true )
        & ( v109181(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109181(VarCurr,B)
      <=> v109183(VarCurr,B) ) ) ).

tff(addAssignment_73876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109183(VarCurr,B)
      <=> v109185(VarCurr,B) ) ) ).

tff(addAssignment_73875,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109185(VarNext,B)
      <=> v130499(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130500(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130499(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1724,axiom,
    ! [VarNext: state_type] :
      ( v130500(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130499(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130500(VarNext)
      <=> v130501(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130501(VarNext)
      <=> ( v130503(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_9464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130503(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_73874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109195(VarCurr,B)
      <=> v109197(VarCurr,B) ) ) ).

tff(addAssignment_73873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109197(VarCurr,B)
      <=> v109211(VarCurr,B) ) ) ).

tff(addAssignment_73872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109199(VarCurr,B)
      <=> v109201(VarCurr,B) ) ) ).

tff(addAssignment_73871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109201(VarCurr,B)
      <=> v109202(VarCurr,B) ) ) ).

tff(addAssignment_73870,axiom,
    ! [VarCurr: state_type] :
      ( v130478(VarCurr,0)
    <=> v130487(VarCurr,0) ) ).

tff(addAssignment_73869,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,0)
    <=> v130495(VarCurr) ) ).

tff(addAssignment_73868,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,1)
    <=> v130494(VarCurr) ) ).

tff(addAssignment_73867,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,2)
    <=> v130493(VarCurr) ) ).

tff(addAssignment_73866,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,3)
    <=> v130492(VarCurr) ) ).

tff(addAssignment_73865,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,4)
    <=> v130491(VarCurr) ) ).

tff(addAssignment_73864,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,5)
    <=> v130490(VarCurr) ) ).

tff(addAssignment_73863,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,6)
    <=> v130489(VarCurr) ) ).

tff(addAssignment_73862,axiom,
    ! [VarCurr: state_type] :
      ( v130487(VarCurr,7)
    <=> v130488(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1658,axiom,
    ! [VarCurr: state_type] :
      ( v130495(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $false )
        & ( v109114(VarCurr,10)
        <=> $false )
        & ( v109114(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1657,axiom,
    ! [VarCurr: state_type] :
      ( v130494(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $false )
        & ( v109114(VarCurr,10)
        <=> $false )
        & ( v109114(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1656,axiom,
    ! [VarCurr: state_type] :
      ( v130493(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $false )
        & ( v109114(VarCurr,10)
        <=> $true )
        & ( v109114(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1655,axiom,
    ! [VarCurr: state_type] :
      ( v130492(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $false )
        & ( v109114(VarCurr,10)
        <=> $true )
        & ( v109114(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1654,axiom,
    ! [VarCurr: state_type] :
      ( v130491(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $true )
        & ( v109114(VarCurr,10)
        <=> $false )
        & ( v109114(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1653,axiom,
    ! [VarCurr: state_type] :
      ( v130490(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $true )
        & ( v109114(VarCurr,10)
        <=> $false )
        & ( v109114(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1652,axiom,
    ! [VarCurr: state_type] :
      ( v130489(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $true )
        & ( v109114(VarCurr,10)
        <=> $true )
        & ( v109114(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1651,axiom,
    ! [VarCurr: state_type] :
      ( v130488(VarCurr)
    <=> ( ( v109114(VarCurr,11)
        <=> $true )
        & ( v109114(VarCurr,10)
        <=> $true )
        & ( v109114(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109114(VarCurr,B)
      <=> v109116(VarCurr,B) ) ) ).

tff(addAssignment_73860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109116(VarCurr,B)
      <=> v109118(VarCurr,B) ) ) ).

tff(addAssignment_73859,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109118(VarNext,B)
      <=> v130480(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130481(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130480(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1723,axiom,
    ! [VarNext: state_type] :
      ( v130481(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130480(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130481(VarNext)
      <=> v130482(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130482(VarNext)
      <=> ( v130484(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_9463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130484(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_73858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109128(VarCurr,B)
      <=> v109130(VarCurr,B) ) ) ).

tff(addAssignment_73857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109130(VarCurr,B)
      <=> v109150(VarCurr,B) ) ) ).

tff(addAssignment_73856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109132(VarCurr,B)
      <=> v109134(VarCurr,B) ) ) ).

tff(addAssignment_73855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v109134(VarCurr,B)
      <=> v109135(VarCurr,B) ) ) ).

tff(addAssignment_73854,axiom,
    ! [VarCurr: state_type] :
      ( v130401(VarCurr,0)
    <=> v130468(VarCurr,0) ) ).

tff(addAssignment_73853,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,0)
    <=> v130476(VarCurr) ) ).

tff(addAssignment_73852,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,1)
    <=> v130475(VarCurr) ) ).

tff(addAssignment_73851,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,2)
    <=> v130474(VarCurr) ) ).

tff(addAssignment_73850,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,3)
    <=> v130473(VarCurr) ) ).

tff(addAssignment_73849,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,4)
    <=> v130472(VarCurr) ) ).

tff(addAssignment_73848,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,5)
    <=> v130471(VarCurr) ) ).

tff(addAssignment_73847,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,6)
    <=> v130470(VarCurr) ) ).

tff(addAssignment_73846,axiom,
    ! [VarCurr: state_type] :
      ( v130468(VarCurr,7)
    <=> v130469(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1650,axiom,
    ! [VarCurr: state_type] :
      ( v130476(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $false )
        & ( v89253(VarCurr,10)
        <=> $false )
        & ( v89253(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1649,axiom,
    ! [VarCurr: state_type] :
      ( v130475(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $false )
        & ( v89253(VarCurr,10)
        <=> $false )
        & ( v89253(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1648,axiom,
    ! [VarCurr: state_type] :
      ( v130474(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $false )
        & ( v89253(VarCurr,10)
        <=> $true )
        & ( v89253(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1647,axiom,
    ! [VarCurr: state_type] :
      ( v130473(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $false )
        & ( v89253(VarCurr,10)
        <=> $true )
        & ( v89253(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1646,axiom,
    ! [VarCurr: state_type] :
      ( v130472(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $true )
        & ( v89253(VarCurr,10)
        <=> $false )
        & ( v89253(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1645,axiom,
    ! [VarCurr: state_type] :
      ( v130471(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $true )
        & ( v89253(VarCurr,10)
        <=> $false )
        & ( v89253(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1644,axiom,
    ! [VarCurr: state_type] :
      ( v130470(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $true )
        & ( v89253(VarCurr,10)
        <=> $true )
        & ( v89253(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1643,axiom,
    ! [VarCurr: state_type] :
      ( v130469(VarCurr)
    <=> ( ( v89253(VarCurr,11)
        <=> $true )
        & ( v89253(VarCurr,10)
        <=> $true )
        & ( v89253(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89253(VarCurr,B)
      <=> v89255(VarCurr,B) ) ) ).

tff(addAssignment_73844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89255(VarCurr,B)
      <=> v89257(VarCurr,B) ) ) ).

tff(addAssignment_73843,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89257(VarNext,B)
      <=> v130461(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130462(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v130461(VarNext,B)
            <=> v89257(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1722,axiom,
    ! [VarNext: state_type] :
      ( v130462(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v130461(VarNext,B)
          <=> v109107(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130462(VarNext)
      <=> v130463(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130463(VarNext)
      <=> ( v130465(VarNext)
          & v109092(VarNext) ) ) ) ).

tff(writeUnaryOperator_9462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130465(VarNext)
      <=> v109101(VarNext) ) ) ).

tff(addAssignment_73842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89267(VarCurr,B)
      <=> v89269(VarCurr,B) ) ) ).

tff(addAssignment_73841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89269(VarCurr,B)
      <=> v109083(VarCurr,B) ) ) ).

tff(addAssignment_73840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89271(VarCurr,B)
      <=> v89273(VarCurr,B) ) ) ).

tff(addAssignment_73839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89273(VarCurr,B)
      <=> v89275(VarCurr,B) ) ) ).

tff(addAssignment_73838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v89275(VarCurr,B)
      <=> v89333(VarCurr,B) ) ) ).

tff(addAssignment_73837,axiom,
    ! [VarCurr: state_type] :
      ( v89334(VarCurr,0)
    <=> v130457(VarCurr) ) ).

tff(addAssignment_73836,axiom,
    ! [VarCurr: state_type] :
      ( v89334(VarCurr,1)
    <=> v130454(VarCurr) ) ).

tff(addAssignment_73835,axiom,
    ! [VarCurr: state_type] :
      ( v89334(VarCurr,2)
    <=> v130451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16920,axiom,
    ! [VarCurr: state_type] :
      ( v130457(VarCurr)
    <=> ( v130458(VarCurr)
        | v130427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16919,axiom,
    ! [VarCurr: state_type] :
      ( v130458(VarCurr)
    <=> ( v130459(VarCurr)
        | v130413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16918,axiom,
    ! [VarCurr: state_type] :
      ( v130459(VarCurr)
    <=> ( v130446(VarCurr)
        | v130440(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16917,axiom,
    ! [VarCurr: state_type] :
      ( v130454(VarCurr)
    <=> ( v130455(VarCurr)
        | v130427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16916,axiom,
    ! [VarCurr: state_type] :
      ( v130455(VarCurr)
    <=> ( v130456(VarCurr)
        | v130420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16915,axiom,
    ! [VarCurr: state_type] :
      ( v130456(VarCurr)
    <=> ( v130434(VarCurr)
        | v130440(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16914,axiom,
    ! [VarCurr: state_type] :
      ( v130451(VarCurr)
    <=> ( v130452(VarCurr)
        | v130427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16913,axiom,
    ! [VarCurr: state_type] :
      ( v130452(VarCurr)
    <=> ( v130453(VarCurr)
        | v130420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16912,axiom,
    ! [VarCurr: state_type] :
      ( v130453(VarCurr)
    <=> ( v130404(VarCurr)
        | v130413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16911,axiom,
    ! [VarCurr: state_type] :
      ( v130446(VarCurr)
    <=> ( v130448(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16910,axiom,
    ! [VarCurr: state_type] :
      ( v130448(VarCurr)
    <=> ( v130449(VarCurr)
        & v743(VarCurr,0) ) ) ).

tff(writeUnaryOperator_9461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130449(VarCurr)
    <=> v743(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16909,axiom,
    ! [VarCurr: state_type] :
      ( v130440(VarCurr)
    <=> ( v130442(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16908,axiom,
    ! [VarCurr: state_type] :
      ( v130442(VarCurr)
    <=> ( v130443(VarCurr)
        & v130444(VarCurr) ) ) ).

tff(addAssignment_73834,axiom,
    ! [VarCurr: state_type] :
      ( v130444(VarCurr)
    <=> v130410(VarCurr) ) ).

tff(writeUnaryOperator_9460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130443(VarCurr)
    <=> v743(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16907,axiom,
    ! [VarCurr: state_type] :
      ( v130434(VarCurr)
    <=> ( v130436(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16906,axiom,
    ! [VarCurr: state_type] :
      ( v130436(VarCurr)
    <=> ( v130437(VarCurr)
        & v130438(VarCurr) ) ) ).

tff(addAssignment_73833,axiom,
    ! [VarCurr: state_type] :
      ( v130438(VarCurr)
    <=> v130411(VarCurr) ) ).

tff(writeUnaryOperator_9459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130437(VarCurr)
    <=> v743(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16905,axiom,
    ! [VarCurr: state_type] :
      ( v130427(VarCurr)
    <=> ( v130429(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16904,axiom,
    ! [VarCurr: state_type] :
      ( v130429(VarCurr)
    <=> ( v130430(VarCurr)
        & v130431(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5943,axiom,
    ! [VarCurr: state_type] :
      ( v130431(VarCurr)
    <=> ( v130425(VarCurr)
        & v743(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5942,axiom,
    ! [VarCurr: state_type] :
      ( v130425(VarCurr)
    <=> ( v130418(VarCurr)
        & v743(VarCurr,5) ) ) ).

tff(writeUnaryOperator_9458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130430(VarCurr)
    <=> v743(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16903,axiom,
    ! [VarCurr: state_type] :
      ( v130420(VarCurr)
    <=> ( v130422(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16902,axiom,
    ! [VarCurr: state_type] :
      ( v130422(VarCurr)
    <=> ( v130423(VarCurr)
        & v130424(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5941,axiom,
    ! [VarCurr: state_type] :
      ( v130424(VarCurr)
    <=> ( v130418(VarCurr)
        & v743(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5940,axiom,
    ! [VarCurr: state_type] :
      ( v130418(VarCurr)
    <=> ( v130409(VarCurr)
        & v743(VarCurr,4) ) ) ).

tff(writeUnaryOperator_9457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130423(VarCurr)
    <=> v743(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16901,axiom,
    ! [VarCurr: state_type] :
      ( v130413(VarCurr)
    <=> ( v130415(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16900,axiom,
    ! [VarCurr: state_type] :
      ( v130415(VarCurr)
    <=> ( v130416(VarCurr)
        & v130417(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5939,axiom,
    ! [VarCurr: state_type] :
      ( v130417(VarCurr)
    <=> ( v130409(VarCurr)
        & v743(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5938,axiom,
    ! [VarCurr: state_type] :
      ( v130409(VarCurr)
    <=> ( v130410(VarCurr)
        & v743(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130416(VarCurr)
    <=> v743(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16899,axiom,
    ! [VarCurr: state_type] :
      ( v130404(VarCurr)
    <=> ( v130406(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16898,axiom,
    ! [VarCurr: state_type] :
      ( v130406(VarCurr)
    <=> ( v130407(VarCurr)
        & v130408(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5937,axiom,
    ! [VarCurr: state_type] :
      ( v130408(VarCurr)
    <=> ( v130410(VarCurr)
        & v743(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5936,axiom,
    ! [VarCurr: state_type] :
      ( v130410(VarCurr)
    <=> ( v130411(VarCurr)
        & v743(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5935,axiom,
    ! [VarCurr: state_type] :
      ( v130411(VarCurr)
    <=> ( v743(VarCurr,0)
        & v743(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130407(VarCurr)
    <=> v743(VarCurr,4) ) ).

tff(addAssignment_73832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130152(VarCurr,B)
      <=> v130154(VarCurr,B) ) ) ).

tff(addAssignment_73831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130154(VarCurr,B)
      <=> v130371(VarCurr,B) ) ) ).

tff(addAssignment_73830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130371(VarCurr,B)
      <=> v130375(VarCurr,B) ) ) ).

tff(addAssignment_73829,axiom,
    ! [VarCurr: state_type] :
      ( ( v130371(VarCurr,25)
      <=> v130374(VarCurr,14) )
      & ( v130371(VarCurr,24)
      <=> v130374(VarCurr,13) )
      & ( v130371(VarCurr,23)
      <=> v130374(VarCurr,12) )
      & ( v130371(VarCurr,22)
      <=> v130374(VarCurr,11) )
      & ( v130371(VarCurr,21)
      <=> v130374(VarCurr,10) )
      & ( v130371(VarCurr,20)
      <=> v130374(VarCurr,9) )
      & ( v130371(VarCurr,19)
      <=> v130374(VarCurr,8) )
      & ( v130371(VarCurr,18)
      <=> v130374(VarCurr,7) )
      & ( v130371(VarCurr,17)
      <=> v130374(VarCurr,6) )
      & ( v130371(VarCurr,16)
      <=> v130374(VarCurr,5) )
      & ( v130371(VarCurr,15)
      <=> v130374(VarCurr,4) )
      & ( v130371(VarCurr,14)
      <=> v130374(VarCurr,3) )
      & ( v130371(VarCurr,13)
      <=> v130374(VarCurr,2) )
      & ( v130371(VarCurr,12)
      <=> v130374(VarCurr,1) )
      & ( v130371(VarCurr,11)
      <=> v130374(VarCurr,0) ) ) ).

tff(addAssignment_73828,axiom,
    ! [VarCurr: state_type] :
      ( ( v130371(VarCurr,28)
      <=> v130373(VarCurr,2) )
      & ( v130371(VarCurr,27)
      <=> v130373(VarCurr,1) )
      & ( v130371(VarCurr,26)
      <=> v130373(VarCurr,0) ) ) ).

tff(addAssignment_73827,axiom,
    ! [VarCurr: state_type] :
      ( ( v130371(VarCurr,32)
      <=> v130156(VarCurr,3) )
      & ( v130371(VarCurr,31)
      <=> v130156(VarCurr,2) )
      & ( v130371(VarCurr,30)
      <=> v130156(VarCurr,1) )
      & ( v130371(VarCurr,29)
      <=> v130156(VarCurr,0) ) ) ).

tff(addAssignment_73826,axiom,
    ! [VarCurr: state_type] :
      ( ( v130371(VarCurr,35)
      <=> v130372(VarCurr,2) )
      & ( v130371(VarCurr,34)
      <=> v130372(VarCurr,1) )
      & ( v130371(VarCurr,33)
      <=> v130372(VarCurr,0) ) ) ).

tff(addAssignment_73825,axiom,
    ! [VarCurr: state_type] :
      ( ( v130156(VarCurr,3)
      <=> v130158(VarCurr,32) )
      & ( v130156(VarCurr,2)
      <=> v130158(VarCurr,31) )
      & ( v130156(VarCurr,1)
      <=> v130158(VarCurr,30) )
      & ( v130156(VarCurr,0)
      <=> v130158(VarCurr,29) ) ) ).

tff(addAssignment_73824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130158(VarCurr,B)
      <=> v130160(VarCurr,B) ) ) ).

tff(addAssignment_73823,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130160(VarNext,B)
      <=> v130354(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130355(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v130354(VarNext,B)
            <=> v130160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1721,axiom,
    ! [VarNext: state_type] :
      ( v130355(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130354(VarNext,B)
          <=> v130365(VarNext,B) ) ) ) ).

tff(addAssignment_73822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130365(VarNext,B)
          <=> v130363(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130366(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130363(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1314,axiom,
    ! [VarCurr: state_type] :
      ( v130366(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130363(VarCurr,B)
          <=> v130194(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16897,axiom,
    ! [VarCurr: state_type] :
      ( v130366(VarCurr)
    <=> ( v130367(VarCurr)
        & v130368(VarCurr) ) ) ).

tff(writeUnaryOperator_9454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130368(VarCurr)
    <=> v130178(VarCurr) ) ).

tff(writeUnaryOperator_9453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130367(VarCurr)
    <=> v130162(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130355(VarNext)
      <=> v130356(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130356(VarNext)
      <=> ( v130357(VarNext)
          & v130291(VarNext) ) ) ) ).

tff(writeUnaryOperator_9452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130357(VarNext)
      <=> v130359(VarNext) ) ) ).

tff(addAssignment_73821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130359(VarNext)
      <=> v130291(VarCurr) ) ) ).

tff(addAssignment_73820,axiom,
    ! [VarCurr: state_type] :
      ( v130291(VarCurr)
    <=> v130293(VarCurr) ) ).

tff(addAssignment_73819,axiom,
    ! [VarCurr: state_type] :
      ( v130293(VarCurr)
    <=> v130295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16894,axiom,
    ! [VarCurr: state_type] :
      ( v130295(VarCurr)
    <=> ( v130352(VarCurr)
        | v130348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16893,axiom,
    ! [VarCurr: state_type] :
      ( v130352(VarCurr)
    <=> ( v130297(VarCurr)
        & v130301(VarCurr) ) ) ).

tff(addAssignment_73818,axiom,
    ! [VarCurr: state_type] :
      ( v130348(VarCurr)
    <=> v130350(VarCurr) ) ).

tff(addAssignment_73817,axiom,
    ! [VarCurr: state_type] :
      ( v130350(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130332(VarNext)
       => ( v130301(VarNext)
        <=> v130301(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1720,axiom,
    ! [VarNext: state_type] :
      ( v130332(VarNext)
     => ( v130301(VarNext)
      <=> v130342(VarNext) ) ) ).

tff(addAssignment_73816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130342(VarNext)
      <=> v130340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16892,axiom,
    ! [VarCurr: state_type] :
      ( v130340(VarCurr)
    <=> ( v130343(VarCurr)
        & v130344(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16891,axiom,
    ! [VarCurr: state_type] :
      ( v130344(VarCurr)
    <=> ( v130307(VarCurr)
        | v130321(VarCurr) ) ) ).

tff(writeUnaryOperator_9451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130343(VarCurr)
    <=> v130303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130332(VarNext)
      <=> v130333(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130333(VarNext)
      <=> ( v130335(VarNext)
          & v130337(VarNext) ) ) ) ).

tff(writeUnaryOperator_9450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130337(VarCurr)
    <=> v130297(VarCurr) ) ).

tff(addAssignment_73815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130335(VarNext)
      <=> v130297(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_246,axiom,
    ( v130301(constB0)
  <=> $true ) ).

tff(addAssignment_73814,axiom,
    ! [VarCurr: state_type] :
      ( v130321(VarCurr)
    <=> v130323(VarCurr) ) ).

tff(addAssignment_73813,axiom,
    ! [VarCurr: state_type] :
      ( v130323(VarCurr)
    <=> v130325(VarCurr) ) ).

tff(addAssignment_73812,axiom,
    ! [VarCurr: state_type] :
      ( v130325(VarCurr)
    <=> v130327(VarCurr) ) ).

tff(addAssignment_73811,axiom,
    ! [VarCurr: state_type] :
      ( v130327(VarCurr)
    <=> v130329(VarCurr) ) ).

tff(addAssignment_73810,axiom,
    ! [VarCurr: state_type] :
      ( v130329(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_73809,axiom,
    ! [VarCurr: state_type] :
      ( v130307(VarCurr)
    <=> v130309(VarCurr) ) ).

tff(addAssignment_73808,axiom,
    ! [VarCurr: state_type] :
      ( v130309(VarCurr)
    <=> v130311(VarCurr) ) ).

tff(addAssignment_73807,axiom,
    ! [VarCurr: state_type] :
      ( v130311(VarCurr)
    <=> v130313(VarCurr) ) ).

tff(addAssignment_73806,axiom,
    ! [VarCurr: state_type] :
      ( v130313(VarCurr)
    <=> v130315(VarCurr) ) ).

tff(addAssignment_73805,axiom,
    ! [VarCurr: state_type] :
      ( v130315(VarCurr)
    <=> v130317(VarCurr) ) ).

tff(addAssignment_73804,axiom,
    ! [VarCurr: state_type] :
      ( v130317(VarCurr)
    <=> v130319(VarCurr) ) ).

tff(addAssignment_73803,axiom,
    ! [VarCurr: state_type] :
      ( v130319(VarCurr)
    <=> v765(VarCurr) ) ).

tff(addAssignment_73802,axiom,
    ! [VarCurr: state_type] :
      ( v130303(VarCurr)
    <=> v130305(VarCurr) ) ).

tff(addAssignment_73801,axiom,
    ! [VarCurr: state_type] :
      ( v130305(VarCurr)
    <=> $false ) ).

tff(addAssignment_73800,axiom,
    ! [VarCurr: state_type] :
      ( v130297(VarCurr)
    <=> v130299(VarCurr) ) ).

tff(addAssignment_73799,axiom,
    ! [VarCurr: state_type] :
      ( v130299(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_73798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130194(VarCurr,B)
      <=> v130196(VarCurr,B) ) ) ).

tff(addAssignment_73797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130196(VarCurr,B)
      <=> v130285(VarCurr,B) ) ) ).

tff(addAssignment_73796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130285(VarCurr,B)
      <=> v130289(VarCurr,B) ) ) ).

tff(addAssignment_73795,axiom,
    ! [VarCurr: state_type] :
      ( ( v130285(VarCurr,25)
      <=> v130288(VarCurr,14) )
      & ( v130285(VarCurr,24)
      <=> v130288(VarCurr,13) )
      & ( v130285(VarCurr,23)
      <=> v130288(VarCurr,12) )
      & ( v130285(VarCurr,22)
      <=> v130288(VarCurr,11) )
      & ( v130285(VarCurr,21)
      <=> v130288(VarCurr,10) )
      & ( v130285(VarCurr,20)
      <=> v130288(VarCurr,9) )
      & ( v130285(VarCurr,19)
      <=> v130288(VarCurr,8) )
      & ( v130285(VarCurr,18)
      <=> v130288(VarCurr,7) )
      & ( v130285(VarCurr,17)
      <=> v130288(VarCurr,6) )
      & ( v130285(VarCurr,16)
      <=> v130288(VarCurr,5) )
      & ( v130285(VarCurr,15)
      <=> v130288(VarCurr,4) )
      & ( v130285(VarCurr,14)
      <=> v130288(VarCurr,3) )
      & ( v130285(VarCurr,13)
      <=> v130288(VarCurr,2) )
      & ( v130285(VarCurr,12)
      <=> v130288(VarCurr,1) )
      & ( v130285(VarCurr,11)
      <=> v130288(VarCurr,0) ) ) ).

tff(addAssignment_73794,axiom,
    ! [VarCurr: state_type] :
      ( ( v130285(VarCurr,28)
      <=> v130287(VarCurr,2) )
      & ( v130285(VarCurr,27)
      <=> v130287(VarCurr,1) )
      & ( v130285(VarCurr,26)
      <=> v130287(VarCurr,0) ) ) ).

tff(addAssignment_73793,axiom,
    ! [VarCurr: state_type] :
      ( ( v130285(VarCurr,32)
      <=> v130198(VarCurr,3) )
      & ( v130285(VarCurr,31)
      <=> v130198(VarCurr,2) )
      & ( v130285(VarCurr,30)
      <=> v130198(VarCurr,1) )
      & ( v130285(VarCurr,29)
      <=> v130198(VarCurr,0) ) ) ).

tff(addAssignment_73792,axiom,
    ! [VarCurr: state_type] :
      ( ( v130285(VarCurr,35)
      <=> v130286(VarCurr,2) )
      & ( v130285(VarCurr,34)
      <=> v130286(VarCurr,1) )
      & ( v130285(VarCurr,33)
      <=> v130286(VarCurr,0) ) ) ).

tff(addAssignment_73791,axiom,
    ! [VarCurr: state_type] :
      ( ( v130198(VarCurr,3)
      <=> v130200(VarCurr,32) )
      & ( v130198(VarCurr,2)
      <=> v130200(VarCurr,31) )
      & ( v130198(VarCurr,1)
      <=> v130200(VarCurr,30) )
      & ( v130198(VarCurr,0)
      <=> v130200(VarCurr,29) ) ) ).

tff(addAssignment_73790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130200(VarCurr,B)
      <=> v130202(VarCurr,B) ) ) ).

tff(addAssignment_73789,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130202(VarNext,B)
      <=> v130268(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130269(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v130268(VarNext,B)
            <=> v130202(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1719,axiom,
    ! [VarNext: state_type] :
      ( v130269(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130268(VarNext,B)
          <=> v130279(VarNext,B) ) ) ) ).

tff(addAssignment_73788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130279(VarNext,B)
          <=> v130277(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130277(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1313,axiom,
    ! [VarCurr: state_type] :
      ( v130280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v130277(VarCurr,B)
          <=> v130224(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16888,axiom,
    ! [VarCurr: state_type] :
      ( v130280(VarCurr)
    <=> ( v130281(VarCurr)
        & v130282(VarCurr) ) ) ).

tff(writeUnaryOperator_9449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130282(VarCurr)
    <=> v130214(VarCurr) ) ).

tff(writeUnaryOperator_9448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130281(VarCurr)
    <=> v130204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130269(VarNext)
      <=> v130270(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130270(VarNext)
      <=> ( v130271(VarNext)
          & v130240(VarNext) ) ) ) ).

tff(writeUnaryOperator_9447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130271(VarNext)
      <=> v130273(VarNext) ) ) ).

tff(addAssignment_73787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130273(VarNext)
      <=> v130240(VarCurr) ) ) ).

tff(addAssignment_73786,axiom,
    ! [VarCurr: state_type] :
      ( v130240(VarCurr)
    <=> v130242(VarCurr) ) ).

tff(addAssignment_73785,axiom,
    ! [VarCurr: state_type] :
      ( v130242(VarCurr)
    <=> v130244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16885,axiom,
    ! [VarCurr: state_type] :
      ( v130244(VarCurr)
    <=> ( v130266(VarCurr)
        | v130256(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16884,axiom,
    ! [VarCurr: state_type] :
      ( v130266(VarCurr)
    <=> ( v130246(VarCurr)
        & v130254(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_245,axiom,
    ( v130254(constB0)
  <=> $true ) ).

tff(addAssignment_73784,axiom,
    ! [VarCurr: state_type] :
      ( v130256(VarCurr)
    <=> v130258(VarCurr) ) ).

tff(addAssignment_73783,axiom,
    ! [VarCurr: state_type] :
      ( v130258(VarCurr)
    <=> v130260(VarCurr) ) ).

tff(addAssignment_73782,axiom,
    ! [VarCurr: state_type] :
      ( v130260(VarCurr)
    <=> v130262(VarCurr) ) ).

tff(addAssignment_73781,axiom,
    ! [VarCurr: state_type] :
      ( v130262(VarCurr)
    <=> v130264(VarCurr) ) ).

tff(addAssignment_73780,axiom,
    ! [VarCurr: state_type] :
      ( v130264(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_73779,axiom,
    ! [VarCurr: state_type] :
      ( v130246(VarCurr)
    <=> v130248(VarCurr) ) ).

tff(addAssignment_73778,axiom,
    ! [VarCurr: state_type] :
      ( v130248(VarCurr)
    <=> v130250(VarCurr) ) ).

tff(addAssignment_73777,axiom,
    ! [VarCurr: state_type] :
      ( v130250(VarCurr)
    <=> v130252(VarCurr) ) ).

tff(addAssignment_73776,axiom,
    ! [VarCurr: state_type] :
      ( v130252(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_73775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130224(VarCurr,B)
      <=> v130226(VarCurr,B) ) ) ).

tff(addAssignment_73774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,33)
        & ~ $less(B,29) )
     => ( v130226(VarCurr,B)
      <=> v130234(VarCurr,B) ) ) ).

tff(addAssignment_73773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,11)
        & ~ $less(B,0) )
     => ( v130234(VarCurr,B)
      <=> v130238(VarCurr,B) ) ) ).

tff(addAssignment_73772,axiom,
    ! [VarCurr: state_type] :
      ( ( v130234(VarCurr,25)
      <=> v130237(VarCurr,14) )
      & ( v130234(VarCurr,24)
      <=> v130237(VarCurr,13) )
      & ( v130234(VarCurr,23)
      <=> v130237(VarCurr,12) )
      & ( v130234(VarCurr,22)
      <=> v130237(VarCurr,11) )
      & ( v130234(VarCurr,21)
      <=> v130237(VarCurr,10) )
      & ( v130234(VarCurr,20)
      <=> v130237(VarCurr,9) )
      & ( v130234(VarCurr,19)
      <=> v130237(VarCurr,8) )
      & ( v130234(VarCurr,18)
      <=> v130237(VarCurr,7) )
      & ( v130234(VarCurr,17)
      <=> v130237(VarCurr,6) )
      & ( v130234(VarCurr,16)
      <=> v130237(VarCurr,5) )
      & ( v130234(VarCurr,15)
      <=> v130237(VarCurr,4) )
      & ( v130234(VarCurr,14)
      <=> v130237(VarCurr,3) )
      & ( v130234(VarCurr,13)
      <=> v130237(VarCurr,2) )
      & ( v130234(VarCurr,12)
      <=> v130237(VarCurr,1) )
      & ( v130234(VarCurr,11)
      <=> v130237(VarCurr,0) ) ) ).

tff(addAssignment_73771,axiom,
    ! [VarCurr: state_type] :
      ( ( v130234(VarCurr,28)
      <=> v130236(VarCurr,2) )
      & ( v130234(VarCurr,27)
      <=> v130236(VarCurr,1) )
      & ( v130234(VarCurr,26)
      <=> v130236(VarCurr,0) ) ) ).

tff(addAssignment_73770,axiom,
    ! [VarCurr: state_type] :
      ( ( v130234(VarCurr,32)
      <=> v130228(VarCurr,3) )
      & ( v130234(VarCurr,31)
      <=> v130228(VarCurr,2) )
      & ( v130234(VarCurr,30)
      <=> v130228(VarCurr,1) )
      & ( v130234(VarCurr,29)
      <=> v130228(VarCurr,0) ) ) ).

tff(addAssignment_73769,axiom,
    ! [VarCurr: state_type] :
      ( ( v130234(VarCurr,35)
      <=> v130235(VarCurr,2) )
      & ( v130234(VarCurr,34)
      <=> v130235(VarCurr,1) )
      & ( v130234(VarCurr,33)
      <=> v130235(VarCurr,0) ) ) ).

tff(addAssignment_73768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v130228(VarCurr,B)
      <=> v130232(VarCurr,B) ) ) ).

tff(addAssignment_73767,axiom,
    ! [VarCurr: state_type] :
      ( v130228(VarCurr,3)
    <=> v130230(VarCurr) ) ).

tff(addAssignment_73766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v130232(VarCurr,B)
      <=> v89303(VarCurr,B) ) ) ).

tff(addAssignment_73765,axiom,
    ! [VarCurr: state_type] :
      ( v130230(VarCurr)
    <=> v109062(VarCurr) ) ).

tff(addAssignment_73764,axiom,
    ! [VarCurr: state_type] :
      ( v130214(VarCurr)
    <=> v130216(VarCurr) ) ).

tff(addAssignment_73763,axiom,
    ! [VarCurr: state_type] :
      ( v130216(VarCurr)
    <=> v130218(VarCurr) ) ).

tff(addAssignment_73762,axiom,
    ! [VarCurr: state_type] :
      ( v130218(VarCurr)
    <=> v130220(VarCurr) ) ).

tff(addAssignment_73761,axiom,
    ! [VarCurr: state_type] :
      ( v130220(VarCurr)
    <=> v130222(VarCurr) ) ).

tff(addAssignment_73760,axiom,
    ! [VarCurr: state_type] :
      ( v130222(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_73759,axiom,
    ! [VarCurr: state_type] :
      ( v130204(VarCurr)
    <=> v130206(VarCurr) ) ).

tff(addAssignment_73758,axiom,
    ! [VarCurr: state_type] :
      ( v130206(VarCurr)
    <=> v130208(VarCurr) ) ).

tff(addAssignment_73757,axiom,
    ! [VarCurr: state_type] :
      ( v130208(VarCurr)
    <=> v130210(VarCurr) ) ).

tff(addAssignment_73756,axiom,
    ! [VarCurr: state_type] :
      ( v130210(VarCurr)
    <=> v130212(VarCurr) ) ).

tff(addAssignment_73755,axiom,
    ! [VarCurr: state_type] :
      ( v130212(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_73754,axiom,
    ! [VarCurr: state_type] :
      ( v130178(VarCurr)
    <=> v130180(VarCurr) ) ).

tff(addAssignment_73753,axiom,
    ! [VarCurr: state_type] :
      ( v130180(VarCurr)
    <=> v130182(VarCurr) ) ).

tff(addAssignment_73752,axiom,
    ! [VarCurr: state_type] :
      ( v130182(VarCurr)
    <=> v130184(VarCurr) ) ).

tff(addAssignment_73751,axiom,
    ! [VarCurr: state_type] :
      ( v130184(VarCurr)
    <=> v130186(VarCurr) ) ).

tff(addAssignment_73750,axiom,
    ! [VarCurr: state_type] :
      ( v130186(VarCurr)
    <=> v130188(VarCurr) ) ).

tff(addAssignment_73749,axiom,
    ! [VarCurr: state_type] :
      ( v130188(VarCurr)
    <=> v130190(VarCurr) ) ).

tff(addAssignment_73748,axiom,
    ! [VarCurr: state_type] :
      ( v130190(VarCurr)
    <=> v130192(VarCurr) ) ).

tff(addAssignment_73747,axiom,
    ! [VarCurr: state_type] :
      ( v130192(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_73746,axiom,
    ! [VarCurr: state_type] :
      ( v130162(VarCurr)
    <=> v130164(VarCurr) ) ).

tff(addAssignment_73745,axiom,
    ! [VarCurr: state_type] :
      ( v130164(VarCurr)
    <=> v130166(VarCurr) ) ).

tff(addAssignment_73744,axiom,
    ! [VarCurr: state_type] :
      ( v130166(VarCurr)
    <=> v130168(VarCurr) ) ).

tff(addAssignment_73743,axiom,
    ! [VarCurr: state_type] :
      ( v130168(VarCurr)
    <=> v130170(VarCurr) ) ).

tff(addAssignment_73742,axiom,
    ! [VarCurr: state_type] :
      ( v130170(VarCurr)
    <=> v130172(VarCurr) ) ).

tff(addAssignment_73741,axiom,
    ! [VarCurr: state_type] :
      ( v130172(VarCurr)
    <=> v130174(VarCurr) ) ).

tff(addAssignment_73740,axiom,
    ! [VarCurr: state_type] :
      ( v130174(VarCurr)
    <=> v130176(VarCurr) ) ).

tff(addAssignment_73739,axiom,
    ! [VarCurr: state_type] :
      ( v130176(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_73738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89413(VarCurr,B)
      <=> v89415(VarCurr,B) ) ) ).

tff(addAssignment_73737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89415(VarCurr,B)
      <=> v89417(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89417(VarCurr,B)
      <=> ( v89419(VarCurr,B)
          & v130128(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130128(VarCurr,B)
      <=> ~ v130026(VarCurr,B) ) ) ).

tff(addAssignment_73736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130026(VarCurr,B)
      <=> v130028(VarCurr,B) ) ) ).

tff(addAssignment_73735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130028(VarCurr,B)
      <=> v130030(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130111(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v130030(VarNext,B)
            <=> v130030(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1718,axiom,
    ! [VarNext: state_type] :
      ( v130111(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130030(VarNext,B)
          <=> v130121(VarNext,B) ) ) ) ).

tff(addAssignment_73734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130121(VarNext,B)
          <=> v130119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130119(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1312,axiom,
    ! [VarCurr: state_type] :
      ( v130122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130119(VarCurr,B)
          <=> v130040(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16883,axiom,
    ! [VarCurr: state_type] :
      ( v130122(VarCurr)
    <=> ( v130123(VarCurr)
        & v130124(VarCurr) ) ) ).

tff(writeUnaryOperator_9445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130124(VarCurr)
    <=> v130036(VarCurr) ) ).

tff(writeUnaryOperator_9444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130123(VarCurr)
    <=> v130032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130111(VarNext)
      <=> v130112(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130112(VarNext)
      <=> ( v130113(VarNext)
          & v130106(VarNext) ) ) ) ).

tff(writeUnaryOperator_9443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130113(VarNext)
      <=> v130115(VarNext) ) ) ).

tff(addAssignment_73733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130115(VarNext)
      <=> v130106(VarCurr) ) ) ).

tff(addAssignment_73732,axiom,
    ! [VarCurr: state_type] :
      ( v130106(VarCurr)
    <=> v130108(VarCurr) ) ).

tff(addAssignment_73731,axiom,
    ! [VarCurr: state_type] :
      ( v130108(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_73730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130040(VarCurr,B)
      <=> v130042(VarCurr,B) ) ) ).

tff(addAssignment_73729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130042(VarCurr,B)
      <=> v130044(VarCurr,B) ) ) ).

tff(addAssignment_73728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130044(VarCurr,B)
      <=> v130046(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,7)
     => ( v130046(VarCurr,7)
      <=> v130104(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_156,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,7)
     => ( v130046(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,7)
     => ( v130104(VarCurr)
      <=> v130026(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1311,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,7)
     => ( v130104(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,6)
     => ( v130046(VarCurr,6)
      <=> v130102(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_155,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,6)
     => ( v130046(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,6)
     => ( v130102(VarCurr)
      <=> v130026(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1310,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,6)
     => ( v130102(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,5)
     => ( v130046(VarCurr,5)
      <=> v130100(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_154,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,5)
     => ( v130046(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,5)
     => ( v130100(VarCurr)
      <=> v130026(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1309,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,5)
     => ( v130100(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,4)
     => ( v130046(VarCurr,4)
      <=> v130098(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_153,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,4)
     => ( v130046(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,4)
     => ( v130098(VarCurr)
      <=> v130026(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1308,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,4)
     => ( v130098(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,3)
     => ( v130046(VarCurr,3)
      <=> v130096(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_152,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,3)
     => ( v130046(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,3)
     => ( v130096(VarCurr)
      <=> v130026(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1307,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,3)
     => ( v130096(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,2)
     => ( v130046(VarCurr,2)
      <=> v130094(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_151,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,2)
     => ( v130046(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,2)
     => ( v130094(VarCurr)
      <=> v130026(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1306,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,2)
     => ( v130094(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,1)
     => ( v130046(VarCurr,1)
      <=> v130092(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_150,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,1)
     => ( v130046(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,1)
     => ( v130092(VarCurr)
      <=> v130026(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1305,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,1)
     => ( v130092(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130048(VarCurr,0)
     => ( v130046(VarCurr,0)
      <=> v130090(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1304,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,0)
     => ( v130046(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,0)
     => ( v130090(VarCurr)
      <=> v130026(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1303,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,0)
     => ( v130090(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_73727,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,7)
    <=> v130050(VarCurr,7) ) ).

tff(addAssignment_73726,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,7)
    <=> v130052(VarCurr,7) ) ).

tff(addAssignment_73725,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,7)
    <=> v130075(VarCurr,7) ) ).

tff(addAssignment_73724,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,7)
    <=> v130066(VarCurr,7) ) ).

tff(addAssignment_73723,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,7)
    <=> v130055(VarCurr,7) ) ).

tff(addAssignment_73722,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,6)
    <=> v130050(VarCurr,6) ) ).

tff(addAssignment_73721,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,6)
    <=> v130052(VarCurr,6) ) ).

tff(addAssignment_73720,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,6)
    <=> v130075(VarCurr,6) ) ).

tff(addAssignment_73719,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,6)
    <=> v130066(VarCurr,6) ) ).

tff(addAssignment_73718,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,6)
    <=> v130055(VarCurr,6) ) ).

tff(addAssignment_73717,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,5)
    <=> v130050(VarCurr,5) ) ).

tff(addAssignment_73716,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,5)
    <=> v130052(VarCurr,5) ) ).

tff(addAssignment_73715,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,5)
    <=> v130075(VarCurr,5) ) ).

tff(addAssignment_73714,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,5)
    <=> v130066(VarCurr,5) ) ).

tff(addAssignment_73713,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,5)
    <=> v130055(VarCurr,5) ) ).

tff(addAssignment_73712,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,4)
    <=> v130050(VarCurr,4) ) ).

tff(addAssignment_73711,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,4)
    <=> v130052(VarCurr,4) ) ).

tff(addAssignment_73710,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,4)
    <=> v130075(VarCurr,4) ) ).

tff(addAssignment_73709,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,4)
    <=> v130066(VarCurr,4) ) ).

tff(addAssignment_73708,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,4)
    <=> v130055(VarCurr,4) ) ).

tff(addAssignment_73707,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,3)
    <=> v130050(VarCurr,3) ) ).

tff(addAssignment_73706,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,3)
    <=> v130052(VarCurr,3) ) ).

tff(addAssignment_73705,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,3)
    <=> v130075(VarCurr,3) ) ).

tff(addAssignment_73704,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,3)
    <=> v130066(VarCurr,3) ) ).

tff(addAssignment_73703,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,3)
    <=> v130055(VarCurr,3) ) ).

tff(addAssignment_73702,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,2)
    <=> v130050(VarCurr,2) ) ).

tff(addAssignment_73701,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,2)
    <=> v130052(VarCurr,2) ) ).

tff(addAssignment_73700,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,2)
    <=> v130075(VarCurr,2) ) ).

tff(addAssignment_73699,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,2)
    <=> v130066(VarCurr,2) ) ).

tff(addAssignment_73698,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,2)
    <=> v130055(VarCurr,2) ) ).

tff(addAssignment_73697,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,1)
    <=> v130050(VarCurr,1) ) ).

tff(addAssignment_73696,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,1)
    <=> v130052(VarCurr,1) ) ).

tff(addAssignment_73695,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,1)
    <=> v130075(VarCurr,1) ) ).

tff(addAssignment_73694,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,1)
    <=> v130066(VarCurr,1) ) ).

tff(addAssignment_73693,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,1)
    <=> v130055(VarCurr,1) ) ).

tff(addAssignment_73692,axiom,
    ! [VarCurr: state_type] :
      ( v130048(VarCurr,0)
    <=> v130050(VarCurr,0) ) ).

tff(addAssignment_73691,axiom,
    ! [VarCurr: state_type] :
      ( v130050(VarCurr,0)
    <=> v130052(VarCurr,0) ) ).

tff(addAssignment_73690,axiom,
    ! [VarCurr: state_type] :
      ( v130052(VarCurr,0)
    <=> v130075(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130075(VarCurr,B)
      <=> ( v130076(VarCurr,B)
          | v130085(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130085(VarCurr,B)
      <=> ( v130086(VarCurr,B)
          & v130065(VarCurr,B) ) ) ) ).

tff(addAssignment_73689,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,0)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73688,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,1)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73687,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,2)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73686,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,3)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73685,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,4)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73684,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,5)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73683,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,6)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73682,axiom,
    ! [VarCurr: state_type] :
      ( v130086(VarCurr,7)
    <=> v130087(VarCurr) ) ).

tff(addAssignment_73681,axiom,
    ! [VarCurr: state_type] :
      ( v130087(VarCurr)
    <=> v130088(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5934,axiom,
    ! [VarCurr: state_type] :
      ( v130088(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v100445(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130076(VarCurr,B)
      <=> ( v130077(VarCurr,B)
          | v130081(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130081(VarCurr,B)
      <=> ( v130082(VarCurr,B)
          & v130054(VarCurr,B) ) ) ) ).

tff(addAssignment_73680,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,0)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73679,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,1)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73678,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,2)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73677,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,3)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73676,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,4)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73675,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,5)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73674,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,6)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73673,axiom,
    ! [VarCurr: state_type] :
      ( v130082(VarCurr,7)
    <=> v130083(VarCurr) ) ).

tff(addAssignment_73672,axiom,
    ! [VarCurr: state_type] :
      ( v130083(VarCurr)
    <=> v130084(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5933,axiom,
    ! [VarCurr: state_type] :
      ( v130084(VarCurr)
    <=> ( v100203(VarCurr,1)
        & v100229(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1807,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v130077(VarCurr,B)
      <=> ( v130078(VarCurr,B)
          & v130054(VarCurr,B) ) ) ) ).

tff(addAssignment_73671,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,0)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73670,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,1)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73669,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,2)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73668,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,3)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73667,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,4)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73666,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,5)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73665,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,6)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73664,axiom,
    ! [VarCurr: state_type] :
      ( v130078(VarCurr,7)
    <=> v130079(VarCurr) ) ).

tff(addAssignment_73663,axiom,
    ! [VarCurr: state_type] :
      ( v130079(VarCurr)
    <=> v130080(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5932,axiom,
    ! [VarCurr: state_type] :
      ( v130080(VarCurr)
    <=> ( v100203(VarCurr,0)
        & v100229(VarCurr,15) ) ) ).

tff(addAssignment_73662,axiom,
    ! [VarCurr: state_type] :
      ( v130065(VarCurr,0)
    <=> v130066(VarCurr,0) ) ).

tff(addAssignment_73661,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,0)
    <=> v130074(VarCurr) ) ).

tff(addAssignment_73660,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,1)
    <=> v130073(VarCurr) ) ).

tff(addAssignment_73659,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,2)
    <=> v130072(VarCurr) ) ).

tff(addAssignment_73658,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,3)
    <=> v130071(VarCurr) ) ).

tff(addAssignment_73657,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,4)
    <=> v130070(VarCurr) ) ).

tff(addAssignment_73656,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,5)
    <=> v130069(VarCurr) ) ).

tff(addAssignment_73655,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,6)
    <=> v130068(VarCurr) ) ).

tff(addAssignment_73654,axiom,
    ! [VarCurr: state_type] :
      ( v130066(VarCurr,7)
    <=> v130067(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1642,axiom,
    ! [VarCurr: state_type] :
      ( v130074(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1641,axiom,
    ! [VarCurr: state_type] :
      ( v130073(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1640,axiom,
    ! [VarCurr: state_type] :
      ( v130072(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1639,axiom,
    ! [VarCurr: state_type] :
      ( v130071(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1638,axiom,
    ! [VarCurr: state_type] :
      ( v130070(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1637,axiom,
    ! [VarCurr: state_type] :
      ( v130069(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1636,axiom,
    ! [VarCurr: state_type] :
      ( v130068(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1635,axiom,
    ! [VarCurr: state_type] :
      ( v130067(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73653,axiom,
    ! [VarCurr: state_type] :
      ( v130054(VarCurr,0)
    <=> v130055(VarCurr,0) ) ).

tff(addAssignment_73652,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,0)
    <=> v130063(VarCurr) ) ).

tff(addAssignment_73651,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,1)
    <=> v130062(VarCurr) ) ).

tff(addAssignment_73650,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,2)
    <=> v130061(VarCurr) ) ).

tff(addAssignment_73649,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,3)
    <=> v130060(VarCurr) ) ).

tff(addAssignment_73648,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,4)
    <=> v130059(VarCurr) ) ).

tff(addAssignment_73647,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,5)
    <=> v130058(VarCurr) ) ).

tff(addAssignment_73646,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,6)
    <=> v130057(VarCurr) ) ).

tff(addAssignment_73645,axiom,
    ! [VarCurr: state_type] :
      ( v130055(VarCurr,7)
    <=> v130056(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1634,axiom,
    ! [VarCurr: state_type] :
      ( v130063(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1633,axiom,
    ! [VarCurr: state_type] :
      ( v130062(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1632,axiom,
    ! [VarCurr: state_type] :
      ( v130061(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1631,axiom,
    ! [VarCurr: state_type] :
      ( v130060(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1630,axiom,
    ! [VarCurr: state_type] :
      ( v130059(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1629,axiom,
    ! [VarCurr: state_type] :
      ( v130058(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1628,axiom,
    ! [VarCurr: state_type] :
      ( v130057(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1627,axiom,
    ! [VarCurr: state_type] :
      ( v130056(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73644,axiom,
    ! [VarCurr: state_type] :
      ( v130036(VarCurr)
    <=> v130038(VarCurr) ) ).

tff(addAssignment_73643,axiom,
    ! [VarCurr: state_type] :
      ( v130038(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_73642,axiom,
    ! [VarCurr: state_type] :
      ( v130032(VarCurr)
    <=> v130034(VarCurr) ) ).

tff(addAssignment_73641,axiom,
    ! [VarCurr: state_type] :
      ( v130034(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_73640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89419(VarCurr,B)
      <=> v89421(VarCurr,B) ) ) ).

tff(addAssignment_73639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89421(VarCurr,B)
      <=> v89423(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130009(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v89423(VarNext,B)
            <=> v89423(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1717,axiom,
    ! [VarNext: state_type] :
      ( v130009(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v89423(VarNext,B)
          <=> v130019(VarNext,B) ) ) ) ).

tff(addAssignment_73638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130019(VarNext,B)
          <=> v130017(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130017(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1302,axiom,
    ! [VarCurr: state_type] :
      ( v130020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v130017(VarCurr,B)
          <=> v89433(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16880,axiom,
    ! [VarCurr: state_type] :
      ( v130020(VarCurr)
    <=> ( v130021(VarCurr)
        & v130022(VarCurr) ) ) ).

tff(writeUnaryOperator_9442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130022(VarCurr)
    <=> v89429(VarCurr) ) ).

tff(writeUnaryOperator_9441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v130021(VarCurr)
    <=> v89425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130009(VarNext)
      <=> v130010(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130010(VarNext)
      <=> ( v130011(VarNext)
          & v130004(VarNext) ) ) ) ).

tff(writeUnaryOperator_9440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v130011(VarNext)
      <=> v130013(VarNext) ) ) ).

tff(addAssignment_73637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v130013(VarNext)
      <=> v130004(VarCurr) ) ) ).

tff(addAssignment_73636,axiom,
    ! [VarCurr: state_type] :
      ( v130004(VarCurr)
    <=> v130006(VarCurr) ) ).

tff(addAssignment_73635,axiom,
    ! [VarCurr: state_type] :
      ( v130006(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_73634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89433(VarCurr,B)
      <=> v89435(VarCurr,B) ) ) ).

tff(addAssignment_73633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89435(VarCurr,B)
      <=> v89437(VarCurr,B) ) ) ).

tff(addAssignment_73632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89437(VarCurr,B)
      <=> v89439(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129972(VarCurr)
     => ( v89439(VarCurr,7)
      <=> v130002(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_149,axiom,
    ! [VarCurr: state_type] :
      ( v129972(VarCurr)
     => ( v89439(VarCurr,7)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,7)
     => ( v130002(VarCurr)
      <=> v89419(VarCurr,7) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1301,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,7)
     => ( v130002(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129956(VarCurr)
     => ( v89439(VarCurr,6)
      <=> v130000(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_148,axiom,
    ! [VarCurr: state_type] :
      ( v129956(VarCurr)
     => ( v89439(VarCurr,6)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,6)
     => ( v130000(VarCurr)
      <=> v89419(VarCurr,6) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1300,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,6)
     => ( v130000(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129940(VarCurr)
     => ( v89439(VarCurr,5)
      <=> v129998(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_147,axiom,
    ! [VarCurr: state_type] :
      ( v129940(VarCurr)
     => ( v89439(VarCurr,5)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,5)
     => ( v129998(VarCurr)
      <=> v89419(VarCurr,5) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1299,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,5)
     => ( v129998(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129924(VarCurr)
     => ( v89439(VarCurr,4)
      <=> v129996(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_146,axiom,
    ! [VarCurr: state_type] :
      ( v129924(VarCurr)
     => ( v89439(VarCurr,4)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,4)
     => ( v129996(VarCurr)
      <=> v89419(VarCurr,4) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1298,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,4)
     => ( v129996(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129908(VarCurr)
     => ( v89439(VarCurr,3)
      <=> v129994(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_145,axiom,
    ! [VarCurr: state_type] :
      ( v129908(VarCurr)
     => ( v89439(VarCurr,3)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,3)
     => ( v129994(VarCurr)
      <=> v89419(VarCurr,3) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1297,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,3)
     => ( v129994(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129892(VarCurr)
     => ( v89439(VarCurr,2)
      <=> v129992(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_144,axiom,
    ! [VarCurr: state_type] :
      ( v129892(VarCurr)
     => ( v89439(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,2)
     => ( v129992(VarCurr)
      <=> v89419(VarCurr,2) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1296,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,2)
     => ( v129992(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129877(VarCurr)
     => ( v89439(VarCurr,1)
      <=> v129990(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_143,axiom,
    ! [VarCurr: state_type] :
      ( v129877(VarCurr)
     => ( v89439(VarCurr,1)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,1)
     => ( v129990(VarCurr)
      <=> v89419(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1295,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,1)
     => ( v129990(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89441(VarCurr)
     => ( v89439(VarCurr,0)
      <=> v129988(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1294,axiom,
    ! [VarCurr: state_type] :
      ( v89441(VarCurr)
     => ( v89439(VarCurr,0)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89515(VarCurr,0)
     => ( v129988(VarCurr)
      <=> v89419(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1293,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,0)
     => ( v129988(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_73631,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,7)
    <=> v89517(VarCurr,7) ) ).

tff(addAssignment_73630,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,7)
    <=> v89519(VarCurr,7) ) ).

tff(addAssignment_73629,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,7)
    <=> v89521(VarCurr,7) ) ).

tff(addAssignment_73628,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,7)
    <=> v129874(VarCurr,7) ) ).

tff(addAssignment_73627,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,7)
    <=> v129873(VarCurr,7) ) ).

tff(addAssignment_73626,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,7)
    <=> v129854(VarCurr,7) ) ).

tff(addAssignment_73625,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,7)
    <=> v129845(VarCurr,7) ) ).

tff(addAssignment_73624,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,7)
    <=> v129834(VarCurr,7) ) ).

tff(addAssignment_73623,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,7)
    <=> v129774(VarCurr,7) ) ).

tff(addAssignment_73622,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,7)
    <=> v89582(VarCurr,7) ) ).

tff(addAssignment_73621,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,7)
    <=> v89584(VarCurr,7) ) ).

tff(addAssignment_73620,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,7)
    <=> v129980(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129981(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129980(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1716,axiom,
    ! [VarNext: state_type] :
      ( v129981(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129980(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129981(VarNext)
      <=> v129982(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129982(VarNext)
      <=> ( v129984(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129984(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73619,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,7)
    <=> v89604(VarCurr,7) ) ).

tff(addAssignment_73618,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,7)
    <=> v97153(VarCurr,7) ) ).

tff(addAssignment_73617,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,7)
    <=> v89607(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16875,axiom,
    ! [VarCurr: state_type] :
      ( v129972(VarCurr)
    <=> ( v129974(VarCurr)
        & v129978(VarCurr) ) ) ).

tff(writeUnaryOperator_9438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129978(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16874,axiom,
    ! [VarCurr: state_type] :
      ( v129974(VarCurr)
    <=> ( v129975(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16873,axiom,
    ! [VarCurr: state_type] :
      ( v129975(VarCurr)
    <=> ( v129976(VarCurr)
        & v129977(VarCurr) ) ) ).

tff(addAssignment_73616,axiom,
    ! [VarCurr: state_type] :
      ( v129977(VarCurr)
    <=> v99261(VarCurr) ) ).

tff(writeUnaryOperator_9437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129976(VarCurr)
    <=> v89419(VarCurr,7) ) ).

tff(addAssignment_73615,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,6)
    <=> v89517(VarCurr,6) ) ).

tff(addAssignment_73614,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,6)
    <=> v89519(VarCurr,6) ) ).

tff(addAssignment_73613,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,6)
    <=> v89521(VarCurr,6) ) ).

tff(addAssignment_73612,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,6)
    <=> v129874(VarCurr,6) ) ).

tff(addAssignment_73611,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,6)
    <=> v129873(VarCurr,6) ) ).

tff(addAssignment_73610,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,6)
    <=> v129854(VarCurr,6) ) ).

tff(addAssignment_73609,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,6)
    <=> v129845(VarCurr,6) ) ).

tff(addAssignment_73608,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,6)
    <=> v129834(VarCurr,6) ) ).

tff(addAssignment_73607,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,6)
    <=> v129774(VarCurr,6) ) ).

tff(addAssignment_73606,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,6)
    <=> v89582(VarCurr,6) ) ).

tff(addAssignment_73605,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,6)
    <=> v89584(VarCurr,6) ) ).

tff(addAssignment_73604,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,6)
    <=> v129964(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129965(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129964(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1715,axiom,
    ! [VarNext: state_type] :
      ( v129965(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129964(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129965(VarNext)
      <=> v129966(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129966(VarNext)
      <=> ( v129968(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129968(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73603,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,6)
    <=> v89604(VarCurr,6) ) ).

tff(addAssignment_73602,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,6)
    <=> v97153(VarCurr,6) ) ).

tff(addAssignment_73601,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,6)
    <=> v89607(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16870,axiom,
    ! [VarCurr: state_type] :
      ( v129956(VarCurr)
    <=> ( v129958(VarCurr)
        & v129962(VarCurr) ) ) ).

tff(writeUnaryOperator_9435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129962(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16869,axiom,
    ! [VarCurr: state_type] :
      ( v129958(VarCurr)
    <=> ( v129959(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16868,axiom,
    ! [VarCurr: state_type] :
      ( v129959(VarCurr)
    <=> ( v129960(VarCurr)
        & v129961(VarCurr) ) ) ).

tff(addAssignment_73600,axiom,
    ! [VarCurr: state_type] :
      ( v129961(VarCurr)
    <=> v99262(VarCurr) ) ).

tff(writeUnaryOperator_9434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129960(VarCurr)
    <=> v89419(VarCurr,6) ) ).

tff(addAssignment_73599,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,5)
    <=> v89517(VarCurr,5) ) ).

tff(addAssignment_73598,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,5)
    <=> v89519(VarCurr,5) ) ).

tff(addAssignment_73597,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,5)
    <=> v89521(VarCurr,5) ) ).

tff(addAssignment_73596,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,5)
    <=> v129874(VarCurr,5) ) ).

tff(addAssignment_73595,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,5)
    <=> v129873(VarCurr,5) ) ).

tff(addAssignment_73594,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,5)
    <=> v129854(VarCurr,5) ) ).

tff(addAssignment_73593,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,5)
    <=> v129845(VarCurr,5) ) ).

tff(addAssignment_73592,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,5)
    <=> v129834(VarCurr,5) ) ).

tff(addAssignment_73591,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,5)
    <=> v129774(VarCurr,5) ) ).

tff(addAssignment_73590,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,5)
    <=> v89582(VarCurr,5) ) ).

tff(addAssignment_73589,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,5)
    <=> v89584(VarCurr,5) ) ).

tff(addAssignment_73588,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,5)
    <=> v129948(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129949(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129948(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1714,axiom,
    ! [VarNext: state_type] :
      ( v129949(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129948(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129949(VarNext)
      <=> v129950(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129950(VarNext)
      <=> ( v129952(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129952(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73587,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,5)
    <=> v89604(VarCurr,5) ) ).

tff(addAssignment_73586,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,5)
    <=> v97153(VarCurr,5) ) ).

tff(addAssignment_73585,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,5)
    <=> v89607(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16865,axiom,
    ! [VarCurr: state_type] :
      ( v129940(VarCurr)
    <=> ( v129942(VarCurr)
        & v129946(VarCurr) ) ) ).

tff(writeUnaryOperator_9432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129946(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16864,axiom,
    ! [VarCurr: state_type] :
      ( v129942(VarCurr)
    <=> ( v129943(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16863,axiom,
    ! [VarCurr: state_type] :
      ( v129943(VarCurr)
    <=> ( v129944(VarCurr)
        & v129945(VarCurr) ) ) ).

tff(addAssignment_73584,axiom,
    ! [VarCurr: state_type] :
      ( v129945(VarCurr)
    <=> v99263(VarCurr) ) ).

tff(writeUnaryOperator_9431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129944(VarCurr)
    <=> v89419(VarCurr,5) ) ).

tff(addAssignment_73583,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,4)
    <=> v89517(VarCurr,4) ) ).

tff(addAssignment_73582,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,4)
    <=> v89519(VarCurr,4) ) ).

tff(addAssignment_73581,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,4)
    <=> v89521(VarCurr,4) ) ).

tff(addAssignment_73580,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,4)
    <=> v129874(VarCurr,4) ) ).

tff(addAssignment_73579,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,4)
    <=> v129873(VarCurr,4) ) ).

tff(addAssignment_73578,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,4)
    <=> v129854(VarCurr,4) ) ).

tff(addAssignment_73577,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,4)
    <=> v129845(VarCurr,4) ) ).

tff(addAssignment_73576,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,4)
    <=> v129834(VarCurr,4) ) ).

tff(addAssignment_73575,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,4)
    <=> v129774(VarCurr,4) ) ).

tff(addAssignment_73574,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,4)
    <=> v89582(VarCurr,4) ) ).

tff(addAssignment_73573,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,4)
    <=> v89584(VarCurr,4) ) ).

tff(addAssignment_73572,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,4)
    <=> v129932(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129933(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129932(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1713,axiom,
    ! [VarNext: state_type] :
      ( v129933(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129932(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129933(VarNext)
      <=> v129934(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129934(VarNext)
      <=> ( v129936(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129936(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73571,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,4)
    <=> v89604(VarCurr,4) ) ).

tff(addAssignment_73570,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,4)
    <=> v97153(VarCurr,4) ) ).

tff(addAssignment_73569,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,4)
    <=> v89607(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16860,axiom,
    ! [VarCurr: state_type] :
      ( v129924(VarCurr)
    <=> ( v129926(VarCurr)
        & v129930(VarCurr) ) ) ).

tff(writeUnaryOperator_9429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129930(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16859,axiom,
    ! [VarCurr: state_type] :
      ( v129926(VarCurr)
    <=> ( v129927(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16858,axiom,
    ! [VarCurr: state_type] :
      ( v129927(VarCurr)
    <=> ( v129928(VarCurr)
        & v129929(VarCurr) ) ) ).

tff(addAssignment_73568,axiom,
    ! [VarCurr: state_type] :
      ( v129929(VarCurr)
    <=> v99264(VarCurr) ) ).

tff(writeUnaryOperator_9428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129928(VarCurr)
    <=> v89419(VarCurr,4) ) ).

tff(addAssignment_73567,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,3)
    <=> v89517(VarCurr,3) ) ).

tff(addAssignment_73566,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,3)
    <=> v89519(VarCurr,3) ) ).

tff(addAssignment_73565,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,3)
    <=> v89521(VarCurr,3) ) ).

tff(addAssignment_73564,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,3)
    <=> v129874(VarCurr,3) ) ).

tff(addAssignment_73563,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,3)
    <=> v129873(VarCurr,3) ) ).

tff(addAssignment_73562,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,3)
    <=> v129854(VarCurr,3) ) ).

tff(addAssignment_73561,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,3)
    <=> v129845(VarCurr,3) ) ).

tff(addAssignment_73560,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,3)
    <=> v129834(VarCurr,3) ) ).

tff(addAssignment_73559,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,3)
    <=> v129774(VarCurr,3) ) ).

tff(addAssignment_73558,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,3)
    <=> v89582(VarCurr,3) ) ).

tff(addAssignment_73557,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,3)
    <=> v89584(VarCurr,3) ) ).

tff(addAssignment_73556,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,3)
    <=> v129916(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129917(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129916(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1712,axiom,
    ! [VarNext: state_type] :
      ( v129917(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129916(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129917(VarNext)
      <=> v129918(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129918(VarNext)
      <=> ( v129920(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129920(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73555,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,3)
    <=> v89604(VarCurr,3) ) ).

tff(addAssignment_73554,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,3)
    <=> v97153(VarCurr,3) ) ).

tff(addAssignment_73553,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,3)
    <=> v89607(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16855,axiom,
    ! [VarCurr: state_type] :
      ( v129908(VarCurr)
    <=> ( v129910(VarCurr)
        & v129914(VarCurr) ) ) ).

tff(writeUnaryOperator_9426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129914(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16854,axiom,
    ! [VarCurr: state_type] :
      ( v129910(VarCurr)
    <=> ( v129911(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16853,axiom,
    ! [VarCurr: state_type] :
      ( v129911(VarCurr)
    <=> ( v129912(VarCurr)
        & v129913(VarCurr) ) ) ).

tff(addAssignment_73552,axiom,
    ! [VarCurr: state_type] :
      ( v129913(VarCurr)
    <=> v99265(VarCurr) ) ).

tff(writeUnaryOperator_9425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129912(VarCurr)
    <=> v89419(VarCurr,3) ) ).

tff(addAssignment_73551,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,2)
    <=> v89517(VarCurr,2) ) ).

tff(addAssignment_73550,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,2)
    <=> v89519(VarCurr,2) ) ).

tff(addAssignment_73549,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,2)
    <=> v89521(VarCurr,2) ) ).

tff(addAssignment_73548,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,2)
    <=> v129874(VarCurr,2) ) ).

tff(addAssignment_73547,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,2)
    <=> v129873(VarCurr,2) ) ).

tff(addAssignment_73546,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,2)
    <=> v129854(VarCurr,2) ) ).

tff(addAssignment_73545,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,2)
    <=> v129845(VarCurr,2) ) ).

tff(addAssignment_73544,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,2)
    <=> v129834(VarCurr,2) ) ).

tff(addAssignment_73543,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,2)
    <=> v129774(VarCurr,2) ) ).

tff(addAssignment_73542,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,2)
    <=> v89582(VarCurr,2) ) ).

tff(addAssignment_73541,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,2)
    <=> v89584(VarCurr,2) ) ).

tff(addAssignment_73540,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,2)
    <=> v129900(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129901(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129900(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1711,axiom,
    ! [VarNext: state_type] :
      ( v129901(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129900(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129901(VarNext)
      <=> v129902(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16851,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129902(VarNext)
      <=> ( v129904(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129904(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73539,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,2)
    <=> v89604(VarCurr,2) ) ).

tff(addAssignment_73538,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,2)
    <=> v97153(VarCurr,2) ) ).

tff(addAssignment_73537,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,2)
    <=> v89607(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16850,axiom,
    ! [VarCurr: state_type] :
      ( v129892(VarCurr)
    <=> ( v129894(VarCurr)
        & v129898(VarCurr) ) ) ).

tff(writeUnaryOperator_9423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129898(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16849,axiom,
    ! [VarCurr: state_type] :
      ( v129894(VarCurr)
    <=> ( v129895(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16848,axiom,
    ! [VarCurr: state_type] :
      ( v129895(VarCurr)
    <=> ( v129896(VarCurr)
        & v129897(VarCurr) ) ) ).

tff(addAssignment_73536,axiom,
    ! [VarCurr: state_type] :
      ( v129897(VarCurr)
    <=> v99266(VarCurr) ) ).

tff(writeUnaryOperator_9422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129896(VarCurr)
    <=> v89419(VarCurr,2) ) ).

tff(addAssignment_73535,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,1)
    <=> v89517(VarCurr,1) ) ).

tff(addAssignment_73534,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,1)
    <=> v89519(VarCurr,1) ) ).

tff(addAssignment_73533,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,1)
    <=> v89521(VarCurr,1) ) ).

tff(addAssignment_73532,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,1)
    <=> v129874(VarCurr,1) ) ).

tff(addAssignment_73531,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,1)
    <=> v129873(VarCurr,1) ) ).

tff(addAssignment_73530,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,1)
    <=> v129854(VarCurr,1) ) ).

tff(addAssignment_73529,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,1)
    <=> v129845(VarCurr,1) ) ).

tff(addAssignment_73528,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,1)
    <=> v129834(VarCurr,1) ) ).

tff(addAssignment_73527,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,1)
    <=> v129774(VarCurr,1) ) ).

tff(addAssignment_73526,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,1)
    <=> v89582(VarCurr,1) ) ).

tff(addAssignment_73525,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,1)
    <=> v89584(VarCurr,1) ) ).

tff(addAssignment_73524,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,1)
    <=> v129884(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129885(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v129884(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1710,axiom,
    ! [VarNext: state_type] :
      ( v129885(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v129884(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129885(VarNext)
      <=> v129886(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129886(VarNext)
      <=> ( v129888(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_9421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129888(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_73523,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,1)
    <=> v89604(VarCurr,1) ) ).

tff(addAssignment_73522,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,1)
    <=> v97153(VarCurr,1) ) ).

tff(addAssignment_73521,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,1)
    <=> v89607(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16845,axiom,
    ! [VarCurr: state_type] :
      ( v129877(VarCurr)
    <=> ( v129879(VarCurr)
        & v129882(VarCurr) ) ) ).

tff(writeUnaryOperator_9420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129882(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16844,axiom,
    ! [VarCurr: state_type] :
      ( v129879(VarCurr)
    <=> ( v129880(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16843,axiom,
    ! [VarCurr: state_type] :
      ( v129880(VarCurr)
    <=> ( v129881(VarCurr)
        & v89419(VarCurr,0) ) ) ).

tff(writeUnaryOperator_9419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129881(VarCurr)
    <=> v89419(VarCurr,1) ) ).

tff(addAssignment_73520,axiom,
    ! [VarCurr: state_type] :
      ( v89515(VarCurr,0)
    <=> v89517(VarCurr,0) ) ).

tff(addAssignment_73519,axiom,
    ! [VarCurr: state_type] :
      ( v89517(VarCurr,0)
    <=> v89519(VarCurr,0) ) ).

tff(addAssignment_73518,axiom,
    ! [VarCurr: state_type] :
      ( v89519(VarCurr,0)
    <=> v89521(VarCurr,0) ) ).

tff(addAssignment_73517,axiom,
    ! [VarCurr: state_type] :
      ( v89521(VarCurr,0)
    <=> v129874(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v129874(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1292,axiom,
    ! [VarCurr: state_type] :
      ( v129875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v129874(VarCurr,B)
          <=> v89578(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16842,axiom,
    ! [VarCurr: state_type] :
      ( v129875(VarCurr)
    <=> ( v4093(VarCurr)
        | v89523(VarCurr) ) ) ).

tff(addAssignment_73516,axiom,
    ! [VarCurr: state_type] :
      ( v89578(VarCurr,0)
    <=> v129873(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129873(VarCurr,B)
      <=> ( v89580(VarCurr,B)
          | v97182(VarCurr,B) ) ) ) ).

tff(addAssignment_73515,axiom,
    ! [VarCurr: state_type] :
      ( v97182(VarCurr,0)
    <=> v129854(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129854(VarCurr,B)
      <=> ( v129855(VarCurr,B)
          | v129868(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129868(VarCurr,B)
      <=> ( v129869(VarCurr,B)
          & v129844(VarCurr,B) ) ) ) ).

tff(addAssignment_73514,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,0)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73513,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,1)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73512,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,2)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73511,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,3)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73510,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,4)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73509,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,5)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73508,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,6)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73507,axiom,
    ! [VarCurr: state_type] :
      ( v129869(VarCurr,7)
    <=> v129870(VarCurr) ) ).

tff(addAssignment_73506,axiom,
    ! [VarCurr: state_type] :
      ( v129870(VarCurr)
    <=> v129871(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16841,axiom,
    ! [VarCurr: state_type] :
      ( v129871(VarCurr)
    <=> ( v129872(VarCurr)
        & v100734(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5931,axiom,
    ! [VarCurr: state_type] :
      ( v129872(VarCurr)
    <=> ( v97411(VarCurr,15)
        & v4093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129855(VarCurr,B)
      <=> ( v129856(VarCurr,B)
          | v129862(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129862(VarCurr,B)
      <=> ( v129863(VarCurr,B)
          & v129833(VarCurr,B) ) ) ) ).

tff(addAssignment_73505,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,0)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73504,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,1)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73503,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,2)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73502,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,3)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73501,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,4)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73500,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,5)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73499,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,6)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73498,axiom,
    ! [VarCurr: state_type] :
      ( v129863(VarCurr,7)
    <=> v129864(VarCurr) ) ).

tff(addAssignment_73497,axiom,
    ! [VarCurr: state_type] :
      ( v129864(VarCurr)
    <=> v129865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16840,axiom,
    ! [VarCurr: state_type] :
      ( v129865(VarCurr)
    <=> ( v129866(VarCurr)
        & v129867(VarCurr) ) ) ).

tff(writeUnaryOperator_9418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129867(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5930,axiom,
    ! [VarCurr: state_type] :
      ( v129866(VarCurr)
    <=> ( v129784(VarCurr,15)
        & v129767(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v129856(VarCurr,B)
      <=> ( v129857(VarCurr,B)
          & v129773(VarCurr,B) ) ) ) ).

tff(addAssignment_73496,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,0)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73495,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,1)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73494,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,2)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73493,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,3)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73492,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,4)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73491,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,5)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73490,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,6)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73489,axiom,
    ! [VarCurr: state_type] :
      ( v129857(VarCurr,7)
    <=> v129858(VarCurr) ) ).

tff(addAssignment_73488,axiom,
    ! [VarCurr: state_type] :
      ( v129858(VarCurr)
    <=> v129859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16839,axiom,
    ! [VarCurr: state_type] :
      ( v129859(VarCurr)
    <=> ( v129860(VarCurr)
        & v129861(VarCurr) ) ) ).

tff(writeUnaryOperator_9417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129861(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5929,axiom,
    ! [VarCurr: state_type] :
      ( v129860(VarCurr)
    <=> ( v97184(VarCurr,15)
        & v129767(VarCurr,0) ) ) ).

tff(addAssignment_73487,axiom,
    ! [VarCurr: state_type] :
      ( v129844(VarCurr,0)
    <=> v129845(VarCurr,0) ) ).

tff(addAssignment_73486,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,0)
    <=> v129853(VarCurr) ) ).

tff(addAssignment_73485,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,1)
    <=> v129852(VarCurr) ) ).

tff(addAssignment_73484,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,2)
    <=> v129851(VarCurr) ) ).

tff(addAssignment_73483,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,3)
    <=> v129850(VarCurr) ) ).

tff(addAssignment_73482,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,4)
    <=> v129849(VarCurr) ) ).

tff(addAssignment_73481,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,5)
    <=> v129848(VarCurr) ) ).

tff(addAssignment_73480,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,6)
    <=> v129847(VarCurr) ) ).

tff(addAssignment_73479,axiom,
    ! [VarCurr: state_type] :
      ( v129845(VarCurr,7)
    <=> v129846(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1626,axiom,
    ! [VarCurr: state_type] :
      ( v129853(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $false )
        & ( v97411(VarCurr,10)
        <=> $false )
        & ( v97411(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1625,axiom,
    ! [VarCurr: state_type] :
      ( v129852(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $false )
        & ( v97411(VarCurr,10)
        <=> $false )
        & ( v97411(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1624,axiom,
    ! [VarCurr: state_type] :
      ( v129851(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $false )
        & ( v97411(VarCurr,10)
        <=> $true )
        & ( v97411(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1623,axiom,
    ! [VarCurr: state_type] :
      ( v129850(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $false )
        & ( v97411(VarCurr,10)
        <=> $true )
        & ( v97411(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1622,axiom,
    ! [VarCurr: state_type] :
      ( v129849(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $true )
        & ( v97411(VarCurr,10)
        <=> $false )
        & ( v97411(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1621,axiom,
    ! [VarCurr: state_type] :
      ( v129848(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $true )
        & ( v97411(VarCurr,10)
        <=> $false )
        & ( v97411(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1620,axiom,
    ! [VarCurr: state_type] :
      ( v129847(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $true )
        & ( v97411(VarCurr,10)
        <=> $true )
        & ( v97411(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1619,axiom,
    ! [VarCurr: state_type] :
      ( v129846(VarCurr)
    <=> ( ( v97411(VarCurr,11)
        <=> $true )
        & ( v97411(VarCurr,10)
        <=> $true )
        & ( v97411(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73478,axiom,
    ! [VarCurr: state_type] :
      ( v129833(VarCurr,0)
    <=> v129834(VarCurr,0) ) ).

tff(addAssignment_73477,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,0)
    <=> v129842(VarCurr) ) ).

tff(addAssignment_73476,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,1)
    <=> v129841(VarCurr) ) ).

tff(addAssignment_73475,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,2)
    <=> v129840(VarCurr) ) ).

tff(addAssignment_73474,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,3)
    <=> v129839(VarCurr) ) ).

tff(addAssignment_73473,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,4)
    <=> v129838(VarCurr) ) ).

tff(addAssignment_73472,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,5)
    <=> v129837(VarCurr) ) ).

tff(addAssignment_73471,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,6)
    <=> v129836(VarCurr) ) ).

tff(addAssignment_73470,axiom,
    ! [VarCurr: state_type] :
      ( v129834(VarCurr,7)
    <=> v129835(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1618,axiom,
    ! [VarCurr: state_type] :
      ( v129842(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $false )
        & ( v129784(VarCurr,10)
        <=> $false )
        & ( v129784(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1617,axiom,
    ! [VarCurr: state_type] :
      ( v129841(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $false )
        & ( v129784(VarCurr,10)
        <=> $false )
        & ( v129784(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1616,axiom,
    ! [VarCurr: state_type] :
      ( v129840(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $false )
        & ( v129784(VarCurr,10)
        <=> $true )
        & ( v129784(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1615,axiom,
    ! [VarCurr: state_type] :
      ( v129839(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $false )
        & ( v129784(VarCurr,10)
        <=> $true )
        & ( v129784(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1614,axiom,
    ! [VarCurr: state_type] :
      ( v129838(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $true )
        & ( v129784(VarCurr,10)
        <=> $false )
        & ( v129784(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1613,axiom,
    ! [VarCurr: state_type] :
      ( v129837(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $true )
        & ( v129784(VarCurr,10)
        <=> $false )
        & ( v129784(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1612,axiom,
    ! [VarCurr: state_type] :
      ( v129836(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $true )
        & ( v129784(VarCurr,10)
        <=> $true )
        & ( v129784(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1611,axiom,
    ! [VarCurr: state_type] :
      ( v129835(VarCurr)
    <=> ( ( v129784(VarCurr,11)
        <=> $true )
        & ( v129784(VarCurr,10)
        <=> $true )
        & ( v129784(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v129784(VarCurr,B)
      <=> v129785(VarCurr,B) ) ) ).

tff(addAssignment_73468,axiom,
    ! [VarCurr: state_type] :
      ( v129767(VarCurr,1)
    <=> v129768(VarCurr,1) ) ).

tff(addAssignment_73467,axiom,
    ! [VarCurr: state_type] :
      ( v129784(VarCurr,15)
    <=> v129785(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129785(VarCurr,B)
      <=> ( v129786(VarCurr,B)
          | v129830(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129830(VarCurr,B)
      <=> ( v129831(VarCurr,B)
          & v97413(VarCurr,B) ) ) ) ).

tff(addAssignment_73466,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,0)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73465,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,1)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73464,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,2)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73463,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,3)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73462,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,4)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73461,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,5)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73460,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,6)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73459,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,7)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73458,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,8)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73457,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,9)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73456,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,10)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73455,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,11)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73454,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,12)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73453,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,13)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73452,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,14)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73451,axiom,
    ! [VarCurr: state_type] :
      ( v129831(VarCurr,15)
    <=> v129765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129786(VarCurr,B)
      <=> ( v129787(VarCurr,B)
          | v129828(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129828(VarCurr,B)
      <=> ( v129829(VarCurr,B)
          & v98301(VarCurr,B) ) ) ) ).

tff(addAssignment_73450,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,0)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73449,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,1)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73448,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,2)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73447,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,3)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73446,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,4)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73445,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,5)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73444,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,6)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73443,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,7)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73442,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,8)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73441,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,9)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73440,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,10)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73439,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,11)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73438,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,12)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73437,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,13)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73436,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,14)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73435,axiom,
    ! [VarCurr: state_type] :
      ( v129829(VarCurr,15)
    <=> v129762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129787(VarCurr,B)
      <=> ( v129788(VarCurr,B)
          | v129826(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129826(VarCurr,B)
      <=> ( v129827(VarCurr,B)
          & v98245(VarCurr,B) ) ) ) ).

tff(addAssignment_73434,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,0)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73433,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,1)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73432,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,2)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73431,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,3)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73430,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,4)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73429,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,5)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73428,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,6)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73427,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,7)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73426,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,8)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73425,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,9)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73424,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,10)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73423,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,11)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73422,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,12)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73421,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,13)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73420,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,14)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73419,axiom,
    ! [VarCurr: state_type] :
      ( v129827(VarCurr,15)
    <=> v129759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129788(VarCurr,B)
      <=> ( v129789(VarCurr,B)
          | v129824(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129824(VarCurr,B)
      <=> ( v129825(VarCurr,B)
          & v98189(VarCurr,B) ) ) ) ).

tff(addAssignment_73418,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,0)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73417,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,1)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73416,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,2)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73415,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,3)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73414,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,4)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73413,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,5)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73412,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,6)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73411,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,7)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73410,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,8)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73409,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,9)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73408,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,10)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73407,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,11)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73406,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,12)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73405,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,13)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73404,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,14)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73403,axiom,
    ! [VarCurr: state_type] :
      ( v129825(VarCurr,15)
    <=> v129756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129789(VarCurr,B)
      <=> ( v129790(VarCurr,B)
          | v129822(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129822(VarCurr,B)
      <=> ( v129823(VarCurr,B)
          & v98133(VarCurr,B) ) ) ) ).

tff(addAssignment_73402,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,0)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73401,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,1)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73400,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,2)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73399,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,3)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73398,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,4)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73397,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,5)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73396,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,6)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73395,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,7)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73394,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,8)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73393,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,9)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73392,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,10)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73391,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,11)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73390,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,12)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73389,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,13)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73388,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,14)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73387,axiom,
    ! [VarCurr: state_type] :
      ( v129823(VarCurr,15)
    <=> v129753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129790(VarCurr,B)
      <=> ( v129791(VarCurr,B)
          | v129820(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129820(VarCurr,B)
      <=> ( v129821(VarCurr,B)
          & v98077(VarCurr,B) ) ) ) ).

tff(addAssignment_73386,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,0)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73385,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,1)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73384,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,2)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73383,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,3)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73382,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,4)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73381,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,5)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73380,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,6)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73379,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,7)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73378,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,8)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73377,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,9)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73376,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,10)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73375,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,11)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73374,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,12)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73373,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,13)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73372,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,14)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73371,axiom,
    ! [VarCurr: state_type] :
      ( v129821(VarCurr,15)
    <=> v129750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129791(VarCurr,B)
      <=> ( v129792(VarCurr,B)
          | v129818(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129818(VarCurr,B)
      <=> ( v129819(VarCurr,B)
          & v98021(VarCurr,B) ) ) ) ).

tff(addAssignment_73370,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,0)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73369,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,1)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73368,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,2)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73367,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,3)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73366,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,4)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73365,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,5)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73364,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,6)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73363,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,7)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73362,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,8)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73361,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,9)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73360,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,10)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73359,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,11)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73358,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,12)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73357,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,13)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73356,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,14)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73355,axiom,
    ! [VarCurr: state_type] :
      ( v129819(VarCurr,15)
    <=> v129747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129792(VarCurr,B)
      <=> ( v129793(VarCurr,B)
          | v129816(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129816(VarCurr,B)
      <=> ( v129817(VarCurr,B)
          & v97965(VarCurr,B) ) ) ) ).

tff(addAssignment_73354,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,0)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73353,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,1)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73352,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,2)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73351,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,3)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73350,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,4)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73349,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,5)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73348,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,6)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73347,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,7)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73346,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,8)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73345,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,9)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73344,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,10)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73343,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,11)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73342,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,12)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73341,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,13)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73340,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,14)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73339,axiom,
    ! [VarCurr: state_type] :
      ( v129817(VarCurr,15)
    <=> v129744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129793(VarCurr,B)
      <=> ( v129794(VarCurr,B)
          | v129814(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129814(VarCurr,B)
      <=> ( v129815(VarCurr,B)
          & v97909(VarCurr,B) ) ) ) ).

tff(addAssignment_73338,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,0)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73337,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,1)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73336,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,2)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73335,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,3)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73334,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,4)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73333,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,5)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73332,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,6)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73331,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,7)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73330,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,8)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73329,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,9)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73328,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,10)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73327,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,11)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73326,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,12)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73325,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,13)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73324,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,14)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73323,axiom,
    ! [VarCurr: state_type] :
      ( v129815(VarCurr,15)
    <=> v129741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129794(VarCurr,B)
      <=> ( v129795(VarCurr,B)
          | v129812(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129812(VarCurr,B)
      <=> ( v129813(VarCurr,B)
          & v97853(VarCurr,B) ) ) ) ).

tff(addAssignment_73322,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,0)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73321,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,1)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73320,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,2)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73319,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,3)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73318,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,4)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73317,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,5)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73316,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,6)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73315,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,7)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73314,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,8)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73313,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,9)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73312,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,10)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73311,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,11)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73310,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,12)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73309,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,13)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73308,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,14)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73307,axiom,
    ! [VarCurr: state_type] :
      ( v129813(VarCurr,15)
    <=> v129738(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129795(VarCurr,B)
      <=> ( v129796(VarCurr,B)
          | v129810(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129810(VarCurr,B)
      <=> ( v129811(VarCurr,B)
          & v97797(VarCurr,B) ) ) ) ).

tff(addAssignment_73306,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,0)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73305,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,1)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73304,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,2)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73303,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,3)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73302,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,4)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73301,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,5)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73300,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,6)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73299,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,7)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73298,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,8)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73297,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,9)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73296,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,10)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73295,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,11)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73294,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,12)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73293,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,13)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73292,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,14)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73291,axiom,
    ! [VarCurr: state_type] :
      ( v129811(VarCurr,15)
    <=> v129735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129796(VarCurr,B)
      <=> ( v129797(VarCurr,B)
          | v129808(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129808(VarCurr,B)
      <=> ( v129809(VarCurr,B)
          & v97741(VarCurr,B) ) ) ) ).

tff(addAssignment_73290,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,0)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73289,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,1)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73288,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,2)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73287,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,3)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73286,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,4)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73285,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,5)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73284,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,6)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73283,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,7)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73282,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,8)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73281,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,9)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73280,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,10)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73279,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,11)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73278,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,12)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73277,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,13)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73276,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,14)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73275,axiom,
    ! [VarCurr: state_type] :
      ( v129809(VarCurr,15)
    <=> v129732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129797(VarCurr,B)
      <=> ( v129798(VarCurr,B)
          | v129806(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129806(VarCurr,B)
      <=> ( v129807(VarCurr,B)
          & v97685(VarCurr,B) ) ) ) ).

tff(addAssignment_73274,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,0)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73273,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,1)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73272,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,2)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73271,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,3)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73270,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,4)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73269,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,5)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73268,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,6)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73267,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,7)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73266,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,8)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73265,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,9)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73264,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,10)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73263,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,11)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73262,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,12)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73261,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,13)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73260,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,14)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73259,axiom,
    ! [VarCurr: state_type] :
      ( v129807(VarCurr,15)
    <=> v129729(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129798(VarCurr,B)
      <=> ( v129799(VarCurr,B)
          | v129804(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129804(VarCurr,B)
      <=> ( v129805(VarCurr,B)
          & v97629(VarCurr,B) ) ) ) ).

tff(addAssignment_73258,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,0)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73257,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,1)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73256,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,2)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73255,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,3)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73254,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,4)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73253,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,5)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73252,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,6)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73251,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,7)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73250,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,8)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73249,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,9)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73248,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,10)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73247,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,11)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73246,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,12)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73245,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,13)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73244,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,14)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_73243,axiom,
    ! [VarCurr: state_type] :
      ( v129805(VarCurr,15)
    <=> v129726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129799(VarCurr,B)
      <=> ( v129800(VarCurr,B)
          | v129802(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129802(VarCurr,B)
      <=> ( v129803(VarCurr,B)
          & v97573(VarCurr,B) ) ) ) ).

tff(addAssignment_73242,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,0)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73241,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,1)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73240,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,2)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73239,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,3)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73238,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,4)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73237,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,5)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73236,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,6)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73235,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,7)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73234,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,8)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73233,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,9)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73232,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,10)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73231,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,11)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73230,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,12)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73229,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,13)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73228,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,14)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_73227,axiom,
    ! [VarCurr: state_type] :
      ( v129803(VarCurr,15)
    <=> v129723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129800(VarCurr,B)
      <=> ( v129801(VarCurr,B)
          & v97517(VarCurr,B) ) ) ) ).

tff(addAssignment_73226,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,0)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73225,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,1)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73224,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,2)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73223,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,3)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73222,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,4)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73221,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,5)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73220,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,6)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73219,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,7)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73218,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,8)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73217,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,9)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73216,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,10)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73215,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,11)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73214,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,12)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73213,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,13)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73212,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,14)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73211,axiom,
    ! [VarCurr: state_type] :
      ( v129801(VarCurr,15)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_73210,axiom,
    ! [VarCurr: state_type] :
      ( v129773(VarCurr,0)
    <=> v129774(VarCurr,0) ) ).

tff(addAssignment_73209,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,0)
    <=> v129782(VarCurr) ) ).

tff(addAssignment_73208,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,1)
    <=> v129781(VarCurr) ) ).

tff(addAssignment_73207,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,2)
    <=> v129780(VarCurr) ) ).

tff(addAssignment_73206,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,3)
    <=> v129779(VarCurr) ) ).

tff(addAssignment_73205,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,4)
    <=> v129778(VarCurr) ) ).

tff(addAssignment_73204,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,5)
    <=> v129777(VarCurr) ) ).

tff(addAssignment_73203,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,6)
    <=> v129776(VarCurr) ) ).

tff(addAssignment_73202,axiom,
    ! [VarCurr: state_type] :
      ( v129774(VarCurr,7)
    <=> v129775(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1610,axiom,
    ! [VarCurr: state_type] :
      ( v129782(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $false )
        & ( v97184(VarCurr,10)
        <=> $false )
        & ( v97184(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1609,axiom,
    ! [VarCurr: state_type] :
      ( v129781(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $false )
        & ( v97184(VarCurr,10)
        <=> $false )
        & ( v97184(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1608,axiom,
    ! [VarCurr: state_type] :
      ( v129780(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $false )
        & ( v97184(VarCurr,10)
        <=> $true )
        & ( v97184(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1607,axiom,
    ! [VarCurr: state_type] :
      ( v129779(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $false )
        & ( v97184(VarCurr,10)
        <=> $true )
        & ( v97184(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1606,axiom,
    ! [VarCurr: state_type] :
      ( v129778(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $true )
        & ( v97184(VarCurr,10)
        <=> $false )
        & ( v97184(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1605,axiom,
    ! [VarCurr: state_type] :
      ( v129777(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $true )
        & ( v97184(VarCurr,10)
        <=> $false )
        & ( v97184(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1604,axiom,
    ! [VarCurr: state_type] :
      ( v129776(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $true )
        & ( v97184(VarCurr,10)
        <=> $true )
        & ( v97184(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1603,axiom,
    ! [VarCurr: state_type] :
      ( v129775(VarCurr)
    <=> ( ( v97184(VarCurr,11)
        <=> $true )
        & ( v97184(VarCurr,10)
        <=> $true )
        & ( v97184(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_73201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97184(VarCurr,B)
      <=> v129703(VarCurr,B) ) ) ).

tff(addAssignment_73200,axiom,
    ! [VarCurr: state_type] :
      ( v129767(VarCurr,0)
    <=> v129768(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v129768(VarCurr,B)
          <=> v129769(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1291,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v129768(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_73199,axiom,
    ! [VarCurr: state_type] :
      ( v129769(VarCurr,0)
    <=> v129770(VarCurr) ) ).

tff(addAssignment_73198,axiom,
    ! [VarCurr: state_type] :
      ( v129769(VarCurr,1)
    <=> v100738(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5928,axiom,
    ! [VarCurr: state_type] :
      ( v129770(VarCurr)
    <=> ( v100738(VarCurr,0)
        | v100738(VarCurr,1) ) ) ).

tff(addAssignment_73197,axiom,
    ! [VarCurr: state_type] :
      ( v97184(VarCurr,15)
    <=> v129703(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129703(VarCurr,B)
      <=> ( v129704(VarCurr,B)
          | v129763(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129763(VarCurr,B)
      <=> ( v129764(VarCurr,B)
          & v98301(VarCurr,B) ) ) ) ).

tff(addAssignment_73196,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,0)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73195,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,1)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73194,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,2)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73193,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,3)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73192,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,4)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73191,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,5)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73190,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,6)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73189,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,7)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73188,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,8)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73187,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,9)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73186,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,10)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73185,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,11)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73184,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,12)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73183,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,13)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73182,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,14)
    <=> v129765(VarCurr) ) ).

tff(addAssignment_73181,axiom,
    ! [VarCurr: state_type] :
      ( v129764(VarCurr,15)
    <=> v129765(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1602,axiom,
    ! [VarCurr: state_type] :
      ( v129765(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129704(VarCurr,B)
      <=> ( v129705(VarCurr,B)
          | v129760(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129760(VarCurr,B)
      <=> ( v129761(VarCurr,B)
          & v98245(VarCurr,B) ) ) ) ).

tff(addAssignment_73180,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,0)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73179,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,1)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73178,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,2)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73177,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,3)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73176,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,4)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73175,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,5)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73174,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,6)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73173,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,7)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73172,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,8)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73171,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,9)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73170,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,10)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73169,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,11)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73168,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,12)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73167,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,13)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73166,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,14)
    <=> v129762(VarCurr) ) ).

tff(addAssignment_73165,axiom,
    ! [VarCurr: state_type] :
      ( v129761(VarCurr,15)
    <=> v129762(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1601,axiom,
    ! [VarCurr: state_type] :
      ( v129762(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129705(VarCurr,B)
      <=> ( v129706(VarCurr,B)
          | v129757(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129757(VarCurr,B)
      <=> ( v129758(VarCurr,B)
          & v98189(VarCurr,B) ) ) ) ).

tff(addAssignment_73164,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,0)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73163,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,1)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73162,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,2)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73161,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,3)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73160,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,4)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73159,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,5)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73158,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,6)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73157,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,7)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73156,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,8)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73155,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,9)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73154,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,10)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73153,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,11)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73152,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,12)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73151,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,13)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73150,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,14)
    <=> v129759(VarCurr) ) ).

tff(addAssignment_73149,axiom,
    ! [VarCurr: state_type] :
      ( v129758(VarCurr,15)
    <=> v129759(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1600,axiom,
    ! [VarCurr: state_type] :
      ( v129759(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129706(VarCurr,B)
      <=> ( v129707(VarCurr,B)
          | v129754(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1762,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129754(VarCurr,B)
      <=> ( v129755(VarCurr,B)
          & v98133(VarCurr,B) ) ) ) ).

tff(addAssignment_73148,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,0)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73147,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,1)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73146,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,2)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73145,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,3)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73144,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,4)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73143,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,5)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73142,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,6)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73141,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,7)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73140,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,8)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73139,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,9)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73138,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,10)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73137,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,11)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73136,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,12)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73135,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,13)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73134,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,14)
    <=> v129756(VarCurr) ) ).

tff(addAssignment_73133,axiom,
    ! [VarCurr: state_type] :
      ( v129755(VarCurr,15)
    <=> v129756(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1599,axiom,
    ! [VarCurr: state_type] :
      ( v129756(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129707(VarCurr,B)
      <=> ( v129708(VarCurr,B)
          | v129751(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129751(VarCurr,B)
      <=> ( v129752(VarCurr,B)
          & v98077(VarCurr,B) ) ) ) ).

tff(addAssignment_73132,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,0)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73131,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,1)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73130,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,2)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73129,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,3)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73128,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,4)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73127,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,5)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73126,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,6)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73125,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,7)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73124,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,8)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73123,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,9)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73122,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,10)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73121,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,11)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73120,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,12)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73119,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,13)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73118,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,14)
    <=> v129753(VarCurr) ) ).

tff(addAssignment_73117,axiom,
    ! [VarCurr: state_type] :
      ( v129752(VarCurr,15)
    <=> v129753(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1598,axiom,
    ! [VarCurr: state_type] :
      ( v129753(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129708(VarCurr,B)
      <=> ( v129709(VarCurr,B)
          | v129748(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129748(VarCurr,B)
      <=> ( v129749(VarCurr,B)
          & v98021(VarCurr,B) ) ) ) ).

tff(addAssignment_73116,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,0)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73115,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,1)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73114,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,2)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73113,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,3)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73112,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,4)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73111,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,5)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73110,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,6)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73109,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,7)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73108,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,8)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73107,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,9)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73106,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,10)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73105,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,11)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73104,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,12)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73103,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,13)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73102,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,14)
    <=> v129750(VarCurr) ) ).

tff(addAssignment_73101,axiom,
    ! [VarCurr: state_type] :
      ( v129749(VarCurr,15)
    <=> v129750(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1597,axiom,
    ! [VarCurr: state_type] :
      ( v129750(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129709(VarCurr,B)
      <=> ( v129710(VarCurr,B)
          | v129745(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129745(VarCurr,B)
      <=> ( v129746(VarCurr,B)
          & v97965(VarCurr,B) ) ) ) ).

tff(addAssignment_73100,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,0)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73099,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,1)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73098,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,2)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73097,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,3)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73096,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,4)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73095,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,5)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73094,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,6)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73093,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,7)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73092,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,8)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73091,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,9)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73090,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,10)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73089,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,11)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73088,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,12)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73087,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,13)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73086,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,14)
    <=> v129747(VarCurr) ) ).

tff(addAssignment_73085,axiom,
    ! [VarCurr: state_type] :
      ( v129746(VarCurr,15)
    <=> v129747(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1596,axiom,
    ! [VarCurr: state_type] :
      ( v129747(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129710(VarCurr,B)
      <=> ( v129711(VarCurr,B)
          | v129742(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129742(VarCurr,B)
      <=> ( v129743(VarCurr,B)
          & v97909(VarCurr,B) ) ) ) ).

tff(addAssignment_73084,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,0)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73083,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,1)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73082,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,2)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73081,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,3)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73080,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,4)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73079,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,5)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73078,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,6)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73077,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,7)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73076,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,8)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73075,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,9)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73074,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,10)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73073,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,11)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73072,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,12)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73071,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,13)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73070,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,14)
    <=> v129744(VarCurr) ) ).

tff(addAssignment_73069,axiom,
    ! [VarCurr: state_type] :
      ( v129743(VarCurr,15)
    <=> v129744(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1595,axiom,
    ! [VarCurr: state_type] :
      ( v129744(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $true )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129711(VarCurr,B)
      <=> ( v129712(VarCurr,B)
          | v129739(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1752,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129739(VarCurr,B)
      <=> ( v129740(VarCurr,B)
          & v97853(VarCurr,B) ) ) ) ).

tff(addAssignment_73068,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,0)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73067,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,1)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73066,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,2)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73065,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,3)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73064,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,4)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73063,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,5)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73062,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,6)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73061,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,7)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73060,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,8)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73059,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,9)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73058,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,10)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73057,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,11)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73056,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,12)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73055,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,13)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73054,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,14)
    <=> v129741(VarCurr) ) ).

tff(addAssignment_73053,axiom,
    ! [VarCurr: state_type] :
      ( v129740(VarCurr,15)
    <=> v129741(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1594,axiom,
    ! [VarCurr: state_type] :
      ( v129741(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129712(VarCurr,B)
      <=> ( v129713(VarCurr,B)
          | v129736(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129736(VarCurr,B)
      <=> ( v129737(VarCurr,B)
          & v97797(VarCurr,B) ) ) ) ).

tff(addAssignment_73052,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,0)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73051,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,1)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73050,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,2)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73049,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,3)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73048,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,4)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73047,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,5)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73046,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,6)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73045,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,7)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73044,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,8)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73043,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,9)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73042,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,10)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73041,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,11)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73040,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,12)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73039,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,13)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73038,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,14)
    <=> v129738(VarCurr) ) ).

tff(addAssignment_73037,axiom,
    ! [VarCurr: state_type] :
      ( v129737(VarCurr,15)
    <=> v129738(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1593,axiom,
    ! [VarCurr: state_type] :
      ( v129738(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129713(VarCurr,B)
      <=> ( v129714(VarCurr,B)
          | v129733(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129733(VarCurr,B)
      <=> ( v129734(VarCurr,B)
          & v97741(VarCurr,B) ) ) ) ).

tff(addAssignment_73036,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,0)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73035,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,1)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73034,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,2)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73033,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,3)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73032,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,4)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73031,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,5)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73030,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,6)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73029,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,7)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73028,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,8)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73027,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,9)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73026,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,10)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73025,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,11)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73024,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,12)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73023,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,13)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73022,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,14)
    <=> v129735(VarCurr) ) ).

tff(addAssignment_73021,axiom,
    ! [VarCurr: state_type] :
      ( v129734(VarCurr,15)
    <=> v129735(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1592,axiom,
    ! [VarCurr: state_type] :
      ( v129735(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129714(VarCurr,B)
      <=> ( v129715(VarCurr,B)
          | v129730(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129730(VarCurr,B)
      <=> ( v129731(VarCurr,B)
          & v97685(VarCurr,B) ) ) ) ).

tff(addAssignment_73020,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,0)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73019,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,1)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73018,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,2)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73017,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,3)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73016,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,4)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73015,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,5)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73014,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,6)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73013,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,7)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73012,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,8)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73011,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,9)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73010,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,10)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73009,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,11)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73008,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,12)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73007,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,13)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73006,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,14)
    <=> v129732(VarCurr) ) ).

tff(addAssignment_73005,axiom,
    ! [VarCurr: state_type] :
      ( v129731(VarCurr,15)
    <=> v129732(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1591,axiom,
    ! [VarCurr: state_type] :
      ( v129732(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $true )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129715(VarCurr,B)
      <=> ( v129716(VarCurr,B)
          | v129727(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129727(VarCurr,B)
      <=> ( v129728(VarCurr,B)
          & v97629(VarCurr,B) ) ) ) ).

tff(addAssignment_73004,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,0)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73003,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,1)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73002,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,2)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73001,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,3)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_73000,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,4)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72999,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,5)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72998,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,6)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72997,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,7)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72996,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,8)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72995,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,9)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72994,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,10)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72993,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,11)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72992,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,12)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72991,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,13)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72990,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,14)
    <=> v129729(VarCurr) ) ).

tff(addAssignment_72989,axiom,
    ! [VarCurr: state_type] :
      ( v129728(VarCurr,15)
    <=> v129729(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1590,axiom,
    ! [VarCurr: state_type] :
      ( v129729(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129716(VarCurr,B)
      <=> ( v129717(VarCurr,B)
          | v129724(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129724(VarCurr,B)
      <=> ( v129725(VarCurr,B)
          & v97573(VarCurr,B) ) ) ) ).

tff(addAssignment_72988,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,0)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72987,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,1)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72986,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,2)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72985,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,3)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72984,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,4)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72983,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,5)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72982,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,6)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72981,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,7)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72980,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,8)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72979,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,9)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72978,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,10)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72977,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,11)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72976,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,12)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72975,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,13)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72974,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,14)
    <=> v129726(VarCurr) ) ).

tff(addAssignment_72973,axiom,
    ! [VarCurr: state_type] :
      ( v129725(VarCurr,15)
    <=> v129726(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1589,axiom,
    ! [VarCurr: state_type] :
      ( v129726(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $true )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129717(VarCurr,B)
      <=> ( v129718(VarCurr,B)
          | v129721(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129721(VarCurr,B)
      <=> ( v129722(VarCurr,B)
          & v97517(VarCurr,B) ) ) ) ).

tff(addAssignment_72972,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,0)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72971,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,1)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72970,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,2)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72969,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,3)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72968,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,4)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72967,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,5)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72966,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,6)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72965,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,7)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72964,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,8)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72963,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,9)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72962,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,10)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72961,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,11)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72960,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,12)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72959,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,13)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72958,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,14)
    <=> v129723(VarCurr) ) ).

tff(addAssignment_72957,axiom,
    ! [VarCurr: state_type] :
      ( v129722(VarCurr,15)
    <=> v129723(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1588,axiom,
    ! [VarCurr: state_type] :
      ( v129723(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v129718(VarCurr,B)
      <=> ( v129719(VarCurr,B)
          & v97413(VarCurr,B) ) ) ) ).

tff(addAssignment_72956,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,0)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72955,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,1)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72954,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,2)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72953,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,3)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72952,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,4)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72951,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,5)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72950,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,6)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72949,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,7)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72948,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,8)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72947,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,9)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72946,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,10)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72945,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,11)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72944,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,12)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72943,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,13)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72942,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,14)
    <=> v129720(VarCurr) ) ).

tff(addAssignment_72941,axiom,
    ! [VarCurr: state_type] :
      ( v129719(VarCurr,15)
    <=> v129720(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1587,axiom,
    ! [VarCurr: state_type] :
      ( v129720(VarCurr)
    <=> ( ( v97186(VarCurr,3)
        <=> $false )
        & ( v97186(VarCurr,2)
        <=> $false )
        & ( v97186(VarCurr,1)
        <=> $false )
        & ( v97186(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_72940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97188(VarCurr,B)
      <=> v97190(VarCurr,B) ) ) ).

tff(addAssignment_72939,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97190(VarNext,B)
      <=> v129696(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129697(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v129696(VarNext,B)
            <=> v97190(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1709,axiom,
    ! [VarNext: state_type] :
      ( v129697(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129696(VarNext,B)
          <=> v129612(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129697(VarNext)
      <=> v129698(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129698(VarNext)
      <=> ( v129700(VarNext)
          & v129597(VarNext) ) ) ) ).

tff(writeUnaryOperator_9416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129700(VarNext)
      <=> v129606(VarNext) ) ) ).

tff(addAssignment_72938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97200(VarCurr,B)
      <=> v97202(VarCurr,B) ) ) ).

tff(addAssignment_72937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97202(VarCurr,B)
      <=> v97204(VarCurr,B) ) ) ).

tff(addAssignment_72936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97204(VarCurr,B)
      <=> v97206(VarCurr,B) ) ) ).

tff(addAssignment_72935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97206(VarCurr,B)
      <=> v129537(VarCurr,B) ) ) ).

tff(addAssignment_72934,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
    <=> v97210(VarCurr) ) ).

tff(addAssignment_72933,axiom,
    ! [VarCurr: state_type] :
      ( v97210(VarCurr)
    <=> v97212(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129679(VarNext)
       => ( v97212(VarNext)
        <=> v97212(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1708,axiom,
    ! [VarNext: state_type] :
      ( v129679(VarNext)
     => ( v97212(VarNext)
      <=> v129689(VarNext) ) ) ).

tff(addAssignment_72932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129689(VarNext)
      <=> v129687(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129690(VarCurr)
     => ( v129687(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1290,axiom,
    ! [VarCurr: state_type] :
      ( v129690(VarCurr)
     => ( v129687(VarCurr)
      <=> v97222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16836,axiom,
    ! [VarCurr: state_type] :
      ( v129690(VarCurr)
    <=> ( v129691(VarCurr)
        & v129692(VarCurr) ) ) ).

tff(writeUnaryOperator_9415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129692(VarCurr)
    <=> v97218(VarCurr) ) ).

tff(writeUnaryOperator_9414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129691(VarCurr)
    <=> v97214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129679(VarNext)
      <=> v129680(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129680(VarNext)
      <=> ( v129681(VarNext)
          & v129674(VarNext) ) ) ) ).

tff(writeUnaryOperator_9413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129681(VarNext)
      <=> v129683(VarNext) ) ) ).

tff(addAssignment_72931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129683(VarNext)
      <=> v129674(VarCurr) ) ) ).

tff(addAssignment_72930,axiom,
    ! [VarCurr: state_type] :
      ( v129674(VarCurr)
    <=> v129676(VarCurr) ) ).

tff(addAssignment_72929,axiom,
    ! [VarCurr: state_type] :
      ( v129676(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72928,axiom,
    ! [VarCurr: state_type] :
      ( v97222(VarCurr)
    <=> v97224(VarCurr) ) ).

tff(addAssignment_72927,axiom,
    ! [VarCurr: state_type] :
      ( v97224(VarCurr)
    <=> v97226(VarCurr) ) ).

tff(addAssignment_72926,axiom,
    ! [VarCurr: state_type] :
      ( v97226(VarCurr)
    <=> v97228(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89614(VarCurr)
     => ( v97228(VarCurr)
      <=> v129672(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1289,axiom,
    ! [VarCurr: state_type] :
      ( v89614(VarCurr)
     => ( v97228(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97230(VarCurr)
     => ( v129672(VarCurr)
      <=> v97208(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1288,axiom,
    ! [VarCurr: state_type] :
      ( v97230(VarCurr)
     => ( v129672(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_1586,axiom,
    ! [VarCurr: state_type] :
      ( v97230(VarCurr)
    <=> ( ( v97232(VarCurr,4)
        <=> v97254(VarCurr,4) )
        & ( v97232(VarCurr,3)
        <=> v97254(VarCurr,3) )
        & ( v97232(VarCurr,2)
        <=> v97254(VarCurr,2) )
        & ( v97232(VarCurr,1)
        <=> v97254(VarCurr,1) )
        & ( v97232(VarCurr,0)
        <=> v97254(VarCurr,0) ) ) ) ).

tff(addAssignment_72925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97232(VarCurr,B)
      <=> v97234(VarCurr,B) ) ) ).

tff(addAssignment_72924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97234(VarCurr,B)
      <=> v97236(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129654(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v97236(VarNext,B)
            <=> v97236(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1707,axiom,
    ! [VarNext: state_type] :
      ( v129654(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97236(VarNext,B)
          <=> v129664(VarNext,B) ) ) ) ).

tff(addAssignment_72923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129664(VarNext,B)
          <=> v129662(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129662(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1287,axiom,
    ! [VarCurr: state_type] :
      ( v129665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129662(VarCurr,B)
          <=> v97246(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16833,axiom,
    ! [VarCurr: state_type] :
      ( v129665(VarCurr)
    <=> ( v129666(VarCurr)
        & v129667(VarCurr) ) ) ).

tff(writeUnaryOperator_9412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129667(VarCurr)
    <=> v97242(VarCurr) ) ).

tff(writeUnaryOperator_9411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129666(VarCurr)
    <=> v97238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129654(VarNext)
      <=> v129655(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129655(VarNext)
      <=> ( v129656(VarNext)
          & v129649(VarNext) ) ) ) ).

tff(writeUnaryOperator_9410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129656(VarNext)
      <=> v129658(VarNext) ) ) ).

tff(addAssignment_72922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129658(VarNext)
      <=> v129649(VarCurr) ) ) ).

tff(addAssignment_72921,axiom,
    ! [VarCurr: state_type] :
      ( v129649(VarCurr)
    <=> v129651(VarCurr) ) ).

tff(addAssignment_72920,axiom,
    ! [VarCurr: state_type] :
      ( v129651(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97246(VarCurr,B)
      <=> v97248(VarCurr,B) ) ) ).

tff(addAssignment_72918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97248(VarCurr,B)
      <=> v97250(VarCurr,B) ) ) ).

tff(addAssignment_72917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97250(VarCurr,B)
      <=> v97252(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129619(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97252(VarCurr,B)
          <=> v129621(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1286,axiom,
    ! [VarCurr: state_type] :
      ( v129619(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97252(VarCurr,B)
          <=> v97186(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129622(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129621(VarCurr,B)
          <=> v97232(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1285,axiom,
    ! [VarCurr: state_type] :
      ( v129622(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129621(VarCurr,B)
          <=> v129623(VarCurr,B) ) ) ) ).

tff(addAssignment_72916,axiom,
    ! [VarCurr: state_type] :
      ( v129623(VarCurr,0)
    <=> v129645(VarCurr) ) ).

tff(addAssignment_72915,axiom,
    ! [VarCurr: state_type] :
      ( v129623(VarCurr,1)
    <=> v129643(VarCurr) ) ).

tff(addAssignment_72914,axiom,
    ! [VarCurr: state_type] :
      ( v129623(VarCurr,2)
    <=> v129638(VarCurr) ) ).

tff(addAssignment_72913,axiom,
    ! [VarCurr: state_type] :
      ( v129623(VarCurr,3)
    <=> v129633(VarCurr) ) ).

tff(addAssignment_72912,axiom,
    ! [VarCurr: state_type] :
      ( v129623(VarCurr,4)
    <=> v129625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16830,axiom,
    ! [VarCurr: state_type] :
      ( v129643(VarCurr)
    <=> ( v129644(VarCurr)
        & v129647(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5927,axiom,
    ! [VarCurr: state_type] :
      ( v129647(VarCurr)
    <=> ( v97232(VarCurr,0)
        | v97232(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16829,axiom,
    ! [VarCurr: state_type] :
      ( v129644(VarCurr)
    <=> ( v129645(VarCurr)
        | v129646(VarCurr) ) ) ).

tff(writeUnaryOperator_9409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129646(VarCurr)
    <=> v97232(VarCurr,1) ) ).

tff(writeUnaryOperator_9408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129645(VarCurr)
    <=> v97232(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16828,axiom,
    ! [VarCurr: state_type] :
      ( v129638(VarCurr)
    <=> ( v129639(VarCurr)
        & v129642(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5926,axiom,
    ! [VarCurr: state_type] :
      ( v129642(VarCurr)
    <=> ( v129630(VarCurr)
        | v97232(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16827,axiom,
    ! [VarCurr: state_type] :
      ( v129639(VarCurr)
    <=> ( v129640(VarCurr)
        | v129641(VarCurr) ) ) ).

tff(writeUnaryOperator_9407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129641(VarCurr)
    <=> v97232(VarCurr,2) ) ).

tff(writeUnaryOperator_9406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129640(VarCurr)
    <=> v129630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16826,axiom,
    ! [VarCurr: state_type] :
      ( v129633(VarCurr)
    <=> ( v129634(VarCurr)
        & v129637(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5925,axiom,
    ! [VarCurr: state_type] :
      ( v129637(VarCurr)
    <=> ( v129629(VarCurr)
        | v97232(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16825,axiom,
    ! [VarCurr: state_type] :
      ( v129634(VarCurr)
    <=> ( v129635(VarCurr)
        | v129636(VarCurr) ) ) ).

tff(writeUnaryOperator_9405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129636(VarCurr)
    <=> v97232(VarCurr,3) ) ).

tff(writeUnaryOperator_9404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129635(VarCurr)
    <=> v129629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16824,axiom,
    ! [VarCurr: state_type] :
      ( v129625(VarCurr)
    <=> ( v129626(VarCurr)
        & v129632(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5924,axiom,
    ! [VarCurr: state_type] :
      ( v129632(VarCurr)
    <=> ( v129628(VarCurr)
        | v97232(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16823,axiom,
    ! [VarCurr: state_type] :
      ( v129626(VarCurr)
    <=> ( v129627(VarCurr)
        | v129631(VarCurr) ) ) ).

tff(writeUnaryOperator_9403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129631(VarCurr)
    <=> v97232(VarCurr,4) ) ).

tff(writeUnaryOperator_9402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129627(VarCurr)
    <=> v129628(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5923,axiom,
    ! [VarCurr: state_type] :
      ( v129628(VarCurr)
    <=> ( v129629(VarCurr)
        & v97232(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5922,axiom,
    ! [VarCurr: state_type] :
      ( v129629(VarCurr)
    <=> ( v129630(VarCurr)
        & v97232(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5921,axiom,
    ! [VarCurr: state_type] :
      ( v129630(VarCurr)
    <=> ( v97232(VarCurr,0)
        & v97232(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16822,axiom,
    ! [VarCurr: state_type] :
      ( v129622(VarCurr)
    <=> ( v100734(VarCurr)
        & v4093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16821,axiom,
    ! [VarCurr: state_type] :
      ( v129619(VarCurr)
    <=> ( v4093(VarCurr)
        & v129620(VarCurr) ) ) ).

tff(writeUnaryOperator_9401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129620(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v97186(VarCurr,B)
      <=> v97188(VarCurr,B) ) ) ).

tff(addAssignment_72910,axiom,
    ! [VarCurr: state_type] :
      ( v97188(VarCurr,4)
    <=> v97190(VarCurr,4) ) ).

tff(addAssignment_72909,axiom,
    ! [VarNext: state_type] :
      ( v97190(VarNext,4)
    <=> v129601(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129602(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v129601(VarNext,B)
            <=> v97190(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1706,axiom,
    ! [VarNext: state_type] :
      ( v129602(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129601(VarNext,B)
          <=> v129612(VarNext,B) ) ) ) ).

tff(addAssignment_72908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129612(VarNext,B)
          <=> v129610(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129613(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129610(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1284,axiom,
    ! [VarCurr: state_type] :
      ( v129613(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129610(VarCurr,B)
          <=> v97200(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16820,axiom,
    ! [VarCurr: state_type] :
      ( v129613(VarCurr)
    <=> ( v129614(VarCurr)
        & v129615(VarCurr) ) ) ).

tff(writeUnaryOperator_9400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129615(VarCurr)
    <=> v97196(VarCurr) ) ).

tff(writeUnaryOperator_9399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129614(VarCurr)
    <=> v97192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129602(VarNext)
      <=> v129603(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129603(VarNext)
      <=> ( v129604(VarNext)
          & v129597(VarNext) ) ) ) ).

tff(writeUnaryOperator_9398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129604(VarNext)
      <=> v129606(VarNext) ) ) ).

tff(addAssignment_72907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129606(VarNext)
      <=> v129597(VarCurr) ) ) ).

tff(addAssignment_72906,axiom,
    ! [VarCurr: state_type] :
      ( v129597(VarCurr)
    <=> v129599(VarCurr) ) ).

tff(addAssignment_72905,axiom,
    ! [VarCurr: state_type] :
      ( v129599(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72904,axiom,
    ! [VarCurr: state_type] :
      ( v97200(VarCurr,4)
    <=> v97202(VarCurr,4) ) ).

tff(addAssignment_72903,axiom,
    ! [VarCurr: state_type] :
      ( v97202(VarCurr,4)
    <=> v97204(VarCurr,4) ) ).

tff(addAssignment_72902,axiom,
    ! [VarCurr: state_type] :
      ( v97204(VarCurr,4)
    <=> v97206(VarCurr,4) ) ).

tff(addAssignment_72901,axiom,
    ! [VarCurr: state_type] :
      ( v97206(VarCurr,4)
    <=> v129537(VarCurr,4) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129537(VarCurr,B)
          <=> v129538(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1283,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129537(VarCurr,B)
          <=> v97254(VarCurr,B) ) ) ) ).

tff(addAssignment_72900,axiom,
    ! [VarCurr: state_type] :
      ( v129538(VarCurr,0)
    <=> v129591(VarCurr) ) ).

tff(addAssignment_72899,axiom,
    ! [VarCurr: state_type] :
      ( v129538(VarCurr,1)
    <=> v129586(VarCurr) ) ).

tff(addAssignment_72898,axiom,
    ! [VarCurr: state_type] :
      ( v129538(VarCurr,2)
    <=> v129581(VarCurr) ) ).

tff(addAssignment_72897,axiom,
    ! [VarCurr: state_type] :
      ( v129538(VarCurr,3)
    <=> v129576(VarCurr) ) ).

tff(addAssignment_72896,axiom,
    ! [VarCurr: state_type] :
      ( v129538(VarCurr,4)
    <=> v129540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16817,axiom,
    ! [VarCurr: state_type] :
      ( v129591(VarCurr)
    <=> ( v129592(VarCurr)
        & v129595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16816,axiom,
    ! [VarCurr: state_type] :
      ( v129595(VarCurr)
    <=> ( v97186(VarCurr,0)
        | v129550(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16815,axiom,
    ! [VarCurr: state_type] :
      ( v129592(VarCurr)
    <=> ( v129593(VarCurr)
        | v129594(VarCurr) ) ) ).

tff(writeUnaryOperator_9397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129594(VarCurr)
    <=> v129550(VarCurr,0) ) ).

tff(writeUnaryOperator_9396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129593(VarCurr)
    <=> v97186(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16814,axiom,
    ! [VarCurr: state_type] :
      ( v129586(VarCurr)
    <=> ( v129587(VarCurr)
        & v129590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16813,axiom,
    ! [VarCurr: state_type] :
      ( v129590(VarCurr)
    <=> ( v129549(VarCurr)
        | v129551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16812,axiom,
    ! [VarCurr: state_type] :
      ( v129587(VarCurr)
    <=> ( v129588(VarCurr)
        | v129589(VarCurr) ) ) ).

tff(writeUnaryOperator_9395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129589(VarCurr)
    <=> v129551(VarCurr) ) ).

tff(writeUnaryOperator_9394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129588(VarCurr)
    <=> v129549(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16811,axiom,
    ! [VarCurr: state_type] :
      ( v129581(VarCurr)
    <=> ( v129582(VarCurr)
        & v129585(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16810,axiom,
    ! [VarCurr: state_type] :
      ( v129585(VarCurr)
    <=> ( v129547(VarCurr)
        | v129557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16809,axiom,
    ! [VarCurr: state_type] :
      ( v129582(VarCurr)
    <=> ( v129583(VarCurr)
        | v129584(VarCurr) ) ) ).

tff(writeUnaryOperator_9393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129584(VarCurr)
    <=> v129557(VarCurr) ) ).

tff(writeUnaryOperator_9392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129583(VarCurr)
    <=> v129547(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16808,axiom,
    ! [VarCurr: state_type] :
      ( v129576(VarCurr)
    <=> ( v129577(VarCurr)
        & v129580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16807,axiom,
    ! [VarCurr: state_type] :
      ( v129580(VarCurr)
    <=> ( v129545(VarCurr)
        | v129563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16806,axiom,
    ! [VarCurr: state_type] :
      ( v129577(VarCurr)
    <=> ( v129578(VarCurr)
        | v129579(VarCurr) ) ) ).

tff(writeUnaryOperator_9391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129579(VarCurr)
    <=> v129563(VarCurr) ) ).

tff(writeUnaryOperator_9390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129578(VarCurr)
    <=> v129545(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16805,axiom,
    ! [VarCurr: state_type] :
      ( v129540(VarCurr)
    <=> ( v129541(VarCurr)
        & v129575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16804,axiom,
    ! [VarCurr: state_type] :
      ( v129575(VarCurr)
    <=> ( v129543(VarCurr)
        | v129570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16803,axiom,
    ! [VarCurr: state_type] :
      ( v129541(VarCurr)
    <=> ( v129542(VarCurr)
        | v129569(VarCurr) ) ) ).

tff(writeUnaryOperator_9389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129569(VarCurr)
    <=> v129570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16802,axiom,
    ! [VarCurr: state_type] :
      ( v129570(VarCurr)
    <=> ( v129571(VarCurr)
        & v129574(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5920,axiom,
    ! [VarCurr: state_type] :
      ( v129574(VarCurr)
    <=> ( v97186(VarCurr,4)
        | v129550(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16801,axiom,
    ! [VarCurr: state_type] :
      ( v129571(VarCurr)
    <=> ( v129572(VarCurr)
        | v129573(VarCurr) ) ) ).

tff(writeUnaryOperator_9388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129573(VarCurr)
    <=> v129550(VarCurr,4) ) ).

tff(writeUnaryOperator_9387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129572(VarCurr)
    <=> v97186(VarCurr,4) ) ).

tff(writeUnaryOperator_9386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129542(VarCurr)
    <=> v129543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16800,axiom,
    ! [VarCurr: state_type] :
      ( v129543(VarCurr)
    <=> ( v129544(VarCurr)
        | v129568(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5919,axiom,
    ! [VarCurr: state_type] :
      ( v129568(VarCurr)
    <=> ( v97186(VarCurr,3)
        & v129550(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16799,axiom,
    ! [VarCurr: state_type] :
      ( v129544(VarCurr)
    <=> ( v129545(VarCurr)
        & v129563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16798,axiom,
    ! [VarCurr: state_type] :
      ( v129563(VarCurr)
    <=> ( v129564(VarCurr)
        & v129567(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5918,axiom,
    ! [VarCurr: state_type] :
      ( v129567(VarCurr)
    <=> ( v97186(VarCurr,3)
        | v129550(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16797,axiom,
    ! [VarCurr: state_type] :
      ( v129564(VarCurr)
    <=> ( v129565(VarCurr)
        | v129566(VarCurr) ) ) ).

tff(writeUnaryOperator_9385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129566(VarCurr)
    <=> v129550(VarCurr,3) ) ).

tff(writeUnaryOperator_9384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129565(VarCurr)
    <=> v97186(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16796,axiom,
    ! [VarCurr: state_type] :
      ( v129545(VarCurr)
    <=> ( v129546(VarCurr)
        | v129562(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5917,axiom,
    ! [VarCurr: state_type] :
      ( v129562(VarCurr)
    <=> ( v97186(VarCurr,2)
        & v129550(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16795,axiom,
    ! [VarCurr: state_type] :
      ( v129546(VarCurr)
    <=> ( v129547(VarCurr)
        & v129557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16794,axiom,
    ! [VarCurr: state_type] :
      ( v129557(VarCurr)
    <=> ( v129558(VarCurr)
        & v129561(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5916,axiom,
    ! [VarCurr: state_type] :
      ( v129561(VarCurr)
    <=> ( v97186(VarCurr,2)
        | v129550(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16793,axiom,
    ! [VarCurr: state_type] :
      ( v129558(VarCurr)
    <=> ( v129559(VarCurr)
        | v129560(VarCurr) ) ) ).

tff(writeUnaryOperator_9383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129560(VarCurr)
    <=> v129550(VarCurr,2) ) ).

tff(writeUnaryOperator_9382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129559(VarCurr)
    <=> v97186(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16792,axiom,
    ! [VarCurr: state_type] :
      ( v129547(VarCurr)
    <=> ( v129548(VarCurr)
        | v129556(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5915,axiom,
    ! [VarCurr: state_type] :
      ( v129556(VarCurr)
    <=> ( v97186(VarCurr,1)
        & v129550(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16791,axiom,
    ! [VarCurr: state_type] :
      ( v129548(VarCurr)
    <=> ( v129549(VarCurr)
        & v129551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16790,axiom,
    ! [VarCurr: state_type] :
      ( v129551(VarCurr)
    <=> ( v129552(VarCurr)
        & v129555(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5914,axiom,
    ! [VarCurr: state_type] :
      ( v129555(VarCurr)
    <=> ( v97186(VarCurr,1)
        | v129550(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16789,axiom,
    ! [VarCurr: state_type] :
      ( v129552(VarCurr)
    <=> ( v129553(VarCurr)
        | v129554(VarCurr) ) ) ).

tff(writeUnaryOperator_9381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129554(VarCurr)
    <=> v129550(VarCurr,1) ) ).

tff(writeUnaryOperator_9380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129553(VarCurr)
    <=> v97186(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16788,axiom,
    ! [VarCurr: state_type] :
      ( v129549(VarCurr)
    <=> ( v97186(VarCurr,0)
        & v129550(VarCurr,0) ) ) ).

tff(addAssignment_72895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129550(VarCurr,B)
      <=> v100738(VarCurr,B) ) ) ).

tff(addAssignment_72894,axiom,
    ! [VarCurr: state_type] :
      ( ( v129550(VarCurr,4)
      <=> $false )
      & ( v129550(VarCurr,3)
      <=> $false )
      & ( v129550(VarCurr,2)
      <=> $false ) ) ).

tff(addAssignment_72893,axiom,
    ! [VarCurr: state_type] :
      ( v100738(VarCurr,1)
    <=> v100740(VarCurr,1) ) ).

tff(addAssignment_72892,axiom,
    ! [VarCurr: state_type] :
      ( v100740(VarCurr,1)
    <=> v100742(VarCurr,1) ) ).

tff(addAssignment_72891,axiom,
    ! [VarCurr: state_type] :
      ( v100742(VarCurr,1)
    <=> v100803(VarCurr,1) ) ).

tff(addAssignment_72890,axiom,
    ! [VarCurr: state_type] :
      ( v97254(VarCurr,4)
    <=> v97256(VarCurr,4) ) ).

tff(addAssignment_72889,axiom,
    ! [VarCurr: state_type] :
      ( v97256(VarCurr,4)
    <=> v97258(VarCurr,4) ) ).

tff(addAssignment_72888,axiom,
    ! [VarNext: state_type] :
      ( v97258(VarNext,4)
    <=> v129530(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129531(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v129530(VarNext,B)
            <=> v97258(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1705,axiom,
    ! [VarNext: state_type] :
      ( v129531(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v129530(VarNext,B)
          <=> v97478(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129531(VarNext)
      <=> v129532(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129532(VarNext)
      <=> ( v129534(VarNext)
          & v97463(VarNext) ) ) ) ).

tff(writeUnaryOperator_9379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129534(VarNext)
      <=> v97472(VarNext) ) ) ).

tff(addAssignment_72887,axiom,
    ! [VarCurr: state_type] :
      ( v97268(VarCurr,4)
    <=> v97270(VarCurr,4) ) ).

tff(addAssignment_72886,axiom,
    ! [VarCurr: state_type] :
      ( v97270(VarCurr,4)
    <=> v97272(VarCurr,4) ) ).

tff(addAssignment_72885,axiom,
    ! [VarCurr: state_type] :
      ( v97272(VarCurr,4)
    <=> v97274(VarCurr,4) ) ).

tff(addAssignment_72884,axiom,
    ! [VarCurr: state_type] :
      ( v97274(VarCurr,4)
    <=> v97436(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16785,axiom,
    ! [VarCurr: state_type] :
      ( v97276(VarCurr)
    <=> ( v129528(VarCurr)
        & v97278(VarCurr) ) ) ).

tff(writeUnaryOperator_9378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129528(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v97278(VarCurr)
      <=> v129525(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1282,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v97278(VarCurr)
      <=> v129523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16784,axiom,
    ! [VarCurr: state_type] :
      ( v129525(VarCurr)
    <=> ( v129526(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1585,axiom,
    ! [VarCurr: state_type] :
      ( v129526(VarCurr)
    <=> ( ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16783,axiom,
    ! [VarCurr: state_type] :
      ( v129523(VarCurr)
    <=> ( v129524(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1584,axiom,
    ! [VarCurr: state_type] :
      ( v129524(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $true )
        & ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72883,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97284(VarCurr,B)
      <=> v97286(VarCurr,B) ) ) ).

tff(addAssignment_72882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97286(VarCurr,B)
      <=> v97288(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129506(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v97288(VarNext,B)
            <=> v97288(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1704,axiom,
    ! [VarNext: state_type] :
      ( v129506(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97288(VarNext,B)
          <=> v129516(VarNext,B) ) ) ) ).

tff(addAssignment_72881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129516(VarNext,B)
          <=> v129514(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129517(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129514(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1281,axiom,
    ! [VarCurr: state_type] :
      ( v129517(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129514(VarCurr,B)
          <=> v97298(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16782,axiom,
    ! [VarCurr: state_type] :
      ( v129517(VarCurr)
    <=> ( v129518(VarCurr)
        & v129519(VarCurr) ) ) ).

tff(writeUnaryOperator_9377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129519(VarCurr)
    <=> v97294(VarCurr) ) ).

tff(writeUnaryOperator_9376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129518(VarCurr)
    <=> v97290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129506(VarNext)
      <=> v129507(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129507(VarNext)
      <=> ( v129508(VarNext)
          & v129501(VarNext) ) ) ) ).

tff(writeUnaryOperator_9375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129508(VarNext)
      <=> v129510(VarNext) ) ) ).

tff(addAssignment_72880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129510(VarNext)
      <=> v129501(VarCurr) ) ) ).

tff(addAssignment_72879,axiom,
    ! [VarCurr: state_type] :
      ( v129501(VarCurr)
    <=> v129503(VarCurr) ) ).

tff(addAssignment_72878,axiom,
    ! [VarCurr: state_type] :
      ( v129503(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97298(VarCurr,B)
      <=> v97300(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97300(VarCurr,B)
      <=> ( v129493(VarCurr,B)
          | v129496(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129496(VarCurr,B)
      <=> ( v97286(VarCurr,B)
          & v129497(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129497(VarCurr,B)
      <=> ~ v129498(VarCurr,B) ) ) ).

tff(addAssignment_72876,axiom,
    ! [VarCurr: state_type] :
      ( v129498(VarCurr,0)
    <=> v129499(VarCurr) ) ).

tff(addAssignment_72875,axiom,
    ! [VarCurr: state_type] :
      ( v129498(VarCurr,1)
    <=> v129499(VarCurr) ) ).

tff(addAssignment_72874,axiom,
    ! [VarCurr: state_type] :
      ( v129498(VarCurr,2)
    <=> v129499(VarCurr) ) ).

tff(addAssignment_72873,axiom,
    ! [VarCurr: state_type] :
      ( v129499(VarCurr)
    <=> v97323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129493(VarCurr,B)
      <=> ( v97302(VarCurr,B)
          & v129494(VarCurr,B) ) ) ) ).

tff(addAssignment_72872,axiom,
    ! [VarCurr: state_type] :
      ( v129494(VarCurr,0)
    <=> v129495(VarCurr) ) ).

tff(addAssignment_72871,axiom,
    ! [VarCurr: state_type] :
      ( v129494(VarCurr,1)
    <=> v129495(VarCurr) ) ).

tff(addAssignment_72870,axiom,
    ! [VarCurr: state_type] :
      ( v129494(VarCurr,2)
    <=> v129495(VarCurr) ) ).

tff(addAssignment_72869,axiom,
    ! [VarCurr: state_type] :
      ( v129495(VarCurr)
    <=> v97323(VarCurr) ) ).

tff(addAssignment_72868,axiom,
    ! [VarCurr: state_type] :
      ( v97323(VarCurr)
    <=> v97325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16779,axiom,
    ! [VarCurr: state_type] :
      ( v97325(VarCurr)
    <=> ( v129441(VarCurr)
        & v129474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16778,axiom,
    ! [VarCurr: state_type] :
      ( v129474(VarCurr)
    <=> ( v129475(VarCurr)
        | v129479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16777,axiom,
    ! [VarCurr: state_type] :
      ( v129479(VarCurr)
    <=> ( v129480(VarCurr)
        & v129491(VarCurr) ) ) ).

tff(writeUnaryOperator_9373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129491(VarCurr)
    <=> v129437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16776,axiom,
    ! [VarCurr: state_type] :
      ( v129480(VarCurr)
    <=> ( v129481(VarCurr)
        & v129490(VarCurr) ) ) ).

tff(writeUnaryOperator_9372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129490(VarCurr)
    <=> v108810(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16775,axiom,
    ! [VarCurr: state_type] :
      ( v129481(VarCurr)
    <=> ( v129482(VarCurr)
        & v129489(VarCurr) ) ) ).

tff(writeUnaryOperator_9371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129489(VarCurr)
    <=> v100723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16774,axiom,
    ! [VarCurr: state_type] :
      ( v129482(VarCurr)
    <=> ( v129483(VarCurr)
        & v129488(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16773,axiom,
    ! [VarCurr: state_type] :
      ( v129488(VarCurr)
    <=> ( v129433(VarCurr)
        | v97208(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16772,axiom,
    ! [VarCurr: state_type] :
      ( v129483(VarCurr)
    <=> ( v129484(VarCurr)
        & v129487(VarCurr) ) ) ).

tff(writeUnaryOperator_9370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129487(VarCurr)
    <=> v129429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16771,axiom,
    ! [VarCurr: state_type] :
      ( v129484(VarCurr)
    <=> ( v129485(VarCurr)
        & v129486(VarCurr) ) ) ).

tff(writeUnaryOperator_9369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129486(VarCurr)
    <=> v129425(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1583,axiom,
    ! [VarCurr: state_type] :
      ( v129485(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $false )
        & ( v97284(VarCurr,1)
        <=> $false )
        & ( v97284(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_9368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129475(VarCurr)
    <=> v129477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16770,axiom,
    ! [VarCurr: state_type] :
      ( v129477(VarCurr)
    <=> ( v129478(VarCurr)
        & v97312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16769,axiom,
    ! [VarCurr: state_type] :
      ( v129478(VarCurr)
    <=> ( v97316(VarCurr)
        & v97317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16768,axiom,
    ! [VarCurr: state_type] :
      ( v129441(VarCurr)
    <=> ( v129442(VarCurr)
        & v129454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16767,axiom,
    ! [VarCurr: state_type] :
      ( v129454(VarCurr)
    <=> ( v129455(VarCurr)
        | v129471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16766,axiom,
    ! [VarCurr: state_type] :
      ( v129471(VarCurr)
    <=> ( v129472(VarCurr)
        & v100713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16765,axiom,
    ! [VarCurr: state_type] :
      ( v129472(VarCurr)
    <=> ( v129473(VarCurr)
        & v97208(VarCurr) ) ) ).

tff(writeUnaryOperator_9367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129473(VarCurr)
    <=> v97230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16764,axiom,
    ! [VarCurr: state_type] :
      ( v129455(VarCurr)
    <=> ( v129456(VarCurr)
        | v129464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16763,axiom,
    ! [VarCurr: state_type] :
      ( v129464(VarCurr)
    <=> ( v129465(VarCurr)
        & v129470(VarCurr) ) ) ).

tff(writeUnaryOperator_9366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129470(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16762,axiom,
    ! [VarCurr: state_type] :
      ( v129465(VarCurr)
    <=> ( v129466(VarCurr)
        & v129469(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5913,axiom,
    ! [VarCurr: state_type] :
      ( v129469(VarCurr)
    <=> ( v99828(VarCurr)
        | v99226(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16761,axiom,
    ! [VarCurr: state_type] :
      ( v129466(VarCurr)
    <=> ( v98444(VarCurr)
        | v129467(VarCurr) ) ) ).

tff(writeUnaryOperator_9365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129467(VarCurr)
    <=> v129468(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5912,axiom,
    ! [VarCurr: state_type] :
      ( v129468(VarCurr)
    <=> ( v99820(VarCurr)
        | v98635(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16760,axiom,
    ! [VarCurr: state_type] :
      ( v129456(VarCurr)
    <=> ( v129457(VarCurr)
        & v129463(VarCurr) ) ) ).

tff(writeUnaryOperator_9364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129463(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16759,axiom,
    ! [VarCurr: state_type] :
      ( v129457(VarCurr)
    <=> ( v129458(VarCurr)
        & v129462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5911,axiom,
    ! [VarCurr: state_type] :
      ( v129462(VarCurr)
    <=> ( v99820(VarCurr)
        | v98635(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16758,axiom,
    ! [VarCurr: state_type] :
      ( v129458(VarCurr)
    <=> ( v129459(VarCurr)
        | v129460(VarCurr) ) ) ).

tff(writeUnaryOperator_9363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129460(VarCurr)
    <=> v129461(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5910,axiom,
    ! [VarCurr: state_type] :
      ( v129461(VarCurr)
    <=> ( v99828(VarCurr)
        | v99226(VarCurr,7) ) ) ).

tff(writeUnaryOperator_9362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129459(VarCurr)
    <=> v98444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16757,axiom,
    ! [VarCurr: state_type] :
      ( v129442(VarCurr)
    <=> ( v129443(VarCurr)
        & v129453(VarCurr) ) ) ).

tff(writeUnaryOperator_9361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129453(VarCurr)
    <=> v129421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16756,axiom,
    ! [VarCurr: state_type] :
      ( v129443(VarCurr)
    <=> ( v129444(VarCurr)
        & v129452(VarCurr) ) ) ).

tff(writeUnaryOperator_9360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129452(VarCurr)
    <=> v129417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16755,axiom,
    ! [VarCurr: state_type] :
      ( v129444(VarCurr)
    <=> ( v129445(VarCurr)
        & v129451(VarCurr) ) ) ).

tff(writeUnaryOperator_9359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129451(VarCurr)
    <=> v129413(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16754,axiom,
    ! [VarCurr: state_type] :
      ( v129445(VarCurr)
    <=> ( v129446(VarCurr)
        & v129450(VarCurr) ) ) ).

tff(writeUnaryOperator_9358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129450(VarCurr)
    <=> v129406(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16753,axiom,
    ! [VarCurr: state_type] :
      ( v129446(VarCurr)
    <=> ( v129447(VarCurr)
        & v129449(VarCurr) ) ) ).

tff(writeUnaryOperator_9357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129449(VarCurr)
    <=> v97381(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16752,axiom,
    ! [VarCurr: state_type] :
      ( v129447(VarCurr)
    <=> ( v129448(VarCurr)
        & v97327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16751,axiom,
    ! [VarCurr: state_type] :
      ( v129448(VarCurr)
    <=> ( v97146(VarCurr)
        | v89523(VarCurr) ) ) ).

tff(addAssignment_72867,axiom,
    ! [VarCurr: state_type] :
      ( v129437(VarCurr)
    <=> v129439(VarCurr) ) ).

tff(addAssignment_72866,axiom,
    ! [VarCurr: state_type] :
      ( v129439(VarCurr)
    <=> v84321(VarCurr) ) ).

tff(addAssignment_72865,axiom,
    ! [VarCurr: state_type] :
      ( v129433(VarCurr)
    <=> v129435(VarCurr) ) ).

tff(addAssignment_72864,axiom,
    ! [VarCurr: state_type] :
      ( v129435(VarCurr)
    <=> v109663(VarCurr) ) ).

tff(addAssignment_72863,axiom,
    ! [VarCurr: state_type] :
      ( v129429(VarCurr)
    <=> v129431(VarCurr) ) ).

tff(addAssignment_72862,axiom,
    ! [VarCurr: state_type] :
      ( v129431(VarCurr)
    <=> v111693(VarCurr) ) ).

tff(addAssignment_72861,axiom,
    ! [VarCurr: state_type] :
      ( v129425(VarCurr)
    <=> v129427(VarCurr) ) ).

tff(addAssignment_72860,axiom,
    ! [VarCurr: state_type] :
      ( v129427(VarCurr)
    <=> v112518(VarCurr) ) ).

tff(addAssignment_72859,axiom,
    ! [VarCurr: state_type] :
      ( v129421(VarCurr)
    <=> v129423(VarCurr) ) ).

tff(addAssignment_72858,axiom,
    ! [VarCurr: state_type] :
      ( v129423(VarCurr)
    <=> v84297(VarCurr,6) ) ).

tff(addAssignment_72857,axiom,
    ! [VarCurr: state_type] :
      ( v129417(VarCurr)
    <=> v129419(VarCurr) ) ).

tff(addAssignment_72856,axiom,
    ! [VarCurr: state_type] :
      ( v129419(VarCurr)
    <=> v84297(VarCurr,5) ) ).

tff(addAssignment_72855,axiom,
    ! [VarCurr: state_type] :
      ( v129413(VarCurr)
    <=> v129415(VarCurr) ) ).

tff(addAssignment_72854,axiom,
    ! [VarCurr: state_type] :
      ( v129415(VarCurr)
    <=> v84297(VarCurr,3) ) ).

tff(addAssignment_72853,axiom,
    ! [VarCurr: state_type] :
      ( v129406(VarCurr)
    <=> v129408(VarCurr) ) ).

tff(addAssignment_72852,axiom,
    ! [VarCurr: state_type] :
      ( v129408(VarCurr)
    <=> v129410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16750,axiom,
    ! [VarCurr: state_type] :
      ( v129410(VarCurr)
    <=> ( v112483(VarCurr)
        & v88420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16749,axiom,
    ! [VarCurr: state_type] :
      ( v97381(VarCurr)
    <=> ( v129399(VarCurr)
        | v129293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16748,axiom,
    ! [VarCurr: state_type] :
      ( v129399(VarCurr)
    <=> ( v129400(VarCurr)
        | v129187(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16747,axiom,
    ! [VarCurr: state_type] :
      ( v129400(VarCurr)
    <=> ( v129401(VarCurr)
        | v129081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16746,axiom,
    ! [VarCurr: state_type] :
      ( v129401(VarCurr)
    <=> ( v129402(VarCurr)
        | v128975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16745,axiom,
    ! [VarCurr: state_type] :
      ( v129402(VarCurr)
    <=> ( v129403(VarCurr)
        | v128869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16744,axiom,
    ! [VarCurr: state_type] :
      ( v129403(VarCurr)
    <=> ( v129404(VarCurr)
        | v128763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16743,axiom,
    ! [VarCurr: state_type] :
      ( v129404(VarCurr)
    <=> ( v97383(VarCurr)
        | v128657(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v129293(VarCurr)
      <=> v129396(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1280,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v129293(VarCurr)
      <=> v129395(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5909,axiom,
    ! [VarCurr: state_type] :
      ( v129396(VarCurr)
    <=> ( v129336(VarCurr)
        & v129295(VarCurr,2) ) ) ).

tff(addAssignment_72851,axiom,
    ! [VarCurr: state_type] :
      ( v129395(VarCurr)
    <=> v129336(VarCurr) ) ).

tff(addAssignment_72850,axiom,
    ! [VarCurr: state_type] :
      ( v129295(VarCurr,2)
    <=> v129297(VarCurr,2) ) ).

tff(addAssignment_72849,axiom,
    ! [VarCurr: state_type] :
      ( v129297(VarCurr,2)
    <=> v129299(VarCurr,2) ) ).

tff(addAssignment_72848,axiom,
    ! [VarNext: state_type] :
      ( v129299(VarNext,2)
    <=> v129387(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129388(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129387(VarNext,B)
            <=> v129299(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1703,axiom,
    ! [VarNext: state_type] :
      ( v129388(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129387(VarNext,B)
          <=> v129380(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129388(VarNext)
      <=> v129389(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129389(VarNext)
      <=> ( v129391(VarNext)
          & v129365(VarNext) ) ) ) ).

tff(writeUnaryOperator_9356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129391(VarNext)
      <=> v129374(VarNext) ) ) ).

tff(addAssignment_72847,axiom,
    ! [VarCurr: state_type] :
      ( v129309(VarCurr,2)
    <=> v129311(VarCurr,2) ) ).

tff(addAssignment_72846,axiom,
    ! [VarCurr: state_type] :
      ( v129311(VarCurr,2)
    <=> v129360(VarCurr,2) ) ).

tff(addAssignment_72845,axiom,
    ! [VarCurr: state_type] :
      ( v129313(VarCurr,2)
    <=> v129315(VarCurr,2) ) ).

tff(addAssignment_72844,axiom,
    ! [VarCurr: state_type] :
      ( v129315(VarCurr,2)
    <=> v129328(VarCurr,2) ) ).

tff(addAssignment_72843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129295(VarCurr,B)
      <=> v129297(VarCurr,B) ) ) ).

tff(addAssignment_72842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129297(VarCurr,B)
      <=> v129299(VarCurr,B) ) ) ).

tff(addAssignment_72841,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129299(VarNext,B)
      <=> v129369(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129370(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129369(VarNext,B)
            <=> v129299(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1702,axiom,
    ! [VarNext: state_type] :
      ( v129370(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129369(VarNext,B)
          <=> v129380(VarNext,B) ) ) ) ).

tff(addAssignment_72840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129380(VarNext,B)
          <=> v129378(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129381(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129378(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1279,axiom,
    ! [VarCurr: state_type] :
      ( v129381(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129378(VarCurr,B)
          <=> v129309(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16740,axiom,
    ! [VarCurr: state_type] :
      ( v129381(VarCurr)
    <=> ( v129382(VarCurr)
        & v129383(VarCurr) ) ) ).

tff(writeUnaryOperator_9355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129383(VarCurr)
    <=> v129305(VarCurr) ) ).

tff(writeUnaryOperator_9354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129382(VarCurr)
    <=> v129301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129370(VarNext)
      <=> v129371(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129371(VarNext)
      <=> ( v129372(VarNext)
          & v129365(VarNext) ) ) ) ).

tff(writeUnaryOperator_9353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129372(VarNext)
      <=> v129374(VarNext) ) ) ).

tff(addAssignment_72839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129374(VarNext)
      <=> v129365(VarCurr) ) ) ).

tff(addAssignment_72838,axiom,
    ! [VarCurr: state_type] :
      ( v129365(VarCurr)
    <=> v129367(VarCurr) ) ).

tff(addAssignment_72837,axiom,
    ! [VarCurr: state_type] :
      ( v129367(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129309(VarCurr,B)
      <=> v129311(VarCurr,B) ) ) ).

tff(addAssignment_72835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129311(VarCurr,B)
      <=> v129360(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129360(VarCurr,B)
      <=> ( v129313(VarCurr,B)
          & v129361(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129361(VarCurr,B)
      <=> ~ v129362(VarCurr,B) ) ) ).

tff(addAssignment_72834,axiom,
    ! [VarCurr: state_type] :
      ( v129362(VarCurr,0)
    <=> v129363(VarCurr) ) ).

tff(addAssignment_72833,axiom,
    ! [VarCurr: state_type] :
      ( v129362(VarCurr,1)
    <=> v129363(VarCurr) ) ).

tff(addAssignment_72832,axiom,
    ! [VarCurr: state_type] :
      ( v129362(VarCurr,2)
    <=> v129363(VarCurr) ) ).

tff(addAssignment_72831,axiom,
    ! [VarCurr: state_type] :
      ( v129363(VarCurr)
    <=> v129359(VarCurr) ) ).

tff(addAssignment_72830,axiom,
    ! [VarCurr: state_type] :
      ( v129359(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129313(VarCurr,B)
      <=> v129315(VarCurr,B) ) ) ).

tff(addAssignment_72828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129315(VarCurr,B)
      <=> v129328(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129328(VarCurr,B)
          <=> v129344(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1278,axiom,
    ! [VarCurr: state_type] :
      ( v129329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129328(VarCurr,B)
          <=> v129331(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129344(VarCurr,B)
          <=> v129295(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1277,axiom,
    ! [VarCurr: state_type] :
      ( v129345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129344(VarCurr,B)
          <=> v129347(VarCurr,B) ) ) ) ).

tff(addAssignment_72827,axiom,
    ! [VarCurr: state_type] :
      ( v129347(VarCurr,0)
    <=> v129341(VarCurr) ) ).

tff(addAssignment_72826,axiom,
    ! [VarCurr: state_type] :
      ( v129347(VarCurr,1)
    <=> v129355(VarCurr) ) ).

tff(addAssignment_72825,axiom,
    ! [VarCurr: state_type] :
      ( v129347(VarCurr,2)
    <=> v129349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16737,axiom,
    ! [VarCurr: state_type] :
      ( v129355(VarCurr)
    <=> ( v129356(VarCurr)
        & v129357(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16736,axiom,
    ! [VarCurr: state_type] :
      ( v129357(VarCurr)
    <=> ( v129295(VarCurr,0)
        | v129342(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5908,axiom,
    ! [VarCurr: state_type] :
      ( v129356(VarCurr)
    <=> ( v129341(VarCurr)
        | v129295(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16735,axiom,
    ! [VarCurr: state_type] :
      ( v129349(VarCurr)
    <=> ( v129350(VarCurr)
        & v129354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16734,axiom,
    ! [VarCurr: state_type] :
      ( v129354(VarCurr)
    <=> ( v129337(VarCurr)
        | v129352(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5907,axiom,
    ! [VarCurr: state_type] :
      ( v129350(VarCurr)
    <=> ( v129295(VarCurr,2)
        | v129351(VarCurr) ) ) ).

tff(writeUnaryOperator_9351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129351(VarCurr)
    <=> v129352(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5906,axiom,
    ! [VarCurr: state_type] :
      ( v129352(VarCurr)
    <=> ( v129295(VarCurr,1)
        | v129353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16733,axiom,
    ! [VarCurr: state_type] :
      ( v129353(VarCurr)
    <=> ( v129295(VarCurr,0)
        & v129342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16732,axiom,
    ! [VarCurr: state_type] :
      ( v129345(VarCurr)
    <=> ( v129346(VarCurr)
        & v129321(VarCurr) ) ) ).

tff(writeUnaryOperator_9350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129346(VarCurr)
    <=> v129317(VarCurr) ) ).

tff(addAssignment_72824,axiom,
    ! [VarCurr: state_type] :
      ( v129331(VarCurr,0)
    <=> v129341(VarCurr) ) ).

tff(addAssignment_72823,axiom,
    ! [VarCurr: state_type] :
      ( v129331(VarCurr,1)
    <=> v129339(VarCurr) ) ).

tff(addAssignment_72822,axiom,
    ! [VarCurr: state_type] :
      ( v129331(VarCurr,2)
    <=> v129333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16731,axiom,
    ! [VarCurr: state_type] :
      ( v129339(VarCurr)
    <=> ( v129340(VarCurr)
        & v129343(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5905,axiom,
    ! [VarCurr: state_type] :
      ( v129343(VarCurr)
    <=> ( v129295(VarCurr,0)
        | v129295(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16730,axiom,
    ! [VarCurr: state_type] :
      ( v129340(VarCurr)
    <=> ( v129341(VarCurr)
        | v129342(VarCurr) ) ) ).

tff(writeUnaryOperator_9349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129342(VarCurr)
    <=> v129295(VarCurr,1) ) ).

tff(writeUnaryOperator_9348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129341(VarCurr)
    <=> v129295(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16729,axiom,
    ! [VarCurr: state_type] :
      ( v129333(VarCurr)
    <=> ( v129334(VarCurr)
        & v129338(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5904,axiom,
    ! [VarCurr: state_type] :
      ( v129338(VarCurr)
    <=> ( v129336(VarCurr)
        | v129295(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16728,axiom,
    ! [VarCurr: state_type] :
      ( v129334(VarCurr)
    <=> ( v129335(VarCurr)
        | v129337(VarCurr) ) ) ).

tff(writeUnaryOperator_9347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129337(VarCurr)
    <=> v129295(VarCurr,2) ) ).

tff(writeUnaryOperator_9346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129335(VarCurr)
    <=> v129336(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5903,axiom,
    ! [VarCurr: state_type] :
      ( v129336(VarCurr)
    <=> ( v129295(VarCurr,0)
        & v129295(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16727,axiom,
    ! [VarCurr: state_type] :
      ( v129329(VarCurr)
    <=> ( v129317(VarCurr)
        & v129330(VarCurr) ) ) ).

tff(writeUnaryOperator_9345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129330(VarCurr)
    <=> v129321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16726,axiom,
    ! [VarCurr: state_type] :
      ( v129321(VarCurr)
    <=> ( v129323(VarCurr)
        | v129326(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5902,axiom,
    ! [VarCurr: state_type] :
      ( v129326(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v129327(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1582,axiom,
    ! [VarCurr: state_type] :
      ( v129327(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16725,axiom,
    ! [VarCurr: state_type] :
      ( v129323(VarCurr)
    <=> ( v129324(VarCurr)
        & v129325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1581,axiom,
    ! [VarCurr: state_type] :
      ( v129325(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5901,axiom,
    ! [VarCurr: state_type] :
      ( v129324(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16724,axiom,
    ! [VarCurr: state_type] :
      ( v129317(VarCurr)
    <=> ( v97276(VarCurr)
        & v129319(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1580,axiom,
    ! [VarCurr: state_type] :
      ( v129319(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $true )
        & ( v97409(VarCurr,4)
        <=> $true )
        & ( v97409(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_72821,axiom,
    ! [VarCurr: state_type] :
      ( v129305(VarCurr)
    <=> v129307(VarCurr) ) ).

tff(addAssignment_72820,axiom,
    ! [VarCurr: state_type] :
      ( v129307(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72819,axiom,
    ! [VarCurr: state_type] :
      ( v129301(VarCurr)
    <=> v129303(VarCurr) ) ).

tff(addAssignment_72818,axiom,
    ! [VarCurr: state_type] :
      ( v129303(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v129187(VarCurr)
      <=> v129290(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1276,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v129187(VarCurr)
      <=> v129289(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5900,axiom,
    ! [VarCurr: state_type] :
      ( v129290(VarCurr)
    <=> ( v129230(VarCurr)
        & v129189(VarCurr,2) ) ) ).

tff(addAssignment_72817,axiom,
    ! [VarCurr: state_type] :
      ( v129289(VarCurr)
    <=> v129230(VarCurr) ) ).

tff(addAssignment_72816,axiom,
    ! [VarCurr: state_type] :
      ( v129189(VarCurr,2)
    <=> v129191(VarCurr,2) ) ).

tff(addAssignment_72815,axiom,
    ! [VarCurr: state_type] :
      ( v129191(VarCurr,2)
    <=> v129193(VarCurr,2) ) ).

tff(addAssignment_72814,axiom,
    ! [VarNext: state_type] :
      ( v129193(VarNext,2)
    <=> v129281(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129281(VarNext,B)
            <=> v129193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1701,axiom,
    ! [VarNext: state_type] :
      ( v129282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129281(VarNext,B)
          <=> v129274(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129282(VarNext)
      <=> v129283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129283(VarNext)
      <=> ( v129285(VarNext)
          & v129259(VarNext) ) ) ) ).

tff(writeUnaryOperator_9344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129285(VarNext)
      <=> v129268(VarNext) ) ) ).

tff(addAssignment_72813,axiom,
    ! [VarCurr: state_type] :
      ( v129203(VarCurr,2)
    <=> v129205(VarCurr,2) ) ).

tff(addAssignment_72812,axiom,
    ! [VarCurr: state_type] :
      ( v129205(VarCurr,2)
    <=> v129254(VarCurr,2) ) ).

tff(addAssignment_72811,axiom,
    ! [VarCurr: state_type] :
      ( v129207(VarCurr,2)
    <=> v129209(VarCurr,2) ) ).

tff(addAssignment_72810,axiom,
    ! [VarCurr: state_type] :
      ( v129209(VarCurr,2)
    <=> v129222(VarCurr,2) ) ).

tff(addAssignment_72809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129189(VarCurr,B)
      <=> v129191(VarCurr,B) ) ) ).

tff(addAssignment_72808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129191(VarCurr,B)
      <=> v129193(VarCurr,B) ) ) ).

tff(addAssignment_72807,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129193(VarNext,B)
      <=> v129263(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129264(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129263(VarNext,B)
            <=> v129193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1700,axiom,
    ! [VarNext: state_type] :
      ( v129264(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129263(VarNext,B)
          <=> v129274(VarNext,B) ) ) ) ).

tff(addAssignment_72806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129274(VarNext,B)
          <=> v129272(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129272(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1275,axiom,
    ! [VarCurr: state_type] :
      ( v129275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129272(VarCurr,B)
          <=> v129203(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16721,axiom,
    ! [VarCurr: state_type] :
      ( v129275(VarCurr)
    <=> ( v129276(VarCurr)
        & v129277(VarCurr) ) ) ).

tff(writeUnaryOperator_9343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129277(VarCurr)
    <=> v129199(VarCurr) ) ).

tff(writeUnaryOperator_9342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129276(VarCurr)
    <=> v129195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129264(VarNext)
      <=> v129265(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129265(VarNext)
      <=> ( v129266(VarNext)
          & v129259(VarNext) ) ) ) ).

tff(writeUnaryOperator_9341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129266(VarNext)
      <=> v129268(VarNext) ) ) ).

tff(addAssignment_72805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129268(VarNext)
      <=> v129259(VarCurr) ) ) ).

tff(addAssignment_72804,axiom,
    ! [VarCurr: state_type] :
      ( v129259(VarCurr)
    <=> v129261(VarCurr) ) ).

tff(addAssignment_72803,axiom,
    ! [VarCurr: state_type] :
      ( v129261(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129203(VarCurr,B)
      <=> v129205(VarCurr,B) ) ) ).

tff(addAssignment_72801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129205(VarCurr,B)
      <=> v129254(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129254(VarCurr,B)
      <=> ( v129207(VarCurr,B)
          & v129255(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129255(VarCurr,B)
      <=> ~ v129256(VarCurr,B) ) ) ).

tff(addAssignment_72800,axiom,
    ! [VarCurr: state_type] :
      ( v129256(VarCurr,0)
    <=> v129257(VarCurr) ) ).

tff(addAssignment_72799,axiom,
    ! [VarCurr: state_type] :
      ( v129256(VarCurr,1)
    <=> v129257(VarCurr) ) ).

tff(addAssignment_72798,axiom,
    ! [VarCurr: state_type] :
      ( v129256(VarCurr,2)
    <=> v129257(VarCurr) ) ).

tff(addAssignment_72797,axiom,
    ! [VarCurr: state_type] :
      ( v129257(VarCurr)
    <=> v129253(VarCurr) ) ).

tff(addAssignment_72796,axiom,
    ! [VarCurr: state_type] :
      ( v129253(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129207(VarCurr,B)
      <=> v129209(VarCurr,B) ) ) ).

tff(addAssignment_72794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129209(VarCurr,B)
      <=> v129222(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129223(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129222(VarCurr,B)
          <=> v129238(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1274,axiom,
    ! [VarCurr: state_type] :
      ( v129223(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129222(VarCurr,B)
          <=> v129225(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129238(VarCurr,B)
          <=> v129189(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1273,axiom,
    ! [VarCurr: state_type] :
      ( v129239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129238(VarCurr,B)
          <=> v129241(VarCurr,B) ) ) ) ).

tff(addAssignment_72793,axiom,
    ! [VarCurr: state_type] :
      ( v129241(VarCurr,0)
    <=> v129235(VarCurr) ) ).

tff(addAssignment_72792,axiom,
    ! [VarCurr: state_type] :
      ( v129241(VarCurr,1)
    <=> v129249(VarCurr) ) ).

tff(addAssignment_72791,axiom,
    ! [VarCurr: state_type] :
      ( v129241(VarCurr,2)
    <=> v129243(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16718,axiom,
    ! [VarCurr: state_type] :
      ( v129249(VarCurr)
    <=> ( v129250(VarCurr)
        & v129251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16717,axiom,
    ! [VarCurr: state_type] :
      ( v129251(VarCurr)
    <=> ( v129189(VarCurr,0)
        | v129236(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5899,axiom,
    ! [VarCurr: state_type] :
      ( v129250(VarCurr)
    <=> ( v129235(VarCurr)
        | v129189(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16716,axiom,
    ! [VarCurr: state_type] :
      ( v129243(VarCurr)
    <=> ( v129244(VarCurr)
        & v129248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16715,axiom,
    ! [VarCurr: state_type] :
      ( v129248(VarCurr)
    <=> ( v129231(VarCurr)
        | v129246(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5898,axiom,
    ! [VarCurr: state_type] :
      ( v129244(VarCurr)
    <=> ( v129189(VarCurr,2)
        | v129245(VarCurr) ) ) ).

tff(writeUnaryOperator_9339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129245(VarCurr)
    <=> v129246(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5897,axiom,
    ! [VarCurr: state_type] :
      ( v129246(VarCurr)
    <=> ( v129189(VarCurr,1)
        | v129247(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16714,axiom,
    ! [VarCurr: state_type] :
      ( v129247(VarCurr)
    <=> ( v129189(VarCurr,0)
        & v129236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16713,axiom,
    ! [VarCurr: state_type] :
      ( v129239(VarCurr)
    <=> ( v129240(VarCurr)
        & v129215(VarCurr) ) ) ).

tff(writeUnaryOperator_9338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129240(VarCurr)
    <=> v129211(VarCurr) ) ).

tff(addAssignment_72790,axiom,
    ! [VarCurr: state_type] :
      ( v129225(VarCurr,0)
    <=> v129235(VarCurr) ) ).

tff(addAssignment_72789,axiom,
    ! [VarCurr: state_type] :
      ( v129225(VarCurr,1)
    <=> v129233(VarCurr) ) ).

tff(addAssignment_72788,axiom,
    ! [VarCurr: state_type] :
      ( v129225(VarCurr,2)
    <=> v129227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16712,axiom,
    ! [VarCurr: state_type] :
      ( v129233(VarCurr)
    <=> ( v129234(VarCurr)
        & v129237(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5896,axiom,
    ! [VarCurr: state_type] :
      ( v129237(VarCurr)
    <=> ( v129189(VarCurr,0)
        | v129189(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16711,axiom,
    ! [VarCurr: state_type] :
      ( v129234(VarCurr)
    <=> ( v129235(VarCurr)
        | v129236(VarCurr) ) ) ).

tff(writeUnaryOperator_9337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129236(VarCurr)
    <=> v129189(VarCurr,1) ) ).

tff(writeUnaryOperator_9336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129235(VarCurr)
    <=> v129189(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16710,axiom,
    ! [VarCurr: state_type] :
      ( v129227(VarCurr)
    <=> ( v129228(VarCurr)
        & v129232(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5895,axiom,
    ! [VarCurr: state_type] :
      ( v129232(VarCurr)
    <=> ( v129230(VarCurr)
        | v129189(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16709,axiom,
    ! [VarCurr: state_type] :
      ( v129228(VarCurr)
    <=> ( v129229(VarCurr)
        | v129231(VarCurr) ) ) ).

tff(writeUnaryOperator_9335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129231(VarCurr)
    <=> v129189(VarCurr,2) ) ).

tff(writeUnaryOperator_9334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129229(VarCurr)
    <=> v129230(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5894,axiom,
    ! [VarCurr: state_type] :
      ( v129230(VarCurr)
    <=> ( v129189(VarCurr,0)
        & v129189(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16708,axiom,
    ! [VarCurr: state_type] :
      ( v129223(VarCurr)
    <=> ( v129211(VarCurr)
        & v129224(VarCurr) ) ) ).

tff(writeUnaryOperator_9333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129224(VarCurr)
    <=> v129215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16707,axiom,
    ! [VarCurr: state_type] :
      ( v129215(VarCurr)
    <=> ( v129217(VarCurr)
        | v129220(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5893,axiom,
    ! [VarCurr: state_type] :
      ( v129220(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v129221(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1579,axiom,
    ! [VarCurr: state_type] :
      ( v129221(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16706,axiom,
    ! [VarCurr: state_type] :
      ( v129217(VarCurr)
    <=> ( v129218(VarCurr)
        & v129219(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1578,axiom,
    ! [VarCurr: state_type] :
      ( v129219(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5892,axiom,
    ! [VarCurr: state_type] :
      ( v129218(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16705,axiom,
    ! [VarCurr: state_type] :
      ( v129211(VarCurr)
    <=> ( v97276(VarCurr)
        & v129213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1577,axiom,
    ! [VarCurr: state_type] :
      ( v129213(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $true )
        & ( v97409(VarCurr,4)
        <=> $true )
        & ( v97409(VarCurr,3)
        <=> $false ) ) ) ).

tff(addAssignment_72787,axiom,
    ! [VarCurr: state_type] :
      ( v129199(VarCurr)
    <=> v129201(VarCurr) ) ).

tff(addAssignment_72786,axiom,
    ! [VarCurr: state_type] :
      ( v129201(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72785,axiom,
    ! [VarCurr: state_type] :
      ( v129195(VarCurr)
    <=> v129197(VarCurr) ) ).

tff(addAssignment_72784,axiom,
    ! [VarCurr: state_type] :
      ( v129197(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v129081(VarCurr)
      <=> v129184(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1272,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v129081(VarCurr)
      <=> v129183(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5891,axiom,
    ! [VarCurr: state_type] :
      ( v129184(VarCurr)
    <=> ( v129124(VarCurr)
        & v129083(VarCurr,2) ) ) ).

tff(addAssignment_72783,axiom,
    ! [VarCurr: state_type] :
      ( v129183(VarCurr)
    <=> v129124(VarCurr) ) ).

tff(addAssignment_72782,axiom,
    ! [VarCurr: state_type] :
      ( v129083(VarCurr,2)
    <=> v129085(VarCurr,2) ) ).

tff(addAssignment_72781,axiom,
    ! [VarCurr: state_type] :
      ( v129085(VarCurr,2)
    <=> v129087(VarCurr,2) ) ).

tff(addAssignment_72780,axiom,
    ! [VarNext: state_type] :
      ( v129087(VarNext,2)
    <=> v129175(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129176(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129175(VarNext,B)
            <=> v129087(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1699,axiom,
    ! [VarNext: state_type] :
      ( v129176(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129175(VarNext,B)
          <=> v129168(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129176(VarNext)
      <=> v129177(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129177(VarNext)
      <=> ( v129179(VarNext)
          & v129153(VarNext) ) ) ) ).

tff(writeUnaryOperator_9332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129179(VarNext)
      <=> v129162(VarNext) ) ) ).

tff(addAssignment_72779,axiom,
    ! [VarCurr: state_type] :
      ( v129097(VarCurr,2)
    <=> v129099(VarCurr,2) ) ).

tff(addAssignment_72778,axiom,
    ! [VarCurr: state_type] :
      ( v129099(VarCurr,2)
    <=> v129148(VarCurr,2) ) ).

tff(addAssignment_72777,axiom,
    ! [VarCurr: state_type] :
      ( v129101(VarCurr,2)
    <=> v129103(VarCurr,2) ) ).

tff(addAssignment_72776,axiom,
    ! [VarCurr: state_type] :
      ( v129103(VarCurr,2)
    <=> v129116(VarCurr,2) ) ).

tff(addAssignment_72775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129083(VarCurr,B)
      <=> v129085(VarCurr,B) ) ) ).

tff(addAssignment_72774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129085(VarCurr,B)
      <=> v129087(VarCurr,B) ) ) ).

tff(addAssignment_72773,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129087(VarNext,B)
      <=> v129157(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129158(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129157(VarNext,B)
            <=> v129087(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1698,axiom,
    ! [VarNext: state_type] :
      ( v129158(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129157(VarNext,B)
          <=> v129168(VarNext,B) ) ) ) ).

tff(addAssignment_72772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129168(VarNext,B)
          <=> v129166(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129169(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129166(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1271,axiom,
    ! [VarCurr: state_type] :
      ( v129169(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129166(VarCurr,B)
          <=> v129097(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16702,axiom,
    ! [VarCurr: state_type] :
      ( v129169(VarCurr)
    <=> ( v129170(VarCurr)
        & v129171(VarCurr) ) ) ).

tff(writeUnaryOperator_9331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129171(VarCurr)
    <=> v129093(VarCurr) ) ).

tff(writeUnaryOperator_9330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129170(VarCurr)
    <=> v129089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129158(VarNext)
      <=> v129159(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129159(VarNext)
      <=> ( v129160(VarNext)
          & v129153(VarNext) ) ) ) ).

tff(writeUnaryOperator_9329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129160(VarNext)
      <=> v129162(VarNext) ) ) ).

tff(addAssignment_72771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129162(VarNext)
      <=> v129153(VarCurr) ) ) ).

tff(addAssignment_72770,axiom,
    ! [VarCurr: state_type] :
      ( v129153(VarCurr)
    <=> v129155(VarCurr) ) ).

tff(addAssignment_72769,axiom,
    ! [VarCurr: state_type] :
      ( v129155(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129097(VarCurr,B)
      <=> v129099(VarCurr,B) ) ) ).

tff(addAssignment_72767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129099(VarCurr,B)
      <=> v129148(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129148(VarCurr,B)
      <=> ( v129101(VarCurr,B)
          & v129149(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129149(VarCurr,B)
      <=> ~ v129150(VarCurr,B) ) ) ).

tff(addAssignment_72766,axiom,
    ! [VarCurr: state_type] :
      ( v129150(VarCurr,0)
    <=> v129151(VarCurr) ) ).

tff(addAssignment_72765,axiom,
    ! [VarCurr: state_type] :
      ( v129150(VarCurr,1)
    <=> v129151(VarCurr) ) ).

tff(addAssignment_72764,axiom,
    ! [VarCurr: state_type] :
      ( v129150(VarCurr,2)
    <=> v129151(VarCurr) ) ).

tff(addAssignment_72763,axiom,
    ! [VarCurr: state_type] :
      ( v129151(VarCurr)
    <=> v129147(VarCurr) ) ).

tff(addAssignment_72762,axiom,
    ! [VarCurr: state_type] :
      ( v129147(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129101(VarCurr,B)
      <=> v129103(VarCurr,B) ) ) ).

tff(addAssignment_72760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v129103(VarCurr,B)
      <=> v129116(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129117(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129116(VarCurr,B)
          <=> v129132(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1270,axiom,
    ! [VarCurr: state_type] :
      ( v129117(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129116(VarCurr,B)
          <=> v129119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129133(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129132(VarCurr,B)
          <=> v129083(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1269,axiom,
    ! [VarCurr: state_type] :
      ( v129133(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129132(VarCurr,B)
          <=> v129135(VarCurr,B) ) ) ) ).

tff(addAssignment_72759,axiom,
    ! [VarCurr: state_type] :
      ( v129135(VarCurr,0)
    <=> v129129(VarCurr) ) ).

tff(addAssignment_72758,axiom,
    ! [VarCurr: state_type] :
      ( v129135(VarCurr,1)
    <=> v129143(VarCurr) ) ).

tff(addAssignment_72757,axiom,
    ! [VarCurr: state_type] :
      ( v129135(VarCurr,2)
    <=> v129137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16699,axiom,
    ! [VarCurr: state_type] :
      ( v129143(VarCurr)
    <=> ( v129144(VarCurr)
        & v129145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16698,axiom,
    ! [VarCurr: state_type] :
      ( v129145(VarCurr)
    <=> ( v129083(VarCurr,0)
        | v129130(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5890,axiom,
    ! [VarCurr: state_type] :
      ( v129144(VarCurr)
    <=> ( v129129(VarCurr)
        | v129083(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16697,axiom,
    ! [VarCurr: state_type] :
      ( v129137(VarCurr)
    <=> ( v129138(VarCurr)
        & v129142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16696,axiom,
    ! [VarCurr: state_type] :
      ( v129142(VarCurr)
    <=> ( v129125(VarCurr)
        | v129140(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5889,axiom,
    ! [VarCurr: state_type] :
      ( v129138(VarCurr)
    <=> ( v129083(VarCurr,2)
        | v129139(VarCurr) ) ) ).

tff(writeUnaryOperator_9327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129139(VarCurr)
    <=> v129140(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5888,axiom,
    ! [VarCurr: state_type] :
      ( v129140(VarCurr)
    <=> ( v129083(VarCurr,1)
        | v129141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16695,axiom,
    ! [VarCurr: state_type] :
      ( v129141(VarCurr)
    <=> ( v129083(VarCurr,0)
        & v129130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16694,axiom,
    ! [VarCurr: state_type] :
      ( v129133(VarCurr)
    <=> ( v129134(VarCurr)
        & v129109(VarCurr) ) ) ).

tff(writeUnaryOperator_9326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129134(VarCurr)
    <=> v129105(VarCurr) ) ).

tff(addAssignment_72756,axiom,
    ! [VarCurr: state_type] :
      ( v129119(VarCurr,0)
    <=> v129129(VarCurr) ) ).

tff(addAssignment_72755,axiom,
    ! [VarCurr: state_type] :
      ( v129119(VarCurr,1)
    <=> v129127(VarCurr) ) ).

tff(addAssignment_72754,axiom,
    ! [VarCurr: state_type] :
      ( v129119(VarCurr,2)
    <=> v129121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16693,axiom,
    ! [VarCurr: state_type] :
      ( v129127(VarCurr)
    <=> ( v129128(VarCurr)
        & v129131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5887,axiom,
    ! [VarCurr: state_type] :
      ( v129131(VarCurr)
    <=> ( v129083(VarCurr,0)
        | v129083(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16692,axiom,
    ! [VarCurr: state_type] :
      ( v129128(VarCurr)
    <=> ( v129129(VarCurr)
        | v129130(VarCurr) ) ) ).

tff(writeUnaryOperator_9325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129130(VarCurr)
    <=> v129083(VarCurr,1) ) ).

tff(writeUnaryOperator_9324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129129(VarCurr)
    <=> v129083(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16691,axiom,
    ! [VarCurr: state_type] :
      ( v129121(VarCurr)
    <=> ( v129122(VarCurr)
        & v129126(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5886,axiom,
    ! [VarCurr: state_type] :
      ( v129126(VarCurr)
    <=> ( v129124(VarCurr)
        | v129083(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16690,axiom,
    ! [VarCurr: state_type] :
      ( v129122(VarCurr)
    <=> ( v129123(VarCurr)
        | v129125(VarCurr) ) ) ).

tff(writeUnaryOperator_9323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129125(VarCurr)
    <=> v129083(VarCurr,2) ) ).

tff(writeUnaryOperator_9322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129123(VarCurr)
    <=> v129124(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5885,axiom,
    ! [VarCurr: state_type] :
      ( v129124(VarCurr)
    <=> ( v129083(VarCurr,0)
        & v129083(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16689,axiom,
    ! [VarCurr: state_type] :
      ( v129117(VarCurr)
    <=> ( v129105(VarCurr)
        & v129118(VarCurr) ) ) ).

tff(writeUnaryOperator_9321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129118(VarCurr)
    <=> v129109(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16688,axiom,
    ! [VarCurr: state_type] :
      ( v129109(VarCurr)
    <=> ( v129111(VarCurr)
        | v129114(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5884,axiom,
    ! [VarCurr: state_type] :
      ( v129114(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v129115(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1576,axiom,
    ! [VarCurr: state_type] :
      ( v129115(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16687,axiom,
    ! [VarCurr: state_type] :
      ( v129111(VarCurr)
    <=> ( v129112(VarCurr)
        & v129113(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1575,axiom,
    ! [VarCurr: state_type] :
      ( v129113(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5883,axiom,
    ! [VarCurr: state_type] :
      ( v129112(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16686,axiom,
    ! [VarCurr: state_type] :
      ( v129105(VarCurr)
    <=> ( v97276(VarCurr)
        & v129107(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1574,axiom,
    ! [VarCurr: state_type] :
      ( v129107(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $true )
        & ( v97409(VarCurr,4)
        <=> $false )
        & ( v97409(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_72753,axiom,
    ! [VarCurr: state_type] :
      ( v129093(VarCurr)
    <=> v129095(VarCurr) ) ).

tff(addAssignment_72752,axiom,
    ! [VarCurr: state_type] :
      ( v129095(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72751,axiom,
    ! [VarCurr: state_type] :
      ( v129089(VarCurr)
    <=> v129091(VarCurr) ) ).

tff(addAssignment_72750,axiom,
    ! [VarCurr: state_type] :
      ( v129091(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v128975(VarCurr)
      <=> v129078(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1268,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v128975(VarCurr)
      <=> v129077(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5882,axiom,
    ! [VarCurr: state_type] :
      ( v129078(VarCurr)
    <=> ( v129018(VarCurr)
        & v128977(VarCurr,2) ) ) ).

tff(addAssignment_72749,axiom,
    ! [VarCurr: state_type] :
      ( v129077(VarCurr)
    <=> v129018(VarCurr) ) ).

tff(addAssignment_72748,axiom,
    ! [VarCurr: state_type] :
      ( v128977(VarCurr,2)
    <=> v128979(VarCurr,2) ) ).

tff(addAssignment_72747,axiom,
    ! [VarCurr: state_type] :
      ( v128979(VarCurr,2)
    <=> v128981(VarCurr,2) ) ).

tff(addAssignment_72746,axiom,
    ! [VarNext: state_type] :
      ( v128981(VarNext,2)
    <=> v129069(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129070(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129069(VarNext,B)
            <=> v128981(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1697,axiom,
    ! [VarNext: state_type] :
      ( v129070(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129069(VarNext,B)
          <=> v129062(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129070(VarNext)
      <=> v129071(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129071(VarNext)
      <=> ( v129073(VarNext)
          & v129047(VarNext) ) ) ) ).

tff(writeUnaryOperator_9320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129073(VarNext)
      <=> v129056(VarNext) ) ) ).

tff(addAssignment_72745,axiom,
    ! [VarCurr: state_type] :
      ( v128991(VarCurr,2)
    <=> v128993(VarCurr,2) ) ).

tff(addAssignment_72744,axiom,
    ! [VarCurr: state_type] :
      ( v128993(VarCurr,2)
    <=> v129042(VarCurr,2) ) ).

tff(addAssignment_72743,axiom,
    ! [VarCurr: state_type] :
      ( v128995(VarCurr,2)
    <=> v128997(VarCurr,2) ) ).

tff(addAssignment_72742,axiom,
    ! [VarCurr: state_type] :
      ( v128997(VarCurr,2)
    <=> v129010(VarCurr,2) ) ).

tff(addAssignment_72741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128977(VarCurr,B)
      <=> v128979(VarCurr,B) ) ) ).

tff(addAssignment_72740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128979(VarCurr,B)
      <=> v128981(VarCurr,B) ) ) ).

tff(addAssignment_72739,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128981(VarNext,B)
      <=> v129051(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129052(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v129051(VarNext,B)
            <=> v128981(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1696,axiom,
    ! [VarNext: state_type] :
      ( v129052(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129051(VarNext,B)
          <=> v129062(VarNext,B) ) ) ) ).

tff(addAssignment_72738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129062(VarNext,B)
          <=> v129060(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129063(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129060(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1267,axiom,
    ! [VarCurr: state_type] :
      ( v129063(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129060(VarCurr,B)
          <=> v128991(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16683,axiom,
    ! [VarCurr: state_type] :
      ( v129063(VarCurr)
    <=> ( v129064(VarCurr)
        & v129065(VarCurr) ) ) ).

tff(writeUnaryOperator_9319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129065(VarCurr)
    <=> v128987(VarCurr) ) ).

tff(writeUnaryOperator_9318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129064(VarCurr)
    <=> v128983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129052(VarNext)
      <=> v129053(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129053(VarNext)
      <=> ( v129054(VarNext)
          & v129047(VarNext) ) ) ) ).

tff(writeUnaryOperator_9317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v129054(VarNext)
      <=> v129056(VarNext) ) ) ).

tff(addAssignment_72737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v129056(VarNext)
      <=> v129047(VarCurr) ) ) ).

tff(addAssignment_72736,axiom,
    ! [VarCurr: state_type] :
      ( v129047(VarCurr)
    <=> v129049(VarCurr) ) ).

tff(addAssignment_72735,axiom,
    ! [VarCurr: state_type] :
      ( v129049(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128991(VarCurr,B)
      <=> v128993(VarCurr,B) ) ) ).

tff(addAssignment_72733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128993(VarCurr,B)
      <=> v129042(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129042(VarCurr,B)
      <=> ( v128995(VarCurr,B)
          & v129043(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v129043(VarCurr,B)
      <=> ~ v129044(VarCurr,B) ) ) ).

tff(addAssignment_72732,axiom,
    ! [VarCurr: state_type] :
      ( v129044(VarCurr,0)
    <=> v129045(VarCurr) ) ).

tff(addAssignment_72731,axiom,
    ! [VarCurr: state_type] :
      ( v129044(VarCurr,1)
    <=> v129045(VarCurr) ) ).

tff(addAssignment_72730,axiom,
    ! [VarCurr: state_type] :
      ( v129044(VarCurr,2)
    <=> v129045(VarCurr) ) ).

tff(addAssignment_72729,axiom,
    ! [VarCurr: state_type] :
      ( v129045(VarCurr)
    <=> v129041(VarCurr) ) ).

tff(addAssignment_72728,axiom,
    ! [VarCurr: state_type] :
      ( v129041(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128995(VarCurr,B)
      <=> v128997(VarCurr,B) ) ) ).

tff(addAssignment_72726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128997(VarCurr,B)
      <=> v129010(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129011(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129010(VarCurr,B)
          <=> v129026(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1266,axiom,
    ! [VarCurr: state_type] :
      ( v129011(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129010(VarCurr,B)
          <=> v129013(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129027(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129026(VarCurr,B)
          <=> v128977(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1265,axiom,
    ! [VarCurr: state_type] :
      ( v129027(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v129026(VarCurr,B)
          <=> v129029(VarCurr,B) ) ) ) ).

tff(addAssignment_72725,axiom,
    ! [VarCurr: state_type] :
      ( v129029(VarCurr,0)
    <=> v129023(VarCurr) ) ).

tff(addAssignment_72724,axiom,
    ! [VarCurr: state_type] :
      ( v129029(VarCurr,1)
    <=> v129037(VarCurr) ) ).

tff(addAssignment_72723,axiom,
    ! [VarCurr: state_type] :
      ( v129029(VarCurr,2)
    <=> v129031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16680,axiom,
    ! [VarCurr: state_type] :
      ( v129037(VarCurr)
    <=> ( v129038(VarCurr)
        & v129039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16679,axiom,
    ! [VarCurr: state_type] :
      ( v129039(VarCurr)
    <=> ( v128977(VarCurr,0)
        | v129024(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5881,axiom,
    ! [VarCurr: state_type] :
      ( v129038(VarCurr)
    <=> ( v129023(VarCurr)
        | v128977(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16678,axiom,
    ! [VarCurr: state_type] :
      ( v129031(VarCurr)
    <=> ( v129032(VarCurr)
        & v129036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16677,axiom,
    ! [VarCurr: state_type] :
      ( v129036(VarCurr)
    <=> ( v129019(VarCurr)
        | v129034(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5880,axiom,
    ! [VarCurr: state_type] :
      ( v129032(VarCurr)
    <=> ( v128977(VarCurr,2)
        | v129033(VarCurr) ) ) ).

tff(writeUnaryOperator_9315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129033(VarCurr)
    <=> v129034(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5879,axiom,
    ! [VarCurr: state_type] :
      ( v129034(VarCurr)
    <=> ( v128977(VarCurr,1)
        | v129035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16676,axiom,
    ! [VarCurr: state_type] :
      ( v129035(VarCurr)
    <=> ( v128977(VarCurr,0)
        & v129024(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16675,axiom,
    ! [VarCurr: state_type] :
      ( v129027(VarCurr)
    <=> ( v129028(VarCurr)
        & v129003(VarCurr) ) ) ).

tff(writeUnaryOperator_9314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129028(VarCurr)
    <=> v128999(VarCurr) ) ).

tff(addAssignment_72722,axiom,
    ! [VarCurr: state_type] :
      ( v129013(VarCurr,0)
    <=> v129023(VarCurr) ) ).

tff(addAssignment_72721,axiom,
    ! [VarCurr: state_type] :
      ( v129013(VarCurr,1)
    <=> v129021(VarCurr) ) ).

tff(addAssignment_72720,axiom,
    ! [VarCurr: state_type] :
      ( v129013(VarCurr,2)
    <=> v129015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16674,axiom,
    ! [VarCurr: state_type] :
      ( v129021(VarCurr)
    <=> ( v129022(VarCurr)
        & v129025(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5878,axiom,
    ! [VarCurr: state_type] :
      ( v129025(VarCurr)
    <=> ( v128977(VarCurr,0)
        | v128977(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16673,axiom,
    ! [VarCurr: state_type] :
      ( v129022(VarCurr)
    <=> ( v129023(VarCurr)
        | v129024(VarCurr) ) ) ).

tff(writeUnaryOperator_9313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129024(VarCurr)
    <=> v128977(VarCurr,1) ) ).

tff(writeUnaryOperator_9312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129023(VarCurr)
    <=> v128977(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16672,axiom,
    ! [VarCurr: state_type] :
      ( v129015(VarCurr)
    <=> ( v129016(VarCurr)
        & v129020(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5877,axiom,
    ! [VarCurr: state_type] :
      ( v129020(VarCurr)
    <=> ( v129018(VarCurr)
        | v128977(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16671,axiom,
    ! [VarCurr: state_type] :
      ( v129016(VarCurr)
    <=> ( v129017(VarCurr)
        | v129019(VarCurr) ) ) ).

tff(writeUnaryOperator_9311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129019(VarCurr)
    <=> v128977(VarCurr,2) ) ).

tff(writeUnaryOperator_9310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129017(VarCurr)
    <=> v129018(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5876,axiom,
    ! [VarCurr: state_type] :
      ( v129018(VarCurr)
    <=> ( v128977(VarCurr,0)
        & v128977(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16670,axiom,
    ! [VarCurr: state_type] :
      ( v129011(VarCurr)
    <=> ( v128999(VarCurr)
        & v129012(VarCurr) ) ) ).

tff(writeUnaryOperator_9309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v129012(VarCurr)
    <=> v129003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16669,axiom,
    ! [VarCurr: state_type] :
      ( v129003(VarCurr)
    <=> ( v129005(VarCurr)
        | v129008(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5875,axiom,
    ! [VarCurr: state_type] :
      ( v129008(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v129009(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1573,axiom,
    ! [VarCurr: state_type] :
      ( v129009(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16668,axiom,
    ! [VarCurr: state_type] :
      ( v129005(VarCurr)
    <=> ( v129006(VarCurr)
        & v129007(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1572,axiom,
    ! [VarCurr: state_type] :
      ( v129007(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5874,axiom,
    ! [VarCurr: state_type] :
      ( v129006(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16667,axiom,
    ! [VarCurr: state_type] :
      ( v128999(VarCurr)
    <=> ( v97276(VarCurr)
        & v129001(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1571,axiom,
    ! [VarCurr: state_type] :
      ( v129001(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $true )
        & ( v97409(VarCurr,4)
        <=> $false )
        & ( v97409(VarCurr,3)
        <=> $false ) ) ) ).

tff(addAssignment_72719,axiom,
    ! [VarCurr: state_type] :
      ( v128987(VarCurr)
    <=> v128989(VarCurr) ) ).

tff(addAssignment_72718,axiom,
    ! [VarCurr: state_type] :
      ( v128989(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72717,axiom,
    ! [VarCurr: state_type] :
      ( v128983(VarCurr)
    <=> v128985(VarCurr) ) ).

tff(addAssignment_72716,axiom,
    ! [VarCurr: state_type] :
      ( v128985(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v128869(VarCurr)
      <=> v128972(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1264,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v128869(VarCurr)
      <=> v128971(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5873,axiom,
    ! [VarCurr: state_type] :
      ( v128972(VarCurr)
    <=> ( v128912(VarCurr)
        & v128871(VarCurr,2) ) ) ).

tff(addAssignment_72715,axiom,
    ! [VarCurr: state_type] :
      ( v128971(VarCurr)
    <=> v128912(VarCurr) ) ).

tff(addAssignment_72714,axiom,
    ! [VarCurr: state_type] :
      ( v128871(VarCurr,2)
    <=> v128873(VarCurr,2) ) ).

tff(addAssignment_72713,axiom,
    ! [VarCurr: state_type] :
      ( v128873(VarCurr,2)
    <=> v128875(VarCurr,2) ) ).

tff(addAssignment_72712,axiom,
    ! [VarNext: state_type] :
      ( v128875(VarNext,2)
    <=> v128963(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128964(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128963(VarNext,B)
            <=> v128875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1695,axiom,
    ! [VarNext: state_type] :
      ( v128964(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128963(VarNext,B)
          <=> v128956(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128964(VarNext)
      <=> v128965(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128965(VarNext)
      <=> ( v128967(VarNext)
          & v128941(VarNext) ) ) ) ).

tff(writeUnaryOperator_9308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128967(VarNext)
      <=> v128950(VarNext) ) ) ).

tff(addAssignment_72711,axiom,
    ! [VarCurr: state_type] :
      ( v128885(VarCurr,2)
    <=> v128887(VarCurr,2) ) ).

tff(addAssignment_72710,axiom,
    ! [VarCurr: state_type] :
      ( v128887(VarCurr,2)
    <=> v128936(VarCurr,2) ) ).

tff(addAssignment_72709,axiom,
    ! [VarCurr: state_type] :
      ( v128889(VarCurr,2)
    <=> v128891(VarCurr,2) ) ).

tff(addAssignment_72708,axiom,
    ! [VarCurr: state_type] :
      ( v128891(VarCurr,2)
    <=> v128904(VarCurr,2) ) ).

tff(addAssignment_72707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128871(VarCurr,B)
      <=> v128873(VarCurr,B) ) ) ).

tff(addAssignment_72706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128873(VarCurr,B)
      <=> v128875(VarCurr,B) ) ) ).

tff(addAssignment_72705,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128875(VarNext,B)
      <=> v128945(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128946(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128945(VarNext,B)
            <=> v128875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1694,axiom,
    ! [VarNext: state_type] :
      ( v128946(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128945(VarNext,B)
          <=> v128956(VarNext,B) ) ) ) ).

tff(addAssignment_72704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128956(VarNext,B)
          <=> v128954(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128957(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128954(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1263,axiom,
    ! [VarCurr: state_type] :
      ( v128957(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128954(VarCurr,B)
          <=> v128885(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16664,axiom,
    ! [VarCurr: state_type] :
      ( v128957(VarCurr)
    <=> ( v128958(VarCurr)
        & v128959(VarCurr) ) ) ).

tff(writeUnaryOperator_9307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128959(VarCurr)
    <=> v128881(VarCurr) ) ).

tff(writeUnaryOperator_9306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128958(VarCurr)
    <=> v128877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128946(VarNext)
      <=> v128947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128947(VarNext)
      <=> ( v128948(VarNext)
          & v128941(VarNext) ) ) ) ).

tff(writeUnaryOperator_9305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128948(VarNext)
      <=> v128950(VarNext) ) ) ).

tff(addAssignment_72703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128950(VarNext)
      <=> v128941(VarCurr) ) ) ).

tff(addAssignment_72702,axiom,
    ! [VarCurr: state_type] :
      ( v128941(VarCurr)
    <=> v128943(VarCurr) ) ).

tff(addAssignment_72701,axiom,
    ! [VarCurr: state_type] :
      ( v128943(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128885(VarCurr,B)
      <=> v128887(VarCurr,B) ) ) ).

tff(addAssignment_72699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128887(VarCurr,B)
      <=> v128936(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128936(VarCurr,B)
      <=> ( v128889(VarCurr,B)
          & v128937(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128937(VarCurr,B)
      <=> ~ v128938(VarCurr,B) ) ) ).

tff(addAssignment_72698,axiom,
    ! [VarCurr: state_type] :
      ( v128938(VarCurr,0)
    <=> v128939(VarCurr) ) ).

tff(addAssignment_72697,axiom,
    ! [VarCurr: state_type] :
      ( v128938(VarCurr,1)
    <=> v128939(VarCurr) ) ).

tff(addAssignment_72696,axiom,
    ! [VarCurr: state_type] :
      ( v128938(VarCurr,2)
    <=> v128939(VarCurr) ) ).

tff(addAssignment_72695,axiom,
    ! [VarCurr: state_type] :
      ( v128939(VarCurr)
    <=> v128935(VarCurr) ) ).

tff(addAssignment_72694,axiom,
    ! [VarCurr: state_type] :
      ( v128935(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128889(VarCurr,B)
      <=> v128891(VarCurr,B) ) ) ).

tff(addAssignment_72692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128891(VarCurr,B)
      <=> v128904(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128904(VarCurr,B)
          <=> v128920(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1262,axiom,
    ! [VarCurr: state_type] :
      ( v128905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128904(VarCurr,B)
          <=> v128907(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128920(VarCurr,B)
          <=> v128871(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1261,axiom,
    ! [VarCurr: state_type] :
      ( v128921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128920(VarCurr,B)
          <=> v128923(VarCurr,B) ) ) ) ).

tff(addAssignment_72691,axiom,
    ! [VarCurr: state_type] :
      ( v128923(VarCurr,0)
    <=> v128917(VarCurr) ) ).

tff(addAssignment_72690,axiom,
    ! [VarCurr: state_type] :
      ( v128923(VarCurr,1)
    <=> v128931(VarCurr) ) ).

tff(addAssignment_72689,axiom,
    ! [VarCurr: state_type] :
      ( v128923(VarCurr,2)
    <=> v128925(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16661,axiom,
    ! [VarCurr: state_type] :
      ( v128931(VarCurr)
    <=> ( v128932(VarCurr)
        & v128933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16660,axiom,
    ! [VarCurr: state_type] :
      ( v128933(VarCurr)
    <=> ( v128871(VarCurr,0)
        | v128918(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5872,axiom,
    ! [VarCurr: state_type] :
      ( v128932(VarCurr)
    <=> ( v128917(VarCurr)
        | v128871(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16659,axiom,
    ! [VarCurr: state_type] :
      ( v128925(VarCurr)
    <=> ( v128926(VarCurr)
        & v128930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16658,axiom,
    ! [VarCurr: state_type] :
      ( v128930(VarCurr)
    <=> ( v128913(VarCurr)
        | v128928(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5871,axiom,
    ! [VarCurr: state_type] :
      ( v128926(VarCurr)
    <=> ( v128871(VarCurr,2)
        | v128927(VarCurr) ) ) ).

tff(writeUnaryOperator_9303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128927(VarCurr)
    <=> v128928(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5870,axiom,
    ! [VarCurr: state_type] :
      ( v128928(VarCurr)
    <=> ( v128871(VarCurr,1)
        | v128929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16657,axiom,
    ! [VarCurr: state_type] :
      ( v128929(VarCurr)
    <=> ( v128871(VarCurr,0)
        & v128918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16656,axiom,
    ! [VarCurr: state_type] :
      ( v128921(VarCurr)
    <=> ( v128922(VarCurr)
        & v128897(VarCurr) ) ) ).

tff(writeUnaryOperator_9302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128922(VarCurr)
    <=> v128893(VarCurr) ) ).

tff(addAssignment_72688,axiom,
    ! [VarCurr: state_type] :
      ( v128907(VarCurr,0)
    <=> v128917(VarCurr) ) ).

tff(addAssignment_72687,axiom,
    ! [VarCurr: state_type] :
      ( v128907(VarCurr,1)
    <=> v128915(VarCurr) ) ).

tff(addAssignment_72686,axiom,
    ! [VarCurr: state_type] :
      ( v128907(VarCurr,2)
    <=> v128909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16655,axiom,
    ! [VarCurr: state_type] :
      ( v128915(VarCurr)
    <=> ( v128916(VarCurr)
        & v128919(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5869,axiom,
    ! [VarCurr: state_type] :
      ( v128919(VarCurr)
    <=> ( v128871(VarCurr,0)
        | v128871(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16654,axiom,
    ! [VarCurr: state_type] :
      ( v128916(VarCurr)
    <=> ( v128917(VarCurr)
        | v128918(VarCurr) ) ) ).

tff(writeUnaryOperator_9301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128918(VarCurr)
    <=> v128871(VarCurr,1) ) ).

tff(writeUnaryOperator_9300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128917(VarCurr)
    <=> v128871(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16653,axiom,
    ! [VarCurr: state_type] :
      ( v128909(VarCurr)
    <=> ( v128910(VarCurr)
        & v128914(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5868,axiom,
    ! [VarCurr: state_type] :
      ( v128914(VarCurr)
    <=> ( v128912(VarCurr)
        | v128871(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16652,axiom,
    ! [VarCurr: state_type] :
      ( v128910(VarCurr)
    <=> ( v128911(VarCurr)
        | v128913(VarCurr) ) ) ).

tff(writeUnaryOperator_9299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128913(VarCurr)
    <=> v128871(VarCurr,2) ) ).

tff(writeUnaryOperator_9298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128911(VarCurr)
    <=> v128912(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5867,axiom,
    ! [VarCurr: state_type] :
      ( v128912(VarCurr)
    <=> ( v128871(VarCurr,0)
        & v128871(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16651,axiom,
    ! [VarCurr: state_type] :
      ( v128905(VarCurr)
    <=> ( v128893(VarCurr)
        & v128906(VarCurr) ) ) ).

tff(writeUnaryOperator_9297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128906(VarCurr)
    <=> v128897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16650,axiom,
    ! [VarCurr: state_type] :
      ( v128897(VarCurr)
    <=> ( v128899(VarCurr)
        | v128902(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5866,axiom,
    ! [VarCurr: state_type] :
      ( v128902(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v128903(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1570,axiom,
    ! [VarCurr: state_type] :
      ( v128903(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16649,axiom,
    ! [VarCurr: state_type] :
      ( v128899(VarCurr)
    <=> ( v128900(VarCurr)
        & v128901(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1569,axiom,
    ! [VarCurr: state_type] :
      ( v128901(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5865,axiom,
    ! [VarCurr: state_type] :
      ( v128900(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16648,axiom,
    ! [VarCurr: state_type] :
      ( v128893(VarCurr)
    <=> ( v97276(VarCurr)
        & v128895(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1568,axiom,
    ! [VarCurr: state_type] :
      ( v128895(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $false )
        & ( v97409(VarCurr,4)
        <=> $true )
        & ( v97409(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_72685,axiom,
    ! [VarCurr: state_type] :
      ( v128881(VarCurr)
    <=> v128883(VarCurr) ) ).

tff(addAssignment_72684,axiom,
    ! [VarCurr: state_type] :
      ( v128883(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72683,axiom,
    ! [VarCurr: state_type] :
      ( v128877(VarCurr)
    <=> v128879(VarCurr) ) ).

tff(addAssignment_72682,axiom,
    ! [VarCurr: state_type] :
      ( v128879(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v128763(VarCurr)
      <=> v128866(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1260,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v128763(VarCurr)
      <=> v128865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5864,axiom,
    ! [VarCurr: state_type] :
      ( v128866(VarCurr)
    <=> ( v128806(VarCurr)
        & v128765(VarCurr,2) ) ) ).

tff(addAssignment_72681,axiom,
    ! [VarCurr: state_type] :
      ( v128865(VarCurr)
    <=> v128806(VarCurr) ) ).

tff(addAssignment_72680,axiom,
    ! [VarCurr: state_type] :
      ( v128765(VarCurr,2)
    <=> v128767(VarCurr,2) ) ).

tff(addAssignment_72679,axiom,
    ! [VarCurr: state_type] :
      ( v128767(VarCurr,2)
    <=> v128769(VarCurr,2) ) ).

tff(addAssignment_72678,axiom,
    ! [VarNext: state_type] :
      ( v128769(VarNext,2)
    <=> v128857(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128858(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128857(VarNext,B)
            <=> v128769(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1693,axiom,
    ! [VarNext: state_type] :
      ( v128858(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128857(VarNext,B)
          <=> v128850(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128858(VarNext)
      <=> v128859(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128859(VarNext)
      <=> ( v128861(VarNext)
          & v128835(VarNext) ) ) ) ).

tff(writeUnaryOperator_9296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128861(VarNext)
      <=> v128844(VarNext) ) ) ).

tff(addAssignment_72677,axiom,
    ! [VarCurr: state_type] :
      ( v128779(VarCurr,2)
    <=> v128781(VarCurr,2) ) ).

tff(addAssignment_72676,axiom,
    ! [VarCurr: state_type] :
      ( v128781(VarCurr,2)
    <=> v128830(VarCurr,2) ) ).

tff(addAssignment_72675,axiom,
    ! [VarCurr: state_type] :
      ( v128783(VarCurr,2)
    <=> v128785(VarCurr,2) ) ).

tff(addAssignment_72674,axiom,
    ! [VarCurr: state_type] :
      ( v128785(VarCurr,2)
    <=> v128798(VarCurr,2) ) ).

tff(addAssignment_72673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128765(VarCurr,B)
      <=> v128767(VarCurr,B) ) ) ).

tff(addAssignment_72672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128767(VarCurr,B)
      <=> v128769(VarCurr,B) ) ) ).

tff(addAssignment_72671,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128769(VarNext,B)
      <=> v128839(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128840(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128839(VarNext,B)
            <=> v128769(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1692,axiom,
    ! [VarNext: state_type] :
      ( v128840(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128839(VarNext,B)
          <=> v128850(VarNext,B) ) ) ) ).

tff(addAssignment_72670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128850(VarNext,B)
          <=> v128848(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128848(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1259,axiom,
    ! [VarCurr: state_type] :
      ( v128851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128848(VarCurr,B)
          <=> v128779(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16645,axiom,
    ! [VarCurr: state_type] :
      ( v128851(VarCurr)
    <=> ( v128852(VarCurr)
        & v128853(VarCurr) ) ) ).

tff(writeUnaryOperator_9295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128853(VarCurr)
    <=> v128775(VarCurr) ) ).

tff(writeUnaryOperator_9294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128852(VarCurr)
    <=> v128771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128840(VarNext)
      <=> v128841(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128841(VarNext)
      <=> ( v128842(VarNext)
          & v128835(VarNext) ) ) ) ).

tff(writeUnaryOperator_9293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128842(VarNext)
      <=> v128844(VarNext) ) ) ).

tff(addAssignment_72669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128844(VarNext)
      <=> v128835(VarCurr) ) ) ).

tff(addAssignment_72668,axiom,
    ! [VarCurr: state_type] :
      ( v128835(VarCurr)
    <=> v128837(VarCurr) ) ).

tff(addAssignment_72667,axiom,
    ! [VarCurr: state_type] :
      ( v128837(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128779(VarCurr,B)
      <=> v128781(VarCurr,B) ) ) ).

tff(addAssignment_72665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128781(VarCurr,B)
      <=> v128830(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128830(VarCurr,B)
      <=> ( v128783(VarCurr,B)
          & v128831(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128831(VarCurr,B)
      <=> ~ v128832(VarCurr,B) ) ) ).

tff(addAssignment_72664,axiom,
    ! [VarCurr: state_type] :
      ( v128832(VarCurr,0)
    <=> v128833(VarCurr) ) ).

tff(addAssignment_72663,axiom,
    ! [VarCurr: state_type] :
      ( v128832(VarCurr,1)
    <=> v128833(VarCurr) ) ).

tff(addAssignment_72662,axiom,
    ! [VarCurr: state_type] :
      ( v128832(VarCurr,2)
    <=> v128833(VarCurr) ) ).

tff(addAssignment_72661,axiom,
    ! [VarCurr: state_type] :
      ( v128833(VarCurr)
    <=> v128829(VarCurr) ) ).

tff(addAssignment_72660,axiom,
    ! [VarCurr: state_type] :
      ( v128829(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128783(VarCurr,B)
      <=> v128785(VarCurr,B) ) ) ).

tff(addAssignment_72658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128785(VarCurr,B)
      <=> v128798(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128798(VarCurr,B)
          <=> v128814(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1258,axiom,
    ! [VarCurr: state_type] :
      ( v128799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128798(VarCurr,B)
          <=> v128801(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128814(VarCurr,B)
          <=> v128765(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1257,axiom,
    ! [VarCurr: state_type] :
      ( v128815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128814(VarCurr,B)
          <=> v128817(VarCurr,B) ) ) ) ).

tff(addAssignment_72657,axiom,
    ! [VarCurr: state_type] :
      ( v128817(VarCurr,0)
    <=> v128811(VarCurr) ) ).

tff(addAssignment_72656,axiom,
    ! [VarCurr: state_type] :
      ( v128817(VarCurr,1)
    <=> v128825(VarCurr) ) ).

tff(addAssignment_72655,axiom,
    ! [VarCurr: state_type] :
      ( v128817(VarCurr,2)
    <=> v128819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16642,axiom,
    ! [VarCurr: state_type] :
      ( v128825(VarCurr)
    <=> ( v128826(VarCurr)
        & v128827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16641,axiom,
    ! [VarCurr: state_type] :
      ( v128827(VarCurr)
    <=> ( v128765(VarCurr,0)
        | v128812(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5863,axiom,
    ! [VarCurr: state_type] :
      ( v128826(VarCurr)
    <=> ( v128811(VarCurr)
        | v128765(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16640,axiom,
    ! [VarCurr: state_type] :
      ( v128819(VarCurr)
    <=> ( v128820(VarCurr)
        & v128824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16639,axiom,
    ! [VarCurr: state_type] :
      ( v128824(VarCurr)
    <=> ( v128807(VarCurr)
        | v128822(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5862,axiom,
    ! [VarCurr: state_type] :
      ( v128820(VarCurr)
    <=> ( v128765(VarCurr,2)
        | v128821(VarCurr) ) ) ).

tff(writeUnaryOperator_9291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128821(VarCurr)
    <=> v128822(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5861,axiom,
    ! [VarCurr: state_type] :
      ( v128822(VarCurr)
    <=> ( v128765(VarCurr,1)
        | v128823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16638,axiom,
    ! [VarCurr: state_type] :
      ( v128823(VarCurr)
    <=> ( v128765(VarCurr,0)
        & v128812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16637,axiom,
    ! [VarCurr: state_type] :
      ( v128815(VarCurr)
    <=> ( v128816(VarCurr)
        & v128791(VarCurr) ) ) ).

tff(writeUnaryOperator_9290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128816(VarCurr)
    <=> v128787(VarCurr) ) ).

tff(addAssignment_72654,axiom,
    ! [VarCurr: state_type] :
      ( v128801(VarCurr,0)
    <=> v128811(VarCurr) ) ).

tff(addAssignment_72653,axiom,
    ! [VarCurr: state_type] :
      ( v128801(VarCurr,1)
    <=> v128809(VarCurr) ) ).

tff(addAssignment_72652,axiom,
    ! [VarCurr: state_type] :
      ( v128801(VarCurr,2)
    <=> v128803(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16636,axiom,
    ! [VarCurr: state_type] :
      ( v128809(VarCurr)
    <=> ( v128810(VarCurr)
        & v128813(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5860,axiom,
    ! [VarCurr: state_type] :
      ( v128813(VarCurr)
    <=> ( v128765(VarCurr,0)
        | v128765(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16635,axiom,
    ! [VarCurr: state_type] :
      ( v128810(VarCurr)
    <=> ( v128811(VarCurr)
        | v128812(VarCurr) ) ) ).

tff(writeUnaryOperator_9289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128812(VarCurr)
    <=> v128765(VarCurr,1) ) ).

tff(writeUnaryOperator_9288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128811(VarCurr)
    <=> v128765(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16634,axiom,
    ! [VarCurr: state_type] :
      ( v128803(VarCurr)
    <=> ( v128804(VarCurr)
        & v128808(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5859,axiom,
    ! [VarCurr: state_type] :
      ( v128808(VarCurr)
    <=> ( v128806(VarCurr)
        | v128765(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16633,axiom,
    ! [VarCurr: state_type] :
      ( v128804(VarCurr)
    <=> ( v128805(VarCurr)
        | v128807(VarCurr) ) ) ).

tff(writeUnaryOperator_9287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128807(VarCurr)
    <=> v128765(VarCurr,2) ) ).

tff(writeUnaryOperator_9286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128805(VarCurr)
    <=> v128806(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5858,axiom,
    ! [VarCurr: state_type] :
      ( v128806(VarCurr)
    <=> ( v128765(VarCurr,0)
        & v128765(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16632,axiom,
    ! [VarCurr: state_type] :
      ( v128799(VarCurr)
    <=> ( v128787(VarCurr)
        & v128800(VarCurr) ) ) ).

tff(writeUnaryOperator_9285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128800(VarCurr)
    <=> v128791(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16631,axiom,
    ! [VarCurr: state_type] :
      ( v128791(VarCurr)
    <=> ( v128793(VarCurr)
        | v128796(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5857,axiom,
    ! [VarCurr: state_type] :
      ( v128796(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v128797(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1567,axiom,
    ! [VarCurr: state_type] :
      ( v128797(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16630,axiom,
    ! [VarCurr: state_type] :
      ( v128793(VarCurr)
    <=> ( v128794(VarCurr)
        & v128795(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1566,axiom,
    ! [VarCurr: state_type] :
      ( v128795(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5856,axiom,
    ! [VarCurr: state_type] :
      ( v128794(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16629,axiom,
    ! [VarCurr: state_type] :
      ( v128787(VarCurr)
    <=> ( v97276(VarCurr)
        & v128789(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1565,axiom,
    ! [VarCurr: state_type] :
      ( v128789(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $false )
        & ( v97409(VarCurr,4)
        <=> $true )
        & ( v97409(VarCurr,3)
        <=> $false ) ) ) ).

tff(addAssignment_72651,axiom,
    ! [VarCurr: state_type] :
      ( v128775(VarCurr)
    <=> v128777(VarCurr) ) ).

tff(addAssignment_72650,axiom,
    ! [VarCurr: state_type] :
      ( v128777(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72649,axiom,
    ! [VarCurr: state_type] :
      ( v128771(VarCurr)
    <=> v128773(VarCurr) ) ).

tff(addAssignment_72648,axiom,
    ! [VarCurr: state_type] :
      ( v128773(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v128657(VarCurr)
      <=> v128760(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1256,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v128657(VarCurr)
      <=> v128759(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5855,axiom,
    ! [VarCurr: state_type] :
      ( v128760(VarCurr)
    <=> ( v128700(VarCurr)
        & v128659(VarCurr,2) ) ) ).

tff(addAssignment_72647,axiom,
    ! [VarCurr: state_type] :
      ( v128759(VarCurr)
    <=> v128700(VarCurr) ) ).

tff(addAssignment_72646,axiom,
    ! [VarCurr: state_type] :
      ( v128659(VarCurr,2)
    <=> v128661(VarCurr,2) ) ).

tff(addAssignment_72645,axiom,
    ! [VarCurr: state_type] :
      ( v128661(VarCurr,2)
    <=> v128663(VarCurr,2) ) ).

tff(addAssignment_72644,axiom,
    ! [VarNext: state_type] :
      ( v128663(VarNext,2)
    <=> v128751(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128752(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128751(VarNext,B)
            <=> v128663(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1691,axiom,
    ! [VarNext: state_type] :
      ( v128752(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128751(VarNext,B)
          <=> v128744(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128752(VarNext)
      <=> v128753(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128753(VarNext)
      <=> ( v128755(VarNext)
          & v128729(VarNext) ) ) ) ).

tff(writeUnaryOperator_9284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128755(VarNext)
      <=> v128738(VarNext) ) ) ).

tff(addAssignment_72643,axiom,
    ! [VarCurr: state_type] :
      ( v128673(VarCurr,2)
    <=> v128675(VarCurr,2) ) ).

tff(addAssignment_72642,axiom,
    ! [VarCurr: state_type] :
      ( v128675(VarCurr,2)
    <=> v128724(VarCurr,2) ) ).

tff(addAssignment_72641,axiom,
    ! [VarCurr: state_type] :
      ( v128677(VarCurr,2)
    <=> v128679(VarCurr,2) ) ).

tff(addAssignment_72640,axiom,
    ! [VarCurr: state_type] :
      ( v128679(VarCurr,2)
    <=> v128692(VarCurr,2) ) ).

tff(addAssignment_72639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128659(VarCurr,B)
      <=> v128661(VarCurr,B) ) ) ).

tff(addAssignment_72638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128661(VarCurr,B)
      <=> v128663(VarCurr,B) ) ) ).

tff(addAssignment_72637,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128663(VarNext,B)
      <=> v128733(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128734(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128733(VarNext,B)
            <=> v128663(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1690,axiom,
    ! [VarNext: state_type] :
      ( v128734(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128733(VarNext,B)
          <=> v128744(VarNext,B) ) ) ) ).

tff(addAssignment_72636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128744(VarNext,B)
          <=> v128742(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128742(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1255,axiom,
    ! [VarCurr: state_type] :
      ( v128745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128742(VarCurr,B)
          <=> v128673(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16626,axiom,
    ! [VarCurr: state_type] :
      ( v128745(VarCurr)
    <=> ( v128746(VarCurr)
        & v128747(VarCurr) ) ) ).

tff(writeUnaryOperator_9283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128747(VarCurr)
    <=> v128669(VarCurr) ) ).

tff(writeUnaryOperator_9282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128746(VarCurr)
    <=> v128665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128734(VarNext)
      <=> v128735(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128735(VarNext)
      <=> ( v128736(VarNext)
          & v128729(VarNext) ) ) ) ).

tff(writeUnaryOperator_9281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128736(VarNext)
      <=> v128738(VarNext) ) ) ).

tff(addAssignment_72635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128738(VarNext)
      <=> v128729(VarCurr) ) ) ).

tff(addAssignment_72634,axiom,
    ! [VarCurr: state_type] :
      ( v128729(VarCurr)
    <=> v128731(VarCurr) ) ).

tff(addAssignment_72633,axiom,
    ! [VarCurr: state_type] :
      ( v128731(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128673(VarCurr,B)
      <=> v128675(VarCurr,B) ) ) ).

tff(addAssignment_72631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128675(VarCurr,B)
      <=> v128724(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128724(VarCurr,B)
      <=> ( v128677(VarCurr,B)
          & v128725(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128725(VarCurr,B)
      <=> ~ v128726(VarCurr,B) ) ) ).

tff(addAssignment_72630,axiom,
    ! [VarCurr: state_type] :
      ( v128726(VarCurr,0)
    <=> v128727(VarCurr) ) ).

tff(addAssignment_72629,axiom,
    ! [VarCurr: state_type] :
      ( v128726(VarCurr,1)
    <=> v128727(VarCurr) ) ).

tff(addAssignment_72628,axiom,
    ! [VarCurr: state_type] :
      ( v128726(VarCurr,2)
    <=> v128727(VarCurr) ) ).

tff(addAssignment_72627,axiom,
    ! [VarCurr: state_type] :
      ( v128727(VarCurr)
    <=> v128723(VarCurr) ) ).

tff(addAssignment_72626,axiom,
    ! [VarCurr: state_type] :
      ( v128723(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128677(VarCurr,B)
      <=> v128679(VarCurr,B) ) ) ).

tff(addAssignment_72624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v128679(VarCurr,B)
      <=> v128692(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128693(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128692(VarCurr,B)
          <=> v128708(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1254,axiom,
    ! [VarCurr: state_type] :
      ( v128693(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128692(VarCurr,B)
          <=> v128695(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128709(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128708(VarCurr,B)
          <=> v128659(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1253,axiom,
    ! [VarCurr: state_type] :
      ( v128709(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128708(VarCurr,B)
          <=> v128711(VarCurr,B) ) ) ) ).

tff(addAssignment_72623,axiom,
    ! [VarCurr: state_type] :
      ( v128711(VarCurr,0)
    <=> v128705(VarCurr) ) ).

tff(addAssignment_72622,axiom,
    ! [VarCurr: state_type] :
      ( v128711(VarCurr,1)
    <=> v128719(VarCurr) ) ).

tff(addAssignment_72621,axiom,
    ! [VarCurr: state_type] :
      ( v128711(VarCurr,2)
    <=> v128713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16623,axiom,
    ! [VarCurr: state_type] :
      ( v128719(VarCurr)
    <=> ( v128720(VarCurr)
        & v128721(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16622,axiom,
    ! [VarCurr: state_type] :
      ( v128721(VarCurr)
    <=> ( v128659(VarCurr,0)
        | v128706(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5854,axiom,
    ! [VarCurr: state_type] :
      ( v128720(VarCurr)
    <=> ( v128705(VarCurr)
        | v128659(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16621,axiom,
    ! [VarCurr: state_type] :
      ( v128713(VarCurr)
    <=> ( v128714(VarCurr)
        & v128718(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16620,axiom,
    ! [VarCurr: state_type] :
      ( v128718(VarCurr)
    <=> ( v128701(VarCurr)
        | v128716(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5853,axiom,
    ! [VarCurr: state_type] :
      ( v128714(VarCurr)
    <=> ( v128659(VarCurr,2)
        | v128715(VarCurr) ) ) ).

tff(writeUnaryOperator_9279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128715(VarCurr)
    <=> v128716(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5852,axiom,
    ! [VarCurr: state_type] :
      ( v128716(VarCurr)
    <=> ( v128659(VarCurr,1)
        | v128717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16619,axiom,
    ! [VarCurr: state_type] :
      ( v128717(VarCurr)
    <=> ( v128659(VarCurr,0)
        & v128706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16618,axiom,
    ! [VarCurr: state_type] :
      ( v128709(VarCurr)
    <=> ( v128710(VarCurr)
        & v128685(VarCurr) ) ) ).

tff(writeUnaryOperator_9278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128710(VarCurr)
    <=> v128681(VarCurr) ) ).

tff(addAssignment_72620,axiom,
    ! [VarCurr: state_type] :
      ( v128695(VarCurr,0)
    <=> v128705(VarCurr) ) ).

tff(addAssignment_72619,axiom,
    ! [VarCurr: state_type] :
      ( v128695(VarCurr,1)
    <=> v128703(VarCurr) ) ).

tff(addAssignment_72618,axiom,
    ! [VarCurr: state_type] :
      ( v128695(VarCurr,2)
    <=> v128697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16617,axiom,
    ! [VarCurr: state_type] :
      ( v128703(VarCurr)
    <=> ( v128704(VarCurr)
        & v128707(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5851,axiom,
    ! [VarCurr: state_type] :
      ( v128707(VarCurr)
    <=> ( v128659(VarCurr,0)
        | v128659(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16616,axiom,
    ! [VarCurr: state_type] :
      ( v128704(VarCurr)
    <=> ( v128705(VarCurr)
        | v128706(VarCurr) ) ) ).

tff(writeUnaryOperator_9277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128706(VarCurr)
    <=> v128659(VarCurr,1) ) ).

tff(writeUnaryOperator_9276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128705(VarCurr)
    <=> v128659(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16615,axiom,
    ! [VarCurr: state_type] :
      ( v128697(VarCurr)
    <=> ( v128698(VarCurr)
        & v128702(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5850,axiom,
    ! [VarCurr: state_type] :
      ( v128702(VarCurr)
    <=> ( v128700(VarCurr)
        | v128659(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16614,axiom,
    ! [VarCurr: state_type] :
      ( v128698(VarCurr)
    <=> ( v128699(VarCurr)
        | v128701(VarCurr) ) ) ).

tff(writeUnaryOperator_9275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128701(VarCurr)
    <=> v128659(VarCurr,2) ) ).

tff(writeUnaryOperator_9274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128699(VarCurr)
    <=> v128700(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5849,axiom,
    ! [VarCurr: state_type] :
      ( v128700(VarCurr)
    <=> ( v128659(VarCurr,0)
        & v128659(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16613,axiom,
    ! [VarCurr: state_type] :
      ( v128693(VarCurr)
    <=> ( v128681(VarCurr)
        & v128694(VarCurr) ) ) ).

tff(writeUnaryOperator_9273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128694(VarCurr)
    <=> v128685(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16612,axiom,
    ! [VarCurr: state_type] :
      ( v128685(VarCurr)
    <=> ( v128687(VarCurr)
        | v128690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5848,axiom,
    ! [VarCurr: state_type] :
      ( v128690(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v128691(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1564,axiom,
    ! [VarCurr: state_type] :
      ( v128691(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16611,axiom,
    ! [VarCurr: state_type] :
      ( v128687(VarCurr)
    <=> ( v128688(VarCurr)
        & v128689(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1563,axiom,
    ! [VarCurr: state_type] :
      ( v128689(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5847,axiom,
    ! [VarCurr: state_type] :
      ( v128688(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16610,axiom,
    ! [VarCurr: state_type] :
      ( v128681(VarCurr)
    <=> ( v97276(VarCurr)
        & v128683(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1562,axiom,
    ! [VarCurr: state_type] :
      ( v128683(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $false )
        & ( v97409(VarCurr,4)
        <=> $false )
        & ( v97409(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_72617,axiom,
    ! [VarCurr: state_type] :
      ( v128669(VarCurr)
    <=> v128671(VarCurr) ) ).

tff(addAssignment_72616,axiom,
    ! [VarCurr: state_type] :
      ( v128671(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_72615,axiom,
    ! [VarCurr: state_type] :
      ( v128665(VarCurr)
    <=> v128667(VarCurr) ) ).

tff(addAssignment_72614,axiom,
    ! [VarCurr: state_type] :
      ( v128667(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v97383(VarCurr)
      <=> v128654(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1252,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v97383(VarCurr)
      <=> v128653(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5846,axiom,
    ! [VarCurr: state_type] :
      ( v128654(VarCurr)
    <=> ( v128594(VarCurr)
        & v97385(VarCurr,2) ) ) ).

tff(addAssignment_72613,axiom,
    ! [VarCurr: state_type] :
      ( v128653(VarCurr)
    <=> v128594(VarCurr) ) ).

tff(addAssignment_72612,axiom,
    ! [VarCurr: state_type] :
      ( v97385(VarCurr,2)
    <=> v97387(VarCurr,2) ) ).

tff(addAssignment_72611,axiom,
    ! [VarCurr: state_type] :
      ( v97387(VarCurr,2)
    <=> v97389(VarCurr,2) ) ).

tff(addAssignment_72610,axiom,
    ! [VarNext: state_type] :
      ( v97389(VarNext,2)
    <=> v128645(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128646(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128645(VarNext,B)
            <=> v97389(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1689,axiom,
    ! [VarNext: state_type] :
      ( v128646(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128645(VarNext,B)
          <=> v128638(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128646(VarNext)
      <=> v128647(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128647(VarNext)
      <=> ( v128649(VarNext)
          & v128623(VarNext) ) ) ) ).

tff(writeUnaryOperator_9272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128649(VarNext)
      <=> v128632(VarNext) ) ) ).

tff(addAssignment_72609,axiom,
    ! [VarCurr: state_type] :
      ( v97399(VarCurr,2)
    <=> v97401(VarCurr,2) ) ).

tff(addAssignment_72608,axiom,
    ! [VarCurr: state_type] :
      ( v97401(VarCurr,2)
    <=> v128618(VarCurr,2) ) ).

tff(addAssignment_72607,axiom,
    ! [VarCurr: state_type] :
      ( v97403(VarCurr,2)
    <=> v97405(VarCurr,2) ) ).

tff(addAssignment_72606,axiom,
    ! [VarCurr: state_type] :
      ( v97405(VarCurr,2)
    <=> v128586(VarCurr,2) ) ).

tff(addAssignment_72605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97385(VarCurr,B)
      <=> v97387(VarCurr,B) ) ) ).

tff(addAssignment_72604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97387(VarCurr,B)
      <=> v97389(VarCurr,B) ) ) ).

tff(addAssignment_72603,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97389(VarNext,B)
      <=> v128627(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128628(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v128627(VarNext,B)
            <=> v97389(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1688,axiom,
    ! [VarNext: state_type] :
      ( v128628(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128627(VarNext,B)
          <=> v128638(VarNext,B) ) ) ) ).

tff(addAssignment_72602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128638(VarNext,B)
          <=> v128636(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128639(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128636(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1251,axiom,
    ! [VarCurr: state_type] :
      ( v128639(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128636(VarCurr,B)
          <=> v97399(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16607,axiom,
    ! [VarCurr: state_type] :
      ( v128639(VarCurr)
    <=> ( v128640(VarCurr)
        & v128641(VarCurr) ) ) ).

tff(writeUnaryOperator_9271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128641(VarCurr)
    <=> v97395(VarCurr) ) ).

tff(writeUnaryOperator_9270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128640(VarCurr)
    <=> v97391(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128628(VarNext)
      <=> v128629(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128629(VarNext)
      <=> ( v128630(VarNext)
          & v128623(VarNext) ) ) ) ).

tff(writeUnaryOperator_9269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128630(VarNext)
      <=> v128632(VarNext) ) ) ).

tff(addAssignment_72601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128632(VarNext)
      <=> v128623(VarCurr) ) ) ).

tff(addAssignment_72600,axiom,
    ! [VarCurr: state_type] :
      ( v128623(VarCurr)
    <=> v128625(VarCurr) ) ).

tff(addAssignment_72599,axiom,
    ! [VarCurr: state_type] :
      ( v128625(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_72598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97399(VarCurr,B)
      <=> v97401(VarCurr,B) ) ) ).

tff(addAssignment_72597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97401(VarCurr,B)
      <=> v128618(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128618(VarCurr,B)
      <=> ( v97403(VarCurr,B)
          & v128619(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128619(VarCurr,B)
      <=> ~ v128620(VarCurr,B) ) ) ).

tff(addAssignment_72596,axiom,
    ! [VarCurr: state_type] :
      ( v128620(VarCurr,0)
    <=> v128621(VarCurr) ) ).

tff(addAssignment_72595,axiom,
    ! [VarCurr: state_type] :
      ( v128620(VarCurr,1)
    <=> v128621(VarCurr) ) ).

tff(addAssignment_72594,axiom,
    ! [VarCurr: state_type] :
      ( v128620(VarCurr,2)
    <=> v128621(VarCurr) ) ).

tff(addAssignment_72593,axiom,
    ! [VarCurr: state_type] :
      ( v128621(VarCurr)
    <=> v128617(VarCurr) ) ).

tff(addAssignment_72592,axiom,
    ! [VarCurr: state_type] :
      ( v128617(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_72591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97403(VarCurr,B)
      <=> v97405(VarCurr,B) ) ) ).

tff(addAssignment_72590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97405(VarCurr,B)
      <=> v128586(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128586(VarCurr,B)
          <=> v128602(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1250,axiom,
    ! [VarCurr: state_type] :
      ( v128587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128586(VarCurr,B)
          <=> v128589(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128603(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128602(VarCurr,B)
          <=> v97385(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1249,axiom,
    ! [VarCurr: state_type] :
      ( v128603(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v128602(VarCurr,B)
          <=> v128605(VarCurr,B) ) ) ) ).

tff(addAssignment_72589,axiom,
    ! [VarCurr: state_type] :
      ( v128605(VarCurr,0)
    <=> v128599(VarCurr) ) ).

tff(addAssignment_72588,axiom,
    ! [VarCurr: state_type] :
      ( v128605(VarCurr,1)
    <=> v128613(VarCurr) ) ).

tff(addAssignment_72587,axiom,
    ! [VarCurr: state_type] :
      ( v128605(VarCurr,2)
    <=> v128607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16604,axiom,
    ! [VarCurr: state_type] :
      ( v128613(VarCurr)
    <=> ( v128614(VarCurr)
        & v128615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16603,axiom,
    ! [VarCurr: state_type] :
      ( v128615(VarCurr)
    <=> ( v97385(VarCurr,0)
        | v128600(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5845,axiom,
    ! [VarCurr: state_type] :
      ( v128614(VarCurr)
    <=> ( v128599(VarCurr)
        | v97385(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16602,axiom,
    ! [VarCurr: state_type] :
      ( v128607(VarCurr)
    <=> ( v128608(VarCurr)
        & v128612(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16601,axiom,
    ! [VarCurr: state_type] :
      ( v128612(VarCurr)
    <=> ( v128595(VarCurr)
        | v128610(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5844,axiom,
    ! [VarCurr: state_type] :
      ( v128608(VarCurr)
    <=> ( v97385(VarCurr,2)
        | v128609(VarCurr) ) ) ).

tff(writeUnaryOperator_9267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128609(VarCurr)
    <=> v128610(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5843,axiom,
    ! [VarCurr: state_type] :
      ( v128610(VarCurr)
    <=> ( v97385(VarCurr,1)
        | v128611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16600,axiom,
    ! [VarCurr: state_type] :
      ( v128611(VarCurr)
    <=> ( v97385(VarCurr,0)
        & v128600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16599,axiom,
    ! [VarCurr: state_type] :
      ( v128603(VarCurr)
    <=> ( v128604(VarCurr)
        & v100201(VarCurr) ) ) ).

tff(writeUnaryOperator_9266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128604(VarCurr)
    <=> v97407(VarCurr) ) ).

tff(addAssignment_72586,axiom,
    ! [VarCurr: state_type] :
      ( v128589(VarCurr,0)
    <=> v128599(VarCurr) ) ).

tff(addAssignment_72585,axiom,
    ! [VarCurr: state_type] :
      ( v128589(VarCurr,1)
    <=> v128597(VarCurr) ) ).

tff(addAssignment_72584,axiom,
    ! [VarCurr: state_type] :
      ( v128589(VarCurr,2)
    <=> v128591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16598,axiom,
    ! [VarCurr: state_type] :
      ( v128597(VarCurr)
    <=> ( v128598(VarCurr)
        & v128601(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5842,axiom,
    ! [VarCurr: state_type] :
      ( v128601(VarCurr)
    <=> ( v97385(VarCurr,0)
        | v97385(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16597,axiom,
    ! [VarCurr: state_type] :
      ( v128598(VarCurr)
    <=> ( v128599(VarCurr)
        | v128600(VarCurr) ) ) ).

tff(writeUnaryOperator_9265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128600(VarCurr)
    <=> v97385(VarCurr,1) ) ).

tff(writeUnaryOperator_9264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128599(VarCurr)
    <=> v97385(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16596,axiom,
    ! [VarCurr: state_type] :
      ( v128591(VarCurr)
    <=> ( v128592(VarCurr)
        & v128596(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5841,axiom,
    ! [VarCurr: state_type] :
      ( v128596(VarCurr)
    <=> ( v128594(VarCurr)
        | v97385(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16595,axiom,
    ! [VarCurr: state_type] :
      ( v128592(VarCurr)
    <=> ( v128593(VarCurr)
        | v128595(VarCurr) ) ) ).

tff(writeUnaryOperator_9263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128595(VarCurr)
    <=> v97385(VarCurr,2) ) ).

tff(writeUnaryOperator_9262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128593(VarCurr)
    <=> v128594(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5840,axiom,
    ! [VarCurr: state_type] :
      ( v128594(VarCurr)
    <=> ( v97385(VarCurr,0)
        & v97385(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16594,axiom,
    ! [VarCurr: state_type] :
      ( v128587(VarCurr)
    <=> ( v97407(VarCurr)
        & v128588(VarCurr) ) ) ).

tff(writeUnaryOperator_9261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128588(VarCurr)
    <=> v100201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16593,axiom,
    ! [VarCurr: state_type] :
      ( v100201(VarCurr)
    <=> ( v128580(VarCurr)
        | v128584(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5839,axiom,
    ! [VarCurr: state_type] :
      ( v128584(VarCurr)
    <=> ( v100203(VarCurr,2)
        & v128585(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1561,axiom,
    ! [VarCurr: state_type] :
      ( v128585(VarCurr)
    <=> ( ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16592,axiom,
    ! [VarCurr: state_type] :
      ( v128580(VarCurr)
    <=> ( v128581(VarCurr)
        & v128583(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1560,axiom,
    ! [VarCurr: state_type] :
      ( v128583(VarCurr)
    <=> ( ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5838,axiom,
    ! [VarCurr: state_type] :
      ( v128581(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v100203(VarCurr,1) ) ) ).

tff(addAssignment_72583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v100205(VarCurr,B)
      <=> v100207(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5837,axiom,
    ! [VarCurr: state_type] :
      ( v100207(VarCurr,1)
    <=> ( v128570(VarCurr)
        & v128578(VarCurr) ) ) ).

tff(writeUnaryOperator_9260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128578(VarCurr)
    <=> v84187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16591,axiom,
    ! [VarCurr: state_type] :
      ( v128570(VarCurr)
    <=> ( v128571(VarCurr)
        & v128577(VarCurr) ) ) ).

tff(writeUnaryOperator_9259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128577(VarCurr)
    <=> v127280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16590,axiom,
    ! [VarCurr: state_type] :
      ( v128571(VarCurr)
    <=> ( v128572(VarCurr)
        & v128576(VarCurr) ) ) ).

tff(writeUnaryOperator_9258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128576(VarCurr)
    <=> v84897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16589,axiom,
    ! [VarCurr: state_type] :
      ( v128572(VarCurr)
    <=> ( v128573(VarCurr)
        & v128575(VarCurr) ) ) ).

tff(writeUnaryOperator_9257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128575(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16588,axiom,
    ! [VarCurr: state_type] :
      ( v128573(VarCurr)
    <=> ( v128574(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5836,axiom,
    ! [VarCurr: state_type] :
      ( v128574(VarCurr)
    <=> ( v100209(VarCurr,1)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16587,axiom,
    ! [VarCurr: state_type] :
      ( v100207(VarCurr,0)
    <=> ( v128566(VarCurr)
        & v128568(VarCurr) ) ) ).

tff(writeUnaryOperator_9256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128568(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16586,axiom,
    ! [VarCurr: state_type] :
      ( v128566(VarCurr)
    <=> ( v128567(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16585,axiom,
    ! [VarCurr: state_type] :
      ( v128567(VarCurr)
    <=> ( v100209(VarCurr,0)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16584,axiom,
    ! [VarCurr: state_type] :
      ( v100209(VarCurr,0)
    <=> ( v128543(VarCurr)
        & v128562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16583,axiom,
    ! [VarCurr: state_type] :
      ( v128562(VarCurr)
    <=> ( v128563(VarCurr)
        | v128564(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1559,axiom,
    ! [VarCurr: state_type] :
      ( v128564(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v101505(VarCurr,6) )
        & ( v110754(VarCurr,2)
        <=> v101505(VarCurr,5) )
        & ( v110754(VarCurr,1)
        <=> v101505(VarCurr,4) )
        & ( v110754(VarCurr,0)
        <=> v101505(VarCurr,3) ) ) ) ).

tff(writeUnaryOperator_9255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128563(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16582,axiom,
    ! [VarCurr: state_type] :
      ( v128543(VarCurr)
    <=> ( v128544(VarCurr)
        & v128561(VarCurr) ) ) ).

tff(writeUnaryOperator_9254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128561(VarCurr)
    <=> v127410(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5835,axiom,
    ! [VarCurr: state_type] :
      ( v128544(VarCurr)
    <=> ( v128546(VarCurr)
        | v128560(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5834,axiom,
    ! [VarCurr: state_type] :
      ( v128546(VarCurr)
    <=> ( v128547(VarCurr)
        | v128560(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5833,axiom,
    ! [VarCurr: state_type] :
      ( v128547(VarCurr)
    <=> ( v128548(VarCurr)
        | v128560(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5832,axiom,
    ! [VarCurr: state_type] :
      ( v128548(VarCurr)
    <=> ( v128549(VarCurr)
        | v128560(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5831,axiom,
    ! [VarCurr: state_type] :
      ( v128549(VarCurr)
    <=> ( v128550(VarCurr)
        | v128560(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5830,axiom,
    ! [VarCurr: state_type] :
      ( v128550(VarCurr)
    <=> ( v128551(VarCurr)
        | v128560(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5829,axiom,
    ! [VarCurr: state_type] :
      ( v128551(VarCurr)
    <=> ( v128552(VarCurr)
        | v128560(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5828,axiom,
    ! [VarCurr: state_type] :
      ( v128552(VarCurr)
    <=> ( v128553(VarCurr)
        | v128560(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5827,axiom,
    ! [VarCurr: state_type] :
      ( v128553(VarCurr)
    <=> ( v128554(VarCurr)
        | v128560(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5826,axiom,
    ! [VarCurr: state_type] :
      ( v128554(VarCurr)
    <=> ( v128555(VarCurr)
        | v128560(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5825,axiom,
    ! [VarCurr: state_type] :
      ( v128555(VarCurr)
    <=> ( v128556(VarCurr)
        | v128560(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5824,axiom,
    ! [VarCurr: state_type] :
      ( v128556(VarCurr)
    <=> ( v128557(VarCurr)
        | v128560(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5823,axiom,
    ! [VarCurr: state_type] :
      ( v128557(VarCurr)
    <=> ( v128558(VarCurr)
        | v128560(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5822,axiom,
    ! [VarCurr: state_type] :
      ( v128558(VarCurr)
    <=> ( v128559(VarCurr)
        | v128560(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5821,axiom,
    ! [VarCurr: state_type] :
      ( v128559(VarCurr)
    <=> ( v128560(VarCurr,0)
        | v128560(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128560(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v100211(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16581,axiom,
    ! [VarCurr: state_type] :
      ( v127410(VarCurr)
    <=> ( v128527(VarCurr)
        | v100727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16580,axiom,
    ! [VarCurr: state_type] :
      ( v128527(VarCurr)
    <=> ( v128528(VarCurr)
        | v128492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16579,axiom,
    ! [VarCurr: state_type] :
      ( v128528(VarCurr)
    <=> ( v128529(VarCurr)
        | v111693(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16578,axiom,
    ! [VarCurr: state_type] :
      ( v128529(VarCurr)
    <=> ( v128530(VarCurr)
        | v108897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16577,axiom,
    ! [VarCurr: state_type] :
      ( v128530(VarCurr)
    <=> ( v128531(VarCurr)
        | v88420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16576,axiom,
    ! [VarCurr: state_type] :
      ( v128531(VarCurr)
    <=> ( v128532(VarCurr)
        | v128540(VarCurr) ) ) ).

tff(writeUnaryOperator_9253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128540(VarCurr)
    <=> v128541(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16575,axiom,
    ! [VarCurr: state_type] :
      ( v128541(VarCurr)
    <=> ( v84583(VarCurr)
        | v89527(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16574,axiom,
    ! [VarCurr: state_type] :
      ( v128532(VarCurr)
    <=> ( v128533(VarCurr)
        | v86879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16573,axiom,
    ! [VarCurr: state_type] :
      ( v128533(VarCurr)
    <=> ( v128534(VarCurr)
        & v128539(VarCurr) ) ) ).

tff(writeUnaryOperator_9252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128539(VarCurr)
    <=> v127180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16572,axiom,
    ! [VarCurr: state_type] :
      ( v128534(VarCurr)
    <=> ( v128535(VarCurr)
        & v109663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16571,axiom,
    ! [VarCurr: state_type] :
      ( v128535(VarCurr)
    <=> ( v128536(VarCurr)
        & v128538(VarCurr) ) ) ).

tff(writeUnaryOperator_9251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128538(VarCurr)
    <=> v128095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16570,axiom,
    ! [VarCurr: state_type] :
      ( v128536(VarCurr)
    <=> ( v127412(VarCurr)
        & v128537(VarCurr) ) ) ).

tff(writeUnaryOperator_9250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128537(VarCurr)
    <=> v101598(VarCurr) ) ).

tff(addAssignment_72582,axiom,
    ! [VarCurr: state_type] :
      ( v128492(VarCurr)
    <=> v128494(VarCurr) ) ).

tff(addAssignment_72581,axiom,
    ! [VarCurr: state_type] :
      ( v128494(VarCurr)
    <=> v128496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16569,axiom,
    ! [VarCurr: state_type] :
      ( v128496(VarCurr)
    <=> ( v128498(VarCurr)
        | v4333(VarCurr) ) ) ).

tff(addAssignment_72580,axiom,
    ! [VarCurr: state_type] :
      ( v128498(VarCurr)
    <=> v5120(VarCurr,0) ) ).

tff(addAssignment_72579,axiom,
    ! [VarCurr: state_type] :
      ( v5120(VarCurr,0)
    <=> v5122(VarCurr,0) ) ).

tff(addAssignment_72578,axiom,
    ! [VarNext: state_type] :
      ( v5122(VarNext,0)
    <=> v128508(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128509(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v128508(VarNext,B)
            <=> v5122(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1687,axiom,
    ! [VarNext: state_type] :
      ( v128509(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v128508(VarNext,B)
          <=> v128519(VarNext,B) ) ) ) ).

tff(addAssignment_72577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v128519(VarNext,B)
          <=> v128517(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v128517(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1248,axiom,
    ! [VarCurr: state_type] :
      ( v128520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v128517(VarCurr,B)
          <=> v5132(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16568,axiom,
    ! [VarCurr: state_type] :
      ( v128520(VarCurr)
    <=> ( v128521(VarCurr)
        & v128522(VarCurr) ) ) ).

tff(writeUnaryOperator_9249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128522(VarCurr)
    <=> v5128(VarCurr) ) ).

tff(writeUnaryOperator_9248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128521(VarCurr)
    <=> v5124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128509(VarNext)
      <=> v128510(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128510(VarNext)
      <=> ( v128511(VarNext)
          & v128504(VarNext) ) ) ) ).

tff(writeUnaryOperator_9247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128511(VarNext)
      <=> v128513(VarNext) ) ) ).

tff(addAssignment_72576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128513(VarNext)
      <=> v128504(VarCurr) ) ) ).

tff(addAssignment_72575,axiom,
    ! [VarCurr: state_type] :
      ( v128504(VarCurr)
    <=> v128506(VarCurr) ) ).

tff(addAssignment_72574,axiom,
    ! [VarCurr: state_type] :
      ( v128506(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_72573,axiom,
    ! [VarCurr: state_type] :
      ( v5132(VarCurr,0)
    <=> v5134(VarCurr,0) ) ).

tff(addAssignment_72572,axiom,
    ! [VarCurr: state_type] :
      ( v5134(VarCurr,0)
    <=> v5136(VarCurr,0) ) ).

tff(addAssignment_72571,axiom,
    ! [VarCurr: state_type] :
      ( v5136(VarCurr,0)
    <=> v128502(VarCurr,0) ) ).

tff(addAssignment_72570,axiom,
    ! [VarCurr: state_type] :
      ( v128502(VarCurr,0)
    <=> v128500(VarCurr) ) ).

tff(addAssignment_72569,axiom,
    ! [VarCurr: state_type] :
      ( v128502(VarCurr,1)
    <=> v5138(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4516(VarCurr)
     => ( v128500(VarCurr)
      <=> v128498(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1247,axiom,
    ! [VarCurr: state_type] :
      ( v4516(VarCurr)
     => ( v128500(VarCurr)
      <=> v5049(VarCurr) ) ) ).

tff(addAssignment_72568,axiom,
    ! [VarCurr: state_type] :
      ( v128095(VarCurr)
    <=> v128097(VarCurr) ) ).

tff(addAssignment_72567,axiom,
    ! [VarCurr: state_type] :
      ( v128097(VarCurr)
    <=> v128099(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128475(VarNext)
       => ( v128099(VarNext)
        <=> v128099(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1686,axiom,
    ! [VarNext: state_type] :
      ( v128475(VarNext)
     => ( v128099(VarNext)
      <=> v128485(VarNext) ) ) ).

tff(addAssignment_72566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128485(VarNext)
      <=> v128483(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128486(VarCurr)
     => ( v128483(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1246,axiom,
    ! [VarCurr: state_type] :
      ( v128486(VarCurr)
     => ( v128483(VarCurr)
      <=> v128109(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16565,axiom,
    ! [VarCurr: state_type] :
      ( v128486(VarCurr)
    <=> ( v128487(VarCurr)
        & v128488(VarCurr) ) ) ).

tff(writeUnaryOperator_9246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128488(VarCurr)
    <=> v128105(VarCurr) ) ).

tff(writeUnaryOperator_9245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128487(VarCurr)
    <=> v128101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128475(VarNext)
      <=> v128476(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128476(VarNext)
      <=> ( v128477(VarNext)
          & v128470(VarNext) ) ) ) ).

tff(writeUnaryOperator_9244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128477(VarNext)
      <=> v128479(VarNext) ) ) ).

tff(addAssignment_72565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128479(VarNext)
      <=> v128470(VarCurr) ) ) ).

tff(addAssignment_72564,axiom,
    ! [VarCurr: state_type] :
      ( v128470(VarCurr)
    <=> v128472(VarCurr) ) ).

tff(addAssignment_72563,axiom,
    ! [VarCurr: state_type] :
      ( v128472(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_72562,axiom,
    ! [VarCurr: state_type] :
      ( v128109(VarCurr)
    <=> v128111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16562,axiom,
    ! [VarCurr: state_type] :
      ( v128111(VarCurr)
    <=> ( v128454(VarCurr)
        | v128461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16561,axiom,
    ! [VarCurr: state_type] :
      ( v128461(VarCurr)
    <=> ( v128462(VarCurr)
        & v128466(VarCurr) ) ) ).

tff(writeUnaryOperator_9243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128466(VarCurr)
    <=> v128467(VarCurr) ) ).

tff(addAssignment_72561,axiom,
    ! [VarCurr: state_type] :
      ( v128467(VarCurr)
    <=> v128468(VarCurr) ) ).

tff(addAssignment_72560,axiom,
    ! [VarCurr: state_type] :
      ( v128468(VarCurr)
    <=> v128124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16560,axiom,
    ! [VarCurr: state_type] :
      ( v128462(VarCurr)
    <=> ( v128097(VarCurr)
        & v128463(VarCurr) ) ) ).

tff(writeUnaryOperator_9242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128463(VarCurr)
    <=> v128464(VarCurr) ) ).

tff(addAssignment_72559,axiom,
    ! [VarCurr: state_type] :
      ( v128464(VarCurr)
    <=> v128465(VarCurr) ) ).

tff(addAssignment_72558,axiom,
    ! [VarCurr: state_type] :
      ( v128465(VarCurr)
    <=> v128120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16559,axiom,
    ! [VarCurr: state_type] :
      ( v128454(VarCurr)
    <=> ( v128455(VarCurr)
        & v128458(VarCurr) ) ) ).

tff(writeUnaryOperator_9241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128458(VarCurr)
    <=> v128459(VarCurr) ) ).

tff(addAssignment_72557,axiom,
    ! [VarCurr: state_type] :
      ( v128459(VarCurr)
    <=> v128460(VarCurr) ) ).

tff(addAssignment_72556,axiom,
    ! [VarCurr: state_type] :
      ( v128460(VarCurr)
    <=> v128124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16558,axiom,
    ! [VarCurr: state_type] :
      ( v128455(VarCurr)
    <=> ( v128113(VarCurr)
        & v128456(VarCurr) ) ) ).

tff(addAssignment_72555,axiom,
    ! [VarCurr: state_type] :
      ( v128456(VarCurr)
    <=> v128457(VarCurr) ) ).

tff(addAssignment_72554,axiom,
    ! [VarCurr: state_type] :
      ( v128457(VarCurr)
    <=> v128120(VarCurr) ) ).

tff(addAssignment_72553,axiom,
    ! [VarCurr: state_type] :
      ( v128124(VarCurr)
    <=> v128126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16557,axiom,
    ! [VarCurr: state_type] :
      ( v128126(VarCurr)
    <=> ( v128380(VarCurr)
        | v128441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16556,axiom,
    ! [VarCurr: state_type] :
      ( v128441(VarCurr)
    <=> ( v128442(VarCurr)
        & v128444(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5820,axiom,
    ! [VarCurr: state_type] :
      ( v128444(VarCurr)
    <=> ( v128446(VarCurr)
        | v128452(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5819,axiom,
    ! [VarCurr: state_type] :
      ( v128446(VarCurr)
    <=> ( v128447(VarCurr)
        | v128452(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5818,axiom,
    ! [VarCurr: state_type] :
      ( v128447(VarCurr)
    <=> ( v128448(VarCurr)
        | v128452(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5817,axiom,
    ! [VarCurr: state_type] :
      ( v128448(VarCurr)
    <=> ( v128449(VarCurr)
        | v128452(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5816,axiom,
    ! [VarCurr: state_type] :
      ( v128449(VarCurr)
    <=> ( v128450(VarCurr)
        | v128452(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5815,axiom,
    ! [VarCurr: state_type] :
      ( v128450(VarCurr)
    <=> ( v128451(VarCurr)
        | v128452(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5814,axiom,
    ! [VarCurr: state_type] :
      ( v128451(VarCurr)
    <=> ( v128452(VarCurr,0)
        | v128452(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128452(VarCurr,B)
      <=> ( v128360(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16555,axiom,
    ! [VarCurr: state_type] :
      ( v128442(VarCurr)
    <=> ( v128443(VarCurr)
        & v103123(VarCurr) ) ) ).

tff(writeUnaryOperator_9240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128443(VarCurr)
    <=> v128128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16554,axiom,
    ! [VarCurr: state_type] :
      ( v128380(VarCurr)
    <=> ( v128381(VarCurr)
        | v128429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16553,axiom,
    ! [VarCurr: state_type] :
      ( v128429(VarCurr)
    <=> ( v128430(VarCurr)
        & v128432(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5813,axiom,
    ! [VarCurr: state_type] :
      ( v128432(VarCurr)
    <=> ( v128434(VarCurr)
        | v128440(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5812,axiom,
    ! [VarCurr: state_type] :
      ( v128434(VarCurr)
    <=> ( v128435(VarCurr)
        | v128440(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5811,axiom,
    ! [VarCurr: state_type] :
      ( v128435(VarCurr)
    <=> ( v128436(VarCurr)
        | v128440(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5810,axiom,
    ! [VarCurr: state_type] :
      ( v128436(VarCurr)
    <=> ( v128437(VarCurr)
        | v128440(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5809,axiom,
    ! [VarCurr: state_type] :
      ( v128437(VarCurr)
    <=> ( v128438(VarCurr)
        | v128440(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5808,axiom,
    ! [VarCurr: state_type] :
      ( v128438(VarCurr)
    <=> ( v128439(VarCurr)
        | v128440(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5807,axiom,
    ! [VarCurr: state_type] :
      ( v128439(VarCurr)
    <=> ( v128440(VarCurr,0)
        | v128440(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128440(VarCurr,B)
      <=> ( v128351(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16552,axiom,
    ! [VarCurr: state_type] :
      ( v128430(VarCurr)
    <=> ( v128431(VarCurr)
        & v103102(VarCurr) ) ) ).

tff(writeUnaryOperator_9239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128431(VarCurr)
    <=> v128128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16551,axiom,
    ! [VarCurr: state_type] :
      ( v128381(VarCurr)
    <=> ( v128382(VarCurr)
        | v128417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16550,axiom,
    ! [VarCurr: state_type] :
      ( v128417(VarCurr)
    <=> ( v128418(VarCurr)
        & v128420(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5806,axiom,
    ! [VarCurr: state_type] :
      ( v128420(VarCurr)
    <=> ( v128422(VarCurr)
        | v128428(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5805,axiom,
    ! [VarCurr: state_type] :
      ( v128422(VarCurr)
    <=> ( v128423(VarCurr)
        | v128428(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5804,axiom,
    ! [VarCurr: state_type] :
      ( v128423(VarCurr)
    <=> ( v128424(VarCurr)
        | v128428(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5803,axiom,
    ! [VarCurr: state_type] :
      ( v128424(VarCurr)
    <=> ( v128425(VarCurr)
        | v128428(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5802,axiom,
    ! [VarCurr: state_type] :
      ( v128425(VarCurr)
    <=> ( v128426(VarCurr)
        | v128428(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5801,axiom,
    ! [VarCurr: state_type] :
      ( v128426(VarCurr)
    <=> ( v128427(VarCurr)
        | v128428(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5800,axiom,
    ! [VarCurr: state_type] :
      ( v128427(VarCurr)
    <=> ( v128428(VarCurr,0)
        | v128428(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128428(VarCurr,B)
      <=> ( v128188(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16549,axiom,
    ! [VarCurr: state_type] :
      ( v128418(VarCurr)
    <=> ( v128419(VarCurr)
        & v101559(VarCurr) ) ) ).

tff(writeUnaryOperator_9238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128419(VarCurr)
    <=> v128128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16548,axiom,
    ! [VarCurr: state_type] :
      ( v128382(VarCurr)
    <=> ( v128383(VarCurr)
        | v128406(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16547,axiom,
    ! [VarCurr: state_type] :
      ( v128406(VarCurr)
    <=> ( v128407(VarCurr)
        & v128408(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5799,axiom,
    ! [VarCurr: state_type] :
      ( v128408(VarCurr)
    <=> ( v128410(VarCurr)
        | v128416(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5798,axiom,
    ! [VarCurr: state_type] :
      ( v128410(VarCurr)
    <=> ( v128411(VarCurr)
        | v128416(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5797,axiom,
    ! [VarCurr: state_type] :
      ( v128411(VarCurr)
    <=> ( v128412(VarCurr)
        | v128416(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5796,axiom,
    ! [VarCurr: state_type] :
      ( v128412(VarCurr)
    <=> ( v128413(VarCurr)
        | v128416(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5795,axiom,
    ! [VarCurr: state_type] :
      ( v128413(VarCurr)
    <=> ( v128414(VarCurr)
        | v128416(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5794,axiom,
    ! [VarCurr: state_type] :
      ( v128414(VarCurr)
    <=> ( v128415(VarCurr)
        | v128416(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5793,axiom,
    ! [VarCurr: state_type] :
      ( v128415(VarCurr)
    <=> ( v128416(VarCurr,0)
        | v128416(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128416(VarCurr,B)
      <=> ( v128360(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16546,axiom,
    ! [VarCurr: state_type] :
      ( v128407(VarCurr)
    <=> ( v128128(VarCurr)
        & v103115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16545,axiom,
    ! [VarCurr: state_type] :
      ( v128383(VarCurr)
    <=> ( v128384(VarCurr)
        | v128395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16544,axiom,
    ! [VarCurr: state_type] :
      ( v128395(VarCurr)
    <=> ( v128396(VarCurr)
        & v128397(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5792,axiom,
    ! [VarCurr: state_type] :
      ( v128397(VarCurr)
    <=> ( v128399(VarCurr)
        | v128405(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5791,axiom,
    ! [VarCurr: state_type] :
      ( v128399(VarCurr)
    <=> ( v128400(VarCurr)
        | v128405(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5790,axiom,
    ! [VarCurr: state_type] :
      ( v128400(VarCurr)
    <=> ( v128401(VarCurr)
        | v128405(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5789,axiom,
    ! [VarCurr: state_type] :
      ( v128401(VarCurr)
    <=> ( v128402(VarCurr)
        | v128405(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5788,axiom,
    ! [VarCurr: state_type] :
      ( v128402(VarCurr)
    <=> ( v128403(VarCurr)
        | v128405(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5787,axiom,
    ! [VarCurr: state_type] :
      ( v128403(VarCurr)
    <=> ( v128404(VarCurr)
        | v128405(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5786,axiom,
    ! [VarCurr: state_type] :
      ( v128404(VarCurr)
    <=> ( v128405(VarCurr,0)
        | v128405(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128405(VarCurr,B)
      <=> ( v128351(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16543,axiom,
    ! [VarCurr: state_type] :
      ( v128396(VarCurr)
    <=> ( v128128(VarCurr)
        & v103098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16542,axiom,
    ! [VarCurr: state_type] :
      ( v128384(VarCurr)
    <=> ( v128385(VarCurr)
        & v128386(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5785,axiom,
    ! [VarCurr: state_type] :
      ( v128386(VarCurr)
    <=> ( v128388(VarCurr)
        | v128394(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5784,axiom,
    ! [VarCurr: state_type] :
      ( v128388(VarCurr)
    <=> ( v128389(VarCurr)
        | v128394(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5783,axiom,
    ! [VarCurr: state_type] :
      ( v128389(VarCurr)
    <=> ( v128390(VarCurr)
        | v128394(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5782,axiom,
    ! [VarCurr: state_type] :
      ( v128390(VarCurr)
    <=> ( v128391(VarCurr)
        | v128394(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5781,axiom,
    ! [VarCurr: state_type] :
      ( v128391(VarCurr)
    <=> ( v128392(VarCurr)
        | v128394(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5780,axiom,
    ! [VarCurr: state_type] :
      ( v128392(VarCurr)
    <=> ( v128393(VarCurr)
        | v128394(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5779,axiom,
    ! [VarCurr: state_type] :
      ( v128393(VarCurr)
    <=> ( v128394(VarCurr,0)
        | v128394(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128394(VarCurr,B)
      <=> ( v128188(VarCurr,B)
          & v128336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16541,axiom,
    ! [VarCurr: state_type] :
      ( v128385(VarCurr)
    <=> ( v128128(VarCurr)
        & v101503(VarCurr) ) ) ).

tff(addAssignment_72552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128360(VarCurr,B)
      <=> v128362(VarCurr,B) ) ) ).

tff(addAssignment_72551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128362(VarCurr,B)
      <=> v128364(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1720,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128364(VarCurr,B)
      <=> ( v128377(VarCurr,B)
          & v128366(VarCurr,B) ) ) ) ).

tff(addAssignment_72550,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,0)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72549,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,1)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72548,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,2)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72547,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,3)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72546,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,4)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72545,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,5)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72544,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,6)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72543,axiom,
    ! [VarCurr: state_type] :
      ( v128377(VarCurr,7)
    <=> v128378(VarCurr) ) ).

tff(addAssignment_72542,axiom,
    ! [VarCurr: state_type] :
      ( v128378(VarCurr)
    <=> v100203(VarCurr,2) ) ).

tff(addAssignment_72541,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,0)
    <=> v128375(VarCurr) ) ).

tff(addAssignment_72540,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,1)
    <=> v128374(VarCurr) ) ).

tff(addAssignment_72539,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,2)
    <=> v128373(VarCurr) ) ).

tff(addAssignment_72538,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,3)
    <=> v128372(VarCurr) ) ).

tff(addAssignment_72537,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,4)
    <=> v128371(VarCurr) ) ).

tff(addAssignment_72536,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,5)
    <=> v128370(VarCurr) ) ).

tff(addAssignment_72535,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,6)
    <=> v128369(VarCurr) ) ).

tff(addAssignment_72534,axiom,
    ! [VarCurr: state_type] :
      ( v128366(VarCurr,7)
    <=> v128368(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1558,axiom,
    ! [VarCurr: state_type] :
      ( v128375(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1557,axiom,
    ! [VarCurr: state_type] :
      ( v128374(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1556,axiom,
    ! [VarCurr: state_type] :
      ( v128373(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1555,axiom,
    ! [VarCurr: state_type] :
      ( v128372(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $false )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1554,axiom,
    ! [VarCurr: state_type] :
      ( v128371(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1553,axiom,
    ! [VarCurr: state_type] :
      ( v128370(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $false )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1552,axiom,
    ! [VarCurr: state_type] :
      ( v128369(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1551,axiom,
    ! [VarCurr: state_type] :
      ( v128368(VarCurr)
    <=> ( ( v100445(VarCurr,11)
        <=> $true )
        & ( v100445(VarCurr,10)
        <=> $true )
        & ( v100445(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_72533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100445(VarCurr,B)
      <=> v100446(VarCurr,B) ) ) ).

tff(addAssignment_72532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128351(VarCurr,B)
      <=> v128353(VarCurr,B) ) ) ).

tff(addAssignment_72531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128353(VarCurr,B)
      <=> v128355(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128355(VarCurr,B)
      <=> ( v128357(VarCurr,B)
          & v128194(VarCurr,B) ) ) ) ).

tff(addAssignment_72530,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,0)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72529,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,1)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72528,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,2)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72527,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,3)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72526,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,4)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72525,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,5)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72524,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,6)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72523,axiom,
    ! [VarCurr: state_type] :
      ( v128357(VarCurr,7)
    <=> v128358(VarCurr) ) ).

tff(addAssignment_72522,axiom,
    ! [VarCurr: state_type] :
      ( v128358(VarCurr)
    <=> v100203(VarCurr,1) ) ).

tff(addAssignment_72521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128336(VarCurr,B)
      <=> v128130(VarCurr,B) ) ) ).

tff(addAssignment_72520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128130(VarCurr,B)
      <=> v128132(VarCurr,B) ) ) ).

tff(addAssignment_72519,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128132(VarNext,B)
      <=> v128343(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128344(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v128343(VarNext,B)
            <=> v128132(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1685,axiom,
    ! [VarNext: state_type] :
      ( v128344(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v128343(VarNext,B)
          <=> v128181(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128344(VarNext)
      <=> v128345(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128345(VarNext)
      <=> ( v128347(VarNext)
          & v128166(VarNext) ) ) ) ).

tff(writeUnaryOperator_9237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128347(VarNext)
      <=> v128175(VarNext) ) ) ).

tff(addAssignment_72518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128142(VarCurr,B)
      <=> v128144(VarCurr,B) ) ) ).

tff(addAssignment_72517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128144(VarCurr,B)
      <=> v128157(VarCurr,B) ) ) ).

tff(addAssignment_72516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128146(VarCurr,B)
      <=> v128150(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128151(VarCurr,B)
      <=> ( v128339(VarCurr,B)
          & v128341(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v128341(VarCurr,B)
          <=> v89411(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1245,axiom,
    ! [VarCurr: state_type] :
      ( v118(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v128341(VarCurr,B)
          <=> v2902(VarCurr,B) ) ) ) ).

tff(addAssignment_72515,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,0)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72514,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,1)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72513,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,2)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72512,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,3)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72511,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,4)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72510,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,5)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72509,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,6)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72508,axiom,
    ! [VarCurr: state_type] :
      ( v128339(VarCurr,7)
    <=> v128340(VarCurr) ) ).

tff(addAssignment_72507,axiom,
    ! [VarCurr: state_type] :
      ( v128340(VarCurr)
    <=> v128122(VarCurr) ) ).

tff(addAssignment_72506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128188(VarCurr,B)
      <=> v128190(VarCurr,B) ) ) ).

tff(addAssignment_72505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128190(VarCurr,B)
      <=> v128192(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128192(VarCurr,B)
      <=> ( v128333(VarCurr,B)
          & v128194(VarCurr,B) ) ) ) ).

tff(addAssignment_72504,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,0)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72503,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,1)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72502,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,2)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72501,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,3)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72500,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,4)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72499,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,5)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72498,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,6)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72497,axiom,
    ! [VarCurr: state_type] :
      ( v128333(VarCurr,7)
    <=> v128334(VarCurr) ) ).

tff(addAssignment_72496,axiom,
    ! [VarCurr: state_type] :
      ( v128334(VarCurr)
    <=> v100203(VarCurr,0) ) ).

tff(addAssignment_72495,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,0)
    <=> v128331(VarCurr) ) ).

tff(addAssignment_72494,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,1)
    <=> v128330(VarCurr) ) ).

tff(addAssignment_72493,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,2)
    <=> v128329(VarCurr) ) ).

tff(addAssignment_72492,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,3)
    <=> v128328(VarCurr) ) ).

tff(addAssignment_72491,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,4)
    <=> v128327(VarCurr) ) ).

tff(addAssignment_72490,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,5)
    <=> v128326(VarCurr) ) ).

tff(addAssignment_72489,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,6)
    <=> v128325(VarCurr) ) ).

tff(addAssignment_72488,axiom,
    ! [VarCurr: state_type] :
      ( v128194(VarCurr,7)
    <=> v128324(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1550,axiom,
    ! [VarCurr: state_type] :
      ( v128331(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1549,axiom,
    ! [VarCurr: state_type] :
      ( v128330(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1548,axiom,
    ! [VarCurr: state_type] :
      ( v128329(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1547,axiom,
    ! [VarCurr: state_type] :
      ( v128328(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $false )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1546,axiom,
    ! [VarCurr: state_type] :
      ( v128327(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1545,axiom,
    ! [VarCurr: state_type] :
      ( v128326(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $false )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1544,axiom,
    ! [VarCurr: state_type] :
      ( v128325(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1543,axiom,
    ! [VarCurr: state_type] :
      ( v128324(VarCurr)
    <=> ( ( v100229(VarCurr,11)
        <=> $true )
        & ( v100229(VarCurr,10)
        <=> $true )
        & ( v100229(VarCurr,9)
        <=> $true ) ) ) ).

tff(addAssignment_72487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100229(VarCurr,B)
      <=> v101555(VarCurr,B) ) ) ).

tff(addAssignment_72486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100409(VarCurr,B)
      <=> v101508(VarCurr,B) ) ) ).

tff(addAssignment_72485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97411(VarCurr,B)
      <=> v98356(VarCurr,B) ) ) ).

tff(addAssignment_72484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98301(VarCurr,B)
      <=> v98303(VarCurr,B) ) ) ).

tff(addAssignment_72483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98303(VarCurr,B)
      <=> v98305(VarCurr,B) ) ) ).

tff(addAssignment_72482,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98305(VarNext,B)
      <=> v128316(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128317(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128316(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1684,axiom,
    ! [VarNext: state_type] :
      ( v128317(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128316(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128317(VarNext)
      <=> v128318(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128318(VarNext)
      <=> ( v128320(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_9236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128320(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_72481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98315(VarCurr,B)
      <=> v98317(VarCurr,B) ) ) ).

tff(addAssignment_72480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98317(VarCurr,B)
      <=> v98326(VarCurr,B) ) ) ).

tff(addAssignment_72479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98319(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98245(VarCurr,B)
      <=> v98247(VarCurr,B) ) ) ).

tff(addAssignment_72477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98247(VarCurr,B)
      <=> v98249(VarCurr,B) ) ) ).

tff(addAssignment_72476,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98249(VarNext,B)
      <=> v128308(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128309(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128308(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1683,axiom,
    ! [VarNext: state_type] :
      ( v128309(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128308(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128309(VarNext)
      <=> v128310(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128310(VarNext)
      <=> ( v128312(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_9235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128312(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_72475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98259(VarCurr,B)
      <=> v98261(VarCurr,B) ) ) ).

tff(addAssignment_72474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98261(VarCurr,B)
      <=> v98270(VarCurr,B) ) ) ).

tff(addAssignment_72473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98263(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98189(VarCurr,B)
      <=> v98191(VarCurr,B) ) ) ).

tff(addAssignment_72471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98191(VarCurr,B)
      <=> v98193(VarCurr,B) ) ) ).

tff(addAssignment_72470,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98193(VarNext,B)
      <=> v128300(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128301(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128300(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1682,axiom,
    ! [VarNext: state_type] :
      ( v128301(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128300(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128301(VarNext)
      <=> v128302(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128302(VarNext)
      <=> ( v128304(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_9234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128304(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_72469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98203(VarCurr,B)
      <=> v98205(VarCurr,B) ) ) ).

tff(addAssignment_72468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98205(VarCurr,B)
      <=> v98214(VarCurr,B) ) ) ).

tff(addAssignment_72467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98207(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98133(VarCurr,B)
      <=> v98135(VarCurr,B) ) ) ).

tff(addAssignment_72465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98135(VarCurr,B)
      <=> v98137(VarCurr,B) ) ) ).

tff(addAssignment_72464,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98137(VarNext,B)
      <=> v128292(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128293(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128292(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1681,axiom,
    ! [VarNext: state_type] :
      ( v128293(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128292(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128293(VarNext)
      <=> v128294(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128294(VarNext)
      <=> ( v128296(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_9233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128296(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_72463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98147(VarCurr,B)
      <=> v98149(VarCurr,B) ) ) ).

tff(addAssignment_72462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98149(VarCurr,B)
      <=> v98158(VarCurr,B) ) ) ).

tff(addAssignment_72461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98151(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98077(VarCurr,B)
      <=> v98079(VarCurr,B) ) ) ).

tff(addAssignment_72459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98079(VarCurr,B)
      <=> v98081(VarCurr,B) ) ) ).

tff(addAssignment_72458,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98081(VarNext,B)
      <=> v128284(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128285(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128284(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1680,axiom,
    ! [VarNext: state_type] :
      ( v128285(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128284(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128285(VarNext)
      <=> v128286(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128286(VarNext)
      <=> ( v128288(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_9232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128288(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_72457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98091(VarCurr,B)
      <=> v98093(VarCurr,B) ) ) ).

tff(addAssignment_72456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98093(VarCurr,B)
      <=> v98102(VarCurr,B) ) ) ).

tff(addAssignment_72455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98095(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98021(VarCurr,B)
      <=> v98023(VarCurr,B) ) ) ).

tff(addAssignment_72453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98023(VarCurr,B)
      <=> v98025(VarCurr,B) ) ) ).

tff(addAssignment_72452,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98025(VarNext,B)
      <=> v128276(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128277(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128276(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1679,axiom,
    ! [VarNext: state_type] :
      ( v128277(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128276(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128277(VarNext)
      <=> v128278(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128278(VarNext)
      <=> ( v128280(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_9231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128280(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_72451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98035(VarCurr,B)
      <=> v98037(VarCurr,B) ) ) ).

tff(addAssignment_72450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98037(VarCurr,B)
      <=> v98046(VarCurr,B) ) ) ).

tff(addAssignment_72449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v98039(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97965(VarCurr,B)
      <=> v97967(VarCurr,B) ) ) ).

tff(addAssignment_72447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97967(VarCurr,B)
      <=> v97969(VarCurr,B) ) ) ).

tff(addAssignment_72446,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97969(VarNext,B)
      <=> v128268(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128269(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128268(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1678,axiom,
    ! [VarNext: state_type] :
      ( v128269(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128268(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128269(VarNext)
      <=> v128270(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128270(VarNext)
      <=> ( v128272(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_9230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128272(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_72445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97979(VarCurr,B)
      <=> v97981(VarCurr,B) ) ) ).

tff(addAssignment_72444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97981(VarCurr,B)
      <=> v97990(VarCurr,B) ) ) ).

tff(addAssignment_72443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97983(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97909(VarCurr,B)
      <=> v97911(VarCurr,B) ) ) ).

tff(addAssignment_72441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97911(VarCurr,B)
      <=> v97913(VarCurr,B) ) ) ).

tff(addAssignment_72440,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97913(VarNext,B)
      <=> v128260(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128261(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128260(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1677,axiom,
    ! [VarNext: state_type] :
      ( v128261(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128260(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128261(VarNext)
      <=> v128262(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128262(VarNext)
      <=> ( v128264(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_9229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128264(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_72439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97923(VarCurr,B)
      <=> v97925(VarCurr,B) ) ) ).

tff(addAssignment_72438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97925(VarCurr,B)
      <=> v97934(VarCurr,B) ) ) ).

tff(addAssignment_72437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97927(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97853(VarCurr,B)
      <=> v97855(VarCurr,B) ) ) ).

tff(addAssignment_72435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97855(VarCurr,B)
      <=> v97857(VarCurr,B) ) ) ).

tff(addAssignment_72434,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97857(VarNext,B)
      <=> v128252(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128253(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128252(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1676,axiom,
    ! [VarNext: state_type] :
      ( v128253(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128252(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128253(VarNext)
      <=> v128254(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128254(VarNext)
      <=> ( v128256(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_9228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128256(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_72433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97867(VarCurr,B)
      <=> v97869(VarCurr,B) ) ) ).

tff(addAssignment_72432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97869(VarCurr,B)
      <=> v97878(VarCurr,B) ) ) ).

tff(addAssignment_72431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97871(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97797(VarCurr,B)
      <=> v97799(VarCurr,B) ) ) ).

tff(addAssignment_72429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97799(VarCurr,B)
      <=> v97801(VarCurr,B) ) ) ).

tff(addAssignment_72428,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97801(VarNext,B)
      <=> v128244(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128245(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128244(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1675,axiom,
    ! [VarNext: state_type] :
      ( v128245(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128244(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128245(VarNext)
      <=> v128246(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128246(VarNext)
      <=> ( v128248(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_9227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128248(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_72427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97811(VarCurr,B)
      <=> v97813(VarCurr,B) ) ) ).

tff(addAssignment_72426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97813(VarCurr,B)
      <=> v97822(VarCurr,B) ) ) ).

tff(addAssignment_72425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97815(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97741(VarCurr,B)
      <=> v97743(VarCurr,B) ) ) ).

tff(addAssignment_72423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97743(VarCurr,B)
      <=> v97745(VarCurr,B) ) ) ).

tff(addAssignment_72422,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97745(VarNext,B)
      <=> v128236(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128237(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128236(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1674,axiom,
    ! [VarNext: state_type] :
      ( v128237(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128236(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128237(VarNext)
      <=> v128238(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128238(VarNext)
      <=> ( v128240(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_9226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128240(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_72421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97755(VarCurr,B)
      <=> v97757(VarCurr,B) ) ) ).

tff(addAssignment_72420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97757(VarCurr,B)
      <=> v97766(VarCurr,B) ) ) ).

tff(addAssignment_72419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97759(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97685(VarCurr,B)
      <=> v97687(VarCurr,B) ) ) ).

tff(addAssignment_72417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97687(VarCurr,B)
      <=> v97689(VarCurr,B) ) ) ).

tff(addAssignment_72416,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97689(VarNext,B)
      <=> v128228(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128229(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128228(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1673,axiom,
    ! [VarNext: state_type] :
      ( v128229(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128228(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128229(VarNext)
      <=> v128230(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128230(VarNext)
      <=> ( v128232(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_9225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128232(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_72415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97699(VarCurr,B)
      <=> v97701(VarCurr,B) ) ) ).

tff(addAssignment_72414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97701(VarCurr,B)
      <=> v97710(VarCurr,B) ) ) ).

tff(addAssignment_72413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97703(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97629(VarCurr,B)
      <=> v97631(VarCurr,B) ) ) ).

tff(addAssignment_72411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97631(VarCurr,B)
      <=> v97633(VarCurr,B) ) ) ).

tff(addAssignment_72410,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97633(VarNext,B)
      <=> v128220(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128221(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128220(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1672,axiom,
    ! [VarNext: state_type] :
      ( v128221(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128220(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128221(VarNext)
      <=> v128222(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128222(VarNext)
      <=> ( v128224(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_9224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128224(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_72409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97643(VarCurr,B)
      <=> v97645(VarCurr,B) ) ) ).

tff(addAssignment_72408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97645(VarCurr,B)
      <=> v97654(VarCurr,B) ) ) ).

tff(addAssignment_72407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97647(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97573(VarCurr,B)
      <=> v97575(VarCurr,B) ) ) ).

tff(addAssignment_72405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97575(VarCurr,B)
      <=> v97577(VarCurr,B) ) ) ).

tff(addAssignment_72404,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97577(VarNext,B)
      <=> v128212(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128213(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128212(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1671,axiom,
    ! [VarNext: state_type] :
      ( v128213(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128212(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128213(VarNext)
      <=> v128214(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128214(VarNext)
      <=> ( v128216(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_9223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128216(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_72403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97587(VarCurr,B)
      <=> v97589(VarCurr,B) ) ) ).

tff(addAssignment_72402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97589(VarCurr,B)
      <=> v97598(VarCurr,B) ) ) ).

tff(addAssignment_72401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97591(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97517(VarCurr,B)
      <=> v97519(VarCurr,B) ) ) ).

tff(addAssignment_72399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97519(VarCurr,B)
      <=> v97521(VarCurr,B) ) ) ).

tff(addAssignment_72398,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97521(VarNext,B)
      <=> v128204(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128205(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128204(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1670,axiom,
    ! [VarNext: state_type] :
      ( v128205(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128204(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128205(VarNext)
      <=> v128206(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128206(VarNext)
      <=> ( v128208(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_9222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128208(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_72397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97531(VarCurr,B)
      <=> v97533(VarCurr,B) ) ) ).

tff(addAssignment_72396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97533(VarCurr,B)
      <=> v97542(VarCurr,B) ) ) ).

tff(addAssignment_72395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97535(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97413(VarCurr,B)
      <=> v97415(VarCurr,B) ) ) ).

tff(addAssignment_72393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97415(VarCurr,B)
      <=> v97417(VarCurr,B) ) ) ).

tff(addAssignment_72392,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97417(VarNext,B)
      <=> v128196(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128197(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v128196(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1669,axiom,
    ! [VarNext: state_type] :
      ( v128197(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v128196(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128197(VarNext)
      <=> v128198(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128198(VarNext)
      <=> ( v128200(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_9221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128200(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_72391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97427(VarCurr,B)
      <=> v97429(VarCurr,B) ) ) ).

tff(addAssignment_72390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97429(VarCurr,B)
      <=> v97486(VarCurr,B) ) ) ).

tff(addAssignment_72389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97431(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_72388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v97409(VarCurr,B)
      <=> v100196(VarCurr,B) ) ) ).

tff(addAssignment_72387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100043(VarCurr,B)
      <=> v100045(VarCurr,B) ) ) ).

tff(addAssignment_72386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100045(VarCurr,B)
      <=> v100047(VarCurr,B) ) ) ).

tff(addAssignment_72385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100047(VarCurr,B)
      <=> v100049(VarCurr,B) ) ) ).

tff(addAssignment_72384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v100049(VarCurr,B)
      <=> v100051(VarCurr,B) ) ) ).

tff(addAssignment_72383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v99888(VarCurr,B)
      <=> v99890(VarCurr,B) ) ) ).

tff(addAssignment_72382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v99890(VarCurr,B)
      <=> v99892(VarCurr,B) ) ) ).

tff(addAssignment_72381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v99892(VarCurr,B)
      <=> v99894(VarCurr,B) ) ) ).

tff(addAssignment_72380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v99894(VarCurr,B)
      <=> v99896(VarCurr,B) ) ) ).

tff(addAssignment_72379,axiom,
    ! [VarCurr: state_type] :
      ( v128128(VarCurr)
    <=> v128130(VarCurr,8) ) ).

tff(addAssignment_72378,axiom,
    ! [VarCurr: state_type] :
      ( v128130(VarCurr,8)
    <=> v128132(VarCurr,8) ) ).

tff(addAssignment_72377,axiom,
    ! [VarNext: state_type] :
      ( v128132(VarNext,8)
    <=> v128170(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_1668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128171(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v128170(VarNext,B)
            <=> v128132(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1668,axiom,
    ! [VarNext: state_type] :
      ( v128171(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v128170(VarNext,B)
          <=> v128181(VarNext,B) ) ) ) ).

tff(addAssignment_72376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v128181(VarNext,B)
          <=> v128179(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128182(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v128179(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1244,axiom,
    ! [VarCurr: state_type] :
      ( v128182(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v128179(VarCurr,B)
          <=> v128142(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16506,axiom,
    ! [VarCurr: state_type] :
      ( v128182(VarCurr)
    <=> ( v128183(VarCurr)
        & v128184(VarCurr) ) ) ).

tff(writeUnaryOperator_9220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128184(VarCurr)
    <=> v128138(VarCurr) ) ).

tff(writeUnaryOperator_9219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128183(VarCurr)
    <=> v128134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128171(VarNext)
      <=> v128172(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128172(VarNext)
      <=> ( v128173(VarNext)
          & v128166(VarNext) ) ) ) ).

tff(writeUnaryOperator_9218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v128173(VarNext)
      <=> v128175(VarNext) ) ) ).

tff(addAssignment_72375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v128175(VarNext)
      <=> v128166(VarCurr) ) ) ).

tff(addAssignment_72374,axiom,
    ! [VarCurr: state_type] :
      ( v128166(VarCurr)
    <=> v128168(VarCurr) ) ).

tff(addAssignment_72373,axiom,
    ! [VarCurr: state_type] :
      ( v128168(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_72372,axiom,
    ! [VarCurr: state_type] :
      ( v128142(VarCurr,8)
    <=> v128144(VarCurr,8) ) ).

tff(addAssignment_72371,axiom,
    ! [VarCurr: state_type] :
      ( v128144(VarCurr,8)
    <=> v128157(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,0) )
     => ( v128157(VarCurr,B)
      <=> ( v128158(VarCurr,B)
          | v128161(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,0) )
     => ( v128161(VarCurr,B)
      <=> ( v128130(VarCurr,B)
          & v128162(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,0) )
     => ( v128162(VarCurr,B)
      <=> ~ v128163(VarCurr,B) ) ) ).

tff(addAssignment_72370,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,0)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72369,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,1)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72368,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,2)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72367,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,3)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72366,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,4)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72365,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,5)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72364,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,6)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72363,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,7)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72362,axiom,
    ! [VarCurr: state_type] :
      ( v128163(VarCurr,8)
    <=> v128164(VarCurr) ) ).

tff(addAssignment_72361,axiom,
    ! [VarCurr: state_type] :
      ( v128164(VarCurr)
    <=> v128153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,0) )
     => ( v128158(VarCurr,B)
      <=> ( v128146(VarCurr,B)
          & v128159(VarCurr,B) ) ) ) ).

tff(addAssignment_72360,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,0)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72359,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,1)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72358,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,2)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72357,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,3)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72356,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,4)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72355,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,5)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72354,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,6)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72353,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,7)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72352,axiom,
    ! [VarCurr: state_type] :
      ( v128159(VarCurr,8)
    <=> v128160(VarCurr) ) ).

tff(addAssignment_72351,axiom,
    ! [VarCurr: state_type] :
      ( v128160(VarCurr)
    <=> v128153(VarCurr) ) ).

tff(addAssignment_72350,axiom,
    ! [VarCurr: state_type] :
      ( v128153(VarCurr)
    <=> v128155(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16503,axiom,
    ! [VarCurr: state_type] :
      ( v128155(VarCurr)
    <=> ( v128122(VarCurr)
        | v128126(VarCurr) ) ) ).

tff(addAssignment_72349,axiom,
    ! [VarCurr: state_type] :
      ( v128146(VarCurr,8)
    <=> v128150(VarCurr,8) ) ).

tff(addAssignment_72348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v128150(VarCurr,B)
      <=> v128151(VarCurr,B) ) ) ).

tff(addAssignment_72347,axiom,
    ! [VarCurr: state_type] :
      ( v128150(VarCurr,8)
    <=> v128148(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v128122(VarCurr)
     => ( v128148(VarCurr)
      <=> v128128(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1243,axiom,
    ! [VarCurr: state_type] :
      ( v128122(VarCurr)
     => ( v128148(VarCurr)
      <=> v118(VarCurr) ) ) ).

tff(addAssignment_72346,axiom,
    ! [VarCurr: state_type] :
      ( v128138(VarCurr)
    <=> v128140(VarCurr) ) ).

tff(addAssignment_72345,axiom,
    ! [VarCurr: state_type] :
      ( v128140(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_72344,axiom,
    ! [VarCurr: state_type] :
      ( v128134(VarCurr)
    <=> v128136(VarCurr) ) ).

tff(addAssignment_72343,axiom,
    ! [VarCurr: state_type] :
      ( v128136(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_72342,axiom,
    ! [VarCurr: state_type] :
      ( v128120(VarCurr)
    <=> v128122(VarCurr) ) ).

tff(addAssignment_72341,axiom,
    ! [VarCurr: state_type] :
      ( v128122(VarCurr)
    <=> v128115(VarCurr) ) ).

tff(addAssignment_72340,axiom,
    ! [VarCurr: state_type] :
      ( v128113(VarCurr)
    <=> v128115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16502,axiom,
    ! [VarCurr: state_type] :
      ( v128115(VarCurr)
    <=> ( v128117(VarCurr)
        | v128118(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16501,axiom,
    ! [VarCurr: state_type] :
      ( v128118(VarCurr)
    <=> ( v89409(VarCurr)
        & v84899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16500,axiom,
    ! [VarCurr: state_type] :
      ( v128117(VarCurr)
    <=> ( v2900(VarCurr)
        & v118(VarCurr) ) ) ).

tff(addAssignment_72339,axiom,
    ! [VarCurr: state_type] :
      ( v128105(VarCurr)
    <=> v128107(VarCurr) ) ).

tff(addAssignment_72338,axiom,
    ! [VarCurr: state_type] :
      ( v128107(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_72337,axiom,
    ! [VarCurr: state_type] :
      ( v128101(VarCurr)
    <=> v128103(VarCurr) ) ).

tff(addAssignment_72336,axiom,
    ! [VarCurr: state_type] :
      ( v128103(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16499,axiom,
    ! [VarCurr: state_type] :
      ( v127412(VarCurr)
    <=> ( v128060(VarCurr)
        | v128077(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5778,axiom,
    ! [VarCurr: state_type] :
      ( v128077(VarCurr)
    <=> ( v128079(VarCurr)
        | v128093(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5777,axiom,
    ! [VarCurr: state_type] :
      ( v128079(VarCurr)
    <=> ( v128080(VarCurr)
        | v128093(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5776,axiom,
    ! [VarCurr: state_type] :
      ( v128080(VarCurr)
    <=> ( v128081(VarCurr)
        | v128093(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5775,axiom,
    ! [VarCurr: state_type] :
      ( v128081(VarCurr)
    <=> ( v128082(VarCurr)
        | v128093(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5774,axiom,
    ! [VarCurr: state_type] :
      ( v128082(VarCurr)
    <=> ( v128083(VarCurr)
        | v128093(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5773,axiom,
    ! [VarCurr: state_type] :
      ( v128083(VarCurr)
    <=> ( v128084(VarCurr)
        | v128093(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5772,axiom,
    ! [VarCurr: state_type] :
      ( v128084(VarCurr)
    <=> ( v128085(VarCurr)
        | v128093(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5771,axiom,
    ! [VarCurr: state_type] :
      ( v128085(VarCurr)
    <=> ( v128086(VarCurr)
        | v128093(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5770,axiom,
    ! [VarCurr: state_type] :
      ( v128086(VarCurr)
    <=> ( v128087(VarCurr)
        | v128093(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5769,axiom,
    ! [VarCurr: state_type] :
      ( v128087(VarCurr)
    <=> ( v128088(VarCurr)
        | v128093(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5768,axiom,
    ! [VarCurr: state_type] :
      ( v128088(VarCurr)
    <=> ( v128089(VarCurr)
        | v128093(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5767,axiom,
    ! [VarCurr: state_type] :
      ( v128089(VarCurr)
    <=> ( v128090(VarCurr)
        | v128093(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5766,axiom,
    ! [VarCurr: state_type] :
      ( v128090(VarCurr)
    <=> ( v128091(VarCurr)
        | v128093(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5765,axiom,
    ! [VarCurr: state_type] :
      ( v128091(VarCurr)
    <=> ( v128092(VarCurr)
        | v128093(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5764,axiom,
    ! [VarCurr: state_type] :
      ( v128092(VarCurr)
    <=> ( v128093(VarCurr,0)
        | v128093(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128093(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v127706(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5763,axiom,
    ! [VarCurr: state_type] :
      ( v128060(VarCurr)
    <=> ( v128062(VarCurr)
        | v128076(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5762,axiom,
    ! [VarCurr: state_type] :
      ( v128062(VarCurr)
    <=> ( v128063(VarCurr)
        | v128076(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5761,axiom,
    ! [VarCurr: state_type] :
      ( v128063(VarCurr)
    <=> ( v128064(VarCurr)
        | v128076(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5760,axiom,
    ! [VarCurr: state_type] :
      ( v128064(VarCurr)
    <=> ( v128065(VarCurr)
        | v128076(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5759,axiom,
    ! [VarCurr: state_type] :
      ( v128065(VarCurr)
    <=> ( v128066(VarCurr)
        | v128076(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5758,axiom,
    ! [VarCurr: state_type] :
      ( v128066(VarCurr)
    <=> ( v128067(VarCurr)
        | v128076(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5757,axiom,
    ! [VarCurr: state_type] :
      ( v128067(VarCurr)
    <=> ( v128068(VarCurr)
        | v128076(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5756,axiom,
    ! [VarCurr: state_type] :
      ( v128068(VarCurr)
    <=> ( v128069(VarCurr)
        | v128076(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5755,axiom,
    ! [VarCurr: state_type] :
      ( v128069(VarCurr)
    <=> ( v128070(VarCurr)
        | v128076(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5754,axiom,
    ! [VarCurr: state_type] :
      ( v128070(VarCurr)
    <=> ( v128071(VarCurr)
        | v128076(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5753,axiom,
    ! [VarCurr: state_type] :
      ( v128071(VarCurr)
    <=> ( v128072(VarCurr)
        | v128076(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5752,axiom,
    ! [VarCurr: state_type] :
      ( v128072(VarCurr)
    <=> ( v128073(VarCurr)
        | v128076(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5751,axiom,
    ! [VarCurr: state_type] :
      ( v128073(VarCurr)
    <=> ( v128074(VarCurr)
        | v128076(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5750,axiom,
    ! [VarCurr: state_type] :
      ( v128074(VarCurr)
    <=> ( v128075(VarCurr)
        | v128076(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5749,axiom,
    ! [VarCurr: state_type] :
      ( v128075(VarCurr)
    <=> ( v128076(VarCurr,0)
        | v128076(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128076(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v127414(VarCurr,B) ) ) ) ).

tff(addAssignment_72335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127706(VarCurr,B)
      <=> v127708(VarCurr,B) ) ) ).

tff(addAssignment_72334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127708(VarCurr,B)
      <=> v127710(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127710(VarCurr,B)
      <=> ( v128026(VarCurr,B)
          & v128057(VarCurr,B) ) ) ) ).

tff(addAssignment_72333,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,0)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72332,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,1)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72331,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,2)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72330,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,3)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72329,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,4)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72328,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,5)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72327,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,6)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72326,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,7)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72325,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,8)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72324,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,9)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72323,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,10)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72322,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,11)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72321,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,12)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72320,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,13)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72319,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,14)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72318,axiom,
    ! [VarCurr: state_type] :
      ( v128057(VarCurr,15)
    <=> v128058(VarCurr) ) ).

tff(addAssignment_72317,axiom,
    ! [VarCurr: state_type] :
      ( v128058(VarCurr)
    <=> v128024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128026(VarCurr,B)
      <=> ( v128027(VarCurr,B)
          | v128054(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128054(VarCurr,B)
      <=> ( v127999(VarCurr,B)
          & v128055(VarCurr,B) ) ) ) ).

tff(addAssignment_72316,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,0)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72315,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,1)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72314,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,2)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72313,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,3)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72312,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,4)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72311,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,5)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72310,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,6)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72309,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,7)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72308,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,8)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72307,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,9)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72306,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,10)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72305,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,11)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72304,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,12)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72303,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,13)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72302,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,14)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72301,axiom,
    ! [VarCurr: state_type] :
      ( v128055(VarCurr,15)
    <=> v128056(VarCurr) ) ).

tff(addAssignment_72300,axiom,
    ! [VarCurr: state_type] :
      ( v128056(VarCurr)
    <=> v134(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128027(VarCurr,B)
      <=> ( v128028(VarCurr,B)
          | v128051(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128051(VarCurr,B)
      <=> ( v127974(VarCurr,B)
          & v128052(VarCurr,B) ) ) ) ).

tff(addAssignment_72299,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,0)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72298,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,1)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72297,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,2)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72296,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,3)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72295,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,4)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72294,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,5)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72293,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,6)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72292,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,7)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72291,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,8)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72290,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,9)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72289,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,10)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72288,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,11)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72287,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,12)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72286,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,13)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72285,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,14)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72284,axiom,
    ! [VarCurr: state_type] :
      ( v128052(VarCurr,15)
    <=> v128053(VarCurr) ) ).

tff(addAssignment_72283,axiom,
    ! [VarCurr: state_type] :
      ( v128053(VarCurr)
    <=> v134(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128028(VarCurr,B)
      <=> ( v128029(VarCurr,B)
          | v128048(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128048(VarCurr,B)
      <=> ( v127949(VarCurr,B)
          & v128049(VarCurr,B) ) ) ) ).

tff(addAssignment_72282,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,0)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72281,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,1)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72280,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,2)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72279,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,3)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72278,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,4)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72277,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,5)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72276,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,6)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72275,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,7)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72274,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,8)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72273,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,9)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72272,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,10)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72271,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,11)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72270,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,12)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72269,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,13)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72268,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,14)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72267,axiom,
    ! [VarCurr: state_type] :
      ( v128049(VarCurr,15)
    <=> v128050(VarCurr) ) ).

tff(addAssignment_72266,axiom,
    ! [VarCurr: state_type] :
      ( v128050(VarCurr)
    <=> v134(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128029(VarCurr,B)
      <=> ( v128030(VarCurr,B)
          | v128045(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128045(VarCurr,B)
      <=> ( v127924(VarCurr,B)
          & v128046(VarCurr,B) ) ) ) ).

tff(addAssignment_72265,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,0)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72264,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,1)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72263,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,2)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72262,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,3)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72261,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,4)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72260,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,5)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72259,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,6)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72258,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,7)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72257,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,8)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72256,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,9)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72255,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,10)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72254,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,11)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72253,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,12)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72252,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,13)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72251,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,14)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72250,axiom,
    ! [VarCurr: state_type] :
      ( v128046(VarCurr,15)
    <=> v128047(VarCurr) ) ).

tff(addAssignment_72249,axiom,
    ! [VarCurr: state_type] :
      ( v128047(VarCurr)
    <=> v134(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128030(VarCurr,B)
      <=> ( v128031(VarCurr,B)
          | v128042(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128042(VarCurr,B)
      <=> ( v127899(VarCurr,B)
          & v128043(VarCurr,B) ) ) ) ).

tff(addAssignment_72248,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,0)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72247,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,1)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72246,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,2)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72245,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,3)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72244,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,4)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72243,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,5)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72242,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,6)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72241,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,7)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72240,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,8)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72239,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,9)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72238,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,10)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72237,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,11)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72236,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,12)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72235,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,13)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72234,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,14)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72233,axiom,
    ! [VarCurr: state_type] :
      ( v128043(VarCurr,15)
    <=> v128044(VarCurr) ) ).

tff(addAssignment_72232,axiom,
    ! [VarCurr: state_type] :
      ( v128044(VarCurr)
    <=> v134(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128031(VarCurr,B)
      <=> ( v128032(VarCurr,B)
          | v128039(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128039(VarCurr,B)
      <=> ( v127874(VarCurr,B)
          & v128040(VarCurr,B) ) ) ) ).

tff(addAssignment_72231,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,0)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72230,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,1)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72229,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,2)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72228,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,3)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72227,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,4)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72226,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,5)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72225,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,6)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72224,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,7)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72223,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,8)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72222,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,9)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72221,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,10)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72220,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,11)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72219,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,12)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72218,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,13)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72217,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,14)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72216,axiom,
    ! [VarCurr: state_type] :
      ( v128040(VarCurr,15)
    <=> v128041(VarCurr) ) ).

tff(addAssignment_72215,axiom,
    ! [VarCurr: state_type] :
      ( v128041(VarCurr)
    <=> v134(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128032(VarCurr,B)
      <=> ( v128033(VarCurr,B)
          | v128036(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128036(VarCurr,B)
      <=> ( v127849(VarCurr,B)
          & v128037(VarCurr,B) ) ) ) ).

tff(addAssignment_72214,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,0)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72213,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,1)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72212,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,2)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72211,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,3)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72210,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,4)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72209,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,5)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72208,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,6)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72207,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,7)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72206,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,8)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72205,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,9)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72204,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,10)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72203,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,11)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72202,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,12)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72201,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,13)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72200,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,14)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72199,axiom,
    ! [VarCurr: state_type] :
      ( v128037(VarCurr,15)
    <=> v128038(VarCurr) ) ).

tff(addAssignment_72198,axiom,
    ! [VarCurr: state_type] :
      ( v128038(VarCurr)
    <=> v134(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v128033(VarCurr,B)
      <=> ( v127712(VarCurr,B)
          & v128034(VarCurr,B) ) ) ) ).

tff(addAssignment_72197,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,0)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72196,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,1)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72195,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,2)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72194,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,3)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72193,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,4)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72192,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,5)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72191,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,6)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72190,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,7)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72189,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,8)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72188,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,9)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72187,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,10)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72186,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,11)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72185,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,12)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72184,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,13)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72183,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,14)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72182,axiom,
    ! [VarCurr: state_type] :
      ( v128034(VarCurr,15)
    <=> v128035(VarCurr) ) ).

tff(addAssignment_72181,axiom,
    ! [VarCurr: state_type] :
      ( v128035(VarCurr)
    <=> v134(VarCurr,0) ) ).

tff(addAssignment_72180,axiom,
    ! [VarCurr: state_type] :
      ( v128024(VarCurr)
    <=> v127622(VarCurr) ) ).

tff(addAssignment_72179,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,0)
    <=> v128022(VarCurr) ) ).

tff(addAssignment_72178,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,1)
    <=> v128021(VarCurr) ) ).

tff(addAssignment_72177,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,2)
    <=> v128020(VarCurr) ) ).

tff(addAssignment_72176,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,3)
    <=> v128019(VarCurr) ) ).

tff(addAssignment_72175,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,4)
    <=> v128018(VarCurr) ) ).

tff(addAssignment_72174,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,5)
    <=> v128017(VarCurr) ) ).

tff(addAssignment_72173,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,6)
    <=> v128016(VarCurr) ) ).

tff(addAssignment_72172,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,7)
    <=> v128015(VarCurr) ) ).

tff(addAssignment_72171,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,8)
    <=> v128014(VarCurr) ) ).

tff(addAssignment_72170,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,9)
    <=> v128013(VarCurr) ) ).

tff(addAssignment_72169,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,10)
    <=> v128012(VarCurr) ) ).

tff(addAssignment_72168,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,11)
    <=> v128011(VarCurr) ) ).

tff(addAssignment_72167,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,12)
    <=> v128010(VarCurr) ) ).

tff(addAssignment_72166,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,13)
    <=> v128009(VarCurr) ) ).

tff(addAssignment_72165,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,14)
    <=> v128008(VarCurr) ) ).

tff(addAssignment_72164,axiom,
    ! [VarCurr: state_type] :
      ( v127999(VarCurr,15)
    <=> v128007(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1542,axiom,
    ! [VarCurr: state_type] :
      ( v128022(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1541,axiom,
    ! [VarCurr: state_type] :
      ( v128021(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1540,axiom,
    ! [VarCurr: state_type] :
      ( v128020(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1539,axiom,
    ! [VarCurr: state_type] :
      ( v128019(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1538,axiom,
    ! [VarCurr: state_type] :
      ( v128018(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1537,axiom,
    ! [VarCurr: state_type] :
      ( v128017(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1536,axiom,
    ! [VarCurr: state_type] :
      ( v128016(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1535,axiom,
    ! [VarCurr: state_type] :
      ( v128015(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $false )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1534,axiom,
    ! [VarCurr: state_type] :
      ( v128014(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1533,axiom,
    ! [VarCurr: state_type] :
      ( v128013(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1532,axiom,
    ! [VarCurr: state_type] :
      ( v128012(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1531,axiom,
    ! [VarCurr: state_type] :
      ( v128011(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $false )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1530,axiom,
    ! [VarCurr: state_type] :
      ( v128010(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1529,axiom,
    ! [VarCurr: state_type] :
      ( v128009(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $false )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1528,axiom,
    ! [VarCurr: state_type] :
      ( v128008(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1527,axiom,
    ! [VarCurr: state_type] :
      ( v128007(VarCurr)
    <=> ( ( v128001(VarCurr,3)
        <=> $true )
        & ( v128001(VarCurr,2)
        <=> $true )
        & ( v128001(VarCurr,1)
        <=> $true )
        & ( v128001(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v128001(VarCurr,B)
      <=> v89253(VarCurr,B) ) ) ).

tff(addAssignment_72162,axiom,
    ! [VarCurr: state_type] :
      ( v128001(VarCurr,3)
    <=> v128003(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v128003(VarCurr)
      <=> v128005(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1242,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v128003(VarCurr)
      <=> v128004(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v128005(VarCurr)
      <=> v89253(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_142,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v128005(VarCurr)
      <=> v89253(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v128004(VarCurr)
      <=> v89253(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_141,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v128004(VarCurr)
      <=> v89253(VarCurr,6) ) ) ).

tff(addAssignment_72161,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,0)
    <=> v127997(VarCurr) ) ).

tff(addAssignment_72160,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,1)
    <=> v127996(VarCurr) ) ).

tff(addAssignment_72159,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,2)
    <=> v127995(VarCurr) ) ).

tff(addAssignment_72158,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,3)
    <=> v127994(VarCurr) ) ).

tff(addAssignment_72157,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,4)
    <=> v127993(VarCurr) ) ).

tff(addAssignment_72156,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,5)
    <=> v127992(VarCurr) ) ).

tff(addAssignment_72155,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,6)
    <=> v127991(VarCurr) ) ).

tff(addAssignment_72154,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,7)
    <=> v127990(VarCurr) ) ).

tff(addAssignment_72153,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,8)
    <=> v127989(VarCurr) ) ).

tff(addAssignment_72152,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,9)
    <=> v127988(VarCurr) ) ).

tff(addAssignment_72151,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,10)
    <=> v127987(VarCurr) ) ).

tff(addAssignment_72150,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,11)
    <=> v127986(VarCurr) ) ).

tff(addAssignment_72149,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,12)
    <=> v127985(VarCurr) ) ).

tff(addAssignment_72148,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,13)
    <=> v127984(VarCurr) ) ).

tff(addAssignment_72147,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,14)
    <=> v127983(VarCurr) ) ).

tff(addAssignment_72146,axiom,
    ! [VarCurr: state_type] :
      ( v127974(VarCurr,15)
    <=> v127982(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1526,axiom,
    ! [VarCurr: state_type] :
      ( v127997(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1525,axiom,
    ! [VarCurr: state_type] :
      ( v127996(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1524,axiom,
    ! [VarCurr: state_type] :
      ( v127995(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1523,axiom,
    ! [VarCurr: state_type] :
      ( v127994(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1522,axiom,
    ! [VarCurr: state_type] :
      ( v127993(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1521,axiom,
    ! [VarCurr: state_type] :
      ( v127992(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1520,axiom,
    ! [VarCurr: state_type] :
      ( v127991(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1519,axiom,
    ! [VarCurr: state_type] :
      ( v127990(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $false )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1518,axiom,
    ! [VarCurr: state_type] :
      ( v127989(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1517,axiom,
    ! [VarCurr: state_type] :
      ( v127988(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1516,axiom,
    ! [VarCurr: state_type] :
      ( v127987(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1515,axiom,
    ! [VarCurr: state_type] :
      ( v127986(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $false )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1514,axiom,
    ! [VarCurr: state_type] :
      ( v127985(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1513,axiom,
    ! [VarCurr: state_type] :
      ( v127984(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $false )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1512,axiom,
    ! [VarCurr: state_type] :
      ( v127983(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1511,axiom,
    ! [VarCurr: state_type] :
      ( v127982(VarCurr)
    <=> ( ( v127976(VarCurr,3)
        <=> $true )
        & ( v127976(VarCurr,2)
        <=> $true )
        & ( v127976(VarCurr,1)
        <=> $true )
        & ( v127976(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127976(VarCurr,B)
      <=> v109114(VarCurr,B) ) ) ).

tff(addAssignment_72144,axiom,
    ! [VarCurr: state_type] :
      ( v127976(VarCurr,3)
    <=> v127978(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127978(VarCurr)
      <=> v127980(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1241,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127978(VarCurr)
      <=> v127979(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127980(VarCurr)
      <=> v109114(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_140,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127980(VarCurr)
      <=> v109114(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127979(VarCurr)
      <=> v109114(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_139,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127979(VarCurr)
      <=> v109114(VarCurr,6) ) ) ).

tff(addAssignment_72143,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,0)
    <=> v127972(VarCurr) ) ).

tff(addAssignment_72142,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,1)
    <=> v127971(VarCurr) ) ).

tff(addAssignment_72141,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,2)
    <=> v127970(VarCurr) ) ).

tff(addAssignment_72140,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,3)
    <=> v127969(VarCurr) ) ).

tff(addAssignment_72139,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,4)
    <=> v127968(VarCurr) ) ).

tff(addAssignment_72138,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,5)
    <=> v127967(VarCurr) ) ).

tff(addAssignment_72137,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,6)
    <=> v127966(VarCurr) ) ).

tff(addAssignment_72136,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,7)
    <=> v127965(VarCurr) ) ).

tff(addAssignment_72135,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,8)
    <=> v127964(VarCurr) ) ).

tff(addAssignment_72134,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,9)
    <=> v127963(VarCurr) ) ).

tff(addAssignment_72133,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,10)
    <=> v127962(VarCurr) ) ).

tff(addAssignment_72132,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,11)
    <=> v127961(VarCurr) ) ).

tff(addAssignment_72131,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,12)
    <=> v127960(VarCurr) ) ).

tff(addAssignment_72130,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,13)
    <=> v127959(VarCurr) ) ).

tff(addAssignment_72129,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,14)
    <=> v127958(VarCurr) ) ).

tff(addAssignment_72128,axiom,
    ! [VarCurr: state_type] :
      ( v127949(VarCurr,15)
    <=> v127957(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1510,axiom,
    ! [VarCurr: state_type] :
      ( v127972(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1509,axiom,
    ! [VarCurr: state_type] :
      ( v127971(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1508,axiom,
    ! [VarCurr: state_type] :
      ( v127970(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1507,axiom,
    ! [VarCurr: state_type] :
      ( v127969(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1506,axiom,
    ! [VarCurr: state_type] :
      ( v127968(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1505,axiom,
    ! [VarCurr: state_type] :
      ( v127967(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1504,axiom,
    ! [VarCurr: state_type] :
      ( v127966(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1503,axiom,
    ! [VarCurr: state_type] :
      ( v127965(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $false )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1502,axiom,
    ! [VarCurr: state_type] :
      ( v127964(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1501,axiom,
    ! [VarCurr: state_type] :
      ( v127963(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1500,axiom,
    ! [VarCurr: state_type] :
      ( v127962(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1499,axiom,
    ! [VarCurr: state_type] :
      ( v127961(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $false )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1498,axiom,
    ! [VarCurr: state_type] :
      ( v127960(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1497,axiom,
    ! [VarCurr: state_type] :
      ( v127959(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $false )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1496,axiom,
    ! [VarCurr: state_type] :
      ( v127958(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1495,axiom,
    ! [VarCurr: state_type] :
      ( v127957(VarCurr)
    <=> ( ( v127951(VarCurr,3)
        <=> $true )
        & ( v127951(VarCurr,2)
        <=> $true )
        & ( v127951(VarCurr,1)
        <=> $true )
        & ( v127951(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127951(VarCurr,B)
      <=> v109181(VarCurr,B) ) ) ).

tff(addAssignment_72126,axiom,
    ! [VarCurr: state_type] :
      ( v127951(VarCurr,3)
    <=> v127953(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127953(VarCurr)
      <=> v127955(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1240,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127953(VarCurr)
      <=> v127954(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127955(VarCurr)
      <=> v109181(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_138,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127955(VarCurr)
      <=> v109181(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127954(VarCurr)
      <=> v109181(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_137,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127954(VarCurr)
      <=> v109181(VarCurr,6) ) ) ).

tff(addAssignment_72125,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,0)
    <=> v127947(VarCurr) ) ).

tff(addAssignment_72124,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,1)
    <=> v127946(VarCurr) ) ).

tff(addAssignment_72123,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,2)
    <=> v127945(VarCurr) ) ).

tff(addAssignment_72122,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,3)
    <=> v127944(VarCurr) ) ).

tff(addAssignment_72121,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,4)
    <=> v127943(VarCurr) ) ).

tff(addAssignment_72120,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,5)
    <=> v127942(VarCurr) ) ).

tff(addAssignment_72119,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,6)
    <=> v127941(VarCurr) ) ).

tff(addAssignment_72118,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,7)
    <=> v127940(VarCurr) ) ).

tff(addAssignment_72117,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,8)
    <=> v127939(VarCurr) ) ).

tff(addAssignment_72116,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,9)
    <=> v127938(VarCurr) ) ).

tff(addAssignment_72115,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,10)
    <=> v127937(VarCurr) ) ).

tff(addAssignment_72114,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,11)
    <=> v127936(VarCurr) ) ).

tff(addAssignment_72113,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,12)
    <=> v127935(VarCurr) ) ).

tff(addAssignment_72112,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,13)
    <=> v127934(VarCurr) ) ).

tff(addAssignment_72111,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,14)
    <=> v127933(VarCurr) ) ).

tff(addAssignment_72110,axiom,
    ! [VarCurr: state_type] :
      ( v127924(VarCurr,15)
    <=> v127932(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1494,axiom,
    ! [VarCurr: state_type] :
      ( v127947(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1493,axiom,
    ! [VarCurr: state_type] :
      ( v127946(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1492,axiom,
    ! [VarCurr: state_type] :
      ( v127945(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1491,axiom,
    ! [VarCurr: state_type] :
      ( v127944(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1490,axiom,
    ! [VarCurr: state_type] :
      ( v127943(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1489,axiom,
    ! [VarCurr: state_type] :
      ( v127942(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1488,axiom,
    ! [VarCurr: state_type] :
      ( v127941(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1487,axiom,
    ! [VarCurr: state_type] :
      ( v127940(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $false )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1486,axiom,
    ! [VarCurr: state_type] :
      ( v127939(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1485,axiom,
    ! [VarCurr: state_type] :
      ( v127938(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1484,axiom,
    ! [VarCurr: state_type] :
      ( v127937(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1483,axiom,
    ! [VarCurr: state_type] :
      ( v127936(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $false )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1482,axiom,
    ! [VarCurr: state_type] :
      ( v127935(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1481,axiom,
    ! [VarCurr: state_type] :
      ( v127934(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $false )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1480,axiom,
    ! [VarCurr: state_type] :
      ( v127933(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1479,axiom,
    ! [VarCurr: state_type] :
      ( v127932(VarCurr)
    <=> ( ( v127926(VarCurr,3)
        <=> $true )
        & ( v127926(VarCurr,2)
        <=> $true )
        & ( v127926(VarCurr,1)
        <=> $true )
        & ( v127926(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127926(VarCurr,B)
      <=> v109242(VarCurr,B) ) ) ).

tff(addAssignment_72108,axiom,
    ! [VarCurr: state_type] :
      ( v127926(VarCurr,3)
    <=> v127928(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127928(VarCurr)
      <=> v127930(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1239,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127928(VarCurr)
      <=> v127929(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127930(VarCurr)
      <=> v109242(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_136,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127930(VarCurr)
      <=> v109242(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127929(VarCurr)
      <=> v109242(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_135,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127929(VarCurr)
      <=> v109242(VarCurr,6) ) ) ).

tff(addAssignment_72107,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,0)
    <=> v127922(VarCurr) ) ).

tff(addAssignment_72106,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,1)
    <=> v127921(VarCurr) ) ).

tff(addAssignment_72105,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,2)
    <=> v127920(VarCurr) ) ).

tff(addAssignment_72104,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,3)
    <=> v127919(VarCurr) ) ).

tff(addAssignment_72103,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,4)
    <=> v127918(VarCurr) ) ).

tff(addAssignment_72102,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,5)
    <=> v127917(VarCurr) ) ).

tff(addAssignment_72101,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,6)
    <=> v127916(VarCurr) ) ).

tff(addAssignment_72100,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,7)
    <=> v127915(VarCurr) ) ).

tff(addAssignment_72099,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,8)
    <=> v127914(VarCurr) ) ).

tff(addAssignment_72098,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,9)
    <=> v127913(VarCurr) ) ).

tff(addAssignment_72097,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,10)
    <=> v127912(VarCurr) ) ).

tff(addAssignment_72096,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,11)
    <=> v127911(VarCurr) ) ).

tff(addAssignment_72095,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,12)
    <=> v127910(VarCurr) ) ).

tff(addAssignment_72094,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,13)
    <=> v127909(VarCurr) ) ).

tff(addAssignment_72093,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,14)
    <=> v127908(VarCurr) ) ).

tff(addAssignment_72092,axiom,
    ! [VarCurr: state_type] :
      ( v127899(VarCurr,15)
    <=> v127907(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1478,axiom,
    ! [VarCurr: state_type] :
      ( v127922(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1477,axiom,
    ! [VarCurr: state_type] :
      ( v127921(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1476,axiom,
    ! [VarCurr: state_type] :
      ( v127920(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1475,axiom,
    ! [VarCurr: state_type] :
      ( v127919(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1474,axiom,
    ! [VarCurr: state_type] :
      ( v127918(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1473,axiom,
    ! [VarCurr: state_type] :
      ( v127917(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1472,axiom,
    ! [VarCurr: state_type] :
      ( v127916(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1471,axiom,
    ! [VarCurr: state_type] :
      ( v127915(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $false )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1470,axiom,
    ! [VarCurr: state_type] :
      ( v127914(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1469,axiom,
    ! [VarCurr: state_type] :
      ( v127913(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1468,axiom,
    ! [VarCurr: state_type] :
      ( v127912(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1467,axiom,
    ! [VarCurr: state_type] :
      ( v127911(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $false )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1466,axiom,
    ! [VarCurr: state_type] :
      ( v127910(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1465,axiom,
    ! [VarCurr: state_type] :
      ( v127909(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $false )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1464,axiom,
    ! [VarCurr: state_type] :
      ( v127908(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1463,axiom,
    ! [VarCurr: state_type] :
      ( v127907(VarCurr)
    <=> ( ( v127901(VarCurr,3)
        <=> $true )
        & ( v127901(VarCurr,2)
        <=> $true )
        & ( v127901(VarCurr,1)
        <=> $true )
        & ( v127901(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127901(VarCurr,B)
      <=> v109303(VarCurr,B) ) ) ).

tff(addAssignment_72090,axiom,
    ! [VarCurr: state_type] :
      ( v127901(VarCurr,3)
    <=> v127903(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127903(VarCurr)
      <=> v127905(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1238,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127903(VarCurr)
      <=> v127904(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127905(VarCurr)
      <=> v109303(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_134,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127905(VarCurr)
      <=> v109303(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127904(VarCurr)
      <=> v109303(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_133,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127904(VarCurr)
      <=> v109303(VarCurr,6) ) ) ).

tff(addAssignment_72089,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,0)
    <=> v127897(VarCurr) ) ).

tff(addAssignment_72088,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,1)
    <=> v127896(VarCurr) ) ).

tff(addAssignment_72087,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,2)
    <=> v127895(VarCurr) ) ).

tff(addAssignment_72086,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,3)
    <=> v127894(VarCurr) ) ).

tff(addAssignment_72085,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,4)
    <=> v127893(VarCurr) ) ).

tff(addAssignment_72084,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,5)
    <=> v127892(VarCurr) ) ).

tff(addAssignment_72083,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,6)
    <=> v127891(VarCurr) ) ).

tff(addAssignment_72082,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,7)
    <=> v127890(VarCurr) ) ).

tff(addAssignment_72081,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,8)
    <=> v127889(VarCurr) ) ).

tff(addAssignment_72080,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,9)
    <=> v127888(VarCurr) ) ).

tff(addAssignment_72079,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,10)
    <=> v127887(VarCurr) ) ).

tff(addAssignment_72078,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,11)
    <=> v127886(VarCurr) ) ).

tff(addAssignment_72077,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,12)
    <=> v127885(VarCurr) ) ).

tff(addAssignment_72076,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,13)
    <=> v127884(VarCurr) ) ).

tff(addAssignment_72075,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,14)
    <=> v127883(VarCurr) ) ).

tff(addAssignment_72074,axiom,
    ! [VarCurr: state_type] :
      ( v127874(VarCurr,15)
    <=> v127882(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1462,axiom,
    ! [VarCurr: state_type] :
      ( v127897(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1461,axiom,
    ! [VarCurr: state_type] :
      ( v127896(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1460,axiom,
    ! [VarCurr: state_type] :
      ( v127895(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1459,axiom,
    ! [VarCurr: state_type] :
      ( v127894(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1458,axiom,
    ! [VarCurr: state_type] :
      ( v127893(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1457,axiom,
    ! [VarCurr: state_type] :
      ( v127892(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1456,axiom,
    ! [VarCurr: state_type] :
      ( v127891(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1455,axiom,
    ! [VarCurr: state_type] :
      ( v127890(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $false )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1454,axiom,
    ! [VarCurr: state_type] :
      ( v127889(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1453,axiom,
    ! [VarCurr: state_type] :
      ( v127888(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1452,axiom,
    ! [VarCurr: state_type] :
      ( v127887(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1451,axiom,
    ! [VarCurr: state_type] :
      ( v127886(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $false )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1450,axiom,
    ! [VarCurr: state_type] :
      ( v127885(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1449,axiom,
    ! [VarCurr: state_type] :
      ( v127884(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $false )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1448,axiom,
    ! [VarCurr: state_type] :
      ( v127883(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1447,axiom,
    ! [VarCurr: state_type] :
      ( v127882(VarCurr)
    <=> ( ( v127876(VarCurr,3)
        <=> $true )
        & ( v127876(VarCurr,2)
        <=> $true )
        & ( v127876(VarCurr,1)
        <=> $true )
        & ( v127876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127876(VarCurr,B)
      <=> v109364(VarCurr,B) ) ) ).

tff(addAssignment_72072,axiom,
    ! [VarCurr: state_type] :
      ( v127876(VarCurr,3)
    <=> v127878(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127878(VarCurr)
      <=> v127880(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1237,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127878(VarCurr)
      <=> v127879(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127880(VarCurr)
      <=> v109364(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_132,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127880(VarCurr)
      <=> v109364(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127879(VarCurr)
      <=> v109364(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_131,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127879(VarCurr)
      <=> v109364(VarCurr,6) ) ) ).

tff(addAssignment_72071,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,0)
    <=> v127872(VarCurr) ) ).

tff(addAssignment_72070,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,1)
    <=> v127871(VarCurr) ) ).

tff(addAssignment_72069,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,2)
    <=> v127870(VarCurr) ) ).

tff(addAssignment_72068,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,3)
    <=> v127869(VarCurr) ) ).

tff(addAssignment_72067,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,4)
    <=> v127868(VarCurr) ) ).

tff(addAssignment_72066,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,5)
    <=> v127867(VarCurr) ) ).

tff(addAssignment_72065,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,6)
    <=> v127866(VarCurr) ) ).

tff(addAssignment_72064,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,7)
    <=> v127865(VarCurr) ) ).

tff(addAssignment_72063,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,8)
    <=> v127864(VarCurr) ) ).

tff(addAssignment_72062,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,9)
    <=> v127863(VarCurr) ) ).

tff(addAssignment_72061,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,10)
    <=> v127862(VarCurr) ) ).

tff(addAssignment_72060,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,11)
    <=> v127861(VarCurr) ) ).

tff(addAssignment_72059,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,12)
    <=> v127860(VarCurr) ) ).

tff(addAssignment_72058,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,13)
    <=> v127859(VarCurr) ) ).

tff(addAssignment_72057,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,14)
    <=> v127858(VarCurr) ) ).

tff(addAssignment_72056,axiom,
    ! [VarCurr: state_type] :
      ( v127849(VarCurr,15)
    <=> v127857(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1446,axiom,
    ! [VarCurr: state_type] :
      ( v127872(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1445,axiom,
    ! [VarCurr: state_type] :
      ( v127871(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1444,axiom,
    ! [VarCurr: state_type] :
      ( v127870(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1443,axiom,
    ! [VarCurr: state_type] :
      ( v127869(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1442,axiom,
    ! [VarCurr: state_type] :
      ( v127868(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1441,axiom,
    ! [VarCurr: state_type] :
      ( v127867(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1440,axiom,
    ! [VarCurr: state_type] :
      ( v127866(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1439,axiom,
    ! [VarCurr: state_type] :
      ( v127865(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $false )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1438,axiom,
    ! [VarCurr: state_type] :
      ( v127864(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1437,axiom,
    ! [VarCurr: state_type] :
      ( v127863(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1436,axiom,
    ! [VarCurr: state_type] :
      ( v127862(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1435,axiom,
    ! [VarCurr: state_type] :
      ( v127861(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $false )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1434,axiom,
    ! [VarCurr: state_type] :
      ( v127860(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1433,axiom,
    ! [VarCurr: state_type] :
      ( v127859(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $false )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1432,axiom,
    ! [VarCurr: state_type] :
      ( v127858(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1431,axiom,
    ! [VarCurr: state_type] :
      ( v127857(VarCurr)
    <=> ( ( v127851(VarCurr,3)
        <=> $true )
        & ( v127851(VarCurr,2)
        <=> $true )
        & ( v127851(VarCurr,1)
        <=> $true )
        & ( v127851(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127851(VarCurr,B)
      <=> v109425(VarCurr,B) ) ) ).

tff(addAssignment_72054,axiom,
    ! [VarCurr: state_type] :
      ( v127851(VarCurr,3)
    <=> v127853(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127853(VarCurr)
      <=> v127855(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1236,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127853(VarCurr)
      <=> v127854(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127855(VarCurr)
      <=> v109425(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_130,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127855(VarCurr)
      <=> v109425(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127854(VarCurr)
      <=> v109425(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_129,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127854(VarCurr)
      <=> v109425(VarCurr,6) ) ) ).

tff(addAssignment_72053,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,0)
    <=> v127847(VarCurr) ) ).

tff(addAssignment_72052,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,1)
    <=> v127846(VarCurr) ) ).

tff(addAssignment_72051,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,2)
    <=> v127845(VarCurr) ) ).

tff(addAssignment_72050,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,3)
    <=> v127844(VarCurr) ) ).

tff(addAssignment_72049,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,4)
    <=> v127843(VarCurr) ) ).

tff(addAssignment_72048,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,5)
    <=> v127842(VarCurr) ) ).

tff(addAssignment_72047,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,6)
    <=> v127841(VarCurr) ) ).

tff(addAssignment_72046,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,7)
    <=> v127840(VarCurr) ) ).

tff(addAssignment_72045,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,8)
    <=> v127839(VarCurr) ) ).

tff(addAssignment_72044,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,9)
    <=> v127838(VarCurr) ) ).

tff(addAssignment_72043,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,10)
    <=> v127837(VarCurr) ) ).

tff(addAssignment_72042,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,11)
    <=> v127836(VarCurr) ) ).

tff(addAssignment_72041,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,12)
    <=> v127835(VarCurr) ) ).

tff(addAssignment_72040,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,13)
    <=> v127834(VarCurr) ) ).

tff(addAssignment_72039,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,14)
    <=> v127833(VarCurr) ) ).

tff(addAssignment_72038,axiom,
    ! [VarCurr: state_type] :
      ( v127712(VarCurr,15)
    <=> v127832(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1430,axiom,
    ! [VarCurr: state_type] :
      ( v127847(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1429,axiom,
    ! [VarCurr: state_type] :
      ( v127846(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1428,axiom,
    ! [VarCurr: state_type] :
      ( v127845(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1427,axiom,
    ! [VarCurr: state_type] :
      ( v127844(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1426,axiom,
    ! [VarCurr: state_type] :
      ( v127843(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1425,axiom,
    ! [VarCurr: state_type] :
      ( v127842(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1424,axiom,
    ! [VarCurr: state_type] :
      ( v127841(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1423,axiom,
    ! [VarCurr: state_type] :
      ( v127840(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $false )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1422,axiom,
    ! [VarCurr: state_type] :
      ( v127839(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1421,axiom,
    ! [VarCurr: state_type] :
      ( v127838(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1420,axiom,
    ! [VarCurr: state_type] :
      ( v127837(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1419,axiom,
    ! [VarCurr: state_type] :
      ( v127836(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $false )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1418,axiom,
    ! [VarCurr: state_type] :
      ( v127835(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1417,axiom,
    ! [VarCurr: state_type] :
      ( v127834(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $false )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1416,axiom,
    ! [VarCurr: state_type] :
      ( v127833(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1415,axiom,
    ! [VarCurr: state_type] :
      ( v127832(VarCurr)
    <=> ( ( v127714(VarCurr,3)
        <=> $true )
        & ( v127714(VarCurr,2)
        <=> $true )
        & ( v127714(VarCurr,1)
        <=> $true )
        & ( v127714(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_72037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127714(VarCurr,B)
      <=> v109486(VarCurr,B) ) ) ).

tff(addAssignment_72036,axiom,
    ! [VarCurr: state_type] :
      ( v127714(VarCurr,3)
    <=> v127828(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v127828(VarCurr)
      <=> v127830(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1235,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v127828(VarCurr)
      <=> v127829(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_99,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127830(VarCurr)
      <=> v109486(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_128,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127830(VarCurr)
      <=> v109486(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_98,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v127829(VarCurr)
      <=> v109486(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_127,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v127829(VarCurr)
      <=> v109486(VarCurr,6) ) ) ).

tff(addAssignment_72035,axiom,
    ! [VarCurr: state_type] :
      ( v109486(VarCurr,4)
    <=> v109488(VarCurr,4) ) ).

tff(addAssignment_72034,axiom,
    ! [VarCurr: state_type] :
      ( v109488(VarCurr,4)
    <=> v109490(VarCurr,4) ) ).

tff(addAssignment_72033,axiom,
    ! [VarNext: state_type] :
      ( v109490(VarNext,4)
    <=> v127820(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127821(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127820(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1667,axiom,
    ! [VarNext: state_type] :
      ( v127821(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127820(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127821(VarNext)
      <=> v127822(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127822(VarNext)
      <=> ( v127824(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_9216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127824(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_72032,axiom,
    ! [VarCurr: state_type] :
      ( v109500(VarCurr,4)
    <=> v109502(VarCurr,4) ) ).

tff(addAssignment_72031,axiom,
    ! [VarCurr: state_type] :
      ( v109502(VarCurr,4)
    <=> v109515(VarCurr,4) ) ).

tff(addAssignment_72030,axiom,
    ! [VarCurr: state_type] :
      ( v109504(VarCurr,4)
    <=> v109506(VarCurr,4) ) ).

tff(addAssignment_72029,axiom,
    ! [VarCurr: state_type] :
      ( v109506(VarCurr,4)
    <=> v109507(VarCurr,4) ) ).

tff(addAssignment_72028,axiom,
    ! [VarCurr: state_type] :
      ( v109425(VarCurr,4)
    <=> v109427(VarCurr,4) ) ).

tff(addAssignment_72027,axiom,
    ! [VarCurr: state_type] :
      ( v109427(VarCurr,4)
    <=> v109429(VarCurr,4) ) ).

tff(addAssignment_72026,axiom,
    ! [VarNext: state_type] :
      ( v109429(VarNext,4)
    <=> v127812(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127813(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127812(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1666,axiom,
    ! [VarNext: state_type] :
      ( v127813(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127812(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127813(VarNext)
      <=> v127814(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127814(VarNext)
      <=> ( v127816(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127816(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_72025,axiom,
    ! [VarCurr: state_type] :
      ( v109439(VarCurr,4)
    <=> v109441(VarCurr,4) ) ).

tff(addAssignment_72024,axiom,
    ! [VarCurr: state_type] :
      ( v109441(VarCurr,4)
    <=> v109455(VarCurr,4) ) ).

tff(addAssignment_72023,axiom,
    ! [VarCurr: state_type] :
      ( v109443(VarCurr,4)
    <=> v109445(VarCurr,4) ) ).

tff(addAssignment_72022,axiom,
    ! [VarCurr: state_type] :
      ( v109445(VarCurr,4)
    <=> v109446(VarCurr,4) ) ).

tff(addAssignment_72021,axiom,
    ! [VarCurr: state_type] :
      ( v109364(VarCurr,4)
    <=> v109366(VarCurr,4) ) ).

tff(addAssignment_72020,axiom,
    ! [VarCurr: state_type] :
      ( v109366(VarCurr,4)
    <=> v109368(VarCurr,4) ) ).

tff(addAssignment_72019,axiom,
    ! [VarNext: state_type] :
      ( v109368(VarNext,4)
    <=> v127804(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127805(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127804(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1665,axiom,
    ! [VarNext: state_type] :
      ( v127805(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127804(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127805(VarNext)
      <=> v127806(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127806(VarNext)
      <=> ( v127808(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_9214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127808(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_72018,axiom,
    ! [VarCurr: state_type] :
      ( v109378(VarCurr,4)
    <=> v109380(VarCurr,4) ) ).

tff(addAssignment_72017,axiom,
    ! [VarCurr: state_type] :
      ( v109380(VarCurr,4)
    <=> v109394(VarCurr,4) ) ).

tff(addAssignment_72016,axiom,
    ! [VarCurr: state_type] :
      ( v109382(VarCurr,4)
    <=> v109384(VarCurr,4) ) ).

tff(addAssignment_72015,axiom,
    ! [VarCurr: state_type] :
      ( v109384(VarCurr,4)
    <=> v109385(VarCurr,4) ) ).

tff(addAssignment_72014,axiom,
    ! [VarCurr: state_type] :
      ( v109303(VarCurr,4)
    <=> v109305(VarCurr,4) ) ).

tff(addAssignment_72013,axiom,
    ! [VarCurr: state_type] :
      ( v109305(VarCurr,4)
    <=> v109307(VarCurr,4) ) ).

tff(addAssignment_72012,axiom,
    ! [VarNext: state_type] :
      ( v109307(VarNext,4)
    <=> v127796(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127797(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127796(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1664,axiom,
    ! [VarNext: state_type] :
      ( v127797(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127796(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127797(VarNext)
      <=> v127798(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127798(VarNext)
      <=> ( v127800(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_9213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127800(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_72011,axiom,
    ! [VarCurr: state_type] :
      ( v109317(VarCurr,4)
    <=> v109319(VarCurr,4) ) ).

tff(addAssignment_72010,axiom,
    ! [VarCurr: state_type] :
      ( v109319(VarCurr,4)
    <=> v109333(VarCurr,4) ) ).

tff(addAssignment_72009,axiom,
    ! [VarCurr: state_type] :
      ( v109321(VarCurr,4)
    <=> v109323(VarCurr,4) ) ).

tff(addAssignment_72008,axiom,
    ! [VarCurr: state_type] :
      ( v109323(VarCurr,4)
    <=> v109324(VarCurr,4) ) ).

tff(addAssignment_72007,axiom,
    ! [VarCurr: state_type] :
      ( v109242(VarCurr,4)
    <=> v109244(VarCurr,4) ) ).

tff(addAssignment_72006,axiom,
    ! [VarCurr: state_type] :
      ( v109244(VarCurr,4)
    <=> v109246(VarCurr,4) ) ).

tff(addAssignment_72005,axiom,
    ! [VarNext: state_type] :
      ( v109246(VarNext,4)
    <=> v127788(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127789(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127788(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1663,axiom,
    ! [VarNext: state_type] :
      ( v127789(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127788(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127789(VarNext)
      <=> v127790(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127790(VarNext)
      <=> ( v127792(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_9212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127792(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_72004,axiom,
    ! [VarCurr: state_type] :
      ( v109256(VarCurr,4)
    <=> v109258(VarCurr,4) ) ).

tff(addAssignment_72003,axiom,
    ! [VarCurr: state_type] :
      ( v109258(VarCurr,4)
    <=> v109272(VarCurr,4) ) ).

tff(addAssignment_72002,axiom,
    ! [VarCurr: state_type] :
      ( v109260(VarCurr,4)
    <=> v109262(VarCurr,4) ) ).

tff(addAssignment_72001,axiom,
    ! [VarCurr: state_type] :
      ( v109262(VarCurr,4)
    <=> v109263(VarCurr,4) ) ).

tff(addAssignment_72000,axiom,
    ! [VarCurr: state_type] :
      ( v109181(VarCurr,4)
    <=> v109183(VarCurr,4) ) ).

tff(addAssignment_71999,axiom,
    ! [VarCurr: state_type] :
      ( v109183(VarCurr,4)
    <=> v109185(VarCurr,4) ) ).

tff(addAssignment_71998,axiom,
    ! [VarNext: state_type] :
      ( v109185(VarNext,4)
    <=> v127780(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127781(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127780(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1662,axiom,
    ! [VarNext: state_type] :
      ( v127781(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127780(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127781(VarNext)
      <=> v127782(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127782(VarNext)
      <=> ( v127784(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_9211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127784(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_71997,axiom,
    ! [VarCurr: state_type] :
      ( v109195(VarCurr,4)
    <=> v109197(VarCurr,4) ) ).

tff(addAssignment_71996,axiom,
    ! [VarCurr: state_type] :
      ( v109197(VarCurr,4)
    <=> v109211(VarCurr,4) ) ).

tff(addAssignment_71995,axiom,
    ! [VarCurr: state_type] :
      ( v109199(VarCurr,4)
    <=> v109201(VarCurr,4) ) ).

tff(addAssignment_71994,axiom,
    ! [VarCurr: state_type] :
      ( v109201(VarCurr,4)
    <=> v109202(VarCurr,4) ) ).

tff(addAssignment_71993,axiom,
    ! [VarCurr: state_type] :
      ( v109114(VarCurr,4)
    <=> v109116(VarCurr,4) ) ).

tff(addAssignment_71992,axiom,
    ! [VarCurr: state_type] :
      ( v109116(VarCurr,4)
    <=> v109118(VarCurr,4) ) ).

tff(addAssignment_71991,axiom,
    ! [VarNext: state_type] :
      ( v109118(VarNext,4)
    <=> v127772(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127773(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127772(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1661,axiom,
    ! [VarNext: state_type] :
      ( v127773(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127772(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127773(VarNext)
      <=> v127774(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127774(VarNext)
      <=> ( v127776(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_9210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127776(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_71990,axiom,
    ! [VarCurr: state_type] :
      ( v109128(VarCurr,4)
    <=> v109130(VarCurr,4) ) ).

tff(addAssignment_71989,axiom,
    ! [VarCurr: state_type] :
      ( v109130(VarCurr,4)
    <=> v109150(VarCurr,4) ) ).

tff(addAssignment_71988,axiom,
    ! [VarCurr: state_type] :
      ( v109132(VarCurr,4)
    <=> v109134(VarCurr,4) ) ).

tff(addAssignment_71987,axiom,
    ! [VarCurr: state_type] :
      ( v109134(VarCurr,4)
    <=> v109135(VarCurr,4) ) ).

tff(addAssignment_71986,axiom,
    ! [VarCurr: state_type] :
      ( v109486(VarCurr,3)
    <=> v109488(VarCurr,3) ) ).

tff(addAssignment_71985,axiom,
    ! [VarCurr: state_type] :
      ( v109488(VarCurr,3)
    <=> v109490(VarCurr,3) ) ).

tff(addAssignment_71984,axiom,
    ! [VarNext: state_type] :
      ( v109490(VarNext,3)
    <=> v127764(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127765(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127764(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1660,axiom,
    ! [VarNext: state_type] :
      ( v127765(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127764(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127765(VarNext)
      <=> v127766(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127766(VarNext)
      <=> ( v127768(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_9209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127768(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_71983,axiom,
    ! [VarCurr: state_type] :
      ( v109500(VarCurr,3)
    <=> v109502(VarCurr,3) ) ).

tff(addAssignment_71982,axiom,
    ! [VarCurr: state_type] :
      ( v109502(VarCurr,3)
    <=> v109515(VarCurr,3) ) ).

tff(addAssignment_71981,axiom,
    ! [VarCurr: state_type] :
      ( v109504(VarCurr,3)
    <=> v109506(VarCurr,3) ) ).

tff(addAssignment_71980,axiom,
    ! [VarCurr: state_type] :
      ( v109506(VarCurr,3)
    <=> v109507(VarCurr,3) ) ).

tff(addAssignment_71979,axiom,
    ! [VarCurr: state_type] :
      ( v109425(VarCurr,3)
    <=> v109427(VarCurr,3) ) ).

tff(addAssignment_71978,axiom,
    ! [VarCurr: state_type] :
      ( v109427(VarCurr,3)
    <=> v109429(VarCurr,3) ) ).

tff(addAssignment_71977,axiom,
    ! [VarNext: state_type] :
      ( v109429(VarNext,3)
    <=> v127756(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127757(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127756(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1659,axiom,
    ! [VarNext: state_type] :
      ( v127757(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127756(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127757(VarNext)
      <=> v127758(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127758(VarNext)
      <=> ( v127760(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_9208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127760(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_71976,axiom,
    ! [VarCurr: state_type] :
      ( v109439(VarCurr,3)
    <=> v109441(VarCurr,3) ) ).

tff(addAssignment_71975,axiom,
    ! [VarCurr: state_type] :
      ( v109441(VarCurr,3)
    <=> v109455(VarCurr,3) ) ).

tff(addAssignment_71974,axiom,
    ! [VarCurr: state_type] :
      ( v109443(VarCurr,3)
    <=> v109445(VarCurr,3) ) ).

tff(addAssignment_71973,axiom,
    ! [VarCurr: state_type] :
      ( v109445(VarCurr,3)
    <=> v109446(VarCurr,3) ) ).

tff(addAssignment_71972,axiom,
    ! [VarCurr: state_type] :
      ( v109364(VarCurr,3)
    <=> v109366(VarCurr,3) ) ).

tff(addAssignment_71971,axiom,
    ! [VarCurr: state_type] :
      ( v109366(VarCurr,3)
    <=> v109368(VarCurr,3) ) ).

tff(addAssignment_71970,axiom,
    ! [VarNext: state_type] :
      ( v109368(VarNext,3)
    <=> v127748(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127749(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127748(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1658,axiom,
    ! [VarNext: state_type] :
      ( v127749(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127748(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127749(VarNext)
      <=> v127750(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127750(VarNext)
      <=> ( v127752(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_9207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127752(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_71969,axiom,
    ! [VarCurr: state_type] :
      ( v109378(VarCurr,3)
    <=> v109380(VarCurr,3) ) ).

tff(addAssignment_71968,axiom,
    ! [VarCurr: state_type] :
      ( v109380(VarCurr,3)
    <=> v109394(VarCurr,3) ) ).

tff(addAssignment_71967,axiom,
    ! [VarCurr: state_type] :
      ( v109382(VarCurr,3)
    <=> v109384(VarCurr,3) ) ).

tff(addAssignment_71966,axiom,
    ! [VarCurr: state_type] :
      ( v109384(VarCurr,3)
    <=> v109385(VarCurr,3) ) ).

tff(addAssignment_71965,axiom,
    ! [VarCurr: state_type] :
      ( v109303(VarCurr,3)
    <=> v109305(VarCurr,3) ) ).

tff(addAssignment_71964,axiom,
    ! [VarCurr: state_type] :
      ( v109305(VarCurr,3)
    <=> v109307(VarCurr,3) ) ).

tff(addAssignment_71963,axiom,
    ! [VarNext: state_type] :
      ( v109307(VarNext,3)
    <=> v127740(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127741(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127740(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1657,axiom,
    ! [VarNext: state_type] :
      ( v127741(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127740(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127741(VarNext)
      <=> v127742(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127742(VarNext)
      <=> ( v127744(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_9206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127744(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_71962,axiom,
    ! [VarCurr: state_type] :
      ( v109317(VarCurr,3)
    <=> v109319(VarCurr,3) ) ).

tff(addAssignment_71961,axiom,
    ! [VarCurr: state_type] :
      ( v109319(VarCurr,3)
    <=> v109333(VarCurr,3) ) ).

tff(addAssignment_71960,axiom,
    ! [VarCurr: state_type] :
      ( v109321(VarCurr,3)
    <=> v109323(VarCurr,3) ) ).

tff(addAssignment_71959,axiom,
    ! [VarCurr: state_type] :
      ( v109323(VarCurr,3)
    <=> v109324(VarCurr,3) ) ).

tff(addAssignment_71958,axiom,
    ! [VarCurr: state_type] :
      ( v109242(VarCurr,3)
    <=> v109244(VarCurr,3) ) ).

tff(addAssignment_71957,axiom,
    ! [VarCurr: state_type] :
      ( v109244(VarCurr,3)
    <=> v109246(VarCurr,3) ) ).

tff(addAssignment_71956,axiom,
    ! [VarNext: state_type] :
      ( v109246(VarNext,3)
    <=> v127732(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127733(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127732(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1656,axiom,
    ! [VarNext: state_type] :
      ( v127733(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127732(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127733(VarNext)
      <=> v127734(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127734(VarNext)
      <=> ( v127736(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_9205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127736(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_71955,axiom,
    ! [VarCurr: state_type] :
      ( v109256(VarCurr,3)
    <=> v109258(VarCurr,3) ) ).

tff(addAssignment_71954,axiom,
    ! [VarCurr: state_type] :
      ( v109258(VarCurr,3)
    <=> v109272(VarCurr,3) ) ).

tff(addAssignment_71953,axiom,
    ! [VarCurr: state_type] :
      ( v109260(VarCurr,3)
    <=> v109262(VarCurr,3) ) ).

tff(addAssignment_71952,axiom,
    ! [VarCurr: state_type] :
      ( v109262(VarCurr,3)
    <=> v109263(VarCurr,3) ) ).

tff(addAssignment_71951,axiom,
    ! [VarCurr: state_type] :
      ( v109181(VarCurr,3)
    <=> v109183(VarCurr,3) ) ).

tff(addAssignment_71950,axiom,
    ! [VarCurr: state_type] :
      ( v109183(VarCurr,3)
    <=> v109185(VarCurr,3) ) ).

tff(addAssignment_71949,axiom,
    ! [VarNext: state_type] :
      ( v109185(VarNext,3)
    <=> v127724(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127725(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127724(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1655,axiom,
    ! [VarNext: state_type] :
      ( v127725(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127724(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127725(VarNext)
      <=> v127726(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127726(VarNext)
      <=> ( v127728(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_9204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127728(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_71948,axiom,
    ! [VarCurr: state_type] :
      ( v109195(VarCurr,3)
    <=> v109197(VarCurr,3) ) ).

tff(addAssignment_71947,axiom,
    ! [VarCurr: state_type] :
      ( v109197(VarCurr,3)
    <=> v109211(VarCurr,3) ) ).

tff(addAssignment_71946,axiom,
    ! [VarCurr: state_type] :
      ( v109199(VarCurr,3)
    <=> v109201(VarCurr,3) ) ).

tff(addAssignment_71945,axiom,
    ! [VarCurr: state_type] :
      ( v109201(VarCurr,3)
    <=> v109202(VarCurr,3) ) ).

tff(addAssignment_71944,axiom,
    ! [VarCurr: state_type] :
      ( v109114(VarCurr,3)
    <=> v109116(VarCurr,3) ) ).

tff(addAssignment_71943,axiom,
    ! [VarCurr: state_type] :
      ( v109116(VarCurr,3)
    <=> v109118(VarCurr,3) ) ).

tff(addAssignment_71942,axiom,
    ! [VarNext: state_type] :
      ( v109118(VarNext,3)
    <=> v127716(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127717(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v127716(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1654,axiom,
    ! [VarNext: state_type] :
      ( v127717(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v127716(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127717(VarNext)
      <=> v127718(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127718(VarNext)
      <=> ( v127720(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_9203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127720(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_71941,axiom,
    ! [VarCurr: state_type] :
      ( v109128(VarCurr,3)
    <=> v109130(VarCurr,3) ) ).

tff(addAssignment_71940,axiom,
    ! [VarCurr: state_type] :
      ( v109130(VarCurr,3)
    <=> v109150(VarCurr,3) ) ).

tff(addAssignment_71939,axiom,
    ! [VarCurr: state_type] :
      ( v109132(VarCurr,3)
    <=> v109134(VarCurr,3) ) ).

tff(addAssignment_71938,axiom,
    ! [VarCurr: state_type] :
      ( v109134(VarCurr,3)
    <=> v109135(VarCurr,3) ) ).

tff(addAssignment_71937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127414(VarCurr,B)
      <=> v127416(VarCurr,B) ) ) ).

tff(addAssignment_71936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127416(VarCurr,B)
      <=> v127418(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127418(VarCurr,B)
      <=> ( v127672(VarCurr,B)
          & v127703(VarCurr,B) ) ) ) ).

tff(addAssignment_71935,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,0)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71934,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,1)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71933,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,2)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71932,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,3)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71931,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,4)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71930,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,5)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71929,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,6)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71928,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,7)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71927,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,8)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71926,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,9)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71925,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,10)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71924,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,11)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71923,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,12)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71922,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,13)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71921,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,14)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71920,axiom,
    ! [VarCurr: state_type] :
      ( v127703(VarCurr,15)
    <=> v127704(VarCurr) ) ).

tff(addAssignment_71919,axiom,
    ! [VarCurr: state_type] :
      ( v127704(VarCurr)
    <=> v127620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127672(VarCurr,B)
      <=> ( v127673(VarCurr,B)
          | v127700(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127700(VarCurr,B)
      <=> ( v127595(VarCurr,B)
          & v127701(VarCurr,B) ) ) ) ).

tff(addAssignment_71918,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,0)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71917,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,1)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71916,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,2)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71915,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,3)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71914,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,4)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71913,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,5)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71912,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,6)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71911,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,7)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71910,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,8)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71909,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,9)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71908,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,10)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71907,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,11)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71906,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,12)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71905,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,13)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71904,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,14)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71903,axiom,
    ! [VarCurr: state_type] :
      ( v127701(VarCurr,15)
    <=> v127702(VarCurr) ) ).

tff(addAssignment_71902,axiom,
    ! [VarCurr: state_type] :
      ( v127702(VarCurr)
    <=> v84915(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127673(VarCurr,B)
      <=> ( v127674(VarCurr,B)
          | v127697(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127697(VarCurr,B)
      <=> ( v127570(VarCurr,B)
          & v127698(VarCurr,B) ) ) ) ).

tff(addAssignment_71901,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,0)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71900,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,1)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71899,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,2)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71898,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,3)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71897,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,4)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71896,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,5)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71895,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,6)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71894,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,7)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71893,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,8)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71892,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,9)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71891,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,10)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71890,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,11)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71889,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,12)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71888,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,13)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71887,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,14)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71886,axiom,
    ! [VarCurr: state_type] :
      ( v127698(VarCurr,15)
    <=> v127699(VarCurr) ) ).

tff(addAssignment_71885,axiom,
    ! [VarCurr: state_type] :
      ( v127699(VarCurr)
    <=> v84915(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127674(VarCurr,B)
      <=> ( v127675(VarCurr,B)
          | v127694(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127694(VarCurr,B)
      <=> ( v127545(VarCurr,B)
          & v127695(VarCurr,B) ) ) ) ).

tff(addAssignment_71884,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,0)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71883,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,1)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71882,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,2)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71881,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,3)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71880,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,4)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71879,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,5)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71878,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,6)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71877,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,7)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71876,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,8)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71875,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,9)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71874,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,10)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71873,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,11)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71872,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,12)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71871,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,13)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71870,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,14)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71869,axiom,
    ! [VarCurr: state_type] :
      ( v127695(VarCurr,15)
    <=> v127696(VarCurr) ) ).

tff(addAssignment_71868,axiom,
    ! [VarCurr: state_type] :
      ( v127696(VarCurr)
    <=> v84915(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127675(VarCurr,B)
      <=> ( v127676(VarCurr,B)
          | v127691(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127691(VarCurr,B)
      <=> ( v127520(VarCurr,B)
          & v127692(VarCurr,B) ) ) ) ).

tff(addAssignment_71867,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,0)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71866,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,1)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71865,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,2)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71864,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,3)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71863,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,4)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71862,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,5)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71861,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,6)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71860,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,7)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71859,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,8)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71858,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,9)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71857,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,10)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71856,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,11)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71855,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,12)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71854,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,13)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71853,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,14)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71852,axiom,
    ! [VarCurr: state_type] :
      ( v127692(VarCurr,15)
    <=> v127693(VarCurr) ) ).

tff(addAssignment_71851,axiom,
    ! [VarCurr: state_type] :
      ( v127693(VarCurr)
    <=> v84915(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127676(VarCurr,B)
      <=> ( v127677(VarCurr,B)
          | v127688(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127688(VarCurr,B)
      <=> ( v127495(VarCurr,B)
          & v127689(VarCurr,B) ) ) ) ).

tff(addAssignment_71850,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,0)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71849,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,1)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71848,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,2)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71847,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,3)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71846,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,4)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71845,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,5)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71844,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,6)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71843,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,7)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71842,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,8)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71841,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,9)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71840,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,10)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71839,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,11)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71838,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,12)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71837,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,13)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71836,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,14)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71835,axiom,
    ! [VarCurr: state_type] :
      ( v127689(VarCurr,15)
    <=> v127690(VarCurr) ) ).

tff(addAssignment_71834,axiom,
    ! [VarCurr: state_type] :
      ( v127690(VarCurr)
    <=> v84915(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127677(VarCurr,B)
      <=> ( v127678(VarCurr,B)
          | v127685(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127685(VarCurr,B)
      <=> ( v127470(VarCurr,B)
          & v127686(VarCurr,B) ) ) ) ).

tff(addAssignment_71833,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,0)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71832,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,1)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71831,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,2)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71830,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,3)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71829,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,4)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71828,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,5)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71827,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,6)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71826,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,7)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71825,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,8)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71824,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,9)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71823,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,10)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71822,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,11)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71821,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,12)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71820,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,13)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71819,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,14)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71818,axiom,
    ! [VarCurr: state_type] :
      ( v127686(VarCurr,15)
    <=> v127687(VarCurr) ) ).

tff(addAssignment_71817,axiom,
    ! [VarCurr: state_type] :
      ( v127687(VarCurr)
    <=> v84915(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127678(VarCurr,B)
      <=> ( v127679(VarCurr,B)
          | v127682(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127682(VarCurr,B)
      <=> ( v127445(VarCurr,B)
          & v127683(VarCurr,B) ) ) ) ).

tff(addAssignment_71816,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,0)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71815,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,1)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71814,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,2)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71813,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,3)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71812,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,4)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71811,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,5)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71810,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,6)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71809,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,7)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71808,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,8)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71807,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,9)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71806,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,10)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71805,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,11)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71804,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,12)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71803,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,13)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71802,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,14)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71801,axiom,
    ! [VarCurr: state_type] :
      ( v127683(VarCurr,15)
    <=> v127684(VarCurr) ) ).

tff(addAssignment_71800,axiom,
    ! [VarCurr: state_type] :
      ( v127684(VarCurr)
    <=> v84915(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127679(VarCurr,B)
      <=> ( v127420(VarCurr,B)
          & v127680(VarCurr,B) ) ) ) ).

tff(addAssignment_71799,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,0)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71798,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,1)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71797,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,2)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71796,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,3)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71795,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,4)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71794,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,5)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71793,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,6)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71792,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,7)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71791,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,8)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71790,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,9)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71789,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,10)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71788,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,11)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71787,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,12)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71786,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,13)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71785,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,14)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71784,axiom,
    ! [VarCurr: state_type] :
      ( v127680(VarCurr,15)
    <=> v127681(VarCurr) ) ).

tff(addAssignment_71783,axiom,
    ! [VarCurr: state_type] :
      ( v127681(VarCurr)
    <=> v84915(VarCurr,0) ) ).

tff(addAssignment_71782,axiom,
    ! [VarCurr: state_type] :
      ( v127620(VarCurr)
    <=> v127622(VarCurr) ) ).

tff(addAssignment_71781,axiom,
    ! [VarCurr: state_type] :
      ( v127622(VarCurr)
    <=> v127624(VarCurr) ) ).

tff(addAssignment_71780,axiom,
    ! [VarCurr: state_type] :
      ( v127624(VarCurr)
    <=> v127626(VarCurr) ) ).

tff(addAssignment_71779,axiom,
    ! [VarCurr: state_type] :
      ( v127626(VarCurr)
    <=> v127628(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127655(VarNext)
       => ( v127628(VarNext)
        <=> v127628(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1653,axiom,
    ! [VarNext: state_type] :
      ( v127655(VarNext)
     => ( v127628(VarNext)
      <=> v127665(VarNext) ) ) ).

tff(addAssignment_71778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127665(VarNext)
      <=> v127663(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127666(VarCurr)
     => ( v127663(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1234,axiom,
    ! [VarCurr: state_type] :
      ( v127666(VarCurr)
     => ( v127663(VarCurr)
      <=> v127638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16470,axiom,
    ! [VarCurr: state_type] :
      ( v127666(VarCurr)
    <=> ( v127667(VarCurr)
        & v127668(VarCurr) ) ) ).

tff(writeUnaryOperator_9202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127668(VarCurr)
    <=> v127634(VarCurr) ) ).

tff(writeUnaryOperator_9201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127667(VarCurr)
    <=> v127630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127655(VarNext)
      <=> v127656(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127656(VarNext)
      <=> ( v127657(VarNext)
          & v127650(VarNext) ) ) ) ).

tff(writeUnaryOperator_9200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127657(VarNext)
      <=> v127659(VarNext) ) ) ).

tff(addAssignment_71777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127659(VarNext)
      <=> v127650(VarCurr) ) ) ).

tff(addAssignment_71776,axiom,
    ! [VarCurr: state_type] :
      ( v127650(VarCurr)
    <=> v127652(VarCurr) ) ).

tff(addAssignment_71775,axiom,
    ! [VarCurr: state_type] :
      ( v127652(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_71774,axiom,
    ! [VarCurr: state_type] :
      ( v127638(VarCurr)
    <=> v127640(VarCurr) ) ).

tff(addAssignment_71773,axiom,
    ! [VarCurr: state_type] :
      ( v127640(VarCurr)
    <=> v127642(VarCurr) ) ).

tff(addAssignment_71772,axiom,
    ! [VarCurr: state_type] :
      ( v127642(VarCurr)
    <=> v127644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16467,axiom,
    ! [VarCurr: state_type] :
      ( v127644(VarCurr)
    <=> ( v127646(VarCurr)
        | v127647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16466,axiom,
    ! [VarCurr: state_type] :
      ( v127647(VarCurr)
    <=> ( v127624(VarCurr)
        & v127648(VarCurr) ) ) ).

tff(writeUnaryOperator_9199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127648(VarCurr)
    <=> v84297(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_1414,axiom,
    ! [VarCurr: state_type] :
      ( v127646(VarCurr)
    <=> ( ( v84319(VarCurr,4)
        <=> $false )
        & ( v84319(VarCurr,3)
        <=> $false )
        & ( v84319(VarCurr,2)
        <=> $false )
        & ( v84319(VarCurr,1)
        <=> $false )
        & ( v84319(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71771,axiom,
    ! [VarCurr: state_type] :
      ( v84297(VarCurr,0)
    <=> v89072(VarCurr,0) ) ).

tff(addAssignment_71770,axiom,
    ! [VarCurr: state_type] :
      ( v127634(VarCurr)
    <=> v127636(VarCurr) ) ).

tff(addAssignment_71769,axiom,
    ! [VarCurr: state_type] :
      ( v127636(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_71768,axiom,
    ! [VarCurr: state_type] :
      ( v127630(VarCurr)
    <=> v127632(VarCurr) ) ).

tff(addAssignment_71767,axiom,
    ! [VarCurr: state_type] :
      ( v127632(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_71766,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,0)
    <=> v127618(VarCurr) ) ).

tff(addAssignment_71765,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,1)
    <=> v127617(VarCurr) ) ).

tff(addAssignment_71764,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,2)
    <=> v127616(VarCurr) ) ).

tff(addAssignment_71763,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,3)
    <=> v127615(VarCurr) ) ).

tff(addAssignment_71762,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,4)
    <=> v127614(VarCurr) ) ).

tff(addAssignment_71761,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,5)
    <=> v127613(VarCurr) ) ).

tff(addAssignment_71760,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,6)
    <=> v127612(VarCurr) ) ).

tff(addAssignment_71759,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,7)
    <=> v127611(VarCurr) ) ).

tff(addAssignment_71758,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,8)
    <=> v127610(VarCurr) ) ).

tff(addAssignment_71757,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,9)
    <=> v127609(VarCurr) ) ).

tff(addAssignment_71756,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,10)
    <=> v127608(VarCurr) ) ).

tff(addAssignment_71755,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,11)
    <=> v127607(VarCurr) ) ).

tff(addAssignment_71754,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,12)
    <=> v127606(VarCurr) ) ).

tff(addAssignment_71753,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,13)
    <=> v127605(VarCurr) ) ).

tff(addAssignment_71752,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,14)
    <=> v127604(VarCurr) ) ).

tff(addAssignment_71751,axiom,
    ! [VarCurr: state_type] :
      ( v127595(VarCurr,15)
    <=> v127603(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1413,axiom,
    ! [VarCurr: state_type] :
      ( v127618(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1412,axiom,
    ! [VarCurr: state_type] :
      ( v127617(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1411,axiom,
    ! [VarCurr: state_type] :
      ( v127616(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1410,axiom,
    ! [VarCurr: state_type] :
      ( v127615(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1409,axiom,
    ! [VarCurr: state_type] :
      ( v127614(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1408,axiom,
    ! [VarCurr: state_type] :
      ( v127613(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1407,axiom,
    ! [VarCurr: state_type] :
      ( v127612(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1406,axiom,
    ! [VarCurr: state_type] :
      ( v127611(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $false )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1405,axiom,
    ! [VarCurr: state_type] :
      ( v127610(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1404,axiom,
    ! [VarCurr: state_type] :
      ( v127609(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1403,axiom,
    ! [VarCurr: state_type] :
      ( v127608(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1402,axiom,
    ! [VarCurr: state_type] :
      ( v127607(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $false )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1401,axiom,
    ! [VarCurr: state_type] :
      ( v127606(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1400,axiom,
    ! [VarCurr: state_type] :
      ( v127605(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $false )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1399,axiom,
    ! [VarCurr: state_type] :
      ( v127604(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1398,axiom,
    ! [VarCurr: state_type] :
      ( v127603(VarCurr)
    <=> ( ( v127597(VarCurr,3)
        <=> $true )
        & ( v127597(VarCurr,2)
        <=> $true )
        & ( v127597(VarCurr,1)
        <=> $true )
        & ( v127597(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127597(VarCurr,B)
      <=> v85282(VarCurr,B) ) ) ).

tff(addAssignment_71749,axiom,
    ! [VarCurr: state_type] :
      ( v127597(VarCurr,3)
    <=> v127599(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127599(VarCurr)
      <=> v127601(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1233,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127599(VarCurr)
      <=> v127600(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_97,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127601(VarCurr)
      <=> v85282(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_126,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127601(VarCurr)
      <=> v85282(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_96,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127600(VarCurr)
      <=> v85282(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_125,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127600(VarCurr)
      <=> v85282(VarCurr,6) ) ) ).

tff(addAssignment_71748,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,0)
    <=> v127593(VarCurr) ) ).

tff(addAssignment_71747,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,1)
    <=> v127592(VarCurr) ) ).

tff(addAssignment_71746,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,2)
    <=> v127591(VarCurr) ) ).

tff(addAssignment_71745,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,3)
    <=> v127590(VarCurr) ) ).

tff(addAssignment_71744,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,4)
    <=> v127589(VarCurr) ) ).

tff(addAssignment_71743,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,5)
    <=> v127588(VarCurr) ) ).

tff(addAssignment_71742,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,6)
    <=> v127587(VarCurr) ) ).

tff(addAssignment_71741,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,7)
    <=> v127586(VarCurr) ) ).

tff(addAssignment_71740,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,8)
    <=> v127585(VarCurr) ) ).

tff(addAssignment_71739,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,9)
    <=> v127584(VarCurr) ) ).

tff(addAssignment_71738,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,10)
    <=> v127583(VarCurr) ) ).

tff(addAssignment_71737,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,11)
    <=> v127582(VarCurr) ) ).

tff(addAssignment_71736,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,12)
    <=> v127581(VarCurr) ) ).

tff(addAssignment_71735,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,13)
    <=> v127580(VarCurr) ) ).

tff(addAssignment_71734,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,14)
    <=> v127579(VarCurr) ) ).

tff(addAssignment_71733,axiom,
    ! [VarCurr: state_type] :
      ( v127570(VarCurr,15)
    <=> v127578(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1397,axiom,
    ! [VarCurr: state_type] :
      ( v127593(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1396,axiom,
    ! [VarCurr: state_type] :
      ( v127592(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1395,axiom,
    ! [VarCurr: state_type] :
      ( v127591(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1394,axiom,
    ! [VarCurr: state_type] :
      ( v127590(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1393,axiom,
    ! [VarCurr: state_type] :
      ( v127589(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1392,axiom,
    ! [VarCurr: state_type] :
      ( v127588(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1391,axiom,
    ! [VarCurr: state_type] :
      ( v127587(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1390,axiom,
    ! [VarCurr: state_type] :
      ( v127586(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $false )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1389,axiom,
    ! [VarCurr: state_type] :
      ( v127585(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1388,axiom,
    ! [VarCurr: state_type] :
      ( v127584(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1387,axiom,
    ! [VarCurr: state_type] :
      ( v127583(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1386,axiom,
    ! [VarCurr: state_type] :
      ( v127582(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $false )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1385,axiom,
    ! [VarCurr: state_type] :
      ( v127581(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1384,axiom,
    ! [VarCurr: state_type] :
      ( v127580(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $false )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1383,axiom,
    ! [VarCurr: state_type] :
      ( v127579(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1382,axiom,
    ! [VarCurr: state_type] :
      ( v127578(VarCurr)
    <=> ( ( v127572(VarCurr,3)
        <=> $true )
        & ( v127572(VarCurr,2)
        <=> $true )
        & ( v127572(VarCurr,1)
        <=> $true )
        & ( v127572(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127572(VarCurr,B)
      <=> v85260(VarCurr,B) ) ) ).

tff(addAssignment_71731,axiom,
    ! [VarCurr: state_type] :
      ( v127572(VarCurr,3)
    <=> v127574(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127574(VarCurr)
      <=> v127576(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1232,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127574(VarCurr)
      <=> v127575(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_95,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127576(VarCurr)
      <=> v85260(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_124,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127576(VarCurr)
      <=> v85260(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_94,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127575(VarCurr)
      <=> v85260(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_123,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127575(VarCurr)
      <=> v85260(VarCurr,6) ) ) ).

tff(addAssignment_71730,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,0)
    <=> v127568(VarCurr) ) ).

tff(addAssignment_71729,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,1)
    <=> v127567(VarCurr) ) ).

tff(addAssignment_71728,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,2)
    <=> v127566(VarCurr) ) ).

tff(addAssignment_71727,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,3)
    <=> v127565(VarCurr) ) ).

tff(addAssignment_71726,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,4)
    <=> v127564(VarCurr) ) ).

tff(addAssignment_71725,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,5)
    <=> v127563(VarCurr) ) ).

tff(addAssignment_71724,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,6)
    <=> v127562(VarCurr) ) ).

tff(addAssignment_71723,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,7)
    <=> v127561(VarCurr) ) ).

tff(addAssignment_71722,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,8)
    <=> v127560(VarCurr) ) ).

tff(addAssignment_71721,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,9)
    <=> v127559(VarCurr) ) ).

tff(addAssignment_71720,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,10)
    <=> v127558(VarCurr) ) ).

tff(addAssignment_71719,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,11)
    <=> v127557(VarCurr) ) ).

tff(addAssignment_71718,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,12)
    <=> v127556(VarCurr) ) ).

tff(addAssignment_71717,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,13)
    <=> v127555(VarCurr) ) ).

tff(addAssignment_71716,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,14)
    <=> v127554(VarCurr) ) ).

tff(addAssignment_71715,axiom,
    ! [VarCurr: state_type] :
      ( v127545(VarCurr,15)
    <=> v127553(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1381,axiom,
    ! [VarCurr: state_type] :
      ( v127568(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1380,axiom,
    ! [VarCurr: state_type] :
      ( v127567(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1379,axiom,
    ! [VarCurr: state_type] :
      ( v127566(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1378,axiom,
    ! [VarCurr: state_type] :
      ( v127565(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1377,axiom,
    ! [VarCurr: state_type] :
      ( v127564(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1376,axiom,
    ! [VarCurr: state_type] :
      ( v127563(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1375,axiom,
    ! [VarCurr: state_type] :
      ( v127562(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1374,axiom,
    ! [VarCurr: state_type] :
      ( v127561(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $false )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1373,axiom,
    ! [VarCurr: state_type] :
      ( v127560(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1372,axiom,
    ! [VarCurr: state_type] :
      ( v127559(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1371,axiom,
    ! [VarCurr: state_type] :
      ( v127558(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1370,axiom,
    ! [VarCurr: state_type] :
      ( v127557(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $false )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1369,axiom,
    ! [VarCurr: state_type] :
      ( v127556(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1368,axiom,
    ! [VarCurr: state_type] :
      ( v127555(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $false )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1367,axiom,
    ! [VarCurr: state_type] :
      ( v127554(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1366,axiom,
    ! [VarCurr: state_type] :
      ( v127553(VarCurr)
    <=> ( ( v127547(VarCurr,3)
        <=> $true )
        & ( v127547(VarCurr,2)
        <=> $true )
        & ( v127547(VarCurr,1)
        <=> $true )
        & ( v127547(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127547(VarCurr,B)
      <=> v85238(VarCurr,B) ) ) ).

tff(addAssignment_71713,axiom,
    ! [VarCurr: state_type] :
      ( v127547(VarCurr,3)
    <=> v127549(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127549(VarCurr)
      <=> v127551(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1231,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127549(VarCurr)
      <=> v127550(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_93,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127551(VarCurr)
      <=> v85238(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_122,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127551(VarCurr)
      <=> v85238(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_92,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127550(VarCurr)
      <=> v85238(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_121,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127550(VarCurr)
      <=> v85238(VarCurr,6) ) ) ).

tff(addAssignment_71712,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,0)
    <=> v127543(VarCurr) ) ).

tff(addAssignment_71711,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,1)
    <=> v127542(VarCurr) ) ).

tff(addAssignment_71710,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,2)
    <=> v127541(VarCurr) ) ).

tff(addAssignment_71709,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,3)
    <=> v127540(VarCurr) ) ).

tff(addAssignment_71708,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,4)
    <=> v127539(VarCurr) ) ).

tff(addAssignment_71707,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,5)
    <=> v127538(VarCurr) ) ).

tff(addAssignment_71706,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,6)
    <=> v127537(VarCurr) ) ).

tff(addAssignment_71705,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,7)
    <=> v127536(VarCurr) ) ).

tff(addAssignment_71704,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,8)
    <=> v127535(VarCurr) ) ).

tff(addAssignment_71703,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,9)
    <=> v127534(VarCurr) ) ).

tff(addAssignment_71702,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,10)
    <=> v127533(VarCurr) ) ).

tff(addAssignment_71701,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,11)
    <=> v127532(VarCurr) ) ).

tff(addAssignment_71700,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,12)
    <=> v127531(VarCurr) ) ).

tff(addAssignment_71699,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,13)
    <=> v127530(VarCurr) ) ).

tff(addAssignment_71698,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,14)
    <=> v127529(VarCurr) ) ).

tff(addAssignment_71697,axiom,
    ! [VarCurr: state_type] :
      ( v127520(VarCurr,15)
    <=> v127528(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1365,axiom,
    ! [VarCurr: state_type] :
      ( v127543(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1364,axiom,
    ! [VarCurr: state_type] :
      ( v127542(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1363,axiom,
    ! [VarCurr: state_type] :
      ( v127541(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1362,axiom,
    ! [VarCurr: state_type] :
      ( v127540(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1361,axiom,
    ! [VarCurr: state_type] :
      ( v127539(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1360,axiom,
    ! [VarCurr: state_type] :
      ( v127538(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1359,axiom,
    ! [VarCurr: state_type] :
      ( v127537(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1358,axiom,
    ! [VarCurr: state_type] :
      ( v127536(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $false )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1357,axiom,
    ! [VarCurr: state_type] :
      ( v127535(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1356,axiom,
    ! [VarCurr: state_type] :
      ( v127534(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1355,axiom,
    ! [VarCurr: state_type] :
      ( v127533(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1354,axiom,
    ! [VarCurr: state_type] :
      ( v127532(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $false )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1353,axiom,
    ! [VarCurr: state_type] :
      ( v127531(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1352,axiom,
    ! [VarCurr: state_type] :
      ( v127530(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $false )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1351,axiom,
    ! [VarCurr: state_type] :
      ( v127529(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1350,axiom,
    ! [VarCurr: state_type] :
      ( v127528(VarCurr)
    <=> ( ( v127522(VarCurr,3)
        <=> $true )
        & ( v127522(VarCurr,2)
        <=> $true )
        & ( v127522(VarCurr,1)
        <=> $true )
        & ( v127522(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127522(VarCurr,B)
      <=> v85216(VarCurr,B) ) ) ).

tff(addAssignment_71695,axiom,
    ! [VarCurr: state_type] :
      ( v127522(VarCurr,3)
    <=> v127524(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127524(VarCurr)
      <=> v127526(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1230,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127524(VarCurr)
      <=> v127525(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_91,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127526(VarCurr)
      <=> v85216(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_120,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127526(VarCurr)
      <=> v85216(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_90,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127525(VarCurr)
      <=> v85216(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_119,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127525(VarCurr)
      <=> v85216(VarCurr,6) ) ) ).

tff(addAssignment_71694,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,0)
    <=> v127518(VarCurr) ) ).

tff(addAssignment_71693,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,1)
    <=> v127517(VarCurr) ) ).

tff(addAssignment_71692,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,2)
    <=> v127516(VarCurr) ) ).

tff(addAssignment_71691,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,3)
    <=> v127515(VarCurr) ) ).

tff(addAssignment_71690,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,4)
    <=> v127514(VarCurr) ) ).

tff(addAssignment_71689,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,5)
    <=> v127513(VarCurr) ) ).

tff(addAssignment_71688,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,6)
    <=> v127512(VarCurr) ) ).

tff(addAssignment_71687,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,7)
    <=> v127511(VarCurr) ) ).

tff(addAssignment_71686,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,8)
    <=> v127510(VarCurr) ) ).

tff(addAssignment_71685,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,9)
    <=> v127509(VarCurr) ) ).

tff(addAssignment_71684,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,10)
    <=> v127508(VarCurr) ) ).

tff(addAssignment_71683,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,11)
    <=> v127507(VarCurr) ) ).

tff(addAssignment_71682,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,12)
    <=> v127506(VarCurr) ) ).

tff(addAssignment_71681,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,13)
    <=> v127505(VarCurr) ) ).

tff(addAssignment_71680,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,14)
    <=> v127504(VarCurr) ) ).

tff(addAssignment_71679,axiom,
    ! [VarCurr: state_type] :
      ( v127495(VarCurr,15)
    <=> v127503(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1349,axiom,
    ! [VarCurr: state_type] :
      ( v127518(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1348,axiom,
    ! [VarCurr: state_type] :
      ( v127517(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1347,axiom,
    ! [VarCurr: state_type] :
      ( v127516(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1346,axiom,
    ! [VarCurr: state_type] :
      ( v127515(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1345,axiom,
    ! [VarCurr: state_type] :
      ( v127514(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1344,axiom,
    ! [VarCurr: state_type] :
      ( v127513(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1343,axiom,
    ! [VarCurr: state_type] :
      ( v127512(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1342,axiom,
    ! [VarCurr: state_type] :
      ( v127511(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $false )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1341,axiom,
    ! [VarCurr: state_type] :
      ( v127510(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1340,axiom,
    ! [VarCurr: state_type] :
      ( v127509(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1339,axiom,
    ! [VarCurr: state_type] :
      ( v127508(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1338,axiom,
    ! [VarCurr: state_type] :
      ( v127507(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $false )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1337,axiom,
    ! [VarCurr: state_type] :
      ( v127506(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1336,axiom,
    ! [VarCurr: state_type] :
      ( v127505(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $false )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1335,axiom,
    ! [VarCurr: state_type] :
      ( v127504(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1334,axiom,
    ! [VarCurr: state_type] :
      ( v127503(VarCurr)
    <=> ( ( v127497(VarCurr,3)
        <=> $true )
        & ( v127497(VarCurr,2)
        <=> $true )
        & ( v127497(VarCurr,1)
        <=> $true )
        & ( v127497(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127497(VarCurr,B)
      <=> v85194(VarCurr,B) ) ) ).

tff(addAssignment_71677,axiom,
    ! [VarCurr: state_type] :
      ( v127497(VarCurr,3)
    <=> v127499(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127499(VarCurr)
      <=> v127501(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1229,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127499(VarCurr)
      <=> v127500(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_89,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127501(VarCurr)
      <=> v85194(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_118,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127501(VarCurr)
      <=> v85194(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_88,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127500(VarCurr)
      <=> v85194(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_117,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127500(VarCurr)
      <=> v85194(VarCurr,6) ) ) ).

tff(addAssignment_71676,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,0)
    <=> v127493(VarCurr) ) ).

tff(addAssignment_71675,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,1)
    <=> v127492(VarCurr) ) ).

tff(addAssignment_71674,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,2)
    <=> v127491(VarCurr) ) ).

tff(addAssignment_71673,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,3)
    <=> v127490(VarCurr) ) ).

tff(addAssignment_71672,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,4)
    <=> v127489(VarCurr) ) ).

tff(addAssignment_71671,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,5)
    <=> v127488(VarCurr) ) ).

tff(addAssignment_71670,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,6)
    <=> v127487(VarCurr) ) ).

tff(addAssignment_71669,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,7)
    <=> v127486(VarCurr) ) ).

tff(addAssignment_71668,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,8)
    <=> v127485(VarCurr) ) ).

tff(addAssignment_71667,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,9)
    <=> v127484(VarCurr) ) ).

tff(addAssignment_71666,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,10)
    <=> v127483(VarCurr) ) ).

tff(addAssignment_71665,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,11)
    <=> v127482(VarCurr) ) ).

tff(addAssignment_71664,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,12)
    <=> v127481(VarCurr) ) ).

tff(addAssignment_71663,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,13)
    <=> v127480(VarCurr) ) ).

tff(addAssignment_71662,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,14)
    <=> v127479(VarCurr) ) ).

tff(addAssignment_71661,axiom,
    ! [VarCurr: state_type] :
      ( v127470(VarCurr,15)
    <=> v127478(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1333,axiom,
    ! [VarCurr: state_type] :
      ( v127493(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1332,axiom,
    ! [VarCurr: state_type] :
      ( v127492(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1331,axiom,
    ! [VarCurr: state_type] :
      ( v127491(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1330,axiom,
    ! [VarCurr: state_type] :
      ( v127490(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1329,axiom,
    ! [VarCurr: state_type] :
      ( v127489(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1328,axiom,
    ! [VarCurr: state_type] :
      ( v127488(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1327,axiom,
    ! [VarCurr: state_type] :
      ( v127487(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1326,axiom,
    ! [VarCurr: state_type] :
      ( v127486(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $false )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1325,axiom,
    ! [VarCurr: state_type] :
      ( v127485(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1324,axiom,
    ! [VarCurr: state_type] :
      ( v127484(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1323,axiom,
    ! [VarCurr: state_type] :
      ( v127483(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1322,axiom,
    ! [VarCurr: state_type] :
      ( v127482(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $false )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1321,axiom,
    ! [VarCurr: state_type] :
      ( v127481(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1320,axiom,
    ! [VarCurr: state_type] :
      ( v127480(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $false )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1319,axiom,
    ! [VarCurr: state_type] :
      ( v127479(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1318,axiom,
    ! [VarCurr: state_type] :
      ( v127478(VarCurr)
    <=> ( ( v127472(VarCurr,3)
        <=> $true )
        & ( v127472(VarCurr,2)
        <=> $true )
        & ( v127472(VarCurr,1)
        <=> $true )
        & ( v127472(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127472(VarCurr,B)
      <=> v85172(VarCurr,B) ) ) ).

tff(addAssignment_71659,axiom,
    ! [VarCurr: state_type] :
      ( v127472(VarCurr,3)
    <=> v127474(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127474(VarCurr)
      <=> v127476(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1228,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127474(VarCurr)
      <=> v127475(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_87,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127476(VarCurr)
      <=> v85172(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_116,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127476(VarCurr)
      <=> v85172(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_86,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127475(VarCurr)
      <=> v85172(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_115,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127475(VarCurr)
      <=> v85172(VarCurr,6) ) ) ).

tff(addAssignment_71658,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,0)
    <=> v127468(VarCurr) ) ).

tff(addAssignment_71657,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,1)
    <=> v127467(VarCurr) ) ).

tff(addAssignment_71656,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,2)
    <=> v127466(VarCurr) ) ).

tff(addAssignment_71655,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,3)
    <=> v127465(VarCurr) ) ).

tff(addAssignment_71654,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,4)
    <=> v127464(VarCurr) ) ).

tff(addAssignment_71653,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,5)
    <=> v127463(VarCurr) ) ).

tff(addAssignment_71652,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,6)
    <=> v127462(VarCurr) ) ).

tff(addAssignment_71651,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,7)
    <=> v127461(VarCurr) ) ).

tff(addAssignment_71650,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,8)
    <=> v127460(VarCurr) ) ).

tff(addAssignment_71649,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,9)
    <=> v127459(VarCurr) ) ).

tff(addAssignment_71648,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,10)
    <=> v127458(VarCurr) ) ).

tff(addAssignment_71647,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,11)
    <=> v127457(VarCurr) ) ).

tff(addAssignment_71646,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,12)
    <=> v127456(VarCurr) ) ).

tff(addAssignment_71645,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,13)
    <=> v127455(VarCurr) ) ).

tff(addAssignment_71644,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,14)
    <=> v127454(VarCurr) ) ).

tff(addAssignment_71643,axiom,
    ! [VarCurr: state_type] :
      ( v127445(VarCurr,15)
    <=> v127453(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1317,axiom,
    ! [VarCurr: state_type] :
      ( v127468(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1316,axiom,
    ! [VarCurr: state_type] :
      ( v127467(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1315,axiom,
    ! [VarCurr: state_type] :
      ( v127466(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1314,axiom,
    ! [VarCurr: state_type] :
      ( v127465(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1313,axiom,
    ! [VarCurr: state_type] :
      ( v127464(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1312,axiom,
    ! [VarCurr: state_type] :
      ( v127463(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1311,axiom,
    ! [VarCurr: state_type] :
      ( v127462(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1310,axiom,
    ! [VarCurr: state_type] :
      ( v127461(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $false )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1309,axiom,
    ! [VarCurr: state_type] :
      ( v127460(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1308,axiom,
    ! [VarCurr: state_type] :
      ( v127459(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1307,axiom,
    ! [VarCurr: state_type] :
      ( v127458(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1306,axiom,
    ! [VarCurr: state_type] :
      ( v127457(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $false )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1305,axiom,
    ! [VarCurr: state_type] :
      ( v127456(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1304,axiom,
    ! [VarCurr: state_type] :
      ( v127455(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $false )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1303,axiom,
    ! [VarCurr: state_type] :
      ( v127454(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1302,axiom,
    ! [VarCurr: state_type] :
      ( v127453(VarCurr)
    <=> ( ( v127447(VarCurr,3)
        <=> $true )
        & ( v127447(VarCurr,2)
        <=> $true )
        & ( v127447(VarCurr,1)
        <=> $true )
        & ( v127447(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127447(VarCurr,B)
      <=> v85150(VarCurr,B) ) ) ).

tff(addAssignment_71641,axiom,
    ! [VarCurr: state_type] :
      ( v127447(VarCurr,3)
    <=> v127449(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127449(VarCurr)
      <=> v127451(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1227,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127449(VarCurr)
      <=> v127450(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_85,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127451(VarCurr)
      <=> v85150(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_114,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127451(VarCurr)
      <=> v85150(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_84,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127450(VarCurr)
      <=> v85150(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_113,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127450(VarCurr)
      <=> v85150(VarCurr,6) ) ) ).

tff(addAssignment_71640,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,0)
    <=> v127443(VarCurr) ) ).

tff(addAssignment_71639,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,1)
    <=> v127442(VarCurr) ) ).

tff(addAssignment_71638,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,2)
    <=> v127441(VarCurr) ) ).

tff(addAssignment_71637,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,3)
    <=> v127440(VarCurr) ) ).

tff(addAssignment_71636,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,4)
    <=> v127439(VarCurr) ) ).

tff(addAssignment_71635,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,5)
    <=> v127438(VarCurr) ) ).

tff(addAssignment_71634,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,6)
    <=> v127437(VarCurr) ) ).

tff(addAssignment_71633,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,7)
    <=> v127436(VarCurr) ) ).

tff(addAssignment_71632,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,8)
    <=> v127435(VarCurr) ) ).

tff(addAssignment_71631,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,9)
    <=> v127434(VarCurr) ) ).

tff(addAssignment_71630,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,10)
    <=> v127433(VarCurr) ) ).

tff(addAssignment_71629,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,11)
    <=> v127432(VarCurr) ) ).

tff(addAssignment_71628,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,12)
    <=> v127431(VarCurr) ) ).

tff(addAssignment_71627,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,13)
    <=> v127430(VarCurr) ) ).

tff(addAssignment_71626,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,14)
    <=> v127429(VarCurr) ) ).

tff(addAssignment_71625,axiom,
    ! [VarCurr: state_type] :
      ( v127420(VarCurr,15)
    <=> v127428(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1301,axiom,
    ! [VarCurr: state_type] :
      ( v127443(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1300,axiom,
    ! [VarCurr: state_type] :
      ( v127442(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1299,axiom,
    ! [VarCurr: state_type] :
      ( v127441(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1298,axiom,
    ! [VarCurr: state_type] :
      ( v127440(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1297,axiom,
    ! [VarCurr: state_type] :
      ( v127439(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1296,axiom,
    ! [VarCurr: state_type] :
      ( v127438(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1295,axiom,
    ! [VarCurr: state_type] :
      ( v127437(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1294,axiom,
    ! [VarCurr: state_type] :
      ( v127436(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $false )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1293,axiom,
    ! [VarCurr: state_type] :
      ( v127435(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1292,axiom,
    ! [VarCurr: state_type] :
      ( v127434(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1291,axiom,
    ! [VarCurr: state_type] :
      ( v127433(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1290,axiom,
    ! [VarCurr: state_type] :
      ( v127432(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $false )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1289,axiom,
    ! [VarCurr: state_type] :
      ( v127431(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1288,axiom,
    ! [VarCurr: state_type] :
      ( v127430(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $false )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1287,axiom,
    ! [VarCurr: state_type] :
      ( v127429(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1286,axiom,
    ! [VarCurr: state_type] :
      ( v127428(VarCurr)
    <=> ( ( v127422(VarCurr,3)
        <=> $true )
        & ( v127422(VarCurr,2)
        <=> $true )
        & ( v127422(VarCurr,1)
        <=> $true )
        & ( v127422(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v127422(VarCurr,B)
      <=> v85128(VarCurr,B) ) ) ).

tff(addAssignment_71623,axiom,
    ! [VarCurr: state_type] :
      ( v127422(VarCurr,3)
    <=> v127424(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v127424(VarCurr)
      <=> v127426(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1226,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v127424(VarCurr)
      <=> v127425(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_83,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127426(VarCurr)
      <=> v85128(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_112,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127426(VarCurr)
      <=> v85128(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_82,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v127425(VarCurr)
      <=> v85128(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_111,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v127425(VarCurr)
      <=> v85128(VarCurr,6) ) ) ).

tff(addAssignment_71622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100211(VarCurr,B)
      <=> v100213(VarCurr,B) ) ) ).

tff(addAssignment_71621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100213(VarCurr,B)
      <=> v100215(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100215(VarCurr,B)
      <=> ( v100217(VarCurr,B)
          & v127375(VarCurr,B) ) ) ) ).

tff(addAssignment_71620,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,0)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71619,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,1)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71618,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,2)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71617,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,3)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71616,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,4)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71615,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,5)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71614,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,6)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71613,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,7)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71612,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,8)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71611,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,9)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71610,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,10)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71609,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,11)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71608,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,12)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71607,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,13)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71606,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,14)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71605,axiom,
    ! [VarCurr: state_type] :
      ( v127375(VarCurr,15)
    <=> v127376(VarCurr) ) ).

tff(addAssignment_71604,axiom,
    ! [VarCurr: state_type] :
      ( v127376(VarCurr)
    <=> v127377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16465,axiom,
    ! [VarCurr: state_type] :
      ( v127377(VarCurr)
    <=> ( v127378(VarCurr)
        & v127379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16464,axiom,
    ! [VarCurr: state_type] :
      ( v127379(VarCurr)
    <=> ( v127380(VarCurr)
        | v108826(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16463,axiom,
    ! [VarCurr: state_type] :
      ( v127380(VarCurr)
    <=> ( v127381(VarCurr)
        & v127384(VarCurr) ) ) ).

tff(writeUnaryOperator_9198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127384(VarCurr)
    <=> v127386(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16462,axiom,
    ! [VarCurr: state_type] :
      ( v127386(VarCurr)
    <=> ( v127387(VarCurr)
        & v127404(VarCurr) ) ) ).

tff(writeUnaryOperator_9197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127404(VarCurr)
    <=> v127405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16461,axiom,
    ! [VarCurr: state_type] :
      ( v127405(VarCurr)
    <=> ( v127406(VarCurr)
        & v127408(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5748,axiom,
    ! [VarCurr: state_type] :
      ( v127408(VarCurr)
    <=> ( v108822(VarCurr,3)
        | v100229(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16460,axiom,
    ! [VarCurr: state_type] :
      ( v127406(VarCurr)
    <=> ( v108866(VarCurr)
        | v127407(VarCurr) ) ) ).

tff(writeUnaryOperator_9196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127407(VarCurr)
    <=> v100229(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16459,axiom,
    ! [VarCurr: state_type] :
      ( v127387(VarCurr)
    <=> ( v127388(VarCurr)
        & v127399(VarCurr) ) ) ).

tff(writeUnaryOperator_9195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127399(VarCurr)
    <=> v127400(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16458,axiom,
    ! [VarCurr: state_type] :
      ( v127400(VarCurr)
    <=> ( v127401(VarCurr)
        & v127403(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5747,axiom,
    ! [VarCurr: state_type] :
      ( v127403(VarCurr)
    <=> ( v108822(VarCurr,2)
        | v100229(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16457,axiom,
    ! [VarCurr: state_type] :
      ( v127401(VarCurr)
    <=> ( v108860(VarCurr)
        | v127402(VarCurr) ) ) ).

tff(writeUnaryOperator_9194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127402(VarCurr)
    <=> v100229(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16456,axiom,
    ! [VarCurr: state_type] :
      ( v127388(VarCurr)
    <=> ( v127389(VarCurr)
        & v127394(VarCurr) ) ) ).

tff(writeUnaryOperator_9193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127394(VarCurr)
    <=> v127395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16455,axiom,
    ! [VarCurr: state_type] :
      ( v127395(VarCurr)
    <=> ( v127396(VarCurr)
        & v127398(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5746,axiom,
    ! [VarCurr: state_type] :
      ( v127398(VarCurr)
    <=> ( v108822(VarCurr,1)
        | v100229(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16454,axiom,
    ! [VarCurr: state_type] :
      ( v127396(VarCurr)
    <=> ( v108854(VarCurr)
        | v127397(VarCurr) ) ) ).

tff(writeUnaryOperator_9192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127397(VarCurr)
    <=> v100229(VarCurr,4) ) ).

tff(writeUnaryOperator_9191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127389(VarCurr)
    <=> v127390(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16453,axiom,
    ! [VarCurr: state_type] :
      ( v127390(VarCurr)
    <=> ( v127391(VarCurr)
        & v127393(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5745,axiom,
    ! [VarCurr: state_type] :
      ( v127393(VarCurr)
    <=> ( v108822(VarCurr,0)
        | v100229(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16452,axiom,
    ! [VarCurr: state_type] :
      ( v127391(VarCurr)
    <=> ( v108848(VarCurr)
        | v127392(VarCurr) ) ) ).

tff(writeUnaryOperator_9190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127392(VarCurr)
    <=> v100229(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16451,axiom,
    ! [VarCurr: state_type] :
      ( v127381(VarCurr)
    <=> ( v127382(VarCurr)
        & v127383(VarCurr) ) ) ).

tff(writeUnaryOperator_9189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127383(VarCurr)
    <=> v108818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16450,axiom,
    ! [VarCurr: state_type] :
      ( v127382(VarCurr)
    <=> ( v108810(VarCurr)
        | v108814(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16449,axiom,
    ! [VarCurr: state_type] :
      ( v127378(VarCurr)
    <=> ( v100689(VarCurr,0)
        & v127337(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5744,axiom,
    ! [VarCurr: state_type] :
      ( v127337(VarCurr)
    <=> ( v127359(VarCurr)
        | v127373(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5743,axiom,
    ! [VarCurr: state_type] :
      ( v127359(VarCurr)
    <=> ( v127360(VarCurr)
        | v127373(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5742,axiom,
    ! [VarCurr: state_type] :
      ( v127360(VarCurr)
    <=> ( v127361(VarCurr)
        | v127373(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5741,axiom,
    ! [VarCurr: state_type] :
      ( v127361(VarCurr)
    <=> ( v127362(VarCurr)
        | v127373(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5740,axiom,
    ! [VarCurr: state_type] :
      ( v127362(VarCurr)
    <=> ( v127363(VarCurr)
        | v127373(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5739,axiom,
    ! [VarCurr: state_type] :
      ( v127363(VarCurr)
    <=> ( v127364(VarCurr)
        | v127373(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5738,axiom,
    ! [VarCurr: state_type] :
      ( v127364(VarCurr)
    <=> ( v127365(VarCurr)
        | v127373(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5737,axiom,
    ! [VarCurr: state_type] :
      ( v127365(VarCurr)
    <=> ( v127366(VarCurr)
        | v127373(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5736,axiom,
    ! [VarCurr: state_type] :
      ( v127366(VarCurr)
    <=> ( v127367(VarCurr)
        | v127373(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5735,axiom,
    ! [VarCurr: state_type] :
      ( v127367(VarCurr)
    <=> ( v127368(VarCurr)
        | v127373(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5734,axiom,
    ! [VarCurr: state_type] :
      ( v127368(VarCurr)
    <=> ( v127369(VarCurr)
        | v127373(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5733,axiom,
    ! [VarCurr: state_type] :
      ( v127369(VarCurr)
    <=> ( v127370(VarCurr)
        | v127373(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5732,axiom,
    ! [VarCurr: state_type] :
      ( v127370(VarCurr)
    <=> ( v127371(VarCurr)
        | v127373(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5731,axiom,
    ! [VarCurr: state_type] :
      ( v127371(VarCurr)
    <=> ( v127372(VarCurr)
        | v127373(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5730,axiom,
    ! [VarCurr: state_type] :
      ( v127372(VarCurr)
    <=> ( v127373(VarCurr,0)
        | v127373(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127373(VarCurr,B)
      <=> ( v127339(VarCurr,B)
          & v101248(VarCurr,B) ) ) ) ).

tff(addAssignment_71603,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,0)
    <=> v127356(VarCurr) ) ).

tff(addAssignment_71602,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,1)
    <=> v127355(VarCurr) ) ).

tff(addAssignment_71601,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,2)
    <=> v127354(VarCurr) ) ).

tff(addAssignment_71600,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,3)
    <=> v127353(VarCurr) ) ).

tff(addAssignment_71599,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,4)
    <=> v127352(VarCurr) ) ).

tff(addAssignment_71598,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,5)
    <=> v127351(VarCurr) ) ).

tff(addAssignment_71597,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,6)
    <=> v127350(VarCurr) ) ).

tff(addAssignment_71596,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,7)
    <=> v127349(VarCurr) ) ).

tff(addAssignment_71595,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,8)
    <=> v127348(VarCurr) ) ).

tff(addAssignment_71594,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,9)
    <=> v127347(VarCurr) ) ).

tff(addAssignment_71593,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,10)
    <=> v127346(VarCurr) ) ).

tff(addAssignment_71592,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,11)
    <=> v127345(VarCurr) ) ).

tff(addAssignment_71591,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,12)
    <=> v127344(VarCurr) ) ).

tff(addAssignment_71590,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,13)
    <=> v127343(VarCurr) ) ).

tff(addAssignment_71589,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,14)
    <=> v127342(VarCurr) ) ).

tff(addAssignment_71588,axiom,
    ! [VarCurr: state_type] :
      ( v127339(VarCurr,15)
    <=> v127341(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1285,axiom,
    ! [VarCurr: state_type] :
      ( v127356(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1284,axiom,
    ! [VarCurr: state_type] :
      ( v127355(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1283,axiom,
    ! [VarCurr: state_type] :
      ( v127354(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1282,axiom,
    ! [VarCurr: state_type] :
      ( v127353(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1281,axiom,
    ! [VarCurr: state_type] :
      ( v127352(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1280,axiom,
    ! [VarCurr: state_type] :
      ( v127351(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1279,axiom,
    ! [VarCurr: state_type] :
      ( v127350(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1278,axiom,
    ! [VarCurr: state_type] :
      ( v127349(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1277,axiom,
    ! [VarCurr: state_type] :
      ( v127348(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1276,axiom,
    ! [VarCurr: state_type] :
      ( v127347(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1275,axiom,
    ! [VarCurr: state_type] :
      ( v127346(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1274,axiom,
    ! [VarCurr: state_type] :
      ( v127345(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1273,axiom,
    ! [VarCurr: state_type] :
      ( v127344(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1272,axiom,
    ! [VarCurr: state_type] :
      ( v127343(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1271,axiom,
    ! [VarCurr: state_type] :
      ( v127342(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1270,axiom,
    ! [VarCurr: state_type] :
      ( v127341(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_71587,axiom,
    ! [VarCurr: state_type] :
      ( v100689(VarCurr,0)
    <=> v101201(VarCurr,0) ) ).

tff(writeUnaryOperator_9188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101225(VarCurr)
    <=> v127324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16448,axiom,
    ! [VarCurr: state_type] :
      ( v127324(VarCurr)
    <=> ( v127326(VarCurr)
        | v100691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16447,axiom,
    ! [VarCurr: state_type] :
      ( v127326(VarCurr)
    <=> ( v127327(VarCurr)
        & v127334(VarCurr) ) ) ).

tff(writeUnaryOperator_9187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127334(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeUnaryOperator_9186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127327(VarCurr)
    <=> v127329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16446,axiom,
    ! [VarCurr: state_type] :
      ( v127329(VarCurr)
    <=> ( v127330(VarCurr)
        & v101040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16445,axiom,
    ! [VarCurr: state_type] :
      ( v127330(VarCurr)
    <=> ( v127331(VarCurr)
        & v101035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16444,axiom,
    ! [VarCurr: state_type] :
      ( v127331(VarCurr)
    <=> ( v127332(VarCurr)
        & v101030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16443,axiom,
    ! [VarCurr: state_type] :
      ( v127332(VarCurr)
    <=> ( v127333(VarCurr)
        & v101025(VarCurr) ) ) ).

tff(writeUnaryOperator_9185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127333(VarCurr)
    <=> v101111(VarCurr) ) ).

tff(addAssignment_71586,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,0)
    <=> v127321(VarCurr) ) ).

tff(addAssignment_71585,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,1)
    <=> v127320(VarCurr) ) ).

tff(addAssignment_71584,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,2)
    <=> v127319(VarCurr) ) ).

tff(addAssignment_71583,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,3)
    <=> v127318(VarCurr) ) ).

tff(addAssignment_71582,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,4)
    <=> v127317(VarCurr) ) ).

tff(addAssignment_71581,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,5)
    <=> v127316(VarCurr) ) ).

tff(addAssignment_71580,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,6)
    <=> v127315(VarCurr) ) ).

tff(addAssignment_71579,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,7)
    <=> v127314(VarCurr) ) ).

tff(addAssignment_71578,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,8)
    <=> v127313(VarCurr) ) ).

tff(addAssignment_71577,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,9)
    <=> v127312(VarCurr) ) ).

tff(addAssignment_71576,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,10)
    <=> v127311(VarCurr) ) ).

tff(addAssignment_71575,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,11)
    <=> v127310(VarCurr) ) ).

tff(addAssignment_71574,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,12)
    <=> v127309(VarCurr) ) ).

tff(addAssignment_71573,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,13)
    <=> v127308(VarCurr) ) ).

tff(addAssignment_71572,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,14)
    <=> v127307(VarCurr) ) ).

tff(addAssignment_71571,axiom,
    ! [VarCurr: state_type] :
      ( v100217(VarCurr,15)
    <=> v127306(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1269,axiom,
    ! [VarCurr: state_type] :
      ( v127321(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1268,axiom,
    ! [VarCurr: state_type] :
      ( v127320(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1267,axiom,
    ! [VarCurr: state_type] :
      ( v127319(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1266,axiom,
    ! [VarCurr: state_type] :
      ( v127318(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1265,axiom,
    ! [VarCurr: state_type] :
      ( v127317(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1264,axiom,
    ! [VarCurr: state_type] :
      ( v127316(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1263,axiom,
    ! [VarCurr: state_type] :
      ( v127315(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1262,axiom,
    ! [VarCurr: state_type] :
      ( v127314(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $false )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1261,axiom,
    ! [VarCurr: state_type] :
      ( v127313(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1260,axiom,
    ! [VarCurr: state_type] :
      ( v127312(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1259,axiom,
    ! [VarCurr: state_type] :
      ( v127311(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1258,axiom,
    ! [VarCurr: state_type] :
      ( v127310(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $false )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1257,axiom,
    ! [VarCurr: state_type] :
      ( v127309(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1256,axiom,
    ! [VarCurr: state_type] :
      ( v127308(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $false )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1255,axiom,
    ! [VarCurr: state_type] :
      ( v127307(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1254,axiom,
    ! [VarCurr: state_type] :
      ( v127306(VarCurr)
    <=> ( ( v100219(VarCurr,3)
        <=> $true )
        & ( v100219(VarCurr,2)
        <=> $true )
        & ( v100219(VarCurr,1)
        <=> $true )
        & ( v100219(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_71570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100219(VarCurr,B)
      <=> v100229(VarCurr,B) ) ) ).

tff(addAssignment_71569,axiom,
    ! [VarCurr: state_type] :
      ( v100219(VarCurr,3)
    <=> v127302(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100221(VarCurr)
     => ( v127302(VarCurr)
      <=> v127304(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1225,axiom,
    ! [VarCurr: state_type] :
      ( v100221(VarCurr)
     => ( v127302(VarCurr)
      <=> v127303(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_81,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100225(VarCurr)
     => ( v127304(VarCurr)
      <=> v100229(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_110,axiom,
    ! [VarCurr: state_type] :
      ( v100225(VarCurr)
     => ( v127304(VarCurr)
      <=> v100229(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_80,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100225(VarCurr)
     => ( v127303(VarCurr)
      <=> v100229(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_109,axiom,
    ! [VarCurr: state_type] :
      ( v100225(VarCurr)
     => ( v127303(VarCurr)
      <=> v100229(VarCurr,6) ) ) ).

tff(addAssignment_71568,axiom,
    ! [VarCurr: state_type] :
      ( v100229(VarCurr,6)
    <=> v101555(VarCurr,6) ) ).

tff(addAssignment_71567,axiom,
    ! [VarCurr: state_type] :
      ( v100409(VarCurr,6)
    <=> v101508(VarCurr,6) ) ).

tff(addAssignment_71566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100413(VarCurr,B)
      <=> v100415(VarCurr,B) ) ) ).

tff(addAssignment_71565,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100415(VarNext,B)
      <=> v127294(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127295(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v127294(VarNext,B)
            <=> v100415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1652,axiom,
    ! [VarNext: state_type] :
      ( v127295(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v127294(VarNext,B)
          <=> v101008(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127295(VarNext)
      <=> v127296(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127296(VarNext)
      <=> ( v127298(VarNext)
          & v100993(VarNext) ) ) ) ).

tff(writeUnaryOperator_9184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127298(VarNext)
      <=> v101002(VarNext) ) ) ).

tff(addAssignment_71564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100425(VarCurr,B)
      <=> v100427(VarCurr,B) ) ) ).

tff(addAssignment_71563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100427(VarCurr,B)
      <=> v100429(VarCurr,B) ) ) ).

tff(addAssignment_71562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100429(VarCurr,B)
      <=> v100431(VarCurr,B) ) ) ).

tff(addAssignment_71561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v100431(VarCurr,B)
      <=> v100933(VarCurr,B) ) ) ).

tff(addAssignment_71560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100203(VarCurr,B)
      <=> v100205(VarCurr,B) ) ) ).

tff(addAssignment_71559,axiom,
    ! [VarCurr: state_type] :
      ( v100205(VarCurr,2)
    <=> v100207(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5729,axiom,
    ! [VarCurr: state_type] :
      ( v100207(VarCurr,2)
    <=> ( v127284(VarCurr)
        & v127292(VarCurr) ) ) ).

tff(writeUnaryOperator_9183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127292(VarCurr)
    <=> v84187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16440,axiom,
    ! [VarCurr: state_type] :
      ( v127284(VarCurr)
    <=> ( v127285(VarCurr)
        & v127291(VarCurr) ) ) ).

tff(writeUnaryOperator_9182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127291(VarCurr)
    <=> v127280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16439,axiom,
    ! [VarCurr: state_type] :
      ( v127285(VarCurr)
    <=> ( v127286(VarCurr)
        & v127290(VarCurr) ) ) ).

tff(writeUnaryOperator_9181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127290(VarCurr)
    <=> v84897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16438,axiom,
    ! [VarCurr: state_type] :
      ( v127286(VarCurr)
    <=> ( v127287(VarCurr)
        & v127289(VarCurr) ) ) ).

tff(writeUnaryOperator_9180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127289(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16437,axiom,
    ! [VarCurr: state_type] :
      ( v127287(VarCurr)
    <=> ( v127288(VarCurr)
        & v127270(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5728,axiom,
    ! [VarCurr: state_type] :
      ( v127288(VarCurr)
    <=> ( v100209(VarCurr,2)
        & v88418(VarCurr) ) ) ).

tff(addAssignment_71558,axiom,
    ! [VarCurr: state_type] :
      ( v127280(VarCurr)
    <=> v127282(VarCurr) ) ).

tff(addAssignment_71557,axiom,
    ! [VarCurr: state_type] :
      ( v127282(VarCurr)
    <=> v84211(VarCurr) ) ).

tff(addAssignment_71556,axiom,
    ! [VarCurr: state_type] :
      ( v127270(VarCurr)
    <=> v97333(VarCurr,2) ) ).

tff(addAssignment_71555,axiom,
    ! [VarCurr: state_type] :
      ( v97333(VarCurr,2)
    <=> v97335(VarCurr,2) ) ).

tff(addAssignment_71554,axiom,
    ! [VarNext: state_type] :
      ( v97335(VarNext,2)
    <=> v127272(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127273(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v127272(VarNext,B)
            <=> v97335(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1651,axiom,
    ! [VarNext: state_type] :
      ( v127273(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127272(VarNext,B)
          <=> v97374(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127273(VarNext)
      <=> v127274(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127274(VarNext)
      <=> ( v127276(VarNext)
          & v97359(VarNext) ) ) ) ).

tff(writeUnaryOperator_9179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127276(VarNext)
      <=> v97368(VarNext) ) ) ).

tff(addAssignment_71553,axiom,
    ! [VarCurr: state_type] :
      ( v97345(VarCurr,2)
    <=> v97347(VarCurr,2) ) ).

tff(addAssignment_71552,axiom,
    ! [VarCurr: state_type] :
      ( v97347(VarCurr,2)
    <=> v97349(VarCurr,2) ) ).

tff(addAssignment_71551,axiom,
    ! [VarCurr: state_type] :
      ( v97349(VarCurr,2)
    <=> v97357(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5727,axiom,
    ! [VarCurr: state_type] :
      ( v100209(VarCurr,2)
    <=> ( v127225(VarCurr)
        & v127247(VarCurr) ) ) ).

tff(writeUnaryOperator_9178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127247(VarCurr)
    <=> v127249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16434,axiom,
    ! [VarCurr: state_type] :
      ( v127249(VarCurr)
    <=> ( v127250(VarCurr)
        & v127263(VarCurr) ) ) ).

tff(writeUnaryOperator_9177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127263(VarCurr)
    <=> v127264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16433,axiom,
    ! [VarCurr: state_type] :
      ( v127264(VarCurr)
    <=> ( v127265(VarCurr)
        & v127268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5726,axiom,
    ! [VarCurr: state_type] :
      ( v127268(VarCurr)
    <=> ( v101505(VarCurr,5)
        | v103117(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16432,axiom,
    ! [VarCurr: state_type] :
      ( v127265(VarCurr)
    <=> ( v127266(VarCurr)
        | v127267(VarCurr) ) ) ).

tff(writeUnaryOperator_9176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127267(VarCurr)
    <=> v103117(VarCurr,5) ) ).

tff(writeUnaryOperator_9175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127266(VarCurr)
    <=> v101505(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16431,axiom,
    ! [VarCurr: state_type] :
      ( v127250(VarCurr)
    <=> ( v127251(VarCurr)
        & v127257(VarCurr) ) ) ).

tff(writeUnaryOperator_9174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127257(VarCurr)
    <=> v127258(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16430,axiom,
    ! [VarCurr: state_type] :
      ( v127258(VarCurr)
    <=> ( v127259(VarCurr)
        & v127262(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5725,axiom,
    ! [VarCurr: state_type] :
      ( v127262(VarCurr)
    <=> ( v101505(VarCurr,4)
        | v103117(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16429,axiom,
    ! [VarCurr: state_type] :
      ( v127259(VarCurr)
    <=> ( v127260(VarCurr)
        | v127261(VarCurr) ) ) ).

tff(writeUnaryOperator_9173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127261(VarCurr)
    <=> v103117(VarCurr,4) ) ).

tff(writeUnaryOperator_9172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127260(VarCurr)
    <=> v101505(VarCurr,4) ) ).

tff(writeUnaryOperator_9171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127251(VarCurr)
    <=> v127252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16428,axiom,
    ! [VarCurr: state_type] :
      ( v127252(VarCurr)
    <=> ( v127253(VarCurr)
        & v127256(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5724,axiom,
    ! [VarCurr: state_type] :
      ( v127256(VarCurr)
    <=> ( v101505(VarCurr,3)
        | v103117(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16427,axiom,
    ! [VarCurr: state_type] :
      ( v127253(VarCurr)
    <=> ( v127254(VarCurr)
        | v127255(VarCurr) ) ) ).

tff(writeUnaryOperator_9170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127255(VarCurr)
    <=> v103117(VarCurr,3) ) ).

tff(writeUnaryOperator_9169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127254(VarCurr)
    <=> v101505(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5723,axiom,
    ! [VarCurr: state_type] :
      ( v127225(VarCurr)
    <=> ( v127226(VarCurr)
        & v100209(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16426,axiom,
    ! [VarCurr: state_type] :
      ( v127226(VarCurr)
    <=> ( v127227(VarCurr)
        & v127244(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16425,axiom,
    ! [VarCurr: state_type] :
      ( v127244(VarCurr)
    <=> ( v127245(VarCurr)
        | v127246(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1253,axiom,
    ! [VarCurr: state_type] :
      ( v127246(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v103117(VarCurr,6) )
        & ( v110754(VarCurr,2)
        <=> v103117(VarCurr,5) )
        & ( v110754(VarCurr,1)
        <=> v103117(VarCurr,4) )
        & ( v110754(VarCurr,0)
        <=> v103117(VarCurr,3) ) ) ) ).

tff(writeUnaryOperator_9168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127245(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5722,axiom,
    ! [VarCurr: state_type] :
      ( v127227(VarCurr)
    <=> ( v127229(VarCurr)
        | v127243(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5721,axiom,
    ! [VarCurr: state_type] :
      ( v127229(VarCurr)
    <=> ( v127230(VarCurr)
        | v127243(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5720,axiom,
    ! [VarCurr: state_type] :
      ( v127230(VarCurr)
    <=> ( v127231(VarCurr)
        | v127243(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5719,axiom,
    ! [VarCurr: state_type] :
      ( v127231(VarCurr)
    <=> ( v127232(VarCurr)
        | v127243(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5718,axiom,
    ! [VarCurr: state_type] :
      ( v127232(VarCurr)
    <=> ( v127233(VarCurr)
        | v127243(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5717,axiom,
    ! [VarCurr: state_type] :
      ( v127233(VarCurr)
    <=> ( v127234(VarCurr)
        | v127243(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5716,axiom,
    ! [VarCurr: state_type] :
      ( v127234(VarCurr)
    <=> ( v127235(VarCurr)
        | v127243(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5715,axiom,
    ! [VarCurr: state_type] :
      ( v127235(VarCurr)
    <=> ( v127236(VarCurr)
        | v127243(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5714,axiom,
    ! [VarCurr: state_type] :
      ( v127236(VarCurr)
    <=> ( v127237(VarCurr)
        | v127243(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5713,axiom,
    ! [VarCurr: state_type] :
      ( v127237(VarCurr)
    <=> ( v127238(VarCurr)
        | v127243(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5712,axiom,
    ! [VarCurr: state_type] :
      ( v127238(VarCurr)
    <=> ( v127239(VarCurr)
        | v127243(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5711,axiom,
    ! [VarCurr: state_type] :
      ( v127239(VarCurr)
    <=> ( v127240(VarCurr)
        | v127243(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5710,axiom,
    ! [VarCurr: state_type] :
      ( v127240(VarCurr)
    <=> ( v127241(VarCurr)
        | v127243(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5709,axiom,
    ! [VarCurr: state_type] :
      ( v127241(VarCurr)
    <=> ( v127242(VarCurr)
        | v127243(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5708,axiom,
    ! [VarCurr: state_type] :
      ( v127242(VarCurr)
    <=> ( v127243(VarCurr,0)
        | v127243(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1677,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127243(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v100435(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5707,axiom,
    ! [VarCurr: state_type] :
      ( v100209(VarCurr,1)
    <=> ( v127184(VarCurr)
        & v127223(VarCurr) ) ) ).

tff(writeUnaryOperator_9167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127223(VarCurr)
    <=> v127180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16424,axiom,
    ! [VarCurr: state_type] :
      ( v127184(VarCurr)
    <=> ( v127185(VarCurr)
        & v127222(VarCurr) ) ) ).

tff(writeUnaryOperator_9166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127222(VarCurr)
    <=> v84297(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16423,axiom,
    ! [VarCurr: state_type] :
      ( v127185(VarCurr)
    <=> ( v127186(VarCurr)
        & v127221(VarCurr) ) ) ).

tff(writeUnaryOperator_9165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127221(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16422,axiom,
    ! [VarCurr: state_type] :
      ( v127186(VarCurr)
    <=> ( v127187(VarCurr)
        & v127220(VarCurr) ) ) ).

tff(writeUnaryOperator_9164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127220(VarCurr)
    <=> v112518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16421,axiom,
    ! [VarCurr: state_type] :
      ( v127187(VarCurr)
    <=> ( v127188(VarCurr)
        & v109663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16420,axiom,
    ! [VarCurr: state_type] :
      ( v127188(VarCurr)
    <=> ( v127189(VarCurr)
        & v127219(VarCurr) ) ) ).

tff(writeUnaryOperator_9163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127219(VarCurr)
    <=> v112483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16419,axiom,
    ! [VarCurr: state_type] :
      ( v127189(VarCurr)
    <=> ( v127190(VarCurr)
        & v127218(VarCurr) ) ) ).

tff(writeUnaryOperator_9162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127218(VarCurr)
    <=> v111693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16418,axiom,
    ! [VarCurr: state_type] :
      ( v127190(VarCurr)
    <=> ( v127191(VarCurr)
        & v127214(VarCurr) ) ) ).

tff(writeUnaryOperator_9161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127214(VarCurr)
    <=> v127215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16417,axiom,
    ! [VarCurr: state_type] :
      ( v127215(VarCurr)
    <=> ( v127216(VarCurr)
        | v111651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16416,axiom,
    ! [VarCurr: state_type] :
      ( v127216(VarCurr)
    <=> ( v127217(VarCurr)
        | v110848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16415,axiom,
    ! [VarCurr: state_type] :
      ( v127217(VarCurr)
    <=> ( v110830(VarCurr)
        | v110840(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16414,axiom,
    ! [VarCurr: state_type] :
      ( v127191(VarCurr)
    <=> ( v127192(VarCurr)
        & v127211(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16413,axiom,
    ! [VarCurr: state_type] :
      ( v127211(VarCurr)
    <=> ( v127212(VarCurr)
        | v127213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1252,axiom,
    ! [VarCurr: state_type] :
      ( v127213(VarCurr)
    <=> ( ( v110754(VarCurr,3)
        <=> v101505(VarCurr,6) )
        & ( v110754(VarCurr,2)
        <=> v101505(VarCurr,5) )
        & ( v110754(VarCurr,1)
        <=> v101505(VarCurr,4) )
        & ( v110754(VarCurr,0)
        <=> v101505(VarCurr,3) ) ) ) ).

tff(writeUnaryOperator_9160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127212(VarCurr)
    <=> v108869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16412,axiom,
    ! [VarCurr: state_type] :
      ( v127192(VarCurr)
    <=> ( v127193(VarCurr)
        & v127194(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5706,axiom,
    ! [VarCurr: state_type] :
      ( v127194(VarCurr)
    <=> ( v127196(VarCurr)
        | v127210(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5705,axiom,
    ! [VarCurr: state_type] :
      ( v127196(VarCurr)
    <=> ( v127197(VarCurr)
        | v127210(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5704,axiom,
    ! [VarCurr: state_type] :
      ( v127197(VarCurr)
    <=> ( v127198(VarCurr)
        | v127210(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5703,axiom,
    ! [VarCurr: state_type] :
      ( v127198(VarCurr)
    <=> ( v127199(VarCurr)
        | v127210(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5702,axiom,
    ! [VarCurr: state_type] :
      ( v127199(VarCurr)
    <=> ( v127200(VarCurr)
        | v127210(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5701,axiom,
    ! [VarCurr: state_type] :
      ( v127200(VarCurr)
    <=> ( v127201(VarCurr)
        | v127210(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5700,axiom,
    ! [VarCurr: state_type] :
      ( v127201(VarCurr)
    <=> ( v127202(VarCurr)
        | v127210(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5699,axiom,
    ! [VarCurr: state_type] :
      ( v127202(VarCurr)
    <=> ( v127203(VarCurr)
        | v127210(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5698,axiom,
    ! [VarCurr: state_type] :
      ( v127203(VarCurr)
    <=> ( v127204(VarCurr)
        | v127210(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5697,axiom,
    ! [VarCurr: state_type] :
      ( v127204(VarCurr)
    <=> ( v127205(VarCurr)
        | v127210(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5696,axiom,
    ! [VarCurr: state_type] :
      ( v127205(VarCurr)
    <=> ( v127206(VarCurr)
        | v127210(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5695,axiom,
    ! [VarCurr: state_type] :
      ( v127206(VarCurr)
    <=> ( v127207(VarCurr)
        | v127210(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5694,axiom,
    ! [VarCurr: state_type] :
      ( v127207(VarCurr)
    <=> ( v127208(VarCurr)
        | v127210(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5693,axiom,
    ! [VarCurr: state_type] :
      ( v127208(VarCurr)
    <=> ( v127209(VarCurr)
        | v127210(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5692,axiom,
    ! [VarCurr: state_type] :
      ( v127209(VarCurr)
    <=> ( v127210(VarCurr,0)
        | v127210(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v127210(VarCurr,B)
      <=> ( v76(VarCurr,B)
          & v100211(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127193(VarCurr)
    <=> v100209(VarCurr,0) ) ).

tff(addAssignment_71550,axiom,
    ! [VarCurr: state_type] :
      ( v127180(VarCurr)
    <=> v127182(VarCurr) ) ).

tff(addAssignment_71549,axiom,
    ! [VarCurr: state_type] :
      ( v127182(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16411,axiom,
    ! [VarCurr: state_type] :
      ( v112518(VarCurr)
    <=> ( v112520(VarCurr)
        | v112751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16410,axiom,
    ! [VarCurr: state_type] :
      ( v112520(VarCurr)
    <=> ( v127097(VarCurr)
        & v127160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16409,axiom,
    ! [VarCurr: state_type] :
      ( v127160(VarCurr)
    <=> ( v127161(VarCurr)
        | v127162(VarCurr) ) ) ).

tff(writeUnaryOperator_9158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127162(VarCurr)
    <=> v127164(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16408,axiom,
    ! [VarCurr: state_type] :
      ( v127164(VarCurr)
    <=> ( v127165(VarCurr)
        & v127174(VarCurr) ) ) ).

tff(writeUnaryOperator_9157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127174(VarCurr)
    <=> v127175(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16407,axiom,
    ! [VarCurr: state_type] :
      ( v127175(VarCurr)
    <=> ( v127176(VarCurr)
        & v127177(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5691,axiom,
    ! [VarCurr: state_type] :
      ( v127177(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v127080(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16406,axiom,
    ! [VarCurr: state_type] :
      ( v127176(VarCurr)
    <=> ( v88904(VarCurr)
        | v127138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16405,axiom,
    ! [VarCurr: state_type] :
      ( v127165(VarCurr)
    <=> ( v127166(VarCurr)
        & v127170(VarCurr) ) ) ).

tff(writeUnaryOperator_9156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127170(VarCurr)
    <=> v127171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16404,axiom,
    ! [VarCurr: state_type] :
      ( v127171(VarCurr)
    <=> ( v127172(VarCurr)
        & v127173(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5690,axiom,
    ! [VarCurr: state_type] :
      ( v127173(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v127080(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16403,axiom,
    ! [VarCurr: state_type] :
      ( v127172(VarCurr)
    <=> ( v88897(VarCurr)
        | v127133(VarCurr) ) ) ).

tff(writeUnaryOperator_9155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127166(VarCurr)
    <=> v127167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16402,axiom,
    ! [VarCurr: state_type] :
      ( v127167(VarCurr)
    <=> ( v127168(VarCurr)
        & v127169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16401,axiom,
    ! [VarCurr: state_type] :
      ( v127169(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v127080(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16400,axiom,
    ! [VarCurr: state_type] :
      ( v127168(VarCurr)
    <=> ( v88915(VarCurr)
        | v127128(VarCurr) ) ) ).

tff(writeUnaryOperator_9154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127161(VarCurr)
    <=> v84295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16399,axiom,
    ! [VarCurr: state_type] :
      ( v127097(VarCurr)
    <=> ( v127098(VarCurr)
        & v127140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16398,axiom,
    ! [VarCurr: state_type] :
      ( v127140(VarCurr)
    <=> ( v127141(VarCurr)
        | v127144(VarCurr) ) ) ).

tff(writeUnaryOperator_9153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127144(VarCurr)
    <=> v127146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16397,axiom,
    ! [VarCurr: state_type] :
      ( v127146(VarCurr)
    <=> ( v127147(VarCurr)
        & v127156(VarCurr) ) ) ).

tff(writeUnaryOperator_9152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127156(VarCurr)
    <=> v127157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16396,axiom,
    ! [VarCurr: state_type] :
      ( v127157(VarCurr)
    <=> ( v127158(VarCurr)
        & v127159(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5689,axiom,
    ! [VarCurr: state_type] :
      ( v127159(VarCurr)
    <=> ( v126777(VarCurr,2)
        | v127080(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16395,axiom,
    ! [VarCurr: state_type] :
      ( v127158(VarCurr)
    <=> ( v126958(VarCurr)
        | v127138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16394,axiom,
    ! [VarCurr: state_type] :
      ( v127147(VarCurr)
    <=> ( v127148(VarCurr)
        & v127152(VarCurr) ) ) ).

tff(writeUnaryOperator_9151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127152(VarCurr)
    <=> v127153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16393,axiom,
    ! [VarCurr: state_type] :
      ( v127153(VarCurr)
    <=> ( v127154(VarCurr)
        & v127155(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5688,axiom,
    ! [VarCurr: state_type] :
      ( v127155(VarCurr)
    <=> ( v126777(VarCurr,1)
        | v127080(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16392,axiom,
    ! [VarCurr: state_type] :
      ( v127154(VarCurr)
    <=> ( v126953(VarCurr)
        | v127133(VarCurr) ) ) ).

tff(writeUnaryOperator_9150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127148(VarCurr)
    <=> v127149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16391,axiom,
    ! [VarCurr: state_type] :
      ( v127149(VarCurr)
    <=> ( v127150(VarCurr)
        & v127151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16390,axiom,
    ! [VarCurr: state_type] :
      ( v127151(VarCurr)
    <=> ( v126777(VarCurr,0)
        | v127080(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16389,axiom,
    ! [VarCurr: state_type] :
      ( v127150(VarCurr)
    <=> ( v126948(VarCurr)
        | v127128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16388,axiom,
    ! [VarCurr: state_type] :
      ( v127141(VarCurr)
    <=> ( v127142(VarCurr)
        & v127143(VarCurr) ) ) ).

tff(writeUnaryOperator_9149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127143(VarCurr)
    <=> v126767(VarCurr) ) ).

tff(writeUnaryOperator_9148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127142(VarCurr)
    <=> v112483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16387,axiom,
    ! [VarCurr: state_type] :
      ( v127098(VarCurr)
    <=> ( v127099(VarCurr)
        & v127117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16386,axiom,
    ! [VarCurr: state_type] :
      ( v127117(VarCurr)
    <=> ( v127118(VarCurr)
        | v127121(VarCurr) ) ) ).

tff(writeUnaryOperator_9147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127121(VarCurr)
    <=> v127123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16385,axiom,
    ! [VarCurr: state_type] :
      ( v127123(VarCurr)
    <=> ( v127124(VarCurr)
        & v127135(VarCurr) ) ) ).

tff(writeUnaryOperator_9146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127135(VarCurr)
    <=> v127136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16384,axiom,
    ! [VarCurr: state_type] :
      ( v127136(VarCurr)
    <=> ( v127137(VarCurr)
        & v127139(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5687,axiom,
    ! [VarCurr: state_type] :
      ( v127139(VarCurr)
    <=> ( v126737(VarCurr,2)
        | v127080(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16383,axiom,
    ! [VarCurr: state_type] :
      ( v127137(VarCurr)
    <=> ( v126934(VarCurr)
        | v127138(VarCurr) ) ) ).

tff(writeUnaryOperator_9145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127138(VarCurr)
    <=> v127080(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16382,axiom,
    ! [VarCurr: state_type] :
      ( v127124(VarCurr)
    <=> ( v127125(VarCurr)
        & v127130(VarCurr) ) ) ).

tff(writeUnaryOperator_9144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127130(VarCurr)
    <=> v127131(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16381,axiom,
    ! [VarCurr: state_type] :
      ( v127131(VarCurr)
    <=> ( v127132(VarCurr)
        & v127134(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5686,axiom,
    ! [VarCurr: state_type] :
      ( v127134(VarCurr)
    <=> ( v126737(VarCurr,1)
        | v127080(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16380,axiom,
    ! [VarCurr: state_type] :
      ( v127132(VarCurr)
    <=> ( v126928(VarCurr)
        | v127133(VarCurr) ) ) ).

tff(writeUnaryOperator_9143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127133(VarCurr)
    <=> v127080(VarCurr,1) ) ).

tff(writeUnaryOperator_9142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127125(VarCurr)
    <=> v127126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16379,axiom,
    ! [VarCurr: state_type] :
      ( v127126(VarCurr)
    <=> ( v127127(VarCurr)
        & v127129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16378,axiom,
    ! [VarCurr: state_type] :
      ( v127129(VarCurr)
    <=> ( v126737(VarCurr,0)
        | v127080(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16377,axiom,
    ! [VarCurr: state_type] :
      ( v127127(VarCurr)
    <=> ( v126922(VarCurr)
        | v127128(VarCurr) ) ) ).

tff(writeUnaryOperator_9141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127128(VarCurr)
    <=> v127080(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16376,axiom,
    ! [VarCurr: state_type] :
      ( v127118(VarCurr)
    <=> ( v127119(VarCurr)
        & v127120(VarCurr) ) ) ).

tff(writeUnaryOperator_9140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127120(VarCurr)
    <=> v126727(VarCurr) ) ).

tff(writeUnaryOperator_9139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127119(VarCurr)
    <=> v2878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16375,axiom,
    ! [VarCurr: state_type] :
      ( v127099(VarCurr)
    <=> ( v127100(VarCurr)
        & v127116(VarCurr) ) ) ).

tff(writeUnaryOperator_9138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127116(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5685,axiom,
    ! [VarCurr: state_type] :
      ( v127100(VarCurr)
    <=> ( v127102(VarCurr)
        | v112522(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5684,axiom,
    ! [VarCurr: state_type] :
      ( v127102(VarCurr)
    <=> ( v127103(VarCurr)
        | v112522(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5683,axiom,
    ! [VarCurr: state_type] :
      ( v127103(VarCurr)
    <=> ( v127104(VarCurr)
        | v112522(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5682,axiom,
    ! [VarCurr: state_type] :
      ( v127104(VarCurr)
    <=> ( v127105(VarCurr)
        | v112522(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5681,axiom,
    ! [VarCurr: state_type] :
      ( v127105(VarCurr)
    <=> ( v127106(VarCurr)
        | v112522(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5680,axiom,
    ! [VarCurr: state_type] :
      ( v127106(VarCurr)
    <=> ( v127107(VarCurr)
        | v112522(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5679,axiom,
    ! [VarCurr: state_type] :
      ( v127107(VarCurr)
    <=> ( v127108(VarCurr)
        | v112522(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5678,axiom,
    ! [VarCurr: state_type] :
      ( v127108(VarCurr)
    <=> ( v127109(VarCurr)
        | v112522(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5677,axiom,
    ! [VarCurr: state_type] :
      ( v127109(VarCurr)
    <=> ( v127110(VarCurr)
        | v112522(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5676,axiom,
    ! [VarCurr: state_type] :
      ( v127110(VarCurr)
    <=> ( v127111(VarCurr)
        | v112522(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5675,axiom,
    ! [VarCurr: state_type] :
      ( v127111(VarCurr)
    <=> ( v127112(VarCurr)
        | v112522(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5674,axiom,
    ! [VarCurr: state_type] :
      ( v127112(VarCurr)
    <=> ( v127113(VarCurr)
        | v112522(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5673,axiom,
    ! [VarCurr: state_type] :
      ( v127113(VarCurr)
    <=> ( v127114(VarCurr)
        | v112522(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5672,axiom,
    ! [VarCurr: state_type] :
      ( v127114(VarCurr)
    <=> ( v127115(VarCurr)
        | v112522(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5671,axiom,
    ! [VarCurr: state_type] :
      ( v127115(VarCurr)
    <=> ( v112522(VarCurr,0)
        | v112522(VarCurr,1) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127080(VarCurr,B)
          <=> v127082(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1224,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127080(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127082(VarCurr,B)
          <=> v127083(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1223,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127082(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127083(VarCurr,B)
          <=> v127084(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1222,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127083(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127084(VarCurr,B)
          <=> v127085(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1221,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127084(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127085(VarCurr,B)
          <=> v127086(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1220,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127085(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127086(VarCurr,B)
          <=> v127087(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1219,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127086(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127087(VarCurr,B)
          <=> v127088(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1218,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127087(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127088(VarCurr,B)
          <=> v127089(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1217,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127088(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127089(VarCurr,B)
          <=> v127090(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1216,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127089(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127090(VarCurr,B)
          <=> v127091(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1215,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127090(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127091(VarCurr,B)
          <=> v127092(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1214,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127091(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127092(VarCurr,B)
          <=> v127093(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1213,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127092(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127093(VarCurr,B)
          <=> v127094(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1212,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127093(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127094(VarCurr,B)
          <=> v127095(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1211,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127094(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127095(VarCurr,B)
          <=> $true ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1210,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v127095(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(addAssignment_71548,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,15)
    <=> v127077(VarCurr) ) ).

tff(addAssignment_71547,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,14)
    <=> v127074(VarCurr) ) ).

tff(addAssignment_71546,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,13)
    <=> v127071(VarCurr) ) ).

tff(addAssignment_71545,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,12)
    <=> v127068(VarCurr) ) ).

tff(addAssignment_71544,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,11)
    <=> v127065(VarCurr) ) ).

tff(addAssignment_71543,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,10)
    <=> v127062(VarCurr) ) ).

tff(addAssignment_71542,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,9)
    <=> v127059(VarCurr) ) ).

tff(addAssignment_71541,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,8)
    <=> v127056(VarCurr) ) ).

tff(addAssignment_71540,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,7)
    <=> v127053(VarCurr) ) ).

tff(addAssignment_71539,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,6)
    <=> v127050(VarCurr) ) ).

tff(addAssignment_71538,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,5)
    <=> v127047(VarCurr) ) ).

tff(addAssignment_71537,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,4)
    <=> v127044(VarCurr) ) ).

tff(addAssignment_71536,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,3)
    <=> v127041(VarCurr) ) ).

tff(addAssignment_71535,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,2)
    <=> v127038(VarCurr) ) ).

tff(addAssignment_71534,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,1)
    <=> v127035(VarCurr) ) ).

tff(addAssignment_71533,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,0)
    <=> v112524(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5670,axiom,
    ! [VarCurr: state_type] :
      ( v127077(VarCurr)
    <=> ( v125928(VarCurr,3)
        & v126574(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5669,axiom,
    ! [VarCurr: state_type] :
      ( v127074(VarCurr)
    <=> ( v125127(VarCurr,3)
        & v125773(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5668,axiom,
    ! [VarCurr: state_type] :
      ( v127071(VarCurr)
    <=> ( v124326(VarCurr,3)
        & v124972(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5667,axiom,
    ! [VarCurr: state_type] :
      ( v127068(VarCurr)
    <=> ( v123525(VarCurr,3)
        & v124171(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5666,axiom,
    ! [VarCurr: state_type] :
      ( v127065(VarCurr)
    <=> ( v122724(VarCurr,3)
        & v123370(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5665,axiom,
    ! [VarCurr: state_type] :
      ( v127062(VarCurr)
    <=> ( v121923(VarCurr,3)
        & v122569(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5664,axiom,
    ! [VarCurr: state_type] :
      ( v127059(VarCurr)
    <=> ( v121122(VarCurr,3)
        & v121768(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5663,axiom,
    ! [VarCurr: state_type] :
      ( v127056(VarCurr)
    <=> ( v120320(VarCurr,3)
        & v120967(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5662,axiom,
    ! [VarCurr: state_type] :
      ( v127053(VarCurr)
    <=> ( v119519(VarCurr,3)
        & v120165(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5661,axiom,
    ! [VarCurr: state_type] :
      ( v127050(VarCurr)
    <=> ( v118718(VarCurr,3)
        & v119364(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5660,axiom,
    ! [VarCurr: state_type] :
      ( v127047(VarCurr)
    <=> ( v117917(VarCurr,3)
        & v118563(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5659,axiom,
    ! [VarCurr: state_type] :
      ( v127044(VarCurr)
    <=> ( v117116(VarCurr,3)
        & v117762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5658,axiom,
    ! [VarCurr: state_type] :
      ( v127041(VarCurr)
    <=> ( v116309(VarCurr,3)
        & v116961(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5657,axiom,
    ! [VarCurr: state_type] :
      ( v127038(VarCurr)
    <=> ( v115502(VarCurr,3)
        & v116154(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5656,axiom,
    ! [VarCurr: state_type] :
      ( v127035(VarCurr)
    <=> ( v114489(VarCurr,3)
        & v115347(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5655,axiom,
    ! [VarCurr: state_type] :
      ( v112524(VarCurr)
    <=> ( v85714(VarCurr,3)
        & v112803(VarCurr) ) ) ).

tff(addAssignment_71532,axiom,
    ! [VarCurr: state_type] :
      ( v85714(VarCurr,3)
    <=> v85718(VarCurr,3) ) ).

tff(addAssignment_71531,axiom,
    ! [VarCurr: state_type] :
      ( v85718(VarCurr,3)
    <=> v85720(VarCurr,3) ) ).

tff(addAssignment_71530,axiom,
    ! [VarNext: state_type] :
      ( v85720(VarNext,3)
    <=> v127026(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127027(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v127026(VarNext,B)
            <=> v85720(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1650,axiom,
    ! [VarNext: state_type] :
      ( v127027(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v127026(VarNext,B)
          <=> v112796(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127027(VarNext)
      <=> v127028(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127028(VarNext)
      <=> ( v127030(VarNext)
          & v112779(VarNext) ) ) ) ).

tff(writeUnaryOperator_9137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127030(VarNext)
      <=> v112790(VarNext) ) ) ).

tff(addAssignment_71529,axiom,
    ! [VarCurr: state_type] :
      ( v85738(VarCurr,3)
    <=> v85740(VarCurr,3) ) ).

tff(addAssignment_71528,axiom,
    ! [VarCurr: state_type] :
      ( v85740(VarCurr,3)
    <=> v85742(VarCurr,3) ) ).

tff(addAssignment_71527,axiom,
    ! [VarCurr: state_type] :
      ( v85742(VarCurr,3)
    <=> v112777(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_79,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127008(VarCurr)
     => ( v85746(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_108,axiom,
    ! [VarCurr: state_type] :
      ( v127008(VarCurr)
     => ( v85746(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16372,axiom,
    ! [VarCurr: state_type] :
      ( v127008(VarCurr)
    <=> ( v127009(VarCurr)
        | v127015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16371,axiom,
    ! [VarCurr: state_type] :
      ( v127015(VarCurr)
    <=> ( v127016(VarCurr)
        & v127017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16370,axiom,
    ! [VarCurr: state_type] :
      ( v127017(VarCurr)
    <=> ( v127018(VarCurr)
        & v127024(VarCurr) ) ) ).

tff(writeUnaryOperator_9136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127024(VarCurr)
    <=> v127014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16369,axiom,
    ! [VarCurr: state_type] :
      ( v127018(VarCurr)
    <=> ( v127019(VarCurr)
        & v127023(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1251,axiom,
    ! [VarCurr: state_type] :
      ( v127023(VarCurr)
    <=> ( $true
      <=> v85714(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127019(VarCurr)
    <=> v127020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16368,axiom,
    ! [VarCurr: state_type] :
      ( v127020(VarCurr)
    <=> ( v127021(VarCurr)
        | v112639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16367,axiom,
    ! [VarCurr: state_type] :
      ( v127021(VarCurr)
    <=> ( v127022(VarCurr)
        | v112829(VarCurr) ) ) ).

tff(writeUnaryOperator_9134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127022(VarCurr)
    <=> v112637(VarCurr) ) ).

tff(writeUnaryOperator_9133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127016(VarCurr)
    <=> v126997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16366,axiom,
    ! [VarCurr: state_type] :
      ( v127009(VarCurr)
    <=> ( v127010(VarCurr)
        & v127013(VarCurr) ) ) ).

tff(writeUnaryOperator_9132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127013(VarCurr)
    <=> v127014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16365,axiom,
    ! [VarCurr: state_type] :
      ( v127014(VarCurr)
    <=> ( v112761(VarCurr)
        | v112776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16364,axiom,
    ! [VarCurr: state_type] :
      ( v127010(VarCurr)
    <=> ( v127011(VarCurr)
        & v126997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16363,axiom,
    ! [VarCurr: state_type] :
      ( v127011(VarCurr)
    <=> ( v126991(VarCurr)
        & v127012(VarCurr) ) ) ).

tff(writeUnaryOperator_9131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v127012(VarCurr)
    <=> v126995(VarCurr) ) ).

tff(addAssignment_71526,axiom,
    ! [VarCurr: state_type] :
      ( v85714(VarCurr,2)
    <=> v85718(VarCurr,2) ) ).

tff(addAssignment_71525,axiom,
    ! [VarCurr: state_type] :
      ( v85718(VarCurr,2)
    <=> v85720(VarCurr,2) ) ).

tff(addAssignment_71524,axiom,
    ! [VarNext: state_type] :
      ( v85720(VarNext,2)
    <=> v127000(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127001(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v127000(VarNext,B)
            <=> v85720(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1649,axiom,
    ! [VarNext: state_type] :
      ( v127001(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v127000(VarNext,B)
          <=> v112796(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127001(VarNext)
      <=> v127002(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v127002(VarNext)
      <=> ( v127004(VarNext)
          & v112779(VarNext) ) ) ) ).

tff(writeUnaryOperator_9130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v127004(VarNext)
      <=> v112790(VarNext) ) ) ).

tff(addAssignment_71523,axiom,
    ! [VarCurr: state_type] :
      ( v85738(VarCurr,2)
    <=> v85740(VarCurr,2) ) ).

tff(addAssignment_71522,axiom,
    ! [VarCurr: state_type] :
      ( v85740(VarCurr,2)
    <=> v85742(VarCurr,2) ) ).

tff(addAssignment_71521,axiom,
    ! [VarCurr: state_type] :
      ( v85742(VarCurr,2)
    <=> v112777(VarCurr,2) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_78,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126979(VarCurr)
     => ( v85746(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_107,axiom,
    ! [VarCurr: state_type] :
      ( v126979(VarCurr)
     => ( v85746(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16360,axiom,
    ! [VarCurr: state_type] :
      ( v126979(VarCurr)
    <=> ( v126980(VarCurr)
        | v126985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16359,axiom,
    ! [VarCurr: state_type] :
      ( v126985(VarCurr)
    <=> ( v126986(VarCurr)
        & v126987(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16358,axiom,
    ! [VarCurr: state_type] :
      ( v126987(VarCurr)
    <=> ( v126988(VarCurr)
        & v126998(VarCurr) ) ) ).

tff(writeUnaryOperator_9129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126998(VarCurr)
    <=> v112761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16357,axiom,
    ! [VarCurr: state_type] :
      ( v126988(VarCurr)
    <=> ( v126989(VarCurr)
        & v126997(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1250,axiom,
    ! [VarCurr: state_type] :
      ( v126997(VarCurr)
    <=> ( $true
      <=> v85714(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16356,axiom,
    ! [VarCurr: state_type] :
      ( v126989(VarCurr)
    <=> ( v126990(VarCurr)
        & v126994(VarCurr) ) ) ).

tff(writeUnaryOperator_9128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126994(VarCurr)
    <=> v126995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16355,axiom,
    ! [VarCurr: state_type] :
      ( v126995(VarCurr)
    <=> ( v126996(VarCurr)
        | v112639(VarCurr) ) ) ).

tff(writeUnaryOperator_9127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126996(VarCurr)
    <=> v112637(VarCurr) ) ).

tff(writeUnaryOperator_9126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126990(VarCurr)
    <=> v126991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16354,axiom,
    ! [VarCurr: state_type] :
      ( v126991(VarCurr)
    <=> ( v126992(VarCurr)
        | v126993(VarCurr) ) ) ).

tff(writeUnaryOperator_9125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126993(VarCurr)
    <=> v112526(VarCurr) ) ).

tff(writeUnaryOperator_9124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126992(VarCurr)
    <=> v85748(VarCurr) ) ).

tff(writeUnaryOperator_9123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126986(VarCurr)
    <=> v112776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16353,axiom,
    ! [VarCurr: state_type] :
      ( v126980(VarCurr)
    <=> ( v126981(VarCurr)
        & v126984(VarCurr) ) ) ).

tff(writeUnaryOperator_9122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126984(VarCurr)
    <=> v112761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16352,axiom,
    ! [VarCurr: state_type] :
      ( v126981(VarCurr)
    <=> ( v126982(VarCurr)
        & v112776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16351,axiom,
    ! [VarCurr: state_type] :
      ( v126982(VarCurr)
    <=> ( v112641(VarCurr)
        & v126983(VarCurr) ) ) ).

tff(writeUnaryOperator_9121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126983(VarCurr)
    <=> v112768(VarCurr) ) ).

tff(addAssignment_71520,axiom,
    ! [VarCurr: state_type] :
      ( v112641(VarCurr)
    <=> v112643(VarCurr,0) ) ).

tff(addAssignment_71519,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,0)
    <=> v115202(VarCurr,0) ) ).

tff(addAssignment_71518,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,0)
    <=> v115186(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16350,axiom,
    ! [VarCurr: state_type] :
      ( v112751(VarCurr)
    <=> ( v126891(VarCurr)
        & v126960(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16349,axiom,
    ! [VarCurr: state_type] :
      ( v126960(VarCurr)
    <=> ( v126961(VarCurr)
        | v126962(VarCurr) ) ) ).

tff(writeUnaryOperator_9120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126962(VarCurr)
    <=> v126964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16348,axiom,
    ! [VarCurr: state_type] :
      ( v126964(VarCurr)
    <=> ( v126965(VarCurr)
        & v126974(VarCurr) ) ) ).

tff(writeUnaryOperator_9119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126974(VarCurr)
    <=> v126975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16347,axiom,
    ! [VarCurr: state_type] :
      ( v126975(VarCurr)
    <=> ( v126976(VarCurr)
        & v126977(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5654,axiom,
    ! [VarCurr: state_type] :
      ( v126977(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v126750(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16346,axiom,
    ! [VarCurr: state_type] :
      ( v126976(VarCurr)
    <=> ( v88904(VarCurr)
        | v126935(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16345,axiom,
    ! [VarCurr: state_type] :
      ( v126965(VarCurr)
    <=> ( v126966(VarCurr)
        & v126970(VarCurr) ) ) ).

tff(writeUnaryOperator_9118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126970(VarCurr)
    <=> v126971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16344,axiom,
    ! [VarCurr: state_type] :
      ( v126971(VarCurr)
    <=> ( v126972(VarCurr)
        & v126973(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5653,axiom,
    ! [VarCurr: state_type] :
      ( v126973(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v126750(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16343,axiom,
    ! [VarCurr: state_type] :
      ( v126972(VarCurr)
    <=> ( v88897(VarCurr)
        | v126929(VarCurr) ) ) ).

tff(writeUnaryOperator_9117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126966(VarCurr)
    <=> v126967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16342,axiom,
    ! [VarCurr: state_type] :
      ( v126967(VarCurr)
    <=> ( v126968(VarCurr)
        & v126969(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16341,axiom,
    ! [VarCurr: state_type] :
      ( v126969(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v126750(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16340,axiom,
    ! [VarCurr: state_type] :
      ( v126968(VarCurr)
    <=> ( v88915(VarCurr)
        | v126923(VarCurr) ) ) ).

tff(writeUnaryOperator_9116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126961(VarCurr)
    <=> v84295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16339,axiom,
    ! [VarCurr: state_type] :
      ( v126891(VarCurr)
    <=> ( v126892(VarCurr)
        & v126937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16338,axiom,
    ! [VarCurr: state_type] :
      ( v126937(VarCurr)
    <=> ( v126938(VarCurr)
        | v126941(VarCurr) ) ) ).

tff(writeUnaryOperator_9115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126941(VarCurr)
    <=> v126943(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16337,axiom,
    ! [VarCurr: state_type] :
      ( v126943(VarCurr)
    <=> ( v126944(VarCurr)
        & v126955(VarCurr) ) ) ).

tff(writeUnaryOperator_9114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126955(VarCurr)
    <=> v126956(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16336,axiom,
    ! [VarCurr: state_type] :
      ( v126956(VarCurr)
    <=> ( v126957(VarCurr)
        & v126959(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5652,axiom,
    ! [VarCurr: state_type] :
      ( v126959(VarCurr)
    <=> ( v126750(VarCurr,2)
        | v126777(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16335,axiom,
    ! [VarCurr: state_type] :
      ( v126957(VarCurr)
    <=> ( v126935(VarCurr)
        | v126958(VarCurr) ) ) ).

tff(writeUnaryOperator_9113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126958(VarCurr)
    <=> v126777(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16334,axiom,
    ! [VarCurr: state_type] :
      ( v126944(VarCurr)
    <=> ( v126945(VarCurr)
        & v126950(VarCurr) ) ) ).

tff(writeUnaryOperator_9112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126950(VarCurr)
    <=> v126951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16333,axiom,
    ! [VarCurr: state_type] :
      ( v126951(VarCurr)
    <=> ( v126952(VarCurr)
        & v126954(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5651,axiom,
    ! [VarCurr: state_type] :
      ( v126954(VarCurr)
    <=> ( v126750(VarCurr,1)
        | v126777(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16332,axiom,
    ! [VarCurr: state_type] :
      ( v126952(VarCurr)
    <=> ( v126929(VarCurr)
        | v126953(VarCurr) ) ) ).

tff(writeUnaryOperator_9111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126953(VarCurr)
    <=> v126777(VarCurr,1) ) ).

tff(writeUnaryOperator_9110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126945(VarCurr)
    <=> v126946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16331,axiom,
    ! [VarCurr: state_type] :
      ( v126946(VarCurr)
    <=> ( v126947(VarCurr)
        & v126949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16330,axiom,
    ! [VarCurr: state_type] :
      ( v126949(VarCurr)
    <=> ( v126750(VarCurr,0)
        | v126777(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16329,axiom,
    ! [VarCurr: state_type] :
      ( v126947(VarCurr)
    <=> ( v126923(VarCurr)
        | v126948(VarCurr) ) ) ).

tff(writeUnaryOperator_9109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126948(VarCurr)
    <=> v126777(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16328,axiom,
    ! [VarCurr: state_type] :
      ( v126938(VarCurr)
    <=> ( v126939(VarCurr)
        & v126940(VarCurr) ) ) ).

tff(writeUnaryOperator_9108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126940(VarCurr)
    <=> v126767(VarCurr) ) ).

tff(writeUnaryOperator_9107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126939(VarCurr)
    <=> v112483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16327,axiom,
    ! [VarCurr: state_type] :
      ( v126892(VarCurr)
    <=> ( v126893(VarCurr)
        & v126911(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16326,axiom,
    ! [VarCurr: state_type] :
      ( v126911(VarCurr)
    <=> ( v126912(VarCurr)
        | v126915(VarCurr) ) ) ).

tff(writeUnaryOperator_9106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126915(VarCurr)
    <=> v126917(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16325,axiom,
    ! [VarCurr: state_type] :
      ( v126917(VarCurr)
    <=> ( v126918(VarCurr)
        & v126931(VarCurr) ) ) ).

tff(writeUnaryOperator_9105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126931(VarCurr)
    <=> v126932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16324,axiom,
    ! [VarCurr: state_type] :
      ( v126932(VarCurr)
    <=> ( v126933(VarCurr)
        & v126936(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5650,axiom,
    ! [VarCurr: state_type] :
      ( v126936(VarCurr)
    <=> ( v126737(VarCurr,2)
        | v126750(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16323,axiom,
    ! [VarCurr: state_type] :
      ( v126933(VarCurr)
    <=> ( v126934(VarCurr)
        | v126935(VarCurr) ) ) ).

tff(writeUnaryOperator_9104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126935(VarCurr)
    <=> v126750(VarCurr,2) ) ).

tff(writeUnaryOperator_9103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126934(VarCurr)
    <=> v126737(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16322,axiom,
    ! [VarCurr: state_type] :
      ( v126918(VarCurr)
    <=> ( v126919(VarCurr)
        & v126925(VarCurr) ) ) ).

tff(writeUnaryOperator_9102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126925(VarCurr)
    <=> v126926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16321,axiom,
    ! [VarCurr: state_type] :
      ( v126926(VarCurr)
    <=> ( v126927(VarCurr)
        & v126930(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5649,axiom,
    ! [VarCurr: state_type] :
      ( v126930(VarCurr)
    <=> ( v126737(VarCurr,1)
        | v126750(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16320,axiom,
    ! [VarCurr: state_type] :
      ( v126927(VarCurr)
    <=> ( v126928(VarCurr)
        | v126929(VarCurr) ) ) ).

tff(writeUnaryOperator_9101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126929(VarCurr)
    <=> v126750(VarCurr,1) ) ).

tff(writeUnaryOperator_9100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126928(VarCurr)
    <=> v126737(VarCurr,1) ) ).

tff(writeUnaryOperator_9099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126919(VarCurr)
    <=> v126920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16319,axiom,
    ! [VarCurr: state_type] :
      ( v126920(VarCurr)
    <=> ( v126921(VarCurr)
        & v126924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16318,axiom,
    ! [VarCurr: state_type] :
      ( v126924(VarCurr)
    <=> ( v126737(VarCurr,0)
        | v126750(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16317,axiom,
    ! [VarCurr: state_type] :
      ( v126921(VarCurr)
    <=> ( v126922(VarCurr)
        | v126923(VarCurr) ) ) ).

tff(writeUnaryOperator_9098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126923(VarCurr)
    <=> v126750(VarCurr,0) ) ).

tff(writeUnaryOperator_9097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126922(VarCurr)
    <=> v126737(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16316,axiom,
    ! [VarCurr: state_type] :
      ( v126912(VarCurr)
    <=> ( v126913(VarCurr)
        & v126914(VarCurr) ) ) ).

tff(writeUnaryOperator_9096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126914(VarCurr)
    <=> v126727(VarCurr) ) ).

tff(writeUnaryOperator_9095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126913(VarCurr)
    <=> v2878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16315,axiom,
    ! [VarCurr: state_type] :
      ( v126893(VarCurr)
    <=> ( v126894(VarCurr)
        & v126910(VarCurr) ) ) ).

tff(writeUnaryOperator_9094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126910(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5648,axiom,
    ! [VarCurr: state_type] :
      ( v126894(VarCurr)
    <=> ( v126896(VarCurr)
        | v112753(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5647,axiom,
    ! [VarCurr: state_type] :
      ( v126896(VarCurr)
    <=> ( v126897(VarCurr)
        | v112753(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5646,axiom,
    ! [VarCurr: state_type] :
      ( v126897(VarCurr)
    <=> ( v126898(VarCurr)
        | v112753(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5645,axiom,
    ! [VarCurr: state_type] :
      ( v126898(VarCurr)
    <=> ( v126899(VarCurr)
        | v112753(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5644,axiom,
    ! [VarCurr: state_type] :
      ( v126899(VarCurr)
    <=> ( v126900(VarCurr)
        | v112753(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5643,axiom,
    ! [VarCurr: state_type] :
      ( v126900(VarCurr)
    <=> ( v126901(VarCurr)
        | v112753(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5642,axiom,
    ! [VarCurr: state_type] :
      ( v126901(VarCurr)
    <=> ( v126902(VarCurr)
        | v112753(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5641,axiom,
    ! [VarCurr: state_type] :
      ( v126902(VarCurr)
    <=> ( v126903(VarCurr)
        | v112753(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5640,axiom,
    ! [VarCurr: state_type] :
      ( v126903(VarCurr)
    <=> ( v126904(VarCurr)
        | v112753(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5639,axiom,
    ! [VarCurr: state_type] :
      ( v126904(VarCurr)
    <=> ( v126905(VarCurr)
        | v112753(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5638,axiom,
    ! [VarCurr: state_type] :
      ( v126905(VarCurr)
    <=> ( v126906(VarCurr)
        | v112753(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5637,axiom,
    ! [VarCurr: state_type] :
      ( v126906(VarCurr)
    <=> ( v126907(VarCurr)
        | v112753(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5636,axiom,
    ! [VarCurr: state_type] :
      ( v126907(VarCurr)
    <=> ( v126908(VarCurr)
        | v112753(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5635,axiom,
    ! [VarCurr: state_type] :
      ( v126908(VarCurr)
    <=> ( v126909(VarCurr)
        | v112753(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5634,axiom,
    ! [VarCurr: state_type] :
      ( v126909(VarCurr)
    <=> ( v112753(VarCurr,0)
        | v112753(VarCurr,1) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126777(VarCurr,B)
          <=> v126889(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1209,axiom,
    ! [VarCurr: state_type] :
      ( v84295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126777(VarCurr,B)
          <=> v88372(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112483(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126889(VarCurr,B)
          <=> v126832(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1208,axiom,
    ! [VarCurr: state_type] :
      ( v112483(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126889(VarCurr,B)
          <=> v126779(VarCurr,B) ) ) ) ).

tff(addAssignment_71517,axiom,
    ! [VarCurr: state_type] :
      ( ( v126832(VarCurr,2)
      <=> v126834(VarCurr,5) )
      & ( v126832(VarCurr,1)
      <=> v126834(VarCurr,4) )
      & ( v126832(VarCurr,0)
      <=> v126834(VarCurr,3) ) ) ).

tff(addAssignment_71516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126834(VarCurr,B)
      <=> v126836(VarCurr,B) ) ) ).

tff(addAssignment_71515,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126836(VarNext,B)
      <=> v126871(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126872(VarNext)
       => ! [B: $int] :
            ( ( $less(B,18)
              & ~ $less(B,0) )
           => ( v126871(VarNext,B)
            <=> v126836(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1648,axiom,
    ! [VarNext: state_type] :
      ( v126872(VarNext)
     => ! [B: $int] :
          ( ( $less(B,18)
            & ~ $less(B,0) )
         => ( v126871(VarNext,B)
          <=> v126882(VarNext,B) ) ) ) ).

tff(addAssignment_71514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,18)
            & ~ $less(B,0) )
         => ( v126882(VarNext,B)
          <=> v126880(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126883(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,18)
            & ~ $less(B,0) )
         => ( v126880(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1207,axiom,
    ! [VarCurr: state_type] :
      ( v126883(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,18)
            & ~ $less(B,0) )
         => ( v126880(VarCurr,B)
          <=> v126846(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16314,axiom,
    ! [VarCurr: state_type] :
      ( v126883(VarCurr)
    <=> ( v126884(VarCurr)
        & v126885(VarCurr) ) ) ).

tff(writeUnaryOperator_9093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126885(VarCurr)
    <=> v126842(VarCurr) ) ).

tff(writeUnaryOperator_9092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126884(VarCurr)
    <=> v126838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126872(VarNext)
      <=> v126873(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126873(VarNext)
      <=> ( v126874(VarNext)
          & v126867(VarNext) ) ) ) ).

tff(writeUnaryOperator_9091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126874(VarNext)
      <=> v126876(VarNext) ) ) ).

tff(addAssignment_71513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126876(VarNext)
      <=> v126867(VarCurr) ) ) ).

tff(addAssignment_71512,axiom,
    ! [VarCurr: state_type] :
      ( v126867(VarCurr)
    <=> v126869(VarCurr) ) ).

tff(addAssignment_71511,axiom,
    ! [VarCurr: state_type] :
      ( v126869(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_71510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126846(VarCurr,B)
      <=> v126848(VarCurr,B) ) ) ).

tff(addAssignment_71509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126848(VarCurr,B)
      <=> v126857(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,18)
        & ~ $less(B,0) )
     => ( v126857(VarCurr,B)
      <=> ( v126858(VarCurr,B)
          | v126861(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,18)
        & ~ $less(B,0) )
     => ( v126861(VarCurr,B)
      <=> ( v126834(VarCurr,B)
          & v126862(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,18)
        & ~ $less(B,0) )
     => ( v126862(VarCurr,B)
      <=> ~ v126863(VarCurr,B) ) ) ).

tff(addAssignment_71508,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,0)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71507,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,1)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71506,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,2)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71505,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,3)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71504,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,4)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71503,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,5)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71502,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,6)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71501,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,7)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71500,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,8)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71499,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,9)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71498,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,10)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71497,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,11)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71496,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,12)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71495,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,13)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71494,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,14)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71493,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,15)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71492,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,16)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71491,axiom,
    ! [VarCurr: state_type] :
      ( v126863(VarCurr,17)
    <=> v126864(VarCurr) ) ).

tff(addAssignment_71490,axiom,
    ! [VarCurr: state_type] :
      ( v126864(VarCurr)
    <=> v126856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,18)
        & ~ $less(B,0) )
     => ( v126858(VarCurr,B)
      <=> ( v126850(VarCurr,B)
          & v126859(VarCurr,B) ) ) ) ).

tff(addAssignment_71489,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,0)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71488,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,1)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71487,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,2)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71486,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,3)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71485,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,4)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71484,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,5)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71483,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,6)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71482,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,7)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71481,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,8)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71480,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,9)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71479,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,10)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71478,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,11)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71477,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,12)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71476,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,13)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71475,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,14)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71474,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,15)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71473,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,16)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71472,axiom,
    ! [VarCurr: state_type] :
      ( v126859(VarCurr,17)
    <=> v126860(VarCurr) ) ).

tff(addAssignment_71471,axiom,
    ! [VarCurr: state_type] :
      ( v126860(VarCurr)
    <=> v126856(VarCurr) ) ).

tff(addAssignment_71470,axiom,
    ! [VarCurr: state_type] :
      ( v126856(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_71469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126850(VarCurr,B)
      <=> v126851(VarCurr,B) ) ) ).

tff(addAssignment_71468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v126851(VarCurr,B)
      <=> v126854(VarCurr,B) ) ) ).

tff(addAssignment_71467,axiom,
    ! [VarCurr: state_type] :
      ( ( v126851(VarCurr,5)
      <=> v126779(VarCurr,2) )
      & ( v126851(VarCurr,4)
      <=> v126779(VarCurr,1) )
      & ( v126851(VarCurr,3)
      <=> v126779(VarCurr,0) ) ) ).

tff(addAssignment_71466,axiom,
    ! [VarCurr: state_type] :
      ( v126851(VarCurr,6)
    <=> v126853(VarCurr) ) ).

tff(addAssignment_71465,axiom,
    ! [VarCurr: state_type] :
      ( ( v126851(VarCurr,17)
      <=> v126852(VarCurr,10) )
      & ( v126851(VarCurr,16)
      <=> v126852(VarCurr,9) )
      & ( v126851(VarCurr,15)
      <=> v126852(VarCurr,8) )
      & ( v126851(VarCurr,14)
      <=> v126852(VarCurr,7) )
      & ( v126851(VarCurr,13)
      <=> v126852(VarCurr,6) )
      & ( v126851(VarCurr,12)
      <=> v126852(VarCurr,5) )
      & ( v126851(VarCurr,11)
      <=> v126852(VarCurr,4) )
      & ( v126851(VarCurr,10)
      <=> v126852(VarCurr,3) )
      & ( v126851(VarCurr,9)
      <=> v126852(VarCurr,2) )
      & ( v126851(VarCurr,8)
      <=> v126852(VarCurr,1) )
      & ( v126851(VarCurr,7)
      <=> v126852(VarCurr,0) ) ) ).

tff(addAssignment_71464,axiom,
    ! [VarCurr: state_type] :
      ( v126842(VarCurr)
    <=> v126844(VarCurr) ) ).

tff(addAssignment_71463,axiom,
    ! [VarCurr: state_type] :
      ( v126844(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_71462,axiom,
    ! [VarCurr: state_type] :
      ( v126838(VarCurr)
    <=> v126840(VarCurr) ) ).

tff(addAssignment_71461,axiom,
    ! [VarCurr: state_type] :
      ( v126840(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_71460,axiom,
    ! [VarCurr: state_type] :
      ( ( v126779(VarCurr,2)
      <=> v126781(VarCurr,5) )
      & ( v126779(VarCurr,1)
      <=> v126781(VarCurr,4) )
      & ( v126779(VarCurr,0)
      <=> v126781(VarCurr,3) ) ) ).

tff(addAssignment_71459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126781(VarCurr,B)
      <=> v126783(VarCurr,B) ) ) ).

tff(addAssignment_71458,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126783(VarNext,B)
      <=> v126814(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126815(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v126814(VarNext,B)
            <=> v126783(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1647,axiom,
    ! [VarNext: state_type] :
      ( v126815(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v126814(VarNext,B)
          <=> v126825(VarNext,B) ) ) ) ).

tff(addAssignment_71457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v126825(VarNext,B)
          <=> v126823(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126826(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v126823(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1206,axiom,
    ! [VarCurr: state_type] :
      ( v126826(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v126823(VarCurr,B)
          <=> v126793(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16311,axiom,
    ! [VarCurr: state_type] :
      ( v126826(VarCurr)
    <=> ( v126827(VarCurr)
        & v126828(VarCurr) ) ) ).

tff(writeUnaryOperator_9089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126828(VarCurr)
    <=> v126789(VarCurr) ) ).

tff(writeUnaryOperator_9088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126827(VarCurr)
    <=> v126785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126815(VarNext)
      <=> v126816(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126816(VarNext)
      <=> ( v126817(VarNext)
          & v126810(VarNext) ) ) ) ).

tff(writeUnaryOperator_9087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126817(VarNext)
      <=> v126819(VarNext) ) ) ).

tff(addAssignment_71456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126819(VarNext)
      <=> v126810(VarCurr) ) ) ).

tff(addAssignment_71455,axiom,
    ! [VarCurr: state_type] :
      ( v126810(VarCurr)
    <=> v126812(VarCurr) ) ).

tff(addAssignment_71454,axiom,
    ! [VarCurr: state_type] :
      ( v126812(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_71453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126793(VarCurr,B)
      <=> v126795(VarCurr,B) ) ) ).

tff(addAssignment_71452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126795(VarCurr,B)
      <=> v126801(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v126801(VarCurr,B)
      <=> ( v126802(VarCurr,B)
          | v126805(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v126805(VarCurr,B)
      <=> ( v126781(VarCurr,B)
          & v126806(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_9086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v126806(VarCurr,B)
      <=> ~ v126807(VarCurr,B) ) ) ).

tff(addAssignment_71451,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,0)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71450,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,1)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71449,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,2)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71448,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,3)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71447,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,4)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71446,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,5)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71445,axiom,
    ! [VarCurr: state_type] :
      ( v126807(VarCurr,6)
    <=> v126808(VarCurr) ) ).

tff(addAssignment_71444,axiom,
    ! [VarCurr: state_type] :
      ( v126808(VarCurr)
    <=> v126800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v126802(VarCurr,B)
      <=> ( v126797(VarCurr,B)
          & v126803(VarCurr,B) ) ) ) ).

tff(addAssignment_71443,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,0)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71442,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,1)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71441,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,2)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71440,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,3)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71439,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,4)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71438,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,5)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71437,axiom,
    ! [VarCurr: state_type] :
      ( v126803(VarCurr,6)
    <=> v126804(VarCurr) ) ).

tff(addAssignment_71436,axiom,
    ! [VarCurr: state_type] :
      ( v126804(VarCurr)
    <=> v126800(VarCurr) ) ).

tff(addAssignment_71435,axiom,
    ! [VarCurr: state_type] :
      ( v126800(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_71434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v126797(VarCurr,B)
      <=> v126798(VarCurr,B) ) ) ).

tff(addAssignment_71433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v126798(VarCurr,B)
      <=> v103106(VarCurr,B) ) ) ).

tff(addAssignment_71432,axiom,
    ! [VarCurr: state_type] :
      ( ( v126798(VarCurr,6)
      <=> v103106(VarCurr,7) )
      & ( v126798(VarCurr,5)
      <=> v103106(VarCurr,6) )
      & ( v126798(VarCurr,4)
      <=> v103106(VarCurr,5) )
      & ( v126798(VarCurr,3)
      <=> v103106(VarCurr,4) ) ) ).

tff(addAssignment_71431,axiom,
    ! [VarCurr: state_type] :
      ( v126789(VarCurr)
    <=> v126791(VarCurr) ) ).

tff(addAssignment_71430,axiom,
    ! [VarCurr: state_type] :
      ( v126791(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_71429,axiom,
    ! [VarCurr: state_type] :
      ( v126785(VarCurr)
    <=> v126787(VarCurr) ) ).

tff(addAssignment_71428,axiom,
    ! [VarCurr: state_type] :
      ( v126787(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_71427,axiom,
    ! [VarCurr: state_type] :
      ( v126767(VarCurr)
    <=> v112700(VarCurr,1) ) ).

tff(addAssignment_71426,axiom,
    ! [VarCurr: state_type] :
      ( v112700(VarCurr,1)
    <=> v112702(VarCurr,1) ) ).

tff(addAssignment_71425,axiom,
    ! [VarNext: state_type] :
      ( v112702(VarNext,1)
    <=> v126769(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126770(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v126769(VarNext,B)
            <=> v112702(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1646,axiom,
    ! [VarNext: state_type] :
      ( v126770(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126769(VarNext,B)
          <=> v112744(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126770(VarNext)
      <=> v126771(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126771(VarNext)
      <=> ( v126773(VarNext)
          & v112729(VarNext) ) ) ) ).

tff(writeUnaryOperator_9085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126773(VarNext)
      <=> v112738(VarNext) ) ) ).

tff(addAssignment_71424,axiom,
    ! [VarCurr: state_type] :
      ( v112712(VarCurr,1)
    <=> v112714(VarCurr,1) ) ).

tff(addAssignment_71423,axiom,
    ! [VarCurr: state_type] :
      ( v112714(VarCurr,1)
    <=> v112720(VarCurr,1) ) ).

tff(addAssignment_71422,axiom,
    ! [VarCurr: state_type] :
      ( v112716(VarCurr,1)
    <=> v112717(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126750(VarCurr,B)
          <=> v126752(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1205,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126750(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126752(VarCurr,B)
          <=> v126753(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1204,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126752(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126753(VarCurr,B)
          <=> v126754(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1203,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126753(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126754(VarCurr,B)
          <=> v126755(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1202,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126754(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126755(VarCurr,B)
          <=> v126756(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1201,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126755(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126756(VarCurr,B)
          <=> v126757(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1200,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126756(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126757(VarCurr,B)
          <=> v126758(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1199,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126757(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126758(VarCurr,B)
          <=> v126759(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1198,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126758(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126759(VarCurr,B)
          <=> v126760(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1197,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126759(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126760(VarCurr,B)
          <=> v126761(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1196,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126760(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126761(VarCurr,B)
          <=> v126762(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1195,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126761(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126762(VarCurr,B)
          <=> v126763(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1194,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126762(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126763(VarCurr,B)
          <=> v126764(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1193,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126763(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126764(VarCurr,B)
          <=> v126765(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1192,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126764(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126765(VarCurr,B)
          <=> $true ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1191,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126765(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126737(VarCurr,B)
          <=> v126739(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1190,axiom,
    ! [VarCurr: state_type] :
      ( v2878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126737(VarCurr,B)
          <=> v83013(VarCurr,B) ) ) ) ).

tff(addAssignment_71421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v126739(VarCurr,B)
      <=> v101574(VarCurr,B) ) ) ).

tff(addAssignment_71420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101574(VarCurr,B)
      <=> v101576(VarCurr,B) ) ) ).

tff(addAssignment_71419,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101576(VarNext,B)
      <=> v126741(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126742(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v126741(VarNext,B)
            <=> v101576(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1645,axiom,
    ! [VarNext: state_type] :
      ( v126742(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v126741(VarNext,B)
          <=> v102089(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126742(VarNext)
      <=> v126743(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126743(VarNext)
      <=> ( v126745(VarNext)
          & v102074(VarNext) ) ) ) ).

tff(writeUnaryOperator_9084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126745(VarNext)
      <=> v102083(VarNext) ) ) ).

tff(addAssignment_71418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101586(VarCurr,B)
      <=> v101588(VarCurr,B) ) ) ).

tff(addAssignment_71417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101588(VarCurr,B)
      <=> v102065(VarCurr,B) ) ) ).

tff(addAssignment_71416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101590(VarCurr,B)
      <=> v102062(VarCurr,B) ) ) ).

tff(addAssignment_71415,axiom,
    ! [VarCurr: state_type] :
      ( v126727(VarCurr)
    <=> v112700(VarCurr,2) ) ).

tff(addAssignment_71414,axiom,
    ! [VarCurr: state_type] :
      ( v112700(VarCurr,2)
    <=> v112702(VarCurr,2) ) ).

tff(addAssignment_71413,axiom,
    ! [VarNext: state_type] :
      ( v112702(VarNext,2)
    <=> v126729(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126730(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v126729(VarNext,B)
            <=> v112702(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1644,axiom,
    ! [VarNext: state_type] :
      ( v126730(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v126729(VarNext,B)
          <=> v112744(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126730(VarNext)
      <=> v126731(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126731(VarNext)
      <=> ( v126733(VarNext)
          & v112729(VarNext) ) ) ) ).

tff(writeUnaryOperator_9083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126733(VarNext)
      <=> v112738(VarNext) ) ) ).

tff(addAssignment_71412,axiom,
    ! [VarCurr: state_type] :
      ( v112712(VarCurr,2)
    <=> v112714(VarCurr,2) ) ).

tff(addAssignment_71411,axiom,
    ! [VarCurr: state_type] :
      ( v112714(VarCurr,2)
    <=> v112720(VarCurr,2) ) ).

tff(addAssignment_71410,axiom,
    ! [VarCurr: state_type] :
      ( v112716(VarCurr,2)
    <=> v112717(VarCurr,2) ) ).

tff(addAssignment_71409,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,15)
    <=> v125926(VarCurr) ) ).

tff(addAssignment_71408,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,14)
    <=> v125125(VarCurr) ) ).

tff(addAssignment_71407,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,13)
    <=> v124324(VarCurr) ) ).

tff(addAssignment_71406,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,12)
    <=> v123523(VarCurr) ) ).

tff(addAssignment_71405,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,11)
    <=> v122722(VarCurr) ) ).

tff(addAssignment_71404,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,10)
    <=> v121921(VarCurr) ) ).

tff(addAssignment_71403,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,9)
    <=> v121120(VarCurr) ) ).

tff(addAssignment_71402,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,8)
    <=> v120318(VarCurr) ) ).

tff(addAssignment_71401,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,7)
    <=> v119517(VarCurr) ) ).

tff(addAssignment_71400,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,6)
    <=> v118716(VarCurr) ) ).

tff(addAssignment_71399,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,5)
    <=> v117915(VarCurr) ) ).

tff(addAssignment_71398,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,4)
    <=> v117114(VarCurr) ) ).

tff(addAssignment_71397,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,3)
    <=> v116307(VarCurr) ) ).

tff(addAssignment_71396,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,2)
    <=> v115500(VarCurr) ) ).

tff(addAssignment_71395,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,1)
    <=> v114487(VarCurr) ) ).

tff(addAssignment_71394,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,0)
    <=> v112755(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16302,axiom,
    ! [VarCurr: state_type] :
      ( v125926(VarCurr)
    <=> ( v126725(VarCurr)
        & v126635(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5633,axiom,
    ! [VarCurr: state_type] :
      ( v126725(VarCurr)
    <=> ( v125928(VarCurr,1)
        & v126574(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1249,axiom,
    ! [VarCurr: state_type] :
      ( v126635(VarCurr)
    <=> ( ( v126637(VarCurr,4)
        <=> $false )
        & ( v126637(VarCurr,3)
        <=> $false )
        & ( v126637(VarCurr,2)
        <=> $false )
        & ( v126637(VarCurr,1)
        <=> $false )
        & ( v126637(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126637(VarCurr,B)
      <=> v126639(VarCurr,B) ) ) ).

tff(addAssignment_71392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126639(VarCurr,B)
      <=> v126641(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126707(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v126641(VarNext,B)
            <=> v126641(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1643,axiom,
    ! [VarNext: state_type] :
      ( v126707(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126641(VarNext,B)
          <=> v126717(VarNext,B) ) ) ) ).

tff(addAssignment_71391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126717(VarNext,B)
          <=> v126715(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126718(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126715(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1189,axiom,
    ! [VarCurr: state_type] :
      ( v126718(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126715(VarCurr,B)
          <=> v126651(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16301,axiom,
    ! [VarCurr: state_type] :
      ( v126718(VarCurr)
    <=> ( v126719(VarCurr)
        & v126720(VarCurr) ) ) ).

tff(writeUnaryOperator_9082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126720(VarCurr)
    <=> v126647(VarCurr) ) ).

tff(writeUnaryOperator_9081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126719(VarCurr)
    <=> v126643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126707(VarNext)
      <=> v126708(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126708(VarNext)
      <=> ( v126709(VarNext)
          & v126702(VarNext) ) ) ) ).

tff(writeUnaryOperator_9080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126709(VarNext)
      <=> v126711(VarNext) ) ) ).

tff(addAssignment_71390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126711(VarNext)
      <=> v126702(VarCurr) ) ) ).

tff(addAssignment_71389,axiom,
    ! [VarCurr: state_type] :
      ( v126702(VarCurr)
    <=> v126704(VarCurr) ) ).

tff(addAssignment_71388,axiom,
    ! [VarCurr: state_type] :
      ( v126704(VarCurr)
    <=> v126408(VarCurr) ) ).

tff(addAssignment_71387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126651(VarCurr,B)
      <=> v126653(VarCurr,B) ) ) ).

tff(addAssignment_71386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126653(VarCurr,B)
      <=> v126655(VarCurr,B) ) ) ).

tff(addAssignment_71385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126655(VarCurr,B)
      <=> v126657(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126659(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126657(VarCurr,B)
          <=> v126671(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1188,axiom,
    ! [VarCurr: state_type] :
      ( v126659(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126657(VarCurr,B)
          <=> v126664(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126671(VarCurr,B)
          <=> v126672(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1187,axiom,
    ! [VarCurr: state_type] :
      ( v126666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126671(VarCurr,B)
          <=> v126669(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126672(VarCurr,B)
          <=> v126673(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1186,axiom,
    ! [VarCurr: state_type] :
      ( v126635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v126672(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_71384,axiom,
    ! [VarCurr: state_type] :
      ( v126673(VarCurr,0)
    <=> v126699(VarCurr) ) ).

tff(addAssignment_71383,axiom,
    ! [VarCurr: state_type] :
      ( v126673(VarCurr,1)
    <=> v126697(VarCurr) ) ).

tff(addAssignment_71382,axiom,
    ! [VarCurr: state_type] :
      ( v126673(VarCurr,2)
    <=> v126693(VarCurr) ) ).

tff(addAssignment_71381,axiom,
    ! [VarCurr: state_type] :
      ( v126673(VarCurr,3)
    <=> v126689(VarCurr) ) ).

tff(addAssignment_71380,axiom,
    ! [VarCurr: state_type] :
      ( v126673(VarCurr,4)
    <=> v126675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16298,axiom,
    ! [VarCurr: state_type] :
      ( v126697(VarCurr)
    <=> ( v126698(VarCurr)
        & v126700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16297,axiom,
    ! [VarCurr: state_type] :
      ( v126700(VarCurr)
    <=> ( v126637(VarCurr,0)
        | v126684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5632,axiom,
    ! [VarCurr: state_type] :
      ( v126698(VarCurr)
    <=> ( v126699(VarCurr)
        | v126637(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126699(VarCurr)
    <=> v126637(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16296,axiom,
    ! [VarCurr: state_type] :
      ( v126693(VarCurr)
    <=> ( v126694(VarCurr)
        & v126696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16295,axiom,
    ! [VarCurr: state_type] :
      ( v126696(VarCurr)
    <=> ( v126682(VarCurr)
        | v126685(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5631,axiom,
    ! [VarCurr: state_type] :
      ( v126694(VarCurr)
    <=> ( v126695(VarCurr)
        | v126637(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126695(VarCurr)
    <=> v126682(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16294,axiom,
    ! [VarCurr: state_type] :
      ( v126689(VarCurr)
    <=> ( v126690(VarCurr)
        & v126692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16293,axiom,
    ! [VarCurr: state_type] :
      ( v126692(VarCurr)
    <=> ( v126680(VarCurr)
        | v126686(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5630,axiom,
    ! [VarCurr: state_type] :
      ( v126690(VarCurr)
    <=> ( v126691(VarCurr)
        | v126637(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126691(VarCurr)
    <=> v126680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16292,axiom,
    ! [VarCurr: state_type] :
      ( v126675(VarCurr)
    <=> ( v126676(VarCurr)
        & v126687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16291,axiom,
    ! [VarCurr: state_type] :
      ( v126687(VarCurr)
    <=> ( v126678(VarCurr)
        | v126688(VarCurr) ) ) ).

tff(writeUnaryOperator_9076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126688(VarCurr)
    <=> v126637(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5629,axiom,
    ! [VarCurr: state_type] :
      ( v126676(VarCurr)
    <=> ( v126677(VarCurr)
        | v126637(VarCurr,4) ) ) ).

tff(writeUnaryOperator_9075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126677(VarCurr)
    <=> v126678(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5628,axiom,
    ! [VarCurr: state_type] :
      ( v126678(VarCurr)
    <=> ( v126637(VarCurr,3)
        | v126679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16290,axiom,
    ! [VarCurr: state_type] :
      ( v126679(VarCurr)
    <=> ( v126680(VarCurr)
        & v126686(VarCurr) ) ) ).

tff(writeUnaryOperator_9074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126686(VarCurr)
    <=> v126637(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5627,axiom,
    ! [VarCurr: state_type] :
      ( v126680(VarCurr)
    <=> ( v126637(VarCurr,2)
        | v126681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16289,axiom,
    ! [VarCurr: state_type] :
      ( v126681(VarCurr)
    <=> ( v126682(VarCurr)
        & v126685(VarCurr) ) ) ).

tff(writeUnaryOperator_9073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126685(VarCurr)
    <=> v126637(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5626,axiom,
    ! [VarCurr: state_type] :
      ( v126682(VarCurr)
    <=> ( v126637(VarCurr,1)
        | v126683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16288,axiom,
    ! [VarCurr: state_type] :
      ( v126683(VarCurr)
    <=> ( v126637(VarCurr,0)
        & v126684(VarCurr) ) ) ).

tff(writeUnaryOperator_9072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126684(VarCurr)
    <=> v126637(VarCurr,1) ) ).

tff(addAssignment_71379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126669(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16287,axiom,
    ! [VarCurr: state_type] :
      ( v126666(VarCurr)
    <=> ( v126213(VarCurr)
        | v126227(VarCurr) ) ) ).

tff(addAssignment_71378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v126664(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16286,axiom,
    ! [VarCurr: state_type] :
      ( v126659(VarCurr)
    <=> ( v126661(VarCurr)
        | v126225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16285,axiom,
    ! [VarCurr: state_type] :
      ( v126661(VarCurr)
    <=> ( v126662(VarCurr)
        | v126223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16284,axiom,
    ! [VarCurr: state_type] :
      ( v126662(VarCurr)
    <=> ( v126193(VarCurr)
        | v126203(VarCurr) ) ) ).

tff(addAssignment_71377,axiom,
    ! [VarCurr: state_type] :
      ( v126647(VarCurr)
    <=> v126649(VarCurr) ) ).

tff(addAssignment_71376,axiom,
    ! [VarCurr: state_type] :
      ( v126649(VarCurr)
    <=> v125946(VarCurr) ) ).

tff(addAssignment_71375,axiom,
    ! [VarCurr: state_type] :
      ( v126643(VarCurr)
    <=> v126645(VarCurr) ) ).

tff(addAssignment_71374,axiom,
    ! [VarCurr: state_type] :
      ( v126645(VarCurr)
    <=> v125938(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1248,axiom,
    ! [VarCurr: state_type] :
      ( v126574(VarCurr)
    <=> ( ( v126576(VarCurr,1)
        <=> $false )
        & ( v126576(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v126576(VarCurr,B)
      <=> v126578(VarCurr,B) ) ) ).

tff(addAssignment_71372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v126578(VarCurr,B)
      <=> v126580(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126617(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v126580(VarNext,B)
            <=> v126580(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1642,axiom,
    ! [VarNext: state_type] :
      ( v126617(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126580(VarNext,B)
          <=> v126627(VarNext,B) ) ) ) ).

tff(addAssignment_71371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126627(VarNext,B)
          <=> v126625(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126628(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126625(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1185,axiom,
    ! [VarCurr: state_type] :
      ( v126628(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126625(VarCurr,B)
          <=> v126590(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16283,axiom,
    ! [VarCurr: state_type] :
      ( v126628(VarCurr)
    <=> ( v126629(VarCurr)
        & v126630(VarCurr) ) ) ).

tff(writeUnaryOperator_9071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126630(VarCurr)
    <=> v126586(VarCurr) ) ).

tff(writeUnaryOperator_9070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126629(VarCurr)
    <=> v126582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126617(VarNext)
      <=> v126618(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126618(VarNext)
      <=> ( v126619(VarNext)
          & v126612(VarNext) ) ) ) ).

tff(writeUnaryOperator_9069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126619(VarNext)
      <=> v126621(VarNext) ) ) ).

tff(addAssignment_71370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126621(VarNext)
      <=> v126612(VarCurr) ) ) ).

tff(addAssignment_71369,axiom,
    ! [VarCurr: state_type] :
      ( v126612(VarCurr)
    <=> v126614(VarCurr) ) ).

tff(addAssignment_71368,axiom,
    ! [VarCurr: state_type] :
      ( v126614(VarCurr)
    <=> v126408(VarCurr) ) ).

tff(addAssignment_71367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v126590(VarCurr,B)
      <=> v126592(VarCurr,B) ) ) ).

tff(addAssignment_71366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v126592(VarCurr,B)
      <=> v126594(VarCurr,B) ) ) ).

tff(addAssignment_71365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v126594(VarCurr,B)
      <=> v126596(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126598(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126596(VarCurr,B)
          <=> v126603(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1184,axiom,
    ! [VarCurr: state_type] :
      ( v126598(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126596(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126603(VarCurr,B)
          <=> v126604(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1183,axiom,
    ! [VarCurr: state_type] :
      ( v126574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v126603(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_71364,axiom,
    ! [VarCurr: state_type] :
      ( v126604(VarCurr,0)
    <=> v126608(VarCurr) ) ).

tff(addAssignment_71363,axiom,
    ! [VarCurr: state_type] :
      ( v126604(VarCurr,1)
    <=> v126606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16280,axiom,
    ! [VarCurr: state_type] :
      ( v126606(VarCurr)
    <=> ( v126607(VarCurr)
        & v126609(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16279,axiom,
    ! [VarCurr: state_type] :
      ( v126609(VarCurr)
    <=> ( v126576(VarCurr,0)
        | v126610(VarCurr) ) ) ).

tff(writeUnaryOperator_9068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126610(VarCurr)
    <=> v126576(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5625,axiom,
    ! [VarCurr: state_type] :
      ( v126607(VarCurr)
    <=> ( v126608(VarCurr)
        | v126576(VarCurr,1) ) ) ).

tff(writeUnaryOperator_9067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126608(VarCurr)
    <=> v126576(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16278,axiom,
    ! [VarCurr: state_type] :
      ( v126598(VarCurr)
    <=> ( v126600(VarCurr)
        | v126601(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5624,axiom,
    ! [VarCurr: state_type] :
      ( v126601(VarCurr)
    <=> ( v125928(VarCurr,1)
        & v126441(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5623,axiom,
    ! [VarCurr: state_type] :
      ( v126600(VarCurr)
    <=> ( v125928(VarCurr,3)
        & v126499(VarCurr) ) ) ).

tff(addAssignment_71362,axiom,
    ! [VarCurr: state_type] :
      ( v126586(VarCurr)
    <=> v126588(VarCurr) ) ).

tff(addAssignment_71361,axiom,
    ! [VarCurr: state_type] :
      ( v126588(VarCurr)
    <=> v125946(VarCurr) ) ).

tff(addAssignment_71360,axiom,
    ! [VarCurr: state_type] :
      ( v126582(VarCurr)
    <=> v126584(VarCurr) ) ).

tff(addAssignment_71359,axiom,
    ! [VarCurr: state_type] :
      ( v126584(VarCurr)
    <=> v125938(VarCurr) ) ).

tff(addAssignment_71358,axiom,
    ! [VarCurr: state_type] :
      ( v125928(VarCurr,1)
    <=> v125930(VarCurr,1) ) ).

tff(addAssignment_71357,axiom,
    ! [VarCurr: state_type] :
      ( v125930(VarCurr,1)
    <=> v125932(VarCurr,1) ) ).

tff(addAssignment_71356,axiom,
    ! [VarNext: state_type] :
      ( v125932(VarNext,1)
    <=> v126566(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126567(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v126566(VarNext,B)
            <=> v125932(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1641,axiom,
    ! [VarNext: state_type] :
      ( v126567(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126566(VarNext,B)
          <=> v126492(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126567(VarNext)
      <=> v126568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126568(VarNext)
      <=> ( v126570(VarNext)
          & v126477(VarNext) ) ) ) ).

tff(writeUnaryOperator_9066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126570(VarNext)
      <=> v126486(VarNext) ) ) ).

tff(addAssignment_71355,axiom,
    ! [VarCurr: state_type] :
      ( v125950(VarCurr,1)
    <=> v125952(VarCurr,1) ) ).

tff(addAssignment_71354,axiom,
    ! [VarCurr: state_type] :
      ( v125952(VarCurr,1)
    <=> v125954(VarCurr,1) ) ).

tff(addAssignment_71353,axiom,
    ! [VarCurr: state_type] :
      ( v125954(VarCurr,1)
    <=> v126475(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_77,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126557(VarCurr)
     => ( v125956(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_106,axiom,
    ! [VarCurr: state_type] :
      ( v126557(VarCurr)
     => ( v125956(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16275,axiom,
    ! [VarCurr: state_type] :
      ( v126557(VarCurr)
    <=> ( v126558(VarCurr)
        | v126559(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16274,axiom,
    ! [VarCurr: state_type] :
      ( v126559(VarCurr)
    <=> ( v126560(VarCurr)
        & v126561(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16273,axiom,
    ! [VarCurr: state_type] :
      ( v126561(VarCurr)
    <=> ( v126562(VarCurr)
        & v126458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16272,axiom,
    ! [VarCurr: state_type] :
      ( v126562(VarCurr)
    <=> ( v126563(VarCurr)
        & v126564(VarCurr) ) ) ).

tff(writeUnaryOperator_9065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126564(VarCurr)
    <=> v126450(VarCurr) ) ).

tff(writeUnaryOperator_9064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126563(VarCurr)
    <=> v126441(VarCurr) ) ).

tff(writeUnaryOperator_9063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126560(VarCurr)
    <=> v126460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16271,axiom,
    ! [VarCurr: state_type] :
      ( v126558(VarCurr)
    <=> ( v126532(VarCurr)
        & v126460(VarCurr) ) ) ).

tff(writeUnaryOperator_9062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125928(VarCurr,0)
    <=> v126437(VarCurr) ) ).

tff(addAssignment_71352,axiom,
    ! [VarCurr: state_type] :
      ( v126437(VarCurr)
    <=> v125930(VarCurr,0) ) ).

tff(addAssignment_71351,axiom,
    ! [VarCurr: state_type] :
      ( v125930(VarCurr,0)
    <=> v125932(VarCurr,0) ) ).

tff(addAssignment_71350,axiom,
    ! [VarNext: state_type] :
      ( v125932(VarNext,0)
    <=> v126548(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126549(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v126548(VarNext,B)
            <=> v125932(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1640,axiom,
    ! [VarNext: state_type] :
      ( v126549(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126548(VarNext,B)
          <=> v126492(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126549(VarNext)
      <=> v126550(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126550(VarNext)
      <=> ( v126552(VarNext)
          & v126477(VarNext) ) ) ) ).

tff(writeUnaryOperator_9061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126552(VarNext)
      <=> v126486(VarNext) ) ) ).

tff(addAssignment_71349,axiom,
    ! [VarCurr: state_type] :
      ( v125950(VarCurr,0)
    <=> v125952(VarCurr,0) ) ).

tff(addAssignment_71348,axiom,
    ! [VarCurr: state_type] :
      ( v125952(VarCurr,0)
    <=> v125954(VarCurr,0) ) ).

tff(addAssignment_71347,axiom,
    ! [VarCurr: state_type] :
      ( v125954(VarCurr,0)
    <=> v126475(VarCurr,0) ) ).

tff(writeUnaryOperator_9060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126439(VarCurr)
    <=> v125956(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126527(VarCurr)
     => ( v125956(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1182,axiom,
    ! [VarCurr: state_type] :
      ( v126527(VarCurr)
     => ( v125956(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16268,axiom,
    ! [VarCurr: state_type] :
      ( v126527(VarCurr)
    <=> ( v126528(VarCurr)
        | v126541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16267,axiom,
    ! [VarCurr: state_type] :
      ( v126541(VarCurr)
    <=> ( v126542(VarCurr)
        & v126545(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16266,axiom,
    ! [VarCurr: state_type] :
      ( v126545(VarCurr)
    <=> ( v126513(VarCurr)
        & v126516(VarCurr) ) ) ).

tff(writeUnaryOperator_9059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126542(VarCurr)
    <=> v126543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16265,axiom,
    ! [VarCurr: state_type] :
      ( v126543(VarCurr)
    <=> ( v126544(VarCurr)
        | v126473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16264,axiom,
    ! [VarCurr: state_type] :
      ( v126544(VarCurr)
    <=> ( v126460(VarCurr)
        | v126458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16263,axiom,
    ! [VarCurr: state_type] :
      ( v126528(VarCurr)
    <=> ( v126529(VarCurr)
        | v126537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16262,axiom,
    ! [VarCurr: state_type] :
      ( v126537(VarCurr)
    <=> ( v126538(VarCurr)
        & v126540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16261,axiom,
    ! [VarCurr: state_type] :
      ( v126540(VarCurr)
    <=> ( v126471(VarCurr)
        & v126473(VarCurr) ) ) ).

tff(writeUnaryOperator_9058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126538(VarCurr)
    <=> v126539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16260,axiom,
    ! [VarCurr: state_type] :
      ( v126539(VarCurr)
    <=> ( v126460(VarCurr)
        | v126458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16259,axiom,
    ! [VarCurr: state_type] :
      ( v126529(VarCurr)
    <=> ( v126530(VarCurr)
        | v126534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16258,axiom,
    ! [VarCurr: state_type] :
      ( v126534(VarCurr)
    <=> ( v126535(VarCurr)
        & v126536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16257,axiom,
    ! [VarCurr: state_type] :
      ( v126536(VarCurr)
    <=> ( v126450(VarCurr)
        & v126458(VarCurr) ) ) ).

tff(writeUnaryOperator_9057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126535(VarCurr)
    <=> v126460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16256,axiom,
    ! [VarCurr: state_type] :
      ( v126530(VarCurr)
    <=> ( v126531(VarCurr)
        & v126460(VarCurr) ) ) ).

tff(writeUnaryOperator_9056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126531(VarCurr)
    <=> v126532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16255,axiom,
    ! [VarCurr: state_type] :
      ( v126532(VarCurr)
    <=> ( v126533(VarCurr)
        & v126435(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16254,axiom,
    ! [VarCurr: state_type] :
      ( v126533(VarCurr)
    <=> ( v125958(VarCurr)
        & v126433(VarCurr) ) ) ).

tff(addAssignment_71346,axiom,
    ! [VarCurr: state_type] :
      ( v125928(VarCurr,3)
    <=> v125930(VarCurr,3) ) ).

tff(addAssignment_71345,axiom,
    ! [VarCurr: state_type] :
      ( v125930(VarCurr,3)
    <=> v125932(VarCurr,3) ) ).

tff(addAssignment_71344,axiom,
    ! [VarNext: state_type] :
      ( v125932(VarNext,3)
    <=> v126519(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126520(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v126519(VarNext,B)
            <=> v125932(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1639,axiom,
    ! [VarNext: state_type] :
      ( v126520(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126519(VarNext,B)
          <=> v126492(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126520(VarNext)
      <=> v126521(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126521(VarNext)
      <=> ( v126523(VarNext)
          & v126477(VarNext) ) ) ) ).

tff(writeUnaryOperator_9055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126523(VarNext)
      <=> v126486(VarNext) ) ) ).

tff(addAssignment_71343,axiom,
    ! [VarCurr: state_type] :
      ( v125950(VarCurr,3)
    <=> v125952(VarCurr,3) ) ).

tff(addAssignment_71342,axiom,
    ! [VarCurr: state_type] :
      ( v125952(VarCurr,3)
    <=> v125954(VarCurr,3) ) ).

tff(addAssignment_71341,axiom,
    ! [VarCurr: state_type] :
      ( v125954(VarCurr,3)
    <=> v126475(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_76,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126501(VarCurr)
     => ( v125956(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_105,axiom,
    ! [VarCurr: state_type] :
      ( v126501(VarCurr)
     => ( v125956(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16251,axiom,
    ! [VarCurr: state_type] :
      ( v126501(VarCurr)
    <=> ( v126502(VarCurr)
        | v126508(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16250,axiom,
    ! [VarCurr: state_type] :
      ( v126508(VarCurr)
    <=> ( v126509(VarCurr)
        & v126510(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16249,axiom,
    ! [VarCurr: state_type] :
      ( v126510(VarCurr)
    <=> ( v126511(VarCurr)
        & v126517(VarCurr) ) ) ).

tff(writeUnaryOperator_9054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126517(VarCurr)
    <=> v126507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16248,axiom,
    ! [VarCurr: state_type] :
      ( v126511(VarCurr)
    <=> ( v126512(VarCurr)
        & v126516(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1247,axiom,
    ! [VarCurr: state_type] :
      ( v126516(VarCurr)
    <=> ( $true
      <=> v125928(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126512(VarCurr)
    <=> v126513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16247,axiom,
    ! [VarCurr: state_type] :
      ( v126513(VarCurr)
    <=> ( v126514(VarCurr)
        | v126443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16246,axiom,
    ! [VarCurr: state_type] :
      ( v126514(VarCurr)
    <=> ( v126515(VarCurr)
        | v126499(VarCurr) ) ) ).

tff(writeUnaryOperator_9052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126515(VarCurr)
    <=> v126433(VarCurr) ) ).

tff(writeUnaryOperator_9051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126509(VarCurr)
    <=> v126473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16245,axiom,
    ! [VarCurr: state_type] :
      ( v126502(VarCurr)
    <=> ( v126503(VarCurr)
        & v126506(VarCurr) ) ) ).

tff(writeUnaryOperator_9050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126506(VarCurr)
    <=> v126507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16244,axiom,
    ! [VarCurr: state_type] :
      ( v126507(VarCurr)
    <=> ( v126460(VarCurr)
        | v126458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16243,axiom,
    ! [VarCurr: state_type] :
      ( v126503(VarCurr)
    <=> ( v126504(VarCurr)
        & v126473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16242,axiom,
    ! [VarCurr: state_type] :
      ( v126504(VarCurr)
    <=> ( v126467(VarCurr)
        & v126505(VarCurr) ) ) ).

tff(writeUnaryOperator_9049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126505(VarCurr)
    <=> v126471(VarCurr) ) ).

tff(addAssignment_71340,axiom,
    ! [VarCurr: state_type] :
      ( v126499(VarCurr)
    <=> v112831(VarCurr,15) ) ).

tff(addAssignment_71339,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,15)
    <=> v112865(VarCurr,15) ) ).

tff(addAssignment_71338,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,15)
    <=> v112849(VarCurr,15) ) ).

tff(addAssignment_71337,axiom,
    ! [VarCurr: state_type] :
      ( v125928(VarCurr,2)
    <=> v125930(VarCurr,2) ) ).

tff(addAssignment_71336,axiom,
    ! [VarCurr: state_type] :
      ( v125930(VarCurr,2)
    <=> v125932(VarCurr,2) ) ).

tff(addAssignment_71335,axiom,
    ! [VarNext: state_type] :
      ( v125932(VarNext,2)
    <=> v126481(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126482(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v126481(VarNext,B)
            <=> v125932(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1638,axiom,
    ! [VarNext: state_type] :
      ( v126482(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126481(VarNext,B)
          <=> v126492(VarNext,B) ) ) ) ).

tff(addAssignment_71334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126492(VarNext,B)
          <=> v126490(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126490(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1181,axiom,
    ! [VarCurr: state_type] :
      ( v126493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v126490(VarCurr,B)
          <=> v125950(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16241,axiom,
    ! [VarCurr: state_type] :
      ( v126493(VarCurr)
    <=> ( v126494(VarCurr)
        & v126495(VarCurr) ) ) ).

tff(writeUnaryOperator_9048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126495(VarCurr)
    <=> v125942(VarCurr) ) ).

tff(writeUnaryOperator_9047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126494(VarCurr)
    <=> v125934(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126482(VarNext)
      <=> v126483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126483(VarNext)
      <=> ( v126484(VarNext)
          & v126477(VarNext) ) ) ) ).

tff(writeUnaryOperator_9046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126484(VarNext)
      <=> v126486(VarNext) ) ) ).

tff(addAssignment_71333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126486(VarNext)
      <=> v126477(VarCurr) ) ) ).

tff(addAssignment_71332,axiom,
    ! [VarCurr: state_type] :
      ( v126477(VarCurr)
    <=> v126479(VarCurr) ) ).

tff(addAssignment_71331,axiom,
    ! [VarCurr: state_type] :
      ( v126479(VarCurr)
    <=> v126408(VarCurr) ) ).

tff(addAssignment_71330,axiom,
    ! [VarCurr: state_type] :
      ( v125950(VarCurr,2)
    <=> v125952(VarCurr,2) ) ).

tff(addAssignment_71329,axiom,
    ! [VarCurr: state_type] :
      ( v125952(VarCurr,2)
    <=> v125954(VarCurr,2) ) ).

tff(addAssignment_71328,axiom,
    ! [VarCurr: state_type] :
      ( v125954(VarCurr,2)
    <=> v126475(VarCurr,2) ) ).

tff(addAssignment_71327,axiom,
    ! [VarCurr: state_type] :
      ( v126475(VarCurr,0)
    <=> v126439(VarCurr) ) ).

tff(addAssignment_71326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v126475(VarCurr,B)
      <=> v125956(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_75,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126445(VarCurr)
     => ( v125956(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_104,axiom,
    ! [VarCurr: state_type] :
      ( v126445(VarCurr)
     => ( v125956(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16238,axiom,
    ! [VarCurr: state_type] :
      ( v126445(VarCurr)
    <=> ( v126446(VarCurr)
        | v126461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16237,axiom,
    ! [VarCurr: state_type] :
      ( v126461(VarCurr)
    <=> ( v126462(VarCurr)
        & v126463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16236,axiom,
    ! [VarCurr: state_type] :
      ( v126463(VarCurr)
    <=> ( v126464(VarCurr)
        & v126474(VarCurr) ) ) ).

tff(writeUnaryOperator_9045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126474(VarCurr)
    <=> v126460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16235,axiom,
    ! [VarCurr: state_type] :
      ( v126464(VarCurr)
    <=> ( v126465(VarCurr)
        & v126473(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1246,axiom,
    ! [VarCurr: state_type] :
      ( v126473(VarCurr)
    <=> ( $true
      <=> v125928(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16234,axiom,
    ! [VarCurr: state_type] :
      ( v126465(VarCurr)
    <=> ( v126466(VarCurr)
        & v126470(VarCurr) ) ) ).

tff(writeUnaryOperator_9044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126470(VarCurr)
    <=> v126471(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16233,axiom,
    ! [VarCurr: state_type] :
      ( v126471(VarCurr)
    <=> ( v126472(VarCurr)
        | v126443(VarCurr) ) ) ).

tff(writeUnaryOperator_9043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126472(VarCurr)
    <=> v126433(VarCurr) ) ).

tff(writeUnaryOperator_9042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126466(VarCurr)
    <=> v126467(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16232,axiom,
    ! [VarCurr: state_type] :
      ( v126467(VarCurr)
    <=> ( v126468(VarCurr)
        | v126469(VarCurr) ) ) ).

tff(writeUnaryOperator_9041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126469(VarCurr)
    <=> v126435(VarCurr) ) ).

tff(writeUnaryOperator_9040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126468(VarCurr)
    <=> v125958(VarCurr) ) ).

tff(writeUnaryOperator_9039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126462(VarCurr)
    <=> v126458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16231,axiom,
    ! [VarCurr: state_type] :
      ( v126446(VarCurr)
    <=> ( v126447(VarCurr)
        & v126459(VarCurr) ) ) ).

tff(writeUnaryOperator_9038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126459(VarCurr)
    <=> v126460(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1245,axiom,
    ! [VarCurr: state_type] :
      ( v126460(VarCurr)
    <=> ( $true
      <=> v125928(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16230,axiom,
    ! [VarCurr: state_type] :
      ( v126447(VarCurr)
    <=> ( v126448(VarCurr)
        & v126458(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1244,axiom,
    ! [VarCurr: state_type] :
      ( v126458(VarCurr)
    <=> ( $true
      <=> v125928(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16229,axiom,
    ! [VarCurr: state_type] :
      ( v126448(VarCurr)
    <=> ( v126441(VarCurr)
        & v126449(VarCurr) ) ) ).

tff(writeUnaryOperator_9037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126449(VarCurr)
    <=> v126450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16228,axiom,
    ! [VarCurr: state_type] :
      ( v126450(VarCurr)
    <=> ( v126451(VarCurr)
        | v126443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16227,axiom,
    ! [VarCurr: state_type] :
      ( v126451(VarCurr)
    <=> ( v126452(VarCurr)
        | v126455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16226,axiom,
    ! [VarCurr: state_type] :
      ( v126455(VarCurr)
    <=> ( v126456(VarCurr)
        & v126457(VarCurr) ) ) ).

tff(writeUnaryOperator_9036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126457(VarCurr)
    <=> v126441(VarCurr) ) ).

tff(writeUnaryOperator_9035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126456(VarCurr)
    <=> v125958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16225,axiom,
    ! [VarCurr: state_type] :
      ( v126452(VarCurr)
    <=> ( v126453(VarCurr)
        | v126454(VarCurr) ) ) ).

tff(writeUnaryOperator_9034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126454(VarCurr)
    <=> v126435(VarCurr) ) ).

tff(writeUnaryOperator_9033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126453(VarCurr)
    <=> v126433(VarCurr) ) ).

tff(addAssignment_71325,axiom,
    ! [VarCurr: state_type] :
      ( v126443(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_71324,axiom,
    ! [VarCurr: state_type] :
      ( v126441(VarCurr)
    <=> v112643(VarCurr,15) ) ).

tff(addAssignment_71323,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,15)
    <=> v115202(VarCurr,15) ) ).

tff(addAssignment_71322,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,15)
    <=> v115186(VarCurr,15) ) ).

tff(addAssignment_71321,axiom,
    ! [VarCurr: state_type] :
      ( v126435(VarCurr)
    <=> v112528(VarCurr,15) ) ).

tff(addAssignment_71320,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,15)
    <=> v120828(VarCurr,7) ) ).

tff(addAssignment_71319,axiom,
    ! [VarCurr: state_type] :
      ( v126433(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16224,axiom,
    ! [VarCurr: state_type] :
      ( v125958(VarCurr)
    <=> ( v126430(VarCurr)
        & v126431(VarCurr) ) ) ).

tff(writeUnaryOperator_9032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126431(VarCurr)
    <=> v126428(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1243,axiom,
    ! [VarCurr: state_type] :
      ( v126430(VarCurr)
    <=> ( ( v125960(VarCurr,5)
        <=> $false )
        & ( v125960(VarCurr,4)
        <=> $false )
        & ( v125960(VarCurr,3)
        <=> $false )
        & ( v125960(VarCurr,2)
        <=> $false )
        & ( v125960(VarCurr,1)
        <=> $false )
        & ( v125960(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71318,axiom,
    ! [VarCurr: state_type] :
      ( v126428(VarCurr)
    <=> v115139(VarCurr,15) ) ).

tff(addAssignment_71317,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,15)
    <=> v115159(VarCurr,15) ) ).

tff(addAssignment_71316,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,15)
    <=> v115142(VarCurr,15) ) ).

tff(addAssignment_71315,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125960(VarCurr,B)
      <=> v125962(VarCurr,B) ) ) ).

tff(addAssignment_71314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125962(VarCurr,B)
      <=> v125964(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126411(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v125964(VarNext,B)
            <=> v125964(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1637,axiom,
    ! [VarNext: state_type] :
      ( v126411(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v125964(VarNext,B)
          <=> v126421(VarNext,B) ) ) ) ).

tff(addAssignment_71313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v126421(VarNext,B)
          <=> v126419(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126422(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v126419(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1180,axiom,
    ! [VarCurr: state_type] :
      ( v126422(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v126419(VarCurr,B)
          <=> v125974(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16223,axiom,
    ! [VarCurr: state_type] :
      ( v126422(VarCurr)
    <=> ( v126423(VarCurr)
        & v126424(VarCurr) ) ) ).

tff(writeUnaryOperator_9031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126424(VarCurr)
    <=> v125970(VarCurr) ) ).

tff(writeUnaryOperator_9030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126423(VarCurr)
    <=> v125966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126411(VarNext)
      <=> v126412(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126412(VarNext)
      <=> ( v126413(VarNext)
          & v126404(VarNext) ) ) ) ).

tff(writeUnaryOperator_9029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126413(VarNext)
      <=> v126415(VarNext) ) ) ).

tff(addAssignment_71312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126415(VarNext)
      <=> v126404(VarCurr) ) ) ).

tff(addAssignment_71311,axiom,
    ! [VarCurr: state_type] :
      ( v126404(VarCurr)
    <=> v126406(VarCurr) ) ).

tff(addAssignment_71310,axiom,
    ! [VarCurr: state_type] :
      ( v126406(VarCurr)
    <=> v126408(VarCurr) ) ).

tff(addAssignment_71309,axiom,
    ! [VarCurr: state_type] :
      ( v126408(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_71308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125974(VarCurr,B)
      <=> v125976(VarCurr,B) ) ) ).

tff(addAssignment_71307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125976(VarCurr,B)
      <=> v125978(VarCurr,B) ) ) ).

tff(addAssignment_71306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125978(VarCurr,B)
      <=> v125980(VarCurr,B) ) ) ).

tff(addAssignment_71305,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,0)
    <=> v126399(VarCurr) ) ).

tff(addAssignment_71304,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,1)
    <=> v126394(VarCurr) ) ).

tff(addAssignment_71303,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,2)
    <=> v126389(VarCurr) ) ).

tff(addAssignment_71302,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,3)
    <=> v126384(VarCurr) ) ).

tff(addAssignment_71301,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,4)
    <=> v126379(VarCurr) ) ).

tff(addAssignment_71300,axiom,
    ! [VarCurr: state_type] :
      ( v125980(VarCurr,5)
    <=> v126236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16220,axiom,
    ! [VarCurr: state_type] :
      ( v126399(VarCurr)
    <=> ( v126400(VarCurr)
        & v126402(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16219,axiom,
    ! [VarCurr: state_type] :
      ( v126402(VarCurr)
    <=> ( v126191(VarCurr,0)
        | v126248(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16218,axiom,
    ! [VarCurr: state_type] :
      ( v126400(VarCurr)
    <=> ( v126325(VarCurr)
        | v126401(VarCurr) ) ) ).

tff(writeUnaryOperator_9028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126401(VarCurr)
    <=> v126248(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16217,axiom,
    ! [VarCurr: state_type] :
      ( v126394(VarCurr)
    <=> ( v126395(VarCurr)
        & v126398(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16216,axiom,
    ! [VarCurr: state_type] :
      ( v126398(VarCurr)
    <=> ( v126247(VarCurr)
        | v126319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16215,axiom,
    ! [VarCurr: state_type] :
      ( v126395(VarCurr)
    <=> ( v126396(VarCurr)
        | v126397(VarCurr) ) ) ).

tff(writeUnaryOperator_9027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126397(VarCurr)
    <=> v126319(VarCurr) ) ).

tff(writeUnaryOperator_9026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126396(VarCurr)
    <=> v126247(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16214,axiom,
    ! [VarCurr: state_type] :
      ( v126389(VarCurr)
    <=> ( v126390(VarCurr)
        & v126393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16213,axiom,
    ! [VarCurr: state_type] :
      ( v126393(VarCurr)
    <=> ( v126245(VarCurr)
        | v126330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16212,axiom,
    ! [VarCurr: state_type] :
      ( v126390(VarCurr)
    <=> ( v126391(VarCurr)
        | v126392(VarCurr) ) ) ).

tff(writeUnaryOperator_9025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126392(VarCurr)
    <=> v126330(VarCurr) ) ).

tff(writeUnaryOperator_9024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126391(VarCurr)
    <=> v126245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16211,axiom,
    ! [VarCurr: state_type] :
      ( v126384(VarCurr)
    <=> ( v126385(VarCurr)
        & v126388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16210,axiom,
    ! [VarCurr: state_type] :
      ( v126388(VarCurr)
    <=> ( v126243(VarCurr)
        | v126342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16209,axiom,
    ! [VarCurr: state_type] :
      ( v126385(VarCurr)
    <=> ( v126386(VarCurr)
        | v126387(VarCurr) ) ) ).

tff(writeUnaryOperator_9023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126387(VarCurr)
    <=> v126342(VarCurr) ) ).

tff(writeUnaryOperator_9022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126386(VarCurr)
    <=> v126243(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16208,axiom,
    ! [VarCurr: state_type] :
      ( v126379(VarCurr)
    <=> ( v126380(VarCurr)
        & v126383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16207,axiom,
    ! [VarCurr: state_type] :
      ( v126383(VarCurr)
    <=> ( v126241(VarCurr)
        | v126354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16206,axiom,
    ! [VarCurr: state_type] :
      ( v126380(VarCurr)
    <=> ( v126381(VarCurr)
        | v126382(VarCurr) ) ) ).

tff(writeUnaryOperator_9021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126382(VarCurr)
    <=> v126354(VarCurr) ) ).

tff(writeUnaryOperator_9020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126381(VarCurr)
    <=> v126241(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16205,axiom,
    ! [VarCurr: state_type] :
      ( v126236(VarCurr)
    <=> ( v126237(VarCurr)
        & v126378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16204,axiom,
    ! [VarCurr: state_type] :
      ( v126378(VarCurr)
    <=> ( v126239(VarCurr)
        | v126367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16203,axiom,
    ! [VarCurr: state_type] :
      ( v126237(VarCurr)
    <=> ( v126238(VarCurr)
        | v126366(VarCurr) ) ) ).

tff(writeUnaryOperator_9019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126366(VarCurr)
    <=> v126367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16202,axiom,
    ! [VarCurr: state_type] :
      ( v126367(VarCurr)
    <=> ( v126368(VarCurr)
        & v126377(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5622,axiom,
    ! [VarCurr: state_type] :
      ( v126377(VarCurr)
    <=> ( v126370(VarCurr)
        | v126248(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16201,axiom,
    ! [VarCurr: state_type] :
      ( v126368(VarCurr)
    <=> ( v126369(VarCurr)
        | v126376(VarCurr) ) ) ).

tff(writeUnaryOperator_9018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126376(VarCurr)
    <=> v126248(VarCurr,5) ) ).

tff(writeUnaryOperator_9017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126369(VarCurr)
    <=> v126370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16200,axiom,
    ! [VarCurr: state_type] :
      ( v126370(VarCurr)
    <=> ( v126371(VarCurr)
        & v126374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16199,axiom,
    ! [VarCurr: state_type] :
      ( v126374(VarCurr)
    <=> ( v126373(VarCurr)
        | v126375(VarCurr) ) ) ).

tff(writeUnaryOperator_9016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126375(VarCurr)
    <=> v126191(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5621,axiom,
    ! [VarCurr: state_type] :
      ( v126371(VarCurr)
    <=> ( v126372(VarCurr)
        | v126191(VarCurr,5) ) ) ).

tff(writeUnaryOperator_9015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126372(VarCurr)
    <=> v126373(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16198,axiom,
    ! [VarCurr: state_type] :
      ( v126373(VarCurr)
    <=> ( v126360(VarCurr)
        & v126362(VarCurr) ) ) ).

tff(writeUnaryOperator_9014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126238(VarCurr)
    <=> v126239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16197,axiom,
    ! [VarCurr: state_type] :
      ( v126239(VarCurr)
    <=> ( v126240(VarCurr)
        | v126365(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5620,axiom,
    ! [VarCurr: state_type] :
      ( v126365(VarCurr)
    <=> ( v126357(VarCurr)
        & v126248(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16196,axiom,
    ! [VarCurr: state_type] :
      ( v126240(VarCurr)
    <=> ( v126241(VarCurr)
        & v126354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16195,axiom,
    ! [VarCurr: state_type] :
      ( v126354(VarCurr)
    <=> ( v126355(VarCurr)
        & v126364(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5619,axiom,
    ! [VarCurr: state_type] :
      ( v126364(VarCurr)
    <=> ( v126357(VarCurr)
        | v126248(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16194,axiom,
    ! [VarCurr: state_type] :
      ( v126355(VarCurr)
    <=> ( v126356(VarCurr)
        | v126363(VarCurr) ) ) ).

tff(writeUnaryOperator_9013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126363(VarCurr)
    <=> v126248(VarCurr,4) ) ).

tff(writeUnaryOperator_9012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126356(VarCurr)
    <=> v126357(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16193,axiom,
    ! [VarCurr: state_type] :
      ( v126357(VarCurr)
    <=> ( v126358(VarCurr)
        & v126361(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16192,axiom,
    ! [VarCurr: state_type] :
      ( v126361(VarCurr)
    <=> ( v126360(VarCurr)
        | v126362(VarCurr) ) ) ).

tff(writeUnaryOperator_9011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126362(VarCurr)
    <=> v126191(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5618,axiom,
    ! [VarCurr: state_type] :
      ( v126358(VarCurr)
    <=> ( v126359(VarCurr)
        | v126191(VarCurr,4) ) ) ).

tff(writeUnaryOperator_9010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126359(VarCurr)
    <=> v126360(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16191,axiom,
    ! [VarCurr: state_type] :
      ( v126360(VarCurr)
    <=> ( v126348(VarCurr)
        & v126350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16190,axiom,
    ! [VarCurr: state_type] :
      ( v126241(VarCurr)
    <=> ( v126242(VarCurr)
        | v126353(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5617,axiom,
    ! [VarCurr: state_type] :
      ( v126353(VarCurr)
    <=> ( v126345(VarCurr)
        & v126248(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16189,axiom,
    ! [VarCurr: state_type] :
      ( v126242(VarCurr)
    <=> ( v126243(VarCurr)
        & v126342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16188,axiom,
    ! [VarCurr: state_type] :
      ( v126342(VarCurr)
    <=> ( v126343(VarCurr)
        & v126352(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5616,axiom,
    ! [VarCurr: state_type] :
      ( v126352(VarCurr)
    <=> ( v126345(VarCurr)
        | v126248(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16187,axiom,
    ! [VarCurr: state_type] :
      ( v126343(VarCurr)
    <=> ( v126344(VarCurr)
        | v126351(VarCurr) ) ) ).

tff(writeUnaryOperator_9009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126351(VarCurr)
    <=> v126248(VarCurr,3) ) ).

tff(writeUnaryOperator_9008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126344(VarCurr)
    <=> v126345(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16186,axiom,
    ! [VarCurr: state_type] :
      ( v126345(VarCurr)
    <=> ( v126346(VarCurr)
        & v126349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16185,axiom,
    ! [VarCurr: state_type] :
      ( v126349(VarCurr)
    <=> ( v126348(VarCurr)
        | v126350(VarCurr) ) ) ).

tff(writeUnaryOperator_9007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126350(VarCurr)
    <=> v126191(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5615,axiom,
    ! [VarCurr: state_type] :
      ( v126346(VarCurr)
    <=> ( v126347(VarCurr)
        | v126191(VarCurr,3) ) ) ).

tff(writeUnaryOperator_9006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126347(VarCurr)
    <=> v126348(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16184,axiom,
    ! [VarCurr: state_type] :
      ( v126348(VarCurr)
    <=> ( v126336(VarCurr)
        & v126338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16183,axiom,
    ! [VarCurr: state_type] :
      ( v126243(VarCurr)
    <=> ( v126244(VarCurr)
        | v126341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5614,axiom,
    ! [VarCurr: state_type] :
      ( v126341(VarCurr)
    <=> ( v126333(VarCurr)
        & v126248(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16182,axiom,
    ! [VarCurr: state_type] :
      ( v126244(VarCurr)
    <=> ( v126245(VarCurr)
        & v126330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16181,axiom,
    ! [VarCurr: state_type] :
      ( v126330(VarCurr)
    <=> ( v126331(VarCurr)
        & v126340(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5613,axiom,
    ! [VarCurr: state_type] :
      ( v126340(VarCurr)
    <=> ( v126333(VarCurr)
        | v126248(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16180,axiom,
    ! [VarCurr: state_type] :
      ( v126331(VarCurr)
    <=> ( v126332(VarCurr)
        | v126339(VarCurr) ) ) ).

tff(writeUnaryOperator_9005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126339(VarCurr)
    <=> v126248(VarCurr,2) ) ).

tff(writeUnaryOperator_9004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126332(VarCurr)
    <=> v126333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16179,axiom,
    ! [VarCurr: state_type] :
      ( v126333(VarCurr)
    <=> ( v126334(VarCurr)
        & v126337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16178,axiom,
    ! [VarCurr: state_type] :
      ( v126337(VarCurr)
    <=> ( v126336(VarCurr)
        | v126338(VarCurr) ) ) ).

tff(writeUnaryOperator_9003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126338(VarCurr)
    <=> v126191(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5612,axiom,
    ! [VarCurr: state_type] :
      ( v126334(VarCurr)
    <=> ( v126335(VarCurr)
        | v126191(VarCurr,2) ) ) ).

tff(writeUnaryOperator_9002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126335(VarCurr)
    <=> v126336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16177,axiom,
    ! [VarCurr: state_type] :
      ( v126336(VarCurr)
    <=> ( v126325(VarCurr)
        & v126326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16176,axiom,
    ! [VarCurr: state_type] :
      ( v126245(VarCurr)
    <=> ( v126246(VarCurr)
        | v126329(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5611,axiom,
    ! [VarCurr: state_type] :
      ( v126329(VarCurr)
    <=> ( v126322(VarCurr)
        & v126248(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16175,axiom,
    ! [VarCurr: state_type] :
      ( v126246(VarCurr)
    <=> ( v126247(VarCurr)
        & v126319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16174,axiom,
    ! [VarCurr: state_type] :
      ( v126319(VarCurr)
    <=> ( v126320(VarCurr)
        & v126328(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5610,axiom,
    ! [VarCurr: state_type] :
      ( v126328(VarCurr)
    <=> ( v126322(VarCurr)
        | v126248(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16173,axiom,
    ! [VarCurr: state_type] :
      ( v126320(VarCurr)
    <=> ( v126321(VarCurr)
        | v126327(VarCurr) ) ) ).

tff(writeUnaryOperator_9001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126327(VarCurr)
    <=> v126248(VarCurr,1) ) ).

tff(writeUnaryOperator_9000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126321(VarCurr)
    <=> v126322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16172,axiom,
    ! [VarCurr: state_type] :
      ( v126322(VarCurr)
    <=> ( v126323(VarCurr)
        & v126324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16171,axiom,
    ! [VarCurr: state_type] :
      ( v126324(VarCurr)
    <=> ( v126325(VarCurr)
        | v126326(VarCurr) ) ) ).

tff(writeUnaryOperator_8999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126326(VarCurr)
    <=> v126191(VarCurr,1) ) ).

tff(writeUnaryOperator_8998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126325(VarCurr)
    <=> v126191(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5609,axiom,
    ! [VarCurr: state_type] :
      ( v126323(VarCurr)
    <=> ( v126191(VarCurr,0)
        | v126191(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16170,axiom,
    ! [VarCurr: state_type] :
      ( v126247(VarCurr)
    <=> ( v126191(VarCurr,0)
        & v126248(VarCurr,0) ) ) ).

tff(addAssignment_71299,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,0)
    <=> v126314(VarCurr) ) ).

tff(addAssignment_71298,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,1)
    <=> v126309(VarCurr) ) ).

tff(addAssignment_71297,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,2)
    <=> v126304(VarCurr) ) ).

tff(addAssignment_71296,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,3)
    <=> v126299(VarCurr) ) ).

tff(addAssignment_71295,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,4)
    <=> v126294(VarCurr) ) ).

tff(addAssignment_71294,axiom,
    ! [VarCurr: state_type] :
      ( v126248(VarCurr,5)
    <=> v126250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16169,axiom,
    ! [VarCurr: state_type] :
      ( v126314(VarCurr)
    <=> ( v126315(VarCurr)
        & v126318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16168,axiom,
    ! [VarCurr: state_type] :
      ( v126318(VarCurr)
    <=> ( v125960(VarCurr,0)
        | v126262(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16167,axiom,
    ! [VarCurr: state_type] :
      ( v126315(VarCurr)
    <=> ( v126316(VarCurr)
        | v126317(VarCurr) ) ) ).

tff(writeUnaryOperator_8997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126317(VarCurr)
    <=> v126262(VarCurr,0) ) ).

tff(writeUnaryOperator_8996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126316(VarCurr)
    <=> v125960(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16166,axiom,
    ! [VarCurr: state_type] :
      ( v126309(VarCurr)
    <=> ( v126310(VarCurr)
        & v126313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16165,axiom,
    ! [VarCurr: state_type] :
      ( v126313(VarCurr)
    <=> ( v126261(VarCurr)
        | v126263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16164,axiom,
    ! [VarCurr: state_type] :
      ( v126310(VarCurr)
    <=> ( v126311(VarCurr)
        | v126312(VarCurr) ) ) ).

tff(writeUnaryOperator_8995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126312(VarCurr)
    <=> v126263(VarCurr) ) ).

tff(writeUnaryOperator_8994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126311(VarCurr)
    <=> v126261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16163,axiom,
    ! [VarCurr: state_type] :
      ( v126304(VarCurr)
    <=> ( v126305(VarCurr)
        & v126308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16162,axiom,
    ! [VarCurr: state_type] :
      ( v126308(VarCurr)
    <=> ( v126259(VarCurr)
        | v126269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16161,axiom,
    ! [VarCurr: state_type] :
      ( v126305(VarCurr)
    <=> ( v126306(VarCurr)
        | v126307(VarCurr) ) ) ).

tff(writeUnaryOperator_8993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126307(VarCurr)
    <=> v126269(VarCurr) ) ).

tff(writeUnaryOperator_8992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126306(VarCurr)
    <=> v126259(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16160,axiom,
    ! [VarCurr: state_type] :
      ( v126299(VarCurr)
    <=> ( v126300(VarCurr)
        & v126303(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16159,axiom,
    ! [VarCurr: state_type] :
      ( v126303(VarCurr)
    <=> ( v126257(VarCurr)
        | v126275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16158,axiom,
    ! [VarCurr: state_type] :
      ( v126300(VarCurr)
    <=> ( v126301(VarCurr)
        | v126302(VarCurr) ) ) ).

tff(writeUnaryOperator_8991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126302(VarCurr)
    <=> v126275(VarCurr) ) ).

tff(writeUnaryOperator_8990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126301(VarCurr)
    <=> v126257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16157,axiom,
    ! [VarCurr: state_type] :
      ( v126294(VarCurr)
    <=> ( v126295(VarCurr)
        & v126298(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16156,axiom,
    ! [VarCurr: state_type] :
      ( v126298(VarCurr)
    <=> ( v126255(VarCurr)
        | v126281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16155,axiom,
    ! [VarCurr: state_type] :
      ( v126295(VarCurr)
    <=> ( v126296(VarCurr)
        | v126297(VarCurr) ) ) ).

tff(writeUnaryOperator_8989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126297(VarCurr)
    <=> v126281(VarCurr) ) ).

tff(writeUnaryOperator_8988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126296(VarCurr)
    <=> v126255(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16154,axiom,
    ! [VarCurr: state_type] :
      ( v126250(VarCurr)
    <=> ( v126251(VarCurr)
        & v126293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16153,axiom,
    ! [VarCurr: state_type] :
      ( v126293(VarCurr)
    <=> ( v126253(VarCurr)
        | v126288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16152,axiom,
    ! [VarCurr: state_type] :
      ( v126251(VarCurr)
    <=> ( v126252(VarCurr)
        | v126287(VarCurr) ) ) ).

tff(writeUnaryOperator_8987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126287(VarCurr)
    <=> v126288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16151,axiom,
    ! [VarCurr: state_type] :
      ( v126288(VarCurr)
    <=> ( v126289(VarCurr)
        & v126292(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5608,axiom,
    ! [VarCurr: state_type] :
      ( v126292(VarCurr)
    <=> ( v125960(VarCurr,5)
        | v126262(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16150,axiom,
    ! [VarCurr: state_type] :
      ( v126289(VarCurr)
    <=> ( v126290(VarCurr)
        | v126291(VarCurr) ) ) ).

tff(writeUnaryOperator_8986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126291(VarCurr)
    <=> v126262(VarCurr,5) ) ).

tff(writeUnaryOperator_8985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126290(VarCurr)
    <=> v125960(VarCurr,5) ) ).

tff(writeUnaryOperator_8984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126252(VarCurr)
    <=> v126253(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16149,axiom,
    ! [VarCurr: state_type] :
      ( v126253(VarCurr)
    <=> ( v126254(VarCurr)
        | v126286(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5607,axiom,
    ! [VarCurr: state_type] :
      ( v126286(VarCurr)
    <=> ( v125960(VarCurr,4)
        & v126262(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16148,axiom,
    ! [VarCurr: state_type] :
      ( v126254(VarCurr)
    <=> ( v126255(VarCurr)
        & v126281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16147,axiom,
    ! [VarCurr: state_type] :
      ( v126281(VarCurr)
    <=> ( v126282(VarCurr)
        & v126285(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5606,axiom,
    ! [VarCurr: state_type] :
      ( v126285(VarCurr)
    <=> ( v125960(VarCurr,4)
        | v126262(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16146,axiom,
    ! [VarCurr: state_type] :
      ( v126282(VarCurr)
    <=> ( v126283(VarCurr)
        | v126284(VarCurr) ) ) ).

tff(writeUnaryOperator_8983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126284(VarCurr)
    <=> v126262(VarCurr,4) ) ).

tff(writeUnaryOperator_8982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126283(VarCurr)
    <=> v125960(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16145,axiom,
    ! [VarCurr: state_type] :
      ( v126255(VarCurr)
    <=> ( v126256(VarCurr)
        | v126280(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5605,axiom,
    ! [VarCurr: state_type] :
      ( v126280(VarCurr)
    <=> ( v125960(VarCurr,3)
        & v126262(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16144,axiom,
    ! [VarCurr: state_type] :
      ( v126256(VarCurr)
    <=> ( v126257(VarCurr)
        & v126275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16143,axiom,
    ! [VarCurr: state_type] :
      ( v126275(VarCurr)
    <=> ( v126276(VarCurr)
        & v126279(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5604,axiom,
    ! [VarCurr: state_type] :
      ( v126279(VarCurr)
    <=> ( v125960(VarCurr,3)
        | v126262(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16142,axiom,
    ! [VarCurr: state_type] :
      ( v126276(VarCurr)
    <=> ( v126277(VarCurr)
        | v126278(VarCurr) ) ) ).

tff(writeUnaryOperator_8981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126278(VarCurr)
    <=> v126262(VarCurr,3) ) ).

tff(writeUnaryOperator_8980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126277(VarCurr)
    <=> v125960(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16141,axiom,
    ! [VarCurr: state_type] :
      ( v126257(VarCurr)
    <=> ( v126258(VarCurr)
        | v126274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5603,axiom,
    ! [VarCurr: state_type] :
      ( v126274(VarCurr)
    <=> ( v125960(VarCurr,2)
        & v126262(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16140,axiom,
    ! [VarCurr: state_type] :
      ( v126258(VarCurr)
    <=> ( v126259(VarCurr)
        & v126269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16139,axiom,
    ! [VarCurr: state_type] :
      ( v126269(VarCurr)
    <=> ( v126270(VarCurr)
        & v126273(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5602,axiom,
    ! [VarCurr: state_type] :
      ( v126273(VarCurr)
    <=> ( v125960(VarCurr,2)
        | v126262(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16138,axiom,
    ! [VarCurr: state_type] :
      ( v126270(VarCurr)
    <=> ( v126271(VarCurr)
        | v126272(VarCurr) ) ) ).

tff(writeUnaryOperator_8979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126272(VarCurr)
    <=> v126262(VarCurr,2) ) ).

tff(writeUnaryOperator_8978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126271(VarCurr)
    <=> v125960(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16137,axiom,
    ! [VarCurr: state_type] :
      ( v126259(VarCurr)
    <=> ( v126260(VarCurr)
        | v126268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5601,axiom,
    ! [VarCurr: state_type] :
      ( v126268(VarCurr)
    <=> ( v125960(VarCurr,1)
        & v126262(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16136,axiom,
    ! [VarCurr: state_type] :
      ( v126260(VarCurr)
    <=> ( v126261(VarCurr)
        & v126263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16135,axiom,
    ! [VarCurr: state_type] :
      ( v126263(VarCurr)
    <=> ( v126264(VarCurr)
        & v126267(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5600,axiom,
    ! [VarCurr: state_type] :
      ( v126267(VarCurr)
    <=> ( v125960(VarCurr,1)
        | v126262(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16134,axiom,
    ! [VarCurr: state_type] :
      ( v126264(VarCurr)
    <=> ( v126265(VarCurr)
        | v126266(VarCurr) ) ) ).

tff(writeUnaryOperator_8977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126266(VarCurr)
    <=> v126262(VarCurr,1) ) ).

tff(writeUnaryOperator_8976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126265(VarCurr)
    <=> v125960(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16133,axiom,
    ! [VarCurr: state_type] :
      ( v126261(VarCurr)
    <=> ( v125960(VarCurr,0)
        & v126262(VarCurr,0) ) ) ).

tff(addAssignment_71293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v126262(VarCurr,B)
      <=> v125982(VarCurr,B) ) ) ).

tff(addAssignment_71292,axiom,
    ! [VarCurr: state_type] :
      ( ( v126262(VarCurr,5)
      <=> $false )
      & ( v126262(VarCurr,4)
      <=> $false )
      & ( v126262(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_71291,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,5)
    <=> v126228(VarCurr,5) ) ).

tff(addAssignment_71290,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,4)
    <=> v126228(VarCurr,4) ) ).

tff(addAssignment_71289,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,3)
    <=> v126228(VarCurr,3) ) ).

tff(addAssignment_71288,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,2)
    <=> v126228(VarCurr,2) ) ).

tff(addAssignment_71287,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,1)
    <=> v126228(VarCurr,1) ) ).

tff(addAssignment_71286,axiom,
    ! [VarCurr: state_type] :
      ( v126191(VarCurr,0)
    <=> v126228(VarCurr,0) ) ).

tff(addAssignment_71285,axiom,
    ! [VarCurr: state_type] :
      ( v126228(VarCurr,0)
    <=> v126229(VarCurr) ) ).

tff(addAssignment_71284,axiom,
    ! [VarCurr: state_type] :
      ( ( v126228(VarCurr,5)
      <=> $false )
      & ( v126228(VarCurr,4)
      <=> $false )
      & ( v126228(VarCurr,3)
      <=> $false )
      & ( v126228(VarCurr,2)
      <=> $false )
      & ( v126228(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16132,axiom,
    ! [VarCurr: state_type] :
      ( v126229(VarCurr)
    <=> ( v126230(VarCurr)
        | v126227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16131,axiom,
    ! [VarCurr: state_type] :
      ( v126230(VarCurr)
    <=> ( v126231(VarCurr)
        | v126225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16130,axiom,
    ! [VarCurr: state_type] :
      ( v126231(VarCurr)
    <=> ( v126232(VarCurr)
        | v126223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16129,axiom,
    ! [VarCurr: state_type] :
      ( v126232(VarCurr)
    <=> ( v126233(VarCurr)
        | v126213(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16128,axiom,
    ! [VarCurr: state_type] :
      ( v126233(VarCurr)
    <=> ( v126193(VarCurr)
        | v126203(VarCurr) ) ) ).

tff(addAssignment_71283,axiom,
    ! [VarCurr: state_type] :
      ( v126227(VarCurr)
    <=> v113911(VarCurr,15) ) ).

tff(addAssignment_71282,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,15)
    <=> v113913(VarCurr,15) ) ).

tff(addAssignment_71281,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,15)
    <=> v113915(VarCurr,15) ) ).

tff(addAssignment_71280,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,15)
    <=> v113935(VarCurr,15) ) ).

tff(addAssignment_71279,axiom,
    ! [VarCurr: state_type] :
      ( v126225(VarCurr)
    <=> v113107(VarCurr,15) ) ).

tff(addAssignment_71278,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,15)
    <=> v113143(VarCurr,15) ) ).

tff(addAssignment_71277,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,15)
    <=> v113110(VarCurr,15) ) ).

tff(addAssignment_71276,axiom,
    ! [VarCurr: state_type] :
      ( v126223(VarCurr)
    <=> v113100(VarCurr,15) ) ).

tff(addAssignment_71275,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,15)
    <=> v113101(VarCurr,15) ) ).

tff(addAssignment_71274,axiom,
    ! [VarCurr: state_type] :
      ( v126213(VarCurr)
    <=> v113810(VarCurr,15) ) ).

tff(addAssignment_71273,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,15)
    <=> v113812(VarCurr,15) ) ).

tff(addAssignment_71272,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,15)
    <=> v113814(VarCurr,15) ) ).

tff(addAssignment_71271,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,15)
    <=> v113816(VarCurr,15) ) ).

tff(addAssignment_71270,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,15)
    <=> v113818(VarCurr,15) ) ).

tff(addAssignment_71269,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,15)
    <=> v126215(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126216(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v126215(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1636,axiom,
    ! [VarNext: state_type] :
      ( v126216(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v126215(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126216(VarNext)
      <=> v126217(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126217(VarNext)
      <=> ( v126219(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126219(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_71268,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,15)
    <=> v113830(VarCurr,15) ) ).

tff(addAssignment_71267,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,15)
    <=> v113832(VarCurr,15) ) ).

tff(addAssignment_71266,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,15)
    <=> v113834(VarCurr,15) ) ).

tff(addAssignment_71265,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,15)
    <=> v113873(VarCurr,15) ) ).

tff(addAssignment_71264,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,15)
    <=> v113856(VarCurr,15) ) ).

tff(addAssignment_71263,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,15)
    <=> v113837(VarCurr,15) ) ).

tff(addAssignment_71262,axiom,
    ! [VarCurr: state_type] :
      ( v126203(VarCurr)
    <=> v113020(VarCurr,15) ) ).

tff(addAssignment_71261,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,15)
    <=> v113022(VarCurr,15) ) ).

tff(addAssignment_71260,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,15)
    <=> v113024(VarCurr,15) ) ).

tff(addAssignment_71259,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,15)
    <=> v113026(VarCurr,15) ) ).

tff(addAssignment_71258,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,15)
    <=> v113028(VarCurr,15) ) ).

tff(addAssignment_71257,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,15)
    <=> v126205(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126206(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v126205(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1635,axiom,
    ! [VarNext: state_type] :
      ( v126206(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v126205(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126206(VarNext)
      <=> v126207(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126207(VarNext)
      <=> ( v126209(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126209(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_71256,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,15)
    <=> v113040(VarCurr,15) ) ).

tff(addAssignment_71255,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,15)
    <=> v113042(VarCurr,15) ) ).

tff(addAssignment_71254,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,15)
    <=> v113044(VarCurr,15) ) ).

tff(addAssignment_71253,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,15)
    <=> v113045(VarCurr,15) ) ).

tff(addAssignment_71252,axiom,
    ! [VarCurr: state_type] :
      ( v126193(VarCurr)
    <=> v112940(VarCurr,15) ) ).

tff(addAssignment_71251,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,15)
    <=> v112942(VarCurr,15) ) ).

tff(addAssignment_71250,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,15)
    <=> v112944(VarCurr,15) ) ).

tff(addAssignment_71249,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,15)
    <=> v112946(VarCurr,15) ) ).

tff(addAssignment_71248,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,15)
    <=> v112948(VarCurr,15) ) ).

tff(addAssignment_71247,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,15)
    <=> v126195(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126196(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v126195(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1634,axiom,
    ! [VarNext: state_type] :
      ( v126196(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v126195(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126196(VarNext)
      <=> v126197(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v126197(VarNext)
      <=> ( v126199(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v126199(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_71246,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,15)
    <=> v112960(VarCurr,15) ) ).

tff(addAssignment_71245,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,15)
    <=> v112962(VarCurr,15) ) ).

tff(addAssignment_71244,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,15)
    <=> v112964(VarCurr,15) ) ).

tff(addAssignment_71243,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,15)
    <=> v112965(VarCurr,15) ) ).

tff(addAssignment_71242,axiom,
    ! [VarCurr: state_type] :
      ( v125982(VarCurr,2)
    <=> v125997(VarCurr,2) ) ).

tff(addAssignment_71241,axiom,
    ! [VarCurr: state_type] :
      ( v125982(VarCurr,1)
    <=> v125997(VarCurr,1) ) ).

tff(addAssignment_71240,axiom,
    ! [VarCurr: state_type] :
      ( v125982(VarCurr,0)
    <=> v125997(VarCurr,0) ) ).

tff(addAssignment_71239,axiom,
    ! [VarCurr: state_type] :
      ( v125997(VarCurr,0)
    <=> v126185(VarCurr) ) ).

tff(addAssignment_71238,axiom,
    ! [VarCurr: state_type] :
      ( v125997(VarCurr,1)
    <=> v126180(VarCurr) ) ).

tff(addAssignment_71237,axiom,
    ! [VarCurr: state_type] :
      ( v125997(VarCurr,2)
    <=> v125999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16121,axiom,
    ! [VarCurr: state_type] :
      ( v126185(VarCurr)
    <=> ( v126186(VarCurr)
        & v126189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16120,axiom,
    ! [VarCurr: state_type] :
      ( v126189(VarCurr)
    <=> ( v126005(VarCurr,0)
        | v126166(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16119,axiom,
    ! [VarCurr: state_type] :
      ( v126186(VarCurr)
    <=> ( v126187(VarCurr)
        | v126188(VarCurr) ) ) ).

tff(writeUnaryOperator_8972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126188(VarCurr)
    <=> v126166(VarCurr,0) ) ).

tff(writeUnaryOperator_8971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126187(VarCurr)
    <=> v126005(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16118,axiom,
    ! [VarCurr: state_type] :
      ( v126180(VarCurr)
    <=> ( v126181(VarCurr)
        & v126184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16117,axiom,
    ! [VarCurr: state_type] :
      ( v126184(VarCurr)
    <=> ( v126004(VarCurr)
        | v126167(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16116,axiom,
    ! [VarCurr: state_type] :
      ( v126181(VarCurr)
    <=> ( v126182(VarCurr)
        | v126183(VarCurr) ) ) ).

tff(writeUnaryOperator_8970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126183(VarCurr)
    <=> v126167(VarCurr) ) ).

tff(writeUnaryOperator_8969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126182(VarCurr)
    <=> v126004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16115,axiom,
    ! [VarCurr: state_type] :
      ( v125999(VarCurr)
    <=> ( v126000(VarCurr)
        & v126179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16114,axiom,
    ! [VarCurr: state_type] :
      ( v126179(VarCurr)
    <=> ( v126002(VarCurr)
        | v126174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16113,axiom,
    ! [VarCurr: state_type] :
      ( v126000(VarCurr)
    <=> ( v126001(VarCurr)
        | v126173(VarCurr) ) ) ).

tff(writeUnaryOperator_8968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126173(VarCurr)
    <=> v126174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16112,axiom,
    ! [VarCurr: state_type] :
      ( v126174(VarCurr)
    <=> ( v126175(VarCurr)
        & v126178(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5599,axiom,
    ! [VarCurr: state_type] :
      ( v126178(VarCurr)
    <=> ( v126005(VarCurr,2)
        | v126166(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16111,axiom,
    ! [VarCurr: state_type] :
      ( v126175(VarCurr)
    <=> ( v126176(VarCurr)
        | v126177(VarCurr) ) ) ).

tff(writeUnaryOperator_8967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126177(VarCurr)
    <=> v126166(VarCurr,2) ) ).

tff(writeUnaryOperator_8966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126176(VarCurr)
    <=> v126005(VarCurr,2) ) ).

tff(writeUnaryOperator_8965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126001(VarCurr)
    <=> v126002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16110,axiom,
    ! [VarCurr: state_type] :
      ( v126002(VarCurr)
    <=> ( v126003(VarCurr)
        | v126172(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5598,axiom,
    ! [VarCurr: state_type] :
      ( v126172(VarCurr)
    <=> ( v126005(VarCurr,1)
        & v126166(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16109,axiom,
    ! [VarCurr: state_type] :
      ( v126003(VarCurr)
    <=> ( v126004(VarCurr)
        & v126167(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16108,axiom,
    ! [VarCurr: state_type] :
      ( v126167(VarCurr)
    <=> ( v126168(VarCurr)
        & v126171(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5597,axiom,
    ! [VarCurr: state_type] :
      ( v126171(VarCurr)
    <=> ( v126005(VarCurr,1)
        | v126166(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16107,axiom,
    ! [VarCurr: state_type] :
      ( v126168(VarCurr)
    <=> ( v126169(VarCurr)
        | v126170(VarCurr) ) ) ).

tff(writeUnaryOperator_8964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126170(VarCurr)
    <=> v126166(VarCurr,1) ) ).

tff(writeUnaryOperator_8963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126169(VarCurr)
    <=> v126005(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16106,axiom,
    ! [VarCurr: state_type] :
      ( v126004(VarCurr)
    <=> ( v126005(VarCurr,0)
        & v126166(VarCurr,0) ) ) ).

tff(addAssignment_71236,axiom,
    ! [VarCurr: state_type] :
      ( v126166(VarCurr,0)
    <=> v125996(VarCurr) ) ).

tff(addAssignment_71235,axiom,
    ! [VarCurr: state_type] :
      ( ( v126166(VarCurr,2)
      <=> $false )
      & ( v126166(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71234,axiom,
    ! [VarCurr: state_type] :
      ( v126005(VarCurr,0)
    <=> v126161(VarCurr) ) ).

tff(addAssignment_71233,axiom,
    ! [VarCurr: state_type] :
      ( v126005(VarCurr,1)
    <=> v126156(VarCurr) ) ).

tff(addAssignment_71232,axiom,
    ! [VarCurr: state_type] :
      ( v126005(VarCurr,2)
    <=> v126007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16105,axiom,
    ! [VarCurr: state_type] :
      ( v126161(VarCurr)
    <=> ( v126162(VarCurr)
        & v126165(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16104,axiom,
    ! [VarCurr: state_type] :
      ( v126165(VarCurr)
    <=> ( v126013(VarCurr,0)
        | v126142(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16103,axiom,
    ! [VarCurr: state_type] :
      ( v126162(VarCurr)
    <=> ( v126163(VarCurr)
        | v126164(VarCurr) ) ) ).

tff(writeUnaryOperator_8962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126164(VarCurr)
    <=> v126142(VarCurr,0) ) ).

tff(writeUnaryOperator_8961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126163(VarCurr)
    <=> v126013(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16102,axiom,
    ! [VarCurr: state_type] :
      ( v126156(VarCurr)
    <=> ( v126157(VarCurr)
        & v126160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16101,axiom,
    ! [VarCurr: state_type] :
      ( v126160(VarCurr)
    <=> ( v126012(VarCurr)
        | v126143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16100,axiom,
    ! [VarCurr: state_type] :
      ( v126157(VarCurr)
    <=> ( v126158(VarCurr)
        | v126159(VarCurr) ) ) ).

tff(writeUnaryOperator_8960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126159(VarCurr)
    <=> v126143(VarCurr) ) ).

tff(writeUnaryOperator_8959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126158(VarCurr)
    <=> v126012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16099,axiom,
    ! [VarCurr: state_type] :
      ( v126007(VarCurr)
    <=> ( v126008(VarCurr)
        & v126155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16098,axiom,
    ! [VarCurr: state_type] :
      ( v126155(VarCurr)
    <=> ( v126010(VarCurr)
        | v126150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16097,axiom,
    ! [VarCurr: state_type] :
      ( v126008(VarCurr)
    <=> ( v126009(VarCurr)
        | v126149(VarCurr) ) ) ).

tff(writeUnaryOperator_8958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126149(VarCurr)
    <=> v126150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16096,axiom,
    ! [VarCurr: state_type] :
      ( v126150(VarCurr)
    <=> ( v126151(VarCurr)
        & v126154(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5596,axiom,
    ! [VarCurr: state_type] :
      ( v126154(VarCurr)
    <=> ( v126013(VarCurr,2)
        | v126142(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16095,axiom,
    ! [VarCurr: state_type] :
      ( v126151(VarCurr)
    <=> ( v126152(VarCurr)
        | v126153(VarCurr) ) ) ).

tff(writeUnaryOperator_8957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126153(VarCurr)
    <=> v126142(VarCurr,2) ) ).

tff(writeUnaryOperator_8956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126152(VarCurr)
    <=> v126013(VarCurr,2) ) ).

tff(writeUnaryOperator_8955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126009(VarCurr)
    <=> v126010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16094,axiom,
    ! [VarCurr: state_type] :
      ( v126010(VarCurr)
    <=> ( v126011(VarCurr)
        | v126148(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5595,axiom,
    ! [VarCurr: state_type] :
      ( v126148(VarCurr)
    <=> ( v126013(VarCurr,1)
        & v126142(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16093,axiom,
    ! [VarCurr: state_type] :
      ( v126011(VarCurr)
    <=> ( v126012(VarCurr)
        & v126143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16092,axiom,
    ! [VarCurr: state_type] :
      ( v126143(VarCurr)
    <=> ( v126144(VarCurr)
        & v126147(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5594,axiom,
    ! [VarCurr: state_type] :
      ( v126147(VarCurr)
    <=> ( v126013(VarCurr,1)
        | v126142(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16091,axiom,
    ! [VarCurr: state_type] :
      ( v126144(VarCurr)
    <=> ( v126145(VarCurr)
        | v126146(VarCurr) ) ) ).

tff(writeUnaryOperator_8954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126146(VarCurr)
    <=> v126142(VarCurr,1) ) ).

tff(writeUnaryOperator_8953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126145(VarCurr)
    <=> v126013(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16090,axiom,
    ! [VarCurr: state_type] :
      ( v126012(VarCurr)
    <=> ( v126013(VarCurr,0)
        & v126142(VarCurr,0) ) ) ).

tff(addAssignment_71231,axiom,
    ! [VarCurr: state_type] :
      ( v126142(VarCurr,0)
    <=> v125994(VarCurr) ) ).

tff(addAssignment_71230,axiom,
    ! [VarCurr: state_type] :
      ( ( v126142(VarCurr,2)
      <=> $false )
      & ( v126142(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71229,axiom,
    ! [VarCurr: state_type] :
      ( v126013(VarCurr,0)
    <=> v126137(VarCurr) ) ).

tff(addAssignment_71228,axiom,
    ! [VarCurr: state_type] :
      ( v126013(VarCurr,1)
    <=> v126132(VarCurr) ) ).

tff(addAssignment_71227,axiom,
    ! [VarCurr: state_type] :
      ( v126013(VarCurr,2)
    <=> v126015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16089,axiom,
    ! [VarCurr: state_type] :
      ( v126137(VarCurr)
    <=> ( v126138(VarCurr)
        & v126141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16088,axiom,
    ! [VarCurr: state_type] :
      ( v126141(VarCurr)
    <=> ( v126021(VarCurr,0)
        | v126118(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16087,axiom,
    ! [VarCurr: state_type] :
      ( v126138(VarCurr)
    <=> ( v126139(VarCurr)
        | v126140(VarCurr) ) ) ).

tff(writeUnaryOperator_8952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126140(VarCurr)
    <=> v126118(VarCurr,0) ) ).

tff(writeUnaryOperator_8951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126139(VarCurr)
    <=> v126021(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16086,axiom,
    ! [VarCurr: state_type] :
      ( v126132(VarCurr)
    <=> ( v126133(VarCurr)
        & v126136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16085,axiom,
    ! [VarCurr: state_type] :
      ( v126136(VarCurr)
    <=> ( v126020(VarCurr)
        | v126119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16084,axiom,
    ! [VarCurr: state_type] :
      ( v126133(VarCurr)
    <=> ( v126134(VarCurr)
        | v126135(VarCurr) ) ) ).

tff(writeUnaryOperator_8950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126135(VarCurr)
    <=> v126119(VarCurr) ) ).

tff(writeUnaryOperator_8949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126134(VarCurr)
    <=> v126020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16083,axiom,
    ! [VarCurr: state_type] :
      ( v126015(VarCurr)
    <=> ( v126016(VarCurr)
        & v126131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16082,axiom,
    ! [VarCurr: state_type] :
      ( v126131(VarCurr)
    <=> ( v126018(VarCurr)
        | v126126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16081,axiom,
    ! [VarCurr: state_type] :
      ( v126016(VarCurr)
    <=> ( v126017(VarCurr)
        | v126125(VarCurr) ) ) ).

tff(writeUnaryOperator_8948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126125(VarCurr)
    <=> v126126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16080,axiom,
    ! [VarCurr: state_type] :
      ( v126126(VarCurr)
    <=> ( v126127(VarCurr)
        & v126130(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5593,axiom,
    ! [VarCurr: state_type] :
      ( v126130(VarCurr)
    <=> ( v126021(VarCurr,2)
        | v126118(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16079,axiom,
    ! [VarCurr: state_type] :
      ( v126127(VarCurr)
    <=> ( v126128(VarCurr)
        | v126129(VarCurr) ) ) ).

tff(writeUnaryOperator_8947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126129(VarCurr)
    <=> v126118(VarCurr,2) ) ).

tff(writeUnaryOperator_8946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126128(VarCurr)
    <=> v126021(VarCurr,2) ) ).

tff(writeUnaryOperator_8945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126017(VarCurr)
    <=> v126018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16078,axiom,
    ! [VarCurr: state_type] :
      ( v126018(VarCurr)
    <=> ( v126019(VarCurr)
        | v126124(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5592,axiom,
    ! [VarCurr: state_type] :
      ( v126124(VarCurr)
    <=> ( v126021(VarCurr,1)
        & v126118(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16077,axiom,
    ! [VarCurr: state_type] :
      ( v126019(VarCurr)
    <=> ( v126020(VarCurr)
        & v126119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16076,axiom,
    ! [VarCurr: state_type] :
      ( v126119(VarCurr)
    <=> ( v126120(VarCurr)
        & v126123(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5591,axiom,
    ! [VarCurr: state_type] :
      ( v126123(VarCurr)
    <=> ( v126021(VarCurr,1)
        | v126118(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16075,axiom,
    ! [VarCurr: state_type] :
      ( v126120(VarCurr)
    <=> ( v126121(VarCurr)
        | v126122(VarCurr) ) ) ).

tff(writeUnaryOperator_8944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126122(VarCurr)
    <=> v126118(VarCurr,1) ) ).

tff(writeUnaryOperator_8943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126121(VarCurr)
    <=> v126021(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16074,axiom,
    ! [VarCurr: state_type] :
      ( v126020(VarCurr)
    <=> ( v126021(VarCurr,0)
        & v126118(VarCurr,0) ) ) ).

tff(addAssignment_71226,axiom,
    ! [VarCurr: state_type] :
      ( v126118(VarCurr,0)
    <=> v125992(VarCurr) ) ).

tff(addAssignment_71225,axiom,
    ! [VarCurr: state_type] :
      ( ( v126118(VarCurr,2)
      <=> $false )
      & ( v126118(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71224,axiom,
    ! [VarCurr: state_type] :
      ( v126021(VarCurr,0)
    <=> v126113(VarCurr) ) ).

tff(addAssignment_71223,axiom,
    ! [VarCurr: state_type] :
      ( v126021(VarCurr,1)
    <=> v126108(VarCurr) ) ).

tff(addAssignment_71222,axiom,
    ! [VarCurr: state_type] :
      ( v126021(VarCurr,2)
    <=> v126023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16073,axiom,
    ! [VarCurr: state_type] :
      ( v126113(VarCurr)
    <=> ( v126114(VarCurr)
        & v126117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16072,axiom,
    ! [VarCurr: state_type] :
      ( v126117(VarCurr)
    <=> ( v126029(VarCurr,0)
        | v126094(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16071,axiom,
    ! [VarCurr: state_type] :
      ( v126114(VarCurr)
    <=> ( v126115(VarCurr)
        | v126116(VarCurr) ) ) ).

tff(writeUnaryOperator_8942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126116(VarCurr)
    <=> v126094(VarCurr,0) ) ).

tff(writeUnaryOperator_8941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126115(VarCurr)
    <=> v126029(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16070,axiom,
    ! [VarCurr: state_type] :
      ( v126108(VarCurr)
    <=> ( v126109(VarCurr)
        & v126112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16069,axiom,
    ! [VarCurr: state_type] :
      ( v126112(VarCurr)
    <=> ( v126028(VarCurr)
        | v126095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16068,axiom,
    ! [VarCurr: state_type] :
      ( v126109(VarCurr)
    <=> ( v126110(VarCurr)
        | v126111(VarCurr) ) ) ).

tff(writeUnaryOperator_8940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126111(VarCurr)
    <=> v126095(VarCurr) ) ).

tff(writeUnaryOperator_8939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126110(VarCurr)
    <=> v126028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16067,axiom,
    ! [VarCurr: state_type] :
      ( v126023(VarCurr)
    <=> ( v126024(VarCurr)
        & v126107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16066,axiom,
    ! [VarCurr: state_type] :
      ( v126107(VarCurr)
    <=> ( v126026(VarCurr)
        | v126102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16065,axiom,
    ! [VarCurr: state_type] :
      ( v126024(VarCurr)
    <=> ( v126025(VarCurr)
        | v126101(VarCurr) ) ) ).

tff(writeUnaryOperator_8938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126101(VarCurr)
    <=> v126102(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16064,axiom,
    ! [VarCurr: state_type] :
      ( v126102(VarCurr)
    <=> ( v126103(VarCurr)
        & v126106(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5590,axiom,
    ! [VarCurr: state_type] :
      ( v126106(VarCurr)
    <=> ( v126029(VarCurr,2)
        | v126094(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16063,axiom,
    ! [VarCurr: state_type] :
      ( v126103(VarCurr)
    <=> ( v126104(VarCurr)
        | v126105(VarCurr) ) ) ).

tff(writeUnaryOperator_8937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126105(VarCurr)
    <=> v126094(VarCurr,2) ) ).

tff(writeUnaryOperator_8936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126104(VarCurr)
    <=> v126029(VarCurr,2) ) ).

tff(writeUnaryOperator_8935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126025(VarCurr)
    <=> v126026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16062,axiom,
    ! [VarCurr: state_type] :
      ( v126026(VarCurr)
    <=> ( v126027(VarCurr)
        | v126100(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5589,axiom,
    ! [VarCurr: state_type] :
      ( v126100(VarCurr)
    <=> ( v126029(VarCurr,1)
        & v126094(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16061,axiom,
    ! [VarCurr: state_type] :
      ( v126027(VarCurr)
    <=> ( v126028(VarCurr)
        & v126095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16060,axiom,
    ! [VarCurr: state_type] :
      ( v126095(VarCurr)
    <=> ( v126096(VarCurr)
        & v126099(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5588,axiom,
    ! [VarCurr: state_type] :
      ( v126099(VarCurr)
    <=> ( v126029(VarCurr,1)
        | v126094(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16059,axiom,
    ! [VarCurr: state_type] :
      ( v126096(VarCurr)
    <=> ( v126097(VarCurr)
        | v126098(VarCurr) ) ) ).

tff(writeUnaryOperator_8934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126098(VarCurr)
    <=> v126094(VarCurr,1) ) ).

tff(writeUnaryOperator_8933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126097(VarCurr)
    <=> v126029(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16058,axiom,
    ! [VarCurr: state_type] :
      ( v126028(VarCurr)
    <=> ( v126029(VarCurr,0)
        & v126094(VarCurr,0) ) ) ).

tff(addAssignment_71221,axiom,
    ! [VarCurr: state_type] :
      ( v126094(VarCurr,0)
    <=> v125990(VarCurr) ) ).

tff(addAssignment_71220,axiom,
    ! [VarCurr: state_type] :
      ( ( v126094(VarCurr,2)
      <=> $false )
      & ( v126094(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71219,axiom,
    ! [VarCurr: state_type] :
      ( v126029(VarCurr,0)
    <=> v126089(VarCurr) ) ).

tff(addAssignment_71218,axiom,
    ! [VarCurr: state_type] :
      ( v126029(VarCurr,1)
    <=> v126084(VarCurr) ) ).

tff(addAssignment_71217,axiom,
    ! [VarCurr: state_type] :
      ( v126029(VarCurr,2)
    <=> v126031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16057,axiom,
    ! [VarCurr: state_type] :
      ( v126089(VarCurr)
    <=> ( v126090(VarCurr)
        & v126093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16056,axiom,
    ! [VarCurr: state_type] :
      ( v126093(VarCurr)
    <=> ( v126037(VarCurr,0)
        | v126070(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16055,axiom,
    ! [VarCurr: state_type] :
      ( v126090(VarCurr)
    <=> ( v126091(VarCurr)
        | v126092(VarCurr) ) ) ).

tff(writeUnaryOperator_8932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126092(VarCurr)
    <=> v126070(VarCurr,0) ) ).

tff(writeUnaryOperator_8931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126091(VarCurr)
    <=> v126037(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16054,axiom,
    ! [VarCurr: state_type] :
      ( v126084(VarCurr)
    <=> ( v126085(VarCurr)
        & v126088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16053,axiom,
    ! [VarCurr: state_type] :
      ( v126088(VarCurr)
    <=> ( v126036(VarCurr)
        | v126071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16052,axiom,
    ! [VarCurr: state_type] :
      ( v126085(VarCurr)
    <=> ( v126086(VarCurr)
        | v126087(VarCurr) ) ) ).

tff(writeUnaryOperator_8930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126087(VarCurr)
    <=> v126071(VarCurr) ) ).

tff(writeUnaryOperator_8929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126086(VarCurr)
    <=> v126036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16051,axiom,
    ! [VarCurr: state_type] :
      ( v126031(VarCurr)
    <=> ( v126032(VarCurr)
        & v126083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16050,axiom,
    ! [VarCurr: state_type] :
      ( v126083(VarCurr)
    <=> ( v126034(VarCurr)
        | v126078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16049,axiom,
    ! [VarCurr: state_type] :
      ( v126032(VarCurr)
    <=> ( v126033(VarCurr)
        | v126077(VarCurr) ) ) ).

tff(writeUnaryOperator_8928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126077(VarCurr)
    <=> v126078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16048,axiom,
    ! [VarCurr: state_type] :
      ( v126078(VarCurr)
    <=> ( v126079(VarCurr)
        & v126082(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5587,axiom,
    ! [VarCurr: state_type] :
      ( v126082(VarCurr)
    <=> ( v126037(VarCurr,2)
        | v126070(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16047,axiom,
    ! [VarCurr: state_type] :
      ( v126079(VarCurr)
    <=> ( v126080(VarCurr)
        | v126081(VarCurr) ) ) ).

tff(writeUnaryOperator_8927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126081(VarCurr)
    <=> v126070(VarCurr,2) ) ).

tff(writeUnaryOperator_8926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126080(VarCurr)
    <=> v126037(VarCurr,2) ) ).

tff(writeUnaryOperator_8925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126033(VarCurr)
    <=> v126034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16046,axiom,
    ! [VarCurr: state_type] :
      ( v126034(VarCurr)
    <=> ( v126035(VarCurr)
        | v126076(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5586,axiom,
    ! [VarCurr: state_type] :
      ( v126076(VarCurr)
    <=> ( v126037(VarCurr,1)
        & v126070(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16045,axiom,
    ! [VarCurr: state_type] :
      ( v126035(VarCurr)
    <=> ( v126036(VarCurr)
        & v126071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16044,axiom,
    ! [VarCurr: state_type] :
      ( v126071(VarCurr)
    <=> ( v126072(VarCurr)
        & v126075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5585,axiom,
    ! [VarCurr: state_type] :
      ( v126075(VarCurr)
    <=> ( v126037(VarCurr,1)
        | v126070(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16043,axiom,
    ! [VarCurr: state_type] :
      ( v126072(VarCurr)
    <=> ( v126073(VarCurr)
        | v126074(VarCurr) ) ) ).

tff(writeUnaryOperator_8924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126074(VarCurr)
    <=> v126070(VarCurr,1) ) ).

tff(writeUnaryOperator_8923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126073(VarCurr)
    <=> v126037(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16042,axiom,
    ! [VarCurr: state_type] :
      ( v126036(VarCurr)
    <=> ( v126037(VarCurr,0)
        & v126070(VarCurr,0) ) ) ).

tff(addAssignment_71216,axiom,
    ! [VarCurr: state_type] :
      ( v126070(VarCurr,0)
    <=> v125988(VarCurr) ) ).

tff(addAssignment_71215,axiom,
    ! [VarCurr: state_type] :
      ( ( v126070(VarCurr,2)
      <=> $false )
      & ( v126070(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71214,axiom,
    ! [VarCurr: state_type] :
      ( v126037(VarCurr,0)
    <=> v126065(VarCurr) ) ).

tff(addAssignment_71213,axiom,
    ! [VarCurr: state_type] :
      ( v126037(VarCurr,1)
    <=> v126060(VarCurr) ) ).

tff(addAssignment_71212,axiom,
    ! [VarCurr: state_type] :
      ( v126037(VarCurr,2)
    <=> v126039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16041,axiom,
    ! [VarCurr: state_type] :
      ( v126065(VarCurr)
    <=> ( v126066(VarCurr)
        & v126069(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16040,axiom,
    ! [VarCurr: state_type] :
      ( v126069(VarCurr)
    <=> ( v126045(VarCurr,0)
        | v126046(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16039,axiom,
    ! [VarCurr: state_type] :
      ( v126066(VarCurr)
    <=> ( v126067(VarCurr)
        | v126068(VarCurr) ) ) ).

tff(writeUnaryOperator_8922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126068(VarCurr)
    <=> v126046(VarCurr,0) ) ).

tff(writeUnaryOperator_8921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126067(VarCurr)
    <=> v126045(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16038,axiom,
    ! [VarCurr: state_type] :
      ( v126060(VarCurr)
    <=> ( v126061(VarCurr)
        & v126064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16037,axiom,
    ! [VarCurr: state_type] :
      ( v126064(VarCurr)
    <=> ( v126044(VarCurr)
        | v126047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16036,axiom,
    ! [VarCurr: state_type] :
      ( v126061(VarCurr)
    <=> ( v126062(VarCurr)
        | v126063(VarCurr) ) ) ).

tff(writeUnaryOperator_8920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126063(VarCurr)
    <=> v126047(VarCurr) ) ).

tff(writeUnaryOperator_8919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126062(VarCurr)
    <=> v126044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16035,axiom,
    ! [VarCurr: state_type] :
      ( v126039(VarCurr)
    <=> ( v126040(VarCurr)
        & v126059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16034,axiom,
    ! [VarCurr: state_type] :
      ( v126059(VarCurr)
    <=> ( v126042(VarCurr)
        | v126054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16033,axiom,
    ! [VarCurr: state_type] :
      ( v126040(VarCurr)
    <=> ( v126041(VarCurr)
        | v126053(VarCurr) ) ) ).

tff(writeUnaryOperator_8918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126053(VarCurr)
    <=> v126054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16032,axiom,
    ! [VarCurr: state_type] :
      ( v126054(VarCurr)
    <=> ( v126055(VarCurr)
        & v126058(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5584,axiom,
    ! [VarCurr: state_type] :
      ( v126058(VarCurr)
    <=> ( v126045(VarCurr,2)
        | v126046(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16031,axiom,
    ! [VarCurr: state_type] :
      ( v126055(VarCurr)
    <=> ( v126056(VarCurr)
        | v126057(VarCurr) ) ) ).

tff(writeUnaryOperator_8917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126057(VarCurr)
    <=> v126046(VarCurr,2) ) ).

tff(writeUnaryOperator_8916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126056(VarCurr)
    <=> v126045(VarCurr,2) ) ).

tff(writeUnaryOperator_8915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126041(VarCurr)
    <=> v126042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16030,axiom,
    ! [VarCurr: state_type] :
      ( v126042(VarCurr)
    <=> ( v126043(VarCurr)
        | v126052(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5583,axiom,
    ! [VarCurr: state_type] :
      ( v126052(VarCurr)
    <=> ( v126045(VarCurr,1)
        & v126046(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16029,axiom,
    ! [VarCurr: state_type] :
      ( v126043(VarCurr)
    <=> ( v126044(VarCurr)
        & v126047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16028,axiom,
    ! [VarCurr: state_type] :
      ( v126047(VarCurr)
    <=> ( v126048(VarCurr)
        & v126051(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5582,axiom,
    ! [VarCurr: state_type] :
      ( v126051(VarCurr)
    <=> ( v126045(VarCurr,1)
        | v126046(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16027,axiom,
    ! [VarCurr: state_type] :
      ( v126048(VarCurr)
    <=> ( v126049(VarCurr)
        | v126050(VarCurr) ) ) ).

tff(writeUnaryOperator_8914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126050(VarCurr)
    <=> v126046(VarCurr,1) ) ).

tff(writeUnaryOperator_8913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v126049(VarCurr)
    <=> v126045(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16026,axiom,
    ! [VarCurr: state_type] :
      ( v126044(VarCurr)
    <=> ( v126045(VarCurr,0)
        & v126046(VarCurr,0) ) ) ).

tff(addAssignment_71211,axiom,
    ! [VarCurr: state_type] :
      ( v126046(VarCurr,0)
    <=> v125986(VarCurr) ) ).

tff(addAssignment_71210,axiom,
    ! [VarCurr: state_type] :
      ( ( v126046(VarCurr,2)
      <=> $false )
      & ( v126046(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71209,axiom,
    ! [VarCurr: state_type] :
      ( v126045(VarCurr,0)
    <=> v125984(VarCurr) ) ).

tff(addAssignment_71208,axiom,
    ! [VarCurr: state_type] :
      ( ( v126045(VarCurr,2)
      <=> $false )
      & ( v126045(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71207,axiom,
    ! [VarCurr: state_type] :
      ( v125996(VarCurr)
    <=> v114692(VarCurr,15) ) ).

tff(addAssignment_71206,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,15)
    <=> v114694(VarCurr,15) ) ).

tff(addAssignment_71205,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,15)
    <=> v114696(VarCurr,15) ) ).

tff(addAssignment_71204,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,15)
    <=> v114697(VarCurr,15) ) ).

tff(addAssignment_71203,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,15)
    <=> v113918(VarCurr,15) ) ).

tff(addAssignment_71202,axiom,
    ! [VarCurr: state_type] :
      ( v125994(VarCurr)
    <=> v114685(VarCurr,15) ) ).

tff(addAssignment_71201,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,15)
    <=> v114686(VarCurr,15) ) ).

tff(addAssignment_71200,axiom,
    ! [VarCurr: state_type] :
      ( v125992(VarCurr)
    <=> v114661(VarCurr,15) ) ).

tff(addAssignment_71199,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,15)
    <=> v114662(VarCurr,15) ) ).

tff(addAssignment_71198,axiom,
    ! [VarCurr: state_type] :
      ( v125990(VarCurr)
    <=> v114633(VarCurr,15) ) ).

tff(addAssignment_71197,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,15)
    <=> v114635(VarCurr,15) ) ).

tff(addAssignment_71196,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,15)
    <=> v114637(VarCurr,15) ) ).

tff(addAssignment_71195,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,15)
    <=> v114638(VarCurr,15) ) ).

tff(addAssignment_71194,axiom,
    ! [VarCurr: state_type] :
      ( v125988(VarCurr)
    <=> v114605(VarCurr,15) ) ).

tff(addAssignment_71193,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,15)
    <=> v114607(VarCurr,15) ) ).

tff(addAssignment_71192,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,15)
    <=> v114609(VarCurr,15) ) ).

tff(addAssignment_71191,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,15)
    <=> v114610(VarCurr,15) ) ).

tff(addAssignment_71190,axiom,
    ! [VarCurr: state_type] :
      ( v125986(VarCurr)
    <=> v114577(VarCurr,15) ) ).

tff(addAssignment_71189,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,15)
    <=> v114579(VarCurr,15) ) ).

tff(addAssignment_71188,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,15)
    <=> v114581(VarCurr,15) ) ).

tff(addAssignment_71187,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,15)
    <=> v114582(VarCurr,15) ) ).

tff(addAssignment_71186,axiom,
    ! [VarCurr: state_type] :
      ( v125984(VarCurr)
    <=> v114549(VarCurr,15) ) ).

tff(addAssignment_71185,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,15)
    <=> v114551(VarCurr,15) ) ).

tff(addAssignment_71184,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,15)
    <=> v114553(VarCurr,15) ) ).

tff(addAssignment_71183,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,15)
    <=> v114554(VarCurr,15) ) ).

tff(addAssignment_71182,axiom,
    ! [VarCurr: state_type] :
      ( v125970(VarCurr)
    <=> v125972(VarCurr) ) ).

tff(addAssignment_71181,axiom,
    ! [VarCurr: state_type] :
      ( v125972(VarCurr)
    <=> v125946(VarCurr) ) ).

tff(addAssignment_71180,axiom,
    ! [VarCurr: state_type] :
      ( v125966(VarCurr)
    <=> v125968(VarCurr) ) ).

tff(addAssignment_71179,axiom,
    ! [VarCurr: state_type] :
      ( v125968(VarCurr)
    <=> v125938(VarCurr) ) ).

tff(addAssignment_71178,axiom,
    ! [VarCurr: state_type] :
      ( v125942(VarCurr)
    <=> v125944(VarCurr) ) ).

tff(addAssignment_71177,axiom,
    ! [VarCurr: state_type] :
      ( v125944(VarCurr)
    <=> v125946(VarCurr) ) ).

tff(addAssignment_71176,axiom,
    ! [VarCurr: state_type] :
      ( v125946(VarCurr)
    <=> v125948(VarCurr) ) ).

tff(addAssignment_71175,axiom,
    ! [VarCurr: state_type] :
      ( v125948(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_71174,axiom,
    ! [VarCurr: state_type] :
      ( v125934(VarCurr)
    <=> v125936(VarCurr) ) ).

tff(addAssignment_71173,axiom,
    ! [VarCurr: state_type] :
      ( v125936(VarCurr)
    <=> v125938(VarCurr) ) ).

tff(addAssignment_71172,axiom,
    ! [VarCurr: state_type] :
      ( v125938(VarCurr)
    <=> v125940(VarCurr) ) ).

tff(addAssignment_71171,axiom,
    ! [VarCurr: state_type] :
      ( v125940(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16025,axiom,
    ! [VarCurr: state_type] :
      ( v125125(VarCurr)
    <=> ( v125924(VarCurr)
        & v125834(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5581,axiom,
    ! [VarCurr: state_type] :
      ( v125924(VarCurr)
    <=> ( v125127(VarCurr,1)
        & v125773(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1242,axiom,
    ! [VarCurr: state_type] :
      ( v125834(VarCurr)
    <=> ( ( v125836(VarCurr,4)
        <=> $false )
        & ( v125836(VarCurr,3)
        <=> $false )
        & ( v125836(VarCurr,2)
        <=> $false )
        & ( v125836(VarCurr,1)
        <=> $false )
        & ( v125836(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125836(VarCurr,B)
      <=> v125838(VarCurr,B) ) ) ).

tff(addAssignment_71169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125838(VarCurr,B)
      <=> v125840(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125906(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v125840(VarNext,B)
            <=> v125840(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1633,axiom,
    ! [VarNext: state_type] :
      ( v125906(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125840(VarNext,B)
          <=> v125916(VarNext,B) ) ) ) ).

tff(addAssignment_71168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125916(VarNext,B)
          <=> v125914(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125917(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125914(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1179,axiom,
    ! [VarCurr: state_type] :
      ( v125917(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125914(VarCurr,B)
          <=> v125850(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16024,axiom,
    ! [VarCurr: state_type] :
      ( v125917(VarCurr)
    <=> ( v125918(VarCurr)
        & v125919(VarCurr) ) ) ).

tff(writeUnaryOperator_8912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125919(VarCurr)
    <=> v125846(VarCurr) ) ).

tff(writeUnaryOperator_8911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125918(VarCurr)
    <=> v125842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125906(VarNext)
      <=> v125907(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125907(VarNext)
      <=> ( v125908(VarNext)
          & v125901(VarNext) ) ) ) ).

tff(writeUnaryOperator_8910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125908(VarNext)
      <=> v125910(VarNext) ) ) ).

tff(addAssignment_71167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125910(VarNext)
      <=> v125901(VarCurr) ) ) ).

tff(addAssignment_71166,axiom,
    ! [VarCurr: state_type] :
      ( v125901(VarCurr)
    <=> v125903(VarCurr) ) ).

tff(addAssignment_71165,axiom,
    ! [VarCurr: state_type] :
      ( v125903(VarCurr)
    <=> v125607(VarCurr) ) ).

tff(addAssignment_71164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125850(VarCurr,B)
      <=> v125852(VarCurr,B) ) ) ).

tff(addAssignment_71163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125852(VarCurr,B)
      <=> v125854(VarCurr,B) ) ) ).

tff(addAssignment_71162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125854(VarCurr,B)
      <=> v125856(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125858(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125856(VarCurr,B)
          <=> v125870(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1178,axiom,
    ! [VarCurr: state_type] :
      ( v125858(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125856(VarCurr,B)
          <=> v125863(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125865(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125870(VarCurr,B)
          <=> v125871(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1177,axiom,
    ! [VarCurr: state_type] :
      ( v125865(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125870(VarCurr,B)
          <=> v125868(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125871(VarCurr,B)
          <=> v125872(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1176,axiom,
    ! [VarCurr: state_type] :
      ( v125834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125871(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_71161,axiom,
    ! [VarCurr: state_type] :
      ( v125872(VarCurr,0)
    <=> v125898(VarCurr) ) ).

tff(addAssignment_71160,axiom,
    ! [VarCurr: state_type] :
      ( v125872(VarCurr,1)
    <=> v125896(VarCurr) ) ).

tff(addAssignment_71159,axiom,
    ! [VarCurr: state_type] :
      ( v125872(VarCurr,2)
    <=> v125892(VarCurr) ) ).

tff(addAssignment_71158,axiom,
    ! [VarCurr: state_type] :
      ( v125872(VarCurr,3)
    <=> v125888(VarCurr) ) ).

tff(addAssignment_71157,axiom,
    ! [VarCurr: state_type] :
      ( v125872(VarCurr,4)
    <=> v125874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16021,axiom,
    ! [VarCurr: state_type] :
      ( v125896(VarCurr)
    <=> ( v125897(VarCurr)
        & v125899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16020,axiom,
    ! [VarCurr: state_type] :
      ( v125899(VarCurr)
    <=> ( v125836(VarCurr,0)
        | v125883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5580,axiom,
    ! [VarCurr: state_type] :
      ( v125897(VarCurr)
    <=> ( v125898(VarCurr)
        | v125836(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125898(VarCurr)
    <=> v125836(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16019,axiom,
    ! [VarCurr: state_type] :
      ( v125892(VarCurr)
    <=> ( v125893(VarCurr)
        & v125895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16018,axiom,
    ! [VarCurr: state_type] :
      ( v125895(VarCurr)
    <=> ( v125881(VarCurr)
        | v125884(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5579,axiom,
    ! [VarCurr: state_type] :
      ( v125893(VarCurr)
    <=> ( v125894(VarCurr)
        | v125836(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125894(VarCurr)
    <=> v125881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16017,axiom,
    ! [VarCurr: state_type] :
      ( v125888(VarCurr)
    <=> ( v125889(VarCurr)
        & v125891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16016,axiom,
    ! [VarCurr: state_type] :
      ( v125891(VarCurr)
    <=> ( v125879(VarCurr)
        | v125885(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5578,axiom,
    ! [VarCurr: state_type] :
      ( v125889(VarCurr)
    <=> ( v125890(VarCurr)
        | v125836(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125890(VarCurr)
    <=> v125879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16015,axiom,
    ! [VarCurr: state_type] :
      ( v125874(VarCurr)
    <=> ( v125875(VarCurr)
        & v125886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16014,axiom,
    ! [VarCurr: state_type] :
      ( v125886(VarCurr)
    <=> ( v125877(VarCurr)
        | v125887(VarCurr) ) ) ).

tff(writeUnaryOperator_8906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125887(VarCurr)
    <=> v125836(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5577,axiom,
    ! [VarCurr: state_type] :
      ( v125875(VarCurr)
    <=> ( v125876(VarCurr)
        | v125836(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125876(VarCurr)
    <=> v125877(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5576,axiom,
    ! [VarCurr: state_type] :
      ( v125877(VarCurr)
    <=> ( v125836(VarCurr,3)
        | v125878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16013,axiom,
    ! [VarCurr: state_type] :
      ( v125878(VarCurr)
    <=> ( v125879(VarCurr)
        & v125885(VarCurr) ) ) ).

tff(writeUnaryOperator_8904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125885(VarCurr)
    <=> v125836(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5575,axiom,
    ! [VarCurr: state_type] :
      ( v125879(VarCurr)
    <=> ( v125836(VarCurr,2)
        | v125880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16012,axiom,
    ! [VarCurr: state_type] :
      ( v125880(VarCurr)
    <=> ( v125881(VarCurr)
        & v125884(VarCurr) ) ) ).

tff(writeUnaryOperator_8903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125884(VarCurr)
    <=> v125836(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5574,axiom,
    ! [VarCurr: state_type] :
      ( v125881(VarCurr)
    <=> ( v125836(VarCurr,1)
        | v125882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16011,axiom,
    ! [VarCurr: state_type] :
      ( v125882(VarCurr)
    <=> ( v125836(VarCurr,0)
        & v125883(VarCurr) ) ) ).

tff(writeUnaryOperator_8902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125883(VarCurr)
    <=> v125836(VarCurr,1) ) ).

tff(addAssignment_71156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125868(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16010,axiom,
    ! [VarCurr: state_type] :
      ( v125865(VarCurr)
    <=> ( v125412(VarCurr)
        | v125426(VarCurr) ) ) ).

tff(addAssignment_71155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125863(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16009,axiom,
    ! [VarCurr: state_type] :
      ( v125858(VarCurr)
    <=> ( v125860(VarCurr)
        | v125424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16008,axiom,
    ! [VarCurr: state_type] :
      ( v125860(VarCurr)
    <=> ( v125861(VarCurr)
        | v125422(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16007,axiom,
    ! [VarCurr: state_type] :
      ( v125861(VarCurr)
    <=> ( v125392(VarCurr)
        | v125402(VarCurr) ) ) ).

tff(addAssignment_71154,axiom,
    ! [VarCurr: state_type] :
      ( v125846(VarCurr)
    <=> v125848(VarCurr) ) ).

tff(addAssignment_71153,axiom,
    ! [VarCurr: state_type] :
      ( v125848(VarCurr)
    <=> v125145(VarCurr) ) ).

tff(addAssignment_71152,axiom,
    ! [VarCurr: state_type] :
      ( v125842(VarCurr)
    <=> v125844(VarCurr) ) ).

tff(addAssignment_71151,axiom,
    ! [VarCurr: state_type] :
      ( v125844(VarCurr)
    <=> v125137(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1241,axiom,
    ! [VarCurr: state_type] :
      ( v125773(VarCurr)
    <=> ( ( v125775(VarCurr,1)
        <=> $false )
        & ( v125775(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v125775(VarCurr,B)
      <=> v125777(VarCurr,B) ) ) ).

tff(addAssignment_71149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v125777(VarCurr,B)
      <=> v125779(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125816(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v125779(VarNext,B)
            <=> v125779(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1632,axiom,
    ! [VarNext: state_type] :
      ( v125816(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125779(VarNext,B)
          <=> v125826(VarNext,B) ) ) ) ).

tff(addAssignment_71148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125826(VarNext,B)
          <=> v125824(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125824(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1175,axiom,
    ! [VarCurr: state_type] :
      ( v125827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125824(VarCurr,B)
          <=> v125789(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16006,axiom,
    ! [VarCurr: state_type] :
      ( v125827(VarCurr)
    <=> ( v125828(VarCurr)
        & v125829(VarCurr) ) ) ).

tff(writeUnaryOperator_8901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125829(VarCurr)
    <=> v125785(VarCurr) ) ).

tff(writeUnaryOperator_8900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125828(VarCurr)
    <=> v125781(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125816(VarNext)
      <=> v125817(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125817(VarNext)
      <=> ( v125818(VarNext)
          & v125811(VarNext) ) ) ) ).

tff(writeUnaryOperator_8899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125818(VarNext)
      <=> v125820(VarNext) ) ) ).

tff(addAssignment_71147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125820(VarNext)
      <=> v125811(VarCurr) ) ) ).

tff(addAssignment_71146,axiom,
    ! [VarCurr: state_type] :
      ( v125811(VarCurr)
    <=> v125813(VarCurr) ) ).

tff(addAssignment_71145,axiom,
    ! [VarCurr: state_type] :
      ( v125813(VarCurr)
    <=> v125607(VarCurr) ) ).

tff(addAssignment_71144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v125789(VarCurr,B)
      <=> v125791(VarCurr,B) ) ) ).

tff(addAssignment_71143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v125791(VarCurr,B)
      <=> v125793(VarCurr,B) ) ) ).

tff(addAssignment_71142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v125793(VarCurr,B)
      <=> v125795(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125795(VarCurr,B)
          <=> v125802(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1174,axiom,
    ! [VarCurr: state_type] :
      ( v125797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125795(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125773(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125802(VarCurr,B)
          <=> v125803(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1173,axiom,
    ! [VarCurr: state_type] :
      ( v125773(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125802(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_71141,axiom,
    ! [VarCurr: state_type] :
      ( v125803(VarCurr,0)
    <=> v125807(VarCurr) ) ).

tff(addAssignment_71140,axiom,
    ! [VarCurr: state_type] :
      ( v125803(VarCurr,1)
    <=> v125805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16003,axiom,
    ! [VarCurr: state_type] :
      ( v125805(VarCurr)
    <=> ( v125806(VarCurr)
        & v125808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16002,axiom,
    ! [VarCurr: state_type] :
      ( v125808(VarCurr)
    <=> ( v125775(VarCurr,0)
        | v125809(VarCurr) ) ) ).

tff(writeUnaryOperator_8898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125809(VarCurr)
    <=> v125775(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5573,axiom,
    ! [VarCurr: state_type] :
      ( v125806(VarCurr)
    <=> ( v125807(VarCurr)
        | v125775(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125807(VarCurr)
    <=> v125775(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16001,axiom,
    ! [VarCurr: state_type] :
      ( v125797(VarCurr)
    <=> ( v125799(VarCurr)
        | v125800(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5572,axiom,
    ! [VarCurr: state_type] :
      ( v125800(VarCurr)
    <=> ( v125127(VarCurr,1)
        & v125640(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5571,axiom,
    ! [VarCurr: state_type] :
      ( v125799(VarCurr)
    <=> ( v125127(VarCurr,3)
        & v125698(VarCurr) ) ) ).

tff(addAssignment_71139,axiom,
    ! [VarCurr: state_type] :
      ( v125785(VarCurr)
    <=> v125787(VarCurr) ) ).

tff(addAssignment_71138,axiom,
    ! [VarCurr: state_type] :
      ( v125787(VarCurr)
    <=> v125145(VarCurr) ) ).

tff(addAssignment_71137,axiom,
    ! [VarCurr: state_type] :
      ( v125781(VarCurr)
    <=> v125783(VarCurr) ) ).

tff(addAssignment_71136,axiom,
    ! [VarCurr: state_type] :
      ( v125783(VarCurr)
    <=> v125137(VarCurr) ) ).

tff(addAssignment_71135,axiom,
    ! [VarCurr: state_type] :
      ( v125127(VarCurr,1)
    <=> v125129(VarCurr,1) ) ).

tff(addAssignment_71134,axiom,
    ! [VarCurr: state_type] :
      ( v125129(VarCurr,1)
    <=> v125131(VarCurr,1) ) ).

tff(addAssignment_71133,axiom,
    ! [VarNext: state_type] :
      ( v125131(VarNext,1)
    <=> v125765(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125766(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v125765(VarNext,B)
            <=> v125131(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1631,axiom,
    ! [VarNext: state_type] :
      ( v125766(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125765(VarNext,B)
          <=> v125691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125766(VarNext)
      <=> v125767(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125767(VarNext)
      <=> ( v125769(VarNext)
          & v125676(VarNext) ) ) ) ).

tff(writeUnaryOperator_8896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125769(VarNext)
      <=> v125685(VarNext) ) ) ).

tff(addAssignment_71132,axiom,
    ! [VarCurr: state_type] :
      ( v125149(VarCurr,1)
    <=> v125151(VarCurr,1) ) ).

tff(addAssignment_71131,axiom,
    ! [VarCurr: state_type] :
      ( v125151(VarCurr,1)
    <=> v125153(VarCurr,1) ) ).

tff(addAssignment_71130,axiom,
    ! [VarCurr: state_type] :
      ( v125153(VarCurr,1)
    <=> v125674(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_74,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125756(VarCurr)
     => ( v125155(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_103,axiom,
    ! [VarCurr: state_type] :
      ( v125756(VarCurr)
     => ( v125155(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15998,axiom,
    ! [VarCurr: state_type] :
      ( v125756(VarCurr)
    <=> ( v125757(VarCurr)
        | v125758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15997,axiom,
    ! [VarCurr: state_type] :
      ( v125758(VarCurr)
    <=> ( v125759(VarCurr)
        & v125760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15996,axiom,
    ! [VarCurr: state_type] :
      ( v125760(VarCurr)
    <=> ( v125761(VarCurr)
        & v125657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15995,axiom,
    ! [VarCurr: state_type] :
      ( v125761(VarCurr)
    <=> ( v125762(VarCurr)
        & v125763(VarCurr) ) ) ).

tff(writeUnaryOperator_8895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125763(VarCurr)
    <=> v125649(VarCurr) ) ).

tff(writeUnaryOperator_8894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125762(VarCurr)
    <=> v125640(VarCurr) ) ).

tff(writeUnaryOperator_8893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125759(VarCurr)
    <=> v125659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15994,axiom,
    ! [VarCurr: state_type] :
      ( v125757(VarCurr)
    <=> ( v125731(VarCurr)
        & v125659(VarCurr) ) ) ).

tff(writeUnaryOperator_8892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125127(VarCurr,0)
    <=> v125636(VarCurr) ) ).

tff(addAssignment_71129,axiom,
    ! [VarCurr: state_type] :
      ( v125636(VarCurr)
    <=> v125129(VarCurr,0) ) ).

tff(addAssignment_71128,axiom,
    ! [VarCurr: state_type] :
      ( v125129(VarCurr,0)
    <=> v125131(VarCurr,0) ) ).

tff(addAssignment_71127,axiom,
    ! [VarNext: state_type] :
      ( v125131(VarNext,0)
    <=> v125747(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125748(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v125747(VarNext,B)
            <=> v125131(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1630,axiom,
    ! [VarNext: state_type] :
      ( v125748(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125747(VarNext,B)
          <=> v125691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125748(VarNext)
      <=> v125749(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125749(VarNext)
      <=> ( v125751(VarNext)
          & v125676(VarNext) ) ) ) ).

tff(writeUnaryOperator_8891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125751(VarNext)
      <=> v125685(VarNext) ) ) ).

tff(addAssignment_71126,axiom,
    ! [VarCurr: state_type] :
      ( v125149(VarCurr,0)
    <=> v125151(VarCurr,0) ) ).

tff(addAssignment_71125,axiom,
    ! [VarCurr: state_type] :
      ( v125151(VarCurr,0)
    <=> v125153(VarCurr,0) ) ).

tff(addAssignment_71124,axiom,
    ! [VarCurr: state_type] :
      ( v125153(VarCurr,0)
    <=> v125674(VarCurr,0) ) ).

tff(writeUnaryOperator_8890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125638(VarCurr)
    <=> v125155(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125726(VarCurr)
     => ( v125155(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1172,axiom,
    ! [VarCurr: state_type] :
      ( v125726(VarCurr)
     => ( v125155(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15991,axiom,
    ! [VarCurr: state_type] :
      ( v125726(VarCurr)
    <=> ( v125727(VarCurr)
        | v125740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15990,axiom,
    ! [VarCurr: state_type] :
      ( v125740(VarCurr)
    <=> ( v125741(VarCurr)
        & v125744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15989,axiom,
    ! [VarCurr: state_type] :
      ( v125744(VarCurr)
    <=> ( v125712(VarCurr)
        & v125715(VarCurr) ) ) ).

tff(writeUnaryOperator_8889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125741(VarCurr)
    <=> v125742(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15988,axiom,
    ! [VarCurr: state_type] :
      ( v125742(VarCurr)
    <=> ( v125743(VarCurr)
        | v125672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15987,axiom,
    ! [VarCurr: state_type] :
      ( v125743(VarCurr)
    <=> ( v125659(VarCurr)
        | v125657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15986,axiom,
    ! [VarCurr: state_type] :
      ( v125727(VarCurr)
    <=> ( v125728(VarCurr)
        | v125736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15985,axiom,
    ! [VarCurr: state_type] :
      ( v125736(VarCurr)
    <=> ( v125737(VarCurr)
        & v125739(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15984,axiom,
    ! [VarCurr: state_type] :
      ( v125739(VarCurr)
    <=> ( v125670(VarCurr)
        & v125672(VarCurr) ) ) ).

tff(writeUnaryOperator_8888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125737(VarCurr)
    <=> v125738(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15983,axiom,
    ! [VarCurr: state_type] :
      ( v125738(VarCurr)
    <=> ( v125659(VarCurr)
        | v125657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15982,axiom,
    ! [VarCurr: state_type] :
      ( v125728(VarCurr)
    <=> ( v125729(VarCurr)
        | v125733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15981,axiom,
    ! [VarCurr: state_type] :
      ( v125733(VarCurr)
    <=> ( v125734(VarCurr)
        & v125735(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15980,axiom,
    ! [VarCurr: state_type] :
      ( v125735(VarCurr)
    <=> ( v125649(VarCurr)
        & v125657(VarCurr) ) ) ).

tff(writeUnaryOperator_8887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125734(VarCurr)
    <=> v125659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15979,axiom,
    ! [VarCurr: state_type] :
      ( v125729(VarCurr)
    <=> ( v125730(VarCurr)
        & v125659(VarCurr) ) ) ).

tff(writeUnaryOperator_8886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125730(VarCurr)
    <=> v125731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15978,axiom,
    ! [VarCurr: state_type] :
      ( v125731(VarCurr)
    <=> ( v125732(VarCurr)
        & v125634(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15977,axiom,
    ! [VarCurr: state_type] :
      ( v125732(VarCurr)
    <=> ( v125157(VarCurr)
        & v125632(VarCurr) ) ) ).

tff(addAssignment_71123,axiom,
    ! [VarCurr: state_type] :
      ( v125127(VarCurr,3)
    <=> v125129(VarCurr,3) ) ).

tff(addAssignment_71122,axiom,
    ! [VarCurr: state_type] :
      ( v125129(VarCurr,3)
    <=> v125131(VarCurr,3) ) ).

tff(addAssignment_71121,axiom,
    ! [VarNext: state_type] :
      ( v125131(VarNext,3)
    <=> v125718(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125719(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v125718(VarNext,B)
            <=> v125131(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1629,axiom,
    ! [VarNext: state_type] :
      ( v125719(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125718(VarNext,B)
          <=> v125691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125719(VarNext)
      <=> v125720(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125720(VarNext)
      <=> ( v125722(VarNext)
          & v125676(VarNext) ) ) ) ).

tff(writeUnaryOperator_8885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125722(VarNext)
      <=> v125685(VarNext) ) ) ).

tff(addAssignment_71120,axiom,
    ! [VarCurr: state_type] :
      ( v125149(VarCurr,3)
    <=> v125151(VarCurr,3) ) ).

tff(addAssignment_71119,axiom,
    ! [VarCurr: state_type] :
      ( v125151(VarCurr,3)
    <=> v125153(VarCurr,3) ) ).

tff(addAssignment_71118,axiom,
    ! [VarCurr: state_type] :
      ( v125153(VarCurr,3)
    <=> v125674(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_73,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125700(VarCurr)
     => ( v125155(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_102,axiom,
    ! [VarCurr: state_type] :
      ( v125700(VarCurr)
     => ( v125155(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15974,axiom,
    ! [VarCurr: state_type] :
      ( v125700(VarCurr)
    <=> ( v125701(VarCurr)
        | v125707(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15973,axiom,
    ! [VarCurr: state_type] :
      ( v125707(VarCurr)
    <=> ( v125708(VarCurr)
        & v125709(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15972,axiom,
    ! [VarCurr: state_type] :
      ( v125709(VarCurr)
    <=> ( v125710(VarCurr)
        & v125716(VarCurr) ) ) ).

tff(writeUnaryOperator_8884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125716(VarCurr)
    <=> v125706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15971,axiom,
    ! [VarCurr: state_type] :
      ( v125710(VarCurr)
    <=> ( v125711(VarCurr)
        & v125715(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1240,axiom,
    ! [VarCurr: state_type] :
      ( v125715(VarCurr)
    <=> ( $true
      <=> v125127(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125711(VarCurr)
    <=> v125712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15970,axiom,
    ! [VarCurr: state_type] :
      ( v125712(VarCurr)
    <=> ( v125713(VarCurr)
        | v125642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15969,axiom,
    ! [VarCurr: state_type] :
      ( v125713(VarCurr)
    <=> ( v125714(VarCurr)
        | v125698(VarCurr) ) ) ).

tff(writeUnaryOperator_8882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125714(VarCurr)
    <=> v125632(VarCurr) ) ).

tff(writeUnaryOperator_8881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125708(VarCurr)
    <=> v125672(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15968,axiom,
    ! [VarCurr: state_type] :
      ( v125701(VarCurr)
    <=> ( v125702(VarCurr)
        & v125705(VarCurr) ) ) ).

tff(writeUnaryOperator_8880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125705(VarCurr)
    <=> v125706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15967,axiom,
    ! [VarCurr: state_type] :
      ( v125706(VarCurr)
    <=> ( v125659(VarCurr)
        | v125657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15966,axiom,
    ! [VarCurr: state_type] :
      ( v125702(VarCurr)
    <=> ( v125703(VarCurr)
        & v125672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15965,axiom,
    ! [VarCurr: state_type] :
      ( v125703(VarCurr)
    <=> ( v125666(VarCurr)
        & v125704(VarCurr) ) ) ).

tff(writeUnaryOperator_8879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125704(VarCurr)
    <=> v125670(VarCurr) ) ).

tff(addAssignment_71117,axiom,
    ! [VarCurr: state_type] :
      ( v125698(VarCurr)
    <=> v112831(VarCurr,14) ) ).

tff(addAssignment_71116,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,14)
    <=> v112865(VarCurr,14) ) ).

tff(addAssignment_71115,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,14)
    <=> v112849(VarCurr,14) ) ).

tff(addAssignment_71114,axiom,
    ! [VarCurr: state_type] :
      ( v125127(VarCurr,2)
    <=> v125129(VarCurr,2) ) ).

tff(addAssignment_71113,axiom,
    ! [VarCurr: state_type] :
      ( v125129(VarCurr,2)
    <=> v125131(VarCurr,2) ) ).

tff(addAssignment_71112,axiom,
    ! [VarNext: state_type] :
      ( v125131(VarNext,2)
    <=> v125680(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125681(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v125680(VarNext,B)
            <=> v125131(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1628,axiom,
    ! [VarNext: state_type] :
      ( v125681(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125680(VarNext,B)
          <=> v125691(VarNext,B) ) ) ) ).

tff(addAssignment_71111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125691(VarNext,B)
          <=> v125689(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125689(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1171,axiom,
    ! [VarCurr: state_type] :
      ( v125692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v125689(VarCurr,B)
          <=> v125149(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15964,axiom,
    ! [VarCurr: state_type] :
      ( v125692(VarCurr)
    <=> ( v125693(VarCurr)
        & v125694(VarCurr) ) ) ).

tff(writeUnaryOperator_8878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125694(VarCurr)
    <=> v125141(VarCurr) ) ).

tff(writeUnaryOperator_8877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125693(VarCurr)
    <=> v125133(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125681(VarNext)
      <=> v125682(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125682(VarNext)
      <=> ( v125683(VarNext)
          & v125676(VarNext) ) ) ) ).

tff(writeUnaryOperator_8876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125683(VarNext)
      <=> v125685(VarNext) ) ) ).

tff(addAssignment_71110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125685(VarNext)
      <=> v125676(VarCurr) ) ) ).

tff(addAssignment_71109,axiom,
    ! [VarCurr: state_type] :
      ( v125676(VarCurr)
    <=> v125678(VarCurr) ) ).

tff(addAssignment_71108,axiom,
    ! [VarCurr: state_type] :
      ( v125678(VarCurr)
    <=> v125607(VarCurr) ) ).

tff(addAssignment_71107,axiom,
    ! [VarCurr: state_type] :
      ( v125149(VarCurr,2)
    <=> v125151(VarCurr,2) ) ).

tff(addAssignment_71106,axiom,
    ! [VarCurr: state_type] :
      ( v125151(VarCurr,2)
    <=> v125153(VarCurr,2) ) ).

tff(addAssignment_71105,axiom,
    ! [VarCurr: state_type] :
      ( v125153(VarCurr,2)
    <=> v125674(VarCurr,2) ) ).

tff(addAssignment_71104,axiom,
    ! [VarCurr: state_type] :
      ( v125674(VarCurr,0)
    <=> v125638(VarCurr) ) ).

tff(addAssignment_71103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v125674(VarCurr,B)
      <=> v125155(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_72,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125644(VarCurr)
     => ( v125155(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_101,axiom,
    ! [VarCurr: state_type] :
      ( v125644(VarCurr)
     => ( v125155(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15961,axiom,
    ! [VarCurr: state_type] :
      ( v125644(VarCurr)
    <=> ( v125645(VarCurr)
        | v125660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15960,axiom,
    ! [VarCurr: state_type] :
      ( v125660(VarCurr)
    <=> ( v125661(VarCurr)
        & v125662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15959,axiom,
    ! [VarCurr: state_type] :
      ( v125662(VarCurr)
    <=> ( v125663(VarCurr)
        & v125673(VarCurr) ) ) ).

tff(writeUnaryOperator_8875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125673(VarCurr)
    <=> v125659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15958,axiom,
    ! [VarCurr: state_type] :
      ( v125663(VarCurr)
    <=> ( v125664(VarCurr)
        & v125672(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1239,axiom,
    ! [VarCurr: state_type] :
      ( v125672(VarCurr)
    <=> ( $true
      <=> v125127(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15957,axiom,
    ! [VarCurr: state_type] :
      ( v125664(VarCurr)
    <=> ( v125665(VarCurr)
        & v125669(VarCurr) ) ) ).

tff(writeUnaryOperator_8874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125669(VarCurr)
    <=> v125670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15956,axiom,
    ! [VarCurr: state_type] :
      ( v125670(VarCurr)
    <=> ( v125671(VarCurr)
        | v125642(VarCurr) ) ) ).

tff(writeUnaryOperator_8873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125671(VarCurr)
    <=> v125632(VarCurr) ) ).

tff(writeUnaryOperator_8872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125665(VarCurr)
    <=> v125666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15955,axiom,
    ! [VarCurr: state_type] :
      ( v125666(VarCurr)
    <=> ( v125667(VarCurr)
        | v125668(VarCurr) ) ) ).

tff(writeUnaryOperator_8871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125668(VarCurr)
    <=> v125634(VarCurr) ) ).

tff(writeUnaryOperator_8870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125667(VarCurr)
    <=> v125157(VarCurr) ) ).

tff(writeUnaryOperator_8869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125661(VarCurr)
    <=> v125657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15954,axiom,
    ! [VarCurr: state_type] :
      ( v125645(VarCurr)
    <=> ( v125646(VarCurr)
        & v125658(VarCurr) ) ) ).

tff(writeUnaryOperator_8868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125658(VarCurr)
    <=> v125659(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1238,axiom,
    ! [VarCurr: state_type] :
      ( v125659(VarCurr)
    <=> ( $true
      <=> v125127(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15953,axiom,
    ! [VarCurr: state_type] :
      ( v125646(VarCurr)
    <=> ( v125647(VarCurr)
        & v125657(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1237,axiom,
    ! [VarCurr: state_type] :
      ( v125657(VarCurr)
    <=> ( $true
      <=> v125127(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15952,axiom,
    ! [VarCurr: state_type] :
      ( v125647(VarCurr)
    <=> ( v125640(VarCurr)
        & v125648(VarCurr) ) ) ).

tff(writeUnaryOperator_8867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125648(VarCurr)
    <=> v125649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15951,axiom,
    ! [VarCurr: state_type] :
      ( v125649(VarCurr)
    <=> ( v125650(VarCurr)
        | v125642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15950,axiom,
    ! [VarCurr: state_type] :
      ( v125650(VarCurr)
    <=> ( v125651(VarCurr)
        | v125654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15949,axiom,
    ! [VarCurr: state_type] :
      ( v125654(VarCurr)
    <=> ( v125655(VarCurr)
        & v125656(VarCurr) ) ) ).

tff(writeUnaryOperator_8866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125656(VarCurr)
    <=> v125640(VarCurr) ) ).

tff(writeUnaryOperator_8865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125655(VarCurr)
    <=> v125157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15948,axiom,
    ! [VarCurr: state_type] :
      ( v125651(VarCurr)
    <=> ( v125652(VarCurr)
        | v125653(VarCurr) ) ) ).

tff(writeUnaryOperator_8864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125653(VarCurr)
    <=> v125634(VarCurr) ) ).

tff(writeUnaryOperator_8863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125652(VarCurr)
    <=> v125632(VarCurr) ) ).

tff(addAssignment_71102,axiom,
    ! [VarCurr: state_type] :
      ( v125642(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_71101,axiom,
    ! [VarCurr: state_type] :
      ( v125640(VarCurr)
    <=> v112643(VarCurr,14) ) ).

tff(addAssignment_71100,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,14)
    <=> v115202(VarCurr,14) ) ).

tff(addAssignment_71099,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,14)
    <=> v115186(VarCurr,14) ) ).

tff(addAssignment_71098,axiom,
    ! [VarCurr: state_type] :
      ( v125634(VarCurr)
    <=> v112528(VarCurr,14) ) ).

tff(addAssignment_71097,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,14)
    <=> v120828(VarCurr,6) ) ).

tff(addAssignment_71096,axiom,
    ! [VarCurr: state_type] :
      ( v125632(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15947,axiom,
    ! [VarCurr: state_type] :
      ( v125157(VarCurr)
    <=> ( v125629(VarCurr)
        & v125630(VarCurr) ) ) ).

tff(writeUnaryOperator_8862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125630(VarCurr)
    <=> v125627(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1236,axiom,
    ! [VarCurr: state_type] :
      ( v125629(VarCurr)
    <=> ( ( v125159(VarCurr,5)
        <=> $false )
        & ( v125159(VarCurr,4)
        <=> $false )
        & ( v125159(VarCurr,3)
        <=> $false )
        & ( v125159(VarCurr,2)
        <=> $false )
        & ( v125159(VarCurr,1)
        <=> $false )
        & ( v125159(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_71095,axiom,
    ! [VarCurr: state_type] :
      ( v125627(VarCurr)
    <=> v115139(VarCurr,14) ) ).

tff(addAssignment_71094,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,14)
    <=> v115159(VarCurr,14) ) ).

tff(addAssignment_71093,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,14)
    <=> v115142(VarCurr,14) ) ).

tff(addAssignment_71092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125159(VarCurr,B)
      <=> v125161(VarCurr,B) ) ) ).

tff(addAssignment_71091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125161(VarCurr,B)
      <=> v125163(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125610(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v125163(VarNext,B)
            <=> v125163(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1627,axiom,
    ! [VarNext: state_type] :
      ( v125610(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v125163(VarNext,B)
          <=> v125620(VarNext,B) ) ) ) ).

tff(addAssignment_71090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v125620(VarNext,B)
          <=> v125618(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v125618(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1170,axiom,
    ! [VarCurr: state_type] :
      ( v125621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v125618(VarCurr,B)
          <=> v125173(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15946,axiom,
    ! [VarCurr: state_type] :
      ( v125621(VarCurr)
    <=> ( v125622(VarCurr)
        & v125623(VarCurr) ) ) ).

tff(writeUnaryOperator_8861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125623(VarCurr)
    <=> v125169(VarCurr) ) ).

tff(writeUnaryOperator_8860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125622(VarCurr)
    <=> v125165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125610(VarNext)
      <=> v125611(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125611(VarNext)
      <=> ( v125612(VarNext)
          & v125603(VarNext) ) ) ) ).

tff(writeUnaryOperator_8859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125612(VarNext)
      <=> v125614(VarNext) ) ) ).

tff(addAssignment_71089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125614(VarNext)
      <=> v125603(VarCurr) ) ) ).

tff(addAssignment_71088,axiom,
    ! [VarCurr: state_type] :
      ( v125603(VarCurr)
    <=> v125605(VarCurr) ) ).

tff(addAssignment_71087,axiom,
    ! [VarCurr: state_type] :
      ( v125605(VarCurr)
    <=> v125607(VarCurr) ) ).

tff(addAssignment_71086,axiom,
    ! [VarCurr: state_type] :
      ( v125607(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_71085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125173(VarCurr,B)
      <=> v125175(VarCurr,B) ) ) ).

tff(addAssignment_71084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125175(VarCurr,B)
      <=> v125177(VarCurr,B) ) ) ).

tff(addAssignment_71083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v125177(VarCurr,B)
      <=> v125179(VarCurr,B) ) ) ).

tff(addAssignment_71082,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,0)
    <=> v125598(VarCurr) ) ).

tff(addAssignment_71081,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,1)
    <=> v125593(VarCurr) ) ).

tff(addAssignment_71080,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,2)
    <=> v125588(VarCurr) ) ).

tff(addAssignment_71079,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,3)
    <=> v125583(VarCurr) ) ).

tff(addAssignment_71078,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,4)
    <=> v125578(VarCurr) ) ).

tff(addAssignment_71077,axiom,
    ! [VarCurr: state_type] :
      ( v125179(VarCurr,5)
    <=> v125435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15943,axiom,
    ! [VarCurr: state_type] :
      ( v125598(VarCurr)
    <=> ( v125599(VarCurr)
        & v125601(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15942,axiom,
    ! [VarCurr: state_type] :
      ( v125601(VarCurr)
    <=> ( v125390(VarCurr,0)
        | v125447(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15941,axiom,
    ! [VarCurr: state_type] :
      ( v125599(VarCurr)
    <=> ( v125524(VarCurr)
        | v125600(VarCurr) ) ) ).

tff(writeUnaryOperator_8858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125600(VarCurr)
    <=> v125447(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15940,axiom,
    ! [VarCurr: state_type] :
      ( v125593(VarCurr)
    <=> ( v125594(VarCurr)
        & v125597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15939,axiom,
    ! [VarCurr: state_type] :
      ( v125597(VarCurr)
    <=> ( v125446(VarCurr)
        | v125518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15938,axiom,
    ! [VarCurr: state_type] :
      ( v125594(VarCurr)
    <=> ( v125595(VarCurr)
        | v125596(VarCurr) ) ) ).

tff(writeUnaryOperator_8857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125596(VarCurr)
    <=> v125518(VarCurr) ) ).

tff(writeUnaryOperator_8856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125595(VarCurr)
    <=> v125446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15937,axiom,
    ! [VarCurr: state_type] :
      ( v125588(VarCurr)
    <=> ( v125589(VarCurr)
        & v125592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15936,axiom,
    ! [VarCurr: state_type] :
      ( v125592(VarCurr)
    <=> ( v125444(VarCurr)
        | v125529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15935,axiom,
    ! [VarCurr: state_type] :
      ( v125589(VarCurr)
    <=> ( v125590(VarCurr)
        | v125591(VarCurr) ) ) ).

tff(writeUnaryOperator_8855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125591(VarCurr)
    <=> v125529(VarCurr) ) ).

tff(writeUnaryOperator_8854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125590(VarCurr)
    <=> v125444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15934,axiom,
    ! [VarCurr: state_type] :
      ( v125583(VarCurr)
    <=> ( v125584(VarCurr)
        & v125587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15933,axiom,
    ! [VarCurr: state_type] :
      ( v125587(VarCurr)
    <=> ( v125442(VarCurr)
        | v125541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15932,axiom,
    ! [VarCurr: state_type] :
      ( v125584(VarCurr)
    <=> ( v125585(VarCurr)
        | v125586(VarCurr) ) ) ).

tff(writeUnaryOperator_8853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125586(VarCurr)
    <=> v125541(VarCurr) ) ).

tff(writeUnaryOperator_8852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125585(VarCurr)
    <=> v125442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15931,axiom,
    ! [VarCurr: state_type] :
      ( v125578(VarCurr)
    <=> ( v125579(VarCurr)
        & v125582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15930,axiom,
    ! [VarCurr: state_type] :
      ( v125582(VarCurr)
    <=> ( v125440(VarCurr)
        | v125553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15929,axiom,
    ! [VarCurr: state_type] :
      ( v125579(VarCurr)
    <=> ( v125580(VarCurr)
        | v125581(VarCurr) ) ) ).

tff(writeUnaryOperator_8851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125581(VarCurr)
    <=> v125553(VarCurr) ) ).

tff(writeUnaryOperator_8850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125580(VarCurr)
    <=> v125440(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15928,axiom,
    ! [VarCurr: state_type] :
      ( v125435(VarCurr)
    <=> ( v125436(VarCurr)
        & v125577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15927,axiom,
    ! [VarCurr: state_type] :
      ( v125577(VarCurr)
    <=> ( v125438(VarCurr)
        | v125566(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15926,axiom,
    ! [VarCurr: state_type] :
      ( v125436(VarCurr)
    <=> ( v125437(VarCurr)
        | v125565(VarCurr) ) ) ).

tff(writeUnaryOperator_8849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125565(VarCurr)
    <=> v125566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15925,axiom,
    ! [VarCurr: state_type] :
      ( v125566(VarCurr)
    <=> ( v125567(VarCurr)
        & v125576(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5570,axiom,
    ! [VarCurr: state_type] :
      ( v125576(VarCurr)
    <=> ( v125569(VarCurr)
        | v125447(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15924,axiom,
    ! [VarCurr: state_type] :
      ( v125567(VarCurr)
    <=> ( v125568(VarCurr)
        | v125575(VarCurr) ) ) ).

tff(writeUnaryOperator_8848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125575(VarCurr)
    <=> v125447(VarCurr,5) ) ).

tff(writeUnaryOperator_8847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125568(VarCurr)
    <=> v125569(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15923,axiom,
    ! [VarCurr: state_type] :
      ( v125569(VarCurr)
    <=> ( v125570(VarCurr)
        & v125573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15922,axiom,
    ! [VarCurr: state_type] :
      ( v125573(VarCurr)
    <=> ( v125572(VarCurr)
        | v125574(VarCurr) ) ) ).

tff(writeUnaryOperator_8846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125574(VarCurr)
    <=> v125390(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5569,axiom,
    ! [VarCurr: state_type] :
      ( v125570(VarCurr)
    <=> ( v125571(VarCurr)
        | v125390(VarCurr,5) ) ) ).

tff(writeUnaryOperator_8845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125571(VarCurr)
    <=> v125572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15921,axiom,
    ! [VarCurr: state_type] :
      ( v125572(VarCurr)
    <=> ( v125559(VarCurr)
        & v125561(VarCurr) ) ) ).

tff(writeUnaryOperator_8844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125437(VarCurr)
    <=> v125438(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15920,axiom,
    ! [VarCurr: state_type] :
      ( v125438(VarCurr)
    <=> ( v125439(VarCurr)
        | v125564(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5568,axiom,
    ! [VarCurr: state_type] :
      ( v125564(VarCurr)
    <=> ( v125556(VarCurr)
        & v125447(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15919,axiom,
    ! [VarCurr: state_type] :
      ( v125439(VarCurr)
    <=> ( v125440(VarCurr)
        & v125553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15918,axiom,
    ! [VarCurr: state_type] :
      ( v125553(VarCurr)
    <=> ( v125554(VarCurr)
        & v125563(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5567,axiom,
    ! [VarCurr: state_type] :
      ( v125563(VarCurr)
    <=> ( v125556(VarCurr)
        | v125447(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15917,axiom,
    ! [VarCurr: state_type] :
      ( v125554(VarCurr)
    <=> ( v125555(VarCurr)
        | v125562(VarCurr) ) ) ).

tff(writeUnaryOperator_8843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125562(VarCurr)
    <=> v125447(VarCurr,4) ) ).

tff(writeUnaryOperator_8842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125555(VarCurr)
    <=> v125556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15916,axiom,
    ! [VarCurr: state_type] :
      ( v125556(VarCurr)
    <=> ( v125557(VarCurr)
        & v125560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15915,axiom,
    ! [VarCurr: state_type] :
      ( v125560(VarCurr)
    <=> ( v125559(VarCurr)
        | v125561(VarCurr) ) ) ).

tff(writeUnaryOperator_8841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125561(VarCurr)
    <=> v125390(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5566,axiom,
    ! [VarCurr: state_type] :
      ( v125557(VarCurr)
    <=> ( v125558(VarCurr)
        | v125390(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125558(VarCurr)
    <=> v125559(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15914,axiom,
    ! [VarCurr: state_type] :
      ( v125559(VarCurr)
    <=> ( v125547(VarCurr)
        & v125549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15913,axiom,
    ! [VarCurr: state_type] :
      ( v125440(VarCurr)
    <=> ( v125441(VarCurr)
        | v125552(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5565,axiom,
    ! [VarCurr: state_type] :
      ( v125552(VarCurr)
    <=> ( v125544(VarCurr)
        & v125447(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15912,axiom,
    ! [VarCurr: state_type] :
      ( v125441(VarCurr)
    <=> ( v125442(VarCurr)
        & v125541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15911,axiom,
    ! [VarCurr: state_type] :
      ( v125541(VarCurr)
    <=> ( v125542(VarCurr)
        & v125551(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5564,axiom,
    ! [VarCurr: state_type] :
      ( v125551(VarCurr)
    <=> ( v125544(VarCurr)
        | v125447(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15910,axiom,
    ! [VarCurr: state_type] :
      ( v125542(VarCurr)
    <=> ( v125543(VarCurr)
        | v125550(VarCurr) ) ) ).

tff(writeUnaryOperator_8839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125550(VarCurr)
    <=> v125447(VarCurr,3) ) ).

tff(writeUnaryOperator_8838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125543(VarCurr)
    <=> v125544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15909,axiom,
    ! [VarCurr: state_type] :
      ( v125544(VarCurr)
    <=> ( v125545(VarCurr)
        & v125548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15908,axiom,
    ! [VarCurr: state_type] :
      ( v125548(VarCurr)
    <=> ( v125547(VarCurr)
        | v125549(VarCurr) ) ) ).

tff(writeUnaryOperator_8837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125549(VarCurr)
    <=> v125390(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5563,axiom,
    ! [VarCurr: state_type] :
      ( v125545(VarCurr)
    <=> ( v125546(VarCurr)
        | v125390(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125546(VarCurr)
    <=> v125547(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15907,axiom,
    ! [VarCurr: state_type] :
      ( v125547(VarCurr)
    <=> ( v125535(VarCurr)
        & v125537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15906,axiom,
    ! [VarCurr: state_type] :
      ( v125442(VarCurr)
    <=> ( v125443(VarCurr)
        | v125540(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5562,axiom,
    ! [VarCurr: state_type] :
      ( v125540(VarCurr)
    <=> ( v125532(VarCurr)
        & v125447(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15905,axiom,
    ! [VarCurr: state_type] :
      ( v125443(VarCurr)
    <=> ( v125444(VarCurr)
        & v125529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15904,axiom,
    ! [VarCurr: state_type] :
      ( v125529(VarCurr)
    <=> ( v125530(VarCurr)
        & v125539(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5561,axiom,
    ! [VarCurr: state_type] :
      ( v125539(VarCurr)
    <=> ( v125532(VarCurr)
        | v125447(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15903,axiom,
    ! [VarCurr: state_type] :
      ( v125530(VarCurr)
    <=> ( v125531(VarCurr)
        | v125538(VarCurr) ) ) ).

tff(writeUnaryOperator_8835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125538(VarCurr)
    <=> v125447(VarCurr,2) ) ).

tff(writeUnaryOperator_8834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125531(VarCurr)
    <=> v125532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15902,axiom,
    ! [VarCurr: state_type] :
      ( v125532(VarCurr)
    <=> ( v125533(VarCurr)
        & v125536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15901,axiom,
    ! [VarCurr: state_type] :
      ( v125536(VarCurr)
    <=> ( v125535(VarCurr)
        | v125537(VarCurr) ) ) ).

tff(writeUnaryOperator_8833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125537(VarCurr)
    <=> v125390(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5560,axiom,
    ! [VarCurr: state_type] :
      ( v125533(VarCurr)
    <=> ( v125534(VarCurr)
        | v125390(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125534(VarCurr)
    <=> v125535(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15900,axiom,
    ! [VarCurr: state_type] :
      ( v125535(VarCurr)
    <=> ( v125524(VarCurr)
        & v125525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15899,axiom,
    ! [VarCurr: state_type] :
      ( v125444(VarCurr)
    <=> ( v125445(VarCurr)
        | v125528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5559,axiom,
    ! [VarCurr: state_type] :
      ( v125528(VarCurr)
    <=> ( v125521(VarCurr)
        & v125447(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15898,axiom,
    ! [VarCurr: state_type] :
      ( v125445(VarCurr)
    <=> ( v125446(VarCurr)
        & v125518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15897,axiom,
    ! [VarCurr: state_type] :
      ( v125518(VarCurr)
    <=> ( v125519(VarCurr)
        & v125527(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5558,axiom,
    ! [VarCurr: state_type] :
      ( v125527(VarCurr)
    <=> ( v125521(VarCurr)
        | v125447(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15896,axiom,
    ! [VarCurr: state_type] :
      ( v125519(VarCurr)
    <=> ( v125520(VarCurr)
        | v125526(VarCurr) ) ) ).

tff(writeUnaryOperator_8831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125526(VarCurr)
    <=> v125447(VarCurr,1) ) ).

tff(writeUnaryOperator_8830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125520(VarCurr)
    <=> v125521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15895,axiom,
    ! [VarCurr: state_type] :
      ( v125521(VarCurr)
    <=> ( v125522(VarCurr)
        & v125523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15894,axiom,
    ! [VarCurr: state_type] :
      ( v125523(VarCurr)
    <=> ( v125524(VarCurr)
        | v125525(VarCurr) ) ) ).

tff(writeUnaryOperator_8829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125525(VarCurr)
    <=> v125390(VarCurr,1) ) ).

tff(writeUnaryOperator_8828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125524(VarCurr)
    <=> v125390(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5557,axiom,
    ! [VarCurr: state_type] :
      ( v125522(VarCurr)
    <=> ( v125390(VarCurr,0)
        | v125390(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15893,axiom,
    ! [VarCurr: state_type] :
      ( v125446(VarCurr)
    <=> ( v125390(VarCurr,0)
        & v125447(VarCurr,0) ) ) ).

tff(addAssignment_71076,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,0)
    <=> v125513(VarCurr) ) ).

tff(addAssignment_71075,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,1)
    <=> v125508(VarCurr) ) ).

tff(addAssignment_71074,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,2)
    <=> v125503(VarCurr) ) ).

tff(addAssignment_71073,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,3)
    <=> v125498(VarCurr) ) ).

tff(addAssignment_71072,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,4)
    <=> v125493(VarCurr) ) ).

tff(addAssignment_71071,axiom,
    ! [VarCurr: state_type] :
      ( v125447(VarCurr,5)
    <=> v125449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15892,axiom,
    ! [VarCurr: state_type] :
      ( v125513(VarCurr)
    <=> ( v125514(VarCurr)
        & v125517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15891,axiom,
    ! [VarCurr: state_type] :
      ( v125517(VarCurr)
    <=> ( v125159(VarCurr,0)
        | v125461(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15890,axiom,
    ! [VarCurr: state_type] :
      ( v125514(VarCurr)
    <=> ( v125515(VarCurr)
        | v125516(VarCurr) ) ) ).

tff(writeUnaryOperator_8827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125516(VarCurr)
    <=> v125461(VarCurr,0) ) ).

tff(writeUnaryOperator_8826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125515(VarCurr)
    <=> v125159(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15889,axiom,
    ! [VarCurr: state_type] :
      ( v125508(VarCurr)
    <=> ( v125509(VarCurr)
        & v125512(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15888,axiom,
    ! [VarCurr: state_type] :
      ( v125512(VarCurr)
    <=> ( v125460(VarCurr)
        | v125462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15887,axiom,
    ! [VarCurr: state_type] :
      ( v125509(VarCurr)
    <=> ( v125510(VarCurr)
        | v125511(VarCurr) ) ) ).

tff(writeUnaryOperator_8825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125511(VarCurr)
    <=> v125462(VarCurr) ) ).

tff(writeUnaryOperator_8824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125510(VarCurr)
    <=> v125460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15886,axiom,
    ! [VarCurr: state_type] :
      ( v125503(VarCurr)
    <=> ( v125504(VarCurr)
        & v125507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15885,axiom,
    ! [VarCurr: state_type] :
      ( v125507(VarCurr)
    <=> ( v125458(VarCurr)
        | v125468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15884,axiom,
    ! [VarCurr: state_type] :
      ( v125504(VarCurr)
    <=> ( v125505(VarCurr)
        | v125506(VarCurr) ) ) ).

tff(writeUnaryOperator_8823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125506(VarCurr)
    <=> v125468(VarCurr) ) ).

tff(writeUnaryOperator_8822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125505(VarCurr)
    <=> v125458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15883,axiom,
    ! [VarCurr: state_type] :
      ( v125498(VarCurr)
    <=> ( v125499(VarCurr)
        & v125502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15882,axiom,
    ! [VarCurr: state_type] :
      ( v125502(VarCurr)
    <=> ( v125456(VarCurr)
        | v125474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15881,axiom,
    ! [VarCurr: state_type] :
      ( v125499(VarCurr)
    <=> ( v125500(VarCurr)
        | v125501(VarCurr) ) ) ).

tff(writeUnaryOperator_8821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125501(VarCurr)
    <=> v125474(VarCurr) ) ).

tff(writeUnaryOperator_8820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125500(VarCurr)
    <=> v125456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15880,axiom,
    ! [VarCurr: state_type] :
      ( v125493(VarCurr)
    <=> ( v125494(VarCurr)
        & v125497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15879,axiom,
    ! [VarCurr: state_type] :
      ( v125497(VarCurr)
    <=> ( v125454(VarCurr)
        | v125480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15878,axiom,
    ! [VarCurr: state_type] :
      ( v125494(VarCurr)
    <=> ( v125495(VarCurr)
        | v125496(VarCurr) ) ) ).

tff(writeUnaryOperator_8819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125496(VarCurr)
    <=> v125480(VarCurr) ) ).

tff(writeUnaryOperator_8818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125495(VarCurr)
    <=> v125454(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15877,axiom,
    ! [VarCurr: state_type] :
      ( v125449(VarCurr)
    <=> ( v125450(VarCurr)
        & v125492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15876,axiom,
    ! [VarCurr: state_type] :
      ( v125492(VarCurr)
    <=> ( v125452(VarCurr)
        | v125487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15875,axiom,
    ! [VarCurr: state_type] :
      ( v125450(VarCurr)
    <=> ( v125451(VarCurr)
        | v125486(VarCurr) ) ) ).

tff(writeUnaryOperator_8817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125486(VarCurr)
    <=> v125487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15874,axiom,
    ! [VarCurr: state_type] :
      ( v125487(VarCurr)
    <=> ( v125488(VarCurr)
        & v125491(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5556,axiom,
    ! [VarCurr: state_type] :
      ( v125491(VarCurr)
    <=> ( v125159(VarCurr,5)
        | v125461(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15873,axiom,
    ! [VarCurr: state_type] :
      ( v125488(VarCurr)
    <=> ( v125489(VarCurr)
        | v125490(VarCurr) ) ) ).

tff(writeUnaryOperator_8816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125490(VarCurr)
    <=> v125461(VarCurr,5) ) ).

tff(writeUnaryOperator_8815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125489(VarCurr)
    <=> v125159(VarCurr,5) ) ).

tff(writeUnaryOperator_8814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125451(VarCurr)
    <=> v125452(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15872,axiom,
    ! [VarCurr: state_type] :
      ( v125452(VarCurr)
    <=> ( v125453(VarCurr)
        | v125485(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5555,axiom,
    ! [VarCurr: state_type] :
      ( v125485(VarCurr)
    <=> ( v125159(VarCurr,4)
        & v125461(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15871,axiom,
    ! [VarCurr: state_type] :
      ( v125453(VarCurr)
    <=> ( v125454(VarCurr)
        & v125480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15870,axiom,
    ! [VarCurr: state_type] :
      ( v125480(VarCurr)
    <=> ( v125481(VarCurr)
        & v125484(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5554,axiom,
    ! [VarCurr: state_type] :
      ( v125484(VarCurr)
    <=> ( v125159(VarCurr,4)
        | v125461(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15869,axiom,
    ! [VarCurr: state_type] :
      ( v125481(VarCurr)
    <=> ( v125482(VarCurr)
        | v125483(VarCurr) ) ) ).

tff(writeUnaryOperator_8813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125483(VarCurr)
    <=> v125461(VarCurr,4) ) ).

tff(writeUnaryOperator_8812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125482(VarCurr)
    <=> v125159(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15868,axiom,
    ! [VarCurr: state_type] :
      ( v125454(VarCurr)
    <=> ( v125455(VarCurr)
        | v125479(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5553,axiom,
    ! [VarCurr: state_type] :
      ( v125479(VarCurr)
    <=> ( v125159(VarCurr,3)
        & v125461(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15867,axiom,
    ! [VarCurr: state_type] :
      ( v125455(VarCurr)
    <=> ( v125456(VarCurr)
        & v125474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15866,axiom,
    ! [VarCurr: state_type] :
      ( v125474(VarCurr)
    <=> ( v125475(VarCurr)
        & v125478(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5552,axiom,
    ! [VarCurr: state_type] :
      ( v125478(VarCurr)
    <=> ( v125159(VarCurr,3)
        | v125461(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15865,axiom,
    ! [VarCurr: state_type] :
      ( v125475(VarCurr)
    <=> ( v125476(VarCurr)
        | v125477(VarCurr) ) ) ).

tff(writeUnaryOperator_8811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125477(VarCurr)
    <=> v125461(VarCurr,3) ) ).

tff(writeUnaryOperator_8810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125476(VarCurr)
    <=> v125159(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15864,axiom,
    ! [VarCurr: state_type] :
      ( v125456(VarCurr)
    <=> ( v125457(VarCurr)
        | v125473(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5551,axiom,
    ! [VarCurr: state_type] :
      ( v125473(VarCurr)
    <=> ( v125159(VarCurr,2)
        & v125461(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15863,axiom,
    ! [VarCurr: state_type] :
      ( v125457(VarCurr)
    <=> ( v125458(VarCurr)
        & v125468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15862,axiom,
    ! [VarCurr: state_type] :
      ( v125468(VarCurr)
    <=> ( v125469(VarCurr)
        & v125472(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5550,axiom,
    ! [VarCurr: state_type] :
      ( v125472(VarCurr)
    <=> ( v125159(VarCurr,2)
        | v125461(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15861,axiom,
    ! [VarCurr: state_type] :
      ( v125469(VarCurr)
    <=> ( v125470(VarCurr)
        | v125471(VarCurr) ) ) ).

tff(writeUnaryOperator_8809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125471(VarCurr)
    <=> v125461(VarCurr,2) ) ).

tff(writeUnaryOperator_8808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125470(VarCurr)
    <=> v125159(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15860,axiom,
    ! [VarCurr: state_type] :
      ( v125458(VarCurr)
    <=> ( v125459(VarCurr)
        | v125467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5549,axiom,
    ! [VarCurr: state_type] :
      ( v125467(VarCurr)
    <=> ( v125159(VarCurr,1)
        & v125461(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15859,axiom,
    ! [VarCurr: state_type] :
      ( v125459(VarCurr)
    <=> ( v125460(VarCurr)
        & v125462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15858,axiom,
    ! [VarCurr: state_type] :
      ( v125462(VarCurr)
    <=> ( v125463(VarCurr)
        & v125466(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5548,axiom,
    ! [VarCurr: state_type] :
      ( v125466(VarCurr)
    <=> ( v125159(VarCurr,1)
        | v125461(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15857,axiom,
    ! [VarCurr: state_type] :
      ( v125463(VarCurr)
    <=> ( v125464(VarCurr)
        | v125465(VarCurr) ) ) ).

tff(writeUnaryOperator_8807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125465(VarCurr)
    <=> v125461(VarCurr,1) ) ).

tff(writeUnaryOperator_8806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125464(VarCurr)
    <=> v125159(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15856,axiom,
    ! [VarCurr: state_type] :
      ( v125460(VarCurr)
    <=> ( v125159(VarCurr,0)
        & v125461(VarCurr,0) ) ) ).

tff(addAssignment_71070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v125461(VarCurr,B)
      <=> v125181(VarCurr,B) ) ) ).

tff(addAssignment_71069,axiom,
    ! [VarCurr: state_type] :
      ( ( v125461(VarCurr,5)
      <=> $false )
      & ( v125461(VarCurr,4)
      <=> $false )
      & ( v125461(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_71068,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,5)
    <=> v125427(VarCurr,5) ) ).

tff(addAssignment_71067,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,4)
    <=> v125427(VarCurr,4) ) ).

tff(addAssignment_71066,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,3)
    <=> v125427(VarCurr,3) ) ).

tff(addAssignment_71065,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,2)
    <=> v125427(VarCurr,2) ) ).

tff(addAssignment_71064,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,1)
    <=> v125427(VarCurr,1) ) ).

tff(addAssignment_71063,axiom,
    ! [VarCurr: state_type] :
      ( v125390(VarCurr,0)
    <=> v125427(VarCurr,0) ) ).

tff(addAssignment_71062,axiom,
    ! [VarCurr: state_type] :
      ( v125427(VarCurr,0)
    <=> v125428(VarCurr) ) ).

tff(addAssignment_71061,axiom,
    ! [VarCurr: state_type] :
      ( ( v125427(VarCurr,5)
      <=> $false )
      & ( v125427(VarCurr,4)
      <=> $false )
      & ( v125427(VarCurr,3)
      <=> $false )
      & ( v125427(VarCurr,2)
      <=> $false )
      & ( v125427(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15855,axiom,
    ! [VarCurr: state_type] :
      ( v125428(VarCurr)
    <=> ( v125429(VarCurr)
        | v125426(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15854,axiom,
    ! [VarCurr: state_type] :
      ( v125429(VarCurr)
    <=> ( v125430(VarCurr)
        | v125424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15853,axiom,
    ! [VarCurr: state_type] :
      ( v125430(VarCurr)
    <=> ( v125431(VarCurr)
        | v125422(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15852,axiom,
    ! [VarCurr: state_type] :
      ( v125431(VarCurr)
    <=> ( v125432(VarCurr)
        | v125412(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15851,axiom,
    ! [VarCurr: state_type] :
      ( v125432(VarCurr)
    <=> ( v125392(VarCurr)
        | v125402(VarCurr) ) ) ).

tff(addAssignment_71060,axiom,
    ! [VarCurr: state_type] :
      ( v125426(VarCurr)
    <=> v113911(VarCurr,14) ) ).

tff(addAssignment_71059,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,14)
    <=> v113913(VarCurr,14) ) ).

tff(addAssignment_71058,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,14)
    <=> v113915(VarCurr,14) ) ).

tff(addAssignment_71057,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,14)
    <=> v113935(VarCurr,14) ) ).

tff(addAssignment_71056,axiom,
    ! [VarCurr: state_type] :
      ( v125424(VarCurr)
    <=> v113107(VarCurr,14) ) ).

tff(addAssignment_71055,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,14)
    <=> v113143(VarCurr,14) ) ).

tff(addAssignment_71054,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,14)
    <=> v113110(VarCurr,14) ) ).

tff(addAssignment_71053,axiom,
    ! [VarCurr: state_type] :
      ( v125422(VarCurr)
    <=> v113100(VarCurr,14) ) ).

tff(addAssignment_71052,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,14)
    <=> v113101(VarCurr,14) ) ).

tff(addAssignment_71051,axiom,
    ! [VarCurr: state_type] :
      ( v125412(VarCurr)
    <=> v113810(VarCurr,14) ) ).

tff(addAssignment_71050,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,14)
    <=> v113812(VarCurr,14) ) ).

tff(addAssignment_71049,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,14)
    <=> v113814(VarCurr,14) ) ).

tff(addAssignment_71048,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,14)
    <=> v113816(VarCurr,14) ) ).

tff(addAssignment_71047,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,14)
    <=> v113818(VarCurr,14) ) ).

tff(addAssignment_71046,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,14)
    <=> v125414(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_1626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125415(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v125414(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1626,axiom,
    ! [VarNext: state_type] :
      ( v125415(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v125414(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125415(VarNext)
      <=> v125416(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125416(VarNext)
      <=> ( v125418(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125418(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_71045,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,14)
    <=> v113830(VarCurr,14) ) ).

tff(addAssignment_71044,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,14)
    <=> v113832(VarCurr,14) ) ).

tff(addAssignment_71043,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,14)
    <=> v113834(VarCurr,14) ) ).

tff(addAssignment_71042,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,14)
    <=> v113873(VarCurr,14) ) ).

tff(addAssignment_71041,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,14)
    <=> v113856(VarCurr,14) ) ).

tff(addAssignment_71040,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,14)
    <=> v113837(VarCurr,14) ) ).

tff(addAssignment_71039,axiom,
    ! [VarCurr: state_type] :
      ( v125402(VarCurr)
    <=> v113020(VarCurr,14) ) ).

tff(addAssignment_71038,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,14)
    <=> v113022(VarCurr,14) ) ).

tff(addAssignment_71037,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,14)
    <=> v113024(VarCurr,14) ) ).

tff(addAssignment_71036,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,14)
    <=> v113026(VarCurr,14) ) ).

tff(addAssignment_71035,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,14)
    <=> v113028(VarCurr,14) ) ).

tff(addAssignment_71034,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,14)
    <=> v125404(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_1625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125405(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v125404(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1625,axiom,
    ! [VarNext: state_type] :
      ( v125405(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v125404(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125405(VarNext)
      <=> v125406(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125406(VarNext)
      <=> ( v125408(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125408(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_71033,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,14)
    <=> v113040(VarCurr,14) ) ).

tff(addAssignment_71032,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,14)
    <=> v113042(VarCurr,14) ) ).

tff(addAssignment_71031,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,14)
    <=> v113044(VarCurr,14) ) ).

tff(addAssignment_71030,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,14)
    <=> v113045(VarCurr,14) ) ).

tff(addAssignment_71029,axiom,
    ! [VarCurr: state_type] :
      ( v125392(VarCurr)
    <=> v112940(VarCurr,14) ) ).

tff(addAssignment_71028,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,14)
    <=> v112942(VarCurr,14) ) ).

tff(addAssignment_71027,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,14)
    <=> v112944(VarCurr,14) ) ).

tff(addAssignment_71026,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,14)
    <=> v112946(VarCurr,14) ) ).

tff(addAssignment_71025,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,14)
    <=> v112948(VarCurr,14) ) ).

tff(addAssignment_71024,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,14)
    <=> v125394(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_1624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125395(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v125394(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1624,axiom,
    ! [VarNext: state_type] :
      ( v125395(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v125394(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125395(VarNext)
      <=> v125396(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125396(VarNext)
      <=> ( v125398(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125398(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_71023,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,14)
    <=> v112960(VarCurr,14) ) ).

tff(addAssignment_71022,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,14)
    <=> v112962(VarCurr,14) ) ).

tff(addAssignment_71021,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,14)
    <=> v112964(VarCurr,14) ) ).

tff(addAssignment_71020,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,14)
    <=> v112965(VarCurr,14) ) ).

tff(addAssignment_71019,axiom,
    ! [VarCurr: state_type] :
      ( v125181(VarCurr,2)
    <=> v125196(VarCurr,2) ) ).

tff(addAssignment_71018,axiom,
    ! [VarCurr: state_type] :
      ( v125181(VarCurr,1)
    <=> v125196(VarCurr,1) ) ).

tff(addAssignment_71017,axiom,
    ! [VarCurr: state_type] :
      ( v125181(VarCurr,0)
    <=> v125196(VarCurr,0) ) ).

tff(addAssignment_71016,axiom,
    ! [VarCurr: state_type] :
      ( v125196(VarCurr,0)
    <=> v125384(VarCurr) ) ).

tff(addAssignment_71015,axiom,
    ! [VarCurr: state_type] :
      ( v125196(VarCurr,1)
    <=> v125379(VarCurr) ) ).

tff(addAssignment_71014,axiom,
    ! [VarCurr: state_type] :
      ( v125196(VarCurr,2)
    <=> v125198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15844,axiom,
    ! [VarCurr: state_type] :
      ( v125384(VarCurr)
    <=> ( v125385(VarCurr)
        & v125388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15843,axiom,
    ! [VarCurr: state_type] :
      ( v125388(VarCurr)
    <=> ( v125204(VarCurr,0)
        | v125365(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15842,axiom,
    ! [VarCurr: state_type] :
      ( v125385(VarCurr)
    <=> ( v125386(VarCurr)
        | v125387(VarCurr) ) ) ).

tff(writeUnaryOperator_8802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125387(VarCurr)
    <=> v125365(VarCurr,0) ) ).

tff(writeUnaryOperator_8801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125386(VarCurr)
    <=> v125204(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15841,axiom,
    ! [VarCurr: state_type] :
      ( v125379(VarCurr)
    <=> ( v125380(VarCurr)
        & v125383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15840,axiom,
    ! [VarCurr: state_type] :
      ( v125383(VarCurr)
    <=> ( v125203(VarCurr)
        | v125366(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15839,axiom,
    ! [VarCurr: state_type] :
      ( v125380(VarCurr)
    <=> ( v125381(VarCurr)
        | v125382(VarCurr) ) ) ).

tff(writeUnaryOperator_8800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125382(VarCurr)
    <=> v125366(VarCurr) ) ).

tff(writeUnaryOperator_8799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125381(VarCurr)
    <=> v125203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15838,axiom,
    ! [VarCurr: state_type] :
      ( v125198(VarCurr)
    <=> ( v125199(VarCurr)
        & v125378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15837,axiom,
    ! [VarCurr: state_type] :
      ( v125378(VarCurr)
    <=> ( v125201(VarCurr)
        | v125373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15836,axiom,
    ! [VarCurr: state_type] :
      ( v125199(VarCurr)
    <=> ( v125200(VarCurr)
        | v125372(VarCurr) ) ) ).

tff(writeUnaryOperator_8798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125372(VarCurr)
    <=> v125373(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15835,axiom,
    ! [VarCurr: state_type] :
      ( v125373(VarCurr)
    <=> ( v125374(VarCurr)
        & v125377(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5547,axiom,
    ! [VarCurr: state_type] :
      ( v125377(VarCurr)
    <=> ( v125204(VarCurr,2)
        | v125365(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15834,axiom,
    ! [VarCurr: state_type] :
      ( v125374(VarCurr)
    <=> ( v125375(VarCurr)
        | v125376(VarCurr) ) ) ).

tff(writeUnaryOperator_8797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125376(VarCurr)
    <=> v125365(VarCurr,2) ) ).

tff(writeUnaryOperator_8796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125375(VarCurr)
    <=> v125204(VarCurr,2) ) ).

tff(writeUnaryOperator_8795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125200(VarCurr)
    <=> v125201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15833,axiom,
    ! [VarCurr: state_type] :
      ( v125201(VarCurr)
    <=> ( v125202(VarCurr)
        | v125371(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5546,axiom,
    ! [VarCurr: state_type] :
      ( v125371(VarCurr)
    <=> ( v125204(VarCurr,1)
        & v125365(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15832,axiom,
    ! [VarCurr: state_type] :
      ( v125202(VarCurr)
    <=> ( v125203(VarCurr)
        & v125366(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15831,axiom,
    ! [VarCurr: state_type] :
      ( v125366(VarCurr)
    <=> ( v125367(VarCurr)
        & v125370(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5545,axiom,
    ! [VarCurr: state_type] :
      ( v125370(VarCurr)
    <=> ( v125204(VarCurr,1)
        | v125365(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15830,axiom,
    ! [VarCurr: state_type] :
      ( v125367(VarCurr)
    <=> ( v125368(VarCurr)
        | v125369(VarCurr) ) ) ).

tff(writeUnaryOperator_8794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125369(VarCurr)
    <=> v125365(VarCurr,1) ) ).

tff(writeUnaryOperator_8793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125368(VarCurr)
    <=> v125204(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15829,axiom,
    ! [VarCurr: state_type] :
      ( v125203(VarCurr)
    <=> ( v125204(VarCurr,0)
        & v125365(VarCurr,0) ) ) ).

tff(addAssignment_71013,axiom,
    ! [VarCurr: state_type] :
      ( v125365(VarCurr,0)
    <=> v125195(VarCurr) ) ).

tff(addAssignment_71012,axiom,
    ! [VarCurr: state_type] :
      ( ( v125365(VarCurr,2)
      <=> $false )
      & ( v125365(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71011,axiom,
    ! [VarCurr: state_type] :
      ( v125204(VarCurr,0)
    <=> v125360(VarCurr) ) ).

tff(addAssignment_71010,axiom,
    ! [VarCurr: state_type] :
      ( v125204(VarCurr,1)
    <=> v125355(VarCurr) ) ).

tff(addAssignment_71009,axiom,
    ! [VarCurr: state_type] :
      ( v125204(VarCurr,2)
    <=> v125206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15828,axiom,
    ! [VarCurr: state_type] :
      ( v125360(VarCurr)
    <=> ( v125361(VarCurr)
        & v125364(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15827,axiom,
    ! [VarCurr: state_type] :
      ( v125364(VarCurr)
    <=> ( v125212(VarCurr,0)
        | v125341(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15826,axiom,
    ! [VarCurr: state_type] :
      ( v125361(VarCurr)
    <=> ( v125362(VarCurr)
        | v125363(VarCurr) ) ) ).

tff(writeUnaryOperator_8792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125363(VarCurr)
    <=> v125341(VarCurr,0) ) ).

tff(writeUnaryOperator_8791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125362(VarCurr)
    <=> v125212(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15825,axiom,
    ! [VarCurr: state_type] :
      ( v125355(VarCurr)
    <=> ( v125356(VarCurr)
        & v125359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15824,axiom,
    ! [VarCurr: state_type] :
      ( v125359(VarCurr)
    <=> ( v125211(VarCurr)
        | v125342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15823,axiom,
    ! [VarCurr: state_type] :
      ( v125356(VarCurr)
    <=> ( v125357(VarCurr)
        | v125358(VarCurr) ) ) ).

tff(writeUnaryOperator_8790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125358(VarCurr)
    <=> v125342(VarCurr) ) ).

tff(writeUnaryOperator_8789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125357(VarCurr)
    <=> v125211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15822,axiom,
    ! [VarCurr: state_type] :
      ( v125206(VarCurr)
    <=> ( v125207(VarCurr)
        & v125354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15821,axiom,
    ! [VarCurr: state_type] :
      ( v125354(VarCurr)
    <=> ( v125209(VarCurr)
        | v125349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15820,axiom,
    ! [VarCurr: state_type] :
      ( v125207(VarCurr)
    <=> ( v125208(VarCurr)
        | v125348(VarCurr) ) ) ).

tff(writeUnaryOperator_8788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125348(VarCurr)
    <=> v125349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15819,axiom,
    ! [VarCurr: state_type] :
      ( v125349(VarCurr)
    <=> ( v125350(VarCurr)
        & v125353(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5544,axiom,
    ! [VarCurr: state_type] :
      ( v125353(VarCurr)
    <=> ( v125212(VarCurr,2)
        | v125341(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15818,axiom,
    ! [VarCurr: state_type] :
      ( v125350(VarCurr)
    <=> ( v125351(VarCurr)
        | v125352(VarCurr) ) ) ).

tff(writeUnaryOperator_8787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125352(VarCurr)
    <=> v125341(VarCurr,2) ) ).

tff(writeUnaryOperator_8786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125351(VarCurr)
    <=> v125212(VarCurr,2) ) ).

tff(writeUnaryOperator_8785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125208(VarCurr)
    <=> v125209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15817,axiom,
    ! [VarCurr: state_type] :
      ( v125209(VarCurr)
    <=> ( v125210(VarCurr)
        | v125347(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5543,axiom,
    ! [VarCurr: state_type] :
      ( v125347(VarCurr)
    <=> ( v125212(VarCurr,1)
        & v125341(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15816,axiom,
    ! [VarCurr: state_type] :
      ( v125210(VarCurr)
    <=> ( v125211(VarCurr)
        & v125342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15815,axiom,
    ! [VarCurr: state_type] :
      ( v125342(VarCurr)
    <=> ( v125343(VarCurr)
        & v125346(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5542,axiom,
    ! [VarCurr: state_type] :
      ( v125346(VarCurr)
    <=> ( v125212(VarCurr,1)
        | v125341(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15814,axiom,
    ! [VarCurr: state_type] :
      ( v125343(VarCurr)
    <=> ( v125344(VarCurr)
        | v125345(VarCurr) ) ) ).

tff(writeUnaryOperator_8784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125345(VarCurr)
    <=> v125341(VarCurr,1) ) ).

tff(writeUnaryOperator_8783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125344(VarCurr)
    <=> v125212(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15813,axiom,
    ! [VarCurr: state_type] :
      ( v125211(VarCurr)
    <=> ( v125212(VarCurr,0)
        & v125341(VarCurr,0) ) ) ).

tff(addAssignment_71008,axiom,
    ! [VarCurr: state_type] :
      ( v125341(VarCurr,0)
    <=> v125193(VarCurr) ) ).

tff(addAssignment_71007,axiom,
    ! [VarCurr: state_type] :
      ( ( v125341(VarCurr,2)
      <=> $false )
      & ( v125341(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71006,axiom,
    ! [VarCurr: state_type] :
      ( v125212(VarCurr,0)
    <=> v125336(VarCurr) ) ).

tff(addAssignment_71005,axiom,
    ! [VarCurr: state_type] :
      ( v125212(VarCurr,1)
    <=> v125331(VarCurr) ) ).

tff(addAssignment_71004,axiom,
    ! [VarCurr: state_type] :
      ( v125212(VarCurr,2)
    <=> v125214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15812,axiom,
    ! [VarCurr: state_type] :
      ( v125336(VarCurr)
    <=> ( v125337(VarCurr)
        & v125340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15811,axiom,
    ! [VarCurr: state_type] :
      ( v125340(VarCurr)
    <=> ( v125220(VarCurr,0)
        | v125317(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15810,axiom,
    ! [VarCurr: state_type] :
      ( v125337(VarCurr)
    <=> ( v125338(VarCurr)
        | v125339(VarCurr) ) ) ).

tff(writeUnaryOperator_8782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125339(VarCurr)
    <=> v125317(VarCurr,0) ) ).

tff(writeUnaryOperator_8781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125338(VarCurr)
    <=> v125220(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15809,axiom,
    ! [VarCurr: state_type] :
      ( v125331(VarCurr)
    <=> ( v125332(VarCurr)
        & v125335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15808,axiom,
    ! [VarCurr: state_type] :
      ( v125335(VarCurr)
    <=> ( v125219(VarCurr)
        | v125318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15807,axiom,
    ! [VarCurr: state_type] :
      ( v125332(VarCurr)
    <=> ( v125333(VarCurr)
        | v125334(VarCurr) ) ) ).

tff(writeUnaryOperator_8780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125334(VarCurr)
    <=> v125318(VarCurr) ) ).

tff(writeUnaryOperator_8779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125333(VarCurr)
    <=> v125219(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15806,axiom,
    ! [VarCurr: state_type] :
      ( v125214(VarCurr)
    <=> ( v125215(VarCurr)
        & v125330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15805,axiom,
    ! [VarCurr: state_type] :
      ( v125330(VarCurr)
    <=> ( v125217(VarCurr)
        | v125325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15804,axiom,
    ! [VarCurr: state_type] :
      ( v125215(VarCurr)
    <=> ( v125216(VarCurr)
        | v125324(VarCurr) ) ) ).

tff(writeUnaryOperator_8778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125324(VarCurr)
    <=> v125325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15803,axiom,
    ! [VarCurr: state_type] :
      ( v125325(VarCurr)
    <=> ( v125326(VarCurr)
        & v125329(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5541,axiom,
    ! [VarCurr: state_type] :
      ( v125329(VarCurr)
    <=> ( v125220(VarCurr,2)
        | v125317(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15802,axiom,
    ! [VarCurr: state_type] :
      ( v125326(VarCurr)
    <=> ( v125327(VarCurr)
        | v125328(VarCurr) ) ) ).

tff(writeUnaryOperator_8777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125328(VarCurr)
    <=> v125317(VarCurr,2) ) ).

tff(writeUnaryOperator_8776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125327(VarCurr)
    <=> v125220(VarCurr,2) ) ).

tff(writeUnaryOperator_8775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125216(VarCurr)
    <=> v125217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15801,axiom,
    ! [VarCurr: state_type] :
      ( v125217(VarCurr)
    <=> ( v125218(VarCurr)
        | v125323(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5540,axiom,
    ! [VarCurr: state_type] :
      ( v125323(VarCurr)
    <=> ( v125220(VarCurr,1)
        & v125317(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15800,axiom,
    ! [VarCurr: state_type] :
      ( v125218(VarCurr)
    <=> ( v125219(VarCurr)
        & v125318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15799,axiom,
    ! [VarCurr: state_type] :
      ( v125318(VarCurr)
    <=> ( v125319(VarCurr)
        & v125322(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5539,axiom,
    ! [VarCurr: state_type] :
      ( v125322(VarCurr)
    <=> ( v125220(VarCurr,1)
        | v125317(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15798,axiom,
    ! [VarCurr: state_type] :
      ( v125319(VarCurr)
    <=> ( v125320(VarCurr)
        | v125321(VarCurr) ) ) ).

tff(writeUnaryOperator_8774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125321(VarCurr)
    <=> v125317(VarCurr,1) ) ).

tff(writeUnaryOperator_8773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125320(VarCurr)
    <=> v125220(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15797,axiom,
    ! [VarCurr: state_type] :
      ( v125219(VarCurr)
    <=> ( v125220(VarCurr,0)
        & v125317(VarCurr,0) ) ) ).

tff(addAssignment_71003,axiom,
    ! [VarCurr: state_type] :
      ( v125317(VarCurr,0)
    <=> v125191(VarCurr) ) ).

tff(addAssignment_71002,axiom,
    ! [VarCurr: state_type] :
      ( ( v125317(VarCurr,2)
      <=> $false )
      & ( v125317(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_71001,axiom,
    ! [VarCurr: state_type] :
      ( v125220(VarCurr,0)
    <=> v125312(VarCurr) ) ).

tff(addAssignment_71000,axiom,
    ! [VarCurr: state_type] :
      ( v125220(VarCurr,1)
    <=> v125307(VarCurr) ) ).

tff(addAssignment_70999,axiom,
    ! [VarCurr: state_type] :
      ( v125220(VarCurr,2)
    <=> v125222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15796,axiom,
    ! [VarCurr: state_type] :
      ( v125312(VarCurr)
    <=> ( v125313(VarCurr)
        & v125316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15795,axiom,
    ! [VarCurr: state_type] :
      ( v125316(VarCurr)
    <=> ( v125228(VarCurr,0)
        | v125293(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15794,axiom,
    ! [VarCurr: state_type] :
      ( v125313(VarCurr)
    <=> ( v125314(VarCurr)
        | v125315(VarCurr) ) ) ).

tff(writeUnaryOperator_8772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125315(VarCurr)
    <=> v125293(VarCurr,0) ) ).

tff(writeUnaryOperator_8771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125314(VarCurr)
    <=> v125228(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15793,axiom,
    ! [VarCurr: state_type] :
      ( v125307(VarCurr)
    <=> ( v125308(VarCurr)
        & v125311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15792,axiom,
    ! [VarCurr: state_type] :
      ( v125311(VarCurr)
    <=> ( v125227(VarCurr)
        | v125294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15791,axiom,
    ! [VarCurr: state_type] :
      ( v125308(VarCurr)
    <=> ( v125309(VarCurr)
        | v125310(VarCurr) ) ) ).

tff(writeUnaryOperator_8770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125310(VarCurr)
    <=> v125294(VarCurr) ) ).

tff(writeUnaryOperator_8769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125309(VarCurr)
    <=> v125227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15790,axiom,
    ! [VarCurr: state_type] :
      ( v125222(VarCurr)
    <=> ( v125223(VarCurr)
        & v125306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15789,axiom,
    ! [VarCurr: state_type] :
      ( v125306(VarCurr)
    <=> ( v125225(VarCurr)
        | v125301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15788,axiom,
    ! [VarCurr: state_type] :
      ( v125223(VarCurr)
    <=> ( v125224(VarCurr)
        | v125300(VarCurr) ) ) ).

tff(writeUnaryOperator_8768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125300(VarCurr)
    <=> v125301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15787,axiom,
    ! [VarCurr: state_type] :
      ( v125301(VarCurr)
    <=> ( v125302(VarCurr)
        & v125305(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5538,axiom,
    ! [VarCurr: state_type] :
      ( v125305(VarCurr)
    <=> ( v125228(VarCurr,2)
        | v125293(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15786,axiom,
    ! [VarCurr: state_type] :
      ( v125302(VarCurr)
    <=> ( v125303(VarCurr)
        | v125304(VarCurr) ) ) ).

tff(writeUnaryOperator_8767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125304(VarCurr)
    <=> v125293(VarCurr,2) ) ).

tff(writeUnaryOperator_8766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125303(VarCurr)
    <=> v125228(VarCurr,2) ) ).

tff(writeUnaryOperator_8765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125224(VarCurr)
    <=> v125225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15785,axiom,
    ! [VarCurr: state_type] :
      ( v125225(VarCurr)
    <=> ( v125226(VarCurr)
        | v125299(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5537,axiom,
    ! [VarCurr: state_type] :
      ( v125299(VarCurr)
    <=> ( v125228(VarCurr,1)
        & v125293(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15784,axiom,
    ! [VarCurr: state_type] :
      ( v125226(VarCurr)
    <=> ( v125227(VarCurr)
        & v125294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15783,axiom,
    ! [VarCurr: state_type] :
      ( v125294(VarCurr)
    <=> ( v125295(VarCurr)
        & v125298(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5536,axiom,
    ! [VarCurr: state_type] :
      ( v125298(VarCurr)
    <=> ( v125228(VarCurr,1)
        | v125293(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15782,axiom,
    ! [VarCurr: state_type] :
      ( v125295(VarCurr)
    <=> ( v125296(VarCurr)
        | v125297(VarCurr) ) ) ).

tff(writeUnaryOperator_8764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125297(VarCurr)
    <=> v125293(VarCurr,1) ) ).

tff(writeUnaryOperator_8763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125296(VarCurr)
    <=> v125228(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15781,axiom,
    ! [VarCurr: state_type] :
      ( v125227(VarCurr)
    <=> ( v125228(VarCurr,0)
        & v125293(VarCurr,0) ) ) ).

tff(addAssignment_70998,axiom,
    ! [VarCurr: state_type] :
      ( v125293(VarCurr,0)
    <=> v125189(VarCurr) ) ).

tff(addAssignment_70997,axiom,
    ! [VarCurr: state_type] :
      ( ( v125293(VarCurr,2)
      <=> $false )
      & ( v125293(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70996,axiom,
    ! [VarCurr: state_type] :
      ( v125228(VarCurr,0)
    <=> v125288(VarCurr) ) ).

tff(addAssignment_70995,axiom,
    ! [VarCurr: state_type] :
      ( v125228(VarCurr,1)
    <=> v125283(VarCurr) ) ).

tff(addAssignment_70994,axiom,
    ! [VarCurr: state_type] :
      ( v125228(VarCurr,2)
    <=> v125230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15780,axiom,
    ! [VarCurr: state_type] :
      ( v125288(VarCurr)
    <=> ( v125289(VarCurr)
        & v125292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15779,axiom,
    ! [VarCurr: state_type] :
      ( v125292(VarCurr)
    <=> ( v125236(VarCurr,0)
        | v125269(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15778,axiom,
    ! [VarCurr: state_type] :
      ( v125289(VarCurr)
    <=> ( v125290(VarCurr)
        | v125291(VarCurr) ) ) ).

tff(writeUnaryOperator_8762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125291(VarCurr)
    <=> v125269(VarCurr,0) ) ).

tff(writeUnaryOperator_8761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125290(VarCurr)
    <=> v125236(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15777,axiom,
    ! [VarCurr: state_type] :
      ( v125283(VarCurr)
    <=> ( v125284(VarCurr)
        & v125287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15776,axiom,
    ! [VarCurr: state_type] :
      ( v125287(VarCurr)
    <=> ( v125235(VarCurr)
        | v125270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15775,axiom,
    ! [VarCurr: state_type] :
      ( v125284(VarCurr)
    <=> ( v125285(VarCurr)
        | v125286(VarCurr) ) ) ).

tff(writeUnaryOperator_8760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125286(VarCurr)
    <=> v125270(VarCurr) ) ).

tff(writeUnaryOperator_8759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125285(VarCurr)
    <=> v125235(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15774,axiom,
    ! [VarCurr: state_type] :
      ( v125230(VarCurr)
    <=> ( v125231(VarCurr)
        & v125282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15773,axiom,
    ! [VarCurr: state_type] :
      ( v125282(VarCurr)
    <=> ( v125233(VarCurr)
        | v125277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15772,axiom,
    ! [VarCurr: state_type] :
      ( v125231(VarCurr)
    <=> ( v125232(VarCurr)
        | v125276(VarCurr) ) ) ).

tff(writeUnaryOperator_8758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125276(VarCurr)
    <=> v125277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15771,axiom,
    ! [VarCurr: state_type] :
      ( v125277(VarCurr)
    <=> ( v125278(VarCurr)
        & v125281(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5535,axiom,
    ! [VarCurr: state_type] :
      ( v125281(VarCurr)
    <=> ( v125236(VarCurr,2)
        | v125269(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15770,axiom,
    ! [VarCurr: state_type] :
      ( v125278(VarCurr)
    <=> ( v125279(VarCurr)
        | v125280(VarCurr) ) ) ).

tff(writeUnaryOperator_8757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125280(VarCurr)
    <=> v125269(VarCurr,2) ) ).

tff(writeUnaryOperator_8756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125279(VarCurr)
    <=> v125236(VarCurr,2) ) ).

tff(writeUnaryOperator_8755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125232(VarCurr)
    <=> v125233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15769,axiom,
    ! [VarCurr: state_type] :
      ( v125233(VarCurr)
    <=> ( v125234(VarCurr)
        | v125275(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5534,axiom,
    ! [VarCurr: state_type] :
      ( v125275(VarCurr)
    <=> ( v125236(VarCurr,1)
        & v125269(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15768,axiom,
    ! [VarCurr: state_type] :
      ( v125234(VarCurr)
    <=> ( v125235(VarCurr)
        & v125270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15767,axiom,
    ! [VarCurr: state_type] :
      ( v125270(VarCurr)
    <=> ( v125271(VarCurr)
        & v125274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5533,axiom,
    ! [VarCurr: state_type] :
      ( v125274(VarCurr)
    <=> ( v125236(VarCurr,1)
        | v125269(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15766,axiom,
    ! [VarCurr: state_type] :
      ( v125271(VarCurr)
    <=> ( v125272(VarCurr)
        | v125273(VarCurr) ) ) ).

tff(writeUnaryOperator_8754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125273(VarCurr)
    <=> v125269(VarCurr,1) ) ).

tff(writeUnaryOperator_8753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125272(VarCurr)
    <=> v125236(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15765,axiom,
    ! [VarCurr: state_type] :
      ( v125235(VarCurr)
    <=> ( v125236(VarCurr,0)
        & v125269(VarCurr,0) ) ) ).

tff(addAssignment_70993,axiom,
    ! [VarCurr: state_type] :
      ( v125269(VarCurr,0)
    <=> v125187(VarCurr) ) ).

tff(addAssignment_70992,axiom,
    ! [VarCurr: state_type] :
      ( ( v125269(VarCurr,2)
      <=> $false )
      & ( v125269(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70991,axiom,
    ! [VarCurr: state_type] :
      ( v125236(VarCurr,0)
    <=> v125264(VarCurr) ) ).

tff(addAssignment_70990,axiom,
    ! [VarCurr: state_type] :
      ( v125236(VarCurr,1)
    <=> v125259(VarCurr) ) ).

tff(addAssignment_70989,axiom,
    ! [VarCurr: state_type] :
      ( v125236(VarCurr,2)
    <=> v125238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15764,axiom,
    ! [VarCurr: state_type] :
      ( v125264(VarCurr)
    <=> ( v125265(VarCurr)
        & v125268(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15763,axiom,
    ! [VarCurr: state_type] :
      ( v125268(VarCurr)
    <=> ( v125244(VarCurr,0)
        | v125245(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15762,axiom,
    ! [VarCurr: state_type] :
      ( v125265(VarCurr)
    <=> ( v125266(VarCurr)
        | v125267(VarCurr) ) ) ).

tff(writeUnaryOperator_8752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125267(VarCurr)
    <=> v125245(VarCurr,0) ) ).

tff(writeUnaryOperator_8751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125266(VarCurr)
    <=> v125244(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15761,axiom,
    ! [VarCurr: state_type] :
      ( v125259(VarCurr)
    <=> ( v125260(VarCurr)
        & v125263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15760,axiom,
    ! [VarCurr: state_type] :
      ( v125263(VarCurr)
    <=> ( v125243(VarCurr)
        | v125246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15759,axiom,
    ! [VarCurr: state_type] :
      ( v125260(VarCurr)
    <=> ( v125261(VarCurr)
        | v125262(VarCurr) ) ) ).

tff(writeUnaryOperator_8750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125262(VarCurr)
    <=> v125246(VarCurr) ) ).

tff(writeUnaryOperator_8749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125261(VarCurr)
    <=> v125243(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15758,axiom,
    ! [VarCurr: state_type] :
      ( v125238(VarCurr)
    <=> ( v125239(VarCurr)
        & v125258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15757,axiom,
    ! [VarCurr: state_type] :
      ( v125258(VarCurr)
    <=> ( v125241(VarCurr)
        | v125253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15756,axiom,
    ! [VarCurr: state_type] :
      ( v125239(VarCurr)
    <=> ( v125240(VarCurr)
        | v125252(VarCurr) ) ) ).

tff(writeUnaryOperator_8748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125252(VarCurr)
    <=> v125253(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15755,axiom,
    ! [VarCurr: state_type] :
      ( v125253(VarCurr)
    <=> ( v125254(VarCurr)
        & v125257(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5532,axiom,
    ! [VarCurr: state_type] :
      ( v125257(VarCurr)
    <=> ( v125244(VarCurr,2)
        | v125245(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15754,axiom,
    ! [VarCurr: state_type] :
      ( v125254(VarCurr)
    <=> ( v125255(VarCurr)
        | v125256(VarCurr) ) ) ).

tff(writeUnaryOperator_8747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125256(VarCurr)
    <=> v125245(VarCurr,2) ) ).

tff(writeUnaryOperator_8746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125255(VarCurr)
    <=> v125244(VarCurr,2) ) ).

tff(writeUnaryOperator_8745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125240(VarCurr)
    <=> v125241(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15753,axiom,
    ! [VarCurr: state_type] :
      ( v125241(VarCurr)
    <=> ( v125242(VarCurr)
        | v125251(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5531,axiom,
    ! [VarCurr: state_type] :
      ( v125251(VarCurr)
    <=> ( v125244(VarCurr,1)
        & v125245(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15752,axiom,
    ! [VarCurr: state_type] :
      ( v125242(VarCurr)
    <=> ( v125243(VarCurr)
        & v125246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15751,axiom,
    ! [VarCurr: state_type] :
      ( v125246(VarCurr)
    <=> ( v125247(VarCurr)
        & v125250(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5530,axiom,
    ! [VarCurr: state_type] :
      ( v125250(VarCurr)
    <=> ( v125244(VarCurr,1)
        | v125245(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15750,axiom,
    ! [VarCurr: state_type] :
      ( v125247(VarCurr)
    <=> ( v125248(VarCurr)
        | v125249(VarCurr) ) ) ).

tff(writeUnaryOperator_8744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125249(VarCurr)
    <=> v125245(VarCurr,1) ) ).

tff(writeUnaryOperator_8743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125248(VarCurr)
    <=> v125244(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15749,axiom,
    ! [VarCurr: state_type] :
      ( v125243(VarCurr)
    <=> ( v125244(VarCurr,0)
        & v125245(VarCurr,0) ) ) ).

tff(addAssignment_70988,axiom,
    ! [VarCurr: state_type] :
      ( v125245(VarCurr,0)
    <=> v125185(VarCurr) ) ).

tff(addAssignment_70987,axiom,
    ! [VarCurr: state_type] :
      ( ( v125245(VarCurr,2)
      <=> $false )
      & ( v125245(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70986,axiom,
    ! [VarCurr: state_type] :
      ( v125244(VarCurr,0)
    <=> v125183(VarCurr) ) ).

tff(addAssignment_70985,axiom,
    ! [VarCurr: state_type] :
      ( ( v125244(VarCurr,2)
      <=> $false )
      & ( v125244(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70984,axiom,
    ! [VarCurr: state_type] :
      ( v125195(VarCurr)
    <=> v114692(VarCurr,14) ) ).

tff(addAssignment_70983,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,14)
    <=> v114694(VarCurr,14) ) ).

tff(addAssignment_70982,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,14)
    <=> v114696(VarCurr,14) ) ).

tff(addAssignment_70981,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,14)
    <=> v114697(VarCurr,14) ) ).

tff(addAssignment_70980,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,14)
    <=> v113918(VarCurr,14) ) ).

tff(addAssignment_70979,axiom,
    ! [VarCurr: state_type] :
      ( v125193(VarCurr)
    <=> v114685(VarCurr,14) ) ).

tff(addAssignment_70978,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,14)
    <=> v114686(VarCurr,14) ) ).

tff(addAssignment_70977,axiom,
    ! [VarCurr: state_type] :
      ( v125191(VarCurr)
    <=> v114661(VarCurr,14) ) ).

tff(addAssignment_70976,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,14)
    <=> v114662(VarCurr,14) ) ).

tff(addAssignment_70975,axiom,
    ! [VarCurr: state_type] :
      ( v125189(VarCurr)
    <=> v114633(VarCurr,14) ) ).

tff(addAssignment_70974,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,14)
    <=> v114635(VarCurr,14) ) ).

tff(addAssignment_70973,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,14)
    <=> v114637(VarCurr,14) ) ).

tff(addAssignment_70972,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,14)
    <=> v114638(VarCurr,14) ) ).

tff(addAssignment_70971,axiom,
    ! [VarCurr: state_type] :
      ( v125187(VarCurr)
    <=> v114605(VarCurr,14) ) ).

tff(addAssignment_70970,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,14)
    <=> v114607(VarCurr,14) ) ).

tff(addAssignment_70969,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,14)
    <=> v114609(VarCurr,14) ) ).

tff(addAssignment_70968,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,14)
    <=> v114610(VarCurr,14) ) ).

tff(addAssignment_70967,axiom,
    ! [VarCurr: state_type] :
      ( v125185(VarCurr)
    <=> v114577(VarCurr,14) ) ).

tff(addAssignment_70966,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,14)
    <=> v114579(VarCurr,14) ) ).

tff(addAssignment_70965,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,14)
    <=> v114581(VarCurr,14) ) ).

tff(addAssignment_70964,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,14)
    <=> v114582(VarCurr,14) ) ).

tff(addAssignment_70963,axiom,
    ! [VarCurr: state_type] :
      ( v125183(VarCurr)
    <=> v114549(VarCurr,14) ) ).

tff(addAssignment_70962,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,14)
    <=> v114551(VarCurr,14) ) ).

tff(addAssignment_70961,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,14)
    <=> v114553(VarCurr,14) ) ).

tff(addAssignment_70960,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,14)
    <=> v114554(VarCurr,14) ) ).

tff(addAssignment_70959,axiom,
    ! [VarCurr: state_type] :
      ( v125169(VarCurr)
    <=> v125171(VarCurr) ) ).

tff(addAssignment_70958,axiom,
    ! [VarCurr: state_type] :
      ( v125171(VarCurr)
    <=> v125145(VarCurr) ) ).

tff(addAssignment_70957,axiom,
    ! [VarCurr: state_type] :
      ( v125165(VarCurr)
    <=> v125167(VarCurr) ) ).

tff(addAssignment_70956,axiom,
    ! [VarCurr: state_type] :
      ( v125167(VarCurr)
    <=> v125137(VarCurr) ) ).

tff(addAssignment_70955,axiom,
    ! [VarCurr: state_type] :
      ( v125141(VarCurr)
    <=> v125143(VarCurr) ) ).

tff(addAssignment_70954,axiom,
    ! [VarCurr: state_type] :
      ( v125143(VarCurr)
    <=> v125145(VarCurr) ) ).

tff(addAssignment_70953,axiom,
    ! [VarCurr: state_type] :
      ( v125145(VarCurr)
    <=> v125147(VarCurr) ) ).

tff(addAssignment_70952,axiom,
    ! [VarCurr: state_type] :
      ( v125147(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_70951,axiom,
    ! [VarCurr: state_type] :
      ( v125133(VarCurr)
    <=> v125135(VarCurr) ) ).

tff(addAssignment_70950,axiom,
    ! [VarCurr: state_type] :
      ( v125135(VarCurr)
    <=> v125137(VarCurr) ) ).

tff(addAssignment_70949,axiom,
    ! [VarCurr: state_type] :
      ( v125137(VarCurr)
    <=> v125139(VarCurr) ) ).

tff(addAssignment_70948,axiom,
    ! [VarCurr: state_type] :
      ( v125139(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15748,axiom,
    ! [VarCurr: state_type] :
      ( v124324(VarCurr)
    <=> ( v125123(VarCurr)
        & v125033(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5529,axiom,
    ! [VarCurr: state_type] :
      ( v125123(VarCurr)
    <=> ( v124326(VarCurr,1)
        & v124972(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1235,axiom,
    ! [VarCurr: state_type] :
      ( v125033(VarCurr)
    <=> ( ( v125035(VarCurr,4)
        <=> $false )
        & ( v125035(VarCurr,3)
        <=> $false )
        & ( v125035(VarCurr,2)
        <=> $false )
        & ( v125035(VarCurr,1)
        <=> $false )
        & ( v125035(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125035(VarCurr,B)
      <=> v125037(VarCurr,B) ) ) ).

tff(addAssignment_70946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125037(VarCurr,B)
      <=> v125039(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125105(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v125039(VarNext,B)
            <=> v125039(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1623,axiom,
    ! [VarNext: state_type] :
      ( v125105(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125039(VarNext,B)
          <=> v125115(VarNext,B) ) ) ) ).

tff(addAssignment_70945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125115(VarNext,B)
          <=> v125113(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125116(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125113(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1169,axiom,
    ! [VarCurr: state_type] :
      ( v125116(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125113(VarCurr,B)
          <=> v125049(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15747,axiom,
    ! [VarCurr: state_type] :
      ( v125116(VarCurr)
    <=> ( v125117(VarCurr)
        & v125118(VarCurr) ) ) ).

tff(writeUnaryOperator_8742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125118(VarCurr)
    <=> v125045(VarCurr) ) ).

tff(writeUnaryOperator_8741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125117(VarCurr)
    <=> v125041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125105(VarNext)
      <=> v125106(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125106(VarNext)
      <=> ( v125107(VarNext)
          & v125100(VarNext) ) ) ) ).

tff(writeUnaryOperator_8740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125107(VarNext)
      <=> v125109(VarNext) ) ) ).

tff(addAssignment_70944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125109(VarNext)
      <=> v125100(VarCurr) ) ) ).

tff(addAssignment_70943,axiom,
    ! [VarCurr: state_type] :
      ( v125100(VarCurr)
    <=> v125102(VarCurr) ) ).

tff(addAssignment_70942,axiom,
    ! [VarCurr: state_type] :
      ( v125102(VarCurr)
    <=> v124806(VarCurr) ) ).

tff(addAssignment_70941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125049(VarCurr,B)
      <=> v125051(VarCurr,B) ) ) ).

tff(addAssignment_70940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125051(VarCurr,B)
      <=> v125053(VarCurr,B) ) ) ).

tff(addAssignment_70939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125053(VarCurr,B)
      <=> v125055(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125057(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125055(VarCurr,B)
          <=> v125069(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1168,axiom,
    ! [VarCurr: state_type] :
      ( v125057(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125055(VarCurr,B)
          <=> v125062(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125064(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125069(VarCurr,B)
          <=> v125070(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1167,axiom,
    ! [VarCurr: state_type] :
      ( v125064(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125069(VarCurr,B)
          <=> v125067(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125070(VarCurr,B)
          <=> v125071(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1166,axiom,
    ! [VarCurr: state_type] :
      ( v125033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v125070(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70938,axiom,
    ! [VarCurr: state_type] :
      ( v125071(VarCurr,0)
    <=> v125097(VarCurr) ) ).

tff(addAssignment_70937,axiom,
    ! [VarCurr: state_type] :
      ( v125071(VarCurr,1)
    <=> v125095(VarCurr) ) ).

tff(addAssignment_70936,axiom,
    ! [VarCurr: state_type] :
      ( v125071(VarCurr,2)
    <=> v125091(VarCurr) ) ).

tff(addAssignment_70935,axiom,
    ! [VarCurr: state_type] :
      ( v125071(VarCurr,3)
    <=> v125087(VarCurr) ) ).

tff(addAssignment_70934,axiom,
    ! [VarCurr: state_type] :
      ( v125071(VarCurr,4)
    <=> v125073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15744,axiom,
    ! [VarCurr: state_type] :
      ( v125095(VarCurr)
    <=> ( v125096(VarCurr)
        & v125098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15743,axiom,
    ! [VarCurr: state_type] :
      ( v125098(VarCurr)
    <=> ( v125035(VarCurr,0)
        | v125082(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5528,axiom,
    ! [VarCurr: state_type] :
      ( v125096(VarCurr)
    <=> ( v125097(VarCurr)
        | v125035(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125097(VarCurr)
    <=> v125035(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15742,axiom,
    ! [VarCurr: state_type] :
      ( v125091(VarCurr)
    <=> ( v125092(VarCurr)
        & v125094(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15741,axiom,
    ! [VarCurr: state_type] :
      ( v125094(VarCurr)
    <=> ( v125080(VarCurr)
        | v125083(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5527,axiom,
    ! [VarCurr: state_type] :
      ( v125092(VarCurr)
    <=> ( v125093(VarCurr)
        | v125035(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125093(VarCurr)
    <=> v125080(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15740,axiom,
    ! [VarCurr: state_type] :
      ( v125087(VarCurr)
    <=> ( v125088(VarCurr)
        & v125090(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15739,axiom,
    ! [VarCurr: state_type] :
      ( v125090(VarCurr)
    <=> ( v125078(VarCurr)
        | v125084(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5526,axiom,
    ! [VarCurr: state_type] :
      ( v125088(VarCurr)
    <=> ( v125089(VarCurr)
        | v125035(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125089(VarCurr)
    <=> v125078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15738,axiom,
    ! [VarCurr: state_type] :
      ( v125073(VarCurr)
    <=> ( v125074(VarCurr)
        & v125085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15737,axiom,
    ! [VarCurr: state_type] :
      ( v125085(VarCurr)
    <=> ( v125076(VarCurr)
        | v125086(VarCurr) ) ) ).

tff(writeUnaryOperator_8736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125086(VarCurr)
    <=> v125035(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5525,axiom,
    ! [VarCurr: state_type] :
      ( v125074(VarCurr)
    <=> ( v125075(VarCurr)
        | v125035(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125075(VarCurr)
    <=> v125076(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5524,axiom,
    ! [VarCurr: state_type] :
      ( v125076(VarCurr)
    <=> ( v125035(VarCurr,3)
        | v125077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15736,axiom,
    ! [VarCurr: state_type] :
      ( v125077(VarCurr)
    <=> ( v125078(VarCurr)
        & v125084(VarCurr) ) ) ).

tff(writeUnaryOperator_8734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125084(VarCurr)
    <=> v125035(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5523,axiom,
    ! [VarCurr: state_type] :
      ( v125078(VarCurr)
    <=> ( v125035(VarCurr,2)
        | v125079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15735,axiom,
    ! [VarCurr: state_type] :
      ( v125079(VarCurr)
    <=> ( v125080(VarCurr)
        & v125083(VarCurr) ) ) ).

tff(writeUnaryOperator_8733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125083(VarCurr)
    <=> v125035(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5522,axiom,
    ! [VarCurr: state_type] :
      ( v125080(VarCurr)
    <=> ( v125035(VarCurr,1)
        | v125081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15734,axiom,
    ! [VarCurr: state_type] :
      ( v125081(VarCurr)
    <=> ( v125035(VarCurr,0)
        & v125082(VarCurr) ) ) ).

tff(writeUnaryOperator_8732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125082(VarCurr)
    <=> v125035(VarCurr,1) ) ).

tff(addAssignment_70933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125067(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15733,axiom,
    ! [VarCurr: state_type] :
      ( v125064(VarCurr)
    <=> ( v124611(VarCurr)
        | v124625(VarCurr) ) ) ).

tff(addAssignment_70932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v125062(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15732,axiom,
    ! [VarCurr: state_type] :
      ( v125057(VarCurr)
    <=> ( v125059(VarCurr)
        | v124623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15731,axiom,
    ! [VarCurr: state_type] :
      ( v125059(VarCurr)
    <=> ( v125060(VarCurr)
        | v124621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15730,axiom,
    ! [VarCurr: state_type] :
      ( v125060(VarCurr)
    <=> ( v124591(VarCurr)
        | v124601(VarCurr) ) ) ).

tff(addAssignment_70931,axiom,
    ! [VarCurr: state_type] :
      ( v125045(VarCurr)
    <=> v125047(VarCurr) ) ).

tff(addAssignment_70930,axiom,
    ! [VarCurr: state_type] :
      ( v125047(VarCurr)
    <=> v124344(VarCurr) ) ).

tff(addAssignment_70929,axiom,
    ! [VarCurr: state_type] :
      ( v125041(VarCurr)
    <=> v125043(VarCurr) ) ).

tff(addAssignment_70928,axiom,
    ! [VarCurr: state_type] :
      ( v125043(VarCurr)
    <=> v124336(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1234,axiom,
    ! [VarCurr: state_type] :
      ( v124972(VarCurr)
    <=> ( ( v124974(VarCurr,1)
        <=> $false )
        & ( v124974(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124974(VarCurr,B)
      <=> v124976(VarCurr,B) ) ) ).

tff(addAssignment_70926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124976(VarCurr,B)
      <=> v124978(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125015(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v124978(VarNext,B)
            <=> v124978(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1622,axiom,
    ! [VarNext: state_type] :
      ( v125015(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124978(VarNext,B)
          <=> v125025(VarNext,B) ) ) ) ).

tff(addAssignment_70925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125025(VarNext,B)
          <=> v125023(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125023(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1165,axiom,
    ! [VarCurr: state_type] :
      ( v125026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125023(VarCurr,B)
          <=> v124988(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15729,axiom,
    ! [VarCurr: state_type] :
      ( v125026(VarCurr)
    <=> ( v125027(VarCurr)
        & v125028(VarCurr) ) ) ).

tff(writeUnaryOperator_8731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125028(VarCurr)
    <=> v124984(VarCurr) ) ).

tff(writeUnaryOperator_8730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125027(VarCurr)
    <=> v124980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125015(VarNext)
      <=> v125016(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125016(VarNext)
      <=> ( v125017(VarNext)
          & v125010(VarNext) ) ) ) ).

tff(writeUnaryOperator_8729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v125017(VarNext)
      <=> v125019(VarNext) ) ) ).

tff(addAssignment_70924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v125019(VarNext)
      <=> v125010(VarCurr) ) ) ).

tff(addAssignment_70923,axiom,
    ! [VarCurr: state_type] :
      ( v125010(VarCurr)
    <=> v125012(VarCurr) ) ).

tff(addAssignment_70922,axiom,
    ! [VarCurr: state_type] :
      ( v125012(VarCurr)
    <=> v124806(VarCurr) ) ).

tff(addAssignment_70921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124988(VarCurr,B)
      <=> v124990(VarCurr,B) ) ) ).

tff(addAssignment_70920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124990(VarCurr,B)
      <=> v124992(VarCurr,B) ) ) ).

tff(addAssignment_70919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124992(VarCurr,B)
      <=> v124994(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124996(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124994(VarCurr,B)
          <=> v125001(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1164,axiom,
    ! [VarCurr: state_type] :
      ( v124996(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124994(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124972(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125001(VarCurr,B)
          <=> v125002(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1163,axiom,
    ! [VarCurr: state_type] :
      ( v124972(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v125001(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70918,axiom,
    ! [VarCurr: state_type] :
      ( v125002(VarCurr,0)
    <=> v125006(VarCurr) ) ).

tff(addAssignment_70917,axiom,
    ! [VarCurr: state_type] :
      ( v125002(VarCurr,1)
    <=> v125004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15726,axiom,
    ! [VarCurr: state_type] :
      ( v125004(VarCurr)
    <=> ( v125005(VarCurr)
        & v125007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15725,axiom,
    ! [VarCurr: state_type] :
      ( v125007(VarCurr)
    <=> ( v124974(VarCurr,0)
        | v125008(VarCurr) ) ) ).

tff(writeUnaryOperator_8728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125008(VarCurr)
    <=> v124974(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5521,axiom,
    ! [VarCurr: state_type] :
      ( v125005(VarCurr)
    <=> ( v125006(VarCurr)
        | v124974(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v125006(VarCurr)
    <=> v124974(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15724,axiom,
    ! [VarCurr: state_type] :
      ( v124996(VarCurr)
    <=> ( v124998(VarCurr)
        | v124999(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5520,axiom,
    ! [VarCurr: state_type] :
      ( v124999(VarCurr)
    <=> ( v124326(VarCurr,1)
        & v124839(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5519,axiom,
    ! [VarCurr: state_type] :
      ( v124998(VarCurr)
    <=> ( v124326(VarCurr,3)
        & v124897(VarCurr) ) ) ).

tff(addAssignment_70916,axiom,
    ! [VarCurr: state_type] :
      ( v124984(VarCurr)
    <=> v124986(VarCurr) ) ).

tff(addAssignment_70915,axiom,
    ! [VarCurr: state_type] :
      ( v124986(VarCurr)
    <=> v124344(VarCurr) ) ).

tff(addAssignment_70914,axiom,
    ! [VarCurr: state_type] :
      ( v124980(VarCurr)
    <=> v124982(VarCurr) ) ).

tff(addAssignment_70913,axiom,
    ! [VarCurr: state_type] :
      ( v124982(VarCurr)
    <=> v124336(VarCurr) ) ).

tff(addAssignment_70912,axiom,
    ! [VarCurr: state_type] :
      ( v124326(VarCurr,1)
    <=> v124328(VarCurr,1) ) ).

tff(addAssignment_70911,axiom,
    ! [VarCurr: state_type] :
      ( v124328(VarCurr,1)
    <=> v124330(VarCurr,1) ) ).

tff(addAssignment_70910,axiom,
    ! [VarNext: state_type] :
      ( v124330(VarNext,1)
    <=> v124964(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124965(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124964(VarNext,B)
            <=> v124330(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1621,axiom,
    ! [VarNext: state_type] :
      ( v124965(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124964(VarNext,B)
          <=> v124890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124965(VarNext)
      <=> v124966(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124966(VarNext)
      <=> ( v124968(VarNext)
          & v124875(VarNext) ) ) ) ).

tff(writeUnaryOperator_8726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124968(VarNext)
      <=> v124884(VarNext) ) ) ).

tff(addAssignment_70909,axiom,
    ! [VarCurr: state_type] :
      ( v124348(VarCurr,1)
    <=> v124350(VarCurr,1) ) ).

tff(addAssignment_70908,axiom,
    ! [VarCurr: state_type] :
      ( v124350(VarCurr,1)
    <=> v124352(VarCurr,1) ) ).

tff(addAssignment_70907,axiom,
    ! [VarCurr: state_type] :
      ( v124352(VarCurr,1)
    <=> v124873(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_71,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124955(VarCurr)
     => ( v124354(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_100,axiom,
    ! [VarCurr: state_type] :
      ( v124955(VarCurr)
     => ( v124354(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15721,axiom,
    ! [VarCurr: state_type] :
      ( v124955(VarCurr)
    <=> ( v124956(VarCurr)
        | v124957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15720,axiom,
    ! [VarCurr: state_type] :
      ( v124957(VarCurr)
    <=> ( v124958(VarCurr)
        & v124959(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15719,axiom,
    ! [VarCurr: state_type] :
      ( v124959(VarCurr)
    <=> ( v124960(VarCurr)
        & v124856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15718,axiom,
    ! [VarCurr: state_type] :
      ( v124960(VarCurr)
    <=> ( v124961(VarCurr)
        & v124962(VarCurr) ) ) ).

tff(writeUnaryOperator_8725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124962(VarCurr)
    <=> v124848(VarCurr) ) ).

tff(writeUnaryOperator_8724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124961(VarCurr)
    <=> v124839(VarCurr) ) ).

tff(writeUnaryOperator_8723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124958(VarCurr)
    <=> v124858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15717,axiom,
    ! [VarCurr: state_type] :
      ( v124956(VarCurr)
    <=> ( v124930(VarCurr)
        & v124858(VarCurr) ) ) ).

tff(writeUnaryOperator_8722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124326(VarCurr,0)
    <=> v124835(VarCurr) ) ).

tff(addAssignment_70906,axiom,
    ! [VarCurr: state_type] :
      ( v124835(VarCurr)
    <=> v124328(VarCurr,0) ) ).

tff(addAssignment_70905,axiom,
    ! [VarCurr: state_type] :
      ( v124328(VarCurr,0)
    <=> v124330(VarCurr,0) ) ).

tff(addAssignment_70904,axiom,
    ! [VarNext: state_type] :
      ( v124330(VarNext,0)
    <=> v124946(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124946(VarNext,B)
            <=> v124330(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1620,axiom,
    ! [VarNext: state_type] :
      ( v124947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124946(VarNext,B)
          <=> v124890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124947(VarNext)
      <=> v124948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124948(VarNext)
      <=> ( v124950(VarNext)
          & v124875(VarNext) ) ) ) ).

tff(writeUnaryOperator_8721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124950(VarNext)
      <=> v124884(VarNext) ) ) ).

tff(addAssignment_70903,axiom,
    ! [VarCurr: state_type] :
      ( v124348(VarCurr,0)
    <=> v124350(VarCurr,0) ) ).

tff(addAssignment_70902,axiom,
    ! [VarCurr: state_type] :
      ( v124350(VarCurr,0)
    <=> v124352(VarCurr,0) ) ).

tff(addAssignment_70901,axiom,
    ! [VarCurr: state_type] :
      ( v124352(VarCurr,0)
    <=> v124873(VarCurr,0) ) ).

tff(writeUnaryOperator_8720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124837(VarCurr)
    <=> v124354(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124925(VarCurr)
     => ( v124354(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1162,axiom,
    ! [VarCurr: state_type] :
      ( v124925(VarCurr)
     => ( v124354(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15714,axiom,
    ! [VarCurr: state_type] :
      ( v124925(VarCurr)
    <=> ( v124926(VarCurr)
        | v124939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15713,axiom,
    ! [VarCurr: state_type] :
      ( v124939(VarCurr)
    <=> ( v124940(VarCurr)
        & v124943(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15712,axiom,
    ! [VarCurr: state_type] :
      ( v124943(VarCurr)
    <=> ( v124911(VarCurr)
        & v124914(VarCurr) ) ) ).

tff(writeUnaryOperator_8719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124940(VarCurr)
    <=> v124941(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15711,axiom,
    ! [VarCurr: state_type] :
      ( v124941(VarCurr)
    <=> ( v124942(VarCurr)
        | v124871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15710,axiom,
    ! [VarCurr: state_type] :
      ( v124942(VarCurr)
    <=> ( v124858(VarCurr)
        | v124856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15709,axiom,
    ! [VarCurr: state_type] :
      ( v124926(VarCurr)
    <=> ( v124927(VarCurr)
        | v124935(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15708,axiom,
    ! [VarCurr: state_type] :
      ( v124935(VarCurr)
    <=> ( v124936(VarCurr)
        & v124938(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15707,axiom,
    ! [VarCurr: state_type] :
      ( v124938(VarCurr)
    <=> ( v124869(VarCurr)
        & v124871(VarCurr) ) ) ).

tff(writeUnaryOperator_8718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124936(VarCurr)
    <=> v124937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15706,axiom,
    ! [VarCurr: state_type] :
      ( v124937(VarCurr)
    <=> ( v124858(VarCurr)
        | v124856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15705,axiom,
    ! [VarCurr: state_type] :
      ( v124927(VarCurr)
    <=> ( v124928(VarCurr)
        | v124932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15704,axiom,
    ! [VarCurr: state_type] :
      ( v124932(VarCurr)
    <=> ( v124933(VarCurr)
        & v124934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15703,axiom,
    ! [VarCurr: state_type] :
      ( v124934(VarCurr)
    <=> ( v124848(VarCurr)
        & v124856(VarCurr) ) ) ).

tff(writeUnaryOperator_8717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124933(VarCurr)
    <=> v124858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15702,axiom,
    ! [VarCurr: state_type] :
      ( v124928(VarCurr)
    <=> ( v124929(VarCurr)
        & v124858(VarCurr) ) ) ).

tff(writeUnaryOperator_8716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124929(VarCurr)
    <=> v124930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15701,axiom,
    ! [VarCurr: state_type] :
      ( v124930(VarCurr)
    <=> ( v124931(VarCurr)
        & v124833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15700,axiom,
    ! [VarCurr: state_type] :
      ( v124931(VarCurr)
    <=> ( v124356(VarCurr)
        & v124831(VarCurr) ) ) ).

tff(addAssignment_70900,axiom,
    ! [VarCurr: state_type] :
      ( v124326(VarCurr,3)
    <=> v124328(VarCurr,3) ) ).

tff(addAssignment_70899,axiom,
    ! [VarCurr: state_type] :
      ( v124328(VarCurr,3)
    <=> v124330(VarCurr,3) ) ).

tff(addAssignment_70898,axiom,
    ! [VarNext: state_type] :
      ( v124330(VarNext,3)
    <=> v124917(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124918(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124917(VarNext,B)
            <=> v124330(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1619,axiom,
    ! [VarNext: state_type] :
      ( v124918(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124917(VarNext,B)
          <=> v124890(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124918(VarNext)
      <=> v124919(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124919(VarNext)
      <=> ( v124921(VarNext)
          & v124875(VarNext) ) ) ) ).

tff(writeUnaryOperator_8715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124921(VarNext)
      <=> v124884(VarNext) ) ) ).

tff(addAssignment_70897,axiom,
    ! [VarCurr: state_type] :
      ( v124348(VarCurr,3)
    <=> v124350(VarCurr,3) ) ).

tff(addAssignment_70896,axiom,
    ! [VarCurr: state_type] :
      ( v124350(VarCurr,3)
    <=> v124352(VarCurr,3) ) ).

tff(addAssignment_70895,axiom,
    ! [VarCurr: state_type] :
      ( v124352(VarCurr,3)
    <=> v124873(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_70,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124899(VarCurr)
     => ( v124354(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_99,axiom,
    ! [VarCurr: state_type] :
      ( v124899(VarCurr)
     => ( v124354(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15697,axiom,
    ! [VarCurr: state_type] :
      ( v124899(VarCurr)
    <=> ( v124900(VarCurr)
        | v124906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15696,axiom,
    ! [VarCurr: state_type] :
      ( v124906(VarCurr)
    <=> ( v124907(VarCurr)
        & v124908(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15695,axiom,
    ! [VarCurr: state_type] :
      ( v124908(VarCurr)
    <=> ( v124909(VarCurr)
        & v124915(VarCurr) ) ) ).

tff(writeUnaryOperator_8714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124915(VarCurr)
    <=> v124905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15694,axiom,
    ! [VarCurr: state_type] :
      ( v124909(VarCurr)
    <=> ( v124910(VarCurr)
        & v124914(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1233,axiom,
    ! [VarCurr: state_type] :
      ( v124914(VarCurr)
    <=> ( $true
      <=> v124326(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124910(VarCurr)
    <=> v124911(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15693,axiom,
    ! [VarCurr: state_type] :
      ( v124911(VarCurr)
    <=> ( v124912(VarCurr)
        | v124841(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15692,axiom,
    ! [VarCurr: state_type] :
      ( v124912(VarCurr)
    <=> ( v124913(VarCurr)
        | v124897(VarCurr) ) ) ).

tff(writeUnaryOperator_8712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124913(VarCurr)
    <=> v124831(VarCurr) ) ).

tff(writeUnaryOperator_8711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124907(VarCurr)
    <=> v124871(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15691,axiom,
    ! [VarCurr: state_type] :
      ( v124900(VarCurr)
    <=> ( v124901(VarCurr)
        & v124904(VarCurr) ) ) ).

tff(writeUnaryOperator_8710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124904(VarCurr)
    <=> v124905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15690,axiom,
    ! [VarCurr: state_type] :
      ( v124905(VarCurr)
    <=> ( v124858(VarCurr)
        | v124856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15689,axiom,
    ! [VarCurr: state_type] :
      ( v124901(VarCurr)
    <=> ( v124902(VarCurr)
        & v124871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15688,axiom,
    ! [VarCurr: state_type] :
      ( v124902(VarCurr)
    <=> ( v124865(VarCurr)
        & v124903(VarCurr) ) ) ).

tff(writeUnaryOperator_8709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124903(VarCurr)
    <=> v124869(VarCurr) ) ).

tff(addAssignment_70894,axiom,
    ! [VarCurr: state_type] :
      ( v124897(VarCurr)
    <=> v112831(VarCurr,13) ) ).

tff(addAssignment_70893,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,13)
    <=> v112865(VarCurr,13) ) ).

tff(addAssignment_70892,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,13)
    <=> v112849(VarCurr,13) ) ).

tff(addAssignment_70891,axiom,
    ! [VarCurr: state_type] :
      ( v124326(VarCurr,2)
    <=> v124328(VarCurr,2) ) ).

tff(addAssignment_70890,axiom,
    ! [VarCurr: state_type] :
      ( v124328(VarCurr,2)
    <=> v124330(VarCurr,2) ) ).

tff(addAssignment_70889,axiom,
    ! [VarNext: state_type] :
      ( v124330(VarNext,2)
    <=> v124879(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124880(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124879(VarNext,B)
            <=> v124330(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1618,axiom,
    ! [VarNext: state_type] :
      ( v124880(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124879(VarNext,B)
          <=> v124890(VarNext,B) ) ) ) ).

tff(addAssignment_70888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124890(VarNext,B)
          <=> v124888(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124891(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124888(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1161,axiom,
    ! [VarCurr: state_type] :
      ( v124891(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124888(VarCurr,B)
          <=> v124348(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15687,axiom,
    ! [VarCurr: state_type] :
      ( v124891(VarCurr)
    <=> ( v124892(VarCurr)
        & v124893(VarCurr) ) ) ).

tff(writeUnaryOperator_8708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124893(VarCurr)
    <=> v124340(VarCurr) ) ).

tff(writeUnaryOperator_8707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124892(VarCurr)
    <=> v124332(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124880(VarNext)
      <=> v124881(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124881(VarNext)
      <=> ( v124882(VarNext)
          & v124875(VarNext) ) ) ) ).

tff(writeUnaryOperator_8706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124882(VarNext)
      <=> v124884(VarNext) ) ) ).

tff(addAssignment_70887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124884(VarNext)
      <=> v124875(VarCurr) ) ) ).

tff(addAssignment_70886,axiom,
    ! [VarCurr: state_type] :
      ( v124875(VarCurr)
    <=> v124877(VarCurr) ) ).

tff(addAssignment_70885,axiom,
    ! [VarCurr: state_type] :
      ( v124877(VarCurr)
    <=> v124806(VarCurr) ) ).

tff(addAssignment_70884,axiom,
    ! [VarCurr: state_type] :
      ( v124348(VarCurr,2)
    <=> v124350(VarCurr,2) ) ).

tff(addAssignment_70883,axiom,
    ! [VarCurr: state_type] :
      ( v124350(VarCurr,2)
    <=> v124352(VarCurr,2) ) ).

tff(addAssignment_70882,axiom,
    ! [VarCurr: state_type] :
      ( v124352(VarCurr,2)
    <=> v124873(VarCurr,2) ) ).

tff(addAssignment_70881,axiom,
    ! [VarCurr: state_type] :
      ( v124873(VarCurr,0)
    <=> v124837(VarCurr) ) ).

tff(addAssignment_70880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v124873(VarCurr,B)
      <=> v124354(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_69,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124843(VarCurr)
     => ( v124354(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_98,axiom,
    ! [VarCurr: state_type] :
      ( v124843(VarCurr)
     => ( v124354(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15684,axiom,
    ! [VarCurr: state_type] :
      ( v124843(VarCurr)
    <=> ( v124844(VarCurr)
        | v124859(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15683,axiom,
    ! [VarCurr: state_type] :
      ( v124859(VarCurr)
    <=> ( v124860(VarCurr)
        & v124861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15682,axiom,
    ! [VarCurr: state_type] :
      ( v124861(VarCurr)
    <=> ( v124862(VarCurr)
        & v124872(VarCurr) ) ) ).

tff(writeUnaryOperator_8705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124872(VarCurr)
    <=> v124858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15681,axiom,
    ! [VarCurr: state_type] :
      ( v124862(VarCurr)
    <=> ( v124863(VarCurr)
        & v124871(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1232,axiom,
    ! [VarCurr: state_type] :
      ( v124871(VarCurr)
    <=> ( $true
      <=> v124326(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15680,axiom,
    ! [VarCurr: state_type] :
      ( v124863(VarCurr)
    <=> ( v124864(VarCurr)
        & v124868(VarCurr) ) ) ).

tff(writeUnaryOperator_8704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124868(VarCurr)
    <=> v124869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15679,axiom,
    ! [VarCurr: state_type] :
      ( v124869(VarCurr)
    <=> ( v124870(VarCurr)
        | v124841(VarCurr) ) ) ).

tff(writeUnaryOperator_8703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124870(VarCurr)
    <=> v124831(VarCurr) ) ).

tff(writeUnaryOperator_8702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124864(VarCurr)
    <=> v124865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15678,axiom,
    ! [VarCurr: state_type] :
      ( v124865(VarCurr)
    <=> ( v124866(VarCurr)
        | v124867(VarCurr) ) ) ).

tff(writeUnaryOperator_8701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124867(VarCurr)
    <=> v124833(VarCurr) ) ).

tff(writeUnaryOperator_8700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124866(VarCurr)
    <=> v124356(VarCurr) ) ).

tff(writeUnaryOperator_8699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124860(VarCurr)
    <=> v124856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15677,axiom,
    ! [VarCurr: state_type] :
      ( v124844(VarCurr)
    <=> ( v124845(VarCurr)
        & v124857(VarCurr) ) ) ).

tff(writeUnaryOperator_8698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124857(VarCurr)
    <=> v124858(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1231,axiom,
    ! [VarCurr: state_type] :
      ( v124858(VarCurr)
    <=> ( $true
      <=> v124326(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15676,axiom,
    ! [VarCurr: state_type] :
      ( v124845(VarCurr)
    <=> ( v124846(VarCurr)
        & v124856(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1230,axiom,
    ! [VarCurr: state_type] :
      ( v124856(VarCurr)
    <=> ( $true
      <=> v124326(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15675,axiom,
    ! [VarCurr: state_type] :
      ( v124846(VarCurr)
    <=> ( v124839(VarCurr)
        & v124847(VarCurr) ) ) ).

tff(writeUnaryOperator_8697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124847(VarCurr)
    <=> v124848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15674,axiom,
    ! [VarCurr: state_type] :
      ( v124848(VarCurr)
    <=> ( v124849(VarCurr)
        | v124841(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15673,axiom,
    ! [VarCurr: state_type] :
      ( v124849(VarCurr)
    <=> ( v124850(VarCurr)
        | v124853(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15672,axiom,
    ! [VarCurr: state_type] :
      ( v124853(VarCurr)
    <=> ( v124854(VarCurr)
        & v124855(VarCurr) ) ) ).

tff(writeUnaryOperator_8696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124855(VarCurr)
    <=> v124839(VarCurr) ) ).

tff(writeUnaryOperator_8695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124854(VarCurr)
    <=> v124356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15671,axiom,
    ! [VarCurr: state_type] :
      ( v124850(VarCurr)
    <=> ( v124851(VarCurr)
        | v124852(VarCurr) ) ) ).

tff(writeUnaryOperator_8694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124852(VarCurr)
    <=> v124833(VarCurr) ) ).

tff(writeUnaryOperator_8693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124851(VarCurr)
    <=> v124831(VarCurr) ) ).

tff(addAssignment_70879,axiom,
    ! [VarCurr: state_type] :
      ( v124841(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_70878,axiom,
    ! [VarCurr: state_type] :
      ( v124839(VarCurr)
    <=> v112643(VarCurr,13) ) ).

tff(addAssignment_70877,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,13)
    <=> v115202(VarCurr,13) ) ).

tff(addAssignment_70876,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,13)
    <=> v115186(VarCurr,13) ) ).

tff(addAssignment_70875,axiom,
    ! [VarCurr: state_type] :
      ( v124833(VarCurr)
    <=> v112528(VarCurr,13) ) ).

tff(addAssignment_70874,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,13)
    <=> v120828(VarCurr,5) ) ).

tff(addAssignment_70873,axiom,
    ! [VarCurr: state_type] :
      ( v124831(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15670,axiom,
    ! [VarCurr: state_type] :
      ( v124356(VarCurr)
    <=> ( v124828(VarCurr)
        & v124829(VarCurr) ) ) ).

tff(writeUnaryOperator_8692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124829(VarCurr)
    <=> v124826(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1229,axiom,
    ! [VarCurr: state_type] :
      ( v124828(VarCurr)
    <=> ( ( v124358(VarCurr,5)
        <=> $false )
        & ( v124358(VarCurr,4)
        <=> $false )
        & ( v124358(VarCurr,3)
        <=> $false )
        & ( v124358(VarCurr,2)
        <=> $false )
        & ( v124358(VarCurr,1)
        <=> $false )
        & ( v124358(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70872,axiom,
    ! [VarCurr: state_type] :
      ( v124826(VarCurr)
    <=> v115139(VarCurr,13) ) ).

tff(addAssignment_70871,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,13)
    <=> v115159(VarCurr,13) ) ).

tff(addAssignment_70870,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,13)
    <=> v115142(VarCurr,13) ) ).

tff(addAssignment_70869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v124358(VarCurr,B)
      <=> v124360(VarCurr,B) ) ) ).

tff(addAssignment_70868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v124360(VarCurr,B)
      <=> v124362(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124809(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v124362(VarNext,B)
            <=> v124362(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1617,axiom,
    ! [VarNext: state_type] :
      ( v124809(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124362(VarNext,B)
          <=> v124819(VarNext,B) ) ) ) ).

tff(addAssignment_70867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124819(VarNext,B)
          <=> v124817(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124820(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124817(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1160,axiom,
    ! [VarCurr: state_type] :
      ( v124820(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124817(VarCurr,B)
          <=> v124372(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15669,axiom,
    ! [VarCurr: state_type] :
      ( v124820(VarCurr)
    <=> ( v124821(VarCurr)
        & v124822(VarCurr) ) ) ).

tff(writeUnaryOperator_8691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124822(VarCurr)
    <=> v124368(VarCurr) ) ).

tff(writeUnaryOperator_8690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124821(VarCurr)
    <=> v124364(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124809(VarNext)
      <=> v124810(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124810(VarNext)
      <=> ( v124811(VarNext)
          & v124802(VarNext) ) ) ) ).

tff(writeUnaryOperator_8689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124811(VarNext)
      <=> v124813(VarNext) ) ) ).

tff(addAssignment_70866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124813(VarNext)
      <=> v124802(VarCurr) ) ) ).

tff(addAssignment_70865,axiom,
    ! [VarCurr: state_type] :
      ( v124802(VarCurr)
    <=> v124804(VarCurr) ) ).

tff(addAssignment_70864,axiom,
    ! [VarCurr: state_type] :
      ( v124804(VarCurr)
    <=> v124806(VarCurr) ) ).

tff(addAssignment_70863,axiom,
    ! [VarCurr: state_type] :
      ( v124806(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_70862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v124372(VarCurr,B)
      <=> v124374(VarCurr,B) ) ) ).

tff(addAssignment_70861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v124374(VarCurr,B)
      <=> v124376(VarCurr,B) ) ) ).

tff(addAssignment_70860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v124376(VarCurr,B)
      <=> v124378(VarCurr,B) ) ) ).

tff(addAssignment_70859,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,0)
    <=> v124797(VarCurr) ) ).

tff(addAssignment_70858,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,1)
    <=> v124792(VarCurr) ) ).

tff(addAssignment_70857,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,2)
    <=> v124787(VarCurr) ) ).

tff(addAssignment_70856,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,3)
    <=> v124782(VarCurr) ) ).

tff(addAssignment_70855,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,4)
    <=> v124777(VarCurr) ) ).

tff(addAssignment_70854,axiom,
    ! [VarCurr: state_type] :
      ( v124378(VarCurr,5)
    <=> v124634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15666,axiom,
    ! [VarCurr: state_type] :
      ( v124797(VarCurr)
    <=> ( v124798(VarCurr)
        & v124800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15665,axiom,
    ! [VarCurr: state_type] :
      ( v124800(VarCurr)
    <=> ( v124589(VarCurr,0)
        | v124646(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15664,axiom,
    ! [VarCurr: state_type] :
      ( v124798(VarCurr)
    <=> ( v124723(VarCurr)
        | v124799(VarCurr) ) ) ).

tff(writeUnaryOperator_8688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124799(VarCurr)
    <=> v124646(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15663,axiom,
    ! [VarCurr: state_type] :
      ( v124792(VarCurr)
    <=> ( v124793(VarCurr)
        & v124796(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15662,axiom,
    ! [VarCurr: state_type] :
      ( v124796(VarCurr)
    <=> ( v124645(VarCurr)
        | v124717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15661,axiom,
    ! [VarCurr: state_type] :
      ( v124793(VarCurr)
    <=> ( v124794(VarCurr)
        | v124795(VarCurr) ) ) ).

tff(writeUnaryOperator_8687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124795(VarCurr)
    <=> v124717(VarCurr) ) ).

tff(writeUnaryOperator_8686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124794(VarCurr)
    <=> v124645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15660,axiom,
    ! [VarCurr: state_type] :
      ( v124787(VarCurr)
    <=> ( v124788(VarCurr)
        & v124791(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15659,axiom,
    ! [VarCurr: state_type] :
      ( v124791(VarCurr)
    <=> ( v124643(VarCurr)
        | v124728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15658,axiom,
    ! [VarCurr: state_type] :
      ( v124788(VarCurr)
    <=> ( v124789(VarCurr)
        | v124790(VarCurr) ) ) ).

tff(writeUnaryOperator_8685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124790(VarCurr)
    <=> v124728(VarCurr) ) ).

tff(writeUnaryOperator_8684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124789(VarCurr)
    <=> v124643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15657,axiom,
    ! [VarCurr: state_type] :
      ( v124782(VarCurr)
    <=> ( v124783(VarCurr)
        & v124786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15656,axiom,
    ! [VarCurr: state_type] :
      ( v124786(VarCurr)
    <=> ( v124641(VarCurr)
        | v124740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15655,axiom,
    ! [VarCurr: state_type] :
      ( v124783(VarCurr)
    <=> ( v124784(VarCurr)
        | v124785(VarCurr) ) ) ).

tff(writeUnaryOperator_8683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124785(VarCurr)
    <=> v124740(VarCurr) ) ).

tff(writeUnaryOperator_8682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124784(VarCurr)
    <=> v124641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15654,axiom,
    ! [VarCurr: state_type] :
      ( v124777(VarCurr)
    <=> ( v124778(VarCurr)
        & v124781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15653,axiom,
    ! [VarCurr: state_type] :
      ( v124781(VarCurr)
    <=> ( v124639(VarCurr)
        | v124752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15652,axiom,
    ! [VarCurr: state_type] :
      ( v124778(VarCurr)
    <=> ( v124779(VarCurr)
        | v124780(VarCurr) ) ) ).

tff(writeUnaryOperator_8681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124780(VarCurr)
    <=> v124752(VarCurr) ) ).

tff(writeUnaryOperator_8680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124779(VarCurr)
    <=> v124639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15651,axiom,
    ! [VarCurr: state_type] :
      ( v124634(VarCurr)
    <=> ( v124635(VarCurr)
        & v124776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15650,axiom,
    ! [VarCurr: state_type] :
      ( v124776(VarCurr)
    <=> ( v124637(VarCurr)
        | v124765(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15649,axiom,
    ! [VarCurr: state_type] :
      ( v124635(VarCurr)
    <=> ( v124636(VarCurr)
        | v124764(VarCurr) ) ) ).

tff(writeUnaryOperator_8679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124764(VarCurr)
    <=> v124765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15648,axiom,
    ! [VarCurr: state_type] :
      ( v124765(VarCurr)
    <=> ( v124766(VarCurr)
        & v124775(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5518,axiom,
    ! [VarCurr: state_type] :
      ( v124775(VarCurr)
    <=> ( v124768(VarCurr)
        | v124646(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15647,axiom,
    ! [VarCurr: state_type] :
      ( v124766(VarCurr)
    <=> ( v124767(VarCurr)
        | v124774(VarCurr) ) ) ).

tff(writeUnaryOperator_8678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124774(VarCurr)
    <=> v124646(VarCurr,5) ) ).

tff(writeUnaryOperator_8677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124767(VarCurr)
    <=> v124768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15646,axiom,
    ! [VarCurr: state_type] :
      ( v124768(VarCurr)
    <=> ( v124769(VarCurr)
        & v124772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15645,axiom,
    ! [VarCurr: state_type] :
      ( v124772(VarCurr)
    <=> ( v124771(VarCurr)
        | v124773(VarCurr) ) ) ).

tff(writeUnaryOperator_8676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124773(VarCurr)
    <=> v124589(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5517,axiom,
    ! [VarCurr: state_type] :
      ( v124769(VarCurr)
    <=> ( v124770(VarCurr)
        | v124589(VarCurr,5) ) ) ).

tff(writeUnaryOperator_8675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124770(VarCurr)
    <=> v124771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15644,axiom,
    ! [VarCurr: state_type] :
      ( v124771(VarCurr)
    <=> ( v124758(VarCurr)
        & v124760(VarCurr) ) ) ).

tff(writeUnaryOperator_8674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124636(VarCurr)
    <=> v124637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15643,axiom,
    ! [VarCurr: state_type] :
      ( v124637(VarCurr)
    <=> ( v124638(VarCurr)
        | v124763(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5516,axiom,
    ! [VarCurr: state_type] :
      ( v124763(VarCurr)
    <=> ( v124755(VarCurr)
        & v124646(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15642,axiom,
    ! [VarCurr: state_type] :
      ( v124638(VarCurr)
    <=> ( v124639(VarCurr)
        & v124752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15641,axiom,
    ! [VarCurr: state_type] :
      ( v124752(VarCurr)
    <=> ( v124753(VarCurr)
        & v124762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5515,axiom,
    ! [VarCurr: state_type] :
      ( v124762(VarCurr)
    <=> ( v124755(VarCurr)
        | v124646(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15640,axiom,
    ! [VarCurr: state_type] :
      ( v124753(VarCurr)
    <=> ( v124754(VarCurr)
        | v124761(VarCurr) ) ) ).

tff(writeUnaryOperator_8673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124761(VarCurr)
    <=> v124646(VarCurr,4) ) ).

tff(writeUnaryOperator_8672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124754(VarCurr)
    <=> v124755(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15639,axiom,
    ! [VarCurr: state_type] :
      ( v124755(VarCurr)
    <=> ( v124756(VarCurr)
        & v124759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15638,axiom,
    ! [VarCurr: state_type] :
      ( v124759(VarCurr)
    <=> ( v124758(VarCurr)
        | v124760(VarCurr) ) ) ).

tff(writeUnaryOperator_8671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124760(VarCurr)
    <=> v124589(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5514,axiom,
    ! [VarCurr: state_type] :
      ( v124756(VarCurr)
    <=> ( v124757(VarCurr)
        | v124589(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124757(VarCurr)
    <=> v124758(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15637,axiom,
    ! [VarCurr: state_type] :
      ( v124758(VarCurr)
    <=> ( v124746(VarCurr)
        & v124748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15636,axiom,
    ! [VarCurr: state_type] :
      ( v124639(VarCurr)
    <=> ( v124640(VarCurr)
        | v124751(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5513,axiom,
    ! [VarCurr: state_type] :
      ( v124751(VarCurr)
    <=> ( v124743(VarCurr)
        & v124646(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15635,axiom,
    ! [VarCurr: state_type] :
      ( v124640(VarCurr)
    <=> ( v124641(VarCurr)
        & v124740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15634,axiom,
    ! [VarCurr: state_type] :
      ( v124740(VarCurr)
    <=> ( v124741(VarCurr)
        & v124750(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5512,axiom,
    ! [VarCurr: state_type] :
      ( v124750(VarCurr)
    <=> ( v124743(VarCurr)
        | v124646(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15633,axiom,
    ! [VarCurr: state_type] :
      ( v124741(VarCurr)
    <=> ( v124742(VarCurr)
        | v124749(VarCurr) ) ) ).

tff(writeUnaryOperator_8669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124749(VarCurr)
    <=> v124646(VarCurr,3) ) ).

tff(writeUnaryOperator_8668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124742(VarCurr)
    <=> v124743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15632,axiom,
    ! [VarCurr: state_type] :
      ( v124743(VarCurr)
    <=> ( v124744(VarCurr)
        & v124747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15631,axiom,
    ! [VarCurr: state_type] :
      ( v124747(VarCurr)
    <=> ( v124746(VarCurr)
        | v124748(VarCurr) ) ) ).

tff(writeUnaryOperator_8667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124748(VarCurr)
    <=> v124589(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5511,axiom,
    ! [VarCurr: state_type] :
      ( v124744(VarCurr)
    <=> ( v124745(VarCurr)
        | v124589(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124745(VarCurr)
    <=> v124746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15630,axiom,
    ! [VarCurr: state_type] :
      ( v124746(VarCurr)
    <=> ( v124734(VarCurr)
        & v124736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15629,axiom,
    ! [VarCurr: state_type] :
      ( v124641(VarCurr)
    <=> ( v124642(VarCurr)
        | v124739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5510,axiom,
    ! [VarCurr: state_type] :
      ( v124739(VarCurr)
    <=> ( v124731(VarCurr)
        & v124646(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15628,axiom,
    ! [VarCurr: state_type] :
      ( v124642(VarCurr)
    <=> ( v124643(VarCurr)
        & v124728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15627,axiom,
    ! [VarCurr: state_type] :
      ( v124728(VarCurr)
    <=> ( v124729(VarCurr)
        & v124738(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5509,axiom,
    ! [VarCurr: state_type] :
      ( v124738(VarCurr)
    <=> ( v124731(VarCurr)
        | v124646(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15626,axiom,
    ! [VarCurr: state_type] :
      ( v124729(VarCurr)
    <=> ( v124730(VarCurr)
        | v124737(VarCurr) ) ) ).

tff(writeUnaryOperator_8665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124737(VarCurr)
    <=> v124646(VarCurr,2) ) ).

tff(writeUnaryOperator_8664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124730(VarCurr)
    <=> v124731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15625,axiom,
    ! [VarCurr: state_type] :
      ( v124731(VarCurr)
    <=> ( v124732(VarCurr)
        & v124735(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15624,axiom,
    ! [VarCurr: state_type] :
      ( v124735(VarCurr)
    <=> ( v124734(VarCurr)
        | v124736(VarCurr) ) ) ).

tff(writeUnaryOperator_8663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124736(VarCurr)
    <=> v124589(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5508,axiom,
    ! [VarCurr: state_type] :
      ( v124732(VarCurr)
    <=> ( v124733(VarCurr)
        | v124589(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124733(VarCurr)
    <=> v124734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15623,axiom,
    ! [VarCurr: state_type] :
      ( v124734(VarCurr)
    <=> ( v124723(VarCurr)
        & v124724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15622,axiom,
    ! [VarCurr: state_type] :
      ( v124643(VarCurr)
    <=> ( v124644(VarCurr)
        | v124727(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5507,axiom,
    ! [VarCurr: state_type] :
      ( v124727(VarCurr)
    <=> ( v124720(VarCurr)
        & v124646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15621,axiom,
    ! [VarCurr: state_type] :
      ( v124644(VarCurr)
    <=> ( v124645(VarCurr)
        & v124717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15620,axiom,
    ! [VarCurr: state_type] :
      ( v124717(VarCurr)
    <=> ( v124718(VarCurr)
        & v124726(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5506,axiom,
    ! [VarCurr: state_type] :
      ( v124726(VarCurr)
    <=> ( v124720(VarCurr)
        | v124646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15619,axiom,
    ! [VarCurr: state_type] :
      ( v124718(VarCurr)
    <=> ( v124719(VarCurr)
        | v124725(VarCurr) ) ) ).

tff(writeUnaryOperator_8661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124725(VarCurr)
    <=> v124646(VarCurr,1) ) ).

tff(writeUnaryOperator_8660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124719(VarCurr)
    <=> v124720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15618,axiom,
    ! [VarCurr: state_type] :
      ( v124720(VarCurr)
    <=> ( v124721(VarCurr)
        & v124722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15617,axiom,
    ! [VarCurr: state_type] :
      ( v124722(VarCurr)
    <=> ( v124723(VarCurr)
        | v124724(VarCurr) ) ) ).

tff(writeUnaryOperator_8659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124724(VarCurr)
    <=> v124589(VarCurr,1) ) ).

tff(writeUnaryOperator_8658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124723(VarCurr)
    <=> v124589(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5505,axiom,
    ! [VarCurr: state_type] :
      ( v124721(VarCurr)
    <=> ( v124589(VarCurr,0)
        | v124589(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15616,axiom,
    ! [VarCurr: state_type] :
      ( v124645(VarCurr)
    <=> ( v124589(VarCurr,0)
        & v124646(VarCurr,0) ) ) ).

tff(addAssignment_70853,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,0)
    <=> v124712(VarCurr) ) ).

tff(addAssignment_70852,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,1)
    <=> v124707(VarCurr) ) ).

tff(addAssignment_70851,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,2)
    <=> v124702(VarCurr) ) ).

tff(addAssignment_70850,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,3)
    <=> v124697(VarCurr) ) ).

tff(addAssignment_70849,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,4)
    <=> v124692(VarCurr) ) ).

tff(addAssignment_70848,axiom,
    ! [VarCurr: state_type] :
      ( v124646(VarCurr,5)
    <=> v124648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15615,axiom,
    ! [VarCurr: state_type] :
      ( v124712(VarCurr)
    <=> ( v124713(VarCurr)
        & v124716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15614,axiom,
    ! [VarCurr: state_type] :
      ( v124716(VarCurr)
    <=> ( v124358(VarCurr,0)
        | v124660(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15613,axiom,
    ! [VarCurr: state_type] :
      ( v124713(VarCurr)
    <=> ( v124714(VarCurr)
        | v124715(VarCurr) ) ) ).

tff(writeUnaryOperator_8657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124715(VarCurr)
    <=> v124660(VarCurr,0) ) ).

tff(writeUnaryOperator_8656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124714(VarCurr)
    <=> v124358(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15612,axiom,
    ! [VarCurr: state_type] :
      ( v124707(VarCurr)
    <=> ( v124708(VarCurr)
        & v124711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15611,axiom,
    ! [VarCurr: state_type] :
      ( v124711(VarCurr)
    <=> ( v124659(VarCurr)
        | v124661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15610,axiom,
    ! [VarCurr: state_type] :
      ( v124708(VarCurr)
    <=> ( v124709(VarCurr)
        | v124710(VarCurr) ) ) ).

tff(writeUnaryOperator_8655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124710(VarCurr)
    <=> v124661(VarCurr) ) ).

tff(writeUnaryOperator_8654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124709(VarCurr)
    <=> v124659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15609,axiom,
    ! [VarCurr: state_type] :
      ( v124702(VarCurr)
    <=> ( v124703(VarCurr)
        & v124706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15608,axiom,
    ! [VarCurr: state_type] :
      ( v124706(VarCurr)
    <=> ( v124657(VarCurr)
        | v124667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15607,axiom,
    ! [VarCurr: state_type] :
      ( v124703(VarCurr)
    <=> ( v124704(VarCurr)
        | v124705(VarCurr) ) ) ).

tff(writeUnaryOperator_8653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124705(VarCurr)
    <=> v124667(VarCurr) ) ).

tff(writeUnaryOperator_8652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124704(VarCurr)
    <=> v124657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15606,axiom,
    ! [VarCurr: state_type] :
      ( v124697(VarCurr)
    <=> ( v124698(VarCurr)
        & v124701(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15605,axiom,
    ! [VarCurr: state_type] :
      ( v124701(VarCurr)
    <=> ( v124655(VarCurr)
        | v124673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15604,axiom,
    ! [VarCurr: state_type] :
      ( v124698(VarCurr)
    <=> ( v124699(VarCurr)
        | v124700(VarCurr) ) ) ).

tff(writeUnaryOperator_8651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124700(VarCurr)
    <=> v124673(VarCurr) ) ).

tff(writeUnaryOperator_8650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124699(VarCurr)
    <=> v124655(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15603,axiom,
    ! [VarCurr: state_type] :
      ( v124692(VarCurr)
    <=> ( v124693(VarCurr)
        & v124696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15602,axiom,
    ! [VarCurr: state_type] :
      ( v124696(VarCurr)
    <=> ( v124653(VarCurr)
        | v124679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15601,axiom,
    ! [VarCurr: state_type] :
      ( v124693(VarCurr)
    <=> ( v124694(VarCurr)
        | v124695(VarCurr) ) ) ).

tff(writeUnaryOperator_8649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124695(VarCurr)
    <=> v124679(VarCurr) ) ).

tff(writeUnaryOperator_8648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124694(VarCurr)
    <=> v124653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15600,axiom,
    ! [VarCurr: state_type] :
      ( v124648(VarCurr)
    <=> ( v124649(VarCurr)
        & v124691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15599,axiom,
    ! [VarCurr: state_type] :
      ( v124691(VarCurr)
    <=> ( v124651(VarCurr)
        | v124686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15598,axiom,
    ! [VarCurr: state_type] :
      ( v124649(VarCurr)
    <=> ( v124650(VarCurr)
        | v124685(VarCurr) ) ) ).

tff(writeUnaryOperator_8647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124685(VarCurr)
    <=> v124686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15597,axiom,
    ! [VarCurr: state_type] :
      ( v124686(VarCurr)
    <=> ( v124687(VarCurr)
        & v124690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5504,axiom,
    ! [VarCurr: state_type] :
      ( v124690(VarCurr)
    <=> ( v124358(VarCurr,5)
        | v124660(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15596,axiom,
    ! [VarCurr: state_type] :
      ( v124687(VarCurr)
    <=> ( v124688(VarCurr)
        | v124689(VarCurr) ) ) ).

tff(writeUnaryOperator_8646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124689(VarCurr)
    <=> v124660(VarCurr,5) ) ).

tff(writeUnaryOperator_8645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124688(VarCurr)
    <=> v124358(VarCurr,5) ) ).

tff(writeUnaryOperator_8644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124650(VarCurr)
    <=> v124651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15595,axiom,
    ! [VarCurr: state_type] :
      ( v124651(VarCurr)
    <=> ( v124652(VarCurr)
        | v124684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5503,axiom,
    ! [VarCurr: state_type] :
      ( v124684(VarCurr)
    <=> ( v124358(VarCurr,4)
        & v124660(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15594,axiom,
    ! [VarCurr: state_type] :
      ( v124652(VarCurr)
    <=> ( v124653(VarCurr)
        & v124679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15593,axiom,
    ! [VarCurr: state_type] :
      ( v124679(VarCurr)
    <=> ( v124680(VarCurr)
        & v124683(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5502,axiom,
    ! [VarCurr: state_type] :
      ( v124683(VarCurr)
    <=> ( v124358(VarCurr,4)
        | v124660(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15592,axiom,
    ! [VarCurr: state_type] :
      ( v124680(VarCurr)
    <=> ( v124681(VarCurr)
        | v124682(VarCurr) ) ) ).

tff(writeUnaryOperator_8643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124682(VarCurr)
    <=> v124660(VarCurr,4) ) ).

tff(writeUnaryOperator_8642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124681(VarCurr)
    <=> v124358(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15591,axiom,
    ! [VarCurr: state_type] :
      ( v124653(VarCurr)
    <=> ( v124654(VarCurr)
        | v124678(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5501,axiom,
    ! [VarCurr: state_type] :
      ( v124678(VarCurr)
    <=> ( v124358(VarCurr,3)
        & v124660(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15590,axiom,
    ! [VarCurr: state_type] :
      ( v124654(VarCurr)
    <=> ( v124655(VarCurr)
        & v124673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15589,axiom,
    ! [VarCurr: state_type] :
      ( v124673(VarCurr)
    <=> ( v124674(VarCurr)
        & v124677(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5500,axiom,
    ! [VarCurr: state_type] :
      ( v124677(VarCurr)
    <=> ( v124358(VarCurr,3)
        | v124660(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15588,axiom,
    ! [VarCurr: state_type] :
      ( v124674(VarCurr)
    <=> ( v124675(VarCurr)
        | v124676(VarCurr) ) ) ).

tff(writeUnaryOperator_8641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124676(VarCurr)
    <=> v124660(VarCurr,3) ) ).

tff(writeUnaryOperator_8640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124675(VarCurr)
    <=> v124358(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15587,axiom,
    ! [VarCurr: state_type] :
      ( v124655(VarCurr)
    <=> ( v124656(VarCurr)
        | v124672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5499,axiom,
    ! [VarCurr: state_type] :
      ( v124672(VarCurr)
    <=> ( v124358(VarCurr,2)
        & v124660(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15586,axiom,
    ! [VarCurr: state_type] :
      ( v124656(VarCurr)
    <=> ( v124657(VarCurr)
        & v124667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15585,axiom,
    ! [VarCurr: state_type] :
      ( v124667(VarCurr)
    <=> ( v124668(VarCurr)
        & v124671(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5498,axiom,
    ! [VarCurr: state_type] :
      ( v124671(VarCurr)
    <=> ( v124358(VarCurr,2)
        | v124660(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15584,axiom,
    ! [VarCurr: state_type] :
      ( v124668(VarCurr)
    <=> ( v124669(VarCurr)
        | v124670(VarCurr) ) ) ).

tff(writeUnaryOperator_8639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124670(VarCurr)
    <=> v124660(VarCurr,2) ) ).

tff(writeUnaryOperator_8638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124669(VarCurr)
    <=> v124358(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15583,axiom,
    ! [VarCurr: state_type] :
      ( v124657(VarCurr)
    <=> ( v124658(VarCurr)
        | v124666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5497,axiom,
    ! [VarCurr: state_type] :
      ( v124666(VarCurr)
    <=> ( v124358(VarCurr,1)
        & v124660(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15582,axiom,
    ! [VarCurr: state_type] :
      ( v124658(VarCurr)
    <=> ( v124659(VarCurr)
        & v124661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15581,axiom,
    ! [VarCurr: state_type] :
      ( v124661(VarCurr)
    <=> ( v124662(VarCurr)
        & v124665(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5496,axiom,
    ! [VarCurr: state_type] :
      ( v124665(VarCurr)
    <=> ( v124358(VarCurr,1)
        | v124660(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15580,axiom,
    ! [VarCurr: state_type] :
      ( v124662(VarCurr)
    <=> ( v124663(VarCurr)
        | v124664(VarCurr) ) ) ).

tff(writeUnaryOperator_8637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124664(VarCurr)
    <=> v124660(VarCurr,1) ) ).

tff(writeUnaryOperator_8636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124663(VarCurr)
    <=> v124358(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15579,axiom,
    ! [VarCurr: state_type] :
      ( v124659(VarCurr)
    <=> ( v124358(VarCurr,0)
        & v124660(VarCurr,0) ) ) ).

tff(addAssignment_70847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v124660(VarCurr,B)
      <=> v124380(VarCurr,B) ) ) ).

tff(addAssignment_70846,axiom,
    ! [VarCurr: state_type] :
      ( ( v124660(VarCurr,5)
      <=> $false )
      & ( v124660(VarCurr,4)
      <=> $false )
      & ( v124660(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_70845,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,5)
    <=> v124626(VarCurr,5) ) ).

tff(addAssignment_70844,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,4)
    <=> v124626(VarCurr,4) ) ).

tff(addAssignment_70843,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,3)
    <=> v124626(VarCurr,3) ) ).

tff(addAssignment_70842,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,2)
    <=> v124626(VarCurr,2) ) ).

tff(addAssignment_70841,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,1)
    <=> v124626(VarCurr,1) ) ).

tff(addAssignment_70840,axiom,
    ! [VarCurr: state_type] :
      ( v124589(VarCurr,0)
    <=> v124626(VarCurr,0) ) ).

tff(addAssignment_70839,axiom,
    ! [VarCurr: state_type] :
      ( v124626(VarCurr,0)
    <=> v124627(VarCurr) ) ).

tff(addAssignment_70838,axiom,
    ! [VarCurr: state_type] :
      ( ( v124626(VarCurr,5)
      <=> $false )
      & ( v124626(VarCurr,4)
      <=> $false )
      & ( v124626(VarCurr,3)
      <=> $false )
      & ( v124626(VarCurr,2)
      <=> $false )
      & ( v124626(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15578,axiom,
    ! [VarCurr: state_type] :
      ( v124627(VarCurr)
    <=> ( v124628(VarCurr)
        | v124625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15577,axiom,
    ! [VarCurr: state_type] :
      ( v124628(VarCurr)
    <=> ( v124629(VarCurr)
        | v124623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15576,axiom,
    ! [VarCurr: state_type] :
      ( v124629(VarCurr)
    <=> ( v124630(VarCurr)
        | v124621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15575,axiom,
    ! [VarCurr: state_type] :
      ( v124630(VarCurr)
    <=> ( v124631(VarCurr)
        | v124611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15574,axiom,
    ! [VarCurr: state_type] :
      ( v124631(VarCurr)
    <=> ( v124591(VarCurr)
        | v124601(VarCurr) ) ) ).

tff(addAssignment_70837,axiom,
    ! [VarCurr: state_type] :
      ( v124625(VarCurr)
    <=> v113911(VarCurr,13) ) ).

tff(addAssignment_70836,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,13)
    <=> v113913(VarCurr,13) ) ).

tff(addAssignment_70835,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,13)
    <=> v113915(VarCurr,13) ) ).

tff(addAssignment_70834,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,13)
    <=> v113935(VarCurr,13) ) ).

tff(addAssignment_70833,axiom,
    ! [VarCurr: state_type] :
      ( v124623(VarCurr)
    <=> v113107(VarCurr,13) ) ).

tff(addAssignment_70832,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,13)
    <=> v113143(VarCurr,13) ) ).

tff(addAssignment_70831,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,13)
    <=> v113110(VarCurr,13) ) ).

tff(addAssignment_70830,axiom,
    ! [VarCurr: state_type] :
      ( v124621(VarCurr)
    <=> v113100(VarCurr,13) ) ).

tff(addAssignment_70829,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,13)
    <=> v113101(VarCurr,13) ) ).

tff(addAssignment_70828,axiom,
    ! [VarCurr: state_type] :
      ( v124611(VarCurr)
    <=> v113810(VarCurr,13) ) ).

tff(addAssignment_70827,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,13)
    <=> v113812(VarCurr,13) ) ).

tff(addAssignment_70826,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,13)
    <=> v113814(VarCurr,13) ) ).

tff(addAssignment_70825,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,13)
    <=> v113816(VarCurr,13) ) ).

tff(addAssignment_70824,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,13)
    <=> v113818(VarCurr,13) ) ).

tff(addAssignment_70823,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,13)
    <=> v124613(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124614(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v124613(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1616,axiom,
    ! [VarNext: state_type] :
      ( v124614(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v124613(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124614(VarNext)
      <=> v124615(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124615(VarNext)
      <=> ( v124617(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124617(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_70822,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,13)
    <=> v113830(VarCurr,13) ) ).

tff(addAssignment_70821,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,13)
    <=> v113832(VarCurr,13) ) ).

tff(addAssignment_70820,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,13)
    <=> v113834(VarCurr,13) ) ).

tff(addAssignment_70819,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,13)
    <=> v113873(VarCurr,13) ) ).

tff(addAssignment_70818,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,13)
    <=> v113856(VarCurr,13) ) ).

tff(addAssignment_70817,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,13)
    <=> v113837(VarCurr,13) ) ).

tff(addAssignment_70816,axiom,
    ! [VarCurr: state_type] :
      ( v124601(VarCurr)
    <=> v113020(VarCurr,13) ) ).

tff(addAssignment_70815,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,13)
    <=> v113022(VarCurr,13) ) ).

tff(addAssignment_70814,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,13)
    <=> v113024(VarCurr,13) ) ).

tff(addAssignment_70813,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,13)
    <=> v113026(VarCurr,13) ) ).

tff(addAssignment_70812,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,13)
    <=> v113028(VarCurr,13) ) ).

tff(addAssignment_70811,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,13)
    <=> v124603(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124604(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v124603(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1615,axiom,
    ! [VarNext: state_type] :
      ( v124604(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v124603(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124604(VarNext)
      <=> v124605(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124605(VarNext)
      <=> ( v124607(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124607(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_70810,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,13)
    <=> v113040(VarCurr,13) ) ).

tff(addAssignment_70809,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,13)
    <=> v113042(VarCurr,13) ) ).

tff(addAssignment_70808,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,13)
    <=> v113044(VarCurr,13) ) ).

tff(addAssignment_70807,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,13)
    <=> v113045(VarCurr,13) ) ).

tff(addAssignment_70806,axiom,
    ! [VarCurr: state_type] :
      ( v124591(VarCurr)
    <=> v112940(VarCurr,13) ) ).

tff(addAssignment_70805,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,13)
    <=> v112942(VarCurr,13) ) ).

tff(addAssignment_70804,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,13)
    <=> v112944(VarCurr,13) ) ).

tff(addAssignment_70803,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,13)
    <=> v112946(VarCurr,13) ) ).

tff(addAssignment_70802,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,13)
    <=> v112948(VarCurr,13) ) ).

tff(addAssignment_70801,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,13)
    <=> v124593(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124594(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v124593(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1614,axiom,
    ! [VarNext: state_type] :
      ( v124594(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v124593(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124594(VarNext)
      <=> v124595(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124595(VarNext)
      <=> ( v124597(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124597(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_70800,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,13)
    <=> v112960(VarCurr,13) ) ).

tff(addAssignment_70799,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,13)
    <=> v112962(VarCurr,13) ) ).

tff(addAssignment_70798,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,13)
    <=> v112964(VarCurr,13) ) ).

tff(addAssignment_70797,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,13)
    <=> v112965(VarCurr,13) ) ).

tff(addAssignment_70796,axiom,
    ! [VarCurr: state_type] :
      ( v124380(VarCurr,2)
    <=> v124395(VarCurr,2) ) ).

tff(addAssignment_70795,axiom,
    ! [VarCurr: state_type] :
      ( v124380(VarCurr,1)
    <=> v124395(VarCurr,1) ) ).

tff(addAssignment_70794,axiom,
    ! [VarCurr: state_type] :
      ( v124380(VarCurr,0)
    <=> v124395(VarCurr,0) ) ).

tff(addAssignment_70793,axiom,
    ! [VarCurr: state_type] :
      ( v124395(VarCurr,0)
    <=> v124583(VarCurr) ) ).

tff(addAssignment_70792,axiom,
    ! [VarCurr: state_type] :
      ( v124395(VarCurr,1)
    <=> v124578(VarCurr) ) ).

tff(addAssignment_70791,axiom,
    ! [VarCurr: state_type] :
      ( v124395(VarCurr,2)
    <=> v124397(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15567,axiom,
    ! [VarCurr: state_type] :
      ( v124583(VarCurr)
    <=> ( v124584(VarCurr)
        & v124587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15566,axiom,
    ! [VarCurr: state_type] :
      ( v124587(VarCurr)
    <=> ( v124403(VarCurr,0)
        | v124564(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15565,axiom,
    ! [VarCurr: state_type] :
      ( v124584(VarCurr)
    <=> ( v124585(VarCurr)
        | v124586(VarCurr) ) ) ).

tff(writeUnaryOperator_8632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124586(VarCurr)
    <=> v124564(VarCurr,0) ) ).

tff(writeUnaryOperator_8631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124585(VarCurr)
    <=> v124403(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15564,axiom,
    ! [VarCurr: state_type] :
      ( v124578(VarCurr)
    <=> ( v124579(VarCurr)
        & v124582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15563,axiom,
    ! [VarCurr: state_type] :
      ( v124582(VarCurr)
    <=> ( v124402(VarCurr)
        | v124565(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15562,axiom,
    ! [VarCurr: state_type] :
      ( v124579(VarCurr)
    <=> ( v124580(VarCurr)
        | v124581(VarCurr) ) ) ).

tff(writeUnaryOperator_8630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124581(VarCurr)
    <=> v124565(VarCurr) ) ).

tff(writeUnaryOperator_8629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124580(VarCurr)
    <=> v124402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15561,axiom,
    ! [VarCurr: state_type] :
      ( v124397(VarCurr)
    <=> ( v124398(VarCurr)
        & v124577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15560,axiom,
    ! [VarCurr: state_type] :
      ( v124577(VarCurr)
    <=> ( v124400(VarCurr)
        | v124572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15559,axiom,
    ! [VarCurr: state_type] :
      ( v124398(VarCurr)
    <=> ( v124399(VarCurr)
        | v124571(VarCurr) ) ) ).

tff(writeUnaryOperator_8628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124571(VarCurr)
    <=> v124572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15558,axiom,
    ! [VarCurr: state_type] :
      ( v124572(VarCurr)
    <=> ( v124573(VarCurr)
        & v124576(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5495,axiom,
    ! [VarCurr: state_type] :
      ( v124576(VarCurr)
    <=> ( v124403(VarCurr,2)
        | v124564(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15557,axiom,
    ! [VarCurr: state_type] :
      ( v124573(VarCurr)
    <=> ( v124574(VarCurr)
        | v124575(VarCurr) ) ) ).

tff(writeUnaryOperator_8627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124575(VarCurr)
    <=> v124564(VarCurr,2) ) ).

tff(writeUnaryOperator_8626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124574(VarCurr)
    <=> v124403(VarCurr,2) ) ).

tff(writeUnaryOperator_8625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124399(VarCurr)
    <=> v124400(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15556,axiom,
    ! [VarCurr: state_type] :
      ( v124400(VarCurr)
    <=> ( v124401(VarCurr)
        | v124570(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5494,axiom,
    ! [VarCurr: state_type] :
      ( v124570(VarCurr)
    <=> ( v124403(VarCurr,1)
        & v124564(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15555,axiom,
    ! [VarCurr: state_type] :
      ( v124401(VarCurr)
    <=> ( v124402(VarCurr)
        & v124565(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15554,axiom,
    ! [VarCurr: state_type] :
      ( v124565(VarCurr)
    <=> ( v124566(VarCurr)
        & v124569(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5493,axiom,
    ! [VarCurr: state_type] :
      ( v124569(VarCurr)
    <=> ( v124403(VarCurr,1)
        | v124564(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15553,axiom,
    ! [VarCurr: state_type] :
      ( v124566(VarCurr)
    <=> ( v124567(VarCurr)
        | v124568(VarCurr) ) ) ).

tff(writeUnaryOperator_8624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124568(VarCurr)
    <=> v124564(VarCurr,1) ) ).

tff(writeUnaryOperator_8623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124567(VarCurr)
    <=> v124403(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15552,axiom,
    ! [VarCurr: state_type] :
      ( v124402(VarCurr)
    <=> ( v124403(VarCurr,0)
        & v124564(VarCurr,0) ) ) ).

tff(addAssignment_70790,axiom,
    ! [VarCurr: state_type] :
      ( v124564(VarCurr,0)
    <=> v124394(VarCurr) ) ).

tff(addAssignment_70789,axiom,
    ! [VarCurr: state_type] :
      ( ( v124564(VarCurr,2)
      <=> $false )
      & ( v124564(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70788,axiom,
    ! [VarCurr: state_type] :
      ( v124403(VarCurr,0)
    <=> v124559(VarCurr) ) ).

tff(addAssignment_70787,axiom,
    ! [VarCurr: state_type] :
      ( v124403(VarCurr,1)
    <=> v124554(VarCurr) ) ).

tff(addAssignment_70786,axiom,
    ! [VarCurr: state_type] :
      ( v124403(VarCurr,2)
    <=> v124405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15551,axiom,
    ! [VarCurr: state_type] :
      ( v124559(VarCurr)
    <=> ( v124560(VarCurr)
        & v124563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15550,axiom,
    ! [VarCurr: state_type] :
      ( v124563(VarCurr)
    <=> ( v124411(VarCurr,0)
        | v124540(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15549,axiom,
    ! [VarCurr: state_type] :
      ( v124560(VarCurr)
    <=> ( v124561(VarCurr)
        | v124562(VarCurr) ) ) ).

tff(writeUnaryOperator_8622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124562(VarCurr)
    <=> v124540(VarCurr,0) ) ).

tff(writeUnaryOperator_8621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124561(VarCurr)
    <=> v124411(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15548,axiom,
    ! [VarCurr: state_type] :
      ( v124554(VarCurr)
    <=> ( v124555(VarCurr)
        & v124558(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15547,axiom,
    ! [VarCurr: state_type] :
      ( v124558(VarCurr)
    <=> ( v124410(VarCurr)
        | v124541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15546,axiom,
    ! [VarCurr: state_type] :
      ( v124555(VarCurr)
    <=> ( v124556(VarCurr)
        | v124557(VarCurr) ) ) ).

tff(writeUnaryOperator_8620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124557(VarCurr)
    <=> v124541(VarCurr) ) ).

tff(writeUnaryOperator_8619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124556(VarCurr)
    <=> v124410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15545,axiom,
    ! [VarCurr: state_type] :
      ( v124405(VarCurr)
    <=> ( v124406(VarCurr)
        & v124553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15544,axiom,
    ! [VarCurr: state_type] :
      ( v124553(VarCurr)
    <=> ( v124408(VarCurr)
        | v124548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15543,axiom,
    ! [VarCurr: state_type] :
      ( v124406(VarCurr)
    <=> ( v124407(VarCurr)
        | v124547(VarCurr) ) ) ).

tff(writeUnaryOperator_8618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124547(VarCurr)
    <=> v124548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15542,axiom,
    ! [VarCurr: state_type] :
      ( v124548(VarCurr)
    <=> ( v124549(VarCurr)
        & v124552(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5492,axiom,
    ! [VarCurr: state_type] :
      ( v124552(VarCurr)
    <=> ( v124411(VarCurr,2)
        | v124540(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15541,axiom,
    ! [VarCurr: state_type] :
      ( v124549(VarCurr)
    <=> ( v124550(VarCurr)
        | v124551(VarCurr) ) ) ).

tff(writeUnaryOperator_8617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124551(VarCurr)
    <=> v124540(VarCurr,2) ) ).

tff(writeUnaryOperator_8616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124550(VarCurr)
    <=> v124411(VarCurr,2) ) ).

tff(writeUnaryOperator_8615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124407(VarCurr)
    <=> v124408(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15540,axiom,
    ! [VarCurr: state_type] :
      ( v124408(VarCurr)
    <=> ( v124409(VarCurr)
        | v124546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5491,axiom,
    ! [VarCurr: state_type] :
      ( v124546(VarCurr)
    <=> ( v124411(VarCurr,1)
        & v124540(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15539,axiom,
    ! [VarCurr: state_type] :
      ( v124409(VarCurr)
    <=> ( v124410(VarCurr)
        & v124541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15538,axiom,
    ! [VarCurr: state_type] :
      ( v124541(VarCurr)
    <=> ( v124542(VarCurr)
        & v124545(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5490,axiom,
    ! [VarCurr: state_type] :
      ( v124545(VarCurr)
    <=> ( v124411(VarCurr,1)
        | v124540(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15537,axiom,
    ! [VarCurr: state_type] :
      ( v124542(VarCurr)
    <=> ( v124543(VarCurr)
        | v124544(VarCurr) ) ) ).

tff(writeUnaryOperator_8614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124544(VarCurr)
    <=> v124540(VarCurr,1) ) ).

tff(writeUnaryOperator_8613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124543(VarCurr)
    <=> v124411(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15536,axiom,
    ! [VarCurr: state_type] :
      ( v124410(VarCurr)
    <=> ( v124411(VarCurr,0)
        & v124540(VarCurr,0) ) ) ).

tff(addAssignment_70785,axiom,
    ! [VarCurr: state_type] :
      ( v124540(VarCurr,0)
    <=> v124392(VarCurr) ) ).

tff(addAssignment_70784,axiom,
    ! [VarCurr: state_type] :
      ( ( v124540(VarCurr,2)
      <=> $false )
      & ( v124540(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70783,axiom,
    ! [VarCurr: state_type] :
      ( v124411(VarCurr,0)
    <=> v124535(VarCurr) ) ).

tff(addAssignment_70782,axiom,
    ! [VarCurr: state_type] :
      ( v124411(VarCurr,1)
    <=> v124530(VarCurr) ) ).

tff(addAssignment_70781,axiom,
    ! [VarCurr: state_type] :
      ( v124411(VarCurr,2)
    <=> v124413(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15535,axiom,
    ! [VarCurr: state_type] :
      ( v124535(VarCurr)
    <=> ( v124536(VarCurr)
        & v124539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15534,axiom,
    ! [VarCurr: state_type] :
      ( v124539(VarCurr)
    <=> ( v124419(VarCurr,0)
        | v124516(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15533,axiom,
    ! [VarCurr: state_type] :
      ( v124536(VarCurr)
    <=> ( v124537(VarCurr)
        | v124538(VarCurr) ) ) ).

tff(writeUnaryOperator_8612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124538(VarCurr)
    <=> v124516(VarCurr,0) ) ).

tff(writeUnaryOperator_8611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124537(VarCurr)
    <=> v124419(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15532,axiom,
    ! [VarCurr: state_type] :
      ( v124530(VarCurr)
    <=> ( v124531(VarCurr)
        & v124534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15531,axiom,
    ! [VarCurr: state_type] :
      ( v124534(VarCurr)
    <=> ( v124418(VarCurr)
        | v124517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15530,axiom,
    ! [VarCurr: state_type] :
      ( v124531(VarCurr)
    <=> ( v124532(VarCurr)
        | v124533(VarCurr) ) ) ).

tff(writeUnaryOperator_8610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124533(VarCurr)
    <=> v124517(VarCurr) ) ).

tff(writeUnaryOperator_8609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124532(VarCurr)
    <=> v124418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15529,axiom,
    ! [VarCurr: state_type] :
      ( v124413(VarCurr)
    <=> ( v124414(VarCurr)
        & v124529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15528,axiom,
    ! [VarCurr: state_type] :
      ( v124529(VarCurr)
    <=> ( v124416(VarCurr)
        | v124524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15527,axiom,
    ! [VarCurr: state_type] :
      ( v124414(VarCurr)
    <=> ( v124415(VarCurr)
        | v124523(VarCurr) ) ) ).

tff(writeUnaryOperator_8608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124523(VarCurr)
    <=> v124524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15526,axiom,
    ! [VarCurr: state_type] :
      ( v124524(VarCurr)
    <=> ( v124525(VarCurr)
        & v124528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5489,axiom,
    ! [VarCurr: state_type] :
      ( v124528(VarCurr)
    <=> ( v124419(VarCurr,2)
        | v124516(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15525,axiom,
    ! [VarCurr: state_type] :
      ( v124525(VarCurr)
    <=> ( v124526(VarCurr)
        | v124527(VarCurr) ) ) ).

tff(writeUnaryOperator_8607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124527(VarCurr)
    <=> v124516(VarCurr,2) ) ).

tff(writeUnaryOperator_8606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124526(VarCurr)
    <=> v124419(VarCurr,2) ) ).

tff(writeUnaryOperator_8605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124415(VarCurr)
    <=> v124416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15524,axiom,
    ! [VarCurr: state_type] :
      ( v124416(VarCurr)
    <=> ( v124417(VarCurr)
        | v124522(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5488,axiom,
    ! [VarCurr: state_type] :
      ( v124522(VarCurr)
    <=> ( v124419(VarCurr,1)
        & v124516(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15523,axiom,
    ! [VarCurr: state_type] :
      ( v124417(VarCurr)
    <=> ( v124418(VarCurr)
        & v124517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15522,axiom,
    ! [VarCurr: state_type] :
      ( v124517(VarCurr)
    <=> ( v124518(VarCurr)
        & v124521(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5487,axiom,
    ! [VarCurr: state_type] :
      ( v124521(VarCurr)
    <=> ( v124419(VarCurr,1)
        | v124516(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15521,axiom,
    ! [VarCurr: state_type] :
      ( v124518(VarCurr)
    <=> ( v124519(VarCurr)
        | v124520(VarCurr) ) ) ).

tff(writeUnaryOperator_8604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124520(VarCurr)
    <=> v124516(VarCurr,1) ) ).

tff(writeUnaryOperator_8603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124519(VarCurr)
    <=> v124419(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15520,axiom,
    ! [VarCurr: state_type] :
      ( v124418(VarCurr)
    <=> ( v124419(VarCurr,0)
        & v124516(VarCurr,0) ) ) ).

tff(addAssignment_70780,axiom,
    ! [VarCurr: state_type] :
      ( v124516(VarCurr,0)
    <=> v124390(VarCurr) ) ).

tff(addAssignment_70779,axiom,
    ! [VarCurr: state_type] :
      ( ( v124516(VarCurr,2)
      <=> $false )
      & ( v124516(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70778,axiom,
    ! [VarCurr: state_type] :
      ( v124419(VarCurr,0)
    <=> v124511(VarCurr) ) ).

tff(addAssignment_70777,axiom,
    ! [VarCurr: state_type] :
      ( v124419(VarCurr,1)
    <=> v124506(VarCurr) ) ).

tff(addAssignment_70776,axiom,
    ! [VarCurr: state_type] :
      ( v124419(VarCurr,2)
    <=> v124421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15519,axiom,
    ! [VarCurr: state_type] :
      ( v124511(VarCurr)
    <=> ( v124512(VarCurr)
        & v124515(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15518,axiom,
    ! [VarCurr: state_type] :
      ( v124515(VarCurr)
    <=> ( v124427(VarCurr,0)
        | v124492(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15517,axiom,
    ! [VarCurr: state_type] :
      ( v124512(VarCurr)
    <=> ( v124513(VarCurr)
        | v124514(VarCurr) ) ) ).

tff(writeUnaryOperator_8602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124514(VarCurr)
    <=> v124492(VarCurr,0) ) ).

tff(writeUnaryOperator_8601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124513(VarCurr)
    <=> v124427(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15516,axiom,
    ! [VarCurr: state_type] :
      ( v124506(VarCurr)
    <=> ( v124507(VarCurr)
        & v124510(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15515,axiom,
    ! [VarCurr: state_type] :
      ( v124510(VarCurr)
    <=> ( v124426(VarCurr)
        | v124493(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15514,axiom,
    ! [VarCurr: state_type] :
      ( v124507(VarCurr)
    <=> ( v124508(VarCurr)
        | v124509(VarCurr) ) ) ).

tff(writeUnaryOperator_8600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124509(VarCurr)
    <=> v124493(VarCurr) ) ).

tff(writeUnaryOperator_8599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124508(VarCurr)
    <=> v124426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15513,axiom,
    ! [VarCurr: state_type] :
      ( v124421(VarCurr)
    <=> ( v124422(VarCurr)
        & v124505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15512,axiom,
    ! [VarCurr: state_type] :
      ( v124505(VarCurr)
    <=> ( v124424(VarCurr)
        | v124500(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15511,axiom,
    ! [VarCurr: state_type] :
      ( v124422(VarCurr)
    <=> ( v124423(VarCurr)
        | v124499(VarCurr) ) ) ).

tff(writeUnaryOperator_8598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124499(VarCurr)
    <=> v124500(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15510,axiom,
    ! [VarCurr: state_type] :
      ( v124500(VarCurr)
    <=> ( v124501(VarCurr)
        & v124504(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5486,axiom,
    ! [VarCurr: state_type] :
      ( v124504(VarCurr)
    <=> ( v124427(VarCurr,2)
        | v124492(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15509,axiom,
    ! [VarCurr: state_type] :
      ( v124501(VarCurr)
    <=> ( v124502(VarCurr)
        | v124503(VarCurr) ) ) ).

tff(writeUnaryOperator_8597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124503(VarCurr)
    <=> v124492(VarCurr,2) ) ).

tff(writeUnaryOperator_8596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124502(VarCurr)
    <=> v124427(VarCurr,2) ) ).

tff(writeUnaryOperator_8595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124423(VarCurr)
    <=> v124424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15508,axiom,
    ! [VarCurr: state_type] :
      ( v124424(VarCurr)
    <=> ( v124425(VarCurr)
        | v124498(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5485,axiom,
    ! [VarCurr: state_type] :
      ( v124498(VarCurr)
    <=> ( v124427(VarCurr,1)
        & v124492(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15507,axiom,
    ! [VarCurr: state_type] :
      ( v124425(VarCurr)
    <=> ( v124426(VarCurr)
        & v124493(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15506,axiom,
    ! [VarCurr: state_type] :
      ( v124493(VarCurr)
    <=> ( v124494(VarCurr)
        & v124497(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5484,axiom,
    ! [VarCurr: state_type] :
      ( v124497(VarCurr)
    <=> ( v124427(VarCurr,1)
        | v124492(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15505,axiom,
    ! [VarCurr: state_type] :
      ( v124494(VarCurr)
    <=> ( v124495(VarCurr)
        | v124496(VarCurr) ) ) ).

tff(writeUnaryOperator_8594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124496(VarCurr)
    <=> v124492(VarCurr,1) ) ).

tff(writeUnaryOperator_8593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124495(VarCurr)
    <=> v124427(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15504,axiom,
    ! [VarCurr: state_type] :
      ( v124426(VarCurr)
    <=> ( v124427(VarCurr,0)
        & v124492(VarCurr,0) ) ) ).

tff(addAssignment_70775,axiom,
    ! [VarCurr: state_type] :
      ( v124492(VarCurr,0)
    <=> v124388(VarCurr) ) ).

tff(addAssignment_70774,axiom,
    ! [VarCurr: state_type] :
      ( ( v124492(VarCurr,2)
      <=> $false )
      & ( v124492(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70773,axiom,
    ! [VarCurr: state_type] :
      ( v124427(VarCurr,0)
    <=> v124487(VarCurr) ) ).

tff(addAssignment_70772,axiom,
    ! [VarCurr: state_type] :
      ( v124427(VarCurr,1)
    <=> v124482(VarCurr) ) ).

tff(addAssignment_70771,axiom,
    ! [VarCurr: state_type] :
      ( v124427(VarCurr,2)
    <=> v124429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15503,axiom,
    ! [VarCurr: state_type] :
      ( v124487(VarCurr)
    <=> ( v124488(VarCurr)
        & v124491(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15502,axiom,
    ! [VarCurr: state_type] :
      ( v124491(VarCurr)
    <=> ( v124435(VarCurr,0)
        | v124468(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15501,axiom,
    ! [VarCurr: state_type] :
      ( v124488(VarCurr)
    <=> ( v124489(VarCurr)
        | v124490(VarCurr) ) ) ).

tff(writeUnaryOperator_8592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124490(VarCurr)
    <=> v124468(VarCurr,0) ) ).

tff(writeUnaryOperator_8591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124489(VarCurr)
    <=> v124435(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15500,axiom,
    ! [VarCurr: state_type] :
      ( v124482(VarCurr)
    <=> ( v124483(VarCurr)
        & v124486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15499,axiom,
    ! [VarCurr: state_type] :
      ( v124486(VarCurr)
    <=> ( v124434(VarCurr)
        | v124469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15498,axiom,
    ! [VarCurr: state_type] :
      ( v124483(VarCurr)
    <=> ( v124484(VarCurr)
        | v124485(VarCurr) ) ) ).

tff(writeUnaryOperator_8590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124485(VarCurr)
    <=> v124469(VarCurr) ) ).

tff(writeUnaryOperator_8589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124484(VarCurr)
    <=> v124434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15497,axiom,
    ! [VarCurr: state_type] :
      ( v124429(VarCurr)
    <=> ( v124430(VarCurr)
        & v124481(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15496,axiom,
    ! [VarCurr: state_type] :
      ( v124481(VarCurr)
    <=> ( v124432(VarCurr)
        | v124476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15495,axiom,
    ! [VarCurr: state_type] :
      ( v124430(VarCurr)
    <=> ( v124431(VarCurr)
        | v124475(VarCurr) ) ) ).

tff(writeUnaryOperator_8588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124475(VarCurr)
    <=> v124476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15494,axiom,
    ! [VarCurr: state_type] :
      ( v124476(VarCurr)
    <=> ( v124477(VarCurr)
        & v124480(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5483,axiom,
    ! [VarCurr: state_type] :
      ( v124480(VarCurr)
    <=> ( v124435(VarCurr,2)
        | v124468(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15493,axiom,
    ! [VarCurr: state_type] :
      ( v124477(VarCurr)
    <=> ( v124478(VarCurr)
        | v124479(VarCurr) ) ) ).

tff(writeUnaryOperator_8587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124479(VarCurr)
    <=> v124468(VarCurr,2) ) ).

tff(writeUnaryOperator_8586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124478(VarCurr)
    <=> v124435(VarCurr,2) ) ).

tff(writeUnaryOperator_8585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124431(VarCurr)
    <=> v124432(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15492,axiom,
    ! [VarCurr: state_type] :
      ( v124432(VarCurr)
    <=> ( v124433(VarCurr)
        | v124474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5482,axiom,
    ! [VarCurr: state_type] :
      ( v124474(VarCurr)
    <=> ( v124435(VarCurr,1)
        & v124468(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15491,axiom,
    ! [VarCurr: state_type] :
      ( v124433(VarCurr)
    <=> ( v124434(VarCurr)
        & v124469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15490,axiom,
    ! [VarCurr: state_type] :
      ( v124469(VarCurr)
    <=> ( v124470(VarCurr)
        & v124473(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5481,axiom,
    ! [VarCurr: state_type] :
      ( v124473(VarCurr)
    <=> ( v124435(VarCurr,1)
        | v124468(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15489,axiom,
    ! [VarCurr: state_type] :
      ( v124470(VarCurr)
    <=> ( v124471(VarCurr)
        | v124472(VarCurr) ) ) ).

tff(writeUnaryOperator_8584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124472(VarCurr)
    <=> v124468(VarCurr,1) ) ).

tff(writeUnaryOperator_8583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124471(VarCurr)
    <=> v124435(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15488,axiom,
    ! [VarCurr: state_type] :
      ( v124434(VarCurr)
    <=> ( v124435(VarCurr,0)
        & v124468(VarCurr,0) ) ) ).

tff(addAssignment_70770,axiom,
    ! [VarCurr: state_type] :
      ( v124468(VarCurr,0)
    <=> v124386(VarCurr) ) ).

tff(addAssignment_70769,axiom,
    ! [VarCurr: state_type] :
      ( ( v124468(VarCurr,2)
      <=> $false )
      & ( v124468(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70768,axiom,
    ! [VarCurr: state_type] :
      ( v124435(VarCurr,0)
    <=> v124463(VarCurr) ) ).

tff(addAssignment_70767,axiom,
    ! [VarCurr: state_type] :
      ( v124435(VarCurr,1)
    <=> v124458(VarCurr) ) ).

tff(addAssignment_70766,axiom,
    ! [VarCurr: state_type] :
      ( v124435(VarCurr,2)
    <=> v124437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15487,axiom,
    ! [VarCurr: state_type] :
      ( v124463(VarCurr)
    <=> ( v124464(VarCurr)
        & v124467(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15486,axiom,
    ! [VarCurr: state_type] :
      ( v124467(VarCurr)
    <=> ( v124443(VarCurr,0)
        | v124444(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15485,axiom,
    ! [VarCurr: state_type] :
      ( v124464(VarCurr)
    <=> ( v124465(VarCurr)
        | v124466(VarCurr) ) ) ).

tff(writeUnaryOperator_8582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124466(VarCurr)
    <=> v124444(VarCurr,0) ) ).

tff(writeUnaryOperator_8581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124465(VarCurr)
    <=> v124443(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15484,axiom,
    ! [VarCurr: state_type] :
      ( v124458(VarCurr)
    <=> ( v124459(VarCurr)
        & v124462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15483,axiom,
    ! [VarCurr: state_type] :
      ( v124462(VarCurr)
    <=> ( v124442(VarCurr)
        | v124445(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15482,axiom,
    ! [VarCurr: state_type] :
      ( v124459(VarCurr)
    <=> ( v124460(VarCurr)
        | v124461(VarCurr) ) ) ).

tff(writeUnaryOperator_8580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124461(VarCurr)
    <=> v124445(VarCurr) ) ).

tff(writeUnaryOperator_8579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124460(VarCurr)
    <=> v124442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15481,axiom,
    ! [VarCurr: state_type] :
      ( v124437(VarCurr)
    <=> ( v124438(VarCurr)
        & v124457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15480,axiom,
    ! [VarCurr: state_type] :
      ( v124457(VarCurr)
    <=> ( v124440(VarCurr)
        | v124452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15479,axiom,
    ! [VarCurr: state_type] :
      ( v124438(VarCurr)
    <=> ( v124439(VarCurr)
        | v124451(VarCurr) ) ) ).

tff(writeUnaryOperator_8578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124451(VarCurr)
    <=> v124452(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15478,axiom,
    ! [VarCurr: state_type] :
      ( v124452(VarCurr)
    <=> ( v124453(VarCurr)
        & v124456(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5480,axiom,
    ! [VarCurr: state_type] :
      ( v124456(VarCurr)
    <=> ( v124443(VarCurr,2)
        | v124444(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15477,axiom,
    ! [VarCurr: state_type] :
      ( v124453(VarCurr)
    <=> ( v124454(VarCurr)
        | v124455(VarCurr) ) ) ).

tff(writeUnaryOperator_8577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124455(VarCurr)
    <=> v124444(VarCurr,2) ) ).

tff(writeUnaryOperator_8576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124454(VarCurr)
    <=> v124443(VarCurr,2) ) ).

tff(writeUnaryOperator_8575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124439(VarCurr)
    <=> v124440(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15476,axiom,
    ! [VarCurr: state_type] :
      ( v124440(VarCurr)
    <=> ( v124441(VarCurr)
        | v124450(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5479,axiom,
    ! [VarCurr: state_type] :
      ( v124450(VarCurr)
    <=> ( v124443(VarCurr,1)
        & v124444(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15475,axiom,
    ! [VarCurr: state_type] :
      ( v124441(VarCurr)
    <=> ( v124442(VarCurr)
        & v124445(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15474,axiom,
    ! [VarCurr: state_type] :
      ( v124445(VarCurr)
    <=> ( v124446(VarCurr)
        & v124449(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5478,axiom,
    ! [VarCurr: state_type] :
      ( v124449(VarCurr)
    <=> ( v124443(VarCurr,1)
        | v124444(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15473,axiom,
    ! [VarCurr: state_type] :
      ( v124446(VarCurr)
    <=> ( v124447(VarCurr)
        | v124448(VarCurr) ) ) ).

tff(writeUnaryOperator_8574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124448(VarCurr)
    <=> v124444(VarCurr,1) ) ).

tff(writeUnaryOperator_8573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124447(VarCurr)
    <=> v124443(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15472,axiom,
    ! [VarCurr: state_type] :
      ( v124442(VarCurr)
    <=> ( v124443(VarCurr,0)
        & v124444(VarCurr,0) ) ) ).

tff(addAssignment_70765,axiom,
    ! [VarCurr: state_type] :
      ( v124444(VarCurr,0)
    <=> v124384(VarCurr) ) ).

tff(addAssignment_70764,axiom,
    ! [VarCurr: state_type] :
      ( ( v124444(VarCurr,2)
      <=> $false )
      & ( v124444(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70763,axiom,
    ! [VarCurr: state_type] :
      ( v124443(VarCurr,0)
    <=> v124382(VarCurr) ) ).

tff(addAssignment_70762,axiom,
    ! [VarCurr: state_type] :
      ( ( v124443(VarCurr,2)
      <=> $false )
      & ( v124443(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70761,axiom,
    ! [VarCurr: state_type] :
      ( v124394(VarCurr)
    <=> v114692(VarCurr,13) ) ).

tff(addAssignment_70760,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,13)
    <=> v114694(VarCurr,13) ) ).

tff(addAssignment_70759,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,13)
    <=> v114696(VarCurr,13) ) ).

tff(addAssignment_70758,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,13)
    <=> v114697(VarCurr,13) ) ).

tff(addAssignment_70757,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,13)
    <=> v113918(VarCurr,13) ) ).

tff(addAssignment_70756,axiom,
    ! [VarCurr: state_type] :
      ( v124392(VarCurr)
    <=> v114685(VarCurr,13) ) ).

tff(addAssignment_70755,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,13)
    <=> v114686(VarCurr,13) ) ).

tff(addAssignment_70754,axiom,
    ! [VarCurr: state_type] :
      ( v124390(VarCurr)
    <=> v114661(VarCurr,13) ) ).

tff(addAssignment_70753,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,13)
    <=> v114662(VarCurr,13) ) ).

tff(addAssignment_70752,axiom,
    ! [VarCurr: state_type] :
      ( v124388(VarCurr)
    <=> v114633(VarCurr,13) ) ).

tff(addAssignment_70751,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,13)
    <=> v114635(VarCurr,13) ) ).

tff(addAssignment_70750,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,13)
    <=> v114637(VarCurr,13) ) ).

tff(addAssignment_70749,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,13)
    <=> v114638(VarCurr,13) ) ).

tff(addAssignment_70748,axiom,
    ! [VarCurr: state_type] :
      ( v124386(VarCurr)
    <=> v114605(VarCurr,13) ) ).

tff(addAssignment_70747,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,13)
    <=> v114607(VarCurr,13) ) ).

tff(addAssignment_70746,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,13)
    <=> v114609(VarCurr,13) ) ).

tff(addAssignment_70745,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,13)
    <=> v114610(VarCurr,13) ) ).

tff(addAssignment_70744,axiom,
    ! [VarCurr: state_type] :
      ( v124384(VarCurr)
    <=> v114577(VarCurr,13) ) ).

tff(addAssignment_70743,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,13)
    <=> v114579(VarCurr,13) ) ).

tff(addAssignment_70742,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,13)
    <=> v114581(VarCurr,13) ) ).

tff(addAssignment_70741,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,13)
    <=> v114582(VarCurr,13) ) ).

tff(addAssignment_70740,axiom,
    ! [VarCurr: state_type] :
      ( v124382(VarCurr)
    <=> v114549(VarCurr,13) ) ).

tff(addAssignment_70739,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,13)
    <=> v114551(VarCurr,13) ) ).

tff(addAssignment_70738,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,13)
    <=> v114553(VarCurr,13) ) ).

tff(addAssignment_70737,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,13)
    <=> v114554(VarCurr,13) ) ).

tff(addAssignment_70736,axiom,
    ! [VarCurr: state_type] :
      ( v124368(VarCurr)
    <=> v124370(VarCurr) ) ).

tff(addAssignment_70735,axiom,
    ! [VarCurr: state_type] :
      ( v124370(VarCurr)
    <=> v124344(VarCurr) ) ).

tff(addAssignment_70734,axiom,
    ! [VarCurr: state_type] :
      ( v124364(VarCurr)
    <=> v124366(VarCurr) ) ).

tff(addAssignment_70733,axiom,
    ! [VarCurr: state_type] :
      ( v124366(VarCurr)
    <=> v124336(VarCurr) ) ).

tff(addAssignment_70732,axiom,
    ! [VarCurr: state_type] :
      ( v124340(VarCurr)
    <=> v124342(VarCurr) ) ).

tff(addAssignment_70731,axiom,
    ! [VarCurr: state_type] :
      ( v124342(VarCurr)
    <=> v124344(VarCurr) ) ).

tff(addAssignment_70730,axiom,
    ! [VarCurr: state_type] :
      ( v124344(VarCurr)
    <=> v124346(VarCurr) ) ).

tff(addAssignment_70729,axiom,
    ! [VarCurr: state_type] :
      ( v124346(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_70728,axiom,
    ! [VarCurr: state_type] :
      ( v124332(VarCurr)
    <=> v124334(VarCurr) ) ).

tff(addAssignment_70727,axiom,
    ! [VarCurr: state_type] :
      ( v124334(VarCurr)
    <=> v124336(VarCurr) ) ).

tff(addAssignment_70726,axiom,
    ! [VarCurr: state_type] :
      ( v124336(VarCurr)
    <=> v124338(VarCurr) ) ).

tff(addAssignment_70725,axiom,
    ! [VarCurr: state_type] :
      ( v124338(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15471,axiom,
    ! [VarCurr: state_type] :
      ( v123523(VarCurr)
    <=> ( v124322(VarCurr)
        & v124232(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5477,axiom,
    ! [VarCurr: state_type] :
      ( v124322(VarCurr)
    <=> ( v123525(VarCurr,1)
        & v124171(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1228,axiom,
    ! [VarCurr: state_type] :
      ( v124232(VarCurr)
    <=> ( ( v124234(VarCurr,4)
        <=> $false )
        & ( v124234(VarCurr,3)
        <=> $false )
        & ( v124234(VarCurr,2)
        <=> $false )
        & ( v124234(VarCurr,1)
        <=> $false )
        & ( v124234(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124234(VarCurr,B)
      <=> v124236(VarCurr,B) ) ) ).

tff(addAssignment_70723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124236(VarCurr,B)
      <=> v124238(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124304(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v124238(VarNext,B)
            <=> v124238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1613,axiom,
    ! [VarNext: state_type] :
      ( v124304(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124238(VarNext,B)
          <=> v124314(VarNext,B) ) ) ) ).

tff(addAssignment_70722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124314(VarNext,B)
          <=> v124312(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124315(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124312(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1159,axiom,
    ! [VarCurr: state_type] :
      ( v124315(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124312(VarCurr,B)
          <=> v124248(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15470,axiom,
    ! [VarCurr: state_type] :
      ( v124315(VarCurr)
    <=> ( v124316(VarCurr)
        & v124317(VarCurr) ) ) ).

tff(writeUnaryOperator_8572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124317(VarCurr)
    <=> v124244(VarCurr) ) ).

tff(writeUnaryOperator_8571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124316(VarCurr)
    <=> v124240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124304(VarNext)
      <=> v124305(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124305(VarNext)
      <=> ( v124306(VarNext)
          & v124299(VarNext) ) ) ) ).

tff(writeUnaryOperator_8570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124306(VarNext)
      <=> v124308(VarNext) ) ) ).

tff(addAssignment_70721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124308(VarNext)
      <=> v124299(VarCurr) ) ) ).

tff(addAssignment_70720,axiom,
    ! [VarCurr: state_type] :
      ( v124299(VarCurr)
    <=> v124301(VarCurr) ) ).

tff(addAssignment_70719,axiom,
    ! [VarCurr: state_type] :
      ( v124301(VarCurr)
    <=> v124005(VarCurr) ) ).

tff(addAssignment_70718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124248(VarCurr,B)
      <=> v124250(VarCurr,B) ) ) ).

tff(addAssignment_70717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124250(VarCurr,B)
      <=> v124252(VarCurr,B) ) ) ).

tff(addAssignment_70716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124252(VarCurr,B)
      <=> v124254(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124256(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124254(VarCurr,B)
          <=> v124268(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1158,axiom,
    ! [VarCurr: state_type] :
      ( v124256(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124254(VarCurr,B)
          <=> v124261(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124268(VarCurr,B)
          <=> v124269(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1157,axiom,
    ! [VarCurr: state_type] :
      ( v124263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124268(VarCurr,B)
          <=> v124266(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124232(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124269(VarCurr,B)
          <=> v124270(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1156,axiom,
    ! [VarCurr: state_type] :
      ( v124232(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v124269(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70715,axiom,
    ! [VarCurr: state_type] :
      ( v124270(VarCurr,0)
    <=> v124296(VarCurr) ) ).

tff(addAssignment_70714,axiom,
    ! [VarCurr: state_type] :
      ( v124270(VarCurr,1)
    <=> v124294(VarCurr) ) ).

tff(addAssignment_70713,axiom,
    ! [VarCurr: state_type] :
      ( v124270(VarCurr,2)
    <=> v124290(VarCurr) ) ).

tff(addAssignment_70712,axiom,
    ! [VarCurr: state_type] :
      ( v124270(VarCurr,3)
    <=> v124286(VarCurr) ) ).

tff(addAssignment_70711,axiom,
    ! [VarCurr: state_type] :
      ( v124270(VarCurr,4)
    <=> v124272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15467,axiom,
    ! [VarCurr: state_type] :
      ( v124294(VarCurr)
    <=> ( v124295(VarCurr)
        & v124297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15466,axiom,
    ! [VarCurr: state_type] :
      ( v124297(VarCurr)
    <=> ( v124234(VarCurr,0)
        | v124281(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5476,axiom,
    ! [VarCurr: state_type] :
      ( v124295(VarCurr)
    <=> ( v124296(VarCurr)
        | v124234(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124296(VarCurr)
    <=> v124234(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15465,axiom,
    ! [VarCurr: state_type] :
      ( v124290(VarCurr)
    <=> ( v124291(VarCurr)
        & v124293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15464,axiom,
    ! [VarCurr: state_type] :
      ( v124293(VarCurr)
    <=> ( v124279(VarCurr)
        | v124282(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5475,axiom,
    ! [VarCurr: state_type] :
      ( v124291(VarCurr)
    <=> ( v124292(VarCurr)
        | v124234(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124292(VarCurr)
    <=> v124279(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15463,axiom,
    ! [VarCurr: state_type] :
      ( v124286(VarCurr)
    <=> ( v124287(VarCurr)
        & v124289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15462,axiom,
    ! [VarCurr: state_type] :
      ( v124289(VarCurr)
    <=> ( v124277(VarCurr)
        | v124283(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5474,axiom,
    ! [VarCurr: state_type] :
      ( v124287(VarCurr)
    <=> ( v124288(VarCurr)
        | v124234(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124288(VarCurr)
    <=> v124277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15461,axiom,
    ! [VarCurr: state_type] :
      ( v124272(VarCurr)
    <=> ( v124273(VarCurr)
        & v124284(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15460,axiom,
    ! [VarCurr: state_type] :
      ( v124284(VarCurr)
    <=> ( v124275(VarCurr)
        | v124285(VarCurr) ) ) ).

tff(writeUnaryOperator_8566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124285(VarCurr)
    <=> v124234(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5473,axiom,
    ! [VarCurr: state_type] :
      ( v124273(VarCurr)
    <=> ( v124274(VarCurr)
        | v124234(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124274(VarCurr)
    <=> v124275(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5472,axiom,
    ! [VarCurr: state_type] :
      ( v124275(VarCurr)
    <=> ( v124234(VarCurr,3)
        | v124276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15459,axiom,
    ! [VarCurr: state_type] :
      ( v124276(VarCurr)
    <=> ( v124277(VarCurr)
        & v124283(VarCurr) ) ) ).

tff(writeUnaryOperator_8564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124283(VarCurr)
    <=> v124234(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5471,axiom,
    ! [VarCurr: state_type] :
      ( v124277(VarCurr)
    <=> ( v124234(VarCurr,2)
        | v124278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15458,axiom,
    ! [VarCurr: state_type] :
      ( v124278(VarCurr)
    <=> ( v124279(VarCurr)
        & v124282(VarCurr) ) ) ).

tff(writeUnaryOperator_8563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124282(VarCurr)
    <=> v124234(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5470,axiom,
    ! [VarCurr: state_type] :
      ( v124279(VarCurr)
    <=> ( v124234(VarCurr,1)
        | v124280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15457,axiom,
    ! [VarCurr: state_type] :
      ( v124280(VarCurr)
    <=> ( v124234(VarCurr,0)
        & v124281(VarCurr) ) ) ).

tff(writeUnaryOperator_8562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124281(VarCurr)
    <=> v124234(VarCurr,1) ) ).

tff(addAssignment_70710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124266(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15456,axiom,
    ! [VarCurr: state_type] :
      ( v124263(VarCurr)
    <=> ( v123810(VarCurr)
        | v123824(VarCurr) ) ) ).

tff(addAssignment_70709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v124261(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15455,axiom,
    ! [VarCurr: state_type] :
      ( v124256(VarCurr)
    <=> ( v124258(VarCurr)
        | v123822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15454,axiom,
    ! [VarCurr: state_type] :
      ( v124258(VarCurr)
    <=> ( v124259(VarCurr)
        | v123820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15453,axiom,
    ! [VarCurr: state_type] :
      ( v124259(VarCurr)
    <=> ( v123790(VarCurr)
        | v123800(VarCurr) ) ) ).

tff(addAssignment_70708,axiom,
    ! [VarCurr: state_type] :
      ( v124244(VarCurr)
    <=> v124246(VarCurr) ) ).

tff(addAssignment_70707,axiom,
    ! [VarCurr: state_type] :
      ( v124246(VarCurr)
    <=> v123543(VarCurr) ) ).

tff(addAssignment_70706,axiom,
    ! [VarCurr: state_type] :
      ( v124240(VarCurr)
    <=> v124242(VarCurr) ) ).

tff(addAssignment_70705,axiom,
    ! [VarCurr: state_type] :
      ( v124242(VarCurr)
    <=> v123535(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1227,axiom,
    ! [VarCurr: state_type] :
      ( v124171(VarCurr)
    <=> ( ( v124173(VarCurr,1)
        <=> $false )
        & ( v124173(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124173(VarCurr,B)
      <=> v124175(VarCurr,B) ) ) ).

tff(addAssignment_70703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124175(VarCurr,B)
      <=> v124177(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124214(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v124177(VarNext,B)
            <=> v124177(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1612,axiom,
    ! [VarNext: state_type] :
      ( v124214(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124177(VarNext,B)
          <=> v124224(VarNext,B) ) ) ) ).

tff(addAssignment_70702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124224(VarNext,B)
          <=> v124222(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124225(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124222(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1155,axiom,
    ! [VarCurr: state_type] :
      ( v124225(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124222(VarCurr,B)
          <=> v124187(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15452,axiom,
    ! [VarCurr: state_type] :
      ( v124225(VarCurr)
    <=> ( v124226(VarCurr)
        & v124227(VarCurr) ) ) ).

tff(writeUnaryOperator_8561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124227(VarCurr)
    <=> v124183(VarCurr) ) ).

tff(writeUnaryOperator_8560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124226(VarCurr)
    <=> v124179(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124214(VarNext)
      <=> v124215(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124215(VarNext)
      <=> ( v124216(VarNext)
          & v124209(VarNext) ) ) ) ).

tff(writeUnaryOperator_8559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124216(VarNext)
      <=> v124218(VarNext) ) ) ).

tff(addAssignment_70701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124218(VarNext)
      <=> v124209(VarCurr) ) ) ).

tff(addAssignment_70700,axiom,
    ! [VarCurr: state_type] :
      ( v124209(VarCurr)
    <=> v124211(VarCurr) ) ).

tff(addAssignment_70699,axiom,
    ! [VarCurr: state_type] :
      ( v124211(VarCurr)
    <=> v124005(VarCurr) ) ).

tff(addAssignment_70698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124187(VarCurr,B)
      <=> v124189(VarCurr,B) ) ) ).

tff(addAssignment_70697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124189(VarCurr,B)
      <=> v124191(VarCurr,B) ) ) ).

tff(addAssignment_70696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v124191(VarCurr,B)
      <=> v124193(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124195(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124193(VarCurr,B)
          <=> v124200(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1154,axiom,
    ! [VarCurr: state_type] :
      ( v124195(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124193(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124171(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124200(VarCurr,B)
          <=> v124201(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1153,axiom,
    ! [VarCurr: state_type] :
      ( v124171(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v124200(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70695,axiom,
    ! [VarCurr: state_type] :
      ( v124201(VarCurr,0)
    <=> v124205(VarCurr) ) ).

tff(addAssignment_70694,axiom,
    ! [VarCurr: state_type] :
      ( v124201(VarCurr,1)
    <=> v124203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15449,axiom,
    ! [VarCurr: state_type] :
      ( v124203(VarCurr)
    <=> ( v124204(VarCurr)
        & v124206(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15448,axiom,
    ! [VarCurr: state_type] :
      ( v124206(VarCurr)
    <=> ( v124173(VarCurr,0)
        | v124207(VarCurr) ) ) ).

tff(writeUnaryOperator_8558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124207(VarCurr)
    <=> v124173(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5469,axiom,
    ! [VarCurr: state_type] :
      ( v124204(VarCurr)
    <=> ( v124205(VarCurr)
        | v124173(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124205(VarCurr)
    <=> v124173(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15447,axiom,
    ! [VarCurr: state_type] :
      ( v124195(VarCurr)
    <=> ( v124197(VarCurr)
        | v124198(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5468,axiom,
    ! [VarCurr: state_type] :
      ( v124198(VarCurr)
    <=> ( v123525(VarCurr,1)
        & v124038(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5467,axiom,
    ! [VarCurr: state_type] :
      ( v124197(VarCurr)
    <=> ( v123525(VarCurr,3)
        & v124096(VarCurr) ) ) ).

tff(addAssignment_70693,axiom,
    ! [VarCurr: state_type] :
      ( v124183(VarCurr)
    <=> v124185(VarCurr) ) ).

tff(addAssignment_70692,axiom,
    ! [VarCurr: state_type] :
      ( v124185(VarCurr)
    <=> v123543(VarCurr) ) ).

tff(addAssignment_70691,axiom,
    ! [VarCurr: state_type] :
      ( v124179(VarCurr)
    <=> v124181(VarCurr) ) ).

tff(addAssignment_70690,axiom,
    ! [VarCurr: state_type] :
      ( v124181(VarCurr)
    <=> v123535(VarCurr) ) ).

tff(addAssignment_70689,axiom,
    ! [VarCurr: state_type] :
      ( v123525(VarCurr,1)
    <=> v123527(VarCurr,1) ) ).

tff(addAssignment_70688,axiom,
    ! [VarCurr: state_type] :
      ( v123527(VarCurr,1)
    <=> v123529(VarCurr,1) ) ).

tff(addAssignment_70687,axiom,
    ! [VarNext: state_type] :
      ( v123529(VarNext,1)
    <=> v124163(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124163(VarNext,B)
            <=> v123529(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1611,axiom,
    ! [VarNext: state_type] :
      ( v124164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124163(VarNext,B)
          <=> v124089(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124164(VarNext)
      <=> v124165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124165(VarNext)
      <=> ( v124167(VarNext)
          & v124074(VarNext) ) ) ) ).

tff(writeUnaryOperator_8556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124167(VarNext)
      <=> v124083(VarNext) ) ) ).

tff(addAssignment_70686,axiom,
    ! [VarCurr: state_type] :
      ( v123547(VarCurr,1)
    <=> v123549(VarCurr,1) ) ).

tff(addAssignment_70685,axiom,
    ! [VarCurr: state_type] :
      ( v123549(VarCurr,1)
    <=> v123551(VarCurr,1) ) ).

tff(addAssignment_70684,axiom,
    ! [VarCurr: state_type] :
      ( v123551(VarCurr,1)
    <=> v124072(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_68,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124154(VarCurr)
     => ( v123553(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_97,axiom,
    ! [VarCurr: state_type] :
      ( v124154(VarCurr)
     => ( v123553(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15444,axiom,
    ! [VarCurr: state_type] :
      ( v124154(VarCurr)
    <=> ( v124155(VarCurr)
        | v124156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15443,axiom,
    ! [VarCurr: state_type] :
      ( v124156(VarCurr)
    <=> ( v124157(VarCurr)
        & v124158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15442,axiom,
    ! [VarCurr: state_type] :
      ( v124158(VarCurr)
    <=> ( v124159(VarCurr)
        & v124055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15441,axiom,
    ! [VarCurr: state_type] :
      ( v124159(VarCurr)
    <=> ( v124160(VarCurr)
        & v124161(VarCurr) ) ) ).

tff(writeUnaryOperator_8555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124161(VarCurr)
    <=> v124047(VarCurr) ) ).

tff(writeUnaryOperator_8554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124160(VarCurr)
    <=> v124038(VarCurr) ) ).

tff(writeUnaryOperator_8553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124157(VarCurr)
    <=> v124057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15440,axiom,
    ! [VarCurr: state_type] :
      ( v124155(VarCurr)
    <=> ( v124129(VarCurr)
        & v124057(VarCurr) ) ) ).

tff(writeUnaryOperator_8552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123525(VarCurr,0)
    <=> v124034(VarCurr) ) ).

tff(addAssignment_70683,axiom,
    ! [VarCurr: state_type] :
      ( v124034(VarCurr)
    <=> v123527(VarCurr,0) ) ).

tff(addAssignment_70682,axiom,
    ! [VarCurr: state_type] :
      ( v123527(VarCurr,0)
    <=> v123529(VarCurr,0) ) ).

tff(addAssignment_70681,axiom,
    ! [VarNext: state_type] :
      ( v123529(VarNext,0)
    <=> v124145(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124146(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124145(VarNext,B)
            <=> v123529(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1610,axiom,
    ! [VarNext: state_type] :
      ( v124146(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124145(VarNext,B)
          <=> v124089(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124146(VarNext)
      <=> v124147(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124147(VarNext)
      <=> ( v124149(VarNext)
          & v124074(VarNext) ) ) ) ).

tff(writeUnaryOperator_8551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124149(VarNext)
      <=> v124083(VarNext) ) ) ).

tff(addAssignment_70680,axiom,
    ! [VarCurr: state_type] :
      ( v123547(VarCurr,0)
    <=> v123549(VarCurr,0) ) ).

tff(addAssignment_70679,axiom,
    ! [VarCurr: state_type] :
      ( v123549(VarCurr,0)
    <=> v123551(VarCurr,0) ) ).

tff(addAssignment_70678,axiom,
    ! [VarCurr: state_type] :
      ( v123551(VarCurr,0)
    <=> v124072(VarCurr,0) ) ).

tff(writeUnaryOperator_8550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124036(VarCurr)
    <=> v123553(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124124(VarCurr)
     => ( v123553(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1152,axiom,
    ! [VarCurr: state_type] :
      ( v124124(VarCurr)
     => ( v123553(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15437,axiom,
    ! [VarCurr: state_type] :
      ( v124124(VarCurr)
    <=> ( v124125(VarCurr)
        | v124138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15436,axiom,
    ! [VarCurr: state_type] :
      ( v124138(VarCurr)
    <=> ( v124139(VarCurr)
        & v124142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15435,axiom,
    ! [VarCurr: state_type] :
      ( v124142(VarCurr)
    <=> ( v124110(VarCurr)
        & v124113(VarCurr) ) ) ).

tff(writeUnaryOperator_8549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124139(VarCurr)
    <=> v124140(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15434,axiom,
    ! [VarCurr: state_type] :
      ( v124140(VarCurr)
    <=> ( v124141(VarCurr)
        | v124070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15433,axiom,
    ! [VarCurr: state_type] :
      ( v124141(VarCurr)
    <=> ( v124057(VarCurr)
        | v124055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15432,axiom,
    ! [VarCurr: state_type] :
      ( v124125(VarCurr)
    <=> ( v124126(VarCurr)
        | v124134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15431,axiom,
    ! [VarCurr: state_type] :
      ( v124134(VarCurr)
    <=> ( v124135(VarCurr)
        & v124137(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15430,axiom,
    ! [VarCurr: state_type] :
      ( v124137(VarCurr)
    <=> ( v124068(VarCurr)
        & v124070(VarCurr) ) ) ).

tff(writeUnaryOperator_8548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124135(VarCurr)
    <=> v124136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15429,axiom,
    ! [VarCurr: state_type] :
      ( v124136(VarCurr)
    <=> ( v124057(VarCurr)
        | v124055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15428,axiom,
    ! [VarCurr: state_type] :
      ( v124126(VarCurr)
    <=> ( v124127(VarCurr)
        | v124131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15427,axiom,
    ! [VarCurr: state_type] :
      ( v124131(VarCurr)
    <=> ( v124132(VarCurr)
        & v124133(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15426,axiom,
    ! [VarCurr: state_type] :
      ( v124133(VarCurr)
    <=> ( v124047(VarCurr)
        & v124055(VarCurr) ) ) ).

tff(writeUnaryOperator_8547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124132(VarCurr)
    <=> v124057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15425,axiom,
    ! [VarCurr: state_type] :
      ( v124127(VarCurr)
    <=> ( v124128(VarCurr)
        & v124057(VarCurr) ) ) ).

tff(writeUnaryOperator_8546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124128(VarCurr)
    <=> v124129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15424,axiom,
    ! [VarCurr: state_type] :
      ( v124129(VarCurr)
    <=> ( v124130(VarCurr)
        & v124032(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15423,axiom,
    ! [VarCurr: state_type] :
      ( v124130(VarCurr)
    <=> ( v123555(VarCurr)
        & v124030(VarCurr) ) ) ).

tff(addAssignment_70677,axiom,
    ! [VarCurr: state_type] :
      ( v123525(VarCurr,3)
    <=> v123527(VarCurr,3) ) ).

tff(addAssignment_70676,axiom,
    ! [VarCurr: state_type] :
      ( v123527(VarCurr,3)
    <=> v123529(VarCurr,3) ) ).

tff(addAssignment_70675,axiom,
    ! [VarNext: state_type] :
      ( v123529(VarNext,3)
    <=> v124116(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124117(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124116(VarNext,B)
            <=> v123529(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1609,axiom,
    ! [VarNext: state_type] :
      ( v124117(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124116(VarNext,B)
          <=> v124089(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124117(VarNext)
      <=> v124118(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124118(VarNext)
      <=> ( v124120(VarNext)
          & v124074(VarNext) ) ) ) ).

tff(writeUnaryOperator_8545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124120(VarNext)
      <=> v124083(VarNext) ) ) ).

tff(addAssignment_70674,axiom,
    ! [VarCurr: state_type] :
      ( v123547(VarCurr,3)
    <=> v123549(VarCurr,3) ) ).

tff(addAssignment_70673,axiom,
    ! [VarCurr: state_type] :
      ( v123549(VarCurr,3)
    <=> v123551(VarCurr,3) ) ).

tff(addAssignment_70672,axiom,
    ! [VarCurr: state_type] :
      ( v123551(VarCurr,3)
    <=> v124072(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_67,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124098(VarCurr)
     => ( v123553(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_96,axiom,
    ! [VarCurr: state_type] :
      ( v124098(VarCurr)
     => ( v123553(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15420,axiom,
    ! [VarCurr: state_type] :
      ( v124098(VarCurr)
    <=> ( v124099(VarCurr)
        | v124105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15419,axiom,
    ! [VarCurr: state_type] :
      ( v124105(VarCurr)
    <=> ( v124106(VarCurr)
        & v124107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15418,axiom,
    ! [VarCurr: state_type] :
      ( v124107(VarCurr)
    <=> ( v124108(VarCurr)
        & v124114(VarCurr) ) ) ).

tff(writeUnaryOperator_8544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124114(VarCurr)
    <=> v124104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15417,axiom,
    ! [VarCurr: state_type] :
      ( v124108(VarCurr)
    <=> ( v124109(VarCurr)
        & v124113(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1226,axiom,
    ! [VarCurr: state_type] :
      ( v124113(VarCurr)
    <=> ( $true
      <=> v123525(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124109(VarCurr)
    <=> v124110(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15416,axiom,
    ! [VarCurr: state_type] :
      ( v124110(VarCurr)
    <=> ( v124111(VarCurr)
        | v124040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15415,axiom,
    ! [VarCurr: state_type] :
      ( v124111(VarCurr)
    <=> ( v124112(VarCurr)
        | v124096(VarCurr) ) ) ).

tff(writeUnaryOperator_8542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124112(VarCurr)
    <=> v124030(VarCurr) ) ).

tff(writeUnaryOperator_8541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124106(VarCurr)
    <=> v124070(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15414,axiom,
    ! [VarCurr: state_type] :
      ( v124099(VarCurr)
    <=> ( v124100(VarCurr)
        & v124103(VarCurr) ) ) ).

tff(writeUnaryOperator_8540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124103(VarCurr)
    <=> v124104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15413,axiom,
    ! [VarCurr: state_type] :
      ( v124104(VarCurr)
    <=> ( v124057(VarCurr)
        | v124055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15412,axiom,
    ! [VarCurr: state_type] :
      ( v124100(VarCurr)
    <=> ( v124101(VarCurr)
        & v124070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15411,axiom,
    ! [VarCurr: state_type] :
      ( v124101(VarCurr)
    <=> ( v124064(VarCurr)
        & v124102(VarCurr) ) ) ).

tff(writeUnaryOperator_8539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124102(VarCurr)
    <=> v124068(VarCurr) ) ).

tff(addAssignment_70671,axiom,
    ! [VarCurr: state_type] :
      ( v124096(VarCurr)
    <=> v112831(VarCurr,12) ) ).

tff(addAssignment_70670,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,12)
    <=> v112865(VarCurr,12) ) ).

tff(addAssignment_70669,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,12)
    <=> v112849(VarCurr,12) ) ).

tff(addAssignment_70668,axiom,
    ! [VarCurr: state_type] :
      ( v123525(VarCurr,2)
    <=> v123527(VarCurr,2) ) ).

tff(addAssignment_70667,axiom,
    ! [VarCurr: state_type] :
      ( v123527(VarCurr,2)
    <=> v123529(VarCurr,2) ) ).

tff(addAssignment_70666,axiom,
    ! [VarNext: state_type] :
      ( v123529(VarNext,2)
    <=> v124078(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124079(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v124078(VarNext,B)
            <=> v123529(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1608,axiom,
    ! [VarNext: state_type] :
      ( v124079(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124078(VarNext,B)
          <=> v124089(VarNext,B) ) ) ) ).

tff(addAssignment_70665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124089(VarNext,B)
          <=> v124087(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124087(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1151,axiom,
    ! [VarCurr: state_type] :
      ( v124090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v124087(VarCurr,B)
          <=> v123547(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15410,axiom,
    ! [VarCurr: state_type] :
      ( v124090(VarCurr)
    <=> ( v124091(VarCurr)
        & v124092(VarCurr) ) ) ).

tff(writeUnaryOperator_8538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124092(VarCurr)
    <=> v123539(VarCurr) ) ).

tff(writeUnaryOperator_8537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124091(VarCurr)
    <=> v123531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124079(VarNext)
      <=> v124080(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124080(VarNext)
      <=> ( v124081(VarNext)
          & v124074(VarNext) ) ) ) ).

tff(writeUnaryOperator_8536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124081(VarNext)
      <=> v124083(VarNext) ) ) ).

tff(addAssignment_70664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124083(VarNext)
      <=> v124074(VarCurr) ) ) ).

tff(addAssignment_70663,axiom,
    ! [VarCurr: state_type] :
      ( v124074(VarCurr)
    <=> v124076(VarCurr) ) ).

tff(addAssignment_70662,axiom,
    ! [VarCurr: state_type] :
      ( v124076(VarCurr)
    <=> v124005(VarCurr) ) ).

tff(addAssignment_70661,axiom,
    ! [VarCurr: state_type] :
      ( v123547(VarCurr,2)
    <=> v123549(VarCurr,2) ) ).

tff(addAssignment_70660,axiom,
    ! [VarCurr: state_type] :
      ( v123549(VarCurr,2)
    <=> v123551(VarCurr,2) ) ).

tff(addAssignment_70659,axiom,
    ! [VarCurr: state_type] :
      ( v123551(VarCurr,2)
    <=> v124072(VarCurr,2) ) ).

tff(addAssignment_70658,axiom,
    ! [VarCurr: state_type] :
      ( v124072(VarCurr,0)
    <=> v124036(VarCurr) ) ).

tff(addAssignment_70657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v124072(VarCurr,B)
      <=> v123553(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_66,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124042(VarCurr)
     => ( v123553(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_95,axiom,
    ! [VarCurr: state_type] :
      ( v124042(VarCurr)
     => ( v123553(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15407,axiom,
    ! [VarCurr: state_type] :
      ( v124042(VarCurr)
    <=> ( v124043(VarCurr)
        | v124058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15406,axiom,
    ! [VarCurr: state_type] :
      ( v124058(VarCurr)
    <=> ( v124059(VarCurr)
        & v124060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15405,axiom,
    ! [VarCurr: state_type] :
      ( v124060(VarCurr)
    <=> ( v124061(VarCurr)
        & v124071(VarCurr) ) ) ).

tff(writeUnaryOperator_8535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124071(VarCurr)
    <=> v124057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15404,axiom,
    ! [VarCurr: state_type] :
      ( v124061(VarCurr)
    <=> ( v124062(VarCurr)
        & v124070(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1225,axiom,
    ! [VarCurr: state_type] :
      ( v124070(VarCurr)
    <=> ( $true
      <=> v123525(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15403,axiom,
    ! [VarCurr: state_type] :
      ( v124062(VarCurr)
    <=> ( v124063(VarCurr)
        & v124067(VarCurr) ) ) ).

tff(writeUnaryOperator_8534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124067(VarCurr)
    <=> v124068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15402,axiom,
    ! [VarCurr: state_type] :
      ( v124068(VarCurr)
    <=> ( v124069(VarCurr)
        | v124040(VarCurr) ) ) ).

tff(writeUnaryOperator_8533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124069(VarCurr)
    <=> v124030(VarCurr) ) ).

tff(writeUnaryOperator_8532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124063(VarCurr)
    <=> v124064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15401,axiom,
    ! [VarCurr: state_type] :
      ( v124064(VarCurr)
    <=> ( v124065(VarCurr)
        | v124066(VarCurr) ) ) ).

tff(writeUnaryOperator_8531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124066(VarCurr)
    <=> v124032(VarCurr) ) ).

tff(writeUnaryOperator_8530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124065(VarCurr)
    <=> v123555(VarCurr) ) ).

tff(writeUnaryOperator_8529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124059(VarCurr)
    <=> v124055(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15400,axiom,
    ! [VarCurr: state_type] :
      ( v124043(VarCurr)
    <=> ( v124044(VarCurr)
        & v124056(VarCurr) ) ) ).

tff(writeUnaryOperator_8528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124056(VarCurr)
    <=> v124057(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1224,axiom,
    ! [VarCurr: state_type] :
      ( v124057(VarCurr)
    <=> ( $true
      <=> v123525(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15399,axiom,
    ! [VarCurr: state_type] :
      ( v124044(VarCurr)
    <=> ( v124045(VarCurr)
        & v124055(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1223,axiom,
    ! [VarCurr: state_type] :
      ( v124055(VarCurr)
    <=> ( $true
      <=> v123525(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15398,axiom,
    ! [VarCurr: state_type] :
      ( v124045(VarCurr)
    <=> ( v124038(VarCurr)
        & v124046(VarCurr) ) ) ).

tff(writeUnaryOperator_8527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124046(VarCurr)
    <=> v124047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15397,axiom,
    ! [VarCurr: state_type] :
      ( v124047(VarCurr)
    <=> ( v124048(VarCurr)
        | v124040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15396,axiom,
    ! [VarCurr: state_type] :
      ( v124048(VarCurr)
    <=> ( v124049(VarCurr)
        | v124052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15395,axiom,
    ! [VarCurr: state_type] :
      ( v124052(VarCurr)
    <=> ( v124053(VarCurr)
        & v124054(VarCurr) ) ) ).

tff(writeUnaryOperator_8526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124054(VarCurr)
    <=> v124038(VarCurr) ) ).

tff(writeUnaryOperator_8525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124053(VarCurr)
    <=> v123555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15394,axiom,
    ! [VarCurr: state_type] :
      ( v124049(VarCurr)
    <=> ( v124050(VarCurr)
        | v124051(VarCurr) ) ) ).

tff(writeUnaryOperator_8524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124051(VarCurr)
    <=> v124032(VarCurr) ) ).

tff(writeUnaryOperator_8523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124050(VarCurr)
    <=> v124030(VarCurr) ) ).

tff(addAssignment_70656,axiom,
    ! [VarCurr: state_type] :
      ( v124040(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_70655,axiom,
    ! [VarCurr: state_type] :
      ( v124038(VarCurr)
    <=> v112643(VarCurr,12) ) ).

tff(addAssignment_70654,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,12)
    <=> v115202(VarCurr,12) ) ).

tff(addAssignment_70653,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,12)
    <=> v115186(VarCurr,12) ) ).

tff(addAssignment_70652,axiom,
    ! [VarCurr: state_type] :
      ( v124032(VarCurr)
    <=> v112528(VarCurr,12) ) ).

tff(addAssignment_70651,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,12)
    <=> v120828(VarCurr,4) ) ).

tff(addAssignment_70650,axiom,
    ! [VarCurr: state_type] :
      ( v124030(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15393,axiom,
    ! [VarCurr: state_type] :
      ( v123555(VarCurr)
    <=> ( v124027(VarCurr)
        & v124028(VarCurr) ) ) ).

tff(writeUnaryOperator_8522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124028(VarCurr)
    <=> v124025(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1222,axiom,
    ! [VarCurr: state_type] :
      ( v124027(VarCurr)
    <=> ( ( v123557(VarCurr,5)
        <=> $false )
        & ( v123557(VarCurr,4)
        <=> $false )
        & ( v123557(VarCurr,3)
        <=> $false )
        & ( v123557(VarCurr,2)
        <=> $false )
        & ( v123557(VarCurr,1)
        <=> $false )
        & ( v123557(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70649,axiom,
    ! [VarCurr: state_type] :
      ( v124025(VarCurr)
    <=> v115139(VarCurr,12) ) ).

tff(addAssignment_70648,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,12)
    <=> v115159(VarCurr,12) ) ).

tff(addAssignment_70647,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,12)
    <=> v115142(VarCurr,12) ) ).

tff(addAssignment_70646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v123557(VarCurr,B)
      <=> v123559(VarCurr,B) ) ) ).

tff(addAssignment_70645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v123559(VarCurr,B)
      <=> v123561(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124008(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v123561(VarNext,B)
            <=> v123561(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1607,axiom,
    ! [VarNext: state_type] :
      ( v124008(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v123561(VarNext,B)
          <=> v124018(VarNext,B) ) ) ) ).

tff(addAssignment_70644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124018(VarNext,B)
          <=> v124016(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124016(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1150,axiom,
    ! [VarCurr: state_type] :
      ( v124019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v124016(VarCurr,B)
          <=> v123571(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15392,axiom,
    ! [VarCurr: state_type] :
      ( v124019(VarCurr)
    <=> ( v124020(VarCurr)
        & v124021(VarCurr) ) ) ).

tff(writeUnaryOperator_8521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124021(VarCurr)
    <=> v123567(VarCurr) ) ).

tff(writeUnaryOperator_8520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v124020(VarCurr)
    <=> v123563(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124008(VarNext)
      <=> v124009(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124009(VarNext)
      <=> ( v124010(VarNext)
          & v124001(VarNext) ) ) ) ).

tff(writeUnaryOperator_8519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v124010(VarNext)
      <=> v124012(VarNext) ) ) ).

tff(addAssignment_70643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v124012(VarNext)
      <=> v124001(VarCurr) ) ) ).

tff(addAssignment_70642,axiom,
    ! [VarCurr: state_type] :
      ( v124001(VarCurr)
    <=> v124003(VarCurr) ) ).

tff(addAssignment_70641,axiom,
    ! [VarCurr: state_type] :
      ( v124003(VarCurr)
    <=> v124005(VarCurr) ) ).

tff(addAssignment_70640,axiom,
    ! [VarCurr: state_type] :
      ( v124005(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_70639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v123571(VarCurr,B)
      <=> v123573(VarCurr,B) ) ) ).

tff(addAssignment_70638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v123573(VarCurr,B)
      <=> v123575(VarCurr,B) ) ) ).

tff(addAssignment_70637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v123575(VarCurr,B)
      <=> v123577(VarCurr,B) ) ) ).

tff(addAssignment_70636,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,0)
    <=> v123996(VarCurr) ) ).

tff(addAssignment_70635,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,1)
    <=> v123991(VarCurr) ) ).

tff(addAssignment_70634,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,2)
    <=> v123986(VarCurr) ) ).

tff(addAssignment_70633,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,3)
    <=> v123981(VarCurr) ) ).

tff(addAssignment_70632,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,4)
    <=> v123976(VarCurr) ) ).

tff(addAssignment_70631,axiom,
    ! [VarCurr: state_type] :
      ( v123577(VarCurr,5)
    <=> v123833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15389,axiom,
    ! [VarCurr: state_type] :
      ( v123996(VarCurr)
    <=> ( v123997(VarCurr)
        & v123999(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15388,axiom,
    ! [VarCurr: state_type] :
      ( v123999(VarCurr)
    <=> ( v123788(VarCurr,0)
        | v123845(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15387,axiom,
    ! [VarCurr: state_type] :
      ( v123997(VarCurr)
    <=> ( v123922(VarCurr)
        | v123998(VarCurr) ) ) ).

tff(writeUnaryOperator_8518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123998(VarCurr)
    <=> v123845(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15386,axiom,
    ! [VarCurr: state_type] :
      ( v123991(VarCurr)
    <=> ( v123992(VarCurr)
        & v123995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15385,axiom,
    ! [VarCurr: state_type] :
      ( v123995(VarCurr)
    <=> ( v123844(VarCurr)
        | v123916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15384,axiom,
    ! [VarCurr: state_type] :
      ( v123992(VarCurr)
    <=> ( v123993(VarCurr)
        | v123994(VarCurr) ) ) ).

tff(writeUnaryOperator_8517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123994(VarCurr)
    <=> v123916(VarCurr) ) ).

tff(writeUnaryOperator_8516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123993(VarCurr)
    <=> v123844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15383,axiom,
    ! [VarCurr: state_type] :
      ( v123986(VarCurr)
    <=> ( v123987(VarCurr)
        & v123990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15382,axiom,
    ! [VarCurr: state_type] :
      ( v123990(VarCurr)
    <=> ( v123842(VarCurr)
        | v123927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15381,axiom,
    ! [VarCurr: state_type] :
      ( v123987(VarCurr)
    <=> ( v123988(VarCurr)
        | v123989(VarCurr) ) ) ).

tff(writeUnaryOperator_8515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123989(VarCurr)
    <=> v123927(VarCurr) ) ).

tff(writeUnaryOperator_8514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123988(VarCurr)
    <=> v123842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15380,axiom,
    ! [VarCurr: state_type] :
      ( v123981(VarCurr)
    <=> ( v123982(VarCurr)
        & v123985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15379,axiom,
    ! [VarCurr: state_type] :
      ( v123985(VarCurr)
    <=> ( v123840(VarCurr)
        | v123939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15378,axiom,
    ! [VarCurr: state_type] :
      ( v123982(VarCurr)
    <=> ( v123983(VarCurr)
        | v123984(VarCurr) ) ) ).

tff(writeUnaryOperator_8513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123984(VarCurr)
    <=> v123939(VarCurr) ) ).

tff(writeUnaryOperator_8512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123983(VarCurr)
    <=> v123840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15377,axiom,
    ! [VarCurr: state_type] :
      ( v123976(VarCurr)
    <=> ( v123977(VarCurr)
        & v123980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15376,axiom,
    ! [VarCurr: state_type] :
      ( v123980(VarCurr)
    <=> ( v123838(VarCurr)
        | v123951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15375,axiom,
    ! [VarCurr: state_type] :
      ( v123977(VarCurr)
    <=> ( v123978(VarCurr)
        | v123979(VarCurr) ) ) ).

tff(writeUnaryOperator_8511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123979(VarCurr)
    <=> v123951(VarCurr) ) ).

tff(writeUnaryOperator_8510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123978(VarCurr)
    <=> v123838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15374,axiom,
    ! [VarCurr: state_type] :
      ( v123833(VarCurr)
    <=> ( v123834(VarCurr)
        & v123975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15373,axiom,
    ! [VarCurr: state_type] :
      ( v123975(VarCurr)
    <=> ( v123836(VarCurr)
        | v123964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15372,axiom,
    ! [VarCurr: state_type] :
      ( v123834(VarCurr)
    <=> ( v123835(VarCurr)
        | v123963(VarCurr) ) ) ).

tff(writeUnaryOperator_8509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123963(VarCurr)
    <=> v123964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15371,axiom,
    ! [VarCurr: state_type] :
      ( v123964(VarCurr)
    <=> ( v123965(VarCurr)
        & v123974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5466,axiom,
    ! [VarCurr: state_type] :
      ( v123974(VarCurr)
    <=> ( v123967(VarCurr)
        | v123845(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15370,axiom,
    ! [VarCurr: state_type] :
      ( v123965(VarCurr)
    <=> ( v123966(VarCurr)
        | v123973(VarCurr) ) ) ).

tff(writeUnaryOperator_8508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123973(VarCurr)
    <=> v123845(VarCurr,5) ) ).

tff(writeUnaryOperator_8507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123966(VarCurr)
    <=> v123967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15369,axiom,
    ! [VarCurr: state_type] :
      ( v123967(VarCurr)
    <=> ( v123968(VarCurr)
        & v123971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15368,axiom,
    ! [VarCurr: state_type] :
      ( v123971(VarCurr)
    <=> ( v123970(VarCurr)
        | v123972(VarCurr) ) ) ).

tff(writeUnaryOperator_8506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123972(VarCurr)
    <=> v123788(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5465,axiom,
    ! [VarCurr: state_type] :
      ( v123968(VarCurr)
    <=> ( v123969(VarCurr)
        | v123788(VarCurr,5) ) ) ).

tff(writeUnaryOperator_8505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123969(VarCurr)
    <=> v123970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15367,axiom,
    ! [VarCurr: state_type] :
      ( v123970(VarCurr)
    <=> ( v123957(VarCurr)
        & v123959(VarCurr) ) ) ).

tff(writeUnaryOperator_8504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123835(VarCurr)
    <=> v123836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15366,axiom,
    ! [VarCurr: state_type] :
      ( v123836(VarCurr)
    <=> ( v123837(VarCurr)
        | v123962(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5464,axiom,
    ! [VarCurr: state_type] :
      ( v123962(VarCurr)
    <=> ( v123954(VarCurr)
        & v123845(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15365,axiom,
    ! [VarCurr: state_type] :
      ( v123837(VarCurr)
    <=> ( v123838(VarCurr)
        & v123951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15364,axiom,
    ! [VarCurr: state_type] :
      ( v123951(VarCurr)
    <=> ( v123952(VarCurr)
        & v123961(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5463,axiom,
    ! [VarCurr: state_type] :
      ( v123961(VarCurr)
    <=> ( v123954(VarCurr)
        | v123845(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15363,axiom,
    ! [VarCurr: state_type] :
      ( v123952(VarCurr)
    <=> ( v123953(VarCurr)
        | v123960(VarCurr) ) ) ).

tff(writeUnaryOperator_8503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123960(VarCurr)
    <=> v123845(VarCurr,4) ) ).

tff(writeUnaryOperator_8502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123953(VarCurr)
    <=> v123954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15362,axiom,
    ! [VarCurr: state_type] :
      ( v123954(VarCurr)
    <=> ( v123955(VarCurr)
        & v123958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15361,axiom,
    ! [VarCurr: state_type] :
      ( v123958(VarCurr)
    <=> ( v123957(VarCurr)
        | v123959(VarCurr) ) ) ).

tff(writeUnaryOperator_8501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123959(VarCurr)
    <=> v123788(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5462,axiom,
    ! [VarCurr: state_type] :
      ( v123955(VarCurr)
    <=> ( v123956(VarCurr)
        | v123788(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123956(VarCurr)
    <=> v123957(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15360,axiom,
    ! [VarCurr: state_type] :
      ( v123957(VarCurr)
    <=> ( v123945(VarCurr)
        & v123947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15359,axiom,
    ! [VarCurr: state_type] :
      ( v123838(VarCurr)
    <=> ( v123839(VarCurr)
        | v123950(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5461,axiom,
    ! [VarCurr: state_type] :
      ( v123950(VarCurr)
    <=> ( v123942(VarCurr)
        & v123845(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15358,axiom,
    ! [VarCurr: state_type] :
      ( v123839(VarCurr)
    <=> ( v123840(VarCurr)
        & v123939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15357,axiom,
    ! [VarCurr: state_type] :
      ( v123939(VarCurr)
    <=> ( v123940(VarCurr)
        & v123949(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5460,axiom,
    ! [VarCurr: state_type] :
      ( v123949(VarCurr)
    <=> ( v123942(VarCurr)
        | v123845(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15356,axiom,
    ! [VarCurr: state_type] :
      ( v123940(VarCurr)
    <=> ( v123941(VarCurr)
        | v123948(VarCurr) ) ) ).

tff(writeUnaryOperator_8499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123948(VarCurr)
    <=> v123845(VarCurr,3) ) ).

tff(writeUnaryOperator_8498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123941(VarCurr)
    <=> v123942(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15355,axiom,
    ! [VarCurr: state_type] :
      ( v123942(VarCurr)
    <=> ( v123943(VarCurr)
        & v123946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15354,axiom,
    ! [VarCurr: state_type] :
      ( v123946(VarCurr)
    <=> ( v123945(VarCurr)
        | v123947(VarCurr) ) ) ).

tff(writeUnaryOperator_8497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123947(VarCurr)
    <=> v123788(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5459,axiom,
    ! [VarCurr: state_type] :
      ( v123943(VarCurr)
    <=> ( v123944(VarCurr)
        | v123788(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123944(VarCurr)
    <=> v123945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15353,axiom,
    ! [VarCurr: state_type] :
      ( v123945(VarCurr)
    <=> ( v123933(VarCurr)
        & v123935(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15352,axiom,
    ! [VarCurr: state_type] :
      ( v123840(VarCurr)
    <=> ( v123841(VarCurr)
        | v123938(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5458,axiom,
    ! [VarCurr: state_type] :
      ( v123938(VarCurr)
    <=> ( v123930(VarCurr)
        & v123845(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15351,axiom,
    ! [VarCurr: state_type] :
      ( v123841(VarCurr)
    <=> ( v123842(VarCurr)
        & v123927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15350,axiom,
    ! [VarCurr: state_type] :
      ( v123927(VarCurr)
    <=> ( v123928(VarCurr)
        & v123937(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5457,axiom,
    ! [VarCurr: state_type] :
      ( v123937(VarCurr)
    <=> ( v123930(VarCurr)
        | v123845(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15349,axiom,
    ! [VarCurr: state_type] :
      ( v123928(VarCurr)
    <=> ( v123929(VarCurr)
        | v123936(VarCurr) ) ) ).

tff(writeUnaryOperator_8495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123936(VarCurr)
    <=> v123845(VarCurr,2) ) ).

tff(writeUnaryOperator_8494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123929(VarCurr)
    <=> v123930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15348,axiom,
    ! [VarCurr: state_type] :
      ( v123930(VarCurr)
    <=> ( v123931(VarCurr)
        & v123934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15347,axiom,
    ! [VarCurr: state_type] :
      ( v123934(VarCurr)
    <=> ( v123933(VarCurr)
        | v123935(VarCurr) ) ) ).

tff(writeUnaryOperator_8493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123935(VarCurr)
    <=> v123788(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5456,axiom,
    ! [VarCurr: state_type] :
      ( v123931(VarCurr)
    <=> ( v123932(VarCurr)
        | v123788(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123932(VarCurr)
    <=> v123933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15346,axiom,
    ! [VarCurr: state_type] :
      ( v123933(VarCurr)
    <=> ( v123922(VarCurr)
        & v123923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15345,axiom,
    ! [VarCurr: state_type] :
      ( v123842(VarCurr)
    <=> ( v123843(VarCurr)
        | v123926(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5455,axiom,
    ! [VarCurr: state_type] :
      ( v123926(VarCurr)
    <=> ( v123919(VarCurr)
        & v123845(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15344,axiom,
    ! [VarCurr: state_type] :
      ( v123843(VarCurr)
    <=> ( v123844(VarCurr)
        & v123916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15343,axiom,
    ! [VarCurr: state_type] :
      ( v123916(VarCurr)
    <=> ( v123917(VarCurr)
        & v123925(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5454,axiom,
    ! [VarCurr: state_type] :
      ( v123925(VarCurr)
    <=> ( v123919(VarCurr)
        | v123845(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15342,axiom,
    ! [VarCurr: state_type] :
      ( v123917(VarCurr)
    <=> ( v123918(VarCurr)
        | v123924(VarCurr) ) ) ).

tff(writeUnaryOperator_8491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123924(VarCurr)
    <=> v123845(VarCurr,1) ) ).

tff(writeUnaryOperator_8490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123918(VarCurr)
    <=> v123919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15341,axiom,
    ! [VarCurr: state_type] :
      ( v123919(VarCurr)
    <=> ( v123920(VarCurr)
        & v123921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15340,axiom,
    ! [VarCurr: state_type] :
      ( v123921(VarCurr)
    <=> ( v123922(VarCurr)
        | v123923(VarCurr) ) ) ).

tff(writeUnaryOperator_8489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123923(VarCurr)
    <=> v123788(VarCurr,1) ) ).

tff(writeUnaryOperator_8488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123922(VarCurr)
    <=> v123788(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5453,axiom,
    ! [VarCurr: state_type] :
      ( v123920(VarCurr)
    <=> ( v123788(VarCurr,0)
        | v123788(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15339,axiom,
    ! [VarCurr: state_type] :
      ( v123844(VarCurr)
    <=> ( v123788(VarCurr,0)
        & v123845(VarCurr,0) ) ) ).

tff(addAssignment_70630,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,0)
    <=> v123911(VarCurr) ) ).

tff(addAssignment_70629,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,1)
    <=> v123906(VarCurr) ) ).

tff(addAssignment_70628,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,2)
    <=> v123901(VarCurr) ) ).

tff(addAssignment_70627,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,3)
    <=> v123896(VarCurr) ) ).

tff(addAssignment_70626,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,4)
    <=> v123891(VarCurr) ) ).

tff(addAssignment_70625,axiom,
    ! [VarCurr: state_type] :
      ( v123845(VarCurr,5)
    <=> v123847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15338,axiom,
    ! [VarCurr: state_type] :
      ( v123911(VarCurr)
    <=> ( v123912(VarCurr)
        & v123915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15337,axiom,
    ! [VarCurr: state_type] :
      ( v123915(VarCurr)
    <=> ( v123557(VarCurr,0)
        | v123859(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15336,axiom,
    ! [VarCurr: state_type] :
      ( v123912(VarCurr)
    <=> ( v123913(VarCurr)
        | v123914(VarCurr) ) ) ).

tff(writeUnaryOperator_8487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123914(VarCurr)
    <=> v123859(VarCurr,0) ) ).

tff(writeUnaryOperator_8486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123913(VarCurr)
    <=> v123557(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15335,axiom,
    ! [VarCurr: state_type] :
      ( v123906(VarCurr)
    <=> ( v123907(VarCurr)
        & v123910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15334,axiom,
    ! [VarCurr: state_type] :
      ( v123910(VarCurr)
    <=> ( v123858(VarCurr)
        | v123860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15333,axiom,
    ! [VarCurr: state_type] :
      ( v123907(VarCurr)
    <=> ( v123908(VarCurr)
        | v123909(VarCurr) ) ) ).

tff(writeUnaryOperator_8485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123909(VarCurr)
    <=> v123860(VarCurr) ) ).

tff(writeUnaryOperator_8484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123908(VarCurr)
    <=> v123858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15332,axiom,
    ! [VarCurr: state_type] :
      ( v123901(VarCurr)
    <=> ( v123902(VarCurr)
        & v123905(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15331,axiom,
    ! [VarCurr: state_type] :
      ( v123905(VarCurr)
    <=> ( v123856(VarCurr)
        | v123866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15330,axiom,
    ! [VarCurr: state_type] :
      ( v123902(VarCurr)
    <=> ( v123903(VarCurr)
        | v123904(VarCurr) ) ) ).

tff(writeUnaryOperator_8483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123904(VarCurr)
    <=> v123866(VarCurr) ) ).

tff(writeUnaryOperator_8482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123903(VarCurr)
    <=> v123856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15329,axiom,
    ! [VarCurr: state_type] :
      ( v123896(VarCurr)
    <=> ( v123897(VarCurr)
        & v123900(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15328,axiom,
    ! [VarCurr: state_type] :
      ( v123900(VarCurr)
    <=> ( v123854(VarCurr)
        | v123872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15327,axiom,
    ! [VarCurr: state_type] :
      ( v123897(VarCurr)
    <=> ( v123898(VarCurr)
        | v123899(VarCurr) ) ) ).

tff(writeUnaryOperator_8481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123899(VarCurr)
    <=> v123872(VarCurr) ) ).

tff(writeUnaryOperator_8480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123898(VarCurr)
    <=> v123854(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15326,axiom,
    ! [VarCurr: state_type] :
      ( v123891(VarCurr)
    <=> ( v123892(VarCurr)
        & v123895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15325,axiom,
    ! [VarCurr: state_type] :
      ( v123895(VarCurr)
    <=> ( v123852(VarCurr)
        | v123878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15324,axiom,
    ! [VarCurr: state_type] :
      ( v123892(VarCurr)
    <=> ( v123893(VarCurr)
        | v123894(VarCurr) ) ) ).

tff(writeUnaryOperator_8479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123894(VarCurr)
    <=> v123878(VarCurr) ) ).

tff(writeUnaryOperator_8478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123893(VarCurr)
    <=> v123852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15323,axiom,
    ! [VarCurr: state_type] :
      ( v123847(VarCurr)
    <=> ( v123848(VarCurr)
        & v123890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15322,axiom,
    ! [VarCurr: state_type] :
      ( v123890(VarCurr)
    <=> ( v123850(VarCurr)
        | v123885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15321,axiom,
    ! [VarCurr: state_type] :
      ( v123848(VarCurr)
    <=> ( v123849(VarCurr)
        | v123884(VarCurr) ) ) ).

tff(writeUnaryOperator_8477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123884(VarCurr)
    <=> v123885(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15320,axiom,
    ! [VarCurr: state_type] :
      ( v123885(VarCurr)
    <=> ( v123886(VarCurr)
        & v123889(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5452,axiom,
    ! [VarCurr: state_type] :
      ( v123889(VarCurr)
    <=> ( v123557(VarCurr,5)
        | v123859(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15319,axiom,
    ! [VarCurr: state_type] :
      ( v123886(VarCurr)
    <=> ( v123887(VarCurr)
        | v123888(VarCurr) ) ) ).

tff(writeUnaryOperator_8476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123888(VarCurr)
    <=> v123859(VarCurr,5) ) ).

tff(writeUnaryOperator_8475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123887(VarCurr)
    <=> v123557(VarCurr,5) ) ).

tff(writeUnaryOperator_8474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123849(VarCurr)
    <=> v123850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15318,axiom,
    ! [VarCurr: state_type] :
      ( v123850(VarCurr)
    <=> ( v123851(VarCurr)
        | v123883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5451,axiom,
    ! [VarCurr: state_type] :
      ( v123883(VarCurr)
    <=> ( v123557(VarCurr,4)
        & v123859(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15317,axiom,
    ! [VarCurr: state_type] :
      ( v123851(VarCurr)
    <=> ( v123852(VarCurr)
        & v123878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15316,axiom,
    ! [VarCurr: state_type] :
      ( v123878(VarCurr)
    <=> ( v123879(VarCurr)
        & v123882(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5450,axiom,
    ! [VarCurr: state_type] :
      ( v123882(VarCurr)
    <=> ( v123557(VarCurr,4)
        | v123859(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15315,axiom,
    ! [VarCurr: state_type] :
      ( v123879(VarCurr)
    <=> ( v123880(VarCurr)
        | v123881(VarCurr) ) ) ).

tff(writeUnaryOperator_8473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123881(VarCurr)
    <=> v123859(VarCurr,4) ) ).

tff(writeUnaryOperator_8472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123880(VarCurr)
    <=> v123557(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15314,axiom,
    ! [VarCurr: state_type] :
      ( v123852(VarCurr)
    <=> ( v123853(VarCurr)
        | v123877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5449,axiom,
    ! [VarCurr: state_type] :
      ( v123877(VarCurr)
    <=> ( v123557(VarCurr,3)
        & v123859(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15313,axiom,
    ! [VarCurr: state_type] :
      ( v123853(VarCurr)
    <=> ( v123854(VarCurr)
        & v123872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15312,axiom,
    ! [VarCurr: state_type] :
      ( v123872(VarCurr)
    <=> ( v123873(VarCurr)
        & v123876(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5448,axiom,
    ! [VarCurr: state_type] :
      ( v123876(VarCurr)
    <=> ( v123557(VarCurr,3)
        | v123859(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15311,axiom,
    ! [VarCurr: state_type] :
      ( v123873(VarCurr)
    <=> ( v123874(VarCurr)
        | v123875(VarCurr) ) ) ).

tff(writeUnaryOperator_8471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123875(VarCurr)
    <=> v123859(VarCurr,3) ) ).

tff(writeUnaryOperator_8470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123874(VarCurr)
    <=> v123557(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15310,axiom,
    ! [VarCurr: state_type] :
      ( v123854(VarCurr)
    <=> ( v123855(VarCurr)
        | v123871(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5447,axiom,
    ! [VarCurr: state_type] :
      ( v123871(VarCurr)
    <=> ( v123557(VarCurr,2)
        & v123859(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15309,axiom,
    ! [VarCurr: state_type] :
      ( v123855(VarCurr)
    <=> ( v123856(VarCurr)
        & v123866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15308,axiom,
    ! [VarCurr: state_type] :
      ( v123866(VarCurr)
    <=> ( v123867(VarCurr)
        & v123870(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5446,axiom,
    ! [VarCurr: state_type] :
      ( v123870(VarCurr)
    <=> ( v123557(VarCurr,2)
        | v123859(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15307,axiom,
    ! [VarCurr: state_type] :
      ( v123867(VarCurr)
    <=> ( v123868(VarCurr)
        | v123869(VarCurr) ) ) ).

tff(writeUnaryOperator_8469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123869(VarCurr)
    <=> v123859(VarCurr,2) ) ).

tff(writeUnaryOperator_8468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123868(VarCurr)
    <=> v123557(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15306,axiom,
    ! [VarCurr: state_type] :
      ( v123856(VarCurr)
    <=> ( v123857(VarCurr)
        | v123865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5445,axiom,
    ! [VarCurr: state_type] :
      ( v123865(VarCurr)
    <=> ( v123557(VarCurr,1)
        & v123859(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15305,axiom,
    ! [VarCurr: state_type] :
      ( v123857(VarCurr)
    <=> ( v123858(VarCurr)
        & v123860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15304,axiom,
    ! [VarCurr: state_type] :
      ( v123860(VarCurr)
    <=> ( v123861(VarCurr)
        & v123864(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5444,axiom,
    ! [VarCurr: state_type] :
      ( v123864(VarCurr)
    <=> ( v123557(VarCurr,1)
        | v123859(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15303,axiom,
    ! [VarCurr: state_type] :
      ( v123861(VarCurr)
    <=> ( v123862(VarCurr)
        | v123863(VarCurr) ) ) ).

tff(writeUnaryOperator_8467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123863(VarCurr)
    <=> v123859(VarCurr,1) ) ).

tff(writeUnaryOperator_8466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123862(VarCurr)
    <=> v123557(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15302,axiom,
    ! [VarCurr: state_type] :
      ( v123858(VarCurr)
    <=> ( v123557(VarCurr,0)
        & v123859(VarCurr,0) ) ) ).

tff(addAssignment_70624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v123859(VarCurr,B)
      <=> v123579(VarCurr,B) ) ) ).

tff(addAssignment_70623,axiom,
    ! [VarCurr: state_type] :
      ( ( v123859(VarCurr,5)
      <=> $false )
      & ( v123859(VarCurr,4)
      <=> $false )
      & ( v123859(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_70622,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,5)
    <=> v123825(VarCurr,5) ) ).

tff(addAssignment_70621,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,4)
    <=> v123825(VarCurr,4) ) ).

tff(addAssignment_70620,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,3)
    <=> v123825(VarCurr,3) ) ).

tff(addAssignment_70619,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,2)
    <=> v123825(VarCurr,2) ) ).

tff(addAssignment_70618,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,1)
    <=> v123825(VarCurr,1) ) ).

tff(addAssignment_70617,axiom,
    ! [VarCurr: state_type] :
      ( v123788(VarCurr,0)
    <=> v123825(VarCurr,0) ) ).

tff(addAssignment_70616,axiom,
    ! [VarCurr: state_type] :
      ( v123825(VarCurr,0)
    <=> v123826(VarCurr) ) ).

tff(addAssignment_70615,axiom,
    ! [VarCurr: state_type] :
      ( ( v123825(VarCurr,5)
      <=> $false )
      & ( v123825(VarCurr,4)
      <=> $false )
      & ( v123825(VarCurr,3)
      <=> $false )
      & ( v123825(VarCurr,2)
      <=> $false )
      & ( v123825(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15301,axiom,
    ! [VarCurr: state_type] :
      ( v123826(VarCurr)
    <=> ( v123827(VarCurr)
        | v123824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15300,axiom,
    ! [VarCurr: state_type] :
      ( v123827(VarCurr)
    <=> ( v123828(VarCurr)
        | v123822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15299,axiom,
    ! [VarCurr: state_type] :
      ( v123828(VarCurr)
    <=> ( v123829(VarCurr)
        | v123820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15298,axiom,
    ! [VarCurr: state_type] :
      ( v123829(VarCurr)
    <=> ( v123830(VarCurr)
        | v123810(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15297,axiom,
    ! [VarCurr: state_type] :
      ( v123830(VarCurr)
    <=> ( v123790(VarCurr)
        | v123800(VarCurr) ) ) ).

tff(addAssignment_70614,axiom,
    ! [VarCurr: state_type] :
      ( v123824(VarCurr)
    <=> v113911(VarCurr,12) ) ).

tff(addAssignment_70613,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,12)
    <=> v113913(VarCurr,12) ) ).

tff(addAssignment_70612,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,12)
    <=> v113915(VarCurr,12) ) ).

tff(addAssignment_70611,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,12)
    <=> v113935(VarCurr,12) ) ).

tff(addAssignment_70610,axiom,
    ! [VarCurr: state_type] :
      ( v123822(VarCurr)
    <=> v113107(VarCurr,12) ) ).

tff(addAssignment_70609,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,12)
    <=> v113143(VarCurr,12) ) ).

tff(addAssignment_70608,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,12)
    <=> v113110(VarCurr,12) ) ).

tff(addAssignment_70607,axiom,
    ! [VarCurr: state_type] :
      ( v123820(VarCurr)
    <=> v113100(VarCurr,12) ) ).

tff(addAssignment_70606,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,12)
    <=> v113101(VarCurr,12) ) ).

tff(addAssignment_70605,axiom,
    ! [VarCurr: state_type] :
      ( v123810(VarCurr)
    <=> v113810(VarCurr,12) ) ).

tff(addAssignment_70604,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,12)
    <=> v113812(VarCurr,12) ) ).

tff(addAssignment_70603,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,12)
    <=> v113814(VarCurr,12) ) ).

tff(addAssignment_70602,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,12)
    <=> v113816(VarCurr,12) ) ).

tff(addAssignment_70601,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,12)
    <=> v113818(VarCurr,12) ) ).

tff(addAssignment_70600,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,12)
    <=> v123812(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_1606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123813(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v123812(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1606,axiom,
    ! [VarNext: state_type] :
      ( v123813(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v123812(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123813(VarNext)
      <=> v123814(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123814(VarNext)
      <=> ( v123816(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123816(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_70599,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,12)
    <=> v113830(VarCurr,12) ) ).

tff(addAssignment_70598,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,12)
    <=> v113832(VarCurr,12) ) ).

tff(addAssignment_70597,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,12)
    <=> v113834(VarCurr,12) ) ).

tff(addAssignment_70596,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,12)
    <=> v113873(VarCurr,12) ) ).

tff(addAssignment_70595,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,12)
    <=> v113856(VarCurr,12) ) ).

tff(addAssignment_70594,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,12)
    <=> v113837(VarCurr,12) ) ).

tff(addAssignment_70593,axiom,
    ! [VarCurr: state_type] :
      ( v123800(VarCurr)
    <=> v113020(VarCurr,12) ) ).

tff(addAssignment_70592,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,12)
    <=> v113022(VarCurr,12) ) ).

tff(addAssignment_70591,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,12)
    <=> v113024(VarCurr,12) ) ).

tff(addAssignment_70590,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,12)
    <=> v113026(VarCurr,12) ) ).

tff(addAssignment_70589,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,12)
    <=> v113028(VarCurr,12) ) ).

tff(addAssignment_70588,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,12)
    <=> v123802(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_1605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123803(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v123802(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1605,axiom,
    ! [VarNext: state_type] :
      ( v123803(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v123802(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123803(VarNext)
      <=> v123804(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123804(VarNext)
      <=> ( v123806(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123806(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_70587,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,12)
    <=> v113040(VarCurr,12) ) ).

tff(addAssignment_70586,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,12)
    <=> v113042(VarCurr,12) ) ).

tff(addAssignment_70585,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,12)
    <=> v113044(VarCurr,12) ) ).

tff(addAssignment_70584,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,12)
    <=> v113045(VarCurr,12) ) ).

tff(addAssignment_70583,axiom,
    ! [VarCurr: state_type] :
      ( v123790(VarCurr)
    <=> v112940(VarCurr,12) ) ).

tff(addAssignment_70582,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,12)
    <=> v112942(VarCurr,12) ) ).

tff(addAssignment_70581,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,12)
    <=> v112944(VarCurr,12) ) ).

tff(addAssignment_70580,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,12)
    <=> v112946(VarCurr,12) ) ).

tff(addAssignment_70579,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,12)
    <=> v112948(VarCurr,12) ) ).

tff(addAssignment_70578,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,12)
    <=> v123792(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_1604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123793(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v123792(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1604,axiom,
    ! [VarNext: state_type] :
      ( v123793(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v123792(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123793(VarNext)
      <=> v123794(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123794(VarNext)
      <=> ( v123796(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123796(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_70577,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,12)
    <=> v112960(VarCurr,12) ) ).

tff(addAssignment_70576,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,12)
    <=> v112962(VarCurr,12) ) ).

tff(addAssignment_70575,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,12)
    <=> v112964(VarCurr,12) ) ).

tff(addAssignment_70574,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,12)
    <=> v112965(VarCurr,12) ) ).

tff(addAssignment_70573,axiom,
    ! [VarCurr: state_type] :
      ( v123579(VarCurr,2)
    <=> v123594(VarCurr,2) ) ).

tff(addAssignment_70572,axiom,
    ! [VarCurr: state_type] :
      ( v123579(VarCurr,1)
    <=> v123594(VarCurr,1) ) ).

tff(addAssignment_70571,axiom,
    ! [VarCurr: state_type] :
      ( v123579(VarCurr,0)
    <=> v123594(VarCurr,0) ) ).

tff(addAssignment_70570,axiom,
    ! [VarCurr: state_type] :
      ( v123594(VarCurr,0)
    <=> v123782(VarCurr) ) ).

tff(addAssignment_70569,axiom,
    ! [VarCurr: state_type] :
      ( v123594(VarCurr,1)
    <=> v123777(VarCurr) ) ).

tff(addAssignment_70568,axiom,
    ! [VarCurr: state_type] :
      ( v123594(VarCurr,2)
    <=> v123596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15290,axiom,
    ! [VarCurr: state_type] :
      ( v123782(VarCurr)
    <=> ( v123783(VarCurr)
        & v123786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15289,axiom,
    ! [VarCurr: state_type] :
      ( v123786(VarCurr)
    <=> ( v123602(VarCurr,0)
        | v123763(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15288,axiom,
    ! [VarCurr: state_type] :
      ( v123783(VarCurr)
    <=> ( v123784(VarCurr)
        | v123785(VarCurr) ) ) ).

tff(writeUnaryOperator_8462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123785(VarCurr)
    <=> v123763(VarCurr,0) ) ).

tff(writeUnaryOperator_8461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123784(VarCurr)
    <=> v123602(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15287,axiom,
    ! [VarCurr: state_type] :
      ( v123777(VarCurr)
    <=> ( v123778(VarCurr)
        & v123781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15286,axiom,
    ! [VarCurr: state_type] :
      ( v123781(VarCurr)
    <=> ( v123601(VarCurr)
        | v123764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15285,axiom,
    ! [VarCurr: state_type] :
      ( v123778(VarCurr)
    <=> ( v123779(VarCurr)
        | v123780(VarCurr) ) ) ).

tff(writeUnaryOperator_8460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123780(VarCurr)
    <=> v123764(VarCurr) ) ).

tff(writeUnaryOperator_8459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123779(VarCurr)
    <=> v123601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15284,axiom,
    ! [VarCurr: state_type] :
      ( v123596(VarCurr)
    <=> ( v123597(VarCurr)
        & v123776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15283,axiom,
    ! [VarCurr: state_type] :
      ( v123776(VarCurr)
    <=> ( v123599(VarCurr)
        | v123771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15282,axiom,
    ! [VarCurr: state_type] :
      ( v123597(VarCurr)
    <=> ( v123598(VarCurr)
        | v123770(VarCurr) ) ) ).

tff(writeUnaryOperator_8458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123770(VarCurr)
    <=> v123771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15281,axiom,
    ! [VarCurr: state_type] :
      ( v123771(VarCurr)
    <=> ( v123772(VarCurr)
        & v123775(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5443,axiom,
    ! [VarCurr: state_type] :
      ( v123775(VarCurr)
    <=> ( v123602(VarCurr,2)
        | v123763(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15280,axiom,
    ! [VarCurr: state_type] :
      ( v123772(VarCurr)
    <=> ( v123773(VarCurr)
        | v123774(VarCurr) ) ) ).

tff(writeUnaryOperator_8457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123774(VarCurr)
    <=> v123763(VarCurr,2) ) ).

tff(writeUnaryOperator_8456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123773(VarCurr)
    <=> v123602(VarCurr,2) ) ).

tff(writeUnaryOperator_8455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123598(VarCurr)
    <=> v123599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15279,axiom,
    ! [VarCurr: state_type] :
      ( v123599(VarCurr)
    <=> ( v123600(VarCurr)
        | v123769(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5442,axiom,
    ! [VarCurr: state_type] :
      ( v123769(VarCurr)
    <=> ( v123602(VarCurr,1)
        & v123763(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15278,axiom,
    ! [VarCurr: state_type] :
      ( v123600(VarCurr)
    <=> ( v123601(VarCurr)
        & v123764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15277,axiom,
    ! [VarCurr: state_type] :
      ( v123764(VarCurr)
    <=> ( v123765(VarCurr)
        & v123768(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5441,axiom,
    ! [VarCurr: state_type] :
      ( v123768(VarCurr)
    <=> ( v123602(VarCurr,1)
        | v123763(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15276,axiom,
    ! [VarCurr: state_type] :
      ( v123765(VarCurr)
    <=> ( v123766(VarCurr)
        | v123767(VarCurr) ) ) ).

tff(writeUnaryOperator_8454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123767(VarCurr)
    <=> v123763(VarCurr,1) ) ).

tff(writeUnaryOperator_8453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123766(VarCurr)
    <=> v123602(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15275,axiom,
    ! [VarCurr: state_type] :
      ( v123601(VarCurr)
    <=> ( v123602(VarCurr,0)
        & v123763(VarCurr,0) ) ) ).

tff(addAssignment_70567,axiom,
    ! [VarCurr: state_type] :
      ( v123763(VarCurr,0)
    <=> v123593(VarCurr) ) ).

tff(addAssignment_70566,axiom,
    ! [VarCurr: state_type] :
      ( ( v123763(VarCurr,2)
      <=> $false )
      & ( v123763(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70565,axiom,
    ! [VarCurr: state_type] :
      ( v123602(VarCurr,0)
    <=> v123758(VarCurr) ) ).

tff(addAssignment_70564,axiom,
    ! [VarCurr: state_type] :
      ( v123602(VarCurr,1)
    <=> v123753(VarCurr) ) ).

tff(addAssignment_70563,axiom,
    ! [VarCurr: state_type] :
      ( v123602(VarCurr,2)
    <=> v123604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15274,axiom,
    ! [VarCurr: state_type] :
      ( v123758(VarCurr)
    <=> ( v123759(VarCurr)
        & v123762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15273,axiom,
    ! [VarCurr: state_type] :
      ( v123762(VarCurr)
    <=> ( v123610(VarCurr,0)
        | v123739(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15272,axiom,
    ! [VarCurr: state_type] :
      ( v123759(VarCurr)
    <=> ( v123760(VarCurr)
        | v123761(VarCurr) ) ) ).

tff(writeUnaryOperator_8452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123761(VarCurr)
    <=> v123739(VarCurr,0) ) ).

tff(writeUnaryOperator_8451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123760(VarCurr)
    <=> v123610(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15271,axiom,
    ! [VarCurr: state_type] :
      ( v123753(VarCurr)
    <=> ( v123754(VarCurr)
        & v123757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15270,axiom,
    ! [VarCurr: state_type] :
      ( v123757(VarCurr)
    <=> ( v123609(VarCurr)
        | v123740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15269,axiom,
    ! [VarCurr: state_type] :
      ( v123754(VarCurr)
    <=> ( v123755(VarCurr)
        | v123756(VarCurr) ) ) ).

tff(writeUnaryOperator_8450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123756(VarCurr)
    <=> v123740(VarCurr) ) ).

tff(writeUnaryOperator_8449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123755(VarCurr)
    <=> v123609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15268,axiom,
    ! [VarCurr: state_type] :
      ( v123604(VarCurr)
    <=> ( v123605(VarCurr)
        & v123752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15267,axiom,
    ! [VarCurr: state_type] :
      ( v123752(VarCurr)
    <=> ( v123607(VarCurr)
        | v123747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15266,axiom,
    ! [VarCurr: state_type] :
      ( v123605(VarCurr)
    <=> ( v123606(VarCurr)
        | v123746(VarCurr) ) ) ).

tff(writeUnaryOperator_8448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123746(VarCurr)
    <=> v123747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15265,axiom,
    ! [VarCurr: state_type] :
      ( v123747(VarCurr)
    <=> ( v123748(VarCurr)
        & v123751(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5440,axiom,
    ! [VarCurr: state_type] :
      ( v123751(VarCurr)
    <=> ( v123610(VarCurr,2)
        | v123739(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15264,axiom,
    ! [VarCurr: state_type] :
      ( v123748(VarCurr)
    <=> ( v123749(VarCurr)
        | v123750(VarCurr) ) ) ).

tff(writeUnaryOperator_8447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123750(VarCurr)
    <=> v123739(VarCurr,2) ) ).

tff(writeUnaryOperator_8446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123749(VarCurr)
    <=> v123610(VarCurr,2) ) ).

tff(writeUnaryOperator_8445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123606(VarCurr)
    <=> v123607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15263,axiom,
    ! [VarCurr: state_type] :
      ( v123607(VarCurr)
    <=> ( v123608(VarCurr)
        | v123745(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5439,axiom,
    ! [VarCurr: state_type] :
      ( v123745(VarCurr)
    <=> ( v123610(VarCurr,1)
        & v123739(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15262,axiom,
    ! [VarCurr: state_type] :
      ( v123608(VarCurr)
    <=> ( v123609(VarCurr)
        & v123740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15261,axiom,
    ! [VarCurr: state_type] :
      ( v123740(VarCurr)
    <=> ( v123741(VarCurr)
        & v123744(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5438,axiom,
    ! [VarCurr: state_type] :
      ( v123744(VarCurr)
    <=> ( v123610(VarCurr,1)
        | v123739(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15260,axiom,
    ! [VarCurr: state_type] :
      ( v123741(VarCurr)
    <=> ( v123742(VarCurr)
        | v123743(VarCurr) ) ) ).

tff(writeUnaryOperator_8444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123743(VarCurr)
    <=> v123739(VarCurr,1) ) ).

tff(writeUnaryOperator_8443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123742(VarCurr)
    <=> v123610(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15259,axiom,
    ! [VarCurr: state_type] :
      ( v123609(VarCurr)
    <=> ( v123610(VarCurr,0)
        & v123739(VarCurr,0) ) ) ).

tff(addAssignment_70562,axiom,
    ! [VarCurr: state_type] :
      ( v123739(VarCurr,0)
    <=> v123591(VarCurr) ) ).

tff(addAssignment_70561,axiom,
    ! [VarCurr: state_type] :
      ( ( v123739(VarCurr,2)
      <=> $false )
      & ( v123739(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70560,axiom,
    ! [VarCurr: state_type] :
      ( v123610(VarCurr,0)
    <=> v123734(VarCurr) ) ).

tff(addAssignment_70559,axiom,
    ! [VarCurr: state_type] :
      ( v123610(VarCurr,1)
    <=> v123729(VarCurr) ) ).

tff(addAssignment_70558,axiom,
    ! [VarCurr: state_type] :
      ( v123610(VarCurr,2)
    <=> v123612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15258,axiom,
    ! [VarCurr: state_type] :
      ( v123734(VarCurr)
    <=> ( v123735(VarCurr)
        & v123738(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15257,axiom,
    ! [VarCurr: state_type] :
      ( v123738(VarCurr)
    <=> ( v123618(VarCurr,0)
        | v123715(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15256,axiom,
    ! [VarCurr: state_type] :
      ( v123735(VarCurr)
    <=> ( v123736(VarCurr)
        | v123737(VarCurr) ) ) ).

tff(writeUnaryOperator_8442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123737(VarCurr)
    <=> v123715(VarCurr,0) ) ).

tff(writeUnaryOperator_8441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123736(VarCurr)
    <=> v123618(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15255,axiom,
    ! [VarCurr: state_type] :
      ( v123729(VarCurr)
    <=> ( v123730(VarCurr)
        & v123733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15254,axiom,
    ! [VarCurr: state_type] :
      ( v123733(VarCurr)
    <=> ( v123617(VarCurr)
        | v123716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15253,axiom,
    ! [VarCurr: state_type] :
      ( v123730(VarCurr)
    <=> ( v123731(VarCurr)
        | v123732(VarCurr) ) ) ).

tff(writeUnaryOperator_8440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123732(VarCurr)
    <=> v123716(VarCurr) ) ).

tff(writeUnaryOperator_8439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123731(VarCurr)
    <=> v123617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15252,axiom,
    ! [VarCurr: state_type] :
      ( v123612(VarCurr)
    <=> ( v123613(VarCurr)
        & v123728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15251,axiom,
    ! [VarCurr: state_type] :
      ( v123728(VarCurr)
    <=> ( v123615(VarCurr)
        | v123723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15250,axiom,
    ! [VarCurr: state_type] :
      ( v123613(VarCurr)
    <=> ( v123614(VarCurr)
        | v123722(VarCurr) ) ) ).

tff(writeUnaryOperator_8438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123722(VarCurr)
    <=> v123723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15249,axiom,
    ! [VarCurr: state_type] :
      ( v123723(VarCurr)
    <=> ( v123724(VarCurr)
        & v123727(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5437,axiom,
    ! [VarCurr: state_type] :
      ( v123727(VarCurr)
    <=> ( v123618(VarCurr,2)
        | v123715(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15248,axiom,
    ! [VarCurr: state_type] :
      ( v123724(VarCurr)
    <=> ( v123725(VarCurr)
        | v123726(VarCurr) ) ) ).

tff(writeUnaryOperator_8437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123726(VarCurr)
    <=> v123715(VarCurr,2) ) ).

tff(writeUnaryOperator_8436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123725(VarCurr)
    <=> v123618(VarCurr,2) ) ).

tff(writeUnaryOperator_8435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123614(VarCurr)
    <=> v123615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15247,axiom,
    ! [VarCurr: state_type] :
      ( v123615(VarCurr)
    <=> ( v123616(VarCurr)
        | v123721(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5436,axiom,
    ! [VarCurr: state_type] :
      ( v123721(VarCurr)
    <=> ( v123618(VarCurr,1)
        & v123715(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15246,axiom,
    ! [VarCurr: state_type] :
      ( v123616(VarCurr)
    <=> ( v123617(VarCurr)
        & v123716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15245,axiom,
    ! [VarCurr: state_type] :
      ( v123716(VarCurr)
    <=> ( v123717(VarCurr)
        & v123720(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5435,axiom,
    ! [VarCurr: state_type] :
      ( v123720(VarCurr)
    <=> ( v123618(VarCurr,1)
        | v123715(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15244,axiom,
    ! [VarCurr: state_type] :
      ( v123717(VarCurr)
    <=> ( v123718(VarCurr)
        | v123719(VarCurr) ) ) ).

tff(writeUnaryOperator_8434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123719(VarCurr)
    <=> v123715(VarCurr,1) ) ).

tff(writeUnaryOperator_8433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123718(VarCurr)
    <=> v123618(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15243,axiom,
    ! [VarCurr: state_type] :
      ( v123617(VarCurr)
    <=> ( v123618(VarCurr,0)
        & v123715(VarCurr,0) ) ) ).

tff(addAssignment_70557,axiom,
    ! [VarCurr: state_type] :
      ( v123715(VarCurr,0)
    <=> v123589(VarCurr) ) ).

tff(addAssignment_70556,axiom,
    ! [VarCurr: state_type] :
      ( ( v123715(VarCurr,2)
      <=> $false )
      & ( v123715(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70555,axiom,
    ! [VarCurr: state_type] :
      ( v123618(VarCurr,0)
    <=> v123710(VarCurr) ) ).

tff(addAssignment_70554,axiom,
    ! [VarCurr: state_type] :
      ( v123618(VarCurr,1)
    <=> v123705(VarCurr) ) ).

tff(addAssignment_70553,axiom,
    ! [VarCurr: state_type] :
      ( v123618(VarCurr,2)
    <=> v123620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15242,axiom,
    ! [VarCurr: state_type] :
      ( v123710(VarCurr)
    <=> ( v123711(VarCurr)
        & v123714(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15241,axiom,
    ! [VarCurr: state_type] :
      ( v123714(VarCurr)
    <=> ( v123626(VarCurr,0)
        | v123691(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15240,axiom,
    ! [VarCurr: state_type] :
      ( v123711(VarCurr)
    <=> ( v123712(VarCurr)
        | v123713(VarCurr) ) ) ).

tff(writeUnaryOperator_8432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123713(VarCurr)
    <=> v123691(VarCurr,0) ) ).

tff(writeUnaryOperator_8431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123712(VarCurr)
    <=> v123626(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15239,axiom,
    ! [VarCurr: state_type] :
      ( v123705(VarCurr)
    <=> ( v123706(VarCurr)
        & v123709(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15238,axiom,
    ! [VarCurr: state_type] :
      ( v123709(VarCurr)
    <=> ( v123625(VarCurr)
        | v123692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15237,axiom,
    ! [VarCurr: state_type] :
      ( v123706(VarCurr)
    <=> ( v123707(VarCurr)
        | v123708(VarCurr) ) ) ).

tff(writeUnaryOperator_8430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123708(VarCurr)
    <=> v123692(VarCurr) ) ).

tff(writeUnaryOperator_8429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123707(VarCurr)
    <=> v123625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15236,axiom,
    ! [VarCurr: state_type] :
      ( v123620(VarCurr)
    <=> ( v123621(VarCurr)
        & v123704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15235,axiom,
    ! [VarCurr: state_type] :
      ( v123704(VarCurr)
    <=> ( v123623(VarCurr)
        | v123699(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15234,axiom,
    ! [VarCurr: state_type] :
      ( v123621(VarCurr)
    <=> ( v123622(VarCurr)
        | v123698(VarCurr) ) ) ).

tff(writeUnaryOperator_8428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123698(VarCurr)
    <=> v123699(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15233,axiom,
    ! [VarCurr: state_type] :
      ( v123699(VarCurr)
    <=> ( v123700(VarCurr)
        & v123703(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5434,axiom,
    ! [VarCurr: state_type] :
      ( v123703(VarCurr)
    <=> ( v123626(VarCurr,2)
        | v123691(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15232,axiom,
    ! [VarCurr: state_type] :
      ( v123700(VarCurr)
    <=> ( v123701(VarCurr)
        | v123702(VarCurr) ) ) ).

tff(writeUnaryOperator_8427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123702(VarCurr)
    <=> v123691(VarCurr,2) ) ).

tff(writeUnaryOperator_8426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123701(VarCurr)
    <=> v123626(VarCurr,2) ) ).

tff(writeUnaryOperator_8425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123622(VarCurr)
    <=> v123623(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15231,axiom,
    ! [VarCurr: state_type] :
      ( v123623(VarCurr)
    <=> ( v123624(VarCurr)
        | v123697(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5433,axiom,
    ! [VarCurr: state_type] :
      ( v123697(VarCurr)
    <=> ( v123626(VarCurr,1)
        & v123691(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15230,axiom,
    ! [VarCurr: state_type] :
      ( v123624(VarCurr)
    <=> ( v123625(VarCurr)
        & v123692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15229,axiom,
    ! [VarCurr: state_type] :
      ( v123692(VarCurr)
    <=> ( v123693(VarCurr)
        & v123696(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5432,axiom,
    ! [VarCurr: state_type] :
      ( v123696(VarCurr)
    <=> ( v123626(VarCurr,1)
        | v123691(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15228,axiom,
    ! [VarCurr: state_type] :
      ( v123693(VarCurr)
    <=> ( v123694(VarCurr)
        | v123695(VarCurr) ) ) ).

tff(writeUnaryOperator_8424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123695(VarCurr)
    <=> v123691(VarCurr,1) ) ).

tff(writeUnaryOperator_8423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123694(VarCurr)
    <=> v123626(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15227,axiom,
    ! [VarCurr: state_type] :
      ( v123625(VarCurr)
    <=> ( v123626(VarCurr,0)
        & v123691(VarCurr,0) ) ) ).

tff(addAssignment_70552,axiom,
    ! [VarCurr: state_type] :
      ( v123691(VarCurr,0)
    <=> v123587(VarCurr) ) ).

tff(addAssignment_70551,axiom,
    ! [VarCurr: state_type] :
      ( ( v123691(VarCurr,2)
      <=> $false )
      & ( v123691(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70550,axiom,
    ! [VarCurr: state_type] :
      ( v123626(VarCurr,0)
    <=> v123686(VarCurr) ) ).

tff(addAssignment_70549,axiom,
    ! [VarCurr: state_type] :
      ( v123626(VarCurr,1)
    <=> v123681(VarCurr) ) ).

tff(addAssignment_70548,axiom,
    ! [VarCurr: state_type] :
      ( v123626(VarCurr,2)
    <=> v123628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15226,axiom,
    ! [VarCurr: state_type] :
      ( v123686(VarCurr)
    <=> ( v123687(VarCurr)
        & v123690(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15225,axiom,
    ! [VarCurr: state_type] :
      ( v123690(VarCurr)
    <=> ( v123634(VarCurr,0)
        | v123667(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15224,axiom,
    ! [VarCurr: state_type] :
      ( v123687(VarCurr)
    <=> ( v123688(VarCurr)
        | v123689(VarCurr) ) ) ).

tff(writeUnaryOperator_8422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123689(VarCurr)
    <=> v123667(VarCurr,0) ) ).

tff(writeUnaryOperator_8421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123688(VarCurr)
    <=> v123634(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15223,axiom,
    ! [VarCurr: state_type] :
      ( v123681(VarCurr)
    <=> ( v123682(VarCurr)
        & v123685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15222,axiom,
    ! [VarCurr: state_type] :
      ( v123685(VarCurr)
    <=> ( v123633(VarCurr)
        | v123668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15221,axiom,
    ! [VarCurr: state_type] :
      ( v123682(VarCurr)
    <=> ( v123683(VarCurr)
        | v123684(VarCurr) ) ) ).

tff(writeUnaryOperator_8420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123684(VarCurr)
    <=> v123668(VarCurr) ) ).

tff(writeUnaryOperator_8419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123683(VarCurr)
    <=> v123633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15220,axiom,
    ! [VarCurr: state_type] :
      ( v123628(VarCurr)
    <=> ( v123629(VarCurr)
        & v123680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15219,axiom,
    ! [VarCurr: state_type] :
      ( v123680(VarCurr)
    <=> ( v123631(VarCurr)
        | v123675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15218,axiom,
    ! [VarCurr: state_type] :
      ( v123629(VarCurr)
    <=> ( v123630(VarCurr)
        | v123674(VarCurr) ) ) ).

tff(writeUnaryOperator_8418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123674(VarCurr)
    <=> v123675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15217,axiom,
    ! [VarCurr: state_type] :
      ( v123675(VarCurr)
    <=> ( v123676(VarCurr)
        & v123679(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5431,axiom,
    ! [VarCurr: state_type] :
      ( v123679(VarCurr)
    <=> ( v123634(VarCurr,2)
        | v123667(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15216,axiom,
    ! [VarCurr: state_type] :
      ( v123676(VarCurr)
    <=> ( v123677(VarCurr)
        | v123678(VarCurr) ) ) ).

tff(writeUnaryOperator_8417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123678(VarCurr)
    <=> v123667(VarCurr,2) ) ).

tff(writeUnaryOperator_8416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123677(VarCurr)
    <=> v123634(VarCurr,2) ) ).

tff(writeUnaryOperator_8415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123630(VarCurr)
    <=> v123631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15215,axiom,
    ! [VarCurr: state_type] :
      ( v123631(VarCurr)
    <=> ( v123632(VarCurr)
        | v123673(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5430,axiom,
    ! [VarCurr: state_type] :
      ( v123673(VarCurr)
    <=> ( v123634(VarCurr,1)
        & v123667(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15214,axiom,
    ! [VarCurr: state_type] :
      ( v123632(VarCurr)
    <=> ( v123633(VarCurr)
        & v123668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15213,axiom,
    ! [VarCurr: state_type] :
      ( v123668(VarCurr)
    <=> ( v123669(VarCurr)
        & v123672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5429,axiom,
    ! [VarCurr: state_type] :
      ( v123672(VarCurr)
    <=> ( v123634(VarCurr,1)
        | v123667(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15212,axiom,
    ! [VarCurr: state_type] :
      ( v123669(VarCurr)
    <=> ( v123670(VarCurr)
        | v123671(VarCurr) ) ) ).

tff(writeUnaryOperator_8414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123671(VarCurr)
    <=> v123667(VarCurr,1) ) ).

tff(writeUnaryOperator_8413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123670(VarCurr)
    <=> v123634(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15211,axiom,
    ! [VarCurr: state_type] :
      ( v123633(VarCurr)
    <=> ( v123634(VarCurr,0)
        & v123667(VarCurr,0) ) ) ).

tff(addAssignment_70547,axiom,
    ! [VarCurr: state_type] :
      ( v123667(VarCurr,0)
    <=> v123585(VarCurr) ) ).

tff(addAssignment_70546,axiom,
    ! [VarCurr: state_type] :
      ( ( v123667(VarCurr,2)
      <=> $false )
      & ( v123667(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70545,axiom,
    ! [VarCurr: state_type] :
      ( v123634(VarCurr,0)
    <=> v123662(VarCurr) ) ).

tff(addAssignment_70544,axiom,
    ! [VarCurr: state_type] :
      ( v123634(VarCurr,1)
    <=> v123657(VarCurr) ) ).

tff(addAssignment_70543,axiom,
    ! [VarCurr: state_type] :
      ( v123634(VarCurr,2)
    <=> v123636(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15210,axiom,
    ! [VarCurr: state_type] :
      ( v123662(VarCurr)
    <=> ( v123663(VarCurr)
        & v123666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15209,axiom,
    ! [VarCurr: state_type] :
      ( v123666(VarCurr)
    <=> ( v123642(VarCurr,0)
        | v123643(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15208,axiom,
    ! [VarCurr: state_type] :
      ( v123663(VarCurr)
    <=> ( v123664(VarCurr)
        | v123665(VarCurr) ) ) ).

tff(writeUnaryOperator_8412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123665(VarCurr)
    <=> v123643(VarCurr,0) ) ).

tff(writeUnaryOperator_8411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123664(VarCurr)
    <=> v123642(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15207,axiom,
    ! [VarCurr: state_type] :
      ( v123657(VarCurr)
    <=> ( v123658(VarCurr)
        & v123661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15206,axiom,
    ! [VarCurr: state_type] :
      ( v123661(VarCurr)
    <=> ( v123641(VarCurr)
        | v123644(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15205,axiom,
    ! [VarCurr: state_type] :
      ( v123658(VarCurr)
    <=> ( v123659(VarCurr)
        | v123660(VarCurr) ) ) ).

tff(writeUnaryOperator_8410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123660(VarCurr)
    <=> v123644(VarCurr) ) ).

tff(writeUnaryOperator_8409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123659(VarCurr)
    <=> v123641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15204,axiom,
    ! [VarCurr: state_type] :
      ( v123636(VarCurr)
    <=> ( v123637(VarCurr)
        & v123656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15203,axiom,
    ! [VarCurr: state_type] :
      ( v123656(VarCurr)
    <=> ( v123639(VarCurr)
        | v123651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15202,axiom,
    ! [VarCurr: state_type] :
      ( v123637(VarCurr)
    <=> ( v123638(VarCurr)
        | v123650(VarCurr) ) ) ).

tff(writeUnaryOperator_8408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123650(VarCurr)
    <=> v123651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15201,axiom,
    ! [VarCurr: state_type] :
      ( v123651(VarCurr)
    <=> ( v123652(VarCurr)
        & v123655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5428,axiom,
    ! [VarCurr: state_type] :
      ( v123655(VarCurr)
    <=> ( v123642(VarCurr,2)
        | v123643(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15200,axiom,
    ! [VarCurr: state_type] :
      ( v123652(VarCurr)
    <=> ( v123653(VarCurr)
        | v123654(VarCurr) ) ) ).

tff(writeUnaryOperator_8407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123654(VarCurr)
    <=> v123643(VarCurr,2) ) ).

tff(writeUnaryOperator_8406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123653(VarCurr)
    <=> v123642(VarCurr,2) ) ).

tff(writeUnaryOperator_8405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123638(VarCurr)
    <=> v123639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15199,axiom,
    ! [VarCurr: state_type] :
      ( v123639(VarCurr)
    <=> ( v123640(VarCurr)
        | v123649(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5427,axiom,
    ! [VarCurr: state_type] :
      ( v123649(VarCurr)
    <=> ( v123642(VarCurr,1)
        & v123643(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15198,axiom,
    ! [VarCurr: state_type] :
      ( v123640(VarCurr)
    <=> ( v123641(VarCurr)
        & v123644(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15197,axiom,
    ! [VarCurr: state_type] :
      ( v123644(VarCurr)
    <=> ( v123645(VarCurr)
        & v123648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5426,axiom,
    ! [VarCurr: state_type] :
      ( v123648(VarCurr)
    <=> ( v123642(VarCurr,1)
        | v123643(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15196,axiom,
    ! [VarCurr: state_type] :
      ( v123645(VarCurr)
    <=> ( v123646(VarCurr)
        | v123647(VarCurr) ) ) ).

tff(writeUnaryOperator_8404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123647(VarCurr)
    <=> v123643(VarCurr,1) ) ).

tff(writeUnaryOperator_8403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123646(VarCurr)
    <=> v123642(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15195,axiom,
    ! [VarCurr: state_type] :
      ( v123641(VarCurr)
    <=> ( v123642(VarCurr,0)
        & v123643(VarCurr,0) ) ) ).

tff(addAssignment_70542,axiom,
    ! [VarCurr: state_type] :
      ( v123643(VarCurr,0)
    <=> v123583(VarCurr) ) ).

tff(addAssignment_70541,axiom,
    ! [VarCurr: state_type] :
      ( ( v123643(VarCurr,2)
      <=> $false )
      & ( v123643(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70540,axiom,
    ! [VarCurr: state_type] :
      ( v123642(VarCurr,0)
    <=> v123581(VarCurr) ) ).

tff(addAssignment_70539,axiom,
    ! [VarCurr: state_type] :
      ( ( v123642(VarCurr,2)
      <=> $false )
      & ( v123642(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70538,axiom,
    ! [VarCurr: state_type] :
      ( v123593(VarCurr)
    <=> v114692(VarCurr,12) ) ).

tff(addAssignment_70537,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,12)
    <=> v114694(VarCurr,12) ) ).

tff(addAssignment_70536,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,12)
    <=> v114696(VarCurr,12) ) ).

tff(addAssignment_70535,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,12)
    <=> v114697(VarCurr,12) ) ).

tff(addAssignment_70534,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,12)
    <=> v113918(VarCurr,12) ) ).

tff(addAssignment_70533,axiom,
    ! [VarCurr: state_type] :
      ( v123591(VarCurr)
    <=> v114685(VarCurr,12) ) ).

tff(addAssignment_70532,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,12)
    <=> v114686(VarCurr,12) ) ).

tff(addAssignment_70531,axiom,
    ! [VarCurr: state_type] :
      ( v123589(VarCurr)
    <=> v114661(VarCurr,12) ) ).

tff(addAssignment_70530,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,12)
    <=> v114662(VarCurr,12) ) ).

tff(addAssignment_70529,axiom,
    ! [VarCurr: state_type] :
      ( v123587(VarCurr)
    <=> v114633(VarCurr,12) ) ).

tff(addAssignment_70528,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,12)
    <=> v114635(VarCurr,12) ) ).

tff(addAssignment_70527,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,12)
    <=> v114637(VarCurr,12) ) ).

tff(addAssignment_70526,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,12)
    <=> v114638(VarCurr,12) ) ).

tff(addAssignment_70525,axiom,
    ! [VarCurr: state_type] :
      ( v123585(VarCurr)
    <=> v114605(VarCurr,12) ) ).

tff(addAssignment_70524,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,12)
    <=> v114607(VarCurr,12) ) ).

tff(addAssignment_70523,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,12)
    <=> v114609(VarCurr,12) ) ).

tff(addAssignment_70522,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,12)
    <=> v114610(VarCurr,12) ) ).

tff(addAssignment_70521,axiom,
    ! [VarCurr: state_type] :
      ( v123583(VarCurr)
    <=> v114577(VarCurr,12) ) ).

tff(addAssignment_70520,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,12)
    <=> v114579(VarCurr,12) ) ).

tff(addAssignment_70519,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,12)
    <=> v114581(VarCurr,12) ) ).

tff(addAssignment_70518,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,12)
    <=> v114582(VarCurr,12) ) ).

tff(addAssignment_70517,axiom,
    ! [VarCurr: state_type] :
      ( v123581(VarCurr)
    <=> v114549(VarCurr,12) ) ).

tff(addAssignment_70516,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,12)
    <=> v114551(VarCurr,12) ) ).

tff(addAssignment_70515,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,12)
    <=> v114553(VarCurr,12) ) ).

tff(addAssignment_70514,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,12)
    <=> v114554(VarCurr,12) ) ).

tff(addAssignment_70513,axiom,
    ! [VarCurr: state_type] :
      ( v123567(VarCurr)
    <=> v123569(VarCurr) ) ).

tff(addAssignment_70512,axiom,
    ! [VarCurr: state_type] :
      ( v123569(VarCurr)
    <=> v123543(VarCurr) ) ).

tff(addAssignment_70511,axiom,
    ! [VarCurr: state_type] :
      ( v123563(VarCurr)
    <=> v123565(VarCurr) ) ).

tff(addAssignment_70510,axiom,
    ! [VarCurr: state_type] :
      ( v123565(VarCurr)
    <=> v123535(VarCurr) ) ).

tff(addAssignment_70509,axiom,
    ! [VarCurr: state_type] :
      ( v123539(VarCurr)
    <=> v123541(VarCurr) ) ).

tff(addAssignment_70508,axiom,
    ! [VarCurr: state_type] :
      ( v123541(VarCurr)
    <=> v123543(VarCurr) ) ).

tff(addAssignment_70507,axiom,
    ! [VarCurr: state_type] :
      ( v123543(VarCurr)
    <=> v123545(VarCurr) ) ).

tff(addAssignment_70506,axiom,
    ! [VarCurr: state_type] :
      ( v123545(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_70505,axiom,
    ! [VarCurr: state_type] :
      ( v123531(VarCurr)
    <=> v123533(VarCurr) ) ).

tff(addAssignment_70504,axiom,
    ! [VarCurr: state_type] :
      ( v123533(VarCurr)
    <=> v123535(VarCurr) ) ).

tff(addAssignment_70503,axiom,
    ! [VarCurr: state_type] :
      ( v123535(VarCurr)
    <=> v123537(VarCurr) ) ).

tff(addAssignment_70502,axiom,
    ! [VarCurr: state_type] :
      ( v123537(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15194,axiom,
    ! [VarCurr: state_type] :
      ( v122722(VarCurr)
    <=> ( v123521(VarCurr)
        & v123431(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5425,axiom,
    ! [VarCurr: state_type] :
      ( v123521(VarCurr)
    <=> ( v122724(VarCurr,1)
        & v123370(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1221,axiom,
    ! [VarCurr: state_type] :
      ( v123431(VarCurr)
    <=> ( ( v123433(VarCurr,4)
        <=> $false )
        & ( v123433(VarCurr,3)
        <=> $false )
        & ( v123433(VarCurr,2)
        <=> $false )
        & ( v123433(VarCurr,1)
        <=> $false )
        & ( v123433(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123433(VarCurr,B)
      <=> v123435(VarCurr,B) ) ) ).

tff(addAssignment_70500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123435(VarCurr,B)
      <=> v123437(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123503(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v123437(VarNext,B)
            <=> v123437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1603,axiom,
    ! [VarNext: state_type] :
      ( v123503(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123437(VarNext,B)
          <=> v123513(VarNext,B) ) ) ) ).

tff(addAssignment_70499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123513(VarNext,B)
          <=> v123511(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123514(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123511(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1149,axiom,
    ! [VarCurr: state_type] :
      ( v123514(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123511(VarCurr,B)
          <=> v123447(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15193,axiom,
    ! [VarCurr: state_type] :
      ( v123514(VarCurr)
    <=> ( v123515(VarCurr)
        & v123516(VarCurr) ) ) ).

tff(writeUnaryOperator_8402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123516(VarCurr)
    <=> v123443(VarCurr) ) ).

tff(writeUnaryOperator_8401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123515(VarCurr)
    <=> v123439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123503(VarNext)
      <=> v123504(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123504(VarNext)
      <=> ( v123505(VarNext)
          & v123498(VarNext) ) ) ) ).

tff(writeUnaryOperator_8400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123505(VarNext)
      <=> v123507(VarNext) ) ) ).

tff(addAssignment_70498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123507(VarNext)
      <=> v123498(VarCurr) ) ) ).

tff(addAssignment_70497,axiom,
    ! [VarCurr: state_type] :
      ( v123498(VarCurr)
    <=> v123500(VarCurr) ) ).

tff(addAssignment_70496,axiom,
    ! [VarCurr: state_type] :
      ( v123500(VarCurr)
    <=> v123204(VarCurr) ) ).

tff(addAssignment_70495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123447(VarCurr,B)
      <=> v123449(VarCurr,B) ) ) ).

tff(addAssignment_70494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123449(VarCurr,B)
      <=> v123451(VarCurr,B) ) ) ).

tff(addAssignment_70493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123451(VarCurr,B)
      <=> v123453(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123455(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123453(VarCurr,B)
          <=> v123467(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1148,axiom,
    ! [VarCurr: state_type] :
      ( v123455(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123453(VarCurr,B)
          <=> v123460(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123467(VarCurr,B)
          <=> v123468(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1147,axiom,
    ! [VarCurr: state_type] :
      ( v123462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123467(VarCurr,B)
          <=> v123465(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123431(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123468(VarCurr,B)
          <=> v123469(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1146,axiom,
    ! [VarCurr: state_type] :
      ( v123431(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v123468(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70492,axiom,
    ! [VarCurr: state_type] :
      ( v123469(VarCurr,0)
    <=> v123495(VarCurr) ) ).

tff(addAssignment_70491,axiom,
    ! [VarCurr: state_type] :
      ( v123469(VarCurr,1)
    <=> v123493(VarCurr) ) ).

tff(addAssignment_70490,axiom,
    ! [VarCurr: state_type] :
      ( v123469(VarCurr,2)
    <=> v123489(VarCurr) ) ).

tff(addAssignment_70489,axiom,
    ! [VarCurr: state_type] :
      ( v123469(VarCurr,3)
    <=> v123485(VarCurr) ) ).

tff(addAssignment_70488,axiom,
    ! [VarCurr: state_type] :
      ( v123469(VarCurr,4)
    <=> v123471(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15190,axiom,
    ! [VarCurr: state_type] :
      ( v123493(VarCurr)
    <=> ( v123494(VarCurr)
        & v123496(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15189,axiom,
    ! [VarCurr: state_type] :
      ( v123496(VarCurr)
    <=> ( v123433(VarCurr,0)
        | v123480(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5424,axiom,
    ! [VarCurr: state_type] :
      ( v123494(VarCurr)
    <=> ( v123495(VarCurr)
        | v123433(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123495(VarCurr)
    <=> v123433(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15188,axiom,
    ! [VarCurr: state_type] :
      ( v123489(VarCurr)
    <=> ( v123490(VarCurr)
        & v123492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15187,axiom,
    ! [VarCurr: state_type] :
      ( v123492(VarCurr)
    <=> ( v123478(VarCurr)
        | v123481(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5423,axiom,
    ! [VarCurr: state_type] :
      ( v123490(VarCurr)
    <=> ( v123491(VarCurr)
        | v123433(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123491(VarCurr)
    <=> v123478(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15186,axiom,
    ! [VarCurr: state_type] :
      ( v123485(VarCurr)
    <=> ( v123486(VarCurr)
        & v123488(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15185,axiom,
    ! [VarCurr: state_type] :
      ( v123488(VarCurr)
    <=> ( v123476(VarCurr)
        | v123482(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5422,axiom,
    ! [VarCurr: state_type] :
      ( v123486(VarCurr)
    <=> ( v123487(VarCurr)
        | v123433(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123487(VarCurr)
    <=> v123476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15184,axiom,
    ! [VarCurr: state_type] :
      ( v123471(VarCurr)
    <=> ( v123472(VarCurr)
        & v123483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15183,axiom,
    ! [VarCurr: state_type] :
      ( v123483(VarCurr)
    <=> ( v123474(VarCurr)
        | v123484(VarCurr) ) ) ).

tff(writeUnaryOperator_8396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123484(VarCurr)
    <=> v123433(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5421,axiom,
    ! [VarCurr: state_type] :
      ( v123472(VarCurr)
    <=> ( v123473(VarCurr)
        | v123433(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123473(VarCurr)
    <=> v123474(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5420,axiom,
    ! [VarCurr: state_type] :
      ( v123474(VarCurr)
    <=> ( v123433(VarCurr,3)
        | v123475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15182,axiom,
    ! [VarCurr: state_type] :
      ( v123475(VarCurr)
    <=> ( v123476(VarCurr)
        & v123482(VarCurr) ) ) ).

tff(writeUnaryOperator_8394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123482(VarCurr)
    <=> v123433(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5419,axiom,
    ! [VarCurr: state_type] :
      ( v123476(VarCurr)
    <=> ( v123433(VarCurr,2)
        | v123477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15181,axiom,
    ! [VarCurr: state_type] :
      ( v123477(VarCurr)
    <=> ( v123478(VarCurr)
        & v123481(VarCurr) ) ) ).

tff(writeUnaryOperator_8393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123481(VarCurr)
    <=> v123433(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5418,axiom,
    ! [VarCurr: state_type] :
      ( v123478(VarCurr)
    <=> ( v123433(VarCurr,1)
        | v123479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15180,axiom,
    ! [VarCurr: state_type] :
      ( v123479(VarCurr)
    <=> ( v123433(VarCurr,0)
        & v123480(VarCurr) ) ) ).

tff(writeUnaryOperator_8392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123480(VarCurr)
    <=> v123433(VarCurr,1) ) ).

tff(addAssignment_70487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123465(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15179,axiom,
    ! [VarCurr: state_type] :
      ( v123462(VarCurr)
    <=> ( v123009(VarCurr)
        | v123023(VarCurr) ) ) ).

tff(addAssignment_70486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v123460(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15178,axiom,
    ! [VarCurr: state_type] :
      ( v123455(VarCurr)
    <=> ( v123457(VarCurr)
        | v123021(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15177,axiom,
    ! [VarCurr: state_type] :
      ( v123457(VarCurr)
    <=> ( v123458(VarCurr)
        | v123019(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15176,axiom,
    ! [VarCurr: state_type] :
      ( v123458(VarCurr)
    <=> ( v122989(VarCurr)
        | v122999(VarCurr) ) ) ).

tff(addAssignment_70485,axiom,
    ! [VarCurr: state_type] :
      ( v123443(VarCurr)
    <=> v123445(VarCurr) ) ).

tff(addAssignment_70484,axiom,
    ! [VarCurr: state_type] :
      ( v123445(VarCurr)
    <=> v122742(VarCurr) ) ).

tff(addAssignment_70483,axiom,
    ! [VarCurr: state_type] :
      ( v123439(VarCurr)
    <=> v123441(VarCurr) ) ).

tff(addAssignment_70482,axiom,
    ! [VarCurr: state_type] :
      ( v123441(VarCurr)
    <=> v122734(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1220,axiom,
    ! [VarCurr: state_type] :
      ( v123370(VarCurr)
    <=> ( ( v123372(VarCurr,1)
        <=> $false )
        & ( v123372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v123372(VarCurr,B)
      <=> v123374(VarCurr,B) ) ) ).

tff(addAssignment_70480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v123374(VarCurr,B)
      <=> v123376(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123413(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v123376(VarNext,B)
            <=> v123376(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1602,axiom,
    ! [VarNext: state_type] :
      ( v123413(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123376(VarNext,B)
          <=> v123423(VarNext,B) ) ) ) ).

tff(addAssignment_70479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123423(VarNext,B)
          <=> v123421(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123424(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123421(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1145,axiom,
    ! [VarCurr: state_type] :
      ( v123424(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123421(VarCurr,B)
          <=> v123386(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15175,axiom,
    ! [VarCurr: state_type] :
      ( v123424(VarCurr)
    <=> ( v123425(VarCurr)
        & v123426(VarCurr) ) ) ).

tff(writeUnaryOperator_8391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123426(VarCurr)
    <=> v123382(VarCurr) ) ).

tff(writeUnaryOperator_8390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123425(VarCurr)
    <=> v123378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123413(VarNext)
      <=> v123414(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123414(VarNext)
      <=> ( v123415(VarNext)
          & v123408(VarNext) ) ) ) ).

tff(writeUnaryOperator_8389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123415(VarNext)
      <=> v123417(VarNext) ) ) ).

tff(addAssignment_70478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123417(VarNext)
      <=> v123408(VarCurr) ) ) ).

tff(addAssignment_70477,axiom,
    ! [VarCurr: state_type] :
      ( v123408(VarCurr)
    <=> v123410(VarCurr) ) ).

tff(addAssignment_70476,axiom,
    ! [VarCurr: state_type] :
      ( v123410(VarCurr)
    <=> v123204(VarCurr) ) ).

tff(addAssignment_70475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v123386(VarCurr,B)
      <=> v123388(VarCurr,B) ) ) ).

tff(addAssignment_70474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v123388(VarCurr,B)
      <=> v123390(VarCurr,B) ) ) ).

tff(addAssignment_70473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v123390(VarCurr,B)
      <=> v123392(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123394(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123392(VarCurr,B)
          <=> v123399(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1144,axiom,
    ! [VarCurr: state_type] :
      ( v123394(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123392(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123370(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123399(VarCurr,B)
          <=> v123400(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1143,axiom,
    ! [VarCurr: state_type] :
      ( v123370(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v123399(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70472,axiom,
    ! [VarCurr: state_type] :
      ( v123400(VarCurr,0)
    <=> v123404(VarCurr) ) ).

tff(addAssignment_70471,axiom,
    ! [VarCurr: state_type] :
      ( v123400(VarCurr,1)
    <=> v123402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15172,axiom,
    ! [VarCurr: state_type] :
      ( v123402(VarCurr)
    <=> ( v123403(VarCurr)
        & v123405(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15171,axiom,
    ! [VarCurr: state_type] :
      ( v123405(VarCurr)
    <=> ( v123372(VarCurr,0)
        | v123406(VarCurr) ) ) ).

tff(writeUnaryOperator_8388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123406(VarCurr)
    <=> v123372(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5417,axiom,
    ! [VarCurr: state_type] :
      ( v123403(VarCurr)
    <=> ( v123404(VarCurr)
        | v123372(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123404(VarCurr)
    <=> v123372(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15170,axiom,
    ! [VarCurr: state_type] :
      ( v123394(VarCurr)
    <=> ( v123396(VarCurr)
        | v123397(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5416,axiom,
    ! [VarCurr: state_type] :
      ( v123397(VarCurr)
    <=> ( v122724(VarCurr,1)
        & v123237(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5415,axiom,
    ! [VarCurr: state_type] :
      ( v123396(VarCurr)
    <=> ( v122724(VarCurr,3)
        & v123295(VarCurr) ) ) ).

tff(addAssignment_70470,axiom,
    ! [VarCurr: state_type] :
      ( v123382(VarCurr)
    <=> v123384(VarCurr) ) ).

tff(addAssignment_70469,axiom,
    ! [VarCurr: state_type] :
      ( v123384(VarCurr)
    <=> v122742(VarCurr) ) ).

tff(addAssignment_70468,axiom,
    ! [VarCurr: state_type] :
      ( v123378(VarCurr)
    <=> v123380(VarCurr) ) ).

tff(addAssignment_70467,axiom,
    ! [VarCurr: state_type] :
      ( v123380(VarCurr)
    <=> v122734(VarCurr) ) ).

tff(addAssignment_70466,axiom,
    ! [VarCurr: state_type] :
      ( v122724(VarCurr,1)
    <=> v122726(VarCurr,1) ) ).

tff(addAssignment_70465,axiom,
    ! [VarCurr: state_type] :
      ( v122726(VarCurr,1)
    <=> v122728(VarCurr,1) ) ).

tff(addAssignment_70464,axiom,
    ! [VarNext: state_type] :
      ( v122728(VarNext,1)
    <=> v123362(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123363(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v123362(VarNext,B)
            <=> v122728(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1601,axiom,
    ! [VarNext: state_type] :
      ( v123363(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123362(VarNext,B)
          <=> v123288(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123363(VarNext)
      <=> v123364(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123364(VarNext)
      <=> ( v123366(VarNext)
          & v123273(VarNext) ) ) ) ).

tff(writeUnaryOperator_8386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123366(VarNext)
      <=> v123282(VarNext) ) ) ).

tff(addAssignment_70463,axiom,
    ! [VarCurr: state_type] :
      ( v122746(VarCurr,1)
    <=> v122748(VarCurr,1) ) ).

tff(addAssignment_70462,axiom,
    ! [VarCurr: state_type] :
      ( v122748(VarCurr,1)
    <=> v122750(VarCurr,1) ) ).

tff(addAssignment_70461,axiom,
    ! [VarCurr: state_type] :
      ( v122750(VarCurr,1)
    <=> v123271(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_65,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123353(VarCurr)
     => ( v122752(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_94,axiom,
    ! [VarCurr: state_type] :
      ( v123353(VarCurr)
     => ( v122752(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15167,axiom,
    ! [VarCurr: state_type] :
      ( v123353(VarCurr)
    <=> ( v123354(VarCurr)
        | v123355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15166,axiom,
    ! [VarCurr: state_type] :
      ( v123355(VarCurr)
    <=> ( v123356(VarCurr)
        & v123357(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15165,axiom,
    ! [VarCurr: state_type] :
      ( v123357(VarCurr)
    <=> ( v123358(VarCurr)
        & v123254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15164,axiom,
    ! [VarCurr: state_type] :
      ( v123358(VarCurr)
    <=> ( v123359(VarCurr)
        & v123360(VarCurr) ) ) ).

tff(writeUnaryOperator_8385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123360(VarCurr)
    <=> v123246(VarCurr) ) ).

tff(writeUnaryOperator_8384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123359(VarCurr)
    <=> v123237(VarCurr) ) ).

tff(writeUnaryOperator_8383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123356(VarCurr)
    <=> v123256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15163,axiom,
    ! [VarCurr: state_type] :
      ( v123354(VarCurr)
    <=> ( v123328(VarCurr)
        & v123256(VarCurr) ) ) ).

tff(writeUnaryOperator_8382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122724(VarCurr,0)
    <=> v123233(VarCurr) ) ).

tff(addAssignment_70460,axiom,
    ! [VarCurr: state_type] :
      ( v123233(VarCurr)
    <=> v122726(VarCurr,0) ) ).

tff(addAssignment_70459,axiom,
    ! [VarCurr: state_type] :
      ( v122726(VarCurr,0)
    <=> v122728(VarCurr,0) ) ).

tff(addAssignment_70458,axiom,
    ! [VarNext: state_type] :
      ( v122728(VarNext,0)
    <=> v123344(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123345(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v123344(VarNext,B)
            <=> v122728(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1600,axiom,
    ! [VarNext: state_type] :
      ( v123345(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123344(VarNext,B)
          <=> v123288(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123345(VarNext)
      <=> v123346(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123346(VarNext)
      <=> ( v123348(VarNext)
          & v123273(VarNext) ) ) ) ).

tff(writeUnaryOperator_8381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123348(VarNext)
      <=> v123282(VarNext) ) ) ).

tff(addAssignment_70457,axiom,
    ! [VarCurr: state_type] :
      ( v122746(VarCurr,0)
    <=> v122748(VarCurr,0) ) ).

tff(addAssignment_70456,axiom,
    ! [VarCurr: state_type] :
      ( v122748(VarCurr,0)
    <=> v122750(VarCurr,0) ) ).

tff(addAssignment_70455,axiom,
    ! [VarCurr: state_type] :
      ( v122750(VarCurr,0)
    <=> v123271(VarCurr,0) ) ).

tff(writeUnaryOperator_8380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123235(VarCurr)
    <=> v122752(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123323(VarCurr)
     => ( v122752(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1142,axiom,
    ! [VarCurr: state_type] :
      ( v123323(VarCurr)
     => ( v122752(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15160,axiom,
    ! [VarCurr: state_type] :
      ( v123323(VarCurr)
    <=> ( v123324(VarCurr)
        | v123337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15159,axiom,
    ! [VarCurr: state_type] :
      ( v123337(VarCurr)
    <=> ( v123338(VarCurr)
        & v123341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15158,axiom,
    ! [VarCurr: state_type] :
      ( v123341(VarCurr)
    <=> ( v123309(VarCurr)
        & v123312(VarCurr) ) ) ).

tff(writeUnaryOperator_8379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123338(VarCurr)
    <=> v123339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15157,axiom,
    ! [VarCurr: state_type] :
      ( v123339(VarCurr)
    <=> ( v123340(VarCurr)
        | v123269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15156,axiom,
    ! [VarCurr: state_type] :
      ( v123340(VarCurr)
    <=> ( v123256(VarCurr)
        | v123254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15155,axiom,
    ! [VarCurr: state_type] :
      ( v123324(VarCurr)
    <=> ( v123325(VarCurr)
        | v123333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15154,axiom,
    ! [VarCurr: state_type] :
      ( v123333(VarCurr)
    <=> ( v123334(VarCurr)
        & v123336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15153,axiom,
    ! [VarCurr: state_type] :
      ( v123336(VarCurr)
    <=> ( v123267(VarCurr)
        & v123269(VarCurr) ) ) ).

tff(writeUnaryOperator_8378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123334(VarCurr)
    <=> v123335(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15152,axiom,
    ! [VarCurr: state_type] :
      ( v123335(VarCurr)
    <=> ( v123256(VarCurr)
        | v123254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15151,axiom,
    ! [VarCurr: state_type] :
      ( v123325(VarCurr)
    <=> ( v123326(VarCurr)
        | v123330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15150,axiom,
    ! [VarCurr: state_type] :
      ( v123330(VarCurr)
    <=> ( v123331(VarCurr)
        & v123332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15149,axiom,
    ! [VarCurr: state_type] :
      ( v123332(VarCurr)
    <=> ( v123246(VarCurr)
        & v123254(VarCurr) ) ) ).

tff(writeUnaryOperator_8377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123331(VarCurr)
    <=> v123256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15148,axiom,
    ! [VarCurr: state_type] :
      ( v123326(VarCurr)
    <=> ( v123327(VarCurr)
        & v123256(VarCurr) ) ) ).

tff(writeUnaryOperator_8376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123327(VarCurr)
    <=> v123328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15147,axiom,
    ! [VarCurr: state_type] :
      ( v123328(VarCurr)
    <=> ( v123329(VarCurr)
        & v123231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15146,axiom,
    ! [VarCurr: state_type] :
      ( v123329(VarCurr)
    <=> ( v122754(VarCurr)
        & v123229(VarCurr) ) ) ).

tff(addAssignment_70454,axiom,
    ! [VarCurr: state_type] :
      ( v122724(VarCurr,3)
    <=> v122726(VarCurr,3) ) ).

tff(addAssignment_70453,axiom,
    ! [VarCurr: state_type] :
      ( v122726(VarCurr,3)
    <=> v122728(VarCurr,3) ) ).

tff(addAssignment_70452,axiom,
    ! [VarNext: state_type] :
      ( v122728(VarNext,3)
    <=> v123315(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123316(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v123315(VarNext,B)
            <=> v122728(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1599,axiom,
    ! [VarNext: state_type] :
      ( v123316(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123315(VarNext,B)
          <=> v123288(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123316(VarNext)
      <=> v123317(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123317(VarNext)
      <=> ( v123319(VarNext)
          & v123273(VarNext) ) ) ) ).

tff(writeUnaryOperator_8375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123319(VarNext)
      <=> v123282(VarNext) ) ) ).

tff(addAssignment_70451,axiom,
    ! [VarCurr: state_type] :
      ( v122746(VarCurr,3)
    <=> v122748(VarCurr,3) ) ).

tff(addAssignment_70450,axiom,
    ! [VarCurr: state_type] :
      ( v122748(VarCurr,3)
    <=> v122750(VarCurr,3) ) ).

tff(addAssignment_70449,axiom,
    ! [VarCurr: state_type] :
      ( v122750(VarCurr,3)
    <=> v123271(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_64,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123297(VarCurr)
     => ( v122752(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_93,axiom,
    ! [VarCurr: state_type] :
      ( v123297(VarCurr)
     => ( v122752(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15143,axiom,
    ! [VarCurr: state_type] :
      ( v123297(VarCurr)
    <=> ( v123298(VarCurr)
        | v123304(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15142,axiom,
    ! [VarCurr: state_type] :
      ( v123304(VarCurr)
    <=> ( v123305(VarCurr)
        & v123306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15141,axiom,
    ! [VarCurr: state_type] :
      ( v123306(VarCurr)
    <=> ( v123307(VarCurr)
        & v123313(VarCurr) ) ) ).

tff(writeUnaryOperator_8374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123313(VarCurr)
    <=> v123303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15140,axiom,
    ! [VarCurr: state_type] :
      ( v123307(VarCurr)
    <=> ( v123308(VarCurr)
        & v123312(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1219,axiom,
    ! [VarCurr: state_type] :
      ( v123312(VarCurr)
    <=> ( $true
      <=> v122724(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123308(VarCurr)
    <=> v123309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15139,axiom,
    ! [VarCurr: state_type] :
      ( v123309(VarCurr)
    <=> ( v123310(VarCurr)
        | v123239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15138,axiom,
    ! [VarCurr: state_type] :
      ( v123310(VarCurr)
    <=> ( v123311(VarCurr)
        | v123295(VarCurr) ) ) ).

tff(writeUnaryOperator_8372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123311(VarCurr)
    <=> v123229(VarCurr) ) ).

tff(writeUnaryOperator_8371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123305(VarCurr)
    <=> v123269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15137,axiom,
    ! [VarCurr: state_type] :
      ( v123298(VarCurr)
    <=> ( v123299(VarCurr)
        & v123302(VarCurr) ) ) ).

tff(writeUnaryOperator_8370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123302(VarCurr)
    <=> v123303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15136,axiom,
    ! [VarCurr: state_type] :
      ( v123303(VarCurr)
    <=> ( v123256(VarCurr)
        | v123254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15135,axiom,
    ! [VarCurr: state_type] :
      ( v123299(VarCurr)
    <=> ( v123300(VarCurr)
        & v123269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15134,axiom,
    ! [VarCurr: state_type] :
      ( v123300(VarCurr)
    <=> ( v123263(VarCurr)
        & v123301(VarCurr) ) ) ).

tff(writeUnaryOperator_8369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123301(VarCurr)
    <=> v123267(VarCurr) ) ).

tff(addAssignment_70448,axiom,
    ! [VarCurr: state_type] :
      ( v123295(VarCurr)
    <=> v112831(VarCurr,11) ) ).

tff(addAssignment_70447,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,11)
    <=> v112865(VarCurr,11) ) ).

tff(addAssignment_70446,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,11)
    <=> v112849(VarCurr,11) ) ).

tff(addAssignment_70445,axiom,
    ! [VarCurr: state_type] :
      ( v122724(VarCurr,2)
    <=> v122726(VarCurr,2) ) ).

tff(addAssignment_70444,axiom,
    ! [VarCurr: state_type] :
      ( v122726(VarCurr,2)
    <=> v122728(VarCurr,2) ) ).

tff(addAssignment_70443,axiom,
    ! [VarNext: state_type] :
      ( v122728(VarNext,2)
    <=> v123277(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123278(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v123277(VarNext,B)
            <=> v122728(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1598,axiom,
    ! [VarNext: state_type] :
      ( v123278(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123277(VarNext,B)
          <=> v123288(VarNext,B) ) ) ) ).

tff(addAssignment_70442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123288(VarNext,B)
          <=> v123286(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123289(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123286(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1141,axiom,
    ! [VarCurr: state_type] :
      ( v123289(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v123286(VarCurr,B)
          <=> v122746(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15133,axiom,
    ! [VarCurr: state_type] :
      ( v123289(VarCurr)
    <=> ( v123290(VarCurr)
        & v123291(VarCurr) ) ) ).

tff(writeUnaryOperator_8368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123291(VarCurr)
    <=> v122738(VarCurr) ) ).

tff(writeUnaryOperator_8367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123290(VarCurr)
    <=> v122730(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123278(VarNext)
      <=> v123279(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123279(VarNext)
      <=> ( v123280(VarNext)
          & v123273(VarNext) ) ) ) ).

tff(writeUnaryOperator_8366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123280(VarNext)
      <=> v123282(VarNext) ) ) ).

tff(addAssignment_70441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123282(VarNext)
      <=> v123273(VarCurr) ) ) ).

tff(addAssignment_70440,axiom,
    ! [VarCurr: state_type] :
      ( v123273(VarCurr)
    <=> v123275(VarCurr) ) ).

tff(addAssignment_70439,axiom,
    ! [VarCurr: state_type] :
      ( v123275(VarCurr)
    <=> v123204(VarCurr) ) ).

tff(addAssignment_70438,axiom,
    ! [VarCurr: state_type] :
      ( v122746(VarCurr,2)
    <=> v122748(VarCurr,2) ) ).

tff(addAssignment_70437,axiom,
    ! [VarCurr: state_type] :
      ( v122748(VarCurr,2)
    <=> v122750(VarCurr,2) ) ).

tff(addAssignment_70436,axiom,
    ! [VarCurr: state_type] :
      ( v122750(VarCurr,2)
    <=> v123271(VarCurr,2) ) ).

tff(addAssignment_70435,axiom,
    ! [VarCurr: state_type] :
      ( v123271(VarCurr,0)
    <=> v123235(VarCurr) ) ).

tff(addAssignment_70434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v123271(VarCurr,B)
      <=> v122752(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_63,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123241(VarCurr)
     => ( v122752(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_92,axiom,
    ! [VarCurr: state_type] :
      ( v123241(VarCurr)
     => ( v122752(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15130,axiom,
    ! [VarCurr: state_type] :
      ( v123241(VarCurr)
    <=> ( v123242(VarCurr)
        | v123257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15129,axiom,
    ! [VarCurr: state_type] :
      ( v123257(VarCurr)
    <=> ( v123258(VarCurr)
        & v123259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15128,axiom,
    ! [VarCurr: state_type] :
      ( v123259(VarCurr)
    <=> ( v123260(VarCurr)
        & v123270(VarCurr) ) ) ).

tff(writeUnaryOperator_8365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123270(VarCurr)
    <=> v123256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15127,axiom,
    ! [VarCurr: state_type] :
      ( v123260(VarCurr)
    <=> ( v123261(VarCurr)
        & v123269(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1218,axiom,
    ! [VarCurr: state_type] :
      ( v123269(VarCurr)
    <=> ( $true
      <=> v122724(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15126,axiom,
    ! [VarCurr: state_type] :
      ( v123261(VarCurr)
    <=> ( v123262(VarCurr)
        & v123266(VarCurr) ) ) ).

tff(writeUnaryOperator_8364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123266(VarCurr)
    <=> v123267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15125,axiom,
    ! [VarCurr: state_type] :
      ( v123267(VarCurr)
    <=> ( v123268(VarCurr)
        | v123239(VarCurr) ) ) ).

tff(writeUnaryOperator_8363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123268(VarCurr)
    <=> v123229(VarCurr) ) ).

tff(writeUnaryOperator_8362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123262(VarCurr)
    <=> v123263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15124,axiom,
    ! [VarCurr: state_type] :
      ( v123263(VarCurr)
    <=> ( v123264(VarCurr)
        | v123265(VarCurr) ) ) ).

tff(writeUnaryOperator_8361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123265(VarCurr)
    <=> v123231(VarCurr) ) ).

tff(writeUnaryOperator_8360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123264(VarCurr)
    <=> v122754(VarCurr) ) ).

tff(writeUnaryOperator_8359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123258(VarCurr)
    <=> v123254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15123,axiom,
    ! [VarCurr: state_type] :
      ( v123242(VarCurr)
    <=> ( v123243(VarCurr)
        & v123255(VarCurr) ) ) ).

tff(writeUnaryOperator_8358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123255(VarCurr)
    <=> v123256(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1217,axiom,
    ! [VarCurr: state_type] :
      ( v123256(VarCurr)
    <=> ( $true
      <=> v122724(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15122,axiom,
    ! [VarCurr: state_type] :
      ( v123243(VarCurr)
    <=> ( v123244(VarCurr)
        & v123254(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1216,axiom,
    ! [VarCurr: state_type] :
      ( v123254(VarCurr)
    <=> ( $true
      <=> v122724(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15121,axiom,
    ! [VarCurr: state_type] :
      ( v123244(VarCurr)
    <=> ( v123237(VarCurr)
        & v123245(VarCurr) ) ) ).

tff(writeUnaryOperator_8357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123245(VarCurr)
    <=> v123246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15120,axiom,
    ! [VarCurr: state_type] :
      ( v123246(VarCurr)
    <=> ( v123247(VarCurr)
        | v123239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15119,axiom,
    ! [VarCurr: state_type] :
      ( v123247(VarCurr)
    <=> ( v123248(VarCurr)
        | v123251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15118,axiom,
    ! [VarCurr: state_type] :
      ( v123251(VarCurr)
    <=> ( v123252(VarCurr)
        & v123253(VarCurr) ) ) ).

tff(writeUnaryOperator_8356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123253(VarCurr)
    <=> v123237(VarCurr) ) ).

tff(writeUnaryOperator_8355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123252(VarCurr)
    <=> v122754(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15117,axiom,
    ! [VarCurr: state_type] :
      ( v123248(VarCurr)
    <=> ( v123249(VarCurr)
        | v123250(VarCurr) ) ) ).

tff(writeUnaryOperator_8354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123250(VarCurr)
    <=> v123231(VarCurr) ) ).

tff(writeUnaryOperator_8353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123249(VarCurr)
    <=> v123229(VarCurr) ) ).

tff(addAssignment_70433,axiom,
    ! [VarCurr: state_type] :
      ( v123239(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_70432,axiom,
    ! [VarCurr: state_type] :
      ( v123237(VarCurr)
    <=> v112643(VarCurr,11) ) ).

tff(addAssignment_70431,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,11)
    <=> v115202(VarCurr,11) ) ).

tff(addAssignment_70430,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,11)
    <=> v115186(VarCurr,11) ) ).

tff(addAssignment_70429,axiom,
    ! [VarCurr: state_type] :
      ( v123231(VarCurr)
    <=> v112528(VarCurr,11) ) ).

tff(addAssignment_70428,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,11)
    <=> v120828(VarCurr,3) ) ).

tff(addAssignment_70427,axiom,
    ! [VarCurr: state_type] :
      ( v123229(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15116,axiom,
    ! [VarCurr: state_type] :
      ( v122754(VarCurr)
    <=> ( v123226(VarCurr)
        & v123227(VarCurr) ) ) ).

tff(writeUnaryOperator_8352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123227(VarCurr)
    <=> v123224(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1215,axiom,
    ! [VarCurr: state_type] :
      ( v123226(VarCurr)
    <=> ( ( v122756(VarCurr,5)
        <=> $false )
        & ( v122756(VarCurr,4)
        <=> $false )
        & ( v122756(VarCurr,3)
        <=> $false )
        & ( v122756(VarCurr,2)
        <=> $false )
        & ( v122756(VarCurr,1)
        <=> $false )
        & ( v122756(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70426,axiom,
    ! [VarCurr: state_type] :
      ( v123224(VarCurr)
    <=> v115139(VarCurr,11) ) ).

tff(addAssignment_70425,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,11)
    <=> v115159(VarCurr,11) ) ).

tff(addAssignment_70424,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,11)
    <=> v115142(VarCurr,11) ) ).

tff(addAssignment_70423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v122756(VarCurr,B)
      <=> v122758(VarCurr,B) ) ) ).

tff(addAssignment_70422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v122758(VarCurr,B)
      <=> v122760(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123207(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v122760(VarNext,B)
            <=> v122760(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1597,axiom,
    ! [VarNext: state_type] :
      ( v123207(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v122760(VarNext,B)
          <=> v123217(VarNext,B) ) ) ) ).

tff(addAssignment_70421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v123217(VarNext,B)
          <=> v123215(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123218(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v123215(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1140,axiom,
    ! [VarCurr: state_type] :
      ( v123218(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v123215(VarCurr,B)
          <=> v122770(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15115,axiom,
    ! [VarCurr: state_type] :
      ( v123218(VarCurr)
    <=> ( v123219(VarCurr)
        & v123220(VarCurr) ) ) ).

tff(writeUnaryOperator_8351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123220(VarCurr)
    <=> v122766(VarCurr) ) ).

tff(writeUnaryOperator_8350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123219(VarCurr)
    <=> v122762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123207(VarNext)
      <=> v123208(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123208(VarNext)
      <=> ( v123209(VarNext)
          & v123200(VarNext) ) ) ) ).

tff(writeUnaryOperator_8349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123209(VarNext)
      <=> v123211(VarNext) ) ) ).

tff(addAssignment_70420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123211(VarNext)
      <=> v123200(VarCurr) ) ) ).

tff(addAssignment_70419,axiom,
    ! [VarCurr: state_type] :
      ( v123200(VarCurr)
    <=> v123202(VarCurr) ) ).

tff(addAssignment_70418,axiom,
    ! [VarCurr: state_type] :
      ( v123202(VarCurr)
    <=> v123204(VarCurr) ) ).

tff(addAssignment_70417,axiom,
    ! [VarCurr: state_type] :
      ( v123204(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_70416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v122770(VarCurr,B)
      <=> v122772(VarCurr,B) ) ) ).

tff(addAssignment_70415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v122772(VarCurr,B)
      <=> v122774(VarCurr,B) ) ) ).

tff(addAssignment_70414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v122774(VarCurr,B)
      <=> v122776(VarCurr,B) ) ) ).

tff(addAssignment_70413,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,0)
    <=> v123195(VarCurr) ) ).

tff(addAssignment_70412,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,1)
    <=> v123190(VarCurr) ) ).

tff(addAssignment_70411,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,2)
    <=> v123185(VarCurr) ) ).

tff(addAssignment_70410,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,3)
    <=> v123180(VarCurr) ) ).

tff(addAssignment_70409,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,4)
    <=> v123175(VarCurr) ) ).

tff(addAssignment_70408,axiom,
    ! [VarCurr: state_type] :
      ( v122776(VarCurr,5)
    <=> v123032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15112,axiom,
    ! [VarCurr: state_type] :
      ( v123195(VarCurr)
    <=> ( v123196(VarCurr)
        & v123198(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15111,axiom,
    ! [VarCurr: state_type] :
      ( v123198(VarCurr)
    <=> ( v122987(VarCurr,0)
        | v123044(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15110,axiom,
    ! [VarCurr: state_type] :
      ( v123196(VarCurr)
    <=> ( v123121(VarCurr)
        | v123197(VarCurr) ) ) ).

tff(writeUnaryOperator_8348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123197(VarCurr)
    <=> v123044(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15109,axiom,
    ! [VarCurr: state_type] :
      ( v123190(VarCurr)
    <=> ( v123191(VarCurr)
        & v123194(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15108,axiom,
    ! [VarCurr: state_type] :
      ( v123194(VarCurr)
    <=> ( v123043(VarCurr)
        | v123115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15107,axiom,
    ! [VarCurr: state_type] :
      ( v123191(VarCurr)
    <=> ( v123192(VarCurr)
        | v123193(VarCurr) ) ) ).

tff(writeUnaryOperator_8347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123193(VarCurr)
    <=> v123115(VarCurr) ) ).

tff(writeUnaryOperator_8346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123192(VarCurr)
    <=> v123043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15106,axiom,
    ! [VarCurr: state_type] :
      ( v123185(VarCurr)
    <=> ( v123186(VarCurr)
        & v123189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15105,axiom,
    ! [VarCurr: state_type] :
      ( v123189(VarCurr)
    <=> ( v123041(VarCurr)
        | v123126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15104,axiom,
    ! [VarCurr: state_type] :
      ( v123186(VarCurr)
    <=> ( v123187(VarCurr)
        | v123188(VarCurr) ) ) ).

tff(writeUnaryOperator_8345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123188(VarCurr)
    <=> v123126(VarCurr) ) ).

tff(writeUnaryOperator_8344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123187(VarCurr)
    <=> v123041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15103,axiom,
    ! [VarCurr: state_type] :
      ( v123180(VarCurr)
    <=> ( v123181(VarCurr)
        & v123184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15102,axiom,
    ! [VarCurr: state_type] :
      ( v123184(VarCurr)
    <=> ( v123039(VarCurr)
        | v123138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15101,axiom,
    ! [VarCurr: state_type] :
      ( v123181(VarCurr)
    <=> ( v123182(VarCurr)
        | v123183(VarCurr) ) ) ).

tff(writeUnaryOperator_8343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123183(VarCurr)
    <=> v123138(VarCurr) ) ).

tff(writeUnaryOperator_8342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123182(VarCurr)
    <=> v123039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15100,axiom,
    ! [VarCurr: state_type] :
      ( v123175(VarCurr)
    <=> ( v123176(VarCurr)
        & v123179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15099,axiom,
    ! [VarCurr: state_type] :
      ( v123179(VarCurr)
    <=> ( v123037(VarCurr)
        | v123150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15098,axiom,
    ! [VarCurr: state_type] :
      ( v123176(VarCurr)
    <=> ( v123177(VarCurr)
        | v123178(VarCurr) ) ) ).

tff(writeUnaryOperator_8341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123178(VarCurr)
    <=> v123150(VarCurr) ) ).

tff(writeUnaryOperator_8340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123177(VarCurr)
    <=> v123037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15097,axiom,
    ! [VarCurr: state_type] :
      ( v123032(VarCurr)
    <=> ( v123033(VarCurr)
        & v123174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15096,axiom,
    ! [VarCurr: state_type] :
      ( v123174(VarCurr)
    <=> ( v123035(VarCurr)
        | v123163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15095,axiom,
    ! [VarCurr: state_type] :
      ( v123033(VarCurr)
    <=> ( v123034(VarCurr)
        | v123162(VarCurr) ) ) ).

tff(writeUnaryOperator_8339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123162(VarCurr)
    <=> v123163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15094,axiom,
    ! [VarCurr: state_type] :
      ( v123163(VarCurr)
    <=> ( v123164(VarCurr)
        & v123173(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5414,axiom,
    ! [VarCurr: state_type] :
      ( v123173(VarCurr)
    <=> ( v123166(VarCurr)
        | v123044(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15093,axiom,
    ! [VarCurr: state_type] :
      ( v123164(VarCurr)
    <=> ( v123165(VarCurr)
        | v123172(VarCurr) ) ) ).

tff(writeUnaryOperator_8338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123172(VarCurr)
    <=> v123044(VarCurr,5) ) ).

tff(writeUnaryOperator_8337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123165(VarCurr)
    <=> v123166(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15092,axiom,
    ! [VarCurr: state_type] :
      ( v123166(VarCurr)
    <=> ( v123167(VarCurr)
        & v123170(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15091,axiom,
    ! [VarCurr: state_type] :
      ( v123170(VarCurr)
    <=> ( v123169(VarCurr)
        | v123171(VarCurr) ) ) ).

tff(writeUnaryOperator_8336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123171(VarCurr)
    <=> v122987(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5413,axiom,
    ! [VarCurr: state_type] :
      ( v123167(VarCurr)
    <=> ( v123168(VarCurr)
        | v122987(VarCurr,5) ) ) ).

tff(writeUnaryOperator_8335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123168(VarCurr)
    <=> v123169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15090,axiom,
    ! [VarCurr: state_type] :
      ( v123169(VarCurr)
    <=> ( v123156(VarCurr)
        & v123158(VarCurr) ) ) ).

tff(writeUnaryOperator_8334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123034(VarCurr)
    <=> v123035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15089,axiom,
    ! [VarCurr: state_type] :
      ( v123035(VarCurr)
    <=> ( v123036(VarCurr)
        | v123161(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5412,axiom,
    ! [VarCurr: state_type] :
      ( v123161(VarCurr)
    <=> ( v123153(VarCurr)
        & v123044(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15088,axiom,
    ! [VarCurr: state_type] :
      ( v123036(VarCurr)
    <=> ( v123037(VarCurr)
        & v123150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15087,axiom,
    ! [VarCurr: state_type] :
      ( v123150(VarCurr)
    <=> ( v123151(VarCurr)
        & v123160(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5411,axiom,
    ! [VarCurr: state_type] :
      ( v123160(VarCurr)
    <=> ( v123153(VarCurr)
        | v123044(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15086,axiom,
    ! [VarCurr: state_type] :
      ( v123151(VarCurr)
    <=> ( v123152(VarCurr)
        | v123159(VarCurr) ) ) ).

tff(writeUnaryOperator_8333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123159(VarCurr)
    <=> v123044(VarCurr,4) ) ).

tff(writeUnaryOperator_8332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123152(VarCurr)
    <=> v123153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15085,axiom,
    ! [VarCurr: state_type] :
      ( v123153(VarCurr)
    <=> ( v123154(VarCurr)
        & v123157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15084,axiom,
    ! [VarCurr: state_type] :
      ( v123157(VarCurr)
    <=> ( v123156(VarCurr)
        | v123158(VarCurr) ) ) ).

tff(writeUnaryOperator_8331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123158(VarCurr)
    <=> v122987(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5410,axiom,
    ! [VarCurr: state_type] :
      ( v123154(VarCurr)
    <=> ( v123155(VarCurr)
        | v122987(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123155(VarCurr)
    <=> v123156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15083,axiom,
    ! [VarCurr: state_type] :
      ( v123156(VarCurr)
    <=> ( v123144(VarCurr)
        & v123146(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15082,axiom,
    ! [VarCurr: state_type] :
      ( v123037(VarCurr)
    <=> ( v123038(VarCurr)
        | v123149(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5409,axiom,
    ! [VarCurr: state_type] :
      ( v123149(VarCurr)
    <=> ( v123141(VarCurr)
        & v123044(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15081,axiom,
    ! [VarCurr: state_type] :
      ( v123038(VarCurr)
    <=> ( v123039(VarCurr)
        & v123138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15080,axiom,
    ! [VarCurr: state_type] :
      ( v123138(VarCurr)
    <=> ( v123139(VarCurr)
        & v123148(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5408,axiom,
    ! [VarCurr: state_type] :
      ( v123148(VarCurr)
    <=> ( v123141(VarCurr)
        | v123044(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15079,axiom,
    ! [VarCurr: state_type] :
      ( v123139(VarCurr)
    <=> ( v123140(VarCurr)
        | v123147(VarCurr) ) ) ).

tff(writeUnaryOperator_8329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123147(VarCurr)
    <=> v123044(VarCurr,3) ) ).

tff(writeUnaryOperator_8328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123140(VarCurr)
    <=> v123141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15078,axiom,
    ! [VarCurr: state_type] :
      ( v123141(VarCurr)
    <=> ( v123142(VarCurr)
        & v123145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15077,axiom,
    ! [VarCurr: state_type] :
      ( v123145(VarCurr)
    <=> ( v123144(VarCurr)
        | v123146(VarCurr) ) ) ).

tff(writeUnaryOperator_8327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123146(VarCurr)
    <=> v122987(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5407,axiom,
    ! [VarCurr: state_type] :
      ( v123142(VarCurr)
    <=> ( v123143(VarCurr)
        | v122987(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123143(VarCurr)
    <=> v123144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15076,axiom,
    ! [VarCurr: state_type] :
      ( v123144(VarCurr)
    <=> ( v123132(VarCurr)
        & v123134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15075,axiom,
    ! [VarCurr: state_type] :
      ( v123039(VarCurr)
    <=> ( v123040(VarCurr)
        | v123137(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5406,axiom,
    ! [VarCurr: state_type] :
      ( v123137(VarCurr)
    <=> ( v123129(VarCurr)
        & v123044(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15074,axiom,
    ! [VarCurr: state_type] :
      ( v123040(VarCurr)
    <=> ( v123041(VarCurr)
        & v123126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15073,axiom,
    ! [VarCurr: state_type] :
      ( v123126(VarCurr)
    <=> ( v123127(VarCurr)
        & v123136(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5405,axiom,
    ! [VarCurr: state_type] :
      ( v123136(VarCurr)
    <=> ( v123129(VarCurr)
        | v123044(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15072,axiom,
    ! [VarCurr: state_type] :
      ( v123127(VarCurr)
    <=> ( v123128(VarCurr)
        | v123135(VarCurr) ) ) ).

tff(writeUnaryOperator_8325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123135(VarCurr)
    <=> v123044(VarCurr,2) ) ).

tff(writeUnaryOperator_8324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123128(VarCurr)
    <=> v123129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15071,axiom,
    ! [VarCurr: state_type] :
      ( v123129(VarCurr)
    <=> ( v123130(VarCurr)
        & v123133(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15070,axiom,
    ! [VarCurr: state_type] :
      ( v123133(VarCurr)
    <=> ( v123132(VarCurr)
        | v123134(VarCurr) ) ) ).

tff(writeUnaryOperator_8323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123134(VarCurr)
    <=> v122987(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5404,axiom,
    ! [VarCurr: state_type] :
      ( v123130(VarCurr)
    <=> ( v123131(VarCurr)
        | v122987(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123131(VarCurr)
    <=> v123132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15069,axiom,
    ! [VarCurr: state_type] :
      ( v123132(VarCurr)
    <=> ( v123121(VarCurr)
        & v123122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15068,axiom,
    ! [VarCurr: state_type] :
      ( v123041(VarCurr)
    <=> ( v123042(VarCurr)
        | v123125(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5403,axiom,
    ! [VarCurr: state_type] :
      ( v123125(VarCurr)
    <=> ( v123118(VarCurr)
        & v123044(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15067,axiom,
    ! [VarCurr: state_type] :
      ( v123042(VarCurr)
    <=> ( v123043(VarCurr)
        & v123115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15066,axiom,
    ! [VarCurr: state_type] :
      ( v123115(VarCurr)
    <=> ( v123116(VarCurr)
        & v123124(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5402,axiom,
    ! [VarCurr: state_type] :
      ( v123124(VarCurr)
    <=> ( v123118(VarCurr)
        | v123044(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15065,axiom,
    ! [VarCurr: state_type] :
      ( v123116(VarCurr)
    <=> ( v123117(VarCurr)
        | v123123(VarCurr) ) ) ).

tff(writeUnaryOperator_8321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123123(VarCurr)
    <=> v123044(VarCurr,1) ) ).

tff(writeUnaryOperator_8320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123117(VarCurr)
    <=> v123118(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15064,axiom,
    ! [VarCurr: state_type] :
      ( v123118(VarCurr)
    <=> ( v123119(VarCurr)
        & v123120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15063,axiom,
    ! [VarCurr: state_type] :
      ( v123120(VarCurr)
    <=> ( v123121(VarCurr)
        | v123122(VarCurr) ) ) ).

tff(writeUnaryOperator_8319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123122(VarCurr)
    <=> v122987(VarCurr,1) ) ).

tff(writeUnaryOperator_8318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123121(VarCurr)
    <=> v122987(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5401,axiom,
    ! [VarCurr: state_type] :
      ( v123119(VarCurr)
    <=> ( v122987(VarCurr,0)
        | v122987(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15062,axiom,
    ! [VarCurr: state_type] :
      ( v123043(VarCurr)
    <=> ( v122987(VarCurr,0)
        & v123044(VarCurr,0) ) ) ).

tff(addAssignment_70407,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,0)
    <=> v123110(VarCurr) ) ).

tff(addAssignment_70406,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,1)
    <=> v123105(VarCurr) ) ).

tff(addAssignment_70405,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,2)
    <=> v123100(VarCurr) ) ).

tff(addAssignment_70404,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,3)
    <=> v123095(VarCurr) ) ).

tff(addAssignment_70403,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,4)
    <=> v123090(VarCurr) ) ).

tff(addAssignment_70402,axiom,
    ! [VarCurr: state_type] :
      ( v123044(VarCurr,5)
    <=> v123046(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15061,axiom,
    ! [VarCurr: state_type] :
      ( v123110(VarCurr)
    <=> ( v123111(VarCurr)
        & v123114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15060,axiom,
    ! [VarCurr: state_type] :
      ( v123114(VarCurr)
    <=> ( v122756(VarCurr,0)
        | v123058(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15059,axiom,
    ! [VarCurr: state_type] :
      ( v123111(VarCurr)
    <=> ( v123112(VarCurr)
        | v123113(VarCurr) ) ) ).

tff(writeUnaryOperator_8317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123113(VarCurr)
    <=> v123058(VarCurr,0) ) ).

tff(writeUnaryOperator_8316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123112(VarCurr)
    <=> v122756(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15058,axiom,
    ! [VarCurr: state_type] :
      ( v123105(VarCurr)
    <=> ( v123106(VarCurr)
        & v123109(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15057,axiom,
    ! [VarCurr: state_type] :
      ( v123109(VarCurr)
    <=> ( v123057(VarCurr)
        | v123059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15056,axiom,
    ! [VarCurr: state_type] :
      ( v123106(VarCurr)
    <=> ( v123107(VarCurr)
        | v123108(VarCurr) ) ) ).

tff(writeUnaryOperator_8315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123108(VarCurr)
    <=> v123059(VarCurr) ) ).

tff(writeUnaryOperator_8314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123107(VarCurr)
    <=> v123057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15055,axiom,
    ! [VarCurr: state_type] :
      ( v123100(VarCurr)
    <=> ( v123101(VarCurr)
        & v123104(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15054,axiom,
    ! [VarCurr: state_type] :
      ( v123104(VarCurr)
    <=> ( v123055(VarCurr)
        | v123065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15053,axiom,
    ! [VarCurr: state_type] :
      ( v123101(VarCurr)
    <=> ( v123102(VarCurr)
        | v123103(VarCurr) ) ) ).

tff(writeUnaryOperator_8313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123103(VarCurr)
    <=> v123065(VarCurr) ) ).

tff(writeUnaryOperator_8312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123102(VarCurr)
    <=> v123055(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15052,axiom,
    ! [VarCurr: state_type] :
      ( v123095(VarCurr)
    <=> ( v123096(VarCurr)
        & v123099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15051,axiom,
    ! [VarCurr: state_type] :
      ( v123099(VarCurr)
    <=> ( v123053(VarCurr)
        | v123071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15050,axiom,
    ! [VarCurr: state_type] :
      ( v123096(VarCurr)
    <=> ( v123097(VarCurr)
        | v123098(VarCurr) ) ) ).

tff(writeUnaryOperator_8311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123098(VarCurr)
    <=> v123071(VarCurr) ) ).

tff(writeUnaryOperator_8310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123097(VarCurr)
    <=> v123053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15049,axiom,
    ! [VarCurr: state_type] :
      ( v123090(VarCurr)
    <=> ( v123091(VarCurr)
        & v123094(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15048,axiom,
    ! [VarCurr: state_type] :
      ( v123094(VarCurr)
    <=> ( v123051(VarCurr)
        | v123077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15047,axiom,
    ! [VarCurr: state_type] :
      ( v123091(VarCurr)
    <=> ( v123092(VarCurr)
        | v123093(VarCurr) ) ) ).

tff(writeUnaryOperator_8309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123093(VarCurr)
    <=> v123077(VarCurr) ) ).

tff(writeUnaryOperator_8308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123092(VarCurr)
    <=> v123051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15046,axiom,
    ! [VarCurr: state_type] :
      ( v123046(VarCurr)
    <=> ( v123047(VarCurr)
        & v123089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15045,axiom,
    ! [VarCurr: state_type] :
      ( v123089(VarCurr)
    <=> ( v123049(VarCurr)
        | v123084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15044,axiom,
    ! [VarCurr: state_type] :
      ( v123047(VarCurr)
    <=> ( v123048(VarCurr)
        | v123083(VarCurr) ) ) ).

tff(writeUnaryOperator_8307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123083(VarCurr)
    <=> v123084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15043,axiom,
    ! [VarCurr: state_type] :
      ( v123084(VarCurr)
    <=> ( v123085(VarCurr)
        & v123088(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5400,axiom,
    ! [VarCurr: state_type] :
      ( v123088(VarCurr)
    <=> ( v122756(VarCurr,5)
        | v123058(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15042,axiom,
    ! [VarCurr: state_type] :
      ( v123085(VarCurr)
    <=> ( v123086(VarCurr)
        | v123087(VarCurr) ) ) ).

tff(writeUnaryOperator_8306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123087(VarCurr)
    <=> v123058(VarCurr,5) ) ).

tff(writeUnaryOperator_8305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123086(VarCurr)
    <=> v122756(VarCurr,5) ) ).

tff(writeUnaryOperator_8304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123048(VarCurr)
    <=> v123049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15041,axiom,
    ! [VarCurr: state_type] :
      ( v123049(VarCurr)
    <=> ( v123050(VarCurr)
        | v123082(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5399,axiom,
    ! [VarCurr: state_type] :
      ( v123082(VarCurr)
    <=> ( v122756(VarCurr,4)
        & v123058(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15040,axiom,
    ! [VarCurr: state_type] :
      ( v123050(VarCurr)
    <=> ( v123051(VarCurr)
        & v123077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15039,axiom,
    ! [VarCurr: state_type] :
      ( v123077(VarCurr)
    <=> ( v123078(VarCurr)
        & v123081(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5398,axiom,
    ! [VarCurr: state_type] :
      ( v123081(VarCurr)
    <=> ( v122756(VarCurr,4)
        | v123058(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15038,axiom,
    ! [VarCurr: state_type] :
      ( v123078(VarCurr)
    <=> ( v123079(VarCurr)
        | v123080(VarCurr) ) ) ).

tff(writeUnaryOperator_8303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123080(VarCurr)
    <=> v123058(VarCurr,4) ) ).

tff(writeUnaryOperator_8302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123079(VarCurr)
    <=> v122756(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15037,axiom,
    ! [VarCurr: state_type] :
      ( v123051(VarCurr)
    <=> ( v123052(VarCurr)
        | v123076(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5397,axiom,
    ! [VarCurr: state_type] :
      ( v123076(VarCurr)
    <=> ( v122756(VarCurr,3)
        & v123058(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15036,axiom,
    ! [VarCurr: state_type] :
      ( v123052(VarCurr)
    <=> ( v123053(VarCurr)
        & v123071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15035,axiom,
    ! [VarCurr: state_type] :
      ( v123071(VarCurr)
    <=> ( v123072(VarCurr)
        & v123075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5396,axiom,
    ! [VarCurr: state_type] :
      ( v123075(VarCurr)
    <=> ( v122756(VarCurr,3)
        | v123058(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15034,axiom,
    ! [VarCurr: state_type] :
      ( v123072(VarCurr)
    <=> ( v123073(VarCurr)
        | v123074(VarCurr) ) ) ).

tff(writeUnaryOperator_8301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123074(VarCurr)
    <=> v123058(VarCurr,3) ) ).

tff(writeUnaryOperator_8300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123073(VarCurr)
    <=> v122756(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15033,axiom,
    ! [VarCurr: state_type] :
      ( v123053(VarCurr)
    <=> ( v123054(VarCurr)
        | v123070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5395,axiom,
    ! [VarCurr: state_type] :
      ( v123070(VarCurr)
    <=> ( v122756(VarCurr,2)
        & v123058(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15032,axiom,
    ! [VarCurr: state_type] :
      ( v123054(VarCurr)
    <=> ( v123055(VarCurr)
        & v123065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15031,axiom,
    ! [VarCurr: state_type] :
      ( v123065(VarCurr)
    <=> ( v123066(VarCurr)
        & v123069(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5394,axiom,
    ! [VarCurr: state_type] :
      ( v123069(VarCurr)
    <=> ( v122756(VarCurr,2)
        | v123058(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15030,axiom,
    ! [VarCurr: state_type] :
      ( v123066(VarCurr)
    <=> ( v123067(VarCurr)
        | v123068(VarCurr) ) ) ).

tff(writeUnaryOperator_8299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123068(VarCurr)
    <=> v123058(VarCurr,2) ) ).

tff(writeUnaryOperator_8298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123067(VarCurr)
    <=> v122756(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15029,axiom,
    ! [VarCurr: state_type] :
      ( v123055(VarCurr)
    <=> ( v123056(VarCurr)
        | v123064(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5393,axiom,
    ! [VarCurr: state_type] :
      ( v123064(VarCurr)
    <=> ( v122756(VarCurr,1)
        & v123058(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15028,axiom,
    ! [VarCurr: state_type] :
      ( v123056(VarCurr)
    <=> ( v123057(VarCurr)
        & v123059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15027,axiom,
    ! [VarCurr: state_type] :
      ( v123059(VarCurr)
    <=> ( v123060(VarCurr)
        & v123063(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5392,axiom,
    ! [VarCurr: state_type] :
      ( v123063(VarCurr)
    <=> ( v122756(VarCurr,1)
        | v123058(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15026,axiom,
    ! [VarCurr: state_type] :
      ( v123060(VarCurr)
    <=> ( v123061(VarCurr)
        | v123062(VarCurr) ) ) ).

tff(writeUnaryOperator_8297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123062(VarCurr)
    <=> v123058(VarCurr,1) ) ).

tff(writeUnaryOperator_8296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v123061(VarCurr)
    <=> v122756(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15025,axiom,
    ! [VarCurr: state_type] :
      ( v123057(VarCurr)
    <=> ( v122756(VarCurr,0)
        & v123058(VarCurr,0) ) ) ).

tff(addAssignment_70401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v123058(VarCurr,B)
      <=> v122778(VarCurr,B) ) ) ).

tff(addAssignment_70400,axiom,
    ! [VarCurr: state_type] :
      ( ( v123058(VarCurr,5)
      <=> $false )
      & ( v123058(VarCurr,4)
      <=> $false )
      & ( v123058(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_70399,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,5)
    <=> v123024(VarCurr,5) ) ).

tff(addAssignment_70398,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,4)
    <=> v123024(VarCurr,4) ) ).

tff(addAssignment_70397,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,3)
    <=> v123024(VarCurr,3) ) ).

tff(addAssignment_70396,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,2)
    <=> v123024(VarCurr,2) ) ).

tff(addAssignment_70395,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,1)
    <=> v123024(VarCurr,1) ) ).

tff(addAssignment_70394,axiom,
    ! [VarCurr: state_type] :
      ( v122987(VarCurr,0)
    <=> v123024(VarCurr,0) ) ).

tff(addAssignment_70393,axiom,
    ! [VarCurr: state_type] :
      ( v123024(VarCurr,0)
    <=> v123025(VarCurr) ) ).

tff(addAssignment_70392,axiom,
    ! [VarCurr: state_type] :
      ( ( v123024(VarCurr,5)
      <=> $false )
      & ( v123024(VarCurr,4)
      <=> $false )
      & ( v123024(VarCurr,3)
      <=> $false )
      & ( v123024(VarCurr,2)
      <=> $false )
      & ( v123024(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15024,axiom,
    ! [VarCurr: state_type] :
      ( v123025(VarCurr)
    <=> ( v123026(VarCurr)
        | v123023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15023,axiom,
    ! [VarCurr: state_type] :
      ( v123026(VarCurr)
    <=> ( v123027(VarCurr)
        | v123021(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15022,axiom,
    ! [VarCurr: state_type] :
      ( v123027(VarCurr)
    <=> ( v123028(VarCurr)
        | v123019(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15021,axiom,
    ! [VarCurr: state_type] :
      ( v123028(VarCurr)
    <=> ( v123029(VarCurr)
        | v123009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15020,axiom,
    ! [VarCurr: state_type] :
      ( v123029(VarCurr)
    <=> ( v122989(VarCurr)
        | v122999(VarCurr) ) ) ).

tff(addAssignment_70391,axiom,
    ! [VarCurr: state_type] :
      ( v123023(VarCurr)
    <=> v113911(VarCurr,11) ) ).

tff(addAssignment_70390,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,11)
    <=> v113913(VarCurr,11) ) ).

tff(addAssignment_70389,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,11)
    <=> v113915(VarCurr,11) ) ).

tff(addAssignment_70388,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,11)
    <=> v113935(VarCurr,11) ) ).

tff(addAssignment_70387,axiom,
    ! [VarCurr: state_type] :
      ( v123021(VarCurr)
    <=> v113107(VarCurr,11) ) ).

tff(addAssignment_70386,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,11)
    <=> v113143(VarCurr,11) ) ).

tff(addAssignment_70385,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,11)
    <=> v113110(VarCurr,11) ) ).

tff(addAssignment_70384,axiom,
    ! [VarCurr: state_type] :
      ( v123019(VarCurr)
    <=> v113100(VarCurr,11) ) ).

tff(addAssignment_70383,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,11)
    <=> v113101(VarCurr,11) ) ).

tff(addAssignment_70382,axiom,
    ! [VarCurr: state_type] :
      ( v123009(VarCurr)
    <=> v113810(VarCurr,11) ) ).

tff(addAssignment_70381,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,11)
    <=> v113812(VarCurr,11) ) ).

tff(addAssignment_70380,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,11)
    <=> v113814(VarCurr,11) ) ).

tff(addAssignment_70379,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,11)
    <=> v113816(VarCurr,11) ) ).

tff(addAssignment_70378,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,11)
    <=> v113818(VarCurr,11) ) ).

tff(addAssignment_70377,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,11)
    <=> v123011(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_1596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123012(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v123011(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1596,axiom,
    ! [VarNext: state_type] :
      ( v123012(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v123011(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123012(VarNext)
      <=> v123013(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123013(VarNext)
      <=> ( v123015(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123015(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_70376,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,11)
    <=> v113830(VarCurr,11) ) ).

tff(addAssignment_70375,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,11)
    <=> v113832(VarCurr,11) ) ).

tff(addAssignment_70374,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,11)
    <=> v113834(VarCurr,11) ) ).

tff(addAssignment_70373,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,11)
    <=> v113873(VarCurr,11) ) ).

tff(addAssignment_70372,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,11)
    <=> v113856(VarCurr,11) ) ).

tff(addAssignment_70371,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,11)
    <=> v113837(VarCurr,11) ) ).

tff(addAssignment_70370,axiom,
    ! [VarCurr: state_type] :
      ( v122999(VarCurr)
    <=> v113020(VarCurr,11) ) ).

tff(addAssignment_70369,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,11)
    <=> v113022(VarCurr,11) ) ).

tff(addAssignment_70368,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,11)
    <=> v113024(VarCurr,11) ) ).

tff(addAssignment_70367,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,11)
    <=> v113026(VarCurr,11) ) ).

tff(addAssignment_70366,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,11)
    <=> v113028(VarCurr,11) ) ).

tff(addAssignment_70365,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,11)
    <=> v123001(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_1595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v123001(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1595,axiom,
    ! [VarNext: state_type] :
      ( v123002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v123001(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123002(VarNext)
      <=> v123003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v123003(VarNext)
      <=> ( v123005(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v123005(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_70364,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,11)
    <=> v113040(VarCurr,11) ) ).

tff(addAssignment_70363,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,11)
    <=> v113042(VarCurr,11) ) ).

tff(addAssignment_70362,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,11)
    <=> v113044(VarCurr,11) ) ).

tff(addAssignment_70361,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,11)
    <=> v113045(VarCurr,11) ) ).

tff(addAssignment_70360,axiom,
    ! [VarCurr: state_type] :
      ( v122989(VarCurr)
    <=> v112940(VarCurr,11) ) ).

tff(addAssignment_70359,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,11)
    <=> v112942(VarCurr,11) ) ).

tff(addAssignment_70358,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,11)
    <=> v112944(VarCurr,11) ) ).

tff(addAssignment_70357,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,11)
    <=> v112946(VarCurr,11) ) ).

tff(addAssignment_70356,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,11)
    <=> v112948(VarCurr,11) ) ).

tff(addAssignment_70355,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,11)
    <=> v122991(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_1594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122992(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v122991(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1594,axiom,
    ! [VarNext: state_type] :
      ( v122992(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v122991(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122992(VarNext)
      <=> v122993(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122993(VarNext)
      <=> ( v122995(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122995(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_70354,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,11)
    <=> v112960(VarCurr,11) ) ).

tff(addAssignment_70353,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,11)
    <=> v112962(VarCurr,11) ) ).

tff(addAssignment_70352,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,11)
    <=> v112964(VarCurr,11) ) ).

tff(addAssignment_70351,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,11)
    <=> v112965(VarCurr,11) ) ).

tff(addAssignment_70350,axiom,
    ! [VarCurr: state_type] :
      ( v122778(VarCurr,2)
    <=> v122793(VarCurr,2) ) ).

tff(addAssignment_70349,axiom,
    ! [VarCurr: state_type] :
      ( v122778(VarCurr,1)
    <=> v122793(VarCurr,1) ) ).

tff(addAssignment_70348,axiom,
    ! [VarCurr: state_type] :
      ( v122778(VarCurr,0)
    <=> v122793(VarCurr,0) ) ).

tff(addAssignment_70347,axiom,
    ! [VarCurr: state_type] :
      ( v122793(VarCurr,0)
    <=> v122981(VarCurr) ) ).

tff(addAssignment_70346,axiom,
    ! [VarCurr: state_type] :
      ( v122793(VarCurr,1)
    <=> v122976(VarCurr) ) ).

tff(addAssignment_70345,axiom,
    ! [VarCurr: state_type] :
      ( v122793(VarCurr,2)
    <=> v122795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15013,axiom,
    ! [VarCurr: state_type] :
      ( v122981(VarCurr)
    <=> ( v122982(VarCurr)
        & v122985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15012,axiom,
    ! [VarCurr: state_type] :
      ( v122985(VarCurr)
    <=> ( v122801(VarCurr,0)
        | v122962(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15011,axiom,
    ! [VarCurr: state_type] :
      ( v122982(VarCurr)
    <=> ( v122983(VarCurr)
        | v122984(VarCurr) ) ) ).

tff(writeUnaryOperator_8292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122984(VarCurr)
    <=> v122962(VarCurr,0) ) ).

tff(writeUnaryOperator_8291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122983(VarCurr)
    <=> v122801(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15010,axiom,
    ! [VarCurr: state_type] :
      ( v122976(VarCurr)
    <=> ( v122977(VarCurr)
        & v122980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15009,axiom,
    ! [VarCurr: state_type] :
      ( v122980(VarCurr)
    <=> ( v122800(VarCurr)
        | v122963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15008,axiom,
    ! [VarCurr: state_type] :
      ( v122977(VarCurr)
    <=> ( v122978(VarCurr)
        | v122979(VarCurr) ) ) ).

tff(writeUnaryOperator_8290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122979(VarCurr)
    <=> v122963(VarCurr) ) ).

tff(writeUnaryOperator_8289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122978(VarCurr)
    <=> v122800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15007,axiom,
    ! [VarCurr: state_type] :
      ( v122795(VarCurr)
    <=> ( v122796(VarCurr)
        & v122975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15006,axiom,
    ! [VarCurr: state_type] :
      ( v122975(VarCurr)
    <=> ( v122798(VarCurr)
        | v122970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15005,axiom,
    ! [VarCurr: state_type] :
      ( v122796(VarCurr)
    <=> ( v122797(VarCurr)
        | v122969(VarCurr) ) ) ).

tff(writeUnaryOperator_8288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122969(VarCurr)
    <=> v122970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15004,axiom,
    ! [VarCurr: state_type] :
      ( v122970(VarCurr)
    <=> ( v122971(VarCurr)
        & v122974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5391,axiom,
    ! [VarCurr: state_type] :
      ( v122974(VarCurr)
    <=> ( v122801(VarCurr,2)
        | v122962(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15003,axiom,
    ! [VarCurr: state_type] :
      ( v122971(VarCurr)
    <=> ( v122972(VarCurr)
        | v122973(VarCurr) ) ) ).

tff(writeUnaryOperator_8287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122973(VarCurr)
    <=> v122962(VarCurr,2) ) ).

tff(writeUnaryOperator_8286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122972(VarCurr)
    <=> v122801(VarCurr,2) ) ).

tff(writeUnaryOperator_8285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122797(VarCurr)
    <=> v122798(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15002,axiom,
    ! [VarCurr: state_type] :
      ( v122798(VarCurr)
    <=> ( v122799(VarCurr)
        | v122968(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5390,axiom,
    ! [VarCurr: state_type] :
      ( v122968(VarCurr)
    <=> ( v122801(VarCurr,1)
        & v122962(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15001,axiom,
    ! [VarCurr: state_type] :
      ( v122799(VarCurr)
    <=> ( v122800(VarCurr)
        & v122963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15000,axiom,
    ! [VarCurr: state_type] :
      ( v122963(VarCurr)
    <=> ( v122964(VarCurr)
        & v122967(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5389,axiom,
    ! [VarCurr: state_type] :
      ( v122967(VarCurr)
    <=> ( v122801(VarCurr,1)
        | v122962(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14999,axiom,
    ! [VarCurr: state_type] :
      ( v122964(VarCurr)
    <=> ( v122965(VarCurr)
        | v122966(VarCurr) ) ) ).

tff(writeUnaryOperator_8284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122966(VarCurr)
    <=> v122962(VarCurr,1) ) ).

tff(writeUnaryOperator_8283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122965(VarCurr)
    <=> v122801(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14998,axiom,
    ! [VarCurr: state_type] :
      ( v122800(VarCurr)
    <=> ( v122801(VarCurr,0)
        & v122962(VarCurr,0) ) ) ).

tff(addAssignment_70344,axiom,
    ! [VarCurr: state_type] :
      ( v122962(VarCurr,0)
    <=> v122792(VarCurr) ) ).

tff(addAssignment_70343,axiom,
    ! [VarCurr: state_type] :
      ( ( v122962(VarCurr,2)
      <=> $false )
      & ( v122962(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70342,axiom,
    ! [VarCurr: state_type] :
      ( v122801(VarCurr,0)
    <=> v122957(VarCurr) ) ).

tff(addAssignment_70341,axiom,
    ! [VarCurr: state_type] :
      ( v122801(VarCurr,1)
    <=> v122952(VarCurr) ) ).

tff(addAssignment_70340,axiom,
    ! [VarCurr: state_type] :
      ( v122801(VarCurr,2)
    <=> v122803(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14997,axiom,
    ! [VarCurr: state_type] :
      ( v122957(VarCurr)
    <=> ( v122958(VarCurr)
        & v122961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14996,axiom,
    ! [VarCurr: state_type] :
      ( v122961(VarCurr)
    <=> ( v122809(VarCurr,0)
        | v122938(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14995,axiom,
    ! [VarCurr: state_type] :
      ( v122958(VarCurr)
    <=> ( v122959(VarCurr)
        | v122960(VarCurr) ) ) ).

tff(writeUnaryOperator_8282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122960(VarCurr)
    <=> v122938(VarCurr,0) ) ).

tff(writeUnaryOperator_8281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122959(VarCurr)
    <=> v122809(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14994,axiom,
    ! [VarCurr: state_type] :
      ( v122952(VarCurr)
    <=> ( v122953(VarCurr)
        & v122956(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14993,axiom,
    ! [VarCurr: state_type] :
      ( v122956(VarCurr)
    <=> ( v122808(VarCurr)
        | v122939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14992,axiom,
    ! [VarCurr: state_type] :
      ( v122953(VarCurr)
    <=> ( v122954(VarCurr)
        | v122955(VarCurr) ) ) ).

tff(writeUnaryOperator_8280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122955(VarCurr)
    <=> v122939(VarCurr) ) ).

tff(writeUnaryOperator_8279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122954(VarCurr)
    <=> v122808(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14991,axiom,
    ! [VarCurr: state_type] :
      ( v122803(VarCurr)
    <=> ( v122804(VarCurr)
        & v122951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14990,axiom,
    ! [VarCurr: state_type] :
      ( v122951(VarCurr)
    <=> ( v122806(VarCurr)
        | v122946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14989,axiom,
    ! [VarCurr: state_type] :
      ( v122804(VarCurr)
    <=> ( v122805(VarCurr)
        | v122945(VarCurr) ) ) ).

tff(writeUnaryOperator_8278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122945(VarCurr)
    <=> v122946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14988,axiom,
    ! [VarCurr: state_type] :
      ( v122946(VarCurr)
    <=> ( v122947(VarCurr)
        & v122950(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5388,axiom,
    ! [VarCurr: state_type] :
      ( v122950(VarCurr)
    <=> ( v122809(VarCurr,2)
        | v122938(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14987,axiom,
    ! [VarCurr: state_type] :
      ( v122947(VarCurr)
    <=> ( v122948(VarCurr)
        | v122949(VarCurr) ) ) ).

tff(writeUnaryOperator_8277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122949(VarCurr)
    <=> v122938(VarCurr,2) ) ).

tff(writeUnaryOperator_8276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122948(VarCurr)
    <=> v122809(VarCurr,2) ) ).

tff(writeUnaryOperator_8275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122805(VarCurr)
    <=> v122806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14986,axiom,
    ! [VarCurr: state_type] :
      ( v122806(VarCurr)
    <=> ( v122807(VarCurr)
        | v122944(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5387,axiom,
    ! [VarCurr: state_type] :
      ( v122944(VarCurr)
    <=> ( v122809(VarCurr,1)
        & v122938(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14985,axiom,
    ! [VarCurr: state_type] :
      ( v122807(VarCurr)
    <=> ( v122808(VarCurr)
        & v122939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14984,axiom,
    ! [VarCurr: state_type] :
      ( v122939(VarCurr)
    <=> ( v122940(VarCurr)
        & v122943(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5386,axiom,
    ! [VarCurr: state_type] :
      ( v122943(VarCurr)
    <=> ( v122809(VarCurr,1)
        | v122938(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14983,axiom,
    ! [VarCurr: state_type] :
      ( v122940(VarCurr)
    <=> ( v122941(VarCurr)
        | v122942(VarCurr) ) ) ).

tff(writeUnaryOperator_8274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122942(VarCurr)
    <=> v122938(VarCurr,1) ) ).

tff(writeUnaryOperator_8273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122941(VarCurr)
    <=> v122809(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14982,axiom,
    ! [VarCurr: state_type] :
      ( v122808(VarCurr)
    <=> ( v122809(VarCurr,0)
        & v122938(VarCurr,0) ) ) ).

tff(addAssignment_70339,axiom,
    ! [VarCurr: state_type] :
      ( v122938(VarCurr,0)
    <=> v122790(VarCurr) ) ).

tff(addAssignment_70338,axiom,
    ! [VarCurr: state_type] :
      ( ( v122938(VarCurr,2)
      <=> $false )
      & ( v122938(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70337,axiom,
    ! [VarCurr: state_type] :
      ( v122809(VarCurr,0)
    <=> v122933(VarCurr) ) ).

tff(addAssignment_70336,axiom,
    ! [VarCurr: state_type] :
      ( v122809(VarCurr,1)
    <=> v122928(VarCurr) ) ).

tff(addAssignment_70335,axiom,
    ! [VarCurr: state_type] :
      ( v122809(VarCurr,2)
    <=> v122811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14981,axiom,
    ! [VarCurr: state_type] :
      ( v122933(VarCurr)
    <=> ( v122934(VarCurr)
        & v122937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14980,axiom,
    ! [VarCurr: state_type] :
      ( v122937(VarCurr)
    <=> ( v122817(VarCurr,0)
        | v122914(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14979,axiom,
    ! [VarCurr: state_type] :
      ( v122934(VarCurr)
    <=> ( v122935(VarCurr)
        | v122936(VarCurr) ) ) ).

tff(writeUnaryOperator_8272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122936(VarCurr)
    <=> v122914(VarCurr,0) ) ).

tff(writeUnaryOperator_8271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122935(VarCurr)
    <=> v122817(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14978,axiom,
    ! [VarCurr: state_type] :
      ( v122928(VarCurr)
    <=> ( v122929(VarCurr)
        & v122932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14977,axiom,
    ! [VarCurr: state_type] :
      ( v122932(VarCurr)
    <=> ( v122816(VarCurr)
        | v122915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14976,axiom,
    ! [VarCurr: state_type] :
      ( v122929(VarCurr)
    <=> ( v122930(VarCurr)
        | v122931(VarCurr) ) ) ).

tff(writeUnaryOperator_8270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122931(VarCurr)
    <=> v122915(VarCurr) ) ).

tff(writeUnaryOperator_8269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122930(VarCurr)
    <=> v122816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14975,axiom,
    ! [VarCurr: state_type] :
      ( v122811(VarCurr)
    <=> ( v122812(VarCurr)
        & v122927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14974,axiom,
    ! [VarCurr: state_type] :
      ( v122927(VarCurr)
    <=> ( v122814(VarCurr)
        | v122922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14973,axiom,
    ! [VarCurr: state_type] :
      ( v122812(VarCurr)
    <=> ( v122813(VarCurr)
        | v122921(VarCurr) ) ) ).

tff(writeUnaryOperator_8268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122921(VarCurr)
    <=> v122922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14972,axiom,
    ! [VarCurr: state_type] :
      ( v122922(VarCurr)
    <=> ( v122923(VarCurr)
        & v122926(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5385,axiom,
    ! [VarCurr: state_type] :
      ( v122926(VarCurr)
    <=> ( v122817(VarCurr,2)
        | v122914(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14971,axiom,
    ! [VarCurr: state_type] :
      ( v122923(VarCurr)
    <=> ( v122924(VarCurr)
        | v122925(VarCurr) ) ) ).

tff(writeUnaryOperator_8267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122925(VarCurr)
    <=> v122914(VarCurr,2) ) ).

tff(writeUnaryOperator_8266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122924(VarCurr)
    <=> v122817(VarCurr,2) ) ).

tff(writeUnaryOperator_8265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122813(VarCurr)
    <=> v122814(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14970,axiom,
    ! [VarCurr: state_type] :
      ( v122814(VarCurr)
    <=> ( v122815(VarCurr)
        | v122920(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5384,axiom,
    ! [VarCurr: state_type] :
      ( v122920(VarCurr)
    <=> ( v122817(VarCurr,1)
        & v122914(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14969,axiom,
    ! [VarCurr: state_type] :
      ( v122815(VarCurr)
    <=> ( v122816(VarCurr)
        & v122915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14968,axiom,
    ! [VarCurr: state_type] :
      ( v122915(VarCurr)
    <=> ( v122916(VarCurr)
        & v122919(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5383,axiom,
    ! [VarCurr: state_type] :
      ( v122919(VarCurr)
    <=> ( v122817(VarCurr,1)
        | v122914(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14967,axiom,
    ! [VarCurr: state_type] :
      ( v122916(VarCurr)
    <=> ( v122917(VarCurr)
        | v122918(VarCurr) ) ) ).

tff(writeUnaryOperator_8264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122918(VarCurr)
    <=> v122914(VarCurr,1) ) ).

tff(writeUnaryOperator_8263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122917(VarCurr)
    <=> v122817(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14966,axiom,
    ! [VarCurr: state_type] :
      ( v122816(VarCurr)
    <=> ( v122817(VarCurr,0)
        & v122914(VarCurr,0) ) ) ).

tff(addAssignment_70334,axiom,
    ! [VarCurr: state_type] :
      ( v122914(VarCurr,0)
    <=> v122788(VarCurr) ) ).

tff(addAssignment_70333,axiom,
    ! [VarCurr: state_type] :
      ( ( v122914(VarCurr,2)
      <=> $false )
      & ( v122914(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70332,axiom,
    ! [VarCurr: state_type] :
      ( v122817(VarCurr,0)
    <=> v122909(VarCurr) ) ).

tff(addAssignment_70331,axiom,
    ! [VarCurr: state_type] :
      ( v122817(VarCurr,1)
    <=> v122904(VarCurr) ) ).

tff(addAssignment_70330,axiom,
    ! [VarCurr: state_type] :
      ( v122817(VarCurr,2)
    <=> v122819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14965,axiom,
    ! [VarCurr: state_type] :
      ( v122909(VarCurr)
    <=> ( v122910(VarCurr)
        & v122913(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14964,axiom,
    ! [VarCurr: state_type] :
      ( v122913(VarCurr)
    <=> ( v122825(VarCurr,0)
        | v122890(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14963,axiom,
    ! [VarCurr: state_type] :
      ( v122910(VarCurr)
    <=> ( v122911(VarCurr)
        | v122912(VarCurr) ) ) ).

tff(writeUnaryOperator_8262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122912(VarCurr)
    <=> v122890(VarCurr,0) ) ).

tff(writeUnaryOperator_8261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122911(VarCurr)
    <=> v122825(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14962,axiom,
    ! [VarCurr: state_type] :
      ( v122904(VarCurr)
    <=> ( v122905(VarCurr)
        & v122908(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14961,axiom,
    ! [VarCurr: state_type] :
      ( v122908(VarCurr)
    <=> ( v122824(VarCurr)
        | v122891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14960,axiom,
    ! [VarCurr: state_type] :
      ( v122905(VarCurr)
    <=> ( v122906(VarCurr)
        | v122907(VarCurr) ) ) ).

tff(writeUnaryOperator_8260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122907(VarCurr)
    <=> v122891(VarCurr) ) ).

tff(writeUnaryOperator_8259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122906(VarCurr)
    <=> v122824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14959,axiom,
    ! [VarCurr: state_type] :
      ( v122819(VarCurr)
    <=> ( v122820(VarCurr)
        & v122903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14958,axiom,
    ! [VarCurr: state_type] :
      ( v122903(VarCurr)
    <=> ( v122822(VarCurr)
        | v122898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14957,axiom,
    ! [VarCurr: state_type] :
      ( v122820(VarCurr)
    <=> ( v122821(VarCurr)
        | v122897(VarCurr) ) ) ).

tff(writeUnaryOperator_8258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122897(VarCurr)
    <=> v122898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14956,axiom,
    ! [VarCurr: state_type] :
      ( v122898(VarCurr)
    <=> ( v122899(VarCurr)
        & v122902(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5382,axiom,
    ! [VarCurr: state_type] :
      ( v122902(VarCurr)
    <=> ( v122825(VarCurr,2)
        | v122890(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14955,axiom,
    ! [VarCurr: state_type] :
      ( v122899(VarCurr)
    <=> ( v122900(VarCurr)
        | v122901(VarCurr) ) ) ).

tff(writeUnaryOperator_8257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122901(VarCurr)
    <=> v122890(VarCurr,2) ) ).

tff(writeUnaryOperator_8256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122900(VarCurr)
    <=> v122825(VarCurr,2) ) ).

tff(writeUnaryOperator_8255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122821(VarCurr)
    <=> v122822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14954,axiom,
    ! [VarCurr: state_type] :
      ( v122822(VarCurr)
    <=> ( v122823(VarCurr)
        | v122896(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5381,axiom,
    ! [VarCurr: state_type] :
      ( v122896(VarCurr)
    <=> ( v122825(VarCurr,1)
        & v122890(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14953,axiom,
    ! [VarCurr: state_type] :
      ( v122823(VarCurr)
    <=> ( v122824(VarCurr)
        & v122891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14952,axiom,
    ! [VarCurr: state_type] :
      ( v122891(VarCurr)
    <=> ( v122892(VarCurr)
        & v122895(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5380,axiom,
    ! [VarCurr: state_type] :
      ( v122895(VarCurr)
    <=> ( v122825(VarCurr,1)
        | v122890(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14951,axiom,
    ! [VarCurr: state_type] :
      ( v122892(VarCurr)
    <=> ( v122893(VarCurr)
        | v122894(VarCurr) ) ) ).

tff(writeUnaryOperator_8254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122894(VarCurr)
    <=> v122890(VarCurr,1) ) ).

tff(writeUnaryOperator_8253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122893(VarCurr)
    <=> v122825(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14950,axiom,
    ! [VarCurr: state_type] :
      ( v122824(VarCurr)
    <=> ( v122825(VarCurr,0)
        & v122890(VarCurr,0) ) ) ).

tff(addAssignment_70329,axiom,
    ! [VarCurr: state_type] :
      ( v122890(VarCurr,0)
    <=> v122786(VarCurr) ) ).

tff(addAssignment_70328,axiom,
    ! [VarCurr: state_type] :
      ( ( v122890(VarCurr,2)
      <=> $false )
      & ( v122890(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70327,axiom,
    ! [VarCurr: state_type] :
      ( v122825(VarCurr,0)
    <=> v122885(VarCurr) ) ).

tff(addAssignment_70326,axiom,
    ! [VarCurr: state_type] :
      ( v122825(VarCurr,1)
    <=> v122880(VarCurr) ) ).

tff(addAssignment_70325,axiom,
    ! [VarCurr: state_type] :
      ( v122825(VarCurr,2)
    <=> v122827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14949,axiom,
    ! [VarCurr: state_type] :
      ( v122885(VarCurr)
    <=> ( v122886(VarCurr)
        & v122889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14948,axiom,
    ! [VarCurr: state_type] :
      ( v122889(VarCurr)
    <=> ( v122833(VarCurr,0)
        | v122866(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14947,axiom,
    ! [VarCurr: state_type] :
      ( v122886(VarCurr)
    <=> ( v122887(VarCurr)
        | v122888(VarCurr) ) ) ).

tff(writeUnaryOperator_8252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122888(VarCurr)
    <=> v122866(VarCurr,0) ) ).

tff(writeUnaryOperator_8251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122887(VarCurr)
    <=> v122833(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14946,axiom,
    ! [VarCurr: state_type] :
      ( v122880(VarCurr)
    <=> ( v122881(VarCurr)
        & v122884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14945,axiom,
    ! [VarCurr: state_type] :
      ( v122884(VarCurr)
    <=> ( v122832(VarCurr)
        | v122867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14944,axiom,
    ! [VarCurr: state_type] :
      ( v122881(VarCurr)
    <=> ( v122882(VarCurr)
        | v122883(VarCurr) ) ) ).

tff(writeUnaryOperator_8250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122883(VarCurr)
    <=> v122867(VarCurr) ) ).

tff(writeUnaryOperator_8249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122882(VarCurr)
    <=> v122832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14943,axiom,
    ! [VarCurr: state_type] :
      ( v122827(VarCurr)
    <=> ( v122828(VarCurr)
        & v122879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14942,axiom,
    ! [VarCurr: state_type] :
      ( v122879(VarCurr)
    <=> ( v122830(VarCurr)
        | v122874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14941,axiom,
    ! [VarCurr: state_type] :
      ( v122828(VarCurr)
    <=> ( v122829(VarCurr)
        | v122873(VarCurr) ) ) ).

tff(writeUnaryOperator_8248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122873(VarCurr)
    <=> v122874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14940,axiom,
    ! [VarCurr: state_type] :
      ( v122874(VarCurr)
    <=> ( v122875(VarCurr)
        & v122878(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5379,axiom,
    ! [VarCurr: state_type] :
      ( v122878(VarCurr)
    <=> ( v122833(VarCurr,2)
        | v122866(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14939,axiom,
    ! [VarCurr: state_type] :
      ( v122875(VarCurr)
    <=> ( v122876(VarCurr)
        | v122877(VarCurr) ) ) ).

tff(writeUnaryOperator_8247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122877(VarCurr)
    <=> v122866(VarCurr,2) ) ).

tff(writeUnaryOperator_8246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122876(VarCurr)
    <=> v122833(VarCurr,2) ) ).

tff(writeUnaryOperator_8245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122829(VarCurr)
    <=> v122830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14938,axiom,
    ! [VarCurr: state_type] :
      ( v122830(VarCurr)
    <=> ( v122831(VarCurr)
        | v122872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5378,axiom,
    ! [VarCurr: state_type] :
      ( v122872(VarCurr)
    <=> ( v122833(VarCurr,1)
        & v122866(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14937,axiom,
    ! [VarCurr: state_type] :
      ( v122831(VarCurr)
    <=> ( v122832(VarCurr)
        & v122867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14936,axiom,
    ! [VarCurr: state_type] :
      ( v122867(VarCurr)
    <=> ( v122868(VarCurr)
        & v122871(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5377,axiom,
    ! [VarCurr: state_type] :
      ( v122871(VarCurr)
    <=> ( v122833(VarCurr,1)
        | v122866(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14935,axiom,
    ! [VarCurr: state_type] :
      ( v122868(VarCurr)
    <=> ( v122869(VarCurr)
        | v122870(VarCurr) ) ) ).

tff(writeUnaryOperator_8244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122870(VarCurr)
    <=> v122866(VarCurr,1) ) ).

tff(writeUnaryOperator_8243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122869(VarCurr)
    <=> v122833(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14934,axiom,
    ! [VarCurr: state_type] :
      ( v122832(VarCurr)
    <=> ( v122833(VarCurr,0)
        & v122866(VarCurr,0) ) ) ).

tff(addAssignment_70324,axiom,
    ! [VarCurr: state_type] :
      ( v122866(VarCurr,0)
    <=> v122784(VarCurr) ) ).

tff(addAssignment_70323,axiom,
    ! [VarCurr: state_type] :
      ( ( v122866(VarCurr,2)
      <=> $false )
      & ( v122866(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70322,axiom,
    ! [VarCurr: state_type] :
      ( v122833(VarCurr,0)
    <=> v122861(VarCurr) ) ).

tff(addAssignment_70321,axiom,
    ! [VarCurr: state_type] :
      ( v122833(VarCurr,1)
    <=> v122856(VarCurr) ) ).

tff(addAssignment_70320,axiom,
    ! [VarCurr: state_type] :
      ( v122833(VarCurr,2)
    <=> v122835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14933,axiom,
    ! [VarCurr: state_type] :
      ( v122861(VarCurr)
    <=> ( v122862(VarCurr)
        & v122865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14932,axiom,
    ! [VarCurr: state_type] :
      ( v122865(VarCurr)
    <=> ( v122841(VarCurr,0)
        | v122842(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14931,axiom,
    ! [VarCurr: state_type] :
      ( v122862(VarCurr)
    <=> ( v122863(VarCurr)
        | v122864(VarCurr) ) ) ).

tff(writeUnaryOperator_8242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122864(VarCurr)
    <=> v122842(VarCurr,0) ) ).

tff(writeUnaryOperator_8241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122863(VarCurr)
    <=> v122841(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14930,axiom,
    ! [VarCurr: state_type] :
      ( v122856(VarCurr)
    <=> ( v122857(VarCurr)
        & v122860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14929,axiom,
    ! [VarCurr: state_type] :
      ( v122860(VarCurr)
    <=> ( v122840(VarCurr)
        | v122843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14928,axiom,
    ! [VarCurr: state_type] :
      ( v122857(VarCurr)
    <=> ( v122858(VarCurr)
        | v122859(VarCurr) ) ) ).

tff(writeUnaryOperator_8240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122859(VarCurr)
    <=> v122843(VarCurr) ) ).

tff(writeUnaryOperator_8239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122858(VarCurr)
    <=> v122840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14927,axiom,
    ! [VarCurr: state_type] :
      ( v122835(VarCurr)
    <=> ( v122836(VarCurr)
        & v122855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14926,axiom,
    ! [VarCurr: state_type] :
      ( v122855(VarCurr)
    <=> ( v122838(VarCurr)
        | v122850(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14925,axiom,
    ! [VarCurr: state_type] :
      ( v122836(VarCurr)
    <=> ( v122837(VarCurr)
        | v122849(VarCurr) ) ) ).

tff(writeUnaryOperator_8238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122849(VarCurr)
    <=> v122850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14924,axiom,
    ! [VarCurr: state_type] :
      ( v122850(VarCurr)
    <=> ( v122851(VarCurr)
        & v122854(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5376,axiom,
    ! [VarCurr: state_type] :
      ( v122854(VarCurr)
    <=> ( v122841(VarCurr,2)
        | v122842(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14923,axiom,
    ! [VarCurr: state_type] :
      ( v122851(VarCurr)
    <=> ( v122852(VarCurr)
        | v122853(VarCurr) ) ) ).

tff(writeUnaryOperator_8237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122853(VarCurr)
    <=> v122842(VarCurr,2) ) ).

tff(writeUnaryOperator_8236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122852(VarCurr)
    <=> v122841(VarCurr,2) ) ).

tff(writeUnaryOperator_8235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122837(VarCurr)
    <=> v122838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14922,axiom,
    ! [VarCurr: state_type] :
      ( v122838(VarCurr)
    <=> ( v122839(VarCurr)
        | v122848(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5375,axiom,
    ! [VarCurr: state_type] :
      ( v122848(VarCurr)
    <=> ( v122841(VarCurr,1)
        & v122842(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14921,axiom,
    ! [VarCurr: state_type] :
      ( v122839(VarCurr)
    <=> ( v122840(VarCurr)
        & v122843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14920,axiom,
    ! [VarCurr: state_type] :
      ( v122843(VarCurr)
    <=> ( v122844(VarCurr)
        & v122847(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5374,axiom,
    ! [VarCurr: state_type] :
      ( v122847(VarCurr)
    <=> ( v122841(VarCurr,1)
        | v122842(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14919,axiom,
    ! [VarCurr: state_type] :
      ( v122844(VarCurr)
    <=> ( v122845(VarCurr)
        | v122846(VarCurr) ) ) ).

tff(writeUnaryOperator_8234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122846(VarCurr)
    <=> v122842(VarCurr,1) ) ).

tff(writeUnaryOperator_8233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122845(VarCurr)
    <=> v122841(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14918,axiom,
    ! [VarCurr: state_type] :
      ( v122840(VarCurr)
    <=> ( v122841(VarCurr,0)
        & v122842(VarCurr,0) ) ) ).

tff(addAssignment_70319,axiom,
    ! [VarCurr: state_type] :
      ( v122842(VarCurr,0)
    <=> v122782(VarCurr) ) ).

tff(addAssignment_70318,axiom,
    ! [VarCurr: state_type] :
      ( ( v122842(VarCurr,2)
      <=> $false )
      & ( v122842(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70317,axiom,
    ! [VarCurr: state_type] :
      ( v122841(VarCurr,0)
    <=> v122780(VarCurr) ) ).

tff(addAssignment_70316,axiom,
    ! [VarCurr: state_type] :
      ( ( v122841(VarCurr,2)
      <=> $false )
      & ( v122841(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70315,axiom,
    ! [VarCurr: state_type] :
      ( v122792(VarCurr)
    <=> v114692(VarCurr,11) ) ).

tff(addAssignment_70314,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,11)
    <=> v114694(VarCurr,11) ) ).

tff(addAssignment_70313,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,11)
    <=> v114696(VarCurr,11) ) ).

tff(addAssignment_70312,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,11)
    <=> v114697(VarCurr,11) ) ).

tff(addAssignment_70311,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,11)
    <=> v113918(VarCurr,11) ) ).

tff(addAssignment_70310,axiom,
    ! [VarCurr: state_type] :
      ( v122790(VarCurr)
    <=> v114685(VarCurr,11) ) ).

tff(addAssignment_70309,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,11)
    <=> v114686(VarCurr,11) ) ).

tff(addAssignment_70308,axiom,
    ! [VarCurr: state_type] :
      ( v122788(VarCurr)
    <=> v114661(VarCurr,11) ) ).

tff(addAssignment_70307,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,11)
    <=> v114662(VarCurr,11) ) ).

tff(addAssignment_70306,axiom,
    ! [VarCurr: state_type] :
      ( v122786(VarCurr)
    <=> v114633(VarCurr,11) ) ).

tff(addAssignment_70305,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,11)
    <=> v114635(VarCurr,11) ) ).

tff(addAssignment_70304,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,11)
    <=> v114637(VarCurr,11) ) ).

tff(addAssignment_70303,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,11)
    <=> v114638(VarCurr,11) ) ).

tff(addAssignment_70302,axiom,
    ! [VarCurr: state_type] :
      ( v122784(VarCurr)
    <=> v114605(VarCurr,11) ) ).

tff(addAssignment_70301,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,11)
    <=> v114607(VarCurr,11) ) ).

tff(addAssignment_70300,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,11)
    <=> v114609(VarCurr,11) ) ).

tff(addAssignment_70299,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,11)
    <=> v114610(VarCurr,11) ) ).

tff(addAssignment_70298,axiom,
    ! [VarCurr: state_type] :
      ( v122782(VarCurr)
    <=> v114577(VarCurr,11) ) ).

tff(addAssignment_70297,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,11)
    <=> v114579(VarCurr,11) ) ).

tff(addAssignment_70296,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,11)
    <=> v114581(VarCurr,11) ) ).

tff(addAssignment_70295,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,11)
    <=> v114582(VarCurr,11) ) ).

tff(addAssignment_70294,axiom,
    ! [VarCurr: state_type] :
      ( v122780(VarCurr)
    <=> v114549(VarCurr,11) ) ).

tff(addAssignment_70293,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,11)
    <=> v114551(VarCurr,11) ) ).

tff(addAssignment_70292,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,11)
    <=> v114553(VarCurr,11) ) ).

tff(addAssignment_70291,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,11)
    <=> v114554(VarCurr,11) ) ).

tff(addAssignment_70290,axiom,
    ! [VarCurr: state_type] :
      ( v122766(VarCurr)
    <=> v122768(VarCurr) ) ).

tff(addAssignment_70289,axiom,
    ! [VarCurr: state_type] :
      ( v122768(VarCurr)
    <=> v122742(VarCurr) ) ).

tff(addAssignment_70288,axiom,
    ! [VarCurr: state_type] :
      ( v122762(VarCurr)
    <=> v122764(VarCurr) ) ).

tff(addAssignment_70287,axiom,
    ! [VarCurr: state_type] :
      ( v122764(VarCurr)
    <=> v122734(VarCurr) ) ).

tff(addAssignment_70286,axiom,
    ! [VarCurr: state_type] :
      ( v122738(VarCurr)
    <=> v122740(VarCurr) ) ).

tff(addAssignment_70285,axiom,
    ! [VarCurr: state_type] :
      ( v122740(VarCurr)
    <=> v122742(VarCurr) ) ).

tff(addAssignment_70284,axiom,
    ! [VarCurr: state_type] :
      ( v122742(VarCurr)
    <=> v122744(VarCurr) ) ).

tff(addAssignment_70283,axiom,
    ! [VarCurr: state_type] :
      ( v122744(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_70282,axiom,
    ! [VarCurr: state_type] :
      ( v122730(VarCurr)
    <=> v122732(VarCurr) ) ).

tff(addAssignment_70281,axiom,
    ! [VarCurr: state_type] :
      ( v122732(VarCurr)
    <=> v122734(VarCurr) ) ).

tff(addAssignment_70280,axiom,
    ! [VarCurr: state_type] :
      ( v122734(VarCurr)
    <=> v122736(VarCurr) ) ).

tff(addAssignment_70279,axiom,
    ! [VarCurr: state_type] :
      ( v122736(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14917,axiom,
    ! [VarCurr: state_type] :
      ( v121921(VarCurr)
    <=> ( v122720(VarCurr)
        & v122630(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5373,axiom,
    ! [VarCurr: state_type] :
      ( v122720(VarCurr)
    <=> ( v121923(VarCurr,1)
        & v122569(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1214,axiom,
    ! [VarCurr: state_type] :
      ( v122630(VarCurr)
    <=> ( ( v122632(VarCurr,4)
        <=> $false )
        & ( v122632(VarCurr,3)
        <=> $false )
        & ( v122632(VarCurr,2)
        <=> $false )
        & ( v122632(VarCurr,1)
        <=> $false )
        & ( v122632(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122632(VarCurr,B)
      <=> v122634(VarCurr,B) ) ) ).

tff(addAssignment_70277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122634(VarCurr,B)
      <=> v122636(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122702(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v122636(VarNext,B)
            <=> v122636(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1593,axiom,
    ! [VarNext: state_type] :
      ( v122702(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122636(VarNext,B)
          <=> v122712(VarNext,B) ) ) ) ).

tff(addAssignment_70276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122712(VarNext,B)
          <=> v122710(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122713(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122710(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1139,axiom,
    ! [VarCurr: state_type] :
      ( v122713(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122710(VarCurr,B)
          <=> v122646(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14916,axiom,
    ! [VarCurr: state_type] :
      ( v122713(VarCurr)
    <=> ( v122714(VarCurr)
        & v122715(VarCurr) ) ) ).

tff(writeUnaryOperator_8232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122715(VarCurr)
    <=> v122642(VarCurr) ) ).

tff(writeUnaryOperator_8231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122714(VarCurr)
    <=> v122638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122702(VarNext)
      <=> v122703(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122703(VarNext)
      <=> ( v122704(VarNext)
          & v122697(VarNext) ) ) ) ).

tff(writeUnaryOperator_8230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122704(VarNext)
      <=> v122706(VarNext) ) ) ).

tff(addAssignment_70275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122706(VarNext)
      <=> v122697(VarCurr) ) ) ).

tff(addAssignment_70274,axiom,
    ! [VarCurr: state_type] :
      ( v122697(VarCurr)
    <=> v122699(VarCurr) ) ).

tff(addAssignment_70273,axiom,
    ! [VarCurr: state_type] :
      ( v122699(VarCurr)
    <=> v122403(VarCurr) ) ).

tff(addAssignment_70272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122646(VarCurr,B)
      <=> v122648(VarCurr,B) ) ) ).

tff(addAssignment_70271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122648(VarCurr,B)
      <=> v122650(VarCurr,B) ) ) ).

tff(addAssignment_70270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122650(VarCurr,B)
      <=> v122652(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122654(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122652(VarCurr,B)
          <=> v122666(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1138,axiom,
    ! [VarCurr: state_type] :
      ( v122654(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122652(VarCurr,B)
          <=> v122659(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122661(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122666(VarCurr,B)
          <=> v122667(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1137,axiom,
    ! [VarCurr: state_type] :
      ( v122661(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122666(VarCurr,B)
          <=> v122664(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122630(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122667(VarCurr,B)
          <=> v122668(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1136,axiom,
    ! [VarCurr: state_type] :
      ( v122630(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v122667(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70269,axiom,
    ! [VarCurr: state_type] :
      ( v122668(VarCurr,0)
    <=> v122694(VarCurr) ) ).

tff(addAssignment_70268,axiom,
    ! [VarCurr: state_type] :
      ( v122668(VarCurr,1)
    <=> v122692(VarCurr) ) ).

tff(addAssignment_70267,axiom,
    ! [VarCurr: state_type] :
      ( v122668(VarCurr,2)
    <=> v122688(VarCurr) ) ).

tff(addAssignment_70266,axiom,
    ! [VarCurr: state_type] :
      ( v122668(VarCurr,3)
    <=> v122684(VarCurr) ) ).

tff(addAssignment_70265,axiom,
    ! [VarCurr: state_type] :
      ( v122668(VarCurr,4)
    <=> v122670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14913,axiom,
    ! [VarCurr: state_type] :
      ( v122692(VarCurr)
    <=> ( v122693(VarCurr)
        & v122695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14912,axiom,
    ! [VarCurr: state_type] :
      ( v122695(VarCurr)
    <=> ( v122632(VarCurr,0)
        | v122679(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5372,axiom,
    ! [VarCurr: state_type] :
      ( v122693(VarCurr)
    <=> ( v122694(VarCurr)
        | v122632(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122694(VarCurr)
    <=> v122632(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14911,axiom,
    ! [VarCurr: state_type] :
      ( v122688(VarCurr)
    <=> ( v122689(VarCurr)
        & v122691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14910,axiom,
    ! [VarCurr: state_type] :
      ( v122691(VarCurr)
    <=> ( v122677(VarCurr)
        | v122680(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5371,axiom,
    ! [VarCurr: state_type] :
      ( v122689(VarCurr)
    <=> ( v122690(VarCurr)
        | v122632(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122690(VarCurr)
    <=> v122677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14909,axiom,
    ! [VarCurr: state_type] :
      ( v122684(VarCurr)
    <=> ( v122685(VarCurr)
        & v122687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14908,axiom,
    ! [VarCurr: state_type] :
      ( v122687(VarCurr)
    <=> ( v122675(VarCurr)
        | v122681(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5370,axiom,
    ! [VarCurr: state_type] :
      ( v122685(VarCurr)
    <=> ( v122686(VarCurr)
        | v122632(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122686(VarCurr)
    <=> v122675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14907,axiom,
    ! [VarCurr: state_type] :
      ( v122670(VarCurr)
    <=> ( v122671(VarCurr)
        & v122682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14906,axiom,
    ! [VarCurr: state_type] :
      ( v122682(VarCurr)
    <=> ( v122673(VarCurr)
        | v122683(VarCurr) ) ) ).

tff(writeUnaryOperator_8226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122683(VarCurr)
    <=> v122632(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5369,axiom,
    ! [VarCurr: state_type] :
      ( v122671(VarCurr)
    <=> ( v122672(VarCurr)
        | v122632(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122672(VarCurr)
    <=> v122673(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5368,axiom,
    ! [VarCurr: state_type] :
      ( v122673(VarCurr)
    <=> ( v122632(VarCurr,3)
        | v122674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14905,axiom,
    ! [VarCurr: state_type] :
      ( v122674(VarCurr)
    <=> ( v122675(VarCurr)
        & v122681(VarCurr) ) ) ).

tff(writeUnaryOperator_8224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122681(VarCurr)
    <=> v122632(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5367,axiom,
    ! [VarCurr: state_type] :
      ( v122675(VarCurr)
    <=> ( v122632(VarCurr,2)
        | v122676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14904,axiom,
    ! [VarCurr: state_type] :
      ( v122676(VarCurr)
    <=> ( v122677(VarCurr)
        & v122680(VarCurr) ) ) ).

tff(writeUnaryOperator_8223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122680(VarCurr)
    <=> v122632(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5366,axiom,
    ! [VarCurr: state_type] :
      ( v122677(VarCurr)
    <=> ( v122632(VarCurr,1)
        | v122678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14903,axiom,
    ! [VarCurr: state_type] :
      ( v122678(VarCurr)
    <=> ( v122632(VarCurr,0)
        & v122679(VarCurr) ) ) ).

tff(writeUnaryOperator_8222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122679(VarCurr)
    <=> v122632(VarCurr,1) ) ).

tff(addAssignment_70264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122664(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14902,axiom,
    ! [VarCurr: state_type] :
      ( v122661(VarCurr)
    <=> ( v122208(VarCurr)
        | v122222(VarCurr) ) ) ).

tff(addAssignment_70263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v122659(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14901,axiom,
    ! [VarCurr: state_type] :
      ( v122654(VarCurr)
    <=> ( v122656(VarCurr)
        | v122220(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14900,axiom,
    ! [VarCurr: state_type] :
      ( v122656(VarCurr)
    <=> ( v122657(VarCurr)
        | v122218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14899,axiom,
    ! [VarCurr: state_type] :
      ( v122657(VarCurr)
    <=> ( v122188(VarCurr)
        | v122198(VarCurr) ) ) ).

tff(addAssignment_70262,axiom,
    ! [VarCurr: state_type] :
      ( v122642(VarCurr)
    <=> v122644(VarCurr) ) ).

tff(addAssignment_70261,axiom,
    ! [VarCurr: state_type] :
      ( v122644(VarCurr)
    <=> v121941(VarCurr) ) ).

tff(addAssignment_70260,axiom,
    ! [VarCurr: state_type] :
      ( v122638(VarCurr)
    <=> v122640(VarCurr) ) ).

tff(addAssignment_70259,axiom,
    ! [VarCurr: state_type] :
      ( v122640(VarCurr)
    <=> v121933(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1213,axiom,
    ! [VarCurr: state_type] :
      ( v122569(VarCurr)
    <=> ( ( v122571(VarCurr,1)
        <=> $false )
        & ( v122571(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v122571(VarCurr,B)
      <=> v122573(VarCurr,B) ) ) ).

tff(addAssignment_70257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v122573(VarCurr,B)
      <=> v122575(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122612(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v122575(VarNext,B)
            <=> v122575(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1592,axiom,
    ! [VarNext: state_type] :
      ( v122612(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122575(VarNext,B)
          <=> v122622(VarNext,B) ) ) ) ).

tff(addAssignment_70256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122622(VarNext,B)
          <=> v122620(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122623(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122620(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1135,axiom,
    ! [VarCurr: state_type] :
      ( v122623(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122620(VarCurr,B)
          <=> v122585(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14898,axiom,
    ! [VarCurr: state_type] :
      ( v122623(VarCurr)
    <=> ( v122624(VarCurr)
        & v122625(VarCurr) ) ) ).

tff(writeUnaryOperator_8221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122625(VarCurr)
    <=> v122581(VarCurr) ) ).

tff(writeUnaryOperator_8220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122624(VarCurr)
    <=> v122577(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122612(VarNext)
      <=> v122613(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122613(VarNext)
      <=> ( v122614(VarNext)
          & v122607(VarNext) ) ) ) ).

tff(writeUnaryOperator_8219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122614(VarNext)
      <=> v122616(VarNext) ) ) ).

tff(addAssignment_70255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122616(VarNext)
      <=> v122607(VarCurr) ) ) ).

tff(addAssignment_70254,axiom,
    ! [VarCurr: state_type] :
      ( v122607(VarCurr)
    <=> v122609(VarCurr) ) ).

tff(addAssignment_70253,axiom,
    ! [VarCurr: state_type] :
      ( v122609(VarCurr)
    <=> v122403(VarCurr) ) ).

tff(addAssignment_70252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v122585(VarCurr,B)
      <=> v122587(VarCurr,B) ) ) ).

tff(addAssignment_70251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v122587(VarCurr,B)
      <=> v122589(VarCurr,B) ) ) ).

tff(addAssignment_70250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v122589(VarCurr,B)
      <=> v122591(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122591(VarCurr,B)
          <=> v122598(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1134,axiom,
    ! [VarCurr: state_type] :
      ( v122593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122591(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122598(VarCurr,B)
          <=> v122599(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1133,axiom,
    ! [VarCurr: state_type] :
      ( v122569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v122598(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70249,axiom,
    ! [VarCurr: state_type] :
      ( v122599(VarCurr,0)
    <=> v122603(VarCurr) ) ).

tff(addAssignment_70248,axiom,
    ! [VarCurr: state_type] :
      ( v122599(VarCurr,1)
    <=> v122601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14895,axiom,
    ! [VarCurr: state_type] :
      ( v122601(VarCurr)
    <=> ( v122602(VarCurr)
        & v122604(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14894,axiom,
    ! [VarCurr: state_type] :
      ( v122604(VarCurr)
    <=> ( v122571(VarCurr,0)
        | v122605(VarCurr) ) ) ).

tff(writeUnaryOperator_8218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122605(VarCurr)
    <=> v122571(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5365,axiom,
    ! [VarCurr: state_type] :
      ( v122602(VarCurr)
    <=> ( v122603(VarCurr)
        | v122571(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122603(VarCurr)
    <=> v122571(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14893,axiom,
    ! [VarCurr: state_type] :
      ( v122593(VarCurr)
    <=> ( v122595(VarCurr)
        | v122596(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5364,axiom,
    ! [VarCurr: state_type] :
      ( v122596(VarCurr)
    <=> ( v121923(VarCurr,1)
        & v122436(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5363,axiom,
    ! [VarCurr: state_type] :
      ( v122595(VarCurr)
    <=> ( v121923(VarCurr,3)
        & v122494(VarCurr) ) ) ).

tff(addAssignment_70247,axiom,
    ! [VarCurr: state_type] :
      ( v122581(VarCurr)
    <=> v122583(VarCurr) ) ).

tff(addAssignment_70246,axiom,
    ! [VarCurr: state_type] :
      ( v122583(VarCurr)
    <=> v121941(VarCurr) ) ).

tff(addAssignment_70245,axiom,
    ! [VarCurr: state_type] :
      ( v122577(VarCurr)
    <=> v122579(VarCurr) ) ).

tff(addAssignment_70244,axiom,
    ! [VarCurr: state_type] :
      ( v122579(VarCurr)
    <=> v121933(VarCurr) ) ).

tff(addAssignment_70243,axiom,
    ! [VarCurr: state_type] :
      ( v121923(VarCurr,1)
    <=> v121925(VarCurr,1) ) ).

tff(addAssignment_70242,axiom,
    ! [VarCurr: state_type] :
      ( v121925(VarCurr,1)
    <=> v121927(VarCurr,1) ) ).

tff(addAssignment_70241,axiom,
    ! [VarNext: state_type] :
      ( v121927(VarNext,1)
    <=> v122561(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122562(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v122561(VarNext,B)
            <=> v121927(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1591,axiom,
    ! [VarNext: state_type] :
      ( v122562(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122561(VarNext,B)
          <=> v122487(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122562(VarNext)
      <=> v122563(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122563(VarNext)
      <=> ( v122565(VarNext)
          & v122472(VarNext) ) ) ) ).

tff(writeUnaryOperator_8216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122565(VarNext)
      <=> v122481(VarNext) ) ) ).

tff(addAssignment_70240,axiom,
    ! [VarCurr: state_type] :
      ( v121945(VarCurr,1)
    <=> v121947(VarCurr,1) ) ).

tff(addAssignment_70239,axiom,
    ! [VarCurr: state_type] :
      ( v121947(VarCurr,1)
    <=> v121949(VarCurr,1) ) ).

tff(addAssignment_70238,axiom,
    ! [VarCurr: state_type] :
      ( v121949(VarCurr,1)
    <=> v122470(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_62,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122552(VarCurr)
     => ( v121951(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_91,axiom,
    ! [VarCurr: state_type] :
      ( v122552(VarCurr)
     => ( v121951(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14890,axiom,
    ! [VarCurr: state_type] :
      ( v122552(VarCurr)
    <=> ( v122553(VarCurr)
        | v122554(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14889,axiom,
    ! [VarCurr: state_type] :
      ( v122554(VarCurr)
    <=> ( v122555(VarCurr)
        & v122556(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14888,axiom,
    ! [VarCurr: state_type] :
      ( v122556(VarCurr)
    <=> ( v122557(VarCurr)
        & v122453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14887,axiom,
    ! [VarCurr: state_type] :
      ( v122557(VarCurr)
    <=> ( v122558(VarCurr)
        & v122559(VarCurr) ) ) ).

tff(writeUnaryOperator_8215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122559(VarCurr)
    <=> v122445(VarCurr) ) ).

tff(writeUnaryOperator_8214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122558(VarCurr)
    <=> v122436(VarCurr) ) ).

tff(writeUnaryOperator_8213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122555(VarCurr)
    <=> v122455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14886,axiom,
    ! [VarCurr: state_type] :
      ( v122553(VarCurr)
    <=> ( v122527(VarCurr)
        & v122455(VarCurr) ) ) ).

tff(writeUnaryOperator_8212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121923(VarCurr,0)
    <=> v122432(VarCurr) ) ).

tff(addAssignment_70237,axiom,
    ! [VarCurr: state_type] :
      ( v122432(VarCurr)
    <=> v121925(VarCurr,0) ) ).

tff(addAssignment_70236,axiom,
    ! [VarCurr: state_type] :
      ( v121925(VarCurr,0)
    <=> v121927(VarCurr,0) ) ).

tff(addAssignment_70235,axiom,
    ! [VarNext: state_type] :
      ( v121927(VarNext,0)
    <=> v122543(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122544(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v122543(VarNext,B)
            <=> v121927(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1590,axiom,
    ! [VarNext: state_type] :
      ( v122544(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122543(VarNext,B)
          <=> v122487(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122544(VarNext)
      <=> v122545(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122545(VarNext)
      <=> ( v122547(VarNext)
          & v122472(VarNext) ) ) ) ).

tff(writeUnaryOperator_8211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122547(VarNext)
      <=> v122481(VarNext) ) ) ).

tff(addAssignment_70234,axiom,
    ! [VarCurr: state_type] :
      ( v121945(VarCurr,0)
    <=> v121947(VarCurr,0) ) ).

tff(addAssignment_70233,axiom,
    ! [VarCurr: state_type] :
      ( v121947(VarCurr,0)
    <=> v121949(VarCurr,0) ) ).

tff(addAssignment_70232,axiom,
    ! [VarCurr: state_type] :
      ( v121949(VarCurr,0)
    <=> v122470(VarCurr,0) ) ).

tff(writeUnaryOperator_8210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122434(VarCurr)
    <=> v121951(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122522(VarCurr)
     => ( v121951(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1132,axiom,
    ! [VarCurr: state_type] :
      ( v122522(VarCurr)
     => ( v121951(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14883,axiom,
    ! [VarCurr: state_type] :
      ( v122522(VarCurr)
    <=> ( v122523(VarCurr)
        | v122536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14882,axiom,
    ! [VarCurr: state_type] :
      ( v122536(VarCurr)
    <=> ( v122537(VarCurr)
        & v122540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14881,axiom,
    ! [VarCurr: state_type] :
      ( v122540(VarCurr)
    <=> ( v122508(VarCurr)
        & v122511(VarCurr) ) ) ).

tff(writeUnaryOperator_8209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122537(VarCurr)
    <=> v122538(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14880,axiom,
    ! [VarCurr: state_type] :
      ( v122538(VarCurr)
    <=> ( v122539(VarCurr)
        | v122468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14879,axiom,
    ! [VarCurr: state_type] :
      ( v122539(VarCurr)
    <=> ( v122455(VarCurr)
        | v122453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14878,axiom,
    ! [VarCurr: state_type] :
      ( v122523(VarCurr)
    <=> ( v122524(VarCurr)
        | v122532(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14877,axiom,
    ! [VarCurr: state_type] :
      ( v122532(VarCurr)
    <=> ( v122533(VarCurr)
        & v122535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14876,axiom,
    ! [VarCurr: state_type] :
      ( v122535(VarCurr)
    <=> ( v122466(VarCurr)
        & v122468(VarCurr) ) ) ).

tff(writeUnaryOperator_8208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122533(VarCurr)
    <=> v122534(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14875,axiom,
    ! [VarCurr: state_type] :
      ( v122534(VarCurr)
    <=> ( v122455(VarCurr)
        | v122453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14874,axiom,
    ! [VarCurr: state_type] :
      ( v122524(VarCurr)
    <=> ( v122525(VarCurr)
        | v122529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14873,axiom,
    ! [VarCurr: state_type] :
      ( v122529(VarCurr)
    <=> ( v122530(VarCurr)
        & v122531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14872,axiom,
    ! [VarCurr: state_type] :
      ( v122531(VarCurr)
    <=> ( v122445(VarCurr)
        & v122453(VarCurr) ) ) ).

tff(writeUnaryOperator_8207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122530(VarCurr)
    <=> v122455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14871,axiom,
    ! [VarCurr: state_type] :
      ( v122525(VarCurr)
    <=> ( v122526(VarCurr)
        & v122455(VarCurr) ) ) ).

tff(writeUnaryOperator_8206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122526(VarCurr)
    <=> v122527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14870,axiom,
    ! [VarCurr: state_type] :
      ( v122527(VarCurr)
    <=> ( v122528(VarCurr)
        & v122430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14869,axiom,
    ! [VarCurr: state_type] :
      ( v122528(VarCurr)
    <=> ( v121953(VarCurr)
        & v122428(VarCurr) ) ) ).

tff(addAssignment_70231,axiom,
    ! [VarCurr: state_type] :
      ( v121923(VarCurr,3)
    <=> v121925(VarCurr,3) ) ).

tff(addAssignment_70230,axiom,
    ! [VarCurr: state_type] :
      ( v121925(VarCurr,3)
    <=> v121927(VarCurr,3) ) ).

tff(addAssignment_70229,axiom,
    ! [VarNext: state_type] :
      ( v121927(VarNext,3)
    <=> v122514(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122515(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v122514(VarNext,B)
            <=> v121927(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1589,axiom,
    ! [VarNext: state_type] :
      ( v122515(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122514(VarNext,B)
          <=> v122487(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122515(VarNext)
      <=> v122516(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122516(VarNext)
      <=> ( v122518(VarNext)
          & v122472(VarNext) ) ) ) ).

tff(writeUnaryOperator_8205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122518(VarNext)
      <=> v122481(VarNext) ) ) ).

tff(addAssignment_70228,axiom,
    ! [VarCurr: state_type] :
      ( v121945(VarCurr,3)
    <=> v121947(VarCurr,3) ) ).

tff(addAssignment_70227,axiom,
    ! [VarCurr: state_type] :
      ( v121947(VarCurr,3)
    <=> v121949(VarCurr,3) ) ).

tff(addAssignment_70226,axiom,
    ! [VarCurr: state_type] :
      ( v121949(VarCurr,3)
    <=> v122470(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_61,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122496(VarCurr)
     => ( v121951(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_90,axiom,
    ! [VarCurr: state_type] :
      ( v122496(VarCurr)
     => ( v121951(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14866,axiom,
    ! [VarCurr: state_type] :
      ( v122496(VarCurr)
    <=> ( v122497(VarCurr)
        | v122503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14865,axiom,
    ! [VarCurr: state_type] :
      ( v122503(VarCurr)
    <=> ( v122504(VarCurr)
        & v122505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14864,axiom,
    ! [VarCurr: state_type] :
      ( v122505(VarCurr)
    <=> ( v122506(VarCurr)
        & v122512(VarCurr) ) ) ).

tff(writeUnaryOperator_8204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122512(VarCurr)
    <=> v122502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14863,axiom,
    ! [VarCurr: state_type] :
      ( v122506(VarCurr)
    <=> ( v122507(VarCurr)
        & v122511(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1212,axiom,
    ! [VarCurr: state_type] :
      ( v122511(VarCurr)
    <=> ( $true
      <=> v121923(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122507(VarCurr)
    <=> v122508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14862,axiom,
    ! [VarCurr: state_type] :
      ( v122508(VarCurr)
    <=> ( v122509(VarCurr)
        | v122438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14861,axiom,
    ! [VarCurr: state_type] :
      ( v122509(VarCurr)
    <=> ( v122510(VarCurr)
        | v122494(VarCurr) ) ) ).

tff(writeUnaryOperator_8202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122510(VarCurr)
    <=> v122428(VarCurr) ) ).

tff(writeUnaryOperator_8201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122504(VarCurr)
    <=> v122468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14860,axiom,
    ! [VarCurr: state_type] :
      ( v122497(VarCurr)
    <=> ( v122498(VarCurr)
        & v122501(VarCurr) ) ) ).

tff(writeUnaryOperator_8200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122501(VarCurr)
    <=> v122502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14859,axiom,
    ! [VarCurr: state_type] :
      ( v122502(VarCurr)
    <=> ( v122455(VarCurr)
        | v122453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14858,axiom,
    ! [VarCurr: state_type] :
      ( v122498(VarCurr)
    <=> ( v122499(VarCurr)
        & v122468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14857,axiom,
    ! [VarCurr: state_type] :
      ( v122499(VarCurr)
    <=> ( v122462(VarCurr)
        & v122500(VarCurr) ) ) ).

tff(writeUnaryOperator_8199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122500(VarCurr)
    <=> v122466(VarCurr) ) ).

tff(addAssignment_70225,axiom,
    ! [VarCurr: state_type] :
      ( v122494(VarCurr)
    <=> v112831(VarCurr,10) ) ).

tff(addAssignment_70224,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,10)
    <=> v112865(VarCurr,10) ) ).

tff(addAssignment_70223,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,10)
    <=> v112849(VarCurr,10) ) ).

tff(addAssignment_70222,axiom,
    ! [VarCurr: state_type] :
      ( v121923(VarCurr,2)
    <=> v121925(VarCurr,2) ) ).

tff(addAssignment_70221,axiom,
    ! [VarCurr: state_type] :
      ( v121925(VarCurr,2)
    <=> v121927(VarCurr,2) ) ).

tff(addAssignment_70220,axiom,
    ! [VarNext: state_type] :
      ( v121927(VarNext,2)
    <=> v122476(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122477(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v122476(VarNext,B)
            <=> v121927(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1588,axiom,
    ! [VarNext: state_type] :
      ( v122477(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122476(VarNext,B)
          <=> v122487(VarNext,B) ) ) ) ).

tff(addAssignment_70219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122487(VarNext,B)
          <=> v122485(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122485(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1131,axiom,
    ! [VarCurr: state_type] :
      ( v122488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v122485(VarCurr,B)
          <=> v121945(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14856,axiom,
    ! [VarCurr: state_type] :
      ( v122488(VarCurr)
    <=> ( v122489(VarCurr)
        & v122490(VarCurr) ) ) ).

tff(writeUnaryOperator_8198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122490(VarCurr)
    <=> v121937(VarCurr) ) ).

tff(writeUnaryOperator_8197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122489(VarCurr)
    <=> v121929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122477(VarNext)
      <=> v122478(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122478(VarNext)
      <=> ( v122479(VarNext)
          & v122472(VarNext) ) ) ) ).

tff(writeUnaryOperator_8196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122479(VarNext)
      <=> v122481(VarNext) ) ) ).

tff(addAssignment_70218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122481(VarNext)
      <=> v122472(VarCurr) ) ) ).

tff(addAssignment_70217,axiom,
    ! [VarCurr: state_type] :
      ( v122472(VarCurr)
    <=> v122474(VarCurr) ) ).

tff(addAssignment_70216,axiom,
    ! [VarCurr: state_type] :
      ( v122474(VarCurr)
    <=> v122403(VarCurr) ) ).

tff(addAssignment_70215,axiom,
    ! [VarCurr: state_type] :
      ( v121945(VarCurr,2)
    <=> v121947(VarCurr,2) ) ).

tff(addAssignment_70214,axiom,
    ! [VarCurr: state_type] :
      ( v121947(VarCurr,2)
    <=> v121949(VarCurr,2) ) ).

tff(addAssignment_70213,axiom,
    ! [VarCurr: state_type] :
      ( v121949(VarCurr,2)
    <=> v122470(VarCurr,2) ) ).

tff(addAssignment_70212,axiom,
    ! [VarCurr: state_type] :
      ( v122470(VarCurr,0)
    <=> v122434(VarCurr) ) ).

tff(addAssignment_70211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v122470(VarCurr,B)
      <=> v121951(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_60,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122440(VarCurr)
     => ( v121951(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_89,axiom,
    ! [VarCurr: state_type] :
      ( v122440(VarCurr)
     => ( v121951(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14853,axiom,
    ! [VarCurr: state_type] :
      ( v122440(VarCurr)
    <=> ( v122441(VarCurr)
        | v122456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14852,axiom,
    ! [VarCurr: state_type] :
      ( v122456(VarCurr)
    <=> ( v122457(VarCurr)
        & v122458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14851,axiom,
    ! [VarCurr: state_type] :
      ( v122458(VarCurr)
    <=> ( v122459(VarCurr)
        & v122469(VarCurr) ) ) ).

tff(writeUnaryOperator_8195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122469(VarCurr)
    <=> v122455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14850,axiom,
    ! [VarCurr: state_type] :
      ( v122459(VarCurr)
    <=> ( v122460(VarCurr)
        & v122468(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1211,axiom,
    ! [VarCurr: state_type] :
      ( v122468(VarCurr)
    <=> ( $true
      <=> v121923(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14849,axiom,
    ! [VarCurr: state_type] :
      ( v122460(VarCurr)
    <=> ( v122461(VarCurr)
        & v122465(VarCurr) ) ) ).

tff(writeUnaryOperator_8194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122465(VarCurr)
    <=> v122466(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14848,axiom,
    ! [VarCurr: state_type] :
      ( v122466(VarCurr)
    <=> ( v122467(VarCurr)
        | v122438(VarCurr) ) ) ).

tff(writeUnaryOperator_8193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122467(VarCurr)
    <=> v122428(VarCurr) ) ).

tff(writeUnaryOperator_8192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122461(VarCurr)
    <=> v122462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14847,axiom,
    ! [VarCurr: state_type] :
      ( v122462(VarCurr)
    <=> ( v122463(VarCurr)
        | v122464(VarCurr) ) ) ).

tff(writeUnaryOperator_8191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122464(VarCurr)
    <=> v122430(VarCurr) ) ).

tff(writeUnaryOperator_8190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122463(VarCurr)
    <=> v121953(VarCurr) ) ).

tff(writeUnaryOperator_8189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122457(VarCurr)
    <=> v122453(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14846,axiom,
    ! [VarCurr: state_type] :
      ( v122441(VarCurr)
    <=> ( v122442(VarCurr)
        & v122454(VarCurr) ) ) ).

tff(writeUnaryOperator_8188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122454(VarCurr)
    <=> v122455(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1210,axiom,
    ! [VarCurr: state_type] :
      ( v122455(VarCurr)
    <=> ( $true
      <=> v121923(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14845,axiom,
    ! [VarCurr: state_type] :
      ( v122442(VarCurr)
    <=> ( v122443(VarCurr)
        & v122453(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1209,axiom,
    ! [VarCurr: state_type] :
      ( v122453(VarCurr)
    <=> ( $true
      <=> v121923(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14844,axiom,
    ! [VarCurr: state_type] :
      ( v122443(VarCurr)
    <=> ( v122436(VarCurr)
        & v122444(VarCurr) ) ) ).

tff(writeUnaryOperator_8187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122444(VarCurr)
    <=> v122445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14843,axiom,
    ! [VarCurr: state_type] :
      ( v122445(VarCurr)
    <=> ( v122446(VarCurr)
        | v122438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14842,axiom,
    ! [VarCurr: state_type] :
      ( v122446(VarCurr)
    <=> ( v122447(VarCurr)
        | v122450(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14841,axiom,
    ! [VarCurr: state_type] :
      ( v122450(VarCurr)
    <=> ( v122451(VarCurr)
        & v122452(VarCurr) ) ) ).

tff(writeUnaryOperator_8186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122452(VarCurr)
    <=> v122436(VarCurr) ) ).

tff(writeUnaryOperator_8185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122451(VarCurr)
    <=> v121953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14840,axiom,
    ! [VarCurr: state_type] :
      ( v122447(VarCurr)
    <=> ( v122448(VarCurr)
        | v122449(VarCurr) ) ) ).

tff(writeUnaryOperator_8184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122449(VarCurr)
    <=> v122430(VarCurr) ) ).

tff(writeUnaryOperator_8183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122448(VarCurr)
    <=> v122428(VarCurr) ) ).

tff(addAssignment_70210,axiom,
    ! [VarCurr: state_type] :
      ( v122438(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_70209,axiom,
    ! [VarCurr: state_type] :
      ( v122436(VarCurr)
    <=> v112643(VarCurr,10) ) ).

tff(addAssignment_70208,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,10)
    <=> v115202(VarCurr,10) ) ).

tff(addAssignment_70207,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,10)
    <=> v115186(VarCurr,10) ) ).

tff(addAssignment_70206,axiom,
    ! [VarCurr: state_type] :
      ( v122430(VarCurr)
    <=> v112528(VarCurr,10) ) ).

tff(addAssignment_70205,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,10)
    <=> v120828(VarCurr,2) ) ).

tff(addAssignment_70204,axiom,
    ! [VarCurr: state_type] :
      ( v122428(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14839,axiom,
    ! [VarCurr: state_type] :
      ( v121953(VarCurr)
    <=> ( v122425(VarCurr)
        & v122426(VarCurr) ) ) ).

tff(writeUnaryOperator_8182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122426(VarCurr)
    <=> v122423(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1208,axiom,
    ! [VarCurr: state_type] :
      ( v122425(VarCurr)
    <=> ( ( v121955(VarCurr,5)
        <=> $false )
        & ( v121955(VarCurr,4)
        <=> $false )
        & ( v121955(VarCurr,3)
        <=> $false )
        & ( v121955(VarCurr,2)
        <=> $false )
        & ( v121955(VarCurr,1)
        <=> $false )
        & ( v121955(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70203,axiom,
    ! [VarCurr: state_type] :
      ( v122423(VarCurr)
    <=> v115139(VarCurr,10) ) ).

tff(addAssignment_70202,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,10)
    <=> v115159(VarCurr,10) ) ).

tff(addAssignment_70201,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,10)
    <=> v115142(VarCurr,10) ) ).

tff(addAssignment_70200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121955(VarCurr,B)
      <=> v121957(VarCurr,B) ) ) ).

tff(addAssignment_70199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121957(VarCurr,B)
      <=> v121959(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122406(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v121959(VarNext,B)
            <=> v121959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1587,axiom,
    ! [VarNext: state_type] :
      ( v122406(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v121959(VarNext,B)
          <=> v122416(VarNext,B) ) ) ) ).

tff(addAssignment_70198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v122416(VarNext,B)
          <=> v122414(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v122414(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1130,axiom,
    ! [VarCurr: state_type] :
      ( v122417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v122414(VarCurr,B)
          <=> v121969(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14838,axiom,
    ! [VarCurr: state_type] :
      ( v122417(VarCurr)
    <=> ( v122418(VarCurr)
        & v122419(VarCurr) ) ) ).

tff(writeUnaryOperator_8181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122419(VarCurr)
    <=> v121965(VarCurr) ) ).

tff(writeUnaryOperator_8180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122418(VarCurr)
    <=> v121961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122406(VarNext)
      <=> v122407(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122407(VarNext)
      <=> ( v122408(VarNext)
          & v122399(VarNext) ) ) ) ).

tff(writeUnaryOperator_8179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122408(VarNext)
      <=> v122410(VarNext) ) ) ).

tff(addAssignment_70197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122410(VarNext)
      <=> v122399(VarCurr) ) ) ).

tff(addAssignment_70196,axiom,
    ! [VarCurr: state_type] :
      ( v122399(VarCurr)
    <=> v122401(VarCurr) ) ).

tff(addAssignment_70195,axiom,
    ! [VarCurr: state_type] :
      ( v122401(VarCurr)
    <=> v122403(VarCurr) ) ).

tff(addAssignment_70194,axiom,
    ! [VarCurr: state_type] :
      ( v122403(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_70193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121969(VarCurr,B)
      <=> v121971(VarCurr,B) ) ) ).

tff(addAssignment_70192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121971(VarCurr,B)
      <=> v121973(VarCurr,B) ) ) ).

tff(addAssignment_70191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121973(VarCurr,B)
      <=> v121975(VarCurr,B) ) ) ).

tff(addAssignment_70190,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,0)
    <=> v122394(VarCurr) ) ).

tff(addAssignment_70189,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,1)
    <=> v122389(VarCurr) ) ).

tff(addAssignment_70188,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,2)
    <=> v122384(VarCurr) ) ).

tff(addAssignment_70187,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,3)
    <=> v122379(VarCurr) ) ).

tff(addAssignment_70186,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,4)
    <=> v122374(VarCurr) ) ).

tff(addAssignment_70185,axiom,
    ! [VarCurr: state_type] :
      ( v121975(VarCurr,5)
    <=> v122231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14835,axiom,
    ! [VarCurr: state_type] :
      ( v122394(VarCurr)
    <=> ( v122395(VarCurr)
        & v122397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14834,axiom,
    ! [VarCurr: state_type] :
      ( v122397(VarCurr)
    <=> ( v122186(VarCurr,0)
        | v122243(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14833,axiom,
    ! [VarCurr: state_type] :
      ( v122395(VarCurr)
    <=> ( v122320(VarCurr)
        | v122396(VarCurr) ) ) ).

tff(writeUnaryOperator_8178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122396(VarCurr)
    <=> v122243(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14832,axiom,
    ! [VarCurr: state_type] :
      ( v122389(VarCurr)
    <=> ( v122390(VarCurr)
        & v122393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14831,axiom,
    ! [VarCurr: state_type] :
      ( v122393(VarCurr)
    <=> ( v122242(VarCurr)
        | v122314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14830,axiom,
    ! [VarCurr: state_type] :
      ( v122390(VarCurr)
    <=> ( v122391(VarCurr)
        | v122392(VarCurr) ) ) ).

tff(writeUnaryOperator_8177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122392(VarCurr)
    <=> v122314(VarCurr) ) ).

tff(writeUnaryOperator_8176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122391(VarCurr)
    <=> v122242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14829,axiom,
    ! [VarCurr: state_type] :
      ( v122384(VarCurr)
    <=> ( v122385(VarCurr)
        & v122388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14828,axiom,
    ! [VarCurr: state_type] :
      ( v122388(VarCurr)
    <=> ( v122240(VarCurr)
        | v122325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14827,axiom,
    ! [VarCurr: state_type] :
      ( v122385(VarCurr)
    <=> ( v122386(VarCurr)
        | v122387(VarCurr) ) ) ).

tff(writeUnaryOperator_8175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122387(VarCurr)
    <=> v122325(VarCurr) ) ).

tff(writeUnaryOperator_8174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122386(VarCurr)
    <=> v122240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14826,axiom,
    ! [VarCurr: state_type] :
      ( v122379(VarCurr)
    <=> ( v122380(VarCurr)
        & v122383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14825,axiom,
    ! [VarCurr: state_type] :
      ( v122383(VarCurr)
    <=> ( v122238(VarCurr)
        | v122337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14824,axiom,
    ! [VarCurr: state_type] :
      ( v122380(VarCurr)
    <=> ( v122381(VarCurr)
        | v122382(VarCurr) ) ) ).

tff(writeUnaryOperator_8173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122382(VarCurr)
    <=> v122337(VarCurr) ) ).

tff(writeUnaryOperator_8172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122381(VarCurr)
    <=> v122238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14823,axiom,
    ! [VarCurr: state_type] :
      ( v122374(VarCurr)
    <=> ( v122375(VarCurr)
        & v122378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14822,axiom,
    ! [VarCurr: state_type] :
      ( v122378(VarCurr)
    <=> ( v122236(VarCurr)
        | v122349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14821,axiom,
    ! [VarCurr: state_type] :
      ( v122375(VarCurr)
    <=> ( v122376(VarCurr)
        | v122377(VarCurr) ) ) ).

tff(writeUnaryOperator_8171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122377(VarCurr)
    <=> v122349(VarCurr) ) ).

tff(writeUnaryOperator_8170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122376(VarCurr)
    <=> v122236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14820,axiom,
    ! [VarCurr: state_type] :
      ( v122231(VarCurr)
    <=> ( v122232(VarCurr)
        & v122373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14819,axiom,
    ! [VarCurr: state_type] :
      ( v122373(VarCurr)
    <=> ( v122234(VarCurr)
        | v122362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14818,axiom,
    ! [VarCurr: state_type] :
      ( v122232(VarCurr)
    <=> ( v122233(VarCurr)
        | v122361(VarCurr) ) ) ).

tff(writeUnaryOperator_8169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122361(VarCurr)
    <=> v122362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14817,axiom,
    ! [VarCurr: state_type] :
      ( v122362(VarCurr)
    <=> ( v122363(VarCurr)
        & v122372(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5362,axiom,
    ! [VarCurr: state_type] :
      ( v122372(VarCurr)
    <=> ( v122365(VarCurr)
        | v122243(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14816,axiom,
    ! [VarCurr: state_type] :
      ( v122363(VarCurr)
    <=> ( v122364(VarCurr)
        | v122371(VarCurr) ) ) ).

tff(writeUnaryOperator_8168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122371(VarCurr)
    <=> v122243(VarCurr,5) ) ).

tff(writeUnaryOperator_8167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122364(VarCurr)
    <=> v122365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14815,axiom,
    ! [VarCurr: state_type] :
      ( v122365(VarCurr)
    <=> ( v122366(VarCurr)
        & v122369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14814,axiom,
    ! [VarCurr: state_type] :
      ( v122369(VarCurr)
    <=> ( v122368(VarCurr)
        | v122370(VarCurr) ) ) ).

tff(writeUnaryOperator_8166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122370(VarCurr)
    <=> v122186(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5361,axiom,
    ! [VarCurr: state_type] :
      ( v122366(VarCurr)
    <=> ( v122367(VarCurr)
        | v122186(VarCurr,5) ) ) ).

tff(writeUnaryOperator_8165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122367(VarCurr)
    <=> v122368(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14813,axiom,
    ! [VarCurr: state_type] :
      ( v122368(VarCurr)
    <=> ( v122355(VarCurr)
        & v122357(VarCurr) ) ) ).

tff(writeUnaryOperator_8164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122233(VarCurr)
    <=> v122234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14812,axiom,
    ! [VarCurr: state_type] :
      ( v122234(VarCurr)
    <=> ( v122235(VarCurr)
        | v122360(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5360,axiom,
    ! [VarCurr: state_type] :
      ( v122360(VarCurr)
    <=> ( v122352(VarCurr)
        & v122243(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14811,axiom,
    ! [VarCurr: state_type] :
      ( v122235(VarCurr)
    <=> ( v122236(VarCurr)
        & v122349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14810,axiom,
    ! [VarCurr: state_type] :
      ( v122349(VarCurr)
    <=> ( v122350(VarCurr)
        & v122359(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5359,axiom,
    ! [VarCurr: state_type] :
      ( v122359(VarCurr)
    <=> ( v122352(VarCurr)
        | v122243(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14809,axiom,
    ! [VarCurr: state_type] :
      ( v122350(VarCurr)
    <=> ( v122351(VarCurr)
        | v122358(VarCurr) ) ) ).

tff(writeUnaryOperator_8163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122358(VarCurr)
    <=> v122243(VarCurr,4) ) ).

tff(writeUnaryOperator_8162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122351(VarCurr)
    <=> v122352(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14808,axiom,
    ! [VarCurr: state_type] :
      ( v122352(VarCurr)
    <=> ( v122353(VarCurr)
        & v122356(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14807,axiom,
    ! [VarCurr: state_type] :
      ( v122356(VarCurr)
    <=> ( v122355(VarCurr)
        | v122357(VarCurr) ) ) ).

tff(writeUnaryOperator_8161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122357(VarCurr)
    <=> v122186(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5358,axiom,
    ! [VarCurr: state_type] :
      ( v122353(VarCurr)
    <=> ( v122354(VarCurr)
        | v122186(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122354(VarCurr)
    <=> v122355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14806,axiom,
    ! [VarCurr: state_type] :
      ( v122355(VarCurr)
    <=> ( v122343(VarCurr)
        & v122345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14805,axiom,
    ! [VarCurr: state_type] :
      ( v122236(VarCurr)
    <=> ( v122237(VarCurr)
        | v122348(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5357,axiom,
    ! [VarCurr: state_type] :
      ( v122348(VarCurr)
    <=> ( v122340(VarCurr)
        & v122243(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14804,axiom,
    ! [VarCurr: state_type] :
      ( v122237(VarCurr)
    <=> ( v122238(VarCurr)
        & v122337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14803,axiom,
    ! [VarCurr: state_type] :
      ( v122337(VarCurr)
    <=> ( v122338(VarCurr)
        & v122347(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5356,axiom,
    ! [VarCurr: state_type] :
      ( v122347(VarCurr)
    <=> ( v122340(VarCurr)
        | v122243(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14802,axiom,
    ! [VarCurr: state_type] :
      ( v122338(VarCurr)
    <=> ( v122339(VarCurr)
        | v122346(VarCurr) ) ) ).

tff(writeUnaryOperator_8159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122346(VarCurr)
    <=> v122243(VarCurr,3) ) ).

tff(writeUnaryOperator_8158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122339(VarCurr)
    <=> v122340(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14801,axiom,
    ! [VarCurr: state_type] :
      ( v122340(VarCurr)
    <=> ( v122341(VarCurr)
        & v122344(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14800,axiom,
    ! [VarCurr: state_type] :
      ( v122344(VarCurr)
    <=> ( v122343(VarCurr)
        | v122345(VarCurr) ) ) ).

tff(writeUnaryOperator_8157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122345(VarCurr)
    <=> v122186(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5355,axiom,
    ! [VarCurr: state_type] :
      ( v122341(VarCurr)
    <=> ( v122342(VarCurr)
        | v122186(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122342(VarCurr)
    <=> v122343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14799,axiom,
    ! [VarCurr: state_type] :
      ( v122343(VarCurr)
    <=> ( v122331(VarCurr)
        & v122333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14798,axiom,
    ! [VarCurr: state_type] :
      ( v122238(VarCurr)
    <=> ( v122239(VarCurr)
        | v122336(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5354,axiom,
    ! [VarCurr: state_type] :
      ( v122336(VarCurr)
    <=> ( v122328(VarCurr)
        & v122243(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14797,axiom,
    ! [VarCurr: state_type] :
      ( v122239(VarCurr)
    <=> ( v122240(VarCurr)
        & v122325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14796,axiom,
    ! [VarCurr: state_type] :
      ( v122325(VarCurr)
    <=> ( v122326(VarCurr)
        & v122335(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5353,axiom,
    ! [VarCurr: state_type] :
      ( v122335(VarCurr)
    <=> ( v122328(VarCurr)
        | v122243(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14795,axiom,
    ! [VarCurr: state_type] :
      ( v122326(VarCurr)
    <=> ( v122327(VarCurr)
        | v122334(VarCurr) ) ) ).

tff(writeUnaryOperator_8155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122334(VarCurr)
    <=> v122243(VarCurr,2) ) ).

tff(writeUnaryOperator_8154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122327(VarCurr)
    <=> v122328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14794,axiom,
    ! [VarCurr: state_type] :
      ( v122328(VarCurr)
    <=> ( v122329(VarCurr)
        & v122332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14793,axiom,
    ! [VarCurr: state_type] :
      ( v122332(VarCurr)
    <=> ( v122331(VarCurr)
        | v122333(VarCurr) ) ) ).

tff(writeUnaryOperator_8153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122333(VarCurr)
    <=> v122186(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5352,axiom,
    ! [VarCurr: state_type] :
      ( v122329(VarCurr)
    <=> ( v122330(VarCurr)
        | v122186(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122330(VarCurr)
    <=> v122331(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14792,axiom,
    ! [VarCurr: state_type] :
      ( v122331(VarCurr)
    <=> ( v122320(VarCurr)
        & v122321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14791,axiom,
    ! [VarCurr: state_type] :
      ( v122240(VarCurr)
    <=> ( v122241(VarCurr)
        | v122324(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5351,axiom,
    ! [VarCurr: state_type] :
      ( v122324(VarCurr)
    <=> ( v122317(VarCurr)
        & v122243(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14790,axiom,
    ! [VarCurr: state_type] :
      ( v122241(VarCurr)
    <=> ( v122242(VarCurr)
        & v122314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14789,axiom,
    ! [VarCurr: state_type] :
      ( v122314(VarCurr)
    <=> ( v122315(VarCurr)
        & v122323(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5350,axiom,
    ! [VarCurr: state_type] :
      ( v122323(VarCurr)
    <=> ( v122317(VarCurr)
        | v122243(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14788,axiom,
    ! [VarCurr: state_type] :
      ( v122315(VarCurr)
    <=> ( v122316(VarCurr)
        | v122322(VarCurr) ) ) ).

tff(writeUnaryOperator_8151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122322(VarCurr)
    <=> v122243(VarCurr,1) ) ).

tff(writeUnaryOperator_8150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122316(VarCurr)
    <=> v122317(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14787,axiom,
    ! [VarCurr: state_type] :
      ( v122317(VarCurr)
    <=> ( v122318(VarCurr)
        & v122319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14786,axiom,
    ! [VarCurr: state_type] :
      ( v122319(VarCurr)
    <=> ( v122320(VarCurr)
        | v122321(VarCurr) ) ) ).

tff(writeUnaryOperator_8149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122321(VarCurr)
    <=> v122186(VarCurr,1) ) ).

tff(writeUnaryOperator_8148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122320(VarCurr)
    <=> v122186(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5349,axiom,
    ! [VarCurr: state_type] :
      ( v122318(VarCurr)
    <=> ( v122186(VarCurr,0)
        | v122186(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14785,axiom,
    ! [VarCurr: state_type] :
      ( v122242(VarCurr)
    <=> ( v122186(VarCurr,0)
        & v122243(VarCurr,0) ) ) ).

tff(addAssignment_70184,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,0)
    <=> v122309(VarCurr) ) ).

tff(addAssignment_70183,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,1)
    <=> v122304(VarCurr) ) ).

tff(addAssignment_70182,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,2)
    <=> v122299(VarCurr) ) ).

tff(addAssignment_70181,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,3)
    <=> v122294(VarCurr) ) ).

tff(addAssignment_70180,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,4)
    <=> v122289(VarCurr) ) ).

tff(addAssignment_70179,axiom,
    ! [VarCurr: state_type] :
      ( v122243(VarCurr,5)
    <=> v122245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14784,axiom,
    ! [VarCurr: state_type] :
      ( v122309(VarCurr)
    <=> ( v122310(VarCurr)
        & v122313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14783,axiom,
    ! [VarCurr: state_type] :
      ( v122313(VarCurr)
    <=> ( v121955(VarCurr,0)
        | v122257(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14782,axiom,
    ! [VarCurr: state_type] :
      ( v122310(VarCurr)
    <=> ( v122311(VarCurr)
        | v122312(VarCurr) ) ) ).

tff(writeUnaryOperator_8147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122312(VarCurr)
    <=> v122257(VarCurr,0) ) ).

tff(writeUnaryOperator_8146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122311(VarCurr)
    <=> v121955(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14781,axiom,
    ! [VarCurr: state_type] :
      ( v122304(VarCurr)
    <=> ( v122305(VarCurr)
        & v122308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14780,axiom,
    ! [VarCurr: state_type] :
      ( v122308(VarCurr)
    <=> ( v122256(VarCurr)
        | v122258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14779,axiom,
    ! [VarCurr: state_type] :
      ( v122305(VarCurr)
    <=> ( v122306(VarCurr)
        | v122307(VarCurr) ) ) ).

tff(writeUnaryOperator_8145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122307(VarCurr)
    <=> v122258(VarCurr) ) ).

tff(writeUnaryOperator_8144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122306(VarCurr)
    <=> v122256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14778,axiom,
    ! [VarCurr: state_type] :
      ( v122299(VarCurr)
    <=> ( v122300(VarCurr)
        & v122303(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14777,axiom,
    ! [VarCurr: state_type] :
      ( v122303(VarCurr)
    <=> ( v122254(VarCurr)
        | v122264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14776,axiom,
    ! [VarCurr: state_type] :
      ( v122300(VarCurr)
    <=> ( v122301(VarCurr)
        | v122302(VarCurr) ) ) ).

tff(writeUnaryOperator_8143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122302(VarCurr)
    <=> v122264(VarCurr) ) ).

tff(writeUnaryOperator_8142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122301(VarCurr)
    <=> v122254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14775,axiom,
    ! [VarCurr: state_type] :
      ( v122294(VarCurr)
    <=> ( v122295(VarCurr)
        & v122298(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14774,axiom,
    ! [VarCurr: state_type] :
      ( v122298(VarCurr)
    <=> ( v122252(VarCurr)
        | v122270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14773,axiom,
    ! [VarCurr: state_type] :
      ( v122295(VarCurr)
    <=> ( v122296(VarCurr)
        | v122297(VarCurr) ) ) ).

tff(writeUnaryOperator_8141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122297(VarCurr)
    <=> v122270(VarCurr) ) ).

tff(writeUnaryOperator_8140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122296(VarCurr)
    <=> v122252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14772,axiom,
    ! [VarCurr: state_type] :
      ( v122289(VarCurr)
    <=> ( v122290(VarCurr)
        & v122293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14771,axiom,
    ! [VarCurr: state_type] :
      ( v122293(VarCurr)
    <=> ( v122250(VarCurr)
        | v122276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14770,axiom,
    ! [VarCurr: state_type] :
      ( v122290(VarCurr)
    <=> ( v122291(VarCurr)
        | v122292(VarCurr) ) ) ).

tff(writeUnaryOperator_8139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122292(VarCurr)
    <=> v122276(VarCurr) ) ).

tff(writeUnaryOperator_8138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122291(VarCurr)
    <=> v122250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14769,axiom,
    ! [VarCurr: state_type] :
      ( v122245(VarCurr)
    <=> ( v122246(VarCurr)
        & v122288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14768,axiom,
    ! [VarCurr: state_type] :
      ( v122288(VarCurr)
    <=> ( v122248(VarCurr)
        | v122283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14767,axiom,
    ! [VarCurr: state_type] :
      ( v122246(VarCurr)
    <=> ( v122247(VarCurr)
        | v122282(VarCurr) ) ) ).

tff(writeUnaryOperator_8137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122282(VarCurr)
    <=> v122283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14766,axiom,
    ! [VarCurr: state_type] :
      ( v122283(VarCurr)
    <=> ( v122284(VarCurr)
        & v122287(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5348,axiom,
    ! [VarCurr: state_type] :
      ( v122287(VarCurr)
    <=> ( v121955(VarCurr,5)
        | v122257(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14765,axiom,
    ! [VarCurr: state_type] :
      ( v122284(VarCurr)
    <=> ( v122285(VarCurr)
        | v122286(VarCurr) ) ) ).

tff(writeUnaryOperator_8136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122286(VarCurr)
    <=> v122257(VarCurr,5) ) ).

tff(writeUnaryOperator_8135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122285(VarCurr)
    <=> v121955(VarCurr,5) ) ).

tff(writeUnaryOperator_8134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122247(VarCurr)
    <=> v122248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14764,axiom,
    ! [VarCurr: state_type] :
      ( v122248(VarCurr)
    <=> ( v122249(VarCurr)
        | v122281(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5347,axiom,
    ! [VarCurr: state_type] :
      ( v122281(VarCurr)
    <=> ( v121955(VarCurr,4)
        & v122257(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14763,axiom,
    ! [VarCurr: state_type] :
      ( v122249(VarCurr)
    <=> ( v122250(VarCurr)
        & v122276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14762,axiom,
    ! [VarCurr: state_type] :
      ( v122276(VarCurr)
    <=> ( v122277(VarCurr)
        & v122280(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5346,axiom,
    ! [VarCurr: state_type] :
      ( v122280(VarCurr)
    <=> ( v121955(VarCurr,4)
        | v122257(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14761,axiom,
    ! [VarCurr: state_type] :
      ( v122277(VarCurr)
    <=> ( v122278(VarCurr)
        | v122279(VarCurr) ) ) ).

tff(writeUnaryOperator_8133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122279(VarCurr)
    <=> v122257(VarCurr,4) ) ).

tff(writeUnaryOperator_8132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122278(VarCurr)
    <=> v121955(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14760,axiom,
    ! [VarCurr: state_type] :
      ( v122250(VarCurr)
    <=> ( v122251(VarCurr)
        | v122275(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5345,axiom,
    ! [VarCurr: state_type] :
      ( v122275(VarCurr)
    <=> ( v121955(VarCurr,3)
        & v122257(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14759,axiom,
    ! [VarCurr: state_type] :
      ( v122251(VarCurr)
    <=> ( v122252(VarCurr)
        & v122270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14758,axiom,
    ! [VarCurr: state_type] :
      ( v122270(VarCurr)
    <=> ( v122271(VarCurr)
        & v122274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5344,axiom,
    ! [VarCurr: state_type] :
      ( v122274(VarCurr)
    <=> ( v121955(VarCurr,3)
        | v122257(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14757,axiom,
    ! [VarCurr: state_type] :
      ( v122271(VarCurr)
    <=> ( v122272(VarCurr)
        | v122273(VarCurr) ) ) ).

tff(writeUnaryOperator_8131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122273(VarCurr)
    <=> v122257(VarCurr,3) ) ).

tff(writeUnaryOperator_8130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122272(VarCurr)
    <=> v121955(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14756,axiom,
    ! [VarCurr: state_type] :
      ( v122252(VarCurr)
    <=> ( v122253(VarCurr)
        | v122269(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5343,axiom,
    ! [VarCurr: state_type] :
      ( v122269(VarCurr)
    <=> ( v121955(VarCurr,2)
        & v122257(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14755,axiom,
    ! [VarCurr: state_type] :
      ( v122253(VarCurr)
    <=> ( v122254(VarCurr)
        & v122264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14754,axiom,
    ! [VarCurr: state_type] :
      ( v122264(VarCurr)
    <=> ( v122265(VarCurr)
        & v122268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5342,axiom,
    ! [VarCurr: state_type] :
      ( v122268(VarCurr)
    <=> ( v121955(VarCurr,2)
        | v122257(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14753,axiom,
    ! [VarCurr: state_type] :
      ( v122265(VarCurr)
    <=> ( v122266(VarCurr)
        | v122267(VarCurr) ) ) ).

tff(writeUnaryOperator_8129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122267(VarCurr)
    <=> v122257(VarCurr,2) ) ).

tff(writeUnaryOperator_8128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122266(VarCurr)
    <=> v121955(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14752,axiom,
    ! [VarCurr: state_type] :
      ( v122254(VarCurr)
    <=> ( v122255(VarCurr)
        | v122263(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5341,axiom,
    ! [VarCurr: state_type] :
      ( v122263(VarCurr)
    <=> ( v121955(VarCurr,1)
        & v122257(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14751,axiom,
    ! [VarCurr: state_type] :
      ( v122255(VarCurr)
    <=> ( v122256(VarCurr)
        & v122258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14750,axiom,
    ! [VarCurr: state_type] :
      ( v122258(VarCurr)
    <=> ( v122259(VarCurr)
        & v122262(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5340,axiom,
    ! [VarCurr: state_type] :
      ( v122262(VarCurr)
    <=> ( v121955(VarCurr,1)
        | v122257(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14749,axiom,
    ! [VarCurr: state_type] :
      ( v122259(VarCurr)
    <=> ( v122260(VarCurr)
        | v122261(VarCurr) ) ) ).

tff(writeUnaryOperator_8127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122261(VarCurr)
    <=> v122257(VarCurr,1) ) ).

tff(writeUnaryOperator_8126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122260(VarCurr)
    <=> v121955(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14748,axiom,
    ! [VarCurr: state_type] :
      ( v122256(VarCurr)
    <=> ( v121955(VarCurr,0)
        & v122257(VarCurr,0) ) ) ).

tff(addAssignment_70178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v122257(VarCurr,B)
      <=> v121977(VarCurr,B) ) ) ).

tff(addAssignment_70177,axiom,
    ! [VarCurr: state_type] :
      ( ( v122257(VarCurr,5)
      <=> $false )
      & ( v122257(VarCurr,4)
      <=> $false )
      & ( v122257(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_70176,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,5)
    <=> v122223(VarCurr,5) ) ).

tff(addAssignment_70175,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,4)
    <=> v122223(VarCurr,4) ) ).

tff(addAssignment_70174,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,3)
    <=> v122223(VarCurr,3) ) ).

tff(addAssignment_70173,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,2)
    <=> v122223(VarCurr,2) ) ).

tff(addAssignment_70172,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,1)
    <=> v122223(VarCurr,1) ) ).

tff(addAssignment_70171,axiom,
    ! [VarCurr: state_type] :
      ( v122186(VarCurr,0)
    <=> v122223(VarCurr,0) ) ).

tff(addAssignment_70170,axiom,
    ! [VarCurr: state_type] :
      ( v122223(VarCurr,0)
    <=> v122224(VarCurr) ) ).

tff(addAssignment_70169,axiom,
    ! [VarCurr: state_type] :
      ( ( v122223(VarCurr,5)
      <=> $false )
      & ( v122223(VarCurr,4)
      <=> $false )
      & ( v122223(VarCurr,3)
      <=> $false )
      & ( v122223(VarCurr,2)
      <=> $false )
      & ( v122223(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14747,axiom,
    ! [VarCurr: state_type] :
      ( v122224(VarCurr)
    <=> ( v122225(VarCurr)
        | v122222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14746,axiom,
    ! [VarCurr: state_type] :
      ( v122225(VarCurr)
    <=> ( v122226(VarCurr)
        | v122220(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14745,axiom,
    ! [VarCurr: state_type] :
      ( v122226(VarCurr)
    <=> ( v122227(VarCurr)
        | v122218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14744,axiom,
    ! [VarCurr: state_type] :
      ( v122227(VarCurr)
    <=> ( v122228(VarCurr)
        | v122208(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14743,axiom,
    ! [VarCurr: state_type] :
      ( v122228(VarCurr)
    <=> ( v122188(VarCurr)
        | v122198(VarCurr) ) ) ).

tff(addAssignment_70168,axiom,
    ! [VarCurr: state_type] :
      ( v122222(VarCurr)
    <=> v113911(VarCurr,10) ) ).

tff(addAssignment_70167,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,10)
    <=> v113913(VarCurr,10) ) ).

tff(addAssignment_70166,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,10)
    <=> v113915(VarCurr,10) ) ).

tff(addAssignment_70165,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,10)
    <=> v113935(VarCurr,10) ) ).

tff(addAssignment_70164,axiom,
    ! [VarCurr: state_type] :
      ( v122220(VarCurr)
    <=> v113107(VarCurr,10) ) ).

tff(addAssignment_70163,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,10)
    <=> v113143(VarCurr,10) ) ).

tff(addAssignment_70162,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,10)
    <=> v113110(VarCurr,10) ) ).

tff(addAssignment_70161,axiom,
    ! [VarCurr: state_type] :
      ( v122218(VarCurr)
    <=> v113100(VarCurr,10) ) ).

tff(addAssignment_70160,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,10)
    <=> v113101(VarCurr,10) ) ).

tff(addAssignment_70159,axiom,
    ! [VarCurr: state_type] :
      ( v122208(VarCurr)
    <=> v113810(VarCurr,10) ) ).

tff(addAssignment_70158,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,10)
    <=> v113812(VarCurr,10) ) ).

tff(addAssignment_70157,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,10)
    <=> v113814(VarCurr,10) ) ).

tff(addAssignment_70156,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,10)
    <=> v113816(VarCurr,10) ) ).

tff(addAssignment_70155,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,10)
    <=> v113818(VarCurr,10) ) ).

tff(addAssignment_70154,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,10)
    <=> v122210(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_1586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122211(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v122210(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1586,axiom,
    ! [VarNext: state_type] :
      ( v122211(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v122210(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122211(VarNext)
      <=> v122212(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122212(VarNext)
      <=> ( v122214(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_8125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122214(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_70153,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,10)
    <=> v113830(VarCurr,10) ) ).

tff(addAssignment_70152,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,10)
    <=> v113832(VarCurr,10) ) ).

tff(addAssignment_70151,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,10)
    <=> v113834(VarCurr,10) ) ).

tff(addAssignment_70150,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,10)
    <=> v113873(VarCurr,10) ) ).

tff(addAssignment_70149,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,10)
    <=> v113856(VarCurr,10) ) ).

tff(addAssignment_70148,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,10)
    <=> v113837(VarCurr,10) ) ).

tff(addAssignment_70147,axiom,
    ! [VarCurr: state_type] :
      ( v122198(VarCurr)
    <=> v113020(VarCurr,10) ) ).

tff(addAssignment_70146,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,10)
    <=> v113022(VarCurr,10) ) ).

tff(addAssignment_70145,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,10)
    <=> v113024(VarCurr,10) ) ).

tff(addAssignment_70144,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,10)
    <=> v113026(VarCurr,10) ) ).

tff(addAssignment_70143,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,10)
    <=> v113028(VarCurr,10) ) ).

tff(addAssignment_70142,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,10)
    <=> v122200(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_1585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122201(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v122200(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1585,axiom,
    ! [VarNext: state_type] :
      ( v122201(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v122200(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122201(VarNext)
      <=> v122202(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122202(VarNext)
      <=> ( v122204(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_8124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122204(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_70141,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,10)
    <=> v113040(VarCurr,10) ) ).

tff(addAssignment_70140,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,10)
    <=> v113042(VarCurr,10) ) ).

tff(addAssignment_70139,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,10)
    <=> v113044(VarCurr,10) ) ).

tff(addAssignment_70138,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,10)
    <=> v113045(VarCurr,10) ) ).

tff(addAssignment_70137,axiom,
    ! [VarCurr: state_type] :
      ( v122188(VarCurr)
    <=> v112940(VarCurr,10) ) ).

tff(addAssignment_70136,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,10)
    <=> v112942(VarCurr,10) ) ).

tff(addAssignment_70135,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,10)
    <=> v112944(VarCurr,10) ) ).

tff(addAssignment_70134,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,10)
    <=> v112946(VarCurr,10) ) ).

tff(addAssignment_70133,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,10)
    <=> v112948(VarCurr,10) ) ).

tff(addAssignment_70132,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,10)
    <=> v122190(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_1584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122191(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v122190(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1584,axiom,
    ! [VarNext: state_type] :
      ( v122191(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v122190(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122191(VarNext)
      <=> v122192(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v122192(VarNext)
      <=> ( v122194(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_8123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v122194(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_70131,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,10)
    <=> v112960(VarCurr,10) ) ).

tff(addAssignment_70130,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,10)
    <=> v112962(VarCurr,10) ) ).

tff(addAssignment_70129,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,10)
    <=> v112964(VarCurr,10) ) ).

tff(addAssignment_70128,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,10)
    <=> v112965(VarCurr,10) ) ).

tff(addAssignment_70127,axiom,
    ! [VarCurr: state_type] :
      ( v121977(VarCurr,2)
    <=> v121992(VarCurr,2) ) ).

tff(addAssignment_70126,axiom,
    ! [VarCurr: state_type] :
      ( v121977(VarCurr,1)
    <=> v121992(VarCurr,1) ) ).

tff(addAssignment_70125,axiom,
    ! [VarCurr: state_type] :
      ( v121977(VarCurr,0)
    <=> v121992(VarCurr,0) ) ).

tff(addAssignment_70124,axiom,
    ! [VarCurr: state_type] :
      ( v121992(VarCurr,0)
    <=> v122180(VarCurr) ) ).

tff(addAssignment_70123,axiom,
    ! [VarCurr: state_type] :
      ( v121992(VarCurr,1)
    <=> v122175(VarCurr) ) ).

tff(addAssignment_70122,axiom,
    ! [VarCurr: state_type] :
      ( v121992(VarCurr,2)
    <=> v121994(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14736,axiom,
    ! [VarCurr: state_type] :
      ( v122180(VarCurr)
    <=> ( v122181(VarCurr)
        & v122184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14735,axiom,
    ! [VarCurr: state_type] :
      ( v122184(VarCurr)
    <=> ( v122000(VarCurr,0)
        | v122161(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14734,axiom,
    ! [VarCurr: state_type] :
      ( v122181(VarCurr)
    <=> ( v122182(VarCurr)
        | v122183(VarCurr) ) ) ).

tff(writeUnaryOperator_8122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122183(VarCurr)
    <=> v122161(VarCurr,0) ) ).

tff(writeUnaryOperator_8121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122182(VarCurr)
    <=> v122000(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14733,axiom,
    ! [VarCurr: state_type] :
      ( v122175(VarCurr)
    <=> ( v122176(VarCurr)
        & v122179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14732,axiom,
    ! [VarCurr: state_type] :
      ( v122179(VarCurr)
    <=> ( v121999(VarCurr)
        | v122162(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14731,axiom,
    ! [VarCurr: state_type] :
      ( v122176(VarCurr)
    <=> ( v122177(VarCurr)
        | v122178(VarCurr) ) ) ).

tff(writeUnaryOperator_8120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122178(VarCurr)
    <=> v122162(VarCurr) ) ).

tff(writeUnaryOperator_8119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122177(VarCurr)
    <=> v121999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14730,axiom,
    ! [VarCurr: state_type] :
      ( v121994(VarCurr)
    <=> ( v121995(VarCurr)
        & v122174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14729,axiom,
    ! [VarCurr: state_type] :
      ( v122174(VarCurr)
    <=> ( v121997(VarCurr)
        | v122169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14728,axiom,
    ! [VarCurr: state_type] :
      ( v121995(VarCurr)
    <=> ( v121996(VarCurr)
        | v122168(VarCurr) ) ) ).

tff(writeUnaryOperator_8118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122168(VarCurr)
    <=> v122169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14727,axiom,
    ! [VarCurr: state_type] :
      ( v122169(VarCurr)
    <=> ( v122170(VarCurr)
        & v122173(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5339,axiom,
    ! [VarCurr: state_type] :
      ( v122173(VarCurr)
    <=> ( v122000(VarCurr,2)
        | v122161(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14726,axiom,
    ! [VarCurr: state_type] :
      ( v122170(VarCurr)
    <=> ( v122171(VarCurr)
        | v122172(VarCurr) ) ) ).

tff(writeUnaryOperator_8117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122172(VarCurr)
    <=> v122161(VarCurr,2) ) ).

tff(writeUnaryOperator_8116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122171(VarCurr)
    <=> v122000(VarCurr,2) ) ).

tff(writeUnaryOperator_8115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121996(VarCurr)
    <=> v121997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14725,axiom,
    ! [VarCurr: state_type] :
      ( v121997(VarCurr)
    <=> ( v121998(VarCurr)
        | v122167(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5338,axiom,
    ! [VarCurr: state_type] :
      ( v122167(VarCurr)
    <=> ( v122000(VarCurr,1)
        & v122161(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14724,axiom,
    ! [VarCurr: state_type] :
      ( v121998(VarCurr)
    <=> ( v121999(VarCurr)
        & v122162(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14723,axiom,
    ! [VarCurr: state_type] :
      ( v122162(VarCurr)
    <=> ( v122163(VarCurr)
        & v122166(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5337,axiom,
    ! [VarCurr: state_type] :
      ( v122166(VarCurr)
    <=> ( v122000(VarCurr,1)
        | v122161(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14722,axiom,
    ! [VarCurr: state_type] :
      ( v122163(VarCurr)
    <=> ( v122164(VarCurr)
        | v122165(VarCurr) ) ) ).

tff(writeUnaryOperator_8114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122165(VarCurr)
    <=> v122161(VarCurr,1) ) ).

tff(writeUnaryOperator_8113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122164(VarCurr)
    <=> v122000(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14721,axiom,
    ! [VarCurr: state_type] :
      ( v121999(VarCurr)
    <=> ( v122000(VarCurr,0)
        & v122161(VarCurr,0) ) ) ).

tff(addAssignment_70121,axiom,
    ! [VarCurr: state_type] :
      ( v122161(VarCurr,0)
    <=> v121991(VarCurr) ) ).

tff(addAssignment_70120,axiom,
    ! [VarCurr: state_type] :
      ( ( v122161(VarCurr,2)
      <=> $false )
      & ( v122161(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70119,axiom,
    ! [VarCurr: state_type] :
      ( v122000(VarCurr,0)
    <=> v122156(VarCurr) ) ).

tff(addAssignment_70118,axiom,
    ! [VarCurr: state_type] :
      ( v122000(VarCurr,1)
    <=> v122151(VarCurr) ) ).

tff(addAssignment_70117,axiom,
    ! [VarCurr: state_type] :
      ( v122000(VarCurr,2)
    <=> v122002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14720,axiom,
    ! [VarCurr: state_type] :
      ( v122156(VarCurr)
    <=> ( v122157(VarCurr)
        & v122160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14719,axiom,
    ! [VarCurr: state_type] :
      ( v122160(VarCurr)
    <=> ( v122008(VarCurr,0)
        | v122137(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14718,axiom,
    ! [VarCurr: state_type] :
      ( v122157(VarCurr)
    <=> ( v122158(VarCurr)
        | v122159(VarCurr) ) ) ).

tff(writeUnaryOperator_8112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122159(VarCurr)
    <=> v122137(VarCurr,0) ) ).

tff(writeUnaryOperator_8111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122158(VarCurr)
    <=> v122008(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14717,axiom,
    ! [VarCurr: state_type] :
      ( v122151(VarCurr)
    <=> ( v122152(VarCurr)
        & v122155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14716,axiom,
    ! [VarCurr: state_type] :
      ( v122155(VarCurr)
    <=> ( v122007(VarCurr)
        | v122138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14715,axiom,
    ! [VarCurr: state_type] :
      ( v122152(VarCurr)
    <=> ( v122153(VarCurr)
        | v122154(VarCurr) ) ) ).

tff(writeUnaryOperator_8110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122154(VarCurr)
    <=> v122138(VarCurr) ) ).

tff(writeUnaryOperator_8109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122153(VarCurr)
    <=> v122007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14714,axiom,
    ! [VarCurr: state_type] :
      ( v122002(VarCurr)
    <=> ( v122003(VarCurr)
        & v122150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14713,axiom,
    ! [VarCurr: state_type] :
      ( v122150(VarCurr)
    <=> ( v122005(VarCurr)
        | v122145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14712,axiom,
    ! [VarCurr: state_type] :
      ( v122003(VarCurr)
    <=> ( v122004(VarCurr)
        | v122144(VarCurr) ) ) ).

tff(writeUnaryOperator_8108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122144(VarCurr)
    <=> v122145(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14711,axiom,
    ! [VarCurr: state_type] :
      ( v122145(VarCurr)
    <=> ( v122146(VarCurr)
        & v122149(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5336,axiom,
    ! [VarCurr: state_type] :
      ( v122149(VarCurr)
    <=> ( v122008(VarCurr,2)
        | v122137(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14710,axiom,
    ! [VarCurr: state_type] :
      ( v122146(VarCurr)
    <=> ( v122147(VarCurr)
        | v122148(VarCurr) ) ) ).

tff(writeUnaryOperator_8107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122148(VarCurr)
    <=> v122137(VarCurr,2) ) ).

tff(writeUnaryOperator_8106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122147(VarCurr)
    <=> v122008(VarCurr,2) ) ).

tff(writeUnaryOperator_8105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122004(VarCurr)
    <=> v122005(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14709,axiom,
    ! [VarCurr: state_type] :
      ( v122005(VarCurr)
    <=> ( v122006(VarCurr)
        | v122143(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5335,axiom,
    ! [VarCurr: state_type] :
      ( v122143(VarCurr)
    <=> ( v122008(VarCurr,1)
        & v122137(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14708,axiom,
    ! [VarCurr: state_type] :
      ( v122006(VarCurr)
    <=> ( v122007(VarCurr)
        & v122138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14707,axiom,
    ! [VarCurr: state_type] :
      ( v122138(VarCurr)
    <=> ( v122139(VarCurr)
        & v122142(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5334,axiom,
    ! [VarCurr: state_type] :
      ( v122142(VarCurr)
    <=> ( v122008(VarCurr,1)
        | v122137(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14706,axiom,
    ! [VarCurr: state_type] :
      ( v122139(VarCurr)
    <=> ( v122140(VarCurr)
        | v122141(VarCurr) ) ) ).

tff(writeUnaryOperator_8104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122141(VarCurr)
    <=> v122137(VarCurr,1) ) ).

tff(writeUnaryOperator_8103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122140(VarCurr)
    <=> v122008(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14705,axiom,
    ! [VarCurr: state_type] :
      ( v122007(VarCurr)
    <=> ( v122008(VarCurr,0)
        & v122137(VarCurr,0) ) ) ).

tff(addAssignment_70116,axiom,
    ! [VarCurr: state_type] :
      ( v122137(VarCurr,0)
    <=> v121989(VarCurr) ) ).

tff(addAssignment_70115,axiom,
    ! [VarCurr: state_type] :
      ( ( v122137(VarCurr,2)
      <=> $false )
      & ( v122137(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70114,axiom,
    ! [VarCurr: state_type] :
      ( v122008(VarCurr,0)
    <=> v122132(VarCurr) ) ).

tff(addAssignment_70113,axiom,
    ! [VarCurr: state_type] :
      ( v122008(VarCurr,1)
    <=> v122127(VarCurr) ) ).

tff(addAssignment_70112,axiom,
    ! [VarCurr: state_type] :
      ( v122008(VarCurr,2)
    <=> v122010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14704,axiom,
    ! [VarCurr: state_type] :
      ( v122132(VarCurr)
    <=> ( v122133(VarCurr)
        & v122136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14703,axiom,
    ! [VarCurr: state_type] :
      ( v122136(VarCurr)
    <=> ( v122016(VarCurr,0)
        | v122113(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14702,axiom,
    ! [VarCurr: state_type] :
      ( v122133(VarCurr)
    <=> ( v122134(VarCurr)
        | v122135(VarCurr) ) ) ).

tff(writeUnaryOperator_8102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122135(VarCurr)
    <=> v122113(VarCurr,0) ) ).

tff(writeUnaryOperator_8101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122134(VarCurr)
    <=> v122016(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14701,axiom,
    ! [VarCurr: state_type] :
      ( v122127(VarCurr)
    <=> ( v122128(VarCurr)
        & v122131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14700,axiom,
    ! [VarCurr: state_type] :
      ( v122131(VarCurr)
    <=> ( v122015(VarCurr)
        | v122114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14699,axiom,
    ! [VarCurr: state_type] :
      ( v122128(VarCurr)
    <=> ( v122129(VarCurr)
        | v122130(VarCurr) ) ) ).

tff(writeUnaryOperator_8100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122130(VarCurr)
    <=> v122114(VarCurr) ) ).

tff(writeUnaryOperator_8099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122129(VarCurr)
    <=> v122015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14698,axiom,
    ! [VarCurr: state_type] :
      ( v122010(VarCurr)
    <=> ( v122011(VarCurr)
        & v122126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14697,axiom,
    ! [VarCurr: state_type] :
      ( v122126(VarCurr)
    <=> ( v122013(VarCurr)
        | v122121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14696,axiom,
    ! [VarCurr: state_type] :
      ( v122011(VarCurr)
    <=> ( v122012(VarCurr)
        | v122120(VarCurr) ) ) ).

tff(writeUnaryOperator_8098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122120(VarCurr)
    <=> v122121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14695,axiom,
    ! [VarCurr: state_type] :
      ( v122121(VarCurr)
    <=> ( v122122(VarCurr)
        & v122125(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5333,axiom,
    ! [VarCurr: state_type] :
      ( v122125(VarCurr)
    <=> ( v122016(VarCurr,2)
        | v122113(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14694,axiom,
    ! [VarCurr: state_type] :
      ( v122122(VarCurr)
    <=> ( v122123(VarCurr)
        | v122124(VarCurr) ) ) ).

tff(writeUnaryOperator_8097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122124(VarCurr)
    <=> v122113(VarCurr,2) ) ).

tff(writeUnaryOperator_8096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122123(VarCurr)
    <=> v122016(VarCurr,2) ) ).

tff(writeUnaryOperator_8095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122012(VarCurr)
    <=> v122013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14693,axiom,
    ! [VarCurr: state_type] :
      ( v122013(VarCurr)
    <=> ( v122014(VarCurr)
        | v122119(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5332,axiom,
    ! [VarCurr: state_type] :
      ( v122119(VarCurr)
    <=> ( v122016(VarCurr,1)
        & v122113(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14692,axiom,
    ! [VarCurr: state_type] :
      ( v122014(VarCurr)
    <=> ( v122015(VarCurr)
        & v122114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14691,axiom,
    ! [VarCurr: state_type] :
      ( v122114(VarCurr)
    <=> ( v122115(VarCurr)
        & v122118(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5331,axiom,
    ! [VarCurr: state_type] :
      ( v122118(VarCurr)
    <=> ( v122016(VarCurr,1)
        | v122113(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14690,axiom,
    ! [VarCurr: state_type] :
      ( v122115(VarCurr)
    <=> ( v122116(VarCurr)
        | v122117(VarCurr) ) ) ).

tff(writeUnaryOperator_8094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122117(VarCurr)
    <=> v122113(VarCurr,1) ) ).

tff(writeUnaryOperator_8093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122116(VarCurr)
    <=> v122016(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14689,axiom,
    ! [VarCurr: state_type] :
      ( v122015(VarCurr)
    <=> ( v122016(VarCurr,0)
        & v122113(VarCurr,0) ) ) ).

tff(addAssignment_70111,axiom,
    ! [VarCurr: state_type] :
      ( v122113(VarCurr,0)
    <=> v121987(VarCurr) ) ).

tff(addAssignment_70110,axiom,
    ! [VarCurr: state_type] :
      ( ( v122113(VarCurr,2)
      <=> $false )
      & ( v122113(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70109,axiom,
    ! [VarCurr: state_type] :
      ( v122016(VarCurr,0)
    <=> v122108(VarCurr) ) ).

tff(addAssignment_70108,axiom,
    ! [VarCurr: state_type] :
      ( v122016(VarCurr,1)
    <=> v122103(VarCurr) ) ).

tff(addAssignment_70107,axiom,
    ! [VarCurr: state_type] :
      ( v122016(VarCurr,2)
    <=> v122018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14688,axiom,
    ! [VarCurr: state_type] :
      ( v122108(VarCurr)
    <=> ( v122109(VarCurr)
        & v122112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14687,axiom,
    ! [VarCurr: state_type] :
      ( v122112(VarCurr)
    <=> ( v122024(VarCurr,0)
        | v122089(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14686,axiom,
    ! [VarCurr: state_type] :
      ( v122109(VarCurr)
    <=> ( v122110(VarCurr)
        | v122111(VarCurr) ) ) ).

tff(writeUnaryOperator_8092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122111(VarCurr)
    <=> v122089(VarCurr,0) ) ).

tff(writeUnaryOperator_8091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122110(VarCurr)
    <=> v122024(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14685,axiom,
    ! [VarCurr: state_type] :
      ( v122103(VarCurr)
    <=> ( v122104(VarCurr)
        & v122107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14684,axiom,
    ! [VarCurr: state_type] :
      ( v122107(VarCurr)
    <=> ( v122023(VarCurr)
        | v122090(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14683,axiom,
    ! [VarCurr: state_type] :
      ( v122104(VarCurr)
    <=> ( v122105(VarCurr)
        | v122106(VarCurr) ) ) ).

tff(writeUnaryOperator_8090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122106(VarCurr)
    <=> v122090(VarCurr) ) ).

tff(writeUnaryOperator_8089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122105(VarCurr)
    <=> v122023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14682,axiom,
    ! [VarCurr: state_type] :
      ( v122018(VarCurr)
    <=> ( v122019(VarCurr)
        & v122102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14681,axiom,
    ! [VarCurr: state_type] :
      ( v122102(VarCurr)
    <=> ( v122021(VarCurr)
        | v122097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14680,axiom,
    ! [VarCurr: state_type] :
      ( v122019(VarCurr)
    <=> ( v122020(VarCurr)
        | v122096(VarCurr) ) ) ).

tff(writeUnaryOperator_8088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122096(VarCurr)
    <=> v122097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14679,axiom,
    ! [VarCurr: state_type] :
      ( v122097(VarCurr)
    <=> ( v122098(VarCurr)
        & v122101(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5330,axiom,
    ! [VarCurr: state_type] :
      ( v122101(VarCurr)
    <=> ( v122024(VarCurr,2)
        | v122089(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14678,axiom,
    ! [VarCurr: state_type] :
      ( v122098(VarCurr)
    <=> ( v122099(VarCurr)
        | v122100(VarCurr) ) ) ).

tff(writeUnaryOperator_8087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122100(VarCurr)
    <=> v122089(VarCurr,2) ) ).

tff(writeUnaryOperator_8086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122099(VarCurr)
    <=> v122024(VarCurr,2) ) ).

tff(writeUnaryOperator_8085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122020(VarCurr)
    <=> v122021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14677,axiom,
    ! [VarCurr: state_type] :
      ( v122021(VarCurr)
    <=> ( v122022(VarCurr)
        | v122095(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5329,axiom,
    ! [VarCurr: state_type] :
      ( v122095(VarCurr)
    <=> ( v122024(VarCurr,1)
        & v122089(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14676,axiom,
    ! [VarCurr: state_type] :
      ( v122022(VarCurr)
    <=> ( v122023(VarCurr)
        & v122090(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14675,axiom,
    ! [VarCurr: state_type] :
      ( v122090(VarCurr)
    <=> ( v122091(VarCurr)
        & v122094(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5328,axiom,
    ! [VarCurr: state_type] :
      ( v122094(VarCurr)
    <=> ( v122024(VarCurr,1)
        | v122089(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14674,axiom,
    ! [VarCurr: state_type] :
      ( v122091(VarCurr)
    <=> ( v122092(VarCurr)
        | v122093(VarCurr) ) ) ).

tff(writeUnaryOperator_8084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122093(VarCurr)
    <=> v122089(VarCurr,1) ) ).

tff(writeUnaryOperator_8083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122092(VarCurr)
    <=> v122024(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14673,axiom,
    ! [VarCurr: state_type] :
      ( v122023(VarCurr)
    <=> ( v122024(VarCurr,0)
        & v122089(VarCurr,0) ) ) ).

tff(addAssignment_70106,axiom,
    ! [VarCurr: state_type] :
      ( v122089(VarCurr,0)
    <=> v121985(VarCurr) ) ).

tff(addAssignment_70105,axiom,
    ! [VarCurr: state_type] :
      ( ( v122089(VarCurr,2)
      <=> $false )
      & ( v122089(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70104,axiom,
    ! [VarCurr: state_type] :
      ( v122024(VarCurr,0)
    <=> v122084(VarCurr) ) ).

tff(addAssignment_70103,axiom,
    ! [VarCurr: state_type] :
      ( v122024(VarCurr,1)
    <=> v122079(VarCurr) ) ).

tff(addAssignment_70102,axiom,
    ! [VarCurr: state_type] :
      ( v122024(VarCurr,2)
    <=> v122026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14672,axiom,
    ! [VarCurr: state_type] :
      ( v122084(VarCurr)
    <=> ( v122085(VarCurr)
        & v122088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14671,axiom,
    ! [VarCurr: state_type] :
      ( v122088(VarCurr)
    <=> ( v122032(VarCurr,0)
        | v122065(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14670,axiom,
    ! [VarCurr: state_type] :
      ( v122085(VarCurr)
    <=> ( v122086(VarCurr)
        | v122087(VarCurr) ) ) ).

tff(writeUnaryOperator_8082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122087(VarCurr)
    <=> v122065(VarCurr,0) ) ).

tff(writeUnaryOperator_8081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122086(VarCurr)
    <=> v122032(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14669,axiom,
    ! [VarCurr: state_type] :
      ( v122079(VarCurr)
    <=> ( v122080(VarCurr)
        & v122083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14668,axiom,
    ! [VarCurr: state_type] :
      ( v122083(VarCurr)
    <=> ( v122031(VarCurr)
        | v122066(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14667,axiom,
    ! [VarCurr: state_type] :
      ( v122080(VarCurr)
    <=> ( v122081(VarCurr)
        | v122082(VarCurr) ) ) ).

tff(writeUnaryOperator_8080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122082(VarCurr)
    <=> v122066(VarCurr) ) ).

tff(writeUnaryOperator_8079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122081(VarCurr)
    <=> v122031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14666,axiom,
    ! [VarCurr: state_type] :
      ( v122026(VarCurr)
    <=> ( v122027(VarCurr)
        & v122078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14665,axiom,
    ! [VarCurr: state_type] :
      ( v122078(VarCurr)
    <=> ( v122029(VarCurr)
        | v122073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14664,axiom,
    ! [VarCurr: state_type] :
      ( v122027(VarCurr)
    <=> ( v122028(VarCurr)
        | v122072(VarCurr) ) ) ).

tff(writeUnaryOperator_8078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122072(VarCurr)
    <=> v122073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14663,axiom,
    ! [VarCurr: state_type] :
      ( v122073(VarCurr)
    <=> ( v122074(VarCurr)
        & v122077(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5327,axiom,
    ! [VarCurr: state_type] :
      ( v122077(VarCurr)
    <=> ( v122032(VarCurr,2)
        | v122065(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14662,axiom,
    ! [VarCurr: state_type] :
      ( v122074(VarCurr)
    <=> ( v122075(VarCurr)
        | v122076(VarCurr) ) ) ).

tff(writeUnaryOperator_8077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122076(VarCurr)
    <=> v122065(VarCurr,2) ) ).

tff(writeUnaryOperator_8076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122075(VarCurr)
    <=> v122032(VarCurr,2) ) ).

tff(writeUnaryOperator_8075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122028(VarCurr)
    <=> v122029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14661,axiom,
    ! [VarCurr: state_type] :
      ( v122029(VarCurr)
    <=> ( v122030(VarCurr)
        | v122071(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5326,axiom,
    ! [VarCurr: state_type] :
      ( v122071(VarCurr)
    <=> ( v122032(VarCurr,1)
        & v122065(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14660,axiom,
    ! [VarCurr: state_type] :
      ( v122030(VarCurr)
    <=> ( v122031(VarCurr)
        & v122066(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14659,axiom,
    ! [VarCurr: state_type] :
      ( v122066(VarCurr)
    <=> ( v122067(VarCurr)
        & v122070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5325,axiom,
    ! [VarCurr: state_type] :
      ( v122070(VarCurr)
    <=> ( v122032(VarCurr,1)
        | v122065(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14658,axiom,
    ! [VarCurr: state_type] :
      ( v122067(VarCurr)
    <=> ( v122068(VarCurr)
        | v122069(VarCurr) ) ) ).

tff(writeUnaryOperator_8074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122069(VarCurr)
    <=> v122065(VarCurr,1) ) ).

tff(writeUnaryOperator_8073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122068(VarCurr)
    <=> v122032(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14657,axiom,
    ! [VarCurr: state_type] :
      ( v122031(VarCurr)
    <=> ( v122032(VarCurr,0)
        & v122065(VarCurr,0) ) ) ).

tff(addAssignment_70101,axiom,
    ! [VarCurr: state_type] :
      ( v122065(VarCurr,0)
    <=> v121983(VarCurr) ) ).

tff(addAssignment_70100,axiom,
    ! [VarCurr: state_type] :
      ( ( v122065(VarCurr,2)
      <=> $false )
      & ( v122065(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70099,axiom,
    ! [VarCurr: state_type] :
      ( v122032(VarCurr,0)
    <=> v122060(VarCurr) ) ).

tff(addAssignment_70098,axiom,
    ! [VarCurr: state_type] :
      ( v122032(VarCurr,1)
    <=> v122055(VarCurr) ) ).

tff(addAssignment_70097,axiom,
    ! [VarCurr: state_type] :
      ( v122032(VarCurr,2)
    <=> v122034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14656,axiom,
    ! [VarCurr: state_type] :
      ( v122060(VarCurr)
    <=> ( v122061(VarCurr)
        & v122064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14655,axiom,
    ! [VarCurr: state_type] :
      ( v122064(VarCurr)
    <=> ( v122040(VarCurr,0)
        | v122041(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14654,axiom,
    ! [VarCurr: state_type] :
      ( v122061(VarCurr)
    <=> ( v122062(VarCurr)
        | v122063(VarCurr) ) ) ).

tff(writeUnaryOperator_8072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122063(VarCurr)
    <=> v122041(VarCurr,0) ) ).

tff(writeUnaryOperator_8071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122062(VarCurr)
    <=> v122040(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14653,axiom,
    ! [VarCurr: state_type] :
      ( v122055(VarCurr)
    <=> ( v122056(VarCurr)
        & v122059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14652,axiom,
    ! [VarCurr: state_type] :
      ( v122059(VarCurr)
    <=> ( v122039(VarCurr)
        | v122042(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14651,axiom,
    ! [VarCurr: state_type] :
      ( v122056(VarCurr)
    <=> ( v122057(VarCurr)
        | v122058(VarCurr) ) ) ).

tff(writeUnaryOperator_8070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122058(VarCurr)
    <=> v122042(VarCurr) ) ).

tff(writeUnaryOperator_8069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122057(VarCurr)
    <=> v122039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14650,axiom,
    ! [VarCurr: state_type] :
      ( v122034(VarCurr)
    <=> ( v122035(VarCurr)
        & v122054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14649,axiom,
    ! [VarCurr: state_type] :
      ( v122054(VarCurr)
    <=> ( v122037(VarCurr)
        | v122049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14648,axiom,
    ! [VarCurr: state_type] :
      ( v122035(VarCurr)
    <=> ( v122036(VarCurr)
        | v122048(VarCurr) ) ) ).

tff(writeUnaryOperator_8068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122048(VarCurr)
    <=> v122049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14647,axiom,
    ! [VarCurr: state_type] :
      ( v122049(VarCurr)
    <=> ( v122050(VarCurr)
        & v122053(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5324,axiom,
    ! [VarCurr: state_type] :
      ( v122053(VarCurr)
    <=> ( v122040(VarCurr,2)
        | v122041(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14646,axiom,
    ! [VarCurr: state_type] :
      ( v122050(VarCurr)
    <=> ( v122051(VarCurr)
        | v122052(VarCurr) ) ) ).

tff(writeUnaryOperator_8067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122052(VarCurr)
    <=> v122041(VarCurr,2) ) ).

tff(writeUnaryOperator_8066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122051(VarCurr)
    <=> v122040(VarCurr,2) ) ).

tff(writeUnaryOperator_8065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122036(VarCurr)
    <=> v122037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14645,axiom,
    ! [VarCurr: state_type] :
      ( v122037(VarCurr)
    <=> ( v122038(VarCurr)
        | v122047(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5323,axiom,
    ! [VarCurr: state_type] :
      ( v122047(VarCurr)
    <=> ( v122040(VarCurr,1)
        & v122041(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14644,axiom,
    ! [VarCurr: state_type] :
      ( v122038(VarCurr)
    <=> ( v122039(VarCurr)
        & v122042(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14643,axiom,
    ! [VarCurr: state_type] :
      ( v122042(VarCurr)
    <=> ( v122043(VarCurr)
        & v122046(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5322,axiom,
    ! [VarCurr: state_type] :
      ( v122046(VarCurr)
    <=> ( v122040(VarCurr,1)
        | v122041(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14642,axiom,
    ! [VarCurr: state_type] :
      ( v122043(VarCurr)
    <=> ( v122044(VarCurr)
        | v122045(VarCurr) ) ) ).

tff(writeUnaryOperator_8064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122045(VarCurr)
    <=> v122041(VarCurr,1) ) ).

tff(writeUnaryOperator_8063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v122044(VarCurr)
    <=> v122040(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14641,axiom,
    ! [VarCurr: state_type] :
      ( v122039(VarCurr)
    <=> ( v122040(VarCurr,0)
        & v122041(VarCurr,0) ) ) ).

tff(addAssignment_70096,axiom,
    ! [VarCurr: state_type] :
      ( v122041(VarCurr,0)
    <=> v121981(VarCurr) ) ).

tff(addAssignment_70095,axiom,
    ! [VarCurr: state_type] :
      ( ( v122041(VarCurr,2)
      <=> $false )
      & ( v122041(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70094,axiom,
    ! [VarCurr: state_type] :
      ( v122040(VarCurr,0)
    <=> v121979(VarCurr) ) ).

tff(addAssignment_70093,axiom,
    ! [VarCurr: state_type] :
      ( ( v122040(VarCurr,2)
      <=> $false )
      & ( v122040(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_70092,axiom,
    ! [VarCurr: state_type] :
      ( v121991(VarCurr)
    <=> v114692(VarCurr,10) ) ).

tff(addAssignment_70091,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,10)
    <=> v114694(VarCurr,10) ) ).

tff(addAssignment_70090,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,10)
    <=> v114696(VarCurr,10) ) ).

tff(addAssignment_70089,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,10)
    <=> v114697(VarCurr,10) ) ).

tff(addAssignment_70088,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,10)
    <=> v113918(VarCurr,10) ) ).

tff(addAssignment_70087,axiom,
    ! [VarCurr: state_type] :
      ( v121989(VarCurr)
    <=> v114685(VarCurr,10) ) ).

tff(addAssignment_70086,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,10)
    <=> v114686(VarCurr,10) ) ).

tff(addAssignment_70085,axiom,
    ! [VarCurr: state_type] :
      ( v121987(VarCurr)
    <=> v114661(VarCurr,10) ) ).

tff(addAssignment_70084,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,10)
    <=> v114662(VarCurr,10) ) ).

tff(addAssignment_70083,axiom,
    ! [VarCurr: state_type] :
      ( v121985(VarCurr)
    <=> v114633(VarCurr,10) ) ).

tff(addAssignment_70082,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,10)
    <=> v114635(VarCurr,10) ) ).

tff(addAssignment_70081,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,10)
    <=> v114637(VarCurr,10) ) ).

tff(addAssignment_70080,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,10)
    <=> v114638(VarCurr,10) ) ).

tff(addAssignment_70079,axiom,
    ! [VarCurr: state_type] :
      ( v121983(VarCurr)
    <=> v114605(VarCurr,10) ) ).

tff(addAssignment_70078,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,10)
    <=> v114607(VarCurr,10) ) ).

tff(addAssignment_70077,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,10)
    <=> v114609(VarCurr,10) ) ).

tff(addAssignment_70076,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,10)
    <=> v114610(VarCurr,10) ) ).

tff(addAssignment_70075,axiom,
    ! [VarCurr: state_type] :
      ( v121981(VarCurr)
    <=> v114577(VarCurr,10) ) ).

tff(addAssignment_70074,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,10)
    <=> v114579(VarCurr,10) ) ).

tff(addAssignment_70073,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,10)
    <=> v114581(VarCurr,10) ) ).

tff(addAssignment_70072,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,10)
    <=> v114582(VarCurr,10) ) ).

tff(addAssignment_70071,axiom,
    ! [VarCurr: state_type] :
      ( v121979(VarCurr)
    <=> v114549(VarCurr,10) ) ).

tff(addAssignment_70070,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,10)
    <=> v114551(VarCurr,10) ) ).

tff(addAssignment_70069,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,10)
    <=> v114553(VarCurr,10) ) ).

tff(addAssignment_70068,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,10)
    <=> v114554(VarCurr,10) ) ).

tff(addAssignment_70067,axiom,
    ! [VarCurr: state_type] :
      ( v121965(VarCurr)
    <=> v121967(VarCurr) ) ).

tff(addAssignment_70066,axiom,
    ! [VarCurr: state_type] :
      ( v121967(VarCurr)
    <=> v121941(VarCurr) ) ).

tff(addAssignment_70065,axiom,
    ! [VarCurr: state_type] :
      ( v121961(VarCurr)
    <=> v121963(VarCurr) ) ).

tff(addAssignment_70064,axiom,
    ! [VarCurr: state_type] :
      ( v121963(VarCurr)
    <=> v121933(VarCurr) ) ).

tff(addAssignment_70063,axiom,
    ! [VarCurr: state_type] :
      ( v121937(VarCurr)
    <=> v121939(VarCurr) ) ).

tff(addAssignment_70062,axiom,
    ! [VarCurr: state_type] :
      ( v121939(VarCurr)
    <=> v121941(VarCurr) ) ).

tff(addAssignment_70061,axiom,
    ! [VarCurr: state_type] :
      ( v121941(VarCurr)
    <=> v121943(VarCurr) ) ).

tff(addAssignment_70060,axiom,
    ! [VarCurr: state_type] :
      ( v121943(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_70059,axiom,
    ! [VarCurr: state_type] :
      ( v121929(VarCurr)
    <=> v121931(VarCurr) ) ).

tff(addAssignment_70058,axiom,
    ! [VarCurr: state_type] :
      ( v121931(VarCurr)
    <=> v121933(VarCurr) ) ).

tff(addAssignment_70057,axiom,
    ! [VarCurr: state_type] :
      ( v121933(VarCurr)
    <=> v121935(VarCurr) ) ).

tff(addAssignment_70056,axiom,
    ! [VarCurr: state_type] :
      ( v121935(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14640,axiom,
    ! [VarCurr: state_type] :
      ( v121120(VarCurr)
    <=> ( v121919(VarCurr)
        & v121829(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5321,axiom,
    ! [VarCurr: state_type] :
      ( v121919(VarCurr)
    <=> ( v121122(VarCurr,1)
        & v121768(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1207,axiom,
    ! [VarCurr: state_type] :
      ( v121829(VarCurr)
    <=> ( ( v121831(VarCurr,4)
        <=> $false )
        & ( v121831(VarCurr,3)
        <=> $false )
        & ( v121831(VarCurr,2)
        <=> $false )
        & ( v121831(VarCurr,1)
        <=> $false )
        & ( v121831(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121831(VarCurr,B)
      <=> v121833(VarCurr,B) ) ) ).

tff(addAssignment_70054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121833(VarCurr,B)
      <=> v121835(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121901(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v121835(VarNext,B)
            <=> v121835(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1583,axiom,
    ! [VarNext: state_type] :
      ( v121901(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121835(VarNext,B)
          <=> v121911(VarNext,B) ) ) ) ).

tff(addAssignment_70053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121911(VarNext,B)
          <=> v121909(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121909(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1129,axiom,
    ! [VarCurr: state_type] :
      ( v121912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121909(VarCurr,B)
          <=> v121845(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14639,axiom,
    ! [VarCurr: state_type] :
      ( v121912(VarCurr)
    <=> ( v121913(VarCurr)
        & v121914(VarCurr) ) ) ).

tff(writeUnaryOperator_8062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121914(VarCurr)
    <=> v121841(VarCurr) ) ).

tff(writeUnaryOperator_8061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121913(VarCurr)
    <=> v121837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121901(VarNext)
      <=> v121902(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121902(VarNext)
      <=> ( v121903(VarNext)
          & v121896(VarNext) ) ) ) ).

tff(writeUnaryOperator_8060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121903(VarNext)
      <=> v121905(VarNext) ) ) ).

tff(addAssignment_70052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121905(VarNext)
      <=> v121896(VarCurr) ) ) ).

tff(addAssignment_70051,axiom,
    ! [VarCurr: state_type] :
      ( v121896(VarCurr)
    <=> v121898(VarCurr) ) ).

tff(addAssignment_70050,axiom,
    ! [VarCurr: state_type] :
      ( v121898(VarCurr)
    <=> v121602(VarCurr) ) ).

tff(addAssignment_70049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121845(VarCurr,B)
      <=> v121847(VarCurr,B) ) ) ).

tff(addAssignment_70048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121847(VarCurr,B)
      <=> v121849(VarCurr,B) ) ) ).

tff(addAssignment_70047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121849(VarCurr,B)
      <=> v121851(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121851(VarCurr,B)
          <=> v121865(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1128,axiom,
    ! [VarCurr: state_type] :
      ( v121853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121851(VarCurr,B)
          <=> v121858(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121865(VarCurr,B)
          <=> v121866(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1127,axiom,
    ! [VarCurr: state_type] :
      ( v121860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121865(VarCurr,B)
          <=> v121863(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121829(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121866(VarCurr,B)
          <=> v121867(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1126,axiom,
    ! [VarCurr: state_type] :
      ( v121829(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121866(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70046,axiom,
    ! [VarCurr: state_type] :
      ( v121867(VarCurr,0)
    <=> v121893(VarCurr) ) ).

tff(addAssignment_70045,axiom,
    ! [VarCurr: state_type] :
      ( v121867(VarCurr,1)
    <=> v121891(VarCurr) ) ).

tff(addAssignment_70044,axiom,
    ! [VarCurr: state_type] :
      ( v121867(VarCurr,2)
    <=> v121887(VarCurr) ) ).

tff(addAssignment_70043,axiom,
    ! [VarCurr: state_type] :
      ( v121867(VarCurr,3)
    <=> v121883(VarCurr) ) ).

tff(addAssignment_70042,axiom,
    ! [VarCurr: state_type] :
      ( v121867(VarCurr,4)
    <=> v121869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14636,axiom,
    ! [VarCurr: state_type] :
      ( v121891(VarCurr)
    <=> ( v121892(VarCurr)
        & v121894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14635,axiom,
    ! [VarCurr: state_type] :
      ( v121894(VarCurr)
    <=> ( v121831(VarCurr,0)
        | v121878(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5320,axiom,
    ! [VarCurr: state_type] :
      ( v121892(VarCurr)
    <=> ( v121893(VarCurr)
        | v121831(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121893(VarCurr)
    <=> v121831(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14634,axiom,
    ! [VarCurr: state_type] :
      ( v121887(VarCurr)
    <=> ( v121888(VarCurr)
        & v121890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14633,axiom,
    ! [VarCurr: state_type] :
      ( v121890(VarCurr)
    <=> ( v121876(VarCurr)
        | v121879(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5319,axiom,
    ! [VarCurr: state_type] :
      ( v121888(VarCurr)
    <=> ( v121889(VarCurr)
        | v121831(VarCurr,2) ) ) ).

tff(writeUnaryOperator_8058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121889(VarCurr)
    <=> v121876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14632,axiom,
    ! [VarCurr: state_type] :
      ( v121883(VarCurr)
    <=> ( v121884(VarCurr)
        & v121886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14631,axiom,
    ! [VarCurr: state_type] :
      ( v121886(VarCurr)
    <=> ( v121874(VarCurr)
        | v121880(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5318,axiom,
    ! [VarCurr: state_type] :
      ( v121884(VarCurr)
    <=> ( v121885(VarCurr)
        | v121831(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121885(VarCurr)
    <=> v121874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14630,axiom,
    ! [VarCurr: state_type] :
      ( v121869(VarCurr)
    <=> ( v121870(VarCurr)
        & v121881(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14629,axiom,
    ! [VarCurr: state_type] :
      ( v121881(VarCurr)
    <=> ( v121872(VarCurr)
        | v121882(VarCurr) ) ) ).

tff(writeUnaryOperator_8056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121882(VarCurr)
    <=> v121831(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5317,axiom,
    ! [VarCurr: state_type] :
      ( v121870(VarCurr)
    <=> ( v121871(VarCurr)
        | v121831(VarCurr,4) ) ) ).

tff(writeUnaryOperator_8055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121871(VarCurr)
    <=> v121872(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5316,axiom,
    ! [VarCurr: state_type] :
      ( v121872(VarCurr)
    <=> ( v121831(VarCurr,3)
        | v121873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14628,axiom,
    ! [VarCurr: state_type] :
      ( v121873(VarCurr)
    <=> ( v121874(VarCurr)
        & v121880(VarCurr) ) ) ).

tff(writeUnaryOperator_8054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121880(VarCurr)
    <=> v121831(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5315,axiom,
    ! [VarCurr: state_type] :
      ( v121874(VarCurr)
    <=> ( v121831(VarCurr,2)
        | v121875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14627,axiom,
    ! [VarCurr: state_type] :
      ( v121875(VarCurr)
    <=> ( v121876(VarCurr)
        & v121879(VarCurr) ) ) ).

tff(writeUnaryOperator_8053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121879(VarCurr)
    <=> v121831(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5314,axiom,
    ! [VarCurr: state_type] :
      ( v121876(VarCurr)
    <=> ( v121831(VarCurr,1)
        | v121877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14626,axiom,
    ! [VarCurr: state_type] :
      ( v121877(VarCurr)
    <=> ( v121831(VarCurr,0)
        & v121878(VarCurr) ) ) ).

tff(writeUnaryOperator_8052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121878(VarCurr)
    <=> v121831(VarCurr,1) ) ).

tff(addAssignment_70041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121863(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14625,axiom,
    ! [VarCurr: state_type] :
      ( v121860(VarCurr)
    <=> ( v121407(VarCurr)
        | v121421(VarCurr) ) ) ).

tff(addAssignment_70040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121858(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14624,axiom,
    ! [VarCurr: state_type] :
      ( v121853(VarCurr)
    <=> ( v121855(VarCurr)
        | v121419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14623,axiom,
    ! [VarCurr: state_type] :
      ( v121855(VarCurr)
    <=> ( v121856(VarCurr)
        | v121417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14622,axiom,
    ! [VarCurr: state_type] :
      ( v121856(VarCurr)
    <=> ( v121387(VarCurr)
        | v121397(VarCurr) ) ) ).

tff(addAssignment_70039,axiom,
    ! [VarCurr: state_type] :
      ( v121841(VarCurr)
    <=> v121843(VarCurr) ) ).

tff(addAssignment_70038,axiom,
    ! [VarCurr: state_type] :
      ( v121843(VarCurr)
    <=> v121140(VarCurr) ) ).

tff(addAssignment_70037,axiom,
    ! [VarCurr: state_type] :
      ( v121837(VarCurr)
    <=> v121839(VarCurr) ) ).

tff(addAssignment_70036,axiom,
    ! [VarCurr: state_type] :
      ( v121839(VarCurr)
    <=> v121132(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1206,axiom,
    ! [VarCurr: state_type] :
      ( v121768(VarCurr)
    <=> ( ( v121770(VarCurr,1)
        <=> $false )
        & ( v121770(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_70035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v121770(VarCurr,B)
      <=> v121772(VarCurr,B) ) ) ).

tff(addAssignment_70034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v121772(VarCurr,B)
      <=> v121774(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121811(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v121774(VarNext,B)
            <=> v121774(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1582,axiom,
    ! [VarNext: state_type] :
      ( v121811(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121774(VarNext,B)
          <=> v121821(VarNext,B) ) ) ) ).

tff(addAssignment_70033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121821(VarNext,B)
          <=> v121819(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121822(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121819(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1125,axiom,
    ! [VarCurr: state_type] :
      ( v121822(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121819(VarCurr,B)
          <=> v121784(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14621,axiom,
    ! [VarCurr: state_type] :
      ( v121822(VarCurr)
    <=> ( v121823(VarCurr)
        & v121824(VarCurr) ) ) ).

tff(writeUnaryOperator_8051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121824(VarCurr)
    <=> v121780(VarCurr) ) ).

tff(writeUnaryOperator_8050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121823(VarCurr)
    <=> v121776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121811(VarNext)
      <=> v121812(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121812(VarNext)
      <=> ( v121813(VarNext)
          & v121806(VarNext) ) ) ) ).

tff(writeUnaryOperator_8049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121813(VarNext)
      <=> v121815(VarNext) ) ) ).

tff(addAssignment_70032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121815(VarNext)
      <=> v121806(VarCurr) ) ) ).

tff(addAssignment_70031,axiom,
    ! [VarCurr: state_type] :
      ( v121806(VarCurr)
    <=> v121808(VarCurr) ) ).

tff(addAssignment_70030,axiom,
    ! [VarCurr: state_type] :
      ( v121808(VarCurr)
    <=> v121602(VarCurr) ) ).

tff(addAssignment_70029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v121784(VarCurr,B)
      <=> v121786(VarCurr,B) ) ) ).

tff(addAssignment_70028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v121786(VarCurr,B)
      <=> v121788(VarCurr,B) ) ) ).

tff(addAssignment_70027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v121788(VarCurr,B)
      <=> v121790(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121790(VarCurr,B)
          <=> v121797(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1124,axiom,
    ! [VarCurr: state_type] :
      ( v121792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121790(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121768(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121797(VarCurr,B)
          <=> v121798(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1123,axiom,
    ! [VarCurr: state_type] :
      ( v121768(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121797(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_70026,axiom,
    ! [VarCurr: state_type] :
      ( v121798(VarCurr,0)
    <=> v121802(VarCurr) ) ).

tff(addAssignment_70025,axiom,
    ! [VarCurr: state_type] :
      ( v121798(VarCurr,1)
    <=> v121800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14618,axiom,
    ! [VarCurr: state_type] :
      ( v121800(VarCurr)
    <=> ( v121801(VarCurr)
        & v121803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14617,axiom,
    ! [VarCurr: state_type] :
      ( v121803(VarCurr)
    <=> ( v121770(VarCurr,0)
        | v121804(VarCurr) ) ) ).

tff(writeUnaryOperator_8048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121804(VarCurr)
    <=> v121770(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5313,axiom,
    ! [VarCurr: state_type] :
      ( v121801(VarCurr)
    <=> ( v121802(VarCurr)
        | v121770(VarCurr,1) ) ) ).

tff(writeUnaryOperator_8047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121802(VarCurr)
    <=> v121770(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14616,axiom,
    ! [VarCurr: state_type] :
      ( v121792(VarCurr)
    <=> ( v121794(VarCurr)
        | v121795(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5312,axiom,
    ! [VarCurr: state_type] :
      ( v121795(VarCurr)
    <=> ( v121122(VarCurr,1)
        & v121635(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5311,axiom,
    ! [VarCurr: state_type] :
      ( v121794(VarCurr)
    <=> ( v121122(VarCurr,3)
        & v121693(VarCurr) ) ) ).

tff(addAssignment_70024,axiom,
    ! [VarCurr: state_type] :
      ( v121780(VarCurr)
    <=> v121782(VarCurr) ) ).

tff(addAssignment_70023,axiom,
    ! [VarCurr: state_type] :
      ( v121782(VarCurr)
    <=> v121140(VarCurr) ) ).

tff(addAssignment_70022,axiom,
    ! [VarCurr: state_type] :
      ( v121776(VarCurr)
    <=> v121778(VarCurr) ) ).

tff(addAssignment_70021,axiom,
    ! [VarCurr: state_type] :
      ( v121778(VarCurr)
    <=> v121132(VarCurr) ) ).

tff(addAssignment_70020,axiom,
    ! [VarCurr: state_type] :
      ( v121122(VarCurr,1)
    <=> v121124(VarCurr,1) ) ).

tff(addAssignment_70019,axiom,
    ! [VarCurr: state_type] :
      ( v121124(VarCurr,1)
    <=> v121126(VarCurr,1) ) ).

tff(addAssignment_70018,axiom,
    ! [VarNext: state_type] :
      ( v121126(VarNext,1)
    <=> v121760(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121761(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v121760(VarNext,B)
            <=> v121126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1581,axiom,
    ! [VarNext: state_type] :
      ( v121761(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121760(VarNext,B)
          <=> v121686(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121761(VarNext)
      <=> v121762(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121762(VarNext)
      <=> ( v121764(VarNext)
          & v121671(VarNext) ) ) ) ).

tff(writeUnaryOperator_8046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121764(VarNext)
      <=> v121680(VarNext) ) ) ).

tff(addAssignment_70017,axiom,
    ! [VarCurr: state_type] :
      ( v121144(VarCurr,1)
    <=> v121146(VarCurr,1) ) ).

tff(addAssignment_70016,axiom,
    ! [VarCurr: state_type] :
      ( v121146(VarCurr,1)
    <=> v121148(VarCurr,1) ) ).

tff(addAssignment_70015,axiom,
    ! [VarCurr: state_type] :
      ( v121148(VarCurr,1)
    <=> v121669(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_59,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121751(VarCurr)
     => ( v121150(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_88,axiom,
    ! [VarCurr: state_type] :
      ( v121751(VarCurr)
     => ( v121150(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14613,axiom,
    ! [VarCurr: state_type] :
      ( v121751(VarCurr)
    <=> ( v121752(VarCurr)
        | v121753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14612,axiom,
    ! [VarCurr: state_type] :
      ( v121753(VarCurr)
    <=> ( v121754(VarCurr)
        & v121755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14611,axiom,
    ! [VarCurr: state_type] :
      ( v121755(VarCurr)
    <=> ( v121756(VarCurr)
        & v121652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14610,axiom,
    ! [VarCurr: state_type] :
      ( v121756(VarCurr)
    <=> ( v121757(VarCurr)
        & v121758(VarCurr) ) ) ).

tff(writeUnaryOperator_8045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121758(VarCurr)
    <=> v121644(VarCurr) ) ).

tff(writeUnaryOperator_8044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121757(VarCurr)
    <=> v121635(VarCurr) ) ).

tff(writeUnaryOperator_8043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121754(VarCurr)
    <=> v121654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14609,axiom,
    ! [VarCurr: state_type] :
      ( v121752(VarCurr)
    <=> ( v121726(VarCurr)
        & v121654(VarCurr) ) ) ).

tff(writeUnaryOperator_8042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121122(VarCurr,0)
    <=> v121631(VarCurr) ) ).

tff(addAssignment_70014,axiom,
    ! [VarCurr: state_type] :
      ( v121631(VarCurr)
    <=> v121124(VarCurr,0) ) ).

tff(addAssignment_70013,axiom,
    ! [VarCurr: state_type] :
      ( v121124(VarCurr,0)
    <=> v121126(VarCurr,0) ) ).

tff(addAssignment_70012,axiom,
    ! [VarNext: state_type] :
      ( v121126(VarNext,0)
    <=> v121742(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121743(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v121742(VarNext,B)
            <=> v121126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1580,axiom,
    ! [VarNext: state_type] :
      ( v121743(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121742(VarNext,B)
          <=> v121686(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121743(VarNext)
      <=> v121744(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121744(VarNext)
      <=> ( v121746(VarNext)
          & v121671(VarNext) ) ) ) ).

tff(writeUnaryOperator_8041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121746(VarNext)
      <=> v121680(VarNext) ) ) ).

tff(addAssignment_70011,axiom,
    ! [VarCurr: state_type] :
      ( v121144(VarCurr,0)
    <=> v121146(VarCurr,0) ) ).

tff(addAssignment_70010,axiom,
    ! [VarCurr: state_type] :
      ( v121146(VarCurr,0)
    <=> v121148(VarCurr,0) ) ).

tff(addAssignment_70009,axiom,
    ! [VarCurr: state_type] :
      ( v121148(VarCurr,0)
    <=> v121669(VarCurr,0) ) ).

tff(writeUnaryOperator_8040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121633(VarCurr)
    <=> v121150(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121721(VarCurr)
     => ( v121150(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1122,axiom,
    ! [VarCurr: state_type] :
      ( v121721(VarCurr)
     => ( v121150(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14606,axiom,
    ! [VarCurr: state_type] :
      ( v121721(VarCurr)
    <=> ( v121722(VarCurr)
        | v121735(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14605,axiom,
    ! [VarCurr: state_type] :
      ( v121735(VarCurr)
    <=> ( v121736(VarCurr)
        & v121739(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14604,axiom,
    ! [VarCurr: state_type] :
      ( v121739(VarCurr)
    <=> ( v121707(VarCurr)
        & v121710(VarCurr) ) ) ).

tff(writeUnaryOperator_8039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121736(VarCurr)
    <=> v121737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14603,axiom,
    ! [VarCurr: state_type] :
      ( v121737(VarCurr)
    <=> ( v121738(VarCurr)
        | v121667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14602,axiom,
    ! [VarCurr: state_type] :
      ( v121738(VarCurr)
    <=> ( v121654(VarCurr)
        | v121652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14601,axiom,
    ! [VarCurr: state_type] :
      ( v121722(VarCurr)
    <=> ( v121723(VarCurr)
        | v121731(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14600,axiom,
    ! [VarCurr: state_type] :
      ( v121731(VarCurr)
    <=> ( v121732(VarCurr)
        & v121734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14599,axiom,
    ! [VarCurr: state_type] :
      ( v121734(VarCurr)
    <=> ( v121665(VarCurr)
        & v121667(VarCurr) ) ) ).

tff(writeUnaryOperator_8038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121732(VarCurr)
    <=> v121733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14598,axiom,
    ! [VarCurr: state_type] :
      ( v121733(VarCurr)
    <=> ( v121654(VarCurr)
        | v121652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14597,axiom,
    ! [VarCurr: state_type] :
      ( v121723(VarCurr)
    <=> ( v121724(VarCurr)
        | v121728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14596,axiom,
    ! [VarCurr: state_type] :
      ( v121728(VarCurr)
    <=> ( v121729(VarCurr)
        & v121730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14595,axiom,
    ! [VarCurr: state_type] :
      ( v121730(VarCurr)
    <=> ( v121644(VarCurr)
        & v121652(VarCurr) ) ) ).

tff(writeUnaryOperator_8037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121729(VarCurr)
    <=> v121654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14594,axiom,
    ! [VarCurr: state_type] :
      ( v121724(VarCurr)
    <=> ( v121725(VarCurr)
        & v121654(VarCurr) ) ) ).

tff(writeUnaryOperator_8036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121725(VarCurr)
    <=> v121726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14593,axiom,
    ! [VarCurr: state_type] :
      ( v121726(VarCurr)
    <=> ( v121727(VarCurr)
        & v121629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14592,axiom,
    ! [VarCurr: state_type] :
      ( v121727(VarCurr)
    <=> ( v121152(VarCurr)
        & v121627(VarCurr) ) ) ).

tff(addAssignment_70008,axiom,
    ! [VarCurr: state_type] :
      ( v121122(VarCurr,3)
    <=> v121124(VarCurr,3) ) ).

tff(addAssignment_70007,axiom,
    ! [VarCurr: state_type] :
      ( v121124(VarCurr,3)
    <=> v121126(VarCurr,3) ) ).

tff(addAssignment_70006,axiom,
    ! [VarNext: state_type] :
      ( v121126(VarNext,3)
    <=> v121713(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121714(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v121713(VarNext,B)
            <=> v121126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1579,axiom,
    ! [VarNext: state_type] :
      ( v121714(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121713(VarNext,B)
          <=> v121686(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121714(VarNext)
      <=> v121715(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121715(VarNext)
      <=> ( v121717(VarNext)
          & v121671(VarNext) ) ) ) ).

tff(writeUnaryOperator_8035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121717(VarNext)
      <=> v121680(VarNext) ) ) ).

tff(addAssignment_70005,axiom,
    ! [VarCurr: state_type] :
      ( v121144(VarCurr,3)
    <=> v121146(VarCurr,3) ) ).

tff(addAssignment_70004,axiom,
    ! [VarCurr: state_type] :
      ( v121146(VarCurr,3)
    <=> v121148(VarCurr,3) ) ).

tff(addAssignment_70003,axiom,
    ! [VarCurr: state_type] :
      ( v121148(VarCurr,3)
    <=> v121669(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_58,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121695(VarCurr)
     => ( v121150(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_87,axiom,
    ! [VarCurr: state_type] :
      ( v121695(VarCurr)
     => ( v121150(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14589,axiom,
    ! [VarCurr: state_type] :
      ( v121695(VarCurr)
    <=> ( v121696(VarCurr)
        | v121702(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14588,axiom,
    ! [VarCurr: state_type] :
      ( v121702(VarCurr)
    <=> ( v121703(VarCurr)
        & v121704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14587,axiom,
    ! [VarCurr: state_type] :
      ( v121704(VarCurr)
    <=> ( v121705(VarCurr)
        & v121711(VarCurr) ) ) ).

tff(writeUnaryOperator_8034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121711(VarCurr)
    <=> v121701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14586,axiom,
    ! [VarCurr: state_type] :
      ( v121705(VarCurr)
    <=> ( v121706(VarCurr)
        & v121710(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1205,axiom,
    ! [VarCurr: state_type] :
      ( v121710(VarCurr)
    <=> ( $true
      <=> v121122(VarCurr,3) ) ) ).

tff(writeUnaryOperator_8033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121706(VarCurr)
    <=> v121707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14585,axiom,
    ! [VarCurr: state_type] :
      ( v121707(VarCurr)
    <=> ( v121708(VarCurr)
        | v121637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14584,axiom,
    ! [VarCurr: state_type] :
      ( v121708(VarCurr)
    <=> ( v121709(VarCurr)
        | v121693(VarCurr) ) ) ).

tff(writeUnaryOperator_8032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121709(VarCurr)
    <=> v121627(VarCurr) ) ).

tff(writeUnaryOperator_8031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121703(VarCurr)
    <=> v121667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14583,axiom,
    ! [VarCurr: state_type] :
      ( v121696(VarCurr)
    <=> ( v121697(VarCurr)
        & v121700(VarCurr) ) ) ).

tff(writeUnaryOperator_8030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121700(VarCurr)
    <=> v121701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14582,axiom,
    ! [VarCurr: state_type] :
      ( v121701(VarCurr)
    <=> ( v121654(VarCurr)
        | v121652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14581,axiom,
    ! [VarCurr: state_type] :
      ( v121697(VarCurr)
    <=> ( v121698(VarCurr)
        & v121667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14580,axiom,
    ! [VarCurr: state_type] :
      ( v121698(VarCurr)
    <=> ( v121661(VarCurr)
        & v121699(VarCurr) ) ) ).

tff(writeUnaryOperator_8029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121699(VarCurr)
    <=> v121665(VarCurr) ) ).

tff(addAssignment_70002,axiom,
    ! [VarCurr: state_type] :
      ( v121693(VarCurr)
    <=> v112831(VarCurr,9) ) ).

tff(addAssignment_70001,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,9)
    <=> v112865(VarCurr,9) ) ).

tff(addAssignment_70000,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,9)
    <=> v112849(VarCurr,9) ) ).

tff(addAssignment_69999,axiom,
    ! [VarCurr: state_type] :
      ( v121122(VarCurr,2)
    <=> v121124(VarCurr,2) ) ).

tff(addAssignment_69998,axiom,
    ! [VarCurr: state_type] :
      ( v121124(VarCurr,2)
    <=> v121126(VarCurr,2) ) ).

tff(addAssignment_69997,axiom,
    ! [VarNext: state_type] :
      ( v121126(VarNext,2)
    <=> v121675(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121676(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v121675(VarNext,B)
            <=> v121126(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1578,axiom,
    ! [VarNext: state_type] :
      ( v121676(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121675(VarNext,B)
          <=> v121686(VarNext,B) ) ) ) ).

tff(addAssignment_69996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121686(VarNext,B)
          <=> v121684(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121684(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1121,axiom,
    ! [VarCurr: state_type] :
      ( v121687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v121684(VarCurr,B)
          <=> v121144(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14579,axiom,
    ! [VarCurr: state_type] :
      ( v121687(VarCurr)
    <=> ( v121688(VarCurr)
        & v121689(VarCurr) ) ) ).

tff(writeUnaryOperator_8028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121689(VarCurr)
    <=> v121136(VarCurr) ) ).

tff(writeUnaryOperator_8027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121688(VarCurr)
    <=> v121128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121676(VarNext)
      <=> v121677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121677(VarNext)
      <=> ( v121678(VarNext)
          & v121671(VarNext) ) ) ) ).

tff(writeUnaryOperator_8026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121678(VarNext)
      <=> v121680(VarNext) ) ) ).

tff(addAssignment_69995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121680(VarNext)
      <=> v121671(VarCurr) ) ) ).

tff(addAssignment_69994,axiom,
    ! [VarCurr: state_type] :
      ( v121671(VarCurr)
    <=> v121673(VarCurr) ) ).

tff(addAssignment_69993,axiom,
    ! [VarCurr: state_type] :
      ( v121673(VarCurr)
    <=> v121602(VarCurr) ) ).

tff(addAssignment_69992,axiom,
    ! [VarCurr: state_type] :
      ( v121144(VarCurr,2)
    <=> v121146(VarCurr,2) ) ).

tff(addAssignment_69991,axiom,
    ! [VarCurr: state_type] :
      ( v121146(VarCurr,2)
    <=> v121148(VarCurr,2) ) ).

tff(addAssignment_69990,axiom,
    ! [VarCurr: state_type] :
      ( v121148(VarCurr,2)
    <=> v121669(VarCurr,2) ) ).

tff(addAssignment_69989,axiom,
    ! [VarCurr: state_type] :
      ( v121669(VarCurr,0)
    <=> v121633(VarCurr) ) ).

tff(addAssignment_69988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v121669(VarCurr,B)
      <=> v121150(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_57,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121639(VarCurr)
     => ( v121150(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_86,axiom,
    ! [VarCurr: state_type] :
      ( v121639(VarCurr)
     => ( v121150(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14576,axiom,
    ! [VarCurr: state_type] :
      ( v121639(VarCurr)
    <=> ( v121640(VarCurr)
        | v121655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14575,axiom,
    ! [VarCurr: state_type] :
      ( v121655(VarCurr)
    <=> ( v121656(VarCurr)
        & v121657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14574,axiom,
    ! [VarCurr: state_type] :
      ( v121657(VarCurr)
    <=> ( v121658(VarCurr)
        & v121668(VarCurr) ) ) ).

tff(writeUnaryOperator_8025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121668(VarCurr)
    <=> v121654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14573,axiom,
    ! [VarCurr: state_type] :
      ( v121658(VarCurr)
    <=> ( v121659(VarCurr)
        & v121667(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1204,axiom,
    ! [VarCurr: state_type] :
      ( v121667(VarCurr)
    <=> ( $true
      <=> v121122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14572,axiom,
    ! [VarCurr: state_type] :
      ( v121659(VarCurr)
    <=> ( v121660(VarCurr)
        & v121664(VarCurr) ) ) ).

tff(writeUnaryOperator_8024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121664(VarCurr)
    <=> v121665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14571,axiom,
    ! [VarCurr: state_type] :
      ( v121665(VarCurr)
    <=> ( v121666(VarCurr)
        | v121637(VarCurr) ) ) ).

tff(writeUnaryOperator_8023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121666(VarCurr)
    <=> v121627(VarCurr) ) ).

tff(writeUnaryOperator_8022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121660(VarCurr)
    <=> v121661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14570,axiom,
    ! [VarCurr: state_type] :
      ( v121661(VarCurr)
    <=> ( v121662(VarCurr)
        | v121663(VarCurr) ) ) ).

tff(writeUnaryOperator_8021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121663(VarCurr)
    <=> v121629(VarCurr) ) ).

tff(writeUnaryOperator_8020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121662(VarCurr)
    <=> v121152(VarCurr) ) ).

tff(writeUnaryOperator_8019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121656(VarCurr)
    <=> v121652(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14569,axiom,
    ! [VarCurr: state_type] :
      ( v121640(VarCurr)
    <=> ( v121641(VarCurr)
        & v121653(VarCurr) ) ) ).

tff(writeUnaryOperator_8018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121653(VarCurr)
    <=> v121654(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1203,axiom,
    ! [VarCurr: state_type] :
      ( v121654(VarCurr)
    <=> ( $true
      <=> v121122(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14568,axiom,
    ! [VarCurr: state_type] :
      ( v121641(VarCurr)
    <=> ( v121642(VarCurr)
        & v121652(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1202,axiom,
    ! [VarCurr: state_type] :
      ( v121652(VarCurr)
    <=> ( $true
      <=> v121122(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14567,axiom,
    ! [VarCurr: state_type] :
      ( v121642(VarCurr)
    <=> ( v121635(VarCurr)
        & v121643(VarCurr) ) ) ).

tff(writeUnaryOperator_8017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121643(VarCurr)
    <=> v121644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14566,axiom,
    ! [VarCurr: state_type] :
      ( v121644(VarCurr)
    <=> ( v121645(VarCurr)
        | v121637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14565,axiom,
    ! [VarCurr: state_type] :
      ( v121645(VarCurr)
    <=> ( v121646(VarCurr)
        | v121649(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14564,axiom,
    ! [VarCurr: state_type] :
      ( v121649(VarCurr)
    <=> ( v121650(VarCurr)
        & v121651(VarCurr) ) ) ).

tff(writeUnaryOperator_8016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121651(VarCurr)
    <=> v121635(VarCurr) ) ).

tff(writeUnaryOperator_8015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121650(VarCurr)
    <=> v121152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14563,axiom,
    ! [VarCurr: state_type] :
      ( v121646(VarCurr)
    <=> ( v121647(VarCurr)
        | v121648(VarCurr) ) ) ).

tff(writeUnaryOperator_8014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121648(VarCurr)
    <=> v121629(VarCurr) ) ).

tff(writeUnaryOperator_8013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121647(VarCurr)
    <=> v121627(VarCurr) ) ).

tff(addAssignment_69987,axiom,
    ! [VarCurr: state_type] :
      ( v121637(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_69986,axiom,
    ! [VarCurr: state_type] :
      ( v121635(VarCurr)
    <=> v112643(VarCurr,9) ) ).

tff(addAssignment_69985,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,9)
    <=> v115202(VarCurr,9) ) ).

tff(addAssignment_69984,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,9)
    <=> v115186(VarCurr,9) ) ).

tff(addAssignment_69983,axiom,
    ! [VarCurr: state_type] :
      ( v121629(VarCurr)
    <=> v112528(VarCurr,9) ) ).

tff(addAssignment_69982,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,9)
    <=> v120828(VarCurr,1) ) ).

tff(addAssignment_69981,axiom,
    ! [VarCurr: state_type] :
      ( v121627(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14562,axiom,
    ! [VarCurr: state_type] :
      ( v121152(VarCurr)
    <=> ( v121624(VarCurr)
        & v121625(VarCurr) ) ) ).

tff(writeUnaryOperator_8012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121625(VarCurr)
    <=> v121622(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1201,axiom,
    ! [VarCurr: state_type] :
      ( v121624(VarCurr)
    <=> ( ( v121154(VarCurr,5)
        <=> $false )
        & ( v121154(VarCurr,4)
        <=> $false )
        & ( v121154(VarCurr,3)
        <=> $false )
        & ( v121154(VarCurr,2)
        <=> $false )
        & ( v121154(VarCurr,1)
        <=> $false )
        & ( v121154(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69980,axiom,
    ! [VarCurr: state_type] :
      ( v121622(VarCurr)
    <=> v115139(VarCurr,9) ) ).

tff(addAssignment_69979,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,9)
    <=> v115159(VarCurr,9) ) ).

tff(addAssignment_69978,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,9)
    <=> v115142(VarCurr,9) ) ).

tff(addAssignment_69977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121154(VarCurr,B)
      <=> v121156(VarCurr,B) ) ) ).

tff(addAssignment_69976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121156(VarCurr,B)
      <=> v121158(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121605(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v121158(VarNext,B)
            <=> v121158(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1577,axiom,
    ! [VarNext: state_type] :
      ( v121605(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v121158(VarNext,B)
          <=> v121615(VarNext,B) ) ) ) ).

tff(addAssignment_69975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v121615(VarNext,B)
          <=> v121613(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121616(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v121613(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1120,axiom,
    ! [VarCurr: state_type] :
      ( v121616(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v121613(VarCurr,B)
          <=> v121168(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14561,axiom,
    ! [VarCurr: state_type] :
      ( v121616(VarCurr)
    <=> ( v121617(VarCurr)
        & v121618(VarCurr) ) ) ).

tff(writeUnaryOperator_8011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121618(VarCurr)
    <=> v121164(VarCurr) ) ).

tff(writeUnaryOperator_8010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121617(VarCurr)
    <=> v121160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121605(VarNext)
      <=> v121606(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121606(VarNext)
      <=> ( v121607(VarNext)
          & v121598(VarNext) ) ) ) ).

tff(writeUnaryOperator_8009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121607(VarNext)
      <=> v121609(VarNext) ) ) ).

tff(addAssignment_69974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121609(VarNext)
      <=> v121598(VarCurr) ) ) ).

tff(addAssignment_69973,axiom,
    ! [VarCurr: state_type] :
      ( v121598(VarCurr)
    <=> v121600(VarCurr) ) ).

tff(addAssignment_69972,axiom,
    ! [VarCurr: state_type] :
      ( v121600(VarCurr)
    <=> v121602(VarCurr) ) ).

tff(addAssignment_69971,axiom,
    ! [VarCurr: state_type] :
      ( v121602(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_69970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121168(VarCurr,B)
      <=> v121170(VarCurr,B) ) ) ).

tff(addAssignment_69969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121170(VarCurr,B)
      <=> v121172(VarCurr,B) ) ) ).

tff(addAssignment_69968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v121172(VarCurr,B)
      <=> v121174(VarCurr,B) ) ) ).

tff(addAssignment_69967,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,0)
    <=> v121593(VarCurr) ) ).

tff(addAssignment_69966,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,1)
    <=> v121588(VarCurr) ) ).

tff(addAssignment_69965,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,2)
    <=> v121583(VarCurr) ) ).

tff(addAssignment_69964,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,3)
    <=> v121578(VarCurr) ) ).

tff(addAssignment_69963,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,4)
    <=> v121573(VarCurr) ) ).

tff(addAssignment_69962,axiom,
    ! [VarCurr: state_type] :
      ( v121174(VarCurr,5)
    <=> v121430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14558,axiom,
    ! [VarCurr: state_type] :
      ( v121593(VarCurr)
    <=> ( v121594(VarCurr)
        & v121596(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14557,axiom,
    ! [VarCurr: state_type] :
      ( v121596(VarCurr)
    <=> ( v121385(VarCurr,0)
        | v121442(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14556,axiom,
    ! [VarCurr: state_type] :
      ( v121594(VarCurr)
    <=> ( v121519(VarCurr)
        | v121595(VarCurr) ) ) ).

tff(writeUnaryOperator_8008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121595(VarCurr)
    <=> v121442(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14555,axiom,
    ! [VarCurr: state_type] :
      ( v121588(VarCurr)
    <=> ( v121589(VarCurr)
        & v121592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14554,axiom,
    ! [VarCurr: state_type] :
      ( v121592(VarCurr)
    <=> ( v121441(VarCurr)
        | v121513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14553,axiom,
    ! [VarCurr: state_type] :
      ( v121589(VarCurr)
    <=> ( v121590(VarCurr)
        | v121591(VarCurr) ) ) ).

tff(writeUnaryOperator_8007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121591(VarCurr)
    <=> v121513(VarCurr) ) ).

tff(writeUnaryOperator_8006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121590(VarCurr)
    <=> v121441(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14552,axiom,
    ! [VarCurr: state_type] :
      ( v121583(VarCurr)
    <=> ( v121584(VarCurr)
        & v121587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14551,axiom,
    ! [VarCurr: state_type] :
      ( v121587(VarCurr)
    <=> ( v121439(VarCurr)
        | v121524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14550,axiom,
    ! [VarCurr: state_type] :
      ( v121584(VarCurr)
    <=> ( v121585(VarCurr)
        | v121586(VarCurr) ) ) ).

tff(writeUnaryOperator_8005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121586(VarCurr)
    <=> v121524(VarCurr) ) ).

tff(writeUnaryOperator_8004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121585(VarCurr)
    <=> v121439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14549,axiom,
    ! [VarCurr: state_type] :
      ( v121578(VarCurr)
    <=> ( v121579(VarCurr)
        & v121582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14548,axiom,
    ! [VarCurr: state_type] :
      ( v121582(VarCurr)
    <=> ( v121437(VarCurr)
        | v121536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14547,axiom,
    ! [VarCurr: state_type] :
      ( v121579(VarCurr)
    <=> ( v121580(VarCurr)
        | v121581(VarCurr) ) ) ).

tff(writeUnaryOperator_8003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121581(VarCurr)
    <=> v121536(VarCurr) ) ).

tff(writeUnaryOperator_8002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121580(VarCurr)
    <=> v121437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14546,axiom,
    ! [VarCurr: state_type] :
      ( v121573(VarCurr)
    <=> ( v121574(VarCurr)
        & v121577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14545,axiom,
    ! [VarCurr: state_type] :
      ( v121577(VarCurr)
    <=> ( v121435(VarCurr)
        | v121548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14544,axiom,
    ! [VarCurr: state_type] :
      ( v121574(VarCurr)
    <=> ( v121575(VarCurr)
        | v121576(VarCurr) ) ) ).

tff(writeUnaryOperator_8001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121576(VarCurr)
    <=> v121548(VarCurr) ) ).

tff(writeUnaryOperator_8000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121575(VarCurr)
    <=> v121435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14543,axiom,
    ! [VarCurr: state_type] :
      ( v121430(VarCurr)
    <=> ( v121431(VarCurr)
        & v121572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14542,axiom,
    ! [VarCurr: state_type] :
      ( v121572(VarCurr)
    <=> ( v121433(VarCurr)
        | v121561(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14541,axiom,
    ! [VarCurr: state_type] :
      ( v121431(VarCurr)
    <=> ( v121432(VarCurr)
        | v121560(VarCurr) ) ) ).

tff(writeUnaryOperator_7999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121560(VarCurr)
    <=> v121561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14540,axiom,
    ! [VarCurr: state_type] :
      ( v121561(VarCurr)
    <=> ( v121562(VarCurr)
        & v121571(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5310,axiom,
    ! [VarCurr: state_type] :
      ( v121571(VarCurr)
    <=> ( v121564(VarCurr)
        | v121442(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14539,axiom,
    ! [VarCurr: state_type] :
      ( v121562(VarCurr)
    <=> ( v121563(VarCurr)
        | v121570(VarCurr) ) ) ).

tff(writeUnaryOperator_7998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121570(VarCurr)
    <=> v121442(VarCurr,5) ) ).

tff(writeUnaryOperator_7997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121563(VarCurr)
    <=> v121564(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14538,axiom,
    ! [VarCurr: state_type] :
      ( v121564(VarCurr)
    <=> ( v121565(VarCurr)
        & v121568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14537,axiom,
    ! [VarCurr: state_type] :
      ( v121568(VarCurr)
    <=> ( v121567(VarCurr)
        | v121569(VarCurr) ) ) ).

tff(writeUnaryOperator_7996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121569(VarCurr)
    <=> v121385(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5309,axiom,
    ! [VarCurr: state_type] :
      ( v121565(VarCurr)
    <=> ( v121566(VarCurr)
        | v121385(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121566(VarCurr)
    <=> v121567(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14536,axiom,
    ! [VarCurr: state_type] :
      ( v121567(VarCurr)
    <=> ( v121554(VarCurr)
        & v121556(VarCurr) ) ) ).

tff(writeUnaryOperator_7994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121432(VarCurr)
    <=> v121433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14535,axiom,
    ! [VarCurr: state_type] :
      ( v121433(VarCurr)
    <=> ( v121434(VarCurr)
        | v121559(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5308,axiom,
    ! [VarCurr: state_type] :
      ( v121559(VarCurr)
    <=> ( v121551(VarCurr)
        & v121442(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14534,axiom,
    ! [VarCurr: state_type] :
      ( v121434(VarCurr)
    <=> ( v121435(VarCurr)
        & v121548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14533,axiom,
    ! [VarCurr: state_type] :
      ( v121548(VarCurr)
    <=> ( v121549(VarCurr)
        & v121558(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5307,axiom,
    ! [VarCurr: state_type] :
      ( v121558(VarCurr)
    <=> ( v121551(VarCurr)
        | v121442(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14532,axiom,
    ! [VarCurr: state_type] :
      ( v121549(VarCurr)
    <=> ( v121550(VarCurr)
        | v121557(VarCurr) ) ) ).

tff(writeUnaryOperator_7993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121557(VarCurr)
    <=> v121442(VarCurr,4) ) ).

tff(writeUnaryOperator_7992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121550(VarCurr)
    <=> v121551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14531,axiom,
    ! [VarCurr: state_type] :
      ( v121551(VarCurr)
    <=> ( v121552(VarCurr)
        & v121555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14530,axiom,
    ! [VarCurr: state_type] :
      ( v121555(VarCurr)
    <=> ( v121554(VarCurr)
        | v121556(VarCurr) ) ) ).

tff(writeUnaryOperator_7991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121556(VarCurr)
    <=> v121385(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5306,axiom,
    ! [VarCurr: state_type] :
      ( v121552(VarCurr)
    <=> ( v121553(VarCurr)
        | v121385(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121553(VarCurr)
    <=> v121554(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14529,axiom,
    ! [VarCurr: state_type] :
      ( v121554(VarCurr)
    <=> ( v121542(VarCurr)
        & v121544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14528,axiom,
    ! [VarCurr: state_type] :
      ( v121435(VarCurr)
    <=> ( v121436(VarCurr)
        | v121547(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5305,axiom,
    ! [VarCurr: state_type] :
      ( v121547(VarCurr)
    <=> ( v121539(VarCurr)
        & v121442(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14527,axiom,
    ! [VarCurr: state_type] :
      ( v121436(VarCurr)
    <=> ( v121437(VarCurr)
        & v121536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14526,axiom,
    ! [VarCurr: state_type] :
      ( v121536(VarCurr)
    <=> ( v121537(VarCurr)
        & v121546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5304,axiom,
    ! [VarCurr: state_type] :
      ( v121546(VarCurr)
    <=> ( v121539(VarCurr)
        | v121442(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14525,axiom,
    ! [VarCurr: state_type] :
      ( v121537(VarCurr)
    <=> ( v121538(VarCurr)
        | v121545(VarCurr) ) ) ).

tff(writeUnaryOperator_7989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121545(VarCurr)
    <=> v121442(VarCurr,3) ) ).

tff(writeUnaryOperator_7988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121538(VarCurr)
    <=> v121539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14524,axiom,
    ! [VarCurr: state_type] :
      ( v121539(VarCurr)
    <=> ( v121540(VarCurr)
        & v121543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14523,axiom,
    ! [VarCurr: state_type] :
      ( v121543(VarCurr)
    <=> ( v121542(VarCurr)
        | v121544(VarCurr) ) ) ).

tff(writeUnaryOperator_7987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121544(VarCurr)
    <=> v121385(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5303,axiom,
    ! [VarCurr: state_type] :
      ( v121540(VarCurr)
    <=> ( v121541(VarCurr)
        | v121385(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121541(VarCurr)
    <=> v121542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14522,axiom,
    ! [VarCurr: state_type] :
      ( v121542(VarCurr)
    <=> ( v121530(VarCurr)
        & v121532(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14521,axiom,
    ! [VarCurr: state_type] :
      ( v121437(VarCurr)
    <=> ( v121438(VarCurr)
        | v121535(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5302,axiom,
    ! [VarCurr: state_type] :
      ( v121535(VarCurr)
    <=> ( v121527(VarCurr)
        & v121442(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14520,axiom,
    ! [VarCurr: state_type] :
      ( v121438(VarCurr)
    <=> ( v121439(VarCurr)
        & v121524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14519,axiom,
    ! [VarCurr: state_type] :
      ( v121524(VarCurr)
    <=> ( v121525(VarCurr)
        & v121534(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5301,axiom,
    ! [VarCurr: state_type] :
      ( v121534(VarCurr)
    <=> ( v121527(VarCurr)
        | v121442(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14518,axiom,
    ! [VarCurr: state_type] :
      ( v121525(VarCurr)
    <=> ( v121526(VarCurr)
        | v121533(VarCurr) ) ) ).

tff(writeUnaryOperator_7985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121533(VarCurr)
    <=> v121442(VarCurr,2) ) ).

tff(writeUnaryOperator_7984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121526(VarCurr)
    <=> v121527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14517,axiom,
    ! [VarCurr: state_type] :
      ( v121527(VarCurr)
    <=> ( v121528(VarCurr)
        & v121531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14516,axiom,
    ! [VarCurr: state_type] :
      ( v121531(VarCurr)
    <=> ( v121530(VarCurr)
        | v121532(VarCurr) ) ) ).

tff(writeUnaryOperator_7983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121532(VarCurr)
    <=> v121385(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5300,axiom,
    ! [VarCurr: state_type] :
      ( v121528(VarCurr)
    <=> ( v121529(VarCurr)
        | v121385(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121529(VarCurr)
    <=> v121530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14515,axiom,
    ! [VarCurr: state_type] :
      ( v121530(VarCurr)
    <=> ( v121519(VarCurr)
        & v121520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14514,axiom,
    ! [VarCurr: state_type] :
      ( v121439(VarCurr)
    <=> ( v121440(VarCurr)
        | v121523(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5299,axiom,
    ! [VarCurr: state_type] :
      ( v121523(VarCurr)
    <=> ( v121516(VarCurr)
        & v121442(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14513,axiom,
    ! [VarCurr: state_type] :
      ( v121440(VarCurr)
    <=> ( v121441(VarCurr)
        & v121513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14512,axiom,
    ! [VarCurr: state_type] :
      ( v121513(VarCurr)
    <=> ( v121514(VarCurr)
        & v121522(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5298,axiom,
    ! [VarCurr: state_type] :
      ( v121522(VarCurr)
    <=> ( v121516(VarCurr)
        | v121442(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14511,axiom,
    ! [VarCurr: state_type] :
      ( v121514(VarCurr)
    <=> ( v121515(VarCurr)
        | v121521(VarCurr) ) ) ).

tff(writeUnaryOperator_7981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121521(VarCurr)
    <=> v121442(VarCurr,1) ) ).

tff(writeUnaryOperator_7980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121515(VarCurr)
    <=> v121516(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14510,axiom,
    ! [VarCurr: state_type] :
      ( v121516(VarCurr)
    <=> ( v121517(VarCurr)
        & v121518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14509,axiom,
    ! [VarCurr: state_type] :
      ( v121518(VarCurr)
    <=> ( v121519(VarCurr)
        | v121520(VarCurr) ) ) ).

tff(writeUnaryOperator_7979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121520(VarCurr)
    <=> v121385(VarCurr,1) ) ).

tff(writeUnaryOperator_7978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121519(VarCurr)
    <=> v121385(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5297,axiom,
    ! [VarCurr: state_type] :
      ( v121517(VarCurr)
    <=> ( v121385(VarCurr,0)
        | v121385(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14508,axiom,
    ! [VarCurr: state_type] :
      ( v121441(VarCurr)
    <=> ( v121385(VarCurr,0)
        & v121442(VarCurr,0) ) ) ).

tff(addAssignment_69961,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,0)
    <=> v121508(VarCurr) ) ).

tff(addAssignment_69960,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,1)
    <=> v121503(VarCurr) ) ).

tff(addAssignment_69959,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,2)
    <=> v121498(VarCurr) ) ).

tff(addAssignment_69958,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,3)
    <=> v121493(VarCurr) ) ).

tff(addAssignment_69957,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,4)
    <=> v121488(VarCurr) ) ).

tff(addAssignment_69956,axiom,
    ! [VarCurr: state_type] :
      ( v121442(VarCurr,5)
    <=> v121444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14507,axiom,
    ! [VarCurr: state_type] :
      ( v121508(VarCurr)
    <=> ( v121509(VarCurr)
        & v121512(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14506,axiom,
    ! [VarCurr: state_type] :
      ( v121512(VarCurr)
    <=> ( v121154(VarCurr,0)
        | v121456(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14505,axiom,
    ! [VarCurr: state_type] :
      ( v121509(VarCurr)
    <=> ( v121510(VarCurr)
        | v121511(VarCurr) ) ) ).

tff(writeUnaryOperator_7977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121511(VarCurr)
    <=> v121456(VarCurr,0) ) ).

tff(writeUnaryOperator_7976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121510(VarCurr)
    <=> v121154(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14504,axiom,
    ! [VarCurr: state_type] :
      ( v121503(VarCurr)
    <=> ( v121504(VarCurr)
        & v121507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14503,axiom,
    ! [VarCurr: state_type] :
      ( v121507(VarCurr)
    <=> ( v121455(VarCurr)
        | v121457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14502,axiom,
    ! [VarCurr: state_type] :
      ( v121504(VarCurr)
    <=> ( v121505(VarCurr)
        | v121506(VarCurr) ) ) ).

tff(writeUnaryOperator_7975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121506(VarCurr)
    <=> v121457(VarCurr) ) ).

tff(writeUnaryOperator_7974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121505(VarCurr)
    <=> v121455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14501,axiom,
    ! [VarCurr: state_type] :
      ( v121498(VarCurr)
    <=> ( v121499(VarCurr)
        & v121502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14500,axiom,
    ! [VarCurr: state_type] :
      ( v121502(VarCurr)
    <=> ( v121453(VarCurr)
        | v121463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14499,axiom,
    ! [VarCurr: state_type] :
      ( v121499(VarCurr)
    <=> ( v121500(VarCurr)
        | v121501(VarCurr) ) ) ).

tff(writeUnaryOperator_7973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121501(VarCurr)
    <=> v121463(VarCurr) ) ).

tff(writeUnaryOperator_7972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121500(VarCurr)
    <=> v121453(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14498,axiom,
    ! [VarCurr: state_type] :
      ( v121493(VarCurr)
    <=> ( v121494(VarCurr)
        & v121497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14497,axiom,
    ! [VarCurr: state_type] :
      ( v121497(VarCurr)
    <=> ( v121451(VarCurr)
        | v121469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14496,axiom,
    ! [VarCurr: state_type] :
      ( v121494(VarCurr)
    <=> ( v121495(VarCurr)
        | v121496(VarCurr) ) ) ).

tff(writeUnaryOperator_7971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121496(VarCurr)
    <=> v121469(VarCurr) ) ).

tff(writeUnaryOperator_7970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121495(VarCurr)
    <=> v121451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14495,axiom,
    ! [VarCurr: state_type] :
      ( v121488(VarCurr)
    <=> ( v121489(VarCurr)
        & v121492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14494,axiom,
    ! [VarCurr: state_type] :
      ( v121492(VarCurr)
    <=> ( v121449(VarCurr)
        | v121475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14493,axiom,
    ! [VarCurr: state_type] :
      ( v121489(VarCurr)
    <=> ( v121490(VarCurr)
        | v121491(VarCurr) ) ) ).

tff(writeUnaryOperator_7969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121491(VarCurr)
    <=> v121475(VarCurr) ) ).

tff(writeUnaryOperator_7968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121490(VarCurr)
    <=> v121449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14492,axiom,
    ! [VarCurr: state_type] :
      ( v121444(VarCurr)
    <=> ( v121445(VarCurr)
        & v121487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14491,axiom,
    ! [VarCurr: state_type] :
      ( v121487(VarCurr)
    <=> ( v121447(VarCurr)
        | v121482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14490,axiom,
    ! [VarCurr: state_type] :
      ( v121445(VarCurr)
    <=> ( v121446(VarCurr)
        | v121481(VarCurr) ) ) ).

tff(writeUnaryOperator_7967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121481(VarCurr)
    <=> v121482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14489,axiom,
    ! [VarCurr: state_type] :
      ( v121482(VarCurr)
    <=> ( v121483(VarCurr)
        & v121486(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5296,axiom,
    ! [VarCurr: state_type] :
      ( v121486(VarCurr)
    <=> ( v121154(VarCurr,5)
        | v121456(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14488,axiom,
    ! [VarCurr: state_type] :
      ( v121483(VarCurr)
    <=> ( v121484(VarCurr)
        | v121485(VarCurr) ) ) ).

tff(writeUnaryOperator_7966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121485(VarCurr)
    <=> v121456(VarCurr,5) ) ).

tff(writeUnaryOperator_7965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121484(VarCurr)
    <=> v121154(VarCurr,5) ) ).

tff(writeUnaryOperator_7964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121446(VarCurr)
    <=> v121447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14487,axiom,
    ! [VarCurr: state_type] :
      ( v121447(VarCurr)
    <=> ( v121448(VarCurr)
        | v121480(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5295,axiom,
    ! [VarCurr: state_type] :
      ( v121480(VarCurr)
    <=> ( v121154(VarCurr,4)
        & v121456(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14486,axiom,
    ! [VarCurr: state_type] :
      ( v121448(VarCurr)
    <=> ( v121449(VarCurr)
        & v121475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14485,axiom,
    ! [VarCurr: state_type] :
      ( v121475(VarCurr)
    <=> ( v121476(VarCurr)
        & v121479(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5294,axiom,
    ! [VarCurr: state_type] :
      ( v121479(VarCurr)
    <=> ( v121154(VarCurr,4)
        | v121456(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14484,axiom,
    ! [VarCurr: state_type] :
      ( v121476(VarCurr)
    <=> ( v121477(VarCurr)
        | v121478(VarCurr) ) ) ).

tff(writeUnaryOperator_7963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121478(VarCurr)
    <=> v121456(VarCurr,4) ) ).

tff(writeUnaryOperator_7962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121477(VarCurr)
    <=> v121154(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14483,axiom,
    ! [VarCurr: state_type] :
      ( v121449(VarCurr)
    <=> ( v121450(VarCurr)
        | v121474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5293,axiom,
    ! [VarCurr: state_type] :
      ( v121474(VarCurr)
    <=> ( v121154(VarCurr,3)
        & v121456(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14482,axiom,
    ! [VarCurr: state_type] :
      ( v121450(VarCurr)
    <=> ( v121451(VarCurr)
        & v121469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14481,axiom,
    ! [VarCurr: state_type] :
      ( v121469(VarCurr)
    <=> ( v121470(VarCurr)
        & v121473(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5292,axiom,
    ! [VarCurr: state_type] :
      ( v121473(VarCurr)
    <=> ( v121154(VarCurr,3)
        | v121456(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14480,axiom,
    ! [VarCurr: state_type] :
      ( v121470(VarCurr)
    <=> ( v121471(VarCurr)
        | v121472(VarCurr) ) ) ).

tff(writeUnaryOperator_7961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121472(VarCurr)
    <=> v121456(VarCurr,3) ) ).

tff(writeUnaryOperator_7960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121471(VarCurr)
    <=> v121154(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14479,axiom,
    ! [VarCurr: state_type] :
      ( v121451(VarCurr)
    <=> ( v121452(VarCurr)
        | v121468(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5291,axiom,
    ! [VarCurr: state_type] :
      ( v121468(VarCurr)
    <=> ( v121154(VarCurr,2)
        & v121456(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14478,axiom,
    ! [VarCurr: state_type] :
      ( v121452(VarCurr)
    <=> ( v121453(VarCurr)
        & v121463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14477,axiom,
    ! [VarCurr: state_type] :
      ( v121463(VarCurr)
    <=> ( v121464(VarCurr)
        & v121467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5290,axiom,
    ! [VarCurr: state_type] :
      ( v121467(VarCurr)
    <=> ( v121154(VarCurr,2)
        | v121456(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14476,axiom,
    ! [VarCurr: state_type] :
      ( v121464(VarCurr)
    <=> ( v121465(VarCurr)
        | v121466(VarCurr) ) ) ).

tff(writeUnaryOperator_7959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121466(VarCurr)
    <=> v121456(VarCurr,2) ) ).

tff(writeUnaryOperator_7958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121465(VarCurr)
    <=> v121154(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14475,axiom,
    ! [VarCurr: state_type] :
      ( v121453(VarCurr)
    <=> ( v121454(VarCurr)
        | v121462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5289,axiom,
    ! [VarCurr: state_type] :
      ( v121462(VarCurr)
    <=> ( v121154(VarCurr,1)
        & v121456(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14474,axiom,
    ! [VarCurr: state_type] :
      ( v121454(VarCurr)
    <=> ( v121455(VarCurr)
        & v121457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14473,axiom,
    ! [VarCurr: state_type] :
      ( v121457(VarCurr)
    <=> ( v121458(VarCurr)
        & v121461(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5288,axiom,
    ! [VarCurr: state_type] :
      ( v121461(VarCurr)
    <=> ( v121154(VarCurr,1)
        | v121456(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14472,axiom,
    ! [VarCurr: state_type] :
      ( v121458(VarCurr)
    <=> ( v121459(VarCurr)
        | v121460(VarCurr) ) ) ).

tff(writeUnaryOperator_7957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121460(VarCurr)
    <=> v121456(VarCurr,1) ) ).

tff(writeUnaryOperator_7956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121459(VarCurr)
    <=> v121154(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14471,axiom,
    ! [VarCurr: state_type] :
      ( v121455(VarCurr)
    <=> ( v121154(VarCurr,0)
        & v121456(VarCurr,0) ) ) ).

tff(addAssignment_69955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v121456(VarCurr,B)
      <=> v121176(VarCurr,B) ) ) ).

tff(addAssignment_69954,axiom,
    ! [VarCurr: state_type] :
      ( ( v121456(VarCurr,5)
      <=> $false )
      & ( v121456(VarCurr,4)
      <=> $false )
      & ( v121456(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_69953,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,5)
    <=> v121422(VarCurr,5) ) ).

tff(addAssignment_69952,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,4)
    <=> v121422(VarCurr,4) ) ).

tff(addAssignment_69951,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,3)
    <=> v121422(VarCurr,3) ) ).

tff(addAssignment_69950,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,2)
    <=> v121422(VarCurr,2) ) ).

tff(addAssignment_69949,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,1)
    <=> v121422(VarCurr,1) ) ).

tff(addAssignment_69948,axiom,
    ! [VarCurr: state_type] :
      ( v121385(VarCurr,0)
    <=> v121422(VarCurr,0) ) ).

tff(addAssignment_69947,axiom,
    ! [VarCurr: state_type] :
      ( v121422(VarCurr,0)
    <=> v121423(VarCurr) ) ).

tff(addAssignment_69946,axiom,
    ! [VarCurr: state_type] :
      ( ( v121422(VarCurr,5)
      <=> $false )
      & ( v121422(VarCurr,4)
      <=> $false )
      & ( v121422(VarCurr,3)
      <=> $false )
      & ( v121422(VarCurr,2)
      <=> $false )
      & ( v121422(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14470,axiom,
    ! [VarCurr: state_type] :
      ( v121423(VarCurr)
    <=> ( v121424(VarCurr)
        | v121421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14469,axiom,
    ! [VarCurr: state_type] :
      ( v121424(VarCurr)
    <=> ( v121425(VarCurr)
        | v121419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14468,axiom,
    ! [VarCurr: state_type] :
      ( v121425(VarCurr)
    <=> ( v121426(VarCurr)
        | v121417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14467,axiom,
    ! [VarCurr: state_type] :
      ( v121426(VarCurr)
    <=> ( v121427(VarCurr)
        | v121407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14466,axiom,
    ! [VarCurr: state_type] :
      ( v121427(VarCurr)
    <=> ( v121387(VarCurr)
        | v121397(VarCurr) ) ) ).

tff(addAssignment_69945,axiom,
    ! [VarCurr: state_type] :
      ( v121421(VarCurr)
    <=> v113911(VarCurr,9) ) ).

tff(addAssignment_69944,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,9)
    <=> v113913(VarCurr,9) ) ).

tff(addAssignment_69943,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,9)
    <=> v113915(VarCurr,9) ) ).

tff(addAssignment_69942,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,9)
    <=> v113935(VarCurr,9) ) ).

tff(addAssignment_69941,axiom,
    ! [VarCurr: state_type] :
      ( v121419(VarCurr)
    <=> v113107(VarCurr,9) ) ).

tff(addAssignment_69940,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,9)
    <=> v113143(VarCurr,9) ) ).

tff(addAssignment_69939,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,9)
    <=> v113110(VarCurr,9) ) ).

tff(addAssignment_69938,axiom,
    ! [VarCurr: state_type] :
      ( v121417(VarCurr)
    <=> v113100(VarCurr,9) ) ).

tff(addAssignment_69937,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,9)
    <=> v113101(VarCurr,9) ) ).

tff(addAssignment_69936,axiom,
    ! [VarCurr: state_type] :
      ( v121407(VarCurr)
    <=> v113810(VarCurr,9) ) ).

tff(addAssignment_69935,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,9)
    <=> v113812(VarCurr,9) ) ).

tff(addAssignment_69934,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,9)
    <=> v113814(VarCurr,9) ) ).

tff(addAssignment_69933,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,9)
    <=> v113816(VarCurr,9) ) ).

tff(addAssignment_69932,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,9)
    <=> v113818(VarCurr,9) ) ).

tff(addAssignment_69931,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,9)
    <=> v121409(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_1576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121410(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v121409(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1576,axiom,
    ! [VarNext: state_type] :
      ( v121410(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v121409(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121410(VarNext)
      <=> v121411(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121411(VarNext)
      <=> ( v121413(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121413(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_69930,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,9)
    <=> v113830(VarCurr,9) ) ).

tff(addAssignment_69929,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,9)
    <=> v113832(VarCurr,9) ) ).

tff(addAssignment_69928,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,9)
    <=> v113834(VarCurr,9) ) ).

tff(addAssignment_69927,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,9)
    <=> v113873(VarCurr,9) ) ).

tff(addAssignment_69926,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,9)
    <=> v113856(VarCurr,9) ) ).

tff(addAssignment_69925,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,9)
    <=> v113837(VarCurr,9) ) ).

tff(addAssignment_69924,axiom,
    ! [VarCurr: state_type] :
      ( v121397(VarCurr)
    <=> v113020(VarCurr,9) ) ).

tff(addAssignment_69923,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,9)
    <=> v113022(VarCurr,9) ) ).

tff(addAssignment_69922,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,9)
    <=> v113024(VarCurr,9) ) ).

tff(addAssignment_69921,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,9)
    <=> v113026(VarCurr,9) ) ).

tff(addAssignment_69920,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,9)
    <=> v113028(VarCurr,9) ) ).

tff(addAssignment_69919,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,9)
    <=> v121399(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_1575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121400(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v121399(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1575,axiom,
    ! [VarNext: state_type] :
      ( v121400(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v121399(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121400(VarNext)
      <=> v121401(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121401(VarNext)
      <=> ( v121403(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121403(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_69918,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,9)
    <=> v113040(VarCurr,9) ) ).

tff(addAssignment_69917,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,9)
    <=> v113042(VarCurr,9) ) ).

tff(addAssignment_69916,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,9)
    <=> v113044(VarCurr,9) ) ).

tff(addAssignment_69915,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,9)
    <=> v113045(VarCurr,9) ) ).

tff(addAssignment_69914,axiom,
    ! [VarCurr: state_type] :
      ( v121387(VarCurr)
    <=> v112940(VarCurr,9) ) ).

tff(addAssignment_69913,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,9)
    <=> v112942(VarCurr,9) ) ).

tff(addAssignment_69912,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,9)
    <=> v112944(VarCurr,9) ) ).

tff(addAssignment_69911,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,9)
    <=> v112946(VarCurr,9) ) ).

tff(addAssignment_69910,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,9)
    <=> v112948(VarCurr,9) ) ).

tff(addAssignment_69909,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,9)
    <=> v121389(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_1574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121390(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v121389(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1574,axiom,
    ! [VarNext: state_type] :
      ( v121390(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v121389(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121390(VarNext)
      <=> v121391(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121391(VarNext)
      <=> ( v121393(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121393(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_69908,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,9)
    <=> v112960(VarCurr,9) ) ).

tff(addAssignment_69907,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,9)
    <=> v112962(VarCurr,9) ) ).

tff(addAssignment_69906,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,9)
    <=> v112964(VarCurr,9) ) ).

tff(addAssignment_69905,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,9)
    <=> v112965(VarCurr,9) ) ).

tff(addAssignment_69904,axiom,
    ! [VarCurr: state_type] :
      ( v121176(VarCurr,2)
    <=> v121191(VarCurr,2) ) ).

tff(addAssignment_69903,axiom,
    ! [VarCurr: state_type] :
      ( v121176(VarCurr,1)
    <=> v121191(VarCurr,1) ) ).

tff(addAssignment_69902,axiom,
    ! [VarCurr: state_type] :
      ( v121176(VarCurr,0)
    <=> v121191(VarCurr,0) ) ).

tff(addAssignment_69901,axiom,
    ! [VarCurr: state_type] :
      ( v121191(VarCurr,0)
    <=> v121379(VarCurr) ) ).

tff(addAssignment_69900,axiom,
    ! [VarCurr: state_type] :
      ( v121191(VarCurr,1)
    <=> v121374(VarCurr) ) ).

tff(addAssignment_69899,axiom,
    ! [VarCurr: state_type] :
      ( v121191(VarCurr,2)
    <=> v121193(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14459,axiom,
    ! [VarCurr: state_type] :
      ( v121379(VarCurr)
    <=> ( v121380(VarCurr)
        & v121383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14458,axiom,
    ! [VarCurr: state_type] :
      ( v121383(VarCurr)
    <=> ( v121199(VarCurr,0)
        | v121360(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14457,axiom,
    ! [VarCurr: state_type] :
      ( v121380(VarCurr)
    <=> ( v121381(VarCurr)
        | v121382(VarCurr) ) ) ).

tff(writeUnaryOperator_7952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121382(VarCurr)
    <=> v121360(VarCurr,0) ) ).

tff(writeUnaryOperator_7951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121381(VarCurr)
    <=> v121199(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14456,axiom,
    ! [VarCurr: state_type] :
      ( v121374(VarCurr)
    <=> ( v121375(VarCurr)
        & v121378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14455,axiom,
    ! [VarCurr: state_type] :
      ( v121378(VarCurr)
    <=> ( v121198(VarCurr)
        | v121361(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14454,axiom,
    ! [VarCurr: state_type] :
      ( v121375(VarCurr)
    <=> ( v121376(VarCurr)
        | v121377(VarCurr) ) ) ).

tff(writeUnaryOperator_7950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121377(VarCurr)
    <=> v121361(VarCurr) ) ).

tff(writeUnaryOperator_7949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121376(VarCurr)
    <=> v121198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14453,axiom,
    ! [VarCurr: state_type] :
      ( v121193(VarCurr)
    <=> ( v121194(VarCurr)
        & v121373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14452,axiom,
    ! [VarCurr: state_type] :
      ( v121373(VarCurr)
    <=> ( v121196(VarCurr)
        | v121368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14451,axiom,
    ! [VarCurr: state_type] :
      ( v121194(VarCurr)
    <=> ( v121195(VarCurr)
        | v121367(VarCurr) ) ) ).

tff(writeUnaryOperator_7948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121367(VarCurr)
    <=> v121368(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14450,axiom,
    ! [VarCurr: state_type] :
      ( v121368(VarCurr)
    <=> ( v121369(VarCurr)
        & v121372(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5287,axiom,
    ! [VarCurr: state_type] :
      ( v121372(VarCurr)
    <=> ( v121199(VarCurr,2)
        | v121360(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14449,axiom,
    ! [VarCurr: state_type] :
      ( v121369(VarCurr)
    <=> ( v121370(VarCurr)
        | v121371(VarCurr) ) ) ).

tff(writeUnaryOperator_7947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121371(VarCurr)
    <=> v121360(VarCurr,2) ) ).

tff(writeUnaryOperator_7946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121370(VarCurr)
    <=> v121199(VarCurr,2) ) ).

tff(writeUnaryOperator_7945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121195(VarCurr)
    <=> v121196(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14448,axiom,
    ! [VarCurr: state_type] :
      ( v121196(VarCurr)
    <=> ( v121197(VarCurr)
        | v121366(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5286,axiom,
    ! [VarCurr: state_type] :
      ( v121366(VarCurr)
    <=> ( v121199(VarCurr,1)
        & v121360(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14447,axiom,
    ! [VarCurr: state_type] :
      ( v121197(VarCurr)
    <=> ( v121198(VarCurr)
        & v121361(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14446,axiom,
    ! [VarCurr: state_type] :
      ( v121361(VarCurr)
    <=> ( v121362(VarCurr)
        & v121365(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5285,axiom,
    ! [VarCurr: state_type] :
      ( v121365(VarCurr)
    <=> ( v121199(VarCurr,1)
        | v121360(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14445,axiom,
    ! [VarCurr: state_type] :
      ( v121362(VarCurr)
    <=> ( v121363(VarCurr)
        | v121364(VarCurr) ) ) ).

tff(writeUnaryOperator_7944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121364(VarCurr)
    <=> v121360(VarCurr,1) ) ).

tff(writeUnaryOperator_7943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121363(VarCurr)
    <=> v121199(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14444,axiom,
    ! [VarCurr: state_type] :
      ( v121198(VarCurr)
    <=> ( v121199(VarCurr,0)
        & v121360(VarCurr,0) ) ) ).

tff(addAssignment_69898,axiom,
    ! [VarCurr: state_type] :
      ( v121360(VarCurr,0)
    <=> v121190(VarCurr) ) ).

tff(addAssignment_69897,axiom,
    ! [VarCurr: state_type] :
      ( ( v121360(VarCurr,2)
      <=> $false )
      & ( v121360(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69896,axiom,
    ! [VarCurr: state_type] :
      ( v121199(VarCurr,0)
    <=> v121355(VarCurr) ) ).

tff(addAssignment_69895,axiom,
    ! [VarCurr: state_type] :
      ( v121199(VarCurr,1)
    <=> v121350(VarCurr) ) ).

tff(addAssignment_69894,axiom,
    ! [VarCurr: state_type] :
      ( v121199(VarCurr,2)
    <=> v121201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14443,axiom,
    ! [VarCurr: state_type] :
      ( v121355(VarCurr)
    <=> ( v121356(VarCurr)
        & v121359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14442,axiom,
    ! [VarCurr: state_type] :
      ( v121359(VarCurr)
    <=> ( v121207(VarCurr,0)
        | v121336(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14441,axiom,
    ! [VarCurr: state_type] :
      ( v121356(VarCurr)
    <=> ( v121357(VarCurr)
        | v121358(VarCurr) ) ) ).

tff(writeUnaryOperator_7942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121358(VarCurr)
    <=> v121336(VarCurr,0) ) ).

tff(writeUnaryOperator_7941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121357(VarCurr)
    <=> v121207(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14440,axiom,
    ! [VarCurr: state_type] :
      ( v121350(VarCurr)
    <=> ( v121351(VarCurr)
        & v121354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14439,axiom,
    ! [VarCurr: state_type] :
      ( v121354(VarCurr)
    <=> ( v121206(VarCurr)
        | v121337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14438,axiom,
    ! [VarCurr: state_type] :
      ( v121351(VarCurr)
    <=> ( v121352(VarCurr)
        | v121353(VarCurr) ) ) ).

tff(writeUnaryOperator_7940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121353(VarCurr)
    <=> v121337(VarCurr) ) ).

tff(writeUnaryOperator_7939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121352(VarCurr)
    <=> v121206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14437,axiom,
    ! [VarCurr: state_type] :
      ( v121201(VarCurr)
    <=> ( v121202(VarCurr)
        & v121349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14436,axiom,
    ! [VarCurr: state_type] :
      ( v121349(VarCurr)
    <=> ( v121204(VarCurr)
        | v121344(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14435,axiom,
    ! [VarCurr: state_type] :
      ( v121202(VarCurr)
    <=> ( v121203(VarCurr)
        | v121343(VarCurr) ) ) ).

tff(writeUnaryOperator_7938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121343(VarCurr)
    <=> v121344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14434,axiom,
    ! [VarCurr: state_type] :
      ( v121344(VarCurr)
    <=> ( v121345(VarCurr)
        & v121348(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5284,axiom,
    ! [VarCurr: state_type] :
      ( v121348(VarCurr)
    <=> ( v121207(VarCurr,2)
        | v121336(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14433,axiom,
    ! [VarCurr: state_type] :
      ( v121345(VarCurr)
    <=> ( v121346(VarCurr)
        | v121347(VarCurr) ) ) ).

tff(writeUnaryOperator_7937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121347(VarCurr)
    <=> v121336(VarCurr,2) ) ).

tff(writeUnaryOperator_7936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121346(VarCurr)
    <=> v121207(VarCurr,2) ) ).

tff(writeUnaryOperator_7935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121203(VarCurr)
    <=> v121204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14432,axiom,
    ! [VarCurr: state_type] :
      ( v121204(VarCurr)
    <=> ( v121205(VarCurr)
        | v121342(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5283,axiom,
    ! [VarCurr: state_type] :
      ( v121342(VarCurr)
    <=> ( v121207(VarCurr,1)
        & v121336(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14431,axiom,
    ! [VarCurr: state_type] :
      ( v121205(VarCurr)
    <=> ( v121206(VarCurr)
        & v121337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14430,axiom,
    ! [VarCurr: state_type] :
      ( v121337(VarCurr)
    <=> ( v121338(VarCurr)
        & v121341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5282,axiom,
    ! [VarCurr: state_type] :
      ( v121341(VarCurr)
    <=> ( v121207(VarCurr,1)
        | v121336(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14429,axiom,
    ! [VarCurr: state_type] :
      ( v121338(VarCurr)
    <=> ( v121339(VarCurr)
        | v121340(VarCurr) ) ) ).

tff(writeUnaryOperator_7934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121340(VarCurr)
    <=> v121336(VarCurr,1) ) ).

tff(writeUnaryOperator_7933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121339(VarCurr)
    <=> v121207(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14428,axiom,
    ! [VarCurr: state_type] :
      ( v121206(VarCurr)
    <=> ( v121207(VarCurr,0)
        & v121336(VarCurr,0) ) ) ).

tff(addAssignment_69893,axiom,
    ! [VarCurr: state_type] :
      ( v121336(VarCurr,0)
    <=> v121188(VarCurr) ) ).

tff(addAssignment_69892,axiom,
    ! [VarCurr: state_type] :
      ( ( v121336(VarCurr,2)
      <=> $false )
      & ( v121336(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69891,axiom,
    ! [VarCurr: state_type] :
      ( v121207(VarCurr,0)
    <=> v121331(VarCurr) ) ).

tff(addAssignment_69890,axiom,
    ! [VarCurr: state_type] :
      ( v121207(VarCurr,1)
    <=> v121326(VarCurr) ) ).

tff(addAssignment_69889,axiom,
    ! [VarCurr: state_type] :
      ( v121207(VarCurr,2)
    <=> v121209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14427,axiom,
    ! [VarCurr: state_type] :
      ( v121331(VarCurr)
    <=> ( v121332(VarCurr)
        & v121335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14426,axiom,
    ! [VarCurr: state_type] :
      ( v121335(VarCurr)
    <=> ( v121215(VarCurr,0)
        | v121312(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14425,axiom,
    ! [VarCurr: state_type] :
      ( v121332(VarCurr)
    <=> ( v121333(VarCurr)
        | v121334(VarCurr) ) ) ).

tff(writeUnaryOperator_7932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121334(VarCurr)
    <=> v121312(VarCurr,0) ) ).

tff(writeUnaryOperator_7931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121333(VarCurr)
    <=> v121215(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14424,axiom,
    ! [VarCurr: state_type] :
      ( v121326(VarCurr)
    <=> ( v121327(VarCurr)
        & v121330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14423,axiom,
    ! [VarCurr: state_type] :
      ( v121330(VarCurr)
    <=> ( v121214(VarCurr)
        | v121313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14422,axiom,
    ! [VarCurr: state_type] :
      ( v121327(VarCurr)
    <=> ( v121328(VarCurr)
        | v121329(VarCurr) ) ) ).

tff(writeUnaryOperator_7930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121329(VarCurr)
    <=> v121313(VarCurr) ) ).

tff(writeUnaryOperator_7929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121328(VarCurr)
    <=> v121214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14421,axiom,
    ! [VarCurr: state_type] :
      ( v121209(VarCurr)
    <=> ( v121210(VarCurr)
        & v121325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14420,axiom,
    ! [VarCurr: state_type] :
      ( v121325(VarCurr)
    <=> ( v121212(VarCurr)
        | v121320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14419,axiom,
    ! [VarCurr: state_type] :
      ( v121210(VarCurr)
    <=> ( v121211(VarCurr)
        | v121319(VarCurr) ) ) ).

tff(writeUnaryOperator_7928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121319(VarCurr)
    <=> v121320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14418,axiom,
    ! [VarCurr: state_type] :
      ( v121320(VarCurr)
    <=> ( v121321(VarCurr)
        & v121324(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5281,axiom,
    ! [VarCurr: state_type] :
      ( v121324(VarCurr)
    <=> ( v121215(VarCurr,2)
        | v121312(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14417,axiom,
    ! [VarCurr: state_type] :
      ( v121321(VarCurr)
    <=> ( v121322(VarCurr)
        | v121323(VarCurr) ) ) ).

tff(writeUnaryOperator_7927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121323(VarCurr)
    <=> v121312(VarCurr,2) ) ).

tff(writeUnaryOperator_7926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121322(VarCurr)
    <=> v121215(VarCurr,2) ) ).

tff(writeUnaryOperator_7925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121211(VarCurr)
    <=> v121212(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14416,axiom,
    ! [VarCurr: state_type] :
      ( v121212(VarCurr)
    <=> ( v121213(VarCurr)
        | v121318(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5280,axiom,
    ! [VarCurr: state_type] :
      ( v121318(VarCurr)
    <=> ( v121215(VarCurr,1)
        & v121312(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14415,axiom,
    ! [VarCurr: state_type] :
      ( v121213(VarCurr)
    <=> ( v121214(VarCurr)
        & v121313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14414,axiom,
    ! [VarCurr: state_type] :
      ( v121313(VarCurr)
    <=> ( v121314(VarCurr)
        & v121317(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5279,axiom,
    ! [VarCurr: state_type] :
      ( v121317(VarCurr)
    <=> ( v121215(VarCurr,1)
        | v121312(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14413,axiom,
    ! [VarCurr: state_type] :
      ( v121314(VarCurr)
    <=> ( v121315(VarCurr)
        | v121316(VarCurr) ) ) ).

tff(writeUnaryOperator_7924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121316(VarCurr)
    <=> v121312(VarCurr,1) ) ).

tff(writeUnaryOperator_7923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121315(VarCurr)
    <=> v121215(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14412,axiom,
    ! [VarCurr: state_type] :
      ( v121214(VarCurr)
    <=> ( v121215(VarCurr,0)
        & v121312(VarCurr,0) ) ) ).

tff(addAssignment_69888,axiom,
    ! [VarCurr: state_type] :
      ( v121312(VarCurr,0)
    <=> v121186(VarCurr) ) ).

tff(addAssignment_69887,axiom,
    ! [VarCurr: state_type] :
      ( ( v121312(VarCurr,2)
      <=> $false )
      & ( v121312(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69886,axiom,
    ! [VarCurr: state_type] :
      ( v121215(VarCurr,0)
    <=> v121307(VarCurr) ) ).

tff(addAssignment_69885,axiom,
    ! [VarCurr: state_type] :
      ( v121215(VarCurr,1)
    <=> v121302(VarCurr) ) ).

tff(addAssignment_69884,axiom,
    ! [VarCurr: state_type] :
      ( v121215(VarCurr,2)
    <=> v121217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14411,axiom,
    ! [VarCurr: state_type] :
      ( v121307(VarCurr)
    <=> ( v121308(VarCurr)
        & v121311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14410,axiom,
    ! [VarCurr: state_type] :
      ( v121311(VarCurr)
    <=> ( v121223(VarCurr,0)
        | v121288(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14409,axiom,
    ! [VarCurr: state_type] :
      ( v121308(VarCurr)
    <=> ( v121309(VarCurr)
        | v121310(VarCurr) ) ) ).

tff(writeUnaryOperator_7922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121310(VarCurr)
    <=> v121288(VarCurr,0) ) ).

tff(writeUnaryOperator_7921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121309(VarCurr)
    <=> v121223(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14408,axiom,
    ! [VarCurr: state_type] :
      ( v121302(VarCurr)
    <=> ( v121303(VarCurr)
        & v121306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14407,axiom,
    ! [VarCurr: state_type] :
      ( v121306(VarCurr)
    <=> ( v121222(VarCurr)
        | v121289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14406,axiom,
    ! [VarCurr: state_type] :
      ( v121303(VarCurr)
    <=> ( v121304(VarCurr)
        | v121305(VarCurr) ) ) ).

tff(writeUnaryOperator_7920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121305(VarCurr)
    <=> v121289(VarCurr) ) ).

tff(writeUnaryOperator_7919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121304(VarCurr)
    <=> v121222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14405,axiom,
    ! [VarCurr: state_type] :
      ( v121217(VarCurr)
    <=> ( v121218(VarCurr)
        & v121301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14404,axiom,
    ! [VarCurr: state_type] :
      ( v121301(VarCurr)
    <=> ( v121220(VarCurr)
        | v121296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14403,axiom,
    ! [VarCurr: state_type] :
      ( v121218(VarCurr)
    <=> ( v121219(VarCurr)
        | v121295(VarCurr) ) ) ).

tff(writeUnaryOperator_7918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121295(VarCurr)
    <=> v121296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14402,axiom,
    ! [VarCurr: state_type] :
      ( v121296(VarCurr)
    <=> ( v121297(VarCurr)
        & v121300(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5278,axiom,
    ! [VarCurr: state_type] :
      ( v121300(VarCurr)
    <=> ( v121223(VarCurr,2)
        | v121288(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14401,axiom,
    ! [VarCurr: state_type] :
      ( v121297(VarCurr)
    <=> ( v121298(VarCurr)
        | v121299(VarCurr) ) ) ).

tff(writeUnaryOperator_7917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121299(VarCurr)
    <=> v121288(VarCurr,2) ) ).

tff(writeUnaryOperator_7916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121298(VarCurr)
    <=> v121223(VarCurr,2) ) ).

tff(writeUnaryOperator_7915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121219(VarCurr)
    <=> v121220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14400,axiom,
    ! [VarCurr: state_type] :
      ( v121220(VarCurr)
    <=> ( v121221(VarCurr)
        | v121294(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5277,axiom,
    ! [VarCurr: state_type] :
      ( v121294(VarCurr)
    <=> ( v121223(VarCurr,1)
        & v121288(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14399,axiom,
    ! [VarCurr: state_type] :
      ( v121221(VarCurr)
    <=> ( v121222(VarCurr)
        & v121289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14398,axiom,
    ! [VarCurr: state_type] :
      ( v121289(VarCurr)
    <=> ( v121290(VarCurr)
        & v121293(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5276,axiom,
    ! [VarCurr: state_type] :
      ( v121293(VarCurr)
    <=> ( v121223(VarCurr,1)
        | v121288(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14397,axiom,
    ! [VarCurr: state_type] :
      ( v121290(VarCurr)
    <=> ( v121291(VarCurr)
        | v121292(VarCurr) ) ) ).

tff(writeUnaryOperator_7914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121292(VarCurr)
    <=> v121288(VarCurr,1) ) ).

tff(writeUnaryOperator_7913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121291(VarCurr)
    <=> v121223(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14396,axiom,
    ! [VarCurr: state_type] :
      ( v121222(VarCurr)
    <=> ( v121223(VarCurr,0)
        & v121288(VarCurr,0) ) ) ).

tff(addAssignment_69883,axiom,
    ! [VarCurr: state_type] :
      ( v121288(VarCurr,0)
    <=> v121184(VarCurr) ) ).

tff(addAssignment_69882,axiom,
    ! [VarCurr: state_type] :
      ( ( v121288(VarCurr,2)
      <=> $false )
      & ( v121288(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69881,axiom,
    ! [VarCurr: state_type] :
      ( v121223(VarCurr,0)
    <=> v121283(VarCurr) ) ).

tff(addAssignment_69880,axiom,
    ! [VarCurr: state_type] :
      ( v121223(VarCurr,1)
    <=> v121278(VarCurr) ) ).

tff(addAssignment_69879,axiom,
    ! [VarCurr: state_type] :
      ( v121223(VarCurr,2)
    <=> v121225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14395,axiom,
    ! [VarCurr: state_type] :
      ( v121283(VarCurr)
    <=> ( v121284(VarCurr)
        & v121287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14394,axiom,
    ! [VarCurr: state_type] :
      ( v121287(VarCurr)
    <=> ( v121231(VarCurr,0)
        | v121264(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14393,axiom,
    ! [VarCurr: state_type] :
      ( v121284(VarCurr)
    <=> ( v121285(VarCurr)
        | v121286(VarCurr) ) ) ).

tff(writeUnaryOperator_7912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121286(VarCurr)
    <=> v121264(VarCurr,0) ) ).

tff(writeUnaryOperator_7911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121285(VarCurr)
    <=> v121231(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14392,axiom,
    ! [VarCurr: state_type] :
      ( v121278(VarCurr)
    <=> ( v121279(VarCurr)
        & v121282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14391,axiom,
    ! [VarCurr: state_type] :
      ( v121282(VarCurr)
    <=> ( v121230(VarCurr)
        | v121265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14390,axiom,
    ! [VarCurr: state_type] :
      ( v121279(VarCurr)
    <=> ( v121280(VarCurr)
        | v121281(VarCurr) ) ) ).

tff(writeUnaryOperator_7910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121281(VarCurr)
    <=> v121265(VarCurr) ) ).

tff(writeUnaryOperator_7909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121280(VarCurr)
    <=> v121230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14389,axiom,
    ! [VarCurr: state_type] :
      ( v121225(VarCurr)
    <=> ( v121226(VarCurr)
        & v121277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14388,axiom,
    ! [VarCurr: state_type] :
      ( v121277(VarCurr)
    <=> ( v121228(VarCurr)
        | v121272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14387,axiom,
    ! [VarCurr: state_type] :
      ( v121226(VarCurr)
    <=> ( v121227(VarCurr)
        | v121271(VarCurr) ) ) ).

tff(writeUnaryOperator_7908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121271(VarCurr)
    <=> v121272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14386,axiom,
    ! [VarCurr: state_type] :
      ( v121272(VarCurr)
    <=> ( v121273(VarCurr)
        & v121276(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5275,axiom,
    ! [VarCurr: state_type] :
      ( v121276(VarCurr)
    <=> ( v121231(VarCurr,2)
        | v121264(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14385,axiom,
    ! [VarCurr: state_type] :
      ( v121273(VarCurr)
    <=> ( v121274(VarCurr)
        | v121275(VarCurr) ) ) ).

tff(writeUnaryOperator_7907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121275(VarCurr)
    <=> v121264(VarCurr,2) ) ).

tff(writeUnaryOperator_7906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121274(VarCurr)
    <=> v121231(VarCurr,2) ) ).

tff(writeUnaryOperator_7905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121227(VarCurr)
    <=> v121228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14384,axiom,
    ! [VarCurr: state_type] :
      ( v121228(VarCurr)
    <=> ( v121229(VarCurr)
        | v121270(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5274,axiom,
    ! [VarCurr: state_type] :
      ( v121270(VarCurr)
    <=> ( v121231(VarCurr,1)
        & v121264(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14383,axiom,
    ! [VarCurr: state_type] :
      ( v121229(VarCurr)
    <=> ( v121230(VarCurr)
        & v121265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14382,axiom,
    ! [VarCurr: state_type] :
      ( v121265(VarCurr)
    <=> ( v121266(VarCurr)
        & v121269(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5273,axiom,
    ! [VarCurr: state_type] :
      ( v121269(VarCurr)
    <=> ( v121231(VarCurr,1)
        | v121264(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14381,axiom,
    ! [VarCurr: state_type] :
      ( v121266(VarCurr)
    <=> ( v121267(VarCurr)
        | v121268(VarCurr) ) ) ).

tff(writeUnaryOperator_7904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121268(VarCurr)
    <=> v121264(VarCurr,1) ) ).

tff(writeUnaryOperator_7903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121267(VarCurr)
    <=> v121231(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14380,axiom,
    ! [VarCurr: state_type] :
      ( v121230(VarCurr)
    <=> ( v121231(VarCurr,0)
        & v121264(VarCurr,0) ) ) ).

tff(addAssignment_69878,axiom,
    ! [VarCurr: state_type] :
      ( v121264(VarCurr,0)
    <=> v121182(VarCurr) ) ).

tff(addAssignment_69877,axiom,
    ! [VarCurr: state_type] :
      ( ( v121264(VarCurr,2)
      <=> $false )
      & ( v121264(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69876,axiom,
    ! [VarCurr: state_type] :
      ( v121231(VarCurr,0)
    <=> v121259(VarCurr) ) ).

tff(addAssignment_69875,axiom,
    ! [VarCurr: state_type] :
      ( v121231(VarCurr,1)
    <=> v121254(VarCurr) ) ).

tff(addAssignment_69874,axiom,
    ! [VarCurr: state_type] :
      ( v121231(VarCurr,2)
    <=> v121233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14379,axiom,
    ! [VarCurr: state_type] :
      ( v121259(VarCurr)
    <=> ( v121260(VarCurr)
        & v121263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14378,axiom,
    ! [VarCurr: state_type] :
      ( v121263(VarCurr)
    <=> ( v121239(VarCurr,0)
        | v121240(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14377,axiom,
    ! [VarCurr: state_type] :
      ( v121260(VarCurr)
    <=> ( v121261(VarCurr)
        | v121262(VarCurr) ) ) ).

tff(writeUnaryOperator_7902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121262(VarCurr)
    <=> v121240(VarCurr,0) ) ).

tff(writeUnaryOperator_7901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121261(VarCurr)
    <=> v121239(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14376,axiom,
    ! [VarCurr: state_type] :
      ( v121254(VarCurr)
    <=> ( v121255(VarCurr)
        & v121258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14375,axiom,
    ! [VarCurr: state_type] :
      ( v121258(VarCurr)
    <=> ( v121238(VarCurr)
        | v121241(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14374,axiom,
    ! [VarCurr: state_type] :
      ( v121255(VarCurr)
    <=> ( v121256(VarCurr)
        | v121257(VarCurr) ) ) ).

tff(writeUnaryOperator_7900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121257(VarCurr)
    <=> v121241(VarCurr) ) ).

tff(writeUnaryOperator_7899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121256(VarCurr)
    <=> v121238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14373,axiom,
    ! [VarCurr: state_type] :
      ( v121233(VarCurr)
    <=> ( v121234(VarCurr)
        & v121253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14372,axiom,
    ! [VarCurr: state_type] :
      ( v121253(VarCurr)
    <=> ( v121236(VarCurr)
        | v121248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14371,axiom,
    ! [VarCurr: state_type] :
      ( v121234(VarCurr)
    <=> ( v121235(VarCurr)
        | v121247(VarCurr) ) ) ).

tff(writeUnaryOperator_7898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121247(VarCurr)
    <=> v121248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14370,axiom,
    ! [VarCurr: state_type] :
      ( v121248(VarCurr)
    <=> ( v121249(VarCurr)
        & v121252(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5272,axiom,
    ! [VarCurr: state_type] :
      ( v121252(VarCurr)
    <=> ( v121239(VarCurr,2)
        | v121240(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14369,axiom,
    ! [VarCurr: state_type] :
      ( v121249(VarCurr)
    <=> ( v121250(VarCurr)
        | v121251(VarCurr) ) ) ).

tff(writeUnaryOperator_7897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121251(VarCurr)
    <=> v121240(VarCurr,2) ) ).

tff(writeUnaryOperator_7896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121250(VarCurr)
    <=> v121239(VarCurr,2) ) ).

tff(writeUnaryOperator_7895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121235(VarCurr)
    <=> v121236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14368,axiom,
    ! [VarCurr: state_type] :
      ( v121236(VarCurr)
    <=> ( v121237(VarCurr)
        | v121246(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5271,axiom,
    ! [VarCurr: state_type] :
      ( v121246(VarCurr)
    <=> ( v121239(VarCurr,1)
        & v121240(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14367,axiom,
    ! [VarCurr: state_type] :
      ( v121237(VarCurr)
    <=> ( v121238(VarCurr)
        & v121241(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14366,axiom,
    ! [VarCurr: state_type] :
      ( v121241(VarCurr)
    <=> ( v121242(VarCurr)
        & v121245(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5270,axiom,
    ! [VarCurr: state_type] :
      ( v121245(VarCurr)
    <=> ( v121239(VarCurr,1)
        | v121240(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14365,axiom,
    ! [VarCurr: state_type] :
      ( v121242(VarCurr)
    <=> ( v121243(VarCurr)
        | v121244(VarCurr) ) ) ).

tff(writeUnaryOperator_7894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121244(VarCurr)
    <=> v121240(VarCurr,1) ) ).

tff(writeUnaryOperator_7893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121243(VarCurr)
    <=> v121239(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14364,axiom,
    ! [VarCurr: state_type] :
      ( v121238(VarCurr)
    <=> ( v121239(VarCurr,0)
        & v121240(VarCurr,0) ) ) ).

tff(addAssignment_69873,axiom,
    ! [VarCurr: state_type] :
      ( v121240(VarCurr,0)
    <=> v121180(VarCurr) ) ).

tff(addAssignment_69872,axiom,
    ! [VarCurr: state_type] :
      ( ( v121240(VarCurr,2)
      <=> $false )
      & ( v121240(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69871,axiom,
    ! [VarCurr: state_type] :
      ( v121239(VarCurr,0)
    <=> v121178(VarCurr) ) ).

tff(addAssignment_69870,axiom,
    ! [VarCurr: state_type] :
      ( ( v121239(VarCurr,2)
      <=> $false )
      & ( v121239(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69869,axiom,
    ! [VarCurr: state_type] :
      ( v121190(VarCurr)
    <=> v114692(VarCurr,9) ) ).

tff(addAssignment_69868,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,9)
    <=> v114694(VarCurr,9) ) ).

tff(addAssignment_69867,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,9)
    <=> v114696(VarCurr,9) ) ).

tff(addAssignment_69866,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,9)
    <=> v114697(VarCurr,9) ) ).

tff(addAssignment_69865,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,9)
    <=> v113918(VarCurr,9) ) ).

tff(addAssignment_69864,axiom,
    ! [VarCurr: state_type] :
      ( v121188(VarCurr)
    <=> v114685(VarCurr,9) ) ).

tff(addAssignment_69863,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,9)
    <=> v114686(VarCurr,9) ) ).

tff(addAssignment_69862,axiom,
    ! [VarCurr: state_type] :
      ( v121186(VarCurr)
    <=> v114661(VarCurr,9) ) ).

tff(addAssignment_69861,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,9)
    <=> v114662(VarCurr,9) ) ).

tff(addAssignment_69860,axiom,
    ! [VarCurr: state_type] :
      ( v121184(VarCurr)
    <=> v114633(VarCurr,9) ) ).

tff(addAssignment_69859,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,9)
    <=> v114635(VarCurr,9) ) ).

tff(addAssignment_69858,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,9)
    <=> v114637(VarCurr,9) ) ).

tff(addAssignment_69857,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,9)
    <=> v114638(VarCurr,9) ) ).

tff(addAssignment_69856,axiom,
    ! [VarCurr: state_type] :
      ( v121182(VarCurr)
    <=> v114605(VarCurr,9) ) ).

tff(addAssignment_69855,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,9)
    <=> v114607(VarCurr,9) ) ).

tff(addAssignment_69854,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,9)
    <=> v114609(VarCurr,9) ) ).

tff(addAssignment_69853,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,9)
    <=> v114610(VarCurr,9) ) ).

tff(addAssignment_69852,axiom,
    ! [VarCurr: state_type] :
      ( v121180(VarCurr)
    <=> v114577(VarCurr,9) ) ).

tff(addAssignment_69851,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,9)
    <=> v114579(VarCurr,9) ) ).

tff(addAssignment_69850,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,9)
    <=> v114581(VarCurr,9) ) ).

tff(addAssignment_69849,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,9)
    <=> v114582(VarCurr,9) ) ).

tff(addAssignment_69848,axiom,
    ! [VarCurr: state_type] :
      ( v121178(VarCurr)
    <=> v114549(VarCurr,9) ) ).

tff(addAssignment_69847,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,9)
    <=> v114551(VarCurr,9) ) ).

tff(addAssignment_69846,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,9)
    <=> v114553(VarCurr,9) ) ).

tff(addAssignment_69845,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,9)
    <=> v114554(VarCurr,9) ) ).

tff(addAssignment_69844,axiom,
    ! [VarCurr: state_type] :
      ( v121164(VarCurr)
    <=> v121166(VarCurr) ) ).

tff(addAssignment_69843,axiom,
    ! [VarCurr: state_type] :
      ( v121166(VarCurr)
    <=> v121140(VarCurr) ) ).

tff(addAssignment_69842,axiom,
    ! [VarCurr: state_type] :
      ( v121160(VarCurr)
    <=> v121162(VarCurr) ) ).

tff(addAssignment_69841,axiom,
    ! [VarCurr: state_type] :
      ( v121162(VarCurr)
    <=> v121132(VarCurr) ) ).

tff(addAssignment_69840,axiom,
    ! [VarCurr: state_type] :
      ( v121136(VarCurr)
    <=> v121138(VarCurr) ) ).

tff(addAssignment_69839,axiom,
    ! [VarCurr: state_type] :
      ( v121138(VarCurr)
    <=> v121140(VarCurr) ) ).

tff(addAssignment_69838,axiom,
    ! [VarCurr: state_type] :
      ( v121140(VarCurr)
    <=> v121142(VarCurr) ) ).

tff(addAssignment_69837,axiom,
    ! [VarCurr: state_type] :
      ( v121142(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_69836,axiom,
    ! [VarCurr: state_type] :
      ( v121128(VarCurr)
    <=> v121130(VarCurr) ) ).

tff(addAssignment_69835,axiom,
    ! [VarCurr: state_type] :
      ( v121130(VarCurr)
    <=> v121132(VarCurr) ) ).

tff(addAssignment_69834,axiom,
    ! [VarCurr: state_type] :
      ( v121132(VarCurr)
    <=> v121134(VarCurr) ) ).

tff(addAssignment_69833,axiom,
    ! [VarCurr: state_type] :
      ( v121134(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14363,axiom,
    ! [VarCurr: state_type] :
      ( v120318(VarCurr)
    <=> ( v121118(VarCurr)
        & v121028(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5269,axiom,
    ! [VarCurr: state_type] :
      ( v121118(VarCurr)
    <=> ( v120320(VarCurr,1)
        & v120967(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1200,axiom,
    ! [VarCurr: state_type] :
      ( v121028(VarCurr)
    <=> ( ( v121030(VarCurr,4)
        <=> $false )
        & ( v121030(VarCurr,3)
        <=> $false )
        & ( v121030(VarCurr,2)
        <=> $false )
        & ( v121030(VarCurr,1)
        <=> $false )
        & ( v121030(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121030(VarCurr,B)
      <=> v121032(VarCurr,B) ) ) ).

tff(addAssignment_69831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121032(VarCurr,B)
      <=> v121034(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121100(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v121034(VarNext,B)
            <=> v121034(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1573,axiom,
    ! [VarNext: state_type] :
      ( v121100(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121034(VarNext,B)
          <=> v121110(VarNext,B) ) ) ) ).

tff(addAssignment_69830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121110(VarNext,B)
          <=> v121108(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121111(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121108(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1119,axiom,
    ! [VarCurr: state_type] :
      ( v121111(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121108(VarCurr,B)
          <=> v121044(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14362,axiom,
    ! [VarCurr: state_type] :
      ( v121111(VarCurr)
    <=> ( v121112(VarCurr)
        & v121113(VarCurr) ) ) ).

tff(writeUnaryOperator_7892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121113(VarCurr)
    <=> v121040(VarCurr) ) ).

tff(writeUnaryOperator_7891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121112(VarCurr)
    <=> v121036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121100(VarNext)
      <=> v121101(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121101(VarNext)
      <=> ( v121102(VarNext)
          & v121095(VarNext) ) ) ) ).

tff(writeUnaryOperator_7890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121102(VarNext)
      <=> v121104(VarNext) ) ) ).

tff(addAssignment_69829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121104(VarNext)
      <=> v121095(VarCurr) ) ) ).

tff(addAssignment_69828,axiom,
    ! [VarCurr: state_type] :
      ( v121095(VarCurr)
    <=> v121097(VarCurr) ) ).

tff(addAssignment_69827,axiom,
    ! [VarCurr: state_type] :
      ( v121097(VarCurr)
    <=> v120800(VarCurr) ) ).

tff(addAssignment_69826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121044(VarCurr,B)
      <=> v121046(VarCurr,B) ) ) ).

tff(addAssignment_69825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121046(VarCurr,B)
      <=> v121048(VarCurr,B) ) ) ).

tff(addAssignment_69824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121048(VarCurr,B)
      <=> v121050(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121052(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121050(VarCurr,B)
          <=> v121064(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1118,axiom,
    ! [VarCurr: state_type] :
      ( v121052(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121050(VarCurr,B)
          <=> v121057(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121064(VarCurr,B)
          <=> v121065(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1117,axiom,
    ! [VarCurr: state_type] :
      ( v121059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121064(VarCurr,B)
          <=> v121062(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121028(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121065(VarCurr,B)
          <=> v121066(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1116,axiom,
    ! [VarCurr: state_type] :
      ( v121028(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v121065(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69823,axiom,
    ! [VarCurr: state_type] :
      ( v121066(VarCurr,0)
    <=> v121092(VarCurr) ) ).

tff(addAssignment_69822,axiom,
    ! [VarCurr: state_type] :
      ( v121066(VarCurr,1)
    <=> v121090(VarCurr) ) ).

tff(addAssignment_69821,axiom,
    ! [VarCurr: state_type] :
      ( v121066(VarCurr,2)
    <=> v121086(VarCurr) ) ).

tff(addAssignment_69820,axiom,
    ! [VarCurr: state_type] :
      ( v121066(VarCurr,3)
    <=> v121082(VarCurr) ) ).

tff(addAssignment_69819,axiom,
    ! [VarCurr: state_type] :
      ( v121066(VarCurr,4)
    <=> v121068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14359,axiom,
    ! [VarCurr: state_type] :
      ( v121090(VarCurr)
    <=> ( v121091(VarCurr)
        & v121093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14358,axiom,
    ! [VarCurr: state_type] :
      ( v121093(VarCurr)
    <=> ( v121030(VarCurr,0)
        | v121077(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5268,axiom,
    ! [VarCurr: state_type] :
      ( v121091(VarCurr)
    <=> ( v121092(VarCurr)
        | v121030(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121092(VarCurr)
    <=> v121030(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14357,axiom,
    ! [VarCurr: state_type] :
      ( v121086(VarCurr)
    <=> ( v121087(VarCurr)
        & v121089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14356,axiom,
    ! [VarCurr: state_type] :
      ( v121089(VarCurr)
    <=> ( v121075(VarCurr)
        | v121078(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5267,axiom,
    ! [VarCurr: state_type] :
      ( v121087(VarCurr)
    <=> ( v121088(VarCurr)
        | v121030(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121088(VarCurr)
    <=> v121075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14355,axiom,
    ! [VarCurr: state_type] :
      ( v121082(VarCurr)
    <=> ( v121083(VarCurr)
        & v121085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14354,axiom,
    ! [VarCurr: state_type] :
      ( v121085(VarCurr)
    <=> ( v121073(VarCurr)
        | v121079(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5266,axiom,
    ! [VarCurr: state_type] :
      ( v121083(VarCurr)
    <=> ( v121084(VarCurr)
        | v121030(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121084(VarCurr)
    <=> v121073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14353,axiom,
    ! [VarCurr: state_type] :
      ( v121068(VarCurr)
    <=> ( v121069(VarCurr)
        & v121080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14352,axiom,
    ! [VarCurr: state_type] :
      ( v121080(VarCurr)
    <=> ( v121071(VarCurr)
        | v121081(VarCurr) ) ) ).

tff(writeUnaryOperator_7886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121081(VarCurr)
    <=> v121030(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5265,axiom,
    ! [VarCurr: state_type] :
      ( v121069(VarCurr)
    <=> ( v121070(VarCurr)
        | v121030(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121070(VarCurr)
    <=> v121071(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5264,axiom,
    ! [VarCurr: state_type] :
      ( v121071(VarCurr)
    <=> ( v121030(VarCurr,3)
        | v121072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14351,axiom,
    ! [VarCurr: state_type] :
      ( v121072(VarCurr)
    <=> ( v121073(VarCurr)
        & v121079(VarCurr) ) ) ).

tff(writeUnaryOperator_7884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121079(VarCurr)
    <=> v121030(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5263,axiom,
    ! [VarCurr: state_type] :
      ( v121073(VarCurr)
    <=> ( v121030(VarCurr,2)
        | v121074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14350,axiom,
    ! [VarCurr: state_type] :
      ( v121074(VarCurr)
    <=> ( v121075(VarCurr)
        & v121078(VarCurr) ) ) ).

tff(writeUnaryOperator_7883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121078(VarCurr)
    <=> v121030(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5262,axiom,
    ! [VarCurr: state_type] :
      ( v121075(VarCurr)
    <=> ( v121030(VarCurr,1)
        | v121076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14349,axiom,
    ! [VarCurr: state_type] :
      ( v121076(VarCurr)
    <=> ( v121030(VarCurr,0)
        & v121077(VarCurr) ) ) ).

tff(writeUnaryOperator_7882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121077(VarCurr)
    <=> v121030(VarCurr,1) ) ).

tff(addAssignment_69818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121062(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14348,axiom,
    ! [VarCurr: state_type] :
      ( v121059(VarCurr)
    <=> ( v120605(VarCurr)
        | v120619(VarCurr) ) ) ).

tff(addAssignment_69817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v121057(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14347,axiom,
    ! [VarCurr: state_type] :
      ( v121052(VarCurr)
    <=> ( v121054(VarCurr)
        | v120617(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14346,axiom,
    ! [VarCurr: state_type] :
      ( v121054(VarCurr)
    <=> ( v121055(VarCurr)
        | v120615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14345,axiom,
    ! [VarCurr: state_type] :
      ( v121055(VarCurr)
    <=> ( v120585(VarCurr)
        | v120595(VarCurr) ) ) ).

tff(addAssignment_69816,axiom,
    ! [VarCurr: state_type] :
      ( v121040(VarCurr)
    <=> v121042(VarCurr) ) ).

tff(addAssignment_69815,axiom,
    ! [VarCurr: state_type] :
      ( v121042(VarCurr)
    <=> v120338(VarCurr) ) ).

tff(addAssignment_69814,axiom,
    ! [VarCurr: state_type] :
      ( v121036(VarCurr)
    <=> v121038(VarCurr) ) ).

tff(addAssignment_69813,axiom,
    ! [VarCurr: state_type] :
      ( v121038(VarCurr)
    <=> v120330(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1199,axiom,
    ! [VarCurr: state_type] :
      ( v120967(VarCurr)
    <=> ( ( v120969(VarCurr,1)
        <=> $false )
        & ( v120969(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120969(VarCurr,B)
      <=> v120971(VarCurr,B) ) ) ).

tff(addAssignment_69811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120971(VarCurr,B)
      <=> v120973(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121010(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v120973(VarNext,B)
            <=> v120973(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1572,axiom,
    ! [VarNext: state_type] :
      ( v121010(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120973(VarNext,B)
          <=> v121020(VarNext,B) ) ) ) ).

tff(addAssignment_69810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121020(VarNext,B)
          <=> v121018(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121018(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1115,axiom,
    ! [VarCurr: state_type] :
      ( v121021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v121018(VarCurr,B)
          <=> v120983(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14344,axiom,
    ! [VarCurr: state_type] :
      ( v121021(VarCurr)
    <=> ( v121022(VarCurr)
        & v121023(VarCurr) ) ) ).

tff(writeUnaryOperator_7881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121023(VarCurr)
    <=> v120979(VarCurr) ) ).

tff(writeUnaryOperator_7880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121022(VarCurr)
    <=> v120975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121010(VarNext)
      <=> v121011(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121011(VarNext)
      <=> ( v121012(VarNext)
          & v121005(VarNext) ) ) ) ).

tff(writeUnaryOperator_7879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v121012(VarNext)
      <=> v121014(VarNext) ) ) ).

tff(addAssignment_69809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v121014(VarNext)
      <=> v121005(VarCurr) ) ) ).

tff(addAssignment_69808,axiom,
    ! [VarCurr: state_type] :
      ( v121005(VarCurr)
    <=> v121007(VarCurr) ) ).

tff(addAssignment_69807,axiom,
    ! [VarCurr: state_type] :
      ( v121007(VarCurr)
    <=> v120800(VarCurr) ) ).

tff(addAssignment_69806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120983(VarCurr,B)
      <=> v120985(VarCurr,B) ) ) ).

tff(addAssignment_69805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120985(VarCurr,B)
      <=> v120987(VarCurr,B) ) ) ).

tff(addAssignment_69804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120987(VarCurr,B)
      <=> v120989(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120991(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120989(VarCurr,B)
          <=> v120996(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1114,axiom,
    ! [VarCurr: state_type] :
      ( v120991(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120989(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120967(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120996(VarCurr,B)
          <=> v120997(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1113,axiom,
    ! [VarCurr: state_type] :
      ( v120967(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120996(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69803,axiom,
    ! [VarCurr: state_type] :
      ( v120997(VarCurr,0)
    <=> v121001(VarCurr) ) ).

tff(addAssignment_69802,axiom,
    ! [VarCurr: state_type] :
      ( v120997(VarCurr,1)
    <=> v120999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14341,axiom,
    ! [VarCurr: state_type] :
      ( v120999(VarCurr)
    <=> ( v121000(VarCurr)
        & v121002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14340,axiom,
    ! [VarCurr: state_type] :
      ( v121002(VarCurr)
    <=> ( v120969(VarCurr,0)
        | v121003(VarCurr) ) ) ).

tff(writeUnaryOperator_7878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121003(VarCurr)
    <=> v120969(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5261,axiom,
    ! [VarCurr: state_type] :
      ( v121000(VarCurr)
    <=> ( v121001(VarCurr)
        | v120969(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v121001(VarCurr)
    <=> v120969(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14339,axiom,
    ! [VarCurr: state_type] :
      ( v120991(VarCurr)
    <=> ( v120993(VarCurr)
        | v120994(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5260,axiom,
    ! [VarCurr: state_type] :
      ( v120994(VarCurr)
    <=> ( v120320(VarCurr,1)
        & v120834(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5259,axiom,
    ! [VarCurr: state_type] :
      ( v120993(VarCurr)
    <=> ( v120320(VarCurr,3)
        & v120892(VarCurr) ) ) ).

tff(addAssignment_69801,axiom,
    ! [VarCurr: state_type] :
      ( v120979(VarCurr)
    <=> v120981(VarCurr) ) ).

tff(addAssignment_69800,axiom,
    ! [VarCurr: state_type] :
      ( v120981(VarCurr)
    <=> v120338(VarCurr) ) ).

tff(addAssignment_69799,axiom,
    ! [VarCurr: state_type] :
      ( v120975(VarCurr)
    <=> v120977(VarCurr) ) ).

tff(addAssignment_69798,axiom,
    ! [VarCurr: state_type] :
      ( v120977(VarCurr)
    <=> v120330(VarCurr) ) ).

tff(addAssignment_69797,axiom,
    ! [VarCurr: state_type] :
      ( v120320(VarCurr,1)
    <=> v120322(VarCurr,1) ) ).

tff(addAssignment_69796,axiom,
    ! [VarCurr: state_type] :
      ( v120322(VarCurr,1)
    <=> v120324(VarCurr,1) ) ).

tff(addAssignment_69795,axiom,
    ! [VarNext: state_type] :
      ( v120324(VarNext,1)
    <=> v120959(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120960(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120959(VarNext,B)
            <=> v120324(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1571,axiom,
    ! [VarNext: state_type] :
      ( v120960(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120959(VarNext,B)
          <=> v120885(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120960(VarNext)
      <=> v120961(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120961(VarNext)
      <=> ( v120963(VarNext)
          & v120870(VarNext) ) ) ) ).

tff(writeUnaryOperator_7876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120963(VarNext)
      <=> v120879(VarNext) ) ) ).

tff(addAssignment_69794,axiom,
    ! [VarCurr: state_type] :
      ( v120342(VarCurr,1)
    <=> v120344(VarCurr,1) ) ).

tff(addAssignment_69793,axiom,
    ! [VarCurr: state_type] :
      ( v120344(VarCurr,1)
    <=> v120346(VarCurr,1) ) ).

tff(addAssignment_69792,axiom,
    ! [VarCurr: state_type] :
      ( v120346(VarCurr,1)
    <=> v120868(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_56,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120950(VarCurr)
     => ( v120348(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_85,axiom,
    ! [VarCurr: state_type] :
      ( v120950(VarCurr)
     => ( v120348(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14336,axiom,
    ! [VarCurr: state_type] :
      ( v120950(VarCurr)
    <=> ( v120951(VarCurr)
        | v120952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14335,axiom,
    ! [VarCurr: state_type] :
      ( v120952(VarCurr)
    <=> ( v120953(VarCurr)
        & v120954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14334,axiom,
    ! [VarCurr: state_type] :
      ( v120954(VarCurr)
    <=> ( v120955(VarCurr)
        & v120851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14333,axiom,
    ! [VarCurr: state_type] :
      ( v120955(VarCurr)
    <=> ( v120956(VarCurr)
        & v120957(VarCurr) ) ) ).

tff(writeUnaryOperator_7875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120957(VarCurr)
    <=> v120843(VarCurr) ) ).

tff(writeUnaryOperator_7874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120956(VarCurr)
    <=> v120834(VarCurr) ) ).

tff(writeUnaryOperator_7873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120953(VarCurr)
    <=> v120853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14332,axiom,
    ! [VarCurr: state_type] :
      ( v120951(VarCurr)
    <=> ( v120925(VarCurr)
        & v120853(VarCurr) ) ) ).

tff(writeUnaryOperator_7872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120320(VarCurr,0)
    <=> v120830(VarCurr) ) ).

tff(addAssignment_69791,axiom,
    ! [VarCurr: state_type] :
      ( v120830(VarCurr)
    <=> v120322(VarCurr,0) ) ).

tff(addAssignment_69790,axiom,
    ! [VarCurr: state_type] :
      ( v120322(VarCurr,0)
    <=> v120324(VarCurr,0) ) ).

tff(addAssignment_69789,axiom,
    ! [VarNext: state_type] :
      ( v120324(VarNext,0)
    <=> v120941(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120942(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120941(VarNext,B)
            <=> v120324(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1570,axiom,
    ! [VarNext: state_type] :
      ( v120942(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120941(VarNext,B)
          <=> v120885(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120942(VarNext)
      <=> v120943(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120943(VarNext)
      <=> ( v120945(VarNext)
          & v120870(VarNext) ) ) ) ).

tff(writeUnaryOperator_7871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120945(VarNext)
      <=> v120879(VarNext) ) ) ).

tff(addAssignment_69788,axiom,
    ! [VarCurr: state_type] :
      ( v120342(VarCurr,0)
    <=> v120344(VarCurr,0) ) ).

tff(addAssignment_69787,axiom,
    ! [VarCurr: state_type] :
      ( v120344(VarCurr,0)
    <=> v120346(VarCurr,0) ) ).

tff(addAssignment_69786,axiom,
    ! [VarCurr: state_type] :
      ( v120346(VarCurr,0)
    <=> v120868(VarCurr,0) ) ).

tff(writeUnaryOperator_7870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120832(VarCurr)
    <=> v120348(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120920(VarCurr)
     => ( v120348(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1112,axiom,
    ! [VarCurr: state_type] :
      ( v120920(VarCurr)
     => ( v120348(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14329,axiom,
    ! [VarCurr: state_type] :
      ( v120920(VarCurr)
    <=> ( v120921(VarCurr)
        | v120934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14328,axiom,
    ! [VarCurr: state_type] :
      ( v120934(VarCurr)
    <=> ( v120935(VarCurr)
        & v120938(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14327,axiom,
    ! [VarCurr: state_type] :
      ( v120938(VarCurr)
    <=> ( v120906(VarCurr)
        & v120909(VarCurr) ) ) ).

tff(writeUnaryOperator_7869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120935(VarCurr)
    <=> v120936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14326,axiom,
    ! [VarCurr: state_type] :
      ( v120936(VarCurr)
    <=> ( v120937(VarCurr)
        | v120866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14325,axiom,
    ! [VarCurr: state_type] :
      ( v120937(VarCurr)
    <=> ( v120853(VarCurr)
        | v120851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14324,axiom,
    ! [VarCurr: state_type] :
      ( v120921(VarCurr)
    <=> ( v120922(VarCurr)
        | v120930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14323,axiom,
    ! [VarCurr: state_type] :
      ( v120930(VarCurr)
    <=> ( v120931(VarCurr)
        & v120933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14322,axiom,
    ! [VarCurr: state_type] :
      ( v120933(VarCurr)
    <=> ( v120864(VarCurr)
        & v120866(VarCurr) ) ) ).

tff(writeUnaryOperator_7868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120931(VarCurr)
    <=> v120932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14321,axiom,
    ! [VarCurr: state_type] :
      ( v120932(VarCurr)
    <=> ( v120853(VarCurr)
        | v120851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14320,axiom,
    ! [VarCurr: state_type] :
      ( v120922(VarCurr)
    <=> ( v120923(VarCurr)
        | v120927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14319,axiom,
    ! [VarCurr: state_type] :
      ( v120927(VarCurr)
    <=> ( v120928(VarCurr)
        & v120929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14318,axiom,
    ! [VarCurr: state_type] :
      ( v120929(VarCurr)
    <=> ( v120843(VarCurr)
        & v120851(VarCurr) ) ) ).

tff(writeUnaryOperator_7867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120928(VarCurr)
    <=> v120853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14317,axiom,
    ! [VarCurr: state_type] :
      ( v120923(VarCurr)
    <=> ( v120924(VarCurr)
        & v120853(VarCurr) ) ) ).

tff(writeUnaryOperator_7866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120924(VarCurr)
    <=> v120925(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14316,axiom,
    ! [VarCurr: state_type] :
      ( v120925(VarCurr)
    <=> ( v120926(VarCurr)
        & v120827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14315,axiom,
    ! [VarCurr: state_type] :
      ( v120926(VarCurr)
    <=> ( v120350(VarCurr)
        & v120825(VarCurr) ) ) ).

tff(addAssignment_69785,axiom,
    ! [VarCurr: state_type] :
      ( v120320(VarCurr,3)
    <=> v120322(VarCurr,3) ) ).

tff(addAssignment_69784,axiom,
    ! [VarCurr: state_type] :
      ( v120322(VarCurr,3)
    <=> v120324(VarCurr,3) ) ).

tff(addAssignment_69783,axiom,
    ! [VarNext: state_type] :
      ( v120324(VarNext,3)
    <=> v120912(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120913(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120912(VarNext,B)
            <=> v120324(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1569,axiom,
    ! [VarNext: state_type] :
      ( v120913(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120912(VarNext,B)
          <=> v120885(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120913(VarNext)
      <=> v120914(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120914(VarNext)
      <=> ( v120916(VarNext)
          & v120870(VarNext) ) ) ) ).

tff(writeUnaryOperator_7865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120916(VarNext)
      <=> v120879(VarNext) ) ) ).

tff(addAssignment_69782,axiom,
    ! [VarCurr: state_type] :
      ( v120342(VarCurr,3)
    <=> v120344(VarCurr,3) ) ).

tff(addAssignment_69781,axiom,
    ! [VarCurr: state_type] :
      ( v120344(VarCurr,3)
    <=> v120346(VarCurr,3) ) ).

tff(addAssignment_69780,axiom,
    ! [VarCurr: state_type] :
      ( v120346(VarCurr,3)
    <=> v120868(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_55,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120894(VarCurr)
     => ( v120348(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_84,axiom,
    ! [VarCurr: state_type] :
      ( v120894(VarCurr)
     => ( v120348(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14312,axiom,
    ! [VarCurr: state_type] :
      ( v120894(VarCurr)
    <=> ( v120895(VarCurr)
        | v120901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14311,axiom,
    ! [VarCurr: state_type] :
      ( v120901(VarCurr)
    <=> ( v120902(VarCurr)
        & v120903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14310,axiom,
    ! [VarCurr: state_type] :
      ( v120903(VarCurr)
    <=> ( v120904(VarCurr)
        & v120910(VarCurr) ) ) ).

tff(writeUnaryOperator_7864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120910(VarCurr)
    <=> v120900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14309,axiom,
    ! [VarCurr: state_type] :
      ( v120904(VarCurr)
    <=> ( v120905(VarCurr)
        & v120909(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1198,axiom,
    ! [VarCurr: state_type] :
      ( v120909(VarCurr)
    <=> ( $true
      <=> v120320(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120905(VarCurr)
    <=> v120906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14308,axiom,
    ! [VarCurr: state_type] :
      ( v120906(VarCurr)
    <=> ( v120907(VarCurr)
        | v120836(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14307,axiom,
    ! [VarCurr: state_type] :
      ( v120907(VarCurr)
    <=> ( v120908(VarCurr)
        | v120892(VarCurr) ) ) ).

tff(writeUnaryOperator_7862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120908(VarCurr)
    <=> v120825(VarCurr) ) ).

tff(writeUnaryOperator_7861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120902(VarCurr)
    <=> v120866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14306,axiom,
    ! [VarCurr: state_type] :
      ( v120895(VarCurr)
    <=> ( v120896(VarCurr)
        & v120899(VarCurr) ) ) ).

tff(writeUnaryOperator_7860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120899(VarCurr)
    <=> v120900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14305,axiom,
    ! [VarCurr: state_type] :
      ( v120900(VarCurr)
    <=> ( v120853(VarCurr)
        | v120851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14304,axiom,
    ! [VarCurr: state_type] :
      ( v120896(VarCurr)
    <=> ( v120897(VarCurr)
        & v120866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14303,axiom,
    ! [VarCurr: state_type] :
      ( v120897(VarCurr)
    <=> ( v120860(VarCurr)
        & v120898(VarCurr) ) ) ).

tff(writeUnaryOperator_7859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120898(VarCurr)
    <=> v120864(VarCurr) ) ).

tff(addAssignment_69779,axiom,
    ! [VarCurr: state_type] :
      ( v120892(VarCurr)
    <=> v112831(VarCurr,8) ) ).

tff(addAssignment_69778,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,8)
    <=> v112865(VarCurr,8) ) ).

tff(addAssignment_69777,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,8)
    <=> v112849(VarCurr,8) ) ).

tff(addAssignment_69776,axiom,
    ! [VarCurr: state_type] :
      ( v120320(VarCurr,2)
    <=> v120322(VarCurr,2) ) ).

tff(addAssignment_69775,axiom,
    ! [VarCurr: state_type] :
      ( v120322(VarCurr,2)
    <=> v120324(VarCurr,2) ) ).

tff(addAssignment_69774,axiom,
    ! [VarNext: state_type] :
      ( v120324(VarNext,2)
    <=> v120874(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120875(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120874(VarNext,B)
            <=> v120324(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1568,axiom,
    ! [VarNext: state_type] :
      ( v120875(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120874(VarNext,B)
          <=> v120885(VarNext,B) ) ) ) ).

tff(addAssignment_69773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120885(VarNext,B)
          <=> v120883(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120886(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120883(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1111,axiom,
    ! [VarCurr: state_type] :
      ( v120886(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120883(VarCurr,B)
          <=> v120342(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14302,axiom,
    ! [VarCurr: state_type] :
      ( v120886(VarCurr)
    <=> ( v120887(VarCurr)
        & v120888(VarCurr) ) ) ).

tff(writeUnaryOperator_7858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120888(VarCurr)
    <=> v120334(VarCurr) ) ).

tff(writeUnaryOperator_7857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120887(VarCurr)
    <=> v120326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120875(VarNext)
      <=> v120876(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120876(VarNext)
      <=> ( v120877(VarNext)
          & v120870(VarNext) ) ) ) ).

tff(writeUnaryOperator_7856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120877(VarNext)
      <=> v120879(VarNext) ) ) ).

tff(addAssignment_69772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120879(VarNext)
      <=> v120870(VarCurr) ) ) ).

tff(addAssignment_69771,axiom,
    ! [VarCurr: state_type] :
      ( v120870(VarCurr)
    <=> v120872(VarCurr) ) ).

tff(addAssignment_69770,axiom,
    ! [VarCurr: state_type] :
      ( v120872(VarCurr)
    <=> v120800(VarCurr) ) ).

tff(addAssignment_69769,axiom,
    ! [VarCurr: state_type] :
      ( v120342(VarCurr,2)
    <=> v120344(VarCurr,2) ) ).

tff(addAssignment_69768,axiom,
    ! [VarCurr: state_type] :
      ( v120344(VarCurr,2)
    <=> v120346(VarCurr,2) ) ).

tff(addAssignment_69767,axiom,
    ! [VarCurr: state_type] :
      ( v120346(VarCurr,2)
    <=> v120868(VarCurr,2) ) ).

tff(addAssignment_69766,axiom,
    ! [VarCurr: state_type] :
      ( v120868(VarCurr,0)
    <=> v120832(VarCurr) ) ).

tff(addAssignment_69765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v120868(VarCurr,B)
      <=> v120348(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_54,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120838(VarCurr)
     => ( v120348(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_83,axiom,
    ! [VarCurr: state_type] :
      ( v120838(VarCurr)
     => ( v120348(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14299,axiom,
    ! [VarCurr: state_type] :
      ( v120838(VarCurr)
    <=> ( v120839(VarCurr)
        | v120854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14298,axiom,
    ! [VarCurr: state_type] :
      ( v120854(VarCurr)
    <=> ( v120855(VarCurr)
        & v120856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14297,axiom,
    ! [VarCurr: state_type] :
      ( v120856(VarCurr)
    <=> ( v120857(VarCurr)
        & v120867(VarCurr) ) ) ).

tff(writeUnaryOperator_7855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120867(VarCurr)
    <=> v120853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14296,axiom,
    ! [VarCurr: state_type] :
      ( v120857(VarCurr)
    <=> ( v120858(VarCurr)
        & v120866(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1197,axiom,
    ! [VarCurr: state_type] :
      ( v120866(VarCurr)
    <=> ( $true
      <=> v120320(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14295,axiom,
    ! [VarCurr: state_type] :
      ( v120858(VarCurr)
    <=> ( v120859(VarCurr)
        & v120863(VarCurr) ) ) ).

tff(writeUnaryOperator_7854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120863(VarCurr)
    <=> v120864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14294,axiom,
    ! [VarCurr: state_type] :
      ( v120864(VarCurr)
    <=> ( v120865(VarCurr)
        | v120836(VarCurr) ) ) ).

tff(writeUnaryOperator_7853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120865(VarCurr)
    <=> v120825(VarCurr) ) ).

tff(writeUnaryOperator_7852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120859(VarCurr)
    <=> v120860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14293,axiom,
    ! [VarCurr: state_type] :
      ( v120860(VarCurr)
    <=> ( v120861(VarCurr)
        | v120862(VarCurr) ) ) ).

tff(writeUnaryOperator_7851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120862(VarCurr)
    <=> v120827(VarCurr) ) ).

tff(writeUnaryOperator_7850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120861(VarCurr)
    <=> v120350(VarCurr) ) ).

tff(writeUnaryOperator_7849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120855(VarCurr)
    <=> v120851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14292,axiom,
    ! [VarCurr: state_type] :
      ( v120839(VarCurr)
    <=> ( v120840(VarCurr)
        & v120852(VarCurr) ) ) ).

tff(writeUnaryOperator_7848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120852(VarCurr)
    <=> v120853(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1196,axiom,
    ! [VarCurr: state_type] :
      ( v120853(VarCurr)
    <=> ( $true
      <=> v120320(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14291,axiom,
    ! [VarCurr: state_type] :
      ( v120840(VarCurr)
    <=> ( v120841(VarCurr)
        & v120851(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1195,axiom,
    ! [VarCurr: state_type] :
      ( v120851(VarCurr)
    <=> ( $true
      <=> v120320(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14290,axiom,
    ! [VarCurr: state_type] :
      ( v120841(VarCurr)
    <=> ( v120834(VarCurr)
        & v120842(VarCurr) ) ) ).

tff(writeUnaryOperator_7847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120842(VarCurr)
    <=> v120843(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14289,axiom,
    ! [VarCurr: state_type] :
      ( v120843(VarCurr)
    <=> ( v120844(VarCurr)
        | v120836(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14288,axiom,
    ! [VarCurr: state_type] :
      ( v120844(VarCurr)
    <=> ( v120845(VarCurr)
        | v120848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14287,axiom,
    ! [VarCurr: state_type] :
      ( v120848(VarCurr)
    <=> ( v120849(VarCurr)
        & v120850(VarCurr) ) ) ).

tff(writeUnaryOperator_7846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120850(VarCurr)
    <=> v120834(VarCurr) ) ).

tff(writeUnaryOperator_7845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120849(VarCurr)
    <=> v120350(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14286,axiom,
    ! [VarCurr: state_type] :
      ( v120845(VarCurr)
    <=> ( v120846(VarCurr)
        | v120847(VarCurr) ) ) ).

tff(writeUnaryOperator_7844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120847(VarCurr)
    <=> v120827(VarCurr) ) ).

tff(writeUnaryOperator_7843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120846(VarCurr)
    <=> v120825(VarCurr) ) ).

tff(addAssignment_69764,axiom,
    ! [VarCurr: state_type] :
      ( v120836(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_69763,axiom,
    ! [VarCurr: state_type] :
      ( v120834(VarCurr)
    <=> v112643(VarCurr,8) ) ).

tff(addAssignment_69762,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,8)
    <=> v115202(VarCurr,8) ) ).

tff(addAssignment_69761,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,8)
    <=> v115186(VarCurr,8) ) ).

tff(addAssignment_69760,axiom,
    ! [VarCurr: state_type] :
      ( v120827(VarCurr)
    <=> v112528(VarCurr,8) ) ).

tff(addAssignment_69759,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,8)
    <=> v120828(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v120828(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1110,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v120828(VarCurr,B)
          <=> v112530(VarCurr,B) ) ) ) ).

tff(addAssignment_69758,axiom,
    ! [VarCurr: state_type] :
      ( v120825(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14285,axiom,
    ! [VarCurr: state_type] :
      ( v120350(VarCurr)
    <=> ( v120822(VarCurr)
        & v120823(VarCurr) ) ) ).

tff(writeUnaryOperator_7842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120823(VarCurr)
    <=> v120820(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1194,axiom,
    ! [VarCurr: state_type] :
      ( v120822(VarCurr)
    <=> ( ( v120352(VarCurr,5)
        <=> $false )
        & ( v120352(VarCurr,4)
        <=> $false )
        & ( v120352(VarCurr,3)
        <=> $false )
        & ( v120352(VarCurr,2)
        <=> $false )
        & ( v120352(VarCurr,1)
        <=> $false )
        & ( v120352(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69757,axiom,
    ! [VarCurr: state_type] :
      ( v120820(VarCurr)
    <=> v115139(VarCurr,8) ) ).

tff(addAssignment_69756,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,8)
    <=> v115159(VarCurr,8) ) ).

tff(addAssignment_69755,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,8)
    <=> v115142(VarCurr,8) ) ).

tff(addAssignment_69754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v120352(VarCurr,B)
      <=> v120354(VarCurr,B) ) ) ).

tff(addAssignment_69753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v120354(VarCurr,B)
      <=> v120356(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120803(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v120356(VarNext,B)
            <=> v120356(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1567,axiom,
    ! [VarNext: state_type] :
      ( v120803(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120356(VarNext,B)
          <=> v120813(VarNext,B) ) ) ) ).

tff(addAssignment_69752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120813(VarNext,B)
          <=> v120811(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120814(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120811(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1109,axiom,
    ! [VarCurr: state_type] :
      ( v120814(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120811(VarCurr,B)
          <=> v120366(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14284,axiom,
    ! [VarCurr: state_type] :
      ( v120814(VarCurr)
    <=> ( v120815(VarCurr)
        & v120816(VarCurr) ) ) ).

tff(writeUnaryOperator_7841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120816(VarCurr)
    <=> v120362(VarCurr) ) ).

tff(writeUnaryOperator_7840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120815(VarCurr)
    <=> v120358(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120803(VarNext)
      <=> v120804(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120804(VarNext)
      <=> ( v120805(VarNext)
          & v120796(VarNext) ) ) ) ).

tff(writeUnaryOperator_7839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120805(VarNext)
      <=> v120807(VarNext) ) ) ).

tff(addAssignment_69751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120807(VarNext)
      <=> v120796(VarCurr) ) ) ).

tff(addAssignment_69750,axiom,
    ! [VarCurr: state_type] :
      ( v120796(VarCurr)
    <=> v120798(VarCurr) ) ).

tff(addAssignment_69749,axiom,
    ! [VarCurr: state_type] :
      ( v120798(VarCurr)
    <=> v120800(VarCurr) ) ).

tff(addAssignment_69748,axiom,
    ! [VarCurr: state_type] :
      ( v120800(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_69747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v120366(VarCurr,B)
      <=> v120368(VarCurr,B) ) ) ).

tff(addAssignment_69746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v120368(VarCurr,B)
      <=> v120370(VarCurr,B) ) ) ).

tff(addAssignment_69745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v120370(VarCurr,B)
      <=> v120372(VarCurr,B) ) ) ).

tff(addAssignment_69744,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,0)
    <=> v120791(VarCurr) ) ).

tff(addAssignment_69743,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,1)
    <=> v120786(VarCurr) ) ).

tff(addAssignment_69742,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,2)
    <=> v120781(VarCurr) ) ).

tff(addAssignment_69741,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,3)
    <=> v120776(VarCurr) ) ).

tff(addAssignment_69740,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,4)
    <=> v120771(VarCurr) ) ).

tff(addAssignment_69739,axiom,
    ! [VarCurr: state_type] :
      ( v120372(VarCurr,5)
    <=> v120628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14281,axiom,
    ! [VarCurr: state_type] :
      ( v120791(VarCurr)
    <=> ( v120792(VarCurr)
        & v120794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14280,axiom,
    ! [VarCurr: state_type] :
      ( v120794(VarCurr)
    <=> ( v120583(VarCurr,0)
        | v120640(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14279,axiom,
    ! [VarCurr: state_type] :
      ( v120792(VarCurr)
    <=> ( v120717(VarCurr)
        | v120793(VarCurr) ) ) ).

tff(writeUnaryOperator_7838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120793(VarCurr)
    <=> v120640(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14278,axiom,
    ! [VarCurr: state_type] :
      ( v120786(VarCurr)
    <=> ( v120787(VarCurr)
        & v120790(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14277,axiom,
    ! [VarCurr: state_type] :
      ( v120790(VarCurr)
    <=> ( v120639(VarCurr)
        | v120711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14276,axiom,
    ! [VarCurr: state_type] :
      ( v120787(VarCurr)
    <=> ( v120788(VarCurr)
        | v120789(VarCurr) ) ) ).

tff(writeUnaryOperator_7837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120789(VarCurr)
    <=> v120711(VarCurr) ) ).

tff(writeUnaryOperator_7836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120788(VarCurr)
    <=> v120639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14275,axiom,
    ! [VarCurr: state_type] :
      ( v120781(VarCurr)
    <=> ( v120782(VarCurr)
        & v120785(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14274,axiom,
    ! [VarCurr: state_type] :
      ( v120785(VarCurr)
    <=> ( v120637(VarCurr)
        | v120722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14273,axiom,
    ! [VarCurr: state_type] :
      ( v120782(VarCurr)
    <=> ( v120783(VarCurr)
        | v120784(VarCurr) ) ) ).

tff(writeUnaryOperator_7835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120784(VarCurr)
    <=> v120722(VarCurr) ) ).

tff(writeUnaryOperator_7834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120783(VarCurr)
    <=> v120637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14272,axiom,
    ! [VarCurr: state_type] :
      ( v120776(VarCurr)
    <=> ( v120777(VarCurr)
        & v120780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14271,axiom,
    ! [VarCurr: state_type] :
      ( v120780(VarCurr)
    <=> ( v120635(VarCurr)
        | v120734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14270,axiom,
    ! [VarCurr: state_type] :
      ( v120777(VarCurr)
    <=> ( v120778(VarCurr)
        | v120779(VarCurr) ) ) ).

tff(writeUnaryOperator_7833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120779(VarCurr)
    <=> v120734(VarCurr) ) ).

tff(writeUnaryOperator_7832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120778(VarCurr)
    <=> v120635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14269,axiom,
    ! [VarCurr: state_type] :
      ( v120771(VarCurr)
    <=> ( v120772(VarCurr)
        & v120775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14268,axiom,
    ! [VarCurr: state_type] :
      ( v120775(VarCurr)
    <=> ( v120633(VarCurr)
        | v120746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14267,axiom,
    ! [VarCurr: state_type] :
      ( v120772(VarCurr)
    <=> ( v120773(VarCurr)
        | v120774(VarCurr) ) ) ).

tff(writeUnaryOperator_7831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120774(VarCurr)
    <=> v120746(VarCurr) ) ).

tff(writeUnaryOperator_7830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120773(VarCurr)
    <=> v120633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14266,axiom,
    ! [VarCurr: state_type] :
      ( v120628(VarCurr)
    <=> ( v120629(VarCurr)
        & v120770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14265,axiom,
    ! [VarCurr: state_type] :
      ( v120770(VarCurr)
    <=> ( v120631(VarCurr)
        | v120759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14264,axiom,
    ! [VarCurr: state_type] :
      ( v120629(VarCurr)
    <=> ( v120630(VarCurr)
        | v120758(VarCurr) ) ) ).

tff(writeUnaryOperator_7829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120758(VarCurr)
    <=> v120759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14263,axiom,
    ! [VarCurr: state_type] :
      ( v120759(VarCurr)
    <=> ( v120760(VarCurr)
        & v120769(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5258,axiom,
    ! [VarCurr: state_type] :
      ( v120769(VarCurr)
    <=> ( v120762(VarCurr)
        | v120640(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14262,axiom,
    ! [VarCurr: state_type] :
      ( v120760(VarCurr)
    <=> ( v120761(VarCurr)
        | v120768(VarCurr) ) ) ).

tff(writeUnaryOperator_7828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120768(VarCurr)
    <=> v120640(VarCurr,5) ) ).

tff(writeUnaryOperator_7827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120761(VarCurr)
    <=> v120762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14261,axiom,
    ! [VarCurr: state_type] :
      ( v120762(VarCurr)
    <=> ( v120763(VarCurr)
        & v120766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14260,axiom,
    ! [VarCurr: state_type] :
      ( v120766(VarCurr)
    <=> ( v120765(VarCurr)
        | v120767(VarCurr) ) ) ).

tff(writeUnaryOperator_7826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120767(VarCurr)
    <=> v120583(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5257,axiom,
    ! [VarCurr: state_type] :
      ( v120763(VarCurr)
    <=> ( v120764(VarCurr)
        | v120583(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120764(VarCurr)
    <=> v120765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14259,axiom,
    ! [VarCurr: state_type] :
      ( v120765(VarCurr)
    <=> ( v120752(VarCurr)
        & v120754(VarCurr) ) ) ).

tff(writeUnaryOperator_7824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120630(VarCurr)
    <=> v120631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14258,axiom,
    ! [VarCurr: state_type] :
      ( v120631(VarCurr)
    <=> ( v120632(VarCurr)
        | v120757(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5256,axiom,
    ! [VarCurr: state_type] :
      ( v120757(VarCurr)
    <=> ( v120749(VarCurr)
        & v120640(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14257,axiom,
    ! [VarCurr: state_type] :
      ( v120632(VarCurr)
    <=> ( v120633(VarCurr)
        & v120746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14256,axiom,
    ! [VarCurr: state_type] :
      ( v120746(VarCurr)
    <=> ( v120747(VarCurr)
        & v120756(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5255,axiom,
    ! [VarCurr: state_type] :
      ( v120756(VarCurr)
    <=> ( v120749(VarCurr)
        | v120640(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14255,axiom,
    ! [VarCurr: state_type] :
      ( v120747(VarCurr)
    <=> ( v120748(VarCurr)
        | v120755(VarCurr) ) ) ).

tff(writeUnaryOperator_7823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120755(VarCurr)
    <=> v120640(VarCurr,4) ) ).

tff(writeUnaryOperator_7822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120748(VarCurr)
    <=> v120749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14254,axiom,
    ! [VarCurr: state_type] :
      ( v120749(VarCurr)
    <=> ( v120750(VarCurr)
        & v120753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14253,axiom,
    ! [VarCurr: state_type] :
      ( v120753(VarCurr)
    <=> ( v120752(VarCurr)
        | v120754(VarCurr) ) ) ).

tff(writeUnaryOperator_7821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120754(VarCurr)
    <=> v120583(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5254,axiom,
    ! [VarCurr: state_type] :
      ( v120750(VarCurr)
    <=> ( v120751(VarCurr)
        | v120583(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120751(VarCurr)
    <=> v120752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14252,axiom,
    ! [VarCurr: state_type] :
      ( v120752(VarCurr)
    <=> ( v120740(VarCurr)
        & v120742(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14251,axiom,
    ! [VarCurr: state_type] :
      ( v120633(VarCurr)
    <=> ( v120634(VarCurr)
        | v120745(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5253,axiom,
    ! [VarCurr: state_type] :
      ( v120745(VarCurr)
    <=> ( v120737(VarCurr)
        & v120640(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14250,axiom,
    ! [VarCurr: state_type] :
      ( v120634(VarCurr)
    <=> ( v120635(VarCurr)
        & v120734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14249,axiom,
    ! [VarCurr: state_type] :
      ( v120734(VarCurr)
    <=> ( v120735(VarCurr)
        & v120744(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5252,axiom,
    ! [VarCurr: state_type] :
      ( v120744(VarCurr)
    <=> ( v120737(VarCurr)
        | v120640(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14248,axiom,
    ! [VarCurr: state_type] :
      ( v120735(VarCurr)
    <=> ( v120736(VarCurr)
        | v120743(VarCurr) ) ) ).

tff(writeUnaryOperator_7819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120743(VarCurr)
    <=> v120640(VarCurr,3) ) ).

tff(writeUnaryOperator_7818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120736(VarCurr)
    <=> v120737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14247,axiom,
    ! [VarCurr: state_type] :
      ( v120737(VarCurr)
    <=> ( v120738(VarCurr)
        & v120741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14246,axiom,
    ! [VarCurr: state_type] :
      ( v120741(VarCurr)
    <=> ( v120740(VarCurr)
        | v120742(VarCurr) ) ) ).

tff(writeUnaryOperator_7817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120742(VarCurr)
    <=> v120583(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5251,axiom,
    ! [VarCurr: state_type] :
      ( v120738(VarCurr)
    <=> ( v120739(VarCurr)
        | v120583(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120739(VarCurr)
    <=> v120740(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14245,axiom,
    ! [VarCurr: state_type] :
      ( v120740(VarCurr)
    <=> ( v120728(VarCurr)
        & v120730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14244,axiom,
    ! [VarCurr: state_type] :
      ( v120635(VarCurr)
    <=> ( v120636(VarCurr)
        | v120733(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5250,axiom,
    ! [VarCurr: state_type] :
      ( v120733(VarCurr)
    <=> ( v120725(VarCurr)
        & v120640(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14243,axiom,
    ! [VarCurr: state_type] :
      ( v120636(VarCurr)
    <=> ( v120637(VarCurr)
        & v120722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14242,axiom,
    ! [VarCurr: state_type] :
      ( v120722(VarCurr)
    <=> ( v120723(VarCurr)
        & v120732(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5249,axiom,
    ! [VarCurr: state_type] :
      ( v120732(VarCurr)
    <=> ( v120725(VarCurr)
        | v120640(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14241,axiom,
    ! [VarCurr: state_type] :
      ( v120723(VarCurr)
    <=> ( v120724(VarCurr)
        | v120731(VarCurr) ) ) ).

tff(writeUnaryOperator_7815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120731(VarCurr)
    <=> v120640(VarCurr,2) ) ).

tff(writeUnaryOperator_7814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120724(VarCurr)
    <=> v120725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14240,axiom,
    ! [VarCurr: state_type] :
      ( v120725(VarCurr)
    <=> ( v120726(VarCurr)
        & v120729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14239,axiom,
    ! [VarCurr: state_type] :
      ( v120729(VarCurr)
    <=> ( v120728(VarCurr)
        | v120730(VarCurr) ) ) ).

tff(writeUnaryOperator_7813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120730(VarCurr)
    <=> v120583(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5248,axiom,
    ! [VarCurr: state_type] :
      ( v120726(VarCurr)
    <=> ( v120727(VarCurr)
        | v120583(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120727(VarCurr)
    <=> v120728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14238,axiom,
    ! [VarCurr: state_type] :
      ( v120728(VarCurr)
    <=> ( v120717(VarCurr)
        & v120718(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14237,axiom,
    ! [VarCurr: state_type] :
      ( v120637(VarCurr)
    <=> ( v120638(VarCurr)
        | v120721(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5247,axiom,
    ! [VarCurr: state_type] :
      ( v120721(VarCurr)
    <=> ( v120714(VarCurr)
        & v120640(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14236,axiom,
    ! [VarCurr: state_type] :
      ( v120638(VarCurr)
    <=> ( v120639(VarCurr)
        & v120711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14235,axiom,
    ! [VarCurr: state_type] :
      ( v120711(VarCurr)
    <=> ( v120712(VarCurr)
        & v120720(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5246,axiom,
    ! [VarCurr: state_type] :
      ( v120720(VarCurr)
    <=> ( v120714(VarCurr)
        | v120640(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14234,axiom,
    ! [VarCurr: state_type] :
      ( v120712(VarCurr)
    <=> ( v120713(VarCurr)
        | v120719(VarCurr) ) ) ).

tff(writeUnaryOperator_7811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120719(VarCurr)
    <=> v120640(VarCurr,1) ) ).

tff(writeUnaryOperator_7810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120713(VarCurr)
    <=> v120714(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14233,axiom,
    ! [VarCurr: state_type] :
      ( v120714(VarCurr)
    <=> ( v120715(VarCurr)
        & v120716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14232,axiom,
    ! [VarCurr: state_type] :
      ( v120716(VarCurr)
    <=> ( v120717(VarCurr)
        | v120718(VarCurr) ) ) ).

tff(writeUnaryOperator_7809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120718(VarCurr)
    <=> v120583(VarCurr,1) ) ).

tff(writeUnaryOperator_7808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120717(VarCurr)
    <=> v120583(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5245,axiom,
    ! [VarCurr: state_type] :
      ( v120715(VarCurr)
    <=> ( v120583(VarCurr,0)
        | v120583(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14231,axiom,
    ! [VarCurr: state_type] :
      ( v120639(VarCurr)
    <=> ( v120583(VarCurr,0)
        & v120640(VarCurr,0) ) ) ).

tff(addAssignment_69738,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,0)
    <=> v120706(VarCurr) ) ).

tff(addAssignment_69737,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,1)
    <=> v120701(VarCurr) ) ).

tff(addAssignment_69736,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,2)
    <=> v120696(VarCurr) ) ).

tff(addAssignment_69735,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,3)
    <=> v120691(VarCurr) ) ).

tff(addAssignment_69734,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,4)
    <=> v120686(VarCurr) ) ).

tff(addAssignment_69733,axiom,
    ! [VarCurr: state_type] :
      ( v120640(VarCurr,5)
    <=> v120642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14230,axiom,
    ! [VarCurr: state_type] :
      ( v120706(VarCurr)
    <=> ( v120707(VarCurr)
        & v120710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14229,axiom,
    ! [VarCurr: state_type] :
      ( v120710(VarCurr)
    <=> ( v120352(VarCurr,0)
        | v120654(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14228,axiom,
    ! [VarCurr: state_type] :
      ( v120707(VarCurr)
    <=> ( v120708(VarCurr)
        | v120709(VarCurr) ) ) ).

tff(writeUnaryOperator_7807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120709(VarCurr)
    <=> v120654(VarCurr,0) ) ).

tff(writeUnaryOperator_7806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120708(VarCurr)
    <=> v120352(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14227,axiom,
    ! [VarCurr: state_type] :
      ( v120701(VarCurr)
    <=> ( v120702(VarCurr)
        & v120705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14226,axiom,
    ! [VarCurr: state_type] :
      ( v120705(VarCurr)
    <=> ( v120653(VarCurr)
        | v120655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14225,axiom,
    ! [VarCurr: state_type] :
      ( v120702(VarCurr)
    <=> ( v120703(VarCurr)
        | v120704(VarCurr) ) ) ).

tff(writeUnaryOperator_7805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120704(VarCurr)
    <=> v120655(VarCurr) ) ).

tff(writeUnaryOperator_7804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120703(VarCurr)
    <=> v120653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14224,axiom,
    ! [VarCurr: state_type] :
      ( v120696(VarCurr)
    <=> ( v120697(VarCurr)
        & v120700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14223,axiom,
    ! [VarCurr: state_type] :
      ( v120700(VarCurr)
    <=> ( v120651(VarCurr)
        | v120661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14222,axiom,
    ! [VarCurr: state_type] :
      ( v120697(VarCurr)
    <=> ( v120698(VarCurr)
        | v120699(VarCurr) ) ) ).

tff(writeUnaryOperator_7803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120699(VarCurr)
    <=> v120661(VarCurr) ) ).

tff(writeUnaryOperator_7802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120698(VarCurr)
    <=> v120651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14221,axiom,
    ! [VarCurr: state_type] :
      ( v120691(VarCurr)
    <=> ( v120692(VarCurr)
        & v120695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14220,axiom,
    ! [VarCurr: state_type] :
      ( v120695(VarCurr)
    <=> ( v120649(VarCurr)
        | v120667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14219,axiom,
    ! [VarCurr: state_type] :
      ( v120692(VarCurr)
    <=> ( v120693(VarCurr)
        | v120694(VarCurr) ) ) ).

tff(writeUnaryOperator_7801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120694(VarCurr)
    <=> v120667(VarCurr) ) ).

tff(writeUnaryOperator_7800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120693(VarCurr)
    <=> v120649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14218,axiom,
    ! [VarCurr: state_type] :
      ( v120686(VarCurr)
    <=> ( v120687(VarCurr)
        & v120690(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14217,axiom,
    ! [VarCurr: state_type] :
      ( v120690(VarCurr)
    <=> ( v120647(VarCurr)
        | v120673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14216,axiom,
    ! [VarCurr: state_type] :
      ( v120687(VarCurr)
    <=> ( v120688(VarCurr)
        | v120689(VarCurr) ) ) ).

tff(writeUnaryOperator_7799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120689(VarCurr)
    <=> v120673(VarCurr) ) ).

tff(writeUnaryOperator_7798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120688(VarCurr)
    <=> v120647(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14215,axiom,
    ! [VarCurr: state_type] :
      ( v120642(VarCurr)
    <=> ( v120643(VarCurr)
        & v120685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14214,axiom,
    ! [VarCurr: state_type] :
      ( v120685(VarCurr)
    <=> ( v120645(VarCurr)
        | v120680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14213,axiom,
    ! [VarCurr: state_type] :
      ( v120643(VarCurr)
    <=> ( v120644(VarCurr)
        | v120679(VarCurr) ) ) ).

tff(writeUnaryOperator_7797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120679(VarCurr)
    <=> v120680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14212,axiom,
    ! [VarCurr: state_type] :
      ( v120680(VarCurr)
    <=> ( v120681(VarCurr)
        & v120684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5244,axiom,
    ! [VarCurr: state_type] :
      ( v120684(VarCurr)
    <=> ( v120352(VarCurr,5)
        | v120654(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14211,axiom,
    ! [VarCurr: state_type] :
      ( v120681(VarCurr)
    <=> ( v120682(VarCurr)
        | v120683(VarCurr) ) ) ).

tff(writeUnaryOperator_7796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120683(VarCurr)
    <=> v120654(VarCurr,5) ) ).

tff(writeUnaryOperator_7795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120682(VarCurr)
    <=> v120352(VarCurr,5) ) ).

tff(writeUnaryOperator_7794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120644(VarCurr)
    <=> v120645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14210,axiom,
    ! [VarCurr: state_type] :
      ( v120645(VarCurr)
    <=> ( v120646(VarCurr)
        | v120678(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5243,axiom,
    ! [VarCurr: state_type] :
      ( v120678(VarCurr)
    <=> ( v120352(VarCurr,4)
        & v120654(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14209,axiom,
    ! [VarCurr: state_type] :
      ( v120646(VarCurr)
    <=> ( v120647(VarCurr)
        & v120673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14208,axiom,
    ! [VarCurr: state_type] :
      ( v120673(VarCurr)
    <=> ( v120674(VarCurr)
        & v120677(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5242,axiom,
    ! [VarCurr: state_type] :
      ( v120677(VarCurr)
    <=> ( v120352(VarCurr,4)
        | v120654(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14207,axiom,
    ! [VarCurr: state_type] :
      ( v120674(VarCurr)
    <=> ( v120675(VarCurr)
        | v120676(VarCurr) ) ) ).

tff(writeUnaryOperator_7793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120676(VarCurr)
    <=> v120654(VarCurr,4) ) ).

tff(writeUnaryOperator_7792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120675(VarCurr)
    <=> v120352(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14206,axiom,
    ! [VarCurr: state_type] :
      ( v120647(VarCurr)
    <=> ( v120648(VarCurr)
        | v120672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5241,axiom,
    ! [VarCurr: state_type] :
      ( v120672(VarCurr)
    <=> ( v120352(VarCurr,3)
        & v120654(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14205,axiom,
    ! [VarCurr: state_type] :
      ( v120648(VarCurr)
    <=> ( v120649(VarCurr)
        & v120667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14204,axiom,
    ! [VarCurr: state_type] :
      ( v120667(VarCurr)
    <=> ( v120668(VarCurr)
        & v120671(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5240,axiom,
    ! [VarCurr: state_type] :
      ( v120671(VarCurr)
    <=> ( v120352(VarCurr,3)
        | v120654(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14203,axiom,
    ! [VarCurr: state_type] :
      ( v120668(VarCurr)
    <=> ( v120669(VarCurr)
        | v120670(VarCurr) ) ) ).

tff(writeUnaryOperator_7791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120670(VarCurr)
    <=> v120654(VarCurr,3) ) ).

tff(writeUnaryOperator_7790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120669(VarCurr)
    <=> v120352(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14202,axiom,
    ! [VarCurr: state_type] :
      ( v120649(VarCurr)
    <=> ( v120650(VarCurr)
        | v120666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5239,axiom,
    ! [VarCurr: state_type] :
      ( v120666(VarCurr)
    <=> ( v120352(VarCurr,2)
        & v120654(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14201,axiom,
    ! [VarCurr: state_type] :
      ( v120650(VarCurr)
    <=> ( v120651(VarCurr)
        & v120661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14200,axiom,
    ! [VarCurr: state_type] :
      ( v120661(VarCurr)
    <=> ( v120662(VarCurr)
        & v120665(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5238,axiom,
    ! [VarCurr: state_type] :
      ( v120665(VarCurr)
    <=> ( v120352(VarCurr,2)
        | v120654(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14199,axiom,
    ! [VarCurr: state_type] :
      ( v120662(VarCurr)
    <=> ( v120663(VarCurr)
        | v120664(VarCurr) ) ) ).

tff(writeUnaryOperator_7789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120664(VarCurr)
    <=> v120654(VarCurr,2) ) ).

tff(writeUnaryOperator_7788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120663(VarCurr)
    <=> v120352(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14198,axiom,
    ! [VarCurr: state_type] :
      ( v120651(VarCurr)
    <=> ( v120652(VarCurr)
        | v120660(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5237,axiom,
    ! [VarCurr: state_type] :
      ( v120660(VarCurr)
    <=> ( v120352(VarCurr,1)
        & v120654(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14197,axiom,
    ! [VarCurr: state_type] :
      ( v120652(VarCurr)
    <=> ( v120653(VarCurr)
        & v120655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14196,axiom,
    ! [VarCurr: state_type] :
      ( v120655(VarCurr)
    <=> ( v120656(VarCurr)
        & v120659(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5236,axiom,
    ! [VarCurr: state_type] :
      ( v120659(VarCurr)
    <=> ( v120352(VarCurr,1)
        | v120654(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14195,axiom,
    ! [VarCurr: state_type] :
      ( v120656(VarCurr)
    <=> ( v120657(VarCurr)
        | v120658(VarCurr) ) ) ).

tff(writeUnaryOperator_7787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120658(VarCurr)
    <=> v120654(VarCurr,1) ) ).

tff(writeUnaryOperator_7786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120657(VarCurr)
    <=> v120352(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14194,axiom,
    ! [VarCurr: state_type] :
      ( v120653(VarCurr)
    <=> ( v120352(VarCurr,0)
        & v120654(VarCurr,0) ) ) ).

tff(addAssignment_69732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v120654(VarCurr,B)
      <=> v120374(VarCurr,B) ) ) ).

tff(addAssignment_69731,axiom,
    ! [VarCurr: state_type] :
      ( ( v120654(VarCurr,5)
      <=> $false )
      & ( v120654(VarCurr,4)
      <=> $false )
      & ( v120654(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_69730,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,5)
    <=> v120620(VarCurr,5) ) ).

tff(addAssignment_69729,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,4)
    <=> v120620(VarCurr,4) ) ).

tff(addAssignment_69728,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,3)
    <=> v120620(VarCurr,3) ) ).

tff(addAssignment_69727,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,2)
    <=> v120620(VarCurr,2) ) ).

tff(addAssignment_69726,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,1)
    <=> v120620(VarCurr,1) ) ).

tff(addAssignment_69725,axiom,
    ! [VarCurr: state_type] :
      ( v120583(VarCurr,0)
    <=> v120620(VarCurr,0) ) ).

tff(addAssignment_69724,axiom,
    ! [VarCurr: state_type] :
      ( v120620(VarCurr,0)
    <=> v120621(VarCurr) ) ).

tff(addAssignment_69723,axiom,
    ! [VarCurr: state_type] :
      ( ( v120620(VarCurr,5)
      <=> $false )
      & ( v120620(VarCurr,4)
      <=> $false )
      & ( v120620(VarCurr,3)
      <=> $false )
      & ( v120620(VarCurr,2)
      <=> $false )
      & ( v120620(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14193,axiom,
    ! [VarCurr: state_type] :
      ( v120621(VarCurr)
    <=> ( v120622(VarCurr)
        | v120619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14192,axiom,
    ! [VarCurr: state_type] :
      ( v120622(VarCurr)
    <=> ( v120623(VarCurr)
        | v120617(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14191,axiom,
    ! [VarCurr: state_type] :
      ( v120623(VarCurr)
    <=> ( v120624(VarCurr)
        | v120615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14190,axiom,
    ! [VarCurr: state_type] :
      ( v120624(VarCurr)
    <=> ( v120625(VarCurr)
        | v120605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14189,axiom,
    ! [VarCurr: state_type] :
      ( v120625(VarCurr)
    <=> ( v120585(VarCurr)
        | v120595(VarCurr) ) ) ).

tff(addAssignment_69722,axiom,
    ! [VarCurr: state_type] :
      ( v120619(VarCurr)
    <=> v113911(VarCurr,8) ) ).

tff(addAssignment_69721,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,8)
    <=> v113913(VarCurr,8) ) ).

tff(addAssignment_69720,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,8)
    <=> v113915(VarCurr,8) ) ).

tff(addAssignment_69719,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,8)
    <=> v113935(VarCurr,8) ) ).

tff(addAssignment_69718,axiom,
    ! [VarCurr: state_type] :
      ( v120617(VarCurr)
    <=> v113107(VarCurr,8) ) ).

tff(addAssignment_69717,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,8)
    <=> v113143(VarCurr,8) ) ).

tff(addAssignment_69716,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,8)
    <=> v113110(VarCurr,8) ) ).

tff(addAssignment_69715,axiom,
    ! [VarCurr: state_type] :
      ( v120615(VarCurr)
    <=> v113100(VarCurr,8) ) ).

tff(addAssignment_69714,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,8)
    <=> v113101(VarCurr,8) ) ).

tff(addAssignment_69713,axiom,
    ! [VarCurr: state_type] :
      ( v120605(VarCurr)
    <=> v113810(VarCurr,8) ) ).

tff(addAssignment_69712,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,8)
    <=> v113812(VarCurr,8) ) ).

tff(addAssignment_69711,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,8)
    <=> v113814(VarCurr,8) ) ).

tff(addAssignment_69710,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,8)
    <=> v113816(VarCurr,8) ) ).

tff(addAssignment_69709,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,8)
    <=> v113818(VarCurr,8) ) ).

tff(addAssignment_69708,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,8)
    <=> v120607(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_1566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120608(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v120607(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1566,axiom,
    ! [VarNext: state_type] :
      ( v120608(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v120607(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120608(VarNext)
      <=> v120609(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120609(VarNext)
      <=> ( v120611(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120611(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_69707,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,8)
    <=> v113830(VarCurr,8) ) ).

tff(addAssignment_69706,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,8)
    <=> v113832(VarCurr,8) ) ).

tff(addAssignment_69705,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,8)
    <=> v113834(VarCurr,8) ) ).

tff(addAssignment_69704,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,8)
    <=> v113873(VarCurr,8) ) ).

tff(addAssignment_69703,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,8)
    <=> v113856(VarCurr,8) ) ).

tff(addAssignment_69702,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,8)
    <=> v113837(VarCurr,8) ) ).

tff(addAssignment_69701,axiom,
    ! [VarCurr: state_type] :
      ( v120595(VarCurr)
    <=> v113020(VarCurr,8) ) ).

tff(addAssignment_69700,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,8)
    <=> v113022(VarCurr,8) ) ).

tff(addAssignment_69699,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,8)
    <=> v113024(VarCurr,8) ) ).

tff(addAssignment_69698,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,8)
    <=> v113026(VarCurr,8) ) ).

tff(addAssignment_69697,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,8)
    <=> v113028(VarCurr,8) ) ).

tff(addAssignment_69696,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,8)
    <=> v120597(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_1565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120598(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v120597(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1565,axiom,
    ! [VarNext: state_type] :
      ( v120598(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v120597(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120598(VarNext)
      <=> v120599(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120599(VarNext)
      <=> ( v120601(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120601(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_69695,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,8)
    <=> v113040(VarCurr,8) ) ).

tff(addAssignment_69694,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,8)
    <=> v113042(VarCurr,8) ) ).

tff(addAssignment_69693,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,8)
    <=> v113044(VarCurr,8) ) ).

tff(addAssignment_69692,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,8)
    <=> v113045(VarCurr,8) ) ).

tff(addAssignment_69691,axiom,
    ! [VarCurr: state_type] :
      ( v120585(VarCurr)
    <=> v112940(VarCurr,8) ) ).

tff(addAssignment_69690,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,8)
    <=> v112942(VarCurr,8) ) ).

tff(addAssignment_69689,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,8)
    <=> v112944(VarCurr,8) ) ).

tff(addAssignment_69688,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,8)
    <=> v112946(VarCurr,8) ) ).

tff(addAssignment_69687,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,8)
    <=> v112948(VarCurr,8) ) ).

tff(addAssignment_69686,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,8)
    <=> v120587(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_1564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120588(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v120587(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1564,axiom,
    ! [VarNext: state_type] :
      ( v120588(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v120587(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120588(VarNext)
      <=> v120589(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120589(VarNext)
      <=> ( v120591(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120591(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_69685,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,8)
    <=> v112960(VarCurr,8) ) ).

tff(addAssignment_69684,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,8)
    <=> v112962(VarCurr,8) ) ).

tff(addAssignment_69683,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,8)
    <=> v112964(VarCurr,8) ) ).

tff(addAssignment_69682,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,8)
    <=> v112965(VarCurr,8) ) ).

tff(addAssignment_69681,axiom,
    ! [VarCurr: state_type] :
      ( v120374(VarCurr,2)
    <=> v120389(VarCurr,2) ) ).

tff(addAssignment_69680,axiom,
    ! [VarCurr: state_type] :
      ( v120374(VarCurr,1)
    <=> v120389(VarCurr,1) ) ).

tff(addAssignment_69679,axiom,
    ! [VarCurr: state_type] :
      ( v120374(VarCurr,0)
    <=> v120389(VarCurr,0) ) ).

tff(addAssignment_69678,axiom,
    ! [VarCurr: state_type] :
      ( v120389(VarCurr,0)
    <=> v120577(VarCurr) ) ).

tff(addAssignment_69677,axiom,
    ! [VarCurr: state_type] :
      ( v120389(VarCurr,1)
    <=> v120572(VarCurr) ) ).

tff(addAssignment_69676,axiom,
    ! [VarCurr: state_type] :
      ( v120389(VarCurr,2)
    <=> v120391(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14182,axiom,
    ! [VarCurr: state_type] :
      ( v120577(VarCurr)
    <=> ( v120578(VarCurr)
        & v120581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14181,axiom,
    ! [VarCurr: state_type] :
      ( v120581(VarCurr)
    <=> ( v120397(VarCurr,0)
        | v120558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14180,axiom,
    ! [VarCurr: state_type] :
      ( v120578(VarCurr)
    <=> ( v120579(VarCurr)
        | v120580(VarCurr) ) ) ).

tff(writeUnaryOperator_7782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120580(VarCurr)
    <=> v120558(VarCurr,0) ) ).

tff(writeUnaryOperator_7781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120579(VarCurr)
    <=> v120397(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14179,axiom,
    ! [VarCurr: state_type] :
      ( v120572(VarCurr)
    <=> ( v120573(VarCurr)
        & v120576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14178,axiom,
    ! [VarCurr: state_type] :
      ( v120576(VarCurr)
    <=> ( v120396(VarCurr)
        | v120559(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14177,axiom,
    ! [VarCurr: state_type] :
      ( v120573(VarCurr)
    <=> ( v120574(VarCurr)
        | v120575(VarCurr) ) ) ).

tff(writeUnaryOperator_7780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120575(VarCurr)
    <=> v120559(VarCurr) ) ).

tff(writeUnaryOperator_7779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120574(VarCurr)
    <=> v120396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14176,axiom,
    ! [VarCurr: state_type] :
      ( v120391(VarCurr)
    <=> ( v120392(VarCurr)
        & v120571(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14175,axiom,
    ! [VarCurr: state_type] :
      ( v120571(VarCurr)
    <=> ( v120394(VarCurr)
        | v120566(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14174,axiom,
    ! [VarCurr: state_type] :
      ( v120392(VarCurr)
    <=> ( v120393(VarCurr)
        | v120565(VarCurr) ) ) ).

tff(writeUnaryOperator_7778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120565(VarCurr)
    <=> v120566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14173,axiom,
    ! [VarCurr: state_type] :
      ( v120566(VarCurr)
    <=> ( v120567(VarCurr)
        & v120570(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5235,axiom,
    ! [VarCurr: state_type] :
      ( v120570(VarCurr)
    <=> ( v120397(VarCurr,2)
        | v120558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14172,axiom,
    ! [VarCurr: state_type] :
      ( v120567(VarCurr)
    <=> ( v120568(VarCurr)
        | v120569(VarCurr) ) ) ).

tff(writeUnaryOperator_7777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120569(VarCurr)
    <=> v120558(VarCurr,2) ) ).

tff(writeUnaryOperator_7776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120568(VarCurr)
    <=> v120397(VarCurr,2) ) ).

tff(writeUnaryOperator_7775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120393(VarCurr)
    <=> v120394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14171,axiom,
    ! [VarCurr: state_type] :
      ( v120394(VarCurr)
    <=> ( v120395(VarCurr)
        | v120564(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5234,axiom,
    ! [VarCurr: state_type] :
      ( v120564(VarCurr)
    <=> ( v120397(VarCurr,1)
        & v120558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14170,axiom,
    ! [VarCurr: state_type] :
      ( v120395(VarCurr)
    <=> ( v120396(VarCurr)
        & v120559(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14169,axiom,
    ! [VarCurr: state_type] :
      ( v120559(VarCurr)
    <=> ( v120560(VarCurr)
        & v120563(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5233,axiom,
    ! [VarCurr: state_type] :
      ( v120563(VarCurr)
    <=> ( v120397(VarCurr,1)
        | v120558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14168,axiom,
    ! [VarCurr: state_type] :
      ( v120560(VarCurr)
    <=> ( v120561(VarCurr)
        | v120562(VarCurr) ) ) ).

tff(writeUnaryOperator_7774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120562(VarCurr)
    <=> v120558(VarCurr,1) ) ).

tff(writeUnaryOperator_7773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120561(VarCurr)
    <=> v120397(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14167,axiom,
    ! [VarCurr: state_type] :
      ( v120396(VarCurr)
    <=> ( v120397(VarCurr,0)
        & v120558(VarCurr,0) ) ) ).

tff(addAssignment_69675,axiom,
    ! [VarCurr: state_type] :
      ( v120558(VarCurr,0)
    <=> v120388(VarCurr) ) ).

tff(addAssignment_69674,axiom,
    ! [VarCurr: state_type] :
      ( ( v120558(VarCurr,2)
      <=> $false )
      & ( v120558(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69673,axiom,
    ! [VarCurr: state_type] :
      ( v120397(VarCurr,0)
    <=> v120553(VarCurr) ) ).

tff(addAssignment_69672,axiom,
    ! [VarCurr: state_type] :
      ( v120397(VarCurr,1)
    <=> v120548(VarCurr) ) ).

tff(addAssignment_69671,axiom,
    ! [VarCurr: state_type] :
      ( v120397(VarCurr,2)
    <=> v120399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14166,axiom,
    ! [VarCurr: state_type] :
      ( v120553(VarCurr)
    <=> ( v120554(VarCurr)
        & v120557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14165,axiom,
    ! [VarCurr: state_type] :
      ( v120557(VarCurr)
    <=> ( v120405(VarCurr,0)
        | v120534(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14164,axiom,
    ! [VarCurr: state_type] :
      ( v120554(VarCurr)
    <=> ( v120555(VarCurr)
        | v120556(VarCurr) ) ) ).

tff(writeUnaryOperator_7772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120556(VarCurr)
    <=> v120534(VarCurr,0) ) ).

tff(writeUnaryOperator_7771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120555(VarCurr)
    <=> v120405(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14163,axiom,
    ! [VarCurr: state_type] :
      ( v120548(VarCurr)
    <=> ( v120549(VarCurr)
        & v120552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14162,axiom,
    ! [VarCurr: state_type] :
      ( v120552(VarCurr)
    <=> ( v120404(VarCurr)
        | v120535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14161,axiom,
    ! [VarCurr: state_type] :
      ( v120549(VarCurr)
    <=> ( v120550(VarCurr)
        | v120551(VarCurr) ) ) ).

tff(writeUnaryOperator_7770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120551(VarCurr)
    <=> v120535(VarCurr) ) ).

tff(writeUnaryOperator_7769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120550(VarCurr)
    <=> v120404(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14160,axiom,
    ! [VarCurr: state_type] :
      ( v120399(VarCurr)
    <=> ( v120400(VarCurr)
        & v120547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14159,axiom,
    ! [VarCurr: state_type] :
      ( v120547(VarCurr)
    <=> ( v120402(VarCurr)
        | v120542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14158,axiom,
    ! [VarCurr: state_type] :
      ( v120400(VarCurr)
    <=> ( v120401(VarCurr)
        | v120541(VarCurr) ) ) ).

tff(writeUnaryOperator_7768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120541(VarCurr)
    <=> v120542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14157,axiom,
    ! [VarCurr: state_type] :
      ( v120542(VarCurr)
    <=> ( v120543(VarCurr)
        & v120546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5232,axiom,
    ! [VarCurr: state_type] :
      ( v120546(VarCurr)
    <=> ( v120405(VarCurr,2)
        | v120534(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14156,axiom,
    ! [VarCurr: state_type] :
      ( v120543(VarCurr)
    <=> ( v120544(VarCurr)
        | v120545(VarCurr) ) ) ).

tff(writeUnaryOperator_7767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120545(VarCurr)
    <=> v120534(VarCurr,2) ) ).

tff(writeUnaryOperator_7766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120544(VarCurr)
    <=> v120405(VarCurr,2) ) ).

tff(writeUnaryOperator_7765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120401(VarCurr)
    <=> v120402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14155,axiom,
    ! [VarCurr: state_type] :
      ( v120402(VarCurr)
    <=> ( v120403(VarCurr)
        | v120540(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5231,axiom,
    ! [VarCurr: state_type] :
      ( v120540(VarCurr)
    <=> ( v120405(VarCurr,1)
        & v120534(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14154,axiom,
    ! [VarCurr: state_type] :
      ( v120403(VarCurr)
    <=> ( v120404(VarCurr)
        & v120535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14153,axiom,
    ! [VarCurr: state_type] :
      ( v120535(VarCurr)
    <=> ( v120536(VarCurr)
        & v120539(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5230,axiom,
    ! [VarCurr: state_type] :
      ( v120539(VarCurr)
    <=> ( v120405(VarCurr,1)
        | v120534(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14152,axiom,
    ! [VarCurr: state_type] :
      ( v120536(VarCurr)
    <=> ( v120537(VarCurr)
        | v120538(VarCurr) ) ) ).

tff(writeUnaryOperator_7764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120538(VarCurr)
    <=> v120534(VarCurr,1) ) ).

tff(writeUnaryOperator_7763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120537(VarCurr)
    <=> v120405(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14151,axiom,
    ! [VarCurr: state_type] :
      ( v120404(VarCurr)
    <=> ( v120405(VarCurr,0)
        & v120534(VarCurr,0) ) ) ).

tff(addAssignment_69670,axiom,
    ! [VarCurr: state_type] :
      ( v120534(VarCurr,0)
    <=> v120386(VarCurr) ) ).

tff(addAssignment_69669,axiom,
    ! [VarCurr: state_type] :
      ( ( v120534(VarCurr,2)
      <=> $false )
      & ( v120534(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69668,axiom,
    ! [VarCurr: state_type] :
      ( v120405(VarCurr,0)
    <=> v120529(VarCurr) ) ).

tff(addAssignment_69667,axiom,
    ! [VarCurr: state_type] :
      ( v120405(VarCurr,1)
    <=> v120524(VarCurr) ) ).

tff(addAssignment_69666,axiom,
    ! [VarCurr: state_type] :
      ( v120405(VarCurr,2)
    <=> v120407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14150,axiom,
    ! [VarCurr: state_type] :
      ( v120529(VarCurr)
    <=> ( v120530(VarCurr)
        & v120533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14149,axiom,
    ! [VarCurr: state_type] :
      ( v120533(VarCurr)
    <=> ( v120413(VarCurr,0)
        | v120510(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14148,axiom,
    ! [VarCurr: state_type] :
      ( v120530(VarCurr)
    <=> ( v120531(VarCurr)
        | v120532(VarCurr) ) ) ).

tff(writeUnaryOperator_7762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120532(VarCurr)
    <=> v120510(VarCurr,0) ) ).

tff(writeUnaryOperator_7761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120531(VarCurr)
    <=> v120413(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14147,axiom,
    ! [VarCurr: state_type] :
      ( v120524(VarCurr)
    <=> ( v120525(VarCurr)
        & v120528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14146,axiom,
    ! [VarCurr: state_type] :
      ( v120528(VarCurr)
    <=> ( v120412(VarCurr)
        | v120511(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14145,axiom,
    ! [VarCurr: state_type] :
      ( v120525(VarCurr)
    <=> ( v120526(VarCurr)
        | v120527(VarCurr) ) ) ).

tff(writeUnaryOperator_7760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120527(VarCurr)
    <=> v120511(VarCurr) ) ).

tff(writeUnaryOperator_7759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120526(VarCurr)
    <=> v120412(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14144,axiom,
    ! [VarCurr: state_type] :
      ( v120407(VarCurr)
    <=> ( v120408(VarCurr)
        & v120523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14143,axiom,
    ! [VarCurr: state_type] :
      ( v120523(VarCurr)
    <=> ( v120410(VarCurr)
        | v120518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14142,axiom,
    ! [VarCurr: state_type] :
      ( v120408(VarCurr)
    <=> ( v120409(VarCurr)
        | v120517(VarCurr) ) ) ).

tff(writeUnaryOperator_7758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120517(VarCurr)
    <=> v120518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14141,axiom,
    ! [VarCurr: state_type] :
      ( v120518(VarCurr)
    <=> ( v120519(VarCurr)
        & v120522(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5229,axiom,
    ! [VarCurr: state_type] :
      ( v120522(VarCurr)
    <=> ( v120413(VarCurr,2)
        | v120510(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14140,axiom,
    ! [VarCurr: state_type] :
      ( v120519(VarCurr)
    <=> ( v120520(VarCurr)
        | v120521(VarCurr) ) ) ).

tff(writeUnaryOperator_7757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120521(VarCurr)
    <=> v120510(VarCurr,2) ) ).

tff(writeUnaryOperator_7756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120520(VarCurr)
    <=> v120413(VarCurr,2) ) ).

tff(writeUnaryOperator_7755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120409(VarCurr)
    <=> v120410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14139,axiom,
    ! [VarCurr: state_type] :
      ( v120410(VarCurr)
    <=> ( v120411(VarCurr)
        | v120516(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5228,axiom,
    ! [VarCurr: state_type] :
      ( v120516(VarCurr)
    <=> ( v120413(VarCurr,1)
        & v120510(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14138,axiom,
    ! [VarCurr: state_type] :
      ( v120411(VarCurr)
    <=> ( v120412(VarCurr)
        & v120511(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14137,axiom,
    ! [VarCurr: state_type] :
      ( v120511(VarCurr)
    <=> ( v120512(VarCurr)
        & v120515(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5227,axiom,
    ! [VarCurr: state_type] :
      ( v120515(VarCurr)
    <=> ( v120413(VarCurr,1)
        | v120510(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14136,axiom,
    ! [VarCurr: state_type] :
      ( v120512(VarCurr)
    <=> ( v120513(VarCurr)
        | v120514(VarCurr) ) ) ).

tff(writeUnaryOperator_7754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120514(VarCurr)
    <=> v120510(VarCurr,1) ) ).

tff(writeUnaryOperator_7753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120513(VarCurr)
    <=> v120413(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14135,axiom,
    ! [VarCurr: state_type] :
      ( v120412(VarCurr)
    <=> ( v120413(VarCurr,0)
        & v120510(VarCurr,0) ) ) ).

tff(addAssignment_69665,axiom,
    ! [VarCurr: state_type] :
      ( v120510(VarCurr,0)
    <=> v120384(VarCurr) ) ).

tff(addAssignment_69664,axiom,
    ! [VarCurr: state_type] :
      ( ( v120510(VarCurr,2)
      <=> $false )
      & ( v120510(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69663,axiom,
    ! [VarCurr: state_type] :
      ( v120413(VarCurr,0)
    <=> v120505(VarCurr) ) ).

tff(addAssignment_69662,axiom,
    ! [VarCurr: state_type] :
      ( v120413(VarCurr,1)
    <=> v120500(VarCurr) ) ).

tff(addAssignment_69661,axiom,
    ! [VarCurr: state_type] :
      ( v120413(VarCurr,2)
    <=> v120415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14134,axiom,
    ! [VarCurr: state_type] :
      ( v120505(VarCurr)
    <=> ( v120506(VarCurr)
        & v120509(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14133,axiom,
    ! [VarCurr: state_type] :
      ( v120509(VarCurr)
    <=> ( v120421(VarCurr,0)
        | v120486(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14132,axiom,
    ! [VarCurr: state_type] :
      ( v120506(VarCurr)
    <=> ( v120507(VarCurr)
        | v120508(VarCurr) ) ) ).

tff(writeUnaryOperator_7752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120508(VarCurr)
    <=> v120486(VarCurr,0) ) ).

tff(writeUnaryOperator_7751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120507(VarCurr)
    <=> v120421(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14131,axiom,
    ! [VarCurr: state_type] :
      ( v120500(VarCurr)
    <=> ( v120501(VarCurr)
        & v120504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14130,axiom,
    ! [VarCurr: state_type] :
      ( v120504(VarCurr)
    <=> ( v120420(VarCurr)
        | v120487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14129,axiom,
    ! [VarCurr: state_type] :
      ( v120501(VarCurr)
    <=> ( v120502(VarCurr)
        | v120503(VarCurr) ) ) ).

tff(writeUnaryOperator_7750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120503(VarCurr)
    <=> v120487(VarCurr) ) ).

tff(writeUnaryOperator_7749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120502(VarCurr)
    <=> v120420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14128,axiom,
    ! [VarCurr: state_type] :
      ( v120415(VarCurr)
    <=> ( v120416(VarCurr)
        & v120499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14127,axiom,
    ! [VarCurr: state_type] :
      ( v120499(VarCurr)
    <=> ( v120418(VarCurr)
        | v120494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14126,axiom,
    ! [VarCurr: state_type] :
      ( v120416(VarCurr)
    <=> ( v120417(VarCurr)
        | v120493(VarCurr) ) ) ).

tff(writeUnaryOperator_7748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120493(VarCurr)
    <=> v120494(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14125,axiom,
    ! [VarCurr: state_type] :
      ( v120494(VarCurr)
    <=> ( v120495(VarCurr)
        & v120498(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5226,axiom,
    ! [VarCurr: state_type] :
      ( v120498(VarCurr)
    <=> ( v120421(VarCurr,2)
        | v120486(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14124,axiom,
    ! [VarCurr: state_type] :
      ( v120495(VarCurr)
    <=> ( v120496(VarCurr)
        | v120497(VarCurr) ) ) ).

tff(writeUnaryOperator_7747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120497(VarCurr)
    <=> v120486(VarCurr,2) ) ).

tff(writeUnaryOperator_7746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120496(VarCurr)
    <=> v120421(VarCurr,2) ) ).

tff(writeUnaryOperator_7745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120417(VarCurr)
    <=> v120418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14123,axiom,
    ! [VarCurr: state_type] :
      ( v120418(VarCurr)
    <=> ( v120419(VarCurr)
        | v120492(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5225,axiom,
    ! [VarCurr: state_type] :
      ( v120492(VarCurr)
    <=> ( v120421(VarCurr,1)
        & v120486(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14122,axiom,
    ! [VarCurr: state_type] :
      ( v120419(VarCurr)
    <=> ( v120420(VarCurr)
        & v120487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14121,axiom,
    ! [VarCurr: state_type] :
      ( v120487(VarCurr)
    <=> ( v120488(VarCurr)
        & v120491(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5224,axiom,
    ! [VarCurr: state_type] :
      ( v120491(VarCurr)
    <=> ( v120421(VarCurr,1)
        | v120486(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14120,axiom,
    ! [VarCurr: state_type] :
      ( v120488(VarCurr)
    <=> ( v120489(VarCurr)
        | v120490(VarCurr) ) ) ).

tff(writeUnaryOperator_7744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120490(VarCurr)
    <=> v120486(VarCurr,1) ) ).

tff(writeUnaryOperator_7743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120489(VarCurr)
    <=> v120421(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14119,axiom,
    ! [VarCurr: state_type] :
      ( v120420(VarCurr)
    <=> ( v120421(VarCurr,0)
        & v120486(VarCurr,0) ) ) ).

tff(addAssignment_69660,axiom,
    ! [VarCurr: state_type] :
      ( v120486(VarCurr,0)
    <=> v120382(VarCurr) ) ).

tff(addAssignment_69659,axiom,
    ! [VarCurr: state_type] :
      ( ( v120486(VarCurr,2)
      <=> $false )
      & ( v120486(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69658,axiom,
    ! [VarCurr: state_type] :
      ( v120421(VarCurr,0)
    <=> v120481(VarCurr) ) ).

tff(addAssignment_69657,axiom,
    ! [VarCurr: state_type] :
      ( v120421(VarCurr,1)
    <=> v120476(VarCurr) ) ).

tff(addAssignment_69656,axiom,
    ! [VarCurr: state_type] :
      ( v120421(VarCurr,2)
    <=> v120423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14118,axiom,
    ! [VarCurr: state_type] :
      ( v120481(VarCurr)
    <=> ( v120482(VarCurr)
        & v120485(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14117,axiom,
    ! [VarCurr: state_type] :
      ( v120485(VarCurr)
    <=> ( v120429(VarCurr,0)
        | v120462(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14116,axiom,
    ! [VarCurr: state_type] :
      ( v120482(VarCurr)
    <=> ( v120483(VarCurr)
        | v120484(VarCurr) ) ) ).

tff(writeUnaryOperator_7742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120484(VarCurr)
    <=> v120462(VarCurr,0) ) ).

tff(writeUnaryOperator_7741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120483(VarCurr)
    <=> v120429(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14115,axiom,
    ! [VarCurr: state_type] :
      ( v120476(VarCurr)
    <=> ( v120477(VarCurr)
        & v120480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14114,axiom,
    ! [VarCurr: state_type] :
      ( v120480(VarCurr)
    <=> ( v120428(VarCurr)
        | v120463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14113,axiom,
    ! [VarCurr: state_type] :
      ( v120477(VarCurr)
    <=> ( v120478(VarCurr)
        | v120479(VarCurr) ) ) ).

tff(writeUnaryOperator_7740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120479(VarCurr)
    <=> v120463(VarCurr) ) ).

tff(writeUnaryOperator_7739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120478(VarCurr)
    <=> v120428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14112,axiom,
    ! [VarCurr: state_type] :
      ( v120423(VarCurr)
    <=> ( v120424(VarCurr)
        & v120475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14111,axiom,
    ! [VarCurr: state_type] :
      ( v120475(VarCurr)
    <=> ( v120426(VarCurr)
        | v120470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14110,axiom,
    ! [VarCurr: state_type] :
      ( v120424(VarCurr)
    <=> ( v120425(VarCurr)
        | v120469(VarCurr) ) ) ).

tff(writeUnaryOperator_7738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120469(VarCurr)
    <=> v120470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14109,axiom,
    ! [VarCurr: state_type] :
      ( v120470(VarCurr)
    <=> ( v120471(VarCurr)
        & v120474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5223,axiom,
    ! [VarCurr: state_type] :
      ( v120474(VarCurr)
    <=> ( v120429(VarCurr,2)
        | v120462(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14108,axiom,
    ! [VarCurr: state_type] :
      ( v120471(VarCurr)
    <=> ( v120472(VarCurr)
        | v120473(VarCurr) ) ) ).

tff(writeUnaryOperator_7737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120473(VarCurr)
    <=> v120462(VarCurr,2) ) ).

tff(writeUnaryOperator_7736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120472(VarCurr)
    <=> v120429(VarCurr,2) ) ).

tff(writeUnaryOperator_7735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120425(VarCurr)
    <=> v120426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14107,axiom,
    ! [VarCurr: state_type] :
      ( v120426(VarCurr)
    <=> ( v120427(VarCurr)
        | v120468(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5222,axiom,
    ! [VarCurr: state_type] :
      ( v120468(VarCurr)
    <=> ( v120429(VarCurr,1)
        & v120462(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14106,axiom,
    ! [VarCurr: state_type] :
      ( v120427(VarCurr)
    <=> ( v120428(VarCurr)
        & v120463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14105,axiom,
    ! [VarCurr: state_type] :
      ( v120463(VarCurr)
    <=> ( v120464(VarCurr)
        & v120467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5221,axiom,
    ! [VarCurr: state_type] :
      ( v120467(VarCurr)
    <=> ( v120429(VarCurr,1)
        | v120462(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14104,axiom,
    ! [VarCurr: state_type] :
      ( v120464(VarCurr)
    <=> ( v120465(VarCurr)
        | v120466(VarCurr) ) ) ).

tff(writeUnaryOperator_7734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120466(VarCurr)
    <=> v120462(VarCurr,1) ) ).

tff(writeUnaryOperator_7733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120465(VarCurr)
    <=> v120429(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14103,axiom,
    ! [VarCurr: state_type] :
      ( v120428(VarCurr)
    <=> ( v120429(VarCurr,0)
        & v120462(VarCurr,0) ) ) ).

tff(addAssignment_69655,axiom,
    ! [VarCurr: state_type] :
      ( v120462(VarCurr,0)
    <=> v120380(VarCurr) ) ).

tff(addAssignment_69654,axiom,
    ! [VarCurr: state_type] :
      ( ( v120462(VarCurr,2)
      <=> $false )
      & ( v120462(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69653,axiom,
    ! [VarCurr: state_type] :
      ( v120429(VarCurr,0)
    <=> v120457(VarCurr) ) ).

tff(addAssignment_69652,axiom,
    ! [VarCurr: state_type] :
      ( v120429(VarCurr,1)
    <=> v120452(VarCurr) ) ).

tff(addAssignment_69651,axiom,
    ! [VarCurr: state_type] :
      ( v120429(VarCurr,2)
    <=> v120431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14102,axiom,
    ! [VarCurr: state_type] :
      ( v120457(VarCurr)
    <=> ( v120458(VarCurr)
        & v120461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14101,axiom,
    ! [VarCurr: state_type] :
      ( v120461(VarCurr)
    <=> ( v120437(VarCurr,0)
        | v120438(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14100,axiom,
    ! [VarCurr: state_type] :
      ( v120458(VarCurr)
    <=> ( v120459(VarCurr)
        | v120460(VarCurr) ) ) ).

tff(writeUnaryOperator_7732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120460(VarCurr)
    <=> v120438(VarCurr,0) ) ).

tff(writeUnaryOperator_7731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120459(VarCurr)
    <=> v120437(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14099,axiom,
    ! [VarCurr: state_type] :
      ( v120452(VarCurr)
    <=> ( v120453(VarCurr)
        & v120456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14098,axiom,
    ! [VarCurr: state_type] :
      ( v120456(VarCurr)
    <=> ( v120436(VarCurr)
        | v120439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14097,axiom,
    ! [VarCurr: state_type] :
      ( v120453(VarCurr)
    <=> ( v120454(VarCurr)
        | v120455(VarCurr) ) ) ).

tff(writeUnaryOperator_7730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120455(VarCurr)
    <=> v120439(VarCurr) ) ).

tff(writeUnaryOperator_7729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120454(VarCurr)
    <=> v120436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14096,axiom,
    ! [VarCurr: state_type] :
      ( v120431(VarCurr)
    <=> ( v120432(VarCurr)
        & v120451(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14095,axiom,
    ! [VarCurr: state_type] :
      ( v120451(VarCurr)
    <=> ( v120434(VarCurr)
        | v120446(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14094,axiom,
    ! [VarCurr: state_type] :
      ( v120432(VarCurr)
    <=> ( v120433(VarCurr)
        | v120445(VarCurr) ) ) ).

tff(writeUnaryOperator_7728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120445(VarCurr)
    <=> v120446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14093,axiom,
    ! [VarCurr: state_type] :
      ( v120446(VarCurr)
    <=> ( v120447(VarCurr)
        & v120450(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5220,axiom,
    ! [VarCurr: state_type] :
      ( v120450(VarCurr)
    <=> ( v120437(VarCurr,2)
        | v120438(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14092,axiom,
    ! [VarCurr: state_type] :
      ( v120447(VarCurr)
    <=> ( v120448(VarCurr)
        | v120449(VarCurr) ) ) ).

tff(writeUnaryOperator_7727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120449(VarCurr)
    <=> v120438(VarCurr,2) ) ).

tff(writeUnaryOperator_7726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120448(VarCurr)
    <=> v120437(VarCurr,2) ) ).

tff(writeUnaryOperator_7725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120433(VarCurr)
    <=> v120434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14091,axiom,
    ! [VarCurr: state_type] :
      ( v120434(VarCurr)
    <=> ( v120435(VarCurr)
        | v120444(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5219,axiom,
    ! [VarCurr: state_type] :
      ( v120444(VarCurr)
    <=> ( v120437(VarCurr,1)
        & v120438(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14090,axiom,
    ! [VarCurr: state_type] :
      ( v120435(VarCurr)
    <=> ( v120436(VarCurr)
        & v120439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14089,axiom,
    ! [VarCurr: state_type] :
      ( v120439(VarCurr)
    <=> ( v120440(VarCurr)
        & v120443(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5218,axiom,
    ! [VarCurr: state_type] :
      ( v120443(VarCurr)
    <=> ( v120437(VarCurr,1)
        | v120438(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14088,axiom,
    ! [VarCurr: state_type] :
      ( v120440(VarCurr)
    <=> ( v120441(VarCurr)
        | v120442(VarCurr) ) ) ).

tff(writeUnaryOperator_7724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120442(VarCurr)
    <=> v120438(VarCurr,1) ) ).

tff(writeUnaryOperator_7723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120441(VarCurr)
    <=> v120437(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14087,axiom,
    ! [VarCurr: state_type] :
      ( v120436(VarCurr)
    <=> ( v120437(VarCurr,0)
        & v120438(VarCurr,0) ) ) ).

tff(addAssignment_69650,axiom,
    ! [VarCurr: state_type] :
      ( v120438(VarCurr,0)
    <=> v120378(VarCurr) ) ).

tff(addAssignment_69649,axiom,
    ! [VarCurr: state_type] :
      ( ( v120438(VarCurr,2)
      <=> $false )
      & ( v120438(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69648,axiom,
    ! [VarCurr: state_type] :
      ( v120437(VarCurr,0)
    <=> v120376(VarCurr) ) ).

tff(addAssignment_69647,axiom,
    ! [VarCurr: state_type] :
      ( ( v120437(VarCurr,2)
      <=> $false )
      & ( v120437(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69646,axiom,
    ! [VarCurr: state_type] :
      ( v120388(VarCurr)
    <=> v114692(VarCurr,8) ) ).

tff(addAssignment_69645,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,8)
    <=> v114694(VarCurr,8) ) ).

tff(addAssignment_69644,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,8)
    <=> v114696(VarCurr,8) ) ).

tff(addAssignment_69643,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,8)
    <=> v114697(VarCurr,8) ) ).

tff(addAssignment_69642,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,8)
    <=> v113918(VarCurr,8) ) ).

tff(addAssignment_69641,axiom,
    ! [VarCurr: state_type] :
      ( v120386(VarCurr)
    <=> v114685(VarCurr,8) ) ).

tff(addAssignment_69640,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,8)
    <=> v114686(VarCurr,8) ) ).

tff(addAssignment_69639,axiom,
    ! [VarCurr: state_type] :
      ( v120384(VarCurr)
    <=> v114661(VarCurr,8) ) ).

tff(addAssignment_69638,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,8)
    <=> v114662(VarCurr,8) ) ).

tff(addAssignment_69637,axiom,
    ! [VarCurr: state_type] :
      ( v120382(VarCurr)
    <=> v114633(VarCurr,8) ) ).

tff(addAssignment_69636,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,8)
    <=> v114635(VarCurr,8) ) ).

tff(addAssignment_69635,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,8)
    <=> v114637(VarCurr,8) ) ).

tff(addAssignment_69634,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,8)
    <=> v114638(VarCurr,8) ) ).

tff(addAssignment_69633,axiom,
    ! [VarCurr: state_type] :
      ( v120380(VarCurr)
    <=> v114605(VarCurr,8) ) ).

tff(addAssignment_69632,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,8)
    <=> v114607(VarCurr,8) ) ).

tff(addAssignment_69631,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,8)
    <=> v114609(VarCurr,8) ) ).

tff(addAssignment_69630,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,8)
    <=> v114610(VarCurr,8) ) ).

tff(addAssignment_69629,axiom,
    ! [VarCurr: state_type] :
      ( v120378(VarCurr)
    <=> v114577(VarCurr,8) ) ).

tff(addAssignment_69628,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,8)
    <=> v114579(VarCurr,8) ) ).

tff(addAssignment_69627,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,8)
    <=> v114581(VarCurr,8) ) ).

tff(addAssignment_69626,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,8)
    <=> v114582(VarCurr,8) ) ).

tff(addAssignment_69625,axiom,
    ! [VarCurr: state_type] :
      ( v120376(VarCurr)
    <=> v114549(VarCurr,8) ) ).

tff(addAssignment_69624,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,8)
    <=> v114551(VarCurr,8) ) ).

tff(addAssignment_69623,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,8)
    <=> v114553(VarCurr,8) ) ).

tff(addAssignment_69622,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,8)
    <=> v114554(VarCurr,8) ) ).

tff(addAssignment_69621,axiom,
    ! [VarCurr: state_type] :
      ( v120362(VarCurr)
    <=> v120364(VarCurr) ) ).

tff(addAssignment_69620,axiom,
    ! [VarCurr: state_type] :
      ( v120364(VarCurr)
    <=> v120338(VarCurr) ) ).

tff(addAssignment_69619,axiom,
    ! [VarCurr: state_type] :
      ( v120358(VarCurr)
    <=> v120360(VarCurr) ) ).

tff(addAssignment_69618,axiom,
    ! [VarCurr: state_type] :
      ( v120360(VarCurr)
    <=> v120330(VarCurr) ) ).

tff(addAssignment_69617,axiom,
    ! [VarCurr: state_type] :
      ( v120334(VarCurr)
    <=> v120336(VarCurr) ) ).

tff(addAssignment_69616,axiom,
    ! [VarCurr: state_type] :
      ( v120336(VarCurr)
    <=> v120338(VarCurr) ) ).

tff(addAssignment_69615,axiom,
    ! [VarCurr: state_type] :
      ( v120338(VarCurr)
    <=> v120340(VarCurr) ) ).

tff(addAssignment_69614,axiom,
    ! [VarCurr: state_type] :
      ( v120340(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_69613,axiom,
    ! [VarCurr: state_type] :
      ( v120326(VarCurr)
    <=> v120328(VarCurr) ) ).

tff(addAssignment_69612,axiom,
    ! [VarCurr: state_type] :
      ( v120328(VarCurr)
    <=> v120330(VarCurr) ) ).

tff(addAssignment_69611,axiom,
    ! [VarCurr: state_type] :
      ( v120330(VarCurr)
    <=> v120332(VarCurr) ) ).

tff(addAssignment_69610,axiom,
    ! [VarCurr: state_type] :
      ( v120332(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14086,axiom,
    ! [VarCurr: state_type] :
      ( v119517(VarCurr)
    <=> ( v120316(VarCurr)
        & v120226(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5217,axiom,
    ! [VarCurr: state_type] :
      ( v120316(VarCurr)
    <=> ( v119519(VarCurr,1)
        & v120165(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1193,axiom,
    ! [VarCurr: state_type] :
      ( v120226(VarCurr)
    <=> ( ( v120228(VarCurr,4)
        <=> $false )
        & ( v120228(VarCurr,3)
        <=> $false )
        & ( v120228(VarCurr,2)
        <=> $false )
        & ( v120228(VarCurr,1)
        <=> $false )
        & ( v120228(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120228(VarCurr,B)
      <=> v120230(VarCurr,B) ) ) ).

tff(addAssignment_69608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120230(VarCurr,B)
      <=> v120232(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120298(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v120232(VarNext,B)
            <=> v120232(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1563,axiom,
    ! [VarNext: state_type] :
      ( v120298(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120232(VarNext,B)
          <=> v120308(VarNext,B) ) ) ) ).

tff(addAssignment_69607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120308(VarNext,B)
          <=> v120306(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120309(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120306(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1108,axiom,
    ! [VarCurr: state_type] :
      ( v120309(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120306(VarCurr,B)
          <=> v120242(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14085,axiom,
    ! [VarCurr: state_type] :
      ( v120309(VarCurr)
    <=> ( v120310(VarCurr)
        & v120311(VarCurr) ) ) ).

tff(writeUnaryOperator_7722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120311(VarCurr)
    <=> v120238(VarCurr) ) ).

tff(writeUnaryOperator_7721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120310(VarCurr)
    <=> v120234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120298(VarNext)
      <=> v120299(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120299(VarNext)
      <=> ( v120300(VarNext)
          & v120293(VarNext) ) ) ) ).

tff(writeUnaryOperator_7720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120300(VarNext)
      <=> v120302(VarNext) ) ) ).

tff(addAssignment_69606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120302(VarNext)
      <=> v120293(VarCurr) ) ) ).

tff(addAssignment_69605,axiom,
    ! [VarCurr: state_type] :
      ( v120293(VarCurr)
    <=> v120295(VarCurr) ) ).

tff(addAssignment_69604,axiom,
    ! [VarCurr: state_type] :
      ( v120295(VarCurr)
    <=> v119999(VarCurr) ) ).

tff(addAssignment_69603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120242(VarCurr,B)
      <=> v120244(VarCurr,B) ) ) ).

tff(addAssignment_69602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120244(VarCurr,B)
      <=> v120246(VarCurr,B) ) ) ).

tff(addAssignment_69601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120246(VarCurr,B)
      <=> v120248(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120248(VarCurr,B)
          <=> v120262(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1107,axiom,
    ! [VarCurr: state_type] :
      ( v120250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120248(VarCurr,B)
          <=> v120255(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120262(VarCurr,B)
          <=> v120263(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1106,axiom,
    ! [VarCurr: state_type] :
      ( v120257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120262(VarCurr,B)
          <=> v120260(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120226(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120263(VarCurr,B)
          <=> v120264(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1105,axiom,
    ! [VarCurr: state_type] :
      ( v120226(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v120263(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69600,axiom,
    ! [VarCurr: state_type] :
      ( v120264(VarCurr,0)
    <=> v120290(VarCurr) ) ).

tff(addAssignment_69599,axiom,
    ! [VarCurr: state_type] :
      ( v120264(VarCurr,1)
    <=> v120288(VarCurr) ) ).

tff(addAssignment_69598,axiom,
    ! [VarCurr: state_type] :
      ( v120264(VarCurr,2)
    <=> v120284(VarCurr) ) ).

tff(addAssignment_69597,axiom,
    ! [VarCurr: state_type] :
      ( v120264(VarCurr,3)
    <=> v120280(VarCurr) ) ).

tff(addAssignment_69596,axiom,
    ! [VarCurr: state_type] :
      ( v120264(VarCurr,4)
    <=> v120266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14082,axiom,
    ! [VarCurr: state_type] :
      ( v120288(VarCurr)
    <=> ( v120289(VarCurr)
        & v120291(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14081,axiom,
    ! [VarCurr: state_type] :
      ( v120291(VarCurr)
    <=> ( v120228(VarCurr,0)
        | v120275(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5216,axiom,
    ! [VarCurr: state_type] :
      ( v120289(VarCurr)
    <=> ( v120290(VarCurr)
        | v120228(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120290(VarCurr)
    <=> v120228(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14080,axiom,
    ! [VarCurr: state_type] :
      ( v120284(VarCurr)
    <=> ( v120285(VarCurr)
        & v120287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14079,axiom,
    ! [VarCurr: state_type] :
      ( v120287(VarCurr)
    <=> ( v120273(VarCurr)
        | v120276(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5215,axiom,
    ! [VarCurr: state_type] :
      ( v120285(VarCurr)
    <=> ( v120286(VarCurr)
        | v120228(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120286(VarCurr)
    <=> v120273(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14078,axiom,
    ! [VarCurr: state_type] :
      ( v120280(VarCurr)
    <=> ( v120281(VarCurr)
        & v120283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14077,axiom,
    ! [VarCurr: state_type] :
      ( v120283(VarCurr)
    <=> ( v120271(VarCurr)
        | v120277(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5214,axiom,
    ! [VarCurr: state_type] :
      ( v120281(VarCurr)
    <=> ( v120282(VarCurr)
        | v120228(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120282(VarCurr)
    <=> v120271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14076,axiom,
    ! [VarCurr: state_type] :
      ( v120266(VarCurr)
    <=> ( v120267(VarCurr)
        & v120278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14075,axiom,
    ! [VarCurr: state_type] :
      ( v120278(VarCurr)
    <=> ( v120269(VarCurr)
        | v120279(VarCurr) ) ) ).

tff(writeUnaryOperator_7716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120279(VarCurr)
    <=> v120228(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5213,axiom,
    ! [VarCurr: state_type] :
      ( v120267(VarCurr)
    <=> ( v120268(VarCurr)
        | v120228(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120268(VarCurr)
    <=> v120269(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5212,axiom,
    ! [VarCurr: state_type] :
      ( v120269(VarCurr)
    <=> ( v120228(VarCurr,3)
        | v120270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14074,axiom,
    ! [VarCurr: state_type] :
      ( v120270(VarCurr)
    <=> ( v120271(VarCurr)
        & v120277(VarCurr) ) ) ).

tff(writeUnaryOperator_7714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120277(VarCurr)
    <=> v120228(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5211,axiom,
    ! [VarCurr: state_type] :
      ( v120271(VarCurr)
    <=> ( v120228(VarCurr,2)
        | v120272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14073,axiom,
    ! [VarCurr: state_type] :
      ( v120272(VarCurr)
    <=> ( v120273(VarCurr)
        & v120276(VarCurr) ) ) ).

tff(writeUnaryOperator_7713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120276(VarCurr)
    <=> v120228(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5210,axiom,
    ! [VarCurr: state_type] :
      ( v120273(VarCurr)
    <=> ( v120228(VarCurr,1)
        | v120274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14072,axiom,
    ! [VarCurr: state_type] :
      ( v120274(VarCurr)
    <=> ( v120228(VarCurr,0)
        & v120275(VarCurr) ) ) ).

tff(writeUnaryOperator_7712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120275(VarCurr)
    <=> v120228(VarCurr,1) ) ).

tff(addAssignment_69595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120260(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14071,axiom,
    ! [VarCurr: state_type] :
      ( v120257(VarCurr)
    <=> ( v119804(VarCurr)
        | v119818(VarCurr) ) ) ).

tff(addAssignment_69594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v120255(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14070,axiom,
    ! [VarCurr: state_type] :
      ( v120250(VarCurr)
    <=> ( v120252(VarCurr)
        | v119816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14069,axiom,
    ! [VarCurr: state_type] :
      ( v120252(VarCurr)
    <=> ( v120253(VarCurr)
        | v119814(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14068,axiom,
    ! [VarCurr: state_type] :
      ( v120253(VarCurr)
    <=> ( v119784(VarCurr)
        | v119794(VarCurr) ) ) ).

tff(addAssignment_69593,axiom,
    ! [VarCurr: state_type] :
      ( v120238(VarCurr)
    <=> v120240(VarCurr) ) ).

tff(addAssignment_69592,axiom,
    ! [VarCurr: state_type] :
      ( v120240(VarCurr)
    <=> v119537(VarCurr) ) ).

tff(addAssignment_69591,axiom,
    ! [VarCurr: state_type] :
      ( v120234(VarCurr)
    <=> v120236(VarCurr) ) ).

tff(addAssignment_69590,axiom,
    ! [VarCurr: state_type] :
      ( v120236(VarCurr)
    <=> v119529(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1192,axiom,
    ! [VarCurr: state_type] :
      ( v120165(VarCurr)
    <=> ( ( v120167(VarCurr,1)
        <=> $false )
        & ( v120167(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120167(VarCurr,B)
      <=> v120169(VarCurr,B) ) ) ).

tff(addAssignment_69588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120169(VarCurr,B)
      <=> v120171(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120208(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v120171(VarNext,B)
            <=> v120171(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1562,axiom,
    ! [VarNext: state_type] :
      ( v120208(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120171(VarNext,B)
          <=> v120218(VarNext,B) ) ) ) ).

tff(addAssignment_69587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120218(VarNext,B)
          <=> v120216(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120219(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120216(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1104,axiom,
    ! [VarCurr: state_type] :
      ( v120219(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120216(VarCurr,B)
          <=> v120181(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14067,axiom,
    ! [VarCurr: state_type] :
      ( v120219(VarCurr)
    <=> ( v120220(VarCurr)
        & v120221(VarCurr) ) ) ).

tff(writeUnaryOperator_7711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120221(VarCurr)
    <=> v120177(VarCurr) ) ).

tff(writeUnaryOperator_7710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120220(VarCurr)
    <=> v120173(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120208(VarNext)
      <=> v120209(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120209(VarNext)
      <=> ( v120210(VarNext)
          & v120203(VarNext) ) ) ) ).

tff(writeUnaryOperator_7709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120210(VarNext)
      <=> v120212(VarNext) ) ) ).

tff(addAssignment_69586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120212(VarNext)
      <=> v120203(VarCurr) ) ) ).

tff(addAssignment_69585,axiom,
    ! [VarCurr: state_type] :
      ( v120203(VarCurr)
    <=> v120205(VarCurr) ) ).

tff(addAssignment_69584,axiom,
    ! [VarCurr: state_type] :
      ( v120205(VarCurr)
    <=> v119999(VarCurr) ) ).

tff(addAssignment_69583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120181(VarCurr,B)
      <=> v120183(VarCurr,B) ) ) ).

tff(addAssignment_69582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120183(VarCurr,B)
      <=> v120185(VarCurr,B) ) ) ).

tff(addAssignment_69581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v120185(VarCurr,B)
      <=> v120187(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120189(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120187(VarCurr,B)
          <=> v120194(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1103,axiom,
    ! [VarCurr: state_type] :
      ( v120189(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120187(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120165(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120194(VarCurr,B)
          <=> v120195(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1102,axiom,
    ! [VarCurr: state_type] :
      ( v120165(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v120194(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69580,axiom,
    ! [VarCurr: state_type] :
      ( v120195(VarCurr,0)
    <=> v120199(VarCurr) ) ).

tff(addAssignment_69579,axiom,
    ! [VarCurr: state_type] :
      ( v120195(VarCurr,1)
    <=> v120197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14064,axiom,
    ! [VarCurr: state_type] :
      ( v120197(VarCurr)
    <=> ( v120198(VarCurr)
        & v120200(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14063,axiom,
    ! [VarCurr: state_type] :
      ( v120200(VarCurr)
    <=> ( v120167(VarCurr,0)
        | v120201(VarCurr) ) ) ).

tff(writeUnaryOperator_7708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120201(VarCurr)
    <=> v120167(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5209,axiom,
    ! [VarCurr: state_type] :
      ( v120198(VarCurr)
    <=> ( v120199(VarCurr)
        | v120167(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120199(VarCurr)
    <=> v120167(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14062,axiom,
    ! [VarCurr: state_type] :
      ( v120189(VarCurr)
    <=> ( v120191(VarCurr)
        | v120192(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5208,axiom,
    ! [VarCurr: state_type] :
      ( v120192(VarCurr)
    <=> ( v119519(VarCurr,1)
        & v120032(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5207,axiom,
    ! [VarCurr: state_type] :
      ( v120191(VarCurr)
    <=> ( v119519(VarCurr,3)
        & v120090(VarCurr) ) ) ).

tff(addAssignment_69578,axiom,
    ! [VarCurr: state_type] :
      ( v120177(VarCurr)
    <=> v120179(VarCurr) ) ).

tff(addAssignment_69577,axiom,
    ! [VarCurr: state_type] :
      ( v120179(VarCurr)
    <=> v119537(VarCurr) ) ).

tff(addAssignment_69576,axiom,
    ! [VarCurr: state_type] :
      ( v120173(VarCurr)
    <=> v120175(VarCurr) ) ).

tff(addAssignment_69575,axiom,
    ! [VarCurr: state_type] :
      ( v120175(VarCurr)
    <=> v119529(VarCurr) ) ).

tff(addAssignment_69574,axiom,
    ! [VarCurr: state_type] :
      ( v119519(VarCurr,1)
    <=> v119521(VarCurr,1) ) ).

tff(addAssignment_69573,axiom,
    ! [VarCurr: state_type] :
      ( v119521(VarCurr,1)
    <=> v119523(VarCurr,1) ) ).

tff(addAssignment_69572,axiom,
    ! [VarNext: state_type] :
      ( v119523(VarNext,1)
    <=> v120157(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120158(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120157(VarNext,B)
            <=> v119523(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1561,axiom,
    ! [VarNext: state_type] :
      ( v120158(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120157(VarNext,B)
          <=> v120083(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120158(VarNext)
      <=> v120159(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120159(VarNext)
      <=> ( v120161(VarNext)
          & v120068(VarNext) ) ) ) ).

tff(writeUnaryOperator_7706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120161(VarNext)
      <=> v120077(VarNext) ) ) ).

tff(addAssignment_69571,axiom,
    ! [VarCurr: state_type] :
      ( v119541(VarCurr,1)
    <=> v119543(VarCurr,1) ) ).

tff(addAssignment_69570,axiom,
    ! [VarCurr: state_type] :
      ( v119543(VarCurr,1)
    <=> v119545(VarCurr,1) ) ).

tff(addAssignment_69569,axiom,
    ! [VarCurr: state_type] :
      ( v119545(VarCurr,1)
    <=> v120066(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_53,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120148(VarCurr)
     => ( v119547(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_82,axiom,
    ! [VarCurr: state_type] :
      ( v120148(VarCurr)
     => ( v119547(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14059,axiom,
    ! [VarCurr: state_type] :
      ( v120148(VarCurr)
    <=> ( v120149(VarCurr)
        | v120150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14058,axiom,
    ! [VarCurr: state_type] :
      ( v120150(VarCurr)
    <=> ( v120151(VarCurr)
        & v120152(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14057,axiom,
    ! [VarCurr: state_type] :
      ( v120152(VarCurr)
    <=> ( v120153(VarCurr)
        & v120049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14056,axiom,
    ! [VarCurr: state_type] :
      ( v120153(VarCurr)
    <=> ( v120154(VarCurr)
        & v120155(VarCurr) ) ) ).

tff(writeUnaryOperator_7705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120155(VarCurr)
    <=> v120041(VarCurr) ) ).

tff(writeUnaryOperator_7704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120154(VarCurr)
    <=> v120032(VarCurr) ) ).

tff(writeUnaryOperator_7703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120151(VarCurr)
    <=> v120051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14055,axiom,
    ! [VarCurr: state_type] :
      ( v120149(VarCurr)
    <=> ( v120123(VarCurr)
        & v120051(VarCurr) ) ) ).

tff(writeUnaryOperator_7702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119519(VarCurr,0)
    <=> v120028(VarCurr) ) ).

tff(addAssignment_69568,axiom,
    ! [VarCurr: state_type] :
      ( v120028(VarCurr)
    <=> v119521(VarCurr,0) ) ).

tff(addAssignment_69567,axiom,
    ! [VarCurr: state_type] :
      ( v119521(VarCurr,0)
    <=> v119523(VarCurr,0) ) ).

tff(addAssignment_69566,axiom,
    ! [VarNext: state_type] :
      ( v119523(VarNext,0)
    <=> v120139(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120140(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120139(VarNext,B)
            <=> v119523(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1560,axiom,
    ! [VarNext: state_type] :
      ( v120140(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120139(VarNext,B)
          <=> v120083(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120140(VarNext)
      <=> v120141(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120141(VarNext)
      <=> ( v120143(VarNext)
          & v120068(VarNext) ) ) ) ).

tff(writeUnaryOperator_7701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120143(VarNext)
      <=> v120077(VarNext) ) ) ).

tff(addAssignment_69565,axiom,
    ! [VarCurr: state_type] :
      ( v119541(VarCurr,0)
    <=> v119543(VarCurr,0) ) ).

tff(addAssignment_69564,axiom,
    ! [VarCurr: state_type] :
      ( v119543(VarCurr,0)
    <=> v119545(VarCurr,0) ) ).

tff(addAssignment_69563,axiom,
    ! [VarCurr: state_type] :
      ( v119545(VarCurr,0)
    <=> v120066(VarCurr,0) ) ).

tff(writeUnaryOperator_7700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120030(VarCurr)
    <=> v119547(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120118(VarCurr)
     => ( v119547(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1101,axiom,
    ! [VarCurr: state_type] :
      ( v120118(VarCurr)
     => ( v119547(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14052,axiom,
    ! [VarCurr: state_type] :
      ( v120118(VarCurr)
    <=> ( v120119(VarCurr)
        | v120132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14051,axiom,
    ! [VarCurr: state_type] :
      ( v120132(VarCurr)
    <=> ( v120133(VarCurr)
        & v120136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14050,axiom,
    ! [VarCurr: state_type] :
      ( v120136(VarCurr)
    <=> ( v120104(VarCurr)
        & v120107(VarCurr) ) ) ).

tff(writeUnaryOperator_7699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120133(VarCurr)
    <=> v120134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14049,axiom,
    ! [VarCurr: state_type] :
      ( v120134(VarCurr)
    <=> ( v120135(VarCurr)
        | v120064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14048,axiom,
    ! [VarCurr: state_type] :
      ( v120135(VarCurr)
    <=> ( v120051(VarCurr)
        | v120049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14047,axiom,
    ! [VarCurr: state_type] :
      ( v120119(VarCurr)
    <=> ( v120120(VarCurr)
        | v120128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14046,axiom,
    ! [VarCurr: state_type] :
      ( v120128(VarCurr)
    <=> ( v120129(VarCurr)
        & v120131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14045,axiom,
    ! [VarCurr: state_type] :
      ( v120131(VarCurr)
    <=> ( v120062(VarCurr)
        & v120064(VarCurr) ) ) ).

tff(writeUnaryOperator_7698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120129(VarCurr)
    <=> v120130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14044,axiom,
    ! [VarCurr: state_type] :
      ( v120130(VarCurr)
    <=> ( v120051(VarCurr)
        | v120049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14043,axiom,
    ! [VarCurr: state_type] :
      ( v120120(VarCurr)
    <=> ( v120121(VarCurr)
        | v120125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14042,axiom,
    ! [VarCurr: state_type] :
      ( v120125(VarCurr)
    <=> ( v120126(VarCurr)
        & v120127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14041,axiom,
    ! [VarCurr: state_type] :
      ( v120127(VarCurr)
    <=> ( v120041(VarCurr)
        & v120049(VarCurr) ) ) ).

tff(writeUnaryOperator_7697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120126(VarCurr)
    <=> v120051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14040,axiom,
    ! [VarCurr: state_type] :
      ( v120121(VarCurr)
    <=> ( v120122(VarCurr)
        & v120051(VarCurr) ) ) ).

tff(writeUnaryOperator_7696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120122(VarCurr)
    <=> v120123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14039,axiom,
    ! [VarCurr: state_type] :
      ( v120123(VarCurr)
    <=> ( v120124(VarCurr)
        & v120026(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14038,axiom,
    ! [VarCurr: state_type] :
      ( v120124(VarCurr)
    <=> ( v119549(VarCurr)
        & v120024(VarCurr) ) ) ).

tff(addAssignment_69562,axiom,
    ! [VarCurr: state_type] :
      ( v119519(VarCurr,3)
    <=> v119521(VarCurr,3) ) ).

tff(addAssignment_69561,axiom,
    ! [VarCurr: state_type] :
      ( v119521(VarCurr,3)
    <=> v119523(VarCurr,3) ) ).

tff(addAssignment_69560,axiom,
    ! [VarNext: state_type] :
      ( v119523(VarNext,3)
    <=> v120110(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120111(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120110(VarNext,B)
            <=> v119523(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1559,axiom,
    ! [VarNext: state_type] :
      ( v120111(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120110(VarNext,B)
          <=> v120083(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120111(VarNext)
      <=> v120112(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120112(VarNext)
      <=> ( v120114(VarNext)
          & v120068(VarNext) ) ) ) ).

tff(writeUnaryOperator_7695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120114(VarNext)
      <=> v120077(VarNext) ) ) ).

tff(addAssignment_69559,axiom,
    ! [VarCurr: state_type] :
      ( v119541(VarCurr,3)
    <=> v119543(VarCurr,3) ) ).

tff(addAssignment_69558,axiom,
    ! [VarCurr: state_type] :
      ( v119543(VarCurr,3)
    <=> v119545(VarCurr,3) ) ).

tff(addAssignment_69557,axiom,
    ! [VarCurr: state_type] :
      ( v119545(VarCurr,3)
    <=> v120066(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_52,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120092(VarCurr)
     => ( v119547(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_81,axiom,
    ! [VarCurr: state_type] :
      ( v120092(VarCurr)
     => ( v119547(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14035,axiom,
    ! [VarCurr: state_type] :
      ( v120092(VarCurr)
    <=> ( v120093(VarCurr)
        | v120099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14034,axiom,
    ! [VarCurr: state_type] :
      ( v120099(VarCurr)
    <=> ( v120100(VarCurr)
        & v120101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14033,axiom,
    ! [VarCurr: state_type] :
      ( v120101(VarCurr)
    <=> ( v120102(VarCurr)
        & v120108(VarCurr) ) ) ).

tff(writeUnaryOperator_7694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120108(VarCurr)
    <=> v120098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14032,axiom,
    ! [VarCurr: state_type] :
      ( v120102(VarCurr)
    <=> ( v120103(VarCurr)
        & v120107(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1191,axiom,
    ! [VarCurr: state_type] :
      ( v120107(VarCurr)
    <=> ( $true
      <=> v119519(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120103(VarCurr)
    <=> v120104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14031,axiom,
    ! [VarCurr: state_type] :
      ( v120104(VarCurr)
    <=> ( v120105(VarCurr)
        | v120034(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14030,axiom,
    ! [VarCurr: state_type] :
      ( v120105(VarCurr)
    <=> ( v120106(VarCurr)
        | v120090(VarCurr) ) ) ).

tff(writeUnaryOperator_7692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120106(VarCurr)
    <=> v120024(VarCurr) ) ).

tff(writeUnaryOperator_7691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120100(VarCurr)
    <=> v120064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14029,axiom,
    ! [VarCurr: state_type] :
      ( v120093(VarCurr)
    <=> ( v120094(VarCurr)
        & v120097(VarCurr) ) ) ).

tff(writeUnaryOperator_7690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120097(VarCurr)
    <=> v120098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14028,axiom,
    ! [VarCurr: state_type] :
      ( v120098(VarCurr)
    <=> ( v120051(VarCurr)
        | v120049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14027,axiom,
    ! [VarCurr: state_type] :
      ( v120094(VarCurr)
    <=> ( v120095(VarCurr)
        & v120064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14026,axiom,
    ! [VarCurr: state_type] :
      ( v120095(VarCurr)
    <=> ( v120058(VarCurr)
        & v120096(VarCurr) ) ) ).

tff(writeUnaryOperator_7689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120096(VarCurr)
    <=> v120062(VarCurr) ) ).

tff(addAssignment_69556,axiom,
    ! [VarCurr: state_type] :
      ( v120090(VarCurr)
    <=> v112831(VarCurr,7) ) ).

tff(addAssignment_69555,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,7)
    <=> v112865(VarCurr,7) ) ).

tff(addAssignment_69554,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,7)
    <=> v112849(VarCurr,7) ) ).

tff(addAssignment_69553,axiom,
    ! [VarCurr: state_type] :
      ( v119519(VarCurr,2)
    <=> v119521(VarCurr,2) ) ).

tff(addAssignment_69552,axiom,
    ! [VarCurr: state_type] :
      ( v119521(VarCurr,2)
    <=> v119523(VarCurr,2) ) ).

tff(addAssignment_69551,axiom,
    ! [VarNext: state_type] :
      ( v119523(VarNext,2)
    <=> v120072(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120073(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v120072(VarNext,B)
            <=> v119523(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1558,axiom,
    ! [VarNext: state_type] :
      ( v120073(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120072(VarNext,B)
          <=> v120083(VarNext,B) ) ) ) ).

tff(addAssignment_69550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120083(VarNext,B)
          <=> v120081(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120084(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120081(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1100,axiom,
    ! [VarCurr: state_type] :
      ( v120084(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v120081(VarCurr,B)
          <=> v119541(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14025,axiom,
    ! [VarCurr: state_type] :
      ( v120084(VarCurr)
    <=> ( v120085(VarCurr)
        & v120086(VarCurr) ) ) ).

tff(writeUnaryOperator_7688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120086(VarCurr)
    <=> v119533(VarCurr) ) ).

tff(writeUnaryOperator_7687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120085(VarCurr)
    <=> v119525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120073(VarNext)
      <=> v120074(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120074(VarNext)
      <=> ( v120075(VarNext)
          & v120068(VarNext) ) ) ) ).

tff(writeUnaryOperator_7686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120075(VarNext)
      <=> v120077(VarNext) ) ) ).

tff(addAssignment_69549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120077(VarNext)
      <=> v120068(VarCurr) ) ) ).

tff(addAssignment_69548,axiom,
    ! [VarCurr: state_type] :
      ( v120068(VarCurr)
    <=> v120070(VarCurr) ) ).

tff(addAssignment_69547,axiom,
    ! [VarCurr: state_type] :
      ( v120070(VarCurr)
    <=> v119999(VarCurr) ) ).

tff(addAssignment_69546,axiom,
    ! [VarCurr: state_type] :
      ( v119541(VarCurr,2)
    <=> v119543(VarCurr,2) ) ).

tff(addAssignment_69545,axiom,
    ! [VarCurr: state_type] :
      ( v119543(VarCurr,2)
    <=> v119545(VarCurr,2) ) ).

tff(addAssignment_69544,axiom,
    ! [VarCurr: state_type] :
      ( v119545(VarCurr,2)
    <=> v120066(VarCurr,2) ) ).

tff(addAssignment_69543,axiom,
    ! [VarCurr: state_type] :
      ( v120066(VarCurr,0)
    <=> v120030(VarCurr) ) ).

tff(addAssignment_69542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v120066(VarCurr,B)
      <=> v119547(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_51,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120036(VarCurr)
     => ( v119547(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_80,axiom,
    ! [VarCurr: state_type] :
      ( v120036(VarCurr)
     => ( v119547(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14022,axiom,
    ! [VarCurr: state_type] :
      ( v120036(VarCurr)
    <=> ( v120037(VarCurr)
        | v120052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14021,axiom,
    ! [VarCurr: state_type] :
      ( v120052(VarCurr)
    <=> ( v120053(VarCurr)
        & v120054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14020,axiom,
    ! [VarCurr: state_type] :
      ( v120054(VarCurr)
    <=> ( v120055(VarCurr)
        & v120065(VarCurr) ) ) ).

tff(writeUnaryOperator_7685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120065(VarCurr)
    <=> v120051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14019,axiom,
    ! [VarCurr: state_type] :
      ( v120055(VarCurr)
    <=> ( v120056(VarCurr)
        & v120064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1190,axiom,
    ! [VarCurr: state_type] :
      ( v120064(VarCurr)
    <=> ( $true
      <=> v119519(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14018,axiom,
    ! [VarCurr: state_type] :
      ( v120056(VarCurr)
    <=> ( v120057(VarCurr)
        & v120061(VarCurr) ) ) ).

tff(writeUnaryOperator_7684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120061(VarCurr)
    <=> v120062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14017,axiom,
    ! [VarCurr: state_type] :
      ( v120062(VarCurr)
    <=> ( v120063(VarCurr)
        | v120034(VarCurr) ) ) ).

tff(writeUnaryOperator_7683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120063(VarCurr)
    <=> v120024(VarCurr) ) ).

tff(writeUnaryOperator_7682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120057(VarCurr)
    <=> v120058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14016,axiom,
    ! [VarCurr: state_type] :
      ( v120058(VarCurr)
    <=> ( v120059(VarCurr)
        | v120060(VarCurr) ) ) ).

tff(writeUnaryOperator_7681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120060(VarCurr)
    <=> v120026(VarCurr) ) ).

tff(writeUnaryOperator_7680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120059(VarCurr)
    <=> v119549(VarCurr) ) ).

tff(writeUnaryOperator_7679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120053(VarCurr)
    <=> v120049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14015,axiom,
    ! [VarCurr: state_type] :
      ( v120037(VarCurr)
    <=> ( v120038(VarCurr)
        & v120050(VarCurr) ) ) ).

tff(writeUnaryOperator_7678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120050(VarCurr)
    <=> v120051(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1189,axiom,
    ! [VarCurr: state_type] :
      ( v120051(VarCurr)
    <=> ( $true
      <=> v119519(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14014,axiom,
    ! [VarCurr: state_type] :
      ( v120038(VarCurr)
    <=> ( v120039(VarCurr)
        & v120049(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1188,axiom,
    ! [VarCurr: state_type] :
      ( v120049(VarCurr)
    <=> ( $true
      <=> v119519(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14013,axiom,
    ! [VarCurr: state_type] :
      ( v120039(VarCurr)
    <=> ( v120032(VarCurr)
        & v120040(VarCurr) ) ) ).

tff(writeUnaryOperator_7677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120040(VarCurr)
    <=> v120041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14012,axiom,
    ! [VarCurr: state_type] :
      ( v120041(VarCurr)
    <=> ( v120042(VarCurr)
        | v120034(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14011,axiom,
    ! [VarCurr: state_type] :
      ( v120042(VarCurr)
    <=> ( v120043(VarCurr)
        | v120046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14010,axiom,
    ! [VarCurr: state_type] :
      ( v120046(VarCurr)
    <=> ( v120047(VarCurr)
        & v120048(VarCurr) ) ) ).

tff(writeUnaryOperator_7676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120048(VarCurr)
    <=> v120032(VarCurr) ) ).

tff(writeUnaryOperator_7675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120047(VarCurr)
    <=> v119549(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14009,axiom,
    ! [VarCurr: state_type] :
      ( v120043(VarCurr)
    <=> ( v120044(VarCurr)
        | v120045(VarCurr) ) ) ).

tff(writeUnaryOperator_7674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120045(VarCurr)
    <=> v120026(VarCurr) ) ).

tff(writeUnaryOperator_7673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120044(VarCurr)
    <=> v120024(VarCurr) ) ).

tff(addAssignment_69541,axiom,
    ! [VarCurr: state_type] :
      ( v120034(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_69540,axiom,
    ! [VarCurr: state_type] :
      ( v120032(VarCurr)
    <=> v112643(VarCurr,7) ) ).

tff(addAssignment_69539,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,7)
    <=> v115202(VarCurr,7) ) ).

tff(addAssignment_69538,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,7)
    <=> v115186(VarCurr,7) ) ).

tff(addAssignment_69537,axiom,
    ! [VarCurr: state_type] :
      ( v120026(VarCurr)
    <=> v112528(VarCurr,7) ) ).

tff(addAssignment_69536,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,7)
    <=> v112530(VarCurr,7) ) ).

tff(addAssignment_69535,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,7)
    <=> v112590(VarCurr,7) ) ).

tff(addAssignment_69534,axiom,
    ! [VarCurr: state_type] :
      ( v120024(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14008,axiom,
    ! [VarCurr: state_type] :
      ( v119549(VarCurr)
    <=> ( v120021(VarCurr)
        & v120022(VarCurr) ) ) ).

tff(writeUnaryOperator_7672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120022(VarCurr)
    <=> v120019(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1187,axiom,
    ! [VarCurr: state_type] :
      ( v120021(VarCurr)
    <=> ( ( v119551(VarCurr,5)
        <=> $false )
        & ( v119551(VarCurr,4)
        <=> $false )
        & ( v119551(VarCurr,3)
        <=> $false )
        & ( v119551(VarCurr,2)
        <=> $false )
        & ( v119551(VarCurr,1)
        <=> $false )
        & ( v119551(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69533,axiom,
    ! [VarCurr: state_type] :
      ( v120019(VarCurr)
    <=> v115139(VarCurr,7) ) ).

tff(addAssignment_69532,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,7)
    <=> v115159(VarCurr,7) ) ).

tff(addAssignment_69531,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,7)
    <=> v115142(VarCurr,7) ) ).

tff(addAssignment_69530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v119551(VarCurr,B)
      <=> v119553(VarCurr,B) ) ) ).

tff(addAssignment_69529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v119553(VarCurr,B)
      <=> v119555(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v119555(VarNext,B)
            <=> v119555(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1557,axiom,
    ! [VarNext: state_type] :
      ( v120002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v119555(VarNext,B)
          <=> v120012(VarNext,B) ) ) ) ).

tff(addAssignment_69528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120012(VarNext,B)
          <=> v120010(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120010(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1099,axiom,
    ! [VarCurr: state_type] :
      ( v120013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v120010(VarCurr,B)
          <=> v119565(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14007,axiom,
    ! [VarCurr: state_type] :
      ( v120013(VarCurr)
    <=> ( v120014(VarCurr)
        & v120015(VarCurr) ) ) ).

tff(writeUnaryOperator_7671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120015(VarCurr)
    <=> v119561(VarCurr) ) ).

tff(writeUnaryOperator_7670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v120014(VarCurr)
    <=> v119557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120002(VarNext)
      <=> v120003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120003(VarNext)
      <=> ( v120004(VarNext)
          & v119995(VarNext) ) ) ) ).

tff(writeUnaryOperator_7669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v120004(VarNext)
      <=> v120006(VarNext) ) ) ).

tff(addAssignment_69527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v120006(VarNext)
      <=> v119995(VarCurr) ) ) ).

tff(addAssignment_69526,axiom,
    ! [VarCurr: state_type] :
      ( v119995(VarCurr)
    <=> v119997(VarCurr) ) ).

tff(addAssignment_69525,axiom,
    ! [VarCurr: state_type] :
      ( v119997(VarCurr)
    <=> v119999(VarCurr) ) ).

tff(addAssignment_69524,axiom,
    ! [VarCurr: state_type] :
      ( v119999(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_69523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v119565(VarCurr,B)
      <=> v119567(VarCurr,B) ) ) ).

tff(addAssignment_69522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v119567(VarCurr,B)
      <=> v119569(VarCurr,B) ) ) ).

tff(addAssignment_69521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v119569(VarCurr,B)
      <=> v119571(VarCurr,B) ) ) ).

tff(addAssignment_69520,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,0)
    <=> v119990(VarCurr) ) ).

tff(addAssignment_69519,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,1)
    <=> v119985(VarCurr) ) ).

tff(addAssignment_69518,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,2)
    <=> v119980(VarCurr) ) ).

tff(addAssignment_69517,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,3)
    <=> v119975(VarCurr) ) ).

tff(addAssignment_69516,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,4)
    <=> v119970(VarCurr) ) ).

tff(addAssignment_69515,axiom,
    ! [VarCurr: state_type] :
      ( v119571(VarCurr,5)
    <=> v119827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14004,axiom,
    ! [VarCurr: state_type] :
      ( v119990(VarCurr)
    <=> ( v119991(VarCurr)
        & v119993(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14003,axiom,
    ! [VarCurr: state_type] :
      ( v119993(VarCurr)
    <=> ( v119782(VarCurr,0)
        | v119839(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14002,axiom,
    ! [VarCurr: state_type] :
      ( v119991(VarCurr)
    <=> ( v119916(VarCurr)
        | v119992(VarCurr) ) ) ).

tff(writeUnaryOperator_7668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119992(VarCurr)
    <=> v119839(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14001,axiom,
    ! [VarCurr: state_type] :
      ( v119985(VarCurr)
    <=> ( v119986(VarCurr)
        & v119989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14000,axiom,
    ! [VarCurr: state_type] :
      ( v119989(VarCurr)
    <=> ( v119838(VarCurr)
        | v119910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13999,axiom,
    ! [VarCurr: state_type] :
      ( v119986(VarCurr)
    <=> ( v119987(VarCurr)
        | v119988(VarCurr) ) ) ).

tff(writeUnaryOperator_7667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119988(VarCurr)
    <=> v119910(VarCurr) ) ).

tff(writeUnaryOperator_7666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119987(VarCurr)
    <=> v119838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13998,axiom,
    ! [VarCurr: state_type] :
      ( v119980(VarCurr)
    <=> ( v119981(VarCurr)
        & v119984(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13997,axiom,
    ! [VarCurr: state_type] :
      ( v119984(VarCurr)
    <=> ( v119836(VarCurr)
        | v119921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13996,axiom,
    ! [VarCurr: state_type] :
      ( v119981(VarCurr)
    <=> ( v119982(VarCurr)
        | v119983(VarCurr) ) ) ).

tff(writeUnaryOperator_7665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119983(VarCurr)
    <=> v119921(VarCurr) ) ).

tff(writeUnaryOperator_7664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119982(VarCurr)
    <=> v119836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13995,axiom,
    ! [VarCurr: state_type] :
      ( v119975(VarCurr)
    <=> ( v119976(VarCurr)
        & v119979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13994,axiom,
    ! [VarCurr: state_type] :
      ( v119979(VarCurr)
    <=> ( v119834(VarCurr)
        | v119933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13993,axiom,
    ! [VarCurr: state_type] :
      ( v119976(VarCurr)
    <=> ( v119977(VarCurr)
        | v119978(VarCurr) ) ) ).

tff(writeUnaryOperator_7663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119978(VarCurr)
    <=> v119933(VarCurr) ) ).

tff(writeUnaryOperator_7662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119977(VarCurr)
    <=> v119834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13992,axiom,
    ! [VarCurr: state_type] :
      ( v119970(VarCurr)
    <=> ( v119971(VarCurr)
        & v119974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13991,axiom,
    ! [VarCurr: state_type] :
      ( v119974(VarCurr)
    <=> ( v119832(VarCurr)
        | v119945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13990,axiom,
    ! [VarCurr: state_type] :
      ( v119971(VarCurr)
    <=> ( v119972(VarCurr)
        | v119973(VarCurr) ) ) ).

tff(writeUnaryOperator_7661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119973(VarCurr)
    <=> v119945(VarCurr) ) ).

tff(writeUnaryOperator_7660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119972(VarCurr)
    <=> v119832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13989,axiom,
    ! [VarCurr: state_type] :
      ( v119827(VarCurr)
    <=> ( v119828(VarCurr)
        & v119969(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13988,axiom,
    ! [VarCurr: state_type] :
      ( v119969(VarCurr)
    <=> ( v119830(VarCurr)
        | v119958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13987,axiom,
    ! [VarCurr: state_type] :
      ( v119828(VarCurr)
    <=> ( v119829(VarCurr)
        | v119957(VarCurr) ) ) ).

tff(writeUnaryOperator_7659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119957(VarCurr)
    <=> v119958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13986,axiom,
    ! [VarCurr: state_type] :
      ( v119958(VarCurr)
    <=> ( v119959(VarCurr)
        & v119968(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5206,axiom,
    ! [VarCurr: state_type] :
      ( v119968(VarCurr)
    <=> ( v119961(VarCurr)
        | v119839(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13985,axiom,
    ! [VarCurr: state_type] :
      ( v119959(VarCurr)
    <=> ( v119960(VarCurr)
        | v119967(VarCurr) ) ) ).

tff(writeUnaryOperator_7658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119967(VarCurr)
    <=> v119839(VarCurr,5) ) ).

tff(writeUnaryOperator_7657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119960(VarCurr)
    <=> v119961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13984,axiom,
    ! [VarCurr: state_type] :
      ( v119961(VarCurr)
    <=> ( v119962(VarCurr)
        & v119965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13983,axiom,
    ! [VarCurr: state_type] :
      ( v119965(VarCurr)
    <=> ( v119964(VarCurr)
        | v119966(VarCurr) ) ) ).

tff(writeUnaryOperator_7656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119966(VarCurr)
    <=> v119782(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5205,axiom,
    ! [VarCurr: state_type] :
      ( v119962(VarCurr)
    <=> ( v119963(VarCurr)
        | v119782(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119963(VarCurr)
    <=> v119964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13982,axiom,
    ! [VarCurr: state_type] :
      ( v119964(VarCurr)
    <=> ( v119951(VarCurr)
        & v119953(VarCurr) ) ) ).

tff(writeUnaryOperator_7654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119829(VarCurr)
    <=> v119830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13981,axiom,
    ! [VarCurr: state_type] :
      ( v119830(VarCurr)
    <=> ( v119831(VarCurr)
        | v119956(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5204,axiom,
    ! [VarCurr: state_type] :
      ( v119956(VarCurr)
    <=> ( v119948(VarCurr)
        & v119839(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13980,axiom,
    ! [VarCurr: state_type] :
      ( v119831(VarCurr)
    <=> ( v119832(VarCurr)
        & v119945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13979,axiom,
    ! [VarCurr: state_type] :
      ( v119945(VarCurr)
    <=> ( v119946(VarCurr)
        & v119955(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5203,axiom,
    ! [VarCurr: state_type] :
      ( v119955(VarCurr)
    <=> ( v119948(VarCurr)
        | v119839(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13978,axiom,
    ! [VarCurr: state_type] :
      ( v119946(VarCurr)
    <=> ( v119947(VarCurr)
        | v119954(VarCurr) ) ) ).

tff(writeUnaryOperator_7653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119954(VarCurr)
    <=> v119839(VarCurr,4) ) ).

tff(writeUnaryOperator_7652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119947(VarCurr)
    <=> v119948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13977,axiom,
    ! [VarCurr: state_type] :
      ( v119948(VarCurr)
    <=> ( v119949(VarCurr)
        & v119952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13976,axiom,
    ! [VarCurr: state_type] :
      ( v119952(VarCurr)
    <=> ( v119951(VarCurr)
        | v119953(VarCurr) ) ) ).

tff(writeUnaryOperator_7651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119953(VarCurr)
    <=> v119782(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5202,axiom,
    ! [VarCurr: state_type] :
      ( v119949(VarCurr)
    <=> ( v119950(VarCurr)
        | v119782(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119950(VarCurr)
    <=> v119951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13975,axiom,
    ! [VarCurr: state_type] :
      ( v119951(VarCurr)
    <=> ( v119939(VarCurr)
        & v119941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13974,axiom,
    ! [VarCurr: state_type] :
      ( v119832(VarCurr)
    <=> ( v119833(VarCurr)
        | v119944(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5201,axiom,
    ! [VarCurr: state_type] :
      ( v119944(VarCurr)
    <=> ( v119936(VarCurr)
        & v119839(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13973,axiom,
    ! [VarCurr: state_type] :
      ( v119833(VarCurr)
    <=> ( v119834(VarCurr)
        & v119933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13972,axiom,
    ! [VarCurr: state_type] :
      ( v119933(VarCurr)
    <=> ( v119934(VarCurr)
        & v119943(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5200,axiom,
    ! [VarCurr: state_type] :
      ( v119943(VarCurr)
    <=> ( v119936(VarCurr)
        | v119839(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13971,axiom,
    ! [VarCurr: state_type] :
      ( v119934(VarCurr)
    <=> ( v119935(VarCurr)
        | v119942(VarCurr) ) ) ).

tff(writeUnaryOperator_7649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119942(VarCurr)
    <=> v119839(VarCurr,3) ) ).

tff(writeUnaryOperator_7648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119935(VarCurr)
    <=> v119936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13970,axiom,
    ! [VarCurr: state_type] :
      ( v119936(VarCurr)
    <=> ( v119937(VarCurr)
        & v119940(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13969,axiom,
    ! [VarCurr: state_type] :
      ( v119940(VarCurr)
    <=> ( v119939(VarCurr)
        | v119941(VarCurr) ) ) ).

tff(writeUnaryOperator_7647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119941(VarCurr)
    <=> v119782(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5199,axiom,
    ! [VarCurr: state_type] :
      ( v119937(VarCurr)
    <=> ( v119938(VarCurr)
        | v119782(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119938(VarCurr)
    <=> v119939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13968,axiom,
    ! [VarCurr: state_type] :
      ( v119939(VarCurr)
    <=> ( v119927(VarCurr)
        & v119929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13967,axiom,
    ! [VarCurr: state_type] :
      ( v119834(VarCurr)
    <=> ( v119835(VarCurr)
        | v119932(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5198,axiom,
    ! [VarCurr: state_type] :
      ( v119932(VarCurr)
    <=> ( v119924(VarCurr)
        & v119839(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13966,axiom,
    ! [VarCurr: state_type] :
      ( v119835(VarCurr)
    <=> ( v119836(VarCurr)
        & v119921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13965,axiom,
    ! [VarCurr: state_type] :
      ( v119921(VarCurr)
    <=> ( v119922(VarCurr)
        & v119931(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5197,axiom,
    ! [VarCurr: state_type] :
      ( v119931(VarCurr)
    <=> ( v119924(VarCurr)
        | v119839(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13964,axiom,
    ! [VarCurr: state_type] :
      ( v119922(VarCurr)
    <=> ( v119923(VarCurr)
        | v119930(VarCurr) ) ) ).

tff(writeUnaryOperator_7645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119930(VarCurr)
    <=> v119839(VarCurr,2) ) ).

tff(writeUnaryOperator_7644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119923(VarCurr)
    <=> v119924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13963,axiom,
    ! [VarCurr: state_type] :
      ( v119924(VarCurr)
    <=> ( v119925(VarCurr)
        & v119928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13962,axiom,
    ! [VarCurr: state_type] :
      ( v119928(VarCurr)
    <=> ( v119927(VarCurr)
        | v119929(VarCurr) ) ) ).

tff(writeUnaryOperator_7643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119929(VarCurr)
    <=> v119782(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5196,axiom,
    ! [VarCurr: state_type] :
      ( v119925(VarCurr)
    <=> ( v119926(VarCurr)
        | v119782(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119926(VarCurr)
    <=> v119927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13961,axiom,
    ! [VarCurr: state_type] :
      ( v119927(VarCurr)
    <=> ( v119916(VarCurr)
        & v119917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13960,axiom,
    ! [VarCurr: state_type] :
      ( v119836(VarCurr)
    <=> ( v119837(VarCurr)
        | v119920(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5195,axiom,
    ! [VarCurr: state_type] :
      ( v119920(VarCurr)
    <=> ( v119913(VarCurr)
        & v119839(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13959,axiom,
    ! [VarCurr: state_type] :
      ( v119837(VarCurr)
    <=> ( v119838(VarCurr)
        & v119910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13958,axiom,
    ! [VarCurr: state_type] :
      ( v119910(VarCurr)
    <=> ( v119911(VarCurr)
        & v119919(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5194,axiom,
    ! [VarCurr: state_type] :
      ( v119919(VarCurr)
    <=> ( v119913(VarCurr)
        | v119839(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13957,axiom,
    ! [VarCurr: state_type] :
      ( v119911(VarCurr)
    <=> ( v119912(VarCurr)
        | v119918(VarCurr) ) ) ).

tff(writeUnaryOperator_7641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119918(VarCurr)
    <=> v119839(VarCurr,1) ) ).

tff(writeUnaryOperator_7640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119912(VarCurr)
    <=> v119913(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13956,axiom,
    ! [VarCurr: state_type] :
      ( v119913(VarCurr)
    <=> ( v119914(VarCurr)
        & v119915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13955,axiom,
    ! [VarCurr: state_type] :
      ( v119915(VarCurr)
    <=> ( v119916(VarCurr)
        | v119917(VarCurr) ) ) ).

tff(writeUnaryOperator_7639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119917(VarCurr)
    <=> v119782(VarCurr,1) ) ).

tff(writeUnaryOperator_7638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119916(VarCurr)
    <=> v119782(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5193,axiom,
    ! [VarCurr: state_type] :
      ( v119914(VarCurr)
    <=> ( v119782(VarCurr,0)
        | v119782(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13954,axiom,
    ! [VarCurr: state_type] :
      ( v119838(VarCurr)
    <=> ( v119782(VarCurr,0)
        & v119839(VarCurr,0) ) ) ).

tff(addAssignment_69514,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,0)
    <=> v119905(VarCurr) ) ).

tff(addAssignment_69513,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,1)
    <=> v119900(VarCurr) ) ).

tff(addAssignment_69512,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,2)
    <=> v119895(VarCurr) ) ).

tff(addAssignment_69511,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,3)
    <=> v119890(VarCurr) ) ).

tff(addAssignment_69510,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,4)
    <=> v119885(VarCurr) ) ).

tff(addAssignment_69509,axiom,
    ! [VarCurr: state_type] :
      ( v119839(VarCurr,5)
    <=> v119841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13953,axiom,
    ! [VarCurr: state_type] :
      ( v119905(VarCurr)
    <=> ( v119906(VarCurr)
        & v119909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13952,axiom,
    ! [VarCurr: state_type] :
      ( v119909(VarCurr)
    <=> ( v119551(VarCurr,0)
        | v119853(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13951,axiom,
    ! [VarCurr: state_type] :
      ( v119906(VarCurr)
    <=> ( v119907(VarCurr)
        | v119908(VarCurr) ) ) ).

tff(writeUnaryOperator_7637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119908(VarCurr)
    <=> v119853(VarCurr,0) ) ).

tff(writeUnaryOperator_7636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119907(VarCurr)
    <=> v119551(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13950,axiom,
    ! [VarCurr: state_type] :
      ( v119900(VarCurr)
    <=> ( v119901(VarCurr)
        & v119904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13949,axiom,
    ! [VarCurr: state_type] :
      ( v119904(VarCurr)
    <=> ( v119852(VarCurr)
        | v119854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13948,axiom,
    ! [VarCurr: state_type] :
      ( v119901(VarCurr)
    <=> ( v119902(VarCurr)
        | v119903(VarCurr) ) ) ).

tff(writeUnaryOperator_7635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119903(VarCurr)
    <=> v119854(VarCurr) ) ).

tff(writeUnaryOperator_7634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119902(VarCurr)
    <=> v119852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13947,axiom,
    ! [VarCurr: state_type] :
      ( v119895(VarCurr)
    <=> ( v119896(VarCurr)
        & v119899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13946,axiom,
    ! [VarCurr: state_type] :
      ( v119899(VarCurr)
    <=> ( v119850(VarCurr)
        | v119860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13945,axiom,
    ! [VarCurr: state_type] :
      ( v119896(VarCurr)
    <=> ( v119897(VarCurr)
        | v119898(VarCurr) ) ) ).

tff(writeUnaryOperator_7633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119898(VarCurr)
    <=> v119860(VarCurr) ) ).

tff(writeUnaryOperator_7632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119897(VarCurr)
    <=> v119850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13944,axiom,
    ! [VarCurr: state_type] :
      ( v119890(VarCurr)
    <=> ( v119891(VarCurr)
        & v119894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13943,axiom,
    ! [VarCurr: state_type] :
      ( v119894(VarCurr)
    <=> ( v119848(VarCurr)
        | v119866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13942,axiom,
    ! [VarCurr: state_type] :
      ( v119891(VarCurr)
    <=> ( v119892(VarCurr)
        | v119893(VarCurr) ) ) ).

tff(writeUnaryOperator_7631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119893(VarCurr)
    <=> v119866(VarCurr) ) ).

tff(writeUnaryOperator_7630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119892(VarCurr)
    <=> v119848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13941,axiom,
    ! [VarCurr: state_type] :
      ( v119885(VarCurr)
    <=> ( v119886(VarCurr)
        & v119889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13940,axiom,
    ! [VarCurr: state_type] :
      ( v119889(VarCurr)
    <=> ( v119846(VarCurr)
        | v119872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13939,axiom,
    ! [VarCurr: state_type] :
      ( v119886(VarCurr)
    <=> ( v119887(VarCurr)
        | v119888(VarCurr) ) ) ).

tff(writeUnaryOperator_7629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119888(VarCurr)
    <=> v119872(VarCurr) ) ).

tff(writeUnaryOperator_7628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119887(VarCurr)
    <=> v119846(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13938,axiom,
    ! [VarCurr: state_type] :
      ( v119841(VarCurr)
    <=> ( v119842(VarCurr)
        & v119884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13937,axiom,
    ! [VarCurr: state_type] :
      ( v119884(VarCurr)
    <=> ( v119844(VarCurr)
        | v119879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13936,axiom,
    ! [VarCurr: state_type] :
      ( v119842(VarCurr)
    <=> ( v119843(VarCurr)
        | v119878(VarCurr) ) ) ).

tff(writeUnaryOperator_7627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119878(VarCurr)
    <=> v119879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13935,axiom,
    ! [VarCurr: state_type] :
      ( v119879(VarCurr)
    <=> ( v119880(VarCurr)
        & v119883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5192,axiom,
    ! [VarCurr: state_type] :
      ( v119883(VarCurr)
    <=> ( v119551(VarCurr,5)
        | v119853(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13934,axiom,
    ! [VarCurr: state_type] :
      ( v119880(VarCurr)
    <=> ( v119881(VarCurr)
        | v119882(VarCurr) ) ) ).

tff(writeUnaryOperator_7626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119882(VarCurr)
    <=> v119853(VarCurr,5) ) ).

tff(writeUnaryOperator_7625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119881(VarCurr)
    <=> v119551(VarCurr,5) ) ).

tff(writeUnaryOperator_7624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119843(VarCurr)
    <=> v119844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13933,axiom,
    ! [VarCurr: state_type] :
      ( v119844(VarCurr)
    <=> ( v119845(VarCurr)
        | v119877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5191,axiom,
    ! [VarCurr: state_type] :
      ( v119877(VarCurr)
    <=> ( v119551(VarCurr,4)
        & v119853(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13932,axiom,
    ! [VarCurr: state_type] :
      ( v119845(VarCurr)
    <=> ( v119846(VarCurr)
        & v119872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13931,axiom,
    ! [VarCurr: state_type] :
      ( v119872(VarCurr)
    <=> ( v119873(VarCurr)
        & v119876(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5190,axiom,
    ! [VarCurr: state_type] :
      ( v119876(VarCurr)
    <=> ( v119551(VarCurr,4)
        | v119853(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13930,axiom,
    ! [VarCurr: state_type] :
      ( v119873(VarCurr)
    <=> ( v119874(VarCurr)
        | v119875(VarCurr) ) ) ).

tff(writeUnaryOperator_7623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119875(VarCurr)
    <=> v119853(VarCurr,4) ) ).

tff(writeUnaryOperator_7622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119874(VarCurr)
    <=> v119551(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13929,axiom,
    ! [VarCurr: state_type] :
      ( v119846(VarCurr)
    <=> ( v119847(VarCurr)
        | v119871(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5189,axiom,
    ! [VarCurr: state_type] :
      ( v119871(VarCurr)
    <=> ( v119551(VarCurr,3)
        & v119853(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13928,axiom,
    ! [VarCurr: state_type] :
      ( v119847(VarCurr)
    <=> ( v119848(VarCurr)
        & v119866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13927,axiom,
    ! [VarCurr: state_type] :
      ( v119866(VarCurr)
    <=> ( v119867(VarCurr)
        & v119870(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5188,axiom,
    ! [VarCurr: state_type] :
      ( v119870(VarCurr)
    <=> ( v119551(VarCurr,3)
        | v119853(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13926,axiom,
    ! [VarCurr: state_type] :
      ( v119867(VarCurr)
    <=> ( v119868(VarCurr)
        | v119869(VarCurr) ) ) ).

tff(writeUnaryOperator_7621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119869(VarCurr)
    <=> v119853(VarCurr,3) ) ).

tff(writeUnaryOperator_7620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119868(VarCurr)
    <=> v119551(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13925,axiom,
    ! [VarCurr: state_type] :
      ( v119848(VarCurr)
    <=> ( v119849(VarCurr)
        | v119865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5187,axiom,
    ! [VarCurr: state_type] :
      ( v119865(VarCurr)
    <=> ( v119551(VarCurr,2)
        & v119853(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13924,axiom,
    ! [VarCurr: state_type] :
      ( v119849(VarCurr)
    <=> ( v119850(VarCurr)
        & v119860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13923,axiom,
    ! [VarCurr: state_type] :
      ( v119860(VarCurr)
    <=> ( v119861(VarCurr)
        & v119864(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5186,axiom,
    ! [VarCurr: state_type] :
      ( v119864(VarCurr)
    <=> ( v119551(VarCurr,2)
        | v119853(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13922,axiom,
    ! [VarCurr: state_type] :
      ( v119861(VarCurr)
    <=> ( v119862(VarCurr)
        | v119863(VarCurr) ) ) ).

tff(writeUnaryOperator_7619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119863(VarCurr)
    <=> v119853(VarCurr,2) ) ).

tff(writeUnaryOperator_7618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119862(VarCurr)
    <=> v119551(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13921,axiom,
    ! [VarCurr: state_type] :
      ( v119850(VarCurr)
    <=> ( v119851(VarCurr)
        | v119859(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5185,axiom,
    ! [VarCurr: state_type] :
      ( v119859(VarCurr)
    <=> ( v119551(VarCurr,1)
        & v119853(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13920,axiom,
    ! [VarCurr: state_type] :
      ( v119851(VarCurr)
    <=> ( v119852(VarCurr)
        & v119854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13919,axiom,
    ! [VarCurr: state_type] :
      ( v119854(VarCurr)
    <=> ( v119855(VarCurr)
        & v119858(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5184,axiom,
    ! [VarCurr: state_type] :
      ( v119858(VarCurr)
    <=> ( v119551(VarCurr,1)
        | v119853(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13918,axiom,
    ! [VarCurr: state_type] :
      ( v119855(VarCurr)
    <=> ( v119856(VarCurr)
        | v119857(VarCurr) ) ) ).

tff(writeUnaryOperator_7617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119857(VarCurr)
    <=> v119853(VarCurr,1) ) ).

tff(writeUnaryOperator_7616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119856(VarCurr)
    <=> v119551(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13917,axiom,
    ! [VarCurr: state_type] :
      ( v119852(VarCurr)
    <=> ( v119551(VarCurr,0)
        & v119853(VarCurr,0) ) ) ).

tff(addAssignment_69508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v119853(VarCurr,B)
      <=> v119573(VarCurr,B) ) ) ).

tff(addAssignment_69507,axiom,
    ! [VarCurr: state_type] :
      ( ( v119853(VarCurr,5)
      <=> $false )
      & ( v119853(VarCurr,4)
      <=> $false )
      & ( v119853(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_69506,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,5)
    <=> v119819(VarCurr,5) ) ).

tff(addAssignment_69505,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,4)
    <=> v119819(VarCurr,4) ) ).

tff(addAssignment_69504,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,3)
    <=> v119819(VarCurr,3) ) ).

tff(addAssignment_69503,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,2)
    <=> v119819(VarCurr,2) ) ).

tff(addAssignment_69502,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,1)
    <=> v119819(VarCurr,1) ) ).

tff(addAssignment_69501,axiom,
    ! [VarCurr: state_type] :
      ( v119782(VarCurr,0)
    <=> v119819(VarCurr,0) ) ).

tff(addAssignment_69500,axiom,
    ! [VarCurr: state_type] :
      ( v119819(VarCurr,0)
    <=> v119820(VarCurr) ) ).

tff(addAssignment_69499,axiom,
    ! [VarCurr: state_type] :
      ( ( v119819(VarCurr,5)
      <=> $false )
      & ( v119819(VarCurr,4)
      <=> $false )
      & ( v119819(VarCurr,3)
      <=> $false )
      & ( v119819(VarCurr,2)
      <=> $false )
      & ( v119819(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13916,axiom,
    ! [VarCurr: state_type] :
      ( v119820(VarCurr)
    <=> ( v119821(VarCurr)
        | v119818(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13915,axiom,
    ! [VarCurr: state_type] :
      ( v119821(VarCurr)
    <=> ( v119822(VarCurr)
        | v119816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13914,axiom,
    ! [VarCurr: state_type] :
      ( v119822(VarCurr)
    <=> ( v119823(VarCurr)
        | v119814(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13913,axiom,
    ! [VarCurr: state_type] :
      ( v119823(VarCurr)
    <=> ( v119824(VarCurr)
        | v119804(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13912,axiom,
    ! [VarCurr: state_type] :
      ( v119824(VarCurr)
    <=> ( v119784(VarCurr)
        | v119794(VarCurr) ) ) ).

tff(addAssignment_69498,axiom,
    ! [VarCurr: state_type] :
      ( v119818(VarCurr)
    <=> v113911(VarCurr,7) ) ).

tff(addAssignment_69497,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,7)
    <=> v113913(VarCurr,7) ) ).

tff(addAssignment_69496,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,7)
    <=> v113915(VarCurr,7) ) ).

tff(addAssignment_69495,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,7)
    <=> v113935(VarCurr,7) ) ).

tff(addAssignment_69494,axiom,
    ! [VarCurr: state_type] :
      ( v119816(VarCurr)
    <=> v113107(VarCurr,7) ) ).

tff(addAssignment_69493,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,7)
    <=> v113143(VarCurr,7) ) ).

tff(addAssignment_69492,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,7)
    <=> v113110(VarCurr,7) ) ).

tff(addAssignment_69491,axiom,
    ! [VarCurr: state_type] :
      ( v119814(VarCurr)
    <=> v113100(VarCurr,7) ) ).

tff(addAssignment_69490,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,7)
    <=> v113101(VarCurr,7) ) ).

tff(addAssignment_69489,axiom,
    ! [VarCurr: state_type] :
      ( v119804(VarCurr)
    <=> v113810(VarCurr,7) ) ).

tff(addAssignment_69488,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,7)
    <=> v113812(VarCurr,7) ) ).

tff(addAssignment_69487,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,7)
    <=> v113814(VarCurr,7) ) ).

tff(addAssignment_69486,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,7)
    <=> v113816(VarCurr,7) ) ).

tff(addAssignment_69485,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,7)
    <=> v113818(VarCurr,7) ) ).

tff(addAssignment_69484,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,7)
    <=> v119806(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119807(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v119806(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1556,axiom,
    ! [VarNext: state_type] :
      ( v119807(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v119806(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119807(VarNext)
      <=> v119808(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119808(VarNext)
      <=> ( v119810(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119810(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_69483,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,7)
    <=> v113830(VarCurr,7) ) ).

tff(addAssignment_69482,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,7)
    <=> v113832(VarCurr,7) ) ).

tff(addAssignment_69481,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,7)
    <=> v113834(VarCurr,7) ) ).

tff(addAssignment_69480,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,7)
    <=> v113873(VarCurr,7) ) ).

tff(addAssignment_69479,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,7)
    <=> v113856(VarCurr,7) ) ).

tff(addAssignment_69478,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,7)
    <=> v113837(VarCurr,7) ) ).

tff(addAssignment_69477,axiom,
    ! [VarCurr: state_type] :
      ( v119794(VarCurr)
    <=> v113020(VarCurr,7) ) ).

tff(addAssignment_69476,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,7)
    <=> v113022(VarCurr,7) ) ).

tff(addAssignment_69475,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,7)
    <=> v113024(VarCurr,7) ) ).

tff(addAssignment_69474,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,7)
    <=> v113026(VarCurr,7) ) ).

tff(addAssignment_69473,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,7)
    <=> v113028(VarCurr,7) ) ).

tff(addAssignment_69472,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,7)
    <=> v119796(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1555,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119797(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v119796(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1555,axiom,
    ! [VarNext: state_type] :
      ( v119797(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v119796(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119797(VarNext)
      <=> v119798(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119798(VarNext)
      <=> ( v119800(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119800(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_69471,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,7)
    <=> v113040(VarCurr,7) ) ).

tff(addAssignment_69470,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,7)
    <=> v113042(VarCurr,7) ) ).

tff(addAssignment_69469,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,7)
    <=> v113044(VarCurr,7) ) ).

tff(addAssignment_69468,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,7)
    <=> v113045(VarCurr,7) ) ).

tff(addAssignment_69467,axiom,
    ! [VarCurr: state_type] :
      ( v119784(VarCurr)
    <=> v112940(VarCurr,7) ) ).

tff(addAssignment_69466,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,7)
    <=> v112942(VarCurr,7) ) ).

tff(addAssignment_69465,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,7)
    <=> v112944(VarCurr,7) ) ).

tff(addAssignment_69464,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,7)
    <=> v112946(VarCurr,7) ) ).

tff(addAssignment_69463,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,7)
    <=> v112948(VarCurr,7) ) ).

tff(addAssignment_69462,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,7)
    <=> v119786(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119787(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v119786(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1554,axiom,
    ! [VarNext: state_type] :
      ( v119787(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v119786(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119787(VarNext)
      <=> v119788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119788(VarNext)
      <=> ( v119790(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119790(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_69461,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,7)
    <=> v112960(VarCurr,7) ) ).

tff(addAssignment_69460,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,7)
    <=> v112962(VarCurr,7) ) ).

tff(addAssignment_69459,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,7)
    <=> v112964(VarCurr,7) ) ).

tff(addAssignment_69458,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,7)
    <=> v112965(VarCurr,7) ) ).

tff(addAssignment_69457,axiom,
    ! [VarCurr: state_type] :
      ( v119573(VarCurr,2)
    <=> v119588(VarCurr,2) ) ).

tff(addAssignment_69456,axiom,
    ! [VarCurr: state_type] :
      ( v119573(VarCurr,1)
    <=> v119588(VarCurr,1) ) ).

tff(addAssignment_69455,axiom,
    ! [VarCurr: state_type] :
      ( v119573(VarCurr,0)
    <=> v119588(VarCurr,0) ) ).

tff(addAssignment_69454,axiom,
    ! [VarCurr: state_type] :
      ( v119588(VarCurr,0)
    <=> v119776(VarCurr) ) ).

tff(addAssignment_69453,axiom,
    ! [VarCurr: state_type] :
      ( v119588(VarCurr,1)
    <=> v119771(VarCurr) ) ).

tff(addAssignment_69452,axiom,
    ! [VarCurr: state_type] :
      ( v119588(VarCurr,2)
    <=> v119590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13905,axiom,
    ! [VarCurr: state_type] :
      ( v119776(VarCurr)
    <=> ( v119777(VarCurr)
        & v119780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13904,axiom,
    ! [VarCurr: state_type] :
      ( v119780(VarCurr)
    <=> ( v119596(VarCurr,0)
        | v119757(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13903,axiom,
    ! [VarCurr: state_type] :
      ( v119777(VarCurr)
    <=> ( v119778(VarCurr)
        | v119779(VarCurr) ) ) ).

tff(writeUnaryOperator_7612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119779(VarCurr)
    <=> v119757(VarCurr,0) ) ).

tff(writeUnaryOperator_7611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119778(VarCurr)
    <=> v119596(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13902,axiom,
    ! [VarCurr: state_type] :
      ( v119771(VarCurr)
    <=> ( v119772(VarCurr)
        & v119775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13901,axiom,
    ! [VarCurr: state_type] :
      ( v119775(VarCurr)
    <=> ( v119595(VarCurr)
        | v119758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13900,axiom,
    ! [VarCurr: state_type] :
      ( v119772(VarCurr)
    <=> ( v119773(VarCurr)
        | v119774(VarCurr) ) ) ).

tff(writeUnaryOperator_7610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119774(VarCurr)
    <=> v119758(VarCurr) ) ).

tff(writeUnaryOperator_7609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119773(VarCurr)
    <=> v119595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13899,axiom,
    ! [VarCurr: state_type] :
      ( v119590(VarCurr)
    <=> ( v119591(VarCurr)
        & v119770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13898,axiom,
    ! [VarCurr: state_type] :
      ( v119770(VarCurr)
    <=> ( v119593(VarCurr)
        | v119765(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13897,axiom,
    ! [VarCurr: state_type] :
      ( v119591(VarCurr)
    <=> ( v119592(VarCurr)
        | v119764(VarCurr) ) ) ).

tff(writeUnaryOperator_7608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119764(VarCurr)
    <=> v119765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13896,axiom,
    ! [VarCurr: state_type] :
      ( v119765(VarCurr)
    <=> ( v119766(VarCurr)
        & v119769(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5183,axiom,
    ! [VarCurr: state_type] :
      ( v119769(VarCurr)
    <=> ( v119596(VarCurr,2)
        | v119757(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13895,axiom,
    ! [VarCurr: state_type] :
      ( v119766(VarCurr)
    <=> ( v119767(VarCurr)
        | v119768(VarCurr) ) ) ).

tff(writeUnaryOperator_7607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119768(VarCurr)
    <=> v119757(VarCurr,2) ) ).

tff(writeUnaryOperator_7606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119767(VarCurr)
    <=> v119596(VarCurr,2) ) ).

tff(writeUnaryOperator_7605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119592(VarCurr)
    <=> v119593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13894,axiom,
    ! [VarCurr: state_type] :
      ( v119593(VarCurr)
    <=> ( v119594(VarCurr)
        | v119763(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5182,axiom,
    ! [VarCurr: state_type] :
      ( v119763(VarCurr)
    <=> ( v119596(VarCurr,1)
        & v119757(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13893,axiom,
    ! [VarCurr: state_type] :
      ( v119594(VarCurr)
    <=> ( v119595(VarCurr)
        & v119758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13892,axiom,
    ! [VarCurr: state_type] :
      ( v119758(VarCurr)
    <=> ( v119759(VarCurr)
        & v119762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5181,axiom,
    ! [VarCurr: state_type] :
      ( v119762(VarCurr)
    <=> ( v119596(VarCurr,1)
        | v119757(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13891,axiom,
    ! [VarCurr: state_type] :
      ( v119759(VarCurr)
    <=> ( v119760(VarCurr)
        | v119761(VarCurr) ) ) ).

tff(writeUnaryOperator_7604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119761(VarCurr)
    <=> v119757(VarCurr,1) ) ).

tff(writeUnaryOperator_7603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119760(VarCurr)
    <=> v119596(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13890,axiom,
    ! [VarCurr: state_type] :
      ( v119595(VarCurr)
    <=> ( v119596(VarCurr,0)
        & v119757(VarCurr,0) ) ) ).

tff(addAssignment_69451,axiom,
    ! [VarCurr: state_type] :
      ( v119757(VarCurr,0)
    <=> v119587(VarCurr) ) ).

tff(addAssignment_69450,axiom,
    ! [VarCurr: state_type] :
      ( ( v119757(VarCurr,2)
      <=> $false )
      & ( v119757(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69449,axiom,
    ! [VarCurr: state_type] :
      ( v119596(VarCurr,0)
    <=> v119752(VarCurr) ) ).

tff(addAssignment_69448,axiom,
    ! [VarCurr: state_type] :
      ( v119596(VarCurr,1)
    <=> v119747(VarCurr) ) ).

tff(addAssignment_69447,axiom,
    ! [VarCurr: state_type] :
      ( v119596(VarCurr,2)
    <=> v119598(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13889,axiom,
    ! [VarCurr: state_type] :
      ( v119752(VarCurr)
    <=> ( v119753(VarCurr)
        & v119756(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13888,axiom,
    ! [VarCurr: state_type] :
      ( v119756(VarCurr)
    <=> ( v119604(VarCurr,0)
        | v119733(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13887,axiom,
    ! [VarCurr: state_type] :
      ( v119753(VarCurr)
    <=> ( v119754(VarCurr)
        | v119755(VarCurr) ) ) ).

tff(writeUnaryOperator_7602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119755(VarCurr)
    <=> v119733(VarCurr,0) ) ).

tff(writeUnaryOperator_7601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119754(VarCurr)
    <=> v119604(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13886,axiom,
    ! [VarCurr: state_type] :
      ( v119747(VarCurr)
    <=> ( v119748(VarCurr)
        & v119751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13885,axiom,
    ! [VarCurr: state_type] :
      ( v119751(VarCurr)
    <=> ( v119603(VarCurr)
        | v119734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13884,axiom,
    ! [VarCurr: state_type] :
      ( v119748(VarCurr)
    <=> ( v119749(VarCurr)
        | v119750(VarCurr) ) ) ).

tff(writeUnaryOperator_7600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119750(VarCurr)
    <=> v119734(VarCurr) ) ).

tff(writeUnaryOperator_7599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119749(VarCurr)
    <=> v119603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13883,axiom,
    ! [VarCurr: state_type] :
      ( v119598(VarCurr)
    <=> ( v119599(VarCurr)
        & v119746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13882,axiom,
    ! [VarCurr: state_type] :
      ( v119746(VarCurr)
    <=> ( v119601(VarCurr)
        | v119741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13881,axiom,
    ! [VarCurr: state_type] :
      ( v119599(VarCurr)
    <=> ( v119600(VarCurr)
        | v119740(VarCurr) ) ) ).

tff(writeUnaryOperator_7598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119740(VarCurr)
    <=> v119741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13880,axiom,
    ! [VarCurr: state_type] :
      ( v119741(VarCurr)
    <=> ( v119742(VarCurr)
        & v119745(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5180,axiom,
    ! [VarCurr: state_type] :
      ( v119745(VarCurr)
    <=> ( v119604(VarCurr,2)
        | v119733(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13879,axiom,
    ! [VarCurr: state_type] :
      ( v119742(VarCurr)
    <=> ( v119743(VarCurr)
        | v119744(VarCurr) ) ) ).

tff(writeUnaryOperator_7597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119744(VarCurr)
    <=> v119733(VarCurr,2) ) ).

tff(writeUnaryOperator_7596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119743(VarCurr)
    <=> v119604(VarCurr,2) ) ).

tff(writeUnaryOperator_7595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119600(VarCurr)
    <=> v119601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13878,axiom,
    ! [VarCurr: state_type] :
      ( v119601(VarCurr)
    <=> ( v119602(VarCurr)
        | v119739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5179,axiom,
    ! [VarCurr: state_type] :
      ( v119739(VarCurr)
    <=> ( v119604(VarCurr,1)
        & v119733(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13877,axiom,
    ! [VarCurr: state_type] :
      ( v119602(VarCurr)
    <=> ( v119603(VarCurr)
        & v119734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13876,axiom,
    ! [VarCurr: state_type] :
      ( v119734(VarCurr)
    <=> ( v119735(VarCurr)
        & v119738(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5178,axiom,
    ! [VarCurr: state_type] :
      ( v119738(VarCurr)
    <=> ( v119604(VarCurr,1)
        | v119733(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13875,axiom,
    ! [VarCurr: state_type] :
      ( v119735(VarCurr)
    <=> ( v119736(VarCurr)
        | v119737(VarCurr) ) ) ).

tff(writeUnaryOperator_7594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119737(VarCurr)
    <=> v119733(VarCurr,1) ) ).

tff(writeUnaryOperator_7593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119736(VarCurr)
    <=> v119604(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13874,axiom,
    ! [VarCurr: state_type] :
      ( v119603(VarCurr)
    <=> ( v119604(VarCurr,0)
        & v119733(VarCurr,0) ) ) ).

tff(addAssignment_69446,axiom,
    ! [VarCurr: state_type] :
      ( v119733(VarCurr,0)
    <=> v119585(VarCurr) ) ).

tff(addAssignment_69445,axiom,
    ! [VarCurr: state_type] :
      ( ( v119733(VarCurr,2)
      <=> $false )
      & ( v119733(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69444,axiom,
    ! [VarCurr: state_type] :
      ( v119604(VarCurr,0)
    <=> v119728(VarCurr) ) ).

tff(addAssignment_69443,axiom,
    ! [VarCurr: state_type] :
      ( v119604(VarCurr,1)
    <=> v119723(VarCurr) ) ).

tff(addAssignment_69442,axiom,
    ! [VarCurr: state_type] :
      ( v119604(VarCurr,2)
    <=> v119606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13873,axiom,
    ! [VarCurr: state_type] :
      ( v119728(VarCurr)
    <=> ( v119729(VarCurr)
        & v119732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13872,axiom,
    ! [VarCurr: state_type] :
      ( v119732(VarCurr)
    <=> ( v119612(VarCurr,0)
        | v119709(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13871,axiom,
    ! [VarCurr: state_type] :
      ( v119729(VarCurr)
    <=> ( v119730(VarCurr)
        | v119731(VarCurr) ) ) ).

tff(writeUnaryOperator_7592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119731(VarCurr)
    <=> v119709(VarCurr,0) ) ).

tff(writeUnaryOperator_7591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119730(VarCurr)
    <=> v119612(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13870,axiom,
    ! [VarCurr: state_type] :
      ( v119723(VarCurr)
    <=> ( v119724(VarCurr)
        & v119727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13869,axiom,
    ! [VarCurr: state_type] :
      ( v119727(VarCurr)
    <=> ( v119611(VarCurr)
        | v119710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13868,axiom,
    ! [VarCurr: state_type] :
      ( v119724(VarCurr)
    <=> ( v119725(VarCurr)
        | v119726(VarCurr) ) ) ).

tff(writeUnaryOperator_7590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119726(VarCurr)
    <=> v119710(VarCurr) ) ).

tff(writeUnaryOperator_7589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119725(VarCurr)
    <=> v119611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13867,axiom,
    ! [VarCurr: state_type] :
      ( v119606(VarCurr)
    <=> ( v119607(VarCurr)
        & v119722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13866,axiom,
    ! [VarCurr: state_type] :
      ( v119722(VarCurr)
    <=> ( v119609(VarCurr)
        | v119717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13865,axiom,
    ! [VarCurr: state_type] :
      ( v119607(VarCurr)
    <=> ( v119608(VarCurr)
        | v119716(VarCurr) ) ) ).

tff(writeUnaryOperator_7588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119716(VarCurr)
    <=> v119717(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13864,axiom,
    ! [VarCurr: state_type] :
      ( v119717(VarCurr)
    <=> ( v119718(VarCurr)
        & v119721(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5177,axiom,
    ! [VarCurr: state_type] :
      ( v119721(VarCurr)
    <=> ( v119612(VarCurr,2)
        | v119709(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13863,axiom,
    ! [VarCurr: state_type] :
      ( v119718(VarCurr)
    <=> ( v119719(VarCurr)
        | v119720(VarCurr) ) ) ).

tff(writeUnaryOperator_7587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119720(VarCurr)
    <=> v119709(VarCurr,2) ) ).

tff(writeUnaryOperator_7586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119719(VarCurr)
    <=> v119612(VarCurr,2) ) ).

tff(writeUnaryOperator_7585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119608(VarCurr)
    <=> v119609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13862,axiom,
    ! [VarCurr: state_type] :
      ( v119609(VarCurr)
    <=> ( v119610(VarCurr)
        | v119715(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5176,axiom,
    ! [VarCurr: state_type] :
      ( v119715(VarCurr)
    <=> ( v119612(VarCurr,1)
        & v119709(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13861,axiom,
    ! [VarCurr: state_type] :
      ( v119610(VarCurr)
    <=> ( v119611(VarCurr)
        & v119710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13860,axiom,
    ! [VarCurr: state_type] :
      ( v119710(VarCurr)
    <=> ( v119711(VarCurr)
        & v119714(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5175,axiom,
    ! [VarCurr: state_type] :
      ( v119714(VarCurr)
    <=> ( v119612(VarCurr,1)
        | v119709(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13859,axiom,
    ! [VarCurr: state_type] :
      ( v119711(VarCurr)
    <=> ( v119712(VarCurr)
        | v119713(VarCurr) ) ) ).

tff(writeUnaryOperator_7584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119713(VarCurr)
    <=> v119709(VarCurr,1) ) ).

tff(writeUnaryOperator_7583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119712(VarCurr)
    <=> v119612(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13858,axiom,
    ! [VarCurr: state_type] :
      ( v119611(VarCurr)
    <=> ( v119612(VarCurr,0)
        & v119709(VarCurr,0) ) ) ).

tff(addAssignment_69441,axiom,
    ! [VarCurr: state_type] :
      ( v119709(VarCurr,0)
    <=> v119583(VarCurr) ) ).

tff(addAssignment_69440,axiom,
    ! [VarCurr: state_type] :
      ( ( v119709(VarCurr,2)
      <=> $false )
      & ( v119709(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69439,axiom,
    ! [VarCurr: state_type] :
      ( v119612(VarCurr,0)
    <=> v119704(VarCurr) ) ).

tff(addAssignment_69438,axiom,
    ! [VarCurr: state_type] :
      ( v119612(VarCurr,1)
    <=> v119699(VarCurr) ) ).

tff(addAssignment_69437,axiom,
    ! [VarCurr: state_type] :
      ( v119612(VarCurr,2)
    <=> v119614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13857,axiom,
    ! [VarCurr: state_type] :
      ( v119704(VarCurr)
    <=> ( v119705(VarCurr)
        & v119708(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13856,axiom,
    ! [VarCurr: state_type] :
      ( v119708(VarCurr)
    <=> ( v119620(VarCurr,0)
        | v119685(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13855,axiom,
    ! [VarCurr: state_type] :
      ( v119705(VarCurr)
    <=> ( v119706(VarCurr)
        | v119707(VarCurr) ) ) ).

tff(writeUnaryOperator_7582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119707(VarCurr)
    <=> v119685(VarCurr,0) ) ).

tff(writeUnaryOperator_7581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119706(VarCurr)
    <=> v119620(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13854,axiom,
    ! [VarCurr: state_type] :
      ( v119699(VarCurr)
    <=> ( v119700(VarCurr)
        & v119703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13853,axiom,
    ! [VarCurr: state_type] :
      ( v119703(VarCurr)
    <=> ( v119619(VarCurr)
        | v119686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13852,axiom,
    ! [VarCurr: state_type] :
      ( v119700(VarCurr)
    <=> ( v119701(VarCurr)
        | v119702(VarCurr) ) ) ).

tff(writeUnaryOperator_7580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119702(VarCurr)
    <=> v119686(VarCurr) ) ).

tff(writeUnaryOperator_7579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119701(VarCurr)
    <=> v119619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13851,axiom,
    ! [VarCurr: state_type] :
      ( v119614(VarCurr)
    <=> ( v119615(VarCurr)
        & v119698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13850,axiom,
    ! [VarCurr: state_type] :
      ( v119698(VarCurr)
    <=> ( v119617(VarCurr)
        | v119693(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13849,axiom,
    ! [VarCurr: state_type] :
      ( v119615(VarCurr)
    <=> ( v119616(VarCurr)
        | v119692(VarCurr) ) ) ).

tff(writeUnaryOperator_7578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119692(VarCurr)
    <=> v119693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13848,axiom,
    ! [VarCurr: state_type] :
      ( v119693(VarCurr)
    <=> ( v119694(VarCurr)
        & v119697(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5174,axiom,
    ! [VarCurr: state_type] :
      ( v119697(VarCurr)
    <=> ( v119620(VarCurr,2)
        | v119685(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13847,axiom,
    ! [VarCurr: state_type] :
      ( v119694(VarCurr)
    <=> ( v119695(VarCurr)
        | v119696(VarCurr) ) ) ).

tff(writeUnaryOperator_7577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119696(VarCurr)
    <=> v119685(VarCurr,2) ) ).

tff(writeUnaryOperator_7576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119695(VarCurr)
    <=> v119620(VarCurr,2) ) ).

tff(writeUnaryOperator_7575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119616(VarCurr)
    <=> v119617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13846,axiom,
    ! [VarCurr: state_type] :
      ( v119617(VarCurr)
    <=> ( v119618(VarCurr)
        | v119691(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5173,axiom,
    ! [VarCurr: state_type] :
      ( v119691(VarCurr)
    <=> ( v119620(VarCurr,1)
        & v119685(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13845,axiom,
    ! [VarCurr: state_type] :
      ( v119618(VarCurr)
    <=> ( v119619(VarCurr)
        & v119686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13844,axiom,
    ! [VarCurr: state_type] :
      ( v119686(VarCurr)
    <=> ( v119687(VarCurr)
        & v119690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5172,axiom,
    ! [VarCurr: state_type] :
      ( v119690(VarCurr)
    <=> ( v119620(VarCurr,1)
        | v119685(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13843,axiom,
    ! [VarCurr: state_type] :
      ( v119687(VarCurr)
    <=> ( v119688(VarCurr)
        | v119689(VarCurr) ) ) ).

tff(writeUnaryOperator_7574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119689(VarCurr)
    <=> v119685(VarCurr,1) ) ).

tff(writeUnaryOperator_7573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119688(VarCurr)
    <=> v119620(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13842,axiom,
    ! [VarCurr: state_type] :
      ( v119619(VarCurr)
    <=> ( v119620(VarCurr,0)
        & v119685(VarCurr,0) ) ) ).

tff(addAssignment_69436,axiom,
    ! [VarCurr: state_type] :
      ( v119685(VarCurr,0)
    <=> v119581(VarCurr) ) ).

tff(addAssignment_69435,axiom,
    ! [VarCurr: state_type] :
      ( ( v119685(VarCurr,2)
      <=> $false )
      & ( v119685(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69434,axiom,
    ! [VarCurr: state_type] :
      ( v119620(VarCurr,0)
    <=> v119680(VarCurr) ) ).

tff(addAssignment_69433,axiom,
    ! [VarCurr: state_type] :
      ( v119620(VarCurr,1)
    <=> v119675(VarCurr) ) ).

tff(addAssignment_69432,axiom,
    ! [VarCurr: state_type] :
      ( v119620(VarCurr,2)
    <=> v119622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13841,axiom,
    ! [VarCurr: state_type] :
      ( v119680(VarCurr)
    <=> ( v119681(VarCurr)
        & v119684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13840,axiom,
    ! [VarCurr: state_type] :
      ( v119684(VarCurr)
    <=> ( v119628(VarCurr,0)
        | v119661(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13839,axiom,
    ! [VarCurr: state_type] :
      ( v119681(VarCurr)
    <=> ( v119682(VarCurr)
        | v119683(VarCurr) ) ) ).

tff(writeUnaryOperator_7572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119683(VarCurr)
    <=> v119661(VarCurr,0) ) ).

tff(writeUnaryOperator_7571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119682(VarCurr)
    <=> v119628(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13838,axiom,
    ! [VarCurr: state_type] :
      ( v119675(VarCurr)
    <=> ( v119676(VarCurr)
        & v119679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13837,axiom,
    ! [VarCurr: state_type] :
      ( v119679(VarCurr)
    <=> ( v119627(VarCurr)
        | v119662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13836,axiom,
    ! [VarCurr: state_type] :
      ( v119676(VarCurr)
    <=> ( v119677(VarCurr)
        | v119678(VarCurr) ) ) ).

tff(writeUnaryOperator_7570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119678(VarCurr)
    <=> v119662(VarCurr) ) ).

tff(writeUnaryOperator_7569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119677(VarCurr)
    <=> v119627(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13835,axiom,
    ! [VarCurr: state_type] :
      ( v119622(VarCurr)
    <=> ( v119623(VarCurr)
        & v119674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13834,axiom,
    ! [VarCurr: state_type] :
      ( v119674(VarCurr)
    <=> ( v119625(VarCurr)
        | v119669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13833,axiom,
    ! [VarCurr: state_type] :
      ( v119623(VarCurr)
    <=> ( v119624(VarCurr)
        | v119668(VarCurr) ) ) ).

tff(writeUnaryOperator_7568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119668(VarCurr)
    <=> v119669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13832,axiom,
    ! [VarCurr: state_type] :
      ( v119669(VarCurr)
    <=> ( v119670(VarCurr)
        & v119673(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5171,axiom,
    ! [VarCurr: state_type] :
      ( v119673(VarCurr)
    <=> ( v119628(VarCurr,2)
        | v119661(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13831,axiom,
    ! [VarCurr: state_type] :
      ( v119670(VarCurr)
    <=> ( v119671(VarCurr)
        | v119672(VarCurr) ) ) ).

tff(writeUnaryOperator_7567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119672(VarCurr)
    <=> v119661(VarCurr,2) ) ).

tff(writeUnaryOperator_7566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119671(VarCurr)
    <=> v119628(VarCurr,2) ) ).

tff(writeUnaryOperator_7565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119624(VarCurr)
    <=> v119625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13830,axiom,
    ! [VarCurr: state_type] :
      ( v119625(VarCurr)
    <=> ( v119626(VarCurr)
        | v119667(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5170,axiom,
    ! [VarCurr: state_type] :
      ( v119667(VarCurr)
    <=> ( v119628(VarCurr,1)
        & v119661(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13829,axiom,
    ! [VarCurr: state_type] :
      ( v119626(VarCurr)
    <=> ( v119627(VarCurr)
        & v119662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13828,axiom,
    ! [VarCurr: state_type] :
      ( v119662(VarCurr)
    <=> ( v119663(VarCurr)
        & v119666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5169,axiom,
    ! [VarCurr: state_type] :
      ( v119666(VarCurr)
    <=> ( v119628(VarCurr,1)
        | v119661(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13827,axiom,
    ! [VarCurr: state_type] :
      ( v119663(VarCurr)
    <=> ( v119664(VarCurr)
        | v119665(VarCurr) ) ) ).

tff(writeUnaryOperator_7564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119665(VarCurr)
    <=> v119661(VarCurr,1) ) ).

tff(writeUnaryOperator_7563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119664(VarCurr)
    <=> v119628(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13826,axiom,
    ! [VarCurr: state_type] :
      ( v119627(VarCurr)
    <=> ( v119628(VarCurr,0)
        & v119661(VarCurr,0) ) ) ).

tff(addAssignment_69431,axiom,
    ! [VarCurr: state_type] :
      ( v119661(VarCurr,0)
    <=> v119579(VarCurr) ) ).

tff(addAssignment_69430,axiom,
    ! [VarCurr: state_type] :
      ( ( v119661(VarCurr,2)
      <=> $false )
      & ( v119661(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69429,axiom,
    ! [VarCurr: state_type] :
      ( v119628(VarCurr,0)
    <=> v119656(VarCurr) ) ).

tff(addAssignment_69428,axiom,
    ! [VarCurr: state_type] :
      ( v119628(VarCurr,1)
    <=> v119651(VarCurr) ) ).

tff(addAssignment_69427,axiom,
    ! [VarCurr: state_type] :
      ( v119628(VarCurr,2)
    <=> v119630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13825,axiom,
    ! [VarCurr: state_type] :
      ( v119656(VarCurr)
    <=> ( v119657(VarCurr)
        & v119660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13824,axiom,
    ! [VarCurr: state_type] :
      ( v119660(VarCurr)
    <=> ( v119636(VarCurr,0)
        | v119637(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13823,axiom,
    ! [VarCurr: state_type] :
      ( v119657(VarCurr)
    <=> ( v119658(VarCurr)
        | v119659(VarCurr) ) ) ).

tff(writeUnaryOperator_7562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119659(VarCurr)
    <=> v119637(VarCurr,0) ) ).

tff(writeUnaryOperator_7561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119658(VarCurr)
    <=> v119636(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13822,axiom,
    ! [VarCurr: state_type] :
      ( v119651(VarCurr)
    <=> ( v119652(VarCurr)
        & v119655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13821,axiom,
    ! [VarCurr: state_type] :
      ( v119655(VarCurr)
    <=> ( v119635(VarCurr)
        | v119638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13820,axiom,
    ! [VarCurr: state_type] :
      ( v119652(VarCurr)
    <=> ( v119653(VarCurr)
        | v119654(VarCurr) ) ) ).

tff(writeUnaryOperator_7560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119654(VarCurr)
    <=> v119638(VarCurr) ) ).

tff(writeUnaryOperator_7559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119653(VarCurr)
    <=> v119635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13819,axiom,
    ! [VarCurr: state_type] :
      ( v119630(VarCurr)
    <=> ( v119631(VarCurr)
        & v119650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13818,axiom,
    ! [VarCurr: state_type] :
      ( v119650(VarCurr)
    <=> ( v119633(VarCurr)
        | v119645(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13817,axiom,
    ! [VarCurr: state_type] :
      ( v119631(VarCurr)
    <=> ( v119632(VarCurr)
        | v119644(VarCurr) ) ) ).

tff(writeUnaryOperator_7558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119644(VarCurr)
    <=> v119645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13816,axiom,
    ! [VarCurr: state_type] :
      ( v119645(VarCurr)
    <=> ( v119646(VarCurr)
        & v119649(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5168,axiom,
    ! [VarCurr: state_type] :
      ( v119649(VarCurr)
    <=> ( v119636(VarCurr,2)
        | v119637(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13815,axiom,
    ! [VarCurr: state_type] :
      ( v119646(VarCurr)
    <=> ( v119647(VarCurr)
        | v119648(VarCurr) ) ) ).

tff(writeUnaryOperator_7557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119648(VarCurr)
    <=> v119637(VarCurr,2) ) ).

tff(writeUnaryOperator_7556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119647(VarCurr)
    <=> v119636(VarCurr,2) ) ).

tff(writeUnaryOperator_7555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119632(VarCurr)
    <=> v119633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13814,axiom,
    ! [VarCurr: state_type] :
      ( v119633(VarCurr)
    <=> ( v119634(VarCurr)
        | v119643(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5167,axiom,
    ! [VarCurr: state_type] :
      ( v119643(VarCurr)
    <=> ( v119636(VarCurr,1)
        & v119637(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13813,axiom,
    ! [VarCurr: state_type] :
      ( v119634(VarCurr)
    <=> ( v119635(VarCurr)
        & v119638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13812,axiom,
    ! [VarCurr: state_type] :
      ( v119638(VarCurr)
    <=> ( v119639(VarCurr)
        & v119642(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5166,axiom,
    ! [VarCurr: state_type] :
      ( v119642(VarCurr)
    <=> ( v119636(VarCurr,1)
        | v119637(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13811,axiom,
    ! [VarCurr: state_type] :
      ( v119639(VarCurr)
    <=> ( v119640(VarCurr)
        | v119641(VarCurr) ) ) ).

tff(writeUnaryOperator_7554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119641(VarCurr)
    <=> v119637(VarCurr,1) ) ).

tff(writeUnaryOperator_7553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119640(VarCurr)
    <=> v119636(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13810,axiom,
    ! [VarCurr: state_type] :
      ( v119635(VarCurr)
    <=> ( v119636(VarCurr,0)
        & v119637(VarCurr,0) ) ) ).

tff(addAssignment_69426,axiom,
    ! [VarCurr: state_type] :
      ( v119637(VarCurr,0)
    <=> v119577(VarCurr) ) ).

tff(addAssignment_69425,axiom,
    ! [VarCurr: state_type] :
      ( ( v119637(VarCurr,2)
      <=> $false )
      & ( v119637(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69424,axiom,
    ! [VarCurr: state_type] :
      ( v119636(VarCurr,0)
    <=> v119575(VarCurr) ) ).

tff(addAssignment_69423,axiom,
    ! [VarCurr: state_type] :
      ( ( v119636(VarCurr,2)
      <=> $false )
      & ( v119636(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69422,axiom,
    ! [VarCurr: state_type] :
      ( v119587(VarCurr)
    <=> v114692(VarCurr,7) ) ).

tff(addAssignment_69421,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,7)
    <=> v114694(VarCurr,7) ) ).

tff(addAssignment_69420,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,7)
    <=> v114696(VarCurr,7) ) ).

tff(addAssignment_69419,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,7)
    <=> v114697(VarCurr,7) ) ).

tff(addAssignment_69418,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,7)
    <=> v113918(VarCurr,7) ) ).

tff(addAssignment_69417,axiom,
    ! [VarCurr: state_type] :
      ( v119585(VarCurr)
    <=> v114685(VarCurr,7) ) ).

tff(addAssignment_69416,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,7)
    <=> v114686(VarCurr,7) ) ).

tff(addAssignment_69415,axiom,
    ! [VarCurr: state_type] :
      ( v119583(VarCurr)
    <=> v114661(VarCurr,7) ) ).

tff(addAssignment_69414,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,7)
    <=> v114662(VarCurr,7) ) ).

tff(addAssignment_69413,axiom,
    ! [VarCurr: state_type] :
      ( v119581(VarCurr)
    <=> v114633(VarCurr,7) ) ).

tff(addAssignment_69412,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,7)
    <=> v114635(VarCurr,7) ) ).

tff(addAssignment_69411,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,7)
    <=> v114637(VarCurr,7) ) ).

tff(addAssignment_69410,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,7)
    <=> v114638(VarCurr,7) ) ).

tff(addAssignment_69409,axiom,
    ! [VarCurr: state_type] :
      ( v119579(VarCurr)
    <=> v114605(VarCurr,7) ) ).

tff(addAssignment_69408,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,7)
    <=> v114607(VarCurr,7) ) ).

tff(addAssignment_69407,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,7)
    <=> v114609(VarCurr,7) ) ).

tff(addAssignment_69406,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,7)
    <=> v114610(VarCurr,7) ) ).

tff(addAssignment_69405,axiom,
    ! [VarCurr: state_type] :
      ( v119577(VarCurr)
    <=> v114577(VarCurr,7) ) ).

tff(addAssignment_69404,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,7)
    <=> v114579(VarCurr,7) ) ).

tff(addAssignment_69403,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,7)
    <=> v114581(VarCurr,7) ) ).

tff(addAssignment_69402,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,7)
    <=> v114582(VarCurr,7) ) ).

tff(addAssignment_69401,axiom,
    ! [VarCurr: state_type] :
      ( v119575(VarCurr)
    <=> v114549(VarCurr,7) ) ).

tff(addAssignment_69400,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,7)
    <=> v114551(VarCurr,7) ) ).

tff(addAssignment_69399,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,7)
    <=> v114553(VarCurr,7) ) ).

tff(addAssignment_69398,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,7)
    <=> v114554(VarCurr,7) ) ).

tff(addAssignment_69397,axiom,
    ! [VarCurr: state_type] :
      ( v119561(VarCurr)
    <=> v119563(VarCurr) ) ).

tff(addAssignment_69396,axiom,
    ! [VarCurr: state_type] :
      ( v119563(VarCurr)
    <=> v119537(VarCurr) ) ).

tff(addAssignment_69395,axiom,
    ! [VarCurr: state_type] :
      ( v119557(VarCurr)
    <=> v119559(VarCurr) ) ).

tff(addAssignment_69394,axiom,
    ! [VarCurr: state_type] :
      ( v119559(VarCurr)
    <=> v119529(VarCurr) ) ).

tff(addAssignment_69393,axiom,
    ! [VarCurr: state_type] :
      ( v119533(VarCurr)
    <=> v119535(VarCurr) ) ).

tff(addAssignment_69392,axiom,
    ! [VarCurr: state_type] :
      ( v119535(VarCurr)
    <=> v119537(VarCurr) ) ).

tff(addAssignment_69391,axiom,
    ! [VarCurr: state_type] :
      ( v119537(VarCurr)
    <=> v119539(VarCurr) ) ).

tff(addAssignment_69390,axiom,
    ! [VarCurr: state_type] :
      ( v119539(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_69389,axiom,
    ! [VarCurr: state_type] :
      ( v119525(VarCurr)
    <=> v119527(VarCurr) ) ).

tff(addAssignment_69388,axiom,
    ! [VarCurr: state_type] :
      ( v119527(VarCurr)
    <=> v119529(VarCurr) ) ).

tff(addAssignment_69387,axiom,
    ! [VarCurr: state_type] :
      ( v119529(VarCurr)
    <=> v119531(VarCurr) ) ).

tff(addAssignment_69386,axiom,
    ! [VarCurr: state_type] :
      ( v119531(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13809,axiom,
    ! [VarCurr: state_type] :
      ( v118716(VarCurr)
    <=> ( v119515(VarCurr)
        & v119425(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5165,axiom,
    ! [VarCurr: state_type] :
      ( v119515(VarCurr)
    <=> ( v118718(VarCurr,1)
        & v119364(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1186,axiom,
    ! [VarCurr: state_type] :
      ( v119425(VarCurr)
    <=> ( ( v119427(VarCurr,4)
        <=> $false )
        & ( v119427(VarCurr,3)
        <=> $false )
        & ( v119427(VarCurr,2)
        <=> $false )
        & ( v119427(VarCurr,1)
        <=> $false )
        & ( v119427(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119427(VarCurr,B)
      <=> v119429(VarCurr,B) ) ) ).

tff(addAssignment_69384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119429(VarCurr,B)
      <=> v119431(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119497(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v119431(VarNext,B)
            <=> v119431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1553,axiom,
    ! [VarNext: state_type] :
      ( v119497(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119431(VarNext,B)
          <=> v119507(VarNext,B) ) ) ) ).

tff(addAssignment_69383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119507(VarNext,B)
          <=> v119505(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119508(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119505(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1098,axiom,
    ! [VarCurr: state_type] :
      ( v119508(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119505(VarCurr,B)
          <=> v119441(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13808,axiom,
    ! [VarCurr: state_type] :
      ( v119508(VarCurr)
    <=> ( v119509(VarCurr)
        & v119510(VarCurr) ) ) ).

tff(writeUnaryOperator_7552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119510(VarCurr)
    <=> v119437(VarCurr) ) ).

tff(writeUnaryOperator_7551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119509(VarCurr)
    <=> v119433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119497(VarNext)
      <=> v119498(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119498(VarNext)
      <=> ( v119499(VarNext)
          & v119492(VarNext) ) ) ) ).

tff(writeUnaryOperator_7550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119499(VarNext)
      <=> v119501(VarNext) ) ) ).

tff(addAssignment_69382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119501(VarNext)
      <=> v119492(VarCurr) ) ) ).

tff(addAssignment_69381,axiom,
    ! [VarCurr: state_type] :
      ( v119492(VarCurr)
    <=> v119494(VarCurr) ) ).

tff(addAssignment_69380,axiom,
    ! [VarCurr: state_type] :
      ( v119494(VarCurr)
    <=> v119198(VarCurr) ) ).

tff(addAssignment_69379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119441(VarCurr,B)
      <=> v119443(VarCurr,B) ) ) ).

tff(addAssignment_69378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119443(VarCurr,B)
      <=> v119445(VarCurr,B) ) ) ).

tff(addAssignment_69377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119445(VarCurr,B)
      <=> v119447(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119447(VarCurr,B)
          <=> v119461(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1097,axiom,
    ! [VarCurr: state_type] :
      ( v119449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119447(VarCurr,B)
          <=> v119454(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119456(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119461(VarCurr,B)
          <=> v119462(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1096,axiom,
    ! [VarCurr: state_type] :
      ( v119456(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119461(VarCurr,B)
          <=> v119459(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119425(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119462(VarCurr,B)
          <=> v119463(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1095,axiom,
    ! [VarCurr: state_type] :
      ( v119425(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v119462(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69376,axiom,
    ! [VarCurr: state_type] :
      ( v119463(VarCurr,0)
    <=> v119489(VarCurr) ) ).

tff(addAssignment_69375,axiom,
    ! [VarCurr: state_type] :
      ( v119463(VarCurr,1)
    <=> v119487(VarCurr) ) ).

tff(addAssignment_69374,axiom,
    ! [VarCurr: state_type] :
      ( v119463(VarCurr,2)
    <=> v119483(VarCurr) ) ).

tff(addAssignment_69373,axiom,
    ! [VarCurr: state_type] :
      ( v119463(VarCurr,3)
    <=> v119479(VarCurr) ) ).

tff(addAssignment_69372,axiom,
    ! [VarCurr: state_type] :
      ( v119463(VarCurr,4)
    <=> v119465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13805,axiom,
    ! [VarCurr: state_type] :
      ( v119487(VarCurr)
    <=> ( v119488(VarCurr)
        & v119490(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13804,axiom,
    ! [VarCurr: state_type] :
      ( v119490(VarCurr)
    <=> ( v119427(VarCurr,0)
        | v119474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5164,axiom,
    ! [VarCurr: state_type] :
      ( v119488(VarCurr)
    <=> ( v119489(VarCurr)
        | v119427(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119489(VarCurr)
    <=> v119427(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13803,axiom,
    ! [VarCurr: state_type] :
      ( v119483(VarCurr)
    <=> ( v119484(VarCurr)
        & v119486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13802,axiom,
    ! [VarCurr: state_type] :
      ( v119486(VarCurr)
    <=> ( v119472(VarCurr)
        | v119475(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5163,axiom,
    ! [VarCurr: state_type] :
      ( v119484(VarCurr)
    <=> ( v119485(VarCurr)
        | v119427(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119485(VarCurr)
    <=> v119472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13801,axiom,
    ! [VarCurr: state_type] :
      ( v119479(VarCurr)
    <=> ( v119480(VarCurr)
        & v119482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13800,axiom,
    ! [VarCurr: state_type] :
      ( v119482(VarCurr)
    <=> ( v119470(VarCurr)
        | v119476(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5162,axiom,
    ! [VarCurr: state_type] :
      ( v119480(VarCurr)
    <=> ( v119481(VarCurr)
        | v119427(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119481(VarCurr)
    <=> v119470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13799,axiom,
    ! [VarCurr: state_type] :
      ( v119465(VarCurr)
    <=> ( v119466(VarCurr)
        & v119477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13798,axiom,
    ! [VarCurr: state_type] :
      ( v119477(VarCurr)
    <=> ( v119468(VarCurr)
        | v119478(VarCurr) ) ) ).

tff(writeUnaryOperator_7546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119478(VarCurr)
    <=> v119427(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5161,axiom,
    ! [VarCurr: state_type] :
      ( v119466(VarCurr)
    <=> ( v119467(VarCurr)
        | v119427(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119467(VarCurr)
    <=> v119468(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5160,axiom,
    ! [VarCurr: state_type] :
      ( v119468(VarCurr)
    <=> ( v119427(VarCurr,3)
        | v119469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13797,axiom,
    ! [VarCurr: state_type] :
      ( v119469(VarCurr)
    <=> ( v119470(VarCurr)
        & v119476(VarCurr) ) ) ).

tff(writeUnaryOperator_7544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119476(VarCurr)
    <=> v119427(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5159,axiom,
    ! [VarCurr: state_type] :
      ( v119470(VarCurr)
    <=> ( v119427(VarCurr,2)
        | v119471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13796,axiom,
    ! [VarCurr: state_type] :
      ( v119471(VarCurr)
    <=> ( v119472(VarCurr)
        & v119475(VarCurr) ) ) ).

tff(writeUnaryOperator_7543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119475(VarCurr)
    <=> v119427(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5158,axiom,
    ! [VarCurr: state_type] :
      ( v119472(VarCurr)
    <=> ( v119427(VarCurr,1)
        | v119473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13795,axiom,
    ! [VarCurr: state_type] :
      ( v119473(VarCurr)
    <=> ( v119427(VarCurr,0)
        & v119474(VarCurr) ) ) ).

tff(writeUnaryOperator_7542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119474(VarCurr)
    <=> v119427(VarCurr,1) ) ).

tff(addAssignment_69371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119459(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13794,axiom,
    ! [VarCurr: state_type] :
      ( v119456(VarCurr)
    <=> ( v119003(VarCurr)
        | v119017(VarCurr) ) ) ).

tff(addAssignment_69370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v119454(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13793,axiom,
    ! [VarCurr: state_type] :
      ( v119449(VarCurr)
    <=> ( v119451(VarCurr)
        | v119015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13792,axiom,
    ! [VarCurr: state_type] :
      ( v119451(VarCurr)
    <=> ( v119452(VarCurr)
        | v119013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13791,axiom,
    ! [VarCurr: state_type] :
      ( v119452(VarCurr)
    <=> ( v118983(VarCurr)
        | v118993(VarCurr) ) ) ).

tff(addAssignment_69369,axiom,
    ! [VarCurr: state_type] :
      ( v119437(VarCurr)
    <=> v119439(VarCurr) ) ).

tff(addAssignment_69368,axiom,
    ! [VarCurr: state_type] :
      ( v119439(VarCurr)
    <=> v118736(VarCurr) ) ).

tff(addAssignment_69367,axiom,
    ! [VarCurr: state_type] :
      ( v119433(VarCurr)
    <=> v119435(VarCurr) ) ).

tff(addAssignment_69366,axiom,
    ! [VarCurr: state_type] :
      ( v119435(VarCurr)
    <=> v118728(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1185,axiom,
    ! [VarCurr: state_type] :
      ( v119364(VarCurr)
    <=> ( ( v119366(VarCurr,1)
        <=> $false )
        & ( v119366(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v119366(VarCurr,B)
      <=> v119368(VarCurr,B) ) ) ).

tff(addAssignment_69364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v119368(VarCurr,B)
      <=> v119370(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119407(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v119370(VarNext,B)
            <=> v119370(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1552,axiom,
    ! [VarNext: state_type] :
      ( v119407(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119370(VarNext,B)
          <=> v119417(VarNext,B) ) ) ) ).

tff(addAssignment_69363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119417(VarNext,B)
          <=> v119415(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119418(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119415(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1094,axiom,
    ! [VarCurr: state_type] :
      ( v119418(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119415(VarCurr,B)
          <=> v119380(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13790,axiom,
    ! [VarCurr: state_type] :
      ( v119418(VarCurr)
    <=> ( v119419(VarCurr)
        & v119420(VarCurr) ) ) ).

tff(writeUnaryOperator_7541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119420(VarCurr)
    <=> v119376(VarCurr) ) ).

tff(writeUnaryOperator_7540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119419(VarCurr)
    <=> v119372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119407(VarNext)
      <=> v119408(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119408(VarNext)
      <=> ( v119409(VarNext)
          & v119402(VarNext) ) ) ) ).

tff(writeUnaryOperator_7539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119409(VarNext)
      <=> v119411(VarNext) ) ) ).

tff(addAssignment_69362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119411(VarNext)
      <=> v119402(VarCurr) ) ) ).

tff(addAssignment_69361,axiom,
    ! [VarCurr: state_type] :
      ( v119402(VarCurr)
    <=> v119404(VarCurr) ) ).

tff(addAssignment_69360,axiom,
    ! [VarCurr: state_type] :
      ( v119404(VarCurr)
    <=> v119198(VarCurr) ) ).

tff(addAssignment_69359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v119380(VarCurr,B)
      <=> v119382(VarCurr,B) ) ) ).

tff(addAssignment_69358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v119382(VarCurr,B)
      <=> v119384(VarCurr,B) ) ) ).

tff(addAssignment_69357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v119384(VarCurr,B)
      <=> v119386(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119388(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119386(VarCurr,B)
          <=> v119393(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1093,axiom,
    ! [VarCurr: state_type] :
      ( v119388(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119386(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119364(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119393(VarCurr,B)
          <=> v119394(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1092,axiom,
    ! [VarCurr: state_type] :
      ( v119364(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v119393(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69356,axiom,
    ! [VarCurr: state_type] :
      ( v119394(VarCurr,0)
    <=> v119398(VarCurr) ) ).

tff(addAssignment_69355,axiom,
    ! [VarCurr: state_type] :
      ( v119394(VarCurr,1)
    <=> v119396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13787,axiom,
    ! [VarCurr: state_type] :
      ( v119396(VarCurr)
    <=> ( v119397(VarCurr)
        & v119399(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13786,axiom,
    ! [VarCurr: state_type] :
      ( v119399(VarCurr)
    <=> ( v119366(VarCurr,0)
        | v119400(VarCurr) ) ) ).

tff(writeUnaryOperator_7538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119400(VarCurr)
    <=> v119366(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5157,axiom,
    ! [VarCurr: state_type] :
      ( v119397(VarCurr)
    <=> ( v119398(VarCurr)
        | v119366(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119398(VarCurr)
    <=> v119366(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13785,axiom,
    ! [VarCurr: state_type] :
      ( v119388(VarCurr)
    <=> ( v119390(VarCurr)
        | v119391(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5156,axiom,
    ! [VarCurr: state_type] :
      ( v119391(VarCurr)
    <=> ( v118718(VarCurr,1)
        & v119231(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5155,axiom,
    ! [VarCurr: state_type] :
      ( v119390(VarCurr)
    <=> ( v118718(VarCurr,3)
        & v119289(VarCurr) ) ) ).

tff(addAssignment_69354,axiom,
    ! [VarCurr: state_type] :
      ( v119376(VarCurr)
    <=> v119378(VarCurr) ) ).

tff(addAssignment_69353,axiom,
    ! [VarCurr: state_type] :
      ( v119378(VarCurr)
    <=> v118736(VarCurr) ) ).

tff(addAssignment_69352,axiom,
    ! [VarCurr: state_type] :
      ( v119372(VarCurr)
    <=> v119374(VarCurr) ) ).

tff(addAssignment_69351,axiom,
    ! [VarCurr: state_type] :
      ( v119374(VarCurr)
    <=> v118728(VarCurr) ) ).

tff(addAssignment_69350,axiom,
    ! [VarCurr: state_type] :
      ( v118718(VarCurr,1)
    <=> v118720(VarCurr,1) ) ).

tff(addAssignment_69349,axiom,
    ! [VarCurr: state_type] :
      ( v118720(VarCurr,1)
    <=> v118722(VarCurr,1) ) ).

tff(addAssignment_69348,axiom,
    ! [VarNext: state_type] :
      ( v118722(VarNext,1)
    <=> v119356(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119357(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v119356(VarNext,B)
            <=> v118722(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1551,axiom,
    ! [VarNext: state_type] :
      ( v119357(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119356(VarNext,B)
          <=> v119282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119357(VarNext)
      <=> v119358(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119358(VarNext)
      <=> ( v119360(VarNext)
          & v119267(VarNext) ) ) ) ).

tff(writeUnaryOperator_7536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119360(VarNext)
      <=> v119276(VarNext) ) ) ).

tff(addAssignment_69347,axiom,
    ! [VarCurr: state_type] :
      ( v118740(VarCurr,1)
    <=> v118742(VarCurr,1) ) ).

tff(addAssignment_69346,axiom,
    ! [VarCurr: state_type] :
      ( v118742(VarCurr,1)
    <=> v118744(VarCurr,1) ) ).

tff(addAssignment_69345,axiom,
    ! [VarCurr: state_type] :
      ( v118744(VarCurr,1)
    <=> v119265(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_50,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119347(VarCurr)
     => ( v118746(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_79,axiom,
    ! [VarCurr: state_type] :
      ( v119347(VarCurr)
     => ( v118746(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13782,axiom,
    ! [VarCurr: state_type] :
      ( v119347(VarCurr)
    <=> ( v119348(VarCurr)
        | v119349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13781,axiom,
    ! [VarCurr: state_type] :
      ( v119349(VarCurr)
    <=> ( v119350(VarCurr)
        & v119351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13780,axiom,
    ! [VarCurr: state_type] :
      ( v119351(VarCurr)
    <=> ( v119352(VarCurr)
        & v119248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13779,axiom,
    ! [VarCurr: state_type] :
      ( v119352(VarCurr)
    <=> ( v119353(VarCurr)
        & v119354(VarCurr) ) ) ).

tff(writeUnaryOperator_7535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119354(VarCurr)
    <=> v119240(VarCurr) ) ).

tff(writeUnaryOperator_7534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119353(VarCurr)
    <=> v119231(VarCurr) ) ).

tff(writeUnaryOperator_7533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119350(VarCurr)
    <=> v119250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13778,axiom,
    ! [VarCurr: state_type] :
      ( v119348(VarCurr)
    <=> ( v119322(VarCurr)
        & v119250(VarCurr) ) ) ).

tff(writeUnaryOperator_7532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118718(VarCurr,0)
    <=> v119227(VarCurr) ) ).

tff(addAssignment_69344,axiom,
    ! [VarCurr: state_type] :
      ( v119227(VarCurr)
    <=> v118720(VarCurr,0) ) ).

tff(addAssignment_69343,axiom,
    ! [VarCurr: state_type] :
      ( v118720(VarCurr,0)
    <=> v118722(VarCurr,0) ) ).

tff(addAssignment_69342,axiom,
    ! [VarNext: state_type] :
      ( v118722(VarNext,0)
    <=> v119338(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119339(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v119338(VarNext,B)
            <=> v118722(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1550,axiom,
    ! [VarNext: state_type] :
      ( v119339(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119338(VarNext,B)
          <=> v119282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119339(VarNext)
      <=> v119340(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119340(VarNext)
      <=> ( v119342(VarNext)
          & v119267(VarNext) ) ) ) ).

tff(writeUnaryOperator_7531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119342(VarNext)
      <=> v119276(VarNext) ) ) ).

tff(addAssignment_69341,axiom,
    ! [VarCurr: state_type] :
      ( v118740(VarCurr,0)
    <=> v118742(VarCurr,0) ) ).

tff(addAssignment_69340,axiom,
    ! [VarCurr: state_type] :
      ( v118742(VarCurr,0)
    <=> v118744(VarCurr,0) ) ).

tff(addAssignment_69339,axiom,
    ! [VarCurr: state_type] :
      ( v118744(VarCurr,0)
    <=> v119265(VarCurr,0) ) ).

tff(writeUnaryOperator_7530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119229(VarCurr)
    <=> v118746(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119317(VarCurr)
     => ( v118746(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1091,axiom,
    ! [VarCurr: state_type] :
      ( v119317(VarCurr)
     => ( v118746(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13775,axiom,
    ! [VarCurr: state_type] :
      ( v119317(VarCurr)
    <=> ( v119318(VarCurr)
        | v119331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13774,axiom,
    ! [VarCurr: state_type] :
      ( v119331(VarCurr)
    <=> ( v119332(VarCurr)
        & v119335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13773,axiom,
    ! [VarCurr: state_type] :
      ( v119335(VarCurr)
    <=> ( v119303(VarCurr)
        & v119306(VarCurr) ) ) ).

tff(writeUnaryOperator_7529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119332(VarCurr)
    <=> v119333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13772,axiom,
    ! [VarCurr: state_type] :
      ( v119333(VarCurr)
    <=> ( v119334(VarCurr)
        | v119263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13771,axiom,
    ! [VarCurr: state_type] :
      ( v119334(VarCurr)
    <=> ( v119250(VarCurr)
        | v119248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13770,axiom,
    ! [VarCurr: state_type] :
      ( v119318(VarCurr)
    <=> ( v119319(VarCurr)
        | v119327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13769,axiom,
    ! [VarCurr: state_type] :
      ( v119327(VarCurr)
    <=> ( v119328(VarCurr)
        & v119330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13768,axiom,
    ! [VarCurr: state_type] :
      ( v119330(VarCurr)
    <=> ( v119261(VarCurr)
        & v119263(VarCurr) ) ) ).

tff(writeUnaryOperator_7528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119328(VarCurr)
    <=> v119329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13767,axiom,
    ! [VarCurr: state_type] :
      ( v119329(VarCurr)
    <=> ( v119250(VarCurr)
        | v119248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13766,axiom,
    ! [VarCurr: state_type] :
      ( v119319(VarCurr)
    <=> ( v119320(VarCurr)
        | v119324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13765,axiom,
    ! [VarCurr: state_type] :
      ( v119324(VarCurr)
    <=> ( v119325(VarCurr)
        & v119326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13764,axiom,
    ! [VarCurr: state_type] :
      ( v119326(VarCurr)
    <=> ( v119240(VarCurr)
        & v119248(VarCurr) ) ) ).

tff(writeUnaryOperator_7527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119325(VarCurr)
    <=> v119250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13763,axiom,
    ! [VarCurr: state_type] :
      ( v119320(VarCurr)
    <=> ( v119321(VarCurr)
        & v119250(VarCurr) ) ) ).

tff(writeUnaryOperator_7526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119321(VarCurr)
    <=> v119322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13762,axiom,
    ! [VarCurr: state_type] :
      ( v119322(VarCurr)
    <=> ( v119323(VarCurr)
        & v119225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13761,axiom,
    ! [VarCurr: state_type] :
      ( v119323(VarCurr)
    <=> ( v118748(VarCurr)
        & v119223(VarCurr) ) ) ).

tff(addAssignment_69338,axiom,
    ! [VarCurr: state_type] :
      ( v118718(VarCurr,3)
    <=> v118720(VarCurr,3) ) ).

tff(addAssignment_69337,axiom,
    ! [VarCurr: state_type] :
      ( v118720(VarCurr,3)
    <=> v118722(VarCurr,3) ) ).

tff(addAssignment_69336,axiom,
    ! [VarNext: state_type] :
      ( v118722(VarNext,3)
    <=> v119309(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119310(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v119309(VarNext,B)
            <=> v118722(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1549,axiom,
    ! [VarNext: state_type] :
      ( v119310(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119309(VarNext,B)
          <=> v119282(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119310(VarNext)
      <=> v119311(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119311(VarNext)
      <=> ( v119313(VarNext)
          & v119267(VarNext) ) ) ) ).

tff(writeUnaryOperator_7525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119313(VarNext)
      <=> v119276(VarNext) ) ) ).

tff(addAssignment_69335,axiom,
    ! [VarCurr: state_type] :
      ( v118740(VarCurr,3)
    <=> v118742(VarCurr,3) ) ).

tff(addAssignment_69334,axiom,
    ! [VarCurr: state_type] :
      ( v118742(VarCurr,3)
    <=> v118744(VarCurr,3) ) ).

tff(addAssignment_69333,axiom,
    ! [VarCurr: state_type] :
      ( v118744(VarCurr,3)
    <=> v119265(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_49,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119291(VarCurr)
     => ( v118746(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_78,axiom,
    ! [VarCurr: state_type] :
      ( v119291(VarCurr)
     => ( v118746(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13758,axiom,
    ! [VarCurr: state_type] :
      ( v119291(VarCurr)
    <=> ( v119292(VarCurr)
        | v119298(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13757,axiom,
    ! [VarCurr: state_type] :
      ( v119298(VarCurr)
    <=> ( v119299(VarCurr)
        & v119300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13756,axiom,
    ! [VarCurr: state_type] :
      ( v119300(VarCurr)
    <=> ( v119301(VarCurr)
        & v119307(VarCurr) ) ) ).

tff(writeUnaryOperator_7524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119307(VarCurr)
    <=> v119297(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13755,axiom,
    ! [VarCurr: state_type] :
      ( v119301(VarCurr)
    <=> ( v119302(VarCurr)
        & v119306(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1184,axiom,
    ! [VarCurr: state_type] :
      ( v119306(VarCurr)
    <=> ( $true
      <=> v118718(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119302(VarCurr)
    <=> v119303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13754,axiom,
    ! [VarCurr: state_type] :
      ( v119303(VarCurr)
    <=> ( v119304(VarCurr)
        | v119233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13753,axiom,
    ! [VarCurr: state_type] :
      ( v119304(VarCurr)
    <=> ( v119305(VarCurr)
        | v119289(VarCurr) ) ) ).

tff(writeUnaryOperator_7522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119305(VarCurr)
    <=> v119223(VarCurr) ) ).

tff(writeUnaryOperator_7521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119299(VarCurr)
    <=> v119263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13752,axiom,
    ! [VarCurr: state_type] :
      ( v119292(VarCurr)
    <=> ( v119293(VarCurr)
        & v119296(VarCurr) ) ) ).

tff(writeUnaryOperator_7520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119296(VarCurr)
    <=> v119297(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13751,axiom,
    ! [VarCurr: state_type] :
      ( v119297(VarCurr)
    <=> ( v119250(VarCurr)
        | v119248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13750,axiom,
    ! [VarCurr: state_type] :
      ( v119293(VarCurr)
    <=> ( v119294(VarCurr)
        & v119263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13749,axiom,
    ! [VarCurr: state_type] :
      ( v119294(VarCurr)
    <=> ( v119257(VarCurr)
        & v119295(VarCurr) ) ) ).

tff(writeUnaryOperator_7519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119295(VarCurr)
    <=> v119261(VarCurr) ) ).

tff(addAssignment_69332,axiom,
    ! [VarCurr: state_type] :
      ( v119289(VarCurr)
    <=> v112831(VarCurr,6) ) ).

tff(addAssignment_69331,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,6)
    <=> v112865(VarCurr,6) ) ).

tff(addAssignment_69330,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,6)
    <=> v112849(VarCurr,6) ) ).

tff(addAssignment_69329,axiom,
    ! [VarCurr: state_type] :
      ( v118718(VarCurr,2)
    <=> v118720(VarCurr,2) ) ).

tff(addAssignment_69328,axiom,
    ! [VarCurr: state_type] :
      ( v118720(VarCurr,2)
    <=> v118722(VarCurr,2) ) ).

tff(addAssignment_69327,axiom,
    ! [VarNext: state_type] :
      ( v118722(VarNext,2)
    <=> v119271(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119272(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v119271(VarNext,B)
            <=> v118722(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1548,axiom,
    ! [VarNext: state_type] :
      ( v119272(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119271(VarNext,B)
          <=> v119282(VarNext,B) ) ) ) ).

tff(addAssignment_69326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119282(VarNext,B)
          <=> v119280(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119283(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119280(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1090,axiom,
    ! [VarCurr: state_type] :
      ( v119283(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v119280(VarCurr,B)
          <=> v118740(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13748,axiom,
    ! [VarCurr: state_type] :
      ( v119283(VarCurr)
    <=> ( v119284(VarCurr)
        & v119285(VarCurr) ) ) ).

tff(writeUnaryOperator_7518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119285(VarCurr)
    <=> v118732(VarCurr) ) ).

tff(writeUnaryOperator_7517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119284(VarCurr)
    <=> v118724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119272(VarNext)
      <=> v119273(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119273(VarNext)
      <=> ( v119274(VarNext)
          & v119267(VarNext) ) ) ) ).

tff(writeUnaryOperator_7516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119274(VarNext)
      <=> v119276(VarNext) ) ) ).

tff(addAssignment_69325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119276(VarNext)
      <=> v119267(VarCurr) ) ) ).

tff(addAssignment_69324,axiom,
    ! [VarCurr: state_type] :
      ( v119267(VarCurr)
    <=> v119269(VarCurr) ) ).

tff(addAssignment_69323,axiom,
    ! [VarCurr: state_type] :
      ( v119269(VarCurr)
    <=> v119198(VarCurr) ) ).

tff(addAssignment_69322,axiom,
    ! [VarCurr: state_type] :
      ( v118740(VarCurr,2)
    <=> v118742(VarCurr,2) ) ).

tff(addAssignment_69321,axiom,
    ! [VarCurr: state_type] :
      ( v118742(VarCurr,2)
    <=> v118744(VarCurr,2) ) ).

tff(addAssignment_69320,axiom,
    ! [VarCurr: state_type] :
      ( v118744(VarCurr,2)
    <=> v119265(VarCurr,2) ) ).

tff(addAssignment_69319,axiom,
    ! [VarCurr: state_type] :
      ( v119265(VarCurr,0)
    <=> v119229(VarCurr) ) ).

tff(addAssignment_69318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v119265(VarCurr,B)
      <=> v118746(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_48,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119235(VarCurr)
     => ( v118746(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_77,axiom,
    ! [VarCurr: state_type] :
      ( v119235(VarCurr)
     => ( v118746(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13745,axiom,
    ! [VarCurr: state_type] :
      ( v119235(VarCurr)
    <=> ( v119236(VarCurr)
        | v119251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13744,axiom,
    ! [VarCurr: state_type] :
      ( v119251(VarCurr)
    <=> ( v119252(VarCurr)
        & v119253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13743,axiom,
    ! [VarCurr: state_type] :
      ( v119253(VarCurr)
    <=> ( v119254(VarCurr)
        & v119264(VarCurr) ) ) ).

tff(writeUnaryOperator_7515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119264(VarCurr)
    <=> v119250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13742,axiom,
    ! [VarCurr: state_type] :
      ( v119254(VarCurr)
    <=> ( v119255(VarCurr)
        & v119263(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1183,axiom,
    ! [VarCurr: state_type] :
      ( v119263(VarCurr)
    <=> ( $true
      <=> v118718(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13741,axiom,
    ! [VarCurr: state_type] :
      ( v119255(VarCurr)
    <=> ( v119256(VarCurr)
        & v119260(VarCurr) ) ) ).

tff(writeUnaryOperator_7514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119260(VarCurr)
    <=> v119261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13740,axiom,
    ! [VarCurr: state_type] :
      ( v119261(VarCurr)
    <=> ( v119262(VarCurr)
        | v119233(VarCurr) ) ) ).

tff(writeUnaryOperator_7513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119262(VarCurr)
    <=> v119223(VarCurr) ) ).

tff(writeUnaryOperator_7512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119256(VarCurr)
    <=> v119257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13739,axiom,
    ! [VarCurr: state_type] :
      ( v119257(VarCurr)
    <=> ( v119258(VarCurr)
        | v119259(VarCurr) ) ) ).

tff(writeUnaryOperator_7511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119259(VarCurr)
    <=> v119225(VarCurr) ) ).

tff(writeUnaryOperator_7510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119258(VarCurr)
    <=> v118748(VarCurr) ) ).

tff(writeUnaryOperator_7509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119252(VarCurr)
    <=> v119248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13738,axiom,
    ! [VarCurr: state_type] :
      ( v119236(VarCurr)
    <=> ( v119237(VarCurr)
        & v119249(VarCurr) ) ) ).

tff(writeUnaryOperator_7508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119249(VarCurr)
    <=> v119250(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1182,axiom,
    ! [VarCurr: state_type] :
      ( v119250(VarCurr)
    <=> ( $true
      <=> v118718(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13737,axiom,
    ! [VarCurr: state_type] :
      ( v119237(VarCurr)
    <=> ( v119238(VarCurr)
        & v119248(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1181,axiom,
    ! [VarCurr: state_type] :
      ( v119248(VarCurr)
    <=> ( $true
      <=> v118718(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13736,axiom,
    ! [VarCurr: state_type] :
      ( v119238(VarCurr)
    <=> ( v119231(VarCurr)
        & v119239(VarCurr) ) ) ).

tff(writeUnaryOperator_7507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119239(VarCurr)
    <=> v119240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13735,axiom,
    ! [VarCurr: state_type] :
      ( v119240(VarCurr)
    <=> ( v119241(VarCurr)
        | v119233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13734,axiom,
    ! [VarCurr: state_type] :
      ( v119241(VarCurr)
    <=> ( v119242(VarCurr)
        | v119245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13733,axiom,
    ! [VarCurr: state_type] :
      ( v119245(VarCurr)
    <=> ( v119246(VarCurr)
        & v119247(VarCurr) ) ) ).

tff(writeUnaryOperator_7506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119247(VarCurr)
    <=> v119231(VarCurr) ) ).

tff(writeUnaryOperator_7505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119246(VarCurr)
    <=> v118748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13732,axiom,
    ! [VarCurr: state_type] :
      ( v119242(VarCurr)
    <=> ( v119243(VarCurr)
        | v119244(VarCurr) ) ) ).

tff(writeUnaryOperator_7504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119244(VarCurr)
    <=> v119225(VarCurr) ) ).

tff(writeUnaryOperator_7503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119243(VarCurr)
    <=> v119223(VarCurr) ) ).

tff(addAssignment_69317,axiom,
    ! [VarCurr: state_type] :
      ( v119233(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_69316,axiom,
    ! [VarCurr: state_type] :
      ( v119231(VarCurr)
    <=> v112643(VarCurr,6) ) ).

tff(addAssignment_69315,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,6)
    <=> v115202(VarCurr,6) ) ).

tff(addAssignment_69314,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,6)
    <=> v115186(VarCurr,6) ) ).

tff(addAssignment_69313,axiom,
    ! [VarCurr: state_type] :
      ( v119225(VarCurr)
    <=> v112528(VarCurr,6) ) ).

tff(addAssignment_69312,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,6)
    <=> v112530(VarCurr,6) ) ).

tff(addAssignment_69311,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,6)
    <=> v112590(VarCurr,6) ) ).

tff(addAssignment_69310,axiom,
    ! [VarCurr: state_type] :
      ( v119223(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13731,axiom,
    ! [VarCurr: state_type] :
      ( v118748(VarCurr)
    <=> ( v119220(VarCurr)
        & v119221(VarCurr) ) ) ).

tff(writeUnaryOperator_7502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119221(VarCurr)
    <=> v119218(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1180,axiom,
    ! [VarCurr: state_type] :
      ( v119220(VarCurr)
    <=> ( ( v118750(VarCurr,5)
        <=> $false )
        & ( v118750(VarCurr,4)
        <=> $false )
        & ( v118750(VarCurr,3)
        <=> $false )
        & ( v118750(VarCurr,2)
        <=> $false )
        & ( v118750(VarCurr,1)
        <=> $false )
        & ( v118750(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69309,axiom,
    ! [VarCurr: state_type] :
      ( v119218(VarCurr)
    <=> v115139(VarCurr,6) ) ).

tff(addAssignment_69308,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,6)
    <=> v115159(VarCurr,6) ) ).

tff(addAssignment_69307,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,6)
    <=> v115142(VarCurr,6) ) ).

tff(addAssignment_69306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v118750(VarCurr,B)
      <=> v118752(VarCurr,B) ) ) ).

tff(addAssignment_69305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v118752(VarCurr,B)
      <=> v118754(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119201(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v118754(VarNext,B)
            <=> v118754(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1547,axiom,
    ! [VarNext: state_type] :
      ( v119201(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v118754(VarNext,B)
          <=> v119211(VarNext,B) ) ) ) ).

tff(addAssignment_69304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v119211(VarNext,B)
          <=> v119209(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119212(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v119209(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1089,axiom,
    ! [VarCurr: state_type] :
      ( v119212(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v119209(VarCurr,B)
          <=> v118764(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13730,axiom,
    ! [VarCurr: state_type] :
      ( v119212(VarCurr)
    <=> ( v119213(VarCurr)
        & v119214(VarCurr) ) ) ).

tff(writeUnaryOperator_7501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119214(VarCurr)
    <=> v118760(VarCurr) ) ).

tff(writeUnaryOperator_7500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119213(VarCurr)
    <=> v118756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119201(VarNext)
      <=> v119202(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119202(VarNext)
      <=> ( v119203(VarNext)
          & v119194(VarNext) ) ) ) ).

tff(writeUnaryOperator_7499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119203(VarNext)
      <=> v119205(VarNext) ) ) ).

tff(addAssignment_69303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119205(VarNext)
      <=> v119194(VarCurr) ) ) ).

tff(addAssignment_69302,axiom,
    ! [VarCurr: state_type] :
      ( v119194(VarCurr)
    <=> v119196(VarCurr) ) ).

tff(addAssignment_69301,axiom,
    ! [VarCurr: state_type] :
      ( v119196(VarCurr)
    <=> v119198(VarCurr) ) ).

tff(addAssignment_69300,axiom,
    ! [VarCurr: state_type] :
      ( v119198(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_69299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v118764(VarCurr,B)
      <=> v118766(VarCurr,B) ) ) ).

tff(addAssignment_69298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v118766(VarCurr,B)
      <=> v118768(VarCurr,B) ) ) ).

tff(addAssignment_69297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v118768(VarCurr,B)
      <=> v118770(VarCurr,B) ) ) ).

tff(addAssignment_69296,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,0)
    <=> v119189(VarCurr) ) ).

tff(addAssignment_69295,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,1)
    <=> v119184(VarCurr) ) ).

tff(addAssignment_69294,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,2)
    <=> v119179(VarCurr) ) ).

tff(addAssignment_69293,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,3)
    <=> v119174(VarCurr) ) ).

tff(addAssignment_69292,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,4)
    <=> v119169(VarCurr) ) ).

tff(addAssignment_69291,axiom,
    ! [VarCurr: state_type] :
      ( v118770(VarCurr,5)
    <=> v119026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13727,axiom,
    ! [VarCurr: state_type] :
      ( v119189(VarCurr)
    <=> ( v119190(VarCurr)
        & v119192(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13726,axiom,
    ! [VarCurr: state_type] :
      ( v119192(VarCurr)
    <=> ( v118981(VarCurr,0)
        | v119038(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13725,axiom,
    ! [VarCurr: state_type] :
      ( v119190(VarCurr)
    <=> ( v119115(VarCurr)
        | v119191(VarCurr) ) ) ).

tff(writeUnaryOperator_7498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119191(VarCurr)
    <=> v119038(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13724,axiom,
    ! [VarCurr: state_type] :
      ( v119184(VarCurr)
    <=> ( v119185(VarCurr)
        & v119188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13723,axiom,
    ! [VarCurr: state_type] :
      ( v119188(VarCurr)
    <=> ( v119037(VarCurr)
        | v119109(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13722,axiom,
    ! [VarCurr: state_type] :
      ( v119185(VarCurr)
    <=> ( v119186(VarCurr)
        | v119187(VarCurr) ) ) ).

tff(writeUnaryOperator_7497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119187(VarCurr)
    <=> v119109(VarCurr) ) ).

tff(writeUnaryOperator_7496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119186(VarCurr)
    <=> v119037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13721,axiom,
    ! [VarCurr: state_type] :
      ( v119179(VarCurr)
    <=> ( v119180(VarCurr)
        & v119183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13720,axiom,
    ! [VarCurr: state_type] :
      ( v119183(VarCurr)
    <=> ( v119035(VarCurr)
        | v119120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13719,axiom,
    ! [VarCurr: state_type] :
      ( v119180(VarCurr)
    <=> ( v119181(VarCurr)
        | v119182(VarCurr) ) ) ).

tff(writeUnaryOperator_7495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119182(VarCurr)
    <=> v119120(VarCurr) ) ).

tff(writeUnaryOperator_7494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119181(VarCurr)
    <=> v119035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13718,axiom,
    ! [VarCurr: state_type] :
      ( v119174(VarCurr)
    <=> ( v119175(VarCurr)
        & v119178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13717,axiom,
    ! [VarCurr: state_type] :
      ( v119178(VarCurr)
    <=> ( v119033(VarCurr)
        | v119132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13716,axiom,
    ! [VarCurr: state_type] :
      ( v119175(VarCurr)
    <=> ( v119176(VarCurr)
        | v119177(VarCurr) ) ) ).

tff(writeUnaryOperator_7493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119177(VarCurr)
    <=> v119132(VarCurr) ) ).

tff(writeUnaryOperator_7492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119176(VarCurr)
    <=> v119033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13715,axiom,
    ! [VarCurr: state_type] :
      ( v119169(VarCurr)
    <=> ( v119170(VarCurr)
        & v119173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13714,axiom,
    ! [VarCurr: state_type] :
      ( v119173(VarCurr)
    <=> ( v119031(VarCurr)
        | v119144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13713,axiom,
    ! [VarCurr: state_type] :
      ( v119170(VarCurr)
    <=> ( v119171(VarCurr)
        | v119172(VarCurr) ) ) ).

tff(writeUnaryOperator_7491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119172(VarCurr)
    <=> v119144(VarCurr) ) ).

tff(writeUnaryOperator_7490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119171(VarCurr)
    <=> v119031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13712,axiom,
    ! [VarCurr: state_type] :
      ( v119026(VarCurr)
    <=> ( v119027(VarCurr)
        & v119168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13711,axiom,
    ! [VarCurr: state_type] :
      ( v119168(VarCurr)
    <=> ( v119029(VarCurr)
        | v119157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13710,axiom,
    ! [VarCurr: state_type] :
      ( v119027(VarCurr)
    <=> ( v119028(VarCurr)
        | v119156(VarCurr) ) ) ).

tff(writeUnaryOperator_7489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119156(VarCurr)
    <=> v119157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13709,axiom,
    ! [VarCurr: state_type] :
      ( v119157(VarCurr)
    <=> ( v119158(VarCurr)
        & v119167(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5154,axiom,
    ! [VarCurr: state_type] :
      ( v119167(VarCurr)
    <=> ( v119160(VarCurr)
        | v119038(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13708,axiom,
    ! [VarCurr: state_type] :
      ( v119158(VarCurr)
    <=> ( v119159(VarCurr)
        | v119166(VarCurr) ) ) ).

tff(writeUnaryOperator_7488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119166(VarCurr)
    <=> v119038(VarCurr,5) ) ).

tff(writeUnaryOperator_7487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119159(VarCurr)
    <=> v119160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13707,axiom,
    ! [VarCurr: state_type] :
      ( v119160(VarCurr)
    <=> ( v119161(VarCurr)
        & v119164(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13706,axiom,
    ! [VarCurr: state_type] :
      ( v119164(VarCurr)
    <=> ( v119163(VarCurr)
        | v119165(VarCurr) ) ) ).

tff(writeUnaryOperator_7486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119165(VarCurr)
    <=> v118981(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5153,axiom,
    ! [VarCurr: state_type] :
      ( v119161(VarCurr)
    <=> ( v119162(VarCurr)
        | v118981(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119162(VarCurr)
    <=> v119163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13705,axiom,
    ! [VarCurr: state_type] :
      ( v119163(VarCurr)
    <=> ( v119150(VarCurr)
        & v119152(VarCurr) ) ) ).

tff(writeUnaryOperator_7484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119028(VarCurr)
    <=> v119029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13704,axiom,
    ! [VarCurr: state_type] :
      ( v119029(VarCurr)
    <=> ( v119030(VarCurr)
        | v119155(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5152,axiom,
    ! [VarCurr: state_type] :
      ( v119155(VarCurr)
    <=> ( v119147(VarCurr)
        & v119038(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13703,axiom,
    ! [VarCurr: state_type] :
      ( v119030(VarCurr)
    <=> ( v119031(VarCurr)
        & v119144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13702,axiom,
    ! [VarCurr: state_type] :
      ( v119144(VarCurr)
    <=> ( v119145(VarCurr)
        & v119154(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5151,axiom,
    ! [VarCurr: state_type] :
      ( v119154(VarCurr)
    <=> ( v119147(VarCurr)
        | v119038(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13701,axiom,
    ! [VarCurr: state_type] :
      ( v119145(VarCurr)
    <=> ( v119146(VarCurr)
        | v119153(VarCurr) ) ) ).

tff(writeUnaryOperator_7483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119153(VarCurr)
    <=> v119038(VarCurr,4) ) ).

tff(writeUnaryOperator_7482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119146(VarCurr)
    <=> v119147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13700,axiom,
    ! [VarCurr: state_type] :
      ( v119147(VarCurr)
    <=> ( v119148(VarCurr)
        & v119151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13699,axiom,
    ! [VarCurr: state_type] :
      ( v119151(VarCurr)
    <=> ( v119150(VarCurr)
        | v119152(VarCurr) ) ) ).

tff(writeUnaryOperator_7481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119152(VarCurr)
    <=> v118981(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5150,axiom,
    ! [VarCurr: state_type] :
      ( v119148(VarCurr)
    <=> ( v119149(VarCurr)
        | v118981(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119149(VarCurr)
    <=> v119150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13698,axiom,
    ! [VarCurr: state_type] :
      ( v119150(VarCurr)
    <=> ( v119138(VarCurr)
        & v119140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13697,axiom,
    ! [VarCurr: state_type] :
      ( v119031(VarCurr)
    <=> ( v119032(VarCurr)
        | v119143(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5149,axiom,
    ! [VarCurr: state_type] :
      ( v119143(VarCurr)
    <=> ( v119135(VarCurr)
        & v119038(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13696,axiom,
    ! [VarCurr: state_type] :
      ( v119032(VarCurr)
    <=> ( v119033(VarCurr)
        & v119132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13695,axiom,
    ! [VarCurr: state_type] :
      ( v119132(VarCurr)
    <=> ( v119133(VarCurr)
        & v119142(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5148,axiom,
    ! [VarCurr: state_type] :
      ( v119142(VarCurr)
    <=> ( v119135(VarCurr)
        | v119038(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13694,axiom,
    ! [VarCurr: state_type] :
      ( v119133(VarCurr)
    <=> ( v119134(VarCurr)
        | v119141(VarCurr) ) ) ).

tff(writeUnaryOperator_7479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119141(VarCurr)
    <=> v119038(VarCurr,3) ) ).

tff(writeUnaryOperator_7478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119134(VarCurr)
    <=> v119135(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13693,axiom,
    ! [VarCurr: state_type] :
      ( v119135(VarCurr)
    <=> ( v119136(VarCurr)
        & v119139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13692,axiom,
    ! [VarCurr: state_type] :
      ( v119139(VarCurr)
    <=> ( v119138(VarCurr)
        | v119140(VarCurr) ) ) ).

tff(writeUnaryOperator_7477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119140(VarCurr)
    <=> v118981(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5147,axiom,
    ! [VarCurr: state_type] :
      ( v119136(VarCurr)
    <=> ( v119137(VarCurr)
        | v118981(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119137(VarCurr)
    <=> v119138(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13691,axiom,
    ! [VarCurr: state_type] :
      ( v119138(VarCurr)
    <=> ( v119126(VarCurr)
        & v119128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13690,axiom,
    ! [VarCurr: state_type] :
      ( v119033(VarCurr)
    <=> ( v119034(VarCurr)
        | v119131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5146,axiom,
    ! [VarCurr: state_type] :
      ( v119131(VarCurr)
    <=> ( v119123(VarCurr)
        & v119038(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13689,axiom,
    ! [VarCurr: state_type] :
      ( v119034(VarCurr)
    <=> ( v119035(VarCurr)
        & v119120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13688,axiom,
    ! [VarCurr: state_type] :
      ( v119120(VarCurr)
    <=> ( v119121(VarCurr)
        & v119130(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5145,axiom,
    ! [VarCurr: state_type] :
      ( v119130(VarCurr)
    <=> ( v119123(VarCurr)
        | v119038(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13687,axiom,
    ! [VarCurr: state_type] :
      ( v119121(VarCurr)
    <=> ( v119122(VarCurr)
        | v119129(VarCurr) ) ) ).

tff(writeUnaryOperator_7475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119129(VarCurr)
    <=> v119038(VarCurr,2) ) ).

tff(writeUnaryOperator_7474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119122(VarCurr)
    <=> v119123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13686,axiom,
    ! [VarCurr: state_type] :
      ( v119123(VarCurr)
    <=> ( v119124(VarCurr)
        & v119127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13685,axiom,
    ! [VarCurr: state_type] :
      ( v119127(VarCurr)
    <=> ( v119126(VarCurr)
        | v119128(VarCurr) ) ) ).

tff(writeUnaryOperator_7473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119128(VarCurr)
    <=> v118981(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5144,axiom,
    ! [VarCurr: state_type] :
      ( v119124(VarCurr)
    <=> ( v119125(VarCurr)
        | v118981(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119125(VarCurr)
    <=> v119126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13684,axiom,
    ! [VarCurr: state_type] :
      ( v119126(VarCurr)
    <=> ( v119115(VarCurr)
        & v119116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13683,axiom,
    ! [VarCurr: state_type] :
      ( v119035(VarCurr)
    <=> ( v119036(VarCurr)
        | v119119(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5143,axiom,
    ! [VarCurr: state_type] :
      ( v119119(VarCurr)
    <=> ( v119112(VarCurr)
        & v119038(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13682,axiom,
    ! [VarCurr: state_type] :
      ( v119036(VarCurr)
    <=> ( v119037(VarCurr)
        & v119109(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13681,axiom,
    ! [VarCurr: state_type] :
      ( v119109(VarCurr)
    <=> ( v119110(VarCurr)
        & v119118(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5142,axiom,
    ! [VarCurr: state_type] :
      ( v119118(VarCurr)
    <=> ( v119112(VarCurr)
        | v119038(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13680,axiom,
    ! [VarCurr: state_type] :
      ( v119110(VarCurr)
    <=> ( v119111(VarCurr)
        | v119117(VarCurr) ) ) ).

tff(writeUnaryOperator_7471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119117(VarCurr)
    <=> v119038(VarCurr,1) ) ).

tff(writeUnaryOperator_7470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119111(VarCurr)
    <=> v119112(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13679,axiom,
    ! [VarCurr: state_type] :
      ( v119112(VarCurr)
    <=> ( v119113(VarCurr)
        & v119114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13678,axiom,
    ! [VarCurr: state_type] :
      ( v119114(VarCurr)
    <=> ( v119115(VarCurr)
        | v119116(VarCurr) ) ) ).

tff(writeUnaryOperator_7469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119116(VarCurr)
    <=> v118981(VarCurr,1) ) ).

tff(writeUnaryOperator_7468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119115(VarCurr)
    <=> v118981(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5141,axiom,
    ! [VarCurr: state_type] :
      ( v119113(VarCurr)
    <=> ( v118981(VarCurr,0)
        | v118981(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13677,axiom,
    ! [VarCurr: state_type] :
      ( v119037(VarCurr)
    <=> ( v118981(VarCurr,0)
        & v119038(VarCurr,0) ) ) ).

tff(addAssignment_69290,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,0)
    <=> v119104(VarCurr) ) ).

tff(addAssignment_69289,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,1)
    <=> v119099(VarCurr) ) ).

tff(addAssignment_69288,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,2)
    <=> v119094(VarCurr) ) ).

tff(addAssignment_69287,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,3)
    <=> v119089(VarCurr) ) ).

tff(addAssignment_69286,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,4)
    <=> v119084(VarCurr) ) ).

tff(addAssignment_69285,axiom,
    ! [VarCurr: state_type] :
      ( v119038(VarCurr,5)
    <=> v119040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13676,axiom,
    ! [VarCurr: state_type] :
      ( v119104(VarCurr)
    <=> ( v119105(VarCurr)
        & v119108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13675,axiom,
    ! [VarCurr: state_type] :
      ( v119108(VarCurr)
    <=> ( v118750(VarCurr,0)
        | v119052(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13674,axiom,
    ! [VarCurr: state_type] :
      ( v119105(VarCurr)
    <=> ( v119106(VarCurr)
        | v119107(VarCurr) ) ) ).

tff(writeUnaryOperator_7467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119107(VarCurr)
    <=> v119052(VarCurr,0) ) ).

tff(writeUnaryOperator_7466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119106(VarCurr)
    <=> v118750(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13673,axiom,
    ! [VarCurr: state_type] :
      ( v119099(VarCurr)
    <=> ( v119100(VarCurr)
        & v119103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13672,axiom,
    ! [VarCurr: state_type] :
      ( v119103(VarCurr)
    <=> ( v119051(VarCurr)
        | v119053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13671,axiom,
    ! [VarCurr: state_type] :
      ( v119100(VarCurr)
    <=> ( v119101(VarCurr)
        | v119102(VarCurr) ) ) ).

tff(writeUnaryOperator_7465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119102(VarCurr)
    <=> v119053(VarCurr) ) ).

tff(writeUnaryOperator_7464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119101(VarCurr)
    <=> v119051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13670,axiom,
    ! [VarCurr: state_type] :
      ( v119094(VarCurr)
    <=> ( v119095(VarCurr)
        & v119098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13669,axiom,
    ! [VarCurr: state_type] :
      ( v119098(VarCurr)
    <=> ( v119049(VarCurr)
        | v119059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13668,axiom,
    ! [VarCurr: state_type] :
      ( v119095(VarCurr)
    <=> ( v119096(VarCurr)
        | v119097(VarCurr) ) ) ).

tff(writeUnaryOperator_7463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119097(VarCurr)
    <=> v119059(VarCurr) ) ).

tff(writeUnaryOperator_7462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119096(VarCurr)
    <=> v119049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13667,axiom,
    ! [VarCurr: state_type] :
      ( v119089(VarCurr)
    <=> ( v119090(VarCurr)
        & v119093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13666,axiom,
    ! [VarCurr: state_type] :
      ( v119093(VarCurr)
    <=> ( v119047(VarCurr)
        | v119065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13665,axiom,
    ! [VarCurr: state_type] :
      ( v119090(VarCurr)
    <=> ( v119091(VarCurr)
        | v119092(VarCurr) ) ) ).

tff(writeUnaryOperator_7461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119092(VarCurr)
    <=> v119065(VarCurr) ) ).

tff(writeUnaryOperator_7460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119091(VarCurr)
    <=> v119047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13664,axiom,
    ! [VarCurr: state_type] :
      ( v119084(VarCurr)
    <=> ( v119085(VarCurr)
        & v119088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13663,axiom,
    ! [VarCurr: state_type] :
      ( v119088(VarCurr)
    <=> ( v119045(VarCurr)
        | v119071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13662,axiom,
    ! [VarCurr: state_type] :
      ( v119085(VarCurr)
    <=> ( v119086(VarCurr)
        | v119087(VarCurr) ) ) ).

tff(writeUnaryOperator_7459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119087(VarCurr)
    <=> v119071(VarCurr) ) ).

tff(writeUnaryOperator_7458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119086(VarCurr)
    <=> v119045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13661,axiom,
    ! [VarCurr: state_type] :
      ( v119040(VarCurr)
    <=> ( v119041(VarCurr)
        & v119083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13660,axiom,
    ! [VarCurr: state_type] :
      ( v119083(VarCurr)
    <=> ( v119043(VarCurr)
        | v119078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13659,axiom,
    ! [VarCurr: state_type] :
      ( v119041(VarCurr)
    <=> ( v119042(VarCurr)
        | v119077(VarCurr) ) ) ).

tff(writeUnaryOperator_7457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119077(VarCurr)
    <=> v119078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13658,axiom,
    ! [VarCurr: state_type] :
      ( v119078(VarCurr)
    <=> ( v119079(VarCurr)
        & v119082(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5140,axiom,
    ! [VarCurr: state_type] :
      ( v119082(VarCurr)
    <=> ( v118750(VarCurr,5)
        | v119052(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13657,axiom,
    ! [VarCurr: state_type] :
      ( v119079(VarCurr)
    <=> ( v119080(VarCurr)
        | v119081(VarCurr) ) ) ).

tff(writeUnaryOperator_7456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119081(VarCurr)
    <=> v119052(VarCurr,5) ) ).

tff(writeUnaryOperator_7455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119080(VarCurr)
    <=> v118750(VarCurr,5) ) ).

tff(writeUnaryOperator_7454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119042(VarCurr)
    <=> v119043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13656,axiom,
    ! [VarCurr: state_type] :
      ( v119043(VarCurr)
    <=> ( v119044(VarCurr)
        | v119076(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5139,axiom,
    ! [VarCurr: state_type] :
      ( v119076(VarCurr)
    <=> ( v118750(VarCurr,4)
        & v119052(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13655,axiom,
    ! [VarCurr: state_type] :
      ( v119044(VarCurr)
    <=> ( v119045(VarCurr)
        & v119071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13654,axiom,
    ! [VarCurr: state_type] :
      ( v119071(VarCurr)
    <=> ( v119072(VarCurr)
        & v119075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5138,axiom,
    ! [VarCurr: state_type] :
      ( v119075(VarCurr)
    <=> ( v118750(VarCurr,4)
        | v119052(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13653,axiom,
    ! [VarCurr: state_type] :
      ( v119072(VarCurr)
    <=> ( v119073(VarCurr)
        | v119074(VarCurr) ) ) ).

tff(writeUnaryOperator_7453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119074(VarCurr)
    <=> v119052(VarCurr,4) ) ).

tff(writeUnaryOperator_7452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119073(VarCurr)
    <=> v118750(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13652,axiom,
    ! [VarCurr: state_type] :
      ( v119045(VarCurr)
    <=> ( v119046(VarCurr)
        | v119070(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5137,axiom,
    ! [VarCurr: state_type] :
      ( v119070(VarCurr)
    <=> ( v118750(VarCurr,3)
        & v119052(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13651,axiom,
    ! [VarCurr: state_type] :
      ( v119046(VarCurr)
    <=> ( v119047(VarCurr)
        & v119065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13650,axiom,
    ! [VarCurr: state_type] :
      ( v119065(VarCurr)
    <=> ( v119066(VarCurr)
        & v119069(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5136,axiom,
    ! [VarCurr: state_type] :
      ( v119069(VarCurr)
    <=> ( v118750(VarCurr,3)
        | v119052(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13649,axiom,
    ! [VarCurr: state_type] :
      ( v119066(VarCurr)
    <=> ( v119067(VarCurr)
        | v119068(VarCurr) ) ) ).

tff(writeUnaryOperator_7451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119068(VarCurr)
    <=> v119052(VarCurr,3) ) ).

tff(writeUnaryOperator_7450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119067(VarCurr)
    <=> v118750(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13648,axiom,
    ! [VarCurr: state_type] :
      ( v119047(VarCurr)
    <=> ( v119048(VarCurr)
        | v119064(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5135,axiom,
    ! [VarCurr: state_type] :
      ( v119064(VarCurr)
    <=> ( v118750(VarCurr,2)
        & v119052(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13647,axiom,
    ! [VarCurr: state_type] :
      ( v119048(VarCurr)
    <=> ( v119049(VarCurr)
        & v119059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13646,axiom,
    ! [VarCurr: state_type] :
      ( v119059(VarCurr)
    <=> ( v119060(VarCurr)
        & v119063(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5134,axiom,
    ! [VarCurr: state_type] :
      ( v119063(VarCurr)
    <=> ( v118750(VarCurr,2)
        | v119052(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13645,axiom,
    ! [VarCurr: state_type] :
      ( v119060(VarCurr)
    <=> ( v119061(VarCurr)
        | v119062(VarCurr) ) ) ).

tff(writeUnaryOperator_7449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119062(VarCurr)
    <=> v119052(VarCurr,2) ) ).

tff(writeUnaryOperator_7448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119061(VarCurr)
    <=> v118750(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13644,axiom,
    ! [VarCurr: state_type] :
      ( v119049(VarCurr)
    <=> ( v119050(VarCurr)
        | v119058(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5133,axiom,
    ! [VarCurr: state_type] :
      ( v119058(VarCurr)
    <=> ( v118750(VarCurr,1)
        & v119052(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13643,axiom,
    ! [VarCurr: state_type] :
      ( v119050(VarCurr)
    <=> ( v119051(VarCurr)
        & v119053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13642,axiom,
    ! [VarCurr: state_type] :
      ( v119053(VarCurr)
    <=> ( v119054(VarCurr)
        & v119057(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5132,axiom,
    ! [VarCurr: state_type] :
      ( v119057(VarCurr)
    <=> ( v118750(VarCurr,1)
        | v119052(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13641,axiom,
    ! [VarCurr: state_type] :
      ( v119054(VarCurr)
    <=> ( v119055(VarCurr)
        | v119056(VarCurr) ) ) ).

tff(writeUnaryOperator_7447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119056(VarCurr)
    <=> v119052(VarCurr,1) ) ).

tff(writeUnaryOperator_7446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v119055(VarCurr)
    <=> v118750(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13640,axiom,
    ! [VarCurr: state_type] :
      ( v119051(VarCurr)
    <=> ( v118750(VarCurr,0)
        & v119052(VarCurr,0) ) ) ).

tff(addAssignment_69284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v119052(VarCurr,B)
      <=> v118772(VarCurr,B) ) ) ).

tff(addAssignment_69283,axiom,
    ! [VarCurr: state_type] :
      ( ( v119052(VarCurr,5)
      <=> $false )
      & ( v119052(VarCurr,4)
      <=> $false )
      & ( v119052(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_69282,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,5)
    <=> v119018(VarCurr,5) ) ).

tff(addAssignment_69281,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,4)
    <=> v119018(VarCurr,4) ) ).

tff(addAssignment_69280,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,3)
    <=> v119018(VarCurr,3) ) ).

tff(addAssignment_69279,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,2)
    <=> v119018(VarCurr,2) ) ).

tff(addAssignment_69278,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,1)
    <=> v119018(VarCurr,1) ) ).

tff(addAssignment_69277,axiom,
    ! [VarCurr: state_type] :
      ( v118981(VarCurr,0)
    <=> v119018(VarCurr,0) ) ).

tff(addAssignment_69276,axiom,
    ! [VarCurr: state_type] :
      ( v119018(VarCurr,0)
    <=> v119019(VarCurr) ) ).

tff(addAssignment_69275,axiom,
    ! [VarCurr: state_type] :
      ( ( v119018(VarCurr,5)
      <=> $false )
      & ( v119018(VarCurr,4)
      <=> $false )
      & ( v119018(VarCurr,3)
      <=> $false )
      & ( v119018(VarCurr,2)
      <=> $false )
      & ( v119018(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13639,axiom,
    ! [VarCurr: state_type] :
      ( v119019(VarCurr)
    <=> ( v119020(VarCurr)
        | v119017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13638,axiom,
    ! [VarCurr: state_type] :
      ( v119020(VarCurr)
    <=> ( v119021(VarCurr)
        | v119015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13637,axiom,
    ! [VarCurr: state_type] :
      ( v119021(VarCurr)
    <=> ( v119022(VarCurr)
        | v119013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13636,axiom,
    ! [VarCurr: state_type] :
      ( v119022(VarCurr)
    <=> ( v119023(VarCurr)
        | v119003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13635,axiom,
    ! [VarCurr: state_type] :
      ( v119023(VarCurr)
    <=> ( v118983(VarCurr)
        | v118993(VarCurr) ) ) ).

tff(addAssignment_69274,axiom,
    ! [VarCurr: state_type] :
      ( v119017(VarCurr)
    <=> v113911(VarCurr,6) ) ).

tff(addAssignment_69273,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,6)
    <=> v113913(VarCurr,6) ) ).

tff(addAssignment_69272,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,6)
    <=> v113915(VarCurr,6) ) ).

tff(addAssignment_69271,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,6)
    <=> v113935(VarCurr,6) ) ).

tff(addAssignment_69270,axiom,
    ! [VarCurr: state_type] :
      ( v119015(VarCurr)
    <=> v113107(VarCurr,6) ) ).

tff(addAssignment_69269,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,6)
    <=> v113143(VarCurr,6) ) ).

tff(addAssignment_69268,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,6)
    <=> v113110(VarCurr,6) ) ).

tff(addAssignment_69267,axiom,
    ! [VarCurr: state_type] :
      ( v119013(VarCurr)
    <=> v113100(VarCurr,6) ) ).

tff(addAssignment_69266,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,6)
    <=> v113101(VarCurr,6) ) ).

tff(addAssignment_69265,axiom,
    ! [VarCurr: state_type] :
      ( v119003(VarCurr)
    <=> v113810(VarCurr,6) ) ).

tff(addAssignment_69264,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,6)
    <=> v113812(VarCurr,6) ) ).

tff(addAssignment_69263,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,6)
    <=> v113814(VarCurr,6) ) ).

tff(addAssignment_69262,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,6)
    <=> v113816(VarCurr,6) ) ).

tff(addAssignment_69261,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,6)
    <=> v113818(VarCurr,6) ) ).

tff(addAssignment_69260,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,6)
    <=> v119005(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119006(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v119005(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1546,axiom,
    ! [VarNext: state_type] :
      ( v119006(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v119005(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119006(VarNext)
      <=> v119007(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v119007(VarNext)
      <=> ( v119009(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v119009(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_69259,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,6)
    <=> v113830(VarCurr,6) ) ).

tff(addAssignment_69258,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,6)
    <=> v113832(VarCurr,6) ) ).

tff(addAssignment_69257,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,6)
    <=> v113834(VarCurr,6) ) ).

tff(addAssignment_69256,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,6)
    <=> v113873(VarCurr,6) ) ).

tff(addAssignment_69255,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,6)
    <=> v113856(VarCurr,6) ) ).

tff(addAssignment_69254,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,6)
    <=> v113837(VarCurr,6) ) ).

tff(addAssignment_69253,axiom,
    ! [VarCurr: state_type] :
      ( v118993(VarCurr)
    <=> v113020(VarCurr,6) ) ).

tff(addAssignment_69252,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,6)
    <=> v113022(VarCurr,6) ) ).

tff(addAssignment_69251,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,6)
    <=> v113024(VarCurr,6) ) ).

tff(addAssignment_69250,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,6)
    <=> v113026(VarCurr,6) ) ).

tff(addAssignment_69249,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,6)
    <=> v113028(VarCurr,6) ) ).

tff(addAssignment_69248,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,6)
    <=> v118995(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118996(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v118995(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1545,axiom,
    ! [VarNext: state_type] :
      ( v118996(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v118995(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118996(VarNext)
      <=> v118997(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118997(VarNext)
      <=> ( v118999(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118999(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_69247,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,6)
    <=> v113040(VarCurr,6) ) ).

tff(addAssignment_69246,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,6)
    <=> v113042(VarCurr,6) ) ).

tff(addAssignment_69245,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,6)
    <=> v113044(VarCurr,6) ) ).

tff(addAssignment_69244,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,6)
    <=> v113045(VarCurr,6) ) ).

tff(addAssignment_69243,axiom,
    ! [VarCurr: state_type] :
      ( v118983(VarCurr)
    <=> v112940(VarCurr,6) ) ).

tff(addAssignment_69242,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,6)
    <=> v112942(VarCurr,6) ) ).

tff(addAssignment_69241,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,6)
    <=> v112944(VarCurr,6) ) ).

tff(addAssignment_69240,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,6)
    <=> v112946(VarCurr,6) ) ).

tff(addAssignment_69239,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,6)
    <=> v112948(VarCurr,6) ) ).

tff(addAssignment_69238,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,6)
    <=> v118985(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118986(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v118985(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1544,axiom,
    ! [VarNext: state_type] :
      ( v118986(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v118985(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118986(VarNext)
      <=> v118987(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118987(VarNext)
      <=> ( v118989(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118989(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_69237,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,6)
    <=> v112960(VarCurr,6) ) ).

tff(addAssignment_69236,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,6)
    <=> v112962(VarCurr,6) ) ).

tff(addAssignment_69235,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,6)
    <=> v112964(VarCurr,6) ) ).

tff(addAssignment_69234,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,6)
    <=> v112965(VarCurr,6) ) ).

tff(addAssignment_69233,axiom,
    ! [VarCurr: state_type] :
      ( v118772(VarCurr,2)
    <=> v118787(VarCurr,2) ) ).

tff(addAssignment_69232,axiom,
    ! [VarCurr: state_type] :
      ( v118772(VarCurr,1)
    <=> v118787(VarCurr,1) ) ).

tff(addAssignment_69231,axiom,
    ! [VarCurr: state_type] :
      ( v118772(VarCurr,0)
    <=> v118787(VarCurr,0) ) ).

tff(addAssignment_69230,axiom,
    ! [VarCurr: state_type] :
      ( v118787(VarCurr,0)
    <=> v118975(VarCurr) ) ).

tff(addAssignment_69229,axiom,
    ! [VarCurr: state_type] :
      ( v118787(VarCurr,1)
    <=> v118970(VarCurr) ) ).

tff(addAssignment_69228,axiom,
    ! [VarCurr: state_type] :
      ( v118787(VarCurr,2)
    <=> v118789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13628,axiom,
    ! [VarCurr: state_type] :
      ( v118975(VarCurr)
    <=> ( v118976(VarCurr)
        & v118979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13627,axiom,
    ! [VarCurr: state_type] :
      ( v118979(VarCurr)
    <=> ( v118795(VarCurr,0)
        | v118956(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13626,axiom,
    ! [VarCurr: state_type] :
      ( v118976(VarCurr)
    <=> ( v118977(VarCurr)
        | v118978(VarCurr) ) ) ).

tff(writeUnaryOperator_7442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118978(VarCurr)
    <=> v118956(VarCurr,0) ) ).

tff(writeUnaryOperator_7441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118977(VarCurr)
    <=> v118795(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13625,axiom,
    ! [VarCurr: state_type] :
      ( v118970(VarCurr)
    <=> ( v118971(VarCurr)
        & v118974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13624,axiom,
    ! [VarCurr: state_type] :
      ( v118974(VarCurr)
    <=> ( v118794(VarCurr)
        | v118957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13623,axiom,
    ! [VarCurr: state_type] :
      ( v118971(VarCurr)
    <=> ( v118972(VarCurr)
        | v118973(VarCurr) ) ) ).

tff(writeUnaryOperator_7440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118973(VarCurr)
    <=> v118957(VarCurr) ) ).

tff(writeUnaryOperator_7439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118972(VarCurr)
    <=> v118794(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13622,axiom,
    ! [VarCurr: state_type] :
      ( v118789(VarCurr)
    <=> ( v118790(VarCurr)
        & v118969(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13621,axiom,
    ! [VarCurr: state_type] :
      ( v118969(VarCurr)
    <=> ( v118792(VarCurr)
        | v118964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13620,axiom,
    ! [VarCurr: state_type] :
      ( v118790(VarCurr)
    <=> ( v118791(VarCurr)
        | v118963(VarCurr) ) ) ).

tff(writeUnaryOperator_7438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118963(VarCurr)
    <=> v118964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13619,axiom,
    ! [VarCurr: state_type] :
      ( v118964(VarCurr)
    <=> ( v118965(VarCurr)
        & v118968(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5131,axiom,
    ! [VarCurr: state_type] :
      ( v118968(VarCurr)
    <=> ( v118795(VarCurr,2)
        | v118956(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13618,axiom,
    ! [VarCurr: state_type] :
      ( v118965(VarCurr)
    <=> ( v118966(VarCurr)
        | v118967(VarCurr) ) ) ).

tff(writeUnaryOperator_7437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118967(VarCurr)
    <=> v118956(VarCurr,2) ) ).

tff(writeUnaryOperator_7436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118966(VarCurr)
    <=> v118795(VarCurr,2) ) ).

tff(writeUnaryOperator_7435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118791(VarCurr)
    <=> v118792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13617,axiom,
    ! [VarCurr: state_type] :
      ( v118792(VarCurr)
    <=> ( v118793(VarCurr)
        | v118962(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5130,axiom,
    ! [VarCurr: state_type] :
      ( v118962(VarCurr)
    <=> ( v118795(VarCurr,1)
        & v118956(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13616,axiom,
    ! [VarCurr: state_type] :
      ( v118793(VarCurr)
    <=> ( v118794(VarCurr)
        & v118957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13615,axiom,
    ! [VarCurr: state_type] :
      ( v118957(VarCurr)
    <=> ( v118958(VarCurr)
        & v118961(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5129,axiom,
    ! [VarCurr: state_type] :
      ( v118961(VarCurr)
    <=> ( v118795(VarCurr,1)
        | v118956(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13614,axiom,
    ! [VarCurr: state_type] :
      ( v118958(VarCurr)
    <=> ( v118959(VarCurr)
        | v118960(VarCurr) ) ) ).

tff(writeUnaryOperator_7434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118960(VarCurr)
    <=> v118956(VarCurr,1) ) ).

tff(writeUnaryOperator_7433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118959(VarCurr)
    <=> v118795(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13613,axiom,
    ! [VarCurr: state_type] :
      ( v118794(VarCurr)
    <=> ( v118795(VarCurr,0)
        & v118956(VarCurr,0) ) ) ).

tff(addAssignment_69227,axiom,
    ! [VarCurr: state_type] :
      ( v118956(VarCurr,0)
    <=> v118786(VarCurr) ) ).

tff(addAssignment_69226,axiom,
    ! [VarCurr: state_type] :
      ( ( v118956(VarCurr,2)
      <=> $false )
      & ( v118956(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69225,axiom,
    ! [VarCurr: state_type] :
      ( v118795(VarCurr,0)
    <=> v118951(VarCurr) ) ).

tff(addAssignment_69224,axiom,
    ! [VarCurr: state_type] :
      ( v118795(VarCurr,1)
    <=> v118946(VarCurr) ) ).

tff(addAssignment_69223,axiom,
    ! [VarCurr: state_type] :
      ( v118795(VarCurr,2)
    <=> v118797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13612,axiom,
    ! [VarCurr: state_type] :
      ( v118951(VarCurr)
    <=> ( v118952(VarCurr)
        & v118955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13611,axiom,
    ! [VarCurr: state_type] :
      ( v118955(VarCurr)
    <=> ( v118803(VarCurr,0)
        | v118932(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13610,axiom,
    ! [VarCurr: state_type] :
      ( v118952(VarCurr)
    <=> ( v118953(VarCurr)
        | v118954(VarCurr) ) ) ).

tff(writeUnaryOperator_7432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118954(VarCurr)
    <=> v118932(VarCurr,0) ) ).

tff(writeUnaryOperator_7431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118953(VarCurr)
    <=> v118803(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13609,axiom,
    ! [VarCurr: state_type] :
      ( v118946(VarCurr)
    <=> ( v118947(VarCurr)
        & v118950(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13608,axiom,
    ! [VarCurr: state_type] :
      ( v118950(VarCurr)
    <=> ( v118802(VarCurr)
        | v118933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13607,axiom,
    ! [VarCurr: state_type] :
      ( v118947(VarCurr)
    <=> ( v118948(VarCurr)
        | v118949(VarCurr) ) ) ).

tff(writeUnaryOperator_7430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118949(VarCurr)
    <=> v118933(VarCurr) ) ).

tff(writeUnaryOperator_7429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118948(VarCurr)
    <=> v118802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13606,axiom,
    ! [VarCurr: state_type] :
      ( v118797(VarCurr)
    <=> ( v118798(VarCurr)
        & v118945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13605,axiom,
    ! [VarCurr: state_type] :
      ( v118945(VarCurr)
    <=> ( v118800(VarCurr)
        | v118940(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13604,axiom,
    ! [VarCurr: state_type] :
      ( v118798(VarCurr)
    <=> ( v118799(VarCurr)
        | v118939(VarCurr) ) ) ).

tff(writeUnaryOperator_7428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118939(VarCurr)
    <=> v118940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13603,axiom,
    ! [VarCurr: state_type] :
      ( v118940(VarCurr)
    <=> ( v118941(VarCurr)
        & v118944(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5128,axiom,
    ! [VarCurr: state_type] :
      ( v118944(VarCurr)
    <=> ( v118803(VarCurr,2)
        | v118932(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13602,axiom,
    ! [VarCurr: state_type] :
      ( v118941(VarCurr)
    <=> ( v118942(VarCurr)
        | v118943(VarCurr) ) ) ).

tff(writeUnaryOperator_7427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118943(VarCurr)
    <=> v118932(VarCurr,2) ) ).

tff(writeUnaryOperator_7426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118942(VarCurr)
    <=> v118803(VarCurr,2) ) ).

tff(writeUnaryOperator_7425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118799(VarCurr)
    <=> v118800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13601,axiom,
    ! [VarCurr: state_type] :
      ( v118800(VarCurr)
    <=> ( v118801(VarCurr)
        | v118938(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5127,axiom,
    ! [VarCurr: state_type] :
      ( v118938(VarCurr)
    <=> ( v118803(VarCurr,1)
        & v118932(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13600,axiom,
    ! [VarCurr: state_type] :
      ( v118801(VarCurr)
    <=> ( v118802(VarCurr)
        & v118933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13599,axiom,
    ! [VarCurr: state_type] :
      ( v118933(VarCurr)
    <=> ( v118934(VarCurr)
        & v118937(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5126,axiom,
    ! [VarCurr: state_type] :
      ( v118937(VarCurr)
    <=> ( v118803(VarCurr,1)
        | v118932(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13598,axiom,
    ! [VarCurr: state_type] :
      ( v118934(VarCurr)
    <=> ( v118935(VarCurr)
        | v118936(VarCurr) ) ) ).

tff(writeUnaryOperator_7424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118936(VarCurr)
    <=> v118932(VarCurr,1) ) ).

tff(writeUnaryOperator_7423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118935(VarCurr)
    <=> v118803(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13597,axiom,
    ! [VarCurr: state_type] :
      ( v118802(VarCurr)
    <=> ( v118803(VarCurr,0)
        & v118932(VarCurr,0) ) ) ).

tff(addAssignment_69222,axiom,
    ! [VarCurr: state_type] :
      ( v118932(VarCurr,0)
    <=> v118784(VarCurr) ) ).

tff(addAssignment_69221,axiom,
    ! [VarCurr: state_type] :
      ( ( v118932(VarCurr,2)
      <=> $false )
      & ( v118932(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69220,axiom,
    ! [VarCurr: state_type] :
      ( v118803(VarCurr,0)
    <=> v118927(VarCurr) ) ).

tff(addAssignment_69219,axiom,
    ! [VarCurr: state_type] :
      ( v118803(VarCurr,1)
    <=> v118922(VarCurr) ) ).

tff(addAssignment_69218,axiom,
    ! [VarCurr: state_type] :
      ( v118803(VarCurr,2)
    <=> v118805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13596,axiom,
    ! [VarCurr: state_type] :
      ( v118927(VarCurr)
    <=> ( v118928(VarCurr)
        & v118931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13595,axiom,
    ! [VarCurr: state_type] :
      ( v118931(VarCurr)
    <=> ( v118811(VarCurr,0)
        | v118908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13594,axiom,
    ! [VarCurr: state_type] :
      ( v118928(VarCurr)
    <=> ( v118929(VarCurr)
        | v118930(VarCurr) ) ) ).

tff(writeUnaryOperator_7422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118930(VarCurr)
    <=> v118908(VarCurr,0) ) ).

tff(writeUnaryOperator_7421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118929(VarCurr)
    <=> v118811(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13593,axiom,
    ! [VarCurr: state_type] :
      ( v118922(VarCurr)
    <=> ( v118923(VarCurr)
        & v118926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13592,axiom,
    ! [VarCurr: state_type] :
      ( v118926(VarCurr)
    <=> ( v118810(VarCurr)
        | v118909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13591,axiom,
    ! [VarCurr: state_type] :
      ( v118923(VarCurr)
    <=> ( v118924(VarCurr)
        | v118925(VarCurr) ) ) ).

tff(writeUnaryOperator_7420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118925(VarCurr)
    <=> v118909(VarCurr) ) ).

tff(writeUnaryOperator_7419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118924(VarCurr)
    <=> v118810(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13590,axiom,
    ! [VarCurr: state_type] :
      ( v118805(VarCurr)
    <=> ( v118806(VarCurr)
        & v118921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13589,axiom,
    ! [VarCurr: state_type] :
      ( v118921(VarCurr)
    <=> ( v118808(VarCurr)
        | v118916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13588,axiom,
    ! [VarCurr: state_type] :
      ( v118806(VarCurr)
    <=> ( v118807(VarCurr)
        | v118915(VarCurr) ) ) ).

tff(writeUnaryOperator_7418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118915(VarCurr)
    <=> v118916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13587,axiom,
    ! [VarCurr: state_type] :
      ( v118916(VarCurr)
    <=> ( v118917(VarCurr)
        & v118920(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5125,axiom,
    ! [VarCurr: state_type] :
      ( v118920(VarCurr)
    <=> ( v118811(VarCurr,2)
        | v118908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13586,axiom,
    ! [VarCurr: state_type] :
      ( v118917(VarCurr)
    <=> ( v118918(VarCurr)
        | v118919(VarCurr) ) ) ).

tff(writeUnaryOperator_7417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118919(VarCurr)
    <=> v118908(VarCurr,2) ) ).

tff(writeUnaryOperator_7416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118918(VarCurr)
    <=> v118811(VarCurr,2) ) ).

tff(writeUnaryOperator_7415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118807(VarCurr)
    <=> v118808(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13585,axiom,
    ! [VarCurr: state_type] :
      ( v118808(VarCurr)
    <=> ( v118809(VarCurr)
        | v118914(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5124,axiom,
    ! [VarCurr: state_type] :
      ( v118914(VarCurr)
    <=> ( v118811(VarCurr,1)
        & v118908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13584,axiom,
    ! [VarCurr: state_type] :
      ( v118809(VarCurr)
    <=> ( v118810(VarCurr)
        & v118909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13583,axiom,
    ! [VarCurr: state_type] :
      ( v118909(VarCurr)
    <=> ( v118910(VarCurr)
        & v118913(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5123,axiom,
    ! [VarCurr: state_type] :
      ( v118913(VarCurr)
    <=> ( v118811(VarCurr,1)
        | v118908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13582,axiom,
    ! [VarCurr: state_type] :
      ( v118910(VarCurr)
    <=> ( v118911(VarCurr)
        | v118912(VarCurr) ) ) ).

tff(writeUnaryOperator_7414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118912(VarCurr)
    <=> v118908(VarCurr,1) ) ).

tff(writeUnaryOperator_7413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118911(VarCurr)
    <=> v118811(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13581,axiom,
    ! [VarCurr: state_type] :
      ( v118810(VarCurr)
    <=> ( v118811(VarCurr,0)
        & v118908(VarCurr,0) ) ) ).

tff(addAssignment_69217,axiom,
    ! [VarCurr: state_type] :
      ( v118908(VarCurr,0)
    <=> v118782(VarCurr) ) ).

tff(addAssignment_69216,axiom,
    ! [VarCurr: state_type] :
      ( ( v118908(VarCurr,2)
      <=> $false )
      & ( v118908(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69215,axiom,
    ! [VarCurr: state_type] :
      ( v118811(VarCurr,0)
    <=> v118903(VarCurr) ) ).

tff(addAssignment_69214,axiom,
    ! [VarCurr: state_type] :
      ( v118811(VarCurr,1)
    <=> v118898(VarCurr) ) ).

tff(addAssignment_69213,axiom,
    ! [VarCurr: state_type] :
      ( v118811(VarCurr,2)
    <=> v118813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13580,axiom,
    ! [VarCurr: state_type] :
      ( v118903(VarCurr)
    <=> ( v118904(VarCurr)
        & v118907(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13579,axiom,
    ! [VarCurr: state_type] :
      ( v118907(VarCurr)
    <=> ( v118819(VarCurr,0)
        | v118884(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13578,axiom,
    ! [VarCurr: state_type] :
      ( v118904(VarCurr)
    <=> ( v118905(VarCurr)
        | v118906(VarCurr) ) ) ).

tff(writeUnaryOperator_7412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118906(VarCurr)
    <=> v118884(VarCurr,0) ) ).

tff(writeUnaryOperator_7411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118905(VarCurr)
    <=> v118819(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13577,axiom,
    ! [VarCurr: state_type] :
      ( v118898(VarCurr)
    <=> ( v118899(VarCurr)
        & v118902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13576,axiom,
    ! [VarCurr: state_type] :
      ( v118902(VarCurr)
    <=> ( v118818(VarCurr)
        | v118885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13575,axiom,
    ! [VarCurr: state_type] :
      ( v118899(VarCurr)
    <=> ( v118900(VarCurr)
        | v118901(VarCurr) ) ) ).

tff(writeUnaryOperator_7410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118901(VarCurr)
    <=> v118885(VarCurr) ) ).

tff(writeUnaryOperator_7409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118900(VarCurr)
    <=> v118818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13574,axiom,
    ! [VarCurr: state_type] :
      ( v118813(VarCurr)
    <=> ( v118814(VarCurr)
        & v118897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13573,axiom,
    ! [VarCurr: state_type] :
      ( v118897(VarCurr)
    <=> ( v118816(VarCurr)
        | v118892(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13572,axiom,
    ! [VarCurr: state_type] :
      ( v118814(VarCurr)
    <=> ( v118815(VarCurr)
        | v118891(VarCurr) ) ) ).

tff(writeUnaryOperator_7408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118891(VarCurr)
    <=> v118892(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13571,axiom,
    ! [VarCurr: state_type] :
      ( v118892(VarCurr)
    <=> ( v118893(VarCurr)
        & v118896(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5122,axiom,
    ! [VarCurr: state_type] :
      ( v118896(VarCurr)
    <=> ( v118819(VarCurr,2)
        | v118884(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13570,axiom,
    ! [VarCurr: state_type] :
      ( v118893(VarCurr)
    <=> ( v118894(VarCurr)
        | v118895(VarCurr) ) ) ).

tff(writeUnaryOperator_7407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118895(VarCurr)
    <=> v118884(VarCurr,2) ) ).

tff(writeUnaryOperator_7406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118894(VarCurr)
    <=> v118819(VarCurr,2) ) ).

tff(writeUnaryOperator_7405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118815(VarCurr)
    <=> v118816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13569,axiom,
    ! [VarCurr: state_type] :
      ( v118816(VarCurr)
    <=> ( v118817(VarCurr)
        | v118890(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5121,axiom,
    ! [VarCurr: state_type] :
      ( v118890(VarCurr)
    <=> ( v118819(VarCurr,1)
        & v118884(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13568,axiom,
    ! [VarCurr: state_type] :
      ( v118817(VarCurr)
    <=> ( v118818(VarCurr)
        & v118885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13567,axiom,
    ! [VarCurr: state_type] :
      ( v118885(VarCurr)
    <=> ( v118886(VarCurr)
        & v118889(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5120,axiom,
    ! [VarCurr: state_type] :
      ( v118889(VarCurr)
    <=> ( v118819(VarCurr,1)
        | v118884(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13566,axiom,
    ! [VarCurr: state_type] :
      ( v118886(VarCurr)
    <=> ( v118887(VarCurr)
        | v118888(VarCurr) ) ) ).

tff(writeUnaryOperator_7404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118888(VarCurr)
    <=> v118884(VarCurr,1) ) ).

tff(writeUnaryOperator_7403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118887(VarCurr)
    <=> v118819(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13565,axiom,
    ! [VarCurr: state_type] :
      ( v118818(VarCurr)
    <=> ( v118819(VarCurr,0)
        & v118884(VarCurr,0) ) ) ).

tff(addAssignment_69212,axiom,
    ! [VarCurr: state_type] :
      ( v118884(VarCurr,0)
    <=> v118780(VarCurr) ) ).

tff(addAssignment_69211,axiom,
    ! [VarCurr: state_type] :
      ( ( v118884(VarCurr,2)
      <=> $false )
      & ( v118884(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69210,axiom,
    ! [VarCurr: state_type] :
      ( v118819(VarCurr,0)
    <=> v118879(VarCurr) ) ).

tff(addAssignment_69209,axiom,
    ! [VarCurr: state_type] :
      ( v118819(VarCurr,1)
    <=> v118874(VarCurr) ) ).

tff(addAssignment_69208,axiom,
    ! [VarCurr: state_type] :
      ( v118819(VarCurr,2)
    <=> v118821(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13564,axiom,
    ! [VarCurr: state_type] :
      ( v118879(VarCurr)
    <=> ( v118880(VarCurr)
        & v118883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13563,axiom,
    ! [VarCurr: state_type] :
      ( v118883(VarCurr)
    <=> ( v118827(VarCurr,0)
        | v118860(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13562,axiom,
    ! [VarCurr: state_type] :
      ( v118880(VarCurr)
    <=> ( v118881(VarCurr)
        | v118882(VarCurr) ) ) ).

tff(writeUnaryOperator_7402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118882(VarCurr)
    <=> v118860(VarCurr,0) ) ).

tff(writeUnaryOperator_7401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118881(VarCurr)
    <=> v118827(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13561,axiom,
    ! [VarCurr: state_type] :
      ( v118874(VarCurr)
    <=> ( v118875(VarCurr)
        & v118878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13560,axiom,
    ! [VarCurr: state_type] :
      ( v118878(VarCurr)
    <=> ( v118826(VarCurr)
        | v118861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13559,axiom,
    ! [VarCurr: state_type] :
      ( v118875(VarCurr)
    <=> ( v118876(VarCurr)
        | v118877(VarCurr) ) ) ).

tff(writeUnaryOperator_7400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118877(VarCurr)
    <=> v118861(VarCurr) ) ).

tff(writeUnaryOperator_7399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118876(VarCurr)
    <=> v118826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13558,axiom,
    ! [VarCurr: state_type] :
      ( v118821(VarCurr)
    <=> ( v118822(VarCurr)
        & v118873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13557,axiom,
    ! [VarCurr: state_type] :
      ( v118873(VarCurr)
    <=> ( v118824(VarCurr)
        | v118868(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13556,axiom,
    ! [VarCurr: state_type] :
      ( v118822(VarCurr)
    <=> ( v118823(VarCurr)
        | v118867(VarCurr) ) ) ).

tff(writeUnaryOperator_7398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118867(VarCurr)
    <=> v118868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13555,axiom,
    ! [VarCurr: state_type] :
      ( v118868(VarCurr)
    <=> ( v118869(VarCurr)
        & v118872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5119,axiom,
    ! [VarCurr: state_type] :
      ( v118872(VarCurr)
    <=> ( v118827(VarCurr,2)
        | v118860(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13554,axiom,
    ! [VarCurr: state_type] :
      ( v118869(VarCurr)
    <=> ( v118870(VarCurr)
        | v118871(VarCurr) ) ) ).

tff(writeUnaryOperator_7397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118871(VarCurr)
    <=> v118860(VarCurr,2) ) ).

tff(writeUnaryOperator_7396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118870(VarCurr)
    <=> v118827(VarCurr,2) ) ).

tff(writeUnaryOperator_7395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118823(VarCurr)
    <=> v118824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13553,axiom,
    ! [VarCurr: state_type] :
      ( v118824(VarCurr)
    <=> ( v118825(VarCurr)
        | v118866(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5118,axiom,
    ! [VarCurr: state_type] :
      ( v118866(VarCurr)
    <=> ( v118827(VarCurr,1)
        & v118860(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13552,axiom,
    ! [VarCurr: state_type] :
      ( v118825(VarCurr)
    <=> ( v118826(VarCurr)
        & v118861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13551,axiom,
    ! [VarCurr: state_type] :
      ( v118861(VarCurr)
    <=> ( v118862(VarCurr)
        & v118865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5117,axiom,
    ! [VarCurr: state_type] :
      ( v118865(VarCurr)
    <=> ( v118827(VarCurr,1)
        | v118860(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13550,axiom,
    ! [VarCurr: state_type] :
      ( v118862(VarCurr)
    <=> ( v118863(VarCurr)
        | v118864(VarCurr) ) ) ).

tff(writeUnaryOperator_7394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118864(VarCurr)
    <=> v118860(VarCurr,1) ) ).

tff(writeUnaryOperator_7393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118863(VarCurr)
    <=> v118827(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13549,axiom,
    ! [VarCurr: state_type] :
      ( v118826(VarCurr)
    <=> ( v118827(VarCurr,0)
        & v118860(VarCurr,0) ) ) ).

tff(addAssignment_69207,axiom,
    ! [VarCurr: state_type] :
      ( v118860(VarCurr,0)
    <=> v118778(VarCurr) ) ).

tff(addAssignment_69206,axiom,
    ! [VarCurr: state_type] :
      ( ( v118860(VarCurr,2)
      <=> $false )
      & ( v118860(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69205,axiom,
    ! [VarCurr: state_type] :
      ( v118827(VarCurr,0)
    <=> v118855(VarCurr) ) ).

tff(addAssignment_69204,axiom,
    ! [VarCurr: state_type] :
      ( v118827(VarCurr,1)
    <=> v118850(VarCurr) ) ).

tff(addAssignment_69203,axiom,
    ! [VarCurr: state_type] :
      ( v118827(VarCurr,2)
    <=> v118829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13548,axiom,
    ! [VarCurr: state_type] :
      ( v118855(VarCurr)
    <=> ( v118856(VarCurr)
        & v118859(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13547,axiom,
    ! [VarCurr: state_type] :
      ( v118859(VarCurr)
    <=> ( v118835(VarCurr,0)
        | v118836(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13546,axiom,
    ! [VarCurr: state_type] :
      ( v118856(VarCurr)
    <=> ( v118857(VarCurr)
        | v118858(VarCurr) ) ) ).

tff(writeUnaryOperator_7392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118858(VarCurr)
    <=> v118836(VarCurr,0) ) ).

tff(writeUnaryOperator_7391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118857(VarCurr)
    <=> v118835(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13545,axiom,
    ! [VarCurr: state_type] :
      ( v118850(VarCurr)
    <=> ( v118851(VarCurr)
        & v118854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13544,axiom,
    ! [VarCurr: state_type] :
      ( v118854(VarCurr)
    <=> ( v118834(VarCurr)
        | v118837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13543,axiom,
    ! [VarCurr: state_type] :
      ( v118851(VarCurr)
    <=> ( v118852(VarCurr)
        | v118853(VarCurr) ) ) ).

tff(writeUnaryOperator_7390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118853(VarCurr)
    <=> v118837(VarCurr) ) ).

tff(writeUnaryOperator_7389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118852(VarCurr)
    <=> v118834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13542,axiom,
    ! [VarCurr: state_type] :
      ( v118829(VarCurr)
    <=> ( v118830(VarCurr)
        & v118849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13541,axiom,
    ! [VarCurr: state_type] :
      ( v118849(VarCurr)
    <=> ( v118832(VarCurr)
        | v118844(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13540,axiom,
    ! [VarCurr: state_type] :
      ( v118830(VarCurr)
    <=> ( v118831(VarCurr)
        | v118843(VarCurr) ) ) ).

tff(writeUnaryOperator_7388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118843(VarCurr)
    <=> v118844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13539,axiom,
    ! [VarCurr: state_type] :
      ( v118844(VarCurr)
    <=> ( v118845(VarCurr)
        & v118848(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5116,axiom,
    ! [VarCurr: state_type] :
      ( v118848(VarCurr)
    <=> ( v118835(VarCurr,2)
        | v118836(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13538,axiom,
    ! [VarCurr: state_type] :
      ( v118845(VarCurr)
    <=> ( v118846(VarCurr)
        | v118847(VarCurr) ) ) ).

tff(writeUnaryOperator_7387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118847(VarCurr)
    <=> v118836(VarCurr,2) ) ).

tff(writeUnaryOperator_7386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118846(VarCurr)
    <=> v118835(VarCurr,2) ) ).

tff(writeUnaryOperator_7385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118831(VarCurr)
    <=> v118832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13537,axiom,
    ! [VarCurr: state_type] :
      ( v118832(VarCurr)
    <=> ( v118833(VarCurr)
        | v118842(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5115,axiom,
    ! [VarCurr: state_type] :
      ( v118842(VarCurr)
    <=> ( v118835(VarCurr,1)
        & v118836(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13536,axiom,
    ! [VarCurr: state_type] :
      ( v118833(VarCurr)
    <=> ( v118834(VarCurr)
        & v118837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13535,axiom,
    ! [VarCurr: state_type] :
      ( v118837(VarCurr)
    <=> ( v118838(VarCurr)
        & v118841(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5114,axiom,
    ! [VarCurr: state_type] :
      ( v118841(VarCurr)
    <=> ( v118835(VarCurr,1)
        | v118836(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13534,axiom,
    ! [VarCurr: state_type] :
      ( v118838(VarCurr)
    <=> ( v118839(VarCurr)
        | v118840(VarCurr) ) ) ).

tff(writeUnaryOperator_7384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118840(VarCurr)
    <=> v118836(VarCurr,1) ) ).

tff(writeUnaryOperator_7383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118839(VarCurr)
    <=> v118835(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13533,axiom,
    ! [VarCurr: state_type] :
      ( v118834(VarCurr)
    <=> ( v118835(VarCurr,0)
        & v118836(VarCurr,0) ) ) ).

tff(addAssignment_69202,axiom,
    ! [VarCurr: state_type] :
      ( v118836(VarCurr,0)
    <=> v118776(VarCurr) ) ).

tff(addAssignment_69201,axiom,
    ! [VarCurr: state_type] :
      ( ( v118836(VarCurr,2)
      <=> $false )
      & ( v118836(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69200,axiom,
    ! [VarCurr: state_type] :
      ( v118835(VarCurr,0)
    <=> v118774(VarCurr) ) ).

tff(addAssignment_69199,axiom,
    ! [VarCurr: state_type] :
      ( ( v118835(VarCurr,2)
      <=> $false )
      & ( v118835(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69198,axiom,
    ! [VarCurr: state_type] :
      ( v118786(VarCurr)
    <=> v114692(VarCurr,6) ) ).

tff(addAssignment_69197,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,6)
    <=> v114694(VarCurr,6) ) ).

tff(addAssignment_69196,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,6)
    <=> v114696(VarCurr,6) ) ).

tff(addAssignment_69195,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,6)
    <=> v114697(VarCurr,6) ) ).

tff(addAssignment_69194,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,6)
    <=> v113918(VarCurr,6) ) ).

tff(addAssignment_69193,axiom,
    ! [VarCurr: state_type] :
      ( v118784(VarCurr)
    <=> v114685(VarCurr,6) ) ).

tff(addAssignment_69192,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,6)
    <=> v114686(VarCurr,6) ) ).

tff(addAssignment_69191,axiom,
    ! [VarCurr: state_type] :
      ( v118782(VarCurr)
    <=> v114661(VarCurr,6) ) ).

tff(addAssignment_69190,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,6)
    <=> v114662(VarCurr,6) ) ).

tff(addAssignment_69189,axiom,
    ! [VarCurr: state_type] :
      ( v118780(VarCurr)
    <=> v114633(VarCurr,6) ) ).

tff(addAssignment_69188,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,6)
    <=> v114635(VarCurr,6) ) ).

tff(addAssignment_69187,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,6)
    <=> v114637(VarCurr,6) ) ).

tff(addAssignment_69186,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,6)
    <=> v114638(VarCurr,6) ) ).

tff(addAssignment_69185,axiom,
    ! [VarCurr: state_type] :
      ( v118778(VarCurr)
    <=> v114605(VarCurr,6) ) ).

tff(addAssignment_69184,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,6)
    <=> v114607(VarCurr,6) ) ).

tff(addAssignment_69183,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,6)
    <=> v114609(VarCurr,6) ) ).

tff(addAssignment_69182,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,6)
    <=> v114610(VarCurr,6) ) ).

tff(addAssignment_69181,axiom,
    ! [VarCurr: state_type] :
      ( v118776(VarCurr)
    <=> v114577(VarCurr,6) ) ).

tff(addAssignment_69180,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,6)
    <=> v114579(VarCurr,6) ) ).

tff(addAssignment_69179,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,6)
    <=> v114581(VarCurr,6) ) ).

tff(addAssignment_69178,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,6)
    <=> v114582(VarCurr,6) ) ).

tff(addAssignment_69177,axiom,
    ! [VarCurr: state_type] :
      ( v118774(VarCurr)
    <=> v114549(VarCurr,6) ) ).

tff(addAssignment_69176,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,6)
    <=> v114551(VarCurr,6) ) ).

tff(addAssignment_69175,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,6)
    <=> v114553(VarCurr,6) ) ).

tff(addAssignment_69174,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,6)
    <=> v114554(VarCurr,6) ) ).

tff(addAssignment_69173,axiom,
    ! [VarCurr: state_type] :
      ( v118760(VarCurr)
    <=> v118762(VarCurr) ) ).

tff(addAssignment_69172,axiom,
    ! [VarCurr: state_type] :
      ( v118762(VarCurr)
    <=> v118736(VarCurr) ) ).

tff(addAssignment_69171,axiom,
    ! [VarCurr: state_type] :
      ( v118756(VarCurr)
    <=> v118758(VarCurr) ) ).

tff(addAssignment_69170,axiom,
    ! [VarCurr: state_type] :
      ( v118758(VarCurr)
    <=> v118728(VarCurr) ) ).

tff(addAssignment_69169,axiom,
    ! [VarCurr: state_type] :
      ( v118732(VarCurr)
    <=> v118734(VarCurr) ) ).

tff(addAssignment_69168,axiom,
    ! [VarCurr: state_type] :
      ( v118734(VarCurr)
    <=> v118736(VarCurr) ) ).

tff(addAssignment_69167,axiom,
    ! [VarCurr: state_type] :
      ( v118736(VarCurr)
    <=> v118738(VarCurr) ) ).

tff(addAssignment_69166,axiom,
    ! [VarCurr: state_type] :
      ( v118738(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_69165,axiom,
    ! [VarCurr: state_type] :
      ( v118724(VarCurr)
    <=> v118726(VarCurr) ) ).

tff(addAssignment_69164,axiom,
    ! [VarCurr: state_type] :
      ( v118726(VarCurr)
    <=> v118728(VarCurr) ) ).

tff(addAssignment_69163,axiom,
    ! [VarCurr: state_type] :
      ( v118728(VarCurr)
    <=> v118730(VarCurr) ) ).

tff(addAssignment_69162,axiom,
    ! [VarCurr: state_type] :
      ( v118730(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13532,axiom,
    ! [VarCurr: state_type] :
      ( v117915(VarCurr)
    <=> ( v118714(VarCurr)
        & v118624(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5113,axiom,
    ! [VarCurr: state_type] :
      ( v118714(VarCurr)
    <=> ( v117917(VarCurr,1)
        & v118563(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1179,axiom,
    ! [VarCurr: state_type] :
      ( v118624(VarCurr)
    <=> ( ( v118626(VarCurr,4)
        <=> $false )
        & ( v118626(VarCurr,3)
        <=> $false )
        & ( v118626(VarCurr,2)
        <=> $false )
        & ( v118626(VarCurr,1)
        <=> $false )
        & ( v118626(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118626(VarCurr,B)
      <=> v118628(VarCurr,B) ) ) ).

tff(addAssignment_69160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118628(VarCurr,B)
      <=> v118630(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118696(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v118630(VarNext,B)
            <=> v118630(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1543,axiom,
    ! [VarNext: state_type] :
      ( v118696(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118630(VarNext,B)
          <=> v118706(VarNext,B) ) ) ) ).

tff(addAssignment_69159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118706(VarNext,B)
          <=> v118704(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118704(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1088,axiom,
    ! [VarCurr: state_type] :
      ( v118707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118704(VarCurr,B)
          <=> v118640(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13531,axiom,
    ! [VarCurr: state_type] :
      ( v118707(VarCurr)
    <=> ( v118708(VarCurr)
        & v118709(VarCurr) ) ) ).

tff(writeUnaryOperator_7382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118709(VarCurr)
    <=> v118636(VarCurr) ) ).

tff(writeUnaryOperator_7381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118708(VarCurr)
    <=> v118632(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118696(VarNext)
      <=> v118697(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118697(VarNext)
      <=> ( v118698(VarNext)
          & v118691(VarNext) ) ) ) ).

tff(writeUnaryOperator_7380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118698(VarNext)
      <=> v118700(VarNext) ) ) ).

tff(addAssignment_69158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118700(VarNext)
      <=> v118691(VarCurr) ) ) ).

tff(addAssignment_69157,axiom,
    ! [VarCurr: state_type] :
      ( v118691(VarCurr)
    <=> v118693(VarCurr) ) ).

tff(addAssignment_69156,axiom,
    ! [VarCurr: state_type] :
      ( v118693(VarCurr)
    <=> v118397(VarCurr) ) ).

tff(addAssignment_69155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118640(VarCurr,B)
      <=> v118642(VarCurr,B) ) ) ).

tff(addAssignment_69154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118642(VarCurr,B)
      <=> v118644(VarCurr,B) ) ) ).

tff(addAssignment_69153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118644(VarCurr,B)
      <=> v118646(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118648(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118646(VarCurr,B)
          <=> v118660(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1087,axiom,
    ! [VarCurr: state_type] :
      ( v118648(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118646(VarCurr,B)
          <=> v118653(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118655(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118660(VarCurr,B)
          <=> v118661(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1086,axiom,
    ! [VarCurr: state_type] :
      ( v118655(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118660(VarCurr,B)
          <=> v118658(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118661(VarCurr,B)
          <=> v118662(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1085,axiom,
    ! [VarCurr: state_type] :
      ( v118624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v118661(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69152,axiom,
    ! [VarCurr: state_type] :
      ( v118662(VarCurr,0)
    <=> v118688(VarCurr) ) ).

tff(addAssignment_69151,axiom,
    ! [VarCurr: state_type] :
      ( v118662(VarCurr,1)
    <=> v118686(VarCurr) ) ).

tff(addAssignment_69150,axiom,
    ! [VarCurr: state_type] :
      ( v118662(VarCurr,2)
    <=> v118682(VarCurr) ) ).

tff(addAssignment_69149,axiom,
    ! [VarCurr: state_type] :
      ( v118662(VarCurr,3)
    <=> v118678(VarCurr) ) ).

tff(addAssignment_69148,axiom,
    ! [VarCurr: state_type] :
      ( v118662(VarCurr,4)
    <=> v118664(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13528,axiom,
    ! [VarCurr: state_type] :
      ( v118686(VarCurr)
    <=> ( v118687(VarCurr)
        & v118689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13527,axiom,
    ! [VarCurr: state_type] :
      ( v118689(VarCurr)
    <=> ( v118626(VarCurr,0)
        | v118673(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5112,axiom,
    ! [VarCurr: state_type] :
      ( v118687(VarCurr)
    <=> ( v118688(VarCurr)
        | v118626(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118688(VarCurr)
    <=> v118626(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13526,axiom,
    ! [VarCurr: state_type] :
      ( v118682(VarCurr)
    <=> ( v118683(VarCurr)
        & v118685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13525,axiom,
    ! [VarCurr: state_type] :
      ( v118685(VarCurr)
    <=> ( v118671(VarCurr)
        | v118674(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5111,axiom,
    ! [VarCurr: state_type] :
      ( v118683(VarCurr)
    <=> ( v118684(VarCurr)
        | v118626(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118684(VarCurr)
    <=> v118671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13524,axiom,
    ! [VarCurr: state_type] :
      ( v118678(VarCurr)
    <=> ( v118679(VarCurr)
        & v118681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13523,axiom,
    ! [VarCurr: state_type] :
      ( v118681(VarCurr)
    <=> ( v118669(VarCurr)
        | v118675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5110,axiom,
    ! [VarCurr: state_type] :
      ( v118679(VarCurr)
    <=> ( v118680(VarCurr)
        | v118626(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118680(VarCurr)
    <=> v118669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13522,axiom,
    ! [VarCurr: state_type] :
      ( v118664(VarCurr)
    <=> ( v118665(VarCurr)
        & v118676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13521,axiom,
    ! [VarCurr: state_type] :
      ( v118676(VarCurr)
    <=> ( v118667(VarCurr)
        | v118677(VarCurr) ) ) ).

tff(writeUnaryOperator_7376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118677(VarCurr)
    <=> v118626(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5109,axiom,
    ! [VarCurr: state_type] :
      ( v118665(VarCurr)
    <=> ( v118666(VarCurr)
        | v118626(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118666(VarCurr)
    <=> v118667(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5108,axiom,
    ! [VarCurr: state_type] :
      ( v118667(VarCurr)
    <=> ( v118626(VarCurr,3)
        | v118668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13520,axiom,
    ! [VarCurr: state_type] :
      ( v118668(VarCurr)
    <=> ( v118669(VarCurr)
        & v118675(VarCurr) ) ) ).

tff(writeUnaryOperator_7374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118675(VarCurr)
    <=> v118626(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5107,axiom,
    ! [VarCurr: state_type] :
      ( v118669(VarCurr)
    <=> ( v118626(VarCurr,2)
        | v118670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13519,axiom,
    ! [VarCurr: state_type] :
      ( v118670(VarCurr)
    <=> ( v118671(VarCurr)
        & v118674(VarCurr) ) ) ).

tff(writeUnaryOperator_7373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118674(VarCurr)
    <=> v118626(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5106,axiom,
    ! [VarCurr: state_type] :
      ( v118671(VarCurr)
    <=> ( v118626(VarCurr,1)
        | v118672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13518,axiom,
    ! [VarCurr: state_type] :
      ( v118672(VarCurr)
    <=> ( v118626(VarCurr,0)
        & v118673(VarCurr) ) ) ).

tff(writeUnaryOperator_7372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118673(VarCurr)
    <=> v118626(VarCurr,1) ) ).

tff(addAssignment_69147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118658(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13517,axiom,
    ! [VarCurr: state_type] :
      ( v118655(VarCurr)
    <=> ( v118202(VarCurr)
        | v118216(VarCurr) ) ) ).

tff(addAssignment_69146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v118653(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13516,axiom,
    ! [VarCurr: state_type] :
      ( v118648(VarCurr)
    <=> ( v118650(VarCurr)
        | v118214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13515,axiom,
    ! [VarCurr: state_type] :
      ( v118650(VarCurr)
    <=> ( v118651(VarCurr)
        | v118212(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13514,axiom,
    ! [VarCurr: state_type] :
      ( v118651(VarCurr)
    <=> ( v118182(VarCurr)
        | v118192(VarCurr) ) ) ).

tff(addAssignment_69145,axiom,
    ! [VarCurr: state_type] :
      ( v118636(VarCurr)
    <=> v118638(VarCurr) ) ).

tff(addAssignment_69144,axiom,
    ! [VarCurr: state_type] :
      ( v118638(VarCurr)
    <=> v117935(VarCurr) ) ).

tff(addAssignment_69143,axiom,
    ! [VarCurr: state_type] :
      ( v118632(VarCurr)
    <=> v118634(VarCurr) ) ).

tff(addAssignment_69142,axiom,
    ! [VarCurr: state_type] :
      ( v118634(VarCurr)
    <=> v117927(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1178,axiom,
    ! [VarCurr: state_type] :
      ( v118563(VarCurr)
    <=> ( ( v118565(VarCurr,1)
        <=> $false )
        & ( v118565(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v118565(VarCurr,B)
      <=> v118567(VarCurr,B) ) ) ).

tff(addAssignment_69140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v118567(VarCurr,B)
      <=> v118569(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118606(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v118569(VarNext,B)
            <=> v118569(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1542,axiom,
    ! [VarNext: state_type] :
      ( v118606(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118569(VarNext,B)
          <=> v118616(VarNext,B) ) ) ) ).

tff(addAssignment_69139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118616(VarNext,B)
          <=> v118614(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118614(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1084,axiom,
    ! [VarCurr: state_type] :
      ( v118617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118614(VarCurr,B)
          <=> v118579(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13513,axiom,
    ! [VarCurr: state_type] :
      ( v118617(VarCurr)
    <=> ( v118618(VarCurr)
        & v118619(VarCurr) ) ) ).

tff(writeUnaryOperator_7371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118619(VarCurr)
    <=> v118575(VarCurr) ) ).

tff(writeUnaryOperator_7370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118618(VarCurr)
    <=> v118571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118606(VarNext)
      <=> v118607(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118607(VarNext)
      <=> ( v118608(VarNext)
          & v118601(VarNext) ) ) ) ).

tff(writeUnaryOperator_7369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118608(VarNext)
      <=> v118610(VarNext) ) ) ).

tff(addAssignment_69138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118610(VarNext)
      <=> v118601(VarCurr) ) ) ).

tff(addAssignment_69137,axiom,
    ! [VarCurr: state_type] :
      ( v118601(VarCurr)
    <=> v118603(VarCurr) ) ).

tff(addAssignment_69136,axiom,
    ! [VarCurr: state_type] :
      ( v118603(VarCurr)
    <=> v118397(VarCurr) ) ).

tff(addAssignment_69135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v118579(VarCurr,B)
      <=> v118581(VarCurr,B) ) ) ).

tff(addAssignment_69134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v118581(VarCurr,B)
      <=> v118583(VarCurr,B) ) ) ).

tff(addAssignment_69133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v118583(VarCurr,B)
      <=> v118585(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118585(VarCurr,B)
          <=> v118592(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1083,axiom,
    ! [VarCurr: state_type] :
      ( v118587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118585(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118592(VarCurr,B)
          <=> v118593(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1082,axiom,
    ! [VarCurr: state_type] :
      ( v118563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v118592(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_69132,axiom,
    ! [VarCurr: state_type] :
      ( v118593(VarCurr,0)
    <=> v118597(VarCurr) ) ).

tff(addAssignment_69131,axiom,
    ! [VarCurr: state_type] :
      ( v118593(VarCurr,1)
    <=> v118595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13510,axiom,
    ! [VarCurr: state_type] :
      ( v118595(VarCurr)
    <=> ( v118596(VarCurr)
        & v118598(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13509,axiom,
    ! [VarCurr: state_type] :
      ( v118598(VarCurr)
    <=> ( v118565(VarCurr,0)
        | v118599(VarCurr) ) ) ).

tff(writeUnaryOperator_7368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118599(VarCurr)
    <=> v118565(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5105,axiom,
    ! [VarCurr: state_type] :
      ( v118596(VarCurr)
    <=> ( v118597(VarCurr)
        | v118565(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118597(VarCurr)
    <=> v118565(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13508,axiom,
    ! [VarCurr: state_type] :
      ( v118587(VarCurr)
    <=> ( v118589(VarCurr)
        | v118590(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5104,axiom,
    ! [VarCurr: state_type] :
      ( v118590(VarCurr)
    <=> ( v117917(VarCurr,1)
        & v118430(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5103,axiom,
    ! [VarCurr: state_type] :
      ( v118589(VarCurr)
    <=> ( v117917(VarCurr,3)
        & v118488(VarCurr) ) ) ).

tff(addAssignment_69130,axiom,
    ! [VarCurr: state_type] :
      ( v118575(VarCurr)
    <=> v118577(VarCurr) ) ).

tff(addAssignment_69129,axiom,
    ! [VarCurr: state_type] :
      ( v118577(VarCurr)
    <=> v117935(VarCurr) ) ).

tff(addAssignment_69128,axiom,
    ! [VarCurr: state_type] :
      ( v118571(VarCurr)
    <=> v118573(VarCurr) ) ).

tff(addAssignment_69127,axiom,
    ! [VarCurr: state_type] :
      ( v118573(VarCurr)
    <=> v117927(VarCurr) ) ).

tff(addAssignment_69126,axiom,
    ! [VarCurr: state_type] :
      ( v117917(VarCurr,1)
    <=> v117919(VarCurr,1) ) ).

tff(addAssignment_69125,axiom,
    ! [VarCurr: state_type] :
      ( v117919(VarCurr,1)
    <=> v117921(VarCurr,1) ) ).

tff(addAssignment_69124,axiom,
    ! [VarNext: state_type] :
      ( v117921(VarNext,1)
    <=> v118555(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118556(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v118555(VarNext,B)
            <=> v117921(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1541,axiom,
    ! [VarNext: state_type] :
      ( v118556(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118555(VarNext,B)
          <=> v118481(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118556(VarNext)
      <=> v118557(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118557(VarNext)
      <=> ( v118559(VarNext)
          & v118466(VarNext) ) ) ) ).

tff(writeUnaryOperator_7366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118559(VarNext)
      <=> v118475(VarNext) ) ) ).

tff(addAssignment_69123,axiom,
    ! [VarCurr: state_type] :
      ( v117939(VarCurr,1)
    <=> v117941(VarCurr,1) ) ).

tff(addAssignment_69122,axiom,
    ! [VarCurr: state_type] :
      ( v117941(VarCurr,1)
    <=> v117943(VarCurr,1) ) ).

tff(addAssignment_69121,axiom,
    ! [VarCurr: state_type] :
      ( v117943(VarCurr,1)
    <=> v118464(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_47,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118546(VarCurr)
     => ( v117945(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_76,axiom,
    ! [VarCurr: state_type] :
      ( v118546(VarCurr)
     => ( v117945(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13505,axiom,
    ! [VarCurr: state_type] :
      ( v118546(VarCurr)
    <=> ( v118547(VarCurr)
        | v118548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13504,axiom,
    ! [VarCurr: state_type] :
      ( v118548(VarCurr)
    <=> ( v118549(VarCurr)
        & v118550(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13503,axiom,
    ! [VarCurr: state_type] :
      ( v118550(VarCurr)
    <=> ( v118551(VarCurr)
        & v118447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13502,axiom,
    ! [VarCurr: state_type] :
      ( v118551(VarCurr)
    <=> ( v118552(VarCurr)
        & v118553(VarCurr) ) ) ).

tff(writeUnaryOperator_7365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118553(VarCurr)
    <=> v118439(VarCurr) ) ).

tff(writeUnaryOperator_7364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118552(VarCurr)
    <=> v118430(VarCurr) ) ).

tff(writeUnaryOperator_7363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118549(VarCurr)
    <=> v118449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13501,axiom,
    ! [VarCurr: state_type] :
      ( v118547(VarCurr)
    <=> ( v118521(VarCurr)
        & v118449(VarCurr) ) ) ).

tff(writeUnaryOperator_7362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117917(VarCurr,0)
    <=> v118426(VarCurr) ) ).

tff(addAssignment_69120,axiom,
    ! [VarCurr: state_type] :
      ( v118426(VarCurr)
    <=> v117919(VarCurr,0) ) ).

tff(addAssignment_69119,axiom,
    ! [VarCurr: state_type] :
      ( v117919(VarCurr,0)
    <=> v117921(VarCurr,0) ) ).

tff(addAssignment_69118,axiom,
    ! [VarNext: state_type] :
      ( v117921(VarNext,0)
    <=> v118537(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118538(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v118537(VarNext,B)
            <=> v117921(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1540,axiom,
    ! [VarNext: state_type] :
      ( v118538(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118537(VarNext,B)
          <=> v118481(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118538(VarNext)
      <=> v118539(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118539(VarNext)
      <=> ( v118541(VarNext)
          & v118466(VarNext) ) ) ) ).

tff(writeUnaryOperator_7361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118541(VarNext)
      <=> v118475(VarNext) ) ) ).

tff(addAssignment_69117,axiom,
    ! [VarCurr: state_type] :
      ( v117939(VarCurr,0)
    <=> v117941(VarCurr,0) ) ).

tff(addAssignment_69116,axiom,
    ! [VarCurr: state_type] :
      ( v117941(VarCurr,0)
    <=> v117943(VarCurr,0) ) ).

tff(addAssignment_69115,axiom,
    ! [VarCurr: state_type] :
      ( v117943(VarCurr,0)
    <=> v118464(VarCurr,0) ) ).

tff(writeUnaryOperator_7360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118428(VarCurr)
    <=> v117945(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118516(VarCurr)
     => ( v117945(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1081,axiom,
    ! [VarCurr: state_type] :
      ( v118516(VarCurr)
     => ( v117945(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13498,axiom,
    ! [VarCurr: state_type] :
      ( v118516(VarCurr)
    <=> ( v118517(VarCurr)
        | v118530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13497,axiom,
    ! [VarCurr: state_type] :
      ( v118530(VarCurr)
    <=> ( v118531(VarCurr)
        & v118534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13496,axiom,
    ! [VarCurr: state_type] :
      ( v118534(VarCurr)
    <=> ( v118502(VarCurr)
        & v118505(VarCurr) ) ) ).

tff(writeUnaryOperator_7359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118531(VarCurr)
    <=> v118532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13495,axiom,
    ! [VarCurr: state_type] :
      ( v118532(VarCurr)
    <=> ( v118533(VarCurr)
        | v118462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13494,axiom,
    ! [VarCurr: state_type] :
      ( v118533(VarCurr)
    <=> ( v118449(VarCurr)
        | v118447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13493,axiom,
    ! [VarCurr: state_type] :
      ( v118517(VarCurr)
    <=> ( v118518(VarCurr)
        | v118526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13492,axiom,
    ! [VarCurr: state_type] :
      ( v118526(VarCurr)
    <=> ( v118527(VarCurr)
        & v118529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13491,axiom,
    ! [VarCurr: state_type] :
      ( v118529(VarCurr)
    <=> ( v118460(VarCurr)
        & v118462(VarCurr) ) ) ).

tff(writeUnaryOperator_7358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118527(VarCurr)
    <=> v118528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13490,axiom,
    ! [VarCurr: state_type] :
      ( v118528(VarCurr)
    <=> ( v118449(VarCurr)
        | v118447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13489,axiom,
    ! [VarCurr: state_type] :
      ( v118518(VarCurr)
    <=> ( v118519(VarCurr)
        | v118523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13488,axiom,
    ! [VarCurr: state_type] :
      ( v118523(VarCurr)
    <=> ( v118524(VarCurr)
        & v118525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13487,axiom,
    ! [VarCurr: state_type] :
      ( v118525(VarCurr)
    <=> ( v118439(VarCurr)
        & v118447(VarCurr) ) ) ).

tff(writeUnaryOperator_7357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118524(VarCurr)
    <=> v118449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13486,axiom,
    ! [VarCurr: state_type] :
      ( v118519(VarCurr)
    <=> ( v118520(VarCurr)
        & v118449(VarCurr) ) ) ).

tff(writeUnaryOperator_7356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118520(VarCurr)
    <=> v118521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13485,axiom,
    ! [VarCurr: state_type] :
      ( v118521(VarCurr)
    <=> ( v118522(VarCurr)
        & v118424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13484,axiom,
    ! [VarCurr: state_type] :
      ( v118522(VarCurr)
    <=> ( v117947(VarCurr)
        & v118422(VarCurr) ) ) ).

tff(addAssignment_69114,axiom,
    ! [VarCurr: state_type] :
      ( v117917(VarCurr,3)
    <=> v117919(VarCurr,3) ) ).

tff(addAssignment_69113,axiom,
    ! [VarCurr: state_type] :
      ( v117919(VarCurr,3)
    <=> v117921(VarCurr,3) ) ).

tff(addAssignment_69112,axiom,
    ! [VarNext: state_type] :
      ( v117921(VarNext,3)
    <=> v118508(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118509(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v118508(VarNext,B)
            <=> v117921(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1539,axiom,
    ! [VarNext: state_type] :
      ( v118509(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118508(VarNext,B)
          <=> v118481(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118509(VarNext)
      <=> v118510(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118510(VarNext)
      <=> ( v118512(VarNext)
          & v118466(VarNext) ) ) ) ).

tff(writeUnaryOperator_7355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118512(VarNext)
      <=> v118475(VarNext) ) ) ).

tff(addAssignment_69111,axiom,
    ! [VarCurr: state_type] :
      ( v117939(VarCurr,3)
    <=> v117941(VarCurr,3) ) ).

tff(addAssignment_69110,axiom,
    ! [VarCurr: state_type] :
      ( v117941(VarCurr,3)
    <=> v117943(VarCurr,3) ) ).

tff(addAssignment_69109,axiom,
    ! [VarCurr: state_type] :
      ( v117943(VarCurr,3)
    <=> v118464(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_46,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118490(VarCurr)
     => ( v117945(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_75,axiom,
    ! [VarCurr: state_type] :
      ( v118490(VarCurr)
     => ( v117945(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13481,axiom,
    ! [VarCurr: state_type] :
      ( v118490(VarCurr)
    <=> ( v118491(VarCurr)
        | v118497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13480,axiom,
    ! [VarCurr: state_type] :
      ( v118497(VarCurr)
    <=> ( v118498(VarCurr)
        & v118499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13479,axiom,
    ! [VarCurr: state_type] :
      ( v118499(VarCurr)
    <=> ( v118500(VarCurr)
        & v118506(VarCurr) ) ) ).

tff(writeUnaryOperator_7354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118506(VarCurr)
    <=> v118496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13478,axiom,
    ! [VarCurr: state_type] :
      ( v118500(VarCurr)
    <=> ( v118501(VarCurr)
        & v118505(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1177,axiom,
    ! [VarCurr: state_type] :
      ( v118505(VarCurr)
    <=> ( $true
      <=> v117917(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118501(VarCurr)
    <=> v118502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13477,axiom,
    ! [VarCurr: state_type] :
      ( v118502(VarCurr)
    <=> ( v118503(VarCurr)
        | v118432(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13476,axiom,
    ! [VarCurr: state_type] :
      ( v118503(VarCurr)
    <=> ( v118504(VarCurr)
        | v118488(VarCurr) ) ) ).

tff(writeUnaryOperator_7352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118504(VarCurr)
    <=> v118422(VarCurr) ) ).

tff(writeUnaryOperator_7351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118498(VarCurr)
    <=> v118462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13475,axiom,
    ! [VarCurr: state_type] :
      ( v118491(VarCurr)
    <=> ( v118492(VarCurr)
        & v118495(VarCurr) ) ) ).

tff(writeUnaryOperator_7350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118495(VarCurr)
    <=> v118496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13474,axiom,
    ! [VarCurr: state_type] :
      ( v118496(VarCurr)
    <=> ( v118449(VarCurr)
        | v118447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13473,axiom,
    ! [VarCurr: state_type] :
      ( v118492(VarCurr)
    <=> ( v118493(VarCurr)
        & v118462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13472,axiom,
    ! [VarCurr: state_type] :
      ( v118493(VarCurr)
    <=> ( v118456(VarCurr)
        & v118494(VarCurr) ) ) ).

tff(writeUnaryOperator_7349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118494(VarCurr)
    <=> v118460(VarCurr) ) ).

tff(addAssignment_69108,axiom,
    ! [VarCurr: state_type] :
      ( v118488(VarCurr)
    <=> v112831(VarCurr,5) ) ).

tff(addAssignment_69107,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,5)
    <=> v112865(VarCurr,5) ) ).

tff(addAssignment_69106,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,5)
    <=> v112849(VarCurr,5) ) ).

tff(addAssignment_69105,axiom,
    ! [VarCurr: state_type] :
      ( v117917(VarCurr,2)
    <=> v117919(VarCurr,2) ) ).

tff(addAssignment_69104,axiom,
    ! [VarCurr: state_type] :
      ( v117919(VarCurr,2)
    <=> v117921(VarCurr,2) ) ).

tff(addAssignment_69103,axiom,
    ! [VarNext: state_type] :
      ( v117921(VarNext,2)
    <=> v118470(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118471(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v118470(VarNext,B)
            <=> v117921(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1538,axiom,
    ! [VarNext: state_type] :
      ( v118471(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118470(VarNext,B)
          <=> v118481(VarNext,B) ) ) ) ).

tff(addAssignment_69102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118481(VarNext,B)
          <=> v118479(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118482(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118479(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1080,axiom,
    ! [VarCurr: state_type] :
      ( v118482(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v118479(VarCurr,B)
          <=> v117939(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13471,axiom,
    ! [VarCurr: state_type] :
      ( v118482(VarCurr)
    <=> ( v118483(VarCurr)
        & v118484(VarCurr) ) ) ).

tff(writeUnaryOperator_7348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118484(VarCurr)
    <=> v117931(VarCurr) ) ).

tff(writeUnaryOperator_7347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118483(VarCurr)
    <=> v117923(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118471(VarNext)
      <=> v118472(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118472(VarNext)
      <=> ( v118473(VarNext)
          & v118466(VarNext) ) ) ) ).

tff(writeUnaryOperator_7346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118473(VarNext)
      <=> v118475(VarNext) ) ) ).

tff(addAssignment_69101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118475(VarNext)
      <=> v118466(VarCurr) ) ) ).

tff(addAssignment_69100,axiom,
    ! [VarCurr: state_type] :
      ( v118466(VarCurr)
    <=> v118468(VarCurr) ) ).

tff(addAssignment_69099,axiom,
    ! [VarCurr: state_type] :
      ( v118468(VarCurr)
    <=> v118397(VarCurr) ) ).

tff(addAssignment_69098,axiom,
    ! [VarCurr: state_type] :
      ( v117939(VarCurr,2)
    <=> v117941(VarCurr,2) ) ).

tff(addAssignment_69097,axiom,
    ! [VarCurr: state_type] :
      ( v117941(VarCurr,2)
    <=> v117943(VarCurr,2) ) ).

tff(addAssignment_69096,axiom,
    ! [VarCurr: state_type] :
      ( v117943(VarCurr,2)
    <=> v118464(VarCurr,2) ) ).

tff(addAssignment_69095,axiom,
    ! [VarCurr: state_type] :
      ( v118464(VarCurr,0)
    <=> v118428(VarCurr) ) ).

tff(addAssignment_69094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v118464(VarCurr,B)
      <=> v117945(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_45,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118434(VarCurr)
     => ( v117945(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_74,axiom,
    ! [VarCurr: state_type] :
      ( v118434(VarCurr)
     => ( v117945(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13468,axiom,
    ! [VarCurr: state_type] :
      ( v118434(VarCurr)
    <=> ( v118435(VarCurr)
        | v118450(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13467,axiom,
    ! [VarCurr: state_type] :
      ( v118450(VarCurr)
    <=> ( v118451(VarCurr)
        & v118452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13466,axiom,
    ! [VarCurr: state_type] :
      ( v118452(VarCurr)
    <=> ( v118453(VarCurr)
        & v118463(VarCurr) ) ) ).

tff(writeUnaryOperator_7345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118463(VarCurr)
    <=> v118449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13465,axiom,
    ! [VarCurr: state_type] :
      ( v118453(VarCurr)
    <=> ( v118454(VarCurr)
        & v118462(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1176,axiom,
    ! [VarCurr: state_type] :
      ( v118462(VarCurr)
    <=> ( $true
      <=> v117917(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13464,axiom,
    ! [VarCurr: state_type] :
      ( v118454(VarCurr)
    <=> ( v118455(VarCurr)
        & v118459(VarCurr) ) ) ).

tff(writeUnaryOperator_7344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118459(VarCurr)
    <=> v118460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13463,axiom,
    ! [VarCurr: state_type] :
      ( v118460(VarCurr)
    <=> ( v118461(VarCurr)
        | v118432(VarCurr) ) ) ).

tff(writeUnaryOperator_7343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118461(VarCurr)
    <=> v118422(VarCurr) ) ).

tff(writeUnaryOperator_7342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118455(VarCurr)
    <=> v118456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13462,axiom,
    ! [VarCurr: state_type] :
      ( v118456(VarCurr)
    <=> ( v118457(VarCurr)
        | v118458(VarCurr) ) ) ).

tff(writeUnaryOperator_7341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118458(VarCurr)
    <=> v118424(VarCurr) ) ).

tff(writeUnaryOperator_7340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118457(VarCurr)
    <=> v117947(VarCurr) ) ).

tff(writeUnaryOperator_7339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118451(VarCurr)
    <=> v118447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13461,axiom,
    ! [VarCurr: state_type] :
      ( v118435(VarCurr)
    <=> ( v118436(VarCurr)
        & v118448(VarCurr) ) ) ).

tff(writeUnaryOperator_7338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118448(VarCurr)
    <=> v118449(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1175,axiom,
    ! [VarCurr: state_type] :
      ( v118449(VarCurr)
    <=> ( $true
      <=> v117917(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13460,axiom,
    ! [VarCurr: state_type] :
      ( v118436(VarCurr)
    <=> ( v118437(VarCurr)
        & v118447(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1174,axiom,
    ! [VarCurr: state_type] :
      ( v118447(VarCurr)
    <=> ( $true
      <=> v117917(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13459,axiom,
    ! [VarCurr: state_type] :
      ( v118437(VarCurr)
    <=> ( v118430(VarCurr)
        & v118438(VarCurr) ) ) ).

tff(writeUnaryOperator_7337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118438(VarCurr)
    <=> v118439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13458,axiom,
    ! [VarCurr: state_type] :
      ( v118439(VarCurr)
    <=> ( v118440(VarCurr)
        | v118432(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13457,axiom,
    ! [VarCurr: state_type] :
      ( v118440(VarCurr)
    <=> ( v118441(VarCurr)
        | v118444(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13456,axiom,
    ! [VarCurr: state_type] :
      ( v118444(VarCurr)
    <=> ( v118445(VarCurr)
        & v118446(VarCurr) ) ) ).

tff(writeUnaryOperator_7336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118446(VarCurr)
    <=> v118430(VarCurr) ) ).

tff(writeUnaryOperator_7335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118445(VarCurr)
    <=> v117947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13455,axiom,
    ! [VarCurr: state_type] :
      ( v118441(VarCurr)
    <=> ( v118442(VarCurr)
        | v118443(VarCurr) ) ) ).

tff(writeUnaryOperator_7334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118443(VarCurr)
    <=> v118424(VarCurr) ) ).

tff(writeUnaryOperator_7333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118442(VarCurr)
    <=> v118422(VarCurr) ) ).

tff(addAssignment_69093,axiom,
    ! [VarCurr: state_type] :
      ( v118432(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_69092,axiom,
    ! [VarCurr: state_type] :
      ( v118430(VarCurr)
    <=> v112643(VarCurr,5) ) ).

tff(addAssignment_69091,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,5)
    <=> v115202(VarCurr,5) ) ).

tff(addAssignment_69090,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,5)
    <=> v115186(VarCurr,5) ) ).

tff(addAssignment_69089,axiom,
    ! [VarCurr: state_type] :
      ( v118424(VarCurr)
    <=> v112528(VarCurr,5) ) ).

tff(addAssignment_69088,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,5)
    <=> v112530(VarCurr,5) ) ).

tff(addAssignment_69087,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,5)
    <=> v112590(VarCurr,5) ) ).

tff(addAssignment_69086,axiom,
    ! [VarCurr: state_type] :
      ( v118422(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13454,axiom,
    ! [VarCurr: state_type] :
      ( v117947(VarCurr)
    <=> ( v118419(VarCurr)
        & v118420(VarCurr) ) ) ).

tff(writeUnaryOperator_7332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118420(VarCurr)
    <=> v118417(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1173,axiom,
    ! [VarCurr: state_type] :
      ( v118419(VarCurr)
    <=> ( ( v117949(VarCurr,5)
        <=> $false )
        & ( v117949(VarCurr,4)
        <=> $false )
        & ( v117949(VarCurr,3)
        <=> $false )
        & ( v117949(VarCurr,2)
        <=> $false )
        & ( v117949(VarCurr,1)
        <=> $false )
        & ( v117949(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_69085,axiom,
    ! [VarCurr: state_type] :
      ( v118417(VarCurr)
    <=> v115139(VarCurr,5) ) ).

tff(addAssignment_69084,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,5)
    <=> v115159(VarCurr,5) ) ).

tff(addAssignment_69083,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,5)
    <=> v115142(VarCurr,5) ) ).

tff(addAssignment_69082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117949(VarCurr,B)
      <=> v117951(VarCurr,B) ) ) ).

tff(addAssignment_69081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117951(VarCurr,B)
      <=> v117953(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118400(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v117953(VarNext,B)
            <=> v117953(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1537,axiom,
    ! [VarNext: state_type] :
      ( v118400(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v117953(VarNext,B)
          <=> v118410(VarNext,B) ) ) ) ).

tff(addAssignment_69080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v118410(VarNext,B)
          <=> v118408(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118411(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v118408(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1079,axiom,
    ! [VarCurr: state_type] :
      ( v118411(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v118408(VarCurr,B)
          <=> v117963(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13453,axiom,
    ! [VarCurr: state_type] :
      ( v118411(VarCurr)
    <=> ( v118412(VarCurr)
        & v118413(VarCurr) ) ) ).

tff(writeUnaryOperator_7331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118413(VarCurr)
    <=> v117959(VarCurr) ) ).

tff(writeUnaryOperator_7330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118412(VarCurr)
    <=> v117955(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118400(VarNext)
      <=> v118401(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118401(VarNext)
      <=> ( v118402(VarNext)
          & v118393(VarNext) ) ) ) ).

tff(writeUnaryOperator_7329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118402(VarNext)
      <=> v118404(VarNext) ) ) ).

tff(addAssignment_69079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118404(VarNext)
      <=> v118393(VarCurr) ) ) ).

tff(addAssignment_69078,axiom,
    ! [VarCurr: state_type] :
      ( v118393(VarCurr)
    <=> v118395(VarCurr) ) ).

tff(addAssignment_69077,axiom,
    ! [VarCurr: state_type] :
      ( v118395(VarCurr)
    <=> v118397(VarCurr) ) ).

tff(addAssignment_69076,axiom,
    ! [VarCurr: state_type] :
      ( v118397(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_69075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117963(VarCurr,B)
      <=> v117965(VarCurr,B) ) ) ).

tff(addAssignment_69074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117965(VarCurr,B)
      <=> v117967(VarCurr,B) ) ) ).

tff(addAssignment_69073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117967(VarCurr,B)
      <=> v117969(VarCurr,B) ) ) ).

tff(addAssignment_69072,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,0)
    <=> v118388(VarCurr) ) ).

tff(addAssignment_69071,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,1)
    <=> v118383(VarCurr) ) ).

tff(addAssignment_69070,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,2)
    <=> v118378(VarCurr) ) ).

tff(addAssignment_69069,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,3)
    <=> v118373(VarCurr) ) ).

tff(addAssignment_69068,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,4)
    <=> v118368(VarCurr) ) ).

tff(addAssignment_69067,axiom,
    ! [VarCurr: state_type] :
      ( v117969(VarCurr,5)
    <=> v118225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13450,axiom,
    ! [VarCurr: state_type] :
      ( v118388(VarCurr)
    <=> ( v118389(VarCurr)
        & v118391(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13449,axiom,
    ! [VarCurr: state_type] :
      ( v118391(VarCurr)
    <=> ( v118180(VarCurr,0)
        | v118237(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13448,axiom,
    ! [VarCurr: state_type] :
      ( v118389(VarCurr)
    <=> ( v118314(VarCurr)
        | v118390(VarCurr) ) ) ).

tff(writeUnaryOperator_7328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118390(VarCurr)
    <=> v118237(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13447,axiom,
    ! [VarCurr: state_type] :
      ( v118383(VarCurr)
    <=> ( v118384(VarCurr)
        & v118387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13446,axiom,
    ! [VarCurr: state_type] :
      ( v118387(VarCurr)
    <=> ( v118236(VarCurr)
        | v118308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13445,axiom,
    ! [VarCurr: state_type] :
      ( v118384(VarCurr)
    <=> ( v118385(VarCurr)
        | v118386(VarCurr) ) ) ).

tff(writeUnaryOperator_7327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118386(VarCurr)
    <=> v118308(VarCurr) ) ).

tff(writeUnaryOperator_7326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118385(VarCurr)
    <=> v118236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13444,axiom,
    ! [VarCurr: state_type] :
      ( v118378(VarCurr)
    <=> ( v118379(VarCurr)
        & v118382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13443,axiom,
    ! [VarCurr: state_type] :
      ( v118382(VarCurr)
    <=> ( v118234(VarCurr)
        | v118319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13442,axiom,
    ! [VarCurr: state_type] :
      ( v118379(VarCurr)
    <=> ( v118380(VarCurr)
        | v118381(VarCurr) ) ) ).

tff(writeUnaryOperator_7325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118381(VarCurr)
    <=> v118319(VarCurr) ) ).

tff(writeUnaryOperator_7324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118380(VarCurr)
    <=> v118234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13441,axiom,
    ! [VarCurr: state_type] :
      ( v118373(VarCurr)
    <=> ( v118374(VarCurr)
        & v118377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13440,axiom,
    ! [VarCurr: state_type] :
      ( v118377(VarCurr)
    <=> ( v118232(VarCurr)
        | v118331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13439,axiom,
    ! [VarCurr: state_type] :
      ( v118374(VarCurr)
    <=> ( v118375(VarCurr)
        | v118376(VarCurr) ) ) ).

tff(writeUnaryOperator_7323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118376(VarCurr)
    <=> v118331(VarCurr) ) ).

tff(writeUnaryOperator_7322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118375(VarCurr)
    <=> v118232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13438,axiom,
    ! [VarCurr: state_type] :
      ( v118368(VarCurr)
    <=> ( v118369(VarCurr)
        & v118372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13437,axiom,
    ! [VarCurr: state_type] :
      ( v118372(VarCurr)
    <=> ( v118230(VarCurr)
        | v118343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13436,axiom,
    ! [VarCurr: state_type] :
      ( v118369(VarCurr)
    <=> ( v118370(VarCurr)
        | v118371(VarCurr) ) ) ).

tff(writeUnaryOperator_7321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118371(VarCurr)
    <=> v118343(VarCurr) ) ).

tff(writeUnaryOperator_7320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118370(VarCurr)
    <=> v118230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13435,axiom,
    ! [VarCurr: state_type] :
      ( v118225(VarCurr)
    <=> ( v118226(VarCurr)
        & v118367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13434,axiom,
    ! [VarCurr: state_type] :
      ( v118367(VarCurr)
    <=> ( v118228(VarCurr)
        | v118356(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13433,axiom,
    ! [VarCurr: state_type] :
      ( v118226(VarCurr)
    <=> ( v118227(VarCurr)
        | v118355(VarCurr) ) ) ).

tff(writeUnaryOperator_7319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118355(VarCurr)
    <=> v118356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13432,axiom,
    ! [VarCurr: state_type] :
      ( v118356(VarCurr)
    <=> ( v118357(VarCurr)
        & v118366(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5102,axiom,
    ! [VarCurr: state_type] :
      ( v118366(VarCurr)
    <=> ( v118359(VarCurr)
        | v118237(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13431,axiom,
    ! [VarCurr: state_type] :
      ( v118357(VarCurr)
    <=> ( v118358(VarCurr)
        | v118365(VarCurr) ) ) ).

tff(writeUnaryOperator_7318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118365(VarCurr)
    <=> v118237(VarCurr,5) ) ).

tff(writeUnaryOperator_7317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118358(VarCurr)
    <=> v118359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13430,axiom,
    ! [VarCurr: state_type] :
      ( v118359(VarCurr)
    <=> ( v118360(VarCurr)
        & v118363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13429,axiom,
    ! [VarCurr: state_type] :
      ( v118363(VarCurr)
    <=> ( v118362(VarCurr)
        | v118364(VarCurr) ) ) ).

tff(writeUnaryOperator_7316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118364(VarCurr)
    <=> v118180(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5101,axiom,
    ! [VarCurr: state_type] :
      ( v118360(VarCurr)
    <=> ( v118361(VarCurr)
        | v118180(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118361(VarCurr)
    <=> v118362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13428,axiom,
    ! [VarCurr: state_type] :
      ( v118362(VarCurr)
    <=> ( v118349(VarCurr)
        & v118351(VarCurr) ) ) ).

tff(writeUnaryOperator_7314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118227(VarCurr)
    <=> v118228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13427,axiom,
    ! [VarCurr: state_type] :
      ( v118228(VarCurr)
    <=> ( v118229(VarCurr)
        | v118354(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5100,axiom,
    ! [VarCurr: state_type] :
      ( v118354(VarCurr)
    <=> ( v118346(VarCurr)
        & v118237(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13426,axiom,
    ! [VarCurr: state_type] :
      ( v118229(VarCurr)
    <=> ( v118230(VarCurr)
        & v118343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13425,axiom,
    ! [VarCurr: state_type] :
      ( v118343(VarCurr)
    <=> ( v118344(VarCurr)
        & v118353(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5099,axiom,
    ! [VarCurr: state_type] :
      ( v118353(VarCurr)
    <=> ( v118346(VarCurr)
        | v118237(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13424,axiom,
    ! [VarCurr: state_type] :
      ( v118344(VarCurr)
    <=> ( v118345(VarCurr)
        | v118352(VarCurr) ) ) ).

tff(writeUnaryOperator_7313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118352(VarCurr)
    <=> v118237(VarCurr,4) ) ).

tff(writeUnaryOperator_7312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118345(VarCurr)
    <=> v118346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13423,axiom,
    ! [VarCurr: state_type] :
      ( v118346(VarCurr)
    <=> ( v118347(VarCurr)
        & v118350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13422,axiom,
    ! [VarCurr: state_type] :
      ( v118350(VarCurr)
    <=> ( v118349(VarCurr)
        | v118351(VarCurr) ) ) ).

tff(writeUnaryOperator_7311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118351(VarCurr)
    <=> v118180(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5098,axiom,
    ! [VarCurr: state_type] :
      ( v118347(VarCurr)
    <=> ( v118348(VarCurr)
        | v118180(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118348(VarCurr)
    <=> v118349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13421,axiom,
    ! [VarCurr: state_type] :
      ( v118349(VarCurr)
    <=> ( v118337(VarCurr)
        & v118339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13420,axiom,
    ! [VarCurr: state_type] :
      ( v118230(VarCurr)
    <=> ( v118231(VarCurr)
        | v118342(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5097,axiom,
    ! [VarCurr: state_type] :
      ( v118342(VarCurr)
    <=> ( v118334(VarCurr)
        & v118237(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13419,axiom,
    ! [VarCurr: state_type] :
      ( v118231(VarCurr)
    <=> ( v118232(VarCurr)
        & v118331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13418,axiom,
    ! [VarCurr: state_type] :
      ( v118331(VarCurr)
    <=> ( v118332(VarCurr)
        & v118341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5096,axiom,
    ! [VarCurr: state_type] :
      ( v118341(VarCurr)
    <=> ( v118334(VarCurr)
        | v118237(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13417,axiom,
    ! [VarCurr: state_type] :
      ( v118332(VarCurr)
    <=> ( v118333(VarCurr)
        | v118340(VarCurr) ) ) ).

tff(writeUnaryOperator_7309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118340(VarCurr)
    <=> v118237(VarCurr,3) ) ).

tff(writeUnaryOperator_7308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118333(VarCurr)
    <=> v118334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13416,axiom,
    ! [VarCurr: state_type] :
      ( v118334(VarCurr)
    <=> ( v118335(VarCurr)
        & v118338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13415,axiom,
    ! [VarCurr: state_type] :
      ( v118338(VarCurr)
    <=> ( v118337(VarCurr)
        | v118339(VarCurr) ) ) ).

tff(writeUnaryOperator_7307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118339(VarCurr)
    <=> v118180(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5095,axiom,
    ! [VarCurr: state_type] :
      ( v118335(VarCurr)
    <=> ( v118336(VarCurr)
        | v118180(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118336(VarCurr)
    <=> v118337(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13414,axiom,
    ! [VarCurr: state_type] :
      ( v118337(VarCurr)
    <=> ( v118325(VarCurr)
        & v118327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13413,axiom,
    ! [VarCurr: state_type] :
      ( v118232(VarCurr)
    <=> ( v118233(VarCurr)
        | v118330(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5094,axiom,
    ! [VarCurr: state_type] :
      ( v118330(VarCurr)
    <=> ( v118322(VarCurr)
        & v118237(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13412,axiom,
    ! [VarCurr: state_type] :
      ( v118233(VarCurr)
    <=> ( v118234(VarCurr)
        & v118319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13411,axiom,
    ! [VarCurr: state_type] :
      ( v118319(VarCurr)
    <=> ( v118320(VarCurr)
        & v118329(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5093,axiom,
    ! [VarCurr: state_type] :
      ( v118329(VarCurr)
    <=> ( v118322(VarCurr)
        | v118237(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13410,axiom,
    ! [VarCurr: state_type] :
      ( v118320(VarCurr)
    <=> ( v118321(VarCurr)
        | v118328(VarCurr) ) ) ).

tff(writeUnaryOperator_7305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118328(VarCurr)
    <=> v118237(VarCurr,2) ) ).

tff(writeUnaryOperator_7304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118321(VarCurr)
    <=> v118322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13409,axiom,
    ! [VarCurr: state_type] :
      ( v118322(VarCurr)
    <=> ( v118323(VarCurr)
        & v118326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13408,axiom,
    ! [VarCurr: state_type] :
      ( v118326(VarCurr)
    <=> ( v118325(VarCurr)
        | v118327(VarCurr) ) ) ).

tff(writeUnaryOperator_7303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118327(VarCurr)
    <=> v118180(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5092,axiom,
    ! [VarCurr: state_type] :
      ( v118323(VarCurr)
    <=> ( v118324(VarCurr)
        | v118180(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118324(VarCurr)
    <=> v118325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13407,axiom,
    ! [VarCurr: state_type] :
      ( v118325(VarCurr)
    <=> ( v118314(VarCurr)
        & v118315(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13406,axiom,
    ! [VarCurr: state_type] :
      ( v118234(VarCurr)
    <=> ( v118235(VarCurr)
        | v118318(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5091,axiom,
    ! [VarCurr: state_type] :
      ( v118318(VarCurr)
    <=> ( v118311(VarCurr)
        & v118237(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13405,axiom,
    ! [VarCurr: state_type] :
      ( v118235(VarCurr)
    <=> ( v118236(VarCurr)
        & v118308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13404,axiom,
    ! [VarCurr: state_type] :
      ( v118308(VarCurr)
    <=> ( v118309(VarCurr)
        & v118317(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5090,axiom,
    ! [VarCurr: state_type] :
      ( v118317(VarCurr)
    <=> ( v118311(VarCurr)
        | v118237(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13403,axiom,
    ! [VarCurr: state_type] :
      ( v118309(VarCurr)
    <=> ( v118310(VarCurr)
        | v118316(VarCurr) ) ) ).

tff(writeUnaryOperator_7301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118316(VarCurr)
    <=> v118237(VarCurr,1) ) ).

tff(writeUnaryOperator_7300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118310(VarCurr)
    <=> v118311(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13402,axiom,
    ! [VarCurr: state_type] :
      ( v118311(VarCurr)
    <=> ( v118312(VarCurr)
        & v118313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13401,axiom,
    ! [VarCurr: state_type] :
      ( v118313(VarCurr)
    <=> ( v118314(VarCurr)
        | v118315(VarCurr) ) ) ).

tff(writeUnaryOperator_7299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118315(VarCurr)
    <=> v118180(VarCurr,1) ) ).

tff(writeUnaryOperator_7298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118314(VarCurr)
    <=> v118180(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5089,axiom,
    ! [VarCurr: state_type] :
      ( v118312(VarCurr)
    <=> ( v118180(VarCurr,0)
        | v118180(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13400,axiom,
    ! [VarCurr: state_type] :
      ( v118236(VarCurr)
    <=> ( v118180(VarCurr,0)
        & v118237(VarCurr,0) ) ) ).

tff(addAssignment_69066,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,0)
    <=> v118303(VarCurr) ) ).

tff(addAssignment_69065,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,1)
    <=> v118298(VarCurr) ) ).

tff(addAssignment_69064,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,2)
    <=> v118293(VarCurr) ) ).

tff(addAssignment_69063,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,3)
    <=> v118288(VarCurr) ) ).

tff(addAssignment_69062,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,4)
    <=> v118283(VarCurr) ) ).

tff(addAssignment_69061,axiom,
    ! [VarCurr: state_type] :
      ( v118237(VarCurr,5)
    <=> v118239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13399,axiom,
    ! [VarCurr: state_type] :
      ( v118303(VarCurr)
    <=> ( v118304(VarCurr)
        & v118307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13398,axiom,
    ! [VarCurr: state_type] :
      ( v118307(VarCurr)
    <=> ( v117949(VarCurr,0)
        | v118251(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13397,axiom,
    ! [VarCurr: state_type] :
      ( v118304(VarCurr)
    <=> ( v118305(VarCurr)
        | v118306(VarCurr) ) ) ).

tff(writeUnaryOperator_7297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118306(VarCurr)
    <=> v118251(VarCurr,0) ) ).

tff(writeUnaryOperator_7296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118305(VarCurr)
    <=> v117949(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13396,axiom,
    ! [VarCurr: state_type] :
      ( v118298(VarCurr)
    <=> ( v118299(VarCurr)
        & v118302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13395,axiom,
    ! [VarCurr: state_type] :
      ( v118302(VarCurr)
    <=> ( v118250(VarCurr)
        | v118252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13394,axiom,
    ! [VarCurr: state_type] :
      ( v118299(VarCurr)
    <=> ( v118300(VarCurr)
        | v118301(VarCurr) ) ) ).

tff(writeUnaryOperator_7295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118301(VarCurr)
    <=> v118252(VarCurr) ) ).

tff(writeUnaryOperator_7294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118300(VarCurr)
    <=> v118250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13393,axiom,
    ! [VarCurr: state_type] :
      ( v118293(VarCurr)
    <=> ( v118294(VarCurr)
        & v118297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13392,axiom,
    ! [VarCurr: state_type] :
      ( v118297(VarCurr)
    <=> ( v118248(VarCurr)
        | v118258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13391,axiom,
    ! [VarCurr: state_type] :
      ( v118294(VarCurr)
    <=> ( v118295(VarCurr)
        | v118296(VarCurr) ) ) ).

tff(writeUnaryOperator_7293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118296(VarCurr)
    <=> v118258(VarCurr) ) ).

tff(writeUnaryOperator_7292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118295(VarCurr)
    <=> v118248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13390,axiom,
    ! [VarCurr: state_type] :
      ( v118288(VarCurr)
    <=> ( v118289(VarCurr)
        & v118292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13389,axiom,
    ! [VarCurr: state_type] :
      ( v118292(VarCurr)
    <=> ( v118246(VarCurr)
        | v118264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13388,axiom,
    ! [VarCurr: state_type] :
      ( v118289(VarCurr)
    <=> ( v118290(VarCurr)
        | v118291(VarCurr) ) ) ).

tff(writeUnaryOperator_7291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118291(VarCurr)
    <=> v118264(VarCurr) ) ).

tff(writeUnaryOperator_7290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118290(VarCurr)
    <=> v118246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13387,axiom,
    ! [VarCurr: state_type] :
      ( v118283(VarCurr)
    <=> ( v118284(VarCurr)
        & v118287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13386,axiom,
    ! [VarCurr: state_type] :
      ( v118287(VarCurr)
    <=> ( v118244(VarCurr)
        | v118270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13385,axiom,
    ! [VarCurr: state_type] :
      ( v118284(VarCurr)
    <=> ( v118285(VarCurr)
        | v118286(VarCurr) ) ) ).

tff(writeUnaryOperator_7289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118286(VarCurr)
    <=> v118270(VarCurr) ) ).

tff(writeUnaryOperator_7288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118285(VarCurr)
    <=> v118244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13384,axiom,
    ! [VarCurr: state_type] :
      ( v118239(VarCurr)
    <=> ( v118240(VarCurr)
        & v118282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13383,axiom,
    ! [VarCurr: state_type] :
      ( v118282(VarCurr)
    <=> ( v118242(VarCurr)
        | v118277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13382,axiom,
    ! [VarCurr: state_type] :
      ( v118240(VarCurr)
    <=> ( v118241(VarCurr)
        | v118276(VarCurr) ) ) ).

tff(writeUnaryOperator_7287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118276(VarCurr)
    <=> v118277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13381,axiom,
    ! [VarCurr: state_type] :
      ( v118277(VarCurr)
    <=> ( v118278(VarCurr)
        & v118281(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5088,axiom,
    ! [VarCurr: state_type] :
      ( v118281(VarCurr)
    <=> ( v117949(VarCurr,5)
        | v118251(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13380,axiom,
    ! [VarCurr: state_type] :
      ( v118278(VarCurr)
    <=> ( v118279(VarCurr)
        | v118280(VarCurr) ) ) ).

tff(writeUnaryOperator_7286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118280(VarCurr)
    <=> v118251(VarCurr,5) ) ).

tff(writeUnaryOperator_7285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118279(VarCurr)
    <=> v117949(VarCurr,5) ) ).

tff(writeUnaryOperator_7284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118241(VarCurr)
    <=> v118242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13379,axiom,
    ! [VarCurr: state_type] :
      ( v118242(VarCurr)
    <=> ( v118243(VarCurr)
        | v118275(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5087,axiom,
    ! [VarCurr: state_type] :
      ( v118275(VarCurr)
    <=> ( v117949(VarCurr,4)
        & v118251(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13378,axiom,
    ! [VarCurr: state_type] :
      ( v118243(VarCurr)
    <=> ( v118244(VarCurr)
        & v118270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13377,axiom,
    ! [VarCurr: state_type] :
      ( v118270(VarCurr)
    <=> ( v118271(VarCurr)
        & v118274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5086,axiom,
    ! [VarCurr: state_type] :
      ( v118274(VarCurr)
    <=> ( v117949(VarCurr,4)
        | v118251(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13376,axiom,
    ! [VarCurr: state_type] :
      ( v118271(VarCurr)
    <=> ( v118272(VarCurr)
        | v118273(VarCurr) ) ) ).

tff(writeUnaryOperator_7283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118273(VarCurr)
    <=> v118251(VarCurr,4) ) ).

tff(writeUnaryOperator_7282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118272(VarCurr)
    <=> v117949(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13375,axiom,
    ! [VarCurr: state_type] :
      ( v118244(VarCurr)
    <=> ( v118245(VarCurr)
        | v118269(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5085,axiom,
    ! [VarCurr: state_type] :
      ( v118269(VarCurr)
    <=> ( v117949(VarCurr,3)
        & v118251(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13374,axiom,
    ! [VarCurr: state_type] :
      ( v118245(VarCurr)
    <=> ( v118246(VarCurr)
        & v118264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13373,axiom,
    ! [VarCurr: state_type] :
      ( v118264(VarCurr)
    <=> ( v118265(VarCurr)
        & v118268(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5084,axiom,
    ! [VarCurr: state_type] :
      ( v118268(VarCurr)
    <=> ( v117949(VarCurr,3)
        | v118251(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13372,axiom,
    ! [VarCurr: state_type] :
      ( v118265(VarCurr)
    <=> ( v118266(VarCurr)
        | v118267(VarCurr) ) ) ).

tff(writeUnaryOperator_7281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118267(VarCurr)
    <=> v118251(VarCurr,3) ) ).

tff(writeUnaryOperator_7280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118266(VarCurr)
    <=> v117949(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13371,axiom,
    ! [VarCurr: state_type] :
      ( v118246(VarCurr)
    <=> ( v118247(VarCurr)
        | v118263(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5083,axiom,
    ! [VarCurr: state_type] :
      ( v118263(VarCurr)
    <=> ( v117949(VarCurr,2)
        & v118251(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13370,axiom,
    ! [VarCurr: state_type] :
      ( v118247(VarCurr)
    <=> ( v118248(VarCurr)
        & v118258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13369,axiom,
    ! [VarCurr: state_type] :
      ( v118258(VarCurr)
    <=> ( v118259(VarCurr)
        & v118262(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5082,axiom,
    ! [VarCurr: state_type] :
      ( v118262(VarCurr)
    <=> ( v117949(VarCurr,2)
        | v118251(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13368,axiom,
    ! [VarCurr: state_type] :
      ( v118259(VarCurr)
    <=> ( v118260(VarCurr)
        | v118261(VarCurr) ) ) ).

tff(writeUnaryOperator_7279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118261(VarCurr)
    <=> v118251(VarCurr,2) ) ).

tff(writeUnaryOperator_7278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118260(VarCurr)
    <=> v117949(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13367,axiom,
    ! [VarCurr: state_type] :
      ( v118248(VarCurr)
    <=> ( v118249(VarCurr)
        | v118257(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5081,axiom,
    ! [VarCurr: state_type] :
      ( v118257(VarCurr)
    <=> ( v117949(VarCurr,1)
        & v118251(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13366,axiom,
    ! [VarCurr: state_type] :
      ( v118249(VarCurr)
    <=> ( v118250(VarCurr)
        & v118252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13365,axiom,
    ! [VarCurr: state_type] :
      ( v118252(VarCurr)
    <=> ( v118253(VarCurr)
        & v118256(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5080,axiom,
    ! [VarCurr: state_type] :
      ( v118256(VarCurr)
    <=> ( v117949(VarCurr,1)
        | v118251(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13364,axiom,
    ! [VarCurr: state_type] :
      ( v118253(VarCurr)
    <=> ( v118254(VarCurr)
        | v118255(VarCurr) ) ) ).

tff(writeUnaryOperator_7277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118255(VarCurr)
    <=> v118251(VarCurr,1) ) ).

tff(writeUnaryOperator_7276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118254(VarCurr)
    <=> v117949(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13363,axiom,
    ! [VarCurr: state_type] :
      ( v118250(VarCurr)
    <=> ( v117949(VarCurr,0)
        & v118251(VarCurr,0) ) ) ).

tff(addAssignment_69060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v118251(VarCurr,B)
      <=> v117971(VarCurr,B) ) ) ).

tff(addAssignment_69059,axiom,
    ! [VarCurr: state_type] :
      ( ( v118251(VarCurr,5)
      <=> $false )
      & ( v118251(VarCurr,4)
      <=> $false )
      & ( v118251(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_69058,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,5)
    <=> v118217(VarCurr,5) ) ).

tff(addAssignment_69057,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,4)
    <=> v118217(VarCurr,4) ) ).

tff(addAssignment_69056,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,3)
    <=> v118217(VarCurr,3) ) ).

tff(addAssignment_69055,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,2)
    <=> v118217(VarCurr,2) ) ).

tff(addAssignment_69054,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,1)
    <=> v118217(VarCurr,1) ) ).

tff(addAssignment_69053,axiom,
    ! [VarCurr: state_type] :
      ( v118180(VarCurr,0)
    <=> v118217(VarCurr,0) ) ).

tff(addAssignment_69052,axiom,
    ! [VarCurr: state_type] :
      ( v118217(VarCurr,0)
    <=> v118218(VarCurr) ) ).

tff(addAssignment_69051,axiom,
    ! [VarCurr: state_type] :
      ( ( v118217(VarCurr,5)
      <=> $false )
      & ( v118217(VarCurr,4)
      <=> $false )
      & ( v118217(VarCurr,3)
      <=> $false )
      & ( v118217(VarCurr,2)
      <=> $false )
      & ( v118217(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13362,axiom,
    ! [VarCurr: state_type] :
      ( v118218(VarCurr)
    <=> ( v118219(VarCurr)
        | v118216(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13361,axiom,
    ! [VarCurr: state_type] :
      ( v118219(VarCurr)
    <=> ( v118220(VarCurr)
        | v118214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13360,axiom,
    ! [VarCurr: state_type] :
      ( v118220(VarCurr)
    <=> ( v118221(VarCurr)
        | v118212(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13359,axiom,
    ! [VarCurr: state_type] :
      ( v118221(VarCurr)
    <=> ( v118222(VarCurr)
        | v118202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13358,axiom,
    ! [VarCurr: state_type] :
      ( v118222(VarCurr)
    <=> ( v118182(VarCurr)
        | v118192(VarCurr) ) ) ).

tff(addAssignment_69050,axiom,
    ! [VarCurr: state_type] :
      ( v118216(VarCurr)
    <=> v113911(VarCurr,5) ) ).

tff(addAssignment_69049,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,5)
    <=> v113913(VarCurr,5) ) ).

tff(addAssignment_69048,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,5)
    <=> v113915(VarCurr,5) ) ).

tff(addAssignment_69047,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,5)
    <=> v113935(VarCurr,5) ) ).

tff(addAssignment_69046,axiom,
    ! [VarCurr: state_type] :
      ( v118214(VarCurr)
    <=> v113107(VarCurr,5) ) ).

tff(addAssignment_69045,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,5)
    <=> v113143(VarCurr,5) ) ).

tff(addAssignment_69044,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,5)
    <=> v113110(VarCurr,5) ) ).

tff(addAssignment_69043,axiom,
    ! [VarCurr: state_type] :
      ( v118212(VarCurr)
    <=> v113100(VarCurr,5) ) ).

tff(addAssignment_69042,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,5)
    <=> v113101(VarCurr,5) ) ).

tff(addAssignment_69041,axiom,
    ! [VarCurr: state_type] :
      ( v118202(VarCurr)
    <=> v113810(VarCurr,5) ) ).

tff(addAssignment_69040,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,5)
    <=> v113812(VarCurr,5) ) ).

tff(addAssignment_69039,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,5)
    <=> v113814(VarCurr,5) ) ).

tff(addAssignment_69038,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,5)
    <=> v113816(VarCurr,5) ) ).

tff(addAssignment_69037,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,5)
    <=> v113818(VarCurr,5) ) ).

tff(addAssignment_69036,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,5)
    <=> v118204(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118205(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v118204(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1536,axiom,
    ! [VarNext: state_type] :
      ( v118205(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v118204(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118205(VarNext)
      <=> v118206(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118206(VarNext)
      <=> ( v118208(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118208(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_69035,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,5)
    <=> v113830(VarCurr,5) ) ).

tff(addAssignment_69034,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,5)
    <=> v113832(VarCurr,5) ) ).

tff(addAssignment_69033,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,5)
    <=> v113834(VarCurr,5) ) ).

tff(addAssignment_69032,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,5)
    <=> v113873(VarCurr,5) ) ).

tff(addAssignment_69031,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,5)
    <=> v113856(VarCurr,5) ) ).

tff(addAssignment_69030,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,5)
    <=> v113837(VarCurr,5) ) ).

tff(addAssignment_69029,axiom,
    ! [VarCurr: state_type] :
      ( v118192(VarCurr)
    <=> v113020(VarCurr,5) ) ).

tff(addAssignment_69028,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,5)
    <=> v113022(VarCurr,5) ) ).

tff(addAssignment_69027,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,5)
    <=> v113024(VarCurr,5) ) ).

tff(addAssignment_69026,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,5)
    <=> v113026(VarCurr,5) ) ).

tff(addAssignment_69025,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,5)
    <=> v113028(VarCurr,5) ) ).

tff(addAssignment_69024,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,5)
    <=> v118194(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118195(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v118194(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1535,axiom,
    ! [VarNext: state_type] :
      ( v118195(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v118194(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118195(VarNext)
      <=> v118196(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118196(VarNext)
      <=> ( v118198(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118198(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_69023,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,5)
    <=> v113040(VarCurr,5) ) ).

tff(addAssignment_69022,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,5)
    <=> v113042(VarCurr,5) ) ).

tff(addAssignment_69021,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,5)
    <=> v113044(VarCurr,5) ) ).

tff(addAssignment_69020,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,5)
    <=> v113045(VarCurr,5) ) ).

tff(addAssignment_69019,axiom,
    ! [VarCurr: state_type] :
      ( v118182(VarCurr)
    <=> v112940(VarCurr,5) ) ).

tff(addAssignment_69018,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,5)
    <=> v112942(VarCurr,5) ) ).

tff(addAssignment_69017,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,5)
    <=> v112944(VarCurr,5) ) ).

tff(addAssignment_69016,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,5)
    <=> v112946(VarCurr,5) ) ).

tff(addAssignment_69015,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,5)
    <=> v112948(VarCurr,5) ) ).

tff(addAssignment_69014,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,5)
    <=> v118184(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118185(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v118184(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1534,axiom,
    ! [VarNext: state_type] :
      ( v118185(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v118184(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118185(VarNext)
      <=> v118186(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v118186(VarNext)
      <=> ( v118188(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v118188(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_69013,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,5)
    <=> v112960(VarCurr,5) ) ).

tff(addAssignment_69012,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,5)
    <=> v112962(VarCurr,5) ) ).

tff(addAssignment_69011,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,5)
    <=> v112964(VarCurr,5) ) ).

tff(addAssignment_69010,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,5)
    <=> v112965(VarCurr,5) ) ).

tff(addAssignment_69009,axiom,
    ! [VarCurr: state_type] :
      ( v117971(VarCurr,2)
    <=> v117986(VarCurr,2) ) ).

tff(addAssignment_69008,axiom,
    ! [VarCurr: state_type] :
      ( v117971(VarCurr,1)
    <=> v117986(VarCurr,1) ) ).

tff(addAssignment_69007,axiom,
    ! [VarCurr: state_type] :
      ( v117971(VarCurr,0)
    <=> v117986(VarCurr,0) ) ).

tff(addAssignment_69006,axiom,
    ! [VarCurr: state_type] :
      ( v117986(VarCurr,0)
    <=> v118174(VarCurr) ) ).

tff(addAssignment_69005,axiom,
    ! [VarCurr: state_type] :
      ( v117986(VarCurr,1)
    <=> v118169(VarCurr) ) ).

tff(addAssignment_69004,axiom,
    ! [VarCurr: state_type] :
      ( v117986(VarCurr,2)
    <=> v117988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13351,axiom,
    ! [VarCurr: state_type] :
      ( v118174(VarCurr)
    <=> ( v118175(VarCurr)
        & v118178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13350,axiom,
    ! [VarCurr: state_type] :
      ( v118178(VarCurr)
    <=> ( v117994(VarCurr,0)
        | v118155(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13349,axiom,
    ! [VarCurr: state_type] :
      ( v118175(VarCurr)
    <=> ( v118176(VarCurr)
        | v118177(VarCurr) ) ) ).

tff(writeUnaryOperator_7272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118177(VarCurr)
    <=> v118155(VarCurr,0) ) ).

tff(writeUnaryOperator_7271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118176(VarCurr)
    <=> v117994(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13348,axiom,
    ! [VarCurr: state_type] :
      ( v118169(VarCurr)
    <=> ( v118170(VarCurr)
        & v118173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13347,axiom,
    ! [VarCurr: state_type] :
      ( v118173(VarCurr)
    <=> ( v117993(VarCurr)
        | v118156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13346,axiom,
    ! [VarCurr: state_type] :
      ( v118170(VarCurr)
    <=> ( v118171(VarCurr)
        | v118172(VarCurr) ) ) ).

tff(writeUnaryOperator_7270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118172(VarCurr)
    <=> v118156(VarCurr) ) ).

tff(writeUnaryOperator_7269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118171(VarCurr)
    <=> v117993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13345,axiom,
    ! [VarCurr: state_type] :
      ( v117988(VarCurr)
    <=> ( v117989(VarCurr)
        & v118168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13344,axiom,
    ! [VarCurr: state_type] :
      ( v118168(VarCurr)
    <=> ( v117991(VarCurr)
        | v118163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13343,axiom,
    ! [VarCurr: state_type] :
      ( v117989(VarCurr)
    <=> ( v117990(VarCurr)
        | v118162(VarCurr) ) ) ).

tff(writeUnaryOperator_7268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118162(VarCurr)
    <=> v118163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13342,axiom,
    ! [VarCurr: state_type] :
      ( v118163(VarCurr)
    <=> ( v118164(VarCurr)
        & v118167(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5079,axiom,
    ! [VarCurr: state_type] :
      ( v118167(VarCurr)
    <=> ( v117994(VarCurr,2)
        | v118155(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13341,axiom,
    ! [VarCurr: state_type] :
      ( v118164(VarCurr)
    <=> ( v118165(VarCurr)
        | v118166(VarCurr) ) ) ).

tff(writeUnaryOperator_7267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118166(VarCurr)
    <=> v118155(VarCurr,2) ) ).

tff(writeUnaryOperator_7266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118165(VarCurr)
    <=> v117994(VarCurr,2) ) ).

tff(writeUnaryOperator_7265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117990(VarCurr)
    <=> v117991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13340,axiom,
    ! [VarCurr: state_type] :
      ( v117991(VarCurr)
    <=> ( v117992(VarCurr)
        | v118161(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5078,axiom,
    ! [VarCurr: state_type] :
      ( v118161(VarCurr)
    <=> ( v117994(VarCurr,1)
        & v118155(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13339,axiom,
    ! [VarCurr: state_type] :
      ( v117992(VarCurr)
    <=> ( v117993(VarCurr)
        & v118156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13338,axiom,
    ! [VarCurr: state_type] :
      ( v118156(VarCurr)
    <=> ( v118157(VarCurr)
        & v118160(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5077,axiom,
    ! [VarCurr: state_type] :
      ( v118160(VarCurr)
    <=> ( v117994(VarCurr,1)
        | v118155(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13337,axiom,
    ! [VarCurr: state_type] :
      ( v118157(VarCurr)
    <=> ( v118158(VarCurr)
        | v118159(VarCurr) ) ) ).

tff(writeUnaryOperator_7264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118159(VarCurr)
    <=> v118155(VarCurr,1) ) ).

tff(writeUnaryOperator_7263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118158(VarCurr)
    <=> v117994(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13336,axiom,
    ! [VarCurr: state_type] :
      ( v117993(VarCurr)
    <=> ( v117994(VarCurr,0)
        & v118155(VarCurr,0) ) ) ).

tff(addAssignment_69003,axiom,
    ! [VarCurr: state_type] :
      ( v118155(VarCurr,0)
    <=> v117985(VarCurr) ) ).

tff(addAssignment_69002,axiom,
    ! [VarCurr: state_type] :
      ( ( v118155(VarCurr,2)
      <=> $false )
      & ( v118155(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_69001,axiom,
    ! [VarCurr: state_type] :
      ( v117994(VarCurr,0)
    <=> v118150(VarCurr) ) ).

tff(addAssignment_69000,axiom,
    ! [VarCurr: state_type] :
      ( v117994(VarCurr,1)
    <=> v118145(VarCurr) ) ).

tff(addAssignment_68999,axiom,
    ! [VarCurr: state_type] :
      ( v117994(VarCurr,2)
    <=> v117996(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13335,axiom,
    ! [VarCurr: state_type] :
      ( v118150(VarCurr)
    <=> ( v118151(VarCurr)
        & v118154(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13334,axiom,
    ! [VarCurr: state_type] :
      ( v118154(VarCurr)
    <=> ( v118002(VarCurr,0)
        | v118131(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13333,axiom,
    ! [VarCurr: state_type] :
      ( v118151(VarCurr)
    <=> ( v118152(VarCurr)
        | v118153(VarCurr) ) ) ).

tff(writeUnaryOperator_7262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118153(VarCurr)
    <=> v118131(VarCurr,0) ) ).

tff(writeUnaryOperator_7261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118152(VarCurr)
    <=> v118002(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13332,axiom,
    ! [VarCurr: state_type] :
      ( v118145(VarCurr)
    <=> ( v118146(VarCurr)
        & v118149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13331,axiom,
    ! [VarCurr: state_type] :
      ( v118149(VarCurr)
    <=> ( v118001(VarCurr)
        | v118132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13330,axiom,
    ! [VarCurr: state_type] :
      ( v118146(VarCurr)
    <=> ( v118147(VarCurr)
        | v118148(VarCurr) ) ) ).

tff(writeUnaryOperator_7260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118148(VarCurr)
    <=> v118132(VarCurr) ) ).

tff(writeUnaryOperator_7259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118147(VarCurr)
    <=> v118001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13329,axiom,
    ! [VarCurr: state_type] :
      ( v117996(VarCurr)
    <=> ( v117997(VarCurr)
        & v118144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13328,axiom,
    ! [VarCurr: state_type] :
      ( v118144(VarCurr)
    <=> ( v117999(VarCurr)
        | v118139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13327,axiom,
    ! [VarCurr: state_type] :
      ( v117997(VarCurr)
    <=> ( v117998(VarCurr)
        | v118138(VarCurr) ) ) ).

tff(writeUnaryOperator_7258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118138(VarCurr)
    <=> v118139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13326,axiom,
    ! [VarCurr: state_type] :
      ( v118139(VarCurr)
    <=> ( v118140(VarCurr)
        & v118143(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5076,axiom,
    ! [VarCurr: state_type] :
      ( v118143(VarCurr)
    <=> ( v118002(VarCurr,2)
        | v118131(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13325,axiom,
    ! [VarCurr: state_type] :
      ( v118140(VarCurr)
    <=> ( v118141(VarCurr)
        | v118142(VarCurr) ) ) ).

tff(writeUnaryOperator_7257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118142(VarCurr)
    <=> v118131(VarCurr,2) ) ).

tff(writeUnaryOperator_7256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118141(VarCurr)
    <=> v118002(VarCurr,2) ) ).

tff(writeUnaryOperator_7255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117998(VarCurr)
    <=> v117999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13324,axiom,
    ! [VarCurr: state_type] :
      ( v117999(VarCurr)
    <=> ( v118000(VarCurr)
        | v118137(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5075,axiom,
    ! [VarCurr: state_type] :
      ( v118137(VarCurr)
    <=> ( v118002(VarCurr,1)
        & v118131(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13323,axiom,
    ! [VarCurr: state_type] :
      ( v118000(VarCurr)
    <=> ( v118001(VarCurr)
        & v118132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13322,axiom,
    ! [VarCurr: state_type] :
      ( v118132(VarCurr)
    <=> ( v118133(VarCurr)
        & v118136(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5074,axiom,
    ! [VarCurr: state_type] :
      ( v118136(VarCurr)
    <=> ( v118002(VarCurr,1)
        | v118131(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13321,axiom,
    ! [VarCurr: state_type] :
      ( v118133(VarCurr)
    <=> ( v118134(VarCurr)
        | v118135(VarCurr) ) ) ).

tff(writeUnaryOperator_7254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118135(VarCurr)
    <=> v118131(VarCurr,1) ) ).

tff(writeUnaryOperator_7253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118134(VarCurr)
    <=> v118002(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13320,axiom,
    ! [VarCurr: state_type] :
      ( v118001(VarCurr)
    <=> ( v118002(VarCurr,0)
        & v118131(VarCurr,0) ) ) ).

tff(addAssignment_68998,axiom,
    ! [VarCurr: state_type] :
      ( v118131(VarCurr,0)
    <=> v117983(VarCurr) ) ).

tff(addAssignment_68997,axiom,
    ! [VarCurr: state_type] :
      ( ( v118131(VarCurr,2)
      <=> $false )
      & ( v118131(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68996,axiom,
    ! [VarCurr: state_type] :
      ( v118002(VarCurr,0)
    <=> v118126(VarCurr) ) ).

tff(addAssignment_68995,axiom,
    ! [VarCurr: state_type] :
      ( v118002(VarCurr,1)
    <=> v118121(VarCurr) ) ).

tff(addAssignment_68994,axiom,
    ! [VarCurr: state_type] :
      ( v118002(VarCurr,2)
    <=> v118004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13319,axiom,
    ! [VarCurr: state_type] :
      ( v118126(VarCurr)
    <=> ( v118127(VarCurr)
        & v118130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13318,axiom,
    ! [VarCurr: state_type] :
      ( v118130(VarCurr)
    <=> ( v118010(VarCurr,0)
        | v118107(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13317,axiom,
    ! [VarCurr: state_type] :
      ( v118127(VarCurr)
    <=> ( v118128(VarCurr)
        | v118129(VarCurr) ) ) ).

tff(writeUnaryOperator_7252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118129(VarCurr)
    <=> v118107(VarCurr,0) ) ).

tff(writeUnaryOperator_7251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118128(VarCurr)
    <=> v118010(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13316,axiom,
    ! [VarCurr: state_type] :
      ( v118121(VarCurr)
    <=> ( v118122(VarCurr)
        & v118125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13315,axiom,
    ! [VarCurr: state_type] :
      ( v118125(VarCurr)
    <=> ( v118009(VarCurr)
        | v118108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13314,axiom,
    ! [VarCurr: state_type] :
      ( v118122(VarCurr)
    <=> ( v118123(VarCurr)
        | v118124(VarCurr) ) ) ).

tff(writeUnaryOperator_7250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118124(VarCurr)
    <=> v118108(VarCurr) ) ).

tff(writeUnaryOperator_7249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118123(VarCurr)
    <=> v118009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13313,axiom,
    ! [VarCurr: state_type] :
      ( v118004(VarCurr)
    <=> ( v118005(VarCurr)
        & v118120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13312,axiom,
    ! [VarCurr: state_type] :
      ( v118120(VarCurr)
    <=> ( v118007(VarCurr)
        | v118115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13311,axiom,
    ! [VarCurr: state_type] :
      ( v118005(VarCurr)
    <=> ( v118006(VarCurr)
        | v118114(VarCurr) ) ) ).

tff(writeUnaryOperator_7248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118114(VarCurr)
    <=> v118115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13310,axiom,
    ! [VarCurr: state_type] :
      ( v118115(VarCurr)
    <=> ( v118116(VarCurr)
        & v118119(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5073,axiom,
    ! [VarCurr: state_type] :
      ( v118119(VarCurr)
    <=> ( v118010(VarCurr,2)
        | v118107(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13309,axiom,
    ! [VarCurr: state_type] :
      ( v118116(VarCurr)
    <=> ( v118117(VarCurr)
        | v118118(VarCurr) ) ) ).

tff(writeUnaryOperator_7247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118118(VarCurr)
    <=> v118107(VarCurr,2) ) ).

tff(writeUnaryOperator_7246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118117(VarCurr)
    <=> v118010(VarCurr,2) ) ).

tff(writeUnaryOperator_7245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118006(VarCurr)
    <=> v118007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13308,axiom,
    ! [VarCurr: state_type] :
      ( v118007(VarCurr)
    <=> ( v118008(VarCurr)
        | v118113(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5072,axiom,
    ! [VarCurr: state_type] :
      ( v118113(VarCurr)
    <=> ( v118010(VarCurr,1)
        & v118107(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13307,axiom,
    ! [VarCurr: state_type] :
      ( v118008(VarCurr)
    <=> ( v118009(VarCurr)
        & v118108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13306,axiom,
    ! [VarCurr: state_type] :
      ( v118108(VarCurr)
    <=> ( v118109(VarCurr)
        & v118112(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5071,axiom,
    ! [VarCurr: state_type] :
      ( v118112(VarCurr)
    <=> ( v118010(VarCurr,1)
        | v118107(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13305,axiom,
    ! [VarCurr: state_type] :
      ( v118109(VarCurr)
    <=> ( v118110(VarCurr)
        | v118111(VarCurr) ) ) ).

tff(writeUnaryOperator_7244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118111(VarCurr)
    <=> v118107(VarCurr,1) ) ).

tff(writeUnaryOperator_7243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118110(VarCurr)
    <=> v118010(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13304,axiom,
    ! [VarCurr: state_type] :
      ( v118009(VarCurr)
    <=> ( v118010(VarCurr,0)
        & v118107(VarCurr,0) ) ) ).

tff(addAssignment_68993,axiom,
    ! [VarCurr: state_type] :
      ( v118107(VarCurr,0)
    <=> v117981(VarCurr) ) ).

tff(addAssignment_68992,axiom,
    ! [VarCurr: state_type] :
      ( ( v118107(VarCurr,2)
      <=> $false )
      & ( v118107(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68991,axiom,
    ! [VarCurr: state_type] :
      ( v118010(VarCurr,0)
    <=> v118102(VarCurr) ) ).

tff(addAssignment_68990,axiom,
    ! [VarCurr: state_type] :
      ( v118010(VarCurr,1)
    <=> v118097(VarCurr) ) ).

tff(addAssignment_68989,axiom,
    ! [VarCurr: state_type] :
      ( v118010(VarCurr,2)
    <=> v118012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13303,axiom,
    ! [VarCurr: state_type] :
      ( v118102(VarCurr)
    <=> ( v118103(VarCurr)
        & v118106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13302,axiom,
    ! [VarCurr: state_type] :
      ( v118106(VarCurr)
    <=> ( v118018(VarCurr,0)
        | v118083(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13301,axiom,
    ! [VarCurr: state_type] :
      ( v118103(VarCurr)
    <=> ( v118104(VarCurr)
        | v118105(VarCurr) ) ) ).

tff(writeUnaryOperator_7242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118105(VarCurr)
    <=> v118083(VarCurr,0) ) ).

tff(writeUnaryOperator_7241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118104(VarCurr)
    <=> v118018(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13300,axiom,
    ! [VarCurr: state_type] :
      ( v118097(VarCurr)
    <=> ( v118098(VarCurr)
        & v118101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13299,axiom,
    ! [VarCurr: state_type] :
      ( v118101(VarCurr)
    <=> ( v118017(VarCurr)
        | v118084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13298,axiom,
    ! [VarCurr: state_type] :
      ( v118098(VarCurr)
    <=> ( v118099(VarCurr)
        | v118100(VarCurr) ) ) ).

tff(writeUnaryOperator_7240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118100(VarCurr)
    <=> v118084(VarCurr) ) ).

tff(writeUnaryOperator_7239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118099(VarCurr)
    <=> v118017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13297,axiom,
    ! [VarCurr: state_type] :
      ( v118012(VarCurr)
    <=> ( v118013(VarCurr)
        & v118096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13296,axiom,
    ! [VarCurr: state_type] :
      ( v118096(VarCurr)
    <=> ( v118015(VarCurr)
        | v118091(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13295,axiom,
    ! [VarCurr: state_type] :
      ( v118013(VarCurr)
    <=> ( v118014(VarCurr)
        | v118090(VarCurr) ) ) ).

tff(writeUnaryOperator_7238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118090(VarCurr)
    <=> v118091(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13294,axiom,
    ! [VarCurr: state_type] :
      ( v118091(VarCurr)
    <=> ( v118092(VarCurr)
        & v118095(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5070,axiom,
    ! [VarCurr: state_type] :
      ( v118095(VarCurr)
    <=> ( v118018(VarCurr,2)
        | v118083(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13293,axiom,
    ! [VarCurr: state_type] :
      ( v118092(VarCurr)
    <=> ( v118093(VarCurr)
        | v118094(VarCurr) ) ) ).

tff(writeUnaryOperator_7237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118094(VarCurr)
    <=> v118083(VarCurr,2) ) ).

tff(writeUnaryOperator_7236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118093(VarCurr)
    <=> v118018(VarCurr,2) ) ).

tff(writeUnaryOperator_7235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118014(VarCurr)
    <=> v118015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13292,axiom,
    ! [VarCurr: state_type] :
      ( v118015(VarCurr)
    <=> ( v118016(VarCurr)
        | v118089(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5069,axiom,
    ! [VarCurr: state_type] :
      ( v118089(VarCurr)
    <=> ( v118018(VarCurr,1)
        & v118083(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13291,axiom,
    ! [VarCurr: state_type] :
      ( v118016(VarCurr)
    <=> ( v118017(VarCurr)
        & v118084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13290,axiom,
    ! [VarCurr: state_type] :
      ( v118084(VarCurr)
    <=> ( v118085(VarCurr)
        & v118088(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5068,axiom,
    ! [VarCurr: state_type] :
      ( v118088(VarCurr)
    <=> ( v118018(VarCurr,1)
        | v118083(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13289,axiom,
    ! [VarCurr: state_type] :
      ( v118085(VarCurr)
    <=> ( v118086(VarCurr)
        | v118087(VarCurr) ) ) ).

tff(writeUnaryOperator_7234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118087(VarCurr)
    <=> v118083(VarCurr,1) ) ).

tff(writeUnaryOperator_7233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118086(VarCurr)
    <=> v118018(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13288,axiom,
    ! [VarCurr: state_type] :
      ( v118017(VarCurr)
    <=> ( v118018(VarCurr,0)
        & v118083(VarCurr,0) ) ) ).

tff(addAssignment_68988,axiom,
    ! [VarCurr: state_type] :
      ( v118083(VarCurr,0)
    <=> v117979(VarCurr) ) ).

tff(addAssignment_68987,axiom,
    ! [VarCurr: state_type] :
      ( ( v118083(VarCurr,2)
      <=> $false )
      & ( v118083(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68986,axiom,
    ! [VarCurr: state_type] :
      ( v118018(VarCurr,0)
    <=> v118078(VarCurr) ) ).

tff(addAssignment_68985,axiom,
    ! [VarCurr: state_type] :
      ( v118018(VarCurr,1)
    <=> v118073(VarCurr) ) ).

tff(addAssignment_68984,axiom,
    ! [VarCurr: state_type] :
      ( v118018(VarCurr,2)
    <=> v118020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13287,axiom,
    ! [VarCurr: state_type] :
      ( v118078(VarCurr)
    <=> ( v118079(VarCurr)
        & v118082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13286,axiom,
    ! [VarCurr: state_type] :
      ( v118082(VarCurr)
    <=> ( v118026(VarCurr,0)
        | v118059(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13285,axiom,
    ! [VarCurr: state_type] :
      ( v118079(VarCurr)
    <=> ( v118080(VarCurr)
        | v118081(VarCurr) ) ) ).

tff(writeUnaryOperator_7232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118081(VarCurr)
    <=> v118059(VarCurr,0) ) ).

tff(writeUnaryOperator_7231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118080(VarCurr)
    <=> v118026(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13284,axiom,
    ! [VarCurr: state_type] :
      ( v118073(VarCurr)
    <=> ( v118074(VarCurr)
        & v118077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13283,axiom,
    ! [VarCurr: state_type] :
      ( v118077(VarCurr)
    <=> ( v118025(VarCurr)
        | v118060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13282,axiom,
    ! [VarCurr: state_type] :
      ( v118074(VarCurr)
    <=> ( v118075(VarCurr)
        | v118076(VarCurr) ) ) ).

tff(writeUnaryOperator_7230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118076(VarCurr)
    <=> v118060(VarCurr) ) ).

tff(writeUnaryOperator_7229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118075(VarCurr)
    <=> v118025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13281,axiom,
    ! [VarCurr: state_type] :
      ( v118020(VarCurr)
    <=> ( v118021(VarCurr)
        & v118072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13280,axiom,
    ! [VarCurr: state_type] :
      ( v118072(VarCurr)
    <=> ( v118023(VarCurr)
        | v118067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13279,axiom,
    ! [VarCurr: state_type] :
      ( v118021(VarCurr)
    <=> ( v118022(VarCurr)
        | v118066(VarCurr) ) ) ).

tff(writeUnaryOperator_7228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118066(VarCurr)
    <=> v118067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13278,axiom,
    ! [VarCurr: state_type] :
      ( v118067(VarCurr)
    <=> ( v118068(VarCurr)
        & v118071(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5067,axiom,
    ! [VarCurr: state_type] :
      ( v118071(VarCurr)
    <=> ( v118026(VarCurr,2)
        | v118059(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13277,axiom,
    ! [VarCurr: state_type] :
      ( v118068(VarCurr)
    <=> ( v118069(VarCurr)
        | v118070(VarCurr) ) ) ).

tff(writeUnaryOperator_7227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118070(VarCurr)
    <=> v118059(VarCurr,2) ) ).

tff(writeUnaryOperator_7226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118069(VarCurr)
    <=> v118026(VarCurr,2) ) ).

tff(writeUnaryOperator_7225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118022(VarCurr)
    <=> v118023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13276,axiom,
    ! [VarCurr: state_type] :
      ( v118023(VarCurr)
    <=> ( v118024(VarCurr)
        | v118065(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5066,axiom,
    ! [VarCurr: state_type] :
      ( v118065(VarCurr)
    <=> ( v118026(VarCurr,1)
        & v118059(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13275,axiom,
    ! [VarCurr: state_type] :
      ( v118024(VarCurr)
    <=> ( v118025(VarCurr)
        & v118060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13274,axiom,
    ! [VarCurr: state_type] :
      ( v118060(VarCurr)
    <=> ( v118061(VarCurr)
        & v118064(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5065,axiom,
    ! [VarCurr: state_type] :
      ( v118064(VarCurr)
    <=> ( v118026(VarCurr,1)
        | v118059(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13273,axiom,
    ! [VarCurr: state_type] :
      ( v118061(VarCurr)
    <=> ( v118062(VarCurr)
        | v118063(VarCurr) ) ) ).

tff(writeUnaryOperator_7224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118063(VarCurr)
    <=> v118059(VarCurr,1) ) ).

tff(writeUnaryOperator_7223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118062(VarCurr)
    <=> v118026(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13272,axiom,
    ! [VarCurr: state_type] :
      ( v118025(VarCurr)
    <=> ( v118026(VarCurr,0)
        & v118059(VarCurr,0) ) ) ).

tff(addAssignment_68983,axiom,
    ! [VarCurr: state_type] :
      ( v118059(VarCurr,0)
    <=> v117977(VarCurr) ) ).

tff(addAssignment_68982,axiom,
    ! [VarCurr: state_type] :
      ( ( v118059(VarCurr,2)
      <=> $false )
      & ( v118059(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68981,axiom,
    ! [VarCurr: state_type] :
      ( v118026(VarCurr,0)
    <=> v118054(VarCurr) ) ).

tff(addAssignment_68980,axiom,
    ! [VarCurr: state_type] :
      ( v118026(VarCurr,1)
    <=> v118049(VarCurr) ) ).

tff(addAssignment_68979,axiom,
    ! [VarCurr: state_type] :
      ( v118026(VarCurr,2)
    <=> v118028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13271,axiom,
    ! [VarCurr: state_type] :
      ( v118054(VarCurr)
    <=> ( v118055(VarCurr)
        & v118058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13270,axiom,
    ! [VarCurr: state_type] :
      ( v118058(VarCurr)
    <=> ( v118034(VarCurr,0)
        | v118035(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13269,axiom,
    ! [VarCurr: state_type] :
      ( v118055(VarCurr)
    <=> ( v118056(VarCurr)
        | v118057(VarCurr) ) ) ).

tff(writeUnaryOperator_7222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118057(VarCurr)
    <=> v118035(VarCurr,0) ) ).

tff(writeUnaryOperator_7221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118056(VarCurr)
    <=> v118034(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13268,axiom,
    ! [VarCurr: state_type] :
      ( v118049(VarCurr)
    <=> ( v118050(VarCurr)
        & v118053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13267,axiom,
    ! [VarCurr: state_type] :
      ( v118053(VarCurr)
    <=> ( v118033(VarCurr)
        | v118036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13266,axiom,
    ! [VarCurr: state_type] :
      ( v118050(VarCurr)
    <=> ( v118051(VarCurr)
        | v118052(VarCurr) ) ) ).

tff(writeUnaryOperator_7220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118052(VarCurr)
    <=> v118036(VarCurr) ) ).

tff(writeUnaryOperator_7219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118051(VarCurr)
    <=> v118033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13265,axiom,
    ! [VarCurr: state_type] :
      ( v118028(VarCurr)
    <=> ( v118029(VarCurr)
        & v118048(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13264,axiom,
    ! [VarCurr: state_type] :
      ( v118048(VarCurr)
    <=> ( v118031(VarCurr)
        | v118043(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13263,axiom,
    ! [VarCurr: state_type] :
      ( v118029(VarCurr)
    <=> ( v118030(VarCurr)
        | v118042(VarCurr) ) ) ).

tff(writeUnaryOperator_7218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118042(VarCurr)
    <=> v118043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13262,axiom,
    ! [VarCurr: state_type] :
      ( v118043(VarCurr)
    <=> ( v118044(VarCurr)
        & v118047(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5064,axiom,
    ! [VarCurr: state_type] :
      ( v118047(VarCurr)
    <=> ( v118034(VarCurr,2)
        | v118035(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13261,axiom,
    ! [VarCurr: state_type] :
      ( v118044(VarCurr)
    <=> ( v118045(VarCurr)
        | v118046(VarCurr) ) ) ).

tff(writeUnaryOperator_7217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118046(VarCurr)
    <=> v118035(VarCurr,2) ) ).

tff(writeUnaryOperator_7216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118045(VarCurr)
    <=> v118034(VarCurr,2) ) ).

tff(writeUnaryOperator_7215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118030(VarCurr)
    <=> v118031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13260,axiom,
    ! [VarCurr: state_type] :
      ( v118031(VarCurr)
    <=> ( v118032(VarCurr)
        | v118041(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5063,axiom,
    ! [VarCurr: state_type] :
      ( v118041(VarCurr)
    <=> ( v118034(VarCurr,1)
        & v118035(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13259,axiom,
    ! [VarCurr: state_type] :
      ( v118032(VarCurr)
    <=> ( v118033(VarCurr)
        & v118036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13258,axiom,
    ! [VarCurr: state_type] :
      ( v118036(VarCurr)
    <=> ( v118037(VarCurr)
        & v118040(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5062,axiom,
    ! [VarCurr: state_type] :
      ( v118040(VarCurr)
    <=> ( v118034(VarCurr,1)
        | v118035(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13257,axiom,
    ! [VarCurr: state_type] :
      ( v118037(VarCurr)
    <=> ( v118038(VarCurr)
        | v118039(VarCurr) ) ) ).

tff(writeUnaryOperator_7214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118039(VarCurr)
    <=> v118035(VarCurr,1) ) ).

tff(writeUnaryOperator_7213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v118038(VarCurr)
    <=> v118034(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13256,axiom,
    ! [VarCurr: state_type] :
      ( v118033(VarCurr)
    <=> ( v118034(VarCurr,0)
        & v118035(VarCurr,0) ) ) ).

tff(addAssignment_68978,axiom,
    ! [VarCurr: state_type] :
      ( v118035(VarCurr,0)
    <=> v117975(VarCurr) ) ).

tff(addAssignment_68977,axiom,
    ! [VarCurr: state_type] :
      ( ( v118035(VarCurr,2)
      <=> $false )
      & ( v118035(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68976,axiom,
    ! [VarCurr: state_type] :
      ( v118034(VarCurr,0)
    <=> v117973(VarCurr) ) ).

tff(addAssignment_68975,axiom,
    ! [VarCurr: state_type] :
      ( ( v118034(VarCurr,2)
      <=> $false )
      & ( v118034(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68974,axiom,
    ! [VarCurr: state_type] :
      ( v117985(VarCurr)
    <=> v114692(VarCurr,5) ) ).

tff(addAssignment_68973,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,5)
    <=> v114694(VarCurr,5) ) ).

tff(addAssignment_68972,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,5)
    <=> v114696(VarCurr,5) ) ).

tff(addAssignment_68971,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,5)
    <=> v114697(VarCurr,5) ) ).

tff(addAssignment_68970,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,5)
    <=> v113918(VarCurr,5) ) ).

tff(addAssignment_68969,axiom,
    ! [VarCurr: state_type] :
      ( v117983(VarCurr)
    <=> v114685(VarCurr,5) ) ).

tff(addAssignment_68968,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,5)
    <=> v114686(VarCurr,5) ) ).

tff(addAssignment_68967,axiom,
    ! [VarCurr: state_type] :
      ( v117981(VarCurr)
    <=> v114661(VarCurr,5) ) ).

tff(addAssignment_68966,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,5)
    <=> v114662(VarCurr,5) ) ).

tff(addAssignment_68965,axiom,
    ! [VarCurr: state_type] :
      ( v117979(VarCurr)
    <=> v114633(VarCurr,5) ) ).

tff(addAssignment_68964,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,5)
    <=> v114635(VarCurr,5) ) ).

tff(addAssignment_68963,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,5)
    <=> v114637(VarCurr,5) ) ).

tff(addAssignment_68962,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,5)
    <=> v114638(VarCurr,5) ) ).

tff(addAssignment_68961,axiom,
    ! [VarCurr: state_type] :
      ( v117977(VarCurr)
    <=> v114605(VarCurr,5) ) ).

tff(addAssignment_68960,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,5)
    <=> v114607(VarCurr,5) ) ).

tff(addAssignment_68959,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,5)
    <=> v114609(VarCurr,5) ) ).

tff(addAssignment_68958,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,5)
    <=> v114610(VarCurr,5) ) ).

tff(addAssignment_68957,axiom,
    ! [VarCurr: state_type] :
      ( v117975(VarCurr)
    <=> v114577(VarCurr,5) ) ).

tff(addAssignment_68956,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,5)
    <=> v114579(VarCurr,5) ) ).

tff(addAssignment_68955,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,5)
    <=> v114581(VarCurr,5) ) ).

tff(addAssignment_68954,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,5)
    <=> v114582(VarCurr,5) ) ).

tff(addAssignment_68953,axiom,
    ! [VarCurr: state_type] :
      ( v117973(VarCurr)
    <=> v114549(VarCurr,5) ) ).

tff(addAssignment_68952,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,5)
    <=> v114551(VarCurr,5) ) ).

tff(addAssignment_68951,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,5)
    <=> v114553(VarCurr,5) ) ).

tff(addAssignment_68950,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,5)
    <=> v114554(VarCurr,5) ) ).

tff(addAssignment_68949,axiom,
    ! [VarCurr: state_type] :
      ( v117959(VarCurr)
    <=> v117961(VarCurr) ) ).

tff(addAssignment_68948,axiom,
    ! [VarCurr: state_type] :
      ( v117961(VarCurr)
    <=> v117935(VarCurr) ) ).

tff(addAssignment_68947,axiom,
    ! [VarCurr: state_type] :
      ( v117955(VarCurr)
    <=> v117957(VarCurr) ) ).

tff(addAssignment_68946,axiom,
    ! [VarCurr: state_type] :
      ( v117957(VarCurr)
    <=> v117927(VarCurr) ) ).

tff(addAssignment_68945,axiom,
    ! [VarCurr: state_type] :
      ( v117931(VarCurr)
    <=> v117933(VarCurr) ) ).

tff(addAssignment_68944,axiom,
    ! [VarCurr: state_type] :
      ( v117933(VarCurr)
    <=> v117935(VarCurr) ) ).

tff(addAssignment_68943,axiom,
    ! [VarCurr: state_type] :
      ( v117935(VarCurr)
    <=> v117937(VarCurr) ) ).

tff(addAssignment_68942,axiom,
    ! [VarCurr: state_type] :
      ( v117937(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_68941,axiom,
    ! [VarCurr: state_type] :
      ( v117923(VarCurr)
    <=> v117925(VarCurr) ) ).

tff(addAssignment_68940,axiom,
    ! [VarCurr: state_type] :
      ( v117925(VarCurr)
    <=> v117927(VarCurr) ) ).

tff(addAssignment_68939,axiom,
    ! [VarCurr: state_type] :
      ( v117927(VarCurr)
    <=> v117929(VarCurr) ) ).

tff(addAssignment_68938,axiom,
    ! [VarCurr: state_type] :
      ( v117929(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13255,axiom,
    ! [VarCurr: state_type] :
      ( v117114(VarCurr)
    <=> ( v117913(VarCurr)
        & v117823(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5061,axiom,
    ! [VarCurr: state_type] :
      ( v117913(VarCurr)
    <=> ( v117116(VarCurr,1)
        & v117762(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1172,axiom,
    ! [VarCurr: state_type] :
      ( v117823(VarCurr)
    <=> ( ( v117825(VarCurr,4)
        <=> $false )
        & ( v117825(VarCurr,3)
        <=> $false )
        & ( v117825(VarCurr,2)
        <=> $false )
        & ( v117825(VarCurr,1)
        <=> $false )
        & ( v117825(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117825(VarCurr,B)
      <=> v117827(VarCurr,B) ) ) ).

tff(addAssignment_68936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117827(VarCurr,B)
      <=> v117829(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117895(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v117829(VarNext,B)
            <=> v117829(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1533,axiom,
    ! [VarNext: state_type] :
      ( v117895(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117829(VarNext,B)
          <=> v117905(VarNext,B) ) ) ) ).

tff(addAssignment_68935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117905(VarNext,B)
          <=> v117903(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117906(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117903(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1078,axiom,
    ! [VarCurr: state_type] :
      ( v117906(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117903(VarCurr,B)
          <=> v117839(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13254,axiom,
    ! [VarCurr: state_type] :
      ( v117906(VarCurr)
    <=> ( v117907(VarCurr)
        & v117908(VarCurr) ) ) ).

tff(writeUnaryOperator_7212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117908(VarCurr)
    <=> v117835(VarCurr) ) ).

tff(writeUnaryOperator_7211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117907(VarCurr)
    <=> v117831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117895(VarNext)
      <=> v117896(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117896(VarNext)
      <=> ( v117897(VarNext)
          & v117890(VarNext) ) ) ) ).

tff(writeUnaryOperator_7210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117897(VarNext)
      <=> v117899(VarNext) ) ) ).

tff(addAssignment_68934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117899(VarNext)
      <=> v117890(VarCurr) ) ) ).

tff(addAssignment_68933,axiom,
    ! [VarCurr: state_type] :
      ( v117890(VarCurr)
    <=> v117892(VarCurr) ) ).

tff(addAssignment_68932,axiom,
    ! [VarCurr: state_type] :
      ( v117892(VarCurr)
    <=> v117596(VarCurr) ) ).

tff(addAssignment_68931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117839(VarCurr,B)
      <=> v117841(VarCurr,B) ) ) ).

tff(addAssignment_68930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117841(VarCurr,B)
      <=> v117843(VarCurr,B) ) ) ).

tff(addAssignment_68929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117843(VarCurr,B)
      <=> v117845(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117845(VarCurr,B)
          <=> v117859(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1077,axiom,
    ! [VarCurr: state_type] :
      ( v117847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117845(VarCurr,B)
          <=> v117852(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117854(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117859(VarCurr,B)
          <=> v117860(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1076,axiom,
    ! [VarCurr: state_type] :
      ( v117854(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117859(VarCurr,B)
          <=> v117857(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117860(VarCurr,B)
          <=> v117861(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1075,axiom,
    ! [VarCurr: state_type] :
      ( v117823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117860(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68928,axiom,
    ! [VarCurr: state_type] :
      ( v117861(VarCurr,0)
    <=> v117887(VarCurr) ) ).

tff(addAssignment_68927,axiom,
    ! [VarCurr: state_type] :
      ( v117861(VarCurr,1)
    <=> v117885(VarCurr) ) ).

tff(addAssignment_68926,axiom,
    ! [VarCurr: state_type] :
      ( v117861(VarCurr,2)
    <=> v117881(VarCurr) ) ).

tff(addAssignment_68925,axiom,
    ! [VarCurr: state_type] :
      ( v117861(VarCurr,3)
    <=> v117877(VarCurr) ) ).

tff(addAssignment_68924,axiom,
    ! [VarCurr: state_type] :
      ( v117861(VarCurr,4)
    <=> v117863(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13251,axiom,
    ! [VarCurr: state_type] :
      ( v117885(VarCurr)
    <=> ( v117886(VarCurr)
        & v117888(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13250,axiom,
    ! [VarCurr: state_type] :
      ( v117888(VarCurr)
    <=> ( v117825(VarCurr,0)
        | v117872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5060,axiom,
    ! [VarCurr: state_type] :
      ( v117886(VarCurr)
    <=> ( v117887(VarCurr)
        | v117825(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117887(VarCurr)
    <=> v117825(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13249,axiom,
    ! [VarCurr: state_type] :
      ( v117881(VarCurr)
    <=> ( v117882(VarCurr)
        & v117884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13248,axiom,
    ! [VarCurr: state_type] :
      ( v117884(VarCurr)
    <=> ( v117870(VarCurr)
        | v117873(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5059,axiom,
    ! [VarCurr: state_type] :
      ( v117882(VarCurr)
    <=> ( v117883(VarCurr)
        | v117825(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117883(VarCurr)
    <=> v117870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13247,axiom,
    ! [VarCurr: state_type] :
      ( v117877(VarCurr)
    <=> ( v117878(VarCurr)
        & v117880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13246,axiom,
    ! [VarCurr: state_type] :
      ( v117880(VarCurr)
    <=> ( v117868(VarCurr)
        | v117874(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5058,axiom,
    ! [VarCurr: state_type] :
      ( v117878(VarCurr)
    <=> ( v117879(VarCurr)
        | v117825(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117879(VarCurr)
    <=> v117868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13245,axiom,
    ! [VarCurr: state_type] :
      ( v117863(VarCurr)
    <=> ( v117864(VarCurr)
        & v117875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13244,axiom,
    ! [VarCurr: state_type] :
      ( v117875(VarCurr)
    <=> ( v117866(VarCurr)
        | v117876(VarCurr) ) ) ).

tff(writeUnaryOperator_7206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117876(VarCurr)
    <=> v117825(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5057,axiom,
    ! [VarCurr: state_type] :
      ( v117864(VarCurr)
    <=> ( v117865(VarCurr)
        | v117825(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117865(VarCurr)
    <=> v117866(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5056,axiom,
    ! [VarCurr: state_type] :
      ( v117866(VarCurr)
    <=> ( v117825(VarCurr,3)
        | v117867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13243,axiom,
    ! [VarCurr: state_type] :
      ( v117867(VarCurr)
    <=> ( v117868(VarCurr)
        & v117874(VarCurr) ) ) ).

tff(writeUnaryOperator_7204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117874(VarCurr)
    <=> v117825(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5055,axiom,
    ! [VarCurr: state_type] :
      ( v117868(VarCurr)
    <=> ( v117825(VarCurr,2)
        | v117869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13242,axiom,
    ! [VarCurr: state_type] :
      ( v117869(VarCurr)
    <=> ( v117870(VarCurr)
        & v117873(VarCurr) ) ) ).

tff(writeUnaryOperator_7203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117873(VarCurr)
    <=> v117825(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5054,axiom,
    ! [VarCurr: state_type] :
      ( v117870(VarCurr)
    <=> ( v117825(VarCurr,1)
        | v117871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13241,axiom,
    ! [VarCurr: state_type] :
      ( v117871(VarCurr)
    <=> ( v117825(VarCurr,0)
        & v117872(VarCurr) ) ) ).

tff(writeUnaryOperator_7202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117872(VarCurr)
    <=> v117825(VarCurr,1) ) ).

tff(addAssignment_68923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117857(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13240,axiom,
    ! [VarCurr: state_type] :
      ( v117854(VarCurr)
    <=> ( v117401(VarCurr)
        | v117415(VarCurr) ) ) ).

tff(addAssignment_68922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117852(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13239,axiom,
    ! [VarCurr: state_type] :
      ( v117847(VarCurr)
    <=> ( v117849(VarCurr)
        | v117413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13238,axiom,
    ! [VarCurr: state_type] :
      ( v117849(VarCurr)
    <=> ( v117850(VarCurr)
        | v117411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13237,axiom,
    ! [VarCurr: state_type] :
      ( v117850(VarCurr)
    <=> ( v117381(VarCurr)
        | v117391(VarCurr) ) ) ).

tff(addAssignment_68921,axiom,
    ! [VarCurr: state_type] :
      ( v117835(VarCurr)
    <=> v117837(VarCurr) ) ).

tff(addAssignment_68920,axiom,
    ! [VarCurr: state_type] :
      ( v117837(VarCurr)
    <=> v117134(VarCurr) ) ).

tff(addAssignment_68919,axiom,
    ! [VarCurr: state_type] :
      ( v117831(VarCurr)
    <=> v117833(VarCurr) ) ).

tff(addAssignment_68918,axiom,
    ! [VarCurr: state_type] :
      ( v117833(VarCurr)
    <=> v117126(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1171,axiom,
    ! [VarCurr: state_type] :
      ( v117762(VarCurr)
    <=> ( ( v117764(VarCurr,1)
        <=> $false )
        & ( v117764(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v117764(VarCurr,B)
      <=> v117766(VarCurr,B) ) ) ).

tff(addAssignment_68916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v117766(VarCurr,B)
      <=> v117768(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117805(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v117768(VarNext,B)
            <=> v117768(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1532,axiom,
    ! [VarNext: state_type] :
      ( v117805(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117768(VarNext,B)
          <=> v117815(VarNext,B) ) ) ) ).

tff(addAssignment_68915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117815(VarNext,B)
          <=> v117813(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117816(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117813(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1074,axiom,
    ! [VarCurr: state_type] :
      ( v117816(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117813(VarCurr,B)
          <=> v117778(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13236,axiom,
    ! [VarCurr: state_type] :
      ( v117816(VarCurr)
    <=> ( v117817(VarCurr)
        & v117818(VarCurr) ) ) ).

tff(writeUnaryOperator_7201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117818(VarCurr)
    <=> v117774(VarCurr) ) ).

tff(writeUnaryOperator_7200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117817(VarCurr)
    <=> v117770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117805(VarNext)
      <=> v117806(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117806(VarNext)
      <=> ( v117807(VarNext)
          & v117800(VarNext) ) ) ) ).

tff(writeUnaryOperator_7199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117807(VarNext)
      <=> v117809(VarNext) ) ) ).

tff(addAssignment_68914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117809(VarNext)
      <=> v117800(VarCurr) ) ) ).

tff(addAssignment_68913,axiom,
    ! [VarCurr: state_type] :
      ( v117800(VarCurr)
    <=> v117802(VarCurr) ) ).

tff(addAssignment_68912,axiom,
    ! [VarCurr: state_type] :
      ( v117802(VarCurr)
    <=> v117596(VarCurr) ) ).

tff(addAssignment_68911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v117778(VarCurr,B)
      <=> v117780(VarCurr,B) ) ) ).

tff(addAssignment_68910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v117780(VarCurr,B)
      <=> v117782(VarCurr,B) ) ) ).

tff(addAssignment_68909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v117782(VarCurr,B)
      <=> v117784(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117786(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117784(VarCurr,B)
          <=> v117791(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1073,axiom,
    ! [VarCurr: state_type] :
      ( v117786(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117784(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117791(VarCurr,B)
          <=> v117792(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1072,axiom,
    ! [VarCurr: state_type] :
      ( v117762(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117791(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68908,axiom,
    ! [VarCurr: state_type] :
      ( v117792(VarCurr,0)
    <=> v117796(VarCurr) ) ).

tff(addAssignment_68907,axiom,
    ! [VarCurr: state_type] :
      ( v117792(VarCurr,1)
    <=> v117794(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13233,axiom,
    ! [VarCurr: state_type] :
      ( v117794(VarCurr)
    <=> ( v117795(VarCurr)
        & v117797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13232,axiom,
    ! [VarCurr: state_type] :
      ( v117797(VarCurr)
    <=> ( v117764(VarCurr,0)
        | v117798(VarCurr) ) ) ).

tff(writeUnaryOperator_7198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117798(VarCurr)
    <=> v117764(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5053,axiom,
    ! [VarCurr: state_type] :
      ( v117795(VarCurr)
    <=> ( v117796(VarCurr)
        | v117764(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117796(VarCurr)
    <=> v117764(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13231,axiom,
    ! [VarCurr: state_type] :
      ( v117786(VarCurr)
    <=> ( v117788(VarCurr)
        | v117789(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5052,axiom,
    ! [VarCurr: state_type] :
      ( v117789(VarCurr)
    <=> ( v117116(VarCurr,1)
        & v117629(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5051,axiom,
    ! [VarCurr: state_type] :
      ( v117788(VarCurr)
    <=> ( v117116(VarCurr,3)
        & v117687(VarCurr) ) ) ).

tff(addAssignment_68906,axiom,
    ! [VarCurr: state_type] :
      ( v117774(VarCurr)
    <=> v117776(VarCurr) ) ).

tff(addAssignment_68905,axiom,
    ! [VarCurr: state_type] :
      ( v117776(VarCurr)
    <=> v117134(VarCurr) ) ).

tff(addAssignment_68904,axiom,
    ! [VarCurr: state_type] :
      ( v117770(VarCurr)
    <=> v117772(VarCurr) ) ).

tff(addAssignment_68903,axiom,
    ! [VarCurr: state_type] :
      ( v117772(VarCurr)
    <=> v117126(VarCurr) ) ).

tff(addAssignment_68902,axiom,
    ! [VarCurr: state_type] :
      ( v117116(VarCurr,1)
    <=> v117118(VarCurr,1) ) ).

tff(addAssignment_68901,axiom,
    ! [VarCurr: state_type] :
      ( v117118(VarCurr,1)
    <=> v117120(VarCurr,1) ) ).

tff(addAssignment_68900,axiom,
    ! [VarNext: state_type] :
      ( v117120(VarNext,1)
    <=> v117754(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117755(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v117754(VarNext,B)
            <=> v117120(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1531,axiom,
    ! [VarNext: state_type] :
      ( v117755(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117754(VarNext,B)
          <=> v117680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117755(VarNext)
      <=> v117756(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117756(VarNext)
      <=> ( v117758(VarNext)
          & v117665(VarNext) ) ) ) ).

tff(writeUnaryOperator_7196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117758(VarNext)
      <=> v117674(VarNext) ) ) ).

tff(addAssignment_68899,axiom,
    ! [VarCurr: state_type] :
      ( v117138(VarCurr,1)
    <=> v117140(VarCurr,1) ) ).

tff(addAssignment_68898,axiom,
    ! [VarCurr: state_type] :
      ( v117140(VarCurr,1)
    <=> v117142(VarCurr,1) ) ).

tff(addAssignment_68897,axiom,
    ! [VarCurr: state_type] :
      ( v117142(VarCurr,1)
    <=> v117663(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_44,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117745(VarCurr)
     => ( v117144(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_73,axiom,
    ! [VarCurr: state_type] :
      ( v117745(VarCurr)
     => ( v117144(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13228,axiom,
    ! [VarCurr: state_type] :
      ( v117745(VarCurr)
    <=> ( v117746(VarCurr)
        | v117747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13227,axiom,
    ! [VarCurr: state_type] :
      ( v117747(VarCurr)
    <=> ( v117748(VarCurr)
        & v117749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13226,axiom,
    ! [VarCurr: state_type] :
      ( v117749(VarCurr)
    <=> ( v117750(VarCurr)
        & v117646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13225,axiom,
    ! [VarCurr: state_type] :
      ( v117750(VarCurr)
    <=> ( v117751(VarCurr)
        & v117752(VarCurr) ) ) ).

tff(writeUnaryOperator_7195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117752(VarCurr)
    <=> v117638(VarCurr) ) ).

tff(writeUnaryOperator_7194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117751(VarCurr)
    <=> v117629(VarCurr) ) ).

tff(writeUnaryOperator_7193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117748(VarCurr)
    <=> v117648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13224,axiom,
    ! [VarCurr: state_type] :
      ( v117746(VarCurr)
    <=> ( v117720(VarCurr)
        & v117648(VarCurr) ) ) ).

tff(writeUnaryOperator_7192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117116(VarCurr,0)
    <=> v117625(VarCurr) ) ).

tff(addAssignment_68896,axiom,
    ! [VarCurr: state_type] :
      ( v117625(VarCurr)
    <=> v117118(VarCurr,0) ) ).

tff(addAssignment_68895,axiom,
    ! [VarCurr: state_type] :
      ( v117118(VarCurr,0)
    <=> v117120(VarCurr,0) ) ).

tff(addAssignment_68894,axiom,
    ! [VarNext: state_type] :
      ( v117120(VarNext,0)
    <=> v117736(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117737(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v117736(VarNext,B)
            <=> v117120(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1530,axiom,
    ! [VarNext: state_type] :
      ( v117737(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117736(VarNext,B)
          <=> v117680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117737(VarNext)
      <=> v117738(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117738(VarNext)
      <=> ( v117740(VarNext)
          & v117665(VarNext) ) ) ) ).

tff(writeUnaryOperator_7191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117740(VarNext)
      <=> v117674(VarNext) ) ) ).

tff(addAssignment_68893,axiom,
    ! [VarCurr: state_type] :
      ( v117138(VarCurr,0)
    <=> v117140(VarCurr,0) ) ).

tff(addAssignment_68892,axiom,
    ! [VarCurr: state_type] :
      ( v117140(VarCurr,0)
    <=> v117142(VarCurr,0) ) ).

tff(addAssignment_68891,axiom,
    ! [VarCurr: state_type] :
      ( v117142(VarCurr,0)
    <=> v117663(VarCurr,0) ) ).

tff(writeUnaryOperator_7190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117627(VarCurr)
    <=> v117144(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117715(VarCurr)
     => ( v117144(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1071,axiom,
    ! [VarCurr: state_type] :
      ( v117715(VarCurr)
     => ( v117144(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13221,axiom,
    ! [VarCurr: state_type] :
      ( v117715(VarCurr)
    <=> ( v117716(VarCurr)
        | v117729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13220,axiom,
    ! [VarCurr: state_type] :
      ( v117729(VarCurr)
    <=> ( v117730(VarCurr)
        & v117733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13219,axiom,
    ! [VarCurr: state_type] :
      ( v117733(VarCurr)
    <=> ( v117701(VarCurr)
        & v117704(VarCurr) ) ) ).

tff(writeUnaryOperator_7189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117730(VarCurr)
    <=> v117731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13218,axiom,
    ! [VarCurr: state_type] :
      ( v117731(VarCurr)
    <=> ( v117732(VarCurr)
        | v117661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13217,axiom,
    ! [VarCurr: state_type] :
      ( v117732(VarCurr)
    <=> ( v117648(VarCurr)
        | v117646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13216,axiom,
    ! [VarCurr: state_type] :
      ( v117716(VarCurr)
    <=> ( v117717(VarCurr)
        | v117725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13215,axiom,
    ! [VarCurr: state_type] :
      ( v117725(VarCurr)
    <=> ( v117726(VarCurr)
        & v117728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13214,axiom,
    ! [VarCurr: state_type] :
      ( v117728(VarCurr)
    <=> ( v117659(VarCurr)
        & v117661(VarCurr) ) ) ).

tff(writeUnaryOperator_7188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117726(VarCurr)
    <=> v117727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13213,axiom,
    ! [VarCurr: state_type] :
      ( v117727(VarCurr)
    <=> ( v117648(VarCurr)
        | v117646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13212,axiom,
    ! [VarCurr: state_type] :
      ( v117717(VarCurr)
    <=> ( v117718(VarCurr)
        | v117722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13211,axiom,
    ! [VarCurr: state_type] :
      ( v117722(VarCurr)
    <=> ( v117723(VarCurr)
        & v117724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13210,axiom,
    ! [VarCurr: state_type] :
      ( v117724(VarCurr)
    <=> ( v117638(VarCurr)
        & v117646(VarCurr) ) ) ).

tff(writeUnaryOperator_7187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117723(VarCurr)
    <=> v117648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13209,axiom,
    ! [VarCurr: state_type] :
      ( v117718(VarCurr)
    <=> ( v117719(VarCurr)
        & v117648(VarCurr) ) ) ).

tff(writeUnaryOperator_7186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117719(VarCurr)
    <=> v117720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13208,axiom,
    ! [VarCurr: state_type] :
      ( v117720(VarCurr)
    <=> ( v117721(VarCurr)
        & v117623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13207,axiom,
    ! [VarCurr: state_type] :
      ( v117721(VarCurr)
    <=> ( v117146(VarCurr)
        & v117621(VarCurr) ) ) ).

tff(addAssignment_68890,axiom,
    ! [VarCurr: state_type] :
      ( v117116(VarCurr,3)
    <=> v117118(VarCurr,3) ) ).

tff(addAssignment_68889,axiom,
    ! [VarCurr: state_type] :
      ( v117118(VarCurr,3)
    <=> v117120(VarCurr,3) ) ).

tff(addAssignment_68888,axiom,
    ! [VarNext: state_type] :
      ( v117120(VarNext,3)
    <=> v117707(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117708(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v117707(VarNext,B)
            <=> v117120(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1529,axiom,
    ! [VarNext: state_type] :
      ( v117708(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117707(VarNext,B)
          <=> v117680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117708(VarNext)
      <=> v117709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117709(VarNext)
      <=> ( v117711(VarNext)
          & v117665(VarNext) ) ) ) ).

tff(writeUnaryOperator_7185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117711(VarNext)
      <=> v117674(VarNext) ) ) ).

tff(addAssignment_68887,axiom,
    ! [VarCurr: state_type] :
      ( v117138(VarCurr,3)
    <=> v117140(VarCurr,3) ) ).

tff(addAssignment_68886,axiom,
    ! [VarCurr: state_type] :
      ( v117140(VarCurr,3)
    <=> v117142(VarCurr,3) ) ).

tff(addAssignment_68885,axiom,
    ! [VarCurr: state_type] :
      ( v117142(VarCurr,3)
    <=> v117663(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_43,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117689(VarCurr)
     => ( v117144(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_72,axiom,
    ! [VarCurr: state_type] :
      ( v117689(VarCurr)
     => ( v117144(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13204,axiom,
    ! [VarCurr: state_type] :
      ( v117689(VarCurr)
    <=> ( v117690(VarCurr)
        | v117696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13203,axiom,
    ! [VarCurr: state_type] :
      ( v117696(VarCurr)
    <=> ( v117697(VarCurr)
        & v117698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13202,axiom,
    ! [VarCurr: state_type] :
      ( v117698(VarCurr)
    <=> ( v117699(VarCurr)
        & v117705(VarCurr) ) ) ).

tff(writeUnaryOperator_7184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117705(VarCurr)
    <=> v117695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13201,axiom,
    ! [VarCurr: state_type] :
      ( v117699(VarCurr)
    <=> ( v117700(VarCurr)
        & v117704(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1170,axiom,
    ! [VarCurr: state_type] :
      ( v117704(VarCurr)
    <=> ( $true
      <=> v117116(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117700(VarCurr)
    <=> v117701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13200,axiom,
    ! [VarCurr: state_type] :
      ( v117701(VarCurr)
    <=> ( v117702(VarCurr)
        | v117631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13199,axiom,
    ! [VarCurr: state_type] :
      ( v117702(VarCurr)
    <=> ( v117703(VarCurr)
        | v117687(VarCurr) ) ) ).

tff(writeUnaryOperator_7182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117703(VarCurr)
    <=> v117621(VarCurr) ) ).

tff(writeUnaryOperator_7181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117697(VarCurr)
    <=> v117661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13198,axiom,
    ! [VarCurr: state_type] :
      ( v117690(VarCurr)
    <=> ( v117691(VarCurr)
        & v117694(VarCurr) ) ) ).

tff(writeUnaryOperator_7180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117694(VarCurr)
    <=> v117695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13197,axiom,
    ! [VarCurr: state_type] :
      ( v117695(VarCurr)
    <=> ( v117648(VarCurr)
        | v117646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13196,axiom,
    ! [VarCurr: state_type] :
      ( v117691(VarCurr)
    <=> ( v117692(VarCurr)
        & v117661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13195,axiom,
    ! [VarCurr: state_type] :
      ( v117692(VarCurr)
    <=> ( v117655(VarCurr)
        & v117693(VarCurr) ) ) ).

tff(writeUnaryOperator_7179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117693(VarCurr)
    <=> v117659(VarCurr) ) ).

tff(addAssignment_68884,axiom,
    ! [VarCurr: state_type] :
      ( v117687(VarCurr)
    <=> v112831(VarCurr,4) ) ).

tff(addAssignment_68883,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,4)
    <=> v112865(VarCurr,4) ) ).

tff(addAssignment_68882,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,4)
    <=> v112849(VarCurr,4) ) ).

tff(addAssignment_68881,axiom,
    ! [VarCurr: state_type] :
      ( v117116(VarCurr,2)
    <=> v117118(VarCurr,2) ) ).

tff(addAssignment_68880,axiom,
    ! [VarCurr: state_type] :
      ( v117118(VarCurr,2)
    <=> v117120(VarCurr,2) ) ).

tff(addAssignment_68879,axiom,
    ! [VarNext: state_type] :
      ( v117120(VarNext,2)
    <=> v117669(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117670(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v117669(VarNext,B)
            <=> v117120(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1528,axiom,
    ! [VarNext: state_type] :
      ( v117670(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117669(VarNext,B)
          <=> v117680(VarNext,B) ) ) ) ).

tff(addAssignment_68878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117680(VarNext,B)
          <=> v117678(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117681(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117678(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1070,axiom,
    ! [VarCurr: state_type] :
      ( v117681(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v117678(VarCurr,B)
          <=> v117138(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13194,axiom,
    ! [VarCurr: state_type] :
      ( v117681(VarCurr)
    <=> ( v117682(VarCurr)
        & v117683(VarCurr) ) ) ).

tff(writeUnaryOperator_7178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117683(VarCurr)
    <=> v117130(VarCurr) ) ).

tff(writeUnaryOperator_7177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117682(VarCurr)
    <=> v117122(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117670(VarNext)
      <=> v117671(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117671(VarNext)
      <=> ( v117672(VarNext)
          & v117665(VarNext) ) ) ) ).

tff(writeUnaryOperator_7176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117672(VarNext)
      <=> v117674(VarNext) ) ) ).

tff(addAssignment_68877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117674(VarNext)
      <=> v117665(VarCurr) ) ) ).

tff(addAssignment_68876,axiom,
    ! [VarCurr: state_type] :
      ( v117665(VarCurr)
    <=> v117667(VarCurr) ) ).

tff(addAssignment_68875,axiom,
    ! [VarCurr: state_type] :
      ( v117667(VarCurr)
    <=> v117596(VarCurr) ) ).

tff(addAssignment_68874,axiom,
    ! [VarCurr: state_type] :
      ( v117138(VarCurr,2)
    <=> v117140(VarCurr,2) ) ).

tff(addAssignment_68873,axiom,
    ! [VarCurr: state_type] :
      ( v117140(VarCurr,2)
    <=> v117142(VarCurr,2) ) ).

tff(addAssignment_68872,axiom,
    ! [VarCurr: state_type] :
      ( v117142(VarCurr,2)
    <=> v117663(VarCurr,2) ) ).

tff(addAssignment_68871,axiom,
    ! [VarCurr: state_type] :
      ( v117663(VarCurr,0)
    <=> v117627(VarCurr) ) ).

tff(addAssignment_68870,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v117663(VarCurr,B)
      <=> v117144(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_42,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117633(VarCurr)
     => ( v117144(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_71,axiom,
    ! [VarCurr: state_type] :
      ( v117633(VarCurr)
     => ( v117144(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13191,axiom,
    ! [VarCurr: state_type] :
      ( v117633(VarCurr)
    <=> ( v117634(VarCurr)
        | v117649(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13190,axiom,
    ! [VarCurr: state_type] :
      ( v117649(VarCurr)
    <=> ( v117650(VarCurr)
        & v117651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13189,axiom,
    ! [VarCurr: state_type] :
      ( v117651(VarCurr)
    <=> ( v117652(VarCurr)
        & v117662(VarCurr) ) ) ).

tff(writeUnaryOperator_7175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117662(VarCurr)
    <=> v117648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13188,axiom,
    ! [VarCurr: state_type] :
      ( v117652(VarCurr)
    <=> ( v117653(VarCurr)
        & v117661(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1169,axiom,
    ! [VarCurr: state_type] :
      ( v117661(VarCurr)
    <=> ( $true
      <=> v117116(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13187,axiom,
    ! [VarCurr: state_type] :
      ( v117653(VarCurr)
    <=> ( v117654(VarCurr)
        & v117658(VarCurr) ) ) ).

tff(writeUnaryOperator_7174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117658(VarCurr)
    <=> v117659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13186,axiom,
    ! [VarCurr: state_type] :
      ( v117659(VarCurr)
    <=> ( v117660(VarCurr)
        | v117631(VarCurr) ) ) ).

tff(writeUnaryOperator_7173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117660(VarCurr)
    <=> v117621(VarCurr) ) ).

tff(writeUnaryOperator_7172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117654(VarCurr)
    <=> v117655(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13185,axiom,
    ! [VarCurr: state_type] :
      ( v117655(VarCurr)
    <=> ( v117656(VarCurr)
        | v117657(VarCurr) ) ) ).

tff(writeUnaryOperator_7171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117657(VarCurr)
    <=> v117623(VarCurr) ) ).

tff(writeUnaryOperator_7170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117656(VarCurr)
    <=> v117146(VarCurr) ) ).

tff(writeUnaryOperator_7169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117650(VarCurr)
    <=> v117646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13184,axiom,
    ! [VarCurr: state_type] :
      ( v117634(VarCurr)
    <=> ( v117635(VarCurr)
        & v117647(VarCurr) ) ) ).

tff(writeUnaryOperator_7168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117647(VarCurr)
    <=> v117648(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1168,axiom,
    ! [VarCurr: state_type] :
      ( v117648(VarCurr)
    <=> ( $true
      <=> v117116(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13183,axiom,
    ! [VarCurr: state_type] :
      ( v117635(VarCurr)
    <=> ( v117636(VarCurr)
        & v117646(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1167,axiom,
    ! [VarCurr: state_type] :
      ( v117646(VarCurr)
    <=> ( $true
      <=> v117116(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13182,axiom,
    ! [VarCurr: state_type] :
      ( v117636(VarCurr)
    <=> ( v117629(VarCurr)
        & v117637(VarCurr) ) ) ).

tff(writeUnaryOperator_7167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117637(VarCurr)
    <=> v117638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13181,axiom,
    ! [VarCurr: state_type] :
      ( v117638(VarCurr)
    <=> ( v117639(VarCurr)
        | v117631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13180,axiom,
    ! [VarCurr: state_type] :
      ( v117639(VarCurr)
    <=> ( v117640(VarCurr)
        | v117643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13179,axiom,
    ! [VarCurr: state_type] :
      ( v117643(VarCurr)
    <=> ( v117644(VarCurr)
        & v117645(VarCurr) ) ) ).

tff(writeUnaryOperator_7166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117645(VarCurr)
    <=> v117629(VarCurr) ) ).

tff(writeUnaryOperator_7165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117644(VarCurr)
    <=> v117146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13178,axiom,
    ! [VarCurr: state_type] :
      ( v117640(VarCurr)
    <=> ( v117641(VarCurr)
        | v117642(VarCurr) ) ) ).

tff(writeUnaryOperator_7164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117642(VarCurr)
    <=> v117623(VarCurr) ) ).

tff(writeUnaryOperator_7163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117641(VarCurr)
    <=> v117621(VarCurr) ) ).

tff(addAssignment_68869,axiom,
    ! [VarCurr: state_type] :
      ( v117631(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_68868,axiom,
    ! [VarCurr: state_type] :
      ( v117629(VarCurr)
    <=> v112643(VarCurr,4) ) ).

tff(addAssignment_68867,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,4)
    <=> v115202(VarCurr,4) ) ).

tff(addAssignment_68866,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,4)
    <=> v115186(VarCurr,4) ) ).

tff(addAssignment_68865,axiom,
    ! [VarCurr: state_type] :
      ( v117623(VarCurr)
    <=> v112528(VarCurr,4) ) ).

tff(addAssignment_68864,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,4)
    <=> v112530(VarCurr,4) ) ).

tff(addAssignment_68863,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,4)
    <=> v112590(VarCurr,4) ) ).

tff(addAssignment_68862,axiom,
    ! [VarCurr: state_type] :
      ( v117621(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13177,axiom,
    ! [VarCurr: state_type] :
      ( v117146(VarCurr)
    <=> ( v117618(VarCurr)
        & v117619(VarCurr) ) ) ).

tff(writeUnaryOperator_7162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117619(VarCurr)
    <=> v117616(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1166,axiom,
    ! [VarCurr: state_type] :
      ( v117618(VarCurr)
    <=> ( ( v117148(VarCurr,5)
        <=> $false )
        & ( v117148(VarCurr,4)
        <=> $false )
        & ( v117148(VarCurr,3)
        <=> $false )
        & ( v117148(VarCurr,2)
        <=> $false )
        & ( v117148(VarCurr,1)
        <=> $false )
        & ( v117148(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68861,axiom,
    ! [VarCurr: state_type] :
      ( v117616(VarCurr)
    <=> v115139(VarCurr,4) ) ).

tff(addAssignment_68860,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,4)
    <=> v115159(VarCurr,4) ) ).

tff(addAssignment_68859,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,4)
    <=> v115142(VarCurr,4) ) ).

tff(addAssignment_68858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117148(VarCurr,B)
      <=> v117150(VarCurr,B) ) ) ).

tff(addAssignment_68857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117150(VarCurr,B)
      <=> v117152(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117599(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v117152(VarNext,B)
            <=> v117152(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1527,axiom,
    ! [VarNext: state_type] :
      ( v117599(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v117152(VarNext,B)
          <=> v117609(VarNext,B) ) ) ) ).

tff(addAssignment_68856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v117609(VarNext,B)
          <=> v117607(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117610(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v117607(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1069,axiom,
    ! [VarCurr: state_type] :
      ( v117610(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v117607(VarCurr,B)
          <=> v117162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13176,axiom,
    ! [VarCurr: state_type] :
      ( v117610(VarCurr)
    <=> ( v117611(VarCurr)
        & v117612(VarCurr) ) ) ).

tff(writeUnaryOperator_7161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117612(VarCurr)
    <=> v117158(VarCurr) ) ).

tff(writeUnaryOperator_7160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117611(VarCurr)
    <=> v117154(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117599(VarNext)
      <=> v117600(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117600(VarNext)
      <=> ( v117601(VarNext)
          & v117592(VarNext) ) ) ) ).

tff(writeUnaryOperator_7159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117601(VarNext)
      <=> v117603(VarNext) ) ) ).

tff(addAssignment_68855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117603(VarNext)
      <=> v117592(VarCurr) ) ) ).

tff(addAssignment_68854,axiom,
    ! [VarCurr: state_type] :
      ( v117592(VarCurr)
    <=> v117594(VarCurr) ) ).

tff(addAssignment_68853,axiom,
    ! [VarCurr: state_type] :
      ( v117594(VarCurr)
    <=> v117596(VarCurr) ) ).

tff(addAssignment_68852,axiom,
    ! [VarCurr: state_type] :
      ( v117596(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_68851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117162(VarCurr,B)
      <=> v117164(VarCurr,B) ) ) ).

tff(addAssignment_68850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117164(VarCurr,B)
      <=> v117166(VarCurr,B) ) ) ).

tff(addAssignment_68849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v117166(VarCurr,B)
      <=> v117168(VarCurr,B) ) ) ).

tff(addAssignment_68848,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,0)
    <=> v117587(VarCurr) ) ).

tff(addAssignment_68847,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,1)
    <=> v117582(VarCurr) ) ).

tff(addAssignment_68846,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,2)
    <=> v117577(VarCurr) ) ).

tff(addAssignment_68845,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,3)
    <=> v117572(VarCurr) ) ).

tff(addAssignment_68844,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,4)
    <=> v117567(VarCurr) ) ).

tff(addAssignment_68843,axiom,
    ! [VarCurr: state_type] :
      ( v117168(VarCurr,5)
    <=> v117424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13173,axiom,
    ! [VarCurr: state_type] :
      ( v117587(VarCurr)
    <=> ( v117588(VarCurr)
        & v117590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13172,axiom,
    ! [VarCurr: state_type] :
      ( v117590(VarCurr)
    <=> ( v117379(VarCurr,0)
        | v117436(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13171,axiom,
    ! [VarCurr: state_type] :
      ( v117588(VarCurr)
    <=> ( v117513(VarCurr)
        | v117589(VarCurr) ) ) ).

tff(writeUnaryOperator_7158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117589(VarCurr)
    <=> v117436(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13170,axiom,
    ! [VarCurr: state_type] :
      ( v117582(VarCurr)
    <=> ( v117583(VarCurr)
        & v117586(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13169,axiom,
    ! [VarCurr: state_type] :
      ( v117586(VarCurr)
    <=> ( v117435(VarCurr)
        | v117507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13168,axiom,
    ! [VarCurr: state_type] :
      ( v117583(VarCurr)
    <=> ( v117584(VarCurr)
        | v117585(VarCurr) ) ) ).

tff(writeUnaryOperator_7157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117585(VarCurr)
    <=> v117507(VarCurr) ) ).

tff(writeUnaryOperator_7156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117584(VarCurr)
    <=> v117435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13167,axiom,
    ! [VarCurr: state_type] :
      ( v117577(VarCurr)
    <=> ( v117578(VarCurr)
        & v117581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13166,axiom,
    ! [VarCurr: state_type] :
      ( v117581(VarCurr)
    <=> ( v117433(VarCurr)
        | v117518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13165,axiom,
    ! [VarCurr: state_type] :
      ( v117578(VarCurr)
    <=> ( v117579(VarCurr)
        | v117580(VarCurr) ) ) ).

tff(writeUnaryOperator_7155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117580(VarCurr)
    <=> v117518(VarCurr) ) ).

tff(writeUnaryOperator_7154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117579(VarCurr)
    <=> v117433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13164,axiom,
    ! [VarCurr: state_type] :
      ( v117572(VarCurr)
    <=> ( v117573(VarCurr)
        & v117576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13163,axiom,
    ! [VarCurr: state_type] :
      ( v117576(VarCurr)
    <=> ( v117431(VarCurr)
        | v117530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13162,axiom,
    ! [VarCurr: state_type] :
      ( v117573(VarCurr)
    <=> ( v117574(VarCurr)
        | v117575(VarCurr) ) ) ).

tff(writeUnaryOperator_7153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117575(VarCurr)
    <=> v117530(VarCurr) ) ).

tff(writeUnaryOperator_7152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117574(VarCurr)
    <=> v117431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13161,axiom,
    ! [VarCurr: state_type] :
      ( v117567(VarCurr)
    <=> ( v117568(VarCurr)
        & v117571(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13160,axiom,
    ! [VarCurr: state_type] :
      ( v117571(VarCurr)
    <=> ( v117429(VarCurr)
        | v117542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13159,axiom,
    ! [VarCurr: state_type] :
      ( v117568(VarCurr)
    <=> ( v117569(VarCurr)
        | v117570(VarCurr) ) ) ).

tff(writeUnaryOperator_7151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117570(VarCurr)
    <=> v117542(VarCurr) ) ).

tff(writeUnaryOperator_7150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117569(VarCurr)
    <=> v117429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13158,axiom,
    ! [VarCurr: state_type] :
      ( v117424(VarCurr)
    <=> ( v117425(VarCurr)
        & v117566(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13157,axiom,
    ! [VarCurr: state_type] :
      ( v117566(VarCurr)
    <=> ( v117427(VarCurr)
        | v117555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13156,axiom,
    ! [VarCurr: state_type] :
      ( v117425(VarCurr)
    <=> ( v117426(VarCurr)
        | v117554(VarCurr) ) ) ).

tff(writeUnaryOperator_7149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117554(VarCurr)
    <=> v117555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13155,axiom,
    ! [VarCurr: state_type] :
      ( v117555(VarCurr)
    <=> ( v117556(VarCurr)
        & v117565(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5050,axiom,
    ! [VarCurr: state_type] :
      ( v117565(VarCurr)
    <=> ( v117558(VarCurr)
        | v117436(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13154,axiom,
    ! [VarCurr: state_type] :
      ( v117556(VarCurr)
    <=> ( v117557(VarCurr)
        | v117564(VarCurr) ) ) ).

tff(writeUnaryOperator_7148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117564(VarCurr)
    <=> v117436(VarCurr,5) ) ).

tff(writeUnaryOperator_7147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117557(VarCurr)
    <=> v117558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13153,axiom,
    ! [VarCurr: state_type] :
      ( v117558(VarCurr)
    <=> ( v117559(VarCurr)
        & v117562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13152,axiom,
    ! [VarCurr: state_type] :
      ( v117562(VarCurr)
    <=> ( v117561(VarCurr)
        | v117563(VarCurr) ) ) ).

tff(writeUnaryOperator_7146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117563(VarCurr)
    <=> v117379(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_5049,axiom,
    ! [VarCurr: state_type] :
      ( v117559(VarCurr)
    <=> ( v117560(VarCurr)
        | v117379(VarCurr,5) ) ) ).

tff(writeUnaryOperator_7145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117560(VarCurr)
    <=> v117561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13151,axiom,
    ! [VarCurr: state_type] :
      ( v117561(VarCurr)
    <=> ( v117548(VarCurr)
        & v117550(VarCurr) ) ) ).

tff(writeUnaryOperator_7144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117426(VarCurr)
    <=> v117427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13150,axiom,
    ! [VarCurr: state_type] :
      ( v117427(VarCurr)
    <=> ( v117428(VarCurr)
        | v117553(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5048,axiom,
    ! [VarCurr: state_type] :
      ( v117553(VarCurr)
    <=> ( v117545(VarCurr)
        & v117436(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13149,axiom,
    ! [VarCurr: state_type] :
      ( v117428(VarCurr)
    <=> ( v117429(VarCurr)
        & v117542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13148,axiom,
    ! [VarCurr: state_type] :
      ( v117542(VarCurr)
    <=> ( v117543(VarCurr)
        & v117552(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5047,axiom,
    ! [VarCurr: state_type] :
      ( v117552(VarCurr)
    <=> ( v117545(VarCurr)
        | v117436(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13147,axiom,
    ! [VarCurr: state_type] :
      ( v117543(VarCurr)
    <=> ( v117544(VarCurr)
        | v117551(VarCurr) ) ) ).

tff(writeUnaryOperator_7143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117551(VarCurr)
    <=> v117436(VarCurr,4) ) ).

tff(writeUnaryOperator_7142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117544(VarCurr)
    <=> v117545(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13146,axiom,
    ! [VarCurr: state_type] :
      ( v117545(VarCurr)
    <=> ( v117546(VarCurr)
        & v117549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13145,axiom,
    ! [VarCurr: state_type] :
      ( v117549(VarCurr)
    <=> ( v117548(VarCurr)
        | v117550(VarCurr) ) ) ).

tff(writeUnaryOperator_7141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117550(VarCurr)
    <=> v117379(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5046,axiom,
    ! [VarCurr: state_type] :
      ( v117546(VarCurr)
    <=> ( v117547(VarCurr)
        | v117379(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117547(VarCurr)
    <=> v117548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13144,axiom,
    ! [VarCurr: state_type] :
      ( v117548(VarCurr)
    <=> ( v117536(VarCurr)
        & v117538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13143,axiom,
    ! [VarCurr: state_type] :
      ( v117429(VarCurr)
    <=> ( v117430(VarCurr)
        | v117541(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5045,axiom,
    ! [VarCurr: state_type] :
      ( v117541(VarCurr)
    <=> ( v117533(VarCurr)
        & v117436(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13142,axiom,
    ! [VarCurr: state_type] :
      ( v117430(VarCurr)
    <=> ( v117431(VarCurr)
        & v117530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13141,axiom,
    ! [VarCurr: state_type] :
      ( v117530(VarCurr)
    <=> ( v117531(VarCurr)
        & v117540(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5044,axiom,
    ! [VarCurr: state_type] :
      ( v117540(VarCurr)
    <=> ( v117533(VarCurr)
        | v117436(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13140,axiom,
    ! [VarCurr: state_type] :
      ( v117531(VarCurr)
    <=> ( v117532(VarCurr)
        | v117539(VarCurr) ) ) ).

tff(writeUnaryOperator_7139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117539(VarCurr)
    <=> v117436(VarCurr,3) ) ).

tff(writeUnaryOperator_7138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117532(VarCurr)
    <=> v117533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13139,axiom,
    ! [VarCurr: state_type] :
      ( v117533(VarCurr)
    <=> ( v117534(VarCurr)
        & v117537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13138,axiom,
    ! [VarCurr: state_type] :
      ( v117537(VarCurr)
    <=> ( v117536(VarCurr)
        | v117538(VarCurr) ) ) ).

tff(writeUnaryOperator_7137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117538(VarCurr)
    <=> v117379(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5043,axiom,
    ! [VarCurr: state_type] :
      ( v117534(VarCurr)
    <=> ( v117535(VarCurr)
        | v117379(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117535(VarCurr)
    <=> v117536(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13137,axiom,
    ! [VarCurr: state_type] :
      ( v117536(VarCurr)
    <=> ( v117524(VarCurr)
        & v117526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13136,axiom,
    ! [VarCurr: state_type] :
      ( v117431(VarCurr)
    <=> ( v117432(VarCurr)
        | v117529(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5042,axiom,
    ! [VarCurr: state_type] :
      ( v117529(VarCurr)
    <=> ( v117521(VarCurr)
        & v117436(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13135,axiom,
    ! [VarCurr: state_type] :
      ( v117432(VarCurr)
    <=> ( v117433(VarCurr)
        & v117518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13134,axiom,
    ! [VarCurr: state_type] :
      ( v117518(VarCurr)
    <=> ( v117519(VarCurr)
        & v117528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5041,axiom,
    ! [VarCurr: state_type] :
      ( v117528(VarCurr)
    <=> ( v117521(VarCurr)
        | v117436(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13133,axiom,
    ! [VarCurr: state_type] :
      ( v117519(VarCurr)
    <=> ( v117520(VarCurr)
        | v117527(VarCurr) ) ) ).

tff(writeUnaryOperator_7135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117527(VarCurr)
    <=> v117436(VarCurr,2) ) ).

tff(writeUnaryOperator_7134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117520(VarCurr)
    <=> v117521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13132,axiom,
    ! [VarCurr: state_type] :
      ( v117521(VarCurr)
    <=> ( v117522(VarCurr)
        & v117525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13131,axiom,
    ! [VarCurr: state_type] :
      ( v117525(VarCurr)
    <=> ( v117524(VarCurr)
        | v117526(VarCurr) ) ) ).

tff(writeUnaryOperator_7133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117526(VarCurr)
    <=> v117379(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5040,axiom,
    ! [VarCurr: state_type] :
      ( v117522(VarCurr)
    <=> ( v117523(VarCurr)
        | v117379(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117523(VarCurr)
    <=> v117524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13130,axiom,
    ! [VarCurr: state_type] :
      ( v117524(VarCurr)
    <=> ( v117513(VarCurr)
        & v117514(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13129,axiom,
    ! [VarCurr: state_type] :
      ( v117433(VarCurr)
    <=> ( v117434(VarCurr)
        | v117517(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5039,axiom,
    ! [VarCurr: state_type] :
      ( v117517(VarCurr)
    <=> ( v117510(VarCurr)
        & v117436(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13128,axiom,
    ! [VarCurr: state_type] :
      ( v117434(VarCurr)
    <=> ( v117435(VarCurr)
        & v117507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13127,axiom,
    ! [VarCurr: state_type] :
      ( v117507(VarCurr)
    <=> ( v117508(VarCurr)
        & v117516(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5038,axiom,
    ! [VarCurr: state_type] :
      ( v117516(VarCurr)
    <=> ( v117510(VarCurr)
        | v117436(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13126,axiom,
    ! [VarCurr: state_type] :
      ( v117508(VarCurr)
    <=> ( v117509(VarCurr)
        | v117515(VarCurr) ) ) ).

tff(writeUnaryOperator_7131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117515(VarCurr)
    <=> v117436(VarCurr,1) ) ).

tff(writeUnaryOperator_7130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117509(VarCurr)
    <=> v117510(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13125,axiom,
    ! [VarCurr: state_type] :
      ( v117510(VarCurr)
    <=> ( v117511(VarCurr)
        & v117512(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13124,axiom,
    ! [VarCurr: state_type] :
      ( v117512(VarCurr)
    <=> ( v117513(VarCurr)
        | v117514(VarCurr) ) ) ).

tff(writeUnaryOperator_7129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117514(VarCurr)
    <=> v117379(VarCurr,1) ) ).

tff(writeUnaryOperator_7128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117513(VarCurr)
    <=> v117379(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_5037,axiom,
    ! [VarCurr: state_type] :
      ( v117511(VarCurr)
    <=> ( v117379(VarCurr,0)
        | v117379(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13123,axiom,
    ! [VarCurr: state_type] :
      ( v117435(VarCurr)
    <=> ( v117379(VarCurr,0)
        & v117436(VarCurr,0) ) ) ).

tff(addAssignment_68842,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,0)
    <=> v117502(VarCurr) ) ).

tff(addAssignment_68841,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,1)
    <=> v117497(VarCurr) ) ).

tff(addAssignment_68840,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,2)
    <=> v117492(VarCurr) ) ).

tff(addAssignment_68839,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,3)
    <=> v117487(VarCurr) ) ).

tff(addAssignment_68838,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,4)
    <=> v117482(VarCurr) ) ).

tff(addAssignment_68837,axiom,
    ! [VarCurr: state_type] :
      ( v117436(VarCurr,5)
    <=> v117438(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13122,axiom,
    ! [VarCurr: state_type] :
      ( v117502(VarCurr)
    <=> ( v117503(VarCurr)
        & v117506(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13121,axiom,
    ! [VarCurr: state_type] :
      ( v117506(VarCurr)
    <=> ( v117148(VarCurr,0)
        | v117450(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13120,axiom,
    ! [VarCurr: state_type] :
      ( v117503(VarCurr)
    <=> ( v117504(VarCurr)
        | v117505(VarCurr) ) ) ).

tff(writeUnaryOperator_7127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117505(VarCurr)
    <=> v117450(VarCurr,0) ) ).

tff(writeUnaryOperator_7126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117504(VarCurr)
    <=> v117148(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13119,axiom,
    ! [VarCurr: state_type] :
      ( v117497(VarCurr)
    <=> ( v117498(VarCurr)
        & v117501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13118,axiom,
    ! [VarCurr: state_type] :
      ( v117501(VarCurr)
    <=> ( v117449(VarCurr)
        | v117451(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13117,axiom,
    ! [VarCurr: state_type] :
      ( v117498(VarCurr)
    <=> ( v117499(VarCurr)
        | v117500(VarCurr) ) ) ).

tff(writeUnaryOperator_7125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117500(VarCurr)
    <=> v117451(VarCurr) ) ).

tff(writeUnaryOperator_7124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117499(VarCurr)
    <=> v117449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13116,axiom,
    ! [VarCurr: state_type] :
      ( v117492(VarCurr)
    <=> ( v117493(VarCurr)
        & v117496(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13115,axiom,
    ! [VarCurr: state_type] :
      ( v117496(VarCurr)
    <=> ( v117447(VarCurr)
        | v117457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13114,axiom,
    ! [VarCurr: state_type] :
      ( v117493(VarCurr)
    <=> ( v117494(VarCurr)
        | v117495(VarCurr) ) ) ).

tff(writeUnaryOperator_7123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117495(VarCurr)
    <=> v117457(VarCurr) ) ).

tff(writeUnaryOperator_7122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117494(VarCurr)
    <=> v117447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13113,axiom,
    ! [VarCurr: state_type] :
      ( v117487(VarCurr)
    <=> ( v117488(VarCurr)
        & v117491(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13112,axiom,
    ! [VarCurr: state_type] :
      ( v117491(VarCurr)
    <=> ( v117445(VarCurr)
        | v117463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13111,axiom,
    ! [VarCurr: state_type] :
      ( v117488(VarCurr)
    <=> ( v117489(VarCurr)
        | v117490(VarCurr) ) ) ).

tff(writeUnaryOperator_7121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117490(VarCurr)
    <=> v117463(VarCurr) ) ).

tff(writeUnaryOperator_7120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117489(VarCurr)
    <=> v117445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13110,axiom,
    ! [VarCurr: state_type] :
      ( v117482(VarCurr)
    <=> ( v117483(VarCurr)
        & v117486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13109,axiom,
    ! [VarCurr: state_type] :
      ( v117486(VarCurr)
    <=> ( v117443(VarCurr)
        | v117469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13108,axiom,
    ! [VarCurr: state_type] :
      ( v117483(VarCurr)
    <=> ( v117484(VarCurr)
        | v117485(VarCurr) ) ) ).

tff(writeUnaryOperator_7119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117485(VarCurr)
    <=> v117469(VarCurr) ) ).

tff(writeUnaryOperator_7118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117484(VarCurr)
    <=> v117443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13107,axiom,
    ! [VarCurr: state_type] :
      ( v117438(VarCurr)
    <=> ( v117439(VarCurr)
        & v117481(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13106,axiom,
    ! [VarCurr: state_type] :
      ( v117481(VarCurr)
    <=> ( v117441(VarCurr)
        | v117476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13105,axiom,
    ! [VarCurr: state_type] :
      ( v117439(VarCurr)
    <=> ( v117440(VarCurr)
        | v117475(VarCurr) ) ) ).

tff(writeUnaryOperator_7117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117475(VarCurr)
    <=> v117476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13104,axiom,
    ! [VarCurr: state_type] :
      ( v117476(VarCurr)
    <=> ( v117477(VarCurr)
        & v117480(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5036,axiom,
    ! [VarCurr: state_type] :
      ( v117480(VarCurr)
    <=> ( v117148(VarCurr,5)
        | v117450(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13103,axiom,
    ! [VarCurr: state_type] :
      ( v117477(VarCurr)
    <=> ( v117478(VarCurr)
        | v117479(VarCurr) ) ) ).

tff(writeUnaryOperator_7116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117479(VarCurr)
    <=> v117450(VarCurr,5) ) ).

tff(writeUnaryOperator_7115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117478(VarCurr)
    <=> v117148(VarCurr,5) ) ).

tff(writeUnaryOperator_7114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117440(VarCurr)
    <=> v117441(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13102,axiom,
    ! [VarCurr: state_type] :
      ( v117441(VarCurr)
    <=> ( v117442(VarCurr)
        | v117474(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5035,axiom,
    ! [VarCurr: state_type] :
      ( v117474(VarCurr)
    <=> ( v117148(VarCurr,4)
        & v117450(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13101,axiom,
    ! [VarCurr: state_type] :
      ( v117442(VarCurr)
    <=> ( v117443(VarCurr)
        & v117469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13100,axiom,
    ! [VarCurr: state_type] :
      ( v117469(VarCurr)
    <=> ( v117470(VarCurr)
        & v117473(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5034,axiom,
    ! [VarCurr: state_type] :
      ( v117473(VarCurr)
    <=> ( v117148(VarCurr,4)
        | v117450(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13099,axiom,
    ! [VarCurr: state_type] :
      ( v117470(VarCurr)
    <=> ( v117471(VarCurr)
        | v117472(VarCurr) ) ) ).

tff(writeUnaryOperator_7113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117472(VarCurr)
    <=> v117450(VarCurr,4) ) ).

tff(writeUnaryOperator_7112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117471(VarCurr)
    <=> v117148(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13098,axiom,
    ! [VarCurr: state_type] :
      ( v117443(VarCurr)
    <=> ( v117444(VarCurr)
        | v117468(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5033,axiom,
    ! [VarCurr: state_type] :
      ( v117468(VarCurr)
    <=> ( v117148(VarCurr,3)
        & v117450(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13097,axiom,
    ! [VarCurr: state_type] :
      ( v117444(VarCurr)
    <=> ( v117445(VarCurr)
        & v117463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13096,axiom,
    ! [VarCurr: state_type] :
      ( v117463(VarCurr)
    <=> ( v117464(VarCurr)
        & v117467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5032,axiom,
    ! [VarCurr: state_type] :
      ( v117467(VarCurr)
    <=> ( v117148(VarCurr,3)
        | v117450(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13095,axiom,
    ! [VarCurr: state_type] :
      ( v117464(VarCurr)
    <=> ( v117465(VarCurr)
        | v117466(VarCurr) ) ) ).

tff(writeUnaryOperator_7111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117466(VarCurr)
    <=> v117450(VarCurr,3) ) ).

tff(writeUnaryOperator_7110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117465(VarCurr)
    <=> v117148(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13094,axiom,
    ! [VarCurr: state_type] :
      ( v117445(VarCurr)
    <=> ( v117446(VarCurr)
        | v117462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5031,axiom,
    ! [VarCurr: state_type] :
      ( v117462(VarCurr)
    <=> ( v117148(VarCurr,2)
        & v117450(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13093,axiom,
    ! [VarCurr: state_type] :
      ( v117446(VarCurr)
    <=> ( v117447(VarCurr)
        & v117457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13092,axiom,
    ! [VarCurr: state_type] :
      ( v117457(VarCurr)
    <=> ( v117458(VarCurr)
        & v117461(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5030,axiom,
    ! [VarCurr: state_type] :
      ( v117461(VarCurr)
    <=> ( v117148(VarCurr,2)
        | v117450(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13091,axiom,
    ! [VarCurr: state_type] :
      ( v117458(VarCurr)
    <=> ( v117459(VarCurr)
        | v117460(VarCurr) ) ) ).

tff(writeUnaryOperator_7109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117460(VarCurr)
    <=> v117450(VarCurr,2) ) ).

tff(writeUnaryOperator_7108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117459(VarCurr)
    <=> v117148(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13090,axiom,
    ! [VarCurr: state_type] :
      ( v117447(VarCurr)
    <=> ( v117448(VarCurr)
        | v117456(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5029,axiom,
    ! [VarCurr: state_type] :
      ( v117456(VarCurr)
    <=> ( v117148(VarCurr,1)
        & v117450(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13089,axiom,
    ! [VarCurr: state_type] :
      ( v117448(VarCurr)
    <=> ( v117449(VarCurr)
        & v117451(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13088,axiom,
    ! [VarCurr: state_type] :
      ( v117451(VarCurr)
    <=> ( v117452(VarCurr)
        & v117455(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5028,axiom,
    ! [VarCurr: state_type] :
      ( v117455(VarCurr)
    <=> ( v117148(VarCurr,1)
        | v117450(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13087,axiom,
    ! [VarCurr: state_type] :
      ( v117452(VarCurr)
    <=> ( v117453(VarCurr)
        | v117454(VarCurr) ) ) ).

tff(writeUnaryOperator_7107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117454(VarCurr)
    <=> v117450(VarCurr,1) ) ).

tff(writeUnaryOperator_7106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117453(VarCurr)
    <=> v117148(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13086,axiom,
    ! [VarCurr: state_type] :
      ( v117449(VarCurr)
    <=> ( v117148(VarCurr,0)
        & v117450(VarCurr,0) ) ) ).

tff(addAssignment_68836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v117450(VarCurr,B)
      <=> v117170(VarCurr,B) ) ) ).

tff(addAssignment_68835,axiom,
    ! [VarCurr: state_type] :
      ( ( v117450(VarCurr,5)
      <=> $false )
      & ( v117450(VarCurr,4)
      <=> $false )
      & ( v117450(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_68834,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,5)
    <=> v117416(VarCurr,5) ) ).

tff(addAssignment_68833,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,4)
    <=> v117416(VarCurr,4) ) ).

tff(addAssignment_68832,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,3)
    <=> v117416(VarCurr,3) ) ).

tff(addAssignment_68831,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,2)
    <=> v117416(VarCurr,2) ) ).

tff(addAssignment_68830,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,1)
    <=> v117416(VarCurr,1) ) ).

tff(addAssignment_68829,axiom,
    ! [VarCurr: state_type] :
      ( v117379(VarCurr,0)
    <=> v117416(VarCurr,0) ) ).

tff(addAssignment_68828,axiom,
    ! [VarCurr: state_type] :
      ( v117416(VarCurr,0)
    <=> v117417(VarCurr) ) ).

tff(addAssignment_68827,axiom,
    ! [VarCurr: state_type] :
      ( ( v117416(VarCurr,5)
      <=> $false )
      & ( v117416(VarCurr,4)
      <=> $false )
      & ( v117416(VarCurr,3)
      <=> $false )
      & ( v117416(VarCurr,2)
      <=> $false )
      & ( v117416(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13085,axiom,
    ! [VarCurr: state_type] :
      ( v117417(VarCurr)
    <=> ( v117418(VarCurr)
        | v117415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13084,axiom,
    ! [VarCurr: state_type] :
      ( v117418(VarCurr)
    <=> ( v117419(VarCurr)
        | v117413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13083,axiom,
    ! [VarCurr: state_type] :
      ( v117419(VarCurr)
    <=> ( v117420(VarCurr)
        | v117411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13082,axiom,
    ! [VarCurr: state_type] :
      ( v117420(VarCurr)
    <=> ( v117421(VarCurr)
        | v117401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13081,axiom,
    ! [VarCurr: state_type] :
      ( v117421(VarCurr)
    <=> ( v117381(VarCurr)
        | v117391(VarCurr) ) ) ).

tff(addAssignment_68826,axiom,
    ! [VarCurr: state_type] :
      ( v117415(VarCurr)
    <=> v113911(VarCurr,4) ) ).

tff(addAssignment_68825,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,4)
    <=> v113913(VarCurr,4) ) ).

tff(addAssignment_68824,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,4)
    <=> v113915(VarCurr,4) ) ).

tff(addAssignment_68823,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,4)
    <=> v113935(VarCurr,4) ) ).

tff(addAssignment_68822,axiom,
    ! [VarCurr: state_type] :
      ( v117413(VarCurr)
    <=> v113107(VarCurr,4) ) ).

tff(addAssignment_68821,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,4)
    <=> v113143(VarCurr,4) ) ).

tff(addAssignment_68820,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,4)
    <=> v113110(VarCurr,4) ) ).

tff(addAssignment_68819,axiom,
    ! [VarCurr: state_type] :
      ( v117411(VarCurr)
    <=> v113100(VarCurr,4) ) ).

tff(addAssignment_68818,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,4)
    <=> v113101(VarCurr,4) ) ).

tff(addAssignment_68817,axiom,
    ! [VarCurr: state_type] :
      ( v117401(VarCurr)
    <=> v113810(VarCurr,4) ) ).

tff(addAssignment_68816,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,4)
    <=> v113812(VarCurr,4) ) ).

tff(addAssignment_68815,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,4)
    <=> v113814(VarCurr,4) ) ).

tff(addAssignment_68814,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,4)
    <=> v113816(VarCurr,4) ) ).

tff(addAssignment_68813,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,4)
    <=> v113818(VarCurr,4) ) ).

tff(addAssignment_68812,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,4)
    <=> v117403(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117404(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v117403(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1526,axiom,
    ! [VarNext: state_type] :
      ( v117404(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v117403(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117404(VarNext)
      <=> v117405(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117405(VarNext)
      <=> ( v117407(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_7105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117407(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_68811,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,4)
    <=> v113830(VarCurr,4) ) ).

tff(addAssignment_68810,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,4)
    <=> v113832(VarCurr,4) ) ).

tff(addAssignment_68809,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,4)
    <=> v113834(VarCurr,4) ) ).

tff(addAssignment_68808,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,4)
    <=> v113873(VarCurr,4) ) ).

tff(addAssignment_68807,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,4)
    <=> v113856(VarCurr,4) ) ).

tff(addAssignment_68806,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,4)
    <=> v113837(VarCurr,4) ) ).

tff(addAssignment_68805,axiom,
    ! [VarCurr: state_type] :
      ( v117391(VarCurr)
    <=> v113020(VarCurr,4) ) ).

tff(addAssignment_68804,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,4)
    <=> v113022(VarCurr,4) ) ).

tff(addAssignment_68803,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,4)
    <=> v113024(VarCurr,4) ) ).

tff(addAssignment_68802,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,4)
    <=> v113026(VarCurr,4) ) ).

tff(addAssignment_68801,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,4)
    <=> v113028(VarCurr,4) ) ).

tff(addAssignment_68800,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,4)
    <=> v117393(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117394(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v117393(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1525,axiom,
    ! [VarNext: state_type] :
      ( v117394(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v117393(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117394(VarNext)
      <=> v117395(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117395(VarNext)
      <=> ( v117397(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_7104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117397(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_68799,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,4)
    <=> v113040(VarCurr,4) ) ).

tff(addAssignment_68798,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,4)
    <=> v113042(VarCurr,4) ) ).

tff(addAssignment_68797,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,4)
    <=> v113044(VarCurr,4) ) ).

tff(addAssignment_68796,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,4)
    <=> v113045(VarCurr,4) ) ).

tff(addAssignment_68795,axiom,
    ! [VarCurr: state_type] :
      ( v117381(VarCurr)
    <=> v112940(VarCurr,4) ) ).

tff(addAssignment_68794,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,4)
    <=> v112942(VarCurr,4) ) ).

tff(addAssignment_68793,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,4)
    <=> v112944(VarCurr,4) ) ).

tff(addAssignment_68792,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,4)
    <=> v112946(VarCurr,4) ) ).

tff(addAssignment_68791,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,4)
    <=> v112948(VarCurr,4) ) ).

tff(addAssignment_68790,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,4)
    <=> v117383(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117384(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v117383(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1524,axiom,
    ! [VarNext: state_type] :
      ( v117384(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v117383(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117384(VarNext)
      <=> v117385(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117385(VarNext)
      <=> ( v117387(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_7103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117387(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_68789,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,4)
    <=> v112960(VarCurr,4) ) ).

tff(addAssignment_68788,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,4)
    <=> v112962(VarCurr,4) ) ).

tff(addAssignment_68787,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,4)
    <=> v112964(VarCurr,4) ) ).

tff(addAssignment_68786,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,4)
    <=> v112965(VarCurr,4) ) ).

tff(addAssignment_68785,axiom,
    ! [VarCurr: state_type] :
      ( v117170(VarCurr,2)
    <=> v117185(VarCurr,2) ) ).

tff(addAssignment_68784,axiom,
    ! [VarCurr: state_type] :
      ( v117170(VarCurr,1)
    <=> v117185(VarCurr,1) ) ).

tff(addAssignment_68783,axiom,
    ! [VarCurr: state_type] :
      ( v117170(VarCurr,0)
    <=> v117185(VarCurr,0) ) ).

tff(addAssignment_68782,axiom,
    ! [VarCurr: state_type] :
      ( v117185(VarCurr,0)
    <=> v117373(VarCurr) ) ).

tff(addAssignment_68781,axiom,
    ! [VarCurr: state_type] :
      ( v117185(VarCurr,1)
    <=> v117368(VarCurr) ) ).

tff(addAssignment_68780,axiom,
    ! [VarCurr: state_type] :
      ( v117185(VarCurr,2)
    <=> v117187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13074,axiom,
    ! [VarCurr: state_type] :
      ( v117373(VarCurr)
    <=> ( v117374(VarCurr)
        & v117377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13073,axiom,
    ! [VarCurr: state_type] :
      ( v117377(VarCurr)
    <=> ( v117193(VarCurr,0)
        | v117354(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13072,axiom,
    ! [VarCurr: state_type] :
      ( v117374(VarCurr)
    <=> ( v117375(VarCurr)
        | v117376(VarCurr) ) ) ).

tff(writeUnaryOperator_7102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117376(VarCurr)
    <=> v117354(VarCurr,0) ) ).

tff(writeUnaryOperator_7101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117375(VarCurr)
    <=> v117193(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13071,axiom,
    ! [VarCurr: state_type] :
      ( v117368(VarCurr)
    <=> ( v117369(VarCurr)
        & v117372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13070,axiom,
    ! [VarCurr: state_type] :
      ( v117372(VarCurr)
    <=> ( v117192(VarCurr)
        | v117355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13069,axiom,
    ! [VarCurr: state_type] :
      ( v117369(VarCurr)
    <=> ( v117370(VarCurr)
        | v117371(VarCurr) ) ) ).

tff(writeUnaryOperator_7100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117371(VarCurr)
    <=> v117355(VarCurr) ) ).

tff(writeUnaryOperator_7099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117370(VarCurr)
    <=> v117192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13068,axiom,
    ! [VarCurr: state_type] :
      ( v117187(VarCurr)
    <=> ( v117188(VarCurr)
        & v117367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13067,axiom,
    ! [VarCurr: state_type] :
      ( v117367(VarCurr)
    <=> ( v117190(VarCurr)
        | v117362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13066,axiom,
    ! [VarCurr: state_type] :
      ( v117188(VarCurr)
    <=> ( v117189(VarCurr)
        | v117361(VarCurr) ) ) ).

tff(writeUnaryOperator_7098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117361(VarCurr)
    <=> v117362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13065,axiom,
    ! [VarCurr: state_type] :
      ( v117362(VarCurr)
    <=> ( v117363(VarCurr)
        & v117366(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5027,axiom,
    ! [VarCurr: state_type] :
      ( v117366(VarCurr)
    <=> ( v117193(VarCurr,2)
        | v117354(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13064,axiom,
    ! [VarCurr: state_type] :
      ( v117363(VarCurr)
    <=> ( v117364(VarCurr)
        | v117365(VarCurr) ) ) ).

tff(writeUnaryOperator_7097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117365(VarCurr)
    <=> v117354(VarCurr,2) ) ).

tff(writeUnaryOperator_7096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117364(VarCurr)
    <=> v117193(VarCurr,2) ) ).

tff(writeUnaryOperator_7095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117189(VarCurr)
    <=> v117190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13063,axiom,
    ! [VarCurr: state_type] :
      ( v117190(VarCurr)
    <=> ( v117191(VarCurr)
        | v117360(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5026,axiom,
    ! [VarCurr: state_type] :
      ( v117360(VarCurr)
    <=> ( v117193(VarCurr,1)
        & v117354(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13062,axiom,
    ! [VarCurr: state_type] :
      ( v117191(VarCurr)
    <=> ( v117192(VarCurr)
        & v117355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13061,axiom,
    ! [VarCurr: state_type] :
      ( v117355(VarCurr)
    <=> ( v117356(VarCurr)
        & v117359(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5025,axiom,
    ! [VarCurr: state_type] :
      ( v117359(VarCurr)
    <=> ( v117193(VarCurr,1)
        | v117354(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13060,axiom,
    ! [VarCurr: state_type] :
      ( v117356(VarCurr)
    <=> ( v117357(VarCurr)
        | v117358(VarCurr) ) ) ).

tff(writeUnaryOperator_7094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117358(VarCurr)
    <=> v117354(VarCurr,1) ) ).

tff(writeUnaryOperator_7093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117357(VarCurr)
    <=> v117193(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13059,axiom,
    ! [VarCurr: state_type] :
      ( v117192(VarCurr)
    <=> ( v117193(VarCurr,0)
        & v117354(VarCurr,0) ) ) ).

tff(addAssignment_68779,axiom,
    ! [VarCurr: state_type] :
      ( v117354(VarCurr,0)
    <=> v117184(VarCurr) ) ).

tff(addAssignment_68778,axiom,
    ! [VarCurr: state_type] :
      ( ( v117354(VarCurr,2)
      <=> $false )
      & ( v117354(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68777,axiom,
    ! [VarCurr: state_type] :
      ( v117193(VarCurr,0)
    <=> v117349(VarCurr) ) ).

tff(addAssignment_68776,axiom,
    ! [VarCurr: state_type] :
      ( v117193(VarCurr,1)
    <=> v117344(VarCurr) ) ).

tff(addAssignment_68775,axiom,
    ! [VarCurr: state_type] :
      ( v117193(VarCurr,2)
    <=> v117195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13058,axiom,
    ! [VarCurr: state_type] :
      ( v117349(VarCurr)
    <=> ( v117350(VarCurr)
        & v117353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13057,axiom,
    ! [VarCurr: state_type] :
      ( v117353(VarCurr)
    <=> ( v117201(VarCurr,0)
        | v117330(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13056,axiom,
    ! [VarCurr: state_type] :
      ( v117350(VarCurr)
    <=> ( v117351(VarCurr)
        | v117352(VarCurr) ) ) ).

tff(writeUnaryOperator_7092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117352(VarCurr)
    <=> v117330(VarCurr,0) ) ).

tff(writeUnaryOperator_7091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117351(VarCurr)
    <=> v117201(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13055,axiom,
    ! [VarCurr: state_type] :
      ( v117344(VarCurr)
    <=> ( v117345(VarCurr)
        & v117348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13054,axiom,
    ! [VarCurr: state_type] :
      ( v117348(VarCurr)
    <=> ( v117200(VarCurr)
        | v117331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13053,axiom,
    ! [VarCurr: state_type] :
      ( v117345(VarCurr)
    <=> ( v117346(VarCurr)
        | v117347(VarCurr) ) ) ).

tff(writeUnaryOperator_7090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117347(VarCurr)
    <=> v117331(VarCurr) ) ).

tff(writeUnaryOperator_7089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117346(VarCurr)
    <=> v117200(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13052,axiom,
    ! [VarCurr: state_type] :
      ( v117195(VarCurr)
    <=> ( v117196(VarCurr)
        & v117343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13051,axiom,
    ! [VarCurr: state_type] :
      ( v117343(VarCurr)
    <=> ( v117198(VarCurr)
        | v117338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13050,axiom,
    ! [VarCurr: state_type] :
      ( v117196(VarCurr)
    <=> ( v117197(VarCurr)
        | v117337(VarCurr) ) ) ).

tff(writeUnaryOperator_7088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117337(VarCurr)
    <=> v117338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13049,axiom,
    ! [VarCurr: state_type] :
      ( v117338(VarCurr)
    <=> ( v117339(VarCurr)
        & v117342(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5024,axiom,
    ! [VarCurr: state_type] :
      ( v117342(VarCurr)
    <=> ( v117201(VarCurr,2)
        | v117330(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13048,axiom,
    ! [VarCurr: state_type] :
      ( v117339(VarCurr)
    <=> ( v117340(VarCurr)
        | v117341(VarCurr) ) ) ).

tff(writeUnaryOperator_7087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117341(VarCurr)
    <=> v117330(VarCurr,2) ) ).

tff(writeUnaryOperator_7086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117340(VarCurr)
    <=> v117201(VarCurr,2) ) ).

tff(writeUnaryOperator_7085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117197(VarCurr)
    <=> v117198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13047,axiom,
    ! [VarCurr: state_type] :
      ( v117198(VarCurr)
    <=> ( v117199(VarCurr)
        | v117336(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5023,axiom,
    ! [VarCurr: state_type] :
      ( v117336(VarCurr)
    <=> ( v117201(VarCurr,1)
        & v117330(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13046,axiom,
    ! [VarCurr: state_type] :
      ( v117199(VarCurr)
    <=> ( v117200(VarCurr)
        & v117331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13045,axiom,
    ! [VarCurr: state_type] :
      ( v117331(VarCurr)
    <=> ( v117332(VarCurr)
        & v117335(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5022,axiom,
    ! [VarCurr: state_type] :
      ( v117335(VarCurr)
    <=> ( v117201(VarCurr,1)
        | v117330(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13044,axiom,
    ! [VarCurr: state_type] :
      ( v117332(VarCurr)
    <=> ( v117333(VarCurr)
        | v117334(VarCurr) ) ) ).

tff(writeUnaryOperator_7084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117334(VarCurr)
    <=> v117330(VarCurr,1) ) ).

tff(writeUnaryOperator_7083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117333(VarCurr)
    <=> v117201(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13043,axiom,
    ! [VarCurr: state_type] :
      ( v117200(VarCurr)
    <=> ( v117201(VarCurr,0)
        & v117330(VarCurr,0) ) ) ).

tff(addAssignment_68774,axiom,
    ! [VarCurr: state_type] :
      ( v117330(VarCurr,0)
    <=> v117182(VarCurr) ) ).

tff(addAssignment_68773,axiom,
    ! [VarCurr: state_type] :
      ( ( v117330(VarCurr,2)
      <=> $false )
      & ( v117330(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68772,axiom,
    ! [VarCurr: state_type] :
      ( v117201(VarCurr,0)
    <=> v117325(VarCurr) ) ).

tff(addAssignment_68771,axiom,
    ! [VarCurr: state_type] :
      ( v117201(VarCurr,1)
    <=> v117320(VarCurr) ) ).

tff(addAssignment_68770,axiom,
    ! [VarCurr: state_type] :
      ( v117201(VarCurr,2)
    <=> v117203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13042,axiom,
    ! [VarCurr: state_type] :
      ( v117325(VarCurr)
    <=> ( v117326(VarCurr)
        & v117329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13041,axiom,
    ! [VarCurr: state_type] :
      ( v117329(VarCurr)
    <=> ( v117209(VarCurr,0)
        | v117306(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13040,axiom,
    ! [VarCurr: state_type] :
      ( v117326(VarCurr)
    <=> ( v117327(VarCurr)
        | v117328(VarCurr) ) ) ).

tff(writeUnaryOperator_7082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117328(VarCurr)
    <=> v117306(VarCurr,0) ) ).

tff(writeUnaryOperator_7081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117327(VarCurr)
    <=> v117209(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13039,axiom,
    ! [VarCurr: state_type] :
      ( v117320(VarCurr)
    <=> ( v117321(VarCurr)
        & v117324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13038,axiom,
    ! [VarCurr: state_type] :
      ( v117324(VarCurr)
    <=> ( v117208(VarCurr)
        | v117307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13037,axiom,
    ! [VarCurr: state_type] :
      ( v117321(VarCurr)
    <=> ( v117322(VarCurr)
        | v117323(VarCurr) ) ) ).

tff(writeUnaryOperator_7080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117323(VarCurr)
    <=> v117307(VarCurr) ) ).

tff(writeUnaryOperator_7079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117322(VarCurr)
    <=> v117208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13036,axiom,
    ! [VarCurr: state_type] :
      ( v117203(VarCurr)
    <=> ( v117204(VarCurr)
        & v117319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13035,axiom,
    ! [VarCurr: state_type] :
      ( v117319(VarCurr)
    <=> ( v117206(VarCurr)
        | v117314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13034,axiom,
    ! [VarCurr: state_type] :
      ( v117204(VarCurr)
    <=> ( v117205(VarCurr)
        | v117313(VarCurr) ) ) ).

tff(writeUnaryOperator_7078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117313(VarCurr)
    <=> v117314(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13033,axiom,
    ! [VarCurr: state_type] :
      ( v117314(VarCurr)
    <=> ( v117315(VarCurr)
        & v117318(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5021,axiom,
    ! [VarCurr: state_type] :
      ( v117318(VarCurr)
    <=> ( v117209(VarCurr,2)
        | v117306(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13032,axiom,
    ! [VarCurr: state_type] :
      ( v117315(VarCurr)
    <=> ( v117316(VarCurr)
        | v117317(VarCurr) ) ) ).

tff(writeUnaryOperator_7077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117317(VarCurr)
    <=> v117306(VarCurr,2) ) ).

tff(writeUnaryOperator_7076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117316(VarCurr)
    <=> v117209(VarCurr,2) ) ).

tff(writeUnaryOperator_7075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117205(VarCurr)
    <=> v117206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13031,axiom,
    ! [VarCurr: state_type] :
      ( v117206(VarCurr)
    <=> ( v117207(VarCurr)
        | v117312(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5020,axiom,
    ! [VarCurr: state_type] :
      ( v117312(VarCurr)
    <=> ( v117209(VarCurr,1)
        & v117306(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13030,axiom,
    ! [VarCurr: state_type] :
      ( v117207(VarCurr)
    <=> ( v117208(VarCurr)
        & v117307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13029,axiom,
    ! [VarCurr: state_type] :
      ( v117307(VarCurr)
    <=> ( v117308(VarCurr)
        & v117311(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5019,axiom,
    ! [VarCurr: state_type] :
      ( v117311(VarCurr)
    <=> ( v117209(VarCurr,1)
        | v117306(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13028,axiom,
    ! [VarCurr: state_type] :
      ( v117308(VarCurr)
    <=> ( v117309(VarCurr)
        | v117310(VarCurr) ) ) ).

tff(writeUnaryOperator_7074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117310(VarCurr)
    <=> v117306(VarCurr,1) ) ).

tff(writeUnaryOperator_7073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117309(VarCurr)
    <=> v117209(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13027,axiom,
    ! [VarCurr: state_type] :
      ( v117208(VarCurr)
    <=> ( v117209(VarCurr,0)
        & v117306(VarCurr,0) ) ) ).

tff(addAssignment_68769,axiom,
    ! [VarCurr: state_type] :
      ( v117306(VarCurr,0)
    <=> v117180(VarCurr) ) ).

tff(addAssignment_68768,axiom,
    ! [VarCurr: state_type] :
      ( ( v117306(VarCurr,2)
      <=> $false )
      & ( v117306(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68767,axiom,
    ! [VarCurr: state_type] :
      ( v117209(VarCurr,0)
    <=> v117301(VarCurr) ) ).

tff(addAssignment_68766,axiom,
    ! [VarCurr: state_type] :
      ( v117209(VarCurr,1)
    <=> v117296(VarCurr) ) ).

tff(addAssignment_68765,axiom,
    ! [VarCurr: state_type] :
      ( v117209(VarCurr,2)
    <=> v117211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13026,axiom,
    ! [VarCurr: state_type] :
      ( v117301(VarCurr)
    <=> ( v117302(VarCurr)
        & v117305(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13025,axiom,
    ! [VarCurr: state_type] :
      ( v117305(VarCurr)
    <=> ( v117217(VarCurr,0)
        | v117282(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13024,axiom,
    ! [VarCurr: state_type] :
      ( v117302(VarCurr)
    <=> ( v117303(VarCurr)
        | v117304(VarCurr) ) ) ).

tff(writeUnaryOperator_7072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117304(VarCurr)
    <=> v117282(VarCurr,0) ) ).

tff(writeUnaryOperator_7071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117303(VarCurr)
    <=> v117217(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13023,axiom,
    ! [VarCurr: state_type] :
      ( v117296(VarCurr)
    <=> ( v117297(VarCurr)
        & v117300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13022,axiom,
    ! [VarCurr: state_type] :
      ( v117300(VarCurr)
    <=> ( v117216(VarCurr)
        | v117283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13021,axiom,
    ! [VarCurr: state_type] :
      ( v117297(VarCurr)
    <=> ( v117298(VarCurr)
        | v117299(VarCurr) ) ) ).

tff(writeUnaryOperator_7070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117299(VarCurr)
    <=> v117283(VarCurr) ) ).

tff(writeUnaryOperator_7069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117298(VarCurr)
    <=> v117216(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13020,axiom,
    ! [VarCurr: state_type] :
      ( v117211(VarCurr)
    <=> ( v117212(VarCurr)
        & v117295(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13019,axiom,
    ! [VarCurr: state_type] :
      ( v117295(VarCurr)
    <=> ( v117214(VarCurr)
        | v117290(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13018,axiom,
    ! [VarCurr: state_type] :
      ( v117212(VarCurr)
    <=> ( v117213(VarCurr)
        | v117289(VarCurr) ) ) ).

tff(writeUnaryOperator_7068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117289(VarCurr)
    <=> v117290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13017,axiom,
    ! [VarCurr: state_type] :
      ( v117290(VarCurr)
    <=> ( v117291(VarCurr)
        & v117294(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5018,axiom,
    ! [VarCurr: state_type] :
      ( v117294(VarCurr)
    <=> ( v117217(VarCurr,2)
        | v117282(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13016,axiom,
    ! [VarCurr: state_type] :
      ( v117291(VarCurr)
    <=> ( v117292(VarCurr)
        | v117293(VarCurr) ) ) ).

tff(writeUnaryOperator_7067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117293(VarCurr)
    <=> v117282(VarCurr,2) ) ).

tff(writeUnaryOperator_7066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117292(VarCurr)
    <=> v117217(VarCurr,2) ) ).

tff(writeUnaryOperator_7065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117213(VarCurr)
    <=> v117214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13015,axiom,
    ! [VarCurr: state_type] :
      ( v117214(VarCurr)
    <=> ( v117215(VarCurr)
        | v117288(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5017,axiom,
    ! [VarCurr: state_type] :
      ( v117288(VarCurr)
    <=> ( v117217(VarCurr,1)
        & v117282(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13014,axiom,
    ! [VarCurr: state_type] :
      ( v117215(VarCurr)
    <=> ( v117216(VarCurr)
        & v117283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13013,axiom,
    ! [VarCurr: state_type] :
      ( v117283(VarCurr)
    <=> ( v117284(VarCurr)
        & v117287(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5016,axiom,
    ! [VarCurr: state_type] :
      ( v117287(VarCurr)
    <=> ( v117217(VarCurr,1)
        | v117282(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13012,axiom,
    ! [VarCurr: state_type] :
      ( v117284(VarCurr)
    <=> ( v117285(VarCurr)
        | v117286(VarCurr) ) ) ).

tff(writeUnaryOperator_7064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117286(VarCurr)
    <=> v117282(VarCurr,1) ) ).

tff(writeUnaryOperator_7063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117285(VarCurr)
    <=> v117217(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13011,axiom,
    ! [VarCurr: state_type] :
      ( v117216(VarCurr)
    <=> ( v117217(VarCurr,0)
        & v117282(VarCurr,0) ) ) ).

tff(addAssignment_68764,axiom,
    ! [VarCurr: state_type] :
      ( v117282(VarCurr,0)
    <=> v117178(VarCurr) ) ).

tff(addAssignment_68763,axiom,
    ! [VarCurr: state_type] :
      ( ( v117282(VarCurr,2)
      <=> $false )
      & ( v117282(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68762,axiom,
    ! [VarCurr: state_type] :
      ( v117217(VarCurr,0)
    <=> v117277(VarCurr) ) ).

tff(addAssignment_68761,axiom,
    ! [VarCurr: state_type] :
      ( v117217(VarCurr,1)
    <=> v117272(VarCurr) ) ).

tff(addAssignment_68760,axiom,
    ! [VarCurr: state_type] :
      ( v117217(VarCurr,2)
    <=> v117219(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13010,axiom,
    ! [VarCurr: state_type] :
      ( v117277(VarCurr)
    <=> ( v117278(VarCurr)
        & v117281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13009,axiom,
    ! [VarCurr: state_type] :
      ( v117281(VarCurr)
    <=> ( v117225(VarCurr,0)
        | v117258(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13008,axiom,
    ! [VarCurr: state_type] :
      ( v117278(VarCurr)
    <=> ( v117279(VarCurr)
        | v117280(VarCurr) ) ) ).

tff(writeUnaryOperator_7062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117280(VarCurr)
    <=> v117258(VarCurr,0) ) ).

tff(writeUnaryOperator_7061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117279(VarCurr)
    <=> v117225(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13007,axiom,
    ! [VarCurr: state_type] :
      ( v117272(VarCurr)
    <=> ( v117273(VarCurr)
        & v117276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13006,axiom,
    ! [VarCurr: state_type] :
      ( v117276(VarCurr)
    <=> ( v117224(VarCurr)
        | v117259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13005,axiom,
    ! [VarCurr: state_type] :
      ( v117273(VarCurr)
    <=> ( v117274(VarCurr)
        | v117275(VarCurr) ) ) ).

tff(writeUnaryOperator_7060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117275(VarCurr)
    <=> v117259(VarCurr) ) ).

tff(writeUnaryOperator_7059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117274(VarCurr)
    <=> v117224(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13004,axiom,
    ! [VarCurr: state_type] :
      ( v117219(VarCurr)
    <=> ( v117220(VarCurr)
        & v117271(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13003,axiom,
    ! [VarCurr: state_type] :
      ( v117271(VarCurr)
    <=> ( v117222(VarCurr)
        | v117266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13002,axiom,
    ! [VarCurr: state_type] :
      ( v117220(VarCurr)
    <=> ( v117221(VarCurr)
        | v117265(VarCurr) ) ) ).

tff(writeUnaryOperator_7058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117265(VarCurr)
    <=> v117266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13001,axiom,
    ! [VarCurr: state_type] :
      ( v117266(VarCurr)
    <=> ( v117267(VarCurr)
        & v117270(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5015,axiom,
    ! [VarCurr: state_type] :
      ( v117270(VarCurr)
    <=> ( v117225(VarCurr,2)
        | v117258(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13000,axiom,
    ! [VarCurr: state_type] :
      ( v117267(VarCurr)
    <=> ( v117268(VarCurr)
        | v117269(VarCurr) ) ) ).

tff(writeUnaryOperator_7057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117269(VarCurr)
    <=> v117258(VarCurr,2) ) ).

tff(writeUnaryOperator_7056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117268(VarCurr)
    <=> v117225(VarCurr,2) ) ).

tff(writeUnaryOperator_7055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117221(VarCurr)
    <=> v117222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12999,axiom,
    ! [VarCurr: state_type] :
      ( v117222(VarCurr)
    <=> ( v117223(VarCurr)
        | v117264(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5014,axiom,
    ! [VarCurr: state_type] :
      ( v117264(VarCurr)
    <=> ( v117225(VarCurr,1)
        & v117258(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12998,axiom,
    ! [VarCurr: state_type] :
      ( v117223(VarCurr)
    <=> ( v117224(VarCurr)
        & v117259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12997,axiom,
    ! [VarCurr: state_type] :
      ( v117259(VarCurr)
    <=> ( v117260(VarCurr)
        & v117263(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5013,axiom,
    ! [VarCurr: state_type] :
      ( v117263(VarCurr)
    <=> ( v117225(VarCurr,1)
        | v117258(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12996,axiom,
    ! [VarCurr: state_type] :
      ( v117260(VarCurr)
    <=> ( v117261(VarCurr)
        | v117262(VarCurr) ) ) ).

tff(writeUnaryOperator_7054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117262(VarCurr)
    <=> v117258(VarCurr,1) ) ).

tff(writeUnaryOperator_7053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117261(VarCurr)
    <=> v117225(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12995,axiom,
    ! [VarCurr: state_type] :
      ( v117224(VarCurr)
    <=> ( v117225(VarCurr,0)
        & v117258(VarCurr,0) ) ) ).

tff(addAssignment_68759,axiom,
    ! [VarCurr: state_type] :
      ( v117258(VarCurr,0)
    <=> v117176(VarCurr) ) ).

tff(addAssignment_68758,axiom,
    ! [VarCurr: state_type] :
      ( ( v117258(VarCurr,2)
      <=> $false )
      & ( v117258(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68757,axiom,
    ! [VarCurr: state_type] :
      ( v117225(VarCurr,0)
    <=> v117253(VarCurr) ) ).

tff(addAssignment_68756,axiom,
    ! [VarCurr: state_type] :
      ( v117225(VarCurr,1)
    <=> v117248(VarCurr) ) ).

tff(addAssignment_68755,axiom,
    ! [VarCurr: state_type] :
      ( v117225(VarCurr,2)
    <=> v117227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12994,axiom,
    ! [VarCurr: state_type] :
      ( v117253(VarCurr)
    <=> ( v117254(VarCurr)
        & v117257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12993,axiom,
    ! [VarCurr: state_type] :
      ( v117257(VarCurr)
    <=> ( v117233(VarCurr,0)
        | v117234(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12992,axiom,
    ! [VarCurr: state_type] :
      ( v117254(VarCurr)
    <=> ( v117255(VarCurr)
        | v117256(VarCurr) ) ) ).

tff(writeUnaryOperator_7052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117256(VarCurr)
    <=> v117234(VarCurr,0) ) ).

tff(writeUnaryOperator_7051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117255(VarCurr)
    <=> v117233(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12991,axiom,
    ! [VarCurr: state_type] :
      ( v117248(VarCurr)
    <=> ( v117249(VarCurr)
        & v117252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12990,axiom,
    ! [VarCurr: state_type] :
      ( v117252(VarCurr)
    <=> ( v117232(VarCurr)
        | v117235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12989,axiom,
    ! [VarCurr: state_type] :
      ( v117249(VarCurr)
    <=> ( v117250(VarCurr)
        | v117251(VarCurr) ) ) ).

tff(writeUnaryOperator_7050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117251(VarCurr)
    <=> v117235(VarCurr) ) ).

tff(writeUnaryOperator_7049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117250(VarCurr)
    <=> v117232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12988,axiom,
    ! [VarCurr: state_type] :
      ( v117227(VarCurr)
    <=> ( v117228(VarCurr)
        & v117247(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12987,axiom,
    ! [VarCurr: state_type] :
      ( v117247(VarCurr)
    <=> ( v117230(VarCurr)
        | v117242(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12986,axiom,
    ! [VarCurr: state_type] :
      ( v117228(VarCurr)
    <=> ( v117229(VarCurr)
        | v117241(VarCurr) ) ) ).

tff(writeUnaryOperator_7048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117241(VarCurr)
    <=> v117242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12985,axiom,
    ! [VarCurr: state_type] :
      ( v117242(VarCurr)
    <=> ( v117243(VarCurr)
        & v117246(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5012,axiom,
    ! [VarCurr: state_type] :
      ( v117246(VarCurr)
    <=> ( v117233(VarCurr,2)
        | v117234(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12984,axiom,
    ! [VarCurr: state_type] :
      ( v117243(VarCurr)
    <=> ( v117244(VarCurr)
        | v117245(VarCurr) ) ) ).

tff(writeUnaryOperator_7047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117245(VarCurr)
    <=> v117234(VarCurr,2) ) ).

tff(writeUnaryOperator_7046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117244(VarCurr)
    <=> v117233(VarCurr,2) ) ).

tff(writeUnaryOperator_7045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117229(VarCurr)
    <=> v117230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12983,axiom,
    ! [VarCurr: state_type] :
      ( v117230(VarCurr)
    <=> ( v117231(VarCurr)
        | v117240(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5011,axiom,
    ! [VarCurr: state_type] :
      ( v117240(VarCurr)
    <=> ( v117233(VarCurr,1)
        & v117234(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12982,axiom,
    ! [VarCurr: state_type] :
      ( v117231(VarCurr)
    <=> ( v117232(VarCurr)
        & v117235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12981,axiom,
    ! [VarCurr: state_type] :
      ( v117235(VarCurr)
    <=> ( v117236(VarCurr)
        & v117239(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5010,axiom,
    ! [VarCurr: state_type] :
      ( v117239(VarCurr)
    <=> ( v117233(VarCurr,1)
        | v117234(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12980,axiom,
    ! [VarCurr: state_type] :
      ( v117236(VarCurr)
    <=> ( v117237(VarCurr)
        | v117238(VarCurr) ) ) ).

tff(writeUnaryOperator_7044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117238(VarCurr)
    <=> v117234(VarCurr,1) ) ).

tff(writeUnaryOperator_7043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117237(VarCurr)
    <=> v117233(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12979,axiom,
    ! [VarCurr: state_type] :
      ( v117232(VarCurr)
    <=> ( v117233(VarCurr,0)
        & v117234(VarCurr,0) ) ) ).

tff(addAssignment_68754,axiom,
    ! [VarCurr: state_type] :
      ( v117234(VarCurr,0)
    <=> v117174(VarCurr) ) ).

tff(addAssignment_68753,axiom,
    ! [VarCurr: state_type] :
      ( ( v117234(VarCurr,2)
      <=> $false )
      & ( v117234(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68752,axiom,
    ! [VarCurr: state_type] :
      ( v117233(VarCurr,0)
    <=> v117172(VarCurr) ) ).

tff(addAssignment_68751,axiom,
    ! [VarCurr: state_type] :
      ( ( v117233(VarCurr,2)
      <=> $false )
      & ( v117233(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68750,axiom,
    ! [VarCurr: state_type] :
      ( v117184(VarCurr)
    <=> v114692(VarCurr,4) ) ).

tff(addAssignment_68749,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,4)
    <=> v114694(VarCurr,4) ) ).

tff(addAssignment_68748,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,4)
    <=> v114696(VarCurr,4) ) ).

tff(addAssignment_68747,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,4)
    <=> v114697(VarCurr,4) ) ).

tff(addAssignment_68746,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,4)
    <=> v113918(VarCurr,4) ) ).

tff(addAssignment_68745,axiom,
    ! [VarCurr: state_type] :
      ( v117182(VarCurr)
    <=> v114685(VarCurr,4) ) ).

tff(addAssignment_68744,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,4)
    <=> v114686(VarCurr,4) ) ).

tff(addAssignment_68743,axiom,
    ! [VarCurr: state_type] :
      ( v117180(VarCurr)
    <=> v114661(VarCurr,4) ) ).

tff(addAssignment_68742,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,4)
    <=> v114662(VarCurr,4) ) ).

tff(addAssignment_68741,axiom,
    ! [VarCurr: state_type] :
      ( v117178(VarCurr)
    <=> v114633(VarCurr,4) ) ).

tff(addAssignment_68740,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,4)
    <=> v114635(VarCurr,4) ) ).

tff(addAssignment_68739,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,4)
    <=> v114637(VarCurr,4) ) ).

tff(addAssignment_68738,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,4)
    <=> v114638(VarCurr,4) ) ).

tff(addAssignment_68737,axiom,
    ! [VarCurr: state_type] :
      ( v117176(VarCurr)
    <=> v114605(VarCurr,4) ) ).

tff(addAssignment_68736,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,4)
    <=> v114607(VarCurr,4) ) ).

tff(addAssignment_68735,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,4)
    <=> v114609(VarCurr,4) ) ).

tff(addAssignment_68734,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,4)
    <=> v114610(VarCurr,4) ) ).

tff(addAssignment_68733,axiom,
    ! [VarCurr: state_type] :
      ( v117174(VarCurr)
    <=> v114577(VarCurr,4) ) ).

tff(addAssignment_68732,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,4)
    <=> v114579(VarCurr,4) ) ).

tff(addAssignment_68731,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,4)
    <=> v114581(VarCurr,4) ) ).

tff(addAssignment_68730,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,4)
    <=> v114582(VarCurr,4) ) ).

tff(addAssignment_68729,axiom,
    ! [VarCurr: state_type] :
      ( v117172(VarCurr)
    <=> v114549(VarCurr,4) ) ).

tff(addAssignment_68728,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,4)
    <=> v114551(VarCurr,4) ) ).

tff(addAssignment_68727,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,4)
    <=> v114553(VarCurr,4) ) ).

tff(addAssignment_68726,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,4)
    <=> v114554(VarCurr,4) ) ).

tff(addAssignment_68725,axiom,
    ! [VarCurr: state_type] :
      ( v117158(VarCurr)
    <=> v117160(VarCurr) ) ).

tff(addAssignment_68724,axiom,
    ! [VarCurr: state_type] :
      ( v117160(VarCurr)
    <=> v117134(VarCurr) ) ).

tff(addAssignment_68723,axiom,
    ! [VarCurr: state_type] :
      ( v117154(VarCurr)
    <=> v117156(VarCurr) ) ).

tff(addAssignment_68722,axiom,
    ! [VarCurr: state_type] :
      ( v117156(VarCurr)
    <=> v117126(VarCurr) ) ).

tff(addAssignment_68721,axiom,
    ! [VarCurr: state_type] :
      ( v117130(VarCurr)
    <=> v117132(VarCurr) ) ).

tff(addAssignment_68720,axiom,
    ! [VarCurr: state_type] :
      ( v117132(VarCurr)
    <=> v117134(VarCurr) ) ).

tff(addAssignment_68719,axiom,
    ! [VarCurr: state_type] :
      ( v117134(VarCurr)
    <=> v117136(VarCurr) ) ).

tff(addAssignment_68718,axiom,
    ! [VarCurr: state_type] :
      ( v117136(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_68717,axiom,
    ! [VarCurr: state_type] :
      ( v117122(VarCurr)
    <=> v117124(VarCurr) ) ).

tff(addAssignment_68716,axiom,
    ! [VarCurr: state_type] :
      ( v117124(VarCurr)
    <=> v117126(VarCurr) ) ).

tff(addAssignment_68715,axiom,
    ! [VarCurr: state_type] :
      ( v117126(VarCurr)
    <=> v117128(VarCurr) ) ).

tff(addAssignment_68714,axiom,
    ! [VarCurr: state_type] :
      ( v117128(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12978,axiom,
    ! [VarCurr: state_type] :
      ( v116307(VarCurr)
    <=> ( v117112(VarCurr)
        & v117022(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5009,axiom,
    ! [VarCurr: state_type] :
      ( v117112(VarCurr)
    <=> ( v116309(VarCurr,1)
        & v116961(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1165,axiom,
    ! [VarCurr: state_type] :
      ( v117022(VarCurr)
    <=> ( ( v117024(VarCurr,4)
        <=> $false )
        & ( v117024(VarCurr,3)
        <=> $false )
        & ( v117024(VarCurr,2)
        <=> $false )
        & ( v117024(VarCurr,1)
        <=> $false )
        & ( v117024(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117024(VarCurr,B)
      <=> v117026(VarCurr,B) ) ) ).

tff(addAssignment_68712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117026(VarCurr,B)
      <=> v117028(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117094(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v117028(VarNext,B)
            <=> v117028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1523,axiom,
    ! [VarNext: state_type] :
      ( v117094(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117028(VarNext,B)
          <=> v117104(VarNext,B) ) ) ) ).

tff(addAssignment_68711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117104(VarNext,B)
          <=> v117102(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117102(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1068,axiom,
    ! [VarCurr: state_type] :
      ( v117105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117102(VarCurr,B)
          <=> v117038(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12977,axiom,
    ! [VarCurr: state_type] :
      ( v117105(VarCurr)
    <=> ( v117106(VarCurr)
        & v117107(VarCurr) ) ) ).

tff(writeUnaryOperator_7042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117107(VarCurr)
    <=> v117034(VarCurr) ) ).

tff(writeUnaryOperator_7041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117106(VarCurr)
    <=> v117030(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117094(VarNext)
      <=> v117095(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117095(VarNext)
      <=> ( v117096(VarNext)
          & v117089(VarNext) ) ) ) ).

tff(writeUnaryOperator_7040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117096(VarNext)
      <=> v117098(VarNext) ) ) ).

tff(addAssignment_68710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117098(VarNext)
      <=> v117089(VarCurr) ) ) ).

tff(addAssignment_68709,axiom,
    ! [VarCurr: state_type] :
      ( v117089(VarCurr)
    <=> v117091(VarCurr) ) ).

tff(addAssignment_68708,axiom,
    ! [VarCurr: state_type] :
      ( v117091(VarCurr)
    <=> v116795(VarCurr) ) ).

tff(addAssignment_68707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117038(VarCurr,B)
      <=> v117040(VarCurr,B) ) ) ).

tff(addAssignment_68706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117040(VarCurr,B)
      <=> v117042(VarCurr,B) ) ) ).

tff(addAssignment_68705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117042(VarCurr,B)
      <=> v117044(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117044(VarCurr,B)
          <=> v117058(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1067,axiom,
    ! [VarCurr: state_type] :
      ( v117046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117044(VarCurr,B)
          <=> v117051(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117053(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117058(VarCurr,B)
          <=> v117059(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1066,axiom,
    ! [VarCurr: state_type] :
      ( v117053(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117058(VarCurr,B)
          <=> v117056(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117022(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117059(VarCurr,B)
          <=> v117060(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1065,axiom,
    ! [VarCurr: state_type] :
      ( v117022(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v117059(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68704,axiom,
    ! [VarCurr: state_type] :
      ( v117060(VarCurr,0)
    <=> v117086(VarCurr) ) ).

tff(addAssignment_68703,axiom,
    ! [VarCurr: state_type] :
      ( v117060(VarCurr,1)
    <=> v117084(VarCurr) ) ).

tff(addAssignment_68702,axiom,
    ! [VarCurr: state_type] :
      ( v117060(VarCurr,2)
    <=> v117080(VarCurr) ) ).

tff(addAssignment_68701,axiom,
    ! [VarCurr: state_type] :
      ( v117060(VarCurr,3)
    <=> v117076(VarCurr) ) ).

tff(addAssignment_68700,axiom,
    ! [VarCurr: state_type] :
      ( v117060(VarCurr,4)
    <=> v117062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12974,axiom,
    ! [VarCurr: state_type] :
      ( v117084(VarCurr)
    <=> ( v117085(VarCurr)
        & v117087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12973,axiom,
    ! [VarCurr: state_type] :
      ( v117087(VarCurr)
    <=> ( v117024(VarCurr,0)
        | v117071(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5008,axiom,
    ! [VarCurr: state_type] :
      ( v117085(VarCurr)
    <=> ( v117086(VarCurr)
        | v117024(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117086(VarCurr)
    <=> v117024(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12972,axiom,
    ! [VarCurr: state_type] :
      ( v117080(VarCurr)
    <=> ( v117081(VarCurr)
        & v117083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12971,axiom,
    ! [VarCurr: state_type] :
      ( v117083(VarCurr)
    <=> ( v117069(VarCurr)
        | v117072(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5007,axiom,
    ! [VarCurr: state_type] :
      ( v117081(VarCurr)
    <=> ( v117082(VarCurr)
        | v117024(VarCurr,2) ) ) ).

tff(writeUnaryOperator_7038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117082(VarCurr)
    <=> v117069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12970,axiom,
    ! [VarCurr: state_type] :
      ( v117076(VarCurr)
    <=> ( v117077(VarCurr)
        & v117079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12969,axiom,
    ! [VarCurr: state_type] :
      ( v117079(VarCurr)
    <=> ( v117067(VarCurr)
        | v117073(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5006,axiom,
    ! [VarCurr: state_type] :
      ( v117077(VarCurr)
    <=> ( v117078(VarCurr)
        | v117024(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117078(VarCurr)
    <=> v117067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12968,axiom,
    ! [VarCurr: state_type] :
      ( v117062(VarCurr)
    <=> ( v117063(VarCurr)
        & v117074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12967,axiom,
    ! [VarCurr: state_type] :
      ( v117074(VarCurr)
    <=> ( v117065(VarCurr)
        | v117075(VarCurr) ) ) ).

tff(writeUnaryOperator_7036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117075(VarCurr)
    <=> v117024(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_5005,axiom,
    ! [VarCurr: state_type] :
      ( v117063(VarCurr)
    <=> ( v117064(VarCurr)
        | v117024(VarCurr,4) ) ) ).

tff(writeUnaryOperator_7035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117064(VarCurr)
    <=> v117065(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_5004,axiom,
    ! [VarCurr: state_type] :
      ( v117065(VarCurr)
    <=> ( v117024(VarCurr,3)
        | v117066(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12966,axiom,
    ! [VarCurr: state_type] :
      ( v117066(VarCurr)
    <=> ( v117067(VarCurr)
        & v117073(VarCurr) ) ) ).

tff(writeUnaryOperator_7034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117073(VarCurr)
    <=> v117024(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_5003,axiom,
    ! [VarCurr: state_type] :
      ( v117067(VarCurr)
    <=> ( v117024(VarCurr,2)
        | v117068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12965,axiom,
    ! [VarCurr: state_type] :
      ( v117068(VarCurr)
    <=> ( v117069(VarCurr)
        & v117072(VarCurr) ) ) ).

tff(writeUnaryOperator_7033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117072(VarCurr)
    <=> v117024(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_5002,axiom,
    ! [VarCurr: state_type] :
      ( v117069(VarCurr)
    <=> ( v117024(VarCurr,1)
        | v117070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12964,axiom,
    ! [VarCurr: state_type] :
      ( v117070(VarCurr)
    <=> ( v117024(VarCurr,0)
        & v117071(VarCurr) ) ) ).

tff(writeUnaryOperator_7032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117071(VarCurr)
    <=> v117024(VarCurr,1) ) ).

tff(addAssignment_68699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117056(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12963,axiom,
    ! [VarCurr: state_type] :
      ( v117053(VarCurr)
    <=> ( v116596(VarCurr)
        | v116610(VarCurr) ) ) ).

tff(addAssignment_68698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v117051(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12962,axiom,
    ! [VarCurr: state_type] :
      ( v117046(VarCurr)
    <=> ( v117048(VarCurr)
        | v116608(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12961,axiom,
    ! [VarCurr: state_type] :
      ( v117048(VarCurr)
    <=> ( v117049(VarCurr)
        | v116606(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12960,axiom,
    ! [VarCurr: state_type] :
      ( v117049(VarCurr)
    <=> ( v116576(VarCurr)
        | v116586(VarCurr) ) ) ).

tff(addAssignment_68697,axiom,
    ! [VarCurr: state_type] :
      ( v117034(VarCurr)
    <=> v117036(VarCurr) ) ).

tff(addAssignment_68696,axiom,
    ! [VarCurr: state_type] :
      ( v117036(VarCurr)
    <=> v116327(VarCurr) ) ).

tff(addAssignment_68695,axiom,
    ! [VarCurr: state_type] :
      ( v117030(VarCurr)
    <=> v117032(VarCurr) ) ).

tff(addAssignment_68694,axiom,
    ! [VarCurr: state_type] :
      ( v117032(VarCurr)
    <=> v116319(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1164,axiom,
    ! [VarCurr: state_type] :
      ( v116961(VarCurr)
    <=> ( ( v116963(VarCurr,1)
        <=> $false )
        & ( v116963(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116963(VarCurr,B)
      <=> v116965(VarCurr,B) ) ) ).

tff(addAssignment_68692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116965(VarCurr,B)
      <=> v116967(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117004(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v116967(VarNext,B)
            <=> v116967(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1522,axiom,
    ! [VarNext: state_type] :
      ( v117004(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116967(VarNext,B)
          <=> v117014(VarNext,B) ) ) ) ).

tff(addAssignment_68691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117014(VarNext,B)
          <=> v117012(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117012(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1064,axiom,
    ! [VarCurr: state_type] :
      ( v117015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v117012(VarCurr,B)
          <=> v116977(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12959,axiom,
    ! [VarCurr: state_type] :
      ( v117015(VarCurr)
    <=> ( v117016(VarCurr)
        & v117017(VarCurr) ) ) ).

tff(writeUnaryOperator_7031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117017(VarCurr)
    <=> v116973(VarCurr) ) ).

tff(writeUnaryOperator_7030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v117016(VarCurr)
    <=> v116969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117004(VarNext)
      <=> v117005(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117005(VarNext)
      <=> ( v117006(VarNext)
          & v116999(VarNext) ) ) ) ).

tff(writeUnaryOperator_7029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v117006(VarNext)
      <=> v117008(VarNext) ) ) ).

tff(addAssignment_68690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v117008(VarNext)
      <=> v116999(VarCurr) ) ) ).

tff(addAssignment_68689,axiom,
    ! [VarCurr: state_type] :
      ( v116999(VarCurr)
    <=> v117001(VarCurr) ) ).

tff(addAssignment_68688,axiom,
    ! [VarCurr: state_type] :
      ( v117001(VarCurr)
    <=> v116795(VarCurr) ) ).

tff(addAssignment_68687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116977(VarCurr,B)
      <=> v116979(VarCurr,B) ) ) ).

tff(addAssignment_68686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116979(VarCurr,B)
      <=> v116981(VarCurr,B) ) ) ).

tff(addAssignment_68685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116981(VarCurr,B)
      <=> v116983(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116985(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116983(VarCurr,B)
          <=> v116990(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1063,axiom,
    ! [VarCurr: state_type] :
      ( v116985(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116983(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116990(VarCurr,B)
          <=> v116991(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1062,axiom,
    ! [VarCurr: state_type] :
      ( v116961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116990(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68684,axiom,
    ! [VarCurr: state_type] :
      ( v116991(VarCurr,0)
    <=> v116995(VarCurr) ) ).

tff(addAssignment_68683,axiom,
    ! [VarCurr: state_type] :
      ( v116991(VarCurr,1)
    <=> v116993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12956,axiom,
    ! [VarCurr: state_type] :
      ( v116993(VarCurr)
    <=> ( v116994(VarCurr)
        & v116996(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12955,axiom,
    ! [VarCurr: state_type] :
      ( v116996(VarCurr)
    <=> ( v116963(VarCurr,0)
        | v116997(VarCurr) ) ) ).

tff(writeUnaryOperator_7028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116997(VarCurr)
    <=> v116963(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_5001,axiom,
    ! [VarCurr: state_type] :
      ( v116994(VarCurr)
    <=> ( v116995(VarCurr)
        | v116963(VarCurr,1) ) ) ).

tff(writeUnaryOperator_7027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116995(VarCurr)
    <=> v116963(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12954,axiom,
    ! [VarCurr: state_type] :
      ( v116985(VarCurr)
    <=> ( v116987(VarCurr)
        | v116988(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5000,axiom,
    ! [VarCurr: state_type] :
      ( v116988(VarCurr)
    <=> ( v116309(VarCurr,1)
        & v116828(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4999,axiom,
    ! [VarCurr: state_type] :
      ( v116987(VarCurr)
    <=> ( v116309(VarCurr,3)
        & v116886(VarCurr) ) ) ).

tff(addAssignment_68682,axiom,
    ! [VarCurr: state_type] :
      ( v116973(VarCurr)
    <=> v116975(VarCurr) ) ).

tff(addAssignment_68681,axiom,
    ! [VarCurr: state_type] :
      ( v116975(VarCurr)
    <=> v116327(VarCurr) ) ).

tff(addAssignment_68680,axiom,
    ! [VarCurr: state_type] :
      ( v116969(VarCurr)
    <=> v116971(VarCurr) ) ).

tff(addAssignment_68679,axiom,
    ! [VarCurr: state_type] :
      ( v116971(VarCurr)
    <=> v116319(VarCurr) ) ).

tff(addAssignment_68678,axiom,
    ! [VarCurr: state_type] :
      ( v116309(VarCurr,1)
    <=> v116311(VarCurr,1) ) ).

tff(addAssignment_68677,axiom,
    ! [VarCurr: state_type] :
      ( v116311(VarCurr,1)
    <=> v116313(VarCurr,1) ) ).

tff(addAssignment_68676,axiom,
    ! [VarNext: state_type] :
      ( v116313(VarNext,1)
    <=> v116953(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116954(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116953(VarNext,B)
            <=> v116313(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1521,axiom,
    ! [VarNext: state_type] :
      ( v116954(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116953(VarNext,B)
          <=> v116879(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116954(VarNext)
      <=> v116955(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116955(VarNext)
      <=> ( v116957(VarNext)
          & v116864(VarNext) ) ) ) ).

tff(writeUnaryOperator_7026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116957(VarNext)
      <=> v116873(VarNext) ) ) ).

tff(addAssignment_68675,axiom,
    ! [VarCurr: state_type] :
      ( v116331(VarCurr,1)
    <=> v116333(VarCurr,1) ) ).

tff(addAssignment_68674,axiom,
    ! [VarCurr: state_type] :
      ( v116333(VarCurr,1)
    <=> v116335(VarCurr,1) ) ).

tff(addAssignment_68673,axiom,
    ! [VarCurr: state_type] :
      ( v116335(VarCurr,1)
    <=> v116862(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_41,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116944(VarCurr)
     => ( v116337(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_70,axiom,
    ! [VarCurr: state_type] :
      ( v116944(VarCurr)
     => ( v116337(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12951,axiom,
    ! [VarCurr: state_type] :
      ( v116944(VarCurr)
    <=> ( v116945(VarCurr)
        | v116946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12950,axiom,
    ! [VarCurr: state_type] :
      ( v116946(VarCurr)
    <=> ( v116947(VarCurr)
        & v116948(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12949,axiom,
    ! [VarCurr: state_type] :
      ( v116948(VarCurr)
    <=> ( v116949(VarCurr)
        & v116845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12948,axiom,
    ! [VarCurr: state_type] :
      ( v116949(VarCurr)
    <=> ( v116950(VarCurr)
        & v116951(VarCurr) ) ) ).

tff(writeUnaryOperator_7025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116951(VarCurr)
    <=> v116837(VarCurr) ) ).

tff(writeUnaryOperator_7024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116950(VarCurr)
    <=> v116828(VarCurr) ) ).

tff(writeUnaryOperator_7023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116947(VarCurr)
    <=> v116847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12947,axiom,
    ! [VarCurr: state_type] :
      ( v116945(VarCurr)
    <=> ( v116919(VarCurr)
        & v116847(VarCurr) ) ) ).

tff(writeUnaryOperator_7022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116309(VarCurr,0)
    <=> v116824(VarCurr) ) ).

tff(addAssignment_68672,axiom,
    ! [VarCurr: state_type] :
      ( v116824(VarCurr)
    <=> v116311(VarCurr,0) ) ).

tff(addAssignment_68671,axiom,
    ! [VarCurr: state_type] :
      ( v116311(VarCurr,0)
    <=> v116313(VarCurr,0) ) ).

tff(addAssignment_68670,axiom,
    ! [VarNext: state_type] :
      ( v116313(VarNext,0)
    <=> v116935(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116936(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116935(VarNext,B)
            <=> v116313(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1520,axiom,
    ! [VarNext: state_type] :
      ( v116936(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116935(VarNext,B)
          <=> v116879(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116936(VarNext)
      <=> v116937(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116937(VarNext)
      <=> ( v116939(VarNext)
          & v116864(VarNext) ) ) ) ).

tff(writeUnaryOperator_7021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116939(VarNext)
      <=> v116873(VarNext) ) ) ).

tff(addAssignment_68669,axiom,
    ! [VarCurr: state_type] :
      ( v116331(VarCurr,0)
    <=> v116333(VarCurr,0) ) ).

tff(addAssignment_68668,axiom,
    ! [VarCurr: state_type] :
      ( v116333(VarCurr,0)
    <=> v116335(VarCurr,0) ) ).

tff(addAssignment_68667,axiom,
    ! [VarCurr: state_type] :
      ( v116335(VarCurr,0)
    <=> v116862(VarCurr,0) ) ).

tff(writeUnaryOperator_7020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116826(VarCurr)
    <=> v116337(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116914(VarCurr)
     => ( v116337(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1061,axiom,
    ! [VarCurr: state_type] :
      ( v116914(VarCurr)
     => ( v116337(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12944,axiom,
    ! [VarCurr: state_type] :
      ( v116914(VarCurr)
    <=> ( v116915(VarCurr)
        | v116928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12943,axiom,
    ! [VarCurr: state_type] :
      ( v116928(VarCurr)
    <=> ( v116929(VarCurr)
        & v116932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12942,axiom,
    ! [VarCurr: state_type] :
      ( v116932(VarCurr)
    <=> ( v116900(VarCurr)
        & v116903(VarCurr) ) ) ).

tff(writeUnaryOperator_7019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116929(VarCurr)
    <=> v116930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12941,axiom,
    ! [VarCurr: state_type] :
      ( v116930(VarCurr)
    <=> ( v116931(VarCurr)
        | v116860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12940,axiom,
    ! [VarCurr: state_type] :
      ( v116931(VarCurr)
    <=> ( v116847(VarCurr)
        | v116845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12939,axiom,
    ! [VarCurr: state_type] :
      ( v116915(VarCurr)
    <=> ( v116916(VarCurr)
        | v116924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12938,axiom,
    ! [VarCurr: state_type] :
      ( v116924(VarCurr)
    <=> ( v116925(VarCurr)
        & v116927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12937,axiom,
    ! [VarCurr: state_type] :
      ( v116927(VarCurr)
    <=> ( v116858(VarCurr)
        & v116860(VarCurr) ) ) ).

tff(writeUnaryOperator_7018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116925(VarCurr)
    <=> v116926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12936,axiom,
    ! [VarCurr: state_type] :
      ( v116926(VarCurr)
    <=> ( v116847(VarCurr)
        | v116845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12935,axiom,
    ! [VarCurr: state_type] :
      ( v116916(VarCurr)
    <=> ( v116917(VarCurr)
        | v116921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12934,axiom,
    ! [VarCurr: state_type] :
      ( v116921(VarCurr)
    <=> ( v116922(VarCurr)
        & v116923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12933,axiom,
    ! [VarCurr: state_type] :
      ( v116923(VarCurr)
    <=> ( v116837(VarCurr)
        & v116845(VarCurr) ) ) ).

tff(writeUnaryOperator_7017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116922(VarCurr)
    <=> v116847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12932,axiom,
    ! [VarCurr: state_type] :
      ( v116917(VarCurr)
    <=> ( v116918(VarCurr)
        & v116847(VarCurr) ) ) ).

tff(writeUnaryOperator_7016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116918(VarCurr)
    <=> v116919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12931,axiom,
    ! [VarCurr: state_type] :
      ( v116919(VarCurr)
    <=> ( v116920(VarCurr)
        & v116822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12930,axiom,
    ! [VarCurr: state_type] :
      ( v116920(VarCurr)
    <=> ( v116339(VarCurr)
        & v116820(VarCurr) ) ) ).

tff(addAssignment_68666,axiom,
    ! [VarCurr: state_type] :
      ( v116309(VarCurr,3)
    <=> v116311(VarCurr,3) ) ).

tff(addAssignment_68665,axiom,
    ! [VarCurr: state_type] :
      ( v116311(VarCurr,3)
    <=> v116313(VarCurr,3) ) ).

tff(addAssignment_68664,axiom,
    ! [VarNext: state_type] :
      ( v116313(VarNext,3)
    <=> v116906(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116907(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116906(VarNext,B)
            <=> v116313(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1519,axiom,
    ! [VarNext: state_type] :
      ( v116907(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116906(VarNext,B)
          <=> v116879(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116907(VarNext)
      <=> v116908(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116908(VarNext)
      <=> ( v116910(VarNext)
          & v116864(VarNext) ) ) ) ).

tff(writeUnaryOperator_7015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116910(VarNext)
      <=> v116873(VarNext) ) ) ).

tff(addAssignment_68663,axiom,
    ! [VarCurr: state_type] :
      ( v116331(VarCurr,3)
    <=> v116333(VarCurr,3) ) ).

tff(addAssignment_68662,axiom,
    ! [VarCurr: state_type] :
      ( v116333(VarCurr,3)
    <=> v116335(VarCurr,3) ) ).

tff(addAssignment_68661,axiom,
    ! [VarCurr: state_type] :
      ( v116335(VarCurr,3)
    <=> v116862(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_40,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116888(VarCurr)
     => ( v116337(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_69,axiom,
    ! [VarCurr: state_type] :
      ( v116888(VarCurr)
     => ( v116337(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12927,axiom,
    ! [VarCurr: state_type] :
      ( v116888(VarCurr)
    <=> ( v116889(VarCurr)
        | v116895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12926,axiom,
    ! [VarCurr: state_type] :
      ( v116895(VarCurr)
    <=> ( v116896(VarCurr)
        & v116897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12925,axiom,
    ! [VarCurr: state_type] :
      ( v116897(VarCurr)
    <=> ( v116898(VarCurr)
        & v116904(VarCurr) ) ) ).

tff(writeUnaryOperator_7014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116904(VarCurr)
    <=> v116894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12924,axiom,
    ! [VarCurr: state_type] :
      ( v116898(VarCurr)
    <=> ( v116899(VarCurr)
        & v116903(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1163,axiom,
    ! [VarCurr: state_type] :
      ( v116903(VarCurr)
    <=> ( $true
      <=> v116309(VarCurr,3) ) ) ).

tff(writeUnaryOperator_7013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116899(VarCurr)
    <=> v116900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12923,axiom,
    ! [VarCurr: state_type] :
      ( v116900(VarCurr)
    <=> ( v116901(VarCurr)
        | v116830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12922,axiom,
    ! [VarCurr: state_type] :
      ( v116901(VarCurr)
    <=> ( v116902(VarCurr)
        | v116886(VarCurr) ) ) ).

tff(writeUnaryOperator_7012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116902(VarCurr)
    <=> v116820(VarCurr) ) ).

tff(writeUnaryOperator_7011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116896(VarCurr)
    <=> v116860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12921,axiom,
    ! [VarCurr: state_type] :
      ( v116889(VarCurr)
    <=> ( v116890(VarCurr)
        & v116893(VarCurr) ) ) ).

tff(writeUnaryOperator_7010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116893(VarCurr)
    <=> v116894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12920,axiom,
    ! [VarCurr: state_type] :
      ( v116894(VarCurr)
    <=> ( v116847(VarCurr)
        | v116845(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12919,axiom,
    ! [VarCurr: state_type] :
      ( v116890(VarCurr)
    <=> ( v116891(VarCurr)
        & v116860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12918,axiom,
    ! [VarCurr: state_type] :
      ( v116891(VarCurr)
    <=> ( v116854(VarCurr)
        & v116892(VarCurr) ) ) ).

tff(writeUnaryOperator_7009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116892(VarCurr)
    <=> v116858(VarCurr) ) ).

tff(addAssignment_68660,axiom,
    ! [VarCurr: state_type] :
      ( v116886(VarCurr)
    <=> v112831(VarCurr,3) ) ).

tff(addAssignment_68659,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,3)
    <=> v112865(VarCurr,3) ) ).

tff(addAssignment_68658,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,3)
    <=> v112849(VarCurr,3) ) ).

tff(addAssignment_68657,axiom,
    ! [VarCurr: state_type] :
      ( v116309(VarCurr,2)
    <=> v116311(VarCurr,2) ) ).

tff(addAssignment_68656,axiom,
    ! [VarCurr: state_type] :
      ( v116311(VarCurr,2)
    <=> v116313(VarCurr,2) ) ).

tff(addAssignment_68655,axiom,
    ! [VarNext: state_type] :
      ( v116313(VarNext,2)
    <=> v116868(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116869(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116868(VarNext,B)
            <=> v116313(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1518,axiom,
    ! [VarNext: state_type] :
      ( v116869(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116868(VarNext,B)
          <=> v116879(VarNext,B) ) ) ) ).

tff(addAssignment_68654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116879(VarNext,B)
          <=> v116877(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116880(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116877(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1060,axiom,
    ! [VarCurr: state_type] :
      ( v116880(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116877(VarCurr,B)
          <=> v116331(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12917,axiom,
    ! [VarCurr: state_type] :
      ( v116880(VarCurr)
    <=> ( v116881(VarCurr)
        & v116882(VarCurr) ) ) ).

tff(writeUnaryOperator_7008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116882(VarCurr)
    <=> v116323(VarCurr) ) ).

tff(writeUnaryOperator_7007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116881(VarCurr)
    <=> v116315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116869(VarNext)
      <=> v116870(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116870(VarNext)
      <=> ( v116871(VarNext)
          & v116864(VarNext) ) ) ) ).

tff(writeUnaryOperator_7006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116871(VarNext)
      <=> v116873(VarNext) ) ) ).

tff(addAssignment_68653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116873(VarNext)
      <=> v116864(VarCurr) ) ) ).

tff(addAssignment_68652,axiom,
    ! [VarCurr: state_type] :
      ( v116864(VarCurr)
    <=> v116866(VarCurr) ) ).

tff(addAssignment_68651,axiom,
    ! [VarCurr: state_type] :
      ( v116866(VarCurr)
    <=> v116795(VarCurr) ) ).

tff(addAssignment_68650,axiom,
    ! [VarCurr: state_type] :
      ( v116331(VarCurr,2)
    <=> v116333(VarCurr,2) ) ).

tff(addAssignment_68649,axiom,
    ! [VarCurr: state_type] :
      ( v116333(VarCurr,2)
    <=> v116335(VarCurr,2) ) ).

tff(addAssignment_68648,axiom,
    ! [VarCurr: state_type] :
      ( v116335(VarCurr,2)
    <=> v116862(VarCurr,2) ) ).

tff(addAssignment_68647,axiom,
    ! [VarCurr: state_type] :
      ( v116862(VarCurr,0)
    <=> v116826(VarCurr) ) ).

tff(addAssignment_68646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v116862(VarCurr,B)
      <=> v116337(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_39,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116832(VarCurr)
     => ( v116337(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_68,axiom,
    ! [VarCurr: state_type] :
      ( v116832(VarCurr)
     => ( v116337(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12914,axiom,
    ! [VarCurr: state_type] :
      ( v116832(VarCurr)
    <=> ( v116833(VarCurr)
        | v116848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12913,axiom,
    ! [VarCurr: state_type] :
      ( v116848(VarCurr)
    <=> ( v116849(VarCurr)
        & v116850(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12912,axiom,
    ! [VarCurr: state_type] :
      ( v116850(VarCurr)
    <=> ( v116851(VarCurr)
        & v116861(VarCurr) ) ) ).

tff(writeUnaryOperator_7005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116861(VarCurr)
    <=> v116847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12911,axiom,
    ! [VarCurr: state_type] :
      ( v116851(VarCurr)
    <=> ( v116852(VarCurr)
        & v116860(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1162,axiom,
    ! [VarCurr: state_type] :
      ( v116860(VarCurr)
    <=> ( $true
      <=> v116309(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12910,axiom,
    ! [VarCurr: state_type] :
      ( v116852(VarCurr)
    <=> ( v116853(VarCurr)
        & v116857(VarCurr) ) ) ).

tff(writeUnaryOperator_7004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116857(VarCurr)
    <=> v116858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12909,axiom,
    ! [VarCurr: state_type] :
      ( v116858(VarCurr)
    <=> ( v116859(VarCurr)
        | v116830(VarCurr) ) ) ).

tff(writeUnaryOperator_7003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116859(VarCurr)
    <=> v116820(VarCurr) ) ).

tff(writeUnaryOperator_7002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116853(VarCurr)
    <=> v116854(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12908,axiom,
    ! [VarCurr: state_type] :
      ( v116854(VarCurr)
    <=> ( v116855(VarCurr)
        | v116856(VarCurr) ) ) ).

tff(writeUnaryOperator_7001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116856(VarCurr)
    <=> v116822(VarCurr) ) ).

tff(writeUnaryOperator_7000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116855(VarCurr)
    <=> v116339(VarCurr) ) ).

tff(writeUnaryOperator_6999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116849(VarCurr)
    <=> v116845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12907,axiom,
    ! [VarCurr: state_type] :
      ( v116833(VarCurr)
    <=> ( v116834(VarCurr)
        & v116846(VarCurr) ) ) ).

tff(writeUnaryOperator_6998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116846(VarCurr)
    <=> v116847(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1161,axiom,
    ! [VarCurr: state_type] :
      ( v116847(VarCurr)
    <=> ( $true
      <=> v116309(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12906,axiom,
    ! [VarCurr: state_type] :
      ( v116834(VarCurr)
    <=> ( v116835(VarCurr)
        & v116845(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1160,axiom,
    ! [VarCurr: state_type] :
      ( v116845(VarCurr)
    <=> ( $true
      <=> v116309(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12905,axiom,
    ! [VarCurr: state_type] :
      ( v116835(VarCurr)
    <=> ( v116828(VarCurr)
        & v116836(VarCurr) ) ) ).

tff(writeUnaryOperator_6997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116836(VarCurr)
    <=> v116837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12904,axiom,
    ! [VarCurr: state_type] :
      ( v116837(VarCurr)
    <=> ( v116838(VarCurr)
        | v116830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12903,axiom,
    ! [VarCurr: state_type] :
      ( v116838(VarCurr)
    <=> ( v116839(VarCurr)
        | v116842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12902,axiom,
    ! [VarCurr: state_type] :
      ( v116842(VarCurr)
    <=> ( v116843(VarCurr)
        & v116844(VarCurr) ) ) ).

tff(writeUnaryOperator_6996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116844(VarCurr)
    <=> v116828(VarCurr) ) ).

tff(writeUnaryOperator_6995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116843(VarCurr)
    <=> v116339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12901,axiom,
    ! [VarCurr: state_type] :
      ( v116839(VarCurr)
    <=> ( v116840(VarCurr)
        | v116841(VarCurr) ) ) ).

tff(writeUnaryOperator_6994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116841(VarCurr)
    <=> v116822(VarCurr) ) ).

tff(writeUnaryOperator_6993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116840(VarCurr)
    <=> v116820(VarCurr) ) ).

tff(addAssignment_68645,axiom,
    ! [VarCurr: state_type] :
      ( v116830(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_68644,axiom,
    ! [VarCurr: state_type] :
      ( v116828(VarCurr)
    <=> v112643(VarCurr,3) ) ).

tff(addAssignment_68643,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,3)
    <=> v115202(VarCurr,3) ) ).

tff(addAssignment_68642,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,3)
    <=> v115186(VarCurr,3) ) ).

tff(addAssignment_68641,axiom,
    ! [VarCurr: state_type] :
      ( v116822(VarCurr)
    <=> v112528(VarCurr,3) ) ).

tff(addAssignment_68640,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,3)
    <=> v112530(VarCurr,3) ) ).

tff(addAssignment_68639,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,3)
    <=> v112590(VarCurr,3) ) ).

tff(addAssignment_68638,axiom,
    ! [VarCurr: state_type] :
      ( v116820(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12900,axiom,
    ! [VarCurr: state_type] :
      ( v116339(VarCurr)
    <=> ( v116817(VarCurr)
        & v116818(VarCurr) ) ) ).

tff(writeUnaryOperator_6992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116818(VarCurr)
    <=> v116815(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1159,axiom,
    ! [VarCurr: state_type] :
      ( v116817(VarCurr)
    <=> ( ( v116341(VarCurr,5)
        <=> $false )
        & ( v116341(VarCurr,4)
        <=> $false )
        & ( v116341(VarCurr,3)
        <=> $false )
        & ( v116341(VarCurr,2)
        <=> $false )
        & ( v116341(VarCurr,1)
        <=> $false )
        & ( v116341(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68637,axiom,
    ! [VarCurr: state_type] :
      ( v116815(VarCurr)
    <=> v115139(VarCurr,3) ) ).

tff(addAssignment_68636,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,3)
    <=> v115159(VarCurr,3) ) ).

tff(addAssignment_68635,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,3)
    <=> v115142(VarCurr,3) ) ).

tff(addAssignment_68634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116341(VarCurr,B)
      <=> v116343(VarCurr,B) ) ) ).

tff(addAssignment_68633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116343(VarCurr,B)
      <=> v116345(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116798(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v116345(VarNext,B)
            <=> v116345(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1517,axiom,
    ! [VarNext: state_type] :
      ( v116798(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v116345(VarNext,B)
          <=> v116808(VarNext,B) ) ) ) ).

tff(addAssignment_68632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v116808(VarNext,B)
          <=> v116806(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116809(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v116806(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1059,axiom,
    ! [VarCurr: state_type] :
      ( v116809(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v116806(VarCurr,B)
          <=> v116355(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12899,axiom,
    ! [VarCurr: state_type] :
      ( v116809(VarCurr)
    <=> ( v116810(VarCurr)
        & v116811(VarCurr) ) ) ).

tff(writeUnaryOperator_6991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116811(VarCurr)
    <=> v116351(VarCurr) ) ).

tff(writeUnaryOperator_6990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116810(VarCurr)
    <=> v116347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116798(VarNext)
      <=> v116799(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116799(VarNext)
      <=> ( v116800(VarNext)
          & v116791(VarNext) ) ) ) ).

tff(writeUnaryOperator_6989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116800(VarNext)
      <=> v116802(VarNext) ) ) ).

tff(addAssignment_68631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116802(VarNext)
      <=> v116791(VarCurr) ) ) ).

tff(addAssignment_68630,axiom,
    ! [VarCurr: state_type] :
      ( v116791(VarCurr)
    <=> v116793(VarCurr) ) ).

tff(addAssignment_68629,axiom,
    ! [VarCurr: state_type] :
      ( v116793(VarCurr)
    <=> v116795(VarCurr) ) ).

tff(addAssignment_68628,axiom,
    ! [VarCurr: state_type] :
      ( v116795(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_68627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116355(VarCurr,B)
      <=> v116357(VarCurr,B) ) ) ).

tff(addAssignment_68626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116357(VarCurr,B)
      <=> v116359(VarCurr,B) ) ) ).

tff(addAssignment_68625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116359(VarCurr,B)
      <=> v116361(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v116361(VarCurr,B)
      <=> ( v116618(VarCurr,B)
          & v116621(VarCurr,B) ) ) ) ).

tff(addAssignment_68624,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,0)
    <=> v116786(VarCurr) ) ).

tff(addAssignment_68623,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,1)
    <=> v116781(VarCurr) ) ).

tff(addAssignment_68622,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,2)
    <=> v116776(VarCurr) ) ).

tff(addAssignment_68621,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,3)
    <=> v116771(VarCurr) ) ).

tff(addAssignment_68620,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,4)
    <=> v116766(VarCurr) ) ).

tff(addAssignment_68619,axiom,
    ! [VarCurr: state_type] :
      ( v116621(VarCurr,5)
    <=> v116623(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12896,axiom,
    ! [VarCurr: state_type] :
      ( v116786(VarCurr)
    <=> ( v116787(VarCurr)
        & v116789(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12895,axiom,
    ! [VarCurr: state_type] :
      ( v116789(VarCurr)
    <=> ( v116574(VarCurr,0)
        | v116635(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12894,axiom,
    ! [VarCurr: state_type] :
      ( v116787(VarCurr)
    <=> ( v116712(VarCurr)
        | v116788(VarCurr) ) ) ).

tff(writeUnaryOperator_6988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116788(VarCurr)
    <=> v116635(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12893,axiom,
    ! [VarCurr: state_type] :
      ( v116781(VarCurr)
    <=> ( v116782(VarCurr)
        & v116785(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12892,axiom,
    ! [VarCurr: state_type] :
      ( v116785(VarCurr)
    <=> ( v116634(VarCurr)
        | v116706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12891,axiom,
    ! [VarCurr: state_type] :
      ( v116782(VarCurr)
    <=> ( v116783(VarCurr)
        | v116784(VarCurr) ) ) ).

tff(writeUnaryOperator_6987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116784(VarCurr)
    <=> v116706(VarCurr) ) ).

tff(writeUnaryOperator_6986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116783(VarCurr)
    <=> v116634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12890,axiom,
    ! [VarCurr: state_type] :
      ( v116776(VarCurr)
    <=> ( v116777(VarCurr)
        & v116780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12889,axiom,
    ! [VarCurr: state_type] :
      ( v116780(VarCurr)
    <=> ( v116632(VarCurr)
        | v116717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12888,axiom,
    ! [VarCurr: state_type] :
      ( v116777(VarCurr)
    <=> ( v116778(VarCurr)
        | v116779(VarCurr) ) ) ).

tff(writeUnaryOperator_6985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116779(VarCurr)
    <=> v116717(VarCurr) ) ).

tff(writeUnaryOperator_6984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116778(VarCurr)
    <=> v116632(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12887,axiom,
    ! [VarCurr: state_type] :
      ( v116771(VarCurr)
    <=> ( v116772(VarCurr)
        & v116775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12886,axiom,
    ! [VarCurr: state_type] :
      ( v116775(VarCurr)
    <=> ( v116630(VarCurr)
        | v116729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12885,axiom,
    ! [VarCurr: state_type] :
      ( v116772(VarCurr)
    <=> ( v116773(VarCurr)
        | v116774(VarCurr) ) ) ).

tff(writeUnaryOperator_6983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116774(VarCurr)
    <=> v116729(VarCurr) ) ).

tff(writeUnaryOperator_6982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116773(VarCurr)
    <=> v116630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12884,axiom,
    ! [VarCurr: state_type] :
      ( v116766(VarCurr)
    <=> ( v116767(VarCurr)
        & v116770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12883,axiom,
    ! [VarCurr: state_type] :
      ( v116770(VarCurr)
    <=> ( v116628(VarCurr)
        | v116741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12882,axiom,
    ! [VarCurr: state_type] :
      ( v116767(VarCurr)
    <=> ( v116768(VarCurr)
        | v116769(VarCurr) ) ) ).

tff(writeUnaryOperator_6981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116769(VarCurr)
    <=> v116741(VarCurr) ) ).

tff(writeUnaryOperator_6980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116768(VarCurr)
    <=> v116628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12881,axiom,
    ! [VarCurr: state_type] :
      ( v116623(VarCurr)
    <=> ( v116624(VarCurr)
        & v116765(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12880,axiom,
    ! [VarCurr: state_type] :
      ( v116765(VarCurr)
    <=> ( v116626(VarCurr)
        | v116754(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12879,axiom,
    ! [VarCurr: state_type] :
      ( v116624(VarCurr)
    <=> ( v116625(VarCurr)
        | v116753(VarCurr) ) ) ).

tff(writeUnaryOperator_6979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116753(VarCurr)
    <=> v116754(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12878,axiom,
    ! [VarCurr: state_type] :
      ( v116754(VarCurr)
    <=> ( v116755(VarCurr)
        & v116764(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4998,axiom,
    ! [VarCurr: state_type] :
      ( v116764(VarCurr)
    <=> ( v116757(VarCurr)
        | v116635(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12877,axiom,
    ! [VarCurr: state_type] :
      ( v116755(VarCurr)
    <=> ( v116756(VarCurr)
        | v116763(VarCurr) ) ) ).

tff(writeUnaryOperator_6978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116763(VarCurr)
    <=> v116635(VarCurr,5) ) ).

tff(writeUnaryOperator_6977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116756(VarCurr)
    <=> v116757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12876,axiom,
    ! [VarCurr: state_type] :
      ( v116757(VarCurr)
    <=> ( v116758(VarCurr)
        & v116761(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12875,axiom,
    ! [VarCurr: state_type] :
      ( v116761(VarCurr)
    <=> ( v116760(VarCurr)
        | v116762(VarCurr) ) ) ).

tff(writeUnaryOperator_6976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116762(VarCurr)
    <=> v116574(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4997,axiom,
    ! [VarCurr: state_type] :
      ( v116758(VarCurr)
    <=> ( v116759(VarCurr)
        | v116574(VarCurr,5) ) ) ).

tff(writeUnaryOperator_6975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116759(VarCurr)
    <=> v116760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12874,axiom,
    ! [VarCurr: state_type] :
      ( v116760(VarCurr)
    <=> ( v116747(VarCurr)
        & v116749(VarCurr) ) ) ).

tff(writeUnaryOperator_6974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116625(VarCurr)
    <=> v116626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12873,axiom,
    ! [VarCurr: state_type] :
      ( v116626(VarCurr)
    <=> ( v116627(VarCurr)
        | v116752(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4996,axiom,
    ! [VarCurr: state_type] :
      ( v116752(VarCurr)
    <=> ( v116744(VarCurr)
        & v116635(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12872,axiom,
    ! [VarCurr: state_type] :
      ( v116627(VarCurr)
    <=> ( v116628(VarCurr)
        & v116741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12871,axiom,
    ! [VarCurr: state_type] :
      ( v116741(VarCurr)
    <=> ( v116742(VarCurr)
        & v116751(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4995,axiom,
    ! [VarCurr: state_type] :
      ( v116751(VarCurr)
    <=> ( v116744(VarCurr)
        | v116635(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12870,axiom,
    ! [VarCurr: state_type] :
      ( v116742(VarCurr)
    <=> ( v116743(VarCurr)
        | v116750(VarCurr) ) ) ).

tff(writeUnaryOperator_6973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116750(VarCurr)
    <=> v116635(VarCurr,4) ) ).

tff(writeUnaryOperator_6972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116743(VarCurr)
    <=> v116744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12869,axiom,
    ! [VarCurr: state_type] :
      ( v116744(VarCurr)
    <=> ( v116745(VarCurr)
        & v116748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12868,axiom,
    ! [VarCurr: state_type] :
      ( v116748(VarCurr)
    <=> ( v116747(VarCurr)
        | v116749(VarCurr) ) ) ).

tff(writeUnaryOperator_6971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116749(VarCurr)
    <=> v116574(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4994,axiom,
    ! [VarCurr: state_type] :
      ( v116745(VarCurr)
    <=> ( v116746(VarCurr)
        | v116574(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116746(VarCurr)
    <=> v116747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12867,axiom,
    ! [VarCurr: state_type] :
      ( v116747(VarCurr)
    <=> ( v116735(VarCurr)
        & v116737(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12866,axiom,
    ! [VarCurr: state_type] :
      ( v116628(VarCurr)
    <=> ( v116629(VarCurr)
        | v116740(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4993,axiom,
    ! [VarCurr: state_type] :
      ( v116740(VarCurr)
    <=> ( v116732(VarCurr)
        & v116635(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12865,axiom,
    ! [VarCurr: state_type] :
      ( v116629(VarCurr)
    <=> ( v116630(VarCurr)
        & v116729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12864,axiom,
    ! [VarCurr: state_type] :
      ( v116729(VarCurr)
    <=> ( v116730(VarCurr)
        & v116739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4992,axiom,
    ! [VarCurr: state_type] :
      ( v116739(VarCurr)
    <=> ( v116732(VarCurr)
        | v116635(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12863,axiom,
    ! [VarCurr: state_type] :
      ( v116730(VarCurr)
    <=> ( v116731(VarCurr)
        | v116738(VarCurr) ) ) ).

tff(writeUnaryOperator_6969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116738(VarCurr)
    <=> v116635(VarCurr,3) ) ).

tff(writeUnaryOperator_6968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116731(VarCurr)
    <=> v116732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12862,axiom,
    ! [VarCurr: state_type] :
      ( v116732(VarCurr)
    <=> ( v116733(VarCurr)
        & v116736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12861,axiom,
    ! [VarCurr: state_type] :
      ( v116736(VarCurr)
    <=> ( v116735(VarCurr)
        | v116737(VarCurr) ) ) ).

tff(writeUnaryOperator_6967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116737(VarCurr)
    <=> v116574(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4991,axiom,
    ! [VarCurr: state_type] :
      ( v116733(VarCurr)
    <=> ( v116734(VarCurr)
        | v116574(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116734(VarCurr)
    <=> v116735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12860,axiom,
    ! [VarCurr: state_type] :
      ( v116735(VarCurr)
    <=> ( v116723(VarCurr)
        & v116725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12859,axiom,
    ! [VarCurr: state_type] :
      ( v116630(VarCurr)
    <=> ( v116631(VarCurr)
        | v116728(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4990,axiom,
    ! [VarCurr: state_type] :
      ( v116728(VarCurr)
    <=> ( v116720(VarCurr)
        & v116635(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12858,axiom,
    ! [VarCurr: state_type] :
      ( v116631(VarCurr)
    <=> ( v116632(VarCurr)
        & v116717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12857,axiom,
    ! [VarCurr: state_type] :
      ( v116717(VarCurr)
    <=> ( v116718(VarCurr)
        & v116727(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4989,axiom,
    ! [VarCurr: state_type] :
      ( v116727(VarCurr)
    <=> ( v116720(VarCurr)
        | v116635(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12856,axiom,
    ! [VarCurr: state_type] :
      ( v116718(VarCurr)
    <=> ( v116719(VarCurr)
        | v116726(VarCurr) ) ) ).

tff(writeUnaryOperator_6965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116726(VarCurr)
    <=> v116635(VarCurr,2) ) ).

tff(writeUnaryOperator_6964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116719(VarCurr)
    <=> v116720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12855,axiom,
    ! [VarCurr: state_type] :
      ( v116720(VarCurr)
    <=> ( v116721(VarCurr)
        & v116724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12854,axiom,
    ! [VarCurr: state_type] :
      ( v116724(VarCurr)
    <=> ( v116723(VarCurr)
        | v116725(VarCurr) ) ) ).

tff(writeUnaryOperator_6963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116725(VarCurr)
    <=> v116574(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4988,axiom,
    ! [VarCurr: state_type] :
      ( v116721(VarCurr)
    <=> ( v116722(VarCurr)
        | v116574(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116722(VarCurr)
    <=> v116723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12853,axiom,
    ! [VarCurr: state_type] :
      ( v116723(VarCurr)
    <=> ( v116712(VarCurr)
        & v116713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12852,axiom,
    ! [VarCurr: state_type] :
      ( v116632(VarCurr)
    <=> ( v116633(VarCurr)
        | v116716(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4987,axiom,
    ! [VarCurr: state_type] :
      ( v116716(VarCurr)
    <=> ( v116709(VarCurr)
        & v116635(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12851,axiom,
    ! [VarCurr: state_type] :
      ( v116633(VarCurr)
    <=> ( v116634(VarCurr)
        & v116706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12850,axiom,
    ! [VarCurr: state_type] :
      ( v116706(VarCurr)
    <=> ( v116707(VarCurr)
        & v116715(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4986,axiom,
    ! [VarCurr: state_type] :
      ( v116715(VarCurr)
    <=> ( v116709(VarCurr)
        | v116635(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12849,axiom,
    ! [VarCurr: state_type] :
      ( v116707(VarCurr)
    <=> ( v116708(VarCurr)
        | v116714(VarCurr) ) ) ).

tff(writeUnaryOperator_6961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116714(VarCurr)
    <=> v116635(VarCurr,1) ) ).

tff(writeUnaryOperator_6960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116708(VarCurr)
    <=> v116709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12848,axiom,
    ! [VarCurr: state_type] :
      ( v116709(VarCurr)
    <=> ( v116710(VarCurr)
        & v116711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12847,axiom,
    ! [VarCurr: state_type] :
      ( v116711(VarCurr)
    <=> ( v116712(VarCurr)
        | v116713(VarCurr) ) ) ).

tff(writeUnaryOperator_6959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116713(VarCurr)
    <=> v116574(VarCurr,1) ) ).

tff(writeUnaryOperator_6958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116712(VarCurr)
    <=> v116574(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_4985,axiom,
    ! [VarCurr: state_type] :
      ( v116710(VarCurr)
    <=> ( v116574(VarCurr,0)
        | v116574(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12846,axiom,
    ! [VarCurr: state_type] :
      ( v116634(VarCurr)
    <=> ( v116574(VarCurr,0)
        & v116635(VarCurr,0) ) ) ).

tff(addAssignment_68618,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,0)
    <=> v116701(VarCurr) ) ).

tff(addAssignment_68617,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,1)
    <=> v116696(VarCurr) ) ).

tff(addAssignment_68616,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,2)
    <=> v116691(VarCurr) ) ).

tff(addAssignment_68615,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,3)
    <=> v116686(VarCurr) ) ).

tff(addAssignment_68614,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,4)
    <=> v116681(VarCurr) ) ).

tff(addAssignment_68613,axiom,
    ! [VarCurr: state_type] :
      ( v116635(VarCurr,5)
    <=> v116637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12845,axiom,
    ! [VarCurr: state_type] :
      ( v116701(VarCurr)
    <=> ( v116702(VarCurr)
        & v116705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12844,axiom,
    ! [VarCurr: state_type] :
      ( v116705(VarCurr)
    <=> ( v116341(VarCurr,0)
        | v116649(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12843,axiom,
    ! [VarCurr: state_type] :
      ( v116702(VarCurr)
    <=> ( v116703(VarCurr)
        | v116704(VarCurr) ) ) ).

tff(writeUnaryOperator_6957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116704(VarCurr)
    <=> v116649(VarCurr,0) ) ).

tff(writeUnaryOperator_6956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116703(VarCurr)
    <=> v116341(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12842,axiom,
    ! [VarCurr: state_type] :
      ( v116696(VarCurr)
    <=> ( v116697(VarCurr)
        & v116700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12841,axiom,
    ! [VarCurr: state_type] :
      ( v116700(VarCurr)
    <=> ( v116648(VarCurr)
        | v116650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12840,axiom,
    ! [VarCurr: state_type] :
      ( v116697(VarCurr)
    <=> ( v116698(VarCurr)
        | v116699(VarCurr) ) ) ).

tff(writeUnaryOperator_6955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116699(VarCurr)
    <=> v116650(VarCurr) ) ).

tff(writeUnaryOperator_6954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116698(VarCurr)
    <=> v116648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12839,axiom,
    ! [VarCurr: state_type] :
      ( v116691(VarCurr)
    <=> ( v116692(VarCurr)
        & v116695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12838,axiom,
    ! [VarCurr: state_type] :
      ( v116695(VarCurr)
    <=> ( v116646(VarCurr)
        | v116656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12837,axiom,
    ! [VarCurr: state_type] :
      ( v116692(VarCurr)
    <=> ( v116693(VarCurr)
        | v116694(VarCurr) ) ) ).

tff(writeUnaryOperator_6953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116694(VarCurr)
    <=> v116656(VarCurr) ) ).

tff(writeUnaryOperator_6952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116693(VarCurr)
    <=> v116646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12836,axiom,
    ! [VarCurr: state_type] :
      ( v116686(VarCurr)
    <=> ( v116687(VarCurr)
        & v116690(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12835,axiom,
    ! [VarCurr: state_type] :
      ( v116690(VarCurr)
    <=> ( v116644(VarCurr)
        | v116662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12834,axiom,
    ! [VarCurr: state_type] :
      ( v116687(VarCurr)
    <=> ( v116688(VarCurr)
        | v116689(VarCurr) ) ) ).

tff(writeUnaryOperator_6951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116689(VarCurr)
    <=> v116662(VarCurr) ) ).

tff(writeUnaryOperator_6950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116688(VarCurr)
    <=> v116644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12833,axiom,
    ! [VarCurr: state_type] :
      ( v116681(VarCurr)
    <=> ( v116682(VarCurr)
        & v116685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12832,axiom,
    ! [VarCurr: state_type] :
      ( v116685(VarCurr)
    <=> ( v116642(VarCurr)
        | v116668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12831,axiom,
    ! [VarCurr: state_type] :
      ( v116682(VarCurr)
    <=> ( v116683(VarCurr)
        | v116684(VarCurr) ) ) ).

tff(writeUnaryOperator_6949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116684(VarCurr)
    <=> v116668(VarCurr) ) ).

tff(writeUnaryOperator_6948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116683(VarCurr)
    <=> v116642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12830,axiom,
    ! [VarCurr: state_type] :
      ( v116637(VarCurr)
    <=> ( v116638(VarCurr)
        & v116680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12829,axiom,
    ! [VarCurr: state_type] :
      ( v116680(VarCurr)
    <=> ( v116640(VarCurr)
        | v116675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12828,axiom,
    ! [VarCurr: state_type] :
      ( v116638(VarCurr)
    <=> ( v116639(VarCurr)
        | v116674(VarCurr) ) ) ).

tff(writeUnaryOperator_6947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116674(VarCurr)
    <=> v116675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12827,axiom,
    ! [VarCurr: state_type] :
      ( v116675(VarCurr)
    <=> ( v116676(VarCurr)
        & v116679(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4984,axiom,
    ! [VarCurr: state_type] :
      ( v116679(VarCurr)
    <=> ( v116341(VarCurr,5)
        | v116649(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12826,axiom,
    ! [VarCurr: state_type] :
      ( v116676(VarCurr)
    <=> ( v116677(VarCurr)
        | v116678(VarCurr) ) ) ).

tff(writeUnaryOperator_6946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116678(VarCurr)
    <=> v116649(VarCurr,5) ) ).

tff(writeUnaryOperator_6945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116677(VarCurr)
    <=> v116341(VarCurr,5) ) ).

tff(writeUnaryOperator_6944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116639(VarCurr)
    <=> v116640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12825,axiom,
    ! [VarCurr: state_type] :
      ( v116640(VarCurr)
    <=> ( v116641(VarCurr)
        | v116673(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4983,axiom,
    ! [VarCurr: state_type] :
      ( v116673(VarCurr)
    <=> ( v116341(VarCurr,4)
        & v116649(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12824,axiom,
    ! [VarCurr: state_type] :
      ( v116641(VarCurr)
    <=> ( v116642(VarCurr)
        & v116668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12823,axiom,
    ! [VarCurr: state_type] :
      ( v116668(VarCurr)
    <=> ( v116669(VarCurr)
        & v116672(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4982,axiom,
    ! [VarCurr: state_type] :
      ( v116672(VarCurr)
    <=> ( v116341(VarCurr,4)
        | v116649(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12822,axiom,
    ! [VarCurr: state_type] :
      ( v116669(VarCurr)
    <=> ( v116670(VarCurr)
        | v116671(VarCurr) ) ) ).

tff(writeUnaryOperator_6943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116671(VarCurr)
    <=> v116649(VarCurr,4) ) ).

tff(writeUnaryOperator_6942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116670(VarCurr)
    <=> v116341(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12821,axiom,
    ! [VarCurr: state_type] :
      ( v116642(VarCurr)
    <=> ( v116643(VarCurr)
        | v116667(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4981,axiom,
    ! [VarCurr: state_type] :
      ( v116667(VarCurr)
    <=> ( v116341(VarCurr,3)
        & v116649(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12820,axiom,
    ! [VarCurr: state_type] :
      ( v116643(VarCurr)
    <=> ( v116644(VarCurr)
        & v116662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12819,axiom,
    ! [VarCurr: state_type] :
      ( v116662(VarCurr)
    <=> ( v116663(VarCurr)
        & v116666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4980,axiom,
    ! [VarCurr: state_type] :
      ( v116666(VarCurr)
    <=> ( v116341(VarCurr,3)
        | v116649(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12818,axiom,
    ! [VarCurr: state_type] :
      ( v116663(VarCurr)
    <=> ( v116664(VarCurr)
        | v116665(VarCurr) ) ) ).

tff(writeUnaryOperator_6941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116665(VarCurr)
    <=> v116649(VarCurr,3) ) ).

tff(writeUnaryOperator_6940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116664(VarCurr)
    <=> v116341(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12817,axiom,
    ! [VarCurr: state_type] :
      ( v116644(VarCurr)
    <=> ( v116645(VarCurr)
        | v116661(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4979,axiom,
    ! [VarCurr: state_type] :
      ( v116661(VarCurr)
    <=> ( v116341(VarCurr,2)
        & v116649(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12816,axiom,
    ! [VarCurr: state_type] :
      ( v116645(VarCurr)
    <=> ( v116646(VarCurr)
        & v116656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12815,axiom,
    ! [VarCurr: state_type] :
      ( v116656(VarCurr)
    <=> ( v116657(VarCurr)
        & v116660(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4978,axiom,
    ! [VarCurr: state_type] :
      ( v116660(VarCurr)
    <=> ( v116341(VarCurr,2)
        | v116649(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12814,axiom,
    ! [VarCurr: state_type] :
      ( v116657(VarCurr)
    <=> ( v116658(VarCurr)
        | v116659(VarCurr) ) ) ).

tff(writeUnaryOperator_6939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116659(VarCurr)
    <=> v116649(VarCurr,2) ) ).

tff(writeUnaryOperator_6938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116658(VarCurr)
    <=> v116341(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12813,axiom,
    ! [VarCurr: state_type] :
      ( v116646(VarCurr)
    <=> ( v116647(VarCurr)
        | v116655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4977,axiom,
    ! [VarCurr: state_type] :
      ( v116655(VarCurr)
    <=> ( v116341(VarCurr,1)
        & v116649(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12812,axiom,
    ! [VarCurr: state_type] :
      ( v116647(VarCurr)
    <=> ( v116648(VarCurr)
        & v116650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12811,axiom,
    ! [VarCurr: state_type] :
      ( v116650(VarCurr)
    <=> ( v116651(VarCurr)
        & v116654(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4976,axiom,
    ! [VarCurr: state_type] :
      ( v116654(VarCurr)
    <=> ( v116341(VarCurr,1)
        | v116649(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12810,axiom,
    ! [VarCurr: state_type] :
      ( v116651(VarCurr)
    <=> ( v116652(VarCurr)
        | v116653(VarCurr) ) ) ).

tff(writeUnaryOperator_6937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116653(VarCurr)
    <=> v116649(VarCurr,1) ) ).

tff(writeUnaryOperator_6936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116652(VarCurr)
    <=> v116341(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12809,axiom,
    ! [VarCurr: state_type] :
      ( v116648(VarCurr)
    <=> ( v116341(VarCurr,0)
        & v116649(VarCurr,0) ) ) ).

tff(addAssignment_68612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v116649(VarCurr,B)
      <=> v116365(VarCurr,B) ) ) ).

tff(addAssignment_68611,axiom,
    ! [VarCurr: state_type] :
      ( ( v116649(VarCurr,5)
      <=> $false )
      & ( v116649(VarCurr,4)
      <=> $false )
      & ( v116649(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_68610,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,0)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68609,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,1)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68608,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,2)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68607,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,3)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68606,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,4)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68605,axiom,
    ! [VarCurr: state_type] :
      ( v116618(VarCurr,5)
    <=> v116619(VarCurr) ) ).

tff(addAssignment_68604,axiom,
    ! [VarCurr: state_type] :
      ( v116619(VarCurr)
    <=> v116620(VarCurr) ) ).

tff(writeUnaryOperator_6935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116620(VarCurr)
    <=> v116363(VarCurr) ) ).

tff(addAssignment_68603,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,5)
    <=> v116611(VarCurr,5) ) ).

tff(addAssignment_68602,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,4)
    <=> v116611(VarCurr,4) ) ).

tff(addAssignment_68601,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,3)
    <=> v116611(VarCurr,3) ) ).

tff(addAssignment_68600,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,2)
    <=> v116611(VarCurr,2) ) ).

tff(addAssignment_68599,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,1)
    <=> v116611(VarCurr,1) ) ).

tff(addAssignment_68598,axiom,
    ! [VarCurr: state_type] :
      ( v116574(VarCurr,0)
    <=> v116611(VarCurr,0) ) ).

tff(addAssignment_68597,axiom,
    ! [VarCurr: state_type] :
      ( v116611(VarCurr,0)
    <=> v116612(VarCurr) ) ).

tff(addAssignment_68596,axiom,
    ! [VarCurr: state_type] :
      ( ( v116611(VarCurr,5)
      <=> $false )
      & ( v116611(VarCurr,4)
      <=> $false )
      & ( v116611(VarCurr,3)
      <=> $false )
      & ( v116611(VarCurr,2)
      <=> $false )
      & ( v116611(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12808,axiom,
    ! [VarCurr: state_type] :
      ( v116612(VarCurr)
    <=> ( v116613(VarCurr)
        | v116610(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12807,axiom,
    ! [VarCurr: state_type] :
      ( v116613(VarCurr)
    <=> ( v116614(VarCurr)
        | v116608(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12806,axiom,
    ! [VarCurr: state_type] :
      ( v116614(VarCurr)
    <=> ( v116615(VarCurr)
        | v116606(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12805,axiom,
    ! [VarCurr: state_type] :
      ( v116615(VarCurr)
    <=> ( v116616(VarCurr)
        | v116596(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12804,axiom,
    ! [VarCurr: state_type] :
      ( v116616(VarCurr)
    <=> ( v116576(VarCurr)
        | v116586(VarCurr) ) ) ).

tff(addAssignment_68595,axiom,
    ! [VarCurr: state_type] :
      ( v116610(VarCurr)
    <=> v113911(VarCurr,3) ) ).

tff(addAssignment_68594,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,3)
    <=> v113913(VarCurr,3) ) ).

tff(addAssignment_68593,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,3)
    <=> v113915(VarCurr,3) ) ).

tff(addAssignment_68592,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,3)
    <=> v113935(VarCurr,3) ) ).

tff(addAssignment_68591,axiom,
    ! [VarCurr: state_type] :
      ( v116608(VarCurr)
    <=> v113107(VarCurr,3) ) ).

tff(addAssignment_68590,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,3)
    <=> v113143(VarCurr,3) ) ).

tff(addAssignment_68589,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,3)
    <=> v113110(VarCurr,3) ) ).

tff(addAssignment_68588,axiom,
    ! [VarCurr: state_type] :
      ( v116606(VarCurr)
    <=> v113100(VarCurr,3) ) ).

tff(addAssignment_68587,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,3)
    <=> v113101(VarCurr,3) ) ).

tff(addAssignment_68586,axiom,
    ! [VarCurr: state_type] :
      ( v116596(VarCurr)
    <=> v113810(VarCurr,3) ) ).

tff(addAssignment_68585,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,3)
    <=> v113812(VarCurr,3) ) ).

tff(addAssignment_68584,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,3)
    <=> v113814(VarCurr,3) ) ).

tff(addAssignment_68583,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,3)
    <=> v113816(VarCurr,3) ) ).

tff(addAssignment_68582,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,3)
    <=> v113818(VarCurr,3) ) ).

tff(addAssignment_68581,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,3)
    <=> v116598(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116599(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v116598(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1516,axiom,
    ! [VarNext: state_type] :
      ( v116599(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v116598(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116599(VarNext)
      <=> v116600(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116600(VarNext)
      <=> ( v116602(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_6934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116602(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_68580,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,3)
    <=> v113830(VarCurr,3) ) ).

tff(addAssignment_68579,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,3)
    <=> v113832(VarCurr,3) ) ).

tff(addAssignment_68578,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,3)
    <=> v113834(VarCurr,3) ) ).

tff(addAssignment_68577,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,3)
    <=> v113873(VarCurr,3) ) ).

tff(addAssignment_68576,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,3)
    <=> v113856(VarCurr,3) ) ).

tff(addAssignment_68575,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,3)
    <=> v113837(VarCurr,3) ) ).

tff(addAssignment_68574,axiom,
    ! [VarCurr: state_type] :
      ( v116586(VarCurr)
    <=> v113020(VarCurr,3) ) ).

tff(addAssignment_68573,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,3)
    <=> v113022(VarCurr,3) ) ).

tff(addAssignment_68572,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,3)
    <=> v113024(VarCurr,3) ) ).

tff(addAssignment_68571,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,3)
    <=> v113026(VarCurr,3) ) ).

tff(addAssignment_68570,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,3)
    <=> v113028(VarCurr,3) ) ).

tff(addAssignment_68569,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,3)
    <=> v116588(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116589(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v116588(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1515,axiom,
    ! [VarNext: state_type] :
      ( v116589(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v116588(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116589(VarNext)
      <=> v116590(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116590(VarNext)
      <=> ( v116592(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_6933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116592(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_68568,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,3)
    <=> v113040(VarCurr,3) ) ).

tff(addAssignment_68567,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,3)
    <=> v113042(VarCurr,3) ) ).

tff(addAssignment_68566,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,3)
    <=> v113044(VarCurr,3) ) ).

tff(addAssignment_68565,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,3)
    <=> v113045(VarCurr,3) ) ).

tff(addAssignment_68564,axiom,
    ! [VarCurr: state_type] :
      ( v116576(VarCurr)
    <=> v112940(VarCurr,3) ) ).

tff(addAssignment_68563,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,3)
    <=> v112942(VarCurr,3) ) ).

tff(addAssignment_68562,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,3)
    <=> v112944(VarCurr,3) ) ).

tff(addAssignment_68561,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,3)
    <=> v112946(VarCurr,3) ) ).

tff(addAssignment_68560,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,3)
    <=> v112948(VarCurr,3) ) ).

tff(addAssignment_68559,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,3)
    <=> v116578(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116579(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v116578(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1514,axiom,
    ! [VarNext: state_type] :
      ( v116579(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v116578(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116579(VarNext)
      <=> v116580(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116580(VarNext)
      <=> ( v116582(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_6932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116582(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_68558,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,3)
    <=> v112960(VarCurr,3) ) ).

tff(addAssignment_68557,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,3)
    <=> v112962(VarCurr,3) ) ).

tff(addAssignment_68556,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,3)
    <=> v112964(VarCurr,3) ) ).

tff(addAssignment_68555,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,3)
    <=> v112965(VarCurr,3) ) ).

tff(addAssignment_68554,axiom,
    ! [VarCurr: state_type] :
      ( v116365(VarCurr,2)
    <=> v116380(VarCurr,2) ) ).

tff(addAssignment_68553,axiom,
    ! [VarCurr: state_type] :
      ( v116365(VarCurr,1)
    <=> v116380(VarCurr,1) ) ).

tff(addAssignment_68552,axiom,
    ! [VarCurr: state_type] :
      ( v116365(VarCurr,0)
    <=> v116380(VarCurr,0) ) ).

tff(addAssignment_68551,axiom,
    ! [VarCurr: state_type] :
      ( v116380(VarCurr,0)
    <=> v116568(VarCurr) ) ).

tff(addAssignment_68550,axiom,
    ! [VarCurr: state_type] :
      ( v116380(VarCurr,1)
    <=> v116563(VarCurr) ) ).

tff(addAssignment_68549,axiom,
    ! [VarCurr: state_type] :
      ( v116380(VarCurr,2)
    <=> v116382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12797,axiom,
    ! [VarCurr: state_type] :
      ( v116568(VarCurr)
    <=> ( v116569(VarCurr)
        & v116572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12796,axiom,
    ! [VarCurr: state_type] :
      ( v116572(VarCurr)
    <=> ( v116388(VarCurr,0)
        | v116549(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12795,axiom,
    ! [VarCurr: state_type] :
      ( v116569(VarCurr)
    <=> ( v116570(VarCurr)
        | v116571(VarCurr) ) ) ).

tff(writeUnaryOperator_6931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116571(VarCurr)
    <=> v116549(VarCurr,0) ) ).

tff(writeUnaryOperator_6930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116570(VarCurr)
    <=> v116388(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12794,axiom,
    ! [VarCurr: state_type] :
      ( v116563(VarCurr)
    <=> ( v116564(VarCurr)
        & v116567(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12793,axiom,
    ! [VarCurr: state_type] :
      ( v116567(VarCurr)
    <=> ( v116387(VarCurr)
        | v116550(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12792,axiom,
    ! [VarCurr: state_type] :
      ( v116564(VarCurr)
    <=> ( v116565(VarCurr)
        | v116566(VarCurr) ) ) ).

tff(writeUnaryOperator_6929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116566(VarCurr)
    <=> v116550(VarCurr) ) ).

tff(writeUnaryOperator_6928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116565(VarCurr)
    <=> v116387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12791,axiom,
    ! [VarCurr: state_type] :
      ( v116382(VarCurr)
    <=> ( v116383(VarCurr)
        & v116562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12790,axiom,
    ! [VarCurr: state_type] :
      ( v116562(VarCurr)
    <=> ( v116385(VarCurr)
        | v116557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12789,axiom,
    ! [VarCurr: state_type] :
      ( v116383(VarCurr)
    <=> ( v116384(VarCurr)
        | v116556(VarCurr) ) ) ).

tff(writeUnaryOperator_6927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116556(VarCurr)
    <=> v116557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12788,axiom,
    ! [VarCurr: state_type] :
      ( v116557(VarCurr)
    <=> ( v116558(VarCurr)
        & v116561(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4975,axiom,
    ! [VarCurr: state_type] :
      ( v116561(VarCurr)
    <=> ( v116388(VarCurr,2)
        | v116549(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12787,axiom,
    ! [VarCurr: state_type] :
      ( v116558(VarCurr)
    <=> ( v116559(VarCurr)
        | v116560(VarCurr) ) ) ).

tff(writeUnaryOperator_6926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116560(VarCurr)
    <=> v116549(VarCurr,2) ) ).

tff(writeUnaryOperator_6925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116559(VarCurr)
    <=> v116388(VarCurr,2) ) ).

tff(writeUnaryOperator_6924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116384(VarCurr)
    <=> v116385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12786,axiom,
    ! [VarCurr: state_type] :
      ( v116385(VarCurr)
    <=> ( v116386(VarCurr)
        | v116555(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4974,axiom,
    ! [VarCurr: state_type] :
      ( v116555(VarCurr)
    <=> ( v116388(VarCurr,1)
        & v116549(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12785,axiom,
    ! [VarCurr: state_type] :
      ( v116386(VarCurr)
    <=> ( v116387(VarCurr)
        & v116550(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12784,axiom,
    ! [VarCurr: state_type] :
      ( v116550(VarCurr)
    <=> ( v116551(VarCurr)
        & v116554(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4973,axiom,
    ! [VarCurr: state_type] :
      ( v116554(VarCurr)
    <=> ( v116388(VarCurr,1)
        | v116549(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12783,axiom,
    ! [VarCurr: state_type] :
      ( v116551(VarCurr)
    <=> ( v116552(VarCurr)
        | v116553(VarCurr) ) ) ).

tff(writeUnaryOperator_6923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116553(VarCurr)
    <=> v116549(VarCurr,1) ) ).

tff(writeUnaryOperator_6922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116552(VarCurr)
    <=> v116388(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12782,axiom,
    ! [VarCurr: state_type] :
      ( v116387(VarCurr)
    <=> ( v116388(VarCurr,0)
        & v116549(VarCurr,0) ) ) ).

tff(addAssignment_68548,axiom,
    ! [VarCurr: state_type] :
      ( v116549(VarCurr,0)
    <=> v116379(VarCurr) ) ).

tff(addAssignment_68547,axiom,
    ! [VarCurr: state_type] :
      ( ( v116549(VarCurr,2)
      <=> $false )
      & ( v116549(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68546,axiom,
    ! [VarCurr: state_type] :
      ( v116388(VarCurr,0)
    <=> v116544(VarCurr) ) ).

tff(addAssignment_68545,axiom,
    ! [VarCurr: state_type] :
      ( v116388(VarCurr,1)
    <=> v116539(VarCurr) ) ).

tff(addAssignment_68544,axiom,
    ! [VarCurr: state_type] :
      ( v116388(VarCurr,2)
    <=> v116390(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12781,axiom,
    ! [VarCurr: state_type] :
      ( v116544(VarCurr)
    <=> ( v116545(VarCurr)
        & v116548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12780,axiom,
    ! [VarCurr: state_type] :
      ( v116548(VarCurr)
    <=> ( v116396(VarCurr,0)
        | v116525(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12779,axiom,
    ! [VarCurr: state_type] :
      ( v116545(VarCurr)
    <=> ( v116546(VarCurr)
        | v116547(VarCurr) ) ) ).

tff(writeUnaryOperator_6921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116547(VarCurr)
    <=> v116525(VarCurr,0) ) ).

tff(writeUnaryOperator_6920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116546(VarCurr)
    <=> v116396(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12778,axiom,
    ! [VarCurr: state_type] :
      ( v116539(VarCurr)
    <=> ( v116540(VarCurr)
        & v116543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12777,axiom,
    ! [VarCurr: state_type] :
      ( v116543(VarCurr)
    <=> ( v116395(VarCurr)
        | v116526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12776,axiom,
    ! [VarCurr: state_type] :
      ( v116540(VarCurr)
    <=> ( v116541(VarCurr)
        | v116542(VarCurr) ) ) ).

tff(writeUnaryOperator_6919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116542(VarCurr)
    <=> v116526(VarCurr) ) ).

tff(writeUnaryOperator_6918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116541(VarCurr)
    <=> v116395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12775,axiom,
    ! [VarCurr: state_type] :
      ( v116390(VarCurr)
    <=> ( v116391(VarCurr)
        & v116538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12774,axiom,
    ! [VarCurr: state_type] :
      ( v116538(VarCurr)
    <=> ( v116393(VarCurr)
        | v116533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12773,axiom,
    ! [VarCurr: state_type] :
      ( v116391(VarCurr)
    <=> ( v116392(VarCurr)
        | v116532(VarCurr) ) ) ).

tff(writeUnaryOperator_6917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116532(VarCurr)
    <=> v116533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12772,axiom,
    ! [VarCurr: state_type] :
      ( v116533(VarCurr)
    <=> ( v116534(VarCurr)
        & v116537(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4972,axiom,
    ! [VarCurr: state_type] :
      ( v116537(VarCurr)
    <=> ( v116396(VarCurr,2)
        | v116525(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12771,axiom,
    ! [VarCurr: state_type] :
      ( v116534(VarCurr)
    <=> ( v116535(VarCurr)
        | v116536(VarCurr) ) ) ).

tff(writeUnaryOperator_6916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116536(VarCurr)
    <=> v116525(VarCurr,2) ) ).

tff(writeUnaryOperator_6915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116535(VarCurr)
    <=> v116396(VarCurr,2) ) ).

tff(writeUnaryOperator_6914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116392(VarCurr)
    <=> v116393(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12770,axiom,
    ! [VarCurr: state_type] :
      ( v116393(VarCurr)
    <=> ( v116394(VarCurr)
        | v116531(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4971,axiom,
    ! [VarCurr: state_type] :
      ( v116531(VarCurr)
    <=> ( v116396(VarCurr,1)
        & v116525(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12769,axiom,
    ! [VarCurr: state_type] :
      ( v116394(VarCurr)
    <=> ( v116395(VarCurr)
        & v116526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12768,axiom,
    ! [VarCurr: state_type] :
      ( v116526(VarCurr)
    <=> ( v116527(VarCurr)
        & v116530(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4970,axiom,
    ! [VarCurr: state_type] :
      ( v116530(VarCurr)
    <=> ( v116396(VarCurr,1)
        | v116525(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12767,axiom,
    ! [VarCurr: state_type] :
      ( v116527(VarCurr)
    <=> ( v116528(VarCurr)
        | v116529(VarCurr) ) ) ).

tff(writeUnaryOperator_6913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116529(VarCurr)
    <=> v116525(VarCurr,1) ) ).

tff(writeUnaryOperator_6912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116528(VarCurr)
    <=> v116396(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12766,axiom,
    ! [VarCurr: state_type] :
      ( v116395(VarCurr)
    <=> ( v116396(VarCurr,0)
        & v116525(VarCurr,0) ) ) ).

tff(addAssignment_68543,axiom,
    ! [VarCurr: state_type] :
      ( v116525(VarCurr,0)
    <=> v116377(VarCurr) ) ).

tff(addAssignment_68542,axiom,
    ! [VarCurr: state_type] :
      ( ( v116525(VarCurr,2)
      <=> $false )
      & ( v116525(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68541,axiom,
    ! [VarCurr: state_type] :
      ( v116396(VarCurr,0)
    <=> v116520(VarCurr) ) ).

tff(addAssignment_68540,axiom,
    ! [VarCurr: state_type] :
      ( v116396(VarCurr,1)
    <=> v116515(VarCurr) ) ).

tff(addAssignment_68539,axiom,
    ! [VarCurr: state_type] :
      ( v116396(VarCurr,2)
    <=> v116398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12765,axiom,
    ! [VarCurr: state_type] :
      ( v116520(VarCurr)
    <=> ( v116521(VarCurr)
        & v116524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12764,axiom,
    ! [VarCurr: state_type] :
      ( v116524(VarCurr)
    <=> ( v116404(VarCurr,0)
        | v116501(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12763,axiom,
    ! [VarCurr: state_type] :
      ( v116521(VarCurr)
    <=> ( v116522(VarCurr)
        | v116523(VarCurr) ) ) ).

tff(writeUnaryOperator_6911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116523(VarCurr)
    <=> v116501(VarCurr,0) ) ).

tff(writeUnaryOperator_6910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116522(VarCurr)
    <=> v116404(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12762,axiom,
    ! [VarCurr: state_type] :
      ( v116515(VarCurr)
    <=> ( v116516(VarCurr)
        & v116519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12761,axiom,
    ! [VarCurr: state_type] :
      ( v116519(VarCurr)
    <=> ( v116403(VarCurr)
        | v116502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12760,axiom,
    ! [VarCurr: state_type] :
      ( v116516(VarCurr)
    <=> ( v116517(VarCurr)
        | v116518(VarCurr) ) ) ).

tff(writeUnaryOperator_6909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116518(VarCurr)
    <=> v116502(VarCurr) ) ).

tff(writeUnaryOperator_6908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116517(VarCurr)
    <=> v116403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12759,axiom,
    ! [VarCurr: state_type] :
      ( v116398(VarCurr)
    <=> ( v116399(VarCurr)
        & v116514(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12758,axiom,
    ! [VarCurr: state_type] :
      ( v116514(VarCurr)
    <=> ( v116401(VarCurr)
        | v116509(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12757,axiom,
    ! [VarCurr: state_type] :
      ( v116399(VarCurr)
    <=> ( v116400(VarCurr)
        | v116508(VarCurr) ) ) ).

tff(writeUnaryOperator_6907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116508(VarCurr)
    <=> v116509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12756,axiom,
    ! [VarCurr: state_type] :
      ( v116509(VarCurr)
    <=> ( v116510(VarCurr)
        & v116513(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4969,axiom,
    ! [VarCurr: state_type] :
      ( v116513(VarCurr)
    <=> ( v116404(VarCurr,2)
        | v116501(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12755,axiom,
    ! [VarCurr: state_type] :
      ( v116510(VarCurr)
    <=> ( v116511(VarCurr)
        | v116512(VarCurr) ) ) ).

tff(writeUnaryOperator_6906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116512(VarCurr)
    <=> v116501(VarCurr,2) ) ).

tff(writeUnaryOperator_6905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116511(VarCurr)
    <=> v116404(VarCurr,2) ) ).

tff(writeUnaryOperator_6904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116400(VarCurr)
    <=> v116401(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12754,axiom,
    ! [VarCurr: state_type] :
      ( v116401(VarCurr)
    <=> ( v116402(VarCurr)
        | v116507(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4968,axiom,
    ! [VarCurr: state_type] :
      ( v116507(VarCurr)
    <=> ( v116404(VarCurr,1)
        & v116501(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12753,axiom,
    ! [VarCurr: state_type] :
      ( v116402(VarCurr)
    <=> ( v116403(VarCurr)
        & v116502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12752,axiom,
    ! [VarCurr: state_type] :
      ( v116502(VarCurr)
    <=> ( v116503(VarCurr)
        & v116506(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4967,axiom,
    ! [VarCurr: state_type] :
      ( v116506(VarCurr)
    <=> ( v116404(VarCurr,1)
        | v116501(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12751,axiom,
    ! [VarCurr: state_type] :
      ( v116503(VarCurr)
    <=> ( v116504(VarCurr)
        | v116505(VarCurr) ) ) ).

tff(writeUnaryOperator_6903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116505(VarCurr)
    <=> v116501(VarCurr,1) ) ).

tff(writeUnaryOperator_6902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116504(VarCurr)
    <=> v116404(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12750,axiom,
    ! [VarCurr: state_type] :
      ( v116403(VarCurr)
    <=> ( v116404(VarCurr,0)
        & v116501(VarCurr,0) ) ) ).

tff(addAssignment_68538,axiom,
    ! [VarCurr: state_type] :
      ( v116501(VarCurr,0)
    <=> v116375(VarCurr) ) ).

tff(addAssignment_68537,axiom,
    ! [VarCurr: state_type] :
      ( ( v116501(VarCurr,2)
      <=> $false )
      & ( v116501(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68536,axiom,
    ! [VarCurr: state_type] :
      ( v116404(VarCurr,0)
    <=> v116496(VarCurr) ) ).

tff(addAssignment_68535,axiom,
    ! [VarCurr: state_type] :
      ( v116404(VarCurr,1)
    <=> v116491(VarCurr) ) ).

tff(addAssignment_68534,axiom,
    ! [VarCurr: state_type] :
      ( v116404(VarCurr,2)
    <=> v116406(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12749,axiom,
    ! [VarCurr: state_type] :
      ( v116496(VarCurr)
    <=> ( v116497(VarCurr)
        & v116500(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12748,axiom,
    ! [VarCurr: state_type] :
      ( v116500(VarCurr)
    <=> ( v116412(VarCurr,0)
        | v116477(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12747,axiom,
    ! [VarCurr: state_type] :
      ( v116497(VarCurr)
    <=> ( v116498(VarCurr)
        | v116499(VarCurr) ) ) ).

tff(writeUnaryOperator_6901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116499(VarCurr)
    <=> v116477(VarCurr,0) ) ).

tff(writeUnaryOperator_6900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116498(VarCurr)
    <=> v116412(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12746,axiom,
    ! [VarCurr: state_type] :
      ( v116491(VarCurr)
    <=> ( v116492(VarCurr)
        & v116495(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12745,axiom,
    ! [VarCurr: state_type] :
      ( v116495(VarCurr)
    <=> ( v116411(VarCurr)
        | v116478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12744,axiom,
    ! [VarCurr: state_type] :
      ( v116492(VarCurr)
    <=> ( v116493(VarCurr)
        | v116494(VarCurr) ) ) ).

tff(writeUnaryOperator_6899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116494(VarCurr)
    <=> v116478(VarCurr) ) ).

tff(writeUnaryOperator_6898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116493(VarCurr)
    <=> v116411(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12743,axiom,
    ! [VarCurr: state_type] :
      ( v116406(VarCurr)
    <=> ( v116407(VarCurr)
        & v116490(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12742,axiom,
    ! [VarCurr: state_type] :
      ( v116490(VarCurr)
    <=> ( v116409(VarCurr)
        | v116485(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12741,axiom,
    ! [VarCurr: state_type] :
      ( v116407(VarCurr)
    <=> ( v116408(VarCurr)
        | v116484(VarCurr) ) ) ).

tff(writeUnaryOperator_6897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116484(VarCurr)
    <=> v116485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12740,axiom,
    ! [VarCurr: state_type] :
      ( v116485(VarCurr)
    <=> ( v116486(VarCurr)
        & v116489(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4966,axiom,
    ! [VarCurr: state_type] :
      ( v116489(VarCurr)
    <=> ( v116412(VarCurr,2)
        | v116477(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12739,axiom,
    ! [VarCurr: state_type] :
      ( v116486(VarCurr)
    <=> ( v116487(VarCurr)
        | v116488(VarCurr) ) ) ).

tff(writeUnaryOperator_6896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116488(VarCurr)
    <=> v116477(VarCurr,2) ) ).

tff(writeUnaryOperator_6895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116487(VarCurr)
    <=> v116412(VarCurr,2) ) ).

tff(writeUnaryOperator_6894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116408(VarCurr)
    <=> v116409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12738,axiom,
    ! [VarCurr: state_type] :
      ( v116409(VarCurr)
    <=> ( v116410(VarCurr)
        | v116483(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4965,axiom,
    ! [VarCurr: state_type] :
      ( v116483(VarCurr)
    <=> ( v116412(VarCurr,1)
        & v116477(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12737,axiom,
    ! [VarCurr: state_type] :
      ( v116410(VarCurr)
    <=> ( v116411(VarCurr)
        & v116478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12736,axiom,
    ! [VarCurr: state_type] :
      ( v116478(VarCurr)
    <=> ( v116479(VarCurr)
        & v116482(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4964,axiom,
    ! [VarCurr: state_type] :
      ( v116482(VarCurr)
    <=> ( v116412(VarCurr,1)
        | v116477(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12735,axiom,
    ! [VarCurr: state_type] :
      ( v116479(VarCurr)
    <=> ( v116480(VarCurr)
        | v116481(VarCurr) ) ) ).

tff(writeUnaryOperator_6893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116481(VarCurr)
    <=> v116477(VarCurr,1) ) ).

tff(writeUnaryOperator_6892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116480(VarCurr)
    <=> v116412(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12734,axiom,
    ! [VarCurr: state_type] :
      ( v116411(VarCurr)
    <=> ( v116412(VarCurr,0)
        & v116477(VarCurr,0) ) ) ).

tff(addAssignment_68533,axiom,
    ! [VarCurr: state_type] :
      ( v116477(VarCurr,0)
    <=> v116373(VarCurr) ) ).

tff(addAssignment_68532,axiom,
    ! [VarCurr: state_type] :
      ( ( v116477(VarCurr,2)
      <=> $false )
      & ( v116477(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68531,axiom,
    ! [VarCurr: state_type] :
      ( v116412(VarCurr,0)
    <=> v116472(VarCurr) ) ).

tff(addAssignment_68530,axiom,
    ! [VarCurr: state_type] :
      ( v116412(VarCurr,1)
    <=> v116467(VarCurr) ) ).

tff(addAssignment_68529,axiom,
    ! [VarCurr: state_type] :
      ( v116412(VarCurr,2)
    <=> v116414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12733,axiom,
    ! [VarCurr: state_type] :
      ( v116472(VarCurr)
    <=> ( v116473(VarCurr)
        & v116476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12732,axiom,
    ! [VarCurr: state_type] :
      ( v116476(VarCurr)
    <=> ( v116420(VarCurr,0)
        | v116453(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12731,axiom,
    ! [VarCurr: state_type] :
      ( v116473(VarCurr)
    <=> ( v116474(VarCurr)
        | v116475(VarCurr) ) ) ).

tff(writeUnaryOperator_6891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116475(VarCurr)
    <=> v116453(VarCurr,0) ) ).

tff(writeUnaryOperator_6890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116474(VarCurr)
    <=> v116420(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12730,axiom,
    ! [VarCurr: state_type] :
      ( v116467(VarCurr)
    <=> ( v116468(VarCurr)
        & v116471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12729,axiom,
    ! [VarCurr: state_type] :
      ( v116471(VarCurr)
    <=> ( v116419(VarCurr)
        | v116454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12728,axiom,
    ! [VarCurr: state_type] :
      ( v116468(VarCurr)
    <=> ( v116469(VarCurr)
        | v116470(VarCurr) ) ) ).

tff(writeUnaryOperator_6889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116470(VarCurr)
    <=> v116454(VarCurr) ) ).

tff(writeUnaryOperator_6888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116469(VarCurr)
    <=> v116419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12727,axiom,
    ! [VarCurr: state_type] :
      ( v116414(VarCurr)
    <=> ( v116415(VarCurr)
        & v116466(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12726,axiom,
    ! [VarCurr: state_type] :
      ( v116466(VarCurr)
    <=> ( v116417(VarCurr)
        | v116461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12725,axiom,
    ! [VarCurr: state_type] :
      ( v116415(VarCurr)
    <=> ( v116416(VarCurr)
        | v116460(VarCurr) ) ) ).

tff(writeUnaryOperator_6887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116460(VarCurr)
    <=> v116461(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12724,axiom,
    ! [VarCurr: state_type] :
      ( v116461(VarCurr)
    <=> ( v116462(VarCurr)
        & v116465(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4963,axiom,
    ! [VarCurr: state_type] :
      ( v116465(VarCurr)
    <=> ( v116420(VarCurr,2)
        | v116453(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12723,axiom,
    ! [VarCurr: state_type] :
      ( v116462(VarCurr)
    <=> ( v116463(VarCurr)
        | v116464(VarCurr) ) ) ).

tff(writeUnaryOperator_6886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116464(VarCurr)
    <=> v116453(VarCurr,2) ) ).

tff(writeUnaryOperator_6885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116463(VarCurr)
    <=> v116420(VarCurr,2) ) ).

tff(writeUnaryOperator_6884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116416(VarCurr)
    <=> v116417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12722,axiom,
    ! [VarCurr: state_type] :
      ( v116417(VarCurr)
    <=> ( v116418(VarCurr)
        | v116459(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4962,axiom,
    ! [VarCurr: state_type] :
      ( v116459(VarCurr)
    <=> ( v116420(VarCurr,1)
        & v116453(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12721,axiom,
    ! [VarCurr: state_type] :
      ( v116418(VarCurr)
    <=> ( v116419(VarCurr)
        & v116454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12720,axiom,
    ! [VarCurr: state_type] :
      ( v116454(VarCurr)
    <=> ( v116455(VarCurr)
        & v116458(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4961,axiom,
    ! [VarCurr: state_type] :
      ( v116458(VarCurr)
    <=> ( v116420(VarCurr,1)
        | v116453(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12719,axiom,
    ! [VarCurr: state_type] :
      ( v116455(VarCurr)
    <=> ( v116456(VarCurr)
        | v116457(VarCurr) ) ) ).

tff(writeUnaryOperator_6883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116457(VarCurr)
    <=> v116453(VarCurr,1) ) ).

tff(writeUnaryOperator_6882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116456(VarCurr)
    <=> v116420(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12718,axiom,
    ! [VarCurr: state_type] :
      ( v116419(VarCurr)
    <=> ( v116420(VarCurr,0)
        & v116453(VarCurr,0) ) ) ).

tff(addAssignment_68528,axiom,
    ! [VarCurr: state_type] :
      ( v116453(VarCurr,0)
    <=> v116371(VarCurr) ) ).

tff(addAssignment_68527,axiom,
    ! [VarCurr: state_type] :
      ( ( v116453(VarCurr,2)
      <=> $false )
      & ( v116453(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68526,axiom,
    ! [VarCurr: state_type] :
      ( v116420(VarCurr,0)
    <=> v116448(VarCurr) ) ).

tff(addAssignment_68525,axiom,
    ! [VarCurr: state_type] :
      ( v116420(VarCurr,1)
    <=> v116443(VarCurr) ) ).

tff(addAssignment_68524,axiom,
    ! [VarCurr: state_type] :
      ( v116420(VarCurr,2)
    <=> v116422(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12717,axiom,
    ! [VarCurr: state_type] :
      ( v116448(VarCurr)
    <=> ( v116449(VarCurr)
        & v116452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12716,axiom,
    ! [VarCurr: state_type] :
      ( v116452(VarCurr)
    <=> ( v116428(VarCurr,0)
        | v116429(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12715,axiom,
    ! [VarCurr: state_type] :
      ( v116449(VarCurr)
    <=> ( v116450(VarCurr)
        | v116451(VarCurr) ) ) ).

tff(writeUnaryOperator_6881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116451(VarCurr)
    <=> v116429(VarCurr,0) ) ).

tff(writeUnaryOperator_6880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116450(VarCurr)
    <=> v116428(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12714,axiom,
    ! [VarCurr: state_type] :
      ( v116443(VarCurr)
    <=> ( v116444(VarCurr)
        & v116447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12713,axiom,
    ! [VarCurr: state_type] :
      ( v116447(VarCurr)
    <=> ( v116427(VarCurr)
        | v116430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12712,axiom,
    ! [VarCurr: state_type] :
      ( v116444(VarCurr)
    <=> ( v116445(VarCurr)
        | v116446(VarCurr) ) ) ).

tff(writeUnaryOperator_6879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116446(VarCurr)
    <=> v116430(VarCurr) ) ).

tff(writeUnaryOperator_6878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116445(VarCurr)
    <=> v116427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12711,axiom,
    ! [VarCurr: state_type] :
      ( v116422(VarCurr)
    <=> ( v116423(VarCurr)
        & v116442(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12710,axiom,
    ! [VarCurr: state_type] :
      ( v116442(VarCurr)
    <=> ( v116425(VarCurr)
        | v116437(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12709,axiom,
    ! [VarCurr: state_type] :
      ( v116423(VarCurr)
    <=> ( v116424(VarCurr)
        | v116436(VarCurr) ) ) ).

tff(writeUnaryOperator_6877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116436(VarCurr)
    <=> v116437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12708,axiom,
    ! [VarCurr: state_type] :
      ( v116437(VarCurr)
    <=> ( v116438(VarCurr)
        & v116441(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4960,axiom,
    ! [VarCurr: state_type] :
      ( v116441(VarCurr)
    <=> ( v116428(VarCurr,2)
        | v116429(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12707,axiom,
    ! [VarCurr: state_type] :
      ( v116438(VarCurr)
    <=> ( v116439(VarCurr)
        | v116440(VarCurr) ) ) ).

tff(writeUnaryOperator_6876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116440(VarCurr)
    <=> v116429(VarCurr,2) ) ).

tff(writeUnaryOperator_6875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116439(VarCurr)
    <=> v116428(VarCurr,2) ) ).

tff(writeUnaryOperator_6874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116424(VarCurr)
    <=> v116425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12706,axiom,
    ! [VarCurr: state_type] :
      ( v116425(VarCurr)
    <=> ( v116426(VarCurr)
        | v116435(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4959,axiom,
    ! [VarCurr: state_type] :
      ( v116435(VarCurr)
    <=> ( v116428(VarCurr,1)
        & v116429(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12705,axiom,
    ! [VarCurr: state_type] :
      ( v116426(VarCurr)
    <=> ( v116427(VarCurr)
        & v116430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12704,axiom,
    ! [VarCurr: state_type] :
      ( v116430(VarCurr)
    <=> ( v116431(VarCurr)
        & v116434(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4958,axiom,
    ! [VarCurr: state_type] :
      ( v116434(VarCurr)
    <=> ( v116428(VarCurr,1)
        | v116429(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12703,axiom,
    ! [VarCurr: state_type] :
      ( v116431(VarCurr)
    <=> ( v116432(VarCurr)
        | v116433(VarCurr) ) ) ).

tff(writeUnaryOperator_6873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116433(VarCurr)
    <=> v116429(VarCurr,1) ) ).

tff(writeUnaryOperator_6872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116432(VarCurr)
    <=> v116428(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12702,axiom,
    ! [VarCurr: state_type] :
      ( v116427(VarCurr)
    <=> ( v116428(VarCurr,0)
        & v116429(VarCurr,0) ) ) ).

tff(addAssignment_68523,axiom,
    ! [VarCurr: state_type] :
      ( v116429(VarCurr,0)
    <=> v116369(VarCurr) ) ).

tff(addAssignment_68522,axiom,
    ! [VarCurr: state_type] :
      ( ( v116429(VarCurr,2)
      <=> $false )
      & ( v116429(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68521,axiom,
    ! [VarCurr: state_type] :
      ( v116428(VarCurr,0)
    <=> v116367(VarCurr) ) ).

tff(addAssignment_68520,axiom,
    ! [VarCurr: state_type] :
      ( ( v116428(VarCurr,2)
      <=> $false )
      & ( v116428(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68519,axiom,
    ! [VarCurr: state_type] :
      ( v116379(VarCurr)
    <=> v114692(VarCurr,3) ) ).

tff(addAssignment_68518,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,3)
    <=> v114694(VarCurr,3) ) ).

tff(addAssignment_68517,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,3)
    <=> v114696(VarCurr,3) ) ).

tff(addAssignment_68516,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,3)
    <=> v114697(VarCurr,3) ) ).

tff(addAssignment_68515,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,3)
    <=> v113918(VarCurr,3) ) ).

tff(addAssignment_68514,axiom,
    ! [VarCurr: state_type] :
      ( v116377(VarCurr)
    <=> v114685(VarCurr,3) ) ).

tff(addAssignment_68513,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,3)
    <=> v114686(VarCurr,3) ) ).

tff(addAssignment_68512,axiom,
    ! [VarCurr: state_type] :
      ( v116375(VarCurr)
    <=> v114661(VarCurr,3) ) ).

tff(addAssignment_68511,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,3)
    <=> v114662(VarCurr,3) ) ).

tff(addAssignment_68510,axiom,
    ! [VarCurr: state_type] :
      ( v116373(VarCurr)
    <=> v114633(VarCurr,3) ) ).

tff(addAssignment_68509,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,3)
    <=> v114635(VarCurr,3) ) ).

tff(addAssignment_68508,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,3)
    <=> v114637(VarCurr,3) ) ).

tff(addAssignment_68507,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,3)
    <=> v114638(VarCurr,3) ) ).

tff(addAssignment_68506,axiom,
    ! [VarCurr: state_type] :
      ( v116371(VarCurr)
    <=> v114605(VarCurr,3) ) ).

tff(addAssignment_68505,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,3)
    <=> v114607(VarCurr,3) ) ).

tff(addAssignment_68504,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,3)
    <=> v114609(VarCurr,3) ) ).

tff(addAssignment_68503,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,3)
    <=> v114610(VarCurr,3) ) ).

tff(addAssignment_68502,axiom,
    ! [VarCurr: state_type] :
      ( v116369(VarCurr)
    <=> v114577(VarCurr,3) ) ).

tff(addAssignment_68501,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,3)
    <=> v114579(VarCurr,3) ) ).

tff(addAssignment_68500,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,3)
    <=> v114581(VarCurr,3) ) ).

tff(addAssignment_68499,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,3)
    <=> v114582(VarCurr,3) ) ).

tff(addAssignment_68498,axiom,
    ! [VarCurr: state_type] :
      ( v116367(VarCurr)
    <=> v114549(VarCurr,3) ) ).

tff(addAssignment_68497,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,3)
    <=> v114551(VarCurr,3) ) ).

tff(addAssignment_68496,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,3)
    <=> v114553(VarCurr,3) ) ).

tff(addAssignment_68495,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,3)
    <=> v114554(VarCurr,3) ) ).

tff(addAssignment_68494,axiom,
    ! [VarCurr: state_type] :
      ( v116363(VarCurr)
    <=> v85774(VarCurr) ) ).

tff(addAssignment_68493,axiom,
    ! [VarCurr: state_type] :
      ( v116351(VarCurr)
    <=> v116353(VarCurr) ) ).

tff(addAssignment_68492,axiom,
    ! [VarCurr: state_type] :
      ( v116353(VarCurr)
    <=> v116327(VarCurr) ) ).

tff(addAssignment_68491,axiom,
    ! [VarCurr: state_type] :
      ( v116347(VarCurr)
    <=> v116349(VarCurr) ) ).

tff(addAssignment_68490,axiom,
    ! [VarCurr: state_type] :
      ( v116349(VarCurr)
    <=> v116319(VarCurr) ) ).

tff(addAssignment_68489,axiom,
    ! [VarCurr: state_type] :
      ( v116323(VarCurr)
    <=> v116325(VarCurr) ) ).

tff(addAssignment_68488,axiom,
    ! [VarCurr: state_type] :
      ( v116325(VarCurr)
    <=> v116327(VarCurr) ) ).

tff(addAssignment_68487,axiom,
    ! [VarCurr: state_type] :
      ( v116327(VarCurr)
    <=> v116329(VarCurr) ) ).

tff(addAssignment_68486,axiom,
    ! [VarCurr: state_type] :
      ( v116329(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_68485,axiom,
    ! [VarCurr: state_type] :
      ( v116315(VarCurr)
    <=> v116317(VarCurr) ) ).

tff(addAssignment_68484,axiom,
    ! [VarCurr: state_type] :
      ( v116317(VarCurr)
    <=> v116319(VarCurr) ) ).

tff(addAssignment_68483,axiom,
    ! [VarCurr: state_type] :
      ( v116319(VarCurr)
    <=> v116321(VarCurr) ) ).

tff(addAssignment_68482,axiom,
    ! [VarCurr: state_type] :
      ( v116321(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12701,axiom,
    ! [VarCurr: state_type] :
      ( v115500(VarCurr)
    <=> ( v116305(VarCurr)
        & v116215(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4957,axiom,
    ! [VarCurr: state_type] :
      ( v116305(VarCurr)
    <=> ( v115502(VarCurr,1)
        & v116154(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1158,axiom,
    ! [VarCurr: state_type] :
      ( v116215(VarCurr)
    <=> ( ( v116217(VarCurr,4)
        <=> $false )
        & ( v116217(VarCurr,3)
        <=> $false )
        & ( v116217(VarCurr,2)
        <=> $false )
        & ( v116217(VarCurr,1)
        <=> $false )
        & ( v116217(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116217(VarCurr,B)
      <=> v116219(VarCurr,B) ) ) ).

tff(addAssignment_68480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116219(VarCurr,B)
      <=> v116221(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116287(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v116221(VarNext,B)
            <=> v116221(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1513,axiom,
    ! [VarNext: state_type] :
      ( v116287(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116221(VarNext,B)
          <=> v116297(VarNext,B) ) ) ) ).

tff(addAssignment_68479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116297(VarNext,B)
          <=> v116295(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116298(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116295(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1058,axiom,
    ! [VarCurr: state_type] :
      ( v116298(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116295(VarCurr,B)
          <=> v116231(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12700,axiom,
    ! [VarCurr: state_type] :
      ( v116298(VarCurr)
    <=> ( v116299(VarCurr)
        & v116300(VarCurr) ) ) ).

tff(writeUnaryOperator_6871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116300(VarCurr)
    <=> v116227(VarCurr) ) ).

tff(writeUnaryOperator_6870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116299(VarCurr)
    <=> v116223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116287(VarNext)
      <=> v116288(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116288(VarNext)
      <=> ( v116289(VarNext)
          & v116282(VarNext) ) ) ) ).

tff(writeUnaryOperator_6869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116289(VarNext)
      <=> v116291(VarNext) ) ) ).

tff(addAssignment_68478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116291(VarNext)
      <=> v116282(VarCurr) ) ) ).

tff(addAssignment_68477,axiom,
    ! [VarCurr: state_type] :
      ( v116282(VarCurr)
    <=> v116284(VarCurr) ) ).

tff(addAssignment_68476,axiom,
    ! [VarCurr: state_type] :
      ( v116284(VarCurr)
    <=> v115988(VarCurr) ) ).

tff(addAssignment_68475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116231(VarCurr,B)
      <=> v116233(VarCurr,B) ) ) ).

tff(addAssignment_68474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116233(VarCurr,B)
      <=> v116235(VarCurr,B) ) ) ).

tff(addAssignment_68473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116235(VarCurr,B)
      <=> v116237(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116237(VarCurr,B)
          <=> v116251(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1057,axiom,
    ! [VarCurr: state_type] :
      ( v116239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116237(VarCurr,B)
          <=> v116244(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116246(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116251(VarCurr,B)
          <=> v116252(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1056,axiom,
    ! [VarCurr: state_type] :
      ( v116246(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116251(VarCurr,B)
          <=> v116249(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116215(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116252(VarCurr,B)
          <=> v116253(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1055,axiom,
    ! [VarCurr: state_type] :
      ( v116215(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v116252(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68472,axiom,
    ! [VarCurr: state_type] :
      ( v116253(VarCurr,0)
    <=> v116279(VarCurr) ) ).

tff(addAssignment_68471,axiom,
    ! [VarCurr: state_type] :
      ( v116253(VarCurr,1)
    <=> v116277(VarCurr) ) ).

tff(addAssignment_68470,axiom,
    ! [VarCurr: state_type] :
      ( v116253(VarCurr,2)
    <=> v116273(VarCurr) ) ).

tff(addAssignment_68469,axiom,
    ! [VarCurr: state_type] :
      ( v116253(VarCurr,3)
    <=> v116269(VarCurr) ) ).

tff(addAssignment_68468,axiom,
    ! [VarCurr: state_type] :
      ( v116253(VarCurr,4)
    <=> v116255(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12697,axiom,
    ! [VarCurr: state_type] :
      ( v116277(VarCurr)
    <=> ( v116278(VarCurr)
        & v116280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12696,axiom,
    ! [VarCurr: state_type] :
      ( v116280(VarCurr)
    <=> ( v116217(VarCurr,0)
        | v116264(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4956,axiom,
    ! [VarCurr: state_type] :
      ( v116278(VarCurr)
    <=> ( v116279(VarCurr)
        | v116217(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116279(VarCurr)
    <=> v116217(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12695,axiom,
    ! [VarCurr: state_type] :
      ( v116273(VarCurr)
    <=> ( v116274(VarCurr)
        & v116276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12694,axiom,
    ! [VarCurr: state_type] :
      ( v116276(VarCurr)
    <=> ( v116262(VarCurr)
        | v116265(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4955,axiom,
    ! [VarCurr: state_type] :
      ( v116274(VarCurr)
    <=> ( v116275(VarCurr)
        | v116217(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116275(VarCurr)
    <=> v116262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12693,axiom,
    ! [VarCurr: state_type] :
      ( v116269(VarCurr)
    <=> ( v116270(VarCurr)
        & v116272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12692,axiom,
    ! [VarCurr: state_type] :
      ( v116272(VarCurr)
    <=> ( v116260(VarCurr)
        | v116266(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4954,axiom,
    ! [VarCurr: state_type] :
      ( v116270(VarCurr)
    <=> ( v116271(VarCurr)
        | v116217(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116271(VarCurr)
    <=> v116260(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12691,axiom,
    ! [VarCurr: state_type] :
      ( v116255(VarCurr)
    <=> ( v116256(VarCurr)
        & v116267(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12690,axiom,
    ! [VarCurr: state_type] :
      ( v116267(VarCurr)
    <=> ( v116258(VarCurr)
        | v116268(VarCurr) ) ) ).

tff(writeUnaryOperator_6865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116268(VarCurr)
    <=> v116217(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4953,axiom,
    ! [VarCurr: state_type] :
      ( v116256(VarCurr)
    <=> ( v116257(VarCurr)
        | v116217(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116257(VarCurr)
    <=> v116258(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4952,axiom,
    ! [VarCurr: state_type] :
      ( v116258(VarCurr)
    <=> ( v116217(VarCurr,3)
        | v116259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12689,axiom,
    ! [VarCurr: state_type] :
      ( v116259(VarCurr)
    <=> ( v116260(VarCurr)
        & v116266(VarCurr) ) ) ).

tff(writeUnaryOperator_6863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116266(VarCurr)
    <=> v116217(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4951,axiom,
    ! [VarCurr: state_type] :
      ( v116260(VarCurr)
    <=> ( v116217(VarCurr,2)
        | v116261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12688,axiom,
    ! [VarCurr: state_type] :
      ( v116261(VarCurr)
    <=> ( v116262(VarCurr)
        & v116265(VarCurr) ) ) ).

tff(writeUnaryOperator_6862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116265(VarCurr)
    <=> v116217(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4950,axiom,
    ! [VarCurr: state_type] :
      ( v116262(VarCurr)
    <=> ( v116217(VarCurr,1)
        | v116263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12687,axiom,
    ! [VarCurr: state_type] :
      ( v116263(VarCurr)
    <=> ( v116217(VarCurr,0)
        & v116264(VarCurr) ) ) ).

tff(writeUnaryOperator_6861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116264(VarCurr)
    <=> v116217(VarCurr,1) ) ).

tff(addAssignment_68467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116249(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12686,axiom,
    ! [VarCurr: state_type] :
      ( v116246(VarCurr)
    <=> ( v115789(VarCurr)
        | v115803(VarCurr) ) ) ).

tff(addAssignment_68466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v116244(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12685,axiom,
    ! [VarCurr: state_type] :
      ( v116239(VarCurr)
    <=> ( v116241(VarCurr)
        | v115801(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12684,axiom,
    ! [VarCurr: state_type] :
      ( v116241(VarCurr)
    <=> ( v116242(VarCurr)
        | v115799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12683,axiom,
    ! [VarCurr: state_type] :
      ( v116242(VarCurr)
    <=> ( v115769(VarCurr)
        | v115779(VarCurr) ) ) ).

tff(addAssignment_68465,axiom,
    ! [VarCurr: state_type] :
      ( v116227(VarCurr)
    <=> v116229(VarCurr) ) ).

tff(addAssignment_68464,axiom,
    ! [VarCurr: state_type] :
      ( v116229(VarCurr)
    <=> v115520(VarCurr) ) ).

tff(addAssignment_68463,axiom,
    ! [VarCurr: state_type] :
      ( v116223(VarCurr)
    <=> v116225(VarCurr) ) ).

tff(addAssignment_68462,axiom,
    ! [VarCurr: state_type] :
      ( v116225(VarCurr)
    <=> v115512(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1157,axiom,
    ! [VarCurr: state_type] :
      ( v116154(VarCurr)
    <=> ( ( v116156(VarCurr,1)
        <=> $false )
        & ( v116156(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116156(VarCurr,B)
      <=> v116158(VarCurr,B) ) ) ).

tff(addAssignment_68460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116158(VarCurr,B)
      <=> v116160(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116197(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v116160(VarNext,B)
            <=> v116160(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1512,axiom,
    ! [VarNext: state_type] :
      ( v116197(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116160(VarNext,B)
          <=> v116207(VarNext,B) ) ) ) ).

tff(addAssignment_68459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116207(VarNext,B)
          <=> v116205(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116205(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1054,axiom,
    ! [VarCurr: state_type] :
      ( v116208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116205(VarCurr,B)
          <=> v116170(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12682,axiom,
    ! [VarCurr: state_type] :
      ( v116208(VarCurr)
    <=> ( v116209(VarCurr)
        & v116210(VarCurr) ) ) ).

tff(writeUnaryOperator_6860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116210(VarCurr)
    <=> v116166(VarCurr) ) ).

tff(writeUnaryOperator_6859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116209(VarCurr)
    <=> v116162(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116197(VarNext)
      <=> v116198(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116198(VarNext)
      <=> ( v116199(VarNext)
          & v116192(VarNext) ) ) ) ).

tff(writeUnaryOperator_6858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116199(VarNext)
      <=> v116201(VarNext) ) ) ).

tff(addAssignment_68458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116201(VarNext)
      <=> v116192(VarCurr) ) ) ).

tff(addAssignment_68457,axiom,
    ! [VarCurr: state_type] :
      ( v116192(VarCurr)
    <=> v116194(VarCurr) ) ).

tff(addAssignment_68456,axiom,
    ! [VarCurr: state_type] :
      ( v116194(VarCurr)
    <=> v115988(VarCurr) ) ).

tff(addAssignment_68455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116170(VarCurr,B)
      <=> v116172(VarCurr,B) ) ) ).

tff(addAssignment_68454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116172(VarCurr,B)
      <=> v116174(VarCurr,B) ) ) ).

tff(addAssignment_68453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v116174(VarCurr,B)
      <=> v116176(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116176(VarCurr,B)
          <=> v116183(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1053,axiom,
    ! [VarCurr: state_type] :
      ( v116178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116176(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116183(VarCurr,B)
          <=> v116184(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1052,axiom,
    ! [VarCurr: state_type] :
      ( v116154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v116183(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68452,axiom,
    ! [VarCurr: state_type] :
      ( v116184(VarCurr,0)
    <=> v116188(VarCurr) ) ).

tff(addAssignment_68451,axiom,
    ! [VarCurr: state_type] :
      ( v116184(VarCurr,1)
    <=> v116186(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12679,axiom,
    ! [VarCurr: state_type] :
      ( v116186(VarCurr)
    <=> ( v116187(VarCurr)
        & v116189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12678,axiom,
    ! [VarCurr: state_type] :
      ( v116189(VarCurr)
    <=> ( v116156(VarCurr,0)
        | v116190(VarCurr) ) ) ).

tff(writeUnaryOperator_6857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116190(VarCurr)
    <=> v116156(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4949,axiom,
    ! [VarCurr: state_type] :
      ( v116187(VarCurr)
    <=> ( v116188(VarCurr)
        | v116156(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116188(VarCurr)
    <=> v116156(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12677,axiom,
    ! [VarCurr: state_type] :
      ( v116178(VarCurr)
    <=> ( v116180(VarCurr)
        | v116181(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4948,axiom,
    ! [VarCurr: state_type] :
      ( v116181(VarCurr)
    <=> ( v115502(VarCurr,1)
        & v116021(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4947,axiom,
    ! [VarCurr: state_type] :
      ( v116180(VarCurr)
    <=> ( v115502(VarCurr,3)
        & v116079(VarCurr) ) ) ).

tff(addAssignment_68450,axiom,
    ! [VarCurr: state_type] :
      ( v116166(VarCurr)
    <=> v116168(VarCurr) ) ).

tff(addAssignment_68449,axiom,
    ! [VarCurr: state_type] :
      ( v116168(VarCurr)
    <=> v115520(VarCurr) ) ).

tff(addAssignment_68448,axiom,
    ! [VarCurr: state_type] :
      ( v116162(VarCurr)
    <=> v116164(VarCurr) ) ).

tff(addAssignment_68447,axiom,
    ! [VarCurr: state_type] :
      ( v116164(VarCurr)
    <=> v115512(VarCurr) ) ).

tff(addAssignment_68446,axiom,
    ! [VarCurr: state_type] :
      ( v115502(VarCurr,1)
    <=> v115504(VarCurr,1) ) ).

tff(addAssignment_68445,axiom,
    ! [VarCurr: state_type] :
      ( v115504(VarCurr,1)
    <=> v115506(VarCurr,1) ) ).

tff(addAssignment_68444,axiom,
    ! [VarNext: state_type] :
      ( v115506(VarNext,1)
    <=> v116146(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116147(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116146(VarNext,B)
            <=> v115506(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1511,axiom,
    ! [VarNext: state_type] :
      ( v116147(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116146(VarNext,B)
          <=> v116072(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116147(VarNext)
      <=> v116148(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116148(VarNext)
      <=> ( v116150(VarNext)
          & v116057(VarNext) ) ) ) ).

tff(writeUnaryOperator_6855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116150(VarNext)
      <=> v116066(VarNext) ) ) ).

tff(addAssignment_68443,axiom,
    ! [VarCurr: state_type] :
      ( v115524(VarCurr,1)
    <=> v115526(VarCurr,1) ) ).

tff(addAssignment_68442,axiom,
    ! [VarCurr: state_type] :
      ( v115526(VarCurr,1)
    <=> v115528(VarCurr,1) ) ).

tff(addAssignment_68441,axiom,
    ! [VarCurr: state_type] :
      ( v115528(VarCurr,1)
    <=> v116055(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_38,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116137(VarCurr)
     => ( v115530(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_67,axiom,
    ! [VarCurr: state_type] :
      ( v116137(VarCurr)
     => ( v115530(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12674,axiom,
    ! [VarCurr: state_type] :
      ( v116137(VarCurr)
    <=> ( v116138(VarCurr)
        | v116139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12673,axiom,
    ! [VarCurr: state_type] :
      ( v116139(VarCurr)
    <=> ( v116140(VarCurr)
        & v116141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12672,axiom,
    ! [VarCurr: state_type] :
      ( v116141(VarCurr)
    <=> ( v116142(VarCurr)
        & v116038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12671,axiom,
    ! [VarCurr: state_type] :
      ( v116142(VarCurr)
    <=> ( v116143(VarCurr)
        & v116144(VarCurr) ) ) ).

tff(writeUnaryOperator_6854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116144(VarCurr)
    <=> v116030(VarCurr) ) ).

tff(writeUnaryOperator_6853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116143(VarCurr)
    <=> v116021(VarCurr) ) ).

tff(writeUnaryOperator_6852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116140(VarCurr)
    <=> v116040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12670,axiom,
    ! [VarCurr: state_type] :
      ( v116138(VarCurr)
    <=> ( v116112(VarCurr)
        & v116040(VarCurr) ) ) ).

tff(writeUnaryOperator_6851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115502(VarCurr,0)
    <=> v116017(VarCurr) ) ).

tff(addAssignment_68440,axiom,
    ! [VarCurr: state_type] :
      ( v116017(VarCurr)
    <=> v115504(VarCurr,0) ) ).

tff(addAssignment_68439,axiom,
    ! [VarCurr: state_type] :
      ( v115504(VarCurr,0)
    <=> v115506(VarCurr,0) ) ).

tff(addAssignment_68438,axiom,
    ! [VarNext: state_type] :
      ( v115506(VarNext,0)
    <=> v116128(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116129(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116128(VarNext,B)
            <=> v115506(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1510,axiom,
    ! [VarNext: state_type] :
      ( v116129(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116128(VarNext,B)
          <=> v116072(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116129(VarNext)
      <=> v116130(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116130(VarNext)
      <=> ( v116132(VarNext)
          & v116057(VarNext) ) ) ) ).

tff(writeUnaryOperator_6850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116132(VarNext)
      <=> v116066(VarNext) ) ) ).

tff(addAssignment_68437,axiom,
    ! [VarCurr: state_type] :
      ( v115524(VarCurr,0)
    <=> v115526(VarCurr,0) ) ).

tff(addAssignment_68436,axiom,
    ! [VarCurr: state_type] :
      ( v115526(VarCurr,0)
    <=> v115528(VarCurr,0) ) ).

tff(addAssignment_68435,axiom,
    ! [VarCurr: state_type] :
      ( v115528(VarCurr,0)
    <=> v116055(VarCurr,0) ) ).

tff(writeUnaryOperator_6849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116019(VarCurr)
    <=> v115530(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116107(VarCurr)
     => ( v115530(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1051,axiom,
    ! [VarCurr: state_type] :
      ( v116107(VarCurr)
     => ( v115530(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12667,axiom,
    ! [VarCurr: state_type] :
      ( v116107(VarCurr)
    <=> ( v116108(VarCurr)
        | v116121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12666,axiom,
    ! [VarCurr: state_type] :
      ( v116121(VarCurr)
    <=> ( v116122(VarCurr)
        & v116125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12665,axiom,
    ! [VarCurr: state_type] :
      ( v116125(VarCurr)
    <=> ( v116093(VarCurr)
        & v116096(VarCurr) ) ) ).

tff(writeUnaryOperator_6848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116122(VarCurr)
    <=> v116123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12664,axiom,
    ! [VarCurr: state_type] :
      ( v116123(VarCurr)
    <=> ( v116124(VarCurr)
        | v116053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12663,axiom,
    ! [VarCurr: state_type] :
      ( v116124(VarCurr)
    <=> ( v116040(VarCurr)
        | v116038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12662,axiom,
    ! [VarCurr: state_type] :
      ( v116108(VarCurr)
    <=> ( v116109(VarCurr)
        | v116117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12661,axiom,
    ! [VarCurr: state_type] :
      ( v116117(VarCurr)
    <=> ( v116118(VarCurr)
        & v116120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12660,axiom,
    ! [VarCurr: state_type] :
      ( v116120(VarCurr)
    <=> ( v116051(VarCurr)
        & v116053(VarCurr) ) ) ).

tff(writeUnaryOperator_6847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116118(VarCurr)
    <=> v116119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12659,axiom,
    ! [VarCurr: state_type] :
      ( v116119(VarCurr)
    <=> ( v116040(VarCurr)
        | v116038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12658,axiom,
    ! [VarCurr: state_type] :
      ( v116109(VarCurr)
    <=> ( v116110(VarCurr)
        | v116114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12657,axiom,
    ! [VarCurr: state_type] :
      ( v116114(VarCurr)
    <=> ( v116115(VarCurr)
        & v116116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12656,axiom,
    ! [VarCurr: state_type] :
      ( v116116(VarCurr)
    <=> ( v116030(VarCurr)
        & v116038(VarCurr) ) ) ).

tff(writeUnaryOperator_6846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116115(VarCurr)
    <=> v116040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12655,axiom,
    ! [VarCurr: state_type] :
      ( v116110(VarCurr)
    <=> ( v116111(VarCurr)
        & v116040(VarCurr) ) ) ).

tff(writeUnaryOperator_6845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116111(VarCurr)
    <=> v116112(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12654,axiom,
    ! [VarCurr: state_type] :
      ( v116112(VarCurr)
    <=> ( v116113(VarCurr)
        & v116015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12653,axiom,
    ! [VarCurr: state_type] :
      ( v116113(VarCurr)
    <=> ( v115532(VarCurr)
        & v116013(VarCurr) ) ) ).

tff(addAssignment_68434,axiom,
    ! [VarCurr: state_type] :
      ( v115502(VarCurr,3)
    <=> v115504(VarCurr,3) ) ).

tff(addAssignment_68433,axiom,
    ! [VarCurr: state_type] :
      ( v115504(VarCurr,3)
    <=> v115506(VarCurr,3) ) ).

tff(addAssignment_68432,axiom,
    ! [VarNext: state_type] :
      ( v115506(VarNext,3)
    <=> v116099(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116100(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116099(VarNext,B)
            <=> v115506(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1509,axiom,
    ! [VarNext: state_type] :
      ( v116100(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116099(VarNext,B)
          <=> v116072(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116100(VarNext)
      <=> v116101(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116101(VarNext)
      <=> ( v116103(VarNext)
          & v116057(VarNext) ) ) ) ).

tff(writeUnaryOperator_6844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116103(VarNext)
      <=> v116066(VarNext) ) ) ).

tff(addAssignment_68431,axiom,
    ! [VarCurr: state_type] :
      ( v115524(VarCurr,3)
    <=> v115526(VarCurr,3) ) ).

tff(addAssignment_68430,axiom,
    ! [VarCurr: state_type] :
      ( v115526(VarCurr,3)
    <=> v115528(VarCurr,3) ) ).

tff(addAssignment_68429,axiom,
    ! [VarCurr: state_type] :
      ( v115528(VarCurr,3)
    <=> v116055(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_37,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116081(VarCurr)
     => ( v115530(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_66,axiom,
    ! [VarCurr: state_type] :
      ( v116081(VarCurr)
     => ( v115530(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12650,axiom,
    ! [VarCurr: state_type] :
      ( v116081(VarCurr)
    <=> ( v116082(VarCurr)
        | v116088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12649,axiom,
    ! [VarCurr: state_type] :
      ( v116088(VarCurr)
    <=> ( v116089(VarCurr)
        & v116090(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12648,axiom,
    ! [VarCurr: state_type] :
      ( v116090(VarCurr)
    <=> ( v116091(VarCurr)
        & v116097(VarCurr) ) ) ).

tff(writeUnaryOperator_6843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116097(VarCurr)
    <=> v116087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12647,axiom,
    ! [VarCurr: state_type] :
      ( v116091(VarCurr)
    <=> ( v116092(VarCurr)
        & v116096(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1156,axiom,
    ! [VarCurr: state_type] :
      ( v116096(VarCurr)
    <=> ( $true
      <=> v115502(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116092(VarCurr)
    <=> v116093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12646,axiom,
    ! [VarCurr: state_type] :
      ( v116093(VarCurr)
    <=> ( v116094(VarCurr)
        | v116023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12645,axiom,
    ! [VarCurr: state_type] :
      ( v116094(VarCurr)
    <=> ( v116095(VarCurr)
        | v116079(VarCurr) ) ) ).

tff(writeUnaryOperator_6841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116095(VarCurr)
    <=> v116013(VarCurr) ) ).

tff(writeUnaryOperator_6840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116089(VarCurr)
    <=> v116053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12644,axiom,
    ! [VarCurr: state_type] :
      ( v116082(VarCurr)
    <=> ( v116083(VarCurr)
        & v116086(VarCurr) ) ) ).

tff(writeUnaryOperator_6839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116086(VarCurr)
    <=> v116087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12643,axiom,
    ! [VarCurr: state_type] :
      ( v116087(VarCurr)
    <=> ( v116040(VarCurr)
        | v116038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12642,axiom,
    ! [VarCurr: state_type] :
      ( v116083(VarCurr)
    <=> ( v116084(VarCurr)
        & v116053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12641,axiom,
    ! [VarCurr: state_type] :
      ( v116084(VarCurr)
    <=> ( v116047(VarCurr)
        & v116085(VarCurr) ) ) ).

tff(writeUnaryOperator_6838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116085(VarCurr)
    <=> v116051(VarCurr) ) ).

tff(addAssignment_68428,axiom,
    ! [VarCurr: state_type] :
      ( v116079(VarCurr)
    <=> v112831(VarCurr,2) ) ).

tff(addAssignment_68427,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,2)
    <=> v112865(VarCurr,2) ) ).

tff(addAssignment_68426,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,2)
    <=> v112849(VarCurr,2) ) ).

tff(addAssignment_68425,axiom,
    ! [VarCurr: state_type] :
      ( v115502(VarCurr,2)
    <=> v115504(VarCurr,2) ) ).

tff(addAssignment_68424,axiom,
    ! [VarCurr: state_type] :
      ( v115504(VarCurr,2)
    <=> v115506(VarCurr,2) ) ).

tff(addAssignment_68423,axiom,
    ! [VarNext: state_type] :
      ( v115506(VarNext,2)
    <=> v116061(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116062(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v116061(VarNext,B)
            <=> v115506(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1508,axiom,
    ! [VarNext: state_type] :
      ( v116062(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116061(VarNext,B)
          <=> v116072(VarNext,B) ) ) ) ).

tff(addAssignment_68422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116072(VarNext,B)
          <=> v116070(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116073(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116070(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1050,axiom,
    ! [VarCurr: state_type] :
      ( v116073(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v116070(VarCurr,B)
          <=> v115524(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12640,axiom,
    ! [VarCurr: state_type] :
      ( v116073(VarCurr)
    <=> ( v116074(VarCurr)
        & v116075(VarCurr) ) ) ).

tff(writeUnaryOperator_6837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116075(VarCurr)
    <=> v115516(VarCurr) ) ).

tff(writeUnaryOperator_6836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116074(VarCurr)
    <=> v115508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116062(VarNext)
      <=> v116063(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116063(VarNext)
      <=> ( v116064(VarNext)
          & v116057(VarNext) ) ) ) ).

tff(writeUnaryOperator_6835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v116064(VarNext)
      <=> v116066(VarNext) ) ) ).

tff(addAssignment_68421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v116066(VarNext)
      <=> v116057(VarCurr) ) ) ).

tff(addAssignment_68420,axiom,
    ! [VarCurr: state_type] :
      ( v116057(VarCurr)
    <=> v116059(VarCurr) ) ).

tff(addAssignment_68419,axiom,
    ! [VarCurr: state_type] :
      ( v116059(VarCurr)
    <=> v115988(VarCurr) ) ).

tff(addAssignment_68418,axiom,
    ! [VarCurr: state_type] :
      ( v115524(VarCurr,2)
    <=> v115526(VarCurr,2) ) ).

tff(addAssignment_68417,axiom,
    ! [VarCurr: state_type] :
      ( v115526(VarCurr,2)
    <=> v115528(VarCurr,2) ) ).

tff(addAssignment_68416,axiom,
    ! [VarCurr: state_type] :
      ( v115528(VarCurr,2)
    <=> v116055(VarCurr,2) ) ).

tff(addAssignment_68415,axiom,
    ! [VarCurr: state_type] :
      ( v116055(VarCurr,0)
    <=> v116019(VarCurr) ) ).

tff(addAssignment_68414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v116055(VarCurr,B)
      <=> v115530(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_36,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116025(VarCurr)
     => ( v115530(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_65,axiom,
    ! [VarCurr: state_type] :
      ( v116025(VarCurr)
     => ( v115530(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12637,axiom,
    ! [VarCurr: state_type] :
      ( v116025(VarCurr)
    <=> ( v116026(VarCurr)
        | v116041(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12636,axiom,
    ! [VarCurr: state_type] :
      ( v116041(VarCurr)
    <=> ( v116042(VarCurr)
        & v116043(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12635,axiom,
    ! [VarCurr: state_type] :
      ( v116043(VarCurr)
    <=> ( v116044(VarCurr)
        & v116054(VarCurr) ) ) ).

tff(writeUnaryOperator_6834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116054(VarCurr)
    <=> v116040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12634,axiom,
    ! [VarCurr: state_type] :
      ( v116044(VarCurr)
    <=> ( v116045(VarCurr)
        & v116053(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1155,axiom,
    ! [VarCurr: state_type] :
      ( v116053(VarCurr)
    <=> ( $true
      <=> v115502(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12633,axiom,
    ! [VarCurr: state_type] :
      ( v116045(VarCurr)
    <=> ( v116046(VarCurr)
        & v116050(VarCurr) ) ) ).

tff(writeUnaryOperator_6833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116050(VarCurr)
    <=> v116051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12632,axiom,
    ! [VarCurr: state_type] :
      ( v116051(VarCurr)
    <=> ( v116052(VarCurr)
        | v116023(VarCurr) ) ) ).

tff(writeUnaryOperator_6832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116052(VarCurr)
    <=> v116013(VarCurr) ) ).

tff(writeUnaryOperator_6831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116046(VarCurr)
    <=> v116047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12631,axiom,
    ! [VarCurr: state_type] :
      ( v116047(VarCurr)
    <=> ( v116048(VarCurr)
        | v116049(VarCurr) ) ) ).

tff(writeUnaryOperator_6830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116049(VarCurr)
    <=> v116015(VarCurr) ) ).

tff(writeUnaryOperator_6829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116048(VarCurr)
    <=> v115532(VarCurr) ) ).

tff(writeUnaryOperator_6828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116042(VarCurr)
    <=> v116038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12630,axiom,
    ! [VarCurr: state_type] :
      ( v116026(VarCurr)
    <=> ( v116027(VarCurr)
        & v116039(VarCurr) ) ) ).

tff(writeUnaryOperator_6827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116039(VarCurr)
    <=> v116040(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1154,axiom,
    ! [VarCurr: state_type] :
      ( v116040(VarCurr)
    <=> ( $true
      <=> v115502(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12629,axiom,
    ! [VarCurr: state_type] :
      ( v116027(VarCurr)
    <=> ( v116028(VarCurr)
        & v116038(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1153,axiom,
    ! [VarCurr: state_type] :
      ( v116038(VarCurr)
    <=> ( $true
      <=> v115502(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12628,axiom,
    ! [VarCurr: state_type] :
      ( v116028(VarCurr)
    <=> ( v116021(VarCurr)
        & v116029(VarCurr) ) ) ).

tff(writeUnaryOperator_6826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116029(VarCurr)
    <=> v116030(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12627,axiom,
    ! [VarCurr: state_type] :
      ( v116030(VarCurr)
    <=> ( v116031(VarCurr)
        | v116023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12626,axiom,
    ! [VarCurr: state_type] :
      ( v116031(VarCurr)
    <=> ( v116032(VarCurr)
        | v116035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12625,axiom,
    ! [VarCurr: state_type] :
      ( v116035(VarCurr)
    <=> ( v116036(VarCurr)
        & v116037(VarCurr) ) ) ).

tff(writeUnaryOperator_6825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116037(VarCurr)
    <=> v116021(VarCurr) ) ).

tff(writeUnaryOperator_6824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116036(VarCurr)
    <=> v115532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12624,axiom,
    ! [VarCurr: state_type] :
      ( v116032(VarCurr)
    <=> ( v116033(VarCurr)
        | v116034(VarCurr) ) ) ).

tff(writeUnaryOperator_6823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116034(VarCurr)
    <=> v116015(VarCurr) ) ).

tff(writeUnaryOperator_6822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116033(VarCurr)
    <=> v116013(VarCurr) ) ).

tff(addAssignment_68413,axiom,
    ! [VarCurr: state_type] :
      ( v116023(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_68412,axiom,
    ! [VarCurr: state_type] :
      ( v116021(VarCurr)
    <=> v112643(VarCurr,2) ) ).

tff(addAssignment_68411,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,2)
    <=> v115202(VarCurr,2) ) ).

tff(addAssignment_68410,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,2)
    <=> v115186(VarCurr,2) ) ).

tff(addAssignment_68409,axiom,
    ! [VarCurr: state_type] :
      ( v116015(VarCurr)
    <=> v112528(VarCurr,2) ) ).

tff(addAssignment_68408,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,2)
    <=> v112530(VarCurr,2) ) ).

tff(addAssignment_68407,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,2)
    <=> v112590(VarCurr,2) ) ).

tff(addAssignment_68406,axiom,
    ! [VarCurr: state_type] :
      ( v116013(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12623,axiom,
    ! [VarCurr: state_type] :
      ( v115532(VarCurr)
    <=> ( v116010(VarCurr)
        & v116011(VarCurr) ) ) ).

tff(writeUnaryOperator_6821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116011(VarCurr)
    <=> v116008(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1152,axiom,
    ! [VarCurr: state_type] :
      ( v116010(VarCurr)
    <=> ( ( v115534(VarCurr,5)
        <=> $false )
        & ( v115534(VarCurr,4)
        <=> $false )
        & ( v115534(VarCurr,3)
        <=> $false )
        & ( v115534(VarCurr,2)
        <=> $false )
        & ( v115534(VarCurr,1)
        <=> $false )
        & ( v115534(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68405,axiom,
    ! [VarCurr: state_type] :
      ( v116008(VarCurr)
    <=> v115139(VarCurr,2) ) ).

tff(addAssignment_68404,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,2)
    <=> v115159(VarCurr,2) ) ).

tff(addAssignment_68403,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,2)
    <=> v115142(VarCurr,2) ) ).

tff(addAssignment_68402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115534(VarCurr,B)
      <=> v115536(VarCurr,B) ) ) ).

tff(addAssignment_68401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115536(VarCurr,B)
      <=> v115538(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115991(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v115538(VarNext,B)
            <=> v115538(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1507,axiom,
    ! [VarNext: state_type] :
      ( v115991(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115538(VarNext,B)
          <=> v116001(VarNext,B) ) ) ) ).

tff(addAssignment_68400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v116001(VarNext,B)
          <=> v115999(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115999(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1049,axiom,
    ! [VarCurr: state_type] :
      ( v116002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115999(VarCurr,B)
          <=> v115548(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12622,axiom,
    ! [VarCurr: state_type] :
      ( v116002(VarCurr)
    <=> ( v116003(VarCurr)
        & v116004(VarCurr) ) ) ).

tff(writeUnaryOperator_6820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116004(VarCurr)
    <=> v115544(VarCurr) ) ).

tff(writeUnaryOperator_6819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v116003(VarCurr)
    <=> v115540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115991(VarNext)
      <=> v115992(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115992(VarNext)
      <=> ( v115993(VarNext)
          & v115984(VarNext) ) ) ) ).

tff(writeUnaryOperator_6818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115993(VarNext)
      <=> v115995(VarNext) ) ) ).

tff(addAssignment_68399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115995(VarNext)
      <=> v115984(VarCurr) ) ) ).

tff(addAssignment_68398,axiom,
    ! [VarCurr: state_type] :
      ( v115984(VarCurr)
    <=> v115986(VarCurr) ) ).

tff(addAssignment_68397,axiom,
    ! [VarCurr: state_type] :
      ( v115986(VarCurr)
    <=> v115988(VarCurr) ) ).

tff(addAssignment_68396,axiom,
    ! [VarCurr: state_type] :
      ( v115988(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_68395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115548(VarCurr,B)
      <=> v115550(VarCurr,B) ) ) ).

tff(addAssignment_68394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115550(VarCurr,B)
      <=> v115552(VarCurr,B) ) ) ).

tff(addAssignment_68393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115552(VarCurr,B)
      <=> v115554(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v115554(VarCurr,B)
      <=> ( v115811(VarCurr,B)
          & v115814(VarCurr,B) ) ) ) ).

tff(addAssignment_68392,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,0)
    <=> v115979(VarCurr) ) ).

tff(addAssignment_68391,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,1)
    <=> v115974(VarCurr) ) ).

tff(addAssignment_68390,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,2)
    <=> v115969(VarCurr) ) ).

tff(addAssignment_68389,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,3)
    <=> v115964(VarCurr) ) ).

tff(addAssignment_68388,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,4)
    <=> v115959(VarCurr) ) ).

tff(addAssignment_68387,axiom,
    ! [VarCurr: state_type] :
      ( v115814(VarCurr,5)
    <=> v115816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12619,axiom,
    ! [VarCurr: state_type] :
      ( v115979(VarCurr)
    <=> ( v115980(VarCurr)
        & v115982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12618,axiom,
    ! [VarCurr: state_type] :
      ( v115982(VarCurr)
    <=> ( v115767(VarCurr,0)
        | v115828(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12617,axiom,
    ! [VarCurr: state_type] :
      ( v115980(VarCurr)
    <=> ( v115905(VarCurr)
        | v115981(VarCurr) ) ) ).

tff(writeUnaryOperator_6817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115981(VarCurr)
    <=> v115828(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12616,axiom,
    ! [VarCurr: state_type] :
      ( v115974(VarCurr)
    <=> ( v115975(VarCurr)
        & v115978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12615,axiom,
    ! [VarCurr: state_type] :
      ( v115978(VarCurr)
    <=> ( v115827(VarCurr)
        | v115899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12614,axiom,
    ! [VarCurr: state_type] :
      ( v115975(VarCurr)
    <=> ( v115976(VarCurr)
        | v115977(VarCurr) ) ) ).

tff(writeUnaryOperator_6816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115977(VarCurr)
    <=> v115899(VarCurr) ) ).

tff(writeUnaryOperator_6815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115976(VarCurr)
    <=> v115827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12613,axiom,
    ! [VarCurr: state_type] :
      ( v115969(VarCurr)
    <=> ( v115970(VarCurr)
        & v115973(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12612,axiom,
    ! [VarCurr: state_type] :
      ( v115973(VarCurr)
    <=> ( v115825(VarCurr)
        | v115910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12611,axiom,
    ! [VarCurr: state_type] :
      ( v115970(VarCurr)
    <=> ( v115971(VarCurr)
        | v115972(VarCurr) ) ) ).

tff(writeUnaryOperator_6814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115972(VarCurr)
    <=> v115910(VarCurr) ) ).

tff(writeUnaryOperator_6813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115971(VarCurr)
    <=> v115825(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12610,axiom,
    ! [VarCurr: state_type] :
      ( v115964(VarCurr)
    <=> ( v115965(VarCurr)
        & v115968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12609,axiom,
    ! [VarCurr: state_type] :
      ( v115968(VarCurr)
    <=> ( v115823(VarCurr)
        | v115922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12608,axiom,
    ! [VarCurr: state_type] :
      ( v115965(VarCurr)
    <=> ( v115966(VarCurr)
        | v115967(VarCurr) ) ) ).

tff(writeUnaryOperator_6812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115967(VarCurr)
    <=> v115922(VarCurr) ) ).

tff(writeUnaryOperator_6811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115966(VarCurr)
    <=> v115823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12607,axiom,
    ! [VarCurr: state_type] :
      ( v115959(VarCurr)
    <=> ( v115960(VarCurr)
        & v115963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12606,axiom,
    ! [VarCurr: state_type] :
      ( v115963(VarCurr)
    <=> ( v115821(VarCurr)
        | v115934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12605,axiom,
    ! [VarCurr: state_type] :
      ( v115960(VarCurr)
    <=> ( v115961(VarCurr)
        | v115962(VarCurr) ) ) ).

tff(writeUnaryOperator_6810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115962(VarCurr)
    <=> v115934(VarCurr) ) ).

tff(writeUnaryOperator_6809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115961(VarCurr)
    <=> v115821(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12604,axiom,
    ! [VarCurr: state_type] :
      ( v115816(VarCurr)
    <=> ( v115817(VarCurr)
        & v115958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12603,axiom,
    ! [VarCurr: state_type] :
      ( v115958(VarCurr)
    <=> ( v115819(VarCurr)
        | v115947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12602,axiom,
    ! [VarCurr: state_type] :
      ( v115817(VarCurr)
    <=> ( v115818(VarCurr)
        | v115946(VarCurr) ) ) ).

tff(writeUnaryOperator_6808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115946(VarCurr)
    <=> v115947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12601,axiom,
    ! [VarCurr: state_type] :
      ( v115947(VarCurr)
    <=> ( v115948(VarCurr)
        & v115957(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4946,axiom,
    ! [VarCurr: state_type] :
      ( v115957(VarCurr)
    <=> ( v115950(VarCurr)
        | v115828(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12600,axiom,
    ! [VarCurr: state_type] :
      ( v115948(VarCurr)
    <=> ( v115949(VarCurr)
        | v115956(VarCurr) ) ) ).

tff(writeUnaryOperator_6807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115956(VarCurr)
    <=> v115828(VarCurr,5) ) ).

tff(writeUnaryOperator_6806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115949(VarCurr)
    <=> v115950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12599,axiom,
    ! [VarCurr: state_type] :
      ( v115950(VarCurr)
    <=> ( v115951(VarCurr)
        & v115954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12598,axiom,
    ! [VarCurr: state_type] :
      ( v115954(VarCurr)
    <=> ( v115953(VarCurr)
        | v115955(VarCurr) ) ) ).

tff(writeUnaryOperator_6805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115955(VarCurr)
    <=> v115767(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4945,axiom,
    ! [VarCurr: state_type] :
      ( v115951(VarCurr)
    <=> ( v115952(VarCurr)
        | v115767(VarCurr,5) ) ) ).

tff(writeUnaryOperator_6804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115952(VarCurr)
    <=> v115953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12597,axiom,
    ! [VarCurr: state_type] :
      ( v115953(VarCurr)
    <=> ( v115940(VarCurr)
        & v115942(VarCurr) ) ) ).

tff(writeUnaryOperator_6803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115818(VarCurr)
    <=> v115819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12596,axiom,
    ! [VarCurr: state_type] :
      ( v115819(VarCurr)
    <=> ( v115820(VarCurr)
        | v115945(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4944,axiom,
    ! [VarCurr: state_type] :
      ( v115945(VarCurr)
    <=> ( v115937(VarCurr)
        & v115828(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12595,axiom,
    ! [VarCurr: state_type] :
      ( v115820(VarCurr)
    <=> ( v115821(VarCurr)
        & v115934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12594,axiom,
    ! [VarCurr: state_type] :
      ( v115934(VarCurr)
    <=> ( v115935(VarCurr)
        & v115944(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4943,axiom,
    ! [VarCurr: state_type] :
      ( v115944(VarCurr)
    <=> ( v115937(VarCurr)
        | v115828(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12593,axiom,
    ! [VarCurr: state_type] :
      ( v115935(VarCurr)
    <=> ( v115936(VarCurr)
        | v115943(VarCurr) ) ) ).

tff(writeUnaryOperator_6802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115943(VarCurr)
    <=> v115828(VarCurr,4) ) ).

tff(writeUnaryOperator_6801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115936(VarCurr)
    <=> v115937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12592,axiom,
    ! [VarCurr: state_type] :
      ( v115937(VarCurr)
    <=> ( v115938(VarCurr)
        & v115941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12591,axiom,
    ! [VarCurr: state_type] :
      ( v115941(VarCurr)
    <=> ( v115940(VarCurr)
        | v115942(VarCurr) ) ) ).

tff(writeUnaryOperator_6800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115942(VarCurr)
    <=> v115767(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4942,axiom,
    ! [VarCurr: state_type] :
      ( v115938(VarCurr)
    <=> ( v115939(VarCurr)
        | v115767(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115939(VarCurr)
    <=> v115940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12590,axiom,
    ! [VarCurr: state_type] :
      ( v115940(VarCurr)
    <=> ( v115928(VarCurr)
        & v115930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12589,axiom,
    ! [VarCurr: state_type] :
      ( v115821(VarCurr)
    <=> ( v115822(VarCurr)
        | v115933(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4941,axiom,
    ! [VarCurr: state_type] :
      ( v115933(VarCurr)
    <=> ( v115925(VarCurr)
        & v115828(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12588,axiom,
    ! [VarCurr: state_type] :
      ( v115822(VarCurr)
    <=> ( v115823(VarCurr)
        & v115922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12587,axiom,
    ! [VarCurr: state_type] :
      ( v115922(VarCurr)
    <=> ( v115923(VarCurr)
        & v115932(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4940,axiom,
    ! [VarCurr: state_type] :
      ( v115932(VarCurr)
    <=> ( v115925(VarCurr)
        | v115828(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12586,axiom,
    ! [VarCurr: state_type] :
      ( v115923(VarCurr)
    <=> ( v115924(VarCurr)
        | v115931(VarCurr) ) ) ).

tff(writeUnaryOperator_6798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115931(VarCurr)
    <=> v115828(VarCurr,3) ) ).

tff(writeUnaryOperator_6797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115924(VarCurr)
    <=> v115925(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12585,axiom,
    ! [VarCurr: state_type] :
      ( v115925(VarCurr)
    <=> ( v115926(VarCurr)
        & v115929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12584,axiom,
    ! [VarCurr: state_type] :
      ( v115929(VarCurr)
    <=> ( v115928(VarCurr)
        | v115930(VarCurr) ) ) ).

tff(writeUnaryOperator_6796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115930(VarCurr)
    <=> v115767(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4939,axiom,
    ! [VarCurr: state_type] :
      ( v115926(VarCurr)
    <=> ( v115927(VarCurr)
        | v115767(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115927(VarCurr)
    <=> v115928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12583,axiom,
    ! [VarCurr: state_type] :
      ( v115928(VarCurr)
    <=> ( v115916(VarCurr)
        & v115918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12582,axiom,
    ! [VarCurr: state_type] :
      ( v115823(VarCurr)
    <=> ( v115824(VarCurr)
        | v115921(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4938,axiom,
    ! [VarCurr: state_type] :
      ( v115921(VarCurr)
    <=> ( v115913(VarCurr)
        & v115828(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12581,axiom,
    ! [VarCurr: state_type] :
      ( v115824(VarCurr)
    <=> ( v115825(VarCurr)
        & v115910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12580,axiom,
    ! [VarCurr: state_type] :
      ( v115910(VarCurr)
    <=> ( v115911(VarCurr)
        & v115920(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4937,axiom,
    ! [VarCurr: state_type] :
      ( v115920(VarCurr)
    <=> ( v115913(VarCurr)
        | v115828(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12579,axiom,
    ! [VarCurr: state_type] :
      ( v115911(VarCurr)
    <=> ( v115912(VarCurr)
        | v115919(VarCurr) ) ) ).

tff(writeUnaryOperator_6794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115919(VarCurr)
    <=> v115828(VarCurr,2) ) ).

tff(writeUnaryOperator_6793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115912(VarCurr)
    <=> v115913(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12578,axiom,
    ! [VarCurr: state_type] :
      ( v115913(VarCurr)
    <=> ( v115914(VarCurr)
        & v115917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12577,axiom,
    ! [VarCurr: state_type] :
      ( v115917(VarCurr)
    <=> ( v115916(VarCurr)
        | v115918(VarCurr) ) ) ).

tff(writeUnaryOperator_6792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115918(VarCurr)
    <=> v115767(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4936,axiom,
    ! [VarCurr: state_type] :
      ( v115914(VarCurr)
    <=> ( v115915(VarCurr)
        | v115767(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115915(VarCurr)
    <=> v115916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12576,axiom,
    ! [VarCurr: state_type] :
      ( v115916(VarCurr)
    <=> ( v115905(VarCurr)
        & v115906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12575,axiom,
    ! [VarCurr: state_type] :
      ( v115825(VarCurr)
    <=> ( v115826(VarCurr)
        | v115909(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4935,axiom,
    ! [VarCurr: state_type] :
      ( v115909(VarCurr)
    <=> ( v115902(VarCurr)
        & v115828(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12574,axiom,
    ! [VarCurr: state_type] :
      ( v115826(VarCurr)
    <=> ( v115827(VarCurr)
        & v115899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12573,axiom,
    ! [VarCurr: state_type] :
      ( v115899(VarCurr)
    <=> ( v115900(VarCurr)
        & v115908(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4934,axiom,
    ! [VarCurr: state_type] :
      ( v115908(VarCurr)
    <=> ( v115902(VarCurr)
        | v115828(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12572,axiom,
    ! [VarCurr: state_type] :
      ( v115900(VarCurr)
    <=> ( v115901(VarCurr)
        | v115907(VarCurr) ) ) ).

tff(writeUnaryOperator_6790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115907(VarCurr)
    <=> v115828(VarCurr,1) ) ).

tff(writeUnaryOperator_6789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115901(VarCurr)
    <=> v115902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12571,axiom,
    ! [VarCurr: state_type] :
      ( v115902(VarCurr)
    <=> ( v115903(VarCurr)
        & v115904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12570,axiom,
    ! [VarCurr: state_type] :
      ( v115904(VarCurr)
    <=> ( v115905(VarCurr)
        | v115906(VarCurr) ) ) ).

tff(writeUnaryOperator_6788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115906(VarCurr)
    <=> v115767(VarCurr,1) ) ).

tff(writeUnaryOperator_6787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115905(VarCurr)
    <=> v115767(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_4933,axiom,
    ! [VarCurr: state_type] :
      ( v115903(VarCurr)
    <=> ( v115767(VarCurr,0)
        | v115767(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12569,axiom,
    ! [VarCurr: state_type] :
      ( v115827(VarCurr)
    <=> ( v115767(VarCurr,0)
        & v115828(VarCurr,0) ) ) ).

tff(addAssignment_68386,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,0)
    <=> v115894(VarCurr) ) ).

tff(addAssignment_68385,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,1)
    <=> v115889(VarCurr) ) ).

tff(addAssignment_68384,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,2)
    <=> v115884(VarCurr) ) ).

tff(addAssignment_68383,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,3)
    <=> v115879(VarCurr) ) ).

tff(addAssignment_68382,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,4)
    <=> v115874(VarCurr) ) ).

tff(addAssignment_68381,axiom,
    ! [VarCurr: state_type] :
      ( v115828(VarCurr,5)
    <=> v115830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12568,axiom,
    ! [VarCurr: state_type] :
      ( v115894(VarCurr)
    <=> ( v115895(VarCurr)
        & v115898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12567,axiom,
    ! [VarCurr: state_type] :
      ( v115898(VarCurr)
    <=> ( v115534(VarCurr,0)
        | v115842(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12566,axiom,
    ! [VarCurr: state_type] :
      ( v115895(VarCurr)
    <=> ( v115896(VarCurr)
        | v115897(VarCurr) ) ) ).

tff(writeUnaryOperator_6786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115897(VarCurr)
    <=> v115842(VarCurr,0) ) ).

tff(writeUnaryOperator_6785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115896(VarCurr)
    <=> v115534(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12565,axiom,
    ! [VarCurr: state_type] :
      ( v115889(VarCurr)
    <=> ( v115890(VarCurr)
        & v115893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12564,axiom,
    ! [VarCurr: state_type] :
      ( v115893(VarCurr)
    <=> ( v115841(VarCurr)
        | v115843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12563,axiom,
    ! [VarCurr: state_type] :
      ( v115890(VarCurr)
    <=> ( v115891(VarCurr)
        | v115892(VarCurr) ) ) ).

tff(writeUnaryOperator_6784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115892(VarCurr)
    <=> v115843(VarCurr) ) ).

tff(writeUnaryOperator_6783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115891(VarCurr)
    <=> v115841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12562,axiom,
    ! [VarCurr: state_type] :
      ( v115884(VarCurr)
    <=> ( v115885(VarCurr)
        & v115888(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12561,axiom,
    ! [VarCurr: state_type] :
      ( v115888(VarCurr)
    <=> ( v115839(VarCurr)
        | v115849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12560,axiom,
    ! [VarCurr: state_type] :
      ( v115885(VarCurr)
    <=> ( v115886(VarCurr)
        | v115887(VarCurr) ) ) ).

tff(writeUnaryOperator_6782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115887(VarCurr)
    <=> v115849(VarCurr) ) ).

tff(writeUnaryOperator_6781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115886(VarCurr)
    <=> v115839(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12559,axiom,
    ! [VarCurr: state_type] :
      ( v115879(VarCurr)
    <=> ( v115880(VarCurr)
        & v115883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12558,axiom,
    ! [VarCurr: state_type] :
      ( v115883(VarCurr)
    <=> ( v115837(VarCurr)
        | v115855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12557,axiom,
    ! [VarCurr: state_type] :
      ( v115880(VarCurr)
    <=> ( v115881(VarCurr)
        | v115882(VarCurr) ) ) ).

tff(writeUnaryOperator_6780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115882(VarCurr)
    <=> v115855(VarCurr) ) ).

tff(writeUnaryOperator_6779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115881(VarCurr)
    <=> v115837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12556,axiom,
    ! [VarCurr: state_type] :
      ( v115874(VarCurr)
    <=> ( v115875(VarCurr)
        & v115878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12555,axiom,
    ! [VarCurr: state_type] :
      ( v115878(VarCurr)
    <=> ( v115835(VarCurr)
        | v115861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12554,axiom,
    ! [VarCurr: state_type] :
      ( v115875(VarCurr)
    <=> ( v115876(VarCurr)
        | v115877(VarCurr) ) ) ).

tff(writeUnaryOperator_6778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115877(VarCurr)
    <=> v115861(VarCurr) ) ).

tff(writeUnaryOperator_6777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115876(VarCurr)
    <=> v115835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12553,axiom,
    ! [VarCurr: state_type] :
      ( v115830(VarCurr)
    <=> ( v115831(VarCurr)
        & v115873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12552,axiom,
    ! [VarCurr: state_type] :
      ( v115873(VarCurr)
    <=> ( v115833(VarCurr)
        | v115868(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12551,axiom,
    ! [VarCurr: state_type] :
      ( v115831(VarCurr)
    <=> ( v115832(VarCurr)
        | v115867(VarCurr) ) ) ).

tff(writeUnaryOperator_6776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115867(VarCurr)
    <=> v115868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12550,axiom,
    ! [VarCurr: state_type] :
      ( v115868(VarCurr)
    <=> ( v115869(VarCurr)
        & v115872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4932,axiom,
    ! [VarCurr: state_type] :
      ( v115872(VarCurr)
    <=> ( v115534(VarCurr,5)
        | v115842(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12549,axiom,
    ! [VarCurr: state_type] :
      ( v115869(VarCurr)
    <=> ( v115870(VarCurr)
        | v115871(VarCurr) ) ) ).

tff(writeUnaryOperator_6775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115871(VarCurr)
    <=> v115842(VarCurr,5) ) ).

tff(writeUnaryOperator_6774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115870(VarCurr)
    <=> v115534(VarCurr,5) ) ).

tff(writeUnaryOperator_6773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115832(VarCurr)
    <=> v115833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12548,axiom,
    ! [VarCurr: state_type] :
      ( v115833(VarCurr)
    <=> ( v115834(VarCurr)
        | v115866(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4931,axiom,
    ! [VarCurr: state_type] :
      ( v115866(VarCurr)
    <=> ( v115534(VarCurr,4)
        & v115842(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12547,axiom,
    ! [VarCurr: state_type] :
      ( v115834(VarCurr)
    <=> ( v115835(VarCurr)
        & v115861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12546,axiom,
    ! [VarCurr: state_type] :
      ( v115861(VarCurr)
    <=> ( v115862(VarCurr)
        & v115865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4930,axiom,
    ! [VarCurr: state_type] :
      ( v115865(VarCurr)
    <=> ( v115534(VarCurr,4)
        | v115842(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12545,axiom,
    ! [VarCurr: state_type] :
      ( v115862(VarCurr)
    <=> ( v115863(VarCurr)
        | v115864(VarCurr) ) ) ).

tff(writeUnaryOperator_6772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115864(VarCurr)
    <=> v115842(VarCurr,4) ) ).

tff(writeUnaryOperator_6771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115863(VarCurr)
    <=> v115534(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12544,axiom,
    ! [VarCurr: state_type] :
      ( v115835(VarCurr)
    <=> ( v115836(VarCurr)
        | v115860(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4929,axiom,
    ! [VarCurr: state_type] :
      ( v115860(VarCurr)
    <=> ( v115534(VarCurr,3)
        & v115842(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12543,axiom,
    ! [VarCurr: state_type] :
      ( v115836(VarCurr)
    <=> ( v115837(VarCurr)
        & v115855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12542,axiom,
    ! [VarCurr: state_type] :
      ( v115855(VarCurr)
    <=> ( v115856(VarCurr)
        & v115859(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4928,axiom,
    ! [VarCurr: state_type] :
      ( v115859(VarCurr)
    <=> ( v115534(VarCurr,3)
        | v115842(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12541,axiom,
    ! [VarCurr: state_type] :
      ( v115856(VarCurr)
    <=> ( v115857(VarCurr)
        | v115858(VarCurr) ) ) ).

tff(writeUnaryOperator_6770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115858(VarCurr)
    <=> v115842(VarCurr,3) ) ).

tff(writeUnaryOperator_6769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115857(VarCurr)
    <=> v115534(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12540,axiom,
    ! [VarCurr: state_type] :
      ( v115837(VarCurr)
    <=> ( v115838(VarCurr)
        | v115854(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4927,axiom,
    ! [VarCurr: state_type] :
      ( v115854(VarCurr)
    <=> ( v115534(VarCurr,2)
        & v115842(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12539,axiom,
    ! [VarCurr: state_type] :
      ( v115838(VarCurr)
    <=> ( v115839(VarCurr)
        & v115849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12538,axiom,
    ! [VarCurr: state_type] :
      ( v115849(VarCurr)
    <=> ( v115850(VarCurr)
        & v115853(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4926,axiom,
    ! [VarCurr: state_type] :
      ( v115853(VarCurr)
    <=> ( v115534(VarCurr,2)
        | v115842(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12537,axiom,
    ! [VarCurr: state_type] :
      ( v115850(VarCurr)
    <=> ( v115851(VarCurr)
        | v115852(VarCurr) ) ) ).

tff(writeUnaryOperator_6768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115852(VarCurr)
    <=> v115842(VarCurr,2) ) ).

tff(writeUnaryOperator_6767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115851(VarCurr)
    <=> v115534(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12536,axiom,
    ! [VarCurr: state_type] :
      ( v115839(VarCurr)
    <=> ( v115840(VarCurr)
        | v115848(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4925,axiom,
    ! [VarCurr: state_type] :
      ( v115848(VarCurr)
    <=> ( v115534(VarCurr,1)
        & v115842(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12535,axiom,
    ! [VarCurr: state_type] :
      ( v115840(VarCurr)
    <=> ( v115841(VarCurr)
        & v115843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12534,axiom,
    ! [VarCurr: state_type] :
      ( v115843(VarCurr)
    <=> ( v115844(VarCurr)
        & v115847(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4924,axiom,
    ! [VarCurr: state_type] :
      ( v115847(VarCurr)
    <=> ( v115534(VarCurr,1)
        | v115842(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12533,axiom,
    ! [VarCurr: state_type] :
      ( v115844(VarCurr)
    <=> ( v115845(VarCurr)
        | v115846(VarCurr) ) ) ).

tff(writeUnaryOperator_6766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115846(VarCurr)
    <=> v115842(VarCurr,1) ) ).

tff(writeUnaryOperator_6765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115845(VarCurr)
    <=> v115534(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12532,axiom,
    ! [VarCurr: state_type] :
      ( v115841(VarCurr)
    <=> ( v115534(VarCurr,0)
        & v115842(VarCurr,0) ) ) ).

tff(addAssignment_68380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v115842(VarCurr,B)
      <=> v115558(VarCurr,B) ) ) ).

tff(addAssignment_68379,axiom,
    ! [VarCurr: state_type] :
      ( ( v115842(VarCurr,5)
      <=> $false )
      & ( v115842(VarCurr,4)
      <=> $false )
      & ( v115842(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_68378,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,0)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68377,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,1)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68376,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,2)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68375,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,3)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68374,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,4)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68373,axiom,
    ! [VarCurr: state_type] :
      ( v115811(VarCurr,5)
    <=> v115812(VarCurr) ) ).

tff(addAssignment_68372,axiom,
    ! [VarCurr: state_type] :
      ( v115812(VarCurr)
    <=> v115813(VarCurr) ) ).

tff(writeUnaryOperator_6764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115813(VarCurr)
    <=> v115556(VarCurr) ) ).

tff(addAssignment_68371,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,5)
    <=> v115804(VarCurr,5) ) ).

tff(addAssignment_68370,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,4)
    <=> v115804(VarCurr,4) ) ).

tff(addAssignment_68369,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,3)
    <=> v115804(VarCurr,3) ) ).

tff(addAssignment_68368,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,2)
    <=> v115804(VarCurr,2) ) ).

tff(addAssignment_68367,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,1)
    <=> v115804(VarCurr,1) ) ).

tff(addAssignment_68366,axiom,
    ! [VarCurr: state_type] :
      ( v115767(VarCurr,0)
    <=> v115804(VarCurr,0) ) ).

tff(addAssignment_68365,axiom,
    ! [VarCurr: state_type] :
      ( v115804(VarCurr,0)
    <=> v115805(VarCurr) ) ).

tff(addAssignment_68364,axiom,
    ! [VarCurr: state_type] :
      ( ( v115804(VarCurr,5)
      <=> $false )
      & ( v115804(VarCurr,4)
      <=> $false )
      & ( v115804(VarCurr,3)
      <=> $false )
      & ( v115804(VarCurr,2)
      <=> $false )
      & ( v115804(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12531,axiom,
    ! [VarCurr: state_type] :
      ( v115805(VarCurr)
    <=> ( v115806(VarCurr)
        | v115803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12530,axiom,
    ! [VarCurr: state_type] :
      ( v115806(VarCurr)
    <=> ( v115807(VarCurr)
        | v115801(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12529,axiom,
    ! [VarCurr: state_type] :
      ( v115807(VarCurr)
    <=> ( v115808(VarCurr)
        | v115799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12528,axiom,
    ! [VarCurr: state_type] :
      ( v115808(VarCurr)
    <=> ( v115809(VarCurr)
        | v115789(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12527,axiom,
    ! [VarCurr: state_type] :
      ( v115809(VarCurr)
    <=> ( v115769(VarCurr)
        | v115779(VarCurr) ) ) ).

tff(addAssignment_68363,axiom,
    ! [VarCurr: state_type] :
      ( v115803(VarCurr)
    <=> v113911(VarCurr,2) ) ).

tff(addAssignment_68362,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,2)
    <=> v113913(VarCurr,2) ) ).

tff(addAssignment_68361,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,2)
    <=> v113915(VarCurr,2) ) ).

tff(addAssignment_68360,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,2)
    <=> v113935(VarCurr,2) ) ).

tff(addAssignment_68359,axiom,
    ! [VarCurr: state_type] :
      ( v115801(VarCurr)
    <=> v113107(VarCurr,2) ) ).

tff(addAssignment_68358,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,2)
    <=> v113143(VarCurr,2) ) ).

tff(addAssignment_68357,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,2)
    <=> v113110(VarCurr,2) ) ).

tff(addAssignment_68356,axiom,
    ! [VarCurr: state_type] :
      ( v115799(VarCurr)
    <=> v113100(VarCurr,2) ) ).

tff(addAssignment_68355,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,2)
    <=> v113101(VarCurr,2) ) ).

tff(addAssignment_68354,axiom,
    ! [VarCurr: state_type] :
      ( v115789(VarCurr)
    <=> v113810(VarCurr,2) ) ).

tff(addAssignment_68353,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,2)
    <=> v113812(VarCurr,2) ) ).

tff(addAssignment_68352,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,2)
    <=> v113814(VarCurr,2) ) ).

tff(addAssignment_68351,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,2)
    <=> v113816(VarCurr,2) ) ).

tff(addAssignment_68350,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,2)
    <=> v113818(VarCurr,2) ) ).

tff(addAssignment_68349,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,2)
    <=> v115791(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115792(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v115791(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1506,axiom,
    ! [VarNext: state_type] :
      ( v115792(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115791(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115792(VarNext)
      <=> v115793(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115793(VarNext)
      <=> ( v115795(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_6763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115795(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_68348,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,2)
    <=> v113830(VarCurr,2) ) ).

tff(addAssignment_68347,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,2)
    <=> v113832(VarCurr,2) ) ).

tff(addAssignment_68346,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,2)
    <=> v113834(VarCurr,2) ) ).

tff(addAssignment_68345,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,2)
    <=> v113873(VarCurr,2) ) ).

tff(addAssignment_68344,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,2)
    <=> v113856(VarCurr,2) ) ).

tff(addAssignment_68343,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,2)
    <=> v113837(VarCurr,2) ) ).

tff(addAssignment_68342,axiom,
    ! [VarCurr: state_type] :
      ( v115779(VarCurr)
    <=> v113020(VarCurr,2) ) ).

tff(addAssignment_68341,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,2)
    <=> v113022(VarCurr,2) ) ).

tff(addAssignment_68340,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,2)
    <=> v113024(VarCurr,2) ) ).

tff(addAssignment_68339,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,2)
    <=> v113026(VarCurr,2) ) ).

tff(addAssignment_68338,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,2)
    <=> v113028(VarCurr,2) ) ).

tff(addAssignment_68337,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,2)
    <=> v115781(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115782(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v115781(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1505,axiom,
    ! [VarNext: state_type] :
      ( v115782(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115781(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115782(VarNext)
      <=> v115783(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115783(VarNext)
      <=> ( v115785(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_6762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115785(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_68336,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,2)
    <=> v113040(VarCurr,2) ) ).

tff(addAssignment_68335,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,2)
    <=> v113042(VarCurr,2) ) ).

tff(addAssignment_68334,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,2)
    <=> v113044(VarCurr,2) ) ).

tff(addAssignment_68333,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,2)
    <=> v113045(VarCurr,2) ) ).

tff(addAssignment_68332,axiom,
    ! [VarCurr: state_type] :
      ( v115769(VarCurr)
    <=> v112940(VarCurr,2) ) ).

tff(addAssignment_68331,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,2)
    <=> v112942(VarCurr,2) ) ).

tff(addAssignment_68330,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,2)
    <=> v112944(VarCurr,2) ) ).

tff(addAssignment_68329,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,2)
    <=> v112946(VarCurr,2) ) ).

tff(addAssignment_68328,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,2)
    <=> v112948(VarCurr,2) ) ).

tff(addAssignment_68327,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,2)
    <=> v115771(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115772(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v115771(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1504,axiom,
    ! [VarNext: state_type] :
      ( v115772(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115771(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115772(VarNext)
      <=> v115773(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115773(VarNext)
      <=> ( v115775(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_6761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115775(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_68326,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,2)
    <=> v112960(VarCurr,2) ) ).

tff(addAssignment_68325,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,2)
    <=> v112962(VarCurr,2) ) ).

tff(addAssignment_68324,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,2)
    <=> v112964(VarCurr,2) ) ).

tff(addAssignment_68323,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,2)
    <=> v112965(VarCurr,2) ) ).

tff(addAssignment_68322,axiom,
    ! [VarCurr: state_type] :
      ( v115558(VarCurr,2)
    <=> v115573(VarCurr,2) ) ).

tff(addAssignment_68321,axiom,
    ! [VarCurr: state_type] :
      ( v115558(VarCurr,1)
    <=> v115573(VarCurr,1) ) ).

tff(addAssignment_68320,axiom,
    ! [VarCurr: state_type] :
      ( v115558(VarCurr,0)
    <=> v115573(VarCurr,0) ) ).

tff(addAssignment_68319,axiom,
    ! [VarCurr: state_type] :
      ( v115573(VarCurr,0)
    <=> v115761(VarCurr) ) ).

tff(addAssignment_68318,axiom,
    ! [VarCurr: state_type] :
      ( v115573(VarCurr,1)
    <=> v115756(VarCurr) ) ).

tff(addAssignment_68317,axiom,
    ! [VarCurr: state_type] :
      ( v115573(VarCurr,2)
    <=> v115575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12520,axiom,
    ! [VarCurr: state_type] :
      ( v115761(VarCurr)
    <=> ( v115762(VarCurr)
        & v115765(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12519,axiom,
    ! [VarCurr: state_type] :
      ( v115765(VarCurr)
    <=> ( v115581(VarCurr,0)
        | v115742(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12518,axiom,
    ! [VarCurr: state_type] :
      ( v115762(VarCurr)
    <=> ( v115763(VarCurr)
        | v115764(VarCurr) ) ) ).

tff(writeUnaryOperator_6760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115764(VarCurr)
    <=> v115742(VarCurr,0) ) ).

tff(writeUnaryOperator_6759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115763(VarCurr)
    <=> v115581(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12517,axiom,
    ! [VarCurr: state_type] :
      ( v115756(VarCurr)
    <=> ( v115757(VarCurr)
        & v115760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12516,axiom,
    ! [VarCurr: state_type] :
      ( v115760(VarCurr)
    <=> ( v115580(VarCurr)
        | v115743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12515,axiom,
    ! [VarCurr: state_type] :
      ( v115757(VarCurr)
    <=> ( v115758(VarCurr)
        | v115759(VarCurr) ) ) ).

tff(writeUnaryOperator_6758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115759(VarCurr)
    <=> v115743(VarCurr) ) ).

tff(writeUnaryOperator_6757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115758(VarCurr)
    <=> v115580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12514,axiom,
    ! [VarCurr: state_type] :
      ( v115575(VarCurr)
    <=> ( v115576(VarCurr)
        & v115755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12513,axiom,
    ! [VarCurr: state_type] :
      ( v115755(VarCurr)
    <=> ( v115578(VarCurr)
        | v115750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12512,axiom,
    ! [VarCurr: state_type] :
      ( v115576(VarCurr)
    <=> ( v115577(VarCurr)
        | v115749(VarCurr) ) ) ).

tff(writeUnaryOperator_6756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115749(VarCurr)
    <=> v115750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12511,axiom,
    ! [VarCurr: state_type] :
      ( v115750(VarCurr)
    <=> ( v115751(VarCurr)
        & v115754(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4923,axiom,
    ! [VarCurr: state_type] :
      ( v115754(VarCurr)
    <=> ( v115581(VarCurr,2)
        | v115742(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12510,axiom,
    ! [VarCurr: state_type] :
      ( v115751(VarCurr)
    <=> ( v115752(VarCurr)
        | v115753(VarCurr) ) ) ).

tff(writeUnaryOperator_6755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115753(VarCurr)
    <=> v115742(VarCurr,2) ) ).

tff(writeUnaryOperator_6754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115752(VarCurr)
    <=> v115581(VarCurr,2) ) ).

tff(writeUnaryOperator_6753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115577(VarCurr)
    <=> v115578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12509,axiom,
    ! [VarCurr: state_type] :
      ( v115578(VarCurr)
    <=> ( v115579(VarCurr)
        | v115748(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4922,axiom,
    ! [VarCurr: state_type] :
      ( v115748(VarCurr)
    <=> ( v115581(VarCurr,1)
        & v115742(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12508,axiom,
    ! [VarCurr: state_type] :
      ( v115579(VarCurr)
    <=> ( v115580(VarCurr)
        & v115743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12507,axiom,
    ! [VarCurr: state_type] :
      ( v115743(VarCurr)
    <=> ( v115744(VarCurr)
        & v115747(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4921,axiom,
    ! [VarCurr: state_type] :
      ( v115747(VarCurr)
    <=> ( v115581(VarCurr,1)
        | v115742(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12506,axiom,
    ! [VarCurr: state_type] :
      ( v115744(VarCurr)
    <=> ( v115745(VarCurr)
        | v115746(VarCurr) ) ) ).

tff(writeUnaryOperator_6752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115746(VarCurr)
    <=> v115742(VarCurr,1) ) ).

tff(writeUnaryOperator_6751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115745(VarCurr)
    <=> v115581(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12505,axiom,
    ! [VarCurr: state_type] :
      ( v115580(VarCurr)
    <=> ( v115581(VarCurr,0)
        & v115742(VarCurr,0) ) ) ).

tff(addAssignment_68316,axiom,
    ! [VarCurr: state_type] :
      ( v115742(VarCurr,0)
    <=> v115572(VarCurr) ) ).

tff(addAssignment_68315,axiom,
    ! [VarCurr: state_type] :
      ( ( v115742(VarCurr,2)
      <=> $false )
      & ( v115742(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68314,axiom,
    ! [VarCurr: state_type] :
      ( v115581(VarCurr,0)
    <=> v115737(VarCurr) ) ).

tff(addAssignment_68313,axiom,
    ! [VarCurr: state_type] :
      ( v115581(VarCurr,1)
    <=> v115732(VarCurr) ) ).

tff(addAssignment_68312,axiom,
    ! [VarCurr: state_type] :
      ( v115581(VarCurr,2)
    <=> v115583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12504,axiom,
    ! [VarCurr: state_type] :
      ( v115737(VarCurr)
    <=> ( v115738(VarCurr)
        & v115741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12503,axiom,
    ! [VarCurr: state_type] :
      ( v115741(VarCurr)
    <=> ( v115589(VarCurr,0)
        | v115718(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12502,axiom,
    ! [VarCurr: state_type] :
      ( v115738(VarCurr)
    <=> ( v115739(VarCurr)
        | v115740(VarCurr) ) ) ).

tff(writeUnaryOperator_6750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115740(VarCurr)
    <=> v115718(VarCurr,0) ) ).

tff(writeUnaryOperator_6749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115739(VarCurr)
    <=> v115589(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12501,axiom,
    ! [VarCurr: state_type] :
      ( v115732(VarCurr)
    <=> ( v115733(VarCurr)
        & v115736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12500,axiom,
    ! [VarCurr: state_type] :
      ( v115736(VarCurr)
    <=> ( v115588(VarCurr)
        | v115719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12499,axiom,
    ! [VarCurr: state_type] :
      ( v115733(VarCurr)
    <=> ( v115734(VarCurr)
        | v115735(VarCurr) ) ) ).

tff(writeUnaryOperator_6748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115735(VarCurr)
    <=> v115719(VarCurr) ) ).

tff(writeUnaryOperator_6747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115734(VarCurr)
    <=> v115588(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12498,axiom,
    ! [VarCurr: state_type] :
      ( v115583(VarCurr)
    <=> ( v115584(VarCurr)
        & v115731(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12497,axiom,
    ! [VarCurr: state_type] :
      ( v115731(VarCurr)
    <=> ( v115586(VarCurr)
        | v115726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12496,axiom,
    ! [VarCurr: state_type] :
      ( v115584(VarCurr)
    <=> ( v115585(VarCurr)
        | v115725(VarCurr) ) ) ).

tff(writeUnaryOperator_6746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115725(VarCurr)
    <=> v115726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12495,axiom,
    ! [VarCurr: state_type] :
      ( v115726(VarCurr)
    <=> ( v115727(VarCurr)
        & v115730(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4920,axiom,
    ! [VarCurr: state_type] :
      ( v115730(VarCurr)
    <=> ( v115589(VarCurr,2)
        | v115718(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12494,axiom,
    ! [VarCurr: state_type] :
      ( v115727(VarCurr)
    <=> ( v115728(VarCurr)
        | v115729(VarCurr) ) ) ).

tff(writeUnaryOperator_6745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115729(VarCurr)
    <=> v115718(VarCurr,2) ) ).

tff(writeUnaryOperator_6744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115728(VarCurr)
    <=> v115589(VarCurr,2) ) ).

tff(writeUnaryOperator_6743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115585(VarCurr)
    <=> v115586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12493,axiom,
    ! [VarCurr: state_type] :
      ( v115586(VarCurr)
    <=> ( v115587(VarCurr)
        | v115724(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4919,axiom,
    ! [VarCurr: state_type] :
      ( v115724(VarCurr)
    <=> ( v115589(VarCurr,1)
        & v115718(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12492,axiom,
    ! [VarCurr: state_type] :
      ( v115587(VarCurr)
    <=> ( v115588(VarCurr)
        & v115719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12491,axiom,
    ! [VarCurr: state_type] :
      ( v115719(VarCurr)
    <=> ( v115720(VarCurr)
        & v115723(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4918,axiom,
    ! [VarCurr: state_type] :
      ( v115723(VarCurr)
    <=> ( v115589(VarCurr,1)
        | v115718(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12490,axiom,
    ! [VarCurr: state_type] :
      ( v115720(VarCurr)
    <=> ( v115721(VarCurr)
        | v115722(VarCurr) ) ) ).

tff(writeUnaryOperator_6742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115722(VarCurr)
    <=> v115718(VarCurr,1) ) ).

tff(writeUnaryOperator_6741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115721(VarCurr)
    <=> v115589(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12489,axiom,
    ! [VarCurr: state_type] :
      ( v115588(VarCurr)
    <=> ( v115589(VarCurr,0)
        & v115718(VarCurr,0) ) ) ).

tff(addAssignment_68311,axiom,
    ! [VarCurr: state_type] :
      ( v115718(VarCurr,0)
    <=> v115570(VarCurr) ) ).

tff(addAssignment_68310,axiom,
    ! [VarCurr: state_type] :
      ( ( v115718(VarCurr,2)
      <=> $false )
      & ( v115718(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68309,axiom,
    ! [VarCurr: state_type] :
      ( v115589(VarCurr,0)
    <=> v115713(VarCurr) ) ).

tff(addAssignment_68308,axiom,
    ! [VarCurr: state_type] :
      ( v115589(VarCurr,1)
    <=> v115708(VarCurr) ) ).

tff(addAssignment_68307,axiom,
    ! [VarCurr: state_type] :
      ( v115589(VarCurr,2)
    <=> v115591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12488,axiom,
    ! [VarCurr: state_type] :
      ( v115713(VarCurr)
    <=> ( v115714(VarCurr)
        & v115717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12487,axiom,
    ! [VarCurr: state_type] :
      ( v115717(VarCurr)
    <=> ( v115597(VarCurr,0)
        | v115694(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12486,axiom,
    ! [VarCurr: state_type] :
      ( v115714(VarCurr)
    <=> ( v115715(VarCurr)
        | v115716(VarCurr) ) ) ).

tff(writeUnaryOperator_6740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115716(VarCurr)
    <=> v115694(VarCurr,0) ) ).

tff(writeUnaryOperator_6739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115715(VarCurr)
    <=> v115597(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12485,axiom,
    ! [VarCurr: state_type] :
      ( v115708(VarCurr)
    <=> ( v115709(VarCurr)
        & v115712(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12484,axiom,
    ! [VarCurr: state_type] :
      ( v115712(VarCurr)
    <=> ( v115596(VarCurr)
        | v115695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12483,axiom,
    ! [VarCurr: state_type] :
      ( v115709(VarCurr)
    <=> ( v115710(VarCurr)
        | v115711(VarCurr) ) ) ).

tff(writeUnaryOperator_6738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115711(VarCurr)
    <=> v115695(VarCurr) ) ).

tff(writeUnaryOperator_6737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115710(VarCurr)
    <=> v115596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12482,axiom,
    ! [VarCurr: state_type] :
      ( v115591(VarCurr)
    <=> ( v115592(VarCurr)
        & v115707(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12481,axiom,
    ! [VarCurr: state_type] :
      ( v115707(VarCurr)
    <=> ( v115594(VarCurr)
        | v115702(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12480,axiom,
    ! [VarCurr: state_type] :
      ( v115592(VarCurr)
    <=> ( v115593(VarCurr)
        | v115701(VarCurr) ) ) ).

tff(writeUnaryOperator_6736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115701(VarCurr)
    <=> v115702(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12479,axiom,
    ! [VarCurr: state_type] :
      ( v115702(VarCurr)
    <=> ( v115703(VarCurr)
        & v115706(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4917,axiom,
    ! [VarCurr: state_type] :
      ( v115706(VarCurr)
    <=> ( v115597(VarCurr,2)
        | v115694(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12478,axiom,
    ! [VarCurr: state_type] :
      ( v115703(VarCurr)
    <=> ( v115704(VarCurr)
        | v115705(VarCurr) ) ) ).

tff(writeUnaryOperator_6735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115705(VarCurr)
    <=> v115694(VarCurr,2) ) ).

tff(writeUnaryOperator_6734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115704(VarCurr)
    <=> v115597(VarCurr,2) ) ).

tff(writeUnaryOperator_6733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115593(VarCurr)
    <=> v115594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12477,axiom,
    ! [VarCurr: state_type] :
      ( v115594(VarCurr)
    <=> ( v115595(VarCurr)
        | v115700(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4916,axiom,
    ! [VarCurr: state_type] :
      ( v115700(VarCurr)
    <=> ( v115597(VarCurr,1)
        & v115694(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12476,axiom,
    ! [VarCurr: state_type] :
      ( v115595(VarCurr)
    <=> ( v115596(VarCurr)
        & v115695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12475,axiom,
    ! [VarCurr: state_type] :
      ( v115695(VarCurr)
    <=> ( v115696(VarCurr)
        & v115699(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4915,axiom,
    ! [VarCurr: state_type] :
      ( v115699(VarCurr)
    <=> ( v115597(VarCurr,1)
        | v115694(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12474,axiom,
    ! [VarCurr: state_type] :
      ( v115696(VarCurr)
    <=> ( v115697(VarCurr)
        | v115698(VarCurr) ) ) ).

tff(writeUnaryOperator_6732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115698(VarCurr)
    <=> v115694(VarCurr,1) ) ).

tff(writeUnaryOperator_6731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115697(VarCurr)
    <=> v115597(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12473,axiom,
    ! [VarCurr: state_type] :
      ( v115596(VarCurr)
    <=> ( v115597(VarCurr,0)
        & v115694(VarCurr,0) ) ) ).

tff(addAssignment_68306,axiom,
    ! [VarCurr: state_type] :
      ( v115694(VarCurr,0)
    <=> v115568(VarCurr) ) ).

tff(addAssignment_68305,axiom,
    ! [VarCurr: state_type] :
      ( ( v115694(VarCurr,2)
      <=> $false )
      & ( v115694(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68304,axiom,
    ! [VarCurr: state_type] :
      ( v115597(VarCurr,0)
    <=> v115689(VarCurr) ) ).

tff(addAssignment_68303,axiom,
    ! [VarCurr: state_type] :
      ( v115597(VarCurr,1)
    <=> v115684(VarCurr) ) ).

tff(addAssignment_68302,axiom,
    ! [VarCurr: state_type] :
      ( v115597(VarCurr,2)
    <=> v115599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12472,axiom,
    ! [VarCurr: state_type] :
      ( v115689(VarCurr)
    <=> ( v115690(VarCurr)
        & v115693(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12471,axiom,
    ! [VarCurr: state_type] :
      ( v115693(VarCurr)
    <=> ( v115605(VarCurr,0)
        | v115670(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12470,axiom,
    ! [VarCurr: state_type] :
      ( v115690(VarCurr)
    <=> ( v115691(VarCurr)
        | v115692(VarCurr) ) ) ).

tff(writeUnaryOperator_6730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115692(VarCurr)
    <=> v115670(VarCurr,0) ) ).

tff(writeUnaryOperator_6729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115691(VarCurr)
    <=> v115605(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12469,axiom,
    ! [VarCurr: state_type] :
      ( v115684(VarCurr)
    <=> ( v115685(VarCurr)
        & v115688(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12468,axiom,
    ! [VarCurr: state_type] :
      ( v115688(VarCurr)
    <=> ( v115604(VarCurr)
        | v115671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12467,axiom,
    ! [VarCurr: state_type] :
      ( v115685(VarCurr)
    <=> ( v115686(VarCurr)
        | v115687(VarCurr) ) ) ).

tff(writeUnaryOperator_6728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115687(VarCurr)
    <=> v115671(VarCurr) ) ).

tff(writeUnaryOperator_6727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115686(VarCurr)
    <=> v115604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12466,axiom,
    ! [VarCurr: state_type] :
      ( v115599(VarCurr)
    <=> ( v115600(VarCurr)
        & v115683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12465,axiom,
    ! [VarCurr: state_type] :
      ( v115683(VarCurr)
    <=> ( v115602(VarCurr)
        | v115678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12464,axiom,
    ! [VarCurr: state_type] :
      ( v115600(VarCurr)
    <=> ( v115601(VarCurr)
        | v115677(VarCurr) ) ) ).

tff(writeUnaryOperator_6726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115677(VarCurr)
    <=> v115678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12463,axiom,
    ! [VarCurr: state_type] :
      ( v115678(VarCurr)
    <=> ( v115679(VarCurr)
        & v115682(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4914,axiom,
    ! [VarCurr: state_type] :
      ( v115682(VarCurr)
    <=> ( v115605(VarCurr,2)
        | v115670(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12462,axiom,
    ! [VarCurr: state_type] :
      ( v115679(VarCurr)
    <=> ( v115680(VarCurr)
        | v115681(VarCurr) ) ) ).

tff(writeUnaryOperator_6725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115681(VarCurr)
    <=> v115670(VarCurr,2) ) ).

tff(writeUnaryOperator_6724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115680(VarCurr)
    <=> v115605(VarCurr,2) ) ).

tff(writeUnaryOperator_6723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115601(VarCurr)
    <=> v115602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12461,axiom,
    ! [VarCurr: state_type] :
      ( v115602(VarCurr)
    <=> ( v115603(VarCurr)
        | v115676(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4913,axiom,
    ! [VarCurr: state_type] :
      ( v115676(VarCurr)
    <=> ( v115605(VarCurr,1)
        & v115670(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12460,axiom,
    ! [VarCurr: state_type] :
      ( v115603(VarCurr)
    <=> ( v115604(VarCurr)
        & v115671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12459,axiom,
    ! [VarCurr: state_type] :
      ( v115671(VarCurr)
    <=> ( v115672(VarCurr)
        & v115675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4912,axiom,
    ! [VarCurr: state_type] :
      ( v115675(VarCurr)
    <=> ( v115605(VarCurr,1)
        | v115670(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12458,axiom,
    ! [VarCurr: state_type] :
      ( v115672(VarCurr)
    <=> ( v115673(VarCurr)
        | v115674(VarCurr) ) ) ).

tff(writeUnaryOperator_6722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115674(VarCurr)
    <=> v115670(VarCurr,1) ) ).

tff(writeUnaryOperator_6721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115673(VarCurr)
    <=> v115605(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12457,axiom,
    ! [VarCurr: state_type] :
      ( v115604(VarCurr)
    <=> ( v115605(VarCurr,0)
        & v115670(VarCurr,0) ) ) ).

tff(addAssignment_68301,axiom,
    ! [VarCurr: state_type] :
      ( v115670(VarCurr,0)
    <=> v115566(VarCurr) ) ).

tff(addAssignment_68300,axiom,
    ! [VarCurr: state_type] :
      ( ( v115670(VarCurr,2)
      <=> $false )
      & ( v115670(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68299,axiom,
    ! [VarCurr: state_type] :
      ( v115605(VarCurr,0)
    <=> v115665(VarCurr) ) ).

tff(addAssignment_68298,axiom,
    ! [VarCurr: state_type] :
      ( v115605(VarCurr,1)
    <=> v115660(VarCurr) ) ).

tff(addAssignment_68297,axiom,
    ! [VarCurr: state_type] :
      ( v115605(VarCurr,2)
    <=> v115607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12456,axiom,
    ! [VarCurr: state_type] :
      ( v115665(VarCurr)
    <=> ( v115666(VarCurr)
        & v115669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12455,axiom,
    ! [VarCurr: state_type] :
      ( v115669(VarCurr)
    <=> ( v115613(VarCurr,0)
        | v115646(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12454,axiom,
    ! [VarCurr: state_type] :
      ( v115666(VarCurr)
    <=> ( v115667(VarCurr)
        | v115668(VarCurr) ) ) ).

tff(writeUnaryOperator_6720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115668(VarCurr)
    <=> v115646(VarCurr,0) ) ).

tff(writeUnaryOperator_6719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115667(VarCurr)
    <=> v115613(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12453,axiom,
    ! [VarCurr: state_type] :
      ( v115660(VarCurr)
    <=> ( v115661(VarCurr)
        & v115664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12452,axiom,
    ! [VarCurr: state_type] :
      ( v115664(VarCurr)
    <=> ( v115612(VarCurr)
        | v115647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12451,axiom,
    ! [VarCurr: state_type] :
      ( v115661(VarCurr)
    <=> ( v115662(VarCurr)
        | v115663(VarCurr) ) ) ).

tff(writeUnaryOperator_6718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115663(VarCurr)
    <=> v115647(VarCurr) ) ).

tff(writeUnaryOperator_6717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115662(VarCurr)
    <=> v115612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12450,axiom,
    ! [VarCurr: state_type] :
      ( v115607(VarCurr)
    <=> ( v115608(VarCurr)
        & v115659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12449,axiom,
    ! [VarCurr: state_type] :
      ( v115659(VarCurr)
    <=> ( v115610(VarCurr)
        | v115654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12448,axiom,
    ! [VarCurr: state_type] :
      ( v115608(VarCurr)
    <=> ( v115609(VarCurr)
        | v115653(VarCurr) ) ) ).

tff(writeUnaryOperator_6716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115653(VarCurr)
    <=> v115654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12447,axiom,
    ! [VarCurr: state_type] :
      ( v115654(VarCurr)
    <=> ( v115655(VarCurr)
        & v115658(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4911,axiom,
    ! [VarCurr: state_type] :
      ( v115658(VarCurr)
    <=> ( v115613(VarCurr,2)
        | v115646(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12446,axiom,
    ! [VarCurr: state_type] :
      ( v115655(VarCurr)
    <=> ( v115656(VarCurr)
        | v115657(VarCurr) ) ) ).

tff(writeUnaryOperator_6715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115657(VarCurr)
    <=> v115646(VarCurr,2) ) ).

tff(writeUnaryOperator_6714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115656(VarCurr)
    <=> v115613(VarCurr,2) ) ).

tff(writeUnaryOperator_6713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115609(VarCurr)
    <=> v115610(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12445,axiom,
    ! [VarCurr: state_type] :
      ( v115610(VarCurr)
    <=> ( v115611(VarCurr)
        | v115652(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4910,axiom,
    ! [VarCurr: state_type] :
      ( v115652(VarCurr)
    <=> ( v115613(VarCurr,1)
        & v115646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12444,axiom,
    ! [VarCurr: state_type] :
      ( v115611(VarCurr)
    <=> ( v115612(VarCurr)
        & v115647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12443,axiom,
    ! [VarCurr: state_type] :
      ( v115647(VarCurr)
    <=> ( v115648(VarCurr)
        & v115651(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4909,axiom,
    ! [VarCurr: state_type] :
      ( v115651(VarCurr)
    <=> ( v115613(VarCurr,1)
        | v115646(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12442,axiom,
    ! [VarCurr: state_type] :
      ( v115648(VarCurr)
    <=> ( v115649(VarCurr)
        | v115650(VarCurr) ) ) ).

tff(writeUnaryOperator_6712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115650(VarCurr)
    <=> v115646(VarCurr,1) ) ).

tff(writeUnaryOperator_6711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115649(VarCurr)
    <=> v115613(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12441,axiom,
    ! [VarCurr: state_type] :
      ( v115612(VarCurr)
    <=> ( v115613(VarCurr,0)
        & v115646(VarCurr,0) ) ) ).

tff(addAssignment_68296,axiom,
    ! [VarCurr: state_type] :
      ( v115646(VarCurr,0)
    <=> v115564(VarCurr) ) ).

tff(addAssignment_68295,axiom,
    ! [VarCurr: state_type] :
      ( ( v115646(VarCurr,2)
      <=> $false )
      & ( v115646(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68294,axiom,
    ! [VarCurr: state_type] :
      ( v115613(VarCurr,0)
    <=> v115641(VarCurr) ) ).

tff(addAssignment_68293,axiom,
    ! [VarCurr: state_type] :
      ( v115613(VarCurr,1)
    <=> v115636(VarCurr) ) ).

tff(addAssignment_68292,axiom,
    ! [VarCurr: state_type] :
      ( v115613(VarCurr,2)
    <=> v115615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12440,axiom,
    ! [VarCurr: state_type] :
      ( v115641(VarCurr)
    <=> ( v115642(VarCurr)
        & v115645(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12439,axiom,
    ! [VarCurr: state_type] :
      ( v115645(VarCurr)
    <=> ( v115621(VarCurr,0)
        | v115622(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12438,axiom,
    ! [VarCurr: state_type] :
      ( v115642(VarCurr)
    <=> ( v115643(VarCurr)
        | v115644(VarCurr) ) ) ).

tff(writeUnaryOperator_6710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115644(VarCurr)
    <=> v115622(VarCurr,0) ) ).

tff(writeUnaryOperator_6709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115643(VarCurr)
    <=> v115621(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12437,axiom,
    ! [VarCurr: state_type] :
      ( v115636(VarCurr)
    <=> ( v115637(VarCurr)
        & v115640(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12436,axiom,
    ! [VarCurr: state_type] :
      ( v115640(VarCurr)
    <=> ( v115620(VarCurr)
        | v115623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12435,axiom,
    ! [VarCurr: state_type] :
      ( v115637(VarCurr)
    <=> ( v115638(VarCurr)
        | v115639(VarCurr) ) ) ).

tff(writeUnaryOperator_6708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115639(VarCurr)
    <=> v115623(VarCurr) ) ).

tff(writeUnaryOperator_6707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115638(VarCurr)
    <=> v115620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12434,axiom,
    ! [VarCurr: state_type] :
      ( v115615(VarCurr)
    <=> ( v115616(VarCurr)
        & v115635(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12433,axiom,
    ! [VarCurr: state_type] :
      ( v115635(VarCurr)
    <=> ( v115618(VarCurr)
        | v115630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12432,axiom,
    ! [VarCurr: state_type] :
      ( v115616(VarCurr)
    <=> ( v115617(VarCurr)
        | v115629(VarCurr) ) ) ).

tff(writeUnaryOperator_6706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115629(VarCurr)
    <=> v115630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12431,axiom,
    ! [VarCurr: state_type] :
      ( v115630(VarCurr)
    <=> ( v115631(VarCurr)
        & v115634(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4908,axiom,
    ! [VarCurr: state_type] :
      ( v115634(VarCurr)
    <=> ( v115621(VarCurr,2)
        | v115622(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12430,axiom,
    ! [VarCurr: state_type] :
      ( v115631(VarCurr)
    <=> ( v115632(VarCurr)
        | v115633(VarCurr) ) ) ).

tff(writeUnaryOperator_6705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115633(VarCurr)
    <=> v115622(VarCurr,2) ) ).

tff(writeUnaryOperator_6704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115632(VarCurr)
    <=> v115621(VarCurr,2) ) ).

tff(writeUnaryOperator_6703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115617(VarCurr)
    <=> v115618(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12429,axiom,
    ! [VarCurr: state_type] :
      ( v115618(VarCurr)
    <=> ( v115619(VarCurr)
        | v115628(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4907,axiom,
    ! [VarCurr: state_type] :
      ( v115628(VarCurr)
    <=> ( v115621(VarCurr,1)
        & v115622(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12428,axiom,
    ! [VarCurr: state_type] :
      ( v115619(VarCurr)
    <=> ( v115620(VarCurr)
        & v115623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12427,axiom,
    ! [VarCurr: state_type] :
      ( v115623(VarCurr)
    <=> ( v115624(VarCurr)
        & v115627(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4906,axiom,
    ! [VarCurr: state_type] :
      ( v115627(VarCurr)
    <=> ( v115621(VarCurr,1)
        | v115622(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12426,axiom,
    ! [VarCurr: state_type] :
      ( v115624(VarCurr)
    <=> ( v115625(VarCurr)
        | v115626(VarCurr) ) ) ).

tff(writeUnaryOperator_6702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115626(VarCurr)
    <=> v115622(VarCurr,1) ) ).

tff(writeUnaryOperator_6701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115625(VarCurr)
    <=> v115621(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12425,axiom,
    ! [VarCurr: state_type] :
      ( v115620(VarCurr)
    <=> ( v115621(VarCurr,0)
        & v115622(VarCurr,0) ) ) ).

tff(addAssignment_68291,axiom,
    ! [VarCurr: state_type] :
      ( v115622(VarCurr,0)
    <=> v115562(VarCurr) ) ).

tff(addAssignment_68290,axiom,
    ! [VarCurr: state_type] :
      ( ( v115622(VarCurr,2)
      <=> $false )
      & ( v115622(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68289,axiom,
    ! [VarCurr: state_type] :
      ( v115621(VarCurr,0)
    <=> v115560(VarCurr) ) ).

tff(addAssignment_68288,axiom,
    ! [VarCurr: state_type] :
      ( ( v115621(VarCurr,2)
      <=> $false )
      & ( v115621(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68287,axiom,
    ! [VarCurr: state_type] :
      ( v115572(VarCurr)
    <=> v114692(VarCurr,2) ) ).

tff(addAssignment_68286,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,2)
    <=> v114694(VarCurr,2) ) ).

tff(addAssignment_68285,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,2)
    <=> v114696(VarCurr,2) ) ).

tff(addAssignment_68284,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,2)
    <=> v114697(VarCurr,2) ) ).

tff(addAssignment_68283,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,2)
    <=> v113918(VarCurr,2) ) ).

tff(addAssignment_68282,axiom,
    ! [VarCurr: state_type] :
      ( v115570(VarCurr)
    <=> v114685(VarCurr,2) ) ).

tff(addAssignment_68281,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,2)
    <=> v114686(VarCurr,2) ) ).

tff(addAssignment_68280,axiom,
    ! [VarCurr: state_type] :
      ( v115568(VarCurr)
    <=> v114661(VarCurr,2) ) ).

tff(addAssignment_68279,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,2)
    <=> v114662(VarCurr,2) ) ).

tff(addAssignment_68278,axiom,
    ! [VarCurr: state_type] :
      ( v115566(VarCurr)
    <=> v114633(VarCurr,2) ) ).

tff(addAssignment_68277,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,2)
    <=> v114635(VarCurr,2) ) ).

tff(addAssignment_68276,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,2)
    <=> v114637(VarCurr,2) ) ).

tff(addAssignment_68275,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,2)
    <=> v114638(VarCurr,2) ) ).

tff(addAssignment_68274,axiom,
    ! [VarCurr: state_type] :
      ( v115564(VarCurr)
    <=> v114605(VarCurr,2) ) ).

tff(addAssignment_68273,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,2)
    <=> v114607(VarCurr,2) ) ).

tff(addAssignment_68272,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,2)
    <=> v114609(VarCurr,2) ) ).

tff(addAssignment_68271,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,2)
    <=> v114610(VarCurr,2) ) ).

tff(addAssignment_68270,axiom,
    ! [VarCurr: state_type] :
      ( v115562(VarCurr)
    <=> v114577(VarCurr,2) ) ).

tff(addAssignment_68269,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,2)
    <=> v114579(VarCurr,2) ) ).

tff(addAssignment_68268,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,2)
    <=> v114581(VarCurr,2) ) ).

tff(addAssignment_68267,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,2)
    <=> v114582(VarCurr,2) ) ).

tff(addAssignment_68266,axiom,
    ! [VarCurr: state_type] :
      ( v115560(VarCurr)
    <=> v114549(VarCurr,2) ) ).

tff(addAssignment_68265,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,2)
    <=> v114551(VarCurr,2) ) ).

tff(addAssignment_68264,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,2)
    <=> v114553(VarCurr,2) ) ).

tff(addAssignment_68263,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,2)
    <=> v114554(VarCurr,2) ) ).

tff(addAssignment_68262,axiom,
    ! [VarCurr: state_type] :
      ( v115556(VarCurr)
    <=> v85774(VarCurr) ) ).

tff(addAssignment_68261,axiom,
    ! [VarCurr: state_type] :
      ( v115544(VarCurr)
    <=> v115546(VarCurr) ) ).

tff(addAssignment_68260,axiom,
    ! [VarCurr: state_type] :
      ( v115546(VarCurr)
    <=> v115520(VarCurr) ) ).

tff(addAssignment_68259,axiom,
    ! [VarCurr: state_type] :
      ( v115540(VarCurr)
    <=> v115542(VarCurr) ) ).

tff(addAssignment_68258,axiom,
    ! [VarCurr: state_type] :
      ( v115542(VarCurr)
    <=> v115512(VarCurr) ) ).

tff(addAssignment_68257,axiom,
    ! [VarCurr: state_type] :
      ( v115516(VarCurr)
    <=> v115518(VarCurr) ) ).

tff(addAssignment_68256,axiom,
    ! [VarCurr: state_type] :
      ( v115518(VarCurr)
    <=> v115520(VarCurr) ) ).

tff(addAssignment_68255,axiom,
    ! [VarCurr: state_type] :
      ( v115520(VarCurr)
    <=> v115522(VarCurr) ) ).

tff(addAssignment_68254,axiom,
    ! [VarCurr: state_type] :
      ( v115522(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_68253,axiom,
    ! [VarCurr: state_type] :
      ( v115508(VarCurr)
    <=> v115510(VarCurr) ) ).

tff(addAssignment_68252,axiom,
    ! [VarCurr: state_type] :
      ( v115510(VarCurr)
    <=> v115512(VarCurr) ) ).

tff(addAssignment_68251,axiom,
    ! [VarCurr: state_type] :
      ( v115512(VarCurr)
    <=> v115514(VarCurr) ) ).

tff(addAssignment_68250,axiom,
    ! [VarCurr: state_type] :
      ( v115514(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12424,axiom,
    ! [VarCurr: state_type] :
      ( v114487(VarCurr)
    <=> ( v115498(VarCurr)
        & v115408(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4905,axiom,
    ! [VarCurr: state_type] :
      ( v115498(VarCurr)
    <=> ( v114489(VarCurr,1)
        & v115347(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1151,axiom,
    ! [VarCurr: state_type] :
      ( v115408(VarCurr)
    <=> ( ( v115410(VarCurr,4)
        <=> $false )
        & ( v115410(VarCurr,3)
        <=> $false )
        & ( v115410(VarCurr,2)
        <=> $false )
        & ( v115410(VarCurr,1)
        <=> $false )
        & ( v115410(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115410(VarCurr,B)
      <=> v115412(VarCurr,B) ) ) ).

tff(addAssignment_68248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115412(VarCurr,B)
      <=> v115414(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1503,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115480(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v115414(VarNext,B)
            <=> v115414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1503,axiom,
    ! [VarNext: state_type] :
      ( v115480(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115414(VarNext,B)
          <=> v115490(VarNext,B) ) ) ) ).

tff(addAssignment_68247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115490(VarNext,B)
          <=> v115488(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115491(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115488(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1048,axiom,
    ! [VarCurr: state_type] :
      ( v115491(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115488(VarCurr,B)
          <=> v115424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12423,axiom,
    ! [VarCurr: state_type] :
      ( v115491(VarCurr)
    <=> ( v115492(VarCurr)
        & v115493(VarCurr) ) ) ).

tff(writeUnaryOperator_6700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115493(VarCurr)
    <=> v115420(VarCurr) ) ).

tff(writeUnaryOperator_6699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115492(VarCurr)
    <=> v115416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115480(VarNext)
      <=> v115481(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115481(VarNext)
      <=> ( v115482(VarNext)
          & v115475(VarNext) ) ) ) ).

tff(writeUnaryOperator_6698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115482(VarNext)
      <=> v115484(VarNext) ) ) ).

tff(addAssignment_68246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115484(VarNext)
      <=> v115475(VarCurr) ) ) ).

tff(addAssignment_68245,axiom,
    ! [VarCurr: state_type] :
      ( v115475(VarCurr)
    <=> v115477(VarCurr) ) ).

tff(addAssignment_68244,axiom,
    ! [VarCurr: state_type] :
      ( v115477(VarCurr)
    <=> v115117(VarCurr) ) ).

tff(addAssignment_68243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115424(VarCurr,B)
      <=> v115426(VarCurr,B) ) ) ).

tff(addAssignment_68242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115426(VarCurr,B)
      <=> v115428(VarCurr,B) ) ) ).

tff(addAssignment_68241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115428(VarCurr,B)
      <=> v115430(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115432(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115430(VarCurr,B)
          <=> v115444(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1047,axiom,
    ! [VarCurr: state_type] :
      ( v115432(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115430(VarCurr,B)
          <=> v115437(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115439(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115444(VarCurr,B)
          <=> v115445(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1046,axiom,
    ! [VarCurr: state_type] :
      ( v115439(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115444(VarCurr,B)
          <=> v115442(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115445(VarCurr,B)
          <=> v115446(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1045,axiom,
    ! [VarCurr: state_type] :
      ( v115408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v115445(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68240,axiom,
    ! [VarCurr: state_type] :
      ( v115446(VarCurr,0)
    <=> v115472(VarCurr) ) ).

tff(addAssignment_68239,axiom,
    ! [VarCurr: state_type] :
      ( v115446(VarCurr,1)
    <=> v115470(VarCurr) ) ).

tff(addAssignment_68238,axiom,
    ! [VarCurr: state_type] :
      ( v115446(VarCurr,2)
    <=> v115466(VarCurr) ) ).

tff(addAssignment_68237,axiom,
    ! [VarCurr: state_type] :
      ( v115446(VarCurr,3)
    <=> v115462(VarCurr) ) ).

tff(addAssignment_68236,axiom,
    ! [VarCurr: state_type] :
      ( v115446(VarCurr,4)
    <=> v115448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12420,axiom,
    ! [VarCurr: state_type] :
      ( v115470(VarCurr)
    <=> ( v115471(VarCurr)
        & v115473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12419,axiom,
    ! [VarCurr: state_type] :
      ( v115473(VarCurr)
    <=> ( v115410(VarCurr,0)
        | v115457(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4904,axiom,
    ! [VarCurr: state_type] :
      ( v115471(VarCurr)
    <=> ( v115472(VarCurr)
        | v115410(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115472(VarCurr)
    <=> v115410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12418,axiom,
    ! [VarCurr: state_type] :
      ( v115466(VarCurr)
    <=> ( v115467(VarCurr)
        & v115469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12417,axiom,
    ! [VarCurr: state_type] :
      ( v115469(VarCurr)
    <=> ( v115455(VarCurr)
        | v115458(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4903,axiom,
    ! [VarCurr: state_type] :
      ( v115467(VarCurr)
    <=> ( v115468(VarCurr)
        | v115410(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115468(VarCurr)
    <=> v115455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12416,axiom,
    ! [VarCurr: state_type] :
      ( v115462(VarCurr)
    <=> ( v115463(VarCurr)
        & v115465(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12415,axiom,
    ! [VarCurr: state_type] :
      ( v115465(VarCurr)
    <=> ( v115453(VarCurr)
        | v115459(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4902,axiom,
    ! [VarCurr: state_type] :
      ( v115463(VarCurr)
    <=> ( v115464(VarCurr)
        | v115410(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115464(VarCurr)
    <=> v115453(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12414,axiom,
    ! [VarCurr: state_type] :
      ( v115448(VarCurr)
    <=> ( v115449(VarCurr)
        & v115460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12413,axiom,
    ! [VarCurr: state_type] :
      ( v115460(VarCurr)
    <=> ( v115451(VarCurr)
        | v115461(VarCurr) ) ) ).

tff(writeUnaryOperator_6694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115461(VarCurr)
    <=> v115410(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4901,axiom,
    ! [VarCurr: state_type] :
      ( v115449(VarCurr)
    <=> ( v115450(VarCurr)
        | v115410(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115450(VarCurr)
    <=> v115451(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4900,axiom,
    ! [VarCurr: state_type] :
      ( v115451(VarCurr)
    <=> ( v115410(VarCurr,3)
        | v115452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12412,axiom,
    ! [VarCurr: state_type] :
      ( v115452(VarCurr)
    <=> ( v115453(VarCurr)
        & v115459(VarCurr) ) ) ).

tff(writeUnaryOperator_6692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115459(VarCurr)
    <=> v115410(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4899,axiom,
    ! [VarCurr: state_type] :
      ( v115453(VarCurr)
    <=> ( v115410(VarCurr,2)
        | v115454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12411,axiom,
    ! [VarCurr: state_type] :
      ( v115454(VarCurr)
    <=> ( v115455(VarCurr)
        & v115458(VarCurr) ) ) ).

tff(writeUnaryOperator_6691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115458(VarCurr)
    <=> v115410(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4898,axiom,
    ! [VarCurr: state_type] :
      ( v115455(VarCurr)
    <=> ( v115410(VarCurr,1)
        | v115456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12410,axiom,
    ! [VarCurr: state_type] :
      ( v115456(VarCurr)
    <=> ( v115410(VarCurr,0)
        & v115457(VarCurr) ) ) ).

tff(writeUnaryOperator_6690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115457(VarCurr)
    <=> v115410(VarCurr,1) ) ).

tff(addAssignment_68235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115442(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12409,axiom,
    ! [VarCurr: state_type] :
      ( v115439(VarCurr)
    <=> ( v114918(VarCurr)
        | v114932(VarCurr) ) ) ).

tff(addAssignment_68234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v115437(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12408,axiom,
    ! [VarCurr: state_type] :
      ( v115432(VarCurr)
    <=> ( v115434(VarCurr)
        | v114930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12407,axiom,
    ! [VarCurr: state_type] :
      ( v115434(VarCurr)
    <=> ( v115435(VarCurr)
        | v114928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12406,axiom,
    ! [VarCurr: state_type] :
      ( v115435(VarCurr)
    <=> ( v114898(VarCurr)
        | v114908(VarCurr) ) ) ).

tff(addAssignment_68233,axiom,
    ! [VarCurr: state_type] :
      ( v115420(VarCurr)
    <=> v115422(VarCurr) ) ).

tff(addAssignment_68232,axiom,
    ! [VarCurr: state_type] :
      ( v115422(VarCurr)
    <=> v114507(VarCurr) ) ).

tff(addAssignment_68231,axiom,
    ! [VarCurr: state_type] :
      ( v115416(VarCurr)
    <=> v115418(VarCurr) ) ).

tff(addAssignment_68230,axiom,
    ! [VarCurr: state_type] :
      ( v115418(VarCurr)
    <=> v114499(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1150,axiom,
    ! [VarCurr: state_type] :
      ( v115347(VarCurr)
    <=> ( ( v115349(VarCurr,1)
        <=> $false )
        & ( v115349(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v115349(VarCurr,B)
      <=> v115351(VarCurr,B) ) ) ).

tff(addAssignment_68228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v115351(VarCurr,B)
      <=> v115353(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115390(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v115353(VarNext,B)
            <=> v115353(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1502,axiom,
    ! [VarNext: state_type] :
      ( v115390(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115353(VarNext,B)
          <=> v115400(VarNext,B) ) ) ) ).

tff(addAssignment_68227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115400(VarNext,B)
          <=> v115398(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115398(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1044,axiom,
    ! [VarCurr: state_type] :
      ( v115401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115398(VarCurr,B)
          <=> v115363(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12405,axiom,
    ! [VarCurr: state_type] :
      ( v115401(VarCurr)
    <=> ( v115402(VarCurr)
        & v115403(VarCurr) ) ) ).

tff(writeUnaryOperator_6689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115403(VarCurr)
    <=> v115359(VarCurr) ) ).

tff(writeUnaryOperator_6688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115402(VarCurr)
    <=> v115355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115390(VarNext)
      <=> v115391(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115391(VarNext)
      <=> ( v115392(VarNext)
          & v115385(VarNext) ) ) ) ).

tff(writeUnaryOperator_6687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115392(VarNext)
      <=> v115394(VarNext) ) ) ).

tff(addAssignment_68226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115394(VarNext)
      <=> v115385(VarCurr) ) ) ).

tff(addAssignment_68225,axiom,
    ! [VarCurr: state_type] :
      ( v115385(VarCurr)
    <=> v115387(VarCurr) ) ).

tff(addAssignment_68224,axiom,
    ! [VarCurr: state_type] :
      ( v115387(VarCurr)
    <=> v115117(VarCurr) ) ).

tff(addAssignment_68223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v115363(VarCurr,B)
      <=> v115365(VarCurr,B) ) ) ).

tff(addAssignment_68222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v115365(VarCurr,B)
      <=> v115367(VarCurr,B) ) ) ).

tff(addAssignment_68221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v115367(VarCurr,B)
      <=> v115369(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115371(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115369(VarCurr,B)
          <=> v115376(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1043,axiom,
    ! [VarCurr: state_type] :
      ( v115371(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115369(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115347(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115376(VarCurr,B)
          <=> v115377(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1042,axiom,
    ! [VarCurr: state_type] :
      ( v115347(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v115376(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_68220,axiom,
    ! [VarCurr: state_type] :
      ( v115377(VarCurr,0)
    <=> v115381(VarCurr) ) ).

tff(addAssignment_68219,axiom,
    ! [VarCurr: state_type] :
      ( v115377(VarCurr,1)
    <=> v115379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12402,axiom,
    ! [VarCurr: state_type] :
      ( v115379(VarCurr)
    <=> ( v115380(VarCurr)
        & v115382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12401,axiom,
    ! [VarCurr: state_type] :
      ( v115382(VarCurr)
    <=> ( v115349(VarCurr,0)
        | v115383(VarCurr) ) ) ).

tff(writeUnaryOperator_6686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115383(VarCurr)
    <=> v115349(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4897,axiom,
    ! [VarCurr: state_type] :
      ( v115380(VarCurr)
    <=> ( v115381(VarCurr)
        | v115349(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115381(VarCurr)
    <=> v115349(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12400,axiom,
    ! [VarCurr: state_type] :
      ( v115371(VarCurr)
    <=> ( v115373(VarCurr)
        | v115374(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4896,axiom,
    ! [VarCurr: state_type] :
      ( v115374(VarCurr)
    <=> ( v114489(VarCurr,1)
        & v115183(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4895,axiom,
    ! [VarCurr: state_type] :
      ( v115373(VarCurr)
    <=> ( v114489(VarCurr,3)
        & v115272(VarCurr) ) ) ).

tff(addAssignment_68218,axiom,
    ! [VarCurr: state_type] :
      ( v115359(VarCurr)
    <=> v115361(VarCurr) ) ).

tff(addAssignment_68217,axiom,
    ! [VarCurr: state_type] :
      ( v115361(VarCurr)
    <=> v114507(VarCurr) ) ).

tff(addAssignment_68216,axiom,
    ! [VarCurr: state_type] :
      ( v115355(VarCurr)
    <=> v115357(VarCurr) ) ).

tff(addAssignment_68215,axiom,
    ! [VarCurr: state_type] :
      ( v115357(VarCurr)
    <=> v114499(VarCurr) ) ).

tff(addAssignment_68214,axiom,
    ! [VarCurr: state_type] :
      ( v114489(VarCurr,1)
    <=> v114491(VarCurr,1) ) ).

tff(addAssignment_68213,axiom,
    ! [VarCurr: state_type] :
      ( v114491(VarCurr,1)
    <=> v114493(VarCurr,1) ) ).

tff(addAssignment_68212,axiom,
    ! [VarNext: state_type] :
      ( v114493(VarNext,1)
    <=> v115339(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115340(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v115339(VarNext,B)
            <=> v114493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1501,axiom,
    ! [VarNext: state_type] :
      ( v115340(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115339(VarNext,B)
          <=> v115265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115340(VarNext)
      <=> v115341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115341(VarNext)
      <=> ( v115343(VarNext)
          & v115250(VarNext) ) ) ) ).

tff(writeUnaryOperator_6684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115343(VarNext)
      <=> v115259(VarNext) ) ) ).

tff(addAssignment_68211,axiom,
    ! [VarCurr: state_type] :
      ( v114511(VarCurr,1)
    <=> v114513(VarCurr,1) ) ).

tff(addAssignment_68210,axiom,
    ! [VarCurr: state_type] :
      ( v114513(VarCurr,1)
    <=> v114515(VarCurr,1) ) ).

tff(addAssignment_68209,axiom,
    ! [VarCurr: state_type] :
      ( v114515(VarCurr,1)
    <=> v115248(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_35,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115330(VarCurr)
     => ( v114517(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_64,axiom,
    ! [VarCurr: state_type] :
      ( v115330(VarCurr)
     => ( v114517(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12397,axiom,
    ! [VarCurr: state_type] :
      ( v115330(VarCurr)
    <=> ( v115331(VarCurr)
        | v115332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12396,axiom,
    ! [VarCurr: state_type] :
      ( v115332(VarCurr)
    <=> ( v115333(VarCurr)
        & v115334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12395,axiom,
    ! [VarCurr: state_type] :
      ( v115334(VarCurr)
    <=> ( v115335(VarCurr)
        & v115231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12394,axiom,
    ! [VarCurr: state_type] :
      ( v115335(VarCurr)
    <=> ( v115336(VarCurr)
        & v115337(VarCurr) ) ) ).

tff(writeUnaryOperator_6683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115337(VarCurr)
    <=> v115223(VarCurr) ) ).

tff(writeUnaryOperator_6682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115336(VarCurr)
    <=> v115183(VarCurr) ) ).

tff(writeUnaryOperator_6681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115333(VarCurr)
    <=> v115233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12393,axiom,
    ! [VarCurr: state_type] :
      ( v115331(VarCurr)
    <=> ( v115305(VarCurr)
        & v115233(VarCurr) ) ) ).

tff(writeUnaryOperator_6680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114489(VarCurr,0)
    <=> v115179(VarCurr) ) ).

tff(addAssignment_68208,axiom,
    ! [VarCurr: state_type] :
      ( v115179(VarCurr)
    <=> v114491(VarCurr,0) ) ).

tff(addAssignment_68207,axiom,
    ! [VarCurr: state_type] :
      ( v114491(VarCurr,0)
    <=> v114493(VarCurr,0) ) ).

tff(addAssignment_68206,axiom,
    ! [VarNext: state_type] :
      ( v114493(VarNext,0)
    <=> v115321(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115322(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v115321(VarNext,B)
            <=> v114493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1500,axiom,
    ! [VarNext: state_type] :
      ( v115322(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115321(VarNext,B)
          <=> v115265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115322(VarNext)
      <=> v115323(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115323(VarNext)
      <=> ( v115325(VarNext)
          & v115250(VarNext) ) ) ) ).

tff(writeUnaryOperator_6679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115325(VarNext)
      <=> v115259(VarNext) ) ) ).

tff(addAssignment_68205,axiom,
    ! [VarCurr: state_type] :
      ( v114511(VarCurr,0)
    <=> v114513(VarCurr,0) ) ).

tff(addAssignment_68204,axiom,
    ! [VarCurr: state_type] :
      ( v114513(VarCurr,0)
    <=> v114515(VarCurr,0) ) ).

tff(addAssignment_68203,axiom,
    ! [VarCurr: state_type] :
      ( v114515(VarCurr,0)
    <=> v115248(VarCurr,0) ) ).

tff(writeUnaryOperator_6678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115181(VarCurr)
    <=> v114517(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115300(VarCurr)
     => ( v114517(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1041,axiom,
    ! [VarCurr: state_type] :
      ( v115300(VarCurr)
     => ( v114517(VarCurr,0)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12390,axiom,
    ! [VarCurr: state_type] :
      ( v115300(VarCurr)
    <=> ( v115301(VarCurr)
        | v115314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12389,axiom,
    ! [VarCurr: state_type] :
      ( v115314(VarCurr)
    <=> ( v115315(VarCurr)
        & v115318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12388,axiom,
    ! [VarCurr: state_type] :
      ( v115318(VarCurr)
    <=> ( v115286(VarCurr)
        & v115289(VarCurr) ) ) ).

tff(writeUnaryOperator_6677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115315(VarCurr)
    <=> v115316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12387,axiom,
    ! [VarCurr: state_type] :
      ( v115316(VarCurr)
    <=> ( v115317(VarCurr)
        | v115246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12386,axiom,
    ! [VarCurr: state_type] :
      ( v115317(VarCurr)
    <=> ( v115233(VarCurr)
        | v115231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12385,axiom,
    ! [VarCurr: state_type] :
      ( v115301(VarCurr)
    <=> ( v115302(VarCurr)
        | v115310(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12384,axiom,
    ! [VarCurr: state_type] :
      ( v115310(VarCurr)
    <=> ( v115311(VarCurr)
        & v115313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12383,axiom,
    ! [VarCurr: state_type] :
      ( v115313(VarCurr)
    <=> ( v115244(VarCurr)
        & v115246(VarCurr) ) ) ).

tff(writeUnaryOperator_6676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115311(VarCurr)
    <=> v115312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12382,axiom,
    ! [VarCurr: state_type] :
      ( v115312(VarCurr)
    <=> ( v115233(VarCurr)
        | v115231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12381,axiom,
    ! [VarCurr: state_type] :
      ( v115302(VarCurr)
    <=> ( v115303(VarCurr)
        | v115307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12380,axiom,
    ! [VarCurr: state_type] :
      ( v115307(VarCurr)
    <=> ( v115308(VarCurr)
        & v115309(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12379,axiom,
    ! [VarCurr: state_type] :
      ( v115309(VarCurr)
    <=> ( v115223(VarCurr)
        & v115231(VarCurr) ) ) ).

tff(writeUnaryOperator_6675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115308(VarCurr)
    <=> v115233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12378,axiom,
    ! [VarCurr: state_type] :
      ( v115303(VarCurr)
    <=> ( v115304(VarCurr)
        & v115233(VarCurr) ) ) ).

tff(writeUnaryOperator_6674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115304(VarCurr)
    <=> v115305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12377,axiom,
    ! [VarCurr: state_type] :
      ( v115305(VarCurr)
    <=> ( v115306(VarCurr)
        & v115177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12376,axiom,
    ! [VarCurr: state_type] :
      ( v115306(VarCurr)
    <=> ( v114519(VarCurr)
        & v115175(VarCurr) ) ) ).

tff(addAssignment_68202,axiom,
    ! [VarCurr: state_type] :
      ( v114489(VarCurr,3)
    <=> v114491(VarCurr,3) ) ).

tff(addAssignment_68201,axiom,
    ! [VarCurr: state_type] :
      ( v114491(VarCurr,3)
    <=> v114493(VarCurr,3) ) ).

tff(addAssignment_68200,axiom,
    ! [VarNext: state_type] :
      ( v114493(VarNext,3)
    <=> v115292(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115293(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v115292(VarNext,B)
            <=> v114493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1499,axiom,
    ! [VarNext: state_type] :
      ( v115293(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115292(VarNext,B)
          <=> v115265(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115293(VarNext)
      <=> v115294(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115294(VarNext)
      <=> ( v115296(VarNext)
          & v115250(VarNext) ) ) ) ).

tff(writeUnaryOperator_6673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115296(VarNext)
      <=> v115259(VarNext) ) ) ).

tff(addAssignment_68199,axiom,
    ! [VarCurr: state_type] :
      ( v114511(VarCurr,3)
    <=> v114513(VarCurr,3) ) ).

tff(addAssignment_68198,axiom,
    ! [VarCurr: state_type] :
      ( v114513(VarCurr,3)
    <=> v114515(VarCurr,3) ) ).

tff(addAssignment_68197,axiom,
    ! [VarCurr: state_type] :
      ( v114515(VarCurr,3)
    <=> v115248(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_34,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115274(VarCurr)
     => ( v114517(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_63,axiom,
    ! [VarCurr: state_type] :
      ( v115274(VarCurr)
     => ( v114517(VarCurr,3)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12373,axiom,
    ! [VarCurr: state_type] :
      ( v115274(VarCurr)
    <=> ( v115275(VarCurr)
        | v115281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12372,axiom,
    ! [VarCurr: state_type] :
      ( v115281(VarCurr)
    <=> ( v115282(VarCurr)
        & v115283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12371,axiom,
    ! [VarCurr: state_type] :
      ( v115283(VarCurr)
    <=> ( v115284(VarCurr)
        & v115290(VarCurr) ) ) ).

tff(writeUnaryOperator_6672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115290(VarCurr)
    <=> v115280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12370,axiom,
    ! [VarCurr: state_type] :
      ( v115284(VarCurr)
    <=> ( v115285(VarCurr)
        & v115289(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1149,axiom,
    ! [VarCurr: state_type] :
      ( v115289(VarCurr)
    <=> ( $true
      <=> v114489(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115285(VarCurr)
    <=> v115286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12369,axiom,
    ! [VarCurr: state_type] :
      ( v115286(VarCurr)
    <=> ( v115287(VarCurr)
        | v115216(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12368,axiom,
    ! [VarCurr: state_type] :
      ( v115287(VarCurr)
    <=> ( v115288(VarCurr)
        | v115272(VarCurr) ) ) ).

tff(writeUnaryOperator_6670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115288(VarCurr)
    <=> v115175(VarCurr) ) ).

tff(writeUnaryOperator_6669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115282(VarCurr)
    <=> v115246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12367,axiom,
    ! [VarCurr: state_type] :
      ( v115275(VarCurr)
    <=> ( v115276(VarCurr)
        & v115279(VarCurr) ) ) ).

tff(writeUnaryOperator_6668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115279(VarCurr)
    <=> v115280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12366,axiom,
    ! [VarCurr: state_type] :
      ( v115280(VarCurr)
    <=> ( v115233(VarCurr)
        | v115231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12365,axiom,
    ! [VarCurr: state_type] :
      ( v115276(VarCurr)
    <=> ( v115277(VarCurr)
        & v115246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12364,axiom,
    ! [VarCurr: state_type] :
      ( v115277(VarCurr)
    <=> ( v115240(VarCurr)
        & v115278(VarCurr) ) ) ).

tff(writeUnaryOperator_6667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115278(VarCurr)
    <=> v115244(VarCurr) ) ).

tff(addAssignment_68196,axiom,
    ! [VarCurr: state_type] :
      ( v115272(VarCurr)
    <=> v112831(VarCurr,1) ) ).

tff(addAssignment_68195,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,1)
    <=> v112865(VarCurr,1) ) ).

tff(addAssignment_68194,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,1)
    <=> v112849(VarCurr,1) ) ).

tff(addAssignment_68193,axiom,
    ! [VarCurr: state_type] :
      ( v114489(VarCurr,2)
    <=> v114491(VarCurr,2) ) ).

tff(addAssignment_68192,axiom,
    ! [VarCurr: state_type] :
      ( v114491(VarCurr,2)
    <=> v114493(VarCurr,2) ) ).

tff(addAssignment_68191,axiom,
    ! [VarNext: state_type] :
      ( v114493(VarNext,2)
    <=> v115254(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v115254(VarNext,B)
            <=> v114493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1498,axiom,
    ! [VarNext: state_type] :
      ( v115255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115254(VarNext,B)
          <=> v115265(VarNext,B) ) ) ) ).

tff(addAssignment_68190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115265(VarNext,B)
          <=> v115263(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115266(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115263(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1040,axiom,
    ! [VarCurr: state_type] :
      ( v115266(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v115263(VarCurr,B)
          <=> v114511(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12363,axiom,
    ! [VarCurr: state_type] :
      ( v115266(VarCurr)
    <=> ( v115267(VarCurr)
        & v115268(VarCurr) ) ) ).

tff(writeUnaryOperator_6666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115268(VarCurr)
    <=> v114503(VarCurr) ) ).

tff(writeUnaryOperator_6665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115267(VarCurr)
    <=> v114495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115255(VarNext)
      <=> v115256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115256(VarNext)
      <=> ( v115257(VarNext)
          & v115250(VarNext) ) ) ) ).

tff(writeUnaryOperator_6664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115257(VarNext)
      <=> v115259(VarNext) ) ) ).

tff(addAssignment_68189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115259(VarNext)
      <=> v115250(VarCurr) ) ) ).

tff(addAssignment_68188,axiom,
    ! [VarCurr: state_type] :
      ( v115250(VarCurr)
    <=> v115252(VarCurr) ) ).

tff(addAssignment_68187,axiom,
    ! [VarCurr: state_type] :
      ( v115252(VarCurr)
    <=> v115117(VarCurr) ) ).

tff(addAssignment_68186,axiom,
    ! [VarCurr: state_type] :
      ( v114511(VarCurr,2)
    <=> v114513(VarCurr,2) ) ).

tff(addAssignment_68185,axiom,
    ! [VarCurr: state_type] :
      ( v114513(VarCurr,2)
    <=> v114515(VarCurr,2) ) ).

tff(addAssignment_68184,axiom,
    ! [VarCurr: state_type] :
      ( v114515(VarCurr,2)
    <=> v115248(VarCurr,2) ) ).

tff(addAssignment_68183,axiom,
    ! [VarCurr: state_type] :
      ( v115248(VarCurr,0)
    <=> v115181(VarCurr) ) ).

tff(addAssignment_68182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v115248(VarCurr,B)
      <=> v114517(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_33,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115218(VarCurr)
     => ( v114517(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_62,axiom,
    ! [VarCurr: state_type] :
      ( v115218(VarCurr)
     => ( v114517(VarCurr,2)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12360,axiom,
    ! [VarCurr: state_type] :
      ( v115218(VarCurr)
    <=> ( v115219(VarCurr)
        | v115234(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12359,axiom,
    ! [VarCurr: state_type] :
      ( v115234(VarCurr)
    <=> ( v115235(VarCurr)
        & v115236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12358,axiom,
    ! [VarCurr: state_type] :
      ( v115236(VarCurr)
    <=> ( v115237(VarCurr)
        & v115247(VarCurr) ) ) ).

tff(writeUnaryOperator_6663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115247(VarCurr)
    <=> v115233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12357,axiom,
    ! [VarCurr: state_type] :
      ( v115237(VarCurr)
    <=> ( v115238(VarCurr)
        & v115246(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1148,axiom,
    ! [VarCurr: state_type] :
      ( v115246(VarCurr)
    <=> ( $true
      <=> v114489(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12356,axiom,
    ! [VarCurr: state_type] :
      ( v115238(VarCurr)
    <=> ( v115239(VarCurr)
        & v115243(VarCurr) ) ) ).

tff(writeUnaryOperator_6662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115243(VarCurr)
    <=> v115244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12355,axiom,
    ! [VarCurr: state_type] :
      ( v115244(VarCurr)
    <=> ( v115245(VarCurr)
        | v115216(VarCurr) ) ) ).

tff(writeUnaryOperator_6661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115245(VarCurr)
    <=> v115175(VarCurr) ) ).

tff(writeUnaryOperator_6660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115239(VarCurr)
    <=> v115240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12354,axiom,
    ! [VarCurr: state_type] :
      ( v115240(VarCurr)
    <=> ( v115241(VarCurr)
        | v115242(VarCurr) ) ) ).

tff(writeUnaryOperator_6659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115242(VarCurr)
    <=> v115177(VarCurr) ) ).

tff(writeUnaryOperator_6658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115241(VarCurr)
    <=> v114519(VarCurr) ) ).

tff(writeUnaryOperator_6657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115235(VarCurr)
    <=> v115231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12353,axiom,
    ! [VarCurr: state_type] :
      ( v115219(VarCurr)
    <=> ( v115220(VarCurr)
        & v115232(VarCurr) ) ) ).

tff(writeUnaryOperator_6656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115232(VarCurr)
    <=> v115233(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1147,axiom,
    ! [VarCurr: state_type] :
      ( v115233(VarCurr)
    <=> ( $true
      <=> v114489(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12352,axiom,
    ! [VarCurr: state_type] :
      ( v115220(VarCurr)
    <=> ( v115221(VarCurr)
        & v115231(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1146,axiom,
    ! [VarCurr: state_type] :
      ( v115231(VarCurr)
    <=> ( $true
      <=> v114489(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12351,axiom,
    ! [VarCurr: state_type] :
      ( v115221(VarCurr)
    <=> ( v115183(VarCurr)
        & v115222(VarCurr) ) ) ).

tff(writeUnaryOperator_6655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115222(VarCurr)
    <=> v115223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12350,axiom,
    ! [VarCurr: state_type] :
      ( v115223(VarCurr)
    <=> ( v115224(VarCurr)
        | v115216(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12349,axiom,
    ! [VarCurr: state_type] :
      ( v115224(VarCurr)
    <=> ( v115225(VarCurr)
        | v115228(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12348,axiom,
    ! [VarCurr: state_type] :
      ( v115228(VarCurr)
    <=> ( v115229(VarCurr)
        & v115230(VarCurr) ) ) ).

tff(writeUnaryOperator_6654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115230(VarCurr)
    <=> v115183(VarCurr) ) ).

tff(writeUnaryOperator_6653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115229(VarCurr)
    <=> v114519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12347,axiom,
    ! [VarCurr: state_type] :
      ( v115225(VarCurr)
    <=> ( v115226(VarCurr)
        | v115227(VarCurr) ) ) ).

tff(writeUnaryOperator_6652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115227(VarCurr)
    <=> v115177(VarCurr) ) ).

tff(writeUnaryOperator_6651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115226(VarCurr)
    <=> v115175(VarCurr) ) ).

tff(addAssignment_68181,axiom,
    ! [VarCurr: state_type] :
      ( v115216(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_68180,axiom,
    ! [VarCurr: state_type] :
      ( v115183(VarCurr)
    <=> v112643(VarCurr,1) ) ).

tff(addAssignment_68179,axiom,
    ! [VarCurr: state_type] :
      ( v112643(VarCurr,1)
    <=> v115202(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v115202(VarCurr,B)
      <=> ( v115203(VarCurr,B)
          & v115185(VarCurr,B) ) ) ) ).

tff(addAssignment_68178,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,0)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68177,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,1)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68176,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,2)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68175,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,3)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68174,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,4)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68173,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,5)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68172,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,6)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68171,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,7)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68170,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,8)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68169,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,9)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68168,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,10)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68167,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,11)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68166,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,12)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68165,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,13)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68164,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,14)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68163,axiom,
    ! [VarCurr: state_type] :
      ( v115203(VarCurr,15)
    <=> v115204(VarCurr) ) ).

tff(addAssignment_68162,axiom,
    ! [VarCurr: state_type] :
      ( v115204(VarCurr)
    <=> v115205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12346,axiom,
    ! [VarCurr: state_type] :
      ( v115205(VarCurr)
    <=> ( v115206(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12345,axiom,
    ! [VarCurr: state_type] :
      ( v115206(VarCurr)
    <=> ( v115207(VarCurr)
        & v112751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12344,axiom,
    ! [VarCurr: state_type] :
      ( v115207(VarCurr)
    <=> ( v115208(VarCurr)
        & v115214(VarCurr) ) ) ).

tff(writeUnaryOperator_6650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115214(VarCurr)
    <=> v112520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12343,axiom,
    ! [VarCurr: state_type] :
      ( v115208(VarCurr)
    <=> ( v115209(VarCurr)
        & v115213(VarCurr) ) ) ).

tff(writeUnaryOperator_6649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115213(VarCurr)
    <=> v112698(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12342,axiom,
    ! [VarCurr: state_type] :
      ( v115209(VarCurr)
    <=> ( v115210(VarCurr)
        & v115212(VarCurr) ) ) ).

tff(writeUnaryOperator_6648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115212(VarCurr)
    <=> v112688(VarCurr) ) ).

tff(writeUnaryOperator_6647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115210(VarCurr)
    <=> v115211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12341,axiom,
    ! [VarCurr: state_type] :
      ( v115211(VarCurr)
    <=> ( v111651(VarCurr)
        | v112645(VarCurr) ) ) ).

tff(addAssignment_68161,axiom,
    ! [VarCurr: state_type] :
      ( v115185(VarCurr,1)
    <=> v115186(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115186(VarCurr,B)
          <=> v115187(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1039,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115186(VarCurr,B)
          <=> b0000000000000001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115187(VarCurr,B)
          <=> v115188(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1038,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115187(VarCurr,B)
          <=> b0000000000000010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115188(VarCurr,B)
          <=> v115189(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1037,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115188(VarCurr,B)
          <=> b0000000000000100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115189(VarCurr,B)
          <=> v115190(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1036,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115189(VarCurr,B)
          <=> b0000000000001000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115190(VarCurr,B)
          <=> v115191(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1035,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115190(VarCurr,B)
          <=> b0000000000010000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115191(VarCurr,B)
          <=> v115192(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1034,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115191(VarCurr,B)
          <=> b0000000000100000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115192(VarCurr,B)
          <=> v115193(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1033,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115192(VarCurr,B)
          <=> b0000000001000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115193(VarCurr,B)
          <=> v115194(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1032,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115193(VarCurr,B)
          <=> b0000000010000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115194(VarCurr,B)
          <=> v115195(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1031,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115194(VarCurr,B)
          <=> b0000000100000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115195(VarCurr,B)
          <=> v115196(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1030,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115195(VarCurr,B)
          <=> b0000001000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115196(VarCurr,B)
          <=> v115197(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1029,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115196(VarCurr,B)
          <=> b0000010000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115197(VarCurr,B)
          <=> v115198(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1028,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115197(VarCurr,B)
          <=> b0000100000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115198(VarCurr,B)
          <=> v115199(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1027,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115198(VarCurr,B)
          <=> b0001000000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115199(VarCurr,B)
          <=> v115200(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1026,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115199(VarCurr,B)
          <=> b0010000000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115200(VarCurr,B)
          <=> v115201(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1025,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115200(VarCurr,B)
          <=> b0100000000000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112753(VarCurr,15)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115201(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1024,axiom,
    ! [VarCurr: state_type] :
      ( v112753(VarCurr,15)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v115201(VarCurr,B)
          <=> b1000000000000000(B) ) ) ) ).

tff(addAssignment_68160,axiom,
    ! [VarCurr: state_type] :
      ( v115177(VarCurr)
    <=> v112528(VarCurr,1) ) ).

tff(addAssignment_68159,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,1)
    <=> v112530(VarCurr,1) ) ).

tff(addAssignment_68158,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,1)
    <=> v112590(VarCurr,1) ) ).

tff(addAssignment_68157,axiom,
    ! [VarCurr: state_type] :
      ( v115175(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12340,axiom,
    ! [VarCurr: state_type] :
      ( v114519(VarCurr)
    <=> ( v115172(VarCurr)
        & v115173(VarCurr) ) ) ).

tff(writeUnaryOperator_6646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115173(VarCurr)
    <=> v115137(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1145,axiom,
    ! [VarCurr: state_type] :
      ( v115172(VarCurr)
    <=> ( ( v114521(VarCurr,5)
        <=> $false )
        & ( v114521(VarCurr,4)
        <=> $false )
        & ( v114521(VarCurr,3)
        <=> $false )
        & ( v114521(VarCurr,2)
        <=> $false )
        & ( v114521(VarCurr,1)
        <=> $false )
        & ( v114521(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_68156,axiom,
    ! [VarCurr: state_type] :
      ( v115137(VarCurr)
    <=> v115139(VarCurr,1) ) ).

tff(addAssignment_68155,axiom,
    ! [VarCurr: state_type] :
      ( v115139(VarCurr,1)
    <=> v115159(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v115159(VarCurr,B)
      <=> ( v115160(VarCurr,B)
          | v115166(VarCurr,B) ) ) ) ).

tff(addAssignment_68154,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,0)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68153,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,1)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68152,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,2)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68151,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,3)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68150,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,4)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68149,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,5)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68148,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,6)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68147,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,7)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68146,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,8)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68145,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,9)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68144,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,10)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68143,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,11)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68142,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,12)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68141,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,13)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68140,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,14)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68139,axiom,
    ! [VarCurr: state_type] :
      ( v115166(VarCurr,15)
    <=> v115167(VarCurr) ) ).

tff(addAssignment_68138,axiom,
    ! [VarCurr: state_type] :
      ( v115167(VarCurr)
    <=> v115168(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12339,axiom,
    ! [VarCurr: state_type] :
      ( v115168(VarCurr)
    <=> ( v115169(VarCurr)
        | v84321(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4894,axiom,
    ! [VarCurr: state_type] :
      ( v115169(VarCurr)
    <=> ( v84297(VarCurr,5)
        | v84297(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v115160(VarCurr,B)
      <=> ( v115161(VarCurr,B)
          & v115141(VarCurr,B) ) ) ) ).

tff(addAssignment_68137,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,0)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68136,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,1)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68135,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,2)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68134,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,3)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68133,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,4)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68132,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,5)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68131,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,6)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68130,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,7)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68129,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,8)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68128,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,9)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68127,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,10)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68126,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,11)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68125,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,12)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68124,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,13)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68123,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,14)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68122,axiom,
    ! [VarCurr: state_type] :
      ( v115161(VarCurr,15)
    <=> v115162(VarCurr) ) ).

tff(addAssignment_68121,axiom,
    ! [VarCurr: state_type] :
      ( v115162(VarCurr)
    <=> v115163(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4893,axiom,
    ! [VarCurr: state_type] :
      ( v115163(VarCurr)
    <=> ( v115165(VarCurr)
        | v84297(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4892,axiom,
    ! [VarCurr: state_type] :
      ( v115165(VarCurr)
    <=> ( v84297(VarCurr,2)
        | v84297(VarCurr,3) ) ) ).

tff(addAssignment_68120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,5) )
     => ( v84297(VarCurr,B)
      <=> v89072(VarCurr,B) ) ) ).

tff(addAssignment_68119,axiom,
    ! [VarCurr: state_type] :
      ( v115141(VarCurr,1)
    <=> v115142(VarCurr,1) ) ).

tff(addAssignment_68118,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,0)
    <=> v115158(VarCurr) ) ).

tff(addAssignment_68117,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,1)
    <=> v115157(VarCurr) ) ).

tff(addAssignment_68116,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,2)
    <=> v115156(VarCurr) ) ).

tff(addAssignment_68115,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,3)
    <=> v115155(VarCurr) ) ).

tff(addAssignment_68114,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,4)
    <=> v115154(VarCurr) ) ).

tff(addAssignment_68113,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,5)
    <=> v115153(VarCurr) ) ).

tff(addAssignment_68112,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,6)
    <=> v115152(VarCurr) ) ).

tff(addAssignment_68111,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,7)
    <=> v115151(VarCurr) ) ).

tff(addAssignment_68110,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,8)
    <=> v115150(VarCurr) ) ).

tff(addAssignment_68109,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,9)
    <=> v115149(VarCurr) ) ).

tff(addAssignment_68108,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,10)
    <=> v115148(VarCurr) ) ).

tff(addAssignment_68107,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,11)
    <=> v115147(VarCurr) ) ).

tff(addAssignment_68106,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,12)
    <=> v115146(VarCurr) ) ).

tff(addAssignment_68105,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,13)
    <=> v115145(VarCurr) ) ).

tff(addAssignment_68104,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,14)
    <=> v115144(VarCurr) ) ).

tff(addAssignment_68103,axiom,
    ! [VarCurr: state_type] :
      ( v115142(VarCurr,15)
    <=> v115143(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1144,axiom,
    ! [VarCurr: state_type] :
      ( v115158(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1143,axiom,
    ! [VarCurr: state_type] :
      ( v115157(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1142,axiom,
    ! [VarCurr: state_type] :
      ( v115156(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1141,axiom,
    ! [VarCurr: state_type] :
      ( v115155(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1140,axiom,
    ! [VarCurr: state_type] :
      ( v115154(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1139,axiom,
    ! [VarCurr: state_type] :
      ( v115153(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1138,axiom,
    ! [VarCurr: state_type] :
      ( v115152(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1137,axiom,
    ! [VarCurr: state_type] :
      ( v115151(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $false )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1136,axiom,
    ! [VarCurr: state_type] :
      ( v115150(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1135,axiom,
    ! [VarCurr: state_type] :
      ( v115149(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1134,axiom,
    ! [VarCurr: state_type] :
      ( v115148(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1133,axiom,
    ! [VarCurr: state_type] :
      ( v115147(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $false )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1132,axiom,
    ! [VarCurr: state_type] :
      ( v115146(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1131,axiom,
    ! [VarCurr: state_type] :
      ( v115145(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $false )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1130,axiom,
    ! [VarCurr: state_type] :
      ( v115144(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1129,axiom,
    ! [VarCurr: state_type] :
      ( v115143(VarCurr)
    <=> ( ( v88372(VarCurr,3)
        <=> $true )
        & ( v88372(VarCurr,2)
        <=> $true )
        & ( v88372(VarCurr,1)
        <=> $true )
        & ( v88372(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_68102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114521(VarCurr,B)
      <=> v114523(VarCurr,B) ) ) ).

tff(addAssignment_68101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114523(VarCurr,B)
      <=> v114525(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115120(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v114525(VarNext,B)
            <=> v114525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1497,axiom,
    ! [VarNext: state_type] :
      ( v115120(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v114525(VarNext,B)
          <=> v115130(VarNext,B) ) ) ) ).

tff(addAssignment_68100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115130(VarNext,B)
          <=> v115128(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115131(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115128(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1023,axiom,
    ! [VarCurr: state_type] :
      ( v115131(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v115128(VarCurr,B)
          <=> v114535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12338,axiom,
    ! [VarCurr: state_type] :
      ( v115131(VarCurr)
    <=> ( v115132(VarCurr)
        & v115133(VarCurr) ) ) ).

tff(writeUnaryOperator_6645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115133(VarCurr)
    <=> v114531(VarCurr) ) ).

tff(writeUnaryOperator_6644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115132(VarCurr)
    <=> v114527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115120(VarNext)
      <=> v115121(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115121(VarNext)
      <=> ( v115122(VarNext)
          & v115113(VarNext) ) ) ) ).

tff(writeUnaryOperator_6643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v115122(VarNext)
      <=> v115124(VarNext) ) ) ).

tff(addAssignment_68099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v115124(VarNext)
      <=> v115113(VarCurr) ) ) ).

tff(addAssignment_68098,axiom,
    ! [VarCurr: state_type] :
      ( v115113(VarCurr)
    <=> v115115(VarCurr) ) ).

tff(addAssignment_68097,axiom,
    ! [VarCurr: state_type] :
      ( v115115(VarCurr)
    <=> v115117(VarCurr) ) ).

tff(addAssignment_68096,axiom,
    ! [VarCurr: state_type] :
      ( v115117(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_68095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114535(VarCurr,B)
      <=> v114537(VarCurr,B) ) ) ).

tff(addAssignment_68094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114537(VarCurr,B)
      <=> v114539(VarCurr,B) ) ) ).

tff(addAssignment_68093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114539(VarCurr,B)
      <=> v114541(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v114541(VarCurr,B)
      <=> ( v114940(VarCurr,B)
          & v114943(VarCurr,B) ) ) ) ).

tff(addAssignment_68092,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,0)
    <=> v115108(VarCurr) ) ).

tff(addAssignment_68091,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,1)
    <=> v115103(VarCurr) ) ).

tff(addAssignment_68090,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,2)
    <=> v115098(VarCurr) ) ).

tff(addAssignment_68089,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,3)
    <=> v115093(VarCurr) ) ).

tff(addAssignment_68088,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,4)
    <=> v115088(VarCurr) ) ).

tff(addAssignment_68087,axiom,
    ! [VarCurr: state_type] :
      ( v114943(VarCurr,5)
    <=> v114945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12335,axiom,
    ! [VarCurr: state_type] :
      ( v115108(VarCurr)
    <=> ( v115109(VarCurr)
        & v115111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12334,axiom,
    ! [VarCurr: state_type] :
      ( v115111(VarCurr)
    <=> ( v114896(VarCurr,0)
        | v114957(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12333,axiom,
    ! [VarCurr: state_type] :
      ( v115109(VarCurr)
    <=> ( v115034(VarCurr)
        | v115110(VarCurr) ) ) ).

tff(writeUnaryOperator_6642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115110(VarCurr)
    <=> v114957(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12332,axiom,
    ! [VarCurr: state_type] :
      ( v115103(VarCurr)
    <=> ( v115104(VarCurr)
        & v115107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12331,axiom,
    ! [VarCurr: state_type] :
      ( v115107(VarCurr)
    <=> ( v114956(VarCurr)
        | v115028(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12330,axiom,
    ! [VarCurr: state_type] :
      ( v115104(VarCurr)
    <=> ( v115105(VarCurr)
        | v115106(VarCurr) ) ) ).

tff(writeUnaryOperator_6641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115106(VarCurr)
    <=> v115028(VarCurr) ) ).

tff(writeUnaryOperator_6640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115105(VarCurr)
    <=> v114956(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12329,axiom,
    ! [VarCurr: state_type] :
      ( v115098(VarCurr)
    <=> ( v115099(VarCurr)
        & v115102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12328,axiom,
    ! [VarCurr: state_type] :
      ( v115102(VarCurr)
    <=> ( v114954(VarCurr)
        | v115039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12327,axiom,
    ! [VarCurr: state_type] :
      ( v115099(VarCurr)
    <=> ( v115100(VarCurr)
        | v115101(VarCurr) ) ) ).

tff(writeUnaryOperator_6639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115101(VarCurr)
    <=> v115039(VarCurr) ) ).

tff(writeUnaryOperator_6638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115100(VarCurr)
    <=> v114954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12326,axiom,
    ! [VarCurr: state_type] :
      ( v115093(VarCurr)
    <=> ( v115094(VarCurr)
        & v115097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12325,axiom,
    ! [VarCurr: state_type] :
      ( v115097(VarCurr)
    <=> ( v114952(VarCurr)
        | v115051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12324,axiom,
    ! [VarCurr: state_type] :
      ( v115094(VarCurr)
    <=> ( v115095(VarCurr)
        | v115096(VarCurr) ) ) ).

tff(writeUnaryOperator_6637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115096(VarCurr)
    <=> v115051(VarCurr) ) ).

tff(writeUnaryOperator_6636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115095(VarCurr)
    <=> v114952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12323,axiom,
    ! [VarCurr: state_type] :
      ( v115088(VarCurr)
    <=> ( v115089(VarCurr)
        & v115092(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12322,axiom,
    ! [VarCurr: state_type] :
      ( v115092(VarCurr)
    <=> ( v114950(VarCurr)
        | v115063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12321,axiom,
    ! [VarCurr: state_type] :
      ( v115089(VarCurr)
    <=> ( v115090(VarCurr)
        | v115091(VarCurr) ) ) ).

tff(writeUnaryOperator_6635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115091(VarCurr)
    <=> v115063(VarCurr) ) ).

tff(writeUnaryOperator_6634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115090(VarCurr)
    <=> v114950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12320,axiom,
    ! [VarCurr: state_type] :
      ( v114945(VarCurr)
    <=> ( v114946(VarCurr)
        & v115087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12319,axiom,
    ! [VarCurr: state_type] :
      ( v115087(VarCurr)
    <=> ( v114948(VarCurr)
        | v115076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12318,axiom,
    ! [VarCurr: state_type] :
      ( v114946(VarCurr)
    <=> ( v114947(VarCurr)
        | v115075(VarCurr) ) ) ).

tff(writeUnaryOperator_6633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115075(VarCurr)
    <=> v115076(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12317,axiom,
    ! [VarCurr: state_type] :
      ( v115076(VarCurr)
    <=> ( v115077(VarCurr)
        & v115086(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4891,axiom,
    ! [VarCurr: state_type] :
      ( v115086(VarCurr)
    <=> ( v115079(VarCurr)
        | v114957(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12316,axiom,
    ! [VarCurr: state_type] :
      ( v115077(VarCurr)
    <=> ( v115078(VarCurr)
        | v115085(VarCurr) ) ) ).

tff(writeUnaryOperator_6632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115085(VarCurr)
    <=> v114957(VarCurr,5) ) ).

tff(writeUnaryOperator_6631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115078(VarCurr)
    <=> v115079(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12315,axiom,
    ! [VarCurr: state_type] :
      ( v115079(VarCurr)
    <=> ( v115080(VarCurr)
        & v115083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12314,axiom,
    ! [VarCurr: state_type] :
      ( v115083(VarCurr)
    <=> ( v115082(VarCurr)
        | v115084(VarCurr) ) ) ).

tff(writeUnaryOperator_6630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115084(VarCurr)
    <=> v114896(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4890,axiom,
    ! [VarCurr: state_type] :
      ( v115080(VarCurr)
    <=> ( v115081(VarCurr)
        | v114896(VarCurr,5) ) ) ).

tff(writeUnaryOperator_6629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115081(VarCurr)
    <=> v115082(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12313,axiom,
    ! [VarCurr: state_type] :
      ( v115082(VarCurr)
    <=> ( v115069(VarCurr)
        & v115071(VarCurr) ) ) ).

tff(writeUnaryOperator_6628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114947(VarCurr)
    <=> v114948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12312,axiom,
    ! [VarCurr: state_type] :
      ( v114948(VarCurr)
    <=> ( v114949(VarCurr)
        | v115074(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4889,axiom,
    ! [VarCurr: state_type] :
      ( v115074(VarCurr)
    <=> ( v115066(VarCurr)
        & v114957(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12311,axiom,
    ! [VarCurr: state_type] :
      ( v114949(VarCurr)
    <=> ( v114950(VarCurr)
        & v115063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12310,axiom,
    ! [VarCurr: state_type] :
      ( v115063(VarCurr)
    <=> ( v115064(VarCurr)
        & v115073(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4888,axiom,
    ! [VarCurr: state_type] :
      ( v115073(VarCurr)
    <=> ( v115066(VarCurr)
        | v114957(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12309,axiom,
    ! [VarCurr: state_type] :
      ( v115064(VarCurr)
    <=> ( v115065(VarCurr)
        | v115072(VarCurr) ) ) ).

tff(writeUnaryOperator_6627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115072(VarCurr)
    <=> v114957(VarCurr,4) ) ).

tff(writeUnaryOperator_6626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115065(VarCurr)
    <=> v115066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12308,axiom,
    ! [VarCurr: state_type] :
      ( v115066(VarCurr)
    <=> ( v115067(VarCurr)
        & v115070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12307,axiom,
    ! [VarCurr: state_type] :
      ( v115070(VarCurr)
    <=> ( v115069(VarCurr)
        | v115071(VarCurr) ) ) ).

tff(writeUnaryOperator_6625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115071(VarCurr)
    <=> v114896(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4887,axiom,
    ! [VarCurr: state_type] :
      ( v115067(VarCurr)
    <=> ( v115068(VarCurr)
        | v114896(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115068(VarCurr)
    <=> v115069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12306,axiom,
    ! [VarCurr: state_type] :
      ( v115069(VarCurr)
    <=> ( v115057(VarCurr)
        & v115059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12305,axiom,
    ! [VarCurr: state_type] :
      ( v114950(VarCurr)
    <=> ( v114951(VarCurr)
        | v115062(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4886,axiom,
    ! [VarCurr: state_type] :
      ( v115062(VarCurr)
    <=> ( v115054(VarCurr)
        & v114957(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12304,axiom,
    ! [VarCurr: state_type] :
      ( v114951(VarCurr)
    <=> ( v114952(VarCurr)
        & v115051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12303,axiom,
    ! [VarCurr: state_type] :
      ( v115051(VarCurr)
    <=> ( v115052(VarCurr)
        & v115061(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4885,axiom,
    ! [VarCurr: state_type] :
      ( v115061(VarCurr)
    <=> ( v115054(VarCurr)
        | v114957(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12302,axiom,
    ! [VarCurr: state_type] :
      ( v115052(VarCurr)
    <=> ( v115053(VarCurr)
        | v115060(VarCurr) ) ) ).

tff(writeUnaryOperator_6623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115060(VarCurr)
    <=> v114957(VarCurr,3) ) ).

tff(writeUnaryOperator_6622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115053(VarCurr)
    <=> v115054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12301,axiom,
    ! [VarCurr: state_type] :
      ( v115054(VarCurr)
    <=> ( v115055(VarCurr)
        & v115058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12300,axiom,
    ! [VarCurr: state_type] :
      ( v115058(VarCurr)
    <=> ( v115057(VarCurr)
        | v115059(VarCurr) ) ) ).

tff(writeUnaryOperator_6621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115059(VarCurr)
    <=> v114896(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4884,axiom,
    ! [VarCurr: state_type] :
      ( v115055(VarCurr)
    <=> ( v115056(VarCurr)
        | v114896(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115056(VarCurr)
    <=> v115057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12299,axiom,
    ! [VarCurr: state_type] :
      ( v115057(VarCurr)
    <=> ( v115045(VarCurr)
        & v115047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12298,axiom,
    ! [VarCurr: state_type] :
      ( v114952(VarCurr)
    <=> ( v114953(VarCurr)
        | v115050(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4883,axiom,
    ! [VarCurr: state_type] :
      ( v115050(VarCurr)
    <=> ( v115042(VarCurr)
        & v114957(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12297,axiom,
    ! [VarCurr: state_type] :
      ( v114953(VarCurr)
    <=> ( v114954(VarCurr)
        & v115039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12296,axiom,
    ! [VarCurr: state_type] :
      ( v115039(VarCurr)
    <=> ( v115040(VarCurr)
        & v115049(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4882,axiom,
    ! [VarCurr: state_type] :
      ( v115049(VarCurr)
    <=> ( v115042(VarCurr)
        | v114957(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12295,axiom,
    ! [VarCurr: state_type] :
      ( v115040(VarCurr)
    <=> ( v115041(VarCurr)
        | v115048(VarCurr) ) ) ).

tff(writeUnaryOperator_6619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115048(VarCurr)
    <=> v114957(VarCurr,2) ) ).

tff(writeUnaryOperator_6618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115041(VarCurr)
    <=> v115042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12294,axiom,
    ! [VarCurr: state_type] :
      ( v115042(VarCurr)
    <=> ( v115043(VarCurr)
        & v115046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12293,axiom,
    ! [VarCurr: state_type] :
      ( v115046(VarCurr)
    <=> ( v115045(VarCurr)
        | v115047(VarCurr) ) ) ).

tff(writeUnaryOperator_6617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115047(VarCurr)
    <=> v114896(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4881,axiom,
    ! [VarCurr: state_type] :
      ( v115043(VarCurr)
    <=> ( v115044(VarCurr)
        | v114896(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115044(VarCurr)
    <=> v115045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12292,axiom,
    ! [VarCurr: state_type] :
      ( v115045(VarCurr)
    <=> ( v115034(VarCurr)
        & v115035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12291,axiom,
    ! [VarCurr: state_type] :
      ( v114954(VarCurr)
    <=> ( v114955(VarCurr)
        | v115038(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4880,axiom,
    ! [VarCurr: state_type] :
      ( v115038(VarCurr)
    <=> ( v115031(VarCurr)
        & v114957(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12290,axiom,
    ! [VarCurr: state_type] :
      ( v114955(VarCurr)
    <=> ( v114956(VarCurr)
        & v115028(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12289,axiom,
    ! [VarCurr: state_type] :
      ( v115028(VarCurr)
    <=> ( v115029(VarCurr)
        & v115037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4879,axiom,
    ! [VarCurr: state_type] :
      ( v115037(VarCurr)
    <=> ( v115031(VarCurr)
        | v114957(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12288,axiom,
    ! [VarCurr: state_type] :
      ( v115029(VarCurr)
    <=> ( v115030(VarCurr)
        | v115036(VarCurr) ) ) ).

tff(writeUnaryOperator_6615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115036(VarCurr)
    <=> v114957(VarCurr,1) ) ).

tff(writeUnaryOperator_6614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115030(VarCurr)
    <=> v115031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12287,axiom,
    ! [VarCurr: state_type] :
      ( v115031(VarCurr)
    <=> ( v115032(VarCurr)
        & v115033(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12286,axiom,
    ! [VarCurr: state_type] :
      ( v115033(VarCurr)
    <=> ( v115034(VarCurr)
        | v115035(VarCurr) ) ) ).

tff(writeUnaryOperator_6613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115035(VarCurr)
    <=> v114896(VarCurr,1) ) ).

tff(writeUnaryOperator_6612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115034(VarCurr)
    <=> v114896(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_4878,axiom,
    ! [VarCurr: state_type] :
      ( v115032(VarCurr)
    <=> ( v114896(VarCurr,0)
        | v114896(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12285,axiom,
    ! [VarCurr: state_type] :
      ( v114956(VarCurr)
    <=> ( v114896(VarCurr,0)
        & v114957(VarCurr,0) ) ) ).

tff(addAssignment_68086,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,0)
    <=> v115023(VarCurr) ) ).

tff(addAssignment_68085,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,1)
    <=> v115018(VarCurr) ) ).

tff(addAssignment_68084,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,2)
    <=> v115013(VarCurr) ) ).

tff(addAssignment_68083,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,3)
    <=> v115008(VarCurr) ) ).

tff(addAssignment_68082,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,4)
    <=> v115003(VarCurr) ) ).

tff(addAssignment_68081,axiom,
    ! [VarCurr: state_type] :
      ( v114957(VarCurr,5)
    <=> v114959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12284,axiom,
    ! [VarCurr: state_type] :
      ( v115023(VarCurr)
    <=> ( v115024(VarCurr)
        & v115027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12283,axiom,
    ! [VarCurr: state_type] :
      ( v115027(VarCurr)
    <=> ( v114521(VarCurr,0)
        | v114971(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12282,axiom,
    ! [VarCurr: state_type] :
      ( v115024(VarCurr)
    <=> ( v115025(VarCurr)
        | v115026(VarCurr) ) ) ).

tff(writeUnaryOperator_6611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115026(VarCurr)
    <=> v114971(VarCurr,0) ) ).

tff(writeUnaryOperator_6610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115025(VarCurr)
    <=> v114521(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12281,axiom,
    ! [VarCurr: state_type] :
      ( v115018(VarCurr)
    <=> ( v115019(VarCurr)
        & v115022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12280,axiom,
    ! [VarCurr: state_type] :
      ( v115022(VarCurr)
    <=> ( v114970(VarCurr)
        | v114972(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12279,axiom,
    ! [VarCurr: state_type] :
      ( v115019(VarCurr)
    <=> ( v115020(VarCurr)
        | v115021(VarCurr) ) ) ).

tff(writeUnaryOperator_6609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115021(VarCurr)
    <=> v114972(VarCurr) ) ).

tff(writeUnaryOperator_6608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115020(VarCurr)
    <=> v114970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12278,axiom,
    ! [VarCurr: state_type] :
      ( v115013(VarCurr)
    <=> ( v115014(VarCurr)
        & v115017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12277,axiom,
    ! [VarCurr: state_type] :
      ( v115017(VarCurr)
    <=> ( v114968(VarCurr)
        | v114978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12276,axiom,
    ! [VarCurr: state_type] :
      ( v115014(VarCurr)
    <=> ( v115015(VarCurr)
        | v115016(VarCurr) ) ) ).

tff(writeUnaryOperator_6607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115016(VarCurr)
    <=> v114978(VarCurr) ) ).

tff(writeUnaryOperator_6606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115015(VarCurr)
    <=> v114968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12275,axiom,
    ! [VarCurr: state_type] :
      ( v115008(VarCurr)
    <=> ( v115009(VarCurr)
        & v115012(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12274,axiom,
    ! [VarCurr: state_type] :
      ( v115012(VarCurr)
    <=> ( v114966(VarCurr)
        | v114984(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12273,axiom,
    ! [VarCurr: state_type] :
      ( v115009(VarCurr)
    <=> ( v115010(VarCurr)
        | v115011(VarCurr) ) ) ).

tff(writeUnaryOperator_6605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115011(VarCurr)
    <=> v114984(VarCurr) ) ).

tff(writeUnaryOperator_6604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115010(VarCurr)
    <=> v114966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12272,axiom,
    ! [VarCurr: state_type] :
      ( v115003(VarCurr)
    <=> ( v115004(VarCurr)
        & v115007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12271,axiom,
    ! [VarCurr: state_type] :
      ( v115007(VarCurr)
    <=> ( v114964(VarCurr)
        | v114990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12270,axiom,
    ! [VarCurr: state_type] :
      ( v115004(VarCurr)
    <=> ( v115005(VarCurr)
        | v115006(VarCurr) ) ) ).

tff(writeUnaryOperator_6603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115006(VarCurr)
    <=> v114990(VarCurr) ) ).

tff(writeUnaryOperator_6602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115005(VarCurr)
    <=> v114964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12269,axiom,
    ! [VarCurr: state_type] :
      ( v114959(VarCurr)
    <=> ( v114960(VarCurr)
        & v115002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12268,axiom,
    ! [VarCurr: state_type] :
      ( v115002(VarCurr)
    <=> ( v114962(VarCurr)
        | v114997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12267,axiom,
    ! [VarCurr: state_type] :
      ( v114960(VarCurr)
    <=> ( v114961(VarCurr)
        | v114996(VarCurr) ) ) ).

tff(writeUnaryOperator_6601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114996(VarCurr)
    <=> v114997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12266,axiom,
    ! [VarCurr: state_type] :
      ( v114997(VarCurr)
    <=> ( v114998(VarCurr)
        & v115001(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4877,axiom,
    ! [VarCurr: state_type] :
      ( v115001(VarCurr)
    <=> ( v114521(VarCurr,5)
        | v114971(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12265,axiom,
    ! [VarCurr: state_type] :
      ( v114998(VarCurr)
    <=> ( v114999(VarCurr)
        | v115000(VarCurr) ) ) ).

tff(writeUnaryOperator_6600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v115000(VarCurr)
    <=> v114971(VarCurr,5) ) ).

tff(writeUnaryOperator_6599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114999(VarCurr)
    <=> v114521(VarCurr,5) ) ).

tff(writeUnaryOperator_6598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114961(VarCurr)
    <=> v114962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12264,axiom,
    ! [VarCurr: state_type] :
      ( v114962(VarCurr)
    <=> ( v114963(VarCurr)
        | v114995(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4876,axiom,
    ! [VarCurr: state_type] :
      ( v114995(VarCurr)
    <=> ( v114521(VarCurr,4)
        & v114971(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12263,axiom,
    ! [VarCurr: state_type] :
      ( v114963(VarCurr)
    <=> ( v114964(VarCurr)
        & v114990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12262,axiom,
    ! [VarCurr: state_type] :
      ( v114990(VarCurr)
    <=> ( v114991(VarCurr)
        & v114994(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4875,axiom,
    ! [VarCurr: state_type] :
      ( v114994(VarCurr)
    <=> ( v114521(VarCurr,4)
        | v114971(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12261,axiom,
    ! [VarCurr: state_type] :
      ( v114991(VarCurr)
    <=> ( v114992(VarCurr)
        | v114993(VarCurr) ) ) ).

tff(writeUnaryOperator_6597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114993(VarCurr)
    <=> v114971(VarCurr,4) ) ).

tff(writeUnaryOperator_6596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114992(VarCurr)
    <=> v114521(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12260,axiom,
    ! [VarCurr: state_type] :
      ( v114964(VarCurr)
    <=> ( v114965(VarCurr)
        | v114989(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4874,axiom,
    ! [VarCurr: state_type] :
      ( v114989(VarCurr)
    <=> ( v114521(VarCurr,3)
        & v114971(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12259,axiom,
    ! [VarCurr: state_type] :
      ( v114965(VarCurr)
    <=> ( v114966(VarCurr)
        & v114984(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12258,axiom,
    ! [VarCurr: state_type] :
      ( v114984(VarCurr)
    <=> ( v114985(VarCurr)
        & v114988(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4873,axiom,
    ! [VarCurr: state_type] :
      ( v114988(VarCurr)
    <=> ( v114521(VarCurr,3)
        | v114971(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12257,axiom,
    ! [VarCurr: state_type] :
      ( v114985(VarCurr)
    <=> ( v114986(VarCurr)
        | v114987(VarCurr) ) ) ).

tff(writeUnaryOperator_6595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114987(VarCurr)
    <=> v114971(VarCurr,3) ) ).

tff(writeUnaryOperator_6594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114986(VarCurr)
    <=> v114521(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12256,axiom,
    ! [VarCurr: state_type] :
      ( v114966(VarCurr)
    <=> ( v114967(VarCurr)
        | v114983(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4872,axiom,
    ! [VarCurr: state_type] :
      ( v114983(VarCurr)
    <=> ( v114521(VarCurr,2)
        & v114971(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12255,axiom,
    ! [VarCurr: state_type] :
      ( v114967(VarCurr)
    <=> ( v114968(VarCurr)
        & v114978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12254,axiom,
    ! [VarCurr: state_type] :
      ( v114978(VarCurr)
    <=> ( v114979(VarCurr)
        & v114982(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4871,axiom,
    ! [VarCurr: state_type] :
      ( v114982(VarCurr)
    <=> ( v114521(VarCurr,2)
        | v114971(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12253,axiom,
    ! [VarCurr: state_type] :
      ( v114979(VarCurr)
    <=> ( v114980(VarCurr)
        | v114981(VarCurr) ) ) ).

tff(writeUnaryOperator_6593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114981(VarCurr)
    <=> v114971(VarCurr,2) ) ).

tff(writeUnaryOperator_6592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114980(VarCurr)
    <=> v114521(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12252,axiom,
    ! [VarCurr: state_type] :
      ( v114968(VarCurr)
    <=> ( v114969(VarCurr)
        | v114977(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4870,axiom,
    ! [VarCurr: state_type] :
      ( v114977(VarCurr)
    <=> ( v114521(VarCurr,1)
        & v114971(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12251,axiom,
    ! [VarCurr: state_type] :
      ( v114969(VarCurr)
    <=> ( v114970(VarCurr)
        & v114972(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12250,axiom,
    ! [VarCurr: state_type] :
      ( v114972(VarCurr)
    <=> ( v114973(VarCurr)
        & v114976(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4869,axiom,
    ! [VarCurr: state_type] :
      ( v114976(VarCurr)
    <=> ( v114521(VarCurr,1)
        | v114971(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12249,axiom,
    ! [VarCurr: state_type] :
      ( v114973(VarCurr)
    <=> ( v114974(VarCurr)
        | v114975(VarCurr) ) ) ).

tff(writeUnaryOperator_6591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114975(VarCurr)
    <=> v114971(VarCurr,1) ) ).

tff(writeUnaryOperator_6590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114974(VarCurr)
    <=> v114521(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12248,axiom,
    ! [VarCurr: state_type] :
      ( v114970(VarCurr)
    <=> ( v114521(VarCurr,0)
        & v114971(VarCurr,0) ) ) ).

tff(addAssignment_68080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114971(VarCurr,B)
      <=> v114545(VarCurr,B) ) ) ).

tff(addAssignment_68079,axiom,
    ! [VarCurr: state_type] :
      ( ( v114971(VarCurr,5)
      <=> $false )
      & ( v114971(VarCurr,4)
      <=> $false )
      & ( v114971(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_68078,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,0)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68077,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,1)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68076,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,2)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68075,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,3)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68074,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,4)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68073,axiom,
    ! [VarCurr: state_type] :
      ( v114940(VarCurr,5)
    <=> v114941(VarCurr) ) ).

tff(addAssignment_68072,axiom,
    ! [VarCurr: state_type] :
      ( v114941(VarCurr)
    <=> v114942(VarCurr) ) ).

tff(writeUnaryOperator_6589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114942(VarCurr)
    <=> v114543(VarCurr) ) ).

tff(addAssignment_68071,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,5)
    <=> v114933(VarCurr,5) ) ).

tff(addAssignment_68070,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,4)
    <=> v114933(VarCurr,4) ) ).

tff(addAssignment_68069,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,3)
    <=> v114933(VarCurr,3) ) ).

tff(addAssignment_68068,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,2)
    <=> v114933(VarCurr,2) ) ).

tff(addAssignment_68067,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,1)
    <=> v114933(VarCurr,1) ) ).

tff(addAssignment_68066,axiom,
    ! [VarCurr: state_type] :
      ( v114896(VarCurr,0)
    <=> v114933(VarCurr,0) ) ).

tff(addAssignment_68065,axiom,
    ! [VarCurr: state_type] :
      ( v114933(VarCurr,0)
    <=> v114934(VarCurr) ) ).

tff(addAssignment_68064,axiom,
    ! [VarCurr: state_type] :
      ( ( v114933(VarCurr,5)
      <=> $false )
      & ( v114933(VarCurr,4)
      <=> $false )
      & ( v114933(VarCurr,3)
      <=> $false )
      & ( v114933(VarCurr,2)
      <=> $false )
      & ( v114933(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12247,axiom,
    ! [VarCurr: state_type] :
      ( v114934(VarCurr)
    <=> ( v114935(VarCurr)
        | v114932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12246,axiom,
    ! [VarCurr: state_type] :
      ( v114935(VarCurr)
    <=> ( v114936(VarCurr)
        | v114930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12245,axiom,
    ! [VarCurr: state_type] :
      ( v114936(VarCurr)
    <=> ( v114937(VarCurr)
        | v114928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12244,axiom,
    ! [VarCurr: state_type] :
      ( v114937(VarCurr)
    <=> ( v114938(VarCurr)
        | v114918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12243,axiom,
    ! [VarCurr: state_type] :
      ( v114938(VarCurr)
    <=> ( v114898(VarCurr)
        | v114908(VarCurr) ) ) ).

tff(addAssignment_68063,axiom,
    ! [VarCurr: state_type] :
      ( v114932(VarCurr)
    <=> v113911(VarCurr,1) ) ).

tff(addAssignment_68062,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,1)
    <=> v113913(VarCurr,1) ) ).

tff(addAssignment_68061,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,1)
    <=> v113915(VarCurr,1) ) ).

tff(addAssignment_68060,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,1)
    <=> v113935(VarCurr,1) ) ).

tff(addAssignment_68059,axiom,
    ! [VarCurr: state_type] :
      ( v114930(VarCurr)
    <=> v113107(VarCurr,1) ) ).

tff(addAssignment_68058,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,1)
    <=> v113143(VarCurr,1) ) ).

tff(addAssignment_68057,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,1)
    <=> v113110(VarCurr,1) ) ).

tff(addAssignment_68056,axiom,
    ! [VarCurr: state_type] :
      ( v114928(VarCurr)
    <=> v113100(VarCurr,1) ) ).

tff(addAssignment_68055,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,1)
    <=> v113101(VarCurr,1) ) ).

tff(addAssignment_68054,axiom,
    ! [VarCurr: state_type] :
      ( v114918(VarCurr)
    <=> v113810(VarCurr,1) ) ).

tff(addAssignment_68053,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,1)
    <=> v113812(VarCurr,1) ) ).

tff(addAssignment_68052,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,1)
    <=> v113814(VarCurr,1) ) ).

tff(addAssignment_68051,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,1)
    <=> v113816(VarCurr,1) ) ).

tff(addAssignment_68050,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,1)
    <=> v113818(VarCurr,1) ) ).

tff(addAssignment_68049,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,1)
    <=> v114920(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114921(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v114920(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1496,axiom,
    ! [VarNext: state_type] :
      ( v114921(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v114920(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114921(VarNext)
      <=> v114922(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114922(VarNext)
      <=> ( v114924(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_6588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114924(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_68048,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,1)
    <=> v113830(VarCurr,1) ) ).

tff(addAssignment_68047,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,1)
    <=> v113832(VarCurr,1) ) ).

tff(addAssignment_68046,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,1)
    <=> v113834(VarCurr,1) ) ).

tff(addAssignment_68045,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,1)
    <=> v113873(VarCurr,1) ) ).

tff(addAssignment_68044,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,1)
    <=> v113856(VarCurr,1) ) ).

tff(addAssignment_68043,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,1)
    <=> v113837(VarCurr,1) ) ).

tff(addAssignment_68042,axiom,
    ! [VarCurr: state_type] :
      ( v114908(VarCurr)
    <=> v113020(VarCurr,1) ) ).

tff(addAssignment_68041,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,1)
    <=> v113022(VarCurr,1) ) ).

tff(addAssignment_68040,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,1)
    <=> v113024(VarCurr,1) ) ).

tff(addAssignment_68039,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,1)
    <=> v113026(VarCurr,1) ) ).

tff(addAssignment_68038,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,1)
    <=> v113028(VarCurr,1) ) ).

tff(addAssignment_68037,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,1)
    <=> v114910(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114911(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v114910(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1495,axiom,
    ! [VarNext: state_type] :
      ( v114911(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v114910(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114911(VarNext)
      <=> v114912(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114912(VarNext)
      <=> ( v114914(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_6587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114914(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_68036,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,1)
    <=> v113040(VarCurr,1) ) ).

tff(addAssignment_68035,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,1)
    <=> v113042(VarCurr,1) ) ).

tff(addAssignment_68034,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,1)
    <=> v113044(VarCurr,1) ) ).

tff(addAssignment_68033,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,1)
    <=> v113045(VarCurr,1) ) ).

tff(addAssignment_68032,axiom,
    ! [VarCurr: state_type] :
      ( v114898(VarCurr)
    <=> v112940(VarCurr,1) ) ).

tff(addAssignment_68031,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,1)
    <=> v112942(VarCurr,1) ) ).

tff(addAssignment_68030,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,1)
    <=> v112944(VarCurr,1) ) ).

tff(addAssignment_68029,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,1)
    <=> v112946(VarCurr,1) ) ).

tff(addAssignment_68028,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,1)
    <=> v112948(VarCurr,1) ) ).

tff(addAssignment_68027,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,1)
    <=> v114900(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114901(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v114900(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1494,axiom,
    ! [VarNext: state_type] :
      ( v114901(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v114900(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114901(VarNext)
      <=> v114902(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114902(VarNext)
      <=> ( v114904(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_6586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114904(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_68026,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,1)
    <=> v112960(VarCurr,1) ) ).

tff(addAssignment_68025,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,1)
    <=> v112962(VarCurr,1) ) ).

tff(addAssignment_68024,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,1)
    <=> v112964(VarCurr,1) ) ).

tff(addAssignment_68023,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,1)
    <=> v112965(VarCurr,1) ) ).

tff(addAssignment_68022,axiom,
    ! [VarCurr: state_type] :
      ( v114545(VarCurr,2)
    <=> v114702(VarCurr,2) ) ).

tff(addAssignment_68021,axiom,
    ! [VarCurr: state_type] :
      ( v114545(VarCurr,1)
    <=> v114702(VarCurr,1) ) ).

tff(addAssignment_68020,axiom,
    ! [VarCurr: state_type] :
      ( v114545(VarCurr,0)
    <=> v114702(VarCurr,0) ) ).

tff(addAssignment_68019,axiom,
    ! [VarCurr: state_type] :
      ( v114702(VarCurr,0)
    <=> v114890(VarCurr) ) ).

tff(addAssignment_68018,axiom,
    ! [VarCurr: state_type] :
      ( v114702(VarCurr,1)
    <=> v114885(VarCurr) ) ).

tff(addAssignment_68017,axiom,
    ! [VarCurr: state_type] :
      ( v114702(VarCurr,2)
    <=> v114704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12236,axiom,
    ! [VarCurr: state_type] :
      ( v114890(VarCurr)
    <=> ( v114891(VarCurr)
        & v114894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12235,axiom,
    ! [VarCurr: state_type] :
      ( v114894(VarCurr)
    <=> ( v114710(VarCurr,0)
        | v114871(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12234,axiom,
    ! [VarCurr: state_type] :
      ( v114891(VarCurr)
    <=> ( v114892(VarCurr)
        | v114893(VarCurr) ) ) ).

tff(writeUnaryOperator_6585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114893(VarCurr)
    <=> v114871(VarCurr,0) ) ).

tff(writeUnaryOperator_6584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114892(VarCurr)
    <=> v114710(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12233,axiom,
    ! [VarCurr: state_type] :
      ( v114885(VarCurr)
    <=> ( v114886(VarCurr)
        & v114889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12232,axiom,
    ! [VarCurr: state_type] :
      ( v114889(VarCurr)
    <=> ( v114709(VarCurr)
        | v114872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12231,axiom,
    ! [VarCurr: state_type] :
      ( v114886(VarCurr)
    <=> ( v114887(VarCurr)
        | v114888(VarCurr) ) ) ).

tff(writeUnaryOperator_6583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114888(VarCurr)
    <=> v114872(VarCurr) ) ).

tff(writeUnaryOperator_6582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114887(VarCurr)
    <=> v114709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12230,axiom,
    ! [VarCurr: state_type] :
      ( v114704(VarCurr)
    <=> ( v114705(VarCurr)
        & v114884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12229,axiom,
    ! [VarCurr: state_type] :
      ( v114884(VarCurr)
    <=> ( v114707(VarCurr)
        | v114879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12228,axiom,
    ! [VarCurr: state_type] :
      ( v114705(VarCurr)
    <=> ( v114706(VarCurr)
        | v114878(VarCurr) ) ) ).

tff(writeUnaryOperator_6581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114878(VarCurr)
    <=> v114879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12227,axiom,
    ! [VarCurr: state_type] :
      ( v114879(VarCurr)
    <=> ( v114880(VarCurr)
        & v114883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4868,axiom,
    ! [VarCurr: state_type] :
      ( v114883(VarCurr)
    <=> ( v114710(VarCurr,2)
        | v114871(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12226,axiom,
    ! [VarCurr: state_type] :
      ( v114880(VarCurr)
    <=> ( v114881(VarCurr)
        | v114882(VarCurr) ) ) ).

tff(writeUnaryOperator_6580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114882(VarCurr)
    <=> v114871(VarCurr,2) ) ).

tff(writeUnaryOperator_6579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114881(VarCurr)
    <=> v114710(VarCurr,2) ) ).

tff(writeUnaryOperator_6578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114706(VarCurr)
    <=> v114707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12225,axiom,
    ! [VarCurr: state_type] :
      ( v114707(VarCurr)
    <=> ( v114708(VarCurr)
        | v114877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4867,axiom,
    ! [VarCurr: state_type] :
      ( v114877(VarCurr)
    <=> ( v114710(VarCurr,1)
        & v114871(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12224,axiom,
    ! [VarCurr: state_type] :
      ( v114708(VarCurr)
    <=> ( v114709(VarCurr)
        & v114872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12223,axiom,
    ! [VarCurr: state_type] :
      ( v114872(VarCurr)
    <=> ( v114873(VarCurr)
        & v114876(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4866,axiom,
    ! [VarCurr: state_type] :
      ( v114876(VarCurr)
    <=> ( v114710(VarCurr,1)
        | v114871(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12222,axiom,
    ! [VarCurr: state_type] :
      ( v114873(VarCurr)
    <=> ( v114874(VarCurr)
        | v114875(VarCurr) ) ) ).

tff(writeUnaryOperator_6577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114875(VarCurr)
    <=> v114871(VarCurr,1) ) ).

tff(writeUnaryOperator_6576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114874(VarCurr)
    <=> v114710(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12221,axiom,
    ! [VarCurr: state_type] :
      ( v114709(VarCurr)
    <=> ( v114710(VarCurr,0)
        & v114871(VarCurr,0) ) ) ).

tff(addAssignment_68016,axiom,
    ! [VarCurr: state_type] :
      ( v114871(VarCurr,0)
    <=> v114690(VarCurr) ) ).

tff(addAssignment_68015,axiom,
    ! [VarCurr: state_type] :
      ( ( v114871(VarCurr,2)
      <=> $false )
      & ( v114871(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68014,axiom,
    ! [VarCurr: state_type] :
      ( v114710(VarCurr,0)
    <=> v114866(VarCurr) ) ).

tff(addAssignment_68013,axiom,
    ! [VarCurr: state_type] :
      ( v114710(VarCurr,1)
    <=> v114861(VarCurr) ) ).

tff(addAssignment_68012,axiom,
    ! [VarCurr: state_type] :
      ( v114710(VarCurr,2)
    <=> v114712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12220,axiom,
    ! [VarCurr: state_type] :
      ( v114866(VarCurr)
    <=> ( v114867(VarCurr)
        & v114870(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12219,axiom,
    ! [VarCurr: state_type] :
      ( v114870(VarCurr)
    <=> ( v114718(VarCurr,0)
        | v114847(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12218,axiom,
    ! [VarCurr: state_type] :
      ( v114867(VarCurr)
    <=> ( v114868(VarCurr)
        | v114869(VarCurr) ) ) ).

tff(writeUnaryOperator_6575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114869(VarCurr)
    <=> v114847(VarCurr,0) ) ).

tff(writeUnaryOperator_6574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114868(VarCurr)
    <=> v114718(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12217,axiom,
    ! [VarCurr: state_type] :
      ( v114861(VarCurr)
    <=> ( v114862(VarCurr)
        & v114865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12216,axiom,
    ! [VarCurr: state_type] :
      ( v114865(VarCurr)
    <=> ( v114717(VarCurr)
        | v114848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12215,axiom,
    ! [VarCurr: state_type] :
      ( v114862(VarCurr)
    <=> ( v114863(VarCurr)
        | v114864(VarCurr) ) ) ).

tff(writeUnaryOperator_6573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114864(VarCurr)
    <=> v114848(VarCurr) ) ).

tff(writeUnaryOperator_6572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114863(VarCurr)
    <=> v114717(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12214,axiom,
    ! [VarCurr: state_type] :
      ( v114712(VarCurr)
    <=> ( v114713(VarCurr)
        & v114860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12213,axiom,
    ! [VarCurr: state_type] :
      ( v114860(VarCurr)
    <=> ( v114715(VarCurr)
        | v114855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12212,axiom,
    ! [VarCurr: state_type] :
      ( v114713(VarCurr)
    <=> ( v114714(VarCurr)
        | v114854(VarCurr) ) ) ).

tff(writeUnaryOperator_6571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114854(VarCurr)
    <=> v114855(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12211,axiom,
    ! [VarCurr: state_type] :
      ( v114855(VarCurr)
    <=> ( v114856(VarCurr)
        & v114859(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4865,axiom,
    ! [VarCurr: state_type] :
      ( v114859(VarCurr)
    <=> ( v114718(VarCurr,2)
        | v114847(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12210,axiom,
    ! [VarCurr: state_type] :
      ( v114856(VarCurr)
    <=> ( v114857(VarCurr)
        | v114858(VarCurr) ) ) ).

tff(writeUnaryOperator_6570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114858(VarCurr)
    <=> v114847(VarCurr,2) ) ).

tff(writeUnaryOperator_6569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114857(VarCurr)
    <=> v114718(VarCurr,2) ) ).

tff(writeUnaryOperator_6568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114714(VarCurr)
    <=> v114715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12209,axiom,
    ! [VarCurr: state_type] :
      ( v114715(VarCurr)
    <=> ( v114716(VarCurr)
        | v114853(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4864,axiom,
    ! [VarCurr: state_type] :
      ( v114853(VarCurr)
    <=> ( v114718(VarCurr,1)
        & v114847(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12208,axiom,
    ! [VarCurr: state_type] :
      ( v114716(VarCurr)
    <=> ( v114717(VarCurr)
        & v114848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12207,axiom,
    ! [VarCurr: state_type] :
      ( v114848(VarCurr)
    <=> ( v114849(VarCurr)
        & v114852(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4863,axiom,
    ! [VarCurr: state_type] :
      ( v114852(VarCurr)
    <=> ( v114718(VarCurr,1)
        | v114847(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12206,axiom,
    ! [VarCurr: state_type] :
      ( v114849(VarCurr)
    <=> ( v114850(VarCurr)
        | v114851(VarCurr) ) ) ).

tff(writeUnaryOperator_6567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114851(VarCurr)
    <=> v114847(VarCurr,1) ) ).

tff(writeUnaryOperator_6566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114850(VarCurr)
    <=> v114718(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12205,axiom,
    ! [VarCurr: state_type] :
      ( v114717(VarCurr)
    <=> ( v114718(VarCurr,0)
        & v114847(VarCurr,0) ) ) ).

tff(addAssignment_68011,axiom,
    ! [VarCurr: state_type] :
      ( v114847(VarCurr,0)
    <=> v114683(VarCurr) ) ).

tff(addAssignment_68010,axiom,
    ! [VarCurr: state_type] :
      ( ( v114847(VarCurr,2)
      <=> $false )
      & ( v114847(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68009,axiom,
    ! [VarCurr: state_type] :
      ( v114718(VarCurr,0)
    <=> v114842(VarCurr) ) ).

tff(addAssignment_68008,axiom,
    ! [VarCurr: state_type] :
      ( v114718(VarCurr,1)
    <=> v114837(VarCurr) ) ).

tff(addAssignment_68007,axiom,
    ! [VarCurr: state_type] :
      ( v114718(VarCurr,2)
    <=> v114720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12204,axiom,
    ! [VarCurr: state_type] :
      ( v114842(VarCurr)
    <=> ( v114843(VarCurr)
        & v114846(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12203,axiom,
    ! [VarCurr: state_type] :
      ( v114846(VarCurr)
    <=> ( v114726(VarCurr,0)
        | v114823(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12202,axiom,
    ! [VarCurr: state_type] :
      ( v114843(VarCurr)
    <=> ( v114844(VarCurr)
        | v114845(VarCurr) ) ) ).

tff(writeUnaryOperator_6565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114845(VarCurr)
    <=> v114823(VarCurr,0) ) ).

tff(writeUnaryOperator_6564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114844(VarCurr)
    <=> v114726(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12201,axiom,
    ! [VarCurr: state_type] :
      ( v114837(VarCurr)
    <=> ( v114838(VarCurr)
        & v114841(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12200,axiom,
    ! [VarCurr: state_type] :
      ( v114841(VarCurr)
    <=> ( v114725(VarCurr)
        | v114824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12199,axiom,
    ! [VarCurr: state_type] :
      ( v114838(VarCurr)
    <=> ( v114839(VarCurr)
        | v114840(VarCurr) ) ) ).

tff(writeUnaryOperator_6563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114840(VarCurr)
    <=> v114824(VarCurr) ) ).

tff(writeUnaryOperator_6562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114839(VarCurr)
    <=> v114725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12198,axiom,
    ! [VarCurr: state_type] :
      ( v114720(VarCurr)
    <=> ( v114721(VarCurr)
        & v114836(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12197,axiom,
    ! [VarCurr: state_type] :
      ( v114836(VarCurr)
    <=> ( v114723(VarCurr)
        | v114831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12196,axiom,
    ! [VarCurr: state_type] :
      ( v114721(VarCurr)
    <=> ( v114722(VarCurr)
        | v114830(VarCurr) ) ) ).

tff(writeUnaryOperator_6561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114830(VarCurr)
    <=> v114831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12195,axiom,
    ! [VarCurr: state_type] :
      ( v114831(VarCurr)
    <=> ( v114832(VarCurr)
        & v114835(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4862,axiom,
    ! [VarCurr: state_type] :
      ( v114835(VarCurr)
    <=> ( v114726(VarCurr,2)
        | v114823(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12194,axiom,
    ! [VarCurr: state_type] :
      ( v114832(VarCurr)
    <=> ( v114833(VarCurr)
        | v114834(VarCurr) ) ) ).

tff(writeUnaryOperator_6560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114834(VarCurr)
    <=> v114823(VarCurr,2) ) ).

tff(writeUnaryOperator_6559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114833(VarCurr)
    <=> v114726(VarCurr,2) ) ).

tff(writeUnaryOperator_6558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114722(VarCurr)
    <=> v114723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12193,axiom,
    ! [VarCurr: state_type] :
      ( v114723(VarCurr)
    <=> ( v114724(VarCurr)
        | v114829(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4861,axiom,
    ! [VarCurr: state_type] :
      ( v114829(VarCurr)
    <=> ( v114726(VarCurr,1)
        & v114823(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12192,axiom,
    ! [VarCurr: state_type] :
      ( v114724(VarCurr)
    <=> ( v114725(VarCurr)
        & v114824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12191,axiom,
    ! [VarCurr: state_type] :
      ( v114824(VarCurr)
    <=> ( v114825(VarCurr)
        & v114828(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4860,axiom,
    ! [VarCurr: state_type] :
      ( v114828(VarCurr)
    <=> ( v114726(VarCurr,1)
        | v114823(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12190,axiom,
    ! [VarCurr: state_type] :
      ( v114825(VarCurr)
    <=> ( v114826(VarCurr)
        | v114827(VarCurr) ) ) ).

tff(writeUnaryOperator_6557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114827(VarCurr)
    <=> v114823(VarCurr,1) ) ).

tff(writeUnaryOperator_6556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114826(VarCurr)
    <=> v114726(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12189,axiom,
    ! [VarCurr: state_type] :
      ( v114725(VarCurr)
    <=> ( v114726(VarCurr,0)
        & v114823(VarCurr,0) ) ) ).

tff(addAssignment_68006,axiom,
    ! [VarCurr: state_type] :
      ( v114823(VarCurr,0)
    <=> v114659(VarCurr) ) ).

tff(addAssignment_68005,axiom,
    ! [VarCurr: state_type] :
      ( ( v114823(VarCurr,2)
      <=> $false )
      & ( v114823(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_68004,axiom,
    ! [VarCurr: state_type] :
      ( v114726(VarCurr,0)
    <=> v114818(VarCurr) ) ).

tff(addAssignment_68003,axiom,
    ! [VarCurr: state_type] :
      ( v114726(VarCurr,1)
    <=> v114813(VarCurr) ) ).

tff(addAssignment_68002,axiom,
    ! [VarCurr: state_type] :
      ( v114726(VarCurr,2)
    <=> v114728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12188,axiom,
    ! [VarCurr: state_type] :
      ( v114818(VarCurr)
    <=> ( v114819(VarCurr)
        & v114822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12187,axiom,
    ! [VarCurr: state_type] :
      ( v114822(VarCurr)
    <=> ( v114734(VarCurr,0)
        | v114799(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12186,axiom,
    ! [VarCurr: state_type] :
      ( v114819(VarCurr)
    <=> ( v114820(VarCurr)
        | v114821(VarCurr) ) ) ).

tff(writeUnaryOperator_6555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114821(VarCurr)
    <=> v114799(VarCurr,0) ) ).

tff(writeUnaryOperator_6554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114820(VarCurr)
    <=> v114734(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12185,axiom,
    ! [VarCurr: state_type] :
      ( v114813(VarCurr)
    <=> ( v114814(VarCurr)
        & v114817(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12184,axiom,
    ! [VarCurr: state_type] :
      ( v114817(VarCurr)
    <=> ( v114733(VarCurr)
        | v114800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12183,axiom,
    ! [VarCurr: state_type] :
      ( v114814(VarCurr)
    <=> ( v114815(VarCurr)
        | v114816(VarCurr) ) ) ).

tff(writeUnaryOperator_6553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114816(VarCurr)
    <=> v114800(VarCurr) ) ).

tff(writeUnaryOperator_6552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114815(VarCurr)
    <=> v114733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12182,axiom,
    ! [VarCurr: state_type] :
      ( v114728(VarCurr)
    <=> ( v114729(VarCurr)
        & v114812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12181,axiom,
    ! [VarCurr: state_type] :
      ( v114812(VarCurr)
    <=> ( v114731(VarCurr)
        | v114807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12180,axiom,
    ! [VarCurr: state_type] :
      ( v114729(VarCurr)
    <=> ( v114730(VarCurr)
        | v114806(VarCurr) ) ) ).

tff(writeUnaryOperator_6551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114806(VarCurr)
    <=> v114807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12179,axiom,
    ! [VarCurr: state_type] :
      ( v114807(VarCurr)
    <=> ( v114808(VarCurr)
        & v114811(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4859,axiom,
    ! [VarCurr: state_type] :
      ( v114811(VarCurr)
    <=> ( v114734(VarCurr,2)
        | v114799(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12178,axiom,
    ! [VarCurr: state_type] :
      ( v114808(VarCurr)
    <=> ( v114809(VarCurr)
        | v114810(VarCurr) ) ) ).

tff(writeUnaryOperator_6550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114810(VarCurr)
    <=> v114799(VarCurr,2) ) ).

tff(writeUnaryOperator_6549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114809(VarCurr)
    <=> v114734(VarCurr,2) ) ).

tff(writeUnaryOperator_6548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114730(VarCurr)
    <=> v114731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12177,axiom,
    ! [VarCurr: state_type] :
      ( v114731(VarCurr)
    <=> ( v114732(VarCurr)
        | v114805(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4858,axiom,
    ! [VarCurr: state_type] :
      ( v114805(VarCurr)
    <=> ( v114734(VarCurr,1)
        & v114799(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12176,axiom,
    ! [VarCurr: state_type] :
      ( v114732(VarCurr)
    <=> ( v114733(VarCurr)
        & v114800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12175,axiom,
    ! [VarCurr: state_type] :
      ( v114800(VarCurr)
    <=> ( v114801(VarCurr)
        & v114804(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4857,axiom,
    ! [VarCurr: state_type] :
      ( v114804(VarCurr)
    <=> ( v114734(VarCurr,1)
        | v114799(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12174,axiom,
    ! [VarCurr: state_type] :
      ( v114801(VarCurr)
    <=> ( v114802(VarCurr)
        | v114803(VarCurr) ) ) ).

tff(writeUnaryOperator_6547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114803(VarCurr)
    <=> v114799(VarCurr,1) ) ).

tff(writeUnaryOperator_6546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114802(VarCurr)
    <=> v114734(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12173,axiom,
    ! [VarCurr: state_type] :
      ( v114733(VarCurr)
    <=> ( v114734(VarCurr,0)
        & v114799(VarCurr,0) ) ) ).

tff(addAssignment_68001,axiom,
    ! [VarCurr: state_type] :
      ( v114799(VarCurr,0)
    <=> v114631(VarCurr) ) ).

tff(addAssignment_68000,axiom,
    ! [VarCurr: state_type] :
      ( ( v114799(VarCurr,2)
      <=> $false )
      & ( v114799(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_67999,axiom,
    ! [VarCurr: state_type] :
      ( v114734(VarCurr,0)
    <=> v114794(VarCurr) ) ).

tff(addAssignment_67998,axiom,
    ! [VarCurr: state_type] :
      ( v114734(VarCurr,1)
    <=> v114789(VarCurr) ) ).

tff(addAssignment_67997,axiom,
    ! [VarCurr: state_type] :
      ( v114734(VarCurr,2)
    <=> v114736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12172,axiom,
    ! [VarCurr: state_type] :
      ( v114794(VarCurr)
    <=> ( v114795(VarCurr)
        & v114798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12171,axiom,
    ! [VarCurr: state_type] :
      ( v114798(VarCurr)
    <=> ( v114742(VarCurr,0)
        | v114775(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12170,axiom,
    ! [VarCurr: state_type] :
      ( v114795(VarCurr)
    <=> ( v114796(VarCurr)
        | v114797(VarCurr) ) ) ).

tff(writeUnaryOperator_6545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114797(VarCurr)
    <=> v114775(VarCurr,0) ) ).

tff(writeUnaryOperator_6544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114796(VarCurr)
    <=> v114742(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12169,axiom,
    ! [VarCurr: state_type] :
      ( v114789(VarCurr)
    <=> ( v114790(VarCurr)
        & v114793(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12168,axiom,
    ! [VarCurr: state_type] :
      ( v114793(VarCurr)
    <=> ( v114741(VarCurr)
        | v114776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12167,axiom,
    ! [VarCurr: state_type] :
      ( v114790(VarCurr)
    <=> ( v114791(VarCurr)
        | v114792(VarCurr) ) ) ).

tff(writeUnaryOperator_6543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114792(VarCurr)
    <=> v114776(VarCurr) ) ).

tff(writeUnaryOperator_6542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114791(VarCurr)
    <=> v114741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12166,axiom,
    ! [VarCurr: state_type] :
      ( v114736(VarCurr)
    <=> ( v114737(VarCurr)
        & v114788(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12165,axiom,
    ! [VarCurr: state_type] :
      ( v114788(VarCurr)
    <=> ( v114739(VarCurr)
        | v114783(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12164,axiom,
    ! [VarCurr: state_type] :
      ( v114737(VarCurr)
    <=> ( v114738(VarCurr)
        | v114782(VarCurr) ) ) ).

tff(writeUnaryOperator_6541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114782(VarCurr)
    <=> v114783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12163,axiom,
    ! [VarCurr: state_type] :
      ( v114783(VarCurr)
    <=> ( v114784(VarCurr)
        & v114787(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4856,axiom,
    ! [VarCurr: state_type] :
      ( v114787(VarCurr)
    <=> ( v114742(VarCurr,2)
        | v114775(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12162,axiom,
    ! [VarCurr: state_type] :
      ( v114784(VarCurr)
    <=> ( v114785(VarCurr)
        | v114786(VarCurr) ) ) ).

tff(writeUnaryOperator_6540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114786(VarCurr)
    <=> v114775(VarCurr,2) ) ).

tff(writeUnaryOperator_6539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114785(VarCurr)
    <=> v114742(VarCurr,2) ) ).

tff(writeUnaryOperator_6538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114738(VarCurr)
    <=> v114739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12161,axiom,
    ! [VarCurr: state_type] :
      ( v114739(VarCurr)
    <=> ( v114740(VarCurr)
        | v114781(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4855,axiom,
    ! [VarCurr: state_type] :
      ( v114781(VarCurr)
    <=> ( v114742(VarCurr,1)
        & v114775(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12160,axiom,
    ! [VarCurr: state_type] :
      ( v114740(VarCurr)
    <=> ( v114741(VarCurr)
        & v114776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12159,axiom,
    ! [VarCurr: state_type] :
      ( v114776(VarCurr)
    <=> ( v114777(VarCurr)
        & v114780(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4854,axiom,
    ! [VarCurr: state_type] :
      ( v114780(VarCurr)
    <=> ( v114742(VarCurr,1)
        | v114775(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12158,axiom,
    ! [VarCurr: state_type] :
      ( v114777(VarCurr)
    <=> ( v114778(VarCurr)
        | v114779(VarCurr) ) ) ).

tff(writeUnaryOperator_6537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114779(VarCurr)
    <=> v114775(VarCurr,1) ) ).

tff(writeUnaryOperator_6536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114778(VarCurr)
    <=> v114742(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12157,axiom,
    ! [VarCurr: state_type] :
      ( v114741(VarCurr)
    <=> ( v114742(VarCurr,0)
        & v114775(VarCurr,0) ) ) ).

tff(addAssignment_67996,axiom,
    ! [VarCurr: state_type] :
      ( v114775(VarCurr,0)
    <=> v114603(VarCurr) ) ).

tff(addAssignment_67995,axiom,
    ! [VarCurr: state_type] :
      ( ( v114775(VarCurr,2)
      <=> $false )
      & ( v114775(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_67994,axiom,
    ! [VarCurr: state_type] :
      ( v114742(VarCurr,0)
    <=> v114770(VarCurr) ) ).

tff(addAssignment_67993,axiom,
    ! [VarCurr: state_type] :
      ( v114742(VarCurr,1)
    <=> v114765(VarCurr) ) ).

tff(addAssignment_67992,axiom,
    ! [VarCurr: state_type] :
      ( v114742(VarCurr,2)
    <=> v114744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12156,axiom,
    ! [VarCurr: state_type] :
      ( v114770(VarCurr)
    <=> ( v114771(VarCurr)
        & v114774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12155,axiom,
    ! [VarCurr: state_type] :
      ( v114774(VarCurr)
    <=> ( v114750(VarCurr,0)
        | v114751(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12154,axiom,
    ! [VarCurr: state_type] :
      ( v114771(VarCurr)
    <=> ( v114772(VarCurr)
        | v114773(VarCurr) ) ) ).

tff(writeUnaryOperator_6535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114773(VarCurr)
    <=> v114751(VarCurr,0) ) ).

tff(writeUnaryOperator_6534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114772(VarCurr)
    <=> v114750(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12153,axiom,
    ! [VarCurr: state_type] :
      ( v114765(VarCurr)
    <=> ( v114766(VarCurr)
        & v114769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12152,axiom,
    ! [VarCurr: state_type] :
      ( v114769(VarCurr)
    <=> ( v114749(VarCurr)
        | v114752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12151,axiom,
    ! [VarCurr: state_type] :
      ( v114766(VarCurr)
    <=> ( v114767(VarCurr)
        | v114768(VarCurr) ) ) ).

tff(writeUnaryOperator_6533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114768(VarCurr)
    <=> v114752(VarCurr) ) ).

tff(writeUnaryOperator_6532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114767(VarCurr)
    <=> v114749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12150,axiom,
    ! [VarCurr: state_type] :
      ( v114744(VarCurr)
    <=> ( v114745(VarCurr)
        & v114764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12149,axiom,
    ! [VarCurr: state_type] :
      ( v114764(VarCurr)
    <=> ( v114747(VarCurr)
        | v114759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12148,axiom,
    ! [VarCurr: state_type] :
      ( v114745(VarCurr)
    <=> ( v114746(VarCurr)
        | v114758(VarCurr) ) ) ).

tff(writeUnaryOperator_6531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114758(VarCurr)
    <=> v114759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12147,axiom,
    ! [VarCurr: state_type] :
      ( v114759(VarCurr)
    <=> ( v114760(VarCurr)
        & v114763(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4853,axiom,
    ! [VarCurr: state_type] :
      ( v114763(VarCurr)
    <=> ( v114750(VarCurr,2)
        | v114751(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12146,axiom,
    ! [VarCurr: state_type] :
      ( v114760(VarCurr)
    <=> ( v114761(VarCurr)
        | v114762(VarCurr) ) ) ).

tff(writeUnaryOperator_6530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114762(VarCurr)
    <=> v114751(VarCurr,2) ) ).

tff(writeUnaryOperator_6529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114761(VarCurr)
    <=> v114750(VarCurr,2) ) ).

tff(writeUnaryOperator_6528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114746(VarCurr)
    <=> v114747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12145,axiom,
    ! [VarCurr: state_type] :
      ( v114747(VarCurr)
    <=> ( v114748(VarCurr)
        | v114757(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4852,axiom,
    ! [VarCurr: state_type] :
      ( v114757(VarCurr)
    <=> ( v114750(VarCurr,1)
        & v114751(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12144,axiom,
    ! [VarCurr: state_type] :
      ( v114748(VarCurr)
    <=> ( v114749(VarCurr)
        & v114752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12143,axiom,
    ! [VarCurr: state_type] :
      ( v114752(VarCurr)
    <=> ( v114753(VarCurr)
        & v114756(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4851,axiom,
    ! [VarCurr: state_type] :
      ( v114756(VarCurr)
    <=> ( v114750(VarCurr,1)
        | v114751(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12142,axiom,
    ! [VarCurr: state_type] :
      ( v114753(VarCurr)
    <=> ( v114754(VarCurr)
        | v114755(VarCurr) ) ) ).

tff(writeUnaryOperator_6527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114755(VarCurr)
    <=> v114751(VarCurr,1) ) ).

tff(writeUnaryOperator_6526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114754(VarCurr)
    <=> v114750(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12141,axiom,
    ! [VarCurr: state_type] :
      ( v114749(VarCurr)
    <=> ( v114750(VarCurr,0)
        & v114751(VarCurr,0) ) ) ).

tff(addAssignment_67991,axiom,
    ! [VarCurr: state_type] :
      ( v114751(VarCurr,0)
    <=> v114575(VarCurr) ) ).

tff(addAssignment_67990,axiom,
    ! [VarCurr: state_type] :
      ( ( v114751(VarCurr,2)
      <=> $false )
      & ( v114751(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_67989,axiom,
    ! [VarCurr: state_type] :
      ( v114750(VarCurr,0)
    <=> v114547(VarCurr) ) ).

tff(addAssignment_67988,axiom,
    ! [VarCurr: state_type] :
      ( ( v114750(VarCurr,2)
      <=> $false )
      & ( v114750(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_67987,axiom,
    ! [VarCurr: state_type] :
      ( v114690(VarCurr)
    <=> v114692(VarCurr,1) ) ).

tff(addAssignment_67986,axiom,
    ! [VarCurr: state_type] :
      ( v114692(VarCurr,1)
    <=> v114694(VarCurr,1) ) ).

tff(addAssignment_67985,axiom,
    ! [VarCurr: state_type] :
      ( v114694(VarCurr,1)
    <=> v114696(VarCurr,1) ) ).

tff(addAssignment_67984,axiom,
    ! [VarCurr: state_type] :
      ( v114696(VarCurr,1)
    <=> v114697(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114697(VarCurr,B)
      <=> ( v114698(VarCurr,B)
          & v113917(VarCurr,B) ) ) ) ).

tff(addAssignment_67983,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,0)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67982,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,1)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67981,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,2)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67980,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,3)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67979,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,4)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67978,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,5)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67977,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,6)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67976,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,7)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67975,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,8)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67974,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,9)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67973,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,10)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67972,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,11)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67971,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,12)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67970,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,13)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67969,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,14)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67968,axiom,
    ! [VarCurr: state_type] :
      ( v114698(VarCurr,15)
    <=> v114699(VarCurr) ) ).

tff(addAssignment_67967,axiom,
    ! [VarCurr: state_type] :
      ( v114699(VarCurr)
    <=> v114700(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12140,axiom,
    ! [VarCurr: state_type] :
      ( v114700(VarCurr)
    <=> ( v114701(VarCurr)
        & v97208(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12139,axiom,
    ! [VarCurr: state_type] :
      ( v114701(VarCurr)
    <=> ( v100713(VarCurr)
        & v97278(VarCurr) ) ) ).

tff(addAssignment_67966,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,1)
    <=> v113918(VarCurr,1) ) ).

tff(addAssignment_67965,axiom,
    ! [VarCurr: state_type] :
      ( v114683(VarCurr)
    <=> v114685(VarCurr,1) ) ).

tff(addAssignment_67964,axiom,
    ! [VarCurr: state_type] :
      ( v114685(VarCurr,1)
    <=> v114686(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114686(VarCurr,B)
      <=> ( v114687(VarCurr,B)
          & v89119(VarCurr,B) ) ) ) ).

tff(addAssignment_67963,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,0)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67962,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,1)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67961,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,2)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67960,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,3)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67959,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,4)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67958,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,5)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67957,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,6)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67956,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,7)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67955,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,8)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67954,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,9)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67953,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,10)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67952,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,11)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67951,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,12)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67950,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,13)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67949,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,14)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67948,axiom,
    ! [VarCurr: state_type] :
      ( v114687(VarCurr,15)
    <=> v114688(VarCurr) ) ).

tff(addAssignment_67947,axiom,
    ! [VarCurr: state_type] :
      ( v114688(VarCurr)
    <=> v86711(VarCurr) ) ).

tff(addAssignment_67946,axiom,
    ! [VarCurr: state_type] :
      ( v114659(VarCurr)
    <=> v114661(VarCurr,1) ) ).

tff(addAssignment_67945,axiom,
    ! [VarCurr: state_type] :
      ( v114661(VarCurr,1)
    <=> v114662(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114662(VarCurr,B)
      <=> ( v114663(VarCurr,B)
          & v114665(VarCurr,B) ) ) ) ).

tff(addAssignment_67944,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,0)
    <=> v114681(VarCurr) ) ).

tff(addAssignment_67943,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,1)
    <=> v114680(VarCurr) ) ).

tff(addAssignment_67942,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,2)
    <=> v114679(VarCurr) ) ).

tff(addAssignment_67941,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,3)
    <=> v114678(VarCurr) ) ).

tff(addAssignment_67940,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,4)
    <=> v114677(VarCurr) ) ).

tff(addAssignment_67939,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,5)
    <=> v114676(VarCurr) ) ).

tff(addAssignment_67938,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,6)
    <=> v114675(VarCurr) ) ).

tff(addAssignment_67937,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,7)
    <=> v114674(VarCurr) ) ).

tff(addAssignment_67936,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,8)
    <=> v114673(VarCurr) ) ).

tff(addAssignment_67935,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,9)
    <=> v114672(VarCurr) ) ).

tff(addAssignment_67934,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,10)
    <=> v114671(VarCurr) ) ).

tff(addAssignment_67933,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,11)
    <=> v114670(VarCurr) ) ).

tff(addAssignment_67932,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,12)
    <=> v114669(VarCurr) ) ).

tff(addAssignment_67931,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,13)
    <=> v114668(VarCurr) ) ).

tff(addAssignment_67930,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,14)
    <=> v114667(VarCurr) ) ).

tff(addAssignment_67929,axiom,
    ! [VarCurr: state_type] :
      ( v114665(VarCurr,15)
    <=> v114666(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1128,axiom,
    ! [VarCurr: state_type] :
      ( v114681(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1127,axiom,
    ! [VarCurr: state_type] :
      ( v114680(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1126,axiom,
    ! [VarCurr: state_type] :
      ( v114679(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1125,axiom,
    ! [VarCurr: state_type] :
      ( v114678(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1124,axiom,
    ! [VarCurr: state_type] :
      ( v114677(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1123,axiom,
    ! [VarCurr: state_type] :
      ( v114676(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1122,axiom,
    ! [VarCurr: state_type] :
      ( v114675(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1121,axiom,
    ! [VarCurr: state_type] :
      ( v114674(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $false )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1120,axiom,
    ! [VarCurr: state_type] :
      ( v114673(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1119,axiom,
    ! [VarCurr: state_type] :
      ( v114672(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1118,axiom,
    ! [VarCurr: state_type] :
      ( v114671(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1117,axiom,
    ! [VarCurr: state_type] :
      ( v114670(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $false )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1116,axiom,
    ! [VarCurr: state_type] :
      ( v114669(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1115,axiom,
    ! [VarCurr: state_type] :
      ( v114668(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $false )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1114,axiom,
    ! [VarCurr: state_type] :
      ( v114667(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1113,axiom,
    ! [VarCurr: state_type] :
      ( v114666(VarCurr)
    <=> ( ( v906(VarCurr,13)
        <=> $true )
        & ( v906(VarCurr,12)
        <=> $true )
        & ( v906(VarCurr,11)
        <=> $true )
        & ( v906(VarCurr,10)
        <=> $true ) ) ) ).

tff(addAssignment_67928,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,0)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67927,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,1)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67926,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,2)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67925,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,3)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67924,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,4)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67923,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,5)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67922,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,6)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67921,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,7)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67920,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,8)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67919,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,9)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67918,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,10)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67917,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,11)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67916,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,12)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67915,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,13)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67914,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,14)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67913,axiom,
    ! [VarCurr: state_type] :
      ( v114663(VarCurr,15)
    <=> v114664(VarCurr) ) ).

tff(addAssignment_67912,axiom,
    ! [VarCurr: state_type] :
      ( v114664(VarCurr)
    <=> v5747(VarCurr) ) ).

tff(addAssignment_67911,axiom,
    ! [VarCurr: state_type] :
      ( v114631(VarCurr)
    <=> v114633(VarCurr,1) ) ).

tff(addAssignment_67910,axiom,
    ! [VarCurr: state_type] :
      ( v114633(VarCurr,1)
    <=> v114635(VarCurr,1) ) ).

tff(addAssignment_67909,axiom,
    ! [VarCurr: state_type] :
      ( v114635(VarCurr,1)
    <=> v114637(VarCurr,1) ) ).

tff(addAssignment_67908,axiom,
    ! [VarCurr: state_type] :
      ( v114637(VarCurr,1)
    <=> v114638(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114638(VarCurr,B)
      <=> ( v114639(VarCurr,B)
          & v114641(VarCurr,B) ) ) ) ).

tff(addAssignment_67907,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,0)
    <=> v114657(VarCurr) ) ).

tff(addAssignment_67906,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,1)
    <=> v114656(VarCurr) ) ).

tff(addAssignment_67905,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,2)
    <=> v114655(VarCurr) ) ).

tff(addAssignment_67904,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,3)
    <=> v114654(VarCurr) ) ).

tff(addAssignment_67903,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,4)
    <=> v114653(VarCurr) ) ).

tff(addAssignment_67902,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,5)
    <=> v114652(VarCurr) ) ).

tff(addAssignment_67901,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,6)
    <=> v114651(VarCurr) ) ).

tff(addAssignment_67900,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,7)
    <=> v114650(VarCurr) ) ).

tff(addAssignment_67899,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,8)
    <=> v114649(VarCurr) ) ).

tff(addAssignment_67898,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,9)
    <=> v114648(VarCurr) ) ).

tff(addAssignment_67897,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,10)
    <=> v114647(VarCurr) ) ).

tff(addAssignment_67896,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,11)
    <=> v114646(VarCurr) ) ).

tff(addAssignment_67895,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,12)
    <=> v114645(VarCurr) ) ).

tff(addAssignment_67894,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,13)
    <=> v114644(VarCurr) ) ).

tff(addAssignment_67893,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,14)
    <=> v114643(VarCurr) ) ).

tff(addAssignment_67892,axiom,
    ! [VarCurr: state_type] :
      ( v114641(VarCurr,15)
    <=> v114642(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1112,axiom,
    ! [VarCurr: state_type] :
      ( v114657(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1111,axiom,
    ! [VarCurr: state_type] :
      ( v114656(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1110,axiom,
    ! [VarCurr: state_type] :
      ( v114655(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1109,axiom,
    ! [VarCurr: state_type] :
      ( v114654(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1108,axiom,
    ! [VarCurr: state_type] :
      ( v114653(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1107,axiom,
    ! [VarCurr: state_type] :
      ( v114652(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1106,axiom,
    ! [VarCurr: state_type] :
      ( v114651(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1105,axiom,
    ! [VarCurr: state_type] :
      ( v114650(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $false )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1104,axiom,
    ! [VarCurr: state_type] :
      ( v114649(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1103,axiom,
    ! [VarCurr: state_type] :
      ( v114648(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1102,axiom,
    ! [VarCurr: state_type] :
      ( v114647(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1101,axiom,
    ! [VarCurr: state_type] :
      ( v114646(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $false )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1100,axiom,
    ! [VarCurr: state_type] :
      ( v114645(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1099,axiom,
    ! [VarCurr: state_type] :
      ( v114644(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $false )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1098,axiom,
    ! [VarCurr: state_type] :
      ( v114643(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1097,axiom,
    ! [VarCurr: state_type] :
      ( v114642(VarCurr)
    <=> ( ( v89443(VarCurr,6)
        <=> $true )
        & ( v89443(VarCurr,5)
        <=> $true )
        & ( v89443(VarCurr,4)
        <=> $true )
        & ( v89443(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67891,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,0)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67890,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,1)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67889,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,2)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67888,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,3)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67887,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,4)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67886,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,5)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67885,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,6)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67884,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,7)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67883,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,8)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67882,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,9)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67881,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,10)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67880,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,11)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67879,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,12)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67878,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,13)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67877,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,14)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67876,axiom,
    ! [VarCurr: state_type] :
      ( v114639(VarCurr,15)
    <=> v114640(VarCurr) ) ).

tff(addAssignment_67875,axiom,
    ! [VarCurr: state_type] :
      ( v114640(VarCurr)
    <=> v85794(VarCurr) ) ).

tff(addAssignment_67874,axiom,
    ! [VarCurr: state_type] :
      ( v114603(VarCurr)
    <=> v114605(VarCurr,1) ) ).

tff(addAssignment_67873,axiom,
    ! [VarCurr: state_type] :
      ( v114605(VarCurr,1)
    <=> v114607(VarCurr,1) ) ).

tff(addAssignment_67872,axiom,
    ! [VarCurr: state_type] :
      ( v114607(VarCurr,1)
    <=> v114609(VarCurr,1) ) ).

tff(addAssignment_67871,axiom,
    ! [VarCurr: state_type] :
      ( v114609(VarCurr,1)
    <=> v114610(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114610(VarCurr,B)
      <=> ( v114611(VarCurr,B)
          & v114613(VarCurr,B) ) ) ) ).

tff(addAssignment_67870,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,0)
    <=> v114629(VarCurr) ) ).

tff(addAssignment_67869,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,1)
    <=> v114628(VarCurr) ) ).

tff(addAssignment_67868,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,2)
    <=> v114627(VarCurr) ) ).

tff(addAssignment_67867,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,3)
    <=> v114626(VarCurr) ) ).

tff(addAssignment_67866,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,4)
    <=> v114625(VarCurr) ) ).

tff(addAssignment_67865,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,5)
    <=> v114624(VarCurr) ) ).

tff(addAssignment_67864,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,6)
    <=> v114623(VarCurr) ) ).

tff(addAssignment_67863,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,7)
    <=> v114622(VarCurr) ) ).

tff(addAssignment_67862,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,8)
    <=> v114621(VarCurr) ) ).

tff(addAssignment_67861,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,9)
    <=> v114620(VarCurr) ) ).

tff(addAssignment_67860,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,10)
    <=> v114619(VarCurr) ) ).

tff(addAssignment_67859,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,11)
    <=> v114618(VarCurr) ) ).

tff(addAssignment_67858,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,12)
    <=> v114617(VarCurr) ) ).

tff(addAssignment_67857,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,13)
    <=> v114616(VarCurr) ) ).

tff(addAssignment_67856,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,14)
    <=> v114615(VarCurr) ) ).

tff(addAssignment_67855,axiom,
    ! [VarCurr: state_type] :
      ( v114613(VarCurr,15)
    <=> v114614(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1096,axiom,
    ! [VarCurr: state_type] :
      ( v114629(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1095,axiom,
    ! [VarCurr: state_type] :
      ( v114628(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1094,axiom,
    ! [VarCurr: state_type] :
      ( v114627(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1093,axiom,
    ! [VarCurr: state_type] :
      ( v114626(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1092,axiom,
    ! [VarCurr: state_type] :
      ( v114625(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1091,axiom,
    ! [VarCurr: state_type] :
      ( v114624(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1090,axiom,
    ! [VarCurr: state_type] :
      ( v114623(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1089,axiom,
    ! [VarCurr: state_type] :
      ( v114622(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $false )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1088,axiom,
    ! [VarCurr: state_type] :
      ( v114621(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1087,axiom,
    ! [VarCurr: state_type] :
      ( v114620(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1086,axiom,
    ! [VarCurr: state_type] :
      ( v114619(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1085,axiom,
    ! [VarCurr: state_type] :
      ( v114618(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $false )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1084,axiom,
    ! [VarCurr: state_type] :
      ( v114617(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1083,axiom,
    ! [VarCurr: state_type] :
      ( v114616(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $false )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1082,axiom,
    ! [VarCurr: state_type] :
      ( v114615(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1081,axiom,
    ! [VarCurr: state_type] :
      ( v114614(VarCurr)
    <=> ( ( v89277(VarCurr,6)
        <=> $true )
        & ( v89277(VarCurr,5)
        <=> $true )
        & ( v89277(VarCurr,4)
        <=> $true )
        & ( v89277(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67854,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,0)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67853,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,1)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67852,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,2)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67851,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,3)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67850,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,4)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67849,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,5)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67848,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,6)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67847,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,7)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67846,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,8)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67845,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,9)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67844,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,10)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67843,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,11)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67842,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,12)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67841,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,13)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67840,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,14)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67839,axiom,
    ! [VarCurr: state_type] :
      ( v114611(VarCurr,15)
    <=> v114612(VarCurr) ) ).

tff(addAssignment_67838,axiom,
    ! [VarCurr: state_type] :
      ( v114612(VarCurr)
    <=> v172(VarCurr) ) ).

tff(addAssignment_67837,axiom,
    ! [VarCurr: state_type] :
      ( v114575(VarCurr)
    <=> v114577(VarCurr,1) ) ).

tff(addAssignment_67836,axiom,
    ! [VarCurr: state_type] :
      ( v114577(VarCurr,1)
    <=> v114579(VarCurr,1) ) ).

tff(addAssignment_67835,axiom,
    ! [VarCurr: state_type] :
      ( v114579(VarCurr,1)
    <=> v114581(VarCurr,1) ) ).

tff(addAssignment_67834,axiom,
    ! [VarCurr: state_type] :
      ( v114581(VarCurr,1)
    <=> v114582(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114582(VarCurr,B)
      <=> ( v114583(VarCurr,B)
          & v114585(VarCurr,B) ) ) ) ).

tff(addAssignment_67833,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,0)
    <=> v114601(VarCurr) ) ).

tff(addAssignment_67832,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,1)
    <=> v114600(VarCurr) ) ).

tff(addAssignment_67831,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,2)
    <=> v114599(VarCurr) ) ).

tff(addAssignment_67830,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,3)
    <=> v114598(VarCurr) ) ).

tff(addAssignment_67829,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,4)
    <=> v114597(VarCurr) ) ).

tff(addAssignment_67828,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,5)
    <=> v114596(VarCurr) ) ).

tff(addAssignment_67827,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,6)
    <=> v114595(VarCurr) ) ).

tff(addAssignment_67826,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,7)
    <=> v114594(VarCurr) ) ).

tff(addAssignment_67825,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,8)
    <=> v114593(VarCurr) ) ).

tff(addAssignment_67824,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,9)
    <=> v114592(VarCurr) ) ).

tff(addAssignment_67823,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,10)
    <=> v114591(VarCurr) ) ).

tff(addAssignment_67822,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,11)
    <=> v114590(VarCurr) ) ).

tff(addAssignment_67821,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,12)
    <=> v114589(VarCurr) ) ).

tff(addAssignment_67820,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,13)
    <=> v114588(VarCurr) ) ).

tff(addAssignment_67819,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,14)
    <=> v114587(VarCurr) ) ).

tff(addAssignment_67818,axiom,
    ! [VarCurr: state_type] :
      ( v114585(VarCurr,15)
    <=> v114586(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1080,axiom,
    ! [VarCurr: state_type] :
      ( v114601(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1079,axiom,
    ! [VarCurr: state_type] :
      ( v114600(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1078,axiom,
    ! [VarCurr: state_type] :
      ( v114599(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1077,axiom,
    ! [VarCurr: state_type] :
      ( v114598(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1076,axiom,
    ! [VarCurr: state_type] :
      ( v114597(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1075,axiom,
    ! [VarCurr: state_type] :
      ( v114596(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1074,axiom,
    ! [VarCurr: state_type] :
      ( v114595(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1073,axiom,
    ! [VarCurr: state_type] :
      ( v114594(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $false )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1072,axiom,
    ! [VarCurr: state_type] :
      ( v114593(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1071,axiom,
    ! [VarCurr: state_type] :
      ( v114592(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1070,axiom,
    ! [VarCurr: state_type] :
      ( v114591(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1069,axiom,
    ! [VarCurr: state_type] :
      ( v114590(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $false )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1068,axiom,
    ! [VarCurr: state_type] :
      ( v114589(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1067,axiom,
    ! [VarCurr: state_type] :
      ( v114588(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $false )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1066,axiom,
    ! [VarCurr: state_type] :
      ( v114587(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1065,axiom,
    ! [VarCurr: state_type] :
      ( v114586(VarCurr)
    <=> ( ( v3918(VarCurr,6)
        <=> $true )
        & ( v3918(VarCurr,5)
        <=> $true )
        & ( v3918(VarCurr,4)
        <=> $true )
        & ( v3918(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67817,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,0)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67816,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,1)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67815,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,2)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67814,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,3)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67813,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,4)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67812,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,5)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67811,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,6)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67810,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,7)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67809,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,8)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67808,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,9)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67807,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,10)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67806,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,11)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67805,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,12)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67804,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,13)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67803,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,14)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67802,axiom,
    ! [VarCurr: state_type] :
      ( v114583(VarCurr,15)
    <=> v114584(VarCurr) ) ).

tff(addAssignment_67801,axiom,
    ! [VarCurr: state_type] :
      ( v114584(VarCurr)
    <=> v2942(VarCurr) ) ).

tff(addAssignment_67800,axiom,
    ! [VarCurr: state_type] :
      ( v114547(VarCurr)
    <=> v114549(VarCurr,1) ) ).

tff(addAssignment_67799,axiom,
    ! [VarCurr: state_type] :
      ( v114549(VarCurr,1)
    <=> v114551(VarCurr,1) ) ).

tff(addAssignment_67798,axiom,
    ! [VarCurr: state_type] :
      ( v114551(VarCurr,1)
    <=> v114553(VarCurr,1) ) ).

tff(addAssignment_67797,axiom,
    ! [VarCurr: state_type] :
      ( v114553(VarCurr,1)
    <=> v114554(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v114554(VarCurr,B)
      <=> ( v114555(VarCurr,B)
          & v114557(VarCurr,B) ) ) ) ).

tff(addAssignment_67796,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,0)
    <=> v114573(VarCurr) ) ).

tff(addAssignment_67795,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,1)
    <=> v114572(VarCurr) ) ).

tff(addAssignment_67794,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,2)
    <=> v114571(VarCurr) ) ).

tff(addAssignment_67793,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,3)
    <=> v114570(VarCurr) ) ).

tff(addAssignment_67792,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,4)
    <=> v114569(VarCurr) ) ).

tff(addAssignment_67791,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,5)
    <=> v114568(VarCurr) ) ).

tff(addAssignment_67790,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,6)
    <=> v114567(VarCurr) ) ).

tff(addAssignment_67789,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,7)
    <=> v114566(VarCurr) ) ).

tff(addAssignment_67788,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,8)
    <=> v114565(VarCurr) ) ).

tff(addAssignment_67787,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,9)
    <=> v114564(VarCurr) ) ).

tff(addAssignment_67786,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,10)
    <=> v114563(VarCurr) ) ).

tff(addAssignment_67785,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,11)
    <=> v114562(VarCurr) ) ).

tff(addAssignment_67784,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,12)
    <=> v114561(VarCurr) ) ).

tff(addAssignment_67783,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,13)
    <=> v114560(VarCurr) ) ).

tff(addAssignment_67782,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,14)
    <=> v114559(VarCurr) ) ).

tff(addAssignment_67781,axiom,
    ! [VarCurr: state_type] :
      ( v114557(VarCurr,15)
    <=> v114558(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1064,axiom,
    ! [VarCurr: state_type] :
      ( v114573(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1063,axiom,
    ! [VarCurr: state_type] :
      ( v114572(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1062,axiom,
    ! [VarCurr: state_type] :
      ( v114571(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1061,axiom,
    ! [VarCurr: state_type] :
      ( v114570(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1060,axiom,
    ! [VarCurr: state_type] :
      ( v114569(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1059,axiom,
    ! [VarCurr: state_type] :
      ( v114568(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1058,axiom,
    ! [VarCurr: state_type] :
      ( v114567(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1057,axiom,
    ! [VarCurr: state_type] :
      ( v114566(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $false )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1056,axiom,
    ! [VarCurr: state_type] :
      ( v114565(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1055,axiom,
    ! [VarCurr: state_type] :
      ( v114564(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1054,axiom,
    ! [VarCurr: state_type] :
      ( v114563(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1053,axiom,
    ! [VarCurr: state_type] :
      ( v114562(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $false )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1052,axiom,
    ! [VarCurr: state_type] :
      ( v114561(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1051,axiom,
    ! [VarCurr: state_type] :
      ( v114560(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $false )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1050,axiom,
    ! [VarCurr: state_type] :
      ( v114559(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1049,axiom,
    ! [VarCurr: state_type] :
      ( v114558(VarCurr)
    <=> ( ( v85306(VarCurr,6)
        <=> $true )
        & ( v85306(VarCurr,5)
        <=> $true )
        & ( v85306(VarCurr,4)
        <=> $true )
        & ( v85306(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67780,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,0)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67779,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,1)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67778,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,2)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67777,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,3)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67776,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,4)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67775,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,5)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67774,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,6)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67773,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,7)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67772,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,8)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67771,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,9)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67770,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,10)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67769,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,11)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67768,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,12)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67767,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,13)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67766,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,14)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67765,axiom,
    ! [VarCurr: state_type] :
      ( v114555(VarCurr,15)
    <=> v114556(VarCurr) ) ).

tff(addAssignment_67764,axiom,
    ! [VarCurr: state_type] :
      ( v114556(VarCurr)
    <=> v5189(VarCurr) ) ).

tff(addAssignment_67763,axiom,
    ! [VarCurr: state_type] :
      ( v114543(VarCurr)
    <=> v85774(VarCurr) ) ).

tff(addAssignment_67762,axiom,
    ! [VarCurr: state_type] :
      ( v114531(VarCurr)
    <=> v114533(VarCurr) ) ).

tff(addAssignment_67761,axiom,
    ! [VarCurr: state_type] :
      ( v114533(VarCurr)
    <=> v114507(VarCurr) ) ).

tff(addAssignment_67760,axiom,
    ! [VarCurr: state_type] :
      ( v114527(VarCurr)
    <=> v114529(VarCurr) ) ).

tff(addAssignment_67759,axiom,
    ! [VarCurr: state_type] :
      ( v114529(VarCurr)
    <=> v114499(VarCurr) ) ).

tff(addAssignment_67758,axiom,
    ! [VarCurr: state_type] :
      ( v114503(VarCurr)
    <=> v114505(VarCurr) ) ).

tff(addAssignment_67757,axiom,
    ! [VarCurr: state_type] :
      ( v114505(VarCurr)
    <=> v114507(VarCurr) ) ).

tff(addAssignment_67756,axiom,
    ! [VarCurr: state_type] :
      ( v114507(VarCurr)
    <=> v114509(VarCurr) ) ).

tff(addAssignment_67755,axiom,
    ! [VarCurr: state_type] :
      ( v114509(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_67754,axiom,
    ! [VarCurr: state_type] :
      ( v114495(VarCurr)
    <=> v114497(VarCurr) ) ).

tff(addAssignment_67753,axiom,
    ! [VarCurr: state_type] :
      ( v114497(VarCurr)
    <=> v114499(VarCurr) ) ).

tff(addAssignment_67752,axiom,
    ! [VarCurr: state_type] :
      ( v114499(VarCurr)
    <=> v114501(VarCurr) ) ).

tff(addAssignment_67751,axiom,
    ! [VarCurr: state_type] :
      ( v114501(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12138,axiom,
    ! [VarCurr: state_type] :
      ( v112755(VarCurr)
    <=> ( v114485(VarCurr)
        & v112912(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4850,axiom,
    ! [VarCurr: state_type] :
      ( v114485(VarCurr)
    <=> ( v85714(VarCurr,1)
        & v112803(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1048,axiom,
    ! [VarCurr: state_type] :
      ( v112912(VarCurr)
    <=> ( ( v112914(VarCurr,4)
        <=> $false )
        & ( v112914(VarCurr,3)
        <=> $false )
        & ( v112914(VarCurr,2)
        <=> $false )
        & ( v112914(VarCurr,1)
        <=> $false )
        & ( v112914(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112914(VarCurr,B)
      <=> v112916(VarCurr,B) ) ) ).

tff(addAssignment_67749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112916(VarCurr,B)
      <=> v112918(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114467(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v112918(VarNext,B)
            <=> v112918(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1493,axiom,
    ! [VarNext: state_type] :
      ( v114467(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v112918(VarNext,B)
          <=> v114477(VarNext,B) ) ) ) ).

tff(addAssignment_67748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114477(VarNext,B)
          <=> v114475(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114478(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114475(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1022,axiom,
    ! [VarCurr: state_type] :
      ( v114478(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114475(VarCurr,B)
          <=> v112928(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12137,axiom,
    ! [VarCurr: state_type] :
      ( v114478(VarCurr)
    <=> ( v114479(VarCurr)
        & v114480(VarCurr) ) ) ).

tff(writeUnaryOperator_6525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114480(VarCurr)
    <=> v112924(VarCurr) ) ).

tff(writeUnaryOperator_6524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114479(VarCurr)
    <=> v112920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114467(VarNext)
      <=> v114468(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114468(VarNext)
      <=> ( v114469(VarNext)
          & v114462(VarNext) ) ) ) ).

tff(writeUnaryOperator_6523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114469(VarNext)
      <=> v114471(VarNext) ) ) ).

tff(addAssignment_67747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114471(VarNext)
      <=> v114462(VarCurr) ) ) ).

tff(addAssignment_67746,axiom,
    ! [VarCurr: state_type] :
      ( v114462(VarCurr)
    <=> v114464(VarCurr) ) ).

tff(addAssignment_67745,axiom,
    ! [VarCurr: state_type] :
      ( v114464(VarCurr)
    <=> v112783(VarCurr) ) ).

tff(addAssignment_67744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112928(VarCurr,B)
      <=> v112930(VarCurr,B) ) ) ).

tff(addAssignment_67743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112930(VarCurr,B)
      <=> v112932(VarCurr,B) ) ) ).

tff(addAssignment_67742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112932(VarCurr,B)
      <=> v112934(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v112934(VarCurr,B)
          <=> v114431(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1021,axiom,
    ! [VarCurr: state_type] :
      ( v112936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v112934(VarCurr,B)
          <=> v113150(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114431(VarCurr,B)
          <=> v114432(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1020,axiom,
    ! [VarCurr: state_type] :
      ( v113806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114431(VarCurr,B)
          <=> v113944(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114432(VarCurr,B)
          <=> v114433(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1019,axiom,
    ! [VarCurr: state_type] :
      ( v112912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114432(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_67741,axiom,
    ! [VarCurr: state_type] :
      ( v114433(VarCurr,0)
    <=> v114459(VarCurr) ) ).

tff(addAssignment_67740,axiom,
    ! [VarCurr: state_type] :
      ( v114433(VarCurr,1)
    <=> v114457(VarCurr) ) ).

tff(addAssignment_67739,axiom,
    ! [VarCurr: state_type] :
      ( v114433(VarCurr,2)
    <=> v114453(VarCurr) ) ).

tff(addAssignment_67738,axiom,
    ! [VarCurr: state_type] :
      ( v114433(VarCurr,3)
    <=> v114449(VarCurr) ) ).

tff(addAssignment_67737,axiom,
    ! [VarCurr: state_type] :
      ( v114433(VarCurr,4)
    <=> v114435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12134,axiom,
    ! [VarCurr: state_type] :
      ( v114457(VarCurr)
    <=> ( v114458(VarCurr)
        & v114460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12133,axiom,
    ! [VarCurr: state_type] :
      ( v114460(VarCurr)
    <=> ( v112914(VarCurr,0)
        | v114444(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4849,axiom,
    ! [VarCurr: state_type] :
      ( v114458(VarCurr)
    <=> ( v114459(VarCurr)
        | v112914(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114459(VarCurr)
    <=> v112914(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12132,axiom,
    ! [VarCurr: state_type] :
      ( v114453(VarCurr)
    <=> ( v114454(VarCurr)
        & v114456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12131,axiom,
    ! [VarCurr: state_type] :
      ( v114456(VarCurr)
    <=> ( v114442(VarCurr)
        | v114445(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4848,axiom,
    ! [VarCurr: state_type] :
      ( v114454(VarCurr)
    <=> ( v114455(VarCurr)
        | v112914(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114455(VarCurr)
    <=> v114442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12130,axiom,
    ! [VarCurr: state_type] :
      ( v114449(VarCurr)
    <=> ( v114450(VarCurr)
        & v114452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12129,axiom,
    ! [VarCurr: state_type] :
      ( v114452(VarCurr)
    <=> ( v114440(VarCurr)
        | v114446(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4847,axiom,
    ! [VarCurr: state_type] :
      ( v114450(VarCurr)
    <=> ( v114451(VarCurr)
        | v112914(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114451(VarCurr)
    <=> v114440(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12128,axiom,
    ! [VarCurr: state_type] :
      ( v114435(VarCurr)
    <=> ( v114436(VarCurr)
        & v114447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12127,axiom,
    ! [VarCurr: state_type] :
      ( v114447(VarCurr)
    <=> ( v114438(VarCurr)
        | v114448(VarCurr) ) ) ).

tff(writeUnaryOperator_6519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114448(VarCurr)
    <=> v112914(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4846,axiom,
    ! [VarCurr: state_type] :
      ( v114436(VarCurr)
    <=> ( v114437(VarCurr)
        | v112914(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114437(VarCurr)
    <=> v114438(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4845,axiom,
    ! [VarCurr: state_type] :
      ( v114438(VarCurr)
    <=> ( v112914(VarCurr,3)
        | v114439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12126,axiom,
    ! [VarCurr: state_type] :
      ( v114439(VarCurr)
    <=> ( v114440(VarCurr)
        & v114446(VarCurr) ) ) ).

tff(writeUnaryOperator_6517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114446(VarCurr)
    <=> v112914(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4844,axiom,
    ! [VarCurr: state_type] :
      ( v114440(VarCurr)
    <=> ( v112914(VarCurr,2)
        | v114441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12125,axiom,
    ! [VarCurr: state_type] :
      ( v114441(VarCurr)
    <=> ( v114442(VarCurr)
        & v114445(VarCurr) ) ) ).

tff(writeUnaryOperator_6516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114445(VarCurr)
    <=> v112914(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4843,axiom,
    ! [VarCurr: state_type] :
      ( v114442(VarCurr)
    <=> ( v112914(VarCurr,1)
        | v114443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12124,axiom,
    ! [VarCurr: state_type] :
      ( v114443(VarCurr)
    <=> ( v112914(VarCurr,0)
        & v114444(VarCurr) ) ) ).

tff(writeUnaryOperator_6515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114444(VarCurr)
    <=> v112914(VarCurr,1) ) ).

tff(addAssignment_67736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113944(VarCurr,B)
      <=> v113946(VarCurr,B) ) ) ).

tff(addAssignment_67735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113946(VarCurr,B)
      <=> v113948(VarCurr,B) ) ) ).

tff(addAssignment_67734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113948(VarCurr,B)
      <=> v113950(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114414(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v113950(VarNext,B)
            <=> v113950(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1492,axiom,
    ! [VarNext: state_type] :
      ( v114414(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113950(VarNext,B)
          <=> v114424(VarNext,B) ) ) ) ).

tff(addAssignment_67733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114424(VarNext,B)
          <=> v114422(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114425(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114422(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1018,axiom,
    ! [VarCurr: state_type] :
      ( v114425(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v114422(VarCurr,B)
          <=> v113960(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12123,axiom,
    ! [VarCurr: state_type] :
      ( v114425(VarCurr)
    <=> ( v114426(VarCurr)
        & v114427(VarCurr) ) ) ).

tff(writeUnaryOperator_6514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114427(VarCurr)
    <=> v113956(VarCurr) ) ).

tff(writeUnaryOperator_6513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114426(VarCurr)
    <=> v113952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114414(VarNext)
      <=> v114415(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114415(VarNext)
      <=> ( v114416(VarNext)
          & v114409(VarNext) ) ) ) ).

tff(writeUnaryOperator_6512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114416(VarNext)
      <=> v114418(VarNext) ) ) ).

tff(addAssignment_67732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114418(VarNext)
      <=> v114409(VarCurr) ) ) ).

tff(addAssignment_67731,axiom,
    ! [VarCurr: state_type] :
      ( v114409(VarCurr)
    <=> v114411(VarCurr) ) ).

tff(addAssignment_67730,axiom,
    ! [VarCurr: state_type] :
      ( v114411(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113960(VarCurr,B)
      <=> v113962(VarCurr,B) ) ) ).

tff(addAssignment_67728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113962(VarCurr,B)
      <=> v113964(VarCurr,B) ) ) ).

tff(addAssignment_67727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113964(VarCurr,B)
      <=> v113966(VarCurr,B) ) ) ).

tff(addAssignment_67726,axiom,
    ! [VarCurr: state_type] :
      ( v113966(VarCurr,0)
    <=> v114403(VarCurr) ) ).

tff(addAssignment_67725,axiom,
    ! [VarCurr: state_type] :
      ( v113966(VarCurr,1)
    <=> v114398(VarCurr) ) ).

tff(addAssignment_67724,axiom,
    ! [VarCurr: state_type] :
      ( v113966(VarCurr,2)
    <=> v114393(VarCurr) ) ).

tff(addAssignment_67723,axiom,
    ! [VarCurr: state_type] :
      ( v113966(VarCurr,3)
    <=> v114388(VarCurr) ) ).

tff(addAssignment_67722,axiom,
    ! [VarCurr: state_type] :
      ( v113966(VarCurr,4)
    <=> v114148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12120,axiom,
    ! [VarCurr: state_type] :
      ( v114403(VarCurr)
    <=> ( v114404(VarCurr)
        & v114407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12119,axiom,
    ! [VarCurr: state_type] :
      ( v114407(VarCurr)
    <=> ( v114158(VarCurr,0)
        | v114276(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12118,axiom,
    ! [VarCurr: state_type] :
      ( v114404(VarCurr)
    <=> ( v114405(VarCurr)
        | v114406(VarCurr) ) ) ).

tff(writeUnaryOperator_6511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114406(VarCurr)
    <=> v114276(VarCurr,0) ) ).

tff(writeUnaryOperator_6510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114405(VarCurr)
    <=> v114158(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12117,axiom,
    ! [VarCurr: state_type] :
      ( v114398(VarCurr)
    <=> ( v114399(VarCurr)
        & v114402(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12116,axiom,
    ! [VarCurr: state_type] :
      ( v114402(VarCurr)
    <=> ( v114157(VarCurr)
        | v114363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12115,axiom,
    ! [VarCurr: state_type] :
      ( v114399(VarCurr)
    <=> ( v114400(VarCurr)
        | v114401(VarCurr) ) ) ).

tff(writeUnaryOperator_6509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114401(VarCurr)
    <=> v114363(VarCurr) ) ).

tff(writeUnaryOperator_6508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114400(VarCurr)
    <=> v114157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12114,axiom,
    ! [VarCurr: state_type] :
      ( v114393(VarCurr)
    <=> ( v114394(VarCurr)
        & v114397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12113,axiom,
    ! [VarCurr: state_type] :
      ( v114397(VarCurr)
    <=> ( v114155(VarCurr)
        | v114369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12112,axiom,
    ! [VarCurr: state_type] :
      ( v114394(VarCurr)
    <=> ( v114395(VarCurr)
        | v114396(VarCurr) ) ) ).

tff(writeUnaryOperator_6507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114396(VarCurr)
    <=> v114369(VarCurr) ) ).

tff(writeUnaryOperator_6506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114395(VarCurr)
    <=> v114155(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12111,axiom,
    ! [VarCurr: state_type] :
      ( v114388(VarCurr)
    <=> ( v114389(VarCurr)
        & v114392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12110,axiom,
    ! [VarCurr: state_type] :
      ( v114392(VarCurr)
    <=> ( v114153(VarCurr)
        | v114375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12109,axiom,
    ! [VarCurr: state_type] :
      ( v114389(VarCurr)
    <=> ( v114390(VarCurr)
        | v114391(VarCurr) ) ) ).

tff(writeUnaryOperator_6505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114391(VarCurr)
    <=> v114375(VarCurr) ) ).

tff(writeUnaryOperator_6504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114390(VarCurr)
    <=> v114153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12108,axiom,
    ! [VarCurr: state_type] :
      ( v114148(VarCurr)
    <=> ( v114149(VarCurr)
        & v114387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12107,axiom,
    ! [VarCurr: state_type] :
      ( v114387(VarCurr)
    <=> ( v114151(VarCurr)
        | v114382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12106,axiom,
    ! [VarCurr: state_type] :
      ( v114149(VarCurr)
    <=> ( v114150(VarCurr)
        | v114381(VarCurr) ) ) ).

tff(writeUnaryOperator_6503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114381(VarCurr)
    <=> v114382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12105,axiom,
    ! [VarCurr: state_type] :
      ( v114382(VarCurr)
    <=> ( v114383(VarCurr)
        & v114386(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4842,axiom,
    ! [VarCurr: state_type] :
      ( v114386(VarCurr)
    <=> ( v114158(VarCurr,4)
        | v114276(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12104,axiom,
    ! [VarCurr: state_type] :
      ( v114383(VarCurr)
    <=> ( v114384(VarCurr)
        | v114385(VarCurr) ) ) ).

tff(writeUnaryOperator_6502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114385(VarCurr)
    <=> v114276(VarCurr,4) ) ).

tff(writeUnaryOperator_6501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114384(VarCurr)
    <=> v114158(VarCurr,4) ) ).

tff(writeUnaryOperator_6500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114150(VarCurr)
    <=> v114151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12103,axiom,
    ! [VarCurr: state_type] :
      ( v114151(VarCurr)
    <=> ( v114152(VarCurr)
        | v114380(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4841,axiom,
    ! [VarCurr: state_type] :
      ( v114380(VarCurr)
    <=> ( v114158(VarCurr,3)
        & v114276(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12102,axiom,
    ! [VarCurr: state_type] :
      ( v114152(VarCurr)
    <=> ( v114153(VarCurr)
        & v114375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12101,axiom,
    ! [VarCurr: state_type] :
      ( v114375(VarCurr)
    <=> ( v114376(VarCurr)
        & v114379(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4840,axiom,
    ! [VarCurr: state_type] :
      ( v114379(VarCurr)
    <=> ( v114158(VarCurr,3)
        | v114276(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12100,axiom,
    ! [VarCurr: state_type] :
      ( v114376(VarCurr)
    <=> ( v114377(VarCurr)
        | v114378(VarCurr) ) ) ).

tff(writeUnaryOperator_6499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114378(VarCurr)
    <=> v114276(VarCurr,3) ) ).

tff(writeUnaryOperator_6498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114377(VarCurr)
    <=> v114158(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12099,axiom,
    ! [VarCurr: state_type] :
      ( v114153(VarCurr)
    <=> ( v114154(VarCurr)
        | v114374(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4839,axiom,
    ! [VarCurr: state_type] :
      ( v114374(VarCurr)
    <=> ( v114158(VarCurr,2)
        & v114276(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12098,axiom,
    ! [VarCurr: state_type] :
      ( v114154(VarCurr)
    <=> ( v114155(VarCurr)
        & v114369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12097,axiom,
    ! [VarCurr: state_type] :
      ( v114369(VarCurr)
    <=> ( v114370(VarCurr)
        & v114373(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4838,axiom,
    ! [VarCurr: state_type] :
      ( v114373(VarCurr)
    <=> ( v114158(VarCurr,2)
        | v114276(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12096,axiom,
    ! [VarCurr: state_type] :
      ( v114370(VarCurr)
    <=> ( v114371(VarCurr)
        | v114372(VarCurr) ) ) ).

tff(writeUnaryOperator_6497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114372(VarCurr)
    <=> v114276(VarCurr,2) ) ).

tff(writeUnaryOperator_6496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114371(VarCurr)
    <=> v114158(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12095,axiom,
    ! [VarCurr: state_type] :
      ( v114155(VarCurr)
    <=> ( v114156(VarCurr)
        | v114368(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4837,axiom,
    ! [VarCurr: state_type] :
      ( v114368(VarCurr)
    <=> ( v114158(VarCurr,1)
        & v114276(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12094,axiom,
    ! [VarCurr: state_type] :
      ( v114156(VarCurr)
    <=> ( v114157(VarCurr)
        & v114363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12093,axiom,
    ! [VarCurr: state_type] :
      ( v114363(VarCurr)
    <=> ( v114364(VarCurr)
        & v114367(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4836,axiom,
    ! [VarCurr: state_type] :
      ( v114367(VarCurr)
    <=> ( v114158(VarCurr,1)
        | v114276(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12092,axiom,
    ! [VarCurr: state_type] :
      ( v114364(VarCurr)
    <=> ( v114365(VarCurr)
        | v114366(VarCurr) ) ) ).

tff(writeUnaryOperator_6495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114366(VarCurr)
    <=> v114276(VarCurr,1) ) ).

tff(writeUnaryOperator_6494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114365(VarCurr)
    <=> v114158(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12091,axiom,
    ! [VarCurr: state_type] :
      ( v114157(VarCurr)
    <=> ( v114158(VarCurr,0)
        & v114276(VarCurr,0) ) ) ).

tff(addAssignment_67721,axiom,
    ! [VarCurr: state_type] :
      ( v114276(VarCurr,0)
    <=> v114361(VarCurr) ) ).

tff(addAssignment_67720,axiom,
    ! [VarCurr: state_type] :
      ( v114276(VarCurr,1)
    <=> v114359(VarCurr) ) ).

tff(addAssignment_67719,axiom,
    ! [VarCurr: state_type] :
      ( v114276(VarCurr,2)
    <=> v114355(VarCurr) ) ).

tff(addAssignment_67718,axiom,
    ! [VarCurr: state_type] :
      ( v114276(VarCurr,3)
    <=> v114351(VarCurr) ) ).

tff(addAssignment_67717,axiom,
    ! [VarCurr: state_type] :
      ( v114276(VarCurr,4)
    <=> v114278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12090,axiom,
    ! [VarCurr: state_type] :
      ( v114359(VarCurr)
    <=> ( v114360(VarCurr)
        & v114362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12089,axiom,
    ! [VarCurr: state_type] :
      ( v114362(VarCurr)
    <=> ( v114282(VarCurr,0)
        | v114346(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4835,axiom,
    ! [VarCurr: state_type] :
      ( v114360(VarCurr)
    <=> ( v114361(VarCurr)
        | v114282(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114361(VarCurr)
    <=> v114282(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12088,axiom,
    ! [VarCurr: state_type] :
      ( v114355(VarCurr)
    <=> ( v114356(VarCurr)
        & v114358(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12087,axiom,
    ! [VarCurr: state_type] :
      ( v114358(VarCurr)
    <=> ( v114344(VarCurr)
        | v114347(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4834,axiom,
    ! [VarCurr: state_type] :
      ( v114356(VarCurr)
    <=> ( v114357(VarCurr)
        | v114282(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114357(VarCurr)
    <=> v114344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12086,axiom,
    ! [VarCurr: state_type] :
      ( v114351(VarCurr)
    <=> ( v114352(VarCurr)
        & v114354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12085,axiom,
    ! [VarCurr: state_type] :
      ( v114354(VarCurr)
    <=> ( v114342(VarCurr)
        | v114348(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4833,axiom,
    ! [VarCurr: state_type] :
      ( v114352(VarCurr)
    <=> ( v114353(VarCurr)
        | v114282(VarCurr,3) ) ) ).

tff(writeUnaryOperator_6491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114353(VarCurr)
    <=> v114342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12084,axiom,
    ! [VarCurr: state_type] :
      ( v114278(VarCurr)
    <=> ( v114279(VarCurr)
        & v114349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12083,axiom,
    ! [VarCurr: state_type] :
      ( v114349(VarCurr)
    <=> ( v114281(VarCurr)
        | v114350(VarCurr) ) ) ).

tff(writeUnaryOperator_6490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114350(VarCurr)
    <=> v114282(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4832,axiom,
    ! [VarCurr: state_type] :
      ( v114279(VarCurr)
    <=> ( v114280(VarCurr)
        | v114282(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114280(VarCurr)
    <=> v114281(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4831,axiom,
    ! [VarCurr: state_type] :
      ( v114281(VarCurr)
    <=> ( v114282(VarCurr,3)
        | v114341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12082,axiom,
    ! [VarCurr: state_type] :
      ( v114341(VarCurr)
    <=> ( v114342(VarCurr)
        & v114348(VarCurr) ) ) ).

tff(writeUnaryOperator_6488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114348(VarCurr)
    <=> v114282(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4830,axiom,
    ! [VarCurr: state_type] :
      ( v114342(VarCurr)
    <=> ( v114282(VarCurr,2)
        | v114343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12081,axiom,
    ! [VarCurr: state_type] :
      ( v114343(VarCurr)
    <=> ( v114344(VarCurr)
        & v114347(VarCurr) ) ) ).

tff(writeUnaryOperator_6487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114347(VarCurr)
    <=> v114282(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4829,axiom,
    ! [VarCurr: state_type] :
      ( v114344(VarCurr)
    <=> ( v114282(VarCurr,1)
        | v114345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12080,axiom,
    ! [VarCurr: state_type] :
      ( v114345(VarCurr)
    <=> ( v114282(VarCurr,0)
        & v114346(VarCurr) ) ) ).

tff(writeUnaryOperator_6486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114346(VarCurr)
    <=> v114282(VarCurr,1) ) ).

tff(addAssignment_67716,axiom,
    ! [VarCurr: state_type] :
      ( v114282(VarCurr,0)
    <=> v114336(VarCurr) ) ).

tff(addAssignment_67715,axiom,
    ! [VarCurr: state_type] :
      ( v114282(VarCurr,1)
    <=> v114331(VarCurr) ) ).

tff(addAssignment_67714,axiom,
    ! [VarCurr: state_type] :
      ( v114282(VarCurr,2)
    <=> v114326(VarCurr) ) ).

tff(addAssignment_67713,axiom,
    ! [VarCurr: state_type] :
      ( v114282(VarCurr,3)
    <=> v114321(VarCurr) ) ).

tff(addAssignment_67712,axiom,
    ! [VarCurr: state_type] :
      ( v114282(VarCurr,4)
    <=> v114284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12079,axiom,
    ! [VarCurr: state_type] :
      ( v114336(VarCurr)
    <=> ( v114337(VarCurr)
        & v114340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12078,axiom,
    ! [VarCurr: state_type] :
      ( v114340(VarCurr)
    <=> ( v114294(VarCurr,0)
        | v114295(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12077,axiom,
    ! [VarCurr: state_type] :
      ( v114337(VarCurr)
    <=> ( v114338(VarCurr)
        | v114339(VarCurr) ) ) ).

tff(writeUnaryOperator_6485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114339(VarCurr)
    <=> v114295(VarCurr,0) ) ).

tff(writeUnaryOperator_6484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114338(VarCurr)
    <=> v114294(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12076,axiom,
    ! [VarCurr: state_type] :
      ( v114331(VarCurr)
    <=> ( v114332(VarCurr)
        & v114335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12075,axiom,
    ! [VarCurr: state_type] :
      ( v114335(VarCurr)
    <=> ( v114293(VarCurr)
        | v114296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12074,axiom,
    ! [VarCurr: state_type] :
      ( v114332(VarCurr)
    <=> ( v114333(VarCurr)
        | v114334(VarCurr) ) ) ).

tff(writeUnaryOperator_6483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114334(VarCurr)
    <=> v114296(VarCurr) ) ).

tff(writeUnaryOperator_6482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114333(VarCurr)
    <=> v114293(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12073,axiom,
    ! [VarCurr: state_type] :
      ( v114326(VarCurr)
    <=> ( v114327(VarCurr)
        & v114330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12072,axiom,
    ! [VarCurr: state_type] :
      ( v114330(VarCurr)
    <=> ( v114291(VarCurr)
        | v114302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12071,axiom,
    ! [VarCurr: state_type] :
      ( v114327(VarCurr)
    <=> ( v114328(VarCurr)
        | v114329(VarCurr) ) ) ).

tff(writeUnaryOperator_6481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114329(VarCurr)
    <=> v114302(VarCurr) ) ).

tff(writeUnaryOperator_6480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114328(VarCurr)
    <=> v114291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12070,axiom,
    ! [VarCurr: state_type] :
      ( v114321(VarCurr)
    <=> ( v114322(VarCurr)
        & v114325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12069,axiom,
    ! [VarCurr: state_type] :
      ( v114325(VarCurr)
    <=> ( v114289(VarCurr)
        | v114308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12068,axiom,
    ! [VarCurr: state_type] :
      ( v114322(VarCurr)
    <=> ( v114323(VarCurr)
        | v114324(VarCurr) ) ) ).

tff(writeUnaryOperator_6479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114324(VarCurr)
    <=> v114308(VarCurr) ) ).

tff(writeUnaryOperator_6478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114323(VarCurr)
    <=> v114289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12067,axiom,
    ! [VarCurr: state_type] :
      ( v114284(VarCurr)
    <=> ( v114285(VarCurr)
        & v114320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12066,axiom,
    ! [VarCurr: state_type] :
      ( v114320(VarCurr)
    <=> ( v114287(VarCurr)
        | v114315(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12065,axiom,
    ! [VarCurr: state_type] :
      ( v114285(VarCurr)
    <=> ( v114286(VarCurr)
        | v114314(VarCurr) ) ) ).

tff(writeUnaryOperator_6477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114314(VarCurr)
    <=> v114315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12064,axiom,
    ! [VarCurr: state_type] :
      ( v114315(VarCurr)
    <=> ( v114316(VarCurr)
        & v114319(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4828,axiom,
    ! [VarCurr: state_type] :
      ( v114319(VarCurr)
    <=> ( v114294(VarCurr,4)
        | v114295(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12063,axiom,
    ! [VarCurr: state_type] :
      ( v114316(VarCurr)
    <=> ( v114317(VarCurr)
        | v114318(VarCurr) ) ) ).

tff(writeUnaryOperator_6476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114318(VarCurr)
    <=> v114295(VarCurr,4) ) ).

tff(writeUnaryOperator_6475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114317(VarCurr)
    <=> v114294(VarCurr,4) ) ).

tff(writeUnaryOperator_6474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114286(VarCurr)
    <=> v114287(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12062,axiom,
    ! [VarCurr: state_type] :
      ( v114287(VarCurr)
    <=> ( v114288(VarCurr)
        | v114313(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4827,axiom,
    ! [VarCurr: state_type] :
      ( v114313(VarCurr)
    <=> ( v114294(VarCurr,3)
        & v114295(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12061,axiom,
    ! [VarCurr: state_type] :
      ( v114288(VarCurr)
    <=> ( v114289(VarCurr)
        & v114308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12060,axiom,
    ! [VarCurr: state_type] :
      ( v114308(VarCurr)
    <=> ( v114309(VarCurr)
        & v114312(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4826,axiom,
    ! [VarCurr: state_type] :
      ( v114312(VarCurr)
    <=> ( v114294(VarCurr,3)
        | v114295(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12059,axiom,
    ! [VarCurr: state_type] :
      ( v114309(VarCurr)
    <=> ( v114310(VarCurr)
        | v114311(VarCurr) ) ) ).

tff(writeUnaryOperator_6473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114311(VarCurr)
    <=> v114295(VarCurr,3) ) ).

tff(writeUnaryOperator_6472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114310(VarCurr)
    <=> v114294(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12058,axiom,
    ! [VarCurr: state_type] :
      ( v114289(VarCurr)
    <=> ( v114290(VarCurr)
        | v114307(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4825,axiom,
    ! [VarCurr: state_type] :
      ( v114307(VarCurr)
    <=> ( v114294(VarCurr,2)
        & v114295(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12057,axiom,
    ! [VarCurr: state_type] :
      ( v114290(VarCurr)
    <=> ( v114291(VarCurr)
        & v114302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12056,axiom,
    ! [VarCurr: state_type] :
      ( v114302(VarCurr)
    <=> ( v114303(VarCurr)
        & v114306(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4824,axiom,
    ! [VarCurr: state_type] :
      ( v114306(VarCurr)
    <=> ( v114294(VarCurr,2)
        | v114295(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12055,axiom,
    ! [VarCurr: state_type] :
      ( v114303(VarCurr)
    <=> ( v114304(VarCurr)
        | v114305(VarCurr) ) ) ).

tff(writeUnaryOperator_6471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114305(VarCurr)
    <=> v114295(VarCurr,2) ) ).

tff(writeUnaryOperator_6470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114304(VarCurr)
    <=> v114294(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12054,axiom,
    ! [VarCurr: state_type] :
      ( v114291(VarCurr)
    <=> ( v114292(VarCurr)
        | v114301(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4823,axiom,
    ! [VarCurr: state_type] :
      ( v114301(VarCurr)
    <=> ( v114294(VarCurr,1)
        & v114295(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12053,axiom,
    ! [VarCurr: state_type] :
      ( v114292(VarCurr)
    <=> ( v114293(VarCurr)
        & v114296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12052,axiom,
    ! [VarCurr: state_type] :
      ( v114296(VarCurr)
    <=> ( v114297(VarCurr)
        & v114300(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4822,axiom,
    ! [VarCurr: state_type] :
      ( v114300(VarCurr)
    <=> ( v114294(VarCurr,1)
        | v114295(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12051,axiom,
    ! [VarCurr: state_type] :
      ( v114297(VarCurr)
    <=> ( v114298(VarCurr)
        | v114299(VarCurr) ) ) ).

tff(writeUnaryOperator_6469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114299(VarCurr)
    <=> v114295(VarCurr,1) ) ).

tff(writeUnaryOperator_6468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114298(VarCurr)
    <=> v114294(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12050,axiom,
    ! [VarCurr: state_type] :
      ( v114293(VarCurr)
    <=> ( v114294(VarCurr,0)
        & v114295(VarCurr,0) ) ) ).

tff(addAssignment_67711,axiom,
    ! [VarCurr: state_type] :
      ( ( v114295(VarCurr,2)
      <=> v113180(VarCurr,5) )
      & ( v114295(VarCurr,1)
      <=> v113180(VarCurr,4) )
      & ( v114295(VarCurr,0)
      <=> v113180(VarCurr,3) ) ) ).

tff(addAssignment_67710,axiom,
    ! [VarCurr: state_type] :
      ( ( v114295(VarCurr,4)
      <=> $false )
      & ( v114295(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_67709,axiom,
    ! [VarCurr: state_type] :
      ( ( v114294(VarCurr,2)
      <=> v114061(VarCurr,6) )
      & ( v114294(VarCurr,1)
      <=> v114061(VarCurr,5) )
      & ( v114294(VarCurr,0)
      <=> v114061(VarCurr,4) ) ) ).

tff(addAssignment_67708,axiom,
    ! [VarCurr: state_type] :
      ( ( v114294(VarCurr,4)
      <=> $false )
      & ( v114294(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_67707,axiom,
    ! [VarCurr: state_type] :
      ( v114158(VarCurr,0)
    <=> v114271(VarCurr) ) ).

tff(addAssignment_67706,axiom,
    ! [VarCurr: state_type] :
      ( v114158(VarCurr,1)
    <=> v114266(VarCurr) ) ).

tff(addAssignment_67705,axiom,
    ! [VarCurr: state_type] :
      ( v114158(VarCurr,2)
    <=> v114261(VarCurr) ) ).

tff(addAssignment_67704,axiom,
    ! [VarCurr: state_type] :
      ( v114158(VarCurr,3)
    <=> v114256(VarCurr) ) ).

tff(addAssignment_67703,axiom,
    ! [VarCurr: state_type] :
      ( v114158(VarCurr,4)
    <=> v114160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12049,axiom,
    ! [VarCurr: state_type] :
      ( v114271(VarCurr)
    <=> ( v114272(VarCurr)
        & v114275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12048,axiom,
    ! [VarCurr: state_type] :
      ( v114275(VarCurr)
    <=> ( v114170(VarCurr,0)
        | v114230(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12047,axiom,
    ! [VarCurr: state_type] :
      ( v114272(VarCurr)
    <=> ( v114273(VarCurr)
        | v114274(VarCurr) ) ) ).

tff(writeUnaryOperator_6467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114274(VarCurr)
    <=> v114230(VarCurr,0) ) ).

tff(writeUnaryOperator_6466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114273(VarCurr)
    <=> v114170(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12046,axiom,
    ! [VarCurr: state_type] :
      ( v114266(VarCurr)
    <=> ( v114267(VarCurr)
        & v114270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12045,axiom,
    ! [VarCurr: state_type] :
      ( v114270(VarCurr)
    <=> ( v114169(VarCurr)
        | v114231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12044,axiom,
    ! [VarCurr: state_type] :
      ( v114267(VarCurr)
    <=> ( v114268(VarCurr)
        | v114269(VarCurr) ) ) ).

tff(writeUnaryOperator_6465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114269(VarCurr)
    <=> v114231(VarCurr) ) ).

tff(writeUnaryOperator_6464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114268(VarCurr)
    <=> v114169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12043,axiom,
    ! [VarCurr: state_type] :
      ( v114261(VarCurr)
    <=> ( v114262(VarCurr)
        & v114265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12042,axiom,
    ! [VarCurr: state_type] :
      ( v114265(VarCurr)
    <=> ( v114167(VarCurr)
        | v114237(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12041,axiom,
    ! [VarCurr: state_type] :
      ( v114262(VarCurr)
    <=> ( v114263(VarCurr)
        | v114264(VarCurr) ) ) ).

tff(writeUnaryOperator_6463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114264(VarCurr)
    <=> v114237(VarCurr) ) ).

tff(writeUnaryOperator_6462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114263(VarCurr)
    <=> v114167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12040,axiom,
    ! [VarCurr: state_type] :
      ( v114256(VarCurr)
    <=> ( v114257(VarCurr)
        & v114260(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12039,axiom,
    ! [VarCurr: state_type] :
      ( v114260(VarCurr)
    <=> ( v114165(VarCurr)
        | v114243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12038,axiom,
    ! [VarCurr: state_type] :
      ( v114257(VarCurr)
    <=> ( v114258(VarCurr)
        | v114259(VarCurr) ) ) ).

tff(writeUnaryOperator_6461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114259(VarCurr)
    <=> v114243(VarCurr) ) ).

tff(writeUnaryOperator_6460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114258(VarCurr)
    <=> v114165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12037,axiom,
    ! [VarCurr: state_type] :
      ( v114160(VarCurr)
    <=> ( v114161(VarCurr)
        & v114255(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12036,axiom,
    ! [VarCurr: state_type] :
      ( v114255(VarCurr)
    <=> ( v114163(VarCurr)
        | v114250(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12035,axiom,
    ! [VarCurr: state_type] :
      ( v114161(VarCurr)
    <=> ( v114162(VarCurr)
        | v114249(VarCurr) ) ) ).

tff(writeUnaryOperator_6459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114249(VarCurr)
    <=> v114250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12034,axiom,
    ! [VarCurr: state_type] :
      ( v114250(VarCurr)
    <=> ( v114251(VarCurr)
        & v114254(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4821,axiom,
    ! [VarCurr: state_type] :
      ( v114254(VarCurr)
    <=> ( v114170(VarCurr,4)
        | v114230(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12033,axiom,
    ! [VarCurr: state_type] :
      ( v114251(VarCurr)
    <=> ( v114252(VarCurr)
        | v114253(VarCurr) ) ) ).

tff(writeUnaryOperator_6458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114253(VarCurr)
    <=> v114230(VarCurr,4) ) ).

tff(writeUnaryOperator_6457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114252(VarCurr)
    <=> v114170(VarCurr,4) ) ).

tff(writeUnaryOperator_6456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114162(VarCurr)
    <=> v114163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12032,axiom,
    ! [VarCurr: state_type] :
      ( v114163(VarCurr)
    <=> ( v114164(VarCurr)
        | v114248(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4820,axiom,
    ! [VarCurr: state_type] :
      ( v114248(VarCurr)
    <=> ( v114170(VarCurr,3)
        & v114230(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12031,axiom,
    ! [VarCurr: state_type] :
      ( v114164(VarCurr)
    <=> ( v114165(VarCurr)
        & v114243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12030,axiom,
    ! [VarCurr: state_type] :
      ( v114243(VarCurr)
    <=> ( v114244(VarCurr)
        & v114247(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4819,axiom,
    ! [VarCurr: state_type] :
      ( v114247(VarCurr)
    <=> ( v114170(VarCurr,3)
        | v114230(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12029,axiom,
    ! [VarCurr: state_type] :
      ( v114244(VarCurr)
    <=> ( v114245(VarCurr)
        | v114246(VarCurr) ) ) ).

tff(writeUnaryOperator_6455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114246(VarCurr)
    <=> v114230(VarCurr,3) ) ).

tff(writeUnaryOperator_6454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114245(VarCurr)
    <=> v114170(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12028,axiom,
    ! [VarCurr: state_type] :
      ( v114165(VarCurr)
    <=> ( v114166(VarCurr)
        | v114242(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4818,axiom,
    ! [VarCurr: state_type] :
      ( v114242(VarCurr)
    <=> ( v114170(VarCurr,2)
        & v114230(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12027,axiom,
    ! [VarCurr: state_type] :
      ( v114166(VarCurr)
    <=> ( v114167(VarCurr)
        & v114237(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12026,axiom,
    ! [VarCurr: state_type] :
      ( v114237(VarCurr)
    <=> ( v114238(VarCurr)
        & v114241(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4817,axiom,
    ! [VarCurr: state_type] :
      ( v114241(VarCurr)
    <=> ( v114170(VarCurr,2)
        | v114230(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12025,axiom,
    ! [VarCurr: state_type] :
      ( v114238(VarCurr)
    <=> ( v114239(VarCurr)
        | v114240(VarCurr) ) ) ).

tff(writeUnaryOperator_6453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114240(VarCurr)
    <=> v114230(VarCurr,2) ) ).

tff(writeUnaryOperator_6452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114239(VarCurr)
    <=> v114170(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12024,axiom,
    ! [VarCurr: state_type] :
      ( v114167(VarCurr)
    <=> ( v114168(VarCurr)
        | v114236(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4816,axiom,
    ! [VarCurr: state_type] :
      ( v114236(VarCurr)
    <=> ( v114170(VarCurr,1)
        & v114230(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12023,axiom,
    ! [VarCurr: state_type] :
      ( v114168(VarCurr)
    <=> ( v114169(VarCurr)
        & v114231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12022,axiom,
    ! [VarCurr: state_type] :
      ( v114231(VarCurr)
    <=> ( v114232(VarCurr)
        & v114235(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4815,axiom,
    ! [VarCurr: state_type] :
      ( v114235(VarCurr)
    <=> ( v114170(VarCurr,1)
        | v114230(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12021,axiom,
    ! [VarCurr: state_type] :
      ( v114232(VarCurr)
    <=> ( v114233(VarCurr)
        | v114234(VarCurr) ) ) ).

tff(writeUnaryOperator_6451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114234(VarCurr)
    <=> v114230(VarCurr,1) ) ).

tff(writeUnaryOperator_6450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114233(VarCurr)
    <=> v114170(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12020,axiom,
    ! [VarCurr: state_type] :
      ( v114169(VarCurr)
    <=> ( v114170(VarCurr,0)
        & v114230(VarCurr,0) ) ) ).

tff(addAssignment_67702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114230(VarCurr,B)
      <=> v113968(VarCurr,B) ) ) ).

tff(addAssignment_67701,axiom,
    ! [VarCurr: state_type] :
      ( v114230(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_67700,axiom,
    ! [VarCurr: state_type] :
      ( v114170(VarCurr,0)
    <=> v114225(VarCurr) ) ).

tff(addAssignment_67699,axiom,
    ! [VarCurr: state_type] :
      ( v114170(VarCurr,1)
    <=> v114220(VarCurr) ) ).

tff(addAssignment_67698,axiom,
    ! [VarCurr: state_type] :
      ( v114170(VarCurr,2)
    <=> v114215(VarCurr) ) ).

tff(addAssignment_67697,axiom,
    ! [VarCurr: state_type] :
      ( v114170(VarCurr,3)
    <=> v114210(VarCurr) ) ).

tff(addAssignment_67696,axiom,
    ! [VarCurr: state_type] :
      ( v114170(VarCurr,4)
    <=> v114172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12019,axiom,
    ! [VarCurr: state_type] :
      ( v114225(VarCurr)
    <=> ( v114226(VarCurr)
        & v114229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12018,axiom,
    ! [VarCurr: state_type] :
      ( v114229(VarCurr)
    <=> ( v114182(VarCurr,0)
        | v114184(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12017,axiom,
    ! [VarCurr: state_type] :
      ( v114226(VarCurr)
    <=> ( v114227(VarCurr)
        | v114228(VarCurr) ) ) ).

tff(writeUnaryOperator_6449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114228(VarCurr)
    <=> v114184(VarCurr,0) ) ).

tff(writeUnaryOperator_6448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114227(VarCurr)
    <=> v114182(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12016,axiom,
    ! [VarCurr: state_type] :
      ( v114220(VarCurr)
    <=> ( v114221(VarCurr)
        & v114224(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12015,axiom,
    ! [VarCurr: state_type] :
      ( v114224(VarCurr)
    <=> ( v114181(VarCurr)
        | v114185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12014,axiom,
    ! [VarCurr: state_type] :
      ( v114221(VarCurr)
    <=> ( v114222(VarCurr)
        | v114223(VarCurr) ) ) ).

tff(writeUnaryOperator_6447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114223(VarCurr)
    <=> v114185(VarCurr) ) ).

tff(writeUnaryOperator_6446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114222(VarCurr)
    <=> v114181(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12013,axiom,
    ! [VarCurr: state_type] :
      ( v114215(VarCurr)
    <=> ( v114216(VarCurr)
        & v114219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12012,axiom,
    ! [VarCurr: state_type] :
      ( v114219(VarCurr)
    <=> ( v114179(VarCurr)
        | v114191(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12011,axiom,
    ! [VarCurr: state_type] :
      ( v114216(VarCurr)
    <=> ( v114217(VarCurr)
        | v114218(VarCurr) ) ) ).

tff(writeUnaryOperator_6445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114218(VarCurr)
    <=> v114191(VarCurr) ) ).

tff(writeUnaryOperator_6444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114217(VarCurr)
    <=> v114179(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12010,axiom,
    ! [VarCurr: state_type] :
      ( v114210(VarCurr)
    <=> ( v114211(VarCurr)
        & v114214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12009,axiom,
    ! [VarCurr: state_type] :
      ( v114214(VarCurr)
    <=> ( v114177(VarCurr)
        | v114197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12008,axiom,
    ! [VarCurr: state_type] :
      ( v114211(VarCurr)
    <=> ( v114212(VarCurr)
        | v114213(VarCurr) ) ) ).

tff(writeUnaryOperator_6443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114213(VarCurr)
    <=> v114197(VarCurr) ) ).

tff(writeUnaryOperator_6442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114212(VarCurr)
    <=> v114177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12007,axiom,
    ! [VarCurr: state_type] :
      ( v114172(VarCurr)
    <=> ( v114173(VarCurr)
        & v114209(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12006,axiom,
    ! [VarCurr: state_type] :
      ( v114209(VarCurr)
    <=> ( v114175(VarCurr)
        | v114204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12005,axiom,
    ! [VarCurr: state_type] :
      ( v114173(VarCurr)
    <=> ( v114174(VarCurr)
        | v114203(VarCurr) ) ) ).

tff(writeUnaryOperator_6441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114203(VarCurr)
    <=> v114204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12004,axiom,
    ! [VarCurr: state_type] :
      ( v114204(VarCurr)
    <=> ( v114205(VarCurr)
        & v114208(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4814,axiom,
    ! [VarCurr: state_type] :
      ( v114208(VarCurr)
    <=> ( v114182(VarCurr,4)
        | v114184(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12003,axiom,
    ! [VarCurr: state_type] :
      ( v114205(VarCurr)
    <=> ( v114206(VarCurr)
        | v114207(VarCurr) ) ) ).

tff(writeUnaryOperator_6440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114207(VarCurr)
    <=> v114184(VarCurr,4) ) ).

tff(writeUnaryOperator_6439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114206(VarCurr)
    <=> v114182(VarCurr,4) ) ).

tff(writeUnaryOperator_6438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114174(VarCurr)
    <=> v114175(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12002,axiom,
    ! [VarCurr: state_type] :
      ( v114175(VarCurr)
    <=> ( v114176(VarCurr)
        | v114202(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4813,axiom,
    ! [VarCurr: state_type] :
      ( v114202(VarCurr)
    <=> ( v114182(VarCurr,3)
        & v114184(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12001,axiom,
    ! [VarCurr: state_type] :
      ( v114176(VarCurr)
    <=> ( v114177(VarCurr)
        & v114197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12000,axiom,
    ! [VarCurr: state_type] :
      ( v114197(VarCurr)
    <=> ( v114198(VarCurr)
        & v114201(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4812,axiom,
    ! [VarCurr: state_type] :
      ( v114201(VarCurr)
    <=> ( v114182(VarCurr,3)
        | v114184(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11999,axiom,
    ! [VarCurr: state_type] :
      ( v114198(VarCurr)
    <=> ( v114199(VarCurr)
        | v114200(VarCurr) ) ) ).

tff(writeUnaryOperator_6437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114200(VarCurr)
    <=> v114184(VarCurr,3) ) ).

tff(writeUnaryOperator_6436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114199(VarCurr)
    <=> v114182(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11998,axiom,
    ! [VarCurr: state_type] :
      ( v114177(VarCurr)
    <=> ( v114178(VarCurr)
        | v114196(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4811,axiom,
    ! [VarCurr: state_type] :
      ( v114196(VarCurr)
    <=> ( v114182(VarCurr,2)
        & v114184(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11997,axiom,
    ! [VarCurr: state_type] :
      ( v114178(VarCurr)
    <=> ( v114179(VarCurr)
        & v114191(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11996,axiom,
    ! [VarCurr: state_type] :
      ( v114191(VarCurr)
    <=> ( v114192(VarCurr)
        & v114195(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4810,axiom,
    ! [VarCurr: state_type] :
      ( v114195(VarCurr)
    <=> ( v114182(VarCurr,2)
        | v114184(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11995,axiom,
    ! [VarCurr: state_type] :
      ( v114192(VarCurr)
    <=> ( v114193(VarCurr)
        | v114194(VarCurr) ) ) ).

tff(writeUnaryOperator_6435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114194(VarCurr)
    <=> v114184(VarCurr,2) ) ).

tff(writeUnaryOperator_6434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114193(VarCurr)
    <=> v114182(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11994,axiom,
    ! [VarCurr: state_type] :
      ( v114179(VarCurr)
    <=> ( v114180(VarCurr)
        | v114190(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4809,axiom,
    ! [VarCurr: state_type] :
      ( v114190(VarCurr)
    <=> ( v114182(VarCurr,1)
        & v114184(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11993,axiom,
    ! [VarCurr: state_type] :
      ( v114180(VarCurr)
    <=> ( v114181(VarCurr)
        & v114185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11992,axiom,
    ! [VarCurr: state_type] :
      ( v114185(VarCurr)
    <=> ( v114186(VarCurr)
        & v114189(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4808,axiom,
    ! [VarCurr: state_type] :
      ( v114189(VarCurr)
    <=> ( v114182(VarCurr,1)
        | v114184(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11991,axiom,
    ! [VarCurr: state_type] :
      ( v114186(VarCurr)
    <=> ( v114187(VarCurr)
        | v114188(VarCurr) ) ) ).

tff(writeUnaryOperator_6433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114188(VarCurr)
    <=> v114184(VarCurr,1) ) ).

tff(writeUnaryOperator_6432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114187(VarCurr)
    <=> v114182(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11990,axiom,
    ! [VarCurr: state_type] :
      ( v114181(VarCurr)
    <=> ( v114182(VarCurr,0)
        & v114184(VarCurr,0) ) ) ).

tff(addAssignment_67695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114184(VarCurr,B)
      <=> v113633(VarCurr,B) ) ) ).

tff(addAssignment_67694,axiom,
    ! [VarCurr: state_type] :
      ( v114184(VarCurr,4)
    <=> $false ) ).

tff(addZeroExtensionConstraint_49,axiom,
    ! [VarCurr: state_type] : ~ v114182(VarCurr,3) ).

tff(addZeroExtensionConstraint_48,axiom,
    ! [VarCurr: state_type] : ~ v114182(VarCurr,4) ).

tff(addAssignment_67693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114182(VarCurr,B)
      <=> v114183(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114183(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1017,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114183(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addAssignment_67692,axiom,
    ! [VarCurr: state_type] :
      ( v114061(VarCurr,6)
    <=> v114065(VarCurr,2) ) ).

tff(addAssignment_67691,axiom,
    ! [VarCurr: state_type] :
      ( v114065(VarCurr,2)
    <=> v114067(VarCurr,2) ) ).

tff(addAssignment_67690,axiom,
    ! [VarNext: state_type] :
      ( v114067(VarNext,2)
    <=> v114139(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114140(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v114139(VarNext,B)
            <=> v114067(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1491,axiom,
    ! [VarNext: state_type] :
      ( v114140(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114139(VarNext,B)
          <=> v114122(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114140(VarNext)
      <=> v114141(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114141(VarNext)
      <=> ( v114143(VarNext)
          & v114107(VarNext) ) ) ) ).

tff(writeUnaryOperator_6431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114143(VarNext)
      <=> v114116(VarNext) ) ) ).

tff(addAssignment_67689,axiom,
    ! [VarCurr: state_type] :
      ( v114077(VarCurr,2)
    <=> v114079(VarCurr,2) ) ).

tff(addAssignment_67688,axiom,
    ! [VarCurr: state_type] :
      ( v114079(VarCurr,2)
    <=> v114098(VarCurr,2) ) ).

tff(addAssignment_67687,axiom,
    ! [VarCurr: state_type] :
      ( v114081(VarCurr,2)
    <=> v114091(VarCurr,2) ) ).

tff(addAssignment_67686,axiom,
    ! [VarCurr: state_type] :
      ( v114085(VarCurr,2)
    <=> v114087(VarCurr,2) ) ).

tff(addAssignment_67685,axiom,
    ! [VarCurr: state_type] :
      ( v114061(VarCurr,5)
    <=> v114128(VarCurr,5) ) ).

tff(addAssignment_67684,axiom,
    ! [VarCurr: state_type] :
      ( v114063(VarCurr,1)
    <=> v114065(VarCurr,1) ) ).

tff(addAssignment_67683,axiom,
    ! [VarCurr: state_type] :
      ( v114065(VarCurr,1)
    <=> v114067(VarCurr,1) ) ).

tff(addAssignment_67682,axiom,
    ! [VarNext: state_type] :
      ( v114067(VarNext,1)
    <=> v114131(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114132(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v114131(VarNext,B)
            <=> v114067(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1490,axiom,
    ! [VarNext: state_type] :
      ( v114132(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114131(VarNext,B)
          <=> v114122(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114132(VarNext)
      <=> v114133(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114133(VarNext)
      <=> ( v114135(VarNext)
          & v114107(VarNext) ) ) ) ).

tff(writeUnaryOperator_6430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114135(VarNext)
      <=> v114116(VarNext) ) ) ).

tff(addAssignment_67681,axiom,
    ! [VarCurr: state_type] :
      ( v114077(VarCurr,1)
    <=> v114079(VarCurr,1) ) ).

tff(addAssignment_67680,axiom,
    ! [VarCurr: state_type] :
      ( v114079(VarCurr,1)
    <=> v114098(VarCurr,1) ) ).

tff(addAssignment_67679,axiom,
    ! [VarCurr: state_type] :
      ( v114081(VarCurr,1)
    <=> v114091(VarCurr,1) ) ).

tff(addAssignment_67678,axiom,
    ! [VarCurr: state_type] :
      ( v114083(VarCurr,1)
    <=> v114090(VarCurr,1) ) ).

tff(addAssignment_67677,axiom,
    ! [VarCurr: state_type] :
      ( v114085(VarCurr,1)
    <=> v114087(VarCurr,1) ) ).

tff(addAssignment_67676,axiom,
    ! [VarCurr: state_type] :
      ( v114061(VarCurr,4)
    <=> v114128(VarCurr,4) ) ).

tff(addAssignment_67675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114128(VarCurr,B)
      <=> b0010(B) ) ) ).

tff(addAssignment_67674,axiom,
    ! [VarCurr: state_type] :
      ( ( v114128(VarCurr,5)
      <=> v114129(VarCurr,1) )
      & ( v114128(VarCurr,4)
      <=> v114129(VarCurr,0) ) ) ).

tff(writeUnaryOperator_6429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v114129(VarCurr,B)
      <=> ~ v114063(VarCurr,B) ) ) ).

tff(addAssignment_67673,axiom,
    ! [VarCurr: state_type] :
      ( v114063(VarCurr,0)
    <=> v114065(VarCurr,0) ) ).

tff(addAssignment_67672,axiom,
    ! [VarCurr: state_type] :
      ( v114065(VarCurr,0)
    <=> v114067(VarCurr,0) ) ).

tff(addAssignment_67671,axiom,
    ! [VarNext: state_type] :
      ( v114067(VarNext,0)
    <=> v114111(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114112(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v114111(VarNext,B)
            <=> v114067(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1489,axiom,
    ! [VarNext: state_type] :
      ( v114112(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114111(VarNext,B)
          <=> v114122(VarNext,B) ) ) ) ).

tff(addAssignment_67670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114122(VarNext,B)
          <=> v114120(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114123(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114120(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1016,axiom,
    ! [VarCurr: state_type] :
      ( v114123(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114120(VarCurr,B)
          <=> v114077(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11985,axiom,
    ! [VarCurr: state_type] :
      ( v114123(VarCurr)
    <=> ( v114124(VarCurr)
        & v114125(VarCurr) ) ) ).

tff(writeUnaryOperator_6428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114125(VarCurr)
    <=> v114073(VarCurr) ) ).

tff(writeUnaryOperator_6427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114124(VarCurr)
    <=> v114069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114112(VarNext)
      <=> v114113(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114113(VarNext)
      <=> ( v114114(VarNext)
          & v114107(VarNext) ) ) ) ).

tff(writeUnaryOperator_6426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114114(VarNext)
      <=> v114116(VarNext) ) ) ).

tff(addAssignment_67669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114116(VarNext)
      <=> v114107(VarCurr) ) ) ).

tff(addAssignment_67668,axiom,
    ! [VarCurr: state_type] :
      ( v114107(VarCurr)
    <=> v114109(VarCurr) ) ).

tff(addAssignment_67667,axiom,
    ! [VarCurr: state_type] :
      ( v114109(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67666,axiom,
    ! [VarCurr: state_type] :
      ( v114077(VarCurr,0)
    <=> v114079(VarCurr,0) ) ).

tff(addAssignment_67665,axiom,
    ! [VarCurr: state_type] :
      ( v114079(VarCurr,0)
    <=> v114098(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114098(VarCurr,B)
      <=> ( v114099(VarCurr,B)
          | v114102(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114102(VarCurr,B)
      <=> ( v114065(VarCurr,B)
          & v114103(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114103(VarCurr,B)
      <=> ~ v114104(VarCurr,B) ) ) ).

tff(addAssignment_67664,axiom,
    ! [VarCurr: state_type] :
      ( v114104(VarCurr,0)
    <=> v114105(VarCurr) ) ).

tff(addAssignment_67663,axiom,
    ! [VarCurr: state_type] :
      ( v114104(VarCurr,1)
    <=> v114105(VarCurr) ) ).

tff(addAssignment_67662,axiom,
    ! [VarCurr: state_type] :
      ( v114104(VarCurr,2)
    <=> v114105(VarCurr) ) ).

tff(addAssignment_67661,axiom,
    ! [VarCurr: state_type] :
      ( v114105(VarCurr)
    <=> v114093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v114099(VarCurr,B)
      <=> ( v114081(VarCurr,B)
          & v114100(VarCurr,B) ) ) ) ).

tff(addAssignment_67660,axiom,
    ! [VarCurr: state_type] :
      ( v114100(VarCurr,0)
    <=> v114101(VarCurr) ) ).

tff(addAssignment_67659,axiom,
    ! [VarCurr: state_type] :
      ( v114100(VarCurr,1)
    <=> v114101(VarCurr) ) ).

tff(addAssignment_67658,axiom,
    ! [VarCurr: state_type] :
      ( v114100(VarCurr,2)
    <=> v114101(VarCurr) ) ).

tff(addAssignment_67657,axiom,
    ! [VarCurr: state_type] :
      ( v114101(VarCurr)
    <=> v114093(VarCurr) ) ).

tff(addAssignment_67656,axiom,
    ! [VarCurr: state_type] :
      ( v114093(VarCurr)
    <=> v114095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11982,axiom,
    ! [VarCurr: state_type] :
      ( v114095(VarCurr)
    <=> ( v1729(VarCurr)
        & v114097(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1047,axiom,
    ! [VarCurr: state_type] :
      ( v114097(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67655,axiom,
    ! [VarCurr: state_type] :
      ( v114081(VarCurr,0)
    <=> v114091(VarCurr,0) ) ).

tff(addAssignment_67654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v114091(VarCurr,B)
      <=> v114083(VarCurr,B) ) ) ).

tff(addAssignment_67653,axiom,
    ! [VarCurr: state_type] :
      ( v114091(VarCurr,2)
    <=> v114085(VarCurr,2) ) ).

tff(addAssignment_67652,axiom,
    ! [VarCurr: state_type] :
      ( v114083(VarCurr,0)
    <=> v114090(VarCurr,0) ) ).

tff(writeUnaryOperator_6424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v114090(VarCurr,B)
      <=> ~ v114085(VarCurr,B) ) ) ).

tff(addAssignment_67651,axiom,
    ! [VarCurr: state_type] :
      ( v114085(VarCurr,0)
    <=> v114087(VarCurr,0) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_32,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114088(VarCurr)
     => ( ( v114087(VarCurr,2)
        <=> v114061(VarCurr,6) )
        & ( v114087(VarCurr,1)
        <=> v114061(VarCurr,5) )
        & ( v114087(VarCurr,0)
        <=> v114061(VarCurr,4) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1015,axiom,
    ! [VarCurr: state_type] :
      ( v114088(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v114087(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11981,axiom,
    ! [VarCurr: state_type] :
      ( v114088(VarCurr)
    <=> ( v1729(VarCurr)
        & v114089(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1046,axiom,
    ! [VarCurr: state_type] :
      ( v114089(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1938,axiom,
    ~ b0000000010000(12) ).

tff(bitBlastConstant_1937,axiom,
    ~ b0000000010000(11) ).

tff(bitBlastConstant_1936,axiom,
    ~ b0000000010000(10) ).

tff(bitBlastConstant_1935,axiom,
    ~ b0000000010000(9) ).

tff(bitBlastConstant_1934,axiom,
    ~ b0000000010000(8) ).

tff(bitBlastConstant_1933,axiom,
    ~ b0000000010000(7) ).

tff(bitBlastConstant_1932,axiom,
    ~ b0000000010000(6) ).

tff(bitBlastConstant_1931,axiom,
    ~ b0000000010000(5) ).

tff(bitBlastConstant_1930,axiom,
    b0000000010000(4) ).

tff(bitBlastConstant_1929,axiom,
    ~ b0000000010000(3) ).

tff(bitBlastConstant_1928,axiom,
    ~ b0000000010000(2) ).

tff(bitBlastConstant_1927,axiom,
    ~ b0000000010000(1) ).

tff(bitBlastConstant_1926,axiom,
    ~ b0000000010000(0) ).

tff(addAssignment_67650,axiom,
    ! [VarCurr: state_type] :
      ( v114073(VarCurr)
    <=> v114075(VarCurr) ) ).

tff(addAssignment_67649,axiom,
    ! [VarCurr: state_type] :
      ( v114075(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67648,axiom,
    ! [VarCurr: state_type] :
      ( v114069(VarCurr)
    <=> v114071(VarCurr) ) ).

tff(addAssignment_67647,axiom,
    ! [VarCurr: state_type] :
      ( v114071(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_67646,axiom,
    ! [VarCurr: state_type] :
      ( v113968(VarCurr,3)
    <=> v113972(VarCurr,3) ) ).

tff(addAssignment_67645,axiom,
    ! [VarCurr: state_type] :
      ( v113972(VarCurr,3)
    <=> v113974(VarCurr,3) ) ).

tff(addAssignment_67644,axiom,
    ! [VarNext: state_type] :
      ( v113974(VarNext,3)
    <=> v114053(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114054(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v114053(VarNext,B)
            <=> v113974(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1488,axiom,
    ! [VarNext: state_type] :
      ( v114054(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114053(VarNext,B)
          <=> v114029(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114054(VarNext)
      <=> v114055(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114055(VarNext)
      <=> ( v114057(VarNext)
          & v114014(VarNext) ) ) ) ).

tff(writeUnaryOperator_6423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114057(VarNext)
      <=> v114023(VarNext) ) ) ).

tff(addAssignment_67643,axiom,
    ! [VarCurr: state_type] :
      ( v113984(VarCurr,3)
    <=> v113986(VarCurr,3) ) ).

tff(addAssignment_67642,axiom,
    ! [VarCurr: state_type] :
      ( v113986(VarCurr,3)
    <=> v114005(VarCurr,3) ) ).

tff(addAssignment_67641,axiom,
    ! [VarCurr: state_type] :
      ( v113988(VarCurr,3)
    <=> v113998(VarCurr,3) ) ).

tff(addAssignment_67640,axiom,
    ! [VarCurr: state_type] :
      ( v113992(VarCurr,3)
    <=> v113994(VarCurr,3) ) ).

tff(addAssignment_67639,axiom,
    ! [VarCurr: state_type] :
      ( v113968(VarCurr,2)
    <=> v113972(VarCurr,2) ) ).

tff(addAssignment_67638,axiom,
    ! [VarCurr: state_type] :
      ( v113972(VarCurr,2)
    <=> v113974(VarCurr,2) ) ).

tff(addAssignment_67637,axiom,
    ! [VarNext: state_type] :
      ( v113974(VarNext,2)
    <=> v114045(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114046(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v114045(VarNext,B)
            <=> v113974(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1487,axiom,
    ! [VarNext: state_type] :
      ( v114046(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114045(VarNext,B)
          <=> v114029(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114046(VarNext)
      <=> v114047(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114047(VarNext)
      <=> ( v114049(VarNext)
          & v114014(VarNext) ) ) ) ).

tff(writeUnaryOperator_6422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114049(VarNext)
      <=> v114023(VarNext) ) ) ).

tff(addAssignment_67636,axiom,
    ! [VarCurr: state_type] :
      ( v113984(VarCurr,2)
    <=> v113986(VarCurr,2) ) ).

tff(addAssignment_67635,axiom,
    ! [VarCurr: state_type] :
      ( v113986(VarCurr,2)
    <=> v114005(VarCurr,2) ) ).

tff(addAssignment_67634,axiom,
    ! [VarCurr: state_type] :
      ( v113988(VarCurr,2)
    <=> v113998(VarCurr,2) ) ).

tff(addAssignment_67633,axiom,
    ! [VarCurr: state_type] :
      ( v113992(VarCurr,2)
    <=> v113994(VarCurr,2) ) ).

tff(addAssignment_67632,axiom,
    ! [VarCurr: state_type] :
      ( v113968(VarCurr,1)
    <=> v114035(VarCurr,1) ) ).

tff(addAssignment_67631,axiom,
    ! [VarCurr: state_type] :
      ( v113970(VarCurr,1)
    <=> v113972(VarCurr,1) ) ).

tff(addAssignment_67630,axiom,
    ! [VarCurr: state_type] :
      ( v113972(VarCurr,1)
    <=> v113974(VarCurr,1) ) ).

tff(addAssignment_67629,axiom,
    ! [VarNext: state_type] :
      ( v113974(VarNext,1)
    <=> v114037(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114038(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v114037(VarNext,B)
            <=> v113974(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1486,axiom,
    ! [VarNext: state_type] :
      ( v114038(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114037(VarNext,B)
          <=> v114029(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114038(VarNext)
      <=> v114039(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114039(VarNext)
      <=> ( v114041(VarNext)
          & v114014(VarNext) ) ) ) ).

tff(writeUnaryOperator_6421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114041(VarNext)
      <=> v114023(VarNext) ) ) ).

tff(addAssignment_67628,axiom,
    ! [VarCurr: state_type] :
      ( v113984(VarCurr,1)
    <=> v113986(VarCurr,1) ) ).

tff(addAssignment_67627,axiom,
    ! [VarCurr: state_type] :
      ( v113986(VarCurr,1)
    <=> v114005(VarCurr,1) ) ).

tff(addAssignment_67626,axiom,
    ! [VarCurr: state_type] :
      ( v113988(VarCurr,1)
    <=> v113998(VarCurr,1) ) ).

tff(addAssignment_67625,axiom,
    ! [VarCurr: state_type] :
      ( v113990(VarCurr,1)
    <=> v113997(VarCurr,1) ) ).

tff(addAssignment_67624,axiom,
    ! [VarCurr: state_type] :
      ( v113992(VarCurr,1)
    <=> v113994(VarCurr,1) ) ).

tff(addAssignment_67623,axiom,
    ! [VarCurr: state_type] :
      ( v113968(VarCurr,0)
    <=> v114035(VarCurr,0) ) ).

tff(writeUnaryOperator_6420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v114035(VarCurr,B)
      <=> ~ v113970(VarCurr,B) ) ) ).

tff(addAssignment_67622,axiom,
    ! [VarCurr: state_type] :
      ( v113970(VarCurr,0)
    <=> v113972(VarCurr,0) ) ).

tff(addAssignment_67621,axiom,
    ! [VarCurr: state_type] :
      ( v113972(VarCurr,0)
    <=> v113974(VarCurr,0) ) ).

tff(addAssignment_67620,axiom,
    ! [VarNext: state_type] :
      ( v113974(VarNext,0)
    <=> v114018(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114019(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v114018(VarNext,B)
            <=> v113974(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1485,axiom,
    ! [VarNext: state_type] :
      ( v114019(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114018(VarNext,B)
          <=> v114029(VarNext,B) ) ) ) ).

tff(addAssignment_67619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114029(VarNext,B)
          <=> v114027(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114030(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114027(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1014,axiom,
    ! [VarCurr: state_type] :
      ( v114030(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v114027(VarCurr,B)
          <=> v113984(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11974,axiom,
    ! [VarCurr: state_type] :
      ( v114030(VarCurr)
    <=> ( v114031(VarCurr)
        & v114032(VarCurr) ) ) ).

tff(writeUnaryOperator_6419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114032(VarCurr)
    <=> v113980(VarCurr) ) ).

tff(writeUnaryOperator_6418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v114031(VarCurr)
    <=> v113976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114019(VarNext)
      <=> v114020(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114020(VarNext)
      <=> ( v114021(VarNext)
          & v114014(VarNext) ) ) ) ).

tff(writeUnaryOperator_6417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v114021(VarNext)
      <=> v114023(VarNext) ) ) ).

tff(addAssignment_67618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v114023(VarNext)
      <=> v114014(VarCurr) ) ) ).

tff(addAssignment_67617,axiom,
    ! [VarCurr: state_type] :
      ( v114014(VarCurr)
    <=> v114016(VarCurr) ) ).

tff(addAssignment_67616,axiom,
    ! [VarCurr: state_type] :
      ( v114016(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67615,axiom,
    ! [VarCurr: state_type] :
      ( v113984(VarCurr,0)
    <=> v113986(VarCurr,0) ) ).

tff(addAssignment_67614,axiom,
    ! [VarCurr: state_type] :
      ( v113986(VarCurr,0)
    <=> v114005(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114005(VarCurr,B)
      <=> ( v114006(VarCurr,B)
          | v114009(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114009(VarCurr,B)
      <=> ( v113972(VarCurr,B)
          & v114010(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114010(VarCurr,B)
      <=> ~ v114011(VarCurr,B) ) ) ).

tff(addAssignment_67613,axiom,
    ! [VarCurr: state_type] :
      ( v114011(VarCurr,0)
    <=> v114012(VarCurr) ) ).

tff(addAssignment_67612,axiom,
    ! [VarCurr: state_type] :
      ( v114011(VarCurr,1)
    <=> v114012(VarCurr) ) ).

tff(addAssignment_67611,axiom,
    ! [VarCurr: state_type] :
      ( v114011(VarCurr,2)
    <=> v114012(VarCurr) ) ).

tff(addAssignment_67610,axiom,
    ! [VarCurr: state_type] :
      ( v114011(VarCurr,3)
    <=> v114012(VarCurr) ) ).

tff(addAssignment_67609,axiom,
    ! [VarCurr: state_type] :
      ( v114012(VarCurr)
    <=> v114000(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v114006(VarCurr,B)
      <=> ( v113988(VarCurr,B)
          & v114007(VarCurr,B) ) ) ) ).

tff(addAssignment_67608,axiom,
    ! [VarCurr: state_type] :
      ( v114007(VarCurr,0)
    <=> v114008(VarCurr) ) ).

tff(addAssignment_67607,axiom,
    ! [VarCurr: state_type] :
      ( v114007(VarCurr,1)
    <=> v114008(VarCurr) ) ).

tff(addAssignment_67606,axiom,
    ! [VarCurr: state_type] :
      ( v114007(VarCurr,2)
    <=> v114008(VarCurr) ) ).

tff(addAssignment_67605,axiom,
    ! [VarCurr: state_type] :
      ( v114007(VarCurr,3)
    <=> v114008(VarCurr) ) ).

tff(addAssignment_67604,axiom,
    ! [VarCurr: state_type] :
      ( v114008(VarCurr)
    <=> v114000(VarCurr) ) ).

tff(addAssignment_67603,axiom,
    ! [VarCurr: state_type] :
      ( v114000(VarCurr)
    <=> v114002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11971,axiom,
    ! [VarCurr: state_type] :
      ( v114002(VarCurr)
    <=> ( v1729(VarCurr)
        & v114004(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1045,axiom,
    ! [VarCurr: state_type] :
      ( v114004(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67602,axiom,
    ! [VarCurr: state_type] :
      ( v113988(VarCurr,0)
    <=> v113998(VarCurr,0) ) ).

tff(addAssignment_67601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113998(VarCurr,B)
      <=> v113990(VarCurr,B) ) ) ).

tff(addAssignment_67600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113998(VarCurr,B)
      <=> v113992(VarCurr,B) ) ) ).

tff(addAssignment_67599,axiom,
    ! [VarCurr: state_type] :
      ( v113990(VarCurr,0)
    <=> v113997(VarCurr,0) ) ).

tff(writeUnaryOperator_6415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113997(VarCurr,B)
      <=> ~ v113992(VarCurr,B) ) ) ).

tff(addAssignment_67598,axiom,
    ! [VarCurr: state_type] :
      ( v113992(VarCurr,0)
    <=> v113994(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113994(VarCurr,B)
          <=> v113968(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1013,axiom,
    ! [VarCurr: state_type] :
      ( v113995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113994(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11970,axiom,
    ! [VarCurr: state_type] :
      ( v113995(VarCurr)
    <=> ( v1729(VarCurr)
        & v113996(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1044,axiom,
    ! [VarCurr: state_type] :
      ( v113996(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1925,axiom,
    ~ b0000011000000(12) ).

tff(bitBlastConstant_1924,axiom,
    ~ b0000011000000(11) ).

tff(bitBlastConstant_1923,axiom,
    ~ b0000011000000(10) ).

tff(bitBlastConstant_1922,axiom,
    ~ b0000011000000(9) ).

tff(bitBlastConstant_1921,axiom,
    ~ b0000011000000(8) ).

tff(bitBlastConstant_1920,axiom,
    b0000011000000(7) ).

tff(bitBlastConstant_1919,axiom,
    b0000011000000(6) ).

tff(bitBlastConstant_1918,axiom,
    ~ b0000011000000(5) ).

tff(bitBlastConstant_1917,axiom,
    ~ b0000011000000(4) ).

tff(bitBlastConstant_1916,axiom,
    ~ b0000011000000(3) ).

tff(bitBlastConstant_1915,axiom,
    ~ b0000011000000(2) ).

tff(bitBlastConstant_1914,axiom,
    ~ b0000011000000(1) ).

tff(bitBlastConstant_1913,axiom,
    ~ b0000011000000(0) ).

tff(addAssignment_67597,axiom,
    ! [VarCurr: state_type] :
      ( v113980(VarCurr)
    <=> v113982(VarCurr) ) ).

tff(addAssignment_67596,axiom,
    ! [VarCurr: state_type] :
      ( v113982(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67595,axiom,
    ! [VarCurr: state_type] :
      ( v113976(VarCurr)
    <=> v113978(VarCurr) ) ).

tff(addAssignment_67594,axiom,
    ! [VarCurr: state_type] :
      ( v113978(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_67593,axiom,
    ! [VarCurr: state_type] :
      ( v113956(VarCurr)
    <=> v113958(VarCurr) ) ).

tff(addAssignment_67592,axiom,
    ! [VarCurr: state_type] :
      ( v113958(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67591,axiom,
    ! [VarCurr: state_type] :
      ( v113952(VarCurr)
    <=> v113954(VarCurr) ) ).

tff(addAssignment_67590,axiom,
    ! [VarCurr: state_type] :
      ( v113954(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11969,axiom,
    ! [VarCurr: state_type] :
      ( v113806(VarCurr)
    <=> ( v113808(VarCurr)
        | v113909(VarCurr) ) ) ).

tff(addAssignment_67589,axiom,
    ! [VarCurr: state_type] :
      ( v113909(VarCurr)
    <=> v113911(VarCurr,0) ) ).

tff(addAssignment_67588,axiom,
    ! [VarCurr: state_type] :
      ( v113911(VarCurr,0)
    <=> v113913(VarCurr,0) ) ).

tff(addAssignment_67587,axiom,
    ! [VarCurr: state_type] :
      ( v113913(VarCurr,0)
    <=> v113915(VarCurr,0) ) ).

tff(addAssignment_67586,axiom,
    ! [VarCurr: state_type] :
      ( v113915(VarCurr,0)
    <=> v113935(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113935(VarCurr,B)
      <=> ( v113936(VarCurr,B)
          & v113917(VarCurr,B) ) ) ) ).

tff(addAssignment_67585,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,0)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67584,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,1)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67583,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,2)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67582,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,3)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67581,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,4)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67580,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,5)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67579,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,6)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67578,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,7)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67577,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,8)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67576,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,9)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67575,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,10)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67574,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,11)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67573,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,12)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67572,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,13)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67571,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,14)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67570,axiom,
    ! [VarCurr: state_type] :
      ( v113936(VarCurr,15)
    <=> v113937(VarCurr) ) ).

tff(addAssignment_67569,axiom,
    ! [VarCurr: state_type] :
      ( v113937(VarCurr)
    <=> v113938(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11968,axiom,
    ! [VarCurr: state_type] :
      ( v113938(VarCurr)
    <=> ( v100691(VarCurr)
        & v113939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11967,axiom,
    ! [VarCurr: state_type] :
      ( v113939(VarCurr)
    <=> ( v113940(VarCurr)
        | v113941(VarCurr) ) ) ).

tff(writeUnaryOperator_6414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113941(VarCurr)
    <=> v97146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11966,axiom,
    ! [VarCurr: state_type] :
      ( v113940(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v89614(VarCurr) ) ) ).

tff(addAssignment_67568,axiom,
    ! [VarCurr: state_type] :
      ( v113917(VarCurr,0)
    <=> v113918(VarCurr,0) ) ).

tff(addAssignment_67567,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,0)
    <=> v113934(VarCurr) ) ).

tff(addAssignment_67566,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,1)
    <=> v113933(VarCurr) ) ).

tff(addAssignment_67565,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,2)
    <=> v113932(VarCurr) ) ).

tff(addAssignment_67564,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,3)
    <=> v113931(VarCurr) ) ).

tff(addAssignment_67563,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,4)
    <=> v113930(VarCurr) ) ).

tff(addAssignment_67562,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,5)
    <=> v113929(VarCurr) ) ).

tff(addAssignment_67561,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,6)
    <=> v113928(VarCurr) ) ).

tff(addAssignment_67560,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,7)
    <=> v113927(VarCurr) ) ).

tff(addAssignment_67559,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,8)
    <=> v113926(VarCurr) ) ).

tff(addAssignment_67558,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,9)
    <=> v113925(VarCurr) ) ).

tff(addAssignment_67557,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,10)
    <=> v113924(VarCurr) ) ).

tff(addAssignment_67556,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,11)
    <=> v113923(VarCurr) ) ).

tff(addAssignment_67555,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,12)
    <=> v113922(VarCurr) ) ).

tff(addAssignment_67554,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,13)
    <=> v113921(VarCurr) ) ).

tff(addAssignment_67553,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,14)
    <=> v113920(VarCurr) ) ).

tff(addAssignment_67552,axiom,
    ! [VarCurr: state_type] :
      ( v113918(VarCurr,15)
    <=> v113919(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1043,axiom,
    ! [VarCurr: state_type] :
      ( v113934(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1042,axiom,
    ! [VarCurr: state_type] :
      ( v113933(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1041,axiom,
    ! [VarCurr: state_type] :
      ( v113932(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1040,axiom,
    ! [VarCurr: state_type] :
      ( v113931(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1039,axiom,
    ! [VarCurr: state_type] :
      ( v113930(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1038,axiom,
    ! [VarCurr: state_type] :
      ( v113929(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1037,axiom,
    ! [VarCurr: state_type] :
      ( v113928(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1036,axiom,
    ! [VarCurr: state_type] :
      ( v113927(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $false )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1035,axiom,
    ! [VarCurr: state_type] :
      ( v113926(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1034,axiom,
    ! [VarCurr: state_type] :
      ( v113925(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1033,axiom,
    ! [VarCurr: state_type] :
      ( v113924(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1032,axiom,
    ! [VarCurr: state_type] :
      ( v113923(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $false )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1031,axiom,
    ! [VarCurr: state_type] :
      ( v113922(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1030,axiom,
    ! [VarCurr: state_type] :
      ( v113921(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $false )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1029,axiom,
    ! [VarCurr: state_type] :
      ( v113920(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1028,axiom,
    ! [VarCurr: state_type] :
      ( v113919(VarCurr)
    <=> ( ( v97411(VarCurr,6)
        <=> $true )
        & ( v97411(VarCurr,5)
        <=> $true )
        & ( v97411(VarCurr,4)
        <=> $true )
        & ( v97411(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67551,axiom,
    ! [VarCurr: state_type] :
      ( v113808(VarCurr)
    <=> v113810(VarCurr,0) ) ).

tff(addAssignment_67550,axiom,
    ! [VarCurr: state_type] :
      ( v113810(VarCurr,0)
    <=> v113812(VarCurr,0) ) ).

tff(addAssignment_67549,axiom,
    ! [VarCurr: state_type] :
      ( v113812(VarCurr,0)
    <=> v113814(VarCurr,0) ) ).

tff(addAssignment_67548,axiom,
    ! [VarCurr: state_type] :
      ( v113814(VarCurr,0)
    <=> v113816(VarCurr,0) ) ).

tff(addAssignment_67547,axiom,
    ! [VarCurr: state_type] :
      ( v113816(VarCurr,0)
    <=> v113818(VarCurr,0) ) ).

tff(addAssignment_67546,axiom,
    ! [VarNext: state_type] :
      ( v113818(VarNext,0)
    <=> v113891(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113892(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v113891(VarNext,B)
            <=> v113818(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1484,axiom,
    ! [VarNext: state_type] :
      ( v113892(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113891(VarNext,B)
          <=> v113902(VarNext,B) ) ) ) ).

tff(addAssignment_67545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113902(VarNext,B)
          <=> v113900(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113900(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1012,axiom,
    ! [VarCurr: state_type] :
      ( v113903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113900(VarCurr,B)
          <=> v113828(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11965,axiom,
    ! [VarCurr: state_type] :
      ( v113903(VarCurr)
    <=> ( v113904(VarCurr)
        & v113905(VarCurr) ) ) ).

tff(writeUnaryOperator_6413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113905(VarCurr)
    <=> v113824(VarCurr) ) ).

tff(writeUnaryOperator_6412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113904(VarCurr)
    <=> v113820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113892(VarNext)
      <=> v113893(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113893(VarNext)
      <=> ( v113894(VarNext)
          & v113887(VarNext) ) ) ) ).

tff(writeUnaryOperator_6411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113894(VarNext)
      <=> v113896(VarNext) ) ) ).

tff(addAssignment_67544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113896(VarNext)
      <=> v113887(VarCurr) ) ) ).

tff(addAssignment_67543,axiom,
    ! [VarCurr: state_type] :
      ( v113887(VarCurr)
    <=> v113889(VarCurr) ) ).

tff(addAssignment_67542,axiom,
    ! [VarCurr: state_type] :
      ( v113889(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_67541,axiom,
    ! [VarCurr: state_type] :
      ( v113828(VarCurr,0)
    <=> v113830(VarCurr,0) ) ).

tff(addAssignment_67540,axiom,
    ! [VarCurr: state_type] :
      ( v113830(VarCurr,0)
    <=> v113832(VarCurr,0) ) ).

tff(addAssignment_67539,axiom,
    ! [VarCurr: state_type] :
      ( v113832(VarCurr,0)
    <=> v113834(VarCurr,0) ) ).

tff(addAssignment_67538,axiom,
    ! [VarCurr: state_type] :
      ( v113834(VarCurr,0)
    <=> v113873(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113873(VarCurr,B)
      <=> ( v113874(VarCurr,B)
          | v113883(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113883(VarCurr,B)
      <=> ( v113884(VarCurr,B)
          & v113855(VarCurr,B) ) ) ) ).

tff(addAssignment_67537,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,0)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67536,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,1)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67535,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,2)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67534,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,3)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67533,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,4)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67532,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,5)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67531,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,6)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67530,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,7)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67529,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,8)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67528,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,9)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67527,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,10)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67526,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,11)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67525,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,12)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67524,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,13)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67523,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,14)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67522,axiom,
    ! [VarCurr: state_type] :
      ( v113884(VarCurr,15)
    <=> v113885(VarCurr) ) ).

tff(addAssignment_67521,axiom,
    ! [VarCurr: state_type] :
      ( v113885(VarCurr)
    <=> v100203(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113874(VarCurr,B)
      <=> ( v113875(VarCurr,B)
          | v113880(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113880(VarCurr,B)
      <=> ( v113881(VarCurr,B)
          & v113836(VarCurr,B) ) ) ) ).

tff(addAssignment_67520,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,0)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67519,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,1)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67518,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,2)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67517,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,3)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67516,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,4)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67515,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,5)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67514,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,6)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67513,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,7)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67512,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,8)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67511,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,9)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67510,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,10)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67509,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,11)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67508,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,12)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67507,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,13)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67506,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,14)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67505,axiom,
    ! [VarCurr: state_type] :
      ( v113881(VarCurr,15)
    <=> v113882(VarCurr) ) ).

tff(addAssignment_67504,axiom,
    ! [VarCurr: state_type] :
      ( v113882(VarCurr)
    <=> v100203(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113875(VarCurr,B)
      <=> ( v113876(VarCurr,B)
          & v113836(VarCurr,B) ) ) ) ).

tff(addAssignment_67503,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,0)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67502,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,1)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67501,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,2)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67500,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,3)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67499,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,4)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67498,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,5)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67497,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,6)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67496,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,7)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67495,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,8)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67494,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,9)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67493,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,10)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67492,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,11)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67491,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,12)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67490,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,13)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67489,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,14)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67488,axiom,
    ! [VarCurr: state_type] :
      ( v113876(VarCurr,15)
    <=> v113877(VarCurr) ) ).

tff(addAssignment_67487,axiom,
    ! [VarCurr: state_type] :
      ( v113877(VarCurr)
    <=> v113878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11962,axiom,
    ! [VarCurr: state_type] :
      ( v113878(VarCurr)
    <=> ( v100203(VarCurr,0)
        & v113879(VarCurr) ) ) ).

tff(writeUnaryOperator_6410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113879(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_67486,axiom,
    ! [VarCurr: state_type] :
      ( v113855(VarCurr,0)
    <=> v113856(VarCurr,0) ) ).

tff(addAssignment_67485,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,0)
    <=> v113872(VarCurr) ) ).

tff(addAssignment_67484,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,1)
    <=> v113871(VarCurr) ) ).

tff(addAssignment_67483,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,2)
    <=> v113870(VarCurr) ) ).

tff(addAssignment_67482,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,3)
    <=> v113869(VarCurr) ) ).

tff(addAssignment_67481,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,4)
    <=> v113868(VarCurr) ) ).

tff(addAssignment_67480,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,5)
    <=> v113867(VarCurr) ) ).

tff(addAssignment_67479,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,6)
    <=> v113866(VarCurr) ) ).

tff(addAssignment_67478,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,7)
    <=> v113865(VarCurr) ) ).

tff(addAssignment_67477,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,8)
    <=> v113864(VarCurr) ) ).

tff(addAssignment_67476,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,9)
    <=> v113863(VarCurr) ) ).

tff(addAssignment_67475,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,10)
    <=> v113862(VarCurr) ) ).

tff(addAssignment_67474,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,11)
    <=> v113861(VarCurr) ) ).

tff(addAssignment_67473,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,12)
    <=> v113860(VarCurr) ) ).

tff(addAssignment_67472,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,13)
    <=> v113859(VarCurr) ) ).

tff(addAssignment_67471,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,14)
    <=> v113858(VarCurr) ) ).

tff(addAssignment_67470,axiom,
    ! [VarCurr: state_type] :
      ( v113856(VarCurr,15)
    <=> v113857(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1027,axiom,
    ! [VarCurr: state_type] :
      ( v113872(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1026,axiom,
    ! [VarCurr: state_type] :
      ( v113871(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1025,axiom,
    ! [VarCurr: state_type] :
      ( v113870(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1024,axiom,
    ! [VarCurr: state_type] :
      ( v113869(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1023,axiom,
    ! [VarCurr: state_type] :
      ( v113868(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1022,axiom,
    ! [VarCurr: state_type] :
      ( v113867(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1021,axiom,
    ! [VarCurr: state_type] :
      ( v113866(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1020,axiom,
    ! [VarCurr: state_type] :
      ( v113865(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1019,axiom,
    ! [VarCurr: state_type] :
      ( v113864(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1018,axiom,
    ! [VarCurr: state_type] :
      ( v113863(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1017,axiom,
    ! [VarCurr: state_type] :
      ( v113862(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1016,axiom,
    ! [VarCurr: state_type] :
      ( v113861(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1015,axiom,
    ! [VarCurr: state_type] :
      ( v113860(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1014,axiom,
    ! [VarCurr: state_type] :
      ( v113859(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1013,axiom,
    ! [VarCurr: state_type] :
      ( v113858(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1012,axiom,
    ! [VarCurr: state_type] :
      ( v113857(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67469,axiom,
    ! [VarCurr: state_type] :
      ( v113836(VarCurr,0)
    <=> v113837(VarCurr,0) ) ).

tff(addAssignment_67468,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,0)
    <=> v113853(VarCurr) ) ).

tff(addAssignment_67467,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,1)
    <=> v113852(VarCurr) ) ).

tff(addAssignment_67466,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,2)
    <=> v113851(VarCurr) ) ).

tff(addAssignment_67465,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,3)
    <=> v113850(VarCurr) ) ).

tff(addAssignment_67464,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,4)
    <=> v113849(VarCurr) ) ).

tff(addAssignment_67463,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,5)
    <=> v113848(VarCurr) ) ).

tff(addAssignment_67462,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,6)
    <=> v113847(VarCurr) ) ).

tff(addAssignment_67461,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,7)
    <=> v113846(VarCurr) ) ).

tff(addAssignment_67460,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,8)
    <=> v113845(VarCurr) ) ).

tff(addAssignment_67459,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,9)
    <=> v113844(VarCurr) ) ).

tff(addAssignment_67458,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,10)
    <=> v113843(VarCurr) ) ).

tff(addAssignment_67457,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,11)
    <=> v113842(VarCurr) ) ).

tff(addAssignment_67456,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,12)
    <=> v113841(VarCurr) ) ).

tff(addAssignment_67455,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,13)
    <=> v113840(VarCurr) ) ).

tff(addAssignment_67454,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,14)
    <=> v113839(VarCurr) ) ).

tff(addAssignment_67453,axiom,
    ! [VarCurr: state_type] :
      ( v113837(VarCurr,15)
    <=> v113838(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_1011,axiom,
    ! [VarCurr: state_type] :
      ( v113853(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1010,axiom,
    ! [VarCurr: state_type] :
      ( v113852(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1009,axiom,
    ! [VarCurr: state_type] :
      ( v113851(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1008,axiom,
    ! [VarCurr: state_type] :
      ( v113850(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1007,axiom,
    ! [VarCurr: state_type] :
      ( v113849(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1006,axiom,
    ! [VarCurr: state_type] :
      ( v113848(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1005,axiom,
    ! [VarCurr: state_type] :
      ( v113847(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1004,axiom,
    ! [VarCurr: state_type] :
      ( v113846(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $false )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1003,axiom,
    ! [VarCurr: state_type] :
      ( v113845(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1002,axiom,
    ! [VarCurr: state_type] :
      ( v113844(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1001,axiom,
    ! [VarCurr: state_type] :
      ( v113843(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_1000,axiom,
    ! [VarCurr: state_type] :
      ( v113842(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $false )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_999,axiom,
    ! [VarCurr: state_type] :
      ( v113841(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_998,axiom,
    ! [VarCurr: state_type] :
      ( v113840(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $false )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_997,axiom,
    ! [VarCurr: state_type] :
      ( v113839(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_996,axiom,
    ! [VarCurr: state_type] :
      ( v113838(VarCurr)
    <=> ( ( v100229(VarCurr,6)
        <=> $true )
        & ( v100229(VarCurr,5)
        <=> $true )
        & ( v100229(VarCurr,4)
        <=> $true )
        & ( v100229(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_67452,axiom,
    ! [VarCurr: state_type] :
      ( v113824(VarCurr)
    <=> v113826(VarCurr) ) ).

tff(addAssignment_67451,axiom,
    ! [VarCurr: state_type] :
      ( v113826(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_67450,axiom,
    ! [VarCurr: state_type] :
      ( v113820(VarCurr)
    <=> v113822(VarCurr) ) ).

tff(addAssignment_67449,axiom,
    ! [VarCurr: state_type] :
      ( v113822(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_67448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113150(VarCurr,B)
      <=> v113152(VarCurr,B) ) ) ).

tff(addAssignment_67447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113152(VarCurr,B)
      <=> v113154(VarCurr,B) ) ) ).

tff(addAssignment_67446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113154(VarCurr,B)
      <=> v113156(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113789(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v113156(VarNext,B)
            <=> v113156(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1483,axiom,
    ! [VarNext: state_type] :
      ( v113789(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113156(VarNext,B)
          <=> v113799(VarNext,B) ) ) ) ).

tff(addAssignment_67445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113799(VarNext,B)
          <=> v113797(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113797(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1011,axiom,
    ! [VarCurr: state_type] :
      ( v113800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113797(VarCurr,B)
          <=> v113166(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11961,axiom,
    ! [VarCurr: state_type] :
      ( v113800(VarCurr)
    <=> ( v113801(VarCurr)
        & v113802(VarCurr) ) ) ).

tff(writeUnaryOperator_6409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113802(VarCurr)
    <=> v113162(VarCurr) ) ).

tff(writeUnaryOperator_6408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113801(VarCurr)
    <=> v113158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113789(VarNext)
      <=> v113790(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113790(VarNext)
      <=> ( v113791(VarNext)
          & v113784(VarNext) ) ) ) ).

tff(writeUnaryOperator_6407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113791(VarNext)
      <=> v113793(VarNext) ) ) ).

tff(addAssignment_67444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113793(VarNext)
      <=> v113784(VarCurr) ) ) ).

tff(addAssignment_67443,axiom,
    ! [VarCurr: state_type] :
      ( v113784(VarCurr)
    <=> v113786(VarCurr) ) ).

tff(addAssignment_67442,axiom,
    ! [VarCurr: state_type] :
      ( v113786(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113166(VarCurr,B)
      <=> v113168(VarCurr,B) ) ) ).

tff(addAssignment_67440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113168(VarCurr,B)
      <=> v113170(VarCurr,B) ) ) ).

tff(addAssignment_67439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v113170(VarCurr,B)
      <=> v113172(VarCurr,B) ) ) ).

tff(addAssignment_67438,axiom,
    ! [VarCurr: state_type] :
      ( v113172(VarCurr,0)
    <=> v113778(VarCurr) ) ).

tff(addAssignment_67437,axiom,
    ! [VarCurr: state_type] :
      ( v113172(VarCurr,1)
    <=> v113773(VarCurr) ) ).

tff(addAssignment_67436,axiom,
    ! [VarCurr: state_type] :
      ( v113172(VarCurr,2)
    <=> v113768(VarCurr) ) ).

tff(addAssignment_67435,axiom,
    ! [VarCurr: state_type] :
      ( v113172(VarCurr,3)
    <=> v113763(VarCurr) ) ).

tff(addAssignment_67434,axiom,
    ! [VarCurr: state_type] :
      ( v113172(VarCurr,4)
    <=> v113727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11958,axiom,
    ! [VarCurr: state_type] :
      ( v113778(VarCurr)
    <=> ( v113779(VarCurr)
        & v113782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11957,axiom,
    ! [VarCurr: state_type] :
      ( v113782(VarCurr)
    <=> ( v113174(VarCurr,0)
        | v113737(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11956,axiom,
    ! [VarCurr: state_type] :
      ( v113779(VarCurr)
    <=> ( v113780(VarCurr)
        | v113781(VarCurr) ) ) ).

tff(writeUnaryOperator_6406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113781(VarCurr)
    <=> v113737(VarCurr,0) ) ).

tff(writeUnaryOperator_6405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113780(VarCurr)
    <=> v113174(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11955,axiom,
    ! [VarCurr: state_type] :
      ( v113773(VarCurr)
    <=> ( v113774(VarCurr)
        & v113777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11954,axiom,
    ! [VarCurr: state_type] :
      ( v113777(VarCurr)
    <=> ( v113736(VarCurr)
        | v113738(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11953,axiom,
    ! [VarCurr: state_type] :
      ( v113774(VarCurr)
    <=> ( v113775(VarCurr)
        | v113776(VarCurr) ) ) ).

tff(writeUnaryOperator_6404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113776(VarCurr)
    <=> v113738(VarCurr) ) ).

tff(writeUnaryOperator_6403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113775(VarCurr)
    <=> v113736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11952,axiom,
    ! [VarCurr: state_type] :
      ( v113768(VarCurr)
    <=> ( v113769(VarCurr)
        & v113772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11951,axiom,
    ! [VarCurr: state_type] :
      ( v113772(VarCurr)
    <=> ( v113734(VarCurr)
        | v113744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11950,axiom,
    ! [VarCurr: state_type] :
      ( v113769(VarCurr)
    <=> ( v113770(VarCurr)
        | v113771(VarCurr) ) ) ).

tff(writeUnaryOperator_6402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113771(VarCurr)
    <=> v113744(VarCurr) ) ).

tff(writeUnaryOperator_6401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113770(VarCurr)
    <=> v113734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11949,axiom,
    ! [VarCurr: state_type] :
      ( v113763(VarCurr)
    <=> ( v113764(VarCurr)
        & v113767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11948,axiom,
    ! [VarCurr: state_type] :
      ( v113767(VarCurr)
    <=> ( v113732(VarCurr)
        | v113750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11947,axiom,
    ! [VarCurr: state_type] :
      ( v113764(VarCurr)
    <=> ( v113765(VarCurr)
        | v113766(VarCurr) ) ) ).

tff(writeUnaryOperator_6400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113766(VarCurr)
    <=> v113750(VarCurr) ) ).

tff(writeUnaryOperator_6399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113765(VarCurr)
    <=> v113732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11946,axiom,
    ! [VarCurr: state_type] :
      ( v113727(VarCurr)
    <=> ( v113728(VarCurr)
        & v113762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11945,axiom,
    ! [VarCurr: state_type] :
      ( v113762(VarCurr)
    <=> ( v113730(VarCurr)
        | v113757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11944,axiom,
    ! [VarCurr: state_type] :
      ( v113728(VarCurr)
    <=> ( v113729(VarCurr)
        | v113756(VarCurr) ) ) ).

tff(writeUnaryOperator_6398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113756(VarCurr)
    <=> v113757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11943,axiom,
    ! [VarCurr: state_type] :
      ( v113757(VarCurr)
    <=> ( v113758(VarCurr)
        & v113761(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4807,axiom,
    ! [VarCurr: state_type] :
      ( v113761(VarCurr)
    <=> ( v113174(VarCurr,4)
        | v113737(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11942,axiom,
    ! [VarCurr: state_type] :
      ( v113758(VarCurr)
    <=> ( v113759(VarCurr)
        | v113760(VarCurr) ) ) ).

tff(writeUnaryOperator_6397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113760(VarCurr)
    <=> v113737(VarCurr,4) ) ).

tff(writeUnaryOperator_6396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113759(VarCurr)
    <=> v113174(VarCurr,4) ) ).

tff(writeUnaryOperator_6395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113729(VarCurr)
    <=> v113730(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11941,axiom,
    ! [VarCurr: state_type] :
      ( v113730(VarCurr)
    <=> ( v113731(VarCurr)
        | v113755(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4806,axiom,
    ! [VarCurr: state_type] :
      ( v113755(VarCurr)
    <=> ( v113174(VarCurr,3)
        & v113737(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11940,axiom,
    ! [VarCurr: state_type] :
      ( v113731(VarCurr)
    <=> ( v113732(VarCurr)
        & v113750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11939,axiom,
    ! [VarCurr: state_type] :
      ( v113750(VarCurr)
    <=> ( v113751(VarCurr)
        & v113754(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4805,axiom,
    ! [VarCurr: state_type] :
      ( v113754(VarCurr)
    <=> ( v113174(VarCurr,3)
        | v113737(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11938,axiom,
    ! [VarCurr: state_type] :
      ( v113751(VarCurr)
    <=> ( v113752(VarCurr)
        | v113753(VarCurr) ) ) ).

tff(writeUnaryOperator_6394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113753(VarCurr)
    <=> v113737(VarCurr,3) ) ).

tff(writeUnaryOperator_6393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113752(VarCurr)
    <=> v113174(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11937,axiom,
    ! [VarCurr: state_type] :
      ( v113732(VarCurr)
    <=> ( v113733(VarCurr)
        | v113749(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4804,axiom,
    ! [VarCurr: state_type] :
      ( v113749(VarCurr)
    <=> ( v113174(VarCurr,2)
        & v113737(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11936,axiom,
    ! [VarCurr: state_type] :
      ( v113733(VarCurr)
    <=> ( v113734(VarCurr)
        & v113744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11935,axiom,
    ! [VarCurr: state_type] :
      ( v113744(VarCurr)
    <=> ( v113745(VarCurr)
        & v113748(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4803,axiom,
    ! [VarCurr: state_type] :
      ( v113748(VarCurr)
    <=> ( v113174(VarCurr,2)
        | v113737(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11934,axiom,
    ! [VarCurr: state_type] :
      ( v113745(VarCurr)
    <=> ( v113746(VarCurr)
        | v113747(VarCurr) ) ) ).

tff(writeUnaryOperator_6392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113747(VarCurr)
    <=> v113737(VarCurr,2) ) ).

tff(writeUnaryOperator_6391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113746(VarCurr)
    <=> v113174(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11933,axiom,
    ! [VarCurr: state_type] :
      ( v113734(VarCurr)
    <=> ( v113735(VarCurr)
        | v113743(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4802,axiom,
    ! [VarCurr: state_type] :
      ( v113743(VarCurr)
    <=> ( v113174(VarCurr,1)
        & v113737(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11932,axiom,
    ! [VarCurr: state_type] :
      ( v113735(VarCurr)
    <=> ( v113736(VarCurr)
        & v113738(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11931,axiom,
    ! [VarCurr: state_type] :
      ( v113738(VarCurr)
    <=> ( v113739(VarCurr)
        & v113742(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4801,axiom,
    ! [VarCurr: state_type] :
      ( v113742(VarCurr)
    <=> ( v113174(VarCurr,1)
        | v113737(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11930,axiom,
    ! [VarCurr: state_type] :
      ( v113739(VarCurr)
    <=> ( v113740(VarCurr)
        | v113741(VarCurr) ) ) ).

tff(writeUnaryOperator_6390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113741(VarCurr)
    <=> v113737(VarCurr,1) ) ).

tff(writeUnaryOperator_6389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113740(VarCurr)
    <=> v113174(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11929,axiom,
    ! [VarCurr: state_type] :
      ( v113736(VarCurr)
    <=> ( v113174(VarCurr,0)
        & v113737(VarCurr,0) ) ) ).

tff(addAssignment_67433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113737(VarCurr,B)
      <=> v113633(VarCurr,B) ) ) ).

tff(addAssignment_67432,axiom,
    ! [VarCurr: state_type] :
      ( v113737(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_67431,axiom,
    ! [VarCurr: state_type] :
      ( v113633(VarCurr,3)
    <=> v113637(VarCurr,3) ) ).

tff(addAssignment_67430,axiom,
    ! [VarCurr: state_type] :
      ( v113637(VarCurr,3)
    <=> v113639(VarCurr,3) ) ).

tff(addAssignment_67429,axiom,
    ! [VarNext: state_type] :
      ( v113639(VarNext,3)
    <=> v113718(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113719(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113718(VarNext,B)
            <=> v113639(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1482,axiom,
    ! [VarNext: state_type] :
      ( v113719(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113718(VarNext,B)
          <=> v113694(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113719(VarNext)
      <=> v113720(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113720(VarNext)
      <=> ( v113722(VarNext)
          & v113679(VarNext) ) ) ) ).

tff(writeUnaryOperator_6388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113722(VarNext)
      <=> v113688(VarNext) ) ) ).

tff(addAssignment_67428,axiom,
    ! [VarCurr: state_type] :
      ( v113649(VarCurr,3)
    <=> v113651(VarCurr,3) ) ).

tff(addAssignment_67427,axiom,
    ! [VarCurr: state_type] :
      ( v113651(VarCurr,3)
    <=> v113670(VarCurr,3) ) ).

tff(addAssignment_67426,axiom,
    ! [VarCurr: state_type] :
      ( v113653(VarCurr,3)
    <=> v113663(VarCurr,3) ) ).

tff(addAssignment_67425,axiom,
    ! [VarCurr: state_type] :
      ( v113657(VarCurr,3)
    <=> v113659(VarCurr,3) ) ).

tff(addAssignment_67424,axiom,
    ! [VarCurr: state_type] :
      ( v113633(VarCurr,2)
    <=> v113637(VarCurr,2) ) ).

tff(addAssignment_67423,axiom,
    ! [VarCurr: state_type] :
      ( v113637(VarCurr,2)
    <=> v113639(VarCurr,2) ) ).

tff(addAssignment_67422,axiom,
    ! [VarNext: state_type] :
      ( v113639(VarNext,2)
    <=> v113710(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113711(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113710(VarNext,B)
            <=> v113639(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1481,axiom,
    ! [VarNext: state_type] :
      ( v113711(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113710(VarNext,B)
          <=> v113694(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113711(VarNext)
      <=> v113712(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113712(VarNext)
      <=> ( v113714(VarNext)
          & v113679(VarNext) ) ) ) ).

tff(writeUnaryOperator_6387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113714(VarNext)
      <=> v113688(VarNext) ) ) ).

tff(addAssignment_67421,axiom,
    ! [VarCurr: state_type] :
      ( v113649(VarCurr,2)
    <=> v113651(VarCurr,2) ) ).

tff(addAssignment_67420,axiom,
    ! [VarCurr: state_type] :
      ( v113651(VarCurr,2)
    <=> v113670(VarCurr,2) ) ).

tff(addAssignment_67419,axiom,
    ! [VarCurr: state_type] :
      ( v113653(VarCurr,2)
    <=> v113663(VarCurr,2) ) ).

tff(addAssignment_67418,axiom,
    ! [VarCurr: state_type] :
      ( v113657(VarCurr,2)
    <=> v113659(VarCurr,2) ) ).

tff(addAssignment_67417,axiom,
    ! [VarCurr: state_type] :
      ( v113633(VarCurr,1)
    <=> v113700(VarCurr,1) ) ).

tff(addAssignment_67416,axiom,
    ! [VarCurr: state_type] :
      ( v113635(VarCurr,1)
    <=> v113637(VarCurr,1) ) ).

tff(addAssignment_67415,axiom,
    ! [VarCurr: state_type] :
      ( v113637(VarCurr,1)
    <=> v113639(VarCurr,1) ) ).

tff(addAssignment_67414,axiom,
    ! [VarNext: state_type] :
      ( v113639(VarNext,1)
    <=> v113702(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113703(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113702(VarNext,B)
            <=> v113639(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1480,axiom,
    ! [VarNext: state_type] :
      ( v113703(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113702(VarNext,B)
          <=> v113694(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113703(VarNext)
      <=> v113704(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113704(VarNext)
      <=> ( v113706(VarNext)
          & v113679(VarNext) ) ) ) ).

tff(writeUnaryOperator_6386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113706(VarNext)
      <=> v113688(VarNext) ) ) ).

tff(addAssignment_67413,axiom,
    ! [VarCurr: state_type] :
      ( v113649(VarCurr,1)
    <=> v113651(VarCurr,1) ) ).

tff(addAssignment_67412,axiom,
    ! [VarCurr: state_type] :
      ( v113651(VarCurr,1)
    <=> v113670(VarCurr,1) ) ).

tff(addAssignment_67411,axiom,
    ! [VarCurr: state_type] :
      ( v113653(VarCurr,1)
    <=> v113663(VarCurr,1) ) ).

tff(addAssignment_67410,axiom,
    ! [VarCurr: state_type] :
      ( v113655(VarCurr,1)
    <=> v113662(VarCurr,1) ) ).

tff(addAssignment_67409,axiom,
    ! [VarCurr: state_type] :
      ( v113657(VarCurr,1)
    <=> v113659(VarCurr,1) ) ).

tff(addAssignment_67408,axiom,
    ! [VarCurr: state_type] :
      ( v113633(VarCurr,0)
    <=> v113700(VarCurr,0) ) ).

tff(writeUnaryOperator_6385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113700(VarCurr,B)
      <=> ~ v113635(VarCurr,B) ) ) ).

tff(addAssignment_67407,axiom,
    ! [VarCurr: state_type] :
      ( v113635(VarCurr,0)
    <=> v113637(VarCurr,0) ) ).

tff(addAssignment_67406,axiom,
    ! [VarCurr: state_type] :
      ( v113637(VarCurr,0)
    <=> v113639(VarCurr,0) ) ).

tff(addAssignment_67405,axiom,
    ! [VarNext: state_type] :
      ( v113639(VarNext,0)
    <=> v113683(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113684(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113683(VarNext,B)
            <=> v113639(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1479,axiom,
    ! [VarNext: state_type] :
      ( v113684(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113683(VarNext,B)
          <=> v113694(VarNext,B) ) ) ) ).

tff(addAssignment_67404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113694(VarNext,B)
          <=> v113692(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113692(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1010,axiom,
    ! [VarCurr: state_type] :
      ( v113695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113692(VarCurr,B)
          <=> v113649(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11922,axiom,
    ! [VarCurr: state_type] :
      ( v113695(VarCurr)
    <=> ( v113696(VarCurr)
        & v113697(VarCurr) ) ) ).

tff(writeUnaryOperator_6384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113697(VarCurr)
    <=> v113645(VarCurr) ) ).

tff(writeUnaryOperator_6383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113696(VarCurr)
    <=> v113641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113684(VarNext)
      <=> v113685(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113685(VarNext)
      <=> ( v113686(VarNext)
          & v113679(VarNext) ) ) ) ).

tff(writeUnaryOperator_6382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113686(VarNext)
      <=> v113688(VarNext) ) ) ).

tff(addAssignment_67403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113688(VarNext)
      <=> v113679(VarCurr) ) ) ).

tff(addAssignment_67402,axiom,
    ! [VarCurr: state_type] :
      ( v113679(VarCurr)
    <=> v113681(VarCurr) ) ).

tff(addAssignment_67401,axiom,
    ! [VarCurr: state_type] :
      ( v113681(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67400,axiom,
    ! [VarCurr: state_type] :
      ( v113649(VarCurr,0)
    <=> v113651(VarCurr,0) ) ).

tff(addAssignment_67399,axiom,
    ! [VarCurr: state_type] :
      ( v113651(VarCurr,0)
    <=> v113670(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113670(VarCurr,B)
      <=> ( v113671(VarCurr,B)
          | v113674(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113674(VarCurr,B)
      <=> ( v113637(VarCurr,B)
          & v113675(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113675(VarCurr,B)
      <=> ~ v113676(VarCurr,B) ) ) ).

tff(addAssignment_67398,axiom,
    ! [VarCurr: state_type] :
      ( v113676(VarCurr,0)
    <=> v113677(VarCurr) ) ).

tff(addAssignment_67397,axiom,
    ! [VarCurr: state_type] :
      ( v113676(VarCurr,1)
    <=> v113677(VarCurr) ) ).

tff(addAssignment_67396,axiom,
    ! [VarCurr: state_type] :
      ( v113676(VarCurr,2)
    <=> v113677(VarCurr) ) ).

tff(addAssignment_67395,axiom,
    ! [VarCurr: state_type] :
      ( v113676(VarCurr,3)
    <=> v113677(VarCurr) ) ).

tff(addAssignment_67394,axiom,
    ! [VarCurr: state_type] :
      ( v113677(VarCurr)
    <=> v113665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113671(VarCurr,B)
      <=> ( v113653(VarCurr,B)
          & v113672(VarCurr,B) ) ) ) ).

tff(addAssignment_67393,axiom,
    ! [VarCurr: state_type] :
      ( v113672(VarCurr,0)
    <=> v113673(VarCurr) ) ).

tff(addAssignment_67392,axiom,
    ! [VarCurr: state_type] :
      ( v113672(VarCurr,1)
    <=> v113673(VarCurr) ) ).

tff(addAssignment_67391,axiom,
    ! [VarCurr: state_type] :
      ( v113672(VarCurr,2)
    <=> v113673(VarCurr) ) ).

tff(addAssignment_67390,axiom,
    ! [VarCurr: state_type] :
      ( v113672(VarCurr,3)
    <=> v113673(VarCurr) ) ).

tff(addAssignment_67389,axiom,
    ! [VarCurr: state_type] :
      ( v113673(VarCurr)
    <=> v113665(VarCurr) ) ).

tff(addAssignment_67388,axiom,
    ! [VarCurr: state_type] :
      ( v113665(VarCurr)
    <=> v113667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11919,axiom,
    ! [VarCurr: state_type] :
      ( v113667(VarCurr)
    <=> ( v1729(VarCurr)
        & v113669(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_995,axiom,
    ! [VarCurr: state_type] :
      ( v113669(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67387,axiom,
    ! [VarCurr: state_type] :
      ( v113653(VarCurr,0)
    <=> v113663(VarCurr,0) ) ).

tff(addAssignment_67386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113663(VarCurr,B)
      <=> v113655(VarCurr,B) ) ) ).

tff(addAssignment_67385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113663(VarCurr,B)
      <=> v113657(VarCurr,B) ) ) ).

tff(addAssignment_67384,axiom,
    ! [VarCurr: state_type] :
      ( v113655(VarCurr,0)
    <=> v113662(VarCurr,0) ) ).

tff(writeUnaryOperator_6380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113662(VarCurr,B)
      <=> ~ v113657(VarCurr,B) ) ) ).

tff(addAssignment_67383,axiom,
    ! [VarCurr: state_type] :
      ( v113657(VarCurr,0)
    <=> v113659(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113660(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113659(VarCurr,B)
          <=> v113633(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1009,axiom,
    ! [VarCurr: state_type] :
      ( v113660(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113659(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11918,axiom,
    ! [VarCurr: state_type] :
      ( v113660(VarCurr)
    <=> ( v1729(VarCurr)
        & v113661(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_994,axiom,
    ! [VarCurr: state_type] :
      ( v113661(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1912,axiom,
    ~ b0000010111000(12) ).

tff(bitBlastConstant_1911,axiom,
    ~ b0000010111000(11) ).

tff(bitBlastConstant_1910,axiom,
    ~ b0000010111000(10) ).

tff(bitBlastConstant_1909,axiom,
    ~ b0000010111000(9) ).

tff(bitBlastConstant_1908,axiom,
    ~ b0000010111000(8) ).

tff(bitBlastConstant_1907,axiom,
    b0000010111000(7) ).

tff(bitBlastConstant_1906,axiom,
    ~ b0000010111000(6) ).

tff(bitBlastConstant_1905,axiom,
    b0000010111000(5) ).

tff(bitBlastConstant_1904,axiom,
    b0000010111000(4) ).

tff(bitBlastConstant_1903,axiom,
    b0000010111000(3) ).

tff(bitBlastConstant_1902,axiom,
    ~ b0000010111000(2) ).

tff(bitBlastConstant_1901,axiom,
    ~ b0000010111000(1) ).

tff(bitBlastConstant_1900,axiom,
    ~ b0000010111000(0) ).

tff(addAssignment_67382,axiom,
    ! [VarCurr: state_type] :
      ( v113645(VarCurr)
    <=> v113647(VarCurr) ) ).

tff(addAssignment_67381,axiom,
    ! [VarCurr: state_type] :
      ( v113647(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67380,axiom,
    ! [VarCurr: state_type] :
      ( v113641(VarCurr)
    <=> v113643(VarCurr) ) ).

tff(addAssignment_67379,axiom,
    ! [VarCurr: state_type] :
      ( v113643(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_67378,axiom,
    ! [VarCurr: state_type] :
      ( v113174(VarCurr,4)
    <=> v113623(VarCurr,4) ) ).

tff(addAssignment_67377,axiom,
    ! [VarCurr: state_type] :
      ( v113174(VarCurr,3)
    <=> v113623(VarCurr,3) ) ).

tff(addAssignment_67376,axiom,
    ! [VarCurr: state_type] :
      ( v113174(VarCurr,2)
    <=> v113623(VarCurr,2) ) ).

tff(addAssignment_67375,axiom,
    ! [VarCurr: state_type] :
      ( v113174(VarCurr,1)
    <=> v113623(VarCurr,1) ) ).

tff(addAssignment_67374,axiom,
    ! [VarCurr: state_type] :
      ( v113174(VarCurr,0)
    <=> v113623(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113623(VarCurr,B)
          <=> v113628(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1008,axiom,
    ! [VarCurr: state_type] :
      ( v113624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113623(VarCurr,B)
          <=> v113627(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113629(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113628(VarCurr,B)
          <=> v113178(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1007,axiom,
    ! [VarCurr: state_type] :
      ( v113629(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v113628(VarCurr,B)
          <=> v113631(VarCurr,B) ) ) ) ).

tff(addAssignment_67373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113631(VarCurr,B)
      <=> v113458(VarCurr,B) ) ) ).

tff(addAssignment_67372,axiom,
    ! [VarCurr: state_type] :
      ( v113631(VarCurr,4)
    <=> $false ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11917,axiom,
    ! [VarCurr: state_type] :
      ( v113629(VarCurr)
    <=> ( v113630(VarCurr)
        & v113456(VarCurr) ) ) ).

tff(writeUnaryOperator_6379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113630(VarCurr)
    <=> v113586(VarCurr) ) ).

tff(addAssignment_67371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113627(VarCurr,B)
      <=> v113322(VarCurr,B) ) ) ).

tff(addAssignment_67370,axiom,
    ! [VarCurr: state_type] :
      ( ( v113627(VarCurr,4)
      <=> $false )
      & ( v113627(VarCurr,3)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11916,axiom,
    ! [VarCurr: state_type] :
      ( v113624(VarCurr)
    <=> ( v113625(VarCurr)
        & v113626(VarCurr) ) ) ).

tff(writeUnaryOperator_6378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113626(VarCurr)
    <=> v113456(VarCurr) ) ).

tff(writeUnaryOperator_6377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113625(VarCurr)
    <=> v113176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11915,axiom,
    ! [VarCurr: state_type] :
      ( v113586(VarCurr)
    <=> ( v113589(VarCurr)
        | v113622(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4800,axiom,
    ! [VarCurr: state_type] :
      ( v113622(VarCurr)
    <=> ( v113178(VarCurr,4)
        & v113620(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11914,axiom,
    ! [VarCurr: state_type] :
      ( v113589(VarCurr)
    <=> ( v113590(VarCurr)
        & v113617(VarCurr) ) ) ).

tff(writeUnaryOperator_6376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113617(VarCurr)
    <=> v113618(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11913,axiom,
    ! [VarCurr: state_type] :
      ( v113618(VarCurr)
    <=> ( v113619(VarCurr)
        & v113621(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4799,axiom,
    ! [VarCurr: state_type] :
      ( v113621(VarCurr)
    <=> ( v113178(VarCurr,4)
        | v113598(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11912,axiom,
    ! [VarCurr: state_type] :
      ( v113619(VarCurr)
    <=> ( v113452(VarCurr)
        | v113620(VarCurr) ) ) ).

tff(writeUnaryOperator_6375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113620(VarCurr)
    <=> v113598(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11911,axiom,
    ! [VarCurr: state_type] :
      ( v113590(VarCurr)
    <=> ( v113591(VarCurr)
        | v113616(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4798,axiom,
    ! [VarCurr: state_type] :
      ( v113616(VarCurr)
    <=> ( v113178(VarCurr,3)
        & v113614(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11910,axiom,
    ! [VarCurr: state_type] :
      ( v113591(VarCurr)
    <=> ( v113592(VarCurr)
        & v113611(VarCurr) ) ) ).

tff(writeUnaryOperator_6374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113611(VarCurr)
    <=> v113612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11909,axiom,
    ! [VarCurr: state_type] :
      ( v113612(VarCurr)
    <=> ( v113613(VarCurr)
        & v113615(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4797,axiom,
    ! [VarCurr: state_type] :
      ( v113615(VarCurr)
    <=> ( v113178(VarCurr,3)
        | v113598(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11908,axiom,
    ! [VarCurr: state_type] :
      ( v113613(VarCurr)
    <=> ( v113445(VarCurr)
        | v113614(VarCurr) ) ) ).

tff(writeUnaryOperator_6373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113614(VarCurr)
    <=> v113598(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11907,axiom,
    ! [VarCurr: state_type] :
      ( v113592(VarCurr)
    <=> ( v113593(VarCurr)
        | v113610(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4796,axiom,
    ! [VarCurr: state_type] :
      ( v113610(VarCurr)
    <=> ( v113178(VarCurr,2)
        & v113608(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11906,axiom,
    ! [VarCurr: state_type] :
      ( v113593(VarCurr)
    <=> ( v113594(VarCurr)
        & v113605(VarCurr) ) ) ).

tff(writeUnaryOperator_6372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113605(VarCurr)
    <=> v113606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11905,axiom,
    ! [VarCurr: state_type] :
      ( v113606(VarCurr)
    <=> ( v113607(VarCurr)
        & v113609(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4795,axiom,
    ! [VarCurr: state_type] :
      ( v113609(VarCurr)
    <=> ( v113178(VarCurr,2)
        | v113598(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11904,axiom,
    ! [VarCurr: state_type] :
      ( v113607(VarCurr)
    <=> ( v113438(VarCurr)
        | v113608(VarCurr) ) ) ).

tff(writeUnaryOperator_6371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113608(VarCurr)
    <=> v113598(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11903,axiom,
    ! [VarCurr: state_type] :
      ( v113594(VarCurr)
    <=> ( v113595(VarCurr)
        | v113604(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4794,axiom,
    ! [VarCurr: state_type] :
      ( v113604(VarCurr)
    <=> ( v113178(VarCurr,1)
        & v113602(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11902,axiom,
    ! [VarCurr: state_type] :
      ( v113595(VarCurr)
    <=> ( v113596(VarCurr)
        & v113599(VarCurr) ) ) ).

tff(writeUnaryOperator_6370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113599(VarCurr)
    <=> v113600(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11901,axiom,
    ! [VarCurr: state_type] :
      ( v113600(VarCurr)
    <=> ( v113601(VarCurr)
        & v113603(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4793,axiom,
    ! [VarCurr: state_type] :
      ( v113603(VarCurr)
    <=> ( v113178(VarCurr,1)
        | v113598(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11900,axiom,
    ! [VarCurr: state_type] :
      ( v113601(VarCurr)
    <=> ( v113431(VarCurr)
        | v113602(VarCurr) ) ) ).

tff(writeUnaryOperator_6369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113602(VarCurr)
    <=> v113598(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11899,axiom,
    ! [VarCurr: state_type] :
      ( v113596(VarCurr)
    <=> ( v113178(VarCurr,0)
        & v113597(VarCurr) ) ) ).

tff(writeUnaryOperator_6368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113597(VarCurr)
    <=> v113598(VarCurr,0) ) ).

tff(addAssignment_67369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113598(VarCurr,B)
      <=> v113458(VarCurr,B) ) ) ).

tff(addAssignment_67368,axiom,
    ! [VarCurr: state_type] :
      ( v113598(VarCurr,4)
    <=> $false ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11898,axiom,
    ! [VarCurr: state_type] :
      ( v113456(VarCurr)
    <=> ( v113546(VarCurr)
        | v113584(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4792,axiom,
    ! [VarCurr: state_type] :
      ( v113584(VarCurr)
    <=> ( v113581(VarCurr)
        & v113556(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11897,axiom,
    ! [VarCurr: state_type] :
      ( v113546(VarCurr)
    <=> ( v113547(VarCurr)
        & v113578(VarCurr) ) ) ).

tff(writeUnaryOperator_6367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113578(VarCurr)
    <=> v113579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11896,axiom,
    ! [VarCurr: state_type] :
      ( v113579(VarCurr)
    <=> ( v113580(VarCurr)
        & v113583(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4791,axiom,
    ! [VarCurr: state_type] :
      ( v113583(VarCurr)
    <=> ( v113555(VarCurr,4)
        | v113556(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11895,axiom,
    ! [VarCurr: state_type] :
      ( v113580(VarCurr)
    <=> ( v113581(VarCurr)
        | v113582(VarCurr) ) ) ).

tff(writeUnaryOperator_6366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113582(VarCurr)
    <=> v113556(VarCurr,4) ) ).

tff(writeUnaryOperator_6365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113581(VarCurr)
    <=> v113555(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11894,axiom,
    ! [VarCurr: state_type] :
      ( v113547(VarCurr)
    <=> ( v113548(VarCurr)
        | v113577(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4790,axiom,
    ! [VarCurr: state_type] :
      ( v113577(VarCurr)
    <=> ( v113574(VarCurr)
        & v113556(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11893,axiom,
    ! [VarCurr: state_type] :
      ( v113548(VarCurr)
    <=> ( v113549(VarCurr)
        & v113571(VarCurr) ) ) ).

tff(writeUnaryOperator_6364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113571(VarCurr)
    <=> v113572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11892,axiom,
    ! [VarCurr: state_type] :
      ( v113572(VarCurr)
    <=> ( v113573(VarCurr)
        & v113576(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4789,axiom,
    ! [VarCurr: state_type] :
      ( v113576(VarCurr)
    <=> ( v113555(VarCurr,3)
        | v113556(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11891,axiom,
    ! [VarCurr: state_type] :
      ( v113573(VarCurr)
    <=> ( v113574(VarCurr)
        | v113575(VarCurr) ) ) ).

tff(writeUnaryOperator_6363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113575(VarCurr)
    <=> v113556(VarCurr,3) ) ).

tff(writeUnaryOperator_6362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113574(VarCurr)
    <=> v113555(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11890,axiom,
    ! [VarCurr: state_type] :
      ( v113549(VarCurr)
    <=> ( v113550(VarCurr)
        | v113570(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4788,axiom,
    ! [VarCurr: state_type] :
      ( v113570(VarCurr)
    <=> ( v113567(VarCurr)
        & v113556(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11889,axiom,
    ! [VarCurr: state_type] :
      ( v113550(VarCurr)
    <=> ( v113551(VarCurr)
        & v113564(VarCurr) ) ) ).

tff(writeUnaryOperator_6361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113564(VarCurr)
    <=> v113565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11888,axiom,
    ! [VarCurr: state_type] :
      ( v113565(VarCurr)
    <=> ( v113566(VarCurr)
        & v113569(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4787,axiom,
    ! [VarCurr: state_type] :
      ( v113569(VarCurr)
    <=> ( v113555(VarCurr,2)
        | v113556(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11887,axiom,
    ! [VarCurr: state_type] :
      ( v113566(VarCurr)
    <=> ( v113567(VarCurr)
        | v113568(VarCurr) ) ) ).

tff(writeUnaryOperator_6360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113568(VarCurr)
    <=> v113556(VarCurr,2) ) ).

tff(writeUnaryOperator_6359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113567(VarCurr)
    <=> v113555(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11886,axiom,
    ! [VarCurr: state_type] :
      ( v113551(VarCurr)
    <=> ( v113552(VarCurr)
        | v113563(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4786,axiom,
    ! [VarCurr: state_type] :
      ( v113563(VarCurr)
    <=> ( v113560(VarCurr)
        & v113556(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11885,axiom,
    ! [VarCurr: state_type] :
      ( v113552(VarCurr)
    <=> ( v113553(VarCurr)
        & v113557(VarCurr) ) ) ).

tff(writeUnaryOperator_6358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113557(VarCurr)
    <=> v113558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11884,axiom,
    ! [VarCurr: state_type] :
      ( v113558(VarCurr)
    <=> ( v113559(VarCurr)
        & v113562(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4785,axiom,
    ! [VarCurr: state_type] :
      ( v113562(VarCurr)
    <=> ( v113555(VarCurr,1)
        | v113556(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11883,axiom,
    ! [VarCurr: state_type] :
      ( v113559(VarCurr)
    <=> ( v113560(VarCurr)
        | v113561(VarCurr) ) ) ).

tff(writeUnaryOperator_6357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113561(VarCurr)
    <=> v113556(VarCurr,1) ) ).

tff(writeUnaryOperator_6356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113560(VarCurr)
    <=> v113555(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11882,axiom,
    ! [VarCurr: state_type] :
      ( v113553(VarCurr)
    <=> ( v113554(VarCurr)
        & v113556(VarCurr,0) ) ) ).

tff(addAssignment_67367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113556(VarCurr,B)
      <=> v113458(VarCurr,B) ) ) ).

tff(addAssignment_67366,axiom,
    ! [VarCurr: state_type] :
      ( v113556(VarCurr,4)
    <=> $false ) ).

tff(writeUnaryOperator_6355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113554(VarCurr)
    <=> v113555(VarCurr,0) ) ).

tff(addAssignment_67365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113555(VarCurr,B)
      <=> v113322(VarCurr,B) ) ) ).

tff(addAssignment_67364,axiom,
    ! [VarCurr: state_type] :
      ( ( v113555(VarCurr,4)
      <=> $false )
      & ( v113555(VarCurr,3)
      <=> $false ) ) ).

tff(writeUnaryOperator_6354,axiom,
    ! [VarCurr: state_type] :
      ( v113458(VarCurr,3)
    <=> ~ v113522(VarCurr,1) ) ).

tff(addAssignment_67363,axiom,
    ! [VarCurr: state_type] :
      ( ( v113458(VarCurr,2)
      <=> v113460(VarCurr,3) )
      & ( v113458(VarCurr,1)
      <=> v113460(VarCurr,2) ) ) ).

tff(writeUnaryOperator_6353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113458(VarCurr,0)
    <=> v113522(VarCurr,0) ) ).

tff(addAssignment_67362,axiom,
    ! [VarCurr: state_type] :
      ( v113522(VarCurr,1)
    <=> v113460(VarCurr,1) ) ).

tff(addAssignment_67361,axiom,
    ! [VarCurr: state_type] :
      ( v113460(VarCurr,1)
    <=> v113462(VarCurr,1) ) ).

tff(addAssignment_67360,axiom,
    ! [VarNext: state_type] :
      ( v113462(VarNext,1)
    <=> v113535(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113536(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113535(VarNext,B)
            <=> v113462(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1478,axiom,
    ! [VarNext: state_type] :
      ( v113536(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113535(VarNext,B)
          <=> v113515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113536(VarNext)
      <=> v113537(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113537(VarNext)
      <=> ( v113539(VarNext)
          & v113500(VarNext) ) ) ) ).

tff(writeUnaryOperator_6352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113539(VarNext)
      <=> v113509(VarNext) ) ) ).

tff(addAssignment_67359,axiom,
    ! [VarCurr: state_type] :
      ( v113472(VarCurr,1)
    <=> v113474(VarCurr,1) ) ).

tff(addAssignment_67358,axiom,
    ! [VarCurr: state_type] :
      ( v113474(VarCurr,1)
    <=> v113491(VarCurr,1) ) ).

tff(addAssignment_67357,axiom,
    ! [VarCurr: state_type] :
      ( v113476(VarCurr,1)
    <=> v113483(VarCurr,1) ) ).

tff(writeUnaryOperator_6351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113484(VarCurr,1)
    <=> v113478(VarCurr,3) ) ).

tff(addAssignment_67356,axiom,
    ! [VarCurr: state_type] :
      ( v113478(VarCurr,3)
    <=> v113480(VarCurr,3) ) ).

tff(addAssignment_67355,axiom,
    ! [VarCurr: state_type] :
      ( v113522(VarCurr,0)
    <=> v113460(VarCurr,0) ) ).

tff(addAssignment_67354,axiom,
    ! [VarCurr: state_type] :
      ( v113460(VarCurr,0)
    <=> v113462(VarCurr,0) ) ).

tff(addAssignment_67353,axiom,
    ! [VarNext: state_type] :
      ( v113462(VarNext,0)
    <=> v113526(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113527(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113526(VarNext,B)
            <=> v113462(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1477,axiom,
    ! [VarNext: state_type] :
      ( v113527(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113526(VarNext,B)
          <=> v113515(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113527(VarNext)
      <=> v113528(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113528(VarNext)
      <=> ( v113530(VarNext)
          & v113500(VarNext) ) ) ) ).

tff(writeUnaryOperator_6350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113530(VarNext)
      <=> v113509(VarNext) ) ) ).

tff(addAssignment_67352,axiom,
    ! [VarCurr: state_type] :
      ( v113472(VarCurr,0)
    <=> v113474(VarCurr,0) ) ).

tff(addAssignment_67351,axiom,
    ! [VarCurr: state_type] :
      ( v113474(VarCurr,0)
    <=> v113491(VarCurr,0) ) ).

tff(addAssignment_67350,axiom,
    ! [VarCurr: state_type] :
      ( v113476(VarCurr,0)
    <=> v113483(VarCurr,0) ) ).

tff(writeUnaryOperator_6349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113484(VarCurr,0)
    <=> v113478(VarCurr,0) ) ).

tff(addAssignment_67349,axiom,
    ! [VarCurr: state_type] :
      ( v113478(VarCurr,0)
    <=> v113480(VarCurr,0) ) ).

tff(addAssignment_67348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113460(VarCurr,B)
      <=> v113462(VarCurr,B) ) ) ).

tff(addAssignment_67347,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113462(VarNext,B)
      <=> v113504(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113505(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v113504(VarNext,B)
            <=> v113462(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1476,axiom,
    ! [VarNext: state_type] :
      ( v113505(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113504(VarNext,B)
          <=> v113515(VarNext,B) ) ) ) ).

tff(addAssignment_67346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113515(VarNext,B)
          <=> v113513(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113513(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1006,axiom,
    ! [VarCurr: state_type] :
      ( v113516(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113513(VarCurr,B)
          <=> v113472(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11877,axiom,
    ! [VarCurr: state_type] :
      ( v113516(VarCurr)
    <=> ( v113517(VarCurr)
        & v113518(VarCurr) ) ) ).

tff(writeUnaryOperator_6348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113518(VarCurr)
    <=> v113468(VarCurr) ) ).

tff(writeUnaryOperator_6347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113517(VarCurr)
    <=> v113464(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113505(VarNext)
      <=> v113506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113506(VarNext)
      <=> ( v113507(VarNext)
          & v113500(VarNext) ) ) ) ).

tff(writeUnaryOperator_6346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113507(VarNext)
      <=> v113509(VarNext) ) ) ).

tff(addAssignment_67345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113509(VarNext)
      <=> v113500(VarCurr) ) ) ).

tff(addAssignment_67344,axiom,
    ! [VarCurr: state_type] :
      ( v113500(VarCurr)
    <=> v113502(VarCurr) ) ).

tff(addAssignment_67343,axiom,
    ! [VarCurr: state_type] :
      ( v113502(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113472(VarCurr,B)
      <=> v113474(VarCurr,B) ) ) ).

tff(addAssignment_67341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113474(VarCurr,B)
      <=> v113491(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113491(VarCurr,B)
      <=> ( v113492(VarCurr,B)
          | v113495(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113495(VarCurr,B)
      <=> ( v113460(VarCurr,B)
          & v113496(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113496(VarCurr,B)
      <=> ~ v113497(VarCurr,B) ) ) ).

tff(addAssignment_67340,axiom,
    ! [VarCurr: state_type] :
      ( v113497(VarCurr,0)
    <=> v113498(VarCurr) ) ).

tff(addAssignment_67339,axiom,
    ! [VarCurr: state_type] :
      ( v113497(VarCurr,1)
    <=> v113498(VarCurr) ) ).

tff(addAssignment_67338,axiom,
    ! [VarCurr: state_type] :
      ( v113497(VarCurr,2)
    <=> v113498(VarCurr) ) ).

tff(addAssignment_67337,axiom,
    ! [VarCurr: state_type] :
      ( v113497(VarCurr,3)
    <=> v113498(VarCurr) ) ).

tff(addAssignment_67336,axiom,
    ! [VarCurr: state_type] :
      ( v113498(VarCurr)
    <=> v113486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v113492(VarCurr,B)
      <=> ( v113476(VarCurr,B)
          & v113493(VarCurr,B) ) ) ) ).

tff(addAssignment_67335,axiom,
    ! [VarCurr: state_type] :
      ( v113493(VarCurr,0)
    <=> v113494(VarCurr) ) ).

tff(addAssignment_67334,axiom,
    ! [VarCurr: state_type] :
      ( v113493(VarCurr,1)
    <=> v113494(VarCurr) ) ).

tff(addAssignment_67333,axiom,
    ! [VarCurr: state_type] :
      ( v113493(VarCurr,2)
    <=> v113494(VarCurr) ) ).

tff(addAssignment_67332,axiom,
    ! [VarCurr: state_type] :
      ( v113493(VarCurr,3)
    <=> v113494(VarCurr) ) ).

tff(addAssignment_67331,axiom,
    ! [VarCurr: state_type] :
      ( v113494(VarCurr)
    <=> v113486(VarCurr) ) ).

tff(addAssignment_67330,axiom,
    ! [VarCurr: state_type] :
      ( v113486(VarCurr)
    <=> v113488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11874,axiom,
    ! [VarCurr: state_type] :
      ( v113488(VarCurr)
    <=> ( v1729(VarCurr)
        & v113490(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_993,axiom,
    ! [VarCurr: state_type] :
      ( v113490(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v113476(VarCurr,B)
      <=> v113483(VarCurr,B) ) ) ).

tff(addAssignment_67328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113483(VarCurr,B)
      <=> v113484(VarCurr,B) ) ) ).

tff(addAssignment_67327,axiom,
    ! [VarCurr: state_type] :
      ( ( v113483(VarCurr,3)
      <=> v113478(VarCurr,2) )
      & ( v113483(VarCurr,2)
      <=> v113478(VarCurr,1) ) ) ).

tff(addAssignment_67326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v113478(VarCurr,B)
      <=> v113480(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113481(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113480(VarCurr,B)
          <=> v113458(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1005,axiom,
    ! [VarCurr: state_type] :
      ( v113481(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v113480(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11873,axiom,
    ! [VarCurr: state_type] :
      ( v113481(VarCurr)
    <=> ( v1729(VarCurr)
        & v113482(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_992,axiom,
    ! [VarCurr: state_type] :
      ( v113482(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1899,axiom,
    ~ b0000010110000(12) ).

tff(bitBlastConstant_1898,axiom,
    ~ b0000010110000(11) ).

tff(bitBlastConstant_1897,axiom,
    ~ b0000010110000(10) ).

tff(bitBlastConstant_1896,axiom,
    ~ b0000010110000(9) ).

tff(bitBlastConstant_1895,axiom,
    ~ b0000010110000(8) ).

tff(bitBlastConstant_1894,axiom,
    b0000010110000(7) ).

tff(bitBlastConstant_1893,axiom,
    ~ b0000010110000(6) ).

tff(bitBlastConstant_1892,axiom,
    b0000010110000(5) ).

tff(bitBlastConstant_1891,axiom,
    b0000010110000(4) ).

tff(bitBlastConstant_1890,axiom,
    ~ b0000010110000(3) ).

tff(bitBlastConstant_1889,axiom,
    ~ b0000010110000(2) ).

tff(bitBlastConstant_1888,axiom,
    ~ b0000010110000(1) ).

tff(bitBlastConstant_1887,axiom,
    ~ b0000010110000(0) ).

tff(addAssignment_67325,axiom,
    ! [VarCurr: state_type] :
      ( v113468(VarCurr)
    <=> v113470(VarCurr) ) ).

tff(addAssignment_67324,axiom,
    ! [VarCurr: state_type] :
      ( v113470(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67323,axiom,
    ! [VarCurr: state_type] :
      ( v113464(VarCurr)
    <=> v113466(VarCurr) ) ).

tff(addAssignment_67322,axiom,
    ! [VarCurr: state_type] :
      ( v113466(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11872,axiom,
    ! [VarCurr: state_type] :
      ( v113176(VarCurr)
    <=> ( v113417(VarCurr)
        | v113454(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4784,axiom,
    ! [VarCurr: state_type] :
      ( v113454(VarCurr)
    <=> ( v113451(VarCurr)
        & v113178(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11871,axiom,
    ! [VarCurr: state_type] :
      ( v113417(VarCurr)
    <=> ( v113418(VarCurr)
        & v113448(VarCurr) ) ) ).

tff(writeUnaryOperator_6344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113448(VarCurr)
    <=> v113449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11870,axiom,
    ! [VarCurr: state_type] :
      ( v113449(VarCurr)
    <=> ( v113450(VarCurr)
        & v113453(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4783,axiom,
    ! [VarCurr: state_type] :
      ( v113453(VarCurr)
    <=> ( v113426(VarCurr,4)
        | v113178(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11869,axiom,
    ! [VarCurr: state_type] :
      ( v113450(VarCurr)
    <=> ( v113451(VarCurr)
        | v113452(VarCurr) ) ) ).

tff(writeUnaryOperator_6343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113452(VarCurr)
    <=> v113178(VarCurr,4) ) ).

tff(writeUnaryOperator_6342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113451(VarCurr)
    <=> v113426(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11868,axiom,
    ! [VarCurr: state_type] :
      ( v113418(VarCurr)
    <=> ( v113419(VarCurr)
        | v113447(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4782,axiom,
    ! [VarCurr: state_type] :
      ( v113447(VarCurr)
    <=> ( v113444(VarCurr)
        & v113178(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11867,axiom,
    ! [VarCurr: state_type] :
      ( v113419(VarCurr)
    <=> ( v113420(VarCurr)
        & v113441(VarCurr) ) ) ).

tff(writeUnaryOperator_6341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113441(VarCurr)
    <=> v113442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11866,axiom,
    ! [VarCurr: state_type] :
      ( v113442(VarCurr)
    <=> ( v113443(VarCurr)
        & v113446(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4781,axiom,
    ! [VarCurr: state_type] :
      ( v113446(VarCurr)
    <=> ( v113426(VarCurr,3)
        | v113178(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11865,axiom,
    ! [VarCurr: state_type] :
      ( v113443(VarCurr)
    <=> ( v113444(VarCurr)
        | v113445(VarCurr) ) ) ).

tff(writeUnaryOperator_6340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113445(VarCurr)
    <=> v113178(VarCurr,3) ) ).

tff(writeUnaryOperator_6339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113444(VarCurr)
    <=> v113426(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11864,axiom,
    ! [VarCurr: state_type] :
      ( v113420(VarCurr)
    <=> ( v113421(VarCurr)
        | v113440(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4780,axiom,
    ! [VarCurr: state_type] :
      ( v113440(VarCurr)
    <=> ( v113437(VarCurr)
        & v113178(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11863,axiom,
    ! [VarCurr: state_type] :
      ( v113421(VarCurr)
    <=> ( v113422(VarCurr)
        & v113434(VarCurr) ) ) ).

tff(writeUnaryOperator_6338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113434(VarCurr)
    <=> v113435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11862,axiom,
    ! [VarCurr: state_type] :
      ( v113435(VarCurr)
    <=> ( v113436(VarCurr)
        & v113439(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4779,axiom,
    ! [VarCurr: state_type] :
      ( v113439(VarCurr)
    <=> ( v113426(VarCurr,2)
        | v113178(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11861,axiom,
    ! [VarCurr: state_type] :
      ( v113436(VarCurr)
    <=> ( v113437(VarCurr)
        | v113438(VarCurr) ) ) ).

tff(writeUnaryOperator_6337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113438(VarCurr)
    <=> v113178(VarCurr,2) ) ).

tff(writeUnaryOperator_6336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113437(VarCurr)
    <=> v113426(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11860,axiom,
    ! [VarCurr: state_type] :
      ( v113422(VarCurr)
    <=> ( v113423(VarCurr)
        | v113433(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4778,axiom,
    ! [VarCurr: state_type] :
      ( v113433(VarCurr)
    <=> ( v113430(VarCurr)
        & v113178(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11859,axiom,
    ! [VarCurr: state_type] :
      ( v113423(VarCurr)
    <=> ( v113424(VarCurr)
        & v113427(VarCurr) ) ) ).

tff(writeUnaryOperator_6335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113427(VarCurr)
    <=> v113428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11858,axiom,
    ! [VarCurr: state_type] :
      ( v113428(VarCurr)
    <=> ( v113429(VarCurr)
        & v113432(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4777,axiom,
    ! [VarCurr: state_type] :
      ( v113432(VarCurr)
    <=> ( v113426(VarCurr,1)
        | v113178(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11857,axiom,
    ! [VarCurr: state_type] :
      ( v113429(VarCurr)
    <=> ( v113430(VarCurr)
        | v113431(VarCurr) ) ) ).

tff(writeUnaryOperator_6334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113431(VarCurr)
    <=> v113178(VarCurr,1) ) ).

tff(writeUnaryOperator_6333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113430(VarCurr)
    <=> v113426(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11856,axiom,
    ! [VarCurr: state_type] :
      ( v113424(VarCurr)
    <=> ( v113425(VarCurr)
        & v113178(VarCurr,0) ) ) ).

tff(writeUnaryOperator_6332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113425(VarCurr)
    <=> v113426(VarCurr,0) ) ).

tff(addAssignment_67321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113426(VarCurr,B)
      <=> v113322(VarCurr,B) ) ) ).

tff(addAssignment_67320,axiom,
    ! [VarCurr: state_type] :
      ( ( v113426(VarCurr,4)
      <=> $false )
      & ( v113426(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_67319,axiom,
    ! [VarCurr: state_type] :
      ( v113322(VarCurr,2)
    <=> v113324(VarCurr,2) ) ).

tff(writeUnaryOperator_6331,axiom,
    ! [VarCurr: state_type] :
      ( v113322(VarCurr,1)
    <=> ~ v113403(VarCurr) ) ).

tff(addAssignment_67318,axiom,
    ! [VarCurr: state_type] :
      ( v113322(VarCurr,0)
    <=> v113324(VarCurr,0) ) ).

tff(addAssignment_67317,axiom,
    ! [VarCurr: state_type] :
      ( v113403(VarCurr)
    <=> v113324(VarCurr,1) ) ).

tff(addAssignment_67316,axiom,
    ! [VarCurr: state_type] :
      ( v113324(VarCurr,1)
    <=> v113326(VarCurr,1) ) ).

tff(addAssignment_67315,axiom,
    ! [VarNext: state_type] :
      ( v113326(VarNext,1)
    <=> v113407(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113408(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v113407(VarNext,B)
            <=> v113326(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1475,axiom,
    ! [VarNext: state_type] :
      ( v113408(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113407(VarNext,B)
          <=> v113388(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113408(VarNext)
      <=> v113409(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113409(VarNext)
      <=> ( v113411(VarNext)
          & v113373(VarNext) ) ) ) ).

tff(writeUnaryOperator_6330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113411(VarNext)
      <=> v113382(VarNext) ) ) ).

tff(addAssignment_67314,axiom,
    ! [VarCurr: state_type] :
      ( v113336(VarCurr,1)
    <=> v113338(VarCurr,1) ) ).

tff(addAssignment_67313,axiom,
    ! [VarCurr: state_type] :
      ( v113338(VarCurr,1)
    <=> v113364(VarCurr,1) ) ).

tff(addAssignment_67312,axiom,
    ! [VarCurr: state_type] :
      ( v113340(VarCurr,1)
    <=> v113356(VarCurr,1) ) ).

tff(writeUnaryOperator_6329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113357(VarCurr)
    <=> v113342(VarCurr,1) ) ).

tff(addAssignment_67311,axiom,
    ! [VarCurr: state_type] :
      ( v113342(VarCurr,1)
    <=> v113344(VarCurr,1) ) ).

tff(addAssignment_67310,axiom,
    ! [VarCurr: state_type] :
      ( v113324(VarCurr,0)
    <=> v113326(VarCurr,0) ) ).

tff(addAssignment_67309,axiom,
    ! [VarNext: state_type] :
      ( v113326(VarNext,0)
    <=> v113395(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113396(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v113395(VarNext,B)
            <=> v113326(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1474,axiom,
    ! [VarNext: state_type] :
      ( v113396(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113395(VarNext,B)
          <=> v113388(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11853,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113396(VarNext)
      <=> v113397(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113397(VarNext)
      <=> ( v113399(VarNext)
          & v113373(VarNext) ) ) ) ).

tff(writeUnaryOperator_6328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113399(VarNext)
      <=> v113382(VarNext) ) ) ).

tff(addAssignment_67308,axiom,
    ! [VarCurr: state_type] :
      ( v113336(VarCurr,0)
    <=> v113338(VarCurr,0) ) ).

tff(addAssignment_67307,axiom,
    ! [VarCurr: state_type] :
      ( v113338(VarCurr,0)
    <=> v113364(VarCurr,0) ) ).

tff(addAssignment_67306,axiom,
    ! [VarCurr: state_type] :
      ( v113340(VarCurr,0)
    <=> v113356(VarCurr,0) ) ).

tff(addAssignment_67305,axiom,
    ! [VarCurr: state_type] :
      ( v113342(VarCurr,0)
    <=> v113344(VarCurr,0) ) ).

tff(addAssignment_67304,axiom,
    ! [VarCurr: state_type] :
      ( v113324(VarCurr,2)
    <=> v113326(VarCurr,2) ) ).

tff(addAssignment_67303,axiom,
    ! [VarNext: state_type] :
      ( v113326(VarNext,2)
    <=> v113377(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113378(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v113377(VarNext,B)
            <=> v113326(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1473,axiom,
    ! [VarNext: state_type] :
      ( v113378(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113377(VarNext,B)
          <=> v113388(VarNext,B) ) ) ) ).

tff(addAssignment_67302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113388(VarNext,B)
          <=> v113386(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113386(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1004,axiom,
    ! [VarCurr: state_type] :
      ( v113389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113386(VarCurr,B)
          <=> v113336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11851,axiom,
    ! [VarCurr: state_type] :
      ( v113389(VarCurr)
    <=> ( v113390(VarCurr)
        & v113391(VarCurr) ) ) ).

tff(writeUnaryOperator_6327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113391(VarCurr)
    <=> v113332(VarCurr) ) ).

tff(writeUnaryOperator_6326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113390(VarCurr)
    <=> v113328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113378(VarNext)
      <=> v113379(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113379(VarNext)
      <=> ( v113380(VarNext)
          & v113373(VarNext) ) ) ) ).

tff(writeUnaryOperator_6325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113380(VarNext)
      <=> v113382(VarNext) ) ) ).

tff(addAssignment_67301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113382(VarNext)
      <=> v113373(VarCurr) ) ) ).

tff(addAssignment_67300,axiom,
    ! [VarCurr: state_type] :
      ( v113373(VarCurr)
    <=> v113375(VarCurr) ) ).

tff(addAssignment_67299,axiom,
    ! [VarCurr: state_type] :
      ( v113375(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67298,axiom,
    ! [VarCurr: state_type] :
      ( v113336(VarCurr,2)
    <=> v113338(VarCurr,2) ) ).

tff(addAssignment_67297,axiom,
    ! [VarCurr: state_type] :
      ( v113338(VarCurr,2)
    <=> v113364(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113364(VarCurr,B)
      <=> ( v113365(VarCurr,B)
          | v113368(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113368(VarCurr,B)
      <=> ( v113324(VarCurr,B)
          & v113369(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113369(VarCurr,B)
      <=> ~ v113370(VarCurr,B) ) ) ).

tff(addAssignment_67296,axiom,
    ! [VarCurr: state_type] :
      ( v113370(VarCurr,0)
    <=> v113371(VarCurr) ) ).

tff(addAssignment_67295,axiom,
    ! [VarCurr: state_type] :
      ( v113370(VarCurr,1)
    <=> v113371(VarCurr) ) ).

tff(addAssignment_67294,axiom,
    ! [VarCurr: state_type] :
      ( v113370(VarCurr,2)
    <=> v113371(VarCurr) ) ).

tff(addAssignment_67293,axiom,
    ! [VarCurr: state_type] :
      ( v113371(VarCurr)
    <=> v113359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113365(VarCurr,B)
      <=> ( v113340(VarCurr,B)
          & v113366(VarCurr,B) ) ) ) ).

tff(addAssignment_67292,axiom,
    ! [VarCurr: state_type] :
      ( v113366(VarCurr,0)
    <=> v113367(VarCurr) ) ).

tff(addAssignment_67291,axiom,
    ! [VarCurr: state_type] :
      ( v113366(VarCurr,1)
    <=> v113367(VarCurr) ) ).

tff(addAssignment_67290,axiom,
    ! [VarCurr: state_type] :
      ( v113366(VarCurr,2)
    <=> v113367(VarCurr) ) ).

tff(addAssignment_67289,axiom,
    ! [VarCurr: state_type] :
      ( v113367(VarCurr)
    <=> v113359(VarCurr) ) ).

tff(addAssignment_67288,axiom,
    ! [VarCurr: state_type] :
      ( v113359(VarCurr)
    <=> v113361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11848,axiom,
    ! [VarCurr: state_type] :
      ( v113361(VarCurr)
    <=> ( v1729(VarCurr)
        & v113363(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_991,axiom,
    ! [VarCurr: state_type] :
      ( v113363(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67287,axiom,
    ! [VarCurr: state_type] :
      ( v113340(VarCurr,2)
    <=> v113356(VarCurr,2) ) ).

tff(addAssignment_67286,axiom,
    ! [VarCurr: state_type] :
      ( v113356(VarCurr,0)
    <=> v113342(VarCurr,0) ) ).

tff(addAssignment_67285,axiom,
    ! [VarCurr: state_type] :
      ( v113356(VarCurr,1)
    <=> v113357(VarCurr) ) ).

tff(addAssignment_67284,axiom,
    ! [VarCurr: state_type] :
      ( v113356(VarCurr,2)
    <=> v113342(VarCurr,2) ) ).

tff(addAssignment_67283,axiom,
    ! [VarCurr: state_type] :
      ( v113342(VarCurr,2)
    <=> v113344(VarCurr,2) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113344(VarCurr,B)
          <=> v113353(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1003,axiom,
    ! [VarCurr: state_type] :
      ( v113345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113344(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113353(VarCurr,B)
          <=> v113322(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1002,axiom,
    ! [VarCurr: state_type] :
      ( v113354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113353(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11847,axiom,
    ! [VarCurr: state_type] :
      ( v113354(VarCurr)
    <=> ( v1729(VarCurr)
        & v113355(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_990,axiom,
    ! [VarCurr: state_type] :
      ( v113355(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11846,axiom,
    ! [VarCurr: state_type] :
      ( v113345(VarCurr)
    <=> ( v113346(VarCurr)
        & v113348(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4776,axiom,
    ! [VarCurr: state_type] :
      ( v113348(VarCurr)
    <=> ( v1119(VarCurr,2)
        | v113350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11845,axiom,
    ! [VarCurr: state_type] :
      ( v113350(VarCurr)
    <=> ( v113351(VarCurr)
        & v113352(VarCurr) ) ) ).

tff(writeUnaryOperator_6323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113352(VarCurr)
    <=> v1119(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4775,axiom,
    ! [VarCurr: state_type] :
      ( v113351(VarCurr)
    <=> ( v1119(VarCurr,0)
        & v1119(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11844,axiom,
    ! [VarCurr: state_type] :
      ( v113346(VarCurr)
    <=> ( v1729(VarCurr)
        & v113347(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_989,axiom,
    ! [VarCurr: state_type] :
      ( v113347(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1886,axiom,
    ~ b0000010101000(12) ).

tff(bitBlastConstant_1885,axiom,
    ~ b0000010101000(11) ).

tff(bitBlastConstant_1884,axiom,
    ~ b0000010101000(10) ).

tff(bitBlastConstant_1883,axiom,
    ~ b0000010101000(9) ).

tff(bitBlastConstant_1882,axiom,
    ~ b0000010101000(8) ).

tff(bitBlastConstant_1881,axiom,
    b0000010101000(7) ).

tff(bitBlastConstant_1880,axiom,
    ~ b0000010101000(6) ).

tff(bitBlastConstant_1879,axiom,
    b0000010101000(5) ).

tff(bitBlastConstant_1878,axiom,
    ~ b0000010101000(4) ).

tff(bitBlastConstant_1877,axiom,
    b0000010101000(3) ).

tff(bitBlastConstant_1876,axiom,
    ~ b0000010101000(2) ).

tff(bitBlastConstant_1875,axiom,
    ~ b0000010101000(1) ).

tff(bitBlastConstant_1874,axiom,
    ~ b0000010101000(0) ).

tff(addAssignment_67282,axiom,
    ! [VarCurr: state_type] :
      ( v113332(VarCurr)
    <=> v113334(VarCurr) ) ).

tff(addAssignment_67281,axiom,
    ! [VarCurr: state_type] :
      ( v113334(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67280,axiom,
    ! [VarCurr: state_type] :
      ( v113328(VarCurr)
    <=> v113330(VarCurr) ) ).

tff(addAssignment_67279,axiom,
    ! [VarCurr: state_type] :
      ( v113330(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_67278,axiom,
    ! [VarCurr: state_type] :
      ( v113178(VarCurr,0)
    <=> v113316(VarCurr) ) ).

tff(addAssignment_67277,axiom,
    ! [VarCurr: state_type] :
      ( v113178(VarCurr,1)
    <=> v113311(VarCurr) ) ).

tff(addAssignment_67276,axiom,
    ! [VarCurr: state_type] :
      ( v113178(VarCurr,2)
    <=> v113306(VarCurr) ) ).

tff(addAssignment_67275,axiom,
    ! [VarCurr: state_type] :
      ( v113178(VarCurr,3)
    <=> v113301(VarCurr) ) ).

tff(addAssignment_67274,axiom,
    ! [VarCurr: state_type] :
      ( v113178(VarCurr,4)
    <=> v113263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11843,axiom,
    ! [VarCurr: state_type] :
      ( v113316(VarCurr)
    <=> ( v113317(VarCurr)
        & v113320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11842,axiom,
    ! [VarCurr: state_type] :
      ( v113320(VarCurr)
    <=> ( v113273(VarCurr,0)
        | v113274(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11841,axiom,
    ! [VarCurr: state_type] :
      ( v113317(VarCurr)
    <=> ( v113318(VarCurr)
        | v113319(VarCurr) ) ) ).

tff(writeUnaryOperator_6322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113319(VarCurr)
    <=> v113274(VarCurr,0) ) ).

tff(writeUnaryOperator_6321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113318(VarCurr)
    <=> v113273(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11840,axiom,
    ! [VarCurr: state_type] :
      ( v113311(VarCurr)
    <=> ( v113312(VarCurr)
        & v113315(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11839,axiom,
    ! [VarCurr: state_type] :
      ( v113315(VarCurr)
    <=> ( v113272(VarCurr)
        | v113276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11838,axiom,
    ! [VarCurr: state_type] :
      ( v113312(VarCurr)
    <=> ( v113313(VarCurr)
        | v113314(VarCurr) ) ) ).

tff(writeUnaryOperator_6320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113314(VarCurr)
    <=> v113276(VarCurr) ) ).

tff(writeUnaryOperator_6319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113313(VarCurr)
    <=> v113272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11837,axiom,
    ! [VarCurr: state_type] :
      ( v113306(VarCurr)
    <=> ( v113307(VarCurr)
        & v113310(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11836,axiom,
    ! [VarCurr: state_type] :
      ( v113310(VarCurr)
    <=> ( v113270(VarCurr)
        | v113282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11835,axiom,
    ! [VarCurr: state_type] :
      ( v113307(VarCurr)
    <=> ( v113308(VarCurr)
        | v113309(VarCurr) ) ) ).

tff(writeUnaryOperator_6318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113309(VarCurr)
    <=> v113282(VarCurr) ) ).

tff(writeUnaryOperator_6317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113308(VarCurr)
    <=> v113270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11834,axiom,
    ! [VarCurr: state_type] :
      ( v113301(VarCurr)
    <=> ( v113302(VarCurr)
        & v113305(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11833,axiom,
    ! [VarCurr: state_type] :
      ( v113305(VarCurr)
    <=> ( v113268(VarCurr)
        | v113288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11832,axiom,
    ! [VarCurr: state_type] :
      ( v113302(VarCurr)
    <=> ( v113303(VarCurr)
        | v113304(VarCurr) ) ) ).

tff(writeUnaryOperator_6316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113304(VarCurr)
    <=> v113288(VarCurr) ) ).

tff(writeUnaryOperator_6315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113303(VarCurr)
    <=> v113268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11831,axiom,
    ! [VarCurr: state_type] :
      ( v113263(VarCurr)
    <=> ( v113264(VarCurr)
        & v113300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11830,axiom,
    ! [VarCurr: state_type] :
      ( v113300(VarCurr)
    <=> ( v113266(VarCurr)
        | v113295(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11829,axiom,
    ! [VarCurr: state_type] :
      ( v113264(VarCurr)
    <=> ( v113265(VarCurr)
        | v113294(VarCurr) ) ) ).

tff(writeUnaryOperator_6314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113294(VarCurr)
    <=> v113295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11828,axiom,
    ! [VarCurr: state_type] :
      ( v113295(VarCurr)
    <=> ( v113296(VarCurr)
        & v113299(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4774,axiom,
    ! [VarCurr: state_type] :
      ( v113299(VarCurr)
    <=> ( v113273(VarCurr,4)
        | v113274(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11827,axiom,
    ! [VarCurr: state_type] :
      ( v113296(VarCurr)
    <=> ( v113297(VarCurr)
        | v113298(VarCurr) ) ) ).

tff(writeUnaryOperator_6313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113298(VarCurr)
    <=> v113274(VarCurr,4) ) ).

tff(writeUnaryOperator_6312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113297(VarCurr)
    <=> v113273(VarCurr,4) ) ).

tff(writeUnaryOperator_6311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113265(VarCurr)
    <=> v113266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11826,axiom,
    ! [VarCurr: state_type] :
      ( v113266(VarCurr)
    <=> ( v113267(VarCurr)
        | v113293(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4773,axiom,
    ! [VarCurr: state_type] :
      ( v113293(VarCurr)
    <=> ( v113273(VarCurr,3)
        & v113274(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11825,axiom,
    ! [VarCurr: state_type] :
      ( v113267(VarCurr)
    <=> ( v113268(VarCurr)
        & v113288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11824,axiom,
    ! [VarCurr: state_type] :
      ( v113288(VarCurr)
    <=> ( v113289(VarCurr)
        & v113292(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4772,axiom,
    ! [VarCurr: state_type] :
      ( v113292(VarCurr)
    <=> ( v113273(VarCurr,3)
        | v113274(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11823,axiom,
    ! [VarCurr: state_type] :
      ( v113289(VarCurr)
    <=> ( v113290(VarCurr)
        | v113291(VarCurr) ) ) ).

tff(writeUnaryOperator_6310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113291(VarCurr)
    <=> v113274(VarCurr,3) ) ).

tff(writeUnaryOperator_6309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113290(VarCurr)
    <=> v113273(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11822,axiom,
    ! [VarCurr: state_type] :
      ( v113268(VarCurr)
    <=> ( v113269(VarCurr)
        | v113287(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4771,axiom,
    ! [VarCurr: state_type] :
      ( v113287(VarCurr)
    <=> ( v113273(VarCurr,2)
        & v113274(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11821,axiom,
    ! [VarCurr: state_type] :
      ( v113269(VarCurr)
    <=> ( v113270(VarCurr)
        & v113282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11820,axiom,
    ! [VarCurr: state_type] :
      ( v113282(VarCurr)
    <=> ( v113283(VarCurr)
        & v113286(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4770,axiom,
    ! [VarCurr: state_type] :
      ( v113286(VarCurr)
    <=> ( v113273(VarCurr,2)
        | v113274(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11819,axiom,
    ! [VarCurr: state_type] :
      ( v113283(VarCurr)
    <=> ( v113284(VarCurr)
        | v113285(VarCurr) ) ) ).

tff(writeUnaryOperator_6308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113285(VarCurr)
    <=> v113274(VarCurr,2) ) ).

tff(writeUnaryOperator_6307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113284(VarCurr)
    <=> v113273(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11818,axiom,
    ! [VarCurr: state_type] :
      ( v113270(VarCurr)
    <=> ( v113271(VarCurr)
        | v113281(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4769,axiom,
    ! [VarCurr: state_type] :
      ( v113281(VarCurr)
    <=> ( v113273(VarCurr,1)
        & v113274(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11817,axiom,
    ! [VarCurr: state_type] :
      ( v113271(VarCurr)
    <=> ( v113272(VarCurr)
        & v113276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11816,axiom,
    ! [VarCurr: state_type] :
      ( v113276(VarCurr)
    <=> ( v113277(VarCurr)
        & v113280(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4768,axiom,
    ! [VarCurr: state_type] :
      ( v113280(VarCurr)
    <=> ( v113273(VarCurr,1)
        | v113274(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11815,axiom,
    ! [VarCurr: state_type] :
      ( v113277(VarCurr)
    <=> ( v113278(VarCurr)
        | v113279(VarCurr) ) ) ).

tff(writeUnaryOperator_6306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113279(VarCurr)
    <=> v113274(VarCurr,1) ) ).

tff(writeUnaryOperator_6305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113278(VarCurr)
    <=> v113273(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11814,axiom,
    ! [VarCurr: state_type] :
      ( v113272(VarCurr)
    <=> ( v113273(VarCurr,0)
        & v113274(VarCurr,0) ) ) ).

tff(addZeroExtensionConstraint_47,axiom,
    ! [VarCurr: state_type] : ~ v113274(VarCurr,3) ).

tff(addZeroExtensionConstraint_46,axiom,
    ! [VarCurr: state_type] : ~ v113274(VarCurr,4) ).

tff(addAssignment_67273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113274(VarCurr,B)
      <=> v113275(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113275(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1001,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v113275(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addAssignment_67272,axiom,
    ! [VarCurr: state_type] :
      ( ( v113273(VarCurr,2)
      <=> v113180(VarCurr,5) )
      & ( v113273(VarCurr,1)
      <=> v113180(VarCurr,4) )
      & ( v113273(VarCurr,0)
      <=> v113180(VarCurr,3) ) ) ).

tff(addAssignment_67271,axiom,
    ! [VarCurr: state_type] :
      ( ( v113273(VarCurr,4)
      <=> $false )
      & ( v113273(VarCurr,3)
      <=> $false ) ) ).

tff(addAssignment_67270,axiom,
    ! [VarCurr: state_type] :
      ( v113180(VarCurr,5)
    <=> v113184(VarCurr,5) ) ).

tff(addAssignment_67269,axiom,
    ! [VarCurr: state_type] :
      ( v113184(VarCurr,5)
    <=> v113186(VarCurr,5) ) ).

tff(addAssignment_67268,axiom,
    ! [VarNext: state_type] :
      ( v113186(VarNext,5)
    <=> v113254(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v113254(VarNext,B)
            <=> v113186(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1472,axiom,
    ! [VarNext: state_type] :
      ( v113255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113254(VarNext,B)
          <=> v113238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113255(VarNext)
      <=> v113256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113256(VarNext)
      <=> ( v113258(VarNext)
          & v113223(VarNext) ) ) ) ).

tff(writeUnaryOperator_6304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113258(VarNext)
      <=> v113232(VarNext) ) ) ).

tff(addAssignment_67267,axiom,
    ! [VarCurr: state_type] :
      ( v113196(VarCurr,5)
    <=> v113198(VarCurr,5) ) ).

tff(addAssignment_67266,axiom,
    ! [VarCurr: state_type] :
      ( v113198(VarCurr,5)
    <=> v113214(VarCurr,5) ) ).

tff(addAssignment_67265,axiom,
    ! [VarCurr: state_type] :
      ( v113200(VarCurr,5)
    <=> v113206(VarCurr,5) ) ).

tff(addAssignment_67264,axiom,
    ! [VarCurr: state_type] :
      ( v113204(VarCurr,5)
    <=> v1119(VarCurr,5) ) ).

tff(addAssignment_67263,axiom,
    ! [VarCurr: state_type] :
      ( v113180(VarCurr,4)
    <=> v113244(VarCurr,1) ) ).

tff(addAssignment_67262,axiom,
    ! [VarCurr: state_type] :
      ( v113182(VarCurr,1)
    <=> v113184(VarCurr,4) ) ).

tff(addAssignment_67261,axiom,
    ! [VarCurr: state_type] :
      ( v113184(VarCurr,4)
    <=> v113186(VarCurr,4) ) ).

tff(addAssignment_67260,axiom,
    ! [VarNext: state_type] :
      ( v113186(VarNext,4)
    <=> v113246(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113247(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v113246(VarNext,B)
            <=> v113186(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1471,axiom,
    ! [VarNext: state_type] :
      ( v113247(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113246(VarNext,B)
          <=> v113238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113247(VarNext)
      <=> v113248(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113248(VarNext)
      <=> ( v113250(VarNext)
          & v113223(VarNext) ) ) ) ).

tff(writeUnaryOperator_6303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113250(VarNext)
      <=> v113232(VarNext) ) ) ).

tff(addAssignment_67259,axiom,
    ! [VarCurr: state_type] :
      ( v113196(VarCurr,4)
    <=> v113198(VarCurr,4) ) ).

tff(addAssignment_67258,axiom,
    ! [VarCurr: state_type] :
      ( v113198(VarCurr,4)
    <=> v113214(VarCurr,4) ) ).

tff(addAssignment_67257,axiom,
    ! [VarCurr: state_type] :
      ( v113200(VarCurr,4)
    <=> v113206(VarCurr,4) ) ).

tff(addAssignment_67256,axiom,
    ! [VarCurr: state_type] :
      ( v113202(VarCurr,1)
    <=> v113205(VarCurr,1) ) ).

tff(addAssignment_67255,axiom,
    ! [VarCurr: state_type] :
      ( v113204(VarCurr,4)
    <=> v1119(VarCurr,4) ) ).

tff(addAssignment_67254,axiom,
    ! [VarCurr: state_type] :
      ( v113180(VarCurr,3)
    <=> v113244(VarCurr,0) ) ).

tff(writeUnaryOperator_6302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v113244(VarCurr,B)
      <=> ~ v113182(VarCurr,B) ) ) ).

tff(addAssignment_67253,axiom,
    ! [VarCurr: state_type] :
      ( v113182(VarCurr,0)
    <=> v113184(VarCurr,3) ) ).

tff(addAssignment_67252,axiom,
    ! [VarCurr: state_type] :
      ( v113184(VarCurr,3)
    <=> v113186(VarCurr,3) ) ).

tff(addAssignment_67251,axiom,
    ! [VarNext: state_type] :
      ( v113186(VarNext,3)
    <=> v113227(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v113227(VarNext,B)
            <=> v113186(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1470,axiom,
    ! [VarNext: state_type] :
      ( v113228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113227(VarNext,B)
          <=> v113238(VarNext,B) ) ) ) ).

tff(addAssignment_67250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113238(VarNext,B)
          <=> v113236(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113236(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1000,axiom,
    ! [VarCurr: state_type] :
      ( v113239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v113236(VarCurr,B)
          <=> v113196(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11809,axiom,
    ! [VarCurr: state_type] :
      ( v113239(VarCurr)
    <=> ( v113240(VarCurr)
        & v113241(VarCurr) ) ) ).

tff(writeUnaryOperator_6301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113241(VarCurr)
    <=> v113192(VarCurr) ) ).

tff(writeUnaryOperator_6300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113240(VarCurr)
    <=> v113188(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113228(VarNext)
      <=> v113229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113229(VarNext)
      <=> ( v113230(VarNext)
          & v113223(VarNext) ) ) ) ).

tff(writeUnaryOperator_6299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113230(VarNext)
      <=> v113232(VarNext) ) ) ).

tff(addAssignment_67249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113232(VarNext)
      <=> v113223(VarCurr) ) ) ).

tff(addAssignment_67248,axiom,
    ! [VarCurr: state_type] :
      ( v113223(VarCurr)
    <=> v113225(VarCurr) ) ).

tff(addAssignment_67247,axiom,
    ! [VarCurr: state_type] :
      ( v113225(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_67246,axiom,
    ! [VarCurr: state_type] :
      ( v113196(VarCurr,3)
    <=> v113198(VarCurr,3) ) ).

tff(addAssignment_67245,axiom,
    ! [VarCurr: state_type] :
      ( v113198(VarCurr,3)
    <=> v113214(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v113214(VarCurr,B)
      <=> ( v113215(VarCurr,B)
          | v113218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v113218(VarCurr,B)
      <=> ( v113184(VarCurr,B)
          & v113219(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v113219(VarCurr,B)
      <=> ~ v113220(VarCurr,B) ) ) ).

tff(addAssignment_67244,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,0)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67243,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,1)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67242,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,2)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67241,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,3)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67240,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,4)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67239,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,5)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67238,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,6)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67237,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,7)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67236,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,8)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67235,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,9)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67234,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,10)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67233,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,11)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67232,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,12)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67231,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,13)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67230,axiom,
    ! [VarCurr: state_type] :
      ( v113220(VarCurr,14)
    <=> v113221(VarCurr) ) ).

tff(addAssignment_67229,axiom,
    ! [VarCurr: state_type] :
      ( v113221(VarCurr)
    <=> v113208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v113215(VarCurr,B)
      <=> ( v113200(VarCurr,B)
          & v113216(VarCurr,B) ) ) ) ).

tff(addAssignment_67228,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,0)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67227,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,1)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67226,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,2)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67225,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,3)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67224,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,4)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67223,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,5)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67222,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,6)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67221,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,7)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67220,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,8)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67219,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,9)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67218,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,10)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67217,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,11)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67216,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,12)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67215,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,13)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67214,axiom,
    ! [VarCurr: state_type] :
      ( v113216(VarCurr,14)
    <=> v113217(VarCurr) ) ).

tff(addAssignment_67213,axiom,
    ! [VarCurr: state_type] :
      ( v113217(VarCurr)
    <=> v113208(VarCurr) ) ).

tff(addAssignment_67212,axiom,
    ! [VarCurr: state_type] :
      ( v113208(VarCurr)
    <=> v113210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11806,axiom,
    ! [VarCurr: state_type] :
      ( v113210(VarCurr)
    <=> ( v1729(VarCurr)
        & v113213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_988,axiom,
    ! [VarCurr: state_type] :
      ( v113213(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1873,axiom,
    ~ b0000100011000(12) ).

tff(bitBlastConstant_1872,axiom,
    ~ b0000100011000(11) ).

tff(bitBlastConstant_1871,axiom,
    ~ b0000100011000(10) ).

tff(bitBlastConstant_1870,axiom,
    ~ b0000100011000(9) ).

tff(bitBlastConstant_1869,axiom,
    b0000100011000(8) ).

tff(bitBlastConstant_1868,axiom,
    ~ b0000100011000(7) ).

tff(bitBlastConstant_1867,axiom,
    ~ b0000100011000(6) ).

tff(bitBlastConstant_1866,axiom,
    ~ b0000100011000(5) ).

tff(bitBlastConstant_1865,axiom,
    b0000100011000(4) ).

tff(bitBlastConstant_1864,axiom,
    b0000100011000(3) ).

tff(bitBlastConstant_1863,axiom,
    ~ b0000100011000(2) ).

tff(bitBlastConstant_1862,axiom,
    ~ b0000100011000(1) ).

tff(bitBlastConstant_1861,axiom,
    ~ b0000100011000(0) ).

tff(addAssignment_67211,axiom,
    ! [VarCurr: state_type] :
      ( v113200(VarCurr,3)
    <=> v113206(VarCurr,3) ) ).

tff(addAssignment_67210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113206(VarCurr,B)
      <=> v113204(VarCurr,B) ) ) ).

tff(addAssignment_67209,axiom,
    ! [VarCurr: state_type] :
      ( ( v113206(VarCurr,4)
      <=> v113202(VarCurr,1) )
      & ( v113206(VarCurr,3)
      <=> v113202(VarCurr,0) ) ) ).

tff(addAssignment_67208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,5) )
     => ( v113206(VarCurr,B)
      <=> v113204(VarCurr,B) ) ) ).

tff(addAssignment_67207,axiom,
    ! [VarCurr: state_type] :
      ( v113202(VarCurr,0)
    <=> v113205(VarCurr,0) ) ).

tff(writeUnaryOperator_6297,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v113205(VarCurr,1)
      <=> v113204(VarCurr,4) )
      & ( ~ v113205(VarCurr,0)
      <=> v113204(VarCurr,3) ) ) ).

tff(addAssignment_67206,axiom,
    ! [VarCurr: state_type] :
      ( v113204(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_67205,axiom,
    ! [VarCurr: state_type] :
      ( v113192(VarCurr)
    <=> v113194(VarCurr) ) ).

tff(addAssignment_67204,axiom,
    ! [VarCurr: state_type] :
      ( v113194(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67203,axiom,
    ! [VarCurr: state_type] :
      ( v113188(VarCurr)
    <=> v113190(VarCurr) ) ).

tff(addAssignment_67202,axiom,
    ! [VarCurr: state_type] :
      ( v113190(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_67201,axiom,
    ! [VarCurr: state_type] :
      ( v113162(VarCurr)
    <=> v113164(VarCurr) ) ).

tff(addAssignment_67200,axiom,
    ! [VarCurr: state_type] :
      ( v113164(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_67199,axiom,
    ! [VarCurr: state_type] :
      ( v113158(VarCurr)
    <=> v113160(VarCurr) ) ).

tff(addAssignment_67198,axiom,
    ! [VarCurr: state_type] :
      ( v113160(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11805,axiom,
    ! [VarCurr: state_type] :
      ( v112936(VarCurr)
    <=> ( v113147(VarCurr)
        | v113105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11804,axiom,
    ! [VarCurr: state_type] :
      ( v113147(VarCurr)
    <=> ( v113148(VarCurr)
        | v113098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11803,axiom,
    ! [VarCurr: state_type] :
      ( v113148(VarCurr)
    <=> ( v112938(VarCurr)
        | v113018(VarCurr) ) ) ).

tff(addAssignment_67197,axiom,
    ! [VarCurr: state_type] :
      ( v113105(VarCurr)
    <=> v113107(VarCurr,0) ) ).

tff(addAssignment_67196,axiom,
    ! [VarCurr: state_type] :
      ( v113107(VarCurr,0)
    <=> v113143(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113143(VarCurr,B)
      <=> ( v113144(VarCurr,B)
          & v113109(VarCurr,B) ) ) ) ).

tff(addAssignment_67195,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,0)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67194,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,1)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67193,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,2)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67192,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,3)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67191,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,4)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67190,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,5)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67189,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,6)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67188,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,7)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67187,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,8)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67186,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,9)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67185,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,10)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67184,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,11)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67183,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,12)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67182,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,13)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67181,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,14)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67180,axiom,
    ! [VarCurr: state_type] :
      ( v113144(VarCurr,15)
    <=> v113145(VarCurr) ) ).

tff(addAssignment_67179,axiom,
    ! [VarCurr: state_type] :
      ( v113145(VarCurr)
    <=> v777(VarCurr) ) ).

tff(addAssignment_67178,axiom,
    ! [VarCurr: state_type] :
      ( v113109(VarCurr,0)
    <=> v113110(VarCurr,0) ) ).

tff(addAssignment_67177,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,0)
    <=> v113141(VarCurr) ) ).

tff(addAssignment_67176,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,1)
    <=> v113139(VarCurr) ) ).

tff(addAssignment_67175,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,2)
    <=> v113137(VarCurr) ) ).

tff(addAssignment_67174,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,3)
    <=> v113135(VarCurr) ) ).

tff(addAssignment_67173,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,4)
    <=> v113133(VarCurr) ) ).

tff(addAssignment_67172,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,5)
    <=> v113131(VarCurr) ) ).

tff(addAssignment_67171,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,6)
    <=> v113129(VarCurr) ) ).

tff(addAssignment_67170,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,7)
    <=> v113127(VarCurr) ) ).

tff(addAssignment_67169,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,8)
    <=> v113125(VarCurr) ) ).

tff(addAssignment_67168,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,9)
    <=> v113123(VarCurr) ) ).

tff(addAssignment_67167,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,10)
    <=> v113121(VarCurr) ) ).

tff(addAssignment_67166,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,11)
    <=> v113119(VarCurr) ) ).

tff(addAssignment_67165,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,12)
    <=> v113117(VarCurr) ) ).

tff(addAssignment_67164,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,13)
    <=> v113115(VarCurr) ) ).

tff(addAssignment_67163,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,14)
    <=> v113113(VarCurr) ) ).

tff(addAssignment_67162,axiom,
    ! [VarCurr: state_type] :
      ( v113110(VarCurr,15)
    <=> v113111(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_987,axiom,
    ! [VarCurr: state_type] :
      ( v113141(VarCurr)
    <=> ( ( v113142(VarCurr,3)
        <=> $false )
        & ( v113142(VarCurr,2)
        <=> $false )
        & ( v113142(VarCurr,1)
        <=> $false )
        & ( v113142(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113142(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67160,axiom,
    ! [VarCurr: state_type] :
      ( v113142(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_986,axiom,
    ! [VarCurr: state_type] :
      ( v113139(VarCurr)
    <=> ( ( v113140(VarCurr,3)
        <=> $false )
        & ( v113140(VarCurr,2)
        <=> $false )
        & ( v113140(VarCurr,1)
        <=> $false )
        & ( v113140(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113140(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67158,axiom,
    ! [VarCurr: state_type] :
      ( v113140(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_985,axiom,
    ! [VarCurr: state_type] :
      ( v113137(VarCurr)
    <=> ( ( v113138(VarCurr,3)
        <=> $false )
        & ( v113138(VarCurr,2)
        <=> $false )
        & ( v113138(VarCurr,1)
        <=> $true )
        & ( v113138(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113138(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67156,axiom,
    ! [VarCurr: state_type] :
      ( v113138(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_984,axiom,
    ! [VarCurr: state_type] :
      ( v113135(VarCurr)
    <=> ( ( v113136(VarCurr,3)
        <=> $false )
        & ( v113136(VarCurr,2)
        <=> $false )
        & ( v113136(VarCurr,1)
        <=> $true )
        & ( v113136(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113136(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67154,axiom,
    ! [VarCurr: state_type] :
      ( v113136(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_983,axiom,
    ! [VarCurr: state_type] :
      ( v113133(VarCurr)
    <=> ( ( v113134(VarCurr,3)
        <=> $false )
        & ( v113134(VarCurr,2)
        <=> $true )
        & ( v113134(VarCurr,1)
        <=> $false )
        & ( v113134(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113134(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67152,axiom,
    ! [VarCurr: state_type] :
      ( v113134(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_982,axiom,
    ! [VarCurr: state_type] :
      ( v113131(VarCurr)
    <=> ( ( v113132(VarCurr,3)
        <=> $false )
        & ( v113132(VarCurr,2)
        <=> $true )
        & ( v113132(VarCurr,1)
        <=> $false )
        & ( v113132(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113132(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67150,axiom,
    ! [VarCurr: state_type] :
      ( v113132(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_981,axiom,
    ! [VarCurr: state_type] :
      ( v113129(VarCurr)
    <=> ( ( v113130(VarCurr,3)
        <=> $false )
        & ( v113130(VarCurr,2)
        <=> $true )
        & ( v113130(VarCurr,1)
        <=> $true )
        & ( v113130(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113130(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67148,axiom,
    ! [VarCurr: state_type] :
      ( v113130(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_980,axiom,
    ! [VarCurr: state_type] :
      ( v113127(VarCurr)
    <=> ( ( v113128(VarCurr,3)
        <=> $false )
        & ( v113128(VarCurr,2)
        <=> $true )
        & ( v113128(VarCurr,1)
        <=> $true )
        & ( v113128(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113128(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67146,axiom,
    ! [VarCurr: state_type] :
      ( v113128(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_979,axiom,
    ! [VarCurr: state_type] :
      ( v113125(VarCurr)
    <=> ( ( v113126(VarCurr,3)
        <=> $true )
        & ( v113126(VarCurr,2)
        <=> $false )
        & ( v113126(VarCurr,1)
        <=> $false )
        & ( v113126(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113126(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67144,axiom,
    ! [VarCurr: state_type] :
      ( v113126(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_978,axiom,
    ! [VarCurr: state_type] :
      ( v113123(VarCurr)
    <=> ( ( v113124(VarCurr,3)
        <=> $true )
        & ( v113124(VarCurr,2)
        <=> $false )
        & ( v113124(VarCurr,1)
        <=> $false )
        & ( v113124(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113124(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67142,axiom,
    ! [VarCurr: state_type] :
      ( v113124(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_977,axiom,
    ! [VarCurr: state_type] :
      ( v113121(VarCurr)
    <=> ( ( v113122(VarCurr,3)
        <=> $true )
        & ( v113122(VarCurr,2)
        <=> $false )
        & ( v113122(VarCurr,1)
        <=> $true )
        & ( v113122(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113122(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67140,axiom,
    ! [VarCurr: state_type] :
      ( v113122(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_976,axiom,
    ! [VarCurr: state_type] :
      ( v113119(VarCurr)
    <=> ( ( v113120(VarCurr,3)
        <=> $true )
        & ( v113120(VarCurr,2)
        <=> $false )
        & ( v113120(VarCurr,1)
        <=> $true )
        & ( v113120(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113120(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67138,axiom,
    ! [VarCurr: state_type] :
      ( v113120(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_975,axiom,
    ! [VarCurr: state_type] :
      ( v113117(VarCurr)
    <=> ( ( v113118(VarCurr,3)
        <=> $true )
        & ( v113118(VarCurr,2)
        <=> $true )
        & ( v113118(VarCurr,1)
        <=> $false )
        & ( v113118(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113118(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67136,axiom,
    ! [VarCurr: state_type] :
      ( v113118(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_974,axiom,
    ! [VarCurr: state_type] :
      ( v113115(VarCurr)
    <=> ( ( v113116(VarCurr,3)
        <=> $true )
        & ( v113116(VarCurr,2)
        <=> $true )
        & ( v113116(VarCurr,1)
        <=> $false )
        & ( v113116(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113116(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67134,axiom,
    ! [VarCurr: state_type] :
      ( v113116(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_973,axiom,
    ! [VarCurr: state_type] :
      ( v113113(VarCurr)
    <=> ( ( v113114(VarCurr,3)
        <=> $true )
        & ( v113114(VarCurr,2)
        <=> $true )
        & ( v113114(VarCurr,1)
        <=> $true )
        & ( v113114(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113114(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67132,axiom,
    ! [VarCurr: state_type] :
      ( v113114(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_972,axiom,
    ! [VarCurr: state_type] :
      ( v113111(VarCurr)
    <=> ( ( v113112(VarCurr,3)
        <=> $true )
        & ( v113112(VarCurr,2)
        <=> $true )
        & ( v113112(VarCurr,1)
        <=> $true )
        & ( v113112(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_67131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v113112(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_67130,axiom,
    ! [VarCurr: state_type] :
      ( v113112(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addAssignment_67129,axiom,
    ! [VarCurr: state_type] :
      ( v113098(VarCurr)
    <=> v113100(VarCurr,0) ) ).

tff(addAssignment_67128,axiom,
    ! [VarCurr: state_type] :
      ( v113100(VarCurr,0)
    <=> v113101(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113101(VarCurr,B)
      <=> ( v113102(VarCurr,B)
          & v89119(VarCurr,B) ) ) ) ).

tff(addAssignment_67127,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,0)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67126,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,1)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67125,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,2)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67124,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,3)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67123,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,4)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67122,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,5)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67121,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,6)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67120,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,7)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67119,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,8)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67118,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,9)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67117,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,10)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67116,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,11)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67115,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,12)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67114,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,13)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67113,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,14)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67112,axiom,
    ! [VarCurr: state_type] :
      ( v113102(VarCurr,15)
    <=> v113103(VarCurr) ) ).

tff(addAssignment_67111,axiom,
    ! [VarCurr: state_type] :
      ( v113103(VarCurr)
    <=> v86877(VarCurr) ) ).

tff(addAssignment_67110,axiom,
    ! [VarCurr: state_type] :
      ( v113018(VarCurr)
    <=> v113020(VarCurr,0) ) ).

tff(addAssignment_67109,axiom,
    ! [VarCurr: state_type] :
      ( v113020(VarCurr,0)
    <=> v113022(VarCurr,0) ) ).

tff(addAssignment_67108,axiom,
    ! [VarCurr: state_type] :
      ( v113022(VarCurr,0)
    <=> v113024(VarCurr,0) ) ).

tff(addAssignment_67107,axiom,
    ! [VarCurr: state_type] :
      ( v113024(VarCurr,0)
    <=> v113026(VarCurr,0) ) ).

tff(addAssignment_67106,axiom,
    ! [VarCurr: state_type] :
      ( v113026(VarCurr,0)
    <=> v113028(VarCurr,0) ) ).

tff(addAssignment_67105,axiom,
    ! [VarNext: state_type] :
      ( v113028(VarNext,0)
    <=> v113080(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113081(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v113080(VarNext,B)
            <=> v113028(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1469,axiom,
    ! [VarNext: state_type] :
      ( v113081(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113080(VarNext,B)
          <=> v113091(VarNext,B) ) ) ) ).

tff(addAssignment_67104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113091(VarNext,B)
          <=> v113089(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113092(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113089(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_999,axiom,
    ! [VarCurr: state_type] :
      ( v113092(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113089(VarCurr,B)
          <=> v113038(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11802,axiom,
    ! [VarCurr: state_type] :
      ( v113092(VarCurr)
    <=> ( v113093(VarCurr)
        & v113094(VarCurr) ) ) ).

tff(writeUnaryOperator_6296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113094(VarCurr)
    <=> v113034(VarCurr) ) ).

tff(writeUnaryOperator_6295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113093(VarCurr)
    <=> v113030(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113081(VarNext)
      <=> v113082(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113082(VarNext)
      <=> ( v113083(VarNext)
          & v113076(VarNext) ) ) ) ).

tff(writeUnaryOperator_6294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113083(VarNext)
      <=> v113085(VarNext) ) ) ).

tff(addAssignment_67103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113085(VarNext)
      <=> v113076(VarCurr) ) ) ).

tff(addAssignment_67102,axiom,
    ! [VarCurr: state_type] :
      ( v113076(VarCurr)
    <=> v113078(VarCurr) ) ).

tff(addAssignment_67101,axiom,
    ! [VarCurr: state_type] :
      ( v113078(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_67100,axiom,
    ! [VarCurr: state_type] :
      ( v113038(VarCurr,0)
    <=> v113040(VarCurr,0) ) ).

tff(addAssignment_67099,axiom,
    ! [VarCurr: state_type] :
      ( v113040(VarCurr,0)
    <=> v113042(VarCurr,0) ) ).

tff(addAssignment_67098,axiom,
    ! [VarCurr: state_type] :
      ( v113042(VarCurr,0)
    <=> v113044(VarCurr,0) ) ).

tff(addAssignment_67097,axiom,
    ! [VarCurr: state_type] :
      ( v113044(VarCurr,0)
    <=> v113045(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v113045(VarCurr,B)
      <=> ( v113046(VarCurr,B)
          & v113058(VarCurr,B) ) ) ) ).

tff(addAssignment_67096,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,0)
    <=> v113074(VarCurr) ) ).

tff(addAssignment_67095,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,1)
    <=> v113073(VarCurr) ) ).

tff(addAssignment_67094,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,2)
    <=> v113072(VarCurr) ) ).

tff(addAssignment_67093,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,3)
    <=> v113071(VarCurr) ) ).

tff(addAssignment_67092,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,4)
    <=> v113070(VarCurr) ) ).

tff(addAssignment_67091,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,5)
    <=> v113069(VarCurr) ) ).

tff(addAssignment_67090,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,6)
    <=> v113068(VarCurr) ) ).

tff(addAssignment_67089,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,7)
    <=> v113067(VarCurr) ) ).

tff(addAssignment_67088,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,8)
    <=> v113066(VarCurr) ) ).

tff(addAssignment_67087,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,9)
    <=> v113065(VarCurr) ) ).

tff(addAssignment_67086,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,10)
    <=> v113064(VarCurr) ) ).

tff(addAssignment_67085,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,11)
    <=> v113063(VarCurr) ) ).

tff(addAssignment_67084,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,12)
    <=> v113062(VarCurr) ) ).

tff(addAssignment_67083,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,13)
    <=> v113061(VarCurr) ) ).

tff(addAssignment_67082,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,14)
    <=> v113060(VarCurr) ) ).

tff(addAssignment_67081,axiom,
    ! [VarCurr: state_type] :
      ( v113058(VarCurr,15)
    <=> v113059(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_971,axiom,
    ! [VarCurr: state_type] :
      ( v113074(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_970,axiom,
    ! [VarCurr: state_type] :
      ( v113073(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_969,axiom,
    ! [VarCurr: state_type] :
      ( v113072(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_968,axiom,
    ! [VarCurr: state_type] :
      ( v113071(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_967,axiom,
    ! [VarCurr: state_type] :
      ( v113070(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_966,axiom,
    ! [VarCurr: state_type] :
      ( v113069(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_965,axiom,
    ! [VarCurr: state_type] :
      ( v113068(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_964,axiom,
    ! [VarCurr: state_type] :
      ( v113067(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $false )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_963,axiom,
    ! [VarCurr: state_type] :
      ( v113066(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_962,axiom,
    ! [VarCurr: state_type] :
      ( v113065(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_961,axiom,
    ! [VarCurr: state_type] :
      ( v113064(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_960,axiom,
    ! [VarCurr: state_type] :
      ( v113063(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $false )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_959,axiom,
    ! [VarCurr: state_type] :
      ( v113062(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_958,axiom,
    ! [VarCurr: state_type] :
      ( v113061(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $false )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_957,axiom,
    ! [VarCurr: state_type] :
      ( v113060(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_956,axiom,
    ! [VarCurr: state_type] :
      ( v113059(VarCurr)
    <=> ( ( v89247(VarCurr,7)
        <=> $true )
        & ( v89247(VarCurr,6)
        <=> $true )
        & ( v89247(VarCurr,5)
        <=> $true )
        & ( v89247(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_67080,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,0)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67079,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,1)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67078,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,2)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67077,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,3)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67076,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,4)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67075,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,5)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67074,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,6)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67073,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,7)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67072,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,8)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67071,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,9)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67070,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,10)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67069,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,11)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67068,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,12)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67067,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,13)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67066,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,14)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67065,axiom,
    ! [VarCurr: state_type] :
      ( v113046(VarCurr,15)
    <=> v113047(VarCurr) ) ).

tff(addAssignment_67064,axiom,
    ! [VarCurr: state_type] :
      ( v113047(VarCurr)
    <=> v113048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11799,axiom,
    ! [VarCurr: state_type] :
      ( v113048(VarCurr)
    <=> ( v113049(VarCurr)
        & v113057(VarCurr) ) ) ).

tff(writeUnaryOperator_6293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113057(VarCurr)
    <=> v89405(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4767,axiom,
    ! [VarCurr: state_type] :
      ( v113049(VarCurr)
    <=> ( v113051(VarCurr)
        | v89249(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4766,axiom,
    ! [VarCurr: state_type] :
      ( v113051(VarCurr)
    <=> ( v113052(VarCurr)
        | v89249(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4765,axiom,
    ! [VarCurr: state_type] :
      ( v113052(VarCurr)
    <=> ( v113053(VarCurr)
        | v89249(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4764,axiom,
    ! [VarCurr: state_type] :
      ( v113053(VarCurr)
    <=> ( v113054(VarCurr)
        | v89249(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4763,axiom,
    ! [VarCurr: state_type] :
      ( v113054(VarCurr)
    <=> ( v113055(VarCurr)
        | v89249(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4762,axiom,
    ! [VarCurr: state_type] :
      ( v113055(VarCurr)
    <=> ( v113056(VarCurr)
        | v89249(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4761,axiom,
    ! [VarCurr: state_type] :
      ( v113056(VarCurr)
    <=> ( v89249(VarCurr,0)
        | v89249(VarCurr,1) ) ) ).

tff(addAssignment_67063,axiom,
    ! [VarCurr: state_type] :
      ( v113034(VarCurr)
    <=> v113036(VarCurr) ) ).

tff(addAssignment_67062,axiom,
    ! [VarCurr: state_type] :
      ( v113036(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_67061,axiom,
    ! [VarCurr: state_type] :
      ( v113030(VarCurr)
    <=> v113032(VarCurr) ) ).

tff(addAssignment_67060,axiom,
    ! [VarCurr: state_type] :
      ( v113032(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_67059,axiom,
    ! [VarCurr: state_type] :
      ( v112938(VarCurr)
    <=> v112940(VarCurr,0) ) ).

tff(addAssignment_67058,axiom,
    ! [VarCurr: state_type] :
      ( v112940(VarCurr,0)
    <=> v112942(VarCurr,0) ) ).

tff(addAssignment_67057,axiom,
    ! [VarCurr: state_type] :
      ( v112942(VarCurr,0)
    <=> v112944(VarCurr,0) ) ).

tff(addAssignment_67056,axiom,
    ! [VarCurr: state_type] :
      ( v112944(VarCurr,0)
    <=> v112946(VarCurr,0) ) ).

tff(addAssignment_67055,axiom,
    ! [VarCurr: state_type] :
      ( v112946(VarCurr,0)
    <=> v112948(VarCurr,0) ) ).

tff(addAssignment_67054,axiom,
    ! [VarNext: state_type] :
      ( v112948(VarNext,0)
    <=> v113000(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113001(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v113000(VarNext,B)
            <=> v112948(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1468,axiom,
    ! [VarNext: state_type] :
      ( v113001(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113000(VarNext,B)
          <=> v113011(VarNext,B) ) ) ) ).

tff(addAssignment_67053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113011(VarNext,B)
          <=> v113009(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113009(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_998,axiom,
    ! [VarCurr: state_type] :
      ( v113012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v113009(VarCurr,B)
          <=> v112958(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11798,axiom,
    ! [VarCurr: state_type] :
      ( v113012(VarCurr)
    <=> ( v113013(VarCurr)
        & v113014(VarCurr) ) ) ).

tff(writeUnaryOperator_6292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113014(VarCurr)
    <=> v112954(VarCurr) ) ).

tff(writeUnaryOperator_6291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v113013(VarCurr)
    <=> v112950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113001(VarNext)
      <=> v113002(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113002(VarNext)
      <=> ( v113003(VarNext)
          & v112996(VarNext) ) ) ) ).

tff(writeUnaryOperator_6290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v113003(VarNext)
      <=> v113005(VarNext) ) ) ).

tff(addAssignment_67052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v113005(VarNext)
      <=> v112996(VarCurr) ) ) ).

tff(addAssignment_67051,axiom,
    ! [VarCurr: state_type] :
      ( v112996(VarCurr)
    <=> v112998(VarCurr) ) ).

tff(addAssignment_67050,axiom,
    ! [VarCurr: state_type] :
      ( v112998(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_67049,axiom,
    ! [VarCurr: state_type] :
      ( v112958(VarCurr,0)
    <=> v112960(VarCurr,0) ) ).

tff(addAssignment_67048,axiom,
    ! [VarCurr: state_type] :
      ( v112960(VarCurr,0)
    <=> v112962(VarCurr,0) ) ).

tff(addAssignment_67047,axiom,
    ! [VarCurr: state_type] :
      ( v112962(VarCurr,0)
    <=> v112964(VarCurr,0) ) ).

tff(addAssignment_67046,axiom,
    ! [VarCurr: state_type] :
      ( v112964(VarCurr,0)
    <=> v112965(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v112965(VarCurr,B)
      <=> ( v112966(VarCurr,B)
          & v112978(VarCurr,B) ) ) ) ).

tff(addAssignment_67045,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,0)
    <=> v112994(VarCurr) ) ).

tff(addAssignment_67044,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,1)
    <=> v112993(VarCurr) ) ).

tff(addAssignment_67043,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,2)
    <=> v112992(VarCurr) ) ).

tff(addAssignment_67042,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,3)
    <=> v112991(VarCurr) ) ).

tff(addAssignment_67041,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,4)
    <=> v112990(VarCurr) ) ).

tff(addAssignment_67040,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,5)
    <=> v112989(VarCurr) ) ).

tff(addAssignment_67039,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,6)
    <=> v112988(VarCurr) ) ).

tff(addAssignment_67038,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,7)
    <=> v112987(VarCurr) ) ).

tff(addAssignment_67037,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,8)
    <=> v112986(VarCurr) ) ).

tff(addAssignment_67036,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,9)
    <=> v112985(VarCurr) ) ).

tff(addAssignment_67035,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,10)
    <=> v112984(VarCurr) ) ).

tff(addAssignment_67034,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,11)
    <=> v112983(VarCurr) ) ).

tff(addAssignment_67033,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,12)
    <=> v112982(VarCurr) ) ).

tff(addAssignment_67032,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,13)
    <=> v112981(VarCurr) ) ).

tff(addAssignment_67031,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,14)
    <=> v112980(VarCurr) ) ).

tff(addAssignment_67030,axiom,
    ! [VarCurr: state_type] :
      ( v112978(VarCurr,15)
    <=> v112979(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_955,axiom,
    ! [VarCurr: state_type] :
      ( v112994(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_954,axiom,
    ! [VarCurr: state_type] :
      ( v112993(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_953,axiom,
    ! [VarCurr: state_type] :
      ( v112992(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_952,axiom,
    ! [VarCurr: state_type] :
      ( v112991(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_951,axiom,
    ! [VarCurr: state_type] :
      ( v112990(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_950,axiom,
    ! [VarCurr: state_type] :
      ( v112989(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_949,axiom,
    ! [VarCurr: state_type] :
      ( v112988(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_948,axiom,
    ! [VarCurr: state_type] :
      ( v112987(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $false )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_947,axiom,
    ! [VarCurr: state_type] :
      ( v112986(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_946,axiom,
    ! [VarCurr: state_type] :
      ( v112985(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_945,axiom,
    ! [VarCurr: state_type] :
      ( v112984(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_944,axiom,
    ! [VarCurr: state_type] :
      ( v112983(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $false )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_943,axiom,
    ! [VarCurr: state_type] :
      ( v112982(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_942,axiom,
    ! [VarCurr: state_type] :
      ( v112981(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $false )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_941,axiom,
    ! [VarCurr: state_type] :
      ( v112980(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_940,axiom,
    ! [VarCurr: state_type] :
      ( v112979(VarCurr)
    <=> ( ( v89218(VarCurr,7)
        <=> $true )
        & ( v89218(VarCurr,6)
        <=> $true )
        & ( v89218(VarCurr,5)
        <=> $true )
        & ( v89218(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_67029,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,0)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67028,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,1)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67027,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,2)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67026,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,3)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67025,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,4)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67024,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,5)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67023,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,6)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67022,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,7)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67021,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,8)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67020,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,9)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67019,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,10)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67018,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,11)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67017,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,12)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67016,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,13)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67015,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,14)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67014,axiom,
    ! [VarCurr: state_type] :
      ( v112966(VarCurr,15)
    <=> v112967(VarCurr) ) ).

tff(addAssignment_67013,axiom,
    ! [VarCurr: state_type] :
      ( v112967(VarCurr)
    <=> v112968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11795,axiom,
    ! [VarCurr: state_type] :
      ( v112968(VarCurr)
    <=> ( v112969(VarCurr)
        & v112977(VarCurr) ) ) ).

tff(writeUnaryOperator_6289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112977(VarCurr)
    <=> v84979(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4760,axiom,
    ! [VarCurr: state_type] :
      ( v112969(VarCurr)
    <=> ( v112971(VarCurr)
        | v84975(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4759,axiom,
    ! [VarCurr: state_type] :
      ( v112971(VarCurr)
    <=> ( v112972(VarCurr)
        | v84975(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4758,axiom,
    ! [VarCurr: state_type] :
      ( v112972(VarCurr)
    <=> ( v112973(VarCurr)
        | v84975(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4757,axiom,
    ! [VarCurr: state_type] :
      ( v112973(VarCurr)
    <=> ( v112974(VarCurr)
        | v84975(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4756,axiom,
    ! [VarCurr: state_type] :
      ( v112974(VarCurr)
    <=> ( v112975(VarCurr)
        | v84975(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4755,axiom,
    ! [VarCurr: state_type] :
      ( v112975(VarCurr)
    <=> ( v112976(VarCurr)
        | v84975(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4754,axiom,
    ! [VarCurr: state_type] :
      ( v112976(VarCurr)
    <=> ( v84975(VarCurr,0)
        | v84975(VarCurr,1) ) ) ).

tff(addAssignment_67012,axiom,
    ! [VarCurr: state_type] :
      ( v112954(VarCurr)
    <=> v112956(VarCurr) ) ).

tff(addAssignment_67011,axiom,
    ! [VarCurr: state_type] :
      ( v112956(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_67010,axiom,
    ! [VarCurr: state_type] :
      ( v112950(VarCurr)
    <=> v112952(VarCurr) ) ).

tff(addAssignment_67009,axiom,
    ! [VarCurr: state_type] :
      ( v112952(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_67008,axiom,
    ! [VarCurr: state_type] :
      ( v112924(VarCurr)
    <=> v112926(VarCurr) ) ).

tff(addAssignment_67007,axiom,
    ! [VarCurr: state_type] :
      ( v112926(VarCurr)
    <=> v85734(VarCurr) ) ).

tff(addAssignment_67006,axiom,
    ! [VarCurr: state_type] :
      ( v112920(VarCurr)
    <=> v112922(VarCurr) ) ).

tff(addAssignment_67005,axiom,
    ! [VarCurr: state_type] :
      ( v112922(VarCurr)
    <=> v85726(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_939,axiom,
    ! [VarCurr: state_type] :
      ( v112803(VarCurr)
    <=> ( ( v112805(VarCurr,1)
        <=> $false )
        & ( v112805(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_67004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112805(VarCurr,B)
      <=> v112807(VarCurr,B) ) ) ).

tff(addAssignment_67003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112807(VarCurr,B)
      <=> v112809(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112894(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v112809(VarNext,B)
            <=> v112809(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1467,axiom,
    ! [VarNext: state_type] :
      ( v112894(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112809(VarNext,B)
          <=> v112904(VarNext,B) ) ) ) ).

tff(addAssignment_67002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112904(VarNext,B)
          <=> v112902(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112902(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_997,axiom,
    ! [VarCurr: state_type] :
      ( v112905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112902(VarCurr,B)
          <=> v112819(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11794,axiom,
    ! [VarCurr: state_type] :
      ( v112905(VarCurr)
    <=> ( v112906(VarCurr)
        & v112907(VarCurr) ) ) ).

tff(writeUnaryOperator_6288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112907(VarCurr)
    <=> v112815(VarCurr) ) ).

tff(writeUnaryOperator_6287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112906(VarCurr)
    <=> v112811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112894(VarNext)
      <=> v112895(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112895(VarNext)
      <=> ( v112896(VarNext)
          & v112889(VarNext) ) ) ) ).

tff(writeUnaryOperator_6286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112896(VarNext)
      <=> v112898(VarNext) ) ) ).

tff(addAssignment_67001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112898(VarNext)
      <=> v112889(VarCurr) ) ) ).

tff(addAssignment_67000,axiom,
    ! [VarCurr: state_type] :
      ( v112889(VarCurr)
    <=> v112891(VarCurr) ) ).

tff(addAssignment_66999,axiom,
    ! [VarCurr: state_type] :
      ( v112891(VarCurr)
    <=> v112783(VarCurr) ) ).

tff(addAssignment_66998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112819(VarCurr,B)
      <=> v112821(VarCurr,B) ) ) ).

tff(addAssignment_66997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112821(VarCurr,B)
      <=> v112823(VarCurr,B) ) ) ).

tff(addAssignment_66996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112823(VarCurr,B)
      <=> v112825(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112825(VarCurr,B)
          <=> v112880(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_996,axiom,
    ! [VarCurr: state_type] :
      ( v112827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112825(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112880(VarCurr,B)
          <=> v112881(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_995,axiom,
    ! [VarCurr: state_type] :
      ( v112803(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112880(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_66995,axiom,
    ! [VarCurr: state_type] :
      ( v112881(VarCurr,0)
    <=> v112885(VarCurr) ) ).

tff(addAssignment_66994,axiom,
    ! [VarCurr: state_type] :
      ( v112881(VarCurr,1)
    <=> v112883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11791,axiom,
    ! [VarCurr: state_type] :
      ( v112883(VarCurr)
    <=> ( v112884(VarCurr)
        & v112886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11790,axiom,
    ! [VarCurr: state_type] :
      ( v112886(VarCurr)
    <=> ( v112805(VarCurr,0)
        | v112887(VarCurr) ) ) ).

tff(writeUnaryOperator_6285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112887(VarCurr)
    <=> v112805(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4753,axiom,
    ! [VarCurr: state_type] :
      ( v112884(VarCurr)
    <=> ( v112885(VarCurr)
        | v112805(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112885(VarCurr)
    <=> v112805(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11789,axiom,
    ! [VarCurr: state_type] :
      ( v112827(VarCurr)
    <=> ( v112877(VarCurr)
        | v112878(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4752,axiom,
    ! [VarCurr: state_type] :
      ( v112878(VarCurr)
    <=> ( v85714(VarCurr,1)
        & v112641(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4751,axiom,
    ! [VarCurr: state_type] :
      ( v112877(VarCurr)
    <=> ( v85714(VarCurr,3)
        & v112829(VarCurr) ) ) ).

tff(addAssignment_66993,axiom,
    ! [VarCurr: state_type] :
      ( v112829(VarCurr)
    <=> v112831(VarCurr,0) ) ).

tff(addAssignment_66992,axiom,
    ! [VarCurr: state_type] :
      ( v112831(VarCurr,0)
    <=> v112865(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v112865(VarCurr,B)
      <=> ( v112866(VarCurr,B)
          & v112833(VarCurr,B) ) ) ) ).

tff(addAssignment_66991,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,0)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66990,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,1)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66989,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,2)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66988,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,3)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66987,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,4)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66986,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,5)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66985,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,6)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66984,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,7)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66983,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,8)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66982,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,9)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66981,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,10)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66980,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,11)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66979,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,12)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66978,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,13)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66977,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,14)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66976,axiom,
    ! [VarCurr: state_type] :
      ( v112866(VarCurr,15)
    <=> v112867(VarCurr) ) ).

tff(addAssignment_66975,axiom,
    ! [VarCurr: state_type] :
      ( v112867(VarCurr)
    <=> v112868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11788,axiom,
    ! [VarCurr: state_type] :
      ( v112868(VarCurr)
    <=> ( v112869(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11787,axiom,
    ! [VarCurr: state_type] :
      ( v112869(VarCurr)
    <=> ( v112870(VarCurr)
        & v112520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11786,axiom,
    ! [VarCurr: state_type] :
      ( v112870(VarCurr)
    <=> ( v112871(VarCurr)
        & v112875(VarCurr) ) ) ).

tff(writeUnaryOperator_6283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112875(VarCurr)
    <=> v112698(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11785,axiom,
    ! [VarCurr: state_type] :
      ( v112871(VarCurr)
    <=> ( v112872(VarCurr)
        & v112874(VarCurr) ) ) ).

tff(writeUnaryOperator_6282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112874(VarCurr)
    <=> v112688(VarCurr) ) ).

tff(writeUnaryOperator_6281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112872(VarCurr)
    <=> v112873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11784,axiom,
    ! [VarCurr: state_type] :
      ( v112873(VarCurr)
    <=> ( v111651(VarCurr)
        | v112645(VarCurr) ) ) ).

tff(addAssignment_66974,axiom,
    ! [VarCurr: state_type] :
      ( v112833(VarCurr,0)
    <=> v112849(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112849(VarCurr,B)
          <=> v112850(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_994,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,0)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112849(VarCurr,B)
          <=> b0000000000000001(B) ) ) ) ).

tff(bitBlastConstant_1860,axiom,
    ~ b0000000000000001(15) ).

tff(bitBlastConstant_1859,axiom,
    ~ b0000000000000001(14) ).

tff(bitBlastConstant_1858,axiom,
    ~ b0000000000000001(13) ).

tff(bitBlastConstant_1857,axiom,
    ~ b0000000000000001(12) ).

tff(bitBlastConstant_1856,axiom,
    ~ b0000000000000001(11) ).

tff(bitBlastConstant_1855,axiom,
    ~ b0000000000000001(10) ).

tff(bitBlastConstant_1854,axiom,
    ~ b0000000000000001(9) ).

tff(bitBlastConstant_1853,axiom,
    ~ b0000000000000001(8) ).

tff(bitBlastConstant_1852,axiom,
    ~ b0000000000000001(7) ).

tff(bitBlastConstant_1851,axiom,
    ~ b0000000000000001(6) ).

tff(bitBlastConstant_1850,axiom,
    ~ b0000000000000001(5) ).

tff(bitBlastConstant_1849,axiom,
    ~ b0000000000000001(4) ).

tff(bitBlastConstant_1848,axiom,
    ~ b0000000000000001(3) ).

tff(bitBlastConstant_1847,axiom,
    ~ b0000000000000001(2) ).

tff(bitBlastConstant_1846,axiom,
    ~ b0000000000000001(1) ).

tff(bitBlastConstant_1845,axiom,
    b0000000000000001(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112850(VarCurr,B)
          <=> v112851(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_993,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112850(VarCurr,B)
          <=> b0000000000000010(B) ) ) ) ).

tff(bitBlastConstant_1844,axiom,
    ~ b0000000000000010(15) ).

tff(bitBlastConstant_1843,axiom,
    ~ b0000000000000010(14) ).

tff(bitBlastConstant_1842,axiom,
    ~ b0000000000000010(13) ).

tff(bitBlastConstant_1841,axiom,
    ~ b0000000000000010(12) ).

tff(bitBlastConstant_1840,axiom,
    ~ b0000000000000010(11) ).

tff(bitBlastConstant_1839,axiom,
    ~ b0000000000000010(10) ).

tff(bitBlastConstant_1838,axiom,
    ~ b0000000000000010(9) ).

tff(bitBlastConstant_1837,axiom,
    ~ b0000000000000010(8) ).

tff(bitBlastConstant_1836,axiom,
    ~ b0000000000000010(7) ).

tff(bitBlastConstant_1835,axiom,
    ~ b0000000000000010(6) ).

tff(bitBlastConstant_1834,axiom,
    ~ b0000000000000010(5) ).

tff(bitBlastConstant_1833,axiom,
    ~ b0000000000000010(4) ).

tff(bitBlastConstant_1832,axiom,
    ~ b0000000000000010(3) ).

tff(bitBlastConstant_1831,axiom,
    ~ b0000000000000010(2) ).

tff(bitBlastConstant_1830,axiom,
    b0000000000000010(1) ).

tff(bitBlastConstant_1829,axiom,
    ~ b0000000000000010(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112851(VarCurr,B)
          <=> v112852(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_992,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112851(VarCurr,B)
          <=> b0000000000000100(B) ) ) ) ).

tff(bitBlastConstant_1828,axiom,
    ~ b0000000000000100(15) ).

tff(bitBlastConstant_1827,axiom,
    ~ b0000000000000100(14) ).

tff(bitBlastConstant_1826,axiom,
    ~ b0000000000000100(13) ).

tff(bitBlastConstant_1825,axiom,
    ~ b0000000000000100(12) ).

tff(bitBlastConstant_1824,axiom,
    ~ b0000000000000100(11) ).

tff(bitBlastConstant_1823,axiom,
    ~ b0000000000000100(10) ).

tff(bitBlastConstant_1822,axiom,
    ~ b0000000000000100(9) ).

tff(bitBlastConstant_1821,axiom,
    ~ b0000000000000100(8) ).

tff(bitBlastConstant_1820,axiom,
    ~ b0000000000000100(7) ).

tff(bitBlastConstant_1819,axiom,
    ~ b0000000000000100(6) ).

tff(bitBlastConstant_1818,axiom,
    ~ b0000000000000100(5) ).

tff(bitBlastConstant_1817,axiom,
    ~ b0000000000000100(4) ).

tff(bitBlastConstant_1816,axiom,
    ~ b0000000000000100(3) ).

tff(bitBlastConstant_1815,axiom,
    b0000000000000100(2) ).

tff(bitBlastConstant_1814,axiom,
    ~ b0000000000000100(1) ).

tff(bitBlastConstant_1813,axiom,
    ~ b0000000000000100(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112852(VarCurr,B)
          <=> v112853(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_991,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112852(VarCurr,B)
          <=> b0000000000001000(B) ) ) ) ).

tff(bitBlastConstant_1812,axiom,
    ~ b0000000000001000(15) ).

tff(bitBlastConstant_1811,axiom,
    ~ b0000000000001000(14) ).

tff(bitBlastConstant_1810,axiom,
    ~ b0000000000001000(13) ).

tff(bitBlastConstant_1809,axiom,
    ~ b0000000000001000(12) ).

tff(bitBlastConstant_1808,axiom,
    ~ b0000000000001000(11) ).

tff(bitBlastConstant_1807,axiom,
    ~ b0000000000001000(10) ).

tff(bitBlastConstant_1806,axiom,
    ~ b0000000000001000(9) ).

tff(bitBlastConstant_1805,axiom,
    ~ b0000000000001000(8) ).

tff(bitBlastConstant_1804,axiom,
    ~ b0000000000001000(7) ).

tff(bitBlastConstant_1803,axiom,
    ~ b0000000000001000(6) ).

tff(bitBlastConstant_1802,axiom,
    ~ b0000000000001000(5) ).

tff(bitBlastConstant_1801,axiom,
    ~ b0000000000001000(4) ).

tff(bitBlastConstant_1800,axiom,
    b0000000000001000(3) ).

tff(bitBlastConstant_1799,axiom,
    ~ b0000000000001000(2) ).

tff(bitBlastConstant_1798,axiom,
    ~ b0000000000001000(1) ).

tff(bitBlastConstant_1797,axiom,
    ~ b0000000000001000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112853(VarCurr,B)
          <=> v112854(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_990,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112853(VarCurr,B)
          <=> b0000000000010000(B) ) ) ) ).

tff(bitBlastConstant_1796,axiom,
    ~ b0000000000010000(15) ).

tff(bitBlastConstant_1795,axiom,
    ~ b0000000000010000(14) ).

tff(bitBlastConstant_1794,axiom,
    ~ b0000000000010000(13) ).

tff(bitBlastConstant_1793,axiom,
    ~ b0000000000010000(12) ).

tff(bitBlastConstant_1792,axiom,
    ~ b0000000000010000(11) ).

tff(bitBlastConstant_1791,axiom,
    ~ b0000000000010000(10) ).

tff(bitBlastConstant_1790,axiom,
    ~ b0000000000010000(9) ).

tff(bitBlastConstant_1789,axiom,
    ~ b0000000000010000(8) ).

tff(bitBlastConstant_1788,axiom,
    ~ b0000000000010000(7) ).

tff(bitBlastConstant_1787,axiom,
    ~ b0000000000010000(6) ).

tff(bitBlastConstant_1786,axiom,
    ~ b0000000000010000(5) ).

tff(bitBlastConstant_1785,axiom,
    b0000000000010000(4) ).

tff(bitBlastConstant_1784,axiom,
    ~ b0000000000010000(3) ).

tff(bitBlastConstant_1783,axiom,
    ~ b0000000000010000(2) ).

tff(bitBlastConstant_1782,axiom,
    ~ b0000000000010000(1) ).

tff(bitBlastConstant_1781,axiom,
    ~ b0000000000010000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112854(VarCurr,B)
          <=> v112855(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_989,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112854(VarCurr,B)
          <=> b0000000000100000(B) ) ) ) ).

tff(bitBlastConstant_1780,axiom,
    ~ b0000000000100000(15) ).

tff(bitBlastConstant_1779,axiom,
    ~ b0000000000100000(14) ).

tff(bitBlastConstant_1778,axiom,
    ~ b0000000000100000(13) ).

tff(bitBlastConstant_1777,axiom,
    ~ b0000000000100000(12) ).

tff(bitBlastConstant_1776,axiom,
    ~ b0000000000100000(11) ).

tff(bitBlastConstant_1775,axiom,
    ~ b0000000000100000(10) ).

tff(bitBlastConstant_1774,axiom,
    ~ b0000000000100000(9) ).

tff(bitBlastConstant_1773,axiom,
    ~ b0000000000100000(8) ).

tff(bitBlastConstant_1772,axiom,
    ~ b0000000000100000(7) ).

tff(bitBlastConstant_1771,axiom,
    ~ b0000000000100000(6) ).

tff(bitBlastConstant_1770,axiom,
    b0000000000100000(5) ).

tff(bitBlastConstant_1769,axiom,
    ~ b0000000000100000(4) ).

tff(bitBlastConstant_1768,axiom,
    ~ b0000000000100000(3) ).

tff(bitBlastConstant_1767,axiom,
    ~ b0000000000100000(2) ).

tff(bitBlastConstant_1766,axiom,
    ~ b0000000000100000(1) ).

tff(bitBlastConstant_1765,axiom,
    ~ b0000000000100000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112855(VarCurr,B)
          <=> v112856(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_988,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112855(VarCurr,B)
          <=> b0000000001000000(B) ) ) ) ).

tff(bitBlastConstant_1764,axiom,
    ~ b0000000001000000(15) ).

tff(bitBlastConstant_1763,axiom,
    ~ b0000000001000000(14) ).

tff(bitBlastConstant_1762,axiom,
    ~ b0000000001000000(13) ).

tff(bitBlastConstant_1761,axiom,
    ~ b0000000001000000(12) ).

tff(bitBlastConstant_1760,axiom,
    ~ b0000000001000000(11) ).

tff(bitBlastConstant_1759,axiom,
    ~ b0000000001000000(10) ).

tff(bitBlastConstant_1758,axiom,
    ~ b0000000001000000(9) ).

tff(bitBlastConstant_1757,axiom,
    ~ b0000000001000000(8) ).

tff(bitBlastConstant_1756,axiom,
    ~ b0000000001000000(7) ).

tff(bitBlastConstant_1755,axiom,
    b0000000001000000(6) ).

tff(bitBlastConstant_1754,axiom,
    ~ b0000000001000000(5) ).

tff(bitBlastConstant_1753,axiom,
    ~ b0000000001000000(4) ).

tff(bitBlastConstant_1752,axiom,
    ~ b0000000001000000(3) ).

tff(bitBlastConstant_1751,axiom,
    ~ b0000000001000000(2) ).

tff(bitBlastConstant_1750,axiom,
    ~ b0000000001000000(1) ).

tff(bitBlastConstant_1749,axiom,
    ~ b0000000001000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112856(VarCurr,B)
          <=> v112857(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_987,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112856(VarCurr,B)
          <=> b0000000010000000(B) ) ) ) ).

tff(bitBlastConstant_1748,axiom,
    ~ b0000000010000000(15) ).

tff(bitBlastConstant_1747,axiom,
    ~ b0000000010000000(14) ).

tff(bitBlastConstant_1746,axiom,
    ~ b0000000010000000(13) ).

tff(bitBlastConstant_1745,axiom,
    ~ b0000000010000000(12) ).

tff(bitBlastConstant_1744,axiom,
    ~ b0000000010000000(11) ).

tff(bitBlastConstant_1743,axiom,
    ~ b0000000010000000(10) ).

tff(bitBlastConstant_1742,axiom,
    ~ b0000000010000000(9) ).

tff(bitBlastConstant_1741,axiom,
    ~ b0000000010000000(8) ).

tff(bitBlastConstant_1740,axiom,
    b0000000010000000(7) ).

tff(bitBlastConstant_1739,axiom,
    ~ b0000000010000000(6) ).

tff(bitBlastConstant_1738,axiom,
    ~ b0000000010000000(5) ).

tff(bitBlastConstant_1737,axiom,
    ~ b0000000010000000(4) ).

tff(bitBlastConstant_1736,axiom,
    ~ b0000000010000000(3) ).

tff(bitBlastConstant_1735,axiom,
    ~ b0000000010000000(2) ).

tff(bitBlastConstant_1734,axiom,
    ~ b0000000010000000(1) ).

tff(bitBlastConstant_1733,axiom,
    ~ b0000000010000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112857(VarCurr,B)
          <=> v112858(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_986,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,8)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112857(VarCurr,B)
          <=> b0000000100000000(B) ) ) ) ).

tff(bitBlastConstant_1732,axiom,
    ~ b0000000100000000(15) ).

tff(bitBlastConstant_1731,axiom,
    ~ b0000000100000000(14) ).

tff(bitBlastConstant_1730,axiom,
    ~ b0000000100000000(13) ).

tff(bitBlastConstant_1729,axiom,
    ~ b0000000100000000(12) ).

tff(bitBlastConstant_1728,axiom,
    ~ b0000000100000000(11) ).

tff(bitBlastConstant_1727,axiom,
    ~ b0000000100000000(10) ).

tff(bitBlastConstant_1726,axiom,
    ~ b0000000100000000(9) ).

tff(bitBlastConstant_1725,axiom,
    b0000000100000000(8) ).

tff(bitBlastConstant_1724,axiom,
    ~ b0000000100000000(7) ).

tff(bitBlastConstant_1723,axiom,
    ~ b0000000100000000(6) ).

tff(bitBlastConstant_1722,axiom,
    ~ b0000000100000000(5) ).

tff(bitBlastConstant_1721,axiom,
    ~ b0000000100000000(4) ).

tff(bitBlastConstant_1720,axiom,
    ~ b0000000100000000(3) ).

tff(bitBlastConstant_1719,axiom,
    ~ b0000000100000000(2) ).

tff(bitBlastConstant_1718,axiom,
    ~ b0000000100000000(1) ).

tff(bitBlastConstant_1717,axiom,
    ~ b0000000100000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112858(VarCurr,B)
          <=> v112859(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_985,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,9)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112858(VarCurr,B)
          <=> b0000001000000000(B) ) ) ) ).

tff(bitBlastConstant_1716,axiom,
    ~ b0000001000000000(15) ).

tff(bitBlastConstant_1715,axiom,
    ~ b0000001000000000(14) ).

tff(bitBlastConstant_1714,axiom,
    ~ b0000001000000000(13) ).

tff(bitBlastConstant_1713,axiom,
    ~ b0000001000000000(12) ).

tff(bitBlastConstant_1712,axiom,
    ~ b0000001000000000(11) ).

tff(bitBlastConstant_1711,axiom,
    ~ b0000001000000000(10) ).

tff(bitBlastConstant_1710,axiom,
    b0000001000000000(9) ).

tff(bitBlastConstant_1709,axiom,
    ~ b0000001000000000(8) ).

tff(bitBlastConstant_1708,axiom,
    ~ b0000001000000000(7) ).

tff(bitBlastConstant_1707,axiom,
    ~ b0000001000000000(6) ).

tff(bitBlastConstant_1706,axiom,
    ~ b0000001000000000(5) ).

tff(bitBlastConstant_1705,axiom,
    ~ b0000001000000000(4) ).

tff(bitBlastConstant_1704,axiom,
    ~ b0000001000000000(3) ).

tff(bitBlastConstant_1703,axiom,
    ~ b0000001000000000(2) ).

tff(bitBlastConstant_1702,axiom,
    ~ b0000001000000000(1) ).

tff(bitBlastConstant_1701,axiom,
    ~ b0000001000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112859(VarCurr,B)
          <=> v112860(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_984,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,10)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112859(VarCurr,B)
          <=> b0000010000000000(B) ) ) ) ).

tff(bitBlastConstant_1700,axiom,
    ~ b0000010000000000(15) ).

tff(bitBlastConstant_1699,axiom,
    ~ b0000010000000000(14) ).

tff(bitBlastConstant_1698,axiom,
    ~ b0000010000000000(13) ).

tff(bitBlastConstant_1697,axiom,
    ~ b0000010000000000(12) ).

tff(bitBlastConstant_1696,axiom,
    ~ b0000010000000000(11) ).

tff(bitBlastConstant_1695,axiom,
    b0000010000000000(10) ).

tff(bitBlastConstant_1694,axiom,
    ~ b0000010000000000(9) ).

tff(bitBlastConstant_1693,axiom,
    ~ b0000010000000000(8) ).

tff(bitBlastConstant_1692,axiom,
    ~ b0000010000000000(7) ).

tff(bitBlastConstant_1691,axiom,
    ~ b0000010000000000(6) ).

tff(bitBlastConstant_1690,axiom,
    ~ b0000010000000000(5) ).

tff(bitBlastConstant_1689,axiom,
    ~ b0000010000000000(4) ).

tff(bitBlastConstant_1688,axiom,
    ~ b0000010000000000(3) ).

tff(bitBlastConstant_1687,axiom,
    ~ b0000010000000000(2) ).

tff(bitBlastConstant_1686,axiom,
    ~ b0000010000000000(1) ).

tff(bitBlastConstant_1685,axiom,
    ~ b0000010000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112860(VarCurr,B)
          <=> v112861(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_983,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,11)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112860(VarCurr,B)
          <=> b0000100000000000(B) ) ) ) ).

tff(bitBlastConstant_1684,axiom,
    ~ b0000100000000000(15) ).

tff(bitBlastConstant_1683,axiom,
    ~ b0000100000000000(14) ).

tff(bitBlastConstant_1682,axiom,
    ~ b0000100000000000(13) ).

tff(bitBlastConstant_1681,axiom,
    ~ b0000100000000000(12) ).

tff(bitBlastConstant_1680,axiom,
    b0000100000000000(11) ).

tff(bitBlastConstant_1679,axiom,
    ~ b0000100000000000(10) ).

tff(bitBlastConstant_1678,axiom,
    ~ b0000100000000000(9) ).

tff(bitBlastConstant_1677,axiom,
    ~ b0000100000000000(8) ).

tff(bitBlastConstant_1676,axiom,
    ~ b0000100000000000(7) ).

tff(bitBlastConstant_1675,axiom,
    ~ b0000100000000000(6) ).

tff(bitBlastConstant_1674,axiom,
    ~ b0000100000000000(5) ).

tff(bitBlastConstant_1673,axiom,
    ~ b0000100000000000(4) ).

tff(bitBlastConstant_1672,axiom,
    ~ b0000100000000000(3) ).

tff(bitBlastConstant_1671,axiom,
    ~ b0000100000000000(2) ).

tff(bitBlastConstant_1670,axiom,
    ~ b0000100000000000(1) ).

tff(bitBlastConstant_1669,axiom,
    ~ b0000100000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112861(VarCurr,B)
          <=> v112862(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_982,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,12)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112861(VarCurr,B)
          <=> b0001000000000000(B) ) ) ) ).

tff(bitBlastConstant_1668,axiom,
    ~ b0001000000000000(15) ).

tff(bitBlastConstant_1667,axiom,
    ~ b0001000000000000(14) ).

tff(bitBlastConstant_1666,axiom,
    ~ b0001000000000000(13) ).

tff(bitBlastConstant_1665,axiom,
    b0001000000000000(12) ).

tff(bitBlastConstant_1664,axiom,
    ~ b0001000000000000(11) ).

tff(bitBlastConstant_1663,axiom,
    ~ b0001000000000000(10) ).

tff(bitBlastConstant_1662,axiom,
    ~ b0001000000000000(9) ).

tff(bitBlastConstant_1661,axiom,
    ~ b0001000000000000(8) ).

tff(bitBlastConstant_1660,axiom,
    ~ b0001000000000000(7) ).

tff(bitBlastConstant_1659,axiom,
    ~ b0001000000000000(6) ).

tff(bitBlastConstant_1658,axiom,
    ~ b0001000000000000(5) ).

tff(bitBlastConstant_1657,axiom,
    ~ b0001000000000000(4) ).

tff(bitBlastConstant_1656,axiom,
    ~ b0001000000000000(3) ).

tff(bitBlastConstant_1655,axiom,
    ~ b0001000000000000(2) ).

tff(bitBlastConstant_1654,axiom,
    ~ b0001000000000000(1) ).

tff(bitBlastConstant_1653,axiom,
    ~ b0001000000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112862(VarCurr,B)
          <=> v112863(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_981,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,13)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112862(VarCurr,B)
          <=> b0010000000000000(B) ) ) ) ).

tff(bitBlastConstant_1652,axiom,
    ~ b0010000000000000(15) ).

tff(bitBlastConstant_1651,axiom,
    ~ b0010000000000000(14) ).

tff(bitBlastConstant_1650,axiom,
    b0010000000000000(13) ).

tff(bitBlastConstant_1649,axiom,
    ~ b0010000000000000(12) ).

tff(bitBlastConstant_1648,axiom,
    ~ b0010000000000000(11) ).

tff(bitBlastConstant_1647,axiom,
    ~ b0010000000000000(10) ).

tff(bitBlastConstant_1646,axiom,
    ~ b0010000000000000(9) ).

tff(bitBlastConstant_1645,axiom,
    ~ b0010000000000000(8) ).

tff(bitBlastConstant_1644,axiom,
    ~ b0010000000000000(7) ).

tff(bitBlastConstant_1643,axiom,
    ~ b0010000000000000(6) ).

tff(bitBlastConstant_1642,axiom,
    ~ b0010000000000000(5) ).

tff(bitBlastConstant_1641,axiom,
    ~ b0010000000000000(4) ).

tff(bitBlastConstant_1640,axiom,
    ~ b0010000000000000(3) ).

tff(bitBlastConstant_1639,axiom,
    ~ b0010000000000000(2) ).

tff(bitBlastConstant_1638,axiom,
    ~ b0010000000000000(1) ).

tff(bitBlastConstant_1637,axiom,
    ~ b0010000000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112863(VarCurr,B)
          <=> v112864(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_980,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,14)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112863(VarCurr,B)
          <=> b0100000000000000(B) ) ) ) ).

tff(bitBlastConstant_1636,axiom,
    ~ b0100000000000000(15) ).

tff(bitBlastConstant_1635,axiom,
    b0100000000000000(14) ).

tff(bitBlastConstant_1634,axiom,
    ~ b0100000000000000(13) ).

tff(bitBlastConstant_1633,axiom,
    ~ b0100000000000000(12) ).

tff(bitBlastConstant_1632,axiom,
    ~ b0100000000000000(11) ).

tff(bitBlastConstant_1631,axiom,
    ~ b0100000000000000(10) ).

tff(bitBlastConstant_1630,axiom,
    ~ b0100000000000000(9) ).

tff(bitBlastConstant_1629,axiom,
    ~ b0100000000000000(8) ).

tff(bitBlastConstant_1628,axiom,
    ~ b0100000000000000(7) ).

tff(bitBlastConstant_1627,axiom,
    ~ b0100000000000000(6) ).

tff(bitBlastConstant_1626,axiom,
    ~ b0100000000000000(5) ).

tff(bitBlastConstant_1625,axiom,
    ~ b0100000000000000(4) ).

tff(bitBlastConstant_1624,axiom,
    ~ b0100000000000000(3) ).

tff(bitBlastConstant_1623,axiom,
    ~ b0100000000000000(2) ).

tff(bitBlastConstant_1622,axiom,
    ~ b0100000000000000(1) ).

tff(bitBlastConstant_1621,axiom,
    ~ b0100000000000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112522(VarCurr,15)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112864(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_979,axiom,
    ! [VarCurr: state_type] :
      ( v112522(VarCurr,15)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v112864(VarCurr,B)
          <=> b1000000000000000(B) ) ) ) ).

tff(bitBlastConstant_1620,axiom,
    b1000000000000000(15) ).

tff(bitBlastConstant_1619,axiom,
    ~ b1000000000000000(14) ).

tff(bitBlastConstant_1618,axiom,
    ~ b1000000000000000(13) ).

tff(bitBlastConstant_1617,axiom,
    ~ b1000000000000000(12) ).

tff(bitBlastConstant_1616,axiom,
    ~ b1000000000000000(11) ).

tff(bitBlastConstant_1615,axiom,
    ~ b1000000000000000(10) ).

tff(bitBlastConstant_1614,axiom,
    ~ b1000000000000000(9) ).

tff(bitBlastConstant_1613,axiom,
    ~ b1000000000000000(8) ).

tff(bitBlastConstant_1612,axiom,
    ~ b1000000000000000(7) ).

tff(bitBlastConstant_1611,axiom,
    ~ b1000000000000000(6) ).

tff(bitBlastConstant_1610,axiom,
    ~ b1000000000000000(5) ).

tff(bitBlastConstant_1609,axiom,
    ~ b1000000000000000(4) ).

tff(bitBlastConstant_1608,axiom,
    ~ b1000000000000000(3) ).

tff(bitBlastConstant_1607,axiom,
    ~ b1000000000000000(2) ).

tff(bitBlastConstant_1606,axiom,
    ~ b1000000000000000(1) ).

tff(bitBlastConstant_1605,axiom,
    ~ b1000000000000000(0) ).

tff(addAssignment_66973,axiom,
    ! [VarCurr: state_type] :
      ( v112815(VarCurr)
    <=> v112817(VarCurr) ) ).

tff(addAssignment_66972,axiom,
    ! [VarCurr: state_type] :
      ( v112817(VarCurr)
    <=> v85734(VarCurr) ) ).

tff(addAssignment_66971,axiom,
    ! [VarCurr: state_type] :
      ( v112811(VarCurr)
    <=> v112813(VarCurr) ) ).

tff(addAssignment_66970,axiom,
    ! [VarCurr: state_type] :
      ( v112813(VarCurr)
    <=> v85726(VarCurr) ) ).

tff(addAssignment_66969,axiom,
    ! [VarCurr: state_type] :
      ( v85714(VarCurr,1)
    <=> v85718(VarCurr,1) ) ).

tff(addAssignment_66968,axiom,
    ! [VarCurr: state_type] :
      ( v85718(VarCurr,1)
    <=> v85720(VarCurr,1) ) ).

tff(addAssignment_66967,axiom,
    ! [VarNext: state_type] :
      ( v85720(VarNext,1)
    <=> v112785(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112786(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v112785(VarNext,B)
            <=> v85720(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1466,axiom,
    ! [VarNext: state_type] :
      ( v112786(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v112785(VarNext,B)
          <=> v112796(VarNext,B) ) ) ) ).

tff(addAssignment_66966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v112796(VarNext,B)
          <=> v112794(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v112794(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_978,axiom,
    ! [VarCurr: state_type] :
      ( v112797(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v112794(VarCurr,B)
          <=> v85738(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11783,axiom,
    ! [VarCurr: state_type] :
      ( v112797(VarCurr)
    <=> ( v112798(VarCurr)
        & v112799(VarCurr) ) ) ).

tff(writeUnaryOperator_6280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112799(VarCurr)
    <=> v85730(VarCurr) ) ).

tff(writeUnaryOperator_6279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112798(VarCurr)
    <=> v85722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112786(VarNext)
      <=> v112787(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112787(VarNext)
      <=> ( v112788(VarNext)
          & v112779(VarNext) ) ) ) ).

tff(writeUnaryOperator_6278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112788(VarNext)
      <=> v112790(VarNext) ) ) ).

tff(addAssignment_66965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112790(VarNext)
      <=> v112779(VarCurr) ) ) ).

tff(addAssignment_66964,axiom,
    ! [VarCurr: state_type] :
      ( v112779(VarCurr)
    <=> v112781(VarCurr) ) ).

tff(addAssignment_66963,axiom,
    ! [VarCurr: state_type] :
      ( v112781(VarCurr)
    <=> v112783(VarCurr) ) ).

tff(addAssignment_66962,axiom,
    ! [VarCurr: state_type] :
      ( v112783(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66961,axiom,
    ! [VarCurr: state_type] :
      ( v85738(VarCurr,1)
    <=> v85740(VarCurr,1) ) ).

tff(addAssignment_66960,axiom,
    ! [VarCurr: state_type] :
      ( v85740(VarCurr,1)
    <=> v85742(VarCurr,1) ) ).

tff(addAssignment_66959,axiom,
    ! [VarCurr: state_type] :
      ( v85742(VarCurr,1)
    <=> v112777(VarCurr,1) ) ).

tff(addAssignment_66958,axiom,
    ! [VarCurr: state_type] :
      ( v112777(VarCurr,0)
    <=> v85744(VarCurr) ) ).

tff(addAssignment_66957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v112777(VarCurr,B)
      <=> v85746(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_31,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112757(VarCurr)
     => ( v85746(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_61,axiom,
    ! [VarCurr: state_type] :
      ( v112757(VarCurr)
     => ( v85746(VarCurr,1)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11780,axiom,
    ! [VarCurr: state_type] :
      ( v112757(VarCurr)
    <=> ( v112758(VarCurr)
        | v112762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11779,axiom,
    ! [VarCurr: state_type] :
      ( v112762(VarCurr)
    <=> ( v112763(VarCurr)
        & v112764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11778,axiom,
    ! [VarCurr: state_type] :
      ( v112764(VarCurr)
    <=> ( v112765(VarCurr)
        & v112776(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_938,axiom,
    ! [VarCurr: state_type] :
      ( v112776(VarCurr)
    <=> ( $true
      <=> v85714(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11777,axiom,
    ! [VarCurr: state_type] :
      ( v112765(VarCurr)
    <=> ( v112766(VarCurr)
        & v112767(VarCurr) ) ) ).

tff(writeUnaryOperator_6277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112767(VarCurr)
    <=> v112768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11776,axiom,
    ! [VarCurr: state_type] :
      ( v112768(VarCurr)
    <=> ( v112769(VarCurr)
        | v112639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11775,axiom,
    ! [VarCurr: state_type] :
      ( v112769(VarCurr)
    <=> ( v112770(VarCurr)
        | v112773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11774,axiom,
    ! [VarCurr: state_type] :
      ( v112773(VarCurr)
    <=> ( v112774(VarCurr)
        & v112775(VarCurr) ) ) ).

tff(writeUnaryOperator_6276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112775(VarCurr)
    <=> v112641(VarCurr) ) ).

tff(writeUnaryOperator_6275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112774(VarCurr)
    <=> v85748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11773,axiom,
    ! [VarCurr: state_type] :
      ( v112770(VarCurr)
    <=> ( v112771(VarCurr)
        | v112772(VarCurr) ) ) ).

tff(writeUnaryOperator_6274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112772(VarCurr)
    <=> v112526(VarCurr) ) ).

tff(writeUnaryOperator_6273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112771(VarCurr)
    <=> v112637(VarCurr) ) ).

tff(writeUnaryOperator_6272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112766(VarCurr)
    <=> v112641(VarCurr) ) ).

tff(writeUnaryOperator_6271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112763(VarCurr)
    <=> v112761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11772,axiom,
    ! [VarCurr: state_type] :
      ( v112758(VarCurr)
    <=> ( v112759(VarCurr)
        & v112761(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_937,axiom,
    ! [VarCurr: state_type] :
      ( v112761(VarCurr)
    <=> ( $true
      <=> v85714(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11771,axiom,
    ! [VarCurr: state_type] :
      ( v112759(VarCurr)
    <=> ( v112760(VarCurr)
        & v112526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11770,axiom,
    ! [VarCurr: state_type] :
      ( v112760(VarCurr)
    <=> ( v85748(VarCurr)
        & v112637(VarCurr) ) ) ).

tff(addAssignment_66956,axiom,
    ! [VarCurr: state_type] :
      ( v112698(VarCurr)
    <=> v112700(VarCurr,0) ) ).

tff(addAssignment_66955,axiom,
    ! [VarCurr: state_type] :
      ( v112700(VarCurr,0)
    <=> v112702(VarCurr,0) ) ).

tff(addAssignment_66954,axiom,
    ! [VarNext: state_type] :
      ( v112702(VarNext,0)
    <=> v112733(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112734(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v112733(VarNext,B)
            <=> v112702(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1465,axiom,
    ! [VarNext: state_type] :
      ( v112734(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112733(VarNext,B)
          <=> v112744(VarNext,B) ) ) ) ).

tff(addAssignment_66953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112744(VarNext,B)
          <=> v112742(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112742(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_977,axiom,
    ! [VarCurr: state_type] :
      ( v112745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112742(VarCurr,B)
          <=> v112712(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11769,axiom,
    ! [VarCurr: state_type] :
      ( v112745(VarCurr)
    <=> ( v112746(VarCurr)
        & v112747(VarCurr) ) ) ).

tff(writeUnaryOperator_6270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112747(VarCurr)
    <=> v112708(VarCurr) ) ).

tff(writeUnaryOperator_6269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112746(VarCurr)
    <=> v112704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112734(VarNext)
      <=> v112735(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112735(VarNext)
      <=> ( v112736(VarNext)
          & v112729(VarNext) ) ) ) ).

tff(writeUnaryOperator_6268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112736(VarNext)
      <=> v112738(VarNext) ) ) ).

tff(addAssignment_66952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112738(VarNext)
      <=> v112729(VarCurr) ) ) ).

tff(addAssignment_66951,axiom,
    ! [VarCurr: state_type] :
      ( v112729(VarCurr)
    <=> v112731(VarCurr) ) ).

tff(addAssignment_66950,axiom,
    ! [VarCurr: state_type] :
      ( v112731(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66949,axiom,
    ! [VarCurr: state_type] :
      ( v112712(VarCurr,0)
    <=> v112714(VarCurr,0) ) ).

tff(addAssignment_66948,axiom,
    ! [VarCurr: state_type] :
      ( v112714(VarCurr,0)
    <=> v112720(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112720(VarCurr,B)
      <=> ( v112721(VarCurr,B)
          | v112724(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112724(VarCurr,B)
      <=> ( v112700(VarCurr,B)
          & v112725(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112725(VarCurr,B)
      <=> ~ v112726(VarCurr,B) ) ) ).

tff(addAssignment_66947,axiom,
    ! [VarCurr: state_type] :
      ( v112726(VarCurr,0)
    <=> v112727(VarCurr) ) ).

tff(addAssignment_66946,axiom,
    ! [VarCurr: state_type] :
      ( v112726(VarCurr,1)
    <=> v112727(VarCurr) ) ).

tff(addAssignment_66945,axiom,
    ! [VarCurr: state_type] :
      ( v112726(VarCurr,2)
    <=> v112727(VarCurr) ) ).

tff(addAssignment_66944,axiom,
    ! [VarCurr: state_type] :
      ( v112727(VarCurr)
    <=> v112719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112721(VarCurr,B)
      <=> ( v112716(VarCurr,B)
          & v112722(VarCurr,B) ) ) ) ).

tff(addAssignment_66943,axiom,
    ! [VarCurr: state_type] :
      ( v112722(VarCurr,0)
    <=> v112723(VarCurr) ) ).

tff(addAssignment_66942,axiom,
    ! [VarCurr: state_type] :
      ( v112722(VarCurr,1)
    <=> v112723(VarCurr) ) ).

tff(addAssignment_66941,axiom,
    ! [VarCurr: state_type] :
      ( v112722(VarCurr,2)
    <=> v112723(VarCurr) ) ).

tff(addAssignment_66940,axiom,
    ! [VarCurr: state_type] :
      ( v112723(VarCurr)
    <=> v112719(VarCurr) ) ).

tff(addAssignment_66939,axiom,
    ! [VarCurr: state_type] :
      ( v112719(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_66938,axiom,
    ! [VarCurr: state_type] :
      ( v112716(VarCurr,0)
    <=> v112717(VarCurr,0) ) ).

tff(addAssignment_66937,axiom,
    ! [VarCurr: state_type] :
      ( v112717(VarCurr,0)
    <=> v112688(VarCurr) ) ).

tff(addAssignment_66936,axiom,
    ! [VarCurr: state_type] :
      ( v112717(VarCurr,1)
    <=> v112483(VarCurr) ) ).

tff(addAssignment_66935,axiom,
    ! [VarCurr: state_type] :
      ( v112717(VarCurr,2)
    <=> v2878(VarCurr) ) ).

tff(addAssignment_66934,axiom,
    ! [VarCurr: state_type] :
      ( v112708(VarCurr)
    <=> v112710(VarCurr) ) ).

tff(addAssignment_66933,axiom,
    ! [VarCurr: state_type] :
      ( v112710(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66932,axiom,
    ! [VarCurr: state_type] :
      ( v112704(VarCurr)
    <=> v112706(VarCurr) ) ).

tff(addAssignment_66931,axiom,
    ! [VarCurr: state_type] :
      ( v112706(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66930,axiom,
    ! [VarCurr: state_type] :
      ( v112688(VarCurr)
    <=> v2880(VarCurr,0) ) ).

tff(addAssignment_66929,axiom,
    ! [VarCurr: state_type] :
      ( v2880(VarCurr,0)
    <=> v2882(VarCurr,0) ) ).

tff(addAssignment_66928,axiom,
    ! [VarNext: state_type] :
      ( v2882(VarNext,0)
    <=> v112690(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112691(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v112690(VarNext,B)
            <=> v2882(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1464,axiom,
    ! [VarNext: state_type] :
      ( v112691(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112690(VarNext,B)
          <=> v112511(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112691(VarNext)
      <=> v112692(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112692(VarNext)
      <=> ( v112694(VarNext)
          & v112496(VarNext) ) ) ) ).

tff(writeUnaryOperator_6266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112694(VarNext)
      <=> v112505(VarNext) ) ) ).

tff(addAssignment_66927,axiom,
    ! [VarCurr: state_type] :
      ( v2892(VarCurr,0)
    <=> v2894(VarCurr,0) ) ).

tff(addAssignment_66926,axiom,
    ! [VarCurr: state_type] :
      ( v2894(VarCurr,0)
    <=> v112487(VarCurr,0) ) ).

tff(addAssignment_66925,axiom,
    ! [VarCurr: state_type] :
      ( v2896(VarCurr,0)
    <=> v112484(VarCurr,0) ) ).

tff(addAssignment_66924,axiom,
    ! [VarCurr: state_type] :
      ( v112645(VarCurr)
    <=> v112647(VarCurr,1) ) ).

tff(addAssignment_66923,axiom,
    ! [VarCurr: state_type] :
      ( v112647(VarCurr,1)
    <=> v112649(VarCurr,1) ) ).

tff(addAssignment_66922,axiom,
    ! [VarNext: state_type] :
      ( v112649(VarNext,1)
    <=> v112670(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112671(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v112670(VarNext,B)
            <=> v112649(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1463,axiom,
    ! [VarNext: state_type] :
      ( v112671(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112670(VarNext,B)
          <=> v112681(VarNext,B) ) ) ) ).

tff(addAssignment_66921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112681(VarNext,B)
          <=> v112679(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112682(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112679(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_976,axiom,
    ! [VarCurr: state_type] :
      ( v112682(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v112679(VarCurr,B)
          <=> v112659(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11764,axiom,
    ! [VarCurr: state_type] :
      ( v112682(VarCurr)
    <=> ( v112683(VarCurr)
        & v112684(VarCurr) ) ) ).

tff(writeUnaryOperator_6265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112684(VarCurr)
    <=> v112655(VarCurr) ) ).

tff(writeUnaryOperator_6264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112683(VarCurr)
    <=> v112651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112671(VarNext)
      <=> v112672(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112672(VarNext)
      <=> ( v112673(VarNext)
          & v112666(VarNext) ) ) ) ).

tff(writeUnaryOperator_6263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112673(VarNext)
      <=> v112675(VarNext) ) ) ).

tff(addAssignment_66920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112675(VarNext)
      <=> v112666(VarCurr) ) ) ).

tff(addAssignment_66919,axiom,
    ! [VarCurr: state_type] :
      ( v112666(VarCurr)
    <=> v112668(VarCurr) ) ).

tff(addAssignment_66918,axiom,
    ! [VarCurr: state_type] :
      ( v112668(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66917,axiom,
    ! [VarCurr: state_type] :
      ( v112659(VarCurr,1)
    <=> v112661(VarCurr,1) ) ).

tff(addAssignment_66916,axiom,
    ! [VarCurr: state_type] :
      ( v112661(VarCurr,1)
    <=> v112663(VarCurr,1) ) ).

tff(addAssignment_66915,axiom,
    ! [VarCurr: state_type] :
      ( v112663(VarCurr,1)
    <=> v112664(VarCurr,1) ) ).

tff(addAssignment_66914,axiom,
    ! [VarCurr: state_type] :
      ( v112664(VarCurr,0)
    <=> v83122(VarCurr,0) ) ).

tff(addAssignment_66913,axiom,
    ! [VarCurr: state_type] :
      ( v112664(VarCurr,1)
    <=> v83163(VarCurr) ) ).

tff(addAssignment_66912,axiom,
    ! [VarCurr: state_type] :
      ( v112655(VarCurr)
    <=> v112657(VarCurr) ) ).

tff(addAssignment_66911,axiom,
    ! [VarCurr: state_type] :
      ( v112657(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66910,axiom,
    ! [VarCurr: state_type] :
      ( v112651(VarCurr)
    <=> v112653(VarCurr) ) ).

tff(addAssignment_66909,axiom,
    ! [VarCurr: state_type] :
      ( v112653(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66908,axiom,
    ! [VarCurr: state_type] :
      ( v112639(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_66907,axiom,
    ! [VarCurr: state_type] :
      ( v112637(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(addAssignment_66906,axiom,
    ! [VarCurr: state_type] :
      ( v112526(VarCurr)
    <=> v112528(VarCurr,0) ) ).

tff(addAssignment_66905,axiom,
    ! [VarCurr: state_type] :
      ( v112528(VarCurr,0)
    <=> v112530(VarCurr,0) ) ).

tff(addAssignment_66904,axiom,
    ! [VarCurr: state_type] :
      ( v112530(VarCurr,0)
    <=> v112590(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v112590(VarCurr,B)
      <=> ( v112591(VarCurr,B)
          & v112593(VarCurr,B) ) ) ) ).

tff(addAssignment_66903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v112593(VarCurr,B)
      <=> v112594(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v112594(VarCurr,B)
      <=> ( v112595(VarCurr,B)
          | v112633(VarCurr,B) ) ) ) ).

tff(addAssignment_66902,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,0)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66901,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,1)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66900,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,2)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66899,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,3)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66898,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,4)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66897,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,5)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66896,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,6)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66895,axiom,
    ! [VarCurr: state_type] :
      ( v112633(VarCurr,7)
    <=> v112634(VarCurr) ) ).

tff(addAssignment_66894,axiom,
    ! [VarCurr: state_type] :
      ( v112634(VarCurr)
    <=> v112635(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_936,axiom,
    ! [VarCurr: state_type] :
      ( v112635(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $false )
        & ( v87667(VarCurr,1)
        <=> $false )
        & ( v87667(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v112595(VarCurr,B)
      <=> ( v112596(VarCurr,B)
          | v112629(VarCurr,B) ) ) ) ).

tff(addAssignment_66893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v112629(VarCurr,B)
      <=> v112630(VarCurr,B) ) ) ).

tff(addAssignment_66892,axiom,
    ! [VarCurr: state_type] :
      ( v112629(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_66891,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,0)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66890,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,1)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66889,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,2)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66888,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,3)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66887,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,4)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66886,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,5)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66885,axiom,
    ! [VarCurr: state_type] :
      ( v112630(VarCurr,6)
    <=> v112631(VarCurr) ) ).

tff(addAssignment_66884,axiom,
    ! [VarCurr: state_type] :
      ( v112631(VarCurr)
    <=> v112632(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_935,axiom,
    ! [VarCurr: state_type] :
      ( v112632(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $true )
        & ( v87667(VarCurr,1)
        <=> $true )
        & ( v87667(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_45,axiom,
    ! [VarCurr: state_type] : ~ v112596(VarCurr,7) ).

tff(addAssignment_66883,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v112596(VarCurr,B)
      <=> v112597(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v112597(VarCurr,B)
      <=> ( v112598(VarCurr,B)
          | v112625(VarCurr,B) ) ) ) ).

tff(addAssignment_66882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v112625(VarCurr,B)
      <=> v112626(VarCurr,B) ) ) ).

tff(addAssignment_66881,axiom,
    ! [VarCurr: state_type] :
      ( v112625(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_66880,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,0)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66879,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,1)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66878,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,2)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66877,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,3)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66876,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,4)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66875,axiom,
    ! [VarCurr: state_type] :
      ( v112626(VarCurr,5)
    <=> v112627(VarCurr) ) ).

tff(addAssignment_66874,axiom,
    ! [VarCurr: state_type] :
      ( v112627(VarCurr)
    <=> v112628(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_934,axiom,
    ! [VarCurr: state_type] :
      ( v112628(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $true )
        & ( v87667(VarCurr,1)
        <=> $true )
        & ( v87667(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_44,axiom,
    ! [VarCurr: state_type] : ~ v112598(VarCurr,6) ).

tff(addAssignment_66873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v112598(VarCurr,B)
      <=> v112599(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v112599(VarCurr,B)
      <=> ( v112600(VarCurr,B)
          | v112621(VarCurr,B) ) ) ) ).

tff(addAssignment_66872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112621(VarCurr,B)
      <=> v112622(VarCurr,B) ) ) ).

tff(addAssignment_66871,axiom,
    ! [VarCurr: state_type] :
      ( v112621(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_66870,axiom,
    ! [VarCurr: state_type] :
      ( v112622(VarCurr,0)
    <=> v112623(VarCurr) ) ).

tff(addAssignment_66869,axiom,
    ! [VarCurr: state_type] :
      ( v112622(VarCurr,1)
    <=> v112623(VarCurr) ) ).

tff(addAssignment_66868,axiom,
    ! [VarCurr: state_type] :
      ( v112622(VarCurr,2)
    <=> v112623(VarCurr) ) ).

tff(addAssignment_66867,axiom,
    ! [VarCurr: state_type] :
      ( v112622(VarCurr,3)
    <=> v112623(VarCurr) ) ).

tff(addAssignment_66866,axiom,
    ! [VarCurr: state_type] :
      ( v112622(VarCurr,4)
    <=> v112623(VarCurr) ) ).

tff(addAssignment_66865,axiom,
    ! [VarCurr: state_type] :
      ( v112623(VarCurr)
    <=> v112624(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_933,axiom,
    ! [VarCurr: state_type] :
      ( v112624(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $true )
        & ( v87667(VarCurr,1)
        <=> $false )
        & ( v87667(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_43,axiom,
    ! [VarCurr: state_type] : ~ v112600(VarCurr,5) ).

tff(addAssignment_66864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112600(VarCurr,B)
      <=> v112601(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v112601(VarCurr,B)
      <=> ( v112602(VarCurr,B)
          | v112617(VarCurr,B) ) ) ) ).

tff(addAssignment_66863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v112617(VarCurr,B)
      <=> v112618(VarCurr,B) ) ) ).

tff(addAssignment_66862,axiom,
    ! [VarCurr: state_type] :
      ( v112617(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_66861,axiom,
    ! [VarCurr: state_type] :
      ( v112618(VarCurr,0)
    <=> v112619(VarCurr) ) ).

tff(addAssignment_66860,axiom,
    ! [VarCurr: state_type] :
      ( v112618(VarCurr,1)
    <=> v112619(VarCurr) ) ).

tff(addAssignment_66859,axiom,
    ! [VarCurr: state_type] :
      ( v112618(VarCurr,2)
    <=> v112619(VarCurr) ) ).

tff(addAssignment_66858,axiom,
    ! [VarCurr: state_type] :
      ( v112618(VarCurr,3)
    <=> v112619(VarCurr) ) ).

tff(addAssignment_66857,axiom,
    ! [VarCurr: state_type] :
      ( v112619(VarCurr)
    <=> v112620(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_932,axiom,
    ! [VarCurr: state_type] :
      ( v112620(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $true )
        & ( v87667(VarCurr,1)
        <=> $false )
        & ( v87667(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_42,axiom,
    ! [VarCurr: state_type] : ~ v112602(VarCurr,4) ).

tff(addAssignment_66856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v112602(VarCurr,B)
      <=> v112603(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v112603(VarCurr,B)
      <=> ( v112604(VarCurr,B)
          | v112613(VarCurr,B) ) ) ) ).

tff(addAssignment_66855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112613(VarCurr,B)
      <=> v112614(VarCurr,B) ) ) ).

tff(addAssignment_66854,axiom,
    ! [VarCurr: state_type] :
      ( v112613(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_66853,axiom,
    ! [VarCurr: state_type] :
      ( v112614(VarCurr,0)
    <=> v112615(VarCurr) ) ).

tff(addAssignment_66852,axiom,
    ! [VarCurr: state_type] :
      ( v112614(VarCurr,1)
    <=> v112615(VarCurr) ) ).

tff(addAssignment_66851,axiom,
    ! [VarCurr: state_type] :
      ( v112614(VarCurr,2)
    <=> v112615(VarCurr) ) ).

tff(addAssignment_66850,axiom,
    ! [VarCurr: state_type] :
      ( v112615(VarCurr)
    <=> v112616(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_931,axiom,
    ! [VarCurr: state_type] :
      ( v112616(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $false )
        & ( v87667(VarCurr,1)
        <=> $true )
        & ( v87667(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_41,axiom,
    ! [VarCurr: state_type] : ~ v112604(VarCurr,3) ).

tff(addAssignment_66849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112604(VarCurr,B)
      <=> v112605(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112605(VarCurr,B)
      <=> ( v112606(VarCurr,B)
          | v112609(VarCurr,B) ) ) ) ).

tff(addAssignment_66848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112609(VarCurr,B)
      <=> v112610(VarCurr,B) ) ) ).

tff(addAssignment_66847,axiom,
    ! [VarCurr: state_type] :
      ( v112609(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_66846,axiom,
    ! [VarCurr: state_type] :
      ( v112610(VarCurr,0)
    <=> v112611(VarCurr) ) ).

tff(addAssignment_66845,axiom,
    ! [VarCurr: state_type] :
      ( v112610(VarCurr,1)
    <=> v112611(VarCurr) ) ).

tff(addAssignment_66844,axiom,
    ! [VarCurr: state_type] :
      ( v112611(VarCurr)
    <=> v112612(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_930,axiom,
    ! [VarCurr: state_type] :
      ( v112612(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $false )
        & ( v87667(VarCurr,1)
        <=> $true )
        & ( v87667(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_40,axiom,
    ! [VarCurr: state_type] : ~ v112606(VarCurr,2) ).

tff(addAssignment_66843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v112606(VarCurr,B)
      <=> v112607(VarCurr,B) ) ) ).

tff(addAssignment_66842,axiom,
    ! [VarCurr: state_type] :
      ( v112607(VarCurr,0)
    <=> v112608(VarCurr) ) ).

tff(addAssignment_66841,axiom,
    ! [VarCurr: state_type] :
      ( v112607(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_929,axiom,
    ! [VarCurr: state_type] :
      ( v112608(VarCurr)
    <=> ( ( v87667(VarCurr,2)
        <=> $false )
        & ( v87667(VarCurr,1)
        <=> $false )
        & ( v87667(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_66840,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,0)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66839,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,1)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66838,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,2)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66837,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,3)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66836,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,4)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66835,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,5)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66834,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,6)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66833,axiom,
    ! [VarCurr: state_type] :
      ( v112591(VarCurr,7)
    <=> v112592(VarCurr) ) ).

tff(addAssignment_66832,axiom,
    ! [VarCurr: state_type] :
      ( v112592(VarCurr)
    <=> v112532(VarCurr) ) ).

tff(addAssignment_66831,axiom,
    ! [VarCurr: state_type] :
      ( v112532(VarCurr)
    <=> v112534(VarCurr) ) ).

tff(addAssignment_66830,axiom,
    ! [VarCurr: state_type] :
      ( v112534(VarCurr)
    <=> v112536(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112574(VarNext)
       => ( v112536(VarNext)
        <=> v112536(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1462,axiom,
    ! [VarNext: state_type] :
      ( v112574(VarNext)
     => ( v112536(VarNext)
      <=> v112584(VarNext) ) ) ).

tff(addAssignment_66829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112584(VarNext)
      <=> v112582(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112585(VarCurr)
     => ( v112582(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_975,axiom,
    ! [VarCurr: state_type] :
      ( v112585(VarCurr)
     => ( v112582(VarCurr)
      <=> v112546(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11761,axiom,
    ! [VarCurr: state_type] :
      ( v112585(VarCurr)
    <=> ( v112586(VarCurr)
        & v112587(VarCurr) ) ) ).

tff(writeUnaryOperator_6262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112587(VarCurr)
    <=> v112542(VarCurr) ) ).

tff(writeUnaryOperator_6261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112586(VarCurr)
    <=> v112538(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112574(VarNext)
      <=> v112575(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112575(VarNext)
      <=> ( v112576(VarNext)
          & v112569(VarNext) ) ) ) ).

tff(writeUnaryOperator_6260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112576(VarNext)
      <=> v112578(VarNext) ) ) ).

tff(addAssignment_66828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112578(VarNext)
      <=> v112569(VarCurr) ) ) ).

tff(addAssignment_66827,axiom,
    ! [VarCurr: state_type] :
      ( v112569(VarCurr)
    <=> v112571(VarCurr) ) ).

tff(addAssignment_66826,axiom,
    ! [VarCurr: state_type] :
      ( v112571(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66825,axiom,
    ! [VarCurr: state_type] :
      ( v112546(VarCurr)
    <=> v112548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11758,axiom,
    ! [VarCurr: state_type] :
      ( v112548(VarCurr)
    <=> ( v112561(VarCurr)
        | v112564(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11757,axiom,
    ! [VarCurr: state_type] :
      ( v112564(VarCurr)
    <=> ( v112534(VarCurr)
        & v112565(VarCurr) ) ) ).

tff(writeUnaryOperator_6259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112565(VarCurr)
    <=> v112566(VarCurr) ) ).

tff(addAssignment_66824,axiom,
    ! [VarCurr: state_type] :
      ( v112566(VarCurr)
    <=> v112567(VarCurr) ) ).

tff(addAssignment_66823,axiom,
    ! [VarCurr: state_type] :
      ( v112567(VarCurr)
    <=> v112554(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11756,axiom,
    ! [VarCurr: state_type] :
      ( v112561(VarCurr)
    <=> ( v112550(VarCurr)
        & v112562(VarCurr) ) ) ).

tff(addAssignment_66822,axiom,
    ! [VarCurr: state_type] :
      ( v112562(VarCurr)
    <=> v112563(VarCurr) ) ).

tff(addAssignment_66821,axiom,
    ! [VarCurr: state_type] :
      ( v112563(VarCurr)
    <=> v112554(VarCurr) ) ).

tff(addAssignment_66820,axiom,
    ! [VarCurr: state_type] :
      ( v112554(VarCurr)
    <=> v112556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11755,axiom,
    ! [VarCurr: state_type] :
      ( v112556(VarCurr)
    <=> ( v1729(VarCurr)
        & v112559(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_928,axiom,
    ! [VarCurr: state_type] :
      ( v112559(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $true )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1604,axiom,
    ~ b0001000111000(12) ).

tff(bitBlastConstant_1603,axiom,
    ~ b0001000111000(11) ).

tff(bitBlastConstant_1602,axiom,
    ~ b0001000111000(10) ).

tff(bitBlastConstant_1601,axiom,
    b0001000111000(9) ).

tff(bitBlastConstant_1600,axiom,
    ~ b0001000111000(8) ).

tff(bitBlastConstant_1599,axiom,
    ~ b0001000111000(7) ).

tff(bitBlastConstant_1598,axiom,
    ~ b0001000111000(6) ).

tff(bitBlastConstant_1597,axiom,
    b0001000111000(5) ).

tff(bitBlastConstant_1596,axiom,
    b0001000111000(4) ).

tff(bitBlastConstant_1595,axiom,
    b0001000111000(3) ).

tff(bitBlastConstant_1594,axiom,
    ~ b0001000111000(2) ).

tff(bitBlastConstant_1593,axiom,
    ~ b0001000111000(1) ).

tff(bitBlastConstant_1592,axiom,
    ~ b0001000111000(0) ).

tff(addAssignment_66819,axiom,
    ! [VarCurr: state_type] :
      ( v112550(VarCurr)
    <=> v112552(VarCurr) ) ).

tff(addAssignment_66818,axiom,
    ! [VarCurr: state_type] :
      ( v112552(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_66817,axiom,
    ! [VarCurr: state_type] :
      ( v112542(VarCurr)
    <=> v112544(VarCurr) ) ).

tff(addAssignment_66816,axiom,
    ! [VarCurr: state_type] :
      ( v112544(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66815,axiom,
    ! [VarCurr: state_type] :
      ( v112538(VarCurr)
    <=> v112540(VarCurr) ) ).

tff(addAssignment_66814,axiom,
    ! [VarCurr: state_type] :
      ( v112540(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66813,axiom,
    ! [VarCurr: state_type] :
      ( v112483(VarCurr)
    <=> v2880(VarCurr,1) ) ).

tff(addAssignment_66812,axiom,
    ! [VarCurr: state_type] :
      ( v2880(VarCurr,1)
    <=> v2882(VarCurr,1) ) ).

tff(addAssignment_66811,axiom,
    ! [VarNext: state_type] :
      ( v2882(VarNext,1)
    <=> v112500(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112501(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v112500(VarNext,B)
            <=> v2882(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1461,axiom,
    ! [VarNext: state_type] :
      ( v112501(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112500(VarNext,B)
          <=> v112511(VarNext,B) ) ) ) ).

tff(addAssignment_66810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112511(VarNext,B)
          <=> v112509(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112512(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112509(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_974,axiom,
    ! [VarCurr: state_type] :
      ( v112512(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v112509(VarCurr,B)
          <=> v2892(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11754,axiom,
    ! [VarCurr: state_type] :
      ( v112512(VarCurr)
    <=> ( v112513(VarCurr)
        & v112514(VarCurr) ) ) ).

tff(writeUnaryOperator_6258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112514(VarCurr)
    <=> v2888(VarCurr) ) ).

tff(writeUnaryOperator_6257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112513(VarCurr)
    <=> v2884(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112501(VarNext)
      <=> v112502(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112502(VarNext)
      <=> ( v112503(VarNext)
          & v112496(VarNext) ) ) ) ).

tff(writeUnaryOperator_6256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112503(VarNext)
      <=> v112505(VarNext) ) ) ).

tff(addAssignment_66809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112505(VarNext)
      <=> v112496(VarCurr) ) ) ).

tff(addAssignment_66808,axiom,
    ! [VarCurr: state_type] :
      ( v112496(VarCurr)
    <=> v112498(VarCurr) ) ).

tff(addAssignment_66807,axiom,
    ! [VarCurr: state_type] :
      ( v112498(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66806,axiom,
    ! [VarCurr: state_type] :
      ( v2892(VarCurr,1)
    <=> v2894(VarCurr,1) ) ).

tff(addAssignment_66805,axiom,
    ! [VarCurr: state_type] :
      ( v2894(VarCurr,1)
    <=> v112487(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112487(VarCurr,B)
      <=> ( v112488(VarCurr,B)
          | v112491(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112491(VarCurr,B)
      <=> ( v2880(VarCurr,B)
          & v112492(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112492(VarCurr,B)
      <=> ~ v112493(VarCurr,B) ) ) ).

tff(addAssignment_66804,axiom,
    ! [VarCurr: state_type] :
      ( v112493(VarCurr,0)
    <=> v112494(VarCurr) ) ).

tff(addAssignment_66803,axiom,
    ! [VarCurr: state_type] :
      ( v112493(VarCurr,1)
    <=> v112494(VarCurr) ) ).

tff(addAssignment_66802,axiom,
    ! [VarCurr: state_type] :
      ( v112493(VarCurr,2)
    <=> v112494(VarCurr) ) ).

tff(addAssignment_66801,axiom,
    ! [VarCurr: state_type] :
      ( v112494(VarCurr)
    <=> v112486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v112488(VarCurr,B)
      <=> ( v2896(VarCurr,B)
          & v112489(VarCurr,B) ) ) ) ).

tff(addAssignment_66800,axiom,
    ! [VarCurr: state_type] :
      ( v112489(VarCurr,0)
    <=> v112490(VarCurr) ) ).

tff(addAssignment_66799,axiom,
    ! [VarCurr: state_type] :
      ( v112489(VarCurr,1)
    <=> v112490(VarCurr) ) ).

tff(addAssignment_66798,axiom,
    ! [VarCurr: state_type] :
      ( v112489(VarCurr,2)
    <=> v112490(VarCurr) ) ).

tff(addAssignment_66797,axiom,
    ! [VarCurr: state_type] :
      ( v112490(VarCurr)
    <=> v112486(VarCurr) ) ).

tff(addAssignment_66796,axiom,
    ! [VarCurr: state_type] :
      ( v112486(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_66795,axiom,
    ! [VarCurr: state_type] :
      ( v2896(VarCurr,1)
    <=> v112484(VarCurr,1) ) ).

tff(addAssignment_66794,axiom,
    ! [VarCurr: state_type] :
      ( v112484(VarCurr,0)
    <=> v100207(VarCurr,2) ) ).

tff(addAssignment_66793,axiom,
    ! [VarCurr: state_type] :
      ( v112484(VarCurr,1)
    <=> v100207(VarCurr,1) ) ).

tff(addAssignment_66792,axiom,
    ! [VarCurr: state_type] :
      ( v112484(VarCurr,2)
    <=> v2898(VarCurr) ) ).

tff(addAssignment_66791,axiom,
    ! [VarCurr: state_type] :
      ( v111693(VarCurr)
    <=> v111695(VarCurr) ) ).

tff(addAssignment_66790,axiom,
    ! [VarCurr: state_type] :
      ( v111695(VarCurr)
    <=> v111697(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112466(VarNext)
       => ( v111697(VarNext)
        <=> v111697(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1460,axiom,
    ! [VarNext: state_type] :
      ( v112466(VarNext)
     => ( v111697(VarNext)
      <=> v112476(VarNext) ) ) ).

tff(addAssignment_66789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112476(VarNext)
      <=> v112474(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112477(VarCurr)
     => ( v112474(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_973,axiom,
    ! [VarCurr: state_type] :
      ( v112477(VarCurr)
     => ( v112474(VarCurr)
      <=> v111707(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11751,axiom,
    ! [VarCurr: state_type] :
      ( v112477(VarCurr)
    <=> ( v112478(VarCurr)
        & v112479(VarCurr) ) ) ).

tff(writeUnaryOperator_6254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112479(VarCurr)
    <=> v111703(VarCurr) ) ).

tff(writeUnaryOperator_6253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112478(VarCurr)
    <=> v111699(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112466(VarNext)
      <=> v112467(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112467(VarNext)
      <=> ( v112468(VarNext)
          & v112461(VarNext) ) ) ) ).

tff(writeUnaryOperator_6252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112468(VarNext)
      <=> v112470(VarNext) ) ) ).

tff(addAssignment_66788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112470(VarNext)
      <=> v112461(VarCurr) ) ) ).

tff(addAssignment_66787,axiom,
    ! [VarCurr: state_type] :
      ( v112461(VarCurr)
    <=> v112463(VarCurr) ) ).

tff(addAssignment_66786,axiom,
    ! [VarCurr: state_type] :
      ( v112463(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66785,axiom,
    ! [VarCurr: state_type] :
      ( v111707(VarCurr)
    <=> v111709(VarCurr) ) ).

tff(addAssignment_66784,axiom,
    ! [VarCurr: state_type] :
      ( v111709(VarCurr)
    <=> v111711(VarCurr) ) ).

tff(addAssignment_66783,axiom,
    ! [VarCurr: state_type] :
      ( v111711(VarCurr)
    <=> v111713(VarCurr) ) ).

tff(writeUnaryOperator_6251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111713(VarCurr)
    <=> v112331(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11748,axiom,
    ! [VarCurr: state_type] :
      ( v112331(VarCurr)
    <=> ( v112332(VarCurr)
        | v112459(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4750,axiom,
    ! [VarCurr: state_type] :
      ( v112459(VarCurr)
    <=> ( v112151(VarCurr)
        & v112265(VarCurr,16) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11747,axiom,
    ! [VarCurr: state_type] :
      ( v112332(VarCurr)
    <=> ( v112333(VarCurr)
        & v112454(VarCurr) ) ) ).

tff(writeUnaryOperator_6250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112454(VarCurr)
    <=> v112455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11746,axiom,
    ! [VarCurr: state_type] :
      ( v112455(VarCurr)
    <=> ( v112456(VarCurr)
        & v112458(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4749,axiom,
    ! [VarCurr: state_type] :
      ( v112458(VarCurr)
    <=> ( v111715(VarCurr,16)
        | v112265(VarCurr,16) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11745,axiom,
    ! [VarCurr: state_type] :
      ( v112456(VarCurr)
    <=> ( v112151(VarCurr)
        | v112457(VarCurr) ) ) ).

tff(writeUnaryOperator_6249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112457(VarCurr)
    <=> v112265(VarCurr,16) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11744,axiom,
    ! [VarCurr: state_type] :
      ( v112333(VarCurr)
    <=> ( v112334(VarCurr)
        | v112453(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4748,axiom,
    ! [VarCurr: state_type] :
      ( v112453(VarCurr)
    <=> ( v112156(VarCurr)
        & v112265(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11743,axiom,
    ! [VarCurr: state_type] :
      ( v112334(VarCurr)
    <=> ( v112335(VarCurr)
        & v112448(VarCurr) ) ) ).

tff(writeUnaryOperator_6248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112448(VarCurr)
    <=> v112449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11742,axiom,
    ! [VarCurr: state_type] :
      ( v112449(VarCurr)
    <=> ( v112450(VarCurr)
        & v112452(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4747,axiom,
    ! [VarCurr: state_type] :
      ( v112452(VarCurr)
    <=> ( v111715(VarCurr,15)
        | v112265(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11741,axiom,
    ! [VarCurr: state_type] :
      ( v112450(VarCurr)
    <=> ( v112156(VarCurr)
        | v112451(VarCurr) ) ) ).

tff(writeUnaryOperator_6247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112451(VarCurr)
    <=> v112265(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11740,axiom,
    ! [VarCurr: state_type] :
      ( v112335(VarCurr)
    <=> ( v112336(VarCurr)
        | v112447(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4746,axiom,
    ! [VarCurr: state_type] :
      ( v112447(VarCurr)
    <=> ( v112161(VarCurr)
        & v112265(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11739,axiom,
    ! [VarCurr: state_type] :
      ( v112336(VarCurr)
    <=> ( v112337(VarCurr)
        & v112442(VarCurr) ) ) ).

tff(writeUnaryOperator_6246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112442(VarCurr)
    <=> v112443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11738,axiom,
    ! [VarCurr: state_type] :
      ( v112443(VarCurr)
    <=> ( v112444(VarCurr)
        & v112446(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4745,axiom,
    ! [VarCurr: state_type] :
      ( v112446(VarCurr)
    <=> ( v111715(VarCurr,14)
        | v112265(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11737,axiom,
    ! [VarCurr: state_type] :
      ( v112444(VarCurr)
    <=> ( v112161(VarCurr)
        | v112445(VarCurr) ) ) ).

tff(writeUnaryOperator_6245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112445(VarCurr)
    <=> v112265(VarCurr,14) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11736,axiom,
    ! [VarCurr: state_type] :
      ( v112337(VarCurr)
    <=> ( v112338(VarCurr)
        | v112441(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4744,axiom,
    ! [VarCurr: state_type] :
      ( v112441(VarCurr)
    <=> ( v112166(VarCurr)
        & v112265(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11735,axiom,
    ! [VarCurr: state_type] :
      ( v112338(VarCurr)
    <=> ( v112339(VarCurr)
        & v112436(VarCurr) ) ) ).

tff(writeUnaryOperator_6244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112436(VarCurr)
    <=> v112437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11734,axiom,
    ! [VarCurr: state_type] :
      ( v112437(VarCurr)
    <=> ( v112438(VarCurr)
        & v112440(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4743,axiom,
    ! [VarCurr: state_type] :
      ( v112440(VarCurr)
    <=> ( v111715(VarCurr,13)
        | v112265(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11733,axiom,
    ! [VarCurr: state_type] :
      ( v112438(VarCurr)
    <=> ( v112166(VarCurr)
        | v112439(VarCurr) ) ) ).

tff(writeUnaryOperator_6243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112439(VarCurr)
    <=> v112265(VarCurr,13) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11732,axiom,
    ! [VarCurr: state_type] :
      ( v112339(VarCurr)
    <=> ( v112340(VarCurr)
        | v112435(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4742,axiom,
    ! [VarCurr: state_type] :
      ( v112435(VarCurr)
    <=> ( v112171(VarCurr)
        & v112265(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11731,axiom,
    ! [VarCurr: state_type] :
      ( v112340(VarCurr)
    <=> ( v112341(VarCurr)
        & v112430(VarCurr) ) ) ).

tff(writeUnaryOperator_6242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112430(VarCurr)
    <=> v112431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11730,axiom,
    ! [VarCurr: state_type] :
      ( v112431(VarCurr)
    <=> ( v112432(VarCurr)
        & v112434(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4741,axiom,
    ! [VarCurr: state_type] :
      ( v112434(VarCurr)
    <=> ( v111715(VarCurr,12)
        | v112265(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11729,axiom,
    ! [VarCurr: state_type] :
      ( v112432(VarCurr)
    <=> ( v112171(VarCurr)
        | v112433(VarCurr) ) ) ).

tff(writeUnaryOperator_6241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112433(VarCurr)
    <=> v112265(VarCurr,12) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11728,axiom,
    ! [VarCurr: state_type] :
      ( v112341(VarCurr)
    <=> ( v112342(VarCurr)
        | v112429(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4740,axiom,
    ! [VarCurr: state_type] :
      ( v112429(VarCurr)
    <=> ( v112176(VarCurr)
        & v112265(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11727,axiom,
    ! [VarCurr: state_type] :
      ( v112342(VarCurr)
    <=> ( v112343(VarCurr)
        & v112424(VarCurr) ) ) ).

tff(writeUnaryOperator_6240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112424(VarCurr)
    <=> v112425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11726,axiom,
    ! [VarCurr: state_type] :
      ( v112425(VarCurr)
    <=> ( v112426(VarCurr)
        & v112428(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4739,axiom,
    ! [VarCurr: state_type] :
      ( v112428(VarCurr)
    <=> ( v111715(VarCurr,11)
        | v112265(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11725,axiom,
    ! [VarCurr: state_type] :
      ( v112426(VarCurr)
    <=> ( v112176(VarCurr)
        | v112427(VarCurr) ) ) ).

tff(writeUnaryOperator_6239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112427(VarCurr)
    <=> v112265(VarCurr,11) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11724,axiom,
    ! [VarCurr: state_type] :
      ( v112343(VarCurr)
    <=> ( v112344(VarCurr)
        | v112423(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4738,axiom,
    ! [VarCurr: state_type] :
      ( v112423(VarCurr)
    <=> ( v112181(VarCurr)
        & v112265(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11723,axiom,
    ! [VarCurr: state_type] :
      ( v112344(VarCurr)
    <=> ( v112345(VarCurr)
        & v112418(VarCurr) ) ) ).

tff(writeUnaryOperator_6238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112418(VarCurr)
    <=> v112419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11722,axiom,
    ! [VarCurr: state_type] :
      ( v112419(VarCurr)
    <=> ( v112420(VarCurr)
        & v112422(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4737,axiom,
    ! [VarCurr: state_type] :
      ( v112422(VarCurr)
    <=> ( v111715(VarCurr,10)
        | v112265(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11721,axiom,
    ! [VarCurr: state_type] :
      ( v112420(VarCurr)
    <=> ( v112181(VarCurr)
        | v112421(VarCurr) ) ) ).

tff(writeUnaryOperator_6237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112421(VarCurr)
    <=> v112265(VarCurr,10) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11720,axiom,
    ! [VarCurr: state_type] :
      ( v112345(VarCurr)
    <=> ( v112346(VarCurr)
        | v112417(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4736,axiom,
    ! [VarCurr: state_type] :
      ( v112417(VarCurr)
    <=> ( v112186(VarCurr)
        & v112265(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11719,axiom,
    ! [VarCurr: state_type] :
      ( v112346(VarCurr)
    <=> ( v112347(VarCurr)
        & v112412(VarCurr) ) ) ).

tff(writeUnaryOperator_6236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112412(VarCurr)
    <=> v112413(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11718,axiom,
    ! [VarCurr: state_type] :
      ( v112413(VarCurr)
    <=> ( v112414(VarCurr)
        & v112416(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4735,axiom,
    ! [VarCurr: state_type] :
      ( v112416(VarCurr)
    <=> ( v111715(VarCurr,9)
        | v112265(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11717,axiom,
    ! [VarCurr: state_type] :
      ( v112414(VarCurr)
    <=> ( v112186(VarCurr)
        | v112415(VarCurr) ) ) ).

tff(writeUnaryOperator_6235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112415(VarCurr)
    <=> v112265(VarCurr,9) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11716,axiom,
    ! [VarCurr: state_type] :
      ( v112347(VarCurr)
    <=> ( v112348(VarCurr)
        | v112411(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4734,axiom,
    ! [VarCurr: state_type] :
      ( v112411(VarCurr)
    <=> ( v112191(VarCurr)
        & v112265(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11715,axiom,
    ! [VarCurr: state_type] :
      ( v112348(VarCurr)
    <=> ( v112349(VarCurr)
        & v112406(VarCurr) ) ) ).

tff(writeUnaryOperator_6234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112406(VarCurr)
    <=> v112407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11714,axiom,
    ! [VarCurr: state_type] :
      ( v112407(VarCurr)
    <=> ( v112408(VarCurr)
        & v112410(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4733,axiom,
    ! [VarCurr: state_type] :
      ( v112410(VarCurr)
    <=> ( v111715(VarCurr,8)
        | v112265(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11713,axiom,
    ! [VarCurr: state_type] :
      ( v112408(VarCurr)
    <=> ( v112191(VarCurr)
        | v112409(VarCurr) ) ) ).

tff(writeUnaryOperator_6233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112409(VarCurr)
    <=> v112265(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11712,axiom,
    ! [VarCurr: state_type] :
      ( v112349(VarCurr)
    <=> ( v112350(VarCurr)
        | v112405(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4732,axiom,
    ! [VarCurr: state_type] :
      ( v112405(VarCurr)
    <=> ( v112196(VarCurr)
        & v112265(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11711,axiom,
    ! [VarCurr: state_type] :
      ( v112350(VarCurr)
    <=> ( v112351(VarCurr)
        & v112400(VarCurr) ) ) ).

tff(writeUnaryOperator_6232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112400(VarCurr)
    <=> v112401(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11710,axiom,
    ! [VarCurr: state_type] :
      ( v112401(VarCurr)
    <=> ( v112402(VarCurr)
        & v112404(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4731,axiom,
    ! [VarCurr: state_type] :
      ( v112404(VarCurr)
    <=> ( v111715(VarCurr,7)
        | v112265(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11709,axiom,
    ! [VarCurr: state_type] :
      ( v112402(VarCurr)
    <=> ( v112196(VarCurr)
        | v112403(VarCurr) ) ) ).

tff(writeUnaryOperator_6231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112403(VarCurr)
    <=> v112265(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11708,axiom,
    ! [VarCurr: state_type] :
      ( v112351(VarCurr)
    <=> ( v112352(VarCurr)
        | v112399(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4730,axiom,
    ! [VarCurr: state_type] :
      ( v112399(VarCurr)
    <=> ( v112201(VarCurr)
        & v112265(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11707,axiom,
    ! [VarCurr: state_type] :
      ( v112352(VarCurr)
    <=> ( v112353(VarCurr)
        & v112394(VarCurr) ) ) ).

tff(writeUnaryOperator_6230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112394(VarCurr)
    <=> v112395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11706,axiom,
    ! [VarCurr: state_type] :
      ( v112395(VarCurr)
    <=> ( v112396(VarCurr)
        & v112398(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4729,axiom,
    ! [VarCurr: state_type] :
      ( v112398(VarCurr)
    <=> ( v111715(VarCurr,6)
        | v112265(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11705,axiom,
    ! [VarCurr: state_type] :
      ( v112396(VarCurr)
    <=> ( v112201(VarCurr)
        | v112397(VarCurr) ) ) ).

tff(writeUnaryOperator_6229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112397(VarCurr)
    <=> v112265(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11704,axiom,
    ! [VarCurr: state_type] :
      ( v112353(VarCurr)
    <=> ( v112354(VarCurr)
        | v112393(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4728,axiom,
    ! [VarCurr: state_type] :
      ( v112393(VarCurr)
    <=> ( v112206(VarCurr)
        & v112265(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11703,axiom,
    ! [VarCurr: state_type] :
      ( v112354(VarCurr)
    <=> ( v112355(VarCurr)
        & v112388(VarCurr) ) ) ).

tff(writeUnaryOperator_6228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112388(VarCurr)
    <=> v112389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11702,axiom,
    ! [VarCurr: state_type] :
      ( v112389(VarCurr)
    <=> ( v112390(VarCurr)
        & v112392(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4727,axiom,
    ! [VarCurr: state_type] :
      ( v112392(VarCurr)
    <=> ( v111715(VarCurr,5)
        | v112265(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11701,axiom,
    ! [VarCurr: state_type] :
      ( v112390(VarCurr)
    <=> ( v112206(VarCurr)
        | v112391(VarCurr) ) ) ).

tff(writeUnaryOperator_6227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112391(VarCurr)
    <=> v112265(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11700,axiom,
    ! [VarCurr: state_type] :
      ( v112355(VarCurr)
    <=> ( v112356(VarCurr)
        | v112387(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4726,axiom,
    ! [VarCurr: state_type] :
      ( v112387(VarCurr)
    <=> ( v112211(VarCurr)
        & v112265(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11699,axiom,
    ! [VarCurr: state_type] :
      ( v112356(VarCurr)
    <=> ( v112357(VarCurr)
        & v112382(VarCurr) ) ) ).

tff(writeUnaryOperator_6226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112382(VarCurr)
    <=> v112383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11698,axiom,
    ! [VarCurr: state_type] :
      ( v112383(VarCurr)
    <=> ( v112384(VarCurr)
        & v112386(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4725,axiom,
    ! [VarCurr: state_type] :
      ( v112386(VarCurr)
    <=> ( v111715(VarCurr,4)
        | v112265(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11697,axiom,
    ! [VarCurr: state_type] :
      ( v112384(VarCurr)
    <=> ( v112211(VarCurr)
        | v112385(VarCurr) ) ) ).

tff(writeUnaryOperator_6225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112385(VarCurr)
    <=> v112265(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11696,axiom,
    ! [VarCurr: state_type] :
      ( v112357(VarCurr)
    <=> ( v112358(VarCurr)
        | v112381(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4724,axiom,
    ! [VarCurr: state_type] :
      ( v112381(VarCurr)
    <=> ( v112216(VarCurr)
        & v112265(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11695,axiom,
    ! [VarCurr: state_type] :
      ( v112358(VarCurr)
    <=> ( v112359(VarCurr)
        & v112376(VarCurr) ) ) ).

tff(writeUnaryOperator_6224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112376(VarCurr)
    <=> v112377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11694,axiom,
    ! [VarCurr: state_type] :
      ( v112377(VarCurr)
    <=> ( v112378(VarCurr)
        & v112380(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4723,axiom,
    ! [VarCurr: state_type] :
      ( v112380(VarCurr)
    <=> ( v111715(VarCurr,3)
        | v112265(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11693,axiom,
    ! [VarCurr: state_type] :
      ( v112378(VarCurr)
    <=> ( v112216(VarCurr)
        | v112379(VarCurr) ) ) ).

tff(writeUnaryOperator_6223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112379(VarCurr)
    <=> v112265(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11692,axiom,
    ! [VarCurr: state_type] :
      ( v112359(VarCurr)
    <=> ( v112360(VarCurr)
        | v112375(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4722,axiom,
    ! [VarCurr: state_type] :
      ( v112375(VarCurr)
    <=> ( v112221(VarCurr)
        & v112265(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11691,axiom,
    ! [VarCurr: state_type] :
      ( v112360(VarCurr)
    <=> ( v112361(VarCurr)
        & v112370(VarCurr) ) ) ).

tff(writeUnaryOperator_6222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112370(VarCurr)
    <=> v112371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11690,axiom,
    ! [VarCurr: state_type] :
      ( v112371(VarCurr)
    <=> ( v112372(VarCurr)
        & v112374(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4721,axiom,
    ! [VarCurr: state_type] :
      ( v112374(VarCurr)
    <=> ( v111715(VarCurr,2)
        | v112265(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11689,axiom,
    ! [VarCurr: state_type] :
      ( v112372(VarCurr)
    <=> ( v112221(VarCurr)
        | v112373(VarCurr) ) ) ).

tff(writeUnaryOperator_6221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112373(VarCurr)
    <=> v112265(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11688,axiom,
    ! [VarCurr: state_type] :
      ( v112361(VarCurr)
    <=> ( v112362(VarCurr)
        | v112369(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4720,axiom,
    ! [VarCurr: state_type] :
      ( v112369(VarCurr)
    <=> ( v112226(VarCurr)
        & v112265(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11687,axiom,
    ! [VarCurr: state_type] :
      ( v112362(VarCurr)
    <=> ( v112363(VarCurr)
        & v112364(VarCurr) ) ) ).

tff(writeUnaryOperator_6220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112364(VarCurr)
    <=> v112365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11686,axiom,
    ! [VarCurr: state_type] :
      ( v112365(VarCurr)
    <=> ( v112366(VarCurr)
        & v112368(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4719,axiom,
    ! [VarCurr: state_type] :
      ( v112368(VarCurr)
    <=> ( v111715(VarCurr,1)
        | v112265(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11685,axiom,
    ! [VarCurr: state_type] :
      ( v112366(VarCurr)
    <=> ( v112226(VarCurr)
        | v112367(VarCurr) ) ) ).

tff(writeUnaryOperator_6219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112367(VarCurr)
    <=> v112265(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11684,axiom,
    ! [VarCurr: state_type] :
      ( v112363(VarCurr)
    <=> ( v112225(VarCurr)
        & v112265(VarCurr,0) ) ) ).

tff(writeUnaryOperator_6218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112265(VarCurr,B)
      <=> ~ v112267(VarCurr,B) ) ) ).

tff(addAssignment_66782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112267(VarCurr,B)
      <=> v112269(VarCurr,B) ) ) ).

tff(addAssignment_66781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112269(VarCurr,B)
      <=> v112271(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112312(VarNext)
       => ! [B: $int] :
            ( ( $less(B,17)
              & ~ $less(B,0) )
           => ( v112271(VarNext,B)
            <=> v112271(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1459,axiom,
    ! [VarNext: state_type] :
      ( v112312(VarNext)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112271(VarNext,B)
          <=> v112322(VarNext,B) ) ) ) ).

tff(addAssignment_66780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112322(VarNext,B)
          <=> v112320(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112323(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112320(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_972,axiom,
    ! [VarCurr: state_type] :
      ( v112323(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112320(VarCurr,B)
          <=> v112281(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11683,axiom,
    ! [VarCurr: state_type] :
      ( v112323(VarCurr)
    <=> ( v112324(VarCurr)
        & v112325(VarCurr) ) ) ).

tff(writeUnaryOperator_6217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112325(VarCurr)
    <=> v112277(VarCurr) ) ).

tff(writeUnaryOperator_6216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112324(VarCurr)
    <=> v112273(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112312(VarNext)
      <=> v112313(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112313(VarNext)
      <=> ( v112314(VarNext)
          & v112307(VarNext) ) ) ) ).

tff(writeUnaryOperator_6215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112314(VarNext)
      <=> v112316(VarNext) ) ) ).

tff(addAssignment_66779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112316(VarNext)
      <=> v112307(VarCurr) ) ) ).

tff(addAssignment_66778,axiom,
    ! [VarCurr: state_type] :
      ( v112307(VarCurr)
    <=> v112309(VarCurr) ) ).

tff(addAssignment_66777,axiom,
    ! [VarCurr: state_type] :
      ( v112309(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112281(VarCurr,B)
      <=> v112283(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112283(VarCurr,B)
      <=> ( v112299(VarCurr,B)
          | v112302(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112302(VarCurr,B)
      <=> ( v112269(VarCurr,B)
          & v112303(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112303(VarCurr,B)
      <=> ~ v112304(VarCurr,B) ) ) ).

tff(addAssignment_66775,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,0)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66774,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,1)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66773,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,2)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66772,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,3)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66771,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,4)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66770,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,5)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66769,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,6)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66768,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,7)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66767,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,8)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66766,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,9)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66765,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,10)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66764,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,11)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66763,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,12)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66762,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,13)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66761,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,14)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66760,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,15)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66759,axiom,
    ! [VarCurr: state_type] :
      ( v112304(VarCurr,16)
    <=> v112305(VarCurr) ) ).

tff(addAssignment_66758,axiom,
    ! [VarCurr: state_type] :
      ( v112305(VarCurr)
    <=> v112292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112299(VarCurr,B)
      <=> ( v112285(VarCurr,B)
          & v112300(VarCurr,B) ) ) ) ).

tff(addAssignment_66757,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,0)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66756,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,1)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66755,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,2)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66754,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,3)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66753,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,4)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66752,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,5)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66751,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,6)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66750,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,7)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66749,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,8)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66748,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,9)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66747,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,10)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66746,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,11)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66745,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,12)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66744,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,13)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66743,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,14)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66742,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,15)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66741,axiom,
    ! [VarCurr: state_type] :
      ( v112300(VarCurr,16)
    <=> v112301(VarCurr) ) ).

tff(addAssignment_66740,axiom,
    ! [VarCurr: state_type] :
      ( v112301(VarCurr)
    <=> v112292(VarCurr) ) ).

tff(addAssignment_66739,axiom,
    ! [VarCurr: state_type] :
      ( v112292(VarCurr)
    <=> v112294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11680,axiom,
    ! [VarCurr: state_type] :
      ( v112294(VarCurr)
    <=> ( v1729(VarCurr)
        & v112297(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_927,axiom,
    ! [VarCurr: state_type] :
      ( v112297(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1591,axiom,
    ~ b0000000101000(12) ).

tff(bitBlastConstant_1590,axiom,
    ~ b0000000101000(11) ).

tff(bitBlastConstant_1589,axiom,
    ~ b0000000101000(10) ).

tff(bitBlastConstant_1588,axiom,
    ~ b0000000101000(9) ).

tff(bitBlastConstant_1587,axiom,
    ~ b0000000101000(8) ).

tff(bitBlastConstant_1586,axiom,
    ~ b0000000101000(7) ).

tff(bitBlastConstant_1585,axiom,
    ~ b0000000101000(6) ).

tff(bitBlastConstant_1584,axiom,
    b0000000101000(5) ).

tff(bitBlastConstant_1583,axiom,
    ~ b0000000101000(4) ).

tff(bitBlastConstant_1582,axiom,
    b0000000101000(3) ).

tff(bitBlastConstant_1581,axiom,
    ~ b0000000101000(2) ).

tff(bitBlastConstant_1580,axiom,
    ~ b0000000101000(1) ).

tff(bitBlastConstant_1579,axiom,
    ~ b0000000101000(0) ).

tff(addAssignment_66738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112285(VarCurr,B)
      <=> v112287(VarCurr,B) ) ) ).

tff(writeUnaryOperator_6213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112287(VarCurr,B)
      <=> ~ v112289(VarCurr,B) ) ) ).

tff(addAssignment_66737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112289(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_66736,axiom,
    ! [VarCurr: state_type] :
      ( v112277(VarCurr)
    <=> v112279(VarCurr) ) ).

tff(addAssignment_66735,axiom,
    ! [VarCurr: state_type] :
      ( v112279(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66734,axiom,
    ! [VarCurr: state_type] :
      ( v112273(VarCurr)
    <=> v112275(VarCurr) ) ).

tff(addAssignment_66733,axiom,
    ! [VarCurr: state_type] :
      ( v112275(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_66732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v111715(VarCurr,B)
      <=> v111717(VarCurr,B) ) ) ).

tff(addAssignment_66731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v111717(VarCurr,B)
      <=> v111719(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112248(VarNext)
       => ! [B: $int] :
            ( ( $less(B,17)
              & ~ $less(B,0) )
           => ( v111719(VarNext,B)
            <=> v111719(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1458,axiom,
    ! [VarNext: state_type] :
      ( v112248(VarNext)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v111719(VarNext,B)
          <=> v112258(VarNext,B) ) ) ) ).

tff(addAssignment_66730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112258(VarNext,B)
          <=> v112256(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112259(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112256(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_971,axiom,
    ! [VarCurr: state_type] :
      ( v112259(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v112256(VarCurr,B)
          <=> v111729(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11679,axiom,
    ! [VarCurr: state_type] :
      ( v112259(VarCurr)
    <=> ( v112260(VarCurr)
        & v112261(VarCurr) ) ) ).

tff(writeUnaryOperator_6212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112261(VarCurr)
    <=> v111725(VarCurr) ) ).

tff(writeUnaryOperator_6211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112260(VarCurr)
    <=> v111721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112248(VarNext)
      <=> v112249(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112249(VarNext)
      <=> ( v112250(VarNext)
          & v112243(VarNext) ) ) ) ).

tff(writeUnaryOperator_6210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v112250(VarNext)
      <=> v112252(VarNext) ) ) ).

tff(addAssignment_66729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v112252(VarNext)
      <=> v112243(VarCurr) ) ) ).

tff(addAssignment_66728,axiom,
    ! [VarCurr: state_type] :
      ( v112243(VarCurr)
    <=> v112245(VarCurr) ) ).

tff(addAssignment_66727,axiom,
    ! [VarCurr: state_type] :
      ( v112245(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v111729(VarCurr,B)
      <=> v111731(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v111731(VarCurr,B)
      <=> ( v112234(VarCurr,B)
          | v112237(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112237(VarCurr,B)
      <=> ( v111717(VarCurr,B)
          & v112238(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112238(VarCurr,B)
      <=> ~ v112239(VarCurr,B) ) ) ).

tff(addAssignment_66725,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,0)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66724,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,1)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66723,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,2)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66722,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,3)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66721,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,4)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66720,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,5)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66719,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,6)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66718,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,7)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66717,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,8)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66716,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,9)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66715,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,10)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66714,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,11)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66713,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,12)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66712,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,13)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66711,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,14)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66710,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,15)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66709,axiom,
    ! [VarCurr: state_type] :
      ( v112239(VarCurr,16)
    <=> v112240(VarCurr) ) ).

tff(addAssignment_66708,axiom,
    ! [VarCurr: state_type] :
      ( v112240(VarCurr)
    <=> v112229(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v112234(VarCurr,B)
      <=> ( v111733(VarCurr,B)
          & v112235(VarCurr,B) ) ) ) ).

tff(addAssignment_66707,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,0)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66706,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,1)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66705,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,2)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66704,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,3)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66703,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,4)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66702,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,5)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66701,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,6)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66700,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,7)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66699,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,8)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66698,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,9)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66697,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,10)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66696,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,11)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66695,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,12)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66694,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,13)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66693,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,14)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66692,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,15)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66691,axiom,
    ! [VarCurr: state_type] :
      ( v112235(VarCurr,16)
    <=> v112236(VarCurr) ) ).

tff(addAssignment_66690,axiom,
    ! [VarCurr: state_type] :
      ( v112236(VarCurr)
    <=> v112229(VarCurr) ) ).

tff(addAssignment_66689,axiom,
    ! [VarCurr: state_type] :
      ( v112229(VarCurr)
    <=> v112231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11676,axiom,
    ! [VarCurr: state_type] :
      ( v112231(VarCurr)
    <=> ( v108897(VarCurr)
        | v111737(VarCurr) ) ) ).

tff(addAssignment_66688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,0) )
     => ( v111733(VarCurr,B)
      <=> v111735(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111737(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v111735(VarCurr,B)
          <=> v112131(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_970,axiom,
    ! [VarCurr: state_type] :
      ( v111737(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,17)
            & ~ $less(B,0) )
         => ( v111735(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_1578,axiom,
    ~ b00000000000000000(16) ).

tff(bitBlastConstant_1577,axiom,
    ~ b00000000000000000(15) ).

tff(bitBlastConstant_1576,axiom,
    ~ b00000000000000000(14) ).

tff(bitBlastConstant_1575,axiom,
    ~ b00000000000000000(13) ).

tff(bitBlastConstant_1574,axiom,
    ~ b00000000000000000(12) ).

tff(bitBlastConstant_1573,axiom,
    ~ b00000000000000000(11) ).

tff(bitBlastConstant_1572,axiom,
    ~ b00000000000000000(10) ).

tff(bitBlastConstant_1571,axiom,
    ~ b00000000000000000(9) ).

tff(bitBlastConstant_1570,axiom,
    ~ b00000000000000000(8) ).

tff(bitBlastConstant_1569,axiom,
    ~ b00000000000000000(7) ).

tff(bitBlastConstant_1568,axiom,
    ~ b00000000000000000(6) ).

tff(bitBlastConstant_1567,axiom,
    ~ b00000000000000000(5) ).

tff(bitBlastConstant_1566,axiom,
    ~ b00000000000000000(4) ).

tff(bitBlastConstant_1565,axiom,
    ~ b00000000000000000(3) ).

tff(bitBlastConstant_1564,axiom,
    ~ b00000000000000000(2) ).

tff(bitBlastConstant_1563,axiom,
    ~ b00000000000000000(1) ).

tff(bitBlastConstant_1562,axiom,
    ~ b00000000000000000(0) ).

tff(addAssignment_66687,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,0)
    <=> v112225(VarCurr) ) ).

tff(addAssignment_66686,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,1)
    <=> v112223(VarCurr) ) ).

tff(addAssignment_66685,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,2)
    <=> v112218(VarCurr) ) ).

tff(addAssignment_66684,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,3)
    <=> v112213(VarCurr) ) ).

tff(addAssignment_66683,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,4)
    <=> v112208(VarCurr) ) ).

tff(addAssignment_66682,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,5)
    <=> v112203(VarCurr) ) ).

tff(addAssignment_66681,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,6)
    <=> v112198(VarCurr) ) ).

tff(addAssignment_66680,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,7)
    <=> v112193(VarCurr) ) ).

tff(addAssignment_66679,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,8)
    <=> v112188(VarCurr) ) ).

tff(addAssignment_66678,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,9)
    <=> v112183(VarCurr) ) ).

tff(addAssignment_66677,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,10)
    <=> v112178(VarCurr) ) ).

tff(addAssignment_66676,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,11)
    <=> v112173(VarCurr) ) ).

tff(addAssignment_66675,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,12)
    <=> v112168(VarCurr) ) ).

tff(addAssignment_66674,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,13)
    <=> v112163(VarCurr) ) ).

tff(addAssignment_66673,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,14)
    <=> v112158(VarCurr) ) ).

tff(addAssignment_66672,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,15)
    <=> v112153(VarCurr) ) ).

tff(addAssignment_66671,axiom,
    ! [VarCurr: state_type] :
      ( v112131(VarCurr,16)
    <=> v112133(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11675,axiom,
    ! [VarCurr: state_type] :
      ( v112223(VarCurr)
    <=> ( v112224(VarCurr)
        & v112227(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4718,axiom,
    ! [VarCurr: state_type] :
      ( v112227(VarCurr)
    <=> ( v111715(VarCurr,0)
        | v111715(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11674,axiom,
    ! [VarCurr: state_type] :
      ( v112224(VarCurr)
    <=> ( v112225(VarCurr)
        | v112226(VarCurr) ) ) ).

tff(writeUnaryOperator_6208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112226(VarCurr)
    <=> v111715(VarCurr,1) ) ).

tff(writeUnaryOperator_6207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112225(VarCurr)
    <=> v111715(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11673,axiom,
    ! [VarCurr: state_type] :
      ( v112218(VarCurr)
    <=> ( v112219(VarCurr)
        & v112222(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4717,axiom,
    ! [VarCurr: state_type] :
      ( v112222(VarCurr)
    <=> ( v112150(VarCurr)
        | v111715(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11672,axiom,
    ! [VarCurr: state_type] :
      ( v112219(VarCurr)
    <=> ( v112220(VarCurr)
        | v112221(VarCurr) ) ) ).

tff(writeUnaryOperator_6206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112221(VarCurr)
    <=> v111715(VarCurr,2) ) ).

tff(writeUnaryOperator_6205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112220(VarCurr)
    <=> v112150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11671,axiom,
    ! [VarCurr: state_type] :
      ( v112213(VarCurr)
    <=> ( v112214(VarCurr)
        & v112217(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4716,axiom,
    ! [VarCurr: state_type] :
      ( v112217(VarCurr)
    <=> ( v112149(VarCurr)
        | v111715(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11670,axiom,
    ! [VarCurr: state_type] :
      ( v112214(VarCurr)
    <=> ( v112215(VarCurr)
        | v112216(VarCurr) ) ) ).

tff(writeUnaryOperator_6204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112216(VarCurr)
    <=> v111715(VarCurr,3) ) ).

tff(writeUnaryOperator_6203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112215(VarCurr)
    <=> v112149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11669,axiom,
    ! [VarCurr: state_type] :
      ( v112208(VarCurr)
    <=> ( v112209(VarCurr)
        & v112212(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4715,axiom,
    ! [VarCurr: state_type] :
      ( v112212(VarCurr)
    <=> ( v112148(VarCurr)
        | v111715(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11668,axiom,
    ! [VarCurr: state_type] :
      ( v112209(VarCurr)
    <=> ( v112210(VarCurr)
        | v112211(VarCurr) ) ) ).

tff(writeUnaryOperator_6202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112211(VarCurr)
    <=> v111715(VarCurr,4) ) ).

tff(writeUnaryOperator_6201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112210(VarCurr)
    <=> v112148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11667,axiom,
    ! [VarCurr: state_type] :
      ( v112203(VarCurr)
    <=> ( v112204(VarCurr)
        & v112207(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4714,axiom,
    ! [VarCurr: state_type] :
      ( v112207(VarCurr)
    <=> ( v112147(VarCurr)
        | v111715(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11666,axiom,
    ! [VarCurr: state_type] :
      ( v112204(VarCurr)
    <=> ( v112205(VarCurr)
        | v112206(VarCurr) ) ) ).

tff(writeUnaryOperator_6200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112206(VarCurr)
    <=> v111715(VarCurr,5) ) ).

tff(writeUnaryOperator_6199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112205(VarCurr)
    <=> v112147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11665,axiom,
    ! [VarCurr: state_type] :
      ( v112198(VarCurr)
    <=> ( v112199(VarCurr)
        & v112202(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4713,axiom,
    ! [VarCurr: state_type] :
      ( v112202(VarCurr)
    <=> ( v112146(VarCurr)
        | v111715(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11664,axiom,
    ! [VarCurr: state_type] :
      ( v112199(VarCurr)
    <=> ( v112200(VarCurr)
        | v112201(VarCurr) ) ) ).

tff(writeUnaryOperator_6198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112201(VarCurr)
    <=> v111715(VarCurr,6) ) ).

tff(writeUnaryOperator_6197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112200(VarCurr)
    <=> v112146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11663,axiom,
    ! [VarCurr: state_type] :
      ( v112193(VarCurr)
    <=> ( v112194(VarCurr)
        & v112197(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4712,axiom,
    ! [VarCurr: state_type] :
      ( v112197(VarCurr)
    <=> ( v112145(VarCurr)
        | v111715(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11662,axiom,
    ! [VarCurr: state_type] :
      ( v112194(VarCurr)
    <=> ( v112195(VarCurr)
        | v112196(VarCurr) ) ) ).

tff(writeUnaryOperator_6196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112196(VarCurr)
    <=> v111715(VarCurr,7) ) ).

tff(writeUnaryOperator_6195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112195(VarCurr)
    <=> v112145(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11661,axiom,
    ! [VarCurr: state_type] :
      ( v112188(VarCurr)
    <=> ( v112189(VarCurr)
        & v112192(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4711,axiom,
    ! [VarCurr: state_type] :
      ( v112192(VarCurr)
    <=> ( v112144(VarCurr)
        | v111715(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11660,axiom,
    ! [VarCurr: state_type] :
      ( v112189(VarCurr)
    <=> ( v112190(VarCurr)
        | v112191(VarCurr) ) ) ).

tff(writeUnaryOperator_6194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112191(VarCurr)
    <=> v111715(VarCurr,8) ) ).

tff(writeUnaryOperator_6193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112190(VarCurr)
    <=> v112144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11659,axiom,
    ! [VarCurr: state_type] :
      ( v112183(VarCurr)
    <=> ( v112184(VarCurr)
        & v112187(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4710,axiom,
    ! [VarCurr: state_type] :
      ( v112187(VarCurr)
    <=> ( v112143(VarCurr)
        | v111715(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11658,axiom,
    ! [VarCurr: state_type] :
      ( v112184(VarCurr)
    <=> ( v112185(VarCurr)
        | v112186(VarCurr) ) ) ).

tff(writeUnaryOperator_6192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112186(VarCurr)
    <=> v111715(VarCurr,9) ) ).

tff(writeUnaryOperator_6191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112185(VarCurr)
    <=> v112143(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11657,axiom,
    ! [VarCurr: state_type] :
      ( v112178(VarCurr)
    <=> ( v112179(VarCurr)
        & v112182(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4709,axiom,
    ! [VarCurr: state_type] :
      ( v112182(VarCurr)
    <=> ( v112142(VarCurr)
        | v111715(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11656,axiom,
    ! [VarCurr: state_type] :
      ( v112179(VarCurr)
    <=> ( v112180(VarCurr)
        | v112181(VarCurr) ) ) ).

tff(writeUnaryOperator_6190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112181(VarCurr)
    <=> v111715(VarCurr,10) ) ).

tff(writeUnaryOperator_6189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112180(VarCurr)
    <=> v112142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11655,axiom,
    ! [VarCurr: state_type] :
      ( v112173(VarCurr)
    <=> ( v112174(VarCurr)
        & v112177(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4708,axiom,
    ! [VarCurr: state_type] :
      ( v112177(VarCurr)
    <=> ( v112141(VarCurr)
        | v111715(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11654,axiom,
    ! [VarCurr: state_type] :
      ( v112174(VarCurr)
    <=> ( v112175(VarCurr)
        | v112176(VarCurr) ) ) ).

tff(writeUnaryOperator_6188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112176(VarCurr)
    <=> v111715(VarCurr,11) ) ).

tff(writeUnaryOperator_6187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112175(VarCurr)
    <=> v112141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11653,axiom,
    ! [VarCurr: state_type] :
      ( v112168(VarCurr)
    <=> ( v112169(VarCurr)
        & v112172(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4707,axiom,
    ! [VarCurr: state_type] :
      ( v112172(VarCurr)
    <=> ( v112140(VarCurr)
        | v111715(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11652,axiom,
    ! [VarCurr: state_type] :
      ( v112169(VarCurr)
    <=> ( v112170(VarCurr)
        | v112171(VarCurr) ) ) ).

tff(writeUnaryOperator_6186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112171(VarCurr)
    <=> v111715(VarCurr,12) ) ).

tff(writeUnaryOperator_6185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112170(VarCurr)
    <=> v112140(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11651,axiom,
    ! [VarCurr: state_type] :
      ( v112163(VarCurr)
    <=> ( v112164(VarCurr)
        & v112167(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4706,axiom,
    ! [VarCurr: state_type] :
      ( v112167(VarCurr)
    <=> ( v112139(VarCurr)
        | v111715(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11650,axiom,
    ! [VarCurr: state_type] :
      ( v112164(VarCurr)
    <=> ( v112165(VarCurr)
        | v112166(VarCurr) ) ) ).

tff(writeUnaryOperator_6184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112166(VarCurr)
    <=> v111715(VarCurr,13) ) ).

tff(writeUnaryOperator_6183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112165(VarCurr)
    <=> v112139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11649,axiom,
    ! [VarCurr: state_type] :
      ( v112158(VarCurr)
    <=> ( v112159(VarCurr)
        & v112162(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4705,axiom,
    ! [VarCurr: state_type] :
      ( v112162(VarCurr)
    <=> ( v112138(VarCurr)
        | v111715(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11648,axiom,
    ! [VarCurr: state_type] :
      ( v112159(VarCurr)
    <=> ( v112160(VarCurr)
        | v112161(VarCurr) ) ) ).

tff(writeUnaryOperator_6182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112161(VarCurr)
    <=> v111715(VarCurr,14) ) ).

tff(writeUnaryOperator_6181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112160(VarCurr)
    <=> v112138(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11647,axiom,
    ! [VarCurr: state_type] :
      ( v112153(VarCurr)
    <=> ( v112154(VarCurr)
        & v112157(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4704,axiom,
    ! [VarCurr: state_type] :
      ( v112157(VarCurr)
    <=> ( v112137(VarCurr)
        | v111715(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11646,axiom,
    ! [VarCurr: state_type] :
      ( v112154(VarCurr)
    <=> ( v112155(VarCurr)
        | v112156(VarCurr) ) ) ).

tff(writeUnaryOperator_6180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112156(VarCurr)
    <=> v111715(VarCurr,15) ) ).

tff(writeUnaryOperator_6179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112155(VarCurr)
    <=> v112137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11645,axiom,
    ! [VarCurr: state_type] :
      ( v112133(VarCurr)
    <=> ( v112134(VarCurr)
        & v112152(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4703,axiom,
    ! [VarCurr: state_type] :
      ( v112152(VarCurr)
    <=> ( v112136(VarCurr)
        | v111715(VarCurr,16) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11644,axiom,
    ! [VarCurr: state_type] :
      ( v112134(VarCurr)
    <=> ( v112135(VarCurr)
        | v112151(VarCurr) ) ) ).

tff(writeUnaryOperator_6178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112151(VarCurr)
    <=> v111715(VarCurr,16) ) ).

tff(writeUnaryOperator_6177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112135(VarCurr)
    <=> v112136(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4702,axiom,
    ! [VarCurr: state_type] :
      ( v112136(VarCurr)
    <=> ( v112137(VarCurr)
        & v111715(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4701,axiom,
    ! [VarCurr: state_type] :
      ( v112137(VarCurr)
    <=> ( v112138(VarCurr)
        & v111715(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4700,axiom,
    ! [VarCurr: state_type] :
      ( v112138(VarCurr)
    <=> ( v112139(VarCurr)
        & v111715(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4699,axiom,
    ! [VarCurr: state_type] :
      ( v112139(VarCurr)
    <=> ( v112140(VarCurr)
        & v111715(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4698,axiom,
    ! [VarCurr: state_type] :
      ( v112140(VarCurr)
    <=> ( v112141(VarCurr)
        & v111715(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4697,axiom,
    ! [VarCurr: state_type] :
      ( v112141(VarCurr)
    <=> ( v112142(VarCurr)
        & v111715(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4696,axiom,
    ! [VarCurr: state_type] :
      ( v112142(VarCurr)
    <=> ( v112143(VarCurr)
        & v111715(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4695,axiom,
    ! [VarCurr: state_type] :
      ( v112143(VarCurr)
    <=> ( v112144(VarCurr)
        & v111715(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4694,axiom,
    ! [VarCurr: state_type] :
      ( v112144(VarCurr)
    <=> ( v112145(VarCurr)
        & v111715(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4693,axiom,
    ! [VarCurr: state_type] :
      ( v112145(VarCurr)
    <=> ( v112146(VarCurr)
        & v111715(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4692,axiom,
    ! [VarCurr: state_type] :
      ( v112146(VarCurr)
    <=> ( v112147(VarCurr)
        & v111715(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4691,axiom,
    ! [VarCurr: state_type] :
      ( v112147(VarCurr)
    <=> ( v112148(VarCurr)
        & v111715(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4690,axiom,
    ! [VarCurr: state_type] :
      ( v112148(VarCurr)
    <=> ( v112149(VarCurr)
        & v111715(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4689,axiom,
    ! [VarCurr: state_type] :
      ( v112149(VarCurr)
    <=> ( v112150(VarCurr)
        & v111715(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4688,axiom,
    ! [VarCurr: state_type] :
      ( v112150(VarCurr)
    <=> ( v111715(VarCurr,0)
        & v111715(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11643,axiom,
    ! [VarCurr: state_type] :
      ( v111737(VarCurr)
    <=> ( v112001(VarCurr)
        | v112124(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4687,axiom,
    ! [VarCurr: state_type] :
      ( v112124(VarCurr)
    <=> ( v112126(VarCurr)
        | v111940(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4686,axiom,
    ! [VarCurr: state_type] :
      ( v112126(VarCurr)
    <=> ( v112127(VarCurr)
        | v111940(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4685,axiom,
    ! [VarCurr: state_type] :
      ( v112127(VarCurr)
    <=> ( v111940(VarCurr,0)
        | v111940(VarCurr,1) ) ) ).

tff(writeUnaryOperator_6176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112001(VarCurr)
    <=> v112003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11642,axiom,
    ! [VarCurr: state_type] :
      ( v112003(VarCurr)
    <=> ( v112004(VarCurr)
        | v112123(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4684,axiom,
    ! [VarCurr: state_type] :
      ( v112123(VarCurr)
    <=> ( v111780(VarCurr)
        & v111875(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11641,axiom,
    ! [VarCurr: state_type] :
      ( v112004(VarCurr)
    <=> ( v112005(VarCurr)
        & v112118(VarCurr) ) ) ).

tff(writeUnaryOperator_6175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112118(VarCurr)
    <=> v112119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11640,axiom,
    ! [VarCurr: state_type] :
      ( v112119(VarCurr)
    <=> ( v112120(VarCurr)
        & v112122(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4683,axiom,
    ! [VarCurr: state_type] :
      ( v112122(VarCurr)
    <=> ( v111739(VarCurr,15)
        | v111875(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11639,axiom,
    ! [VarCurr: state_type] :
      ( v112120(VarCurr)
    <=> ( v111780(VarCurr)
        | v112121(VarCurr) ) ) ).

tff(writeUnaryOperator_6174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112121(VarCurr)
    <=> v111875(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11638,axiom,
    ! [VarCurr: state_type] :
      ( v112005(VarCurr)
    <=> ( v112006(VarCurr)
        | v112117(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4682,axiom,
    ! [VarCurr: state_type] :
      ( v112117(VarCurr)
    <=> ( v111785(VarCurr)
        & v111875(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11637,axiom,
    ! [VarCurr: state_type] :
      ( v112006(VarCurr)
    <=> ( v112007(VarCurr)
        & v112112(VarCurr) ) ) ).

tff(writeUnaryOperator_6173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112112(VarCurr)
    <=> v112113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11636,axiom,
    ! [VarCurr: state_type] :
      ( v112113(VarCurr)
    <=> ( v112114(VarCurr)
        & v112116(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4681,axiom,
    ! [VarCurr: state_type] :
      ( v112116(VarCurr)
    <=> ( v111739(VarCurr,14)
        | v111875(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11635,axiom,
    ! [VarCurr: state_type] :
      ( v112114(VarCurr)
    <=> ( v111785(VarCurr)
        | v112115(VarCurr) ) ) ).

tff(writeUnaryOperator_6172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112115(VarCurr)
    <=> v111875(VarCurr,14) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11634,axiom,
    ! [VarCurr: state_type] :
      ( v112007(VarCurr)
    <=> ( v112008(VarCurr)
        | v112111(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4680,axiom,
    ! [VarCurr: state_type] :
      ( v112111(VarCurr)
    <=> ( v111790(VarCurr)
        & v111875(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11633,axiom,
    ! [VarCurr: state_type] :
      ( v112008(VarCurr)
    <=> ( v112009(VarCurr)
        & v112106(VarCurr) ) ) ).

tff(writeUnaryOperator_6171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112106(VarCurr)
    <=> v112107(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11632,axiom,
    ! [VarCurr: state_type] :
      ( v112107(VarCurr)
    <=> ( v112108(VarCurr)
        & v112110(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4679,axiom,
    ! [VarCurr: state_type] :
      ( v112110(VarCurr)
    <=> ( v111739(VarCurr,13)
        | v111875(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11631,axiom,
    ! [VarCurr: state_type] :
      ( v112108(VarCurr)
    <=> ( v111790(VarCurr)
        | v112109(VarCurr) ) ) ).

tff(writeUnaryOperator_6170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112109(VarCurr)
    <=> v111875(VarCurr,13) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11630,axiom,
    ! [VarCurr: state_type] :
      ( v112009(VarCurr)
    <=> ( v112010(VarCurr)
        | v112105(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4678,axiom,
    ! [VarCurr: state_type] :
      ( v112105(VarCurr)
    <=> ( v111795(VarCurr)
        & v111875(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11629,axiom,
    ! [VarCurr: state_type] :
      ( v112010(VarCurr)
    <=> ( v112011(VarCurr)
        & v112100(VarCurr) ) ) ).

tff(writeUnaryOperator_6169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112100(VarCurr)
    <=> v112101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11628,axiom,
    ! [VarCurr: state_type] :
      ( v112101(VarCurr)
    <=> ( v112102(VarCurr)
        & v112104(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4677,axiom,
    ! [VarCurr: state_type] :
      ( v112104(VarCurr)
    <=> ( v111739(VarCurr,12)
        | v111875(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11627,axiom,
    ! [VarCurr: state_type] :
      ( v112102(VarCurr)
    <=> ( v111795(VarCurr)
        | v112103(VarCurr) ) ) ).

tff(writeUnaryOperator_6168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112103(VarCurr)
    <=> v111875(VarCurr,12) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11626,axiom,
    ! [VarCurr: state_type] :
      ( v112011(VarCurr)
    <=> ( v112012(VarCurr)
        | v112099(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4676,axiom,
    ! [VarCurr: state_type] :
      ( v112099(VarCurr)
    <=> ( v111800(VarCurr)
        & v111875(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11625,axiom,
    ! [VarCurr: state_type] :
      ( v112012(VarCurr)
    <=> ( v112013(VarCurr)
        & v112094(VarCurr) ) ) ).

tff(writeUnaryOperator_6167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112094(VarCurr)
    <=> v112095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11624,axiom,
    ! [VarCurr: state_type] :
      ( v112095(VarCurr)
    <=> ( v112096(VarCurr)
        & v112098(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4675,axiom,
    ! [VarCurr: state_type] :
      ( v112098(VarCurr)
    <=> ( v111739(VarCurr,11)
        | v111875(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11623,axiom,
    ! [VarCurr: state_type] :
      ( v112096(VarCurr)
    <=> ( v111800(VarCurr)
        | v112097(VarCurr) ) ) ).

tff(writeUnaryOperator_6166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112097(VarCurr)
    <=> v111875(VarCurr,11) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11622,axiom,
    ! [VarCurr: state_type] :
      ( v112013(VarCurr)
    <=> ( v112014(VarCurr)
        | v112093(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4674,axiom,
    ! [VarCurr: state_type] :
      ( v112093(VarCurr)
    <=> ( v111805(VarCurr)
        & v111875(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11621,axiom,
    ! [VarCurr: state_type] :
      ( v112014(VarCurr)
    <=> ( v112015(VarCurr)
        & v112088(VarCurr) ) ) ).

tff(writeUnaryOperator_6165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112088(VarCurr)
    <=> v112089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11620,axiom,
    ! [VarCurr: state_type] :
      ( v112089(VarCurr)
    <=> ( v112090(VarCurr)
        & v112092(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4673,axiom,
    ! [VarCurr: state_type] :
      ( v112092(VarCurr)
    <=> ( v111739(VarCurr,10)
        | v111875(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11619,axiom,
    ! [VarCurr: state_type] :
      ( v112090(VarCurr)
    <=> ( v111805(VarCurr)
        | v112091(VarCurr) ) ) ).

tff(writeUnaryOperator_6164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112091(VarCurr)
    <=> v111875(VarCurr,10) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11618,axiom,
    ! [VarCurr: state_type] :
      ( v112015(VarCurr)
    <=> ( v112016(VarCurr)
        | v112087(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4672,axiom,
    ! [VarCurr: state_type] :
      ( v112087(VarCurr)
    <=> ( v111810(VarCurr)
        & v111875(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11617,axiom,
    ! [VarCurr: state_type] :
      ( v112016(VarCurr)
    <=> ( v112017(VarCurr)
        & v112082(VarCurr) ) ) ).

tff(writeUnaryOperator_6163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112082(VarCurr)
    <=> v112083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11616,axiom,
    ! [VarCurr: state_type] :
      ( v112083(VarCurr)
    <=> ( v112084(VarCurr)
        & v112086(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4671,axiom,
    ! [VarCurr: state_type] :
      ( v112086(VarCurr)
    <=> ( v111739(VarCurr,9)
        | v111875(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11615,axiom,
    ! [VarCurr: state_type] :
      ( v112084(VarCurr)
    <=> ( v111810(VarCurr)
        | v112085(VarCurr) ) ) ).

tff(writeUnaryOperator_6162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112085(VarCurr)
    <=> v111875(VarCurr,9) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11614,axiom,
    ! [VarCurr: state_type] :
      ( v112017(VarCurr)
    <=> ( v112018(VarCurr)
        | v112081(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4670,axiom,
    ! [VarCurr: state_type] :
      ( v112081(VarCurr)
    <=> ( v111815(VarCurr)
        & v111875(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11613,axiom,
    ! [VarCurr: state_type] :
      ( v112018(VarCurr)
    <=> ( v112019(VarCurr)
        & v112076(VarCurr) ) ) ).

tff(writeUnaryOperator_6161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112076(VarCurr)
    <=> v112077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11612,axiom,
    ! [VarCurr: state_type] :
      ( v112077(VarCurr)
    <=> ( v112078(VarCurr)
        & v112080(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4669,axiom,
    ! [VarCurr: state_type] :
      ( v112080(VarCurr)
    <=> ( v111739(VarCurr,8)
        | v111875(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11611,axiom,
    ! [VarCurr: state_type] :
      ( v112078(VarCurr)
    <=> ( v111815(VarCurr)
        | v112079(VarCurr) ) ) ).

tff(writeUnaryOperator_6160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112079(VarCurr)
    <=> v111875(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11610,axiom,
    ! [VarCurr: state_type] :
      ( v112019(VarCurr)
    <=> ( v112020(VarCurr)
        | v112075(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4668,axiom,
    ! [VarCurr: state_type] :
      ( v112075(VarCurr)
    <=> ( v111820(VarCurr)
        & v111875(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11609,axiom,
    ! [VarCurr: state_type] :
      ( v112020(VarCurr)
    <=> ( v112021(VarCurr)
        & v112070(VarCurr) ) ) ).

tff(writeUnaryOperator_6159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112070(VarCurr)
    <=> v112071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11608,axiom,
    ! [VarCurr: state_type] :
      ( v112071(VarCurr)
    <=> ( v112072(VarCurr)
        & v112074(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4667,axiom,
    ! [VarCurr: state_type] :
      ( v112074(VarCurr)
    <=> ( v111739(VarCurr,7)
        | v111875(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11607,axiom,
    ! [VarCurr: state_type] :
      ( v112072(VarCurr)
    <=> ( v111820(VarCurr)
        | v112073(VarCurr) ) ) ).

tff(writeUnaryOperator_6158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112073(VarCurr)
    <=> v111875(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11606,axiom,
    ! [VarCurr: state_type] :
      ( v112021(VarCurr)
    <=> ( v112022(VarCurr)
        | v112069(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4666,axiom,
    ! [VarCurr: state_type] :
      ( v112069(VarCurr)
    <=> ( v111825(VarCurr)
        & v111875(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11605,axiom,
    ! [VarCurr: state_type] :
      ( v112022(VarCurr)
    <=> ( v112023(VarCurr)
        & v112064(VarCurr) ) ) ).

tff(writeUnaryOperator_6157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112064(VarCurr)
    <=> v112065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11604,axiom,
    ! [VarCurr: state_type] :
      ( v112065(VarCurr)
    <=> ( v112066(VarCurr)
        & v112068(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4665,axiom,
    ! [VarCurr: state_type] :
      ( v112068(VarCurr)
    <=> ( v111739(VarCurr,6)
        | v111875(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11603,axiom,
    ! [VarCurr: state_type] :
      ( v112066(VarCurr)
    <=> ( v111825(VarCurr)
        | v112067(VarCurr) ) ) ).

tff(writeUnaryOperator_6156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112067(VarCurr)
    <=> v111875(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11602,axiom,
    ! [VarCurr: state_type] :
      ( v112023(VarCurr)
    <=> ( v112024(VarCurr)
        | v112063(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4664,axiom,
    ! [VarCurr: state_type] :
      ( v112063(VarCurr)
    <=> ( v111830(VarCurr)
        & v111875(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11601,axiom,
    ! [VarCurr: state_type] :
      ( v112024(VarCurr)
    <=> ( v112025(VarCurr)
        & v112058(VarCurr) ) ) ).

tff(writeUnaryOperator_6155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112058(VarCurr)
    <=> v112059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11600,axiom,
    ! [VarCurr: state_type] :
      ( v112059(VarCurr)
    <=> ( v112060(VarCurr)
        & v112062(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4663,axiom,
    ! [VarCurr: state_type] :
      ( v112062(VarCurr)
    <=> ( v111739(VarCurr,5)
        | v111875(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11599,axiom,
    ! [VarCurr: state_type] :
      ( v112060(VarCurr)
    <=> ( v111830(VarCurr)
        | v112061(VarCurr) ) ) ).

tff(writeUnaryOperator_6154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112061(VarCurr)
    <=> v111875(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11598,axiom,
    ! [VarCurr: state_type] :
      ( v112025(VarCurr)
    <=> ( v112026(VarCurr)
        | v112057(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4662,axiom,
    ! [VarCurr: state_type] :
      ( v112057(VarCurr)
    <=> ( v111835(VarCurr)
        & v111875(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11597,axiom,
    ! [VarCurr: state_type] :
      ( v112026(VarCurr)
    <=> ( v112027(VarCurr)
        & v112052(VarCurr) ) ) ).

tff(writeUnaryOperator_6153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112052(VarCurr)
    <=> v112053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11596,axiom,
    ! [VarCurr: state_type] :
      ( v112053(VarCurr)
    <=> ( v112054(VarCurr)
        & v112056(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4661,axiom,
    ! [VarCurr: state_type] :
      ( v112056(VarCurr)
    <=> ( v111739(VarCurr,4)
        | v111875(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11595,axiom,
    ! [VarCurr: state_type] :
      ( v112054(VarCurr)
    <=> ( v111835(VarCurr)
        | v112055(VarCurr) ) ) ).

tff(writeUnaryOperator_6152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112055(VarCurr)
    <=> v111875(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11594,axiom,
    ! [VarCurr: state_type] :
      ( v112027(VarCurr)
    <=> ( v112028(VarCurr)
        | v112051(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4660,axiom,
    ! [VarCurr: state_type] :
      ( v112051(VarCurr)
    <=> ( v111840(VarCurr)
        & v111875(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11593,axiom,
    ! [VarCurr: state_type] :
      ( v112028(VarCurr)
    <=> ( v112029(VarCurr)
        & v112046(VarCurr) ) ) ).

tff(writeUnaryOperator_6151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112046(VarCurr)
    <=> v112047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11592,axiom,
    ! [VarCurr: state_type] :
      ( v112047(VarCurr)
    <=> ( v112048(VarCurr)
        & v112050(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4659,axiom,
    ! [VarCurr: state_type] :
      ( v112050(VarCurr)
    <=> ( v111739(VarCurr,3)
        | v111875(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11591,axiom,
    ! [VarCurr: state_type] :
      ( v112048(VarCurr)
    <=> ( v111840(VarCurr)
        | v112049(VarCurr) ) ) ).

tff(writeUnaryOperator_6150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112049(VarCurr)
    <=> v111875(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11590,axiom,
    ! [VarCurr: state_type] :
      ( v112029(VarCurr)
    <=> ( v112030(VarCurr)
        | v112045(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4658,axiom,
    ! [VarCurr: state_type] :
      ( v112045(VarCurr)
    <=> ( v111845(VarCurr)
        & v111875(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11589,axiom,
    ! [VarCurr: state_type] :
      ( v112030(VarCurr)
    <=> ( v112031(VarCurr)
        & v112040(VarCurr) ) ) ).

tff(writeUnaryOperator_6149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112040(VarCurr)
    <=> v112041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11588,axiom,
    ! [VarCurr: state_type] :
      ( v112041(VarCurr)
    <=> ( v112042(VarCurr)
        & v112044(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4657,axiom,
    ! [VarCurr: state_type] :
      ( v112044(VarCurr)
    <=> ( v111739(VarCurr,2)
        | v111875(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11587,axiom,
    ! [VarCurr: state_type] :
      ( v112042(VarCurr)
    <=> ( v111845(VarCurr)
        | v112043(VarCurr) ) ) ).

tff(writeUnaryOperator_6148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112043(VarCurr)
    <=> v111875(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11586,axiom,
    ! [VarCurr: state_type] :
      ( v112031(VarCurr)
    <=> ( v112032(VarCurr)
        | v112039(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4656,axiom,
    ! [VarCurr: state_type] :
      ( v112039(VarCurr)
    <=> ( v111850(VarCurr)
        & v111875(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11585,axiom,
    ! [VarCurr: state_type] :
      ( v112032(VarCurr)
    <=> ( v112033(VarCurr)
        & v112034(VarCurr) ) ) ).

tff(writeUnaryOperator_6147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112034(VarCurr)
    <=> v112035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11584,axiom,
    ! [VarCurr: state_type] :
      ( v112035(VarCurr)
    <=> ( v112036(VarCurr)
        & v112038(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4655,axiom,
    ! [VarCurr: state_type] :
      ( v112038(VarCurr)
    <=> ( v111739(VarCurr,1)
        | v111875(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11583,axiom,
    ! [VarCurr: state_type] :
      ( v112036(VarCurr)
    <=> ( v111850(VarCurr)
        | v112037(VarCurr) ) ) ).

tff(writeUnaryOperator_6146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v112037(VarCurr)
    <=> v111875(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11582,axiom,
    ! [VarCurr: state_type] :
      ( v112033(VarCurr)
    <=> ( v111849(VarCurr)
        & v111875(VarCurr,0) ) ) ).

tff(addAssignment_66670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v111940(VarCurr,B)
      <=> v111942(VarCurr,B) ) ) ).

tff(addAssignment_66669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v111942(VarCurr,B)
      <=> v111944(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111984(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v111944(VarNext,B)
            <=> v111944(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1457,axiom,
    ! [VarNext: state_type] :
      ( v111984(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111944(VarNext,B)
          <=> v111994(VarNext,B) ) ) ) ).

tff(addAssignment_66668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111994(VarNext,B)
          <=> v111992(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111992(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_969,axiom,
    ! [VarCurr: state_type] :
      ( v111995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111992(VarCurr,B)
          <=> v111954(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11581,axiom,
    ! [VarCurr: state_type] :
      ( v111995(VarCurr)
    <=> ( v111996(VarCurr)
        & v111997(VarCurr) ) ) ).

tff(writeUnaryOperator_6145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111997(VarCurr)
    <=> v111950(VarCurr) ) ).

tff(writeUnaryOperator_6144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111996(VarCurr)
    <=> v111946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111984(VarNext)
      <=> v111985(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111985(VarNext)
      <=> ( v111986(VarNext)
          & v111979(VarNext) ) ) ) ).

tff(writeUnaryOperator_6143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111986(VarNext)
      <=> v111988(VarNext) ) ) ).

tff(addAssignment_66667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111988(VarNext)
      <=> v111979(VarCurr) ) ) ).

tff(addAssignment_66666,axiom,
    ! [VarCurr: state_type] :
      ( v111979(VarCurr)
    <=> v111981(VarCurr) ) ).

tff(addAssignment_66665,axiom,
    ! [VarCurr: state_type] :
      ( v111981(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v111954(VarCurr,B)
      <=> v111956(VarCurr,B) ) ) ).

tff(addAssignment_66663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v111956(VarCurr,B)
      <=> v111958(VarCurr,B) ) ) ).

tff(addAssignment_66662,axiom,
    ! [VarCurr: state_type] :
      ( v111958(VarCurr,0)
    <=> v111972(VarCurr) ) ).

tff(addAssignment_66661,axiom,
    ! [VarCurr: state_type] :
      ( v111958(VarCurr,1)
    <=> v111968(VarCurr) ) ).

tff(addAssignment_66660,axiom,
    ! [VarCurr: state_type] :
      ( v111958(VarCurr,2)
    <=> v111964(VarCurr) ) ).

tff(addAssignment_66659,axiom,
    ! [VarCurr: state_type] :
      ( v111958(VarCurr,3)
    <=> v111960(VarCurr) ) ).

tff(addAssignment_66658,axiom,
    ! [VarCurr: state_type] :
      ( v111972(VarCurr)
    <=> v111974(VarCurr) ) ).

tff(addAssignment_66657,axiom,
    ! [VarCurr: state_type] :
      ( v111974(VarCurr)
    <=> v111976(VarCurr) ) ).

tff(addAssignment_66656,axiom,
    ! [VarCurr: state_type] :
      ( v111968(VarCurr)
    <=> v111970(VarCurr) ) ).

tff(addAssignment_66655,axiom,
    ! [VarCurr: state_type] :
      ( v111964(VarCurr)
    <=> v111966(VarCurr) ) ).

tff(addAssignment_66654,axiom,
    ! [VarCurr: state_type] :
      ( v111960(VarCurr)
    <=> v111962(VarCurr) ) ).

tff(addAssignment_66653,axiom,
    ! [VarCurr: state_type] :
      ( v111950(VarCurr)
    <=> v111952(VarCurr) ) ).

tff(addAssignment_66652,axiom,
    ! [VarCurr: state_type] :
      ( v111952(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66651,axiom,
    ! [VarCurr: state_type] :
      ( v111946(VarCurr)
    <=> v111948(VarCurr) ) ).

tff(addAssignment_66650,axiom,
    ! [VarCurr: state_type] :
      ( v111948(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeUnaryOperator_6142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111875(VarCurr,B)
      <=> ~ v111877(VarCurr,B) ) ) ).

tff(addAssignment_66649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111877(VarCurr,B)
      <=> v111879(VarCurr,B) ) ) ).

tff(addAssignment_66648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111879(VarCurr,B)
      <=> v111881(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111922(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111881(VarNext,B)
            <=> v111881(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1456,axiom,
    ! [VarNext: state_type] :
      ( v111922(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111881(VarNext,B)
          <=> v111932(VarNext,B) ) ) ) ).

tff(addAssignment_66647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111932(VarNext,B)
          <=> v111930(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111933(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111930(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_968,axiom,
    ! [VarCurr: state_type] :
      ( v111933(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111930(VarCurr,B)
          <=> v111891(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11578,axiom,
    ! [VarCurr: state_type] :
      ( v111933(VarCurr)
    <=> ( v111934(VarCurr)
        & v111935(VarCurr) ) ) ).

tff(writeUnaryOperator_6141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111935(VarCurr)
    <=> v111887(VarCurr) ) ).

tff(writeUnaryOperator_6140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111934(VarCurr)
    <=> v111883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111922(VarNext)
      <=> v111923(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111923(VarNext)
      <=> ( v111924(VarNext)
          & v111917(VarNext) ) ) ) ).

tff(writeUnaryOperator_6139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111924(VarNext)
      <=> v111926(VarNext) ) ) ).

tff(addAssignment_66646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111926(VarNext)
      <=> v111917(VarCurr) ) ) ).

tff(addAssignment_66645,axiom,
    ! [VarCurr: state_type] :
      ( v111917(VarCurr)
    <=> v111919(VarCurr) ) ).

tff(addAssignment_66644,axiom,
    ! [VarCurr: state_type] :
      ( v111919(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111891(VarCurr,B)
      <=> v111893(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111893(VarCurr,B)
      <=> ( v111909(VarCurr,B)
          | v111912(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111912(VarCurr,B)
      <=> ( v111879(VarCurr,B)
          & v111913(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111913(VarCurr,B)
      <=> ~ v111914(VarCurr,B) ) ) ).

tff(addAssignment_66642,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,0)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66641,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,1)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66640,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,2)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66639,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,3)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66638,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,4)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66637,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,5)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66636,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,6)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66635,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,7)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66634,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,8)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66633,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,9)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66632,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,10)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66631,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,11)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66630,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,12)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66629,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,13)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66628,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,14)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66627,axiom,
    ! [VarCurr: state_type] :
      ( v111914(VarCurr,15)
    <=> v111915(VarCurr) ) ).

tff(addAssignment_66626,axiom,
    ! [VarCurr: state_type] :
      ( v111915(VarCurr)
    <=> v111902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111909(VarCurr,B)
      <=> ( v111895(VarCurr,B)
          & v111910(VarCurr,B) ) ) ) ).

tff(addAssignment_66625,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,0)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66624,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,1)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66623,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,2)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66622,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,3)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66621,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,4)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66620,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,5)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66619,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,6)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66618,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,7)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66617,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,8)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66616,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,9)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66615,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,10)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66614,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,11)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66613,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,12)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66612,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,13)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66611,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,14)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66610,axiom,
    ! [VarCurr: state_type] :
      ( v111910(VarCurr,15)
    <=> v111911(VarCurr) ) ).

tff(addAssignment_66609,axiom,
    ! [VarCurr: state_type] :
      ( v111911(VarCurr)
    <=> v111902(VarCurr) ) ).

tff(addAssignment_66608,axiom,
    ! [VarCurr: state_type] :
      ( v111902(VarCurr)
    <=> v111904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11575,axiom,
    ! [VarCurr: state_type] :
      ( v111904(VarCurr)
    <=> ( v1729(VarCurr)
        & v111907(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_926,axiom,
    ! [VarCurr: state_type] :
      ( v111907(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1561,axiom,
    ~ b0000001001000(12) ).

tff(bitBlastConstant_1560,axiom,
    ~ b0000001001000(11) ).

tff(bitBlastConstant_1559,axiom,
    ~ b0000001001000(10) ).

tff(bitBlastConstant_1558,axiom,
    ~ b0000001001000(9) ).

tff(bitBlastConstant_1557,axiom,
    ~ b0000001001000(8) ).

tff(bitBlastConstant_1556,axiom,
    ~ b0000001001000(7) ).

tff(bitBlastConstant_1555,axiom,
    b0000001001000(6) ).

tff(bitBlastConstant_1554,axiom,
    ~ b0000001001000(5) ).

tff(bitBlastConstant_1553,axiom,
    ~ b0000001001000(4) ).

tff(bitBlastConstant_1552,axiom,
    b0000001001000(3) ).

tff(bitBlastConstant_1551,axiom,
    ~ b0000001001000(2) ).

tff(bitBlastConstant_1550,axiom,
    ~ b0000001001000(1) ).

tff(bitBlastConstant_1549,axiom,
    ~ b0000001001000(0) ).

tff(addAssignment_66607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111895(VarCurr,B)
      <=> v111897(VarCurr,B) ) ) ).

tff(writeUnaryOperator_6137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111897(VarCurr,B)
      <=> ~ v111899(VarCurr,B) ) ) ).

tff(addAssignment_66606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111899(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_66605,axiom,
    ! [VarCurr: state_type] :
      ( v111887(VarCurr)
    <=> v111889(VarCurr) ) ).

tff(addAssignment_66604,axiom,
    ! [VarCurr: state_type] :
      ( v111889(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66603,axiom,
    ! [VarCurr: state_type] :
      ( v111883(VarCurr)
    <=> v111885(VarCurr) ) ).

tff(addAssignment_66602,axiom,
    ! [VarCurr: state_type] :
      ( v111885(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_66601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111739(VarCurr,B)
      <=> v111741(VarCurr,B) ) ) ).

tff(addAssignment_66600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111741(VarCurr,B)
      <=> v111743(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111858(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111743(VarNext,B)
            <=> v111743(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1455,axiom,
    ! [VarNext: state_type] :
      ( v111858(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111743(VarNext,B)
          <=> v111868(VarNext,B) ) ) ) ).

tff(addAssignment_66599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111868(VarNext,B)
          <=> v111866(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111866(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_967,axiom,
    ! [VarCurr: state_type] :
      ( v111869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111866(VarCurr,B)
          <=> v111753(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11574,axiom,
    ! [VarCurr: state_type] :
      ( v111869(VarCurr)
    <=> ( v111870(VarCurr)
        & v111871(VarCurr) ) ) ).

tff(writeUnaryOperator_6136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111871(VarCurr)
    <=> v111749(VarCurr) ) ).

tff(writeUnaryOperator_6135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111870(VarCurr)
    <=> v111745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111858(VarNext)
      <=> v111859(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111859(VarNext)
      <=> ( v111860(VarNext)
          & v111853(VarNext) ) ) ) ).

tff(writeUnaryOperator_6134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111860(VarNext)
      <=> v111862(VarNext) ) ) ).

tff(addAssignment_66598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111862(VarNext)
      <=> v111853(VarCurr) ) ) ).

tff(addAssignment_66597,axiom,
    ! [VarCurr: state_type] :
      ( v111853(VarCurr)
    <=> v111855(VarCurr) ) ).

tff(addAssignment_66596,axiom,
    ! [VarCurr: state_type] :
      ( v111855(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111753(VarCurr,B)
      <=> v111755(VarCurr,B) ) ) ).

tff(addAssignment_66594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111755(VarCurr,B)
      <=> v111757(VarCurr,B) ) ) ).

tff(addAssignment_66593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v111757(VarCurr,B)
      <=> v111759(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111737(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111759(VarCurr,B)
          <=> v111761(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_966,axiom,
    ! [VarCurr: state_type] :
      ( v111737(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111759(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_66592,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,0)
    <=> v111849(VarCurr) ) ).

tff(addAssignment_66591,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,1)
    <=> v111847(VarCurr) ) ).

tff(addAssignment_66590,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,2)
    <=> v111842(VarCurr) ) ).

tff(addAssignment_66589,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,3)
    <=> v111837(VarCurr) ) ).

tff(addAssignment_66588,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,4)
    <=> v111832(VarCurr) ) ).

tff(addAssignment_66587,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,5)
    <=> v111827(VarCurr) ) ).

tff(addAssignment_66586,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,6)
    <=> v111822(VarCurr) ) ).

tff(addAssignment_66585,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,7)
    <=> v111817(VarCurr) ) ).

tff(addAssignment_66584,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,8)
    <=> v111812(VarCurr) ) ).

tff(addAssignment_66583,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,9)
    <=> v111807(VarCurr) ) ).

tff(addAssignment_66582,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,10)
    <=> v111802(VarCurr) ) ).

tff(addAssignment_66581,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,11)
    <=> v111797(VarCurr) ) ).

tff(addAssignment_66580,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,12)
    <=> v111792(VarCurr) ) ).

tff(addAssignment_66579,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,13)
    <=> v111787(VarCurr) ) ).

tff(addAssignment_66578,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,14)
    <=> v111782(VarCurr) ) ).

tff(addAssignment_66577,axiom,
    ! [VarCurr: state_type] :
      ( v111761(VarCurr,15)
    <=> v111763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11571,axiom,
    ! [VarCurr: state_type] :
      ( v111847(VarCurr)
    <=> ( v111848(VarCurr)
        & v111851(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4654,axiom,
    ! [VarCurr: state_type] :
      ( v111851(VarCurr)
    <=> ( v111739(VarCurr,0)
        | v111739(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11570,axiom,
    ! [VarCurr: state_type] :
      ( v111848(VarCurr)
    <=> ( v111849(VarCurr)
        | v111850(VarCurr) ) ) ).

tff(writeUnaryOperator_6133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111850(VarCurr)
    <=> v111739(VarCurr,1) ) ).

tff(writeUnaryOperator_6132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111849(VarCurr)
    <=> v111739(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11569,axiom,
    ! [VarCurr: state_type] :
      ( v111842(VarCurr)
    <=> ( v111843(VarCurr)
        & v111846(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4653,axiom,
    ! [VarCurr: state_type] :
      ( v111846(VarCurr)
    <=> ( v111779(VarCurr)
        | v111739(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11568,axiom,
    ! [VarCurr: state_type] :
      ( v111843(VarCurr)
    <=> ( v111844(VarCurr)
        | v111845(VarCurr) ) ) ).

tff(writeUnaryOperator_6131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111845(VarCurr)
    <=> v111739(VarCurr,2) ) ).

tff(writeUnaryOperator_6130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111844(VarCurr)
    <=> v111779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11567,axiom,
    ! [VarCurr: state_type] :
      ( v111837(VarCurr)
    <=> ( v111838(VarCurr)
        & v111841(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4652,axiom,
    ! [VarCurr: state_type] :
      ( v111841(VarCurr)
    <=> ( v111778(VarCurr)
        | v111739(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11566,axiom,
    ! [VarCurr: state_type] :
      ( v111838(VarCurr)
    <=> ( v111839(VarCurr)
        | v111840(VarCurr) ) ) ).

tff(writeUnaryOperator_6129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111840(VarCurr)
    <=> v111739(VarCurr,3) ) ).

tff(writeUnaryOperator_6128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111839(VarCurr)
    <=> v111778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11565,axiom,
    ! [VarCurr: state_type] :
      ( v111832(VarCurr)
    <=> ( v111833(VarCurr)
        & v111836(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4651,axiom,
    ! [VarCurr: state_type] :
      ( v111836(VarCurr)
    <=> ( v111777(VarCurr)
        | v111739(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11564,axiom,
    ! [VarCurr: state_type] :
      ( v111833(VarCurr)
    <=> ( v111834(VarCurr)
        | v111835(VarCurr) ) ) ).

tff(writeUnaryOperator_6127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111835(VarCurr)
    <=> v111739(VarCurr,4) ) ).

tff(writeUnaryOperator_6126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111834(VarCurr)
    <=> v111777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11563,axiom,
    ! [VarCurr: state_type] :
      ( v111827(VarCurr)
    <=> ( v111828(VarCurr)
        & v111831(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4650,axiom,
    ! [VarCurr: state_type] :
      ( v111831(VarCurr)
    <=> ( v111776(VarCurr)
        | v111739(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11562,axiom,
    ! [VarCurr: state_type] :
      ( v111828(VarCurr)
    <=> ( v111829(VarCurr)
        | v111830(VarCurr) ) ) ).

tff(writeUnaryOperator_6125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111830(VarCurr)
    <=> v111739(VarCurr,5) ) ).

tff(writeUnaryOperator_6124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111829(VarCurr)
    <=> v111776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11561,axiom,
    ! [VarCurr: state_type] :
      ( v111822(VarCurr)
    <=> ( v111823(VarCurr)
        & v111826(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4649,axiom,
    ! [VarCurr: state_type] :
      ( v111826(VarCurr)
    <=> ( v111775(VarCurr)
        | v111739(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11560,axiom,
    ! [VarCurr: state_type] :
      ( v111823(VarCurr)
    <=> ( v111824(VarCurr)
        | v111825(VarCurr) ) ) ).

tff(writeUnaryOperator_6123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111825(VarCurr)
    <=> v111739(VarCurr,6) ) ).

tff(writeUnaryOperator_6122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111824(VarCurr)
    <=> v111775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11559,axiom,
    ! [VarCurr: state_type] :
      ( v111817(VarCurr)
    <=> ( v111818(VarCurr)
        & v111821(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4648,axiom,
    ! [VarCurr: state_type] :
      ( v111821(VarCurr)
    <=> ( v111774(VarCurr)
        | v111739(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11558,axiom,
    ! [VarCurr: state_type] :
      ( v111818(VarCurr)
    <=> ( v111819(VarCurr)
        | v111820(VarCurr) ) ) ).

tff(writeUnaryOperator_6121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111820(VarCurr)
    <=> v111739(VarCurr,7) ) ).

tff(writeUnaryOperator_6120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111819(VarCurr)
    <=> v111774(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11557,axiom,
    ! [VarCurr: state_type] :
      ( v111812(VarCurr)
    <=> ( v111813(VarCurr)
        & v111816(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4647,axiom,
    ! [VarCurr: state_type] :
      ( v111816(VarCurr)
    <=> ( v111773(VarCurr)
        | v111739(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11556,axiom,
    ! [VarCurr: state_type] :
      ( v111813(VarCurr)
    <=> ( v111814(VarCurr)
        | v111815(VarCurr) ) ) ).

tff(writeUnaryOperator_6119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111815(VarCurr)
    <=> v111739(VarCurr,8) ) ).

tff(writeUnaryOperator_6118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111814(VarCurr)
    <=> v111773(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11555,axiom,
    ! [VarCurr: state_type] :
      ( v111807(VarCurr)
    <=> ( v111808(VarCurr)
        & v111811(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4646,axiom,
    ! [VarCurr: state_type] :
      ( v111811(VarCurr)
    <=> ( v111772(VarCurr)
        | v111739(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11554,axiom,
    ! [VarCurr: state_type] :
      ( v111808(VarCurr)
    <=> ( v111809(VarCurr)
        | v111810(VarCurr) ) ) ).

tff(writeUnaryOperator_6117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111810(VarCurr)
    <=> v111739(VarCurr,9) ) ).

tff(writeUnaryOperator_6116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111809(VarCurr)
    <=> v111772(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11553,axiom,
    ! [VarCurr: state_type] :
      ( v111802(VarCurr)
    <=> ( v111803(VarCurr)
        & v111806(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4645,axiom,
    ! [VarCurr: state_type] :
      ( v111806(VarCurr)
    <=> ( v111771(VarCurr)
        | v111739(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11552,axiom,
    ! [VarCurr: state_type] :
      ( v111803(VarCurr)
    <=> ( v111804(VarCurr)
        | v111805(VarCurr) ) ) ).

tff(writeUnaryOperator_6115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111805(VarCurr)
    <=> v111739(VarCurr,10) ) ).

tff(writeUnaryOperator_6114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111804(VarCurr)
    <=> v111771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11551,axiom,
    ! [VarCurr: state_type] :
      ( v111797(VarCurr)
    <=> ( v111798(VarCurr)
        & v111801(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4644,axiom,
    ! [VarCurr: state_type] :
      ( v111801(VarCurr)
    <=> ( v111770(VarCurr)
        | v111739(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11550,axiom,
    ! [VarCurr: state_type] :
      ( v111798(VarCurr)
    <=> ( v111799(VarCurr)
        | v111800(VarCurr) ) ) ).

tff(writeUnaryOperator_6113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111800(VarCurr)
    <=> v111739(VarCurr,11) ) ).

tff(writeUnaryOperator_6112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111799(VarCurr)
    <=> v111770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11549,axiom,
    ! [VarCurr: state_type] :
      ( v111792(VarCurr)
    <=> ( v111793(VarCurr)
        & v111796(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4643,axiom,
    ! [VarCurr: state_type] :
      ( v111796(VarCurr)
    <=> ( v111769(VarCurr)
        | v111739(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11548,axiom,
    ! [VarCurr: state_type] :
      ( v111793(VarCurr)
    <=> ( v111794(VarCurr)
        | v111795(VarCurr) ) ) ).

tff(writeUnaryOperator_6111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111795(VarCurr)
    <=> v111739(VarCurr,12) ) ).

tff(writeUnaryOperator_6110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111794(VarCurr)
    <=> v111769(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11547,axiom,
    ! [VarCurr: state_type] :
      ( v111787(VarCurr)
    <=> ( v111788(VarCurr)
        & v111791(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4642,axiom,
    ! [VarCurr: state_type] :
      ( v111791(VarCurr)
    <=> ( v111768(VarCurr)
        | v111739(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11546,axiom,
    ! [VarCurr: state_type] :
      ( v111788(VarCurr)
    <=> ( v111789(VarCurr)
        | v111790(VarCurr) ) ) ).

tff(writeUnaryOperator_6109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111790(VarCurr)
    <=> v111739(VarCurr,13) ) ).

tff(writeUnaryOperator_6108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111789(VarCurr)
    <=> v111768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11545,axiom,
    ! [VarCurr: state_type] :
      ( v111782(VarCurr)
    <=> ( v111783(VarCurr)
        & v111786(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4641,axiom,
    ! [VarCurr: state_type] :
      ( v111786(VarCurr)
    <=> ( v111767(VarCurr)
        | v111739(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11544,axiom,
    ! [VarCurr: state_type] :
      ( v111783(VarCurr)
    <=> ( v111784(VarCurr)
        | v111785(VarCurr) ) ) ).

tff(writeUnaryOperator_6107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111785(VarCurr)
    <=> v111739(VarCurr,14) ) ).

tff(writeUnaryOperator_6106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111784(VarCurr)
    <=> v111767(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11543,axiom,
    ! [VarCurr: state_type] :
      ( v111763(VarCurr)
    <=> ( v111764(VarCurr)
        & v111781(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4640,axiom,
    ! [VarCurr: state_type] :
      ( v111781(VarCurr)
    <=> ( v111766(VarCurr)
        | v111739(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11542,axiom,
    ! [VarCurr: state_type] :
      ( v111764(VarCurr)
    <=> ( v111765(VarCurr)
        | v111780(VarCurr) ) ) ).

tff(writeUnaryOperator_6105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111780(VarCurr)
    <=> v111739(VarCurr,15) ) ).

tff(writeUnaryOperator_6104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111765(VarCurr)
    <=> v111766(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4639,axiom,
    ! [VarCurr: state_type] :
      ( v111766(VarCurr)
    <=> ( v111767(VarCurr)
        & v111739(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4638,axiom,
    ! [VarCurr: state_type] :
      ( v111767(VarCurr)
    <=> ( v111768(VarCurr)
        & v111739(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4637,axiom,
    ! [VarCurr: state_type] :
      ( v111768(VarCurr)
    <=> ( v111769(VarCurr)
        & v111739(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4636,axiom,
    ! [VarCurr: state_type] :
      ( v111769(VarCurr)
    <=> ( v111770(VarCurr)
        & v111739(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4635,axiom,
    ! [VarCurr: state_type] :
      ( v111770(VarCurr)
    <=> ( v111771(VarCurr)
        & v111739(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4634,axiom,
    ! [VarCurr: state_type] :
      ( v111771(VarCurr)
    <=> ( v111772(VarCurr)
        & v111739(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4633,axiom,
    ! [VarCurr: state_type] :
      ( v111772(VarCurr)
    <=> ( v111773(VarCurr)
        & v111739(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4632,axiom,
    ! [VarCurr: state_type] :
      ( v111773(VarCurr)
    <=> ( v111774(VarCurr)
        & v111739(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4631,axiom,
    ! [VarCurr: state_type] :
      ( v111774(VarCurr)
    <=> ( v111775(VarCurr)
        & v111739(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4630,axiom,
    ! [VarCurr: state_type] :
      ( v111775(VarCurr)
    <=> ( v111776(VarCurr)
        & v111739(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4629,axiom,
    ! [VarCurr: state_type] :
      ( v111776(VarCurr)
    <=> ( v111777(VarCurr)
        & v111739(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4628,axiom,
    ! [VarCurr: state_type] :
      ( v111777(VarCurr)
    <=> ( v111778(VarCurr)
        & v111739(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4627,axiom,
    ! [VarCurr: state_type] :
      ( v111778(VarCurr)
    <=> ( v111779(VarCurr)
        & v111739(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4626,axiom,
    ! [VarCurr: state_type] :
      ( v111779(VarCurr)
    <=> ( v111739(VarCurr,0)
        & v111739(VarCurr,1) ) ) ).

tff(addAssignment_66576,axiom,
    ! [VarCurr: state_type] :
      ( v111749(VarCurr)
    <=> v111751(VarCurr) ) ).

tff(addAssignment_66575,axiom,
    ! [VarCurr: state_type] :
      ( v111751(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66574,axiom,
    ! [VarCurr: state_type] :
      ( v111745(VarCurr)
    <=> v111747(VarCurr) ) ).

tff(addAssignment_66573,axiom,
    ! [VarCurr: state_type] :
      ( v111747(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66572,axiom,
    ! [VarCurr: state_type] :
      ( v111725(VarCurr)
    <=> v111727(VarCurr) ) ).

tff(addAssignment_66571,axiom,
    ! [VarCurr: state_type] :
      ( v111727(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66570,axiom,
    ! [VarCurr: state_type] :
      ( v111721(VarCurr)
    <=> v111723(VarCurr) ) ).

tff(addAssignment_66569,axiom,
    ! [VarCurr: state_type] :
      ( v111723(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66568,axiom,
    ! [VarCurr: state_type] :
      ( v111703(VarCurr)
    <=> v111705(VarCurr) ) ).

tff(addAssignment_66567,axiom,
    ! [VarCurr: state_type] :
      ( v111705(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66566,axiom,
    ! [VarCurr: state_type] :
      ( v111699(VarCurr)
    <=> v111701(VarCurr) ) ).

tff(addAssignment_66565,axiom,
    ! [VarCurr: state_type] :
      ( v111701(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66564,axiom,
    ! [VarCurr: state_type] :
      ( v111651(VarCurr)
    <=> v111653(VarCurr) ) ).

tff(addAssignment_66563,axiom,
    ! [VarCurr: state_type] :
      ( v111653(VarCurr)
    <=> v111655(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111676(VarNext)
       => ( v111655(VarNext)
        <=> v111655(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1454,axiom,
    ! [VarNext: state_type] :
      ( v111676(VarNext)
     => ( v111655(VarNext)
      <=> v111686(VarNext) ) ) ).

tff(addAssignment_66562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111686(VarNext)
      <=> v111684(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111687(VarCurr)
     => ( v111684(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_965,axiom,
    ! [VarCurr: state_type] :
      ( v111687(VarCurr)
     => ( v111684(VarCurr)
      <=> v111665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11541,axiom,
    ! [VarCurr: state_type] :
      ( v111687(VarCurr)
    <=> ( v111688(VarCurr)
        & v111689(VarCurr) ) ) ).

tff(writeUnaryOperator_6103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111689(VarCurr)
    <=> v111661(VarCurr) ) ).

tff(writeUnaryOperator_6102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111688(VarCurr)
    <=> v111657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111676(VarNext)
      <=> v111677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111677(VarNext)
      <=> ( v111678(VarNext)
          & v111671(VarNext) ) ) ) ).

tff(writeUnaryOperator_6101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111678(VarNext)
      <=> v111680(VarNext) ) ) ).

tff(addAssignment_66561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111680(VarNext)
      <=> v111671(VarCurr) ) ) ).

tff(addAssignment_66560,axiom,
    ! [VarCurr: state_type] :
      ( v111671(VarCurr)
    <=> v111673(VarCurr) ) ).

tff(addAssignment_66559,axiom,
    ! [VarCurr: state_type] :
      ( v111673(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66558,axiom,
    ! [VarCurr: state_type] :
      ( v111665(VarCurr)
    <=> v111667(VarCurr) ) ).

tff(addAssignment_66557,axiom,
    ! [VarCurr: state_type] :
      ( v111667(VarCurr)
    <=> v111669(VarCurr) ) ).

tff(addAssignment_66556,axiom,
    ! [VarCurr: state_type] :
      ( v111669(VarCurr)
    <=> v110848(VarCurr) ) ).

tff(addAssignment_66555,axiom,
    ! [VarCurr: state_type] :
      ( v111661(VarCurr)
    <=> v111663(VarCurr) ) ).

tff(addAssignment_66554,axiom,
    ! [VarCurr: state_type] :
      ( v111663(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66553,axiom,
    ! [VarCurr: state_type] :
      ( v111657(VarCurr)
    <=> v111659(VarCurr) ) ).

tff(addAssignment_66552,axiom,
    ! [VarCurr: state_type] :
      ( v111659(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11538,axiom,
    ! [VarCurr: state_type] :
      ( v110848(VarCurr)
    <=> ( v110850(VarCurr)
        | v111516(VarCurr) ) ) ).

tff(addAssignment_66551,axiom,
    ! [VarCurr: state_type] :
      ( v111516(VarCurr)
    <=> v110852(VarCurr,0) ) ).

tff(addAssignment_66550,axiom,
    ! [VarCurr: state_type] :
      ( v110852(VarCurr,0)
    <=> v110854(VarCurr,0) ) ).

tff(addAssignment_66549,axiom,
    ! [VarNext: state_type] :
      ( v110854(VarNext,0)
    <=> v111642(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111643(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v111642(VarNext,B)
            <=> v110854(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1453,axiom,
    ! [VarNext: state_type] :
      ( v111643(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v111642(VarNext,B)
          <=> v111509(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111643(VarNext)
      <=> v111644(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111644(VarNext)
      <=> ( v111646(VarNext)
          & v111494(VarNext) ) ) ) ).

tff(writeUnaryOperator_6100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111646(VarNext)
      <=> v111503(VarNext) ) ) ).

tff(addAssignment_66548,axiom,
    ! [VarCurr: state_type] :
      ( v110864(VarCurr,0)
    <=> v110866(VarCurr,0) ) ).

tff(addAssignment_66547,axiom,
    ! [VarCurr: state_type] :
      ( v110866(VarCurr,0)
    <=> v110868(VarCurr,0) ) ).

tff(addAssignment_66546,axiom,
    ! [VarCurr: state_type] :
      ( v110868(VarCurr,0)
    <=> v111491(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11535,axiom,
    ! [VarCurr: state_type] :
      ( v111492(VarCurr)
    <=> ( v111636(VarCurr)
        & v111638(VarCurr) ) ) ).

tff(writeUnaryOperator_6099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111638(VarCurr)
    <=> v111639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11534,axiom,
    ! [VarCurr: state_type] :
      ( v111639(VarCurr)
    <=> ( v111519(VarCurr)
        & v111640(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_925,axiom,
    ! [VarCurr: state_type] :
      ( v111640(VarCurr)
    <=> ( ( v111248(VarCurr,2)
        <=> v111634(VarCurr,4) )
        & ( v111248(VarCurr,1)
        <=> v111634(VarCurr,3) )
        & ( v111248(VarCurr,0)
        <=> v111634(VarCurr,2) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11533,axiom,
    ! [VarCurr: state_type] :
      ( v111636(VarCurr)
    <=> ( v110840(VarCurr)
        & v111637(VarCurr) ) ) ).

tff(writeUnaryOperator_6098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111637(VarCurr)
    <=> v8(VarCurr,3) ) ).

tff(addAssignment_66545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v111634(VarCurr,B)
      <=> v111087(VarCurr,B) ) ) ).

tff(addAssignment_66544,axiom,
    ! [VarCurr: state_type] :
      ( v111519(VarCurr)
    <=> v111250(VarCurr,3) ) ).

tff(addAssignment_66543,axiom,
    ! [VarCurr: state_type] :
      ( v111250(VarCurr,3)
    <=> v111252(VarCurr,3) ) ).

tff(addAssignment_66542,axiom,
    ! [VarNext: state_type] :
      ( v111252(VarNext,3)
    <=> v111626(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111627(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v111626(VarNext,B)
            <=> v111252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1452,axiom,
    ! [VarNext: state_type] :
      ( v111627(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111626(VarNext,B)
          <=> v111341(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111627(VarNext)
      <=> v111628(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111628(VarNext)
      <=> ( v111630(VarNext)
          & v111326(VarNext) ) ) ) ).

tff(writeUnaryOperator_6097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111630(VarNext)
      <=> v111335(VarNext) ) ) ).

tff(addAssignment_66541,axiom,
    ! [VarCurr: state_type] :
      ( v111262(VarCurr,3)
    <=> v111264(VarCurr,3) ) ).

tff(addAssignment_66540,axiom,
    ! [VarCurr: state_type] :
      ( v111264(VarCurr,3)
    <=> v111266(VarCurr,3) ) ).

tff(addAssignment_66539,axiom,
    ! [VarCurr: state_type] :
      ( v111266(VarCurr,3)
    <=> v111323(VarCurr,3) ) ).

tff(addAssignment_66538,axiom,
    ! [VarCurr: state_type] :
      ( v111324(VarCurr)
    <=> v111522(VarCurr) ) ).

tff(addAssignment_66537,axiom,
    ! [VarCurr: state_type] :
      ( v111522(VarCurr)
    <=> v111524(VarCurr) ) ).

tff(addAssignment_66536,axiom,
    ! [VarCurr: state_type] :
      ( v111524(VarCurr)
    <=> v111526(VarCurr) ) ).

tff(addAssignment_66535,axiom,
    ! [VarCurr: state_type] :
      ( v111526(VarCurr)
    <=> v111528(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111609(VarNext)
       => ( v111528(VarNext)
        <=> v111528(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1451,axiom,
    ! [VarNext: state_type] :
      ( v111609(VarNext)
     => ( v111528(VarNext)
      <=> v111619(VarNext) ) ) ).

tff(addAssignment_66534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111619(VarNext)
      <=> v111617(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111620(VarCurr)
     => ( v111617(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_964,axiom,
    ! [VarCurr: state_type] :
      ( v111620(VarCurr)
     => ( v111617(VarCurr)
      <=> v111538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11530,axiom,
    ! [VarCurr: state_type] :
      ( v111620(VarCurr)
    <=> ( v111621(VarCurr)
        & v111622(VarCurr) ) ) ).

tff(writeUnaryOperator_6096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111622(VarCurr)
    <=> v111534(VarCurr) ) ).

tff(writeUnaryOperator_6095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111621(VarCurr)
    <=> v111530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111609(VarNext)
      <=> v111610(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111610(VarNext)
      <=> ( v111611(VarNext)
          & v111604(VarNext) ) ) ) ).

tff(writeUnaryOperator_6094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111611(VarNext)
      <=> v111613(VarNext) ) ) ).

tff(addAssignment_66533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111613(VarNext)
      <=> v111604(VarCurr) ) ) ).

tff(addAssignment_66532,axiom,
    ! [VarCurr: state_type] :
      ( v111604(VarCurr)
    <=> v111606(VarCurr) ) ).

tff(addAssignment_66531,axiom,
    ! [VarCurr: state_type] :
      ( v111606(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_66530,axiom,
    ! [VarCurr: state_type] :
      ( v111538(VarCurr)
    <=> v111540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11527,axiom,
    ! [VarCurr: state_type] :
      ( v111540(VarCurr)
    <=> ( v111596(VarCurr)
        | v111599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11526,axiom,
    ! [VarCurr: state_type] :
      ( v111599(VarCurr)
    <=> ( v111526(VarCurr)
        & v111600(VarCurr) ) ) ).

tff(writeUnaryOperator_6093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111600(VarCurr)
    <=> v111601(VarCurr) ) ).

tff(addAssignment_66529,axiom,
    ! [VarCurr: state_type] :
      ( v111601(VarCurr)
    <=> v111602(VarCurr) ) ).

tff(addAssignment_66528,axiom,
    ! [VarCurr: state_type] :
      ( v111602(VarCurr)
    <=> v111594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11525,axiom,
    ! [VarCurr: state_type] :
      ( v111596(VarCurr)
    <=> ( v111542(VarCurr)
        & v111597(VarCurr) ) ) ).

tff(addAssignment_66527,axiom,
    ! [VarCurr: state_type] :
      ( v111597(VarCurr)
    <=> v111598(VarCurr) ) ).

tff(addAssignment_66526,axiom,
    ! [VarCurr: state_type] :
      ( v111598(VarCurr)
    <=> v111594(VarCurr) ) ).

tff(addAssignment_66525,axiom,
    ! [VarCurr: state_type] :
      ( v111594(VarCurr)
    <=> v86612(VarCurr) ) ).

tff(addAssignment_66524,axiom,
    ! [VarCurr: state_type] :
      ( v111542(VarCurr)
    <=> v111544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11524,axiom,
    ! [VarCurr: state_type] :
      ( v111544(VarCurr)
    <=> ( v85827(VarCurr)
        | v111546(VarCurr) ) ) ).

tff(addAssignment_66523,axiom,
    ! [VarCurr: state_type] :
      ( v111546(VarCurr)
    <=> v111548(VarCurr) ) ).

tff(addAssignment_66522,axiom,
    ! [VarCurr: state_type] :
      ( v111548(VarCurr)
    <=> v111550(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111576(VarNext)
       => ( v111550(VarNext)
        <=> v111550(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1450,axiom,
    ! [VarNext: state_type] :
      ( v111576(VarNext)
     => ( v111550(VarNext)
      <=> v111586(VarNext) ) ) ).

tff(addAssignment_66521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111586(VarNext)
      <=> v111584(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111587(VarCurr)
     => ( v111584(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_963,axiom,
    ! [VarCurr: state_type] :
      ( v111587(VarCurr)
     => ( v111584(VarCurr)
      <=> v111560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11523,axiom,
    ! [VarCurr: state_type] :
      ( v111587(VarCurr)
    <=> ( v111588(VarCurr)
        & v111589(VarCurr) ) ) ).

tff(writeUnaryOperator_6092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111589(VarCurr)
    <=> v111556(VarCurr) ) ).

tff(writeUnaryOperator_6091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111588(VarCurr)
    <=> v111552(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111576(VarNext)
      <=> v111577(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111577(VarNext)
      <=> ( v111578(VarNext)
          & v111571(VarNext) ) ) ) ).

tff(writeUnaryOperator_6090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111578(VarNext)
      <=> v111580(VarNext) ) ) ).

tff(addAssignment_66520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111580(VarNext)
      <=> v111571(VarCurr) ) ) ).

tff(addAssignment_66519,axiom,
    ! [VarCurr: state_type] :
      ( v111571(VarCurr)
    <=> v111573(VarCurr) ) ).

tff(addAssignment_66518,axiom,
    ! [VarCurr: state_type] :
      ( v111573(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_66517,axiom,
    ! [VarCurr: state_type] :
      ( v111560(VarCurr)
    <=> v111562(VarCurr) ) ).

tff(addAssignment_66516,axiom,
    ! [VarCurr: state_type] :
      ( v111562(VarCurr)
    <=> v111564(VarCurr) ) ).

tff(addAssignment_66515,axiom,
    ! [VarCurr: state_type] :
      ( v111564(VarCurr)
    <=> v111566(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85827(VarCurr)
     => ( v111566(VarCurr)
      <=> v111568(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_962,axiom,
    ! [VarCurr: state_type] :
      ( v85827(VarCurr)
     => ( v111566(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111569(VarCurr)
     => ( v111568(VarCurr)
      <=> v111546(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_961,axiom,
    ! [VarCurr: state_type] :
      ( v111569(VarCurr)
     => ( v111568(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_924,axiom,
    ! [VarCurr: state_type] :
      ( v111569(VarCurr)
    <=> ( ( v85876(VarCurr,2)
        <=> $true )
        & ( v85876(VarCurr,1)
        <=> $true )
        & ( v85876(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_66514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85876(VarCurr,B)
      <=> v85878(VarCurr,B) ) ) ).

tff(addAssignment_66513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85878(VarCurr,B)
      <=> v85880(VarCurr,B) ) ) ).

tff(addAssignment_66512,axiom,
    ! [VarCurr: state_type] :
      ( v111556(VarCurr)
    <=> v111558(VarCurr) ) ).

tff(addAssignment_66511,axiom,
    ! [VarCurr: state_type] :
      ( v111558(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_66510,axiom,
    ! [VarCurr: state_type] :
      ( v111552(VarCurr)
    <=> v111554(VarCurr) ) ).

tff(addAssignment_66509,axiom,
    ! [VarCurr: state_type] :
      ( v111554(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_66508,axiom,
    ! [VarCurr: state_type] :
      ( v111534(VarCurr)
    <=> v111536(VarCurr) ) ).

tff(addAssignment_66507,axiom,
    ! [VarCurr: state_type] :
      ( v111536(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_66506,axiom,
    ! [VarCurr: state_type] :
      ( v111530(VarCurr)
    <=> v111532(VarCurr) ) ).

tff(addAssignment_66505,axiom,
    ! [VarCurr: state_type] :
      ( v111532(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_66504,axiom,
    ! [VarCurr: state_type] :
      ( v110850(VarCurr)
    <=> v110852(VarCurr,1) ) ).

tff(addAssignment_66503,axiom,
    ! [VarCurr: state_type] :
      ( v110852(VarCurr,1)
    <=> v110854(VarCurr,1) ) ).

tff(addAssignment_66502,axiom,
    ! [VarNext: state_type] :
      ( v110854(VarNext,1)
    <=> v111498(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111499(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v111498(VarNext,B)
            <=> v110854(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1449,axiom,
    ! [VarNext: state_type] :
      ( v111499(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v111498(VarNext,B)
          <=> v111509(VarNext,B) ) ) ) ).

tff(addAssignment_66501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v111509(VarNext,B)
          <=> v111507(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v111507(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_960,axiom,
    ! [VarCurr: state_type] :
      ( v111510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v111507(VarCurr,B)
          <=> v110864(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11520,axiom,
    ! [VarCurr: state_type] :
      ( v111510(VarCurr)
    <=> ( v111511(VarCurr)
        & v111512(VarCurr) ) ) ).

tff(writeUnaryOperator_6089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111512(VarCurr)
    <=> v110860(VarCurr) ) ).

tff(writeUnaryOperator_6088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111511(VarCurr)
    <=> v110856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111499(VarNext)
      <=> v111500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111500(VarNext)
      <=> ( v111501(VarNext)
          & v111494(VarNext) ) ) ) ).

tff(writeUnaryOperator_6087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111501(VarNext)
      <=> v111503(VarNext) ) ) ).

tff(addAssignment_66500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111503(VarNext)
      <=> v111494(VarCurr) ) ) ).

tff(addAssignment_66499,axiom,
    ! [VarCurr: state_type] :
      ( v111494(VarCurr)
    <=> v111496(VarCurr) ) ).

tff(addAssignment_66498,axiom,
    ! [VarCurr: state_type] :
      ( v111496(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66497,axiom,
    ! [VarCurr: state_type] :
      ( v110864(VarCurr,1)
    <=> v110866(VarCurr,1) ) ).

tff(addAssignment_66496,axiom,
    ! [VarCurr: state_type] :
      ( v110866(VarCurr,1)
    <=> v110868(VarCurr,1) ) ).

tff(addAssignment_66495,axiom,
    ! [VarCurr: state_type] :
      ( v110868(VarCurr,1)
    <=> v111491(VarCurr,1) ) ).

tff(addAssignment_66494,axiom,
    ! [VarCurr: state_type] :
      ( v111491(VarCurr,0)
    <=> v111492(VarCurr) ) ).

tff(addAssignment_66493,axiom,
    ! [VarCurr: state_type] :
      ( v111491(VarCurr,1)
    <=> v110870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11517,axiom,
    ! [VarCurr: state_type] :
      ( v110870(VarCurr)
    <=> ( v111486(VarCurr)
        & v111488(VarCurr) ) ) ).

tff(writeUnaryOperator_6086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111488(VarCurr)
    <=> v111489(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11516,axiom,
    ! [VarCurr: state_type] :
      ( v111489(VarCurr)
    <=> ( v110872(VarCurr)
        & v111490(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_923,axiom,
    ! [VarCurr: state_type] :
      ( v111490(VarCurr)
    <=> ( ( v111022(VarCurr,2)
        <=> v111087(VarCurr,4) )
        & ( v111022(VarCurr,1)
        <=> v111087(VarCurr,3) )
        & ( v111022(VarCurr,0)
        <=> v111087(VarCurr,2) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11515,axiom,
    ! [VarCurr: state_type] :
      ( v111486(VarCurr)
    <=> ( v110830(VarCurr)
        & v111487(VarCurr) ) ) ).

tff(writeUnaryOperator_6085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111487(VarCurr)
    <=> v8(VarCurr,3) ) ).

tff(addAssignment_66492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v111087(VarCurr,B)
      <=> v111089(VarCurr,B) ) ) ).

tff(addAssignment_66491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v111089(VarCurr,B)
      <=> v111091(VarCurr,B) ) ) ).

tff(addAssignment_66490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v111091(VarCurr,B)
      <=> v111093(VarCurr,B) ) ) ).

tff(addAssignment_66489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,2) )
     => ( v111093(VarCurr,B)
      <=> v111482(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v111482(VarCurr,B)
          <=> v111484(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_959,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v111482(VarCurr,B)
          <=> v111483(VarCurr,B) ) ) ) ).

tff(addAssignment_66488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v111484(VarCurr,B)
      <=> v97284(VarCurr,B) ) ) ).

tff(addAssignment_66487,axiom,
    ! [VarCurr: state_type] :
      ( ( v111484(VarCurr,4)
      <=> v97409(VarCurr,14) )
      & ( v111484(VarCurr,3)
      <=> v97409(VarCurr,13) )
      & ( v111484(VarCurr,2)
      <=> v97409(VarCurr,12) ) ) ).

tff(addAssignment_66486,axiom,
    ! [VarCurr: state_type] :
      ( ( v111483(VarCurr,1)
      <=> v97284(VarCurr,2) )
      & ( v111483(VarCurr,0)
      <=> v97284(VarCurr,1) ) ) ).

tff(addAssignment_66485,axiom,
    ! [VarCurr: state_type] :
      ( ( v111483(VarCurr,4)
      <=> v97409(VarCurr,14) )
      & ( v111483(VarCurr,3)
      <=> v97409(VarCurr,13) )
      & ( v111483(VarCurr,2)
      <=> v97409(VarCurr,12) ) ) ).

tff(addAssignment_66484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97409(VarCurr,B)
      <=> v100196(VarCurr,B) ) ) ).

tff(addAssignment_66483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100043(VarCurr,B)
      <=> v100045(VarCurr,B) ) ) ).

tff(addAssignment_66482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100045(VarCurr,B)
      <=> v100047(VarCurr,B) ) ) ).

tff(addAssignment_66481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100047(VarCurr,B)
      <=> v100049(VarCurr,B) ) ) ).

tff(addAssignment_66480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100049(VarCurr,B)
      <=> v100051(VarCurr,B) ) ) ).

tff(addAssignment_66479,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100051(VarNext,B)
      <=> v111475(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111476(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111475(VarNext,B)
            <=> v100051(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1448,axiom,
    ! [VarNext: state_type] :
      ( v111476(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111475(VarNext,B)
          <=> v100190(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111476(VarNext)
      <=> v111477(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111477(VarNext)
      <=> ( v111479(VarNext)
          & v100175(VarNext) ) ) ) ).

tff(writeUnaryOperator_6084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111479(VarNext)
      <=> v100184(VarNext) ) ) ).

tff(addAssignment_66478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100061(VarCurr,B)
      <=> v100063(VarCurr,B) ) ) ).

tff(addAssignment_66477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100063(VarCurr,B)
      <=> v100166(VarCurr,B) ) ) ).

tff(addAssignment_66476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100065(VarCurr,B)
      <=> v100067(VarCurr,B) ) ) ).

tff(addAssignment_66475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100067(VarCurr,B)
      <=> v100158(VarCurr,B) ) ) ).

tff(addAssignment_66474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100069(VarCurr,B)
      <=> v100071(VarCurr,B) ) ) ).

tff(addAssignment_66473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100071(VarCurr,B)
      <=> v100073(VarCurr,B) ) ) ).

tff(addAssignment_66472,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100073(VarNext,B)
      <=> v111467(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111468(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111467(VarNext,B)
            <=> v100073(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1447,axiom,
    ! [VarNext: state_type] :
      ( v111468(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111467(VarNext,B)
          <=> v100152(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111468(VarNext)
      <=> v111469(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111469(VarNext)
      <=> ( v111471(VarNext)
          & v100137(VarNext) ) ) ) ).

tff(writeUnaryOperator_6083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111471(VarNext)
      <=> v100146(VarNext) ) ) ).

tff(addAssignment_66471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100083(VarCurr,B)
      <=> v100085(VarCurr,B) ) ) ).

tff(addAssignment_66470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100085(VarCurr,B)
      <=> v100128(VarCurr,B) ) ) ).

tff(addAssignment_66469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100087(VarCurr,B)
      <=> v100089(VarCurr,B) ) ) ).

tff(addAssignment_66468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100089(VarCurr,B)
      <=> v100119(VarCurr,B) ) ) ).

tff(addAssignment_66467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100091(VarCurr,B)
      <=> v100093(VarCurr,B) ) ) ).

tff(addAssignment_66466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100093(VarCurr,B)
      <=> v100095(VarCurr,B) ) ) ).

tff(addAssignment_66465,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100095(VarNext,B)
      <=> v111449(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111450(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111449(VarNext,B)
            <=> v100095(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1446,axiom,
    ! [VarNext: state_type] :
      ( v111450(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111449(VarNext,B)
          <=> v111460(VarNext,B) ) ) ) ).

tff(addAssignment_66464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111460(VarNext,B)
          <=> v111458(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111461(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111458(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_958,axiom,
    ! [VarCurr: state_type] :
      ( v111461(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111458(VarCurr,B)
          <=> v111411(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11510,axiom,
    ! [VarCurr: state_type] :
      ( v111461(VarCurr)
    <=> ( v111462(VarCurr)
        & v111463(VarCurr) ) ) ).

tff(writeUnaryOperator_6082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111463(VarCurr)
    <=> v111407(VarCurr) ) ).

tff(writeUnaryOperator_6081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111462(VarCurr)
    <=> v111403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111450(VarNext)
      <=> v111451(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111451(VarNext)
      <=> ( v111452(VarNext)
          & v111445(VarNext) ) ) ) ).

tff(writeUnaryOperator_6080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111452(VarNext)
      <=> v111454(VarNext) ) ) ).

tff(addAssignment_66463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111454(VarNext)
      <=> v111445(VarCurr) ) ) ).

tff(addAssignment_66462,axiom,
    ! [VarCurr: state_type] :
      ( v111445(VarCurr)
    <=> v111447(VarCurr) ) ).

tff(addAssignment_66461,axiom,
    ! [VarCurr: state_type] :
      ( v111447(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_66460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111411(VarCurr,B)
      <=> v111413(VarCurr,B) ) ) ).

tff(addAssignment_66459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111413(VarCurr,B)
      <=> v111436(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111436(VarCurr,B)
      <=> ( v111437(VarCurr,B)
          | v111440(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111440(VarCurr,B)
      <=> ( v100093(VarCurr,B)
          & v111441(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111441(VarCurr,B)
      <=> ~ v111442(VarCurr,B) ) ) ).

tff(addAssignment_66458,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,0)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66457,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,1)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66456,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,2)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66455,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,3)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66454,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,4)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66453,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,5)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66452,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,6)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66451,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,7)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66450,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,8)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66449,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,9)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66448,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,10)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66447,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,11)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66446,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,12)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66445,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,13)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66444,axiom,
    ! [VarCurr: state_type] :
      ( v111442(VarCurr,14)
    <=> v111443(VarCurr) ) ).

tff(addAssignment_66443,axiom,
    ! [VarCurr: state_type] :
      ( v111443(VarCurr)
    <=> v111429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111437(VarCurr,B)
      <=> ( v111415(VarCurr,B)
          & v111438(VarCurr,B) ) ) ) ).

tff(addAssignment_66442,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,0)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66441,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,1)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66440,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,2)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66439,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,3)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66438,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,4)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66437,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,5)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66436,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,6)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66435,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,7)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66434,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,8)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66433,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,9)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66432,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,10)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66431,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,11)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66430,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,12)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66429,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,13)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66428,axiom,
    ! [VarCurr: state_type] :
      ( v111438(VarCurr,14)
    <=> v111439(VarCurr) ) ).

tff(addAssignment_66427,axiom,
    ! [VarCurr: state_type] :
      ( v111439(VarCurr)
    <=> v111429(VarCurr) ) ).

tff(addAssignment_66426,axiom,
    ! [VarCurr: state_type] :
      ( v111429(VarCurr)
    <=> v111431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11507,axiom,
    ! [VarCurr: state_type] :
      ( v111431(VarCurr)
    <=> ( v111433(VarCurr)
        | v111435(VarCurr) ) ) ).

tff(addAssignment_66425,axiom,
    ! [VarCurr: state_type] :
      ( v111435(VarCurr)
    <=> v98705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11506,axiom,
    ! [VarCurr: state_type] :
      ( v111433(VarCurr)
    <=> ( v111434(VarCurr)
        & v98665(VarCurr) ) ) ).

tff(writeUnaryOperator_6078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111434(VarCurr)
    <=> v98641(VarCurr,2) ) ).

tff(addAssignment_66424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111415(VarCurr,B)
      <=> v111417(VarCurr,B) ) ) ).

tff(addAssignment_66423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111417(VarCurr,B)
      <=> v111427(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98641(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111427(VarCurr,B)
          <=> v100097(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_957,axiom,
    ! [VarCurr: state_type] :
      ( v98641(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111427(VarCurr,B)
          <=> v111419(VarCurr,B) ) ) ) ).

tff(addAssignment_66422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v100097(VarCurr,B)
      <=> v100115(VarCurr,B) ) ) ).

tff(addAssignment_66421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100116(VarCurr,B)
      <=> v111426(VarCurr,B) ) ) ).

tff(addAssignment_66420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111426(VarCurr,B)
      <=> v111022(VarCurr,B) ) ) ).

tff(addAssignment_66419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111419(VarCurr,B)
      <=> v111421(VarCurr,B) ) ) ).

tff(addAssignment_66418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111421(VarCurr,B)
      <=> v111423(VarCurr,B) ) ) ).

tff(addAssignment_66417,axiom,
    ! [VarCurr: state_type] :
      ( v111407(VarCurr)
    <=> v111409(VarCurr) ) ).

tff(addAssignment_66416,axiom,
    ! [VarCurr: state_type] :
      ( v111409(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_66415,axiom,
    ! [VarCurr: state_type] :
      ( v111403(VarCurr)
    <=> v111405(VarCurr) ) ).

tff(addAssignment_66414,axiom,
    ! [VarCurr: state_type] :
      ( v111405(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_66413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99888(VarCurr,B)
      <=> v99890(VarCurr,B) ) ) ).

tff(addAssignment_66412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99890(VarCurr,B)
      <=> v99892(VarCurr,B) ) ) ).

tff(addAssignment_66411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99892(VarCurr,B)
      <=> v99894(VarCurr,B) ) ) ).

tff(addAssignment_66410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99894(VarCurr,B)
      <=> v99896(VarCurr,B) ) ) ).

tff(addAssignment_66409,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99896(VarNext,B)
      <=> v111395(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111396(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111395(VarNext,B)
            <=> v99896(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1445,axiom,
    ! [VarNext: state_type] :
      ( v111396(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111395(VarNext,B)
          <=> v100036(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111396(VarNext)
      <=> v111397(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111397(VarNext)
      <=> ( v111399(VarNext)
          & v100021(VarNext) ) ) ) ).

tff(writeUnaryOperator_6077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111399(VarNext)
      <=> v100030(VarNext) ) ) ).

tff(addAssignment_66408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99906(VarCurr,B)
      <=> v99908(VarCurr,B) ) ) ).

tff(addAssignment_66407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99908(VarCurr,B)
      <=> v100012(VarCurr,B) ) ) ).

tff(addAssignment_66406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99910(VarCurr,B)
      <=> v99912(VarCurr,B) ) ) ).

tff(addAssignment_66405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99912(VarCurr,B)
      <=> v100004(VarCurr,B) ) ) ).

tff(addAssignment_66404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99914(VarCurr,B)
      <=> v99916(VarCurr,B) ) ) ).

tff(addAssignment_66403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99916(VarCurr,B)
      <=> v99918(VarCurr,B) ) ) ).

tff(addAssignment_66402,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99918(VarNext,B)
      <=> v111387(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111388(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111387(VarNext,B)
            <=> v99918(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1444,axiom,
    ! [VarNext: state_type] :
      ( v111388(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111387(VarNext,B)
          <=> v99998(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11503,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111388(VarNext)
      <=> v111389(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111389(VarNext)
      <=> ( v111391(VarNext)
          & v99983(VarNext) ) ) ) ).

tff(writeUnaryOperator_6076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111391(VarNext)
      <=> v99992(VarNext) ) ) ).

tff(addAssignment_66401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99928(VarCurr,B)
      <=> v99930(VarCurr,B) ) ) ).

tff(addAssignment_66400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99930(VarCurr,B)
      <=> v99973(VarCurr,B) ) ) ).

tff(addAssignment_66399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99932(VarCurr,B)
      <=> v99934(VarCurr,B) ) ) ).

tff(addAssignment_66398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99934(VarCurr,B)
      <=> v99964(VarCurr,B) ) ) ).

tff(addAssignment_66397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99936(VarCurr,B)
      <=> v99938(VarCurr,B) ) ) ).

tff(addAssignment_66396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99938(VarCurr,B)
      <=> v99940(VarCurr,B) ) ) ).

tff(addAssignment_66395,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99940(VarNext,B)
      <=> v111369(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111370(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v111369(VarNext,B)
            <=> v99940(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1443,axiom,
    ! [VarNext: state_type] :
      ( v111370(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111369(VarNext,B)
          <=> v111380(VarNext,B) ) ) ) ).

tff(addAssignment_66394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111380(VarNext,B)
          <=> v111378(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111381(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111378(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_956,axiom,
    ! [VarCurr: state_type] :
      ( v111381(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111378(VarCurr,B)
          <=> v111231(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11501,axiom,
    ! [VarCurr: state_type] :
      ( v111381(VarCurr)
    <=> ( v111382(VarCurr)
        & v111383(VarCurr) ) ) ).

tff(writeUnaryOperator_6075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111383(VarCurr)
    <=> v111227(VarCurr) ) ).

tff(writeUnaryOperator_6074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111382(VarCurr)
    <=> v111223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111370(VarNext)
      <=> v111371(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111371(VarNext)
      <=> ( v111372(VarNext)
          & v111365(VarNext) ) ) ) ).

tff(writeUnaryOperator_6073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111372(VarNext)
      <=> v111374(VarNext) ) ) ).

tff(addAssignment_66393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111374(VarNext)
      <=> v111365(VarCurr) ) ) ).

tff(addAssignment_66392,axiom,
    ! [VarCurr: state_type] :
      ( v111365(VarCurr)
    <=> v111367(VarCurr) ) ).

tff(addAssignment_66391,axiom,
    ! [VarCurr: state_type] :
      ( v111367(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_66390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111231(VarCurr,B)
      <=> v111233(VarCurr,B) ) ) ).

tff(addAssignment_66389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111233(VarCurr,B)
      <=> v111356(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111356(VarCurr,B)
      <=> ( v111357(VarCurr,B)
          | v111360(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111360(VarCurr,B)
      <=> ( v99938(VarCurr,B)
          & v111361(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111361(VarCurr,B)
      <=> ~ v111362(VarCurr,B) ) ) ).

tff(addAssignment_66388,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,0)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66387,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,1)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66386,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,2)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66385,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,3)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66384,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,4)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66383,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,5)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66382,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,6)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66381,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,7)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66380,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,8)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66379,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,9)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66378,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,10)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66377,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,11)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66376,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,12)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66375,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,13)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66374,axiom,
    ! [VarCurr: state_type] :
      ( v111362(VarCurr,14)
    <=> v111363(VarCurr) ) ).

tff(addAssignment_66373,axiom,
    ! [VarCurr: state_type] :
      ( v111363(VarCurr)
    <=> v111349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v111357(VarCurr,B)
      <=> ( v111235(VarCurr,B)
          & v111358(VarCurr,B) ) ) ) ).

tff(addAssignment_66372,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,0)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66371,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,1)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66370,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,2)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66369,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,3)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66368,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,4)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66367,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,5)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66366,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,6)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66365,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,7)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66364,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,8)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66363,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,9)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66362,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,10)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66361,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,11)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66360,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,12)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66359,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,13)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66358,axiom,
    ! [VarCurr: state_type] :
      ( v111358(VarCurr,14)
    <=> v111359(VarCurr) ) ).

tff(addAssignment_66357,axiom,
    ! [VarCurr: state_type] :
      ( v111359(VarCurr)
    <=> v111349(VarCurr) ) ).

tff(addAssignment_66356,axiom,
    ! [VarCurr: state_type] :
      ( v111349(VarCurr)
    <=> v111351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11498,axiom,
    ! [VarCurr: state_type] :
      ( v111351(VarCurr)
    <=> ( v111353(VarCurr)
        | v111355(VarCurr) ) ) ).

tff(addAssignment_66355,axiom,
    ! [VarCurr: state_type] :
      ( v111355(VarCurr)
    <=> v99295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11497,axiom,
    ! [VarCurr: state_type] :
      ( v111353(VarCurr)
    <=> ( v111354(VarCurr)
        & v99256(VarCurr) ) ) ).

tff(writeUnaryOperator_6071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111354(VarCurr)
    <=> v99232(VarCurr,2) ) ).

tff(addAssignment_66354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111235(VarCurr,B)
      <=> v111237(VarCurr,B) ) ) ).

tff(addAssignment_66353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111237(VarCurr,B)
      <=> v111347(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99232(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111347(VarCurr,B)
          <=> v99942(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_955,axiom,
    ! [VarCurr: state_type] :
      ( v99232(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v111347(VarCurr,B)
          <=> v111239(VarCurr,B) ) ) ) ).

tff(addAssignment_66352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v99942(VarCurr,B)
      <=> v99960(VarCurr,B) ) ) ).

tff(addAssignment_66351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99961(VarCurr,B)
      <=> v111246(VarCurr,B) ) ) ).

tff(addAssignment_66350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111246(VarCurr,B)
      <=> v111248(VarCurr,B) ) ) ).

tff(addAssignment_66349,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111248(VarCurr,B)
      <=> v111250(VarCurr,B) ) ) ).

tff(addAssignment_66348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111250(VarCurr,B)
      <=> v111252(VarCurr,B) ) ) ).

tff(addAssignment_66347,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111252(VarNext,B)
      <=> v111330(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111331(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v111330(VarNext,B)
            <=> v111252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1442,axiom,
    ! [VarNext: state_type] :
      ( v111331(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111330(VarNext,B)
          <=> v111341(VarNext,B) ) ) ) ).

tff(addAssignment_66346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111341(VarNext,B)
          <=> v111339(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111342(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111339(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_954,axiom,
    ! [VarCurr: state_type] :
      ( v111342(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111339(VarCurr,B)
          <=> v111262(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11496,axiom,
    ! [VarCurr: state_type] :
      ( v111342(VarCurr)
    <=> ( v111343(VarCurr)
        & v111344(VarCurr) ) ) ).

tff(writeUnaryOperator_6070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111344(VarCurr)
    <=> v111258(VarCurr) ) ).

tff(writeUnaryOperator_6069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111343(VarCurr)
    <=> v111254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111331(VarNext)
      <=> v111332(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111332(VarNext)
      <=> ( v111333(VarNext)
          & v111326(VarNext) ) ) ) ).

tff(writeUnaryOperator_6068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111333(VarNext)
      <=> v111335(VarNext) ) ) ).

tff(addAssignment_66345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111335(VarNext)
      <=> v111326(VarCurr) ) ) ).

tff(addAssignment_66344,axiom,
    ! [VarCurr: state_type] :
      ( v111326(VarCurr)
    <=> v111328(VarCurr) ) ).

tff(addAssignment_66343,axiom,
    ! [VarCurr: state_type] :
      ( v111328(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111262(VarCurr,B)
      <=> v111264(VarCurr,B) ) ) ).

tff(addAssignment_66341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111264(VarCurr,B)
      <=> v111266(VarCurr,B) ) ) ).

tff(addAssignment_66340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111266(VarCurr,B)
      <=> v111323(VarCurr,B) ) ) ).

tff(addAssignment_66339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111323(VarCurr,B)
      <=> v111268(VarCurr,B) ) ) ).

tff(addAssignment_66338,axiom,
    ! [VarCurr: state_type] :
      ( v111323(VarCurr,3)
    <=> v111324(VarCurr) ) ).

tff(addAssignment_66337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111268(VarCurr,B)
      <=> v111270(VarCurr,B) ) ) ).

tff(addAssignment_66336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111270(VarCurr,B)
      <=> v111272(VarCurr,B) ) ) ).

tff(addAssignment_66335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111272(VarCurr,B)
      <=> v111274(VarCurr,B) ) ) ).

tff(addAssignment_66334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111274(VarCurr,B)
      <=> v111276(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111307(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v111276(VarNext,B)
            <=> v111276(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1441,axiom,
    ! [VarNext: state_type] :
      ( v111307(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111276(VarNext,B)
          <=> v111317(VarNext,B) ) ) ) ).

tff(addAssignment_66333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111317(VarNext,B)
          <=> v111315(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111318(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111315(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_953,axiom,
    ! [VarCurr: state_type] :
      ( v111318(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111315(VarCurr,B)
          <=> v111286(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11493,axiom,
    ! [VarCurr: state_type] :
      ( v111318(VarCurr)
    <=> ( v111319(VarCurr)
        & v111320(VarCurr) ) ) ).

tff(writeUnaryOperator_6067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111320(VarCurr)
    <=> v111282(VarCurr) ) ).

tff(writeUnaryOperator_6066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111319(VarCurr)
    <=> v111278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111307(VarNext)
      <=> v111308(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111308(VarNext)
      <=> ( v111309(VarNext)
          & v111302(VarNext) ) ) ) ).

tff(writeUnaryOperator_6065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111309(VarNext)
      <=> v111311(VarNext) ) ) ).

tff(addAssignment_66332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111311(VarNext)
      <=> v111302(VarCurr) ) ) ).

tff(addAssignment_66331,axiom,
    ! [VarCurr: state_type] :
      ( v111302(VarCurr)
    <=> v111304(VarCurr) ) ).

tff(addAssignment_66330,axiom,
    ! [VarCurr: state_type] :
      ( v111304(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_66329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111286(VarCurr,B)
      <=> v111288(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111288(VarCurr,B)
      <=> ( v111294(VarCurr,B)
          | v111297(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111297(VarCurr,B)
      <=> ( v111274(VarCurr,B)
          & v111298(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111298(VarCurr,B)
      <=> ~ v111299(VarCurr,B) ) ) ).

tff(addAssignment_66328,axiom,
    ! [VarCurr: state_type] :
      ( v111299(VarCurr,0)
    <=> v111300(VarCurr) ) ).

tff(addAssignment_66327,axiom,
    ! [VarCurr: state_type] :
      ( v111299(VarCurr,1)
    <=> v111300(VarCurr) ) ).

tff(addAssignment_66326,axiom,
    ! [VarCurr: state_type] :
      ( v111299(VarCurr,2)
    <=> v111300(VarCurr) ) ).

tff(addAssignment_66325,axiom,
    ! [VarCurr: state_type] :
      ( v111300(VarCurr)
    <=> v111292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111294(VarCurr,B)
      <=> ( v111290(VarCurr,B)
          & v111295(VarCurr,B) ) ) ) ).

tff(addAssignment_66324,axiom,
    ! [VarCurr: state_type] :
      ( v111295(VarCurr,0)
    <=> v111296(VarCurr) ) ).

tff(addAssignment_66323,axiom,
    ! [VarCurr: state_type] :
      ( v111295(VarCurr,1)
    <=> v111296(VarCurr) ) ).

tff(addAssignment_66322,axiom,
    ! [VarCurr: state_type] :
      ( v111295(VarCurr,2)
    <=> v111296(VarCurr) ) ).

tff(addAssignment_66321,axiom,
    ! [VarCurr: state_type] :
      ( v111296(VarCurr)
    <=> v111292(VarCurr) ) ).

tff(addAssignment_66320,axiom,
    ! [VarCurr: state_type] :
      ( v111292(VarCurr)
    <=> v86612(VarCurr) ) ).

tff(addAssignment_66319,axiom,
    ! [VarCurr: state_type] :
      ( ( v111290(VarCurr,2)
      <=> v85876(VarCurr,5) )
      & ( v111290(VarCurr,1)
      <=> v85876(VarCurr,4) )
      & ( v111290(VarCurr,0)
      <=> v85876(VarCurr,3) ) ) ).

tff(addAssignment_66318,axiom,
    ! [VarCurr: state_type] :
      ( v111282(VarCurr)
    <=> v111284(VarCurr) ) ).

tff(addAssignment_66317,axiom,
    ! [VarCurr: state_type] :
      ( v111284(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_66316,axiom,
    ! [VarCurr: state_type] :
      ( v111278(VarCurr)
    <=> v111280(VarCurr) ) ).

tff(addAssignment_66315,axiom,
    ! [VarCurr: state_type] :
      ( v111280(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_66314,axiom,
    ! [VarCurr: state_type] :
      ( v111258(VarCurr)
    <=> v111260(VarCurr) ) ).

tff(addAssignment_66313,axiom,
    ! [VarCurr: state_type] :
      ( v111260(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66312,axiom,
    ! [VarCurr: state_type] :
      ( v111254(VarCurr)
    <=> v111256(VarCurr) ) ).

tff(addAssignment_66311,axiom,
    ! [VarCurr: state_type] :
      ( v111256(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111239(VarCurr,B)
      <=> v111241(VarCurr,B) ) ) ).

tff(addAssignment_66309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v111241(VarCurr,B)
      <=> v111243(VarCurr,B) ) ) ).

tff(addAssignment_66308,axiom,
    ! [VarCurr: state_type] :
      ( v111227(VarCurr)
    <=> v111229(VarCurr) ) ).

tff(addAssignment_66307,axiom,
    ! [VarCurr: state_type] :
      ( v111229(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_66306,axiom,
    ! [VarCurr: state_type] :
      ( v111223(VarCurr)
    <=> v111225(VarCurr) ) ).

tff(addAssignment_66305,axiom,
    ! [VarCurr: state_type] :
      ( v111225(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_66304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97411(VarCurr,B)
      <=> v98356(VarCurr,B) ) ) ).

tff(addAssignment_66303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98301(VarCurr,B)
      <=> v98303(VarCurr,B) ) ) ).

tff(addAssignment_66302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98303(VarCurr,B)
      <=> v98305(VarCurr,B) ) ) ).

tff(addAssignment_66301,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98305(VarNext,B)
      <=> v111215(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111216(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111215(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1440,axiom,
    ! [VarNext: state_type] :
      ( v111216(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111215(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111216(VarNext)
      <=> v111217(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111217(VarNext)
      <=> ( v111219(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_6063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111219(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_66300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98315(VarCurr,B)
      <=> v98317(VarCurr,B) ) ) ).

tff(addAssignment_66299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98317(VarCurr,B)
      <=> v98326(VarCurr,B) ) ) ).

tff(addAssignment_66298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98319(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98245(VarCurr,B)
      <=> v98247(VarCurr,B) ) ) ).

tff(addAssignment_66296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98247(VarCurr,B)
      <=> v98249(VarCurr,B) ) ) ).

tff(addAssignment_66295,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98249(VarNext,B)
      <=> v111207(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111208(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111207(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1439,axiom,
    ! [VarNext: state_type] :
      ( v111208(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111207(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111208(VarNext)
      <=> v111209(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111209(VarNext)
      <=> ( v111211(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_6062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111211(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_66294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98259(VarCurr,B)
      <=> v98261(VarCurr,B) ) ) ).

tff(addAssignment_66293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98261(VarCurr,B)
      <=> v98270(VarCurr,B) ) ) ).

tff(addAssignment_66292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98263(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98189(VarCurr,B)
      <=> v98191(VarCurr,B) ) ) ).

tff(addAssignment_66290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98191(VarCurr,B)
      <=> v98193(VarCurr,B) ) ) ).

tff(addAssignment_66289,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98193(VarNext,B)
      <=> v111199(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111200(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111199(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1438,axiom,
    ! [VarNext: state_type] :
      ( v111200(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111199(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111200(VarNext)
      <=> v111201(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111201(VarNext)
      <=> ( v111203(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_6061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111203(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_66288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98203(VarCurr,B)
      <=> v98205(VarCurr,B) ) ) ).

tff(addAssignment_66287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98205(VarCurr,B)
      <=> v98214(VarCurr,B) ) ) ).

tff(addAssignment_66286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98207(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98133(VarCurr,B)
      <=> v98135(VarCurr,B) ) ) ).

tff(addAssignment_66284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98135(VarCurr,B)
      <=> v98137(VarCurr,B) ) ) ).

tff(addAssignment_66283,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98137(VarNext,B)
      <=> v111191(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111192(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111191(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1437,axiom,
    ! [VarNext: state_type] :
      ( v111192(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111191(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111192(VarNext)
      <=> v111193(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111193(VarNext)
      <=> ( v111195(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_6060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111195(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_66282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98147(VarCurr,B)
      <=> v98149(VarCurr,B) ) ) ).

tff(addAssignment_66281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98149(VarCurr,B)
      <=> v98158(VarCurr,B) ) ) ).

tff(addAssignment_66280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98151(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98077(VarCurr,B)
      <=> v98079(VarCurr,B) ) ) ).

tff(addAssignment_66278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98079(VarCurr,B)
      <=> v98081(VarCurr,B) ) ) ).

tff(addAssignment_66277,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98081(VarNext,B)
      <=> v111183(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111184(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111183(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1436,axiom,
    ! [VarNext: state_type] :
      ( v111184(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111183(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111184(VarNext)
      <=> v111185(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111185(VarNext)
      <=> ( v111187(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_6059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111187(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_66276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98091(VarCurr,B)
      <=> v98093(VarCurr,B) ) ) ).

tff(addAssignment_66275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98093(VarCurr,B)
      <=> v98102(VarCurr,B) ) ) ).

tff(addAssignment_66274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98095(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98021(VarCurr,B)
      <=> v98023(VarCurr,B) ) ) ).

tff(addAssignment_66272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98023(VarCurr,B)
      <=> v98025(VarCurr,B) ) ) ).

tff(addAssignment_66271,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98025(VarNext,B)
      <=> v111175(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111176(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111175(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1435,axiom,
    ! [VarNext: state_type] :
      ( v111176(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111175(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111176(VarNext)
      <=> v111177(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111177(VarNext)
      <=> ( v111179(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_6058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111179(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_66270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98035(VarCurr,B)
      <=> v98037(VarCurr,B) ) ) ).

tff(addAssignment_66269,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98037(VarCurr,B)
      <=> v98046(VarCurr,B) ) ) ).

tff(addAssignment_66268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v98039(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97965(VarCurr,B)
      <=> v97967(VarCurr,B) ) ) ).

tff(addAssignment_66266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97967(VarCurr,B)
      <=> v97969(VarCurr,B) ) ) ).

tff(addAssignment_66265,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97969(VarNext,B)
      <=> v111167(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111168(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111167(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1434,axiom,
    ! [VarNext: state_type] :
      ( v111168(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111167(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111168(VarNext)
      <=> v111169(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111169(VarNext)
      <=> ( v111171(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_6057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111171(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_66264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97979(VarCurr,B)
      <=> v97981(VarCurr,B) ) ) ).

tff(addAssignment_66263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97981(VarCurr,B)
      <=> v97990(VarCurr,B) ) ) ).

tff(addAssignment_66262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97983(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97909(VarCurr,B)
      <=> v97911(VarCurr,B) ) ) ).

tff(addAssignment_66260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97911(VarCurr,B)
      <=> v97913(VarCurr,B) ) ) ).

tff(addAssignment_66259,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97913(VarNext,B)
      <=> v111159(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111160(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111159(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1433,axiom,
    ! [VarNext: state_type] :
      ( v111160(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111159(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111160(VarNext)
      <=> v111161(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111161(VarNext)
      <=> ( v111163(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_6056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111163(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_66258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97923(VarCurr,B)
      <=> v97925(VarCurr,B) ) ) ).

tff(addAssignment_66257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97925(VarCurr,B)
      <=> v97934(VarCurr,B) ) ) ).

tff(addAssignment_66256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97927(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97853(VarCurr,B)
      <=> v97855(VarCurr,B) ) ) ).

tff(addAssignment_66254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97855(VarCurr,B)
      <=> v97857(VarCurr,B) ) ) ).

tff(addAssignment_66253,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97857(VarNext,B)
      <=> v111151(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111152(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111151(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1432,axiom,
    ! [VarNext: state_type] :
      ( v111152(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111151(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111152(VarNext)
      <=> v111153(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111153(VarNext)
      <=> ( v111155(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_6055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111155(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_66252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97867(VarCurr,B)
      <=> v97869(VarCurr,B) ) ) ).

tff(addAssignment_66251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97869(VarCurr,B)
      <=> v97878(VarCurr,B) ) ) ).

tff(addAssignment_66250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97871(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97797(VarCurr,B)
      <=> v97799(VarCurr,B) ) ) ).

tff(addAssignment_66248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97799(VarCurr,B)
      <=> v97801(VarCurr,B) ) ) ).

tff(addAssignment_66247,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97801(VarNext,B)
      <=> v111143(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111144(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111143(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1431,axiom,
    ! [VarNext: state_type] :
      ( v111144(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111143(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111144(VarNext)
      <=> v111145(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111145(VarNext)
      <=> ( v111147(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_6054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111147(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_66246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97811(VarCurr,B)
      <=> v97813(VarCurr,B) ) ) ).

tff(addAssignment_66245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97813(VarCurr,B)
      <=> v97822(VarCurr,B) ) ) ).

tff(addAssignment_66244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97815(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97741(VarCurr,B)
      <=> v97743(VarCurr,B) ) ) ).

tff(addAssignment_66242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97743(VarCurr,B)
      <=> v97745(VarCurr,B) ) ) ).

tff(addAssignment_66241,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97745(VarNext,B)
      <=> v111135(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111136(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111135(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1430,axiom,
    ! [VarNext: state_type] :
      ( v111136(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111135(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111136(VarNext)
      <=> v111137(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111137(VarNext)
      <=> ( v111139(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_6053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111139(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_66240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97755(VarCurr,B)
      <=> v97757(VarCurr,B) ) ) ).

tff(addAssignment_66239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97757(VarCurr,B)
      <=> v97766(VarCurr,B) ) ) ).

tff(addAssignment_66238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97759(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97685(VarCurr,B)
      <=> v97687(VarCurr,B) ) ) ).

tff(addAssignment_66236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97687(VarCurr,B)
      <=> v97689(VarCurr,B) ) ) ).

tff(addAssignment_66235,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97689(VarNext,B)
      <=> v111127(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111128(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111127(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1429,axiom,
    ! [VarNext: state_type] :
      ( v111128(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111127(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111128(VarNext)
      <=> v111129(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111129(VarNext)
      <=> ( v111131(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_6052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111131(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_66234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97699(VarCurr,B)
      <=> v97701(VarCurr,B) ) ) ).

tff(addAssignment_66233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97701(VarCurr,B)
      <=> v97710(VarCurr,B) ) ) ).

tff(addAssignment_66232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97703(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97629(VarCurr,B)
      <=> v97631(VarCurr,B) ) ) ).

tff(addAssignment_66230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97631(VarCurr,B)
      <=> v97633(VarCurr,B) ) ) ).

tff(addAssignment_66229,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97633(VarNext,B)
      <=> v111119(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111120(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111119(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1428,axiom,
    ! [VarNext: state_type] :
      ( v111120(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111119(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111120(VarNext)
      <=> v111121(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111121(VarNext)
      <=> ( v111123(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_6051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111123(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_66228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97643(VarCurr,B)
      <=> v97645(VarCurr,B) ) ) ).

tff(addAssignment_66227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97645(VarCurr,B)
      <=> v97654(VarCurr,B) ) ) ).

tff(addAssignment_66226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97647(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97573(VarCurr,B)
      <=> v97575(VarCurr,B) ) ) ).

tff(addAssignment_66224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97575(VarCurr,B)
      <=> v97577(VarCurr,B) ) ) ).

tff(addAssignment_66223,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97577(VarNext,B)
      <=> v111111(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111112(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111111(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1427,axiom,
    ! [VarNext: state_type] :
      ( v111112(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111111(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111112(VarNext)
      <=> v111113(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111113(VarNext)
      <=> ( v111115(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_6050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111115(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_66222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97587(VarCurr,B)
      <=> v97589(VarCurr,B) ) ) ).

tff(addAssignment_66221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97589(VarCurr,B)
      <=> v97598(VarCurr,B) ) ) ).

tff(addAssignment_66220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97591(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97517(VarCurr,B)
      <=> v97519(VarCurr,B) ) ) ).

tff(addAssignment_66218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97519(VarCurr,B)
      <=> v97521(VarCurr,B) ) ) ).

tff(addAssignment_66217,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97521(VarNext,B)
      <=> v111103(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111104(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111103(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1426,axiom,
    ! [VarNext: state_type] :
      ( v111104(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111103(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111104(VarNext)
      <=> v111105(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111105(VarNext)
      <=> ( v111107(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_6049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111107(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_66216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97531(VarCurr,B)
      <=> v97533(VarCurr,B) ) ) ).

tff(addAssignment_66215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97533(VarCurr,B)
      <=> v97542(VarCurr,B) ) ) ).

tff(addAssignment_66214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97535(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97413(VarCurr,B)
      <=> v97415(VarCurr,B) ) ) ).

tff(addAssignment_66212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97415(VarCurr,B)
      <=> v97417(VarCurr,B) ) ) ).

tff(addAssignment_66211,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97417(VarNext,B)
      <=> v111095(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111096(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v111095(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1425,axiom,
    ! [VarNext: state_type] :
      ( v111096(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v111095(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111096(VarNext)
      <=> v111097(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111097(VarNext)
      <=> ( v111099(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_6048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111099(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_66210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97427(VarCurr,B)
      <=> v97429(VarCurr,B) ) ) ).

tff(addAssignment_66209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97429(VarCurr,B)
      <=> v97486(VarCurr,B) ) ) ).

tff(addAssignment_66208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,12) )
     => ( v97431(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_66207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111022(VarCurr,B)
      <=> v110874(VarCurr,B) ) ) ).

tff(addAssignment_66206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110874(VarCurr,B)
      <=> v110876(VarCurr,B) ) ) ).

tff(addAssignment_66205,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110876(VarNext,B)
      <=> v111079(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111080(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v111079(VarNext,B)
            <=> v110876(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1424,axiom,
    ! [VarNext: state_type] :
      ( v111080(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111079(VarNext,B)
          <=> v111015(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111080(VarNext)
      <=> v111081(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111081(VarNext)
      <=> ( v111083(VarNext)
          & v111000(VarNext) ) ) ) ).

tff(writeUnaryOperator_6047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111083(VarNext)
      <=> v111009(VarNext) ) ) ).

tff(addAssignment_66204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110886(VarCurr,B)
      <=> v110888(VarCurr,B) ) ) ).

tff(addAssignment_66203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110888(VarCurr,B)
      <=> v110890(VarCurr,B) ) ) ).

tff(addAssignment_66202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110890(VarCurr,B)
      <=> v110997(VarCurr,B) ) ) ).

tff(addAssignment_66201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110998(VarCurr,B)
      <=> v111025(VarCurr,B) ) ) ).

tff(addAssignment_66200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111025(VarCurr,B)
      <=> v111027(VarCurr,B) ) ) ).

tff(addAssignment_66199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111027(VarCurr,B)
      <=> v111029(VarCurr,B) ) ) ).

tff(addAssignment_66198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111029(VarCurr,B)
      <=> v111031(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111062(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v111031(VarNext,B)
            <=> v111031(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1423,axiom,
    ! [VarNext: state_type] :
      ( v111062(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111031(VarNext,B)
          <=> v111072(VarNext,B) ) ) ) ).

tff(addAssignment_66197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111072(VarNext,B)
          <=> v111070(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111073(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111070(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_952,axiom,
    ! [VarCurr: state_type] :
      ( v111073(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v111070(VarCurr,B)
          <=> v111041(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11456,axiom,
    ! [VarCurr: state_type] :
      ( v111073(VarCurr)
    <=> ( v111074(VarCurr)
        & v111075(VarCurr) ) ) ).

tff(writeUnaryOperator_6046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111075(VarCurr)
    <=> v111037(VarCurr) ) ).

tff(writeUnaryOperator_6045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111074(VarCurr)
    <=> v111033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111062(VarNext)
      <=> v111063(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111063(VarNext)
      <=> ( v111064(VarNext)
          & v111057(VarNext) ) ) ) ).

tff(writeUnaryOperator_6044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111064(VarNext)
      <=> v111066(VarNext) ) ) ).

tff(addAssignment_66196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111066(VarNext)
      <=> v111057(VarCurr) ) ) ).

tff(addAssignment_66195,axiom,
    ! [VarCurr: state_type] :
      ( v111057(VarCurr)
    <=> v111059(VarCurr) ) ).

tff(addAssignment_66194,axiom,
    ! [VarCurr: state_type] :
      ( v111059(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_66193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111041(VarCurr,B)
      <=> v111043(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111043(VarCurr,B)
      <=> ( v111049(VarCurr,B)
          | v111052(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111052(VarCurr,B)
      <=> ( v111029(VarCurr,B)
          & v111053(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111053(VarCurr,B)
      <=> ~ v111054(VarCurr,B) ) ) ).

tff(addAssignment_66192,axiom,
    ! [VarCurr: state_type] :
      ( v111054(VarCurr,0)
    <=> v111055(VarCurr) ) ).

tff(addAssignment_66191,axiom,
    ! [VarCurr: state_type] :
      ( v111054(VarCurr,1)
    <=> v111055(VarCurr) ) ).

tff(addAssignment_66190,axiom,
    ! [VarCurr: state_type] :
      ( v111054(VarCurr,2)
    <=> v111055(VarCurr) ) ).

tff(addAssignment_66189,axiom,
    ! [VarCurr: state_type] :
      ( v111055(VarCurr)
    <=> v111047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v111049(VarCurr,B)
      <=> ( v111045(VarCurr,B)
          & v111050(VarCurr,B) ) ) ) ).

tff(addAssignment_66188,axiom,
    ! [VarCurr: state_type] :
      ( v111050(VarCurr,0)
    <=> v111051(VarCurr) ) ).

tff(addAssignment_66187,axiom,
    ! [VarCurr: state_type] :
      ( v111050(VarCurr,1)
    <=> v111051(VarCurr) ) ).

tff(addAssignment_66186,axiom,
    ! [VarCurr: state_type] :
      ( v111050(VarCurr,2)
    <=> v111051(VarCurr) ) ).

tff(addAssignment_66185,axiom,
    ! [VarCurr: state_type] :
      ( v111051(VarCurr)
    <=> v111047(VarCurr) ) ).

tff(addAssignment_66184,axiom,
    ! [VarCurr: state_type] :
      ( v111047(VarCurr)
    <=> v3799(VarCurr) ) ).

tff(addAssignment_66183,axiom,
    ! [VarCurr: state_type] :
      ( ( v111045(VarCurr,2)
      <=> v3047(VarCurr,5) )
      & ( v111045(VarCurr,1)
      <=> v3047(VarCurr,4) )
      & ( v111045(VarCurr,0)
      <=> v3047(VarCurr,3) ) ) ).

tff(addAssignment_66182,axiom,
    ! [VarCurr: state_type] :
      ( v111037(VarCurr)
    <=> v111039(VarCurr) ) ).

tff(addAssignment_66181,axiom,
    ! [VarCurr: state_type] :
      ( v111039(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_66180,axiom,
    ! [VarCurr: state_type] :
      ( v111033(VarCurr)
    <=> v111035(VarCurr) ) ).

tff(addAssignment_66179,axiom,
    ! [VarCurr: state_type] :
      ( v111035(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_66178,axiom,
    ! [VarCurr: state_type] :
      ( v110872(VarCurr)
    <=> v110874(VarCurr,3) ) ).

tff(addAssignment_66177,axiom,
    ! [VarCurr: state_type] :
      ( v110874(VarCurr,3)
    <=> v110876(VarCurr,3) ) ).

tff(addAssignment_66176,axiom,
    ! [VarNext: state_type] :
      ( v110876(VarNext,3)
    <=> v111004(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111005(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v111004(VarNext,B)
            <=> v110876(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1422,axiom,
    ! [VarNext: state_type] :
      ( v111005(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111004(VarNext,B)
          <=> v111015(VarNext,B) ) ) ) ).

tff(addAssignment_66175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111015(VarNext,B)
          <=> v111013(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111013(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_951,axiom,
    ! [VarCurr: state_type] :
      ( v111016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v111013(VarCurr,B)
          <=> v110886(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11453,axiom,
    ! [VarCurr: state_type] :
      ( v111016(VarCurr)
    <=> ( v111017(VarCurr)
        & v111018(VarCurr) ) ) ).

tff(writeUnaryOperator_6042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111018(VarCurr)
    <=> v110882(VarCurr) ) ).

tff(writeUnaryOperator_6041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v111017(VarCurr)
    <=> v110878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111005(VarNext)
      <=> v111006(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111006(VarNext)
      <=> ( v111007(VarNext)
          & v111000(VarNext) ) ) ) ).

tff(writeUnaryOperator_6040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v111007(VarNext)
      <=> v111009(VarNext) ) ) ).

tff(addAssignment_66174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v111009(VarNext)
      <=> v111000(VarCurr) ) ) ).

tff(addAssignment_66173,axiom,
    ! [VarCurr: state_type] :
      ( v111000(VarCurr)
    <=> v111002(VarCurr) ) ).

tff(addAssignment_66172,axiom,
    ! [VarCurr: state_type] :
      ( v111002(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66171,axiom,
    ! [VarCurr: state_type] :
      ( v110886(VarCurr,3)
    <=> v110888(VarCurr,3) ) ).

tff(addAssignment_66170,axiom,
    ! [VarCurr: state_type] :
      ( v110888(VarCurr,3)
    <=> v110890(VarCurr,3) ) ).

tff(addAssignment_66169,axiom,
    ! [VarCurr: state_type] :
      ( v110890(VarCurr,3)
    <=> v110997(VarCurr,3) ) ).

tff(addAssignment_66168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110997(VarCurr,B)
      <=> v110998(VarCurr,B) ) ) ).

tff(addAssignment_66167,axiom,
    ! [VarCurr: state_type] :
      ( v110997(VarCurr,3)
    <=> v110892(VarCurr) ) ).

tff(addAssignment_66166,axiom,
    ! [VarCurr: state_type] :
      ( v110892(VarCurr)
    <=> v110894(VarCurr) ) ).

tff(addAssignment_66165,axiom,
    ! [VarCurr: state_type] :
      ( v110894(VarCurr)
    <=> v110896(VarCurr) ) ).

tff(addAssignment_66164,axiom,
    ! [VarCurr: state_type] :
      ( v110896(VarCurr)
    <=> v110898(VarCurr) ) ).

tff(addAssignment_66163,axiom,
    ! [VarCurr: state_type] :
      ( v110898(VarCurr)
    <=> v110900(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110981(VarNext)
       => ( v110900(VarNext)
        <=> v110900(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1421,axiom,
    ! [VarNext: state_type] :
      ( v110981(VarNext)
     => ( v110900(VarNext)
      <=> v110991(VarNext) ) ) ).

tff(addAssignment_66162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110991(VarNext)
      <=> v110989(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110992(VarCurr)
     => ( v110989(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_950,axiom,
    ! [VarCurr: state_type] :
      ( v110992(VarCurr)
     => ( v110989(VarCurr)
      <=> v110910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11450,axiom,
    ! [VarCurr: state_type] :
      ( v110992(VarCurr)
    <=> ( v110993(VarCurr)
        & v110994(VarCurr) ) ) ).

tff(writeUnaryOperator_6039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110994(VarCurr)
    <=> v110906(VarCurr) ) ).

tff(writeUnaryOperator_6038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110993(VarCurr)
    <=> v110902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110981(VarNext)
      <=> v110982(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110982(VarNext)
      <=> ( v110983(VarNext)
          & v110976(VarNext) ) ) ) ).

tff(writeUnaryOperator_6037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110983(VarNext)
      <=> v110985(VarNext) ) ) ).

tff(addAssignment_66161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110985(VarNext)
      <=> v110976(VarCurr) ) ) ).

tff(addAssignment_66160,axiom,
    ! [VarCurr: state_type] :
      ( v110976(VarCurr)
    <=> v110978(VarCurr) ) ).

tff(addAssignment_66159,axiom,
    ! [VarCurr: state_type] :
      ( v110978(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_66158,axiom,
    ! [VarCurr: state_type] :
      ( v110910(VarCurr)
    <=> v110912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11447,axiom,
    ! [VarCurr: state_type] :
      ( v110912(VarCurr)
    <=> ( v110968(VarCurr)
        | v110971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11446,axiom,
    ! [VarCurr: state_type] :
      ( v110971(VarCurr)
    <=> ( v110898(VarCurr)
        & v110972(VarCurr) ) ) ).

tff(writeUnaryOperator_6036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110972(VarCurr)
    <=> v110973(VarCurr) ) ).

tff(addAssignment_66157,axiom,
    ! [VarCurr: state_type] :
      ( v110973(VarCurr)
    <=> v110974(VarCurr) ) ).

tff(addAssignment_66156,axiom,
    ! [VarCurr: state_type] :
      ( v110974(VarCurr)
    <=> v110966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11445,axiom,
    ! [VarCurr: state_type] :
      ( v110968(VarCurr)
    <=> ( v110914(VarCurr)
        & v110969(VarCurr) ) ) ).

tff(addAssignment_66155,axiom,
    ! [VarCurr: state_type] :
      ( v110969(VarCurr)
    <=> v110970(VarCurr) ) ).

tff(addAssignment_66154,axiom,
    ! [VarCurr: state_type] :
      ( v110970(VarCurr)
    <=> v110966(VarCurr) ) ).

tff(addAssignment_66153,axiom,
    ! [VarCurr: state_type] :
      ( v110966(VarCurr)
    <=> v3799(VarCurr) ) ).

tff(addAssignment_66152,axiom,
    ! [VarCurr: state_type] :
      ( v110914(VarCurr)
    <=> v110916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11444,axiom,
    ! [VarCurr: state_type] :
      ( v110916(VarCurr)
    <=> ( v2998(VarCurr)
        | v110918(VarCurr) ) ) ).

tff(addAssignment_66151,axiom,
    ! [VarCurr: state_type] :
      ( v110918(VarCurr)
    <=> v110920(VarCurr) ) ).

tff(addAssignment_66150,axiom,
    ! [VarCurr: state_type] :
      ( v110920(VarCurr)
    <=> v110922(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110948(VarNext)
       => ( v110922(VarNext)
        <=> v110922(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1420,axiom,
    ! [VarNext: state_type] :
      ( v110948(VarNext)
     => ( v110922(VarNext)
      <=> v110958(VarNext) ) ) ).

tff(addAssignment_66149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110958(VarNext)
      <=> v110956(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110959(VarCurr)
     => ( v110956(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_949,axiom,
    ! [VarCurr: state_type] :
      ( v110959(VarCurr)
     => ( v110956(VarCurr)
      <=> v110932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11443,axiom,
    ! [VarCurr: state_type] :
      ( v110959(VarCurr)
    <=> ( v110960(VarCurr)
        & v110961(VarCurr) ) ) ).

tff(writeUnaryOperator_6035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110961(VarCurr)
    <=> v110928(VarCurr) ) ).

tff(writeUnaryOperator_6034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110960(VarCurr)
    <=> v110924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110948(VarNext)
      <=> v110949(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110949(VarNext)
      <=> ( v110950(VarNext)
          & v110943(VarNext) ) ) ) ).

tff(writeUnaryOperator_6033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110950(VarNext)
      <=> v110952(VarNext) ) ) ).

tff(addAssignment_66148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110952(VarNext)
      <=> v110943(VarCurr) ) ) ).

tff(addAssignment_66147,axiom,
    ! [VarCurr: state_type] :
      ( v110943(VarCurr)
    <=> v110945(VarCurr) ) ).

tff(addAssignment_66146,axiom,
    ! [VarCurr: state_type] :
      ( v110945(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_66145,axiom,
    ! [VarCurr: state_type] :
      ( v110932(VarCurr)
    <=> v110934(VarCurr) ) ).

tff(addAssignment_66144,axiom,
    ! [VarCurr: state_type] :
      ( v110934(VarCurr)
    <=> v110936(VarCurr) ) ).

tff(addAssignment_66143,axiom,
    ! [VarCurr: state_type] :
      ( v110936(VarCurr)
    <=> v110938(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2998(VarCurr)
     => ( v110938(VarCurr)
      <=> v110940(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_948,axiom,
    ! [VarCurr: state_type] :
      ( v2998(VarCurr)
     => ( v110938(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110941(VarCurr)
     => ( v110940(VarCurr)
      <=> v110918(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_947,axiom,
    ! [VarCurr: state_type] :
      ( v110941(VarCurr)
     => ( v110940(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_922,axiom,
    ! [VarCurr: state_type] :
      ( v110941(VarCurr)
    <=> ( ( v3047(VarCurr,2)
        <=> $true )
        & ( v3047(VarCurr,1)
        <=> $true )
        & ( v3047(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_66142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v3047(VarCurr,B)
      <=> v3049(VarCurr,B) ) ) ).

tff(addAssignment_66141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v3049(VarCurr,B)
      <=> v3051(VarCurr,B) ) ) ).

tff(addAssignment_66140,axiom,
    ! [VarCurr: state_type] :
      ( v110928(VarCurr)
    <=> v110930(VarCurr) ) ).

tff(addAssignment_66139,axiom,
    ! [VarCurr: state_type] :
      ( v110930(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_66138,axiom,
    ! [VarCurr: state_type] :
      ( v110924(VarCurr)
    <=> v110926(VarCurr) ) ).

tff(addAssignment_66137,axiom,
    ! [VarCurr: state_type] :
      ( v110926(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_66136,axiom,
    ! [VarCurr: state_type] :
      ( v110906(VarCurr)
    <=> v110908(VarCurr) ) ).

tff(addAssignment_66135,axiom,
    ! [VarCurr: state_type] :
      ( v110908(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_66134,axiom,
    ! [VarCurr: state_type] :
      ( v110902(VarCurr)
    <=> v110904(VarCurr) ) ).

tff(addAssignment_66133,axiom,
    ! [VarCurr: state_type] :
      ( v110904(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_66132,axiom,
    ! [VarCurr: state_type] :
      ( v110882(VarCurr)
    <=> v110884(VarCurr) ) ).

tff(addAssignment_66131,axiom,
    ! [VarCurr: state_type] :
      ( v110884(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66130,axiom,
    ! [VarCurr: state_type] :
      ( v110878(VarCurr)
    <=> v110880(VarCurr) ) ).

tff(addAssignment_66129,axiom,
    ! [VarCurr: state_type] :
      ( v110880(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66128,axiom,
    ! [VarCurr: state_type] :
      ( v110860(VarCurr)
    <=> v110862(VarCurr) ) ).

tff(addAssignment_66127,axiom,
    ! [VarCurr: state_type] :
      ( v110862(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66126,axiom,
    ! [VarCurr: state_type] :
      ( v110856(VarCurr)
    <=> v110858(VarCurr) ) ).

tff(addAssignment_66125,axiom,
    ! [VarCurr: state_type] :
      ( v110858(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66124,axiom,
    ! [VarCurr: state_type] :
      ( v110840(VarCurr)
    <=> v110842(VarCurr) ) ).

tff(addAssignment_66123,axiom,
    ! [VarCurr: state_type] :
      ( v110842(VarCurr)
    <=> v110844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11440,axiom,
    ! [VarCurr: state_type] :
      ( v110844(VarCurr)
    <=> ( v97325(VarCurr)
        & v110846(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ( v110846(VarCurr)
      <=> v98436(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_60,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ( v110846(VarCurr)
      <=> v97411(VarCurr,15) ) ) ).

tff(addAssignment_66122,axiom,
    ! [VarCurr: state_type] :
      ( v110830(VarCurr)
    <=> v110832(VarCurr) ) ).

tff(addAssignment_66121,axiom,
    ! [VarCurr: state_type] :
      ( v110832(VarCurr)
    <=> v110834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11439,axiom,
    ! [VarCurr: state_type] :
      ( v110834(VarCurr)
    <=> ( v97325(VarCurr)
        & v110836(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ( v110836(VarCurr)
      <=> v110838(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_946,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ( v110836(VarCurr)
      <=> v110837(VarCurr) ) ) ).

tff(writeUnaryOperator_6032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110838(VarCurr)
    <=> v98436(VarCurr) ) ).

tff(writeUnaryOperator_6031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110837(VarCurr)
    <=> v97411(VarCurr,15) ) ).

tff(addAssignment_66120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v101505(VarCurr,B)
      <=> v101507(VarCurr,B) ) ) ).

tff(addAssignment_66119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v101507(VarCurr,B)
      <=> v100229(VarCurr,B) ) ) ).

tff(addAssignment_66118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v103117(VarCurr,B)
      <=> v103119(VarCurr,B) ) ) ).

tff(addAssignment_66117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v103119(VarCurr,B)
      <=> v100445(VarCurr,B) ) ) ).

tff(addAssignment_66116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110754(VarCurr,B)
      <=> v110756(VarCurr,B) ) ) ).

tff(addAssignment_66115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110756(VarCurr,B)
      <=> v110758(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110813(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v110758(VarNext,B)
            <=> v110758(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1419,axiom,
    ! [VarNext: state_type] :
      ( v110813(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v110758(VarNext,B)
          <=> v110823(VarNext,B) ) ) ) ).

tff(addAssignment_66114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v110823(VarNext,B)
          <=> v110821(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v110821(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_945,axiom,
    ! [VarCurr: state_type] :
      ( v110824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v110821(VarCurr,B)
          <=> v110768(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11438,axiom,
    ! [VarCurr: state_type] :
      ( v110824(VarCurr)
    <=> ( v110825(VarCurr)
        & v110826(VarCurr) ) ) ).

tff(writeUnaryOperator_6030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110826(VarCurr)
    <=> v110764(VarCurr) ) ).

tff(writeUnaryOperator_6029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110825(VarCurr)
    <=> v110760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110813(VarNext)
      <=> v110814(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110814(VarNext)
      <=> ( v110815(VarNext)
          & v110808(VarNext) ) ) ) ).

tff(writeUnaryOperator_6028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110815(VarNext)
      <=> v110817(VarNext) ) ) ).

tff(addAssignment_66113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110817(VarNext)
      <=> v110808(VarCurr) ) ) ).

tff(addAssignment_66112,axiom,
    ! [VarCurr: state_type] :
      ( v110808(VarCurr)
    <=> v110810(VarCurr) ) ).

tff(addAssignment_66111,axiom,
    ! [VarCurr: state_type] :
      ( v110810(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110768(VarCurr,B)
      <=> v110770(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110770(VarCurr,B)
      <=> ( v110800(VarCurr,B)
          | v110803(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110803(VarCurr,B)
      <=> ( v110756(VarCurr,B)
          & v110804(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110804(VarCurr,B)
      <=> ~ v110805(VarCurr,B) ) ) ).

tff(addAssignment_66109,axiom,
    ! [VarCurr: state_type] :
      ( v110805(VarCurr,0)
    <=> v110806(VarCurr) ) ).

tff(addAssignment_66108,axiom,
    ! [VarCurr: state_type] :
      ( v110805(VarCurr,1)
    <=> v110806(VarCurr) ) ).

tff(addAssignment_66107,axiom,
    ! [VarCurr: state_type] :
      ( v110805(VarCurr,2)
    <=> v110806(VarCurr) ) ).

tff(addAssignment_66106,axiom,
    ! [VarCurr: state_type] :
      ( v110805(VarCurr,3)
    <=> v110806(VarCurr) ) ).

tff(addAssignment_66105,axiom,
    ! [VarCurr: state_type] :
      ( v110806(VarCurr)
    <=> v110777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v110800(VarCurr,B)
      <=> ( v110772(VarCurr,B)
          & v110801(VarCurr,B) ) ) ) ).

tff(addAssignment_66104,axiom,
    ! [VarCurr: state_type] :
      ( v110801(VarCurr,0)
    <=> v110802(VarCurr) ) ).

tff(addAssignment_66103,axiom,
    ! [VarCurr: state_type] :
      ( v110801(VarCurr,1)
    <=> v110802(VarCurr) ) ).

tff(addAssignment_66102,axiom,
    ! [VarCurr: state_type] :
      ( v110801(VarCurr,2)
    <=> v110802(VarCurr) ) ).

tff(addAssignment_66101,axiom,
    ! [VarCurr: state_type] :
      ( v110801(VarCurr,3)
    <=> v110802(VarCurr) ) ).

tff(addAssignment_66100,axiom,
    ! [VarCurr: state_type] :
      ( v110802(VarCurr)
    <=> v110777(VarCurr) ) ).

tff(addAssignment_66099,axiom,
    ! [VarCurr: state_type] :
      ( v110777(VarCurr)
    <=> v110779(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4625,axiom,
    ! [VarCurr: state_type] :
      ( v110779(VarCurr)
    <=> ( v110785(VarCurr)
        | v110781(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4624,axiom,
    ! [VarCurr: state_type] :
      ( v110785(VarCurr)
    <=> ( v110786(VarCurr)
        | v110781(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4623,axiom,
    ! [VarCurr: state_type] :
      ( v110786(VarCurr)
    <=> ( v110787(VarCurr)
        | v110781(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4622,axiom,
    ! [VarCurr: state_type] :
      ( v110787(VarCurr)
    <=> ( v110788(VarCurr)
        | v110781(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4621,axiom,
    ! [VarCurr: state_type] :
      ( v110788(VarCurr)
    <=> ( v110789(VarCurr)
        | v110781(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4620,axiom,
    ! [VarCurr: state_type] :
      ( v110789(VarCurr)
    <=> ( v110790(VarCurr)
        | v110781(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4619,axiom,
    ! [VarCurr: state_type] :
      ( v110790(VarCurr)
    <=> ( v110791(VarCurr)
        | v110781(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4618,axiom,
    ! [VarCurr: state_type] :
      ( v110791(VarCurr)
    <=> ( v110792(VarCurr)
        | v110781(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4617,axiom,
    ! [VarCurr: state_type] :
      ( v110792(VarCurr)
    <=> ( v110793(VarCurr)
        | v110781(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4616,axiom,
    ! [VarCurr: state_type] :
      ( v110793(VarCurr)
    <=> ( v110794(VarCurr)
        | v110781(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4615,axiom,
    ! [VarCurr: state_type] :
      ( v110794(VarCurr)
    <=> ( v110795(VarCurr)
        | v110781(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4614,axiom,
    ! [VarCurr: state_type] :
      ( v110795(VarCurr)
    <=> ( v110796(VarCurr)
        | v110781(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4613,axiom,
    ! [VarCurr: state_type] :
      ( v110796(VarCurr)
    <=> ( v110797(VarCurr)
        | v110781(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4612,axiom,
    ! [VarCurr: state_type] :
      ( v110797(VarCurr)
    <=> ( v110798(VarCurr)
        | v110781(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4611,axiom,
    ! [VarCurr: state_type] :
      ( v110798(VarCurr)
    <=> ( v110781(VarCurr,0)
        | v110781(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110781(VarCurr,B)
      <=> ( v116(VarCurr,B)
          | v110583(VarCurr,B) ) ) ) ).

tff(addAssignment_66098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110772(VarCurr,B)
      <=> v101592(VarCurr,B) ) ) ).

tff(addAssignment_66097,axiom,
    ! [VarCurr: state_type] :
      ( v110772(VarCurr,3)
    <=> v110774(VarCurr) ) ).

tff(addAssignment_66096,axiom,
    ! [VarCurr: state_type] :
      ( v110774(VarCurr)
    <=> v101594(VarCurr,6) ) ).

tff(addAssignment_66095,axiom,
    ! [VarCurr: state_type] :
      ( v101594(VarCurr,6)
    <=> v102053(VarCurr,6) ) ).

tff(addAssignment_66094,axiom,
    ! [VarCurr: state_type] :
      ( v101596(VarCurr,6)
    <=> v102037(VarCurr,6) ) ).

tff(addAssignment_66093,axiom,
    ! [VarCurr: state_type] :
      ( v102024(VarCurr,6)
    <=> v102025(VarCurr,6) ) ).

tff(addAssignment_66092,axiom,
    ! [VarCurr: state_type] :
      ( v89243(VarCurr,7)
    <=> v89245(VarCurr,7) ) ).

tff(addAssignment_66091,axiom,
    ! [VarCurr: state_type] :
      ( v89245(VarCurr,7)
    <=> v89247(VarCurr,7) ) ).

tff(addAssignment_66090,axiom,
    ! [VarCurr: state_type] :
      ( v89214(VarCurr,7)
    <=> v89216(VarCurr,7) ) ).

tff(addAssignment_66089,axiom,
    ! [VarCurr: state_type] :
      ( v89216(VarCurr,7)
    <=> v89218(VarCurr,7) ) ).

tff(addAssignment_66088,axiom,
    ! [VarCurr: state_type] :
      ( v101563(VarCurr,7)
    <=> v101565(VarCurr,7) ) ).

tff(addAssignment_66087,axiom,
    ! [VarCurr: state_type] :
      ( v101565(VarCurr,7)
    <=> v101567(VarCurr,7) ) ).

tff(addAssignment_66086,axiom,
    ! [VarCurr: state_type] :
      ( v101567(VarCurr,7)
    <=> v101568(VarCurr,7) ) ).

tff(addAssignment_66085,axiom,
    ! [VarCurr: state_type] :
      ( v110764(VarCurr)
    <=> v110766(VarCurr) ) ).

tff(addAssignment_66084,axiom,
    ! [VarCurr: state_type] :
      ( v110766(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66083,axiom,
    ! [VarCurr: state_type] :
      ( v110760(VarCurr)
    <=> v110762(VarCurr) ) ).

tff(addAssignment_66082,axiom,
    ! [VarCurr: state_type] :
      ( v110762(VarCurr)
    <=> v18(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ( v108869(VarCurr)
      <=> v108893(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_944,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ( v108869(VarCurr)
      <=> v108871(VarCurr) ) ) ).

tff(addAssignment_66081,axiom,
    ! [VarCurr: state_type] :
      ( v108871(VarCurr)
    <=> v108873(VarCurr,0) ) ).

tff(addAssignment_66080,axiom,
    ! [VarCurr: state_type] :
      ( v108873(VarCurr,0)
    <=> v108875(VarCurr,0) ) ).

tff(addAssignment_66079,axiom,
    ! [VarNext: state_type] :
      ( v108875(VarNext,0)
    <=> v110745(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110746(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v110745(VarNext,B)
            <=> v108875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1418,axiom,
    ! [VarNext: state_type] :
      ( v110746(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110745(VarNext,B)
          <=> v110730(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110746(VarNext)
      <=> v110747(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110747(VarNext)
      <=> ( v110749(VarNext)
          & v110715(VarNext) ) ) ) ).

tff(writeUnaryOperator_6026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110749(VarNext)
      <=> v110724(VarNext) ) ) ).

tff(addAssignment_66078,axiom,
    ! [VarCurr: state_type] :
      ( v108885(VarCurr,0)
    <=> v108887(VarCurr,0) ) ).

tff(addAssignment_66077,axiom,
    ! [VarCurr: state_type] :
      ( v108887(VarCurr,0)
    <=> v108889(VarCurr,0) ) ).

tff(addAssignment_66076,axiom,
    ! [VarCurr: state_type] :
      ( v108889(VarCurr,0)
    <=> v110713(VarCurr,0) ) ).

tff(addAssignment_66075,axiom,
    ! [VarCurr: state_type] :
      ( v108891(VarCurr)
    <=> v108873(VarCurr,1) ) ).

tff(addAssignment_66074,axiom,
    ! [VarCurr: state_type] :
      ( v108873(VarCurr,1)
    <=> v108875(VarCurr,1) ) ).

tff(addAssignment_66073,axiom,
    ! [VarNext: state_type] :
      ( v108875(VarNext,1)
    <=> v110737(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110738(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v110737(VarNext,B)
            <=> v108875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1417,axiom,
    ! [VarNext: state_type] :
      ( v110738(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110737(VarNext,B)
          <=> v110730(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110738(VarNext)
      <=> v110739(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110739(VarNext)
      <=> ( v110741(VarNext)
          & v110715(VarNext) ) ) ) ).

tff(writeUnaryOperator_6025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110741(VarNext)
      <=> v110724(VarNext) ) ) ).

tff(addAssignment_66072,axiom,
    ! [VarCurr: state_type] :
      ( v108885(VarCurr,1)
    <=> v108887(VarCurr,1) ) ).

tff(addAssignment_66071,axiom,
    ! [VarCurr: state_type] :
      ( v108887(VarCurr,1)
    <=> v108889(VarCurr,1) ) ).

tff(addAssignment_66070,axiom,
    ! [VarCurr: state_type] :
      ( v108889(VarCurr,1)
    <=> v110713(VarCurr,1) ) ).

tff(addAssignment_66069,axiom,
    ! [VarCurr: state_type] :
      ( v108893(VarCurr)
    <=> v108873(VarCurr,2) ) ).

tff(addAssignment_66068,axiom,
    ! [VarCurr: state_type] :
      ( v108873(VarCurr,2)
    <=> v108875(VarCurr,2) ) ).

tff(addAssignment_66067,axiom,
    ! [VarNext: state_type] :
      ( v108875(VarNext,2)
    <=> v110719(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110720(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v110719(VarNext,B)
            <=> v108875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1416,axiom,
    ! [VarNext: state_type] :
      ( v110720(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110719(VarNext,B)
          <=> v110730(VarNext,B) ) ) ) ).

tff(addAssignment_66066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110730(VarNext,B)
          <=> v110728(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110731(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110728(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_943,axiom,
    ! [VarCurr: state_type] :
      ( v110731(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v110728(VarCurr,B)
          <=> v108885(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11431,axiom,
    ! [VarCurr: state_type] :
      ( v110731(VarCurr)
    <=> ( v110732(VarCurr)
        & v110733(VarCurr) ) ) ).

tff(writeUnaryOperator_6024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110733(VarCurr)
    <=> v108881(VarCurr) ) ).

tff(writeUnaryOperator_6023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110732(VarCurr)
    <=> v108877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110720(VarNext)
      <=> v110721(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110721(VarNext)
      <=> ( v110722(VarNext)
          & v110715(VarNext) ) ) ) ).

tff(writeUnaryOperator_6022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110722(VarNext)
      <=> v110724(VarNext) ) ) ).

tff(addAssignment_66065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110724(VarNext)
      <=> v110715(VarCurr) ) ) ).

tff(addAssignment_66064,axiom,
    ! [VarCurr: state_type] :
      ( v110715(VarCurr)
    <=> v110717(VarCurr) ) ).

tff(addAssignment_66063,axiom,
    ! [VarCurr: state_type] :
      ( v110717(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66062,axiom,
    ! [VarCurr: state_type] :
      ( v108885(VarCurr,2)
    <=> v108887(VarCurr,2) ) ).

tff(addAssignment_66061,axiom,
    ! [VarCurr: state_type] :
      ( v108887(VarCurr,2)
    <=> v108889(VarCurr,2) ) ).

tff(addAssignment_66060,axiom,
    ! [VarCurr: state_type] :
      ( v108889(VarCurr,2)
    <=> v110713(VarCurr,2) ) ).

tff(addAssignment_66059,axiom,
    ! [VarCurr: state_type] :
      ( v110713(VarCurr,0)
    <=> v108891(VarCurr) ) ).

tff(addAssignment_66058,axiom,
    ! [VarCurr: state_type] :
      ( v110713(VarCurr,1)
    <=> v108893(VarCurr) ) ).

tff(addAssignment_66057,axiom,
    ! [VarCurr: state_type] :
      ( v110713(VarCurr,2)
    <=> v108895(VarCurr) ) ).

tff(addAssignment_66056,axiom,
    ! [VarCurr: state_type] :
      ( v108895(VarCurr)
    <=> v108897(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4610,axiom,
    ! [VarCurr: state_type] :
      ( v108897(VarCurr)
    <=> ( v110699(VarCurr)
        | v108899(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4609,axiom,
    ! [VarCurr: state_type] :
      ( v110699(VarCurr)
    <=> ( v110700(VarCurr)
        | v108899(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4608,axiom,
    ! [VarCurr: state_type] :
      ( v110700(VarCurr)
    <=> ( v110701(VarCurr)
        | v108899(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4607,axiom,
    ! [VarCurr: state_type] :
      ( v110701(VarCurr)
    <=> ( v110702(VarCurr)
        | v108899(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4606,axiom,
    ! [VarCurr: state_type] :
      ( v110702(VarCurr)
    <=> ( v110703(VarCurr)
        | v108899(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4605,axiom,
    ! [VarCurr: state_type] :
      ( v110703(VarCurr)
    <=> ( v110704(VarCurr)
        | v108899(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4604,axiom,
    ! [VarCurr: state_type] :
      ( v110704(VarCurr)
    <=> ( v110705(VarCurr)
        | v108899(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4603,axiom,
    ! [VarCurr: state_type] :
      ( v110705(VarCurr)
    <=> ( v110706(VarCurr)
        | v108899(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4602,axiom,
    ! [VarCurr: state_type] :
      ( v110706(VarCurr)
    <=> ( v110707(VarCurr)
        | v108899(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4601,axiom,
    ! [VarCurr: state_type] :
      ( v110707(VarCurr)
    <=> ( v110708(VarCurr)
        | v108899(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4600,axiom,
    ! [VarCurr: state_type] :
      ( v110708(VarCurr)
    <=> ( v110709(VarCurr)
        | v108899(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4599,axiom,
    ! [VarCurr: state_type] :
      ( v110709(VarCurr)
    <=> ( v110710(VarCurr)
        | v108899(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4598,axiom,
    ! [VarCurr: state_type] :
      ( v110710(VarCurr)
    <=> ( v110711(VarCurr)
        | v108899(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4597,axiom,
    ! [VarCurr: state_type] :
      ( v110711(VarCurr)
    <=> ( v110712(VarCurr)
        | v108899(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4596,axiom,
    ! [VarCurr: state_type] :
      ( v110712(VarCurr)
    <=> ( v108899(VarCurr,0)
        | v108899(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108899(VarCurr,B)
      <=> ( v108901(VarCurr,B)
          | v110563(VarCurr,B) ) ) ) ).

tff(addAssignment_66055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110563(VarCurr,B)
      <=> v110565(VarCurr,B) ) ) ).

tff(addAssignment_66054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110565(VarCurr,B)
      <=> v110567(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110680(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v110567(VarNext,B)
            <=> v110567(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1415,axiom,
    ! [VarNext: state_type] :
      ( v110680(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110567(VarNext,B)
          <=> v110690(VarNext,B) ) ) ) ).

tff(addAssignment_66053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110690(VarNext,B)
          <=> v110688(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110691(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110688(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_942,axiom,
    ! [VarCurr: state_type] :
      ( v110691(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110688(VarCurr,B)
          <=> v110577(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11428,axiom,
    ! [VarCurr: state_type] :
      ( v110691(VarCurr)
    <=> ( v110692(VarCurr)
        & v110693(VarCurr) ) ) ).

tff(writeUnaryOperator_6021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110693(VarCurr)
    <=> v110573(VarCurr) ) ).

tff(writeUnaryOperator_6020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110692(VarCurr)
    <=> v110569(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110680(VarNext)
      <=> v110681(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110681(VarNext)
      <=> ( v110682(VarNext)
          & v110675(VarNext) ) ) ) ).

tff(writeUnaryOperator_6019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110682(VarNext)
      <=> v110684(VarNext) ) ) ).

tff(addAssignment_66052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110684(VarNext)
      <=> v110675(VarCurr) ) ) ).

tff(addAssignment_66051,axiom,
    ! [VarCurr: state_type] :
      ( v110675(VarCurr)
    <=> v110677(VarCurr) ) ).

tff(addAssignment_66050,axiom,
    ! [VarCurr: state_type] :
      ( v110677(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_66049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110577(VarCurr,B)
      <=> v110579(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110579(VarCurr,B)
      <=> ( v110667(VarCurr,B)
          | v110670(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110670(VarCurr,B)
      <=> ( v110565(VarCurr,B)
          & v110671(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110671(VarCurr,B)
      <=> ~ v110672(VarCurr,B) ) ) ).

tff(addAssignment_66048,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,0)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66047,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,1)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66046,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,2)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66045,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,3)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66044,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,4)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66043,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,5)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66042,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,6)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66041,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,7)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66040,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,8)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66039,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,9)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66038,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,10)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66037,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,11)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66036,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,12)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66035,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,13)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66034,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,14)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66033,axiom,
    ! [VarCurr: state_type] :
      ( v110672(VarCurr,15)
    <=> v110673(VarCurr) ) ).

tff(addAssignment_66032,axiom,
    ! [VarCurr: state_type] :
      ( v110673(VarCurr)
    <=> v110665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110667(VarCurr,B)
      <=> ( v110581(VarCurr,B)
          & v110668(VarCurr,B) ) ) ) ).

tff(addAssignment_66031,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,0)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66030,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,1)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66029,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,2)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66028,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,3)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66027,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,4)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66026,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,5)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66025,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,6)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66024,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,7)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66023,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,8)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66022,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,9)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66021,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,10)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66020,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,11)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66019,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,12)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66018,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,13)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66017,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,14)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66016,axiom,
    ! [VarCurr: state_type] :
      ( v110668(VarCurr,15)
    <=> v110669(VarCurr) ) ).

tff(addAssignment_66015,axiom,
    ! [VarCurr: state_type] :
      ( v110669(VarCurr)
    <=> v110665(VarCurr) ) ).

tff(addAssignment_66014,axiom,
    ! [VarCurr: state_type] :
      ( v110665(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_66013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110581(VarCurr,B)
      <=> v110583(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4595,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,15)
    <=> ( v110660(VarCurr)
        | v110662(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11425,axiom,
    ! [VarCurr: state_type] :
      ( v110662(VarCurr)
    <=> ( v103113(VarCurr)
        & v110663(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_921,axiom,
    ! [VarCurr: state_type] :
      ( v110663(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11424,axiom,
    ! [VarCurr: state_type] :
      ( v110660(VarCurr)
    <=> ( v103096(VarCurr)
        & v110661(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_920,axiom,
    ! [VarCurr: state_type] :
      ( v110661(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4594,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,14)
    <=> ( v110655(VarCurr)
        | v110657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11423,axiom,
    ! [VarCurr: state_type] :
      ( v110657(VarCurr)
    <=> ( v103113(VarCurr)
        & v110658(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_919,axiom,
    ! [VarCurr: state_type] :
      ( v110658(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11422,axiom,
    ! [VarCurr: state_type] :
      ( v110655(VarCurr)
    <=> ( v103096(VarCurr)
        & v110656(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_918,axiom,
    ! [VarCurr: state_type] :
      ( v110656(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4593,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,13)
    <=> ( v110650(VarCurr)
        | v110652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11421,axiom,
    ! [VarCurr: state_type] :
      ( v110652(VarCurr)
    <=> ( v103113(VarCurr)
        & v110653(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_917,axiom,
    ! [VarCurr: state_type] :
      ( v110653(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11420,axiom,
    ! [VarCurr: state_type] :
      ( v110650(VarCurr)
    <=> ( v103096(VarCurr)
        & v110651(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_916,axiom,
    ! [VarCurr: state_type] :
      ( v110651(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4592,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,12)
    <=> ( v110645(VarCurr)
        | v110647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11419,axiom,
    ! [VarCurr: state_type] :
      ( v110647(VarCurr)
    <=> ( v103113(VarCurr)
        & v110648(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_915,axiom,
    ! [VarCurr: state_type] :
      ( v110648(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11418,axiom,
    ! [VarCurr: state_type] :
      ( v110645(VarCurr)
    <=> ( v103096(VarCurr)
        & v110646(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_914,axiom,
    ! [VarCurr: state_type] :
      ( v110646(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4591,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,11)
    <=> ( v110640(VarCurr)
        | v110642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11417,axiom,
    ! [VarCurr: state_type] :
      ( v110642(VarCurr)
    <=> ( v103113(VarCurr)
        & v110643(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_913,axiom,
    ! [VarCurr: state_type] :
      ( v110643(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11416,axiom,
    ! [VarCurr: state_type] :
      ( v110640(VarCurr)
    <=> ( v103096(VarCurr)
        & v110641(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_912,axiom,
    ! [VarCurr: state_type] :
      ( v110641(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4590,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,10)
    <=> ( v110635(VarCurr)
        | v110637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11415,axiom,
    ! [VarCurr: state_type] :
      ( v110637(VarCurr)
    <=> ( v103113(VarCurr)
        & v110638(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_911,axiom,
    ! [VarCurr: state_type] :
      ( v110638(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11414,axiom,
    ! [VarCurr: state_type] :
      ( v110635(VarCurr)
    <=> ( v103096(VarCurr)
        & v110636(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_910,axiom,
    ! [VarCurr: state_type] :
      ( v110636(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4589,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,9)
    <=> ( v110630(VarCurr)
        | v110632(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11413,axiom,
    ! [VarCurr: state_type] :
      ( v110632(VarCurr)
    <=> ( v103113(VarCurr)
        & v110633(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_909,axiom,
    ! [VarCurr: state_type] :
      ( v110633(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11412,axiom,
    ! [VarCurr: state_type] :
      ( v110630(VarCurr)
    <=> ( v103096(VarCurr)
        & v110631(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_908,axiom,
    ! [VarCurr: state_type] :
      ( v110631(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4588,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,8)
    <=> ( v110625(VarCurr)
        | v110627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11411,axiom,
    ! [VarCurr: state_type] :
      ( v110627(VarCurr)
    <=> ( v103113(VarCurr)
        & v110628(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_907,axiom,
    ! [VarCurr: state_type] :
      ( v110628(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $true )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11410,axiom,
    ! [VarCurr: state_type] :
      ( v110625(VarCurr)
    <=> ( v103096(VarCurr)
        & v110626(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_906,axiom,
    ! [VarCurr: state_type] :
      ( v110626(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $true )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4587,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,7)
    <=> ( v110620(VarCurr)
        | v110622(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11409,axiom,
    ! [VarCurr: state_type] :
      ( v110622(VarCurr)
    <=> ( v103113(VarCurr)
        & v110623(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_905,axiom,
    ! [VarCurr: state_type] :
      ( v110623(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11408,axiom,
    ! [VarCurr: state_type] :
      ( v110620(VarCurr)
    <=> ( v103096(VarCurr)
        & v110621(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_904,axiom,
    ! [VarCurr: state_type] :
      ( v110621(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4586,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,6)
    <=> ( v110615(VarCurr)
        | v110617(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11407,axiom,
    ! [VarCurr: state_type] :
      ( v110617(VarCurr)
    <=> ( v103113(VarCurr)
        & v110618(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_903,axiom,
    ! [VarCurr: state_type] :
      ( v110618(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11406,axiom,
    ! [VarCurr: state_type] :
      ( v110615(VarCurr)
    <=> ( v103096(VarCurr)
        & v110616(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_902,axiom,
    ! [VarCurr: state_type] :
      ( v110616(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4585,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,5)
    <=> ( v110610(VarCurr)
        | v110612(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11405,axiom,
    ! [VarCurr: state_type] :
      ( v110612(VarCurr)
    <=> ( v103113(VarCurr)
        & v110613(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_901,axiom,
    ! [VarCurr: state_type] :
      ( v110613(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11404,axiom,
    ! [VarCurr: state_type] :
      ( v110610(VarCurr)
    <=> ( v103096(VarCurr)
        & v110611(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_900,axiom,
    ! [VarCurr: state_type] :
      ( v110611(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4584,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,4)
    <=> ( v110605(VarCurr)
        | v110607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11403,axiom,
    ! [VarCurr: state_type] :
      ( v110607(VarCurr)
    <=> ( v103113(VarCurr)
        & v110608(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_899,axiom,
    ! [VarCurr: state_type] :
      ( v110608(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $true )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11402,axiom,
    ! [VarCurr: state_type] :
      ( v110605(VarCurr)
    <=> ( v103096(VarCurr)
        & v110606(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_898,axiom,
    ! [VarCurr: state_type] :
      ( v110606(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $true )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4583,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,3)
    <=> ( v110600(VarCurr)
        | v110602(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11401,axiom,
    ! [VarCurr: state_type] :
      ( v110602(VarCurr)
    <=> ( v103113(VarCurr)
        & v110603(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_897,axiom,
    ! [VarCurr: state_type] :
      ( v110603(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11400,axiom,
    ! [VarCurr: state_type] :
      ( v110600(VarCurr)
    <=> ( v103096(VarCurr)
        & v110601(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_896,axiom,
    ! [VarCurr: state_type] :
      ( v110601(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4582,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,2)
    <=> ( v110595(VarCurr)
        | v110597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11399,axiom,
    ! [VarCurr: state_type] :
      ( v110597(VarCurr)
    <=> ( v103113(VarCurr)
        & v110598(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_895,axiom,
    ! [VarCurr: state_type] :
      ( v110598(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $true )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11398,axiom,
    ! [VarCurr: state_type] :
      ( v110595(VarCurr)
    <=> ( v103096(VarCurr)
        & v110596(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_894,axiom,
    ! [VarCurr: state_type] :
      ( v110596(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $true )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4581,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,1)
    <=> ( v110590(VarCurr)
        | v110592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11397,axiom,
    ! [VarCurr: state_type] :
      ( v110592(VarCurr)
    <=> ( v103113(VarCurr)
        & v110593(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_893,axiom,
    ! [VarCurr: state_type] :
      ( v110593(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11396,axiom,
    ! [VarCurr: state_type] :
      ( v110590(VarCurr)
    <=> ( v103096(VarCurr)
        & v110591(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_892,axiom,
    ! [VarCurr: state_type] :
      ( v110591(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11395,axiom,
    ! [VarCurr: state_type] :
      ( v110583(VarCurr,0)
    <=> ( v110585(VarCurr)
        | v110587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11394,axiom,
    ! [VarCurr: state_type] :
      ( v110587(VarCurr)
    <=> ( v103113(VarCurr)
        & v110588(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_891,axiom,
    ! [VarCurr: state_type] :
      ( v110588(VarCurr)
    <=> ( ( v103127(VarCurr,3)
        <=> $false )
        & ( v103127(VarCurr,2)
        <=> $false )
        & ( v103127(VarCurr,1)
        <=> $false )
        & ( v103127(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11393,axiom,
    ! [VarCurr: state_type] :
      ( v110585(VarCurr)
    <=> ( v103096(VarCurr)
        & v110586(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_890,axiom,
    ! [VarCurr: state_type] :
      ( v110586(VarCurr)
    <=> ( ( v103106(VarCurr,3)
        <=> $false )
        & ( v103106(VarCurr,2)
        <=> $false )
        & ( v103106(VarCurr,1)
        <=> $false )
        & ( v103106(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_66012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103127(VarCurr,B)
      <=> v103129(VarCurr,B) ) ) ).

tff(addAssignment_66011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103129(VarCurr,B)
      <=> v103131(VarCurr,B) ) ) ).

tff(addAssignment_66010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103131(VarCurr,B)
      <=> v103132(VarCurr,B) ) ) ).

tff(addAssignment_66009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103106(VarCurr,B)
      <=> v103108(VarCurr,B) ) ) ).

tff(addAssignment_66008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103108(VarCurr,B)
      <=> v103110(VarCurr,B) ) ) ).

tff(addAssignment_66007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103110(VarCurr,B)
      <=> v103111(VarCurr,B) ) ) ).

tff(addAssignment_66006,axiom,
    ! [VarCurr: state_type] :
      ( v110573(VarCurr)
    <=> v110575(VarCurr) ) ).

tff(addAssignment_66005,axiom,
    ! [VarCurr: state_type] :
      ( v110575(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_66004,axiom,
    ! [VarCurr: state_type] :
      ( v110569(VarCurr)
    <=> v110571(VarCurr) ) ).

tff(addAssignment_66003,axiom,
    ! [VarCurr: state_type] :
      ( v110571(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_66002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108901(VarCurr,B)
      <=> v108903(VarCurr,B) ) ) ).

tff(addAssignment_66001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108903(VarCurr,B)
      <=> v108905(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110546(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v108905(VarNext,B)
            <=> v108905(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1414,axiom,
    ! [VarNext: state_type] :
      ( v110546(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v108905(VarNext,B)
          <=> v110556(VarNext,B) ) ) ) ).

tff(addAssignment_66000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110556(VarNext,B)
          <=> v110554(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110557(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110554(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_941,axiom,
    ! [VarCurr: state_type] :
      ( v110557(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v110554(VarCurr,B)
          <=> v108915(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11392,axiom,
    ! [VarCurr: state_type] :
      ( v110557(VarCurr)
    <=> ( v110558(VarCurr)
        & v110559(VarCurr) ) ) ).

tff(writeUnaryOperator_6017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110559(VarCurr)
    <=> v108911(VarCurr) ) ).

tff(writeUnaryOperator_6016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110558(VarCurr)
    <=> v108907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110546(VarNext)
      <=> v110547(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110547(VarNext)
      <=> ( v110548(VarNext)
          & v110541(VarNext) ) ) ) ).

tff(writeUnaryOperator_6015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110548(VarNext)
      <=> v110550(VarNext) ) ) ).

tff(addAssignment_65999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110550(VarNext)
      <=> v110541(VarCurr) ) ) ).

tff(addAssignment_65998,axiom,
    ! [VarCurr: state_type] :
      ( v110541(VarCurr)
    <=> v110543(VarCurr) ) ).

tff(addAssignment_65997,axiom,
    ! [VarCurr: state_type] :
      ( v110543(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_65996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108915(VarCurr,B)
      <=> v108917(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108917(VarCurr,B)
      <=> ( v110533(VarCurr,B)
          | v110536(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110536(VarCurr,B)
      <=> ( v108903(VarCurr,B)
          & v110537(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_6014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110537(VarCurr,B)
      <=> ~ v110538(VarCurr,B) ) ) ).

tff(addAssignment_65995,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,0)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65994,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,1)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65993,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,2)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65992,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,3)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65991,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,4)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65990,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,5)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65989,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,6)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65988,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,7)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65987,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,8)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65986,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,9)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65985,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,10)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65984,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,11)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65983,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,12)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65982,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,13)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65981,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,14)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65980,axiom,
    ! [VarCurr: state_type] :
      ( v110538(VarCurr,15)
    <=> v110539(VarCurr) ) ).

tff(addAssignment_65979,axiom,
    ! [VarCurr: state_type] :
      ( v110539(VarCurr)
    <=> v110531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110533(VarCurr,B)
      <=> ( v108919(VarCurr,B)
          & v110534(VarCurr,B) ) ) ) ).

tff(addAssignment_65978,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,0)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65977,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,1)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65976,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,2)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65975,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,3)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65974,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,4)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65973,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,5)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65972,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,6)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65971,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,7)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65970,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,8)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65969,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,9)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65968,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,10)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65967,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,11)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65966,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,12)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65965,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,13)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65964,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,14)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65963,axiom,
    ! [VarCurr: state_type] :
      ( v110534(VarCurr,15)
    <=> v110535(VarCurr) ) ).

tff(addAssignment_65962,axiom,
    ! [VarCurr: state_type] :
      ( v110535(VarCurr)
    <=> v110531(VarCurr) ) ).

tff(addAssignment_65961,axiom,
    ! [VarCurr: state_type] :
      ( v110531(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_65960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108919(VarCurr,B)
      <=> v116(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4580,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,15)
    <=> ( v110518(VarCurr)
        | v110528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4579,axiom,
    ! [VarCurr: state_type] :
      ( v110528(VarCurr)
    <=> ( v110529(VarCurr)
        & v109659(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11389,axiom,
    ! [VarCurr: state_type] :
      ( v110529(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11388,axiom,
    ! [VarCurr: state_type] :
      ( v110518(VarCurr)
    <=> ( v110519(VarCurr)
        | v110527(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4578,axiom,
    ! [VarCurr: state_type] :
      ( v110527(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11387,axiom,
    ! [VarCurr: state_type] :
      ( v110519(VarCurr)
    <=> ( v110520(VarCurr)
        | v110525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11386,axiom,
    ! [VarCurr: state_type] :
      ( v110525(VarCurr)
    <=> ( v101501(VarCurr)
        & v110526(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_889,axiom,
    ! [VarCurr: state_type] :
      ( v110526(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11385,axiom,
    ! [VarCurr: state_type] :
      ( v110520(VarCurr)
    <=> ( v110521(VarCurr)
        | v110523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11384,axiom,
    ! [VarCurr: state_type] :
      ( v110523(VarCurr)
    <=> ( v84899(VarCurr)
        & v110524(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_888,axiom,
    ! [VarCurr: state_type] :
      ( v110524(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11383,axiom,
    ! [VarCurr: state_type] :
      ( v110521(VarCurr)
    <=> ( v118(VarCurr)
        & v110522(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_887,axiom,
    ! [VarCurr: state_type] :
      ( v110522(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4577,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,14)
    <=> ( v110505(VarCurr)
        | v110515(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4576,axiom,
    ! [VarCurr: state_type] :
      ( v110515(VarCurr)
    <=> ( v110516(VarCurr)
        & v109659(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11382,axiom,
    ! [VarCurr: state_type] :
      ( v110516(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11381,axiom,
    ! [VarCurr: state_type] :
      ( v110505(VarCurr)
    <=> ( v110506(VarCurr)
        | v110514(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4575,axiom,
    ! [VarCurr: state_type] :
      ( v110514(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11380,axiom,
    ! [VarCurr: state_type] :
      ( v110506(VarCurr)
    <=> ( v110507(VarCurr)
        | v110512(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11379,axiom,
    ! [VarCurr: state_type] :
      ( v110512(VarCurr)
    <=> ( v101501(VarCurr)
        & v110513(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_886,axiom,
    ! [VarCurr: state_type] :
      ( v110513(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11378,axiom,
    ! [VarCurr: state_type] :
      ( v110507(VarCurr)
    <=> ( v110508(VarCurr)
        | v110510(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11377,axiom,
    ! [VarCurr: state_type] :
      ( v110510(VarCurr)
    <=> ( v84899(VarCurr)
        & v110511(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_885,axiom,
    ! [VarCurr: state_type] :
      ( v110511(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11376,axiom,
    ! [VarCurr: state_type] :
      ( v110508(VarCurr)
    <=> ( v118(VarCurr)
        & v110509(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_884,axiom,
    ! [VarCurr: state_type] :
      ( v110509(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4574,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,13)
    <=> ( v110492(VarCurr)
        | v110502(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4573,axiom,
    ! [VarCurr: state_type] :
      ( v110502(VarCurr)
    <=> ( v110503(VarCurr)
        & v109659(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11375,axiom,
    ! [VarCurr: state_type] :
      ( v110503(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11374,axiom,
    ! [VarCurr: state_type] :
      ( v110492(VarCurr)
    <=> ( v110493(VarCurr)
        | v110501(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4572,axiom,
    ! [VarCurr: state_type] :
      ( v110501(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11373,axiom,
    ! [VarCurr: state_type] :
      ( v110493(VarCurr)
    <=> ( v110494(VarCurr)
        | v110499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11372,axiom,
    ! [VarCurr: state_type] :
      ( v110499(VarCurr)
    <=> ( v101501(VarCurr)
        & v110500(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_883,axiom,
    ! [VarCurr: state_type] :
      ( v110500(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11371,axiom,
    ! [VarCurr: state_type] :
      ( v110494(VarCurr)
    <=> ( v110495(VarCurr)
        | v110497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11370,axiom,
    ! [VarCurr: state_type] :
      ( v110497(VarCurr)
    <=> ( v84899(VarCurr)
        & v110498(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_882,axiom,
    ! [VarCurr: state_type] :
      ( v110498(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11369,axiom,
    ! [VarCurr: state_type] :
      ( v110495(VarCurr)
    <=> ( v118(VarCurr)
        & v110496(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_881,axiom,
    ! [VarCurr: state_type] :
      ( v110496(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4571,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,12)
    <=> ( v110479(VarCurr)
        | v110489(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4570,axiom,
    ! [VarCurr: state_type] :
      ( v110489(VarCurr)
    <=> ( v110490(VarCurr)
        & v109659(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11368,axiom,
    ! [VarCurr: state_type] :
      ( v110490(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11367,axiom,
    ! [VarCurr: state_type] :
      ( v110479(VarCurr)
    <=> ( v110480(VarCurr)
        | v110488(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4569,axiom,
    ! [VarCurr: state_type] :
      ( v110488(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11366,axiom,
    ! [VarCurr: state_type] :
      ( v110480(VarCurr)
    <=> ( v110481(VarCurr)
        | v110486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11365,axiom,
    ! [VarCurr: state_type] :
      ( v110486(VarCurr)
    <=> ( v101501(VarCurr)
        & v110487(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_880,axiom,
    ! [VarCurr: state_type] :
      ( v110487(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11364,axiom,
    ! [VarCurr: state_type] :
      ( v110481(VarCurr)
    <=> ( v110482(VarCurr)
        | v110484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11363,axiom,
    ! [VarCurr: state_type] :
      ( v110484(VarCurr)
    <=> ( v84899(VarCurr)
        & v110485(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_879,axiom,
    ! [VarCurr: state_type] :
      ( v110485(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11362,axiom,
    ! [VarCurr: state_type] :
      ( v110482(VarCurr)
    <=> ( v118(VarCurr)
        & v110483(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_878,axiom,
    ! [VarCurr: state_type] :
      ( v110483(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4568,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,11)
    <=> ( v110466(VarCurr)
        | v110476(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4567,axiom,
    ! [VarCurr: state_type] :
      ( v110476(VarCurr)
    <=> ( v110477(VarCurr)
        & v109659(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11361,axiom,
    ! [VarCurr: state_type] :
      ( v110477(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11360,axiom,
    ! [VarCurr: state_type] :
      ( v110466(VarCurr)
    <=> ( v110467(VarCurr)
        | v110475(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4566,axiom,
    ! [VarCurr: state_type] :
      ( v110475(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11359,axiom,
    ! [VarCurr: state_type] :
      ( v110467(VarCurr)
    <=> ( v110468(VarCurr)
        | v110473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11358,axiom,
    ! [VarCurr: state_type] :
      ( v110473(VarCurr)
    <=> ( v101501(VarCurr)
        & v110474(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_877,axiom,
    ! [VarCurr: state_type] :
      ( v110474(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11357,axiom,
    ! [VarCurr: state_type] :
      ( v110468(VarCurr)
    <=> ( v110469(VarCurr)
        | v110471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11356,axiom,
    ! [VarCurr: state_type] :
      ( v110471(VarCurr)
    <=> ( v84899(VarCurr)
        & v110472(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_876,axiom,
    ! [VarCurr: state_type] :
      ( v110472(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11355,axiom,
    ! [VarCurr: state_type] :
      ( v110469(VarCurr)
    <=> ( v118(VarCurr)
        & v110470(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_875,axiom,
    ! [VarCurr: state_type] :
      ( v110470(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4565,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,10)
    <=> ( v110453(VarCurr)
        | v110463(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4564,axiom,
    ! [VarCurr: state_type] :
      ( v110463(VarCurr)
    <=> ( v110464(VarCurr)
        & v109659(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11354,axiom,
    ! [VarCurr: state_type] :
      ( v110464(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11353,axiom,
    ! [VarCurr: state_type] :
      ( v110453(VarCurr)
    <=> ( v110454(VarCurr)
        | v110462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4563,axiom,
    ! [VarCurr: state_type] :
      ( v110462(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11352,axiom,
    ! [VarCurr: state_type] :
      ( v110454(VarCurr)
    <=> ( v110455(VarCurr)
        | v110460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11351,axiom,
    ! [VarCurr: state_type] :
      ( v110460(VarCurr)
    <=> ( v101501(VarCurr)
        & v110461(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_874,axiom,
    ! [VarCurr: state_type] :
      ( v110461(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11350,axiom,
    ! [VarCurr: state_type] :
      ( v110455(VarCurr)
    <=> ( v110456(VarCurr)
        | v110458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11349,axiom,
    ! [VarCurr: state_type] :
      ( v110458(VarCurr)
    <=> ( v84899(VarCurr)
        & v110459(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_873,axiom,
    ! [VarCurr: state_type] :
      ( v110459(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11348,axiom,
    ! [VarCurr: state_type] :
      ( v110456(VarCurr)
    <=> ( v118(VarCurr)
        & v110457(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_872,axiom,
    ! [VarCurr: state_type] :
      ( v110457(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4562,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,9)
    <=> ( v110440(VarCurr)
        | v110450(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4561,axiom,
    ! [VarCurr: state_type] :
      ( v110450(VarCurr)
    <=> ( v110451(VarCurr)
        & v109659(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11347,axiom,
    ! [VarCurr: state_type] :
      ( v110451(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11346,axiom,
    ! [VarCurr: state_type] :
      ( v110440(VarCurr)
    <=> ( v110441(VarCurr)
        | v110449(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4560,axiom,
    ! [VarCurr: state_type] :
      ( v110449(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11345,axiom,
    ! [VarCurr: state_type] :
      ( v110441(VarCurr)
    <=> ( v110442(VarCurr)
        | v110447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11344,axiom,
    ! [VarCurr: state_type] :
      ( v110447(VarCurr)
    <=> ( v101501(VarCurr)
        & v110448(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_871,axiom,
    ! [VarCurr: state_type] :
      ( v110448(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11343,axiom,
    ! [VarCurr: state_type] :
      ( v110442(VarCurr)
    <=> ( v110443(VarCurr)
        | v110445(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11342,axiom,
    ! [VarCurr: state_type] :
      ( v110445(VarCurr)
    <=> ( v84899(VarCurr)
        & v110446(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_870,axiom,
    ! [VarCurr: state_type] :
      ( v110446(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11341,axiom,
    ! [VarCurr: state_type] :
      ( v110443(VarCurr)
    <=> ( v118(VarCurr)
        & v110444(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_869,axiom,
    ! [VarCurr: state_type] :
      ( v110444(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4559,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,8)
    <=> ( v110427(VarCurr)
        | v110437(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4558,axiom,
    ! [VarCurr: state_type] :
      ( v110437(VarCurr)
    <=> ( v110438(VarCurr)
        & v109659(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11340,axiom,
    ! [VarCurr: state_type] :
      ( v110438(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11339,axiom,
    ! [VarCurr: state_type] :
      ( v110427(VarCurr)
    <=> ( v110428(VarCurr)
        | v110436(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4557,axiom,
    ! [VarCurr: state_type] :
      ( v110436(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11338,axiom,
    ! [VarCurr: state_type] :
      ( v110428(VarCurr)
    <=> ( v110429(VarCurr)
        | v110434(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11337,axiom,
    ! [VarCurr: state_type] :
      ( v110434(VarCurr)
    <=> ( v101501(VarCurr)
        & v110435(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_868,axiom,
    ! [VarCurr: state_type] :
      ( v110435(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $true )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11336,axiom,
    ! [VarCurr: state_type] :
      ( v110429(VarCurr)
    <=> ( v110430(VarCurr)
        | v110432(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11335,axiom,
    ! [VarCurr: state_type] :
      ( v110432(VarCurr)
    <=> ( v84899(VarCurr)
        & v110433(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_867,axiom,
    ! [VarCurr: state_type] :
      ( v110433(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $true )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11334,axiom,
    ! [VarCurr: state_type] :
      ( v110430(VarCurr)
    <=> ( v118(VarCurr)
        & v110431(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_866,axiom,
    ! [VarCurr: state_type] :
      ( v110431(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $true )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4556,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,7)
    <=> ( v110414(VarCurr)
        | v110424(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4555,axiom,
    ! [VarCurr: state_type] :
      ( v110424(VarCurr)
    <=> ( v110425(VarCurr)
        & v109659(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11333,axiom,
    ! [VarCurr: state_type] :
      ( v110425(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11332,axiom,
    ! [VarCurr: state_type] :
      ( v110414(VarCurr)
    <=> ( v110415(VarCurr)
        | v110423(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4554,axiom,
    ! [VarCurr: state_type] :
      ( v110423(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11331,axiom,
    ! [VarCurr: state_type] :
      ( v110415(VarCurr)
    <=> ( v110416(VarCurr)
        | v110421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11330,axiom,
    ! [VarCurr: state_type] :
      ( v110421(VarCurr)
    <=> ( v101501(VarCurr)
        & v110422(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_865,axiom,
    ! [VarCurr: state_type] :
      ( v110422(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11329,axiom,
    ! [VarCurr: state_type] :
      ( v110416(VarCurr)
    <=> ( v110417(VarCurr)
        | v110419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11328,axiom,
    ! [VarCurr: state_type] :
      ( v110419(VarCurr)
    <=> ( v84899(VarCurr)
        & v110420(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_864,axiom,
    ! [VarCurr: state_type] :
      ( v110420(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11327,axiom,
    ! [VarCurr: state_type] :
      ( v110417(VarCurr)
    <=> ( v118(VarCurr)
        & v110418(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_863,axiom,
    ! [VarCurr: state_type] :
      ( v110418(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4553,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,6)
    <=> ( v110401(VarCurr)
        | v110411(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4552,axiom,
    ! [VarCurr: state_type] :
      ( v110411(VarCurr)
    <=> ( v110412(VarCurr)
        & v109659(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11326,axiom,
    ! [VarCurr: state_type] :
      ( v110412(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11325,axiom,
    ! [VarCurr: state_type] :
      ( v110401(VarCurr)
    <=> ( v110402(VarCurr)
        | v110410(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4551,axiom,
    ! [VarCurr: state_type] :
      ( v110410(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11324,axiom,
    ! [VarCurr: state_type] :
      ( v110402(VarCurr)
    <=> ( v110403(VarCurr)
        | v110408(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11323,axiom,
    ! [VarCurr: state_type] :
      ( v110408(VarCurr)
    <=> ( v101501(VarCurr)
        & v110409(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_862,axiom,
    ! [VarCurr: state_type] :
      ( v110409(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11322,axiom,
    ! [VarCurr: state_type] :
      ( v110403(VarCurr)
    <=> ( v110404(VarCurr)
        | v110406(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11321,axiom,
    ! [VarCurr: state_type] :
      ( v110406(VarCurr)
    <=> ( v84899(VarCurr)
        & v110407(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_861,axiom,
    ! [VarCurr: state_type] :
      ( v110407(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11320,axiom,
    ! [VarCurr: state_type] :
      ( v110404(VarCurr)
    <=> ( v118(VarCurr)
        & v110405(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_860,axiom,
    ! [VarCurr: state_type] :
      ( v110405(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4550,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,5)
    <=> ( v110388(VarCurr)
        | v110398(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4549,axiom,
    ! [VarCurr: state_type] :
      ( v110398(VarCurr)
    <=> ( v110399(VarCurr)
        & v109659(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11319,axiom,
    ! [VarCurr: state_type] :
      ( v110399(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11318,axiom,
    ! [VarCurr: state_type] :
      ( v110388(VarCurr)
    <=> ( v110389(VarCurr)
        | v110397(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4548,axiom,
    ! [VarCurr: state_type] :
      ( v110397(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11317,axiom,
    ! [VarCurr: state_type] :
      ( v110389(VarCurr)
    <=> ( v110390(VarCurr)
        | v110395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11316,axiom,
    ! [VarCurr: state_type] :
      ( v110395(VarCurr)
    <=> ( v101501(VarCurr)
        & v110396(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_859,axiom,
    ! [VarCurr: state_type] :
      ( v110396(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11315,axiom,
    ! [VarCurr: state_type] :
      ( v110390(VarCurr)
    <=> ( v110391(VarCurr)
        | v110393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11314,axiom,
    ! [VarCurr: state_type] :
      ( v110393(VarCurr)
    <=> ( v84899(VarCurr)
        & v110394(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_858,axiom,
    ! [VarCurr: state_type] :
      ( v110394(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11313,axiom,
    ! [VarCurr: state_type] :
      ( v110391(VarCurr)
    <=> ( v118(VarCurr)
        & v110392(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_857,axiom,
    ! [VarCurr: state_type] :
      ( v110392(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4547,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,4)
    <=> ( v110375(VarCurr)
        | v110385(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4546,axiom,
    ! [VarCurr: state_type] :
      ( v110385(VarCurr)
    <=> ( v110386(VarCurr)
        & v109659(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11312,axiom,
    ! [VarCurr: state_type] :
      ( v110386(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11311,axiom,
    ! [VarCurr: state_type] :
      ( v110375(VarCurr)
    <=> ( v110376(VarCurr)
        | v110384(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4545,axiom,
    ! [VarCurr: state_type] :
      ( v110384(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11310,axiom,
    ! [VarCurr: state_type] :
      ( v110376(VarCurr)
    <=> ( v110377(VarCurr)
        | v110382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11309,axiom,
    ! [VarCurr: state_type] :
      ( v110382(VarCurr)
    <=> ( v101501(VarCurr)
        & v110383(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_856,axiom,
    ! [VarCurr: state_type] :
      ( v110383(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $true )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11308,axiom,
    ! [VarCurr: state_type] :
      ( v110377(VarCurr)
    <=> ( v110378(VarCurr)
        | v110380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11307,axiom,
    ! [VarCurr: state_type] :
      ( v110380(VarCurr)
    <=> ( v84899(VarCurr)
        & v110381(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_855,axiom,
    ! [VarCurr: state_type] :
      ( v110381(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $true )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11306,axiom,
    ! [VarCurr: state_type] :
      ( v110378(VarCurr)
    <=> ( v118(VarCurr)
        & v110379(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_854,axiom,
    ! [VarCurr: state_type] :
      ( v110379(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $true )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4544,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,3)
    <=> ( v110362(VarCurr)
        | v110372(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4543,axiom,
    ! [VarCurr: state_type] :
      ( v110372(VarCurr)
    <=> ( v110373(VarCurr)
        & v109659(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11305,axiom,
    ! [VarCurr: state_type] :
      ( v110373(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11304,axiom,
    ! [VarCurr: state_type] :
      ( v110362(VarCurr)
    <=> ( v110363(VarCurr)
        | v110371(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4542,axiom,
    ! [VarCurr: state_type] :
      ( v110371(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11303,axiom,
    ! [VarCurr: state_type] :
      ( v110363(VarCurr)
    <=> ( v110364(VarCurr)
        | v110369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11302,axiom,
    ! [VarCurr: state_type] :
      ( v110369(VarCurr)
    <=> ( v101501(VarCurr)
        & v110370(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_853,axiom,
    ! [VarCurr: state_type] :
      ( v110370(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11301,axiom,
    ! [VarCurr: state_type] :
      ( v110364(VarCurr)
    <=> ( v110365(VarCurr)
        | v110367(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11300,axiom,
    ! [VarCurr: state_type] :
      ( v110367(VarCurr)
    <=> ( v84899(VarCurr)
        & v110368(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_852,axiom,
    ! [VarCurr: state_type] :
      ( v110368(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11299,axiom,
    ! [VarCurr: state_type] :
      ( v110365(VarCurr)
    <=> ( v118(VarCurr)
        & v110366(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_851,axiom,
    ! [VarCurr: state_type] :
      ( v110366(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4541,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,2)
    <=> ( v110349(VarCurr)
        | v110359(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4540,axiom,
    ! [VarCurr: state_type] :
      ( v110359(VarCurr)
    <=> ( v110360(VarCurr)
        & v109659(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11298,axiom,
    ! [VarCurr: state_type] :
      ( v110360(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11297,axiom,
    ! [VarCurr: state_type] :
      ( v110349(VarCurr)
    <=> ( v110350(VarCurr)
        | v110358(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4539,axiom,
    ! [VarCurr: state_type] :
      ( v110358(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11296,axiom,
    ! [VarCurr: state_type] :
      ( v110350(VarCurr)
    <=> ( v110351(VarCurr)
        | v110356(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11295,axiom,
    ! [VarCurr: state_type] :
      ( v110356(VarCurr)
    <=> ( v101501(VarCurr)
        & v110357(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_850,axiom,
    ! [VarCurr: state_type] :
      ( v110357(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $true )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11294,axiom,
    ! [VarCurr: state_type] :
      ( v110351(VarCurr)
    <=> ( v110352(VarCurr)
        | v110354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11293,axiom,
    ! [VarCurr: state_type] :
      ( v110354(VarCurr)
    <=> ( v84899(VarCurr)
        & v110355(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_849,axiom,
    ! [VarCurr: state_type] :
      ( v110355(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $true )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11292,axiom,
    ! [VarCurr: state_type] :
      ( v110352(VarCurr)
    <=> ( v118(VarCurr)
        & v110353(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_848,axiom,
    ! [VarCurr: state_type] :
      ( v110353(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $true )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4538,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,1)
    <=> ( v110336(VarCurr)
        | v110346(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4537,axiom,
    ! [VarCurr: state_type] :
      ( v110346(VarCurr)
    <=> ( v110347(VarCurr)
        & v109659(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11291,axiom,
    ! [VarCurr: state_type] :
      ( v110347(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11290,axiom,
    ! [VarCurr: state_type] :
      ( v110336(VarCurr)
    <=> ( v110337(VarCurr)
        | v110345(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4536,axiom,
    ! [VarCurr: state_type] :
      ( v110345(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11289,axiom,
    ! [VarCurr: state_type] :
      ( v110337(VarCurr)
    <=> ( v110338(VarCurr)
        | v110343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11288,axiom,
    ! [VarCurr: state_type] :
      ( v110343(VarCurr)
    <=> ( v101501(VarCurr)
        & v110344(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_847,axiom,
    ! [VarCurr: state_type] :
      ( v110344(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11287,axiom,
    ! [VarCurr: state_type] :
      ( v110338(VarCurr)
    <=> ( v110339(VarCurr)
        | v110341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11286,axiom,
    ! [VarCurr: state_type] :
      ( v110341(VarCurr)
    <=> ( v84899(VarCurr)
        & v110342(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_846,axiom,
    ! [VarCurr: state_type] :
      ( v110342(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11285,axiom,
    ! [VarCurr: state_type] :
      ( v110339(VarCurr)
    <=> ( v118(VarCurr)
        & v110340(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_845,axiom,
    ! [VarCurr: state_type] :
      ( v110340(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11284,axiom,
    ! [VarCurr: state_type] :
      ( v116(VarCurr,0)
    <=> ( v110323(VarCurr)
        | v110333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11283,axiom,
    ! [VarCurr: state_type] :
      ( v110333(VarCurr)
    <=> ( v110334(VarCurr)
        & v109659(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11282,axiom,
    ! [VarCurr: state_type] :
      ( v110334(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11281,axiom,
    ! [VarCurr: state_type] :
      ( v110323(VarCurr)
    <=> ( v110324(VarCurr)
        | v110332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11280,axiom,
    ! [VarCurr: state_type] :
      ( v110332(VarCurr)
    <=> ( v86877(VarCurr)
        & v86881(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11279,axiom,
    ! [VarCurr: state_type] :
      ( v110324(VarCurr)
    <=> ( v110325(VarCurr)
        | v110330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11278,axiom,
    ! [VarCurr: state_type] :
      ( v110330(VarCurr)
    <=> ( v101501(VarCurr)
        & v110331(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_844,axiom,
    ! [VarCurr: state_type] :
      ( v110331(VarCurr)
    <=> ( ( v101563(VarCurr,3)
        <=> $false )
        & ( v101563(VarCurr,2)
        <=> $false )
        & ( v101563(VarCurr,1)
        <=> $false )
        & ( v101563(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11277,axiom,
    ! [VarCurr: state_type] :
      ( v110325(VarCurr)
    <=> ( v110326(VarCurr)
        | v110328(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11276,axiom,
    ! [VarCurr: state_type] :
      ( v110328(VarCurr)
    <=> ( v84899(VarCurr)
        & v110329(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_843,axiom,
    ! [VarCurr: state_type] :
      ( v110329(VarCurr)
    <=> ( ( v89243(VarCurr,3)
        <=> $false )
        & ( v89243(VarCurr,2)
        <=> $false )
        & ( v89243(VarCurr,1)
        <=> $false )
        & ( v89243(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11275,axiom,
    ! [VarCurr: state_type] :
      ( v110326(VarCurr)
    <=> ( v118(VarCurr)
        & v110327(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_842,axiom,
    ! [VarCurr: state_type] :
      ( v110327(VarCurr)
    <=> ( ( v89214(VarCurr,3)
        <=> $false )
        & ( v89214(VarCurr,2)
        <=> $false )
        & ( v89214(VarCurr,1)
        <=> $false )
        & ( v89214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_65959,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,15)
    <=> v110288(VarCurr,15) ) ).

tff(addAssignment_65958,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,15)
    <=> v110267(VarCurr,15) ) ).

tff(addAssignment_65957,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,14)
    <=> v110288(VarCurr,14) ) ).

tff(addAssignment_65956,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,14)
    <=> v110267(VarCurr,14) ) ).

tff(addAssignment_65955,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,13)
    <=> v110288(VarCurr,13) ) ).

tff(addAssignment_65954,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,13)
    <=> v110267(VarCurr,13) ) ).

tff(addAssignment_65953,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,12)
    <=> v110288(VarCurr,12) ) ).

tff(addAssignment_65952,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,12)
    <=> v110267(VarCurr,12) ) ).

tff(addAssignment_65951,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,11)
    <=> v110288(VarCurr,11) ) ).

tff(addAssignment_65950,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,11)
    <=> v110267(VarCurr,11) ) ).

tff(addAssignment_65949,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,10)
    <=> v110288(VarCurr,10) ) ).

tff(addAssignment_65948,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,10)
    <=> v110267(VarCurr,10) ) ).

tff(addAssignment_65947,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,9)
    <=> v110288(VarCurr,9) ) ).

tff(addAssignment_65946,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,9)
    <=> v110267(VarCurr,9) ) ).

tff(addAssignment_65945,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,8)
    <=> v110288(VarCurr,8) ) ).

tff(addAssignment_65944,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,8)
    <=> v110267(VarCurr,8) ) ).

tff(addAssignment_65943,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,7)
    <=> v110288(VarCurr,7) ) ).

tff(addAssignment_65942,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,7)
    <=> v110267(VarCurr,7) ) ).

tff(addAssignment_65941,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,6)
    <=> v110288(VarCurr,6) ) ).

tff(addAssignment_65940,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,6)
    <=> v110267(VarCurr,6) ) ).

tff(addAssignment_65939,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,5)
    <=> v110288(VarCurr,5) ) ).

tff(addAssignment_65938,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,5)
    <=> v110267(VarCurr,5) ) ).

tff(addAssignment_65937,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,4)
    <=> v110288(VarCurr,4) ) ).

tff(addAssignment_65936,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,4)
    <=> v110267(VarCurr,4) ) ).

tff(addAssignment_65935,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,3)
    <=> v110288(VarCurr,3) ) ).

tff(addAssignment_65934,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,3)
    <=> v110267(VarCurr,3) ) ).

tff(addAssignment_65933,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,2)
    <=> v110288(VarCurr,2) ) ).

tff(addAssignment_65932,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,2)
    <=> v110267(VarCurr,2) ) ).

tff(addAssignment_65931,axiom,
    ! [VarCurr: state_type] :
      ( v109659(VarCurr,1)
    <=> v110288(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110288(VarCurr,B)
      <=> ( v109661(VarCurr,B)
          & v110289(VarCurr,B) ) ) ) ).

tff(addAssignment_65930,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,0)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65929,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,1)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65928,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,2)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65927,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,3)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65926,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,4)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65925,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,5)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65924,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,6)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65923,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,7)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65922,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,8)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65921,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,9)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65920,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,10)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65919,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,11)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65918,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,12)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65917,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,13)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65916,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,14)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65915,axiom,
    ! [VarCurr: state_type] :
      ( v110289(VarCurr,15)
    <=> v110290(VarCurr) ) ).

tff(addAssignment_65914,axiom,
    ! [VarCurr: state_type] :
      ( v110290(VarCurr)
    <=> v110291(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4535,axiom,
    ! [VarCurr: state_type] :
      ( v110291(VarCurr)
    <=> ( v110292(VarCurr)
        | v84297(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11274,axiom,
    ! [VarCurr: state_type] :
      ( v110292(VarCurr)
    <=> ( v110293(VarCurr)
        & v110321(VarCurr) ) ) ).

tff(writeUnaryOperator_6013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110321(VarCurr)
    <=> v84488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11273,axiom,
    ! [VarCurr: state_type] :
      ( v110293(VarCurr)
    <=> ( v110294(VarCurr)
        & v110320(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4534,axiom,
    ! [VarCurr: state_type] :
      ( v110320(VarCurr)
    <=> ( v84297(VarCurr,2)
        | v84297(VarCurr,4) ) ) ).

tff(writeUnaryOperator_6012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110294(VarCurr)
    <=> v110296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11272,axiom,
    ! [VarCurr: state_type] :
      ( v110296(VarCurr)
    <=> ( v110297(VarCurr)
        & v110315(VarCurr) ) ) ).

tff(writeUnaryOperator_6011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110315(VarCurr)
    <=> v110316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11271,axiom,
    ! [VarCurr: state_type] :
      ( v110316(VarCurr)
    <=> ( v110317(VarCurr)
        & v110319(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4533,axiom,
    ! [VarCurr: state_type] :
      ( v110319(VarCurr)
    <=> ( v88372(VarCurr,3)
        | v110303(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11270,axiom,
    ! [VarCurr: state_type] :
      ( v110317(VarCurr)
    <=> ( v89111(VarCurr)
        | v110318(VarCurr) ) ) ).

tff(writeUnaryOperator_6010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110318(VarCurr)
    <=> v110303(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11269,axiom,
    ! [VarCurr: state_type] :
      ( v110297(VarCurr)
    <=> ( v110298(VarCurr)
        & v110310(VarCurr) ) ) ).

tff(writeUnaryOperator_6009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110310(VarCurr)
    <=> v110311(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11268,axiom,
    ! [VarCurr: state_type] :
      ( v110311(VarCurr)
    <=> ( v110312(VarCurr)
        & v110314(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4532,axiom,
    ! [VarCurr: state_type] :
      ( v110314(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v110303(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11267,axiom,
    ! [VarCurr: state_type] :
      ( v110312(VarCurr)
    <=> ( v88904(VarCurr)
        | v110313(VarCurr) ) ) ).

tff(writeUnaryOperator_6008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110313(VarCurr)
    <=> v110303(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11266,axiom,
    ! [VarCurr: state_type] :
      ( v110298(VarCurr)
    <=> ( v110299(VarCurr)
        & v110305(VarCurr) ) ) ).

tff(writeUnaryOperator_6007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110305(VarCurr)
    <=> v110306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11265,axiom,
    ! [VarCurr: state_type] :
      ( v110306(VarCurr)
    <=> ( v110307(VarCurr)
        & v110309(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4531,axiom,
    ! [VarCurr: state_type] :
      ( v110309(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v110303(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11264,axiom,
    ! [VarCurr: state_type] :
      ( v110307(VarCurr)
    <=> ( v88897(VarCurr)
        | v110308(VarCurr) ) ) ).

tff(writeUnaryOperator_6006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110308(VarCurr)
    <=> v110303(VarCurr,1) ) ).

tff(writeUnaryOperator_6005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110299(VarCurr)
    <=> v110300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11263,axiom,
    ! [VarCurr: state_type] :
      ( v110300(VarCurr)
    <=> ( v110301(VarCurr)
        & v110304(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11262,axiom,
    ! [VarCurr: state_type] :
      ( v110304(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v110303(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11261,axiom,
    ! [VarCurr: state_type] :
      ( v110301(VarCurr)
    <=> ( v88915(VarCurr)
        | v110302(VarCurr) ) ) ).

tff(writeUnaryOperator_6004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110302(VarCurr)
    <=> v110303(VarCurr,0) ) ).

tff(addAssignment_65913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v110303(VarCurr,B)
      <=> v101570(VarCurr,B) ) ) ).

tff(addAssignment_65912,axiom,
    ! [VarCurr: state_type] :
      ( v110303(VarCurr,3)
    <=> v102060(VarCurr) ) ).

tff(addAssignment_65911,axiom,
    ! [VarCurr: state_type] :
      ( v109661(VarCurr,1)
    <=> v110267(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v110267(VarCurr,B)
      <=> ( v110268(VarCurr,B)
          & v110271(VarCurr,B) ) ) ) ).

tff(addAssignment_65910,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,0)
    <=> v110287(VarCurr) ) ).

tff(addAssignment_65909,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,1)
    <=> v110286(VarCurr) ) ).

tff(addAssignment_65908,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,2)
    <=> v110285(VarCurr) ) ).

tff(addAssignment_65907,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,3)
    <=> v110284(VarCurr) ) ).

tff(addAssignment_65906,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,4)
    <=> v110283(VarCurr) ) ).

tff(addAssignment_65905,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,5)
    <=> v110282(VarCurr) ) ).

tff(addAssignment_65904,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,6)
    <=> v110281(VarCurr) ) ).

tff(addAssignment_65903,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,7)
    <=> v110280(VarCurr) ) ).

tff(addAssignment_65902,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,8)
    <=> v110279(VarCurr) ) ).

tff(addAssignment_65901,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,9)
    <=> v110278(VarCurr) ) ).

tff(addAssignment_65900,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,10)
    <=> v110277(VarCurr) ) ).

tff(addAssignment_65899,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,11)
    <=> v110276(VarCurr) ) ).

tff(addAssignment_65898,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,12)
    <=> v110275(VarCurr) ) ).

tff(addAssignment_65897,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,13)
    <=> v110274(VarCurr) ) ).

tff(addAssignment_65896,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,14)
    <=> v110273(VarCurr) ) ).

tff(addAssignment_65895,axiom,
    ! [VarCurr: state_type] :
      ( v110271(VarCurr,15)
    <=> v110272(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_841,axiom,
    ! [VarCurr: state_type] :
      ( v110287(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_840,axiom,
    ! [VarCurr: state_type] :
      ( v110286(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_839,axiom,
    ! [VarCurr: state_type] :
      ( v110285(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_838,axiom,
    ! [VarCurr: state_type] :
      ( v110284(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_837,axiom,
    ! [VarCurr: state_type] :
      ( v110283(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_836,axiom,
    ! [VarCurr: state_type] :
      ( v110282(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_835,axiom,
    ! [VarCurr: state_type] :
      ( v110281(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_834,axiom,
    ! [VarCurr: state_type] :
      ( v110280(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $false )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_833,axiom,
    ! [VarCurr: state_type] :
      ( v110279(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_832,axiom,
    ! [VarCurr: state_type] :
      ( v110278(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_831,axiom,
    ! [VarCurr: state_type] :
      ( v110277(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_830,axiom,
    ! [VarCurr: state_type] :
      ( v110276(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $false )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_829,axiom,
    ! [VarCurr: state_type] :
      ( v110275(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_828,axiom,
    ! [VarCurr: state_type] :
      ( v110274(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $false )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_827,axiom,
    ! [VarCurr: state_type] :
      ( v110273(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_826,axiom,
    ! [VarCurr: state_type] :
      ( v110272(VarCurr)
    <=> ( ( v102061(VarCurr,3)
        <=> $true )
        & ( v102061(VarCurr,2)
        <=> $true )
        & ( v102061(VarCurr,1)
        <=> $true )
        & ( v102061(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_65894,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,0)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65893,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,1)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65892,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,2)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65891,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,3)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65890,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,4)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65889,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,5)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65888,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,6)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65887,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,7)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65886,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,8)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65885,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,9)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65884,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,10)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65883,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,11)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65882,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,12)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65881,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,13)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65880,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,14)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65879,axiom,
    ! [VarCurr: state_type] :
      ( v110268(VarCurr,15)
    <=> v110269(VarCurr) ) ).

tff(addAssignment_65878,axiom,
    ! [VarCurr: state_type] :
      ( v110269(VarCurr)
    <=> v110270(VarCurr) ) ).

tff(writeUnaryOperator_6003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v110270(VarCurr)
    <=> v109663(VarCurr) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_30,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87990(VarCurr)
     => ( v102061(VarCurr,3)
      <=> v110266(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_59,axiom,
    ! [VarCurr: state_type] :
      ( v87990(VarCurr)
     => ( v102061(VarCurr,3)
      <=> v110265(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_29,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ( v110266(VarCurr)
      <=> v101570(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_940,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ( v110266(VarCurr)
      <=> v101570(VarCurr,0) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ( v110265(VarCurr)
      <=> v101570(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_939,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ( v110265(VarCurr)
      <=> v102060(VarCurr) ) ) ).

tff(addAssignment_65877,axiom,
    ! [VarCurr: state_type] :
      ( ( v102061(VarCurr,2)
      <=> v781(VarCurr,9) )
      & ( v102061(VarCurr,1)
      <=> v781(VarCurr,8) )
      & ( v102061(VarCurr,0)
      <=> v781(VarCurr,7) ) ) ).

tff(addAssignment_65876,axiom,
    ! [VarCurr: state_type] :
      ( v102060(VarCurr)
    <=> v781(VarCurr,13) ) ).

tff(addAssignment_65875,axiom,
    ! [VarCurr: state_type] :
      ( v781(VarCurr,13)
    <=> v783(VarCurr,13) ) ).

tff(addAssignment_65874,axiom,
    ! [VarCurr: state_type] :
      ( v783(VarCurr,13)
    <=> v5329(VarCurr,13) ) ).

tff(addAssignment_65873,axiom,
    ! [VarCurr: state_type] :
      ( v5324(VarCurr,13)
    <=> v5326(VarCurr,13) ) ).

tff(addAssignment_65872,axiom,
    ! [VarCurr: state_type] :
      ( v5326(VarCurr,13)
    <=> v5328(VarCurr,13) ) ).

tff(addAssignment_65871,axiom,
    ! [VarNext: state_type] :
      ( v5328(VarNext,13)
    <=> v110257(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110258(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110257(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1413,axiom,
    ! [VarNext: state_type] :
      ( v110258(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110257(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110258(VarNext)
      <=> v110259(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110259(VarNext)
      <=> ( v110261(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_6002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110261(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_65870,axiom,
    ! [VarCurr: state_type] :
      ( v103020(VarCurr,13)
    <=> v103022(VarCurr,13) ) ).

tff(addAssignment_65869,axiom,
    ! [VarCurr: state_type] :
      ( v103022(VarCurr,13)
    <=> v103031(VarCurr,13) ) ).

tff(addAssignment_65868,axiom,
    ! [VarCurr: state_type] :
      ( v103024(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65867,axiom,
    ! [VarCurr: state_type] :
      ( v5318(VarCurr,13)
    <=> v5320(VarCurr,13) ) ).

tff(addAssignment_65866,axiom,
    ! [VarCurr: state_type] :
      ( v5320(VarCurr,13)
    <=> v5322(VarCurr,13) ) ).

tff(addAssignment_65865,axiom,
    ! [VarNext: state_type] :
      ( v5322(VarNext,13)
    <=> v110249(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110250(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110249(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1412,axiom,
    ! [VarNext: state_type] :
      ( v110250(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110249(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110250(VarNext)
      <=> v110251(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110251(VarNext)
      <=> ( v110253(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_6001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110253(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_65864,axiom,
    ! [VarCurr: state_type] :
      ( v102970(VarCurr,13)
    <=> v102972(VarCurr,13) ) ).

tff(addAssignment_65863,axiom,
    ! [VarCurr: state_type] :
      ( v102972(VarCurr,13)
    <=> v102981(VarCurr,13) ) ).

tff(addAssignment_65862,axiom,
    ! [VarCurr: state_type] :
      ( v102974(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65861,axiom,
    ! [VarCurr: state_type] :
      ( v5311(VarCurr,13)
    <=> v5313(VarCurr,13) ) ).

tff(addAssignment_65860,axiom,
    ! [VarCurr: state_type] :
      ( v5313(VarCurr,13)
    <=> v5315(VarCurr,13) ) ).

tff(addAssignment_65859,axiom,
    ! [VarNext: state_type] :
      ( v5315(VarNext,13)
    <=> v110241(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110242(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110241(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1411,axiom,
    ! [VarNext: state_type] :
      ( v110242(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110241(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110242(VarNext)
      <=> v110243(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110243(VarNext)
      <=> ( v110245(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_6000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110245(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_65858,axiom,
    ! [VarCurr: state_type] :
      ( v102920(VarCurr,13)
    <=> v102922(VarCurr,13) ) ).

tff(addAssignment_65857,axiom,
    ! [VarCurr: state_type] :
      ( v102922(VarCurr,13)
    <=> v102931(VarCurr,13) ) ).

tff(addAssignment_65856,axiom,
    ! [VarCurr: state_type] :
      ( v102924(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65855,axiom,
    ! [VarCurr: state_type] :
      ( v5304(VarCurr,13)
    <=> v5306(VarCurr,13) ) ).

tff(addAssignment_65854,axiom,
    ! [VarCurr: state_type] :
      ( v5306(VarCurr,13)
    <=> v5308(VarCurr,13) ) ).

tff(addAssignment_65853,axiom,
    ! [VarNext: state_type] :
      ( v5308(VarNext,13)
    <=> v110233(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110234(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110233(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1410,axiom,
    ! [VarNext: state_type] :
      ( v110234(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110233(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110234(VarNext)
      <=> v110235(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110235(VarNext)
      <=> ( v110237(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_5999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110237(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_65852,axiom,
    ! [VarCurr: state_type] :
      ( v102870(VarCurr,13)
    <=> v102872(VarCurr,13) ) ).

tff(addAssignment_65851,axiom,
    ! [VarCurr: state_type] :
      ( v102872(VarCurr,13)
    <=> v102881(VarCurr,13) ) ).

tff(addAssignment_65850,axiom,
    ! [VarCurr: state_type] :
      ( v102874(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65849,axiom,
    ! [VarCurr: state_type] :
      ( v5297(VarCurr,13)
    <=> v5299(VarCurr,13) ) ).

tff(addAssignment_65848,axiom,
    ! [VarCurr: state_type] :
      ( v5299(VarCurr,13)
    <=> v5301(VarCurr,13) ) ).

tff(addAssignment_65847,axiom,
    ! [VarNext: state_type] :
      ( v5301(VarNext,13)
    <=> v110225(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110226(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110225(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1409,axiom,
    ! [VarNext: state_type] :
      ( v110226(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110225(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110226(VarNext)
      <=> v110227(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110227(VarNext)
      <=> ( v110229(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_5998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110229(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_65846,axiom,
    ! [VarCurr: state_type] :
      ( v102820(VarCurr,13)
    <=> v102822(VarCurr,13) ) ).

tff(addAssignment_65845,axiom,
    ! [VarCurr: state_type] :
      ( v102822(VarCurr,13)
    <=> v102831(VarCurr,13) ) ).

tff(addAssignment_65844,axiom,
    ! [VarCurr: state_type] :
      ( v102824(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65843,axiom,
    ! [VarCurr: state_type] :
      ( v5290(VarCurr,13)
    <=> v5292(VarCurr,13) ) ).

tff(addAssignment_65842,axiom,
    ! [VarCurr: state_type] :
      ( v5292(VarCurr,13)
    <=> v5294(VarCurr,13) ) ).

tff(addAssignment_65841,axiom,
    ! [VarNext: state_type] :
      ( v5294(VarNext,13)
    <=> v110217(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110218(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110217(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1408,axiom,
    ! [VarNext: state_type] :
      ( v110218(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110217(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110218(VarNext)
      <=> v110219(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110219(VarNext)
      <=> ( v110221(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_5997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110221(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_65840,axiom,
    ! [VarCurr: state_type] :
      ( v102770(VarCurr,13)
    <=> v102772(VarCurr,13) ) ).

tff(addAssignment_65839,axiom,
    ! [VarCurr: state_type] :
      ( v102772(VarCurr,13)
    <=> v102781(VarCurr,13) ) ).

tff(addAssignment_65838,axiom,
    ! [VarCurr: state_type] :
      ( v102774(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65837,axiom,
    ! [VarCurr: state_type] :
      ( v5283(VarCurr,13)
    <=> v5285(VarCurr,13) ) ).

tff(addAssignment_65836,axiom,
    ! [VarCurr: state_type] :
      ( v5285(VarCurr,13)
    <=> v5287(VarCurr,13) ) ).

tff(addAssignment_65835,axiom,
    ! [VarNext: state_type] :
      ( v5287(VarNext,13)
    <=> v110209(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110210(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110209(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1407,axiom,
    ! [VarNext: state_type] :
      ( v110210(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110209(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110210(VarNext)
      <=> v110211(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110211(VarNext)
      <=> ( v110213(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_5996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110213(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_65834,axiom,
    ! [VarCurr: state_type] :
      ( v102720(VarCurr,13)
    <=> v102722(VarCurr,13) ) ).

tff(addAssignment_65833,axiom,
    ! [VarCurr: state_type] :
      ( v102722(VarCurr,13)
    <=> v102731(VarCurr,13) ) ).

tff(addAssignment_65832,axiom,
    ! [VarCurr: state_type] :
      ( v102724(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65831,axiom,
    ! [VarCurr: state_type] :
      ( v5276(VarCurr,13)
    <=> v5278(VarCurr,13) ) ).

tff(addAssignment_65830,axiom,
    ! [VarCurr: state_type] :
      ( v5278(VarCurr,13)
    <=> v5280(VarCurr,13) ) ).

tff(addAssignment_65829,axiom,
    ! [VarNext: state_type] :
      ( v5280(VarNext,13)
    <=> v110201(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110202(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110201(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1406,axiom,
    ! [VarNext: state_type] :
      ( v110202(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110201(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110202(VarNext)
      <=> v110203(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110203(VarNext)
      <=> ( v110205(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_5995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110205(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_65828,axiom,
    ! [VarCurr: state_type] :
      ( v102670(VarCurr,13)
    <=> v102672(VarCurr,13) ) ).

tff(addAssignment_65827,axiom,
    ! [VarCurr: state_type] :
      ( v102672(VarCurr,13)
    <=> v102681(VarCurr,13) ) ).

tff(addAssignment_65826,axiom,
    ! [VarCurr: state_type] :
      ( v102674(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65825,axiom,
    ! [VarCurr: state_type] :
      ( v5269(VarCurr,13)
    <=> v5271(VarCurr,13) ) ).

tff(addAssignment_65824,axiom,
    ! [VarCurr: state_type] :
      ( v5271(VarCurr,13)
    <=> v5273(VarCurr,13) ) ).

tff(addAssignment_65823,axiom,
    ! [VarNext: state_type] :
      ( v5273(VarNext,13)
    <=> v110193(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110194(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110193(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1405,axiom,
    ! [VarNext: state_type] :
      ( v110194(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110193(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110194(VarNext)
      <=> v110195(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110195(VarNext)
      <=> ( v110197(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_5994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110197(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_65822,axiom,
    ! [VarCurr: state_type] :
      ( v102620(VarCurr,13)
    <=> v102622(VarCurr,13) ) ).

tff(addAssignment_65821,axiom,
    ! [VarCurr: state_type] :
      ( v102622(VarCurr,13)
    <=> v102631(VarCurr,13) ) ).

tff(addAssignment_65820,axiom,
    ! [VarCurr: state_type] :
      ( v102624(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65819,axiom,
    ! [VarCurr: state_type] :
      ( v5262(VarCurr,13)
    <=> v5264(VarCurr,13) ) ).

tff(addAssignment_65818,axiom,
    ! [VarCurr: state_type] :
      ( v5264(VarCurr,13)
    <=> v5266(VarCurr,13) ) ).

tff(addAssignment_65817,axiom,
    ! [VarNext: state_type] :
      ( v5266(VarNext,13)
    <=> v110185(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110186(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110185(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1404,axiom,
    ! [VarNext: state_type] :
      ( v110186(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110185(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110186(VarNext)
      <=> v110187(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110187(VarNext)
      <=> ( v110189(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_5993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110189(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_65816,axiom,
    ! [VarCurr: state_type] :
      ( v102570(VarCurr,13)
    <=> v102572(VarCurr,13) ) ).

tff(addAssignment_65815,axiom,
    ! [VarCurr: state_type] :
      ( v102572(VarCurr,13)
    <=> v102581(VarCurr,13) ) ).

tff(addAssignment_65814,axiom,
    ! [VarCurr: state_type] :
      ( v102574(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65813,axiom,
    ! [VarCurr: state_type] :
      ( v5255(VarCurr,13)
    <=> v5257(VarCurr,13) ) ).

tff(addAssignment_65812,axiom,
    ! [VarCurr: state_type] :
      ( v5257(VarCurr,13)
    <=> v5259(VarCurr,13) ) ).

tff(addAssignment_65811,axiom,
    ! [VarNext: state_type] :
      ( v5259(VarNext,13)
    <=> v110177(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110178(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110177(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1403,axiom,
    ! [VarNext: state_type] :
      ( v110178(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110177(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110178(VarNext)
      <=> v110179(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110179(VarNext)
      <=> ( v110181(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_5992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110181(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_65810,axiom,
    ! [VarCurr: state_type] :
      ( v102520(VarCurr,13)
    <=> v102522(VarCurr,13) ) ).

tff(addAssignment_65809,axiom,
    ! [VarCurr: state_type] :
      ( v102522(VarCurr,13)
    <=> v102531(VarCurr,13) ) ).

tff(addAssignment_65808,axiom,
    ! [VarCurr: state_type] :
      ( v102524(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65807,axiom,
    ! [VarCurr: state_type] :
      ( v5248(VarCurr,13)
    <=> v5250(VarCurr,13) ) ).

tff(addAssignment_65806,axiom,
    ! [VarCurr: state_type] :
      ( v5250(VarCurr,13)
    <=> v5252(VarCurr,13) ) ).

tff(addAssignment_65805,axiom,
    ! [VarNext: state_type] :
      ( v5252(VarNext,13)
    <=> v110169(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110170(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110169(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1402,axiom,
    ! [VarNext: state_type] :
      ( v110170(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110169(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110170(VarNext)
      <=> v110171(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110171(VarNext)
      <=> ( v110173(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_5991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110173(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_65804,axiom,
    ! [VarCurr: state_type] :
      ( v102470(VarCurr,13)
    <=> v102472(VarCurr,13) ) ).

tff(addAssignment_65803,axiom,
    ! [VarCurr: state_type] :
      ( v102472(VarCurr,13)
    <=> v102481(VarCurr,13) ) ).

tff(addAssignment_65802,axiom,
    ! [VarCurr: state_type] :
      ( v102474(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65801,axiom,
    ! [VarCurr: state_type] :
      ( v5241(VarCurr,13)
    <=> v5243(VarCurr,13) ) ).

tff(addAssignment_65800,axiom,
    ! [VarCurr: state_type] :
      ( v5243(VarCurr,13)
    <=> v5245(VarCurr,13) ) ).

tff(addAssignment_65799,axiom,
    ! [VarNext: state_type] :
      ( v5245(VarNext,13)
    <=> v110161(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110162(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110161(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1401,axiom,
    ! [VarNext: state_type] :
      ( v110162(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110161(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110162(VarNext)
      <=> v110163(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110163(VarNext)
      <=> ( v110165(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_5990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110165(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_65798,axiom,
    ! [VarCurr: state_type] :
      ( v102420(VarCurr,13)
    <=> v102422(VarCurr,13) ) ).

tff(addAssignment_65797,axiom,
    ! [VarCurr: state_type] :
      ( v102422(VarCurr,13)
    <=> v102431(VarCurr,13) ) ).

tff(addAssignment_65796,axiom,
    ! [VarCurr: state_type] :
      ( v102424(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65795,axiom,
    ! [VarCurr: state_type] :
      ( v5234(VarCurr,13)
    <=> v5236(VarCurr,13) ) ).

tff(addAssignment_65794,axiom,
    ! [VarCurr: state_type] :
      ( v5236(VarCurr,13)
    <=> v5238(VarCurr,13) ) ).

tff(addAssignment_65793,axiom,
    ! [VarNext: state_type] :
      ( v5238(VarNext,13)
    <=> v110153(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110154(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110153(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1400,axiom,
    ! [VarNext: state_type] :
      ( v110154(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110153(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110154(VarNext)
      <=> v110155(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110155(VarNext)
      <=> ( v110157(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_5989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110157(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_65792,axiom,
    ! [VarCurr: state_type] :
      ( v102370(VarCurr,13)
    <=> v102372(VarCurr,13) ) ).

tff(addAssignment_65791,axiom,
    ! [VarCurr: state_type] :
      ( v102372(VarCurr,13)
    <=> v102381(VarCurr,13) ) ).

tff(addAssignment_65790,axiom,
    ! [VarCurr: state_type] :
      ( v102374(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65789,axiom,
    ! [VarCurr: state_type] :
      ( v5227(VarCurr,13)
    <=> v5229(VarCurr,13) ) ).

tff(addAssignment_65788,axiom,
    ! [VarCurr: state_type] :
      ( v5229(VarCurr,13)
    <=> v5231(VarCurr,13) ) ).

tff(addAssignment_65787,axiom,
    ! [VarNext: state_type] :
      ( v5231(VarNext,13)
    <=> v110145(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110146(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110145(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1399,axiom,
    ! [VarNext: state_type] :
      ( v110146(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110145(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110146(VarNext)
      <=> v110147(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110147(VarNext)
      <=> ( v110149(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_5988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110149(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_65786,axiom,
    ! [VarCurr: state_type] :
      ( v102320(VarCurr,13)
    <=> v102322(VarCurr,13) ) ).

tff(addAssignment_65785,axiom,
    ! [VarCurr: state_type] :
      ( v102322(VarCurr,13)
    <=> v102331(VarCurr,13) ) ).

tff(addAssignment_65784,axiom,
    ! [VarCurr: state_type] :
      ( v102324(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65783,axiom,
    ! [VarCurr: state_type] :
      ( v5220(VarCurr,13)
    <=> v5222(VarCurr,13) ) ).

tff(addAssignment_65782,axiom,
    ! [VarCurr: state_type] :
      ( v5222(VarCurr,13)
    <=> v5224(VarCurr,13) ) ).

tff(addAssignment_65781,axiom,
    ! [VarNext: state_type] :
      ( v5224(VarNext,13)
    <=> v110137(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110138(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110137(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1398,axiom,
    ! [VarNext: state_type] :
      ( v110138(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110137(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110138(VarNext)
      <=> v110139(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110139(VarNext)
      <=> ( v110141(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_5987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110141(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_65780,axiom,
    ! [VarCurr: state_type] :
      ( v102270(VarCurr,13)
    <=> v102272(VarCurr,13) ) ).

tff(addAssignment_65779,axiom,
    ! [VarCurr: state_type] :
      ( v102272(VarCurr,13)
    <=> v102281(VarCurr,13) ) ).

tff(addAssignment_65778,axiom,
    ! [VarCurr: state_type] :
      ( v102274(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65777,axiom,
    ! [VarCurr: state_type] :
      ( v884(VarCurr,13)
    <=> v886(VarCurr,13) ) ).

tff(addAssignment_65776,axiom,
    ! [VarCurr: state_type] :
      ( v886(VarCurr,13)
    <=> v888(VarCurr,13) ) ).

tff(addAssignment_65775,axiom,
    ! [VarNext: state_type] :
      ( v888(VarNext,13)
    <=> v110129(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_1397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110130(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v110129(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1397,axiom,
    ! [VarNext: state_type] :
      ( v110130(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v110129(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110130(VarNext)
      <=> v110131(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110131(VarNext)
      <=> ( v110133(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_5986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110133(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_65774,axiom,
    ! [VarCurr: state_type] :
      ( v898(VarCurr,13)
    <=> v900(VarCurr,13) ) ).

tff(addAssignment_65773,axiom,
    ! [VarCurr: state_type] :
      ( v900(VarCurr,13)
    <=> v102231(VarCurr,13) ) ).

tff(addAssignment_65772,axiom,
    ! [VarCurr: state_type] :
      ( v902(VarCurr,13)
    <=> v904(VarCurr,13) ) ).

tff(addAssignment_65771,axiom,
    ! [VarCurr: state_type] :
      ( v904(VarCurr,13)
    <=> v906(VarCurr,13) ) ).

tff(addAssignment_65770,axiom,
    ! [VarCurr: state_type] :
      ( v906(VarCurr,13)
    <=> v908(VarCurr,13) ) ).

tff(addAssignment_65769,axiom,
    ! [VarCurr: state_type] :
      ( v908(VarCurr,13)
    <=> v910(VarCurr,13) ) ).

tff(addAssignment_65768,axiom,
    ! [VarCurr: state_type] :
      ( v910(VarCurr,13)
    <=> v912(VarCurr,12) ) ).

tff(addAssignment_65767,axiom,
    ! [VarCurr: state_type] :
      ( v912(VarCurr,12)
    <=> v914(VarCurr,12) ) ).

tff(addAssignment_65766,axiom,
    ! [VarNext: state_type] :
      ( v914(VarNext,12)
    <=> v110121(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_1396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110122(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v110121(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1396,axiom,
    ! [VarNext: state_type] :
      ( v110122(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v110121(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110122(VarNext)
      <=> v110123(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110123(VarNext)
      <=> ( v110125(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_5985,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110125(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_65765,axiom,
    ! [VarCurr: state_type] :
      ( v932(VarCurr,12)
    <=> v934(VarCurr,12) ) ).

tff(addAssignment_65764,axiom,
    ! [VarCurr: state_type] :
      ( v934(VarCurr,12)
    <=> v5598(VarCurr,12) ) ).

tff(addAssignment_65763,axiom,
    ! [VarCurr: state_type] :
      ( v936(VarCurr,12)
    <=> v938(VarCurr,12) ) ).

tff(addAssignment_65762,axiom,
    ! [VarCurr: state_type] :
      ( v938(VarCurr,12)
    <=> v5589(VarCurr,12) ) ).

tff(addAssignment_65761,axiom,
    ! [VarCurr: state_type] :
      ( v5590(VarCurr)
    <=> v964(VarCurr,17) ) ).

tff(addAssignment_65760,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,17)
    <=> v966(VarCurr,17) ) ).

tff(addAssignment_65759,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,17)
    <=> v5526(VarCurr,17) ) ).

tff(addAssignment_65758,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,17)
    <=> v5523(VarCurr,17) ) ).

tff(addAssignment_65757,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,17)
    <=> v5525(VarCurr,17) ) ).

tff(addAssignment_65756,axiom,
    ! [VarNext: state_type] :
      ( v5525(VarNext,17)
    <=> v110113(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110114(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110113(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1395,axiom,
    ! [VarNext: state_type] :
      ( v110114(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110113(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110114(VarNext)
      <=> v110115(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110115(VarNext)
      <=> ( v110117(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_5984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110117(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_65755,axiom,
    ! [VarCurr: state_type] :
      ( v83988(VarCurr,17)
    <=> v83990(VarCurr,17) ) ).

tff(addAssignment_65754,axiom,
    ! [VarCurr: state_type] :
      ( v83990(VarCurr,17)
    <=> v83999(VarCurr,17) ) ).

tff(addAssignment_65753,axiom,
    ! [VarCurr: state_type] :
      ( v83992(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65752,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,17)
    <=> v5516(VarCurr,17) ) ).

tff(addAssignment_65751,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,17)
    <=> v5518(VarCurr,17) ) ).

tff(addAssignment_65750,axiom,
    ! [VarNext: state_type] :
      ( v5518(VarNext,17)
    <=> v110105(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110106(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110105(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1394,axiom,
    ! [VarNext: state_type] :
      ( v110106(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110105(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110106(VarNext)
      <=> v110107(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110107(VarNext)
      <=> ( v110109(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_5983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110109(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_65749,axiom,
    ! [VarCurr: state_type] :
      ( v83938(VarCurr,17)
    <=> v83940(VarCurr,17) ) ).

tff(addAssignment_65748,axiom,
    ! [VarCurr: state_type] :
      ( v83940(VarCurr,17)
    <=> v83949(VarCurr,17) ) ).

tff(addAssignment_65747,axiom,
    ! [VarCurr: state_type] :
      ( v83942(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65746,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,17)
    <=> v5509(VarCurr,17) ) ).

tff(addAssignment_65745,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,17)
    <=> v5511(VarCurr,17) ) ).

tff(addAssignment_65744,axiom,
    ! [VarNext: state_type] :
      ( v5511(VarNext,17)
    <=> v110097(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110098(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110097(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1393,axiom,
    ! [VarNext: state_type] :
      ( v110098(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110097(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110098(VarNext)
      <=> v110099(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110099(VarNext)
      <=> ( v110101(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_5982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110101(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_65743,axiom,
    ! [VarCurr: state_type] :
      ( v83888(VarCurr,17)
    <=> v83890(VarCurr,17) ) ).

tff(addAssignment_65742,axiom,
    ! [VarCurr: state_type] :
      ( v83890(VarCurr,17)
    <=> v83899(VarCurr,17) ) ).

tff(addAssignment_65741,axiom,
    ! [VarCurr: state_type] :
      ( v83892(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65740,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,17)
    <=> v5502(VarCurr,17) ) ).

tff(addAssignment_65739,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,17)
    <=> v5504(VarCurr,17) ) ).

tff(addAssignment_65738,axiom,
    ! [VarNext: state_type] :
      ( v5504(VarNext,17)
    <=> v110089(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110090(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110089(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1392,axiom,
    ! [VarNext: state_type] :
      ( v110090(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110089(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110090(VarNext)
      <=> v110091(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110091(VarNext)
      <=> ( v110093(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_5981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110093(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_65737,axiom,
    ! [VarCurr: state_type] :
      ( v83838(VarCurr,17)
    <=> v83840(VarCurr,17) ) ).

tff(addAssignment_65736,axiom,
    ! [VarCurr: state_type] :
      ( v83840(VarCurr,17)
    <=> v83849(VarCurr,17) ) ).

tff(addAssignment_65735,axiom,
    ! [VarCurr: state_type] :
      ( v83842(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65734,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,17)
    <=> v5495(VarCurr,17) ) ).

tff(addAssignment_65733,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,17)
    <=> v5497(VarCurr,17) ) ).

tff(addAssignment_65732,axiom,
    ! [VarNext: state_type] :
      ( v5497(VarNext,17)
    <=> v110081(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110082(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110081(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1391,axiom,
    ! [VarNext: state_type] :
      ( v110082(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110081(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110082(VarNext)
      <=> v110083(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110083(VarNext)
      <=> ( v110085(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_5980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110085(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_65731,axiom,
    ! [VarCurr: state_type] :
      ( v83788(VarCurr,17)
    <=> v83790(VarCurr,17) ) ).

tff(addAssignment_65730,axiom,
    ! [VarCurr: state_type] :
      ( v83790(VarCurr,17)
    <=> v83799(VarCurr,17) ) ).

tff(addAssignment_65729,axiom,
    ! [VarCurr: state_type] :
      ( v83792(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65728,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,17)
    <=> v5489(VarCurr,17) ) ).

tff(addAssignment_65727,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,17)
    <=> v5491(VarCurr,17) ) ).

tff(addAssignment_65726,axiom,
    ! [VarNext: state_type] :
      ( v5491(VarNext,17)
    <=> v110073(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110074(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110073(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1390,axiom,
    ! [VarNext: state_type] :
      ( v110074(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110073(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110074(VarNext)
      <=> v110075(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110075(VarNext)
      <=> ( v110077(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_5979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110077(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_65725,axiom,
    ! [VarCurr: state_type] :
      ( v83738(VarCurr,17)
    <=> v83740(VarCurr,17) ) ).

tff(addAssignment_65724,axiom,
    ! [VarCurr: state_type] :
      ( v83740(VarCurr,17)
    <=> v83749(VarCurr,17) ) ).

tff(addAssignment_65723,axiom,
    ! [VarCurr: state_type] :
      ( v83742(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65722,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,17)
    <=> v5482(VarCurr,17) ) ).

tff(addAssignment_65721,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,17)
    <=> v5484(VarCurr,17) ) ).

tff(addAssignment_65720,axiom,
    ! [VarNext: state_type] :
      ( v5484(VarNext,17)
    <=> v110065(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110066(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110065(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1389,axiom,
    ! [VarNext: state_type] :
      ( v110066(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110065(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110066(VarNext)
      <=> v110067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110067(VarNext)
      <=> ( v110069(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_5978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110069(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_65719,axiom,
    ! [VarCurr: state_type] :
      ( v83688(VarCurr,17)
    <=> v83690(VarCurr,17) ) ).

tff(addAssignment_65718,axiom,
    ! [VarCurr: state_type] :
      ( v83690(VarCurr,17)
    <=> v83699(VarCurr,17) ) ).

tff(addAssignment_65717,axiom,
    ! [VarCurr: state_type] :
      ( v83692(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65716,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,17)
    <=> v5475(VarCurr,17) ) ).

tff(addAssignment_65715,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,17)
    <=> v5477(VarCurr,17) ) ).

tff(addAssignment_65714,axiom,
    ! [VarNext: state_type] :
      ( v5477(VarNext,17)
    <=> v110057(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110058(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110057(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1388,axiom,
    ! [VarNext: state_type] :
      ( v110058(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110057(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110058(VarNext)
      <=> v110059(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110059(VarNext)
      <=> ( v110061(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_5977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110061(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_65713,axiom,
    ! [VarCurr: state_type] :
      ( v83638(VarCurr,17)
    <=> v83640(VarCurr,17) ) ).

tff(addAssignment_65712,axiom,
    ! [VarCurr: state_type] :
      ( v83640(VarCurr,17)
    <=> v83649(VarCurr,17) ) ).

tff(addAssignment_65711,axiom,
    ! [VarCurr: state_type] :
      ( v83642(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65710,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,17)
    <=> v5468(VarCurr,17) ) ).

tff(addAssignment_65709,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,17)
    <=> v5470(VarCurr,17) ) ).

tff(addAssignment_65708,axiom,
    ! [VarNext: state_type] :
      ( v5470(VarNext,17)
    <=> v110049(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110050(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110049(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1387,axiom,
    ! [VarNext: state_type] :
      ( v110050(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110049(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110050(VarNext)
      <=> v110051(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110051(VarNext)
      <=> ( v110053(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_5976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110053(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_65707,axiom,
    ! [VarCurr: state_type] :
      ( v83588(VarCurr,17)
    <=> v83590(VarCurr,17) ) ).

tff(addAssignment_65706,axiom,
    ! [VarCurr: state_type] :
      ( v83590(VarCurr,17)
    <=> v83599(VarCurr,17) ) ).

tff(addAssignment_65705,axiom,
    ! [VarCurr: state_type] :
      ( v83592(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65704,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,17)
    <=> v5461(VarCurr,17) ) ).

tff(addAssignment_65703,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,17)
    <=> v5463(VarCurr,17) ) ).

tff(addAssignment_65702,axiom,
    ! [VarNext: state_type] :
      ( v5463(VarNext,17)
    <=> v110041(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110042(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110041(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1386,axiom,
    ! [VarNext: state_type] :
      ( v110042(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110041(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110042(VarNext)
      <=> v110043(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110043(VarNext)
      <=> ( v110045(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_5975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110045(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_65701,axiom,
    ! [VarCurr: state_type] :
      ( v83538(VarCurr,17)
    <=> v83540(VarCurr,17) ) ).

tff(addAssignment_65700,axiom,
    ! [VarCurr: state_type] :
      ( v83540(VarCurr,17)
    <=> v83549(VarCurr,17) ) ).

tff(addAssignment_65699,axiom,
    ! [VarCurr: state_type] :
      ( v83542(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65698,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,17)
    <=> v5454(VarCurr,17) ) ).

tff(addAssignment_65697,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,17)
    <=> v5456(VarCurr,17) ) ).

tff(addAssignment_65696,axiom,
    ! [VarNext: state_type] :
      ( v5456(VarNext,17)
    <=> v110033(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110034(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110033(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1385,axiom,
    ! [VarNext: state_type] :
      ( v110034(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110033(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110034(VarNext)
      <=> v110035(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110035(VarNext)
      <=> ( v110037(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_5974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110037(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_65695,axiom,
    ! [VarCurr: state_type] :
      ( v83488(VarCurr,17)
    <=> v83490(VarCurr,17) ) ).

tff(addAssignment_65694,axiom,
    ! [VarCurr: state_type] :
      ( v83490(VarCurr,17)
    <=> v83499(VarCurr,17) ) ).

tff(addAssignment_65693,axiom,
    ! [VarCurr: state_type] :
      ( v83492(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65692,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,17)
    <=> v5447(VarCurr,17) ) ).

tff(addAssignment_65691,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,17)
    <=> v5449(VarCurr,17) ) ).

tff(addAssignment_65690,axiom,
    ! [VarNext: state_type] :
      ( v5449(VarNext,17)
    <=> v110025(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110026(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110025(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1384,axiom,
    ! [VarNext: state_type] :
      ( v110026(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110025(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110026(VarNext)
      <=> v110027(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110027(VarNext)
      <=> ( v110029(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_5973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110029(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_65689,axiom,
    ! [VarCurr: state_type] :
      ( v83438(VarCurr,17)
    <=> v83440(VarCurr,17) ) ).

tff(addAssignment_65688,axiom,
    ! [VarCurr: state_type] :
      ( v83440(VarCurr,17)
    <=> v83449(VarCurr,17) ) ).

tff(addAssignment_65687,axiom,
    ! [VarCurr: state_type] :
      ( v83442(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65686,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,17)
    <=> v5440(VarCurr,17) ) ).

tff(addAssignment_65685,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,17)
    <=> v5442(VarCurr,17) ) ).

tff(addAssignment_65684,axiom,
    ! [VarNext: state_type] :
      ( v5442(VarNext,17)
    <=> v110017(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110018(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110017(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1383,axiom,
    ! [VarNext: state_type] :
      ( v110018(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110017(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110018(VarNext)
      <=> v110019(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110019(VarNext)
      <=> ( v110021(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_5972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110021(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_65683,axiom,
    ! [VarCurr: state_type] :
      ( v83388(VarCurr,17)
    <=> v83390(VarCurr,17) ) ).

tff(addAssignment_65682,axiom,
    ! [VarCurr: state_type] :
      ( v83390(VarCurr,17)
    <=> v83399(VarCurr,17) ) ).

tff(addAssignment_65681,axiom,
    ! [VarCurr: state_type] :
      ( v83392(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65680,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,17)
    <=> v5433(VarCurr,17) ) ).

tff(addAssignment_65679,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,17)
    <=> v5435(VarCurr,17) ) ).

tff(addAssignment_65678,axiom,
    ! [VarNext: state_type] :
      ( v5435(VarNext,17)
    <=> v110009(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110010(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110009(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1382,axiom,
    ! [VarNext: state_type] :
      ( v110010(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110009(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110010(VarNext)
      <=> v110011(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110011(VarNext)
      <=> ( v110013(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_5971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110013(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_65677,axiom,
    ! [VarCurr: state_type] :
      ( v83338(VarCurr,17)
    <=> v83340(VarCurr,17) ) ).

tff(addAssignment_65676,axiom,
    ! [VarCurr: state_type] :
      ( v83340(VarCurr,17)
    <=> v83349(VarCurr,17) ) ).

tff(addAssignment_65675,axiom,
    ! [VarCurr: state_type] :
      ( v83342(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65674,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,17)
    <=> v5426(VarCurr,17) ) ).

tff(addAssignment_65673,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,17)
    <=> v5428(VarCurr,17) ) ).

tff(addAssignment_65672,axiom,
    ! [VarNext: state_type] :
      ( v5428(VarNext,17)
    <=> v110001(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v110001(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1381,axiom,
    ! [VarNext: state_type] :
      ( v110002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v110001(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110002(VarNext)
      <=> v110003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v110003(VarNext)
      <=> ( v110005(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_5970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v110005(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_65671,axiom,
    ! [VarCurr: state_type] :
      ( v83288(VarCurr,17)
    <=> v83290(VarCurr,17) ) ).

tff(addAssignment_65670,axiom,
    ! [VarCurr: state_type] :
      ( v83290(VarCurr,17)
    <=> v83299(VarCurr,17) ) ).

tff(addAssignment_65669,axiom,
    ! [VarCurr: state_type] :
      ( v83292(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65668,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,17)
    <=> v5420(VarCurr,17) ) ).

tff(addAssignment_65667,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,17)
    <=> v5422(VarCurr,17) ) ).

tff(addAssignment_65666,axiom,
    ! [VarNext: state_type] :
      ( v5422(VarNext,17)
    <=> v109993(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109994(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109993(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1380,axiom,
    ! [VarNext: state_type] :
      ( v109994(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109993(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109994(VarNext)
      <=> v109995(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109995(VarNext)
      <=> ( v109997(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_5969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109997(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_65665,axiom,
    ! [VarCurr: state_type] :
      ( v82920(VarCurr,17)
    <=> v82922(VarCurr,17) ) ).

tff(addAssignment_65664,axiom,
    ! [VarCurr: state_type] :
      ( v82922(VarCurr,17)
    <=> v83246(VarCurr,17) ) ).

tff(addAssignment_65663,axiom,
    ! [VarCurr: state_type] :
      ( v82924(VarCurr,17)
    <=> v82926(VarCurr,17) ) ).

tff(addAssignment_65662,axiom,
    ! [VarCurr: state_type] :
      ( v82926(VarCurr,17)
    <=> v82928(VarCurr,17) ) ).

tff(addAssignment_65661,axiom,
    ! [VarCurr: state_type] :
      ( v82928(VarCurr,17)
    <=> v82930(VarCurr,17) ) ).

tff(addAssignment_65660,axiom,
    ! [VarCurr: state_type] :
      ( v82930(VarCurr,17)
    <=> v82932(VarCurr,17) ) ).

tff(addAssignment_65659,axiom,
    ! [VarCurr: state_type] :
      ( v82932(VarCurr,17)
    <=> v83008(VarCurr,17) ) ).

tff(addAssignment_65658,axiom,
    ! [VarCurr: state_type] :
      ( v83012(VarCurr)
    <=> v109989(VarCurr,1) ) ).

tff(addAssignment_65657,axiom,
    ! [VarCurr: state_type] :
      ( v109989(VarCurr,1)
    <=> v109991(VarCurr,1) ) ).

tff(addAssignment_65656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v781(VarCurr,B)
      <=> v783(VarCurr,B) ) ) ).

tff(addAssignment_65655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v783(VarCurr,B)
      <=> v5329(VarCurr,B) ) ) ).

tff(addAssignment_65654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5324(VarCurr,B)
      <=> v5326(VarCurr,B) ) ) ).

tff(addAssignment_65653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5326(VarCurr,B)
      <=> v5328(VarCurr,B) ) ) ).

tff(addAssignment_65652,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5328(VarNext,B)
      <=> v109978(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109979(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109978(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1379,axiom,
    ! [VarNext: state_type] :
      ( v109979(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109978(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109979(VarNext)
      <=> v109980(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109980(VarNext)
      <=> ( v109982(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_5968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109982(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_65651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v103020(VarCurr,B)
      <=> v103022(VarCurr,B) ) ) ).

tff(addAssignment_65650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v103022(VarCurr,B)
      <=> v103031(VarCurr,B) ) ) ).

tff(addAssignment_65649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v103024(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5318(VarCurr,B)
      <=> v5320(VarCurr,B) ) ) ).

tff(addAssignment_65647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5320(VarCurr,B)
      <=> v5322(VarCurr,B) ) ) ).

tff(addAssignment_65646,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5322(VarNext,B)
      <=> v109970(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1378,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109971(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109970(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1378,axiom,
    ! [VarNext: state_type] :
      ( v109971(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109970(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109971(VarNext)
      <=> v109972(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109972(VarNext)
      <=> ( v109974(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_5967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109974(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_65645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102970(VarCurr,B)
      <=> v102972(VarCurr,B) ) ) ).

tff(addAssignment_65644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102972(VarCurr,B)
      <=> v102981(VarCurr,B) ) ) ).

tff(addAssignment_65643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102974(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5311(VarCurr,B)
      <=> v5313(VarCurr,B) ) ) ).

tff(addAssignment_65641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5313(VarCurr,B)
      <=> v5315(VarCurr,B) ) ) ).

tff(addAssignment_65640,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5315(VarNext,B)
      <=> v109962(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109963(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109962(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1377,axiom,
    ! [VarNext: state_type] :
      ( v109963(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109962(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109963(VarNext)
      <=> v109964(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109964(VarNext)
      <=> ( v109966(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_5966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109966(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_65639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102920(VarCurr,B)
      <=> v102922(VarCurr,B) ) ) ).

tff(addAssignment_65638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102922(VarCurr,B)
      <=> v102931(VarCurr,B) ) ) ).

tff(addAssignment_65637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102924(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5304(VarCurr,B)
      <=> v5306(VarCurr,B) ) ) ).

tff(addAssignment_65635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5306(VarCurr,B)
      <=> v5308(VarCurr,B) ) ) ).

tff(addAssignment_65634,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5308(VarNext,B)
      <=> v109954(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109955(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109954(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1376,axiom,
    ! [VarNext: state_type] :
      ( v109955(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109954(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109955(VarNext)
      <=> v109956(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109956(VarNext)
      <=> ( v109958(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_5965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109958(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_65633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102870(VarCurr,B)
      <=> v102872(VarCurr,B) ) ) ).

tff(addAssignment_65632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102872(VarCurr,B)
      <=> v102881(VarCurr,B) ) ) ).

tff(addAssignment_65631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102874(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5297(VarCurr,B)
      <=> v5299(VarCurr,B) ) ) ).

tff(addAssignment_65629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5299(VarCurr,B)
      <=> v5301(VarCurr,B) ) ) ).

tff(addAssignment_65628,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5301(VarNext,B)
      <=> v109946(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109946(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1375,axiom,
    ! [VarNext: state_type] :
      ( v109947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109946(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109947(VarNext)
      <=> v109948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109948(VarNext)
      <=> ( v109950(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_5964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109950(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_65627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102820(VarCurr,B)
      <=> v102822(VarCurr,B) ) ) ).

tff(addAssignment_65626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102822(VarCurr,B)
      <=> v102831(VarCurr,B) ) ) ).

tff(addAssignment_65625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102824(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5290(VarCurr,B)
      <=> v5292(VarCurr,B) ) ) ).

tff(addAssignment_65623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5292(VarCurr,B)
      <=> v5294(VarCurr,B) ) ) ).

tff(addAssignment_65622,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5294(VarNext,B)
      <=> v109938(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109939(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109938(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1374,axiom,
    ! [VarNext: state_type] :
      ( v109939(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109938(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109939(VarNext)
      <=> v109940(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109940(VarNext)
      <=> ( v109942(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_5963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109942(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_65621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102770(VarCurr,B)
      <=> v102772(VarCurr,B) ) ) ).

tff(addAssignment_65620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102772(VarCurr,B)
      <=> v102781(VarCurr,B) ) ) ).

tff(addAssignment_65619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102774(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5283(VarCurr,B)
      <=> v5285(VarCurr,B) ) ) ).

tff(addAssignment_65617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5285(VarCurr,B)
      <=> v5287(VarCurr,B) ) ) ).

tff(addAssignment_65616,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5287(VarNext,B)
      <=> v109930(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109931(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109930(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1373,axiom,
    ! [VarNext: state_type] :
      ( v109931(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109930(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109931(VarNext)
      <=> v109932(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109932(VarNext)
      <=> ( v109934(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_5962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109934(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_65615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102720(VarCurr,B)
      <=> v102722(VarCurr,B) ) ) ).

tff(addAssignment_65614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102722(VarCurr,B)
      <=> v102731(VarCurr,B) ) ) ).

tff(addAssignment_65613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102724(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5276(VarCurr,B)
      <=> v5278(VarCurr,B) ) ) ).

tff(addAssignment_65611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5278(VarCurr,B)
      <=> v5280(VarCurr,B) ) ) ).

tff(addAssignment_65610,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5280(VarNext,B)
      <=> v109922(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109923(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109922(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1372,axiom,
    ! [VarNext: state_type] :
      ( v109923(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109922(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109923(VarNext)
      <=> v109924(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109924(VarNext)
      <=> ( v109926(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_5961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109926(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_65609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102670(VarCurr,B)
      <=> v102672(VarCurr,B) ) ) ).

tff(addAssignment_65608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102672(VarCurr,B)
      <=> v102681(VarCurr,B) ) ) ).

tff(addAssignment_65607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102674(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5269(VarCurr,B)
      <=> v5271(VarCurr,B) ) ) ).

tff(addAssignment_65605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5271(VarCurr,B)
      <=> v5273(VarCurr,B) ) ) ).

tff(addAssignment_65604,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5273(VarNext,B)
      <=> v109914(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109915(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109914(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1371,axiom,
    ! [VarNext: state_type] :
      ( v109915(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109914(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109915(VarNext)
      <=> v109916(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109916(VarNext)
      <=> ( v109918(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_5960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109918(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_65603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102620(VarCurr,B)
      <=> v102622(VarCurr,B) ) ) ).

tff(addAssignment_65602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102622(VarCurr,B)
      <=> v102631(VarCurr,B) ) ) ).

tff(addAssignment_65601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102624(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5262(VarCurr,B)
      <=> v5264(VarCurr,B) ) ) ).

tff(addAssignment_65599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5264(VarCurr,B)
      <=> v5266(VarCurr,B) ) ) ).

tff(addAssignment_65598,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5266(VarNext,B)
      <=> v109906(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109907(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109906(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1370,axiom,
    ! [VarNext: state_type] :
      ( v109907(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109906(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109907(VarNext)
      <=> v109908(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109908(VarNext)
      <=> ( v109910(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_5959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109910(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_65597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102570(VarCurr,B)
      <=> v102572(VarCurr,B) ) ) ).

tff(addAssignment_65596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102572(VarCurr,B)
      <=> v102581(VarCurr,B) ) ) ).

tff(addAssignment_65595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102574(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5255(VarCurr,B)
      <=> v5257(VarCurr,B) ) ) ).

tff(addAssignment_65593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5257(VarCurr,B)
      <=> v5259(VarCurr,B) ) ) ).

tff(addAssignment_65592,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5259(VarNext,B)
      <=> v109898(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109899(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109898(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1369,axiom,
    ! [VarNext: state_type] :
      ( v109899(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109898(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109899(VarNext)
      <=> v109900(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109900(VarNext)
      <=> ( v109902(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_5958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109902(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_65591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102520(VarCurr,B)
      <=> v102522(VarCurr,B) ) ) ).

tff(addAssignment_65590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102522(VarCurr,B)
      <=> v102531(VarCurr,B) ) ) ).

tff(addAssignment_65589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102524(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5248(VarCurr,B)
      <=> v5250(VarCurr,B) ) ) ).

tff(addAssignment_65587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5250(VarCurr,B)
      <=> v5252(VarCurr,B) ) ) ).

tff(addAssignment_65586,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5252(VarNext,B)
      <=> v109890(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109891(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109890(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1368,axiom,
    ! [VarNext: state_type] :
      ( v109891(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109890(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109891(VarNext)
      <=> v109892(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109892(VarNext)
      <=> ( v109894(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_5957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109894(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_65585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102470(VarCurr,B)
      <=> v102472(VarCurr,B) ) ) ).

tff(addAssignment_65584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102472(VarCurr,B)
      <=> v102481(VarCurr,B) ) ) ).

tff(addAssignment_65583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102474(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5241(VarCurr,B)
      <=> v5243(VarCurr,B) ) ) ).

tff(addAssignment_65581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5243(VarCurr,B)
      <=> v5245(VarCurr,B) ) ) ).

tff(addAssignment_65580,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5245(VarNext,B)
      <=> v109882(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109883(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109882(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1367,axiom,
    ! [VarNext: state_type] :
      ( v109883(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109882(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109883(VarNext)
      <=> v109884(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109884(VarNext)
      <=> ( v109886(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_5956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109886(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_65579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102420(VarCurr,B)
      <=> v102422(VarCurr,B) ) ) ).

tff(addAssignment_65578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102422(VarCurr,B)
      <=> v102431(VarCurr,B) ) ) ).

tff(addAssignment_65577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102424(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5234(VarCurr,B)
      <=> v5236(VarCurr,B) ) ) ).

tff(addAssignment_65575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5236(VarCurr,B)
      <=> v5238(VarCurr,B) ) ) ).

tff(addAssignment_65574,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5238(VarNext,B)
      <=> v109874(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109875(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109874(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1366,axiom,
    ! [VarNext: state_type] :
      ( v109875(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109874(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109875(VarNext)
      <=> v109876(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109876(VarNext)
      <=> ( v109878(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_5955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109878(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_65573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102370(VarCurr,B)
      <=> v102372(VarCurr,B) ) ) ).

tff(addAssignment_65572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102372(VarCurr,B)
      <=> v102381(VarCurr,B) ) ) ).

tff(addAssignment_65571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102374(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5227(VarCurr,B)
      <=> v5229(VarCurr,B) ) ) ).

tff(addAssignment_65569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5229(VarCurr,B)
      <=> v5231(VarCurr,B) ) ) ).

tff(addAssignment_65568,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5231(VarNext,B)
      <=> v109866(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109867(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109866(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1365,axiom,
    ! [VarNext: state_type] :
      ( v109867(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109866(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109867(VarNext)
      <=> v109868(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109868(VarNext)
      <=> ( v109870(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_5954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109870(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_65567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102320(VarCurr,B)
      <=> v102322(VarCurr,B) ) ) ).

tff(addAssignment_65566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102322(VarCurr,B)
      <=> v102331(VarCurr,B) ) ) ).

tff(addAssignment_65565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102324(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5220(VarCurr,B)
      <=> v5222(VarCurr,B) ) ) ).

tff(addAssignment_65563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5222(VarCurr,B)
      <=> v5224(VarCurr,B) ) ) ).

tff(addAssignment_65562,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v5224(VarNext,B)
      <=> v109858(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109859(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109858(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1364,axiom,
    ! [VarNext: state_type] :
      ( v109859(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109858(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109859(VarNext)
      <=> v109860(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109860(VarNext)
      <=> ( v109862(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_5953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109862(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_65561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102270(VarCurr,B)
      <=> v102272(VarCurr,B) ) ) ).

tff(addAssignment_65560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102272(VarCurr,B)
      <=> v102281(VarCurr,B) ) ) ).

tff(addAssignment_65559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v102274(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v884(VarCurr,B)
      <=> v886(VarCurr,B) ) ) ).

tff(addAssignment_65557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v886(VarCurr,B)
      <=> v888(VarCurr,B) ) ) ).

tff(addAssignment_65556,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v888(VarNext,B)
      <=> v109850(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109851(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v109850(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1363,axiom,
    ! [VarNext: state_type] :
      ( v109851(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v109850(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109851(VarNext)
      <=> v109852(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109852(VarNext)
      <=> ( v109854(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_5952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109854(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_65555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v898(VarCurr,B)
      <=> v900(VarCurr,B) ) ) ).

tff(addAssignment_65554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v900(VarCurr,B)
      <=> v102231(VarCurr,B) ) ) ).

tff(addAssignment_65553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v902(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_65552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v904(VarCurr,B)
      <=> v906(VarCurr,B) ) ) ).

tff(addAssignment_65551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v906(VarCurr,B)
      <=> v908(VarCurr,B) ) ) ).

tff(addAssignment_65550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,7) )
     => ( v908(VarCurr,B)
      <=> v910(VarCurr,B) ) ) ).

tff(addAssignment_65549,axiom,
    ! [VarCurr: state_type] :
      ( ( v910(VarCurr,9)
      <=> v912(VarCurr,8) )
      & ( v910(VarCurr,8)
      <=> v912(VarCurr,7) )
      & ( v910(VarCurr,7)
      <=> v912(VarCurr,6) ) ) ).

tff(addAssignment_65548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v912(VarCurr,B)
      <=> v914(VarCurr,B) ) ) ).

tff(addAssignment_65547,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v914(VarNext,B)
      <=> v109842(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109843(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v109842(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1362,axiom,
    ! [VarNext: state_type] :
      ( v109843(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v109842(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109843(VarNext)
      <=> v109844(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109844(VarNext)
      <=> ( v109846(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_5951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109846(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_65546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v932(VarCurr,B)
      <=> v934(VarCurr,B) ) ) ).

tff(addAssignment_65545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v934(VarCurr,B)
      <=> v5598(VarCurr,B) ) ) ).

tff(addAssignment_65544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v936(VarCurr,B)
      <=> v938(VarCurr,B) ) ) ).

tff(addAssignment_65543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,6) )
     => ( v938(VarCurr,B)
      <=> v5589(VarCurr,B) ) ) ).

tff(addAssignment_65542,axiom,
    ! [VarCurr: state_type] :
      ( ( v5592(VarCurr,2)
      <=> v964(VarCurr,13) )
      & ( v5592(VarCurr,1)
      <=> v964(VarCurr,12) )
      & ( v5592(VarCurr,0)
      <=> v964(VarCurr,11) ) ) ).

tff(addAssignment_65541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v964(VarCurr,B)
      <=> v966(VarCurr,B) ) ) ).

tff(addAssignment_65540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v966(VarCurr,B)
      <=> v5526(VarCurr,B) ) ) ).

tff(addAssignment_65539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5521(VarCurr,B)
      <=> v5523(VarCurr,B) ) ) ).

tff(addAssignment_65538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5523(VarCurr,B)
      <=> v5525(VarCurr,B) ) ) ).

tff(addAssignment_65537,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5525(VarNext,B)
      <=> v109834(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109835(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109834(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1361,axiom,
    ! [VarNext: state_type] :
      ( v109835(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109834(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109835(VarNext)
      <=> v109836(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109836(VarNext)
      <=> ( v109838(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_5950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109838(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_65536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83988(VarCurr,B)
      <=> v83990(VarCurr,B) ) ) ).

tff(addAssignment_65535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83990(VarCurr,B)
      <=> v83999(VarCurr,B) ) ) ).

tff(addAssignment_65534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83992(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5514(VarCurr,B)
      <=> v5516(VarCurr,B) ) ) ).

tff(addAssignment_65532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5516(VarCurr,B)
      <=> v5518(VarCurr,B) ) ) ).

tff(addAssignment_65531,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5518(VarNext,B)
      <=> v109826(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109827(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109826(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1360,axiom,
    ! [VarNext: state_type] :
      ( v109827(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109826(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109827(VarNext)
      <=> v109828(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109828(VarNext)
      <=> ( v109830(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_5949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109830(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_65530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83938(VarCurr,B)
      <=> v83940(VarCurr,B) ) ) ).

tff(addAssignment_65529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83940(VarCurr,B)
      <=> v83949(VarCurr,B) ) ) ).

tff(addAssignment_65528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83942(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5507(VarCurr,B)
      <=> v5509(VarCurr,B) ) ) ).

tff(addAssignment_65526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5509(VarCurr,B)
      <=> v5511(VarCurr,B) ) ) ).

tff(addAssignment_65525,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5511(VarNext,B)
      <=> v109818(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109819(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109818(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1359,axiom,
    ! [VarNext: state_type] :
      ( v109819(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109818(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109819(VarNext)
      <=> v109820(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109820(VarNext)
      <=> ( v109822(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_5948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109822(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_65524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83888(VarCurr,B)
      <=> v83890(VarCurr,B) ) ) ).

tff(addAssignment_65523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83890(VarCurr,B)
      <=> v83899(VarCurr,B) ) ) ).

tff(addAssignment_65522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83892(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5500(VarCurr,B)
      <=> v5502(VarCurr,B) ) ) ).

tff(addAssignment_65520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5502(VarCurr,B)
      <=> v5504(VarCurr,B) ) ) ).

tff(addAssignment_65519,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5504(VarNext,B)
      <=> v109810(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109811(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109810(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1358,axiom,
    ! [VarNext: state_type] :
      ( v109811(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109810(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109811(VarNext)
      <=> v109812(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109812(VarNext)
      <=> ( v109814(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_5947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109814(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_65518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83838(VarCurr,B)
      <=> v83840(VarCurr,B) ) ) ).

tff(addAssignment_65517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83840(VarCurr,B)
      <=> v83849(VarCurr,B) ) ) ).

tff(addAssignment_65516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83842(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5493(VarCurr,B)
      <=> v5495(VarCurr,B) ) ) ).

tff(addAssignment_65514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5495(VarCurr,B)
      <=> v5497(VarCurr,B) ) ) ).

tff(addAssignment_65513,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5497(VarNext,B)
      <=> v109802(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109803(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109802(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1357,axiom,
    ! [VarNext: state_type] :
      ( v109803(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109802(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109803(VarNext)
      <=> v109804(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109804(VarNext)
      <=> ( v109806(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_5946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109806(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_65512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83788(VarCurr,B)
      <=> v83790(VarCurr,B) ) ) ).

tff(addAssignment_65511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83790(VarCurr,B)
      <=> v83799(VarCurr,B) ) ) ).

tff(addAssignment_65510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83792(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5487(VarCurr,B)
      <=> v5489(VarCurr,B) ) ) ).

tff(addAssignment_65508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5489(VarCurr,B)
      <=> v5491(VarCurr,B) ) ) ).

tff(addAssignment_65507,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5491(VarNext,B)
      <=> v109794(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109795(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109794(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1356,axiom,
    ! [VarNext: state_type] :
      ( v109795(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109794(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109795(VarNext)
      <=> v109796(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109796(VarNext)
      <=> ( v109798(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_5945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109798(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_65506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83738(VarCurr,B)
      <=> v83740(VarCurr,B) ) ) ).

tff(addAssignment_65505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83740(VarCurr,B)
      <=> v83749(VarCurr,B) ) ) ).

tff(addAssignment_65504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83742(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5480(VarCurr,B)
      <=> v5482(VarCurr,B) ) ) ).

tff(addAssignment_65502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5482(VarCurr,B)
      <=> v5484(VarCurr,B) ) ) ).

tff(addAssignment_65501,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5484(VarNext,B)
      <=> v109786(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109787(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109786(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1355,axiom,
    ! [VarNext: state_type] :
      ( v109787(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109786(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109787(VarNext)
      <=> v109788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109788(VarNext)
      <=> ( v109790(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_5944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109790(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_65500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83688(VarCurr,B)
      <=> v83690(VarCurr,B) ) ) ).

tff(addAssignment_65499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83690(VarCurr,B)
      <=> v83699(VarCurr,B) ) ) ).

tff(addAssignment_65498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83692(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5473(VarCurr,B)
      <=> v5475(VarCurr,B) ) ) ).

tff(addAssignment_65496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5475(VarCurr,B)
      <=> v5477(VarCurr,B) ) ) ).

tff(addAssignment_65495,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5477(VarNext,B)
      <=> v109778(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109779(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109778(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1354,axiom,
    ! [VarNext: state_type] :
      ( v109779(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109778(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109779(VarNext)
      <=> v109780(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109780(VarNext)
      <=> ( v109782(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_5943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109782(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_65494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83638(VarCurr,B)
      <=> v83640(VarCurr,B) ) ) ).

tff(addAssignment_65493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83640(VarCurr,B)
      <=> v83649(VarCurr,B) ) ) ).

tff(addAssignment_65492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83642(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5466(VarCurr,B)
      <=> v5468(VarCurr,B) ) ) ).

tff(addAssignment_65490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5468(VarCurr,B)
      <=> v5470(VarCurr,B) ) ) ).

tff(addAssignment_65489,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5470(VarNext,B)
      <=> v109770(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109771(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109770(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1353,axiom,
    ! [VarNext: state_type] :
      ( v109771(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109770(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109771(VarNext)
      <=> v109772(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109772(VarNext)
      <=> ( v109774(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_5942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109774(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_65488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83588(VarCurr,B)
      <=> v83590(VarCurr,B) ) ) ).

tff(addAssignment_65487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83590(VarCurr,B)
      <=> v83599(VarCurr,B) ) ) ).

tff(addAssignment_65486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83592(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5459(VarCurr,B)
      <=> v5461(VarCurr,B) ) ) ).

tff(addAssignment_65484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5461(VarCurr,B)
      <=> v5463(VarCurr,B) ) ) ).

tff(addAssignment_65483,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5463(VarNext,B)
      <=> v109762(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109763(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109762(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1352,axiom,
    ! [VarNext: state_type] :
      ( v109763(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109762(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109763(VarNext)
      <=> v109764(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109764(VarNext)
      <=> ( v109766(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_5941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109766(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_65482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83538(VarCurr,B)
      <=> v83540(VarCurr,B) ) ) ).

tff(addAssignment_65481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83540(VarCurr,B)
      <=> v83549(VarCurr,B) ) ) ).

tff(addAssignment_65480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83542(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5452(VarCurr,B)
      <=> v5454(VarCurr,B) ) ) ).

tff(addAssignment_65478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5454(VarCurr,B)
      <=> v5456(VarCurr,B) ) ) ).

tff(addAssignment_65477,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5456(VarNext,B)
      <=> v109754(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109755(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109754(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1351,axiom,
    ! [VarNext: state_type] :
      ( v109755(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109754(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109755(VarNext)
      <=> v109756(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109756(VarNext)
      <=> ( v109758(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_5940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109758(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_65476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83488(VarCurr,B)
      <=> v83490(VarCurr,B) ) ) ).

tff(addAssignment_65475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83490(VarCurr,B)
      <=> v83499(VarCurr,B) ) ) ).

tff(addAssignment_65474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83492(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5445(VarCurr,B)
      <=> v5447(VarCurr,B) ) ) ).

tff(addAssignment_65472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5447(VarCurr,B)
      <=> v5449(VarCurr,B) ) ) ).

tff(addAssignment_65471,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5449(VarNext,B)
      <=> v109746(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109747(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109746(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1350,axiom,
    ! [VarNext: state_type] :
      ( v109747(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109746(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109747(VarNext)
      <=> v109748(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109748(VarNext)
      <=> ( v109750(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_5939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109750(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_65470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83438(VarCurr,B)
      <=> v83440(VarCurr,B) ) ) ).

tff(addAssignment_65469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83440(VarCurr,B)
      <=> v83449(VarCurr,B) ) ) ).

tff(addAssignment_65468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83442(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5438(VarCurr,B)
      <=> v5440(VarCurr,B) ) ) ).

tff(addAssignment_65466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5440(VarCurr,B)
      <=> v5442(VarCurr,B) ) ) ).

tff(addAssignment_65465,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5442(VarNext,B)
      <=> v109738(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109739(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109738(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1349,axiom,
    ! [VarNext: state_type] :
      ( v109739(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109738(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109739(VarNext)
      <=> v109740(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109740(VarNext)
      <=> ( v109742(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_5938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109742(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_65464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83388(VarCurr,B)
      <=> v83390(VarCurr,B) ) ) ).

tff(addAssignment_65463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83390(VarCurr,B)
      <=> v83399(VarCurr,B) ) ) ).

tff(addAssignment_65462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83392(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5431(VarCurr,B)
      <=> v5433(VarCurr,B) ) ) ).

tff(addAssignment_65460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5433(VarCurr,B)
      <=> v5435(VarCurr,B) ) ) ).

tff(addAssignment_65459,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5435(VarNext,B)
      <=> v109730(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109731(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109730(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1348,axiom,
    ! [VarNext: state_type] :
      ( v109731(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109730(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109731(VarNext)
      <=> v109732(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109732(VarNext)
      <=> ( v109734(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_5937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109734(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_65458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83338(VarCurr,B)
      <=> v83340(VarCurr,B) ) ) ).

tff(addAssignment_65457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83340(VarCurr,B)
      <=> v83349(VarCurr,B) ) ) ).

tff(addAssignment_65456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83342(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5424(VarCurr,B)
      <=> v5426(VarCurr,B) ) ) ).

tff(addAssignment_65454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5426(VarCurr,B)
      <=> v5428(VarCurr,B) ) ) ).

tff(addAssignment_65453,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5428(VarNext,B)
      <=> v109722(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109723(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109722(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1347,axiom,
    ! [VarNext: state_type] :
      ( v109723(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109722(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109723(VarNext)
      <=> v109724(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109724(VarNext)
      <=> ( v109726(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_5936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109726(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_65452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83288(VarCurr,B)
      <=> v83290(VarCurr,B) ) ) ).

tff(addAssignment_65451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83290(VarCurr,B)
      <=> v83299(VarCurr,B) ) ) ).

tff(addAssignment_65450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v83292(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5418(VarCurr,B)
      <=> v5420(VarCurr,B) ) ) ).

tff(addAssignment_65448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5420(VarCurr,B)
      <=> v5422(VarCurr,B) ) ) ).

tff(addAssignment_65447,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v5422(VarNext,B)
      <=> v109714(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109715(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v109714(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1346,axiom,
    ! [VarNext: state_type] :
      ( v109715(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v109714(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109715(VarNext)
      <=> v109716(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109716(VarNext)
      <=> ( v109718(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_5935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109718(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_65446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82920(VarCurr,B)
      <=> v82922(VarCurr,B) ) ) ).

tff(addAssignment_65445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82922(VarCurr,B)
      <=> v83246(VarCurr,B) ) ) ).

tff(addAssignment_65444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82924(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_65443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82926(VarCurr,B)
      <=> v82928(VarCurr,B) ) ) ).

tff(addAssignment_65442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82928(VarCurr,B)
      <=> v82930(VarCurr,B) ) ) ).

tff(addAssignment_65441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82930(VarCurr,B)
      <=> v82932(VarCurr,B) ) ) ).

tff(addAssignment_65440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,11) )
     => ( v82932(VarCurr,B)
      <=> v83008(VarCurr,B) ) ) ).

tff(addAssignment_65439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83016(VarCurr,B)
      <=> v83015(VarCurr,B) ) ) ).

tff(addAssignment_65438,axiom,
    ! [VarCurr: state_type] :
      ( ( v83015(VarCurr,1)
      <=> v109709(VarCurr,4) )
      & ( v83015(VarCurr,0)
      <=> v109709(VarCurr,3) ) ) ).

tff(addAssignment_65437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,3) )
     => ( v109709(VarCurr,B)
      <=> v109711(VarCurr,B) ) ) ).

tff(addAssignment_65436,axiom,
    ! [VarCurr: state_type] :
      ( v83015(VarCurr,2)
    <=> v109709(VarCurr,5) ) ).

tff(addAssignment_65435,axiom,
    ! [VarCurr: state_type] :
      ( v109709(VarCurr,5)
    <=> v109711(VarCurr,5) ) ).

tff(addAssignment_65434,axiom,
    ! [VarCurr: state_type] :
      ( v109663(VarCurr)
    <=> v109665(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_825,axiom,
    ! [VarCurr: state_type] :
      ( v109665(VarCurr)
    <=> ( ( v785(VarCurr,5)
        <=> v5691(VarCurr,5) )
        & ( v785(VarCurr,4)
        <=> v5691(VarCurr,4) )
        & ( v785(VarCurr,3)
        <=> v5691(VarCurr,3) )
        & ( v785(VarCurr,2)
        <=> v5691(VarCurr,2) )
        & ( v785(VarCurr,1)
        <=> v5691(VarCurr,1) )
        & ( v785(VarCurr,0)
        <=> v5691(VarCurr,0) ) ) ) ).

tff(addAssignment_65433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v5691(VarCurr,B)
      <=> v5693(VarCurr,B) ) ) ).

tff(addAssignment_65432,axiom,
    ! [VarCurr: state_type] :
      ( v5693(VarCurr,5)
    <=> v5695(VarCurr,5) ) ).

tff(addAssignment_65431,axiom,
    ! [VarNext: state_type] :
      ( v5695(VarNext,5)
    <=> v109687(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109688(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v109687(VarNext,B)
            <=> v5695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1345,axiom,
    ! [VarNext: state_type] :
      ( v109688(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v109687(VarNext,B)
          <=> v109698(VarNext,B) ) ) ) ).

tff(addAssignment_65430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v109698(VarNext,B)
          <=> v109696(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109699(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v109696(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_938,axiom,
    ! [VarCurr: state_type] :
      ( v109699(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v109696(VarCurr,B)
          <=> v5705(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11124,axiom,
    ! [VarCurr: state_type] :
      ( v109699(VarCurr)
    <=> ( v109700(VarCurr)
        & v109701(VarCurr) ) ) ).

tff(writeUnaryOperator_5934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109701(VarCurr)
    <=> v5701(VarCurr) ) ).

tff(writeUnaryOperator_5933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109700(VarCurr)
    <=> v5697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109688(VarNext)
      <=> v109689(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109689(VarNext)
      <=> ( v109690(VarNext)
          & v109683(VarNext) ) ) ) ).

tff(writeUnaryOperator_5932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109690(VarNext)
      <=> v109692(VarNext) ) ) ).

tff(addAssignment_65429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109692(VarNext)
      <=> v109683(VarCurr) ) ) ).

tff(addAssignment_65428,axiom,
    ! [VarCurr: state_type] :
      ( v109683(VarCurr)
    <=> v109685(VarCurr) ) ).

tff(addAssignment_65427,axiom,
    ! [VarCurr: state_type] :
      ( v109685(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_65426,axiom,
    ! [VarCurr: state_type] :
      ( v5705(VarCurr,5)
    <=> v5707(VarCurr,5) ) ).

tff(addAssignment_65425,axiom,
    ! [VarCurr: state_type] :
      ( v5707(VarCurr,5)
    <=> v109674(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109674(VarCurr,B)
      <=> ( v109675(VarCurr,B)
          | v109678(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109678(VarCurr,B)
      <=> ( v5693(VarCurr,B)
          & v109679(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109679(VarCurr,B)
      <=> ~ v109680(VarCurr,B) ) ) ).

tff(addAssignment_65424,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,0)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65423,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,1)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65422,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,2)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65421,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,3)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65420,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,4)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65419,axiom,
    ! [VarCurr: state_type] :
      ( v109680(VarCurr,5)
    <=> v109681(VarCurr) ) ).

tff(addAssignment_65418,axiom,
    ! [VarCurr: state_type] :
      ( v109681(VarCurr)
    <=> v5743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109675(VarCurr,B)
      <=> ( v5709(VarCurr,B)
          & v109676(VarCurr,B) ) ) ) ).

tff(addAssignment_65417,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,0)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65416,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,1)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65415,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,2)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65414,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,3)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65413,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,4)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65412,axiom,
    ! [VarCurr: state_type] :
      ( v109676(VarCurr,5)
    <=> v109677(VarCurr) ) ).

tff(addAssignment_65411,axiom,
    ! [VarCurr: state_type] :
      ( v109677(VarCurr)
    <=> v5743(VarCurr) ) ).

tff(addAssignment_65410,axiom,
    ! [VarCurr: state_type] :
      ( v5709(VarCurr,5)
    <=> v5711(VarCurr,5) ) ).

tff(addAssignment_65409,axiom,
    ! [VarCurr: state_type] :
      ( v5711(VarCurr,5)
    <=> v5712(VarCurr,5) ) ).

tff(addAssignment_65408,axiom,
    ! [VarCurr: state_type] :
      ( v785(VarCurr,5)
    <=> v787(VarCurr,5) ) ).

tff(addAssignment_65407,axiom,
    ! [VarCurr: state_type] :
      ( v787(VarCurr,5)
    <=> v789(VarCurr,5) ) ).

tff(addAssignment_65406,axiom,
    ! [VarNext: state_type] :
      ( v789(VarNext,5)
    <=> v109667(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109668(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v109667(VarNext,B)
            <=> v789(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1344,axiom,
    ! [VarNext: state_type] :
      ( v109668(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v109667(VarNext,B)
          <=> v877(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109668(VarNext)
      <=> v109669(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109669(VarNext)
      <=> ( v109671(VarNext)
          & v860(VarNext) ) ) ) ).

tff(writeUnaryOperator_5930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109671(VarNext)
      <=> v871(VarNext) ) ) ).

tff(addAssignment_65405,axiom,
    ! [VarCurr: state_type] :
      ( v807(VarCurr,5)
    <=> v809(VarCurr,5) ) ).

tff(addAssignment_65404,axiom,
    ! [VarCurr: state_type] :
      ( v809(VarCurr,5)
    <=> v851(VarCurr,5) ) ).

tff(addAssignment_65403,axiom,
    ! [VarCurr: state_type] :
      ( v811(VarCurr,5)
    <=> v813(VarCurr,5) ) ).

tff(addAssignment_65402,axiom,
    ! [VarCurr: state_type] :
      ( v813(VarCurr,5)
    <=> v817(VarCurr,5) ) ).

tff(addAssignment_65401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101563(VarCurr,B)
      <=> v101565(VarCurr,B) ) ) ).

tff(addAssignment_65400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101565(VarCurr,B)
      <=> v101567(VarCurr,B) ) ) ).

tff(addAssignment_65399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101567(VarCurr,B)
      <=> v101568(VarCurr,B) ) ) ).

tff(addAssignment_65398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100229(VarCurr,B)
      <=> v101555(VarCurr,B) ) ) ).

tff(addAssignment_65397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100409(VarCurr,B)
      <=> v101508(VarCurr,B) ) ) ).

tff(addAssignment_65396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89243(VarCurr,B)
      <=> v89245(VarCurr,B) ) ) ).

tff(addAssignment_65395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89245(VarCurr,B)
      <=> v89247(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_28,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v89247(VarCurr,3)
      <=> v109657(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_58,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v89247(VarCurr,3)
      <=> v109656(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_27,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v109657(VarCurr)
      <=> v89247(VarCurr,5) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_57,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v109657(VarCurr)
      <=> v89247(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_26,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v109656(VarCurr)
      <=> v89247(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_56,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v109656(VarCurr)
      <=> v89247(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89247(VarCurr,B)
      <=> ( v109633(VarCurr,B)
          | v109653(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109653(VarCurr,B)
      <=> ( v109654(VarCurr,B)
          & v109486(VarCurr,B) ) ) ) ).

tff(addAssignment_65394,axiom,
    ! [VarCurr: state_type] :
      ( v109654(VarCurr,0)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65393,axiom,
    ! [VarCurr: state_type] :
      ( v109654(VarCurr,1)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65392,axiom,
    ! [VarCurr: state_type] :
      ( v109654(VarCurr,2)
    <=> v89249(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109633(VarCurr,B)
      <=> ( v109634(VarCurr,B)
          | v109651(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109651(VarCurr,B)
      <=> ( v109652(VarCurr,B)
          & v109425(VarCurr,B) ) ) ) ).

tff(addAssignment_65391,axiom,
    ! [VarCurr: state_type] :
      ( v109652(VarCurr,0)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65390,axiom,
    ! [VarCurr: state_type] :
      ( v109652(VarCurr,1)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65389,axiom,
    ! [VarCurr: state_type] :
      ( v109652(VarCurr,2)
    <=> v89249(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109634(VarCurr,B)
      <=> ( v109635(VarCurr,B)
          | v109649(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109649(VarCurr,B)
      <=> ( v109650(VarCurr,B)
          & v109364(VarCurr,B) ) ) ) ).

tff(addAssignment_65388,axiom,
    ! [VarCurr: state_type] :
      ( v109650(VarCurr,0)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65387,axiom,
    ! [VarCurr: state_type] :
      ( v109650(VarCurr,1)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65386,axiom,
    ! [VarCurr: state_type] :
      ( v109650(VarCurr,2)
    <=> v89249(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109635(VarCurr,B)
      <=> ( v109636(VarCurr,B)
          | v109647(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109647(VarCurr,B)
      <=> ( v109648(VarCurr,B)
          & v109303(VarCurr,B) ) ) ) ).

tff(addAssignment_65385,axiom,
    ! [VarCurr: state_type] :
      ( v109648(VarCurr,0)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65384,axiom,
    ! [VarCurr: state_type] :
      ( v109648(VarCurr,1)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65383,axiom,
    ! [VarCurr: state_type] :
      ( v109648(VarCurr,2)
    <=> v89249(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109636(VarCurr,B)
      <=> ( v109637(VarCurr,B)
          | v109645(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109645(VarCurr,B)
      <=> ( v109646(VarCurr,B)
          & v109242(VarCurr,B) ) ) ) ).

tff(addAssignment_65382,axiom,
    ! [VarCurr: state_type] :
      ( v109646(VarCurr,0)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65381,axiom,
    ! [VarCurr: state_type] :
      ( v109646(VarCurr,1)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65380,axiom,
    ! [VarCurr: state_type] :
      ( v109646(VarCurr,2)
    <=> v89249(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109637(VarCurr,B)
      <=> ( v109638(VarCurr,B)
          | v109643(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109643(VarCurr,B)
      <=> ( v109644(VarCurr,B)
          & v109181(VarCurr,B) ) ) ) ).

tff(addAssignment_65379,axiom,
    ! [VarCurr: state_type] :
      ( v109644(VarCurr,0)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65378,axiom,
    ! [VarCurr: state_type] :
      ( v109644(VarCurr,1)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65377,axiom,
    ! [VarCurr: state_type] :
      ( v109644(VarCurr,2)
    <=> v89249(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109638(VarCurr,B)
      <=> ( v109639(VarCurr,B)
          | v109641(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109641(VarCurr,B)
      <=> ( v109642(VarCurr,B)
          & v109114(VarCurr,B) ) ) ) ).

tff(addAssignment_65376,axiom,
    ! [VarCurr: state_type] :
      ( v109642(VarCurr,0)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65375,axiom,
    ! [VarCurr: state_type] :
      ( v109642(VarCurr,1)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65374,axiom,
    ! [VarCurr: state_type] :
      ( v109642(VarCurr,2)
    <=> v89249(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109639(VarCurr,B)
      <=> ( v109640(VarCurr,B)
          & v89253(VarCurr,B) ) ) ) ).

tff(addAssignment_65373,axiom,
    ! [VarCurr: state_type] :
      ( v109640(VarCurr,0)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65372,axiom,
    ! [VarCurr: state_type] :
      ( v109640(VarCurr,1)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65371,axiom,
    ! [VarCurr: state_type] :
      ( v109640(VarCurr,2)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65370,axiom,
    ! [VarCurr: state_type] :
      ( v89247(VarCurr,7)
    <=> v109609(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109609(VarCurr,B)
      <=> ( v109610(VarCurr,B)
          | v109630(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4530,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,0)
    <=> ( v109631(VarCurr,0)
        & v109486(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4529,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,1)
    <=> ( v109631(VarCurr,1)
        & v109486(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4528,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,2)
    <=> ( v109631(VarCurr,2)
        & v109486(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4527,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,3)
    <=> ( v109631(VarCurr,3)
        & v109486(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4526,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,4)
    <=> ( v109631(VarCurr,4)
        & v109486(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4525,axiom,
    ! [VarCurr: state_type] :
      ( v109630(VarCurr,5)
    <=> ( v109631(VarCurr,5)
        & v109486(VarCurr,8) ) ) ).

tff(addAssignment_65369,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,0)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65368,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,1)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65367,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,2)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65366,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,3)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65365,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,4)
    <=> v89249(VarCurr,0) ) ).

tff(addAssignment_65364,axiom,
    ! [VarCurr: state_type] :
      ( v109631(VarCurr,5)
    <=> v89249(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109610(VarCurr,B)
      <=> ( v109611(VarCurr,B)
          | v109628(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4524,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,0)
    <=> ( v109629(VarCurr,0)
        & v109425(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4523,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,1)
    <=> ( v109629(VarCurr,1)
        & v109425(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4522,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,2)
    <=> ( v109629(VarCurr,2)
        & v109425(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4521,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,3)
    <=> ( v109629(VarCurr,3)
        & v109425(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4520,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,4)
    <=> ( v109629(VarCurr,4)
        & v109425(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4519,axiom,
    ! [VarCurr: state_type] :
      ( v109628(VarCurr,5)
    <=> ( v109629(VarCurr,5)
        & v109425(VarCurr,8) ) ) ).

tff(addAssignment_65363,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,0)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65362,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,1)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65361,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,2)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65360,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,3)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65359,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,4)
    <=> v89249(VarCurr,1) ) ).

tff(addAssignment_65358,axiom,
    ! [VarCurr: state_type] :
      ( v109629(VarCurr,5)
    <=> v89249(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109611(VarCurr,B)
      <=> ( v109612(VarCurr,B)
          | v109626(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4518,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,0)
    <=> ( v109627(VarCurr,0)
        & v109364(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4517,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,1)
    <=> ( v109627(VarCurr,1)
        & v109364(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4516,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,2)
    <=> ( v109627(VarCurr,2)
        & v109364(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4515,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,3)
    <=> ( v109627(VarCurr,3)
        & v109364(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4514,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,4)
    <=> ( v109627(VarCurr,4)
        & v109364(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4513,axiom,
    ! [VarCurr: state_type] :
      ( v109626(VarCurr,5)
    <=> ( v109627(VarCurr,5)
        & v109364(VarCurr,8) ) ) ).

tff(addAssignment_65357,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,0)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65356,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,1)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65355,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,2)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65354,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,3)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65353,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,4)
    <=> v89249(VarCurr,2) ) ).

tff(addAssignment_65352,axiom,
    ! [VarCurr: state_type] :
      ( v109627(VarCurr,5)
    <=> v89249(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109612(VarCurr,B)
      <=> ( v109613(VarCurr,B)
          | v109624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4512,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,0)
    <=> ( v109625(VarCurr,0)
        & v109303(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4511,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,1)
    <=> ( v109625(VarCurr,1)
        & v109303(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4510,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,2)
    <=> ( v109625(VarCurr,2)
        & v109303(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4509,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,3)
    <=> ( v109625(VarCurr,3)
        & v109303(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4508,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,4)
    <=> ( v109625(VarCurr,4)
        & v109303(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4507,axiom,
    ! [VarCurr: state_type] :
      ( v109624(VarCurr,5)
    <=> ( v109625(VarCurr,5)
        & v109303(VarCurr,8) ) ) ).

tff(addAssignment_65351,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,0)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65350,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,1)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65349,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,2)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65348,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,3)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65347,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,4)
    <=> v89249(VarCurr,3) ) ).

tff(addAssignment_65346,axiom,
    ! [VarCurr: state_type] :
      ( v109625(VarCurr,5)
    <=> v89249(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109613(VarCurr,B)
      <=> ( v109614(VarCurr,B)
          | v109622(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4506,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,0)
    <=> ( v109623(VarCurr,0)
        & v109242(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4505,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,1)
    <=> ( v109623(VarCurr,1)
        & v109242(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4504,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,2)
    <=> ( v109623(VarCurr,2)
        & v109242(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4503,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,3)
    <=> ( v109623(VarCurr,3)
        & v109242(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4502,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,4)
    <=> ( v109623(VarCurr,4)
        & v109242(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4501,axiom,
    ! [VarCurr: state_type] :
      ( v109622(VarCurr,5)
    <=> ( v109623(VarCurr,5)
        & v109242(VarCurr,8) ) ) ).

tff(addAssignment_65345,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,0)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65344,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,1)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65343,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,2)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65342,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,3)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65341,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,4)
    <=> v89249(VarCurr,4) ) ).

tff(addAssignment_65340,axiom,
    ! [VarCurr: state_type] :
      ( v109623(VarCurr,5)
    <=> v89249(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109614(VarCurr,B)
      <=> ( v109615(VarCurr,B)
          | v109620(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4500,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,0)
    <=> ( v109621(VarCurr,0)
        & v109181(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4499,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,1)
    <=> ( v109621(VarCurr,1)
        & v109181(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4498,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,2)
    <=> ( v109621(VarCurr,2)
        & v109181(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4497,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,3)
    <=> ( v109621(VarCurr,3)
        & v109181(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4496,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,4)
    <=> ( v109621(VarCurr,4)
        & v109181(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4495,axiom,
    ! [VarCurr: state_type] :
      ( v109620(VarCurr,5)
    <=> ( v109621(VarCurr,5)
        & v109181(VarCurr,8) ) ) ).

tff(addAssignment_65339,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,0)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65338,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,1)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65337,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,2)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65336,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,3)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65335,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,4)
    <=> v89249(VarCurr,5) ) ).

tff(addAssignment_65334,axiom,
    ! [VarCurr: state_type] :
      ( v109621(VarCurr,5)
    <=> v89249(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v109615(VarCurr,B)
      <=> ( v109616(VarCurr,B)
          | v109618(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4494,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,0)
    <=> ( v109619(VarCurr,0)
        & v109114(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4493,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,1)
    <=> ( v109619(VarCurr,1)
        & v109114(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4492,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,2)
    <=> ( v109619(VarCurr,2)
        & v109114(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4491,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,3)
    <=> ( v109619(VarCurr,3)
        & v109114(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4490,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,4)
    <=> ( v109619(VarCurr,4)
        & v109114(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4489,axiom,
    ! [VarCurr: state_type] :
      ( v109618(VarCurr,5)
    <=> ( v109619(VarCurr,5)
        & v109114(VarCurr,8) ) ) ).

tff(addAssignment_65333,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,0)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65332,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,1)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65331,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,2)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65330,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,3)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65329,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,4)
    <=> v89249(VarCurr,6) ) ).

tff(addAssignment_65328,axiom,
    ! [VarCurr: state_type] :
      ( v109619(VarCurr,5)
    <=> v89249(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_4488,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,0)
    <=> ( v109617(VarCurr,0)
        & v89253(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4487,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,1)
    <=> ( v109617(VarCurr,1)
        & v89253(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4486,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,2)
    <=> ( v109617(VarCurr,2)
        & v89253(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4485,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,3)
    <=> ( v109617(VarCurr,3)
        & v89253(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4484,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,4)
    <=> ( v109617(VarCurr,4)
        & v89253(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4483,axiom,
    ! [VarCurr: state_type] :
      ( v109616(VarCurr,5)
    <=> ( v109617(VarCurr,5)
        & v89253(VarCurr,8) ) ) ).

tff(addAssignment_65327,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,0)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65326,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,1)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65325,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,2)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65324,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,3)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65323,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,4)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65322,axiom,
    ! [VarCurr: state_type] :
      ( v109617(VarCurr,5)
    <=> v89249(VarCurr,7) ) ).

tff(addAssignment_65321,axiom,
    ! [VarCurr: state_type] :
      ( v109486(VarCurr,6)
    <=> v109488(VarCurr,6) ) ).

tff(addAssignment_65320,axiom,
    ! [VarCurr: state_type] :
      ( v109488(VarCurr,6)
    <=> v109490(VarCurr,6) ) ).

tff(addAssignment_65319,axiom,
    ! [VarNext: state_type] :
      ( v109490(VarNext,6)
    <=> v109602(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109603(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109602(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1343,axiom,
    ! [VarNext: state_type] :
      ( v109603(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109602(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109603(VarNext)
      <=> v109604(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109604(VarNext)
      <=> ( v109606(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_5929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109606(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_65318,axiom,
    ! [VarCurr: state_type] :
      ( v109500(VarCurr,6)
    <=> v109502(VarCurr,6) ) ).

tff(addAssignment_65317,axiom,
    ! [VarCurr: state_type] :
      ( v109502(VarCurr,6)
    <=> v109515(VarCurr,6) ) ).

tff(addAssignment_65316,axiom,
    ! [VarCurr: state_type] :
      ( v109504(VarCurr,6)
    <=> v109506(VarCurr,6) ) ).

tff(addAssignment_65315,axiom,
    ! [VarCurr: state_type] :
      ( v109506(VarCurr,6)
    <=> v109507(VarCurr,6) ) ).

tff(addAssignment_65314,axiom,
    ! [VarCurr: state_type] :
      ( v109425(VarCurr,6)
    <=> v109427(VarCurr,6) ) ).

tff(addAssignment_65313,axiom,
    ! [VarCurr: state_type] :
      ( v109427(VarCurr,6)
    <=> v109429(VarCurr,6) ) ).

tff(addAssignment_65312,axiom,
    ! [VarNext: state_type] :
      ( v109429(VarNext,6)
    <=> v109594(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109595(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109594(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1342,axiom,
    ! [VarNext: state_type] :
      ( v109595(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109594(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109595(VarNext)
      <=> v109596(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109596(VarNext)
      <=> ( v109598(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_5928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109598(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_65311,axiom,
    ! [VarCurr: state_type] :
      ( v109439(VarCurr,6)
    <=> v109441(VarCurr,6) ) ).

tff(addAssignment_65310,axiom,
    ! [VarCurr: state_type] :
      ( v109441(VarCurr,6)
    <=> v109455(VarCurr,6) ) ).

tff(addAssignment_65309,axiom,
    ! [VarCurr: state_type] :
      ( v109443(VarCurr,6)
    <=> v109445(VarCurr,6) ) ).

tff(addAssignment_65308,axiom,
    ! [VarCurr: state_type] :
      ( v109445(VarCurr,6)
    <=> v109446(VarCurr,6) ) ).

tff(addAssignment_65307,axiom,
    ! [VarCurr: state_type] :
      ( v109364(VarCurr,6)
    <=> v109366(VarCurr,6) ) ).

tff(addAssignment_65306,axiom,
    ! [VarCurr: state_type] :
      ( v109366(VarCurr,6)
    <=> v109368(VarCurr,6) ) ).

tff(addAssignment_65305,axiom,
    ! [VarNext: state_type] :
      ( v109368(VarNext,6)
    <=> v109586(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109587(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109586(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1341,axiom,
    ! [VarNext: state_type] :
      ( v109587(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109586(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109587(VarNext)
      <=> v109588(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109588(VarNext)
      <=> ( v109590(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_5927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109590(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_65304,axiom,
    ! [VarCurr: state_type] :
      ( v109378(VarCurr,6)
    <=> v109380(VarCurr,6) ) ).

tff(addAssignment_65303,axiom,
    ! [VarCurr: state_type] :
      ( v109380(VarCurr,6)
    <=> v109394(VarCurr,6) ) ).

tff(addAssignment_65302,axiom,
    ! [VarCurr: state_type] :
      ( v109382(VarCurr,6)
    <=> v109384(VarCurr,6) ) ).

tff(addAssignment_65301,axiom,
    ! [VarCurr: state_type] :
      ( v109384(VarCurr,6)
    <=> v109385(VarCurr,6) ) ).

tff(addAssignment_65300,axiom,
    ! [VarCurr: state_type] :
      ( v109303(VarCurr,6)
    <=> v109305(VarCurr,6) ) ).

tff(addAssignment_65299,axiom,
    ! [VarCurr: state_type] :
      ( v109305(VarCurr,6)
    <=> v109307(VarCurr,6) ) ).

tff(addAssignment_65298,axiom,
    ! [VarNext: state_type] :
      ( v109307(VarNext,6)
    <=> v109578(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109579(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109578(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1340,axiom,
    ! [VarNext: state_type] :
      ( v109579(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109578(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109579(VarNext)
      <=> v109580(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109580(VarNext)
      <=> ( v109582(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_5926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109582(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_65297,axiom,
    ! [VarCurr: state_type] :
      ( v109317(VarCurr,6)
    <=> v109319(VarCurr,6) ) ).

tff(addAssignment_65296,axiom,
    ! [VarCurr: state_type] :
      ( v109319(VarCurr,6)
    <=> v109333(VarCurr,6) ) ).

tff(addAssignment_65295,axiom,
    ! [VarCurr: state_type] :
      ( v109321(VarCurr,6)
    <=> v109323(VarCurr,6) ) ).

tff(addAssignment_65294,axiom,
    ! [VarCurr: state_type] :
      ( v109323(VarCurr,6)
    <=> v109324(VarCurr,6) ) ).

tff(addAssignment_65293,axiom,
    ! [VarCurr: state_type] :
      ( v109242(VarCurr,6)
    <=> v109244(VarCurr,6) ) ).

tff(addAssignment_65292,axiom,
    ! [VarCurr: state_type] :
      ( v109244(VarCurr,6)
    <=> v109246(VarCurr,6) ) ).

tff(addAssignment_65291,axiom,
    ! [VarNext: state_type] :
      ( v109246(VarNext,6)
    <=> v109570(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109571(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109570(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1339,axiom,
    ! [VarNext: state_type] :
      ( v109571(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109570(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109571(VarNext)
      <=> v109572(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109572(VarNext)
      <=> ( v109574(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_5925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109574(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_65290,axiom,
    ! [VarCurr: state_type] :
      ( v109256(VarCurr,6)
    <=> v109258(VarCurr,6) ) ).

tff(addAssignment_65289,axiom,
    ! [VarCurr: state_type] :
      ( v109258(VarCurr,6)
    <=> v109272(VarCurr,6) ) ).

tff(addAssignment_65288,axiom,
    ! [VarCurr: state_type] :
      ( v109260(VarCurr,6)
    <=> v109262(VarCurr,6) ) ).

tff(addAssignment_65287,axiom,
    ! [VarCurr: state_type] :
      ( v109262(VarCurr,6)
    <=> v109263(VarCurr,6) ) ).

tff(addAssignment_65286,axiom,
    ! [VarCurr: state_type] :
      ( v109181(VarCurr,6)
    <=> v109183(VarCurr,6) ) ).

tff(addAssignment_65285,axiom,
    ! [VarCurr: state_type] :
      ( v109183(VarCurr,6)
    <=> v109185(VarCurr,6) ) ).

tff(addAssignment_65284,axiom,
    ! [VarNext: state_type] :
      ( v109185(VarNext,6)
    <=> v109562(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109563(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109562(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1338,axiom,
    ! [VarNext: state_type] :
      ( v109563(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109562(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109563(VarNext)
      <=> v109564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109564(VarNext)
      <=> ( v109566(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_5924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109566(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_65283,axiom,
    ! [VarCurr: state_type] :
      ( v109195(VarCurr,6)
    <=> v109197(VarCurr,6) ) ).

tff(addAssignment_65282,axiom,
    ! [VarCurr: state_type] :
      ( v109197(VarCurr,6)
    <=> v109211(VarCurr,6) ) ).

tff(addAssignment_65281,axiom,
    ! [VarCurr: state_type] :
      ( v109199(VarCurr,6)
    <=> v109201(VarCurr,6) ) ).

tff(addAssignment_65280,axiom,
    ! [VarCurr: state_type] :
      ( v109201(VarCurr,6)
    <=> v109202(VarCurr,6) ) ).

tff(addAssignment_65279,axiom,
    ! [VarCurr: state_type] :
      ( v109114(VarCurr,6)
    <=> v109116(VarCurr,6) ) ).

tff(addAssignment_65278,axiom,
    ! [VarCurr: state_type] :
      ( v109116(VarCurr,6)
    <=> v109118(VarCurr,6) ) ).

tff(addAssignment_65277,axiom,
    ! [VarNext: state_type] :
      ( v109118(VarNext,6)
    <=> v109554(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109555(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109554(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1337,axiom,
    ! [VarNext: state_type] :
      ( v109555(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109554(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109555(VarNext)
      <=> v109556(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109556(VarNext)
      <=> ( v109558(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_5923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109558(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_65276,axiom,
    ! [VarCurr: state_type] :
      ( v109128(VarCurr,6)
    <=> v109130(VarCurr,6) ) ).

tff(addAssignment_65275,axiom,
    ! [VarCurr: state_type] :
      ( v109130(VarCurr,6)
    <=> v109150(VarCurr,6) ) ).

tff(addAssignment_65274,axiom,
    ! [VarCurr: state_type] :
      ( v109132(VarCurr,6)
    <=> v109134(VarCurr,6) ) ).

tff(addAssignment_65273,axiom,
    ! [VarCurr: state_type] :
      ( v109134(VarCurr,6)
    <=> v109135(VarCurr,6) ) ).

tff(addAssignment_65272,axiom,
    ! [VarCurr: state_type] :
      ( v89253(VarCurr,6)
    <=> v89255(VarCurr,6) ) ).

tff(addAssignment_65271,axiom,
    ! [VarCurr: state_type] :
      ( v89255(VarCurr,6)
    <=> v89257(VarCurr,6) ) ).

tff(addAssignment_65270,axiom,
    ! [VarNext: state_type] :
      ( v89257(VarNext,6)
    <=> v109546(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109547(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109546(VarNext,B)
            <=> v89257(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1336,axiom,
    ! [VarNext: state_type] :
      ( v109547(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109546(VarNext,B)
          <=> v109107(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109547(VarNext)
      <=> v109548(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109548(VarNext)
      <=> ( v109550(VarNext)
          & v109092(VarNext) ) ) ) ).

tff(writeUnaryOperator_5922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109550(VarNext)
      <=> v109101(VarNext) ) ) ).

tff(addAssignment_65269,axiom,
    ! [VarCurr: state_type] :
      ( v89267(VarCurr,6)
    <=> v89269(VarCurr,6) ) ).

tff(addAssignment_65268,axiom,
    ! [VarCurr: state_type] :
      ( v89269(VarCurr,6)
    <=> v109083(VarCurr,6) ) ).

tff(addAssignment_65267,axiom,
    ! [VarCurr: state_type] :
      ( v89271(VarCurr,6)
    <=> v89273(VarCurr,6) ) ).

tff(addAssignment_65266,axiom,
    ! [VarCurr: state_type] :
      ( v89273(VarCurr,6)
    <=> v89275(VarCurr,6) ) ).

tff(addAssignment_65265,axiom,
    ! [VarCurr: state_type] :
      ( v89275(VarCurr,6)
    <=> v89333(VarCurr,6) ) ).

tff(addAssignment_65264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109486(VarCurr,B)
      <=> v109488(VarCurr,B) ) ) ).

tff(addAssignment_65263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109488(VarCurr,B)
      <=> v109490(VarCurr,B) ) ) ).

tff(addAssignment_65262,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109490(VarNext,B)
      <=> v109528(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109529(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109528(VarNext,B)
            <=> v109490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1335,axiom,
    ! [VarNext: state_type] :
      ( v109529(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109528(VarNext,B)
          <=> v109539(VarNext,B) ) ) ) ).

tff(addAssignment_65261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109539(VarNext,B)
          <=> v109537(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109540(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109537(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_937,axiom,
    ! [VarCurr: state_type] :
      ( v109540(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109537(VarCurr,B)
          <=> v109500(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11103,axiom,
    ! [VarCurr: state_type] :
      ( v109540(VarCurr)
    <=> ( v109541(VarCurr)
        & v109542(VarCurr) ) ) ).

tff(writeUnaryOperator_5921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109542(VarCurr)
    <=> v109496(VarCurr) ) ).

tff(writeUnaryOperator_5920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109541(VarCurr)
    <=> v109492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109529(VarNext)
      <=> v109530(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109530(VarNext)
      <=> ( v109531(VarNext)
          & v109524(VarNext) ) ) ) ).

tff(writeUnaryOperator_5919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109531(VarNext)
      <=> v109533(VarNext) ) ) ).

tff(addAssignment_65260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109533(VarNext)
      <=> v109524(VarCurr) ) ) ).

tff(addAssignment_65259,axiom,
    ! [VarCurr: state_type] :
      ( v109524(VarCurr)
    <=> v109526(VarCurr) ) ).

tff(addAssignment_65258,axiom,
    ! [VarCurr: state_type] :
      ( v109526(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109500(VarCurr,B)
      <=> v109502(VarCurr,B) ) ) ).

tff(addAssignment_65256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109502(VarCurr,B)
      <=> v109515(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109515(VarCurr,B)
      <=> ( v109516(VarCurr,B)
          | v109519(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109519(VarCurr,B)
      <=> ( v109488(VarCurr,B)
          & v109520(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109520(VarCurr,B)
      <=> ~ v109521(VarCurr,B) ) ) ).

tff(addAssignment_65255,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,0)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65254,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,1)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65253,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,2)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65252,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,3)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65251,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,4)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65250,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,5)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65249,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,6)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65248,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,7)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65247,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,8)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65246,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,9)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65245,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,10)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65244,axiom,
    ! [VarCurr: state_type] :
      ( v109521(VarCurr,11)
    <=> v109522(VarCurr) ) ).

tff(addAssignment_65243,axiom,
    ! [VarCurr: state_type] :
      ( v109522(VarCurr)
    <=> v109509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109516(VarCurr,B)
      <=> ( v109504(VarCurr,B)
          & v109517(VarCurr,B) ) ) ) ).

tff(addAssignment_65242,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,0)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65241,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,1)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65240,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,2)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65239,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,3)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65238,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,4)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65237,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,5)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65236,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,6)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65235,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,7)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65234,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,8)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65233,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,9)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65232,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,10)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65231,axiom,
    ! [VarCurr: state_type] :
      ( v109517(VarCurr,11)
    <=> v109518(VarCurr) ) ).

tff(addAssignment_65230,axiom,
    ! [VarCurr: state_type] :
      ( v109518(VarCurr)
    <=> v109509(VarCurr) ) ).

tff(addAssignment_65229,axiom,
    ! [VarCurr: state_type] :
      ( v109509(VarCurr)
    <=> v109511(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11100,axiom,
    ! [VarCurr: state_type] :
      ( v109511(VarCurr)
    <=> ( v109513(VarCurr)
        | v89383(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11099,axiom,
    ! [VarCurr: state_type] :
      ( v109513(VarCurr)
    <=> ( v109514(VarCurr)
        & v170(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_824,axiom,
    ! [VarCurr: state_type] :
      ( v109514(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $false )
        & ( v136(VarCurr,1)
        <=> $false )
        & ( v136(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_65228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109504(VarCurr,B)
      <=> v109506(VarCurr,B) ) ) ).

tff(addAssignment_65227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109506(VarCurr,B)
      <=> v109507(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109507(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_936,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109507(VarCurr,B)
          <=> v109425(VarCurr,B) ) ) ) ).

tff(addAssignment_65226,axiom,
    ! [VarCurr: state_type] :
      ( v109496(VarCurr)
    <=> v109498(VarCurr) ) ).

tff(addAssignment_65225,axiom,
    ! [VarCurr: state_type] :
      ( v109498(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65224,axiom,
    ! [VarCurr: state_type] :
      ( v109492(VarCurr)
    <=> v109494(VarCurr) ) ).

tff(addAssignment_65223,axiom,
    ! [VarCurr: state_type] :
      ( v109494(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109425(VarCurr,B)
      <=> v109427(VarCurr,B) ) ) ).

tff(addAssignment_65221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109427(VarCurr,B)
      <=> v109429(VarCurr,B) ) ) ).

tff(addAssignment_65220,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109429(VarNext,B)
      <=> v109468(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109469(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109468(VarNext,B)
            <=> v109429(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1334,axiom,
    ! [VarNext: state_type] :
      ( v109469(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109468(VarNext,B)
          <=> v109479(VarNext,B) ) ) ) ).

tff(addAssignment_65219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109479(VarNext,B)
          <=> v109477(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109477(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_935,axiom,
    ! [VarCurr: state_type] :
      ( v109480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109477(VarCurr,B)
          <=> v109439(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11098,axiom,
    ! [VarCurr: state_type] :
      ( v109480(VarCurr)
    <=> ( v109481(VarCurr)
        & v109482(VarCurr) ) ) ).

tff(writeUnaryOperator_5917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109482(VarCurr)
    <=> v109435(VarCurr) ) ).

tff(writeUnaryOperator_5916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109481(VarCurr)
    <=> v109431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109469(VarNext)
      <=> v109470(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109470(VarNext)
      <=> ( v109471(VarNext)
          & v109464(VarNext) ) ) ) ).

tff(writeUnaryOperator_5915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109471(VarNext)
      <=> v109473(VarNext) ) ) ).

tff(addAssignment_65218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109473(VarNext)
      <=> v109464(VarCurr) ) ) ).

tff(addAssignment_65217,axiom,
    ! [VarCurr: state_type] :
      ( v109464(VarCurr)
    <=> v109466(VarCurr) ) ).

tff(addAssignment_65216,axiom,
    ! [VarCurr: state_type] :
      ( v109466(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109439(VarCurr,B)
      <=> v109441(VarCurr,B) ) ) ).

tff(addAssignment_65214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109441(VarCurr,B)
      <=> v109455(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109455(VarCurr,B)
      <=> ( v109456(VarCurr,B)
          | v109459(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109459(VarCurr,B)
      <=> ( v109427(VarCurr,B)
          & v109460(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109460(VarCurr,B)
      <=> ~ v109461(VarCurr,B) ) ) ).

tff(addAssignment_65213,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,0)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65212,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,1)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65211,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,2)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65210,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,3)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65209,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,4)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65208,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,5)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65207,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,6)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65206,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,7)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65205,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,8)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65204,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,9)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65203,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,10)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65202,axiom,
    ! [VarCurr: state_type] :
      ( v109461(VarCurr,11)
    <=> v109462(VarCurr) ) ).

tff(addAssignment_65201,axiom,
    ! [VarCurr: state_type] :
      ( v109462(VarCurr)
    <=> v109448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109456(VarCurr,B)
      <=> ( v109443(VarCurr,B)
          & v109457(VarCurr,B) ) ) ) ).

tff(addAssignment_65200,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,0)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65199,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,1)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65198,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,2)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65197,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,3)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65196,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,4)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65195,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,5)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65194,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,6)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65193,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,7)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65192,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,8)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65191,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,9)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65190,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,10)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65189,axiom,
    ! [VarCurr: state_type] :
      ( v109457(VarCurr,11)
    <=> v109458(VarCurr) ) ).

tff(addAssignment_65188,axiom,
    ! [VarCurr: state_type] :
      ( v109458(VarCurr)
    <=> v109448(VarCurr) ) ).

tff(addAssignment_65187,axiom,
    ! [VarCurr: state_type] :
      ( v109448(VarCurr)
    <=> v109450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11095,axiom,
    ! [VarCurr: state_type] :
      ( v109450(VarCurr)
    <=> ( v109452(VarCurr)
        | v109454(VarCurr) ) ) ).

tff(addAssignment_65186,axiom,
    ! [VarCurr: state_type] :
      ( v109454(VarCurr)
    <=> v109149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11094,axiom,
    ! [VarCurr: state_type] :
      ( v109452(VarCurr)
    <=> ( v109453(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109453(VarCurr)
    <=> v134(VarCurr,1) ) ).

tff(addAssignment_65185,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,1)
    <=> v89340(VarCurr,1) ) ).

tff(addAssignment_65184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109443(VarCurr,B)
      <=> v109445(VarCurr,B) ) ) ).

tff(addAssignment_65183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109445(VarCurr,B)
      <=> v109446(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109446(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_934,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109446(VarCurr,B)
          <=> v109364(VarCurr,B) ) ) ) ).

tff(addAssignment_65182,axiom,
    ! [VarCurr: state_type] :
      ( v109435(VarCurr)
    <=> v109437(VarCurr) ) ).

tff(addAssignment_65181,axiom,
    ! [VarCurr: state_type] :
      ( v109437(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65180,axiom,
    ! [VarCurr: state_type] :
      ( v109431(VarCurr)
    <=> v109433(VarCurr) ) ).

tff(addAssignment_65179,axiom,
    ! [VarCurr: state_type] :
      ( v109433(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109364(VarCurr,B)
      <=> v109366(VarCurr,B) ) ) ).

tff(addAssignment_65177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109366(VarCurr,B)
      <=> v109368(VarCurr,B) ) ) ).

tff(addAssignment_65176,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109368(VarNext,B)
      <=> v109407(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109408(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109407(VarNext,B)
            <=> v109368(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1333,axiom,
    ! [VarNext: state_type] :
      ( v109408(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109407(VarNext,B)
          <=> v109418(VarNext,B) ) ) ) ).

tff(addAssignment_65175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109418(VarNext,B)
          <=> v109416(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109419(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109416(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_933,axiom,
    ! [VarCurr: state_type] :
      ( v109419(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109416(VarCurr,B)
          <=> v109378(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11093,axiom,
    ! [VarCurr: state_type] :
      ( v109419(VarCurr)
    <=> ( v109420(VarCurr)
        & v109421(VarCurr) ) ) ).

tff(writeUnaryOperator_5912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109421(VarCurr)
    <=> v109374(VarCurr) ) ).

tff(writeUnaryOperator_5911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109420(VarCurr)
    <=> v109370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109408(VarNext)
      <=> v109409(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109409(VarNext)
      <=> ( v109410(VarNext)
          & v109403(VarNext) ) ) ) ).

tff(writeUnaryOperator_5910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109410(VarNext)
      <=> v109412(VarNext) ) ) ).

tff(addAssignment_65174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109412(VarNext)
      <=> v109403(VarCurr) ) ) ).

tff(addAssignment_65173,axiom,
    ! [VarCurr: state_type] :
      ( v109403(VarCurr)
    <=> v109405(VarCurr) ) ).

tff(addAssignment_65172,axiom,
    ! [VarCurr: state_type] :
      ( v109405(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109378(VarCurr,B)
      <=> v109380(VarCurr,B) ) ) ).

tff(addAssignment_65170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109380(VarCurr,B)
      <=> v109394(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109394(VarCurr,B)
      <=> ( v109395(VarCurr,B)
          | v109398(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109398(VarCurr,B)
      <=> ( v109366(VarCurr,B)
          & v109399(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109399(VarCurr,B)
      <=> ~ v109400(VarCurr,B) ) ) ).

tff(addAssignment_65169,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,0)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65168,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,1)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65167,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,2)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65166,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,3)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65165,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,4)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65164,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,5)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65163,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,6)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65162,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,7)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65161,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,8)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65160,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,9)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65159,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,10)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65158,axiom,
    ! [VarCurr: state_type] :
      ( v109400(VarCurr,11)
    <=> v109401(VarCurr) ) ).

tff(addAssignment_65157,axiom,
    ! [VarCurr: state_type] :
      ( v109401(VarCurr)
    <=> v109387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109395(VarCurr,B)
      <=> ( v109382(VarCurr,B)
          & v109396(VarCurr,B) ) ) ) ).

tff(addAssignment_65156,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,0)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65155,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,1)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65154,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,2)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65153,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,3)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65152,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,4)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65151,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,5)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65150,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,6)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65149,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,7)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65148,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,8)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65147,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,9)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65146,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,10)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65145,axiom,
    ! [VarCurr: state_type] :
      ( v109396(VarCurr,11)
    <=> v109397(VarCurr) ) ).

tff(addAssignment_65144,axiom,
    ! [VarCurr: state_type] :
      ( v109397(VarCurr)
    <=> v109387(VarCurr) ) ).

tff(addAssignment_65143,axiom,
    ! [VarCurr: state_type] :
      ( v109387(VarCurr)
    <=> v109389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11090,axiom,
    ! [VarCurr: state_type] :
      ( v109389(VarCurr)
    <=> ( v109391(VarCurr)
        | v109393(VarCurr) ) ) ).

tff(addAssignment_65142,axiom,
    ! [VarCurr: state_type] :
      ( v109393(VarCurr)
    <=> v109148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11089,axiom,
    ! [VarCurr: state_type] :
      ( v109391(VarCurr)
    <=> ( v109392(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109392(VarCurr)
    <=> v134(VarCurr,2) ) ).

tff(addAssignment_65141,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,2)
    <=> v89340(VarCurr,2) ) ).

tff(addAssignment_65140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109382(VarCurr,B)
      <=> v109384(VarCurr,B) ) ) ).

tff(addAssignment_65139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109384(VarCurr,B)
      <=> v109385(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109385(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_932,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109385(VarCurr,B)
          <=> v109303(VarCurr,B) ) ) ) ).

tff(addAssignment_65138,axiom,
    ! [VarCurr: state_type] :
      ( v109374(VarCurr)
    <=> v109376(VarCurr) ) ).

tff(addAssignment_65137,axiom,
    ! [VarCurr: state_type] :
      ( v109376(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65136,axiom,
    ! [VarCurr: state_type] :
      ( v109370(VarCurr)
    <=> v109372(VarCurr) ) ).

tff(addAssignment_65135,axiom,
    ! [VarCurr: state_type] :
      ( v109372(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109303(VarCurr,B)
      <=> v109305(VarCurr,B) ) ) ).

tff(addAssignment_65133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109305(VarCurr,B)
      <=> v109307(VarCurr,B) ) ) ).

tff(addAssignment_65132,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109307(VarNext,B)
      <=> v109346(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109347(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109346(VarNext,B)
            <=> v109307(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1332,axiom,
    ! [VarNext: state_type] :
      ( v109347(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109346(VarNext,B)
          <=> v109357(VarNext,B) ) ) ) ).

tff(addAssignment_65131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109357(VarNext,B)
          <=> v109355(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109358(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109355(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_931,axiom,
    ! [VarCurr: state_type] :
      ( v109358(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109355(VarCurr,B)
          <=> v109317(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11088,axiom,
    ! [VarCurr: state_type] :
      ( v109358(VarCurr)
    <=> ( v109359(VarCurr)
        & v109360(VarCurr) ) ) ).

tff(writeUnaryOperator_5907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109360(VarCurr)
    <=> v109313(VarCurr) ) ).

tff(writeUnaryOperator_5906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109359(VarCurr)
    <=> v109309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109347(VarNext)
      <=> v109348(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109348(VarNext)
      <=> ( v109349(VarNext)
          & v109342(VarNext) ) ) ) ).

tff(writeUnaryOperator_5905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109349(VarNext)
      <=> v109351(VarNext) ) ) ).

tff(addAssignment_65130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109351(VarNext)
      <=> v109342(VarCurr) ) ) ).

tff(addAssignment_65129,axiom,
    ! [VarCurr: state_type] :
      ( v109342(VarCurr)
    <=> v109344(VarCurr) ) ).

tff(addAssignment_65128,axiom,
    ! [VarCurr: state_type] :
      ( v109344(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109317(VarCurr,B)
      <=> v109319(VarCurr,B) ) ) ).

tff(addAssignment_65126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109319(VarCurr,B)
      <=> v109333(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109333(VarCurr,B)
      <=> ( v109334(VarCurr,B)
          | v109337(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109337(VarCurr,B)
      <=> ( v109305(VarCurr,B)
          & v109338(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109338(VarCurr,B)
      <=> ~ v109339(VarCurr,B) ) ) ).

tff(addAssignment_65125,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,0)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65124,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,1)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65123,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,2)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65122,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,3)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65121,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,4)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65120,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,5)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65119,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,6)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65118,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,7)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65117,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,8)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65116,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,9)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65115,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,10)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65114,axiom,
    ! [VarCurr: state_type] :
      ( v109339(VarCurr,11)
    <=> v109340(VarCurr) ) ).

tff(addAssignment_65113,axiom,
    ! [VarCurr: state_type] :
      ( v109340(VarCurr)
    <=> v109326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109334(VarCurr,B)
      <=> ( v109321(VarCurr,B)
          & v109335(VarCurr,B) ) ) ) ).

tff(addAssignment_65112,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,0)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65111,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,1)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65110,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,2)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65109,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,3)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65108,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,4)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65107,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,5)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65106,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,6)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65105,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,7)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65104,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,8)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65103,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,9)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65102,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,10)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65101,axiom,
    ! [VarCurr: state_type] :
      ( v109335(VarCurr,11)
    <=> v109336(VarCurr) ) ).

tff(addAssignment_65100,axiom,
    ! [VarCurr: state_type] :
      ( v109336(VarCurr)
    <=> v109326(VarCurr) ) ).

tff(addAssignment_65099,axiom,
    ! [VarCurr: state_type] :
      ( v109326(VarCurr)
    <=> v109328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11085,axiom,
    ! [VarCurr: state_type] :
      ( v109328(VarCurr)
    <=> ( v109330(VarCurr)
        | v109332(VarCurr) ) ) ).

tff(addAssignment_65098,axiom,
    ! [VarCurr: state_type] :
      ( v109332(VarCurr)
    <=> v109147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11084,axiom,
    ! [VarCurr: state_type] :
      ( v109330(VarCurr)
    <=> ( v109331(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109331(VarCurr)
    <=> v134(VarCurr,3) ) ).

tff(addAssignment_65097,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,3)
    <=> v89340(VarCurr,3) ) ).

tff(addAssignment_65096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109321(VarCurr,B)
      <=> v109323(VarCurr,B) ) ) ).

tff(addAssignment_65095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109323(VarCurr,B)
      <=> v109324(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109324(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_930,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109324(VarCurr,B)
          <=> v109242(VarCurr,B) ) ) ) ).

tff(addAssignment_65094,axiom,
    ! [VarCurr: state_type] :
      ( v109313(VarCurr)
    <=> v109315(VarCurr) ) ).

tff(addAssignment_65093,axiom,
    ! [VarCurr: state_type] :
      ( v109315(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65092,axiom,
    ! [VarCurr: state_type] :
      ( v109309(VarCurr)
    <=> v109311(VarCurr) ) ).

tff(addAssignment_65091,axiom,
    ! [VarCurr: state_type] :
      ( v109311(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109242(VarCurr,B)
      <=> v109244(VarCurr,B) ) ) ).

tff(addAssignment_65089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109244(VarCurr,B)
      <=> v109246(VarCurr,B) ) ) ).

tff(addAssignment_65088,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109246(VarNext,B)
      <=> v109285(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109286(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109285(VarNext,B)
            <=> v109246(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1331,axiom,
    ! [VarNext: state_type] :
      ( v109286(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109285(VarNext,B)
          <=> v109296(VarNext,B) ) ) ) ).

tff(addAssignment_65087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109296(VarNext,B)
          <=> v109294(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109297(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109294(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_929,axiom,
    ! [VarCurr: state_type] :
      ( v109297(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109294(VarCurr,B)
          <=> v109256(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11083,axiom,
    ! [VarCurr: state_type] :
      ( v109297(VarCurr)
    <=> ( v109298(VarCurr)
        & v109299(VarCurr) ) ) ).

tff(writeUnaryOperator_5902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109299(VarCurr)
    <=> v109252(VarCurr) ) ).

tff(writeUnaryOperator_5901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109298(VarCurr)
    <=> v109248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109286(VarNext)
      <=> v109287(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109287(VarNext)
      <=> ( v109288(VarNext)
          & v109281(VarNext) ) ) ) ).

tff(writeUnaryOperator_5900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109288(VarNext)
      <=> v109290(VarNext) ) ) ).

tff(addAssignment_65086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109290(VarNext)
      <=> v109281(VarCurr) ) ) ).

tff(addAssignment_65085,axiom,
    ! [VarCurr: state_type] :
      ( v109281(VarCurr)
    <=> v109283(VarCurr) ) ).

tff(addAssignment_65084,axiom,
    ! [VarCurr: state_type] :
      ( v109283(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109256(VarCurr,B)
      <=> v109258(VarCurr,B) ) ) ).

tff(addAssignment_65082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109258(VarCurr,B)
      <=> v109272(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109272(VarCurr,B)
      <=> ( v109273(VarCurr,B)
          | v109276(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109276(VarCurr,B)
      <=> ( v109244(VarCurr,B)
          & v109277(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5899,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109277(VarCurr,B)
      <=> ~ v109278(VarCurr,B) ) ) ).

tff(addAssignment_65081,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,0)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65080,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,1)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65079,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,2)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65078,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,3)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65077,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,4)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65076,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,5)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65075,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,6)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65074,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,7)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65073,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,8)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65072,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,9)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65071,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,10)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65070,axiom,
    ! [VarCurr: state_type] :
      ( v109278(VarCurr,11)
    <=> v109279(VarCurr) ) ).

tff(addAssignment_65069,axiom,
    ! [VarCurr: state_type] :
      ( v109279(VarCurr)
    <=> v109265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109273(VarCurr,B)
      <=> ( v109260(VarCurr,B)
          & v109274(VarCurr,B) ) ) ) ).

tff(addAssignment_65068,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,0)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65067,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,1)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65066,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,2)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65065,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,3)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65064,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,4)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65063,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,5)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65062,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,6)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65061,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,7)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65060,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,8)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65059,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,9)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65058,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,10)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65057,axiom,
    ! [VarCurr: state_type] :
      ( v109274(VarCurr,11)
    <=> v109275(VarCurr) ) ).

tff(addAssignment_65056,axiom,
    ! [VarCurr: state_type] :
      ( v109275(VarCurr)
    <=> v109265(VarCurr) ) ).

tff(addAssignment_65055,axiom,
    ! [VarCurr: state_type] :
      ( v109265(VarCurr)
    <=> v109267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11080,axiom,
    ! [VarCurr: state_type] :
      ( v109267(VarCurr)
    <=> ( v109269(VarCurr)
        | v109271(VarCurr) ) ) ).

tff(addAssignment_65054,axiom,
    ! [VarCurr: state_type] :
      ( v109271(VarCurr)
    <=> v109146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11079,axiom,
    ! [VarCurr: state_type] :
      ( v109269(VarCurr)
    <=> ( v109270(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109270(VarCurr)
    <=> v134(VarCurr,4) ) ).

tff(addAssignment_65053,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,4)
    <=> v89340(VarCurr,4) ) ).

tff(addAssignment_65052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109260(VarCurr,B)
      <=> v109262(VarCurr,B) ) ) ).

tff(addAssignment_65051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109262(VarCurr,B)
      <=> v109263(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109263(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_928,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109263(VarCurr,B)
          <=> v109181(VarCurr,B) ) ) ) ).

tff(addAssignment_65050,axiom,
    ! [VarCurr: state_type] :
      ( v109252(VarCurr)
    <=> v109254(VarCurr) ) ).

tff(addAssignment_65049,axiom,
    ! [VarCurr: state_type] :
      ( v109254(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65048,axiom,
    ! [VarCurr: state_type] :
      ( v109248(VarCurr)
    <=> v109250(VarCurr) ) ).

tff(addAssignment_65047,axiom,
    ! [VarCurr: state_type] :
      ( v109250(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109181(VarCurr,B)
      <=> v109183(VarCurr,B) ) ) ).

tff(addAssignment_65045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109183(VarCurr,B)
      <=> v109185(VarCurr,B) ) ) ).

tff(addAssignment_65044,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109185(VarNext,B)
      <=> v109224(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109225(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109224(VarNext,B)
            <=> v109185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1330,axiom,
    ! [VarNext: state_type] :
      ( v109225(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109224(VarNext,B)
          <=> v109235(VarNext,B) ) ) ) ).

tff(addAssignment_65043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109235(VarNext,B)
          <=> v109233(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109236(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109233(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_927,axiom,
    ! [VarCurr: state_type] :
      ( v109236(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109233(VarCurr,B)
          <=> v109195(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11078,axiom,
    ! [VarCurr: state_type] :
      ( v109236(VarCurr)
    <=> ( v109237(VarCurr)
        & v109238(VarCurr) ) ) ).

tff(writeUnaryOperator_5897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109238(VarCurr)
    <=> v109191(VarCurr) ) ).

tff(writeUnaryOperator_5896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109237(VarCurr)
    <=> v109187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109225(VarNext)
      <=> v109226(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109226(VarNext)
      <=> ( v109227(VarNext)
          & v109220(VarNext) ) ) ) ).

tff(writeUnaryOperator_5895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109227(VarNext)
      <=> v109229(VarNext) ) ) ).

tff(addAssignment_65042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109229(VarNext)
      <=> v109220(VarCurr) ) ) ).

tff(addAssignment_65041,axiom,
    ! [VarCurr: state_type] :
      ( v109220(VarCurr)
    <=> v109222(VarCurr) ) ).

tff(addAssignment_65040,axiom,
    ! [VarCurr: state_type] :
      ( v109222(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_65039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109195(VarCurr,B)
      <=> v109197(VarCurr,B) ) ) ).

tff(addAssignment_65038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109197(VarCurr,B)
      <=> v109211(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109211(VarCurr,B)
      <=> ( v109212(VarCurr,B)
          | v109215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109215(VarCurr,B)
      <=> ( v109183(VarCurr,B)
          & v109216(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109216(VarCurr,B)
      <=> ~ v109217(VarCurr,B) ) ) ).

tff(addAssignment_65037,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,0)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65036,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,1)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65035,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,2)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65034,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,3)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65033,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,4)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65032,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,5)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65031,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,6)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65030,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,7)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65029,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,8)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65028,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,9)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65027,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,10)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65026,axiom,
    ! [VarCurr: state_type] :
      ( v109217(VarCurr,11)
    <=> v109218(VarCurr) ) ).

tff(addAssignment_65025,axiom,
    ! [VarCurr: state_type] :
      ( v109218(VarCurr)
    <=> v109204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109212(VarCurr,B)
      <=> ( v109199(VarCurr,B)
          & v109213(VarCurr,B) ) ) ) ).

tff(addAssignment_65024,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,0)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65023,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,1)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65022,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,2)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65021,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,3)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65020,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,4)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65019,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,5)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65018,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,6)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65017,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,7)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65016,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,8)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65015,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,9)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65014,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,10)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65013,axiom,
    ! [VarCurr: state_type] :
      ( v109213(VarCurr,11)
    <=> v109214(VarCurr) ) ).

tff(addAssignment_65012,axiom,
    ! [VarCurr: state_type] :
      ( v109214(VarCurr)
    <=> v109204(VarCurr) ) ).

tff(addAssignment_65011,axiom,
    ! [VarCurr: state_type] :
      ( v109204(VarCurr)
    <=> v109206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11075,axiom,
    ! [VarCurr: state_type] :
      ( v109206(VarCurr)
    <=> ( v109208(VarCurr)
        | v109210(VarCurr) ) ) ).

tff(addAssignment_65010,axiom,
    ! [VarCurr: state_type] :
      ( v109210(VarCurr)
    <=> v109145(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11074,axiom,
    ! [VarCurr: state_type] :
      ( v109208(VarCurr)
    <=> ( v109209(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109209(VarCurr)
    <=> v134(VarCurr,5) ) ).

tff(addAssignment_65009,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,5)
    <=> v89340(VarCurr,5) ) ).

tff(addAssignment_65008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109199(VarCurr,B)
      <=> v109201(VarCurr,B) ) ) ).

tff(addAssignment_65007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109201(VarCurr,B)
      <=> v109202(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109202(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_926,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109202(VarCurr,B)
          <=> v109114(VarCurr,B) ) ) ) ).

tff(addAssignment_65006,axiom,
    ! [VarCurr: state_type] :
      ( v109191(VarCurr)
    <=> v109193(VarCurr) ) ).

tff(addAssignment_65005,axiom,
    ! [VarCurr: state_type] :
      ( v109193(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_65004,axiom,
    ! [VarCurr: state_type] :
      ( v109187(VarCurr)
    <=> v109189(VarCurr) ) ).

tff(addAssignment_65003,axiom,
    ! [VarCurr: state_type] :
      ( v109189(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_65002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109114(VarCurr,B)
      <=> v109116(VarCurr,B) ) ) ).

tff(addAssignment_65001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109116(VarCurr,B)
      <=> v109118(VarCurr,B) ) ) ).

tff(addAssignment_65000,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109118(VarNext,B)
      <=> v109163(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109163(VarNext,B)
            <=> v109118(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1329,axiom,
    ! [VarNext: state_type] :
      ( v109164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109163(VarNext,B)
          <=> v109174(VarNext,B) ) ) ) ).

tff(addAssignment_64999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109174(VarNext,B)
          <=> v109172(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109172(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_925,axiom,
    ! [VarCurr: state_type] :
      ( v109175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109172(VarCurr,B)
          <=> v109128(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11073,axiom,
    ! [VarCurr: state_type] :
      ( v109175(VarCurr)
    <=> ( v109176(VarCurr)
        & v109177(VarCurr) ) ) ).

tff(writeUnaryOperator_5892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109177(VarCurr)
    <=> v109124(VarCurr) ) ).

tff(writeUnaryOperator_5891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109176(VarCurr)
    <=> v109120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109164(VarNext)
      <=> v109165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109165(VarNext)
      <=> ( v109166(VarNext)
          & v109159(VarNext) ) ) ) ).

tff(writeUnaryOperator_5890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109166(VarNext)
      <=> v109168(VarNext) ) ) ).

tff(addAssignment_64998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109168(VarNext)
      <=> v109159(VarCurr) ) ) ).

tff(addAssignment_64997,axiom,
    ! [VarCurr: state_type] :
      ( v109159(VarCurr)
    <=> v109161(VarCurr) ) ).

tff(addAssignment_64996,axiom,
    ! [VarCurr: state_type] :
      ( v109161(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_64995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109128(VarCurr,B)
      <=> v109130(VarCurr,B) ) ) ).

tff(addAssignment_64994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109130(VarCurr,B)
      <=> v109150(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109150(VarCurr,B)
      <=> ( v109151(VarCurr,B)
          | v109154(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109154(VarCurr,B)
      <=> ( v109116(VarCurr,B)
          & v109155(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109155(VarCurr,B)
      <=> ~ v109156(VarCurr,B) ) ) ).

tff(addAssignment_64993,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,0)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64992,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,1)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64991,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,2)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64990,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,3)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64989,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,4)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64988,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,5)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64987,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,6)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64986,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,7)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64985,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,8)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64984,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,9)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64983,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,10)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64982,axiom,
    ! [VarCurr: state_type] :
      ( v109156(VarCurr,11)
    <=> v109157(VarCurr) ) ).

tff(addAssignment_64981,axiom,
    ! [VarCurr: state_type] :
      ( v109157(VarCurr)
    <=> v109137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109151(VarCurr,B)
      <=> ( v109132(VarCurr,B)
          & v109152(VarCurr,B) ) ) ) ).

tff(addAssignment_64980,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,0)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64979,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,1)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64978,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,2)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64977,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,3)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64976,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,4)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64975,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,5)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64974,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,6)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64973,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,7)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64972,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,8)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64971,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,9)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64970,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,10)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64969,axiom,
    ! [VarCurr: state_type] :
      ( v109152(VarCurr,11)
    <=> v109153(VarCurr) ) ).

tff(addAssignment_64968,axiom,
    ! [VarCurr: state_type] :
      ( v109153(VarCurr)
    <=> v109137(VarCurr) ) ).

tff(addAssignment_64967,axiom,
    ! [VarCurr: state_type] :
      ( v109137(VarCurr)
    <=> v109139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11070,axiom,
    ! [VarCurr: state_type] :
      ( v109139(VarCurr)
    <=> ( v109141(VarCurr)
        | v109143(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4482,axiom,
    ! [VarCurr: state_type] :
      ( v109143(VarCurr)
    <=> ( v109145(VarCurr)
        | v89383(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4481,axiom,
    ! [VarCurr: state_type] :
      ( v109145(VarCurr)
    <=> ( v109146(VarCurr)
        | v89383(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4480,axiom,
    ! [VarCurr: state_type] :
      ( v109146(VarCurr)
    <=> ( v109147(VarCurr)
        | v89383(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4479,axiom,
    ! [VarCurr: state_type] :
      ( v109147(VarCurr)
    <=> ( v109148(VarCurr)
        | v89383(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4478,axiom,
    ! [VarCurr: state_type] :
      ( v109148(VarCurr)
    <=> ( v109149(VarCurr)
        | v89383(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4477,axiom,
    ! [VarCurr: state_type] :
      ( v109149(VarCurr)
    <=> ( v89383(VarCurr,0)
        | v89383(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11069,axiom,
    ! [VarCurr: state_type] :
      ( v109141(VarCurr)
    <=> ( v109142(VarCurr)
        & v170(VarCurr) ) ) ).

tff(writeUnaryOperator_5888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109142(VarCurr)
    <=> v134(VarCurr,6) ) ).

tff(addAssignment_64966,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,6)
    <=> v89340(VarCurr,6) ) ).

tff(addAssignment_64965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109132(VarCurr,B)
      <=> v109134(VarCurr,B) ) ) ).

tff(addAssignment_64964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109134(VarCurr,B)
      <=> v109135(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v134(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109135(VarCurr,B)
          <=> v89275(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_924,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109135(VarCurr,B)
          <=> v89253(VarCurr,B) ) ) ) ).

tff(addAssignment_64963,axiom,
    ! [VarCurr: state_type] :
      ( v109124(VarCurr)
    <=> v109126(VarCurr) ) ).

tff(addAssignment_64962,axiom,
    ! [VarCurr: state_type] :
      ( v109126(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_64961,axiom,
    ! [VarCurr: state_type] :
      ( v109120(VarCurr)
    <=> v109122(VarCurr) ) ).

tff(addAssignment_64960,axiom,
    ! [VarCurr: state_type] :
      ( v109122(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_64959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89253(VarCurr,B)
      <=> v89255(VarCurr,B) ) ) ).

tff(addAssignment_64958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89255(VarCurr,B)
      <=> v89257(VarCurr,B) ) ) ).

tff(addAssignment_64957,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89257(VarNext,B)
      <=> v109096(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109097(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109096(VarNext,B)
            <=> v89257(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1328,axiom,
    ! [VarNext: state_type] :
      ( v109097(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109096(VarNext,B)
          <=> v109107(VarNext,B) ) ) ) ).

tff(addAssignment_64956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109107(VarNext,B)
          <=> v109105(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109105(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_923,axiom,
    ! [VarCurr: state_type] :
      ( v109108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109105(VarCurr,B)
          <=> v89267(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11068,axiom,
    ! [VarCurr: state_type] :
      ( v109108(VarCurr)
    <=> ( v109109(VarCurr)
        & v109110(VarCurr) ) ) ).

tff(writeUnaryOperator_5887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109110(VarCurr)
    <=> v89263(VarCurr) ) ).

tff(writeUnaryOperator_5886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v109109(VarCurr)
    <=> v89259(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109097(VarNext)
      <=> v109098(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109098(VarNext)
      <=> ( v109099(VarNext)
          & v109092(VarNext) ) ) ) ).

tff(writeUnaryOperator_5885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109099(VarNext)
      <=> v109101(VarNext) ) ) ).

tff(addAssignment_64955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109101(VarNext)
      <=> v109092(VarCurr) ) ) ).

tff(addAssignment_64954,axiom,
    ! [VarCurr: state_type] :
      ( v109092(VarCurr)
    <=> v109094(VarCurr) ) ).

tff(addAssignment_64953,axiom,
    ! [VarCurr: state_type] :
      ( v109094(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_64952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89267(VarCurr,B)
      <=> v89269(VarCurr,B) ) ) ).

tff(addAssignment_64951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89269(VarCurr,B)
      <=> v109083(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109083(VarCurr,B)
      <=> ( v109084(VarCurr,B)
          | v109087(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109087(VarCurr,B)
      <=> ( v89255(VarCurr,B)
          & v109088(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109088(VarCurr,B)
      <=> ~ v109089(VarCurr,B) ) ) ).

tff(addAssignment_64950,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,0)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64949,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,1)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64948,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,2)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64947,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,3)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64946,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,4)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64945,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,5)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64944,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,6)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64943,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,7)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64942,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,8)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64941,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,9)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64940,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,10)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64939,axiom,
    ! [VarCurr: state_type] :
      ( v109089(VarCurr,11)
    <=> v109090(VarCurr) ) ).

tff(addAssignment_64938,axiom,
    ! [VarCurr: state_type] :
      ( v109090(VarCurr)
    <=> v89337(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v109084(VarCurr,B)
      <=> ( v89271(VarCurr,B)
          & v109085(VarCurr,B) ) ) ) ).

tff(addAssignment_64937,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,0)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64936,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,1)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64935,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,2)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64934,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,3)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64933,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,4)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64932,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,5)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64931,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,6)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64930,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,7)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64929,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,8)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64928,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,9)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64927,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,10)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64926,axiom,
    ! [VarCurr: state_type] :
      ( v109085(VarCurr,11)
    <=> v109086(VarCurr) ) ).

tff(addAssignment_64925,axiom,
    ! [VarCurr: state_type] :
      ( v109086(VarCurr)
    <=> v89337(VarCurr) ) ).

tff(addAssignment_64924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89271(VarCurr,B)
      <=> v89273(VarCurr,B) ) ) ).

tff(addAssignment_64923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89273(VarCurr,B)
      <=> v89275(VarCurr,B) ) ) ).

tff(addAssignment_64922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89275(VarCurr,B)
      <=> v89333(VarCurr,B) ) ) ).

tff(addAssignment_64921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89277(VarCurr,B)
      <=> v89279(VarCurr,B) ) ) ).

tff(addAssignment_64920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89279(VarCurr,B)
      <=> v89281(VarCurr,B) ) ) ).

tff(addAssignment_64919,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89281(VarNext,B)
      <=> v109076(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109077(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v109076(VarNext,B)
            <=> v89281(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1327,axiom,
    ! [VarNext: state_type] :
      ( v109077(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v109076(VarNext,B)
          <=> v89327(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109077(VarNext)
      <=> v109078(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109078(VarNext)
      <=> ( v109080(VarNext)
          & v89312(VarNext) ) ) ) ).

tff(writeUnaryOperator_5883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109080(VarNext)
      <=> v89321(VarNext) ) ) ).

tff(addAssignment_64918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89291(VarCurr,B)
      <=> v89293(VarCurr,B) ) ) ).

tff(addAssignment_64917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89293(VarCurr,B)
      <=> v89295(VarCurr,B) ) ) ).

tff(addAssignment_64916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89295(VarCurr,B)
      <=> v89306(VarCurr,B) ) ) ).

tff(addAssignment_64915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89310(VarCurr,B)
      <=> v109041(VarCurr,B) ) ) ).

tff(addAssignment_64914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v109041(VarCurr,B)
      <=> v109043(VarCurr,B) ) ) ).

tff(addAssignment_64913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v109043(VarCurr,B)
      <=> v109045(VarCurr,B) ) ) ).

tff(addAssignment_64912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v109045(VarCurr,B)
      <=> v109047(VarCurr,B) ) ) ).

tff(addAssignment_64911,axiom,
    ! [VarCurr: state_type] :
      ( ( v109047(VarCurr,1)
      <=> v3948(VarCurr,24) )
      & ( v109047(VarCurr,0)
      <=> v3948(VarCurr,23) ) ) ).

tff(addAssignment_64910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,25)
        & ~ $less(B,23) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v89335(VarCurr)
      <=> v109074(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_55,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v89335(VarCurr)
      <=> v89277(VarCurr,2) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_25,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v109074(VarCurr)
      <=> v89277(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_54,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v109074(VarCurr)
      <=> v89277(VarCurr,6) ) ) ).

tff(addAssignment_64909,axiom,
    ! [VarCurr: state_type] :
      ( v89277(VarCurr,6)
    <=> v89279(VarCurr,6) ) ).

tff(addAssignment_64908,axiom,
    ! [VarCurr: state_type] :
      ( v89279(VarCurr,6)
    <=> v89281(VarCurr,6) ) ).

tff(addAssignment_64907,axiom,
    ! [VarNext: state_type] :
      ( v89281(VarNext,6)
    <=> v109066(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109067(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v109066(VarNext,B)
            <=> v89281(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1326,axiom,
    ! [VarNext: state_type] :
      ( v109067(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v109066(VarNext,B)
          <=> v89327(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109067(VarNext)
      <=> v109068(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109068(VarNext)
      <=> ( v109070(VarNext)
          & v89312(VarNext) ) ) ) ).

tff(writeUnaryOperator_5882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109070(VarNext)
      <=> v89321(VarNext) ) ) ).

tff(addAssignment_64906,axiom,
    ! [VarCurr: state_type] :
      ( v89291(VarCurr,6)
    <=> v89293(VarCurr,6) ) ).

tff(addAssignment_64905,axiom,
    ! [VarCurr: state_type] :
      ( v89293(VarCurr,6)
    <=> v89295(VarCurr,6) ) ).

tff(addAssignment_64904,axiom,
    ! [VarCurr: state_type] :
      ( v89295(VarCurr,6)
    <=> v89306(VarCurr,6) ) ).

tff(addAssignment_64903,axiom,
    ! [VarCurr: state_type] :
      ( v89309(VarCurr)
    <=> v109058(VarCurr) ) ).

tff(addAssignment_64902,axiom,
    ! [VarCurr: state_type] :
      ( v109058(VarCurr)
    <=> v109060(VarCurr) ) ).

tff(addAssignment_64901,axiom,
    ! [VarCurr: state_type] :
      ( v109060(VarCurr)
    <=> v109062(VarCurr) ) ).

tff(addAssignment_64900,axiom,
    ! [VarCurr: state_type] :
      ( v109062(VarCurr)
    <=> v109064(VarCurr) ) ).

tff(addAssignment_64899,axiom,
    ! [VarCurr: state_type] :
      ( v109064(VarCurr)
    <=> v3948(VarCurr,29) ) ).

tff(addAssignment_64898,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,29)
    <=> v3950(VarCurr,29) ) ).

tff(addAssignment_64897,axiom,
    ! [VarCurr: state_type] :
      ( v89277(VarCurr,2)
    <=> v89279(VarCurr,2) ) ).

tff(addAssignment_64896,axiom,
    ! [VarCurr: state_type] :
      ( v89279(VarCurr,2)
    <=> v89281(VarCurr,2) ) ).

tff(addAssignment_64895,axiom,
    ! [VarNext: state_type] :
      ( v89281(VarNext,2)
    <=> v109049(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109050(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v109049(VarNext,B)
            <=> v89281(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1325,axiom,
    ! [VarNext: state_type] :
      ( v109050(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v109049(VarNext,B)
          <=> v89327(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109050(VarNext)
      <=> v109051(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109051(VarNext)
      <=> ( v109053(VarNext)
          & v89312(VarNext) ) ) ) ).

tff(writeUnaryOperator_5881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109053(VarNext)
      <=> v89321(VarNext) ) ) ).

tff(addAssignment_64894,axiom,
    ! [VarCurr: state_type] :
      ( v89291(VarCurr,2)
    <=> v89293(VarCurr,2) ) ).

tff(addAssignment_64893,axiom,
    ! [VarCurr: state_type] :
      ( v89293(VarCurr,2)
    <=> v89295(VarCurr,2) ) ).

tff(addAssignment_64892,axiom,
    ! [VarCurr: state_type] :
      ( v89295(VarCurr,2)
    <=> v89306(VarCurr,2) ) ).

tff(addAssignment_64891,axiom,
    ! [VarCurr: state_type] :
      ( v89310(VarCurr,2)
    <=> v109041(VarCurr,2) ) ).

tff(addAssignment_64890,axiom,
    ! [VarCurr: state_type] :
      ( v109041(VarCurr,2)
    <=> v109043(VarCurr,2) ) ).

tff(addAssignment_64889,axiom,
    ! [VarCurr: state_type] :
      ( v109043(VarCurr,2)
    <=> v109045(VarCurr,2) ) ).

tff(addAssignment_64888,axiom,
    ! [VarCurr: state_type] :
      ( v109045(VarCurr,2)
    <=> v109047(VarCurr,2) ) ).

tff(addAssignment_64887,axiom,
    ! [VarCurr: state_type] :
      ( v109047(VarCurr,2)
    <=> v3948(VarCurr,25) ) ).

tff(addAssignment_64886,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,25)
    <=> v3950(VarCurr,25) ) ).

tff(addAssignment_64885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89214(VarCurr,B)
      <=> v89216(VarCurr,B) ) ) ).

tff(addAssignment_64884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89216(VarCurr,B)
      <=> v89218(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_24,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v89218(VarCurr,3)
      <=> v109037(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_53,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v89218(VarCurr,3)
      <=> v109036(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_23,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v109037(VarCurr)
      <=> v89218(VarCurr,5) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_52,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v109037(VarCurr)
      <=> v89218(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_22,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v109036(VarCurr)
      <=> v89218(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_51,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v109036(VarCurr)
      <=> v89218(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89218(VarCurr,B)
      <=> ( v109013(VarCurr,B)
          | v109033(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109033(VarCurr,B)
      <=> ( v109034(VarCurr,B)
          & v85128(VarCurr,B) ) ) ) ).

tff(addAssignment_64883,axiom,
    ! [VarCurr: state_type] :
      ( v109034(VarCurr,0)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_64882,axiom,
    ! [VarCurr: state_type] :
      ( v109034(VarCurr,1)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_64881,axiom,
    ! [VarCurr: state_type] :
      ( v109034(VarCurr,2)
    <=> v84975(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109013(VarCurr,B)
      <=> ( v109014(VarCurr,B)
          | v109031(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109031(VarCurr,B)
      <=> ( v109032(VarCurr,B)
          & v85150(VarCurr,B) ) ) ) ).

tff(addAssignment_64880,axiom,
    ! [VarCurr: state_type] :
      ( v109032(VarCurr,0)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_64879,axiom,
    ! [VarCurr: state_type] :
      ( v109032(VarCurr,1)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_64878,axiom,
    ! [VarCurr: state_type] :
      ( v109032(VarCurr,2)
    <=> v84975(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109014(VarCurr,B)
      <=> ( v109015(VarCurr,B)
          | v109029(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109029(VarCurr,B)
      <=> ( v109030(VarCurr,B)
          & v85172(VarCurr,B) ) ) ) ).

tff(addAssignment_64877,axiom,
    ! [VarCurr: state_type] :
      ( v109030(VarCurr,0)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_64876,axiom,
    ! [VarCurr: state_type] :
      ( v109030(VarCurr,1)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_64875,axiom,
    ! [VarCurr: state_type] :
      ( v109030(VarCurr,2)
    <=> v84975(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109015(VarCurr,B)
      <=> ( v109016(VarCurr,B)
          | v109027(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109027(VarCurr,B)
      <=> ( v109028(VarCurr,B)
          & v85194(VarCurr,B) ) ) ) ).

tff(addAssignment_64874,axiom,
    ! [VarCurr: state_type] :
      ( v109028(VarCurr,0)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_64873,axiom,
    ! [VarCurr: state_type] :
      ( v109028(VarCurr,1)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_64872,axiom,
    ! [VarCurr: state_type] :
      ( v109028(VarCurr,2)
    <=> v84975(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109016(VarCurr,B)
      <=> ( v109017(VarCurr,B)
          | v109025(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109025(VarCurr,B)
      <=> ( v109026(VarCurr,B)
          & v85216(VarCurr,B) ) ) ) ).

tff(addAssignment_64871,axiom,
    ! [VarCurr: state_type] :
      ( v109026(VarCurr,0)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_64870,axiom,
    ! [VarCurr: state_type] :
      ( v109026(VarCurr,1)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_64869,axiom,
    ! [VarCurr: state_type] :
      ( v109026(VarCurr,2)
    <=> v84975(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109017(VarCurr,B)
      <=> ( v109018(VarCurr,B)
          | v109023(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109023(VarCurr,B)
      <=> ( v109024(VarCurr,B)
          & v85238(VarCurr,B) ) ) ) ).

tff(addAssignment_64868,axiom,
    ! [VarCurr: state_type] :
      ( v109024(VarCurr,0)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_64867,axiom,
    ! [VarCurr: state_type] :
      ( v109024(VarCurr,1)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_64866,axiom,
    ! [VarCurr: state_type] :
      ( v109024(VarCurr,2)
    <=> v84975(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109018(VarCurr,B)
      <=> ( v109019(VarCurr,B)
          | v109021(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109021(VarCurr,B)
      <=> ( v109022(VarCurr,B)
          & v85260(VarCurr,B) ) ) ) ).

tff(addAssignment_64865,axiom,
    ! [VarCurr: state_type] :
      ( v109022(VarCurr,0)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_64864,axiom,
    ! [VarCurr: state_type] :
      ( v109022(VarCurr,1)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_64863,axiom,
    ! [VarCurr: state_type] :
      ( v109022(VarCurr,2)
    <=> v84975(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v109019(VarCurr,B)
      <=> ( v109020(VarCurr,B)
          & v85282(VarCurr,B) ) ) ) ).

tff(addAssignment_64862,axiom,
    ! [VarCurr: state_type] :
      ( v109020(VarCurr,0)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_64861,axiom,
    ! [VarCurr: state_type] :
      ( v109020(VarCurr,1)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_64860,axiom,
    ! [VarCurr: state_type] :
      ( v109020(VarCurr,2)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_64859,axiom,
    ! [VarCurr: state_type] :
      ( v89218(VarCurr,7)
    <=> v89219(VarCurr,3) ) ).

tff(addAssignment_64858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85128(VarCurr,B)
      <=> v85130(VarCurr,B) ) ) ).

tff(addAssignment_64857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85130(VarCurr,B)
      <=> v85132(VarCurr,B) ) ) ).

tff(addAssignment_64856,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85132(VarNext,B)
      <=> v109005(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109006(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v109005(VarNext,B)
            <=> v85132(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1324,axiom,
    ! [VarNext: state_type] :
      ( v109006(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v109005(VarNext,B)
          <=> v85678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109006(VarNext)
      <=> v109007(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v109007(VarNext)
      <=> ( v109009(VarNext)
          & v85663(VarNext) ) ) ) ).

tff(writeUnaryOperator_5880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109009(VarNext)
      <=> v85672(VarNext) ) ) ).

tff(addAssignment_64855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85142(VarCurr,B)
      <=> v85144(VarCurr,B) ) ) ).

tff(addAssignment_64854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85144(VarCurr,B)
      <=> v85654(VarCurr,B) ) ) ).

tff(addAssignment_64853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85146(VarCurr,B)
      <=> v85148(VarCurr,B) ) ) ).

tff(addAssignment_64852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85148(VarCurr,B)
      <=> v85646(VarCurr,B) ) ) ).

tff(addAssignment_64851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85150(VarCurr,B)
      <=> v85152(VarCurr,B) ) ) ).

tff(addAssignment_64850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85152(VarCurr,B)
      <=> v85154(VarCurr,B) ) ) ).

tff(addAssignment_64849,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85154(VarNext,B)
      <=> v108997(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108998(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108997(VarNext,B)
            <=> v85154(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1323,axiom,
    ! [VarNext: state_type] :
      ( v108998(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108997(VarNext,B)
          <=> v85640(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108998(VarNext)
      <=> v108999(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108999(VarNext)
      <=> ( v109001(VarNext)
          & v85625(VarNext) ) ) ) ).

tff(writeUnaryOperator_5879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v109001(VarNext)
      <=> v85634(VarNext) ) ) ).

tff(addAssignment_64848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85164(VarCurr,B)
      <=> v85166(VarCurr,B) ) ) ).

tff(addAssignment_64847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85166(VarCurr,B)
      <=> v85616(VarCurr,B) ) ) ).

tff(addAssignment_64846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85168(VarCurr,B)
      <=> v85170(VarCurr,B) ) ) ).

tff(addAssignment_64845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85170(VarCurr,B)
      <=> v85607(VarCurr,B) ) ) ).

tff(addAssignment_64844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85172(VarCurr,B)
      <=> v85174(VarCurr,B) ) ) ).

tff(addAssignment_64843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85174(VarCurr,B)
      <=> v85176(VarCurr,B) ) ) ).

tff(addAssignment_64842,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85176(VarNext,B)
      <=> v108989(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108990(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108989(VarNext,B)
            <=> v85176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1322,axiom,
    ! [VarNext: state_type] :
      ( v108990(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108989(VarNext,B)
          <=> v85601(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108990(VarNext)
      <=> v108991(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108991(VarNext)
      <=> ( v108993(VarNext)
          & v85586(VarNext) ) ) ) ).

tff(writeUnaryOperator_5878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108993(VarNext)
      <=> v85595(VarNext) ) ) ).

tff(addAssignment_64841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85186(VarCurr,B)
      <=> v85188(VarCurr,B) ) ) ).

tff(addAssignment_64840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85188(VarCurr,B)
      <=> v85577(VarCurr,B) ) ) ).

tff(addAssignment_64839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85190(VarCurr,B)
      <=> v85192(VarCurr,B) ) ) ).

tff(addAssignment_64838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85192(VarCurr,B)
      <=> v85568(VarCurr,B) ) ) ).

tff(addAssignment_64837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85194(VarCurr,B)
      <=> v85196(VarCurr,B) ) ) ).

tff(addAssignment_64836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85196(VarCurr,B)
      <=> v85198(VarCurr,B) ) ) ).

tff(addAssignment_64835,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85198(VarNext,B)
      <=> v108981(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108982(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108981(VarNext,B)
            <=> v85198(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1321,axiom,
    ! [VarNext: state_type] :
      ( v108982(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108981(VarNext,B)
          <=> v85562(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108982(VarNext)
      <=> v108983(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108983(VarNext)
      <=> ( v108985(VarNext)
          & v85547(VarNext) ) ) ) ).

tff(writeUnaryOperator_5877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108985(VarNext)
      <=> v85556(VarNext) ) ) ).

tff(addAssignment_64834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85208(VarCurr,B)
      <=> v85210(VarCurr,B) ) ) ).

tff(addAssignment_64833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85210(VarCurr,B)
      <=> v85538(VarCurr,B) ) ) ).

tff(addAssignment_64832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85212(VarCurr,B)
      <=> v85214(VarCurr,B) ) ) ).

tff(addAssignment_64831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85214(VarCurr,B)
      <=> v85529(VarCurr,B) ) ) ).

tff(addAssignment_64830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85216(VarCurr,B)
      <=> v85218(VarCurr,B) ) ) ).

tff(addAssignment_64829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85218(VarCurr,B)
      <=> v85220(VarCurr,B) ) ) ).

tff(addAssignment_64828,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85220(VarNext,B)
      <=> v108973(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108974(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108973(VarNext,B)
            <=> v85220(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1320,axiom,
    ! [VarNext: state_type] :
      ( v108974(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108973(VarNext,B)
          <=> v85523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108974(VarNext)
      <=> v108975(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108975(VarNext)
      <=> ( v108977(VarNext)
          & v85508(VarNext) ) ) ) ).

tff(writeUnaryOperator_5876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108977(VarNext)
      <=> v85517(VarNext) ) ) ).

tff(addAssignment_64827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85230(VarCurr,B)
      <=> v85232(VarCurr,B) ) ) ).

tff(addAssignment_64826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85232(VarCurr,B)
      <=> v85499(VarCurr,B) ) ) ).

tff(addAssignment_64825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85234(VarCurr,B)
      <=> v85236(VarCurr,B) ) ) ).

tff(addAssignment_64824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85236(VarCurr,B)
      <=> v85490(VarCurr,B) ) ) ).

tff(addAssignment_64823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85238(VarCurr,B)
      <=> v85240(VarCurr,B) ) ) ).

tff(addAssignment_64822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85240(VarCurr,B)
      <=> v85242(VarCurr,B) ) ) ).

tff(addAssignment_64821,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85242(VarNext,B)
      <=> v108965(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108966(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108965(VarNext,B)
            <=> v85242(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1319,axiom,
    ! [VarNext: state_type] :
      ( v108966(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108965(VarNext,B)
          <=> v85484(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108966(VarNext)
      <=> v108967(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108967(VarNext)
      <=> ( v108969(VarNext)
          & v85469(VarNext) ) ) ) ).

tff(writeUnaryOperator_5875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108969(VarNext)
      <=> v85478(VarNext) ) ) ).

tff(addAssignment_64820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85252(VarCurr,B)
      <=> v85254(VarCurr,B) ) ) ).

tff(addAssignment_64819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85254(VarCurr,B)
      <=> v85460(VarCurr,B) ) ) ).

tff(addAssignment_64818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85256(VarCurr,B)
      <=> v85258(VarCurr,B) ) ) ).

tff(addAssignment_64817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85258(VarCurr,B)
      <=> v85451(VarCurr,B) ) ) ).

tff(addAssignment_64816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85260(VarCurr,B)
      <=> v85262(VarCurr,B) ) ) ).

tff(addAssignment_64815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85262(VarCurr,B)
      <=> v85264(VarCurr,B) ) ) ).

tff(addAssignment_64814,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85264(VarNext,B)
      <=> v108957(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108958(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108957(VarNext,B)
            <=> v85264(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1318,axiom,
    ! [VarNext: state_type] :
      ( v108958(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108957(VarNext,B)
          <=> v85445(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108958(VarNext)
      <=> v108959(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108959(VarNext)
      <=> ( v108961(VarNext)
          & v85430(VarNext) ) ) ) ).

tff(writeUnaryOperator_5874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108961(VarNext)
      <=> v85439(VarNext) ) ) ).

tff(addAssignment_64813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85274(VarCurr,B)
      <=> v85276(VarCurr,B) ) ) ).

tff(addAssignment_64812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85276(VarCurr,B)
      <=> v85421(VarCurr,B) ) ) ).

tff(addAssignment_64811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85278(VarCurr,B)
      <=> v85280(VarCurr,B) ) ) ).

tff(addAssignment_64810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85280(VarCurr,B)
      <=> v85412(VarCurr,B) ) ) ).

tff(addAssignment_64809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85282(VarCurr,B)
      <=> v85284(VarCurr,B) ) ) ).

tff(addAssignment_64808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85284(VarCurr,B)
      <=> v85286(VarCurr,B) ) ) ).

tff(addAssignment_64807,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85286(VarNext,B)
      <=> v108949(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108950(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v108949(VarNext,B)
            <=> v85286(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1317,axiom,
    ! [VarNext: state_type] :
      ( v108950(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v108949(VarNext,B)
          <=> v85406(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108950(VarNext)
      <=> v108951(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108951(VarNext)
      <=> ( v108953(VarNext)
          & v85391(VarNext) ) ) ) ).

tff(writeUnaryOperator_5873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108953(VarNext)
      <=> v85400(VarNext) ) ) ).

tff(addAssignment_64806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85296(VarCurr,B)
      <=> v85298(VarCurr,B) ) ) ).

tff(addAssignment_64805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85298(VarCurr,B)
      <=> v85382(VarCurr,B) ) ) ).

tff(addAssignment_64804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85300(VarCurr,B)
      <=> v85302(VarCurr,B) ) ) ).

tff(addAssignment_64803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85302(VarCurr,B)
      <=> v85304(VarCurr,B) ) ) ).

tff(addAssignment_64802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85304(VarCurr,B)
      <=> v85371(VarCurr,B) ) ) ).

tff(addAssignment_64801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85306(VarCurr,B)
      <=> v85308(VarCurr,B) ) ) ).

tff(addAssignment_64800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85308(VarCurr,B)
      <=> v85310(VarCurr,B) ) ) ).

tff(addAssignment_64799,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85310(VarNext,B)
      <=> v108941(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108942(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v108941(VarNext,B)
            <=> v85310(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1316,axiom,
    ! [VarNext: state_type] :
      ( v108942(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v108941(VarNext,B)
          <=> v85365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108942(VarNext)
      <=> v108943(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108943(VarNext)
      <=> ( v108945(VarNext)
          & v85350(VarNext) ) ) ) ).

tff(writeUnaryOperator_5872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108945(VarNext)
      <=> v85359(VarNext) ) ) ).

tff(addAssignment_64798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85320(VarCurr,B)
      <=> v85322(VarCurr,B) ) ) ).

tff(addAssignment_64797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85322(VarCurr,B)
      <=> v85324(VarCurr,B) ) ) ).

tff(addAssignment_64796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85324(VarCurr,B)
      <=> v85345(VarCurr,B) ) ) ).

tff(addAssignment_64795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85348(VarCurr,B)
      <=> v108923(VarCurr,B) ) ) ).

tff(addAssignment_64794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108923(VarCurr,B)
      <=> v108925(VarCurr,B) ) ) ).

tff(addAssignment_64793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108925(VarCurr,B)
      <=> v108927(VarCurr,B) ) ) ).

tff(addAssignment_64792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108927(VarCurr,B)
      <=> v108929(VarCurr,B) ) ) ).

tff(addAssignment_64791,axiom,
    ! [VarCurr: state_type] :
      ( ( v108929(VarCurr,1)
      <=> v3948(VarCurr,36) )
      & ( v108929(VarCurr,0)
      <=> v3948(VarCurr,35) ) ) ).

tff(addAssignment_64790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,37)
        & ~ $less(B,35) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v85373(VarCurr)
      <=> v108939(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_50,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v85373(VarCurr)
      <=> v85306(VarCurr,2) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_21,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v108939(VarCurr)
      <=> v85306(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_49,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v108939(VarCurr)
      <=> v85306(VarCurr,6) ) ) ).

tff(addAssignment_64789,axiom,
    ! [VarCurr: state_type] :
      ( v85306(VarCurr,2)
    <=> v85308(VarCurr,2) ) ).

tff(addAssignment_64788,axiom,
    ! [VarCurr: state_type] :
      ( v85308(VarCurr,2)
    <=> v85310(VarCurr,2) ) ).

tff(addAssignment_64787,axiom,
    ! [VarNext: state_type] :
      ( v85310(VarNext,2)
    <=> v108931(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108932(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v108931(VarNext,B)
            <=> v85310(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1315,axiom,
    ! [VarNext: state_type] :
      ( v108932(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v108931(VarNext,B)
          <=> v85365(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108932(VarNext)
      <=> v108933(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108933(VarNext)
      <=> ( v108935(VarNext)
          & v85350(VarNext) ) ) ) ).

tff(writeUnaryOperator_5871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108935(VarNext)
      <=> v85359(VarNext) ) ) ).

tff(addAssignment_64786,axiom,
    ! [VarCurr: state_type] :
      ( v85320(VarCurr,2)
    <=> v85322(VarCurr,2) ) ).

tff(addAssignment_64785,axiom,
    ! [VarCurr: state_type] :
      ( v85322(VarCurr,2)
    <=> v85324(VarCurr,2) ) ).

tff(addAssignment_64784,axiom,
    ! [VarCurr: state_type] :
      ( v85324(VarCurr,2)
    <=> v85345(VarCurr,2) ) ).

tff(addAssignment_64783,axiom,
    ! [VarCurr: state_type] :
      ( v85348(VarCurr,2)
    <=> v108923(VarCurr,2) ) ).

tff(addAssignment_64782,axiom,
    ! [VarCurr: state_type] :
      ( v108923(VarCurr,2)
    <=> v108925(VarCurr,2) ) ).

tff(addAssignment_64781,axiom,
    ! [VarCurr: state_type] :
      ( v108925(VarCurr,2)
    <=> v108927(VarCurr,2) ) ).

tff(addAssignment_64780,axiom,
    ! [VarCurr: state_type] :
      ( v108927(VarCurr,2)
    <=> v108929(VarCurr,2) ) ).

tff(addAssignment_64779,axiom,
    ! [VarCurr: state_type] :
      ( v108929(VarCurr,2)
    <=> v3948(VarCurr,37) ) ).

tff(addAssignment_64778,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,37)
    <=> v3950(VarCurr,37) ) ).

tff(addAssignment_64777,axiom,
    ! [VarCurr: state_type] :
      ( v108911(VarCurr)
    <=> v108913(VarCurr) ) ).

tff(addAssignment_64776,axiom,
    ! [VarCurr: state_type] :
      ( v108913(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_64775,axiom,
    ! [VarCurr: state_type] :
      ( v108907(VarCurr)
    <=> v108909(VarCurr) ) ).

tff(addAssignment_64774,axiom,
    ! [VarCurr: state_type] :
      ( v108909(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_64773,axiom,
    ! [VarCurr: state_type] :
      ( v108881(VarCurr)
    <=> v108883(VarCurr) ) ).

tff(addAssignment_64772,axiom,
    ! [VarCurr: state_type] :
      ( v108883(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_64771,axiom,
    ! [VarCurr: state_type] :
      ( v108877(VarCurr)
    <=> v108879(VarCurr) ) ).

tff(addAssignment_64770,axiom,
    ! [VarCurr: state_type] :
      ( v108879(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_64769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100435(VarCurr,B)
      <=> v100437(VarCurr,B) ) ) ).

tff(addAssignment_64768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100437(VarCurr,B)
      <=> v100439(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100439(VarCurr,B)
      <=> ( v100441(VarCurr,B)
          & v108830(VarCurr,B) ) ) ) ).

tff(addAssignment_64767,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,0)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64766,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,1)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64765,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,2)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64764,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,3)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64763,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,4)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64762,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,5)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64761,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,6)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64760,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,7)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64759,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,8)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64758,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,9)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64757,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,10)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64756,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,11)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64755,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,12)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64754,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,13)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64753,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,14)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64752,axiom,
    ! [VarCurr: state_type] :
      ( v108830(VarCurr,15)
    <=> v108831(VarCurr) ) ).

tff(addAssignment_64751,axiom,
    ! [VarCurr: state_type] :
      ( v108831(VarCurr)
    <=> v108832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11039,axiom,
    ! [VarCurr: state_type] :
      ( v108832(VarCurr)
    <=> ( v108833(VarCurr)
        & v108834(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11038,axiom,
    ! [VarCurr: state_type] :
      ( v108834(VarCurr)
    <=> ( v108835(VarCurr)
        | v108826(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11037,axiom,
    ! [VarCurr: state_type] :
      ( v108835(VarCurr)
    <=> ( v108836(VarCurr)
        & v108839(VarCurr) ) ) ).

tff(writeUnaryOperator_5870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108839(VarCurr)
    <=> v108841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11036,axiom,
    ! [VarCurr: state_type] :
      ( v108841(VarCurr)
    <=> ( v108842(VarCurr)
        & v108862(VarCurr) ) ) ).

tff(writeUnaryOperator_5869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108862(VarCurr)
    <=> v108863(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11035,axiom,
    ! [VarCurr: state_type] :
      ( v108863(VarCurr)
    <=> ( v108864(VarCurr)
        & v108867(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4476,axiom,
    ! [VarCurr: state_type] :
      ( v108867(VarCurr)
    <=> ( v100445(VarCurr,6)
        | v108822(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11034,axiom,
    ! [VarCurr: state_type] :
      ( v108864(VarCurr)
    <=> ( v108865(VarCurr)
        | v108866(VarCurr) ) ) ).

tff(writeUnaryOperator_5868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108866(VarCurr)
    <=> v108822(VarCurr,3) ) ).

tff(writeUnaryOperator_5867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108865(VarCurr)
    <=> v100445(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11033,axiom,
    ! [VarCurr: state_type] :
      ( v108842(VarCurr)
    <=> ( v108843(VarCurr)
        & v108856(VarCurr) ) ) ).

tff(writeUnaryOperator_5866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108856(VarCurr)
    <=> v108857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11032,axiom,
    ! [VarCurr: state_type] :
      ( v108857(VarCurr)
    <=> ( v108858(VarCurr)
        & v108861(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4475,axiom,
    ! [VarCurr: state_type] :
      ( v108861(VarCurr)
    <=> ( v100445(VarCurr,5)
        | v108822(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11031,axiom,
    ! [VarCurr: state_type] :
      ( v108858(VarCurr)
    <=> ( v108859(VarCurr)
        | v108860(VarCurr) ) ) ).

tff(writeUnaryOperator_5865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108860(VarCurr)
    <=> v108822(VarCurr,2) ) ).

tff(writeUnaryOperator_5864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108859(VarCurr)
    <=> v100445(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11030,axiom,
    ! [VarCurr: state_type] :
      ( v108843(VarCurr)
    <=> ( v108844(VarCurr)
        & v108850(VarCurr) ) ) ).

tff(writeUnaryOperator_5863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108850(VarCurr)
    <=> v108851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11029,axiom,
    ! [VarCurr: state_type] :
      ( v108851(VarCurr)
    <=> ( v108852(VarCurr)
        & v108855(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4474,axiom,
    ! [VarCurr: state_type] :
      ( v108855(VarCurr)
    <=> ( v100445(VarCurr,4)
        | v108822(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11028,axiom,
    ! [VarCurr: state_type] :
      ( v108852(VarCurr)
    <=> ( v108853(VarCurr)
        | v108854(VarCurr) ) ) ).

tff(writeUnaryOperator_5862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108854(VarCurr)
    <=> v108822(VarCurr,1) ) ).

tff(writeUnaryOperator_5861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108853(VarCurr)
    <=> v100445(VarCurr,4) ) ).

tff(writeUnaryOperator_5860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108844(VarCurr)
    <=> v108845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11027,axiom,
    ! [VarCurr: state_type] :
      ( v108845(VarCurr)
    <=> ( v108846(VarCurr)
        & v108849(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4473,axiom,
    ! [VarCurr: state_type] :
      ( v108849(VarCurr)
    <=> ( v100445(VarCurr,3)
        | v108822(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11026,axiom,
    ! [VarCurr: state_type] :
      ( v108846(VarCurr)
    <=> ( v108847(VarCurr)
        | v108848(VarCurr) ) ) ).

tff(writeUnaryOperator_5859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108848(VarCurr)
    <=> v108822(VarCurr,0) ) ).

tff(writeUnaryOperator_5858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108847(VarCurr)
    <=> v100445(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11025,axiom,
    ! [VarCurr: state_type] :
      ( v108836(VarCurr)
    <=> ( v108837(VarCurr)
        & v108838(VarCurr) ) ) ).

tff(writeUnaryOperator_5857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108838(VarCurr)
    <=> v108818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11024,axiom,
    ! [VarCurr: state_type] :
      ( v108837(VarCurr)
    <=> ( v108810(VarCurr)
        | v108814(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4472,axiom,
    ! [VarCurr: state_type] :
      ( v108833(VarCurr)
    <=> ( v100689(VarCurr,1)
        & v101227(VarCurr) ) ) ).

tff(addAssignment_64750,axiom,
    ! [VarCurr: state_type] :
      ( v108826(VarCurr)
    <=> v108828(VarCurr) ) ).

tff(addAssignment_64749,axiom,
    ! [VarCurr: state_type] :
      ( v108828(VarCurr)
    <=> v84297(VarCurr,1) ) ).

tff(addAssignment_64748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108822(VarCurr,B)
      <=> v108824(VarCurr,B) ) ) ).

tff(addAssignment_64747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108824(VarCurr,B)
      <=> v88372(VarCurr,B) ) ) ).

tff(addAssignment_64746,axiom,
    ! [VarCurr: state_type] :
      ( v108818(VarCurr)
    <=> v108820(VarCurr) ) ).

tff(addAssignment_64745,axiom,
    ! [VarCurr: state_type] :
      ( v108820(VarCurr)
    <=> v84488(VarCurr) ) ).

tff(addAssignment_64744,axiom,
    ! [VarCurr: state_type] :
      ( v108814(VarCurr)
    <=> v108816(VarCurr) ) ).

tff(addAssignment_64743,axiom,
    ! [VarCurr: state_type] :
      ( v108816(VarCurr)
    <=> v84297(VarCurr,4) ) ).

tff(addAssignment_64742,axiom,
    ! [VarCurr: state_type] :
      ( v108810(VarCurr)
    <=> v108812(VarCurr) ) ).

tff(addAssignment_64741,axiom,
    ! [VarCurr: state_type] :
      ( v108812(VarCurr)
    <=> v84297(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4471,axiom,
    ! [VarCurr: state_type] :
      ( v101227(VarCurr)
    <=> ( v108794(VarCurr)
        | v108808(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4470,axiom,
    ! [VarCurr: state_type] :
      ( v108794(VarCurr)
    <=> ( v108795(VarCurr)
        | v108808(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4469,axiom,
    ! [VarCurr: state_type] :
      ( v108795(VarCurr)
    <=> ( v108796(VarCurr)
        | v108808(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4468,axiom,
    ! [VarCurr: state_type] :
      ( v108796(VarCurr)
    <=> ( v108797(VarCurr)
        | v108808(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4467,axiom,
    ! [VarCurr: state_type] :
      ( v108797(VarCurr)
    <=> ( v108798(VarCurr)
        | v108808(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4466,axiom,
    ! [VarCurr: state_type] :
      ( v108798(VarCurr)
    <=> ( v108799(VarCurr)
        | v108808(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4465,axiom,
    ! [VarCurr: state_type] :
      ( v108799(VarCurr)
    <=> ( v108800(VarCurr)
        | v108808(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4464,axiom,
    ! [VarCurr: state_type] :
      ( v108800(VarCurr)
    <=> ( v108801(VarCurr)
        | v108808(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4463,axiom,
    ! [VarCurr: state_type] :
      ( v108801(VarCurr)
    <=> ( v108802(VarCurr)
        | v108808(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4462,axiom,
    ! [VarCurr: state_type] :
      ( v108802(VarCurr)
    <=> ( v108803(VarCurr)
        | v108808(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4461,axiom,
    ! [VarCurr: state_type] :
      ( v108803(VarCurr)
    <=> ( v108804(VarCurr)
        | v108808(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4460,axiom,
    ! [VarCurr: state_type] :
      ( v108804(VarCurr)
    <=> ( v108805(VarCurr)
        | v108808(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4459,axiom,
    ! [VarCurr: state_type] :
      ( v108805(VarCurr)
    <=> ( v108806(VarCurr)
        | v108808(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4458,axiom,
    ! [VarCurr: state_type] :
      ( v108806(VarCurr)
    <=> ( v108807(VarCurr)
        | v108808(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4457,axiom,
    ! [VarCurr: state_type] :
      ( v108807(VarCurr)
    <=> ( v108808(VarCurr,0)
        | v108808(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v108808(VarCurr,B)
      <=> ( v101229(VarCurr,B)
          & v101248(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101248(VarCurr,B)
      <=> ( v101250(VarCurr,B)
          & v108791(VarCurr,B) ) ) ) ).

tff(addAssignment_64740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v108791(VarCurr,B)
      <=> v101252(VarCurr,B) ) ) ).

tff(addAssignment_64739,axiom,
    ! [VarCurr: state_type] :
      ( ( v108791(VarCurr,15)
      <=> v101252(VarCurr,7) )
      & ( v108791(VarCurr,14)
      <=> v101252(VarCurr,6) )
      & ( v108791(VarCurr,13)
      <=> v101252(VarCurr,5) )
      & ( v108791(VarCurr,12)
      <=> v101252(VarCurr,4) )
      & ( v108791(VarCurr,11)
      <=> v101252(VarCurr,3) )
      & ( v108791(VarCurr,10)
      <=> v101252(VarCurr,2) )
      & ( v108791(VarCurr,9)
      <=> v101252(VarCurr,1) )
      & ( v108791(VarCurr,8)
      <=> v101252(VarCurr,0) ) ) ).

tff(addAssignment_64738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v101252(VarCurr,B)
      <=> v101254(VarCurr,B) ) ) ).

tff(addAssignment_64737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v101254(VarCurr,B)
      <=> v101256(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4456,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,7)
    <=> ( v108787(VarCurr)
        & v108789(VarCurr) ) ) ).

tff(writeUnaryOperator_5856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108789(VarCurr)
    <=> v103376(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_4455,axiom,
    ! [VarCurr: state_type] :
      ( v108787(VarCurr)
    <=> ( v108788(VarCurr)
        & v103183(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4454,axiom,
    ! [VarCurr: state_type] :
      ( v108788(VarCurr)
    <=> ( v101258(VarCurr,7)
        & v101469(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4453,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,6)
    <=> ( v108783(VarCurr)
        & v108785(VarCurr) ) ) ).

tff(writeUnaryOperator_5855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108785(VarCurr)
    <=> v103376(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_4452,axiom,
    ! [VarCurr: state_type] :
      ( v108783(VarCurr)
    <=> ( v108784(VarCurr)
        & v103183(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4451,axiom,
    ! [VarCurr: state_type] :
      ( v108784(VarCurr)
    <=> ( v101258(VarCurr,6)
        & v101469(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4450,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,5)
    <=> ( v108779(VarCurr)
        & v108781(VarCurr) ) ) ).

tff(writeUnaryOperator_5854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108781(VarCurr)
    <=> v103376(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4449,axiom,
    ! [VarCurr: state_type] :
      ( v108779(VarCurr)
    <=> ( v108780(VarCurr)
        & v103183(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4448,axiom,
    ! [VarCurr: state_type] :
      ( v108780(VarCurr)
    <=> ( v101258(VarCurr,5)
        & v101469(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4447,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,4)
    <=> ( v108775(VarCurr)
        & v108777(VarCurr) ) ) ).

tff(writeUnaryOperator_5853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108777(VarCurr)
    <=> v103376(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4446,axiom,
    ! [VarCurr: state_type] :
      ( v108775(VarCurr)
    <=> ( v108776(VarCurr)
        & v103183(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4445,axiom,
    ! [VarCurr: state_type] :
      ( v108776(VarCurr)
    <=> ( v101258(VarCurr,4)
        & v101469(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4444,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,3)
    <=> ( v108771(VarCurr)
        & v108773(VarCurr) ) ) ).

tff(writeUnaryOperator_5852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108773(VarCurr)
    <=> v103376(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4443,axiom,
    ! [VarCurr: state_type] :
      ( v108771(VarCurr)
    <=> ( v108772(VarCurr)
        & v103183(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4442,axiom,
    ! [VarCurr: state_type] :
      ( v108772(VarCurr)
    <=> ( v101258(VarCurr,3)
        & v101469(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4441,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,2)
    <=> ( v108767(VarCurr)
        & v108769(VarCurr) ) ) ).

tff(writeUnaryOperator_5851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108769(VarCurr)
    <=> v103376(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4440,axiom,
    ! [VarCurr: state_type] :
      ( v108767(VarCurr)
    <=> ( v108768(VarCurr)
        & v103183(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4439,axiom,
    ! [VarCurr: state_type] :
      ( v108768(VarCurr)
    <=> ( v101258(VarCurr,2)
        & v101469(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4438,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,1)
    <=> ( v108763(VarCurr)
        & v108765(VarCurr) ) ) ).

tff(writeUnaryOperator_5850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108765(VarCurr)
    <=> v103376(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4437,axiom,
    ! [VarCurr: state_type] :
      ( v108763(VarCurr)
    <=> ( v108764(VarCurr)
        & v103183(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4436,axiom,
    ! [VarCurr: state_type] :
      ( v108764(VarCurr)
    <=> ( v101258(VarCurr,1)
        & v101469(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11023,axiom,
    ! [VarCurr: state_type] :
      ( v101256(VarCurr,0)
    <=> ( v108759(VarCurr)
        & v108761(VarCurr) ) ) ).

tff(writeUnaryOperator_5849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108761(VarCurr)
    <=> v103376(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11022,axiom,
    ! [VarCurr: state_type] :
      ( v108759(VarCurr)
    <=> ( v108760(VarCurr)
        & v103183(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11021,axiom,
    ! [VarCurr: state_type] :
      ( v108760(VarCurr)
    <=> ( v101258(VarCurr,0)
        & v101469(VarCurr,0) ) ) ).

tff(addAssignment_64736,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,7)
    <=> v108385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11020,axiom,
    ! [VarCurr: state_type] :
      ( v108385(VarCurr)
    <=> ( v108752(VarCurr)
        & v108757(VarCurr) ) ) ).

tff(writeUnaryOperator_5848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108757(VarCurr)
    <=> v108666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11019,axiom,
    ! [VarCurr: state_type] :
      ( v108752(VarCurr)
    <=> ( v108753(VarCurr)
        & v108756(VarCurr) ) ) ).

tff(writeUnaryOperator_5847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108756(VarCurr)
    <=> v108582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11018,axiom,
    ! [VarCurr: state_type] :
      ( v108753(VarCurr)
    <=> ( v108754(VarCurr)
        & v108755(VarCurr) ) ) ).

tff(writeUnaryOperator_5846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108755(VarCurr)
    <=> v108500(VarCurr) ) ).

tff(writeUnaryOperator_5845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108754(VarCurr)
    <=> v108387(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_823,axiom,
    ! [VarCurr: state_type] :
      ( v108666(VarCurr)
    <=> ( ( v108668(VarCurr,4)
        <=> $false )
        & ( v108668(VarCurr,3)
        <=> $false )
        & ( v108668(VarCurr,2)
        <=> $false )
        & ( v108668(VarCurr,1)
        <=> $false )
        & ( v108668(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108668(VarCurr,B)
      <=> v108670(VarCurr,B) ) ) ).

tff(addAssignment_64734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108670(VarCurr,B)
      <=> v108672(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108734(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v108672(VarNext,B)
            <=> v108672(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1314,axiom,
    ! [VarNext: state_type] :
      ( v108734(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108672(VarNext,B)
          <=> v108744(VarNext,B) ) ) ) ).

tff(addAssignment_64733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108744(VarNext,B)
          <=> v108742(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108742(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_922,axiom,
    ! [VarCurr: state_type] :
      ( v108745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108742(VarCurr,B)
          <=> v108682(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11017,axiom,
    ! [VarCurr: state_type] :
      ( v108745(VarCurr)
    <=> ( v108746(VarCurr)
        & v108747(VarCurr) ) ) ).

tff(writeUnaryOperator_5844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108747(VarCurr)
    <=> v108678(VarCurr) ) ).

tff(writeUnaryOperator_5843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108746(VarCurr)
    <=> v108674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108734(VarNext)
      <=> v108735(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108735(VarNext)
      <=> ( v108736(VarNext)
          & v108729(VarNext) ) ) ) ).

tff(writeUnaryOperator_5842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108736(VarNext)
      <=> v108738(VarNext) ) ) ).

tff(addAssignment_64732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108738(VarNext)
      <=> v108729(VarCurr) ) ) ).

tff(addAssignment_64731,axiom,
    ! [VarCurr: state_type] :
      ( v108729(VarCurr)
    <=> v108731(VarCurr) ) ).

tff(addAssignment_64730,axiom,
    ! [VarCurr: state_type] :
      ( v108731(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108682(VarCurr,B)
      <=> v108684(VarCurr,B) ) ) ).

tff(addAssignment_64728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108684(VarCurr,B)
      <=> v108686(VarCurr,B) ) ) ).

tff(addAssignment_64727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108686(VarCurr,B)
      <=> v108688(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108690(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108688(VarCurr,B)
          <=> v108699(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_921,axiom,
    ! [VarCurr: state_type] :
      ( v108690(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108688(VarCurr,B)
          <=> v108698(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108699(VarCurr,B)
          <=> v108700(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_920,axiom,
    ! [VarCurr: state_type] :
      ( v108666(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108699(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64726,axiom,
    ! [VarCurr: state_type] :
      ( v108700(VarCurr,0)
    <=> v108726(VarCurr) ) ).

tff(addAssignment_64725,axiom,
    ! [VarCurr: state_type] :
      ( v108700(VarCurr,1)
    <=> v108724(VarCurr) ) ).

tff(addAssignment_64724,axiom,
    ! [VarCurr: state_type] :
      ( v108700(VarCurr,2)
    <=> v108720(VarCurr) ) ).

tff(addAssignment_64723,axiom,
    ! [VarCurr: state_type] :
      ( v108700(VarCurr,3)
    <=> v108716(VarCurr) ) ).

tff(addAssignment_64722,axiom,
    ! [VarCurr: state_type] :
      ( v108700(VarCurr,4)
    <=> v108702(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11014,axiom,
    ! [VarCurr: state_type] :
      ( v108724(VarCurr)
    <=> ( v108725(VarCurr)
        & v108727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11013,axiom,
    ! [VarCurr: state_type] :
      ( v108727(VarCurr)
    <=> ( v108668(VarCurr,0)
        | v108711(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4435,axiom,
    ! [VarCurr: state_type] :
      ( v108725(VarCurr)
    <=> ( v108726(VarCurr)
        | v108668(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108726(VarCurr)
    <=> v108668(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11012,axiom,
    ! [VarCurr: state_type] :
      ( v108720(VarCurr)
    <=> ( v108721(VarCurr)
        & v108723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11011,axiom,
    ! [VarCurr: state_type] :
      ( v108723(VarCurr)
    <=> ( v108709(VarCurr)
        | v108712(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4434,axiom,
    ! [VarCurr: state_type] :
      ( v108721(VarCurr)
    <=> ( v108722(VarCurr)
        | v108668(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108722(VarCurr)
    <=> v108709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11010,axiom,
    ! [VarCurr: state_type] :
      ( v108716(VarCurr)
    <=> ( v108717(VarCurr)
        & v108719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11009,axiom,
    ! [VarCurr: state_type] :
      ( v108719(VarCurr)
    <=> ( v108707(VarCurr)
        | v108713(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4433,axiom,
    ! [VarCurr: state_type] :
      ( v108717(VarCurr)
    <=> ( v108718(VarCurr)
        | v108668(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108718(VarCurr)
    <=> v108707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11008,axiom,
    ! [VarCurr: state_type] :
      ( v108702(VarCurr)
    <=> ( v108703(VarCurr)
        & v108714(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11007,axiom,
    ! [VarCurr: state_type] :
      ( v108714(VarCurr)
    <=> ( v108705(VarCurr)
        | v108715(VarCurr) ) ) ).

tff(writeUnaryOperator_5838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108715(VarCurr)
    <=> v108668(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4432,axiom,
    ! [VarCurr: state_type] :
      ( v108703(VarCurr)
    <=> ( v108704(VarCurr)
        | v108668(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108704(VarCurr)
    <=> v108705(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4431,axiom,
    ! [VarCurr: state_type] :
      ( v108705(VarCurr)
    <=> ( v108668(VarCurr,3)
        | v108706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11006,axiom,
    ! [VarCurr: state_type] :
      ( v108706(VarCurr)
    <=> ( v108707(VarCurr)
        & v108713(VarCurr) ) ) ).

tff(writeUnaryOperator_5836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108713(VarCurr)
    <=> v108668(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4430,axiom,
    ! [VarCurr: state_type] :
      ( v108707(VarCurr)
    <=> ( v108668(VarCurr,2)
        | v108708(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11005,axiom,
    ! [VarCurr: state_type] :
      ( v108708(VarCurr)
    <=> ( v108709(VarCurr)
        & v108712(VarCurr) ) ) ).

tff(writeUnaryOperator_5835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108712(VarCurr)
    <=> v108668(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4429,axiom,
    ! [VarCurr: state_type] :
      ( v108709(VarCurr)
    <=> ( v108668(VarCurr,1)
        | v108710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11004,axiom,
    ! [VarCurr: state_type] :
      ( v108710(VarCurr)
    <=> ( v108668(VarCurr,0)
        & v108711(VarCurr) ) ) ).

tff(writeUnaryOperator_5834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108711(VarCurr)
    <=> v108668(VarCurr,1) ) ).

tff(addAssignment_64721,axiom,
    ! [VarCurr: state_type] :
      ( v108698(VarCurr,0)
    <=> v108445(VarCurr) ) ).

tff(addAssignment_64720,axiom,
    ! [VarCurr: state_type] :
      ( v108698(VarCurr,1)
    <=> v108443(VarCurr) ) ).

tff(addAssignment_64719,axiom,
    ! [VarCurr: state_type] :
      ( v108698(VarCurr,2)
    <=> v108439(VarCurr) ) ).

tff(addAssignment_64718,axiom,
    ! [VarCurr: state_type] :
      ( v108698(VarCurr,3)
    <=> v108435(VarCurr) ) ).

tff(addAssignment_64717,axiom,
    ! [VarCurr: state_type] :
      ( v108698(VarCurr,4)
    <=> v108421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11003,axiom,
    ! [VarCurr: state_type] :
      ( v108690(VarCurr)
    <=> ( v108691(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11002,axiom,
    ! [VarCurr: state_type] :
      ( v108691(VarCurr)
    <=> ( v108692(VarCurr)
        & v108411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11001,axiom,
    ! [VarCurr: state_type] :
      ( v108692(VarCurr)
    <=> ( v108693(VarCurr)
        & v108697(VarCurr) ) ) ).

tff(writeUnaryOperator_5833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108697(VarCurr)
    <=> v108387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11000,axiom,
    ! [VarCurr: state_type] :
      ( v108693(VarCurr)
    <=> ( v108694(VarCurr)
        & v108696(VarCurr) ) ) ).

tff(writeUnaryOperator_5832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108696(VarCurr)
    <=> v108500(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10999,axiom,
    ! [VarCurr: state_type] :
      ( v108694(VarCurr)
    <=> ( v108666(VarCurr)
        & v108695(VarCurr) ) ) ).

tff(writeUnaryOperator_5831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108695(VarCurr)
    <=> v108582(VarCurr) ) ).

tff(addAssignment_64716,axiom,
    ! [VarCurr: state_type] :
      ( v108678(VarCurr)
    <=> v108680(VarCurr) ) ).

tff(addAssignment_64715,axiom,
    ! [VarCurr: state_type] :
      ( v108680(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64714,axiom,
    ! [VarCurr: state_type] :
      ( v108674(VarCurr)
    <=> v108676(VarCurr) ) ).

tff(addAssignment_64713,axiom,
    ! [VarCurr: state_type] :
      ( v108676(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_822,axiom,
    ! [VarCurr: state_type] :
      ( v108582(VarCurr)
    <=> ( ( v108584(VarCurr,4)
        <=> $false )
        & ( v108584(VarCurr,3)
        <=> $false )
        & ( v108584(VarCurr,2)
        <=> $false )
        & ( v108584(VarCurr,1)
        <=> $false )
        & ( v108584(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108584(VarCurr,B)
      <=> v108586(VarCurr,B) ) ) ).

tff(addAssignment_64711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108586(VarCurr,B)
      <=> v108588(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108648(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v108588(VarNext,B)
            <=> v108588(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1313,axiom,
    ! [VarNext: state_type] :
      ( v108648(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108588(VarNext,B)
          <=> v108658(VarNext,B) ) ) ) ).

tff(addAssignment_64710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108658(VarNext,B)
          <=> v108656(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108659(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108656(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_919,axiom,
    ! [VarCurr: state_type] :
      ( v108659(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108656(VarCurr,B)
          <=> v108598(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10998,axiom,
    ! [VarCurr: state_type] :
      ( v108659(VarCurr)
    <=> ( v108660(VarCurr)
        & v108661(VarCurr) ) ) ).

tff(writeUnaryOperator_5830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108661(VarCurr)
    <=> v108594(VarCurr) ) ).

tff(writeUnaryOperator_5829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108660(VarCurr)
    <=> v108590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108648(VarNext)
      <=> v108649(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108649(VarNext)
      <=> ( v108650(VarNext)
          & v108643(VarNext) ) ) ) ).

tff(writeUnaryOperator_5828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108650(VarNext)
      <=> v108652(VarNext) ) ) ).

tff(addAssignment_64709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108652(VarNext)
      <=> v108643(VarCurr) ) ) ).

tff(addAssignment_64708,axiom,
    ! [VarCurr: state_type] :
      ( v108643(VarCurr)
    <=> v108645(VarCurr) ) ).

tff(addAssignment_64707,axiom,
    ! [VarCurr: state_type] :
      ( v108645(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108598(VarCurr,B)
      <=> v108600(VarCurr,B) ) ) ).

tff(addAssignment_64705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108600(VarCurr,B)
      <=> v108602(VarCurr,B) ) ) ).

tff(addAssignment_64704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108602(VarCurr,B)
      <=> v108604(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108606(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108604(VarCurr,B)
          <=> v108613(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_918,axiom,
    ! [VarCurr: state_type] :
      ( v108606(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108604(VarCurr,B)
          <=> v108612(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108582(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108613(VarCurr,B)
          <=> v108614(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_917,axiom,
    ! [VarCurr: state_type] :
      ( v108582(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108613(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64703,axiom,
    ! [VarCurr: state_type] :
      ( v108614(VarCurr,0)
    <=> v108640(VarCurr) ) ).

tff(addAssignment_64702,axiom,
    ! [VarCurr: state_type] :
      ( v108614(VarCurr,1)
    <=> v108638(VarCurr) ) ).

tff(addAssignment_64701,axiom,
    ! [VarCurr: state_type] :
      ( v108614(VarCurr,2)
    <=> v108634(VarCurr) ) ).

tff(addAssignment_64700,axiom,
    ! [VarCurr: state_type] :
      ( v108614(VarCurr,3)
    <=> v108630(VarCurr) ) ).

tff(addAssignment_64699,axiom,
    ! [VarCurr: state_type] :
      ( v108614(VarCurr,4)
    <=> v108616(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10995,axiom,
    ! [VarCurr: state_type] :
      ( v108638(VarCurr)
    <=> ( v108639(VarCurr)
        & v108641(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10994,axiom,
    ! [VarCurr: state_type] :
      ( v108641(VarCurr)
    <=> ( v108584(VarCurr,0)
        | v108625(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4428,axiom,
    ! [VarCurr: state_type] :
      ( v108639(VarCurr)
    <=> ( v108640(VarCurr)
        | v108584(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108640(VarCurr)
    <=> v108584(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10993,axiom,
    ! [VarCurr: state_type] :
      ( v108634(VarCurr)
    <=> ( v108635(VarCurr)
        & v108637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10992,axiom,
    ! [VarCurr: state_type] :
      ( v108637(VarCurr)
    <=> ( v108623(VarCurr)
        | v108626(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4427,axiom,
    ! [VarCurr: state_type] :
      ( v108635(VarCurr)
    <=> ( v108636(VarCurr)
        | v108584(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108636(VarCurr)
    <=> v108623(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10991,axiom,
    ! [VarCurr: state_type] :
      ( v108630(VarCurr)
    <=> ( v108631(VarCurr)
        & v108633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10990,axiom,
    ! [VarCurr: state_type] :
      ( v108633(VarCurr)
    <=> ( v108621(VarCurr)
        | v108627(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4426,axiom,
    ! [VarCurr: state_type] :
      ( v108631(VarCurr)
    <=> ( v108632(VarCurr)
        | v108584(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108632(VarCurr)
    <=> v108621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10989,axiom,
    ! [VarCurr: state_type] :
      ( v108616(VarCurr)
    <=> ( v108617(VarCurr)
        & v108628(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10988,axiom,
    ! [VarCurr: state_type] :
      ( v108628(VarCurr)
    <=> ( v108619(VarCurr)
        | v108629(VarCurr) ) ) ).

tff(writeUnaryOperator_5824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108629(VarCurr)
    <=> v108584(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4425,axiom,
    ! [VarCurr: state_type] :
      ( v108617(VarCurr)
    <=> ( v108618(VarCurr)
        | v108584(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108618(VarCurr)
    <=> v108619(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4424,axiom,
    ! [VarCurr: state_type] :
      ( v108619(VarCurr)
    <=> ( v108584(VarCurr,3)
        | v108620(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10987,axiom,
    ! [VarCurr: state_type] :
      ( v108620(VarCurr)
    <=> ( v108621(VarCurr)
        & v108627(VarCurr) ) ) ).

tff(writeUnaryOperator_5822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108627(VarCurr)
    <=> v108584(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4423,axiom,
    ! [VarCurr: state_type] :
      ( v108621(VarCurr)
    <=> ( v108584(VarCurr,2)
        | v108622(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10986,axiom,
    ! [VarCurr: state_type] :
      ( v108622(VarCurr)
    <=> ( v108623(VarCurr)
        & v108626(VarCurr) ) ) ).

tff(writeUnaryOperator_5821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108626(VarCurr)
    <=> v108584(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4422,axiom,
    ! [VarCurr: state_type] :
      ( v108623(VarCurr)
    <=> ( v108584(VarCurr,1)
        | v108624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10985,axiom,
    ! [VarCurr: state_type] :
      ( v108624(VarCurr)
    <=> ( v108584(VarCurr,0)
        & v108625(VarCurr) ) ) ).

tff(writeUnaryOperator_5820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108625(VarCurr)
    <=> v108584(VarCurr,1) ) ).

tff(addAssignment_64698,axiom,
    ! [VarCurr: state_type] :
      ( v108612(VarCurr,0)
    <=> v108445(VarCurr) ) ).

tff(addAssignment_64697,axiom,
    ! [VarCurr: state_type] :
      ( v108612(VarCurr,1)
    <=> v108443(VarCurr) ) ).

tff(addAssignment_64696,axiom,
    ! [VarCurr: state_type] :
      ( v108612(VarCurr,2)
    <=> v108439(VarCurr) ) ).

tff(addAssignment_64695,axiom,
    ! [VarCurr: state_type] :
      ( v108612(VarCurr,3)
    <=> v108435(VarCurr) ) ).

tff(addAssignment_64694,axiom,
    ! [VarCurr: state_type] :
      ( v108612(VarCurr,4)
    <=> v108421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10984,axiom,
    ! [VarCurr: state_type] :
      ( v108606(VarCurr)
    <=> ( v108607(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10983,axiom,
    ! [VarCurr: state_type] :
      ( v108607(VarCurr)
    <=> ( v108608(VarCurr)
        & v108411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10982,axiom,
    ! [VarCurr: state_type] :
      ( v108608(VarCurr)
    <=> ( v108609(VarCurr)
        & v108611(VarCurr) ) ) ).

tff(writeUnaryOperator_5819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108611(VarCurr)
    <=> v108387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10981,axiom,
    ! [VarCurr: state_type] :
      ( v108609(VarCurr)
    <=> ( v108582(VarCurr)
        & v108610(VarCurr) ) ) ).

tff(writeUnaryOperator_5818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108610(VarCurr)
    <=> v108500(VarCurr) ) ).

tff(addAssignment_64693,axiom,
    ! [VarCurr: state_type] :
      ( v108594(VarCurr)
    <=> v108596(VarCurr) ) ).

tff(addAssignment_64692,axiom,
    ! [VarCurr: state_type] :
      ( v108596(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64691,axiom,
    ! [VarCurr: state_type] :
      ( v108590(VarCurr)
    <=> v108592(VarCurr) ) ).

tff(addAssignment_64690,axiom,
    ! [VarCurr: state_type] :
      ( v108592(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_821,axiom,
    ! [VarCurr: state_type] :
      ( v108500(VarCurr)
    <=> ( ( v108502(VarCurr,4)
        <=> $false )
        & ( v108502(VarCurr,3)
        <=> $false )
        & ( v108502(VarCurr,2)
        <=> $false )
        & ( v108502(VarCurr,1)
        <=> $false )
        & ( v108502(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108502(VarCurr,B)
      <=> v108504(VarCurr,B) ) ) ).

tff(addAssignment_64688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108504(VarCurr,B)
      <=> v108506(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108564(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v108506(VarNext,B)
            <=> v108506(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1312,axiom,
    ! [VarNext: state_type] :
      ( v108564(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108506(VarNext,B)
          <=> v108574(VarNext,B) ) ) ) ).

tff(addAssignment_64687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108574(VarNext,B)
          <=> v108572(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108572(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_916,axiom,
    ! [VarCurr: state_type] :
      ( v108575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108572(VarCurr,B)
          <=> v108516(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10980,axiom,
    ! [VarCurr: state_type] :
      ( v108575(VarCurr)
    <=> ( v108576(VarCurr)
        & v108577(VarCurr) ) ) ).

tff(writeUnaryOperator_5817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108577(VarCurr)
    <=> v108512(VarCurr) ) ).

tff(writeUnaryOperator_5816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108576(VarCurr)
    <=> v108508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108564(VarNext)
      <=> v108565(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108565(VarNext)
      <=> ( v108566(VarNext)
          & v108559(VarNext) ) ) ) ).

tff(writeUnaryOperator_5815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108566(VarNext)
      <=> v108568(VarNext) ) ) ).

tff(addAssignment_64686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108568(VarNext)
      <=> v108559(VarCurr) ) ) ).

tff(addAssignment_64685,axiom,
    ! [VarCurr: state_type] :
      ( v108559(VarCurr)
    <=> v108561(VarCurr) ) ).

tff(addAssignment_64684,axiom,
    ! [VarCurr: state_type] :
      ( v108561(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108516(VarCurr,B)
      <=> v108518(VarCurr,B) ) ) ).

tff(addAssignment_64682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108518(VarCurr,B)
      <=> v108520(VarCurr,B) ) ) ).

tff(addAssignment_64681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108520(VarCurr,B)
      <=> v108522(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108522(VarCurr,B)
          <=> v108529(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_915,axiom,
    ! [VarCurr: state_type] :
      ( v108524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108522(VarCurr,B)
          <=> v108528(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108529(VarCurr,B)
          <=> v108530(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_914,axiom,
    ! [VarCurr: state_type] :
      ( v108500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108529(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64680,axiom,
    ! [VarCurr: state_type] :
      ( v108530(VarCurr,0)
    <=> v108556(VarCurr) ) ).

tff(addAssignment_64679,axiom,
    ! [VarCurr: state_type] :
      ( v108530(VarCurr,1)
    <=> v108554(VarCurr) ) ).

tff(addAssignment_64678,axiom,
    ! [VarCurr: state_type] :
      ( v108530(VarCurr,2)
    <=> v108550(VarCurr) ) ).

tff(addAssignment_64677,axiom,
    ! [VarCurr: state_type] :
      ( v108530(VarCurr,3)
    <=> v108546(VarCurr) ) ).

tff(addAssignment_64676,axiom,
    ! [VarCurr: state_type] :
      ( v108530(VarCurr,4)
    <=> v108532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10977,axiom,
    ! [VarCurr: state_type] :
      ( v108554(VarCurr)
    <=> ( v108555(VarCurr)
        & v108557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10976,axiom,
    ! [VarCurr: state_type] :
      ( v108557(VarCurr)
    <=> ( v108502(VarCurr,0)
        | v108541(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4421,axiom,
    ! [VarCurr: state_type] :
      ( v108555(VarCurr)
    <=> ( v108556(VarCurr)
        | v108502(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108556(VarCurr)
    <=> v108502(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10975,axiom,
    ! [VarCurr: state_type] :
      ( v108550(VarCurr)
    <=> ( v108551(VarCurr)
        & v108553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10974,axiom,
    ! [VarCurr: state_type] :
      ( v108553(VarCurr)
    <=> ( v108539(VarCurr)
        | v108542(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4420,axiom,
    ! [VarCurr: state_type] :
      ( v108551(VarCurr)
    <=> ( v108552(VarCurr)
        | v108502(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108552(VarCurr)
    <=> v108539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10973,axiom,
    ! [VarCurr: state_type] :
      ( v108546(VarCurr)
    <=> ( v108547(VarCurr)
        & v108549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10972,axiom,
    ! [VarCurr: state_type] :
      ( v108549(VarCurr)
    <=> ( v108537(VarCurr)
        | v108543(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4419,axiom,
    ! [VarCurr: state_type] :
      ( v108547(VarCurr)
    <=> ( v108548(VarCurr)
        | v108502(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108548(VarCurr)
    <=> v108537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10971,axiom,
    ! [VarCurr: state_type] :
      ( v108532(VarCurr)
    <=> ( v108533(VarCurr)
        & v108544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10970,axiom,
    ! [VarCurr: state_type] :
      ( v108544(VarCurr)
    <=> ( v108535(VarCurr)
        | v108545(VarCurr) ) ) ).

tff(writeUnaryOperator_5811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108545(VarCurr)
    <=> v108502(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4418,axiom,
    ! [VarCurr: state_type] :
      ( v108533(VarCurr)
    <=> ( v108534(VarCurr)
        | v108502(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108534(VarCurr)
    <=> v108535(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4417,axiom,
    ! [VarCurr: state_type] :
      ( v108535(VarCurr)
    <=> ( v108502(VarCurr,3)
        | v108536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10969,axiom,
    ! [VarCurr: state_type] :
      ( v108536(VarCurr)
    <=> ( v108537(VarCurr)
        & v108543(VarCurr) ) ) ).

tff(writeUnaryOperator_5809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108543(VarCurr)
    <=> v108502(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4416,axiom,
    ! [VarCurr: state_type] :
      ( v108537(VarCurr)
    <=> ( v108502(VarCurr,2)
        | v108538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10968,axiom,
    ! [VarCurr: state_type] :
      ( v108538(VarCurr)
    <=> ( v108539(VarCurr)
        & v108542(VarCurr) ) ) ).

tff(writeUnaryOperator_5808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108542(VarCurr)
    <=> v108502(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4415,axiom,
    ! [VarCurr: state_type] :
      ( v108539(VarCurr)
    <=> ( v108502(VarCurr,1)
        | v108540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10967,axiom,
    ! [VarCurr: state_type] :
      ( v108540(VarCurr)
    <=> ( v108502(VarCurr,0)
        & v108541(VarCurr) ) ) ).

tff(writeUnaryOperator_5807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108541(VarCurr)
    <=> v108502(VarCurr,1) ) ).

tff(addAssignment_64675,axiom,
    ! [VarCurr: state_type] :
      ( v108528(VarCurr,0)
    <=> v108445(VarCurr) ) ).

tff(addAssignment_64674,axiom,
    ! [VarCurr: state_type] :
      ( v108528(VarCurr,1)
    <=> v108443(VarCurr) ) ).

tff(addAssignment_64673,axiom,
    ! [VarCurr: state_type] :
      ( v108528(VarCurr,2)
    <=> v108439(VarCurr) ) ).

tff(addAssignment_64672,axiom,
    ! [VarCurr: state_type] :
      ( v108528(VarCurr,3)
    <=> v108435(VarCurr) ) ).

tff(addAssignment_64671,axiom,
    ! [VarCurr: state_type] :
      ( v108528(VarCurr,4)
    <=> v108421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10966,axiom,
    ! [VarCurr: state_type] :
      ( v108524(VarCurr)
    <=> ( v108525(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10965,axiom,
    ! [VarCurr: state_type] :
      ( v108525(VarCurr)
    <=> ( v108526(VarCurr)
        & v108411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10964,axiom,
    ! [VarCurr: state_type] :
      ( v108526(VarCurr)
    <=> ( v108500(VarCurr)
        & v108527(VarCurr) ) ) ).

tff(writeUnaryOperator_5806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108527(VarCurr)
    <=> v108387(VarCurr) ) ).

tff(addAssignment_64670,axiom,
    ! [VarCurr: state_type] :
      ( v108512(VarCurr)
    <=> v108514(VarCurr) ) ).

tff(addAssignment_64669,axiom,
    ! [VarCurr: state_type] :
      ( v108514(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64668,axiom,
    ! [VarCurr: state_type] :
      ( v108508(VarCurr)
    <=> v108510(VarCurr) ) ).

tff(addAssignment_64667,axiom,
    ! [VarCurr: state_type] :
      ( v108510(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_820,axiom,
    ! [VarCurr: state_type] :
      ( v108387(VarCurr)
    <=> ( ( v108389(VarCurr,4)
        <=> $false )
        & ( v108389(VarCurr,3)
        <=> $false )
        & ( v108389(VarCurr,2)
        <=> $false )
        & ( v108389(VarCurr,1)
        <=> $false )
        & ( v108389(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108389(VarCurr,B)
      <=> v108391(VarCurr,B) ) ) ).

tff(addAssignment_64665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108391(VarCurr,B)
      <=> v108393(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108482(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v108393(VarNext,B)
            <=> v108393(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1311,axiom,
    ! [VarNext: state_type] :
      ( v108482(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108393(VarNext,B)
          <=> v108492(VarNext,B) ) ) ) ).

tff(addAssignment_64664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108492(VarNext,B)
          <=> v108490(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108490(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_913,axiom,
    ! [VarCurr: state_type] :
      ( v108493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108490(VarCurr,B)
          <=> v108403(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10963,axiom,
    ! [VarCurr: state_type] :
      ( v108493(VarCurr)
    <=> ( v108494(VarCurr)
        & v108495(VarCurr) ) ) ).

tff(writeUnaryOperator_5805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108495(VarCurr)
    <=> v108399(VarCurr) ) ).

tff(writeUnaryOperator_5804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108494(VarCurr)
    <=> v108395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108482(VarNext)
      <=> v108483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108483(VarNext)
      <=> ( v108484(VarNext)
          & v108477(VarNext) ) ) ) ).

tff(writeUnaryOperator_5803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108484(VarNext)
      <=> v108486(VarNext) ) ) ).

tff(addAssignment_64663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108486(VarNext)
      <=> v108477(VarCurr) ) ) ).

tff(addAssignment_64662,axiom,
    ! [VarCurr: state_type] :
      ( v108477(VarCurr)
    <=> v108479(VarCurr) ) ).

tff(addAssignment_64661,axiom,
    ! [VarCurr: state_type] :
      ( v108479(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108403(VarCurr,B)
      <=> v108405(VarCurr,B) ) ) ).

tff(addAssignment_64659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108405(VarCurr,B)
      <=> v108407(VarCurr,B) ) ) ).

tff(addAssignment_64658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v108407(VarCurr,B)
      <=> v108409(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108409(VarCurr,B)
          <=> v108447(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_912,axiom,
    ! [VarCurr: state_type] :
      ( v108417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108409(VarCurr,B)
          <=> v108419(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108387(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108447(VarCurr,B)
          <=> v108448(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_911,axiom,
    ! [VarCurr: state_type] :
      ( v108387(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108447(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64657,axiom,
    ! [VarCurr: state_type] :
      ( v108448(VarCurr,0)
    <=> v108474(VarCurr) ) ).

tff(addAssignment_64656,axiom,
    ! [VarCurr: state_type] :
      ( v108448(VarCurr,1)
    <=> v108472(VarCurr) ) ).

tff(addAssignment_64655,axiom,
    ! [VarCurr: state_type] :
      ( v108448(VarCurr,2)
    <=> v108468(VarCurr) ) ).

tff(addAssignment_64654,axiom,
    ! [VarCurr: state_type] :
      ( v108448(VarCurr,3)
    <=> v108464(VarCurr) ) ).

tff(addAssignment_64653,axiom,
    ! [VarCurr: state_type] :
      ( v108448(VarCurr,4)
    <=> v108450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10960,axiom,
    ! [VarCurr: state_type] :
      ( v108472(VarCurr)
    <=> ( v108473(VarCurr)
        & v108475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10959,axiom,
    ! [VarCurr: state_type] :
      ( v108475(VarCurr)
    <=> ( v108389(VarCurr,0)
        | v108459(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4414,axiom,
    ! [VarCurr: state_type] :
      ( v108473(VarCurr)
    <=> ( v108474(VarCurr)
        | v108389(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108474(VarCurr)
    <=> v108389(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10958,axiom,
    ! [VarCurr: state_type] :
      ( v108468(VarCurr)
    <=> ( v108469(VarCurr)
        & v108471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10957,axiom,
    ! [VarCurr: state_type] :
      ( v108471(VarCurr)
    <=> ( v108457(VarCurr)
        | v108460(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4413,axiom,
    ! [VarCurr: state_type] :
      ( v108469(VarCurr)
    <=> ( v108470(VarCurr)
        | v108389(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108470(VarCurr)
    <=> v108457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10956,axiom,
    ! [VarCurr: state_type] :
      ( v108464(VarCurr)
    <=> ( v108465(VarCurr)
        & v108467(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10955,axiom,
    ! [VarCurr: state_type] :
      ( v108467(VarCurr)
    <=> ( v108455(VarCurr)
        | v108461(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4412,axiom,
    ! [VarCurr: state_type] :
      ( v108465(VarCurr)
    <=> ( v108466(VarCurr)
        | v108389(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108466(VarCurr)
    <=> v108455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10954,axiom,
    ! [VarCurr: state_type] :
      ( v108450(VarCurr)
    <=> ( v108451(VarCurr)
        & v108462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10953,axiom,
    ! [VarCurr: state_type] :
      ( v108462(VarCurr)
    <=> ( v108453(VarCurr)
        | v108463(VarCurr) ) ) ).

tff(writeUnaryOperator_5799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108463(VarCurr)
    <=> v108389(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4411,axiom,
    ! [VarCurr: state_type] :
      ( v108451(VarCurr)
    <=> ( v108452(VarCurr)
        | v108389(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108452(VarCurr)
    <=> v108453(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4410,axiom,
    ! [VarCurr: state_type] :
      ( v108453(VarCurr)
    <=> ( v108389(VarCurr,3)
        | v108454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10952,axiom,
    ! [VarCurr: state_type] :
      ( v108454(VarCurr)
    <=> ( v108455(VarCurr)
        & v108461(VarCurr) ) ) ).

tff(writeUnaryOperator_5797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108461(VarCurr)
    <=> v108389(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4409,axiom,
    ! [VarCurr: state_type] :
      ( v108455(VarCurr)
    <=> ( v108389(VarCurr,2)
        | v108456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10951,axiom,
    ! [VarCurr: state_type] :
      ( v108456(VarCurr)
    <=> ( v108457(VarCurr)
        & v108460(VarCurr) ) ) ).

tff(writeUnaryOperator_5796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108460(VarCurr)
    <=> v108389(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4408,axiom,
    ! [VarCurr: state_type] :
      ( v108457(VarCurr)
    <=> ( v108389(VarCurr,1)
        | v108458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10950,axiom,
    ! [VarCurr: state_type] :
      ( v108458(VarCurr)
    <=> ( v108389(VarCurr,0)
        & v108459(VarCurr) ) ) ).

tff(writeUnaryOperator_5795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108459(VarCurr)
    <=> v108389(VarCurr,1) ) ).

tff(addAssignment_64652,axiom,
    ! [VarCurr: state_type] :
      ( v108419(VarCurr,0)
    <=> v108445(VarCurr) ) ).

tff(addAssignment_64651,axiom,
    ! [VarCurr: state_type] :
      ( v108419(VarCurr,1)
    <=> v108443(VarCurr) ) ).

tff(addAssignment_64650,axiom,
    ! [VarCurr: state_type] :
      ( v108419(VarCurr,2)
    <=> v108439(VarCurr) ) ).

tff(addAssignment_64649,axiom,
    ! [VarCurr: state_type] :
      ( v108419(VarCurr,3)
    <=> v108435(VarCurr) ) ).

tff(addAssignment_64648,axiom,
    ! [VarCurr: state_type] :
      ( v108419(VarCurr,4)
    <=> v108421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10949,axiom,
    ! [VarCurr: state_type] :
      ( v108443(VarCurr)
    <=> ( v108444(VarCurr)
        & v108446(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10948,axiom,
    ! [VarCurr: state_type] :
      ( v108446(VarCurr)
    <=> ( v108415(VarCurr,0)
        | v108430(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4407,axiom,
    ! [VarCurr: state_type] :
      ( v108444(VarCurr)
    <=> ( v108445(VarCurr)
        | v108415(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108445(VarCurr)
    <=> v108415(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10947,axiom,
    ! [VarCurr: state_type] :
      ( v108439(VarCurr)
    <=> ( v108440(VarCurr)
        & v108442(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10946,axiom,
    ! [VarCurr: state_type] :
      ( v108442(VarCurr)
    <=> ( v108428(VarCurr)
        | v108431(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4406,axiom,
    ! [VarCurr: state_type] :
      ( v108440(VarCurr)
    <=> ( v108441(VarCurr)
        | v108415(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108441(VarCurr)
    <=> v108428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10945,axiom,
    ! [VarCurr: state_type] :
      ( v108435(VarCurr)
    <=> ( v108436(VarCurr)
        & v108438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10944,axiom,
    ! [VarCurr: state_type] :
      ( v108438(VarCurr)
    <=> ( v108426(VarCurr)
        | v108432(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4405,axiom,
    ! [VarCurr: state_type] :
      ( v108436(VarCurr)
    <=> ( v108437(VarCurr)
        | v108415(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108437(VarCurr)
    <=> v108426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10943,axiom,
    ! [VarCurr: state_type] :
      ( v108421(VarCurr)
    <=> ( v108422(VarCurr)
        & v108433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10942,axiom,
    ! [VarCurr: state_type] :
      ( v108433(VarCurr)
    <=> ( v108424(VarCurr)
        | v108434(VarCurr) ) ) ).

tff(writeUnaryOperator_5791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108434(VarCurr)
    <=> v108415(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4404,axiom,
    ! [VarCurr: state_type] :
      ( v108422(VarCurr)
    <=> ( v108423(VarCurr)
        | v108415(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108423(VarCurr)
    <=> v108424(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4403,axiom,
    ! [VarCurr: state_type] :
      ( v108424(VarCurr)
    <=> ( v108415(VarCurr,3)
        | v108425(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10941,axiom,
    ! [VarCurr: state_type] :
      ( v108425(VarCurr)
    <=> ( v108426(VarCurr)
        & v108432(VarCurr) ) ) ).

tff(writeUnaryOperator_5789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108432(VarCurr)
    <=> v108415(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4402,axiom,
    ! [VarCurr: state_type] :
      ( v108426(VarCurr)
    <=> ( v108415(VarCurr,2)
        | v108427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10940,axiom,
    ! [VarCurr: state_type] :
      ( v108427(VarCurr)
    <=> ( v108428(VarCurr)
        & v108431(VarCurr) ) ) ).

tff(writeUnaryOperator_5788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108431(VarCurr)
    <=> v108415(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4401,axiom,
    ! [VarCurr: state_type] :
      ( v108428(VarCurr)
    <=> ( v108415(VarCurr,1)
        | v108429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10939,axiom,
    ! [VarCurr: state_type] :
      ( v108429(VarCurr)
    <=> ( v108415(VarCurr,0)
        & v108430(VarCurr) ) ) ).

tff(writeUnaryOperator_5787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108430(VarCurr)
    <=> v108415(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10938,axiom,
    ! [VarCurr: state_type] :
      ( v108417(VarCurr)
    <=> ( v108418(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10937,axiom,
    ! [VarCurr: state_type] :
      ( v108418(VarCurr)
    <=> ( v108387(VarCurr)
        & v108411(VarCurr) ) ) ).

tff(addAssignment_64647,axiom,
    ! [VarCurr: state_type] :
      ( v108415(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_64646,axiom,
    ! [VarCurr: state_type] :
      ( v108415(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_64645,axiom,
    ! [VarCurr: state_type] :
      ( v108415(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_64644,axiom,
    ! [VarCurr: state_type] :
      ( v108415(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_64643,axiom,
    ! [VarCurr: state_type] :
      ( v108415(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10936,axiom,
    ! [VarCurr: state_type] :
      ( v108411(VarCurr)
    <=> ( v108413(VarCurr)
        | v108208(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10935,axiom,
    ! [VarCurr: state_type] :
      ( v108413(VarCurr)
    <=> ( v108090(VarCurr)
        | v108201(VarCurr) ) ) ).

tff(addAssignment_64642,axiom,
    ! [VarCurr: state_type] :
      ( v108399(VarCurr)
    <=> v108401(VarCurr) ) ).

tff(addAssignment_64641,axiom,
    ! [VarCurr: state_type] :
      ( v108401(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64640,axiom,
    ! [VarCurr: state_type] :
      ( v108395(VarCurr)
    <=> v108397(VarCurr) ) ).

tff(addAssignment_64639,axiom,
    ! [VarCurr: state_type] :
      ( v108397(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_64638,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,7)
    <=> v108284(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_819,axiom,
    ! [VarCurr: state_type] :
      ( v108284(VarCurr)
    <=> ( ( v108286(VarCurr,3)
        <=> $false )
        & ( v108286(VarCurr,2)
        <=> $false )
        & ( v108286(VarCurr,1)
        <=> $false )
        & ( v108286(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108286(VarCurr,B)
      <=> v108288(VarCurr,B) ) ) ).

tff(addAssignment_64636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108288(VarCurr,B)
      <=> v108290(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108367(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v108290(VarNext,B)
            <=> v108290(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1310,axiom,
    ! [VarNext: state_type] :
      ( v108367(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108290(VarNext,B)
          <=> v108377(VarNext,B) ) ) ) ).

tff(addAssignment_64635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108377(VarNext,B)
          <=> v108375(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108378(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108375(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_910,axiom,
    ! [VarCurr: state_type] :
      ( v108378(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108375(VarCurr,B)
          <=> v108300(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10934,axiom,
    ! [VarCurr: state_type] :
      ( v108378(VarCurr)
    <=> ( v108379(VarCurr)
        & v108380(VarCurr) ) ) ).

tff(writeUnaryOperator_5786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108380(VarCurr)
    <=> v108296(VarCurr) ) ).

tff(writeUnaryOperator_5785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108379(VarCurr)
    <=> v108292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108367(VarNext)
      <=> v108368(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108368(VarNext)
      <=> ( v108369(VarNext)
          & v108362(VarNext) ) ) ) ).

tff(writeUnaryOperator_5784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108369(VarNext)
      <=> v108371(VarNext) ) ) ).

tff(addAssignment_64634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108371(VarNext)
      <=> v108362(VarCurr) ) ) ).

tff(addAssignment_64633,axiom,
    ! [VarCurr: state_type] :
      ( v108362(VarCurr)
    <=> v108364(VarCurr) ) ).

tff(addAssignment_64632,axiom,
    ! [VarCurr: state_type] :
      ( v108364(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108300(VarCurr,B)
      <=> v108302(VarCurr,B) ) ) ).

tff(addAssignment_64630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108302(VarCurr,B)
      <=> v108304(VarCurr,B) ) ) ).

tff(addAssignment_64629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108304(VarCurr,B)
      <=> v108306(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108313(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108306(VarCurr,B)
          <=> v108335(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_909,axiom,
    ! [VarCurr: state_type] :
      ( v108313(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108306(VarCurr,B)
          <=> v108314(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108336(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108335(VarCurr,B)
          <=> v108337(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_908,axiom,
    ! [VarCurr: state_type] :
      ( v108336(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108335(VarCurr,B)
          <=> v108311(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108338(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108337(VarCurr,B)
          <=> v108339(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_907,axiom,
    ! [VarCurr: state_type] :
      ( v108338(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108337(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108339(VarCurr,B)
          <=> v108286(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_906,axiom,
    ! [VarCurr: state_type] :
      ( v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108339(VarCurr,B)
          <=> v108340(VarCurr,B) ) ) ) ).

tff(addAssignment_64628,axiom,
    ! [VarCurr: state_type] :
      ( v108340(VarCurr,0)
    <=> v108359(VarCurr) ) ).

tff(addAssignment_64627,axiom,
    ! [VarCurr: state_type] :
      ( v108340(VarCurr,1)
    <=> v108357(VarCurr) ) ).

tff(addAssignment_64626,axiom,
    ! [VarCurr: state_type] :
      ( v108340(VarCurr,2)
    <=> v108353(VarCurr) ) ).

tff(addAssignment_64625,axiom,
    ! [VarCurr: state_type] :
      ( v108340(VarCurr,3)
    <=> v108342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10931,axiom,
    ! [VarCurr: state_type] :
      ( v108357(VarCurr)
    <=> ( v108358(VarCurr)
        & v108360(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10930,axiom,
    ! [VarCurr: state_type] :
      ( v108360(VarCurr)
    <=> ( v108286(VarCurr,0)
        | v108349(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4400,axiom,
    ! [VarCurr: state_type] :
      ( v108358(VarCurr)
    <=> ( v108359(VarCurr)
        | v108286(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108359(VarCurr)
    <=> v108286(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10929,axiom,
    ! [VarCurr: state_type] :
      ( v108353(VarCurr)
    <=> ( v108354(VarCurr)
        & v108356(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10928,axiom,
    ! [VarCurr: state_type] :
      ( v108356(VarCurr)
    <=> ( v108347(VarCurr)
        | v108350(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4399,axiom,
    ! [VarCurr: state_type] :
      ( v108354(VarCurr)
    <=> ( v108355(VarCurr)
        | v108286(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108355(VarCurr)
    <=> v108347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10927,axiom,
    ! [VarCurr: state_type] :
      ( v108342(VarCurr)
    <=> ( v108343(VarCurr)
        & v108351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10926,axiom,
    ! [VarCurr: state_type] :
      ( v108351(VarCurr)
    <=> ( v108345(VarCurr)
        | v108352(VarCurr) ) ) ).

tff(writeUnaryOperator_5781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108352(VarCurr)
    <=> v108286(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4398,axiom,
    ! [VarCurr: state_type] :
      ( v108343(VarCurr)
    <=> ( v108344(VarCurr)
        | v108286(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108344(VarCurr)
    <=> v108345(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4397,axiom,
    ! [VarCurr: state_type] :
      ( v108345(VarCurr)
    <=> ( v108286(VarCurr,2)
        | v108346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10925,axiom,
    ! [VarCurr: state_type] :
      ( v108346(VarCurr)
    <=> ( v108347(VarCurr)
        & v108350(VarCurr) ) ) ).

tff(writeUnaryOperator_5779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108350(VarCurr)
    <=> v108286(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4396,axiom,
    ! [VarCurr: state_type] :
      ( v108347(VarCurr)
    <=> ( v108286(VarCurr,1)
        | v108348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10924,axiom,
    ! [VarCurr: state_type] :
      ( v108348(VarCurr)
    <=> ( v108286(VarCurr,0)
        & v108349(VarCurr) ) ) ).

tff(writeUnaryOperator_5778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108349(VarCurr)
    <=> v108286(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_818,axiom,
    ! [VarCurr: state_type] :
      ( v108338(VarCurr)
    <=> ( ( v108286(VarCurr,3)
        <=> $false )
        & ( v108286(VarCurr,2)
        <=> $false )
        & ( v108286(VarCurr,1)
        <=> $false )
        & ( v108286(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10923,axiom,
    ! [VarCurr: state_type] :
      ( v108336(VarCurr)
    <=> ( v108208(VarCurr)
        & v108284(VarCurr) ) ) ).

tff(addAssignment_64624,axiom,
    ! [VarCurr: state_type] :
      ( v108314(VarCurr,0)
    <=> v108333(VarCurr) ) ).

tff(addAssignment_64623,axiom,
    ! [VarCurr: state_type] :
      ( v108314(VarCurr,1)
    <=> v108331(VarCurr) ) ).

tff(addAssignment_64622,axiom,
    ! [VarCurr: state_type] :
      ( v108314(VarCurr,2)
    <=> v108327(VarCurr) ) ).

tff(addAssignment_64621,axiom,
    ! [VarCurr: state_type] :
      ( v108314(VarCurr,3)
    <=> v108316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10922,axiom,
    ! [VarCurr: state_type] :
      ( v108331(VarCurr)
    <=> ( v108332(VarCurr)
        & v108334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10921,axiom,
    ! [VarCurr: state_type] :
      ( v108334(VarCurr)
    <=> ( v108311(VarCurr,0)
        | v108323(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4395,axiom,
    ! [VarCurr: state_type] :
      ( v108332(VarCurr)
    <=> ( v108333(VarCurr)
        | v108311(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108333(VarCurr)
    <=> v108311(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10920,axiom,
    ! [VarCurr: state_type] :
      ( v108327(VarCurr)
    <=> ( v108328(VarCurr)
        & v108330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10919,axiom,
    ! [VarCurr: state_type] :
      ( v108330(VarCurr)
    <=> ( v108321(VarCurr)
        | v108324(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4394,axiom,
    ! [VarCurr: state_type] :
      ( v108328(VarCurr)
    <=> ( v108329(VarCurr)
        | v108311(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108329(VarCurr)
    <=> v108321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10918,axiom,
    ! [VarCurr: state_type] :
      ( v108316(VarCurr)
    <=> ( v108317(VarCurr)
        & v108325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10917,axiom,
    ! [VarCurr: state_type] :
      ( v108325(VarCurr)
    <=> ( v108319(VarCurr)
        | v108326(VarCurr) ) ) ).

tff(writeUnaryOperator_5775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108326(VarCurr)
    <=> v108311(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4393,axiom,
    ! [VarCurr: state_type] :
      ( v108317(VarCurr)
    <=> ( v108318(VarCurr)
        | v108311(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108318(VarCurr)
    <=> v108319(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4392,axiom,
    ! [VarCurr: state_type] :
      ( v108319(VarCurr)
    <=> ( v108311(VarCurr,2)
        | v108320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10916,axiom,
    ! [VarCurr: state_type] :
      ( v108320(VarCurr)
    <=> ( v108321(VarCurr)
        & v108324(VarCurr) ) ) ).

tff(writeUnaryOperator_5773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108324(VarCurr)
    <=> v108311(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4391,axiom,
    ! [VarCurr: state_type] :
      ( v108321(VarCurr)
    <=> ( v108311(VarCurr,1)
        | v108322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10915,axiom,
    ! [VarCurr: state_type] :
      ( v108322(VarCurr)
    <=> ( v108311(VarCurr,0)
        & v108323(VarCurr) ) ) ).

tff(writeUnaryOperator_5772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108323(VarCurr)
    <=> v108311(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10914,axiom,
    ! [VarCurr: state_type] :
      ( v108313(VarCurr)
    <=> ( v108308(VarCurr)
        & v108284(VarCurr) ) ) ).

tff(addAssignment_64620,axiom,
    ! [VarCurr: state_type] :
      ( v108311(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_64619,axiom,
    ! [VarCurr: state_type] :
      ( v108311(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_64618,axiom,
    ! [VarCurr: state_type] :
      ( v108311(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_64617,axiom,
    ! [VarCurr: state_type] :
      ( v108311(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10913,axiom,
    ! [VarCurr: state_type] :
      ( v108308(VarCurr)
    <=> ( v108090(VarCurr)
        | v108201(VarCurr) ) ) ).

tff(addAssignment_64616,axiom,
    ! [VarCurr: state_type] :
      ( v108296(VarCurr)
    <=> v108298(VarCurr) ) ).

tff(addAssignment_64615,axiom,
    ! [VarCurr: state_type] :
      ( v108298(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64614,axiom,
    ! [VarCurr: state_type] :
      ( v108292(VarCurr)
    <=> v108294(VarCurr) ) ).

tff(addAssignment_64613,axiom,
    ! [VarCurr: state_type] :
      ( v108294(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_64612,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,7)
    <=> v108157(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_817,axiom,
    ! [VarCurr: state_type] :
      ( v108157(VarCurr)
    <=> ( ( v108159(VarCurr,1)
        <=> $false )
        & ( v108159(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108159(VarCurr,B)
      <=> v108161(VarCurr,B) ) ) ).

tff(addAssignment_64610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108161(VarCurr,B)
      <=> v108163(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108266(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v108163(VarNext,B)
            <=> v108163(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1309,axiom,
    ! [VarNext: state_type] :
      ( v108266(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108163(VarNext,B)
          <=> v108276(VarNext,B) ) ) ) ).

tff(addAssignment_64609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108276(VarNext,B)
          <=> v108274(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108277(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108274(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_905,axiom,
    ! [VarCurr: state_type] :
      ( v108277(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108274(VarCurr,B)
          <=> v108173(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10912,axiom,
    ! [VarCurr: state_type] :
      ( v108277(VarCurr)
    <=> ( v108278(VarCurr)
        & v108279(VarCurr) ) ) ).

tff(writeUnaryOperator_5771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108279(VarCurr)
    <=> v108169(VarCurr) ) ).

tff(writeUnaryOperator_5770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108278(VarCurr)
    <=> v108165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108266(VarNext)
      <=> v108267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108267(VarNext)
      <=> ( v108268(VarNext)
          & v108261(VarNext) ) ) ) ).

tff(writeUnaryOperator_5769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108268(VarNext)
      <=> v108270(VarNext) ) ) ).

tff(addAssignment_64608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108270(VarNext)
      <=> v108261(VarCurr) ) ) ).

tff(addAssignment_64607,axiom,
    ! [VarCurr: state_type] :
      ( v108261(VarCurr)
    <=> v108263(VarCurr) ) ).

tff(addAssignment_64606,axiom,
    ! [VarCurr: state_type] :
      ( v108263(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108173(VarCurr,B)
      <=> v108175(VarCurr,B) ) ) ).

tff(addAssignment_64604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108175(VarCurr,B)
      <=> v108177(VarCurr,B) ) ) ).

tff(addAssignment_64603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v108177(VarCurr,B)
      <=> v108179(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108248(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108179(VarCurr,B)
          <=> v108249(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_904,axiom,
    ! [VarCurr: state_type] :
      ( v108248(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108179(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108249(VarCurr,B)
          <=> v108251(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_903,axiom,
    ! [VarCurr: state_type] :
      ( v108250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108249(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108252(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108251(VarCurr,B)
          <=> v108253(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_902,axiom,
    ! [VarCurr: state_type] :
      ( v108252(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v108251(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64602,axiom,
    ! [VarCurr: state_type] :
      ( v108253(VarCurr,0)
    <=> v108257(VarCurr) ) ).

tff(addAssignment_64601,axiom,
    ! [VarCurr: state_type] :
      ( v108253(VarCurr,1)
    <=> v108255(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10909,axiom,
    ! [VarCurr: state_type] :
      ( v108255(VarCurr)
    <=> ( v108256(VarCurr)
        & v108258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10908,axiom,
    ! [VarCurr: state_type] :
      ( v108258(VarCurr)
    <=> ( v108159(VarCurr,0)
        | v108259(VarCurr) ) ) ).

tff(writeUnaryOperator_5768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108259(VarCurr)
    <=> v108159(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4390,axiom,
    ! [VarCurr: state_type] :
      ( v108256(VarCurr)
    <=> ( v108257(VarCurr)
        | v108159(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108257(VarCurr)
    <=> v108159(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_816,axiom,
    ! [VarCurr: state_type] :
      ( v108252(VarCurr)
    <=> ( ( v108159(VarCurr,1)
        <=> $false )
        & ( v108159(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10907,axiom,
    ! [VarCurr: state_type] :
      ( v108250(VarCurr)
    <=> ( v108232(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10906,axiom,
    ! [VarCurr: state_type] :
      ( v108248(VarCurr)
    <=> ( v108181(VarCurr)
        & v108105(VarCurr) ) ) ).

tff(addAssignment_64600,axiom,
    ! [VarCurr: state_type] :
      ( v108232(VarCurr)
    <=> v108183(VarCurr,0) ) ).

tff(addAssignment_64599,axiom,
    ! [VarCurr: state_type] :
      ( v108183(VarCurr,0)
    <=> v108185(VarCurr,0) ) ).

tff(addAssignment_64598,axiom,
    ! [VarNext: state_type] :
      ( v108185(VarNext,0)
    <=> v108240(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108241(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v108240(VarNext,B)
            <=> v108185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1308,axiom,
    ! [VarNext: state_type] :
      ( v108241(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v108240(VarNext,B)
          <=> v108225(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108241(VarNext)
      <=> v108242(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108242(VarNext)
      <=> ( v108244(VarNext)
          & v108210(VarNext) ) ) ) ).

tff(writeUnaryOperator_5766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108244(VarNext)
      <=> v108219(VarNext) ) ) ).

tff(addAssignment_64597,axiom,
    ! [VarCurr: state_type] :
      ( v108195(VarCurr,0)
    <=> v108197(VarCurr,0) ) ).

tff(addAssignment_64596,axiom,
    ! [VarCurr: state_type] :
      ( v108197(VarCurr,0)
    <=> v108199(VarCurr,0) ) ).

tff(addAssignment_64595,axiom,
    ! [VarCurr: state_type] :
      ( v108199(VarCurr,0)
    <=> v108207(VarCurr,0) ) ).

tff(addAssignment_64594,axiom,
    ! [VarCurr: state_type] :
      ( v108208(VarCurr)
    <=> v103094(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_4389,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,7)
    <=> ( v108235(VarCurr)
        | v108237(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10903,axiom,
    ! [VarCurr: state_type] :
      ( v108237(VarCurr)
    <=> ( v103113(VarCurr)
        & v108238(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_815,axiom,
    ! [VarCurr: state_type] :
      ( v108238(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $true )
        & ( v103127(VarCurr,5)
        <=> $true )
        & ( v103127(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10902,axiom,
    ! [VarCurr: state_type] :
      ( v108235(VarCurr)
    <=> ( v103096(VarCurr)
        & v108236(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_814,axiom,
    ! [VarCurr: state_type] :
      ( v108236(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $true )
        & ( v103106(VarCurr,5)
        <=> $true )
        & ( v103106(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64593,axiom,
    ! [VarCurr: state_type] :
      ( v108181(VarCurr)
    <=> v108183(VarCurr,1) ) ).

tff(addAssignment_64592,axiom,
    ! [VarCurr: state_type] :
      ( v108183(VarCurr,1)
    <=> v108185(VarCurr,1) ) ).

tff(addAssignment_64591,axiom,
    ! [VarNext: state_type] :
      ( v108185(VarNext,1)
    <=> v108214(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108215(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v108214(VarNext,B)
            <=> v108185(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1307,axiom,
    ! [VarNext: state_type] :
      ( v108215(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v108214(VarNext,B)
          <=> v108225(VarNext,B) ) ) ) ).

tff(addAssignment_64590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v108225(VarNext,B)
          <=> v108223(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108226(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v108223(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_901,axiom,
    ! [VarCurr: state_type] :
      ( v108226(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v108223(VarCurr,B)
          <=> v108195(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10901,axiom,
    ! [VarCurr: state_type] :
      ( v108226(VarCurr)
    <=> ( v108227(VarCurr)
        & v108228(VarCurr) ) ) ).

tff(writeUnaryOperator_5765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108228(VarCurr)
    <=> v108191(VarCurr) ) ).

tff(writeUnaryOperator_5764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108227(VarCurr)
    <=> v108187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108215(VarNext)
      <=> v108216(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108216(VarNext)
      <=> ( v108217(VarNext)
          & v108210(VarNext) ) ) ) ).

tff(writeUnaryOperator_5763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108217(VarNext)
      <=> v108219(VarNext) ) ) ).

tff(addAssignment_64589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108219(VarNext)
      <=> v108210(VarCurr) ) ) ).

tff(addAssignment_64588,axiom,
    ! [VarCurr: state_type] :
      ( v108210(VarCurr)
    <=> v108212(VarCurr) ) ).

tff(addAssignment_64587,axiom,
    ! [VarCurr: state_type] :
      ( v108212(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64586,axiom,
    ! [VarCurr: state_type] :
      ( v108195(VarCurr,1)
    <=> v108197(VarCurr,1) ) ).

tff(addAssignment_64585,axiom,
    ! [VarCurr: state_type] :
      ( v108197(VarCurr,1)
    <=> v108199(VarCurr,1) ) ).

tff(addAssignment_64584,axiom,
    ! [VarCurr: state_type] :
      ( v108199(VarCurr,1)
    <=> v108207(VarCurr,1) ) ).

tff(addAssignment_64583,axiom,
    ! [VarCurr: state_type] :
      ( v108207(VarCurr,0)
    <=> v108208(VarCurr) ) ).

tff(addAssignment_64582,axiom,
    ! [VarCurr: state_type] :
      ( v108207(VarCurr,1)
    <=> v108201(VarCurr) ) ).

tff(addAssignment_64581,axiom,
    ! [VarCurr: state_type] :
      ( v108207(VarCurr,2)
    <=> v108090(VarCurr) ) ).

tff(addAssignment_64580,axiom,
    ! [VarCurr: state_type] :
      ( v108201(VarCurr)
    <=> v101499(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_4388,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,7)
    <=> ( v108203(VarCurr)
        | v108205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10898,axiom,
    ! [VarCurr: state_type] :
      ( v108205(VarCurr)
    <=> ( v83096(VarCurr)
        & v108206(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_813,axiom,
    ! [VarCurr: state_type] :
      ( v108206(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10897,axiom,
    ! [VarCurr: state_type] :
      ( v108203(VarCurr)
    <=> ( v101501(VarCurr)
        & v108204(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_812,axiom,
    ! [VarCurr: state_type] :
      ( v108204(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $true )
        & ( v101563(VarCurr,5)
        <=> $true )
        & ( v101563(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64579,axiom,
    ! [VarCurr: state_type] :
      ( v108191(VarCurr)
    <=> v108193(VarCurr) ) ).

tff(addAssignment_64578,axiom,
    ! [VarCurr: state_type] :
      ( v108193(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64577,axiom,
    ! [VarCurr: state_type] :
      ( v108187(VarCurr)
    <=> v108189(VarCurr) ) ).

tff(addAssignment_64576,axiom,
    ! [VarCurr: state_type] :
      ( v108189(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_64575,axiom,
    ! [VarCurr: state_type] :
      ( v108169(VarCurr)
    <=> v108171(VarCurr) ) ).

tff(addAssignment_64574,axiom,
    ! [VarCurr: state_type] :
      ( v108171(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64573,axiom,
    ! [VarCurr: state_type] :
      ( v108165(VarCurr)
    <=> v108167(VarCurr) ) ).

tff(addAssignment_64572,axiom,
    ! [VarCurr: state_type] :
      ( v108167(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_64571,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,7)
    <=> v108058(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_811,axiom,
    ! [VarCurr: state_type] :
      ( v108058(VarCurr)
    <=> ( ( v108060(VarCurr,3)
        <=> $false )
        & ( v108060(VarCurr,2)
        <=> $false )
        & ( v108060(VarCurr,1)
        <=> $false )
        & ( v108060(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108060(VarCurr,B)
      <=> v108062(VarCurr,B) ) ) ).

tff(addAssignment_64569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108062(VarCurr,B)
      <=> v108064(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108139(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v108064(VarNext,B)
            <=> v108064(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1306,axiom,
    ! [VarNext: state_type] :
      ( v108139(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108064(VarNext,B)
          <=> v108149(VarNext,B) ) ) ) ).

tff(addAssignment_64568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108149(VarNext,B)
          <=> v108147(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108150(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108147(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_900,axiom,
    ! [VarCurr: state_type] :
      ( v108150(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108147(VarCurr,B)
          <=> v108082(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10896,axiom,
    ! [VarCurr: state_type] :
      ( v108150(VarCurr)
    <=> ( v108151(VarCurr)
        & v108152(VarCurr) ) ) ).

tff(writeUnaryOperator_5762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108152(VarCurr)
    <=> v108074(VarCurr) ) ).

tff(writeUnaryOperator_5761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108151(VarCurr)
    <=> v108066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108139(VarNext)
      <=> v108140(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108140(VarNext)
      <=> ( v108141(VarNext)
          & v108132(VarNext) ) ) ) ).

tff(writeUnaryOperator_5760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108141(VarNext)
      <=> v108143(VarNext) ) ) ).

tff(addAssignment_64567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108143(VarNext)
      <=> v108132(VarCurr) ) ) ).

tff(addAssignment_64566,axiom,
    ! [VarCurr: state_type] :
      ( v108132(VarCurr)
    <=> v108134(VarCurr) ) ).

tff(addAssignment_64565,axiom,
    ! [VarCurr: state_type] :
      ( v108134(VarCurr)
    <=> v108136(VarCurr) ) ).

tff(addAssignment_64564,axiom,
    ! [VarCurr: state_type] :
      ( v108136(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_64563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108082(VarCurr,B)
      <=> v108084(VarCurr,B) ) ) ).

tff(addAssignment_64562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108084(VarCurr,B)
      <=> v108086(VarCurr,B) ) ) ).

tff(addAssignment_64561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108086(VarCurr,B)
      <=> v108088(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108088(VarCurr,B)
          <=> v108107(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_899,axiom,
    ! [VarCurr: state_type] :
      ( v108090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108088(VarCurr,B)
          <=> v108103(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108107(VarCurr,B)
          <=> v108109(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_898,axiom,
    ! [VarCurr: state_type] :
      ( v108108(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108107(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108109(VarCurr,B)
          <=> v108060(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_897,axiom,
    ! [VarCurr: state_type] :
      ( v108105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v108109(VarCurr,B)
          <=> v108110(VarCurr,B) ) ) ) ).

tff(addAssignment_64560,axiom,
    ! [VarCurr: state_type] :
      ( v108110(VarCurr,0)
    <=> v108129(VarCurr) ) ).

tff(addAssignment_64559,axiom,
    ! [VarCurr: state_type] :
      ( v108110(VarCurr,1)
    <=> v108127(VarCurr) ) ).

tff(addAssignment_64558,axiom,
    ! [VarCurr: state_type] :
      ( v108110(VarCurr,2)
    <=> v108123(VarCurr) ) ).

tff(addAssignment_64557,axiom,
    ! [VarCurr: state_type] :
      ( v108110(VarCurr,3)
    <=> v108112(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10893,axiom,
    ! [VarCurr: state_type] :
      ( v108127(VarCurr)
    <=> ( v108128(VarCurr)
        & v108130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10892,axiom,
    ! [VarCurr: state_type] :
      ( v108130(VarCurr)
    <=> ( v108060(VarCurr,0)
        | v108119(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4387,axiom,
    ! [VarCurr: state_type] :
      ( v108128(VarCurr)
    <=> ( v108129(VarCurr)
        | v108060(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108129(VarCurr)
    <=> v108060(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10891,axiom,
    ! [VarCurr: state_type] :
      ( v108123(VarCurr)
    <=> ( v108124(VarCurr)
        & v108126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10890,axiom,
    ! [VarCurr: state_type] :
      ( v108126(VarCurr)
    <=> ( v108117(VarCurr)
        | v108120(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4386,axiom,
    ! [VarCurr: state_type] :
      ( v108124(VarCurr)
    <=> ( v108125(VarCurr)
        | v108060(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108125(VarCurr)
    <=> v108117(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10889,axiom,
    ! [VarCurr: state_type] :
      ( v108112(VarCurr)
    <=> ( v108113(VarCurr)
        & v108121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10888,axiom,
    ! [VarCurr: state_type] :
      ( v108121(VarCurr)
    <=> ( v108115(VarCurr)
        | v108122(VarCurr) ) ) ).

tff(writeUnaryOperator_5757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108122(VarCurr)
    <=> v108060(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4385,axiom,
    ! [VarCurr: state_type] :
      ( v108113(VarCurr)
    <=> ( v108114(VarCurr)
        | v108060(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108114(VarCurr)
    <=> v108115(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4384,axiom,
    ! [VarCurr: state_type] :
      ( v108115(VarCurr)
    <=> ( v108060(VarCurr,2)
        | v108116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10887,axiom,
    ! [VarCurr: state_type] :
      ( v108116(VarCurr)
    <=> ( v108117(VarCurr)
        & v108120(VarCurr) ) ) ).

tff(writeUnaryOperator_5755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108120(VarCurr)
    <=> v108060(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4383,axiom,
    ! [VarCurr: state_type] :
      ( v108117(VarCurr)
    <=> ( v108060(VarCurr,1)
        | v108118(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10886,axiom,
    ! [VarCurr: state_type] :
      ( v108118(VarCurr)
    <=> ( v108060(VarCurr,0)
        & v108119(VarCurr) ) ) ).

tff(writeUnaryOperator_5754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108119(VarCurr)
    <=> v108060(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_810,axiom,
    ! [VarCurr: state_type] :
      ( v108108(VarCurr)
    <=> ( ( v108060(VarCurr,3)
        <=> $false )
        & ( v108060(VarCurr,2)
        <=> $false )
        & ( v108060(VarCurr,1)
        <=> $false )
        & ( v108060(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64556,axiom,
    ! [VarCurr: state_type] :
      ( v108105(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_64555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v108103(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_64554,axiom,
    ! [VarCurr: state_type] :
      ( v108090(VarCurr)
    <=> v89212(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_4382,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,7)
    <=> ( v108092(VarCurr)
        | v108100(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10885,axiom,
    ! [VarCurr: state_type] :
      ( v108100(VarCurr)
    <=> ( v82954(VarCurr)
        & v108101(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_809,axiom,
    ! [VarCurr: state_type] :
      ( v108101(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10884,axiom,
    ! [VarCurr: state_type] :
      ( v108092(VarCurr)
    <=> ( v108093(VarCurr)
        | v108098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10883,axiom,
    ! [VarCurr: state_type] :
      ( v108098(VarCurr)
    <=> ( v86877(VarCurr)
        & v108099(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_808,axiom,
    ! [VarCurr: state_type] :
      ( v108099(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10882,axiom,
    ! [VarCurr: state_type] :
      ( v108093(VarCurr)
    <=> ( v108094(VarCurr)
        | v108096(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10881,axiom,
    ! [VarCurr: state_type] :
      ( v108096(VarCurr)
    <=> ( v84899(VarCurr)
        & v108097(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_807,axiom,
    ! [VarCurr: state_type] :
      ( v108097(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $true )
        & ( v89243(VarCurr,5)
        <=> $true )
        & ( v89243(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10880,axiom,
    ! [VarCurr: state_type] :
      ( v108094(VarCurr)
    <=> ( v118(VarCurr)
        & v108095(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_806,axiom,
    ! [VarCurr: state_type] :
      ( v108095(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $true )
        & ( v89214(VarCurr,5)
        <=> $true )
        & ( v89214(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64553,axiom,
    ! [VarCurr: state_type] :
      ( v108074(VarCurr)
    <=> v108076(VarCurr) ) ).

tff(addAssignment_64552,axiom,
    ! [VarCurr: state_type] :
      ( v108076(VarCurr)
    <=> v108078(VarCurr) ) ).

tff(addAssignment_64551,axiom,
    ! [VarCurr: state_type] :
      ( v108078(VarCurr)
    <=> v108080(VarCurr) ) ).

tff(addAssignment_64550,axiom,
    ! [VarCurr: state_type] :
      ( v108080(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_64549,axiom,
    ! [VarCurr: state_type] :
      ( v108066(VarCurr)
    <=> v108068(VarCurr) ) ).

tff(addAssignment_64548,axiom,
    ! [VarCurr: state_type] :
      ( v108068(VarCurr)
    <=> v108070(VarCurr) ) ).

tff(addAssignment_64547,axiom,
    ! [VarCurr: state_type] :
      ( v108070(VarCurr)
    <=> v108072(VarCurr) ) ).

tff(addAssignment_64546,axiom,
    ! [VarCurr: state_type] :
      ( v108072(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_64545,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,6)
    <=> v107684(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10879,axiom,
    ! [VarCurr: state_type] :
      ( v107684(VarCurr)
    <=> ( v108051(VarCurr)
        & v108056(VarCurr) ) ) ).

tff(writeUnaryOperator_5753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108056(VarCurr)
    <=> v107965(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10878,axiom,
    ! [VarCurr: state_type] :
      ( v108051(VarCurr)
    <=> ( v108052(VarCurr)
        & v108055(VarCurr) ) ) ).

tff(writeUnaryOperator_5752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108055(VarCurr)
    <=> v107881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10877,axiom,
    ! [VarCurr: state_type] :
      ( v108052(VarCurr)
    <=> ( v108053(VarCurr)
        & v108054(VarCurr) ) ) ).

tff(writeUnaryOperator_5751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108054(VarCurr)
    <=> v107799(VarCurr) ) ).

tff(writeUnaryOperator_5750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108053(VarCurr)
    <=> v107686(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_805,axiom,
    ! [VarCurr: state_type] :
      ( v107965(VarCurr)
    <=> ( ( v107967(VarCurr,4)
        <=> $false )
        & ( v107967(VarCurr,3)
        <=> $false )
        & ( v107967(VarCurr,2)
        <=> $false )
        & ( v107967(VarCurr,1)
        <=> $false )
        & ( v107967(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107967(VarCurr,B)
      <=> v107969(VarCurr,B) ) ) ).

tff(addAssignment_64543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107969(VarCurr,B)
      <=> v107971(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108033(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107971(VarNext,B)
            <=> v107971(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1305,axiom,
    ! [VarNext: state_type] :
      ( v108033(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107971(VarNext,B)
          <=> v108043(VarNext,B) ) ) ) ).

tff(addAssignment_64542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108043(VarNext,B)
          <=> v108041(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108041(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_896,axiom,
    ! [VarCurr: state_type] :
      ( v108044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v108041(VarCurr,B)
          <=> v107981(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10876,axiom,
    ! [VarCurr: state_type] :
      ( v108044(VarCurr)
    <=> ( v108045(VarCurr)
        & v108046(VarCurr) ) ) ).

tff(writeUnaryOperator_5749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108046(VarCurr)
    <=> v107977(VarCurr) ) ).

tff(writeUnaryOperator_5748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108045(VarCurr)
    <=> v107973(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108033(VarNext)
      <=> v108034(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108034(VarNext)
      <=> ( v108035(VarNext)
          & v108028(VarNext) ) ) ) ).

tff(writeUnaryOperator_5747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v108035(VarNext)
      <=> v108037(VarNext) ) ) ).

tff(addAssignment_64541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v108037(VarNext)
      <=> v108028(VarCurr) ) ) ).

tff(addAssignment_64540,axiom,
    ! [VarCurr: state_type] :
      ( v108028(VarCurr)
    <=> v108030(VarCurr) ) ).

tff(addAssignment_64539,axiom,
    ! [VarCurr: state_type] :
      ( v108030(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107981(VarCurr,B)
      <=> v107983(VarCurr,B) ) ) ).

tff(addAssignment_64537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107983(VarCurr,B)
      <=> v107985(VarCurr,B) ) ) ).

tff(addAssignment_64536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107985(VarCurr,B)
      <=> v107987(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107989(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107987(VarCurr,B)
          <=> v107998(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_895,axiom,
    ! [VarCurr: state_type] :
      ( v107989(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107987(VarCurr,B)
          <=> v107997(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107998(VarCurr,B)
          <=> v107999(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_894,axiom,
    ! [VarCurr: state_type] :
      ( v107965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107998(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64535,axiom,
    ! [VarCurr: state_type] :
      ( v107999(VarCurr,0)
    <=> v108025(VarCurr) ) ).

tff(addAssignment_64534,axiom,
    ! [VarCurr: state_type] :
      ( v107999(VarCurr,1)
    <=> v108023(VarCurr) ) ).

tff(addAssignment_64533,axiom,
    ! [VarCurr: state_type] :
      ( v107999(VarCurr,2)
    <=> v108019(VarCurr) ) ).

tff(addAssignment_64532,axiom,
    ! [VarCurr: state_type] :
      ( v107999(VarCurr,3)
    <=> v108015(VarCurr) ) ).

tff(addAssignment_64531,axiom,
    ! [VarCurr: state_type] :
      ( v107999(VarCurr,4)
    <=> v108001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10873,axiom,
    ! [VarCurr: state_type] :
      ( v108023(VarCurr)
    <=> ( v108024(VarCurr)
        & v108026(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10872,axiom,
    ! [VarCurr: state_type] :
      ( v108026(VarCurr)
    <=> ( v107967(VarCurr,0)
        | v108010(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4381,axiom,
    ! [VarCurr: state_type] :
      ( v108024(VarCurr)
    <=> ( v108025(VarCurr)
        | v107967(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108025(VarCurr)
    <=> v107967(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10871,axiom,
    ! [VarCurr: state_type] :
      ( v108019(VarCurr)
    <=> ( v108020(VarCurr)
        & v108022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10870,axiom,
    ! [VarCurr: state_type] :
      ( v108022(VarCurr)
    <=> ( v108008(VarCurr)
        | v108011(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4380,axiom,
    ! [VarCurr: state_type] :
      ( v108020(VarCurr)
    <=> ( v108021(VarCurr)
        | v107967(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108021(VarCurr)
    <=> v108008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10869,axiom,
    ! [VarCurr: state_type] :
      ( v108015(VarCurr)
    <=> ( v108016(VarCurr)
        & v108018(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10868,axiom,
    ! [VarCurr: state_type] :
      ( v108018(VarCurr)
    <=> ( v108006(VarCurr)
        | v108012(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4379,axiom,
    ! [VarCurr: state_type] :
      ( v108016(VarCurr)
    <=> ( v108017(VarCurr)
        | v107967(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108017(VarCurr)
    <=> v108006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10867,axiom,
    ! [VarCurr: state_type] :
      ( v108001(VarCurr)
    <=> ( v108002(VarCurr)
        & v108013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10866,axiom,
    ! [VarCurr: state_type] :
      ( v108013(VarCurr)
    <=> ( v108004(VarCurr)
        | v108014(VarCurr) ) ) ).

tff(writeUnaryOperator_5743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108014(VarCurr)
    <=> v107967(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4378,axiom,
    ! [VarCurr: state_type] :
      ( v108002(VarCurr)
    <=> ( v108003(VarCurr)
        | v107967(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108003(VarCurr)
    <=> v108004(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4377,axiom,
    ! [VarCurr: state_type] :
      ( v108004(VarCurr)
    <=> ( v107967(VarCurr,3)
        | v108005(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10865,axiom,
    ! [VarCurr: state_type] :
      ( v108005(VarCurr)
    <=> ( v108006(VarCurr)
        & v108012(VarCurr) ) ) ).

tff(writeUnaryOperator_5741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108012(VarCurr)
    <=> v107967(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4376,axiom,
    ! [VarCurr: state_type] :
      ( v108006(VarCurr)
    <=> ( v107967(VarCurr,2)
        | v108007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10864,axiom,
    ! [VarCurr: state_type] :
      ( v108007(VarCurr)
    <=> ( v108008(VarCurr)
        & v108011(VarCurr) ) ) ).

tff(writeUnaryOperator_5740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108011(VarCurr)
    <=> v107967(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4375,axiom,
    ! [VarCurr: state_type] :
      ( v108008(VarCurr)
    <=> ( v107967(VarCurr,1)
        | v108009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10863,axiom,
    ! [VarCurr: state_type] :
      ( v108009(VarCurr)
    <=> ( v107967(VarCurr,0)
        & v108010(VarCurr) ) ) ).

tff(writeUnaryOperator_5739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v108010(VarCurr)
    <=> v107967(VarCurr,1) ) ).

tff(addAssignment_64530,axiom,
    ! [VarCurr: state_type] :
      ( v107997(VarCurr,0)
    <=> v107744(VarCurr) ) ).

tff(addAssignment_64529,axiom,
    ! [VarCurr: state_type] :
      ( v107997(VarCurr,1)
    <=> v107742(VarCurr) ) ).

tff(addAssignment_64528,axiom,
    ! [VarCurr: state_type] :
      ( v107997(VarCurr,2)
    <=> v107738(VarCurr) ) ).

tff(addAssignment_64527,axiom,
    ! [VarCurr: state_type] :
      ( v107997(VarCurr,3)
    <=> v107734(VarCurr) ) ).

tff(addAssignment_64526,axiom,
    ! [VarCurr: state_type] :
      ( v107997(VarCurr,4)
    <=> v107720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10862,axiom,
    ! [VarCurr: state_type] :
      ( v107989(VarCurr)
    <=> ( v107990(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10861,axiom,
    ! [VarCurr: state_type] :
      ( v107990(VarCurr)
    <=> ( v107991(VarCurr)
        & v107710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10860,axiom,
    ! [VarCurr: state_type] :
      ( v107991(VarCurr)
    <=> ( v107992(VarCurr)
        & v107996(VarCurr) ) ) ).

tff(writeUnaryOperator_5738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107996(VarCurr)
    <=> v107686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10859,axiom,
    ! [VarCurr: state_type] :
      ( v107992(VarCurr)
    <=> ( v107993(VarCurr)
        & v107995(VarCurr) ) ) ).

tff(writeUnaryOperator_5737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107995(VarCurr)
    <=> v107799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10858,axiom,
    ! [VarCurr: state_type] :
      ( v107993(VarCurr)
    <=> ( v107965(VarCurr)
        & v107994(VarCurr) ) ) ).

tff(writeUnaryOperator_5736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107994(VarCurr)
    <=> v107881(VarCurr) ) ).

tff(addAssignment_64525,axiom,
    ! [VarCurr: state_type] :
      ( v107977(VarCurr)
    <=> v107979(VarCurr) ) ).

tff(addAssignment_64524,axiom,
    ! [VarCurr: state_type] :
      ( v107979(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64523,axiom,
    ! [VarCurr: state_type] :
      ( v107973(VarCurr)
    <=> v107975(VarCurr) ) ).

tff(addAssignment_64522,axiom,
    ! [VarCurr: state_type] :
      ( v107975(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_804,axiom,
    ! [VarCurr: state_type] :
      ( v107881(VarCurr)
    <=> ( ( v107883(VarCurr,4)
        <=> $false )
        & ( v107883(VarCurr,3)
        <=> $false )
        & ( v107883(VarCurr,2)
        <=> $false )
        & ( v107883(VarCurr,1)
        <=> $false )
        & ( v107883(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107883(VarCurr,B)
      <=> v107885(VarCurr,B) ) ) ).

tff(addAssignment_64520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107885(VarCurr,B)
      <=> v107887(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107887(VarNext,B)
            <=> v107887(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1304,axiom,
    ! [VarNext: state_type] :
      ( v107947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107887(VarNext,B)
          <=> v107957(VarNext,B) ) ) ) ).

tff(addAssignment_64519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107957(VarNext,B)
          <=> v107955(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107955(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_893,axiom,
    ! [VarCurr: state_type] :
      ( v107958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107955(VarCurr,B)
          <=> v107897(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10857,axiom,
    ! [VarCurr: state_type] :
      ( v107958(VarCurr)
    <=> ( v107959(VarCurr)
        & v107960(VarCurr) ) ) ).

tff(writeUnaryOperator_5735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107960(VarCurr)
    <=> v107893(VarCurr) ) ).

tff(writeUnaryOperator_5734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107959(VarCurr)
    <=> v107889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107947(VarNext)
      <=> v107948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107948(VarNext)
      <=> ( v107949(VarNext)
          & v107942(VarNext) ) ) ) ).

tff(writeUnaryOperator_5733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107949(VarNext)
      <=> v107951(VarNext) ) ) ).

tff(addAssignment_64518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107951(VarNext)
      <=> v107942(VarCurr) ) ) ).

tff(addAssignment_64517,axiom,
    ! [VarCurr: state_type] :
      ( v107942(VarCurr)
    <=> v107944(VarCurr) ) ).

tff(addAssignment_64516,axiom,
    ! [VarCurr: state_type] :
      ( v107944(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107897(VarCurr,B)
      <=> v107899(VarCurr,B) ) ) ).

tff(addAssignment_64514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107899(VarCurr,B)
      <=> v107901(VarCurr,B) ) ) ).

tff(addAssignment_64513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107901(VarCurr,B)
      <=> v107903(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107903(VarCurr,B)
          <=> v107912(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_892,axiom,
    ! [VarCurr: state_type] :
      ( v107905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107903(VarCurr,B)
          <=> v107911(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107881(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107912(VarCurr,B)
          <=> v107913(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_891,axiom,
    ! [VarCurr: state_type] :
      ( v107881(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107912(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64512,axiom,
    ! [VarCurr: state_type] :
      ( v107913(VarCurr,0)
    <=> v107939(VarCurr) ) ).

tff(addAssignment_64511,axiom,
    ! [VarCurr: state_type] :
      ( v107913(VarCurr,1)
    <=> v107937(VarCurr) ) ).

tff(addAssignment_64510,axiom,
    ! [VarCurr: state_type] :
      ( v107913(VarCurr,2)
    <=> v107933(VarCurr) ) ).

tff(addAssignment_64509,axiom,
    ! [VarCurr: state_type] :
      ( v107913(VarCurr,3)
    <=> v107929(VarCurr) ) ).

tff(addAssignment_64508,axiom,
    ! [VarCurr: state_type] :
      ( v107913(VarCurr,4)
    <=> v107915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10854,axiom,
    ! [VarCurr: state_type] :
      ( v107937(VarCurr)
    <=> ( v107938(VarCurr)
        & v107940(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10853,axiom,
    ! [VarCurr: state_type] :
      ( v107940(VarCurr)
    <=> ( v107883(VarCurr,0)
        | v107924(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4374,axiom,
    ! [VarCurr: state_type] :
      ( v107938(VarCurr)
    <=> ( v107939(VarCurr)
        | v107883(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107939(VarCurr)
    <=> v107883(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10852,axiom,
    ! [VarCurr: state_type] :
      ( v107933(VarCurr)
    <=> ( v107934(VarCurr)
        & v107936(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10851,axiom,
    ! [VarCurr: state_type] :
      ( v107936(VarCurr)
    <=> ( v107922(VarCurr)
        | v107925(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4373,axiom,
    ! [VarCurr: state_type] :
      ( v107934(VarCurr)
    <=> ( v107935(VarCurr)
        | v107883(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107935(VarCurr)
    <=> v107922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10850,axiom,
    ! [VarCurr: state_type] :
      ( v107929(VarCurr)
    <=> ( v107930(VarCurr)
        & v107932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10849,axiom,
    ! [VarCurr: state_type] :
      ( v107932(VarCurr)
    <=> ( v107920(VarCurr)
        | v107926(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4372,axiom,
    ! [VarCurr: state_type] :
      ( v107930(VarCurr)
    <=> ( v107931(VarCurr)
        | v107883(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107931(VarCurr)
    <=> v107920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10848,axiom,
    ! [VarCurr: state_type] :
      ( v107915(VarCurr)
    <=> ( v107916(VarCurr)
        & v107927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10847,axiom,
    ! [VarCurr: state_type] :
      ( v107927(VarCurr)
    <=> ( v107918(VarCurr)
        | v107928(VarCurr) ) ) ).

tff(writeUnaryOperator_5729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107928(VarCurr)
    <=> v107883(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4371,axiom,
    ! [VarCurr: state_type] :
      ( v107916(VarCurr)
    <=> ( v107917(VarCurr)
        | v107883(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107917(VarCurr)
    <=> v107918(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4370,axiom,
    ! [VarCurr: state_type] :
      ( v107918(VarCurr)
    <=> ( v107883(VarCurr,3)
        | v107919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10846,axiom,
    ! [VarCurr: state_type] :
      ( v107919(VarCurr)
    <=> ( v107920(VarCurr)
        & v107926(VarCurr) ) ) ).

tff(writeUnaryOperator_5727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107926(VarCurr)
    <=> v107883(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4369,axiom,
    ! [VarCurr: state_type] :
      ( v107920(VarCurr)
    <=> ( v107883(VarCurr,2)
        | v107921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10845,axiom,
    ! [VarCurr: state_type] :
      ( v107921(VarCurr)
    <=> ( v107922(VarCurr)
        & v107925(VarCurr) ) ) ).

tff(writeUnaryOperator_5726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107925(VarCurr)
    <=> v107883(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4368,axiom,
    ! [VarCurr: state_type] :
      ( v107922(VarCurr)
    <=> ( v107883(VarCurr,1)
        | v107923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10844,axiom,
    ! [VarCurr: state_type] :
      ( v107923(VarCurr)
    <=> ( v107883(VarCurr,0)
        & v107924(VarCurr) ) ) ).

tff(writeUnaryOperator_5725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107924(VarCurr)
    <=> v107883(VarCurr,1) ) ).

tff(addAssignment_64507,axiom,
    ! [VarCurr: state_type] :
      ( v107911(VarCurr,0)
    <=> v107744(VarCurr) ) ).

tff(addAssignment_64506,axiom,
    ! [VarCurr: state_type] :
      ( v107911(VarCurr,1)
    <=> v107742(VarCurr) ) ).

tff(addAssignment_64505,axiom,
    ! [VarCurr: state_type] :
      ( v107911(VarCurr,2)
    <=> v107738(VarCurr) ) ).

tff(addAssignment_64504,axiom,
    ! [VarCurr: state_type] :
      ( v107911(VarCurr,3)
    <=> v107734(VarCurr) ) ).

tff(addAssignment_64503,axiom,
    ! [VarCurr: state_type] :
      ( v107911(VarCurr,4)
    <=> v107720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10843,axiom,
    ! [VarCurr: state_type] :
      ( v107905(VarCurr)
    <=> ( v107906(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10842,axiom,
    ! [VarCurr: state_type] :
      ( v107906(VarCurr)
    <=> ( v107907(VarCurr)
        & v107710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10841,axiom,
    ! [VarCurr: state_type] :
      ( v107907(VarCurr)
    <=> ( v107908(VarCurr)
        & v107910(VarCurr) ) ) ).

tff(writeUnaryOperator_5724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107910(VarCurr)
    <=> v107686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10840,axiom,
    ! [VarCurr: state_type] :
      ( v107908(VarCurr)
    <=> ( v107881(VarCurr)
        & v107909(VarCurr) ) ) ).

tff(writeUnaryOperator_5723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107909(VarCurr)
    <=> v107799(VarCurr) ) ).

tff(addAssignment_64502,axiom,
    ! [VarCurr: state_type] :
      ( v107893(VarCurr)
    <=> v107895(VarCurr) ) ).

tff(addAssignment_64501,axiom,
    ! [VarCurr: state_type] :
      ( v107895(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64500,axiom,
    ! [VarCurr: state_type] :
      ( v107889(VarCurr)
    <=> v107891(VarCurr) ) ).

tff(addAssignment_64499,axiom,
    ! [VarCurr: state_type] :
      ( v107891(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_803,axiom,
    ! [VarCurr: state_type] :
      ( v107799(VarCurr)
    <=> ( ( v107801(VarCurr,4)
        <=> $false )
        & ( v107801(VarCurr,3)
        <=> $false )
        & ( v107801(VarCurr,2)
        <=> $false )
        & ( v107801(VarCurr,1)
        <=> $false )
        & ( v107801(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107801(VarCurr,B)
      <=> v107803(VarCurr,B) ) ) ).

tff(addAssignment_64497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107803(VarCurr,B)
      <=> v107805(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107863(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107805(VarNext,B)
            <=> v107805(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1303,axiom,
    ! [VarNext: state_type] :
      ( v107863(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107805(VarNext,B)
          <=> v107873(VarNext,B) ) ) ) ).

tff(addAssignment_64496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107873(VarNext,B)
          <=> v107871(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107874(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107871(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_890,axiom,
    ! [VarCurr: state_type] :
      ( v107874(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107871(VarCurr,B)
          <=> v107815(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10839,axiom,
    ! [VarCurr: state_type] :
      ( v107874(VarCurr)
    <=> ( v107875(VarCurr)
        & v107876(VarCurr) ) ) ).

tff(writeUnaryOperator_5722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107876(VarCurr)
    <=> v107811(VarCurr) ) ).

tff(writeUnaryOperator_5721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107875(VarCurr)
    <=> v107807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107863(VarNext)
      <=> v107864(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107864(VarNext)
      <=> ( v107865(VarNext)
          & v107858(VarNext) ) ) ) ).

tff(writeUnaryOperator_5720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107865(VarNext)
      <=> v107867(VarNext) ) ) ).

tff(addAssignment_64495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107867(VarNext)
      <=> v107858(VarCurr) ) ) ).

tff(addAssignment_64494,axiom,
    ! [VarCurr: state_type] :
      ( v107858(VarCurr)
    <=> v107860(VarCurr) ) ).

tff(addAssignment_64493,axiom,
    ! [VarCurr: state_type] :
      ( v107860(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107815(VarCurr,B)
      <=> v107817(VarCurr,B) ) ) ).

tff(addAssignment_64491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107817(VarCurr,B)
      <=> v107819(VarCurr,B) ) ) ).

tff(addAssignment_64490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107819(VarCurr,B)
      <=> v107821(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107821(VarCurr,B)
          <=> v107828(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_889,axiom,
    ! [VarCurr: state_type] :
      ( v107823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107821(VarCurr,B)
          <=> v107827(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107828(VarCurr,B)
          <=> v107829(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_888,axiom,
    ! [VarCurr: state_type] :
      ( v107799(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107828(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64489,axiom,
    ! [VarCurr: state_type] :
      ( v107829(VarCurr,0)
    <=> v107855(VarCurr) ) ).

tff(addAssignment_64488,axiom,
    ! [VarCurr: state_type] :
      ( v107829(VarCurr,1)
    <=> v107853(VarCurr) ) ).

tff(addAssignment_64487,axiom,
    ! [VarCurr: state_type] :
      ( v107829(VarCurr,2)
    <=> v107849(VarCurr) ) ).

tff(addAssignment_64486,axiom,
    ! [VarCurr: state_type] :
      ( v107829(VarCurr,3)
    <=> v107845(VarCurr) ) ).

tff(addAssignment_64485,axiom,
    ! [VarCurr: state_type] :
      ( v107829(VarCurr,4)
    <=> v107831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10836,axiom,
    ! [VarCurr: state_type] :
      ( v107853(VarCurr)
    <=> ( v107854(VarCurr)
        & v107856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10835,axiom,
    ! [VarCurr: state_type] :
      ( v107856(VarCurr)
    <=> ( v107801(VarCurr,0)
        | v107840(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4367,axiom,
    ! [VarCurr: state_type] :
      ( v107854(VarCurr)
    <=> ( v107855(VarCurr)
        | v107801(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107855(VarCurr)
    <=> v107801(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10834,axiom,
    ! [VarCurr: state_type] :
      ( v107849(VarCurr)
    <=> ( v107850(VarCurr)
        & v107852(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10833,axiom,
    ! [VarCurr: state_type] :
      ( v107852(VarCurr)
    <=> ( v107838(VarCurr)
        | v107841(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4366,axiom,
    ! [VarCurr: state_type] :
      ( v107850(VarCurr)
    <=> ( v107851(VarCurr)
        | v107801(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107851(VarCurr)
    <=> v107838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10832,axiom,
    ! [VarCurr: state_type] :
      ( v107845(VarCurr)
    <=> ( v107846(VarCurr)
        & v107848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10831,axiom,
    ! [VarCurr: state_type] :
      ( v107848(VarCurr)
    <=> ( v107836(VarCurr)
        | v107842(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4365,axiom,
    ! [VarCurr: state_type] :
      ( v107846(VarCurr)
    <=> ( v107847(VarCurr)
        | v107801(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107847(VarCurr)
    <=> v107836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10830,axiom,
    ! [VarCurr: state_type] :
      ( v107831(VarCurr)
    <=> ( v107832(VarCurr)
        & v107843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10829,axiom,
    ! [VarCurr: state_type] :
      ( v107843(VarCurr)
    <=> ( v107834(VarCurr)
        | v107844(VarCurr) ) ) ).

tff(writeUnaryOperator_5716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107844(VarCurr)
    <=> v107801(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4364,axiom,
    ! [VarCurr: state_type] :
      ( v107832(VarCurr)
    <=> ( v107833(VarCurr)
        | v107801(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107833(VarCurr)
    <=> v107834(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4363,axiom,
    ! [VarCurr: state_type] :
      ( v107834(VarCurr)
    <=> ( v107801(VarCurr,3)
        | v107835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10828,axiom,
    ! [VarCurr: state_type] :
      ( v107835(VarCurr)
    <=> ( v107836(VarCurr)
        & v107842(VarCurr) ) ) ).

tff(writeUnaryOperator_5714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107842(VarCurr)
    <=> v107801(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4362,axiom,
    ! [VarCurr: state_type] :
      ( v107836(VarCurr)
    <=> ( v107801(VarCurr,2)
        | v107837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10827,axiom,
    ! [VarCurr: state_type] :
      ( v107837(VarCurr)
    <=> ( v107838(VarCurr)
        & v107841(VarCurr) ) ) ).

tff(writeUnaryOperator_5713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107841(VarCurr)
    <=> v107801(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4361,axiom,
    ! [VarCurr: state_type] :
      ( v107838(VarCurr)
    <=> ( v107801(VarCurr,1)
        | v107839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10826,axiom,
    ! [VarCurr: state_type] :
      ( v107839(VarCurr)
    <=> ( v107801(VarCurr,0)
        & v107840(VarCurr) ) ) ).

tff(writeUnaryOperator_5712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107840(VarCurr)
    <=> v107801(VarCurr,1) ) ).

tff(addAssignment_64484,axiom,
    ! [VarCurr: state_type] :
      ( v107827(VarCurr,0)
    <=> v107744(VarCurr) ) ).

tff(addAssignment_64483,axiom,
    ! [VarCurr: state_type] :
      ( v107827(VarCurr,1)
    <=> v107742(VarCurr) ) ).

tff(addAssignment_64482,axiom,
    ! [VarCurr: state_type] :
      ( v107827(VarCurr,2)
    <=> v107738(VarCurr) ) ).

tff(addAssignment_64481,axiom,
    ! [VarCurr: state_type] :
      ( v107827(VarCurr,3)
    <=> v107734(VarCurr) ) ).

tff(addAssignment_64480,axiom,
    ! [VarCurr: state_type] :
      ( v107827(VarCurr,4)
    <=> v107720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10825,axiom,
    ! [VarCurr: state_type] :
      ( v107823(VarCurr)
    <=> ( v107824(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10824,axiom,
    ! [VarCurr: state_type] :
      ( v107824(VarCurr)
    <=> ( v107825(VarCurr)
        & v107710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10823,axiom,
    ! [VarCurr: state_type] :
      ( v107825(VarCurr)
    <=> ( v107799(VarCurr)
        & v107826(VarCurr) ) ) ).

tff(writeUnaryOperator_5711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107826(VarCurr)
    <=> v107686(VarCurr) ) ).

tff(addAssignment_64479,axiom,
    ! [VarCurr: state_type] :
      ( v107811(VarCurr)
    <=> v107813(VarCurr) ) ).

tff(addAssignment_64478,axiom,
    ! [VarCurr: state_type] :
      ( v107813(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64477,axiom,
    ! [VarCurr: state_type] :
      ( v107807(VarCurr)
    <=> v107809(VarCurr) ) ).

tff(addAssignment_64476,axiom,
    ! [VarCurr: state_type] :
      ( v107809(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_802,axiom,
    ! [VarCurr: state_type] :
      ( v107686(VarCurr)
    <=> ( ( v107688(VarCurr,4)
        <=> $false )
        & ( v107688(VarCurr,3)
        <=> $false )
        & ( v107688(VarCurr,2)
        <=> $false )
        & ( v107688(VarCurr,1)
        <=> $false )
        & ( v107688(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107688(VarCurr,B)
      <=> v107690(VarCurr,B) ) ) ).

tff(addAssignment_64474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107690(VarCurr,B)
      <=> v107692(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107781(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107692(VarNext,B)
            <=> v107692(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1302,axiom,
    ! [VarNext: state_type] :
      ( v107781(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107692(VarNext,B)
          <=> v107791(VarNext,B) ) ) ) ).

tff(addAssignment_64473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107791(VarNext,B)
          <=> v107789(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107789(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_887,axiom,
    ! [VarCurr: state_type] :
      ( v107792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107789(VarCurr,B)
          <=> v107702(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10822,axiom,
    ! [VarCurr: state_type] :
      ( v107792(VarCurr)
    <=> ( v107793(VarCurr)
        & v107794(VarCurr) ) ) ).

tff(writeUnaryOperator_5710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107794(VarCurr)
    <=> v107698(VarCurr) ) ).

tff(writeUnaryOperator_5709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107793(VarCurr)
    <=> v107694(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107781(VarNext)
      <=> v107782(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107782(VarNext)
      <=> ( v107783(VarNext)
          & v107776(VarNext) ) ) ) ).

tff(writeUnaryOperator_5708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107783(VarNext)
      <=> v107785(VarNext) ) ) ).

tff(addAssignment_64472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107785(VarNext)
      <=> v107776(VarCurr) ) ) ).

tff(addAssignment_64471,axiom,
    ! [VarCurr: state_type] :
      ( v107776(VarCurr)
    <=> v107778(VarCurr) ) ).

tff(addAssignment_64470,axiom,
    ! [VarCurr: state_type] :
      ( v107778(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107702(VarCurr,B)
      <=> v107704(VarCurr,B) ) ) ).

tff(addAssignment_64468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107704(VarCurr,B)
      <=> v107706(VarCurr,B) ) ) ).

tff(addAssignment_64467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107706(VarCurr,B)
      <=> v107708(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107716(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107708(VarCurr,B)
          <=> v107746(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_886,axiom,
    ! [VarCurr: state_type] :
      ( v107716(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107708(VarCurr,B)
          <=> v107718(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107686(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107746(VarCurr,B)
          <=> v107747(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_885,axiom,
    ! [VarCurr: state_type] :
      ( v107686(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107746(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64466,axiom,
    ! [VarCurr: state_type] :
      ( v107747(VarCurr,0)
    <=> v107773(VarCurr) ) ).

tff(addAssignment_64465,axiom,
    ! [VarCurr: state_type] :
      ( v107747(VarCurr,1)
    <=> v107771(VarCurr) ) ).

tff(addAssignment_64464,axiom,
    ! [VarCurr: state_type] :
      ( v107747(VarCurr,2)
    <=> v107767(VarCurr) ) ).

tff(addAssignment_64463,axiom,
    ! [VarCurr: state_type] :
      ( v107747(VarCurr,3)
    <=> v107763(VarCurr) ) ).

tff(addAssignment_64462,axiom,
    ! [VarCurr: state_type] :
      ( v107747(VarCurr,4)
    <=> v107749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10819,axiom,
    ! [VarCurr: state_type] :
      ( v107771(VarCurr)
    <=> ( v107772(VarCurr)
        & v107774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10818,axiom,
    ! [VarCurr: state_type] :
      ( v107774(VarCurr)
    <=> ( v107688(VarCurr,0)
        | v107758(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4360,axiom,
    ! [VarCurr: state_type] :
      ( v107772(VarCurr)
    <=> ( v107773(VarCurr)
        | v107688(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107773(VarCurr)
    <=> v107688(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10817,axiom,
    ! [VarCurr: state_type] :
      ( v107767(VarCurr)
    <=> ( v107768(VarCurr)
        & v107770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10816,axiom,
    ! [VarCurr: state_type] :
      ( v107770(VarCurr)
    <=> ( v107756(VarCurr)
        | v107759(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4359,axiom,
    ! [VarCurr: state_type] :
      ( v107768(VarCurr)
    <=> ( v107769(VarCurr)
        | v107688(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107769(VarCurr)
    <=> v107756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10815,axiom,
    ! [VarCurr: state_type] :
      ( v107763(VarCurr)
    <=> ( v107764(VarCurr)
        & v107766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10814,axiom,
    ! [VarCurr: state_type] :
      ( v107766(VarCurr)
    <=> ( v107754(VarCurr)
        | v107760(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4358,axiom,
    ! [VarCurr: state_type] :
      ( v107764(VarCurr)
    <=> ( v107765(VarCurr)
        | v107688(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107765(VarCurr)
    <=> v107754(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10813,axiom,
    ! [VarCurr: state_type] :
      ( v107749(VarCurr)
    <=> ( v107750(VarCurr)
        & v107761(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10812,axiom,
    ! [VarCurr: state_type] :
      ( v107761(VarCurr)
    <=> ( v107752(VarCurr)
        | v107762(VarCurr) ) ) ).

tff(writeUnaryOperator_5704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107762(VarCurr)
    <=> v107688(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4357,axiom,
    ! [VarCurr: state_type] :
      ( v107750(VarCurr)
    <=> ( v107751(VarCurr)
        | v107688(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107751(VarCurr)
    <=> v107752(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4356,axiom,
    ! [VarCurr: state_type] :
      ( v107752(VarCurr)
    <=> ( v107688(VarCurr,3)
        | v107753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10811,axiom,
    ! [VarCurr: state_type] :
      ( v107753(VarCurr)
    <=> ( v107754(VarCurr)
        & v107760(VarCurr) ) ) ).

tff(writeUnaryOperator_5702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107760(VarCurr)
    <=> v107688(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4355,axiom,
    ! [VarCurr: state_type] :
      ( v107754(VarCurr)
    <=> ( v107688(VarCurr,2)
        | v107755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10810,axiom,
    ! [VarCurr: state_type] :
      ( v107755(VarCurr)
    <=> ( v107756(VarCurr)
        & v107759(VarCurr) ) ) ).

tff(writeUnaryOperator_5701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107759(VarCurr)
    <=> v107688(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4354,axiom,
    ! [VarCurr: state_type] :
      ( v107756(VarCurr)
    <=> ( v107688(VarCurr,1)
        | v107757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10809,axiom,
    ! [VarCurr: state_type] :
      ( v107757(VarCurr)
    <=> ( v107688(VarCurr,0)
        & v107758(VarCurr) ) ) ).

tff(writeUnaryOperator_5700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107758(VarCurr)
    <=> v107688(VarCurr,1) ) ).

tff(addAssignment_64461,axiom,
    ! [VarCurr: state_type] :
      ( v107718(VarCurr,0)
    <=> v107744(VarCurr) ) ).

tff(addAssignment_64460,axiom,
    ! [VarCurr: state_type] :
      ( v107718(VarCurr,1)
    <=> v107742(VarCurr) ) ).

tff(addAssignment_64459,axiom,
    ! [VarCurr: state_type] :
      ( v107718(VarCurr,2)
    <=> v107738(VarCurr) ) ).

tff(addAssignment_64458,axiom,
    ! [VarCurr: state_type] :
      ( v107718(VarCurr,3)
    <=> v107734(VarCurr) ) ).

tff(addAssignment_64457,axiom,
    ! [VarCurr: state_type] :
      ( v107718(VarCurr,4)
    <=> v107720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10808,axiom,
    ! [VarCurr: state_type] :
      ( v107742(VarCurr)
    <=> ( v107743(VarCurr)
        & v107745(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10807,axiom,
    ! [VarCurr: state_type] :
      ( v107745(VarCurr)
    <=> ( v107714(VarCurr,0)
        | v107729(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4353,axiom,
    ! [VarCurr: state_type] :
      ( v107743(VarCurr)
    <=> ( v107744(VarCurr)
        | v107714(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107744(VarCurr)
    <=> v107714(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10806,axiom,
    ! [VarCurr: state_type] :
      ( v107738(VarCurr)
    <=> ( v107739(VarCurr)
        & v107741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10805,axiom,
    ! [VarCurr: state_type] :
      ( v107741(VarCurr)
    <=> ( v107727(VarCurr)
        | v107730(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4352,axiom,
    ! [VarCurr: state_type] :
      ( v107739(VarCurr)
    <=> ( v107740(VarCurr)
        | v107714(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107740(VarCurr)
    <=> v107727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10804,axiom,
    ! [VarCurr: state_type] :
      ( v107734(VarCurr)
    <=> ( v107735(VarCurr)
        & v107737(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10803,axiom,
    ! [VarCurr: state_type] :
      ( v107737(VarCurr)
    <=> ( v107725(VarCurr)
        | v107731(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4351,axiom,
    ! [VarCurr: state_type] :
      ( v107735(VarCurr)
    <=> ( v107736(VarCurr)
        | v107714(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107736(VarCurr)
    <=> v107725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10802,axiom,
    ! [VarCurr: state_type] :
      ( v107720(VarCurr)
    <=> ( v107721(VarCurr)
        & v107732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10801,axiom,
    ! [VarCurr: state_type] :
      ( v107732(VarCurr)
    <=> ( v107723(VarCurr)
        | v107733(VarCurr) ) ) ).

tff(writeUnaryOperator_5696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107733(VarCurr)
    <=> v107714(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4350,axiom,
    ! [VarCurr: state_type] :
      ( v107721(VarCurr)
    <=> ( v107722(VarCurr)
        | v107714(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107722(VarCurr)
    <=> v107723(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4349,axiom,
    ! [VarCurr: state_type] :
      ( v107723(VarCurr)
    <=> ( v107714(VarCurr,3)
        | v107724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10800,axiom,
    ! [VarCurr: state_type] :
      ( v107724(VarCurr)
    <=> ( v107725(VarCurr)
        & v107731(VarCurr) ) ) ).

tff(writeUnaryOperator_5694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107731(VarCurr)
    <=> v107714(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4348,axiom,
    ! [VarCurr: state_type] :
      ( v107725(VarCurr)
    <=> ( v107714(VarCurr,2)
        | v107726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10799,axiom,
    ! [VarCurr: state_type] :
      ( v107726(VarCurr)
    <=> ( v107727(VarCurr)
        & v107730(VarCurr) ) ) ).

tff(writeUnaryOperator_5693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107730(VarCurr)
    <=> v107714(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4347,axiom,
    ! [VarCurr: state_type] :
      ( v107727(VarCurr)
    <=> ( v107714(VarCurr,1)
        | v107728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10798,axiom,
    ! [VarCurr: state_type] :
      ( v107728(VarCurr)
    <=> ( v107714(VarCurr,0)
        & v107729(VarCurr) ) ) ).

tff(writeUnaryOperator_5692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107729(VarCurr)
    <=> v107714(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10797,axiom,
    ! [VarCurr: state_type] :
      ( v107716(VarCurr)
    <=> ( v107717(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10796,axiom,
    ! [VarCurr: state_type] :
      ( v107717(VarCurr)
    <=> ( v107686(VarCurr)
        & v107710(VarCurr) ) ) ).

tff(addAssignment_64456,axiom,
    ! [VarCurr: state_type] :
      ( v107714(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_64455,axiom,
    ! [VarCurr: state_type] :
      ( v107714(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_64454,axiom,
    ! [VarCurr: state_type] :
      ( v107714(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_64453,axiom,
    ! [VarCurr: state_type] :
      ( v107714(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_64452,axiom,
    ! [VarCurr: state_type] :
      ( v107714(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10795,axiom,
    ! [VarCurr: state_type] :
      ( v107710(VarCurr)
    <=> ( v107712(VarCurr)
        | v107507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10794,axiom,
    ! [VarCurr: state_type] :
      ( v107712(VarCurr)
    <=> ( v107389(VarCurr)
        | v107500(VarCurr) ) ) ).

tff(addAssignment_64451,axiom,
    ! [VarCurr: state_type] :
      ( v107698(VarCurr)
    <=> v107700(VarCurr) ) ).

tff(addAssignment_64450,axiom,
    ! [VarCurr: state_type] :
      ( v107700(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64449,axiom,
    ! [VarCurr: state_type] :
      ( v107694(VarCurr)
    <=> v107696(VarCurr) ) ).

tff(addAssignment_64448,axiom,
    ! [VarCurr: state_type] :
      ( v107696(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_64447,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,6)
    <=> v107583(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_801,axiom,
    ! [VarCurr: state_type] :
      ( v107583(VarCurr)
    <=> ( ( v107585(VarCurr,3)
        <=> $false )
        & ( v107585(VarCurr,2)
        <=> $false )
        & ( v107585(VarCurr,1)
        <=> $false )
        & ( v107585(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107585(VarCurr,B)
      <=> v107587(VarCurr,B) ) ) ).

tff(addAssignment_64445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107587(VarCurr,B)
      <=> v107589(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107666(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v107589(VarNext,B)
            <=> v107589(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1301,axiom,
    ! [VarNext: state_type] :
      ( v107666(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107589(VarNext,B)
          <=> v107676(VarNext,B) ) ) ) ).

tff(addAssignment_64444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107676(VarNext,B)
          <=> v107674(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107677(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107674(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_884,axiom,
    ! [VarCurr: state_type] :
      ( v107677(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107674(VarCurr,B)
          <=> v107599(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10793,axiom,
    ! [VarCurr: state_type] :
      ( v107677(VarCurr)
    <=> ( v107678(VarCurr)
        & v107679(VarCurr) ) ) ).

tff(writeUnaryOperator_5691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107679(VarCurr)
    <=> v107595(VarCurr) ) ).

tff(writeUnaryOperator_5690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107678(VarCurr)
    <=> v107591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107666(VarNext)
      <=> v107667(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107667(VarNext)
      <=> ( v107668(VarNext)
          & v107661(VarNext) ) ) ) ).

tff(writeUnaryOperator_5689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107668(VarNext)
      <=> v107670(VarNext) ) ) ).

tff(addAssignment_64443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107670(VarNext)
      <=> v107661(VarCurr) ) ) ).

tff(addAssignment_64442,axiom,
    ! [VarCurr: state_type] :
      ( v107661(VarCurr)
    <=> v107663(VarCurr) ) ).

tff(addAssignment_64441,axiom,
    ! [VarCurr: state_type] :
      ( v107663(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107599(VarCurr,B)
      <=> v107601(VarCurr,B) ) ) ).

tff(addAssignment_64439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107601(VarCurr,B)
      <=> v107603(VarCurr,B) ) ) ).

tff(addAssignment_64438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107603(VarCurr,B)
      <=> v107605(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107612(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107605(VarCurr,B)
          <=> v107634(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_883,axiom,
    ! [VarCurr: state_type] :
      ( v107612(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107605(VarCurr,B)
          <=> v107613(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107634(VarCurr,B)
          <=> v107636(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_882,axiom,
    ! [VarCurr: state_type] :
      ( v107635(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107634(VarCurr,B)
          <=> v107610(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107637(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107636(VarCurr,B)
          <=> v107638(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_881,axiom,
    ! [VarCurr: state_type] :
      ( v107637(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107636(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107638(VarCurr,B)
          <=> v107585(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_880,axiom,
    ! [VarCurr: state_type] :
      ( v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107638(VarCurr,B)
          <=> v107639(VarCurr,B) ) ) ) ).

tff(addAssignment_64437,axiom,
    ! [VarCurr: state_type] :
      ( v107639(VarCurr,0)
    <=> v107658(VarCurr) ) ).

tff(addAssignment_64436,axiom,
    ! [VarCurr: state_type] :
      ( v107639(VarCurr,1)
    <=> v107656(VarCurr) ) ).

tff(addAssignment_64435,axiom,
    ! [VarCurr: state_type] :
      ( v107639(VarCurr,2)
    <=> v107652(VarCurr) ) ).

tff(addAssignment_64434,axiom,
    ! [VarCurr: state_type] :
      ( v107639(VarCurr,3)
    <=> v107641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10790,axiom,
    ! [VarCurr: state_type] :
      ( v107656(VarCurr)
    <=> ( v107657(VarCurr)
        & v107659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10789,axiom,
    ! [VarCurr: state_type] :
      ( v107659(VarCurr)
    <=> ( v107585(VarCurr,0)
        | v107648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4346,axiom,
    ! [VarCurr: state_type] :
      ( v107657(VarCurr)
    <=> ( v107658(VarCurr)
        | v107585(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107658(VarCurr)
    <=> v107585(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10788,axiom,
    ! [VarCurr: state_type] :
      ( v107652(VarCurr)
    <=> ( v107653(VarCurr)
        & v107655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10787,axiom,
    ! [VarCurr: state_type] :
      ( v107655(VarCurr)
    <=> ( v107646(VarCurr)
        | v107649(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4345,axiom,
    ! [VarCurr: state_type] :
      ( v107653(VarCurr)
    <=> ( v107654(VarCurr)
        | v107585(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107654(VarCurr)
    <=> v107646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10786,axiom,
    ! [VarCurr: state_type] :
      ( v107641(VarCurr)
    <=> ( v107642(VarCurr)
        & v107650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10785,axiom,
    ! [VarCurr: state_type] :
      ( v107650(VarCurr)
    <=> ( v107644(VarCurr)
        | v107651(VarCurr) ) ) ).

tff(writeUnaryOperator_5686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107651(VarCurr)
    <=> v107585(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4344,axiom,
    ! [VarCurr: state_type] :
      ( v107642(VarCurr)
    <=> ( v107643(VarCurr)
        | v107585(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107643(VarCurr)
    <=> v107644(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4343,axiom,
    ! [VarCurr: state_type] :
      ( v107644(VarCurr)
    <=> ( v107585(VarCurr,2)
        | v107645(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10784,axiom,
    ! [VarCurr: state_type] :
      ( v107645(VarCurr)
    <=> ( v107646(VarCurr)
        & v107649(VarCurr) ) ) ).

tff(writeUnaryOperator_5684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107649(VarCurr)
    <=> v107585(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4342,axiom,
    ! [VarCurr: state_type] :
      ( v107646(VarCurr)
    <=> ( v107585(VarCurr,1)
        | v107647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10783,axiom,
    ! [VarCurr: state_type] :
      ( v107647(VarCurr)
    <=> ( v107585(VarCurr,0)
        & v107648(VarCurr) ) ) ).

tff(writeUnaryOperator_5683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107648(VarCurr)
    <=> v107585(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_800,axiom,
    ! [VarCurr: state_type] :
      ( v107637(VarCurr)
    <=> ( ( v107585(VarCurr,3)
        <=> $false )
        & ( v107585(VarCurr,2)
        <=> $false )
        & ( v107585(VarCurr,1)
        <=> $false )
        & ( v107585(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10782,axiom,
    ! [VarCurr: state_type] :
      ( v107635(VarCurr)
    <=> ( v107507(VarCurr)
        & v107583(VarCurr) ) ) ).

tff(addAssignment_64433,axiom,
    ! [VarCurr: state_type] :
      ( v107613(VarCurr,0)
    <=> v107632(VarCurr) ) ).

tff(addAssignment_64432,axiom,
    ! [VarCurr: state_type] :
      ( v107613(VarCurr,1)
    <=> v107630(VarCurr) ) ).

tff(addAssignment_64431,axiom,
    ! [VarCurr: state_type] :
      ( v107613(VarCurr,2)
    <=> v107626(VarCurr) ) ).

tff(addAssignment_64430,axiom,
    ! [VarCurr: state_type] :
      ( v107613(VarCurr,3)
    <=> v107615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10781,axiom,
    ! [VarCurr: state_type] :
      ( v107630(VarCurr)
    <=> ( v107631(VarCurr)
        & v107633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10780,axiom,
    ! [VarCurr: state_type] :
      ( v107633(VarCurr)
    <=> ( v107610(VarCurr,0)
        | v107622(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4341,axiom,
    ! [VarCurr: state_type] :
      ( v107631(VarCurr)
    <=> ( v107632(VarCurr)
        | v107610(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107632(VarCurr)
    <=> v107610(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10779,axiom,
    ! [VarCurr: state_type] :
      ( v107626(VarCurr)
    <=> ( v107627(VarCurr)
        & v107629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10778,axiom,
    ! [VarCurr: state_type] :
      ( v107629(VarCurr)
    <=> ( v107620(VarCurr)
        | v107623(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4340,axiom,
    ! [VarCurr: state_type] :
      ( v107627(VarCurr)
    <=> ( v107628(VarCurr)
        | v107610(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107628(VarCurr)
    <=> v107620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10777,axiom,
    ! [VarCurr: state_type] :
      ( v107615(VarCurr)
    <=> ( v107616(VarCurr)
        & v107624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10776,axiom,
    ! [VarCurr: state_type] :
      ( v107624(VarCurr)
    <=> ( v107618(VarCurr)
        | v107625(VarCurr) ) ) ).

tff(writeUnaryOperator_5680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107625(VarCurr)
    <=> v107610(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4339,axiom,
    ! [VarCurr: state_type] :
      ( v107616(VarCurr)
    <=> ( v107617(VarCurr)
        | v107610(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107617(VarCurr)
    <=> v107618(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4338,axiom,
    ! [VarCurr: state_type] :
      ( v107618(VarCurr)
    <=> ( v107610(VarCurr,2)
        | v107619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10775,axiom,
    ! [VarCurr: state_type] :
      ( v107619(VarCurr)
    <=> ( v107620(VarCurr)
        & v107623(VarCurr) ) ) ).

tff(writeUnaryOperator_5678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107623(VarCurr)
    <=> v107610(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4337,axiom,
    ! [VarCurr: state_type] :
      ( v107620(VarCurr)
    <=> ( v107610(VarCurr,1)
        | v107621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10774,axiom,
    ! [VarCurr: state_type] :
      ( v107621(VarCurr)
    <=> ( v107610(VarCurr,0)
        & v107622(VarCurr) ) ) ).

tff(writeUnaryOperator_5677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107622(VarCurr)
    <=> v107610(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10773,axiom,
    ! [VarCurr: state_type] :
      ( v107612(VarCurr)
    <=> ( v107607(VarCurr)
        & v107583(VarCurr) ) ) ).

tff(addAssignment_64429,axiom,
    ! [VarCurr: state_type] :
      ( v107610(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_64428,axiom,
    ! [VarCurr: state_type] :
      ( v107610(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_64427,axiom,
    ! [VarCurr: state_type] :
      ( v107610(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_64426,axiom,
    ! [VarCurr: state_type] :
      ( v107610(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10772,axiom,
    ! [VarCurr: state_type] :
      ( v107607(VarCurr)
    <=> ( v107389(VarCurr)
        | v107500(VarCurr) ) ) ).

tff(addAssignment_64425,axiom,
    ! [VarCurr: state_type] :
      ( v107595(VarCurr)
    <=> v107597(VarCurr) ) ).

tff(addAssignment_64424,axiom,
    ! [VarCurr: state_type] :
      ( v107597(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64423,axiom,
    ! [VarCurr: state_type] :
      ( v107591(VarCurr)
    <=> v107593(VarCurr) ) ).

tff(addAssignment_64422,axiom,
    ! [VarCurr: state_type] :
      ( v107593(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_64421,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,6)
    <=> v107456(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_799,axiom,
    ! [VarCurr: state_type] :
      ( v107456(VarCurr)
    <=> ( ( v107458(VarCurr,1)
        <=> $false )
        & ( v107458(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v107458(VarCurr,B)
      <=> v107460(VarCurr,B) ) ) ).

tff(addAssignment_64419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v107460(VarCurr,B)
      <=> v107462(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107565(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v107462(VarNext,B)
            <=> v107462(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1300,axiom,
    ! [VarNext: state_type] :
      ( v107565(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107462(VarNext,B)
          <=> v107575(VarNext,B) ) ) ) ).

tff(addAssignment_64418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107575(VarNext,B)
          <=> v107573(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107576(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107573(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_879,axiom,
    ! [VarCurr: state_type] :
      ( v107576(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107573(VarCurr,B)
          <=> v107472(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10771,axiom,
    ! [VarCurr: state_type] :
      ( v107576(VarCurr)
    <=> ( v107577(VarCurr)
        & v107578(VarCurr) ) ) ).

tff(writeUnaryOperator_5676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107578(VarCurr)
    <=> v107468(VarCurr) ) ).

tff(writeUnaryOperator_5675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107577(VarCurr)
    <=> v107464(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107565(VarNext)
      <=> v107566(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107566(VarNext)
      <=> ( v107567(VarNext)
          & v107560(VarNext) ) ) ) ).

tff(writeUnaryOperator_5674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107567(VarNext)
      <=> v107569(VarNext) ) ) ).

tff(addAssignment_64417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107569(VarNext)
      <=> v107560(VarCurr) ) ) ).

tff(addAssignment_64416,axiom,
    ! [VarCurr: state_type] :
      ( v107560(VarCurr)
    <=> v107562(VarCurr) ) ).

tff(addAssignment_64415,axiom,
    ! [VarCurr: state_type] :
      ( v107562(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v107472(VarCurr,B)
      <=> v107474(VarCurr,B) ) ) ).

tff(addAssignment_64413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v107474(VarCurr,B)
      <=> v107476(VarCurr,B) ) ) ).

tff(addAssignment_64412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v107476(VarCurr,B)
      <=> v107478(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107547(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107478(VarCurr,B)
          <=> v107548(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_878,axiom,
    ! [VarCurr: state_type] :
      ( v107547(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107478(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107548(VarCurr,B)
          <=> v107550(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_877,axiom,
    ! [VarCurr: state_type] :
      ( v107549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107548(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107550(VarCurr,B)
          <=> v107552(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_876,axiom,
    ! [VarCurr: state_type] :
      ( v107551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v107550(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64411,axiom,
    ! [VarCurr: state_type] :
      ( v107552(VarCurr,0)
    <=> v107556(VarCurr) ) ).

tff(addAssignment_64410,axiom,
    ! [VarCurr: state_type] :
      ( v107552(VarCurr,1)
    <=> v107554(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10768,axiom,
    ! [VarCurr: state_type] :
      ( v107554(VarCurr)
    <=> ( v107555(VarCurr)
        & v107557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10767,axiom,
    ! [VarCurr: state_type] :
      ( v107557(VarCurr)
    <=> ( v107458(VarCurr,0)
        | v107558(VarCurr) ) ) ).

tff(writeUnaryOperator_5673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107558(VarCurr)
    <=> v107458(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4336,axiom,
    ! [VarCurr: state_type] :
      ( v107555(VarCurr)
    <=> ( v107556(VarCurr)
        | v107458(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107556(VarCurr)
    <=> v107458(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_798,axiom,
    ! [VarCurr: state_type] :
      ( v107551(VarCurr)
    <=> ( ( v107458(VarCurr,1)
        <=> $false )
        & ( v107458(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10766,axiom,
    ! [VarCurr: state_type] :
      ( v107549(VarCurr)
    <=> ( v107531(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10765,axiom,
    ! [VarCurr: state_type] :
      ( v107547(VarCurr)
    <=> ( v107480(VarCurr)
        & v107404(VarCurr) ) ) ).

tff(addAssignment_64409,axiom,
    ! [VarCurr: state_type] :
      ( v107531(VarCurr)
    <=> v107482(VarCurr,0) ) ).

tff(addAssignment_64408,axiom,
    ! [VarCurr: state_type] :
      ( v107482(VarCurr,0)
    <=> v107484(VarCurr,0) ) ).

tff(addAssignment_64407,axiom,
    ! [VarNext: state_type] :
      ( v107484(VarNext,0)
    <=> v107539(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107540(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v107539(VarNext,B)
            <=> v107484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1299,axiom,
    ! [VarNext: state_type] :
      ( v107540(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v107539(VarNext,B)
          <=> v107524(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107540(VarNext)
      <=> v107541(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107541(VarNext)
      <=> ( v107543(VarNext)
          & v107509(VarNext) ) ) ) ).

tff(writeUnaryOperator_5671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107543(VarNext)
      <=> v107518(VarNext) ) ) ).

tff(addAssignment_64406,axiom,
    ! [VarCurr: state_type] :
      ( v107494(VarCurr,0)
    <=> v107496(VarCurr,0) ) ).

tff(addAssignment_64405,axiom,
    ! [VarCurr: state_type] :
      ( v107496(VarCurr,0)
    <=> v107498(VarCurr,0) ) ).

tff(addAssignment_64404,axiom,
    ! [VarCurr: state_type] :
      ( v107498(VarCurr,0)
    <=> v107506(VarCurr,0) ) ).

tff(addAssignment_64403,axiom,
    ! [VarCurr: state_type] :
      ( v107507(VarCurr)
    <=> v103094(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_4335,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,6)
    <=> ( v107534(VarCurr)
        | v107536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10762,axiom,
    ! [VarCurr: state_type] :
      ( v107536(VarCurr)
    <=> ( v103113(VarCurr)
        & v107537(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_797,axiom,
    ! [VarCurr: state_type] :
      ( v107537(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $true )
        & ( v103127(VarCurr,5)
        <=> $true )
        & ( v103127(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10761,axiom,
    ! [VarCurr: state_type] :
      ( v107534(VarCurr)
    <=> ( v103096(VarCurr)
        & v107535(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_796,axiom,
    ! [VarCurr: state_type] :
      ( v107535(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $true )
        & ( v103106(VarCurr,5)
        <=> $true )
        & ( v103106(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_64402,axiom,
    ! [VarCurr: state_type] :
      ( v107480(VarCurr)
    <=> v107482(VarCurr,1) ) ).

tff(addAssignment_64401,axiom,
    ! [VarCurr: state_type] :
      ( v107482(VarCurr,1)
    <=> v107484(VarCurr,1) ) ).

tff(addAssignment_64400,axiom,
    ! [VarNext: state_type] :
      ( v107484(VarNext,1)
    <=> v107513(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107514(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v107513(VarNext,B)
            <=> v107484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1298,axiom,
    ! [VarNext: state_type] :
      ( v107514(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v107513(VarNext,B)
          <=> v107524(VarNext,B) ) ) ) ).

tff(addAssignment_64399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v107524(VarNext,B)
          <=> v107522(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v107522(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_875,axiom,
    ! [VarCurr: state_type] :
      ( v107525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v107522(VarCurr,B)
          <=> v107494(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10760,axiom,
    ! [VarCurr: state_type] :
      ( v107525(VarCurr)
    <=> ( v107526(VarCurr)
        & v107527(VarCurr) ) ) ).

tff(writeUnaryOperator_5670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107527(VarCurr)
    <=> v107490(VarCurr) ) ).

tff(writeUnaryOperator_5669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107526(VarCurr)
    <=> v107486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107514(VarNext)
      <=> v107515(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107515(VarNext)
      <=> ( v107516(VarNext)
          & v107509(VarNext) ) ) ) ).

tff(writeUnaryOperator_5668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107516(VarNext)
      <=> v107518(VarNext) ) ) ).

tff(addAssignment_64398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107518(VarNext)
      <=> v107509(VarCurr) ) ) ).

tff(addAssignment_64397,axiom,
    ! [VarCurr: state_type] :
      ( v107509(VarCurr)
    <=> v107511(VarCurr) ) ).

tff(addAssignment_64396,axiom,
    ! [VarCurr: state_type] :
      ( v107511(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64395,axiom,
    ! [VarCurr: state_type] :
      ( v107494(VarCurr,1)
    <=> v107496(VarCurr,1) ) ).

tff(addAssignment_64394,axiom,
    ! [VarCurr: state_type] :
      ( v107496(VarCurr,1)
    <=> v107498(VarCurr,1) ) ).

tff(addAssignment_64393,axiom,
    ! [VarCurr: state_type] :
      ( v107498(VarCurr,1)
    <=> v107506(VarCurr,1) ) ).

tff(addAssignment_64392,axiom,
    ! [VarCurr: state_type] :
      ( v107506(VarCurr,0)
    <=> v107507(VarCurr) ) ).

tff(addAssignment_64391,axiom,
    ! [VarCurr: state_type] :
      ( v107506(VarCurr,1)
    <=> v107500(VarCurr) ) ).

tff(addAssignment_64390,axiom,
    ! [VarCurr: state_type] :
      ( v107506(VarCurr,2)
    <=> v107389(VarCurr) ) ).

tff(addAssignment_64389,axiom,
    ! [VarCurr: state_type] :
      ( v107500(VarCurr)
    <=> v101499(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_4334,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,6)
    <=> ( v107502(VarCurr)
        | v107504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10757,axiom,
    ! [VarCurr: state_type] :
      ( v107504(VarCurr)
    <=> ( v83096(VarCurr)
        & v107505(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_795,axiom,
    ! [VarCurr: state_type] :
      ( v107505(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10756,axiom,
    ! [VarCurr: state_type] :
      ( v107502(VarCurr)
    <=> ( v101501(VarCurr)
        & v107503(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_794,axiom,
    ! [VarCurr: state_type] :
      ( v107503(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $true )
        & ( v101563(VarCurr,5)
        <=> $true )
        & ( v101563(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_64388,axiom,
    ! [VarCurr: state_type] :
      ( v107490(VarCurr)
    <=> v107492(VarCurr) ) ).

tff(addAssignment_64387,axiom,
    ! [VarCurr: state_type] :
      ( v107492(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64386,axiom,
    ! [VarCurr: state_type] :
      ( v107486(VarCurr)
    <=> v107488(VarCurr) ) ).

tff(addAssignment_64385,axiom,
    ! [VarCurr: state_type] :
      ( v107488(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_64384,axiom,
    ! [VarCurr: state_type] :
      ( v107468(VarCurr)
    <=> v107470(VarCurr) ) ).

tff(addAssignment_64383,axiom,
    ! [VarCurr: state_type] :
      ( v107470(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64382,axiom,
    ! [VarCurr: state_type] :
      ( v107464(VarCurr)
    <=> v107466(VarCurr) ) ).

tff(addAssignment_64381,axiom,
    ! [VarCurr: state_type] :
      ( v107466(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_64380,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,6)
    <=> v107357(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_793,axiom,
    ! [VarCurr: state_type] :
      ( v107357(VarCurr)
    <=> ( ( v107359(VarCurr,3)
        <=> $false )
        & ( v107359(VarCurr,2)
        <=> $false )
        & ( v107359(VarCurr,1)
        <=> $false )
        & ( v107359(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107359(VarCurr,B)
      <=> v107361(VarCurr,B) ) ) ).

tff(addAssignment_64378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107361(VarCurr,B)
      <=> v107363(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107438(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v107363(VarNext,B)
            <=> v107363(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1297,axiom,
    ! [VarNext: state_type] :
      ( v107438(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107363(VarNext,B)
          <=> v107448(VarNext,B) ) ) ) ).

tff(addAssignment_64377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107448(VarNext,B)
          <=> v107446(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107446(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_874,axiom,
    ! [VarCurr: state_type] :
      ( v107449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107446(VarCurr,B)
          <=> v107381(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10755,axiom,
    ! [VarCurr: state_type] :
      ( v107449(VarCurr)
    <=> ( v107450(VarCurr)
        & v107451(VarCurr) ) ) ).

tff(writeUnaryOperator_5667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107451(VarCurr)
    <=> v107373(VarCurr) ) ).

tff(writeUnaryOperator_5666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107450(VarCurr)
    <=> v107365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107438(VarNext)
      <=> v107439(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107439(VarNext)
      <=> ( v107440(VarNext)
          & v107431(VarNext) ) ) ) ).

tff(writeUnaryOperator_5665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107440(VarNext)
      <=> v107442(VarNext) ) ) ).

tff(addAssignment_64376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107442(VarNext)
      <=> v107431(VarCurr) ) ) ).

tff(addAssignment_64375,axiom,
    ! [VarCurr: state_type] :
      ( v107431(VarCurr)
    <=> v107433(VarCurr) ) ).

tff(addAssignment_64374,axiom,
    ! [VarCurr: state_type] :
      ( v107433(VarCurr)
    <=> v107435(VarCurr) ) ).

tff(addAssignment_64373,axiom,
    ! [VarCurr: state_type] :
      ( v107435(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_64372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107381(VarCurr,B)
      <=> v107383(VarCurr,B) ) ) ).

tff(addAssignment_64371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107383(VarCurr,B)
      <=> v107385(VarCurr,B) ) ) ).

tff(addAssignment_64370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107385(VarCurr,B)
      <=> v107387(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107387(VarCurr,B)
          <=> v107406(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_873,axiom,
    ! [VarCurr: state_type] :
      ( v107389(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107387(VarCurr,B)
          <=> v107402(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107406(VarCurr,B)
          <=> v107408(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_872,axiom,
    ! [VarCurr: state_type] :
      ( v107407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107406(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107408(VarCurr,B)
          <=> v107359(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_871,axiom,
    ! [VarCurr: state_type] :
      ( v107404(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v107408(VarCurr,B)
          <=> v107409(VarCurr,B) ) ) ) ).

tff(addAssignment_64369,axiom,
    ! [VarCurr: state_type] :
      ( v107409(VarCurr,0)
    <=> v107428(VarCurr) ) ).

tff(addAssignment_64368,axiom,
    ! [VarCurr: state_type] :
      ( v107409(VarCurr,1)
    <=> v107426(VarCurr) ) ).

tff(addAssignment_64367,axiom,
    ! [VarCurr: state_type] :
      ( v107409(VarCurr,2)
    <=> v107422(VarCurr) ) ).

tff(addAssignment_64366,axiom,
    ! [VarCurr: state_type] :
      ( v107409(VarCurr,3)
    <=> v107411(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10752,axiom,
    ! [VarCurr: state_type] :
      ( v107426(VarCurr)
    <=> ( v107427(VarCurr)
        & v107429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10751,axiom,
    ! [VarCurr: state_type] :
      ( v107429(VarCurr)
    <=> ( v107359(VarCurr,0)
        | v107418(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4333,axiom,
    ! [VarCurr: state_type] :
      ( v107427(VarCurr)
    <=> ( v107428(VarCurr)
        | v107359(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107428(VarCurr)
    <=> v107359(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10750,axiom,
    ! [VarCurr: state_type] :
      ( v107422(VarCurr)
    <=> ( v107423(VarCurr)
        & v107425(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10749,axiom,
    ! [VarCurr: state_type] :
      ( v107425(VarCurr)
    <=> ( v107416(VarCurr)
        | v107419(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4332,axiom,
    ! [VarCurr: state_type] :
      ( v107423(VarCurr)
    <=> ( v107424(VarCurr)
        | v107359(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107424(VarCurr)
    <=> v107416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10748,axiom,
    ! [VarCurr: state_type] :
      ( v107411(VarCurr)
    <=> ( v107412(VarCurr)
        & v107420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10747,axiom,
    ! [VarCurr: state_type] :
      ( v107420(VarCurr)
    <=> ( v107414(VarCurr)
        | v107421(VarCurr) ) ) ).

tff(writeUnaryOperator_5662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107421(VarCurr)
    <=> v107359(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4331,axiom,
    ! [VarCurr: state_type] :
      ( v107412(VarCurr)
    <=> ( v107413(VarCurr)
        | v107359(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107413(VarCurr)
    <=> v107414(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4330,axiom,
    ! [VarCurr: state_type] :
      ( v107414(VarCurr)
    <=> ( v107359(VarCurr,2)
        | v107415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10746,axiom,
    ! [VarCurr: state_type] :
      ( v107415(VarCurr)
    <=> ( v107416(VarCurr)
        & v107419(VarCurr) ) ) ).

tff(writeUnaryOperator_5660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107419(VarCurr)
    <=> v107359(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4329,axiom,
    ! [VarCurr: state_type] :
      ( v107416(VarCurr)
    <=> ( v107359(VarCurr,1)
        | v107417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10745,axiom,
    ! [VarCurr: state_type] :
      ( v107417(VarCurr)
    <=> ( v107359(VarCurr,0)
        & v107418(VarCurr) ) ) ).

tff(writeUnaryOperator_5659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107418(VarCurr)
    <=> v107359(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_792,axiom,
    ! [VarCurr: state_type] :
      ( v107407(VarCurr)
    <=> ( ( v107359(VarCurr,3)
        <=> $false )
        & ( v107359(VarCurr,2)
        <=> $false )
        & ( v107359(VarCurr,1)
        <=> $false )
        & ( v107359(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64365,axiom,
    ! [VarCurr: state_type] :
      ( v107404(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_64364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v107402(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_64363,axiom,
    ! [VarCurr: state_type] :
      ( v107389(VarCurr)
    <=> v89212(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_4328,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,6)
    <=> ( v107391(VarCurr)
        | v107399(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10744,axiom,
    ! [VarCurr: state_type] :
      ( v107399(VarCurr)
    <=> ( v82954(VarCurr)
        & v107400(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_791,axiom,
    ! [VarCurr: state_type] :
      ( v107400(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10743,axiom,
    ! [VarCurr: state_type] :
      ( v107391(VarCurr)
    <=> ( v107392(VarCurr)
        | v107397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10742,axiom,
    ! [VarCurr: state_type] :
      ( v107397(VarCurr)
    <=> ( v86877(VarCurr)
        & v107398(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_790,axiom,
    ! [VarCurr: state_type] :
      ( v107398(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10741,axiom,
    ! [VarCurr: state_type] :
      ( v107392(VarCurr)
    <=> ( v107393(VarCurr)
        | v107395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10740,axiom,
    ! [VarCurr: state_type] :
      ( v107395(VarCurr)
    <=> ( v84899(VarCurr)
        & v107396(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_789,axiom,
    ! [VarCurr: state_type] :
      ( v107396(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $true )
        & ( v89243(VarCurr,5)
        <=> $true )
        & ( v89243(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10739,axiom,
    ! [VarCurr: state_type] :
      ( v107393(VarCurr)
    <=> ( v118(VarCurr)
        & v107394(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_788,axiom,
    ! [VarCurr: state_type] :
      ( v107394(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $true )
        & ( v89214(VarCurr,5)
        <=> $true )
        & ( v89214(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_64362,axiom,
    ! [VarCurr: state_type] :
      ( v107373(VarCurr)
    <=> v107375(VarCurr) ) ).

tff(addAssignment_64361,axiom,
    ! [VarCurr: state_type] :
      ( v107375(VarCurr)
    <=> v107377(VarCurr) ) ).

tff(addAssignment_64360,axiom,
    ! [VarCurr: state_type] :
      ( v107377(VarCurr)
    <=> v107379(VarCurr) ) ).

tff(addAssignment_64359,axiom,
    ! [VarCurr: state_type] :
      ( v107379(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_64358,axiom,
    ! [VarCurr: state_type] :
      ( v107365(VarCurr)
    <=> v107367(VarCurr) ) ).

tff(addAssignment_64357,axiom,
    ! [VarCurr: state_type] :
      ( v107367(VarCurr)
    <=> v107369(VarCurr) ) ).

tff(addAssignment_64356,axiom,
    ! [VarCurr: state_type] :
      ( v107369(VarCurr)
    <=> v107371(VarCurr) ) ).

tff(addAssignment_64355,axiom,
    ! [VarCurr: state_type] :
      ( v107371(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_64354,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,5)
    <=> v106983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10738,axiom,
    ! [VarCurr: state_type] :
      ( v106983(VarCurr)
    <=> ( v107350(VarCurr)
        & v107355(VarCurr) ) ) ).

tff(writeUnaryOperator_5658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107355(VarCurr)
    <=> v107264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10737,axiom,
    ! [VarCurr: state_type] :
      ( v107350(VarCurr)
    <=> ( v107351(VarCurr)
        & v107354(VarCurr) ) ) ).

tff(writeUnaryOperator_5657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107354(VarCurr)
    <=> v107180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10736,axiom,
    ! [VarCurr: state_type] :
      ( v107351(VarCurr)
    <=> ( v107352(VarCurr)
        & v107353(VarCurr) ) ) ).

tff(writeUnaryOperator_5656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107353(VarCurr)
    <=> v107098(VarCurr) ) ).

tff(writeUnaryOperator_5655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107352(VarCurr)
    <=> v106985(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_787,axiom,
    ! [VarCurr: state_type] :
      ( v107264(VarCurr)
    <=> ( ( v107266(VarCurr,4)
        <=> $false )
        & ( v107266(VarCurr,3)
        <=> $false )
        & ( v107266(VarCurr,2)
        <=> $false )
        & ( v107266(VarCurr,1)
        <=> $false )
        & ( v107266(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107266(VarCurr,B)
      <=> v107268(VarCurr,B) ) ) ).

tff(addAssignment_64352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107268(VarCurr,B)
      <=> v107270(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107332(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107270(VarNext,B)
            <=> v107270(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1296,axiom,
    ! [VarNext: state_type] :
      ( v107332(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107270(VarNext,B)
          <=> v107342(VarNext,B) ) ) ) ).

tff(addAssignment_64351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107342(VarNext,B)
          <=> v107340(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107343(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107340(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_870,axiom,
    ! [VarCurr: state_type] :
      ( v107343(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107340(VarCurr,B)
          <=> v107280(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10735,axiom,
    ! [VarCurr: state_type] :
      ( v107343(VarCurr)
    <=> ( v107344(VarCurr)
        & v107345(VarCurr) ) ) ).

tff(writeUnaryOperator_5654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107345(VarCurr)
    <=> v107276(VarCurr) ) ).

tff(writeUnaryOperator_5653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107344(VarCurr)
    <=> v107272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107332(VarNext)
      <=> v107333(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107333(VarNext)
      <=> ( v107334(VarNext)
          & v107327(VarNext) ) ) ) ).

tff(writeUnaryOperator_5652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107334(VarNext)
      <=> v107336(VarNext) ) ) ).

tff(addAssignment_64350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107336(VarNext)
      <=> v107327(VarCurr) ) ) ).

tff(addAssignment_64349,axiom,
    ! [VarCurr: state_type] :
      ( v107327(VarCurr)
    <=> v107329(VarCurr) ) ).

tff(addAssignment_64348,axiom,
    ! [VarCurr: state_type] :
      ( v107329(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107280(VarCurr,B)
      <=> v107282(VarCurr,B) ) ) ).

tff(addAssignment_64346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107282(VarCurr,B)
      <=> v107284(VarCurr,B) ) ) ).

tff(addAssignment_64345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107284(VarCurr,B)
      <=> v107286(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107288(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107286(VarCurr,B)
          <=> v107297(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_869,axiom,
    ! [VarCurr: state_type] :
      ( v107288(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107286(VarCurr,B)
          <=> v107296(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107264(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107297(VarCurr,B)
          <=> v107298(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_868,axiom,
    ! [VarCurr: state_type] :
      ( v107264(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107297(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64344,axiom,
    ! [VarCurr: state_type] :
      ( v107298(VarCurr,0)
    <=> v107324(VarCurr) ) ).

tff(addAssignment_64343,axiom,
    ! [VarCurr: state_type] :
      ( v107298(VarCurr,1)
    <=> v107322(VarCurr) ) ).

tff(addAssignment_64342,axiom,
    ! [VarCurr: state_type] :
      ( v107298(VarCurr,2)
    <=> v107318(VarCurr) ) ).

tff(addAssignment_64341,axiom,
    ! [VarCurr: state_type] :
      ( v107298(VarCurr,3)
    <=> v107314(VarCurr) ) ).

tff(addAssignment_64340,axiom,
    ! [VarCurr: state_type] :
      ( v107298(VarCurr,4)
    <=> v107300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10732,axiom,
    ! [VarCurr: state_type] :
      ( v107322(VarCurr)
    <=> ( v107323(VarCurr)
        & v107325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10731,axiom,
    ! [VarCurr: state_type] :
      ( v107325(VarCurr)
    <=> ( v107266(VarCurr,0)
        | v107309(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4327,axiom,
    ! [VarCurr: state_type] :
      ( v107323(VarCurr)
    <=> ( v107324(VarCurr)
        | v107266(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107324(VarCurr)
    <=> v107266(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10730,axiom,
    ! [VarCurr: state_type] :
      ( v107318(VarCurr)
    <=> ( v107319(VarCurr)
        & v107321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10729,axiom,
    ! [VarCurr: state_type] :
      ( v107321(VarCurr)
    <=> ( v107307(VarCurr)
        | v107310(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4326,axiom,
    ! [VarCurr: state_type] :
      ( v107319(VarCurr)
    <=> ( v107320(VarCurr)
        | v107266(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107320(VarCurr)
    <=> v107307(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10728,axiom,
    ! [VarCurr: state_type] :
      ( v107314(VarCurr)
    <=> ( v107315(VarCurr)
        & v107317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10727,axiom,
    ! [VarCurr: state_type] :
      ( v107317(VarCurr)
    <=> ( v107305(VarCurr)
        | v107311(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4325,axiom,
    ! [VarCurr: state_type] :
      ( v107315(VarCurr)
    <=> ( v107316(VarCurr)
        | v107266(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107316(VarCurr)
    <=> v107305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10726,axiom,
    ! [VarCurr: state_type] :
      ( v107300(VarCurr)
    <=> ( v107301(VarCurr)
        & v107312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10725,axiom,
    ! [VarCurr: state_type] :
      ( v107312(VarCurr)
    <=> ( v107303(VarCurr)
        | v107313(VarCurr) ) ) ).

tff(writeUnaryOperator_5648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107313(VarCurr)
    <=> v107266(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4324,axiom,
    ! [VarCurr: state_type] :
      ( v107301(VarCurr)
    <=> ( v107302(VarCurr)
        | v107266(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107302(VarCurr)
    <=> v107303(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4323,axiom,
    ! [VarCurr: state_type] :
      ( v107303(VarCurr)
    <=> ( v107266(VarCurr,3)
        | v107304(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10724,axiom,
    ! [VarCurr: state_type] :
      ( v107304(VarCurr)
    <=> ( v107305(VarCurr)
        & v107311(VarCurr) ) ) ).

tff(writeUnaryOperator_5646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107311(VarCurr)
    <=> v107266(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4322,axiom,
    ! [VarCurr: state_type] :
      ( v107305(VarCurr)
    <=> ( v107266(VarCurr,2)
        | v107306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10723,axiom,
    ! [VarCurr: state_type] :
      ( v107306(VarCurr)
    <=> ( v107307(VarCurr)
        & v107310(VarCurr) ) ) ).

tff(writeUnaryOperator_5645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107310(VarCurr)
    <=> v107266(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4321,axiom,
    ! [VarCurr: state_type] :
      ( v107307(VarCurr)
    <=> ( v107266(VarCurr,1)
        | v107308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10722,axiom,
    ! [VarCurr: state_type] :
      ( v107308(VarCurr)
    <=> ( v107266(VarCurr,0)
        & v107309(VarCurr) ) ) ).

tff(writeUnaryOperator_5644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107309(VarCurr)
    <=> v107266(VarCurr,1) ) ).

tff(addAssignment_64339,axiom,
    ! [VarCurr: state_type] :
      ( v107296(VarCurr,0)
    <=> v107043(VarCurr) ) ).

tff(addAssignment_64338,axiom,
    ! [VarCurr: state_type] :
      ( v107296(VarCurr,1)
    <=> v107041(VarCurr) ) ).

tff(addAssignment_64337,axiom,
    ! [VarCurr: state_type] :
      ( v107296(VarCurr,2)
    <=> v107037(VarCurr) ) ).

tff(addAssignment_64336,axiom,
    ! [VarCurr: state_type] :
      ( v107296(VarCurr,3)
    <=> v107033(VarCurr) ) ).

tff(addAssignment_64335,axiom,
    ! [VarCurr: state_type] :
      ( v107296(VarCurr,4)
    <=> v107019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10721,axiom,
    ! [VarCurr: state_type] :
      ( v107288(VarCurr)
    <=> ( v107289(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10720,axiom,
    ! [VarCurr: state_type] :
      ( v107289(VarCurr)
    <=> ( v107290(VarCurr)
        & v107009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10719,axiom,
    ! [VarCurr: state_type] :
      ( v107290(VarCurr)
    <=> ( v107291(VarCurr)
        & v107295(VarCurr) ) ) ).

tff(writeUnaryOperator_5643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107295(VarCurr)
    <=> v106985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10718,axiom,
    ! [VarCurr: state_type] :
      ( v107291(VarCurr)
    <=> ( v107292(VarCurr)
        & v107294(VarCurr) ) ) ).

tff(writeUnaryOperator_5642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107294(VarCurr)
    <=> v107098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10717,axiom,
    ! [VarCurr: state_type] :
      ( v107292(VarCurr)
    <=> ( v107264(VarCurr)
        & v107293(VarCurr) ) ) ).

tff(writeUnaryOperator_5641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107293(VarCurr)
    <=> v107180(VarCurr) ) ).

tff(addAssignment_64334,axiom,
    ! [VarCurr: state_type] :
      ( v107276(VarCurr)
    <=> v107278(VarCurr) ) ).

tff(addAssignment_64333,axiom,
    ! [VarCurr: state_type] :
      ( v107278(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64332,axiom,
    ! [VarCurr: state_type] :
      ( v107272(VarCurr)
    <=> v107274(VarCurr) ) ).

tff(addAssignment_64331,axiom,
    ! [VarCurr: state_type] :
      ( v107274(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_786,axiom,
    ! [VarCurr: state_type] :
      ( v107180(VarCurr)
    <=> ( ( v107182(VarCurr,4)
        <=> $false )
        & ( v107182(VarCurr,3)
        <=> $false )
        & ( v107182(VarCurr,2)
        <=> $false )
        & ( v107182(VarCurr,1)
        <=> $false )
        & ( v107182(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107182(VarCurr,B)
      <=> v107184(VarCurr,B) ) ) ).

tff(addAssignment_64329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107184(VarCurr,B)
      <=> v107186(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107246(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107186(VarNext,B)
            <=> v107186(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1295,axiom,
    ! [VarNext: state_type] :
      ( v107246(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107186(VarNext,B)
          <=> v107256(VarNext,B) ) ) ) ).

tff(addAssignment_64328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107256(VarNext,B)
          <=> v107254(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107254(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_867,axiom,
    ! [VarCurr: state_type] :
      ( v107257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107254(VarCurr,B)
          <=> v107196(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10716,axiom,
    ! [VarCurr: state_type] :
      ( v107257(VarCurr)
    <=> ( v107258(VarCurr)
        & v107259(VarCurr) ) ) ).

tff(writeUnaryOperator_5640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107259(VarCurr)
    <=> v107192(VarCurr) ) ).

tff(writeUnaryOperator_5639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107258(VarCurr)
    <=> v107188(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107246(VarNext)
      <=> v107247(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107247(VarNext)
      <=> ( v107248(VarNext)
          & v107241(VarNext) ) ) ) ).

tff(writeUnaryOperator_5638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107248(VarNext)
      <=> v107250(VarNext) ) ) ).

tff(addAssignment_64327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107250(VarNext)
      <=> v107241(VarCurr) ) ) ).

tff(addAssignment_64326,axiom,
    ! [VarCurr: state_type] :
      ( v107241(VarCurr)
    <=> v107243(VarCurr) ) ).

tff(addAssignment_64325,axiom,
    ! [VarCurr: state_type] :
      ( v107243(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107196(VarCurr,B)
      <=> v107198(VarCurr,B) ) ) ).

tff(addAssignment_64323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107198(VarCurr,B)
      <=> v107200(VarCurr,B) ) ) ).

tff(addAssignment_64322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107200(VarCurr,B)
      <=> v107202(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107202(VarCurr,B)
          <=> v107211(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_866,axiom,
    ! [VarCurr: state_type] :
      ( v107204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107202(VarCurr,B)
          <=> v107210(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107180(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107211(VarCurr,B)
          <=> v107212(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_865,axiom,
    ! [VarCurr: state_type] :
      ( v107180(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107211(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64321,axiom,
    ! [VarCurr: state_type] :
      ( v107212(VarCurr,0)
    <=> v107238(VarCurr) ) ).

tff(addAssignment_64320,axiom,
    ! [VarCurr: state_type] :
      ( v107212(VarCurr,1)
    <=> v107236(VarCurr) ) ).

tff(addAssignment_64319,axiom,
    ! [VarCurr: state_type] :
      ( v107212(VarCurr,2)
    <=> v107232(VarCurr) ) ).

tff(addAssignment_64318,axiom,
    ! [VarCurr: state_type] :
      ( v107212(VarCurr,3)
    <=> v107228(VarCurr) ) ).

tff(addAssignment_64317,axiom,
    ! [VarCurr: state_type] :
      ( v107212(VarCurr,4)
    <=> v107214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10713,axiom,
    ! [VarCurr: state_type] :
      ( v107236(VarCurr)
    <=> ( v107237(VarCurr)
        & v107239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10712,axiom,
    ! [VarCurr: state_type] :
      ( v107239(VarCurr)
    <=> ( v107182(VarCurr,0)
        | v107223(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4320,axiom,
    ! [VarCurr: state_type] :
      ( v107237(VarCurr)
    <=> ( v107238(VarCurr)
        | v107182(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107238(VarCurr)
    <=> v107182(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10711,axiom,
    ! [VarCurr: state_type] :
      ( v107232(VarCurr)
    <=> ( v107233(VarCurr)
        & v107235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10710,axiom,
    ! [VarCurr: state_type] :
      ( v107235(VarCurr)
    <=> ( v107221(VarCurr)
        | v107224(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4319,axiom,
    ! [VarCurr: state_type] :
      ( v107233(VarCurr)
    <=> ( v107234(VarCurr)
        | v107182(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107234(VarCurr)
    <=> v107221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10709,axiom,
    ! [VarCurr: state_type] :
      ( v107228(VarCurr)
    <=> ( v107229(VarCurr)
        & v107231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10708,axiom,
    ! [VarCurr: state_type] :
      ( v107231(VarCurr)
    <=> ( v107219(VarCurr)
        | v107225(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4318,axiom,
    ! [VarCurr: state_type] :
      ( v107229(VarCurr)
    <=> ( v107230(VarCurr)
        | v107182(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107230(VarCurr)
    <=> v107219(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10707,axiom,
    ! [VarCurr: state_type] :
      ( v107214(VarCurr)
    <=> ( v107215(VarCurr)
        & v107226(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10706,axiom,
    ! [VarCurr: state_type] :
      ( v107226(VarCurr)
    <=> ( v107217(VarCurr)
        | v107227(VarCurr) ) ) ).

tff(writeUnaryOperator_5634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107227(VarCurr)
    <=> v107182(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4317,axiom,
    ! [VarCurr: state_type] :
      ( v107215(VarCurr)
    <=> ( v107216(VarCurr)
        | v107182(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107216(VarCurr)
    <=> v107217(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4316,axiom,
    ! [VarCurr: state_type] :
      ( v107217(VarCurr)
    <=> ( v107182(VarCurr,3)
        | v107218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10705,axiom,
    ! [VarCurr: state_type] :
      ( v107218(VarCurr)
    <=> ( v107219(VarCurr)
        & v107225(VarCurr) ) ) ).

tff(writeUnaryOperator_5632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107225(VarCurr)
    <=> v107182(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4315,axiom,
    ! [VarCurr: state_type] :
      ( v107219(VarCurr)
    <=> ( v107182(VarCurr,2)
        | v107220(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10704,axiom,
    ! [VarCurr: state_type] :
      ( v107220(VarCurr)
    <=> ( v107221(VarCurr)
        & v107224(VarCurr) ) ) ).

tff(writeUnaryOperator_5631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107224(VarCurr)
    <=> v107182(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4314,axiom,
    ! [VarCurr: state_type] :
      ( v107221(VarCurr)
    <=> ( v107182(VarCurr,1)
        | v107222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10703,axiom,
    ! [VarCurr: state_type] :
      ( v107222(VarCurr)
    <=> ( v107182(VarCurr,0)
        & v107223(VarCurr) ) ) ).

tff(writeUnaryOperator_5630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107223(VarCurr)
    <=> v107182(VarCurr,1) ) ).

tff(addAssignment_64316,axiom,
    ! [VarCurr: state_type] :
      ( v107210(VarCurr,0)
    <=> v107043(VarCurr) ) ).

tff(addAssignment_64315,axiom,
    ! [VarCurr: state_type] :
      ( v107210(VarCurr,1)
    <=> v107041(VarCurr) ) ).

tff(addAssignment_64314,axiom,
    ! [VarCurr: state_type] :
      ( v107210(VarCurr,2)
    <=> v107037(VarCurr) ) ).

tff(addAssignment_64313,axiom,
    ! [VarCurr: state_type] :
      ( v107210(VarCurr,3)
    <=> v107033(VarCurr) ) ).

tff(addAssignment_64312,axiom,
    ! [VarCurr: state_type] :
      ( v107210(VarCurr,4)
    <=> v107019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10702,axiom,
    ! [VarCurr: state_type] :
      ( v107204(VarCurr)
    <=> ( v107205(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10701,axiom,
    ! [VarCurr: state_type] :
      ( v107205(VarCurr)
    <=> ( v107206(VarCurr)
        & v107009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10700,axiom,
    ! [VarCurr: state_type] :
      ( v107206(VarCurr)
    <=> ( v107207(VarCurr)
        & v107209(VarCurr) ) ) ).

tff(writeUnaryOperator_5629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107209(VarCurr)
    <=> v106985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10699,axiom,
    ! [VarCurr: state_type] :
      ( v107207(VarCurr)
    <=> ( v107180(VarCurr)
        & v107208(VarCurr) ) ) ).

tff(writeUnaryOperator_5628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107208(VarCurr)
    <=> v107098(VarCurr) ) ).

tff(addAssignment_64311,axiom,
    ! [VarCurr: state_type] :
      ( v107192(VarCurr)
    <=> v107194(VarCurr) ) ).

tff(addAssignment_64310,axiom,
    ! [VarCurr: state_type] :
      ( v107194(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64309,axiom,
    ! [VarCurr: state_type] :
      ( v107188(VarCurr)
    <=> v107190(VarCurr) ) ).

tff(addAssignment_64308,axiom,
    ! [VarCurr: state_type] :
      ( v107190(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_785,axiom,
    ! [VarCurr: state_type] :
      ( v107098(VarCurr)
    <=> ( ( v107100(VarCurr,4)
        <=> $false )
        & ( v107100(VarCurr,3)
        <=> $false )
        & ( v107100(VarCurr,2)
        <=> $false )
        & ( v107100(VarCurr,1)
        <=> $false )
        & ( v107100(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107100(VarCurr,B)
      <=> v107102(VarCurr,B) ) ) ).

tff(addAssignment_64306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107102(VarCurr,B)
      <=> v107104(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107162(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v107104(VarNext,B)
            <=> v107104(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1294,axiom,
    ! [VarNext: state_type] :
      ( v107162(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107104(VarNext,B)
          <=> v107172(VarNext,B) ) ) ) ).

tff(addAssignment_64305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107172(VarNext,B)
          <=> v107170(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107173(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107170(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_864,axiom,
    ! [VarCurr: state_type] :
      ( v107173(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107170(VarCurr,B)
          <=> v107114(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10698,axiom,
    ! [VarCurr: state_type] :
      ( v107173(VarCurr)
    <=> ( v107174(VarCurr)
        & v107175(VarCurr) ) ) ).

tff(writeUnaryOperator_5627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107175(VarCurr)
    <=> v107110(VarCurr) ) ).

tff(writeUnaryOperator_5626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107174(VarCurr)
    <=> v107106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107162(VarNext)
      <=> v107163(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107163(VarNext)
      <=> ( v107164(VarNext)
          & v107157(VarNext) ) ) ) ).

tff(writeUnaryOperator_5625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107164(VarNext)
      <=> v107166(VarNext) ) ) ).

tff(addAssignment_64304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107166(VarNext)
      <=> v107157(VarCurr) ) ) ).

tff(addAssignment_64303,axiom,
    ! [VarCurr: state_type] :
      ( v107157(VarCurr)
    <=> v107159(VarCurr) ) ).

tff(addAssignment_64302,axiom,
    ! [VarCurr: state_type] :
      ( v107159(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107114(VarCurr,B)
      <=> v107116(VarCurr,B) ) ) ).

tff(addAssignment_64300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107116(VarCurr,B)
      <=> v107118(VarCurr,B) ) ) ).

tff(addAssignment_64299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107118(VarCurr,B)
      <=> v107120(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107120(VarCurr,B)
          <=> v107127(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_863,axiom,
    ! [VarCurr: state_type] :
      ( v107122(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107120(VarCurr,B)
          <=> v107126(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107098(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107127(VarCurr,B)
          <=> v107128(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_862,axiom,
    ! [VarCurr: state_type] :
      ( v107098(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107127(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64298,axiom,
    ! [VarCurr: state_type] :
      ( v107128(VarCurr,0)
    <=> v107154(VarCurr) ) ).

tff(addAssignment_64297,axiom,
    ! [VarCurr: state_type] :
      ( v107128(VarCurr,1)
    <=> v107152(VarCurr) ) ).

tff(addAssignment_64296,axiom,
    ! [VarCurr: state_type] :
      ( v107128(VarCurr,2)
    <=> v107148(VarCurr) ) ).

tff(addAssignment_64295,axiom,
    ! [VarCurr: state_type] :
      ( v107128(VarCurr,3)
    <=> v107144(VarCurr) ) ).

tff(addAssignment_64294,axiom,
    ! [VarCurr: state_type] :
      ( v107128(VarCurr,4)
    <=> v107130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10695,axiom,
    ! [VarCurr: state_type] :
      ( v107152(VarCurr)
    <=> ( v107153(VarCurr)
        & v107155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10694,axiom,
    ! [VarCurr: state_type] :
      ( v107155(VarCurr)
    <=> ( v107100(VarCurr,0)
        | v107139(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4313,axiom,
    ! [VarCurr: state_type] :
      ( v107153(VarCurr)
    <=> ( v107154(VarCurr)
        | v107100(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107154(VarCurr)
    <=> v107100(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10693,axiom,
    ! [VarCurr: state_type] :
      ( v107148(VarCurr)
    <=> ( v107149(VarCurr)
        & v107151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10692,axiom,
    ! [VarCurr: state_type] :
      ( v107151(VarCurr)
    <=> ( v107137(VarCurr)
        | v107140(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4312,axiom,
    ! [VarCurr: state_type] :
      ( v107149(VarCurr)
    <=> ( v107150(VarCurr)
        | v107100(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107150(VarCurr)
    <=> v107137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10691,axiom,
    ! [VarCurr: state_type] :
      ( v107144(VarCurr)
    <=> ( v107145(VarCurr)
        & v107147(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10690,axiom,
    ! [VarCurr: state_type] :
      ( v107147(VarCurr)
    <=> ( v107135(VarCurr)
        | v107141(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4311,axiom,
    ! [VarCurr: state_type] :
      ( v107145(VarCurr)
    <=> ( v107146(VarCurr)
        | v107100(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107146(VarCurr)
    <=> v107135(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10689,axiom,
    ! [VarCurr: state_type] :
      ( v107130(VarCurr)
    <=> ( v107131(VarCurr)
        & v107142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10688,axiom,
    ! [VarCurr: state_type] :
      ( v107142(VarCurr)
    <=> ( v107133(VarCurr)
        | v107143(VarCurr) ) ) ).

tff(writeUnaryOperator_5621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107143(VarCurr)
    <=> v107100(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4310,axiom,
    ! [VarCurr: state_type] :
      ( v107131(VarCurr)
    <=> ( v107132(VarCurr)
        | v107100(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107132(VarCurr)
    <=> v107133(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4309,axiom,
    ! [VarCurr: state_type] :
      ( v107133(VarCurr)
    <=> ( v107100(VarCurr,3)
        | v107134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10687,axiom,
    ! [VarCurr: state_type] :
      ( v107134(VarCurr)
    <=> ( v107135(VarCurr)
        & v107141(VarCurr) ) ) ).

tff(writeUnaryOperator_5619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107141(VarCurr)
    <=> v107100(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4308,axiom,
    ! [VarCurr: state_type] :
      ( v107135(VarCurr)
    <=> ( v107100(VarCurr,2)
        | v107136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10686,axiom,
    ! [VarCurr: state_type] :
      ( v107136(VarCurr)
    <=> ( v107137(VarCurr)
        & v107140(VarCurr) ) ) ).

tff(writeUnaryOperator_5618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107140(VarCurr)
    <=> v107100(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4307,axiom,
    ! [VarCurr: state_type] :
      ( v107137(VarCurr)
    <=> ( v107100(VarCurr,1)
        | v107138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10685,axiom,
    ! [VarCurr: state_type] :
      ( v107138(VarCurr)
    <=> ( v107100(VarCurr,0)
        & v107139(VarCurr) ) ) ).

tff(writeUnaryOperator_5617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107139(VarCurr)
    <=> v107100(VarCurr,1) ) ).

tff(addAssignment_64293,axiom,
    ! [VarCurr: state_type] :
      ( v107126(VarCurr,0)
    <=> v107043(VarCurr) ) ).

tff(addAssignment_64292,axiom,
    ! [VarCurr: state_type] :
      ( v107126(VarCurr,1)
    <=> v107041(VarCurr) ) ).

tff(addAssignment_64291,axiom,
    ! [VarCurr: state_type] :
      ( v107126(VarCurr,2)
    <=> v107037(VarCurr) ) ).

tff(addAssignment_64290,axiom,
    ! [VarCurr: state_type] :
      ( v107126(VarCurr,3)
    <=> v107033(VarCurr) ) ).

tff(addAssignment_64289,axiom,
    ! [VarCurr: state_type] :
      ( v107126(VarCurr,4)
    <=> v107019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10684,axiom,
    ! [VarCurr: state_type] :
      ( v107122(VarCurr)
    <=> ( v107123(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10683,axiom,
    ! [VarCurr: state_type] :
      ( v107123(VarCurr)
    <=> ( v107124(VarCurr)
        & v107009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10682,axiom,
    ! [VarCurr: state_type] :
      ( v107124(VarCurr)
    <=> ( v107098(VarCurr)
        & v107125(VarCurr) ) ) ).

tff(writeUnaryOperator_5616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107125(VarCurr)
    <=> v106985(VarCurr) ) ).

tff(addAssignment_64288,axiom,
    ! [VarCurr: state_type] :
      ( v107110(VarCurr)
    <=> v107112(VarCurr) ) ).

tff(addAssignment_64287,axiom,
    ! [VarCurr: state_type] :
      ( v107112(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64286,axiom,
    ! [VarCurr: state_type] :
      ( v107106(VarCurr)
    <=> v107108(VarCurr) ) ).

tff(addAssignment_64285,axiom,
    ! [VarCurr: state_type] :
      ( v107108(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_784,axiom,
    ! [VarCurr: state_type] :
      ( v106985(VarCurr)
    <=> ( ( v106987(VarCurr,4)
        <=> $false )
        & ( v106987(VarCurr,3)
        <=> $false )
        & ( v106987(VarCurr,2)
        <=> $false )
        & ( v106987(VarCurr,1)
        <=> $false )
        & ( v106987(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106987(VarCurr,B)
      <=> v106989(VarCurr,B) ) ) ).

tff(addAssignment_64283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106989(VarCurr,B)
      <=> v106991(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107080(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v106991(VarNext,B)
            <=> v106991(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1293,axiom,
    ! [VarNext: state_type] :
      ( v107080(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106991(VarNext,B)
          <=> v107090(VarNext,B) ) ) ) ).

tff(addAssignment_64282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107090(VarNext,B)
          <=> v107088(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107091(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107088(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_861,axiom,
    ! [VarCurr: state_type] :
      ( v107091(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107088(VarCurr,B)
          <=> v107001(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10681,axiom,
    ! [VarCurr: state_type] :
      ( v107091(VarCurr)
    <=> ( v107092(VarCurr)
        & v107093(VarCurr) ) ) ).

tff(writeUnaryOperator_5615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107093(VarCurr)
    <=> v106997(VarCurr) ) ).

tff(writeUnaryOperator_5614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107092(VarCurr)
    <=> v106993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107080(VarNext)
      <=> v107081(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107081(VarNext)
      <=> ( v107082(VarNext)
          & v107075(VarNext) ) ) ) ).

tff(writeUnaryOperator_5613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v107082(VarNext)
      <=> v107084(VarNext) ) ) ).

tff(addAssignment_64281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v107084(VarNext)
      <=> v107075(VarCurr) ) ) ).

tff(addAssignment_64280,axiom,
    ! [VarCurr: state_type] :
      ( v107075(VarCurr)
    <=> v107077(VarCurr) ) ).

tff(addAssignment_64279,axiom,
    ! [VarCurr: state_type] :
      ( v107077(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107001(VarCurr,B)
      <=> v107003(VarCurr,B) ) ) ).

tff(addAssignment_64277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107003(VarCurr,B)
      <=> v107005(VarCurr,B) ) ) ).

tff(addAssignment_64276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v107005(VarCurr,B)
      <=> v107007(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107007(VarCurr,B)
          <=> v107045(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_860,axiom,
    ! [VarCurr: state_type] :
      ( v107015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107007(VarCurr,B)
          <=> v107017(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106985(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107045(VarCurr,B)
          <=> v107046(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_859,axiom,
    ! [VarCurr: state_type] :
      ( v106985(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v107045(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64275,axiom,
    ! [VarCurr: state_type] :
      ( v107046(VarCurr,0)
    <=> v107072(VarCurr) ) ).

tff(addAssignment_64274,axiom,
    ! [VarCurr: state_type] :
      ( v107046(VarCurr,1)
    <=> v107070(VarCurr) ) ).

tff(addAssignment_64273,axiom,
    ! [VarCurr: state_type] :
      ( v107046(VarCurr,2)
    <=> v107066(VarCurr) ) ).

tff(addAssignment_64272,axiom,
    ! [VarCurr: state_type] :
      ( v107046(VarCurr,3)
    <=> v107062(VarCurr) ) ).

tff(addAssignment_64271,axiom,
    ! [VarCurr: state_type] :
      ( v107046(VarCurr,4)
    <=> v107048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10678,axiom,
    ! [VarCurr: state_type] :
      ( v107070(VarCurr)
    <=> ( v107071(VarCurr)
        & v107073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10677,axiom,
    ! [VarCurr: state_type] :
      ( v107073(VarCurr)
    <=> ( v106987(VarCurr,0)
        | v107057(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4306,axiom,
    ! [VarCurr: state_type] :
      ( v107071(VarCurr)
    <=> ( v107072(VarCurr)
        | v106987(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107072(VarCurr)
    <=> v106987(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10676,axiom,
    ! [VarCurr: state_type] :
      ( v107066(VarCurr)
    <=> ( v107067(VarCurr)
        & v107069(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10675,axiom,
    ! [VarCurr: state_type] :
      ( v107069(VarCurr)
    <=> ( v107055(VarCurr)
        | v107058(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4305,axiom,
    ! [VarCurr: state_type] :
      ( v107067(VarCurr)
    <=> ( v107068(VarCurr)
        | v106987(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107068(VarCurr)
    <=> v107055(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10674,axiom,
    ! [VarCurr: state_type] :
      ( v107062(VarCurr)
    <=> ( v107063(VarCurr)
        & v107065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10673,axiom,
    ! [VarCurr: state_type] :
      ( v107065(VarCurr)
    <=> ( v107053(VarCurr)
        | v107059(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4304,axiom,
    ! [VarCurr: state_type] :
      ( v107063(VarCurr)
    <=> ( v107064(VarCurr)
        | v106987(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107064(VarCurr)
    <=> v107053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10672,axiom,
    ! [VarCurr: state_type] :
      ( v107048(VarCurr)
    <=> ( v107049(VarCurr)
        & v107060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10671,axiom,
    ! [VarCurr: state_type] :
      ( v107060(VarCurr)
    <=> ( v107051(VarCurr)
        | v107061(VarCurr) ) ) ).

tff(writeUnaryOperator_5609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107061(VarCurr)
    <=> v106987(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4303,axiom,
    ! [VarCurr: state_type] :
      ( v107049(VarCurr)
    <=> ( v107050(VarCurr)
        | v106987(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107050(VarCurr)
    <=> v107051(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4302,axiom,
    ! [VarCurr: state_type] :
      ( v107051(VarCurr)
    <=> ( v106987(VarCurr,3)
        | v107052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10670,axiom,
    ! [VarCurr: state_type] :
      ( v107052(VarCurr)
    <=> ( v107053(VarCurr)
        & v107059(VarCurr) ) ) ).

tff(writeUnaryOperator_5607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107059(VarCurr)
    <=> v106987(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4301,axiom,
    ! [VarCurr: state_type] :
      ( v107053(VarCurr)
    <=> ( v106987(VarCurr,2)
        | v107054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10669,axiom,
    ! [VarCurr: state_type] :
      ( v107054(VarCurr)
    <=> ( v107055(VarCurr)
        & v107058(VarCurr) ) ) ).

tff(writeUnaryOperator_5606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107058(VarCurr)
    <=> v106987(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4300,axiom,
    ! [VarCurr: state_type] :
      ( v107055(VarCurr)
    <=> ( v106987(VarCurr,1)
        | v107056(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10668,axiom,
    ! [VarCurr: state_type] :
      ( v107056(VarCurr)
    <=> ( v106987(VarCurr,0)
        & v107057(VarCurr) ) ) ).

tff(writeUnaryOperator_5605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107057(VarCurr)
    <=> v106987(VarCurr,1) ) ).

tff(addAssignment_64270,axiom,
    ! [VarCurr: state_type] :
      ( v107017(VarCurr,0)
    <=> v107043(VarCurr) ) ).

tff(addAssignment_64269,axiom,
    ! [VarCurr: state_type] :
      ( v107017(VarCurr,1)
    <=> v107041(VarCurr) ) ).

tff(addAssignment_64268,axiom,
    ! [VarCurr: state_type] :
      ( v107017(VarCurr,2)
    <=> v107037(VarCurr) ) ).

tff(addAssignment_64267,axiom,
    ! [VarCurr: state_type] :
      ( v107017(VarCurr,3)
    <=> v107033(VarCurr) ) ).

tff(addAssignment_64266,axiom,
    ! [VarCurr: state_type] :
      ( v107017(VarCurr,4)
    <=> v107019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10667,axiom,
    ! [VarCurr: state_type] :
      ( v107041(VarCurr)
    <=> ( v107042(VarCurr)
        & v107044(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10666,axiom,
    ! [VarCurr: state_type] :
      ( v107044(VarCurr)
    <=> ( v107013(VarCurr,0)
        | v107028(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4299,axiom,
    ! [VarCurr: state_type] :
      ( v107042(VarCurr)
    <=> ( v107043(VarCurr)
        | v107013(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107043(VarCurr)
    <=> v107013(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10665,axiom,
    ! [VarCurr: state_type] :
      ( v107037(VarCurr)
    <=> ( v107038(VarCurr)
        & v107040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10664,axiom,
    ! [VarCurr: state_type] :
      ( v107040(VarCurr)
    <=> ( v107026(VarCurr)
        | v107029(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4298,axiom,
    ! [VarCurr: state_type] :
      ( v107038(VarCurr)
    <=> ( v107039(VarCurr)
        | v107013(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107039(VarCurr)
    <=> v107026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10663,axiom,
    ! [VarCurr: state_type] :
      ( v107033(VarCurr)
    <=> ( v107034(VarCurr)
        & v107036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10662,axiom,
    ! [VarCurr: state_type] :
      ( v107036(VarCurr)
    <=> ( v107024(VarCurr)
        | v107030(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4297,axiom,
    ! [VarCurr: state_type] :
      ( v107034(VarCurr)
    <=> ( v107035(VarCurr)
        | v107013(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107035(VarCurr)
    <=> v107024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10661,axiom,
    ! [VarCurr: state_type] :
      ( v107019(VarCurr)
    <=> ( v107020(VarCurr)
        & v107031(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10660,axiom,
    ! [VarCurr: state_type] :
      ( v107031(VarCurr)
    <=> ( v107022(VarCurr)
        | v107032(VarCurr) ) ) ).

tff(writeUnaryOperator_5601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107032(VarCurr)
    <=> v107013(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4296,axiom,
    ! [VarCurr: state_type] :
      ( v107020(VarCurr)
    <=> ( v107021(VarCurr)
        | v107013(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107021(VarCurr)
    <=> v107022(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4295,axiom,
    ! [VarCurr: state_type] :
      ( v107022(VarCurr)
    <=> ( v107013(VarCurr,3)
        | v107023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10659,axiom,
    ! [VarCurr: state_type] :
      ( v107023(VarCurr)
    <=> ( v107024(VarCurr)
        & v107030(VarCurr) ) ) ).

tff(writeUnaryOperator_5599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107030(VarCurr)
    <=> v107013(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4294,axiom,
    ! [VarCurr: state_type] :
      ( v107024(VarCurr)
    <=> ( v107013(VarCurr,2)
        | v107025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10658,axiom,
    ! [VarCurr: state_type] :
      ( v107025(VarCurr)
    <=> ( v107026(VarCurr)
        & v107029(VarCurr) ) ) ).

tff(writeUnaryOperator_5598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107029(VarCurr)
    <=> v107013(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4293,axiom,
    ! [VarCurr: state_type] :
      ( v107026(VarCurr)
    <=> ( v107013(VarCurr,1)
        | v107027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10657,axiom,
    ! [VarCurr: state_type] :
      ( v107027(VarCurr)
    <=> ( v107013(VarCurr,0)
        & v107028(VarCurr) ) ) ).

tff(writeUnaryOperator_5597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v107028(VarCurr)
    <=> v107013(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10656,axiom,
    ! [VarCurr: state_type] :
      ( v107015(VarCurr)
    <=> ( v107016(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10655,axiom,
    ! [VarCurr: state_type] :
      ( v107016(VarCurr)
    <=> ( v106985(VarCurr)
        & v107009(VarCurr) ) ) ).

tff(addAssignment_64265,axiom,
    ! [VarCurr: state_type] :
      ( v107013(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_64264,axiom,
    ! [VarCurr: state_type] :
      ( v107013(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_64263,axiom,
    ! [VarCurr: state_type] :
      ( v107013(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_64262,axiom,
    ! [VarCurr: state_type] :
      ( v107013(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_64261,axiom,
    ! [VarCurr: state_type] :
      ( v107013(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10654,axiom,
    ! [VarCurr: state_type] :
      ( v107009(VarCurr)
    <=> ( v107011(VarCurr)
        | v106806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10653,axiom,
    ! [VarCurr: state_type] :
      ( v107011(VarCurr)
    <=> ( v106688(VarCurr)
        | v106799(VarCurr) ) ) ).

tff(addAssignment_64260,axiom,
    ! [VarCurr: state_type] :
      ( v106997(VarCurr)
    <=> v106999(VarCurr) ) ).

tff(addAssignment_64259,axiom,
    ! [VarCurr: state_type] :
      ( v106999(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64258,axiom,
    ! [VarCurr: state_type] :
      ( v106993(VarCurr)
    <=> v106995(VarCurr) ) ).

tff(addAssignment_64257,axiom,
    ! [VarCurr: state_type] :
      ( v106995(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_64256,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,5)
    <=> v106882(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_783,axiom,
    ! [VarCurr: state_type] :
      ( v106882(VarCurr)
    <=> ( ( v106884(VarCurr,3)
        <=> $false )
        & ( v106884(VarCurr,2)
        <=> $false )
        & ( v106884(VarCurr,1)
        <=> $false )
        & ( v106884(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106884(VarCurr,B)
      <=> v106886(VarCurr,B) ) ) ).

tff(addAssignment_64254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106886(VarCurr,B)
      <=> v106888(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106965(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v106888(VarNext,B)
            <=> v106888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1292,axiom,
    ! [VarNext: state_type] :
      ( v106965(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106888(VarNext,B)
          <=> v106975(VarNext,B) ) ) ) ).

tff(addAssignment_64253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106975(VarNext,B)
          <=> v106973(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106976(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106973(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_858,axiom,
    ! [VarCurr: state_type] :
      ( v106976(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106973(VarCurr,B)
          <=> v106898(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10652,axiom,
    ! [VarCurr: state_type] :
      ( v106976(VarCurr)
    <=> ( v106977(VarCurr)
        & v106978(VarCurr) ) ) ).

tff(writeUnaryOperator_5596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106978(VarCurr)
    <=> v106894(VarCurr) ) ).

tff(writeUnaryOperator_5595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106977(VarCurr)
    <=> v106890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106965(VarNext)
      <=> v106966(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106966(VarNext)
      <=> ( v106967(VarNext)
          & v106960(VarNext) ) ) ) ).

tff(writeUnaryOperator_5594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106967(VarNext)
      <=> v106969(VarNext) ) ) ).

tff(addAssignment_64252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106969(VarNext)
      <=> v106960(VarCurr) ) ) ).

tff(addAssignment_64251,axiom,
    ! [VarCurr: state_type] :
      ( v106960(VarCurr)
    <=> v106962(VarCurr) ) ).

tff(addAssignment_64250,axiom,
    ! [VarCurr: state_type] :
      ( v106962(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106898(VarCurr,B)
      <=> v106900(VarCurr,B) ) ) ).

tff(addAssignment_64248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106900(VarCurr,B)
      <=> v106902(VarCurr,B) ) ) ).

tff(addAssignment_64247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106902(VarCurr,B)
      <=> v106904(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106911(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106904(VarCurr,B)
          <=> v106933(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_857,axiom,
    ! [VarCurr: state_type] :
      ( v106911(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106904(VarCurr,B)
          <=> v106912(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106934(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106933(VarCurr,B)
          <=> v106935(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_856,axiom,
    ! [VarCurr: state_type] :
      ( v106934(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106933(VarCurr,B)
          <=> v106909(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106935(VarCurr,B)
          <=> v106937(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_855,axiom,
    ! [VarCurr: state_type] :
      ( v106936(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106935(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106937(VarCurr,B)
          <=> v106884(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_854,axiom,
    ! [VarCurr: state_type] :
      ( v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106937(VarCurr,B)
          <=> v106938(VarCurr,B) ) ) ) ).

tff(addAssignment_64246,axiom,
    ! [VarCurr: state_type] :
      ( v106938(VarCurr,0)
    <=> v106957(VarCurr) ) ).

tff(addAssignment_64245,axiom,
    ! [VarCurr: state_type] :
      ( v106938(VarCurr,1)
    <=> v106955(VarCurr) ) ).

tff(addAssignment_64244,axiom,
    ! [VarCurr: state_type] :
      ( v106938(VarCurr,2)
    <=> v106951(VarCurr) ) ).

tff(addAssignment_64243,axiom,
    ! [VarCurr: state_type] :
      ( v106938(VarCurr,3)
    <=> v106940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10649,axiom,
    ! [VarCurr: state_type] :
      ( v106955(VarCurr)
    <=> ( v106956(VarCurr)
        & v106958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10648,axiom,
    ! [VarCurr: state_type] :
      ( v106958(VarCurr)
    <=> ( v106884(VarCurr,0)
        | v106947(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4292,axiom,
    ! [VarCurr: state_type] :
      ( v106956(VarCurr)
    <=> ( v106957(VarCurr)
        | v106884(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106957(VarCurr)
    <=> v106884(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10647,axiom,
    ! [VarCurr: state_type] :
      ( v106951(VarCurr)
    <=> ( v106952(VarCurr)
        & v106954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10646,axiom,
    ! [VarCurr: state_type] :
      ( v106954(VarCurr)
    <=> ( v106945(VarCurr)
        | v106948(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4291,axiom,
    ! [VarCurr: state_type] :
      ( v106952(VarCurr)
    <=> ( v106953(VarCurr)
        | v106884(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106953(VarCurr)
    <=> v106945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10645,axiom,
    ! [VarCurr: state_type] :
      ( v106940(VarCurr)
    <=> ( v106941(VarCurr)
        & v106949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10644,axiom,
    ! [VarCurr: state_type] :
      ( v106949(VarCurr)
    <=> ( v106943(VarCurr)
        | v106950(VarCurr) ) ) ).

tff(writeUnaryOperator_5591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106950(VarCurr)
    <=> v106884(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4290,axiom,
    ! [VarCurr: state_type] :
      ( v106941(VarCurr)
    <=> ( v106942(VarCurr)
        | v106884(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106942(VarCurr)
    <=> v106943(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4289,axiom,
    ! [VarCurr: state_type] :
      ( v106943(VarCurr)
    <=> ( v106884(VarCurr,2)
        | v106944(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10643,axiom,
    ! [VarCurr: state_type] :
      ( v106944(VarCurr)
    <=> ( v106945(VarCurr)
        & v106948(VarCurr) ) ) ).

tff(writeUnaryOperator_5589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106948(VarCurr)
    <=> v106884(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4288,axiom,
    ! [VarCurr: state_type] :
      ( v106945(VarCurr)
    <=> ( v106884(VarCurr,1)
        | v106946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10642,axiom,
    ! [VarCurr: state_type] :
      ( v106946(VarCurr)
    <=> ( v106884(VarCurr,0)
        & v106947(VarCurr) ) ) ).

tff(writeUnaryOperator_5588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106947(VarCurr)
    <=> v106884(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_782,axiom,
    ! [VarCurr: state_type] :
      ( v106936(VarCurr)
    <=> ( ( v106884(VarCurr,3)
        <=> $false )
        & ( v106884(VarCurr,2)
        <=> $false )
        & ( v106884(VarCurr,1)
        <=> $false )
        & ( v106884(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10641,axiom,
    ! [VarCurr: state_type] :
      ( v106934(VarCurr)
    <=> ( v106806(VarCurr)
        & v106882(VarCurr) ) ) ).

tff(addAssignment_64242,axiom,
    ! [VarCurr: state_type] :
      ( v106912(VarCurr,0)
    <=> v106931(VarCurr) ) ).

tff(addAssignment_64241,axiom,
    ! [VarCurr: state_type] :
      ( v106912(VarCurr,1)
    <=> v106929(VarCurr) ) ).

tff(addAssignment_64240,axiom,
    ! [VarCurr: state_type] :
      ( v106912(VarCurr,2)
    <=> v106925(VarCurr) ) ).

tff(addAssignment_64239,axiom,
    ! [VarCurr: state_type] :
      ( v106912(VarCurr,3)
    <=> v106914(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10640,axiom,
    ! [VarCurr: state_type] :
      ( v106929(VarCurr)
    <=> ( v106930(VarCurr)
        & v106932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10639,axiom,
    ! [VarCurr: state_type] :
      ( v106932(VarCurr)
    <=> ( v106909(VarCurr,0)
        | v106921(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4287,axiom,
    ! [VarCurr: state_type] :
      ( v106930(VarCurr)
    <=> ( v106931(VarCurr)
        | v106909(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106931(VarCurr)
    <=> v106909(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10638,axiom,
    ! [VarCurr: state_type] :
      ( v106925(VarCurr)
    <=> ( v106926(VarCurr)
        & v106928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10637,axiom,
    ! [VarCurr: state_type] :
      ( v106928(VarCurr)
    <=> ( v106919(VarCurr)
        | v106922(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4286,axiom,
    ! [VarCurr: state_type] :
      ( v106926(VarCurr)
    <=> ( v106927(VarCurr)
        | v106909(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106927(VarCurr)
    <=> v106919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10636,axiom,
    ! [VarCurr: state_type] :
      ( v106914(VarCurr)
    <=> ( v106915(VarCurr)
        & v106923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10635,axiom,
    ! [VarCurr: state_type] :
      ( v106923(VarCurr)
    <=> ( v106917(VarCurr)
        | v106924(VarCurr) ) ) ).

tff(writeUnaryOperator_5585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106924(VarCurr)
    <=> v106909(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4285,axiom,
    ! [VarCurr: state_type] :
      ( v106915(VarCurr)
    <=> ( v106916(VarCurr)
        | v106909(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106916(VarCurr)
    <=> v106917(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4284,axiom,
    ! [VarCurr: state_type] :
      ( v106917(VarCurr)
    <=> ( v106909(VarCurr,2)
        | v106918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10634,axiom,
    ! [VarCurr: state_type] :
      ( v106918(VarCurr)
    <=> ( v106919(VarCurr)
        & v106922(VarCurr) ) ) ).

tff(writeUnaryOperator_5583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106922(VarCurr)
    <=> v106909(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4283,axiom,
    ! [VarCurr: state_type] :
      ( v106919(VarCurr)
    <=> ( v106909(VarCurr,1)
        | v106920(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10633,axiom,
    ! [VarCurr: state_type] :
      ( v106920(VarCurr)
    <=> ( v106909(VarCurr,0)
        & v106921(VarCurr) ) ) ).

tff(writeUnaryOperator_5582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106921(VarCurr)
    <=> v106909(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10632,axiom,
    ! [VarCurr: state_type] :
      ( v106911(VarCurr)
    <=> ( v106906(VarCurr)
        & v106882(VarCurr) ) ) ).

tff(addAssignment_64238,axiom,
    ! [VarCurr: state_type] :
      ( v106909(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_64237,axiom,
    ! [VarCurr: state_type] :
      ( v106909(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_64236,axiom,
    ! [VarCurr: state_type] :
      ( v106909(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_64235,axiom,
    ! [VarCurr: state_type] :
      ( v106909(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10631,axiom,
    ! [VarCurr: state_type] :
      ( v106906(VarCurr)
    <=> ( v106688(VarCurr)
        | v106799(VarCurr) ) ) ).

tff(addAssignment_64234,axiom,
    ! [VarCurr: state_type] :
      ( v106894(VarCurr)
    <=> v106896(VarCurr) ) ).

tff(addAssignment_64233,axiom,
    ! [VarCurr: state_type] :
      ( v106896(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64232,axiom,
    ! [VarCurr: state_type] :
      ( v106890(VarCurr)
    <=> v106892(VarCurr) ) ).

tff(addAssignment_64231,axiom,
    ! [VarCurr: state_type] :
      ( v106892(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_64230,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,5)
    <=> v106755(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_781,axiom,
    ! [VarCurr: state_type] :
      ( v106755(VarCurr)
    <=> ( ( v106757(VarCurr,1)
        <=> $false )
        & ( v106757(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106757(VarCurr,B)
      <=> v106759(VarCurr,B) ) ) ).

tff(addAssignment_64228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106759(VarCurr,B)
      <=> v106761(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106864(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v106761(VarNext,B)
            <=> v106761(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1291,axiom,
    ! [VarNext: state_type] :
      ( v106864(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106761(VarNext,B)
          <=> v106874(VarNext,B) ) ) ) ).

tff(addAssignment_64227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106874(VarNext,B)
          <=> v106872(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106872(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_853,axiom,
    ! [VarCurr: state_type] :
      ( v106875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106872(VarCurr,B)
          <=> v106771(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10630,axiom,
    ! [VarCurr: state_type] :
      ( v106875(VarCurr)
    <=> ( v106876(VarCurr)
        & v106877(VarCurr) ) ) ).

tff(writeUnaryOperator_5581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106877(VarCurr)
    <=> v106767(VarCurr) ) ).

tff(writeUnaryOperator_5580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106876(VarCurr)
    <=> v106763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106864(VarNext)
      <=> v106865(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106865(VarNext)
      <=> ( v106866(VarNext)
          & v106859(VarNext) ) ) ) ).

tff(writeUnaryOperator_5579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106866(VarNext)
      <=> v106868(VarNext) ) ) ).

tff(addAssignment_64226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106868(VarNext)
      <=> v106859(VarCurr) ) ) ).

tff(addAssignment_64225,axiom,
    ! [VarCurr: state_type] :
      ( v106859(VarCurr)
    <=> v106861(VarCurr) ) ).

tff(addAssignment_64224,axiom,
    ! [VarCurr: state_type] :
      ( v106861(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106771(VarCurr,B)
      <=> v106773(VarCurr,B) ) ) ).

tff(addAssignment_64222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106773(VarCurr,B)
      <=> v106775(VarCurr,B) ) ) ).

tff(addAssignment_64221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106775(VarCurr,B)
      <=> v106777(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106846(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106777(VarCurr,B)
          <=> v106847(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_852,axiom,
    ! [VarCurr: state_type] :
      ( v106846(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106777(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106848(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106847(VarCurr,B)
          <=> v106849(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_851,axiom,
    ! [VarCurr: state_type] :
      ( v106848(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106847(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106850(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106849(VarCurr,B)
          <=> v106851(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_850,axiom,
    ! [VarCurr: state_type] :
      ( v106850(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106849(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64220,axiom,
    ! [VarCurr: state_type] :
      ( v106851(VarCurr,0)
    <=> v106855(VarCurr) ) ).

tff(addAssignment_64219,axiom,
    ! [VarCurr: state_type] :
      ( v106851(VarCurr,1)
    <=> v106853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10627,axiom,
    ! [VarCurr: state_type] :
      ( v106853(VarCurr)
    <=> ( v106854(VarCurr)
        & v106856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10626,axiom,
    ! [VarCurr: state_type] :
      ( v106856(VarCurr)
    <=> ( v106757(VarCurr,0)
        | v106857(VarCurr) ) ) ).

tff(writeUnaryOperator_5578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106857(VarCurr)
    <=> v106757(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4282,axiom,
    ! [VarCurr: state_type] :
      ( v106854(VarCurr)
    <=> ( v106855(VarCurr)
        | v106757(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106855(VarCurr)
    <=> v106757(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_780,axiom,
    ! [VarCurr: state_type] :
      ( v106850(VarCurr)
    <=> ( ( v106757(VarCurr,1)
        <=> $false )
        & ( v106757(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10625,axiom,
    ! [VarCurr: state_type] :
      ( v106848(VarCurr)
    <=> ( v106830(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10624,axiom,
    ! [VarCurr: state_type] :
      ( v106846(VarCurr)
    <=> ( v106779(VarCurr)
        & v106703(VarCurr) ) ) ).

tff(addAssignment_64218,axiom,
    ! [VarCurr: state_type] :
      ( v106830(VarCurr)
    <=> v106781(VarCurr,0) ) ).

tff(addAssignment_64217,axiom,
    ! [VarCurr: state_type] :
      ( v106781(VarCurr,0)
    <=> v106783(VarCurr,0) ) ).

tff(addAssignment_64216,axiom,
    ! [VarNext: state_type] :
      ( v106783(VarNext,0)
    <=> v106838(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106839(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v106838(VarNext,B)
            <=> v106783(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1290,axiom,
    ! [VarNext: state_type] :
      ( v106839(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106838(VarNext,B)
          <=> v106823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106839(VarNext)
      <=> v106840(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106840(VarNext)
      <=> ( v106842(VarNext)
          & v106808(VarNext) ) ) ) ).

tff(writeUnaryOperator_5576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106842(VarNext)
      <=> v106817(VarNext) ) ) ).

tff(addAssignment_64215,axiom,
    ! [VarCurr: state_type] :
      ( v106793(VarCurr,0)
    <=> v106795(VarCurr,0) ) ).

tff(addAssignment_64214,axiom,
    ! [VarCurr: state_type] :
      ( v106795(VarCurr,0)
    <=> v106797(VarCurr,0) ) ).

tff(addAssignment_64213,axiom,
    ! [VarCurr: state_type] :
      ( v106797(VarCurr,0)
    <=> v106805(VarCurr,0) ) ).

tff(addAssignment_64212,axiom,
    ! [VarCurr: state_type] :
      ( v106806(VarCurr)
    <=> v103094(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4281,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,5)
    <=> ( v106833(VarCurr)
        | v106835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10621,axiom,
    ! [VarCurr: state_type] :
      ( v106835(VarCurr)
    <=> ( v103113(VarCurr)
        & v106836(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_779,axiom,
    ! [VarCurr: state_type] :
      ( v106836(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $true )
        & ( v103127(VarCurr,5)
        <=> $false )
        & ( v103127(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10620,axiom,
    ! [VarCurr: state_type] :
      ( v106833(VarCurr)
    <=> ( v103096(VarCurr)
        & v106834(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_778,axiom,
    ! [VarCurr: state_type] :
      ( v106834(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $true )
        & ( v103106(VarCurr,5)
        <=> $false )
        & ( v103106(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64211,axiom,
    ! [VarCurr: state_type] :
      ( v106779(VarCurr)
    <=> v106781(VarCurr,1) ) ).

tff(addAssignment_64210,axiom,
    ! [VarCurr: state_type] :
      ( v106781(VarCurr,1)
    <=> v106783(VarCurr,1) ) ).

tff(addAssignment_64209,axiom,
    ! [VarNext: state_type] :
      ( v106783(VarNext,1)
    <=> v106812(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106813(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v106812(VarNext,B)
            <=> v106783(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1289,axiom,
    ! [VarNext: state_type] :
      ( v106813(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106812(VarNext,B)
          <=> v106823(VarNext,B) ) ) ) ).

tff(addAssignment_64208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106823(VarNext,B)
          <=> v106821(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106821(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_849,axiom,
    ! [VarCurr: state_type] :
      ( v106824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106821(VarCurr,B)
          <=> v106793(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10619,axiom,
    ! [VarCurr: state_type] :
      ( v106824(VarCurr)
    <=> ( v106825(VarCurr)
        & v106826(VarCurr) ) ) ).

tff(writeUnaryOperator_5575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106826(VarCurr)
    <=> v106789(VarCurr) ) ).

tff(writeUnaryOperator_5574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106825(VarCurr)
    <=> v106785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106813(VarNext)
      <=> v106814(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106814(VarNext)
      <=> ( v106815(VarNext)
          & v106808(VarNext) ) ) ) ).

tff(writeUnaryOperator_5573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106815(VarNext)
      <=> v106817(VarNext) ) ) ).

tff(addAssignment_64207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106817(VarNext)
      <=> v106808(VarCurr) ) ) ).

tff(addAssignment_64206,axiom,
    ! [VarCurr: state_type] :
      ( v106808(VarCurr)
    <=> v106810(VarCurr) ) ).

tff(addAssignment_64205,axiom,
    ! [VarCurr: state_type] :
      ( v106810(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64204,axiom,
    ! [VarCurr: state_type] :
      ( v106793(VarCurr,1)
    <=> v106795(VarCurr,1) ) ).

tff(addAssignment_64203,axiom,
    ! [VarCurr: state_type] :
      ( v106795(VarCurr,1)
    <=> v106797(VarCurr,1) ) ).

tff(addAssignment_64202,axiom,
    ! [VarCurr: state_type] :
      ( v106797(VarCurr,1)
    <=> v106805(VarCurr,1) ) ).

tff(addAssignment_64201,axiom,
    ! [VarCurr: state_type] :
      ( v106805(VarCurr,0)
    <=> v106806(VarCurr) ) ).

tff(addAssignment_64200,axiom,
    ! [VarCurr: state_type] :
      ( v106805(VarCurr,1)
    <=> v106799(VarCurr) ) ).

tff(addAssignment_64199,axiom,
    ! [VarCurr: state_type] :
      ( v106805(VarCurr,2)
    <=> v106688(VarCurr) ) ).

tff(addAssignment_64198,axiom,
    ! [VarCurr: state_type] :
      ( v106799(VarCurr)
    <=> v101499(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4280,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,5)
    <=> ( v106801(VarCurr)
        | v106803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10616,axiom,
    ! [VarCurr: state_type] :
      ( v106803(VarCurr)
    <=> ( v83096(VarCurr)
        & v106804(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_777,axiom,
    ! [VarCurr: state_type] :
      ( v106804(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10615,axiom,
    ! [VarCurr: state_type] :
      ( v106801(VarCurr)
    <=> ( v101501(VarCurr)
        & v106802(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_776,axiom,
    ! [VarCurr: state_type] :
      ( v106802(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $true )
        & ( v101563(VarCurr,5)
        <=> $false )
        & ( v101563(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64197,axiom,
    ! [VarCurr: state_type] :
      ( v106789(VarCurr)
    <=> v106791(VarCurr) ) ).

tff(addAssignment_64196,axiom,
    ! [VarCurr: state_type] :
      ( v106791(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64195,axiom,
    ! [VarCurr: state_type] :
      ( v106785(VarCurr)
    <=> v106787(VarCurr) ) ).

tff(addAssignment_64194,axiom,
    ! [VarCurr: state_type] :
      ( v106787(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_64193,axiom,
    ! [VarCurr: state_type] :
      ( v106767(VarCurr)
    <=> v106769(VarCurr) ) ).

tff(addAssignment_64192,axiom,
    ! [VarCurr: state_type] :
      ( v106769(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64191,axiom,
    ! [VarCurr: state_type] :
      ( v106763(VarCurr)
    <=> v106765(VarCurr) ) ).

tff(addAssignment_64190,axiom,
    ! [VarCurr: state_type] :
      ( v106765(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_64189,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,5)
    <=> v106656(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_775,axiom,
    ! [VarCurr: state_type] :
      ( v106656(VarCurr)
    <=> ( ( v106658(VarCurr,3)
        <=> $false )
        & ( v106658(VarCurr,2)
        <=> $false )
        & ( v106658(VarCurr,1)
        <=> $false )
        & ( v106658(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106658(VarCurr,B)
      <=> v106660(VarCurr,B) ) ) ).

tff(addAssignment_64187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106660(VarCurr,B)
      <=> v106662(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106737(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v106662(VarNext,B)
            <=> v106662(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1288,axiom,
    ! [VarNext: state_type] :
      ( v106737(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106662(VarNext,B)
          <=> v106747(VarNext,B) ) ) ) ).

tff(addAssignment_64186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106747(VarNext,B)
          <=> v106745(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106748(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106745(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_848,axiom,
    ! [VarCurr: state_type] :
      ( v106748(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106745(VarCurr,B)
          <=> v106680(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10614,axiom,
    ! [VarCurr: state_type] :
      ( v106748(VarCurr)
    <=> ( v106749(VarCurr)
        & v106750(VarCurr) ) ) ).

tff(writeUnaryOperator_5572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106750(VarCurr)
    <=> v106672(VarCurr) ) ).

tff(writeUnaryOperator_5571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106749(VarCurr)
    <=> v106664(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106737(VarNext)
      <=> v106738(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106738(VarNext)
      <=> ( v106739(VarNext)
          & v106730(VarNext) ) ) ) ).

tff(writeUnaryOperator_5570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106739(VarNext)
      <=> v106741(VarNext) ) ) ).

tff(addAssignment_64185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106741(VarNext)
      <=> v106730(VarCurr) ) ) ).

tff(addAssignment_64184,axiom,
    ! [VarCurr: state_type] :
      ( v106730(VarCurr)
    <=> v106732(VarCurr) ) ).

tff(addAssignment_64183,axiom,
    ! [VarCurr: state_type] :
      ( v106732(VarCurr)
    <=> v106734(VarCurr) ) ).

tff(addAssignment_64182,axiom,
    ! [VarCurr: state_type] :
      ( v106734(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_64181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106680(VarCurr,B)
      <=> v106682(VarCurr,B) ) ) ).

tff(addAssignment_64180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106682(VarCurr,B)
      <=> v106684(VarCurr,B) ) ) ).

tff(addAssignment_64179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106684(VarCurr,B)
      <=> v106686(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106686(VarCurr,B)
          <=> v106705(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_847,axiom,
    ! [VarCurr: state_type] :
      ( v106688(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106686(VarCurr,B)
          <=> v106701(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106705(VarCurr,B)
          <=> v106707(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_846,axiom,
    ! [VarCurr: state_type] :
      ( v106706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106705(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106707(VarCurr,B)
          <=> v106658(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_845,axiom,
    ! [VarCurr: state_type] :
      ( v106703(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106707(VarCurr,B)
          <=> v106708(VarCurr,B) ) ) ) ).

tff(addAssignment_64178,axiom,
    ! [VarCurr: state_type] :
      ( v106708(VarCurr,0)
    <=> v106727(VarCurr) ) ).

tff(addAssignment_64177,axiom,
    ! [VarCurr: state_type] :
      ( v106708(VarCurr,1)
    <=> v106725(VarCurr) ) ).

tff(addAssignment_64176,axiom,
    ! [VarCurr: state_type] :
      ( v106708(VarCurr,2)
    <=> v106721(VarCurr) ) ).

tff(addAssignment_64175,axiom,
    ! [VarCurr: state_type] :
      ( v106708(VarCurr,3)
    <=> v106710(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10611,axiom,
    ! [VarCurr: state_type] :
      ( v106725(VarCurr)
    <=> ( v106726(VarCurr)
        & v106728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10610,axiom,
    ! [VarCurr: state_type] :
      ( v106728(VarCurr)
    <=> ( v106658(VarCurr,0)
        | v106717(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4279,axiom,
    ! [VarCurr: state_type] :
      ( v106726(VarCurr)
    <=> ( v106727(VarCurr)
        | v106658(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106727(VarCurr)
    <=> v106658(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10609,axiom,
    ! [VarCurr: state_type] :
      ( v106721(VarCurr)
    <=> ( v106722(VarCurr)
        & v106724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10608,axiom,
    ! [VarCurr: state_type] :
      ( v106724(VarCurr)
    <=> ( v106715(VarCurr)
        | v106718(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4278,axiom,
    ! [VarCurr: state_type] :
      ( v106722(VarCurr)
    <=> ( v106723(VarCurr)
        | v106658(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106723(VarCurr)
    <=> v106715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10607,axiom,
    ! [VarCurr: state_type] :
      ( v106710(VarCurr)
    <=> ( v106711(VarCurr)
        & v106719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10606,axiom,
    ! [VarCurr: state_type] :
      ( v106719(VarCurr)
    <=> ( v106713(VarCurr)
        | v106720(VarCurr) ) ) ).

tff(writeUnaryOperator_5567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106720(VarCurr)
    <=> v106658(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4277,axiom,
    ! [VarCurr: state_type] :
      ( v106711(VarCurr)
    <=> ( v106712(VarCurr)
        | v106658(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106712(VarCurr)
    <=> v106713(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4276,axiom,
    ! [VarCurr: state_type] :
      ( v106713(VarCurr)
    <=> ( v106658(VarCurr,2)
        | v106714(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10605,axiom,
    ! [VarCurr: state_type] :
      ( v106714(VarCurr)
    <=> ( v106715(VarCurr)
        & v106718(VarCurr) ) ) ).

tff(writeUnaryOperator_5565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106718(VarCurr)
    <=> v106658(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4275,axiom,
    ! [VarCurr: state_type] :
      ( v106715(VarCurr)
    <=> ( v106658(VarCurr,1)
        | v106716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10604,axiom,
    ! [VarCurr: state_type] :
      ( v106716(VarCurr)
    <=> ( v106658(VarCurr,0)
        & v106717(VarCurr) ) ) ).

tff(writeUnaryOperator_5564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106717(VarCurr)
    <=> v106658(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_774,axiom,
    ! [VarCurr: state_type] :
      ( v106706(VarCurr)
    <=> ( ( v106658(VarCurr,3)
        <=> $false )
        & ( v106658(VarCurr,2)
        <=> $false )
        & ( v106658(VarCurr,1)
        <=> $false )
        & ( v106658(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64174,axiom,
    ! [VarCurr: state_type] :
      ( v106703(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_64173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106701(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_64172,axiom,
    ! [VarCurr: state_type] :
      ( v106688(VarCurr)
    <=> v89212(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_4274,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,5)
    <=> ( v106690(VarCurr)
        | v106698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10603,axiom,
    ! [VarCurr: state_type] :
      ( v106698(VarCurr)
    <=> ( v82954(VarCurr)
        & v106699(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_773,axiom,
    ! [VarCurr: state_type] :
      ( v106699(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10602,axiom,
    ! [VarCurr: state_type] :
      ( v106690(VarCurr)
    <=> ( v106691(VarCurr)
        | v106696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10601,axiom,
    ! [VarCurr: state_type] :
      ( v106696(VarCurr)
    <=> ( v86877(VarCurr)
        & v106697(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_772,axiom,
    ! [VarCurr: state_type] :
      ( v106697(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10600,axiom,
    ! [VarCurr: state_type] :
      ( v106691(VarCurr)
    <=> ( v106692(VarCurr)
        | v106694(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10599,axiom,
    ! [VarCurr: state_type] :
      ( v106694(VarCurr)
    <=> ( v84899(VarCurr)
        & v106695(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_771,axiom,
    ! [VarCurr: state_type] :
      ( v106695(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $true )
        & ( v89243(VarCurr,5)
        <=> $false )
        & ( v89243(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10598,axiom,
    ! [VarCurr: state_type] :
      ( v106692(VarCurr)
    <=> ( v118(VarCurr)
        & v106693(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_770,axiom,
    ! [VarCurr: state_type] :
      ( v106693(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $true )
        & ( v89214(VarCurr,5)
        <=> $false )
        & ( v89214(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_64171,axiom,
    ! [VarCurr: state_type] :
      ( v106672(VarCurr)
    <=> v106674(VarCurr) ) ).

tff(addAssignment_64170,axiom,
    ! [VarCurr: state_type] :
      ( v106674(VarCurr)
    <=> v106676(VarCurr) ) ).

tff(addAssignment_64169,axiom,
    ! [VarCurr: state_type] :
      ( v106676(VarCurr)
    <=> v106678(VarCurr) ) ).

tff(addAssignment_64168,axiom,
    ! [VarCurr: state_type] :
      ( v106678(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_64167,axiom,
    ! [VarCurr: state_type] :
      ( v106664(VarCurr)
    <=> v106666(VarCurr) ) ).

tff(addAssignment_64166,axiom,
    ! [VarCurr: state_type] :
      ( v106666(VarCurr)
    <=> v106668(VarCurr) ) ).

tff(addAssignment_64165,axiom,
    ! [VarCurr: state_type] :
      ( v106668(VarCurr)
    <=> v106670(VarCurr) ) ).

tff(addAssignment_64164,axiom,
    ! [VarCurr: state_type] :
      ( v106670(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_64163,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,4)
    <=> v106282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10597,axiom,
    ! [VarCurr: state_type] :
      ( v106282(VarCurr)
    <=> ( v106649(VarCurr)
        & v106654(VarCurr) ) ) ).

tff(writeUnaryOperator_5563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106654(VarCurr)
    <=> v106563(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10596,axiom,
    ! [VarCurr: state_type] :
      ( v106649(VarCurr)
    <=> ( v106650(VarCurr)
        & v106653(VarCurr) ) ) ).

tff(writeUnaryOperator_5562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106653(VarCurr)
    <=> v106479(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10595,axiom,
    ! [VarCurr: state_type] :
      ( v106650(VarCurr)
    <=> ( v106651(VarCurr)
        & v106652(VarCurr) ) ) ).

tff(writeUnaryOperator_5561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106652(VarCurr)
    <=> v106397(VarCurr) ) ).

tff(writeUnaryOperator_5560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106651(VarCurr)
    <=> v106284(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_769,axiom,
    ! [VarCurr: state_type] :
      ( v106563(VarCurr)
    <=> ( ( v106565(VarCurr,4)
        <=> $false )
        & ( v106565(VarCurr,3)
        <=> $false )
        & ( v106565(VarCurr,2)
        <=> $false )
        & ( v106565(VarCurr,1)
        <=> $false )
        & ( v106565(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106565(VarCurr,B)
      <=> v106567(VarCurr,B) ) ) ).

tff(addAssignment_64161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106567(VarCurr,B)
      <=> v106569(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106631(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v106569(VarNext,B)
            <=> v106569(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1287,axiom,
    ! [VarNext: state_type] :
      ( v106631(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106569(VarNext,B)
          <=> v106641(VarNext,B) ) ) ) ).

tff(addAssignment_64160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106641(VarNext,B)
          <=> v106639(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106642(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106639(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_844,axiom,
    ! [VarCurr: state_type] :
      ( v106642(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106639(VarCurr,B)
          <=> v106579(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10594,axiom,
    ! [VarCurr: state_type] :
      ( v106642(VarCurr)
    <=> ( v106643(VarCurr)
        & v106644(VarCurr) ) ) ).

tff(writeUnaryOperator_5559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106644(VarCurr)
    <=> v106575(VarCurr) ) ).

tff(writeUnaryOperator_5558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106643(VarCurr)
    <=> v106571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106631(VarNext)
      <=> v106632(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106632(VarNext)
      <=> ( v106633(VarNext)
          & v106626(VarNext) ) ) ) ).

tff(writeUnaryOperator_5557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106633(VarNext)
      <=> v106635(VarNext) ) ) ).

tff(addAssignment_64159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106635(VarNext)
      <=> v106626(VarCurr) ) ) ).

tff(addAssignment_64158,axiom,
    ! [VarCurr: state_type] :
      ( v106626(VarCurr)
    <=> v106628(VarCurr) ) ).

tff(addAssignment_64157,axiom,
    ! [VarCurr: state_type] :
      ( v106628(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106579(VarCurr,B)
      <=> v106581(VarCurr,B) ) ) ).

tff(addAssignment_64155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106581(VarCurr,B)
      <=> v106583(VarCurr,B) ) ) ).

tff(addAssignment_64154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106583(VarCurr,B)
      <=> v106585(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106585(VarCurr,B)
          <=> v106596(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_843,axiom,
    ! [VarCurr: state_type] :
      ( v106587(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106585(VarCurr,B)
          <=> v106595(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106596(VarCurr,B)
          <=> v106597(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_842,axiom,
    ! [VarCurr: state_type] :
      ( v106563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106596(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64153,axiom,
    ! [VarCurr: state_type] :
      ( v106597(VarCurr,0)
    <=> v106623(VarCurr) ) ).

tff(addAssignment_64152,axiom,
    ! [VarCurr: state_type] :
      ( v106597(VarCurr,1)
    <=> v106621(VarCurr) ) ).

tff(addAssignment_64151,axiom,
    ! [VarCurr: state_type] :
      ( v106597(VarCurr,2)
    <=> v106617(VarCurr) ) ).

tff(addAssignment_64150,axiom,
    ! [VarCurr: state_type] :
      ( v106597(VarCurr,3)
    <=> v106613(VarCurr) ) ).

tff(addAssignment_64149,axiom,
    ! [VarCurr: state_type] :
      ( v106597(VarCurr,4)
    <=> v106599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10591,axiom,
    ! [VarCurr: state_type] :
      ( v106621(VarCurr)
    <=> ( v106622(VarCurr)
        & v106624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10590,axiom,
    ! [VarCurr: state_type] :
      ( v106624(VarCurr)
    <=> ( v106565(VarCurr,0)
        | v106608(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4273,axiom,
    ! [VarCurr: state_type] :
      ( v106622(VarCurr)
    <=> ( v106623(VarCurr)
        | v106565(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106623(VarCurr)
    <=> v106565(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10589,axiom,
    ! [VarCurr: state_type] :
      ( v106617(VarCurr)
    <=> ( v106618(VarCurr)
        & v106620(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10588,axiom,
    ! [VarCurr: state_type] :
      ( v106620(VarCurr)
    <=> ( v106606(VarCurr)
        | v106609(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4272,axiom,
    ! [VarCurr: state_type] :
      ( v106618(VarCurr)
    <=> ( v106619(VarCurr)
        | v106565(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106619(VarCurr)
    <=> v106606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10587,axiom,
    ! [VarCurr: state_type] :
      ( v106613(VarCurr)
    <=> ( v106614(VarCurr)
        & v106616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10586,axiom,
    ! [VarCurr: state_type] :
      ( v106616(VarCurr)
    <=> ( v106604(VarCurr)
        | v106610(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4271,axiom,
    ! [VarCurr: state_type] :
      ( v106614(VarCurr)
    <=> ( v106615(VarCurr)
        | v106565(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106615(VarCurr)
    <=> v106604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10585,axiom,
    ! [VarCurr: state_type] :
      ( v106599(VarCurr)
    <=> ( v106600(VarCurr)
        & v106611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10584,axiom,
    ! [VarCurr: state_type] :
      ( v106611(VarCurr)
    <=> ( v106602(VarCurr)
        | v106612(VarCurr) ) ) ).

tff(writeUnaryOperator_5553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106612(VarCurr)
    <=> v106565(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4270,axiom,
    ! [VarCurr: state_type] :
      ( v106600(VarCurr)
    <=> ( v106601(VarCurr)
        | v106565(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106601(VarCurr)
    <=> v106602(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4269,axiom,
    ! [VarCurr: state_type] :
      ( v106602(VarCurr)
    <=> ( v106565(VarCurr,3)
        | v106603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10583,axiom,
    ! [VarCurr: state_type] :
      ( v106603(VarCurr)
    <=> ( v106604(VarCurr)
        & v106610(VarCurr) ) ) ).

tff(writeUnaryOperator_5551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106610(VarCurr)
    <=> v106565(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4268,axiom,
    ! [VarCurr: state_type] :
      ( v106604(VarCurr)
    <=> ( v106565(VarCurr,2)
        | v106605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10582,axiom,
    ! [VarCurr: state_type] :
      ( v106605(VarCurr)
    <=> ( v106606(VarCurr)
        & v106609(VarCurr) ) ) ).

tff(writeUnaryOperator_5550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106609(VarCurr)
    <=> v106565(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4267,axiom,
    ! [VarCurr: state_type] :
      ( v106606(VarCurr)
    <=> ( v106565(VarCurr,1)
        | v106607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10581,axiom,
    ! [VarCurr: state_type] :
      ( v106607(VarCurr)
    <=> ( v106565(VarCurr,0)
        & v106608(VarCurr) ) ) ).

tff(writeUnaryOperator_5549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106608(VarCurr)
    <=> v106565(VarCurr,1) ) ).

tff(addAssignment_64148,axiom,
    ! [VarCurr: state_type] :
      ( v106595(VarCurr,0)
    <=> v106342(VarCurr) ) ).

tff(addAssignment_64147,axiom,
    ! [VarCurr: state_type] :
      ( v106595(VarCurr,1)
    <=> v106340(VarCurr) ) ).

tff(addAssignment_64146,axiom,
    ! [VarCurr: state_type] :
      ( v106595(VarCurr,2)
    <=> v106336(VarCurr) ) ).

tff(addAssignment_64145,axiom,
    ! [VarCurr: state_type] :
      ( v106595(VarCurr,3)
    <=> v106332(VarCurr) ) ).

tff(addAssignment_64144,axiom,
    ! [VarCurr: state_type] :
      ( v106595(VarCurr,4)
    <=> v106318(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10580,axiom,
    ! [VarCurr: state_type] :
      ( v106587(VarCurr)
    <=> ( v106588(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10579,axiom,
    ! [VarCurr: state_type] :
      ( v106588(VarCurr)
    <=> ( v106589(VarCurr)
        & v106308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10578,axiom,
    ! [VarCurr: state_type] :
      ( v106589(VarCurr)
    <=> ( v106590(VarCurr)
        & v106594(VarCurr) ) ) ).

tff(writeUnaryOperator_5548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106594(VarCurr)
    <=> v106284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10577,axiom,
    ! [VarCurr: state_type] :
      ( v106590(VarCurr)
    <=> ( v106591(VarCurr)
        & v106593(VarCurr) ) ) ).

tff(writeUnaryOperator_5547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106593(VarCurr)
    <=> v106397(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10576,axiom,
    ! [VarCurr: state_type] :
      ( v106591(VarCurr)
    <=> ( v106563(VarCurr)
        & v106592(VarCurr) ) ) ).

tff(writeUnaryOperator_5546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106592(VarCurr)
    <=> v106479(VarCurr) ) ).

tff(addAssignment_64143,axiom,
    ! [VarCurr: state_type] :
      ( v106575(VarCurr)
    <=> v106577(VarCurr) ) ).

tff(addAssignment_64142,axiom,
    ! [VarCurr: state_type] :
      ( v106577(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64141,axiom,
    ! [VarCurr: state_type] :
      ( v106571(VarCurr)
    <=> v106573(VarCurr) ) ).

tff(addAssignment_64140,axiom,
    ! [VarCurr: state_type] :
      ( v106573(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_768,axiom,
    ! [VarCurr: state_type] :
      ( v106479(VarCurr)
    <=> ( ( v106481(VarCurr,4)
        <=> $false )
        & ( v106481(VarCurr,3)
        <=> $false )
        & ( v106481(VarCurr,2)
        <=> $false )
        & ( v106481(VarCurr,1)
        <=> $false )
        & ( v106481(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106481(VarCurr,B)
      <=> v106483(VarCurr,B) ) ) ).

tff(addAssignment_64138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106483(VarCurr,B)
      <=> v106485(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v106485(VarNext,B)
            <=> v106485(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1286,axiom,
    ! [VarNext: state_type] :
      ( v106545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106485(VarNext,B)
          <=> v106555(VarNext,B) ) ) ) ).

tff(addAssignment_64137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106555(VarNext,B)
          <=> v106553(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106553(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_841,axiom,
    ! [VarCurr: state_type] :
      ( v106556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106553(VarCurr,B)
          <=> v106495(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10575,axiom,
    ! [VarCurr: state_type] :
      ( v106556(VarCurr)
    <=> ( v106557(VarCurr)
        & v106558(VarCurr) ) ) ).

tff(writeUnaryOperator_5545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106558(VarCurr)
    <=> v106491(VarCurr) ) ).

tff(writeUnaryOperator_5544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106557(VarCurr)
    <=> v106487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106545(VarNext)
      <=> v106546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106546(VarNext)
      <=> ( v106547(VarNext)
          & v106540(VarNext) ) ) ) ).

tff(writeUnaryOperator_5543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106547(VarNext)
      <=> v106549(VarNext) ) ) ).

tff(addAssignment_64136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106549(VarNext)
      <=> v106540(VarCurr) ) ) ).

tff(addAssignment_64135,axiom,
    ! [VarCurr: state_type] :
      ( v106540(VarCurr)
    <=> v106542(VarCurr) ) ).

tff(addAssignment_64134,axiom,
    ! [VarCurr: state_type] :
      ( v106542(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106495(VarCurr,B)
      <=> v106497(VarCurr,B) ) ) ).

tff(addAssignment_64132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106497(VarCurr,B)
      <=> v106499(VarCurr,B) ) ) ).

tff(addAssignment_64131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106499(VarCurr,B)
      <=> v106501(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106503(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106501(VarCurr,B)
          <=> v106510(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_840,axiom,
    ! [VarCurr: state_type] :
      ( v106503(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106501(VarCurr,B)
          <=> v106509(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106479(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106510(VarCurr,B)
          <=> v106511(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_839,axiom,
    ! [VarCurr: state_type] :
      ( v106479(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106510(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64130,axiom,
    ! [VarCurr: state_type] :
      ( v106511(VarCurr,0)
    <=> v106537(VarCurr) ) ).

tff(addAssignment_64129,axiom,
    ! [VarCurr: state_type] :
      ( v106511(VarCurr,1)
    <=> v106535(VarCurr) ) ).

tff(addAssignment_64128,axiom,
    ! [VarCurr: state_type] :
      ( v106511(VarCurr,2)
    <=> v106531(VarCurr) ) ).

tff(addAssignment_64127,axiom,
    ! [VarCurr: state_type] :
      ( v106511(VarCurr,3)
    <=> v106527(VarCurr) ) ).

tff(addAssignment_64126,axiom,
    ! [VarCurr: state_type] :
      ( v106511(VarCurr,4)
    <=> v106513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10572,axiom,
    ! [VarCurr: state_type] :
      ( v106535(VarCurr)
    <=> ( v106536(VarCurr)
        & v106538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10571,axiom,
    ! [VarCurr: state_type] :
      ( v106538(VarCurr)
    <=> ( v106481(VarCurr,0)
        | v106522(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4266,axiom,
    ! [VarCurr: state_type] :
      ( v106536(VarCurr)
    <=> ( v106537(VarCurr)
        | v106481(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106537(VarCurr)
    <=> v106481(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10570,axiom,
    ! [VarCurr: state_type] :
      ( v106531(VarCurr)
    <=> ( v106532(VarCurr)
        & v106534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10569,axiom,
    ! [VarCurr: state_type] :
      ( v106534(VarCurr)
    <=> ( v106520(VarCurr)
        | v106523(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4265,axiom,
    ! [VarCurr: state_type] :
      ( v106532(VarCurr)
    <=> ( v106533(VarCurr)
        | v106481(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106533(VarCurr)
    <=> v106520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10568,axiom,
    ! [VarCurr: state_type] :
      ( v106527(VarCurr)
    <=> ( v106528(VarCurr)
        & v106530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10567,axiom,
    ! [VarCurr: state_type] :
      ( v106530(VarCurr)
    <=> ( v106518(VarCurr)
        | v106524(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4264,axiom,
    ! [VarCurr: state_type] :
      ( v106528(VarCurr)
    <=> ( v106529(VarCurr)
        | v106481(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106529(VarCurr)
    <=> v106518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10566,axiom,
    ! [VarCurr: state_type] :
      ( v106513(VarCurr)
    <=> ( v106514(VarCurr)
        & v106525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10565,axiom,
    ! [VarCurr: state_type] :
      ( v106525(VarCurr)
    <=> ( v106516(VarCurr)
        | v106526(VarCurr) ) ) ).

tff(writeUnaryOperator_5539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106526(VarCurr)
    <=> v106481(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4263,axiom,
    ! [VarCurr: state_type] :
      ( v106514(VarCurr)
    <=> ( v106515(VarCurr)
        | v106481(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106515(VarCurr)
    <=> v106516(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4262,axiom,
    ! [VarCurr: state_type] :
      ( v106516(VarCurr)
    <=> ( v106481(VarCurr,3)
        | v106517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10564,axiom,
    ! [VarCurr: state_type] :
      ( v106517(VarCurr)
    <=> ( v106518(VarCurr)
        & v106524(VarCurr) ) ) ).

tff(writeUnaryOperator_5537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106524(VarCurr)
    <=> v106481(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4261,axiom,
    ! [VarCurr: state_type] :
      ( v106518(VarCurr)
    <=> ( v106481(VarCurr,2)
        | v106519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10563,axiom,
    ! [VarCurr: state_type] :
      ( v106519(VarCurr)
    <=> ( v106520(VarCurr)
        & v106523(VarCurr) ) ) ).

tff(writeUnaryOperator_5536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106523(VarCurr)
    <=> v106481(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4260,axiom,
    ! [VarCurr: state_type] :
      ( v106520(VarCurr)
    <=> ( v106481(VarCurr,1)
        | v106521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10562,axiom,
    ! [VarCurr: state_type] :
      ( v106521(VarCurr)
    <=> ( v106481(VarCurr,0)
        & v106522(VarCurr) ) ) ).

tff(writeUnaryOperator_5535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106522(VarCurr)
    <=> v106481(VarCurr,1) ) ).

tff(addAssignment_64125,axiom,
    ! [VarCurr: state_type] :
      ( v106509(VarCurr,0)
    <=> v106342(VarCurr) ) ).

tff(addAssignment_64124,axiom,
    ! [VarCurr: state_type] :
      ( v106509(VarCurr,1)
    <=> v106340(VarCurr) ) ).

tff(addAssignment_64123,axiom,
    ! [VarCurr: state_type] :
      ( v106509(VarCurr,2)
    <=> v106336(VarCurr) ) ).

tff(addAssignment_64122,axiom,
    ! [VarCurr: state_type] :
      ( v106509(VarCurr,3)
    <=> v106332(VarCurr) ) ).

tff(addAssignment_64121,axiom,
    ! [VarCurr: state_type] :
      ( v106509(VarCurr,4)
    <=> v106318(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10561,axiom,
    ! [VarCurr: state_type] :
      ( v106503(VarCurr)
    <=> ( v106504(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10560,axiom,
    ! [VarCurr: state_type] :
      ( v106504(VarCurr)
    <=> ( v106505(VarCurr)
        & v106308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10559,axiom,
    ! [VarCurr: state_type] :
      ( v106505(VarCurr)
    <=> ( v106506(VarCurr)
        & v106508(VarCurr) ) ) ).

tff(writeUnaryOperator_5534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106508(VarCurr)
    <=> v106284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10558,axiom,
    ! [VarCurr: state_type] :
      ( v106506(VarCurr)
    <=> ( v106479(VarCurr)
        & v106507(VarCurr) ) ) ).

tff(writeUnaryOperator_5533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106507(VarCurr)
    <=> v106397(VarCurr) ) ).

tff(addAssignment_64120,axiom,
    ! [VarCurr: state_type] :
      ( v106491(VarCurr)
    <=> v106493(VarCurr) ) ).

tff(addAssignment_64119,axiom,
    ! [VarCurr: state_type] :
      ( v106493(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64118,axiom,
    ! [VarCurr: state_type] :
      ( v106487(VarCurr)
    <=> v106489(VarCurr) ) ).

tff(addAssignment_64117,axiom,
    ! [VarCurr: state_type] :
      ( v106489(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_767,axiom,
    ! [VarCurr: state_type] :
      ( v106397(VarCurr)
    <=> ( ( v106399(VarCurr,4)
        <=> $false )
        & ( v106399(VarCurr,3)
        <=> $false )
        & ( v106399(VarCurr,2)
        <=> $false )
        & ( v106399(VarCurr,1)
        <=> $false )
        & ( v106399(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106399(VarCurr,B)
      <=> v106401(VarCurr,B) ) ) ).

tff(addAssignment_64115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106401(VarCurr,B)
      <=> v106403(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106461(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v106403(VarNext,B)
            <=> v106403(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1285,axiom,
    ! [VarNext: state_type] :
      ( v106461(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106403(VarNext,B)
          <=> v106471(VarNext,B) ) ) ) ).

tff(addAssignment_64114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106471(VarNext,B)
          <=> v106469(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106472(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106469(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_838,axiom,
    ! [VarCurr: state_type] :
      ( v106472(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106469(VarCurr,B)
          <=> v106413(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10557,axiom,
    ! [VarCurr: state_type] :
      ( v106472(VarCurr)
    <=> ( v106473(VarCurr)
        & v106474(VarCurr) ) ) ).

tff(writeUnaryOperator_5532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106474(VarCurr)
    <=> v106409(VarCurr) ) ).

tff(writeUnaryOperator_5531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106473(VarCurr)
    <=> v106405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106461(VarNext)
      <=> v106462(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10555,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106462(VarNext)
      <=> ( v106463(VarNext)
          & v106456(VarNext) ) ) ) ).

tff(writeUnaryOperator_5530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106463(VarNext)
      <=> v106465(VarNext) ) ) ).

tff(addAssignment_64113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106465(VarNext)
      <=> v106456(VarCurr) ) ) ).

tff(addAssignment_64112,axiom,
    ! [VarCurr: state_type] :
      ( v106456(VarCurr)
    <=> v106458(VarCurr) ) ).

tff(addAssignment_64111,axiom,
    ! [VarCurr: state_type] :
      ( v106458(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106413(VarCurr,B)
      <=> v106415(VarCurr,B) ) ) ).

tff(addAssignment_64109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106415(VarCurr,B)
      <=> v106417(VarCurr,B) ) ) ).

tff(addAssignment_64108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106417(VarCurr,B)
      <=> v106419(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106421(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106419(VarCurr,B)
          <=> v106426(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_837,axiom,
    ! [VarCurr: state_type] :
      ( v106421(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106419(VarCurr,B)
          <=> v106425(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106397(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106426(VarCurr,B)
          <=> v106427(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_836,axiom,
    ! [VarCurr: state_type] :
      ( v106397(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106426(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64107,axiom,
    ! [VarCurr: state_type] :
      ( v106427(VarCurr,0)
    <=> v106453(VarCurr) ) ).

tff(addAssignment_64106,axiom,
    ! [VarCurr: state_type] :
      ( v106427(VarCurr,1)
    <=> v106451(VarCurr) ) ).

tff(addAssignment_64105,axiom,
    ! [VarCurr: state_type] :
      ( v106427(VarCurr,2)
    <=> v106447(VarCurr) ) ).

tff(addAssignment_64104,axiom,
    ! [VarCurr: state_type] :
      ( v106427(VarCurr,3)
    <=> v106443(VarCurr) ) ).

tff(addAssignment_64103,axiom,
    ! [VarCurr: state_type] :
      ( v106427(VarCurr,4)
    <=> v106429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10554,axiom,
    ! [VarCurr: state_type] :
      ( v106451(VarCurr)
    <=> ( v106452(VarCurr)
        & v106454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10553,axiom,
    ! [VarCurr: state_type] :
      ( v106454(VarCurr)
    <=> ( v106399(VarCurr,0)
        | v106438(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4259,axiom,
    ! [VarCurr: state_type] :
      ( v106452(VarCurr)
    <=> ( v106453(VarCurr)
        | v106399(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106453(VarCurr)
    <=> v106399(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10552,axiom,
    ! [VarCurr: state_type] :
      ( v106447(VarCurr)
    <=> ( v106448(VarCurr)
        & v106450(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10551,axiom,
    ! [VarCurr: state_type] :
      ( v106450(VarCurr)
    <=> ( v106436(VarCurr)
        | v106439(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4258,axiom,
    ! [VarCurr: state_type] :
      ( v106448(VarCurr)
    <=> ( v106449(VarCurr)
        | v106399(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106449(VarCurr)
    <=> v106436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10550,axiom,
    ! [VarCurr: state_type] :
      ( v106443(VarCurr)
    <=> ( v106444(VarCurr)
        & v106446(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10549,axiom,
    ! [VarCurr: state_type] :
      ( v106446(VarCurr)
    <=> ( v106434(VarCurr)
        | v106440(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4257,axiom,
    ! [VarCurr: state_type] :
      ( v106444(VarCurr)
    <=> ( v106445(VarCurr)
        | v106399(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106445(VarCurr)
    <=> v106434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10548,axiom,
    ! [VarCurr: state_type] :
      ( v106429(VarCurr)
    <=> ( v106430(VarCurr)
        & v106441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10547,axiom,
    ! [VarCurr: state_type] :
      ( v106441(VarCurr)
    <=> ( v106432(VarCurr)
        | v106442(VarCurr) ) ) ).

tff(writeUnaryOperator_5526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106442(VarCurr)
    <=> v106399(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4256,axiom,
    ! [VarCurr: state_type] :
      ( v106430(VarCurr)
    <=> ( v106431(VarCurr)
        | v106399(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106431(VarCurr)
    <=> v106432(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4255,axiom,
    ! [VarCurr: state_type] :
      ( v106432(VarCurr)
    <=> ( v106399(VarCurr,3)
        | v106433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10546,axiom,
    ! [VarCurr: state_type] :
      ( v106433(VarCurr)
    <=> ( v106434(VarCurr)
        & v106440(VarCurr) ) ) ).

tff(writeUnaryOperator_5524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106440(VarCurr)
    <=> v106399(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4254,axiom,
    ! [VarCurr: state_type] :
      ( v106434(VarCurr)
    <=> ( v106399(VarCurr,2)
        | v106435(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10545,axiom,
    ! [VarCurr: state_type] :
      ( v106435(VarCurr)
    <=> ( v106436(VarCurr)
        & v106439(VarCurr) ) ) ).

tff(writeUnaryOperator_5523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106439(VarCurr)
    <=> v106399(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4253,axiom,
    ! [VarCurr: state_type] :
      ( v106436(VarCurr)
    <=> ( v106399(VarCurr,1)
        | v106437(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10544,axiom,
    ! [VarCurr: state_type] :
      ( v106437(VarCurr)
    <=> ( v106399(VarCurr,0)
        & v106438(VarCurr) ) ) ).

tff(writeUnaryOperator_5522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106438(VarCurr)
    <=> v106399(VarCurr,1) ) ).

tff(addAssignment_64102,axiom,
    ! [VarCurr: state_type] :
      ( v106425(VarCurr,0)
    <=> v106342(VarCurr) ) ).

tff(addAssignment_64101,axiom,
    ! [VarCurr: state_type] :
      ( v106425(VarCurr,1)
    <=> v106340(VarCurr) ) ).

tff(addAssignment_64100,axiom,
    ! [VarCurr: state_type] :
      ( v106425(VarCurr,2)
    <=> v106336(VarCurr) ) ).

tff(addAssignment_64099,axiom,
    ! [VarCurr: state_type] :
      ( v106425(VarCurr,3)
    <=> v106332(VarCurr) ) ).

tff(addAssignment_64098,axiom,
    ! [VarCurr: state_type] :
      ( v106425(VarCurr,4)
    <=> v106318(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10543,axiom,
    ! [VarCurr: state_type] :
      ( v106421(VarCurr)
    <=> ( v106422(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10542,axiom,
    ! [VarCurr: state_type] :
      ( v106422(VarCurr)
    <=> ( v106423(VarCurr)
        & v106308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10541,axiom,
    ! [VarCurr: state_type] :
      ( v106423(VarCurr)
    <=> ( v106397(VarCurr)
        & v106424(VarCurr) ) ) ).

tff(writeUnaryOperator_5521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106424(VarCurr)
    <=> v106284(VarCurr) ) ).

tff(addAssignment_64097,axiom,
    ! [VarCurr: state_type] :
      ( v106409(VarCurr)
    <=> v106411(VarCurr) ) ).

tff(addAssignment_64096,axiom,
    ! [VarCurr: state_type] :
      ( v106411(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64095,axiom,
    ! [VarCurr: state_type] :
      ( v106405(VarCurr)
    <=> v106407(VarCurr) ) ).

tff(addAssignment_64094,axiom,
    ! [VarCurr: state_type] :
      ( v106407(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_766,axiom,
    ! [VarCurr: state_type] :
      ( v106284(VarCurr)
    <=> ( ( v106286(VarCurr,4)
        <=> $false )
        & ( v106286(VarCurr,3)
        <=> $false )
        & ( v106286(VarCurr,2)
        <=> $false )
        & ( v106286(VarCurr,1)
        <=> $false )
        & ( v106286(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106286(VarCurr,B)
      <=> v106288(VarCurr,B) ) ) ).

tff(addAssignment_64092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106288(VarCurr,B)
      <=> v106290(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106379(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v106290(VarNext,B)
            <=> v106290(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1284,axiom,
    ! [VarNext: state_type] :
      ( v106379(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106290(VarNext,B)
          <=> v106389(VarNext,B) ) ) ) ).

tff(addAssignment_64091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106389(VarNext,B)
          <=> v106387(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106390(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106387(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_835,axiom,
    ! [VarCurr: state_type] :
      ( v106390(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106387(VarCurr,B)
          <=> v106300(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10540,axiom,
    ! [VarCurr: state_type] :
      ( v106390(VarCurr)
    <=> ( v106391(VarCurr)
        & v106392(VarCurr) ) ) ).

tff(writeUnaryOperator_5520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106392(VarCurr)
    <=> v106296(VarCurr) ) ).

tff(writeUnaryOperator_5519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106391(VarCurr)
    <=> v106292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106379(VarNext)
      <=> v106380(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106380(VarNext)
      <=> ( v106381(VarNext)
          & v106374(VarNext) ) ) ) ).

tff(writeUnaryOperator_5518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106381(VarNext)
      <=> v106383(VarNext) ) ) ).

tff(addAssignment_64090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106383(VarNext)
      <=> v106374(VarCurr) ) ) ).

tff(addAssignment_64089,axiom,
    ! [VarCurr: state_type] :
      ( v106374(VarCurr)
    <=> v106376(VarCurr) ) ).

tff(addAssignment_64088,axiom,
    ! [VarCurr: state_type] :
      ( v106376(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106300(VarCurr,B)
      <=> v106302(VarCurr,B) ) ) ).

tff(addAssignment_64086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106302(VarCurr,B)
      <=> v106304(VarCurr,B) ) ) ).

tff(addAssignment_64085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v106304(VarCurr,B)
      <=> v106306(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106314(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106306(VarCurr,B)
          <=> v106344(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_834,axiom,
    ! [VarCurr: state_type] :
      ( v106314(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106306(VarCurr,B)
          <=> v106316(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106284(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106344(VarCurr,B)
          <=> v106345(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_833,axiom,
    ! [VarCurr: state_type] :
      ( v106284(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v106344(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64084,axiom,
    ! [VarCurr: state_type] :
      ( v106345(VarCurr,0)
    <=> v106371(VarCurr) ) ).

tff(addAssignment_64083,axiom,
    ! [VarCurr: state_type] :
      ( v106345(VarCurr,1)
    <=> v106369(VarCurr) ) ).

tff(addAssignment_64082,axiom,
    ! [VarCurr: state_type] :
      ( v106345(VarCurr,2)
    <=> v106365(VarCurr) ) ).

tff(addAssignment_64081,axiom,
    ! [VarCurr: state_type] :
      ( v106345(VarCurr,3)
    <=> v106361(VarCurr) ) ).

tff(addAssignment_64080,axiom,
    ! [VarCurr: state_type] :
      ( v106345(VarCurr,4)
    <=> v106347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10537,axiom,
    ! [VarCurr: state_type] :
      ( v106369(VarCurr)
    <=> ( v106370(VarCurr)
        & v106372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10536,axiom,
    ! [VarCurr: state_type] :
      ( v106372(VarCurr)
    <=> ( v106286(VarCurr,0)
        | v106356(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4252,axiom,
    ! [VarCurr: state_type] :
      ( v106370(VarCurr)
    <=> ( v106371(VarCurr)
        | v106286(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106371(VarCurr)
    <=> v106286(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10535,axiom,
    ! [VarCurr: state_type] :
      ( v106365(VarCurr)
    <=> ( v106366(VarCurr)
        & v106368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10534,axiom,
    ! [VarCurr: state_type] :
      ( v106368(VarCurr)
    <=> ( v106354(VarCurr)
        | v106357(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4251,axiom,
    ! [VarCurr: state_type] :
      ( v106366(VarCurr)
    <=> ( v106367(VarCurr)
        | v106286(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106367(VarCurr)
    <=> v106354(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10533,axiom,
    ! [VarCurr: state_type] :
      ( v106361(VarCurr)
    <=> ( v106362(VarCurr)
        & v106364(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10532,axiom,
    ! [VarCurr: state_type] :
      ( v106364(VarCurr)
    <=> ( v106352(VarCurr)
        | v106358(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4250,axiom,
    ! [VarCurr: state_type] :
      ( v106362(VarCurr)
    <=> ( v106363(VarCurr)
        | v106286(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106363(VarCurr)
    <=> v106352(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10531,axiom,
    ! [VarCurr: state_type] :
      ( v106347(VarCurr)
    <=> ( v106348(VarCurr)
        & v106359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10530,axiom,
    ! [VarCurr: state_type] :
      ( v106359(VarCurr)
    <=> ( v106350(VarCurr)
        | v106360(VarCurr) ) ) ).

tff(writeUnaryOperator_5514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106360(VarCurr)
    <=> v106286(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4249,axiom,
    ! [VarCurr: state_type] :
      ( v106348(VarCurr)
    <=> ( v106349(VarCurr)
        | v106286(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106349(VarCurr)
    <=> v106350(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4248,axiom,
    ! [VarCurr: state_type] :
      ( v106350(VarCurr)
    <=> ( v106286(VarCurr,3)
        | v106351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10529,axiom,
    ! [VarCurr: state_type] :
      ( v106351(VarCurr)
    <=> ( v106352(VarCurr)
        & v106358(VarCurr) ) ) ).

tff(writeUnaryOperator_5512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106358(VarCurr)
    <=> v106286(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4247,axiom,
    ! [VarCurr: state_type] :
      ( v106352(VarCurr)
    <=> ( v106286(VarCurr,2)
        | v106353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10528,axiom,
    ! [VarCurr: state_type] :
      ( v106353(VarCurr)
    <=> ( v106354(VarCurr)
        & v106357(VarCurr) ) ) ).

tff(writeUnaryOperator_5511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106357(VarCurr)
    <=> v106286(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4246,axiom,
    ! [VarCurr: state_type] :
      ( v106354(VarCurr)
    <=> ( v106286(VarCurr,1)
        | v106355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10527,axiom,
    ! [VarCurr: state_type] :
      ( v106355(VarCurr)
    <=> ( v106286(VarCurr,0)
        & v106356(VarCurr) ) ) ).

tff(writeUnaryOperator_5510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106356(VarCurr)
    <=> v106286(VarCurr,1) ) ).

tff(addAssignment_64079,axiom,
    ! [VarCurr: state_type] :
      ( v106316(VarCurr,0)
    <=> v106342(VarCurr) ) ).

tff(addAssignment_64078,axiom,
    ! [VarCurr: state_type] :
      ( v106316(VarCurr,1)
    <=> v106340(VarCurr) ) ).

tff(addAssignment_64077,axiom,
    ! [VarCurr: state_type] :
      ( v106316(VarCurr,2)
    <=> v106336(VarCurr) ) ).

tff(addAssignment_64076,axiom,
    ! [VarCurr: state_type] :
      ( v106316(VarCurr,3)
    <=> v106332(VarCurr) ) ).

tff(addAssignment_64075,axiom,
    ! [VarCurr: state_type] :
      ( v106316(VarCurr,4)
    <=> v106318(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10526,axiom,
    ! [VarCurr: state_type] :
      ( v106340(VarCurr)
    <=> ( v106341(VarCurr)
        & v106343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10525,axiom,
    ! [VarCurr: state_type] :
      ( v106343(VarCurr)
    <=> ( v106312(VarCurr,0)
        | v106327(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4245,axiom,
    ! [VarCurr: state_type] :
      ( v106341(VarCurr)
    <=> ( v106342(VarCurr)
        | v106312(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106342(VarCurr)
    <=> v106312(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10524,axiom,
    ! [VarCurr: state_type] :
      ( v106336(VarCurr)
    <=> ( v106337(VarCurr)
        & v106339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10523,axiom,
    ! [VarCurr: state_type] :
      ( v106339(VarCurr)
    <=> ( v106325(VarCurr)
        | v106328(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4244,axiom,
    ! [VarCurr: state_type] :
      ( v106337(VarCurr)
    <=> ( v106338(VarCurr)
        | v106312(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106338(VarCurr)
    <=> v106325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10522,axiom,
    ! [VarCurr: state_type] :
      ( v106332(VarCurr)
    <=> ( v106333(VarCurr)
        & v106335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10521,axiom,
    ! [VarCurr: state_type] :
      ( v106335(VarCurr)
    <=> ( v106323(VarCurr)
        | v106329(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4243,axiom,
    ! [VarCurr: state_type] :
      ( v106333(VarCurr)
    <=> ( v106334(VarCurr)
        | v106312(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106334(VarCurr)
    <=> v106323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10520,axiom,
    ! [VarCurr: state_type] :
      ( v106318(VarCurr)
    <=> ( v106319(VarCurr)
        & v106330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10519,axiom,
    ! [VarCurr: state_type] :
      ( v106330(VarCurr)
    <=> ( v106321(VarCurr)
        | v106331(VarCurr) ) ) ).

tff(writeUnaryOperator_5506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106331(VarCurr)
    <=> v106312(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4242,axiom,
    ! [VarCurr: state_type] :
      ( v106319(VarCurr)
    <=> ( v106320(VarCurr)
        | v106312(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106320(VarCurr)
    <=> v106321(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4241,axiom,
    ! [VarCurr: state_type] :
      ( v106321(VarCurr)
    <=> ( v106312(VarCurr,3)
        | v106322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10518,axiom,
    ! [VarCurr: state_type] :
      ( v106322(VarCurr)
    <=> ( v106323(VarCurr)
        & v106329(VarCurr) ) ) ).

tff(writeUnaryOperator_5504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106329(VarCurr)
    <=> v106312(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4240,axiom,
    ! [VarCurr: state_type] :
      ( v106323(VarCurr)
    <=> ( v106312(VarCurr,2)
        | v106324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10517,axiom,
    ! [VarCurr: state_type] :
      ( v106324(VarCurr)
    <=> ( v106325(VarCurr)
        & v106328(VarCurr) ) ) ).

tff(writeUnaryOperator_5503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106328(VarCurr)
    <=> v106312(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4239,axiom,
    ! [VarCurr: state_type] :
      ( v106325(VarCurr)
    <=> ( v106312(VarCurr,1)
        | v106326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10516,axiom,
    ! [VarCurr: state_type] :
      ( v106326(VarCurr)
    <=> ( v106312(VarCurr,0)
        & v106327(VarCurr) ) ) ).

tff(writeUnaryOperator_5502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106327(VarCurr)
    <=> v106312(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10515,axiom,
    ! [VarCurr: state_type] :
      ( v106314(VarCurr)
    <=> ( v106315(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10514,axiom,
    ! [VarCurr: state_type] :
      ( v106315(VarCurr)
    <=> ( v106284(VarCurr)
        & v106308(VarCurr) ) ) ).

tff(addAssignment_64074,axiom,
    ! [VarCurr: state_type] :
      ( v106312(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_64073,axiom,
    ! [VarCurr: state_type] :
      ( v106312(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_64072,axiom,
    ! [VarCurr: state_type] :
      ( v106312(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_64071,axiom,
    ! [VarCurr: state_type] :
      ( v106312(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_64070,axiom,
    ! [VarCurr: state_type] :
      ( v106312(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10513,axiom,
    ! [VarCurr: state_type] :
      ( v106308(VarCurr)
    <=> ( v106310(VarCurr)
        | v106105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10512,axiom,
    ! [VarCurr: state_type] :
      ( v106310(VarCurr)
    <=> ( v105987(VarCurr)
        | v106098(VarCurr) ) ) ).

tff(addAssignment_64069,axiom,
    ! [VarCurr: state_type] :
      ( v106296(VarCurr)
    <=> v106298(VarCurr) ) ).

tff(addAssignment_64068,axiom,
    ! [VarCurr: state_type] :
      ( v106298(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64067,axiom,
    ! [VarCurr: state_type] :
      ( v106292(VarCurr)
    <=> v106294(VarCurr) ) ).

tff(addAssignment_64066,axiom,
    ! [VarCurr: state_type] :
      ( v106294(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_64065,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,4)
    <=> v106181(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_765,axiom,
    ! [VarCurr: state_type] :
      ( v106181(VarCurr)
    <=> ( ( v106183(VarCurr,3)
        <=> $false )
        & ( v106183(VarCurr,2)
        <=> $false )
        & ( v106183(VarCurr,1)
        <=> $false )
        & ( v106183(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106183(VarCurr,B)
      <=> v106185(VarCurr,B) ) ) ).

tff(addAssignment_64063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106185(VarCurr,B)
      <=> v106187(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106264(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v106187(VarNext,B)
            <=> v106187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1283,axiom,
    ! [VarNext: state_type] :
      ( v106264(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106187(VarNext,B)
          <=> v106274(VarNext,B) ) ) ) ).

tff(addAssignment_64062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106274(VarNext,B)
          <=> v106272(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106272(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_832,axiom,
    ! [VarCurr: state_type] :
      ( v106275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106272(VarCurr,B)
          <=> v106197(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10511,axiom,
    ! [VarCurr: state_type] :
      ( v106275(VarCurr)
    <=> ( v106276(VarCurr)
        & v106277(VarCurr) ) ) ).

tff(writeUnaryOperator_5501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106277(VarCurr)
    <=> v106193(VarCurr) ) ).

tff(writeUnaryOperator_5500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106276(VarCurr)
    <=> v106189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106264(VarNext)
      <=> v106265(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106265(VarNext)
      <=> ( v106266(VarNext)
          & v106259(VarNext) ) ) ) ).

tff(writeUnaryOperator_5499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106266(VarNext)
      <=> v106268(VarNext) ) ) ).

tff(addAssignment_64061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106268(VarNext)
      <=> v106259(VarCurr) ) ) ).

tff(addAssignment_64060,axiom,
    ! [VarCurr: state_type] :
      ( v106259(VarCurr)
    <=> v106261(VarCurr) ) ).

tff(addAssignment_64059,axiom,
    ! [VarCurr: state_type] :
      ( v106261(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106197(VarCurr,B)
      <=> v106199(VarCurr,B) ) ) ).

tff(addAssignment_64057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106199(VarCurr,B)
      <=> v106201(VarCurr,B) ) ) ).

tff(addAssignment_64056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106201(VarCurr,B)
      <=> v106203(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106210(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106203(VarCurr,B)
          <=> v106232(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_831,axiom,
    ! [VarCurr: state_type] :
      ( v106210(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106203(VarCurr,B)
          <=> v106211(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106233(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106232(VarCurr,B)
          <=> v106234(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_830,axiom,
    ! [VarCurr: state_type] :
      ( v106233(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106232(VarCurr,B)
          <=> v106208(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106235(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106234(VarCurr,B)
          <=> v106236(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_829,axiom,
    ! [VarCurr: state_type] :
      ( v106235(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106234(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106236(VarCurr,B)
          <=> v106183(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_828,axiom,
    ! [VarCurr: state_type] :
      ( v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106236(VarCurr,B)
          <=> v106237(VarCurr,B) ) ) ) ).

tff(addAssignment_64055,axiom,
    ! [VarCurr: state_type] :
      ( v106237(VarCurr,0)
    <=> v106256(VarCurr) ) ).

tff(addAssignment_64054,axiom,
    ! [VarCurr: state_type] :
      ( v106237(VarCurr,1)
    <=> v106254(VarCurr) ) ).

tff(addAssignment_64053,axiom,
    ! [VarCurr: state_type] :
      ( v106237(VarCurr,2)
    <=> v106250(VarCurr) ) ).

tff(addAssignment_64052,axiom,
    ! [VarCurr: state_type] :
      ( v106237(VarCurr,3)
    <=> v106239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10508,axiom,
    ! [VarCurr: state_type] :
      ( v106254(VarCurr)
    <=> ( v106255(VarCurr)
        & v106257(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10507,axiom,
    ! [VarCurr: state_type] :
      ( v106257(VarCurr)
    <=> ( v106183(VarCurr,0)
        | v106246(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4238,axiom,
    ! [VarCurr: state_type] :
      ( v106255(VarCurr)
    <=> ( v106256(VarCurr)
        | v106183(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106256(VarCurr)
    <=> v106183(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10506,axiom,
    ! [VarCurr: state_type] :
      ( v106250(VarCurr)
    <=> ( v106251(VarCurr)
        & v106253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10505,axiom,
    ! [VarCurr: state_type] :
      ( v106253(VarCurr)
    <=> ( v106244(VarCurr)
        | v106247(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4237,axiom,
    ! [VarCurr: state_type] :
      ( v106251(VarCurr)
    <=> ( v106252(VarCurr)
        | v106183(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106252(VarCurr)
    <=> v106244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10504,axiom,
    ! [VarCurr: state_type] :
      ( v106239(VarCurr)
    <=> ( v106240(VarCurr)
        & v106248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10503,axiom,
    ! [VarCurr: state_type] :
      ( v106248(VarCurr)
    <=> ( v106242(VarCurr)
        | v106249(VarCurr) ) ) ).

tff(writeUnaryOperator_5496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106249(VarCurr)
    <=> v106183(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4236,axiom,
    ! [VarCurr: state_type] :
      ( v106240(VarCurr)
    <=> ( v106241(VarCurr)
        | v106183(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106241(VarCurr)
    <=> v106242(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4235,axiom,
    ! [VarCurr: state_type] :
      ( v106242(VarCurr)
    <=> ( v106183(VarCurr,2)
        | v106243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10502,axiom,
    ! [VarCurr: state_type] :
      ( v106243(VarCurr)
    <=> ( v106244(VarCurr)
        & v106247(VarCurr) ) ) ).

tff(writeUnaryOperator_5494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106247(VarCurr)
    <=> v106183(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4234,axiom,
    ! [VarCurr: state_type] :
      ( v106244(VarCurr)
    <=> ( v106183(VarCurr,1)
        | v106245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10501,axiom,
    ! [VarCurr: state_type] :
      ( v106245(VarCurr)
    <=> ( v106183(VarCurr,0)
        & v106246(VarCurr) ) ) ).

tff(writeUnaryOperator_5493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106246(VarCurr)
    <=> v106183(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_764,axiom,
    ! [VarCurr: state_type] :
      ( v106235(VarCurr)
    <=> ( ( v106183(VarCurr,3)
        <=> $false )
        & ( v106183(VarCurr,2)
        <=> $false )
        & ( v106183(VarCurr,1)
        <=> $false )
        & ( v106183(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10500,axiom,
    ! [VarCurr: state_type] :
      ( v106233(VarCurr)
    <=> ( v106105(VarCurr)
        & v106181(VarCurr) ) ) ).

tff(addAssignment_64051,axiom,
    ! [VarCurr: state_type] :
      ( v106211(VarCurr,0)
    <=> v106230(VarCurr) ) ).

tff(addAssignment_64050,axiom,
    ! [VarCurr: state_type] :
      ( v106211(VarCurr,1)
    <=> v106228(VarCurr) ) ).

tff(addAssignment_64049,axiom,
    ! [VarCurr: state_type] :
      ( v106211(VarCurr,2)
    <=> v106224(VarCurr) ) ).

tff(addAssignment_64048,axiom,
    ! [VarCurr: state_type] :
      ( v106211(VarCurr,3)
    <=> v106213(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10499,axiom,
    ! [VarCurr: state_type] :
      ( v106228(VarCurr)
    <=> ( v106229(VarCurr)
        & v106231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10498,axiom,
    ! [VarCurr: state_type] :
      ( v106231(VarCurr)
    <=> ( v106208(VarCurr,0)
        | v106220(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4233,axiom,
    ! [VarCurr: state_type] :
      ( v106229(VarCurr)
    <=> ( v106230(VarCurr)
        | v106208(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106230(VarCurr)
    <=> v106208(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10497,axiom,
    ! [VarCurr: state_type] :
      ( v106224(VarCurr)
    <=> ( v106225(VarCurr)
        & v106227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10496,axiom,
    ! [VarCurr: state_type] :
      ( v106227(VarCurr)
    <=> ( v106218(VarCurr)
        | v106221(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4232,axiom,
    ! [VarCurr: state_type] :
      ( v106225(VarCurr)
    <=> ( v106226(VarCurr)
        | v106208(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106226(VarCurr)
    <=> v106218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10495,axiom,
    ! [VarCurr: state_type] :
      ( v106213(VarCurr)
    <=> ( v106214(VarCurr)
        & v106222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10494,axiom,
    ! [VarCurr: state_type] :
      ( v106222(VarCurr)
    <=> ( v106216(VarCurr)
        | v106223(VarCurr) ) ) ).

tff(writeUnaryOperator_5490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106223(VarCurr)
    <=> v106208(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4231,axiom,
    ! [VarCurr: state_type] :
      ( v106214(VarCurr)
    <=> ( v106215(VarCurr)
        | v106208(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106215(VarCurr)
    <=> v106216(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4230,axiom,
    ! [VarCurr: state_type] :
      ( v106216(VarCurr)
    <=> ( v106208(VarCurr,2)
        | v106217(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10493,axiom,
    ! [VarCurr: state_type] :
      ( v106217(VarCurr)
    <=> ( v106218(VarCurr)
        & v106221(VarCurr) ) ) ).

tff(writeUnaryOperator_5488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106221(VarCurr)
    <=> v106208(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4229,axiom,
    ! [VarCurr: state_type] :
      ( v106218(VarCurr)
    <=> ( v106208(VarCurr,1)
        | v106219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10492,axiom,
    ! [VarCurr: state_type] :
      ( v106219(VarCurr)
    <=> ( v106208(VarCurr,0)
        & v106220(VarCurr) ) ) ).

tff(writeUnaryOperator_5487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106220(VarCurr)
    <=> v106208(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10491,axiom,
    ! [VarCurr: state_type] :
      ( v106210(VarCurr)
    <=> ( v106205(VarCurr)
        & v106181(VarCurr) ) ) ).

tff(addAssignment_64047,axiom,
    ! [VarCurr: state_type] :
      ( v106208(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_64046,axiom,
    ! [VarCurr: state_type] :
      ( v106208(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_64045,axiom,
    ! [VarCurr: state_type] :
      ( v106208(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_64044,axiom,
    ! [VarCurr: state_type] :
      ( v106208(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10490,axiom,
    ! [VarCurr: state_type] :
      ( v106205(VarCurr)
    <=> ( v105987(VarCurr)
        | v106098(VarCurr) ) ) ).

tff(addAssignment_64043,axiom,
    ! [VarCurr: state_type] :
      ( v106193(VarCurr)
    <=> v106195(VarCurr) ) ).

tff(addAssignment_64042,axiom,
    ! [VarCurr: state_type] :
      ( v106195(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64041,axiom,
    ! [VarCurr: state_type] :
      ( v106189(VarCurr)
    <=> v106191(VarCurr) ) ).

tff(addAssignment_64040,axiom,
    ! [VarCurr: state_type] :
      ( v106191(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_64039,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,4)
    <=> v106054(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_763,axiom,
    ! [VarCurr: state_type] :
      ( v106054(VarCurr)
    <=> ( ( v106056(VarCurr,1)
        <=> $false )
        & ( v106056(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_64038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106056(VarCurr,B)
      <=> v106058(VarCurr,B) ) ) ).

tff(addAssignment_64037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106058(VarCurr,B)
      <=> v106060(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106163(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v106060(VarNext,B)
            <=> v106060(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1282,axiom,
    ! [VarNext: state_type] :
      ( v106163(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106060(VarNext,B)
          <=> v106173(VarNext,B) ) ) ) ).

tff(addAssignment_64036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106173(VarNext,B)
          <=> v106171(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106174(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106171(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_827,axiom,
    ! [VarCurr: state_type] :
      ( v106174(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106171(VarCurr,B)
          <=> v106070(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10489,axiom,
    ! [VarCurr: state_type] :
      ( v106174(VarCurr)
    <=> ( v106175(VarCurr)
        & v106176(VarCurr) ) ) ).

tff(writeUnaryOperator_5486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106176(VarCurr)
    <=> v106066(VarCurr) ) ).

tff(writeUnaryOperator_5485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106175(VarCurr)
    <=> v106062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106163(VarNext)
      <=> v106164(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106164(VarNext)
      <=> ( v106165(VarNext)
          & v106158(VarNext) ) ) ) ).

tff(writeUnaryOperator_5484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106165(VarNext)
      <=> v106167(VarNext) ) ) ).

tff(addAssignment_64035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106167(VarNext)
      <=> v106158(VarCurr) ) ) ).

tff(addAssignment_64034,axiom,
    ! [VarCurr: state_type] :
      ( v106158(VarCurr)
    <=> v106160(VarCurr) ) ).

tff(addAssignment_64033,axiom,
    ! [VarCurr: state_type] :
      ( v106160(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106070(VarCurr,B)
      <=> v106072(VarCurr,B) ) ) ).

tff(addAssignment_64031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106072(VarCurr,B)
      <=> v106074(VarCurr,B) ) ) ).

tff(addAssignment_64030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v106074(VarCurr,B)
      <=> v106076(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106145(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106076(VarCurr,B)
          <=> v106146(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_826,axiom,
    ! [VarCurr: state_type] :
      ( v106145(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106076(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106147(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106146(VarCurr,B)
          <=> v106148(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_825,axiom,
    ! [VarCurr: state_type] :
      ( v106147(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106146(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106148(VarCurr,B)
          <=> v106150(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_824,axiom,
    ! [VarCurr: state_type] :
      ( v106149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v106148(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_64029,axiom,
    ! [VarCurr: state_type] :
      ( v106150(VarCurr,0)
    <=> v106154(VarCurr) ) ).

tff(addAssignment_64028,axiom,
    ! [VarCurr: state_type] :
      ( v106150(VarCurr,1)
    <=> v106152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10486,axiom,
    ! [VarCurr: state_type] :
      ( v106152(VarCurr)
    <=> ( v106153(VarCurr)
        & v106155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10485,axiom,
    ! [VarCurr: state_type] :
      ( v106155(VarCurr)
    <=> ( v106056(VarCurr,0)
        | v106156(VarCurr) ) ) ).

tff(writeUnaryOperator_5483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106156(VarCurr)
    <=> v106056(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4228,axiom,
    ! [VarCurr: state_type] :
      ( v106153(VarCurr)
    <=> ( v106154(VarCurr)
        | v106056(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106154(VarCurr)
    <=> v106056(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_762,axiom,
    ! [VarCurr: state_type] :
      ( v106149(VarCurr)
    <=> ( ( v106056(VarCurr,1)
        <=> $false )
        & ( v106056(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10484,axiom,
    ! [VarCurr: state_type] :
      ( v106147(VarCurr)
    <=> ( v106129(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10483,axiom,
    ! [VarCurr: state_type] :
      ( v106145(VarCurr)
    <=> ( v106078(VarCurr)
        & v106002(VarCurr) ) ) ).

tff(addAssignment_64027,axiom,
    ! [VarCurr: state_type] :
      ( v106129(VarCurr)
    <=> v106080(VarCurr,0) ) ).

tff(addAssignment_64026,axiom,
    ! [VarCurr: state_type] :
      ( v106080(VarCurr,0)
    <=> v106082(VarCurr,0) ) ).

tff(addAssignment_64025,axiom,
    ! [VarNext: state_type] :
      ( v106082(VarNext,0)
    <=> v106137(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106138(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v106137(VarNext,B)
            <=> v106082(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1281,axiom,
    ! [VarNext: state_type] :
      ( v106138(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106137(VarNext,B)
          <=> v106122(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106138(VarNext)
      <=> v106139(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106139(VarNext)
      <=> ( v106141(VarNext)
          & v106107(VarNext) ) ) ) ).

tff(writeUnaryOperator_5481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106141(VarNext)
      <=> v106116(VarNext) ) ) ).

tff(addAssignment_64024,axiom,
    ! [VarCurr: state_type] :
      ( v106092(VarCurr,0)
    <=> v106094(VarCurr,0) ) ).

tff(addAssignment_64023,axiom,
    ! [VarCurr: state_type] :
      ( v106094(VarCurr,0)
    <=> v106096(VarCurr,0) ) ).

tff(addAssignment_64022,axiom,
    ! [VarCurr: state_type] :
      ( v106096(VarCurr,0)
    <=> v106104(VarCurr,0) ) ).

tff(addAssignment_64021,axiom,
    ! [VarCurr: state_type] :
      ( v106105(VarCurr)
    <=> v103094(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4227,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,4)
    <=> ( v106132(VarCurr)
        | v106134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10480,axiom,
    ! [VarCurr: state_type] :
      ( v106134(VarCurr)
    <=> ( v103113(VarCurr)
        & v106135(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_761,axiom,
    ! [VarCurr: state_type] :
      ( v106135(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $true )
        & ( v103127(VarCurr,5)
        <=> $false )
        & ( v103127(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10479,axiom,
    ! [VarCurr: state_type] :
      ( v106132(VarCurr)
    <=> ( v103096(VarCurr)
        & v106133(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_760,axiom,
    ! [VarCurr: state_type] :
      ( v106133(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $true )
        & ( v103106(VarCurr,5)
        <=> $false )
        & ( v103106(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_64020,axiom,
    ! [VarCurr: state_type] :
      ( v106078(VarCurr)
    <=> v106080(VarCurr,1) ) ).

tff(addAssignment_64019,axiom,
    ! [VarCurr: state_type] :
      ( v106080(VarCurr,1)
    <=> v106082(VarCurr,1) ) ).

tff(addAssignment_64018,axiom,
    ! [VarNext: state_type] :
      ( v106082(VarNext,1)
    <=> v106111(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106112(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v106111(VarNext,B)
            <=> v106082(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1280,axiom,
    ! [VarNext: state_type] :
      ( v106112(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106111(VarNext,B)
          <=> v106122(VarNext,B) ) ) ) ).

tff(addAssignment_64017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106122(VarNext,B)
          <=> v106120(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106123(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106120(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_823,axiom,
    ! [VarCurr: state_type] :
      ( v106123(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v106120(VarCurr,B)
          <=> v106092(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10478,axiom,
    ! [VarCurr: state_type] :
      ( v106123(VarCurr)
    <=> ( v106124(VarCurr)
        & v106125(VarCurr) ) ) ).

tff(writeUnaryOperator_5480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106125(VarCurr)
    <=> v106088(VarCurr) ) ).

tff(writeUnaryOperator_5479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106124(VarCurr)
    <=> v106084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106112(VarNext)
      <=> v106113(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106113(VarNext)
      <=> ( v106114(VarNext)
          & v106107(VarNext) ) ) ) ).

tff(writeUnaryOperator_5478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106114(VarNext)
      <=> v106116(VarNext) ) ) ).

tff(addAssignment_64016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106116(VarNext)
      <=> v106107(VarCurr) ) ) ).

tff(addAssignment_64015,axiom,
    ! [VarCurr: state_type] :
      ( v106107(VarCurr)
    <=> v106109(VarCurr) ) ).

tff(addAssignment_64014,axiom,
    ! [VarCurr: state_type] :
      ( v106109(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_64013,axiom,
    ! [VarCurr: state_type] :
      ( v106092(VarCurr,1)
    <=> v106094(VarCurr,1) ) ).

tff(addAssignment_64012,axiom,
    ! [VarCurr: state_type] :
      ( v106094(VarCurr,1)
    <=> v106096(VarCurr,1) ) ).

tff(addAssignment_64011,axiom,
    ! [VarCurr: state_type] :
      ( v106096(VarCurr,1)
    <=> v106104(VarCurr,1) ) ).

tff(addAssignment_64010,axiom,
    ! [VarCurr: state_type] :
      ( v106104(VarCurr,0)
    <=> v106105(VarCurr) ) ).

tff(addAssignment_64009,axiom,
    ! [VarCurr: state_type] :
      ( v106104(VarCurr,1)
    <=> v106098(VarCurr) ) ).

tff(addAssignment_64008,axiom,
    ! [VarCurr: state_type] :
      ( v106104(VarCurr,2)
    <=> v105987(VarCurr) ) ).

tff(addAssignment_64007,axiom,
    ! [VarCurr: state_type] :
      ( v106098(VarCurr)
    <=> v101499(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4226,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,4)
    <=> ( v106100(VarCurr)
        | v106102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10475,axiom,
    ! [VarCurr: state_type] :
      ( v106102(VarCurr)
    <=> ( v83096(VarCurr)
        & v106103(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_759,axiom,
    ! [VarCurr: state_type] :
      ( v106103(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10474,axiom,
    ! [VarCurr: state_type] :
      ( v106100(VarCurr)
    <=> ( v101501(VarCurr)
        & v106101(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_758,axiom,
    ! [VarCurr: state_type] :
      ( v106101(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $true )
        & ( v101563(VarCurr,5)
        <=> $false )
        & ( v101563(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_64006,axiom,
    ! [VarCurr: state_type] :
      ( v106088(VarCurr)
    <=> v106090(VarCurr) ) ).

tff(addAssignment_64005,axiom,
    ! [VarCurr: state_type] :
      ( v106090(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64004,axiom,
    ! [VarCurr: state_type] :
      ( v106084(VarCurr)
    <=> v106086(VarCurr) ) ).

tff(addAssignment_64003,axiom,
    ! [VarCurr: state_type] :
      ( v106086(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_64002,axiom,
    ! [VarCurr: state_type] :
      ( v106066(VarCurr)
    <=> v106068(VarCurr) ) ).

tff(addAssignment_64001,axiom,
    ! [VarCurr: state_type] :
      ( v106068(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_64000,axiom,
    ! [VarCurr: state_type] :
      ( v106062(VarCurr)
    <=> v106064(VarCurr) ) ).

tff(addAssignment_63999,axiom,
    ! [VarCurr: state_type] :
      ( v106064(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_63998,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,4)
    <=> v105955(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_757,axiom,
    ! [VarCurr: state_type] :
      ( v105955(VarCurr)
    <=> ( ( v105957(VarCurr,3)
        <=> $false )
        & ( v105957(VarCurr,2)
        <=> $false )
        & ( v105957(VarCurr,1)
        <=> $false )
        & ( v105957(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105957(VarCurr,B)
      <=> v105959(VarCurr,B) ) ) ).

tff(addAssignment_63996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105959(VarCurr,B)
      <=> v105961(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106036(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v105961(VarNext,B)
            <=> v105961(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1279,axiom,
    ! [VarNext: state_type] :
      ( v106036(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105961(VarNext,B)
          <=> v106046(VarNext,B) ) ) ) ).

tff(addAssignment_63995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106046(VarNext,B)
          <=> v106044(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106044(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_822,axiom,
    ! [VarCurr: state_type] :
      ( v106047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106044(VarCurr,B)
          <=> v105979(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10473,axiom,
    ! [VarCurr: state_type] :
      ( v106047(VarCurr)
    <=> ( v106048(VarCurr)
        & v106049(VarCurr) ) ) ).

tff(writeUnaryOperator_5477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106049(VarCurr)
    <=> v105971(VarCurr) ) ).

tff(writeUnaryOperator_5476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106048(VarCurr)
    <=> v105963(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106036(VarNext)
      <=> v106037(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106037(VarNext)
      <=> ( v106038(VarNext)
          & v106029(VarNext) ) ) ) ).

tff(writeUnaryOperator_5475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v106038(VarNext)
      <=> v106040(VarNext) ) ) ).

tff(addAssignment_63994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v106040(VarNext)
      <=> v106029(VarCurr) ) ) ).

tff(addAssignment_63993,axiom,
    ! [VarCurr: state_type] :
      ( v106029(VarCurr)
    <=> v106031(VarCurr) ) ).

tff(addAssignment_63992,axiom,
    ! [VarCurr: state_type] :
      ( v106031(VarCurr)
    <=> v106033(VarCurr) ) ).

tff(addAssignment_63991,axiom,
    ! [VarCurr: state_type] :
      ( v106033(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105979(VarCurr,B)
      <=> v105981(VarCurr,B) ) ) ).

tff(addAssignment_63989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105981(VarCurr,B)
      <=> v105983(VarCurr,B) ) ) ).

tff(addAssignment_63988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105983(VarCurr,B)
      <=> v105985(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105987(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105985(VarCurr,B)
          <=> v106004(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_821,axiom,
    ! [VarCurr: state_type] :
      ( v105987(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105985(VarCurr,B)
          <=> v106000(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106004(VarCurr,B)
          <=> v106006(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_820,axiom,
    ! [VarCurr: state_type] :
      ( v106005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106004(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106006(VarCurr,B)
          <=> v105957(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_819,axiom,
    ! [VarCurr: state_type] :
      ( v106002(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v106006(VarCurr,B)
          <=> v106007(VarCurr,B) ) ) ) ).

tff(addAssignment_63987,axiom,
    ! [VarCurr: state_type] :
      ( v106007(VarCurr,0)
    <=> v106026(VarCurr) ) ).

tff(addAssignment_63986,axiom,
    ! [VarCurr: state_type] :
      ( v106007(VarCurr,1)
    <=> v106024(VarCurr) ) ).

tff(addAssignment_63985,axiom,
    ! [VarCurr: state_type] :
      ( v106007(VarCurr,2)
    <=> v106020(VarCurr) ) ).

tff(addAssignment_63984,axiom,
    ! [VarCurr: state_type] :
      ( v106007(VarCurr,3)
    <=> v106009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10470,axiom,
    ! [VarCurr: state_type] :
      ( v106024(VarCurr)
    <=> ( v106025(VarCurr)
        & v106027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10469,axiom,
    ! [VarCurr: state_type] :
      ( v106027(VarCurr)
    <=> ( v105957(VarCurr,0)
        | v106016(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4225,axiom,
    ! [VarCurr: state_type] :
      ( v106025(VarCurr)
    <=> ( v106026(VarCurr)
        | v105957(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106026(VarCurr)
    <=> v105957(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10468,axiom,
    ! [VarCurr: state_type] :
      ( v106020(VarCurr)
    <=> ( v106021(VarCurr)
        & v106023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10467,axiom,
    ! [VarCurr: state_type] :
      ( v106023(VarCurr)
    <=> ( v106014(VarCurr)
        | v106017(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4224,axiom,
    ! [VarCurr: state_type] :
      ( v106021(VarCurr)
    <=> ( v106022(VarCurr)
        | v105957(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106022(VarCurr)
    <=> v106014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10466,axiom,
    ! [VarCurr: state_type] :
      ( v106009(VarCurr)
    <=> ( v106010(VarCurr)
        & v106018(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10465,axiom,
    ! [VarCurr: state_type] :
      ( v106018(VarCurr)
    <=> ( v106012(VarCurr)
        | v106019(VarCurr) ) ) ).

tff(writeUnaryOperator_5472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106019(VarCurr)
    <=> v105957(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4223,axiom,
    ! [VarCurr: state_type] :
      ( v106010(VarCurr)
    <=> ( v106011(VarCurr)
        | v105957(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106011(VarCurr)
    <=> v106012(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4222,axiom,
    ! [VarCurr: state_type] :
      ( v106012(VarCurr)
    <=> ( v105957(VarCurr,2)
        | v106013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10464,axiom,
    ! [VarCurr: state_type] :
      ( v106013(VarCurr)
    <=> ( v106014(VarCurr)
        & v106017(VarCurr) ) ) ).

tff(writeUnaryOperator_5470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106017(VarCurr)
    <=> v105957(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4221,axiom,
    ! [VarCurr: state_type] :
      ( v106014(VarCurr)
    <=> ( v105957(VarCurr,1)
        | v106015(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10463,axiom,
    ! [VarCurr: state_type] :
      ( v106015(VarCurr)
    <=> ( v105957(VarCurr,0)
        & v106016(VarCurr) ) ) ).

tff(writeUnaryOperator_5469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v106016(VarCurr)
    <=> v105957(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_756,axiom,
    ! [VarCurr: state_type] :
      ( v106005(VarCurr)
    <=> ( ( v105957(VarCurr,3)
        <=> $false )
        & ( v105957(VarCurr,2)
        <=> $false )
        & ( v105957(VarCurr,1)
        <=> $false )
        & ( v105957(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63983,axiom,
    ! [VarCurr: state_type] :
      ( v106002(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_63982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v106000(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_63981,axiom,
    ! [VarCurr: state_type] :
      ( v105987(VarCurr)
    <=> v89212(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4220,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,4)
    <=> ( v105989(VarCurr)
        | v105997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10462,axiom,
    ! [VarCurr: state_type] :
      ( v105997(VarCurr)
    <=> ( v82954(VarCurr)
        & v105998(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_755,axiom,
    ! [VarCurr: state_type] :
      ( v105998(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $true )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10461,axiom,
    ! [VarCurr: state_type] :
      ( v105989(VarCurr)
    <=> ( v105990(VarCurr)
        | v105995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10460,axiom,
    ! [VarCurr: state_type] :
      ( v105995(VarCurr)
    <=> ( v86877(VarCurr)
        & v105996(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_754,axiom,
    ! [VarCurr: state_type] :
      ( v105996(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $true )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10459,axiom,
    ! [VarCurr: state_type] :
      ( v105990(VarCurr)
    <=> ( v105991(VarCurr)
        | v105993(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10458,axiom,
    ! [VarCurr: state_type] :
      ( v105993(VarCurr)
    <=> ( v84899(VarCurr)
        & v105994(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_753,axiom,
    ! [VarCurr: state_type] :
      ( v105994(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $true )
        & ( v89243(VarCurr,5)
        <=> $false )
        & ( v89243(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10457,axiom,
    ! [VarCurr: state_type] :
      ( v105991(VarCurr)
    <=> ( v118(VarCurr)
        & v105992(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_752,axiom,
    ! [VarCurr: state_type] :
      ( v105992(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $true )
        & ( v89214(VarCurr,5)
        <=> $false )
        & ( v89214(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63980,axiom,
    ! [VarCurr: state_type] :
      ( v105971(VarCurr)
    <=> v105973(VarCurr) ) ).

tff(addAssignment_63979,axiom,
    ! [VarCurr: state_type] :
      ( v105973(VarCurr)
    <=> v105975(VarCurr) ) ).

tff(addAssignment_63978,axiom,
    ! [VarCurr: state_type] :
      ( v105975(VarCurr)
    <=> v105977(VarCurr) ) ).

tff(addAssignment_63977,axiom,
    ! [VarCurr: state_type] :
      ( v105977(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_63976,axiom,
    ! [VarCurr: state_type] :
      ( v105963(VarCurr)
    <=> v105965(VarCurr) ) ).

tff(addAssignment_63975,axiom,
    ! [VarCurr: state_type] :
      ( v105965(VarCurr)
    <=> v105967(VarCurr) ) ).

tff(addAssignment_63974,axiom,
    ! [VarCurr: state_type] :
      ( v105967(VarCurr)
    <=> v105969(VarCurr) ) ).

tff(addAssignment_63973,axiom,
    ! [VarCurr: state_type] :
      ( v105969(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_63972,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,3)
    <=> v105581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10456,axiom,
    ! [VarCurr: state_type] :
      ( v105581(VarCurr)
    <=> ( v105948(VarCurr)
        & v105953(VarCurr) ) ) ).

tff(writeUnaryOperator_5468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105953(VarCurr)
    <=> v105862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10455,axiom,
    ! [VarCurr: state_type] :
      ( v105948(VarCurr)
    <=> ( v105949(VarCurr)
        & v105952(VarCurr) ) ) ).

tff(writeUnaryOperator_5467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105952(VarCurr)
    <=> v105778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10454,axiom,
    ! [VarCurr: state_type] :
      ( v105949(VarCurr)
    <=> ( v105950(VarCurr)
        & v105951(VarCurr) ) ) ).

tff(writeUnaryOperator_5466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105951(VarCurr)
    <=> v105696(VarCurr) ) ).

tff(writeUnaryOperator_5465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105950(VarCurr)
    <=> v105583(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_751,axiom,
    ! [VarCurr: state_type] :
      ( v105862(VarCurr)
    <=> ( ( v105864(VarCurr,4)
        <=> $false )
        & ( v105864(VarCurr,3)
        <=> $false )
        & ( v105864(VarCurr,2)
        <=> $false )
        & ( v105864(VarCurr,1)
        <=> $false )
        & ( v105864(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105864(VarCurr,B)
      <=> v105866(VarCurr,B) ) ) ).

tff(addAssignment_63970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105866(VarCurr,B)
      <=> v105868(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105930(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105868(VarNext,B)
            <=> v105868(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1278,axiom,
    ! [VarNext: state_type] :
      ( v105930(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105868(VarNext,B)
          <=> v105940(VarNext,B) ) ) ) ).

tff(addAssignment_63969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105940(VarNext,B)
          <=> v105938(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105941(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105938(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_818,axiom,
    ! [VarCurr: state_type] :
      ( v105941(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105938(VarCurr,B)
          <=> v105878(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10453,axiom,
    ! [VarCurr: state_type] :
      ( v105941(VarCurr)
    <=> ( v105942(VarCurr)
        & v105943(VarCurr) ) ) ).

tff(writeUnaryOperator_5464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105943(VarCurr)
    <=> v105874(VarCurr) ) ).

tff(writeUnaryOperator_5463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105942(VarCurr)
    <=> v105870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105930(VarNext)
      <=> v105931(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105931(VarNext)
      <=> ( v105932(VarNext)
          & v105925(VarNext) ) ) ) ).

tff(writeUnaryOperator_5462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105932(VarNext)
      <=> v105934(VarNext) ) ) ).

tff(addAssignment_63968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105934(VarNext)
      <=> v105925(VarCurr) ) ) ).

tff(addAssignment_63967,axiom,
    ! [VarCurr: state_type] :
      ( v105925(VarCurr)
    <=> v105927(VarCurr) ) ).

tff(addAssignment_63966,axiom,
    ! [VarCurr: state_type] :
      ( v105927(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105878(VarCurr,B)
      <=> v105880(VarCurr,B) ) ) ).

tff(addAssignment_63964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105880(VarCurr,B)
      <=> v105882(VarCurr,B) ) ) ).

tff(addAssignment_63963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105882(VarCurr,B)
      <=> v105884(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105886(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105884(VarCurr,B)
          <=> v105895(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_817,axiom,
    ! [VarCurr: state_type] :
      ( v105886(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105884(VarCurr,B)
          <=> v105894(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105862(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105895(VarCurr,B)
          <=> v105896(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_816,axiom,
    ! [VarCurr: state_type] :
      ( v105862(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105895(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63962,axiom,
    ! [VarCurr: state_type] :
      ( v105896(VarCurr,0)
    <=> v105922(VarCurr) ) ).

tff(addAssignment_63961,axiom,
    ! [VarCurr: state_type] :
      ( v105896(VarCurr,1)
    <=> v105920(VarCurr) ) ).

tff(addAssignment_63960,axiom,
    ! [VarCurr: state_type] :
      ( v105896(VarCurr,2)
    <=> v105916(VarCurr) ) ).

tff(addAssignment_63959,axiom,
    ! [VarCurr: state_type] :
      ( v105896(VarCurr,3)
    <=> v105912(VarCurr) ) ).

tff(addAssignment_63958,axiom,
    ! [VarCurr: state_type] :
      ( v105896(VarCurr,4)
    <=> v105898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10450,axiom,
    ! [VarCurr: state_type] :
      ( v105920(VarCurr)
    <=> ( v105921(VarCurr)
        & v105923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10449,axiom,
    ! [VarCurr: state_type] :
      ( v105923(VarCurr)
    <=> ( v105864(VarCurr,0)
        | v105907(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4219,axiom,
    ! [VarCurr: state_type] :
      ( v105921(VarCurr)
    <=> ( v105922(VarCurr)
        | v105864(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105922(VarCurr)
    <=> v105864(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10448,axiom,
    ! [VarCurr: state_type] :
      ( v105916(VarCurr)
    <=> ( v105917(VarCurr)
        & v105919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10447,axiom,
    ! [VarCurr: state_type] :
      ( v105919(VarCurr)
    <=> ( v105905(VarCurr)
        | v105908(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4218,axiom,
    ! [VarCurr: state_type] :
      ( v105917(VarCurr)
    <=> ( v105918(VarCurr)
        | v105864(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105918(VarCurr)
    <=> v105905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10446,axiom,
    ! [VarCurr: state_type] :
      ( v105912(VarCurr)
    <=> ( v105913(VarCurr)
        & v105915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10445,axiom,
    ! [VarCurr: state_type] :
      ( v105915(VarCurr)
    <=> ( v105903(VarCurr)
        | v105909(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4217,axiom,
    ! [VarCurr: state_type] :
      ( v105913(VarCurr)
    <=> ( v105914(VarCurr)
        | v105864(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105914(VarCurr)
    <=> v105903(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10444,axiom,
    ! [VarCurr: state_type] :
      ( v105898(VarCurr)
    <=> ( v105899(VarCurr)
        & v105910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10443,axiom,
    ! [VarCurr: state_type] :
      ( v105910(VarCurr)
    <=> ( v105901(VarCurr)
        | v105911(VarCurr) ) ) ).

tff(writeUnaryOperator_5458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105911(VarCurr)
    <=> v105864(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4216,axiom,
    ! [VarCurr: state_type] :
      ( v105899(VarCurr)
    <=> ( v105900(VarCurr)
        | v105864(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105900(VarCurr)
    <=> v105901(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4215,axiom,
    ! [VarCurr: state_type] :
      ( v105901(VarCurr)
    <=> ( v105864(VarCurr,3)
        | v105902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10442,axiom,
    ! [VarCurr: state_type] :
      ( v105902(VarCurr)
    <=> ( v105903(VarCurr)
        & v105909(VarCurr) ) ) ).

tff(writeUnaryOperator_5456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105909(VarCurr)
    <=> v105864(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4214,axiom,
    ! [VarCurr: state_type] :
      ( v105903(VarCurr)
    <=> ( v105864(VarCurr,2)
        | v105904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10441,axiom,
    ! [VarCurr: state_type] :
      ( v105904(VarCurr)
    <=> ( v105905(VarCurr)
        & v105908(VarCurr) ) ) ).

tff(writeUnaryOperator_5455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105908(VarCurr)
    <=> v105864(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4213,axiom,
    ! [VarCurr: state_type] :
      ( v105905(VarCurr)
    <=> ( v105864(VarCurr,1)
        | v105906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10440,axiom,
    ! [VarCurr: state_type] :
      ( v105906(VarCurr)
    <=> ( v105864(VarCurr,0)
        & v105907(VarCurr) ) ) ).

tff(writeUnaryOperator_5454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105907(VarCurr)
    <=> v105864(VarCurr,1) ) ).

tff(addAssignment_63957,axiom,
    ! [VarCurr: state_type] :
      ( v105894(VarCurr,0)
    <=> v105641(VarCurr) ) ).

tff(addAssignment_63956,axiom,
    ! [VarCurr: state_type] :
      ( v105894(VarCurr,1)
    <=> v105639(VarCurr) ) ).

tff(addAssignment_63955,axiom,
    ! [VarCurr: state_type] :
      ( v105894(VarCurr,2)
    <=> v105635(VarCurr) ) ).

tff(addAssignment_63954,axiom,
    ! [VarCurr: state_type] :
      ( v105894(VarCurr,3)
    <=> v105631(VarCurr) ) ).

tff(addAssignment_63953,axiom,
    ! [VarCurr: state_type] :
      ( v105894(VarCurr,4)
    <=> v105617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10439,axiom,
    ! [VarCurr: state_type] :
      ( v105886(VarCurr)
    <=> ( v105887(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10438,axiom,
    ! [VarCurr: state_type] :
      ( v105887(VarCurr)
    <=> ( v105888(VarCurr)
        & v105607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10437,axiom,
    ! [VarCurr: state_type] :
      ( v105888(VarCurr)
    <=> ( v105889(VarCurr)
        & v105893(VarCurr) ) ) ).

tff(writeUnaryOperator_5453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105893(VarCurr)
    <=> v105583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10436,axiom,
    ! [VarCurr: state_type] :
      ( v105889(VarCurr)
    <=> ( v105890(VarCurr)
        & v105892(VarCurr) ) ) ).

tff(writeUnaryOperator_5452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105892(VarCurr)
    <=> v105696(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10435,axiom,
    ! [VarCurr: state_type] :
      ( v105890(VarCurr)
    <=> ( v105862(VarCurr)
        & v105891(VarCurr) ) ) ).

tff(writeUnaryOperator_5451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105891(VarCurr)
    <=> v105778(VarCurr) ) ).

tff(addAssignment_63952,axiom,
    ! [VarCurr: state_type] :
      ( v105874(VarCurr)
    <=> v105876(VarCurr) ) ).

tff(addAssignment_63951,axiom,
    ! [VarCurr: state_type] :
      ( v105876(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63950,axiom,
    ! [VarCurr: state_type] :
      ( v105870(VarCurr)
    <=> v105872(VarCurr) ) ).

tff(addAssignment_63949,axiom,
    ! [VarCurr: state_type] :
      ( v105872(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_750,axiom,
    ! [VarCurr: state_type] :
      ( v105778(VarCurr)
    <=> ( ( v105780(VarCurr,4)
        <=> $false )
        & ( v105780(VarCurr,3)
        <=> $false )
        & ( v105780(VarCurr,2)
        <=> $false )
        & ( v105780(VarCurr,1)
        <=> $false )
        & ( v105780(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105780(VarCurr,B)
      <=> v105782(VarCurr,B) ) ) ).

tff(addAssignment_63947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105782(VarCurr,B)
      <=> v105784(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105844(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105784(VarNext,B)
            <=> v105784(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1277,axiom,
    ! [VarNext: state_type] :
      ( v105844(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105784(VarNext,B)
          <=> v105854(VarNext,B) ) ) ) ).

tff(addAssignment_63946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105854(VarNext,B)
          <=> v105852(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105852(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_815,axiom,
    ! [VarCurr: state_type] :
      ( v105855(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105852(VarCurr,B)
          <=> v105794(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10434,axiom,
    ! [VarCurr: state_type] :
      ( v105855(VarCurr)
    <=> ( v105856(VarCurr)
        & v105857(VarCurr) ) ) ).

tff(writeUnaryOperator_5450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105857(VarCurr)
    <=> v105790(VarCurr) ) ).

tff(writeUnaryOperator_5449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105856(VarCurr)
    <=> v105786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105844(VarNext)
      <=> v105845(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105845(VarNext)
      <=> ( v105846(VarNext)
          & v105839(VarNext) ) ) ) ).

tff(writeUnaryOperator_5448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105846(VarNext)
      <=> v105848(VarNext) ) ) ).

tff(addAssignment_63945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105848(VarNext)
      <=> v105839(VarCurr) ) ) ).

tff(addAssignment_63944,axiom,
    ! [VarCurr: state_type] :
      ( v105839(VarCurr)
    <=> v105841(VarCurr) ) ).

tff(addAssignment_63943,axiom,
    ! [VarCurr: state_type] :
      ( v105841(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105794(VarCurr,B)
      <=> v105796(VarCurr,B) ) ) ).

tff(addAssignment_63941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105796(VarCurr,B)
      <=> v105798(VarCurr,B) ) ) ).

tff(addAssignment_63940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105798(VarCurr,B)
      <=> v105800(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105802(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105800(VarCurr,B)
          <=> v105809(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_814,axiom,
    ! [VarCurr: state_type] :
      ( v105802(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105800(VarCurr,B)
          <=> v105808(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105778(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105809(VarCurr,B)
          <=> v105810(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_813,axiom,
    ! [VarCurr: state_type] :
      ( v105778(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105809(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63939,axiom,
    ! [VarCurr: state_type] :
      ( v105810(VarCurr,0)
    <=> v105836(VarCurr) ) ).

tff(addAssignment_63938,axiom,
    ! [VarCurr: state_type] :
      ( v105810(VarCurr,1)
    <=> v105834(VarCurr) ) ).

tff(addAssignment_63937,axiom,
    ! [VarCurr: state_type] :
      ( v105810(VarCurr,2)
    <=> v105830(VarCurr) ) ).

tff(addAssignment_63936,axiom,
    ! [VarCurr: state_type] :
      ( v105810(VarCurr,3)
    <=> v105826(VarCurr) ) ).

tff(addAssignment_63935,axiom,
    ! [VarCurr: state_type] :
      ( v105810(VarCurr,4)
    <=> v105812(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10431,axiom,
    ! [VarCurr: state_type] :
      ( v105834(VarCurr)
    <=> ( v105835(VarCurr)
        & v105837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10430,axiom,
    ! [VarCurr: state_type] :
      ( v105837(VarCurr)
    <=> ( v105780(VarCurr,0)
        | v105821(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4212,axiom,
    ! [VarCurr: state_type] :
      ( v105835(VarCurr)
    <=> ( v105836(VarCurr)
        | v105780(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105836(VarCurr)
    <=> v105780(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10429,axiom,
    ! [VarCurr: state_type] :
      ( v105830(VarCurr)
    <=> ( v105831(VarCurr)
        & v105833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10428,axiom,
    ! [VarCurr: state_type] :
      ( v105833(VarCurr)
    <=> ( v105819(VarCurr)
        | v105822(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4211,axiom,
    ! [VarCurr: state_type] :
      ( v105831(VarCurr)
    <=> ( v105832(VarCurr)
        | v105780(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105832(VarCurr)
    <=> v105819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10427,axiom,
    ! [VarCurr: state_type] :
      ( v105826(VarCurr)
    <=> ( v105827(VarCurr)
        & v105829(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10426,axiom,
    ! [VarCurr: state_type] :
      ( v105829(VarCurr)
    <=> ( v105817(VarCurr)
        | v105823(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4210,axiom,
    ! [VarCurr: state_type] :
      ( v105827(VarCurr)
    <=> ( v105828(VarCurr)
        | v105780(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105828(VarCurr)
    <=> v105817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10425,axiom,
    ! [VarCurr: state_type] :
      ( v105812(VarCurr)
    <=> ( v105813(VarCurr)
        & v105824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10424,axiom,
    ! [VarCurr: state_type] :
      ( v105824(VarCurr)
    <=> ( v105815(VarCurr)
        | v105825(VarCurr) ) ) ).

tff(writeUnaryOperator_5444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105825(VarCurr)
    <=> v105780(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4209,axiom,
    ! [VarCurr: state_type] :
      ( v105813(VarCurr)
    <=> ( v105814(VarCurr)
        | v105780(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105814(VarCurr)
    <=> v105815(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4208,axiom,
    ! [VarCurr: state_type] :
      ( v105815(VarCurr)
    <=> ( v105780(VarCurr,3)
        | v105816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10423,axiom,
    ! [VarCurr: state_type] :
      ( v105816(VarCurr)
    <=> ( v105817(VarCurr)
        & v105823(VarCurr) ) ) ).

tff(writeUnaryOperator_5442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105823(VarCurr)
    <=> v105780(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4207,axiom,
    ! [VarCurr: state_type] :
      ( v105817(VarCurr)
    <=> ( v105780(VarCurr,2)
        | v105818(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10422,axiom,
    ! [VarCurr: state_type] :
      ( v105818(VarCurr)
    <=> ( v105819(VarCurr)
        & v105822(VarCurr) ) ) ).

tff(writeUnaryOperator_5441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105822(VarCurr)
    <=> v105780(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4206,axiom,
    ! [VarCurr: state_type] :
      ( v105819(VarCurr)
    <=> ( v105780(VarCurr,1)
        | v105820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10421,axiom,
    ! [VarCurr: state_type] :
      ( v105820(VarCurr)
    <=> ( v105780(VarCurr,0)
        & v105821(VarCurr) ) ) ).

tff(writeUnaryOperator_5440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105821(VarCurr)
    <=> v105780(VarCurr,1) ) ).

tff(addAssignment_63934,axiom,
    ! [VarCurr: state_type] :
      ( v105808(VarCurr,0)
    <=> v105641(VarCurr) ) ).

tff(addAssignment_63933,axiom,
    ! [VarCurr: state_type] :
      ( v105808(VarCurr,1)
    <=> v105639(VarCurr) ) ).

tff(addAssignment_63932,axiom,
    ! [VarCurr: state_type] :
      ( v105808(VarCurr,2)
    <=> v105635(VarCurr) ) ).

tff(addAssignment_63931,axiom,
    ! [VarCurr: state_type] :
      ( v105808(VarCurr,3)
    <=> v105631(VarCurr) ) ).

tff(addAssignment_63930,axiom,
    ! [VarCurr: state_type] :
      ( v105808(VarCurr,4)
    <=> v105617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10420,axiom,
    ! [VarCurr: state_type] :
      ( v105802(VarCurr)
    <=> ( v105803(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10419,axiom,
    ! [VarCurr: state_type] :
      ( v105803(VarCurr)
    <=> ( v105804(VarCurr)
        & v105607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10418,axiom,
    ! [VarCurr: state_type] :
      ( v105804(VarCurr)
    <=> ( v105805(VarCurr)
        & v105807(VarCurr) ) ) ).

tff(writeUnaryOperator_5439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105807(VarCurr)
    <=> v105583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10417,axiom,
    ! [VarCurr: state_type] :
      ( v105805(VarCurr)
    <=> ( v105778(VarCurr)
        & v105806(VarCurr) ) ) ).

tff(writeUnaryOperator_5438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105806(VarCurr)
    <=> v105696(VarCurr) ) ).

tff(addAssignment_63929,axiom,
    ! [VarCurr: state_type] :
      ( v105790(VarCurr)
    <=> v105792(VarCurr) ) ).

tff(addAssignment_63928,axiom,
    ! [VarCurr: state_type] :
      ( v105792(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63927,axiom,
    ! [VarCurr: state_type] :
      ( v105786(VarCurr)
    <=> v105788(VarCurr) ) ).

tff(addAssignment_63926,axiom,
    ! [VarCurr: state_type] :
      ( v105788(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_749,axiom,
    ! [VarCurr: state_type] :
      ( v105696(VarCurr)
    <=> ( ( v105698(VarCurr,4)
        <=> $false )
        & ( v105698(VarCurr,3)
        <=> $false )
        & ( v105698(VarCurr,2)
        <=> $false )
        & ( v105698(VarCurr,1)
        <=> $false )
        & ( v105698(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105698(VarCurr,B)
      <=> v105700(VarCurr,B) ) ) ).

tff(addAssignment_63924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105700(VarCurr,B)
      <=> v105702(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105760(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105702(VarNext,B)
            <=> v105702(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1276,axiom,
    ! [VarNext: state_type] :
      ( v105760(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105702(VarNext,B)
          <=> v105770(VarNext,B) ) ) ) ).

tff(addAssignment_63923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105770(VarNext,B)
          <=> v105768(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105771(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105768(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_812,axiom,
    ! [VarCurr: state_type] :
      ( v105771(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105768(VarCurr,B)
          <=> v105712(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10416,axiom,
    ! [VarCurr: state_type] :
      ( v105771(VarCurr)
    <=> ( v105772(VarCurr)
        & v105773(VarCurr) ) ) ).

tff(writeUnaryOperator_5437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105773(VarCurr)
    <=> v105708(VarCurr) ) ).

tff(writeUnaryOperator_5436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105772(VarCurr)
    <=> v105704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105760(VarNext)
      <=> v105761(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105761(VarNext)
      <=> ( v105762(VarNext)
          & v105755(VarNext) ) ) ) ).

tff(writeUnaryOperator_5435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105762(VarNext)
      <=> v105764(VarNext) ) ) ).

tff(addAssignment_63922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105764(VarNext)
      <=> v105755(VarCurr) ) ) ).

tff(addAssignment_63921,axiom,
    ! [VarCurr: state_type] :
      ( v105755(VarCurr)
    <=> v105757(VarCurr) ) ).

tff(addAssignment_63920,axiom,
    ! [VarCurr: state_type] :
      ( v105757(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105712(VarCurr,B)
      <=> v105714(VarCurr,B) ) ) ).

tff(addAssignment_63918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105714(VarCurr,B)
      <=> v105716(VarCurr,B) ) ) ).

tff(addAssignment_63917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105716(VarCurr,B)
      <=> v105718(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105720(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105718(VarCurr,B)
          <=> v105725(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_811,axiom,
    ! [VarCurr: state_type] :
      ( v105720(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105718(VarCurr,B)
          <=> v105724(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105696(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105725(VarCurr,B)
          <=> v105726(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_810,axiom,
    ! [VarCurr: state_type] :
      ( v105696(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105725(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63916,axiom,
    ! [VarCurr: state_type] :
      ( v105726(VarCurr,0)
    <=> v105752(VarCurr) ) ).

tff(addAssignment_63915,axiom,
    ! [VarCurr: state_type] :
      ( v105726(VarCurr,1)
    <=> v105750(VarCurr) ) ).

tff(addAssignment_63914,axiom,
    ! [VarCurr: state_type] :
      ( v105726(VarCurr,2)
    <=> v105746(VarCurr) ) ).

tff(addAssignment_63913,axiom,
    ! [VarCurr: state_type] :
      ( v105726(VarCurr,3)
    <=> v105742(VarCurr) ) ).

tff(addAssignment_63912,axiom,
    ! [VarCurr: state_type] :
      ( v105726(VarCurr,4)
    <=> v105728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10413,axiom,
    ! [VarCurr: state_type] :
      ( v105750(VarCurr)
    <=> ( v105751(VarCurr)
        & v105753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10412,axiom,
    ! [VarCurr: state_type] :
      ( v105753(VarCurr)
    <=> ( v105698(VarCurr,0)
        | v105737(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4205,axiom,
    ! [VarCurr: state_type] :
      ( v105751(VarCurr)
    <=> ( v105752(VarCurr)
        | v105698(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105752(VarCurr)
    <=> v105698(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10411,axiom,
    ! [VarCurr: state_type] :
      ( v105746(VarCurr)
    <=> ( v105747(VarCurr)
        & v105749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10410,axiom,
    ! [VarCurr: state_type] :
      ( v105749(VarCurr)
    <=> ( v105735(VarCurr)
        | v105738(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4204,axiom,
    ! [VarCurr: state_type] :
      ( v105747(VarCurr)
    <=> ( v105748(VarCurr)
        | v105698(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105748(VarCurr)
    <=> v105735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10409,axiom,
    ! [VarCurr: state_type] :
      ( v105742(VarCurr)
    <=> ( v105743(VarCurr)
        & v105745(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10408,axiom,
    ! [VarCurr: state_type] :
      ( v105745(VarCurr)
    <=> ( v105733(VarCurr)
        | v105739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4203,axiom,
    ! [VarCurr: state_type] :
      ( v105743(VarCurr)
    <=> ( v105744(VarCurr)
        | v105698(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105744(VarCurr)
    <=> v105733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10407,axiom,
    ! [VarCurr: state_type] :
      ( v105728(VarCurr)
    <=> ( v105729(VarCurr)
        & v105740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10406,axiom,
    ! [VarCurr: state_type] :
      ( v105740(VarCurr)
    <=> ( v105731(VarCurr)
        | v105741(VarCurr) ) ) ).

tff(writeUnaryOperator_5431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105741(VarCurr)
    <=> v105698(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4202,axiom,
    ! [VarCurr: state_type] :
      ( v105729(VarCurr)
    <=> ( v105730(VarCurr)
        | v105698(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105730(VarCurr)
    <=> v105731(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4201,axiom,
    ! [VarCurr: state_type] :
      ( v105731(VarCurr)
    <=> ( v105698(VarCurr,3)
        | v105732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10405,axiom,
    ! [VarCurr: state_type] :
      ( v105732(VarCurr)
    <=> ( v105733(VarCurr)
        & v105739(VarCurr) ) ) ).

tff(writeUnaryOperator_5429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105739(VarCurr)
    <=> v105698(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4200,axiom,
    ! [VarCurr: state_type] :
      ( v105733(VarCurr)
    <=> ( v105698(VarCurr,2)
        | v105734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10404,axiom,
    ! [VarCurr: state_type] :
      ( v105734(VarCurr)
    <=> ( v105735(VarCurr)
        & v105738(VarCurr) ) ) ).

tff(writeUnaryOperator_5428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105738(VarCurr)
    <=> v105698(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4199,axiom,
    ! [VarCurr: state_type] :
      ( v105735(VarCurr)
    <=> ( v105698(VarCurr,1)
        | v105736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10403,axiom,
    ! [VarCurr: state_type] :
      ( v105736(VarCurr)
    <=> ( v105698(VarCurr,0)
        & v105737(VarCurr) ) ) ).

tff(writeUnaryOperator_5427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105737(VarCurr)
    <=> v105698(VarCurr,1) ) ).

tff(addAssignment_63911,axiom,
    ! [VarCurr: state_type] :
      ( v105724(VarCurr,0)
    <=> v105641(VarCurr) ) ).

tff(addAssignment_63910,axiom,
    ! [VarCurr: state_type] :
      ( v105724(VarCurr,1)
    <=> v105639(VarCurr) ) ).

tff(addAssignment_63909,axiom,
    ! [VarCurr: state_type] :
      ( v105724(VarCurr,2)
    <=> v105635(VarCurr) ) ).

tff(addAssignment_63908,axiom,
    ! [VarCurr: state_type] :
      ( v105724(VarCurr,3)
    <=> v105631(VarCurr) ) ).

tff(addAssignment_63907,axiom,
    ! [VarCurr: state_type] :
      ( v105724(VarCurr,4)
    <=> v105617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10402,axiom,
    ! [VarCurr: state_type] :
      ( v105720(VarCurr)
    <=> ( v105721(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10401,axiom,
    ! [VarCurr: state_type] :
      ( v105721(VarCurr)
    <=> ( v105722(VarCurr)
        & v105607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10400,axiom,
    ! [VarCurr: state_type] :
      ( v105722(VarCurr)
    <=> ( v105696(VarCurr)
        & v105723(VarCurr) ) ) ).

tff(writeUnaryOperator_5426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105723(VarCurr)
    <=> v105583(VarCurr) ) ).

tff(addAssignment_63906,axiom,
    ! [VarCurr: state_type] :
      ( v105708(VarCurr)
    <=> v105710(VarCurr) ) ).

tff(addAssignment_63905,axiom,
    ! [VarCurr: state_type] :
      ( v105710(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63904,axiom,
    ! [VarCurr: state_type] :
      ( v105704(VarCurr)
    <=> v105706(VarCurr) ) ).

tff(addAssignment_63903,axiom,
    ! [VarCurr: state_type] :
      ( v105706(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_748,axiom,
    ! [VarCurr: state_type] :
      ( v105583(VarCurr)
    <=> ( ( v105585(VarCurr,4)
        <=> $false )
        & ( v105585(VarCurr,3)
        <=> $false )
        & ( v105585(VarCurr,2)
        <=> $false )
        & ( v105585(VarCurr,1)
        <=> $false )
        & ( v105585(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105585(VarCurr,B)
      <=> v105587(VarCurr,B) ) ) ).

tff(addAssignment_63901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105587(VarCurr,B)
      <=> v105589(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105678(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105589(VarNext,B)
            <=> v105589(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1275,axiom,
    ! [VarNext: state_type] :
      ( v105678(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105589(VarNext,B)
          <=> v105688(VarNext,B) ) ) ) ).

tff(addAssignment_63900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105688(VarNext,B)
          <=> v105686(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105689(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105686(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_809,axiom,
    ! [VarCurr: state_type] :
      ( v105689(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105686(VarCurr,B)
          <=> v105599(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10399,axiom,
    ! [VarCurr: state_type] :
      ( v105689(VarCurr)
    <=> ( v105690(VarCurr)
        & v105691(VarCurr) ) ) ).

tff(writeUnaryOperator_5425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105691(VarCurr)
    <=> v105595(VarCurr) ) ).

tff(writeUnaryOperator_5424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105690(VarCurr)
    <=> v105591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105678(VarNext)
      <=> v105679(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105679(VarNext)
      <=> ( v105680(VarNext)
          & v105673(VarNext) ) ) ) ).

tff(writeUnaryOperator_5423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105680(VarNext)
      <=> v105682(VarNext) ) ) ).

tff(addAssignment_63899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105682(VarNext)
      <=> v105673(VarCurr) ) ) ).

tff(addAssignment_63898,axiom,
    ! [VarCurr: state_type] :
      ( v105673(VarCurr)
    <=> v105675(VarCurr) ) ).

tff(addAssignment_63897,axiom,
    ! [VarCurr: state_type] :
      ( v105675(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105599(VarCurr,B)
      <=> v105601(VarCurr,B) ) ) ).

tff(addAssignment_63895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105601(VarCurr,B)
      <=> v105603(VarCurr,B) ) ) ).

tff(addAssignment_63894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105603(VarCurr,B)
      <=> v105605(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105613(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105605(VarCurr,B)
          <=> v105643(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_808,axiom,
    ! [VarCurr: state_type] :
      ( v105613(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105605(VarCurr,B)
          <=> v105615(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105583(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105643(VarCurr,B)
          <=> v105644(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_807,axiom,
    ! [VarCurr: state_type] :
      ( v105583(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105643(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63893,axiom,
    ! [VarCurr: state_type] :
      ( v105644(VarCurr,0)
    <=> v105670(VarCurr) ) ).

tff(addAssignment_63892,axiom,
    ! [VarCurr: state_type] :
      ( v105644(VarCurr,1)
    <=> v105668(VarCurr) ) ).

tff(addAssignment_63891,axiom,
    ! [VarCurr: state_type] :
      ( v105644(VarCurr,2)
    <=> v105664(VarCurr) ) ).

tff(addAssignment_63890,axiom,
    ! [VarCurr: state_type] :
      ( v105644(VarCurr,3)
    <=> v105660(VarCurr) ) ).

tff(addAssignment_63889,axiom,
    ! [VarCurr: state_type] :
      ( v105644(VarCurr,4)
    <=> v105646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10396,axiom,
    ! [VarCurr: state_type] :
      ( v105668(VarCurr)
    <=> ( v105669(VarCurr)
        & v105671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10395,axiom,
    ! [VarCurr: state_type] :
      ( v105671(VarCurr)
    <=> ( v105585(VarCurr,0)
        | v105655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4198,axiom,
    ! [VarCurr: state_type] :
      ( v105669(VarCurr)
    <=> ( v105670(VarCurr)
        | v105585(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105670(VarCurr)
    <=> v105585(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10394,axiom,
    ! [VarCurr: state_type] :
      ( v105664(VarCurr)
    <=> ( v105665(VarCurr)
        & v105667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10393,axiom,
    ! [VarCurr: state_type] :
      ( v105667(VarCurr)
    <=> ( v105653(VarCurr)
        | v105656(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4197,axiom,
    ! [VarCurr: state_type] :
      ( v105665(VarCurr)
    <=> ( v105666(VarCurr)
        | v105585(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105666(VarCurr)
    <=> v105653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10392,axiom,
    ! [VarCurr: state_type] :
      ( v105660(VarCurr)
    <=> ( v105661(VarCurr)
        & v105663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10391,axiom,
    ! [VarCurr: state_type] :
      ( v105663(VarCurr)
    <=> ( v105651(VarCurr)
        | v105657(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4196,axiom,
    ! [VarCurr: state_type] :
      ( v105661(VarCurr)
    <=> ( v105662(VarCurr)
        | v105585(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105662(VarCurr)
    <=> v105651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10390,axiom,
    ! [VarCurr: state_type] :
      ( v105646(VarCurr)
    <=> ( v105647(VarCurr)
        & v105658(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10389,axiom,
    ! [VarCurr: state_type] :
      ( v105658(VarCurr)
    <=> ( v105649(VarCurr)
        | v105659(VarCurr) ) ) ).

tff(writeUnaryOperator_5419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105659(VarCurr)
    <=> v105585(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4195,axiom,
    ! [VarCurr: state_type] :
      ( v105647(VarCurr)
    <=> ( v105648(VarCurr)
        | v105585(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105648(VarCurr)
    <=> v105649(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4194,axiom,
    ! [VarCurr: state_type] :
      ( v105649(VarCurr)
    <=> ( v105585(VarCurr,3)
        | v105650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10388,axiom,
    ! [VarCurr: state_type] :
      ( v105650(VarCurr)
    <=> ( v105651(VarCurr)
        & v105657(VarCurr) ) ) ).

tff(writeUnaryOperator_5417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105657(VarCurr)
    <=> v105585(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4193,axiom,
    ! [VarCurr: state_type] :
      ( v105651(VarCurr)
    <=> ( v105585(VarCurr,2)
        | v105652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10387,axiom,
    ! [VarCurr: state_type] :
      ( v105652(VarCurr)
    <=> ( v105653(VarCurr)
        & v105656(VarCurr) ) ) ).

tff(writeUnaryOperator_5416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105656(VarCurr)
    <=> v105585(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4192,axiom,
    ! [VarCurr: state_type] :
      ( v105653(VarCurr)
    <=> ( v105585(VarCurr,1)
        | v105654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10386,axiom,
    ! [VarCurr: state_type] :
      ( v105654(VarCurr)
    <=> ( v105585(VarCurr,0)
        & v105655(VarCurr) ) ) ).

tff(writeUnaryOperator_5415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105655(VarCurr)
    <=> v105585(VarCurr,1) ) ).

tff(addAssignment_63888,axiom,
    ! [VarCurr: state_type] :
      ( v105615(VarCurr,0)
    <=> v105641(VarCurr) ) ).

tff(addAssignment_63887,axiom,
    ! [VarCurr: state_type] :
      ( v105615(VarCurr,1)
    <=> v105639(VarCurr) ) ).

tff(addAssignment_63886,axiom,
    ! [VarCurr: state_type] :
      ( v105615(VarCurr,2)
    <=> v105635(VarCurr) ) ).

tff(addAssignment_63885,axiom,
    ! [VarCurr: state_type] :
      ( v105615(VarCurr,3)
    <=> v105631(VarCurr) ) ).

tff(addAssignment_63884,axiom,
    ! [VarCurr: state_type] :
      ( v105615(VarCurr,4)
    <=> v105617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10385,axiom,
    ! [VarCurr: state_type] :
      ( v105639(VarCurr)
    <=> ( v105640(VarCurr)
        & v105642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10384,axiom,
    ! [VarCurr: state_type] :
      ( v105642(VarCurr)
    <=> ( v105611(VarCurr,0)
        | v105626(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4191,axiom,
    ! [VarCurr: state_type] :
      ( v105640(VarCurr)
    <=> ( v105641(VarCurr)
        | v105611(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105641(VarCurr)
    <=> v105611(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10383,axiom,
    ! [VarCurr: state_type] :
      ( v105635(VarCurr)
    <=> ( v105636(VarCurr)
        & v105638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10382,axiom,
    ! [VarCurr: state_type] :
      ( v105638(VarCurr)
    <=> ( v105624(VarCurr)
        | v105627(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4190,axiom,
    ! [VarCurr: state_type] :
      ( v105636(VarCurr)
    <=> ( v105637(VarCurr)
        | v105611(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105637(VarCurr)
    <=> v105624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10381,axiom,
    ! [VarCurr: state_type] :
      ( v105631(VarCurr)
    <=> ( v105632(VarCurr)
        & v105634(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10380,axiom,
    ! [VarCurr: state_type] :
      ( v105634(VarCurr)
    <=> ( v105622(VarCurr)
        | v105628(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4189,axiom,
    ! [VarCurr: state_type] :
      ( v105632(VarCurr)
    <=> ( v105633(VarCurr)
        | v105611(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105633(VarCurr)
    <=> v105622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10379,axiom,
    ! [VarCurr: state_type] :
      ( v105617(VarCurr)
    <=> ( v105618(VarCurr)
        & v105629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10378,axiom,
    ! [VarCurr: state_type] :
      ( v105629(VarCurr)
    <=> ( v105620(VarCurr)
        | v105630(VarCurr) ) ) ).

tff(writeUnaryOperator_5411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105630(VarCurr)
    <=> v105611(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4188,axiom,
    ! [VarCurr: state_type] :
      ( v105618(VarCurr)
    <=> ( v105619(VarCurr)
        | v105611(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105619(VarCurr)
    <=> v105620(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4187,axiom,
    ! [VarCurr: state_type] :
      ( v105620(VarCurr)
    <=> ( v105611(VarCurr,3)
        | v105621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10377,axiom,
    ! [VarCurr: state_type] :
      ( v105621(VarCurr)
    <=> ( v105622(VarCurr)
        & v105628(VarCurr) ) ) ).

tff(writeUnaryOperator_5409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105628(VarCurr)
    <=> v105611(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4186,axiom,
    ! [VarCurr: state_type] :
      ( v105622(VarCurr)
    <=> ( v105611(VarCurr,2)
        | v105623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10376,axiom,
    ! [VarCurr: state_type] :
      ( v105623(VarCurr)
    <=> ( v105624(VarCurr)
        & v105627(VarCurr) ) ) ).

tff(writeUnaryOperator_5408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105627(VarCurr)
    <=> v105611(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4185,axiom,
    ! [VarCurr: state_type] :
      ( v105624(VarCurr)
    <=> ( v105611(VarCurr,1)
        | v105625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10375,axiom,
    ! [VarCurr: state_type] :
      ( v105625(VarCurr)
    <=> ( v105611(VarCurr,0)
        & v105626(VarCurr) ) ) ).

tff(writeUnaryOperator_5407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105626(VarCurr)
    <=> v105611(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10374,axiom,
    ! [VarCurr: state_type] :
      ( v105613(VarCurr)
    <=> ( v105614(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10373,axiom,
    ! [VarCurr: state_type] :
      ( v105614(VarCurr)
    <=> ( v105583(VarCurr)
        & v105607(VarCurr) ) ) ).

tff(addAssignment_63883,axiom,
    ! [VarCurr: state_type] :
      ( v105611(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_63882,axiom,
    ! [VarCurr: state_type] :
      ( v105611(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_63881,axiom,
    ! [VarCurr: state_type] :
      ( v105611(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_63880,axiom,
    ! [VarCurr: state_type] :
      ( v105611(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_63879,axiom,
    ! [VarCurr: state_type] :
      ( v105611(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10372,axiom,
    ! [VarCurr: state_type] :
      ( v105607(VarCurr)
    <=> ( v105609(VarCurr)
        | v105404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10371,axiom,
    ! [VarCurr: state_type] :
      ( v105609(VarCurr)
    <=> ( v105286(VarCurr)
        | v105397(VarCurr) ) ) ).

tff(addAssignment_63878,axiom,
    ! [VarCurr: state_type] :
      ( v105595(VarCurr)
    <=> v105597(VarCurr) ) ).

tff(addAssignment_63877,axiom,
    ! [VarCurr: state_type] :
      ( v105597(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63876,axiom,
    ! [VarCurr: state_type] :
      ( v105591(VarCurr)
    <=> v105593(VarCurr) ) ).

tff(addAssignment_63875,axiom,
    ! [VarCurr: state_type] :
      ( v105593(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_63874,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,3)
    <=> v105480(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_747,axiom,
    ! [VarCurr: state_type] :
      ( v105480(VarCurr)
    <=> ( ( v105482(VarCurr,3)
        <=> $false )
        & ( v105482(VarCurr,2)
        <=> $false )
        & ( v105482(VarCurr,1)
        <=> $false )
        & ( v105482(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105482(VarCurr,B)
      <=> v105484(VarCurr,B) ) ) ).

tff(addAssignment_63872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105484(VarCurr,B)
      <=> v105486(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105563(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v105486(VarNext,B)
            <=> v105486(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1274,axiom,
    ! [VarNext: state_type] :
      ( v105563(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105486(VarNext,B)
          <=> v105573(VarNext,B) ) ) ) ).

tff(addAssignment_63871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105573(VarNext,B)
          <=> v105571(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105571(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_806,axiom,
    ! [VarCurr: state_type] :
      ( v105574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105571(VarCurr,B)
          <=> v105496(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10370,axiom,
    ! [VarCurr: state_type] :
      ( v105574(VarCurr)
    <=> ( v105575(VarCurr)
        & v105576(VarCurr) ) ) ).

tff(writeUnaryOperator_5406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105576(VarCurr)
    <=> v105492(VarCurr) ) ).

tff(writeUnaryOperator_5405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105575(VarCurr)
    <=> v105488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105563(VarNext)
      <=> v105564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105564(VarNext)
      <=> ( v105565(VarNext)
          & v105558(VarNext) ) ) ) ).

tff(writeUnaryOperator_5404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105565(VarNext)
      <=> v105567(VarNext) ) ) ).

tff(addAssignment_63870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105567(VarNext)
      <=> v105558(VarCurr) ) ) ).

tff(addAssignment_63869,axiom,
    ! [VarCurr: state_type] :
      ( v105558(VarCurr)
    <=> v105560(VarCurr) ) ).

tff(addAssignment_63868,axiom,
    ! [VarCurr: state_type] :
      ( v105560(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105496(VarCurr,B)
      <=> v105498(VarCurr,B) ) ) ).

tff(addAssignment_63866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105498(VarCurr,B)
      <=> v105500(VarCurr,B) ) ) ).

tff(addAssignment_63865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105500(VarCurr,B)
      <=> v105502(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105509(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105502(VarCurr,B)
          <=> v105531(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_805,axiom,
    ! [VarCurr: state_type] :
      ( v105509(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105502(VarCurr,B)
          <=> v105510(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105532(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105531(VarCurr,B)
          <=> v105533(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_804,axiom,
    ! [VarCurr: state_type] :
      ( v105532(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105531(VarCurr,B)
          <=> v105507(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105534(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105533(VarCurr,B)
          <=> v105535(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_803,axiom,
    ! [VarCurr: state_type] :
      ( v105534(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105533(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105535(VarCurr,B)
          <=> v105482(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_802,axiom,
    ! [VarCurr: state_type] :
      ( v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105535(VarCurr,B)
          <=> v105536(VarCurr,B) ) ) ) ).

tff(addAssignment_63864,axiom,
    ! [VarCurr: state_type] :
      ( v105536(VarCurr,0)
    <=> v105555(VarCurr) ) ).

tff(addAssignment_63863,axiom,
    ! [VarCurr: state_type] :
      ( v105536(VarCurr,1)
    <=> v105553(VarCurr) ) ).

tff(addAssignment_63862,axiom,
    ! [VarCurr: state_type] :
      ( v105536(VarCurr,2)
    <=> v105549(VarCurr) ) ).

tff(addAssignment_63861,axiom,
    ! [VarCurr: state_type] :
      ( v105536(VarCurr,3)
    <=> v105538(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10367,axiom,
    ! [VarCurr: state_type] :
      ( v105553(VarCurr)
    <=> ( v105554(VarCurr)
        & v105556(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10366,axiom,
    ! [VarCurr: state_type] :
      ( v105556(VarCurr)
    <=> ( v105482(VarCurr,0)
        | v105545(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4184,axiom,
    ! [VarCurr: state_type] :
      ( v105554(VarCurr)
    <=> ( v105555(VarCurr)
        | v105482(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105555(VarCurr)
    <=> v105482(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10365,axiom,
    ! [VarCurr: state_type] :
      ( v105549(VarCurr)
    <=> ( v105550(VarCurr)
        & v105552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10364,axiom,
    ! [VarCurr: state_type] :
      ( v105552(VarCurr)
    <=> ( v105543(VarCurr)
        | v105546(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4183,axiom,
    ! [VarCurr: state_type] :
      ( v105550(VarCurr)
    <=> ( v105551(VarCurr)
        | v105482(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105551(VarCurr)
    <=> v105543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10363,axiom,
    ! [VarCurr: state_type] :
      ( v105538(VarCurr)
    <=> ( v105539(VarCurr)
        & v105547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10362,axiom,
    ! [VarCurr: state_type] :
      ( v105547(VarCurr)
    <=> ( v105541(VarCurr)
        | v105548(VarCurr) ) ) ).

tff(writeUnaryOperator_5401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105548(VarCurr)
    <=> v105482(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4182,axiom,
    ! [VarCurr: state_type] :
      ( v105539(VarCurr)
    <=> ( v105540(VarCurr)
        | v105482(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105540(VarCurr)
    <=> v105541(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4181,axiom,
    ! [VarCurr: state_type] :
      ( v105541(VarCurr)
    <=> ( v105482(VarCurr,2)
        | v105542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10361,axiom,
    ! [VarCurr: state_type] :
      ( v105542(VarCurr)
    <=> ( v105543(VarCurr)
        & v105546(VarCurr) ) ) ).

tff(writeUnaryOperator_5399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105546(VarCurr)
    <=> v105482(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4180,axiom,
    ! [VarCurr: state_type] :
      ( v105543(VarCurr)
    <=> ( v105482(VarCurr,1)
        | v105544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10360,axiom,
    ! [VarCurr: state_type] :
      ( v105544(VarCurr)
    <=> ( v105482(VarCurr,0)
        & v105545(VarCurr) ) ) ).

tff(writeUnaryOperator_5398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105545(VarCurr)
    <=> v105482(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_746,axiom,
    ! [VarCurr: state_type] :
      ( v105534(VarCurr)
    <=> ( ( v105482(VarCurr,3)
        <=> $false )
        & ( v105482(VarCurr,2)
        <=> $false )
        & ( v105482(VarCurr,1)
        <=> $false )
        & ( v105482(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10359,axiom,
    ! [VarCurr: state_type] :
      ( v105532(VarCurr)
    <=> ( v105404(VarCurr)
        & v105480(VarCurr) ) ) ).

tff(addAssignment_63860,axiom,
    ! [VarCurr: state_type] :
      ( v105510(VarCurr,0)
    <=> v105529(VarCurr) ) ).

tff(addAssignment_63859,axiom,
    ! [VarCurr: state_type] :
      ( v105510(VarCurr,1)
    <=> v105527(VarCurr) ) ).

tff(addAssignment_63858,axiom,
    ! [VarCurr: state_type] :
      ( v105510(VarCurr,2)
    <=> v105523(VarCurr) ) ).

tff(addAssignment_63857,axiom,
    ! [VarCurr: state_type] :
      ( v105510(VarCurr,3)
    <=> v105512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10358,axiom,
    ! [VarCurr: state_type] :
      ( v105527(VarCurr)
    <=> ( v105528(VarCurr)
        & v105530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10357,axiom,
    ! [VarCurr: state_type] :
      ( v105530(VarCurr)
    <=> ( v105507(VarCurr,0)
        | v105519(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4179,axiom,
    ! [VarCurr: state_type] :
      ( v105528(VarCurr)
    <=> ( v105529(VarCurr)
        | v105507(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105529(VarCurr)
    <=> v105507(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10356,axiom,
    ! [VarCurr: state_type] :
      ( v105523(VarCurr)
    <=> ( v105524(VarCurr)
        & v105526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10355,axiom,
    ! [VarCurr: state_type] :
      ( v105526(VarCurr)
    <=> ( v105517(VarCurr)
        | v105520(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4178,axiom,
    ! [VarCurr: state_type] :
      ( v105524(VarCurr)
    <=> ( v105525(VarCurr)
        | v105507(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105525(VarCurr)
    <=> v105517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10354,axiom,
    ! [VarCurr: state_type] :
      ( v105512(VarCurr)
    <=> ( v105513(VarCurr)
        & v105521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10353,axiom,
    ! [VarCurr: state_type] :
      ( v105521(VarCurr)
    <=> ( v105515(VarCurr)
        | v105522(VarCurr) ) ) ).

tff(writeUnaryOperator_5395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105522(VarCurr)
    <=> v105507(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4177,axiom,
    ! [VarCurr: state_type] :
      ( v105513(VarCurr)
    <=> ( v105514(VarCurr)
        | v105507(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105514(VarCurr)
    <=> v105515(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4176,axiom,
    ! [VarCurr: state_type] :
      ( v105515(VarCurr)
    <=> ( v105507(VarCurr,2)
        | v105516(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10352,axiom,
    ! [VarCurr: state_type] :
      ( v105516(VarCurr)
    <=> ( v105517(VarCurr)
        & v105520(VarCurr) ) ) ).

tff(writeUnaryOperator_5393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105520(VarCurr)
    <=> v105507(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4175,axiom,
    ! [VarCurr: state_type] :
      ( v105517(VarCurr)
    <=> ( v105507(VarCurr,1)
        | v105518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10351,axiom,
    ! [VarCurr: state_type] :
      ( v105518(VarCurr)
    <=> ( v105507(VarCurr,0)
        & v105519(VarCurr) ) ) ).

tff(writeUnaryOperator_5392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105519(VarCurr)
    <=> v105507(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10350,axiom,
    ! [VarCurr: state_type] :
      ( v105509(VarCurr)
    <=> ( v105504(VarCurr)
        & v105480(VarCurr) ) ) ).

tff(addAssignment_63856,axiom,
    ! [VarCurr: state_type] :
      ( v105507(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_63855,axiom,
    ! [VarCurr: state_type] :
      ( v105507(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_63854,axiom,
    ! [VarCurr: state_type] :
      ( v105507(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_63853,axiom,
    ! [VarCurr: state_type] :
      ( v105507(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10349,axiom,
    ! [VarCurr: state_type] :
      ( v105504(VarCurr)
    <=> ( v105286(VarCurr)
        | v105397(VarCurr) ) ) ).

tff(addAssignment_63852,axiom,
    ! [VarCurr: state_type] :
      ( v105492(VarCurr)
    <=> v105494(VarCurr) ) ).

tff(addAssignment_63851,axiom,
    ! [VarCurr: state_type] :
      ( v105494(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63850,axiom,
    ! [VarCurr: state_type] :
      ( v105488(VarCurr)
    <=> v105490(VarCurr) ) ).

tff(addAssignment_63849,axiom,
    ! [VarCurr: state_type] :
      ( v105490(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_63848,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,3)
    <=> v105353(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_745,axiom,
    ! [VarCurr: state_type] :
      ( v105353(VarCurr)
    <=> ( ( v105355(VarCurr,1)
        <=> $false )
        & ( v105355(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v105355(VarCurr,B)
      <=> v105357(VarCurr,B) ) ) ).

tff(addAssignment_63846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v105357(VarCurr,B)
      <=> v105359(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105462(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v105359(VarNext,B)
            <=> v105359(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1273,axiom,
    ! [VarNext: state_type] :
      ( v105462(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105359(VarNext,B)
          <=> v105472(VarNext,B) ) ) ) ).

tff(addAssignment_63845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105472(VarNext,B)
          <=> v105470(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105473(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105470(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_801,axiom,
    ! [VarCurr: state_type] :
      ( v105473(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105470(VarCurr,B)
          <=> v105369(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10348,axiom,
    ! [VarCurr: state_type] :
      ( v105473(VarCurr)
    <=> ( v105474(VarCurr)
        & v105475(VarCurr) ) ) ).

tff(writeUnaryOperator_5391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105475(VarCurr)
    <=> v105365(VarCurr) ) ).

tff(writeUnaryOperator_5390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105474(VarCurr)
    <=> v105361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105462(VarNext)
      <=> v105463(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105463(VarNext)
      <=> ( v105464(VarNext)
          & v105457(VarNext) ) ) ) ).

tff(writeUnaryOperator_5389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105464(VarNext)
      <=> v105466(VarNext) ) ) ).

tff(addAssignment_63844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105466(VarNext)
      <=> v105457(VarCurr) ) ) ).

tff(addAssignment_63843,axiom,
    ! [VarCurr: state_type] :
      ( v105457(VarCurr)
    <=> v105459(VarCurr) ) ).

tff(addAssignment_63842,axiom,
    ! [VarCurr: state_type] :
      ( v105459(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v105369(VarCurr,B)
      <=> v105371(VarCurr,B) ) ) ).

tff(addAssignment_63840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v105371(VarCurr,B)
      <=> v105373(VarCurr,B) ) ) ).

tff(addAssignment_63839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v105373(VarCurr,B)
      <=> v105375(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105444(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105375(VarCurr,B)
          <=> v105445(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_800,axiom,
    ! [VarCurr: state_type] :
      ( v105444(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105375(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105446(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105445(VarCurr,B)
          <=> v105447(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_799,axiom,
    ! [VarCurr: state_type] :
      ( v105446(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105445(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105448(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105447(VarCurr,B)
          <=> v105449(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_798,axiom,
    ! [VarCurr: state_type] :
      ( v105448(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v105447(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63838,axiom,
    ! [VarCurr: state_type] :
      ( v105449(VarCurr,0)
    <=> v105453(VarCurr) ) ).

tff(addAssignment_63837,axiom,
    ! [VarCurr: state_type] :
      ( v105449(VarCurr,1)
    <=> v105451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10345,axiom,
    ! [VarCurr: state_type] :
      ( v105451(VarCurr)
    <=> ( v105452(VarCurr)
        & v105454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10344,axiom,
    ! [VarCurr: state_type] :
      ( v105454(VarCurr)
    <=> ( v105355(VarCurr,0)
        | v105455(VarCurr) ) ) ).

tff(writeUnaryOperator_5388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105455(VarCurr)
    <=> v105355(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4174,axiom,
    ! [VarCurr: state_type] :
      ( v105452(VarCurr)
    <=> ( v105453(VarCurr)
        | v105355(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105453(VarCurr)
    <=> v105355(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_744,axiom,
    ! [VarCurr: state_type] :
      ( v105448(VarCurr)
    <=> ( ( v105355(VarCurr,1)
        <=> $false )
        & ( v105355(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10343,axiom,
    ! [VarCurr: state_type] :
      ( v105446(VarCurr)
    <=> ( v105428(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10342,axiom,
    ! [VarCurr: state_type] :
      ( v105444(VarCurr)
    <=> ( v105377(VarCurr)
        & v105301(VarCurr) ) ) ).

tff(addAssignment_63836,axiom,
    ! [VarCurr: state_type] :
      ( v105428(VarCurr)
    <=> v105379(VarCurr,0) ) ).

tff(addAssignment_63835,axiom,
    ! [VarCurr: state_type] :
      ( v105379(VarCurr,0)
    <=> v105381(VarCurr,0) ) ).

tff(addAssignment_63834,axiom,
    ! [VarNext: state_type] :
      ( v105381(VarNext,0)
    <=> v105436(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105437(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v105436(VarNext,B)
            <=> v105381(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1272,axiom,
    ! [VarNext: state_type] :
      ( v105437(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v105436(VarNext,B)
          <=> v105421(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105437(VarNext)
      <=> v105438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105438(VarNext)
      <=> ( v105440(VarNext)
          & v105406(VarNext) ) ) ) ).

tff(writeUnaryOperator_5386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105440(VarNext)
      <=> v105415(VarNext) ) ) ).

tff(addAssignment_63833,axiom,
    ! [VarCurr: state_type] :
      ( v105391(VarCurr,0)
    <=> v105393(VarCurr,0) ) ).

tff(addAssignment_63832,axiom,
    ! [VarCurr: state_type] :
      ( v105393(VarCurr,0)
    <=> v105395(VarCurr,0) ) ).

tff(addAssignment_63831,axiom,
    ! [VarCurr: state_type] :
      ( v105395(VarCurr,0)
    <=> v105403(VarCurr,0) ) ).

tff(addAssignment_63830,axiom,
    ! [VarCurr: state_type] :
      ( v105404(VarCurr)
    <=> v103094(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4173,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,3)
    <=> ( v105431(VarCurr)
        | v105433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10339,axiom,
    ! [VarCurr: state_type] :
      ( v105433(VarCurr)
    <=> ( v103113(VarCurr)
        & v105434(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_743,axiom,
    ! [VarCurr: state_type] :
      ( v105434(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $false )
        & ( v103127(VarCurr,5)
        <=> $true )
        & ( v103127(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10338,axiom,
    ! [VarCurr: state_type] :
      ( v105431(VarCurr)
    <=> ( v103096(VarCurr)
        & v105432(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_742,axiom,
    ! [VarCurr: state_type] :
      ( v105432(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $false )
        & ( v103106(VarCurr,5)
        <=> $true )
        & ( v103106(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63829,axiom,
    ! [VarCurr: state_type] :
      ( v105377(VarCurr)
    <=> v105379(VarCurr,1) ) ).

tff(addAssignment_63828,axiom,
    ! [VarCurr: state_type] :
      ( v105379(VarCurr,1)
    <=> v105381(VarCurr,1) ) ).

tff(addAssignment_63827,axiom,
    ! [VarNext: state_type] :
      ( v105381(VarNext,1)
    <=> v105410(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105411(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v105410(VarNext,B)
            <=> v105381(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1271,axiom,
    ! [VarNext: state_type] :
      ( v105411(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v105410(VarNext,B)
          <=> v105421(VarNext,B) ) ) ) ).

tff(addAssignment_63826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v105421(VarNext,B)
          <=> v105419(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105422(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v105419(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_797,axiom,
    ! [VarCurr: state_type] :
      ( v105422(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v105419(VarCurr,B)
          <=> v105391(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10337,axiom,
    ! [VarCurr: state_type] :
      ( v105422(VarCurr)
    <=> ( v105423(VarCurr)
        & v105424(VarCurr) ) ) ).

tff(writeUnaryOperator_5385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105424(VarCurr)
    <=> v105387(VarCurr) ) ).

tff(writeUnaryOperator_5384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105423(VarCurr)
    <=> v105383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105411(VarNext)
      <=> v105412(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105412(VarNext)
      <=> ( v105413(VarNext)
          & v105406(VarNext) ) ) ) ).

tff(writeUnaryOperator_5383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105413(VarNext)
      <=> v105415(VarNext) ) ) ).

tff(addAssignment_63825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105415(VarNext)
      <=> v105406(VarCurr) ) ) ).

tff(addAssignment_63824,axiom,
    ! [VarCurr: state_type] :
      ( v105406(VarCurr)
    <=> v105408(VarCurr) ) ).

tff(addAssignment_63823,axiom,
    ! [VarCurr: state_type] :
      ( v105408(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63822,axiom,
    ! [VarCurr: state_type] :
      ( v105391(VarCurr,1)
    <=> v105393(VarCurr,1) ) ).

tff(addAssignment_63821,axiom,
    ! [VarCurr: state_type] :
      ( v105393(VarCurr,1)
    <=> v105395(VarCurr,1) ) ).

tff(addAssignment_63820,axiom,
    ! [VarCurr: state_type] :
      ( v105395(VarCurr,1)
    <=> v105403(VarCurr,1) ) ).

tff(addAssignment_63819,axiom,
    ! [VarCurr: state_type] :
      ( v105403(VarCurr,0)
    <=> v105404(VarCurr) ) ).

tff(addAssignment_63818,axiom,
    ! [VarCurr: state_type] :
      ( v105403(VarCurr,1)
    <=> v105397(VarCurr) ) ).

tff(addAssignment_63817,axiom,
    ! [VarCurr: state_type] :
      ( v105403(VarCurr,2)
    <=> v105286(VarCurr) ) ).

tff(addAssignment_63816,axiom,
    ! [VarCurr: state_type] :
      ( v105397(VarCurr)
    <=> v101499(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4172,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,3)
    <=> ( v105399(VarCurr)
        | v105401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10334,axiom,
    ! [VarCurr: state_type] :
      ( v105401(VarCurr)
    <=> ( v83096(VarCurr)
        & v105402(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_741,axiom,
    ! [VarCurr: state_type] :
      ( v105402(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10333,axiom,
    ! [VarCurr: state_type] :
      ( v105399(VarCurr)
    <=> ( v101501(VarCurr)
        & v105400(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_740,axiom,
    ! [VarCurr: state_type] :
      ( v105400(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $false )
        & ( v101563(VarCurr,5)
        <=> $true )
        & ( v101563(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63815,axiom,
    ! [VarCurr: state_type] :
      ( v105387(VarCurr)
    <=> v105389(VarCurr) ) ).

tff(addAssignment_63814,axiom,
    ! [VarCurr: state_type] :
      ( v105389(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63813,axiom,
    ! [VarCurr: state_type] :
      ( v105383(VarCurr)
    <=> v105385(VarCurr) ) ).

tff(addAssignment_63812,axiom,
    ! [VarCurr: state_type] :
      ( v105385(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_63811,axiom,
    ! [VarCurr: state_type] :
      ( v105365(VarCurr)
    <=> v105367(VarCurr) ) ).

tff(addAssignment_63810,axiom,
    ! [VarCurr: state_type] :
      ( v105367(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63809,axiom,
    ! [VarCurr: state_type] :
      ( v105361(VarCurr)
    <=> v105363(VarCurr) ) ).

tff(addAssignment_63808,axiom,
    ! [VarCurr: state_type] :
      ( v105363(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_63807,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,3)
    <=> v105254(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_739,axiom,
    ! [VarCurr: state_type] :
      ( v105254(VarCurr)
    <=> ( ( v105256(VarCurr,3)
        <=> $false )
        & ( v105256(VarCurr,2)
        <=> $false )
        & ( v105256(VarCurr,1)
        <=> $false )
        & ( v105256(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105256(VarCurr,B)
      <=> v105258(VarCurr,B) ) ) ).

tff(addAssignment_63805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105258(VarCurr,B)
      <=> v105260(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105335(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v105260(VarNext,B)
            <=> v105260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1270,axiom,
    ! [VarNext: state_type] :
      ( v105335(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105260(VarNext,B)
          <=> v105345(VarNext,B) ) ) ) ).

tff(addAssignment_63804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105345(VarNext,B)
          <=> v105343(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105346(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105343(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_796,axiom,
    ! [VarCurr: state_type] :
      ( v105346(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105343(VarCurr,B)
          <=> v105278(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10332,axiom,
    ! [VarCurr: state_type] :
      ( v105346(VarCurr)
    <=> ( v105347(VarCurr)
        & v105348(VarCurr) ) ) ).

tff(writeUnaryOperator_5382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105348(VarCurr)
    <=> v105270(VarCurr) ) ).

tff(writeUnaryOperator_5381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105347(VarCurr)
    <=> v105262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105335(VarNext)
      <=> v105336(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105336(VarNext)
      <=> ( v105337(VarNext)
          & v105328(VarNext) ) ) ) ).

tff(writeUnaryOperator_5380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105337(VarNext)
      <=> v105339(VarNext) ) ) ).

tff(addAssignment_63803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105339(VarNext)
      <=> v105328(VarCurr) ) ) ).

tff(addAssignment_63802,axiom,
    ! [VarCurr: state_type] :
      ( v105328(VarCurr)
    <=> v105330(VarCurr) ) ).

tff(addAssignment_63801,axiom,
    ! [VarCurr: state_type] :
      ( v105330(VarCurr)
    <=> v105332(VarCurr) ) ).

tff(addAssignment_63800,axiom,
    ! [VarCurr: state_type] :
      ( v105332(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105278(VarCurr,B)
      <=> v105280(VarCurr,B) ) ) ).

tff(addAssignment_63798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105280(VarCurr,B)
      <=> v105282(VarCurr,B) ) ) ).

tff(addAssignment_63797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105282(VarCurr,B)
      <=> v105284(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105286(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105284(VarCurr,B)
          <=> v105303(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_795,axiom,
    ! [VarCurr: state_type] :
      ( v105286(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105284(VarCurr,B)
          <=> v105299(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105304(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105303(VarCurr,B)
          <=> v105305(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_794,axiom,
    ! [VarCurr: state_type] :
      ( v105304(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105303(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105305(VarCurr,B)
          <=> v105256(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_793,axiom,
    ! [VarCurr: state_type] :
      ( v105301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v105305(VarCurr,B)
          <=> v105306(VarCurr,B) ) ) ) ).

tff(addAssignment_63796,axiom,
    ! [VarCurr: state_type] :
      ( v105306(VarCurr,0)
    <=> v105325(VarCurr) ) ).

tff(addAssignment_63795,axiom,
    ! [VarCurr: state_type] :
      ( v105306(VarCurr,1)
    <=> v105323(VarCurr) ) ).

tff(addAssignment_63794,axiom,
    ! [VarCurr: state_type] :
      ( v105306(VarCurr,2)
    <=> v105319(VarCurr) ) ).

tff(addAssignment_63793,axiom,
    ! [VarCurr: state_type] :
      ( v105306(VarCurr,3)
    <=> v105308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10329,axiom,
    ! [VarCurr: state_type] :
      ( v105323(VarCurr)
    <=> ( v105324(VarCurr)
        & v105326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10328,axiom,
    ! [VarCurr: state_type] :
      ( v105326(VarCurr)
    <=> ( v105256(VarCurr,0)
        | v105315(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4171,axiom,
    ! [VarCurr: state_type] :
      ( v105324(VarCurr)
    <=> ( v105325(VarCurr)
        | v105256(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105325(VarCurr)
    <=> v105256(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10327,axiom,
    ! [VarCurr: state_type] :
      ( v105319(VarCurr)
    <=> ( v105320(VarCurr)
        & v105322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10326,axiom,
    ! [VarCurr: state_type] :
      ( v105322(VarCurr)
    <=> ( v105313(VarCurr)
        | v105316(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4170,axiom,
    ! [VarCurr: state_type] :
      ( v105320(VarCurr)
    <=> ( v105321(VarCurr)
        | v105256(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105321(VarCurr)
    <=> v105313(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10325,axiom,
    ! [VarCurr: state_type] :
      ( v105308(VarCurr)
    <=> ( v105309(VarCurr)
        & v105317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10324,axiom,
    ! [VarCurr: state_type] :
      ( v105317(VarCurr)
    <=> ( v105311(VarCurr)
        | v105318(VarCurr) ) ) ).

tff(writeUnaryOperator_5377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105318(VarCurr)
    <=> v105256(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4169,axiom,
    ! [VarCurr: state_type] :
      ( v105309(VarCurr)
    <=> ( v105310(VarCurr)
        | v105256(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105310(VarCurr)
    <=> v105311(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4168,axiom,
    ! [VarCurr: state_type] :
      ( v105311(VarCurr)
    <=> ( v105256(VarCurr,2)
        | v105312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10323,axiom,
    ! [VarCurr: state_type] :
      ( v105312(VarCurr)
    <=> ( v105313(VarCurr)
        & v105316(VarCurr) ) ) ).

tff(writeUnaryOperator_5375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105316(VarCurr)
    <=> v105256(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4167,axiom,
    ! [VarCurr: state_type] :
      ( v105313(VarCurr)
    <=> ( v105256(VarCurr,1)
        | v105314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10322,axiom,
    ! [VarCurr: state_type] :
      ( v105314(VarCurr)
    <=> ( v105256(VarCurr,0)
        & v105315(VarCurr) ) ) ).

tff(writeUnaryOperator_5374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105315(VarCurr)
    <=> v105256(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_738,axiom,
    ! [VarCurr: state_type] :
      ( v105304(VarCurr)
    <=> ( ( v105256(VarCurr,3)
        <=> $false )
        & ( v105256(VarCurr,2)
        <=> $false )
        & ( v105256(VarCurr,1)
        <=> $false )
        & ( v105256(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63792,axiom,
    ! [VarCurr: state_type] :
      ( v105301(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_63791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v105299(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_63790,axiom,
    ! [VarCurr: state_type] :
      ( v105286(VarCurr)
    <=> v89212(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4166,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,3)
    <=> ( v105288(VarCurr)
        | v105296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10321,axiom,
    ! [VarCurr: state_type] :
      ( v105296(VarCurr)
    <=> ( v82954(VarCurr)
        & v105297(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_737,axiom,
    ! [VarCurr: state_type] :
      ( v105297(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10320,axiom,
    ! [VarCurr: state_type] :
      ( v105288(VarCurr)
    <=> ( v105289(VarCurr)
        | v105294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10319,axiom,
    ! [VarCurr: state_type] :
      ( v105294(VarCurr)
    <=> ( v86877(VarCurr)
        & v105295(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_736,axiom,
    ! [VarCurr: state_type] :
      ( v105295(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10318,axiom,
    ! [VarCurr: state_type] :
      ( v105289(VarCurr)
    <=> ( v105290(VarCurr)
        | v105292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10317,axiom,
    ! [VarCurr: state_type] :
      ( v105292(VarCurr)
    <=> ( v84899(VarCurr)
        & v105293(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_735,axiom,
    ! [VarCurr: state_type] :
      ( v105293(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $false )
        & ( v89243(VarCurr,5)
        <=> $true )
        & ( v89243(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10316,axiom,
    ! [VarCurr: state_type] :
      ( v105290(VarCurr)
    <=> ( v118(VarCurr)
        & v105291(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_734,axiom,
    ! [VarCurr: state_type] :
      ( v105291(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $false )
        & ( v89214(VarCurr,5)
        <=> $true )
        & ( v89214(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63789,axiom,
    ! [VarCurr: state_type] :
      ( v105270(VarCurr)
    <=> v105272(VarCurr) ) ).

tff(addAssignment_63788,axiom,
    ! [VarCurr: state_type] :
      ( v105272(VarCurr)
    <=> v105274(VarCurr) ) ).

tff(addAssignment_63787,axiom,
    ! [VarCurr: state_type] :
      ( v105274(VarCurr)
    <=> v105276(VarCurr) ) ).

tff(addAssignment_63786,axiom,
    ! [VarCurr: state_type] :
      ( v105276(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_63785,axiom,
    ! [VarCurr: state_type] :
      ( v105262(VarCurr)
    <=> v105264(VarCurr) ) ).

tff(addAssignment_63784,axiom,
    ! [VarCurr: state_type] :
      ( v105264(VarCurr)
    <=> v105266(VarCurr) ) ).

tff(addAssignment_63783,axiom,
    ! [VarCurr: state_type] :
      ( v105266(VarCurr)
    <=> v105268(VarCurr) ) ).

tff(addAssignment_63782,axiom,
    ! [VarCurr: state_type] :
      ( v105268(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_63781,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,2)
    <=> v104880(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10315,axiom,
    ! [VarCurr: state_type] :
      ( v104880(VarCurr)
    <=> ( v105247(VarCurr)
        & v105252(VarCurr) ) ) ).

tff(writeUnaryOperator_5373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105252(VarCurr)
    <=> v105161(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10314,axiom,
    ! [VarCurr: state_type] :
      ( v105247(VarCurr)
    <=> ( v105248(VarCurr)
        & v105251(VarCurr) ) ) ).

tff(writeUnaryOperator_5372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105251(VarCurr)
    <=> v105077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10313,axiom,
    ! [VarCurr: state_type] :
      ( v105248(VarCurr)
    <=> ( v105249(VarCurr)
        & v105250(VarCurr) ) ) ).

tff(writeUnaryOperator_5371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105250(VarCurr)
    <=> v104995(VarCurr) ) ).

tff(writeUnaryOperator_5370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105249(VarCurr)
    <=> v104882(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_733,axiom,
    ! [VarCurr: state_type] :
      ( v105161(VarCurr)
    <=> ( ( v105163(VarCurr,4)
        <=> $false )
        & ( v105163(VarCurr,3)
        <=> $false )
        & ( v105163(VarCurr,2)
        <=> $false )
        & ( v105163(VarCurr,1)
        <=> $false )
        & ( v105163(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105163(VarCurr,B)
      <=> v105165(VarCurr,B) ) ) ).

tff(addAssignment_63779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105165(VarCurr,B)
      <=> v105167(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105229(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105167(VarNext,B)
            <=> v105167(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1269,axiom,
    ! [VarNext: state_type] :
      ( v105229(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105167(VarNext,B)
          <=> v105239(VarNext,B) ) ) ) ).

tff(addAssignment_63778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105239(VarNext,B)
          <=> v105237(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105240(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105237(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_792,axiom,
    ! [VarCurr: state_type] :
      ( v105240(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105237(VarCurr,B)
          <=> v105177(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10312,axiom,
    ! [VarCurr: state_type] :
      ( v105240(VarCurr)
    <=> ( v105241(VarCurr)
        & v105242(VarCurr) ) ) ).

tff(writeUnaryOperator_5369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105242(VarCurr)
    <=> v105173(VarCurr) ) ).

tff(writeUnaryOperator_5368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105241(VarCurr)
    <=> v105169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105229(VarNext)
      <=> v105230(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105230(VarNext)
      <=> ( v105231(VarNext)
          & v105224(VarNext) ) ) ) ).

tff(writeUnaryOperator_5367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105231(VarNext)
      <=> v105233(VarNext) ) ) ).

tff(addAssignment_63777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105233(VarNext)
      <=> v105224(VarCurr) ) ) ).

tff(addAssignment_63776,axiom,
    ! [VarCurr: state_type] :
      ( v105224(VarCurr)
    <=> v105226(VarCurr) ) ).

tff(addAssignment_63775,axiom,
    ! [VarCurr: state_type] :
      ( v105226(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105177(VarCurr,B)
      <=> v105179(VarCurr,B) ) ) ).

tff(addAssignment_63773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105179(VarCurr,B)
      <=> v105181(VarCurr,B) ) ) ).

tff(addAssignment_63772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105181(VarCurr,B)
      <=> v105183(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105185(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105183(VarCurr,B)
          <=> v105194(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_791,axiom,
    ! [VarCurr: state_type] :
      ( v105185(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105183(VarCurr,B)
          <=> v105193(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105161(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105194(VarCurr,B)
          <=> v105195(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_790,axiom,
    ! [VarCurr: state_type] :
      ( v105161(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105194(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63771,axiom,
    ! [VarCurr: state_type] :
      ( v105195(VarCurr,0)
    <=> v105221(VarCurr) ) ).

tff(addAssignment_63770,axiom,
    ! [VarCurr: state_type] :
      ( v105195(VarCurr,1)
    <=> v105219(VarCurr) ) ).

tff(addAssignment_63769,axiom,
    ! [VarCurr: state_type] :
      ( v105195(VarCurr,2)
    <=> v105215(VarCurr) ) ).

tff(addAssignment_63768,axiom,
    ! [VarCurr: state_type] :
      ( v105195(VarCurr,3)
    <=> v105211(VarCurr) ) ).

tff(addAssignment_63767,axiom,
    ! [VarCurr: state_type] :
      ( v105195(VarCurr,4)
    <=> v105197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10309,axiom,
    ! [VarCurr: state_type] :
      ( v105219(VarCurr)
    <=> ( v105220(VarCurr)
        & v105222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10308,axiom,
    ! [VarCurr: state_type] :
      ( v105222(VarCurr)
    <=> ( v105163(VarCurr,0)
        | v105206(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4165,axiom,
    ! [VarCurr: state_type] :
      ( v105220(VarCurr)
    <=> ( v105221(VarCurr)
        | v105163(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105221(VarCurr)
    <=> v105163(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10307,axiom,
    ! [VarCurr: state_type] :
      ( v105215(VarCurr)
    <=> ( v105216(VarCurr)
        & v105218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10306,axiom,
    ! [VarCurr: state_type] :
      ( v105218(VarCurr)
    <=> ( v105204(VarCurr)
        | v105207(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4164,axiom,
    ! [VarCurr: state_type] :
      ( v105216(VarCurr)
    <=> ( v105217(VarCurr)
        | v105163(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105217(VarCurr)
    <=> v105204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10305,axiom,
    ! [VarCurr: state_type] :
      ( v105211(VarCurr)
    <=> ( v105212(VarCurr)
        & v105214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10304,axiom,
    ! [VarCurr: state_type] :
      ( v105214(VarCurr)
    <=> ( v105202(VarCurr)
        | v105208(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4163,axiom,
    ! [VarCurr: state_type] :
      ( v105212(VarCurr)
    <=> ( v105213(VarCurr)
        | v105163(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105213(VarCurr)
    <=> v105202(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10303,axiom,
    ! [VarCurr: state_type] :
      ( v105197(VarCurr)
    <=> ( v105198(VarCurr)
        & v105209(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10302,axiom,
    ! [VarCurr: state_type] :
      ( v105209(VarCurr)
    <=> ( v105200(VarCurr)
        | v105210(VarCurr) ) ) ).

tff(writeUnaryOperator_5363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105210(VarCurr)
    <=> v105163(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4162,axiom,
    ! [VarCurr: state_type] :
      ( v105198(VarCurr)
    <=> ( v105199(VarCurr)
        | v105163(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105199(VarCurr)
    <=> v105200(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4161,axiom,
    ! [VarCurr: state_type] :
      ( v105200(VarCurr)
    <=> ( v105163(VarCurr,3)
        | v105201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10301,axiom,
    ! [VarCurr: state_type] :
      ( v105201(VarCurr)
    <=> ( v105202(VarCurr)
        & v105208(VarCurr) ) ) ).

tff(writeUnaryOperator_5361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105208(VarCurr)
    <=> v105163(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4160,axiom,
    ! [VarCurr: state_type] :
      ( v105202(VarCurr)
    <=> ( v105163(VarCurr,2)
        | v105203(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10300,axiom,
    ! [VarCurr: state_type] :
      ( v105203(VarCurr)
    <=> ( v105204(VarCurr)
        & v105207(VarCurr) ) ) ).

tff(writeUnaryOperator_5360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105207(VarCurr)
    <=> v105163(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4159,axiom,
    ! [VarCurr: state_type] :
      ( v105204(VarCurr)
    <=> ( v105163(VarCurr,1)
        | v105205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10299,axiom,
    ! [VarCurr: state_type] :
      ( v105205(VarCurr)
    <=> ( v105163(VarCurr,0)
        & v105206(VarCurr) ) ) ).

tff(writeUnaryOperator_5359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105206(VarCurr)
    <=> v105163(VarCurr,1) ) ).

tff(addAssignment_63766,axiom,
    ! [VarCurr: state_type] :
      ( v105193(VarCurr,0)
    <=> v104940(VarCurr) ) ).

tff(addAssignment_63765,axiom,
    ! [VarCurr: state_type] :
      ( v105193(VarCurr,1)
    <=> v104938(VarCurr) ) ).

tff(addAssignment_63764,axiom,
    ! [VarCurr: state_type] :
      ( v105193(VarCurr,2)
    <=> v104934(VarCurr) ) ).

tff(addAssignment_63763,axiom,
    ! [VarCurr: state_type] :
      ( v105193(VarCurr,3)
    <=> v104930(VarCurr) ) ).

tff(addAssignment_63762,axiom,
    ! [VarCurr: state_type] :
      ( v105193(VarCurr,4)
    <=> v104916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10298,axiom,
    ! [VarCurr: state_type] :
      ( v105185(VarCurr)
    <=> ( v105186(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10297,axiom,
    ! [VarCurr: state_type] :
      ( v105186(VarCurr)
    <=> ( v105187(VarCurr)
        & v104906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10296,axiom,
    ! [VarCurr: state_type] :
      ( v105187(VarCurr)
    <=> ( v105188(VarCurr)
        & v105192(VarCurr) ) ) ).

tff(writeUnaryOperator_5358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105192(VarCurr)
    <=> v104882(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10295,axiom,
    ! [VarCurr: state_type] :
      ( v105188(VarCurr)
    <=> ( v105189(VarCurr)
        & v105191(VarCurr) ) ) ).

tff(writeUnaryOperator_5357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105191(VarCurr)
    <=> v104995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10294,axiom,
    ! [VarCurr: state_type] :
      ( v105189(VarCurr)
    <=> ( v105161(VarCurr)
        & v105190(VarCurr) ) ) ).

tff(writeUnaryOperator_5356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105190(VarCurr)
    <=> v105077(VarCurr) ) ).

tff(addAssignment_63761,axiom,
    ! [VarCurr: state_type] :
      ( v105173(VarCurr)
    <=> v105175(VarCurr) ) ).

tff(addAssignment_63760,axiom,
    ! [VarCurr: state_type] :
      ( v105175(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63759,axiom,
    ! [VarCurr: state_type] :
      ( v105169(VarCurr)
    <=> v105171(VarCurr) ) ).

tff(addAssignment_63758,axiom,
    ! [VarCurr: state_type] :
      ( v105171(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_732,axiom,
    ! [VarCurr: state_type] :
      ( v105077(VarCurr)
    <=> ( ( v105079(VarCurr,4)
        <=> $false )
        & ( v105079(VarCurr,3)
        <=> $false )
        & ( v105079(VarCurr,2)
        <=> $false )
        & ( v105079(VarCurr,1)
        <=> $false )
        & ( v105079(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105079(VarCurr,B)
      <=> v105081(VarCurr,B) ) ) ).

tff(addAssignment_63756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105081(VarCurr,B)
      <=> v105083(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105143(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105083(VarNext,B)
            <=> v105083(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1268,axiom,
    ! [VarNext: state_type] :
      ( v105143(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105083(VarNext,B)
          <=> v105153(VarNext,B) ) ) ) ).

tff(addAssignment_63755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105153(VarNext,B)
          <=> v105151(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105151(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_789,axiom,
    ! [VarCurr: state_type] :
      ( v105154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105151(VarCurr,B)
          <=> v105093(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10293,axiom,
    ! [VarCurr: state_type] :
      ( v105154(VarCurr)
    <=> ( v105155(VarCurr)
        & v105156(VarCurr) ) ) ).

tff(writeUnaryOperator_5355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105156(VarCurr)
    <=> v105089(VarCurr) ) ).

tff(writeUnaryOperator_5354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105155(VarCurr)
    <=> v105085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105143(VarNext)
      <=> v105144(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105144(VarNext)
      <=> ( v105145(VarNext)
          & v105138(VarNext) ) ) ) ).

tff(writeUnaryOperator_5353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105145(VarNext)
      <=> v105147(VarNext) ) ) ).

tff(addAssignment_63754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105147(VarNext)
      <=> v105138(VarCurr) ) ) ).

tff(addAssignment_63753,axiom,
    ! [VarCurr: state_type] :
      ( v105138(VarCurr)
    <=> v105140(VarCurr) ) ).

tff(addAssignment_63752,axiom,
    ! [VarCurr: state_type] :
      ( v105140(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105093(VarCurr,B)
      <=> v105095(VarCurr,B) ) ) ).

tff(addAssignment_63750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105095(VarCurr,B)
      <=> v105097(VarCurr,B) ) ) ).

tff(addAssignment_63749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105097(VarCurr,B)
      <=> v105099(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105101(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105099(VarCurr,B)
          <=> v105108(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_788,axiom,
    ! [VarCurr: state_type] :
      ( v105101(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105099(VarCurr,B)
          <=> v105107(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105108(VarCurr,B)
          <=> v105109(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_787,axiom,
    ! [VarCurr: state_type] :
      ( v105077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105108(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63748,axiom,
    ! [VarCurr: state_type] :
      ( v105109(VarCurr,0)
    <=> v105135(VarCurr) ) ).

tff(addAssignment_63747,axiom,
    ! [VarCurr: state_type] :
      ( v105109(VarCurr,1)
    <=> v105133(VarCurr) ) ).

tff(addAssignment_63746,axiom,
    ! [VarCurr: state_type] :
      ( v105109(VarCurr,2)
    <=> v105129(VarCurr) ) ).

tff(addAssignment_63745,axiom,
    ! [VarCurr: state_type] :
      ( v105109(VarCurr,3)
    <=> v105125(VarCurr) ) ).

tff(addAssignment_63744,axiom,
    ! [VarCurr: state_type] :
      ( v105109(VarCurr,4)
    <=> v105111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10290,axiom,
    ! [VarCurr: state_type] :
      ( v105133(VarCurr)
    <=> ( v105134(VarCurr)
        & v105136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10289,axiom,
    ! [VarCurr: state_type] :
      ( v105136(VarCurr)
    <=> ( v105079(VarCurr,0)
        | v105120(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4158,axiom,
    ! [VarCurr: state_type] :
      ( v105134(VarCurr)
    <=> ( v105135(VarCurr)
        | v105079(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105135(VarCurr)
    <=> v105079(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10288,axiom,
    ! [VarCurr: state_type] :
      ( v105129(VarCurr)
    <=> ( v105130(VarCurr)
        & v105132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10287,axiom,
    ! [VarCurr: state_type] :
      ( v105132(VarCurr)
    <=> ( v105118(VarCurr)
        | v105121(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4157,axiom,
    ! [VarCurr: state_type] :
      ( v105130(VarCurr)
    <=> ( v105131(VarCurr)
        | v105079(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105131(VarCurr)
    <=> v105118(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10286,axiom,
    ! [VarCurr: state_type] :
      ( v105125(VarCurr)
    <=> ( v105126(VarCurr)
        & v105128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10285,axiom,
    ! [VarCurr: state_type] :
      ( v105128(VarCurr)
    <=> ( v105116(VarCurr)
        | v105122(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4156,axiom,
    ! [VarCurr: state_type] :
      ( v105126(VarCurr)
    <=> ( v105127(VarCurr)
        | v105079(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105127(VarCurr)
    <=> v105116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10284,axiom,
    ! [VarCurr: state_type] :
      ( v105111(VarCurr)
    <=> ( v105112(VarCurr)
        & v105123(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10283,axiom,
    ! [VarCurr: state_type] :
      ( v105123(VarCurr)
    <=> ( v105114(VarCurr)
        | v105124(VarCurr) ) ) ).

tff(writeUnaryOperator_5349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105124(VarCurr)
    <=> v105079(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4155,axiom,
    ! [VarCurr: state_type] :
      ( v105112(VarCurr)
    <=> ( v105113(VarCurr)
        | v105079(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105113(VarCurr)
    <=> v105114(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4154,axiom,
    ! [VarCurr: state_type] :
      ( v105114(VarCurr)
    <=> ( v105079(VarCurr,3)
        | v105115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10282,axiom,
    ! [VarCurr: state_type] :
      ( v105115(VarCurr)
    <=> ( v105116(VarCurr)
        & v105122(VarCurr) ) ) ).

tff(writeUnaryOperator_5347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105122(VarCurr)
    <=> v105079(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4153,axiom,
    ! [VarCurr: state_type] :
      ( v105116(VarCurr)
    <=> ( v105079(VarCurr,2)
        | v105117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10281,axiom,
    ! [VarCurr: state_type] :
      ( v105117(VarCurr)
    <=> ( v105118(VarCurr)
        & v105121(VarCurr) ) ) ).

tff(writeUnaryOperator_5346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105121(VarCurr)
    <=> v105079(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4152,axiom,
    ! [VarCurr: state_type] :
      ( v105118(VarCurr)
    <=> ( v105079(VarCurr,1)
        | v105119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10280,axiom,
    ! [VarCurr: state_type] :
      ( v105119(VarCurr)
    <=> ( v105079(VarCurr,0)
        & v105120(VarCurr) ) ) ).

tff(writeUnaryOperator_5345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105120(VarCurr)
    <=> v105079(VarCurr,1) ) ).

tff(addAssignment_63743,axiom,
    ! [VarCurr: state_type] :
      ( v105107(VarCurr,0)
    <=> v104940(VarCurr) ) ).

tff(addAssignment_63742,axiom,
    ! [VarCurr: state_type] :
      ( v105107(VarCurr,1)
    <=> v104938(VarCurr) ) ).

tff(addAssignment_63741,axiom,
    ! [VarCurr: state_type] :
      ( v105107(VarCurr,2)
    <=> v104934(VarCurr) ) ).

tff(addAssignment_63740,axiom,
    ! [VarCurr: state_type] :
      ( v105107(VarCurr,3)
    <=> v104930(VarCurr) ) ).

tff(addAssignment_63739,axiom,
    ! [VarCurr: state_type] :
      ( v105107(VarCurr,4)
    <=> v104916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10279,axiom,
    ! [VarCurr: state_type] :
      ( v105101(VarCurr)
    <=> ( v105102(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10278,axiom,
    ! [VarCurr: state_type] :
      ( v105102(VarCurr)
    <=> ( v105103(VarCurr)
        & v104906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10277,axiom,
    ! [VarCurr: state_type] :
      ( v105103(VarCurr)
    <=> ( v105104(VarCurr)
        & v105106(VarCurr) ) ) ).

tff(writeUnaryOperator_5344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105106(VarCurr)
    <=> v104882(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10276,axiom,
    ! [VarCurr: state_type] :
      ( v105104(VarCurr)
    <=> ( v105077(VarCurr)
        & v105105(VarCurr) ) ) ).

tff(writeUnaryOperator_5343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105105(VarCurr)
    <=> v104995(VarCurr) ) ).

tff(addAssignment_63738,axiom,
    ! [VarCurr: state_type] :
      ( v105089(VarCurr)
    <=> v105091(VarCurr) ) ).

tff(addAssignment_63737,axiom,
    ! [VarCurr: state_type] :
      ( v105091(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63736,axiom,
    ! [VarCurr: state_type] :
      ( v105085(VarCurr)
    <=> v105087(VarCurr) ) ).

tff(addAssignment_63735,axiom,
    ! [VarCurr: state_type] :
      ( v105087(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_731,axiom,
    ! [VarCurr: state_type] :
      ( v104995(VarCurr)
    <=> ( ( v104997(VarCurr,4)
        <=> $false )
        & ( v104997(VarCurr,3)
        <=> $false )
        & ( v104997(VarCurr,2)
        <=> $false )
        & ( v104997(VarCurr,1)
        <=> $false )
        & ( v104997(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104997(VarCurr,B)
      <=> v104999(VarCurr,B) ) ) ).

tff(addAssignment_63733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104999(VarCurr,B)
      <=> v105001(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105059(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v105001(VarNext,B)
            <=> v105001(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1267,axiom,
    ! [VarNext: state_type] :
      ( v105059(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105001(VarNext,B)
          <=> v105069(VarNext,B) ) ) ) ).

tff(addAssignment_63732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105069(VarNext,B)
          <=> v105067(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105070(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105067(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_786,axiom,
    ! [VarCurr: state_type] :
      ( v105070(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105067(VarCurr,B)
          <=> v105011(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10275,axiom,
    ! [VarCurr: state_type] :
      ( v105070(VarCurr)
    <=> ( v105071(VarCurr)
        & v105072(VarCurr) ) ) ).

tff(writeUnaryOperator_5342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105072(VarCurr)
    <=> v105007(VarCurr) ) ).

tff(writeUnaryOperator_5341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105071(VarCurr)
    <=> v105003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105059(VarNext)
      <=> v105060(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105060(VarNext)
      <=> ( v105061(VarNext)
          & v105054(VarNext) ) ) ) ).

tff(writeUnaryOperator_5340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v105061(VarNext)
      <=> v105063(VarNext) ) ) ).

tff(addAssignment_63731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v105063(VarNext)
      <=> v105054(VarCurr) ) ) ).

tff(addAssignment_63730,axiom,
    ! [VarCurr: state_type] :
      ( v105054(VarCurr)
    <=> v105056(VarCurr) ) ).

tff(addAssignment_63729,axiom,
    ! [VarCurr: state_type] :
      ( v105056(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105011(VarCurr,B)
      <=> v105013(VarCurr,B) ) ) ).

tff(addAssignment_63727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105013(VarCurr,B)
      <=> v105015(VarCurr,B) ) ) ).

tff(addAssignment_63726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v105015(VarCurr,B)
      <=> v105017(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105017(VarCurr,B)
          <=> v105024(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_785,axiom,
    ! [VarCurr: state_type] :
      ( v105019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105017(VarCurr,B)
          <=> v105023(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105024(VarCurr,B)
          <=> v105025(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_784,axiom,
    ! [VarCurr: state_type] :
      ( v104995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v105024(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63725,axiom,
    ! [VarCurr: state_type] :
      ( v105025(VarCurr,0)
    <=> v105051(VarCurr) ) ).

tff(addAssignment_63724,axiom,
    ! [VarCurr: state_type] :
      ( v105025(VarCurr,1)
    <=> v105049(VarCurr) ) ).

tff(addAssignment_63723,axiom,
    ! [VarCurr: state_type] :
      ( v105025(VarCurr,2)
    <=> v105045(VarCurr) ) ).

tff(addAssignment_63722,axiom,
    ! [VarCurr: state_type] :
      ( v105025(VarCurr,3)
    <=> v105041(VarCurr) ) ).

tff(addAssignment_63721,axiom,
    ! [VarCurr: state_type] :
      ( v105025(VarCurr,4)
    <=> v105027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10272,axiom,
    ! [VarCurr: state_type] :
      ( v105049(VarCurr)
    <=> ( v105050(VarCurr)
        & v105052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10271,axiom,
    ! [VarCurr: state_type] :
      ( v105052(VarCurr)
    <=> ( v104997(VarCurr,0)
        | v105036(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4151,axiom,
    ! [VarCurr: state_type] :
      ( v105050(VarCurr)
    <=> ( v105051(VarCurr)
        | v104997(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105051(VarCurr)
    <=> v104997(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10270,axiom,
    ! [VarCurr: state_type] :
      ( v105045(VarCurr)
    <=> ( v105046(VarCurr)
        & v105048(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10269,axiom,
    ! [VarCurr: state_type] :
      ( v105048(VarCurr)
    <=> ( v105034(VarCurr)
        | v105037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4150,axiom,
    ! [VarCurr: state_type] :
      ( v105046(VarCurr)
    <=> ( v105047(VarCurr)
        | v104997(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105047(VarCurr)
    <=> v105034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10268,axiom,
    ! [VarCurr: state_type] :
      ( v105041(VarCurr)
    <=> ( v105042(VarCurr)
        & v105044(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10267,axiom,
    ! [VarCurr: state_type] :
      ( v105044(VarCurr)
    <=> ( v105032(VarCurr)
        | v105038(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4149,axiom,
    ! [VarCurr: state_type] :
      ( v105042(VarCurr)
    <=> ( v105043(VarCurr)
        | v104997(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105043(VarCurr)
    <=> v105032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10266,axiom,
    ! [VarCurr: state_type] :
      ( v105027(VarCurr)
    <=> ( v105028(VarCurr)
        & v105039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10265,axiom,
    ! [VarCurr: state_type] :
      ( v105039(VarCurr)
    <=> ( v105030(VarCurr)
        | v105040(VarCurr) ) ) ).

tff(writeUnaryOperator_5336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105040(VarCurr)
    <=> v104997(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4148,axiom,
    ! [VarCurr: state_type] :
      ( v105028(VarCurr)
    <=> ( v105029(VarCurr)
        | v104997(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105029(VarCurr)
    <=> v105030(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4147,axiom,
    ! [VarCurr: state_type] :
      ( v105030(VarCurr)
    <=> ( v104997(VarCurr,3)
        | v105031(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10264,axiom,
    ! [VarCurr: state_type] :
      ( v105031(VarCurr)
    <=> ( v105032(VarCurr)
        & v105038(VarCurr) ) ) ).

tff(writeUnaryOperator_5334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105038(VarCurr)
    <=> v104997(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4146,axiom,
    ! [VarCurr: state_type] :
      ( v105032(VarCurr)
    <=> ( v104997(VarCurr,2)
        | v105033(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10263,axiom,
    ! [VarCurr: state_type] :
      ( v105033(VarCurr)
    <=> ( v105034(VarCurr)
        & v105037(VarCurr) ) ) ).

tff(writeUnaryOperator_5333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105037(VarCurr)
    <=> v104997(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4145,axiom,
    ! [VarCurr: state_type] :
      ( v105034(VarCurr)
    <=> ( v104997(VarCurr,1)
        | v105035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10262,axiom,
    ! [VarCurr: state_type] :
      ( v105035(VarCurr)
    <=> ( v104997(VarCurr,0)
        & v105036(VarCurr) ) ) ).

tff(writeUnaryOperator_5332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105036(VarCurr)
    <=> v104997(VarCurr,1) ) ).

tff(addAssignment_63720,axiom,
    ! [VarCurr: state_type] :
      ( v105023(VarCurr,0)
    <=> v104940(VarCurr) ) ).

tff(addAssignment_63719,axiom,
    ! [VarCurr: state_type] :
      ( v105023(VarCurr,1)
    <=> v104938(VarCurr) ) ).

tff(addAssignment_63718,axiom,
    ! [VarCurr: state_type] :
      ( v105023(VarCurr,2)
    <=> v104934(VarCurr) ) ).

tff(addAssignment_63717,axiom,
    ! [VarCurr: state_type] :
      ( v105023(VarCurr,3)
    <=> v104930(VarCurr) ) ).

tff(addAssignment_63716,axiom,
    ! [VarCurr: state_type] :
      ( v105023(VarCurr,4)
    <=> v104916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10261,axiom,
    ! [VarCurr: state_type] :
      ( v105019(VarCurr)
    <=> ( v105020(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10260,axiom,
    ! [VarCurr: state_type] :
      ( v105020(VarCurr)
    <=> ( v105021(VarCurr)
        & v104906(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10259,axiom,
    ! [VarCurr: state_type] :
      ( v105021(VarCurr)
    <=> ( v104995(VarCurr)
        & v105022(VarCurr) ) ) ).

tff(writeUnaryOperator_5331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v105022(VarCurr)
    <=> v104882(VarCurr) ) ).

tff(addAssignment_63715,axiom,
    ! [VarCurr: state_type] :
      ( v105007(VarCurr)
    <=> v105009(VarCurr) ) ).

tff(addAssignment_63714,axiom,
    ! [VarCurr: state_type] :
      ( v105009(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63713,axiom,
    ! [VarCurr: state_type] :
      ( v105003(VarCurr)
    <=> v105005(VarCurr) ) ).

tff(addAssignment_63712,axiom,
    ! [VarCurr: state_type] :
      ( v105005(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_730,axiom,
    ! [VarCurr: state_type] :
      ( v104882(VarCurr)
    <=> ( ( v104884(VarCurr,4)
        <=> $false )
        & ( v104884(VarCurr,3)
        <=> $false )
        & ( v104884(VarCurr,2)
        <=> $false )
        & ( v104884(VarCurr,1)
        <=> $false )
        & ( v104884(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104884(VarCurr,B)
      <=> v104886(VarCurr,B) ) ) ).

tff(addAssignment_63710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104886(VarCurr,B)
      <=> v104888(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104977(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v104888(VarNext,B)
            <=> v104888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1266,axiom,
    ! [VarNext: state_type] :
      ( v104977(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104888(VarNext,B)
          <=> v104987(VarNext,B) ) ) ) ).

tff(addAssignment_63709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104987(VarNext,B)
          <=> v104985(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104988(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104985(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_783,axiom,
    ! [VarCurr: state_type] :
      ( v104988(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104985(VarCurr,B)
          <=> v104898(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10258,axiom,
    ! [VarCurr: state_type] :
      ( v104988(VarCurr)
    <=> ( v104989(VarCurr)
        & v104990(VarCurr) ) ) ).

tff(writeUnaryOperator_5330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104990(VarCurr)
    <=> v104894(VarCurr) ) ).

tff(writeUnaryOperator_5329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104989(VarCurr)
    <=> v104890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104977(VarNext)
      <=> v104978(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104978(VarNext)
      <=> ( v104979(VarNext)
          & v104972(VarNext) ) ) ) ).

tff(writeUnaryOperator_5328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104979(VarNext)
      <=> v104981(VarNext) ) ) ).

tff(addAssignment_63708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104981(VarNext)
      <=> v104972(VarCurr) ) ) ).

tff(addAssignment_63707,axiom,
    ! [VarCurr: state_type] :
      ( v104972(VarCurr)
    <=> v104974(VarCurr) ) ).

tff(addAssignment_63706,axiom,
    ! [VarCurr: state_type] :
      ( v104974(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104898(VarCurr,B)
      <=> v104900(VarCurr,B) ) ) ).

tff(addAssignment_63704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104900(VarCurr,B)
      <=> v104902(VarCurr,B) ) ) ).

tff(addAssignment_63703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104902(VarCurr,B)
      <=> v104904(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104904(VarCurr,B)
          <=> v104942(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_782,axiom,
    ! [VarCurr: state_type] :
      ( v104912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104904(VarCurr,B)
          <=> v104914(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104882(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104942(VarCurr,B)
          <=> v104943(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_781,axiom,
    ! [VarCurr: state_type] :
      ( v104882(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104942(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63702,axiom,
    ! [VarCurr: state_type] :
      ( v104943(VarCurr,0)
    <=> v104969(VarCurr) ) ).

tff(addAssignment_63701,axiom,
    ! [VarCurr: state_type] :
      ( v104943(VarCurr,1)
    <=> v104967(VarCurr) ) ).

tff(addAssignment_63700,axiom,
    ! [VarCurr: state_type] :
      ( v104943(VarCurr,2)
    <=> v104963(VarCurr) ) ).

tff(addAssignment_63699,axiom,
    ! [VarCurr: state_type] :
      ( v104943(VarCurr,3)
    <=> v104959(VarCurr) ) ).

tff(addAssignment_63698,axiom,
    ! [VarCurr: state_type] :
      ( v104943(VarCurr,4)
    <=> v104945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10255,axiom,
    ! [VarCurr: state_type] :
      ( v104967(VarCurr)
    <=> ( v104968(VarCurr)
        & v104970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10254,axiom,
    ! [VarCurr: state_type] :
      ( v104970(VarCurr)
    <=> ( v104884(VarCurr,0)
        | v104954(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4144,axiom,
    ! [VarCurr: state_type] :
      ( v104968(VarCurr)
    <=> ( v104969(VarCurr)
        | v104884(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104969(VarCurr)
    <=> v104884(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10253,axiom,
    ! [VarCurr: state_type] :
      ( v104963(VarCurr)
    <=> ( v104964(VarCurr)
        & v104966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10252,axiom,
    ! [VarCurr: state_type] :
      ( v104966(VarCurr)
    <=> ( v104952(VarCurr)
        | v104955(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4143,axiom,
    ! [VarCurr: state_type] :
      ( v104964(VarCurr)
    <=> ( v104965(VarCurr)
        | v104884(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104965(VarCurr)
    <=> v104952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10251,axiom,
    ! [VarCurr: state_type] :
      ( v104959(VarCurr)
    <=> ( v104960(VarCurr)
        & v104962(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10250,axiom,
    ! [VarCurr: state_type] :
      ( v104962(VarCurr)
    <=> ( v104950(VarCurr)
        | v104956(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4142,axiom,
    ! [VarCurr: state_type] :
      ( v104960(VarCurr)
    <=> ( v104961(VarCurr)
        | v104884(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104961(VarCurr)
    <=> v104950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10249,axiom,
    ! [VarCurr: state_type] :
      ( v104945(VarCurr)
    <=> ( v104946(VarCurr)
        & v104957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10248,axiom,
    ! [VarCurr: state_type] :
      ( v104957(VarCurr)
    <=> ( v104948(VarCurr)
        | v104958(VarCurr) ) ) ).

tff(writeUnaryOperator_5324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104958(VarCurr)
    <=> v104884(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4141,axiom,
    ! [VarCurr: state_type] :
      ( v104946(VarCurr)
    <=> ( v104947(VarCurr)
        | v104884(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104947(VarCurr)
    <=> v104948(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4140,axiom,
    ! [VarCurr: state_type] :
      ( v104948(VarCurr)
    <=> ( v104884(VarCurr,3)
        | v104949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10247,axiom,
    ! [VarCurr: state_type] :
      ( v104949(VarCurr)
    <=> ( v104950(VarCurr)
        & v104956(VarCurr) ) ) ).

tff(writeUnaryOperator_5322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104956(VarCurr)
    <=> v104884(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4139,axiom,
    ! [VarCurr: state_type] :
      ( v104950(VarCurr)
    <=> ( v104884(VarCurr,2)
        | v104951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10246,axiom,
    ! [VarCurr: state_type] :
      ( v104951(VarCurr)
    <=> ( v104952(VarCurr)
        & v104955(VarCurr) ) ) ).

tff(writeUnaryOperator_5321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104955(VarCurr)
    <=> v104884(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4138,axiom,
    ! [VarCurr: state_type] :
      ( v104952(VarCurr)
    <=> ( v104884(VarCurr,1)
        | v104953(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10245,axiom,
    ! [VarCurr: state_type] :
      ( v104953(VarCurr)
    <=> ( v104884(VarCurr,0)
        & v104954(VarCurr) ) ) ).

tff(writeUnaryOperator_5320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104954(VarCurr)
    <=> v104884(VarCurr,1) ) ).

tff(addAssignment_63697,axiom,
    ! [VarCurr: state_type] :
      ( v104914(VarCurr,0)
    <=> v104940(VarCurr) ) ).

tff(addAssignment_63696,axiom,
    ! [VarCurr: state_type] :
      ( v104914(VarCurr,1)
    <=> v104938(VarCurr) ) ).

tff(addAssignment_63695,axiom,
    ! [VarCurr: state_type] :
      ( v104914(VarCurr,2)
    <=> v104934(VarCurr) ) ).

tff(addAssignment_63694,axiom,
    ! [VarCurr: state_type] :
      ( v104914(VarCurr,3)
    <=> v104930(VarCurr) ) ).

tff(addAssignment_63693,axiom,
    ! [VarCurr: state_type] :
      ( v104914(VarCurr,4)
    <=> v104916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10244,axiom,
    ! [VarCurr: state_type] :
      ( v104938(VarCurr)
    <=> ( v104939(VarCurr)
        & v104941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10243,axiom,
    ! [VarCurr: state_type] :
      ( v104941(VarCurr)
    <=> ( v104910(VarCurr,0)
        | v104925(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4137,axiom,
    ! [VarCurr: state_type] :
      ( v104939(VarCurr)
    <=> ( v104940(VarCurr)
        | v104910(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104940(VarCurr)
    <=> v104910(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10242,axiom,
    ! [VarCurr: state_type] :
      ( v104934(VarCurr)
    <=> ( v104935(VarCurr)
        & v104937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10241,axiom,
    ! [VarCurr: state_type] :
      ( v104937(VarCurr)
    <=> ( v104923(VarCurr)
        | v104926(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4136,axiom,
    ! [VarCurr: state_type] :
      ( v104935(VarCurr)
    <=> ( v104936(VarCurr)
        | v104910(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104936(VarCurr)
    <=> v104923(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10240,axiom,
    ! [VarCurr: state_type] :
      ( v104930(VarCurr)
    <=> ( v104931(VarCurr)
        & v104933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10239,axiom,
    ! [VarCurr: state_type] :
      ( v104933(VarCurr)
    <=> ( v104921(VarCurr)
        | v104927(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4135,axiom,
    ! [VarCurr: state_type] :
      ( v104931(VarCurr)
    <=> ( v104932(VarCurr)
        | v104910(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104932(VarCurr)
    <=> v104921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10238,axiom,
    ! [VarCurr: state_type] :
      ( v104916(VarCurr)
    <=> ( v104917(VarCurr)
        & v104928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10237,axiom,
    ! [VarCurr: state_type] :
      ( v104928(VarCurr)
    <=> ( v104919(VarCurr)
        | v104929(VarCurr) ) ) ).

tff(writeUnaryOperator_5316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104929(VarCurr)
    <=> v104910(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4134,axiom,
    ! [VarCurr: state_type] :
      ( v104917(VarCurr)
    <=> ( v104918(VarCurr)
        | v104910(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104918(VarCurr)
    <=> v104919(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4133,axiom,
    ! [VarCurr: state_type] :
      ( v104919(VarCurr)
    <=> ( v104910(VarCurr,3)
        | v104920(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10236,axiom,
    ! [VarCurr: state_type] :
      ( v104920(VarCurr)
    <=> ( v104921(VarCurr)
        & v104927(VarCurr) ) ) ).

tff(writeUnaryOperator_5314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104927(VarCurr)
    <=> v104910(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4132,axiom,
    ! [VarCurr: state_type] :
      ( v104921(VarCurr)
    <=> ( v104910(VarCurr,2)
        | v104922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10235,axiom,
    ! [VarCurr: state_type] :
      ( v104922(VarCurr)
    <=> ( v104923(VarCurr)
        & v104926(VarCurr) ) ) ).

tff(writeUnaryOperator_5313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104926(VarCurr)
    <=> v104910(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4131,axiom,
    ! [VarCurr: state_type] :
      ( v104923(VarCurr)
    <=> ( v104910(VarCurr,1)
        | v104924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10234,axiom,
    ! [VarCurr: state_type] :
      ( v104924(VarCurr)
    <=> ( v104910(VarCurr,0)
        & v104925(VarCurr) ) ) ).

tff(writeUnaryOperator_5312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104925(VarCurr)
    <=> v104910(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10233,axiom,
    ! [VarCurr: state_type] :
      ( v104912(VarCurr)
    <=> ( v104913(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10232,axiom,
    ! [VarCurr: state_type] :
      ( v104913(VarCurr)
    <=> ( v104882(VarCurr)
        & v104906(VarCurr) ) ) ).

tff(addAssignment_63692,axiom,
    ! [VarCurr: state_type] :
      ( v104910(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_63691,axiom,
    ! [VarCurr: state_type] :
      ( v104910(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_63690,axiom,
    ! [VarCurr: state_type] :
      ( v104910(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_63689,axiom,
    ! [VarCurr: state_type] :
      ( v104910(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_63688,axiom,
    ! [VarCurr: state_type] :
      ( v104910(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10231,axiom,
    ! [VarCurr: state_type] :
      ( v104906(VarCurr)
    <=> ( v104908(VarCurr)
        | v104703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10230,axiom,
    ! [VarCurr: state_type] :
      ( v104908(VarCurr)
    <=> ( v104585(VarCurr)
        | v104696(VarCurr) ) ) ).

tff(addAssignment_63687,axiom,
    ! [VarCurr: state_type] :
      ( v104894(VarCurr)
    <=> v104896(VarCurr) ) ).

tff(addAssignment_63686,axiom,
    ! [VarCurr: state_type] :
      ( v104896(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63685,axiom,
    ! [VarCurr: state_type] :
      ( v104890(VarCurr)
    <=> v104892(VarCurr) ) ).

tff(addAssignment_63684,axiom,
    ! [VarCurr: state_type] :
      ( v104892(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_63683,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,2)
    <=> v104779(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_729,axiom,
    ! [VarCurr: state_type] :
      ( v104779(VarCurr)
    <=> ( ( v104781(VarCurr,3)
        <=> $false )
        & ( v104781(VarCurr,2)
        <=> $false )
        & ( v104781(VarCurr,1)
        <=> $false )
        & ( v104781(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104781(VarCurr,B)
      <=> v104783(VarCurr,B) ) ) ).

tff(addAssignment_63681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104783(VarCurr,B)
      <=> v104785(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104862(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v104785(VarNext,B)
            <=> v104785(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1265,axiom,
    ! [VarNext: state_type] :
      ( v104862(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104785(VarNext,B)
          <=> v104872(VarNext,B) ) ) ) ).

tff(addAssignment_63680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104872(VarNext,B)
          <=> v104870(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104873(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104870(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_780,axiom,
    ! [VarCurr: state_type] :
      ( v104873(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104870(VarCurr,B)
          <=> v104795(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10229,axiom,
    ! [VarCurr: state_type] :
      ( v104873(VarCurr)
    <=> ( v104874(VarCurr)
        & v104875(VarCurr) ) ) ).

tff(writeUnaryOperator_5311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104875(VarCurr)
    <=> v104791(VarCurr) ) ).

tff(writeUnaryOperator_5310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104874(VarCurr)
    <=> v104787(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104862(VarNext)
      <=> v104863(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104863(VarNext)
      <=> ( v104864(VarNext)
          & v104857(VarNext) ) ) ) ).

tff(writeUnaryOperator_5309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104864(VarNext)
      <=> v104866(VarNext) ) ) ).

tff(addAssignment_63679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104866(VarNext)
      <=> v104857(VarCurr) ) ) ).

tff(addAssignment_63678,axiom,
    ! [VarCurr: state_type] :
      ( v104857(VarCurr)
    <=> v104859(VarCurr) ) ).

tff(addAssignment_63677,axiom,
    ! [VarCurr: state_type] :
      ( v104859(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104795(VarCurr,B)
      <=> v104797(VarCurr,B) ) ) ).

tff(addAssignment_63675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104797(VarCurr,B)
      <=> v104799(VarCurr,B) ) ) ).

tff(addAssignment_63674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104799(VarCurr,B)
      <=> v104801(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104808(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104801(VarCurr,B)
          <=> v104830(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_779,axiom,
    ! [VarCurr: state_type] :
      ( v104808(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104801(VarCurr,B)
          <=> v104809(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104831(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104830(VarCurr,B)
          <=> v104832(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_778,axiom,
    ! [VarCurr: state_type] :
      ( v104831(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104830(VarCurr,B)
          <=> v104806(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104833(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104832(VarCurr,B)
          <=> v104834(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_777,axiom,
    ! [VarCurr: state_type] :
      ( v104833(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104832(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104834(VarCurr,B)
          <=> v104781(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_776,axiom,
    ! [VarCurr: state_type] :
      ( v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104834(VarCurr,B)
          <=> v104835(VarCurr,B) ) ) ) ).

tff(addAssignment_63673,axiom,
    ! [VarCurr: state_type] :
      ( v104835(VarCurr,0)
    <=> v104854(VarCurr) ) ).

tff(addAssignment_63672,axiom,
    ! [VarCurr: state_type] :
      ( v104835(VarCurr,1)
    <=> v104852(VarCurr) ) ).

tff(addAssignment_63671,axiom,
    ! [VarCurr: state_type] :
      ( v104835(VarCurr,2)
    <=> v104848(VarCurr) ) ).

tff(addAssignment_63670,axiom,
    ! [VarCurr: state_type] :
      ( v104835(VarCurr,3)
    <=> v104837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10226,axiom,
    ! [VarCurr: state_type] :
      ( v104852(VarCurr)
    <=> ( v104853(VarCurr)
        & v104855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10225,axiom,
    ! [VarCurr: state_type] :
      ( v104855(VarCurr)
    <=> ( v104781(VarCurr,0)
        | v104844(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4130,axiom,
    ! [VarCurr: state_type] :
      ( v104853(VarCurr)
    <=> ( v104854(VarCurr)
        | v104781(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104854(VarCurr)
    <=> v104781(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10224,axiom,
    ! [VarCurr: state_type] :
      ( v104848(VarCurr)
    <=> ( v104849(VarCurr)
        & v104851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10223,axiom,
    ! [VarCurr: state_type] :
      ( v104851(VarCurr)
    <=> ( v104842(VarCurr)
        | v104845(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4129,axiom,
    ! [VarCurr: state_type] :
      ( v104849(VarCurr)
    <=> ( v104850(VarCurr)
        | v104781(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104850(VarCurr)
    <=> v104842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10222,axiom,
    ! [VarCurr: state_type] :
      ( v104837(VarCurr)
    <=> ( v104838(VarCurr)
        & v104846(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10221,axiom,
    ! [VarCurr: state_type] :
      ( v104846(VarCurr)
    <=> ( v104840(VarCurr)
        | v104847(VarCurr) ) ) ).

tff(writeUnaryOperator_5306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104847(VarCurr)
    <=> v104781(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4128,axiom,
    ! [VarCurr: state_type] :
      ( v104838(VarCurr)
    <=> ( v104839(VarCurr)
        | v104781(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104839(VarCurr)
    <=> v104840(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4127,axiom,
    ! [VarCurr: state_type] :
      ( v104840(VarCurr)
    <=> ( v104781(VarCurr,2)
        | v104841(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10220,axiom,
    ! [VarCurr: state_type] :
      ( v104841(VarCurr)
    <=> ( v104842(VarCurr)
        & v104845(VarCurr) ) ) ).

tff(writeUnaryOperator_5304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104845(VarCurr)
    <=> v104781(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4126,axiom,
    ! [VarCurr: state_type] :
      ( v104842(VarCurr)
    <=> ( v104781(VarCurr,1)
        | v104843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10219,axiom,
    ! [VarCurr: state_type] :
      ( v104843(VarCurr)
    <=> ( v104781(VarCurr,0)
        & v104844(VarCurr) ) ) ).

tff(writeUnaryOperator_5303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104844(VarCurr)
    <=> v104781(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_728,axiom,
    ! [VarCurr: state_type] :
      ( v104833(VarCurr)
    <=> ( ( v104781(VarCurr,3)
        <=> $false )
        & ( v104781(VarCurr,2)
        <=> $false )
        & ( v104781(VarCurr,1)
        <=> $false )
        & ( v104781(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10218,axiom,
    ! [VarCurr: state_type] :
      ( v104831(VarCurr)
    <=> ( v104703(VarCurr)
        & v104779(VarCurr) ) ) ).

tff(addAssignment_63669,axiom,
    ! [VarCurr: state_type] :
      ( v104809(VarCurr,0)
    <=> v104828(VarCurr) ) ).

tff(addAssignment_63668,axiom,
    ! [VarCurr: state_type] :
      ( v104809(VarCurr,1)
    <=> v104826(VarCurr) ) ).

tff(addAssignment_63667,axiom,
    ! [VarCurr: state_type] :
      ( v104809(VarCurr,2)
    <=> v104822(VarCurr) ) ).

tff(addAssignment_63666,axiom,
    ! [VarCurr: state_type] :
      ( v104809(VarCurr,3)
    <=> v104811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10217,axiom,
    ! [VarCurr: state_type] :
      ( v104826(VarCurr)
    <=> ( v104827(VarCurr)
        & v104829(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10216,axiom,
    ! [VarCurr: state_type] :
      ( v104829(VarCurr)
    <=> ( v104806(VarCurr,0)
        | v104818(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4125,axiom,
    ! [VarCurr: state_type] :
      ( v104827(VarCurr)
    <=> ( v104828(VarCurr)
        | v104806(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104828(VarCurr)
    <=> v104806(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10215,axiom,
    ! [VarCurr: state_type] :
      ( v104822(VarCurr)
    <=> ( v104823(VarCurr)
        & v104825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10214,axiom,
    ! [VarCurr: state_type] :
      ( v104825(VarCurr)
    <=> ( v104816(VarCurr)
        | v104819(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4124,axiom,
    ! [VarCurr: state_type] :
      ( v104823(VarCurr)
    <=> ( v104824(VarCurr)
        | v104806(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104824(VarCurr)
    <=> v104816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10213,axiom,
    ! [VarCurr: state_type] :
      ( v104811(VarCurr)
    <=> ( v104812(VarCurr)
        & v104820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10212,axiom,
    ! [VarCurr: state_type] :
      ( v104820(VarCurr)
    <=> ( v104814(VarCurr)
        | v104821(VarCurr) ) ) ).

tff(writeUnaryOperator_5300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104821(VarCurr)
    <=> v104806(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4123,axiom,
    ! [VarCurr: state_type] :
      ( v104812(VarCurr)
    <=> ( v104813(VarCurr)
        | v104806(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104813(VarCurr)
    <=> v104814(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4122,axiom,
    ! [VarCurr: state_type] :
      ( v104814(VarCurr)
    <=> ( v104806(VarCurr,2)
        | v104815(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10211,axiom,
    ! [VarCurr: state_type] :
      ( v104815(VarCurr)
    <=> ( v104816(VarCurr)
        & v104819(VarCurr) ) ) ).

tff(writeUnaryOperator_5298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104819(VarCurr)
    <=> v104806(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4121,axiom,
    ! [VarCurr: state_type] :
      ( v104816(VarCurr)
    <=> ( v104806(VarCurr,1)
        | v104817(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10210,axiom,
    ! [VarCurr: state_type] :
      ( v104817(VarCurr)
    <=> ( v104806(VarCurr,0)
        & v104818(VarCurr) ) ) ).

tff(writeUnaryOperator_5297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104818(VarCurr)
    <=> v104806(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10209,axiom,
    ! [VarCurr: state_type] :
      ( v104808(VarCurr)
    <=> ( v104803(VarCurr)
        & v104779(VarCurr) ) ) ).

tff(addAssignment_63665,axiom,
    ! [VarCurr: state_type] :
      ( v104806(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_63664,axiom,
    ! [VarCurr: state_type] :
      ( v104806(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_63663,axiom,
    ! [VarCurr: state_type] :
      ( v104806(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_63662,axiom,
    ! [VarCurr: state_type] :
      ( v104806(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10208,axiom,
    ! [VarCurr: state_type] :
      ( v104803(VarCurr)
    <=> ( v104585(VarCurr)
        | v104696(VarCurr) ) ) ).

tff(addAssignment_63661,axiom,
    ! [VarCurr: state_type] :
      ( v104791(VarCurr)
    <=> v104793(VarCurr) ) ).

tff(addAssignment_63660,axiom,
    ! [VarCurr: state_type] :
      ( v104793(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63659,axiom,
    ! [VarCurr: state_type] :
      ( v104787(VarCurr)
    <=> v104789(VarCurr) ) ).

tff(addAssignment_63658,axiom,
    ! [VarCurr: state_type] :
      ( v104789(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_63657,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,2)
    <=> v104652(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_727,axiom,
    ! [VarCurr: state_type] :
      ( v104652(VarCurr)
    <=> ( ( v104654(VarCurr,1)
        <=> $false )
        & ( v104654(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v104654(VarCurr,B)
      <=> v104656(VarCurr,B) ) ) ).

tff(addAssignment_63655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v104656(VarCurr,B)
      <=> v104658(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104761(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v104658(VarNext,B)
            <=> v104658(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1264,axiom,
    ! [VarNext: state_type] :
      ( v104761(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104658(VarNext,B)
          <=> v104771(VarNext,B) ) ) ) ).

tff(addAssignment_63654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104771(VarNext,B)
          <=> v104769(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104772(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104769(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_775,axiom,
    ! [VarCurr: state_type] :
      ( v104772(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104769(VarCurr,B)
          <=> v104668(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10207,axiom,
    ! [VarCurr: state_type] :
      ( v104772(VarCurr)
    <=> ( v104773(VarCurr)
        & v104774(VarCurr) ) ) ).

tff(writeUnaryOperator_5296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104774(VarCurr)
    <=> v104664(VarCurr) ) ).

tff(writeUnaryOperator_5295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104773(VarCurr)
    <=> v104660(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104761(VarNext)
      <=> v104762(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104762(VarNext)
      <=> ( v104763(VarNext)
          & v104756(VarNext) ) ) ) ).

tff(writeUnaryOperator_5294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104763(VarNext)
      <=> v104765(VarNext) ) ) ).

tff(addAssignment_63653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104765(VarNext)
      <=> v104756(VarCurr) ) ) ).

tff(addAssignment_63652,axiom,
    ! [VarCurr: state_type] :
      ( v104756(VarCurr)
    <=> v104758(VarCurr) ) ).

tff(addAssignment_63651,axiom,
    ! [VarCurr: state_type] :
      ( v104758(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v104668(VarCurr,B)
      <=> v104670(VarCurr,B) ) ) ).

tff(addAssignment_63649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v104670(VarCurr,B)
      <=> v104672(VarCurr,B) ) ) ).

tff(addAssignment_63648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v104672(VarCurr,B)
      <=> v104674(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104743(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104674(VarCurr,B)
          <=> v104744(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_774,axiom,
    ! [VarCurr: state_type] :
      ( v104743(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104674(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104744(VarCurr,B)
          <=> v104746(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_773,axiom,
    ! [VarCurr: state_type] :
      ( v104745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104744(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104747(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104746(VarCurr,B)
          <=> v104748(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_772,axiom,
    ! [VarCurr: state_type] :
      ( v104747(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104746(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63647,axiom,
    ! [VarCurr: state_type] :
      ( v104748(VarCurr,0)
    <=> v104752(VarCurr) ) ).

tff(addAssignment_63646,axiom,
    ! [VarCurr: state_type] :
      ( v104748(VarCurr,1)
    <=> v104750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10204,axiom,
    ! [VarCurr: state_type] :
      ( v104750(VarCurr)
    <=> ( v104751(VarCurr)
        & v104753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10203,axiom,
    ! [VarCurr: state_type] :
      ( v104753(VarCurr)
    <=> ( v104654(VarCurr,0)
        | v104754(VarCurr) ) ) ).

tff(writeUnaryOperator_5293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104754(VarCurr)
    <=> v104654(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4120,axiom,
    ! [VarCurr: state_type] :
      ( v104751(VarCurr)
    <=> ( v104752(VarCurr)
        | v104654(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104752(VarCurr)
    <=> v104654(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_726,axiom,
    ! [VarCurr: state_type] :
      ( v104747(VarCurr)
    <=> ( ( v104654(VarCurr,1)
        <=> $false )
        & ( v104654(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10202,axiom,
    ! [VarCurr: state_type] :
      ( v104745(VarCurr)
    <=> ( v104727(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10201,axiom,
    ! [VarCurr: state_type] :
      ( v104743(VarCurr)
    <=> ( v104676(VarCurr)
        & v104600(VarCurr) ) ) ).

tff(addAssignment_63645,axiom,
    ! [VarCurr: state_type] :
      ( v104727(VarCurr)
    <=> v104678(VarCurr,0) ) ).

tff(addAssignment_63644,axiom,
    ! [VarCurr: state_type] :
      ( v104678(VarCurr,0)
    <=> v104680(VarCurr,0) ) ).

tff(addAssignment_63643,axiom,
    ! [VarNext: state_type] :
      ( v104680(VarNext,0)
    <=> v104735(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104736(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v104735(VarNext,B)
            <=> v104680(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1263,axiom,
    ! [VarNext: state_type] :
      ( v104736(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104735(VarNext,B)
          <=> v104720(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104736(VarNext)
      <=> v104737(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104737(VarNext)
      <=> ( v104739(VarNext)
          & v104705(VarNext) ) ) ) ).

tff(writeUnaryOperator_5291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104739(VarNext)
      <=> v104714(VarNext) ) ) ).

tff(addAssignment_63642,axiom,
    ! [VarCurr: state_type] :
      ( v104690(VarCurr,0)
    <=> v104692(VarCurr,0) ) ).

tff(addAssignment_63641,axiom,
    ! [VarCurr: state_type] :
      ( v104692(VarCurr,0)
    <=> v104694(VarCurr,0) ) ).

tff(addAssignment_63640,axiom,
    ! [VarCurr: state_type] :
      ( v104694(VarCurr,0)
    <=> v104702(VarCurr,0) ) ).

tff(addAssignment_63639,axiom,
    ! [VarCurr: state_type] :
      ( v104703(VarCurr)
    <=> v103094(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4119,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,2)
    <=> ( v104730(VarCurr)
        | v104732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10198,axiom,
    ! [VarCurr: state_type] :
      ( v104732(VarCurr)
    <=> ( v103113(VarCurr)
        & v104733(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_725,axiom,
    ! [VarCurr: state_type] :
      ( v104733(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $false )
        & ( v103127(VarCurr,5)
        <=> $true )
        & ( v103127(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10197,axiom,
    ! [VarCurr: state_type] :
      ( v104730(VarCurr)
    <=> ( v103096(VarCurr)
        & v104731(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_724,axiom,
    ! [VarCurr: state_type] :
      ( v104731(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $false )
        & ( v103106(VarCurr,5)
        <=> $true )
        & ( v103106(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63638,axiom,
    ! [VarCurr: state_type] :
      ( v104676(VarCurr)
    <=> v104678(VarCurr,1) ) ).

tff(addAssignment_63637,axiom,
    ! [VarCurr: state_type] :
      ( v104678(VarCurr,1)
    <=> v104680(VarCurr,1) ) ).

tff(addAssignment_63636,axiom,
    ! [VarNext: state_type] :
      ( v104680(VarNext,1)
    <=> v104709(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104710(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v104709(VarNext,B)
            <=> v104680(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1262,axiom,
    ! [VarNext: state_type] :
      ( v104710(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104709(VarNext,B)
          <=> v104720(VarNext,B) ) ) ) ).

tff(addAssignment_63635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104720(VarNext,B)
          <=> v104718(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104721(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104718(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_771,axiom,
    ! [VarCurr: state_type] :
      ( v104721(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104718(VarCurr,B)
          <=> v104690(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10196,axiom,
    ! [VarCurr: state_type] :
      ( v104721(VarCurr)
    <=> ( v104722(VarCurr)
        & v104723(VarCurr) ) ) ).

tff(writeUnaryOperator_5290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104723(VarCurr)
    <=> v104686(VarCurr) ) ).

tff(writeUnaryOperator_5289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104722(VarCurr)
    <=> v104682(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104710(VarNext)
      <=> v104711(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104711(VarNext)
      <=> ( v104712(VarNext)
          & v104705(VarNext) ) ) ) ).

tff(writeUnaryOperator_5288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104712(VarNext)
      <=> v104714(VarNext) ) ) ).

tff(addAssignment_63634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104714(VarNext)
      <=> v104705(VarCurr) ) ) ).

tff(addAssignment_63633,axiom,
    ! [VarCurr: state_type] :
      ( v104705(VarCurr)
    <=> v104707(VarCurr) ) ).

tff(addAssignment_63632,axiom,
    ! [VarCurr: state_type] :
      ( v104707(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63631,axiom,
    ! [VarCurr: state_type] :
      ( v104690(VarCurr,1)
    <=> v104692(VarCurr,1) ) ).

tff(addAssignment_63630,axiom,
    ! [VarCurr: state_type] :
      ( v104692(VarCurr,1)
    <=> v104694(VarCurr,1) ) ).

tff(addAssignment_63629,axiom,
    ! [VarCurr: state_type] :
      ( v104694(VarCurr,1)
    <=> v104702(VarCurr,1) ) ).

tff(addAssignment_63628,axiom,
    ! [VarCurr: state_type] :
      ( v104702(VarCurr,0)
    <=> v104703(VarCurr) ) ).

tff(addAssignment_63627,axiom,
    ! [VarCurr: state_type] :
      ( v104702(VarCurr,1)
    <=> v104696(VarCurr) ) ).

tff(addAssignment_63626,axiom,
    ! [VarCurr: state_type] :
      ( v104702(VarCurr,2)
    <=> v104585(VarCurr) ) ).

tff(addAssignment_63625,axiom,
    ! [VarCurr: state_type] :
      ( v104696(VarCurr)
    <=> v101499(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4118,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,2)
    <=> ( v104698(VarCurr)
        | v104700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10193,axiom,
    ! [VarCurr: state_type] :
      ( v104700(VarCurr)
    <=> ( v83096(VarCurr)
        & v104701(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_723,axiom,
    ! [VarCurr: state_type] :
      ( v104701(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10192,axiom,
    ! [VarCurr: state_type] :
      ( v104698(VarCurr)
    <=> ( v101501(VarCurr)
        & v104699(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_722,axiom,
    ! [VarCurr: state_type] :
      ( v104699(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $false )
        & ( v101563(VarCurr,5)
        <=> $true )
        & ( v101563(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63624,axiom,
    ! [VarCurr: state_type] :
      ( v104686(VarCurr)
    <=> v104688(VarCurr) ) ).

tff(addAssignment_63623,axiom,
    ! [VarCurr: state_type] :
      ( v104688(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63622,axiom,
    ! [VarCurr: state_type] :
      ( v104682(VarCurr)
    <=> v104684(VarCurr) ) ).

tff(addAssignment_63621,axiom,
    ! [VarCurr: state_type] :
      ( v104684(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_63620,axiom,
    ! [VarCurr: state_type] :
      ( v104664(VarCurr)
    <=> v104666(VarCurr) ) ).

tff(addAssignment_63619,axiom,
    ! [VarCurr: state_type] :
      ( v104666(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63618,axiom,
    ! [VarCurr: state_type] :
      ( v104660(VarCurr)
    <=> v104662(VarCurr) ) ).

tff(addAssignment_63617,axiom,
    ! [VarCurr: state_type] :
      ( v104662(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_63616,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,2)
    <=> v104553(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_721,axiom,
    ! [VarCurr: state_type] :
      ( v104553(VarCurr)
    <=> ( ( v104555(VarCurr,3)
        <=> $false )
        & ( v104555(VarCurr,2)
        <=> $false )
        & ( v104555(VarCurr,1)
        <=> $false )
        & ( v104555(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104555(VarCurr,B)
      <=> v104557(VarCurr,B) ) ) ).

tff(addAssignment_63614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104557(VarCurr,B)
      <=> v104559(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104634(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v104559(VarNext,B)
            <=> v104559(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1261,axiom,
    ! [VarNext: state_type] :
      ( v104634(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104559(VarNext,B)
          <=> v104644(VarNext,B) ) ) ) ).

tff(addAssignment_63613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104644(VarNext,B)
          <=> v104642(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104642(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_770,axiom,
    ! [VarCurr: state_type] :
      ( v104645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104642(VarCurr,B)
          <=> v104577(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10191,axiom,
    ! [VarCurr: state_type] :
      ( v104645(VarCurr)
    <=> ( v104646(VarCurr)
        & v104647(VarCurr) ) ) ).

tff(writeUnaryOperator_5287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104647(VarCurr)
    <=> v104569(VarCurr) ) ).

tff(writeUnaryOperator_5286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104646(VarCurr)
    <=> v104561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104634(VarNext)
      <=> v104635(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104635(VarNext)
      <=> ( v104636(VarNext)
          & v104627(VarNext) ) ) ) ).

tff(writeUnaryOperator_5285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104636(VarNext)
      <=> v104638(VarNext) ) ) ).

tff(addAssignment_63612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104638(VarNext)
      <=> v104627(VarCurr) ) ) ).

tff(addAssignment_63611,axiom,
    ! [VarCurr: state_type] :
      ( v104627(VarCurr)
    <=> v104629(VarCurr) ) ).

tff(addAssignment_63610,axiom,
    ! [VarCurr: state_type] :
      ( v104629(VarCurr)
    <=> v104631(VarCurr) ) ).

tff(addAssignment_63609,axiom,
    ! [VarCurr: state_type] :
      ( v104631(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104577(VarCurr,B)
      <=> v104579(VarCurr,B) ) ) ).

tff(addAssignment_63607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104579(VarCurr,B)
      <=> v104581(VarCurr,B) ) ) ).

tff(addAssignment_63606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104581(VarCurr,B)
      <=> v104583(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104585(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104583(VarCurr,B)
          <=> v104602(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_769,axiom,
    ! [VarCurr: state_type] :
      ( v104585(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104583(VarCurr,B)
          <=> v104598(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104603(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104602(VarCurr,B)
          <=> v104604(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_768,axiom,
    ! [VarCurr: state_type] :
      ( v104603(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104602(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104604(VarCurr,B)
          <=> v104555(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_767,axiom,
    ! [VarCurr: state_type] :
      ( v104600(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104604(VarCurr,B)
          <=> v104605(VarCurr,B) ) ) ) ).

tff(addAssignment_63605,axiom,
    ! [VarCurr: state_type] :
      ( v104605(VarCurr,0)
    <=> v104624(VarCurr) ) ).

tff(addAssignment_63604,axiom,
    ! [VarCurr: state_type] :
      ( v104605(VarCurr,1)
    <=> v104622(VarCurr) ) ).

tff(addAssignment_63603,axiom,
    ! [VarCurr: state_type] :
      ( v104605(VarCurr,2)
    <=> v104618(VarCurr) ) ).

tff(addAssignment_63602,axiom,
    ! [VarCurr: state_type] :
      ( v104605(VarCurr,3)
    <=> v104607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10188,axiom,
    ! [VarCurr: state_type] :
      ( v104622(VarCurr)
    <=> ( v104623(VarCurr)
        & v104625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10187,axiom,
    ! [VarCurr: state_type] :
      ( v104625(VarCurr)
    <=> ( v104555(VarCurr,0)
        | v104614(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4117,axiom,
    ! [VarCurr: state_type] :
      ( v104623(VarCurr)
    <=> ( v104624(VarCurr)
        | v104555(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104624(VarCurr)
    <=> v104555(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10186,axiom,
    ! [VarCurr: state_type] :
      ( v104618(VarCurr)
    <=> ( v104619(VarCurr)
        & v104621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10185,axiom,
    ! [VarCurr: state_type] :
      ( v104621(VarCurr)
    <=> ( v104612(VarCurr)
        | v104615(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4116,axiom,
    ! [VarCurr: state_type] :
      ( v104619(VarCurr)
    <=> ( v104620(VarCurr)
        | v104555(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104620(VarCurr)
    <=> v104612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10184,axiom,
    ! [VarCurr: state_type] :
      ( v104607(VarCurr)
    <=> ( v104608(VarCurr)
        & v104616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10183,axiom,
    ! [VarCurr: state_type] :
      ( v104616(VarCurr)
    <=> ( v104610(VarCurr)
        | v104617(VarCurr) ) ) ).

tff(writeUnaryOperator_5282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104617(VarCurr)
    <=> v104555(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4115,axiom,
    ! [VarCurr: state_type] :
      ( v104608(VarCurr)
    <=> ( v104609(VarCurr)
        | v104555(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104609(VarCurr)
    <=> v104610(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4114,axiom,
    ! [VarCurr: state_type] :
      ( v104610(VarCurr)
    <=> ( v104555(VarCurr,2)
        | v104611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10182,axiom,
    ! [VarCurr: state_type] :
      ( v104611(VarCurr)
    <=> ( v104612(VarCurr)
        & v104615(VarCurr) ) ) ).

tff(writeUnaryOperator_5280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104615(VarCurr)
    <=> v104555(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4113,axiom,
    ! [VarCurr: state_type] :
      ( v104612(VarCurr)
    <=> ( v104555(VarCurr,1)
        | v104613(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10181,axiom,
    ! [VarCurr: state_type] :
      ( v104613(VarCurr)
    <=> ( v104555(VarCurr,0)
        & v104614(VarCurr) ) ) ).

tff(writeUnaryOperator_5279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104614(VarCurr)
    <=> v104555(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_720,axiom,
    ! [VarCurr: state_type] :
      ( v104603(VarCurr)
    <=> ( ( v104555(VarCurr,3)
        <=> $false )
        & ( v104555(VarCurr,2)
        <=> $false )
        & ( v104555(VarCurr,1)
        <=> $false )
        & ( v104555(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63601,axiom,
    ! [VarCurr: state_type] :
      ( v104600(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_63600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104598(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_63599,axiom,
    ! [VarCurr: state_type] :
      ( v104585(VarCurr)
    <=> v89212(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4112,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,2)
    <=> ( v104587(VarCurr)
        | v104595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10180,axiom,
    ! [VarCurr: state_type] :
      ( v104595(VarCurr)
    <=> ( v82954(VarCurr)
        & v104596(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_719,axiom,
    ! [VarCurr: state_type] :
      ( v104596(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $true )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10179,axiom,
    ! [VarCurr: state_type] :
      ( v104587(VarCurr)
    <=> ( v104588(VarCurr)
        | v104593(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10178,axiom,
    ! [VarCurr: state_type] :
      ( v104593(VarCurr)
    <=> ( v86877(VarCurr)
        & v104594(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_718,axiom,
    ! [VarCurr: state_type] :
      ( v104594(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $true )
        & ( v88266(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10177,axiom,
    ! [VarCurr: state_type] :
      ( v104588(VarCurr)
    <=> ( v104589(VarCurr)
        | v104591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10176,axiom,
    ! [VarCurr: state_type] :
      ( v104591(VarCurr)
    <=> ( v84899(VarCurr)
        & v104592(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_717,axiom,
    ! [VarCurr: state_type] :
      ( v104592(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $false )
        & ( v89243(VarCurr,5)
        <=> $true )
        & ( v89243(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10175,axiom,
    ! [VarCurr: state_type] :
      ( v104589(VarCurr)
    <=> ( v118(VarCurr)
        & v104590(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_716,axiom,
    ! [VarCurr: state_type] :
      ( v104590(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $false )
        & ( v89214(VarCurr,5)
        <=> $true )
        & ( v89214(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63598,axiom,
    ! [VarCurr: state_type] :
      ( v104569(VarCurr)
    <=> v104571(VarCurr) ) ).

tff(addAssignment_63597,axiom,
    ! [VarCurr: state_type] :
      ( v104571(VarCurr)
    <=> v104573(VarCurr) ) ).

tff(addAssignment_63596,axiom,
    ! [VarCurr: state_type] :
      ( v104573(VarCurr)
    <=> v104575(VarCurr) ) ).

tff(addAssignment_63595,axiom,
    ! [VarCurr: state_type] :
      ( v104575(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_63594,axiom,
    ! [VarCurr: state_type] :
      ( v104561(VarCurr)
    <=> v104563(VarCurr) ) ).

tff(addAssignment_63593,axiom,
    ! [VarCurr: state_type] :
      ( v104563(VarCurr)
    <=> v104565(VarCurr) ) ).

tff(addAssignment_63592,axiom,
    ! [VarCurr: state_type] :
      ( v104565(VarCurr)
    <=> v104567(VarCurr) ) ).

tff(addAssignment_63591,axiom,
    ! [VarCurr: state_type] :
      ( v104567(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_63590,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,1)
    <=> v104179(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10174,axiom,
    ! [VarCurr: state_type] :
      ( v104179(VarCurr)
    <=> ( v104546(VarCurr)
        & v104551(VarCurr) ) ) ).

tff(writeUnaryOperator_5278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104551(VarCurr)
    <=> v104460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10173,axiom,
    ! [VarCurr: state_type] :
      ( v104546(VarCurr)
    <=> ( v104547(VarCurr)
        & v104550(VarCurr) ) ) ).

tff(writeUnaryOperator_5277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104550(VarCurr)
    <=> v104376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10172,axiom,
    ! [VarCurr: state_type] :
      ( v104547(VarCurr)
    <=> ( v104548(VarCurr)
        & v104549(VarCurr) ) ) ).

tff(writeUnaryOperator_5276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104549(VarCurr)
    <=> v104294(VarCurr) ) ).

tff(writeUnaryOperator_5275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104548(VarCurr)
    <=> v104181(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_715,axiom,
    ! [VarCurr: state_type] :
      ( v104460(VarCurr)
    <=> ( ( v104462(VarCurr,4)
        <=> $false )
        & ( v104462(VarCurr,3)
        <=> $false )
        & ( v104462(VarCurr,2)
        <=> $false )
        & ( v104462(VarCurr,1)
        <=> $false )
        & ( v104462(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104462(VarCurr,B)
      <=> v104464(VarCurr,B) ) ) ).

tff(addAssignment_63588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104464(VarCurr,B)
      <=> v104466(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104528(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v104466(VarNext,B)
            <=> v104466(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1260,axiom,
    ! [VarNext: state_type] :
      ( v104528(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104466(VarNext,B)
          <=> v104538(VarNext,B) ) ) ) ).

tff(addAssignment_63587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104538(VarNext,B)
          <=> v104536(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104539(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104536(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_766,axiom,
    ! [VarCurr: state_type] :
      ( v104539(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104536(VarCurr,B)
          <=> v104476(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10171,axiom,
    ! [VarCurr: state_type] :
      ( v104539(VarCurr)
    <=> ( v104540(VarCurr)
        & v104541(VarCurr) ) ) ).

tff(writeUnaryOperator_5274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104541(VarCurr)
    <=> v104472(VarCurr) ) ).

tff(writeUnaryOperator_5273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104540(VarCurr)
    <=> v104468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104528(VarNext)
      <=> v104529(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104529(VarNext)
      <=> ( v104530(VarNext)
          & v104523(VarNext) ) ) ) ).

tff(writeUnaryOperator_5272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104530(VarNext)
      <=> v104532(VarNext) ) ) ).

tff(addAssignment_63586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104532(VarNext)
      <=> v104523(VarCurr) ) ) ).

tff(addAssignment_63585,axiom,
    ! [VarCurr: state_type] :
      ( v104523(VarCurr)
    <=> v104525(VarCurr) ) ).

tff(addAssignment_63584,axiom,
    ! [VarCurr: state_type] :
      ( v104525(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104476(VarCurr,B)
      <=> v104478(VarCurr,B) ) ) ).

tff(addAssignment_63582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104478(VarCurr,B)
      <=> v104480(VarCurr,B) ) ) ).

tff(addAssignment_63581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104480(VarCurr,B)
      <=> v104482(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104484(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104482(VarCurr,B)
          <=> v104493(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_765,axiom,
    ! [VarCurr: state_type] :
      ( v104484(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104482(VarCurr,B)
          <=> v104492(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104460(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104493(VarCurr,B)
          <=> v104494(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_764,axiom,
    ! [VarCurr: state_type] :
      ( v104460(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104493(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63580,axiom,
    ! [VarCurr: state_type] :
      ( v104494(VarCurr,0)
    <=> v104520(VarCurr) ) ).

tff(addAssignment_63579,axiom,
    ! [VarCurr: state_type] :
      ( v104494(VarCurr,1)
    <=> v104518(VarCurr) ) ).

tff(addAssignment_63578,axiom,
    ! [VarCurr: state_type] :
      ( v104494(VarCurr,2)
    <=> v104514(VarCurr) ) ).

tff(addAssignment_63577,axiom,
    ! [VarCurr: state_type] :
      ( v104494(VarCurr,3)
    <=> v104510(VarCurr) ) ).

tff(addAssignment_63576,axiom,
    ! [VarCurr: state_type] :
      ( v104494(VarCurr,4)
    <=> v104496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10168,axiom,
    ! [VarCurr: state_type] :
      ( v104518(VarCurr)
    <=> ( v104519(VarCurr)
        & v104521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10167,axiom,
    ! [VarCurr: state_type] :
      ( v104521(VarCurr)
    <=> ( v104462(VarCurr,0)
        | v104505(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4111,axiom,
    ! [VarCurr: state_type] :
      ( v104519(VarCurr)
    <=> ( v104520(VarCurr)
        | v104462(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104520(VarCurr)
    <=> v104462(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10166,axiom,
    ! [VarCurr: state_type] :
      ( v104514(VarCurr)
    <=> ( v104515(VarCurr)
        & v104517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10165,axiom,
    ! [VarCurr: state_type] :
      ( v104517(VarCurr)
    <=> ( v104503(VarCurr)
        | v104506(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4110,axiom,
    ! [VarCurr: state_type] :
      ( v104515(VarCurr)
    <=> ( v104516(VarCurr)
        | v104462(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104516(VarCurr)
    <=> v104503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10164,axiom,
    ! [VarCurr: state_type] :
      ( v104510(VarCurr)
    <=> ( v104511(VarCurr)
        & v104513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10163,axiom,
    ! [VarCurr: state_type] :
      ( v104513(VarCurr)
    <=> ( v104501(VarCurr)
        | v104507(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4109,axiom,
    ! [VarCurr: state_type] :
      ( v104511(VarCurr)
    <=> ( v104512(VarCurr)
        | v104462(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104512(VarCurr)
    <=> v104501(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10162,axiom,
    ! [VarCurr: state_type] :
      ( v104496(VarCurr)
    <=> ( v104497(VarCurr)
        & v104508(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10161,axiom,
    ! [VarCurr: state_type] :
      ( v104508(VarCurr)
    <=> ( v104499(VarCurr)
        | v104509(VarCurr) ) ) ).

tff(writeUnaryOperator_5268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104509(VarCurr)
    <=> v104462(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4108,axiom,
    ! [VarCurr: state_type] :
      ( v104497(VarCurr)
    <=> ( v104498(VarCurr)
        | v104462(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104498(VarCurr)
    <=> v104499(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4107,axiom,
    ! [VarCurr: state_type] :
      ( v104499(VarCurr)
    <=> ( v104462(VarCurr,3)
        | v104500(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10160,axiom,
    ! [VarCurr: state_type] :
      ( v104500(VarCurr)
    <=> ( v104501(VarCurr)
        & v104507(VarCurr) ) ) ).

tff(writeUnaryOperator_5266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104507(VarCurr)
    <=> v104462(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4106,axiom,
    ! [VarCurr: state_type] :
      ( v104501(VarCurr)
    <=> ( v104462(VarCurr,2)
        | v104502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10159,axiom,
    ! [VarCurr: state_type] :
      ( v104502(VarCurr)
    <=> ( v104503(VarCurr)
        & v104506(VarCurr) ) ) ).

tff(writeUnaryOperator_5265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104506(VarCurr)
    <=> v104462(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4105,axiom,
    ! [VarCurr: state_type] :
      ( v104503(VarCurr)
    <=> ( v104462(VarCurr,1)
        | v104504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10158,axiom,
    ! [VarCurr: state_type] :
      ( v104504(VarCurr)
    <=> ( v104462(VarCurr,0)
        & v104505(VarCurr) ) ) ).

tff(writeUnaryOperator_5264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104505(VarCurr)
    <=> v104462(VarCurr,1) ) ).

tff(addAssignment_63575,axiom,
    ! [VarCurr: state_type] :
      ( v104492(VarCurr,0)
    <=> v104239(VarCurr) ) ).

tff(addAssignment_63574,axiom,
    ! [VarCurr: state_type] :
      ( v104492(VarCurr,1)
    <=> v104237(VarCurr) ) ).

tff(addAssignment_63573,axiom,
    ! [VarCurr: state_type] :
      ( v104492(VarCurr,2)
    <=> v104233(VarCurr) ) ).

tff(addAssignment_63572,axiom,
    ! [VarCurr: state_type] :
      ( v104492(VarCurr,3)
    <=> v104229(VarCurr) ) ).

tff(addAssignment_63571,axiom,
    ! [VarCurr: state_type] :
      ( v104492(VarCurr,4)
    <=> v104215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10157,axiom,
    ! [VarCurr: state_type] :
      ( v104484(VarCurr)
    <=> ( v104485(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10156,axiom,
    ! [VarCurr: state_type] :
      ( v104485(VarCurr)
    <=> ( v104486(VarCurr)
        & v104205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10155,axiom,
    ! [VarCurr: state_type] :
      ( v104486(VarCurr)
    <=> ( v104487(VarCurr)
        & v104491(VarCurr) ) ) ).

tff(writeUnaryOperator_5263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104491(VarCurr)
    <=> v104181(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10154,axiom,
    ! [VarCurr: state_type] :
      ( v104487(VarCurr)
    <=> ( v104488(VarCurr)
        & v104490(VarCurr) ) ) ).

tff(writeUnaryOperator_5262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104490(VarCurr)
    <=> v104294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10153,axiom,
    ! [VarCurr: state_type] :
      ( v104488(VarCurr)
    <=> ( v104460(VarCurr)
        & v104489(VarCurr) ) ) ).

tff(writeUnaryOperator_5261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104489(VarCurr)
    <=> v104376(VarCurr) ) ).

tff(addAssignment_63570,axiom,
    ! [VarCurr: state_type] :
      ( v104472(VarCurr)
    <=> v104474(VarCurr) ) ).

tff(addAssignment_63569,axiom,
    ! [VarCurr: state_type] :
      ( v104474(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63568,axiom,
    ! [VarCurr: state_type] :
      ( v104468(VarCurr)
    <=> v104470(VarCurr) ) ).

tff(addAssignment_63567,axiom,
    ! [VarCurr: state_type] :
      ( v104470(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_714,axiom,
    ! [VarCurr: state_type] :
      ( v104376(VarCurr)
    <=> ( ( v104378(VarCurr,4)
        <=> $false )
        & ( v104378(VarCurr,3)
        <=> $false )
        & ( v104378(VarCurr,2)
        <=> $false )
        & ( v104378(VarCurr,1)
        <=> $false )
        & ( v104378(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104378(VarCurr,B)
      <=> v104380(VarCurr,B) ) ) ).

tff(addAssignment_63565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104380(VarCurr,B)
      <=> v104382(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104442(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v104382(VarNext,B)
            <=> v104382(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1259,axiom,
    ! [VarNext: state_type] :
      ( v104442(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104382(VarNext,B)
          <=> v104452(VarNext,B) ) ) ) ).

tff(addAssignment_63564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104452(VarNext,B)
          <=> v104450(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104453(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104450(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_763,axiom,
    ! [VarCurr: state_type] :
      ( v104453(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104450(VarCurr,B)
          <=> v104392(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10152,axiom,
    ! [VarCurr: state_type] :
      ( v104453(VarCurr)
    <=> ( v104454(VarCurr)
        & v104455(VarCurr) ) ) ).

tff(writeUnaryOperator_5260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104455(VarCurr)
    <=> v104388(VarCurr) ) ).

tff(writeUnaryOperator_5259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104454(VarCurr)
    <=> v104384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104442(VarNext)
      <=> v104443(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104443(VarNext)
      <=> ( v104444(VarNext)
          & v104437(VarNext) ) ) ) ).

tff(writeUnaryOperator_5258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104444(VarNext)
      <=> v104446(VarNext) ) ) ).

tff(addAssignment_63563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104446(VarNext)
      <=> v104437(VarCurr) ) ) ).

tff(addAssignment_63562,axiom,
    ! [VarCurr: state_type] :
      ( v104437(VarCurr)
    <=> v104439(VarCurr) ) ).

tff(addAssignment_63561,axiom,
    ! [VarCurr: state_type] :
      ( v104439(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104392(VarCurr,B)
      <=> v104394(VarCurr,B) ) ) ).

tff(addAssignment_63559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104394(VarCurr,B)
      <=> v104396(VarCurr,B) ) ) ).

tff(addAssignment_63558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104396(VarCurr,B)
      <=> v104398(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104400(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104398(VarCurr,B)
          <=> v104407(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_762,axiom,
    ! [VarCurr: state_type] :
      ( v104400(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104398(VarCurr,B)
          <=> v104406(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104376(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104407(VarCurr,B)
          <=> v104408(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_761,axiom,
    ! [VarCurr: state_type] :
      ( v104376(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104407(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63557,axiom,
    ! [VarCurr: state_type] :
      ( v104408(VarCurr,0)
    <=> v104434(VarCurr) ) ).

tff(addAssignment_63556,axiom,
    ! [VarCurr: state_type] :
      ( v104408(VarCurr,1)
    <=> v104432(VarCurr) ) ).

tff(addAssignment_63555,axiom,
    ! [VarCurr: state_type] :
      ( v104408(VarCurr,2)
    <=> v104428(VarCurr) ) ).

tff(addAssignment_63554,axiom,
    ! [VarCurr: state_type] :
      ( v104408(VarCurr,3)
    <=> v104424(VarCurr) ) ).

tff(addAssignment_63553,axiom,
    ! [VarCurr: state_type] :
      ( v104408(VarCurr,4)
    <=> v104410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10149,axiom,
    ! [VarCurr: state_type] :
      ( v104432(VarCurr)
    <=> ( v104433(VarCurr)
        & v104435(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10148,axiom,
    ! [VarCurr: state_type] :
      ( v104435(VarCurr)
    <=> ( v104378(VarCurr,0)
        | v104419(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4104,axiom,
    ! [VarCurr: state_type] :
      ( v104433(VarCurr)
    <=> ( v104434(VarCurr)
        | v104378(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104434(VarCurr)
    <=> v104378(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10147,axiom,
    ! [VarCurr: state_type] :
      ( v104428(VarCurr)
    <=> ( v104429(VarCurr)
        & v104431(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10146,axiom,
    ! [VarCurr: state_type] :
      ( v104431(VarCurr)
    <=> ( v104417(VarCurr)
        | v104420(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4103,axiom,
    ! [VarCurr: state_type] :
      ( v104429(VarCurr)
    <=> ( v104430(VarCurr)
        | v104378(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104430(VarCurr)
    <=> v104417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10145,axiom,
    ! [VarCurr: state_type] :
      ( v104424(VarCurr)
    <=> ( v104425(VarCurr)
        & v104427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10144,axiom,
    ! [VarCurr: state_type] :
      ( v104427(VarCurr)
    <=> ( v104415(VarCurr)
        | v104421(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4102,axiom,
    ! [VarCurr: state_type] :
      ( v104425(VarCurr)
    <=> ( v104426(VarCurr)
        | v104378(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104426(VarCurr)
    <=> v104415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10143,axiom,
    ! [VarCurr: state_type] :
      ( v104410(VarCurr)
    <=> ( v104411(VarCurr)
        & v104422(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10142,axiom,
    ! [VarCurr: state_type] :
      ( v104422(VarCurr)
    <=> ( v104413(VarCurr)
        | v104423(VarCurr) ) ) ).

tff(writeUnaryOperator_5254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104423(VarCurr)
    <=> v104378(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4101,axiom,
    ! [VarCurr: state_type] :
      ( v104411(VarCurr)
    <=> ( v104412(VarCurr)
        | v104378(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104412(VarCurr)
    <=> v104413(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4100,axiom,
    ! [VarCurr: state_type] :
      ( v104413(VarCurr)
    <=> ( v104378(VarCurr,3)
        | v104414(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10141,axiom,
    ! [VarCurr: state_type] :
      ( v104414(VarCurr)
    <=> ( v104415(VarCurr)
        & v104421(VarCurr) ) ) ).

tff(writeUnaryOperator_5252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104421(VarCurr)
    <=> v104378(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4099,axiom,
    ! [VarCurr: state_type] :
      ( v104415(VarCurr)
    <=> ( v104378(VarCurr,2)
        | v104416(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10140,axiom,
    ! [VarCurr: state_type] :
      ( v104416(VarCurr)
    <=> ( v104417(VarCurr)
        & v104420(VarCurr) ) ) ).

tff(writeUnaryOperator_5251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104420(VarCurr)
    <=> v104378(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4098,axiom,
    ! [VarCurr: state_type] :
      ( v104417(VarCurr)
    <=> ( v104378(VarCurr,1)
        | v104418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10139,axiom,
    ! [VarCurr: state_type] :
      ( v104418(VarCurr)
    <=> ( v104378(VarCurr,0)
        & v104419(VarCurr) ) ) ).

tff(writeUnaryOperator_5250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104419(VarCurr)
    <=> v104378(VarCurr,1) ) ).

tff(addAssignment_63552,axiom,
    ! [VarCurr: state_type] :
      ( v104406(VarCurr,0)
    <=> v104239(VarCurr) ) ).

tff(addAssignment_63551,axiom,
    ! [VarCurr: state_type] :
      ( v104406(VarCurr,1)
    <=> v104237(VarCurr) ) ).

tff(addAssignment_63550,axiom,
    ! [VarCurr: state_type] :
      ( v104406(VarCurr,2)
    <=> v104233(VarCurr) ) ).

tff(addAssignment_63549,axiom,
    ! [VarCurr: state_type] :
      ( v104406(VarCurr,3)
    <=> v104229(VarCurr) ) ).

tff(addAssignment_63548,axiom,
    ! [VarCurr: state_type] :
      ( v104406(VarCurr,4)
    <=> v104215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10138,axiom,
    ! [VarCurr: state_type] :
      ( v104400(VarCurr)
    <=> ( v104401(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10137,axiom,
    ! [VarCurr: state_type] :
      ( v104401(VarCurr)
    <=> ( v104402(VarCurr)
        & v104205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10136,axiom,
    ! [VarCurr: state_type] :
      ( v104402(VarCurr)
    <=> ( v104403(VarCurr)
        & v104405(VarCurr) ) ) ).

tff(writeUnaryOperator_5249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104405(VarCurr)
    <=> v104181(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10135,axiom,
    ! [VarCurr: state_type] :
      ( v104403(VarCurr)
    <=> ( v104376(VarCurr)
        & v104404(VarCurr) ) ) ).

tff(writeUnaryOperator_5248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104404(VarCurr)
    <=> v104294(VarCurr) ) ).

tff(addAssignment_63547,axiom,
    ! [VarCurr: state_type] :
      ( v104388(VarCurr)
    <=> v104390(VarCurr) ) ).

tff(addAssignment_63546,axiom,
    ! [VarCurr: state_type] :
      ( v104390(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63545,axiom,
    ! [VarCurr: state_type] :
      ( v104384(VarCurr)
    <=> v104386(VarCurr) ) ).

tff(addAssignment_63544,axiom,
    ! [VarCurr: state_type] :
      ( v104386(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_713,axiom,
    ! [VarCurr: state_type] :
      ( v104294(VarCurr)
    <=> ( ( v104296(VarCurr,4)
        <=> $false )
        & ( v104296(VarCurr,3)
        <=> $false )
        & ( v104296(VarCurr,2)
        <=> $false )
        & ( v104296(VarCurr,1)
        <=> $false )
        & ( v104296(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104296(VarCurr,B)
      <=> v104298(VarCurr,B) ) ) ).

tff(addAssignment_63542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104298(VarCurr,B)
      <=> v104300(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104358(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v104300(VarNext,B)
            <=> v104300(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1258,axiom,
    ! [VarNext: state_type] :
      ( v104358(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104300(VarNext,B)
          <=> v104368(VarNext,B) ) ) ) ).

tff(addAssignment_63541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104368(VarNext,B)
          <=> v104366(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104369(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104366(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_760,axiom,
    ! [VarCurr: state_type] :
      ( v104369(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104366(VarCurr,B)
          <=> v104310(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10134,axiom,
    ! [VarCurr: state_type] :
      ( v104369(VarCurr)
    <=> ( v104370(VarCurr)
        & v104371(VarCurr) ) ) ).

tff(writeUnaryOperator_5247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104371(VarCurr)
    <=> v104306(VarCurr) ) ).

tff(writeUnaryOperator_5246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104370(VarCurr)
    <=> v104302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104358(VarNext)
      <=> v104359(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104359(VarNext)
      <=> ( v104360(VarNext)
          & v104353(VarNext) ) ) ) ).

tff(writeUnaryOperator_5245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104360(VarNext)
      <=> v104362(VarNext) ) ) ).

tff(addAssignment_63540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104362(VarNext)
      <=> v104353(VarCurr) ) ) ).

tff(addAssignment_63539,axiom,
    ! [VarCurr: state_type] :
      ( v104353(VarCurr)
    <=> v104355(VarCurr) ) ).

tff(addAssignment_63538,axiom,
    ! [VarCurr: state_type] :
      ( v104355(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104310(VarCurr,B)
      <=> v104312(VarCurr,B) ) ) ).

tff(addAssignment_63536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104312(VarCurr,B)
      <=> v104314(VarCurr,B) ) ) ).

tff(addAssignment_63535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104314(VarCurr,B)
      <=> v104316(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104318(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104316(VarCurr,B)
          <=> v104323(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_759,axiom,
    ! [VarCurr: state_type] :
      ( v104318(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104316(VarCurr,B)
          <=> v104322(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104323(VarCurr,B)
          <=> v104324(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_758,axiom,
    ! [VarCurr: state_type] :
      ( v104294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104323(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63534,axiom,
    ! [VarCurr: state_type] :
      ( v104324(VarCurr,0)
    <=> v104350(VarCurr) ) ).

tff(addAssignment_63533,axiom,
    ! [VarCurr: state_type] :
      ( v104324(VarCurr,1)
    <=> v104348(VarCurr) ) ).

tff(addAssignment_63532,axiom,
    ! [VarCurr: state_type] :
      ( v104324(VarCurr,2)
    <=> v104344(VarCurr) ) ).

tff(addAssignment_63531,axiom,
    ! [VarCurr: state_type] :
      ( v104324(VarCurr,3)
    <=> v104340(VarCurr) ) ).

tff(addAssignment_63530,axiom,
    ! [VarCurr: state_type] :
      ( v104324(VarCurr,4)
    <=> v104326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10131,axiom,
    ! [VarCurr: state_type] :
      ( v104348(VarCurr)
    <=> ( v104349(VarCurr)
        & v104351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10130,axiom,
    ! [VarCurr: state_type] :
      ( v104351(VarCurr)
    <=> ( v104296(VarCurr,0)
        | v104335(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4097,axiom,
    ! [VarCurr: state_type] :
      ( v104349(VarCurr)
    <=> ( v104350(VarCurr)
        | v104296(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104350(VarCurr)
    <=> v104296(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10129,axiom,
    ! [VarCurr: state_type] :
      ( v104344(VarCurr)
    <=> ( v104345(VarCurr)
        & v104347(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10128,axiom,
    ! [VarCurr: state_type] :
      ( v104347(VarCurr)
    <=> ( v104333(VarCurr)
        | v104336(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4096,axiom,
    ! [VarCurr: state_type] :
      ( v104345(VarCurr)
    <=> ( v104346(VarCurr)
        | v104296(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104346(VarCurr)
    <=> v104333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10127,axiom,
    ! [VarCurr: state_type] :
      ( v104340(VarCurr)
    <=> ( v104341(VarCurr)
        & v104343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10126,axiom,
    ! [VarCurr: state_type] :
      ( v104343(VarCurr)
    <=> ( v104331(VarCurr)
        | v104337(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4095,axiom,
    ! [VarCurr: state_type] :
      ( v104341(VarCurr)
    <=> ( v104342(VarCurr)
        | v104296(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104342(VarCurr)
    <=> v104331(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10125,axiom,
    ! [VarCurr: state_type] :
      ( v104326(VarCurr)
    <=> ( v104327(VarCurr)
        & v104338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10124,axiom,
    ! [VarCurr: state_type] :
      ( v104338(VarCurr)
    <=> ( v104329(VarCurr)
        | v104339(VarCurr) ) ) ).

tff(writeUnaryOperator_5241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104339(VarCurr)
    <=> v104296(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4094,axiom,
    ! [VarCurr: state_type] :
      ( v104327(VarCurr)
    <=> ( v104328(VarCurr)
        | v104296(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104328(VarCurr)
    <=> v104329(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4093,axiom,
    ! [VarCurr: state_type] :
      ( v104329(VarCurr)
    <=> ( v104296(VarCurr,3)
        | v104330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10123,axiom,
    ! [VarCurr: state_type] :
      ( v104330(VarCurr)
    <=> ( v104331(VarCurr)
        & v104337(VarCurr) ) ) ).

tff(writeUnaryOperator_5239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104337(VarCurr)
    <=> v104296(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4092,axiom,
    ! [VarCurr: state_type] :
      ( v104331(VarCurr)
    <=> ( v104296(VarCurr,2)
        | v104332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10122,axiom,
    ! [VarCurr: state_type] :
      ( v104332(VarCurr)
    <=> ( v104333(VarCurr)
        & v104336(VarCurr) ) ) ).

tff(writeUnaryOperator_5238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104336(VarCurr)
    <=> v104296(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4091,axiom,
    ! [VarCurr: state_type] :
      ( v104333(VarCurr)
    <=> ( v104296(VarCurr,1)
        | v104334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10121,axiom,
    ! [VarCurr: state_type] :
      ( v104334(VarCurr)
    <=> ( v104296(VarCurr,0)
        & v104335(VarCurr) ) ) ).

tff(writeUnaryOperator_5237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104335(VarCurr)
    <=> v104296(VarCurr,1) ) ).

tff(addAssignment_63529,axiom,
    ! [VarCurr: state_type] :
      ( v104322(VarCurr,0)
    <=> v104239(VarCurr) ) ).

tff(addAssignment_63528,axiom,
    ! [VarCurr: state_type] :
      ( v104322(VarCurr,1)
    <=> v104237(VarCurr) ) ).

tff(addAssignment_63527,axiom,
    ! [VarCurr: state_type] :
      ( v104322(VarCurr,2)
    <=> v104233(VarCurr) ) ).

tff(addAssignment_63526,axiom,
    ! [VarCurr: state_type] :
      ( v104322(VarCurr,3)
    <=> v104229(VarCurr) ) ).

tff(addAssignment_63525,axiom,
    ! [VarCurr: state_type] :
      ( v104322(VarCurr,4)
    <=> v104215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10120,axiom,
    ! [VarCurr: state_type] :
      ( v104318(VarCurr)
    <=> ( v104319(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10119,axiom,
    ! [VarCurr: state_type] :
      ( v104319(VarCurr)
    <=> ( v104320(VarCurr)
        & v104205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10118,axiom,
    ! [VarCurr: state_type] :
      ( v104320(VarCurr)
    <=> ( v104294(VarCurr)
        & v104321(VarCurr) ) ) ).

tff(writeUnaryOperator_5236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104321(VarCurr)
    <=> v104181(VarCurr) ) ).

tff(addAssignment_63524,axiom,
    ! [VarCurr: state_type] :
      ( v104306(VarCurr)
    <=> v104308(VarCurr) ) ).

tff(addAssignment_63523,axiom,
    ! [VarCurr: state_type] :
      ( v104308(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63522,axiom,
    ! [VarCurr: state_type] :
      ( v104302(VarCurr)
    <=> v104304(VarCurr) ) ).

tff(addAssignment_63521,axiom,
    ! [VarCurr: state_type] :
      ( v104304(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_712,axiom,
    ! [VarCurr: state_type] :
      ( v104181(VarCurr)
    <=> ( ( v104183(VarCurr,4)
        <=> $false )
        & ( v104183(VarCurr,3)
        <=> $false )
        & ( v104183(VarCurr,2)
        <=> $false )
        & ( v104183(VarCurr,1)
        <=> $false )
        & ( v104183(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104183(VarCurr,B)
      <=> v104185(VarCurr,B) ) ) ).

tff(addAssignment_63519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104185(VarCurr,B)
      <=> v104187(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104276(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v104187(VarNext,B)
            <=> v104187(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1257,axiom,
    ! [VarNext: state_type] :
      ( v104276(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104187(VarNext,B)
          <=> v104286(VarNext,B) ) ) ) ).

tff(addAssignment_63518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104286(VarNext,B)
          <=> v104284(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104287(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104284(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_757,axiom,
    ! [VarCurr: state_type] :
      ( v104287(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104284(VarCurr,B)
          <=> v104197(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10117,axiom,
    ! [VarCurr: state_type] :
      ( v104287(VarCurr)
    <=> ( v104288(VarCurr)
        & v104289(VarCurr) ) ) ).

tff(writeUnaryOperator_5235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104289(VarCurr)
    <=> v104193(VarCurr) ) ).

tff(writeUnaryOperator_5234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104288(VarCurr)
    <=> v104189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104276(VarNext)
      <=> v104277(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104277(VarNext)
      <=> ( v104278(VarNext)
          & v104271(VarNext) ) ) ) ).

tff(writeUnaryOperator_5233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104278(VarNext)
      <=> v104280(VarNext) ) ) ).

tff(addAssignment_63517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104280(VarNext)
      <=> v104271(VarCurr) ) ) ).

tff(addAssignment_63516,axiom,
    ! [VarCurr: state_type] :
      ( v104271(VarCurr)
    <=> v104273(VarCurr) ) ).

tff(addAssignment_63515,axiom,
    ! [VarCurr: state_type] :
      ( v104273(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104197(VarCurr,B)
      <=> v104199(VarCurr,B) ) ) ).

tff(addAssignment_63513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104199(VarCurr,B)
      <=> v104201(VarCurr,B) ) ) ).

tff(addAssignment_63512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v104201(VarCurr,B)
      <=> v104203(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104211(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104203(VarCurr,B)
          <=> v104241(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_756,axiom,
    ! [VarCurr: state_type] :
      ( v104211(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104203(VarCurr,B)
          <=> v104213(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104181(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104241(VarCurr,B)
          <=> v104242(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_755,axiom,
    ! [VarCurr: state_type] :
      ( v104181(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v104241(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63511,axiom,
    ! [VarCurr: state_type] :
      ( v104242(VarCurr,0)
    <=> v104268(VarCurr) ) ).

tff(addAssignment_63510,axiom,
    ! [VarCurr: state_type] :
      ( v104242(VarCurr,1)
    <=> v104266(VarCurr) ) ).

tff(addAssignment_63509,axiom,
    ! [VarCurr: state_type] :
      ( v104242(VarCurr,2)
    <=> v104262(VarCurr) ) ).

tff(addAssignment_63508,axiom,
    ! [VarCurr: state_type] :
      ( v104242(VarCurr,3)
    <=> v104258(VarCurr) ) ).

tff(addAssignment_63507,axiom,
    ! [VarCurr: state_type] :
      ( v104242(VarCurr,4)
    <=> v104244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10114,axiom,
    ! [VarCurr: state_type] :
      ( v104266(VarCurr)
    <=> ( v104267(VarCurr)
        & v104269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10113,axiom,
    ! [VarCurr: state_type] :
      ( v104269(VarCurr)
    <=> ( v104183(VarCurr,0)
        | v104253(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4090,axiom,
    ! [VarCurr: state_type] :
      ( v104267(VarCurr)
    <=> ( v104268(VarCurr)
        | v104183(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104268(VarCurr)
    <=> v104183(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10112,axiom,
    ! [VarCurr: state_type] :
      ( v104262(VarCurr)
    <=> ( v104263(VarCurr)
        & v104265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10111,axiom,
    ! [VarCurr: state_type] :
      ( v104265(VarCurr)
    <=> ( v104251(VarCurr)
        | v104254(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4089,axiom,
    ! [VarCurr: state_type] :
      ( v104263(VarCurr)
    <=> ( v104264(VarCurr)
        | v104183(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104264(VarCurr)
    <=> v104251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10110,axiom,
    ! [VarCurr: state_type] :
      ( v104258(VarCurr)
    <=> ( v104259(VarCurr)
        & v104261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10109,axiom,
    ! [VarCurr: state_type] :
      ( v104261(VarCurr)
    <=> ( v104249(VarCurr)
        | v104255(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4088,axiom,
    ! [VarCurr: state_type] :
      ( v104259(VarCurr)
    <=> ( v104260(VarCurr)
        | v104183(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104260(VarCurr)
    <=> v104249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10108,axiom,
    ! [VarCurr: state_type] :
      ( v104244(VarCurr)
    <=> ( v104245(VarCurr)
        & v104256(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10107,axiom,
    ! [VarCurr: state_type] :
      ( v104256(VarCurr)
    <=> ( v104247(VarCurr)
        | v104257(VarCurr) ) ) ).

tff(writeUnaryOperator_5229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104257(VarCurr)
    <=> v104183(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4087,axiom,
    ! [VarCurr: state_type] :
      ( v104245(VarCurr)
    <=> ( v104246(VarCurr)
        | v104183(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104246(VarCurr)
    <=> v104247(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4086,axiom,
    ! [VarCurr: state_type] :
      ( v104247(VarCurr)
    <=> ( v104183(VarCurr,3)
        | v104248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10106,axiom,
    ! [VarCurr: state_type] :
      ( v104248(VarCurr)
    <=> ( v104249(VarCurr)
        & v104255(VarCurr) ) ) ).

tff(writeUnaryOperator_5227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104255(VarCurr)
    <=> v104183(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4085,axiom,
    ! [VarCurr: state_type] :
      ( v104249(VarCurr)
    <=> ( v104183(VarCurr,2)
        | v104250(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10105,axiom,
    ! [VarCurr: state_type] :
      ( v104250(VarCurr)
    <=> ( v104251(VarCurr)
        & v104254(VarCurr) ) ) ).

tff(writeUnaryOperator_5226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104254(VarCurr)
    <=> v104183(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4084,axiom,
    ! [VarCurr: state_type] :
      ( v104251(VarCurr)
    <=> ( v104183(VarCurr,1)
        | v104252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10104,axiom,
    ! [VarCurr: state_type] :
      ( v104252(VarCurr)
    <=> ( v104183(VarCurr,0)
        & v104253(VarCurr) ) ) ).

tff(writeUnaryOperator_5225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104253(VarCurr)
    <=> v104183(VarCurr,1) ) ).

tff(addAssignment_63506,axiom,
    ! [VarCurr: state_type] :
      ( v104213(VarCurr,0)
    <=> v104239(VarCurr) ) ).

tff(addAssignment_63505,axiom,
    ! [VarCurr: state_type] :
      ( v104213(VarCurr,1)
    <=> v104237(VarCurr) ) ).

tff(addAssignment_63504,axiom,
    ! [VarCurr: state_type] :
      ( v104213(VarCurr,2)
    <=> v104233(VarCurr) ) ).

tff(addAssignment_63503,axiom,
    ! [VarCurr: state_type] :
      ( v104213(VarCurr,3)
    <=> v104229(VarCurr) ) ).

tff(addAssignment_63502,axiom,
    ! [VarCurr: state_type] :
      ( v104213(VarCurr,4)
    <=> v104215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10103,axiom,
    ! [VarCurr: state_type] :
      ( v104237(VarCurr)
    <=> ( v104238(VarCurr)
        & v104240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10102,axiom,
    ! [VarCurr: state_type] :
      ( v104240(VarCurr)
    <=> ( v104209(VarCurr,0)
        | v104224(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4083,axiom,
    ! [VarCurr: state_type] :
      ( v104238(VarCurr)
    <=> ( v104239(VarCurr)
        | v104209(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104239(VarCurr)
    <=> v104209(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10101,axiom,
    ! [VarCurr: state_type] :
      ( v104233(VarCurr)
    <=> ( v104234(VarCurr)
        & v104236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10100,axiom,
    ! [VarCurr: state_type] :
      ( v104236(VarCurr)
    <=> ( v104222(VarCurr)
        | v104225(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4082,axiom,
    ! [VarCurr: state_type] :
      ( v104234(VarCurr)
    <=> ( v104235(VarCurr)
        | v104209(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104235(VarCurr)
    <=> v104222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10099,axiom,
    ! [VarCurr: state_type] :
      ( v104229(VarCurr)
    <=> ( v104230(VarCurr)
        & v104232(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10098,axiom,
    ! [VarCurr: state_type] :
      ( v104232(VarCurr)
    <=> ( v104220(VarCurr)
        | v104226(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4081,axiom,
    ! [VarCurr: state_type] :
      ( v104230(VarCurr)
    <=> ( v104231(VarCurr)
        | v104209(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104231(VarCurr)
    <=> v104220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10097,axiom,
    ! [VarCurr: state_type] :
      ( v104215(VarCurr)
    <=> ( v104216(VarCurr)
        & v104227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10096,axiom,
    ! [VarCurr: state_type] :
      ( v104227(VarCurr)
    <=> ( v104218(VarCurr)
        | v104228(VarCurr) ) ) ).

tff(writeUnaryOperator_5221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104228(VarCurr)
    <=> v104209(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4080,axiom,
    ! [VarCurr: state_type] :
      ( v104216(VarCurr)
    <=> ( v104217(VarCurr)
        | v104209(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104217(VarCurr)
    <=> v104218(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4079,axiom,
    ! [VarCurr: state_type] :
      ( v104218(VarCurr)
    <=> ( v104209(VarCurr,3)
        | v104219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10095,axiom,
    ! [VarCurr: state_type] :
      ( v104219(VarCurr)
    <=> ( v104220(VarCurr)
        & v104226(VarCurr) ) ) ).

tff(writeUnaryOperator_5219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104226(VarCurr)
    <=> v104209(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4078,axiom,
    ! [VarCurr: state_type] :
      ( v104220(VarCurr)
    <=> ( v104209(VarCurr,2)
        | v104221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10094,axiom,
    ! [VarCurr: state_type] :
      ( v104221(VarCurr)
    <=> ( v104222(VarCurr)
        & v104225(VarCurr) ) ) ).

tff(writeUnaryOperator_5218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104225(VarCurr)
    <=> v104209(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4077,axiom,
    ! [VarCurr: state_type] :
      ( v104222(VarCurr)
    <=> ( v104209(VarCurr,1)
        | v104223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10093,axiom,
    ! [VarCurr: state_type] :
      ( v104223(VarCurr)
    <=> ( v104209(VarCurr,0)
        & v104224(VarCurr) ) ) ).

tff(writeUnaryOperator_5217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104224(VarCurr)
    <=> v104209(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10092,axiom,
    ! [VarCurr: state_type] :
      ( v104211(VarCurr)
    <=> ( v104212(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10091,axiom,
    ! [VarCurr: state_type] :
      ( v104212(VarCurr)
    <=> ( v104181(VarCurr)
        & v104205(VarCurr) ) ) ).

tff(addAssignment_63501,axiom,
    ! [VarCurr: state_type] :
      ( v104209(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_63500,axiom,
    ! [VarCurr: state_type] :
      ( v104209(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(addAssignment_63499,axiom,
    ! [VarCurr: state_type] :
      ( v104209(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_63498,axiom,
    ! [VarCurr: state_type] :
      ( v104209(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(addAssignment_63497,axiom,
    ! [VarCurr: state_type] :
      ( v104209(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10090,axiom,
    ! [VarCurr: state_type] :
      ( v104205(VarCurr)
    <=> ( v104207(VarCurr)
        | v104002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10089,axiom,
    ! [VarCurr: state_type] :
      ( v104207(VarCurr)
    <=> ( v103884(VarCurr)
        | v103995(VarCurr) ) ) ).

tff(addAssignment_63496,axiom,
    ! [VarCurr: state_type] :
      ( v104193(VarCurr)
    <=> v104195(VarCurr) ) ).

tff(addAssignment_63495,axiom,
    ! [VarCurr: state_type] :
      ( v104195(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63494,axiom,
    ! [VarCurr: state_type] :
      ( v104189(VarCurr)
    <=> v104191(VarCurr) ) ).

tff(addAssignment_63493,axiom,
    ! [VarCurr: state_type] :
      ( v104191(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_63492,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,1)
    <=> v104078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_711,axiom,
    ! [VarCurr: state_type] :
      ( v104078(VarCurr)
    <=> ( ( v104080(VarCurr,3)
        <=> $false )
        & ( v104080(VarCurr,2)
        <=> $false )
        & ( v104080(VarCurr,1)
        <=> $false )
        & ( v104080(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104080(VarCurr,B)
      <=> v104082(VarCurr,B) ) ) ).

tff(addAssignment_63490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104082(VarCurr,B)
      <=> v104084(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104161(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v104084(VarNext,B)
            <=> v104084(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1256,axiom,
    ! [VarNext: state_type] :
      ( v104161(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104084(VarNext,B)
          <=> v104171(VarNext,B) ) ) ) ).

tff(addAssignment_63489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104171(VarNext,B)
          <=> v104169(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104172(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104169(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_754,axiom,
    ! [VarCurr: state_type] :
      ( v104172(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104169(VarCurr,B)
          <=> v104094(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10088,axiom,
    ! [VarCurr: state_type] :
      ( v104172(VarCurr)
    <=> ( v104173(VarCurr)
        & v104174(VarCurr) ) ) ).

tff(writeUnaryOperator_5216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104174(VarCurr)
    <=> v104090(VarCurr) ) ).

tff(writeUnaryOperator_5215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104173(VarCurr)
    <=> v104086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104161(VarNext)
      <=> v104162(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104162(VarNext)
      <=> ( v104163(VarNext)
          & v104156(VarNext) ) ) ) ).

tff(writeUnaryOperator_5214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104163(VarNext)
      <=> v104165(VarNext) ) ) ).

tff(addAssignment_63488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104165(VarNext)
      <=> v104156(VarCurr) ) ) ).

tff(addAssignment_63487,axiom,
    ! [VarCurr: state_type] :
      ( v104156(VarCurr)
    <=> v104158(VarCurr) ) ).

tff(addAssignment_63486,axiom,
    ! [VarCurr: state_type] :
      ( v104158(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104094(VarCurr,B)
      <=> v104096(VarCurr,B) ) ) ).

tff(addAssignment_63484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104096(VarCurr,B)
      <=> v104098(VarCurr,B) ) ) ).

tff(addAssignment_63483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v104098(VarCurr,B)
      <=> v104100(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104100(VarCurr,B)
          <=> v104129(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_753,axiom,
    ! [VarCurr: state_type] :
      ( v104107(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104100(VarCurr,B)
          <=> v104108(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104130(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104129(VarCurr,B)
          <=> v104131(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_752,axiom,
    ! [VarCurr: state_type] :
      ( v104130(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104129(VarCurr,B)
          <=> v104105(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104132(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104131(VarCurr,B)
          <=> v104133(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_751,axiom,
    ! [VarCurr: state_type] :
      ( v104132(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104131(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104133(VarCurr,B)
          <=> v104080(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_750,axiom,
    ! [VarCurr: state_type] :
      ( v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v104133(VarCurr,B)
          <=> v104134(VarCurr,B) ) ) ) ).

tff(addAssignment_63482,axiom,
    ! [VarCurr: state_type] :
      ( v104134(VarCurr,0)
    <=> v104153(VarCurr) ) ).

tff(addAssignment_63481,axiom,
    ! [VarCurr: state_type] :
      ( v104134(VarCurr,1)
    <=> v104151(VarCurr) ) ).

tff(addAssignment_63480,axiom,
    ! [VarCurr: state_type] :
      ( v104134(VarCurr,2)
    <=> v104147(VarCurr) ) ).

tff(addAssignment_63479,axiom,
    ! [VarCurr: state_type] :
      ( v104134(VarCurr,3)
    <=> v104136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10085,axiom,
    ! [VarCurr: state_type] :
      ( v104151(VarCurr)
    <=> ( v104152(VarCurr)
        & v104154(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10084,axiom,
    ! [VarCurr: state_type] :
      ( v104154(VarCurr)
    <=> ( v104080(VarCurr,0)
        | v104143(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4076,axiom,
    ! [VarCurr: state_type] :
      ( v104152(VarCurr)
    <=> ( v104153(VarCurr)
        | v104080(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104153(VarCurr)
    <=> v104080(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10083,axiom,
    ! [VarCurr: state_type] :
      ( v104147(VarCurr)
    <=> ( v104148(VarCurr)
        & v104150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10082,axiom,
    ! [VarCurr: state_type] :
      ( v104150(VarCurr)
    <=> ( v104141(VarCurr)
        | v104144(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4075,axiom,
    ! [VarCurr: state_type] :
      ( v104148(VarCurr)
    <=> ( v104149(VarCurr)
        | v104080(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104149(VarCurr)
    <=> v104141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10081,axiom,
    ! [VarCurr: state_type] :
      ( v104136(VarCurr)
    <=> ( v104137(VarCurr)
        & v104145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10080,axiom,
    ! [VarCurr: state_type] :
      ( v104145(VarCurr)
    <=> ( v104139(VarCurr)
        | v104146(VarCurr) ) ) ).

tff(writeUnaryOperator_5211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104146(VarCurr)
    <=> v104080(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4074,axiom,
    ! [VarCurr: state_type] :
      ( v104137(VarCurr)
    <=> ( v104138(VarCurr)
        | v104080(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104138(VarCurr)
    <=> v104139(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4073,axiom,
    ! [VarCurr: state_type] :
      ( v104139(VarCurr)
    <=> ( v104080(VarCurr,2)
        | v104140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10079,axiom,
    ! [VarCurr: state_type] :
      ( v104140(VarCurr)
    <=> ( v104141(VarCurr)
        & v104144(VarCurr) ) ) ).

tff(writeUnaryOperator_5209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104144(VarCurr)
    <=> v104080(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4072,axiom,
    ! [VarCurr: state_type] :
      ( v104141(VarCurr)
    <=> ( v104080(VarCurr,1)
        | v104142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10078,axiom,
    ! [VarCurr: state_type] :
      ( v104142(VarCurr)
    <=> ( v104080(VarCurr,0)
        & v104143(VarCurr) ) ) ).

tff(writeUnaryOperator_5208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104143(VarCurr)
    <=> v104080(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_710,axiom,
    ! [VarCurr: state_type] :
      ( v104132(VarCurr)
    <=> ( ( v104080(VarCurr,3)
        <=> $false )
        & ( v104080(VarCurr,2)
        <=> $false )
        & ( v104080(VarCurr,1)
        <=> $false )
        & ( v104080(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10077,axiom,
    ! [VarCurr: state_type] :
      ( v104130(VarCurr)
    <=> ( v104002(VarCurr)
        & v104078(VarCurr) ) ) ).

tff(addAssignment_63478,axiom,
    ! [VarCurr: state_type] :
      ( v104108(VarCurr,0)
    <=> v104127(VarCurr) ) ).

tff(addAssignment_63477,axiom,
    ! [VarCurr: state_type] :
      ( v104108(VarCurr,1)
    <=> v104125(VarCurr) ) ).

tff(addAssignment_63476,axiom,
    ! [VarCurr: state_type] :
      ( v104108(VarCurr,2)
    <=> v104121(VarCurr) ) ).

tff(addAssignment_63475,axiom,
    ! [VarCurr: state_type] :
      ( v104108(VarCurr,3)
    <=> v104110(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10076,axiom,
    ! [VarCurr: state_type] :
      ( v104125(VarCurr)
    <=> ( v104126(VarCurr)
        & v104128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10075,axiom,
    ! [VarCurr: state_type] :
      ( v104128(VarCurr)
    <=> ( v104105(VarCurr,0)
        | v104117(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4071,axiom,
    ! [VarCurr: state_type] :
      ( v104126(VarCurr)
    <=> ( v104127(VarCurr)
        | v104105(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104127(VarCurr)
    <=> v104105(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10074,axiom,
    ! [VarCurr: state_type] :
      ( v104121(VarCurr)
    <=> ( v104122(VarCurr)
        & v104124(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10073,axiom,
    ! [VarCurr: state_type] :
      ( v104124(VarCurr)
    <=> ( v104115(VarCurr)
        | v104118(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4070,axiom,
    ! [VarCurr: state_type] :
      ( v104122(VarCurr)
    <=> ( v104123(VarCurr)
        | v104105(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104123(VarCurr)
    <=> v104115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10072,axiom,
    ! [VarCurr: state_type] :
      ( v104110(VarCurr)
    <=> ( v104111(VarCurr)
        & v104119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10071,axiom,
    ! [VarCurr: state_type] :
      ( v104119(VarCurr)
    <=> ( v104113(VarCurr)
        | v104120(VarCurr) ) ) ).

tff(writeUnaryOperator_5205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104120(VarCurr)
    <=> v104105(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4069,axiom,
    ! [VarCurr: state_type] :
      ( v104111(VarCurr)
    <=> ( v104112(VarCurr)
        | v104105(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104112(VarCurr)
    <=> v104113(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4068,axiom,
    ! [VarCurr: state_type] :
      ( v104113(VarCurr)
    <=> ( v104105(VarCurr,2)
        | v104114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10070,axiom,
    ! [VarCurr: state_type] :
      ( v104114(VarCurr)
    <=> ( v104115(VarCurr)
        & v104118(VarCurr) ) ) ).

tff(writeUnaryOperator_5203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104118(VarCurr)
    <=> v104105(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4067,axiom,
    ! [VarCurr: state_type] :
      ( v104115(VarCurr)
    <=> ( v104105(VarCurr,1)
        | v104116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10069,axiom,
    ! [VarCurr: state_type] :
      ( v104116(VarCurr)
    <=> ( v104105(VarCurr,0)
        & v104117(VarCurr) ) ) ).

tff(writeUnaryOperator_5202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104117(VarCurr)
    <=> v104105(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10068,axiom,
    ! [VarCurr: state_type] :
      ( v104107(VarCurr)
    <=> ( v104102(VarCurr)
        & v104078(VarCurr) ) ) ).

tff(addAssignment_63474,axiom,
    ! [VarCurr: state_type] :
      ( v104105(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_63473,axiom,
    ! [VarCurr: state_type] :
      ( v104105(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_63472,axiom,
    ! [VarCurr: state_type] :
      ( v104105(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(addAssignment_63471,axiom,
    ! [VarCurr: state_type] :
      ( v104105(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10067,axiom,
    ! [VarCurr: state_type] :
      ( v104102(VarCurr)
    <=> ( v103884(VarCurr)
        | v103995(VarCurr) ) ) ).

tff(addAssignment_63470,axiom,
    ! [VarCurr: state_type] :
      ( v104090(VarCurr)
    <=> v104092(VarCurr) ) ).

tff(addAssignment_63469,axiom,
    ! [VarCurr: state_type] :
      ( v104092(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63468,axiom,
    ! [VarCurr: state_type] :
      ( v104086(VarCurr)
    <=> v104088(VarCurr) ) ).

tff(addAssignment_63467,axiom,
    ! [VarCurr: state_type] :
      ( v104088(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_63466,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,1)
    <=> v103951(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_709,axiom,
    ! [VarCurr: state_type] :
      ( v103951(VarCurr)
    <=> ( ( v103953(VarCurr,1)
        <=> $false )
        & ( v103953(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103953(VarCurr,B)
      <=> v103955(VarCurr,B) ) ) ).

tff(addAssignment_63464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103955(VarCurr,B)
      <=> v103957(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104060(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v103957(VarNext,B)
            <=> v103957(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1255,axiom,
    ! [VarNext: state_type] :
      ( v104060(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103957(VarNext,B)
          <=> v104070(VarNext,B) ) ) ) ).

tff(addAssignment_63463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104070(VarNext,B)
          <=> v104068(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104071(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104068(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_749,axiom,
    ! [VarCurr: state_type] :
      ( v104071(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104068(VarCurr,B)
          <=> v103967(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10066,axiom,
    ! [VarCurr: state_type] :
      ( v104071(VarCurr)
    <=> ( v104072(VarCurr)
        & v104073(VarCurr) ) ) ).

tff(writeUnaryOperator_5201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104073(VarCurr)
    <=> v103963(VarCurr) ) ).

tff(writeUnaryOperator_5200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104072(VarCurr)
    <=> v103959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104060(VarNext)
      <=> v104061(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104061(VarNext)
      <=> ( v104062(VarNext)
          & v104055(VarNext) ) ) ) ).

tff(writeUnaryOperator_5199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104062(VarNext)
      <=> v104064(VarNext) ) ) ).

tff(addAssignment_63462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104064(VarNext)
      <=> v104055(VarCurr) ) ) ).

tff(addAssignment_63461,axiom,
    ! [VarCurr: state_type] :
      ( v104055(VarCurr)
    <=> v104057(VarCurr) ) ).

tff(addAssignment_63460,axiom,
    ! [VarCurr: state_type] :
      ( v104057(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103967(VarCurr,B)
      <=> v103969(VarCurr,B) ) ) ).

tff(addAssignment_63458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103969(VarCurr,B)
      <=> v103971(VarCurr,B) ) ) ).

tff(addAssignment_63457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103971(VarCurr,B)
      <=> v103973(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104042(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103973(VarCurr,B)
          <=> v104043(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_748,axiom,
    ! [VarCurr: state_type] :
      ( v104042(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103973(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104043(VarCurr,B)
          <=> v104045(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_747,axiom,
    ! [VarCurr: state_type] :
      ( v104044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104043(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104045(VarCurr,B)
          <=> v104047(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_746,axiom,
    ! [VarCurr: state_type] :
      ( v104046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v104045(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63456,axiom,
    ! [VarCurr: state_type] :
      ( v104047(VarCurr,0)
    <=> v104051(VarCurr) ) ).

tff(addAssignment_63455,axiom,
    ! [VarCurr: state_type] :
      ( v104047(VarCurr,1)
    <=> v104049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10063,axiom,
    ! [VarCurr: state_type] :
      ( v104049(VarCurr)
    <=> ( v104050(VarCurr)
        & v104052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10062,axiom,
    ! [VarCurr: state_type] :
      ( v104052(VarCurr)
    <=> ( v103953(VarCurr,0)
        | v104053(VarCurr) ) ) ).

tff(writeUnaryOperator_5198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104053(VarCurr)
    <=> v103953(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4066,axiom,
    ! [VarCurr: state_type] :
      ( v104050(VarCurr)
    <=> ( v104051(VarCurr)
        | v103953(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104051(VarCurr)
    <=> v103953(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_708,axiom,
    ! [VarCurr: state_type] :
      ( v104046(VarCurr)
    <=> ( ( v103953(VarCurr,1)
        <=> $false )
        & ( v103953(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10061,axiom,
    ! [VarCurr: state_type] :
      ( v104044(VarCurr)
    <=> ( v104026(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10060,axiom,
    ! [VarCurr: state_type] :
      ( v104042(VarCurr)
    <=> ( v103975(VarCurr)
        & v103899(VarCurr) ) ) ).

tff(addAssignment_63454,axiom,
    ! [VarCurr: state_type] :
      ( v104026(VarCurr)
    <=> v103977(VarCurr,0) ) ).

tff(addAssignment_63453,axiom,
    ! [VarCurr: state_type] :
      ( v103977(VarCurr,0)
    <=> v103979(VarCurr,0) ) ).

tff(addAssignment_63452,axiom,
    ! [VarNext: state_type] :
      ( v103979(VarNext,0)
    <=> v104034(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104035(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v104034(VarNext,B)
            <=> v103979(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1254,axiom,
    ! [VarNext: state_type] :
      ( v104035(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104034(VarNext,B)
          <=> v104019(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104035(VarNext)
      <=> v104036(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104036(VarNext)
      <=> ( v104038(VarNext)
          & v104004(VarNext) ) ) ) ).

tff(writeUnaryOperator_5196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104038(VarNext)
      <=> v104013(VarNext) ) ) ).

tff(addAssignment_63451,axiom,
    ! [VarCurr: state_type] :
      ( v103989(VarCurr,0)
    <=> v103991(VarCurr,0) ) ).

tff(addAssignment_63450,axiom,
    ! [VarCurr: state_type] :
      ( v103991(VarCurr,0)
    <=> v103993(VarCurr,0) ) ).

tff(addAssignment_63449,axiom,
    ! [VarCurr: state_type] :
      ( v103993(VarCurr,0)
    <=> v104001(VarCurr,0) ) ).

tff(addAssignment_63448,axiom,
    ! [VarCurr: state_type] :
      ( v104002(VarCurr)
    <=> v103094(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4065,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,1)
    <=> ( v104029(VarCurr)
        | v104031(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10057,axiom,
    ! [VarCurr: state_type] :
      ( v104031(VarCurr)
    <=> ( v103113(VarCurr)
        & v104032(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_707,axiom,
    ! [VarCurr: state_type] :
      ( v104032(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $false )
        & ( v103127(VarCurr,5)
        <=> $false )
        & ( v103127(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10056,axiom,
    ! [VarCurr: state_type] :
      ( v104029(VarCurr)
    <=> ( v103096(VarCurr)
        & v104030(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_706,axiom,
    ! [VarCurr: state_type] :
      ( v104030(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $false )
        & ( v103106(VarCurr,5)
        <=> $false )
        & ( v103106(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63447,axiom,
    ! [VarCurr: state_type] :
      ( v103975(VarCurr)
    <=> v103977(VarCurr,1) ) ).

tff(addAssignment_63446,axiom,
    ! [VarCurr: state_type] :
      ( v103977(VarCurr,1)
    <=> v103979(VarCurr,1) ) ).

tff(addAssignment_63445,axiom,
    ! [VarNext: state_type] :
      ( v103979(VarNext,1)
    <=> v104008(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104009(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v104008(VarNext,B)
            <=> v103979(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1253,axiom,
    ! [VarNext: state_type] :
      ( v104009(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104008(VarNext,B)
          <=> v104019(VarNext,B) ) ) ) ).

tff(addAssignment_63444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104019(VarNext,B)
          <=> v104017(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104017(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_745,axiom,
    ! [VarCurr: state_type] :
      ( v104020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v104017(VarCurr,B)
          <=> v103989(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10055,axiom,
    ! [VarCurr: state_type] :
      ( v104020(VarCurr)
    <=> ( v104021(VarCurr)
        & v104022(VarCurr) ) ) ).

tff(writeUnaryOperator_5195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104022(VarCurr)
    <=> v103985(VarCurr) ) ).

tff(writeUnaryOperator_5194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v104021(VarCurr)
    <=> v103981(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104009(VarNext)
      <=> v104010(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104010(VarNext)
      <=> ( v104011(VarNext)
          & v104004(VarNext) ) ) ) ).

tff(writeUnaryOperator_5193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v104011(VarNext)
      <=> v104013(VarNext) ) ) ).

tff(addAssignment_63443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v104013(VarNext)
      <=> v104004(VarCurr) ) ) ).

tff(addAssignment_63442,axiom,
    ! [VarCurr: state_type] :
      ( v104004(VarCurr)
    <=> v104006(VarCurr) ) ).

tff(addAssignment_63441,axiom,
    ! [VarCurr: state_type] :
      ( v104006(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63440,axiom,
    ! [VarCurr: state_type] :
      ( v103989(VarCurr,1)
    <=> v103991(VarCurr,1) ) ).

tff(addAssignment_63439,axiom,
    ! [VarCurr: state_type] :
      ( v103991(VarCurr,1)
    <=> v103993(VarCurr,1) ) ).

tff(addAssignment_63438,axiom,
    ! [VarCurr: state_type] :
      ( v103993(VarCurr,1)
    <=> v104001(VarCurr,1) ) ).

tff(addAssignment_63437,axiom,
    ! [VarCurr: state_type] :
      ( v104001(VarCurr,0)
    <=> v104002(VarCurr) ) ).

tff(addAssignment_63436,axiom,
    ! [VarCurr: state_type] :
      ( v104001(VarCurr,1)
    <=> v103995(VarCurr) ) ).

tff(addAssignment_63435,axiom,
    ! [VarCurr: state_type] :
      ( v104001(VarCurr,2)
    <=> v103884(VarCurr) ) ).

tff(addAssignment_63434,axiom,
    ! [VarCurr: state_type] :
      ( v103995(VarCurr)
    <=> v101499(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4064,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,1)
    <=> ( v103997(VarCurr)
        | v103999(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10052,axiom,
    ! [VarCurr: state_type] :
      ( v103999(VarCurr)
    <=> ( v83096(VarCurr)
        & v104000(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_705,axiom,
    ! [VarCurr: state_type] :
      ( v104000(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10051,axiom,
    ! [VarCurr: state_type] :
      ( v103997(VarCurr)
    <=> ( v101501(VarCurr)
        & v103998(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_704,axiom,
    ! [VarCurr: state_type] :
      ( v103998(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $false )
        & ( v101563(VarCurr,5)
        <=> $false )
        & ( v101563(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63433,axiom,
    ! [VarCurr: state_type] :
      ( v103985(VarCurr)
    <=> v103987(VarCurr) ) ).

tff(addAssignment_63432,axiom,
    ! [VarCurr: state_type] :
      ( v103987(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63431,axiom,
    ! [VarCurr: state_type] :
      ( v103981(VarCurr)
    <=> v103983(VarCurr) ) ).

tff(addAssignment_63430,axiom,
    ! [VarCurr: state_type] :
      ( v103983(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_63429,axiom,
    ! [VarCurr: state_type] :
      ( v103963(VarCurr)
    <=> v103965(VarCurr) ) ).

tff(addAssignment_63428,axiom,
    ! [VarCurr: state_type] :
      ( v103965(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63427,axiom,
    ! [VarCurr: state_type] :
      ( v103959(VarCurr)
    <=> v103961(VarCurr) ) ).

tff(addAssignment_63426,axiom,
    ! [VarCurr: state_type] :
      ( v103961(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_63425,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,1)
    <=> v103852(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_703,axiom,
    ! [VarCurr: state_type] :
      ( v103852(VarCurr)
    <=> ( ( v103854(VarCurr,3)
        <=> $false )
        & ( v103854(VarCurr,2)
        <=> $false )
        & ( v103854(VarCurr,1)
        <=> $false )
        & ( v103854(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103854(VarCurr,B)
      <=> v103856(VarCurr,B) ) ) ).

tff(addAssignment_63423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103856(VarCurr,B)
      <=> v103858(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103933(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103858(VarNext,B)
            <=> v103858(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1252,axiom,
    ! [VarNext: state_type] :
      ( v103933(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103858(VarNext,B)
          <=> v103943(VarNext,B) ) ) ) ).

tff(addAssignment_63422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103943(VarNext,B)
          <=> v103941(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103944(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103941(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_744,axiom,
    ! [VarCurr: state_type] :
      ( v103944(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103941(VarCurr,B)
          <=> v103876(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10050,axiom,
    ! [VarCurr: state_type] :
      ( v103944(VarCurr)
    <=> ( v103945(VarCurr)
        & v103946(VarCurr) ) ) ).

tff(writeUnaryOperator_5192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103946(VarCurr)
    <=> v103868(VarCurr) ) ).

tff(writeUnaryOperator_5191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103945(VarCurr)
    <=> v103860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103933(VarNext)
      <=> v103934(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103934(VarNext)
      <=> ( v103935(VarNext)
          & v103926(VarNext) ) ) ) ).

tff(writeUnaryOperator_5190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103935(VarNext)
      <=> v103937(VarNext) ) ) ).

tff(addAssignment_63421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103937(VarNext)
      <=> v103926(VarCurr) ) ) ).

tff(addAssignment_63420,axiom,
    ! [VarCurr: state_type] :
      ( v103926(VarCurr)
    <=> v103928(VarCurr) ) ).

tff(addAssignment_63419,axiom,
    ! [VarCurr: state_type] :
      ( v103928(VarCurr)
    <=> v103930(VarCurr) ) ).

tff(addAssignment_63418,axiom,
    ! [VarCurr: state_type] :
      ( v103930(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103876(VarCurr,B)
      <=> v103878(VarCurr,B) ) ) ).

tff(addAssignment_63416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103878(VarCurr,B)
      <=> v103880(VarCurr,B) ) ) ).

tff(addAssignment_63415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103880(VarCurr,B)
      <=> v103882(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103884(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103882(VarCurr,B)
          <=> v103901(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_743,axiom,
    ! [VarCurr: state_type] :
      ( v103884(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103882(VarCurr,B)
          <=> v103897(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103902(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103901(VarCurr,B)
          <=> v103903(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_742,axiom,
    ! [VarCurr: state_type] :
      ( v103902(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103901(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103903(VarCurr,B)
          <=> v103854(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_741,axiom,
    ! [VarCurr: state_type] :
      ( v103899(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103903(VarCurr,B)
          <=> v103904(VarCurr,B) ) ) ) ).

tff(addAssignment_63414,axiom,
    ! [VarCurr: state_type] :
      ( v103904(VarCurr,0)
    <=> v103923(VarCurr) ) ).

tff(addAssignment_63413,axiom,
    ! [VarCurr: state_type] :
      ( v103904(VarCurr,1)
    <=> v103921(VarCurr) ) ).

tff(addAssignment_63412,axiom,
    ! [VarCurr: state_type] :
      ( v103904(VarCurr,2)
    <=> v103917(VarCurr) ) ).

tff(addAssignment_63411,axiom,
    ! [VarCurr: state_type] :
      ( v103904(VarCurr,3)
    <=> v103906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10047,axiom,
    ! [VarCurr: state_type] :
      ( v103921(VarCurr)
    <=> ( v103922(VarCurr)
        & v103924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10046,axiom,
    ! [VarCurr: state_type] :
      ( v103924(VarCurr)
    <=> ( v103854(VarCurr,0)
        | v103913(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4063,axiom,
    ! [VarCurr: state_type] :
      ( v103922(VarCurr)
    <=> ( v103923(VarCurr)
        | v103854(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103923(VarCurr)
    <=> v103854(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10045,axiom,
    ! [VarCurr: state_type] :
      ( v103917(VarCurr)
    <=> ( v103918(VarCurr)
        & v103920(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10044,axiom,
    ! [VarCurr: state_type] :
      ( v103920(VarCurr)
    <=> ( v103911(VarCurr)
        | v103914(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4062,axiom,
    ! [VarCurr: state_type] :
      ( v103918(VarCurr)
    <=> ( v103919(VarCurr)
        | v103854(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103919(VarCurr)
    <=> v103911(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10043,axiom,
    ! [VarCurr: state_type] :
      ( v103906(VarCurr)
    <=> ( v103907(VarCurr)
        & v103915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10042,axiom,
    ! [VarCurr: state_type] :
      ( v103915(VarCurr)
    <=> ( v103909(VarCurr)
        | v103916(VarCurr) ) ) ).

tff(writeUnaryOperator_5187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103916(VarCurr)
    <=> v103854(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4061,axiom,
    ! [VarCurr: state_type] :
      ( v103907(VarCurr)
    <=> ( v103908(VarCurr)
        | v103854(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103908(VarCurr)
    <=> v103909(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4060,axiom,
    ! [VarCurr: state_type] :
      ( v103909(VarCurr)
    <=> ( v103854(VarCurr,2)
        | v103910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10041,axiom,
    ! [VarCurr: state_type] :
      ( v103910(VarCurr)
    <=> ( v103911(VarCurr)
        & v103914(VarCurr) ) ) ).

tff(writeUnaryOperator_5185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103914(VarCurr)
    <=> v103854(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4059,axiom,
    ! [VarCurr: state_type] :
      ( v103911(VarCurr)
    <=> ( v103854(VarCurr,1)
        | v103912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10040,axiom,
    ! [VarCurr: state_type] :
      ( v103912(VarCurr)
    <=> ( v103854(VarCurr,0)
        & v103913(VarCurr) ) ) ).

tff(writeUnaryOperator_5184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103913(VarCurr)
    <=> v103854(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_702,axiom,
    ! [VarCurr: state_type] :
      ( v103902(VarCurr)
    <=> ( ( v103854(VarCurr,3)
        <=> $false )
        & ( v103854(VarCurr,2)
        <=> $false )
        & ( v103854(VarCurr,1)
        <=> $false )
        & ( v103854(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63410,axiom,
    ! [VarCurr: state_type] :
      ( v103899(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_63409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103897(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_63408,axiom,
    ! [VarCurr: state_type] :
      ( v103884(VarCurr)
    <=> v89212(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4058,axiom,
    ! [VarCurr: state_type] :
      ( v89212(VarCurr,1)
    <=> ( v103886(VarCurr)
        | v103894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10039,axiom,
    ! [VarCurr: state_type] :
      ( v103894(VarCurr)
    <=> ( v82954(VarCurr)
        & v103895(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_701,axiom,
    ! [VarCurr: state_type] :
      ( v103895(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10038,axiom,
    ! [VarCurr: state_type] :
      ( v103886(VarCurr)
    <=> ( v103887(VarCurr)
        | v103892(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10037,axiom,
    ! [VarCurr: state_type] :
      ( v103892(VarCurr)
    <=> ( v86877(VarCurr)
        & v103893(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_700,axiom,
    ! [VarCurr: state_type] :
      ( v103893(VarCurr)
    <=> ( ( v88266(VarCurr,2)
        <=> $false )
        & ( v88266(VarCurr,1)
        <=> $false )
        & ( v88266(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10036,axiom,
    ! [VarCurr: state_type] :
      ( v103887(VarCurr)
    <=> ( v103888(VarCurr)
        | v103890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10035,axiom,
    ! [VarCurr: state_type] :
      ( v103890(VarCurr)
    <=> ( v84899(VarCurr)
        & v103891(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_699,axiom,
    ! [VarCurr: state_type] :
      ( v103891(VarCurr)
    <=> ( ( v89243(VarCurr,6)
        <=> $false )
        & ( v89243(VarCurr,5)
        <=> $false )
        & ( v89243(VarCurr,4)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10034,axiom,
    ! [VarCurr: state_type] :
      ( v103888(VarCurr)
    <=> ( v118(VarCurr)
        & v103889(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_698,axiom,
    ! [VarCurr: state_type] :
      ( v103889(VarCurr)
    <=> ( ( v89214(VarCurr,6)
        <=> $false )
        & ( v89214(VarCurr,5)
        <=> $false )
        & ( v89214(VarCurr,4)
        <=> $true ) ) ) ).

tff(addAssignment_63407,axiom,
    ! [VarCurr: state_type] :
      ( v103868(VarCurr)
    <=> v103870(VarCurr) ) ).

tff(addAssignment_63406,axiom,
    ! [VarCurr: state_type] :
      ( v103870(VarCurr)
    <=> v103872(VarCurr) ) ).

tff(addAssignment_63405,axiom,
    ! [VarCurr: state_type] :
      ( v103872(VarCurr)
    <=> v103874(VarCurr) ) ).

tff(addAssignment_63404,axiom,
    ! [VarCurr: state_type] :
      ( v103874(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_63403,axiom,
    ! [VarCurr: state_type] :
      ( v103860(VarCurr)
    <=> v103862(VarCurr) ) ).

tff(addAssignment_63402,axiom,
    ! [VarCurr: state_type] :
      ( v103862(VarCurr)
    <=> v103864(VarCurr) ) ).

tff(addAssignment_63401,axiom,
    ! [VarCurr: state_type] :
      ( v103864(VarCurr)
    <=> v103866(VarCurr) ) ).

tff(addAssignment_63400,axiom,
    ! [VarCurr: state_type] :
      ( v103866(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_63399,axiom,
    ! [VarCurr: state_type] :
      ( v103376(VarCurr,0)
    <=> v103378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10033,axiom,
    ! [VarCurr: state_type] :
      ( v103378(VarCurr)
    <=> ( v103845(VarCurr)
        & v103850(VarCurr) ) ) ).

tff(writeUnaryOperator_5183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103850(VarCurr)
    <=> v103759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10032,axiom,
    ! [VarCurr: state_type] :
      ( v103845(VarCurr)
    <=> ( v103846(VarCurr)
        & v103849(VarCurr) ) ) ).

tff(writeUnaryOperator_5182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103849(VarCurr)
    <=> v103675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10031,axiom,
    ! [VarCurr: state_type] :
      ( v103846(VarCurr)
    <=> ( v103847(VarCurr)
        & v103848(VarCurr) ) ) ).

tff(writeUnaryOperator_5181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103848(VarCurr)
    <=> v103593(VarCurr) ) ).

tff(writeUnaryOperator_5180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103847(VarCurr)
    <=> v103380(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_697,axiom,
    ! [VarCurr: state_type] :
      ( v103759(VarCurr)
    <=> ( ( v103761(VarCurr,4)
        <=> $false )
        & ( v103761(VarCurr,3)
        <=> $false )
        & ( v103761(VarCurr,2)
        <=> $false )
        & ( v103761(VarCurr,1)
        <=> $false )
        & ( v103761(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103761(VarCurr,B)
      <=> v103763(VarCurr,B) ) ) ).

tff(addAssignment_63397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103763(VarCurr,B)
      <=> v103765(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103827(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103765(VarNext,B)
            <=> v103765(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1251,axiom,
    ! [VarNext: state_type] :
      ( v103827(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103765(VarNext,B)
          <=> v103837(VarNext,B) ) ) ) ).

tff(addAssignment_63396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103837(VarNext,B)
          <=> v103835(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103838(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103835(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_740,axiom,
    ! [VarCurr: state_type] :
      ( v103838(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103835(VarCurr,B)
          <=> v103775(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10030,axiom,
    ! [VarCurr: state_type] :
      ( v103838(VarCurr)
    <=> ( v103839(VarCurr)
        & v103840(VarCurr) ) ) ).

tff(writeUnaryOperator_5179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103840(VarCurr)
    <=> v103771(VarCurr) ) ).

tff(writeUnaryOperator_5178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103839(VarCurr)
    <=> v103767(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103827(VarNext)
      <=> v103828(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103828(VarNext)
      <=> ( v103829(VarNext)
          & v103822(VarNext) ) ) ) ).

tff(writeUnaryOperator_5177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103829(VarNext)
      <=> v103831(VarNext) ) ) ).

tff(addAssignment_63395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103831(VarNext)
      <=> v103822(VarCurr) ) ) ).

tff(addAssignment_63394,axiom,
    ! [VarCurr: state_type] :
      ( v103822(VarCurr)
    <=> v103824(VarCurr) ) ).

tff(addAssignment_63393,axiom,
    ! [VarCurr: state_type] :
      ( v103824(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103775(VarCurr,B)
      <=> v103777(VarCurr,B) ) ) ).

tff(addAssignment_63391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103777(VarCurr,B)
      <=> v103779(VarCurr,B) ) ) ).

tff(addAssignment_63390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103779(VarCurr,B)
      <=> v103781(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103783(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103781(VarCurr,B)
          <=> v103792(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_739,axiom,
    ! [VarCurr: state_type] :
      ( v103783(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103781(VarCurr,B)
          <=> v103791(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103759(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103792(VarCurr,B)
          <=> v103793(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_738,axiom,
    ! [VarCurr: state_type] :
      ( v103759(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103792(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63389,axiom,
    ! [VarCurr: state_type] :
      ( v103793(VarCurr,0)
    <=> v103819(VarCurr) ) ).

tff(addAssignment_63388,axiom,
    ! [VarCurr: state_type] :
      ( v103793(VarCurr,1)
    <=> v103817(VarCurr) ) ).

tff(addAssignment_63387,axiom,
    ! [VarCurr: state_type] :
      ( v103793(VarCurr,2)
    <=> v103813(VarCurr) ) ).

tff(addAssignment_63386,axiom,
    ! [VarCurr: state_type] :
      ( v103793(VarCurr,3)
    <=> v103809(VarCurr) ) ).

tff(addAssignment_63385,axiom,
    ! [VarCurr: state_type] :
      ( v103793(VarCurr,4)
    <=> v103795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10027,axiom,
    ! [VarCurr: state_type] :
      ( v103817(VarCurr)
    <=> ( v103818(VarCurr)
        & v103820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10026,axiom,
    ! [VarCurr: state_type] :
      ( v103820(VarCurr)
    <=> ( v103761(VarCurr,0)
        | v103804(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4057,axiom,
    ! [VarCurr: state_type] :
      ( v103818(VarCurr)
    <=> ( v103819(VarCurr)
        | v103761(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103819(VarCurr)
    <=> v103761(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10025,axiom,
    ! [VarCurr: state_type] :
      ( v103813(VarCurr)
    <=> ( v103814(VarCurr)
        & v103816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10024,axiom,
    ! [VarCurr: state_type] :
      ( v103816(VarCurr)
    <=> ( v103802(VarCurr)
        | v103805(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4056,axiom,
    ! [VarCurr: state_type] :
      ( v103814(VarCurr)
    <=> ( v103815(VarCurr)
        | v103761(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103815(VarCurr)
    <=> v103802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10023,axiom,
    ! [VarCurr: state_type] :
      ( v103809(VarCurr)
    <=> ( v103810(VarCurr)
        & v103812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10022,axiom,
    ! [VarCurr: state_type] :
      ( v103812(VarCurr)
    <=> ( v103800(VarCurr)
        | v103806(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4055,axiom,
    ! [VarCurr: state_type] :
      ( v103810(VarCurr)
    <=> ( v103811(VarCurr)
        | v103761(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103811(VarCurr)
    <=> v103800(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10021,axiom,
    ! [VarCurr: state_type] :
      ( v103795(VarCurr)
    <=> ( v103796(VarCurr)
        & v103807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10020,axiom,
    ! [VarCurr: state_type] :
      ( v103807(VarCurr)
    <=> ( v103798(VarCurr)
        | v103808(VarCurr) ) ) ).

tff(writeUnaryOperator_5173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103808(VarCurr)
    <=> v103761(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4054,axiom,
    ! [VarCurr: state_type] :
      ( v103796(VarCurr)
    <=> ( v103797(VarCurr)
        | v103761(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103797(VarCurr)
    <=> v103798(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4053,axiom,
    ! [VarCurr: state_type] :
      ( v103798(VarCurr)
    <=> ( v103761(VarCurr,3)
        | v103799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10019,axiom,
    ! [VarCurr: state_type] :
      ( v103799(VarCurr)
    <=> ( v103800(VarCurr)
        & v103806(VarCurr) ) ) ).

tff(writeUnaryOperator_5171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103806(VarCurr)
    <=> v103761(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4052,axiom,
    ! [VarCurr: state_type] :
      ( v103800(VarCurr)
    <=> ( v103761(VarCurr,2)
        | v103801(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10018,axiom,
    ! [VarCurr: state_type] :
      ( v103801(VarCurr)
    <=> ( v103802(VarCurr)
        & v103805(VarCurr) ) ) ).

tff(writeUnaryOperator_5170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103805(VarCurr)
    <=> v103761(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4051,axiom,
    ! [VarCurr: state_type] :
      ( v103802(VarCurr)
    <=> ( v103761(VarCurr,1)
        | v103803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10017,axiom,
    ! [VarCurr: state_type] :
      ( v103803(VarCurr)
    <=> ( v103761(VarCurr,0)
        & v103804(VarCurr) ) ) ).

tff(writeUnaryOperator_5169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103804(VarCurr)
    <=> v103761(VarCurr,1) ) ).

tff(addAssignment_63384,axiom,
    ! [VarCurr: state_type] :
      ( v103791(VarCurr,0)
    <=> v103538(VarCurr) ) ).

tff(addAssignment_63383,axiom,
    ! [VarCurr: state_type] :
      ( v103791(VarCurr,1)
    <=> v103536(VarCurr) ) ).

tff(addAssignment_63382,axiom,
    ! [VarCurr: state_type] :
      ( v103791(VarCurr,2)
    <=> v103532(VarCurr) ) ).

tff(addAssignment_63381,axiom,
    ! [VarCurr: state_type] :
      ( v103791(VarCurr,3)
    <=> v103528(VarCurr) ) ).

tff(addAssignment_63380,axiom,
    ! [VarCurr: state_type] :
      ( v103791(VarCurr,4)
    <=> v103514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10016,axiom,
    ! [VarCurr: state_type] :
      ( v103783(VarCurr)
    <=> ( v103784(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10015,axiom,
    ! [VarCurr: state_type] :
      ( v103784(VarCurr)
    <=> ( v103785(VarCurr)
        & v103404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10014,axiom,
    ! [VarCurr: state_type] :
      ( v103785(VarCurr)
    <=> ( v103786(VarCurr)
        & v103790(VarCurr) ) ) ).

tff(writeUnaryOperator_5168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103790(VarCurr)
    <=> v103380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10013,axiom,
    ! [VarCurr: state_type] :
      ( v103786(VarCurr)
    <=> ( v103787(VarCurr)
        & v103789(VarCurr) ) ) ).

tff(writeUnaryOperator_5167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103789(VarCurr)
    <=> v103593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10012,axiom,
    ! [VarCurr: state_type] :
      ( v103787(VarCurr)
    <=> ( v103759(VarCurr)
        & v103788(VarCurr) ) ) ).

tff(writeUnaryOperator_5166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103788(VarCurr)
    <=> v103675(VarCurr) ) ).

tff(addAssignment_63379,axiom,
    ! [VarCurr: state_type] :
      ( v103771(VarCurr)
    <=> v103773(VarCurr) ) ).

tff(addAssignment_63378,axiom,
    ! [VarCurr: state_type] :
      ( v103773(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_63377,axiom,
    ! [VarCurr: state_type] :
      ( v103767(VarCurr)
    <=> v103769(VarCurr) ) ).

tff(addAssignment_63376,axiom,
    ! [VarCurr: state_type] :
      ( v103769(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_696,axiom,
    ! [VarCurr: state_type] :
      ( v103675(VarCurr)
    <=> ( ( v103677(VarCurr,4)
        <=> $false )
        & ( v103677(VarCurr,3)
        <=> $false )
        & ( v103677(VarCurr,2)
        <=> $false )
        & ( v103677(VarCurr,1)
        <=> $false )
        & ( v103677(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103677(VarCurr,B)
      <=> v103679(VarCurr,B) ) ) ).

tff(addAssignment_63374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103679(VarCurr,B)
      <=> v103681(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103741(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103681(VarNext,B)
            <=> v103681(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1250,axiom,
    ! [VarNext: state_type] :
      ( v103741(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103681(VarNext,B)
          <=> v103751(VarNext,B) ) ) ) ).

tff(addAssignment_63373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103751(VarNext,B)
          <=> v103749(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103752(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103749(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_737,axiom,
    ! [VarCurr: state_type] :
      ( v103752(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103749(VarCurr,B)
          <=> v103691(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10011,axiom,
    ! [VarCurr: state_type] :
      ( v103752(VarCurr)
    <=> ( v103753(VarCurr)
        & v103754(VarCurr) ) ) ).

tff(writeUnaryOperator_5165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103754(VarCurr)
    <=> v103687(VarCurr) ) ).

tff(writeUnaryOperator_5164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103753(VarCurr)
    <=> v103683(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103741(VarNext)
      <=> v103742(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103742(VarNext)
      <=> ( v103743(VarNext)
          & v103736(VarNext) ) ) ) ).

tff(writeUnaryOperator_5163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103743(VarNext)
      <=> v103745(VarNext) ) ) ).

tff(addAssignment_63372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103745(VarNext)
      <=> v103736(VarCurr) ) ) ).

tff(addAssignment_63371,axiom,
    ! [VarCurr: state_type] :
      ( v103736(VarCurr)
    <=> v103738(VarCurr) ) ).

tff(addAssignment_63370,axiom,
    ! [VarCurr: state_type] :
      ( v103738(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103691(VarCurr,B)
      <=> v103693(VarCurr,B) ) ) ).

tff(addAssignment_63368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103693(VarCurr,B)
      <=> v103695(VarCurr,B) ) ) ).

tff(addAssignment_63367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103695(VarCurr,B)
      <=> v103697(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103699(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103697(VarCurr,B)
          <=> v103706(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_736,axiom,
    ! [VarCurr: state_type] :
      ( v103699(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103697(VarCurr,B)
          <=> v103705(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103675(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103706(VarCurr,B)
          <=> v103707(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_735,axiom,
    ! [VarCurr: state_type] :
      ( v103675(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103706(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63366,axiom,
    ! [VarCurr: state_type] :
      ( v103707(VarCurr,0)
    <=> v103733(VarCurr) ) ).

tff(addAssignment_63365,axiom,
    ! [VarCurr: state_type] :
      ( v103707(VarCurr,1)
    <=> v103731(VarCurr) ) ).

tff(addAssignment_63364,axiom,
    ! [VarCurr: state_type] :
      ( v103707(VarCurr,2)
    <=> v103727(VarCurr) ) ).

tff(addAssignment_63363,axiom,
    ! [VarCurr: state_type] :
      ( v103707(VarCurr,3)
    <=> v103723(VarCurr) ) ).

tff(addAssignment_63362,axiom,
    ! [VarCurr: state_type] :
      ( v103707(VarCurr,4)
    <=> v103709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10008,axiom,
    ! [VarCurr: state_type] :
      ( v103731(VarCurr)
    <=> ( v103732(VarCurr)
        & v103734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10007,axiom,
    ! [VarCurr: state_type] :
      ( v103734(VarCurr)
    <=> ( v103677(VarCurr,0)
        | v103718(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4050,axiom,
    ! [VarCurr: state_type] :
      ( v103732(VarCurr)
    <=> ( v103733(VarCurr)
        | v103677(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103733(VarCurr)
    <=> v103677(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10006,axiom,
    ! [VarCurr: state_type] :
      ( v103727(VarCurr)
    <=> ( v103728(VarCurr)
        & v103730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10005,axiom,
    ! [VarCurr: state_type] :
      ( v103730(VarCurr)
    <=> ( v103716(VarCurr)
        | v103719(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4049,axiom,
    ! [VarCurr: state_type] :
      ( v103728(VarCurr)
    <=> ( v103729(VarCurr)
        | v103677(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103729(VarCurr)
    <=> v103716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10004,axiom,
    ! [VarCurr: state_type] :
      ( v103723(VarCurr)
    <=> ( v103724(VarCurr)
        & v103726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10003,axiom,
    ! [VarCurr: state_type] :
      ( v103726(VarCurr)
    <=> ( v103714(VarCurr)
        | v103720(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4048,axiom,
    ! [VarCurr: state_type] :
      ( v103724(VarCurr)
    <=> ( v103725(VarCurr)
        | v103677(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103725(VarCurr)
    <=> v103714(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10002,axiom,
    ! [VarCurr: state_type] :
      ( v103709(VarCurr)
    <=> ( v103710(VarCurr)
        & v103721(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10001,axiom,
    ! [VarCurr: state_type] :
      ( v103721(VarCurr)
    <=> ( v103712(VarCurr)
        | v103722(VarCurr) ) ) ).

tff(writeUnaryOperator_5159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103722(VarCurr)
    <=> v103677(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4047,axiom,
    ! [VarCurr: state_type] :
      ( v103710(VarCurr)
    <=> ( v103711(VarCurr)
        | v103677(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103711(VarCurr)
    <=> v103712(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4046,axiom,
    ! [VarCurr: state_type] :
      ( v103712(VarCurr)
    <=> ( v103677(VarCurr,3)
        | v103713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10000,axiom,
    ! [VarCurr: state_type] :
      ( v103713(VarCurr)
    <=> ( v103714(VarCurr)
        & v103720(VarCurr) ) ) ).

tff(writeUnaryOperator_5157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103720(VarCurr)
    <=> v103677(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4045,axiom,
    ! [VarCurr: state_type] :
      ( v103714(VarCurr)
    <=> ( v103677(VarCurr,2)
        | v103715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9999,axiom,
    ! [VarCurr: state_type] :
      ( v103715(VarCurr)
    <=> ( v103716(VarCurr)
        & v103719(VarCurr) ) ) ).

tff(writeUnaryOperator_5156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103719(VarCurr)
    <=> v103677(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4044,axiom,
    ! [VarCurr: state_type] :
      ( v103716(VarCurr)
    <=> ( v103677(VarCurr,1)
        | v103717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9998,axiom,
    ! [VarCurr: state_type] :
      ( v103717(VarCurr)
    <=> ( v103677(VarCurr,0)
        & v103718(VarCurr) ) ) ).

tff(writeUnaryOperator_5155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103718(VarCurr)
    <=> v103677(VarCurr,1) ) ).

tff(addAssignment_63361,axiom,
    ! [VarCurr: state_type] :
      ( v103705(VarCurr,0)
    <=> v103538(VarCurr) ) ).

tff(addAssignment_63360,axiom,
    ! [VarCurr: state_type] :
      ( v103705(VarCurr,1)
    <=> v103536(VarCurr) ) ).

tff(addAssignment_63359,axiom,
    ! [VarCurr: state_type] :
      ( v103705(VarCurr,2)
    <=> v103532(VarCurr) ) ).

tff(addAssignment_63358,axiom,
    ! [VarCurr: state_type] :
      ( v103705(VarCurr,3)
    <=> v103528(VarCurr) ) ).

tff(addAssignment_63357,axiom,
    ! [VarCurr: state_type] :
      ( v103705(VarCurr,4)
    <=> v103514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9997,axiom,
    ! [VarCurr: state_type] :
      ( v103699(VarCurr)
    <=> ( v103700(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9996,axiom,
    ! [VarCurr: state_type] :
      ( v103700(VarCurr)
    <=> ( v103701(VarCurr)
        & v103404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9995,axiom,
    ! [VarCurr: state_type] :
      ( v103701(VarCurr)
    <=> ( v103702(VarCurr)
        & v103704(VarCurr) ) ) ).

tff(writeUnaryOperator_5154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103704(VarCurr)
    <=> v103380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9994,axiom,
    ! [VarCurr: state_type] :
      ( v103702(VarCurr)
    <=> ( v103675(VarCurr)
        & v103703(VarCurr) ) ) ).

tff(writeUnaryOperator_5153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103703(VarCurr)
    <=> v103593(VarCurr) ) ).

tff(addAssignment_63356,axiom,
    ! [VarCurr: state_type] :
      ( v103687(VarCurr)
    <=> v103689(VarCurr) ) ).

tff(addAssignment_63355,axiom,
    ! [VarCurr: state_type] :
      ( v103689(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_63354,axiom,
    ! [VarCurr: state_type] :
      ( v103683(VarCurr)
    <=> v103685(VarCurr) ) ).

tff(addAssignment_63353,axiom,
    ! [VarCurr: state_type] :
      ( v103685(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_695,axiom,
    ! [VarCurr: state_type] :
      ( v103593(VarCurr)
    <=> ( ( v103595(VarCurr,4)
        <=> $false )
        & ( v103595(VarCurr,3)
        <=> $false )
        & ( v103595(VarCurr,2)
        <=> $false )
        & ( v103595(VarCurr,1)
        <=> $false )
        & ( v103595(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103595(VarCurr,B)
      <=> v103597(VarCurr,B) ) ) ).

tff(addAssignment_63351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103597(VarCurr,B)
      <=> v103599(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103657(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103599(VarNext,B)
            <=> v103599(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1249,axiom,
    ! [VarNext: state_type] :
      ( v103657(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103599(VarNext,B)
          <=> v103667(VarNext,B) ) ) ) ).

tff(addAssignment_63350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103667(VarNext,B)
          <=> v103665(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103665(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_734,axiom,
    ! [VarCurr: state_type] :
      ( v103668(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103665(VarCurr,B)
          <=> v103609(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9993,axiom,
    ! [VarCurr: state_type] :
      ( v103668(VarCurr)
    <=> ( v103669(VarCurr)
        & v103670(VarCurr) ) ) ).

tff(writeUnaryOperator_5152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103670(VarCurr)
    <=> v103605(VarCurr) ) ).

tff(writeUnaryOperator_5151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103669(VarCurr)
    <=> v103601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103657(VarNext)
      <=> v103658(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103658(VarNext)
      <=> ( v103659(VarNext)
          & v103652(VarNext) ) ) ) ).

tff(writeUnaryOperator_5150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103659(VarNext)
      <=> v103661(VarNext) ) ) ).

tff(addAssignment_63349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103661(VarNext)
      <=> v103652(VarCurr) ) ) ).

tff(addAssignment_63348,axiom,
    ! [VarCurr: state_type] :
      ( v103652(VarCurr)
    <=> v103654(VarCurr) ) ).

tff(addAssignment_63347,axiom,
    ! [VarCurr: state_type] :
      ( v103654(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103609(VarCurr,B)
      <=> v103611(VarCurr,B) ) ) ).

tff(addAssignment_63345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103611(VarCurr,B)
      <=> v103613(VarCurr,B) ) ) ).

tff(addAssignment_63344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103613(VarCurr,B)
      <=> v103615(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103615(VarCurr,B)
          <=> v103622(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_733,axiom,
    ! [VarCurr: state_type] :
      ( v103617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103615(VarCurr,B)
          <=> v103621(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103622(VarCurr,B)
          <=> v103623(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_732,axiom,
    ! [VarCurr: state_type] :
      ( v103593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103622(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63343,axiom,
    ! [VarCurr: state_type] :
      ( v103623(VarCurr,0)
    <=> v103649(VarCurr) ) ).

tff(addAssignment_63342,axiom,
    ! [VarCurr: state_type] :
      ( v103623(VarCurr,1)
    <=> v103647(VarCurr) ) ).

tff(addAssignment_63341,axiom,
    ! [VarCurr: state_type] :
      ( v103623(VarCurr,2)
    <=> v103643(VarCurr) ) ).

tff(addAssignment_63340,axiom,
    ! [VarCurr: state_type] :
      ( v103623(VarCurr,3)
    <=> v103639(VarCurr) ) ).

tff(addAssignment_63339,axiom,
    ! [VarCurr: state_type] :
      ( v103623(VarCurr,4)
    <=> v103625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9990,axiom,
    ! [VarCurr: state_type] :
      ( v103647(VarCurr)
    <=> ( v103648(VarCurr)
        & v103650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9989,axiom,
    ! [VarCurr: state_type] :
      ( v103650(VarCurr)
    <=> ( v103595(VarCurr,0)
        | v103634(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4043,axiom,
    ! [VarCurr: state_type] :
      ( v103648(VarCurr)
    <=> ( v103649(VarCurr)
        | v103595(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103649(VarCurr)
    <=> v103595(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9988,axiom,
    ! [VarCurr: state_type] :
      ( v103643(VarCurr)
    <=> ( v103644(VarCurr)
        & v103646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9987,axiom,
    ! [VarCurr: state_type] :
      ( v103646(VarCurr)
    <=> ( v103632(VarCurr)
        | v103635(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4042,axiom,
    ! [VarCurr: state_type] :
      ( v103644(VarCurr)
    <=> ( v103645(VarCurr)
        | v103595(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103645(VarCurr)
    <=> v103632(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9986,axiom,
    ! [VarCurr: state_type] :
      ( v103639(VarCurr)
    <=> ( v103640(VarCurr)
        & v103642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9985,axiom,
    ! [VarCurr: state_type] :
      ( v103642(VarCurr)
    <=> ( v103630(VarCurr)
        | v103636(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4041,axiom,
    ! [VarCurr: state_type] :
      ( v103640(VarCurr)
    <=> ( v103641(VarCurr)
        | v103595(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103641(VarCurr)
    <=> v103630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9984,axiom,
    ! [VarCurr: state_type] :
      ( v103625(VarCurr)
    <=> ( v103626(VarCurr)
        & v103637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9983,axiom,
    ! [VarCurr: state_type] :
      ( v103637(VarCurr)
    <=> ( v103628(VarCurr)
        | v103638(VarCurr) ) ) ).

tff(writeUnaryOperator_5146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103638(VarCurr)
    <=> v103595(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4040,axiom,
    ! [VarCurr: state_type] :
      ( v103626(VarCurr)
    <=> ( v103627(VarCurr)
        | v103595(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103627(VarCurr)
    <=> v103628(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4039,axiom,
    ! [VarCurr: state_type] :
      ( v103628(VarCurr)
    <=> ( v103595(VarCurr,3)
        | v103629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9982,axiom,
    ! [VarCurr: state_type] :
      ( v103629(VarCurr)
    <=> ( v103630(VarCurr)
        & v103636(VarCurr) ) ) ).

tff(writeUnaryOperator_5144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103636(VarCurr)
    <=> v103595(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4038,axiom,
    ! [VarCurr: state_type] :
      ( v103630(VarCurr)
    <=> ( v103595(VarCurr,2)
        | v103631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9981,axiom,
    ! [VarCurr: state_type] :
      ( v103631(VarCurr)
    <=> ( v103632(VarCurr)
        & v103635(VarCurr) ) ) ).

tff(writeUnaryOperator_5143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103635(VarCurr)
    <=> v103595(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4037,axiom,
    ! [VarCurr: state_type] :
      ( v103632(VarCurr)
    <=> ( v103595(VarCurr,1)
        | v103633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9980,axiom,
    ! [VarCurr: state_type] :
      ( v103633(VarCurr)
    <=> ( v103595(VarCurr,0)
        & v103634(VarCurr) ) ) ).

tff(writeUnaryOperator_5142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103634(VarCurr)
    <=> v103595(VarCurr,1) ) ).

tff(addAssignment_63338,axiom,
    ! [VarCurr: state_type] :
      ( v103621(VarCurr,0)
    <=> v103538(VarCurr) ) ).

tff(addAssignment_63337,axiom,
    ! [VarCurr: state_type] :
      ( v103621(VarCurr,1)
    <=> v103536(VarCurr) ) ).

tff(addAssignment_63336,axiom,
    ! [VarCurr: state_type] :
      ( v103621(VarCurr,2)
    <=> v103532(VarCurr) ) ).

tff(addAssignment_63335,axiom,
    ! [VarCurr: state_type] :
      ( v103621(VarCurr,3)
    <=> v103528(VarCurr) ) ).

tff(addAssignment_63334,axiom,
    ! [VarCurr: state_type] :
      ( v103621(VarCurr,4)
    <=> v103514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9979,axiom,
    ! [VarCurr: state_type] :
      ( v103617(VarCurr)
    <=> ( v103618(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9978,axiom,
    ! [VarCurr: state_type] :
      ( v103618(VarCurr)
    <=> ( v103619(VarCurr)
        & v103404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9977,axiom,
    ! [VarCurr: state_type] :
      ( v103619(VarCurr)
    <=> ( v103593(VarCurr)
        & v103620(VarCurr) ) ) ).

tff(writeUnaryOperator_5141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103620(VarCurr)
    <=> v103380(VarCurr) ) ).

tff(addAssignment_63333,axiom,
    ! [VarCurr: state_type] :
      ( v103605(VarCurr)
    <=> v103607(VarCurr) ) ).

tff(addAssignment_63332,axiom,
    ! [VarCurr: state_type] :
      ( v103607(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_63331,axiom,
    ! [VarCurr: state_type] :
      ( v103601(VarCurr)
    <=> v103603(VarCurr) ) ).

tff(addAssignment_63330,axiom,
    ! [VarCurr: state_type] :
      ( v103603(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_694,axiom,
    ! [VarCurr: state_type] :
      ( v103380(VarCurr)
    <=> ( ( v103382(VarCurr,4)
        <=> $false )
        & ( v103382(VarCurr,3)
        <=> $false )
        & ( v103382(VarCurr,2)
        <=> $false )
        & ( v103382(VarCurr,1)
        <=> $false )
        & ( v103382(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103382(VarCurr,B)
      <=> v103384(VarCurr,B) ) ) ).

tff(addAssignment_63328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103384(VarCurr,B)
      <=> v103386(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103575(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103386(VarNext,B)
            <=> v103386(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1248,axiom,
    ! [VarNext: state_type] :
      ( v103575(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103386(VarNext,B)
          <=> v103585(VarNext,B) ) ) ) ).

tff(addAssignment_63327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103585(VarNext,B)
          <=> v103583(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103586(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103583(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_731,axiom,
    ! [VarCurr: state_type] :
      ( v103586(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103583(VarCurr,B)
          <=> v103396(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9976,axiom,
    ! [VarCurr: state_type] :
      ( v103586(VarCurr)
    <=> ( v103587(VarCurr)
        & v103588(VarCurr) ) ) ).

tff(writeUnaryOperator_5140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103588(VarCurr)
    <=> v103392(VarCurr) ) ).

tff(writeUnaryOperator_5139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103587(VarCurr)
    <=> v103388(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103575(VarNext)
      <=> v103576(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103576(VarNext)
      <=> ( v103577(VarNext)
          & v103570(VarNext) ) ) ) ).

tff(writeUnaryOperator_5138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103577(VarNext)
      <=> v103579(VarNext) ) ) ).

tff(addAssignment_63326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103579(VarNext)
      <=> v103570(VarCurr) ) ) ).

tff(addAssignment_63325,axiom,
    ! [VarCurr: state_type] :
      ( v103570(VarCurr)
    <=> v103572(VarCurr) ) ).

tff(addAssignment_63324,axiom,
    ! [VarCurr: state_type] :
      ( v103572(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103396(VarCurr,B)
      <=> v103398(VarCurr,B) ) ) ).

tff(addAssignment_63322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103398(VarCurr,B)
      <=> v103400(VarCurr,B) ) ) ).

tff(addAssignment_63321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103400(VarCurr,B)
      <=> v103402(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103402(VarCurr,B)
          <=> v103540(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_730,axiom,
    ! [VarCurr: state_type] :
      ( v103510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103402(VarCurr,B)
          <=> v103512(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103540(VarCurr,B)
          <=> v103541(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_729,axiom,
    ! [VarCurr: state_type] :
      ( v103380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103540(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63320,axiom,
    ! [VarCurr: state_type] :
      ( v103541(VarCurr,0)
    <=> v103567(VarCurr) ) ).

tff(addAssignment_63319,axiom,
    ! [VarCurr: state_type] :
      ( v103541(VarCurr,1)
    <=> v103565(VarCurr) ) ).

tff(addAssignment_63318,axiom,
    ! [VarCurr: state_type] :
      ( v103541(VarCurr,2)
    <=> v103561(VarCurr) ) ).

tff(addAssignment_63317,axiom,
    ! [VarCurr: state_type] :
      ( v103541(VarCurr,3)
    <=> v103557(VarCurr) ) ).

tff(addAssignment_63316,axiom,
    ! [VarCurr: state_type] :
      ( v103541(VarCurr,4)
    <=> v103543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9973,axiom,
    ! [VarCurr: state_type] :
      ( v103565(VarCurr)
    <=> ( v103566(VarCurr)
        & v103568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9972,axiom,
    ! [VarCurr: state_type] :
      ( v103568(VarCurr)
    <=> ( v103382(VarCurr,0)
        | v103552(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4036,axiom,
    ! [VarCurr: state_type] :
      ( v103566(VarCurr)
    <=> ( v103567(VarCurr)
        | v103382(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103567(VarCurr)
    <=> v103382(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9971,axiom,
    ! [VarCurr: state_type] :
      ( v103561(VarCurr)
    <=> ( v103562(VarCurr)
        & v103564(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9970,axiom,
    ! [VarCurr: state_type] :
      ( v103564(VarCurr)
    <=> ( v103550(VarCurr)
        | v103553(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4035,axiom,
    ! [VarCurr: state_type] :
      ( v103562(VarCurr)
    <=> ( v103563(VarCurr)
        | v103382(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103563(VarCurr)
    <=> v103550(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9969,axiom,
    ! [VarCurr: state_type] :
      ( v103557(VarCurr)
    <=> ( v103558(VarCurr)
        & v103560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9968,axiom,
    ! [VarCurr: state_type] :
      ( v103560(VarCurr)
    <=> ( v103548(VarCurr)
        | v103554(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4034,axiom,
    ! [VarCurr: state_type] :
      ( v103558(VarCurr)
    <=> ( v103559(VarCurr)
        | v103382(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103559(VarCurr)
    <=> v103548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9967,axiom,
    ! [VarCurr: state_type] :
      ( v103543(VarCurr)
    <=> ( v103544(VarCurr)
        & v103555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9966,axiom,
    ! [VarCurr: state_type] :
      ( v103555(VarCurr)
    <=> ( v103546(VarCurr)
        | v103556(VarCurr) ) ) ).

tff(writeUnaryOperator_5134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103556(VarCurr)
    <=> v103382(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4033,axiom,
    ! [VarCurr: state_type] :
      ( v103544(VarCurr)
    <=> ( v103545(VarCurr)
        | v103382(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103545(VarCurr)
    <=> v103546(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4032,axiom,
    ! [VarCurr: state_type] :
      ( v103546(VarCurr)
    <=> ( v103382(VarCurr,3)
        | v103547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9965,axiom,
    ! [VarCurr: state_type] :
      ( v103547(VarCurr)
    <=> ( v103548(VarCurr)
        & v103554(VarCurr) ) ) ).

tff(writeUnaryOperator_5132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103554(VarCurr)
    <=> v103382(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4031,axiom,
    ! [VarCurr: state_type] :
      ( v103548(VarCurr)
    <=> ( v103382(VarCurr,2)
        | v103549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9964,axiom,
    ! [VarCurr: state_type] :
      ( v103549(VarCurr)
    <=> ( v103550(VarCurr)
        & v103553(VarCurr) ) ) ).

tff(writeUnaryOperator_5131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103553(VarCurr)
    <=> v103382(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4030,axiom,
    ! [VarCurr: state_type] :
      ( v103550(VarCurr)
    <=> ( v103382(VarCurr,1)
        | v103551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9963,axiom,
    ! [VarCurr: state_type] :
      ( v103551(VarCurr)
    <=> ( v103382(VarCurr,0)
        & v103552(VarCurr) ) ) ).

tff(writeUnaryOperator_5130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103552(VarCurr)
    <=> v103382(VarCurr,1) ) ).

tff(addAssignment_63315,axiom,
    ! [VarCurr: state_type] :
      ( v103512(VarCurr,0)
    <=> v103538(VarCurr) ) ).

tff(addAssignment_63314,axiom,
    ! [VarCurr: state_type] :
      ( v103512(VarCurr,1)
    <=> v103536(VarCurr) ) ).

tff(addAssignment_63313,axiom,
    ! [VarCurr: state_type] :
      ( v103512(VarCurr,2)
    <=> v103532(VarCurr) ) ).

tff(addAssignment_63312,axiom,
    ! [VarCurr: state_type] :
      ( v103512(VarCurr,3)
    <=> v103528(VarCurr) ) ).

tff(addAssignment_63311,axiom,
    ! [VarCurr: state_type] :
      ( v103512(VarCurr,4)
    <=> v103514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9962,axiom,
    ! [VarCurr: state_type] :
      ( v103536(VarCurr)
    <=> ( v103537(VarCurr)
        & v103539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9961,axiom,
    ! [VarCurr: state_type] :
      ( v103539(VarCurr)
    <=> ( v103408(VarCurr,0)
        | v103523(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4029,axiom,
    ! [VarCurr: state_type] :
      ( v103537(VarCurr)
    <=> ( v103538(VarCurr)
        | v103408(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103538(VarCurr)
    <=> v103408(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9960,axiom,
    ! [VarCurr: state_type] :
      ( v103532(VarCurr)
    <=> ( v103533(VarCurr)
        & v103535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9959,axiom,
    ! [VarCurr: state_type] :
      ( v103535(VarCurr)
    <=> ( v103521(VarCurr)
        | v103524(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4028,axiom,
    ! [VarCurr: state_type] :
      ( v103533(VarCurr)
    <=> ( v103534(VarCurr)
        | v103408(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103534(VarCurr)
    <=> v103521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9958,axiom,
    ! [VarCurr: state_type] :
      ( v103528(VarCurr)
    <=> ( v103529(VarCurr)
        & v103531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9957,axiom,
    ! [VarCurr: state_type] :
      ( v103531(VarCurr)
    <=> ( v103519(VarCurr)
        | v103525(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4027,axiom,
    ! [VarCurr: state_type] :
      ( v103529(VarCurr)
    <=> ( v103530(VarCurr)
        | v103408(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103530(VarCurr)
    <=> v103519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9956,axiom,
    ! [VarCurr: state_type] :
      ( v103514(VarCurr)
    <=> ( v103515(VarCurr)
        & v103526(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9955,axiom,
    ! [VarCurr: state_type] :
      ( v103526(VarCurr)
    <=> ( v103517(VarCurr)
        | v103527(VarCurr) ) ) ).

tff(writeUnaryOperator_5126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103527(VarCurr)
    <=> v103408(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_4026,axiom,
    ! [VarCurr: state_type] :
      ( v103515(VarCurr)
    <=> ( v103516(VarCurr)
        | v103408(VarCurr,4) ) ) ).

tff(writeUnaryOperator_5125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103516(VarCurr)
    <=> v103517(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4025,axiom,
    ! [VarCurr: state_type] :
      ( v103517(VarCurr)
    <=> ( v103408(VarCurr,3)
        | v103518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9954,axiom,
    ! [VarCurr: state_type] :
      ( v103518(VarCurr)
    <=> ( v103519(VarCurr)
        & v103525(VarCurr) ) ) ).

tff(writeUnaryOperator_5124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103525(VarCurr)
    <=> v103408(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4024,axiom,
    ! [VarCurr: state_type] :
      ( v103519(VarCurr)
    <=> ( v103408(VarCurr,2)
        | v103520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9953,axiom,
    ! [VarCurr: state_type] :
      ( v103520(VarCurr)
    <=> ( v103521(VarCurr)
        & v103524(VarCurr) ) ) ).

tff(writeUnaryOperator_5123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103524(VarCurr)
    <=> v103408(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4023,axiom,
    ! [VarCurr: state_type] :
      ( v103521(VarCurr)
    <=> ( v103408(VarCurr,1)
        | v103522(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9952,axiom,
    ! [VarCurr: state_type] :
      ( v103522(VarCurr)
    <=> ( v103408(VarCurr,0)
        & v103523(VarCurr) ) ) ).

tff(writeUnaryOperator_5122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103523(VarCurr)
    <=> v103408(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9951,axiom,
    ! [VarCurr: state_type] :
      ( v103510(VarCurr)
    <=> ( v103511(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9950,axiom,
    ! [VarCurr: state_type] :
      ( v103511(VarCurr)
    <=> ( v103380(VarCurr)
        & v103404(VarCurr) ) ) ).

tff(addAssignment_63310,axiom,
    ! [VarCurr: state_type] :
      ( v103408(VarCurr,4)
    <=> v103410(VarCurr,4) ) ).

tff(addAssignment_63309,axiom,
    ! [VarCurr: state_type] :
      ( v103410(VarCurr,4)
    <=> v103412(VarCurr,4) ) ).

tff(addAssignment_63308,axiom,
    ! [VarCurr: state_type] :
      ( v103412(VarCurr,4)
    <=> v103414(VarCurr,4) ) ).

tff(addAssignment_63307,axiom,
    ! [VarNext: state_type] :
      ( v103414(VarNext,4)
    <=> v103502(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103503(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103502(VarNext,B)
            <=> v103414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1247,axiom,
    ! [VarNext: state_type] :
      ( v103503(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103502(VarNext,B)
          <=> v103464(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103503(VarNext)
      <=> v103504(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103504(VarNext)
      <=> ( v103506(VarNext)
          & v103449(VarNext) ) ) ) ).

tff(writeUnaryOperator_5121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103506(VarNext)
      <=> v103458(VarNext) ) ) ).

tff(addAssignment_63306,axiom,
    ! [VarCurr: state_type] :
      ( v103424(VarCurr,4)
    <=> v103426(VarCurr,4) ) ).

tff(addAssignment_63305,axiom,
    ! [VarCurr: state_type] :
      ( v103426(VarCurr,4)
    <=> v103440(VarCurr,4) ) ).

tff(addAssignment_63304,axiom,
    ! [VarCurr: state_type] :
      ( v103428(VarCurr,4)
    <=> v103431(VarCurr,4) ) ).

tff(addAssignment_63303,axiom,
    ! [VarCurr: state_type] :
      ( v103430(VarCurr,4)
    <=> v1119(VarCurr,4) ) ).

tff(addAssignment_63302,axiom,
    ! [VarCurr: state_type] :
      ( v103408(VarCurr,3)
    <=> v103410(VarCurr,3) ) ).

tff(writeUnaryOperator_5120,axiom,
    ! [VarCurr: state_type] :
      ( v103410(VarCurr,3)
    <=> ~ v103471(VarCurr,1) ) ).

tff(addAssignment_63301,axiom,
    ! [VarCurr: state_type] :
      ( v103471(VarCurr,1)
    <=> v103412(VarCurr,1) ) ).

tff(addAssignment_63300,axiom,
    ! [VarCurr: state_type] :
      ( v103412(VarCurr,1)
    <=> v103414(VarCurr,1) ) ).

tff(addAssignment_63299,axiom,
    ! [VarNext: state_type] :
      ( v103414(VarNext,1)
    <=> v103493(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103494(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103493(VarNext,B)
            <=> v103414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1246,axiom,
    ! [VarNext: state_type] :
      ( v103494(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103493(VarNext,B)
          <=> v103464(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103494(VarNext)
      <=> v103495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103495(VarNext)
      <=> ( v103497(VarNext)
          & v103449(VarNext) ) ) ) ).

tff(writeUnaryOperator_5119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103497(VarNext)
      <=> v103458(VarNext) ) ) ).

tff(addAssignment_63298,axiom,
    ! [VarCurr: state_type] :
      ( v103424(VarCurr,1)
    <=> v103426(VarCurr,1) ) ).

tff(addAssignment_63297,axiom,
    ! [VarCurr: state_type] :
      ( v103426(VarCurr,1)
    <=> v103440(VarCurr,1) ) ).

tff(addAssignment_63296,axiom,
    ! [VarCurr: state_type] :
      ( v103428(VarCurr,1)
    <=> v103431(VarCurr,1) ) ).

tff(writeUnaryOperator_5118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103432(VarCurr,1)
    <=> v103430(VarCurr,3) ) ).

tff(addAssignment_63295,axiom,
    ! [VarCurr: state_type] :
      ( v103430(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_63294,axiom,
    ! [VarCurr: state_type] :
      ( v103408(VarCurr,2)
    <=> v103410(VarCurr,2) ) ).

tff(addAssignment_63293,axiom,
    ! [VarCurr: state_type] :
      ( v103410(VarCurr,2)
    <=> v103412(VarCurr,3) ) ).

tff(addAssignment_63292,axiom,
    ! [VarCurr: state_type] :
      ( v103412(VarCurr,3)
    <=> v103414(VarCurr,3) ) ).

tff(addAssignment_63291,axiom,
    ! [VarNext: state_type] :
      ( v103414(VarNext,3)
    <=> v103484(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103485(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103484(VarNext,B)
            <=> v103414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1245,axiom,
    ! [VarNext: state_type] :
      ( v103485(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103484(VarNext,B)
          <=> v103464(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103485(VarNext)
      <=> v103486(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103486(VarNext)
      <=> ( v103488(VarNext)
          & v103449(VarNext) ) ) ) ).

tff(writeUnaryOperator_5117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103488(VarNext)
      <=> v103458(VarNext) ) ) ).

tff(addAssignment_63290,axiom,
    ! [VarCurr: state_type] :
      ( v103424(VarCurr,3)
    <=> v103426(VarCurr,3) ) ).

tff(addAssignment_63289,axiom,
    ! [VarCurr: state_type] :
      ( v103426(VarCurr,3)
    <=> v103440(VarCurr,3) ) ).

tff(addAssignment_63288,axiom,
    ! [VarCurr: state_type] :
      ( v103428(VarCurr,3)
    <=> v103431(VarCurr,3) ) ).

tff(addAssignment_63287,axiom,
    ! [VarCurr: state_type] :
      ( v103430(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_63286,axiom,
    ! [VarCurr: state_type] :
      ( v103408(VarCurr,1)
    <=> v103410(VarCurr,1) ) ).

tff(writeUnaryOperator_5116,axiom,
    ! [VarCurr: state_type] :
      ( v103410(VarCurr,1)
    <=> ~ v103471(VarCurr,0) ) ).

tff(addAssignment_63285,axiom,
    ! [VarCurr: state_type] :
      ( v103471(VarCurr,0)
    <=> v103412(VarCurr,0) ) ).

tff(addAssignment_63284,axiom,
    ! [VarCurr: state_type] :
      ( v103412(VarCurr,0)
    <=> v103414(VarCurr,0) ) ).

tff(addAssignment_63283,axiom,
    ! [VarNext: state_type] :
      ( v103414(VarNext,0)
    <=> v103475(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103476(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103475(VarNext,B)
            <=> v103414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1244,axiom,
    ! [VarNext: state_type] :
      ( v103476(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103475(VarNext,B)
          <=> v103464(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103476(VarNext)
      <=> v103477(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103477(VarNext)
      <=> ( v103479(VarNext)
          & v103449(VarNext) ) ) ) ).

tff(writeUnaryOperator_5115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103479(VarNext)
      <=> v103458(VarNext) ) ) ).

tff(addAssignment_63282,axiom,
    ! [VarCurr: state_type] :
      ( v103424(VarCurr,0)
    <=> v103426(VarCurr,0) ) ).

tff(addAssignment_63281,axiom,
    ! [VarCurr: state_type] :
      ( v103426(VarCurr,0)
    <=> v103440(VarCurr,0) ) ).

tff(addAssignment_63280,axiom,
    ! [VarCurr: state_type] :
      ( v103428(VarCurr,0)
    <=> v103431(VarCurr,0) ) ).

tff(writeUnaryOperator_5114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103432(VarCurr,0)
    <=> v103430(VarCurr,1) ) ).

tff(addAssignment_63279,axiom,
    ! [VarCurr: state_type] :
      ( v103430(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_63278,axiom,
    ! [VarCurr: state_type] :
      ( v103408(VarCurr,0)
    <=> v103410(VarCurr,0) ) ).

tff(addAssignment_63277,axiom,
    ! [VarCurr: state_type] :
      ( v103410(VarCurr,0)
    <=> v103412(VarCurr,2) ) ).

tff(addAssignment_63276,axiom,
    ! [VarCurr: state_type] :
      ( v103412(VarCurr,2)
    <=> v103414(VarCurr,2) ) ).

tff(addAssignment_63275,axiom,
    ! [VarNext: state_type] :
      ( v103414(VarNext,2)
    <=> v103453(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103454(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v103453(VarNext,B)
            <=> v103414(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1243,axiom,
    ! [VarNext: state_type] :
      ( v103454(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103453(VarNext,B)
          <=> v103464(VarNext,B) ) ) ) ).

tff(addAssignment_63274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103464(VarNext,B)
          <=> v103462(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103465(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103462(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_728,axiom,
    ! [VarCurr: state_type] :
      ( v103465(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v103462(VarCurr,B)
          <=> v103424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9941,axiom,
    ! [VarCurr: state_type] :
      ( v103465(VarCurr)
    <=> ( v103466(VarCurr)
        & v103467(VarCurr) ) ) ).

tff(writeUnaryOperator_5113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103467(VarCurr)
    <=> v103420(VarCurr) ) ).

tff(writeUnaryOperator_5112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103466(VarCurr)
    <=> v103416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103454(VarNext)
      <=> v103455(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103455(VarNext)
      <=> ( v103456(VarNext)
          & v103449(VarNext) ) ) ) ).

tff(writeUnaryOperator_5111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103456(VarNext)
      <=> v103458(VarNext) ) ) ).

tff(addAssignment_63273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103458(VarNext)
      <=> v103449(VarCurr) ) ) ).

tff(addAssignment_63272,axiom,
    ! [VarCurr: state_type] :
      ( v103449(VarCurr)
    <=> v103451(VarCurr) ) ).

tff(addAssignment_63271,axiom,
    ! [VarCurr: state_type] :
      ( v103451(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63270,axiom,
    ! [VarCurr: state_type] :
      ( v103424(VarCurr,2)
    <=> v103426(VarCurr,2) ) ).

tff(addAssignment_63269,axiom,
    ! [VarCurr: state_type] :
      ( v103426(VarCurr,2)
    <=> v103440(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103440(VarCurr,B)
      <=> ( v103441(VarCurr,B)
          | v103444(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103444(VarCurr,B)
      <=> ( v103412(VarCurr,B)
          & v103445(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103445(VarCurr,B)
      <=> ~ v103446(VarCurr,B) ) ) ).

tff(addAssignment_63268,axiom,
    ! [VarCurr: state_type] :
      ( v103446(VarCurr,0)
    <=> v103447(VarCurr) ) ).

tff(addAssignment_63267,axiom,
    ! [VarCurr: state_type] :
      ( v103446(VarCurr,1)
    <=> v103447(VarCurr) ) ).

tff(addAssignment_63266,axiom,
    ! [VarCurr: state_type] :
      ( v103446(VarCurr,2)
    <=> v103447(VarCurr) ) ).

tff(addAssignment_63265,axiom,
    ! [VarCurr: state_type] :
      ( v103446(VarCurr,3)
    <=> v103447(VarCurr) ) ).

tff(addAssignment_63264,axiom,
    ! [VarCurr: state_type] :
      ( v103446(VarCurr,4)
    <=> v103447(VarCurr) ) ).

tff(addAssignment_63263,axiom,
    ! [VarCurr: state_type] :
      ( v103447(VarCurr)
    <=> v103434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v103441(VarCurr,B)
      <=> ( v103428(VarCurr,B)
          & v103442(VarCurr,B) ) ) ) ).

tff(addAssignment_63262,axiom,
    ! [VarCurr: state_type] :
      ( v103442(VarCurr,0)
    <=> v103443(VarCurr) ) ).

tff(addAssignment_63261,axiom,
    ! [VarCurr: state_type] :
      ( v103442(VarCurr,1)
    <=> v103443(VarCurr) ) ).

tff(addAssignment_63260,axiom,
    ! [VarCurr: state_type] :
      ( v103442(VarCurr,2)
    <=> v103443(VarCurr) ) ).

tff(addAssignment_63259,axiom,
    ! [VarCurr: state_type] :
      ( v103442(VarCurr,3)
    <=> v103443(VarCurr) ) ).

tff(addAssignment_63258,axiom,
    ! [VarCurr: state_type] :
      ( v103442(VarCurr,4)
    <=> v103443(VarCurr) ) ).

tff(addAssignment_63257,axiom,
    ! [VarCurr: state_type] :
      ( v103443(VarCurr)
    <=> v103434(VarCurr) ) ).

tff(addAssignment_63256,axiom,
    ! [VarCurr: state_type] :
      ( v103434(VarCurr)
    <=> v103436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9938,axiom,
    ! [VarCurr: state_type] :
      ( v103436(VarCurr)
    <=> ( v1729(VarCurr)
        & v103439(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_693,axiom,
    ! [VarCurr: state_type] :
      ( v103439(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1548,axiom,
    ~ b0000011011000(12) ).

tff(bitBlastConstant_1547,axiom,
    ~ b0000011011000(11) ).

tff(bitBlastConstant_1546,axiom,
    ~ b0000011011000(10) ).

tff(bitBlastConstant_1545,axiom,
    ~ b0000011011000(9) ).

tff(bitBlastConstant_1544,axiom,
    ~ b0000011011000(8) ).

tff(bitBlastConstant_1543,axiom,
    b0000011011000(7) ).

tff(bitBlastConstant_1542,axiom,
    b0000011011000(6) ).

tff(bitBlastConstant_1541,axiom,
    ~ b0000011011000(5) ).

tff(bitBlastConstant_1540,axiom,
    b0000011011000(4) ).

tff(bitBlastConstant_1539,axiom,
    b0000011011000(3) ).

tff(bitBlastConstant_1538,axiom,
    ~ b0000011011000(2) ).

tff(bitBlastConstant_1537,axiom,
    ~ b0000011011000(1) ).

tff(bitBlastConstant_1536,axiom,
    ~ b0000011011000(0) ).

tff(addAssignment_63255,axiom,
    ! [VarCurr: state_type] :
      ( v103428(VarCurr,2)
    <=> v103431(VarCurr,2) ) ).

tff(addAssignment_63254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v103431(VarCurr,B)
      <=> v103432(VarCurr,B) ) ) ).

tff(addAssignment_63253,axiom,
    ! [VarCurr: state_type] :
      ( v103431(VarCurr,2)
    <=> v103430(VarCurr,0) ) ).

tff(addAssignment_63252,axiom,
    ! [VarCurr: state_type] :
      ( v103431(VarCurr,3)
    <=> v103430(VarCurr,2) ) ).

tff(addAssignment_63251,axiom,
    ! [VarCurr: state_type] :
      ( v103431(VarCurr,4)
    <=> v103430(VarCurr,4) ) ).

tff(addAssignment_63250,axiom,
    ! [VarCurr: state_type] :
      ( v103430(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_63249,axiom,
    ! [VarCurr: state_type] :
      ( v103420(VarCurr)
    <=> v103422(VarCurr) ) ).

tff(addAssignment_63248,axiom,
    ! [VarCurr: state_type] :
      ( v103422(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_63247,axiom,
    ! [VarCurr: state_type] :
      ( v103416(VarCurr)
    <=> v103418(VarCurr) ) ).

tff(addAssignment_63246,axiom,
    ! [VarCurr: state_type] :
      ( v103418(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9937,axiom,
    ! [VarCurr: state_type] :
      ( v103404(VarCurr)
    <=> ( v103406(VarCurr)
        | v103067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9936,axiom,
    ! [VarCurr: state_type] :
      ( v103406(VarCurr)
    <=> ( v89210(VarCurr)
        | v101497(VarCurr) ) ) ).

tff(addAssignment_63245,axiom,
    ! [VarCurr: state_type] :
      ( v103392(VarCurr)
    <=> v103394(VarCurr) ) ).

tff(addAssignment_63244,axiom,
    ! [VarCurr: state_type] :
      ( v103394(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_63243,axiom,
    ! [VarCurr: state_type] :
      ( v103388(VarCurr)
    <=> v103390(VarCurr) ) ).

tff(addAssignment_63242,axiom,
    ! [VarCurr: state_type] :
      ( v103390(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_63241,axiom,
    ! [VarCurr: state_type] :
      ( v103183(VarCurr,0)
    <=> v103185(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_692,axiom,
    ! [VarCurr: state_type] :
      ( v103185(VarCurr)
    <=> ( ( v103187(VarCurr,3)
        <=> $false )
        & ( v103187(VarCurr,2)
        <=> $false )
        & ( v103187(VarCurr,1)
        <=> $false )
        & ( v103187(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103187(VarCurr,B)
      <=> v103189(VarCurr,B) ) ) ).

tff(addAssignment_63239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103189(VarCurr,B)
      <=> v103191(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103358(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103191(VarNext,B)
            <=> v103191(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1242,axiom,
    ! [VarNext: state_type] :
      ( v103358(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103191(VarNext,B)
          <=> v103368(VarNext,B) ) ) ) ).

tff(addAssignment_63238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103368(VarNext,B)
          <=> v103366(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103369(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103366(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_727,axiom,
    ! [VarCurr: state_type] :
      ( v103369(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103366(VarCurr,B)
          <=> v103201(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9935,axiom,
    ! [VarCurr: state_type] :
      ( v103369(VarCurr)
    <=> ( v103370(VarCurr)
        & v103371(VarCurr) ) ) ).

tff(writeUnaryOperator_5109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103371(VarCurr)
    <=> v103197(VarCurr) ) ).

tff(writeUnaryOperator_5108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103370(VarCurr)
    <=> v103193(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103358(VarNext)
      <=> v103359(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103359(VarNext)
      <=> ( v103360(VarNext)
          & v103353(VarNext) ) ) ) ).

tff(writeUnaryOperator_5107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103360(VarNext)
      <=> v103362(VarNext) ) ) ).

tff(addAssignment_63237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103362(VarNext)
      <=> v103353(VarCurr) ) ) ).

tff(addAssignment_63236,axiom,
    ! [VarCurr: state_type] :
      ( v103353(VarCurr)
    <=> v103355(VarCurr) ) ).

tff(addAssignment_63235,axiom,
    ! [VarCurr: state_type] :
      ( v103355(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103201(VarCurr,B)
      <=> v103203(VarCurr,B) ) ) ).

tff(addAssignment_63233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103203(VarCurr,B)
      <=> v103205(VarCurr,B) ) ) ).

tff(addAssignment_63232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103205(VarCurr,B)
      <=> v103207(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103304(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103207(VarCurr,B)
          <=> v103326(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_726,axiom,
    ! [VarCurr: state_type] :
      ( v103304(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103207(VarCurr,B)
          <=> v103305(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103326(VarCurr,B)
          <=> v103328(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_725,axiom,
    ! [VarCurr: state_type] :
      ( v103327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103326(VarCurr,B)
          <=> v103212(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103328(VarCurr,B)
          <=> v103330(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_724,axiom,
    ! [VarCurr: state_type] :
      ( v103329(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103328(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103330(VarCurr,B)
          <=> v103187(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_723,axiom,
    ! [VarCurr: state_type] :
      ( v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103330(VarCurr,B)
          <=> v103331(VarCurr,B) ) ) ) ).

tff(addAssignment_63231,axiom,
    ! [VarCurr: state_type] :
      ( v103331(VarCurr,0)
    <=> v103350(VarCurr) ) ).

tff(addAssignment_63230,axiom,
    ! [VarCurr: state_type] :
      ( v103331(VarCurr,1)
    <=> v103348(VarCurr) ) ).

tff(addAssignment_63229,axiom,
    ! [VarCurr: state_type] :
      ( v103331(VarCurr,2)
    <=> v103344(VarCurr) ) ).

tff(addAssignment_63228,axiom,
    ! [VarCurr: state_type] :
      ( v103331(VarCurr,3)
    <=> v103333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9932,axiom,
    ! [VarCurr: state_type] :
      ( v103348(VarCurr)
    <=> ( v103349(VarCurr)
        & v103351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9931,axiom,
    ! [VarCurr: state_type] :
      ( v103351(VarCurr)
    <=> ( v103187(VarCurr,0)
        | v103340(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4022,axiom,
    ! [VarCurr: state_type] :
      ( v103349(VarCurr)
    <=> ( v103350(VarCurr)
        | v103187(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103350(VarCurr)
    <=> v103187(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9930,axiom,
    ! [VarCurr: state_type] :
      ( v103344(VarCurr)
    <=> ( v103345(VarCurr)
        & v103347(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9929,axiom,
    ! [VarCurr: state_type] :
      ( v103347(VarCurr)
    <=> ( v103338(VarCurr)
        | v103341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4021,axiom,
    ! [VarCurr: state_type] :
      ( v103345(VarCurr)
    <=> ( v103346(VarCurr)
        | v103187(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103346(VarCurr)
    <=> v103338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9928,axiom,
    ! [VarCurr: state_type] :
      ( v103333(VarCurr)
    <=> ( v103334(VarCurr)
        & v103342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9927,axiom,
    ! [VarCurr: state_type] :
      ( v103342(VarCurr)
    <=> ( v103336(VarCurr)
        | v103343(VarCurr) ) ) ).

tff(writeUnaryOperator_5104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103343(VarCurr)
    <=> v103187(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4020,axiom,
    ! [VarCurr: state_type] :
      ( v103334(VarCurr)
    <=> ( v103335(VarCurr)
        | v103187(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103335(VarCurr)
    <=> v103336(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4019,axiom,
    ! [VarCurr: state_type] :
      ( v103336(VarCurr)
    <=> ( v103187(VarCurr,2)
        | v103337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9926,axiom,
    ! [VarCurr: state_type] :
      ( v103337(VarCurr)
    <=> ( v103338(VarCurr)
        & v103341(VarCurr) ) ) ).

tff(writeUnaryOperator_5102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103341(VarCurr)
    <=> v103187(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4018,axiom,
    ! [VarCurr: state_type] :
      ( v103338(VarCurr)
    <=> ( v103187(VarCurr,1)
        | v103339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9925,axiom,
    ! [VarCurr: state_type] :
      ( v103339(VarCurr)
    <=> ( v103187(VarCurr,0)
        & v103340(VarCurr) ) ) ).

tff(writeUnaryOperator_5101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103340(VarCurr)
    <=> v103187(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_691,axiom,
    ! [VarCurr: state_type] :
      ( v103329(VarCurr)
    <=> ( ( v103187(VarCurr,3)
        <=> $false )
        & ( v103187(VarCurr,2)
        <=> $false )
        & ( v103187(VarCurr,1)
        <=> $false )
        & ( v103187(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9924,axiom,
    ! [VarCurr: state_type] :
      ( v103327(VarCurr)
    <=> ( v103067(VarCurr)
        & v103185(VarCurr) ) ) ).

tff(addAssignment_63227,axiom,
    ! [VarCurr: state_type] :
      ( v103305(VarCurr,0)
    <=> v103324(VarCurr) ) ).

tff(addAssignment_63226,axiom,
    ! [VarCurr: state_type] :
      ( v103305(VarCurr,1)
    <=> v103322(VarCurr) ) ).

tff(addAssignment_63225,axiom,
    ! [VarCurr: state_type] :
      ( v103305(VarCurr,2)
    <=> v103318(VarCurr) ) ).

tff(addAssignment_63224,axiom,
    ! [VarCurr: state_type] :
      ( v103305(VarCurr,3)
    <=> v103307(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9923,axiom,
    ! [VarCurr: state_type] :
      ( v103322(VarCurr)
    <=> ( v103323(VarCurr)
        & v103325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9922,axiom,
    ! [VarCurr: state_type] :
      ( v103325(VarCurr)
    <=> ( v103212(VarCurr,0)
        | v103314(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4017,axiom,
    ! [VarCurr: state_type] :
      ( v103323(VarCurr)
    <=> ( v103324(VarCurr)
        | v103212(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103324(VarCurr)
    <=> v103212(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9921,axiom,
    ! [VarCurr: state_type] :
      ( v103318(VarCurr)
    <=> ( v103319(VarCurr)
        & v103321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9920,axiom,
    ! [VarCurr: state_type] :
      ( v103321(VarCurr)
    <=> ( v103312(VarCurr)
        | v103315(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4016,axiom,
    ! [VarCurr: state_type] :
      ( v103319(VarCurr)
    <=> ( v103320(VarCurr)
        | v103212(VarCurr,2) ) ) ).

tff(writeUnaryOperator_5099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103320(VarCurr)
    <=> v103312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9919,axiom,
    ! [VarCurr: state_type] :
      ( v103307(VarCurr)
    <=> ( v103308(VarCurr)
        & v103316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9918,axiom,
    ! [VarCurr: state_type] :
      ( v103316(VarCurr)
    <=> ( v103310(VarCurr)
        | v103317(VarCurr) ) ) ).

tff(writeUnaryOperator_5098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103317(VarCurr)
    <=> v103212(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_4015,axiom,
    ! [VarCurr: state_type] :
      ( v103308(VarCurr)
    <=> ( v103309(VarCurr)
        | v103212(VarCurr,3) ) ) ).

tff(writeUnaryOperator_5097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103309(VarCurr)
    <=> v103310(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_4014,axiom,
    ! [VarCurr: state_type] :
      ( v103310(VarCurr)
    <=> ( v103212(VarCurr,2)
        | v103311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9917,axiom,
    ! [VarCurr: state_type] :
      ( v103311(VarCurr)
    <=> ( v103312(VarCurr)
        & v103315(VarCurr) ) ) ).

tff(writeUnaryOperator_5096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103315(VarCurr)
    <=> v103212(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_4013,axiom,
    ! [VarCurr: state_type] :
      ( v103312(VarCurr)
    <=> ( v103212(VarCurr,1)
        | v103313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9916,axiom,
    ! [VarCurr: state_type] :
      ( v103313(VarCurr)
    <=> ( v103212(VarCurr,0)
        & v103314(VarCurr) ) ) ).

tff(writeUnaryOperator_5095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103314(VarCurr)
    <=> v103212(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9915,axiom,
    ! [VarCurr: state_type] :
      ( v103304(VarCurr)
    <=> ( v103209(VarCurr)
        & v103185(VarCurr) ) ) ).

tff(addAssignment_63223,axiom,
    ! [VarCurr: state_type] :
      ( v103212(VarCurr,3)
    <=> v103214(VarCurr,3) ) ).

tff(addAssignment_63222,axiom,
    ! [VarCurr: state_type] :
      ( v103214(VarCurr,3)
    <=> v103216(VarCurr,3) ) ).

tff(addAssignment_63221,axiom,
    ! [VarCurr: state_type] :
      ( v103216(VarCurr,3)
    <=> v103218(VarCurr,3) ) ).

tff(addAssignment_63220,axiom,
    ! [VarNext: state_type] :
      ( v103218(VarNext,3)
    <=> v103296(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103297(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103296(VarNext,B)
            <=> v103218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1241,axiom,
    ! [VarNext: state_type] :
      ( v103297(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103296(VarNext,B)
          <=> v103268(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103297(VarNext)
      <=> v103298(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103298(VarNext)
      <=> ( v103300(VarNext)
          & v103253(VarNext) ) ) ) ).

tff(writeUnaryOperator_5094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103300(VarNext)
      <=> v103262(VarNext) ) ) ).

tff(addAssignment_63219,axiom,
    ! [VarCurr: state_type] :
      ( v103228(VarCurr,3)
    <=> v103230(VarCurr,3) ) ).

tff(addAssignment_63218,axiom,
    ! [VarCurr: state_type] :
      ( v103230(VarCurr,3)
    <=> v103244(VarCurr,3) ) ).

tff(addAssignment_63217,axiom,
    ! [VarCurr: state_type] :
      ( v103232(VarCurr,3)
    <=> v103235(VarCurr,3) ) ).

tff(addAssignment_63216,axiom,
    ! [VarCurr: state_type] :
      ( v103234(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_63215,axiom,
    ! [VarCurr: state_type] :
      ( v103212(VarCurr,2)
    <=> v103214(VarCurr,2) ) ).

tff(addAssignment_63214,axiom,
    ! [VarCurr: state_type] :
      ( v103214(VarCurr,2)
    <=> v103216(VarCurr,2) ) ).

tff(addAssignment_63213,axiom,
    ! [VarCurr: state_type] :
      ( v103216(VarCurr,2)
    <=> v103218(VarCurr,2) ) ).

tff(addAssignment_63212,axiom,
    ! [VarNext: state_type] :
      ( v103218(VarNext,2)
    <=> v103288(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103289(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103288(VarNext,B)
            <=> v103218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1240,axiom,
    ! [VarNext: state_type] :
      ( v103289(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103288(VarNext,B)
          <=> v103268(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103289(VarNext)
      <=> v103290(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103290(VarNext)
      <=> ( v103292(VarNext)
          & v103253(VarNext) ) ) ) ).

tff(writeUnaryOperator_5093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103292(VarNext)
      <=> v103262(VarNext) ) ) ).

tff(addAssignment_63211,axiom,
    ! [VarCurr: state_type] :
      ( v103228(VarCurr,2)
    <=> v103230(VarCurr,2) ) ).

tff(addAssignment_63210,axiom,
    ! [VarCurr: state_type] :
      ( v103230(VarCurr,2)
    <=> v103244(VarCurr,2) ) ).

tff(addAssignment_63209,axiom,
    ! [VarCurr: state_type] :
      ( v103232(VarCurr,2)
    <=> v103235(VarCurr,2) ) ).

tff(addAssignment_63208,axiom,
    ! [VarCurr: state_type] :
      ( v103234(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_63207,axiom,
    ! [VarCurr: state_type] :
      ( v103212(VarCurr,1)
    <=> v103214(VarCurr,1) ) ).

tff(writeUnaryOperator_5092,axiom,
    ! [VarCurr: state_type] :
      ( v103214(VarCurr,1)
    <=> ~ v103275(VarCurr) ) ).

tff(addAssignment_63206,axiom,
    ! [VarCurr: state_type] :
      ( v103275(VarCurr)
    <=> v103216(VarCurr,1) ) ).

tff(addAssignment_63205,axiom,
    ! [VarCurr: state_type] :
      ( v103216(VarCurr,1)
    <=> v103218(VarCurr,1) ) ).

tff(addAssignment_63204,axiom,
    ! [VarNext: state_type] :
      ( v103218(VarNext,1)
    <=> v103279(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103280(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103279(VarNext,B)
            <=> v103218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1239,axiom,
    ! [VarNext: state_type] :
      ( v103280(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103279(VarNext,B)
          <=> v103268(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103280(VarNext)
      <=> v103281(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103281(VarNext)
      <=> ( v103283(VarNext)
          & v103253(VarNext) ) ) ) ).

tff(writeUnaryOperator_5091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103283(VarNext)
      <=> v103262(VarNext) ) ) ).

tff(addAssignment_63203,axiom,
    ! [VarCurr: state_type] :
      ( v103228(VarCurr,1)
    <=> v103230(VarCurr,1) ) ).

tff(addAssignment_63202,axiom,
    ! [VarCurr: state_type] :
      ( v103230(VarCurr,1)
    <=> v103244(VarCurr,1) ) ).

tff(addAssignment_63201,axiom,
    ! [VarCurr: state_type] :
      ( v103232(VarCurr,1)
    <=> v103235(VarCurr,1) ) ).

tff(writeUnaryOperator_5090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103236(VarCurr)
    <=> v103234(VarCurr,1) ) ).

tff(addAssignment_63200,axiom,
    ! [VarCurr: state_type] :
      ( v103234(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_63199,axiom,
    ! [VarCurr: state_type] :
      ( v103212(VarCurr,0)
    <=> v103214(VarCurr,0) ) ).

tff(addAssignment_63198,axiom,
    ! [VarCurr: state_type] :
      ( v103214(VarCurr,0)
    <=> v103216(VarCurr,0) ) ).

tff(addAssignment_63197,axiom,
    ! [VarCurr: state_type] :
      ( v103216(VarCurr,0)
    <=> v103218(VarCurr,0) ) ).

tff(addAssignment_63196,axiom,
    ! [VarNext: state_type] :
      ( v103218(VarNext,0)
    <=> v103257(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103258(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v103257(VarNext,B)
            <=> v103218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1238,axiom,
    ! [VarNext: state_type] :
      ( v103258(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103257(VarNext,B)
          <=> v103268(VarNext,B) ) ) ) ).

tff(addAssignment_63195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103268(VarNext,B)
          <=> v103266(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103269(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103266(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_722,axiom,
    ! [VarCurr: state_type] :
      ( v103269(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v103266(VarCurr,B)
          <=> v103228(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9908,axiom,
    ! [VarCurr: state_type] :
      ( v103269(VarCurr)
    <=> ( v103270(VarCurr)
        & v103271(VarCurr) ) ) ).

tff(writeUnaryOperator_5089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103271(VarCurr)
    <=> v103224(VarCurr) ) ).

tff(writeUnaryOperator_5088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103270(VarCurr)
    <=> v103220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103258(VarNext)
      <=> v103259(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103259(VarNext)
      <=> ( v103260(VarNext)
          & v103253(VarNext) ) ) ) ).

tff(writeUnaryOperator_5087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103260(VarNext)
      <=> v103262(VarNext) ) ) ).

tff(addAssignment_63194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103262(VarNext)
      <=> v103253(VarCurr) ) ) ).

tff(addAssignment_63193,axiom,
    ! [VarCurr: state_type] :
      ( v103253(VarCurr)
    <=> v103255(VarCurr) ) ).

tff(addAssignment_63192,axiom,
    ! [VarCurr: state_type] :
      ( v103255(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_63191,axiom,
    ! [VarCurr: state_type] :
      ( v103228(VarCurr,0)
    <=> v103230(VarCurr,0) ) ).

tff(addAssignment_63190,axiom,
    ! [VarCurr: state_type] :
      ( v103230(VarCurr,0)
    <=> v103244(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103244(VarCurr,B)
      <=> ( v103245(VarCurr,B)
          | v103248(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103248(VarCurr,B)
      <=> ( v103216(VarCurr,B)
          & v103249(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103249(VarCurr,B)
      <=> ~ v103250(VarCurr,B) ) ) ).

tff(addAssignment_63189,axiom,
    ! [VarCurr: state_type] :
      ( v103250(VarCurr,0)
    <=> v103251(VarCurr) ) ).

tff(addAssignment_63188,axiom,
    ! [VarCurr: state_type] :
      ( v103250(VarCurr,1)
    <=> v103251(VarCurr) ) ).

tff(addAssignment_63187,axiom,
    ! [VarCurr: state_type] :
      ( v103250(VarCurr,2)
    <=> v103251(VarCurr) ) ).

tff(addAssignment_63186,axiom,
    ! [VarCurr: state_type] :
      ( v103250(VarCurr,3)
    <=> v103251(VarCurr) ) ).

tff(addAssignment_63185,axiom,
    ! [VarCurr: state_type] :
      ( v103251(VarCurr)
    <=> v103238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v103245(VarCurr,B)
      <=> ( v103232(VarCurr,B)
          & v103246(VarCurr,B) ) ) ) ).

tff(addAssignment_63184,axiom,
    ! [VarCurr: state_type] :
      ( v103246(VarCurr,0)
    <=> v103247(VarCurr) ) ).

tff(addAssignment_63183,axiom,
    ! [VarCurr: state_type] :
      ( v103246(VarCurr,1)
    <=> v103247(VarCurr) ) ).

tff(addAssignment_63182,axiom,
    ! [VarCurr: state_type] :
      ( v103246(VarCurr,2)
    <=> v103247(VarCurr) ) ).

tff(addAssignment_63181,axiom,
    ! [VarCurr: state_type] :
      ( v103246(VarCurr,3)
    <=> v103247(VarCurr) ) ).

tff(addAssignment_63180,axiom,
    ! [VarCurr: state_type] :
      ( v103247(VarCurr)
    <=> v103238(VarCurr) ) ).

tff(addAssignment_63179,axiom,
    ! [VarCurr: state_type] :
      ( v103238(VarCurr)
    <=> v103240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9905,axiom,
    ! [VarCurr: state_type] :
      ( v103240(VarCurr)
    <=> ( v1729(VarCurr)
        & v103243(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_690,axiom,
    ! [VarCurr: state_type] :
      ( v103243(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1535,axiom,
    ~ b0000010000000(12) ).

tff(bitBlastConstant_1534,axiom,
    ~ b0000010000000(11) ).

tff(bitBlastConstant_1533,axiom,
    ~ b0000010000000(10) ).

tff(bitBlastConstant_1532,axiom,
    ~ b0000010000000(9) ).

tff(bitBlastConstant_1531,axiom,
    ~ b0000010000000(8) ).

tff(bitBlastConstant_1530,axiom,
    b0000010000000(7) ).

tff(bitBlastConstant_1529,axiom,
    ~ b0000010000000(6) ).

tff(bitBlastConstant_1528,axiom,
    ~ b0000010000000(5) ).

tff(bitBlastConstant_1527,axiom,
    ~ b0000010000000(4) ).

tff(bitBlastConstant_1526,axiom,
    ~ b0000010000000(3) ).

tff(bitBlastConstant_1525,axiom,
    ~ b0000010000000(2) ).

tff(bitBlastConstant_1524,axiom,
    ~ b0000010000000(1) ).

tff(bitBlastConstant_1523,axiom,
    ~ b0000010000000(0) ).

tff(addAssignment_63178,axiom,
    ! [VarCurr: state_type] :
      ( v103232(VarCurr,0)
    <=> v103235(VarCurr,0) ) ).

tff(addAssignment_63177,axiom,
    ! [VarCurr: state_type] :
      ( v103235(VarCurr,0)
    <=> v103234(VarCurr,0) ) ).

tff(addAssignment_63176,axiom,
    ! [VarCurr: state_type] :
      ( v103235(VarCurr,1)
    <=> v103236(VarCurr) ) ).

tff(addAssignment_63175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v103235(VarCurr,B)
      <=> v103234(VarCurr,B) ) ) ).

tff(addAssignment_63174,axiom,
    ! [VarCurr: state_type] :
      ( v103234(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_63173,axiom,
    ! [VarCurr: state_type] :
      ( v103224(VarCurr)
    <=> v103226(VarCurr) ) ).

tff(addAssignment_63172,axiom,
    ! [VarCurr: state_type] :
      ( v103226(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_63171,axiom,
    ! [VarCurr: state_type] :
      ( v103220(VarCurr)
    <=> v103222(VarCurr) ) ).

tff(addAssignment_63170,axiom,
    ! [VarCurr: state_type] :
      ( v103222(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9904,axiom,
    ! [VarCurr: state_type] :
      ( v103209(VarCurr)
    <=> ( v89210(VarCurr)
        | v101497(VarCurr) ) ) ).

tff(addAssignment_63169,axiom,
    ! [VarCurr: state_type] :
      ( v103197(VarCurr)
    <=> v103199(VarCurr) ) ).

tff(addAssignment_63168,axiom,
    ! [VarCurr: state_type] :
      ( v103199(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_63167,axiom,
    ! [VarCurr: state_type] :
      ( v103193(VarCurr)
    <=> v103195(VarCurr) ) ).

tff(addAssignment_63166,axiom,
    ! [VarCurr: state_type] :
      ( v103195(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_63165,axiom,
    ! [VarCurr: state_type] :
      ( v101469(VarCurr,0)
    <=> v101471(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_689,axiom,
    ! [VarCurr: state_type] :
      ( v101471(VarCurr)
    <=> ( ( v101473(VarCurr,1)
        <=> $false )
        & ( v101473(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v101473(VarCurr,B)
      <=> v101475(VarCurr,B) ) ) ).

tff(addAssignment_63163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v101475(VarCurr,B)
      <=> v101477(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103165(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v101477(VarNext,B)
            <=> v101477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1237,axiom,
    ! [VarNext: state_type] :
      ( v103165(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v101477(VarNext,B)
          <=> v103175(VarNext,B) ) ) ) ).

tff(addAssignment_63162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103175(VarNext,B)
          <=> v103173(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103176(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103173(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_721,axiom,
    ! [VarCurr: state_type] :
      ( v103176(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103173(VarCurr,B)
          <=> v101487(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9903,axiom,
    ! [VarCurr: state_type] :
      ( v103176(VarCurr)
    <=> ( v103177(VarCurr)
        & v103178(VarCurr) ) ) ).

tff(writeUnaryOperator_5085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103178(VarCurr)
    <=> v101483(VarCurr) ) ).

tff(writeUnaryOperator_5084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103177(VarCurr)
    <=> v101479(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103165(VarNext)
      <=> v103166(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103166(VarNext)
      <=> ( v103167(VarNext)
          & v103160(VarNext) ) ) ) ).

tff(writeUnaryOperator_5083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103167(VarNext)
      <=> v103169(VarNext) ) ) ).

tff(addAssignment_63161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103169(VarNext)
      <=> v103160(VarCurr) ) ) ).

tff(addAssignment_63160,axiom,
    ! [VarCurr: state_type] :
      ( v103160(VarCurr)
    <=> v103162(VarCurr) ) ).

tff(addAssignment_63159,axiom,
    ! [VarCurr: state_type] :
      ( v103162(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v101487(VarCurr,B)
      <=> v101489(VarCurr,B) ) ) ).

tff(addAssignment_63157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v101489(VarCurr,B)
      <=> v101491(VarCurr,B) ) ) ).

tff(addAssignment_63156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v101491(VarCurr,B)
      <=> v101493(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103147(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v101493(VarCurr,B)
          <=> v103148(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_720,axiom,
    ! [VarCurr: state_type] :
      ( v103147(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v101493(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103148(VarCurr,B)
          <=> v103150(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_719,axiom,
    ! [VarCurr: state_type] :
      ( v103149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103148(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103151(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103150(VarCurr,B)
          <=> v103152(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_718,axiom,
    ! [VarCurr: state_type] :
      ( v103151(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v103150(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_63155,axiom,
    ! [VarCurr: state_type] :
      ( v103152(VarCurr,0)
    <=> v103156(VarCurr) ) ).

tff(addAssignment_63154,axiom,
    ! [VarCurr: state_type] :
      ( v103152(VarCurr,1)
    <=> v103154(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9900,axiom,
    ! [VarCurr: state_type] :
      ( v103154(VarCurr)
    <=> ( v103155(VarCurr)
        & v103157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9899,axiom,
    ! [VarCurr: state_type] :
      ( v103157(VarCurr)
    <=> ( v101473(VarCurr,0)
        | v103158(VarCurr) ) ) ).

tff(writeUnaryOperator_5082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103158(VarCurr)
    <=> v101473(VarCurr,1) ) ).

tff(writeBinaryOperatorShiftedRanges_4012,axiom,
    ! [VarCurr: state_type] :
      ( v103155(VarCurr)
    <=> ( v103156(VarCurr)
        | v101473(VarCurr,1) ) ) ).

tff(writeUnaryOperator_5081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103156(VarCurr)
    <=> v101473(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_688,axiom,
    ! [VarCurr: state_type] :
      ( v103151(VarCurr)
    <=> ( ( v101473(VarCurr,1)
        <=> $false )
        & ( v101473(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9898,axiom,
    ! [VarCurr: state_type] :
      ( v103149(VarCurr)
    <=> ( v103091(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9897,axiom,
    ! [VarCurr: state_type] :
      ( v103147(VarCurr)
    <=> ( v101495(VarCurr)
        & v101417(VarCurr) ) ) ).

tff(addAssignment_63153,axiom,
    ! [VarCurr: state_type] :
      ( v103091(VarCurr)
    <=> v89192(VarCurr,0) ) ).

tff(addAssignment_63152,axiom,
    ! [VarCurr: state_type] :
      ( v89192(VarCurr,0)
    <=> v89194(VarCurr,0) ) ).

tff(addAssignment_63151,axiom,
    ! [VarNext: state_type] :
      ( v89194(VarNext,0)
    <=> v103139(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103140(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v103139(VarNext,B)
            <=> v89194(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1236,axiom,
    ! [VarNext: state_type] :
      ( v103140(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v103139(VarNext,B)
          <=> v103084(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103140(VarNext)
      <=> v103141(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103141(VarNext)
      <=> ( v103143(VarNext)
          & v103069(VarNext) ) ) ) ).

tff(writeUnaryOperator_5080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103143(VarNext)
      <=> v103078(VarNext) ) ) ).

tff(addAssignment_63150,axiom,
    ! [VarCurr: state_type] :
      ( v89204(VarCurr,0)
    <=> v89206(VarCurr,0) ) ).

tff(addAssignment_63149,axiom,
    ! [VarCurr: state_type] :
      ( v89206(VarCurr,0)
    <=> v89208(VarCurr,0) ) ).

tff(addAssignment_63148,axiom,
    ! [VarCurr: state_type] :
      ( v89208(VarCurr,0)
    <=> v103066(VarCurr,0) ) ).

tff(addAssignment_63147,axiom,
    ! [VarCurr: state_type] :
      ( v103067(VarCurr)
    <=> v103094(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9894,axiom,
    ! [VarCurr: state_type] :
      ( v103094(VarCurr,0)
    <=> ( v103134(VarCurr)
        | v103136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9893,axiom,
    ! [VarCurr: state_type] :
      ( v103136(VarCurr)
    <=> ( v103113(VarCurr)
        & v103137(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_687,axiom,
    ! [VarCurr: state_type] :
      ( v103137(VarCurr)
    <=> ( ( v103127(VarCurr,6)
        <=> $false )
        & ( v103127(VarCurr,5)
        <=> $false )
        & ( v103127(VarCurr,4)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9892,axiom,
    ! [VarCurr: state_type] :
      ( v103134(VarCurr)
    <=> ( v103096(VarCurr)
        & v103135(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_686,axiom,
    ! [VarCurr: state_type] :
      ( v103135(VarCurr)
    <=> ( ( v103106(VarCurr,6)
        <=> $false )
        & ( v103106(VarCurr,5)
        <=> $false )
        & ( v103106(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103127(VarCurr,B)
      <=> v103129(VarCurr,B) ) ) ).

tff(addAssignment_63145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103129(VarCurr,B)
      <=> v103131(VarCurr,B) ) ) ).

tff(addAssignment_63144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103131(VarCurr,B)
      <=> v103132(VarCurr,B) ) ) ).

tff(addAssignment_63143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v103132(VarCurr,B)
      <=> v100445(VarCurr,B) ) ) ).

tff(addAssignment_63142,axiom,
    ! [VarCurr: state_type] :
      ( v103132(VarCurr,3)
    <=> v100443(VarCurr,3) ) ).

tff(addAssignment_63141,axiom,
    ! [VarCurr: state_type] :
      ( ( v103132(VarCurr,9)
      <=> v100445(VarCurr,8) )
      & ( v103132(VarCurr,8)
      <=> v100445(VarCurr,7) )
      & ( v103132(VarCurr,7)
      <=> v100445(VarCurr,6) )
      & ( v103132(VarCurr,6)
      <=> v100445(VarCurr,5) )
      & ( v103132(VarCurr,5)
      <=> v100445(VarCurr,4) )
      & ( v103132(VarCurr,4)
      <=> v100445(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9891,axiom,
    ! [VarCurr: state_type] :
      ( v103113(VarCurr)
    <=> ( v103115(VarCurr)
        | v103123(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4011,axiom,
    ! [VarCurr: state_type] :
      ( v103123(VarCurr)
    <=> ( v100207(VarCurr,2)
        & v103117(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4010,axiom,
    ! [VarCurr: state_type] :
      ( v103115(VarCurr)
    <=> ( v100207(VarCurr,2)
        & v103121(VarCurr) ) ) ).

tff(writeUnaryOperator_5079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103121(VarCurr)
    <=> v103117(VarCurr,15) ) ).

tff(addAssignment_63140,axiom,
    ! [VarCurr: state_type] :
      ( v103117(VarCurr,15)
    <=> v103119(VarCurr,15) ) ).

tff(addAssignment_63139,axiom,
    ! [VarCurr: state_type] :
      ( v103119(VarCurr,15)
    <=> v100445(VarCurr,15) ) ).

tff(addAssignment_63138,axiom,
    ! [VarCurr: state_type] :
      ( v100445(VarCurr,15)
    <=> v100446(VarCurr,15) ) ).

tff(addAssignment_63137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103106(VarCurr,B)
      <=> v103108(VarCurr,B) ) ) ).

tff(addAssignment_63136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103108(VarCurr,B)
      <=> v103110(VarCurr,B) ) ) ).

tff(addAssignment_63135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v103110(VarCurr,B)
      <=> v103111(VarCurr,B) ) ) ).

tff(addAssignment_63134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v103111(VarCurr,B)
      <=> v100229(VarCurr,B) ) ) ).

tff(addAssignment_63133,axiom,
    ! [VarCurr: state_type] :
      ( v103111(VarCurr,3)
    <=> v100219(VarCurr,3) ) ).

tff(addAssignment_63132,axiom,
    ! [VarCurr: state_type] :
      ( ( v103111(VarCurr,9)
      <=> v100229(VarCurr,8) )
      & ( v103111(VarCurr,8)
      <=> v100229(VarCurr,7) )
      & ( v103111(VarCurr,7)
      <=> v100229(VarCurr,6) )
      & ( v103111(VarCurr,6)
      <=> v100229(VarCurr,5) )
      & ( v103111(VarCurr,5)
      <=> v100229(VarCurr,4) )
      & ( v103111(VarCurr,4)
      <=> v100229(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9890,axiom,
    ! [VarCurr: state_type] :
      ( v103096(VarCurr)
    <=> ( v103098(VarCurr)
        | v103102(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4009,axiom,
    ! [VarCurr: state_type] :
      ( v103102(VarCurr)
    <=> ( v100207(VarCurr,1)
        & v101505(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4008,axiom,
    ! [VarCurr: state_type] :
      ( v103098(VarCurr)
    <=> ( v100207(VarCurr,1)
        & v103100(VarCurr) ) ) ).

tff(writeUnaryOperator_5078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103100(VarCurr)
    <=> v101505(VarCurr,15) ) ).

tff(addAssignment_63131,axiom,
    ! [VarCurr: state_type] :
      ( v101495(VarCurr)
    <=> v89192(VarCurr,1) ) ).

tff(addAssignment_63130,axiom,
    ! [VarCurr: state_type] :
      ( v89192(VarCurr,1)
    <=> v89194(VarCurr,1) ) ).

tff(addAssignment_63129,axiom,
    ! [VarNext: state_type] :
      ( v89194(VarNext,1)
    <=> v103073(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103074(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v103073(VarNext,B)
            <=> v89194(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1235,axiom,
    ! [VarNext: state_type] :
      ( v103074(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v103073(VarNext,B)
          <=> v103084(VarNext,B) ) ) ) ).

tff(addAssignment_63128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v103084(VarNext,B)
          <=> v103082(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v103082(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_717,axiom,
    ! [VarCurr: state_type] :
      ( v103085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v103082(VarCurr,B)
          <=> v89204(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9889,axiom,
    ! [VarCurr: state_type] :
      ( v103085(VarCurr)
    <=> ( v103086(VarCurr)
        & v103087(VarCurr) ) ) ).

tff(writeUnaryOperator_5077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103087(VarCurr)
    <=> v89200(VarCurr) ) ).

tff(writeUnaryOperator_5076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103086(VarCurr)
    <=> v89196(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103074(VarNext)
      <=> v103075(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103075(VarNext)
      <=> ( v103076(VarNext)
          & v103069(VarNext) ) ) ) ).

tff(writeUnaryOperator_5075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103076(VarNext)
      <=> v103078(VarNext) ) ) ).

tff(addAssignment_63127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103078(VarNext)
      <=> v103069(VarCurr) ) ) ).

tff(addAssignment_63126,axiom,
    ! [VarCurr: state_type] :
      ( v103069(VarCurr)
    <=> v103071(VarCurr) ) ).

tff(addAssignment_63125,axiom,
    ! [VarCurr: state_type] :
      ( v103071(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_63124,axiom,
    ! [VarCurr: state_type] :
      ( v89204(VarCurr,1)
    <=> v89206(VarCurr,1) ) ).

tff(addAssignment_63123,axiom,
    ! [VarCurr: state_type] :
      ( v89206(VarCurr,1)
    <=> v89208(VarCurr,1) ) ).

tff(addAssignment_63122,axiom,
    ! [VarCurr: state_type] :
      ( v89208(VarCurr,1)
    <=> v103066(VarCurr,1) ) ).

tff(addAssignment_63121,axiom,
    ! [VarCurr: state_type] :
      ( v103066(VarCurr,0)
    <=> v103067(VarCurr) ) ).

tff(addAssignment_63120,axiom,
    ! [VarCurr: state_type] :
      ( v103066(VarCurr,1)
    <=> v101497(VarCurr) ) ).

tff(addAssignment_63119,axiom,
    ! [VarCurr: state_type] :
      ( v103066(VarCurr,2)
    <=> v89210(VarCurr) ) ).

tff(addAssignment_63118,axiom,
    ! [VarCurr: state_type] :
      ( v101497(VarCurr)
    <=> v101499(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9886,axiom,
    ! [VarCurr: state_type] :
      ( v101499(VarCurr,0)
    <=> ( v103062(VarCurr)
        | v103064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9885,axiom,
    ! [VarCurr: state_type] :
      ( v103064(VarCurr)
    <=> ( v83096(VarCurr)
        & v103065(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_685,axiom,
    ! [VarCurr: state_type] :
      ( v103065(VarCurr)
    <=> ( ( v101570(VarCurr,2)
        <=> $false )
        & ( v101570(VarCurr,1)
        <=> $false )
        & ( v101570(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9884,axiom,
    ! [VarCurr: state_type] :
      ( v103062(VarCurr)
    <=> ( v101501(VarCurr)
        & v103063(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_684,axiom,
    ! [VarCurr: state_type] :
      ( v103063(VarCurr)
    <=> ( ( v101563(VarCurr,6)
        <=> $false )
        & ( v101563(VarCurr,5)
        <=> $false )
        & ( v101563(VarCurr,4)
        <=> $false ) ) ) ).

tff(addAssignment_63117,axiom,
    ! [VarCurr: state_type] :
      ( ( v101570(VarCurr,2)
      <=> v781(VarCurr,12) )
      & ( v101570(VarCurr,1)
      <=> v781(VarCurr,11) )
      & ( v101570(VarCurr,0)
      <=> v781(VarCurr,10) ) ) ).

tff(addAssignment_63116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v781(VarCurr,B)
      <=> v783(VarCurr,B) ) ) ).

tff(addAssignment_63115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v783(VarCurr,B)
      <=> v5329(VarCurr,B) ) ) ).

tff(addAssignment_63114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5324(VarCurr,B)
      <=> v5326(VarCurr,B) ) ) ).

tff(addAssignment_63113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5326(VarCurr,B)
      <=> v5328(VarCurr,B) ) ) ).

tff(addAssignment_63112,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5328(VarNext,B)
      <=> v103044(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103045(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v103044(VarNext,B)
            <=> v5328(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1234,axiom,
    ! [VarNext: state_type] :
      ( v103045(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103044(VarNext,B)
          <=> v103055(VarNext,B) ) ) ) ).

tff(addAssignment_63111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103055(VarNext,B)
          <=> v103053(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103056(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103053(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_716,axiom,
    ! [VarCurr: state_type] :
      ( v103056(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103053(VarCurr,B)
          <=> v103020(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9883,axiom,
    ! [VarCurr: state_type] :
      ( v103056(VarCurr)
    <=> ( v103057(VarCurr)
        & v103058(VarCurr) ) ) ).

tff(writeUnaryOperator_5074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103058(VarCurr)
    <=> v103016(VarCurr) ) ).

tff(writeUnaryOperator_5073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103057(VarCurr)
    <=> v103012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103045(VarNext)
      <=> v103046(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103046(VarNext)
      <=> ( v103047(VarNext)
          & v103040(VarNext) ) ) ) ).

tff(writeUnaryOperator_5072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v103047(VarNext)
      <=> v103049(VarNext) ) ) ).

tff(addAssignment_63110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v103049(VarNext)
      <=> v103040(VarCurr) ) ) ).

tff(addAssignment_63109,axiom,
    ! [VarCurr: state_type] :
      ( v103040(VarCurr)
    <=> v103042(VarCurr) ) ).

tff(addAssignment_63108,axiom,
    ! [VarCurr: state_type] :
      ( v103042(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_63107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v103020(VarCurr,B)
      <=> v103022(VarCurr,B) ) ) ).

tff(addAssignment_63106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v103022(VarCurr,B)
      <=> v103031(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v103031(VarCurr,B)
      <=> ( v103032(VarCurr,B)
          | v103035(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v103035(VarCurr,B)
      <=> ( v5326(VarCurr,B)
          & v103036(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v103036(VarCurr,B)
      <=> ~ v103037(VarCurr,B) ) ) ).

tff(addAssignment_63105,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,0)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63104,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,1)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63103,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,2)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63102,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,3)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63101,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,4)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63100,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,5)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63099,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,6)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63098,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,7)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63097,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,8)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63096,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,9)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63095,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,10)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63094,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,11)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63093,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,12)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63092,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,13)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63091,axiom,
    ! [VarCurr: state_type] :
      ( v103037(VarCurr,14)
    <=> v103038(VarCurr) ) ).

tff(addAssignment_63090,axiom,
    ! [VarCurr: state_type] :
      ( v103038(VarCurr)
    <=> v103026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v103032(VarCurr,B)
      <=> ( v103024(VarCurr,B)
          & v103033(VarCurr,B) ) ) ) ).

tff(addAssignment_63089,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,0)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63088,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,1)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63087,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,2)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63086,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,3)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63085,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,4)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63084,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,5)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63083,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,6)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63082,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,7)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63081,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,8)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63080,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,9)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63079,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,10)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63078,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,11)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63077,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,12)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63076,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,13)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63075,axiom,
    ! [VarCurr: state_type] :
      ( v103033(VarCurr,14)
    <=> v103034(VarCurr) ) ).

tff(addAssignment_63074,axiom,
    ! [VarCurr: state_type] :
      ( v103034(VarCurr)
    <=> v103026(VarCurr) ) ).

tff(addAssignment_63073,axiom,
    ! [VarCurr: state_type] :
      ( v103026(VarCurr)
    <=> v103028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9880,axiom,
    ! [VarCurr: state_type] :
      ( v103028(VarCurr)
    <=> ( v103030(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_683,axiom,
    ! [VarCurr: state_type] :
      ( v103030(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $true )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_63072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v103024(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_63071,axiom,
    ! [VarCurr: state_type] :
      ( v103016(VarCurr)
    <=> v103018(VarCurr) ) ).

tff(addAssignment_63070,axiom,
    ! [VarCurr: state_type] :
      ( v103018(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_63069,axiom,
    ! [VarCurr: state_type] :
      ( v103012(VarCurr)
    <=> v103014(VarCurr) ) ).

tff(addAssignment_63068,axiom,
    ! [VarCurr: state_type] :
      ( v103014(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_63067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5318(VarCurr,B)
      <=> v5320(VarCurr,B) ) ) ).

tff(addAssignment_63066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5320(VarCurr,B)
      <=> v5322(VarCurr,B) ) ) ).

tff(addAssignment_63065,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5322(VarNext,B)
      <=> v102994(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102995(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102994(VarNext,B)
            <=> v5322(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1233,axiom,
    ! [VarNext: state_type] :
      ( v102995(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102994(VarNext,B)
          <=> v103005(VarNext,B) ) ) ) ).

tff(addAssignment_63064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103005(VarNext,B)
          <=> v103003(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103006(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103003(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_715,axiom,
    ! [VarCurr: state_type] :
      ( v103006(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v103003(VarCurr,B)
          <=> v102970(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9879,axiom,
    ! [VarCurr: state_type] :
      ( v103006(VarCurr)
    <=> ( v103007(VarCurr)
        & v103008(VarCurr) ) ) ).

tff(writeUnaryOperator_5070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103008(VarCurr)
    <=> v102966(VarCurr) ) ).

tff(writeUnaryOperator_5069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v103007(VarCurr)
    <=> v102962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102995(VarNext)
      <=> v102996(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102996(VarNext)
      <=> ( v102997(VarNext)
          & v102990(VarNext) ) ) ) ).

tff(writeUnaryOperator_5068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102997(VarNext)
      <=> v102999(VarNext) ) ) ).

tff(addAssignment_63063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102999(VarNext)
      <=> v102990(VarCurr) ) ) ).

tff(addAssignment_63062,axiom,
    ! [VarCurr: state_type] :
      ( v102990(VarCurr)
    <=> v102992(VarCurr) ) ).

tff(addAssignment_63061,axiom,
    ! [VarCurr: state_type] :
      ( v102992(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_63060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102970(VarCurr,B)
      <=> v102972(VarCurr,B) ) ) ).

tff(addAssignment_63059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102972(VarCurr,B)
      <=> v102981(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102981(VarCurr,B)
      <=> ( v102982(VarCurr,B)
          | v102985(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102985(VarCurr,B)
      <=> ( v5320(VarCurr,B)
          & v102986(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102986(VarCurr,B)
      <=> ~ v102987(VarCurr,B) ) ) ).

tff(addAssignment_63058,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,0)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63057,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,1)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63056,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,2)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63055,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,3)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63054,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,4)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63053,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,5)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63052,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,6)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63051,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,7)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63050,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,8)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63049,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,9)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63048,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,10)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63047,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,11)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63046,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,12)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63045,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,13)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63044,axiom,
    ! [VarCurr: state_type] :
      ( v102987(VarCurr,14)
    <=> v102988(VarCurr) ) ).

tff(addAssignment_63043,axiom,
    ! [VarCurr: state_type] :
      ( v102988(VarCurr)
    <=> v102976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102982(VarCurr,B)
      <=> ( v102974(VarCurr,B)
          & v102983(VarCurr,B) ) ) ) ).

tff(addAssignment_63042,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,0)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63041,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,1)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63040,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,2)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63039,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,3)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63038,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,4)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63037,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,5)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63036,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,6)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63035,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,7)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63034,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,8)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63033,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,9)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63032,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,10)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63031,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,11)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63030,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,12)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63029,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,13)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63028,axiom,
    ! [VarCurr: state_type] :
      ( v102983(VarCurr,14)
    <=> v102984(VarCurr) ) ).

tff(addAssignment_63027,axiom,
    ! [VarCurr: state_type] :
      ( v102984(VarCurr)
    <=> v102976(VarCurr) ) ).

tff(addAssignment_63026,axiom,
    ! [VarCurr: state_type] :
      ( v102976(VarCurr)
    <=> v102978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9876,axiom,
    ! [VarCurr: state_type] :
      ( v102978(VarCurr)
    <=> ( v102980(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_682,axiom,
    ! [VarCurr: state_type] :
      ( v102980(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_63025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102974(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_63024,axiom,
    ! [VarCurr: state_type] :
      ( v102966(VarCurr)
    <=> v102968(VarCurr) ) ).

tff(addAssignment_63023,axiom,
    ! [VarCurr: state_type] :
      ( v102968(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_63022,axiom,
    ! [VarCurr: state_type] :
      ( v102962(VarCurr)
    <=> v102964(VarCurr) ) ).

tff(addAssignment_63021,axiom,
    ! [VarCurr: state_type] :
      ( v102964(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_63020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5311(VarCurr,B)
      <=> v5313(VarCurr,B) ) ) ).

tff(addAssignment_63019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5313(VarCurr,B)
      <=> v5315(VarCurr,B) ) ) ).

tff(addAssignment_63018,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5315(VarNext,B)
      <=> v102944(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102945(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102944(VarNext,B)
            <=> v5315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1232,axiom,
    ! [VarNext: state_type] :
      ( v102945(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102944(VarNext,B)
          <=> v102955(VarNext,B) ) ) ) ).

tff(addAssignment_63017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102955(VarNext,B)
          <=> v102953(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102953(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_714,axiom,
    ! [VarCurr: state_type] :
      ( v102956(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102953(VarCurr,B)
          <=> v102920(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9875,axiom,
    ! [VarCurr: state_type] :
      ( v102956(VarCurr)
    <=> ( v102957(VarCurr)
        & v102958(VarCurr) ) ) ).

tff(writeUnaryOperator_5066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102958(VarCurr)
    <=> v102916(VarCurr) ) ).

tff(writeUnaryOperator_5065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102957(VarCurr)
    <=> v102912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102945(VarNext)
      <=> v102946(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102946(VarNext)
      <=> ( v102947(VarNext)
          & v102940(VarNext) ) ) ) ).

tff(writeUnaryOperator_5064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102947(VarNext)
      <=> v102949(VarNext) ) ) ).

tff(addAssignment_63016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102949(VarNext)
      <=> v102940(VarCurr) ) ) ).

tff(addAssignment_63015,axiom,
    ! [VarCurr: state_type] :
      ( v102940(VarCurr)
    <=> v102942(VarCurr) ) ).

tff(addAssignment_63014,axiom,
    ! [VarCurr: state_type] :
      ( v102942(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_63013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102920(VarCurr,B)
      <=> v102922(VarCurr,B) ) ) ).

tff(addAssignment_63012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102922(VarCurr,B)
      <=> v102931(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102931(VarCurr,B)
      <=> ( v102932(VarCurr,B)
          | v102935(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102935(VarCurr,B)
      <=> ( v5313(VarCurr,B)
          & v102936(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102936(VarCurr,B)
      <=> ~ v102937(VarCurr,B) ) ) ).

tff(addAssignment_63011,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,0)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63010,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,1)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63009,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,2)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63008,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,3)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63007,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,4)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63006,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,5)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63005,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,6)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63004,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,7)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63003,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,8)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63002,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,9)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63001,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,10)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_63000,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,11)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_62999,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,12)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_62998,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,13)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_62997,axiom,
    ! [VarCurr: state_type] :
      ( v102937(VarCurr,14)
    <=> v102938(VarCurr) ) ).

tff(addAssignment_62996,axiom,
    ! [VarCurr: state_type] :
      ( v102938(VarCurr)
    <=> v102926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102932(VarCurr,B)
      <=> ( v102924(VarCurr,B)
          & v102933(VarCurr,B) ) ) ) ).

tff(addAssignment_62995,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,0)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62994,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,1)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62993,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,2)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62992,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,3)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62991,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,4)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62990,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,5)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62989,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,6)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62988,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,7)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62987,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,8)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62986,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,9)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62985,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,10)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62984,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,11)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62983,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,12)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62982,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,13)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62981,axiom,
    ! [VarCurr: state_type] :
      ( v102933(VarCurr,14)
    <=> v102934(VarCurr) ) ).

tff(addAssignment_62980,axiom,
    ! [VarCurr: state_type] :
      ( v102934(VarCurr)
    <=> v102926(VarCurr) ) ).

tff(addAssignment_62979,axiom,
    ! [VarCurr: state_type] :
      ( v102926(VarCurr)
    <=> v102928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9872,axiom,
    ! [VarCurr: state_type] :
      ( v102928(VarCurr)
    <=> ( v102930(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_681,axiom,
    ! [VarCurr: state_type] :
      ( v102930(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102924(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62977,axiom,
    ! [VarCurr: state_type] :
      ( v102916(VarCurr)
    <=> v102918(VarCurr) ) ).

tff(addAssignment_62976,axiom,
    ! [VarCurr: state_type] :
      ( v102918(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62975,axiom,
    ! [VarCurr: state_type] :
      ( v102912(VarCurr)
    <=> v102914(VarCurr) ) ).

tff(addAssignment_62974,axiom,
    ! [VarCurr: state_type] :
      ( v102914(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5304(VarCurr,B)
      <=> v5306(VarCurr,B) ) ) ).

tff(addAssignment_62972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5306(VarCurr,B)
      <=> v5308(VarCurr,B) ) ) ).

tff(addAssignment_62971,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5308(VarNext,B)
      <=> v102894(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102895(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102894(VarNext,B)
            <=> v5308(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1231,axiom,
    ! [VarNext: state_type] :
      ( v102895(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102894(VarNext,B)
          <=> v102905(VarNext,B) ) ) ) ).

tff(addAssignment_62970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102905(VarNext,B)
          <=> v102903(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102906(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102903(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_713,axiom,
    ! [VarCurr: state_type] :
      ( v102906(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102903(VarCurr,B)
          <=> v102870(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9871,axiom,
    ! [VarCurr: state_type] :
      ( v102906(VarCurr)
    <=> ( v102907(VarCurr)
        & v102908(VarCurr) ) ) ).

tff(writeUnaryOperator_5062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102908(VarCurr)
    <=> v102866(VarCurr) ) ).

tff(writeUnaryOperator_5061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102907(VarCurr)
    <=> v102862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102895(VarNext)
      <=> v102896(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102896(VarNext)
      <=> ( v102897(VarNext)
          & v102890(VarNext) ) ) ) ).

tff(writeUnaryOperator_5060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102897(VarNext)
      <=> v102899(VarNext) ) ) ).

tff(addAssignment_62969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102899(VarNext)
      <=> v102890(VarCurr) ) ) ).

tff(addAssignment_62968,axiom,
    ! [VarCurr: state_type] :
      ( v102890(VarCurr)
    <=> v102892(VarCurr) ) ).

tff(addAssignment_62967,axiom,
    ! [VarCurr: state_type] :
      ( v102892(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102870(VarCurr,B)
      <=> v102872(VarCurr,B) ) ) ).

tff(addAssignment_62965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102872(VarCurr,B)
      <=> v102881(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102881(VarCurr,B)
      <=> ( v102882(VarCurr,B)
          | v102885(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102885(VarCurr,B)
      <=> ( v5306(VarCurr,B)
          & v102886(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102886(VarCurr,B)
      <=> ~ v102887(VarCurr,B) ) ) ).

tff(addAssignment_62964,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,0)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62963,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,1)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62962,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,2)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62961,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,3)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62960,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,4)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62959,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,5)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62958,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,6)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62957,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,7)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62956,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,8)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62955,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,9)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62954,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,10)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62953,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,11)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62952,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,12)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62951,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,13)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62950,axiom,
    ! [VarCurr: state_type] :
      ( v102887(VarCurr,14)
    <=> v102888(VarCurr) ) ).

tff(addAssignment_62949,axiom,
    ! [VarCurr: state_type] :
      ( v102888(VarCurr)
    <=> v102876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102882(VarCurr,B)
      <=> ( v102874(VarCurr,B)
          & v102883(VarCurr,B) ) ) ) ).

tff(addAssignment_62948,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,0)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62947,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,1)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62946,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,2)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62945,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,3)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62944,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,4)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62943,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,5)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62942,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,6)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62941,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,7)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62940,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,8)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62939,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,9)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62938,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,10)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62937,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,11)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62936,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,12)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62935,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,13)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62934,axiom,
    ! [VarCurr: state_type] :
      ( v102883(VarCurr,14)
    <=> v102884(VarCurr) ) ).

tff(addAssignment_62933,axiom,
    ! [VarCurr: state_type] :
      ( v102884(VarCurr)
    <=> v102876(VarCurr) ) ).

tff(addAssignment_62932,axiom,
    ! [VarCurr: state_type] :
      ( v102876(VarCurr)
    <=> v102878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9868,axiom,
    ! [VarCurr: state_type] :
      ( v102878(VarCurr)
    <=> ( v102880(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_680,axiom,
    ! [VarCurr: state_type] :
      ( v102880(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102874(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62930,axiom,
    ! [VarCurr: state_type] :
      ( v102866(VarCurr)
    <=> v102868(VarCurr) ) ).

tff(addAssignment_62929,axiom,
    ! [VarCurr: state_type] :
      ( v102868(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62928,axiom,
    ! [VarCurr: state_type] :
      ( v102862(VarCurr)
    <=> v102864(VarCurr) ) ).

tff(addAssignment_62927,axiom,
    ! [VarCurr: state_type] :
      ( v102864(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5297(VarCurr,B)
      <=> v5299(VarCurr,B) ) ) ).

tff(addAssignment_62925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5299(VarCurr,B)
      <=> v5301(VarCurr,B) ) ) ).

tff(addAssignment_62924,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5301(VarNext,B)
      <=> v102844(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102845(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102844(VarNext,B)
            <=> v5301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1230,axiom,
    ! [VarNext: state_type] :
      ( v102845(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102844(VarNext,B)
          <=> v102855(VarNext,B) ) ) ) ).

tff(addAssignment_62923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102855(VarNext,B)
          <=> v102853(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102853(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_712,axiom,
    ! [VarCurr: state_type] :
      ( v102856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102853(VarCurr,B)
          <=> v102820(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9867,axiom,
    ! [VarCurr: state_type] :
      ( v102856(VarCurr)
    <=> ( v102857(VarCurr)
        & v102858(VarCurr) ) ) ).

tff(writeUnaryOperator_5058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102858(VarCurr)
    <=> v102816(VarCurr) ) ).

tff(writeUnaryOperator_5057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102857(VarCurr)
    <=> v102812(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102845(VarNext)
      <=> v102846(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102846(VarNext)
      <=> ( v102847(VarNext)
          & v102840(VarNext) ) ) ) ).

tff(writeUnaryOperator_5056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102847(VarNext)
      <=> v102849(VarNext) ) ) ).

tff(addAssignment_62922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102849(VarNext)
      <=> v102840(VarCurr) ) ) ).

tff(addAssignment_62921,axiom,
    ! [VarCurr: state_type] :
      ( v102840(VarCurr)
    <=> v102842(VarCurr) ) ).

tff(addAssignment_62920,axiom,
    ! [VarCurr: state_type] :
      ( v102842(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102820(VarCurr,B)
      <=> v102822(VarCurr,B) ) ) ).

tff(addAssignment_62918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102822(VarCurr,B)
      <=> v102831(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102831(VarCurr,B)
      <=> ( v102832(VarCurr,B)
          | v102835(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102835(VarCurr,B)
      <=> ( v5299(VarCurr,B)
          & v102836(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102836(VarCurr,B)
      <=> ~ v102837(VarCurr,B) ) ) ).

tff(addAssignment_62917,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,0)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62916,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,1)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62915,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,2)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62914,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,3)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62913,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,4)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62912,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,5)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62911,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,6)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62910,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,7)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62909,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,8)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62908,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,9)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62907,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,10)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62906,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,11)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62905,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,12)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62904,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,13)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62903,axiom,
    ! [VarCurr: state_type] :
      ( v102837(VarCurr,14)
    <=> v102838(VarCurr) ) ).

tff(addAssignment_62902,axiom,
    ! [VarCurr: state_type] :
      ( v102838(VarCurr)
    <=> v102826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102832(VarCurr,B)
      <=> ( v102824(VarCurr,B)
          & v102833(VarCurr,B) ) ) ) ).

tff(addAssignment_62901,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,0)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62900,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,1)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62899,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,2)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62898,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,3)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62897,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,4)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62896,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,5)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62895,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,6)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62894,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,7)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62893,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,8)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62892,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,9)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62891,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,10)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62890,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,11)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62889,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,12)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62888,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,13)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62887,axiom,
    ! [VarCurr: state_type] :
      ( v102833(VarCurr,14)
    <=> v102834(VarCurr) ) ).

tff(addAssignment_62886,axiom,
    ! [VarCurr: state_type] :
      ( v102834(VarCurr)
    <=> v102826(VarCurr) ) ).

tff(addAssignment_62885,axiom,
    ! [VarCurr: state_type] :
      ( v102826(VarCurr)
    <=> v102828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9864,axiom,
    ! [VarCurr: state_type] :
      ( v102828(VarCurr)
    <=> ( v102830(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_679,axiom,
    ! [VarCurr: state_type] :
      ( v102830(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102824(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62883,axiom,
    ! [VarCurr: state_type] :
      ( v102816(VarCurr)
    <=> v102818(VarCurr) ) ).

tff(addAssignment_62882,axiom,
    ! [VarCurr: state_type] :
      ( v102818(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62881,axiom,
    ! [VarCurr: state_type] :
      ( v102812(VarCurr)
    <=> v102814(VarCurr) ) ).

tff(addAssignment_62880,axiom,
    ! [VarCurr: state_type] :
      ( v102814(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5290(VarCurr,B)
      <=> v5292(VarCurr,B) ) ) ).

tff(addAssignment_62878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5292(VarCurr,B)
      <=> v5294(VarCurr,B) ) ) ).

tff(addAssignment_62877,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5294(VarNext,B)
      <=> v102794(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102795(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102794(VarNext,B)
            <=> v5294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1229,axiom,
    ! [VarNext: state_type] :
      ( v102795(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102794(VarNext,B)
          <=> v102805(VarNext,B) ) ) ) ).

tff(addAssignment_62876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102805(VarNext,B)
          <=> v102803(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102803(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_711,axiom,
    ! [VarCurr: state_type] :
      ( v102806(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102803(VarCurr,B)
          <=> v102770(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9863,axiom,
    ! [VarCurr: state_type] :
      ( v102806(VarCurr)
    <=> ( v102807(VarCurr)
        & v102808(VarCurr) ) ) ).

tff(writeUnaryOperator_5054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102808(VarCurr)
    <=> v102766(VarCurr) ) ).

tff(writeUnaryOperator_5053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102807(VarCurr)
    <=> v102762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102795(VarNext)
      <=> v102796(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102796(VarNext)
      <=> ( v102797(VarNext)
          & v102790(VarNext) ) ) ) ).

tff(writeUnaryOperator_5052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102797(VarNext)
      <=> v102799(VarNext) ) ) ).

tff(addAssignment_62875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102799(VarNext)
      <=> v102790(VarCurr) ) ) ).

tff(addAssignment_62874,axiom,
    ! [VarCurr: state_type] :
      ( v102790(VarCurr)
    <=> v102792(VarCurr) ) ).

tff(addAssignment_62873,axiom,
    ! [VarCurr: state_type] :
      ( v102792(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102770(VarCurr,B)
      <=> v102772(VarCurr,B) ) ) ).

tff(addAssignment_62871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102772(VarCurr,B)
      <=> v102781(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102781(VarCurr,B)
      <=> ( v102782(VarCurr,B)
          | v102785(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102785(VarCurr,B)
      <=> ( v5292(VarCurr,B)
          & v102786(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102786(VarCurr,B)
      <=> ~ v102787(VarCurr,B) ) ) ).

tff(addAssignment_62870,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,0)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62869,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,1)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62868,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,2)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62867,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,3)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62866,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,4)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62865,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,5)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62864,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,6)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62863,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,7)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62862,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,8)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62861,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,9)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62860,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,10)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62859,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,11)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62858,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,12)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62857,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,13)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62856,axiom,
    ! [VarCurr: state_type] :
      ( v102787(VarCurr,14)
    <=> v102788(VarCurr) ) ).

tff(addAssignment_62855,axiom,
    ! [VarCurr: state_type] :
      ( v102788(VarCurr)
    <=> v102776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102782(VarCurr,B)
      <=> ( v102774(VarCurr,B)
          & v102783(VarCurr,B) ) ) ) ).

tff(addAssignment_62854,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,0)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62853,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,1)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62852,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,2)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62851,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,3)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62850,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,4)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62849,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,5)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62848,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,6)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62847,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,7)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62846,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,8)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62845,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,9)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62844,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,10)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62843,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,11)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62842,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,12)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62841,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,13)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62840,axiom,
    ! [VarCurr: state_type] :
      ( v102783(VarCurr,14)
    <=> v102784(VarCurr) ) ).

tff(addAssignment_62839,axiom,
    ! [VarCurr: state_type] :
      ( v102784(VarCurr)
    <=> v102776(VarCurr) ) ).

tff(addAssignment_62838,axiom,
    ! [VarCurr: state_type] :
      ( v102776(VarCurr)
    <=> v102778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9860,axiom,
    ! [VarCurr: state_type] :
      ( v102778(VarCurr)
    <=> ( v102780(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_678,axiom,
    ! [VarCurr: state_type] :
      ( v102780(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102774(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62836,axiom,
    ! [VarCurr: state_type] :
      ( v102766(VarCurr)
    <=> v102768(VarCurr) ) ).

tff(addAssignment_62835,axiom,
    ! [VarCurr: state_type] :
      ( v102768(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62834,axiom,
    ! [VarCurr: state_type] :
      ( v102762(VarCurr)
    <=> v102764(VarCurr) ) ).

tff(addAssignment_62833,axiom,
    ! [VarCurr: state_type] :
      ( v102764(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5283(VarCurr,B)
      <=> v5285(VarCurr,B) ) ) ).

tff(addAssignment_62831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5285(VarCurr,B)
      <=> v5287(VarCurr,B) ) ) ).

tff(addAssignment_62830,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5287(VarNext,B)
      <=> v102744(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102745(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102744(VarNext,B)
            <=> v5287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1228,axiom,
    ! [VarNext: state_type] :
      ( v102745(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102744(VarNext,B)
          <=> v102755(VarNext,B) ) ) ) ).

tff(addAssignment_62829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102755(VarNext,B)
          <=> v102753(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102756(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102753(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_710,axiom,
    ! [VarCurr: state_type] :
      ( v102756(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102753(VarCurr,B)
          <=> v102720(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9859,axiom,
    ! [VarCurr: state_type] :
      ( v102756(VarCurr)
    <=> ( v102757(VarCurr)
        & v102758(VarCurr) ) ) ).

tff(writeUnaryOperator_5050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102758(VarCurr)
    <=> v102716(VarCurr) ) ).

tff(writeUnaryOperator_5049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102757(VarCurr)
    <=> v102712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102745(VarNext)
      <=> v102746(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102746(VarNext)
      <=> ( v102747(VarNext)
          & v102740(VarNext) ) ) ) ).

tff(writeUnaryOperator_5048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102747(VarNext)
      <=> v102749(VarNext) ) ) ).

tff(addAssignment_62828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102749(VarNext)
      <=> v102740(VarCurr) ) ) ).

tff(addAssignment_62827,axiom,
    ! [VarCurr: state_type] :
      ( v102740(VarCurr)
    <=> v102742(VarCurr) ) ).

tff(addAssignment_62826,axiom,
    ! [VarCurr: state_type] :
      ( v102742(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102720(VarCurr,B)
      <=> v102722(VarCurr,B) ) ) ).

tff(addAssignment_62824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102722(VarCurr,B)
      <=> v102731(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102731(VarCurr,B)
      <=> ( v102732(VarCurr,B)
          | v102735(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102735(VarCurr,B)
      <=> ( v5285(VarCurr,B)
          & v102736(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102736(VarCurr,B)
      <=> ~ v102737(VarCurr,B) ) ) ).

tff(addAssignment_62823,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,0)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62822,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,1)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62821,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,2)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62820,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,3)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62819,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,4)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62818,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,5)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62817,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,6)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62816,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,7)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62815,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,8)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62814,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,9)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62813,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,10)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62812,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,11)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62811,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,12)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62810,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,13)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62809,axiom,
    ! [VarCurr: state_type] :
      ( v102737(VarCurr,14)
    <=> v102738(VarCurr) ) ).

tff(addAssignment_62808,axiom,
    ! [VarCurr: state_type] :
      ( v102738(VarCurr)
    <=> v102726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102732(VarCurr,B)
      <=> ( v102724(VarCurr,B)
          & v102733(VarCurr,B) ) ) ) ).

tff(addAssignment_62807,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,0)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62806,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,1)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62805,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,2)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62804,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,3)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62803,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,4)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62802,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,5)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62801,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,6)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62800,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,7)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62799,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,8)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62798,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,9)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62797,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,10)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62796,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,11)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62795,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,12)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62794,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,13)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62793,axiom,
    ! [VarCurr: state_type] :
      ( v102733(VarCurr,14)
    <=> v102734(VarCurr) ) ).

tff(addAssignment_62792,axiom,
    ! [VarCurr: state_type] :
      ( v102734(VarCurr)
    <=> v102726(VarCurr) ) ).

tff(addAssignment_62791,axiom,
    ! [VarCurr: state_type] :
      ( v102726(VarCurr)
    <=> v102728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9856,axiom,
    ! [VarCurr: state_type] :
      ( v102728(VarCurr)
    <=> ( v102730(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_677,axiom,
    ! [VarCurr: state_type] :
      ( v102730(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102724(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62789,axiom,
    ! [VarCurr: state_type] :
      ( v102716(VarCurr)
    <=> v102718(VarCurr) ) ).

tff(addAssignment_62788,axiom,
    ! [VarCurr: state_type] :
      ( v102718(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62787,axiom,
    ! [VarCurr: state_type] :
      ( v102712(VarCurr)
    <=> v102714(VarCurr) ) ).

tff(addAssignment_62786,axiom,
    ! [VarCurr: state_type] :
      ( v102714(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5276(VarCurr,B)
      <=> v5278(VarCurr,B) ) ) ).

tff(addAssignment_62784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5278(VarCurr,B)
      <=> v5280(VarCurr,B) ) ) ).

tff(addAssignment_62783,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5280(VarNext,B)
      <=> v102694(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102695(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102694(VarNext,B)
            <=> v5280(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1227,axiom,
    ! [VarNext: state_type] :
      ( v102695(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102694(VarNext,B)
          <=> v102705(VarNext,B) ) ) ) ).

tff(addAssignment_62782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102705(VarNext,B)
          <=> v102703(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102703(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_709,axiom,
    ! [VarCurr: state_type] :
      ( v102706(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102703(VarCurr,B)
          <=> v102670(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9855,axiom,
    ! [VarCurr: state_type] :
      ( v102706(VarCurr)
    <=> ( v102707(VarCurr)
        & v102708(VarCurr) ) ) ).

tff(writeUnaryOperator_5046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102708(VarCurr)
    <=> v102666(VarCurr) ) ).

tff(writeUnaryOperator_5045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102707(VarCurr)
    <=> v102662(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102695(VarNext)
      <=> v102696(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9853,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102696(VarNext)
      <=> ( v102697(VarNext)
          & v102690(VarNext) ) ) ) ).

tff(writeUnaryOperator_5044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102697(VarNext)
      <=> v102699(VarNext) ) ) ).

tff(addAssignment_62781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102699(VarNext)
      <=> v102690(VarCurr) ) ) ).

tff(addAssignment_62780,axiom,
    ! [VarCurr: state_type] :
      ( v102690(VarCurr)
    <=> v102692(VarCurr) ) ).

tff(addAssignment_62779,axiom,
    ! [VarCurr: state_type] :
      ( v102692(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102670(VarCurr,B)
      <=> v102672(VarCurr,B) ) ) ).

tff(addAssignment_62777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102672(VarCurr,B)
      <=> v102681(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102681(VarCurr,B)
      <=> ( v102682(VarCurr,B)
          | v102685(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102685(VarCurr,B)
      <=> ( v5278(VarCurr,B)
          & v102686(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102686(VarCurr,B)
      <=> ~ v102687(VarCurr,B) ) ) ).

tff(addAssignment_62776,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,0)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62775,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,1)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62774,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,2)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62773,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,3)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62772,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,4)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62771,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,5)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62770,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,6)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62769,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,7)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62768,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,8)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62767,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,9)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62766,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,10)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62765,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,11)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62764,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,12)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62763,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,13)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62762,axiom,
    ! [VarCurr: state_type] :
      ( v102687(VarCurr,14)
    <=> v102688(VarCurr) ) ).

tff(addAssignment_62761,axiom,
    ! [VarCurr: state_type] :
      ( v102688(VarCurr)
    <=> v102676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102682(VarCurr,B)
      <=> ( v102674(VarCurr,B)
          & v102683(VarCurr,B) ) ) ) ).

tff(addAssignment_62760,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,0)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62759,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,1)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62758,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,2)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62757,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,3)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62756,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,4)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62755,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,5)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62754,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,6)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62753,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,7)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62752,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,8)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62751,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,9)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62750,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,10)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62749,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,11)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62748,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,12)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62747,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,13)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62746,axiom,
    ! [VarCurr: state_type] :
      ( v102683(VarCurr,14)
    <=> v102684(VarCurr) ) ).

tff(addAssignment_62745,axiom,
    ! [VarCurr: state_type] :
      ( v102684(VarCurr)
    <=> v102676(VarCurr) ) ).

tff(addAssignment_62744,axiom,
    ! [VarCurr: state_type] :
      ( v102676(VarCurr)
    <=> v102678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9852,axiom,
    ! [VarCurr: state_type] :
      ( v102678(VarCurr)
    <=> ( v102680(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_676,axiom,
    ! [VarCurr: state_type] :
      ( v102680(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102674(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62742,axiom,
    ! [VarCurr: state_type] :
      ( v102666(VarCurr)
    <=> v102668(VarCurr) ) ).

tff(addAssignment_62741,axiom,
    ! [VarCurr: state_type] :
      ( v102668(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62740,axiom,
    ! [VarCurr: state_type] :
      ( v102662(VarCurr)
    <=> v102664(VarCurr) ) ).

tff(addAssignment_62739,axiom,
    ! [VarCurr: state_type] :
      ( v102664(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5269(VarCurr,B)
      <=> v5271(VarCurr,B) ) ) ).

tff(addAssignment_62737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5271(VarCurr,B)
      <=> v5273(VarCurr,B) ) ) ).

tff(addAssignment_62736,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5273(VarNext,B)
      <=> v102644(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102645(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102644(VarNext,B)
            <=> v5273(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1226,axiom,
    ! [VarNext: state_type] :
      ( v102645(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102644(VarNext,B)
          <=> v102655(VarNext,B) ) ) ) ).

tff(addAssignment_62735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102655(VarNext,B)
          <=> v102653(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102656(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102653(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_708,axiom,
    ! [VarCurr: state_type] :
      ( v102656(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102653(VarCurr,B)
          <=> v102620(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9851,axiom,
    ! [VarCurr: state_type] :
      ( v102656(VarCurr)
    <=> ( v102657(VarCurr)
        & v102658(VarCurr) ) ) ).

tff(writeUnaryOperator_5042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102658(VarCurr)
    <=> v102616(VarCurr) ) ).

tff(writeUnaryOperator_5041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102657(VarCurr)
    <=> v102612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102645(VarNext)
      <=> v102646(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102646(VarNext)
      <=> ( v102647(VarNext)
          & v102640(VarNext) ) ) ) ).

tff(writeUnaryOperator_5040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102647(VarNext)
      <=> v102649(VarNext) ) ) ).

tff(addAssignment_62734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102649(VarNext)
      <=> v102640(VarCurr) ) ) ).

tff(addAssignment_62733,axiom,
    ! [VarCurr: state_type] :
      ( v102640(VarCurr)
    <=> v102642(VarCurr) ) ).

tff(addAssignment_62732,axiom,
    ! [VarCurr: state_type] :
      ( v102642(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102620(VarCurr,B)
      <=> v102622(VarCurr,B) ) ) ).

tff(addAssignment_62730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102622(VarCurr,B)
      <=> v102631(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102631(VarCurr,B)
      <=> ( v102632(VarCurr,B)
          | v102635(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102635(VarCurr,B)
      <=> ( v5271(VarCurr,B)
          & v102636(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102636(VarCurr,B)
      <=> ~ v102637(VarCurr,B) ) ) ).

tff(addAssignment_62729,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,0)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62728,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,1)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62727,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,2)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62726,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,3)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62725,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,4)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62724,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,5)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62723,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,6)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62722,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,7)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62721,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,8)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62720,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,9)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62719,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,10)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62718,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,11)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62717,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,12)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62716,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,13)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62715,axiom,
    ! [VarCurr: state_type] :
      ( v102637(VarCurr,14)
    <=> v102638(VarCurr) ) ).

tff(addAssignment_62714,axiom,
    ! [VarCurr: state_type] :
      ( v102638(VarCurr)
    <=> v102626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102632(VarCurr,B)
      <=> ( v102624(VarCurr,B)
          & v102633(VarCurr,B) ) ) ) ).

tff(addAssignment_62713,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,0)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62712,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,1)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62711,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,2)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62710,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,3)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62709,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,4)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62708,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,5)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62707,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,6)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62706,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,7)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62705,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,8)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62704,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,9)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62703,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,10)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62702,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,11)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62701,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,12)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62700,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,13)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62699,axiom,
    ! [VarCurr: state_type] :
      ( v102633(VarCurr,14)
    <=> v102634(VarCurr) ) ).

tff(addAssignment_62698,axiom,
    ! [VarCurr: state_type] :
      ( v102634(VarCurr)
    <=> v102626(VarCurr) ) ).

tff(addAssignment_62697,axiom,
    ! [VarCurr: state_type] :
      ( v102626(VarCurr)
    <=> v102628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9848,axiom,
    ! [VarCurr: state_type] :
      ( v102628(VarCurr)
    <=> ( v102630(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_675,axiom,
    ! [VarCurr: state_type] :
      ( v102630(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $true )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102624(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62695,axiom,
    ! [VarCurr: state_type] :
      ( v102616(VarCurr)
    <=> v102618(VarCurr) ) ).

tff(addAssignment_62694,axiom,
    ! [VarCurr: state_type] :
      ( v102618(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62693,axiom,
    ! [VarCurr: state_type] :
      ( v102612(VarCurr)
    <=> v102614(VarCurr) ) ).

tff(addAssignment_62692,axiom,
    ! [VarCurr: state_type] :
      ( v102614(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5262(VarCurr,B)
      <=> v5264(VarCurr,B) ) ) ).

tff(addAssignment_62690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5264(VarCurr,B)
      <=> v5266(VarCurr,B) ) ) ).

tff(addAssignment_62689,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5266(VarNext,B)
      <=> v102594(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102595(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102594(VarNext,B)
            <=> v5266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1225,axiom,
    ! [VarNext: state_type] :
      ( v102595(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102594(VarNext,B)
          <=> v102605(VarNext,B) ) ) ) ).

tff(addAssignment_62688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102605(VarNext,B)
          <=> v102603(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102606(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102603(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_707,axiom,
    ! [VarCurr: state_type] :
      ( v102606(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102603(VarCurr,B)
          <=> v102570(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9847,axiom,
    ! [VarCurr: state_type] :
      ( v102606(VarCurr)
    <=> ( v102607(VarCurr)
        & v102608(VarCurr) ) ) ).

tff(writeUnaryOperator_5038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102608(VarCurr)
    <=> v102566(VarCurr) ) ).

tff(writeUnaryOperator_5037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102607(VarCurr)
    <=> v102562(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102595(VarNext)
      <=> v102596(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102596(VarNext)
      <=> ( v102597(VarNext)
          & v102590(VarNext) ) ) ) ).

tff(writeUnaryOperator_5036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102597(VarNext)
      <=> v102599(VarNext) ) ) ).

tff(addAssignment_62687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102599(VarNext)
      <=> v102590(VarCurr) ) ) ).

tff(addAssignment_62686,axiom,
    ! [VarCurr: state_type] :
      ( v102590(VarCurr)
    <=> v102592(VarCurr) ) ).

tff(addAssignment_62685,axiom,
    ! [VarCurr: state_type] :
      ( v102592(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102570(VarCurr,B)
      <=> v102572(VarCurr,B) ) ) ).

tff(addAssignment_62683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102572(VarCurr,B)
      <=> v102581(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102581(VarCurr,B)
      <=> ( v102582(VarCurr,B)
          | v102585(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102585(VarCurr,B)
      <=> ( v5264(VarCurr,B)
          & v102586(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102586(VarCurr,B)
      <=> ~ v102587(VarCurr,B) ) ) ).

tff(addAssignment_62682,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,0)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62681,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,1)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62680,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,2)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62679,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,3)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62678,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,4)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62677,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,5)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62676,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,6)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62675,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,7)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62674,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,8)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62673,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,9)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62672,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,10)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62671,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,11)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62670,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,12)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62669,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,13)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62668,axiom,
    ! [VarCurr: state_type] :
      ( v102587(VarCurr,14)
    <=> v102588(VarCurr) ) ).

tff(addAssignment_62667,axiom,
    ! [VarCurr: state_type] :
      ( v102588(VarCurr)
    <=> v102576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102582(VarCurr,B)
      <=> ( v102574(VarCurr,B)
          & v102583(VarCurr,B) ) ) ) ).

tff(addAssignment_62666,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,0)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62665,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,1)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62664,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,2)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62663,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,3)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62662,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,4)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62661,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,5)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62660,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,6)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62659,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,7)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62658,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,8)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62657,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,9)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62656,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,10)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62655,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,11)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62654,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,12)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62653,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,13)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62652,axiom,
    ! [VarCurr: state_type] :
      ( v102583(VarCurr,14)
    <=> v102584(VarCurr) ) ).

tff(addAssignment_62651,axiom,
    ! [VarCurr: state_type] :
      ( v102584(VarCurr)
    <=> v102576(VarCurr) ) ).

tff(addAssignment_62650,axiom,
    ! [VarCurr: state_type] :
      ( v102576(VarCurr)
    <=> v102578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9844,axiom,
    ! [VarCurr: state_type] :
      ( v102578(VarCurr)
    <=> ( v102580(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_674,axiom,
    ! [VarCurr: state_type] :
      ( v102580(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102574(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62648,axiom,
    ! [VarCurr: state_type] :
      ( v102566(VarCurr)
    <=> v102568(VarCurr) ) ).

tff(addAssignment_62647,axiom,
    ! [VarCurr: state_type] :
      ( v102568(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62646,axiom,
    ! [VarCurr: state_type] :
      ( v102562(VarCurr)
    <=> v102564(VarCurr) ) ).

tff(addAssignment_62645,axiom,
    ! [VarCurr: state_type] :
      ( v102564(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5255(VarCurr,B)
      <=> v5257(VarCurr,B) ) ) ).

tff(addAssignment_62643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5257(VarCurr,B)
      <=> v5259(VarCurr,B) ) ) ).

tff(addAssignment_62642,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5259(VarNext,B)
      <=> v102544(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102544(VarNext,B)
            <=> v5259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1224,axiom,
    ! [VarNext: state_type] :
      ( v102545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102544(VarNext,B)
          <=> v102555(VarNext,B) ) ) ) ).

tff(addAssignment_62641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102555(VarNext,B)
          <=> v102553(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102553(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_706,axiom,
    ! [VarCurr: state_type] :
      ( v102556(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102553(VarCurr,B)
          <=> v102520(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9843,axiom,
    ! [VarCurr: state_type] :
      ( v102556(VarCurr)
    <=> ( v102557(VarCurr)
        & v102558(VarCurr) ) ) ).

tff(writeUnaryOperator_5034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102558(VarCurr)
    <=> v102516(VarCurr) ) ).

tff(writeUnaryOperator_5033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102557(VarCurr)
    <=> v102512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102545(VarNext)
      <=> v102546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102546(VarNext)
      <=> ( v102547(VarNext)
          & v102540(VarNext) ) ) ) ).

tff(writeUnaryOperator_5032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102547(VarNext)
      <=> v102549(VarNext) ) ) ).

tff(addAssignment_62640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102549(VarNext)
      <=> v102540(VarCurr) ) ) ).

tff(addAssignment_62639,axiom,
    ! [VarCurr: state_type] :
      ( v102540(VarCurr)
    <=> v102542(VarCurr) ) ).

tff(addAssignment_62638,axiom,
    ! [VarCurr: state_type] :
      ( v102542(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102520(VarCurr,B)
      <=> v102522(VarCurr,B) ) ) ).

tff(addAssignment_62636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102522(VarCurr,B)
      <=> v102531(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102531(VarCurr,B)
      <=> ( v102532(VarCurr,B)
          | v102535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102535(VarCurr,B)
      <=> ( v5257(VarCurr,B)
          & v102536(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102536(VarCurr,B)
      <=> ~ v102537(VarCurr,B) ) ) ).

tff(addAssignment_62635,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,0)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62634,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,1)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62633,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,2)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62632,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,3)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62631,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,4)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62630,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,5)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62629,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,6)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62628,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,7)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62627,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,8)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62626,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,9)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62625,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,10)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62624,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,11)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62623,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,12)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62622,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,13)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62621,axiom,
    ! [VarCurr: state_type] :
      ( v102537(VarCurr,14)
    <=> v102538(VarCurr) ) ).

tff(addAssignment_62620,axiom,
    ! [VarCurr: state_type] :
      ( v102538(VarCurr)
    <=> v102526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102532(VarCurr,B)
      <=> ( v102524(VarCurr,B)
          & v102533(VarCurr,B) ) ) ) ).

tff(addAssignment_62619,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,0)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62618,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,1)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62617,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,2)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62616,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,3)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62615,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,4)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62614,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,5)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62613,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,6)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62612,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,7)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62611,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,8)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62610,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,9)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62609,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,10)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62608,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,11)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62607,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,12)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62606,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,13)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62605,axiom,
    ! [VarCurr: state_type] :
      ( v102533(VarCurr,14)
    <=> v102534(VarCurr) ) ).

tff(addAssignment_62604,axiom,
    ! [VarCurr: state_type] :
      ( v102534(VarCurr)
    <=> v102526(VarCurr) ) ).

tff(addAssignment_62603,axiom,
    ! [VarCurr: state_type] :
      ( v102526(VarCurr)
    <=> v102528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9840,axiom,
    ! [VarCurr: state_type] :
      ( v102528(VarCurr)
    <=> ( v102530(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_673,axiom,
    ! [VarCurr: state_type] :
      ( v102530(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102524(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62601,axiom,
    ! [VarCurr: state_type] :
      ( v102516(VarCurr)
    <=> v102518(VarCurr) ) ).

tff(addAssignment_62600,axiom,
    ! [VarCurr: state_type] :
      ( v102518(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62599,axiom,
    ! [VarCurr: state_type] :
      ( v102512(VarCurr)
    <=> v102514(VarCurr) ) ).

tff(addAssignment_62598,axiom,
    ! [VarCurr: state_type] :
      ( v102514(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5248(VarCurr,B)
      <=> v5250(VarCurr,B) ) ) ).

tff(addAssignment_62596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5250(VarCurr,B)
      <=> v5252(VarCurr,B) ) ) ).

tff(addAssignment_62595,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5252(VarNext,B)
      <=> v102494(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102495(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102494(VarNext,B)
            <=> v5252(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1223,axiom,
    ! [VarNext: state_type] :
      ( v102495(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102494(VarNext,B)
          <=> v102505(VarNext,B) ) ) ) ).

tff(addAssignment_62594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102505(VarNext,B)
          <=> v102503(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102506(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102503(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_705,axiom,
    ! [VarCurr: state_type] :
      ( v102506(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102503(VarCurr,B)
          <=> v102470(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9839,axiom,
    ! [VarCurr: state_type] :
      ( v102506(VarCurr)
    <=> ( v102507(VarCurr)
        & v102508(VarCurr) ) ) ).

tff(writeUnaryOperator_5030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102508(VarCurr)
    <=> v102466(VarCurr) ) ).

tff(writeUnaryOperator_5029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102507(VarCurr)
    <=> v102462(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102495(VarNext)
      <=> v102496(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102496(VarNext)
      <=> ( v102497(VarNext)
          & v102490(VarNext) ) ) ) ).

tff(writeUnaryOperator_5028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102497(VarNext)
      <=> v102499(VarNext) ) ) ).

tff(addAssignment_62593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102499(VarNext)
      <=> v102490(VarCurr) ) ) ).

tff(addAssignment_62592,axiom,
    ! [VarCurr: state_type] :
      ( v102490(VarCurr)
    <=> v102492(VarCurr) ) ).

tff(addAssignment_62591,axiom,
    ! [VarCurr: state_type] :
      ( v102492(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102470(VarCurr,B)
      <=> v102472(VarCurr,B) ) ) ).

tff(addAssignment_62589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102472(VarCurr,B)
      <=> v102481(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102481(VarCurr,B)
      <=> ( v102482(VarCurr,B)
          | v102485(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102485(VarCurr,B)
      <=> ( v5250(VarCurr,B)
          & v102486(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102486(VarCurr,B)
      <=> ~ v102487(VarCurr,B) ) ) ).

tff(addAssignment_62588,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,0)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62587,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,1)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62586,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,2)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62585,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,3)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62584,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,4)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62583,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,5)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62582,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,6)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62581,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,7)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62580,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,8)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62579,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,9)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62578,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,10)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62577,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,11)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62576,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,12)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62575,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,13)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62574,axiom,
    ! [VarCurr: state_type] :
      ( v102487(VarCurr,14)
    <=> v102488(VarCurr) ) ).

tff(addAssignment_62573,axiom,
    ! [VarCurr: state_type] :
      ( v102488(VarCurr)
    <=> v102476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102482(VarCurr,B)
      <=> ( v102474(VarCurr,B)
          & v102483(VarCurr,B) ) ) ) ).

tff(addAssignment_62572,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,0)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62571,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,1)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62570,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,2)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62569,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,3)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62568,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,4)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62567,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,5)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62566,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,6)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62565,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,7)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62564,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,8)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62563,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,9)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62562,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,10)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62561,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,11)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62560,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,12)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62559,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,13)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62558,axiom,
    ! [VarCurr: state_type] :
      ( v102483(VarCurr,14)
    <=> v102484(VarCurr) ) ).

tff(addAssignment_62557,axiom,
    ! [VarCurr: state_type] :
      ( v102484(VarCurr)
    <=> v102476(VarCurr) ) ).

tff(addAssignment_62556,axiom,
    ! [VarCurr: state_type] :
      ( v102476(VarCurr)
    <=> v102478(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9836,axiom,
    ! [VarCurr: state_type] :
      ( v102478(VarCurr)
    <=> ( v102480(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_672,axiom,
    ! [VarCurr: state_type] :
      ( v102480(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102474(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62554,axiom,
    ! [VarCurr: state_type] :
      ( v102466(VarCurr)
    <=> v102468(VarCurr) ) ).

tff(addAssignment_62553,axiom,
    ! [VarCurr: state_type] :
      ( v102468(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62552,axiom,
    ! [VarCurr: state_type] :
      ( v102462(VarCurr)
    <=> v102464(VarCurr) ) ).

tff(addAssignment_62551,axiom,
    ! [VarCurr: state_type] :
      ( v102464(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5241(VarCurr,B)
      <=> v5243(VarCurr,B) ) ) ).

tff(addAssignment_62549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5243(VarCurr,B)
      <=> v5245(VarCurr,B) ) ) ).

tff(addAssignment_62548,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5245(VarNext,B)
      <=> v102444(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102445(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102444(VarNext,B)
            <=> v5245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1222,axiom,
    ! [VarNext: state_type] :
      ( v102445(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102444(VarNext,B)
          <=> v102455(VarNext,B) ) ) ) ).

tff(addAssignment_62547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102455(VarNext,B)
          <=> v102453(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102456(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102453(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_704,axiom,
    ! [VarCurr: state_type] :
      ( v102456(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102453(VarCurr,B)
          <=> v102420(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9835,axiom,
    ! [VarCurr: state_type] :
      ( v102456(VarCurr)
    <=> ( v102457(VarCurr)
        & v102458(VarCurr) ) ) ).

tff(writeUnaryOperator_5026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102458(VarCurr)
    <=> v102416(VarCurr) ) ).

tff(writeUnaryOperator_5025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102457(VarCurr)
    <=> v102412(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102445(VarNext)
      <=> v102446(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102446(VarNext)
      <=> ( v102447(VarNext)
          & v102440(VarNext) ) ) ) ).

tff(writeUnaryOperator_5024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102447(VarNext)
      <=> v102449(VarNext) ) ) ).

tff(addAssignment_62546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102449(VarNext)
      <=> v102440(VarCurr) ) ) ).

tff(addAssignment_62545,axiom,
    ! [VarCurr: state_type] :
      ( v102440(VarCurr)
    <=> v102442(VarCurr) ) ).

tff(addAssignment_62544,axiom,
    ! [VarCurr: state_type] :
      ( v102442(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102420(VarCurr,B)
      <=> v102422(VarCurr,B) ) ) ).

tff(addAssignment_62542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102422(VarCurr,B)
      <=> v102431(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102431(VarCurr,B)
      <=> ( v102432(VarCurr,B)
          | v102435(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102435(VarCurr,B)
      <=> ( v5243(VarCurr,B)
          & v102436(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102436(VarCurr,B)
      <=> ~ v102437(VarCurr,B) ) ) ).

tff(addAssignment_62541,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,0)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62540,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,1)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62539,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,2)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62538,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,3)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62537,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,4)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62536,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,5)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62535,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,6)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62534,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,7)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62533,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,8)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62532,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,9)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62531,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,10)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62530,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,11)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62529,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,12)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62528,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,13)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62527,axiom,
    ! [VarCurr: state_type] :
      ( v102437(VarCurr,14)
    <=> v102438(VarCurr) ) ).

tff(addAssignment_62526,axiom,
    ! [VarCurr: state_type] :
      ( v102438(VarCurr)
    <=> v102426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102432(VarCurr,B)
      <=> ( v102424(VarCurr,B)
          & v102433(VarCurr,B) ) ) ) ).

tff(addAssignment_62525,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,0)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62524,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,1)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62523,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,2)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62522,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,3)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62521,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,4)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62520,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,5)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62519,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,6)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62518,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,7)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62517,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,8)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62516,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,9)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62515,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,10)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62514,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,11)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62513,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,12)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62512,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,13)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62511,axiom,
    ! [VarCurr: state_type] :
      ( v102433(VarCurr,14)
    <=> v102434(VarCurr) ) ).

tff(addAssignment_62510,axiom,
    ! [VarCurr: state_type] :
      ( v102434(VarCurr)
    <=> v102426(VarCurr) ) ).

tff(addAssignment_62509,axiom,
    ! [VarCurr: state_type] :
      ( v102426(VarCurr)
    <=> v102428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9832,axiom,
    ! [VarCurr: state_type] :
      ( v102428(VarCurr)
    <=> ( v102430(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_671,axiom,
    ! [VarCurr: state_type] :
      ( v102430(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $true )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102424(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62507,axiom,
    ! [VarCurr: state_type] :
      ( v102416(VarCurr)
    <=> v102418(VarCurr) ) ).

tff(addAssignment_62506,axiom,
    ! [VarCurr: state_type] :
      ( v102418(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62505,axiom,
    ! [VarCurr: state_type] :
      ( v102412(VarCurr)
    <=> v102414(VarCurr) ) ).

tff(addAssignment_62504,axiom,
    ! [VarCurr: state_type] :
      ( v102414(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5234(VarCurr,B)
      <=> v5236(VarCurr,B) ) ) ).

tff(addAssignment_62502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5236(VarCurr,B)
      <=> v5238(VarCurr,B) ) ) ).

tff(addAssignment_62501,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5238(VarNext,B)
      <=> v102394(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102395(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102394(VarNext,B)
            <=> v5238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1221,axiom,
    ! [VarNext: state_type] :
      ( v102395(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102394(VarNext,B)
          <=> v102405(VarNext,B) ) ) ) ).

tff(addAssignment_62500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102405(VarNext,B)
          <=> v102403(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102406(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102403(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_703,axiom,
    ! [VarCurr: state_type] :
      ( v102406(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102403(VarCurr,B)
          <=> v102370(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9831,axiom,
    ! [VarCurr: state_type] :
      ( v102406(VarCurr)
    <=> ( v102407(VarCurr)
        & v102408(VarCurr) ) ) ).

tff(writeUnaryOperator_5022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102408(VarCurr)
    <=> v102366(VarCurr) ) ).

tff(writeUnaryOperator_5021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102407(VarCurr)
    <=> v102362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102395(VarNext)
      <=> v102396(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102396(VarNext)
      <=> ( v102397(VarNext)
          & v102390(VarNext) ) ) ) ).

tff(writeUnaryOperator_5020,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102397(VarNext)
      <=> v102399(VarNext) ) ) ).

tff(addAssignment_62499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102399(VarNext)
      <=> v102390(VarCurr) ) ) ).

tff(addAssignment_62498,axiom,
    ! [VarCurr: state_type] :
      ( v102390(VarCurr)
    <=> v102392(VarCurr) ) ).

tff(addAssignment_62497,axiom,
    ! [VarCurr: state_type] :
      ( v102392(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102370(VarCurr,B)
      <=> v102372(VarCurr,B) ) ) ).

tff(addAssignment_62495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102372(VarCurr,B)
      <=> v102381(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102381(VarCurr,B)
      <=> ( v102382(VarCurr,B)
          | v102385(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102385(VarCurr,B)
      <=> ( v5236(VarCurr,B)
          & v102386(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102386(VarCurr,B)
      <=> ~ v102387(VarCurr,B) ) ) ).

tff(addAssignment_62494,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,0)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62493,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,1)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62492,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,2)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62491,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,3)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62490,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,4)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62489,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,5)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62488,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,6)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62487,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,7)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62486,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,8)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62485,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,9)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62484,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,10)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62483,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,11)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62482,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,12)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62481,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,13)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62480,axiom,
    ! [VarCurr: state_type] :
      ( v102387(VarCurr,14)
    <=> v102388(VarCurr) ) ).

tff(addAssignment_62479,axiom,
    ! [VarCurr: state_type] :
      ( v102388(VarCurr)
    <=> v102376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102382(VarCurr,B)
      <=> ( v102374(VarCurr,B)
          & v102383(VarCurr,B) ) ) ) ).

tff(addAssignment_62478,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,0)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62477,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,1)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62476,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,2)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62475,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,3)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62474,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,4)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62473,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,5)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62472,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,6)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62471,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,7)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62470,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,8)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62469,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,9)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62468,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,10)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62467,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,11)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62466,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,12)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62465,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,13)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62464,axiom,
    ! [VarCurr: state_type] :
      ( v102383(VarCurr,14)
    <=> v102384(VarCurr) ) ).

tff(addAssignment_62463,axiom,
    ! [VarCurr: state_type] :
      ( v102384(VarCurr)
    <=> v102376(VarCurr) ) ).

tff(addAssignment_62462,axiom,
    ! [VarCurr: state_type] :
      ( v102376(VarCurr)
    <=> v102378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9828,axiom,
    ! [VarCurr: state_type] :
      ( v102378(VarCurr)
    <=> ( v102380(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_670,axiom,
    ! [VarCurr: state_type] :
      ( v102380(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102374(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62460,axiom,
    ! [VarCurr: state_type] :
      ( v102366(VarCurr)
    <=> v102368(VarCurr) ) ).

tff(addAssignment_62459,axiom,
    ! [VarCurr: state_type] :
      ( v102368(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62458,axiom,
    ! [VarCurr: state_type] :
      ( v102362(VarCurr)
    <=> v102364(VarCurr) ) ).

tff(addAssignment_62457,axiom,
    ! [VarCurr: state_type] :
      ( v102364(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5227(VarCurr,B)
      <=> v5229(VarCurr,B) ) ) ).

tff(addAssignment_62455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5229(VarCurr,B)
      <=> v5231(VarCurr,B) ) ) ).

tff(addAssignment_62454,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5231(VarNext,B)
      <=> v102344(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102345(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102344(VarNext,B)
            <=> v5231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1220,axiom,
    ! [VarNext: state_type] :
      ( v102345(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102344(VarNext,B)
          <=> v102355(VarNext,B) ) ) ) ).

tff(addAssignment_62453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102355(VarNext,B)
          <=> v102353(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102356(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102353(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_702,axiom,
    ! [VarCurr: state_type] :
      ( v102356(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102353(VarCurr,B)
          <=> v102320(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9827,axiom,
    ! [VarCurr: state_type] :
      ( v102356(VarCurr)
    <=> ( v102357(VarCurr)
        & v102358(VarCurr) ) ) ).

tff(writeUnaryOperator_5018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102358(VarCurr)
    <=> v102316(VarCurr) ) ).

tff(writeUnaryOperator_5017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102357(VarCurr)
    <=> v102312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102345(VarNext)
      <=> v102346(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102346(VarNext)
      <=> ( v102347(VarNext)
          & v102340(VarNext) ) ) ) ).

tff(writeUnaryOperator_5016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102347(VarNext)
      <=> v102349(VarNext) ) ) ).

tff(addAssignment_62452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102349(VarNext)
      <=> v102340(VarCurr) ) ) ).

tff(addAssignment_62451,axiom,
    ! [VarCurr: state_type] :
      ( v102340(VarCurr)
    <=> v102342(VarCurr) ) ).

tff(addAssignment_62450,axiom,
    ! [VarCurr: state_type] :
      ( v102342(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102320(VarCurr,B)
      <=> v102322(VarCurr,B) ) ) ).

tff(addAssignment_62448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102322(VarCurr,B)
      <=> v102331(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102331(VarCurr,B)
      <=> ( v102332(VarCurr,B)
          | v102335(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102335(VarCurr,B)
      <=> ( v5229(VarCurr,B)
          & v102336(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102336(VarCurr,B)
      <=> ~ v102337(VarCurr,B) ) ) ).

tff(addAssignment_62447,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,0)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62446,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,1)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62445,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,2)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62444,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,3)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62443,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,4)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62442,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,5)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62441,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,6)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62440,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,7)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62439,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,8)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62438,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,9)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62437,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,10)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62436,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,11)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62435,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,12)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62434,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,13)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62433,axiom,
    ! [VarCurr: state_type] :
      ( v102337(VarCurr,14)
    <=> v102338(VarCurr) ) ).

tff(addAssignment_62432,axiom,
    ! [VarCurr: state_type] :
      ( v102338(VarCurr)
    <=> v102326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102332(VarCurr,B)
      <=> ( v102324(VarCurr,B)
          & v102333(VarCurr,B) ) ) ) ).

tff(addAssignment_62431,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,0)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62430,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,1)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62429,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,2)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62428,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,3)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62427,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,4)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62426,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,5)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62425,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,6)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62424,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,7)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62423,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,8)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62422,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,9)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62421,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,10)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62420,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,11)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62419,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,12)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62418,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,13)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62417,axiom,
    ! [VarCurr: state_type] :
      ( v102333(VarCurr,14)
    <=> v102334(VarCurr) ) ).

tff(addAssignment_62416,axiom,
    ! [VarCurr: state_type] :
      ( v102334(VarCurr)
    <=> v102326(VarCurr) ) ).

tff(addAssignment_62415,axiom,
    ! [VarCurr: state_type] :
      ( v102326(VarCurr)
    <=> v102328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9824,axiom,
    ! [VarCurr: state_type] :
      ( v102328(VarCurr)
    <=> ( v102330(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_669,axiom,
    ! [VarCurr: state_type] :
      ( v102330(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $true )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102324(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62413,axiom,
    ! [VarCurr: state_type] :
      ( v102316(VarCurr)
    <=> v102318(VarCurr) ) ).

tff(addAssignment_62412,axiom,
    ! [VarCurr: state_type] :
      ( v102318(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62411,axiom,
    ! [VarCurr: state_type] :
      ( v102312(VarCurr)
    <=> v102314(VarCurr) ) ).

tff(addAssignment_62410,axiom,
    ! [VarCurr: state_type] :
      ( v102314(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5220(VarCurr,B)
      <=> v5222(VarCurr,B) ) ) ).

tff(addAssignment_62408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5222(VarCurr,B)
      <=> v5224(VarCurr,B) ) ) ).

tff(addAssignment_62407,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v5224(VarNext,B)
      <=> v102294(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102295(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102294(VarNext,B)
            <=> v5224(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1219,axiom,
    ! [VarNext: state_type] :
      ( v102295(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102294(VarNext,B)
          <=> v102305(VarNext,B) ) ) ) ).

tff(addAssignment_62406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102305(VarNext,B)
          <=> v102303(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102306(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102303(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_701,axiom,
    ! [VarCurr: state_type] :
      ( v102306(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102303(VarCurr,B)
          <=> v102270(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9823,axiom,
    ! [VarCurr: state_type] :
      ( v102306(VarCurr)
    <=> ( v102307(VarCurr)
        & v102308(VarCurr) ) ) ).

tff(writeUnaryOperator_5014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102308(VarCurr)
    <=> v102266(VarCurr) ) ).

tff(writeUnaryOperator_5013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102307(VarCurr)
    <=> v102262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102295(VarNext)
      <=> v102296(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102296(VarNext)
      <=> ( v102297(VarNext)
          & v102290(VarNext) ) ) ) ).

tff(writeUnaryOperator_5012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102297(VarNext)
      <=> v102299(VarNext) ) ) ).

tff(addAssignment_62405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102299(VarNext)
      <=> v102290(VarCurr) ) ) ).

tff(addAssignment_62404,axiom,
    ! [VarCurr: state_type] :
      ( v102290(VarCurr)
    <=> v102292(VarCurr) ) ).

tff(addAssignment_62403,axiom,
    ! [VarCurr: state_type] :
      ( v102292(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102270(VarCurr,B)
      <=> v102272(VarCurr,B) ) ) ).

tff(addAssignment_62401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102272(VarCurr,B)
      <=> v102281(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102281(VarCurr,B)
      <=> ( v102282(VarCurr,B)
          | v102285(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102285(VarCurr,B)
      <=> ( v5222(VarCurr,B)
          & v102286(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102286(VarCurr,B)
      <=> ~ v102287(VarCurr,B) ) ) ).

tff(addAssignment_62400,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,0)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62399,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,1)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62398,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,2)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62397,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,3)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62396,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,4)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62395,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,5)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62394,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,6)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62393,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,7)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62392,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,8)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62391,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,9)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62390,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,10)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62389,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,11)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62388,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,12)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62387,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,13)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62386,axiom,
    ! [VarCurr: state_type] :
      ( v102287(VarCurr,14)
    <=> v102288(VarCurr) ) ).

tff(addAssignment_62385,axiom,
    ! [VarCurr: state_type] :
      ( v102288(VarCurr)
    <=> v102276(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102282(VarCurr,B)
      <=> ( v102274(VarCurr,B)
          & v102283(VarCurr,B) ) ) ) ).

tff(addAssignment_62384,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,0)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62383,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,1)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62382,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,2)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62381,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,3)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62380,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,4)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62379,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,5)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62378,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,6)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62377,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,7)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62376,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,8)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62375,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,9)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62374,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,10)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62373,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,11)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62372,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,12)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62371,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,13)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62370,axiom,
    ! [VarCurr: state_type] :
      ( v102283(VarCurr,14)
    <=> v102284(VarCurr) ) ).

tff(addAssignment_62369,axiom,
    ! [VarCurr: state_type] :
      ( v102284(VarCurr)
    <=> v102276(VarCurr) ) ).

tff(addAssignment_62368,axiom,
    ! [VarCurr: state_type] :
      ( v102276(VarCurr)
    <=> v102278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9820,axiom,
    ! [VarCurr: state_type] :
      ( v102278(VarCurr)
    <=> ( v102280(VarCurr)
        & v5745(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_668,axiom,
    ! [VarCurr: state_type] :
      ( v102280(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $false )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v102274(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62366,axiom,
    ! [VarCurr: state_type] :
      ( v102266(VarCurr)
    <=> v102268(VarCurr) ) ).

tff(addAssignment_62365,axiom,
    ! [VarCurr: state_type] :
      ( v102268(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_62364,axiom,
    ! [VarCurr: state_type] :
      ( v102262(VarCurr)
    <=> v102264(VarCurr) ) ).

tff(addAssignment_62363,axiom,
    ! [VarCurr: state_type] :
      ( v102264(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_62362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v884(VarCurr,B)
      <=> v886(VarCurr,B) ) ) ).

tff(addAssignment_62361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v886(VarCurr,B)
      <=> v888(VarCurr,B) ) ) ).

tff(addAssignment_62360,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v888(VarNext,B)
      <=> v102244(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102245(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v102244(VarNext,B)
            <=> v888(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1218,axiom,
    ! [VarNext: state_type] :
      ( v102245(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102244(VarNext,B)
          <=> v102255(VarNext,B) ) ) ) ).

tff(addAssignment_62359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102255(VarNext,B)
          <=> v102253(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102256(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102253(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_700,axiom,
    ! [VarCurr: state_type] :
      ( v102256(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v102253(VarCurr,B)
          <=> v898(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9819,axiom,
    ! [VarCurr: state_type] :
      ( v102256(VarCurr)
    <=> ( v102257(VarCurr)
        & v102258(VarCurr) ) ) ).

tff(writeUnaryOperator_5010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102258(VarCurr)
    <=> v894(VarCurr) ) ).

tff(writeUnaryOperator_5009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102257(VarCurr)
    <=> v890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102245(VarNext)
      <=> v102246(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102246(VarNext)
      <=> ( v102247(VarNext)
          & v102240(VarNext) ) ) ) ).

tff(writeUnaryOperator_5008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102247(VarNext)
      <=> v102249(VarNext) ) ) ).

tff(addAssignment_62358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102249(VarNext)
      <=> v102240(VarCurr) ) ) ).

tff(addAssignment_62357,axiom,
    ! [VarCurr: state_type] :
      ( v102240(VarCurr)
    <=> v102242(VarCurr) ) ).

tff(addAssignment_62356,axiom,
    ! [VarCurr: state_type] :
      ( v102242(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_62355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v898(VarCurr,B)
      <=> v900(VarCurr,B) ) ) ).

tff(addAssignment_62354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v900(VarCurr,B)
      <=> v102231(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102231(VarCurr,B)
      <=> ( v102232(VarCurr,B)
          | v102235(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102235(VarCurr,B)
      <=> ( v886(VarCurr,B)
          & v102236(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_5007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102236(VarCurr,B)
      <=> ~ v102237(VarCurr,B) ) ) ).

tff(addAssignment_62353,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,0)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62352,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,1)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62351,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,2)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62350,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,3)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62349,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,4)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62348,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,5)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62347,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,6)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62346,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,7)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62345,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,8)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62344,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,9)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62343,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,10)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62342,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,11)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62341,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,12)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62340,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,13)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62339,axiom,
    ! [VarCurr: state_type] :
      ( v102237(VarCurr,14)
    <=> v102238(VarCurr) ) ).

tff(addAssignment_62338,axiom,
    ! [VarCurr: state_type] :
      ( v102238(VarCurr)
    <=> v5687(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v102232(VarCurr,B)
      <=> ( v902(VarCurr,B)
          & v102233(VarCurr,B) ) ) ) ).

tff(addAssignment_62337,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,0)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62336,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,1)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62335,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,2)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62334,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,3)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62333,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,4)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62332,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,5)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62331,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,6)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62330,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,7)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62329,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,8)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62328,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,9)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62327,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,10)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62326,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,11)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62325,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,12)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62324,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,13)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62323,axiom,
    ! [VarCurr: state_type] :
      ( v102233(VarCurr,14)
    <=> v102234(VarCurr) ) ).

tff(addAssignment_62322,axiom,
    ! [VarCurr: state_type] :
      ( v102234(VarCurr)
    <=> v5687(VarCurr) ) ).

tff(addAssignment_62321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v902(VarCurr,B)
      <=> v904(VarCurr,B) ) ) ).

tff(addAssignment_62320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v904(VarCurr,B)
      <=> v906(VarCurr,B) ) ) ).

tff(addAssignment_62319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v906(VarCurr,B)
      <=> v908(VarCurr,B) ) ) ).

tff(addAssignment_62318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,10) )
     => ( v908(VarCurr,B)
      <=> v910(VarCurr,B) ) ) ).

tff(addAssignment_62317,axiom,
    ! [VarCurr: state_type] :
      ( ( v910(VarCurr,12)
      <=> v912(VarCurr,11) )
      & ( v910(VarCurr,11)
      <=> v912(VarCurr,10) )
      & ( v910(VarCurr,10)
      <=> v912(VarCurr,9) ) ) ).

tff(addAssignment_62316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v912(VarCurr,B)
      <=> v914(VarCurr,B) ) ) ).

tff(addAssignment_62315,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v914(VarNext,B)
      <=> v102224(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102225(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v102224(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1217,axiom,
    ! [VarNext: state_type] :
      ( v102225(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v102224(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102225(VarNext)
      <=> v102226(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102226(VarNext)
      <=> ( v102228(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_5006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102228(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_62314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v932(VarCurr,B)
      <=> v934(VarCurr,B) ) ) ).

tff(addAssignment_62313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v934(VarCurr,B)
      <=> v5598(VarCurr,B) ) ) ).

tff(addAssignment_62312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v936(VarCurr,B)
      <=> v938(VarCurr,B) ) ) ).

tff(addAssignment_62311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,9) )
     => ( v938(VarCurr,B)
      <=> v5589(VarCurr,B) ) ) ).

tff(addAssignment_62310,axiom,
    ! [VarCurr: state_type] :
      ( ( v5591(VarCurr,2)
      <=> v964(VarCurr,16) )
      & ( v5591(VarCurr,1)
      <=> v964(VarCurr,15) )
      & ( v5591(VarCurr,0)
      <=> v964(VarCurr,14) ) ) ).

tff(addAssignment_62309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v964(VarCurr,B)
      <=> v966(VarCurr,B) ) ) ).

tff(addAssignment_62308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v966(VarCurr,B)
      <=> v5526(VarCurr,B) ) ) ).

tff(addAssignment_62307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5521(VarCurr,B)
      <=> v5523(VarCurr,B) ) ) ).

tff(addAssignment_62306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5523(VarCurr,B)
      <=> v5525(VarCurr,B) ) ) ).

tff(addAssignment_62305,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5525(VarNext,B)
      <=> v102216(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102217(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102216(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1216,axiom,
    ! [VarNext: state_type] :
      ( v102217(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102216(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102217(VarNext)
      <=> v102218(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102218(VarNext)
      <=> ( v102220(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_5005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102220(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_62304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83988(VarCurr,B)
      <=> v83990(VarCurr,B) ) ) ).

tff(addAssignment_62303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83990(VarCurr,B)
      <=> v83999(VarCurr,B) ) ) ).

tff(addAssignment_62302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83992(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5514(VarCurr,B)
      <=> v5516(VarCurr,B) ) ) ).

tff(addAssignment_62300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5516(VarCurr,B)
      <=> v5518(VarCurr,B) ) ) ).

tff(addAssignment_62299,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5518(VarNext,B)
      <=> v102208(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102209(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102208(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1215,axiom,
    ! [VarNext: state_type] :
      ( v102209(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102208(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102209(VarNext)
      <=> v102210(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102210(VarNext)
      <=> ( v102212(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_5004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102212(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_62298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83938(VarCurr,B)
      <=> v83940(VarCurr,B) ) ) ).

tff(addAssignment_62297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83940(VarCurr,B)
      <=> v83949(VarCurr,B) ) ) ).

tff(addAssignment_62296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83942(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5507(VarCurr,B)
      <=> v5509(VarCurr,B) ) ) ).

tff(addAssignment_62294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5509(VarCurr,B)
      <=> v5511(VarCurr,B) ) ) ).

tff(addAssignment_62293,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5511(VarNext,B)
      <=> v102200(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102201(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102200(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1214,axiom,
    ! [VarNext: state_type] :
      ( v102201(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102200(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102201(VarNext)
      <=> v102202(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102202(VarNext)
      <=> ( v102204(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_5003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102204(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_62292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83888(VarCurr,B)
      <=> v83890(VarCurr,B) ) ) ).

tff(addAssignment_62291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83890(VarCurr,B)
      <=> v83899(VarCurr,B) ) ) ).

tff(addAssignment_62290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83892(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5500(VarCurr,B)
      <=> v5502(VarCurr,B) ) ) ).

tff(addAssignment_62288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5502(VarCurr,B)
      <=> v5504(VarCurr,B) ) ) ).

tff(addAssignment_62287,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5504(VarNext,B)
      <=> v102192(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102193(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102192(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1213,axiom,
    ! [VarNext: state_type] :
      ( v102193(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102192(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102193(VarNext)
      <=> v102194(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102194(VarNext)
      <=> ( v102196(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_5002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102196(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_62286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83838(VarCurr,B)
      <=> v83840(VarCurr,B) ) ) ).

tff(addAssignment_62285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83840(VarCurr,B)
      <=> v83849(VarCurr,B) ) ) ).

tff(addAssignment_62284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83842(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5493(VarCurr,B)
      <=> v5495(VarCurr,B) ) ) ).

tff(addAssignment_62282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5495(VarCurr,B)
      <=> v5497(VarCurr,B) ) ) ).

tff(addAssignment_62281,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5497(VarNext,B)
      <=> v102184(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102185(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102184(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1212,axiom,
    ! [VarNext: state_type] :
      ( v102185(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102184(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102185(VarNext)
      <=> v102186(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102186(VarNext)
      <=> ( v102188(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_5001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102188(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_62280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83788(VarCurr,B)
      <=> v83790(VarCurr,B) ) ) ).

tff(addAssignment_62279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83790(VarCurr,B)
      <=> v83799(VarCurr,B) ) ) ).

tff(addAssignment_62278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83792(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5487(VarCurr,B)
      <=> v5489(VarCurr,B) ) ) ).

tff(addAssignment_62276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5489(VarCurr,B)
      <=> v5491(VarCurr,B) ) ) ).

tff(addAssignment_62275,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5491(VarNext,B)
      <=> v102176(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102177(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102176(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1211,axiom,
    ! [VarNext: state_type] :
      ( v102177(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102176(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102177(VarNext)
      <=> v102178(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102178(VarNext)
      <=> ( v102180(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_5000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102180(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_62274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83738(VarCurr,B)
      <=> v83740(VarCurr,B) ) ) ).

tff(addAssignment_62273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83740(VarCurr,B)
      <=> v83749(VarCurr,B) ) ) ).

tff(addAssignment_62272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83742(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5480(VarCurr,B)
      <=> v5482(VarCurr,B) ) ) ).

tff(addAssignment_62270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5482(VarCurr,B)
      <=> v5484(VarCurr,B) ) ) ).

tff(addAssignment_62269,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5484(VarNext,B)
      <=> v102168(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102169(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102168(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1210,axiom,
    ! [VarNext: state_type] :
      ( v102169(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102168(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102169(VarNext)
      <=> v102170(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102170(VarNext)
      <=> ( v102172(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_4999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102172(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_62268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83688(VarCurr,B)
      <=> v83690(VarCurr,B) ) ) ).

tff(addAssignment_62267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83690(VarCurr,B)
      <=> v83699(VarCurr,B) ) ) ).

tff(addAssignment_62266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83692(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5473(VarCurr,B)
      <=> v5475(VarCurr,B) ) ) ).

tff(addAssignment_62264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5475(VarCurr,B)
      <=> v5477(VarCurr,B) ) ) ).

tff(addAssignment_62263,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5477(VarNext,B)
      <=> v102160(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102161(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102160(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1209,axiom,
    ! [VarNext: state_type] :
      ( v102161(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102160(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102161(VarNext)
      <=> v102162(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102162(VarNext)
      <=> ( v102164(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_4998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102164(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_62262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83638(VarCurr,B)
      <=> v83640(VarCurr,B) ) ) ).

tff(addAssignment_62261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83640(VarCurr,B)
      <=> v83649(VarCurr,B) ) ) ).

tff(addAssignment_62260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83642(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5466(VarCurr,B)
      <=> v5468(VarCurr,B) ) ) ).

tff(addAssignment_62258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5468(VarCurr,B)
      <=> v5470(VarCurr,B) ) ) ).

tff(addAssignment_62257,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5470(VarNext,B)
      <=> v102152(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102153(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102152(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1208,axiom,
    ! [VarNext: state_type] :
      ( v102153(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102152(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102153(VarNext)
      <=> v102154(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102154(VarNext)
      <=> ( v102156(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_4997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102156(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_62256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83588(VarCurr,B)
      <=> v83590(VarCurr,B) ) ) ).

tff(addAssignment_62255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83590(VarCurr,B)
      <=> v83599(VarCurr,B) ) ) ).

tff(addAssignment_62254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83592(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5459(VarCurr,B)
      <=> v5461(VarCurr,B) ) ) ).

tff(addAssignment_62252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5461(VarCurr,B)
      <=> v5463(VarCurr,B) ) ) ).

tff(addAssignment_62251,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5463(VarNext,B)
      <=> v102144(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102145(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102144(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1207,axiom,
    ! [VarNext: state_type] :
      ( v102145(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102144(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102145(VarNext)
      <=> v102146(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102146(VarNext)
      <=> ( v102148(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_4996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102148(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_62250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83538(VarCurr,B)
      <=> v83540(VarCurr,B) ) ) ).

tff(addAssignment_62249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83540(VarCurr,B)
      <=> v83549(VarCurr,B) ) ) ).

tff(addAssignment_62248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83542(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5452(VarCurr,B)
      <=> v5454(VarCurr,B) ) ) ).

tff(addAssignment_62246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5454(VarCurr,B)
      <=> v5456(VarCurr,B) ) ) ).

tff(addAssignment_62245,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5456(VarNext,B)
      <=> v102136(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102137(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102136(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1206,axiom,
    ! [VarNext: state_type] :
      ( v102137(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102136(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102137(VarNext)
      <=> v102138(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102138(VarNext)
      <=> ( v102140(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_4995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102140(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_62244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83488(VarCurr,B)
      <=> v83490(VarCurr,B) ) ) ).

tff(addAssignment_62243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83490(VarCurr,B)
      <=> v83499(VarCurr,B) ) ) ).

tff(addAssignment_62242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83492(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5445(VarCurr,B)
      <=> v5447(VarCurr,B) ) ) ).

tff(addAssignment_62240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5447(VarCurr,B)
      <=> v5449(VarCurr,B) ) ) ).

tff(addAssignment_62239,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5449(VarNext,B)
      <=> v102128(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102129(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102128(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1205,axiom,
    ! [VarNext: state_type] :
      ( v102129(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102128(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102129(VarNext)
      <=> v102130(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102130(VarNext)
      <=> ( v102132(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_4994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102132(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_62238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83438(VarCurr,B)
      <=> v83440(VarCurr,B) ) ) ).

tff(addAssignment_62237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83440(VarCurr,B)
      <=> v83449(VarCurr,B) ) ) ).

tff(addAssignment_62236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83442(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5438(VarCurr,B)
      <=> v5440(VarCurr,B) ) ) ).

tff(addAssignment_62234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5440(VarCurr,B)
      <=> v5442(VarCurr,B) ) ) ).

tff(addAssignment_62233,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5442(VarNext,B)
      <=> v102120(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102121(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102120(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1204,axiom,
    ! [VarNext: state_type] :
      ( v102121(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102120(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102121(VarNext)
      <=> v102122(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102122(VarNext)
      <=> ( v102124(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_4993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102124(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_62232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83388(VarCurr,B)
      <=> v83390(VarCurr,B) ) ) ).

tff(addAssignment_62231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83390(VarCurr,B)
      <=> v83399(VarCurr,B) ) ) ).

tff(addAssignment_62230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83392(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5431(VarCurr,B)
      <=> v5433(VarCurr,B) ) ) ).

tff(addAssignment_62228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5433(VarCurr,B)
      <=> v5435(VarCurr,B) ) ) ).

tff(addAssignment_62227,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5435(VarNext,B)
      <=> v102112(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102113(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102112(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1203,axiom,
    ! [VarNext: state_type] :
      ( v102113(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102112(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102113(VarNext)
      <=> v102114(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102114(VarNext)
      <=> ( v102116(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_4992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102116(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_62226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83338(VarCurr,B)
      <=> v83340(VarCurr,B) ) ) ).

tff(addAssignment_62225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83340(VarCurr,B)
      <=> v83349(VarCurr,B) ) ) ).

tff(addAssignment_62224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83342(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5424(VarCurr,B)
      <=> v5426(VarCurr,B) ) ) ).

tff(addAssignment_62222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5426(VarCurr,B)
      <=> v5428(VarCurr,B) ) ) ).

tff(addAssignment_62221,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5428(VarNext,B)
      <=> v102104(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102105(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102104(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1202,axiom,
    ! [VarNext: state_type] :
      ( v102105(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102104(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102105(VarNext)
      <=> v102106(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102106(VarNext)
      <=> ( v102108(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_4991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102108(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_62220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83288(VarCurr,B)
      <=> v83290(VarCurr,B) ) ) ).

tff(addAssignment_62219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83290(VarCurr,B)
      <=> v83299(VarCurr,B) ) ) ).

tff(addAssignment_62218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v83292(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5418(VarCurr,B)
      <=> v5420(VarCurr,B) ) ) ).

tff(addAssignment_62216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5420(VarCurr,B)
      <=> v5422(VarCurr,B) ) ) ).

tff(addAssignment_62215,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v5422(VarNext,B)
      <=> v102096(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102097(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v102096(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1201,axiom,
    ! [VarNext: state_type] :
      ( v102097(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v102096(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102097(VarNext)
      <=> v102098(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102098(VarNext)
      <=> ( v102100(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_4990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102100(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_62214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82920(VarCurr,B)
      <=> v82922(VarCurr,B) ) ) ).

tff(addAssignment_62213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82922(VarCurr,B)
      <=> v83246(VarCurr,B) ) ) ).

tff(addAssignment_62212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82924(VarCurr,B)
      <=> v82926(VarCurr,B) ) ) ).

tff(addAssignment_62211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82926(VarCurr,B)
      <=> v82928(VarCurr,B) ) ) ).

tff(addAssignment_62210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82928(VarCurr,B)
      <=> v82930(VarCurr,B) ) ) ).

tff(addAssignment_62209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82930(VarCurr,B)
      <=> v82932(VarCurr,B) ) ) ).

tff(addAssignment_62208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v82932(VarCurr,B)
      <=> v83008(VarCurr,B) ) ) ).

tff(addAssignment_62207,axiom,
    ! [VarCurr: state_type] :
      ( ( v83013(VarCurr,2)
      <=> v101574(VarCurr,5) )
      & ( v83013(VarCurr,1)
      <=> v101574(VarCurr,4) )
      & ( v83013(VarCurr,0)
      <=> v101574(VarCurr,3) ) ) ).

tff(addAssignment_62206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101574(VarCurr,B)
      <=> v101576(VarCurr,B) ) ) ).

tff(addAssignment_62205,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101576(VarNext,B)
      <=> v102078(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102079(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v102078(VarNext,B)
            <=> v101576(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1200,axiom,
    ! [VarNext: state_type] :
      ( v102079(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v102078(VarNext,B)
          <=> v102089(VarNext,B) ) ) ) ).

tff(addAssignment_62204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v102089(VarNext,B)
          <=> v102087(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v102087(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_699,axiom,
    ! [VarCurr: state_type] :
      ( v102090(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v102087(VarCurr,B)
          <=> v101586(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9782,axiom,
    ! [VarCurr: state_type] :
      ( v102090(VarCurr)
    <=> ( v102091(VarCurr)
        & v102092(VarCurr) ) ) ).

tff(writeUnaryOperator_4989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102092(VarCurr)
    <=> v101582(VarCurr) ) ).

tff(writeUnaryOperator_4988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102091(VarCurr)
    <=> v101578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102079(VarNext)
      <=> v102080(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102080(VarNext)
      <=> ( v102081(VarNext)
          & v102074(VarNext) ) ) ) ).

tff(writeUnaryOperator_4987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102081(VarNext)
      <=> v102083(VarNext) ) ) ).

tff(addAssignment_62203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102083(VarNext)
      <=> v102074(VarCurr) ) ) ).

tff(addAssignment_62202,axiom,
    ! [VarCurr: state_type] :
      ( v102074(VarCurr)
    <=> v102076(VarCurr) ) ).

tff(addAssignment_62201,axiom,
    ! [VarCurr: state_type] :
      ( v102076(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_62200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101586(VarCurr,B)
      <=> v101588(VarCurr,B) ) ) ).

tff(addAssignment_62199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101588(VarCurr,B)
      <=> v102065(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v102065(VarCurr,B)
      <=> ( v102066(VarCurr,B)
          | v102069(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v102069(VarCurr,B)
      <=> ( v101574(VarCurr,B)
          & v102070(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v102070(VarCurr,B)
      <=> ~ v102071(VarCurr,B) ) ) ).

tff(addAssignment_62198,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,0)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62197,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,1)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62196,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,2)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62195,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,3)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62194,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,4)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62193,axiom,
    ! [VarCurr: state_type] :
      ( v102071(VarCurr,5)
    <=> v102072(VarCurr) ) ).

tff(addAssignment_62192,axiom,
    ! [VarCurr: state_type] :
      ( v102072(VarCurr)
    <=> v102064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v102066(VarCurr,B)
      <=> ( v101590(VarCurr,B)
          & v102067(VarCurr,B) ) ) ) ).

tff(addAssignment_62191,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,0)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62190,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,1)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62189,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,2)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62188,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,3)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62187,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,4)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62186,axiom,
    ! [VarCurr: state_type] :
      ( v102067(VarCurr,5)
    <=> v102068(VarCurr) ) ).

tff(addAssignment_62185,axiom,
    ! [VarCurr: state_type] :
      ( v102068(VarCurr)
    <=> v102064(VarCurr) ) ).

tff(addAssignment_62184,axiom,
    ! [VarCurr: state_type] :
      ( v102064(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_62183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101590(VarCurr,B)
      <=> v102062(VarCurr,B) ) ) ).

tff(addAssignment_62182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102062(VarCurr,B)
      <=> v83013(VarCurr,B) ) ) ).

tff(addAssignment_62181,axiom,
    ! [VarCurr: state_type] :
      ( ( v102062(VarCurr,5)
      <=> v101592(VarCurr,2) )
      & ( v102062(VarCurr,4)
      <=> v101592(VarCurr,1) )
      & ( v102062(VarCurr,3)
      <=> v101592(VarCurr,0) ) ) ).

tff(addAssignment_62180,axiom,
    ! [VarCurr: state_type] :
      ( ( v101592(VarCurr,2)
      <=> v101594(VarCurr,5) )
      & ( v101592(VarCurr,1)
      <=> v101594(VarCurr,4) )
      & ( v101592(VarCurr,0)
      <=> v101594(VarCurr,3) ) ) ).

tff(addAssignment_62179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101594(VarCurr,B)
      <=> v102053(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102053(VarCurr,B)
          <=> v102056(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_698,axiom,
    ! [VarCurr: state_type] :
      ( v86877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102053(VarCurr,B)
          <=> v102054(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102057(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102056(VarCurr,B)
          <=> v101596(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_697,axiom,
    ! [VarCurr: state_type] :
      ( v102057(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102056(VarCurr,B)
          <=> v102058(VarCurr,B) ) ) ) ).

tff(addAssignment_62178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102058(VarCurr,B)
      <=> v102061(VarCurr,B) ) ) ).

tff(addAssignment_62177,axiom,
    ! [VarCurr: state_type] :
      ( ( v102058(VarCurr,5)
      <=> v101570(VarCurr,2) )
      & ( v102058(VarCurr,4)
      <=> v101570(VarCurr,1) )
      & ( v102058(VarCurr,3)
      <=> v101570(VarCurr,0) ) ) ).

tff(addAssignment_62176,axiom,
    ! [VarCurr: state_type] :
      ( v102058(VarCurr,6)
    <=> v102060(VarCurr) ) ).

tff(addAssignment_62175,axiom,
    ! [VarCurr: state_type] :
      ( v102058(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_62174,axiom,
    ! [VarCurr: state_type] :
      ( v102058(VarCurr,8)
    <=> v102059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9779,axiom,
    ! [VarCurr: state_type] :
      ( v102057(VarCurr)
    <=> ( v82954(VarCurr)
        | v83096(VarCurr) ) ) ).

tff(addAssignment_62173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102054(VarCurr,B)
      <=> v86950(VarCurr,B) ) ) ).

tff(addAssignment_62172,axiom,
    ! [VarCurr: state_type] :
      ( ( v102054(VarCurr,5)
      <=> v88266(VarCurr,2) )
      & ( v102054(VarCurr,4)
      <=> v88266(VarCurr,1) )
      & ( v102054(VarCurr,3)
      <=> v88266(VarCurr,0) ) ) ).

tff(addAssignment_62171,axiom,
    ! [VarCurr: state_type] :
      ( v102054(VarCurr,6)
    <=> v88078(VarCurr) ) ).

tff(addAssignment_62170,axiom,
    ! [VarCurr: state_type] :
      ( v102054(VarCurr,7)
    <=> v87198(VarCurr) ) ).

tff(addAssignment_62169,axiom,
    ! [VarCurr: state_type] :
      ( v102054(VarCurr,8)
    <=> v102055(VarCurr) ) ).

tff(addAssignment_62168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v101596(VarCurr,B)
      <=> v102037(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102038(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102037(VarCurr,B)
          <=> v102040(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_696,axiom,
    ! [VarCurr: state_type] :
      ( v102038(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102037(VarCurr,B)
          <=> v102039(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102041(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102040(VarCurr,B)
          <=> v102051(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_695,axiom,
    ! [VarCurr: state_type] :
      ( v102041(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102040(VarCurr,B)
          <=> v102024(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102051(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_1522,axiom,
    ~ b000000000(8) ).

tff(bitBlastConstant_1521,axiom,
    ~ b000000000(7) ).

tff(bitBlastConstant_1520,axiom,
    ~ b000000000(6) ).

tff(bitBlastConstant_1519,axiom,
    ~ b000000000(5) ).

tff(bitBlastConstant_1518,axiom,
    ~ b000000000(4) ).

tff(bitBlastConstant_1517,axiom,
    ~ b000000000(3) ).

tff(bitBlastConstant_1516,axiom,
    ~ b000000000(2) ).

tff(bitBlastConstant_1515,axiom,
    ~ b000000000(1) ).

tff(bitBlastConstant_1514,axiom,
    ~ b000000000(0) ).

tff(addConditionBooleanCondEqualRangesThenBranch_694,axiom,
    ! [VarCurr: state_type] :
      ( v101501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102051(VarCurr,B)
          <=> v102052(VarCurr,B) ) ) ) ).

tff(addAssignment_62167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102052(VarCurr,B)
      <=> v101563(VarCurr,B) ) ) ).

tff(addAssignment_62166,axiom,
    ! [VarCurr: state_type] :
      ( ( v102052(VarCurr,8)
      <=> v101563(VarCurr,9) )
      & ( v102052(VarCurr,7)
      <=> v101563(VarCurr,8) )
      & ( v102052(VarCurr,6)
      <=> v101563(VarCurr,7) )
      & ( v102052(VarCurr,5)
      <=> v101563(VarCurr,6) )
      & ( v102052(VarCurr,4)
      <=> v101563(VarCurr,5) )
      & ( v102052(VarCurr,3)
      <=> v101563(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9778,axiom,
    ! [VarCurr: state_type] :
      ( v102041(VarCurr)
    <=> ( v102042(VarCurr)
        | v102043(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4007,axiom,
    ! [VarCurr: state_type] :
      ( v102043(VarCurr)
    <=> ( v102045(VarCurr)
        | v84901(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4006,axiom,
    ! [VarCurr: state_type] :
      ( v102045(VarCurr)
    <=> ( v102046(VarCurr)
        | v84901(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4005,axiom,
    ! [VarCurr: state_type] :
      ( v102046(VarCurr)
    <=> ( v102047(VarCurr)
        | v84901(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4004,axiom,
    ! [VarCurr: state_type] :
      ( v102047(VarCurr)
    <=> ( v102048(VarCurr)
        | v84901(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4003,axiom,
    ! [VarCurr: state_type] :
      ( v102048(VarCurr)
    <=> ( v102049(VarCurr)
        | v84901(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4002,axiom,
    ! [VarCurr: state_type] :
      ( v102049(VarCurr)
    <=> ( v102050(VarCurr)
        | v84901(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4001,axiom,
    ! [VarCurr: state_type] :
      ( v102050(VarCurr)
    <=> ( v84901(VarCurr,0)
        | v84901(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4000,axiom,
    ! [VarCurr: state_type] :
      ( v102042(VarCurr)
    <=> ( v102028(VarCurr)
        | v120(VarCurr,7) ) ) ).

tff(addAssignment_62165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102039(VarCurr,B)
      <=> v101563(VarCurr,B) ) ) ).

tff(addAssignment_62164,axiom,
    ! [VarCurr: state_type] :
      ( ( v102039(VarCurr,8)
      <=> v101563(VarCurr,9) )
      & ( v102039(VarCurr,7)
      <=> v101563(VarCurr,8) )
      & ( v102039(VarCurr,6)
      <=> v101563(VarCurr,7) )
      & ( v102039(VarCurr,5)
      <=> v101563(VarCurr,6) )
      & ( v102039(VarCurr,4)
      <=> v101563(VarCurr,5) )
      & ( v102039(VarCurr,3)
      <=> v101563(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9777,axiom,
    ! [VarCurr: state_type] :
      ( v102038(VarCurr)
    <=> ( v101598(VarCurr)
        & v101501(VarCurr) ) ) ).

tff(addAssignment_62163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v102024(VarCurr,B)
      <=> v102025(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102025(VarCurr,B)
          <=> v102035(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_693,axiom,
    ! [VarCurr: state_type] :
      ( v102026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v102025(VarCurr,B)
          <=> v102034(VarCurr,B) ) ) ) ).

tff(addAssignment_62162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102035(VarCurr,B)
      <=> v89243(VarCurr,B) ) ) ).

tff(addAssignment_62161,axiom,
    ! [VarCurr: state_type] :
      ( ( v102035(VarCurr,8)
      <=> v89243(VarCurr,9) )
      & ( v102035(VarCurr,7)
      <=> v89243(VarCurr,8) )
      & ( v102035(VarCurr,6)
      <=> v89243(VarCurr,7) )
      & ( v102035(VarCurr,5)
      <=> v89243(VarCurr,6) )
      & ( v102035(VarCurr,4)
      <=> v89243(VarCurr,5) )
      & ( v102035(VarCurr,3)
      <=> v89243(VarCurr,4) ) ) ).

tff(addAssignment_62160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v102034(VarCurr,B)
      <=> v89214(VarCurr,B) ) ) ).

tff(addAssignment_62159,axiom,
    ! [VarCurr: state_type] :
      ( ( v102034(VarCurr,8)
      <=> v89214(VarCurr,9) )
      & ( v102034(VarCurr,7)
      <=> v89214(VarCurr,8) )
      & ( v102034(VarCurr,6)
      <=> v89214(VarCurr,7) )
      & ( v102034(VarCurr,5)
      <=> v89214(VarCurr,6) )
      & ( v102034(VarCurr,4)
      <=> v89214(VarCurr,5) )
      & ( v102034(VarCurr,3)
      <=> v89214(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3999,axiom,
    ! [VarCurr: state_type] :
      ( v102026(VarCurr)
    <=> ( v102028(VarCurr)
        | v120(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3998,axiom,
    ! [VarCurr: state_type] :
      ( v102028(VarCurr)
    <=> ( v102029(VarCurr)
        | v120(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3997,axiom,
    ! [VarCurr: state_type] :
      ( v102029(VarCurr)
    <=> ( v102030(VarCurr)
        | v120(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3996,axiom,
    ! [VarCurr: state_type] :
      ( v102030(VarCurr)
    <=> ( v102031(VarCurr)
        | v120(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3995,axiom,
    ! [VarCurr: state_type] :
      ( v102031(VarCurr)
    <=> ( v102032(VarCurr)
        | v120(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3994,axiom,
    ! [VarCurr: state_type] :
      ( v102032(VarCurr)
    <=> ( v102033(VarCurr)
        | v120(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3993,axiom,
    ! [VarCurr: state_type] :
      ( v102033(VarCurr)
    <=> ( v120(VarCurr,0)
        | v120(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9776,axiom,
    ! [VarCurr: state_type] :
      ( v101598(VarCurr)
    <=> ( v101600(VarCurr)
        | v101812(VarCurr) ) ) ).

tff(addAssignment_62158,axiom,
    ! [VarCurr: state_type] :
      ( v101812(VarCurr)
    <=> v101814(VarCurr) ) ).

tff(addAssignment_62157,axiom,
    ! [VarCurr: state_type] :
      ( v101814(VarCurr)
    <=> v101816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102006(VarNext)
       => ( v101816(VarNext)
        <=> v101816(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1199,axiom,
    ! [VarNext: state_type] :
      ( v102006(VarNext)
     => ( v101816(VarNext)
      <=> v102016(VarNext) ) ) ).

tff(addAssignment_62156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102016(VarNext)
      <=> v102014(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102017(VarCurr)
     => ( v102014(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_692,axiom,
    ! [VarCurr: state_type] :
      ( v102017(VarCurr)
     => ( v102014(VarCurr)
      <=> v101826(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9775,axiom,
    ! [VarCurr: state_type] :
      ( v102017(VarCurr)
    <=> ( v102018(VarCurr)
        & v102019(VarCurr) ) ) ).

tff(writeUnaryOperator_4985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102019(VarCurr)
    <=> v101822(VarCurr) ) ).

tff(writeUnaryOperator_4984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v102018(VarCurr)
    <=> v101818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102006(VarNext)
      <=> v102007(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102007(VarNext)
      <=> ( v102008(VarNext)
          & v102001(VarNext) ) ) ) ).

tff(writeUnaryOperator_4983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v102008(VarNext)
      <=> v102010(VarNext) ) ) ).

tff(addAssignment_62155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v102010(VarNext)
      <=> v102001(VarCurr) ) ) ).

tff(addAssignment_62154,axiom,
    ! [VarCurr: state_type] :
      ( v102001(VarCurr)
    <=> v102003(VarCurr) ) ).

tff(addAssignment_62153,axiom,
    ! [VarCurr: state_type] :
      ( v102003(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_62152,axiom,
    ! [VarCurr: state_type] :
      ( v101826(VarCurr)
    <=> v101828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9772,axiom,
    ! [VarCurr: state_type] :
      ( v101828(VarCurr)
    <=> ( v101985(VarCurr)
        | v101992(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9771,axiom,
    ! [VarCurr: state_type] :
      ( v101992(VarCurr)
    <=> ( v101993(VarCurr)
        & v101997(VarCurr) ) ) ).

tff(writeUnaryOperator_4982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101997(VarCurr)
    <=> v101998(VarCurr) ) ).

tff(addAssignment_62151,axiom,
    ! [VarCurr: state_type] :
      ( v101998(VarCurr)
    <=> v101999(VarCurr) ) ).

tff(addAssignment_62150,axiom,
    ! [VarCurr: state_type] :
      ( v101999(VarCurr)
    <=> v101980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9770,axiom,
    ! [VarCurr: state_type] :
      ( v101993(VarCurr)
    <=> ( v101814(VarCurr)
        & v101994(VarCurr) ) ) ).

tff(writeUnaryOperator_4981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101994(VarCurr)
    <=> v101995(VarCurr) ) ).

tff(addAssignment_62149,axiom,
    ! [VarCurr: state_type] :
      ( v101995(VarCurr)
    <=> v101996(VarCurr) ) ).

tff(addAssignment_62148,axiom,
    ! [VarCurr: state_type] :
      ( v101996(VarCurr)
    <=> v101978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9769,axiom,
    ! [VarCurr: state_type] :
      ( v101985(VarCurr)
    <=> ( v101986(VarCurr)
        & v101989(VarCurr) ) ) ).

tff(writeUnaryOperator_4980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101989(VarCurr)
    <=> v101990(VarCurr) ) ).

tff(addAssignment_62147,axiom,
    ! [VarCurr: state_type] :
      ( v101990(VarCurr)
    <=> v101991(VarCurr) ) ).

tff(addAssignment_62146,axiom,
    ! [VarCurr: state_type] :
      ( v101991(VarCurr)
    <=> v101980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9768,axiom,
    ! [VarCurr: state_type] :
      ( v101986(VarCurr)
    <=> ( v101830(VarCurr)
        & v101987(VarCurr) ) ) ).

tff(addAssignment_62145,axiom,
    ! [VarCurr: state_type] :
      ( v101987(VarCurr)
    <=> v101988(VarCurr) ) ).

tff(addAssignment_62144,axiom,
    ! [VarCurr: state_type] :
      ( v101988(VarCurr)
    <=> v101978(VarCurr) ) ).

tff(addAssignment_62143,axiom,
    ! [VarCurr: state_type] :
      ( v101980(VarCurr)
    <=> v101982(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_667,axiom,
    ! [VarCurr: state_type] :
      ( v101982(VarCurr)
    <=> ( ( v101834(VarCurr,5)
        <=> $false )
        & ( v101834(VarCurr,4)
        <=> $false )
        & ( v101834(VarCurr,3)
        <=> $false )
        & ( v101834(VarCurr,2)
        <=> $false )
        & ( v101834(VarCurr,1)
        <=> $false )
        & ( v101834(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62142,axiom,
    ! [VarCurr: state_type] :
      ( v101978(VarCurr)
    <=> v101832(VarCurr) ) ).

tff(addAssignment_62141,axiom,
    ! [VarCurr: state_type] :
      ( v101830(VarCurr)
    <=> v101832(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_666,axiom,
    ! [VarCurr: state_type] :
      ( v101832(VarCurr)
    <=> ( ( v101834(VarCurr,5)
        <=> $true )
        & ( v101834(VarCurr,4)
        <=> $true )
        & ( v101834(VarCurr,3)
        <=> $true )
        & ( v101834(VarCurr,2)
        <=> $true )
        & ( v101834(VarCurr,1)
        <=> $true )
        & ( v101834(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_62140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101834(VarCurr,B)
      <=> v101836(VarCurr,B) ) ) ).

tff(addAssignment_62139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101836(VarCurr,B)
      <=> v101838(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101960(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v101838(VarNext,B)
            <=> v101838(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1198,axiom,
    ! [VarNext: state_type] :
      ( v101960(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101838(VarNext,B)
          <=> v101970(VarNext,B) ) ) ) ).

tff(addAssignment_62138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101970(VarNext,B)
          <=> v101968(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101971(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101968(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_691,axiom,
    ! [VarCurr: state_type] :
      ( v101971(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101968(VarCurr,B)
          <=> v101848(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9767,axiom,
    ! [VarCurr: state_type] :
      ( v101971(VarCurr)
    <=> ( v101972(VarCurr)
        & v101973(VarCurr) ) ) ).

tff(writeUnaryOperator_4979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101973(VarCurr)
    <=> v101844(VarCurr) ) ).

tff(writeUnaryOperator_4978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101972(VarCurr)
    <=> v101840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101960(VarNext)
      <=> v101961(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101961(VarNext)
      <=> ( v101962(VarNext)
          & v101955(VarNext) ) ) ) ).

tff(writeUnaryOperator_4977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101962(VarNext)
      <=> v101964(VarNext) ) ) ).

tff(addAssignment_62137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101964(VarNext)
      <=> v101955(VarCurr) ) ) ).

tff(addAssignment_62136,axiom,
    ! [VarCurr: state_type] :
      ( v101955(VarCurr)
    <=> v101957(VarCurr) ) ).

tff(addAssignment_62135,axiom,
    ! [VarCurr: state_type] :
      ( v101957(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_62134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101848(VarCurr,B)
      <=> v101850(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101850(VarCurr,B)
      <=> ( v101852(VarCurr,B)
          & v101951(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101951(VarCurr,B)
      <=> ~ v101952(VarCurr,B) ) ) ).

tff(addAssignment_62133,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,0)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62132,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,1)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62131,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,2)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62130,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,3)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62129,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,4)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62128,axiom,
    ! [VarCurr: state_type] :
      ( v101952(VarCurr,5)
    <=> v101953(VarCurr) ) ).

tff(addAssignment_62127,axiom,
    ! [VarCurr: state_type] :
      ( v101953(VarCurr)
    <=> v101934(VarCurr) ) ).

tff(addAssignment_62126,axiom,
    ! [VarCurr: state_type] :
      ( v101934(VarCurr)
    <=> v101936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9764,axiom,
    ! [VarCurr: state_type] :
      ( v101936(VarCurr)
    <=> ( v101938(VarCurr)
        & v101949(VarCurr) ) ) ).

tff(writeUnaryOperator_4975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101949(VarCurr)
    <=> v101832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9763,axiom,
    ! [VarCurr: state_type] :
      ( v101938(VarCurr)
    <=> ( v101939(VarCurr)
        & v101948(VarCurr) ) ) ).

tff(writeUnaryOperator_4974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101948(VarCurr)
    <=> v101812(VarCurr) ) ).

tff(writeUnaryOperator_4973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101939(VarCurr)
    <=> v101940(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3992,axiom,
    ! [VarCurr: state_type] :
      ( v101940(VarCurr)
    <=> ( v101942(VarCurr)
        & v89413(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3991,axiom,
    ! [VarCurr: state_type] :
      ( v101942(VarCurr)
    <=> ( v101943(VarCurr)
        & v89413(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3990,axiom,
    ! [VarCurr: state_type] :
      ( v101943(VarCurr)
    <=> ( v101944(VarCurr)
        & v89413(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3989,axiom,
    ! [VarCurr: state_type] :
      ( v101944(VarCurr)
    <=> ( v101945(VarCurr)
        & v89413(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3988,axiom,
    ! [VarCurr: state_type] :
      ( v101945(VarCurr)
    <=> ( v101946(VarCurr)
        & v89413(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3987,axiom,
    ! [VarCurr: state_type] :
      ( v101946(VarCurr)
    <=> ( v101947(VarCurr)
        & v89413(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3986,axiom,
    ! [VarCurr: state_type] :
      ( v101947(VarCurr)
    <=> ( v89413(VarCurr,0)
        & v89413(VarCurr,1) ) ) ).

tff(addAssignment_62125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101852(VarCurr,B)
      <=> v101854(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101854(VarCurr,B)
          <=> v101899(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_690,axiom,
    ! [VarCurr: state_type] :
      ( v101856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101854(VarCurr,B)
          <=> v101870(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101900(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101899(VarCurr,B)
          <=> v101834(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_689,axiom,
    ! [VarCurr: state_type] :
      ( v101900(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101899(VarCurr,B)
          <=> v101909(VarCurr,B) ) ) ) ).

tff(addAssignment_62124,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,0)
    <=> v101864(VarCurr) ) ).

tff(addAssignment_62123,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,1)
    <=> v101930(VarCurr) ) ).

tff(addAssignment_62122,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,2)
    <=> v101926(VarCurr) ) ).

tff(addAssignment_62121,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,3)
    <=> v101922(VarCurr) ) ).

tff(addAssignment_62120,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,4)
    <=> v101918(VarCurr) ) ).

tff(addAssignment_62119,axiom,
    ! [VarCurr: state_type] :
      ( v101909(VarCurr,5)
    <=> v101911(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9762,axiom,
    ! [VarCurr: state_type] :
      ( v101930(VarCurr)
    <=> ( v101931(VarCurr)
        & v101932(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3985,axiom,
    ! [VarCurr: state_type] :
      ( v101932(VarCurr)
    <=> ( v101834(VarCurr,0)
        | v101834(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9761,axiom,
    ! [VarCurr: state_type] :
      ( v101931(VarCurr)
    <=> ( v101864(VarCurr)
        | v101865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9760,axiom,
    ! [VarCurr: state_type] :
      ( v101926(VarCurr)
    <=> ( v101927(VarCurr)
        & v101929(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3984,axiom,
    ! [VarCurr: state_type] :
      ( v101929(VarCurr)
    <=> ( v101834(VarCurr,2)
        | v101908(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9759,axiom,
    ! [VarCurr: state_type] :
      ( v101927(VarCurr)
    <=> ( v101866(VarCurr)
        | v101928(VarCurr) ) ) ).

tff(writeUnaryOperator_4972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101928(VarCurr)
    <=> v101908(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9758,axiom,
    ! [VarCurr: state_type] :
      ( v101922(VarCurr)
    <=> ( v101923(VarCurr)
        & v101925(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3983,axiom,
    ! [VarCurr: state_type] :
      ( v101925(VarCurr)
    <=> ( v101834(VarCurr,3)
        | v101916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9757,axiom,
    ! [VarCurr: state_type] :
      ( v101923(VarCurr)
    <=> ( v101867(VarCurr)
        | v101924(VarCurr) ) ) ).

tff(writeUnaryOperator_4971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101924(VarCurr)
    <=> v101916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9756,axiom,
    ! [VarCurr: state_type] :
      ( v101918(VarCurr)
    <=> ( v101919(VarCurr)
        & v101921(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3982,axiom,
    ! [VarCurr: state_type] :
      ( v101921(VarCurr)
    <=> ( v101834(VarCurr,4)
        | v101915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9755,axiom,
    ! [VarCurr: state_type] :
      ( v101919(VarCurr)
    <=> ( v101868(VarCurr)
        | v101920(VarCurr) ) ) ).

tff(writeUnaryOperator_4970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101920(VarCurr)
    <=> v101915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9754,axiom,
    ! [VarCurr: state_type] :
      ( v101911(VarCurr)
    <=> ( v101912(VarCurr)
        & v101917(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3981,axiom,
    ! [VarCurr: state_type] :
      ( v101917(VarCurr)
    <=> ( v101834(VarCurr,5)
        | v101914(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9753,axiom,
    ! [VarCurr: state_type] :
      ( v101912(VarCurr)
    <=> ( v101869(VarCurr)
        | v101913(VarCurr) ) ) ).

tff(writeUnaryOperator_4969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101913(VarCurr)
    <=> v101914(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3980,axiom,
    ! [VarCurr: state_type] :
      ( v101914(VarCurr)
    <=> ( v101834(VarCurr,4)
        & v101915(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3979,axiom,
    ! [VarCurr: state_type] :
      ( v101915(VarCurr)
    <=> ( v101834(VarCurr,3)
        & v101916(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3978,axiom,
    ! [VarCurr: state_type] :
      ( v101916(VarCurr)
    <=> ( v101834(VarCurr,2)
        & v101908(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9752,axiom,
    ! [VarCurr: state_type] :
      ( v101900(VarCurr)
    <=> ( v101901(VarCurr)
        & v101902(VarCurr) ) ) ).

tff(writeUnaryOperator_4968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101902(VarCurr)
    <=> v101904(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3977,axiom,
    ! [VarCurr: state_type] :
      ( v101904(VarCurr)
    <=> ( v101905(VarCurr)
        & v101834(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3976,axiom,
    ! [VarCurr: state_type] :
      ( v101905(VarCurr)
    <=> ( v101906(VarCurr)
        & v101834(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3975,axiom,
    ! [VarCurr: state_type] :
      ( v101906(VarCurr)
    <=> ( v101907(VarCurr)
        & v101834(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3974,axiom,
    ! [VarCurr: state_type] :
      ( v101907(VarCurr)
    <=> ( v101908(VarCurr)
        & v101834(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3973,axiom,
    ! [VarCurr: state_type] :
      ( v101908(VarCurr)
    <=> ( v101834(VarCurr,0)
        & v101834(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101901(VarCurr)
    <=> v101812(VarCurr) ) ).

tff(addAssignment_62118,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,0)
    <=> v101864(VarCurr) ) ).

tff(addAssignment_62117,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,1)
    <=> v101896(VarCurr) ) ).

tff(addAssignment_62116,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,2)
    <=> v101892(VarCurr) ) ).

tff(addAssignment_62115,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,3)
    <=> v101888(VarCurr) ) ).

tff(addAssignment_62114,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,4)
    <=> v101884(VarCurr) ) ).

tff(addAssignment_62113,axiom,
    ! [VarCurr: state_type] :
      ( v101870(VarCurr,5)
    <=> v101872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9751,axiom,
    ! [VarCurr: state_type] :
      ( v101896(VarCurr)
    <=> ( v101897(VarCurr)
        & v101898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9750,axiom,
    ! [VarCurr: state_type] :
      ( v101898(VarCurr)
    <=> ( v101834(VarCurr,0)
        | v101865(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3972,axiom,
    ! [VarCurr: state_type] :
      ( v101897(VarCurr)
    <=> ( v101864(VarCurr)
        | v101834(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9749,axiom,
    ! [VarCurr: state_type] :
      ( v101892(VarCurr)
    <=> ( v101893(VarCurr)
        & v101895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9748,axiom,
    ! [VarCurr: state_type] :
      ( v101895(VarCurr)
    <=> ( v101866(VarCurr)
        | v101881(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3971,axiom,
    ! [VarCurr: state_type] :
      ( v101893(VarCurr)
    <=> ( v101834(VarCurr,2)
        | v101894(VarCurr) ) ) ).

tff(writeUnaryOperator_4966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101894(VarCurr)
    <=> v101881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9747,axiom,
    ! [VarCurr: state_type] :
      ( v101888(VarCurr)
    <=> ( v101889(VarCurr)
        & v101891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9746,axiom,
    ! [VarCurr: state_type] :
      ( v101891(VarCurr)
    <=> ( v101867(VarCurr)
        | v101879(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3970,axiom,
    ! [VarCurr: state_type] :
      ( v101889(VarCurr)
    <=> ( v101834(VarCurr,3)
        | v101890(VarCurr) ) ) ).

tff(writeUnaryOperator_4965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101890(VarCurr)
    <=> v101879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9745,axiom,
    ! [VarCurr: state_type] :
      ( v101884(VarCurr)
    <=> ( v101885(VarCurr)
        & v101887(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9744,axiom,
    ! [VarCurr: state_type] :
      ( v101887(VarCurr)
    <=> ( v101868(VarCurr)
        | v101877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3969,axiom,
    ! [VarCurr: state_type] :
      ( v101885(VarCurr)
    <=> ( v101834(VarCurr,4)
        | v101886(VarCurr) ) ) ).

tff(writeUnaryOperator_4964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101886(VarCurr)
    <=> v101877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9743,axiom,
    ! [VarCurr: state_type] :
      ( v101872(VarCurr)
    <=> ( v101873(VarCurr)
        & v101883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9742,axiom,
    ! [VarCurr: state_type] :
      ( v101883(VarCurr)
    <=> ( v101869(VarCurr)
        | v101875(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3968,axiom,
    ! [VarCurr: state_type] :
      ( v101873(VarCurr)
    <=> ( v101834(VarCurr,5)
        | v101874(VarCurr) ) ) ).

tff(writeUnaryOperator_4963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101874(VarCurr)
    <=> v101875(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3967,axiom,
    ! [VarCurr: state_type] :
      ( v101875(VarCurr)
    <=> ( v101834(VarCurr,4)
        | v101876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9741,axiom,
    ! [VarCurr: state_type] :
      ( v101876(VarCurr)
    <=> ( v101868(VarCurr)
        & v101877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3966,axiom,
    ! [VarCurr: state_type] :
      ( v101877(VarCurr)
    <=> ( v101834(VarCurr,3)
        | v101878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9740,axiom,
    ! [VarCurr: state_type] :
      ( v101878(VarCurr)
    <=> ( v101867(VarCurr)
        & v101879(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3965,axiom,
    ! [VarCurr: state_type] :
      ( v101879(VarCurr)
    <=> ( v101834(VarCurr,2)
        | v101880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9739,axiom,
    ! [VarCurr: state_type] :
      ( v101880(VarCurr)
    <=> ( v101866(VarCurr)
        & v101881(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3964,axiom,
    ! [VarCurr: state_type] :
      ( v101881(VarCurr)
    <=> ( v101834(VarCurr,1)
        | v101882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9738,axiom,
    ! [VarCurr: state_type] :
      ( v101882(VarCurr)
    <=> ( v101834(VarCurr,0)
        & v101865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9737,axiom,
    ! [VarCurr: state_type] :
      ( v101856(VarCurr)
    <=> ( v101812(VarCurr)
        & v101857(VarCurr) ) ) ).

tff(writeUnaryOperator_4962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101857(VarCurr)
    <=> v101859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9736,axiom,
    ! [VarCurr: state_type] :
      ( v101859(VarCurr)
    <=> ( v101860(VarCurr)
        & v101869(VarCurr) ) ) ).

tff(writeUnaryOperator_4961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101869(VarCurr)
    <=> v101834(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9735,axiom,
    ! [VarCurr: state_type] :
      ( v101860(VarCurr)
    <=> ( v101861(VarCurr)
        & v101868(VarCurr) ) ) ).

tff(writeUnaryOperator_4960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101868(VarCurr)
    <=> v101834(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9734,axiom,
    ! [VarCurr: state_type] :
      ( v101861(VarCurr)
    <=> ( v101862(VarCurr)
        & v101867(VarCurr) ) ) ).

tff(writeUnaryOperator_4959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101867(VarCurr)
    <=> v101834(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9733,axiom,
    ! [VarCurr: state_type] :
      ( v101862(VarCurr)
    <=> ( v101863(VarCurr)
        & v101866(VarCurr) ) ) ).

tff(writeUnaryOperator_4958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101866(VarCurr)
    <=> v101834(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9732,axiom,
    ! [VarCurr: state_type] :
      ( v101863(VarCurr)
    <=> ( v101864(VarCurr)
        & v101865(VarCurr) ) ) ).

tff(writeUnaryOperator_4957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101865(VarCurr)
    <=> v101834(VarCurr,1) ) ).

tff(writeUnaryOperator_4956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101864(VarCurr)
    <=> v101834(VarCurr,0) ) ).

tff(addAssignment_62112,axiom,
    ! [VarCurr: state_type] :
      ( v101844(VarCurr)
    <=> v101846(VarCurr) ) ).

tff(addAssignment_62111,axiom,
    ! [VarCurr: state_type] :
      ( v101846(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_62110,axiom,
    ! [VarCurr: state_type] :
      ( v101840(VarCurr)
    <=> v101842(VarCurr) ) ).

tff(addAssignment_62109,axiom,
    ! [VarCurr: state_type] :
      ( v101842(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_62108,axiom,
    ! [VarCurr: state_type] :
      ( v101822(VarCurr)
    <=> v101824(VarCurr) ) ).

tff(addAssignment_62107,axiom,
    ! [VarCurr: state_type] :
      ( v101824(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_62106,axiom,
    ! [VarCurr: state_type] :
      ( v101818(VarCurr)
    <=> v101820(VarCurr) ) ).

tff(addAssignment_62105,axiom,
    ! [VarCurr: state_type] :
      ( v101820(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_62104,axiom,
    ! [VarCurr: state_type] :
      ( v101600(VarCurr)
    <=> v101602(VarCurr) ) ).

tff(addAssignment_62103,axiom,
    ! [VarCurr: state_type] :
      ( v101602(VarCurr)
    <=> v101604(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101795(VarNext)
       => ( v101604(VarNext)
        <=> v101604(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1197,axiom,
    ! [VarNext: state_type] :
      ( v101795(VarNext)
     => ( v101604(VarNext)
      <=> v101805(VarNext) ) ) ).

tff(addAssignment_62102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101805(VarNext)
      <=> v101803(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101806(VarCurr)
     => ( v101803(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_688,axiom,
    ! [VarCurr: state_type] :
      ( v101806(VarCurr)
     => ( v101803(VarCurr)
      <=> v101614(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9731,axiom,
    ! [VarCurr: state_type] :
      ( v101806(VarCurr)
    <=> ( v101807(VarCurr)
        & v101808(VarCurr) ) ) ).

tff(writeUnaryOperator_4955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101808(VarCurr)
    <=> v101610(VarCurr) ) ).

tff(writeUnaryOperator_4954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101807(VarCurr)
    <=> v101606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101795(VarNext)
      <=> v101796(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101796(VarNext)
      <=> ( v101797(VarNext)
          & v101790(VarNext) ) ) ) ).

tff(writeUnaryOperator_4953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101797(VarNext)
      <=> v101799(VarNext) ) ) ).

tff(addAssignment_62101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101799(VarNext)
      <=> v101790(VarCurr) ) ) ).

tff(addAssignment_62100,axiom,
    ! [VarCurr: state_type] :
      ( v101790(VarCurr)
    <=> v101792(VarCurr) ) ).

tff(addAssignment_62099,axiom,
    ! [VarCurr: state_type] :
      ( v101792(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_62098,axiom,
    ! [VarCurr: state_type] :
      ( v101614(VarCurr)
    <=> v101616(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9728,axiom,
    ! [VarCurr: state_type] :
      ( v101616(VarCurr)
    <=> ( v101774(VarCurr)
        | v101781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9727,axiom,
    ! [VarCurr: state_type] :
      ( v101781(VarCurr)
    <=> ( v101782(VarCurr)
        & v101786(VarCurr) ) ) ).

tff(writeUnaryOperator_4952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101786(VarCurr)
    <=> v101787(VarCurr) ) ).

tff(addAssignment_62097,axiom,
    ! [VarCurr: state_type] :
      ( v101787(VarCurr)
    <=> v101788(VarCurr) ) ).

tff(addAssignment_62096,axiom,
    ! [VarCurr: state_type] :
      ( v101788(VarCurr)
    <=> v101769(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9726,axiom,
    ! [VarCurr: state_type] :
      ( v101782(VarCurr)
    <=> ( v101602(VarCurr)
        & v101783(VarCurr) ) ) ).

tff(writeUnaryOperator_4951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101783(VarCurr)
    <=> v101784(VarCurr) ) ).

tff(addAssignment_62095,axiom,
    ! [VarCurr: state_type] :
      ( v101784(VarCurr)
    <=> v101785(VarCurr) ) ).

tff(addAssignment_62094,axiom,
    ! [VarCurr: state_type] :
      ( v101785(VarCurr)
    <=> v101767(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9725,axiom,
    ! [VarCurr: state_type] :
      ( v101774(VarCurr)
    <=> ( v101775(VarCurr)
        & v101778(VarCurr) ) ) ).

tff(writeUnaryOperator_4950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101778(VarCurr)
    <=> v101779(VarCurr) ) ).

tff(addAssignment_62093,axiom,
    ! [VarCurr: state_type] :
      ( v101779(VarCurr)
    <=> v101780(VarCurr) ) ).

tff(addAssignment_62092,axiom,
    ! [VarCurr: state_type] :
      ( v101780(VarCurr)
    <=> v101769(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9724,axiom,
    ! [VarCurr: state_type] :
      ( v101775(VarCurr)
    <=> ( v101618(VarCurr)
        & v101776(VarCurr) ) ) ).

tff(addAssignment_62091,axiom,
    ! [VarCurr: state_type] :
      ( v101776(VarCurr)
    <=> v101777(VarCurr) ) ).

tff(addAssignment_62090,axiom,
    ! [VarCurr: state_type] :
      ( v101777(VarCurr)
    <=> v101767(VarCurr) ) ).

tff(addAssignment_62089,axiom,
    ! [VarCurr: state_type] :
      ( v101769(VarCurr)
    <=> v101771(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_665,axiom,
    ! [VarCurr: state_type] :
      ( v101771(VarCurr)
    <=> ( ( v101622(VarCurr,5)
        <=> $false )
        & ( v101622(VarCurr,4)
        <=> $false )
        & ( v101622(VarCurr,3)
        <=> $false )
        & ( v101622(VarCurr,2)
        <=> $false )
        & ( v101622(VarCurr,1)
        <=> $false )
        & ( v101622(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_62088,axiom,
    ! [VarCurr: state_type] :
      ( v101767(VarCurr)
    <=> v101620(VarCurr) ) ).

tff(addAssignment_62087,axiom,
    ! [VarCurr: state_type] :
      ( v101618(VarCurr)
    <=> v101620(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_664,axiom,
    ! [VarCurr: state_type] :
      ( v101620(VarCurr)
    <=> ( ( v101622(VarCurr,5)
        <=> $true )
        & ( v101622(VarCurr,4)
        <=> $true )
        & ( v101622(VarCurr,3)
        <=> $true )
        & ( v101622(VarCurr,2)
        <=> $true )
        & ( v101622(VarCurr,1)
        <=> $true )
        & ( v101622(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_1513,axiom,
    b111111(5) ).

tff(bitBlastConstant_1512,axiom,
    b111111(4) ).

tff(bitBlastConstant_1511,axiom,
    b111111(3) ).

tff(bitBlastConstant_1510,axiom,
    b111111(2) ).

tff(bitBlastConstant_1509,axiom,
    b111111(1) ).

tff(bitBlastConstant_1508,axiom,
    b111111(0) ).

tff(addAssignment_62086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101622(VarCurr,B)
      <=> v101624(VarCurr,B) ) ) ).

tff(addAssignment_62085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101624(VarCurr,B)
      <=> v101626(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101749(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v101626(VarNext,B)
            <=> v101626(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1196,axiom,
    ! [VarNext: state_type] :
      ( v101749(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101626(VarNext,B)
          <=> v101759(VarNext,B) ) ) ) ).

tff(addAssignment_62084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101759(VarNext,B)
          <=> v101757(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101760(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101757(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_687,axiom,
    ! [VarCurr: state_type] :
      ( v101760(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101757(VarCurr,B)
          <=> v101636(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9723,axiom,
    ! [VarCurr: state_type] :
      ( v101760(VarCurr)
    <=> ( v101761(VarCurr)
        & v101762(VarCurr) ) ) ).

tff(writeUnaryOperator_4949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101762(VarCurr)
    <=> v101632(VarCurr) ) ).

tff(writeUnaryOperator_4948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101761(VarCurr)
    <=> v101628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101749(VarNext)
      <=> v101750(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101750(VarNext)
      <=> ( v101751(VarNext)
          & v101744(VarNext) ) ) ) ).

tff(writeUnaryOperator_4947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101751(VarNext)
      <=> v101753(VarNext) ) ) ).

tff(addAssignment_62083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101753(VarNext)
      <=> v101744(VarCurr) ) ) ).

tff(addAssignment_62082,axiom,
    ! [VarCurr: state_type] :
      ( v101744(VarCurr)
    <=> v101746(VarCurr) ) ).

tff(addAssignment_62081,axiom,
    ! [VarCurr: state_type] :
      ( v101746(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_62080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101636(VarCurr,B)
      <=> v101638(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101638(VarCurr,B)
      <=> ( v101640(VarCurr,B)
          & v101740(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101740(VarCurr,B)
      <=> ~ v101741(VarCurr,B) ) ) ).

tff(addAssignment_62079,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,0)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62078,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,1)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62077,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,2)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62076,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,3)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62075,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,4)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62074,axiom,
    ! [VarCurr: state_type] :
      ( v101741(VarCurr,5)
    <=> v101742(VarCurr) ) ).

tff(addAssignment_62073,axiom,
    ! [VarCurr: state_type] :
      ( v101742(VarCurr)
    <=> v101723(VarCurr) ) ).

tff(addAssignment_62072,axiom,
    ! [VarCurr: state_type] :
      ( v101723(VarCurr)
    <=> v101725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9720,axiom,
    ! [VarCurr: state_type] :
      ( v101725(VarCurr)
    <=> ( v101727(VarCurr)
        & v101738(VarCurr) ) ) ).

tff(writeUnaryOperator_4945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101738(VarCurr)
    <=> v101620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9719,axiom,
    ! [VarCurr: state_type] :
      ( v101727(VarCurr)
    <=> ( v101728(VarCurr)
        & v101737(VarCurr) ) ) ).

tff(writeUnaryOperator_4944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101737(VarCurr)
    <=> v101600(VarCurr) ) ).

tff(writeUnaryOperator_4943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101728(VarCurr)
    <=> v101729(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3963,axiom,
    ! [VarCurr: state_type] :
      ( v101729(VarCurr)
    <=> ( v101731(VarCurr)
        & v2904(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3962,axiom,
    ! [VarCurr: state_type] :
      ( v101731(VarCurr)
    <=> ( v101732(VarCurr)
        & v2904(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3961,axiom,
    ! [VarCurr: state_type] :
      ( v101732(VarCurr)
    <=> ( v101733(VarCurr)
        & v2904(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3960,axiom,
    ! [VarCurr: state_type] :
      ( v101733(VarCurr)
    <=> ( v101734(VarCurr)
        & v2904(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3959,axiom,
    ! [VarCurr: state_type] :
      ( v101734(VarCurr)
    <=> ( v101735(VarCurr)
        & v2904(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3958,axiom,
    ! [VarCurr: state_type] :
      ( v101735(VarCurr)
    <=> ( v101736(VarCurr)
        & v2904(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3957,axiom,
    ! [VarCurr: state_type] :
      ( v101736(VarCurr)
    <=> ( v2904(VarCurr,0)
        & v2904(VarCurr,1) ) ) ).

tff(addAssignment_62071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v101640(VarCurr,B)
      <=> v101642(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101642(VarCurr,B)
          <=> v101688(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_686,axiom,
    ! [VarCurr: state_type] :
      ( v101645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101642(VarCurr,B)
          <=> v101659(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101689(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101688(VarCurr,B)
          <=> v101622(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_685,axiom,
    ! [VarCurr: state_type] :
      ( v101689(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v101688(VarCurr,B)
          <=> v101698(VarCurr,B) ) ) ) ).

tff(addAssignment_62070,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,0)
    <=> v101653(VarCurr) ) ).

tff(addAssignment_62069,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,1)
    <=> v101719(VarCurr) ) ).

tff(addAssignment_62068,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,2)
    <=> v101715(VarCurr) ) ).

tff(addAssignment_62067,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,3)
    <=> v101711(VarCurr) ) ).

tff(addAssignment_62066,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,4)
    <=> v101707(VarCurr) ) ).

tff(addAssignment_62065,axiom,
    ! [VarCurr: state_type] :
      ( v101698(VarCurr,5)
    <=> v101700(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9718,axiom,
    ! [VarCurr: state_type] :
      ( v101719(VarCurr)
    <=> ( v101720(VarCurr)
        & v101721(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3956,axiom,
    ! [VarCurr: state_type] :
      ( v101721(VarCurr)
    <=> ( v101622(VarCurr,0)
        | v101622(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9717,axiom,
    ! [VarCurr: state_type] :
      ( v101720(VarCurr)
    <=> ( v101653(VarCurr)
        | v101654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9716,axiom,
    ! [VarCurr: state_type] :
      ( v101715(VarCurr)
    <=> ( v101716(VarCurr)
        & v101718(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3955,axiom,
    ! [VarCurr: state_type] :
      ( v101718(VarCurr)
    <=> ( v101622(VarCurr,2)
        | v101697(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9715,axiom,
    ! [VarCurr: state_type] :
      ( v101716(VarCurr)
    <=> ( v101655(VarCurr)
        | v101717(VarCurr) ) ) ).

tff(writeUnaryOperator_4942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101717(VarCurr)
    <=> v101697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9714,axiom,
    ! [VarCurr: state_type] :
      ( v101711(VarCurr)
    <=> ( v101712(VarCurr)
        & v101714(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3954,axiom,
    ! [VarCurr: state_type] :
      ( v101714(VarCurr)
    <=> ( v101622(VarCurr,3)
        | v101705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9713,axiom,
    ! [VarCurr: state_type] :
      ( v101712(VarCurr)
    <=> ( v101656(VarCurr)
        | v101713(VarCurr) ) ) ).

tff(writeUnaryOperator_4941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101713(VarCurr)
    <=> v101705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9712,axiom,
    ! [VarCurr: state_type] :
      ( v101707(VarCurr)
    <=> ( v101708(VarCurr)
        & v101710(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3953,axiom,
    ! [VarCurr: state_type] :
      ( v101710(VarCurr)
    <=> ( v101622(VarCurr,4)
        | v101704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9711,axiom,
    ! [VarCurr: state_type] :
      ( v101708(VarCurr)
    <=> ( v101657(VarCurr)
        | v101709(VarCurr) ) ) ).

tff(writeUnaryOperator_4940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101709(VarCurr)
    <=> v101704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9710,axiom,
    ! [VarCurr: state_type] :
      ( v101700(VarCurr)
    <=> ( v101701(VarCurr)
        & v101706(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3952,axiom,
    ! [VarCurr: state_type] :
      ( v101706(VarCurr)
    <=> ( v101622(VarCurr,5)
        | v101703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9709,axiom,
    ! [VarCurr: state_type] :
      ( v101701(VarCurr)
    <=> ( v101658(VarCurr)
        | v101702(VarCurr) ) ) ).

tff(writeUnaryOperator_4939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101702(VarCurr)
    <=> v101703(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3951,axiom,
    ! [VarCurr: state_type] :
      ( v101703(VarCurr)
    <=> ( v101622(VarCurr,4)
        & v101704(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3950,axiom,
    ! [VarCurr: state_type] :
      ( v101704(VarCurr)
    <=> ( v101622(VarCurr,3)
        & v101705(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3949,axiom,
    ! [VarCurr: state_type] :
      ( v101705(VarCurr)
    <=> ( v101622(VarCurr,2)
        & v101697(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9708,axiom,
    ! [VarCurr: state_type] :
      ( v101689(VarCurr)
    <=> ( v101690(VarCurr)
        & v101691(VarCurr) ) ) ).

tff(writeUnaryOperator_4938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101691(VarCurr)
    <=> v101693(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3948,axiom,
    ! [VarCurr: state_type] :
      ( v101693(VarCurr)
    <=> ( v101694(VarCurr)
        & v101622(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3947,axiom,
    ! [VarCurr: state_type] :
      ( v101694(VarCurr)
    <=> ( v101695(VarCurr)
        & v101622(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3946,axiom,
    ! [VarCurr: state_type] :
      ( v101695(VarCurr)
    <=> ( v101696(VarCurr)
        & v101622(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3945,axiom,
    ! [VarCurr: state_type] :
      ( v101696(VarCurr)
    <=> ( v101697(VarCurr)
        & v101622(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3944,axiom,
    ! [VarCurr: state_type] :
      ( v101697(VarCurr)
    <=> ( v101622(VarCurr,0)
        & v101622(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101690(VarCurr)
    <=> v101600(VarCurr) ) ).

tff(addAssignment_62064,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,0)
    <=> v101653(VarCurr) ) ).

tff(addAssignment_62063,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,1)
    <=> v101685(VarCurr) ) ).

tff(addAssignment_62062,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,2)
    <=> v101681(VarCurr) ) ).

tff(addAssignment_62061,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,3)
    <=> v101677(VarCurr) ) ).

tff(addAssignment_62060,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,4)
    <=> v101673(VarCurr) ) ).

tff(addAssignment_62059,axiom,
    ! [VarCurr: state_type] :
      ( v101659(VarCurr,5)
    <=> v101661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9707,axiom,
    ! [VarCurr: state_type] :
      ( v101685(VarCurr)
    <=> ( v101686(VarCurr)
        & v101687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9706,axiom,
    ! [VarCurr: state_type] :
      ( v101687(VarCurr)
    <=> ( v101622(VarCurr,0)
        | v101654(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3943,axiom,
    ! [VarCurr: state_type] :
      ( v101686(VarCurr)
    <=> ( v101653(VarCurr)
        | v101622(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9705,axiom,
    ! [VarCurr: state_type] :
      ( v101681(VarCurr)
    <=> ( v101682(VarCurr)
        & v101684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9704,axiom,
    ! [VarCurr: state_type] :
      ( v101684(VarCurr)
    <=> ( v101655(VarCurr)
        | v101670(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3942,axiom,
    ! [VarCurr: state_type] :
      ( v101682(VarCurr)
    <=> ( v101622(VarCurr,2)
        | v101683(VarCurr) ) ) ).

tff(writeUnaryOperator_4936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101683(VarCurr)
    <=> v101670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9703,axiom,
    ! [VarCurr: state_type] :
      ( v101677(VarCurr)
    <=> ( v101678(VarCurr)
        & v101680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9702,axiom,
    ! [VarCurr: state_type] :
      ( v101680(VarCurr)
    <=> ( v101656(VarCurr)
        | v101668(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3941,axiom,
    ! [VarCurr: state_type] :
      ( v101678(VarCurr)
    <=> ( v101622(VarCurr,3)
        | v101679(VarCurr) ) ) ).

tff(writeUnaryOperator_4935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101679(VarCurr)
    <=> v101668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9701,axiom,
    ! [VarCurr: state_type] :
      ( v101673(VarCurr)
    <=> ( v101674(VarCurr)
        & v101676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9700,axiom,
    ! [VarCurr: state_type] :
      ( v101676(VarCurr)
    <=> ( v101657(VarCurr)
        | v101666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3940,axiom,
    ! [VarCurr: state_type] :
      ( v101674(VarCurr)
    <=> ( v101622(VarCurr,4)
        | v101675(VarCurr) ) ) ).

tff(writeUnaryOperator_4934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101675(VarCurr)
    <=> v101666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9699,axiom,
    ! [VarCurr: state_type] :
      ( v101661(VarCurr)
    <=> ( v101662(VarCurr)
        & v101672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9698,axiom,
    ! [VarCurr: state_type] :
      ( v101672(VarCurr)
    <=> ( v101658(VarCurr)
        | v101664(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3939,axiom,
    ! [VarCurr: state_type] :
      ( v101662(VarCurr)
    <=> ( v101622(VarCurr,5)
        | v101663(VarCurr) ) ) ).

tff(writeUnaryOperator_4933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101663(VarCurr)
    <=> v101664(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3938,axiom,
    ! [VarCurr: state_type] :
      ( v101664(VarCurr)
    <=> ( v101622(VarCurr,4)
        | v101665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9697,axiom,
    ! [VarCurr: state_type] :
      ( v101665(VarCurr)
    <=> ( v101657(VarCurr)
        & v101666(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3937,axiom,
    ! [VarCurr: state_type] :
      ( v101666(VarCurr)
    <=> ( v101622(VarCurr,3)
        | v101667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9696,axiom,
    ! [VarCurr: state_type] :
      ( v101667(VarCurr)
    <=> ( v101656(VarCurr)
        & v101668(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3936,axiom,
    ! [VarCurr: state_type] :
      ( v101668(VarCurr)
    <=> ( v101622(VarCurr,2)
        | v101669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9695,axiom,
    ! [VarCurr: state_type] :
      ( v101669(VarCurr)
    <=> ( v101655(VarCurr)
        & v101670(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3935,axiom,
    ! [VarCurr: state_type] :
      ( v101670(VarCurr)
    <=> ( v101622(VarCurr,1)
        | v101671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9694,axiom,
    ! [VarCurr: state_type] :
      ( v101671(VarCurr)
    <=> ( v101622(VarCurr,0)
        & v101654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9693,axiom,
    ! [VarCurr: state_type] :
      ( v101645(VarCurr)
    <=> ( v101600(VarCurr)
        & v101646(VarCurr) ) ) ).

tff(writeUnaryOperator_4932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101646(VarCurr)
    <=> v101648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9692,axiom,
    ! [VarCurr: state_type] :
      ( v101648(VarCurr)
    <=> ( v101649(VarCurr)
        & v101658(VarCurr) ) ) ).

tff(writeUnaryOperator_4931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101658(VarCurr)
    <=> v101622(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9691,axiom,
    ! [VarCurr: state_type] :
      ( v101649(VarCurr)
    <=> ( v101650(VarCurr)
        & v101657(VarCurr) ) ) ).

tff(writeUnaryOperator_4930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101657(VarCurr)
    <=> v101622(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9690,axiom,
    ! [VarCurr: state_type] :
      ( v101650(VarCurr)
    <=> ( v101651(VarCurr)
        & v101656(VarCurr) ) ) ).

tff(writeUnaryOperator_4929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101656(VarCurr)
    <=> v101622(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9689,axiom,
    ! [VarCurr: state_type] :
      ( v101651(VarCurr)
    <=> ( v101652(VarCurr)
        & v101655(VarCurr) ) ) ).

tff(writeUnaryOperator_4928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101655(VarCurr)
    <=> v101622(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9688,axiom,
    ! [VarCurr: state_type] :
      ( v101652(VarCurr)
    <=> ( v101653(VarCurr)
        & v101654(VarCurr) ) ) ).

tff(writeUnaryOperator_4927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101654(VarCurr)
    <=> v101622(VarCurr,1) ) ).

tff(writeUnaryOperator_4926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101653(VarCurr)
    <=> v101622(VarCurr,0) ) ).

tff(addAssignment_62058,axiom,
    ! [VarCurr: state_type] :
      ( v101632(VarCurr)
    <=> v101634(VarCurr) ) ).

tff(addAssignment_62057,axiom,
    ! [VarCurr: state_type] :
      ( v101634(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_62056,axiom,
    ! [VarCurr: state_type] :
      ( v101628(VarCurr)
    <=> v101630(VarCurr) ) ).

tff(addAssignment_62055,axiom,
    ! [VarCurr: state_type] :
      ( v101630(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_62054,axiom,
    ! [VarCurr: state_type] :
      ( v101610(VarCurr)
    <=> v101612(VarCurr) ) ).

tff(addAssignment_62053,axiom,
    ! [VarCurr: state_type] :
      ( v101612(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_62052,axiom,
    ! [VarCurr: state_type] :
      ( v101606(VarCurr)
    <=> v101608(VarCurr) ) ).

tff(addAssignment_62051,axiom,
    ! [VarCurr: state_type] :
      ( v101608(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_62050,axiom,
    ! [VarCurr: state_type] :
      ( v101582(VarCurr)
    <=> v101584(VarCurr) ) ).

tff(addAssignment_62049,axiom,
    ! [VarCurr: state_type] :
      ( v101584(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_62048,axiom,
    ! [VarCurr: state_type] :
      ( v101578(VarCurr)
    <=> v101580(VarCurr) ) ).

tff(addAssignment_62047,axiom,
    ! [VarCurr: state_type] :
      ( v101580(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_62046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v101563(VarCurr,B)
      <=> v101565(VarCurr,B) ) ) ).

tff(addAssignment_62045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v101565(VarCurr,B)
      <=> v101567(VarCurr,B) ) ) ).

tff(addAssignment_62044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v101567(VarCurr,B)
      <=> v101568(VarCurr,B) ) ) ).

tff(addAssignment_62043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101568(VarCurr,B)
      <=> v100229(VarCurr,B) ) ) ).

tff(addAssignment_62042,axiom,
    ! [VarCurr: state_type] :
      ( v101568(VarCurr,3)
    <=> v100219(VarCurr,3) ) ).

tff(addAssignment_62041,axiom,
    ! [VarCurr: state_type] :
      ( ( v101568(VarCurr,9)
      <=> v100229(VarCurr,8) )
      & ( v101568(VarCurr,8)
      <=> v100229(VarCurr,7) )
      & ( v101568(VarCurr,7)
      <=> v100229(VarCurr,6) )
      & ( v101568(VarCurr,6)
      <=> v100229(VarCurr,5) )
      & ( v101568(VarCurr,5)
      <=> v100229(VarCurr,4) )
      & ( v101568(VarCurr,4)
      <=> v100229(VarCurr,3) ) ) ).

tff(addAssignment_62040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100229(VarCurr,B)
      <=> v101555(VarCurr,B) ) ) ).

tff(addAssignment_62039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100409(VarCurr,B)
      <=> v101508(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9687,axiom,
    ! [VarCurr: state_type] :
      ( v101501(VarCurr)
    <=> ( v101503(VarCurr)
        | v101559(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3934,axiom,
    ! [VarCurr: state_type] :
      ( v101559(VarCurr)
    <=> ( v100207(VarCurr,0)
        & v101505(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9686,axiom,
    ! [VarCurr: state_type] :
      ( v101503(VarCurr)
    <=> ( v100207(VarCurr,0)
        & v101557(VarCurr) ) ) ).

tff(writeUnaryOperator_4925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101557(VarCurr)
    <=> v101505(VarCurr,15) ) ).

tff(addAssignment_62038,axiom,
    ! [VarCurr: state_type] :
      ( v101505(VarCurr,15)
    <=> v101507(VarCurr,15) ) ).

tff(addAssignment_62037,axiom,
    ! [VarCurr: state_type] :
      ( v101507(VarCurr,15)
    <=> v100229(VarCurr,15) ) ).

tff(addAssignment_62036,axiom,
    ! [VarCurr: state_type] :
      ( v100229(VarCurr,15)
    <=> v101555(VarCurr,15) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v101555(VarCurr,B)
          <=> v100409(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_684,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v101555(VarCurr,B)
          <=> v97411(VarCurr,B) ) ) ) ).

tff(addAssignment_62035,axiom,
    ! [VarCurr: state_type] :
      ( v100409(VarCurr,15)
    <=> v101508(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101508(VarCurr,B)
      <=> ( v101509(VarCurr,B)
          | v101553(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101553(VarCurr,B)
      <=> ( v101554(VarCurr,B)
          & v98301(VarCurr,B) ) ) ) ).

tff(addAssignment_62034,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,0)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62033,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,1)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62032,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,2)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62031,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,3)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62030,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,4)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62029,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,5)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62028,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,6)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62027,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,7)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62026,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,8)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62025,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,9)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62024,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,10)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62023,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,11)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62022,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,12)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62021,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,13)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62020,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,14)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_62019,axiom,
    ! [VarCurr: state_type] :
      ( v101554(VarCurr,15)
    <=> v100508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101509(VarCurr,B)
      <=> ( v101510(VarCurr,B)
          | v101551(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101551(VarCurr,B)
      <=> ( v101552(VarCurr,B)
          & v98245(VarCurr,B) ) ) ) ).

tff(addAssignment_62018,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,0)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62017,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,1)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62016,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,2)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62015,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,3)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62014,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,4)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62013,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,5)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62012,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,6)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62011,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,7)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62010,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,8)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62009,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,9)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62008,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,10)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62007,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,11)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62006,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,12)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62005,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,13)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62004,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,14)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_62003,axiom,
    ! [VarCurr: state_type] :
      ( v101552(VarCurr,15)
    <=> v100505(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101510(VarCurr,B)
      <=> ( v101511(VarCurr,B)
          | v101549(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101549(VarCurr,B)
      <=> ( v101550(VarCurr,B)
          & v98189(VarCurr,B) ) ) ) ).

tff(addAssignment_62002,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,0)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_62001,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,1)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_62000,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,2)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61999,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,3)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61998,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,4)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61997,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,5)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61996,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,6)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61995,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,7)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61994,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,8)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61993,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,9)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61992,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,10)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61991,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,11)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61990,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,12)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61989,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,13)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61988,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,14)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61987,axiom,
    ! [VarCurr: state_type] :
      ( v101550(VarCurr,15)
    <=> v100502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101511(VarCurr,B)
      <=> ( v101512(VarCurr,B)
          | v101547(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101547(VarCurr,B)
      <=> ( v101548(VarCurr,B)
          & v98133(VarCurr,B) ) ) ) ).

tff(addAssignment_61986,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,0)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61985,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,1)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61984,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,2)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61983,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,3)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61982,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,4)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61981,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,5)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61980,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,6)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61979,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,7)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61978,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,8)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61977,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,9)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61976,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,10)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61975,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,11)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61974,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,12)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61973,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,13)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61972,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,14)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61971,axiom,
    ! [VarCurr: state_type] :
      ( v101548(VarCurr,15)
    <=> v100499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101512(VarCurr,B)
      <=> ( v101513(VarCurr,B)
          | v101545(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101545(VarCurr,B)
      <=> ( v101546(VarCurr,B)
          & v98077(VarCurr,B) ) ) ) ).

tff(addAssignment_61970,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,0)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61969,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,1)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61968,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,2)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61967,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,3)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61966,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,4)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61965,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,5)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61964,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,6)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61963,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,7)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61962,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,8)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61961,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,9)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61960,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,10)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61959,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,11)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61958,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,12)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61957,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,13)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61956,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,14)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61955,axiom,
    ! [VarCurr: state_type] :
      ( v101546(VarCurr,15)
    <=> v100496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101513(VarCurr,B)
      <=> ( v101514(VarCurr,B)
          | v101543(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101543(VarCurr,B)
      <=> ( v101544(VarCurr,B)
          & v98021(VarCurr,B) ) ) ) ).

tff(addAssignment_61954,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,0)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61953,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,1)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61952,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,2)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61951,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,3)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61950,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,4)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61949,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,5)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61948,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,6)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61947,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,7)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61946,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,8)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61945,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,9)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61944,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,10)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61943,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,11)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61942,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,12)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61941,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,13)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61940,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,14)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61939,axiom,
    ! [VarCurr: state_type] :
      ( v101544(VarCurr,15)
    <=> v100493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101514(VarCurr,B)
      <=> ( v101515(VarCurr,B)
          | v101541(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101541(VarCurr,B)
      <=> ( v101542(VarCurr,B)
          & v97965(VarCurr,B) ) ) ) ).

tff(addAssignment_61938,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,0)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61937,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,1)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61936,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,2)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61935,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,3)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61934,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,4)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61933,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,5)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61932,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,6)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61931,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,7)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61930,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,8)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61929,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,9)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61928,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,10)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61927,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,11)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61926,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,12)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61925,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,13)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61924,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,14)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61923,axiom,
    ! [VarCurr: state_type] :
      ( v101542(VarCurr,15)
    <=> v100490(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101515(VarCurr,B)
      <=> ( v101516(VarCurr,B)
          | v101539(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101539(VarCurr,B)
      <=> ( v101540(VarCurr,B)
          & v97909(VarCurr,B) ) ) ) ).

tff(addAssignment_61922,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,0)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61921,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,1)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61920,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,2)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61919,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,3)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61918,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,4)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61917,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,5)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61916,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,6)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61915,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,7)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61914,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,8)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61913,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,9)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61912,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,10)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61911,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,11)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61910,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,12)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61909,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,13)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61908,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,14)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61907,axiom,
    ! [VarCurr: state_type] :
      ( v101540(VarCurr,15)
    <=> v100487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101516(VarCurr,B)
      <=> ( v101517(VarCurr,B)
          | v101537(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101537(VarCurr,B)
      <=> ( v101538(VarCurr,B)
          & v97853(VarCurr,B) ) ) ) ).

tff(addAssignment_61906,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,0)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61905,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,1)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61904,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,2)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61903,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,3)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61902,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,4)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61901,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,5)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61900,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,6)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61899,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,7)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61898,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,8)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61897,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,9)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61896,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,10)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61895,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,11)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61894,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,12)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61893,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,13)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61892,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,14)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61891,axiom,
    ! [VarCurr: state_type] :
      ( v101538(VarCurr,15)
    <=> v100484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101517(VarCurr,B)
      <=> ( v101518(VarCurr,B)
          | v101535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101535(VarCurr,B)
      <=> ( v101536(VarCurr,B)
          & v97797(VarCurr,B) ) ) ) ).

tff(addAssignment_61890,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,0)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61889,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,1)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61888,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,2)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61887,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,3)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61886,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,4)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61885,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,5)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61884,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,6)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61883,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,7)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61882,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,8)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61881,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,9)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61880,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,10)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61879,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,11)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61878,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,12)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61877,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,13)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61876,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,14)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61875,axiom,
    ! [VarCurr: state_type] :
      ( v101536(VarCurr,15)
    <=> v100481(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101518(VarCurr,B)
      <=> ( v101519(VarCurr,B)
          | v101533(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101533(VarCurr,B)
      <=> ( v101534(VarCurr,B)
          & v97741(VarCurr,B) ) ) ) ).

tff(addAssignment_61874,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,0)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61873,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,1)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61872,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,2)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61871,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,3)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61870,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,4)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61869,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,5)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61868,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,6)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61867,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,7)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61866,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,8)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61865,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,9)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61864,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,10)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61863,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,11)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61862,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,12)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61861,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,13)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61860,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,14)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61859,axiom,
    ! [VarCurr: state_type] :
      ( v101534(VarCurr,15)
    <=> v100478(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101519(VarCurr,B)
      <=> ( v101520(VarCurr,B)
          | v101531(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101531(VarCurr,B)
      <=> ( v101532(VarCurr,B)
          & v97685(VarCurr,B) ) ) ) ).

tff(addAssignment_61858,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,0)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61857,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,1)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61856,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,2)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61855,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,3)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61854,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,4)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61853,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,5)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61852,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,6)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61851,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,7)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61850,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,8)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61849,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,9)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61848,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,10)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61847,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,11)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61846,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,12)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61845,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,13)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61844,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,14)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61843,axiom,
    ! [VarCurr: state_type] :
      ( v101532(VarCurr,15)
    <=> v100475(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101520(VarCurr,B)
      <=> ( v101521(VarCurr,B)
          | v101529(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101529(VarCurr,B)
      <=> ( v101530(VarCurr,B)
          & v97629(VarCurr,B) ) ) ) ).

tff(addAssignment_61842,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,0)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61841,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,1)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61840,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,2)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61839,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,3)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61838,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,4)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61837,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,5)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61836,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,6)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61835,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,7)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61834,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,8)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61833,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,9)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61832,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,10)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61831,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,11)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61830,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,12)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61829,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,13)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61828,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,14)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61827,axiom,
    ! [VarCurr: state_type] :
      ( v101530(VarCurr,15)
    <=> v100472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101521(VarCurr,B)
      <=> ( v101522(VarCurr,B)
          | v101527(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101527(VarCurr,B)
      <=> ( v101528(VarCurr,B)
          & v97573(VarCurr,B) ) ) ) ).

tff(addAssignment_61826,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,0)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61825,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,1)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61824,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,2)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61823,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,3)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61822,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,4)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61821,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,5)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61820,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,6)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61819,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,7)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61818,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,8)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61817,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,9)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61816,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,10)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61815,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,11)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61814,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,12)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61813,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,13)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61812,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,14)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61811,axiom,
    ! [VarCurr: state_type] :
      ( v101528(VarCurr,15)
    <=> v100469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101522(VarCurr,B)
      <=> ( v101523(VarCurr,B)
          | v101525(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101525(VarCurr,B)
      <=> ( v101526(VarCurr,B)
          & v97517(VarCurr,B) ) ) ) ).

tff(addAssignment_61810,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,0)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61809,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,1)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61808,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,2)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61807,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,3)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61806,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,4)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61805,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,5)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61804,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,6)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61803,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,7)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61802,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,8)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61801,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,9)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61800,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,10)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61799,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,11)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61798,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,12)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61797,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,13)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61796,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,14)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61795,axiom,
    ! [VarCurr: state_type] :
      ( v101526(VarCurr,15)
    <=> v100466(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101523(VarCurr,B)
      <=> ( v101524(VarCurr,B)
          & v97413(VarCurr,B) ) ) ) ).

tff(addAssignment_61794,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,0)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61793,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,1)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61792,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,2)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61791,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,3)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61790,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,4)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61789,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,5)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61788,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,6)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61787,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,7)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61786,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,8)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61785,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,9)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61784,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,10)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61783,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,11)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61782,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,12)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61781,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,13)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61780,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,14)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61779,axiom,
    ! [VarCurr: state_type] :
      ( v101524(VarCurr,15)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61778,axiom,
    ! [VarCurr: state_type] :
      ( v101483(VarCurr)
    <=> v101485(VarCurr) ) ).

tff(addAssignment_61777,axiom,
    ! [VarCurr: state_type] :
      ( v101485(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_61776,axiom,
    ! [VarCurr: state_type] :
      ( v101479(VarCurr)
    <=> v101481(VarCurr) ) ).

tff(addAssignment_61775,axiom,
    ! [VarCurr: state_type] :
      ( v101481(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_61774,axiom,
    ! [VarCurr: state_type] :
      ( v101258(VarCurr,0)
    <=> v101260(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_663,axiom,
    ! [VarCurr: state_type] :
      ( v101260(VarCurr)
    <=> ( ( v101262(VarCurr,3)
        <=> $false )
        & ( v101262(VarCurr,2)
        <=> $false )
        & ( v101262(VarCurr,1)
        <=> $false )
        & ( v101262(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_61773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101262(VarCurr,B)
      <=> v101264(VarCurr,B) ) ) ).

tff(addAssignment_61772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101264(VarCurr,B)
      <=> v101266(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101451(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v101266(VarNext,B)
            <=> v101266(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1195,axiom,
    ! [VarNext: state_type] :
      ( v101451(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101266(VarNext,B)
          <=> v101461(VarNext,B) ) ) ) ).

tff(addAssignment_61771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101461(VarNext,B)
          <=> v101459(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101459(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_683,axiom,
    ! [VarCurr: state_type] :
      ( v101462(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101459(VarCurr,B)
          <=> v101276(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9685,axiom,
    ! [VarCurr: state_type] :
      ( v101462(VarCurr)
    <=> ( v101463(VarCurr)
        & v101464(VarCurr) ) ) ).

tff(writeUnaryOperator_4924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101464(VarCurr)
    <=> v101272(VarCurr) ) ).

tff(writeUnaryOperator_4923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101463(VarCurr)
    <=> v101268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101451(VarNext)
      <=> v101452(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101452(VarNext)
      <=> ( v101453(VarNext)
          & v101444(VarNext) ) ) ) ).

tff(writeUnaryOperator_4922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101453(VarNext)
      <=> v101455(VarNext) ) ) ).

tff(addAssignment_61770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101455(VarNext)
      <=> v101444(VarCurr) ) ) ).

tff(addAssignment_61769,axiom,
    ! [VarCurr: state_type] :
      ( v101444(VarCurr)
    <=> v101446(VarCurr) ) ).

tff(addAssignment_61768,axiom,
    ! [VarCurr: state_type] :
      ( v101446(VarCurr)
    <=> v101448(VarCurr) ) ).

tff(addAssignment_61767,axiom,
    ! [VarCurr: state_type] :
      ( v101448(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_61766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101276(VarCurr,B)
      <=> v101278(VarCurr,B) ) ) ).

tff(addAssignment_61765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101278(VarCurr,B)
      <=> v101280(VarCurr,B) ) ) ).

tff(addAssignment_61764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101280(VarCurr,B)
      <=> v101282(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89210(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101282(VarCurr,B)
          <=> v101419(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_682,axiom,
    ! [VarCurr: state_type] :
      ( v89210(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101282(VarCurr,B)
          <=> v101284(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101420(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101419(VarCurr,B)
          <=> v101421(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_681,axiom,
    ! [VarCurr: state_type] :
      ( v101420(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101419(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101421(VarCurr,B)
          <=> v101262(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_680,axiom,
    ! [VarCurr: state_type] :
      ( v101417(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101421(VarCurr,B)
          <=> v101422(VarCurr,B) ) ) ) ).

tff(addAssignment_61763,axiom,
    ! [VarCurr: state_type] :
      ( v101422(VarCurr,0)
    <=> v101441(VarCurr) ) ).

tff(addAssignment_61762,axiom,
    ! [VarCurr: state_type] :
      ( v101422(VarCurr,1)
    <=> v101439(VarCurr) ) ).

tff(addAssignment_61761,axiom,
    ! [VarCurr: state_type] :
      ( v101422(VarCurr,2)
    <=> v101435(VarCurr) ) ).

tff(addAssignment_61760,axiom,
    ! [VarCurr: state_type] :
      ( v101422(VarCurr,3)
    <=> v101424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9682,axiom,
    ! [VarCurr: state_type] :
      ( v101439(VarCurr)
    <=> ( v101440(VarCurr)
        & v101442(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9681,axiom,
    ! [VarCurr: state_type] :
      ( v101442(VarCurr)
    <=> ( v101262(VarCurr,0)
        | v101431(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3933,axiom,
    ! [VarCurr: state_type] :
      ( v101440(VarCurr)
    <=> ( v101441(VarCurr)
        | v101262(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101441(VarCurr)
    <=> v101262(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9680,axiom,
    ! [VarCurr: state_type] :
      ( v101435(VarCurr)
    <=> ( v101436(VarCurr)
        & v101438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9679,axiom,
    ! [VarCurr: state_type] :
      ( v101438(VarCurr)
    <=> ( v101429(VarCurr)
        | v101432(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3932,axiom,
    ! [VarCurr: state_type] :
      ( v101436(VarCurr)
    <=> ( v101437(VarCurr)
        | v101262(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101437(VarCurr)
    <=> v101429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9678,axiom,
    ! [VarCurr: state_type] :
      ( v101424(VarCurr)
    <=> ( v101425(VarCurr)
        & v101433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9677,axiom,
    ! [VarCurr: state_type] :
      ( v101433(VarCurr)
    <=> ( v101427(VarCurr)
        | v101434(VarCurr) ) ) ).

tff(writeUnaryOperator_4919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101434(VarCurr)
    <=> v101262(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_3931,axiom,
    ! [VarCurr: state_type] :
      ( v101425(VarCurr)
    <=> ( v101426(VarCurr)
        | v101262(VarCurr,3) ) ) ).

tff(writeUnaryOperator_4918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101426(VarCurr)
    <=> v101427(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3930,axiom,
    ! [VarCurr: state_type] :
      ( v101427(VarCurr)
    <=> ( v101262(VarCurr,2)
        | v101428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9676,axiom,
    ! [VarCurr: state_type] :
      ( v101428(VarCurr)
    <=> ( v101429(VarCurr)
        & v101432(VarCurr) ) ) ).

tff(writeUnaryOperator_4917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101432(VarCurr)
    <=> v101262(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_3929,axiom,
    ! [VarCurr: state_type] :
      ( v101429(VarCurr)
    <=> ( v101262(VarCurr,1)
        | v101430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9675,axiom,
    ! [VarCurr: state_type] :
      ( v101430(VarCurr)
    <=> ( v101262(VarCurr,0)
        & v101431(VarCurr) ) ) ).

tff(writeUnaryOperator_4916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101431(VarCurr)
    <=> v101262(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_662,axiom,
    ! [VarCurr: state_type] :
      ( v101420(VarCurr)
    <=> ( ( v101262(VarCurr,3)
        <=> $false )
        & ( v101262(VarCurr,2)
        <=> $false )
        & ( v101262(VarCurr,1)
        <=> $false )
        & ( v101262(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_61759,axiom,
    ! [VarCurr: state_type] :
      ( v101417(VarCurr)
    <=> v88418(VarCurr) ) ).

tff(addAssignment_61758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101284(VarCurr,B)
      <=> v101286(VarCurr,B) ) ) ).

tff(addAssignment_61757,axiom,
    ! [VarCurr: state_type] :
      ( v101286(VarCurr,0)
    <=> v101411(VarCurr) ) ).

tff(addAssignment_61756,axiom,
    ! [VarCurr: state_type] :
      ( v101286(VarCurr,1)
    <=> v101406(VarCurr) ) ).

tff(addAssignment_61755,axiom,
    ! [VarCurr: state_type] :
      ( v101286(VarCurr,2)
    <=> v101401(VarCurr) ) ).

tff(addAssignment_61754,axiom,
    ! [VarCurr: state_type] :
      ( v101286(VarCurr,3)
    <=> v101372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9674,axiom,
    ! [VarCurr: state_type] :
      ( v101411(VarCurr)
    <=> ( v101412(VarCurr)
        & v101415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9673,axiom,
    ! [VarCurr: state_type] :
      ( v101415(VarCurr)
    <=> ( v101288(VarCurr,0)
        | v101380(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9672,axiom,
    ! [VarCurr: state_type] :
      ( v101412(VarCurr)
    <=> ( v101413(VarCurr)
        | v101414(VarCurr) ) ) ).

tff(writeUnaryOperator_4915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101414(VarCurr)
    <=> v101380(VarCurr,0) ) ).

tff(writeUnaryOperator_4914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101413(VarCurr)
    <=> v101288(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9671,axiom,
    ! [VarCurr: state_type] :
      ( v101406(VarCurr)
    <=> ( v101407(VarCurr)
        & v101410(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9670,axiom,
    ! [VarCurr: state_type] :
      ( v101410(VarCurr)
    <=> ( v101379(VarCurr)
        | v101382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9669,axiom,
    ! [VarCurr: state_type] :
      ( v101407(VarCurr)
    <=> ( v101408(VarCurr)
        | v101409(VarCurr) ) ) ).

tff(writeUnaryOperator_4913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101409(VarCurr)
    <=> v101382(VarCurr) ) ).

tff(writeUnaryOperator_4912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101408(VarCurr)
    <=> v101379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9668,axiom,
    ! [VarCurr: state_type] :
      ( v101401(VarCurr)
    <=> ( v101402(VarCurr)
        & v101405(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9667,axiom,
    ! [VarCurr: state_type] :
      ( v101405(VarCurr)
    <=> ( v101377(VarCurr)
        | v101388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9666,axiom,
    ! [VarCurr: state_type] :
      ( v101402(VarCurr)
    <=> ( v101403(VarCurr)
        | v101404(VarCurr) ) ) ).

tff(writeUnaryOperator_4911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101404(VarCurr)
    <=> v101388(VarCurr) ) ).

tff(writeUnaryOperator_4910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101403(VarCurr)
    <=> v101377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9665,axiom,
    ! [VarCurr: state_type] :
      ( v101372(VarCurr)
    <=> ( v101373(VarCurr)
        & v101400(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9664,axiom,
    ! [VarCurr: state_type] :
      ( v101400(VarCurr)
    <=> ( v101375(VarCurr)
        | v101395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9663,axiom,
    ! [VarCurr: state_type] :
      ( v101373(VarCurr)
    <=> ( v101374(VarCurr)
        | v101394(VarCurr) ) ) ).

tff(writeUnaryOperator_4909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101394(VarCurr)
    <=> v101395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9662,axiom,
    ! [VarCurr: state_type] :
      ( v101395(VarCurr)
    <=> ( v101396(VarCurr)
        & v101399(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3928,axiom,
    ! [VarCurr: state_type] :
      ( v101399(VarCurr)
    <=> ( v101288(VarCurr,3)
        | v101380(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9661,axiom,
    ! [VarCurr: state_type] :
      ( v101396(VarCurr)
    <=> ( v101397(VarCurr)
        | v101398(VarCurr) ) ) ).

tff(writeUnaryOperator_4908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101398(VarCurr)
    <=> v101380(VarCurr,3) ) ).

tff(writeUnaryOperator_4907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101397(VarCurr)
    <=> v101288(VarCurr,3) ) ).

tff(writeUnaryOperator_4906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101374(VarCurr)
    <=> v101375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9660,axiom,
    ! [VarCurr: state_type] :
      ( v101375(VarCurr)
    <=> ( v101376(VarCurr)
        | v101393(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3927,axiom,
    ! [VarCurr: state_type] :
      ( v101393(VarCurr)
    <=> ( v101288(VarCurr,2)
        & v101380(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9659,axiom,
    ! [VarCurr: state_type] :
      ( v101376(VarCurr)
    <=> ( v101377(VarCurr)
        & v101388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9658,axiom,
    ! [VarCurr: state_type] :
      ( v101388(VarCurr)
    <=> ( v101389(VarCurr)
        & v101392(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3926,axiom,
    ! [VarCurr: state_type] :
      ( v101392(VarCurr)
    <=> ( v101288(VarCurr,2)
        | v101380(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9657,axiom,
    ! [VarCurr: state_type] :
      ( v101389(VarCurr)
    <=> ( v101390(VarCurr)
        | v101391(VarCurr) ) ) ).

tff(writeUnaryOperator_4905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101391(VarCurr)
    <=> v101380(VarCurr,2) ) ).

tff(writeUnaryOperator_4904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101390(VarCurr)
    <=> v101288(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9656,axiom,
    ! [VarCurr: state_type] :
      ( v101377(VarCurr)
    <=> ( v101378(VarCurr)
        | v101387(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3925,axiom,
    ! [VarCurr: state_type] :
      ( v101387(VarCurr)
    <=> ( v101288(VarCurr,1)
        & v101380(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9655,axiom,
    ! [VarCurr: state_type] :
      ( v101378(VarCurr)
    <=> ( v101379(VarCurr)
        & v101382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9654,axiom,
    ! [VarCurr: state_type] :
      ( v101382(VarCurr)
    <=> ( v101383(VarCurr)
        & v101386(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3924,axiom,
    ! [VarCurr: state_type] :
      ( v101386(VarCurr)
    <=> ( v101288(VarCurr,1)
        | v101380(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9653,axiom,
    ! [VarCurr: state_type] :
      ( v101383(VarCurr)
    <=> ( v101384(VarCurr)
        | v101385(VarCurr) ) ) ).

tff(writeUnaryOperator_4903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101385(VarCurr)
    <=> v101380(VarCurr,1) ) ).

tff(writeUnaryOperator_4902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101384(VarCurr)
    <=> v101288(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9652,axiom,
    ! [VarCurr: state_type] :
      ( v101379(VarCurr)
    <=> ( v101288(VarCurr,0)
        & v101380(VarCurr,0) ) ) ).

tff(addZeroExtensionConstraint_39,axiom,
    ! [VarCurr: state_type] : ~ v101380(VarCurr,3) ).

tff(addAssignment_61753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v101380(VarCurr,B)
      <=> v101381(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101381(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_679,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101381(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(addAssignment_61752,axiom,
    ! [VarCurr: state_type] :
      ( v101288(VarCurr,3)
    <=> v101290(VarCurr,3) ) ).

tff(addAssignment_61751,axiom,
    ! [VarCurr: state_type] :
      ( v101290(VarCurr,3)
    <=> v101292(VarCurr,3) ) ).

tff(addAssignment_61750,axiom,
    ! [VarNext: state_type] :
      ( v101292(VarNext,3)
    <=> v101363(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101364(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v101363(VarNext,B)
            <=> v101292(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1194,axiom,
    ! [VarNext: state_type] :
      ( v101364(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101363(VarNext,B)
          <=> v101340(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101364(VarNext)
      <=> v101365(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101365(VarNext)
      <=> ( v101367(VarNext)
          & v101325(VarNext) ) ) ) ).

tff(writeUnaryOperator_4901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101367(VarNext)
      <=> v101334(VarNext) ) ) ).

tff(addAssignment_61749,axiom,
    ! [VarCurr: state_type] :
      ( v101302(VarCurr,3)
    <=> v101304(VarCurr,3) ) ).

tff(addAssignment_61748,axiom,
    ! [VarCurr: state_type] :
      ( v101304(VarCurr,3)
    <=> v101316(VarCurr,3) ) ).

tff(addAssignment_61747,axiom,
    ! [VarCurr: state_type] :
      ( v101306(VarCurr,3)
    <=> v101308(VarCurr,3) ) ).

tff(addAssignment_61746,axiom,
    ! [VarCurr: state_type] :
      ( v101308(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_61745,axiom,
    ! [VarCurr: state_type] :
      ( v101288(VarCurr,2)
    <=> v101290(VarCurr,2) ) ).

tff(addAssignment_61744,axiom,
    ! [VarCurr: state_type] :
      ( v101290(VarCurr,2)
    <=> v101292(VarCurr,2) ) ).

tff(addAssignment_61743,axiom,
    ! [VarNext: state_type] :
      ( v101292(VarNext,2)
    <=> v101355(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101356(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v101355(VarNext,B)
            <=> v101292(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1193,axiom,
    ! [VarNext: state_type] :
      ( v101356(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101355(VarNext,B)
          <=> v101340(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101356(VarNext)
      <=> v101357(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101357(VarNext)
      <=> ( v101359(VarNext)
          & v101325(VarNext) ) ) ) ).

tff(writeUnaryOperator_4900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101359(VarNext)
      <=> v101334(VarNext) ) ) ).

tff(addAssignment_61742,axiom,
    ! [VarCurr: state_type] :
      ( v101302(VarCurr,2)
    <=> v101304(VarCurr,2) ) ).

tff(addAssignment_61741,axiom,
    ! [VarCurr: state_type] :
      ( v101304(VarCurr,2)
    <=> v101316(VarCurr,2) ) ).

tff(addAssignment_61740,axiom,
    ! [VarCurr: state_type] :
      ( v101306(VarCurr,2)
    <=> v101308(VarCurr,2) ) ).

tff(addAssignment_61739,axiom,
    ! [VarCurr: state_type] :
      ( v101308(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_61738,axiom,
    ! [VarCurr: state_type] :
      ( v101288(VarCurr,1)
    <=> v101290(VarCurr,1) ) ).

tff(addAssignment_61737,axiom,
    ! [VarCurr: state_type] :
      ( v101290(VarCurr,1)
    <=> v101292(VarCurr,1) ) ).

tff(addAssignment_61736,axiom,
    ! [VarNext: state_type] :
      ( v101292(VarNext,1)
    <=> v101347(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101348(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v101347(VarNext,B)
            <=> v101292(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1192,axiom,
    ! [VarNext: state_type] :
      ( v101348(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101347(VarNext,B)
          <=> v101340(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101348(VarNext)
      <=> v101349(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101349(VarNext)
      <=> ( v101351(VarNext)
          & v101325(VarNext) ) ) ) ).

tff(writeUnaryOperator_4899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101351(VarNext)
      <=> v101334(VarNext) ) ) ).

tff(addAssignment_61735,axiom,
    ! [VarCurr: state_type] :
      ( v101302(VarCurr,1)
    <=> v101304(VarCurr,1) ) ).

tff(addAssignment_61734,axiom,
    ! [VarCurr: state_type] :
      ( v101304(VarCurr,1)
    <=> v101316(VarCurr,1) ) ).

tff(addAssignment_61733,axiom,
    ! [VarCurr: state_type] :
      ( v101306(VarCurr,1)
    <=> v101308(VarCurr,1) ) ).

tff(addAssignment_61732,axiom,
    ! [VarCurr: state_type] :
      ( v101308(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_61731,axiom,
    ! [VarCurr: state_type] :
      ( v101288(VarCurr,0)
    <=> v101290(VarCurr,0) ) ).

tff(addAssignment_61730,axiom,
    ! [VarCurr: state_type] :
      ( v101290(VarCurr,0)
    <=> v101292(VarCurr,0) ) ).

tff(addAssignment_61729,axiom,
    ! [VarNext: state_type] :
      ( v101292(VarNext,0)
    <=> v101329(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101330(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v101329(VarNext,B)
            <=> v101292(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1191,axiom,
    ! [VarNext: state_type] :
      ( v101330(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101329(VarNext,B)
          <=> v101340(VarNext,B) ) ) ) ).

tff(addAssignment_61728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101340(VarNext,B)
          <=> v101338(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101341(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101338(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_678,axiom,
    ! [VarCurr: state_type] :
      ( v101341(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v101338(VarCurr,B)
          <=> v101302(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9645,axiom,
    ! [VarCurr: state_type] :
      ( v101341(VarCurr)
    <=> ( v101342(VarCurr)
        & v101343(VarCurr) ) ) ).

tff(writeUnaryOperator_4898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101343(VarCurr)
    <=> v101298(VarCurr) ) ).

tff(writeUnaryOperator_4897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101342(VarCurr)
    <=> v101294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101330(VarNext)
      <=> v101331(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101331(VarNext)
      <=> ( v101332(VarNext)
          & v101325(VarNext) ) ) ) ).

tff(writeUnaryOperator_4896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101332(VarNext)
      <=> v101334(VarNext) ) ) ).

tff(addAssignment_61727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101334(VarNext)
      <=> v101325(VarCurr) ) ) ).

tff(addAssignment_61726,axiom,
    ! [VarCurr: state_type] :
      ( v101325(VarCurr)
    <=> v101327(VarCurr) ) ).

tff(addAssignment_61725,axiom,
    ! [VarCurr: state_type] :
      ( v101327(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_61724,axiom,
    ! [VarCurr: state_type] :
      ( v101302(VarCurr,0)
    <=> v101304(VarCurr,0) ) ).

tff(addAssignment_61723,axiom,
    ! [VarCurr: state_type] :
      ( v101304(VarCurr,0)
    <=> v101316(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101316(VarCurr,B)
      <=> ( v101317(VarCurr,B)
          | v101320(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101320(VarCurr,B)
      <=> ( v101290(VarCurr,B)
          & v101321(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101321(VarCurr,B)
      <=> ~ v101322(VarCurr,B) ) ) ).

tff(addAssignment_61722,axiom,
    ! [VarCurr: state_type] :
      ( v101322(VarCurr,0)
    <=> v101323(VarCurr) ) ).

tff(addAssignment_61721,axiom,
    ! [VarCurr: state_type] :
      ( v101322(VarCurr,1)
    <=> v101323(VarCurr) ) ).

tff(addAssignment_61720,axiom,
    ! [VarCurr: state_type] :
      ( v101322(VarCurr,2)
    <=> v101323(VarCurr) ) ).

tff(addAssignment_61719,axiom,
    ! [VarCurr: state_type] :
      ( v101322(VarCurr,3)
    <=> v101323(VarCurr) ) ).

tff(addAssignment_61718,axiom,
    ! [VarCurr: state_type] :
      ( v101323(VarCurr)
    <=> v101310(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v101317(VarCurr,B)
      <=> ( v101306(VarCurr,B)
          & v101318(VarCurr,B) ) ) ) ).

tff(addAssignment_61717,axiom,
    ! [VarCurr: state_type] :
      ( v101318(VarCurr,0)
    <=> v101319(VarCurr) ) ).

tff(addAssignment_61716,axiom,
    ! [VarCurr: state_type] :
      ( v101318(VarCurr,1)
    <=> v101319(VarCurr) ) ).

tff(addAssignment_61715,axiom,
    ! [VarCurr: state_type] :
      ( v101318(VarCurr,2)
    <=> v101319(VarCurr) ) ).

tff(addAssignment_61714,axiom,
    ! [VarCurr: state_type] :
      ( v101318(VarCurr,3)
    <=> v101319(VarCurr) ) ).

tff(addAssignment_61713,axiom,
    ! [VarCurr: state_type] :
      ( v101319(VarCurr)
    <=> v101310(VarCurr) ) ).

tff(addAssignment_61712,axiom,
    ! [VarCurr: state_type] :
      ( v101310(VarCurr)
    <=> v101312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9642,axiom,
    ! [VarCurr: state_type] :
      ( v101312(VarCurr)
    <=> ( v1729(VarCurr)
        & v101315(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_661,axiom,
    ! [VarCurr: state_type] :
      ( v101315(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1507,axiom,
    ~ b0000010100000(12) ).

tff(bitBlastConstant_1506,axiom,
    ~ b0000010100000(11) ).

tff(bitBlastConstant_1505,axiom,
    ~ b0000010100000(10) ).

tff(bitBlastConstant_1504,axiom,
    ~ b0000010100000(9) ).

tff(bitBlastConstant_1503,axiom,
    ~ b0000010100000(8) ).

tff(bitBlastConstant_1502,axiom,
    b0000010100000(7) ).

tff(bitBlastConstant_1501,axiom,
    ~ b0000010100000(6) ).

tff(bitBlastConstant_1500,axiom,
    b0000010100000(5) ).

tff(bitBlastConstant_1499,axiom,
    ~ b0000010100000(4) ).

tff(bitBlastConstant_1498,axiom,
    ~ b0000010100000(3) ).

tff(bitBlastConstant_1497,axiom,
    ~ b0000010100000(2) ).

tff(bitBlastConstant_1496,axiom,
    ~ b0000010100000(1) ).

tff(bitBlastConstant_1495,axiom,
    ~ b0000010100000(0) ).

tff(addAssignment_61711,axiom,
    ! [VarCurr: state_type] :
      ( v101306(VarCurr,0)
    <=> v101308(VarCurr,0) ) ).

tff(addAssignment_61710,axiom,
    ! [VarCurr: state_type] :
      ( v101308(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_61709,axiom,
    ! [VarCurr: state_type] :
      ( v101298(VarCurr)
    <=> v101300(VarCurr) ) ).

tff(addAssignment_61708,axiom,
    ! [VarCurr: state_type] :
      ( v101300(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_61707,axiom,
    ! [VarCurr: state_type] :
      ( v101294(VarCurr)
    <=> v101296(VarCurr) ) ).

tff(addAssignment_61706,axiom,
    ! [VarCurr: state_type] :
      ( v101296(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_61705,axiom,
    ! [VarCurr: state_type] :
      ( v101272(VarCurr)
    <=> v101274(VarCurr) ) ).

tff(addAssignment_61704,axiom,
    ! [VarCurr: state_type] :
      ( v101274(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_61703,axiom,
    ! [VarCurr: state_type] :
      ( v101268(VarCurr)
    <=> v101270(VarCurr) ) ).

tff(addAssignment_61702,axiom,
    ! [VarCurr: state_type] :
      ( v101270(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_61701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v101250(VarCurr,B)
      <=> v85706(VarCurr,B) ) ) ).

tff(addAssignment_61700,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,0)
    <=> v101246(VarCurr) ) ).

tff(addAssignment_61699,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,1)
    <=> v101245(VarCurr) ) ).

tff(addAssignment_61698,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,2)
    <=> v101244(VarCurr) ) ).

tff(addAssignment_61697,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,3)
    <=> v101243(VarCurr) ) ).

tff(addAssignment_61696,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,4)
    <=> v101242(VarCurr) ) ).

tff(addAssignment_61695,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,5)
    <=> v101241(VarCurr) ) ).

tff(addAssignment_61694,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,6)
    <=> v101240(VarCurr) ) ).

tff(addAssignment_61693,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,7)
    <=> v101239(VarCurr) ) ).

tff(addAssignment_61692,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,8)
    <=> v101238(VarCurr) ) ).

tff(addAssignment_61691,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,9)
    <=> v101237(VarCurr) ) ).

tff(addAssignment_61690,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,10)
    <=> v101236(VarCurr) ) ).

tff(addAssignment_61689,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,11)
    <=> v101235(VarCurr) ) ).

tff(addAssignment_61688,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,12)
    <=> v101234(VarCurr) ) ).

tff(addAssignment_61687,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,13)
    <=> v101233(VarCurr) ) ).

tff(addAssignment_61686,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,14)
    <=> v101232(VarCurr) ) ).

tff(addAssignment_61685,axiom,
    ! [VarCurr: state_type] :
      ( v101229(VarCurr,15)
    <=> v101231(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_660,axiom,
    ! [VarCurr: state_type] :
      ( v101246(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_659,axiom,
    ! [VarCurr: state_type] :
      ( v101245(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_658,axiom,
    ! [VarCurr: state_type] :
      ( v101244(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_657,axiom,
    ! [VarCurr: state_type] :
      ( v101243(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_656,axiom,
    ! [VarCurr: state_type] :
      ( v101242(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_655,axiom,
    ! [VarCurr: state_type] :
      ( v101241(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_654,axiom,
    ! [VarCurr: state_type] :
      ( v101240(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_653,axiom,
    ! [VarCurr: state_type] :
      ( v101239(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $false )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_652,axiom,
    ! [VarCurr: state_type] :
      ( v101238(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_651,axiom,
    ! [VarCurr: state_type] :
      ( v101237(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_650,axiom,
    ! [VarCurr: state_type] :
      ( v101236(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_649,axiom,
    ! [VarCurr: state_type] :
      ( v101235(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $false )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_648,axiom,
    ! [VarCurr: state_type] :
      ( v101234(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_647,axiom,
    ! [VarCurr: state_type] :
      ( v101233(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $false )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_646,axiom,
    ! [VarCurr: state_type] :
      ( v101232(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_645,axiom,
    ! [VarCurr: state_type] :
      ( v101231(VarCurr)
    <=> ( ( v100445(VarCurr,6)
        <=> $true )
        & ( v100445(VarCurr,5)
        <=> $true )
        & ( v100445(VarCurr,4)
        <=> $true )
        & ( v100445(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_61684,axiom,
    ! [VarCurr: state_type] :
      ( v100445(VarCurr,5)
    <=> v100446(VarCurr,5) ) ).

tff(addAssignment_61683,axiom,
    ! [VarCurr: state_type] :
      ( v100689(VarCurr,1)
    <=> v101201(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101201(VarCurr,B)
          <=> v101203(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_677,axiom,
    ! [VarCurr: state_type] :
      ( v101202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101201(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101203(VarCurr,B)
          <=> v101206(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_676,axiom,
    ! [VarCurr: state_type] :
      ( v101204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v101203(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_61682,axiom,
    ! [VarCurr: state_type] :
      ( v101206(VarCurr,0)
    <=> v101224(VarCurr) ) ).

tff(addAssignment_61681,axiom,
    ! [VarCurr: state_type] :
      ( v101206(VarCurr,1)
    <=> v101219(VarCurr) ) ).

tff(addAssignment_61680,axiom,
    ! [VarCurr: state_type] :
      ( v101206(VarCurr,2)
    <=> v101207(VarCurr) ) ).

tff(writeUnaryOperator_4894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101224(VarCurr)
    <=> v101225(VarCurr) ) ).

tff(writeUnaryOperator_4893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101219(VarCurr)
    <=> v101221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9641,axiom,
    ! [VarCurr: state_type] :
      ( v101221(VarCurr)
    <=> ( v101218(VarCurr)
        & v101222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9640,axiom,
    ! [VarCurr: state_type] :
      ( v101222(VarCurr)
    <=> ( v101217(VarCurr)
        & v101223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9639,axiom,
    ! [VarCurr: state_type] :
      ( v101223(VarCurr)
    <=> ( v101213(VarCurr)
        & v101216(VarCurr) ) ) ).

tff(writeUnaryOperator_4892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101207(VarCurr)
    <=> v101209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9638,axiom,
    ! [VarCurr: state_type] :
      ( v101209(VarCurr)
    <=> ( v101210(VarCurr)
        & v101218(VarCurr) ) ) ).

tff(writeUnaryOperator_4891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101218(VarCurr)
    <=> v100922(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9637,axiom,
    ! [VarCurr: state_type] :
      ( v101210(VarCurr)
    <=> ( v101211(VarCurr)
        & v101217(VarCurr) ) ) ).

tff(writeUnaryOperator_4890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101217(VarCurr)
    <=> v100922(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9636,axiom,
    ! [VarCurr: state_type] :
      ( v101211(VarCurr)
    <=> ( v101212(VarCurr)
        & v101216(VarCurr) ) ) ).

tff(writeUnaryOperator_4889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101216(VarCurr)
    <=> v100922(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9635,axiom,
    ! [VarCurr: state_type] :
      ( v101212(VarCurr)
    <=> ( v101213(VarCurr)
        | v101214(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3923,axiom,
    ! [VarCurr: state_type] :
      ( v101214(VarCurr)
    <=> ( v101215(VarCurr)
        & v100922(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101215(VarCurr)
    <=> v100922(VarCurr,0) ) ).

tff(writeUnaryOperator_4887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101213(VarCurr)
    <=> v100922(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9634,axiom,
    ! [VarCurr: state_type] :
      ( v101204(VarCurr)
    <=> ( v97208(VarCurr)
        & v101205(VarCurr) ) ) ).

tff(writeUnaryOperator_4886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101205(VarCurr)
    <=> v100691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9633,axiom,
    ! [VarCurr: state_type] :
      ( v101202(VarCurr)
    <=> ( v97208(VarCurr)
        & v100691(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v100922(VarCurr,B)
          <=> v101114(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_675,axiom,
    ! [VarCurr: state_type] :
      ( v101015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v100922(VarCurr,B)
          <=> v101045(VarCurr,B) ) ) ) ).

tff(addAssignment_61679,axiom,
    ! [VarCurr: state_type] :
      ( v101114(VarCurr,0)
    <=> v101198(VarCurr) ) ).

tff(addAssignment_61678,axiom,
    ! [VarCurr: state_type] :
      ( v101114(VarCurr,1)
    <=> v101196(VarCurr) ) ).

tff(addAssignment_61677,axiom,
    ! [VarCurr: state_type] :
      ( v101114(VarCurr,2)
    <=> v101191(VarCurr) ) ).

tff(addAssignment_61676,axiom,
    ! [VarCurr: state_type] :
      ( v101114(VarCurr,3)
    <=> v101186(VarCurr) ) ).

tff(addAssignment_61675,axiom,
    ! [VarCurr: state_type] :
      ( v101114(VarCurr,4)
    <=> v101116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9632,axiom,
    ! [VarCurr: state_type] :
      ( v101196(VarCurr)
    <=> ( v101197(VarCurr)
        & v101200(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3922,axiom,
    ! [VarCurr: state_type] :
      ( v101200(VarCurr)
    <=> ( v101122(VarCurr,0)
        | v101122(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9631,axiom,
    ! [VarCurr: state_type] :
      ( v101197(VarCurr)
    <=> ( v101198(VarCurr)
        | v101199(VarCurr) ) ) ).

tff(writeUnaryOperator_4885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101199(VarCurr)
    <=> v101122(VarCurr,1) ) ).

tff(writeUnaryOperator_4884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101198(VarCurr)
    <=> v101122(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9630,axiom,
    ! [VarCurr: state_type] :
      ( v101191(VarCurr)
    <=> ( v101192(VarCurr)
        & v101195(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3921,axiom,
    ! [VarCurr: state_type] :
      ( v101195(VarCurr)
    <=> ( v101121(VarCurr)
        | v101122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9629,axiom,
    ! [VarCurr: state_type] :
      ( v101192(VarCurr)
    <=> ( v101193(VarCurr)
        | v101194(VarCurr) ) ) ).

tff(writeUnaryOperator_4883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101194(VarCurr)
    <=> v101122(VarCurr,2) ) ).

tff(writeUnaryOperator_4882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101193(VarCurr)
    <=> v101121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9628,axiom,
    ! [VarCurr: state_type] :
      ( v101186(VarCurr)
    <=> ( v101187(VarCurr)
        & v101190(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3920,axiom,
    ! [VarCurr: state_type] :
      ( v101190(VarCurr)
    <=> ( v101120(VarCurr)
        | v101122(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9627,axiom,
    ! [VarCurr: state_type] :
      ( v101187(VarCurr)
    <=> ( v101188(VarCurr)
        | v101189(VarCurr) ) ) ).

tff(writeUnaryOperator_4881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101189(VarCurr)
    <=> v101122(VarCurr,3) ) ).

tff(writeUnaryOperator_4880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101188(VarCurr)
    <=> v101120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9626,axiom,
    ! [VarCurr: state_type] :
      ( v101116(VarCurr)
    <=> ( v101117(VarCurr)
        & v101185(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3919,axiom,
    ! [VarCurr: state_type] :
      ( v101185(VarCurr)
    <=> ( v101119(VarCurr)
        | v101122(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9625,axiom,
    ! [VarCurr: state_type] :
      ( v101117(VarCurr)
    <=> ( v101118(VarCurr)
        | v101184(VarCurr) ) ) ).

tff(writeUnaryOperator_4879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101184(VarCurr)
    <=> v101122(VarCurr,4) ) ).

tff(writeUnaryOperator_4878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101118(VarCurr)
    <=> v101119(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3918,axiom,
    ! [VarCurr: state_type] :
      ( v101119(VarCurr)
    <=> ( v101120(VarCurr)
        & v101122(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3917,axiom,
    ! [VarCurr: state_type] :
      ( v101120(VarCurr)
    <=> ( v101121(VarCurr)
        & v101122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3916,axiom,
    ! [VarCurr: state_type] :
      ( v101121(VarCurr)
    <=> ( v101122(VarCurr,0)
        & v101122(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v101122(VarCurr,B)
      <=> ~ v101123(VarCurr,B) ) ) ).

tff(addAssignment_61674,axiom,
    ! [VarCurr: state_type] :
      ( v101123(VarCurr,0)
    <=> v101111(VarCurr) ) ).

tff(addAssignment_61673,axiom,
    ! [VarCurr: state_type] :
      ( v101123(VarCurr,1)
    <=> v101180(VarCurr) ) ).

tff(addAssignment_61672,axiom,
    ! [VarCurr: state_type] :
      ( v101123(VarCurr,2)
    <=> v101175(VarCurr) ) ).

tff(addAssignment_61671,axiom,
    ! [VarCurr: state_type] :
      ( v101123(VarCurr,3)
    <=> v101170(VarCurr) ) ).

tff(addAssignment_61670,axiom,
    ! [VarCurr: state_type] :
      ( v101123(VarCurr,4)
    <=> v101125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9624,axiom,
    ! [VarCurr: state_type] :
      ( v101180(VarCurr)
    <=> ( v101181(VarCurr)
        & v101183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9623,axiom,
    ! [VarCurr: state_type] :
      ( v101183(VarCurr)
    <=> ( v101056(VarCurr)
        | v101134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9622,axiom,
    ! [VarCurr: state_type] :
      ( v101181(VarCurr)
    <=> ( v101108(VarCurr)
        | v101182(VarCurr) ) ) ).

tff(writeUnaryOperator_4876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101182(VarCurr)
    <=> v101134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9621,axiom,
    ! [VarCurr: state_type] :
      ( v101175(VarCurr)
    <=> ( v101176(VarCurr)
        & v101179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9620,axiom,
    ! [VarCurr: state_type] :
      ( v101179(VarCurr)
    <=> ( v101132(VarCurr)
        | v101139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9619,axiom,
    ! [VarCurr: state_type] :
      ( v101176(VarCurr)
    <=> ( v101177(VarCurr)
        | v101178(VarCurr) ) ) ).

tff(writeUnaryOperator_4875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101178(VarCurr)
    <=> v101139(VarCurr) ) ).

tff(writeUnaryOperator_4874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101177(VarCurr)
    <=> v101132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9618,axiom,
    ! [VarCurr: state_type] :
      ( v101170(VarCurr)
    <=> ( v101171(VarCurr)
        & v101174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9617,axiom,
    ! [VarCurr: state_type] :
      ( v101174(VarCurr)
    <=> ( v101130(VarCurr)
        | v101149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9616,axiom,
    ! [VarCurr: state_type] :
      ( v101171(VarCurr)
    <=> ( v101172(VarCurr)
        | v101173(VarCurr) ) ) ).

tff(writeUnaryOperator_4873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101173(VarCurr)
    <=> v101149(VarCurr) ) ).

tff(writeUnaryOperator_4872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101172(VarCurr)
    <=> v101130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9615,axiom,
    ! [VarCurr: state_type] :
      ( v101125(VarCurr)
    <=> ( v101126(VarCurr)
        & v101169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9614,axiom,
    ! [VarCurr: state_type] :
      ( v101169(VarCurr)
    <=> ( v101128(VarCurr)
        | v101160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9613,axiom,
    ! [VarCurr: state_type] :
      ( v101126(VarCurr)
    <=> ( v101127(VarCurr)
        | v101159(VarCurr) ) ) ).

tff(writeUnaryOperator_4871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101159(VarCurr)
    <=> v101160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9612,axiom,
    ! [VarCurr: state_type] :
      ( v101160(VarCurr)
    <=> ( v101161(VarCurr)
        & v101168(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3915,axiom,
    ! [VarCurr: state_type] :
      ( v101168(VarCurr)
    <=> ( v100411(VarCurr,4)
        | v101163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9611,axiom,
    ! [VarCurr: state_type] :
      ( v101161(VarCurr)
    <=> ( v100968(VarCurr)
        | v101162(VarCurr) ) ) ).

tff(writeUnaryOperator_4870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101162(VarCurr)
    <=> v101163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9610,axiom,
    ! [VarCurr: state_type] :
      ( v101163(VarCurr)
    <=> ( v101164(VarCurr)
        & v101167(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9609,axiom,
    ! [VarCurr: state_type] :
      ( v101167(VarCurr)
    <=> ( v97445(VarCurr)
        | v101166(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3914,axiom,
    ! [VarCurr: state_type] :
      ( v101164(VarCurr)
    <=> ( v97254(VarCurr,4)
        | v101165(VarCurr) ) ) ).

tff(writeUnaryOperator_4869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101165(VarCurr)
    <=> v101166(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9608,axiom,
    ! [VarCurr: state_type] :
      ( v101166(VarCurr)
    <=> ( v97450(VarCurr)
        & v101155(VarCurr) ) ) ).

tff(writeUnaryOperator_4868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101127(VarCurr)
    <=> v101128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9607,axiom,
    ! [VarCurr: state_type] :
      ( v101128(VarCurr)
    <=> ( v101129(VarCurr)
        | v101158(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3913,axiom,
    ! [VarCurr: state_type] :
      ( v101158(VarCurr)
    <=> ( v100411(VarCurr,3)
        & v101152(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9606,axiom,
    ! [VarCurr: state_type] :
      ( v101129(VarCurr)
    <=> ( v101130(VarCurr)
        & v101149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9605,axiom,
    ! [VarCurr: state_type] :
      ( v101149(VarCurr)
    <=> ( v101150(VarCurr)
        & v101157(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3912,axiom,
    ! [VarCurr: state_type] :
      ( v101157(VarCurr)
    <=> ( v100411(VarCurr,3)
        | v101152(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9604,axiom,
    ! [VarCurr: state_type] :
      ( v101150(VarCurr)
    <=> ( v100961(VarCurr)
        | v101151(VarCurr) ) ) ).

tff(writeUnaryOperator_4867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101151(VarCurr)
    <=> v101152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9603,axiom,
    ! [VarCurr: state_type] :
      ( v101152(VarCurr)
    <=> ( v101153(VarCurr)
        & v101156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9602,axiom,
    ! [VarCurr: state_type] :
      ( v101156(VarCurr)
    <=> ( v97450(VarCurr)
        | v101155(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3911,axiom,
    ! [VarCurr: state_type] :
      ( v101153(VarCurr)
    <=> ( v97254(VarCurr,3)
        | v101154(VarCurr) ) ) ).

tff(writeUnaryOperator_4866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101154(VarCurr)
    <=> v101155(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9601,axiom,
    ! [VarCurr: state_type] :
      ( v101155(VarCurr)
    <=> ( v97455(VarCurr)
        & v101145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9600,axiom,
    ! [VarCurr: state_type] :
      ( v101130(VarCurr)
    <=> ( v101131(VarCurr)
        | v101148(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3910,axiom,
    ! [VarCurr: state_type] :
      ( v101148(VarCurr)
    <=> ( v100411(VarCurr,2)
        & v101142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9599,axiom,
    ! [VarCurr: state_type] :
      ( v101131(VarCurr)
    <=> ( v101132(VarCurr)
        & v101139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9598,axiom,
    ! [VarCurr: state_type] :
      ( v101139(VarCurr)
    <=> ( v101140(VarCurr)
        & v101147(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3909,axiom,
    ! [VarCurr: state_type] :
      ( v101147(VarCurr)
    <=> ( v100411(VarCurr,2)
        | v101142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9597,axiom,
    ! [VarCurr: state_type] :
      ( v101140(VarCurr)
    <=> ( v100955(VarCurr)
        | v101141(VarCurr) ) ) ).

tff(writeUnaryOperator_4865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101141(VarCurr)
    <=> v101142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9596,axiom,
    ! [VarCurr: state_type] :
      ( v101142(VarCurr)
    <=> ( v101143(VarCurr)
        & v101146(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9595,axiom,
    ! [VarCurr: state_type] :
      ( v101146(VarCurr)
    <=> ( v97455(VarCurr)
        | v101145(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3908,axiom,
    ! [VarCurr: state_type] :
      ( v101143(VarCurr)
    <=> ( v97254(VarCurr,2)
        | v101144(VarCurr) ) ) ).

tff(writeUnaryOperator_4864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101144(VarCurr)
    <=> v101145(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9594,axiom,
    ! [VarCurr: state_type] :
      ( v101145(VarCurr)
    <=> ( v97459(VarCurr)
        & v97460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9593,axiom,
    ! [VarCurr: state_type] :
      ( v101132(VarCurr)
    <=> ( v101133(VarCurr)
        | v101138(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3907,axiom,
    ! [VarCurr: state_type] :
      ( v101138(VarCurr)
    <=> ( v97457(VarCurr)
        & v100411(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9592,axiom,
    ! [VarCurr: state_type] :
      ( v101133(VarCurr)
    <=> ( v101056(VarCurr)
        & v101134(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9591,axiom,
    ! [VarCurr: state_type] :
      ( v101134(VarCurr)
    <=> ( v101135(VarCurr)
        & v101137(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3906,axiom,
    ! [VarCurr: state_type] :
      ( v101137(VarCurr)
    <=> ( v97457(VarCurr)
        | v100411(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9590,axiom,
    ! [VarCurr: state_type] :
      ( v101135(VarCurr)
    <=> ( v101136(VarCurr)
        | v100949(VarCurr) ) ) ).

tff(writeUnaryOperator_4863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101136(VarCurr)
    <=> v97457(VarCurr) ) ).

tff(addAssignment_61669,axiom,
    ! [VarCurr: state_type] :
      ( v101045(VarCurr,0)
    <=> v101111(VarCurr) ) ).

tff(addAssignment_61668,axiom,
    ! [VarCurr: state_type] :
      ( v101045(VarCurr,1)
    <=> v101106(VarCurr) ) ).

tff(addAssignment_61667,axiom,
    ! [VarCurr: state_type] :
      ( v101045(VarCurr,2)
    <=> v101101(VarCurr) ) ).

tff(addAssignment_61666,axiom,
    ! [VarCurr: state_type] :
      ( v101045(VarCurr,3)
    <=> v101096(VarCurr) ) ).

tff(addAssignment_61665,axiom,
    ! [VarCurr: state_type] :
      ( v101045(VarCurr,4)
    <=> v101047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9589,axiom,
    ! [VarCurr: state_type] :
      ( v101111(VarCurr)
    <=> ( v101112(VarCurr)
        & v101113(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9588,axiom,
    ! [VarCurr: state_type] :
      ( v101113(VarCurr)
    <=> ( v97254(VarCurr,0)
        | v100411(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9587,axiom,
    ! [VarCurr: state_type] :
      ( v101112(VarCurr)
    <=> ( v97459(VarCurr)
        | v100989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9586,axiom,
    ! [VarCurr: state_type] :
      ( v101106(VarCurr)
    <=> ( v101107(VarCurr)
        & v101110(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9585,axiom,
    ! [VarCurr: state_type] :
      ( v101110(VarCurr)
    <=> ( v101056(VarCurr)
        | v101057(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9584,axiom,
    ! [VarCurr: state_type] :
      ( v101107(VarCurr)
    <=> ( v101108(VarCurr)
        | v101109(VarCurr) ) ) ).

tff(writeUnaryOperator_4862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101109(VarCurr)
    <=> v101057(VarCurr) ) ).

tff(writeUnaryOperator_4861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101108(VarCurr)
    <=> v101056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9583,axiom,
    ! [VarCurr: state_type] :
      ( v101101(VarCurr)
    <=> ( v101102(VarCurr)
        & v101105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9582,axiom,
    ! [VarCurr: state_type] :
      ( v101105(VarCurr)
    <=> ( v101054(VarCurr)
        | v101065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9581,axiom,
    ! [VarCurr: state_type] :
      ( v101102(VarCurr)
    <=> ( v101103(VarCurr)
        | v101104(VarCurr) ) ) ).

tff(writeUnaryOperator_4860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101104(VarCurr)
    <=> v101065(VarCurr) ) ).

tff(writeUnaryOperator_4859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101103(VarCurr)
    <=> v101054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9580,axiom,
    ! [VarCurr: state_type] :
      ( v101096(VarCurr)
    <=> ( v101097(VarCurr)
        & v101100(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9579,axiom,
    ! [VarCurr: state_type] :
      ( v101100(VarCurr)
    <=> ( v101052(VarCurr)
        | v101075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9578,axiom,
    ! [VarCurr: state_type] :
      ( v101097(VarCurr)
    <=> ( v101098(VarCurr)
        | v101099(VarCurr) ) ) ).

tff(writeUnaryOperator_4858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101099(VarCurr)
    <=> v101075(VarCurr) ) ).

tff(writeUnaryOperator_4857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101098(VarCurr)
    <=> v101052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9577,axiom,
    ! [VarCurr: state_type] :
      ( v101047(VarCurr)
    <=> ( v101048(VarCurr)
        & v101095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9576,axiom,
    ! [VarCurr: state_type] :
      ( v101095(VarCurr)
    <=> ( v101050(VarCurr)
        | v101086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9575,axiom,
    ! [VarCurr: state_type] :
      ( v101048(VarCurr)
    <=> ( v101049(VarCurr)
        | v101085(VarCurr) ) ) ).

tff(writeUnaryOperator_4856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101085(VarCurr)
    <=> v101086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9574,axiom,
    ! [VarCurr: state_type] :
      ( v101086(VarCurr)
    <=> ( v101087(VarCurr)
        & v101094(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3905,axiom,
    ! [VarCurr: state_type] :
      ( v101094(VarCurr)
    <=> ( v97254(VarCurr,4)
        | v101089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9573,axiom,
    ! [VarCurr: state_type] :
      ( v101087(VarCurr)
    <=> ( v97445(VarCurr)
        | v101088(VarCurr) ) ) ).

tff(writeUnaryOperator_4855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101088(VarCurr)
    <=> v101089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9572,axiom,
    ! [VarCurr: state_type] :
      ( v101089(VarCurr)
    <=> ( v101090(VarCurr)
        & v101093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9571,axiom,
    ! [VarCurr: state_type] :
      ( v101093(VarCurr)
    <=> ( v100968(VarCurr)
        | v101092(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3904,axiom,
    ! [VarCurr: state_type] :
      ( v101090(VarCurr)
    <=> ( v100411(VarCurr,4)
        | v101091(VarCurr) ) ) ).

tff(writeUnaryOperator_4854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101091(VarCurr)
    <=> v101092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9570,axiom,
    ! [VarCurr: state_type] :
      ( v101092(VarCurr)
    <=> ( v100961(VarCurr)
        & v101081(VarCurr) ) ) ).

tff(writeUnaryOperator_4853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101049(VarCurr)
    <=> v101050(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9569,axiom,
    ! [VarCurr: state_type] :
      ( v101050(VarCurr)
    <=> ( v101051(VarCurr)
        | v101084(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3903,axiom,
    ! [VarCurr: state_type] :
      ( v101084(VarCurr)
    <=> ( v97254(VarCurr,3)
        & v101078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9568,axiom,
    ! [VarCurr: state_type] :
      ( v101051(VarCurr)
    <=> ( v101052(VarCurr)
        & v101075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9567,axiom,
    ! [VarCurr: state_type] :
      ( v101075(VarCurr)
    <=> ( v101076(VarCurr)
        & v101083(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3902,axiom,
    ! [VarCurr: state_type] :
      ( v101083(VarCurr)
    <=> ( v97254(VarCurr,3)
        | v101078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9566,axiom,
    ! [VarCurr: state_type] :
      ( v101076(VarCurr)
    <=> ( v97450(VarCurr)
        | v101077(VarCurr) ) ) ).

tff(writeUnaryOperator_4852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101077(VarCurr)
    <=> v101078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9565,axiom,
    ! [VarCurr: state_type] :
      ( v101078(VarCurr)
    <=> ( v101079(VarCurr)
        & v101082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9564,axiom,
    ! [VarCurr: state_type] :
      ( v101082(VarCurr)
    <=> ( v100961(VarCurr)
        | v101081(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3901,axiom,
    ! [VarCurr: state_type] :
      ( v101079(VarCurr)
    <=> ( v100411(VarCurr,3)
        | v101080(VarCurr) ) ) ).

tff(writeUnaryOperator_4851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101080(VarCurr)
    <=> v101081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9563,axiom,
    ! [VarCurr: state_type] :
      ( v101081(VarCurr)
    <=> ( v100955(VarCurr)
        & v101071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9562,axiom,
    ! [VarCurr: state_type] :
      ( v101052(VarCurr)
    <=> ( v101053(VarCurr)
        | v101074(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3900,axiom,
    ! [VarCurr: state_type] :
      ( v101074(VarCurr)
    <=> ( v97254(VarCurr,2)
        & v101068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9561,axiom,
    ! [VarCurr: state_type] :
      ( v101053(VarCurr)
    <=> ( v101054(VarCurr)
        & v101065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9560,axiom,
    ! [VarCurr: state_type] :
      ( v101065(VarCurr)
    <=> ( v101066(VarCurr)
        & v101073(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3899,axiom,
    ! [VarCurr: state_type] :
      ( v101073(VarCurr)
    <=> ( v97254(VarCurr,2)
        | v101068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9559,axiom,
    ! [VarCurr: state_type] :
      ( v101066(VarCurr)
    <=> ( v97455(VarCurr)
        | v101067(VarCurr) ) ) ).

tff(writeUnaryOperator_4850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101067(VarCurr)
    <=> v101068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9558,axiom,
    ! [VarCurr: state_type] :
      ( v101068(VarCurr)
    <=> ( v101069(VarCurr)
        & v101072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9557,axiom,
    ! [VarCurr: state_type] :
      ( v101072(VarCurr)
    <=> ( v100955(VarCurr)
        | v101071(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3898,axiom,
    ! [VarCurr: state_type] :
      ( v101069(VarCurr)
    <=> ( v100411(VarCurr,2)
        | v101070(VarCurr) ) ) ).

tff(writeUnaryOperator_4849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101070(VarCurr)
    <=> v101071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9556,axiom,
    ! [VarCurr: state_type] :
      ( v101071(VarCurr)
    <=> ( v100989(VarCurr)
        & v100949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9555,axiom,
    ! [VarCurr: state_type] :
      ( v101054(VarCurr)
    <=> ( v101055(VarCurr)
        | v101064(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3897,axiom,
    ! [VarCurr: state_type] :
      ( v101064(VarCurr)
    <=> ( v97254(VarCurr,1)
        & v101060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9554,axiom,
    ! [VarCurr: state_type] :
      ( v101055(VarCurr)
    <=> ( v101056(VarCurr)
        & v101057(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9553,axiom,
    ! [VarCurr: state_type] :
      ( v101057(VarCurr)
    <=> ( v101058(VarCurr)
        & v101063(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3896,axiom,
    ! [VarCurr: state_type] :
      ( v101063(VarCurr)
    <=> ( v97254(VarCurr,1)
        | v101060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9552,axiom,
    ! [VarCurr: state_type] :
      ( v101058(VarCurr)
    <=> ( v97460(VarCurr)
        | v101059(VarCurr) ) ) ).

tff(writeUnaryOperator_4848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101059(VarCurr)
    <=> v101060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9551,axiom,
    ! [VarCurr: state_type] :
      ( v101060(VarCurr)
    <=> ( v101061(VarCurr)
        & v101062(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9550,axiom,
    ! [VarCurr: state_type] :
      ( v101062(VarCurr)
    <=> ( v100989(VarCurr)
        | v100949(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3895,axiom,
    ! [VarCurr: state_type] :
      ( v101061(VarCurr)
    <=> ( v100411(VarCurr,0)
        | v100411(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9549,axiom,
    ! [VarCurr: state_type] :
      ( v101056(VarCurr)
    <=> ( v97254(VarCurr,0)
        & v100411(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9548,axiom,
    ! [VarCurr: state_type] :
      ( v101015(VarCurr)
    <=> ( v101017(VarCurr)
        | v101044(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3894,axiom,
    ! [VarCurr: state_type] :
      ( v101044(VarCurr)
    <=> ( v97254(VarCurr,4)
        & v100968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9547,axiom,
    ! [VarCurr: state_type] :
      ( v101017(VarCurr)
    <=> ( v101018(VarCurr)
        & v101040(VarCurr) ) ) ).

tff(writeUnaryOperator_4847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101040(VarCurr)
    <=> v101041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9546,axiom,
    ! [VarCurr: state_type] :
      ( v101041(VarCurr)
    <=> ( v101042(VarCurr)
        & v101043(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3893,axiom,
    ! [VarCurr: state_type] :
      ( v101043(VarCurr)
    <=> ( v97254(VarCurr,4)
        | v100411(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9545,axiom,
    ! [VarCurr: state_type] :
      ( v101042(VarCurr)
    <=> ( v97445(VarCurr)
        | v100968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9544,axiom,
    ! [VarCurr: state_type] :
      ( v101018(VarCurr)
    <=> ( v101019(VarCurr)
        | v101039(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3892,axiom,
    ! [VarCurr: state_type] :
      ( v101039(VarCurr)
    <=> ( v97254(VarCurr,3)
        & v100961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9543,axiom,
    ! [VarCurr: state_type] :
      ( v101019(VarCurr)
    <=> ( v101020(VarCurr)
        & v101035(VarCurr) ) ) ).

tff(writeUnaryOperator_4846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101035(VarCurr)
    <=> v101036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9542,axiom,
    ! [VarCurr: state_type] :
      ( v101036(VarCurr)
    <=> ( v101037(VarCurr)
        & v101038(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3891,axiom,
    ! [VarCurr: state_type] :
      ( v101038(VarCurr)
    <=> ( v97254(VarCurr,3)
        | v100411(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9541,axiom,
    ! [VarCurr: state_type] :
      ( v101037(VarCurr)
    <=> ( v97450(VarCurr)
        | v100961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9540,axiom,
    ! [VarCurr: state_type] :
      ( v101020(VarCurr)
    <=> ( v101021(VarCurr)
        | v101034(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3890,axiom,
    ! [VarCurr: state_type] :
      ( v101034(VarCurr)
    <=> ( v97254(VarCurr,2)
        & v100955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9539,axiom,
    ! [VarCurr: state_type] :
      ( v101021(VarCurr)
    <=> ( v101022(VarCurr)
        & v101030(VarCurr) ) ) ).

tff(writeUnaryOperator_4845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101030(VarCurr)
    <=> v101031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9538,axiom,
    ! [VarCurr: state_type] :
      ( v101031(VarCurr)
    <=> ( v101032(VarCurr)
        & v101033(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3889,axiom,
    ! [VarCurr: state_type] :
      ( v101033(VarCurr)
    <=> ( v97254(VarCurr,2)
        | v100411(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9537,axiom,
    ! [VarCurr: state_type] :
      ( v101032(VarCurr)
    <=> ( v97455(VarCurr)
        | v100955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9536,axiom,
    ! [VarCurr: state_type] :
      ( v101022(VarCurr)
    <=> ( v101023(VarCurr)
        | v101029(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3888,axiom,
    ! [VarCurr: state_type] :
      ( v101029(VarCurr)
    <=> ( v97254(VarCurr,1)
        & v100949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9535,axiom,
    ! [VarCurr: state_type] :
      ( v101023(VarCurr)
    <=> ( v101024(VarCurr)
        & v101025(VarCurr) ) ) ).

tff(writeUnaryOperator_4844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101025(VarCurr)
    <=> v101026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9534,axiom,
    ! [VarCurr: state_type] :
      ( v101026(VarCurr)
    <=> ( v101027(VarCurr)
        & v101028(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3887,axiom,
    ! [VarCurr: state_type] :
      ( v101028(VarCurr)
    <=> ( v97254(VarCurr,1)
        | v100411(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9533,axiom,
    ! [VarCurr: state_type] :
      ( v101027(VarCurr)
    <=> ( v97460(VarCurr)
        | v100949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9532,axiom,
    ! [VarCurr: state_type] :
      ( v101024(VarCurr)
    <=> ( v97254(VarCurr,0)
        & v100989(VarCurr) ) ) ).

tff(addAssignment_61664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v100411(VarCurr,B)
      <=> v100413(VarCurr,B) ) ) ).

tff(addAssignment_61663,axiom,
    ! [VarCurr: state_type] :
      ( v100413(VarCurr,4)
    <=> v100415(VarCurr,4) ) ).

tff(addAssignment_61662,axiom,
    ! [VarNext: state_type] :
      ( v100415(VarNext,4)
    <=> v100997(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100998(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v100997(VarNext,B)
            <=> v100415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1190,axiom,
    ! [VarNext: state_type] :
      ( v100998(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v100997(VarNext,B)
          <=> v101008(VarNext,B) ) ) ) ).

tff(addAssignment_61661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v101008(VarNext,B)
          <=> v101006(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101009(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v101006(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_674,axiom,
    ! [VarCurr: state_type] :
      ( v101009(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v101006(VarCurr,B)
          <=> v100425(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9531,axiom,
    ! [VarCurr: state_type] :
      ( v101009(VarCurr)
    <=> ( v101010(VarCurr)
        & v101011(VarCurr) ) ) ).

tff(writeUnaryOperator_4843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101011(VarCurr)
    <=> v100421(VarCurr) ) ).

tff(writeUnaryOperator_4842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v101010(VarCurr)
    <=> v100417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100998(VarNext)
      <=> v100999(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100999(VarNext)
      <=> ( v101000(VarNext)
          & v100993(VarNext) ) ) ) ).

tff(writeUnaryOperator_4841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v101000(VarNext)
      <=> v101002(VarNext) ) ) ).

tff(addAssignment_61660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v101002(VarNext)
      <=> v100993(VarCurr) ) ) ).

tff(addAssignment_61659,axiom,
    ! [VarCurr: state_type] :
      ( v100993(VarCurr)
    <=> v100995(VarCurr) ) ).

tff(addAssignment_61658,axiom,
    ! [VarCurr: state_type] :
      ( v100995(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_61657,axiom,
    ! [VarCurr: state_type] :
      ( v100425(VarCurr,4)
    <=> v100427(VarCurr,4) ) ).

tff(addAssignment_61656,axiom,
    ! [VarCurr: state_type] :
      ( v100427(VarCurr,4)
    <=> v100429(VarCurr,4) ) ).

tff(addAssignment_61655,axiom,
    ! [VarCurr: state_type] :
      ( v100429(VarCurr,4)
    <=> v100431(VarCurr,4) ) ).

tff(addAssignment_61654,axiom,
    ! [VarCurr: state_type] :
      ( v100431(VarCurr,4)
    <=> v100933(VarCurr,4) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v100933(VarCurr,B)
          <=> v100934(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_673,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v100933(VarCurr,B)
          <=> v97254(VarCurr,B) ) ) ) ).

tff(addAssignment_61653,axiom,
    ! [VarCurr: state_type] :
      ( v100934(VarCurr,0)
    <=> v100987(VarCurr) ) ).

tff(addAssignment_61652,axiom,
    ! [VarCurr: state_type] :
      ( v100934(VarCurr,1)
    <=> v100982(VarCurr) ) ).

tff(addAssignment_61651,axiom,
    ! [VarCurr: state_type] :
      ( v100934(VarCurr,2)
    <=> v100977(VarCurr) ) ).

tff(addAssignment_61650,axiom,
    ! [VarCurr: state_type] :
      ( v100934(VarCurr,3)
    <=> v100972(VarCurr) ) ).

tff(addAssignment_61649,axiom,
    ! [VarCurr: state_type] :
      ( v100934(VarCurr,4)
    <=> v100936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9528,axiom,
    ! [VarCurr: state_type] :
      ( v100987(VarCurr)
    <=> ( v100988(VarCurr)
        & v100991(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9527,axiom,
    ! [VarCurr: state_type] :
      ( v100991(VarCurr)
    <=> ( v100411(VarCurr,0)
        | v100946(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9526,axiom,
    ! [VarCurr: state_type] :
      ( v100988(VarCurr)
    <=> ( v100989(VarCurr)
        | v100990(VarCurr) ) ) ).

tff(writeUnaryOperator_4840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100990(VarCurr)
    <=> v100946(VarCurr,0) ) ).

tff(writeUnaryOperator_4839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100989(VarCurr)
    <=> v100411(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9525,axiom,
    ! [VarCurr: state_type] :
      ( v100982(VarCurr)
    <=> ( v100983(VarCurr)
        & v100986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9524,axiom,
    ! [VarCurr: state_type] :
      ( v100986(VarCurr)
    <=> ( v100945(VarCurr)
        | v100947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9523,axiom,
    ! [VarCurr: state_type] :
      ( v100983(VarCurr)
    <=> ( v100984(VarCurr)
        | v100985(VarCurr) ) ) ).

tff(writeUnaryOperator_4838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100985(VarCurr)
    <=> v100947(VarCurr) ) ).

tff(writeUnaryOperator_4837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100984(VarCurr)
    <=> v100945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9522,axiom,
    ! [VarCurr: state_type] :
      ( v100977(VarCurr)
    <=> ( v100978(VarCurr)
        & v100981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9521,axiom,
    ! [VarCurr: state_type] :
      ( v100981(VarCurr)
    <=> ( v100943(VarCurr)
        | v100953(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9520,axiom,
    ! [VarCurr: state_type] :
      ( v100978(VarCurr)
    <=> ( v100979(VarCurr)
        | v100980(VarCurr) ) ) ).

tff(writeUnaryOperator_4836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100980(VarCurr)
    <=> v100953(VarCurr) ) ).

tff(writeUnaryOperator_4835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100979(VarCurr)
    <=> v100943(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9519,axiom,
    ! [VarCurr: state_type] :
      ( v100972(VarCurr)
    <=> ( v100973(VarCurr)
        & v100976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9518,axiom,
    ! [VarCurr: state_type] :
      ( v100976(VarCurr)
    <=> ( v100941(VarCurr)
        | v100959(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9517,axiom,
    ! [VarCurr: state_type] :
      ( v100973(VarCurr)
    <=> ( v100974(VarCurr)
        | v100975(VarCurr) ) ) ).

tff(writeUnaryOperator_4834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100975(VarCurr)
    <=> v100959(VarCurr) ) ).

tff(writeUnaryOperator_4833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100974(VarCurr)
    <=> v100941(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9516,axiom,
    ! [VarCurr: state_type] :
      ( v100936(VarCurr)
    <=> ( v100937(VarCurr)
        & v100971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9515,axiom,
    ! [VarCurr: state_type] :
      ( v100971(VarCurr)
    <=> ( v100939(VarCurr)
        | v100966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9514,axiom,
    ! [VarCurr: state_type] :
      ( v100937(VarCurr)
    <=> ( v100938(VarCurr)
        | v100965(VarCurr) ) ) ).

tff(writeUnaryOperator_4832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100965(VarCurr)
    <=> v100966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9513,axiom,
    ! [VarCurr: state_type] :
      ( v100966(VarCurr)
    <=> ( v100967(VarCurr)
        & v100970(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3886,axiom,
    ! [VarCurr: state_type] :
      ( v100970(VarCurr)
    <=> ( v100411(VarCurr,4)
        | v100946(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9512,axiom,
    ! [VarCurr: state_type] :
      ( v100967(VarCurr)
    <=> ( v100968(VarCurr)
        | v100969(VarCurr) ) ) ).

tff(writeUnaryOperator_4831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100969(VarCurr)
    <=> v100946(VarCurr,4) ) ).

tff(writeUnaryOperator_4830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100968(VarCurr)
    <=> v100411(VarCurr,4) ) ).

tff(writeUnaryOperator_4829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100938(VarCurr)
    <=> v100939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9511,axiom,
    ! [VarCurr: state_type] :
      ( v100939(VarCurr)
    <=> ( v100940(VarCurr)
        | v100964(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3885,axiom,
    ! [VarCurr: state_type] :
      ( v100964(VarCurr)
    <=> ( v100411(VarCurr,3)
        & v100946(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9510,axiom,
    ! [VarCurr: state_type] :
      ( v100940(VarCurr)
    <=> ( v100941(VarCurr)
        & v100959(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9509,axiom,
    ! [VarCurr: state_type] :
      ( v100959(VarCurr)
    <=> ( v100960(VarCurr)
        & v100963(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3884,axiom,
    ! [VarCurr: state_type] :
      ( v100963(VarCurr)
    <=> ( v100411(VarCurr,3)
        | v100946(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9508,axiom,
    ! [VarCurr: state_type] :
      ( v100960(VarCurr)
    <=> ( v100961(VarCurr)
        | v100962(VarCurr) ) ) ).

tff(writeUnaryOperator_4828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100962(VarCurr)
    <=> v100946(VarCurr,3) ) ).

tff(writeUnaryOperator_4827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100961(VarCurr)
    <=> v100411(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9507,axiom,
    ! [VarCurr: state_type] :
      ( v100941(VarCurr)
    <=> ( v100942(VarCurr)
        | v100958(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3883,axiom,
    ! [VarCurr: state_type] :
      ( v100958(VarCurr)
    <=> ( v100411(VarCurr,2)
        & v100946(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9506,axiom,
    ! [VarCurr: state_type] :
      ( v100942(VarCurr)
    <=> ( v100943(VarCurr)
        & v100953(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9505,axiom,
    ! [VarCurr: state_type] :
      ( v100953(VarCurr)
    <=> ( v100954(VarCurr)
        & v100957(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3882,axiom,
    ! [VarCurr: state_type] :
      ( v100957(VarCurr)
    <=> ( v100411(VarCurr,2)
        | v100946(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9504,axiom,
    ! [VarCurr: state_type] :
      ( v100954(VarCurr)
    <=> ( v100955(VarCurr)
        | v100956(VarCurr) ) ) ).

tff(writeUnaryOperator_4826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100956(VarCurr)
    <=> v100946(VarCurr,2) ) ).

tff(writeUnaryOperator_4825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100955(VarCurr)
    <=> v100411(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9503,axiom,
    ! [VarCurr: state_type] :
      ( v100943(VarCurr)
    <=> ( v100944(VarCurr)
        | v100952(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3881,axiom,
    ! [VarCurr: state_type] :
      ( v100952(VarCurr)
    <=> ( v100411(VarCurr,1)
        & v100946(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9502,axiom,
    ! [VarCurr: state_type] :
      ( v100944(VarCurr)
    <=> ( v100945(VarCurr)
        & v100947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9501,axiom,
    ! [VarCurr: state_type] :
      ( v100947(VarCurr)
    <=> ( v100948(VarCurr)
        & v100951(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3880,axiom,
    ! [VarCurr: state_type] :
      ( v100951(VarCurr)
    <=> ( v100411(VarCurr,1)
        | v100946(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9500,axiom,
    ! [VarCurr: state_type] :
      ( v100948(VarCurr)
    <=> ( v100949(VarCurr)
        | v100950(VarCurr) ) ) ).

tff(writeUnaryOperator_4824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100950(VarCurr)
    <=> v100946(VarCurr,1) ) ).

tff(writeUnaryOperator_4823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100949(VarCurr)
    <=> v100411(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9499,axiom,
    ! [VarCurr: state_type] :
      ( v100945(VarCurr)
    <=> ( v100411(VarCurr,0)
        & v100946(VarCurr,0) ) ) ).

tff(addAssignment_61648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v100946(VarCurr,B)
      <=> v100433(VarCurr,B) ) ) ).

tff(addAssignment_61647,axiom,
    ! [VarCurr: state_type] :
      ( ( v100946(VarCurr,4)
      <=> $false )
      & ( v100946(VarCurr,3)
      <=> $false )
      & ( v100946(VarCurr,2)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v100433(VarCurr,B)
      <=> ( v100924(VarCurr,B)
          & v100927(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100928(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100927(VarCurr,B)
          <=> v100929(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_672,axiom,
    ! [VarCurr: state_type] :
      ( v100928(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100927(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100930(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100929(VarCurr,B)
          <=> v100931(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_671,axiom,
    ! [VarCurr: state_type] :
      ( v100930(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100929(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100932(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100931(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_670,axiom,
    ! [VarCurr: state_type] :
      ( v100932(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100931(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(addBitVectorEqualityBitBlasted_644,axiom,
    ! [VarCurr: state_type] :
      ( v100932(VarCurr)
    <=> ( ( v100203(VarCurr,2)
        <=> $true )
        & ( v100203(VarCurr,1)
        <=> $true )
        & ( v100203(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_643,axiom,
    ! [VarCurr: state_type] :
      ( v100930(VarCurr)
    <=> ( ( v100203(VarCurr,2)
        <=> $false )
        & ( v100203(VarCurr,1)
        <=> $true )
        & ( v100203(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_642,axiom,
    ! [VarCurr: state_type] :
      ( v100928(VarCurr)
    <=> ( ( v100203(VarCurr,2)
        <=> $false )
        & ( v100203(VarCurr,1)
        <=> $false )
        & ( v100203(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_61646,axiom,
    ! [VarCurr: state_type] :
      ( v100924(VarCurr,0)
    <=> v100925(VarCurr) ) ).

tff(addAssignment_61645,axiom,
    ! [VarCurr: state_type] :
      ( v100924(VarCurr,1)
    <=> v100925(VarCurr) ) ).

tff(addAssignment_61644,axiom,
    ! [VarCurr: state_type] :
      ( v100925(VarCurr)
    <=> v100926(VarCurr) ) ).

tff(writeUnaryOperator_4822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100926(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(addAssignment_61643,axiom,
    ! [VarCurr: state_type] :
      ( v100691(VarCurr)
    <=> v100693(VarCurr,2) ) ).

tff(addAssignment_61642,axiom,
    ! [VarCurr: state_type] :
      ( v100693(VarCurr,2)
    <=> v100695(VarCurr,2) ) ).

tff(addAssignment_61641,axiom,
    ! [VarNext: state_type] :
      ( v100695(VarNext,2)
    <=> v100914(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100915(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v100914(VarNext,B)
            <=> v100695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1189,axiom,
    ! [VarNext: state_type] :
      ( v100915(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100914(VarNext,B)
          <=> v100856(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100915(VarNext)
      <=> v100916(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100916(VarNext)
      <=> ( v100918(VarNext)
          & v100841(VarNext) ) ) ) ).

tff(writeUnaryOperator_4821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100918(VarNext)
      <=> v100850(VarNext) ) ) ).

tff(addAssignment_61640,axiom,
    ! [VarCurr: state_type] :
      ( v100705(VarCurr,2)
    <=> v100707(VarCurr,2) ) ).

tff(addAssignment_61639,axiom,
    ! [VarCurr: state_type] :
      ( v100707(VarCurr,2)
    <=> v100709(VarCurr,2) ) ).

tff(addAssignment_61638,axiom,
    ! [VarCurr: state_type] :
      ( v100709(VarCurr,2)
    <=> v100839(VarCurr,2) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100907(VarCurr)
     => ( v100711(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_669,axiom,
    ! [VarCurr: state_type] :
      ( v100907(VarCurr)
     => ( v100711(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9496,axiom,
    ! [VarCurr: state_type] :
      ( v100907(VarCurr)
    <=> ( v100908(VarCurr)
        | v100909(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9495,axiom,
    ! [VarCurr: state_type] :
      ( v100909(VarCurr)
    <=> ( v100910(VarCurr)
        & v100911(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9494,axiom,
    ! [VarCurr: state_type] :
      ( v100911(VarCurr)
    <=> ( v100912(VarCurr)
        & v100820(VarCurr) ) ) ).

tff(writeUnaryOperator_4820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100912(VarCurr)
    <=> v100817(VarCurr) ) ).

tff(writeUnaryOperator_4819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100910(VarCurr)
    <=> v100822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9493,axiom,
    ! [VarCurr: state_type] :
      ( v100908(VarCurr)
    <=> ( v100888(VarCurr)
        & v100822(VarCurr) ) ) ).

tff(writeUnaryOperator_4818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100713(VarCurr)
    <=> v100715(VarCurr) ) ).

tff(addAssignment_61637,axiom,
    ! [VarCurr: state_type] :
      ( v100715(VarCurr)
    <=> v100693(VarCurr,3) ) ).

tff(addAssignment_61636,axiom,
    ! [VarCurr: state_type] :
      ( v100693(VarCurr,3)
    <=> v100695(VarCurr,3) ) ).

tff(addAssignment_61635,axiom,
    ! [VarNext: state_type] :
      ( v100695(VarNext,3)
    <=> v100898(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100899(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v100898(VarNext,B)
            <=> v100695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1188,axiom,
    ! [VarNext: state_type] :
      ( v100899(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100898(VarNext,B)
          <=> v100856(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100899(VarNext)
      <=> v100900(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100900(VarNext)
      <=> ( v100902(VarNext)
          & v100841(VarNext) ) ) ) ).

tff(writeUnaryOperator_4817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100902(VarNext)
      <=> v100850(VarNext) ) ) ).

tff(addAssignment_61634,axiom,
    ! [VarCurr: state_type] :
      ( v100705(VarCurr,3)
    <=> v100707(VarCurr,3) ) ).

tff(addAssignment_61633,axiom,
    ! [VarCurr: state_type] :
      ( v100707(VarCurr,3)
    <=> v100709(VarCurr,3) ) ).

tff(addAssignment_61632,axiom,
    ! [VarCurr: state_type] :
      ( v100709(VarCurr,3)
    <=> v100839(VarCurr,3) ) ).

tff(writeUnaryOperator_4816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100717(VarCurr)
    <=> v100719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9490,axiom,
    ! [VarCurr: state_type] :
      ( v100719(VarCurr)
    <=> ( v100721(VarCurr)
        | v100831(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100885(VarCurr)
     => ( v100721(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_668,axiom,
    ! [VarCurr: state_type] :
      ( v100885(VarCurr)
     => ( v100721(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9489,axiom,
    ! [VarCurr: state_type] :
      ( v100885(VarCurr)
    <=> ( v100886(VarCurr)
        | v100889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9488,axiom,
    ! [VarCurr: state_type] :
      ( v100889(VarCurr)
    <=> ( v100890(VarCurr)
        & v100891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9487,axiom,
    ! [VarCurr: state_type] :
      ( v100891(VarCurr)
    <=> ( v100892(VarCurr)
        & v100893(VarCurr) ) ) ).

tff(writeUnaryOperator_4815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100893(VarCurr)
    <=> v100894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9486,axiom,
    ! [VarCurr: state_type] :
      ( v100894(VarCurr)
    <=> ( v100820(VarCurr)
        | v100828(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9485,axiom,
    ! [VarCurr: state_type] :
      ( v100892(VarCurr)
    <=> ( v100873(VarCurr)
        & v100874(VarCurr) ) ) ).

tff(writeUnaryOperator_4814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100890(VarCurr)
    <=> v100822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9484,axiom,
    ! [VarCurr: state_type] :
      ( v100886(VarCurr)
    <=> ( v100887(VarCurr)
        & v100822(VarCurr) ) ) ).

tff(writeUnaryOperator_4813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100887(VarCurr)
    <=> v100888(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9483,axiom,
    ! [VarCurr: state_type] :
      ( v100888(VarCurr)
    <=> ( v97208(VarCurr)
        & v97278(VarCurr) ) ) ).

tff(addAssignment_61631,axiom,
    ! [VarCurr: state_type] :
      ( v100734(VarCurr)
    <=> v100693(VarCurr,0) ) ).

tff(addAssignment_61630,axiom,
    ! [VarCurr: state_type] :
      ( v100693(VarCurr,0)
    <=> v100695(VarCurr,0) ) ).

tff(addAssignment_61629,axiom,
    ! [VarNext: state_type] :
      ( v100695(VarNext,0)
    <=> v100877(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100878(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v100877(VarNext,B)
            <=> v100695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1187,axiom,
    ! [VarNext: state_type] :
      ( v100878(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100877(VarNext,B)
          <=> v100856(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100878(VarNext)
      <=> v100879(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100879(VarNext)
      <=> ( v100881(VarNext)
          & v100841(VarNext) ) ) ) ).

tff(writeUnaryOperator_4812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100881(VarNext)
      <=> v100850(VarNext) ) ) ).

tff(addAssignment_61628,axiom,
    ! [VarCurr: state_type] :
      ( v100705(VarCurr,0)
    <=> v100707(VarCurr,0) ) ).

tff(addAssignment_61627,axiom,
    ! [VarCurr: state_type] :
      ( v100707(VarCurr,0)
    <=> v100709(VarCurr,0) ) ).

tff(addAssignment_61626,axiom,
    ! [VarCurr: state_type] :
      ( v100709(VarCurr,0)
    <=> v100839(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100863(VarCurr)
     => ( v100736(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_667,axiom,
    ! [VarCurr: state_type] :
      ( v100863(VarCurr)
     => ( v100736(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9480,axiom,
    ! [VarCurr: state_type] :
      ( v100863(VarCurr)
    <=> ( v100864(VarCurr)
        | v100868(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9479,axiom,
    ! [VarCurr: state_type] :
      ( v100868(VarCurr)
    <=> ( v100869(VarCurr)
        & v100870(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9478,axiom,
    ! [VarCurr: state_type] :
      ( v100870(VarCurr)
    <=> ( v100871(VarCurr)
        & v100875(VarCurr) ) ) ).

tff(writeUnaryOperator_4811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100875(VarCurr)
    <=> v100867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9477,axiom,
    ! [VarCurr: state_type] :
      ( v100871(VarCurr)
    <=> ( v100872(VarCurr)
        & v100874(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_641,axiom,
    ! [VarCurr: state_type] :
      ( v100874(VarCurr)
    <=> ( $true
      <=> v100734(VarCurr) ) ) ).

tff(writeUnaryOperator_4810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100872(VarCurr)
    <=> v100873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9476,axiom,
    ! [VarCurr: state_type] :
      ( v100873(VarCurr)
    <=> ( v4093(VarCurr)
        | v100723(VarCurr) ) ) ).

tff(writeUnaryOperator_4809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100869(VarCurr)
    <=> v100828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9475,axiom,
    ! [VarCurr: state_type] :
      ( v100864(VarCurr)
    <=> ( v100865(VarCurr)
        & v100866(VarCurr) ) ) ).

tff(writeUnaryOperator_4808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100866(VarCurr)
    <=> v100867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9474,axiom,
    ! [VarCurr: state_type] :
      ( v100867(VarCurr)
    <=> ( v100822(VarCurr)
        | v100820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9473,axiom,
    ! [VarCurr: state_type] :
      ( v100865(VarCurr)
    <=> ( v100738(VarCurr,0)
        & v100828(VarCurr) ) ) ).

tff(addAssignment_61625,axiom,
    ! [VarCurr: state_type] :
      ( v100808(VarCurr)
    <=> v100693(VarCurr,1) ) ).

tff(addAssignment_61624,axiom,
    ! [VarCurr: state_type] :
      ( v100693(VarCurr,1)
    <=> v100695(VarCurr,1) ) ).

tff(addAssignment_61623,axiom,
    ! [VarNext: state_type] :
      ( v100695(VarNext,1)
    <=> v100845(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100846(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v100845(VarNext,B)
            <=> v100695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1186,axiom,
    ! [VarNext: state_type] :
      ( v100846(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100845(VarNext,B)
          <=> v100856(VarNext,B) ) ) ) ).

tff(addAssignment_61622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100856(VarNext,B)
          <=> v100854(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100854(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_666,axiom,
    ! [VarCurr: state_type] :
      ( v100857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v100854(VarCurr,B)
          <=> v100705(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9472,axiom,
    ! [VarCurr: state_type] :
      ( v100857(VarCurr)
    <=> ( v100858(VarCurr)
        & v100859(VarCurr) ) ) ).

tff(writeUnaryOperator_4807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100859(VarCurr)
    <=> v100701(VarCurr) ) ).

tff(writeUnaryOperator_4806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100858(VarCurr)
    <=> v100697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100846(VarNext)
      <=> v100847(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100847(VarNext)
      <=> ( v100848(VarNext)
          & v100841(VarNext) ) ) ) ).

tff(writeUnaryOperator_4805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100848(VarNext)
      <=> v100850(VarNext) ) ) ).

tff(addAssignment_61621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100850(VarNext)
      <=> v100841(VarCurr) ) ) ).

tff(addAssignment_61620,axiom,
    ! [VarCurr: state_type] :
      ( v100841(VarCurr)
    <=> v100843(VarCurr) ) ).

tff(addAssignment_61619,axiom,
    ! [VarCurr: state_type] :
      ( v100843(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_61618,axiom,
    ! [VarCurr: state_type] :
      ( v100705(VarCurr,1)
    <=> v100707(VarCurr,1) ) ).

tff(addAssignment_61617,axiom,
    ! [VarCurr: state_type] :
      ( v100707(VarCurr,1)
    <=> v100709(VarCurr,1) ) ).

tff(addAssignment_61616,axiom,
    ! [VarCurr: state_type] :
      ( v100709(VarCurr,1)
    <=> v100839(VarCurr,1) ) ).

tff(addAssignment_61615,axiom,
    ! [VarCurr: state_type] :
      ( v100839(VarCurr,0)
    <=> v100736(VarCurr) ) ).

tff(addAssignment_61614,axiom,
    ! [VarCurr: state_type] :
      ( v100839(VarCurr,1)
    <=> v100810(VarCurr) ) ).

tff(addAssignment_61613,axiom,
    ! [VarCurr: state_type] :
      ( v100839(VarCurr,2)
    <=> v100711(VarCurr) ) ).

tff(addAssignment_61612,axiom,
    ! [VarCurr: state_type] :
      ( v100839(VarCurr,3)
    <=> v100717(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9469,axiom,
    ! [VarCurr: state_type] :
      ( v100810(VarCurr)
    <=> ( v100812(VarCurr)
        & v100838(VarCurr) ) ) ).

tff(writeUnaryOperator_4804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100838(VarCurr)
    <=> v100831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9468,axiom,
    ! [VarCurr: state_type] :
      ( v100831(VarCurr)
    <=> ( v100833(VarCurr)
        & v100835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9467,axiom,
    ! [VarCurr: state_type] :
      ( v100835(VarCurr)
    <=> ( v89614(VarCurr)
        | v100836(VarCurr) ) ) ).

tff(writeUnaryOperator_4803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100836(VarCurr)
    <=> v97146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9466,axiom,
    ! [VarCurr: state_type] :
      ( v100833(VarCurr)
    <=> ( v100691(VarCurr)
        & v100834(VarCurr) ) ) ).

tff(writeUnaryOperator_4802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100834(VarCurr)
    <=> v100203(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100814(VarCurr)
     => ( v100812(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_665,axiom,
    ! [VarCurr: state_type] :
      ( v100814(VarCurr)
     => ( v100812(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9465,axiom,
    ! [VarCurr: state_type] :
      ( v100814(VarCurr)
    <=> ( v100815(VarCurr)
        | v100823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9464,axiom,
    ! [VarCurr: state_type] :
      ( v100823(VarCurr)
    <=> ( v100824(VarCurr)
        & v100825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9463,axiom,
    ! [VarCurr: state_type] :
      ( v100825(VarCurr)
    <=> ( v100826(VarCurr)
        & v100829(VarCurr) ) ) ).

tff(writeUnaryOperator_4801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100829(VarCurr)
    <=> v100822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9462,axiom,
    ! [VarCurr: state_type] :
      ( v100826(VarCurr)
    <=> ( v100827(VarCurr)
        & v100828(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_640,axiom,
    ! [VarCurr: state_type] :
      ( v100828(VarCurr)
    <=> ( $true
      <=> v100808(VarCurr) ) ) ).

tff(writeUnaryOperator_4800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100827(VarCurr)
    <=> v100738(VarCurr,0) ) ).

tff(writeUnaryOperator_4799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100824(VarCurr)
    <=> v100820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9461,axiom,
    ! [VarCurr: state_type] :
      ( v100815(VarCurr)
    <=> ( v100816(VarCurr)
        & v100821(VarCurr) ) ) ).

tff(writeUnaryOperator_4798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100821(VarCurr)
    <=> v100822(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_639,axiom,
    ! [VarCurr: state_type] :
      ( v100822(VarCurr)
    <=> ( $true
      <=> v100713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9460,axiom,
    ! [VarCurr: state_type] :
      ( v100816(VarCurr)
    <=> ( v100817(VarCurr)
        & v100820(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_638,axiom,
    ! [VarCurr: state_type] :
      ( v100820(VarCurr)
    <=> ( $true
      <=> v100691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9459,axiom,
    ! [VarCurr: state_type] :
      ( v100817(VarCurr)
    <=> ( v100818(VarCurr)
        | v100819(VarCurr) ) ) ).

tff(writeUnaryOperator_4797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100819(VarCurr)
    <=> v97146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9458,axiom,
    ! [VarCurr: state_type] :
      ( v100818(VarCurr)
    <=> ( v100203(VarCurr,0)
        | v89614(VarCurr) ) ) ).

tff(addAssignment_61611,axiom,
    ! [VarCurr: state_type] :
      ( v100738(VarCurr,0)
    <=> v100740(VarCurr,0) ) ).

tff(addAssignment_61610,axiom,
    ! [VarCurr: state_type] :
      ( v100740(VarCurr,0)
    <=> v100742(VarCurr,0) ) ).

tff(addAssignment_61609,axiom,
    ! [VarCurr: state_type] :
      ( v100742(VarCurr,0)
    <=> v100803(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v100803(VarCurr,B)
      <=> ( v100744(VarCurr,B)
          & v100804(VarCurr,B) ) ) ) ).

tff(addAssignment_61608,axiom,
    ! [VarCurr: state_type] :
      ( v100804(VarCurr,0)
    <=> v100805(VarCurr) ) ).

tff(addAssignment_61607,axiom,
    ! [VarCurr: state_type] :
      ( v100804(VarCurr,1)
    <=> v100805(VarCurr) ) ).

tff(addAssignment_61606,axiom,
    ! [VarCurr: state_type] :
      ( v100805(VarCurr)
    <=> v100806(VarCurr) ) ).

tff(writeUnaryOperator_4796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100806(VarCurr)
    <=> v100756(VarCurr) ) ).

tff(addAssignment_61605,axiom,
    ! [VarCurr: state_type] :
      ( v100756(VarCurr)
    <=> v100758(VarCurr) ) ).

tff(addAssignment_61604,axiom,
    ! [VarCurr: state_type] :
      ( v100758(VarCurr)
    <=> v100760(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100787(VarNext)
       => ( v100760(VarNext)
        <=> v100760(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1185,axiom,
    ! [VarNext: state_type] :
      ( v100787(VarNext)
     => ( v100760(VarNext)
      <=> v100797(VarNext) ) ) ).

tff(addAssignment_61603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100797(VarNext)
      <=> v100795(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100798(VarCurr)
     => ( v100795(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_664,axiom,
    ! [VarCurr: state_type] :
      ( v100798(VarCurr)
     => ( v100795(VarCurr)
      <=> v100770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9457,axiom,
    ! [VarCurr: state_type] :
      ( v100798(VarCurr)
    <=> ( v100799(VarCurr)
        & v100800(VarCurr) ) ) ).

tff(writeUnaryOperator_4795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100800(VarCurr)
    <=> v100766(VarCurr) ) ).

tff(writeUnaryOperator_4794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100799(VarCurr)
    <=> v100762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100787(VarNext)
      <=> v100788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100788(VarNext)
      <=> ( v100789(VarNext)
          & v100782(VarNext) ) ) ) ).

tff(writeUnaryOperator_4793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100789(VarNext)
      <=> v100791(VarNext) ) ) ).

tff(addAssignment_61602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100791(VarNext)
      <=> v100782(VarCurr) ) ) ).

tff(addAssignment_61601,axiom,
    ! [VarCurr: state_type] :
      ( v100782(VarCurr)
    <=> v100784(VarCurr) ) ).

tff(addAssignment_61600,axiom,
    ! [VarCurr: state_type] :
      ( v100784(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_61599,axiom,
    ! [VarCurr: state_type] :
      ( v100770(VarCurr)
    <=> v100772(VarCurr) ) ).

tff(addAssignment_61598,axiom,
    ! [VarCurr: state_type] :
      ( v100772(VarCurr)
    <=> v100774(VarCurr) ) ).

tff(addAssignment_61597,axiom,
    ! [VarCurr: state_type] :
      ( v100774(VarCurr)
    <=> v100776(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83163(VarCurr)
     => ( v100776(VarCurr)
      <=> v100778(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_663,axiom,
    ! [VarCurr: state_type] :
      ( v83163(VarCurr)
     => ( v100776(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100779(VarCurr)
     => ( v100778(VarCurr)
      <=> v100756(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_662,axiom,
    ! [VarCurr: state_type] :
      ( v100779(VarCurr)
     => ( v100778(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorShiftedRanges_3879,axiom,
    ! [VarCurr: state_type] :
      ( v100779(VarCurr)
    <=> ( v100744(VarCurr,0)
        | v100744(VarCurr,1) ) ) ).

tff(addAssignment_61596,axiom,
    ! [VarCurr: state_type] :
      ( v100744(VarCurr,1)
    <=> v100746(VarCurr,1) ) ).

tff(addAssignment_61595,axiom,
    ! [VarCurr: state_type] :
      ( v100746(VarCurr,1)
    <=> v100748(VarCurr,1) ) ).

tff(addAssignment_61594,axiom,
    ! [VarCurr: state_type] :
      ( v100748(VarCurr,1)
    <=> v100749(VarCurr,1) ) ).

tff(addAssignment_61593,axiom,
    ! [VarCurr: state_type] :
      ( v100766(VarCurr)
    <=> v100768(VarCurr) ) ).

tff(addAssignment_61592,axiom,
    ! [VarCurr: state_type] :
      ( v100768(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_61591,axiom,
    ! [VarCurr: state_type] :
      ( v100762(VarCurr)
    <=> v100764(VarCurr) ) ).

tff(addAssignment_61590,axiom,
    ! [VarCurr: state_type] :
      ( v100764(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_61589,axiom,
    ! [VarCurr: state_type] :
      ( v100744(VarCurr,0)
    <=> v100746(VarCurr,0) ) ).

tff(addAssignment_61588,axiom,
    ! [VarCurr: state_type] :
      ( v100746(VarCurr,0)
    <=> v100748(VarCurr,0) ) ).

tff(addAssignment_61587,axiom,
    ! [VarCurr: state_type] :
      ( v100748(VarCurr,0)
    <=> v100749(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100749(VarCurr,B)
          <=> v100752(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_661,axiom,
    ! [VarCurr: state_type] :
      ( v100750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100749(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100753(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100752(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_660,axiom,
    ! [VarCurr: state_type] :
      ( v100753(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v100752(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9454,axiom,
    ! [VarCurr: state_type] :
      ( v100753(VarCurr)
    <=> ( v2044(VarCurr)
        & v100754(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_637,axiom,
    ! [VarCurr: state_type] :
      ( v100754(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $false )
        & ( v2200(VarCurr,9)
        <=> $true )
        & ( v2200(VarCurr,8)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9453,axiom,
    ! [VarCurr: state_type] :
      ( v100750(VarCurr)
    <=> ( v2044(VarCurr)
        & v100751(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_636,axiom,
    ! [VarCurr: state_type] :
      ( v100751(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $false )
        & ( v2200(VarCurr,9)
        <=> $false )
        & ( v2200(VarCurr,8)
        <=> $true ) ) ) ).

tff(addAssignment_61586,axiom,
    ! [VarCurr: state_type] :
      ( v100723(VarCurr)
    <=> v100725(VarCurr) ) ).

tff(addAssignment_61585,axiom,
    ! [VarCurr: state_type] :
      ( v100725(VarCurr)
    <=> v100727(VarCurr) ) ).

tff(addAssignment_61584,axiom,
    ! [VarCurr: state_type] :
      ( v100727(VarCurr)
    <=> v100729(VarCurr) ) ).

tff(addAssignment_61583,axiom,
    ! [VarCurr: state_type] :
      ( v100729(VarCurr)
    <=> v100731(VarCurr) ) ).

tff(writeUnaryOperator_4792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100731(VarCurr)
    <=> v89674(VarCurr,0) ) ).

tff(addAssignment_61582,axiom,
    ! [VarCurr: state_type] :
      ( v100701(VarCurr)
    <=> v100703(VarCurr) ) ).

tff(addAssignment_61581,axiom,
    ! [VarCurr: state_type] :
      ( v100703(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_61580,axiom,
    ! [VarCurr: state_type] :
      ( v100697(VarCurr)
    <=> v100699(VarCurr) ) ).

tff(addAssignment_61579,axiom,
    ! [VarCurr: state_type] :
      ( v100699(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_61578,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,0)
    <=> v100687(VarCurr) ) ).

tff(addAssignment_61577,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,1)
    <=> v100686(VarCurr) ) ).

tff(addAssignment_61576,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,2)
    <=> v100685(VarCurr) ) ).

tff(addAssignment_61575,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,3)
    <=> v100684(VarCurr) ) ).

tff(addAssignment_61574,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,4)
    <=> v100683(VarCurr) ) ).

tff(addAssignment_61573,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,5)
    <=> v100682(VarCurr) ) ).

tff(addAssignment_61572,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,6)
    <=> v100681(VarCurr) ) ).

tff(addAssignment_61571,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,7)
    <=> v100680(VarCurr) ) ).

tff(addAssignment_61570,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,8)
    <=> v100679(VarCurr) ) ).

tff(addAssignment_61569,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,9)
    <=> v100678(VarCurr) ) ).

tff(addAssignment_61568,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,10)
    <=> v100677(VarCurr) ) ).

tff(addAssignment_61567,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,11)
    <=> v100676(VarCurr) ) ).

tff(addAssignment_61566,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,12)
    <=> v100675(VarCurr) ) ).

tff(addAssignment_61565,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,13)
    <=> v100674(VarCurr) ) ).

tff(addAssignment_61564,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,14)
    <=> v100673(VarCurr) ) ).

tff(addAssignment_61563,axiom,
    ! [VarCurr: state_type] :
      ( v100441(VarCurr,15)
    <=> v100672(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_635,axiom,
    ! [VarCurr: state_type] :
      ( v100687(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_634,axiom,
    ! [VarCurr: state_type] :
      ( v100686(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_633,axiom,
    ! [VarCurr: state_type] :
      ( v100685(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_632,axiom,
    ! [VarCurr: state_type] :
      ( v100684(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_631,axiom,
    ! [VarCurr: state_type] :
      ( v100683(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_630,axiom,
    ! [VarCurr: state_type] :
      ( v100682(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_629,axiom,
    ! [VarCurr: state_type] :
      ( v100681(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_628,axiom,
    ! [VarCurr: state_type] :
      ( v100680(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $false )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_627,axiom,
    ! [VarCurr: state_type] :
      ( v100679(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_626,axiom,
    ! [VarCurr: state_type] :
      ( v100678(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_625,axiom,
    ! [VarCurr: state_type] :
      ( v100677(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_624,axiom,
    ! [VarCurr: state_type] :
      ( v100676(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $false )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_623,axiom,
    ! [VarCurr: state_type] :
      ( v100675(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_622,axiom,
    ! [VarCurr: state_type] :
      ( v100674(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $false )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_621,axiom,
    ! [VarCurr: state_type] :
      ( v100673(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_620,axiom,
    ! [VarCurr: state_type] :
      ( v100672(VarCurr)
    <=> ( ( v100443(VarCurr,3)
        <=> $true )
        & ( v100443(VarCurr,2)
        <=> $true )
        & ( v100443(VarCurr,1)
        <=> $true )
        & ( v100443(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_61562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100443(VarCurr,B)
      <=> v100445(VarCurr,B) ) ) ).

tff(addAssignment_61561,axiom,
    ! [VarCurr: state_type] :
      ( v100443(VarCurr,3)
    <=> v100668(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100221(VarCurr)
     => ( v100668(VarCurr)
      <=> v100670(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_659,axiom,
    ! [VarCurr: state_type] :
      ( v100221(VarCurr)
     => ( v100668(VarCurr)
      <=> v100669(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_20,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100225(VarCurr)
     => ( v100670(VarCurr)
      <=> v100445(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_48,axiom,
    ! [VarCurr: state_type] :
      ( v100225(VarCurr)
     => ( v100670(VarCurr)
      <=> v100445(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_19,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100225(VarCurr)
     => ( v100669(VarCurr)
      <=> v100445(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_47,axiom,
    ! [VarCurr: state_type] :
      ( v100225(VarCurr)
     => ( v100669(VarCurr)
      <=> v100445(VarCurr,6) ) ) ).

tff(addAssignment_61560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100445(VarCurr,B)
      <=> v100446(VarCurr,B) ) ) ).

tff(addAssignment_61559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97517(VarCurr,B)
      <=> v97519(VarCurr,B) ) ) ).

tff(addAssignment_61558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97519(VarCurr,B)
      <=> v97521(VarCurr,B) ) ) ).

tff(addAssignment_61557,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97521(VarNext,B)
      <=> v100660(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100661(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100660(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1184,axiom,
    ! [VarNext: state_type] :
      ( v100661(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100660(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100661(VarNext)
      <=> v100662(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100662(VarNext)
      <=> ( v100664(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_4791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100664(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_61556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97531(VarCurr,B)
      <=> v97533(VarCurr,B) ) ) ).

tff(addAssignment_61555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97533(VarCurr,B)
      <=> v97542(VarCurr,B) ) ) ).

tff(addAssignment_61554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97535(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97409(VarCurr,B)
      <=> v100196(VarCurr,B) ) ) ).

tff(addAssignment_61552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100043(VarCurr,B)
      <=> v100045(VarCurr,B) ) ) ).

tff(addAssignment_61551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100045(VarCurr,B)
      <=> v100047(VarCurr,B) ) ) ).

tff(addAssignment_61550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100047(VarCurr,B)
      <=> v100049(VarCurr,B) ) ) ).

tff(addAssignment_61549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100049(VarCurr,B)
      <=> v100051(VarCurr,B) ) ) ).

tff(addAssignment_61548,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100051(VarNext,B)
      <=> v100652(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100653(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100652(VarNext,B)
            <=> v100051(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1183,axiom,
    ! [VarNext: state_type] :
      ( v100653(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100652(VarNext,B)
          <=> v100190(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100653(VarNext)
      <=> v100654(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100654(VarNext)
      <=> ( v100656(VarNext)
          & v100175(VarNext) ) ) ) ).

tff(writeUnaryOperator_4790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100656(VarNext)
      <=> v100184(VarNext) ) ) ).

tff(addAssignment_61547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100061(VarCurr,B)
      <=> v100063(VarCurr,B) ) ) ).

tff(addAssignment_61546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100063(VarCurr,B)
      <=> v100166(VarCurr,B) ) ) ).

tff(addAssignment_61545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100065(VarCurr,B)
      <=> v100067(VarCurr,B) ) ) ).

tff(addAssignment_61544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100067(VarCurr,B)
      <=> v100158(VarCurr,B) ) ) ).

tff(addAssignment_61543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100097(VarCurr,B)
      <=> v100115(VarCurr,B) ) ) ).

tff(addAssignment_61542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3918(VarCurr,B)
      <=> v3920(VarCurr,B) ) ) ).

tff(addAssignment_61541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3920(VarCurr,B)
      <=> v3922(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100646(VarCurr)
     => ( v100118(VarCurr)
      <=> v100650(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_46,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
     => ( v100118(VarCurr)
      <=> v3918(VarCurr,2) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_18,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100648(VarCurr)
     => ( v100650(VarCurr)
      <=> v3918(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_45,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
     => ( v100650(VarCurr)
      <=> v3918(VarCurr,6) ) ) ).

tff(addAssignment_61540,axiom,
    ! [VarCurr: state_type] :
      ( v100648(VarCurr)
    <=> v100227(VarCurr) ) ).

tff(addAssignment_61539,axiom,
    ! [VarCurr: state_type] :
      ( v3918(VarCurr,2)
    <=> v3920(VarCurr,2) ) ).

tff(addAssignment_61538,axiom,
    ! [VarCurr: state_type] :
      ( v3920(VarCurr,2)
    <=> v3922(VarCurr,2) ) ).

tff(addAssignment_61537,axiom,
    ! [VarCurr: state_type] :
      ( v100646(VarCurr)
    <=> v100223(VarCurr) ) ).

tff(addAssignment_61536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100069(VarCurr,B)
      <=> v100071(VarCurr,B) ) ) ).

tff(addAssignment_61535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100071(VarCurr,B)
      <=> v100073(VarCurr,B) ) ) ).

tff(addAssignment_61534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99888(VarCurr,B)
      <=> v99890(VarCurr,B) ) ) ).

tff(addAssignment_61533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99890(VarCurr,B)
      <=> v99892(VarCurr,B) ) ) ).

tff(addAssignment_61532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99892(VarCurr,B)
      <=> v99894(VarCurr,B) ) ) ).

tff(addAssignment_61531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99894(VarCurr,B)
      <=> v99896(VarCurr,B) ) ) ).

tff(addAssignment_61530,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99896(VarNext,B)
      <=> v100637(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100638(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100637(VarNext,B)
            <=> v99896(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1182,axiom,
    ! [VarNext: state_type] :
      ( v100638(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100637(VarNext,B)
          <=> v100036(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100638(VarNext)
      <=> v100639(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100639(VarNext)
      <=> ( v100641(VarNext)
          & v100021(VarNext) ) ) ) ).

tff(writeUnaryOperator_4789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100641(VarNext)
      <=> v100030(VarNext) ) ) ).

tff(addAssignment_61529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99906(VarCurr,B)
      <=> v99908(VarCurr,B) ) ) ).

tff(addAssignment_61528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99908(VarCurr,B)
      <=> v100012(VarCurr,B) ) ) ).

tff(addAssignment_61527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99910(VarCurr,B)
      <=> v99912(VarCurr,B) ) ) ).

tff(addAssignment_61526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99912(VarCurr,B)
      <=> v100004(VarCurr,B) ) ) ).

tff(addAssignment_61525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99942(VarCurr,B)
      <=> v99960(VarCurr,B) ) ) ).

tff(addAssignment_61524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89443(VarCurr,B)
      <=> v89445(VarCurr,B) ) ) ).

tff(addAssignment_61523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89445(VarCurr,B)
      <=> v89447(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100631(VarCurr)
     => ( v99963(VarCurr)
      <=> v100635(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_44,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
     => ( v99963(VarCurr)
      <=> v89443(VarCurr,2) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_17,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100633(VarCurr)
     => ( v100635(VarCurr)
      <=> v89443(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_43,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
     => ( v100635(VarCurr)
      <=> v89443(VarCurr,6) ) ) ).

tff(addAssignment_61522,axiom,
    ! [VarCurr: state_type] :
      ( v100633(VarCurr)
    <=> v100227(VarCurr) ) ).

tff(addAssignment_61521,axiom,
    ! [VarCurr: state_type] :
      ( v89443(VarCurr,2)
    <=> v89445(VarCurr,2) ) ).

tff(addAssignment_61520,axiom,
    ! [VarCurr: state_type] :
      ( v89445(VarCurr,2)
    <=> v89447(VarCurr,2) ) ).

tff(addAssignment_61519,axiom,
    ! [VarCurr: state_type] :
      ( v100631(VarCurr)
    <=> v100223(VarCurr) ) ).

tff(addAssignment_61518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99914(VarCurr,B)
      <=> v99916(VarCurr,B) ) ) ).

tff(addAssignment_61517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99916(VarCurr,B)
      <=> v99918(VarCurr,B) ) ) ).

tff(addAssignment_61516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97411(VarCurr,B)
      <=> v98356(VarCurr,B) ) ) ).

tff(addAssignment_61515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98301(VarCurr,B)
      <=> v98303(VarCurr,B) ) ) ).

tff(addAssignment_61514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98303(VarCurr,B)
      <=> v98305(VarCurr,B) ) ) ).

tff(addAssignment_61513,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98305(VarNext,B)
      <=> v100622(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100623(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100622(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1181,axiom,
    ! [VarNext: state_type] :
      ( v100623(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100622(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100623(VarNext)
      <=> v100624(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100624(VarNext)
      <=> ( v100626(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_4788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100626(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_61512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98315(VarCurr,B)
      <=> v98317(VarCurr,B) ) ) ).

tff(addAssignment_61511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98317(VarCurr,B)
      <=> v98326(VarCurr,B) ) ) ).

tff(addAssignment_61510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98319(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98245(VarCurr,B)
      <=> v98247(VarCurr,B) ) ) ).

tff(addAssignment_61508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98247(VarCurr,B)
      <=> v98249(VarCurr,B) ) ) ).

tff(addAssignment_61507,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98249(VarNext,B)
      <=> v100614(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100615(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100614(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1180,axiom,
    ! [VarNext: state_type] :
      ( v100615(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100614(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100615(VarNext)
      <=> v100616(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100616(VarNext)
      <=> ( v100618(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_4787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100618(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_61506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98259(VarCurr,B)
      <=> v98261(VarCurr,B) ) ) ).

tff(addAssignment_61505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98261(VarCurr,B)
      <=> v98270(VarCurr,B) ) ) ).

tff(addAssignment_61504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98263(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98189(VarCurr,B)
      <=> v98191(VarCurr,B) ) ) ).

tff(addAssignment_61502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98191(VarCurr,B)
      <=> v98193(VarCurr,B) ) ) ).

tff(addAssignment_61501,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98193(VarNext,B)
      <=> v100606(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100607(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100606(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1179,axiom,
    ! [VarNext: state_type] :
      ( v100607(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100606(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100607(VarNext)
      <=> v100608(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100608(VarNext)
      <=> ( v100610(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_4786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100610(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_61500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98203(VarCurr,B)
      <=> v98205(VarCurr,B) ) ) ).

tff(addAssignment_61499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98205(VarCurr,B)
      <=> v98214(VarCurr,B) ) ) ).

tff(addAssignment_61498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98207(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98133(VarCurr,B)
      <=> v98135(VarCurr,B) ) ) ).

tff(addAssignment_61496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98135(VarCurr,B)
      <=> v98137(VarCurr,B) ) ) ).

tff(addAssignment_61495,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98137(VarNext,B)
      <=> v100598(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100599(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100598(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1178,axiom,
    ! [VarNext: state_type] :
      ( v100599(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100598(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100599(VarNext)
      <=> v100600(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100600(VarNext)
      <=> ( v100602(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_4785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100602(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_61494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98147(VarCurr,B)
      <=> v98149(VarCurr,B) ) ) ).

tff(addAssignment_61493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98149(VarCurr,B)
      <=> v98158(VarCurr,B) ) ) ).

tff(addAssignment_61492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98151(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98077(VarCurr,B)
      <=> v98079(VarCurr,B) ) ) ).

tff(addAssignment_61490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98079(VarCurr,B)
      <=> v98081(VarCurr,B) ) ) ).

tff(addAssignment_61489,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98081(VarNext,B)
      <=> v100590(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100591(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100590(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1177,axiom,
    ! [VarNext: state_type] :
      ( v100591(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100590(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100591(VarNext)
      <=> v100592(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100592(VarNext)
      <=> ( v100594(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_4784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100594(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_61488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98091(VarCurr,B)
      <=> v98093(VarCurr,B) ) ) ).

tff(addAssignment_61487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98093(VarCurr,B)
      <=> v98102(VarCurr,B) ) ) ).

tff(addAssignment_61486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98095(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98021(VarCurr,B)
      <=> v98023(VarCurr,B) ) ) ).

tff(addAssignment_61484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98023(VarCurr,B)
      <=> v98025(VarCurr,B) ) ) ).

tff(addAssignment_61483,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98025(VarNext,B)
      <=> v100582(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100583(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100582(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1176,axiom,
    ! [VarNext: state_type] :
      ( v100583(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100582(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100583(VarNext)
      <=> v100584(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100584(VarNext)
      <=> ( v100586(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_4783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100586(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_61482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98035(VarCurr,B)
      <=> v98037(VarCurr,B) ) ) ).

tff(addAssignment_61481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98037(VarCurr,B)
      <=> v98046(VarCurr,B) ) ) ).

tff(addAssignment_61480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98039(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97965(VarCurr,B)
      <=> v97967(VarCurr,B) ) ) ).

tff(addAssignment_61478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97967(VarCurr,B)
      <=> v97969(VarCurr,B) ) ) ).

tff(addAssignment_61477,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97969(VarNext,B)
      <=> v100574(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100575(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100574(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1175,axiom,
    ! [VarNext: state_type] :
      ( v100575(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100574(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100575(VarNext)
      <=> v100576(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100576(VarNext)
      <=> ( v100578(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_4782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100578(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_61476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97979(VarCurr,B)
      <=> v97981(VarCurr,B) ) ) ).

tff(addAssignment_61475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97981(VarCurr,B)
      <=> v97990(VarCurr,B) ) ) ).

tff(addAssignment_61474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97983(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97909(VarCurr,B)
      <=> v97911(VarCurr,B) ) ) ).

tff(addAssignment_61472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97911(VarCurr,B)
      <=> v97913(VarCurr,B) ) ) ).

tff(addAssignment_61471,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97913(VarNext,B)
      <=> v100566(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100567(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100566(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1174,axiom,
    ! [VarNext: state_type] :
      ( v100567(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100566(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100567(VarNext)
      <=> v100568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100568(VarNext)
      <=> ( v100570(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_4781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100570(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_61470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97923(VarCurr,B)
      <=> v97925(VarCurr,B) ) ) ).

tff(addAssignment_61469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97925(VarCurr,B)
      <=> v97934(VarCurr,B) ) ) ).

tff(addAssignment_61468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97927(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97853(VarCurr,B)
      <=> v97855(VarCurr,B) ) ) ).

tff(addAssignment_61466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97855(VarCurr,B)
      <=> v97857(VarCurr,B) ) ) ).

tff(addAssignment_61465,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97857(VarNext,B)
      <=> v100558(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100559(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100558(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1173,axiom,
    ! [VarNext: state_type] :
      ( v100559(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100558(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100559(VarNext)
      <=> v100560(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100560(VarNext)
      <=> ( v100562(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_4780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100562(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_61464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97867(VarCurr,B)
      <=> v97869(VarCurr,B) ) ) ).

tff(addAssignment_61463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97869(VarCurr,B)
      <=> v97878(VarCurr,B) ) ) ).

tff(addAssignment_61462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97871(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97797(VarCurr,B)
      <=> v97799(VarCurr,B) ) ) ).

tff(addAssignment_61460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97799(VarCurr,B)
      <=> v97801(VarCurr,B) ) ) ).

tff(addAssignment_61459,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97801(VarNext,B)
      <=> v100550(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100551(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100550(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1172,axiom,
    ! [VarNext: state_type] :
      ( v100551(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100550(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100551(VarNext)
      <=> v100552(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100552(VarNext)
      <=> ( v100554(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_4779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100554(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_61458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97811(VarCurr,B)
      <=> v97813(VarCurr,B) ) ) ).

tff(addAssignment_61457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97813(VarCurr,B)
      <=> v97822(VarCurr,B) ) ) ).

tff(addAssignment_61456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97815(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97741(VarCurr,B)
      <=> v97743(VarCurr,B) ) ) ).

tff(addAssignment_61454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97743(VarCurr,B)
      <=> v97745(VarCurr,B) ) ) ).

tff(addAssignment_61453,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97745(VarNext,B)
      <=> v100542(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100543(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100542(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1171,axiom,
    ! [VarNext: state_type] :
      ( v100543(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100542(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100543(VarNext)
      <=> v100544(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100544(VarNext)
      <=> ( v100546(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_4778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100546(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_61452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97755(VarCurr,B)
      <=> v97757(VarCurr,B) ) ) ).

tff(addAssignment_61451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97757(VarCurr,B)
      <=> v97766(VarCurr,B) ) ) ).

tff(addAssignment_61450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97759(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97685(VarCurr,B)
      <=> v97687(VarCurr,B) ) ) ).

tff(addAssignment_61448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97687(VarCurr,B)
      <=> v97689(VarCurr,B) ) ) ).

tff(addAssignment_61447,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97689(VarNext,B)
      <=> v100534(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100535(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100534(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1170,axiom,
    ! [VarNext: state_type] :
      ( v100535(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100534(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100535(VarNext)
      <=> v100536(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100536(VarNext)
      <=> ( v100538(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_4777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100538(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_61446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97699(VarCurr,B)
      <=> v97701(VarCurr,B) ) ) ).

tff(addAssignment_61445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97701(VarCurr,B)
      <=> v97710(VarCurr,B) ) ) ).

tff(addAssignment_61444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97703(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97629(VarCurr,B)
      <=> v97631(VarCurr,B) ) ) ).

tff(addAssignment_61442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97631(VarCurr,B)
      <=> v97633(VarCurr,B) ) ) ).

tff(addAssignment_61441,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97633(VarNext,B)
      <=> v100526(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100527(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100526(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1169,axiom,
    ! [VarNext: state_type] :
      ( v100527(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100526(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100527(VarNext)
      <=> v100528(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100528(VarNext)
      <=> ( v100530(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_4776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100530(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_61440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97643(VarCurr,B)
      <=> v97645(VarCurr,B) ) ) ).

tff(addAssignment_61439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97645(VarCurr,B)
      <=> v97654(VarCurr,B) ) ) ).

tff(addAssignment_61438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97647(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97573(VarCurr,B)
      <=> v97575(VarCurr,B) ) ) ).

tff(addAssignment_61436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97575(VarCurr,B)
      <=> v97577(VarCurr,B) ) ) ).

tff(addAssignment_61435,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97577(VarNext,B)
      <=> v100518(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100519(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100518(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1168,axiom,
    ! [VarNext: state_type] :
      ( v100519(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100518(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100519(VarNext)
      <=> v100520(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100520(VarNext)
      <=> ( v100522(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_4775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100522(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_61434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97587(VarCurr,B)
      <=> v97589(VarCurr,B) ) ) ).

tff(addAssignment_61433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97589(VarCurr,B)
      <=> v97598(VarCurr,B) ) ) ).

tff(addAssignment_61432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97591(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97413(VarCurr,B)
      <=> v97415(VarCurr,B) ) ) ).

tff(addAssignment_61430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97415(VarCurr,B)
      <=> v97417(VarCurr,B) ) ) ).

tff(addAssignment_61429,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97417(VarNext,B)
      <=> v100510(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100511(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100510(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1167,axiom,
    ! [VarNext: state_type] :
      ( v100511(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100510(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100511(VarNext)
      <=> v100512(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100512(VarNext)
      <=> ( v100514(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_4774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100514(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_61428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97427(VarCurr,B)
      <=> v97429(VarCurr,B) ) ) ).

tff(addAssignment_61427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97429(VarCurr,B)
      <=> v97486(VarCurr,B) ) ) ).

tff(addAssignment_61426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97431(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_61425,axiom,
    ! [VarCurr: state_type] :
      ( v100445(VarCurr,4)
    <=> v100446(VarCurr,4) ) ).

tff(addAssignment_61424,axiom,
    ! [VarCurr: state_type] :
      ( v100445(VarCurr,3)
    <=> v100446(VarCurr,3) ) ).

tff(addAssignment_61423,axiom,
    ! [VarCurr: state_type] :
      ( v100445(VarCurr,6)
    <=> v100446(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100446(VarCurr,B)
      <=> ( v100447(VarCurr,B)
          | v100506(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100506(VarCurr,B)
      <=> ( v100507(VarCurr,B)
          & v97413(VarCurr,B) ) ) ) ).

tff(addAssignment_61422,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,0)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61421,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,1)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61420,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,2)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61419,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,3)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61418,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,4)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61417,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,5)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61416,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,6)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61415,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,7)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61414,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,8)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61413,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,9)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61412,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,10)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61411,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,11)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61410,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,12)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61409,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,13)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61408,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,14)
    <=> v100508(VarCurr) ) ).

tff(addAssignment_61407,axiom,
    ! [VarCurr: state_type] :
      ( v100507(VarCurr,15)
    <=> v100508(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_619,axiom,
    ! [VarCurr: state_type] :
      ( v100508(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100447(VarCurr,B)
      <=> ( v100448(VarCurr,B)
          | v100503(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100503(VarCurr,B)
      <=> ( v100504(VarCurr,B)
          & v98301(VarCurr,B) ) ) ) ).

tff(addAssignment_61406,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,0)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61405,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,1)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61404,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,2)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61403,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,3)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61402,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,4)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61401,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,5)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61400,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,6)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61399,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,7)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61398,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,8)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61397,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,9)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61396,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,10)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61395,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,11)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61394,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,12)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61393,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,13)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61392,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,14)
    <=> v100505(VarCurr) ) ).

tff(addAssignment_61391,axiom,
    ! [VarCurr: state_type] :
      ( v100504(VarCurr,15)
    <=> v100505(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_618,axiom,
    ! [VarCurr: state_type] :
      ( v100505(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100448(VarCurr,B)
      <=> ( v100449(VarCurr,B)
          | v100500(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100500(VarCurr,B)
      <=> ( v100501(VarCurr,B)
          & v98245(VarCurr,B) ) ) ) ).

tff(addAssignment_61390,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,0)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61389,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,1)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61388,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,2)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61387,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,3)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61386,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,4)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61385,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,5)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61384,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,6)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61383,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,7)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61382,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,8)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61381,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,9)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61380,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,10)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61379,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,11)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61378,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,12)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61377,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,13)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61376,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,14)
    <=> v100502(VarCurr) ) ).

tff(addAssignment_61375,axiom,
    ! [VarCurr: state_type] :
      ( v100501(VarCurr,15)
    <=> v100502(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_617,axiom,
    ! [VarCurr: state_type] :
      ( v100502(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100449(VarCurr,B)
      <=> ( v100450(VarCurr,B)
          | v100497(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100497(VarCurr,B)
      <=> ( v100498(VarCurr,B)
          & v98189(VarCurr,B) ) ) ) ).

tff(addAssignment_61374,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,0)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61373,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,1)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61372,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,2)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61371,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,3)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61370,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,4)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61369,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,5)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61368,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,6)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61367,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,7)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61366,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,8)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61365,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,9)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61364,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,10)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61363,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,11)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61362,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,12)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61361,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,13)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61360,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,14)
    <=> v100499(VarCurr) ) ).

tff(addAssignment_61359,axiom,
    ! [VarCurr: state_type] :
      ( v100498(VarCurr,15)
    <=> v100499(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_616,axiom,
    ! [VarCurr: state_type] :
      ( v100499(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100450(VarCurr,B)
      <=> ( v100451(VarCurr,B)
          | v100494(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100494(VarCurr,B)
      <=> ( v100495(VarCurr,B)
          & v98133(VarCurr,B) ) ) ) ).

tff(addAssignment_61358,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,0)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61357,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,1)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61356,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,2)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61355,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,3)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61354,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,4)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61353,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,5)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61352,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,6)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61351,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,7)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61350,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,8)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61349,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,9)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61348,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,10)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61347,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,11)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61346,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,12)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61345,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,13)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61344,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,14)
    <=> v100496(VarCurr) ) ).

tff(addAssignment_61343,axiom,
    ! [VarCurr: state_type] :
      ( v100495(VarCurr,15)
    <=> v100496(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_615,axiom,
    ! [VarCurr: state_type] :
      ( v100496(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100451(VarCurr,B)
      <=> ( v100452(VarCurr,B)
          | v100491(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100491(VarCurr,B)
      <=> ( v100492(VarCurr,B)
          & v98077(VarCurr,B) ) ) ) ).

tff(addAssignment_61342,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,0)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61341,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,1)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61340,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,2)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61339,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,3)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61338,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,4)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61337,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,5)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61336,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,6)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61335,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,7)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61334,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,8)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61333,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,9)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61332,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,10)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61331,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,11)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61330,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,12)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61329,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,13)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61328,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,14)
    <=> v100493(VarCurr) ) ).

tff(addAssignment_61327,axiom,
    ! [VarCurr: state_type] :
      ( v100492(VarCurr,15)
    <=> v100493(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_614,axiom,
    ! [VarCurr: state_type] :
      ( v100493(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100452(VarCurr,B)
      <=> ( v100453(VarCurr,B)
          | v100488(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100488(VarCurr,B)
      <=> ( v100489(VarCurr,B)
          & v98021(VarCurr,B) ) ) ) ).

tff(addAssignment_61326,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,0)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61325,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,1)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61324,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,2)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61323,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,3)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61322,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,4)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61321,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,5)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61320,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,6)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61319,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,7)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61318,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,8)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61317,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,9)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61316,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,10)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61315,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,11)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61314,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,12)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61313,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,13)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61312,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,14)
    <=> v100490(VarCurr) ) ).

tff(addAssignment_61311,axiom,
    ! [VarCurr: state_type] :
      ( v100489(VarCurr,15)
    <=> v100490(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_613,axiom,
    ! [VarCurr: state_type] :
      ( v100490(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100453(VarCurr,B)
      <=> ( v100454(VarCurr,B)
          | v100485(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100485(VarCurr,B)
      <=> ( v100486(VarCurr,B)
          & v97965(VarCurr,B) ) ) ) ).

tff(addAssignment_61310,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,0)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61309,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,1)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61308,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,2)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61307,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,3)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61306,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,4)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61305,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,5)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61304,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,6)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61303,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,7)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61302,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,8)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61301,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,9)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61300,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,10)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61299,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,11)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61298,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,12)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61297,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,13)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61296,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,14)
    <=> v100487(VarCurr) ) ).

tff(addAssignment_61295,axiom,
    ! [VarCurr: state_type] :
      ( v100486(VarCurr,15)
    <=> v100487(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_612,axiom,
    ! [VarCurr: state_type] :
      ( v100487(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $true )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100454(VarCurr,B)
      <=> ( v100455(VarCurr,B)
          | v100482(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100482(VarCurr,B)
      <=> ( v100483(VarCurr,B)
          & v97909(VarCurr,B) ) ) ) ).

tff(addAssignment_61294,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,0)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61293,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,1)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61292,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,2)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61291,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,3)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61290,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,4)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61289,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,5)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61288,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,6)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61287,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,7)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61286,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,8)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61285,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,9)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61284,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,10)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61283,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,11)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61282,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,12)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61281,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,13)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61280,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,14)
    <=> v100484(VarCurr) ) ).

tff(addAssignment_61279,axiom,
    ! [VarCurr: state_type] :
      ( v100483(VarCurr,15)
    <=> v100484(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_611,axiom,
    ! [VarCurr: state_type] :
      ( v100484(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100455(VarCurr,B)
      <=> ( v100456(VarCurr,B)
          | v100479(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100479(VarCurr,B)
      <=> ( v100480(VarCurr,B)
          & v97853(VarCurr,B) ) ) ) ).

tff(addAssignment_61278,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,0)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61277,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,1)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61276,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,2)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61275,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,3)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61274,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,4)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61273,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,5)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61272,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,6)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61271,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,7)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61270,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,8)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61269,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,9)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61268,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,10)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61267,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,11)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61266,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,12)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61265,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,13)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61264,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,14)
    <=> v100481(VarCurr) ) ).

tff(addAssignment_61263,axiom,
    ! [VarCurr: state_type] :
      ( v100480(VarCurr,15)
    <=> v100481(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_610,axiom,
    ! [VarCurr: state_type] :
      ( v100481(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100456(VarCurr,B)
      <=> ( v100457(VarCurr,B)
          | v100476(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100476(VarCurr,B)
      <=> ( v100477(VarCurr,B)
          & v97797(VarCurr,B) ) ) ) ).

tff(addAssignment_61262,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,0)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61261,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,1)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61260,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,2)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61259,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,3)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61258,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,4)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61257,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,5)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61256,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,6)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61255,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,7)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61254,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,8)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61253,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,9)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61252,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,10)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61251,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,11)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61250,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,12)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61249,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,13)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61248,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,14)
    <=> v100478(VarCurr) ) ).

tff(addAssignment_61247,axiom,
    ! [VarCurr: state_type] :
      ( v100477(VarCurr,15)
    <=> v100478(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_609,axiom,
    ! [VarCurr: state_type] :
      ( v100478(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100457(VarCurr,B)
      <=> ( v100458(VarCurr,B)
          | v100473(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100473(VarCurr,B)
      <=> ( v100474(VarCurr,B)
          & v97741(VarCurr,B) ) ) ) ).

tff(addAssignment_61246,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,0)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61245,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,1)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61244,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,2)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61243,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,3)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61242,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,4)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61241,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,5)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61240,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,6)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61239,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,7)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61238,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,8)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61237,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,9)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61236,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,10)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61235,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,11)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61234,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,12)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61233,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,13)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61232,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,14)
    <=> v100475(VarCurr) ) ).

tff(addAssignment_61231,axiom,
    ! [VarCurr: state_type] :
      ( v100474(VarCurr,15)
    <=> v100475(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_608,axiom,
    ! [VarCurr: state_type] :
      ( v100475(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $true )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100458(VarCurr,B)
      <=> ( v100459(VarCurr,B)
          | v100470(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100470(VarCurr,B)
      <=> ( v100471(VarCurr,B)
          & v97685(VarCurr,B) ) ) ) ).

tff(addAssignment_61230,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,0)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61229,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,1)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61228,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,2)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61227,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,3)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61226,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,4)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61225,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,5)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61224,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,6)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61223,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,7)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61222,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,8)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61221,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,9)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61220,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,10)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61219,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,11)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61218,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,12)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61217,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,13)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61216,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,14)
    <=> v100472(VarCurr) ) ).

tff(addAssignment_61215,axiom,
    ! [VarCurr: state_type] :
      ( v100471(VarCurr,15)
    <=> v100472(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_607,axiom,
    ! [VarCurr: state_type] :
      ( v100472(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100459(VarCurr,B)
      <=> ( v100460(VarCurr,B)
          | v100467(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100467(VarCurr,B)
      <=> ( v100468(VarCurr,B)
          & v97629(VarCurr,B) ) ) ) ).

tff(addAssignment_61214,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,0)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61213,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,1)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61212,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,2)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61211,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,3)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61210,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,4)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61209,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,5)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61208,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,6)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61207,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,7)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61206,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,8)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61205,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,9)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61204,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,10)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61203,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,11)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61202,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,12)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61201,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,13)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61200,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,14)
    <=> v100469(VarCurr) ) ).

tff(addAssignment_61199,axiom,
    ! [VarCurr: state_type] :
      ( v100468(VarCurr,15)
    <=> v100469(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_606,axiom,
    ! [VarCurr: state_type] :
      ( v100469(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $true )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100460(VarCurr,B)
      <=> ( v100461(VarCurr,B)
          | v100464(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100464(VarCurr,B)
      <=> ( v100465(VarCurr,B)
          & v97573(VarCurr,B) ) ) ) ).

tff(addAssignment_61198,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,0)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61197,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,1)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61196,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,2)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61195,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,3)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61194,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,4)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61193,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,5)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61192,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,6)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61191,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,7)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61190,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,8)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61189,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,9)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61188,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,10)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61187,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,11)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61186,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,12)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61185,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,13)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61184,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,14)
    <=> v100466(VarCurr) ) ).

tff(addAssignment_61183,axiom,
    ! [VarCurr: state_type] :
      ( v100465(VarCurr,15)
    <=> v100466(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_605,axiom,
    ! [VarCurr: state_type] :
      ( v100466(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v100461(VarCurr,B)
      <=> ( v100462(VarCurr,B)
          & v97517(VarCurr,B) ) ) ) ).

tff(addAssignment_61182,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,0)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61181,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,1)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61180,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,2)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61179,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,3)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61178,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,4)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61177,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,5)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61176,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,6)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61175,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,7)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61174,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,8)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61173,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,9)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61172,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,10)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61171,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,11)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61170,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,12)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61169,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,13)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61168,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,14)
    <=> v100463(VarCurr) ) ).

tff(addAssignment_61167,axiom,
    ! [VarCurr: state_type] :
      ( v100462(VarCurr,15)
    <=> v100463(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_604,axiom,
    ! [VarCurr: state_type] :
      ( v100463(VarCurr)
    <=> ( ( v100411(VarCurr,3)
        <=> $false )
        & ( v100411(VarCurr,2)
        <=> $false )
        & ( v100411(VarCurr,1)
        <=> $false )
        & ( v100411(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_61166,axiom,
    ! [VarCurr: state_type] :
      ( v100421(VarCurr)
    <=> v100423(VarCurr) ) ).

tff(addAssignment_61165,axiom,
    ! [VarCurr: state_type] :
      ( v100423(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_61164,axiom,
    ! [VarCurr: state_type] :
      ( v100417(VarCurr)
    <=> v100419(VarCurr) ) ).

tff(addAssignment_61163,axiom,
    ! [VarCurr: state_type] :
      ( v100419(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_61162,axiom,
    ! [VarCurr: state_type] :
      ( v97411(VarCurr,6)
    <=> v98356(VarCurr,6) ) ).

tff(addAssignment_61161,axiom,
    ! [VarCurr: state_type] :
      ( v98301(VarCurr,6)
    <=> v98303(VarCurr,6) ) ).

tff(addAssignment_61160,axiom,
    ! [VarCurr: state_type] :
      ( v98303(VarCurr,6)
    <=> v98305(VarCurr,6) ) ).

tff(addAssignment_61159,axiom,
    ! [VarNext: state_type] :
      ( v98305(VarNext,6)
    <=> v100401(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100402(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100401(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1166,axiom,
    ! [VarNext: state_type] :
      ( v100402(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100401(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100402(VarNext)
      <=> v100403(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100403(VarNext)
      <=> ( v100405(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_4773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100405(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_61158,axiom,
    ! [VarCurr: state_type] :
      ( v98315(VarCurr,6)
    <=> v98317(VarCurr,6) ) ).

tff(addAssignment_61157,axiom,
    ! [VarCurr: state_type] :
      ( v98317(VarCurr,6)
    <=> v98326(VarCurr,6) ) ).

tff(addAssignment_61156,axiom,
    ! [VarCurr: state_type] :
      ( v98319(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61155,axiom,
    ! [VarCurr: state_type] :
      ( v98245(VarCurr,6)
    <=> v98247(VarCurr,6) ) ).

tff(addAssignment_61154,axiom,
    ! [VarCurr: state_type] :
      ( v98247(VarCurr,6)
    <=> v98249(VarCurr,6) ) ).

tff(addAssignment_61153,axiom,
    ! [VarNext: state_type] :
      ( v98249(VarNext,6)
    <=> v100393(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100394(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100393(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1165,axiom,
    ! [VarNext: state_type] :
      ( v100394(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100393(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100394(VarNext)
      <=> v100395(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100395(VarNext)
      <=> ( v100397(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_4772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100397(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_61152,axiom,
    ! [VarCurr: state_type] :
      ( v98259(VarCurr,6)
    <=> v98261(VarCurr,6) ) ).

tff(addAssignment_61151,axiom,
    ! [VarCurr: state_type] :
      ( v98261(VarCurr,6)
    <=> v98270(VarCurr,6) ) ).

tff(addAssignment_61150,axiom,
    ! [VarCurr: state_type] :
      ( v98263(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61149,axiom,
    ! [VarCurr: state_type] :
      ( v98189(VarCurr,6)
    <=> v98191(VarCurr,6) ) ).

tff(addAssignment_61148,axiom,
    ! [VarCurr: state_type] :
      ( v98191(VarCurr,6)
    <=> v98193(VarCurr,6) ) ).

tff(addAssignment_61147,axiom,
    ! [VarNext: state_type] :
      ( v98193(VarNext,6)
    <=> v100385(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100386(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100385(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1164,axiom,
    ! [VarNext: state_type] :
      ( v100386(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100385(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100386(VarNext)
      <=> v100387(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100387(VarNext)
      <=> ( v100389(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_4771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100389(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_61146,axiom,
    ! [VarCurr: state_type] :
      ( v98203(VarCurr,6)
    <=> v98205(VarCurr,6) ) ).

tff(addAssignment_61145,axiom,
    ! [VarCurr: state_type] :
      ( v98205(VarCurr,6)
    <=> v98214(VarCurr,6) ) ).

tff(addAssignment_61144,axiom,
    ! [VarCurr: state_type] :
      ( v98207(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61143,axiom,
    ! [VarCurr: state_type] :
      ( v98133(VarCurr,6)
    <=> v98135(VarCurr,6) ) ).

tff(addAssignment_61142,axiom,
    ! [VarCurr: state_type] :
      ( v98135(VarCurr,6)
    <=> v98137(VarCurr,6) ) ).

tff(addAssignment_61141,axiom,
    ! [VarNext: state_type] :
      ( v98137(VarNext,6)
    <=> v100377(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100378(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100377(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1163,axiom,
    ! [VarNext: state_type] :
      ( v100378(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100377(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100378(VarNext)
      <=> v100379(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100379(VarNext)
      <=> ( v100381(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_4770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100381(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_61140,axiom,
    ! [VarCurr: state_type] :
      ( v98147(VarCurr,6)
    <=> v98149(VarCurr,6) ) ).

tff(addAssignment_61139,axiom,
    ! [VarCurr: state_type] :
      ( v98149(VarCurr,6)
    <=> v98158(VarCurr,6) ) ).

tff(addAssignment_61138,axiom,
    ! [VarCurr: state_type] :
      ( v98151(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61137,axiom,
    ! [VarCurr: state_type] :
      ( v98077(VarCurr,6)
    <=> v98079(VarCurr,6) ) ).

tff(addAssignment_61136,axiom,
    ! [VarCurr: state_type] :
      ( v98079(VarCurr,6)
    <=> v98081(VarCurr,6) ) ).

tff(addAssignment_61135,axiom,
    ! [VarNext: state_type] :
      ( v98081(VarNext,6)
    <=> v100369(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100370(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100369(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1162,axiom,
    ! [VarNext: state_type] :
      ( v100370(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100369(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100370(VarNext)
      <=> v100371(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100371(VarNext)
      <=> ( v100373(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_4769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100373(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_61134,axiom,
    ! [VarCurr: state_type] :
      ( v98091(VarCurr,6)
    <=> v98093(VarCurr,6) ) ).

tff(addAssignment_61133,axiom,
    ! [VarCurr: state_type] :
      ( v98093(VarCurr,6)
    <=> v98102(VarCurr,6) ) ).

tff(addAssignment_61132,axiom,
    ! [VarCurr: state_type] :
      ( v98095(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61131,axiom,
    ! [VarCurr: state_type] :
      ( v98021(VarCurr,6)
    <=> v98023(VarCurr,6) ) ).

tff(addAssignment_61130,axiom,
    ! [VarCurr: state_type] :
      ( v98023(VarCurr,6)
    <=> v98025(VarCurr,6) ) ).

tff(addAssignment_61129,axiom,
    ! [VarNext: state_type] :
      ( v98025(VarNext,6)
    <=> v100361(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100362(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100361(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1161,axiom,
    ! [VarNext: state_type] :
      ( v100362(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100361(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100362(VarNext)
      <=> v100363(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100363(VarNext)
      <=> ( v100365(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_4768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100365(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_61128,axiom,
    ! [VarCurr: state_type] :
      ( v98035(VarCurr,6)
    <=> v98037(VarCurr,6) ) ).

tff(addAssignment_61127,axiom,
    ! [VarCurr: state_type] :
      ( v98037(VarCurr,6)
    <=> v98046(VarCurr,6) ) ).

tff(addAssignment_61126,axiom,
    ! [VarCurr: state_type] :
      ( v98039(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61125,axiom,
    ! [VarCurr: state_type] :
      ( v97965(VarCurr,6)
    <=> v97967(VarCurr,6) ) ).

tff(addAssignment_61124,axiom,
    ! [VarCurr: state_type] :
      ( v97967(VarCurr,6)
    <=> v97969(VarCurr,6) ) ).

tff(addAssignment_61123,axiom,
    ! [VarNext: state_type] :
      ( v97969(VarNext,6)
    <=> v100353(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100354(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100353(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1160,axiom,
    ! [VarNext: state_type] :
      ( v100354(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100353(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100354(VarNext)
      <=> v100355(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100355(VarNext)
      <=> ( v100357(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_4767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100357(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_61122,axiom,
    ! [VarCurr: state_type] :
      ( v97979(VarCurr,6)
    <=> v97981(VarCurr,6) ) ).

tff(addAssignment_61121,axiom,
    ! [VarCurr: state_type] :
      ( v97981(VarCurr,6)
    <=> v97990(VarCurr,6) ) ).

tff(addAssignment_61120,axiom,
    ! [VarCurr: state_type] :
      ( v97983(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61119,axiom,
    ! [VarCurr: state_type] :
      ( v97909(VarCurr,6)
    <=> v97911(VarCurr,6) ) ).

tff(addAssignment_61118,axiom,
    ! [VarCurr: state_type] :
      ( v97911(VarCurr,6)
    <=> v97913(VarCurr,6) ) ).

tff(addAssignment_61117,axiom,
    ! [VarNext: state_type] :
      ( v97913(VarNext,6)
    <=> v100345(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100346(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100345(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1159,axiom,
    ! [VarNext: state_type] :
      ( v100346(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100345(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100346(VarNext)
      <=> v100347(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100347(VarNext)
      <=> ( v100349(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_4766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100349(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_61116,axiom,
    ! [VarCurr: state_type] :
      ( v97923(VarCurr,6)
    <=> v97925(VarCurr,6) ) ).

tff(addAssignment_61115,axiom,
    ! [VarCurr: state_type] :
      ( v97925(VarCurr,6)
    <=> v97934(VarCurr,6) ) ).

tff(addAssignment_61114,axiom,
    ! [VarCurr: state_type] :
      ( v97927(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61113,axiom,
    ! [VarCurr: state_type] :
      ( v97853(VarCurr,6)
    <=> v97855(VarCurr,6) ) ).

tff(addAssignment_61112,axiom,
    ! [VarCurr: state_type] :
      ( v97855(VarCurr,6)
    <=> v97857(VarCurr,6) ) ).

tff(addAssignment_61111,axiom,
    ! [VarNext: state_type] :
      ( v97857(VarNext,6)
    <=> v100337(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100338(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100337(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1158,axiom,
    ! [VarNext: state_type] :
      ( v100338(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100337(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100338(VarNext)
      <=> v100339(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100339(VarNext)
      <=> ( v100341(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_4765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100341(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_61110,axiom,
    ! [VarCurr: state_type] :
      ( v97867(VarCurr,6)
    <=> v97869(VarCurr,6) ) ).

tff(addAssignment_61109,axiom,
    ! [VarCurr: state_type] :
      ( v97869(VarCurr,6)
    <=> v97878(VarCurr,6) ) ).

tff(addAssignment_61108,axiom,
    ! [VarCurr: state_type] :
      ( v97871(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61107,axiom,
    ! [VarCurr: state_type] :
      ( v97797(VarCurr,6)
    <=> v97799(VarCurr,6) ) ).

tff(addAssignment_61106,axiom,
    ! [VarCurr: state_type] :
      ( v97799(VarCurr,6)
    <=> v97801(VarCurr,6) ) ).

tff(addAssignment_61105,axiom,
    ! [VarNext: state_type] :
      ( v97801(VarNext,6)
    <=> v100329(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100330(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100329(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1157,axiom,
    ! [VarNext: state_type] :
      ( v100330(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100329(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100330(VarNext)
      <=> v100331(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100331(VarNext)
      <=> ( v100333(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_4764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100333(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_61104,axiom,
    ! [VarCurr: state_type] :
      ( v97811(VarCurr,6)
    <=> v97813(VarCurr,6) ) ).

tff(addAssignment_61103,axiom,
    ! [VarCurr: state_type] :
      ( v97813(VarCurr,6)
    <=> v97822(VarCurr,6) ) ).

tff(addAssignment_61102,axiom,
    ! [VarCurr: state_type] :
      ( v97815(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61101,axiom,
    ! [VarCurr: state_type] :
      ( v97741(VarCurr,6)
    <=> v97743(VarCurr,6) ) ).

tff(addAssignment_61100,axiom,
    ! [VarCurr: state_type] :
      ( v97743(VarCurr,6)
    <=> v97745(VarCurr,6) ) ).

tff(addAssignment_61099,axiom,
    ! [VarNext: state_type] :
      ( v97745(VarNext,6)
    <=> v100321(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100322(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100321(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1156,axiom,
    ! [VarNext: state_type] :
      ( v100322(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100321(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100322(VarNext)
      <=> v100323(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100323(VarNext)
      <=> ( v100325(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_4763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100325(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_61098,axiom,
    ! [VarCurr: state_type] :
      ( v97755(VarCurr,6)
    <=> v97757(VarCurr,6) ) ).

tff(addAssignment_61097,axiom,
    ! [VarCurr: state_type] :
      ( v97757(VarCurr,6)
    <=> v97766(VarCurr,6) ) ).

tff(addAssignment_61096,axiom,
    ! [VarCurr: state_type] :
      ( v97759(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61095,axiom,
    ! [VarCurr: state_type] :
      ( v97685(VarCurr,6)
    <=> v97687(VarCurr,6) ) ).

tff(addAssignment_61094,axiom,
    ! [VarCurr: state_type] :
      ( v97687(VarCurr,6)
    <=> v97689(VarCurr,6) ) ).

tff(addAssignment_61093,axiom,
    ! [VarNext: state_type] :
      ( v97689(VarNext,6)
    <=> v100313(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100314(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100313(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1155,axiom,
    ! [VarNext: state_type] :
      ( v100314(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100313(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100314(VarNext)
      <=> v100315(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100315(VarNext)
      <=> ( v100317(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_4762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100317(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_61092,axiom,
    ! [VarCurr: state_type] :
      ( v97699(VarCurr,6)
    <=> v97701(VarCurr,6) ) ).

tff(addAssignment_61091,axiom,
    ! [VarCurr: state_type] :
      ( v97701(VarCurr,6)
    <=> v97710(VarCurr,6) ) ).

tff(addAssignment_61090,axiom,
    ! [VarCurr: state_type] :
      ( v97703(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61089,axiom,
    ! [VarCurr: state_type] :
      ( v97629(VarCurr,6)
    <=> v97631(VarCurr,6) ) ).

tff(addAssignment_61088,axiom,
    ! [VarCurr: state_type] :
      ( v97631(VarCurr,6)
    <=> v97633(VarCurr,6) ) ).

tff(addAssignment_61087,axiom,
    ! [VarNext: state_type] :
      ( v97633(VarNext,6)
    <=> v100305(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100306(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100305(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1154,axiom,
    ! [VarNext: state_type] :
      ( v100306(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100305(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100306(VarNext)
      <=> v100307(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100307(VarNext)
      <=> ( v100309(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_4761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100309(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_61086,axiom,
    ! [VarCurr: state_type] :
      ( v97643(VarCurr,6)
    <=> v97645(VarCurr,6) ) ).

tff(addAssignment_61085,axiom,
    ! [VarCurr: state_type] :
      ( v97645(VarCurr,6)
    <=> v97654(VarCurr,6) ) ).

tff(addAssignment_61084,axiom,
    ! [VarCurr: state_type] :
      ( v97647(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61083,axiom,
    ! [VarCurr: state_type] :
      ( v97573(VarCurr,6)
    <=> v97575(VarCurr,6) ) ).

tff(addAssignment_61082,axiom,
    ! [VarCurr: state_type] :
      ( v97575(VarCurr,6)
    <=> v97577(VarCurr,6) ) ).

tff(addAssignment_61081,axiom,
    ! [VarNext: state_type] :
      ( v97577(VarNext,6)
    <=> v100297(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100298(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100297(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1153,axiom,
    ! [VarNext: state_type] :
      ( v100298(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100297(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100298(VarNext)
      <=> v100299(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100299(VarNext)
      <=> ( v100301(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_4760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100301(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_61080,axiom,
    ! [VarCurr: state_type] :
      ( v97587(VarCurr,6)
    <=> v97589(VarCurr,6) ) ).

tff(addAssignment_61079,axiom,
    ! [VarCurr: state_type] :
      ( v97589(VarCurr,6)
    <=> v97598(VarCurr,6) ) ).

tff(addAssignment_61078,axiom,
    ! [VarCurr: state_type] :
      ( v97591(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61077,axiom,
    ! [VarCurr: state_type] :
      ( v97517(VarCurr,6)
    <=> v97519(VarCurr,6) ) ).

tff(addAssignment_61076,axiom,
    ! [VarCurr: state_type] :
      ( v97519(VarCurr,6)
    <=> v97521(VarCurr,6) ) ).

tff(addAssignment_61075,axiom,
    ! [VarNext: state_type] :
      ( v97521(VarNext,6)
    <=> v100289(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100290(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100289(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1152,axiom,
    ! [VarNext: state_type] :
      ( v100290(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100289(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100290(VarNext)
      <=> v100291(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100291(VarNext)
      <=> ( v100293(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_4759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100293(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_61074,axiom,
    ! [VarCurr: state_type] :
      ( v97531(VarCurr,6)
    <=> v97533(VarCurr,6) ) ).

tff(addAssignment_61073,axiom,
    ! [VarCurr: state_type] :
      ( v97533(VarCurr,6)
    <=> v97542(VarCurr,6) ) ).

tff(addAssignment_61072,axiom,
    ! [VarCurr: state_type] :
      ( v97535(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61071,axiom,
    ! [VarCurr: state_type] :
      ( v97413(VarCurr,6)
    <=> v97415(VarCurr,6) ) ).

tff(addAssignment_61070,axiom,
    ! [VarCurr: state_type] :
      ( v97415(VarCurr,6)
    <=> v97417(VarCurr,6) ) ).

tff(addAssignment_61069,axiom,
    ! [VarNext: state_type] :
      ( v97417(VarNext,6)
    <=> v100281(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v100281(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1151,axiom,
    ! [VarNext: state_type] :
      ( v100282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v100281(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100282(VarNext)
      <=> v100283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100283(VarNext)
      <=> ( v100285(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_4758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100285(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_61068,axiom,
    ! [VarCurr: state_type] :
      ( v97427(VarCurr,6)
    <=> v97429(VarCurr,6) ) ).

tff(addAssignment_61067,axiom,
    ! [VarCurr: state_type] :
      ( v97429(VarCurr,6)
    <=> v97486(VarCurr,6) ) ).

tff(addAssignment_61066,axiom,
    ! [VarCurr: state_type] :
      ( v97431(VarCurr,6)
    <=> v97409(VarCurr,6) ) ).

tff(addAssignment_61065,axiom,
    ! [VarCurr: state_type] :
      ( v97409(VarCurr,6)
    <=> v100196(VarCurr,6) ) ).

tff(addAssignment_61064,axiom,
    ! [VarCurr: state_type] :
      ( v100043(VarCurr,6)
    <=> v100045(VarCurr,6) ) ).

tff(addAssignment_61063,axiom,
    ! [VarCurr: state_type] :
      ( v100045(VarCurr,6)
    <=> v100047(VarCurr,6) ) ).

tff(addAssignment_61062,axiom,
    ! [VarCurr: state_type] :
      ( v100047(VarCurr,6)
    <=> v100049(VarCurr,6) ) ).

tff(addAssignment_61061,axiom,
    ! [VarCurr: state_type] :
      ( v100049(VarCurr,6)
    <=> v100051(VarCurr,6) ) ).

tff(addAssignment_61060,axiom,
    ! [VarNext: state_type] :
      ( v100051(VarNext,6)
    <=> v100273(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100274(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100273(VarNext,B)
            <=> v100051(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1150,axiom,
    ! [VarNext: state_type] :
      ( v100274(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100273(VarNext,B)
          <=> v100190(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100274(VarNext)
      <=> v100275(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100275(VarNext)
      <=> ( v100277(VarNext)
          & v100175(VarNext) ) ) ) ).

tff(writeUnaryOperator_4757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100277(VarNext)
      <=> v100184(VarNext) ) ) ).

tff(addAssignment_61059,axiom,
    ! [VarCurr: state_type] :
      ( v100061(VarCurr,6)
    <=> v100063(VarCurr,6) ) ).

tff(addAssignment_61058,axiom,
    ! [VarCurr: state_type] :
      ( v100063(VarCurr,6)
    <=> v100166(VarCurr,6) ) ).

tff(addAssignment_61057,axiom,
    ! [VarCurr: state_type] :
      ( v100065(VarCurr,6)
    <=> v100067(VarCurr,6) ) ).

tff(addAssignment_61056,axiom,
    ! [VarCurr: state_type] :
      ( v100067(VarCurr,6)
    <=> v100158(VarCurr,6) ) ).

tff(addAssignment_61055,axiom,
    ! [VarCurr: state_type] :
      ( v100097(VarCurr,6)
    <=> v100115(VarCurr,6) ) ).

tff(addAssignment_61054,axiom,
    ! [VarCurr: state_type] :
      ( v3918(VarCurr,6)
    <=> v3920(VarCurr,6) ) ).

tff(addAssignment_61053,axiom,
    ! [VarCurr: state_type] :
      ( v3920(VarCurr,6)
    <=> v3922(VarCurr,6) ) ).

tff(addAssignment_61052,axiom,
    ! [VarNext: state_type] :
      ( v3922(VarNext,6)
    <=> v100265(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100266(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v100265(VarNext,B)
            <=> v3922(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1149,axiom,
    ! [VarNext: state_type] :
      ( v100266(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v100265(VarNext,B)
          <=> v4074(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100266(VarNext)
      <=> v100267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100267(VarNext)
      <=> ( v100269(VarNext)
          & v4059(VarNext) ) ) ) ).

tff(writeUnaryOperator_4756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100269(VarNext)
      <=> v4068(VarNext) ) ) ).

tff(addAssignment_61051,axiom,
    ! [VarCurr: state_type] :
      ( v3932(VarCurr,6)
    <=> v3934(VarCurr,6) ) ).

tff(addAssignment_61050,axiom,
    ! [VarCurr: state_type] :
      ( v3934(VarCurr,6)
    <=> v3936(VarCurr,6) ) ).

tff(addAssignment_61049,axiom,
    ! [VarCurr: state_type] :
      ( v3936(VarCurr,6)
    <=> v4052(VarCurr,6) ) ).

tff(addAssignment_61048,axiom,
    ! [VarCurr: state_type] :
      ( v4054(VarCurr)
    <=> v100257(VarCurr) ) ).

tff(addAssignment_61047,axiom,
    ! [VarCurr: state_type] :
      ( v100257(VarCurr)
    <=> v100259(VarCurr) ) ).

tff(addAssignment_61046,axiom,
    ! [VarCurr: state_type] :
      ( v100259(VarCurr)
    <=> v100261(VarCurr) ) ).

tff(addAssignment_61045,axiom,
    ! [VarCurr: state_type] :
      ( v100261(VarCurr)
    <=> v100263(VarCurr) ) ).

tff(addAssignment_61044,axiom,
    ! [VarCurr: state_type] :
      ( v100263(VarCurr)
    <=> v3948(VarCurr,17) ) ).

tff(addAssignment_61043,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,17)
    <=> v3950(VarCurr,17) ) ).

tff(addAssignment_61042,axiom,
    ! [VarCurr: state_type] :
      ( v100069(VarCurr,6)
    <=> v100071(VarCurr,6) ) ).

tff(addAssignment_61041,axiom,
    ! [VarCurr: state_type] :
      ( v100071(VarCurr,6)
    <=> v100073(VarCurr,6) ) ).

tff(addAssignment_61040,axiom,
    ! [VarCurr: state_type] :
      ( v99888(VarCurr,6)
    <=> v99890(VarCurr,6) ) ).

tff(addAssignment_61039,axiom,
    ! [VarCurr: state_type] :
      ( v99890(VarCurr,6)
    <=> v99892(VarCurr,6) ) ).

tff(addAssignment_61038,axiom,
    ! [VarCurr: state_type] :
      ( v99892(VarCurr,6)
    <=> v99894(VarCurr,6) ) ).

tff(addAssignment_61037,axiom,
    ! [VarCurr: state_type] :
      ( v99894(VarCurr,6)
    <=> v99896(VarCurr,6) ) ).

tff(addAssignment_61036,axiom,
    ! [VarNext: state_type] :
      ( v99896(VarNext,6)
    <=> v100248(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100249(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100248(VarNext,B)
            <=> v99896(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1148,axiom,
    ! [VarNext: state_type] :
      ( v100249(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100248(VarNext,B)
          <=> v100036(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100249(VarNext)
      <=> v100250(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100250(VarNext)
      <=> ( v100252(VarNext)
          & v100021(VarNext) ) ) ) ).

tff(writeUnaryOperator_4755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100252(VarNext)
      <=> v100030(VarNext) ) ) ).

tff(addAssignment_61035,axiom,
    ! [VarCurr: state_type] :
      ( v99906(VarCurr,6)
    <=> v99908(VarCurr,6) ) ).

tff(addAssignment_61034,axiom,
    ! [VarCurr: state_type] :
      ( v99908(VarCurr,6)
    <=> v100012(VarCurr,6) ) ).

tff(addAssignment_61033,axiom,
    ! [VarCurr: state_type] :
      ( v99910(VarCurr,6)
    <=> v99912(VarCurr,6) ) ).

tff(addAssignment_61032,axiom,
    ! [VarCurr: state_type] :
      ( v99912(VarCurr,6)
    <=> v100004(VarCurr,6) ) ).

tff(addAssignment_61031,axiom,
    ! [VarCurr: state_type] :
      ( v99942(VarCurr,6)
    <=> v99960(VarCurr,6) ) ).

tff(addAssignment_61030,axiom,
    ! [VarCurr: state_type] :
      ( v89443(VarCurr,6)
    <=> v89445(VarCurr,6) ) ).

tff(addAssignment_61029,axiom,
    ! [VarCurr: state_type] :
      ( v89445(VarCurr,6)
    <=> v89447(VarCurr,6) ) ).

tff(addAssignment_61028,axiom,
    ! [VarNext: state_type] :
      ( v89447(VarNext,6)
    <=> v100240(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100241(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v100240(VarNext,B)
            <=> v89447(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1147,axiom,
    ! [VarNext: state_type] :
      ( v100241(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v100240(VarNext,B)
          <=> v89504(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9378,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100241(VarNext)
      <=> v100242(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100242(VarNext)
      <=> ( v100244(VarNext)
          & v89489(VarNext) ) ) ) ).

tff(writeUnaryOperator_4754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100244(VarNext)
      <=> v89498(VarNext) ) ) ).

tff(addAssignment_61027,axiom,
    ! [VarCurr: state_type] :
      ( v89457(VarCurr,6)
    <=> v89459(VarCurr,6) ) ).

tff(addAssignment_61026,axiom,
    ! [VarCurr: state_type] :
      ( v89459(VarCurr,6)
    <=> v89461(VarCurr,6) ) ).

tff(addAssignment_61025,axiom,
    ! [VarCurr: state_type] :
      ( v89461(VarCurr,6)
    <=> v89483(VarCurr,6) ) ).

tff(addAssignment_61024,axiom,
    ! [VarCurr: state_type] :
      ( v89485(VarCurr)
    <=> v100232(VarCurr) ) ).

tff(addAssignment_61023,axiom,
    ! [VarCurr: state_type] :
      ( v100232(VarCurr)
    <=> v100234(VarCurr) ) ).

tff(addAssignment_61022,axiom,
    ! [VarCurr: state_type] :
      ( v100234(VarCurr)
    <=> v100236(VarCurr) ) ).

tff(addAssignment_61021,axiom,
    ! [VarCurr: state_type] :
      ( v100236(VarCurr)
    <=> v100238(VarCurr) ) ).

tff(addAssignment_61020,axiom,
    ! [VarCurr: state_type] :
      ( v100238(VarCurr)
    <=> v3948(VarCurr,8) ) ).

tff(addAssignment_61019,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,8)
    <=> v3950(VarCurr,8) ) ).

tff(addAssignment_61018,axiom,
    ! [VarCurr: state_type] :
      ( v99914(VarCurr,6)
    <=> v99916(VarCurr,6) ) ).

tff(addAssignment_61017,axiom,
    ! [VarCurr: state_type] :
      ( v99916(VarCurr,6)
    <=> v99918(VarCurr,6) ) ).

tff(addAssignment_61016,axiom,
    ! [VarCurr: state_type] :
      ( v100225(VarCurr)
    <=> v100227(VarCurr) ) ).

tff(addAssignment_61015,axiom,
    ! [VarCurr: state_type] :
      ( v100227(VarCurr)
    <=> v87580(VarCurr) ) ).

tff(addAssignment_61014,axiom,
    ! [VarCurr: state_type] :
      ( v100221(VarCurr)
    <=> v100223(VarCurr) ) ).

tff(addAssignment_61013,axiom,
    ! [VarCurr: state_type] :
      ( v100223(VarCurr)
    <=> v87990(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9376,axiom,
    ! [VarCurr: state_type] :
      ( v97407(VarCurr)
    <=> ( v97276(VarCurr)
        & v100199(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_603,axiom,
    ! [VarCurr: state_type] :
      ( v100199(VarCurr)
    <=> ( ( v97409(VarCurr,5)
        <=> $false )
        & ( v97409(VarCurr,4)
        <=> $false )
        & ( v97409(VarCurr,3)
        <=> $false ) ) ) ).

tff(addAssignment_61012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97409(VarCurr,B)
      <=> v100196(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100196(VarCurr,B)
          <=> v100197(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_658,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100196(VarCurr,B)
          <=> v97411(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98436(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100197(VarCurr,B)
          <=> v100043(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_657,axiom,
    ! [VarCurr: state_type] :
      ( v98436(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100197(VarCurr,B)
          <=> v99888(VarCurr,B) ) ) ) ).

tff(addAssignment_61011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100043(VarCurr,B)
      <=> v100045(VarCurr,B) ) ) ).

tff(addAssignment_61010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100045(VarCurr,B)
      <=> v100047(VarCurr,B) ) ) ).

tff(addAssignment_61009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100047(VarCurr,B)
      <=> v100049(VarCurr,B) ) ) ).

tff(addAssignment_61008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100049(VarCurr,B)
      <=> v100051(VarCurr,B) ) ) ).

tff(addAssignment_61007,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100051(VarNext,B)
      <=> v100179(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100180(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100179(VarNext,B)
            <=> v100051(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1146,axiom,
    ! [VarNext: state_type] :
      ( v100180(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100179(VarNext,B)
          <=> v100190(VarNext,B) ) ) ) ).

tff(addAssignment_61006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100190(VarNext,B)
          <=> v100188(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100191(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100188(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_656,axiom,
    ! [VarCurr: state_type] :
      ( v100191(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100188(VarCurr,B)
          <=> v100061(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9375,axiom,
    ! [VarCurr: state_type] :
      ( v100191(VarCurr)
    <=> ( v100192(VarCurr)
        & v100193(VarCurr) ) ) ).

tff(writeUnaryOperator_4753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100193(VarCurr)
    <=> v100057(VarCurr) ) ).

tff(writeUnaryOperator_4752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100192(VarCurr)
    <=> v100053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100180(VarNext)
      <=> v100181(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100181(VarNext)
      <=> ( v100182(VarNext)
          & v100175(VarNext) ) ) ) ).

tff(writeUnaryOperator_4751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100182(VarNext)
      <=> v100184(VarNext) ) ) ).

tff(addAssignment_61005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100184(VarNext)
      <=> v100175(VarCurr) ) ) ).

tff(addAssignment_61004,axiom,
    ! [VarCurr: state_type] :
      ( v100175(VarCurr)
    <=> v100177(VarCurr) ) ).

tff(addAssignment_61003,axiom,
    ! [VarCurr: state_type] :
      ( v100177(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_61002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100061(VarCurr,B)
      <=> v100063(VarCurr,B) ) ) ).

tff(addAssignment_61001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100063(VarCurr,B)
      <=> v100166(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100166(VarCurr,B)
      <=> ( v100167(VarCurr,B)
          | v100170(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100170(VarCurr,B)
      <=> ( v100049(VarCurr,B)
          & v100171(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100171(VarCurr,B)
      <=> ~ v100172(VarCurr,B) ) ) ).

tff(addAssignment_61000,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,0)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60999,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,1)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60998,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,2)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60997,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,3)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60996,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,4)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60995,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,5)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60994,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,6)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60993,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,7)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60992,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,8)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60991,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,9)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60990,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,10)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60989,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,11)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60988,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,12)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60987,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,13)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60986,axiom,
    ! [VarCurr: state_type] :
      ( v100172(VarCurr,14)
    <=> v100173(VarCurr) ) ).

tff(addAssignment_60985,axiom,
    ! [VarCurr: state_type] :
      ( v100173(VarCurr)
    <=> v100160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100167(VarCurr,B)
      <=> ( v100065(VarCurr,B)
          & v100168(VarCurr,B) ) ) ) ).

tff(addAssignment_60984,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,0)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60983,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,1)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60982,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,2)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60981,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,3)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60980,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,4)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60979,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,5)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60978,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,6)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60977,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,7)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60976,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,8)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60975,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,9)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60974,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,10)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60973,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,11)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60972,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,12)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60971,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,13)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60970,axiom,
    ! [VarCurr: state_type] :
      ( v100168(VarCurr,14)
    <=> v100169(VarCurr) ) ).

tff(addAssignment_60969,axiom,
    ! [VarCurr: state_type] :
      ( v100169(VarCurr)
    <=> v100160(VarCurr) ) ).

tff(addAssignment_60968,axiom,
    ! [VarCurr: state_type] :
      ( v100160(VarCurr)
    <=> v100162(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9372,axiom,
    ! [VarCurr: state_type] :
      ( v100162(VarCurr)
    <=> ( v100164(VarCurr)
        | v98681(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9371,axiom,
    ! [VarCurr: state_type] :
      ( v100164(VarCurr)
    <=> ( v100165(VarCurr)
        & v98665(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_602,axiom,
    ! [VarCurr: state_type] :
      ( v100165(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $false )
        & ( v98643(VarCurr,1)
        <=> $false )
        & ( v98643(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_60967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100065(VarCurr,B)
      <=> v100067(VarCurr,B) ) ) ).

tff(addAssignment_60966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100067(VarCurr,B)
      <=> v100158(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98641(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100158(VarCurr,B)
          <=> v100097(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_655,axiom,
    ! [VarCurr: state_type] :
      ( v98641(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100158(VarCurr,B)
          <=> v100069(VarCurr,B) ) ) ) ).

tff(addAssignment_60965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100069(VarCurr,B)
      <=> v100071(VarCurr,B) ) ) ).

tff(addAssignment_60964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100071(VarCurr,B)
      <=> v100073(VarCurr,B) ) ) ).

tff(addAssignment_60963,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100073(VarNext,B)
      <=> v100141(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100142(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100141(VarNext,B)
            <=> v100073(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1145,axiom,
    ! [VarNext: state_type] :
      ( v100142(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100141(VarNext,B)
          <=> v100152(VarNext,B) ) ) ) ).

tff(addAssignment_60962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100152(VarNext,B)
          <=> v100150(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100153(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100150(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_654,axiom,
    ! [VarCurr: state_type] :
      ( v100153(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100150(VarCurr,B)
          <=> v100083(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9370,axiom,
    ! [VarCurr: state_type] :
      ( v100153(VarCurr)
    <=> ( v100154(VarCurr)
        & v100155(VarCurr) ) ) ).

tff(writeUnaryOperator_4749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100155(VarCurr)
    <=> v100079(VarCurr) ) ).

tff(writeUnaryOperator_4748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100154(VarCurr)
    <=> v100075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100142(VarNext)
      <=> v100143(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100143(VarNext)
      <=> ( v100144(VarNext)
          & v100137(VarNext) ) ) ) ).

tff(writeUnaryOperator_4747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100144(VarNext)
      <=> v100146(VarNext) ) ) ).

tff(addAssignment_60961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100146(VarNext)
      <=> v100137(VarCurr) ) ) ).

tff(addAssignment_60960,axiom,
    ! [VarCurr: state_type] :
      ( v100137(VarCurr)
    <=> v100139(VarCurr) ) ).

tff(addAssignment_60959,axiom,
    ! [VarCurr: state_type] :
      ( v100139(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_60958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100083(VarCurr,B)
      <=> v100085(VarCurr,B) ) ) ).

tff(addAssignment_60957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100085(VarCurr,B)
      <=> v100128(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100128(VarCurr,B)
      <=> ( v100129(VarCurr,B)
          | v100132(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100132(VarCurr,B)
      <=> ( v100071(VarCurr,B)
          & v100133(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100133(VarCurr,B)
      <=> ~ v100134(VarCurr,B) ) ) ).

tff(addAssignment_60956,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,0)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60955,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,1)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60954,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,2)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60953,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,3)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60952,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,4)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60951,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,5)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60950,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,6)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60949,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,7)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60948,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,8)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60947,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,9)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60946,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,10)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60945,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,11)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60944,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,12)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60943,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,13)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60942,axiom,
    ! [VarCurr: state_type] :
      ( v100134(VarCurr,14)
    <=> v100135(VarCurr) ) ).

tff(addAssignment_60941,axiom,
    ! [VarCurr: state_type] :
      ( v100135(VarCurr)
    <=> v100121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100129(VarCurr,B)
      <=> ( v100087(VarCurr,B)
          & v100130(VarCurr,B) ) ) ) ).

tff(addAssignment_60940,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,0)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60939,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,1)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60938,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,2)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60937,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,3)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60936,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,4)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60935,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,5)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60934,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,6)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60933,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,7)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60932,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,8)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60931,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,9)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60930,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,10)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60929,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,11)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60928,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,12)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60927,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,13)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60926,axiom,
    ! [VarCurr: state_type] :
      ( v100130(VarCurr,14)
    <=> v100131(VarCurr) ) ).

tff(addAssignment_60925,axiom,
    ! [VarCurr: state_type] :
      ( v100131(VarCurr)
    <=> v100121(VarCurr) ) ).

tff(addAssignment_60924,axiom,
    ! [VarCurr: state_type] :
      ( v100121(VarCurr)
    <=> v100123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9367,axiom,
    ! [VarCurr: state_type] :
      ( v100123(VarCurr)
    <=> ( v100125(VarCurr)
        | v100127(VarCurr) ) ) ).

tff(addAssignment_60923,axiom,
    ! [VarCurr: state_type] :
      ( v100127(VarCurr)
    <=> v98706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9366,axiom,
    ! [VarCurr: state_type] :
      ( v100125(VarCurr)
    <=> ( v100126(VarCurr)
        & v98665(VarCurr) ) ) ).

tff(writeUnaryOperator_4745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100126(VarCurr)
    <=> v98641(VarCurr,1) ) ).

tff(addAssignment_60922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100087(VarCurr,B)
      <=> v100089(VarCurr,B) ) ) ).

tff(addAssignment_60921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100089(VarCurr,B)
      <=> v100119(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98641(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100119(VarCurr,B)
          <=> v100097(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_653,axiom,
    ! [VarCurr: state_type] :
      ( v98641(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100119(VarCurr,B)
          <=> v100091(VarCurr,B) ) ) ) ).

tff(addAssignment_60920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100097(VarCurr,B)
      <=> v100115(VarCurr,B) ) ) ).

tff(addAssignment_60919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v100115(VarCurr,B)
      <=> v3918(VarCurr,B) ) ) ).

tff(addAssignment_60918,axiom,
    ! [VarCurr: state_type] :
      ( v100115(VarCurr,2)
    <=> v100118(VarCurr) ) ).

tff(addAssignment_60917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,3) )
     => ( v100115(VarCurr,B)
      <=> v3918(VarCurr,B) ) ) ).

tff(addAssignment_60916,axiom,
    ! [VarCurr: state_type] :
      ( ( v100115(VarCurr,11)
      <=> v100117(VarCurr,2) )
      & ( v100115(VarCurr,10)
      <=> v100117(VarCurr,1) )
      & ( v100115(VarCurr,9)
      <=> v100117(VarCurr,0) ) ) ).

tff(addAssignment_60915,axiom,
    ! [VarCurr: state_type] :
      ( ( v100115(VarCurr,14)
      <=> v100116(VarCurr,2) )
      & ( v100115(VarCurr,13)
      <=> v100116(VarCurr,1) )
      & ( v100115(VarCurr,12)
      <=> v100116(VarCurr,0) ) ) ).

tff(addAssignment_60914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3918(VarCurr,B)
      <=> v3920(VarCurr,B) ) ) ).

tff(addAssignment_60913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3920(VarCurr,B)
      <=> v3922(VarCurr,B) ) ) ).

tff(addAssignment_60912,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3922(VarNext,B)
      <=> v100108(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100109(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v100108(VarNext,B)
            <=> v3922(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1144,axiom,
    ! [VarNext: state_type] :
      ( v100109(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v100108(VarNext,B)
          <=> v4074(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100109(VarNext)
      <=> v100110(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100110(VarNext)
      <=> ( v100112(VarNext)
          & v4059(VarNext) ) ) ) ).

tff(writeUnaryOperator_4744,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100112(VarNext)
      <=> v4068(VarNext) ) ) ).

tff(addAssignment_60911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3932(VarCurr,B)
      <=> v3934(VarCurr,B) ) ) ).

tff(addAssignment_60910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3934(VarCurr,B)
      <=> v3936(VarCurr,B) ) ) ).

tff(addAssignment_60909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3936(VarCurr,B)
      <=> v4052(VarCurr,B) ) ) ).

tff(addAssignment_60908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4055(VarCurr,B)
      <=> v100100(VarCurr,B) ) ) ).

tff(addAssignment_60907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100100(VarCurr,B)
      <=> v100102(VarCurr,B) ) ) ).

tff(addAssignment_60906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100102(VarCurr,B)
      <=> v100104(VarCurr,B) ) ) ).

tff(addAssignment_60905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v100104(VarCurr,B)
      <=> v100106(VarCurr,B) ) ) ).

tff(addAssignment_60904,axiom,
    ! [VarCurr: state_type] :
      ( ( v100106(VarCurr,2)
      <=> v3948(VarCurr,16) )
      & ( v100106(VarCurr,1)
      <=> v3948(VarCurr,15) )
      & ( v100106(VarCurr,0)
      <=> v3948(VarCurr,14) ) ) ).

tff(addAssignment_60903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,17)
        & ~ $less(B,14) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_60902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100091(VarCurr,B)
      <=> v100093(VarCurr,B) ) ) ).

tff(addAssignment_60901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v100093(VarCurr,B)
      <=> v100095(VarCurr,B) ) ) ).

tff(addAssignment_60900,axiom,
    ! [VarCurr: state_type] :
      ( v100079(VarCurr)
    <=> v100081(VarCurr) ) ).

tff(addAssignment_60899,axiom,
    ! [VarCurr: state_type] :
      ( v100081(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_60898,axiom,
    ! [VarCurr: state_type] :
      ( v100075(VarCurr)
    <=> v100077(VarCurr) ) ).

tff(addAssignment_60897,axiom,
    ! [VarCurr: state_type] :
      ( v100077(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_60896,axiom,
    ! [VarCurr: state_type] :
      ( v100057(VarCurr)
    <=> v100059(VarCurr) ) ).

tff(addAssignment_60895,axiom,
    ! [VarCurr: state_type] :
      ( v100059(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_60894,axiom,
    ! [VarCurr: state_type] :
      ( v100053(VarCurr)
    <=> v100055(VarCurr) ) ).

tff(addAssignment_60893,axiom,
    ! [VarCurr: state_type] :
      ( v100055(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_60892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99888(VarCurr,B)
      <=> v99890(VarCurr,B) ) ) ).

tff(addAssignment_60891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99890(VarCurr,B)
      <=> v99892(VarCurr,B) ) ) ).

tff(addAssignment_60890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99892(VarCurr,B)
      <=> v99894(VarCurr,B) ) ) ).

tff(addAssignment_60889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99894(VarCurr,B)
      <=> v99896(VarCurr,B) ) ) ).

tff(addAssignment_60888,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99896(VarNext,B)
      <=> v100025(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100026(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v100025(VarNext,B)
            <=> v99896(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1143,axiom,
    ! [VarNext: state_type] :
      ( v100026(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100025(VarNext,B)
          <=> v100036(VarNext,B) ) ) ) ).

tff(addAssignment_60887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100036(VarNext,B)
          <=> v100034(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100037(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100034(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_652,axiom,
    ! [VarCurr: state_type] :
      ( v100037(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100034(VarCurr,B)
          <=> v99906(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9363,axiom,
    ! [VarCurr: state_type] :
      ( v100037(VarCurr)
    <=> ( v100038(VarCurr)
        & v100039(VarCurr) ) ) ).

tff(writeUnaryOperator_4743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100039(VarCurr)
    <=> v99902(VarCurr) ) ).

tff(writeUnaryOperator_4742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100038(VarCurr)
    <=> v99898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100026(VarNext)
      <=> v100027(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100027(VarNext)
      <=> ( v100028(VarNext)
          & v100021(VarNext) ) ) ) ).

tff(writeUnaryOperator_4741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v100028(VarNext)
      <=> v100030(VarNext) ) ) ).

tff(addAssignment_60886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v100030(VarNext)
      <=> v100021(VarCurr) ) ) ).

tff(addAssignment_60885,axiom,
    ! [VarCurr: state_type] :
      ( v100021(VarCurr)
    <=> v100023(VarCurr) ) ).

tff(addAssignment_60884,axiom,
    ! [VarCurr: state_type] :
      ( v100023(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_60883,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99906(VarCurr,B)
      <=> v99908(VarCurr,B) ) ) ).

tff(addAssignment_60882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99908(VarCurr,B)
      <=> v100012(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100012(VarCurr,B)
      <=> ( v100013(VarCurr,B)
          | v100016(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100016(VarCurr,B)
      <=> ( v99894(VarCurr,B)
          & v100017(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100017(VarCurr,B)
      <=> ~ v100018(VarCurr,B) ) ) ).

tff(addAssignment_60881,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,0)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60880,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,1)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60879,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,2)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60878,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,3)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60877,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,4)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60876,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,5)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60875,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,6)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60874,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,7)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60873,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,8)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60872,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,9)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60871,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,10)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60870,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,11)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60869,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,12)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60868,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,13)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60867,axiom,
    ! [VarCurr: state_type] :
      ( v100018(VarCurr,14)
    <=> v100019(VarCurr) ) ).

tff(addAssignment_60866,axiom,
    ! [VarCurr: state_type] :
      ( v100019(VarCurr)
    <=> v100006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v100013(VarCurr,B)
      <=> ( v99910(VarCurr,B)
          & v100014(VarCurr,B) ) ) ) ).

tff(addAssignment_60865,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,0)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60864,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,1)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60863,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,2)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60862,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,3)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60861,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,4)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60860,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,5)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60859,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,6)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60858,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,7)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60857,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,8)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60856,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,9)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60855,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,10)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60854,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,11)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60853,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,12)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60852,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,13)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60851,axiom,
    ! [VarCurr: state_type] :
      ( v100014(VarCurr,14)
    <=> v100015(VarCurr) ) ).

tff(addAssignment_60850,axiom,
    ! [VarCurr: state_type] :
      ( v100015(VarCurr)
    <=> v100006(VarCurr) ) ).

tff(addAssignment_60849,axiom,
    ! [VarCurr: state_type] :
      ( v100006(VarCurr)
    <=> v100008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9360,axiom,
    ! [VarCurr: state_type] :
      ( v100008(VarCurr)
    <=> ( v100010(VarCurr)
        | v99272(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9359,axiom,
    ! [VarCurr: state_type] :
      ( v100010(VarCurr)
    <=> ( v100011(VarCurr)
        & v99256(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_601,axiom,
    ! [VarCurr: state_type] :
      ( v100011(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $false )
        & ( v99234(VarCurr,1)
        <=> $false )
        & ( v99234(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_60848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99910(VarCurr,B)
      <=> v99912(VarCurr,B) ) ) ).

tff(addAssignment_60847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99912(VarCurr,B)
      <=> v100004(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99232(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100004(VarCurr,B)
          <=> v99942(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_651,axiom,
    ! [VarCurr: state_type] :
      ( v99232(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v100004(VarCurr,B)
          <=> v99914(VarCurr,B) ) ) ) ).

tff(addAssignment_60846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99914(VarCurr,B)
      <=> v99916(VarCurr,B) ) ) ).

tff(addAssignment_60845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99916(VarCurr,B)
      <=> v99918(VarCurr,B) ) ) ).

tff(addAssignment_60844,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99918(VarNext,B)
      <=> v99987(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99988(VarNext)
       => ! [B: $int] :
            ( ( $less(B,15)
              & ~ $less(B,0) )
           => ( v99987(VarNext,B)
            <=> v99918(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1142,axiom,
    ! [VarNext: state_type] :
      ( v99988(VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99987(VarNext,B)
          <=> v99998(VarNext,B) ) ) ) ).

tff(addAssignment_60843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99998(VarNext,B)
          <=> v99996(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99999(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99996(VarCurr,B)
          <=> bxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_650,axiom,
    ! [VarCurr: state_type] :
      ( v99999(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99996(VarCurr,B)
          <=> v99928(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9358,axiom,
    ! [VarCurr: state_type] :
      ( v99999(VarCurr)
    <=> ( v100000(VarCurr)
        & v100001(VarCurr) ) ) ).

tff(writeUnaryOperator_4739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100001(VarCurr)
    <=> v99924(VarCurr) ) ).

tff(writeUnaryOperator_4738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v100000(VarCurr)
    <=> v99920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99988(VarNext)
      <=> v99989(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99989(VarNext)
      <=> ( v99990(VarNext)
          & v99983(VarNext) ) ) ) ).

tff(writeUnaryOperator_4737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99990(VarNext)
      <=> v99992(VarNext) ) ) ).

tff(addAssignment_60842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99992(VarNext)
      <=> v99983(VarCurr) ) ) ).

tff(addAssignment_60841,axiom,
    ! [VarCurr: state_type] :
      ( v99983(VarCurr)
    <=> v99985(VarCurr) ) ).

tff(addAssignment_60840,axiom,
    ! [VarCurr: state_type] :
      ( v99985(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_60839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99928(VarCurr,B)
      <=> v99930(VarCurr,B) ) ) ).

tff(addAssignment_60838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99930(VarCurr,B)
      <=> v99973(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v99973(VarCurr,B)
      <=> ( v99974(VarCurr,B)
          | v99977(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v99977(VarCurr,B)
      <=> ( v99916(VarCurr,B)
          & v99978(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v99978(VarCurr,B)
      <=> ~ v99979(VarCurr,B) ) ) ).

tff(addAssignment_60837,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,0)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60836,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,1)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60835,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,2)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60834,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,3)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60833,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,4)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60832,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,5)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60831,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,6)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60830,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,7)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60829,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,8)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60828,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,9)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60827,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,10)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60826,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,11)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60825,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,12)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60824,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,13)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60823,axiom,
    ! [VarCurr: state_type] :
      ( v99979(VarCurr,14)
    <=> v99980(VarCurr) ) ).

tff(addAssignment_60822,axiom,
    ! [VarCurr: state_type] :
      ( v99980(VarCurr)
    <=> v99966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v99974(VarCurr,B)
      <=> ( v99932(VarCurr,B)
          & v99975(VarCurr,B) ) ) ) ).

tff(addAssignment_60821,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,0)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60820,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,1)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60819,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,2)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60818,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,3)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60817,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,4)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60816,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,5)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60815,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,6)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60814,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,7)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60813,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,8)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60812,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,9)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60811,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,10)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60810,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,11)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60809,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,12)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60808,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,13)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60807,axiom,
    ! [VarCurr: state_type] :
      ( v99975(VarCurr,14)
    <=> v99976(VarCurr) ) ).

tff(addAssignment_60806,axiom,
    ! [VarCurr: state_type] :
      ( v99976(VarCurr)
    <=> v99966(VarCurr) ) ).

tff(addAssignment_60805,axiom,
    ! [VarCurr: state_type] :
      ( v99966(VarCurr)
    <=> v99968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9355,axiom,
    ! [VarCurr: state_type] :
      ( v99968(VarCurr)
    <=> ( v99970(VarCurr)
        | v99972(VarCurr) ) ) ).

tff(addAssignment_60804,axiom,
    ! [VarCurr: state_type] :
      ( v99972(VarCurr)
    <=> v99296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9354,axiom,
    ! [VarCurr: state_type] :
      ( v99970(VarCurr)
    <=> ( v99971(VarCurr)
        & v99256(VarCurr) ) ) ).

tff(writeUnaryOperator_4735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99971(VarCurr)
    <=> v99232(VarCurr,1) ) ).

tff(addAssignment_60803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99932(VarCurr,B)
      <=> v99934(VarCurr,B) ) ) ).

tff(addAssignment_60802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99934(VarCurr,B)
      <=> v99964(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99232(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99964(VarCurr,B)
          <=> v99942(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_649,axiom,
    ! [VarCurr: state_type] :
      ( v99232(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,15)
            & ~ $less(B,0) )
         => ( v99964(VarCurr,B)
          <=> v99936(VarCurr,B) ) ) ) ).

tff(addAssignment_60801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99942(VarCurr,B)
      <=> v99960(VarCurr,B) ) ) ).

tff(addAssignment_60800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99960(VarCurr,B)
      <=> v89443(VarCurr,B) ) ) ).

tff(addAssignment_60799,axiom,
    ! [VarCurr: state_type] :
      ( v99960(VarCurr,2)
    <=> v99963(VarCurr) ) ).

tff(addAssignment_60798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,3) )
     => ( v99960(VarCurr,B)
      <=> v89443(VarCurr,B) ) ) ).

tff(addAssignment_60797,axiom,
    ! [VarCurr: state_type] :
      ( ( v99960(VarCurr,11)
      <=> v99962(VarCurr,2) )
      & ( v99960(VarCurr,10)
      <=> v99962(VarCurr,1) )
      & ( v99960(VarCurr,9)
      <=> v99962(VarCurr,0) ) ) ).

tff(addAssignment_60796,axiom,
    ! [VarCurr: state_type] :
      ( ( v99960(VarCurr,14)
      <=> v99961(VarCurr,2) )
      & ( v99960(VarCurr,13)
      <=> v99961(VarCurr,1) )
      & ( v99960(VarCurr,12)
      <=> v99961(VarCurr,0) ) ) ).

tff(addAssignment_60795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89443(VarCurr,B)
      <=> v89445(VarCurr,B) ) ) ).

tff(addAssignment_60794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89445(VarCurr,B)
      <=> v89447(VarCurr,B) ) ) ).

tff(addAssignment_60793,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89447(VarNext,B)
      <=> v99953(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99954(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v99953(VarNext,B)
            <=> v89447(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1141,axiom,
    ! [VarNext: state_type] :
      ( v99954(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v99953(VarNext,B)
          <=> v89504(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99954(VarNext)
      <=> v99955(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99955(VarNext)
      <=> ( v99957(VarNext)
          & v89489(VarNext) ) ) ) ).

tff(writeUnaryOperator_4734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99957(VarNext)
      <=> v89498(VarNext) ) ) ).

tff(addAssignment_60792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89457(VarCurr,B)
      <=> v89459(VarCurr,B) ) ) ).

tff(addAssignment_60791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89459(VarCurr,B)
      <=> v89461(VarCurr,B) ) ) ).

tff(addAssignment_60790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89461(VarCurr,B)
      <=> v89483(VarCurr,B) ) ) ).

tff(addAssignment_60789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89486(VarCurr,B)
      <=> v99945(VarCurr,B) ) ) ).

tff(addAssignment_60788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99945(VarCurr,B)
      <=> v99947(VarCurr,B) ) ) ).

tff(addAssignment_60787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99947(VarCurr,B)
      <=> v99949(VarCurr,B) ) ) ).

tff(addAssignment_60786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99949(VarCurr,B)
      <=> v99951(VarCurr,B) ) ) ).

tff(addAssignment_60785,axiom,
    ! [VarCurr: state_type] :
      ( ( v99951(VarCurr,2)
      <=> v3948(VarCurr,7) )
      & ( v99951(VarCurr,1)
      <=> v3948(VarCurr,6) )
      & ( v99951(VarCurr,0)
      <=> v3948(VarCurr,5) ) ) ).

tff(addAssignment_60784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,5) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_60783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99936(VarCurr,B)
      <=> v99938(VarCurr,B) ) ) ).

tff(addAssignment_60782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v99938(VarCurr,B)
      <=> v99940(VarCurr,B) ) ) ).

tff(addAssignment_60781,axiom,
    ! [VarCurr: state_type] :
      ( v99924(VarCurr)
    <=> v99926(VarCurr) ) ).

tff(addAssignment_60780,axiom,
    ! [VarCurr: state_type] :
      ( v99926(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_60779,axiom,
    ! [VarCurr: state_type] :
      ( v99920(VarCurr)
    <=> v99922(VarCurr) ) ).

tff(addAssignment_60778,axiom,
    ! [VarCurr: state_type] :
      ( v99922(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_60777,axiom,
    ! [VarCurr: state_type] :
      ( v99902(VarCurr)
    <=> v99904(VarCurr) ) ).

tff(addAssignment_60776,axiom,
    ! [VarCurr: state_type] :
      ( v99904(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_60775,axiom,
    ! [VarCurr: state_type] :
      ( v99898(VarCurr)
    <=> v99900(VarCurr) ) ).

tff(addAssignment_60774,axiom,
    ! [VarCurr: state_type] :
      ( v99900(VarCurr)
    <=> v146(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98438(VarCurr)
     => ( v98436(VarCurr)
      <=> v99835(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_648,axiom,
    ! [VarCurr: state_type] :
      ( v98438(VarCurr)
     => ( v98436(VarCurr)
      <=> v98442(VarCurr) ) ) ).

tff(addAssignment_60773,axiom,
    ! [VarCurr: state_type] :
      ( v99835(VarCurr)
    <=> v99837(VarCurr) ) ).

tff(addAssignment_60772,axiom,
    ! [VarCurr: state_type] :
      ( v99837(VarCurr)
    <=> v99839(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99870(VarNext)
       => ( v99839(VarNext)
        <=> v99839(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1140,axiom,
    ! [VarNext: state_type] :
      ( v99870(VarNext)
     => ( v99839(VarNext)
      <=> v99880(VarNext) ) ) ).

tff(addAssignment_60771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99880(VarNext)
      <=> v99878(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99881(VarCurr)
     => ( v99878(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_647,axiom,
    ! [VarCurr: state_type] :
      ( v99881(VarCurr)
     => ( v99878(VarCurr)
      <=> v99849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9351,axiom,
    ! [VarCurr: state_type] :
      ( v99881(VarCurr)
    <=> ( v99882(VarCurr)
        & v99883(VarCurr) ) ) ).

tff(writeUnaryOperator_4733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99883(VarCurr)
    <=> v99845(VarCurr) ) ).

tff(writeUnaryOperator_4732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99882(VarCurr)
    <=> v99841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99870(VarNext)
      <=> v99871(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99871(VarNext)
      <=> ( v99872(VarNext)
          & v99865(VarNext) ) ) ) ).

tff(writeUnaryOperator_4731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99872(VarNext)
      <=> v99874(VarNext) ) ) ).

tff(addAssignment_60770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99874(VarNext)
      <=> v99865(VarCurr) ) ) ).

tff(addAssignment_60769,axiom,
    ! [VarCurr: state_type] :
      ( v99865(VarCurr)
    <=> v99867(VarCurr) ) ).

tff(addAssignment_60768,axiom,
    ! [VarCurr: state_type] :
      ( v99867(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_60767,axiom,
    ! [VarCurr: state_type] :
      ( v99849(VarCurr)
    <=> v99851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9348,axiom,
    ! [VarCurr: state_type] :
      ( v99851(VarCurr)
    <=> ( v99857(VarCurr)
        | v99860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9347,axiom,
    ! [VarCurr: state_type] :
      ( v99860(VarCurr)
    <=> ( v99837(VarCurr)
        & v99861(VarCurr) ) ) ).

tff(writeUnaryOperator_4730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99861(VarCurr)
    <=> v99862(VarCurr) ) ).

tff(addAssignment_60766,axiom,
    ! [VarCurr: state_type] :
      ( v99862(VarCurr)
    <=> v99863(VarCurr) ) ).

tff(addAssignment_60765,axiom,
    ! [VarCurr: state_type] :
      ( v99863(VarCurr)
    <=> v99855(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9346,axiom,
    ! [VarCurr: state_type] :
      ( v99857(VarCurr)
    <=> ( v99853(VarCurr)
        & v99858(VarCurr) ) ) ).

tff(addAssignment_60764,axiom,
    ! [VarCurr: state_type] :
      ( v99858(VarCurr)
    <=> v99859(VarCurr) ) ).

tff(addAssignment_60763,axiom,
    ! [VarCurr: state_type] :
      ( v99859(VarCurr)
    <=> v99855(VarCurr) ) ).

tff(addAssignment_60762,axiom,
    ! [VarCurr: state_type] :
      ( v99855(VarCurr)
    <=> v98438(VarCurr) ) ).

tff(addAssignment_60761,axiom,
    ! [VarCurr: state_type] :
      ( v99853(VarCurr)
    <=> v98442(VarCurr) ) ).

tff(addAssignment_60760,axiom,
    ! [VarCurr: state_type] :
      ( v99845(VarCurr)
    <=> v99847(VarCurr) ) ).

tff(addAssignment_60759,axiom,
    ! [VarCurr: state_type] :
      ( v99847(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_60758,axiom,
    ! [VarCurr: state_type] :
      ( v99841(VarCurr)
    <=> v99843(VarCurr) ) ).

tff(addAssignment_60757,axiom,
    ! [VarCurr: state_type] :
      ( v99843(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9345,axiom,
    ! [VarCurr: state_type] :
      ( v98442(VarCurr)
    <=> ( v99816(VarCurr)
        & v99826(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3878,axiom,
    ! [VarCurr: state_type] :
      ( v99826(VarCurr)
    <=> ( v99828(VarCurr)
        | v99226(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3877,axiom,
    ! [VarCurr: state_type] :
      ( v99828(VarCurr)
    <=> ( v99829(VarCurr)
        | v99226(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3876,axiom,
    ! [VarCurr: state_type] :
      ( v99829(VarCurr)
    <=> ( v99830(VarCurr)
        | v99226(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3875,axiom,
    ! [VarCurr: state_type] :
      ( v99830(VarCurr)
    <=> ( v99831(VarCurr)
        | v99226(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3874,axiom,
    ! [VarCurr: state_type] :
      ( v99831(VarCurr)
    <=> ( v99832(VarCurr)
        | v99226(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3873,axiom,
    ! [VarCurr: state_type] :
      ( v99832(VarCurr)
    <=> ( v99833(VarCurr)
        | v99226(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3872,axiom,
    ! [VarCurr: state_type] :
      ( v99833(VarCurr)
    <=> ( v99226(VarCurr,0)
        | v99226(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9344,axiom,
    ! [VarCurr: state_type] :
      ( v99816(VarCurr)
    <=> ( v98444(VarCurr)
        | v99817(VarCurr) ) ) ).

tff(writeUnaryOperator_4729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99817(VarCurr)
    <=> v99818(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3871,axiom,
    ! [VarCurr: state_type] :
      ( v99818(VarCurr)
    <=> ( v99820(VarCurr)
        | v98635(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3870,axiom,
    ! [VarCurr: state_type] :
      ( v99820(VarCurr)
    <=> ( v99821(VarCurr)
        | v98635(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3869,axiom,
    ! [VarCurr: state_type] :
      ( v99821(VarCurr)
    <=> ( v99822(VarCurr)
        | v98635(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3868,axiom,
    ! [VarCurr: state_type] :
      ( v99822(VarCurr)
    <=> ( v99823(VarCurr)
        | v98635(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3867,axiom,
    ! [VarCurr: state_type] :
      ( v99823(VarCurr)
    <=> ( v99824(VarCurr)
        | v98635(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3866,axiom,
    ! [VarCurr: state_type] :
      ( v99824(VarCurr)
    <=> ( v99825(VarCurr)
        | v98635(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3865,axiom,
    ! [VarCurr: state_type] :
      ( v99825(VarCurr)
    <=> ( v98635(VarCurr,0)
        | v98635(VarCurr,1) ) ) ).

tff(addAssignment_60756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99226(VarCurr,B)
      <=> v99228(VarCurr,B) ) ) ).

tff(addAssignment_60755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99228(VarCurr,B)
      <=> v99230(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99230(VarCurr,B)
      <=> ( v99232(VarCurr,B)
          & v99773(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99773(VarCurr,B)
      <=> ( v99774(VarCurr,B)
          | v99812(VarCurr,B) ) ) ) ).

tff(addAssignment_60754,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,0)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60753,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,1)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60752,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,2)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60751,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,3)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60750,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,4)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60749,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,5)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60748,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,6)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60747,axiom,
    ! [VarCurr: state_type] :
      ( v99812(VarCurr,7)
    <=> v99813(VarCurr) ) ).

tff(addAssignment_60746,axiom,
    ! [VarCurr: state_type] :
      ( v99813(VarCurr)
    <=> v99814(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_600,axiom,
    ! [VarCurr: state_type] :
      ( v99814(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $true )
        & ( v99402(VarCurr,2)
        <=> $false )
        & ( v99402(VarCurr,1)
        <=> $false )
        & ( v99402(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99774(VarCurr,B)
      <=> ( v99775(VarCurr,B)
          | v99808(VarCurr,B) ) ) ) ).

tff(addAssignment_60745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99808(VarCurr,B)
      <=> v99809(VarCurr,B) ) ) ).

tff(addAssignment_60744,axiom,
    ! [VarCurr: state_type] :
      ( v99808(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_60743,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,0)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60742,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,1)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60741,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,2)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60740,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,3)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60739,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,4)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60738,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,5)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60737,axiom,
    ! [VarCurr: state_type] :
      ( v99809(VarCurr,6)
    <=> v99810(VarCurr) ) ).

tff(addAssignment_60736,axiom,
    ! [VarCurr: state_type] :
      ( v99810(VarCurr)
    <=> v99811(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_599,axiom,
    ! [VarCurr: state_type] :
      ( v99811(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $true )
        & ( v99402(VarCurr,1)
        <=> $true )
        & ( v99402(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_38,axiom,
    ! [VarCurr: state_type] : ~ v99775(VarCurr,7) ).

tff(addAssignment_60735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99775(VarCurr,B)
      <=> v99776(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99776(VarCurr,B)
      <=> ( v99777(VarCurr,B)
          | v99804(VarCurr,B) ) ) ) ).

tff(addAssignment_60734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99804(VarCurr,B)
      <=> v99805(VarCurr,B) ) ) ).

tff(addAssignment_60733,axiom,
    ! [VarCurr: state_type] :
      ( v99804(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_60732,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,0)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60731,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,1)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60730,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,2)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60729,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,3)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60728,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,4)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60727,axiom,
    ! [VarCurr: state_type] :
      ( v99805(VarCurr,5)
    <=> v99806(VarCurr) ) ).

tff(addAssignment_60726,axiom,
    ! [VarCurr: state_type] :
      ( v99806(VarCurr)
    <=> v99807(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_598,axiom,
    ! [VarCurr: state_type] :
      ( v99807(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $true )
        & ( v99402(VarCurr,1)
        <=> $true )
        & ( v99402(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_37,axiom,
    ! [VarCurr: state_type] : ~ v99777(VarCurr,6) ).

tff(addAssignment_60725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99777(VarCurr,B)
      <=> v99778(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99778(VarCurr,B)
      <=> ( v99779(VarCurr,B)
          | v99800(VarCurr,B) ) ) ) ).

tff(addAssignment_60724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99800(VarCurr,B)
      <=> v99801(VarCurr,B) ) ) ).

tff(addAssignment_60723,axiom,
    ! [VarCurr: state_type] :
      ( v99800(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_60722,axiom,
    ! [VarCurr: state_type] :
      ( v99801(VarCurr,0)
    <=> v99802(VarCurr) ) ).

tff(addAssignment_60721,axiom,
    ! [VarCurr: state_type] :
      ( v99801(VarCurr,1)
    <=> v99802(VarCurr) ) ).

tff(addAssignment_60720,axiom,
    ! [VarCurr: state_type] :
      ( v99801(VarCurr,2)
    <=> v99802(VarCurr) ) ).

tff(addAssignment_60719,axiom,
    ! [VarCurr: state_type] :
      ( v99801(VarCurr,3)
    <=> v99802(VarCurr) ) ).

tff(addAssignment_60718,axiom,
    ! [VarCurr: state_type] :
      ( v99801(VarCurr,4)
    <=> v99802(VarCurr) ) ).

tff(addAssignment_60717,axiom,
    ! [VarCurr: state_type] :
      ( v99802(VarCurr)
    <=> v99803(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_597,axiom,
    ! [VarCurr: state_type] :
      ( v99803(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $true )
        & ( v99402(VarCurr,1)
        <=> $false )
        & ( v99402(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_36,axiom,
    ! [VarCurr: state_type] : ~ v99779(VarCurr,5) ).

tff(addAssignment_60716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99779(VarCurr,B)
      <=> v99780(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99780(VarCurr,B)
      <=> ( v99781(VarCurr,B)
          | v99796(VarCurr,B) ) ) ) ).

tff(addAssignment_60715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99796(VarCurr,B)
      <=> v99797(VarCurr,B) ) ) ).

tff(addAssignment_60714,axiom,
    ! [VarCurr: state_type] :
      ( v99796(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_60713,axiom,
    ! [VarCurr: state_type] :
      ( v99797(VarCurr,0)
    <=> v99798(VarCurr) ) ).

tff(addAssignment_60712,axiom,
    ! [VarCurr: state_type] :
      ( v99797(VarCurr,1)
    <=> v99798(VarCurr) ) ).

tff(addAssignment_60711,axiom,
    ! [VarCurr: state_type] :
      ( v99797(VarCurr,2)
    <=> v99798(VarCurr) ) ).

tff(addAssignment_60710,axiom,
    ! [VarCurr: state_type] :
      ( v99797(VarCurr,3)
    <=> v99798(VarCurr) ) ).

tff(addAssignment_60709,axiom,
    ! [VarCurr: state_type] :
      ( v99798(VarCurr)
    <=> v99799(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_596,axiom,
    ! [VarCurr: state_type] :
      ( v99799(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $true )
        & ( v99402(VarCurr,1)
        <=> $false )
        & ( v99402(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_35,axiom,
    ! [VarCurr: state_type] : ~ v99781(VarCurr,4) ).

tff(addAssignment_60708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99781(VarCurr,B)
      <=> v99782(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99782(VarCurr,B)
      <=> ( v99783(VarCurr,B)
          | v99792(VarCurr,B) ) ) ) ).

tff(addAssignment_60707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99792(VarCurr,B)
      <=> v99793(VarCurr,B) ) ) ).

tff(addAssignment_60706,axiom,
    ! [VarCurr: state_type] :
      ( v99792(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_60705,axiom,
    ! [VarCurr: state_type] :
      ( v99793(VarCurr,0)
    <=> v99794(VarCurr) ) ).

tff(addAssignment_60704,axiom,
    ! [VarCurr: state_type] :
      ( v99793(VarCurr,1)
    <=> v99794(VarCurr) ) ).

tff(addAssignment_60703,axiom,
    ! [VarCurr: state_type] :
      ( v99793(VarCurr,2)
    <=> v99794(VarCurr) ) ).

tff(addAssignment_60702,axiom,
    ! [VarCurr: state_type] :
      ( v99794(VarCurr)
    <=> v99795(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_595,axiom,
    ! [VarCurr: state_type] :
      ( v99795(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $false )
        & ( v99402(VarCurr,1)
        <=> $true )
        & ( v99402(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_34,axiom,
    ! [VarCurr: state_type] : ~ v99783(VarCurr,3) ).

tff(addAssignment_60701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99783(VarCurr,B)
      <=> v99784(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99784(VarCurr,B)
      <=> ( v99785(VarCurr,B)
          | v99788(VarCurr,B) ) ) ) ).

tff(addAssignment_60700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99788(VarCurr,B)
      <=> v99789(VarCurr,B) ) ) ).

tff(addAssignment_60699,axiom,
    ! [VarCurr: state_type] :
      ( v99788(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_60698,axiom,
    ! [VarCurr: state_type] :
      ( v99789(VarCurr,0)
    <=> v99790(VarCurr) ) ).

tff(addAssignment_60697,axiom,
    ! [VarCurr: state_type] :
      ( v99789(VarCurr,1)
    <=> v99790(VarCurr) ) ).

tff(addAssignment_60696,axiom,
    ! [VarCurr: state_type] :
      ( v99790(VarCurr)
    <=> v99791(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_594,axiom,
    ! [VarCurr: state_type] :
      ( v99791(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $false )
        & ( v99402(VarCurr,1)
        <=> $true )
        & ( v99402(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_33,axiom,
    ! [VarCurr: state_type] : ~ v99785(VarCurr,2) ).

tff(addAssignment_60695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99785(VarCurr,B)
      <=> v99786(VarCurr,B) ) ) ).

tff(addAssignment_60694,axiom,
    ! [VarCurr: state_type] :
      ( v99786(VarCurr,0)
    <=> v99787(VarCurr) ) ).

tff(addAssignment_60693,axiom,
    ! [VarCurr: state_type] :
      ( v99786(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_593,axiom,
    ! [VarCurr: state_type] :
      ( v99787(VarCurr)
    <=> ( ( v99402(VarCurr,3)
        <=> $false )
        & ( v99402(VarCurr,2)
        <=> $false )
        & ( v99402(VarCurr,1)
        <=> $false )
        & ( v99402(VarCurr,0)
        <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99628(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99402(VarCurr,B)
          <=> v99705(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_646,axiom,
    ! [VarCurr: state_type] :
      ( v99628(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99402(VarCurr,B)
          <=> v99656(VarCurr,B) ) ) ) ).

tff(addAssignment_60692,axiom,
    ! [VarCurr: state_type] :
      ( v99705(VarCurr,0)
    <=> v99769(VarCurr) ) ).

tff(addAssignment_60691,axiom,
    ! [VarCurr: state_type] :
      ( v99705(VarCurr,1)
    <=> v99767(VarCurr) ) ).

tff(addAssignment_60690,axiom,
    ! [VarCurr: state_type] :
      ( v99705(VarCurr,2)
    <=> v99762(VarCurr) ) ).

tff(addAssignment_60689,axiom,
    ! [VarCurr: state_type] :
      ( v99705(VarCurr,3)
    <=> v99707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9343,axiom,
    ! [VarCurr: state_type] :
      ( v99767(VarCurr)
    <=> ( v99768(VarCurr)
        & v99771(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3864,axiom,
    ! [VarCurr: state_type] :
      ( v99771(VarCurr)
    <=> ( v99712(VarCurr,0)
        | v99712(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9342,axiom,
    ! [VarCurr: state_type] :
      ( v99768(VarCurr)
    <=> ( v99769(VarCurr)
        | v99770(VarCurr) ) ) ).

tff(writeUnaryOperator_4728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99770(VarCurr)
    <=> v99712(VarCurr,1) ) ).

tff(writeUnaryOperator_4727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99769(VarCurr)
    <=> v99712(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9341,axiom,
    ! [VarCurr: state_type] :
      ( v99762(VarCurr)
    <=> ( v99763(VarCurr)
        & v99766(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3863,axiom,
    ! [VarCurr: state_type] :
      ( v99766(VarCurr)
    <=> ( v99711(VarCurr)
        | v99712(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9340,axiom,
    ! [VarCurr: state_type] :
      ( v99763(VarCurr)
    <=> ( v99764(VarCurr)
        | v99765(VarCurr) ) ) ).

tff(writeUnaryOperator_4726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99765(VarCurr)
    <=> v99712(VarCurr,2) ) ).

tff(writeUnaryOperator_4725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99764(VarCurr)
    <=> v99711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9339,axiom,
    ! [VarCurr: state_type] :
      ( v99707(VarCurr)
    <=> ( v99708(VarCurr)
        & v99761(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3862,axiom,
    ! [VarCurr: state_type] :
      ( v99761(VarCurr)
    <=> ( v99710(VarCurr)
        | v99712(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9338,axiom,
    ! [VarCurr: state_type] :
      ( v99708(VarCurr)
    <=> ( v99709(VarCurr)
        | v99760(VarCurr) ) ) ).

tff(writeUnaryOperator_4724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99760(VarCurr)
    <=> v99712(VarCurr,3) ) ).

tff(writeUnaryOperator_4723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99709(VarCurr)
    <=> v99710(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3861,axiom,
    ! [VarCurr: state_type] :
      ( v99710(VarCurr)
    <=> ( v99711(VarCurr)
        & v99712(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3860,axiom,
    ! [VarCurr: state_type] :
      ( v99711(VarCurr)
    <=> ( v99712(VarCurr,0)
        & v99712(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99712(VarCurr,B)
      <=> ~ v99713(VarCurr,B) ) ) ).

tff(addAssignment_60688,axiom,
    ! [VarCurr: state_type] :
      ( v99713(VarCurr,0)
    <=> v99702(VarCurr) ) ).

tff(addAssignment_60687,axiom,
    ! [VarCurr: state_type] :
      ( v99713(VarCurr,1)
    <=> v99756(VarCurr) ) ).

tff(addAssignment_60686,axiom,
    ! [VarCurr: state_type] :
      ( v99713(VarCurr,2)
    <=> v99751(VarCurr) ) ).

tff(addAssignment_60685,axiom,
    ! [VarCurr: state_type] :
      ( v99713(VarCurr,3)
    <=> v99715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9337,axiom,
    ! [VarCurr: state_type] :
      ( v99756(VarCurr)
    <=> ( v99757(VarCurr)
        & v99759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9336,axiom,
    ! [VarCurr: state_type] :
      ( v99759(VarCurr)
    <=> ( v99665(VarCurr)
        | v99722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9335,axiom,
    ! [VarCurr: state_type] :
      ( v99757(VarCurr)
    <=> ( v99699(VarCurr)
        | v99758(VarCurr) ) ) ).

tff(writeUnaryOperator_4721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99758(VarCurr)
    <=> v99722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9334,axiom,
    ! [VarCurr: state_type] :
      ( v99751(VarCurr)
    <=> ( v99752(VarCurr)
        & v99755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9333,axiom,
    ! [VarCurr: state_type] :
      ( v99755(VarCurr)
    <=> ( v99720(VarCurr)
        | v99730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9332,axiom,
    ! [VarCurr: state_type] :
      ( v99752(VarCurr)
    <=> ( v99753(VarCurr)
        | v99754(VarCurr) ) ) ).

tff(writeUnaryOperator_4720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99754(VarCurr)
    <=> v99730(VarCurr) ) ).

tff(writeUnaryOperator_4719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99753(VarCurr)
    <=> v99720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9331,axiom,
    ! [VarCurr: state_type] :
      ( v99715(VarCurr)
    <=> ( v99716(VarCurr)
        & v99750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9330,axiom,
    ! [VarCurr: state_type] :
      ( v99750(VarCurr)
    <=> ( v99718(VarCurr)
        | v99741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9329,axiom,
    ! [VarCurr: state_type] :
      ( v99716(VarCurr)
    <=> ( v99717(VarCurr)
        | v99740(VarCurr) ) ) ).

tff(writeUnaryOperator_4718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99740(VarCurr)
    <=> v99741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9328,axiom,
    ! [VarCurr: state_type] :
      ( v99741(VarCurr)
    <=> ( v99742(VarCurr)
        & v99749(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3859,axiom,
    ! [VarCurr: state_type] :
      ( v99749(VarCurr)
    <=> ( v99552(VarCurr,3)
        | v99744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9327,axiom,
    ! [VarCurr: state_type] :
      ( v99742(VarCurr)
    <=> ( v99580(VarCurr)
        | v99743(VarCurr) ) ) ).

tff(writeUnaryOperator_4717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99743(VarCurr)
    <=> v99744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9326,axiom,
    ! [VarCurr: state_type] :
      ( v99744(VarCurr)
    <=> ( v99745(VarCurr)
        & v99748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9325,axiom,
    ! [VarCurr: state_type] :
      ( v99748(VarCurr)
    <=> ( v99653(VarCurr)
        | v99747(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3858,axiom,
    ! [VarCurr: state_type] :
      ( v99745(VarCurr)
    <=> ( v99404(VarCurr,3)
        | v99746(VarCurr) ) ) ).

tff(writeUnaryOperator_4716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99746(VarCurr)
    <=> v99747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9324,axiom,
    ! [VarCurr: state_type] :
      ( v99747(VarCurr)
    <=> ( v99647(VarCurr)
        & v99736(VarCurr) ) ) ).

tff(writeUnaryOperator_4715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99717(VarCurr)
    <=> v99718(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9323,axiom,
    ! [VarCurr: state_type] :
      ( v99718(VarCurr)
    <=> ( v99719(VarCurr)
        | v99739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3857,axiom,
    ! [VarCurr: state_type] :
      ( v99739(VarCurr)
    <=> ( v99552(VarCurr,2)
        & v99733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9322,axiom,
    ! [VarCurr: state_type] :
      ( v99719(VarCurr)
    <=> ( v99720(VarCurr)
        & v99730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9321,axiom,
    ! [VarCurr: state_type] :
      ( v99730(VarCurr)
    <=> ( v99731(VarCurr)
        & v99738(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3856,axiom,
    ! [VarCurr: state_type] :
      ( v99738(VarCurr)
    <=> ( v99552(VarCurr,2)
        | v99733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9320,axiom,
    ! [VarCurr: state_type] :
      ( v99731(VarCurr)
    <=> ( v99585(VarCurr)
        | v99732(VarCurr) ) ) ).

tff(writeUnaryOperator_4714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99732(VarCurr)
    <=> v99733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9319,axiom,
    ! [VarCurr: state_type] :
      ( v99733(VarCurr)
    <=> ( v99734(VarCurr)
        & v99737(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9318,axiom,
    ! [VarCurr: state_type] :
      ( v99737(VarCurr)
    <=> ( v99647(VarCurr)
        | v99736(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3855,axiom,
    ! [VarCurr: state_type] :
      ( v99734(VarCurr)
    <=> ( v99404(VarCurr,2)
        | v99735(VarCurr) ) ) ).

tff(writeUnaryOperator_4713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99735(VarCurr)
    <=> v99736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9317,axiom,
    ! [VarCurr: state_type] :
      ( v99736(VarCurr)
    <=> ( v99637(VarCurr)
        & v99641(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9316,axiom,
    ! [VarCurr: state_type] :
      ( v99720(VarCurr)
    <=> ( v99721(VarCurr)
        | v99729(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3854,axiom,
    ! [VarCurr: state_type] :
      ( v99729(VarCurr)
    <=> ( v99552(VarCurr,1)
        & v99725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9315,axiom,
    ! [VarCurr: state_type] :
      ( v99721(VarCurr)
    <=> ( v99665(VarCurr)
        & v99722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9314,axiom,
    ! [VarCurr: state_type] :
      ( v99722(VarCurr)
    <=> ( v99723(VarCurr)
        & v99728(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3853,axiom,
    ! [VarCurr: state_type] :
      ( v99728(VarCurr)
    <=> ( v99552(VarCurr,1)
        | v99725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9313,axiom,
    ! [VarCurr: state_type] :
      ( v99723(VarCurr)
    <=> ( v99590(VarCurr)
        | v99724(VarCurr) ) ) ).

tff(writeUnaryOperator_4712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99724(VarCurr)
    <=> v99725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9312,axiom,
    ! [VarCurr: state_type] :
      ( v99725(VarCurr)
    <=> ( v99726(VarCurr)
        & v99727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9311,axiom,
    ! [VarCurr: state_type] :
      ( v99727(VarCurr)
    <=> ( v99637(VarCurr)
        | v99641(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3852,axiom,
    ! [VarCurr: state_type] :
      ( v99726(VarCurr)
    <=> ( v99404(VarCurr,0)
        | v99404(VarCurr,1) ) ) ).

tff(addAssignment_60684,axiom,
    ! [VarCurr: state_type] :
      ( v99656(VarCurr,0)
    <=> v99702(VarCurr) ) ).

tff(addAssignment_60683,axiom,
    ! [VarCurr: state_type] :
      ( v99656(VarCurr,1)
    <=> v99697(VarCurr) ) ).

tff(addAssignment_60682,axiom,
    ! [VarCurr: state_type] :
      ( v99656(VarCurr,2)
    <=> v99692(VarCurr) ) ).

tff(addAssignment_60681,axiom,
    ! [VarCurr: state_type] :
      ( v99656(VarCurr,3)
    <=> v99658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9310,axiom,
    ! [VarCurr: state_type] :
      ( v99702(VarCurr)
    <=> ( v99703(VarCurr)
        & v99704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9309,axiom,
    ! [VarCurr: state_type] :
      ( v99704(VarCurr)
    <=> ( v99552(VarCurr,0)
        | v99404(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9308,axiom,
    ! [VarCurr: state_type] :
      ( v99703(VarCurr)
    <=> ( v99589(VarCurr)
        | v99637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9307,axiom,
    ! [VarCurr: state_type] :
      ( v99697(VarCurr)
    <=> ( v99698(VarCurr)
        & v99701(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9306,axiom,
    ! [VarCurr: state_type] :
      ( v99701(VarCurr)
    <=> ( v99665(VarCurr)
        | v99666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9305,axiom,
    ! [VarCurr: state_type] :
      ( v99698(VarCurr)
    <=> ( v99699(VarCurr)
        | v99700(VarCurr) ) ) ).

tff(writeUnaryOperator_4711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99700(VarCurr)
    <=> v99666(VarCurr) ) ).

tff(writeUnaryOperator_4710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99699(VarCurr)
    <=> v99665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9304,axiom,
    ! [VarCurr: state_type] :
      ( v99692(VarCurr)
    <=> ( v99693(VarCurr)
        & v99696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9303,axiom,
    ! [VarCurr: state_type] :
      ( v99696(VarCurr)
    <=> ( v99663(VarCurr)
        | v99671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9302,axiom,
    ! [VarCurr: state_type] :
      ( v99693(VarCurr)
    <=> ( v99694(VarCurr)
        | v99695(VarCurr) ) ) ).

tff(writeUnaryOperator_4709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99695(VarCurr)
    <=> v99671(VarCurr) ) ).

tff(writeUnaryOperator_4708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99694(VarCurr)
    <=> v99663(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9301,axiom,
    ! [VarCurr: state_type] :
      ( v99658(VarCurr)
    <=> ( v99659(VarCurr)
        & v99691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9300,axiom,
    ! [VarCurr: state_type] :
      ( v99691(VarCurr)
    <=> ( v99661(VarCurr)
        | v99682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9299,axiom,
    ! [VarCurr: state_type] :
      ( v99659(VarCurr)
    <=> ( v99660(VarCurr)
        | v99681(VarCurr) ) ) ).

tff(writeUnaryOperator_4707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99681(VarCurr)
    <=> v99682(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9298,axiom,
    ! [VarCurr: state_type] :
      ( v99682(VarCurr)
    <=> ( v99683(VarCurr)
        & v99690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3851,axiom,
    ! [VarCurr: state_type] :
      ( v99690(VarCurr)
    <=> ( v99404(VarCurr,3)
        | v99685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9297,axiom,
    ! [VarCurr: state_type] :
      ( v99683(VarCurr)
    <=> ( v99653(VarCurr)
        | v99684(VarCurr) ) ) ).

tff(writeUnaryOperator_4706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99684(VarCurr)
    <=> v99685(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9296,axiom,
    ! [VarCurr: state_type] :
      ( v99685(VarCurr)
    <=> ( v99686(VarCurr)
        & v99689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9295,axiom,
    ! [VarCurr: state_type] :
      ( v99689(VarCurr)
    <=> ( v99580(VarCurr)
        | v99688(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3850,axiom,
    ! [VarCurr: state_type] :
      ( v99686(VarCurr)
    <=> ( v99552(VarCurr,3)
        | v99687(VarCurr) ) ) ).

tff(writeUnaryOperator_4705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99687(VarCurr)
    <=> v99688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9294,axiom,
    ! [VarCurr: state_type] :
      ( v99688(VarCurr)
    <=> ( v99585(VarCurr)
        & v99677(VarCurr) ) ) ).

tff(writeUnaryOperator_4704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99660(VarCurr)
    <=> v99661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9293,axiom,
    ! [VarCurr: state_type] :
      ( v99661(VarCurr)
    <=> ( v99662(VarCurr)
        | v99680(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3849,axiom,
    ! [VarCurr: state_type] :
      ( v99680(VarCurr)
    <=> ( v99404(VarCurr,2)
        & v99674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9292,axiom,
    ! [VarCurr: state_type] :
      ( v99662(VarCurr)
    <=> ( v99663(VarCurr)
        & v99671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9291,axiom,
    ! [VarCurr: state_type] :
      ( v99671(VarCurr)
    <=> ( v99672(VarCurr)
        & v99679(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3848,axiom,
    ! [VarCurr: state_type] :
      ( v99679(VarCurr)
    <=> ( v99404(VarCurr,2)
        | v99674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9290,axiom,
    ! [VarCurr: state_type] :
      ( v99672(VarCurr)
    <=> ( v99647(VarCurr)
        | v99673(VarCurr) ) ) ).

tff(writeUnaryOperator_4703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99673(VarCurr)
    <=> v99674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9289,axiom,
    ! [VarCurr: state_type] :
      ( v99674(VarCurr)
    <=> ( v99675(VarCurr)
        & v99678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9288,axiom,
    ! [VarCurr: state_type] :
      ( v99678(VarCurr)
    <=> ( v99585(VarCurr)
        | v99677(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3847,axiom,
    ! [VarCurr: state_type] :
      ( v99675(VarCurr)
    <=> ( v99552(VarCurr,2)
        | v99676(VarCurr) ) ) ).

tff(writeUnaryOperator_4702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99676(VarCurr)
    <=> v99677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9287,axiom,
    ! [VarCurr: state_type] :
      ( v99677(VarCurr)
    <=> ( v99589(VarCurr)
        & v99590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9286,axiom,
    ! [VarCurr: state_type] :
      ( v99663(VarCurr)
    <=> ( v99664(VarCurr)
        | v99670(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3846,axiom,
    ! [VarCurr: state_type] :
      ( v99670(VarCurr)
    <=> ( v99587(VarCurr)
        & v99404(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9285,axiom,
    ! [VarCurr: state_type] :
      ( v99664(VarCurr)
    <=> ( v99665(VarCurr)
        & v99666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9284,axiom,
    ! [VarCurr: state_type] :
      ( v99666(VarCurr)
    <=> ( v99667(VarCurr)
        & v99669(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3845,axiom,
    ! [VarCurr: state_type] :
      ( v99669(VarCurr)
    <=> ( v99587(VarCurr)
        | v99404(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9283,axiom,
    ! [VarCurr: state_type] :
      ( v99667(VarCurr)
    <=> ( v99668(VarCurr)
        | v99641(VarCurr) ) ) ).

tff(writeUnaryOperator_4701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99668(VarCurr)
    <=> v99587(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9282,axiom,
    ! [VarCurr: state_type] :
      ( v99665(VarCurr)
    <=> ( v99552(VarCurr,0)
        & v99404(VarCurr,0) ) ) ).

tff(writeUnaryOperator_4700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99628(VarCurr)
    <=> v99630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9281,axiom,
    ! [VarCurr: state_type] :
      ( v99630(VarCurr)
    <=> ( v99631(VarCurr)
        | v99655(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3844,axiom,
    ! [VarCurr: state_type] :
      ( v99655(VarCurr)
    <=> ( v99552(VarCurr,3)
        & v99653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9280,axiom,
    ! [VarCurr: state_type] :
      ( v99631(VarCurr)
    <=> ( v99632(VarCurr)
        & v99650(VarCurr) ) ) ).

tff(writeUnaryOperator_4699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99650(VarCurr)
    <=> v99651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9279,axiom,
    ! [VarCurr: state_type] :
      ( v99651(VarCurr)
    <=> ( v99652(VarCurr)
        & v99654(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3843,axiom,
    ! [VarCurr: state_type] :
      ( v99654(VarCurr)
    <=> ( v99552(VarCurr,3)
        | v99404(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9278,axiom,
    ! [VarCurr: state_type] :
      ( v99652(VarCurr)
    <=> ( v99580(VarCurr)
        | v99653(VarCurr) ) ) ).

tff(writeUnaryOperator_4698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99653(VarCurr)
    <=> v99404(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9277,axiom,
    ! [VarCurr: state_type] :
      ( v99632(VarCurr)
    <=> ( v99633(VarCurr)
        | v99649(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3842,axiom,
    ! [VarCurr: state_type] :
      ( v99649(VarCurr)
    <=> ( v99552(VarCurr,2)
        & v99647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9276,axiom,
    ! [VarCurr: state_type] :
      ( v99633(VarCurr)
    <=> ( v99634(VarCurr)
        & v99644(VarCurr) ) ) ).

tff(writeUnaryOperator_4697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99644(VarCurr)
    <=> v99645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9275,axiom,
    ! [VarCurr: state_type] :
      ( v99645(VarCurr)
    <=> ( v99646(VarCurr)
        & v99648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3841,axiom,
    ! [VarCurr: state_type] :
      ( v99648(VarCurr)
    <=> ( v99552(VarCurr,2)
        | v99404(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9274,axiom,
    ! [VarCurr: state_type] :
      ( v99646(VarCurr)
    <=> ( v99585(VarCurr)
        | v99647(VarCurr) ) ) ).

tff(writeUnaryOperator_4696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99647(VarCurr)
    <=> v99404(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9273,axiom,
    ! [VarCurr: state_type] :
      ( v99634(VarCurr)
    <=> ( v99635(VarCurr)
        | v99643(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3840,axiom,
    ! [VarCurr: state_type] :
      ( v99643(VarCurr)
    <=> ( v99552(VarCurr,1)
        & v99641(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9272,axiom,
    ! [VarCurr: state_type] :
      ( v99635(VarCurr)
    <=> ( v99636(VarCurr)
        & v99638(VarCurr) ) ) ).

tff(writeUnaryOperator_4695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99638(VarCurr)
    <=> v99639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9271,axiom,
    ! [VarCurr: state_type] :
      ( v99639(VarCurr)
    <=> ( v99640(VarCurr)
        & v99642(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3839,axiom,
    ! [VarCurr: state_type] :
      ( v99642(VarCurr)
    <=> ( v99552(VarCurr,1)
        | v99404(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9270,axiom,
    ! [VarCurr: state_type] :
      ( v99640(VarCurr)
    <=> ( v99590(VarCurr)
        | v99641(VarCurr) ) ) ).

tff(writeUnaryOperator_4694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99641(VarCurr)
    <=> v99404(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9269,axiom,
    ! [VarCurr: state_type] :
      ( v99636(VarCurr)
    <=> ( v99552(VarCurr,0)
        & v99637(VarCurr) ) ) ).

tff(writeUnaryOperator_4693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99637(VarCurr)
    <=> v99404(VarCurr,0) ) ).

tff(addAssignment_60680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99552(VarCurr,B)
      <=> v99554(VarCurr,B) ) ) ).

tff(addAssignment_60679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99554(VarCurr,B)
      <=> v99556(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99611(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v99556(VarNext,B)
            <=> v99556(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1139,axiom,
    ! [VarNext: state_type] :
      ( v99611(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99556(VarNext,B)
          <=> v99621(VarNext,B) ) ) ) ).

tff(addAssignment_60678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99621(VarNext,B)
          <=> v99619(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99622(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99619(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_645,axiom,
    ! [VarCurr: state_type] :
      ( v99622(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99619(VarCurr,B)
          <=> v99566(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9268,axiom,
    ! [VarCurr: state_type] :
      ( v99622(VarCurr)
    <=> ( v99623(VarCurr)
        & v99624(VarCurr) ) ) ).

tff(writeUnaryOperator_4692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99624(VarCurr)
    <=> v99562(VarCurr) ) ).

tff(writeUnaryOperator_4691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99623(VarCurr)
    <=> v99558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99611(VarNext)
      <=> v99612(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99612(VarNext)
      <=> ( v99613(VarNext)
          & v99606(VarNext) ) ) ) ).

tff(writeUnaryOperator_4690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99613(VarNext)
      <=> v99615(VarNext) ) ) ).

tff(addAssignment_60677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99615(VarNext)
      <=> v99606(VarCurr) ) ) ).

tff(addAssignment_60676,axiom,
    ! [VarCurr: state_type] :
      ( v99606(VarCurr)
    <=> v99608(VarCurr) ) ).

tff(addAssignment_60675,axiom,
    ! [VarCurr: state_type] :
      ( v99608(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_60674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99566(VarCurr,B)
      <=> v99568(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99568(VarCurr,B)
      <=> ( v99598(VarCurr,B)
          | v99601(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99601(VarCurr,B)
      <=> ( v99554(VarCurr,B)
          & v99602(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99602(VarCurr,B)
      <=> ~ v99603(VarCurr,B) ) ) ).

tff(addAssignment_60673,axiom,
    ! [VarCurr: state_type] :
      ( v99603(VarCurr,0)
    <=> v99604(VarCurr) ) ).

tff(addAssignment_60672,axiom,
    ! [VarCurr: state_type] :
      ( v99603(VarCurr,1)
    <=> v99604(VarCurr) ) ).

tff(addAssignment_60671,axiom,
    ! [VarCurr: state_type] :
      ( v99603(VarCurr,2)
    <=> v99604(VarCurr) ) ).

tff(addAssignment_60670,axiom,
    ! [VarCurr: state_type] :
      ( v99603(VarCurr,3)
    <=> v99604(VarCurr) ) ).

tff(addAssignment_60669,axiom,
    ! [VarCurr: state_type] :
      ( v99604(VarCurr)
    <=> v99593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99598(VarCurr,B)
      <=> ( v99570(VarCurr,B)
          & v99599(VarCurr,B) ) ) ) ).

tff(addAssignment_60668,axiom,
    ! [VarCurr: state_type] :
      ( v99599(VarCurr,0)
    <=> v99600(VarCurr) ) ).

tff(addAssignment_60667,axiom,
    ! [VarCurr: state_type] :
      ( v99599(VarCurr,1)
    <=> v99600(VarCurr) ) ).

tff(addAssignment_60666,axiom,
    ! [VarCurr: state_type] :
      ( v99599(VarCurr,2)
    <=> v99600(VarCurr) ) ).

tff(addAssignment_60665,axiom,
    ! [VarCurr: state_type] :
      ( v99599(VarCurr,3)
    <=> v99600(VarCurr) ) ).

tff(addAssignment_60664,axiom,
    ! [VarCurr: state_type] :
      ( v99600(VarCurr)
    <=> v99593(VarCurr) ) ).

tff(addAssignment_60663,axiom,
    ! [VarCurr: state_type] :
      ( v99593(VarCurr)
    <=> v99595(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3838,axiom,
    ! [VarCurr: state_type] :
      ( v99595(VarCurr)
    <=> ( v99291(VarCurr)
        | v99272(VarCurr,7) ) ) ).

tff(addAssignment_60662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99570(VarCurr,B)
      <=> v99572(VarCurr,B) ) ) ).

tff(addAssignment_60661,axiom,
    ! [VarCurr: state_type] :
      ( v99572(VarCurr,0)
    <=> v99589(VarCurr) ) ).

tff(addAssignment_60660,axiom,
    ! [VarCurr: state_type] :
      ( v99572(VarCurr,1)
    <=> v99587(VarCurr) ) ).

tff(addAssignment_60659,axiom,
    ! [VarCurr: state_type] :
      ( v99572(VarCurr,2)
    <=> v99582(VarCurr) ) ).

tff(addAssignment_60658,axiom,
    ! [VarCurr: state_type] :
      ( v99572(VarCurr,3)
    <=> v99575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9265,axiom,
    ! [VarCurr: state_type] :
      ( v99587(VarCurr)
    <=> ( v99588(VarCurr)
        & v99591(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3837,axiom,
    ! [VarCurr: state_type] :
      ( v99591(VarCurr)
    <=> ( v99552(VarCurr,0)
        | v99552(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9264,axiom,
    ! [VarCurr: state_type] :
      ( v99588(VarCurr)
    <=> ( v99589(VarCurr)
        | v99590(VarCurr) ) ) ).

tff(writeUnaryOperator_4688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99590(VarCurr)
    <=> v99552(VarCurr,1) ) ).

tff(writeUnaryOperator_4687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99589(VarCurr)
    <=> v99552(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9263,axiom,
    ! [VarCurr: state_type] :
      ( v99582(VarCurr)
    <=> ( v99583(VarCurr)
        & v99586(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3836,axiom,
    ! [VarCurr: state_type] :
      ( v99586(VarCurr)
    <=> ( v99579(VarCurr)
        | v99552(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9262,axiom,
    ! [VarCurr: state_type] :
      ( v99583(VarCurr)
    <=> ( v99584(VarCurr)
        | v99585(VarCurr) ) ) ).

tff(writeUnaryOperator_4686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99585(VarCurr)
    <=> v99552(VarCurr,2) ) ).

tff(writeUnaryOperator_4685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99584(VarCurr)
    <=> v99579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9261,axiom,
    ! [VarCurr: state_type] :
      ( v99575(VarCurr)
    <=> ( v99576(VarCurr)
        & v99581(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3835,axiom,
    ! [VarCurr: state_type] :
      ( v99581(VarCurr)
    <=> ( v99578(VarCurr)
        | v99552(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9260,axiom,
    ! [VarCurr: state_type] :
      ( v99576(VarCurr)
    <=> ( v99577(VarCurr)
        | v99580(VarCurr) ) ) ).

tff(writeUnaryOperator_4684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99580(VarCurr)
    <=> v99552(VarCurr,3) ) ).

tff(writeUnaryOperator_4683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99577(VarCurr)
    <=> v99578(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3834,axiom,
    ! [VarCurr: state_type] :
      ( v99578(VarCurr)
    <=> ( v99579(VarCurr)
        & v99552(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3833,axiom,
    ! [VarCurr: state_type] :
      ( v99579(VarCurr)
    <=> ( v99552(VarCurr,0)
        & v99552(VarCurr,1) ) ) ).

tff(addAssignment_60657,axiom,
    ! [VarCurr: state_type] :
      ( v99562(VarCurr)
    <=> v99564(VarCurr) ) ).

tff(addAssignment_60656,axiom,
    ! [VarCurr: state_type] :
      ( v99564(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_60655,axiom,
    ! [VarCurr: state_type] :
      ( v99558(VarCurr)
    <=> v99560(VarCurr) ) ).

tff(addAssignment_60654,axiom,
    ! [VarCurr: state_type] :
      ( v99560(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_60653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99404(VarCurr,B)
      <=> v174(VarCurr,B) ) ) ).

tff(addAssignment_60652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v174(VarCurr,B)
      <=> v176(VarCurr,B) ) ) ).

tff(addAssignment_60651,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v176(VarNext,B)
      <=> v99544(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v99544(VarNext,B)
            <=> v176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1138,axiom,
    ! [VarNext: state_type] :
      ( v99545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v99544(VarNext,B)
          <=> v734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99545(VarNext)
      <=> v99546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99546(VarNext)
      <=> ( v99548(VarNext)
          & v210(VarNext) ) ) ) ).

tff(writeUnaryOperator_4682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99548(VarNext)
      <=> v728(VarNext) ) ) ).

tff(addAssignment_60650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v186(VarCurr,B)
      <=> v188(VarCurr,B) ) ) ).

tff(addAssignment_60649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v188(VarCurr,B)
      <=> v190(VarCurr,B) ) ) ).

tff(addAssignment_60648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v190(VarCurr,B)
      <=> v205(VarCurr,B) ) ) ).

tff(addAssignment_60647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v207(VarCurr,B)
      <=> v99407(VarCurr,B) ) ) ).

tff(addAssignment_60646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99407(VarCurr,B)
      <=> v99409(VarCurr,B) ) ) ).

tff(addAssignment_60645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99409(VarCurr,B)
      <=> v99411(VarCurr,B) ) ) ).

tff(addAssignment_60644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99411(VarCurr,B)
      <=> v99413(VarCurr,B) ) ) ).

tff(addAssignment_60643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99413(VarCurr,B)
      <=> v99415(VarCurr,B) ) ) ).

tff(addAssignment_60642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99415(VarCurr,B)
      <=> v99417(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99527(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v99417(VarNext,B)
            <=> v99417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1137,axiom,
    ! [VarNext: state_type] :
      ( v99527(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99417(VarNext,B)
          <=> v99537(VarNext,B) ) ) ) ).

tff(addAssignment_60641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99537(VarNext,B)
          <=> v99535(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99538(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99535(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_644,axiom,
    ! [VarCurr: state_type] :
      ( v99538(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99535(VarCurr,B)
          <=> v99427(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9257,axiom,
    ! [VarCurr: state_type] :
      ( v99538(VarCurr)
    <=> ( v99539(VarCurr)
        & v99540(VarCurr) ) ) ).

tff(writeUnaryOperator_4681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99540(VarCurr)
    <=> v99423(VarCurr) ) ).

tff(writeUnaryOperator_4680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99539(VarCurr)
    <=> v99419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99527(VarNext)
      <=> v99528(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99528(VarNext)
      <=> ( v99529(VarNext)
          & v99522(VarNext) ) ) ) ).

tff(writeUnaryOperator_4679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99529(VarNext)
      <=> v99531(VarNext) ) ) ).

tff(addAssignment_60640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99531(VarNext)
      <=> v99522(VarCurr) ) ) ).

tff(addAssignment_60639,axiom,
    ! [VarCurr: state_type] :
      ( v99522(VarCurr)
    <=> v99524(VarCurr) ) ).

tff(addAssignment_60638,axiom,
    ! [VarCurr: state_type] :
      ( v99524(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_60637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99427(VarCurr,B)
      <=> v99429(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99429(VarCurr,B)
      <=> ( v99514(VarCurr,B)
          | v99517(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99517(VarCurr,B)
      <=> ( v99415(VarCurr,B)
          & v99518(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99518(VarCurr,B)
      <=> ~ v99519(VarCurr,B) ) ) ).

tff(addAssignment_60636,axiom,
    ! [VarCurr: state_type] :
      ( v99519(VarCurr,0)
    <=> v99520(VarCurr) ) ).

tff(addAssignment_60635,axiom,
    ! [VarCurr: state_type] :
      ( v99519(VarCurr,1)
    <=> v99520(VarCurr) ) ).

tff(addAssignment_60634,axiom,
    ! [VarCurr: state_type] :
      ( v99519(VarCurr,2)
    <=> v99520(VarCurr) ) ).

tff(addAssignment_60633,axiom,
    ! [VarCurr: state_type] :
      ( v99519(VarCurr,3)
    <=> v99520(VarCurr) ) ).

tff(addAssignment_60632,axiom,
    ! [VarCurr: state_type] :
      ( v99520(VarCurr)
    <=> v99512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99514(VarCurr,B)
      <=> ( v99431(VarCurr,B)
          & v99515(VarCurr,B) ) ) ) ).

tff(addAssignment_60631,axiom,
    ! [VarCurr: state_type] :
      ( v99515(VarCurr,0)
    <=> v99516(VarCurr) ) ).

tff(addAssignment_60630,axiom,
    ! [VarCurr: state_type] :
      ( v99515(VarCurr,1)
    <=> v99516(VarCurr) ) ).

tff(addAssignment_60629,axiom,
    ! [VarCurr: state_type] :
      ( v99515(VarCurr,2)
    <=> v99516(VarCurr) ) ).

tff(addAssignment_60628,axiom,
    ! [VarCurr: state_type] :
      ( v99515(VarCurr,3)
    <=> v99516(VarCurr) ) ).

tff(addAssignment_60627,axiom,
    ! [VarCurr: state_type] :
      ( v99516(VarCurr)
    <=> v99512(VarCurr) ) ).

tff(addAssignment_60626,axiom,
    ! [VarCurr: state_type] :
      ( v99512(VarCurr)
    <=> v86612(VarCurr) ) ).

tff(addAssignment_60625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99431(VarCurr,B)
      <=> v99433(VarCurr,B) ) ) ).

tff(addAssignment_60624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99433(VarCurr,B)
      <=> v99435(VarCurr,B) ) ) ).

tff(addAssignment_60623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99435(VarCurr,B)
      <=> v99437(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99495(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v99437(VarNext,B)
            <=> v99437(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1136,axiom,
    ! [VarNext: state_type] :
      ( v99495(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99437(VarNext,B)
          <=> v99505(VarNext,B) ) ) ) ).

tff(addAssignment_60622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99505(VarNext,B)
          <=> v99503(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99506(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99503(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_643,axiom,
    ! [VarCurr: state_type] :
      ( v99506(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99503(VarCurr,B)
          <=> v99447(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9254,axiom,
    ! [VarCurr: state_type] :
      ( v99506(VarCurr)
    <=> ( v99507(VarCurr)
        & v99508(VarCurr) ) ) ).

tff(writeUnaryOperator_4677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99508(VarCurr)
    <=> v99443(VarCurr) ) ).

tff(writeUnaryOperator_4676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99507(VarCurr)
    <=> v99439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99495(VarNext)
      <=> v99496(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99496(VarNext)
      <=> ( v99497(VarNext)
          & v99490(VarNext) ) ) ) ).

tff(writeUnaryOperator_4675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99497(VarNext)
      <=> v99499(VarNext) ) ) ).

tff(addAssignment_60621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99499(VarNext)
      <=> v99490(VarCurr) ) ) ).

tff(addAssignment_60620,axiom,
    ! [VarCurr: state_type] :
      ( v99490(VarCurr)
    <=> v99492(VarCurr) ) ).

tff(addAssignment_60619,axiom,
    ! [VarCurr: state_type] :
      ( v99492(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_60618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99447(VarCurr,B)
      <=> v99449(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99449(VarCurr,B)
      <=> ( v99482(VarCurr,B)
          | v99485(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99485(VarCurr,B)
      <=> ( v99435(VarCurr,B)
          & v99486(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99486(VarCurr,B)
      <=> ~ v99487(VarCurr,B) ) ) ).

tff(addAssignment_60617,axiom,
    ! [VarCurr: state_type] :
      ( v99487(VarCurr,0)
    <=> v99488(VarCurr) ) ).

tff(addAssignment_60616,axiom,
    ! [VarCurr: state_type] :
      ( v99487(VarCurr,1)
    <=> v99488(VarCurr) ) ).

tff(addAssignment_60615,axiom,
    ! [VarCurr: state_type] :
      ( v99487(VarCurr,2)
    <=> v99488(VarCurr) ) ).

tff(addAssignment_60614,axiom,
    ! [VarCurr: state_type] :
      ( v99487(VarCurr,3)
    <=> v99488(VarCurr) ) ).

tff(addAssignment_60613,axiom,
    ! [VarCurr: state_type] :
      ( v99488(VarCurr)
    <=> v99474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99482(VarCurr,B)
      <=> ( v99451(VarCurr,B)
          & v99483(VarCurr,B) ) ) ) ).

tff(addAssignment_60612,axiom,
    ! [VarCurr: state_type] :
      ( v99483(VarCurr,0)
    <=> v99484(VarCurr) ) ).

tff(addAssignment_60611,axiom,
    ! [VarCurr: state_type] :
      ( v99483(VarCurr,1)
    <=> v99484(VarCurr) ) ).

tff(addAssignment_60610,axiom,
    ! [VarCurr: state_type] :
      ( v99483(VarCurr,2)
    <=> v99484(VarCurr) ) ).

tff(addAssignment_60609,axiom,
    ! [VarCurr: state_type] :
      ( v99483(VarCurr,3)
    <=> v99484(VarCurr) ) ).

tff(addAssignment_60608,axiom,
    ! [VarCurr: state_type] :
      ( v99484(VarCurr)
    <=> v99474(VarCurr) ) ).

tff(addAssignment_60607,axiom,
    ! [VarCurr: state_type] :
      ( v99474(VarCurr)
    <=> v99476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9251,axiom,
    ! [VarCurr: state_type] :
      ( v99476(VarCurr)
    <=> ( v99478(VarCurr)
        & v99480(VarCurr) ) ) ).

tff(writeUnaryOperator_4673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99480(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9250,axiom,
    ! [VarCurr: state_type] :
      ( v99478(VarCurr)
    <=> ( v85874(VarCurr)
        & v99479(VarCurr) ) ) ).

tff(writeUnaryOperator_4672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99479(VarCurr)
    <=> v85868(VarCurr) ) ).

tff(addAssignment_60606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99451(VarCurr,B)
      <=> v99453(VarCurr,B) ) ) ).

tff(addAssignment_60605,axiom,
    ! [VarCurr: state_type] :
      ( v99453(VarCurr,0)
    <=> v99470(VarCurr) ) ).

tff(addAssignment_60604,axiom,
    ! [VarCurr: state_type] :
      ( v99453(VarCurr,1)
    <=> v99468(VarCurr) ) ).

tff(addAssignment_60603,axiom,
    ! [VarCurr: state_type] :
      ( v99453(VarCurr,2)
    <=> v99463(VarCurr) ) ).

tff(addAssignment_60602,axiom,
    ! [VarCurr: state_type] :
      ( v99453(VarCurr,3)
    <=> v99456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9249,axiom,
    ! [VarCurr: state_type] :
      ( v99468(VarCurr)
    <=> ( v99469(VarCurr)
        & v99472(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3832,axiom,
    ! [VarCurr: state_type] :
      ( v99472(VarCurr)
    <=> ( v99413(VarCurr,0)
        | v99413(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9248,axiom,
    ! [VarCurr: state_type] :
      ( v99469(VarCurr)
    <=> ( v99470(VarCurr)
        | v99471(VarCurr) ) ) ).

tff(writeUnaryOperator_4671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99471(VarCurr)
    <=> v99413(VarCurr,1) ) ).

tff(writeUnaryOperator_4670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99470(VarCurr)
    <=> v99413(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9247,axiom,
    ! [VarCurr: state_type] :
      ( v99463(VarCurr)
    <=> ( v99464(VarCurr)
        & v99467(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3831,axiom,
    ! [VarCurr: state_type] :
      ( v99467(VarCurr)
    <=> ( v99460(VarCurr)
        | v99413(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9246,axiom,
    ! [VarCurr: state_type] :
      ( v99464(VarCurr)
    <=> ( v99465(VarCurr)
        | v99466(VarCurr) ) ) ).

tff(writeUnaryOperator_4669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99466(VarCurr)
    <=> v99413(VarCurr,2) ) ).

tff(writeUnaryOperator_4668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99465(VarCurr)
    <=> v99460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9245,axiom,
    ! [VarCurr: state_type] :
      ( v99456(VarCurr)
    <=> ( v99457(VarCurr)
        & v99462(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3830,axiom,
    ! [VarCurr: state_type] :
      ( v99462(VarCurr)
    <=> ( v99459(VarCurr)
        | v99413(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9244,axiom,
    ! [VarCurr: state_type] :
      ( v99457(VarCurr)
    <=> ( v99458(VarCurr)
        | v99461(VarCurr) ) ) ).

tff(writeUnaryOperator_4667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99461(VarCurr)
    <=> v99413(VarCurr,3) ) ).

tff(writeUnaryOperator_4666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99458(VarCurr)
    <=> v99459(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3829,axiom,
    ! [VarCurr: state_type] :
      ( v99459(VarCurr)
    <=> ( v99460(VarCurr)
        & v99413(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3828,axiom,
    ! [VarCurr: state_type] :
      ( v99460(VarCurr)
    <=> ( v99413(VarCurr,0)
        & v99413(VarCurr,1) ) ) ).

tff(addAssignment_60601,axiom,
    ! [VarCurr: state_type] :
      ( v99443(VarCurr)
    <=> v99445(VarCurr) ) ).

tff(addAssignment_60600,axiom,
    ! [VarCurr: state_type] :
      ( v99445(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_60599,axiom,
    ! [VarCurr: state_type] :
      ( v99439(VarCurr)
    <=> v99441(VarCurr) ) ).

tff(addAssignment_60598,axiom,
    ! [VarCurr: state_type] :
      ( v99441(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_60597,axiom,
    ! [VarCurr: state_type] :
      ( v99423(VarCurr)
    <=> v99425(VarCurr) ) ).

tff(addAssignment_60596,axiom,
    ! [VarCurr: state_type] :
      ( v99425(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_60595,axiom,
    ! [VarCurr: state_type] :
      ( v99419(VarCurr)
    <=> v99421(VarCurr) ) ).

tff(addAssignment_60594,axiom,
    ! [VarCurr: state_type] :
      ( v99421(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99232(VarCurr,B)
      <=> ( v99360(VarCurr,B)
          | v99398(VarCurr,B) ) ) ) ).

tff(addAssignment_60593,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,0)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60592,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,1)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60591,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,2)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60590,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,3)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60589,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,4)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60588,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,5)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60587,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,6)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60586,axiom,
    ! [VarCurr: state_type] :
      ( v99398(VarCurr,7)
    <=> v99399(VarCurr) ) ).

tff(addAssignment_60585,axiom,
    ! [VarCurr: state_type] :
      ( v99399(VarCurr)
    <=> v99400(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_592,axiom,
    ! [VarCurr: state_type] :
      ( v99400(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $true )
        & ( v99234(VarCurr,2)
        <=> $false )
        & ( v99234(VarCurr,1)
        <=> $false )
        & ( v99234(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99360(VarCurr,B)
      <=> ( v99361(VarCurr,B)
          | v99394(VarCurr,B) ) ) ) ).

tff(addAssignment_60584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99394(VarCurr,B)
      <=> v99395(VarCurr,B) ) ) ).

tff(addAssignment_60583,axiom,
    ! [VarCurr: state_type] :
      ( v99394(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_60582,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,0)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60581,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,1)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60580,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,2)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60579,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,3)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60578,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,4)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60577,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,5)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60576,axiom,
    ! [VarCurr: state_type] :
      ( v99395(VarCurr,6)
    <=> v99396(VarCurr) ) ).

tff(addAssignment_60575,axiom,
    ! [VarCurr: state_type] :
      ( v99396(VarCurr)
    <=> v99397(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_591,axiom,
    ! [VarCurr: state_type] :
      ( v99397(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $true )
        & ( v99234(VarCurr,1)
        <=> $true )
        & ( v99234(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_32,axiom,
    ! [VarCurr: state_type] : ~ v99361(VarCurr,7) ).

tff(addAssignment_60574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99361(VarCurr,B)
      <=> v99362(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99362(VarCurr,B)
      <=> ( v99363(VarCurr,B)
          | v99390(VarCurr,B) ) ) ) ).

tff(addAssignment_60573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99390(VarCurr,B)
      <=> v99391(VarCurr,B) ) ) ).

tff(addAssignment_60572,axiom,
    ! [VarCurr: state_type] :
      ( v99390(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_60571,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,0)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60570,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,1)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60569,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,2)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60568,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,3)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60567,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,4)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60566,axiom,
    ! [VarCurr: state_type] :
      ( v99391(VarCurr,5)
    <=> v99392(VarCurr) ) ).

tff(addAssignment_60565,axiom,
    ! [VarCurr: state_type] :
      ( v99392(VarCurr)
    <=> v99393(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_590,axiom,
    ! [VarCurr: state_type] :
      ( v99393(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $true )
        & ( v99234(VarCurr,1)
        <=> $true )
        & ( v99234(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_31,axiom,
    ! [VarCurr: state_type] : ~ v99363(VarCurr,6) ).

tff(addAssignment_60564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99363(VarCurr,B)
      <=> v99364(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99364(VarCurr,B)
      <=> ( v99365(VarCurr,B)
          | v99386(VarCurr,B) ) ) ) ).

tff(addAssignment_60563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99386(VarCurr,B)
      <=> v99387(VarCurr,B) ) ) ).

tff(addAssignment_60562,axiom,
    ! [VarCurr: state_type] :
      ( v99386(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_60561,axiom,
    ! [VarCurr: state_type] :
      ( v99387(VarCurr,0)
    <=> v99388(VarCurr) ) ).

tff(addAssignment_60560,axiom,
    ! [VarCurr: state_type] :
      ( v99387(VarCurr,1)
    <=> v99388(VarCurr) ) ).

tff(addAssignment_60559,axiom,
    ! [VarCurr: state_type] :
      ( v99387(VarCurr,2)
    <=> v99388(VarCurr) ) ).

tff(addAssignment_60558,axiom,
    ! [VarCurr: state_type] :
      ( v99387(VarCurr,3)
    <=> v99388(VarCurr) ) ).

tff(addAssignment_60557,axiom,
    ! [VarCurr: state_type] :
      ( v99387(VarCurr,4)
    <=> v99388(VarCurr) ) ).

tff(addAssignment_60556,axiom,
    ! [VarCurr: state_type] :
      ( v99388(VarCurr)
    <=> v99389(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_589,axiom,
    ! [VarCurr: state_type] :
      ( v99389(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $true )
        & ( v99234(VarCurr,1)
        <=> $false )
        & ( v99234(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_30,axiom,
    ! [VarCurr: state_type] : ~ v99365(VarCurr,5) ).

tff(addAssignment_60555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99365(VarCurr,B)
      <=> v99366(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99366(VarCurr,B)
      <=> ( v99367(VarCurr,B)
          | v99382(VarCurr,B) ) ) ) ).

tff(addAssignment_60554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99382(VarCurr,B)
      <=> v99383(VarCurr,B) ) ) ).

tff(addAssignment_60553,axiom,
    ! [VarCurr: state_type] :
      ( v99382(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_60552,axiom,
    ! [VarCurr: state_type] :
      ( v99383(VarCurr,0)
    <=> v99384(VarCurr) ) ).

tff(addAssignment_60551,axiom,
    ! [VarCurr: state_type] :
      ( v99383(VarCurr,1)
    <=> v99384(VarCurr) ) ).

tff(addAssignment_60550,axiom,
    ! [VarCurr: state_type] :
      ( v99383(VarCurr,2)
    <=> v99384(VarCurr) ) ).

tff(addAssignment_60549,axiom,
    ! [VarCurr: state_type] :
      ( v99383(VarCurr,3)
    <=> v99384(VarCurr) ) ).

tff(addAssignment_60548,axiom,
    ! [VarCurr: state_type] :
      ( v99384(VarCurr)
    <=> v99385(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_588,axiom,
    ! [VarCurr: state_type] :
      ( v99385(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $true )
        & ( v99234(VarCurr,1)
        <=> $false )
        & ( v99234(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_29,axiom,
    ! [VarCurr: state_type] : ~ v99367(VarCurr,4) ).

tff(addAssignment_60547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99367(VarCurr,B)
      <=> v99368(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1349,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99368(VarCurr,B)
      <=> ( v99369(VarCurr,B)
          | v99378(VarCurr,B) ) ) ) ).

tff(addAssignment_60546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99378(VarCurr,B)
      <=> v99379(VarCurr,B) ) ) ).

tff(addAssignment_60545,axiom,
    ! [VarCurr: state_type] :
      ( v99378(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_60544,axiom,
    ! [VarCurr: state_type] :
      ( v99379(VarCurr,0)
    <=> v99380(VarCurr) ) ).

tff(addAssignment_60543,axiom,
    ! [VarCurr: state_type] :
      ( v99379(VarCurr,1)
    <=> v99380(VarCurr) ) ).

tff(addAssignment_60542,axiom,
    ! [VarCurr: state_type] :
      ( v99379(VarCurr,2)
    <=> v99380(VarCurr) ) ).

tff(addAssignment_60541,axiom,
    ! [VarCurr: state_type] :
      ( v99380(VarCurr)
    <=> v99381(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_587,axiom,
    ! [VarCurr: state_type] :
      ( v99381(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $false )
        & ( v99234(VarCurr,1)
        <=> $true )
        & ( v99234(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_28,axiom,
    ! [VarCurr: state_type] : ~ v99369(VarCurr,3) ).

tff(addAssignment_60540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99369(VarCurr,B)
      <=> v99370(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99370(VarCurr,B)
      <=> ( v99371(VarCurr,B)
          | v99374(VarCurr,B) ) ) ) ).

tff(addAssignment_60539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99374(VarCurr,B)
      <=> v99375(VarCurr,B) ) ) ).

tff(addAssignment_60538,axiom,
    ! [VarCurr: state_type] :
      ( v99374(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_60537,axiom,
    ! [VarCurr: state_type] :
      ( v99375(VarCurr,0)
    <=> v99376(VarCurr) ) ).

tff(addAssignment_60536,axiom,
    ! [VarCurr: state_type] :
      ( v99375(VarCurr,1)
    <=> v99376(VarCurr) ) ).

tff(addAssignment_60535,axiom,
    ! [VarCurr: state_type] :
      ( v99376(VarCurr)
    <=> v99377(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_586,axiom,
    ! [VarCurr: state_type] :
      ( v99377(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $false )
        & ( v99234(VarCurr,1)
        <=> $true )
        & ( v99234(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_27,axiom,
    ! [VarCurr: state_type] : ~ v99371(VarCurr,2) ).

tff(addAssignment_60534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99371(VarCurr,B)
      <=> v99372(VarCurr,B) ) ) ).

tff(addAssignment_60533,axiom,
    ! [VarCurr: state_type] :
      ( v99372(VarCurr,0)
    <=> v99373(VarCurr) ) ).

tff(addAssignment_60532,axiom,
    ! [VarCurr: state_type] :
      ( v99372(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_585,axiom,
    ! [VarCurr: state_type] :
      ( v99373(VarCurr)
    <=> ( ( v99234(VarCurr,3)
        <=> $false )
        & ( v99234(VarCurr,2)
        <=> $false )
        & ( v99234(VarCurr,1)
        <=> $false )
        & ( v99234(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_60531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99234(VarCurr,B)
      <=> v99236(VarCurr,B) ) ) ).

tff(addAssignment_60530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99236(VarCurr,B)
      <=> v99238(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99343(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v99238(VarNext,B)
            <=> v99238(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1135,axiom,
    ! [VarNext: state_type] :
      ( v99343(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99238(VarNext,B)
          <=> v99353(VarNext,B) ) ) ) ).

tff(addAssignment_60529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99353(VarNext,B)
          <=> v99351(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99351(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_642,axiom,
    ! [VarCurr: state_type] :
      ( v99354(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99351(VarCurr,B)
          <=> v99248(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9243,axiom,
    ! [VarCurr: state_type] :
      ( v99354(VarCurr)
    <=> ( v99355(VarCurr)
        & v99356(VarCurr) ) ) ).

tff(writeUnaryOperator_4665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99356(VarCurr)
    <=> v99244(VarCurr) ) ).

tff(writeUnaryOperator_4664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99355(VarCurr)
    <=> v99240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99343(VarNext)
      <=> v99344(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99344(VarNext)
      <=> ( v99345(VarNext)
          & v99338(VarNext) ) ) ) ).

tff(writeUnaryOperator_4663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99345(VarNext)
      <=> v99347(VarNext) ) ) ).

tff(addAssignment_60528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99347(VarNext)
      <=> v99338(VarCurr) ) ) ).

tff(addAssignment_60527,axiom,
    ! [VarCurr: state_type] :
      ( v99338(VarCurr)
    <=> v99340(VarCurr) ) ).

tff(addAssignment_60526,axiom,
    ! [VarCurr: state_type] :
      ( v99340(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_60525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99248(VarCurr,B)
      <=> v99250(VarCurr,B) ) ) ).

tff(addAssignment_60524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99250(VarCurr,B)
      <=> v99252(VarCurr,B) ) ) ).

tff(addAssignment_60523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99252(VarCurr,B)
      <=> v99254(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99287(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99254(VarCurr,B)
          <=> v99316(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_641,axiom,
    ! [VarCurr: state_type] :
      ( v99287(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99254(VarCurr,B)
          <=> v99297(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99317(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99316(VarCurr,B)
          <=> v99234(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_640,axiom,
    ! [VarCurr: state_type] :
      ( v99317(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99316(VarCurr,B)
          <=> v99320(VarCurr,B) ) ) ) ).

tff(addAssignment_60522,axiom,
    ! [VarCurr: state_type] :
      ( v99320(VarCurr,0)
    <=> v99313(VarCurr) ) ).

tff(addAssignment_60521,axiom,
    ! [VarCurr: state_type] :
      ( v99320(VarCurr,1)
    <=> v99334(VarCurr) ) ).

tff(addAssignment_60520,axiom,
    ! [VarCurr: state_type] :
      ( v99320(VarCurr,2)
    <=> v99330(VarCurr) ) ).

tff(addAssignment_60519,axiom,
    ! [VarCurr: state_type] :
      ( v99320(VarCurr,3)
    <=> v99322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9240,axiom,
    ! [VarCurr: state_type] :
      ( v99334(VarCurr)
    <=> ( v99335(VarCurr)
        & v99336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9239,axiom,
    ! [VarCurr: state_type] :
      ( v99336(VarCurr)
    <=> ( v99234(VarCurr,0)
        | v99314(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3827,axiom,
    ! [VarCurr: state_type] :
      ( v99335(VarCurr)
    <=> ( v99313(VarCurr)
        | v99234(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9238,axiom,
    ! [VarCurr: state_type] :
      ( v99330(VarCurr)
    <=> ( v99331(VarCurr)
        & v99333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9237,axiom,
    ! [VarCurr: state_type] :
      ( v99333(VarCurr)
    <=> ( v99309(VarCurr)
        | v99327(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3826,axiom,
    ! [VarCurr: state_type] :
      ( v99331(VarCurr)
    <=> ( v99234(VarCurr,2)
        | v99332(VarCurr) ) ) ).

tff(writeUnaryOperator_4662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99332(VarCurr)
    <=> v99327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9236,axiom,
    ! [VarCurr: state_type] :
      ( v99322(VarCurr)
    <=> ( v99323(VarCurr)
        & v99329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9235,axiom,
    ! [VarCurr: state_type] :
      ( v99329(VarCurr)
    <=> ( v99304(VarCurr)
        | v99325(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3825,axiom,
    ! [VarCurr: state_type] :
      ( v99323(VarCurr)
    <=> ( v99234(VarCurr,3)
        | v99324(VarCurr) ) ) ).

tff(writeUnaryOperator_4661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99324(VarCurr)
    <=> v99325(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3824,axiom,
    ! [VarCurr: state_type] :
      ( v99325(VarCurr)
    <=> ( v99234(VarCurr,2)
        | v99326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9234,axiom,
    ! [VarCurr: state_type] :
      ( v99326(VarCurr)
    <=> ( v99309(VarCurr)
        & v99327(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3823,axiom,
    ! [VarCurr: state_type] :
      ( v99327(VarCurr)
    <=> ( v99234(VarCurr,1)
        | v99328(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9233,axiom,
    ! [VarCurr: state_type] :
      ( v99328(VarCurr)
    <=> ( v99234(VarCurr,0)
        & v99314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9232,axiom,
    ! [VarCurr: state_type] :
      ( v99317(VarCurr)
    <=> ( v99318(VarCurr)
        & v99319(VarCurr) ) ) ).

tff(writeUnaryOperator_4660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99319(VarCurr)
    <=> v99256(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3822,axiom,
    ! [VarCurr: state_type] :
      ( v99318(VarCurr)
    <=> ( v99291(VarCurr)
        | v99272(VarCurr,7) ) ) ).

tff(addAssignment_60518,axiom,
    ! [VarCurr: state_type] :
      ( v99297(VarCurr,0)
    <=> v99313(VarCurr) ) ).

tff(addAssignment_60517,axiom,
    ! [VarCurr: state_type] :
      ( v99297(VarCurr,1)
    <=> v99311(VarCurr) ) ).

tff(addAssignment_60516,axiom,
    ! [VarCurr: state_type] :
      ( v99297(VarCurr,2)
    <=> v99306(VarCurr) ) ).

tff(addAssignment_60515,axiom,
    ! [VarCurr: state_type] :
      ( v99297(VarCurr,3)
    <=> v99299(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9231,axiom,
    ! [VarCurr: state_type] :
      ( v99311(VarCurr)
    <=> ( v99312(VarCurr)
        & v99315(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3821,axiom,
    ! [VarCurr: state_type] :
      ( v99315(VarCurr)
    <=> ( v99234(VarCurr,0)
        | v99234(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9230,axiom,
    ! [VarCurr: state_type] :
      ( v99312(VarCurr)
    <=> ( v99313(VarCurr)
        | v99314(VarCurr) ) ) ).

tff(writeUnaryOperator_4659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99314(VarCurr)
    <=> v99234(VarCurr,1) ) ).

tff(writeUnaryOperator_4658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99313(VarCurr)
    <=> v99234(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9229,axiom,
    ! [VarCurr: state_type] :
      ( v99306(VarCurr)
    <=> ( v99307(VarCurr)
        & v99310(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3820,axiom,
    ! [VarCurr: state_type] :
      ( v99310(VarCurr)
    <=> ( v99303(VarCurr)
        | v99234(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9228,axiom,
    ! [VarCurr: state_type] :
      ( v99307(VarCurr)
    <=> ( v99308(VarCurr)
        | v99309(VarCurr) ) ) ).

tff(writeUnaryOperator_4657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99309(VarCurr)
    <=> v99234(VarCurr,2) ) ).

tff(writeUnaryOperator_4656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99308(VarCurr)
    <=> v99303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9227,axiom,
    ! [VarCurr: state_type] :
      ( v99299(VarCurr)
    <=> ( v99300(VarCurr)
        & v99305(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3819,axiom,
    ! [VarCurr: state_type] :
      ( v99305(VarCurr)
    <=> ( v99302(VarCurr)
        | v99234(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9226,axiom,
    ! [VarCurr: state_type] :
      ( v99300(VarCurr)
    <=> ( v99301(VarCurr)
        | v99304(VarCurr) ) ) ).

tff(writeUnaryOperator_4655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99304(VarCurr)
    <=> v99234(VarCurr,3) ) ).

tff(writeUnaryOperator_4654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99301(VarCurr)
    <=> v99302(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3818,axiom,
    ! [VarCurr: state_type] :
      ( v99302(VarCurr)
    <=> ( v99303(VarCurr)
        & v99234(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3817,axiom,
    ! [VarCurr: state_type] :
      ( v99303(VarCurr)
    <=> ( v99234(VarCurr,0)
        & v99234(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9225,axiom,
    ! [VarCurr: state_type] :
      ( v99287(VarCurr)
    <=> ( v99256(VarCurr)
        & v99288(VarCurr) ) ) ).

tff(writeUnaryOperator_4653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99288(VarCurr)
    <=> v99289(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3816,axiom,
    ! [VarCurr: state_type] :
      ( v99289(VarCurr)
    <=> ( v99291(VarCurr)
        | v99272(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3815,axiom,
    ! [VarCurr: state_type] :
      ( v99291(VarCurr)
    <=> ( v99292(VarCurr)
        | v99272(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3814,axiom,
    ! [VarCurr: state_type] :
      ( v99292(VarCurr)
    <=> ( v99293(VarCurr)
        | v99272(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3813,axiom,
    ! [VarCurr: state_type] :
      ( v99293(VarCurr)
    <=> ( v99294(VarCurr)
        | v99272(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3812,axiom,
    ! [VarCurr: state_type] :
      ( v99294(VarCurr)
    <=> ( v99295(VarCurr)
        | v99272(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3811,axiom,
    ! [VarCurr: state_type] :
      ( v99295(VarCurr)
    <=> ( v99296(VarCurr)
        | v99272(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3810,axiom,
    ! [VarCurr: state_type] :
      ( v99296(VarCurr)
    <=> ( v99272(VarCurr,0)
        | v99272(VarCurr,1) ) ) ).

tff(addAssignment_60514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99272(VarCurr,B)
      <=> v99274(VarCurr,B) ) ) ).

tff(addAssignment_60513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99274(VarCurr,B)
      <=> v99276(VarCurr,B) ) ) ).

tff(addAssignment_60512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99276(VarCurr,B)
      <=> v99278(VarCurr,B) ) ) ).

tff(addAssignment_60511,axiom,
    ! [VarCurr: state_type] :
      ( ( v99278(VarCurr,7)
      <=> $false )
      & ( v99278(VarCurr,6)
      <=> $false )
      & ( v99278(VarCurr,5)
      <=> $false )
      & ( v99278(VarCurr,4)
      <=> $false )
      & ( v99278(VarCurr,3)
      <=> $false )
      & ( v99278(VarCurr,2)
      <=> $false )
      & ( v99278(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9224,axiom,
    ! [VarCurr: state_type] :
      ( v99278(VarCurr,0)
    <=> ( v99280(VarCurr)
        & v99283(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v99283(VarCurr)
      <=> v99285(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_639,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v99283(VarCurr)
      <=> v99284(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_584,axiom,
    ! [VarCurr: state_type] :
      ( v99285(VarCurr)
    <=> ( ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_583,axiom,
    ! [VarCurr: state_type] :
      ( v99284(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $true )
        & ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9223,axiom,
    ! [VarCurr: state_type] :
      ( v99280(VarCurr)
    <=> ( v99281(VarCurr)
        & v99282(VarCurr) ) ) ).

tff(writeUnaryOperator_4652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99282(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9222,axiom,
    ! [VarCurr: state_type] :
      ( v99281(VarCurr)
    <=> ( v98436(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9221,axiom,
    ! [VarCurr: state_type] :
      ( v99256(VarCurr)
    <=> ( v99268(VarCurr)
        & v99270(VarCurr) ) ) ).

tff(writeUnaryOperator_4651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99270(VarCurr)
    <=> v99258(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9220,axiom,
    ! [VarCurr: state_type] :
      ( v99268(VarCurr)
    <=> ( v85794(VarCurr)
        & v99269(VarCurr) ) ) ).

tff(writeUnaryOperator_4650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99269(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_3809,axiom,
    ! [VarCurr: state_type] :
      ( v99258(VarCurr)
    <=> ( v99261(VarCurr)
        & v89419(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3808,axiom,
    ! [VarCurr: state_type] :
      ( v99261(VarCurr)
    <=> ( v99262(VarCurr)
        & v89419(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3807,axiom,
    ! [VarCurr: state_type] :
      ( v99262(VarCurr)
    <=> ( v99263(VarCurr)
        & v89419(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3806,axiom,
    ! [VarCurr: state_type] :
      ( v99263(VarCurr)
    <=> ( v99264(VarCurr)
        & v89419(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3805,axiom,
    ! [VarCurr: state_type] :
      ( v99264(VarCurr)
    <=> ( v99265(VarCurr)
        & v89419(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3804,axiom,
    ! [VarCurr: state_type] :
      ( v99265(VarCurr)
    <=> ( v99266(VarCurr)
        & v89419(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3803,axiom,
    ! [VarCurr: state_type] :
      ( v99266(VarCurr)
    <=> ( v89419(VarCurr,0)
        & v89419(VarCurr,1) ) ) ).

tff(addAssignment_60510,axiom,
    ! [VarCurr: state_type] :
      ( v99244(VarCurr)
    <=> v99246(VarCurr) ) ).

tff(addAssignment_60509,axiom,
    ! [VarCurr: state_type] :
      ( v99246(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_60508,axiom,
    ! [VarCurr: state_type] :
      ( v99240(VarCurr)
    <=> v99242(VarCurr) ) ).

tff(addAssignment_60507,axiom,
    ! [VarCurr: state_type] :
      ( v99242(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_60506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98635(VarCurr,B)
      <=> v98637(VarCurr,B) ) ) ).

tff(addAssignment_60505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98637(VarCurr,B)
      <=> v98639(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98639(VarCurr,B)
      <=> ( v98641(VarCurr,B)
          & v99183(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99183(VarCurr,B)
      <=> ( v99184(VarCurr,B)
          | v99222(VarCurr,B) ) ) ) ).

tff(addAssignment_60504,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,0)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60503,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,1)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60502,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,2)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60501,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,3)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60500,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,4)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60499,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,5)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60498,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,6)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60497,axiom,
    ! [VarCurr: state_type] :
      ( v99222(VarCurr,7)
    <=> v99223(VarCurr) ) ).

tff(addAssignment_60496,axiom,
    ! [VarCurr: state_type] :
      ( v99223(VarCurr)
    <=> v99224(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_582,axiom,
    ! [VarCurr: state_type] :
      ( v99224(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $true )
        & ( v98812(VarCurr,2)
        <=> $false )
        & ( v98812(VarCurr,1)
        <=> $false )
        & ( v98812(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v99184(VarCurr,B)
      <=> ( v99185(VarCurr,B)
          | v99218(VarCurr,B) ) ) ) ).

tff(addAssignment_60495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99218(VarCurr,B)
      <=> v99219(VarCurr,B) ) ) ).

tff(addAssignment_60494,axiom,
    ! [VarCurr: state_type] :
      ( v99218(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_60493,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,0)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60492,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,1)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60491,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,2)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60490,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,3)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60489,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,4)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60488,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,5)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60487,axiom,
    ! [VarCurr: state_type] :
      ( v99219(VarCurr,6)
    <=> v99220(VarCurr) ) ).

tff(addAssignment_60486,axiom,
    ! [VarCurr: state_type] :
      ( v99220(VarCurr)
    <=> v99221(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_581,axiom,
    ! [VarCurr: state_type] :
      ( v99221(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $true )
        & ( v98812(VarCurr,1)
        <=> $true )
        & ( v98812(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_26,axiom,
    ! [VarCurr: state_type] : ~ v99185(VarCurr,7) ).

tff(addAssignment_60485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99185(VarCurr,B)
      <=> v99186(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v99186(VarCurr,B)
      <=> ( v99187(VarCurr,B)
          | v99214(VarCurr,B) ) ) ) ).

tff(addAssignment_60484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99214(VarCurr,B)
      <=> v99215(VarCurr,B) ) ) ).

tff(addAssignment_60483,axiom,
    ! [VarCurr: state_type] :
      ( v99214(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_60482,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,0)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60481,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,1)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60480,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,2)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60479,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,3)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60478,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,4)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60477,axiom,
    ! [VarCurr: state_type] :
      ( v99215(VarCurr,5)
    <=> v99216(VarCurr) ) ).

tff(addAssignment_60476,axiom,
    ! [VarCurr: state_type] :
      ( v99216(VarCurr)
    <=> v99217(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_580,axiom,
    ! [VarCurr: state_type] :
      ( v99217(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $true )
        & ( v98812(VarCurr,1)
        <=> $true )
        & ( v98812(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_25,axiom,
    ! [VarCurr: state_type] : ~ v99187(VarCurr,6) ).

tff(addAssignment_60475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99187(VarCurr,B)
      <=> v99188(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v99188(VarCurr,B)
      <=> ( v99189(VarCurr,B)
          | v99210(VarCurr,B) ) ) ) ).

tff(addAssignment_60474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99210(VarCurr,B)
      <=> v99211(VarCurr,B) ) ) ).

tff(addAssignment_60473,axiom,
    ! [VarCurr: state_type] :
      ( v99210(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_60472,axiom,
    ! [VarCurr: state_type] :
      ( v99211(VarCurr,0)
    <=> v99212(VarCurr) ) ).

tff(addAssignment_60471,axiom,
    ! [VarCurr: state_type] :
      ( v99211(VarCurr,1)
    <=> v99212(VarCurr) ) ).

tff(addAssignment_60470,axiom,
    ! [VarCurr: state_type] :
      ( v99211(VarCurr,2)
    <=> v99212(VarCurr) ) ).

tff(addAssignment_60469,axiom,
    ! [VarCurr: state_type] :
      ( v99211(VarCurr,3)
    <=> v99212(VarCurr) ) ).

tff(addAssignment_60468,axiom,
    ! [VarCurr: state_type] :
      ( v99211(VarCurr,4)
    <=> v99212(VarCurr) ) ).

tff(addAssignment_60467,axiom,
    ! [VarCurr: state_type] :
      ( v99212(VarCurr)
    <=> v99213(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_579,axiom,
    ! [VarCurr: state_type] :
      ( v99213(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $true )
        & ( v98812(VarCurr,1)
        <=> $false )
        & ( v98812(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_24,axiom,
    ! [VarCurr: state_type] : ~ v99189(VarCurr,5) ).

tff(addAssignment_60466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99189(VarCurr,B)
      <=> v99190(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v99190(VarCurr,B)
      <=> ( v99191(VarCurr,B)
          | v99206(VarCurr,B) ) ) ) ).

tff(addAssignment_60465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99206(VarCurr,B)
      <=> v99207(VarCurr,B) ) ) ).

tff(addAssignment_60464,axiom,
    ! [VarCurr: state_type] :
      ( v99206(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_60463,axiom,
    ! [VarCurr: state_type] :
      ( v99207(VarCurr,0)
    <=> v99208(VarCurr) ) ).

tff(addAssignment_60462,axiom,
    ! [VarCurr: state_type] :
      ( v99207(VarCurr,1)
    <=> v99208(VarCurr) ) ).

tff(addAssignment_60461,axiom,
    ! [VarCurr: state_type] :
      ( v99207(VarCurr,2)
    <=> v99208(VarCurr) ) ).

tff(addAssignment_60460,axiom,
    ! [VarCurr: state_type] :
      ( v99207(VarCurr,3)
    <=> v99208(VarCurr) ) ).

tff(addAssignment_60459,axiom,
    ! [VarCurr: state_type] :
      ( v99208(VarCurr)
    <=> v99209(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_578,axiom,
    ! [VarCurr: state_type] :
      ( v99209(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $true )
        & ( v98812(VarCurr,1)
        <=> $false )
        & ( v98812(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_23,axiom,
    ! [VarCurr: state_type] : ~ v99191(VarCurr,4) ).

tff(addAssignment_60458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99191(VarCurr,B)
      <=> v99192(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99192(VarCurr,B)
      <=> ( v99193(VarCurr,B)
          | v99202(VarCurr,B) ) ) ) ).

tff(addAssignment_60457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99202(VarCurr,B)
      <=> v99203(VarCurr,B) ) ) ).

tff(addAssignment_60456,axiom,
    ! [VarCurr: state_type] :
      ( v99202(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_60455,axiom,
    ! [VarCurr: state_type] :
      ( v99203(VarCurr,0)
    <=> v99204(VarCurr) ) ).

tff(addAssignment_60454,axiom,
    ! [VarCurr: state_type] :
      ( v99203(VarCurr,1)
    <=> v99204(VarCurr) ) ).

tff(addAssignment_60453,axiom,
    ! [VarCurr: state_type] :
      ( v99203(VarCurr,2)
    <=> v99204(VarCurr) ) ).

tff(addAssignment_60452,axiom,
    ! [VarCurr: state_type] :
      ( v99204(VarCurr)
    <=> v99205(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_577,axiom,
    ! [VarCurr: state_type] :
      ( v99205(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $false )
        & ( v98812(VarCurr,1)
        <=> $true )
        & ( v98812(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_22,axiom,
    ! [VarCurr: state_type] : ~ v99193(VarCurr,3) ).

tff(addAssignment_60451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99193(VarCurr,B)
      <=> v99194(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v99194(VarCurr,B)
      <=> ( v99195(VarCurr,B)
          | v99198(VarCurr,B) ) ) ) ).

tff(addAssignment_60450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99198(VarCurr,B)
      <=> v99199(VarCurr,B) ) ) ).

tff(addAssignment_60449,axiom,
    ! [VarCurr: state_type] :
      ( v99198(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_60448,axiom,
    ! [VarCurr: state_type] :
      ( v99199(VarCurr,0)
    <=> v99200(VarCurr) ) ).

tff(addAssignment_60447,axiom,
    ! [VarCurr: state_type] :
      ( v99199(VarCurr,1)
    <=> v99200(VarCurr) ) ).

tff(addAssignment_60446,axiom,
    ! [VarCurr: state_type] :
      ( v99200(VarCurr)
    <=> v99201(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_576,axiom,
    ! [VarCurr: state_type] :
      ( v99201(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $false )
        & ( v98812(VarCurr,1)
        <=> $true )
        & ( v98812(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_21,axiom,
    ! [VarCurr: state_type] : ~ v99195(VarCurr,2) ).

tff(addAssignment_60445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v99195(VarCurr,B)
      <=> v99196(VarCurr,B) ) ) ).

tff(addAssignment_60444,axiom,
    ! [VarCurr: state_type] :
      ( v99196(VarCurr,0)
    <=> v99197(VarCurr) ) ).

tff(addAssignment_60443,axiom,
    ! [VarCurr: state_type] :
      ( v99196(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_575,axiom,
    ! [VarCurr: state_type] :
      ( v99197(VarCurr)
    <=> ( ( v98812(VarCurr,3)
        <=> $false )
        & ( v98812(VarCurr,2)
        <=> $false )
        & ( v98812(VarCurr,1)
        <=> $false )
        & ( v98812(VarCurr,0)
        <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99038(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98812(VarCurr,B)
          <=> v99115(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_638,axiom,
    ! [VarCurr: state_type] :
      ( v99038(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98812(VarCurr,B)
          <=> v99066(VarCurr,B) ) ) ) ).

tff(addAssignment_60442,axiom,
    ! [VarCurr: state_type] :
      ( v99115(VarCurr,0)
    <=> v99179(VarCurr) ) ).

tff(addAssignment_60441,axiom,
    ! [VarCurr: state_type] :
      ( v99115(VarCurr,1)
    <=> v99177(VarCurr) ) ).

tff(addAssignment_60440,axiom,
    ! [VarCurr: state_type] :
      ( v99115(VarCurr,2)
    <=> v99172(VarCurr) ) ).

tff(addAssignment_60439,axiom,
    ! [VarCurr: state_type] :
      ( v99115(VarCurr,3)
    <=> v99117(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9219,axiom,
    ! [VarCurr: state_type] :
      ( v99177(VarCurr)
    <=> ( v99178(VarCurr)
        & v99181(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3802,axiom,
    ! [VarCurr: state_type] :
      ( v99181(VarCurr)
    <=> ( v99122(VarCurr,0)
        | v99122(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9218,axiom,
    ! [VarCurr: state_type] :
      ( v99178(VarCurr)
    <=> ( v99179(VarCurr)
        | v99180(VarCurr) ) ) ).

tff(writeUnaryOperator_4649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99180(VarCurr)
    <=> v99122(VarCurr,1) ) ).

tff(writeUnaryOperator_4648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99179(VarCurr)
    <=> v99122(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9217,axiom,
    ! [VarCurr: state_type] :
      ( v99172(VarCurr)
    <=> ( v99173(VarCurr)
        & v99176(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3801,axiom,
    ! [VarCurr: state_type] :
      ( v99176(VarCurr)
    <=> ( v99121(VarCurr)
        | v99122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9216,axiom,
    ! [VarCurr: state_type] :
      ( v99173(VarCurr)
    <=> ( v99174(VarCurr)
        | v99175(VarCurr) ) ) ).

tff(writeUnaryOperator_4647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99175(VarCurr)
    <=> v99122(VarCurr,2) ) ).

tff(writeUnaryOperator_4646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99174(VarCurr)
    <=> v99121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9215,axiom,
    ! [VarCurr: state_type] :
      ( v99117(VarCurr)
    <=> ( v99118(VarCurr)
        & v99171(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3800,axiom,
    ! [VarCurr: state_type] :
      ( v99171(VarCurr)
    <=> ( v99120(VarCurr)
        | v99122(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9214,axiom,
    ! [VarCurr: state_type] :
      ( v99118(VarCurr)
    <=> ( v99119(VarCurr)
        | v99170(VarCurr) ) ) ).

tff(writeUnaryOperator_4645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99170(VarCurr)
    <=> v99122(VarCurr,3) ) ).

tff(writeUnaryOperator_4644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99119(VarCurr)
    <=> v99120(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3799,axiom,
    ! [VarCurr: state_type] :
      ( v99120(VarCurr)
    <=> ( v99121(VarCurr)
        & v99122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3798,axiom,
    ! [VarCurr: state_type] :
      ( v99121(VarCurr)
    <=> ( v99122(VarCurr,0)
        & v99122(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99122(VarCurr,B)
      <=> ~ v99123(VarCurr,B) ) ) ).

tff(addAssignment_60438,axiom,
    ! [VarCurr: state_type] :
      ( v99123(VarCurr,0)
    <=> v99112(VarCurr) ) ).

tff(addAssignment_60437,axiom,
    ! [VarCurr: state_type] :
      ( v99123(VarCurr,1)
    <=> v99166(VarCurr) ) ).

tff(addAssignment_60436,axiom,
    ! [VarCurr: state_type] :
      ( v99123(VarCurr,2)
    <=> v99161(VarCurr) ) ).

tff(addAssignment_60435,axiom,
    ! [VarCurr: state_type] :
      ( v99123(VarCurr,3)
    <=> v99125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9213,axiom,
    ! [VarCurr: state_type] :
      ( v99166(VarCurr)
    <=> ( v99167(VarCurr)
        & v99169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9212,axiom,
    ! [VarCurr: state_type] :
      ( v99169(VarCurr)
    <=> ( v99075(VarCurr)
        | v99132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9211,axiom,
    ! [VarCurr: state_type] :
      ( v99167(VarCurr)
    <=> ( v99109(VarCurr)
        | v99168(VarCurr) ) ) ).

tff(writeUnaryOperator_4642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99168(VarCurr)
    <=> v99132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9210,axiom,
    ! [VarCurr: state_type] :
      ( v99161(VarCurr)
    <=> ( v99162(VarCurr)
        & v99165(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9209,axiom,
    ! [VarCurr: state_type] :
      ( v99165(VarCurr)
    <=> ( v99130(VarCurr)
        | v99140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9208,axiom,
    ! [VarCurr: state_type] :
      ( v99162(VarCurr)
    <=> ( v99163(VarCurr)
        | v99164(VarCurr) ) ) ).

tff(writeUnaryOperator_4641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99164(VarCurr)
    <=> v99140(VarCurr) ) ).

tff(writeUnaryOperator_4640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99163(VarCurr)
    <=> v99130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9207,axiom,
    ! [VarCurr: state_type] :
      ( v99125(VarCurr)
    <=> ( v99126(VarCurr)
        & v99160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9206,axiom,
    ! [VarCurr: state_type] :
      ( v99160(VarCurr)
    <=> ( v99128(VarCurr)
        | v99151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9205,axiom,
    ! [VarCurr: state_type] :
      ( v99126(VarCurr)
    <=> ( v99127(VarCurr)
        | v99150(VarCurr) ) ) ).

tff(writeUnaryOperator_4639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99150(VarCurr)
    <=> v99151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9204,axiom,
    ! [VarCurr: state_type] :
      ( v99151(VarCurr)
    <=> ( v99152(VarCurr)
        & v99159(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3797,axiom,
    ! [VarCurr: state_type] :
      ( v99159(VarCurr)
    <=> ( v98962(VarCurr,3)
        | v99154(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9203,axiom,
    ! [VarCurr: state_type] :
      ( v99152(VarCurr)
    <=> ( v98990(VarCurr)
        | v99153(VarCurr) ) ) ).

tff(writeUnaryOperator_4638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99153(VarCurr)
    <=> v99154(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9202,axiom,
    ! [VarCurr: state_type] :
      ( v99154(VarCurr)
    <=> ( v99155(VarCurr)
        & v99158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9201,axiom,
    ! [VarCurr: state_type] :
      ( v99158(VarCurr)
    <=> ( v99063(VarCurr)
        | v99157(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3796,axiom,
    ! [VarCurr: state_type] :
      ( v99155(VarCurr)
    <=> ( v98814(VarCurr,3)
        | v99156(VarCurr) ) ) ).

tff(writeUnaryOperator_4637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99156(VarCurr)
    <=> v99157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9200,axiom,
    ! [VarCurr: state_type] :
      ( v99157(VarCurr)
    <=> ( v99057(VarCurr)
        & v99146(VarCurr) ) ) ).

tff(writeUnaryOperator_4636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99127(VarCurr)
    <=> v99128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9199,axiom,
    ! [VarCurr: state_type] :
      ( v99128(VarCurr)
    <=> ( v99129(VarCurr)
        | v99149(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3795,axiom,
    ! [VarCurr: state_type] :
      ( v99149(VarCurr)
    <=> ( v98962(VarCurr,2)
        & v99143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9198,axiom,
    ! [VarCurr: state_type] :
      ( v99129(VarCurr)
    <=> ( v99130(VarCurr)
        & v99140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9197,axiom,
    ! [VarCurr: state_type] :
      ( v99140(VarCurr)
    <=> ( v99141(VarCurr)
        & v99148(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3794,axiom,
    ! [VarCurr: state_type] :
      ( v99148(VarCurr)
    <=> ( v98962(VarCurr,2)
        | v99143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9196,axiom,
    ! [VarCurr: state_type] :
      ( v99141(VarCurr)
    <=> ( v98995(VarCurr)
        | v99142(VarCurr) ) ) ).

tff(writeUnaryOperator_4635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99142(VarCurr)
    <=> v99143(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9195,axiom,
    ! [VarCurr: state_type] :
      ( v99143(VarCurr)
    <=> ( v99144(VarCurr)
        & v99147(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9194,axiom,
    ! [VarCurr: state_type] :
      ( v99147(VarCurr)
    <=> ( v99057(VarCurr)
        | v99146(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3793,axiom,
    ! [VarCurr: state_type] :
      ( v99144(VarCurr)
    <=> ( v98814(VarCurr,2)
        | v99145(VarCurr) ) ) ).

tff(writeUnaryOperator_4634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99145(VarCurr)
    <=> v99146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9193,axiom,
    ! [VarCurr: state_type] :
      ( v99146(VarCurr)
    <=> ( v99047(VarCurr)
        & v99051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9192,axiom,
    ! [VarCurr: state_type] :
      ( v99130(VarCurr)
    <=> ( v99131(VarCurr)
        | v99139(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3792,axiom,
    ! [VarCurr: state_type] :
      ( v99139(VarCurr)
    <=> ( v98962(VarCurr,1)
        & v99135(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9191,axiom,
    ! [VarCurr: state_type] :
      ( v99131(VarCurr)
    <=> ( v99075(VarCurr)
        & v99132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9190,axiom,
    ! [VarCurr: state_type] :
      ( v99132(VarCurr)
    <=> ( v99133(VarCurr)
        & v99138(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3791,axiom,
    ! [VarCurr: state_type] :
      ( v99138(VarCurr)
    <=> ( v98962(VarCurr,1)
        | v99135(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9189,axiom,
    ! [VarCurr: state_type] :
      ( v99133(VarCurr)
    <=> ( v99000(VarCurr)
        | v99134(VarCurr) ) ) ).

tff(writeUnaryOperator_4633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99134(VarCurr)
    <=> v99135(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9188,axiom,
    ! [VarCurr: state_type] :
      ( v99135(VarCurr)
    <=> ( v99136(VarCurr)
        & v99137(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9187,axiom,
    ! [VarCurr: state_type] :
      ( v99137(VarCurr)
    <=> ( v99047(VarCurr)
        | v99051(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3790,axiom,
    ! [VarCurr: state_type] :
      ( v99136(VarCurr)
    <=> ( v98814(VarCurr,0)
        | v98814(VarCurr,1) ) ) ).

tff(addAssignment_60434,axiom,
    ! [VarCurr: state_type] :
      ( v99066(VarCurr,0)
    <=> v99112(VarCurr) ) ).

tff(addAssignment_60433,axiom,
    ! [VarCurr: state_type] :
      ( v99066(VarCurr,1)
    <=> v99107(VarCurr) ) ).

tff(addAssignment_60432,axiom,
    ! [VarCurr: state_type] :
      ( v99066(VarCurr,2)
    <=> v99102(VarCurr) ) ).

tff(addAssignment_60431,axiom,
    ! [VarCurr: state_type] :
      ( v99066(VarCurr,3)
    <=> v99068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9186,axiom,
    ! [VarCurr: state_type] :
      ( v99112(VarCurr)
    <=> ( v99113(VarCurr)
        & v99114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9185,axiom,
    ! [VarCurr: state_type] :
      ( v99114(VarCurr)
    <=> ( v98962(VarCurr,0)
        | v98814(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9184,axiom,
    ! [VarCurr: state_type] :
      ( v99113(VarCurr)
    <=> ( v98999(VarCurr)
        | v99047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9183,axiom,
    ! [VarCurr: state_type] :
      ( v99107(VarCurr)
    <=> ( v99108(VarCurr)
        & v99111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9182,axiom,
    ! [VarCurr: state_type] :
      ( v99111(VarCurr)
    <=> ( v99075(VarCurr)
        | v99076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9181,axiom,
    ! [VarCurr: state_type] :
      ( v99108(VarCurr)
    <=> ( v99109(VarCurr)
        | v99110(VarCurr) ) ) ).

tff(writeUnaryOperator_4632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99110(VarCurr)
    <=> v99076(VarCurr) ) ).

tff(writeUnaryOperator_4631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99109(VarCurr)
    <=> v99075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9180,axiom,
    ! [VarCurr: state_type] :
      ( v99102(VarCurr)
    <=> ( v99103(VarCurr)
        & v99106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9179,axiom,
    ! [VarCurr: state_type] :
      ( v99106(VarCurr)
    <=> ( v99073(VarCurr)
        | v99081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9178,axiom,
    ! [VarCurr: state_type] :
      ( v99103(VarCurr)
    <=> ( v99104(VarCurr)
        | v99105(VarCurr) ) ) ).

tff(writeUnaryOperator_4630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99105(VarCurr)
    <=> v99081(VarCurr) ) ).

tff(writeUnaryOperator_4629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99104(VarCurr)
    <=> v99073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9177,axiom,
    ! [VarCurr: state_type] :
      ( v99068(VarCurr)
    <=> ( v99069(VarCurr)
        & v99101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9176,axiom,
    ! [VarCurr: state_type] :
      ( v99101(VarCurr)
    <=> ( v99071(VarCurr)
        | v99092(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9175,axiom,
    ! [VarCurr: state_type] :
      ( v99069(VarCurr)
    <=> ( v99070(VarCurr)
        | v99091(VarCurr) ) ) ).

tff(writeUnaryOperator_4628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99091(VarCurr)
    <=> v99092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9174,axiom,
    ! [VarCurr: state_type] :
      ( v99092(VarCurr)
    <=> ( v99093(VarCurr)
        & v99100(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3789,axiom,
    ! [VarCurr: state_type] :
      ( v99100(VarCurr)
    <=> ( v98814(VarCurr,3)
        | v99095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9173,axiom,
    ! [VarCurr: state_type] :
      ( v99093(VarCurr)
    <=> ( v99063(VarCurr)
        | v99094(VarCurr) ) ) ).

tff(writeUnaryOperator_4627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99094(VarCurr)
    <=> v99095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9172,axiom,
    ! [VarCurr: state_type] :
      ( v99095(VarCurr)
    <=> ( v99096(VarCurr)
        & v99099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9171,axiom,
    ! [VarCurr: state_type] :
      ( v99099(VarCurr)
    <=> ( v98990(VarCurr)
        | v99098(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3788,axiom,
    ! [VarCurr: state_type] :
      ( v99096(VarCurr)
    <=> ( v98962(VarCurr,3)
        | v99097(VarCurr) ) ) ).

tff(writeUnaryOperator_4626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99097(VarCurr)
    <=> v99098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9170,axiom,
    ! [VarCurr: state_type] :
      ( v99098(VarCurr)
    <=> ( v98995(VarCurr)
        & v99087(VarCurr) ) ) ).

tff(writeUnaryOperator_4625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99070(VarCurr)
    <=> v99071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9169,axiom,
    ! [VarCurr: state_type] :
      ( v99071(VarCurr)
    <=> ( v99072(VarCurr)
        | v99090(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3787,axiom,
    ! [VarCurr: state_type] :
      ( v99090(VarCurr)
    <=> ( v98814(VarCurr,2)
        & v99084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9168,axiom,
    ! [VarCurr: state_type] :
      ( v99072(VarCurr)
    <=> ( v99073(VarCurr)
        & v99081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9167,axiom,
    ! [VarCurr: state_type] :
      ( v99081(VarCurr)
    <=> ( v99082(VarCurr)
        & v99089(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3786,axiom,
    ! [VarCurr: state_type] :
      ( v99089(VarCurr)
    <=> ( v98814(VarCurr,2)
        | v99084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9166,axiom,
    ! [VarCurr: state_type] :
      ( v99082(VarCurr)
    <=> ( v99057(VarCurr)
        | v99083(VarCurr) ) ) ).

tff(writeUnaryOperator_4624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99083(VarCurr)
    <=> v99084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9165,axiom,
    ! [VarCurr: state_type] :
      ( v99084(VarCurr)
    <=> ( v99085(VarCurr)
        & v99088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9164,axiom,
    ! [VarCurr: state_type] :
      ( v99088(VarCurr)
    <=> ( v98995(VarCurr)
        | v99087(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3785,axiom,
    ! [VarCurr: state_type] :
      ( v99085(VarCurr)
    <=> ( v98962(VarCurr,2)
        | v99086(VarCurr) ) ) ).

tff(writeUnaryOperator_4623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99086(VarCurr)
    <=> v99087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9163,axiom,
    ! [VarCurr: state_type] :
      ( v99087(VarCurr)
    <=> ( v98999(VarCurr)
        & v99000(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9162,axiom,
    ! [VarCurr: state_type] :
      ( v99073(VarCurr)
    <=> ( v99074(VarCurr)
        | v99080(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3784,axiom,
    ! [VarCurr: state_type] :
      ( v99080(VarCurr)
    <=> ( v98997(VarCurr)
        & v98814(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9161,axiom,
    ! [VarCurr: state_type] :
      ( v99074(VarCurr)
    <=> ( v99075(VarCurr)
        & v99076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9160,axiom,
    ! [VarCurr: state_type] :
      ( v99076(VarCurr)
    <=> ( v99077(VarCurr)
        & v99079(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3783,axiom,
    ! [VarCurr: state_type] :
      ( v99079(VarCurr)
    <=> ( v98997(VarCurr)
        | v98814(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9159,axiom,
    ! [VarCurr: state_type] :
      ( v99077(VarCurr)
    <=> ( v99078(VarCurr)
        | v99051(VarCurr) ) ) ).

tff(writeUnaryOperator_4622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99078(VarCurr)
    <=> v98997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9158,axiom,
    ! [VarCurr: state_type] :
      ( v99075(VarCurr)
    <=> ( v98962(VarCurr,0)
        & v98814(VarCurr,0) ) ) ).

tff(writeUnaryOperator_4621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99038(VarCurr)
    <=> v99040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9157,axiom,
    ! [VarCurr: state_type] :
      ( v99040(VarCurr)
    <=> ( v99041(VarCurr)
        | v99065(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3782,axiom,
    ! [VarCurr: state_type] :
      ( v99065(VarCurr)
    <=> ( v98962(VarCurr,3)
        & v99063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9156,axiom,
    ! [VarCurr: state_type] :
      ( v99041(VarCurr)
    <=> ( v99042(VarCurr)
        & v99060(VarCurr) ) ) ).

tff(writeUnaryOperator_4620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99060(VarCurr)
    <=> v99061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9155,axiom,
    ! [VarCurr: state_type] :
      ( v99061(VarCurr)
    <=> ( v99062(VarCurr)
        & v99064(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3781,axiom,
    ! [VarCurr: state_type] :
      ( v99064(VarCurr)
    <=> ( v98962(VarCurr,3)
        | v98814(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9154,axiom,
    ! [VarCurr: state_type] :
      ( v99062(VarCurr)
    <=> ( v98990(VarCurr)
        | v99063(VarCurr) ) ) ).

tff(writeUnaryOperator_4619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99063(VarCurr)
    <=> v98814(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9153,axiom,
    ! [VarCurr: state_type] :
      ( v99042(VarCurr)
    <=> ( v99043(VarCurr)
        | v99059(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3780,axiom,
    ! [VarCurr: state_type] :
      ( v99059(VarCurr)
    <=> ( v98962(VarCurr,2)
        & v99057(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9152,axiom,
    ! [VarCurr: state_type] :
      ( v99043(VarCurr)
    <=> ( v99044(VarCurr)
        & v99054(VarCurr) ) ) ).

tff(writeUnaryOperator_4618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99054(VarCurr)
    <=> v99055(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9151,axiom,
    ! [VarCurr: state_type] :
      ( v99055(VarCurr)
    <=> ( v99056(VarCurr)
        & v99058(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3779,axiom,
    ! [VarCurr: state_type] :
      ( v99058(VarCurr)
    <=> ( v98962(VarCurr,2)
        | v98814(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9150,axiom,
    ! [VarCurr: state_type] :
      ( v99056(VarCurr)
    <=> ( v98995(VarCurr)
        | v99057(VarCurr) ) ) ).

tff(writeUnaryOperator_4617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99057(VarCurr)
    <=> v98814(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9149,axiom,
    ! [VarCurr: state_type] :
      ( v99044(VarCurr)
    <=> ( v99045(VarCurr)
        | v99053(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3778,axiom,
    ! [VarCurr: state_type] :
      ( v99053(VarCurr)
    <=> ( v98962(VarCurr,1)
        & v99051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9148,axiom,
    ! [VarCurr: state_type] :
      ( v99045(VarCurr)
    <=> ( v99046(VarCurr)
        & v99048(VarCurr) ) ) ).

tff(writeUnaryOperator_4616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99048(VarCurr)
    <=> v99049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9147,axiom,
    ! [VarCurr: state_type] :
      ( v99049(VarCurr)
    <=> ( v99050(VarCurr)
        & v99052(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3777,axiom,
    ! [VarCurr: state_type] :
      ( v99052(VarCurr)
    <=> ( v98962(VarCurr,1)
        | v98814(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9146,axiom,
    ! [VarCurr: state_type] :
      ( v99050(VarCurr)
    <=> ( v99000(VarCurr)
        | v99051(VarCurr) ) ) ).

tff(writeUnaryOperator_4615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99051(VarCurr)
    <=> v98814(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9145,axiom,
    ! [VarCurr: state_type] :
      ( v99046(VarCurr)
    <=> ( v98962(VarCurr,0)
        & v99047(VarCurr) ) ) ).

tff(writeUnaryOperator_4614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99047(VarCurr)
    <=> v98814(VarCurr,0) ) ).

tff(addAssignment_60430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98962(VarCurr,B)
      <=> v98964(VarCurr,B) ) ) ).

tff(addAssignment_60429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98964(VarCurr,B)
      <=> v98966(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99021(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v98966(VarNext,B)
            <=> v98966(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1134,axiom,
    ! [VarNext: state_type] :
      ( v99021(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98966(VarNext,B)
          <=> v99031(VarNext,B) ) ) ) ).

tff(addAssignment_60428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99031(VarNext,B)
          <=> v99029(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99032(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99029(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_637,axiom,
    ! [VarCurr: state_type] :
      ( v99032(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v99029(VarCurr,B)
          <=> v98976(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9144,axiom,
    ! [VarCurr: state_type] :
      ( v99032(VarCurr)
    <=> ( v99033(VarCurr)
        & v99034(VarCurr) ) ) ).

tff(writeUnaryOperator_4613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99034(VarCurr)
    <=> v98972(VarCurr) ) ).

tff(writeUnaryOperator_4612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99033(VarCurr)
    <=> v98968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99021(VarNext)
      <=> v99022(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99022(VarNext)
      <=> ( v99023(VarNext)
          & v99016(VarNext) ) ) ) ).

tff(writeUnaryOperator_4611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v99023(VarNext)
      <=> v99025(VarNext) ) ) ).

tff(addAssignment_60427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v99025(VarNext)
      <=> v99016(VarCurr) ) ) ).

tff(addAssignment_60426,axiom,
    ! [VarCurr: state_type] :
      ( v99016(VarCurr)
    <=> v99018(VarCurr) ) ).

tff(addAssignment_60425,axiom,
    ! [VarCurr: state_type] :
      ( v99018(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_60424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98976(VarCurr,B)
      <=> v98978(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98978(VarCurr,B)
      <=> ( v99008(VarCurr,B)
          | v99011(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99011(VarCurr,B)
      <=> ( v98964(VarCurr,B)
          & v99012(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99012(VarCurr,B)
      <=> ~ v99013(VarCurr,B) ) ) ).

tff(addAssignment_60423,axiom,
    ! [VarCurr: state_type] :
      ( v99013(VarCurr,0)
    <=> v99014(VarCurr) ) ).

tff(addAssignment_60422,axiom,
    ! [VarCurr: state_type] :
      ( v99013(VarCurr,1)
    <=> v99014(VarCurr) ) ).

tff(addAssignment_60421,axiom,
    ! [VarCurr: state_type] :
      ( v99013(VarCurr,2)
    <=> v99014(VarCurr) ) ).

tff(addAssignment_60420,axiom,
    ! [VarCurr: state_type] :
      ( v99013(VarCurr,3)
    <=> v99014(VarCurr) ) ).

tff(addAssignment_60419,axiom,
    ! [VarCurr: state_type] :
      ( v99014(VarCurr)
    <=> v99003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v99008(VarCurr,B)
      <=> ( v98980(VarCurr,B)
          & v99009(VarCurr,B) ) ) ) ).

tff(addAssignment_60418,axiom,
    ! [VarCurr: state_type] :
      ( v99009(VarCurr,0)
    <=> v99010(VarCurr) ) ).

tff(addAssignment_60417,axiom,
    ! [VarCurr: state_type] :
      ( v99009(VarCurr,1)
    <=> v99010(VarCurr) ) ).

tff(addAssignment_60416,axiom,
    ! [VarCurr: state_type] :
      ( v99009(VarCurr,2)
    <=> v99010(VarCurr) ) ).

tff(addAssignment_60415,axiom,
    ! [VarCurr: state_type] :
      ( v99009(VarCurr,3)
    <=> v99010(VarCurr) ) ).

tff(addAssignment_60414,axiom,
    ! [VarCurr: state_type] :
      ( v99010(VarCurr)
    <=> v99003(VarCurr) ) ).

tff(addAssignment_60413,axiom,
    ! [VarCurr: state_type] :
      ( v99003(VarCurr)
    <=> v99005(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3776,axiom,
    ! [VarCurr: state_type] :
      ( v99005(VarCurr)
    <=> ( v98701(VarCurr)
        | v98681(VarCurr,7) ) ) ).

tff(addAssignment_60412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98980(VarCurr,B)
      <=> v98982(VarCurr,B) ) ) ).

tff(addAssignment_60411,axiom,
    ! [VarCurr: state_type] :
      ( v98982(VarCurr,0)
    <=> v98999(VarCurr) ) ).

tff(addAssignment_60410,axiom,
    ! [VarCurr: state_type] :
      ( v98982(VarCurr,1)
    <=> v98997(VarCurr) ) ).

tff(addAssignment_60409,axiom,
    ! [VarCurr: state_type] :
      ( v98982(VarCurr,2)
    <=> v98992(VarCurr) ) ).

tff(addAssignment_60408,axiom,
    ! [VarCurr: state_type] :
      ( v98982(VarCurr,3)
    <=> v98985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9141,axiom,
    ! [VarCurr: state_type] :
      ( v98997(VarCurr)
    <=> ( v98998(VarCurr)
        & v99001(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3775,axiom,
    ! [VarCurr: state_type] :
      ( v99001(VarCurr)
    <=> ( v98962(VarCurr,0)
        | v98962(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9140,axiom,
    ! [VarCurr: state_type] :
      ( v98998(VarCurr)
    <=> ( v98999(VarCurr)
        | v99000(VarCurr) ) ) ).

tff(writeUnaryOperator_4609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v99000(VarCurr)
    <=> v98962(VarCurr,1) ) ).

tff(writeUnaryOperator_4608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98999(VarCurr)
    <=> v98962(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9139,axiom,
    ! [VarCurr: state_type] :
      ( v98992(VarCurr)
    <=> ( v98993(VarCurr)
        & v98996(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3774,axiom,
    ! [VarCurr: state_type] :
      ( v98996(VarCurr)
    <=> ( v98989(VarCurr)
        | v98962(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9138,axiom,
    ! [VarCurr: state_type] :
      ( v98993(VarCurr)
    <=> ( v98994(VarCurr)
        | v98995(VarCurr) ) ) ).

tff(writeUnaryOperator_4607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98995(VarCurr)
    <=> v98962(VarCurr,2) ) ).

tff(writeUnaryOperator_4606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98994(VarCurr)
    <=> v98989(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9137,axiom,
    ! [VarCurr: state_type] :
      ( v98985(VarCurr)
    <=> ( v98986(VarCurr)
        & v98991(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3773,axiom,
    ! [VarCurr: state_type] :
      ( v98991(VarCurr)
    <=> ( v98988(VarCurr)
        | v98962(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9136,axiom,
    ! [VarCurr: state_type] :
      ( v98986(VarCurr)
    <=> ( v98987(VarCurr)
        | v98990(VarCurr) ) ) ).

tff(writeUnaryOperator_4605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98990(VarCurr)
    <=> v98962(VarCurr,3) ) ).

tff(writeUnaryOperator_4604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98987(VarCurr)
    <=> v98988(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3772,axiom,
    ! [VarCurr: state_type] :
      ( v98988(VarCurr)
    <=> ( v98989(VarCurr)
        & v98962(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3771,axiom,
    ! [VarCurr: state_type] :
      ( v98989(VarCurr)
    <=> ( v98962(VarCurr,0)
        & v98962(VarCurr,1) ) ) ).

tff(addAssignment_60407,axiom,
    ! [VarCurr: state_type] :
      ( v98972(VarCurr)
    <=> v98974(VarCurr) ) ).

tff(addAssignment_60406,axiom,
    ! [VarCurr: state_type] :
      ( v98974(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_60405,axiom,
    ! [VarCurr: state_type] :
      ( v98968(VarCurr)
    <=> v98970(VarCurr) ) ).

tff(addAssignment_60404,axiom,
    ! [VarCurr: state_type] :
      ( v98970(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_60403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98814(VarCurr,B)
      <=> v2944(VarCurr,B) ) ) ).

tff(addAssignment_60402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2944(VarCurr,B)
      <=> v2946(VarCurr,B) ) ) ).

tff(addAssignment_60401,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2946(VarNext,B)
      <=> v98954(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98955(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v98954(VarNext,B)
            <=> v2946(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1133,axiom,
    ! [VarNext: state_type] :
      ( v98955(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v98954(VarNext,B)
          <=> v3911(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98955(VarNext)
      <=> v98956(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98956(VarNext)
      <=> ( v98958(VarNext)
          & v3894(VarNext) ) ) ) ).

tff(writeUnaryOperator_4603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98958(VarNext)
      <=> v3905(VarNext) ) ) ).

tff(addAssignment_60400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2956(VarCurr,B)
      <=> v2958(VarCurr,B) ) ) ).

tff(addAssignment_60399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2958(VarCurr,B)
      <=> v2960(VarCurr,B) ) ) ).

tff(addAssignment_60398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2960(VarCurr,B)
      <=> v3890(VarCurr,B) ) ) ).

tff(addAssignment_60397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v3892(VarCurr,B)
      <=> v98817(VarCurr,B) ) ) ).

tff(addAssignment_60396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98817(VarCurr,B)
      <=> v98819(VarCurr,B) ) ) ).

tff(addAssignment_60395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98819(VarCurr,B)
      <=> v98821(VarCurr,B) ) ) ).

tff(addAssignment_60394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98821(VarCurr,B)
      <=> v98823(VarCurr,B) ) ) ).

tff(addAssignment_60393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98823(VarCurr,B)
      <=> v98825(VarCurr,B) ) ) ).

tff(addAssignment_60392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98825(VarCurr,B)
      <=> v98827(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98937(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v98827(VarNext,B)
            <=> v98827(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1132,axiom,
    ! [VarNext: state_type] :
      ( v98937(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98827(VarNext,B)
          <=> v98947(VarNext,B) ) ) ) ).

tff(addAssignment_60391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98947(VarNext,B)
          <=> v98945(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98948(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98945(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_636,axiom,
    ! [VarCurr: state_type] :
      ( v98948(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98945(VarCurr,B)
          <=> v98837(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9133,axiom,
    ! [VarCurr: state_type] :
      ( v98948(VarCurr)
    <=> ( v98949(VarCurr)
        & v98950(VarCurr) ) ) ).

tff(writeUnaryOperator_4602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98950(VarCurr)
    <=> v98833(VarCurr) ) ).

tff(writeUnaryOperator_4601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98949(VarCurr)
    <=> v98829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98937(VarNext)
      <=> v98938(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98938(VarNext)
      <=> ( v98939(VarNext)
          & v98932(VarNext) ) ) ) ).

tff(writeUnaryOperator_4600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98939(VarNext)
      <=> v98941(VarNext) ) ) ).

tff(addAssignment_60390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98941(VarNext)
      <=> v98932(VarCurr) ) ) ).

tff(addAssignment_60389,axiom,
    ! [VarCurr: state_type] :
      ( v98932(VarCurr)
    <=> v98934(VarCurr) ) ).

tff(addAssignment_60388,axiom,
    ! [VarCurr: state_type] :
      ( v98934(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_60387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98837(VarCurr,B)
      <=> v98839(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98839(VarCurr,B)
      <=> ( v98924(VarCurr,B)
          | v98927(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98927(VarCurr,B)
      <=> ( v98825(VarCurr,B)
          & v98928(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98928(VarCurr,B)
      <=> ~ v98929(VarCurr,B) ) ) ).

tff(addAssignment_60386,axiom,
    ! [VarCurr: state_type] :
      ( v98929(VarCurr,0)
    <=> v98930(VarCurr) ) ).

tff(addAssignment_60385,axiom,
    ! [VarCurr: state_type] :
      ( v98929(VarCurr,1)
    <=> v98930(VarCurr) ) ).

tff(addAssignment_60384,axiom,
    ! [VarCurr: state_type] :
      ( v98929(VarCurr,2)
    <=> v98930(VarCurr) ) ).

tff(addAssignment_60383,axiom,
    ! [VarCurr: state_type] :
      ( v98929(VarCurr,3)
    <=> v98930(VarCurr) ) ).

tff(addAssignment_60382,axiom,
    ! [VarCurr: state_type] :
      ( v98930(VarCurr)
    <=> v98922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98924(VarCurr,B)
      <=> ( v98841(VarCurr,B)
          & v98925(VarCurr,B) ) ) ) ).

tff(addAssignment_60381,axiom,
    ! [VarCurr: state_type] :
      ( v98925(VarCurr,0)
    <=> v98926(VarCurr) ) ).

tff(addAssignment_60380,axiom,
    ! [VarCurr: state_type] :
      ( v98925(VarCurr,1)
    <=> v98926(VarCurr) ) ).

tff(addAssignment_60379,axiom,
    ! [VarCurr: state_type] :
      ( v98925(VarCurr,2)
    <=> v98926(VarCurr) ) ).

tff(addAssignment_60378,axiom,
    ! [VarCurr: state_type] :
      ( v98925(VarCurr,3)
    <=> v98926(VarCurr) ) ).

tff(addAssignment_60377,axiom,
    ! [VarCurr: state_type] :
      ( v98926(VarCurr)
    <=> v98922(VarCurr) ) ).

tff(addAssignment_60376,axiom,
    ! [VarCurr: state_type] :
      ( v98922(VarCurr)
    <=> v3799(VarCurr) ) ).

tff(addAssignment_60375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98841(VarCurr,B)
      <=> v98843(VarCurr,B) ) ) ).

tff(addAssignment_60374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98843(VarCurr,B)
      <=> v98845(VarCurr,B) ) ) ).

tff(addAssignment_60373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98845(VarCurr,B)
      <=> v98847(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98905(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v98847(VarNext,B)
            <=> v98847(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1131,axiom,
    ! [VarNext: state_type] :
      ( v98905(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98847(VarNext,B)
          <=> v98915(VarNext,B) ) ) ) ).

tff(addAssignment_60372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98915(VarNext,B)
          <=> v98913(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98916(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98913(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_635,axiom,
    ! [VarCurr: state_type] :
      ( v98916(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98913(VarCurr,B)
          <=> v98857(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9130,axiom,
    ! [VarCurr: state_type] :
      ( v98916(VarCurr)
    <=> ( v98917(VarCurr)
        & v98918(VarCurr) ) ) ).

tff(writeUnaryOperator_4598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98918(VarCurr)
    <=> v98853(VarCurr) ) ).

tff(writeUnaryOperator_4597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98917(VarCurr)
    <=> v98849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98905(VarNext)
      <=> v98906(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98906(VarNext)
      <=> ( v98907(VarNext)
          & v98900(VarNext) ) ) ) ).

tff(writeUnaryOperator_4596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98907(VarNext)
      <=> v98909(VarNext) ) ) ).

tff(addAssignment_60371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98909(VarNext)
      <=> v98900(VarCurr) ) ) ).

tff(addAssignment_60370,axiom,
    ! [VarCurr: state_type] :
      ( v98900(VarCurr)
    <=> v98902(VarCurr) ) ).

tff(addAssignment_60369,axiom,
    ! [VarCurr: state_type] :
      ( v98902(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_60368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98857(VarCurr,B)
      <=> v98859(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98859(VarCurr,B)
      <=> ( v98892(VarCurr,B)
          | v98895(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98895(VarCurr,B)
      <=> ( v98845(VarCurr,B)
          & v98896(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98896(VarCurr,B)
      <=> ~ v98897(VarCurr,B) ) ) ).

tff(addAssignment_60367,axiom,
    ! [VarCurr: state_type] :
      ( v98897(VarCurr,0)
    <=> v98898(VarCurr) ) ).

tff(addAssignment_60366,axiom,
    ! [VarCurr: state_type] :
      ( v98897(VarCurr,1)
    <=> v98898(VarCurr) ) ).

tff(addAssignment_60365,axiom,
    ! [VarCurr: state_type] :
      ( v98897(VarCurr,2)
    <=> v98898(VarCurr) ) ).

tff(addAssignment_60364,axiom,
    ! [VarCurr: state_type] :
      ( v98897(VarCurr,3)
    <=> v98898(VarCurr) ) ).

tff(addAssignment_60363,axiom,
    ! [VarCurr: state_type] :
      ( v98898(VarCurr)
    <=> v98884(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98892(VarCurr,B)
      <=> ( v98861(VarCurr,B)
          & v98893(VarCurr,B) ) ) ) ).

tff(addAssignment_60362,axiom,
    ! [VarCurr: state_type] :
      ( v98893(VarCurr,0)
    <=> v98894(VarCurr) ) ).

tff(addAssignment_60361,axiom,
    ! [VarCurr: state_type] :
      ( v98893(VarCurr,1)
    <=> v98894(VarCurr) ) ).

tff(addAssignment_60360,axiom,
    ! [VarCurr: state_type] :
      ( v98893(VarCurr,2)
    <=> v98894(VarCurr) ) ).

tff(addAssignment_60359,axiom,
    ! [VarCurr: state_type] :
      ( v98893(VarCurr,3)
    <=> v98894(VarCurr) ) ).

tff(addAssignment_60358,axiom,
    ! [VarCurr: state_type] :
      ( v98894(VarCurr)
    <=> v98884(VarCurr) ) ).

tff(addAssignment_60357,axiom,
    ! [VarCurr: state_type] :
      ( v98884(VarCurr)
    <=> v98886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9127,axiom,
    ! [VarCurr: state_type] :
      ( v98886(VarCurr)
    <=> ( v98888(VarCurr)
        & v98890(VarCurr) ) ) ).

tff(writeUnaryOperator_4594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98890(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9126,axiom,
    ! [VarCurr: state_type] :
      ( v98888(VarCurr)
    <=> ( v3045(VarCurr)
        & v98889(VarCurr) ) ) ).

tff(writeUnaryOperator_4593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98889(VarCurr)
    <=> v3039(VarCurr) ) ).

tff(addAssignment_60356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98861(VarCurr,B)
      <=> v98863(VarCurr,B) ) ) ).

tff(addAssignment_60355,axiom,
    ! [VarCurr: state_type] :
      ( v98863(VarCurr,0)
    <=> v98880(VarCurr) ) ).

tff(addAssignment_60354,axiom,
    ! [VarCurr: state_type] :
      ( v98863(VarCurr,1)
    <=> v98878(VarCurr) ) ).

tff(addAssignment_60353,axiom,
    ! [VarCurr: state_type] :
      ( v98863(VarCurr,2)
    <=> v98873(VarCurr) ) ).

tff(addAssignment_60352,axiom,
    ! [VarCurr: state_type] :
      ( v98863(VarCurr,3)
    <=> v98866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9125,axiom,
    ! [VarCurr: state_type] :
      ( v98878(VarCurr)
    <=> ( v98879(VarCurr)
        & v98882(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3770,axiom,
    ! [VarCurr: state_type] :
      ( v98882(VarCurr)
    <=> ( v98823(VarCurr,0)
        | v98823(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9124,axiom,
    ! [VarCurr: state_type] :
      ( v98879(VarCurr)
    <=> ( v98880(VarCurr)
        | v98881(VarCurr) ) ) ).

tff(writeUnaryOperator_4592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98881(VarCurr)
    <=> v98823(VarCurr,1) ) ).

tff(writeUnaryOperator_4591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98880(VarCurr)
    <=> v98823(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9123,axiom,
    ! [VarCurr: state_type] :
      ( v98873(VarCurr)
    <=> ( v98874(VarCurr)
        & v98877(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3769,axiom,
    ! [VarCurr: state_type] :
      ( v98877(VarCurr)
    <=> ( v98870(VarCurr)
        | v98823(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9122,axiom,
    ! [VarCurr: state_type] :
      ( v98874(VarCurr)
    <=> ( v98875(VarCurr)
        | v98876(VarCurr) ) ) ).

tff(writeUnaryOperator_4590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98876(VarCurr)
    <=> v98823(VarCurr,2) ) ).

tff(writeUnaryOperator_4589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98875(VarCurr)
    <=> v98870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9121,axiom,
    ! [VarCurr: state_type] :
      ( v98866(VarCurr)
    <=> ( v98867(VarCurr)
        & v98872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3768,axiom,
    ! [VarCurr: state_type] :
      ( v98872(VarCurr)
    <=> ( v98869(VarCurr)
        | v98823(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9120,axiom,
    ! [VarCurr: state_type] :
      ( v98867(VarCurr)
    <=> ( v98868(VarCurr)
        | v98871(VarCurr) ) ) ).

tff(writeUnaryOperator_4588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98871(VarCurr)
    <=> v98823(VarCurr,3) ) ).

tff(writeUnaryOperator_4587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98868(VarCurr)
    <=> v98869(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3767,axiom,
    ! [VarCurr: state_type] :
      ( v98869(VarCurr)
    <=> ( v98870(VarCurr)
        & v98823(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3766,axiom,
    ! [VarCurr: state_type] :
      ( v98870(VarCurr)
    <=> ( v98823(VarCurr,0)
        & v98823(VarCurr,1) ) ) ).

tff(addAssignment_60351,axiom,
    ! [VarCurr: state_type] :
      ( v98853(VarCurr)
    <=> v98855(VarCurr) ) ).

tff(addAssignment_60350,axiom,
    ! [VarCurr: state_type] :
      ( v98855(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_60349,axiom,
    ! [VarCurr: state_type] :
      ( v98849(VarCurr)
    <=> v98851(VarCurr) ) ).

tff(addAssignment_60348,axiom,
    ! [VarCurr: state_type] :
      ( v98851(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_60347,axiom,
    ! [VarCurr: state_type] :
      ( v98833(VarCurr)
    <=> v98835(VarCurr) ) ).

tff(addAssignment_60346,axiom,
    ! [VarCurr: state_type] :
      ( v98835(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_60345,axiom,
    ! [VarCurr: state_type] :
      ( v98829(VarCurr)
    <=> v98831(VarCurr) ) ).

tff(addAssignment_60344,axiom,
    ! [VarCurr: state_type] :
      ( v98831(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98641(VarCurr,B)
      <=> ( v98770(VarCurr,B)
          | v98808(VarCurr,B) ) ) ) ).

tff(addAssignment_60343,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,0)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60342,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,1)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60341,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,2)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60340,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,3)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60339,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,4)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60338,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,5)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60337,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,6)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60336,axiom,
    ! [VarCurr: state_type] :
      ( v98808(VarCurr,7)
    <=> v98809(VarCurr) ) ).

tff(addAssignment_60335,axiom,
    ! [VarCurr: state_type] :
      ( v98809(VarCurr)
    <=> v98810(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_574,axiom,
    ! [VarCurr: state_type] :
      ( v98810(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $true )
        & ( v98643(VarCurr,2)
        <=> $false )
        & ( v98643(VarCurr,1)
        <=> $false )
        & ( v98643(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98770(VarCurr,B)
      <=> ( v98771(VarCurr,B)
          | v98804(VarCurr,B) ) ) ) ).

tff(addAssignment_60334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v98804(VarCurr,B)
      <=> v98805(VarCurr,B) ) ) ).

tff(addAssignment_60333,axiom,
    ! [VarCurr: state_type] :
      ( v98804(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_60332,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,0)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60331,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,1)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60330,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,2)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60329,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,3)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60328,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,4)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60327,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,5)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60326,axiom,
    ! [VarCurr: state_type] :
      ( v98805(VarCurr,6)
    <=> v98806(VarCurr) ) ).

tff(addAssignment_60325,axiom,
    ! [VarCurr: state_type] :
      ( v98806(VarCurr)
    <=> v98807(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_573,axiom,
    ! [VarCurr: state_type] :
      ( v98807(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $true )
        & ( v98643(VarCurr,1)
        <=> $true )
        & ( v98643(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_20,axiom,
    ! [VarCurr: state_type] : ~ v98771(VarCurr,7) ).

tff(addAssignment_60324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v98771(VarCurr,B)
      <=> v98772(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v98772(VarCurr,B)
      <=> ( v98773(VarCurr,B)
          | v98800(VarCurr,B) ) ) ) ).

tff(addAssignment_60323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v98800(VarCurr,B)
      <=> v98801(VarCurr,B) ) ) ).

tff(addAssignment_60322,axiom,
    ! [VarCurr: state_type] :
      ( v98800(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_60321,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,0)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60320,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,1)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60319,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,2)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60318,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,3)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60317,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,4)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60316,axiom,
    ! [VarCurr: state_type] :
      ( v98801(VarCurr,5)
    <=> v98802(VarCurr) ) ).

tff(addAssignment_60315,axiom,
    ! [VarCurr: state_type] :
      ( v98802(VarCurr)
    <=> v98803(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_572,axiom,
    ! [VarCurr: state_type] :
      ( v98803(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $true )
        & ( v98643(VarCurr,1)
        <=> $true )
        & ( v98643(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_19,axiom,
    ! [VarCurr: state_type] : ~ v98773(VarCurr,6) ).

tff(addAssignment_60314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v98773(VarCurr,B)
      <=> v98774(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v98774(VarCurr,B)
      <=> ( v98775(VarCurr,B)
          | v98796(VarCurr,B) ) ) ) ).

tff(addAssignment_60313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v98796(VarCurr,B)
      <=> v98797(VarCurr,B) ) ) ).

tff(addAssignment_60312,axiom,
    ! [VarCurr: state_type] :
      ( v98796(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_60311,axiom,
    ! [VarCurr: state_type] :
      ( v98797(VarCurr,0)
    <=> v98798(VarCurr) ) ).

tff(addAssignment_60310,axiom,
    ! [VarCurr: state_type] :
      ( v98797(VarCurr,1)
    <=> v98798(VarCurr) ) ).

tff(addAssignment_60309,axiom,
    ! [VarCurr: state_type] :
      ( v98797(VarCurr,2)
    <=> v98798(VarCurr) ) ).

tff(addAssignment_60308,axiom,
    ! [VarCurr: state_type] :
      ( v98797(VarCurr,3)
    <=> v98798(VarCurr) ) ).

tff(addAssignment_60307,axiom,
    ! [VarCurr: state_type] :
      ( v98797(VarCurr,4)
    <=> v98798(VarCurr) ) ).

tff(addAssignment_60306,axiom,
    ! [VarCurr: state_type] :
      ( v98798(VarCurr)
    <=> v98799(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_571,axiom,
    ! [VarCurr: state_type] :
      ( v98799(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $true )
        & ( v98643(VarCurr,1)
        <=> $false )
        & ( v98643(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_18,axiom,
    ! [VarCurr: state_type] : ~ v98775(VarCurr,5) ).

tff(addAssignment_60305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v98775(VarCurr,B)
      <=> v98776(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v98776(VarCurr,B)
      <=> ( v98777(VarCurr,B)
          | v98792(VarCurr,B) ) ) ) ).

tff(addAssignment_60304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98792(VarCurr,B)
      <=> v98793(VarCurr,B) ) ) ).

tff(addAssignment_60303,axiom,
    ! [VarCurr: state_type] :
      ( v98792(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_60302,axiom,
    ! [VarCurr: state_type] :
      ( v98793(VarCurr,0)
    <=> v98794(VarCurr) ) ).

tff(addAssignment_60301,axiom,
    ! [VarCurr: state_type] :
      ( v98793(VarCurr,1)
    <=> v98794(VarCurr) ) ).

tff(addAssignment_60300,axiom,
    ! [VarCurr: state_type] :
      ( v98793(VarCurr,2)
    <=> v98794(VarCurr) ) ).

tff(addAssignment_60299,axiom,
    ! [VarCurr: state_type] :
      ( v98793(VarCurr,3)
    <=> v98794(VarCurr) ) ).

tff(addAssignment_60298,axiom,
    ! [VarCurr: state_type] :
      ( v98794(VarCurr)
    <=> v98795(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_570,axiom,
    ! [VarCurr: state_type] :
      ( v98795(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $true )
        & ( v98643(VarCurr,1)
        <=> $false )
        & ( v98643(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_17,axiom,
    ! [VarCurr: state_type] : ~ v98777(VarCurr,4) ).

tff(addAssignment_60297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98777(VarCurr,B)
      <=> v98778(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98778(VarCurr,B)
      <=> ( v98779(VarCurr,B)
          | v98788(VarCurr,B) ) ) ) ).

tff(addAssignment_60296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98788(VarCurr,B)
      <=> v98789(VarCurr,B) ) ) ).

tff(addAssignment_60295,axiom,
    ! [VarCurr: state_type] :
      ( v98788(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_60294,axiom,
    ! [VarCurr: state_type] :
      ( v98789(VarCurr,0)
    <=> v98790(VarCurr) ) ).

tff(addAssignment_60293,axiom,
    ! [VarCurr: state_type] :
      ( v98789(VarCurr,1)
    <=> v98790(VarCurr) ) ).

tff(addAssignment_60292,axiom,
    ! [VarCurr: state_type] :
      ( v98789(VarCurr,2)
    <=> v98790(VarCurr) ) ).

tff(addAssignment_60291,axiom,
    ! [VarCurr: state_type] :
      ( v98790(VarCurr)
    <=> v98791(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_569,axiom,
    ! [VarCurr: state_type] :
      ( v98791(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $false )
        & ( v98643(VarCurr,1)
        <=> $true )
        & ( v98643(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_16,axiom,
    ! [VarCurr: state_type] : ~ v98779(VarCurr,3) ).

tff(addAssignment_60290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98779(VarCurr,B)
      <=> v98780(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v98780(VarCurr,B)
      <=> ( v98781(VarCurr,B)
          | v98784(VarCurr,B) ) ) ) ).

tff(addAssignment_60289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v98784(VarCurr,B)
      <=> v98785(VarCurr,B) ) ) ).

tff(addAssignment_60288,axiom,
    ! [VarCurr: state_type] :
      ( v98784(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_60287,axiom,
    ! [VarCurr: state_type] :
      ( v98785(VarCurr,0)
    <=> v98786(VarCurr) ) ).

tff(addAssignment_60286,axiom,
    ! [VarCurr: state_type] :
      ( v98785(VarCurr,1)
    <=> v98786(VarCurr) ) ).

tff(addAssignment_60285,axiom,
    ! [VarCurr: state_type] :
      ( v98786(VarCurr)
    <=> v98787(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_568,axiom,
    ! [VarCurr: state_type] :
      ( v98787(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $false )
        & ( v98643(VarCurr,1)
        <=> $true )
        & ( v98643(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_15,axiom,
    ! [VarCurr: state_type] : ~ v98781(VarCurr,2) ).

tff(addAssignment_60284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v98781(VarCurr,B)
      <=> v98782(VarCurr,B) ) ) ).

tff(addAssignment_60283,axiom,
    ! [VarCurr: state_type] :
      ( v98782(VarCurr,0)
    <=> v98783(VarCurr) ) ).

tff(addAssignment_60282,axiom,
    ! [VarCurr: state_type] :
      ( v98782(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_567,axiom,
    ! [VarCurr: state_type] :
      ( v98783(VarCurr)
    <=> ( ( v98643(VarCurr,3)
        <=> $false )
        & ( v98643(VarCurr,2)
        <=> $false )
        & ( v98643(VarCurr,1)
        <=> $false )
        & ( v98643(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_60281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98643(VarCurr,B)
      <=> v98645(VarCurr,B) ) ) ).

tff(addAssignment_60280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98645(VarCurr,B)
      <=> v98647(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98753(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v98647(VarNext,B)
            <=> v98647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1130,axiom,
    ! [VarNext: state_type] :
      ( v98753(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98647(VarNext,B)
          <=> v98763(VarNext,B) ) ) ) ).

tff(addAssignment_60279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98763(VarNext,B)
          <=> v98761(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98761(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_634,axiom,
    ! [VarCurr: state_type] :
      ( v98764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98761(VarCurr,B)
          <=> v98657(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9119,axiom,
    ! [VarCurr: state_type] :
      ( v98764(VarCurr)
    <=> ( v98765(VarCurr)
        & v98766(VarCurr) ) ) ).

tff(writeUnaryOperator_4586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98766(VarCurr)
    <=> v98653(VarCurr) ) ).

tff(writeUnaryOperator_4585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98765(VarCurr)
    <=> v98649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98753(VarNext)
      <=> v98754(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98754(VarNext)
      <=> ( v98755(VarNext)
          & v98748(VarNext) ) ) ) ).

tff(writeUnaryOperator_4584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98755(VarNext)
      <=> v98757(VarNext) ) ) ).

tff(addAssignment_60278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98757(VarNext)
      <=> v98748(VarCurr) ) ) ).

tff(addAssignment_60277,axiom,
    ! [VarCurr: state_type] :
      ( v98748(VarCurr)
    <=> v98750(VarCurr) ) ).

tff(addAssignment_60276,axiom,
    ! [VarCurr: state_type] :
      ( v98750(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_60275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98657(VarCurr,B)
      <=> v98659(VarCurr,B) ) ) ).

tff(addAssignment_60274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98659(VarCurr,B)
      <=> v98661(VarCurr,B) ) ) ).

tff(addAssignment_60273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v98661(VarCurr,B)
      <=> v98663(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98663(VarCurr,B)
          <=> v98726(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_633,axiom,
    ! [VarCurr: state_type] :
      ( v98697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98663(VarCurr,B)
          <=> v98707(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98727(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98726(VarCurr,B)
          <=> v98643(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_632,axiom,
    ! [VarCurr: state_type] :
      ( v98727(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v98726(VarCurr,B)
          <=> v98730(VarCurr,B) ) ) ) ).

tff(addAssignment_60272,axiom,
    ! [VarCurr: state_type] :
      ( v98730(VarCurr,0)
    <=> v98723(VarCurr) ) ).

tff(addAssignment_60271,axiom,
    ! [VarCurr: state_type] :
      ( v98730(VarCurr,1)
    <=> v98744(VarCurr) ) ).

tff(addAssignment_60270,axiom,
    ! [VarCurr: state_type] :
      ( v98730(VarCurr,2)
    <=> v98740(VarCurr) ) ).

tff(addAssignment_60269,axiom,
    ! [VarCurr: state_type] :
      ( v98730(VarCurr,3)
    <=> v98732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9116,axiom,
    ! [VarCurr: state_type] :
      ( v98744(VarCurr)
    <=> ( v98745(VarCurr)
        & v98746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9115,axiom,
    ! [VarCurr: state_type] :
      ( v98746(VarCurr)
    <=> ( v98643(VarCurr,0)
        | v98724(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3765,axiom,
    ! [VarCurr: state_type] :
      ( v98745(VarCurr)
    <=> ( v98723(VarCurr)
        | v98643(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9114,axiom,
    ! [VarCurr: state_type] :
      ( v98740(VarCurr)
    <=> ( v98741(VarCurr)
        & v98743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9113,axiom,
    ! [VarCurr: state_type] :
      ( v98743(VarCurr)
    <=> ( v98719(VarCurr)
        | v98737(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3764,axiom,
    ! [VarCurr: state_type] :
      ( v98741(VarCurr)
    <=> ( v98643(VarCurr,2)
        | v98742(VarCurr) ) ) ).

tff(writeUnaryOperator_4583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98742(VarCurr)
    <=> v98737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9112,axiom,
    ! [VarCurr: state_type] :
      ( v98732(VarCurr)
    <=> ( v98733(VarCurr)
        & v98739(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9111,axiom,
    ! [VarCurr: state_type] :
      ( v98739(VarCurr)
    <=> ( v98714(VarCurr)
        | v98735(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3763,axiom,
    ! [VarCurr: state_type] :
      ( v98733(VarCurr)
    <=> ( v98643(VarCurr,3)
        | v98734(VarCurr) ) ) ).

tff(writeUnaryOperator_4582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98734(VarCurr)
    <=> v98735(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3762,axiom,
    ! [VarCurr: state_type] :
      ( v98735(VarCurr)
    <=> ( v98643(VarCurr,2)
        | v98736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9110,axiom,
    ! [VarCurr: state_type] :
      ( v98736(VarCurr)
    <=> ( v98719(VarCurr)
        & v98737(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3761,axiom,
    ! [VarCurr: state_type] :
      ( v98737(VarCurr)
    <=> ( v98643(VarCurr,1)
        | v98738(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9109,axiom,
    ! [VarCurr: state_type] :
      ( v98738(VarCurr)
    <=> ( v98643(VarCurr,0)
        & v98724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9108,axiom,
    ! [VarCurr: state_type] :
      ( v98727(VarCurr)
    <=> ( v98728(VarCurr)
        & v98729(VarCurr) ) ) ).

tff(writeUnaryOperator_4581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98729(VarCurr)
    <=> v98665(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3760,axiom,
    ! [VarCurr: state_type] :
      ( v98728(VarCurr)
    <=> ( v98701(VarCurr)
        | v98681(VarCurr,7) ) ) ).

tff(addAssignment_60268,axiom,
    ! [VarCurr: state_type] :
      ( v98707(VarCurr,0)
    <=> v98723(VarCurr) ) ).

tff(addAssignment_60267,axiom,
    ! [VarCurr: state_type] :
      ( v98707(VarCurr,1)
    <=> v98721(VarCurr) ) ).

tff(addAssignment_60266,axiom,
    ! [VarCurr: state_type] :
      ( v98707(VarCurr,2)
    <=> v98716(VarCurr) ) ).

tff(addAssignment_60265,axiom,
    ! [VarCurr: state_type] :
      ( v98707(VarCurr,3)
    <=> v98709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9107,axiom,
    ! [VarCurr: state_type] :
      ( v98721(VarCurr)
    <=> ( v98722(VarCurr)
        & v98725(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3759,axiom,
    ! [VarCurr: state_type] :
      ( v98725(VarCurr)
    <=> ( v98643(VarCurr,0)
        | v98643(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9106,axiom,
    ! [VarCurr: state_type] :
      ( v98722(VarCurr)
    <=> ( v98723(VarCurr)
        | v98724(VarCurr) ) ) ).

tff(writeUnaryOperator_4580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98724(VarCurr)
    <=> v98643(VarCurr,1) ) ).

tff(writeUnaryOperator_4579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98723(VarCurr)
    <=> v98643(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9105,axiom,
    ! [VarCurr: state_type] :
      ( v98716(VarCurr)
    <=> ( v98717(VarCurr)
        & v98720(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3758,axiom,
    ! [VarCurr: state_type] :
      ( v98720(VarCurr)
    <=> ( v98713(VarCurr)
        | v98643(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9104,axiom,
    ! [VarCurr: state_type] :
      ( v98717(VarCurr)
    <=> ( v98718(VarCurr)
        | v98719(VarCurr) ) ) ).

tff(writeUnaryOperator_4578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98719(VarCurr)
    <=> v98643(VarCurr,2) ) ).

tff(writeUnaryOperator_4577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98718(VarCurr)
    <=> v98713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9103,axiom,
    ! [VarCurr: state_type] :
      ( v98709(VarCurr)
    <=> ( v98710(VarCurr)
        & v98715(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3757,axiom,
    ! [VarCurr: state_type] :
      ( v98715(VarCurr)
    <=> ( v98712(VarCurr)
        | v98643(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9102,axiom,
    ! [VarCurr: state_type] :
      ( v98710(VarCurr)
    <=> ( v98711(VarCurr)
        | v98714(VarCurr) ) ) ).

tff(writeUnaryOperator_4576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98714(VarCurr)
    <=> v98643(VarCurr,3) ) ).

tff(writeUnaryOperator_4575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98711(VarCurr)
    <=> v98712(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3756,axiom,
    ! [VarCurr: state_type] :
      ( v98712(VarCurr)
    <=> ( v98713(VarCurr)
        & v98643(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3755,axiom,
    ! [VarCurr: state_type] :
      ( v98713(VarCurr)
    <=> ( v98643(VarCurr,0)
        & v98643(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9101,axiom,
    ! [VarCurr: state_type] :
      ( v98697(VarCurr)
    <=> ( v98665(VarCurr)
        & v98698(VarCurr) ) ) ).

tff(writeUnaryOperator_4574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98698(VarCurr)
    <=> v98699(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3754,axiom,
    ! [VarCurr: state_type] :
      ( v98699(VarCurr)
    <=> ( v98701(VarCurr)
        | v98681(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3753,axiom,
    ! [VarCurr: state_type] :
      ( v98701(VarCurr)
    <=> ( v98702(VarCurr)
        | v98681(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3752,axiom,
    ! [VarCurr: state_type] :
      ( v98702(VarCurr)
    <=> ( v98703(VarCurr)
        | v98681(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3751,axiom,
    ! [VarCurr: state_type] :
      ( v98703(VarCurr)
    <=> ( v98704(VarCurr)
        | v98681(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3750,axiom,
    ! [VarCurr: state_type] :
      ( v98704(VarCurr)
    <=> ( v98705(VarCurr)
        | v98681(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3749,axiom,
    ! [VarCurr: state_type] :
      ( v98705(VarCurr)
    <=> ( v98706(VarCurr)
        | v98681(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3748,axiom,
    ! [VarCurr: state_type] :
      ( v98706(VarCurr)
    <=> ( v98681(VarCurr,0)
        | v98681(VarCurr,1) ) ) ).

tff(addAssignment_60264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98681(VarCurr,B)
      <=> v98683(VarCurr,B) ) ) ).

tff(addAssignment_60263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98683(VarCurr,B)
      <=> v98685(VarCurr,B) ) ) ).

tff(addAssignment_60262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v98685(VarCurr,B)
      <=> v98687(VarCurr,B) ) ) ).

tff(addAssignment_60261,axiom,
    ! [VarCurr: state_type] :
      ( ( v98687(VarCurr,7)
      <=> $false )
      & ( v98687(VarCurr,6)
      <=> $false )
      & ( v98687(VarCurr,5)
      <=> $false )
      & ( v98687(VarCurr,4)
      <=> $false )
      & ( v98687(VarCurr,3)
      <=> $false )
      & ( v98687(VarCurr,2)
      <=> $false )
      & ( v98687(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9100,axiom,
    ! [VarCurr: state_type] :
      ( v98687(VarCurr,0)
    <=> ( v98689(VarCurr)
        & v98693(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v98693(VarCurr)
      <=> v98695(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_631,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v98693(VarCurr)
      <=> v98694(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_566,axiom,
    ! [VarCurr: state_type] :
      ( v98695(VarCurr)
    <=> ( ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_565,axiom,
    ! [VarCurr: state_type] :
      ( v98694(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $true )
        & ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9099,axiom,
    ! [VarCurr: state_type] :
      ( v98689(VarCurr)
    <=> ( v98690(VarCurr)
        & v98692(VarCurr) ) ) ).

tff(writeUnaryOperator_4573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98692(VarCurr)
    <=> v97208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9098,axiom,
    ! [VarCurr: state_type] :
      ( v98690(VarCurr)
    <=> ( v98691(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(writeUnaryOperator_4572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98691(VarCurr)
    <=> v98436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9097,axiom,
    ! [VarCurr: state_type] :
      ( v98665(VarCurr)
    <=> ( v98677(VarCurr)
        & v98679(VarCurr) ) ) ).

tff(writeUnaryOperator_4571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98679(VarCurr)
    <=> v98667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9096,axiom,
    ! [VarCurr: state_type] :
      ( v98677(VarCurr)
    <=> ( v2942(VarCurr)
        & v98678(VarCurr) ) ) ).

tff(writeUnaryOperator_4570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98678(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_3747,axiom,
    ! [VarCurr: state_type] :
      ( v98667(VarCurr)
    <=> ( v98670(VarCurr)
        & v2910(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3746,axiom,
    ! [VarCurr: state_type] :
      ( v98670(VarCurr)
    <=> ( v98671(VarCurr)
        & v2910(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3745,axiom,
    ! [VarCurr: state_type] :
      ( v98671(VarCurr)
    <=> ( v98672(VarCurr)
        & v2910(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3744,axiom,
    ! [VarCurr: state_type] :
      ( v98672(VarCurr)
    <=> ( v98673(VarCurr)
        & v2910(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3743,axiom,
    ! [VarCurr: state_type] :
      ( v98673(VarCurr)
    <=> ( v98674(VarCurr)
        & v2910(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3742,axiom,
    ! [VarCurr: state_type] :
      ( v98674(VarCurr)
    <=> ( v98675(VarCurr)
        & v2910(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3741,axiom,
    ! [VarCurr: state_type] :
      ( v98675(VarCurr)
    <=> ( v2910(VarCurr,0)
        & v2910(VarCurr,1) ) ) ).

tff(addAssignment_60260,axiom,
    ! [VarCurr: state_type] :
      ( v98653(VarCurr)
    <=> v98655(VarCurr) ) ).

tff(addAssignment_60259,axiom,
    ! [VarCurr: state_type] :
      ( v98655(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_60258,axiom,
    ! [VarCurr: state_type] :
      ( v98649(VarCurr)
    <=> v98651(VarCurr) ) ).

tff(addAssignment_60257,axiom,
    ! [VarCurr: state_type] :
      ( v98651(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_60256,axiom,
    ! [VarCurr: state_type] :
      ( v98444(VarCurr)
    <=> v98446(VarCurr) ) ).

tff(addAssignment_60255,axiom,
    ! [VarCurr: state_type] :
      ( v98446(VarCurr)
    <=> v98448(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98618(VarNext)
       => ( v98448(VarNext)
        <=> v98448(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1129,axiom,
    ! [VarNext: state_type] :
      ( v98618(VarNext)
     => ( v98448(VarNext)
      <=> v98628(VarNext) ) ) ).

tff(addAssignment_60254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98628(VarNext)
      <=> v98626(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98629(VarCurr)
     => ( v98626(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_630,axiom,
    ! [VarCurr: state_type] :
      ( v98629(VarCurr)
     => ( v98626(VarCurr)
      <=> v98458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9095,axiom,
    ! [VarCurr: state_type] :
      ( v98629(VarCurr)
    <=> ( v98630(VarCurr)
        & v98631(VarCurr) ) ) ).

tff(writeUnaryOperator_4569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98631(VarCurr)
    <=> v98454(VarCurr) ) ).

tff(writeUnaryOperator_4568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98630(VarCurr)
    <=> v98450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98618(VarNext)
      <=> v98619(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98619(VarNext)
      <=> ( v98620(VarNext)
          & v98613(VarNext) ) ) ) ).

tff(writeUnaryOperator_4567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98620(VarNext)
      <=> v98622(VarNext) ) ) ).

tff(addAssignment_60253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98622(VarNext)
      <=> v98613(VarCurr) ) ) ).

tff(addAssignment_60252,axiom,
    ! [VarCurr: state_type] :
      ( v98613(VarCurr)
    <=> v98615(VarCurr) ) ).

tff(addAssignment_60251,axiom,
    ! [VarCurr: state_type] :
      ( v98615(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_60250,axiom,
    ! [VarCurr: state_type] :
      ( v98458(VarCurr)
    <=> v98460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9092,axiom,
    ! [VarCurr: state_type] :
      ( v98460(VarCurr)
    <=> ( v98605(VarCurr)
        | v98608(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9091,axiom,
    ! [VarCurr: state_type] :
      ( v98608(VarCurr)
    <=> ( v98446(VarCurr)
        & v98609(VarCurr) ) ) ).

tff(writeUnaryOperator_4566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98609(VarCurr)
    <=> v98610(VarCurr) ) ).

tff(addAssignment_60249,axiom,
    ! [VarCurr: state_type] :
      ( v98610(VarCurr)
    <=> v98611(VarCurr) ) ).

tff(addAssignment_60248,axiom,
    ! [VarCurr: state_type] :
      ( v98611(VarCurr)
    <=> v98596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9090,axiom,
    ! [VarCurr: state_type] :
      ( v98605(VarCurr)
    <=> ( v98462(VarCurr)
        & v98606(VarCurr) ) ) ).

tff(addAssignment_60247,axiom,
    ! [VarCurr: state_type] :
      ( v98606(VarCurr)
    <=> v98607(VarCurr) ) ).

tff(addAssignment_60246,axiom,
    ! [VarCurr: state_type] :
      ( v98607(VarCurr)
    <=> v98596(VarCurr) ) ).

tff(addAssignment_60245,axiom,
    ! [VarCurr: state_type] :
      ( v98596(VarCurr)
    <=> v98598(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ( v98598(VarCurr)
      <=> v98602(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_629,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ( v98598(VarCurr)
      <=> v98600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9089,axiom,
    ! [VarCurr: state_type] :
      ( v98602(VarCurr)
    <=> ( v98603(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_564,axiom,
    ! [VarCurr: state_type] :
      ( v98603(VarCurr)
    <=> ( ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9088,axiom,
    ! [VarCurr: state_type] :
      ( v98600(VarCurr)
    <=> ( v98601(VarCurr)
        & v97325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_563,axiom,
    ! [VarCurr: state_type] :
      ( v98601(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $true )
        & ( v97284(VarCurr,1)
        <=> $true )
        & ( v97284(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_60244,axiom,
    ! [VarCurr: state_type] :
      ( v98462(VarCurr)
    <=> v98464(VarCurr) ) ).

tff(writeUnaryOperator_4565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98464(VarCurr)
    <=> v97409(VarCurr,15) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_16,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97208(VarCurr)
     => ( v97409(VarCurr,15)
      <=> v98436(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_628,axiom,
    ! [VarCurr: state_type] :
      ( v97208(VarCurr)
     => ( v97409(VarCurr,15)
      <=> v97411(VarCurr,15) ) ) ).

tff(addAssignment_60243,axiom,
    ! [VarCurr: state_type] :
      ( v97411(VarCurr,15)
    <=> v98356(VarCurr,15) ) ).

tff(addAssignment_60242,axiom,
    ! [VarCurr: state_type] :
      ( v98301(VarCurr,15)
    <=> v98303(VarCurr,15) ) ).

tff(addAssignment_60241,axiom,
    ! [VarCurr: state_type] :
      ( v98303(VarCurr,15)
    <=> v98305(VarCurr,15) ) ).

tff(addAssignment_60240,axiom,
    ! [VarNext: state_type] :
      ( v98305(VarNext,15)
    <=> v98586(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98587(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98586(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1128,axiom,
    ! [VarNext: state_type] :
      ( v98587(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98586(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98587(VarNext)
      <=> v98588(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98588(VarNext)
      <=> ( v98590(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_4564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98590(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_60239,axiom,
    ! [VarCurr: state_type] :
      ( v98315(VarCurr,15)
    <=> v98317(VarCurr,15) ) ).

tff(addAssignment_60238,axiom,
    ! [VarCurr: state_type] :
      ( v98317(VarCurr,15)
    <=> v98326(VarCurr,15) ) ).

tff(addAssignment_60237,axiom,
    ! [VarCurr: state_type] :
      ( v98319(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60236,axiom,
    ! [VarCurr: state_type] :
      ( v98245(VarCurr,15)
    <=> v98247(VarCurr,15) ) ).

tff(addAssignment_60235,axiom,
    ! [VarCurr: state_type] :
      ( v98247(VarCurr,15)
    <=> v98249(VarCurr,15) ) ).

tff(addAssignment_60234,axiom,
    ! [VarNext: state_type] :
      ( v98249(VarNext,15)
    <=> v98578(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98579(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98578(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1127,axiom,
    ! [VarNext: state_type] :
      ( v98579(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98578(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98579(VarNext)
      <=> v98580(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98580(VarNext)
      <=> ( v98582(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_4563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98582(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_60233,axiom,
    ! [VarCurr: state_type] :
      ( v98259(VarCurr,15)
    <=> v98261(VarCurr,15) ) ).

tff(addAssignment_60232,axiom,
    ! [VarCurr: state_type] :
      ( v98261(VarCurr,15)
    <=> v98270(VarCurr,15) ) ).

tff(addAssignment_60231,axiom,
    ! [VarCurr: state_type] :
      ( v98263(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60230,axiom,
    ! [VarCurr: state_type] :
      ( v98189(VarCurr,15)
    <=> v98191(VarCurr,15) ) ).

tff(addAssignment_60229,axiom,
    ! [VarCurr: state_type] :
      ( v98191(VarCurr,15)
    <=> v98193(VarCurr,15) ) ).

tff(addAssignment_60228,axiom,
    ! [VarNext: state_type] :
      ( v98193(VarNext,15)
    <=> v98570(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98571(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98570(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1126,axiom,
    ! [VarNext: state_type] :
      ( v98571(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98570(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98571(VarNext)
      <=> v98572(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98572(VarNext)
      <=> ( v98574(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_4562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98574(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_60227,axiom,
    ! [VarCurr: state_type] :
      ( v98203(VarCurr,15)
    <=> v98205(VarCurr,15) ) ).

tff(addAssignment_60226,axiom,
    ! [VarCurr: state_type] :
      ( v98205(VarCurr,15)
    <=> v98214(VarCurr,15) ) ).

tff(addAssignment_60225,axiom,
    ! [VarCurr: state_type] :
      ( v98207(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60224,axiom,
    ! [VarCurr: state_type] :
      ( v98133(VarCurr,15)
    <=> v98135(VarCurr,15) ) ).

tff(addAssignment_60223,axiom,
    ! [VarCurr: state_type] :
      ( v98135(VarCurr,15)
    <=> v98137(VarCurr,15) ) ).

tff(addAssignment_60222,axiom,
    ! [VarNext: state_type] :
      ( v98137(VarNext,15)
    <=> v98562(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98563(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98562(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1125,axiom,
    ! [VarNext: state_type] :
      ( v98563(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98562(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98563(VarNext)
      <=> v98564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98564(VarNext)
      <=> ( v98566(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_4561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98566(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_60221,axiom,
    ! [VarCurr: state_type] :
      ( v98147(VarCurr,15)
    <=> v98149(VarCurr,15) ) ).

tff(addAssignment_60220,axiom,
    ! [VarCurr: state_type] :
      ( v98149(VarCurr,15)
    <=> v98158(VarCurr,15) ) ).

tff(addAssignment_60219,axiom,
    ! [VarCurr: state_type] :
      ( v98151(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60218,axiom,
    ! [VarCurr: state_type] :
      ( v98077(VarCurr,15)
    <=> v98079(VarCurr,15) ) ).

tff(addAssignment_60217,axiom,
    ! [VarCurr: state_type] :
      ( v98079(VarCurr,15)
    <=> v98081(VarCurr,15) ) ).

tff(addAssignment_60216,axiom,
    ! [VarNext: state_type] :
      ( v98081(VarNext,15)
    <=> v98554(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98555(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98554(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1124,axiom,
    ! [VarNext: state_type] :
      ( v98555(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98554(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98555(VarNext)
      <=> v98556(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98556(VarNext)
      <=> ( v98558(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_4560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98558(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_60215,axiom,
    ! [VarCurr: state_type] :
      ( v98091(VarCurr,15)
    <=> v98093(VarCurr,15) ) ).

tff(addAssignment_60214,axiom,
    ! [VarCurr: state_type] :
      ( v98093(VarCurr,15)
    <=> v98102(VarCurr,15) ) ).

tff(addAssignment_60213,axiom,
    ! [VarCurr: state_type] :
      ( v98095(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60212,axiom,
    ! [VarCurr: state_type] :
      ( v98021(VarCurr,15)
    <=> v98023(VarCurr,15) ) ).

tff(addAssignment_60211,axiom,
    ! [VarCurr: state_type] :
      ( v98023(VarCurr,15)
    <=> v98025(VarCurr,15) ) ).

tff(addAssignment_60210,axiom,
    ! [VarNext: state_type] :
      ( v98025(VarNext,15)
    <=> v98546(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98547(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98546(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1123,axiom,
    ! [VarNext: state_type] :
      ( v98547(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98546(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98547(VarNext)
      <=> v98548(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98548(VarNext)
      <=> ( v98550(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_4559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98550(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_60209,axiom,
    ! [VarCurr: state_type] :
      ( v98035(VarCurr,15)
    <=> v98037(VarCurr,15) ) ).

tff(addAssignment_60208,axiom,
    ! [VarCurr: state_type] :
      ( v98037(VarCurr,15)
    <=> v98046(VarCurr,15) ) ).

tff(addAssignment_60207,axiom,
    ! [VarCurr: state_type] :
      ( v98039(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60206,axiom,
    ! [VarCurr: state_type] :
      ( v97965(VarCurr,15)
    <=> v97967(VarCurr,15) ) ).

tff(addAssignment_60205,axiom,
    ! [VarCurr: state_type] :
      ( v97967(VarCurr,15)
    <=> v97969(VarCurr,15) ) ).

tff(addAssignment_60204,axiom,
    ! [VarNext: state_type] :
      ( v97969(VarNext,15)
    <=> v98538(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98539(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98538(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1122,axiom,
    ! [VarNext: state_type] :
      ( v98539(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98538(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98539(VarNext)
      <=> v98540(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98540(VarNext)
      <=> ( v98542(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_4558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98542(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_60203,axiom,
    ! [VarCurr: state_type] :
      ( v97979(VarCurr,15)
    <=> v97981(VarCurr,15) ) ).

tff(addAssignment_60202,axiom,
    ! [VarCurr: state_type] :
      ( v97981(VarCurr,15)
    <=> v97990(VarCurr,15) ) ).

tff(addAssignment_60201,axiom,
    ! [VarCurr: state_type] :
      ( v97983(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60200,axiom,
    ! [VarCurr: state_type] :
      ( v97909(VarCurr,15)
    <=> v97911(VarCurr,15) ) ).

tff(addAssignment_60199,axiom,
    ! [VarCurr: state_type] :
      ( v97911(VarCurr,15)
    <=> v97913(VarCurr,15) ) ).

tff(addAssignment_60198,axiom,
    ! [VarNext: state_type] :
      ( v97913(VarNext,15)
    <=> v98530(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98531(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98530(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1121,axiom,
    ! [VarNext: state_type] :
      ( v98531(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98530(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98531(VarNext)
      <=> v98532(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98532(VarNext)
      <=> ( v98534(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_4557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98534(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_60197,axiom,
    ! [VarCurr: state_type] :
      ( v97923(VarCurr,15)
    <=> v97925(VarCurr,15) ) ).

tff(addAssignment_60196,axiom,
    ! [VarCurr: state_type] :
      ( v97925(VarCurr,15)
    <=> v97934(VarCurr,15) ) ).

tff(addAssignment_60195,axiom,
    ! [VarCurr: state_type] :
      ( v97927(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60194,axiom,
    ! [VarCurr: state_type] :
      ( v97853(VarCurr,15)
    <=> v97855(VarCurr,15) ) ).

tff(addAssignment_60193,axiom,
    ! [VarCurr: state_type] :
      ( v97855(VarCurr,15)
    <=> v97857(VarCurr,15) ) ).

tff(addAssignment_60192,axiom,
    ! [VarNext: state_type] :
      ( v97857(VarNext,15)
    <=> v98522(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98523(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98522(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1120,axiom,
    ! [VarNext: state_type] :
      ( v98523(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98522(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98523(VarNext)
      <=> v98524(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98524(VarNext)
      <=> ( v98526(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_4556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98526(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_60191,axiom,
    ! [VarCurr: state_type] :
      ( v97867(VarCurr,15)
    <=> v97869(VarCurr,15) ) ).

tff(addAssignment_60190,axiom,
    ! [VarCurr: state_type] :
      ( v97869(VarCurr,15)
    <=> v97878(VarCurr,15) ) ).

tff(addAssignment_60189,axiom,
    ! [VarCurr: state_type] :
      ( v97871(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60188,axiom,
    ! [VarCurr: state_type] :
      ( v97797(VarCurr,15)
    <=> v97799(VarCurr,15) ) ).

tff(addAssignment_60187,axiom,
    ! [VarCurr: state_type] :
      ( v97799(VarCurr,15)
    <=> v97801(VarCurr,15) ) ).

tff(addAssignment_60186,axiom,
    ! [VarNext: state_type] :
      ( v97801(VarNext,15)
    <=> v98514(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98515(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98514(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1119,axiom,
    ! [VarNext: state_type] :
      ( v98515(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98514(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98515(VarNext)
      <=> v98516(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98516(VarNext)
      <=> ( v98518(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_4555,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98518(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_60185,axiom,
    ! [VarCurr: state_type] :
      ( v97811(VarCurr,15)
    <=> v97813(VarCurr,15) ) ).

tff(addAssignment_60184,axiom,
    ! [VarCurr: state_type] :
      ( v97813(VarCurr,15)
    <=> v97822(VarCurr,15) ) ).

tff(addAssignment_60183,axiom,
    ! [VarCurr: state_type] :
      ( v97815(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60182,axiom,
    ! [VarCurr: state_type] :
      ( v97741(VarCurr,15)
    <=> v97743(VarCurr,15) ) ).

tff(addAssignment_60181,axiom,
    ! [VarCurr: state_type] :
      ( v97743(VarCurr,15)
    <=> v97745(VarCurr,15) ) ).

tff(addAssignment_60180,axiom,
    ! [VarNext: state_type] :
      ( v97745(VarNext,15)
    <=> v98506(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98507(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98506(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1118,axiom,
    ! [VarNext: state_type] :
      ( v98507(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98506(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98507(VarNext)
      <=> v98508(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98508(VarNext)
      <=> ( v98510(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_4554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98510(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_60179,axiom,
    ! [VarCurr: state_type] :
      ( v97755(VarCurr,15)
    <=> v97757(VarCurr,15) ) ).

tff(addAssignment_60178,axiom,
    ! [VarCurr: state_type] :
      ( v97757(VarCurr,15)
    <=> v97766(VarCurr,15) ) ).

tff(addAssignment_60177,axiom,
    ! [VarCurr: state_type] :
      ( v97759(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60176,axiom,
    ! [VarCurr: state_type] :
      ( v97685(VarCurr,15)
    <=> v97687(VarCurr,15) ) ).

tff(addAssignment_60175,axiom,
    ! [VarCurr: state_type] :
      ( v97687(VarCurr,15)
    <=> v97689(VarCurr,15) ) ).

tff(addAssignment_60174,axiom,
    ! [VarNext: state_type] :
      ( v97689(VarNext,15)
    <=> v98498(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98499(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98498(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1117,axiom,
    ! [VarNext: state_type] :
      ( v98499(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98498(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98499(VarNext)
      <=> v98500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98500(VarNext)
      <=> ( v98502(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_4553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98502(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_60173,axiom,
    ! [VarCurr: state_type] :
      ( v97699(VarCurr,15)
    <=> v97701(VarCurr,15) ) ).

tff(addAssignment_60172,axiom,
    ! [VarCurr: state_type] :
      ( v97701(VarCurr,15)
    <=> v97710(VarCurr,15) ) ).

tff(addAssignment_60171,axiom,
    ! [VarCurr: state_type] :
      ( v97703(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60170,axiom,
    ! [VarCurr: state_type] :
      ( v97629(VarCurr,15)
    <=> v97631(VarCurr,15) ) ).

tff(addAssignment_60169,axiom,
    ! [VarCurr: state_type] :
      ( v97631(VarCurr,15)
    <=> v97633(VarCurr,15) ) ).

tff(addAssignment_60168,axiom,
    ! [VarNext: state_type] :
      ( v97633(VarNext,15)
    <=> v98490(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98491(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98490(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1116,axiom,
    ! [VarNext: state_type] :
      ( v98491(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98490(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98491(VarNext)
      <=> v98492(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98492(VarNext)
      <=> ( v98494(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_4552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98494(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_60167,axiom,
    ! [VarCurr: state_type] :
      ( v97643(VarCurr,15)
    <=> v97645(VarCurr,15) ) ).

tff(addAssignment_60166,axiom,
    ! [VarCurr: state_type] :
      ( v97645(VarCurr,15)
    <=> v97654(VarCurr,15) ) ).

tff(addAssignment_60165,axiom,
    ! [VarCurr: state_type] :
      ( v97647(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60164,axiom,
    ! [VarCurr: state_type] :
      ( v97573(VarCurr,15)
    <=> v97575(VarCurr,15) ) ).

tff(addAssignment_60163,axiom,
    ! [VarCurr: state_type] :
      ( v97575(VarCurr,15)
    <=> v97577(VarCurr,15) ) ).

tff(addAssignment_60162,axiom,
    ! [VarNext: state_type] :
      ( v97577(VarNext,15)
    <=> v98482(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98483(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98482(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1115,axiom,
    ! [VarNext: state_type] :
      ( v98483(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98482(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98483(VarNext)
      <=> v98484(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98484(VarNext)
      <=> ( v98486(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_4551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98486(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_60161,axiom,
    ! [VarCurr: state_type] :
      ( v97587(VarCurr,15)
    <=> v97589(VarCurr,15) ) ).

tff(addAssignment_60160,axiom,
    ! [VarCurr: state_type] :
      ( v97589(VarCurr,15)
    <=> v97598(VarCurr,15) ) ).

tff(addAssignment_60159,axiom,
    ! [VarCurr: state_type] :
      ( v97591(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60158,axiom,
    ! [VarCurr: state_type] :
      ( v97517(VarCurr,15)
    <=> v97519(VarCurr,15) ) ).

tff(addAssignment_60157,axiom,
    ! [VarCurr: state_type] :
      ( v97519(VarCurr,15)
    <=> v97521(VarCurr,15) ) ).

tff(addAssignment_60156,axiom,
    ! [VarNext: state_type] :
      ( v97521(VarNext,15)
    <=> v98474(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98475(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98474(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1114,axiom,
    ! [VarNext: state_type] :
      ( v98475(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98474(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98475(VarNext)
      <=> v98476(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98476(VarNext)
      <=> ( v98478(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_4550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98478(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_60155,axiom,
    ! [VarCurr: state_type] :
      ( v97531(VarCurr,15)
    <=> v97533(VarCurr,15) ) ).

tff(addAssignment_60154,axiom,
    ! [VarCurr: state_type] :
      ( v97533(VarCurr,15)
    <=> v97542(VarCurr,15) ) ).

tff(addAssignment_60153,axiom,
    ! [VarCurr: state_type] :
      ( v97535(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60152,axiom,
    ! [VarCurr: state_type] :
      ( v97413(VarCurr,15)
    <=> v97415(VarCurr,15) ) ).

tff(addAssignment_60151,axiom,
    ! [VarCurr: state_type] :
      ( v97415(VarCurr,15)
    <=> v97417(VarCurr,15) ) ).

tff(addAssignment_60150,axiom,
    ! [VarNext: state_type] :
      ( v97417(VarNext,15)
    <=> v98466(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_1113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98467(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98466(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1113,axiom,
    ! [VarNext: state_type] :
      ( v98467(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98466(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98467(VarNext)
      <=> v98468(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98468(VarNext)
      <=> ( v98470(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_4549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98470(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_60149,axiom,
    ! [VarCurr: state_type] :
      ( v97427(VarCurr,15)
    <=> v97429(VarCurr,15) ) ).

tff(addAssignment_60148,axiom,
    ! [VarCurr: state_type] :
      ( v97429(VarCurr,15)
    <=> v97486(VarCurr,15) ) ).

tff(addAssignment_60147,axiom,
    ! [VarCurr: state_type] :
      ( v97431(VarCurr,15)
    <=> v97409(VarCurr,15) ) ).

tff(addAssignment_60146,axiom,
    ! [VarCurr: state_type] :
      ( v98454(VarCurr)
    <=> v98456(VarCurr) ) ).

tff(addAssignment_60145,axiom,
    ! [VarCurr: state_type] :
      ( v98456(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_60144,axiom,
    ! [VarCurr: state_type] :
      ( v98450(VarCurr)
    <=> v98452(VarCurr) ) ).

tff(addAssignment_60143,axiom,
    ! [VarCurr: state_type] :
      ( v98452(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9055,axiom,
    ! [VarCurr: state_type] :
      ( v98438(VarCurr)
    <=> ( v97325(VarCurr)
        & v98440(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_562,axiom,
    ! [VarCurr: state_type] :
      ( v98440(VarCurr)
    <=> ( ( v97284(VarCurr,2)
        <=> $false )
        & ( v97284(VarCurr,1)
        <=> $false )
        & ( v97284(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_60142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97411(VarCurr,B)
      <=> v98356(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98356(VarCurr,B)
      <=> ( v98357(VarCurr,B)
          | v98431(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98431(VarCurr,B)
      <=> ( v98432(VarCurr,B)
          & v98301(VarCurr,B) ) ) ) ).

tff(addAssignment_60141,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,0)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60140,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,1)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60139,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,2)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60138,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,3)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60137,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,4)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60136,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,5)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60135,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,6)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60134,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,7)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60133,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,8)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60132,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,9)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60131,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,10)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60130,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,11)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60129,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,12)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60128,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,13)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60127,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,14)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60126,axiom,
    ! [VarCurr: state_type] :
      ( v98432(VarCurr,15)
    <=> v98433(VarCurr) ) ).

tff(addAssignment_60125,axiom,
    ! [VarCurr: state_type] :
      ( v98433(VarCurr)
    <=> v98434(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_561,axiom,
    ! [VarCurr: state_type] :
      ( v98434(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98357(VarCurr,B)
      <=> ( v98358(VarCurr,B)
          | v98427(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98427(VarCurr,B)
      <=> ( v98428(VarCurr,B)
          & v98245(VarCurr,B) ) ) ) ).

tff(addAssignment_60124,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,0)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60123,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,1)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60122,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,2)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60121,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,3)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60120,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,4)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60119,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,5)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60118,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,6)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60117,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,7)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60116,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,8)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60115,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,9)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60114,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,10)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60113,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,11)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60112,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,12)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60111,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,13)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60110,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,14)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60109,axiom,
    ! [VarCurr: state_type] :
      ( v98428(VarCurr,15)
    <=> v98429(VarCurr) ) ).

tff(addAssignment_60108,axiom,
    ! [VarCurr: state_type] :
      ( v98429(VarCurr)
    <=> v98430(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_560,axiom,
    ! [VarCurr: state_type] :
      ( v98430(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98358(VarCurr,B)
      <=> ( v98359(VarCurr,B)
          | v98423(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98423(VarCurr,B)
      <=> ( v98424(VarCurr,B)
          & v98189(VarCurr,B) ) ) ) ).

tff(addAssignment_60107,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,0)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60106,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,1)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60105,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,2)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60104,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,3)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60103,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,4)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60102,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,5)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60101,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,6)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60100,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,7)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60099,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,8)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60098,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,9)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60097,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,10)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60096,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,11)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60095,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,12)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60094,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,13)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60093,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,14)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60092,axiom,
    ! [VarCurr: state_type] :
      ( v98424(VarCurr,15)
    <=> v98425(VarCurr) ) ).

tff(addAssignment_60091,axiom,
    ! [VarCurr: state_type] :
      ( v98425(VarCurr)
    <=> v98426(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_559,axiom,
    ! [VarCurr: state_type] :
      ( v98426(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1317,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98359(VarCurr,B)
      <=> ( v98360(VarCurr,B)
          | v98419(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98419(VarCurr,B)
      <=> ( v98420(VarCurr,B)
          & v98133(VarCurr,B) ) ) ) ).

tff(addAssignment_60090,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,0)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60089,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,1)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60088,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,2)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60087,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,3)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60086,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,4)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60085,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,5)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60084,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,6)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60083,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,7)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60082,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,8)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60081,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,9)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60080,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,10)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60079,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,11)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60078,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,12)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60077,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,13)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60076,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,14)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60075,axiom,
    ! [VarCurr: state_type] :
      ( v98420(VarCurr,15)
    <=> v98421(VarCurr) ) ).

tff(addAssignment_60074,axiom,
    ! [VarCurr: state_type] :
      ( v98421(VarCurr)
    <=> v98422(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_558,axiom,
    ! [VarCurr: state_type] :
      ( v98422(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1315,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98360(VarCurr,B)
      <=> ( v98361(VarCurr,B)
          | v98415(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98415(VarCurr,B)
      <=> ( v98416(VarCurr,B)
          & v98077(VarCurr,B) ) ) ) ).

tff(addAssignment_60073,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,0)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60072,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,1)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60071,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,2)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60070,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,3)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60069,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,4)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60068,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,5)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60067,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,6)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60066,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,7)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60065,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,8)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60064,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,9)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60063,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,10)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60062,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,11)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60061,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,12)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60060,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,13)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60059,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,14)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60058,axiom,
    ! [VarCurr: state_type] :
      ( v98416(VarCurr,15)
    <=> v98417(VarCurr) ) ).

tff(addAssignment_60057,axiom,
    ! [VarCurr: state_type] :
      ( v98417(VarCurr)
    <=> v98418(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_557,axiom,
    ! [VarCurr: state_type] :
      ( v98418(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98361(VarCurr,B)
      <=> ( v98362(VarCurr,B)
          | v98411(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98411(VarCurr,B)
      <=> ( v98412(VarCurr,B)
          & v98021(VarCurr,B) ) ) ) ).

tff(addAssignment_60056,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,0)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60055,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,1)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60054,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,2)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60053,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,3)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60052,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,4)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60051,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,5)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60050,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,6)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60049,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,7)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60048,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,8)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60047,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,9)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60046,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,10)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60045,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,11)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60044,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,12)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60043,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,13)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60042,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,14)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60041,axiom,
    ! [VarCurr: state_type] :
      ( v98412(VarCurr,15)
    <=> v98413(VarCurr) ) ).

tff(addAssignment_60040,axiom,
    ! [VarCurr: state_type] :
      ( v98413(VarCurr)
    <=> v98414(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_556,axiom,
    ! [VarCurr: state_type] :
      ( v98414(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98362(VarCurr,B)
      <=> ( v98363(VarCurr,B)
          | v98407(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98407(VarCurr,B)
      <=> ( v98408(VarCurr,B)
          & v97965(VarCurr,B) ) ) ) ).

tff(addAssignment_60039,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,0)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60038,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,1)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60037,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,2)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60036,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,3)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60035,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,4)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60034,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,5)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60033,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,6)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60032,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,7)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60031,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,8)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60030,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,9)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60029,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,10)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60028,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,11)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60027,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,12)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60026,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,13)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60025,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,14)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60024,axiom,
    ! [VarCurr: state_type] :
      ( v98408(VarCurr,15)
    <=> v98409(VarCurr) ) ).

tff(addAssignment_60023,axiom,
    ! [VarCurr: state_type] :
      ( v98409(VarCurr)
    <=> v98410(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_555,axiom,
    ! [VarCurr: state_type] :
      ( v98410(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98363(VarCurr,B)
      <=> ( v98364(VarCurr,B)
          | v98403(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98403(VarCurr,B)
      <=> ( v98404(VarCurr,B)
          & v97909(VarCurr,B) ) ) ) ).

tff(addAssignment_60022,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,0)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60021,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,1)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60020,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,2)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60019,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,3)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60018,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,4)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60017,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,5)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60016,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,6)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60015,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,7)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60014,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,8)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60013,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,9)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60012,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,10)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60011,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,11)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60010,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,12)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60009,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,13)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60008,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,14)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60007,axiom,
    ! [VarCurr: state_type] :
      ( v98404(VarCurr,15)
    <=> v98405(VarCurr) ) ).

tff(addAssignment_60006,axiom,
    ! [VarCurr: state_type] :
      ( v98405(VarCurr)
    <=> v98406(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_554,axiom,
    ! [VarCurr: state_type] :
      ( v98406(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $true )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98364(VarCurr,B)
      <=> ( v98365(VarCurr,B)
          | v98399(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98399(VarCurr,B)
      <=> ( v98400(VarCurr,B)
          & v97853(VarCurr,B) ) ) ) ).

tff(addAssignment_60005,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,0)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_60004,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,1)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_60003,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,2)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_60002,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,3)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_60001,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,4)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_60000,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,5)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59999,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,6)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59998,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,7)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59997,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,8)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59996,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,9)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59995,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,10)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59994,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,11)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59993,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,12)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59992,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,13)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59991,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,14)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59990,axiom,
    ! [VarCurr: state_type] :
      ( v98400(VarCurr,15)
    <=> v98401(VarCurr) ) ).

tff(addAssignment_59989,axiom,
    ! [VarCurr: state_type] :
      ( v98401(VarCurr)
    <=> v98402(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_553,axiom,
    ! [VarCurr: state_type] :
      ( v98402(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98365(VarCurr,B)
      <=> ( v98366(VarCurr,B)
          | v98395(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98395(VarCurr,B)
      <=> ( v98396(VarCurr,B)
          & v97797(VarCurr,B) ) ) ) ).

tff(addAssignment_59988,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,0)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59987,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,1)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59986,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,2)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59985,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,3)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59984,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,4)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59983,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,5)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59982,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,6)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59981,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,7)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59980,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,8)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59979,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,9)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59978,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,10)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59977,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,11)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59976,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,12)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59975,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,13)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59974,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,14)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59973,axiom,
    ! [VarCurr: state_type] :
      ( v98396(VarCurr,15)
    <=> v98397(VarCurr) ) ).

tff(addAssignment_59972,axiom,
    ! [VarCurr: state_type] :
      ( v98397(VarCurr)
    <=> v98398(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_552,axiom,
    ! [VarCurr: state_type] :
      ( v98398(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98366(VarCurr,B)
      <=> ( v98367(VarCurr,B)
          | v98391(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98391(VarCurr,B)
      <=> ( v98392(VarCurr,B)
          & v97741(VarCurr,B) ) ) ) ).

tff(addAssignment_59971,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,0)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59970,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,1)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59969,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,2)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59968,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,3)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59967,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,4)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59966,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,5)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59965,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,6)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59964,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,7)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59963,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,8)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59962,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,9)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59961,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,10)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59960,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,11)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59959,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,12)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59958,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,13)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59957,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,14)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59956,axiom,
    ! [VarCurr: state_type] :
      ( v98392(VarCurr,15)
    <=> v98393(VarCurr) ) ).

tff(addAssignment_59955,axiom,
    ! [VarCurr: state_type] :
      ( v98393(VarCurr)
    <=> v98394(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_551,axiom,
    ! [VarCurr: state_type] :
      ( v98394(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98367(VarCurr,B)
      <=> ( v98368(VarCurr,B)
          | v98387(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98387(VarCurr,B)
      <=> ( v98388(VarCurr,B)
          & v97685(VarCurr,B) ) ) ) ).

tff(addAssignment_59954,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,0)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59953,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,1)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59952,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,2)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59951,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,3)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59950,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,4)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59949,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,5)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59948,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,6)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59947,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,7)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59946,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,8)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59945,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,9)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59944,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,10)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59943,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,11)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59942,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,12)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59941,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,13)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59940,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,14)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59939,axiom,
    ! [VarCurr: state_type] :
      ( v98388(VarCurr,15)
    <=> v98389(VarCurr) ) ).

tff(addAssignment_59938,axiom,
    ! [VarCurr: state_type] :
      ( v98389(VarCurr)
    <=> v98390(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_550,axiom,
    ! [VarCurr: state_type] :
      ( v98390(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $true )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98368(VarCurr,B)
      <=> ( v98369(VarCurr,B)
          | v98383(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98383(VarCurr,B)
      <=> ( v98384(VarCurr,B)
          & v97629(VarCurr,B) ) ) ) ).

tff(addAssignment_59937,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,0)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59936,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,1)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59935,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,2)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59934,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,3)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59933,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,4)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59932,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,5)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59931,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,6)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59930,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,7)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59929,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,8)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59928,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,9)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59927,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,10)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59926,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,11)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59925,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,12)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59924,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,13)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59923,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,14)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59922,axiom,
    ! [VarCurr: state_type] :
      ( v98384(VarCurr,15)
    <=> v98385(VarCurr) ) ).

tff(addAssignment_59921,axiom,
    ! [VarCurr: state_type] :
      ( v98385(VarCurr)
    <=> v98386(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_549,axiom,
    ! [VarCurr: state_type] :
      ( v98386(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98369(VarCurr,B)
      <=> ( v98370(VarCurr,B)
          | v98379(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98379(VarCurr,B)
      <=> ( v98380(VarCurr,B)
          & v97573(VarCurr,B) ) ) ) ).

tff(addAssignment_59920,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,0)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59919,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,1)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59918,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,2)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59917,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,3)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59916,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,4)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59915,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,5)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59914,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,6)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59913,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,7)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59912,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,8)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59911,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,9)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59910,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,10)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59909,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,11)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59908,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,12)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59907,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,13)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59906,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,14)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59905,axiom,
    ! [VarCurr: state_type] :
      ( v98380(VarCurr,15)
    <=> v98381(VarCurr) ) ).

tff(addAssignment_59904,axiom,
    ! [VarCurr: state_type] :
      ( v98381(VarCurr)
    <=> v98382(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_548,axiom,
    ! [VarCurr: state_type] :
      ( v98382(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $true )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98370(VarCurr,B)
      <=> ( v98371(VarCurr,B)
          | v98375(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98375(VarCurr,B)
      <=> ( v98376(VarCurr,B)
          & v97517(VarCurr,B) ) ) ) ).

tff(addAssignment_59903,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,0)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59902,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,1)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59901,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,2)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59900,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,3)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59899,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,4)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59898,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,5)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59897,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,6)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59896,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,7)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59895,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,8)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59894,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,9)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59893,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,10)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59892,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,11)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59891,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,12)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59890,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,13)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59889,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,14)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59888,axiom,
    ! [VarCurr: state_type] :
      ( v98376(VarCurr,15)
    <=> v98377(VarCurr) ) ).

tff(addAssignment_59887,axiom,
    ! [VarCurr: state_type] :
      ( v98377(VarCurr)
    <=> v98378(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_547,axiom,
    ! [VarCurr: state_type] :
      ( v98378(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98371(VarCurr,B)
      <=> ( v98372(VarCurr,B)
          & v97413(VarCurr,B) ) ) ) ).

tff(addAssignment_59886,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,0)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59885,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,1)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59884,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,2)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59883,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,3)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59882,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,4)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59881,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,5)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59880,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,6)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59879,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,7)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59878,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,8)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59877,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,9)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59876,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,10)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59875,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,11)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59874,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,12)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59873,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,13)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59872,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,14)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59871,axiom,
    ! [VarCurr: state_type] :
      ( v98372(VarCurr,15)
    <=> v98373(VarCurr) ) ).

tff(addAssignment_59870,axiom,
    ! [VarCurr: state_type] :
      ( v98373(VarCurr)
    <=> v98374(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_546,axiom,
    ! [VarCurr: state_type] :
      ( v98374(VarCurr)
    <=> ( ( v97232(VarCurr,3)
        <=> $false )
        & ( v97232(VarCurr,2)
        <=> $false )
        & ( v97232(VarCurr,1)
        <=> $false )
        & ( v97232(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98301(VarCurr,B)
      <=> v98303(VarCurr,B) ) ) ).

tff(addAssignment_59868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98303(VarCurr,B)
      <=> v98305(VarCurr,B) ) ) ).

tff(addAssignment_59867,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98305(VarNext,B)
      <=> v98339(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98340(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98339(VarNext,B)
            <=> v98305(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1112,axiom,
    ! [VarNext: state_type] :
      ( v98340(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98339(VarNext,B)
          <=> v98350(VarNext,B) ) ) ) ).

tff(addAssignment_59866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98350(VarNext,B)
          <=> v98348(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98348(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_627,axiom,
    ! [VarCurr: state_type] :
      ( v98351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98348(VarCurr,B)
          <=> v98315(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9054,axiom,
    ! [VarCurr: state_type] :
      ( v98351(VarCurr)
    <=> ( v98352(VarCurr)
        & v98353(VarCurr) ) ) ).

tff(writeUnaryOperator_4548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98353(VarCurr)
    <=> v98311(VarCurr) ) ).

tff(writeUnaryOperator_4547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98352(VarCurr)
    <=> v98307(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98340(VarNext)
      <=> v98341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98341(VarNext)
      <=> ( v98342(VarNext)
          & v98335(VarNext) ) ) ) ).

tff(writeUnaryOperator_4546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98342(VarNext)
      <=> v98344(VarNext) ) ) ).

tff(addAssignment_59865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98344(VarNext)
      <=> v98335(VarCurr) ) ) ).

tff(addAssignment_59864,axiom,
    ! [VarCurr: state_type] :
      ( v98335(VarCurr)
    <=> v98337(VarCurr) ) ).

tff(addAssignment_59863,axiom,
    ! [VarCurr: state_type] :
      ( v98337(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98315(VarCurr,B)
      <=> v98317(VarCurr,B) ) ) ).

tff(addAssignment_59861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98317(VarCurr,B)
      <=> v98326(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98326(VarCurr,B)
      <=> ( v98327(VarCurr,B)
          | v98330(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98330(VarCurr,B)
      <=> ( v98303(VarCurr,B)
          & v98331(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98331(VarCurr,B)
      <=> ~ v98332(VarCurr,B) ) ) ).

tff(addAssignment_59860,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,0)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59859,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,1)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59858,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,2)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59857,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,3)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59856,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,4)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59855,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,5)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59854,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,6)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59853,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,7)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59852,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,8)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59851,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,9)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59850,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,10)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59849,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,11)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59848,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,12)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59847,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,13)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59846,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,14)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59845,axiom,
    ! [VarCurr: state_type] :
      ( v98332(VarCurr,15)
    <=> v98333(VarCurr) ) ).

tff(addAssignment_59844,axiom,
    ! [VarCurr: state_type] :
      ( v98333(VarCurr)
    <=> v98321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98327(VarCurr,B)
      <=> ( v98319(VarCurr,B)
          & v98328(VarCurr,B) ) ) ) ).

tff(addAssignment_59843,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,0)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59842,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,1)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59841,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,2)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59840,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,3)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59839,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,4)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59838,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,5)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59837,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,6)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59836,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,7)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59835,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,8)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59834,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,9)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59833,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,10)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59832,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,11)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59831,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,12)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59830,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,13)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59829,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,14)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59828,axiom,
    ! [VarCurr: state_type] :
      ( v98328(VarCurr,15)
    <=> v98329(VarCurr) ) ).

tff(addAssignment_59827,axiom,
    ! [VarCurr: state_type] :
      ( v98329(VarCurr)
    <=> v98321(VarCurr) ) ).

tff(addAssignment_59826,axiom,
    ! [VarCurr: state_type] :
      ( v98321(VarCurr)
    <=> v98323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9051,axiom,
    ! [VarCurr: state_type] :
      ( v98323(VarCurr)
    <=> ( v97276(VarCurr)
        & v98325(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_545,axiom,
    ! [VarCurr: state_type] :
      ( v98325(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98319(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59824,axiom,
    ! [VarCurr: state_type] :
      ( v98311(VarCurr)
    <=> v98313(VarCurr) ) ).

tff(addAssignment_59823,axiom,
    ! [VarCurr: state_type] :
      ( v98313(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59822,axiom,
    ! [VarCurr: state_type] :
      ( v98307(VarCurr)
    <=> v98309(VarCurr) ) ).

tff(addAssignment_59821,axiom,
    ! [VarCurr: state_type] :
      ( v98309(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98245(VarCurr,B)
      <=> v98247(VarCurr,B) ) ) ).

tff(addAssignment_59819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98247(VarCurr,B)
      <=> v98249(VarCurr,B) ) ) ).

tff(addAssignment_59818,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98249(VarNext,B)
      <=> v98283(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98284(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98283(VarNext,B)
            <=> v98249(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1111,axiom,
    ! [VarNext: state_type] :
      ( v98284(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98283(VarNext,B)
          <=> v98294(VarNext,B) ) ) ) ).

tff(addAssignment_59817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98294(VarNext,B)
          <=> v98292(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98292(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_626,axiom,
    ! [VarCurr: state_type] :
      ( v98295(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98292(VarCurr,B)
          <=> v98259(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9050,axiom,
    ! [VarCurr: state_type] :
      ( v98295(VarCurr)
    <=> ( v98296(VarCurr)
        & v98297(VarCurr) ) ) ).

tff(writeUnaryOperator_4544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98297(VarCurr)
    <=> v98255(VarCurr) ) ).

tff(writeUnaryOperator_4543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98296(VarCurr)
    <=> v98251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98284(VarNext)
      <=> v98285(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98285(VarNext)
      <=> ( v98286(VarNext)
          & v98279(VarNext) ) ) ) ).

tff(writeUnaryOperator_4542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98286(VarNext)
      <=> v98288(VarNext) ) ) ).

tff(addAssignment_59816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98288(VarNext)
      <=> v98279(VarCurr) ) ) ).

tff(addAssignment_59815,axiom,
    ! [VarCurr: state_type] :
      ( v98279(VarCurr)
    <=> v98281(VarCurr) ) ).

tff(addAssignment_59814,axiom,
    ! [VarCurr: state_type] :
      ( v98281(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98259(VarCurr,B)
      <=> v98261(VarCurr,B) ) ) ).

tff(addAssignment_59812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98261(VarCurr,B)
      <=> v98270(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98270(VarCurr,B)
      <=> ( v98271(VarCurr,B)
          | v98274(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98274(VarCurr,B)
      <=> ( v98247(VarCurr,B)
          & v98275(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98275(VarCurr,B)
      <=> ~ v98276(VarCurr,B) ) ) ).

tff(addAssignment_59811,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,0)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59810,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,1)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59809,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,2)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59808,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,3)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59807,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,4)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59806,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,5)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59805,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,6)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59804,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,7)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59803,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,8)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59802,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,9)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59801,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,10)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59800,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,11)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59799,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,12)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59798,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,13)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59797,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,14)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59796,axiom,
    ! [VarCurr: state_type] :
      ( v98276(VarCurr,15)
    <=> v98277(VarCurr) ) ).

tff(addAssignment_59795,axiom,
    ! [VarCurr: state_type] :
      ( v98277(VarCurr)
    <=> v98265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98271(VarCurr,B)
      <=> ( v98263(VarCurr,B)
          & v98272(VarCurr,B) ) ) ) ).

tff(addAssignment_59794,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,0)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59793,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,1)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59792,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,2)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59791,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,3)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59790,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,4)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59789,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,5)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59788,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,6)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59787,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,7)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59786,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,8)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59785,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,9)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59784,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,10)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59783,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,11)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59782,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,12)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59781,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,13)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59780,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,14)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59779,axiom,
    ! [VarCurr: state_type] :
      ( v98272(VarCurr,15)
    <=> v98273(VarCurr) ) ).

tff(addAssignment_59778,axiom,
    ! [VarCurr: state_type] :
      ( v98273(VarCurr)
    <=> v98265(VarCurr) ) ).

tff(addAssignment_59777,axiom,
    ! [VarCurr: state_type] :
      ( v98265(VarCurr)
    <=> v98267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9047,axiom,
    ! [VarCurr: state_type] :
      ( v98267(VarCurr)
    <=> ( v97276(VarCurr)
        & v98269(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_544,axiom,
    ! [VarCurr: state_type] :
      ( v98269(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98263(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59775,axiom,
    ! [VarCurr: state_type] :
      ( v98255(VarCurr)
    <=> v98257(VarCurr) ) ).

tff(addAssignment_59774,axiom,
    ! [VarCurr: state_type] :
      ( v98257(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59773,axiom,
    ! [VarCurr: state_type] :
      ( v98251(VarCurr)
    <=> v98253(VarCurr) ) ).

tff(addAssignment_59772,axiom,
    ! [VarCurr: state_type] :
      ( v98253(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98189(VarCurr,B)
      <=> v98191(VarCurr,B) ) ) ).

tff(addAssignment_59770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98191(VarCurr,B)
      <=> v98193(VarCurr,B) ) ) ).

tff(addAssignment_59769,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98193(VarNext,B)
      <=> v98227(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98227(VarNext,B)
            <=> v98193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1110,axiom,
    ! [VarNext: state_type] :
      ( v98228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98227(VarNext,B)
          <=> v98238(VarNext,B) ) ) ) ).

tff(addAssignment_59768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98238(VarNext,B)
          <=> v98236(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98236(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_625,axiom,
    ! [VarCurr: state_type] :
      ( v98239(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98236(VarCurr,B)
          <=> v98203(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9046,axiom,
    ! [VarCurr: state_type] :
      ( v98239(VarCurr)
    <=> ( v98240(VarCurr)
        & v98241(VarCurr) ) ) ).

tff(writeUnaryOperator_4540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98241(VarCurr)
    <=> v98199(VarCurr) ) ).

tff(writeUnaryOperator_4539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98240(VarCurr)
    <=> v98195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98228(VarNext)
      <=> v98229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98229(VarNext)
      <=> ( v98230(VarNext)
          & v98223(VarNext) ) ) ) ).

tff(writeUnaryOperator_4538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98230(VarNext)
      <=> v98232(VarNext) ) ) ).

tff(addAssignment_59767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98232(VarNext)
      <=> v98223(VarCurr) ) ) ).

tff(addAssignment_59766,axiom,
    ! [VarCurr: state_type] :
      ( v98223(VarCurr)
    <=> v98225(VarCurr) ) ).

tff(addAssignment_59765,axiom,
    ! [VarCurr: state_type] :
      ( v98225(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98203(VarCurr,B)
      <=> v98205(VarCurr,B) ) ) ).

tff(addAssignment_59763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98205(VarCurr,B)
      <=> v98214(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98214(VarCurr,B)
      <=> ( v98215(VarCurr,B)
          | v98218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98218(VarCurr,B)
      <=> ( v98191(VarCurr,B)
          & v98219(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98219(VarCurr,B)
      <=> ~ v98220(VarCurr,B) ) ) ).

tff(addAssignment_59762,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,0)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59761,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,1)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59760,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,2)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59759,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,3)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59758,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,4)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59757,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,5)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59756,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,6)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59755,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,7)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59754,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,8)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59753,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,9)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59752,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,10)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59751,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,11)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59750,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,12)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59749,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,13)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59748,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,14)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59747,axiom,
    ! [VarCurr: state_type] :
      ( v98220(VarCurr,15)
    <=> v98221(VarCurr) ) ).

tff(addAssignment_59746,axiom,
    ! [VarCurr: state_type] :
      ( v98221(VarCurr)
    <=> v98209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98215(VarCurr,B)
      <=> ( v98207(VarCurr,B)
          & v98216(VarCurr,B) ) ) ) ).

tff(addAssignment_59745,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,0)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59744,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,1)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59743,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,2)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59742,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,3)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59741,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,4)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59740,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,5)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59739,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,6)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59738,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,7)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59737,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,8)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59736,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,9)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59735,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,10)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59734,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,11)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59733,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,12)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59732,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,13)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59731,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,14)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59730,axiom,
    ! [VarCurr: state_type] :
      ( v98216(VarCurr,15)
    <=> v98217(VarCurr) ) ).

tff(addAssignment_59729,axiom,
    ! [VarCurr: state_type] :
      ( v98217(VarCurr)
    <=> v98209(VarCurr) ) ).

tff(addAssignment_59728,axiom,
    ! [VarCurr: state_type] :
      ( v98209(VarCurr)
    <=> v98211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9043,axiom,
    ! [VarCurr: state_type] :
      ( v98211(VarCurr)
    <=> ( v97276(VarCurr)
        & v98213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_543,axiom,
    ! [VarCurr: state_type] :
      ( v98213(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98207(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59726,axiom,
    ! [VarCurr: state_type] :
      ( v98199(VarCurr)
    <=> v98201(VarCurr) ) ).

tff(addAssignment_59725,axiom,
    ! [VarCurr: state_type] :
      ( v98201(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59724,axiom,
    ! [VarCurr: state_type] :
      ( v98195(VarCurr)
    <=> v98197(VarCurr) ) ).

tff(addAssignment_59723,axiom,
    ! [VarCurr: state_type] :
      ( v98197(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98133(VarCurr,B)
      <=> v98135(VarCurr,B) ) ) ).

tff(addAssignment_59721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98135(VarCurr,B)
      <=> v98137(VarCurr,B) ) ) ).

tff(addAssignment_59720,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98137(VarNext,B)
      <=> v98171(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98172(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98171(VarNext,B)
            <=> v98137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1109,axiom,
    ! [VarNext: state_type] :
      ( v98172(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98171(VarNext,B)
          <=> v98182(VarNext,B) ) ) ) ).

tff(addAssignment_59719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98182(VarNext,B)
          <=> v98180(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98183(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98180(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_624,axiom,
    ! [VarCurr: state_type] :
      ( v98183(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98180(VarCurr,B)
          <=> v98147(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9042,axiom,
    ! [VarCurr: state_type] :
      ( v98183(VarCurr)
    <=> ( v98184(VarCurr)
        & v98185(VarCurr) ) ) ).

tff(writeUnaryOperator_4536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98185(VarCurr)
    <=> v98143(VarCurr) ) ).

tff(writeUnaryOperator_4535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98184(VarCurr)
    <=> v98139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98172(VarNext)
      <=> v98173(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98173(VarNext)
      <=> ( v98174(VarNext)
          & v98167(VarNext) ) ) ) ).

tff(writeUnaryOperator_4534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98174(VarNext)
      <=> v98176(VarNext) ) ) ).

tff(addAssignment_59718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98176(VarNext)
      <=> v98167(VarCurr) ) ) ).

tff(addAssignment_59717,axiom,
    ! [VarCurr: state_type] :
      ( v98167(VarCurr)
    <=> v98169(VarCurr) ) ).

tff(addAssignment_59716,axiom,
    ! [VarCurr: state_type] :
      ( v98169(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98147(VarCurr,B)
      <=> v98149(VarCurr,B) ) ) ).

tff(addAssignment_59714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98149(VarCurr,B)
      <=> v98158(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98158(VarCurr,B)
      <=> ( v98159(VarCurr,B)
          | v98162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98162(VarCurr,B)
      <=> ( v98135(VarCurr,B)
          & v98163(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98163(VarCurr,B)
      <=> ~ v98164(VarCurr,B) ) ) ).

tff(addAssignment_59713,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,0)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59712,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,1)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59711,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,2)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59710,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,3)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59709,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,4)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59708,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,5)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59707,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,6)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59706,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,7)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59705,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,8)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59704,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,9)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59703,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,10)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59702,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,11)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59701,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,12)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59700,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,13)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59699,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,14)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59698,axiom,
    ! [VarCurr: state_type] :
      ( v98164(VarCurr,15)
    <=> v98165(VarCurr) ) ).

tff(addAssignment_59697,axiom,
    ! [VarCurr: state_type] :
      ( v98165(VarCurr)
    <=> v98153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98159(VarCurr,B)
      <=> ( v98151(VarCurr,B)
          & v98160(VarCurr,B) ) ) ) ).

tff(addAssignment_59696,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,0)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59695,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,1)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59694,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,2)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59693,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,3)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59692,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,4)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59691,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,5)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59690,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,6)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59689,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,7)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59688,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,8)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59687,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,9)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59686,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,10)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59685,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,11)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59684,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,12)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59683,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,13)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59682,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,14)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59681,axiom,
    ! [VarCurr: state_type] :
      ( v98160(VarCurr,15)
    <=> v98161(VarCurr) ) ).

tff(addAssignment_59680,axiom,
    ! [VarCurr: state_type] :
      ( v98161(VarCurr)
    <=> v98153(VarCurr) ) ).

tff(addAssignment_59679,axiom,
    ! [VarCurr: state_type] :
      ( v98153(VarCurr)
    <=> v98155(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9039,axiom,
    ! [VarCurr: state_type] :
      ( v98155(VarCurr)
    <=> ( v97276(VarCurr)
        & v98157(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_542,axiom,
    ! [VarCurr: state_type] :
      ( v98157(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98151(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59677,axiom,
    ! [VarCurr: state_type] :
      ( v98143(VarCurr)
    <=> v98145(VarCurr) ) ).

tff(addAssignment_59676,axiom,
    ! [VarCurr: state_type] :
      ( v98145(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59675,axiom,
    ! [VarCurr: state_type] :
      ( v98139(VarCurr)
    <=> v98141(VarCurr) ) ).

tff(addAssignment_59674,axiom,
    ! [VarCurr: state_type] :
      ( v98141(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98077(VarCurr,B)
      <=> v98079(VarCurr,B) ) ) ).

tff(addAssignment_59672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98079(VarCurr,B)
      <=> v98081(VarCurr,B) ) ) ).

tff(addAssignment_59671,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98081(VarNext,B)
      <=> v98115(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98116(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98115(VarNext,B)
            <=> v98081(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1108,axiom,
    ! [VarNext: state_type] :
      ( v98116(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98115(VarNext,B)
          <=> v98126(VarNext,B) ) ) ) ).

tff(addAssignment_59670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98126(VarNext,B)
          <=> v98124(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98127(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98124(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_623,axiom,
    ! [VarCurr: state_type] :
      ( v98127(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98124(VarCurr,B)
          <=> v98091(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9038,axiom,
    ! [VarCurr: state_type] :
      ( v98127(VarCurr)
    <=> ( v98128(VarCurr)
        & v98129(VarCurr) ) ) ).

tff(writeUnaryOperator_4532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98129(VarCurr)
    <=> v98087(VarCurr) ) ).

tff(writeUnaryOperator_4531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98128(VarCurr)
    <=> v98083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98116(VarNext)
      <=> v98117(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98117(VarNext)
      <=> ( v98118(VarNext)
          & v98111(VarNext) ) ) ) ).

tff(writeUnaryOperator_4530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98118(VarNext)
      <=> v98120(VarNext) ) ) ).

tff(addAssignment_59669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98120(VarNext)
      <=> v98111(VarCurr) ) ) ).

tff(addAssignment_59668,axiom,
    ! [VarCurr: state_type] :
      ( v98111(VarCurr)
    <=> v98113(VarCurr) ) ).

tff(addAssignment_59667,axiom,
    ! [VarCurr: state_type] :
      ( v98113(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98091(VarCurr,B)
      <=> v98093(VarCurr,B) ) ) ).

tff(addAssignment_59665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98093(VarCurr,B)
      <=> v98102(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98102(VarCurr,B)
      <=> ( v98103(VarCurr,B)
          | v98106(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98106(VarCurr,B)
      <=> ( v98079(VarCurr,B)
          & v98107(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98107(VarCurr,B)
      <=> ~ v98108(VarCurr,B) ) ) ).

tff(addAssignment_59664,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,0)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59663,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,1)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59662,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,2)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59661,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,3)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59660,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,4)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59659,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,5)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59658,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,6)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59657,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,7)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59656,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,8)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59655,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,9)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59654,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,10)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59653,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,11)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59652,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,12)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59651,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,13)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59650,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,14)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59649,axiom,
    ! [VarCurr: state_type] :
      ( v98108(VarCurr,15)
    <=> v98109(VarCurr) ) ).

tff(addAssignment_59648,axiom,
    ! [VarCurr: state_type] :
      ( v98109(VarCurr)
    <=> v98097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98103(VarCurr,B)
      <=> ( v98095(VarCurr,B)
          & v98104(VarCurr,B) ) ) ) ).

tff(addAssignment_59647,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,0)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59646,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,1)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59645,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,2)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59644,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,3)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59643,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,4)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59642,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,5)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59641,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,6)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59640,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,7)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59639,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,8)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59638,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,9)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59637,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,10)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59636,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,11)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59635,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,12)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59634,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,13)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59633,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,14)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59632,axiom,
    ! [VarCurr: state_type] :
      ( v98104(VarCurr,15)
    <=> v98105(VarCurr) ) ).

tff(addAssignment_59631,axiom,
    ! [VarCurr: state_type] :
      ( v98105(VarCurr)
    <=> v98097(VarCurr) ) ).

tff(addAssignment_59630,axiom,
    ! [VarCurr: state_type] :
      ( v98097(VarCurr)
    <=> v98099(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9035,axiom,
    ! [VarCurr: state_type] :
      ( v98099(VarCurr)
    <=> ( v97276(VarCurr)
        & v98101(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_541,axiom,
    ! [VarCurr: state_type] :
      ( v98101(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98095(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59628,axiom,
    ! [VarCurr: state_type] :
      ( v98087(VarCurr)
    <=> v98089(VarCurr) ) ).

tff(addAssignment_59627,axiom,
    ! [VarCurr: state_type] :
      ( v98089(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59626,axiom,
    ! [VarCurr: state_type] :
      ( v98083(VarCurr)
    <=> v98085(VarCurr) ) ).

tff(addAssignment_59625,axiom,
    ! [VarCurr: state_type] :
      ( v98085(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98021(VarCurr,B)
      <=> v98023(VarCurr,B) ) ) ).

tff(addAssignment_59623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98023(VarCurr,B)
      <=> v98025(VarCurr,B) ) ) ).

tff(addAssignment_59622,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98025(VarNext,B)
      <=> v98059(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98060(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98059(VarNext,B)
            <=> v98025(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1107,axiom,
    ! [VarNext: state_type] :
      ( v98060(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98059(VarNext,B)
          <=> v98070(VarNext,B) ) ) ) ).

tff(addAssignment_59621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98070(VarNext,B)
          <=> v98068(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98071(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98068(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_622,axiom,
    ! [VarCurr: state_type] :
      ( v98071(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98068(VarCurr,B)
          <=> v98035(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9034,axiom,
    ! [VarCurr: state_type] :
      ( v98071(VarCurr)
    <=> ( v98072(VarCurr)
        & v98073(VarCurr) ) ) ).

tff(writeUnaryOperator_4528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98073(VarCurr)
    <=> v98031(VarCurr) ) ).

tff(writeUnaryOperator_4527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98072(VarCurr)
    <=> v98027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98060(VarNext)
      <=> v98061(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98061(VarNext)
      <=> ( v98062(VarNext)
          & v98055(VarNext) ) ) ) ).

tff(writeUnaryOperator_4526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98062(VarNext)
      <=> v98064(VarNext) ) ) ).

tff(addAssignment_59620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98064(VarNext)
      <=> v98055(VarCurr) ) ) ).

tff(addAssignment_59619,axiom,
    ! [VarCurr: state_type] :
      ( v98055(VarCurr)
    <=> v98057(VarCurr) ) ).

tff(addAssignment_59618,axiom,
    ! [VarCurr: state_type] :
      ( v98057(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98035(VarCurr,B)
      <=> v98037(VarCurr,B) ) ) ).

tff(addAssignment_59616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98037(VarCurr,B)
      <=> v98046(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98046(VarCurr,B)
      <=> ( v98047(VarCurr,B)
          | v98050(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98050(VarCurr,B)
      <=> ( v98023(VarCurr,B)
          & v98051(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98051(VarCurr,B)
      <=> ~ v98052(VarCurr,B) ) ) ).

tff(addAssignment_59615,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,0)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59614,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,1)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59613,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,2)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59612,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,3)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59611,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,4)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59610,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,5)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59609,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,6)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59608,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,7)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59607,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,8)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59606,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,9)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59605,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,10)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59604,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,11)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59603,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,12)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59602,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,13)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59601,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,14)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59600,axiom,
    ! [VarCurr: state_type] :
      ( v98052(VarCurr,15)
    <=> v98053(VarCurr) ) ).

tff(addAssignment_59599,axiom,
    ! [VarCurr: state_type] :
      ( v98053(VarCurr)
    <=> v98041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v98047(VarCurr,B)
      <=> ( v98039(VarCurr,B)
          & v98048(VarCurr,B) ) ) ) ).

tff(addAssignment_59598,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,0)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59597,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,1)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59596,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,2)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59595,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,3)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59594,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,4)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59593,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,5)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59592,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,6)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59591,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,7)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59590,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,8)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59589,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,9)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59588,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,10)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59587,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,11)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59586,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,12)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59585,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,13)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59584,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,14)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59583,axiom,
    ! [VarCurr: state_type] :
      ( v98048(VarCurr,15)
    <=> v98049(VarCurr) ) ).

tff(addAssignment_59582,axiom,
    ! [VarCurr: state_type] :
      ( v98049(VarCurr)
    <=> v98041(VarCurr) ) ).

tff(addAssignment_59581,axiom,
    ! [VarCurr: state_type] :
      ( v98041(VarCurr)
    <=> v98043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9031,axiom,
    ! [VarCurr: state_type] :
      ( v98043(VarCurr)
    <=> ( v97276(VarCurr)
        & v98045(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_540,axiom,
    ! [VarCurr: state_type] :
      ( v98045(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v98039(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59579,axiom,
    ! [VarCurr: state_type] :
      ( v98031(VarCurr)
    <=> v98033(VarCurr) ) ).

tff(addAssignment_59578,axiom,
    ! [VarCurr: state_type] :
      ( v98033(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59577,axiom,
    ! [VarCurr: state_type] :
      ( v98027(VarCurr)
    <=> v98029(VarCurr) ) ).

tff(addAssignment_59576,axiom,
    ! [VarCurr: state_type] :
      ( v98029(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97965(VarCurr,B)
      <=> v97967(VarCurr,B) ) ) ).

tff(addAssignment_59574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97967(VarCurr,B)
      <=> v97969(VarCurr,B) ) ) ).

tff(addAssignment_59573,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97969(VarNext,B)
      <=> v98003(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98004(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v98003(VarNext,B)
            <=> v97969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1106,axiom,
    ! [VarNext: state_type] :
      ( v98004(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98003(VarNext,B)
          <=> v98014(VarNext,B) ) ) ) ).

tff(addAssignment_59572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98014(VarNext,B)
          <=> v98012(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98012(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_621,axiom,
    ! [VarCurr: state_type] :
      ( v98015(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v98012(VarCurr,B)
          <=> v97979(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9030,axiom,
    ! [VarCurr: state_type] :
      ( v98015(VarCurr)
    <=> ( v98016(VarCurr)
        & v98017(VarCurr) ) ) ).

tff(writeUnaryOperator_4524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98017(VarCurr)
    <=> v97975(VarCurr) ) ).

tff(writeUnaryOperator_4523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v98016(VarCurr)
    <=> v97971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98004(VarNext)
      <=> v98005(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98005(VarNext)
      <=> ( v98006(VarNext)
          & v97999(VarNext) ) ) ) ).

tff(writeUnaryOperator_4522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v98006(VarNext)
      <=> v98008(VarNext) ) ) ).

tff(addAssignment_59571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v98008(VarNext)
      <=> v97999(VarCurr) ) ) ).

tff(addAssignment_59570,axiom,
    ! [VarCurr: state_type] :
      ( v97999(VarCurr)
    <=> v98001(VarCurr) ) ).

tff(addAssignment_59569,axiom,
    ! [VarCurr: state_type] :
      ( v98001(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97979(VarCurr,B)
      <=> v97981(VarCurr,B) ) ) ).

tff(addAssignment_59567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97981(VarCurr,B)
      <=> v97990(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97990(VarCurr,B)
      <=> ( v97991(VarCurr,B)
          | v97994(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97994(VarCurr,B)
      <=> ( v97967(VarCurr,B)
          & v97995(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97995(VarCurr,B)
      <=> ~ v97996(VarCurr,B) ) ) ).

tff(addAssignment_59566,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,0)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59565,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,1)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59564,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,2)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59563,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,3)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59562,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,4)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59561,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,5)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59560,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,6)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59559,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,7)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59558,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,8)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59557,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,9)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59556,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,10)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59555,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,11)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59554,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,12)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59553,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,13)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59552,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,14)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59551,axiom,
    ! [VarCurr: state_type] :
      ( v97996(VarCurr,15)
    <=> v97997(VarCurr) ) ).

tff(addAssignment_59550,axiom,
    ! [VarCurr: state_type] :
      ( v97997(VarCurr)
    <=> v97985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97991(VarCurr,B)
      <=> ( v97983(VarCurr,B)
          & v97992(VarCurr,B) ) ) ) ).

tff(addAssignment_59549,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,0)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59548,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,1)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59547,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,2)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59546,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,3)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59545,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,4)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59544,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,5)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59543,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,6)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59542,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,7)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59541,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,8)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59540,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,9)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59539,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,10)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59538,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,11)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59537,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,12)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59536,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,13)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59535,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,14)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59534,axiom,
    ! [VarCurr: state_type] :
      ( v97992(VarCurr,15)
    <=> v97993(VarCurr) ) ).

tff(addAssignment_59533,axiom,
    ! [VarCurr: state_type] :
      ( v97993(VarCurr)
    <=> v97985(VarCurr) ) ).

tff(addAssignment_59532,axiom,
    ! [VarCurr: state_type] :
      ( v97985(VarCurr)
    <=> v97987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9027,axiom,
    ! [VarCurr: state_type] :
      ( v97987(VarCurr)
    <=> ( v97276(VarCurr)
        & v97989(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_539,axiom,
    ! [VarCurr: state_type] :
      ( v97989(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97983(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59530,axiom,
    ! [VarCurr: state_type] :
      ( v97975(VarCurr)
    <=> v97977(VarCurr) ) ).

tff(addAssignment_59529,axiom,
    ! [VarCurr: state_type] :
      ( v97977(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59528,axiom,
    ! [VarCurr: state_type] :
      ( v97971(VarCurr)
    <=> v97973(VarCurr) ) ).

tff(addAssignment_59527,axiom,
    ! [VarCurr: state_type] :
      ( v97973(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97909(VarCurr,B)
      <=> v97911(VarCurr,B) ) ) ).

tff(addAssignment_59525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97911(VarCurr,B)
      <=> v97913(VarCurr,B) ) ) ).

tff(addAssignment_59524,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97913(VarNext,B)
      <=> v97947(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97948(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97947(VarNext,B)
            <=> v97913(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1105,axiom,
    ! [VarNext: state_type] :
      ( v97948(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97947(VarNext,B)
          <=> v97958(VarNext,B) ) ) ) ).

tff(addAssignment_59523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97958(VarNext,B)
          <=> v97956(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97959(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97956(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_620,axiom,
    ! [VarCurr: state_type] :
      ( v97959(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97956(VarCurr,B)
          <=> v97923(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9026,axiom,
    ! [VarCurr: state_type] :
      ( v97959(VarCurr)
    <=> ( v97960(VarCurr)
        & v97961(VarCurr) ) ) ).

tff(writeUnaryOperator_4520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97961(VarCurr)
    <=> v97919(VarCurr) ) ).

tff(writeUnaryOperator_4519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97960(VarCurr)
    <=> v97915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97948(VarNext)
      <=> v97949(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97949(VarNext)
      <=> ( v97950(VarNext)
          & v97943(VarNext) ) ) ) ).

tff(writeUnaryOperator_4518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97950(VarNext)
      <=> v97952(VarNext) ) ) ).

tff(addAssignment_59522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97952(VarNext)
      <=> v97943(VarCurr) ) ) ).

tff(addAssignment_59521,axiom,
    ! [VarCurr: state_type] :
      ( v97943(VarCurr)
    <=> v97945(VarCurr) ) ).

tff(addAssignment_59520,axiom,
    ! [VarCurr: state_type] :
      ( v97945(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97923(VarCurr,B)
      <=> v97925(VarCurr,B) ) ) ).

tff(addAssignment_59518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97925(VarCurr,B)
      <=> v97934(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97934(VarCurr,B)
      <=> ( v97935(VarCurr,B)
          | v97938(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97938(VarCurr,B)
      <=> ( v97911(VarCurr,B)
          & v97939(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97939(VarCurr,B)
      <=> ~ v97940(VarCurr,B) ) ) ).

tff(addAssignment_59517,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,0)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59516,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,1)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59515,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,2)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59514,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,3)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59513,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,4)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59512,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,5)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59511,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,6)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59510,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,7)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59509,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,8)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59508,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,9)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59507,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,10)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59506,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,11)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59505,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,12)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59504,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,13)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59503,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,14)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59502,axiom,
    ! [VarCurr: state_type] :
      ( v97940(VarCurr,15)
    <=> v97941(VarCurr) ) ).

tff(addAssignment_59501,axiom,
    ! [VarCurr: state_type] :
      ( v97941(VarCurr)
    <=> v97929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1269,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97935(VarCurr,B)
      <=> ( v97927(VarCurr,B)
          & v97936(VarCurr,B) ) ) ) ).

tff(addAssignment_59500,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,0)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59499,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,1)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59498,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,2)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59497,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,3)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59496,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,4)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59495,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,5)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59494,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,6)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59493,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,7)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59492,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,8)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59491,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,9)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59490,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,10)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59489,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,11)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59488,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,12)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59487,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,13)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59486,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,14)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59485,axiom,
    ! [VarCurr: state_type] :
      ( v97936(VarCurr,15)
    <=> v97937(VarCurr) ) ).

tff(addAssignment_59484,axiom,
    ! [VarCurr: state_type] :
      ( v97937(VarCurr)
    <=> v97929(VarCurr) ) ).

tff(addAssignment_59483,axiom,
    ! [VarCurr: state_type] :
      ( v97929(VarCurr)
    <=> v97931(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9023,axiom,
    ! [VarCurr: state_type] :
      ( v97931(VarCurr)
    <=> ( v97276(VarCurr)
        & v97933(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_538,axiom,
    ! [VarCurr: state_type] :
      ( v97933(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $true )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97927(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59481,axiom,
    ! [VarCurr: state_type] :
      ( v97919(VarCurr)
    <=> v97921(VarCurr) ) ).

tff(addAssignment_59480,axiom,
    ! [VarCurr: state_type] :
      ( v97921(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59479,axiom,
    ! [VarCurr: state_type] :
      ( v97915(VarCurr)
    <=> v97917(VarCurr) ) ).

tff(addAssignment_59478,axiom,
    ! [VarCurr: state_type] :
      ( v97917(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97853(VarCurr,B)
      <=> v97855(VarCurr,B) ) ) ).

tff(addAssignment_59476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97855(VarCurr,B)
      <=> v97857(VarCurr,B) ) ) ).

tff(addAssignment_59475,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97857(VarNext,B)
      <=> v97891(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97892(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97891(VarNext,B)
            <=> v97857(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1104,axiom,
    ! [VarNext: state_type] :
      ( v97892(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97891(VarNext,B)
          <=> v97902(VarNext,B) ) ) ) ).

tff(addAssignment_59474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97902(VarNext,B)
          <=> v97900(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97900(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_619,axiom,
    ! [VarCurr: state_type] :
      ( v97903(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97900(VarCurr,B)
          <=> v97867(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9022,axiom,
    ! [VarCurr: state_type] :
      ( v97903(VarCurr)
    <=> ( v97904(VarCurr)
        & v97905(VarCurr) ) ) ).

tff(writeUnaryOperator_4516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97905(VarCurr)
    <=> v97863(VarCurr) ) ).

tff(writeUnaryOperator_4515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97904(VarCurr)
    <=> v97859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97892(VarNext)
      <=> v97893(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9020,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97893(VarNext)
      <=> ( v97894(VarNext)
          & v97887(VarNext) ) ) ) ).

tff(writeUnaryOperator_4514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97894(VarNext)
      <=> v97896(VarNext) ) ) ).

tff(addAssignment_59473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97896(VarNext)
      <=> v97887(VarCurr) ) ) ).

tff(addAssignment_59472,axiom,
    ! [VarCurr: state_type] :
      ( v97887(VarCurr)
    <=> v97889(VarCurr) ) ).

tff(addAssignment_59471,axiom,
    ! [VarCurr: state_type] :
      ( v97889(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97867(VarCurr,B)
      <=> v97869(VarCurr,B) ) ) ).

tff(addAssignment_59469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97869(VarCurr,B)
      <=> v97878(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97878(VarCurr,B)
      <=> ( v97879(VarCurr,B)
          | v97882(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97882(VarCurr,B)
      <=> ( v97855(VarCurr,B)
          & v97883(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97883(VarCurr,B)
      <=> ~ v97884(VarCurr,B) ) ) ).

tff(addAssignment_59468,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,0)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59467,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,1)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59466,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,2)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59465,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,3)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59464,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,4)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59463,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,5)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59462,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,6)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59461,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,7)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59460,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,8)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59459,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,9)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59458,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,10)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59457,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,11)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59456,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,12)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59455,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,13)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59454,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,14)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59453,axiom,
    ! [VarCurr: state_type] :
      ( v97884(VarCurr,15)
    <=> v97885(VarCurr) ) ).

tff(addAssignment_59452,axiom,
    ! [VarCurr: state_type] :
      ( v97885(VarCurr)
    <=> v97873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97879(VarCurr,B)
      <=> ( v97871(VarCurr,B)
          & v97880(VarCurr,B) ) ) ) ).

tff(addAssignment_59451,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,0)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59450,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,1)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59449,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,2)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59448,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,3)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59447,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,4)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59446,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,5)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59445,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,6)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59444,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,7)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59443,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,8)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59442,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,9)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59441,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,10)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59440,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,11)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59439,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,12)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59438,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,13)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59437,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,14)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59436,axiom,
    ! [VarCurr: state_type] :
      ( v97880(VarCurr,15)
    <=> v97881(VarCurr) ) ).

tff(addAssignment_59435,axiom,
    ! [VarCurr: state_type] :
      ( v97881(VarCurr)
    <=> v97873(VarCurr) ) ).

tff(addAssignment_59434,axiom,
    ! [VarCurr: state_type] :
      ( v97873(VarCurr)
    <=> v97875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9019,axiom,
    ! [VarCurr: state_type] :
      ( v97875(VarCurr)
    <=> ( v97276(VarCurr)
        & v97877(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_537,axiom,
    ! [VarCurr: state_type] :
      ( v97877(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97871(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59432,axiom,
    ! [VarCurr: state_type] :
      ( v97863(VarCurr)
    <=> v97865(VarCurr) ) ).

tff(addAssignment_59431,axiom,
    ! [VarCurr: state_type] :
      ( v97865(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59430,axiom,
    ! [VarCurr: state_type] :
      ( v97859(VarCurr)
    <=> v97861(VarCurr) ) ).

tff(addAssignment_59429,axiom,
    ! [VarCurr: state_type] :
      ( v97861(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97797(VarCurr,B)
      <=> v97799(VarCurr,B) ) ) ).

tff(addAssignment_59427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97799(VarCurr,B)
      <=> v97801(VarCurr,B) ) ) ).

tff(addAssignment_59426,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97801(VarNext,B)
      <=> v97835(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97836(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97835(VarNext,B)
            <=> v97801(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1103,axiom,
    ! [VarNext: state_type] :
      ( v97836(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97835(VarNext,B)
          <=> v97846(VarNext,B) ) ) ) ).

tff(addAssignment_59425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97846(VarNext,B)
          <=> v97844(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97844(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_618,axiom,
    ! [VarCurr: state_type] :
      ( v97847(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97844(VarCurr,B)
          <=> v97811(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9018,axiom,
    ! [VarCurr: state_type] :
      ( v97847(VarCurr)
    <=> ( v97848(VarCurr)
        & v97849(VarCurr) ) ) ).

tff(writeUnaryOperator_4512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97849(VarCurr)
    <=> v97807(VarCurr) ) ).

tff(writeUnaryOperator_4511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97848(VarCurr)
    <=> v97803(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97836(VarNext)
      <=> v97837(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97837(VarNext)
      <=> ( v97838(VarNext)
          & v97831(VarNext) ) ) ) ).

tff(writeUnaryOperator_4510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97838(VarNext)
      <=> v97840(VarNext) ) ) ).

tff(addAssignment_59424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97840(VarNext)
      <=> v97831(VarCurr) ) ) ).

tff(addAssignment_59423,axiom,
    ! [VarCurr: state_type] :
      ( v97831(VarCurr)
    <=> v97833(VarCurr) ) ).

tff(addAssignment_59422,axiom,
    ! [VarCurr: state_type] :
      ( v97833(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97811(VarCurr,B)
      <=> v97813(VarCurr,B) ) ) ).

tff(addAssignment_59420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97813(VarCurr,B)
      <=> v97822(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97822(VarCurr,B)
      <=> ( v97823(VarCurr,B)
          | v97826(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97826(VarCurr,B)
      <=> ( v97799(VarCurr,B)
          & v97827(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97827(VarCurr,B)
      <=> ~ v97828(VarCurr,B) ) ) ).

tff(addAssignment_59419,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,0)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59418,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,1)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59417,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,2)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59416,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,3)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59415,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,4)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59414,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,5)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59413,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,6)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59412,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,7)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59411,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,8)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59410,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,9)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59409,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,10)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59408,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,11)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59407,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,12)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59406,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,13)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59405,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,14)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59404,axiom,
    ! [VarCurr: state_type] :
      ( v97828(VarCurr,15)
    <=> v97829(VarCurr) ) ).

tff(addAssignment_59403,axiom,
    ! [VarCurr: state_type] :
      ( v97829(VarCurr)
    <=> v97817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97823(VarCurr,B)
      <=> ( v97815(VarCurr,B)
          & v97824(VarCurr,B) ) ) ) ).

tff(addAssignment_59402,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,0)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59401,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,1)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59400,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,2)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59399,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,3)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59398,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,4)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59397,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,5)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59396,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,6)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59395,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,7)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59394,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,8)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59393,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,9)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59392,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,10)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59391,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,11)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59390,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,12)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59389,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,13)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59388,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,14)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59387,axiom,
    ! [VarCurr: state_type] :
      ( v97824(VarCurr,15)
    <=> v97825(VarCurr) ) ).

tff(addAssignment_59386,axiom,
    ! [VarCurr: state_type] :
      ( v97825(VarCurr)
    <=> v97817(VarCurr) ) ).

tff(addAssignment_59385,axiom,
    ! [VarCurr: state_type] :
      ( v97817(VarCurr)
    <=> v97819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9015,axiom,
    ! [VarCurr: state_type] :
      ( v97819(VarCurr)
    <=> ( v97276(VarCurr)
        & v97821(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_536,axiom,
    ! [VarCurr: state_type] :
      ( v97821(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97815(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59383,axiom,
    ! [VarCurr: state_type] :
      ( v97807(VarCurr)
    <=> v97809(VarCurr) ) ).

tff(addAssignment_59382,axiom,
    ! [VarCurr: state_type] :
      ( v97809(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59381,axiom,
    ! [VarCurr: state_type] :
      ( v97803(VarCurr)
    <=> v97805(VarCurr) ) ).

tff(addAssignment_59380,axiom,
    ! [VarCurr: state_type] :
      ( v97805(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97741(VarCurr,B)
      <=> v97743(VarCurr,B) ) ) ).

tff(addAssignment_59378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97743(VarCurr,B)
      <=> v97745(VarCurr,B) ) ) ).

tff(addAssignment_59377,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97745(VarNext,B)
      <=> v97779(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97780(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97779(VarNext,B)
            <=> v97745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1102,axiom,
    ! [VarNext: state_type] :
      ( v97780(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97779(VarNext,B)
          <=> v97790(VarNext,B) ) ) ) ).

tff(addAssignment_59376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97790(VarNext,B)
          <=> v97788(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97791(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97788(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_617,axiom,
    ! [VarCurr: state_type] :
      ( v97791(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97788(VarCurr,B)
          <=> v97755(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9014,axiom,
    ! [VarCurr: state_type] :
      ( v97791(VarCurr)
    <=> ( v97792(VarCurr)
        & v97793(VarCurr) ) ) ).

tff(writeUnaryOperator_4508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97793(VarCurr)
    <=> v97751(VarCurr) ) ).

tff(writeUnaryOperator_4507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97792(VarCurr)
    <=> v97747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97780(VarNext)
      <=> v97781(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97781(VarNext)
      <=> ( v97782(VarNext)
          & v97775(VarNext) ) ) ) ).

tff(writeUnaryOperator_4506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97782(VarNext)
      <=> v97784(VarNext) ) ) ).

tff(addAssignment_59375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97784(VarNext)
      <=> v97775(VarCurr) ) ) ).

tff(addAssignment_59374,axiom,
    ! [VarCurr: state_type] :
      ( v97775(VarCurr)
    <=> v97777(VarCurr) ) ).

tff(addAssignment_59373,axiom,
    ! [VarCurr: state_type] :
      ( v97777(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97755(VarCurr,B)
      <=> v97757(VarCurr,B) ) ) ).

tff(addAssignment_59371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97757(VarCurr,B)
      <=> v97766(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97766(VarCurr,B)
      <=> ( v97767(VarCurr,B)
          | v97770(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97770(VarCurr,B)
      <=> ( v97743(VarCurr,B)
          & v97771(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97771(VarCurr,B)
      <=> ~ v97772(VarCurr,B) ) ) ).

tff(addAssignment_59370,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,0)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59369,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,1)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59368,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,2)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59367,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,3)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59366,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,4)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59365,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,5)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59364,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,6)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59363,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,7)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59362,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,8)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59361,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,9)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59360,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,10)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59359,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,11)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59358,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,12)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59357,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,13)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59356,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,14)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59355,axiom,
    ! [VarCurr: state_type] :
      ( v97772(VarCurr,15)
    <=> v97773(VarCurr) ) ).

tff(addAssignment_59354,axiom,
    ! [VarCurr: state_type] :
      ( v97773(VarCurr)
    <=> v97761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97767(VarCurr,B)
      <=> ( v97759(VarCurr,B)
          & v97768(VarCurr,B) ) ) ) ).

tff(addAssignment_59353,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,0)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59352,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,1)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59351,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,2)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59350,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,3)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59349,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,4)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59348,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,5)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59347,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,6)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59346,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,7)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59345,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,8)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59344,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,9)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59343,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,10)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59342,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,11)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59341,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,12)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59340,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,13)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59339,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,14)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59338,axiom,
    ! [VarCurr: state_type] :
      ( v97768(VarCurr,15)
    <=> v97769(VarCurr) ) ).

tff(addAssignment_59337,axiom,
    ! [VarCurr: state_type] :
      ( v97769(VarCurr)
    <=> v97761(VarCurr) ) ).

tff(addAssignment_59336,axiom,
    ! [VarCurr: state_type] :
      ( v97761(VarCurr)
    <=> v97763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9011,axiom,
    ! [VarCurr: state_type] :
      ( v97763(VarCurr)
    <=> ( v97276(VarCurr)
        & v97765(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_535,axiom,
    ! [VarCurr: state_type] :
      ( v97765(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97759(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59334,axiom,
    ! [VarCurr: state_type] :
      ( v97751(VarCurr)
    <=> v97753(VarCurr) ) ).

tff(addAssignment_59333,axiom,
    ! [VarCurr: state_type] :
      ( v97753(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59332,axiom,
    ! [VarCurr: state_type] :
      ( v97747(VarCurr)
    <=> v97749(VarCurr) ) ).

tff(addAssignment_59331,axiom,
    ! [VarCurr: state_type] :
      ( v97749(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97685(VarCurr,B)
      <=> v97687(VarCurr,B) ) ) ).

tff(addAssignment_59329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97687(VarCurr,B)
      <=> v97689(VarCurr,B) ) ) ).

tff(addAssignment_59328,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97689(VarNext,B)
      <=> v97723(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97724(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97723(VarNext,B)
            <=> v97689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1101,axiom,
    ! [VarNext: state_type] :
      ( v97724(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97723(VarNext,B)
          <=> v97734(VarNext,B) ) ) ) ).

tff(addAssignment_59327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97734(VarNext,B)
          <=> v97732(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97732(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_616,axiom,
    ! [VarCurr: state_type] :
      ( v97735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97732(VarCurr,B)
          <=> v97699(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9010,axiom,
    ! [VarCurr: state_type] :
      ( v97735(VarCurr)
    <=> ( v97736(VarCurr)
        & v97737(VarCurr) ) ) ).

tff(writeUnaryOperator_4504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97737(VarCurr)
    <=> v97695(VarCurr) ) ).

tff(writeUnaryOperator_4503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97736(VarCurr)
    <=> v97691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97724(VarNext)
      <=> v97725(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97725(VarNext)
      <=> ( v97726(VarNext)
          & v97719(VarNext) ) ) ) ).

tff(writeUnaryOperator_4502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97726(VarNext)
      <=> v97728(VarNext) ) ) ).

tff(addAssignment_59326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97728(VarNext)
      <=> v97719(VarCurr) ) ) ).

tff(addAssignment_59325,axiom,
    ! [VarCurr: state_type] :
      ( v97719(VarCurr)
    <=> v97721(VarCurr) ) ).

tff(addAssignment_59324,axiom,
    ! [VarCurr: state_type] :
      ( v97721(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97699(VarCurr,B)
      <=> v97701(VarCurr,B) ) ) ).

tff(addAssignment_59322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97701(VarCurr,B)
      <=> v97710(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97710(VarCurr,B)
      <=> ( v97711(VarCurr,B)
          | v97714(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97714(VarCurr,B)
      <=> ( v97687(VarCurr,B)
          & v97715(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97715(VarCurr,B)
      <=> ~ v97716(VarCurr,B) ) ) ).

tff(addAssignment_59321,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,0)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59320,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,1)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59319,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,2)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59318,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,3)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59317,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,4)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59316,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,5)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59315,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,6)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59314,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,7)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59313,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,8)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59312,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,9)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59311,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,10)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59310,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,11)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59309,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,12)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59308,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,13)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59307,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,14)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59306,axiom,
    ! [VarCurr: state_type] :
      ( v97716(VarCurr,15)
    <=> v97717(VarCurr) ) ).

tff(addAssignment_59305,axiom,
    ! [VarCurr: state_type] :
      ( v97717(VarCurr)
    <=> v97705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97711(VarCurr,B)
      <=> ( v97703(VarCurr,B)
          & v97712(VarCurr,B) ) ) ) ).

tff(addAssignment_59304,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,0)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59303,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,1)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59302,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,2)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59301,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,3)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59300,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,4)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59299,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,5)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59298,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,6)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59297,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,7)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59296,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,8)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59295,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,9)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59294,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,10)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59293,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,11)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59292,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,12)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59291,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,13)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59290,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,14)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59289,axiom,
    ! [VarCurr: state_type] :
      ( v97712(VarCurr,15)
    <=> v97713(VarCurr) ) ).

tff(addAssignment_59288,axiom,
    ! [VarCurr: state_type] :
      ( v97713(VarCurr)
    <=> v97705(VarCurr) ) ).

tff(addAssignment_59287,axiom,
    ! [VarCurr: state_type] :
      ( v97705(VarCurr)
    <=> v97707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9007,axiom,
    ! [VarCurr: state_type] :
      ( v97707(VarCurr)
    <=> ( v97276(VarCurr)
        & v97709(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_534,axiom,
    ! [VarCurr: state_type] :
      ( v97709(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $true )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97703(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59285,axiom,
    ! [VarCurr: state_type] :
      ( v97695(VarCurr)
    <=> v97697(VarCurr) ) ).

tff(addAssignment_59284,axiom,
    ! [VarCurr: state_type] :
      ( v97697(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59283,axiom,
    ! [VarCurr: state_type] :
      ( v97691(VarCurr)
    <=> v97693(VarCurr) ) ).

tff(addAssignment_59282,axiom,
    ! [VarCurr: state_type] :
      ( v97693(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97629(VarCurr,B)
      <=> v97631(VarCurr,B) ) ) ).

tff(addAssignment_59280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97631(VarCurr,B)
      <=> v97633(VarCurr,B) ) ) ).

tff(addAssignment_59279,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97633(VarNext,B)
      <=> v97667(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97668(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97667(VarNext,B)
            <=> v97633(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1100,axiom,
    ! [VarNext: state_type] :
      ( v97668(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97667(VarNext,B)
          <=> v97678(VarNext,B) ) ) ) ).

tff(addAssignment_59278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97678(VarNext,B)
          <=> v97676(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97679(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97676(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_615,axiom,
    ! [VarCurr: state_type] :
      ( v97679(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97676(VarCurr,B)
          <=> v97643(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9006,axiom,
    ! [VarCurr: state_type] :
      ( v97679(VarCurr)
    <=> ( v97680(VarCurr)
        & v97681(VarCurr) ) ) ).

tff(writeUnaryOperator_4500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97681(VarCurr)
    <=> v97639(VarCurr) ) ).

tff(writeUnaryOperator_4499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97680(VarCurr)
    <=> v97635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97668(VarNext)
      <=> v97669(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97669(VarNext)
      <=> ( v97670(VarNext)
          & v97663(VarNext) ) ) ) ).

tff(writeUnaryOperator_4498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97670(VarNext)
      <=> v97672(VarNext) ) ) ).

tff(addAssignment_59277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97672(VarNext)
      <=> v97663(VarCurr) ) ) ).

tff(addAssignment_59276,axiom,
    ! [VarCurr: state_type] :
      ( v97663(VarCurr)
    <=> v97665(VarCurr) ) ).

tff(addAssignment_59275,axiom,
    ! [VarCurr: state_type] :
      ( v97665(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97643(VarCurr,B)
      <=> v97645(VarCurr,B) ) ) ).

tff(addAssignment_59273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97645(VarCurr,B)
      <=> v97654(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97654(VarCurr,B)
      <=> ( v97655(VarCurr,B)
          | v97658(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97658(VarCurr,B)
      <=> ( v97631(VarCurr,B)
          & v97659(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97659(VarCurr,B)
      <=> ~ v97660(VarCurr,B) ) ) ).

tff(addAssignment_59272,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,0)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59271,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,1)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59270,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,2)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59269,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,3)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59268,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,4)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59267,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,5)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59266,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,6)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59265,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,7)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59264,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,8)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59263,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,9)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59262,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,10)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59261,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,11)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59260,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,12)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59259,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,13)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59258,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,14)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59257,axiom,
    ! [VarCurr: state_type] :
      ( v97660(VarCurr,15)
    <=> v97661(VarCurr) ) ).

tff(addAssignment_59256,axiom,
    ! [VarCurr: state_type] :
      ( v97661(VarCurr)
    <=> v97649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97655(VarCurr,B)
      <=> ( v97647(VarCurr,B)
          & v97656(VarCurr,B) ) ) ) ).

tff(addAssignment_59255,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,0)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59254,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,1)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59253,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,2)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59252,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,3)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59251,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,4)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59250,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,5)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59249,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,6)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59248,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,7)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59247,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,8)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59246,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,9)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59245,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,10)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59244,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,11)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59243,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,12)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59242,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,13)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59241,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,14)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59240,axiom,
    ! [VarCurr: state_type] :
      ( v97656(VarCurr,15)
    <=> v97657(VarCurr) ) ).

tff(addAssignment_59239,axiom,
    ! [VarCurr: state_type] :
      ( v97657(VarCurr)
    <=> v97649(VarCurr) ) ).

tff(addAssignment_59238,axiom,
    ! [VarCurr: state_type] :
      ( v97649(VarCurr)
    <=> v97651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9003,axiom,
    ! [VarCurr: state_type] :
      ( v97651(VarCurr)
    <=> ( v97276(VarCurr)
        & v97653(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_533,axiom,
    ! [VarCurr: state_type] :
      ( v97653(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97647(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59236,axiom,
    ! [VarCurr: state_type] :
      ( v97639(VarCurr)
    <=> v97641(VarCurr) ) ).

tff(addAssignment_59235,axiom,
    ! [VarCurr: state_type] :
      ( v97641(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59234,axiom,
    ! [VarCurr: state_type] :
      ( v97635(VarCurr)
    <=> v97637(VarCurr) ) ).

tff(addAssignment_59233,axiom,
    ! [VarCurr: state_type] :
      ( v97637(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97573(VarCurr,B)
      <=> v97575(VarCurr,B) ) ) ).

tff(addAssignment_59231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97575(VarCurr,B)
      <=> v97577(VarCurr,B) ) ) ).

tff(addAssignment_59230,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97577(VarNext,B)
      <=> v97611(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97612(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97611(VarNext,B)
            <=> v97577(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1099,axiom,
    ! [VarNext: state_type] :
      ( v97612(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97611(VarNext,B)
          <=> v97622(VarNext,B) ) ) ) ).

tff(addAssignment_59229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97622(VarNext,B)
          <=> v97620(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97623(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97620(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_614,axiom,
    ! [VarCurr: state_type] :
      ( v97623(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97620(VarCurr,B)
          <=> v97587(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9002,axiom,
    ! [VarCurr: state_type] :
      ( v97623(VarCurr)
    <=> ( v97624(VarCurr)
        & v97625(VarCurr) ) ) ).

tff(writeUnaryOperator_4496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97625(VarCurr)
    <=> v97583(VarCurr) ) ).

tff(writeUnaryOperator_4495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97624(VarCurr)
    <=> v97579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97612(VarNext)
      <=> v97613(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97613(VarNext)
      <=> ( v97614(VarNext)
          & v97607(VarNext) ) ) ) ).

tff(writeUnaryOperator_4494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97614(VarNext)
      <=> v97616(VarNext) ) ) ).

tff(addAssignment_59228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97616(VarNext)
      <=> v97607(VarCurr) ) ) ).

tff(addAssignment_59227,axiom,
    ! [VarCurr: state_type] :
      ( v97607(VarCurr)
    <=> v97609(VarCurr) ) ).

tff(addAssignment_59226,axiom,
    ! [VarCurr: state_type] :
      ( v97609(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97587(VarCurr,B)
      <=> v97589(VarCurr,B) ) ) ).

tff(addAssignment_59224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97589(VarCurr,B)
      <=> v97598(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97598(VarCurr,B)
      <=> ( v97599(VarCurr,B)
          | v97602(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97602(VarCurr,B)
      <=> ( v97575(VarCurr,B)
          & v97603(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97603(VarCurr,B)
      <=> ~ v97604(VarCurr,B) ) ) ).

tff(addAssignment_59223,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,0)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59222,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,1)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59221,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,2)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59220,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,3)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59219,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,4)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59218,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,5)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59217,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,6)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59216,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,7)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59215,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,8)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59214,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,9)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59213,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,10)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59212,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,11)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59211,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,12)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59210,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,13)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59209,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,14)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59208,axiom,
    ! [VarCurr: state_type] :
      ( v97604(VarCurr,15)
    <=> v97605(VarCurr) ) ).

tff(addAssignment_59207,axiom,
    ! [VarCurr: state_type] :
      ( v97605(VarCurr)
    <=> v97593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97599(VarCurr,B)
      <=> ( v97591(VarCurr,B)
          & v97600(VarCurr,B) ) ) ) ).

tff(addAssignment_59206,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,0)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59205,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,1)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59204,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,2)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59203,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,3)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59202,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,4)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59201,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,5)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59200,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,6)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59199,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,7)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59198,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,8)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59197,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,9)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59196,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,10)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59195,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,11)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59194,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,12)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59193,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,13)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59192,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,14)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59191,axiom,
    ! [VarCurr: state_type] :
      ( v97600(VarCurr,15)
    <=> v97601(VarCurr) ) ).

tff(addAssignment_59190,axiom,
    ! [VarCurr: state_type] :
      ( v97601(VarCurr)
    <=> v97593(VarCurr) ) ).

tff(addAssignment_59189,axiom,
    ! [VarCurr: state_type] :
      ( v97593(VarCurr)
    <=> v97595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8999,axiom,
    ! [VarCurr: state_type] :
      ( v97595(VarCurr)
    <=> ( v97276(VarCurr)
        & v97597(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_532,axiom,
    ! [VarCurr: state_type] :
      ( v97597(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $true )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97591(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59187,axiom,
    ! [VarCurr: state_type] :
      ( v97583(VarCurr)
    <=> v97585(VarCurr) ) ).

tff(addAssignment_59186,axiom,
    ! [VarCurr: state_type] :
      ( v97585(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59185,axiom,
    ! [VarCurr: state_type] :
      ( v97579(VarCurr)
    <=> v97581(VarCurr) ) ).

tff(addAssignment_59184,axiom,
    ! [VarCurr: state_type] :
      ( v97581(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97517(VarCurr,B)
      <=> v97519(VarCurr,B) ) ) ).

tff(addAssignment_59182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97519(VarCurr,B)
      <=> v97521(VarCurr,B) ) ) ).

tff(addAssignment_59181,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97521(VarNext,B)
      <=> v97555(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97556(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97555(VarNext,B)
            <=> v97521(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1098,axiom,
    ! [VarNext: state_type] :
      ( v97556(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97555(VarNext,B)
          <=> v97566(VarNext,B) ) ) ) ).

tff(addAssignment_59180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97566(VarNext,B)
          <=> v97564(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97567(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97564(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_613,axiom,
    ! [VarCurr: state_type] :
      ( v97567(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97564(VarCurr,B)
          <=> v97531(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8998,axiom,
    ! [VarCurr: state_type] :
      ( v97567(VarCurr)
    <=> ( v97568(VarCurr)
        & v97569(VarCurr) ) ) ).

tff(writeUnaryOperator_4492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97569(VarCurr)
    <=> v97527(VarCurr) ) ).

tff(writeUnaryOperator_4491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97568(VarCurr)
    <=> v97523(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97556(VarNext)
      <=> v97557(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97557(VarNext)
      <=> ( v97558(VarNext)
          & v97551(VarNext) ) ) ) ).

tff(writeUnaryOperator_4490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97558(VarNext)
      <=> v97560(VarNext) ) ) ).

tff(addAssignment_59179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97560(VarNext)
      <=> v97551(VarCurr) ) ) ).

tff(addAssignment_59178,axiom,
    ! [VarCurr: state_type] :
      ( v97551(VarCurr)
    <=> v97553(VarCurr) ) ).

tff(addAssignment_59177,axiom,
    ! [VarCurr: state_type] :
      ( v97553(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97531(VarCurr,B)
      <=> v97533(VarCurr,B) ) ) ).

tff(addAssignment_59175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97533(VarCurr,B)
      <=> v97542(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97542(VarCurr,B)
      <=> ( v97543(VarCurr,B)
          | v97546(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97546(VarCurr,B)
      <=> ( v97519(VarCurr,B)
          & v97547(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97547(VarCurr,B)
      <=> ~ v97548(VarCurr,B) ) ) ).

tff(addAssignment_59174,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,0)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59173,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,1)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59172,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,2)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59171,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,3)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59170,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,4)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59169,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,5)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59168,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,6)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59167,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,7)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59166,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,8)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59165,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,9)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59164,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,10)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59163,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,11)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59162,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,12)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59161,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,13)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59160,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,14)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59159,axiom,
    ! [VarCurr: state_type] :
      ( v97548(VarCurr,15)
    <=> v97549(VarCurr) ) ).

tff(addAssignment_59158,axiom,
    ! [VarCurr: state_type] :
      ( v97549(VarCurr)
    <=> v97537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97543(VarCurr,B)
      <=> ( v97535(VarCurr,B)
          & v97544(VarCurr,B) ) ) ) ).

tff(addAssignment_59157,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,0)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59156,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,1)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59155,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,2)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59154,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,3)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59153,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,4)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59152,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,5)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59151,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,6)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59150,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,7)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59149,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,8)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59148,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,9)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59147,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,10)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59146,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,11)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59145,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,12)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59144,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,13)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59143,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,14)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59142,axiom,
    ! [VarCurr: state_type] :
      ( v97544(VarCurr,15)
    <=> v97545(VarCurr) ) ).

tff(addAssignment_59141,axiom,
    ! [VarCurr: state_type] :
      ( v97545(VarCurr)
    <=> v97537(VarCurr) ) ).

tff(addAssignment_59140,axiom,
    ! [VarCurr: state_type] :
      ( v97537(VarCurr)
    <=> v97539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8995,axiom,
    ! [VarCurr: state_type] :
      ( v97539(VarCurr)
    <=> ( v97276(VarCurr)
        & v97541(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_531,axiom,
    ! [VarCurr: state_type] :
      ( v97541(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_59139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97535(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59138,axiom,
    ! [VarCurr: state_type] :
      ( v97527(VarCurr)
    <=> v97529(VarCurr) ) ).

tff(addAssignment_59137,axiom,
    ! [VarCurr: state_type] :
      ( v97529(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59136,axiom,
    ! [VarCurr: state_type] :
      ( v97523(VarCurr)
    <=> v97525(VarCurr) ) ).

tff(addAssignment_59135,axiom,
    ! [VarCurr: state_type] :
      ( v97525(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97413(VarCurr,B)
      <=> v97415(VarCurr,B) ) ) ).

tff(addAssignment_59133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97415(VarCurr,B)
      <=> v97417(VarCurr,B) ) ) ).

tff(addAssignment_59132,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97417(VarNext,B)
      <=> v97499(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97500(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97499(VarNext,B)
            <=> v97417(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1097,axiom,
    ! [VarNext: state_type] :
      ( v97500(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97499(VarNext,B)
          <=> v97510(VarNext,B) ) ) ) ).

tff(addAssignment_59131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97510(VarNext,B)
          <=> v97508(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97511(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97508(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_612,axiom,
    ! [VarCurr: state_type] :
      ( v97511(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97508(VarCurr,B)
          <=> v97427(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8994,axiom,
    ! [VarCurr: state_type] :
      ( v97511(VarCurr)
    <=> ( v97512(VarCurr)
        & v97513(VarCurr) ) ) ).

tff(writeUnaryOperator_4488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97513(VarCurr)
    <=> v97423(VarCurr) ) ).

tff(writeUnaryOperator_4487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97512(VarCurr)
    <=> v97419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97500(VarNext)
      <=> v97501(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97501(VarNext)
      <=> ( v97502(VarNext)
          & v97495(VarNext) ) ) ) ).

tff(writeUnaryOperator_4486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97502(VarNext)
      <=> v97504(VarNext) ) ) ).

tff(addAssignment_59130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97504(VarNext)
      <=> v97495(VarCurr) ) ) ).

tff(addAssignment_59129,axiom,
    ! [VarCurr: state_type] :
      ( v97495(VarCurr)
    <=> v97497(VarCurr) ) ).

tff(addAssignment_59128,axiom,
    ! [VarCurr: state_type] :
      ( v97497(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97427(VarCurr,B)
      <=> v97429(VarCurr,B) ) ) ).

tff(addAssignment_59126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97429(VarCurr,B)
      <=> v97486(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97486(VarCurr,B)
      <=> ( v97487(VarCurr,B)
          | v97490(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97490(VarCurr,B)
      <=> ( v97415(VarCurr,B)
          & v97491(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97491(VarCurr,B)
      <=> ~ v97492(VarCurr,B) ) ) ).

tff(addAssignment_59125,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,0)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59124,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,1)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59123,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,2)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59122,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,3)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59121,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,4)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59120,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,5)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59119,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,6)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59118,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,7)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59117,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,8)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59116,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,9)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59115,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,10)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59114,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,11)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59113,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,12)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59112,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,13)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59111,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,14)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59110,axiom,
    ! [VarCurr: state_type] :
      ( v97492(VarCurr,15)
    <=> v97493(VarCurr) ) ).

tff(addAssignment_59109,axiom,
    ! [VarCurr: state_type] :
      ( v97493(VarCurr)
    <=> v97433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97487(VarCurr,B)
      <=> ( v97431(VarCurr,B)
          & v97488(VarCurr,B) ) ) ) ).

tff(addAssignment_59108,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,0)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59107,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,1)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59106,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,2)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59105,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,3)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59104,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,4)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59103,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,5)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59102,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,6)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59101,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,7)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59100,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,8)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59099,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,9)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59098,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,10)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59097,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,11)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59096,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,12)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59095,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,13)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59094,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,14)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59093,axiom,
    ! [VarCurr: state_type] :
      ( v97488(VarCurr,15)
    <=> v97489(VarCurr) ) ).

tff(addAssignment_59092,axiom,
    ! [VarCurr: state_type] :
      ( v97489(VarCurr)
    <=> v97433(VarCurr) ) ).

tff(addAssignment_59091,axiom,
    ! [VarCurr: state_type] :
      ( v97433(VarCurr)
    <=> v97435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8991,axiom,
    ! [VarCurr: state_type] :
      ( v97435(VarCurr)
    <=> ( v97276(VarCurr)
        & v97485(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_530,axiom,
    ! [VarCurr: state_type] :
      ( v97485(VarCurr)
    <=> ( ( v97254(VarCurr,3)
        <=> $false )
        & ( v97254(VarCurr,2)
        <=> $false )
        & ( v97254(VarCurr,1)
        <=> $false )
        & ( v97254(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_59090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97254(VarCurr,B)
      <=> v97256(VarCurr,B) ) ) ).

tff(addAssignment_59089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97256(VarCurr,B)
      <=> v97258(VarCurr,B) ) ) ).

tff(addAssignment_59088,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97258(VarNext,B)
      <=> v97467(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97468(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v97467(VarNext,B)
            <=> v97258(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1096,axiom,
    ! [VarNext: state_type] :
      ( v97468(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97467(VarNext,B)
          <=> v97478(VarNext,B) ) ) ) ).

tff(addAssignment_59087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97478(VarNext,B)
          <=> v97476(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97479(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97476(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_611,axiom,
    ! [VarCurr: state_type] :
      ( v97479(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97476(VarCurr,B)
          <=> v97268(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8990,axiom,
    ! [VarCurr: state_type] :
      ( v97479(VarCurr)
    <=> ( v97480(VarCurr)
        & v97481(VarCurr) ) ) ).

tff(writeUnaryOperator_4484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97481(VarCurr)
    <=> v97264(VarCurr) ) ).

tff(writeUnaryOperator_4483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97480(VarCurr)
    <=> v97260(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97468(VarNext)
      <=> v97469(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97469(VarNext)
      <=> ( v97470(VarNext)
          & v97463(VarNext) ) ) ) ).

tff(writeUnaryOperator_4482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97470(VarNext)
      <=> v97472(VarNext) ) ) ).

tff(addAssignment_59086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97472(VarNext)
      <=> v97463(VarCurr) ) ) ).

tff(addAssignment_59085,axiom,
    ! [VarCurr: state_type] :
      ( v97463(VarCurr)
    <=> v97465(VarCurr) ) ).

tff(addAssignment_59084,axiom,
    ! [VarCurr: state_type] :
      ( v97465(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97268(VarCurr,B)
      <=> v97270(VarCurr,B) ) ) ).

tff(addAssignment_59082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97270(VarCurr,B)
      <=> v97272(VarCurr,B) ) ) ).

tff(addAssignment_59081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97272(VarCurr,B)
      <=> v97274(VarCurr,B) ) ) ).

tff(addAssignment_59080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97274(VarCurr,B)
      <=> v97436(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97276(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97436(VarCurr,B)
          <=> v97254(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_610,axiom,
    ! [VarCurr: state_type] :
      ( v97276(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v97436(VarCurr,B)
          <=> v97437(VarCurr,B) ) ) ) ).

tff(addAssignment_59079,axiom,
    ! [VarCurr: state_type] :
      ( v97437(VarCurr,0)
    <=> v97459(VarCurr) ) ).

tff(addAssignment_59078,axiom,
    ! [VarCurr: state_type] :
      ( v97437(VarCurr,1)
    <=> v97457(VarCurr) ) ).

tff(addAssignment_59077,axiom,
    ! [VarCurr: state_type] :
      ( v97437(VarCurr,2)
    <=> v97452(VarCurr) ) ).

tff(addAssignment_59076,axiom,
    ! [VarCurr: state_type] :
      ( v97437(VarCurr,3)
    <=> v97447(VarCurr) ) ).

tff(addAssignment_59075,axiom,
    ! [VarCurr: state_type] :
      ( v97437(VarCurr,4)
    <=> v97439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8987,axiom,
    ! [VarCurr: state_type] :
      ( v97457(VarCurr)
    <=> ( v97458(VarCurr)
        & v97461(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3740,axiom,
    ! [VarCurr: state_type] :
      ( v97461(VarCurr)
    <=> ( v97254(VarCurr,0)
        | v97254(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8986,axiom,
    ! [VarCurr: state_type] :
      ( v97458(VarCurr)
    <=> ( v97459(VarCurr)
        | v97460(VarCurr) ) ) ).

tff(writeUnaryOperator_4481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97460(VarCurr)
    <=> v97254(VarCurr,1) ) ).

tff(writeUnaryOperator_4480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97459(VarCurr)
    <=> v97254(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8985,axiom,
    ! [VarCurr: state_type] :
      ( v97452(VarCurr)
    <=> ( v97453(VarCurr)
        & v97456(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3739,axiom,
    ! [VarCurr: state_type] :
      ( v97456(VarCurr)
    <=> ( v97444(VarCurr)
        | v97254(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8984,axiom,
    ! [VarCurr: state_type] :
      ( v97453(VarCurr)
    <=> ( v97454(VarCurr)
        | v97455(VarCurr) ) ) ).

tff(writeUnaryOperator_4479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97455(VarCurr)
    <=> v97254(VarCurr,2) ) ).

tff(writeUnaryOperator_4478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97454(VarCurr)
    <=> v97444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8983,axiom,
    ! [VarCurr: state_type] :
      ( v97447(VarCurr)
    <=> ( v97448(VarCurr)
        & v97451(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3738,axiom,
    ! [VarCurr: state_type] :
      ( v97451(VarCurr)
    <=> ( v97443(VarCurr)
        | v97254(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8982,axiom,
    ! [VarCurr: state_type] :
      ( v97448(VarCurr)
    <=> ( v97449(VarCurr)
        | v97450(VarCurr) ) ) ).

tff(writeUnaryOperator_4477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97450(VarCurr)
    <=> v97254(VarCurr,3) ) ).

tff(writeUnaryOperator_4476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97449(VarCurr)
    <=> v97443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8981,axiom,
    ! [VarCurr: state_type] :
      ( v97439(VarCurr)
    <=> ( v97440(VarCurr)
        & v97446(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3737,axiom,
    ! [VarCurr: state_type] :
      ( v97446(VarCurr)
    <=> ( v97442(VarCurr)
        | v97254(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8980,axiom,
    ! [VarCurr: state_type] :
      ( v97440(VarCurr)
    <=> ( v97441(VarCurr)
        | v97445(VarCurr) ) ) ).

tff(writeUnaryOperator_4475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97445(VarCurr)
    <=> v97254(VarCurr,4) ) ).

tff(writeUnaryOperator_4474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97441(VarCurr)
    <=> v97442(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3736,axiom,
    ! [VarCurr: state_type] :
      ( v97442(VarCurr)
    <=> ( v97443(VarCurr)
        & v97254(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3735,axiom,
    ! [VarCurr: state_type] :
      ( v97443(VarCurr)
    <=> ( v97444(VarCurr)
        & v97254(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3734,axiom,
    ! [VarCurr: state_type] :
      ( v97444(VarCurr)
    <=> ( v97254(VarCurr,0)
        & v97254(VarCurr,1) ) ) ).

tff(addAssignment_59074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v97431(VarCurr,B)
      <=> v97409(VarCurr,B) ) ) ).

tff(addAssignment_59073,axiom,
    ! [VarCurr: state_type] :
      ( v97423(VarCurr)
    <=> v97425(VarCurr) ) ).

tff(addAssignment_59072,axiom,
    ! [VarCurr: state_type] :
      ( v97425(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59071,axiom,
    ! [VarCurr: state_type] :
      ( v97419(VarCurr)
    <=> v97421(VarCurr) ) ).

tff(addAssignment_59070,axiom,
    ! [VarCurr: state_type] :
      ( v97421(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59069,axiom,
    ! [VarCurr: state_type] :
      ( v97395(VarCurr)
    <=> v97397(VarCurr) ) ).

tff(addAssignment_59068,axiom,
    ! [VarCurr: state_type] :
      ( v97397(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59067,axiom,
    ! [VarCurr: state_type] :
      ( v97391(VarCurr)
    <=> v97393(VarCurr) ) ).

tff(addAssignment_59066,axiom,
    ! [VarCurr: state_type] :
      ( v97393(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59065,axiom,
    ! [VarCurr: state_type] :
      ( v97327(VarCurr)
    <=> v97329(VarCurr) ) ).

tff(addAssignment_59064,axiom,
    ! [VarCurr: state_type] :
      ( v97329(VarCurr)
    <=> v97331(VarCurr) ) ).

tff(addAssignment_59063,axiom,
    ! [VarCurr: state_type] :
      ( v97331(VarCurr)
    <=> v97333(VarCurr,1) ) ).

tff(addAssignment_59062,axiom,
    ! [VarCurr: state_type] :
      ( v97333(VarCurr,1)
    <=> v97335(VarCurr,1) ) ).

tff(addAssignment_59061,axiom,
    ! [VarNext: state_type] :
      ( v97335(VarNext,1)
    <=> v97363(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97364(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v97363(VarNext,B)
            <=> v97335(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1095,axiom,
    ! [VarNext: state_type] :
      ( v97364(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97363(VarNext,B)
          <=> v97374(VarNext,B) ) ) ) ).

tff(addAssignment_59060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97374(VarNext,B)
          <=> v97372(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97375(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97372(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_609,axiom,
    ! [VarCurr: state_type] :
      ( v97375(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97372(VarCurr,B)
          <=> v97345(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8979,axiom,
    ! [VarCurr: state_type] :
      ( v97375(VarCurr)
    <=> ( v97376(VarCurr)
        & v97377(VarCurr) ) ) ).

tff(writeUnaryOperator_4473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97377(VarCurr)
    <=> v97341(VarCurr) ) ).

tff(writeUnaryOperator_4472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97376(VarCurr)
    <=> v97337(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97364(VarNext)
      <=> v97365(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97365(VarNext)
      <=> ( v97366(VarNext)
          & v97359(VarNext) ) ) ) ).

tff(writeUnaryOperator_4471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97366(VarNext)
      <=> v97368(VarNext) ) ) ).

tff(addAssignment_59059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97368(VarNext)
      <=> v97359(VarCurr) ) ) ).

tff(addAssignment_59058,axiom,
    ! [VarCurr: state_type] :
      ( v97359(VarCurr)
    <=> v97361(VarCurr) ) ).

tff(addAssignment_59057,axiom,
    ! [VarCurr: state_type] :
      ( v97361(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_59056,axiom,
    ! [VarCurr: state_type] :
      ( v97345(VarCurr,1)
    <=> v97347(VarCurr,1) ) ).

tff(addAssignment_59055,axiom,
    ! [VarCurr: state_type] :
      ( v97347(VarCurr,1)
    <=> v97349(VarCurr,1) ) ).

tff(addAssignment_59054,axiom,
    ! [VarCurr: state_type] :
      ( v97349(VarCurr,1)
    <=> v97357(VarCurr,1) ) ).

tff(addAssignment_59053,axiom,
    ! [VarCurr: state_type] :
      ( v97357(VarCurr,0)
    <=> v84185(VarCurr) ) ).

tff(addAssignment_59052,axiom,
    ! [VarCurr: state_type] :
      ( v97357(VarCurr,1)
    <=> v97351(VarCurr) ) ).

tff(addAssignment_59051,axiom,
    ! [VarCurr: state_type] :
      ( v97357(VarCurr,2)
    <=> v88418(VarCurr) ) ).

tff(writeUnaryOperator_4470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97351(VarCurr)
    <=> v97353(VarCurr) ) ).

tff(addAssignment_59050,axiom,
    ! [VarCurr: state_type] :
      ( v97353(VarCurr)
    <=> v97355(VarCurr) ) ).

tff(addAssignment_59049,axiom,
    ! [VarCurr: state_type] :
      ( v97355(VarCurr)
    <=> v84213(VarCurr) ) ).

tff(addAssignment_59048,axiom,
    ! [VarCurr: state_type] :
      ( v97341(VarCurr)
    <=> v97343(VarCurr) ) ).

tff(addAssignment_59047,axiom,
    ! [VarCurr: state_type] :
      ( v97343(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_59046,axiom,
    ! [VarCurr: state_type] :
      ( v97337(VarCurr)
    <=> v97339(VarCurr) ) ).

tff(addAssignment_59045,axiom,
    ! [VarCurr: state_type] :
      ( v97339(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_59044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v97302(VarCurr,B)
      <=> v97304(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97304(VarCurr,B)
          <=> v97319(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_608,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v97304(VarCurr,B)
          <=> v97306(VarCurr,B) ) ) ) ).

tff(addAssignment_59043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v97319(VarCurr,B)
      <=> v97320(VarCurr,B) ) ) ).

tff(addAssignment_59042,axiom,
    ! [VarCurr: state_type] :
      ( v97319(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_59041,axiom,
    ! [VarCurr: state_type] :
      ( v97320(VarCurr,0)
    <=> v97316(VarCurr) ) ).

tff(addAssignment_59040,axiom,
    ! [VarCurr: state_type] :
      ( v97320(VarCurr,1)
    <=> v97314(VarCurr) ) ).

tff(addAssignment_59039,axiom,
    ! [VarCurr: state_type] :
      ( v97306(VarCurr,0)
    <=> v97316(VarCurr) ) ).

tff(addAssignment_59038,axiom,
    ! [VarCurr: state_type] :
      ( v97306(VarCurr,1)
    <=> v97314(VarCurr) ) ).

tff(addAssignment_59037,axiom,
    ! [VarCurr: state_type] :
      ( v97306(VarCurr,2)
    <=> v97308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8976,axiom,
    ! [VarCurr: state_type] :
      ( v97314(VarCurr)
    <=> ( v97315(VarCurr)
        & v97318(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3733,axiom,
    ! [VarCurr: state_type] :
      ( v97318(VarCurr)
    <=> ( v97284(VarCurr,0)
        | v97284(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8975,axiom,
    ! [VarCurr: state_type] :
      ( v97315(VarCurr)
    <=> ( v97316(VarCurr)
        | v97317(VarCurr) ) ) ).

tff(writeUnaryOperator_4469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97317(VarCurr)
    <=> v97284(VarCurr,1) ) ).

tff(writeUnaryOperator_4468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97316(VarCurr)
    <=> v97284(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8974,axiom,
    ! [VarCurr: state_type] :
      ( v97308(VarCurr)
    <=> ( v97309(VarCurr)
        & v97313(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3732,axiom,
    ! [VarCurr: state_type] :
      ( v97313(VarCurr)
    <=> ( v97311(VarCurr)
        | v97284(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8973,axiom,
    ! [VarCurr: state_type] :
      ( v97309(VarCurr)
    <=> ( v97310(VarCurr)
        | v97312(VarCurr) ) ) ).

tff(writeUnaryOperator_4467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97312(VarCurr)
    <=> v97284(VarCurr,2) ) ).

tff(writeUnaryOperator_4466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97310(VarCurr)
    <=> v97311(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3731,axiom,
    ! [VarCurr: state_type] :
      ( v97311(VarCurr)
    <=> ( v97284(VarCurr,0)
        & v97284(VarCurr,1) ) ) ).

tff(addAssignment_59036,axiom,
    ! [VarCurr: state_type] :
      ( v97294(VarCurr)
    <=> v97296(VarCurr) ) ).

tff(addAssignment_59035,axiom,
    ! [VarCurr: state_type] :
      ( v97296(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59034,axiom,
    ! [VarCurr: state_type] :
      ( v97290(VarCurr)
    <=> v97292(VarCurr) ) ).

tff(addAssignment_59033,axiom,
    ! [VarCurr: state_type] :
      ( v97292(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59032,axiom,
    ! [VarCurr: state_type] :
      ( v97280(VarCurr)
    <=> v97282(VarCurr) ) ).

tff(addAssignment_59031,axiom,
    ! [VarCurr: state_type] :
      ( v97282(VarCurr)
    <=> v1051(VarCurr) ) ).

tff(addAssignment_59030,axiom,
    ! [VarCurr: state_type] :
      ( v97264(VarCurr)
    <=> v97266(VarCurr) ) ).

tff(addAssignment_59029,axiom,
    ! [VarCurr: state_type] :
      ( v97266(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59028,axiom,
    ! [VarCurr: state_type] :
      ( v97260(VarCurr)
    <=> v97262(VarCurr) ) ).

tff(addAssignment_59027,axiom,
    ! [VarCurr: state_type] :
      ( v97262(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59026,axiom,
    ! [VarCurr: state_type] :
      ( v97242(VarCurr)
    <=> v97244(VarCurr) ) ).

tff(addAssignment_59025,axiom,
    ! [VarCurr: state_type] :
      ( v97244(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59024,axiom,
    ! [VarCurr: state_type] :
      ( v97238(VarCurr)
    <=> v97240(VarCurr) ) ).

tff(addAssignment_59023,axiom,
    ! [VarCurr: state_type] :
      ( v97240(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59022,axiom,
    ! [VarCurr: state_type] :
      ( v97218(VarCurr)
    <=> v97220(VarCurr) ) ).

tff(addAssignment_59021,axiom,
    ! [VarCurr: state_type] :
      ( v97220(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59020,axiom,
    ! [VarCurr: state_type] :
      ( v97214(VarCurr)
    <=> v97216(VarCurr) ) ).

tff(addAssignment_59019,axiom,
    ! [VarCurr: state_type] :
      ( v97216(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59018,axiom,
    ! [VarCurr: state_type] :
      ( v97196(VarCurr)
    <=> v97198(VarCurr) ) ).

tff(addAssignment_59017,axiom,
    ! [VarCurr: state_type] :
      ( v97198(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_59016,axiom,
    ! [VarCurr: state_type] :
      ( v97192(VarCurr)
    <=> v97194(VarCurr) ) ).

tff(addAssignment_59015,axiom,
    ! [VarCurr: state_type] :
      ( v97194(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_59014,axiom,
    ! [VarCurr: state_type] :
      ( v89580(VarCurr,0)
    <=> v89582(VarCurr,0) ) ).

tff(addAssignment_59013,axiom,
    ! [VarCurr: state_type] :
      ( v89582(VarCurr,0)
    <=> v89584(VarCurr,0) ) ).

tff(addAssignment_59012,axiom,
    ! [VarNext: state_type] :
      ( v89584(VarNext,0)
    <=> v97164(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97165(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v97164(VarNext,B)
            <=> v89584(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1094,axiom,
    ! [VarNext: state_type] :
      ( v97165(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97164(VarNext,B)
          <=> v97175(VarNext,B) ) ) ) ).

tff(addAssignment_59011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97175(VarNext,B)
          <=> v97173(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97176(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97173(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_607,axiom,
    ! [VarCurr: state_type] :
      ( v97176(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v97173(VarCurr,B)
          <=> v89602(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8972,axiom,
    ! [VarCurr: state_type] :
      ( v97176(VarCurr)
    <=> ( v97177(VarCurr)
        & v97178(VarCurr) ) ) ).

tff(writeUnaryOperator_4465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97178(VarCurr)
    <=> v89594(VarCurr) ) ).

tff(writeUnaryOperator_4464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97177(VarCurr)
    <=> v89586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97165(VarNext)
      <=> v97166(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97166(VarNext)
      <=> ( v97167(VarNext)
          & v97158(VarNext) ) ) ) ).

tff(writeUnaryOperator_4463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97167(VarNext)
      <=> v97169(VarNext) ) ) ).

tff(addAssignment_59010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97169(VarNext)
      <=> v97158(VarCurr) ) ) ).

tff(addAssignment_59009,axiom,
    ! [VarCurr: state_type] :
      ( v97158(VarCurr)
    <=> v97160(VarCurr) ) ).

tff(addAssignment_59008,axiom,
    ! [VarCurr: state_type] :
      ( v97160(VarCurr)
    <=> v97162(VarCurr) ) ).

tff(addAssignment_59007,axiom,
    ! [VarCurr: state_type] :
      ( v97162(VarCurr)
    <=> v216(VarCurr) ) ).

tff(addAssignment_59006,axiom,
    ! [VarCurr: state_type] :
      ( v89602(VarCurr,0)
    <=> v89604(VarCurr,0) ) ).

tff(addAssignment_59005,axiom,
    ! [VarCurr: state_type] :
      ( v89604(VarCurr,0)
    <=> v97153(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97153(VarCurr,B)
      <=> ( v89606(VarCurr,B)
          & v97154(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v97154(VarCurr,B)
      <=> ~ v97155(VarCurr,B) ) ) ).

tff(addAssignment_59004,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,0)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_59003,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,1)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_59002,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,2)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_59001,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,3)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_59000,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,4)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58999,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,5)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58998,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,6)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58997,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,7)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58996,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,8)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58995,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,9)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58994,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,10)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58993,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,11)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58992,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,12)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58991,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,13)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58990,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,14)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58989,axiom,
    ! [VarCurr: state_type] :
      ( v97155(VarCurr,15)
    <=> v97156(VarCurr) ) ).

tff(addAssignment_58988,axiom,
    ! [VarCurr: state_type] :
      ( v97156(VarCurr)
    <=> v89610(VarCurr) ) ).

tff(addAssignment_58987,axiom,
    ! [VarCurr: state_type] :
      ( v89610(VarCurr)
    <=> v89612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8969,axiom,
    ! [VarCurr: state_type] :
      ( v89612(VarCurr)
    <=> ( v97150(VarCurr)
        | v97152(VarCurr) ) ) ).

tff(writeUnaryOperator_4461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97152(VarCurr)
    <=> v97146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8968,axiom,
    ! [VarCurr: state_type] :
      ( v97150(VarCurr)
    <=> ( v97151(VarCurr)
        | v89523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8967,axiom,
    ! [VarCurr: state_type] :
      ( v97151(VarCurr)
    <=> ( v4093(VarCurr)
        | v89614(VarCurr) ) ) ).

tff(addAssignment_58986,axiom,
    ! [VarCurr: state_type] :
      ( v97146(VarCurr)
    <=> v97148(VarCurr) ) ).

tff(addAssignment_58985,axiom,
    ! [VarCurr: state_type] :
      ( v97148(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(addAssignment_58984,axiom,
    ! [VarCurr: state_type] :
      ( v89614(VarCurr)
    <=> v89616(VarCurr) ) ).

tff(addAssignment_58983,axiom,
    ! [VarCurr: state_type] :
      ( v89616(VarCurr)
    <=> v89618(VarCurr) ) ).

tff(addAssignment_58982,axiom,
    ! [VarCurr: state_type] :
      ( v89618(VarCurr)
    <=> v89620(VarCurr) ) ).

tff(addAssignment_58981,axiom,
    ! [VarCurr: state_type] :
      ( v89620(VarCurr)
    <=> v89622(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_529,axiom,
    ! [VarCurr: state_type] :
      ( v89622(VarCurr)
    <=> ( ( v89624(VarCurr,3)
        <=> $false )
        & ( v89624(VarCurr,2)
        <=> $true )
        & ( v89624(VarCurr,1)
        <=> $false )
        & ( v89624(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_58980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89624(VarCurr,B)
      <=> v89626(VarCurr,B) ) ) ).

tff(addAssignment_58979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89626(VarCurr,B)
      <=> v89628(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97128(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v89628(VarNext,B)
            <=> v89628(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1093,axiom,
    ! [VarNext: state_type] :
      ( v97128(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v89628(VarNext,B)
          <=> v97138(VarNext,B) ) ) ) ).

tff(addAssignment_58978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v97138(VarNext,B)
          <=> v97136(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97139(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v97136(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_606,axiom,
    ! [VarCurr: state_type] :
      ( v97139(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v97136(VarCurr,B)
          <=> v89638(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8966,axiom,
    ! [VarCurr: state_type] :
      ( v97139(VarCurr)
    <=> ( v97140(VarCurr)
        & v97141(VarCurr) ) ) ).

tff(writeUnaryOperator_4460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97141(VarCurr)
    <=> v89634(VarCurr) ) ).

tff(writeUnaryOperator_4459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97140(VarCurr)
    <=> v89630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97128(VarNext)
      <=> v97129(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97129(VarNext)
      <=> ( v97130(VarNext)
          & v97123(VarNext) ) ) ) ).

tff(writeUnaryOperator_4458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97130(VarNext)
      <=> v97132(VarNext) ) ) ).

tff(addAssignment_58977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97132(VarNext)
      <=> v97123(VarCurr) ) ) ).

tff(addAssignment_58976,axiom,
    ! [VarCurr: state_type] :
      ( v97123(VarCurr)
    <=> v97125(VarCurr) ) ).

tff(addAssignment_58975,axiom,
    ! [VarCurr: state_type] :
      ( v97125(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89638(VarCurr,B)
      <=> v89640(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89640(VarCurr,B)
      <=> ( v97115(VarCurr,B)
          | v97118(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97118(VarCurr,B)
      <=> ( v89626(VarCurr,B)
          & v97119(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97119(VarCurr,B)
      <=> ~ v97120(VarCurr,B) ) ) ).

tff(addAssignment_58973,axiom,
    ! [VarCurr: state_type] :
      ( v97120(VarCurr,0)
    <=> v97121(VarCurr) ) ).

tff(addAssignment_58972,axiom,
    ! [VarCurr: state_type] :
      ( v97120(VarCurr,1)
    <=> v97121(VarCurr) ) ).

tff(addAssignment_58971,axiom,
    ! [VarCurr: state_type] :
      ( v97120(VarCurr,2)
    <=> v97121(VarCurr) ) ).

tff(addAssignment_58970,axiom,
    ! [VarCurr: state_type] :
      ( v97120(VarCurr,3)
    <=> v97121(VarCurr) ) ).

tff(addAssignment_58969,axiom,
    ! [VarCurr: state_type] :
      ( v97121(VarCurr)
    <=> v89665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v97115(VarCurr,B)
      <=> ( v89642(VarCurr,B)
          & v97116(VarCurr,B) ) ) ) ).

tff(addAssignment_58968,axiom,
    ! [VarCurr: state_type] :
      ( v97116(VarCurr,0)
    <=> v97117(VarCurr) ) ).

tff(addAssignment_58967,axiom,
    ! [VarCurr: state_type] :
      ( v97116(VarCurr,1)
    <=> v97117(VarCurr) ) ).

tff(addAssignment_58966,axiom,
    ! [VarCurr: state_type] :
      ( v97116(VarCurr,2)
    <=> v97117(VarCurr) ) ).

tff(addAssignment_58965,axiom,
    ! [VarCurr: state_type] :
      ( v97116(VarCurr,3)
    <=> v97117(VarCurr) ) ).

tff(addAssignment_58964,axiom,
    ! [VarCurr: state_type] :
      ( v97117(VarCurr)
    <=> v89665(VarCurr) ) ).

tff(addAssignment_58963,axiom,
    ! [VarCurr: state_type] :
      ( v89665(VarCurr)
    <=> v89667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8963,axiom,
    ! [VarCurr: state_type] :
      ( v89667(VarCurr)
    <=> ( v89669(VarCurr)
        | v97111(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3730,axiom,
    ! [VarCurr: state_type] :
      ( v97111(VarCurr)
    <=> ( v97113(VarCurr)
        | v89624(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3729,axiom,
    ! [VarCurr: state_type] :
      ( v97113(VarCurr)
    <=> ( v89663(VarCurr)
        | v89624(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8962,axiom,
    ! [VarCurr: state_type] :
      ( v89669(VarCurr)
    <=> ( v97109(VarCurr)
        & v96927(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3728,axiom,
    ! [VarCurr: state_type] :
      ( v97109(VarCurr)
    <=> ( v89671(VarCurr)
        & v89674(VarCurr,2) ) ) ).

tff(addAssignment_58962,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,2)
    <=> v89676(VarCurr,2) ) ).

tff(addAssignment_58961,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,2)
    <=> v89678(VarCurr,2) ) ).

tff(addAssignment_58960,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,2)
    <=> v97101(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97102(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97101(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1092,axiom,
    ! [VarNext: state_type] :
      ( v97102(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97101(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97102(VarNext)
      <=> v97103(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97103(VarNext)
      <=> ( v97105(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97105(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58959,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,2)
    <=> v89690(VarCurr,2) ) ).

tff(addAssignment_58958,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,2)
    <=> v89692(VarCurr,2) ) ).

tff(addAssignment_58957,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,2)
    <=> v97035(VarCurr,2) ) ).

tff(addAssignment_58956,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,2)
    <=> v96981(VarCurr,2) ) ).

tff(writeUnaryOperator_4455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89674(VarCurr,0)
    <=> v89696(VarCurr) ) ).

tff(addAssignment_58955,axiom,
    ! [VarCurr: state_type] :
      ( v89696(VarCurr)
    <=> v89676(VarCurr,0) ) ).

tff(addAssignment_58954,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,0)
    <=> v89678(VarCurr,0) ) ).

tff(addAssignment_58953,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,0)
    <=> v97092(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97093(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97092(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1091,axiom,
    ! [VarNext: state_type] :
      ( v97093(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97092(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97093(VarNext)
      <=> v97094(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97094(VarNext)
      <=> ( v97096(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97096(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58952,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,0)
    <=> v89690(VarCurr,0) ) ).

tff(addAssignment_58951,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,0)
    <=> v89692(VarCurr,0) ) ).

tff(addAssignment_58950,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,0)
    <=> v97035(VarCurr,0) ) ).

tff(writeUnaryOperator_4453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89698(VarCurr)
    <=> v89694(VarCurr,0) ) ).

tff(addAssignment_58949,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,0)
    <=> v96981(VarCurr,0) ) ).

tff(addAssignment_58948,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,1)
    <=> v89676(VarCurr,1) ) ).

tff(addAssignment_58947,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,1)
    <=> v89678(VarCurr,1) ) ).

tff(addAssignment_58946,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,1)
    <=> v97083(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97084(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97083(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1090,axiom,
    ! [VarNext: state_type] :
      ( v97084(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97083(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97084(VarNext)
      <=> v97085(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97085(VarNext)
      <=> ( v97087(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97087(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58945,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,1)
    <=> v89690(VarCurr,1) ) ).

tff(addAssignment_58944,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,1)
    <=> v89692(VarCurr,1) ) ).

tff(addAssignment_58943,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,1)
    <=> v97035(VarCurr,1) ) ).

tff(addAssignment_58942,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,1)
    <=> v96981(VarCurr,1) ) ).

tff(addAssignment_58941,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,3)
    <=> v89676(VarCurr,3) ) ).

tff(addAssignment_58940,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,3)
    <=> v89678(VarCurr,3) ) ).

tff(addAssignment_58939,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,3)
    <=> v97075(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97076(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97075(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1089,axiom,
    ! [VarNext: state_type] :
      ( v97076(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97075(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97076(VarNext)
      <=> v97077(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97077(VarNext)
      <=> ( v97079(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97079(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58938,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,3)
    <=> v89690(VarCurr,3) ) ).

tff(addAssignment_58937,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,3)
    <=> v89692(VarCurr,3) ) ).

tff(addAssignment_58936,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,3)
    <=> v97035(VarCurr,3) ) ).

tff(addAssignment_58935,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,3)
    <=> v96981(VarCurr,3) ) ).

tff(addAssignment_58934,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,4)
    <=> v89676(VarCurr,4) ) ).

tff(addAssignment_58933,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,4)
    <=> v89678(VarCurr,4) ) ).

tff(addAssignment_58932,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,4)
    <=> v97067(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97068(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97067(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1088,axiom,
    ! [VarNext: state_type] :
      ( v97068(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97067(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97068(VarNext)
      <=> v97069(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97069(VarNext)
      <=> ( v97071(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97071(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58931,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,4)
    <=> v89690(VarCurr,4) ) ).

tff(addAssignment_58930,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,4)
    <=> v89692(VarCurr,4) ) ).

tff(addAssignment_58929,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,4)
    <=> v97035(VarCurr,4) ) ).

tff(addAssignment_58928,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,4)
    <=> v96981(VarCurr,4) ) ).

tff(addAssignment_58927,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,5)
    <=> v89676(VarCurr,5) ) ).

tff(addAssignment_58926,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,5)
    <=> v89678(VarCurr,5) ) ).

tff(addAssignment_58925,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,5)
    <=> v97059(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97060(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97059(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1087,axiom,
    ! [VarNext: state_type] :
      ( v97060(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97059(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97060(VarNext)
      <=> v97061(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97061(VarNext)
      <=> ( v97063(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97063(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58924,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,5)
    <=> v89690(VarCurr,5) ) ).

tff(addAssignment_58923,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,5)
    <=> v89692(VarCurr,5) ) ).

tff(addAssignment_58922,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,5)
    <=> v97035(VarCurr,5) ) ).

tff(addAssignment_58921,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,5)
    <=> v96981(VarCurr,5) ) ).

tff(addAssignment_58920,axiom,
    ! [VarCurr: state_type] :
      ( v89674(VarCurr,6)
    <=> v89676(VarCurr,6) ) ).

tff(addAssignment_58919,axiom,
    ! [VarCurr: state_type] :
      ( v89676(VarCurr,6)
    <=> v89678(VarCurr,6) ) ).

tff(addAssignment_58918,axiom,
    ! [VarNext: state_type] :
      ( v89678(VarNext,6)
    <=> v97041(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97042(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v97041(VarNext,B)
            <=> v89678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1086,axiom,
    ! [VarNext: state_type] :
      ( v97042(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97041(VarNext,B)
          <=> v97052(VarNext,B) ) ) ) ).

tff(addAssignment_58917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97052(VarNext,B)
          <=> v97050(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97053(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97050(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_605,axiom,
    ! [VarCurr: state_type] :
      ( v97053(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97050(VarCurr,B)
          <=> v89688(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8949,axiom,
    ! [VarCurr: state_type] :
      ( v97053(VarCurr)
    <=> ( v97054(VarCurr)
        & v97055(VarCurr) ) ) ).

tff(writeUnaryOperator_4448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97055(VarCurr)
    <=> v89684(VarCurr) ) ).

tff(writeUnaryOperator_4447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97054(VarCurr)
    <=> v89680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97042(VarNext)
      <=> v97043(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97043(VarNext)
      <=> ( v97044(VarNext)
          & v97037(VarNext) ) ) ) ).

tff(writeUnaryOperator_4446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v97044(VarNext)
      <=> v97046(VarNext) ) ) ).

tff(addAssignment_58916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v97046(VarNext)
      <=> v97037(VarCurr) ) ) ).

tff(addAssignment_58915,axiom,
    ! [VarCurr: state_type] :
      ( v97037(VarCurr)
    <=> v97039(VarCurr) ) ).

tff(addAssignment_58914,axiom,
    ! [VarCurr: state_type] :
      ( v97039(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58913,axiom,
    ! [VarCurr: state_type] :
      ( v89688(VarCurr,6)
    <=> v89690(VarCurr,6) ) ).

tff(addAssignment_58912,axiom,
    ! [VarCurr: state_type] :
      ( v89690(VarCurr,6)
    <=> v89692(VarCurr,6) ) ).

tff(addAssignment_58911,axiom,
    ! [VarCurr: state_type] :
      ( v89692(VarCurr,6)
    <=> v97035(VarCurr,6) ) ).

tff(addAssignment_58910,axiom,
    ! [VarCurr: state_type] :
      ( v97035(VarCurr,0)
    <=> v89698(VarCurr) ) ).

tff(addAssignment_58909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,1) )
     => ( v97035(VarCurr,B)
      <=> v89694(VarCurr,B) ) ) ).

tff(addAssignment_58908,axiom,
    ! [VarCurr: state_type] :
      ( v89694(VarCurr,6)
    <=> v96981(VarCurr,6) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96982(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96981(VarCurr,B)
          <=> v89674(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_604,axiom,
    ! [VarCurr: state_type] :
      ( v96982(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96981(VarCurr,B)
          <=> v96995(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges6,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & ~ v96989(VarCurr)
        & ~ v96990(VarCurr)
        & ~ v96991(VarCurr)
        & ~ v96992(VarCurr)
        & ~ v96993(VarCurr)
        & v96994(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97032(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges5,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & ~ v96989(VarCurr)
        & ~ v96990(VarCurr)
        & ~ v96991(VarCurr)
        & ~ v96992(VarCurr)
        & v96993(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97031(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & ~ v96989(VarCurr)
        & ~ v96990(VarCurr)
        & ~ v96991(VarCurr)
        & v96992(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97025(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges3_4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & ~ v96989(VarCurr)
        & ~ v96990(VarCurr)
        & v96991(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97020(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges2_4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & ~ v96989(VarCurr)
        & v96990(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97018(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1085,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v96988(VarCurr)
        & v96989(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v97012(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1085,axiom,
    ! [VarCurr: state_type] :
      ( v96988(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96995(VarCurr,B)
          <=> v96996(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97032(VarCurr,B)
          <=> b1000000(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_603,axiom,
    ! [VarCurr: state_type] :
      ( v97033(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97032(VarCurr,B)
          <=> b0000001(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8946,axiom,
    ! [VarCurr: state_type] :
      ( v97033(VarCurr)
    <=> ( v97034(VarCurr)
        | v34197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8945,axiom,
    ! [VarCurr: state_type] :
      ( v97034(VarCurr)
    <=> ( v96601(VarCurr)
        | v96455(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97031(VarCurr,B)
          <=> b0100000(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_602,axiom,
    ! [VarCurr: state_type] :
      ( v4250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97031(VarCurr,B)
          <=> b1000000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97025(VarCurr,B)
          <=> v97028(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_601,axiom,
    ! [VarCurr: state_type] :
      ( v97026(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97025(VarCurr,B)
          <=> b0000001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97029(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97028(VarCurr,B)
          <=> b0010000(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_600,axiom,
    ! [VarCurr: state_type] :
      ( v97029(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97028(VarCurr,B)
          <=> b0100000(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8944,axiom,
    ! [VarCurr: state_type] :
      ( v97029(VarCurr)
    <=> ( v97030(VarCurr)
        | v94806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8943,axiom,
    ! [VarCurr: state_type] :
      ( v97030(VarCurr)
    <=> ( v4513(VarCurr)
        & v89722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8942,axiom,
    ! [VarCurr: state_type] :
      ( v97026(VarCurr)
    <=> ( v4513(VarCurr)
        & v97027(VarCurr) ) ) ).

tff(writeUnaryOperator_4445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97027(VarCurr)
    <=> v89722(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97020(VarCurr,B)
          <=> v97023(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_599,axiom,
    ! [VarCurr: state_type] :
      ( v97021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97020(VarCurr,B)
          <=> b0010000(B) ) ) ) ).

tff(bitBlastConstant_1494,axiom,
    ~ b0010000(6) ).

tff(bitBlastConstant_1493,axiom,
    ~ b0010000(5) ).

tff(bitBlastConstant_1492,axiom,
    b0010000(4) ).

tff(bitBlastConstant_1491,axiom,
    ~ b0010000(3) ).

tff(bitBlastConstant_1490,axiom,
    ~ b0010000(2) ).

tff(bitBlastConstant_1489,axiom,
    ~ b0010000(1) ).

tff(bitBlastConstant_1488,axiom,
    ~ b0010000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97024(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97023(VarCurr,B)
          <=> b0001000(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_598,axiom,
    ! [VarCurr: state_type] :
      ( v97024(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97023(VarCurr,B)
          <=> b0100000(B) ) ) ) ).

tff(bitBlastConstant_1487,axiom,
    ~ b0100000(6) ).

tff(bitBlastConstant_1486,axiom,
    b0100000(5) ).

tff(bitBlastConstant_1485,axiom,
    ~ b0100000(4) ).

tff(bitBlastConstant_1484,axiom,
    ~ b0100000(3) ).

tff(bitBlastConstant_1483,axiom,
    ~ b0100000(2) ).

tff(bitBlastConstant_1482,axiom,
    ~ b0100000(1) ).

tff(bitBlastConstant_1481,axiom,
    ~ b0100000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8941,axiom,
    ! [VarCurr: state_type] :
      ( v97024(VarCurr)
    <=> ( v94782(VarCurr)
        & v94806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8940,axiom,
    ! [VarCurr: state_type] :
      ( v97021(VarCurr)
    <=> ( v94782(VarCurr)
        & v97022(VarCurr) ) ) ).

tff(writeUnaryOperator_4444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97022(VarCurr)
    <=> v94806(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97018(VarCurr,B)
          <=> b0000100(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_597,axiom,
    ! [VarCurr: state_type] :
      ( v97019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97018(VarCurr,B)
          <=> b0001000(B) ) ) ) ).

tff(bitBlastConstant_1480,axiom,
    ~ b0001000(6) ).

tff(bitBlastConstant_1479,axiom,
    ~ b0001000(5) ).

tff(bitBlastConstant_1478,axiom,
    ~ b0001000(4) ).

tff(bitBlastConstant_1477,axiom,
    b0001000(3) ).

tff(bitBlastConstant_1476,axiom,
    ~ b0001000(2) ).

tff(bitBlastConstant_1475,axiom,
    ~ b0001000(1) ).

tff(bitBlastConstant_1474,axiom,
    ~ b0001000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8939,axiom,
    ! [VarCurr: state_type] :
      ( v97019(VarCurr)
    <=> ( v89671(VarCurr)
        & v96927(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97012(VarCurr,B)
          <=> v97015(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_596,axiom,
    ! [VarCurr: state_type] :
      ( v97013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97012(VarCurr,B)
          <=> b0000100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97015(VarCurr,B)
          <=> b0000010(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_595,axiom,
    ! [VarCurr: state_type] :
      ( v97016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97015(VarCurr,B)
          <=> b0000001(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8938,axiom,
    ! [VarCurr: state_type] :
      ( v97016(VarCurr)
    <=> ( v4513(VarCurr)
        & v97017(VarCurr) ) ) ).

tff(writeUnaryOperator_4443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97017(VarCurr)
    <=> v89722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8937,axiom,
    ! [VarCurr: state_type] :
      ( v97013(VarCurr)
    <=> ( v97014(VarCurr)
        | v96373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8936,axiom,
    ! [VarCurr: state_type] :
      ( v97014(VarCurr)
    <=> ( v4513(VarCurr)
        & v89722(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96997(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96996(VarCurr,B)
          <=> v97007(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_594,axiom,
    ! [VarCurr: state_type] :
      ( v96997(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v96996(VarCurr,B)
          <=> b0000010(B) ) ) ) ).

tff(bitBlastConstant_1473,axiom,
    ~ b0000010(6) ).

tff(bitBlastConstant_1472,axiom,
    ~ b0000010(5) ).

tff(bitBlastConstant_1471,axiom,
    ~ b0000010(4) ).

tff(bitBlastConstant_1470,axiom,
    ~ b0000010(3) ).

tff(bitBlastConstant_1469,axiom,
    ~ b0000010(2) ).

tff(bitBlastConstant_1468,axiom,
    b0000010(1) ).

tff(bitBlastConstant_1467,axiom,
    ~ b0000010(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97007(VarCurr,B)
          <=> b0000001(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_593,axiom,
    ! [VarCurr: state_type] :
      ( v97008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v97007(VarCurr,B)
          <=> b0000100(B) ) ) ) ).

tff(bitBlastConstant_1466,axiom,
    ~ b0000100(6) ).

tff(bitBlastConstant_1465,axiom,
    ~ b0000100(5) ).

tff(bitBlastConstant_1464,axiom,
    ~ b0000100(4) ).

tff(bitBlastConstant_1463,axiom,
    ~ b0000100(3) ).

tff(bitBlastConstant_1462,axiom,
    b0000100(2) ).

tff(bitBlastConstant_1461,axiom,
    ~ b0000100(1) ).

tff(bitBlastConstant_1460,axiom,
    ~ b0000100(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8935,axiom,
    ! [VarCurr: state_type] :
      ( v97008(VarCurr)
    <=> ( v96373(VarCurr)
        & v97009(VarCurr) ) ) ).

tff(writeUnaryOperator_4442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97009(VarCurr)
    <=> v97010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8934,axiom,
    ! [VarCurr: state_type] :
      ( v97010(VarCurr)
    <=> ( v97011(VarCurr)
        & v96901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8933,axiom,
    ! [VarCurr: state_type] :
      ( v97011(VarCurr)
    <=> ( v96579(VarCurr)
        & v96899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8932,axiom,
    ! [VarCurr: state_type] :
      ( v96997(VarCurr)
    <=> ( v96998(VarCurr)
        | v97002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8931,axiom,
    ! [VarCurr: state_type] :
      ( v97002(VarCurr)
    <=> ( v97003(VarCurr)
        & v97006(VarCurr) ) ) ).

tff(writeUnaryOperator_4441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97006(VarCurr)
    <=> v96455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8930,axiom,
    ! [VarCurr: state_type] :
      ( v97003(VarCurr)
    <=> ( v94331(VarCurr)
        & v97004(VarCurr) ) ) ).

tff(writeUnaryOperator_4440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v97004(VarCurr)
    <=> v97005(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8929,axiom,
    ! [VarCurr: state_type] :
      ( v97005(VarCurr)
    <=> ( v96899(VarCurr)
        & v96783(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8928,axiom,
    ! [VarCurr: state_type] :
      ( v96998(VarCurr)
    <=> ( v89700(VarCurr)
        & v96999(VarCurr) ) ) ).

tff(writeUnaryOperator_4439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96999(VarCurr)
    <=> v97000(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8927,axiom,
    ! [VarCurr: state_type] :
      ( v97000(VarCurr)
    <=> ( v97001(VarCurr)
        & v96901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8926,axiom,
    ! [VarCurr: state_type] :
      ( v97001(VarCurr)
    <=> ( v96579(VarCurr)
        & v96899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8925,axiom,
    ! [VarCurr: state_type] :
      ( v96982(VarCurr)
    <=> ( v96983(VarCurr)
        | v96994(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_528,axiom,
    ! [VarCurr: state_type] :
      ( v96994(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8924,axiom,
    ! [VarCurr: state_type] :
      ( v96983(VarCurr)
    <=> ( v96984(VarCurr)
        | v96993(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_527,axiom,
    ! [VarCurr: state_type] :
      ( v96993(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8923,axiom,
    ! [VarCurr: state_type] :
      ( v96984(VarCurr)
    <=> ( v96985(VarCurr)
        | v96992(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_526,axiom,
    ! [VarCurr: state_type] :
      ( v96992(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8922,axiom,
    ! [VarCurr: state_type] :
      ( v96985(VarCurr)
    <=> ( v96986(VarCurr)
        | v96991(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_525,axiom,
    ! [VarCurr: state_type] :
      ( v96991(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8921,axiom,
    ! [VarCurr: state_type] :
      ( v96986(VarCurr)
    <=> ( v96987(VarCurr)
        | v96990(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_524,axiom,
    ! [VarCurr: state_type] :
      ( v96990(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8920,axiom,
    ! [VarCurr: state_type] :
      ( v96987(VarCurr)
    <=> ( v96988(VarCurr)
        | v96989(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_523,axiom,
    ! [VarCurr: state_type] :
      ( v96989(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_522,axiom,
    ! [VarCurr: state_type] :
      ( v96988(VarCurr)
    <=> ( $true
      <=> v89674(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8919,axiom,
    ! [VarCurr: state_type] :
      ( v94782(VarCurr)
    <=> ( v2044(VarCurr)
        & v96978(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_521,axiom,
    ! [VarCurr: state_type] :
      ( v96978(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $false )
        & ( v2200(VarCurr,10)
        <=> $false )
        & ( v2200(VarCurr,9)
        <=> $true )
        & ( v2200(VarCurr,8)
        <=> $true ) ) ) ).

tff(addAssignment_58907,axiom,
    ! [VarCurr: state_type] :
      ( v96927(VarCurr)
    <=> v96929(VarCurr) ) ).

tff(addAssignment_58906,axiom,
    ! [VarCurr: state_type] :
      ( v96929(VarCurr)
    <=> v96931(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96959(VarNext)
       => ( v96931(VarNext)
        <=> v96931(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1084,axiom,
    ! [VarNext: state_type] :
      ( v96959(VarNext)
     => ( v96931(VarNext)
      <=> v96969(VarNext) ) ) ).

tff(addAssignment_58905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96969(VarNext)
      <=> v96967(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96970(VarCurr)
     => ( v96967(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_592,axiom,
    ! [VarCurr: state_type] :
      ( v96970(VarCurr)
     => ( v96967(VarCurr)
      <=> v96941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8918,axiom,
    ! [VarCurr: state_type] :
      ( v96970(VarCurr)
    <=> ( v96971(VarCurr)
        & v96972(VarCurr) ) ) ).

tff(writeUnaryOperator_4438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96972(VarCurr)
    <=> v96937(VarCurr) ) ).

tff(writeUnaryOperator_4437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96971(VarCurr)
    <=> v96933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96959(VarNext)
      <=> v96960(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96960(VarNext)
      <=> ( v96961(VarNext)
          & v96954(VarNext) ) ) ) ).

tff(writeUnaryOperator_4436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96961(VarNext)
      <=> v96963(VarNext) ) ) ).

tff(addAssignment_58904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96963(VarNext)
      <=> v96954(VarCurr) ) ) ).

tff(addAssignment_58903,axiom,
    ! [VarCurr: state_type] :
      ( v96954(VarCurr)
    <=> v96956(VarCurr) ) ).

tff(addAssignment_58902,axiom,
    ! [VarCurr: state_type] :
      ( v96956(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58901,axiom,
    ! [VarCurr: state_type] :
      ( v96941(VarCurr)
    <=> v96943(VarCurr) ) ).

tff(addAssignment_58900,axiom,
    ! [VarCurr: state_type] :
      ( v96943(VarCurr)
    <=> v96945(VarCurr) ) ).

tff(addAssignment_58899,axiom,
    ! [VarCurr: state_type] :
      ( v96945(VarCurr)
    <=> v96947(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96949(VarCurr)
     => ( v96947(VarCurr)
      <=> v96952(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_591,axiom,
    ! [VarCurr: state_type] :
      ( v96949(VarCurr)
     => ( v96947(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89669(VarCurr)
     => ( v96952(VarCurr)
      <=> v96927(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_590,axiom,
    ! [VarCurr: state_type] :
      ( v89669(VarCurr)
     => ( v96952(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8915,axiom,
    ! [VarCurr: state_type] :
      ( v96949(VarCurr)
    <=> ( v96950(VarCurr)
        & v96951(VarCurr) ) ) ).

tff(writeUnaryOperator_4435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96951(VarCurr)
    <=> v96927(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3727,axiom,
    ! [VarCurr: state_type] :
      ( v96950(VarCurr)
    <=> ( v89671(VarCurr)
        & v89674(VarCurr,2) ) ) ).

tff(addAssignment_58898,axiom,
    ! [VarCurr: state_type] :
      ( v96937(VarCurr)
    <=> v96939(VarCurr) ) ).

tff(addAssignment_58897,axiom,
    ! [VarCurr: state_type] :
      ( v96939(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58896,axiom,
    ! [VarCurr: state_type] :
      ( v96933(VarCurr)
    <=> v96935(VarCurr) ) ).

tff(addAssignment_58895,axiom,
    ! [VarCurr: state_type] :
      ( v96935(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_58894,axiom,
    ! [VarCurr: state_type] :
      ( v96901(VarCurr)
    <=> v96700(VarCurr,4) ) ).

tff(addAssignment_58893,axiom,
    ! [VarCurr: state_type] :
      ( v96700(VarCurr,4)
    <=> v96702(VarCurr,4) ) ).

tff(addAssignment_58892,axiom,
    ! [VarCurr: state_type] :
      ( v96702(VarCurr,4)
    <=> v96704(VarCurr,4) ) ).

tff(addAssignment_58891,axiom,
    ! [VarNext: state_type] :
      ( v96704(VarNext,4)
    <=> v96917(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96918(VarNext)
       => ! [B: $int] :
            ( ( $less(B,31)
              & ~ $less(B,0) )
           => ( v96917(VarNext,B)
            <=> v96704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1083,axiom,
    ! [VarNext: state_type] :
      ( v96918(VarNext)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96917(VarNext,B)
          <=> v96850(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96918(VarNext)
      <=> v96919(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96919(VarNext)
      <=> ( v96921(VarNext)
          & v96835(VarNext) ) ) ) ).

tff(writeUnaryOperator_4434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96921(VarNext)
      <=> v96844(VarNext) ) ) ).

tff(addAssignment_58890,axiom,
    ! [VarCurr: state_type] :
      ( v96714(VarCurr,4)
    <=> v96716(VarCurr,4) ) ).

tff(addAssignment_58889,axiom,
    ! [VarCurr: state_type] :
      ( v96716(VarCurr,4)
    <=> v96825(VarCurr,4) ) ).

tff(addAssignment_58888,axiom,
    ! [VarCurr: state_type] :
      ( v96718(VarCurr,4)
    <=> v96720(VarCurr,4) ) ).

tff(addAssignment_58887,axiom,
    ! [VarCurr: state_type] :
      ( v96720(VarCurr,4)
    <=> v96784(VarCurr,4) ) ).

tff(addAssignment_58886,axiom,
    ! [VarCurr: state_type] :
      ( v96796(VarCurr)
    <=> v96724(VarCurr,0) ) ).

tff(addAssignment_58885,axiom,
    ! [VarCurr: state_type] :
      ( v96724(VarCurr,0)
    <=> v96726(VarCurr,0) ) ).

tff(addAssignment_58884,axiom,
    ! [VarNext: state_type] :
      ( v96726(VarNext,0)
    <=> v96909(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96910(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v96909(VarNext,B)
            <=> v96726(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1082,axiom,
    ! [VarNext: state_type] :
      ( v96910(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96909(VarNext,B)
          <=> v96776(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96910(VarNext)
      <=> v96911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96911(VarNext)
      <=> ( v96913(VarNext)
          & v96761(VarNext) ) ) ) ).

tff(writeUnaryOperator_4433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96913(VarNext)
      <=> v96770(VarNext) ) ) ).

tff(addAssignment_58883,axiom,
    ! [VarCurr: state_type] :
      ( v96736(VarCurr,0)
    <=> v96738(VarCurr,0) ) ).

tff(addAssignment_58882,axiom,
    ! [VarCurr: state_type] :
      ( v96738(VarCurr,0)
    <=> v96756(VarCurr,0) ) ).

tff(addAssignment_58881,axiom,
    ! [VarCurr: state_type] :
      ( v96740(VarCurr,0)
    <=> v96744(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8910,axiom,
    ! [VarCurr: state_type] :
      ( v96748(VarCurr)
    <=> ( v96907(VarCurr)
        | v96796(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3726,axiom,
    ! [VarCurr: state_type] :
      ( v96907(VarCurr)
    <=> ( v89674(VarCurr,5)
        | v96905(VarCurr) ) ) ).

tff(addAssignment_58880,axiom,
    ! [VarCurr: state_type] :
      ( v96905(VarCurr)
    <=> v96671(VarCurr) ) ).

tff(addAssignment_58879,axiom,
    ! [VarCurr: state_type] :
      ( v96899(VarCurr)
    <=> v96700(VarCurr,30) ) ).

tff(addAssignment_58878,axiom,
    ! [VarCurr: state_type] :
      ( v96579(VarCurr)
    <=> v96581(VarCurr) ) ).

tff(addAssignment_58877,axiom,
    ! [VarCurr: state_type] :
      ( v96581(VarCurr)
    <=> v96583(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96882(VarNext)
       => ( v96583(VarNext)
        <=> v96583(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1081,axiom,
    ! [VarNext: state_type] :
      ( v96882(VarNext)
     => ( v96583(VarNext)
      <=> v96892(VarNext) ) ) ).

tff(addAssignment_58876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96892(VarNext)
      <=> v96890(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96893(VarCurr)
     => ( v96890(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_589,axiom,
    ! [VarCurr: state_type] :
      ( v96893(VarCurr)
     => ( v96890(VarCurr)
      <=> v96593(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8909,axiom,
    ! [VarCurr: state_type] :
      ( v96893(VarCurr)
    <=> ( v96894(VarCurr)
        & v96895(VarCurr) ) ) ).

tff(writeUnaryOperator_4432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96895(VarCurr)
    <=> v96589(VarCurr) ) ).

tff(writeUnaryOperator_4431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96894(VarCurr)
    <=> v96585(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96882(VarNext)
      <=> v96883(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96883(VarNext)
      <=> ( v96884(VarNext)
          & v96877(VarNext) ) ) ) ).

tff(writeUnaryOperator_4430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96884(VarNext)
      <=> v96886(VarNext) ) ) ).

tff(addAssignment_58875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96886(VarNext)
      <=> v96877(VarCurr) ) ) ).

tff(addAssignment_58874,axiom,
    ! [VarCurr: state_type] :
      ( v96877(VarCurr)
    <=> v96879(VarCurr) ) ).

tff(addAssignment_58873,axiom,
    ! [VarCurr: state_type] :
      ( v96879(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58872,axiom,
    ! [VarCurr: state_type] :
      ( v96593(VarCurr)
    <=> v96595(VarCurr) ) ).

tff(addAssignment_58871,axiom,
    ! [VarCurr: state_type] :
      ( v96595(VarCurr)
    <=> v96597(VarCurr) ) ).

tff(addAssignment_58870,axiom,
    ! [VarCurr: state_type] :
      ( v96597(VarCurr)
    <=> v96599(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96873(VarCurr)
     => ( v96599(VarCurr)
      <=> v96874(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_588,axiom,
    ! [VarCurr: state_type] :
      ( v96873(VarCurr)
     => ( v96599(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96875(VarCurr)
     => ( v96874(VarCurr)
      <=> v96579(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_587,axiom,
    ! [VarCurr: state_type] :
      ( v96875(VarCurr)
     => ( v96874(VarCurr)
      <=> $false ) ) ).

tff(writeUnaryOperator_4429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96875(VarCurr)
    <=> v96700(VarCurr,30) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8906,axiom,
    ! [VarCurr: state_type] :
      ( v96873(VarCurr)
    <=> ( v96601(VarCurr)
        | v96643(VarCurr) ) ) ).

tff(addAssignment_58869,axiom,
    ! [VarCurr: state_type] :
      ( v96700(VarCurr,30)
    <=> v96702(VarCurr,30) ) ).

tff(addAssignment_58868,axiom,
    ! [VarCurr: state_type] :
      ( v96702(VarCurr,30)
    <=> v96704(VarCurr,30) ) ).

tff(addAssignment_58867,axiom,
    ! [VarNext: state_type] :
      ( v96704(VarNext,30)
    <=> v96865(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_1080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96866(VarNext)
       => ! [B: $int] :
            ( ( $less(B,31)
              & ~ $less(B,0) )
           => ( v96865(VarNext,B)
            <=> v96704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1080,axiom,
    ! [VarNext: state_type] :
      ( v96866(VarNext)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96865(VarNext,B)
          <=> v96850(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96866(VarNext)
      <=> v96867(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96867(VarNext)
      <=> ( v96869(VarNext)
          & v96835(VarNext) ) ) ) ).

tff(writeUnaryOperator_4428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96869(VarNext)
      <=> v96844(VarNext) ) ) ).

tff(addAssignment_58866,axiom,
    ! [VarCurr: state_type] :
      ( v96714(VarCurr,30)
    <=> v96716(VarCurr,30) ) ).

tff(addAssignment_58865,axiom,
    ! [VarCurr: state_type] :
      ( v96716(VarCurr,30)
    <=> v96825(VarCurr,30) ) ).

tff(addAssignment_58864,axiom,
    ! [VarCurr: state_type] :
      ( v96718(VarCurr,30)
    <=> v96720(VarCurr,30) ) ).

tff(addAssignment_58863,axiom,
    ! [VarCurr: state_type] :
      ( v96720(VarCurr,30)
    <=> v96784(VarCurr,30) ) ).

tff(addAssignment_58862,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,63)
    <=> v2365(VarCurr,63) ) ).

tff(addAssignment_58861,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,63)
    <=> v1119(VarCurr,63) ) ).

tff(addAssignment_58860,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,63)
    <=> v1121(VarCurr,63) ) ).

tff(addAssignment_58859,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,63)
    <=> v1123(VarCurr,63) ) ).

tff(addAssignment_58858,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,63)
    <=> v96857(VarNext,63) ) ).

tff(addCaseBooleanConditionEqualRanges1_1079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96858(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v96857(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1079,axiom,
    ! [VarNext: state_type] :
      ( v96858(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v96857(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96858(VarNext)
      <=> v96859(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96859(VarNext)
      <=> ( v96861(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_4427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96861(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_58857,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,63)
    <=> v1135(VarCurr,63) ) ).

tff(addAssignment_58856,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,63)
    <=> v1137(VarCurr,63) ) ).

tff(addAssignment_58855,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,63)
    <=> v1697(VarCurr,63) ) ).

tff(addAssignment_58854,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,63)
    <=> v1141(VarCurr,63) ) ).

tff(addAssignment_58853,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,63)
    <=> v1143(VarCurr,63) ) ).

tff(addAssignment_58852,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,63)
    <=> v1145(VarCurr,63) ) ).

tff(addAssignment_58851,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,63)
    <=> v1147(VarCurr,63) ) ).

tff(addAssignment_58850,axiom,
    ! [VarCurr: state_type] :
      ( v96783(VarCurr)
    <=> v96700(VarCurr,2) ) ).

tff(addAssignment_58849,axiom,
    ! [VarCurr: state_type] :
      ( v96700(VarCurr,2)
    <=> v96702(VarCurr,2) ) ).

tff(addAssignment_58848,axiom,
    ! [VarCurr: state_type] :
      ( v96702(VarCurr,2)
    <=> v96704(VarCurr,2) ) ).

tff(addAssignment_58847,axiom,
    ! [VarNext: state_type] :
      ( v96704(VarNext,2)
    <=> v96839(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96840(VarNext)
       => ! [B: $int] :
            ( ( $less(B,31)
              & ~ $less(B,0) )
           => ( v96839(VarNext,B)
            <=> v96704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1078,axiom,
    ! [VarNext: state_type] :
      ( v96840(VarNext)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96839(VarNext,B)
          <=> v96850(VarNext,B) ) ) ) ).

tff(addAssignment_58846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96850(VarNext,B)
          <=> v96848(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96848(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_586,axiom,
    ! [VarCurr: state_type] :
      ( v96851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96848(VarCurr,B)
          <=> v96714(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8901,axiom,
    ! [VarCurr: state_type] :
      ( v96851(VarCurr)
    <=> ( v96852(VarCurr)
        & v96853(VarCurr) ) ) ).

tff(writeUnaryOperator_4426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96853(VarCurr)
    <=> v96710(VarCurr) ) ).

tff(writeUnaryOperator_4425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96852(VarCurr)
    <=> v96706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96840(VarNext)
      <=> v96841(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96841(VarNext)
      <=> ( v96842(VarNext)
          & v96835(VarNext) ) ) ) ).

tff(writeUnaryOperator_4424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96842(VarNext)
      <=> v96844(VarNext) ) ) ).

tff(addAssignment_58845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96844(VarNext)
      <=> v96835(VarCurr) ) ) ).

tff(addAssignment_58844,axiom,
    ! [VarCurr: state_type] :
      ( v96835(VarCurr)
    <=> v96837(VarCurr) ) ).

tff(addAssignment_58843,axiom,
    ! [VarCurr: state_type] :
      ( v96837(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58842,axiom,
    ! [VarCurr: state_type] :
      ( v96714(VarCurr,2)
    <=> v96716(VarCurr,2) ) ).

tff(addAssignment_58841,axiom,
    ! [VarCurr: state_type] :
      ( v96716(VarCurr,2)
    <=> v96825(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,0) )
     => ( v96825(VarCurr,B)
      <=> ( v96826(VarCurr,B)
          | v96829(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,0) )
     => ( v96829(VarCurr,B)
      <=> ( v96702(VarCurr,B)
          & v96830(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,0) )
     => ( v96830(VarCurr,B)
      <=> ~ v96831(VarCurr,B) ) ) ).

tff(addAssignment_58840,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,0)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58839,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,1)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58838,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,2)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58837,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,3)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58836,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,4)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58835,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,5)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58834,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,6)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58833,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,7)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58832,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,8)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58831,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,9)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58830,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,10)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58829,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,11)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58828,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,12)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58827,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,13)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58826,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,14)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58825,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,15)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58824,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,16)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58823,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,17)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58822,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,18)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58821,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,19)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58820,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,20)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58819,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,21)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58818,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,22)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58817,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,23)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58816,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,24)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58815,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,25)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58814,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,26)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58813,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,27)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58812,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,28)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58811,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,29)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58810,axiom,
    ! [VarCurr: state_type] :
      ( v96831(VarCurr,30)
    <=> v96832(VarCurr) ) ).

tff(addAssignment_58809,axiom,
    ! [VarCurr: state_type] :
      ( v96832(VarCurr)
    <=> v96807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,0) )
     => ( v96826(VarCurr,B)
      <=> ( v96718(VarCurr,B)
          & v96827(VarCurr,B) ) ) ) ).

tff(addAssignment_58808,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,0)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58807,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,1)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58806,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,2)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58805,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,3)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58804,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,4)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58803,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,5)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58802,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,6)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58801,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,7)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58800,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,8)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58799,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,9)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58798,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,10)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58797,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,11)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58796,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,12)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58795,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,13)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58794,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,14)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58793,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,15)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58792,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,16)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58791,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,17)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58790,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,18)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58789,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,19)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58788,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,20)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58787,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,21)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58786,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,22)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58785,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,23)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58784,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,24)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58783,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,25)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58782,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,26)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58781,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,27)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58780,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,28)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58779,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,29)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58778,axiom,
    ! [VarCurr: state_type] :
      ( v96827(VarCurr,30)
    <=> v96828(VarCurr) ) ).

tff(addAssignment_58777,axiom,
    ! [VarCurr: state_type] :
      ( v96828(VarCurr)
    <=> v96807(VarCurr) ) ).

tff(addAssignment_58776,axiom,
    ! [VarCurr: state_type] :
      ( v96807(VarCurr)
    <=> v96809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8898,axiom,
    ! [VarCurr: state_type] :
      ( v96809(VarCurr)
    <=> ( v96812(VarCurr)
        | v96823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8897,axiom,
    ! [VarCurr: state_type] :
      ( v96823(VarCurr)
    <=> ( v2354(VarCurr)
        & v96824(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_520,axiom,
    ! [VarCurr: state_type] :
      ( v96824(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1459,axiom,
    ~ b0110000000000(12) ).

tff(bitBlastConstant_1458,axiom,
    b0110000000000(11) ).

tff(bitBlastConstant_1457,axiom,
    b0110000000000(10) ).

tff(bitBlastConstant_1456,axiom,
    ~ b0110000000000(9) ).

tff(bitBlastConstant_1455,axiom,
    ~ b0110000000000(8) ).

tff(bitBlastConstant_1454,axiom,
    ~ b0110000000000(7) ).

tff(bitBlastConstant_1453,axiom,
    ~ b0110000000000(6) ).

tff(bitBlastConstant_1452,axiom,
    ~ b0110000000000(5) ).

tff(bitBlastConstant_1451,axiom,
    ~ b0110000000000(4) ).

tff(bitBlastConstant_1450,axiom,
    ~ b0110000000000(3) ).

tff(bitBlastConstant_1449,axiom,
    ~ b0110000000000(2) ).

tff(bitBlastConstant_1448,axiom,
    ~ b0110000000000(1) ).

tff(bitBlastConstant_1447,axiom,
    ~ b0110000000000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8896,axiom,
    ! [VarCurr: state_type] :
      ( v96812(VarCurr)
    <=> ( v96813(VarCurr)
        | v96820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8895,axiom,
    ! [VarCurr: state_type] :
      ( v96820(VarCurr)
    <=> ( v96821(VarCurr)
        & v96822(VarCurr) ) ) ).

tff(writeUnaryOperator_4422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96822(VarCurr)
    <=> v96783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8894,axiom,
    ! [VarCurr: state_type] :
      ( v96821(VarCurr)
    <=> ( v96455(VarCurr)
        & v96722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8893,axiom,
    ! [VarCurr: state_type] :
      ( v96813(VarCurr)
    <=> ( v96814(VarCurr)
        | v96817(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8892,axiom,
    ! [VarCurr: state_type] :
      ( v96817(VarCurr)
    <=> ( v96818(VarCurr)
        & v96819(VarCurr) ) ) ).

tff(writeUnaryOperator_4421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96819(VarCurr)
    <=> v96579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8891,axiom,
    ! [VarCurr: state_type] :
      ( v96818(VarCurr)
    <=> ( v96601(VarCurr)
        | v96643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8890,axiom,
    ! [VarCurr: state_type] :
      ( v96814(VarCurr)
    <=> ( v96815(VarCurr)
        & v96816(VarCurr) ) ) ).

tff(writeUnaryOperator_4420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96816(VarCurr)
    <=> v96700(VarCurr,30) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8889,axiom,
    ! [VarCurr: state_type] :
      ( v96815(VarCurr)
    <=> ( v96455(VarCurr)
        | v96390(VarCurr) ) ) ).

tff(addAssignment_58775,axiom,
    ! [VarCurr: state_type] :
      ( v96718(VarCurr,2)
    <=> v96720(VarCurr,2) ) ).

tff(addAssignment_58774,axiom,
    ! [VarCurr: state_type] :
      ( v96720(VarCurr,2)
    <=> v96784(VarCurr,2) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96785(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96784(VarCurr,B)
          <=> v96800(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_585,axiom,
    ! [VarCurr: state_type] :
      ( v96785(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96784(VarCurr,B)
          <=> v96792(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96801(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96800(VarCurr,B)
          <=> v96805(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_584,axiom,
    ! [VarCurr: state_type] :
      ( v96801(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,31)
            & ~ $less(B,0) )
         => ( v96800(VarCurr,B)
          <=> v96804(VarCurr,B) ) ) ) ).

tff(addAssignment_58773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,0) )
     => ( v96805(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_58772,axiom,
    ! [VarCurr: state_type] :
      ( v96805(VarCurr,30)
    <=> v2363(VarCurr,63) ) ).

tff(addAssignment_58771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96804(VarCurr,B)
      <=> v96700(VarCurr,B) ) ) ).

tff(addAssignment_58770,axiom,
    ! [VarCurr: state_type] :
      ( v96804(VarCurr,2)
    <=> $true ) ).

tff(addAssignment_58769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v96804(VarCurr,B)
      <=> v96700(VarCurr,B) ) ) ).

tff(addAssignment_58768,axiom,
    ! [VarCurr: state_type] :
      ( ( v96804(VarCurr,17)
      <=> v96794(VarCurr,11) )
      & ( v96804(VarCurr,16)
      <=> v96794(VarCurr,10) )
      & ( v96804(VarCurr,15)
      <=> v96794(VarCurr,9) )
      & ( v96804(VarCurr,14)
      <=> v96794(VarCurr,8) )
      & ( v96804(VarCurr,13)
      <=> v96794(VarCurr,7) )
      & ( v96804(VarCurr,12)
      <=> v96794(VarCurr,6) )
      & ( v96804(VarCurr,11)
      <=> v96794(VarCurr,5) )
      & ( v96804(VarCurr,10)
      <=> v96794(VarCurr,4) )
      & ( v96804(VarCurr,9)
      <=> v96794(VarCurr,3) )
      & ( v96804(VarCurr,8)
      <=> v96794(VarCurr,2) )
      & ( v96804(VarCurr,7)
      <=> v96794(VarCurr,1) )
      & ( v96804(VarCurr,6)
      <=> v96794(VarCurr,0) ) ) ).

tff(addAssignment_58767,axiom,
    ! [VarCurr: state_type] :
      ( ( v96804(VarCurr,29)
      <=> v96793(VarCurr,11) )
      & ( v96804(VarCurr,28)
      <=> v96793(VarCurr,10) )
      & ( v96804(VarCurr,27)
      <=> v96793(VarCurr,9) )
      & ( v96804(VarCurr,26)
      <=> v96793(VarCurr,8) )
      & ( v96804(VarCurr,25)
      <=> v96793(VarCurr,7) )
      & ( v96804(VarCurr,24)
      <=> v96793(VarCurr,6) )
      & ( v96804(VarCurr,23)
      <=> v96793(VarCurr,5) )
      & ( v96804(VarCurr,22)
      <=> v96793(VarCurr,4) )
      & ( v96804(VarCurr,21)
      <=> v96793(VarCurr,3) )
      & ( v96804(VarCurr,20)
      <=> v96793(VarCurr,2) )
      & ( v96804(VarCurr,19)
      <=> v96793(VarCurr,1) )
      & ( v96804(VarCurr,18)
      <=> v96793(VarCurr,0) ) ) ).

tff(addAssignment_58766,axiom,
    ! [VarCurr: state_type] :
      ( v96804(VarCurr,30)
    <=> v96700(VarCurr,30) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8888,axiom,
    ! [VarCurr: state_type] :
      ( v96801(VarCurr)
    <=> ( v96802(VarCurr)
        & v96803(VarCurr) ) ) ).

tff(writeUnaryOperator_4419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96803(VarCurr)
    <=> v96783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8887,axiom,
    ! [VarCurr: state_type] :
      ( v96802(VarCurr)
    <=> ( v96455(VarCurr)
        & v96722(VarCurr) ) ) ).

tff(addAssignment_58765,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,0)
    <=> v96799(VarCurr) ) ).

tff(addAssignment_58764,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,1)
    <=> v96798(VarCurr) ) ).

tff(addAssignment_58763,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,2)
    <=> v96722(VarCurr) ) ).

tff(addAssignment_58762,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,3)
    <=> v96797(VarCurr) ) ).

tff(addAssignment_58761,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,4)
    <=> v96796(VarCurr) ) ).

tff(addAssignment_58760,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,5)
    <=> v96795(VarCurr) ) ).

tff(addAssignment_58759,axiom,
    ! [VarCurr: state_type] :
      ( ( v96792(VarCurr,17)
      <=> v96794(VarCurr,11) )
      & ( v96792(VarCurr,16)
      <=> v96794(VarCurr,10) )
      & ( v96792(VarCurr,15)
      <=> v96794(VarCurr,9) )
      & ( v96792(VarCurr,14)
      <=> v96794(VarCurr,8) )
      & ( v96792(VarCurr,13)
      <=> v96794(VarCurr,7) )
      & ( v96792(VarCurr,12)
      <=> v96794(VarCurr,6) )
      & ( v96792(VarCurr,11)
      <=> v96794(VarCurr,5) )
      & ( v96792(VarCurr,10)
      <=> v96794(VarCurr,4) )
      & ( v96792(VarCurr,9)
      <=> v96794(VarCurr,3) )
      & ( v96792(VarCurr,8)
      <=> v96794(VarCurr,2) )
      & ( v96792(VarCurr,7)
      <=> v96794(VarCurr,1) )
      & ( v96792(VarCurr,6)
      <=> v96794(VarCurr,0) ) ) ).

tff(addAssignment_58758,axiom,
    ! [VarCurr: state_type] :
      ( ( v96792(VarCurr,29)
      <=> v96793(VarCurr,11) )
      & ( v96792(VarCurr,28)
      <=> v96793(VarCurr,10) )
      & ( v96792(VarCurr,27)
      <=> v96793(VarCurr,9) )
      & ( v96792(VarCurr,26)
      <=> v96793(VarCurr,8) )
      & ( v96792(VarCurr,25)
      <=> v96793(VarCurr,7) )
      & ( v96792(VarCurr,24)
      <=> v96793(VarCurr,6) )
      & ( v96792(VarCurr,23)
      <=> v96793(VarCurr,5) )
      & ( v96792(VarCurr,22)
      <=> v96793(VarCurr,4) )
      & ( v96792(VarCurr,21)
      <=> v96793(VarCurr,3) )
      & ( v96792(VarCurr,20)
      <=> v96793(VarCurr,2) )
      & ( v96792(VarCurr,19)
      <=> v96793(VarCurr,1) )
      & ( v96792(VarCurr,18)
      <=> v96793(VarCurr,0) ) ) ).

tff(addAssignment_58757,axiom,
    ! [VarCurr: state_type] :
      ( v96792(VarCurr,30)
    <=> $true ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8886,axiom,
    ! [VarCurr: state_type] :
      ( v96799(VarCurr)
    <=> ( v96390(VarCurr)
        | v96643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8885,axiom,
    ! [VarCurr: state_type] :
      ( v96785(VarCurr)
    <=> ( v96786(VarCurr)
        | v96789(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8884,axiom,
    ! [VarCurr: state_type] :
      ( v96789(VarCurr)
    <=> ( v96790(VarCurr)
        & v96791(VarCurr) ) ) ).

tff(writeUnaryOperator_4418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96791(VarCurr)
    <=> v96579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8883,axiom,
    ! [VarCurr: state_type] :
      ( v96790(VarCurr)
    <=> ( v96601(VarCurr)
        | v96643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8882,axiom,
    ! [VarCurr: state_type] :
      ( v96786(VarCurr)
    <=> ( v96787(VarCurr)
        & v96788(VarCurr) ) ) ).

tff(writeUnaryOperator_4417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96788(VarCurr)
    <=> v96700(VarCurr,30) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8881,axiom,
    ! [VarCurr: state_type] :
      ( v96787(VarCurr)
    <=> ( v96455(VarCurr)
        | v96390(VarCurr) ) ) ).

tff(addAssignment_58756,axiom,
    ! [VarCurr: state_type] :
      ( v96722(VarCurr)
    <=> v96724(VarCurr,3) ) ).

tff(addAssignment_58755,axiom,
    ! [VarCurr: state_type] :
      ( v96724(VarCurr,3)
    <=> v96726(VarCurr,3) ) ).

tff(addAssignment_58754,axiom,
    ! [VarNext: state_type] :
      ( v96726(VarNext,3)
    <=> v96765(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96766(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v96765(VarNext,B)
            <=> v96726(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1077,axiom,
    ! [VarNext: state_type] :
      ( v96766(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96765(VarNext,B)
          <=> v96776(VarNext,B) ) ) ) ).

tff(addAssignment_58753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96776(VarNext,B)
          <=> v96774(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96777(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96774(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_583,axiom,
    ! [VarCurr: state_type] :
      ( v96777(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96774(VarCurr,B)
          <=> v96736(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8880,axiom,
    ! [VarCurr: state_type] :
      ( v96777(VarCurr)
    <=> ( v96778(VarCurr)
        & v96779(VarCurr) ) ) ).

tff(writeUnaryOperator_4416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96779(VarCurr)
    <=> v96732(VarCurr) ) ).

tff(writeUnaryOperator_4415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96778(VarCurr)
    <=> v96728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96766(VarNext)
      <=> v96767(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96767(VarNext)
      <=> ( v96768(VarNext)
          & v96761(VarNext) ) ) ) ).

tff(writeUnaryOperator_4414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96768(VarNext)
      <=> v96770(VarNext) ) ) ).

tff(addAssignment_58752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96770(VarNext)
      <=> v96761(VarCurr) ) ) ).

tff(addAssignment_58751,axiom,
    ! [VarCurr: state_type] :
      ( v96761(VarCurr)
    <=> v96763(VarCurr) ) ).

tff(addAssignment_58750,axiom,
    ! [VarCurr: state_type] :
      ( v96763(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58749,axiom,
    ! [VarCurr: state_type] :
      ( v96736(VarCurr,3)
    <=> v96738(VarCurr,3) ) ).

tff(addAssignment_58748,axiom,
    ! [VarCurr: state_type] :
      ( v96738(VarCurr,3)
    <=> v96756(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v96756(VarCurr,B)
      <=> ( v96740(VarCurr,B)
          & v96757(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v96757(VarCurr,B)
      <=> ~ v96758(VarCurr,B) ) ) ).

tff(addAssignment_58747,axiom,
    ! [VarCurr: state_type] :
      ( v96758(VarCurr,0)
    <=> v96759(VarCurr) ) ).

tff(addAssignment_58746,axiom,
    ! [VarCurr: state_type] :
      ( v96758(VarCurr,1)
    <=> v96759(VarCurr) ) ).

tff(addAssignment_58745,axiom,
    ! [VarCurr: state_type] :
      ( v96758(VarCurr,2)
    <=> v96759(VarCurr) ) ).

tff(addAssignment_58744,axiom,
    ! [VarCurr: state_type] :
      ( v96758(VarCurr,3)
    <=> v96759(VarCurr) ) ).

tff(addAssignment_58743,axiom,
    ! [VarCurr: state_type] :
      ( v96758(VarCurr,4)
    <=> v96759(VarCurr) ) ).

tff(addAssignment_58742,axiom,
    ! [VarCurr: state_type] :
      ( v96759(VarCurr)
    <=> v96750(VarCurr) ) ).

tff(addAssignment_58741,axiom,
    ! [VarCurr: state_type] :
      ( v96750(VarCurr)
    <=> v96752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8877,axiom,
    ! [VarCurr: state_type] :
      ( v96752(VarCurr)
    <=> ( v96754(VarCurr)
        | v96643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8876,axiom,
    ! [VarCurr: state_type] :
      ( v96754(VarCurr)
    <=> ( v96755(VarCurr)
        | v96390(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8875,axiom,
    ! [VarCurr: state_type] :
      ( v96755(VarCurr)
    <=> ( v96601(VarCurr)
        | v96455(VarCurr) ) ) ).

tff(addAssignment_58740,axiom,
    ! [VarCurr: state_type] :
      ( v96740(VarCurr,3)
    <=> v96744(VarCurr,3) ) ).

tff(addAssignment_58739,axiom,
    ! [VarCurr: state_type] :
      ( v96744(VarCurr,0)
    <=> v96748(VarCurr) ) ).

tff(addAssignment_58738,axiom,
    ! [VarCurr: state_type] :
      ( v96744(VarCurr,1)
    <=> v96747(VarCurr) ) ).

tff(addAssignment_58737,axiom,
    ! [VarCurr: state_type] :
      ( v96744(VarCurr,2)
    <=> v96746(VarCurr) ) ).

tff(addAssignment_58736,axiom,
    ! [VarCurr: state_type] :
      ( v96744(VarCurr,3)
    <=> v96742(VarCurr) ) ).

tff(addAssignment_58735,axiom,
    ! [VarCurr: state_type] :
      ( v96744(VarCurr,4)
    <=> v96745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8874,axiom,
    ! [VarCurr: state_type] :
      ( v96742(VarCurr)
    <=> ( v94331(VarCurr)
        | v96722(VarCurr) ) ) ).

tff(addAssignment_58734,axiom,
    ! [VarCurr: state_type] :
      ( v96732(VarCurr)
    <=> v96734(VarCurr) ) ).

tff(addAssignment_58733,axiom,
    ! [VarCurr: state_type] :
      ( v96734(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58732,axiom,
    ! [VarCurr: state_type] :
      ( v96728(VarCurr)
    <=> v96730(VarCurr) ) ).

tff(addAssignment_58731,axiom,
    ! [VarCurr: state_type] :
      ( v96730(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_58730,axiom,
    ! [VarCurr: state_type] :
      ( v96710(VarCurr)
    <=> v96712(VarCurr) ) ).

tff(addAssignment_58729,axiom,
    ! [VarCurr: state_type] :
      ( v96712(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58728,axiom,
    ! [VarCurr: state_type] :
      ( v96706(VarCurr)
    <=> v96708(VarCurr) ) ).

tff(addAssignment_58727,axiom,
    ! [VarCurr: state_type] :
      ( v96708(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_58726,axiom,
    ! [VarCurr: state_type] :
      ( v96643(VarCurr)
    <=> v96645(VarCurr) ) ).

tff(addAssignment_58725,axiom,
    ! [VarCurr: state_type] :
      ( v96645(VarCurr)
    <=> v96647(VarCurr) ) ).

tff(addAssignment_58724,axiom,
    ! [VarCurr: state_type] :
      ( v96647(VarCurr)
    <=> v96649(VarCurr) ) ).

tff(addAssignment_58723,axiom,
    ! [VarCurr: state_type] :
      ( v96649(VarCurr)
    <=> v96651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96683(VarNext)
       => ( v96651(VarNext)
        <=> v96651(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1076,axiom,
    ! [VarNext: state_type] :
      ( v96683(VarNext)
     => ( v96651(VarNext)
      <=> v96693(VarNext) ) ) ).

tff(addAssignment_58722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96693(VarNext)
      <=> v96691(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96694(VarCurr)
     => ( v96691(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_582,axiom,
    ! [VarCurr: state_type] :
      ( v96694(VarCurr)
     => ( v96691(VarCurr)
      <=> v96661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8873,axiom,
    ! [VarCurr: state_type] :
      ( v96694(VarCurr)
    <=> ( v96695(VarCurr)
        & v96696(VarCurr) ) ) ).

tff(writeUnaryOperator_4412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96696(VarCurr)
    <=> v96657(VarCurr) ) ).

tff(writeUnaryOperator_4411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96695(VarCurr)
    <=> v96653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96683(VarNext)
      <=> v96684(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96684(VarNext)
      <=> ( v96685(VarNext)
          & v96678(VarNext) ) ) ) ).

tff(writeUnaryOperator_4410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96685(VarNext)
      <=> v96687(VarNext) ) ) ).

tff(addAssignment_58721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96687(VarNext)
      <=> v96678(VarCurr) ) ) ).

tff(addAssignment_58720,axiom,
    ! [VarCurr: state_type] :
      ( v96678(VarCurr)
    <=> v96680(VarCurr) ) ).

tff(addAssignment_58719,axiom,
    ! [VarCurr: state_type] :
      ( v96680(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_58718,axiom,
    ! [VarCurr: state_type] :
      ( v96661(VarCurr)
    <=> v96663(VarCurr) ) ).

tff(addAssignment_58717,axiom,
    ! [VarCurr: state_type] :
      ( v96663(VarCurr)
    <=> v96665(VarCurr) ) ).

tff(addAssignment_58716,axiom,
    ! [VarCurr: state_type] :
      ( v96665(VarCurr)
    <=> v96667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8870,axiom,
    ! [VarCurr: state_type] :
      ( v96667(VarCurr)
    <=> ( v96675(VarCurr)
        | v96423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8869,axiom,
    ! [VarCurr: state_type] :
      ( v96675(VarCurr)
    <=> ( v96669(VarCurr)
        & v96676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8868,axiom,
    ! [VarCurr: state_type] :
      ( v96676(VarCurr)
    <=> ( v940(VarCurr)
        | v960(VarCurr) ) ) ).

tff(addAssignment_58715,axiom,
    ! [VarCurr: state_type] :
      ( v96669(VarCurr)
    <=> v96671(VarCurr) ) ).

tff(addAssignment_58714,axiom,
    ! [VarCurr: state_type] :
      ( v96671(VarCurr)
    <=> v96673(VarCurr) ) ).

tff(addAssignment_58713,axiom,
    ! [VarCurr: state_type] :
      ( v96673(VarCurr)
    <=> v8(VarCurr,4) ) ).

tff(addAssignment_58712,axiom,
    ! [VarCurr: state_type] :
      ( v96657(VarCurr)
    <=> v96659(VarCurr) ) ).

tff(addAssignment_58711,axiom,
    ! [VarCurr: state_type] :
      ( v96659(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_58710,axiom,
    ! [VarCurr: state_type] :
      ( v96653(VarCurr)
    <=> v96655(VarCurr) ) ).

tff(addAssignment_58709,axiom,
    ! [VarCurr: state_type] :
      ( v96655(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_58708,axiom,
    ! [VarCurr: state_type] :
      ( v96601(VarCurr)
    <=> v96603(VarCurr) ) ).

tff(addAssignment_58707,axiom,
    ! [VarCurr: state_type] :
      ( v96603(VarCurr)
    <=> v96605(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96626(VarNext)
       => ( v96605(VarNext)
        <=> v96605(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1075,axiom,
    ! [VarNext: state_type] :
      ( v96626(VarNext)
     => ( v96605(VarNext)
      <=> v96636(VarNext) ) ) ).

tff(addAssignment_58706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96636(VarNext)
      <=> v96634(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96637(VarCurr)
     => ( v96634(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_581,axiom,
    ! [VarCurr: state_type] :
      ( v96637(VarCurr)
     => ( v96634(VarCurr)
      <=> v96615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8867,axiom,
    ! [VarCurr: state_type] :
      ( v96637(VarCurr)
    <=> ( v96638(VarCurr)
        & v96639(VarCurr) ) ) ).

tff(writeUnaryOperator_4409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96639(VarCurr)
    <=> v96611(VarCurr) ) ).

tff(writeUnaryOperator_4408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96638(VarCurr)
    <=> v96607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96626(VarNext)
      <=> v96627(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96627(VarNext)
      <=> ( v96628(VarNext)
          & v96621(VarNext) ) ) ) ).

tff(writeUnaryOperator_4407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96628(VarNext)
      <=> v96630(VarNext) ) ) ).

tff(addAssignment_58705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96630(VarNext)
      <=> v96621(VarCurr) ) ) ).

tff(addAssignment_58704,axiom,
    ! [VarCurr: state_type] :
      ( v96621(VarCurr)
    <=> v96623(VarCurr) ) ).

tff(addAssignment_58703,axiom,
    ! [VarCurr: state_type] :
      ( v96623(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58702,axiom,
    ! [VarCurr: state_type] :
      ( v96615(VarCurr)
    <=> v96617(VarCurr) ) ).

tff(addAssignment_58701,axiom,
    ! [VarCurr: state_type] :
      ( v96617(VarCurr)
    <=> v96619(VarCurr) ) ).

tff(addAssignment_58700,axiom,
    ! [VarCurr: state_type] :
      ( v96619(VarCurr)
    <=> v94760(VarCurr) ) ).

tff(addAssignment_58699,axiom,
    ! [VarCurr: state_type] :
      ( v96611(VarCurr)
    <=> v96613(VarCurr) ) ).

tff(addAssignment_58698,axiom,
    ! [VarCurr: state_type] :
      ( v96613(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58697,axiom,
    ! [VarCurr: state_type] :
      ( v96607(VarCurr)
    <=> v96609(VarCurr) ) ).

tff(addAssignment_58696,axiom,
    ! [VarCurr: state_type] :
      ( v96609(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_58695,axiom,
    ! [VarCurr: state_type] :
      ( v96589(VarCurr)
    <=> v96591(VarCurr) ) ).

tff(addAssignment_58694,axiom,
    ! [VarCurr: state_type] :
      ( v96591(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58693,axiom,
    ! [VarCurr: state_type] :
      ( v96585(VarCurr)
    <=> v96587(VarCurr) ) ).

tff(addAssignment_58692,axiom,
    ! [VarCurr: state_type] :
      ( v96587(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_58691,axiom,
    ! [VarCurr: state_type] :
      ( v89700(VarCurr)
    <=> v89702(VarCurr,3) ) ).

tff(addAssignment_58690,axiom,
    ! [VarCurr: state_type] :
      ( v89702(VarCurr,3)
    <=> v89704(VarCurr,3) ) ).

tff(addAssignment_58689,axiom,
    ! [VarNext: state_type] :
      ( v89704(VarNext,3)
    <=> v96571(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96572(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v96571(VarNext,B)
            <=> v89704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1074,axiom,
    ! [VarNext: state_type] :
      ( v96572(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96571(VarNext,B)
          <=> v96366(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96572(VarNext)
      <=> v96573(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96573(VarNext)
      <=> ( v96575(VarNext)
          & v96351(VarNext) ) ) ) ).

tff(writeUnaryOperator_4406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96575(VarNext)
      <=> v96360(VarNext) ) ) ).

tff(addAssignment_58688,axiom,
    ! [VarCurr: state_type] :
      ( v89714(VarCurr,3)
    <=> v89716(VarCurr,3) ) ).

tff(addAssignment_58687,axiom,
    ! [VarCurr: state_type] :
      ( v89716(VarCurr,3)
    <=> v89718(VarCurr,3) ) ).

tff(addAssignment_58686,axiom,
    ! [VarCurr: state_type] :
      ( v89718(VarCurr,3)
    <=> v96347(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8862,axiom,
    ! [VarCurr: state_type] :
      ( v89720(VarCurr)
    <=> ( v89722(VarCurr)
        | v96568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8861,axiom,
    ! [VarCurr: state_type] :
      ( v96568(VarCurr)
    <=> ( v89700(VarCurr)
        & v96569(VarCurr) ) ) ).

tff(writeUnaryOperator_4405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96569(VarCurr)
    <=> v96565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8860,axiom,
    ! [VarCurr: state_type] :
      ( v96565(VarCurr)
    <=> ( v94760(VarCurr)
        | v96317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8859,axiom,
    ! [VarCurr: state_type] :
      ( v89722(VarCurr)
    <=> ( v96535(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8858,axiom,
    ! [VarCurr: state_type] :
      ( v96535(VarCurr)
    <=> ( v96536(VarCurr)
        & v96563(VarCurr) ) ) ).

tff(writeUnaryOperator_4404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96563(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8857,axiom,
    ! [VarCurr: state_type] :
      ( v96536(VarCurr)
    <=> ( v96537(VarCurr)
        & v4513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8856,axiom,
    ! [VarCurr: state_type] :
      ( v96537(VarCurr)
    <=> ( v96538(VarCurr)
        | v90798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8855,axiom,
    ! [VarCurr: state_type] :
      ( v96538(VarCurr)
    <=> ( v96539(VarCurr)
        | v96551(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3725,axiom,
    ! [VarCurr: state_type] :
      ( v96551(VarCurr)
    <=> ( v96553(VarCurr)
        | v90304(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3724,axiom,
    ! [VarCurr: state_type] :
      ( v96553(VarCurr)
    <=> ( v96554(VarCurr)
        | v90304(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3723,axiom,
    ! [VarCurr: state_type] :
      ( v96554(VarCurr)
    <=> ( v96555(VarCurr)
        | v90304(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3722,axiom,
    ! [VarCurr: state_type] :
      ( v96555(VarCurr)
    <=> ( v96556(VarCurr)
        | v90304(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3721,axiom,
    ! [VarCurr: state_type] :
      ( v96556(VarCurr)
    <=> ( v96557(VarCurr)
        | v90304(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3720,axiom,
    ! [VarCurr: state_type] :
      ( v96557(VarCurr)
    <=> ( v96558(VarCurr)
        | v90304(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3719,axiom,
    ! [VarCurr: state_type] :
      ( v96558(VarCurr)
    <=> ( v96559(VarCurr)
        | v90304(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3718,axiom,
    ! [VarCurr: state_type] :
      ( v96559(VarCurr)
    <=> ( v96560(VarCurr)
        | v90304(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3717,axiom,
    ! [VarCurr: state_type] :
      ( v96560(VarCurr)
    <=> ( v96561(VarCurr)
        | v90304(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3716,axiom,
    ! [VarCurr: state_type] :
      ( v96561(VarCurr)
    <=> ( v96562(VarCurr)
        | v90304(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3715,axiom,
    ! [VarCurr: state_type] :
      ( v96562(VarCurr)
    <=> ( v90304(VarCurr,0)
        | v90304(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3714,axiom,
    ! [VarCurr: state_type] :
      ( v96539(VarCurr)
    <=> ( v96541(VarCurr)
        | v89724(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3713,axiom,
    ! [VarCurr: state_type] :
      ( v96541(VarCurr)
    <=> ( v96542(VarCurr)
        | v89724(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3712,axiom,
    ! [VarCurr: state_type] :
      ( v96542(VarCurr)
    <=> ( v96543(VarCurr)
        | v89724(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3711,axiom,
    ! [VarCurr: state_type] :
      ( v96543(VarCurr)
    <=> ( v96544(VarCurr)
        | v89724(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3710,axiom,
    ! [VarCurr: state_type] :
      ( v96544(VarCurr)
    <=> ( v96545(VarCurr)
        | v89724(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3709,axiom,
    ! [VarCurr: state_type] :
      ( v96545(VarCurr)
    <=> ( v96546(VarCurr)
        | v89724(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3708,axiom,
    ! [VarCurr: state_type] :
      ( v96546(VarCurr)
    <=> ( v96547(VarCurr)
        | v89724(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3707,axiom,
    ! [VarCurr: state_type] :
      ( v96547(VarCurr)
    <=> ( v96548(VarCurr)
        | v89724(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3706,axiom,
    ! [VarCurr: state_type] :
      ( v96548(VarCurr)
    <=> ( v96549(VarCurr)
        | v89724(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3705,axiom,
    ! [VarCurr: state_type] :
      ( v96549(VarCurr)
    <=> ( v96550(VarCurr)
        | v89724(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3704,axiom,
    ! [VarCurr: state_type] :
      ( v96550(VarCurr)
    <=> ( v89724(VarCurr,0)
        | v89724(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8854,axiom,
    ! [VarCurr: state_type] :
      ( v90798(VarCurr)
    <=> ( v96530(VarCurr)
        & v96531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8853,axiom,
    ! [VarCurr: state_type] :
      ( v96531(VarCurr)
    <=> ( v96532(VarCurr)
        | v94294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8852,axiom,
    ! [VarCurr: state_type] :
      ( v96532(VarCurr)
    <=> ( v90859(VarCurr)
        & v96533(VarCurr) ) ) ).

tff(writeUnaryOperator_4403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96533(VarCurr)
    <=> v90968(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_519,axiom,
    ! [VarCurr: state_type] :
      ( v96530(VarCurr)
    <=> ( ( v90800(VarCurr,1)
        <=> $true )
        & ( v90800(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_58685,axiom,
    ! [VarCurr: state_type] :
      ( v90968(VarCurr)
    <=> v90970(VarCurr) ) ).

tff(addAssignment_58684,axiom,
    ! [VarCurr: state_type] :
      ( v90970(VarCurr)
    <=> v90972(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96513(VarNext)
       => ( v90972(VarNext)
        <=> v90972(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1073,axiom,
    ! [VarNext: state_type] :
      ( v96513(VarNext)
     => ( v90972(VarNext)
      <=> v96523(VarNext) ) ) ).

tff(addAssignment_58683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96523(VarNext)
      <=> v96521(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96524(VarCurr)
     => ( v96521(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_580,axiom,
    ! [VarCurr: state_type] :
      ( v96524(VarCurr)
     => ( v96521(VarCurr)
      <=> v90982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8851,axiom,
    ! [VarCurr: state_type] :
      ( v96524(VarCurr)
    <=> ( v96525(VarCurr)
        & v96526(VarCurr) ) ) ).

tff(writeUnaryOperator_4402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96526(VarCurr)
    <=> v90978(VarCurr) ) ).

tff(writeUnaryOperator_4401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96525(VarCurr)
    <=> v90974(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96513(VarNext)
      <=> v96514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96514(VarNext)
      <=> ( v96515(VarNext)
          & v96508(VarNext) ) ) ) ).

tff(writeUnaryOperator_4400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96515(VarNext)
      <=> v96517(VarNext) ) ) ).

tff(addAssignment_58682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96517(VarNext)
      <=> v96508(VarCurr) ) ) ).

tff(addAssignment_58681,axiom,
    ! [VarCurr: state_type] :
      ( v96508(VarCurr)
    <=> v96510(VarCurr) ) ).

tff(addAssignment_58680,axiom,
    ! [VarCurr: state_type] :
      ( v96510(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58679,axiom,
    ! [VarCurr: state_type] :
      ( v90982(VarCurr)
    <=> v90984(VarCurr) ) ).

tff(addAssignment_58678,axiom,
    ! [VarCurr: state_type] :
      ( v90984(VarCurr)
    <=> v90986(VarCurr) ) ).

tff(addAssignment_58677,axiom,
    ! [VarCurr: state_type] :
      ( v90986(VarCurr)
    <=> v90988(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96497(VarCurr)
     => ( v90988(VarCurr)
      <=> v96505(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_579,axiom,
    ! [VarCurr: state_type] :
      ( v96497(VarCurr)
     => ( v90988(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96506(VarCurr)
     => ( v96505(VarCurr)
      <=> v90968(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_578,axiom,
    ! [VarCurr: state_type] :
      ( v96506(VarCurr)
     => ( v96505(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8848,axiom,
    ! [VarCurr: state_type] :
      ( v96506(VarCurr)
    <=> ( v96390(VarCurr)
        | v96455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8847,axiom,
    ! [VarCurr: state_type] :
      ( v96497(VarCurr)
    <=> ( v90859(VarCurr)
        & v96498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8846,axiom,
    ! [VarCurr: state_type] :
      ( v96498(VarCurr)
    <=> ( v96499(VarCurr)
        | v96504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8845,axiom,
    ! [VarCurr: state_type] :
      ( v96504(VarCurr)
    <=> ( v96373(VarCurr)
        & v96214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8844,axiom,
    ! [VarCurr: state_type] :
      ( v96499(VarCurr)
    <=> ( v96500(VarCurr)
        | v96503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8843,axiom,
    ! [VarCurr: state_type] :
      ( v96503(VarCurr)
    <=> ( v94331(VarCurr)
        & v94719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8842,axiom,
    ! [VarCurr: state_type] :
      ( v96500(VarCurr)
    <=> ( v96501(VarCurr)
        | v96502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8841,axiom,
    ! [VarCurr: state_type] :
      ( v96502(VarCurr)
    <=> ( v89700(VarCurr)
        & v90798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8840,axiom,
    ! [VarCurr: state_type] :
      ( v96501(VarCurr)
    <=> ( v90990(VarCurr)
        & v94292(VarCurr) ) ) ).

tff(addAssignment_58676,axiom,
    ! [VarCurr: state_type] :
      ( v96455(VarCurr)
    <=> v96457(VarCurr) ) ).

tff(addAssignment_58675,axiom,
    ! [VarCurr: state_type] :
      ( v96457(VarCurr)
    <=> v96459(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96480(VarNext)
       => ( v96459(VarNext)
        <=> v96459(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1072,axiom,
    ! [VarNext: state_type] :
      ( v96480(VarNext)
     => ( v96459(VarNext)
      <=> v96490(VarNext) ) ) ).

tff(addAssignment_58674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96490(VarNext)
      <=> v96488(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96491(VarCurr)
     => ( v96488(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_577,axiom,
    ! [VarCurr: state_type] :
      ( v96491(VarCurr)
     => ( v96488(VarCurr)
      <=> v96469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8839,axiom,
    ! [VarCurr: state_type] :
      ( v96491(VarCurr)
    <=> ( v96492(VarCurr)
        & v96493(VarCurr) ) ) ).

tff(writeUnaryOperator_4399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96493(VarCurr)
    <=> v96465(VarCurr) ) ).

tff(writeUnaryOperator_4398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96492(VarCurr)
    <=> v96461(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96480(VarNext)
      <=> v96481(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96481(VarNext)
      <=> ( v96482(VarNext)
          & v96475(VarNext) ) ) ) ).

tff(writeUnaryOperator_4397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96482(VarNext)
      <=> v96484(VarNext) ) ) ).

tff(addAssignment_58673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96484(VarNext)
      <=> v96475(VarCurr) ) ) ).

tff(addAssignment_58672,axiom,
    ! [VarCurr: state_type] :
      ( v96475(VarCurr)
    <=> v96477(VarCurr) ) ).

tff(addAssignment_58671,axiom,
    ! [VarCurr: state_type] :
      ( v96477(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58670,axiom,
    ! [VarCurr: state_type] :
      ( v96469(VarCurr)
    <=> v96471(VarCurr) ) ).

tff(addAssignment_58669,axiom,
    ! [VarCurr: state_type] :
      ( v96471(VarCurr)
    <=> v96473(VarCurr) ) ).

tff(addAssignment_58668,axiom,
    ! [VarCurr: state_type] :
      ( v96473(VarCurr)
    <=> v96317(VarCurr) ) ).

tff(addAssignment_58667,axiom,
    ! [VarCurr: state_type] :
      ( v96465(VarCurr)
    <=> v96467(VarCurr) ) ).

tff(addAssignment_58666,axiom,
    ! [VarCurr: state_type] :
      ( v96467(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58665,axiom,
    ! [VarCurr: state_type] :
      ( v96461(VarCurr)
    <=> v96463(VarCurr) ) ).

tff(addAssignment_58664,axiom,
    ! [VarCurr: state_type] :
      ( v96463(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_58663,axiom,
    ! [VarCurr: state_type] :
      ( v96390(VarCurr)
    <=> v96392(VarCurr) ) ).

tff(addAssignment_58662,axiom,
    ! [VarCurr: state_type] :
      ( v96392(VarCurr)
    <=> v96394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8836,axiom,
    ! [VarCurr: state_type] :
      ( v96394(VarCurr)
    <=> ( v96396(VarCurr)
        | v96450(VarCurr) ) ) ).

tff(addAssignment_58661,axiom,
    ! [VarCurr: state_type] :
      ( v96450(VarCurr)
    <=> v96452(VarCurr) ) ).

tff(addAssignment_58660,axiom,
    ! [VarCurr: state_type] :
      ( v96452(VarCurr)
    <=> v96319(VarCurr) ) ).

tff(addAssignment_58659,axiom,
    ! [VarCurr: state_type] :
      ( v96396(VarCurr)
    <=> v96398(VarCurr) ) ).

tff(addAssignment_58658,axiom,
    ! [VarCurr: state_type] :
      ( v96398(VarCurr)
    <=> v96400(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96433(VarNext)
       => ( v96400(VarNext)
        <=> v96400(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1071,axiom,
    ! [VarNext: state_type] :
      ( v96433(VarNext)
     => ( v96400(VarNext)
      <=> v96443(VarNext) ) ) ).

tff(addAssignment_58657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96443(VarNext)
      <=> v96441(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96444(VarCurr)
     => ( v96441(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_576,axiom,
    ! [VarCurr: state_type] :
      ( v96444(VarCurr)
     => ( v96441(VarCurr)
      <=> v96410(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8835,axiom,
    ! [VarCurr: state_type] :
      ( v96444(VarCurr)
    <=> ( v96445(VarCurr)
        & v96446(VarCurr) ) ) ).

tff(writeUnaryOperator_4396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96446(VarCurr)
    <=> v96406(VarCurr) ) ).

tff(writeUnaryOperator_4395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96445(VarCurr)
    <=> v96402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96433(VarNext)
      <=> v96434(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96434(VarNext)
      <=> ( v96435(VarNext)
          & v96428(VarNext) ) ) ) ).

tff(writeUnaryOperator_4394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96435(VarNext)
      <=> v96437(VarNext) ) ) ).

tff(addAssignment_58656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96437(VarNext)
      <=> v96428(VarCurr) ) ) ).

tff(addAssignment_58655,axiom,
    ! [VarCurr: state_type] :
      ( v96428(VarCurr)
    <=> v96430(VarCurr) ) ).

tff(addAssignment_58654,axiom,
    ! [VarCurr: state_type] :
      ( v96430(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_58653,axiom,
    ! [VarCurr: state_type] :
      ( v96410(VarCurr)
    <=> v96412(VarCurr) ) ).

tff(addAssignment_58652,axiom,
    ! [VarCurr: state_type] :
      ( v96412(VarCurr)
    <=> v96414(VarCurr) ) ).

tff(addAssignment_58651,axiom,
    ! [VarCurr: state_type] :
      ( v96414(VarCurr)
    <=> v96416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8832,axiom,
    ! [VarCurr: state_type] :
      ( v96416(VarCurr)
    <=> ( v96425(VarCurr)
        & v96426(VarCurr) ) ) ).

tff(writeUnaryOperator_4393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96426(VarCurr)
    <=> v96423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8831,axiom,
    ! [VarCurr: state_type] :
      ( v96425(VarCurr)
    <=> ( v96418(VarCurr)
        & v5776(VarCurr) ) ) ).

tff(addAssignment_58650,axiom,
    ! [VarCurr: state_type] :
      ( v96423(VarCurr)
    <=> v89529(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8830,axiom,
    ! [VarCurr: state_type] :
      ( v96418(VarCurr)
    <=> ( v96420(VarCurr)
        & v5776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8829,axiom,
    ! [VarCurr: state_type] :
      ( v96420(VarCurr)
    <=> ( v1001(VarCurr)
        & v96421(VarCurr) ) ) ).

tff(writeUnaryOperator_4392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96421(VarCurr)
    <=> v940(VarCurr) ) ).

tff(addAssignment_58649,axiom,
    ! [VarCurr: state_type] :
      ( v96406(VarCurr)
    <=> v96408(VarCurr) ) ).

tff(addAssignment_58648,axiom,
    ! [VarCurr: state_type] :
      ( v96408(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_58647,axiom,
    ! [VarCurr: state_type] :
      ( v96402(VarCurr)
    <=> v96404(VarCurr) ) ).

tff(addAssignment_58646,axiom,
    ! [VarCurr: state_type] :
      ( v96404(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_58645,axiom,
    ! [VarCurr: state_type] :
      ( v96373(VarCurr)
    <=> v89702(VarCurr,1) ) ).

tff(addAssignment_58644,axiom,
    ! [VarCurr: state_type] :
      ( v89702(VarCurr,1)
    <=> v89704(VarCurr,1) ) ).

tff(addAssignment_58643,axiom,
    ! [VarNext: state_type] :
      ( v89704(VarNext,1)
    <=> v96382(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96383(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v96382(VarNext,B)
            <=> v89704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1070,axiom,
    ! [VarNext: state_type] :
      ( v96383(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96382(VarNext,B)
          <=> v96366(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96383(VarNext)
      <=> v96384(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96384(VarNext)
      <=> ( v96386(VarNext)
          & v96351(VarNext) ) ) ) ).

tff(writeUnaryOperator_4391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96386(VarNext)
      <=> v96360(VarNext) ) ) ).

tff(addAssignment_58642,axiom,
    ! [VarCurr: state_type] :
      ( v89714(VarCurr,1)
    <=> v89716(VarCurr,1) ) ).

tff(addAssignment_58641,axiom,
    ! [VarCurr: state_type] :
      ( v89716(VarCurr,1)
    <=> v89718(VarCurr,1) ) ).

tff(addAssignment_58640,axiom,
    ! [VarCurr: state_type] :
      ( v89718(VarCurr,1)
    <=> v96347(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8826,axiom,
    ! [VarCurr: state_type] :
      ( v96348(VarCurr)
    <=> ( v94806(VarCurr)
        | v96379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8825,axiom,
    ! [VarCurr: state_type] :
      ( v96379(VarCurr)
    <=> ( v96373(VarCurr)
        & v96380(VarCurr) ) ) ).

tff(writeUnaryOperator_4390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96380(VarCurr)
    <=> v96376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8824,axiom,
    ! [VarCurr: state_type] :
      ( v96376(VarCurr)
    <=> ( v94760(VarCurr)
        | v96317(VarCurr) ) ) ).

tff(addAssignment_58639,axiom,
    ! [VarCurr: state_type] :
      ( v94331(VarCurr)
    <=> v89702(VarCurr,2) ) ).

tff(addAssignment_58638,axiom,
    ! [VarCurr: state_type] :
      ( v89702(VarCurr,2)
    <=> v89704(VarCurr,2) ) ).

tff(addAssignment_58637,axiom,
    ! [VarNext: state_type] :
      ( v89704(VarNext,2)
    <=> v96355(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96356(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v96355(VarNext,B)
            <=> v89704(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1069,axiom,
    ! [VarNext: state_type] :
      ( v96356(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96355(VarNext,B)
          <=> v96366(VarNext,B) ) ) ) ).

tff(addAssignment_58636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96366(VarNext,B)
          <=> v96364(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96367(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96364(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_575,axiom,
    ! [VarCurr: state_type] :
      ( v96367(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v96364(VarCurr,B)
          <=> v89714(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8823,axiom,
    ! [VarCurr: state_type] :
      ( v96367(VarCurr)
    <=> ( v96368(VarCurr)
        & v96369(VarCurr) ) ) ).

tff(writeUnaryOperator_4389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96369(VarCurr)
    <=> v89710(VarCurr) ) ).

tff(writeUnaryOperator_4388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96368(VarCurr)
    <=> v89706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96356(VarNext)
      <=> v96357(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96357(VarNext)
      <=> ( v96358(VarNext)
          & v96351(VarNext) ) ) ) ).

tff(writeUnaryOperator_4387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96358(VarNext)
      <=> v96360(VarNext) ) ) ).

tff(addAssignment_58635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96360(VarNext)
      <=> v96351(VarCurr) ) ) ).

tff(addAssignment_58634,axiom,
    ! [VarCurr: state_type] :
      ( v96351(VarCurr)
    <=> v96353(VarCurr) ) ).

tff(addAssignment_58633,axiom,
    ! [VarCurr: state_type] :
      ( v96353(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58632,axiom,
    ! [VarCurr: state_type] :
      ( v89714(VarCurr,2)
    <=> v89716(VarCurr,2) ) ).

tff(addAssignment_58631,axiom,
    ! [VarCurr: state_type] :
      ( v89716(VarCurr,2)
    <=> v89718(VarCurr,2) ) ).

tff(addAssignment_58630,axiom,
    ! [VarCurr: state_type] :
      ( v89718(VarCurr,2)
    <=> v96347(VarCurr,2) ) ).

tff(addAssignment_58629,axiom,
    ! [VarCurr: state_type] :
      ( v96347(VarCurr,0)
    <=> v96349(VarCurr) ) ).

tff(addAssignment_58628,axiom,
    ! [VarCurr: state_type] :
      ( v96347(VarCurr,1)
    <=> v96348(VarCurr) ) ).

tff(addAssignment_58627,axiom,
    ! [VarCurr: state_type] :
      ( v96347(VarCurr,2)
    <=> v94333(VarCurr) ) ).

tff(addAssignment_58626,axiom,
    ! [VarCurr: state_type] :
      ( v96347(VarCurr,3)
    <=> v89720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8820,axiom,
    ! [VarCurr: state_type] :
      ( v94333(VarCurr)
    <=> ( v94335(VarCurr)
        | v96345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8819,axiom,
    ! [VarCurr: state_type] :
      ( v96345(VarCurr)
    <=> ( v94331(VarCurr)
        & v96346(VarCurr) ) ) ).

tff(writeUnaryOperator_4386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96346(VarCurr)
    <=> v94758(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8818,axiom,
    ! [VarCurr: state_type] :
      ( v94758(VarCurr)
    <=> ( v94760(VarCurr)
        | v96317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8817,axiom,
    ! [VarCurr: state_type] :
      ( v96317(VarCurr)
    <=> ( v96329(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8816,axiom,
    ! [VarCurr: state_type] :
      ( v96329(VarCurr)
    <=> ( v96330(VarCurr)
        | v96319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8815,axiom,
    ! [VarCurr: state_type] :
      ( v96330(VarCurr)
    <=> ( v96331(VarCurr)
        | v96338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8814,axiom,
    ! [VarCurr: state_type] :
      ( v96338(VarCurr)
    <=> ( v96339(VarCurr)
        & v96342(VarCurr) ) ) ).

tff(writeUnaryOperator_4385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96342(VarCurr)
    <=> v96270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8813,axiom,
    ! [VarCurr: state_type] :
      ( v96339(VarCurr)
    <=> ( v96340(VarCurr)
        & v96341(VarCurr) ) ) ).

tff(writeUnaryOperator_4384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96341(VarCurr)
    <=> v94806(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3703,axiom,
    ! [VarCurr: state_type] :
      ( v96340(VarCurr)
    <=> ( v89674(VarCurr,6)
        & v94762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8812,axiom,
    ! [VarCurr: state_type] :
      ( v96331(VarCurr)
    <=> ( v96332(VarCurr)
        | v96335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8811,axiom,
    ! [VarCurr: state_type] :
      ( v96335(VarCurr)
    <=> ( v96336(VarCurr)
        & v96337(VarCurr) ) ) ).

tff(writeUnaryOperator_4383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96337(VarCurr)
    <=> v89722(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3702,axiom,
    ! [VarCurr: state_type] :
      ( v96336(VarCurr)
    <=> ( v89674(VarCurr,4)
        & v4513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8810,axiom,
    ! [VarCurr: state_type] :
      ( v96332(VarCurr)
    <=> ( v96333(VarCurr)
        & v96334(VarCurr) ) ) ).

tff(writeUnaryOperator_4382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96334(VarCurr)
    <=> v89722(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3701,axiom,
    ! [VarCurr: state_type] :
      ( v96333(VarCurr)
    <=> ( v89674(VarCurr,1)
        & v4513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8809,axiom,
    ! [VarCurr: state_type] :
      ( v96319(VarCurr)
    <=> ( v96321(VarCurr)
        & v96327(VarCurr) ) ) ).

tff(writeUnaryOperator_4381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96327(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8808,axiom,
    ! [VarCurr: state_type] :
      ( v96321(VarCurr)
    <=> ( v96322(VarCurr)
        & v6136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8807,axiom,
    ! [VarCurr: state_type] :
      ( v96322(VarCurr)
    <=> ( v96323(VarCurr)
        | v94292(VarCurr) ) ) ).

tff(writeUnaryOperator_4380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96323(VarCurr)
    <=> v96324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8806,axiom,
    ! [VarCurr: state_type] :
      ( v96324(VarCurr)
    <=> ( v96325(VarCurr)
        & v93475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8805,axiom,
    ! [VarCurr: state_type] :
      ( v96325(VarCurr)
    <=> ( v96326(VarCurr)
        & v92642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8804,axiom,
    ! [VarCurr: state_type] :
      ( v96326(VarCurr)
    <=> ( v90992(VarCurr)
        & v91825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8803,axiom,
    ! [VarCurr: state_type] :
      ( v94760(VarCurr)
    <=> ( v96313(VarCurr)
        & v96315(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8802,axiom,
    ! [VarCurr: state_type] :
      ( v96315(VarCurr)
    <=> ( v94806(VarCurr)
        | v96270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8801,axiom,
    ! [VarCurr: state_type] :
      ( v96313(VarCurr)
    <=> ( v96314(VarCurr)
        & v94762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3700,axiom,
    ! [VarCurr: state_type] :
      ( v96314(VarCurr)
    <=> ( v89674(VarCurr,6)
        & v4574(VarCurr) ) ) ).

tff(addAssignment_58625,axiom,
    ! [VarCurr: state_type] :
      ( v96270(VarCurr)
    <=> v96272(VarCurr,1) ) ).

tff(addAssignment_58624,axiom,
    ! [VarCurr: state_type] :
      ( v96272(VarCurr,1)
    <=> v96274(VarCurr,1) ) ).

tff(addAssignment_58623,axiom,
    ! [VarNext: state_type] :
      ( v96274(VarNext,1)
    <=> v96295(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96296(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v96295(VarNext,B)
            <=> v96274(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1068,axiom,
    ! [VarNext: state_type] :
      ( v96296(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v96295(VarNext,B)
          <=> v96306(VarNext,B) ) ) ) ).

tff(addAssignment_58622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v96306(VarNext,B)
          <=> v96304(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96307(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v96304(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_574,axiom,
    ! [VarCurr: state_type] :
      ( v96307(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v96304(VarCurr,B)
          <=> v96284(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8800,axiom,
    ! [VarCurr: state_type] :
      ( v96307(VarCurr)
    <=> ( v96308(VarCurr)
        & v96309(VarCurr) ) ) ).

tff(writeUnaryOperator_4379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96309(VarCurr)
    <=> v96280(VarCurr) ) ).

tff(writeUnaryOperator_4378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96308(VarCurr)
    <=> v96276(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96296(VarNext)
      <=> v96297(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96297(VarNext)
      <=> ( v96298(VarNext)
          & v96291(VarNext) ) ) ) ).

tff(writeUnaryOperator_4377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96298(VarNext)
      <=> v96300(VarNext) ) ) ).

tff(addAssignment_58621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96300(VarNext)
      <=> v96291(VarCurr) ) ) ).

tff(addAssignment_58620,axiom,
    ! [VarCurr: state_type] :
      ( v96291(VarCurr)
    <=> v96293(VarCurr) ) ).

tff(addAssignment_58619,axiom,
    ! [VarCurr: state_type] :
      ( v96293(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_58618,axiom,
    ! [VarCurr: state_type] :
      ( v96284(VarCurr,1)
    <=> v96286(VarCurr,1) ) ).

tff(addAssignment_58617,axiom,
    ! [VarCurr: state_type] :
      ( v96286(VarCurr,1)
    <=> v96288(VarCurr,1) ) ).

tff(addAssignment_58616,axiom,
    ! [VarCurr: state_type] :
      ( v96288(VarCurr,1)
    <=> v96289(VarCurr,1) ) ).

tff(addAssignment_58615,axiom,
    ! [VarCurr: state_type] :
      ( v96289(VarCurr,0)
    <=> v94335(VarCurr) ) ).

tff(addAssignment_58614,axiom,
    ! [VarCurr: state_type] :
      ( v96289(VarCurr,1)
    <=> v89722(VarCurr) ) ).

tff(addAssignment_58613,axiom,
    ! [VarCurr: state_type] :
      ( v96280(VarCurr)
    <=> v96282(VarCurr) ) ).

tff(addAssignment_58612,axiom,
    ! [VarCurr: state_type] :
      ( v96282(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_58611,axiom,
    ! [VarCurr: state_type] :
      ( v96276(VarCurr)
    <=> v96278(VarCurr) ) ).

tff(addAssignment_58610,axiom,
    ! [VarCurr: state_type] :
      ( v96278(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8797,axiom,
    ! [VarCurr: state_type] :
      ( v94806(VarCurr)
    <=> ( v96235(VarCurr)
        & v96268(VarCurr) ) ) ).

tff(writeUnaryOperator_4376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96268(VarCurr)
    <=> v96221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8796,axiom,
    ! [VarCurr: state_type] :
      ( v96235(VarCurr)
    <=> ( v96236(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8795,axiom,
    ! [VarCurr: state_type] :
      ( v96236(VarCurr)
    <=> ( v96237(VarCurr)
        & v96267(VarCurr) ) ) ).

tff(writeUnaryOperator_4375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96267(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8794,axiom,
    ! [VarCurr: state_type] :
      ( v96237(VarCurr)
    <=> ( v96238(VarCurr)
        | v96214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8793,axiom,
    ! [VarCurr: state_type] :
      ( v96238(VarCurr)
    <=> ( v96239(VarCurr)
        | v96252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8792,axiom,
    ! [VarCurr: state_type] :
      ( v96252(VarCurr)
    <=> ( v96253(VarCurr)
        & v96266(VarCurr) ) ) ).

tff(writeUnaryOperator_4374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96266(VarCurr)
    <=> v10059(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_3699,axiom,
    ! [VarCurr: state_type] :
      ( v96253(VarCurr)
    <=> ( v96255(VarCurr)
        & v95740(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3698,axiom,
    ! [VarCurr: state_type] :
      ( v96255(VarCurr)
    <=> ( v96256(VarCurr)
        & v95740(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3697,axiom,
    ! [VarCurr: state_type] :
      ( v96256(VarCurr)
    <=> ( v96257(VarCurr)
        & v95740(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3696,axiom,
    ! [VarCurr: state_type] :
      ( v96257(VarCurr)
    <=> ( v96258(VarCurr)
        & v95740(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3695,axiom,
    ! [VarCurr: state_type] :
      ( v96258(VarCurr)
    <=> ( v96259(VarCurr)
        & v95740(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3694,axiom,
    ! [VarCurr: state_type] :
      ( v96259(VarCurr)
    <=> ( v96260(VarCurr)
        & v95740(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3693,axiom,
    ! [VarCurr: state_type] :
      ( v96260(VarCurr)
    <=> ( v96261(VarCurr)
        & v95740(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3692,axiom,
    ! [VarCurr: state_type] :
      ( v96261(VarCurr)
    <=> ( v96262(VarCurr)
        & v95740(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3691,axiom,
    ! [VarCurr: state_type] :
      ( v96262(VarCurr)
    <=> ( v96263(VarCurr)
        & v95740(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3690,axiom,
    ! [VarCurr: state_type] :
      ( v96263(VarCurr)
    <=> ( v96264(VarCurr)
        & v95740(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3689,axiom,
    ! [VarCurr: state_type] :
      ( v96264(VarCurr)
    <=> ( v96265(VarCurr)
        & v95740(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3688,axiom,
    ! [VarCurr: state_type] :
      ( v96265(VarCurr)
    <=> ( v95740(VarCurr,0)
        & v95740(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3687,axiom,
    ! [VarCurr: state_type] :
      ( v96239(VarCurr)
    <=> ( v96241(VarCurr)
        & v94808(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3686,axiom,
    ! [VarCurr: state_type] :
      ( v96241(VarCurr)
    <=> ( v96242(VarCurr)
        & v94808(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3685,axiom,
    ! [VarCurr: state_type] :
      ( v96242(VarCurr)
    <=> ( v96243(VarCurr)
        & v94808(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3684,axiom,
    ! [VarCurr: state_type] :
      ( v96243(VarCurr)
    <=> ( v96244(VarCurr)
        & v94808(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3683,axiom,
    ! [VarCurr: state_type] :
      ( v96244(VarCurr)
    <=> ( v96245(VarCurr)
        & v94808(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3682,axiom,
    ! [VarCurr: state_type] :
      ( v96245(VarCurr)
    <=> ( v96246(VarCurr)
        & v94808(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3681,axiom,
    ! [VarCurr: state_type] :
      ( v96246(VarCurr)
    <=> ( v96247(VarCurr)
        & v94808(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3680,axiom,
    ! [VarCurr: state_type] :
      ( v96247(VarCurr)
    <=> ( v96248(VarCurr)
        & v94808(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3679,axiom,
    ! [VarCurr: state_type] :
      ( v96248(VarCurr)
    <=> ( v96249(VarCurr)
        & v94808(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3678,axiom,
    ! [VarCurr: state_type] :
      ( v96249(VarCurr)
    <=> ( v96250(VarCurr)
        & v94808(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3677,axiom,
    ! [VarCurr: state_type] :
      ( v96250(VarCurr)
    <=> ( v96251(VarCurr)
        & v94808(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3676,axiom,
    ! [VarCurr: state_type] :
      ( v96251(VarCurr)
    <=> ( v94808(VarCurr,0)
        & v94808(VarCurr,1) ) ) ).

tff(addAssignment_58609,axiom,
    ! [VarCurr: state_type] :
      ( v96221(VarCurr)
    <=> v96223(VarCurr) ) ).

tff(addAssignment_58608,axiom,
    ! [VarCurr: state_type] :
      ( v96223(VarCurr)
    <=> v96225(VarCurr) ) ).

tff(addAssignment_58607,axiom,
    ! [VarCurr: state_type] :
      ( v96225(VarCurr)
    <=> v8363(VarCurr,0) ) ).

tff(addAssignment_58606,axiom,
    ! [VarCurr: state_type] :
      ( v8363(VarCurr,0)
    <=> v8365(VarCurr,0) ) ).

tff(addAssignment_58605,axiom,
    ! [VarNext: state_type] :
      ( v8365(VarNext,0)
    <=> v96227(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v96227(VarNext,B)
            <=> v8365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1067,axiom,
    ! [VarNext: state_type] :
      ( v96228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v96227(VarNext,B)
          <=> v8414(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96228(VarNext)
      <=> v96229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v96229(VarNext)
      <=> ( v96231(VarNext)
          & v8399(VarNext) ) ) ) ).

tff(writeUnaryOperator_4373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v96231(VarNext)
      <=> v8408(VarNext) ) ) ).

tff(addAssignment_58604,axiom,
    ! [VarCurr: state_type] :
      ( v8377(VarCurr,0)
    <=> v8379(VarCurr,0) ) ).

tff(addAssignment_58603,axiom,
    ! [VarCurr: state_type] :
      ( v8379(VarCurr,0)
    <=> v8390(VarCurr,0) ) ).

tff(addAssignment_58602,axiom,
    ! [VarCurr: state_type] :
      ( v8381(VarCurr,0)
    <=> v8383(VarCurr,0) ) ).

tff(addAssignment_58601,axiom,
    ! [VarCurr: state_type] :
      ( v8383(VarCurr,0)
    <=> v8385(VarCurr,1) ) ).

tff(addAssignment_58600,axiom,
    ! [VarCurr: state_type] :
      ( v8385(VarCurr,1)
    <=> v2365(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8789,axiom,
    ! [VarCurr: state_type] :
      ( v96214(VarCurr)
    <=> ( v96216(VarCurr)
        & v96217(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8788,axiom,
    ! [VarCurr: state_type] :
      ( v96217(VarCurr)
    <=> ( v96218(VarCurr)
        | v94294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8787,axiom,
    ! [VarCurr: state_type] :
      ( v96218(VarCurr)
    <=> ( v90859(VarCurr)
        & v96219(VarCurr) ) ) ).

tff(writeUnaryOperator_4372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v96219(VarCurr)
    <=> v90968(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_518,axiom,
    ! [VarCurr: state_type] :
      ( v96216(VarCurr)
    <=> ( ( v90800(VarCurr,1)
        <=> $false )
        & ( v90800(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_58599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v95740(VarCurr,B)
      <=> v95742(VarCurr,B) ) ) ).

tff(addAssignment_58598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v95742(VarCurr,B)
      <=> v95744(VarCurr,B) ) ) ).

tff(addAssignment_58597,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,12)
    <=> v96178(VarCurr) ) ).

tff(addAssignment_58596,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,11)
    <=> v96143(VarCurr) ) ).

tff(addAssignment_58595,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,10)
    <=> v96108(VarCurr) ) ).

tff(addAssignment_58594,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,9)
    <=> v96073(VarCurr) ) ).

tff(addAssignment_58593,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,8)
    <=> v96038(VarCurr) ) ).

tff(addAssignment_58592,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,7)
    <=> v96003(VarCurr) ) ).

tff(addAssignment_58591,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,6)
    <=> v95968(VarCurr) ) ).

tff(addAssignment_58590,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,5)
    <=> v95933(VarCurr) ) ).

tff(addAssignment_58589,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,4)
    <=> v95898(VarCurr) ) ).

tff(addAssignment_58588,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,3)
    <=> v95863(VarCurr) ) ).

tff(addAssignment_58587,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,2)
    <=> v95828(VarCurr) ) ).

tff(addAssignment_58586,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,1)
    <=> v95791(VarCurr) ) ).

tff(addAssignment_58585,axiom,
    ! [VarCurr: state_type] :
      ( v95744(VarCurr,0)
    <=> v95746(VarCurr) ) ).

tff(addAssignment_58584,axiom,
    ! [VarCurr: state_type] :
      ( v96178(VarCurr)
    <=> v96180(VarCurr) ) ).

tff(addAssignment_58583,axiom,
    ! [VarCurr: state_type] :
      ( v96180(VarCurr)
    <=> v96182(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_517,axiom,
    ! [VarCurr: state_type] :
      ( v96182(VarCurr)
    <=> ( ( v96184(VarCurr,11)
        <=> v96188(VarCurr,11) )
        & ( v96184(VarCurr,10)
        <=> v96188(VarCurr,10) )
        & ( v96184(VarCurr,9)
        <=> v96188(VarCurr,9) )
        & ( v96184(VarCurr,8)
        <=> v96188(VarCurr,8) )
        & ( v96184(VarCurr,7)
        <=> v96188(VarCurr,7) )
        & ( v96184(VarCurr,6)
        <=> v96188(VarCurr,6) )
        & ( v96184(VarCurr,5)
        <=> v96188(VarCurr,5) )
        & ( v96184(VarCurr,4)
        <=> v96188(VarCurr,4) )
        & ( v96184(VarCurr,3)
        <=> v96188(VarCurr,3) )
        & ( v96184(VarCurr,2)
        <=> v96188(VarCurr,2) )
        & ( v96184(VarCurr,1)
        <=> v96188(VarCurr,1) )
        & ( v96184(VarCurr,0)
        <=> v96188(VarCurr,0) ) ) ) ).

tff(addAssignment_58582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96188(VarCurr,B)
      <=> v96190(VarCurr,B) ) ) ).

tff(addAssignment_58581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96190(VarCurr,B)
      <=> v96210(VarCurr,B) ) ) ).

tff(addAssignment_58580,axiom,
    ! [VarCurr: state_type] :
      ( ( v96190(VarCurr,11)
      <=> v96208(VarCurr,5) )
      & ( v96190(VarCurr,10)
      <=> v96208(VarCurr,4) )
      & ( v96190(VarCurr,9)
      <=> v96208(VarCurr,3) )
      & ( v96190(VarCurr,8)
      <=> v96208(VarCurr,2) )
      & ( v96190(VarCurr,7)
      <=> v96208(VarCurr,1) )
      & ( v96190(VarCurr,6)
      <=> v96208(VarCurr,0) ) ) ).

tff(addAssignment_58579,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,0)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58578,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,1)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58577,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,2)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58576,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,3)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58575,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,4)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58574,axiom,
    ! [VarCurr: state_type] :
      ( v96210(VarCurr,5)
    <=> v96211(VarCurr) ) ).

tff(addAssignment_58573,axiom,
    ! [VarCurr: state_type] :
      ( v96211(VarCurr)
    <=> v96192(VarCurr,0) ) ).

tff(addAssignment_58572,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,0)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58571,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,1)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58570,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,2)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58569,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,3)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58568,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,4)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58567,axiom,
    ! [VarCurr: state_type] :
      ( v96208(VarCurr,5)
    <=> v96209(VarCurr) ) ).

tff(addAssignment_58566,axiom,
    ! [VarCurr: state_type] :
      ( v96209(VarCurr)
    <=> v96192(VarCurr,1) ) ).

tff(addAssignment_58565,axiom,
    ! [VarCurr: state_type] :
      ( v96192(VarCurr,0)
    <=> v96194(VarCurr,0) ) ).

tff(addAssignment_58564,axiom,
    ! [VarCurr: state_type] :
      ( v96194(VarCurr,0)
    <=> v96196(VarCurr,0) ) ).

tff(addAssignment_58563,axiom,
    ! [VarCurr: state_type] :
      ( v96196(VarCurr,0)
    <=> v96206(VarCurr,0) ) ).

tff(addAssignment_58562,axiom,
    ! [VarCurr: state_type] :
      ( v96198(VarCurr,0)
    <=> v96200(VarCurr,0) ) ).

tff(addAssignment_58561,axiom,
    ! [VarCurr: state_type] :
      ( v96200(VarCurr,0)
    <=> v96202(VarCurr,0) ) ).

tff(addAssignment_58560,axiom,
    ! [VarCurr: state_type] :
      ( v96202(VarCurr,0)
    <=> v96205(VarCurr,0) ) ).

tff(addAssignment_58559,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,0)
    <=> v95218(VarCurr,0) ) ).

tff(addAssignment_58558,axiom,
    ! [VarCurr: state_type] :
      ( v96192(VarCurr,1)
    <=> v96194(VarCurr,1) ) ).

tff(addAssignment_58557,axiom,
    ! [VarCurr: state_type] :
      ( v96194(VarCurr,1)
    <=> v96196(VarCurr,1) ) ).

tff(addAssignment_58556,axiom,
    ! [VarCurr: state_type] :
      ( v96196(VarCurr,1)
    <=> v96206(VarCurr,1) ) ).

tff(writeUnaryOperator_4371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96206(VarCurr,B)
      <=> ~ v96198(VarCurr,B) ) ) ).

tff(addAssignment_58555,axiom,
    ! [VarCurr: state_type] :
      ( v96198(VarCurr,1)
    <=> v96200(VarCurr,1) ) ).

tff(addAssignment_58554,axiom,
    ! [VarCurr: state_type] :
      ( v96200(VarCurr,1)
    <=> v96202(VarCurr,1) ) ).

tff(addAssignment_58553,axiom,
    ! [VarCurr: state_type] :
      ( v96202(VarCurr,1)
    <=> v96205(VarCurr,1) ) ).

tff(addAssignment_58552,axiom,
    ! [VarCurr: state_type] :
      ( v96205(VarCurr,0)
    <=> v95817(VarCurr,0) ) ).

tff(addAssignment_58551,axiom,
    ! [VarCurr: state_type] :
      ( v96205(VarCurr,1)
    <=> v96204(VarCurr) ) ).

tff(addAssignment_58550,axiom,
    ! [VarCurr: state_type] :
      ( v96204(VarCurr)
    <=> v95697(VarCurr) ) ).

tff(addAssignment_58549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96184(VarCurr,B)
      <=> v96186(VarCurr,B) ) ) ).

tff(addAssignment_58548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96186(VarCurr,B)
      <=> v28105(VarCurr,B) ) ) ).

tff(addAssignment_58547,axiom,
    ! [VarCurr: state_type] :
      ( v96143(VarCurr)
    <=> v96145(VarCurr) ) ).

tff(addAssignment_58546,axiom,
    ! [VarCurr: state_type] :
      ( v96145(VarCurr)
    <=> v96147(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_516,axiom,
    ! [VarCurr: state_type] :
      ( v96147(VarCurr)
    <=> ( ( v96149(VarCurr,11)
        <=> v96153(VarCurr,11) )
        & ( v96149(VarCurr,10)
        <=> v96153(VarCurr,10) )
        & ( v96149(VarCurr,9)
        <=> v96153(VarCurr,9) )
        & ( v96149(VarCurr,8)
        <=> v96153(VarCurr,8) )
        & ( v96149(VarCurr,7)
        <=> v96153(VarCurr,7) )
        & ( v96149(VarCurr,6)
        <=> v96153(VarCurr,6) )
        & ( v96149(VarCurr,5)
        <=> v96153(VarCurr,5) )
        & ( v96149(VarCurr,4)
        <=> v96153(VarCurr,4) )
        & ( v96149(VarCurr,3)
        <=> v96153(VarCurr,3) )
        & ( v96149(VarCurr,2)
        <=> v96153(VarCurr,2) )
        & ( v96149(VarCurr,1)
        <=> v96153(VarCurr,1) )
        & ( v96149(VarCurr,0)
        <=> v96153(VarCurr,0) ) ) ) ).

tff(addAssignment_58545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96153(VarCurr,B)
      <=> v96155(VarCurr,B) ) ) ).

tff(addAssignment_58544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96155(VarCurr,B)
      <=> v96174(VarCurr,B) ) ) ).

tff(addAssignment_58543,axiom,
    ! [VarCurr: state_type] :
      ( ( v96155(VarCurr,11)
      <=> v96172(VarCurr,5) )
      & ( v96155(VarCurr,10)
      <=> v96172(VarCurr,4) )
      & ( v96155(VarCurr,9)
      <=> v96172(VarCurr,3) )
      & ( v96155(VarCurr,8)
      <=> v96172(VarCurr,2) )
      & ( v96155(VarCurr,7)
      <=> v96172(VarCurr,1) )
      & ( v96155(VarCurr,6)
      <=> v96172(VarCurr,0) ) ) ).

tff(addAssignment_58542,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,0)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58541,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,1)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58540,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,2)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58539,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,3)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58538,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,4)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58537,axiom,
    ! [VarCurr: state_type] :
      ( v96174(VarCurr,5)
    <=> v96175(VarCurr) ) ).

tff(addAssignment_58536,axiom,
    ! [VarCurr: state_type] :
      ( v96175(VarCurr)
    <=> v96157(VarCurr,0) ) ).

tff(addAssignment_58535,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,0)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58534,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,1)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58533,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,2)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58532,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,3)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58531,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,4)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58530,axiom,
    ! [VarCurr: state_type] :
      ( v96172(VarCurr,5)
    <=> v96173(VarCurr) ) ).

tff(addAssignment_58529,axiom,
    ! [VarCurr: state_type] :
      ( v96173(VarCurr)
    <=> v96157(VarCurr,1) ) ).

tff(addAssignment_58528,axiom,
    ! [VarCurr: state_type] :
      ( v96157(VarCurr,0)
    <=> v96159(VarCurr,0) ) ).

tff(addAssignment_58527,axiom,
    ! [VarCurr: state_type] :
      ( v96159(VarCurr,0)
    <=> v96161(VarCurr,0) ) ).

tff(addAssignment_58526,axiom,
    ! [VarCurr: state_type] :
      ( v96161(VarCurr,0)
    <=> v96170(VarCurr,0) ) ).

tff(addAssignment_58525,axiom,
    ! [VarCurr: state_type] :
      ( v96163(VarCurr,0)
    <=> v96165(VarCurr,0) ) ).

tff(addAssignment_58524,axiom,
    ! [VarCurr: state_type] :
      ( v96165(VarCurr,0)
    <=> v96167(VarCurr,0) ) ).

tff(addAssignment_58523,axiom,
    ! [VarCurr: state_type] :
      ( v96167(VarCurr,0)
    <=> v96168(VarCurr,0) ) ).

tff(addAssignment_58522,axiom,
    ! [VarCurr: state_type] :
      ( v96157(VarCurr,1)
    <=> v96159(VarCurr,1) ) ).

tff(addAssignment_58521,axiom,
    ! [VarCurr: state_type] :
      ( v96159(VarCurr,1)
    <=> v96161(VarCurr,1) ) ).

tff(addAssignment_58520,axiom,
    ! [VarCurr: state_type] :
      ( v96161(VarCurr,1)
    <=> v96170(VarCurr,1) ) ).

tff(writeUnaryOperator_4370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96170(VarCurr,B)
      <=> ~ v96163(VarCurr,B) ) ) ).

tff(addAssignment_58519,axiom,
    ! [VarCurr: state_type] :
      ( v96163(VarCurr,1)
    <=> v96165(VarCurr,1) ) ).

tff(addAssignment_58518,axiom,
    ! [VarCurr: state_type] :
      ( v96165(VarCurr,1)
    <=> v96167(VarCurr,1) ) ).

tff(addAssignment_58517,axiom,
    ! [VarCurr: state_type] :
      ( v96167(VarCurr,1)
    <=> v96168(VarCurr,1) ) ).

tff(addAssignment_58516,axiom,
    ! [VarCurr: state_type] :
      ( v96168(VarCurr,0)
    <=> v96169(VarCurr) ) ).

tff(addAssignment_58515,axiom,
    ! [VarCurr: state_type] :
      ( v96168(VarCurr,1)
    <=> v96169(VarCurr) ) ).

tff(addAssignment_58514,axiom,
    ! [VarCurr: state_type] :
      ( v96169(VarCurr)
    <=> v95817(VarCurr,11) ) ).

tff(addAssignment_58513,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,11)
    <=> v95218(VarCurr,11) ) ).

tff(addAssignment_58512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96149(VarCurr,B)
      <=> v96151(VarCurr,B) ) ) ).

tff(addAssignment_58511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96151(VarCurr,B)
      <=> v26555(VarCurr,B) ) ) ).

tff(addAssignment_58510,axiom,
    ! [VarCurr: state_type] :
      ( v96108(VarCurr)
    <=> v96110(VarCurr) ) ).

tff(addAssignment_58509,axiom,
    ! [VarCurr: state_type] :
      ( v96110(VarCurr)
    <=> v96112(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_515,axiom,
    ! [VarCurr: state_type] :
      ( v96112(VarCurr)
    <=> ( ( v96114(VarCurr,11)
        <=> v96118(VarCurr,11) )
        & ( v96114(VarCurr,10)
        <=> v96118(VarCurr,10) )
        & ( v96114(VarCurr,9)
        <=> v96118(VarCurr,9) )
        & ( v96114(VarCurr,8)
        <=> v96118(VarCurr,8) )
        & ( v96114(VarCurr,7)
        <=> v96118(VarCurr,7) )
        & ( v96114(VarCurr,6)
        <=> v96118(VarCurr,6) )
        & ( v96114(VarCurr,5)
        <=> v96118(VarCurr,5) )
        & ( v96114(VarCurr,4)
        <=> v96118(VarCurr,4) )
        & ( v96114(VarCurr,3)
        <=> v96118(VarCurr,3) )
        & ( v96114(VarCurr,2)
        <=> v96118(VarCurr,2) )
        & ( v96114(VarCurr,1)
        <=> v96118(VarCurr,1) )
        & ( v96114(VarCurr,0)
        <=> v96118(VarCurr,0) ) ) ) ).

tff(addAssignment_58508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96118(VarCurr,B)
      <=> v96120(VarCurr,B) ) ) ).

tff(addAssignment_58507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96120(VarCurr,B)
      <=> v96139(VarCurr,B) ) ) ).

tff(addAssignment_58506,axiom,
    ! [VarCurr: state_type] :
      ( ( v96120(VarCurr,11)
      <=> v96137(VarCurr,5) )
      & ( v96120(VarCurr,10)
      <=> v96137(VarCurr,4) )
      & ( v96120(VarCurr,9)
      <=> v96137(VarCurr,3) )
      & ( v96120(VarCurr,8)
      <=> v96137(VarCurr,2) )
      & ( v96120(VarCurr,7)
      <=> v96137(VarCurr,1) )
      & ( v96120(VarCurr,6)
      <=> v96137(VarCurr,0) ) ) ).

tff(addAssignment_58505,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,0)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58504,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,1)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58503,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,2)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58502,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,3)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58501,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,4)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58500,axiom,
    ! [VarCurr: state_type] :
      ( v96139(VarCurr,5)
    <=> v96140(VarCurr) ) ).

tff(addAssignment_58499,axiom,
    ! [VarCurr: state_type] :
      ( v96140(VarCurr)
    <=> v96122(VarCurr,0) ) ).

tff(addAssignment_58498,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,0)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58497,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,1)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58496,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,2)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58495,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,3)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58494,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,4)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58493,axiom,
    ! [VarCurr: state_type] :
      ( v96137(VarCurr,5)
    <=> v96138(VarCurr) ) ).

tff(addAssignment_58492,axiom,
    ! [VarCurr: state_type] :
      ( v96138(VarCurr)
    <=> v96122(VarCurr,1) ) ).

tff(addAssignment_58491,axiom,
    ! [VarCurr: state_type] :
      ( v96122(VarCurr,0)
    <=> v96124(VarCurr,0) ) ).

tff(addAssignment_58490,axiom,
    ! [VarCurr: state_type] :
      ( v96124(VarCurr,0)
    <=> v96126(VarCurr,0) ) ).

tff(addAssignment_58489,axiom,
    ! [VarCurr: state_type] :
      ( v96126(VarCurr,0)
    <=> v96135(VarCurr,0) ) ).

tff(addAssignment_58488,axiom,
    ! [VarCurr: state_type] :
      ( v96128(VarCurr,0)
    <=> v96130(VarCurr,0) ) ).

tff(addAssignment_58487,axiom,
    ! [VarCurr: state_type] :
      ( v96130(VarCurr,0)
    <=> v96132(VarCurr,0) ) ).

tff(addAssignment_58486,axiom,
    ! [VarCurr: state_type] :
      ( v96132(VarCurr,0)
    <=> v96133(VarCurr,0) ) ).

tff(addAssignment_58485,axiom,
    ! [VarCurr: state_type] :
      ( v96122(VarCurr,1)
    <=> v96124(VarCurr,1) ) ).

tff(addAssignment_58484,axiom,
    ! [VarCurr: state_type] :
      ( v96124(VarCurr,1)
    <=> v96126(VarCurr,1) ) ).

tff(addAssignment_58483,axiom,
    ! [VarCurr: state_type] :
      ( v96126(VarCurr,1)
    <=> v96135(VarCurr,1) ) ).

tff(writeUnaryOperator_4369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96135(VarCurr,B)
      <=> ~ v96128(VarCurr,B) ) ) ).

tff(addAssignment_58482,axiom,
    ! [VarCurr: state_type] :
      ( v96128(VarCurr,1)
    <=> v96130(VarCurr,1) ) ).

tff(addAssignment_58481,axiom,
    ! [VarCurr: state_type] :
      ( v96130(VarCurr,1)
    <=> v96132(VarCurr,1) ) ).

tff(addAssignment_58480,axiom,
    ! [VarCurr: state_type] :
      ( v96132(VarCurr,1)
    <=> v96133(VarCurr,1) ) ).

tff(addAssignment_58479,axiom,
    ! [VarCurr: state_type] :
      ( v96133(VarCurr,0)
    <=> v96134(VarCurr) ) ).

tff(addAssignment_58478,axiom,
    ! [VarCurr: state_type] :
      ( v96133(VarCurr,1)
    <=> v96134(VarCurr) ) ).

tff(addAssignment_58477,axiom,
    ! [VarCurr: state_type] :
      ( v96134(VarCurr)
    <=> v95817(VarCurr,10) ) ).

tff(addAssignment_58476,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,10)
    <=> v95218(VarCurr,10) ) ).

tff(addAssignment_58475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96114(VarCurr,B)
      <=> v96116(VarCurr,B) ) ) ).

tff(addAssignment_58474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96116(VarCurr,B)
      <=> v25005(VarCurr,B) ) ) ).

tff(addAssignment_58473,axiom,
    ! [VarCurr: state_type] :
      ( v96073(VarCurr)
    <=> v96075(VarCurr) ) ).

tff(addAssignment_58472,axiom,
    ! [VarCurr: state_type] :
      ( v96075(VarCurr)
    <=> v96077(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_514,axiom,
    ! [VarCurr: state_type] :
      ( v96077(VarCurr)
    <=> ( ( v96079(VarCurr,11)
        <=> v96083(VarCurr,11) )
        & ( v96079(VarCurr,10)
        <=> v96083(VarCurr,10) )
        & ( v96079(VarCurr,9)
        <=> v96083(VarCurr,9) )
        & ( v96079(VarCurr,8)
        <=> v96083(VarCurr,8) )
        & ( v96079(VarCurr,7)
        <=> v96083(VarCurr,7) )
        & ( v96079(VarCurr,6)
        <=> v96083(VarCurr,6) )
        & ( v96079(VarCurr,5)
        <=> v96083(VarCurr,5) )
        & ( v96079(VarCurr,4)
        <=> v96083(VarCurr,4) )
        & ( v96079(VarCurr,3)
        <=> v96083(VarCurr,3) )
        & ( v96079(VarCurr,2)
        <=> v96083(VarCurr,2) )
        & ( v96079(VarCurr,1)
        <=> v96083(VarCurr,1) )
        & ( v96079(VarCurr,0)
        <=> v96083(VarCurr,0) ) ) ) ).

tff(addAssignment_58471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96083(VarCurr,B)
      <=> v96085(VarCurr,B) ) ) ).

tff(addAssignment_58470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96085(VarCurr,B)
      <=> v96104(VarCurr,B) ) ) ).

tff(addAssignment_58469,axiom,
    ! [VarCurr: state_type] :
      ( ( v96085(VarCurr,11)
      <=> v96102(VarCurr,5) )
      & ( v96085(VarCurr,10)
      <=> v96102(VarCurr,4) )
      & ( v96085(VarCurr,9)
      <=> v96102(VarCurr,3) )
      & ( v96085(VarCurr,8)
      <=> v96102(VarCurr,2) )
      & ( v96085(VarCurr,7)
      <=> v96102(VarCurr,1) )
      & ( v96085(VarCurr,6)
      <=> v96102(VarCurr,0) ) ) ).

tff(addAssignment_58468,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,0)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58467,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,1)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58466,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,2)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58465,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,3)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58464,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,4)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58463,axiom,
    ! [VarCurr: state_type] :
      ( v96104(VarCurr,5)
    <=> v96105(VarCurr) ) ).

tff(addAssignment_58462,axiom,
    ! [VarCurr: state_type] :
      ( v96105(VarCurr)
    <=> v96087(VarCurr,0) ) ).

tff(addAssignment_58461,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,0)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58460,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,1)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58459,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,2)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58458,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,3)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58457,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,4)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58456,axiom,
    ! [VarCurr: state_type] :
      ( v96102(VarCurr,5)
    <=> v96103(VarCurr) ) ).

tff(addAssignment_58455,axiom,
    ! [VarCurr: state_type] :
      ( v96103(VarCurr)
    <=> v96087(VarCurr,1) ) ).

tff(addAssignment_58454,axiom,
    ! [VarCurr: state_type] :
      ( v96087(VarCurr,0)
    <=> v96089(VarCurr,0) ) ).

tff(addAssignment_58453,axiom,
    ! [VarCurr: state_type] :
      ( v96089(VarCurr,0)
    <=> v96091(VarCurr,0) ) ).

tff(addAssignment_58452,axiom,
    ! [VarCurr: state_type] :
      ( v96091(VarCurr,0)
    <=> v96100(VarCurr,0) ) ).

tff(addAssignment_58451,axiom,
    ! [VarCurr: state_type] :
      ( v96093(VarCurr,0)
    <=> v96095(VarCurr,0) ) ).

tff(addAssignment_58450,axiom,
    ! [VarCurr: state_type] :
      ( v96095(VarCurr,0)
    <=> v96097(VarCurr,0) ) ).

tff(addAssignment_58449,axiom,
    ! [VarCurr: state_type] :
      ( v96097(VarCurr,0)
    <=> v96098(VarCurr,0) ) ).

tff(addAssignment_58448,axiom,
    ! [VarCurr: state_type] :
      ( v96087(VarCurr,1)
    <=> v96089(VarCurr,1) ) ).

tff(addAssignment_58447,axiom,
    ! [VarCurr: state_type] :
      ( v96089(VarCurr,1)
    <=> v96091(VarCurr,1) ) ).

tff(addAssignment_58446,axiom,
    ! [VarCurr: state_type] :
      ( v96091(VarCurr,1)
    <=> v96100(VarCurr,1) ) ).

tff(writeUnaryOperator_4368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96100(VarCurr,B)
      <=> ~ v96093(VarCurr,B) ) ) ).

tff(addAssignment_58445,axiom,
    ! [VarCurr: state_type] :
      ( v96093(VarCurr,1)
    <=> v96095(VarCurr,1) ) ).

tff(addAssignment_58444,axiom,
    ! [VarCurr: state_type] :
      ( v96095(VarCurr,1)
    <=> v96097(VarCurr,1) ) ).

tff(addAssignment_58443,axiom,
    ! [VarCurr: state_type] :
      ( v96097(VarCurr,1)
    <=> v96098(VarCurr,1) ) ).

tff(addAssignment_58442,axiom,
    ! [VarCurr: state_type] :
      ( v96098(VarCurr,0)
    <=> v96099(VarCurr) ) ).

tff(addAssignment_58441,axiom,
    ! [VarCurr: state_type] :
      ( v96098(VarCurr,1)
    <=> v96099(VarCurr) ) ).

tff(addAssignment_58440,axiom,
    ! [VarCurr: state_type] :
      ( v96099(VarCurr)
    <=> v95817(VarCurr,9) ) ).

tff(addAssignment_58439,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,9)
    <=> v95218(VarCurr,9) ) ).

tff(addAssignment_58438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96079(VarCurr,B)
      <=> v96081(VarCurr,B) ) ) ).

tff(addAssignment_58437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96081(VarCurr,B)
      <=> v23455(VarCurr,B) ) ) ).

tff(addAssignment_58436,axiom,
    ! [VarCurr: state_type] :
      ( v96038(VarCurr)
    <=> v96040(VarCurr) ) ).

tff(addAssignment_58435,axiom,
    ! [VarCurr: state_type] :
      ( v96040(VarCurr)
    <=> v96042(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_513,axiom,
    ! [VarCurr: state_type] :
      ( v96042(VarCurr)
    <=> ( ( v96044(VarCurr,11)
        <=> v96048(VarCurr,11) )
        & ( v96044(VarCurr,10)
        <=> v96048(VarCurr,10) )
        & ( v96044(VarCurr,9)
        <=> v96048(VarCurr,9) )
        & ( v96044(VarCurr,8)
        <=> v96048(VarCurr,8) )
        & ( v96044(VarCurr,7)
        <=> v96048(VarCurr,7) )
        & ( v96044(VarCurr,6)
        <=> v96048(VarCurr,6) )
        & ( v96044(VarCurr,5)
        <=> v96048(VarCurr,5) )
        & ( v96044(VarCurr,4)
        <=> v96048(VarCurr,4) )
        & ( v96044(VarCurr,3)
        <=> v96048(VarCurr,3) )
        & ( v96044(VarCurr,2)
        <=> v96048(VarCurr,2) )
        & ( v96044(VarCurr,1)
        <=> v96048(VarCurr,1) )
        & ( v96044(VarCurr,0)
        <=> v96048(VarCurr,0) ) ) ) ).

tff(addAssignment_58434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96048(VarCurr,B)
      <=> v96050(VarCurr,B) ) ) ).

tff(addAssignment_58433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96050(VarCurr,B)
      <=> v96069(VarCurr,B) ) ) ).

tff(addAssignment_58432,axiom,
    ! [VarCurr: state_type] :
      ( ( v96050(VarCurr,11)
      <=> v96067(VarCurr,5) )
      & ( v96050(VarCurr,10)
      <=> v96067(VarCurr,4) )
      & ( v96050(VarCurr,9)
      <=> v96067(VarCurr,3) )
      & ( v96050(VarCurr,8)
      <=> v96067(VarCurr,2) )
      & ( v96050(VarCurr,7)
      <=> v96067(VarCurr,1) )
      & ( v96050(VarCurr,6)
      <=> v96067(VarCurr,0) ) ) ).

tff(addAssignment_58431,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,0)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58430,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,1)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58429,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,2)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58428,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,3)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58427,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,4)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58426,axiom,
    ! [VarCurr: state_type] :
      ( v96069(VarCurr,5)
    <=> v96070(VarCurr) ) ).

tff(addAssignment_58425,axiom,
    ! [VarCurr: state_type] :
      ( v96070(VarCurr)
    <=> v96052(VarCurr,0) ) ).

tff(addAssignment_58424,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,0)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58423,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,1)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58422,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,2)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58421,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,3)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58420,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,4)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58419,axiom,
    ! [VarCurr: state_type] :
      ( v96067(VarCurr,5)
    <=> v96068(VarCurr) ) ).

tff(addAssignment_58418,axiom,
    ! [VarCurr: state_type] :
      ( v96068(VarCurr)
    <=> v96052(VarCurr,1) ) ).

tff(addAssignment_58417,axiom,
    ! [VarCurr: state_type] :
      ( v96052(VarCurr,0)
    <=> v96054(VarCurr,0) ) ).

tff(addAssignment_58416,axiom,
    ! [VarCurr: state_type] :
      ( v96054(VarCurr,0)
    <=> v96056(VarCurr,0) ) ).

tff(addAssignment_58415,axiom,
    ! [VarCurr: state_type] :
      ( v96056(VarCurr,0)
    <=> v96065(VarCurr,0) ) ).

tff(addAssignment_58414,axiom,
    ! [VarCurr: state_type] :
      ( v96058(VarCurr,0)
    <=> v96060(VarCurr,0) ) ).

tff(addAssignment_58413,axiom,
    ! [VarCurr: state_type] :
      ( v96060(VarCurr,0)
    <=> v96062(VarCurr,0) ) ).

tff(addAssignment_58412,axiom,
    ! [VarCurr: state_type] :
      ( v96062(VarCurr,0)
    <=> v96063(VarCurr,0) ) ).

tff(addAssignment_58411,axiom,
    ! [VarCurr: state_type] :
      ( v96052(VarCurr,1)
    <=> v96054(VarCurr,1) ) ).

tff(addAssignment_58410,axiom,
    ! [VarCurr: state_type] :
      ( v96054(VarCurr,1)
    <=> v96056(VarCurr,1) ) ).

tff(addAssignment_58409,axiom,
    ! [VarCurr: state_type] :
      ( v96056(VarCurr,1)
    <=> v96065(VarCurr,1) ) ).

tff(writeUnaryOperator_4367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96065(VarCurr,B)
      <=> ~ v96058(VarCurr,B) ) ) ).

tff(addAssignment_58408,axiom,
    ! [VarCurr: state_type] :
      ( v96058(VarCurr,1)
    <=> v96060(VarCurr,1) ) ).

tff(addAssignment_58407,axiom,
    ! [VarCurr: state_type] :
      ( v96060(VarCurr,1)
    <=> v96062(VarCurr,1) ) ).

tff(addAssignment_58406,axiom,
    ! [VarCurr: state_type] :
      ( v96062(VarCurr,1)
    <=> v96063(VarCurr,1) ) ).

tff(addAssignment_58405,axiom,
    ! [VarCurr: state_type] :
      ( v96063(VarCurr,0)
    <=> v96064(VarCurr) ) ).

tff(addAssignment_58404,axiom,
    ! [VarCurr: state_type] :
      ( v96063(VarCurr,1)
    <=> v96064(VarCurr) ) ).

tff(addAssignment_58403,axiom,
    ! [VarCurr: state_type] :
      ( v96064(VarCurr)
    <=> v95817(VarCurr,8) ) ).

tff(addAssignment_58402,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,8)
    <=> v95218(VarCurr,8) ) ).

tff(addAssignment_58401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96044(VarCurr,B)
      <=> v96046(VarCurr,B) ) ) ).

tff(addAssignment_58400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96046(VarCurr,B)
      <=> v21905(VarCurr,B) ) ) ).

tff(addAssignment_58399,axiom,
    ! [VarCurr: state_type] :
      ( v96003(VarCurr)
    <=> v96005(VarCurr) ) ).

tff(addAssignment_58398,axiom,
    ! [VarCurr: state_type] :
      ( v96005(VarCurr)
    <=> v96007(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_512,axiom,
    ! [VarCurr: state_type] :
      ( v96007(VarCurr)
    <=> ( ( v96009(VarCurr,11)
        <=> v96013(VarCurr,11) )
        & ( v96009(VarCurr,10)
        <=> v96013(VarCurr,10) )
        & ( v96009(VarCurr,9)
        <=> v96013(VarCurr,9) )
        & ( v96009(VarCurr,8)
        <=> v96013(VarCurr,8) )
        & ( v96009(VarCurr,7)
        <=> v96013(VarCurr,7) )
        & ( v96009(VarCurr,6)
        <=> v96013(VarCurr,6) )
        & ( v96009(VarCurr,5)
        <=> v96013(VarCurr,5) )
        & ( v96009(VarCurr,4)
        <=> v96013(VarCurr,4) )
        & ( v96009(VarCurr,3)
        <=> v96013(VarCurr,3) )
        & ( v96009(VarCurr,2)
        <=> v96013(VarCurr,2) )
        & ( v96009(VarCurr,1)
        <=> v96013(VarCurr,1) )
        & ( v96009(VarCurr,0)
        <=> v96013(VarCurr,0) ) ) ) ).

tff(addAssignment_58397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96013(VarCurr,B)
      <=> v96015(VarCurr,B) ) ) ).

tff(addAssignment_58396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v96015(VarCurr,B)
      <=> v96034(VarCurr,B) ) ) ).

tff(addAssignment_58395,axiom,
    ! [VarCurr: state_type] :
      ( ( v96015(VarCurr,11)
      <=> v96032(VarCurr,5) )
      & ( v96015(VarCurr,10)
      <=> v96032(VarCurr,4) )
      & ( v96015(VarCurr,9)
      <=> v96032(VarCurr,3) )
      & ( v96015(VarCurr,8)
      <=> v96032(VarCurr,2) )
      & ( v96015(VarCurr,7)
      <=> v96032(VarCurr,1) )
      & ( v96015(VarCurr,6)
      <=> v96032(VarCurr,0) ) ) ).

tff(addAssignment_58394,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,0)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58393,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,1)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58392,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,2)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58391,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,3)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58390,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,4)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58389,axiom,
    ! [VarCurr: state_type] :
      ( v96034(VarCurr,5)
    <=> v96035(VarCurr) ) ).

tff(addAssignment_58388,axiom,
    ! [VarCurr: state_type] :
      ( v96035(VarCurr)
    <=> v96017(VarCurr,0) ) ).

tff(addAssignment_58387,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,0)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58386,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,1)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58385,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,2)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58384,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,3)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58383,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,4)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58382,axiom,
    ! [VarCurr: state_type] :
      ( v96032(VarCurr,5)
    <=> v96033(VarCurr) ) ).

tff(addAssignment_58381,axiom,
    ! [VarCurr: state_type] :
      ( v96033(VarCurr)
    <=> v96017(VarCurr,1) ) ).

tff(addAssignment_58380,axiom,
    ! [VarCurr: state_type] :
      ( v96017(VarCurr,0)
    <=> v96019(VarCurr,0) ) ).

tff(addAssignment_58379,axiom,
    ! [VarCurr: state_type] :
      ( v96019(VarCurr,0)
    <=> v96021(VarCurr,0) ) ).

tff(addAssignment_58378,axiom,
    ! [VarCurr: state_type] :
      ( v96021(VarCurr,0)
    <=> v96030(VarCurr,0) ) ).

tff(addAssignment_58377,axiom,
    ! [VarCurr: state_type] :
      ( v96023(VarCurr,0)
    <=> v96025(VarCurr,0) ) ).

tff(addAssignment_58376,axiom,
    ! [VarCurr: state_type] :
      ( v96025(VarCurr,0)
    <=> v96027(VarCurr,0) ) ).

tff(addAssignment_58375,axiom,
    ! [VarCurr: state_type] :
      ( v96027(VarCurr,0)
    <=> v96028(VarCurr,0) ) ).

tff(addAssignment_58374,axiom,
    ! [VarCurr: state_type] :
      ( v96017(VarCurr,1)
    <=> v96019(VarCurr,1) ) ).

tff(addAssignment_58373,axiom,
    ! [VarCurr: state_type] :
      ( v96019(VarCurr,1)
    <=> v96021(VarCurr,1) ) ).

tff(addAssignment_58372,axiom,
    ! [VarCurr: state_type] :
      ( v96021(VarCurr,1)
    <=> v96030(VarCurr,1) ) ).

tff(writeUnaryOperator_4366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v96030(VarCurr,B)
      <=> ~ v96023(VarCurr,B) ) ) ).

tff(addAssignment_58371,axiom,
    ! [VarCurr: state_type] :
      ( v96023(VarCurr,1)
    <=> v96025(VarCurr,1) ) ).

tff(addAssignment_58370,axiom,
    ! [VarCurr: state_type] :
      ( v96025(VarCurr,1)
    <=> v96027(VarCurr,1) ) ).

tff(addAssignment_58369,axiom,
    ! [VarCurr: state_type] :
      ( v96027(VarCurr,1)
    <=> v96028(VarCurr,1) ) ).

tff(addAssignment_58368,axiom,
    ! [VarCurr: state_type] :
      ( v96028(VarCurr,0)
    <=> v96029(VarCurr) ) ).

tff(addAssignment_58367,axiom,
    ! [VarCurr: state_type] :
      ( v96028(VarCurr,1)
    <=> v96029(VarCurr) ) ).

tff(addAssignment_58366,axiom,
    ! [VarCurr: state_type] :
      ( v96029(VarCurr)
    <=> v95817(VarCurr,7) ) ).

tff(addAssignment_58365,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,7)
    <=> v95218(VarCurr,7) ) ).

tff(addAssignment_58364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96009(VarCurr,B)
      <=> v96011(VarCurr,B) ) ) ).

tff(addAssignment_58363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v96011(VarCurr,B)
      <=> v20355(VarCurr,B) ) ) ).

tff(addAssignment_58362,axiom,
    ! [VarCurr: state_type] :
      ( v95968(VarCurr)
    <=> v95970(VarCurr) ) ).

tff(addAssignment_58361,axiom,
    ! [VarCurr: state_type] :
      ( v95970(VarCurr)
    <=> v95972(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_511,axiom,
    ! [VarCurr: state_type] :
      ( v95972(VarCurr)
    <=> ( ( v95974(VarCurr,11)
        <=> v95978(VarCurr,11) )
        & ( v95974(VarCurr,10)
        <=> v95978(VarCurr,10) )
        & ( v95974(VarCurr,9)
        <=> v95978(VarCurr,9) )
        & ( v95974(VarCurr,8)
        <=> v95978(VarCurr,8) )
        & ( v95974(VarCurr,7)
        <=> v95978(VarCurr,7) )
        & ( v95974(VarCurr,6)
        <=> v95978(VarCurr,6) )
        & ( v95974(VarCurr,5)
        <=> v95978(VarCurr,5) )
        & ( v95974(VarCurr,4)
        <=> v95978(VarCurr,4) )
        & ( v95974(VarCurr,3)
        <=> v95978(VarCurr,3) )
        & ( v95974(VarCurr,2)
        <=> v95978(VarCurr,2) )
        & ( v95974(VarCurr,1)
        <=> v95978(VarCurr,1) )
        & ( v95974(VarCurr,0)
        <=> v95978(VarCurr,0) ) ) ) ).

tff(addAssignment_58360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95978(VarCurr,B)
      <=> v95980(VarCurr,B) ) ) ).

tff(addAssignment_58359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95980(VarCurr,B)
      <=> v95999(VarCurr,B) ) ) ).

tff(addAssignment_58358,axiom,
    ! [VarCurr: state_type] :
      ( ( v95980(VarCurr,11)
      <=> v95997(VarCurr,5) )
      & ( v95980(VarCurr,10)
      <=> v95997(VarCurr,4) )
      & ( v95980(VarCurr,9)
      <=> v95997(VarCurr,3) )
      & ( v95980(VarCurr,8)
      <=> v95997(VarCurr,2) )
      & ( v95980(VarCurr,7)
      <=> v95997(VarCurr,1) )
      & ( v95980(VarCurr,6)
      <=> v95997(VarCurr,0) ) ) ).

tff(addAssignment_58357,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,0)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58356,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,1)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58355,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,2)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58354,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,3)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58353,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,4)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58352,axiom,
    ! [VarCurr: state_type] :
      ( v95999(VarCurr,5)
    <=> v96000(VarCurr) ) ).

tff(addAssignment_58351,axiom,
    ! [VarCurr: state_type] :
      ( v96000(VarCurr)
    <=> v95982(VarCurr,0) ) ).

tff(addAssignment_58350,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,0)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58349,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,1)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58348,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,2)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58347,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,3)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58346,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,4)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58345,axiom,
    ! [VarCurr: state_type] :
      ( v95997(VarCurr,5)
    <=> v95998(VarCurr) ) ).

tff(addAssignment_58344,axiom,
    ! [VarCurr: state_type] :
      ( v95998(VarCurr)
    <=> v95982(VarCurr,1) ) ).

tff(addAssignment_58343,axiom,
    ! [VarCurr: state_type] :
      ( v95982(VarCurr,0)
    <=> v95984(VarCurr,0) ) ).

tff(addAssignment_58342,axiom,
    ! [VarCurr: state_type] :
      ( v95984(VarCurr,0)
    <=> v95986(VarCurr,0) ) ).

tff(addAssignment_58341,axiom,
    ! [VarCurr: state_type] :
      ( v95986(VarCurr,0)
    <=> v95995(VarCurr,0) ) ).

tff(addAssignment_58340,axiom,
    ! [VarCurr: state_type] :
      ( v95988(VarCurr,0)
    <=> v95990(VarCurr,0) ) ).

tff(addAssignment_58339,axiom,
    ! [VarCurr: state_type] :
      ( v95990(VarCurr,0)
    <=> v95992(VarCurr,0) ) ).

tff(addAssignment_58338,axiom,
    ! [VarCurr: state_type] :
      ( v95992(VarCurr,0)
    <=> v95993(VarCurr,0) ) ).

tff(addAssignment_58337,axiom,
    ! [VarCurr: state_type] :
      ( v95982(VarCurr,1)
    <=> v95984(VarCurr,1) ) ).

tff(addAssignment_58336,axiom,
    ! [VarCurr: state_type] :
      ( v95984(VarCurr,1)
    <=> v95986(VarCurr,1) ) ).

tff(addAssignment_58335,axiom,
    ! [VarCurr: state_type] :
      ( v95986(VarCurr,1)
    <=> v95995(VarCurr,1) ) ).

tff(writeUnaryOperator_4365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95995(VarCurr,B)
      <=> ~ v95988(VarCurr,B) ) ) ).

tff(addAssignment_58334,axiom,
    ! [VarCurr: state_type] :
      ( v95988(VarCurr,1)
    <=> v95990(VarCurr,1) ) ).

tff(addAssignment_58333,axiom,
    ! [VarCurr: state_type] :
      ( v95990(VarCurr,1)
    <=> v95992(VarCurr,1) ) ).

tff(addAssignment_58332,axiom,
    ! [VarCurr: state_type] :
      ( v95992(VarCurr,1)
    <=> v95993(VarCurr,1) ) ).

tff(addAssignment_58331,axiom,
    ! [VarCurr: state_type] :
      ( v95993(VarCurr,0)
    <=> v95994(VarCurr) ) ).

tff(addAssignment_58330,axiom,
    ! [VarCurr: state_type] :
      ( v95993(VarCurr,1)
    <=> v95994(VarCurr) ) ).

tff(addAssignment_58329,axiom,
    ! [VarCurr: state_type] :
      ( v95994(VarCurr)
    <=> v95817(VarCurr,6) ) ).

tff(addAssignment_58328,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,6)
    <=> v95218(VarCurr,6) ) ).

tff(addAssignment_58327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95974(VarCurr,B)
      <=> v95976(VarCurr,B) ) ) ).

tff(addAssignment_58326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95976(VarCurr,B)
      <=> v18805(VarCurr,B) ) ) ).

tff(addAssignment_58325,axiom,
    ! [VarCurr: state_type] :
      ( v95933(VarCurr)
    <=> v95935(VarCurr) ) ).

tff(addAssignment_58324,axiom,
    ! [VarCurr: state_type] :
      ( v95935(VarCurr)
    <=> v95937(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_510,axiom,
    ! [VarCurr: state_type] :
      ( v95937(VarCurr)
    <=> ( ( v95939(VarCurr,11)
        <=> v95943(VarCurr,11) )
        & ( v95939(VarCurr,10)
        <=> v95943(VarCurr,10) )
        & ( v95939(VarCurr,9)
        <=> v95943(VarCurr,9) )
        & ( v95939(VarCurr,8)
        <=> v95943(VarCurr,8) )
        & ( v95939(VarCurr,7)
        <=> v95943(VarCurr,7) )
        & ( v95939(VarCurr,6)
        <=> v95943(VarCurr,6) )
        & ( v95939(VarCurr,5)
        <=> v95943(VarCurr,5) )
        & ( v95939(VarCurr,4)
        <=> v95943(VarCurr,4) )
        & ( v95939(VarCurr,3)
        <=> v95943(VarCurr,3) )
        & ( v95939(VarCurr,2)
        <=> v95943(VarCurr,2) )
        & ( v95939(VarCurr,1)
        <=> v95943(VarCurr,1) )
        & ( v95939(VarCurr,0)
        <=> v95943(VarCurr,0) ) ) ) ).

tff(addAssignment_58323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95943(VarCurr,B)
      <=> v95945(VarCurr,B) ) ) ).

tff(addAssignment_58322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95945(VarCurr,B)
      <=> v95964(VarCurr,B) ) ) ).

tff(addAssignment_58321,axiom,
    ! [VarCurr: state_type] :
      ( ( v95945(VarCurr,11)
      <=> v95962(VarCurr,5) )
      & ( v95945(VarCurr,10)
      <=> v95962(VarCurr,4) )
      & ( v95945(VarCurr,9)
      <=> v95962(VarCurr,3) )
      & ( v95945(VarCurr,8)
      <=> v95962(VarCurr,2) )
      & ( v95945(VarCurr,7)
      <=> v95962(VarCurr,1) )
      & ( v95945(VarCurr,6)
      <=> v95962(VarCurr,0) ) ) ).

tff(addAssignment_58320,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,0)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58319,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,1)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58318,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,2)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58317,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,3)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58316,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,4)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58315,axiom,
    ! [VarCurr: state_type] :
      ( v95964(VarCurr,5)
    <=> v95965(VarCurr) ) ).

tff(addAssignment_58314,axiom,
    ! [VarCurr: state_type] :
      ( v95965(VarCurr)
    <=> v95947(VarCurr,0) ) ).

tff(addAssignment_58313,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,0)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58312,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,1)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58311,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,2)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58310,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,3)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58309,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,4)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58308,axiom,
    ! [VarCurr: state_type] :
      ( v95962(VarCurr,5)
    <=> v95963(VarCurr) ) ).

tff(addAssignment_58307,axiom,
    ! [VarCurr: state_type] :
      ( v95963(VarCurr)
    <=> v95947(VarCurr,1) ) ).

tff(addAssignment_58306,axiom,
    ! [VarCurr: state_type] :
      ( v95947(VarCurr,0)
    <=> v95949(VarCurr,0) ) ).

tff(addAssignment_58305,axiom,
    ! [VarCurr: state_type] :
      ( v95949(VarCurr,0)
    <=> v95951(VarCurr,0) ) ).

tff(addAssignment_58304,axiom,
    ! [VarCurr: state_type] :
      ( v95951(VarCurr,0)
    <=> v95960(VarCurr,0) ) ).

tff(addAssignment_58303,axiom,
    ! [VarCurr: state_type] :
      ( v95953(VarCurr,0)
    <=> v95955(VarCurr,0) ) ).

tff(addAssignment_58302,axiom,
    ! [VarCurr: state_type] :
      ( v95955(VarCurr,0)
    <=> v95957(VarCurr,0) ) ).

tff(addAssignment_58301,axiom,
    ! [VarCurr: state_type] :
      ( v95957(VarCurr,0)
    <=> v95958(VarCurr,0) ) ).

tff(addAssignment_58300,axiom,
    ! [VarCurr: state_type] :
      ( v95947(VarCurr,1)
    <=> v95949(VarCurr,1) ) ).

tff(addAssignment_58299,axiom,
    ! [VarCurr: state_type] :
      ( v95949(VarCurr,1)
    <=> v95951(VarCurr,1) ) ).

tff(addAssignment_58298,axiom,
    ! [VarCurr: state_type] :
      ( v95951(VarCurr,1)
    <=> v95960(VarCurr,1) ) ).

tff(writeUnaryOperator_4364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95960(VarCurr,B)
      <=> ~ v95953(VarCurr,B) ) ) ).

tff(addAssignment_58297,axiom,
    ! [VarCurr: state_type] :
      ( v95953(VarCurr,1)
    <=> v95955(VarCurr,1) ) ).

tff(addAssignment_58296,axiom,
    ! [VarCurr: state_type] :
      ( v95955(VarCurr,1)
    <=> v95957(VarCurr,1) ) ).

tff(addAssignment_58295,axiom,
    ! [VarCurr: state_type] :
      ( v95957(VarCurr,1)
    <=> v95958(VarCurr,1) ) ).

tff(addAssignment_58294,axiom,
    ! [VarCurr: state_type] :
      ( v95958(VarCurr,0)
    <=> v95959(VarCurr) ) ).

tff(addAssignment_58293,axiom,
    ! [VarCurr: state_type] :
      ( v95958(VarCurr,1)
    <=> v95959(VarCurr) ) ).

tff(addAssignment_58292,axiom,
    ! [VarCurr: state_type] :
      ( v95959(VarCurr)
    <=> v95817(VarCurr,5) ) ).

tff(addAssignment_58291,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,5)
    <=> v95218(VarCurr,5) ) ).

tff(addAssignment_58290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95939(VarCurr,B)
      <=> v95941(VarCurr,B) ) ) ).

tff(addAssignment_58289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95941(VarCurr,B)
      <=> v17255(VarCurr,B) ) ) ).

tff(addAssignment_58288,axiom,
    ! [VarCurr: state_type] :
      ( v95898(VarCurr)
    <=> v95900(VarCurr) ) ).

tff(addAssignment_58287,axiom,
    ! [VarCurr: state_type] :
      ( v95900(VarCurr)
    <=> v95902(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_509,axiom,
    ! [VarCurr: state_type] :
      ( v95902(VarCurr)
    <=> ( ( v95904(VarCurr,11)
        <=> v95908(VarCurr,11) )
        & ( v95904(VarCurr,10)
        <=> v95908(VarCurr,10) )
        & ( v95904(VarCurr,9)
        <=> v95908(VarCurr,9) )
        & ( v95904(VarCurr,8)
        <=> v95908(VarCurr,8) )
        & ( v95904(VarCurr,7)
        <=> v95908(VarCurr,7) )
        & ( v95904(VarCurr,6)
        <=> v95908(VarCurr,6) )
        & ( v95904(VarCurr,5)
        <=> v95908(VarCurr,5) )
        & ( v95904(VarCurr,4)
        <=> v95908(VarCurr,4) )
        & ( v95904(VarCurr,3)
        <=> v95908(VarCurr,3) )
        & ( v95904(VarCurr,2)
        <=> v95908(VarCurr,2) )
        & ( v95904(VarCurr,1)
        <=> v95908(VarCurr,1) )
        & ( v95904(VarCurr,0)
        <=> v95908(VarCurr,0) ) ) ) ).

tff(addAssignment_58286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95908(VarCurr,B)
      <=> v95910(VarCurr,B) ) ) ).

tff(addAssignment_58285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95910(VarCurr,B)
      <=> v95929(VarCurr,B) ) ) ).

tff(addAssignment_58284,axiom,
    ! [VarCurr: state_type] :
      ( ( v95910(VarCurr,11)
      <=> v95927(VarCurr,5) )
      & ( v95910(VarCurr,10)
      <=> v95927(VarCurr,4) )
      & ( v95910(VarCurr,9)
      <=> v95927(VarCurr,3) )
      & ( v95910(VarCurr,8)
      <=> v95927(VarCurr,2) )
      & ( v95910(VarCurr,7)
      <=> v95927(VarCurr,1) )
      & ( v95910(VarCurr,6)
      <=> v95927(VarCurr,0) ) ) ).

tff(addAssignment_58283,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,0)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58282,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,1)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58281,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,2)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58280,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,3)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58279,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,4)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58278,axiom,
    ! [VarCurr: state_type] :
      ( v95929(VarCurr,5)
    <=> v95930(VarCurr) ) ).

tff(addAssignment_58277,axiom,
    ! [VarCurr: state_type] :
      ( v95930(VarCurr)
    <=> v95912(VarCurr,0) ) ).

tff(addAssignment_58276,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,0)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58275,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,1)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58274,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,2)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58273,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,3)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58272,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,4)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58271,axiom,
    ! [VarCurr: state_type] :
      ( v95927(VarCurr,5)
    <=> v95928(VarCurr) ) ).

tff(addAssignment_58270,axiom,
    ! [VarCurr: state_type] :
      ( v95928(VarCurr)
    <=> v95912(VarCurr,1) ) ).

tff(addAssignment_58269,axiom,
    ! [VarCurr: state_type] :
      ( v95912(VarCurr,0)
    <=> v95914(VarCurr,0) ) ).

tff(addAssignment_58268,axiom,
    ! [VarCurr: state_type] :
      ( v95914(VarCurr,0)
    <=> v95916(VarCurr,0) ) ).

tff(addAssignment_58267,axiom,
    ! [VarCurr: state_type] :
      ( v95916(VarCurr,0)
    <=> v95925(VarCurr,0) ) ).

tff(addAssignment_58266,axiom,
    ! [VarCurr: state_type] :
      ( v95918(VarCurr,0)
    <=> v95920(VarCurr,0) ) ).

tff(addAssignment_58265,axiom,
    ! [VarCurr: state_type] :
      ( v95920(VarCurr,0)
    <=> v95922(VarCurr,0) ) ).

tff(addAssignment_58264,axiom,
    ! [VarCurr: state_type] :
      ( v95922(VarCurr,0)
    <=> v95923(VarCurr,0) ) ).

tff(addAssignment_58263,axiom,
    ! [VarCurr: state_type] :
      ( v95912(VarCurr,1)
    <=> v95914(VarCurr,1) ) ).

tff(addAssignment_58262,axiom,
    ! [VarCurr: state_type] :
      ( v95914(VarCurr,1)
    <=> v95916(VarCurr,1) ) ).

tff(addAssignment_58261,axiom,
    ! [VarCurr: state_type] :
      ( v95916(VarCurr,1)
    <=> v95925(VarCurr,1) ) ).

tff(writeUnaryOperator_4363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95925(VarCurr,B)
      <=> ~ v95918(VarCurr,B) ) ) ).

tff(addAssignment_58260,axiom,
    ! [VarCurr: state_type] :
      ( v95918(VarCurr,1)
    <=> v95920(VarCurr,1) ) ).

tff(addAssignment_58259,axiom,
    ! [VarCurr: state_type] :
      ( v95920(VarCurr,1)
    <=> v95922(VarCurr,1) ) ).

tff(addAssignment_58258,axiom,
    ! [VarCurr: state_type] :
      ( v95922(VarCurr,1)
    <=> v95923(VarCurr,1) ) ).

tff(addAssignment_58257,axiom,
    ! [VarCurr: state_type] :
      ( v95923(VarCurr,0)
    <=> v95924(VarCurr) ) ).

tff(addAssignment_58256,axiom,
    ! [VarCurr: state_type] :
      ( v95923(VarCurr,1)
    <=> v95924(VarCurr) ) ).

tff(addAssignment_58255,axiom,
    ! [VarCurr: state_type] :
      ( v95924(VarCurr)
    <=> v95817(VarCurr,4) ) ).

tff(addAssignment_58254,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,4)
    <=> v95218(VarCurr,4) ) ).

tff(addAssignment_58253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95904(VarCurr,B)
      <=> v95906(VarCurr,B) ) ) ).

tff(addAssignment_58252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95906(VarCurr,B)
      <=> v15705(VarCurr,B) ) ) ).

tff(addAssignment_58251,axiom,
    ! [VarCurr: state_type] :
      ( v95863(VarCurr)
    <=> v95865(VarCurr) ) ).

tff(addAssignment_58250,axiom,
    ! [VarCurr: state_type] :
      ( v95865(VarCurr)
    <=> v95867(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_508,axiom,
    ! [VarCurr: state_type] :
      ( v95867(VarCurr)
    <=> ( ( v95869(VarCurr,11)
        <=> v95873(VarCurr,11) )
        & ( v95869(VarCurr,10)
        <=> v95873(VarCurr,10) )
        & ( v95869(VarCurr,9)
        <=> v95873(VarCurr,9) )
        & ( v95869(VarCurr,8)
        <=> v95873(VarCurr,8) )
        & ( v95869(VarCurr,7)
        <=> v95873(VarCurr,7) )
        & ( v95869(VarCurr,6)
        <=> v95873(VarCurr,6) )
        & ( v95869(VarCurr,5)
        <=> v95873(VarCurr,5) )
        & ( v95869(VarCurr,4)
        <=> v95873(VarCurr,4) )
        & ( v95869(VarCurr,3)
        <=> v95873(VarCurr,3) )
        & ( v95869(VarCurr,2)
        <=> v95873(VarCurr,2) )
        & ( v95869(VarCurr,1)
        <=> v95873(VarCurr,1) )
        & ( v95869(VarCurr,0)
        <=> v95873(VarCurr,0) ) ) ) ).

tff(addAssignment_58249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95873(VarCurr,B)
      <=> v95875(VarCurr,B) ) ) ).

tff(addAssignment_58248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95875(VarCurr,B)
      <=> v95894(VarCurr,B) ) ) ).

tff(addAssignment_58247,axiom,
    ! [VarCurr: state_type] :
      ( ( v95875(VarCurr,11)
      <=> v95892(VarCurr,5) )
      & ( v95875(VarCurr,10)
      <=> v95892(VarCurr,4) )
      & ( v95875(VarCurr,9)
      <=> v95892(VarCurr,3) )
      & ( v95875(VarCurr,8)
      <=> v95892(VarCurr,2) )
      & ( v95875(VarCurr,7)
      <=> v95892(VarCurr,1) )
      & ( v95875(VarCurr,6)
      <=> v95892(VarCurr,0) ) ) ).

tff(addAssignment_58246,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,0)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58245,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,1)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58244,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,2)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58243,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,3)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58242,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,4)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58241,axiom,
    ! [VarCurr: state_type] :
      ( v95894(VarCurr,5)
    <=> v95895(VarCurr) ) ).

tff(addAssignment_58240,axiom,
    ! [VarCurr: state_type] :
      ( v95895(VarCurr)
    <=> v95877(VarCurr,0) ) ).

tff(addAssignment_58239,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,0)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58238,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,1)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58237,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,2)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58236,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,3)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58235,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,4)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58234,axiom,
    ! [VarCurr: state_type] :
      ( v95892(VarCurr,5)
    <=> v95893(VarCurr) ) ).

tff(addAssignment_58233,axiom,
    ! [VarCurr: state_type] :
      ( v95893(VarCurr)
    <=> v95877(VarCurr,1) ) ).

tff(addAssignment_58232,axiom,
    ! [VarCurr: state_type] :
      ( v95877(VarCurr,0)
    <=> v95879(VarCurr,0) ) ).

tff(addAssignment_58231,axiom,
    ! [VarCurr: state_type] :
      ( v95879(VarCurr,0)
    <=> v95881(VarCurr,0) ) ).

tff(addAssignment_58230,axiom,
    ! [VarCurr: state_type] :
      ( v95881(VarCurr,0)
    <=> v95890(VarCurr,0) ) ).

tff(addAssignment_58229,axiom,
    ! [VarCurr: state_type] :
      ( v95883(VarCurr,0)
    <=> v95885(VarCurr,0) ) ).

tff(addAssignment_58228,axiom,
    ! [VarCurr: state_type] :
      ( v95885(VarCurr,0)
    <=> v95887(VarCurr,0) ) ).

tff(addAssignment_58227,axiom,
    ! [VarCurr: state_type] :
      ( v95887(VarCurr,0)
    <=> v95888(VarCurr,0) ) ).

tff(addAssignment_58226,axiom,
    ! [VarCurr: state_type] :
      ( v95877(VarCurr,1)
    <=> v95879(VarCurr,1) ) ).

tff(addAssignment_58225,axiom,
    ! [VarCurr: state_type] :
      ( v95879(VarCurr,1)
    <=> v95881(VarCurr,1) ) ).

tff(addAssignment_58224,axiom,
    ! [VarCurr: state_type] :
      ( v95881(VarCurr,1)
    <=> v95890(VarCurr,1) ) ).

tff(writeUnaryOperator_4362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95890(VarCurr,B)
      <=> ~ v95883(VarCurr,B) ) ) ).

tff(addAssignment_58223,axiom,
    ! [VarCurr: state_type] :
      ( v95883(VarCurr,1)
    <=> v95885(VarCurr,1) ) ).

tff(addAssignment_58222,axiom,
    ! [VarCurr: state_type] :
      ( v95885(VarCurr,1)
    <=> v95887(VarCurr,1) ) ).

tff(addAssignment_58221,axiom,
    ! [VarCurr: state_type] :
      ( v95887(VarCurr,1)
    <=> v95888(VarCurr,1) ) ).

tff(addAssignment_58220,axiom,
    ! [VarCurr: state_type] :
      ( v95888(VarCurr,0)
    <=> v95889(VarCurr) ) ).

tff(addAssignment_58219,axiom,
    ! [VarCurr: state_type] :
      ( v95888(VarCurr,1)
    <=> v95889(VarCurr) ) ).

tff(addAssignment_58218,axiom,
    ! [VarCurr: state_type] :
      ( v95889(VarCurr)
    <=> v95817(VarCurr,3) ) ).

tff(addAssignment_58217,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,3)
    <=> v95218(VarCurr,3) ) ).

tff(addAssignment_58216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95869(VarCurr,B)
      <=> v95871(VarCurr,B) ) ) ).

tff(addAssignment_58215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95871(VarCurr,B)
      <=> v14155(VarCurr,B) ) ) ).

tff(addAssignment_58214,axiom,
    ! [VarCurr: state_type] :
      ( v95828(VarCurr)
    <=> v95830(VarCurr) ) ).

tff(addAssignment_58213,axiom,
    ! [VarCurr: state_type] :
      ( v95830(VarCurr)
    <=> v95832(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_507,axiom,
    ! [VarCurr: state_type] :
      ( v95832(VarCurr)
    <=> ( ( v95834(VarCurr,11)
        <=> v95838(VarCurr,11) )
        & ( v95834(VarCurr,10)
        <=> v95838(VarCurr,10) )
        & ( v95834(VarCurr,9)
        <=> v95838(VarCurr,9) )
        & ( v95834(VarCurr,8)
        <=> v95838(VarCurr,8) )
        & ( v95834(VarCurr,7)
        <=> v95838(VarCurr,7) )
        & ( v95834(VarCurr,6)
        <=> v95838(VarCurr,6) )
        & ( v95834(VarCurr,5)
        <=> v95838(VarCurr,5) )
        & ( v95834(VarCurr,4)
        <=> v95838(VarCurr,4) )
        & ( v95834(VarCurr,3)
        <=> v95838(VarCurr,3) )
        & ( v95834(VarCurr,2)
        <=> v95838(VarCurr,2) )
        & ( v95834(VarCurr,1)
        <=> v95838(VarCurr,1) )
        & ( v95834(VarCurr,0)
        <=> v95838(VarCurr,0) ) ) ) ).

tff(addAssignment_58212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95838(VarCurr,B)
      <=> v95840(VarCurr,B) ) ) ).

tff(addAssignment_58211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95840(VarCurr,B)
      <=> v95859(VarCurr,B) ) ) ).

tff(addAssignment_58210,axiom,
    ! [VarCurr: state_type] :
      ( ( v95840(VarCurr,11)
      <=> v95857(VarCurr,5) )
      & ( v95840(VarCurr,10)
      <=> v95857(VarCurr,4) )
      & ( v95840(VarCurr,9)
      <=> v95857(VarCurr,3) )
      & ( v95840(VarCurr,8)
      <=> v95857(VarCurr,2) )
      & ( v95840(VarCurr,7)
      <=> v95857(VarCurr,1) )
      & ( v95840(VarCurr,6)
      <=> v95857(VarCurr,0) ) ) ).

tff(addAssignment_58209,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,0)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58208,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,1)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58207,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,2)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58206,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,3)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58205,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,4)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58204,axiom,
    ! [VarCurr: state_type] :
      ( v95859(VarCurr,5)
    <=> v95860(VarCurr) ) ).

tff(addAssignment_58203,axiom,
    ! [VarCurr: state_type] :
      ( v95860(VarCurr)
    <=> v95842(VarCurr,0) ) ).

tff(addAssignment_58202,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,0)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58201,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,1)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58200,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,2)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58199,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,3)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58198,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,4)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58197,axiom,
    ! [VarCurr: state_type] :
      ( v95857(VarCurr,5)
    <=> v95858(VarCurr) ) ).

tff(addAssignment_58196,axiom,
    ! [VarCurr: state_type] :
      ( v95858(VarCurr)
    <=> v95842(VarCurr,1) ) ).

tff(addAssignment_58195,axiom,
    ! [VarCurr: state_type] :
      ( v95842(VarCurr,0)
    <=> v95844(VarCurr,0) ) ).

tff(addAssignment_58194,axiom,
    ! [VarCurr: state_type] :
      ( v95844(VarCurr,0)
    <=> v95846(VarCurr,0) ) ).

tff(addAssignment_58193,axiom,
    ! [VarCurr: state_type] :
      ( v95846(VarCurr,0)
    <=> v95855(VarCurr,0) ) ).

tff(addAssignment_58192,axiom,
    ! [VarCurr: state_type] :
      ( v95848(VarCurr,0)
    <=> v95850(VarCurr,0) ) ).

tff(addAssignment_58191,axiom,
    ! [VarCurr: state_type] :
      ( v95850(VarCurr,0)
    <=> v95852(VarCurr,0) ) ).

tff(addAssignment_58190,axiom,
    ! [VarCurr: state_type] :
      ( v95852(VarCurr,0)
    <=> v95853(VarCurr,0) ) ).

tff(addAssignment_58189,axiom,
    ! [VarCurr: state_type] :
      ( v95842(VarCurr,1)
    <=> v95844(VarCurr,1) ) ).

tff(addAssignment_58188,axiom,
    ! [VarCurr: state_type] :
      ( v95844(VarCurr,1)
    <=> v95846(VarCurr,1) ) ).

tff(addAssignment_58187,axiom,
    ! [VarCurr: state_type] :
      ( v95846(VarCurr,1)
    <=> v95855(VarCurr,1) ) ).

tff(writeUnaryOperator_4361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95855(VarCurr,B)
      <=> ~ v95848(VarCurr,B) ) ) ).

tff(addAssignment_58186,axiom,
    ! [VarCurr: state_type] :
      ( v95848(VarCurr,1)
    <=> v95850(VarCurr,1) ) ).

tff(addAssignment_58185,axiom,
    ! [VarCurr: state_type] :
      ( v95850(VarCurr,1)
    <=> v95852(VarCurr,1) ) ).

tff(addAssignment_58184,axiom,
    ! [VarCurr: state_type] :
      ( v95852(VarCurr,1)
    <=> v95853(VarCurr,1) ) ).

tff(addAssignment_58183,axiom,
    ! [VarCurr: state_type] :
      ( v95853(VarCurr,0)
    <=> v95854(VarCurr) ) ).

tff(addAssignment_58182,axiom,
    ! [VarCurr: state_type] :
      ( v95853(VarCurr,1)
    <=> v95854(VarCurr) ) ).

tff(addAssignment_58181,axiom,
    ! [VarCurr: state_type] :
      ( v95854(VarCurr)
    <=> v95817(VarCurr,2) ) ).

tff(addAssignment_58180,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,2)
    <=> v95218(VarCurr,2) ) ).

tff(addAssignment_58179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95834(VarCurr,B)
      <=> v95836(VarCurr,B) ) ) ).

tff(addAssignment_58178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95836(VarCurr,B)
      <=> v12605(VarCurr,B) ) ) ).

tff(addAssignment_58177,axiom,
    ! [VarCurr: state_type] :
      ( v95791(VarCurr)
    <=> v95793(VarCurr) ) ).

tff(addAssignment_58176,axiom,
    ! [VarCurr: state_type] :
      ( v95793(VarCurr)
    <=> v95795(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_506,axiom,
    ! [VarCurr: state_type] :
      ( v95795(VarCurr)
    <=> ( ( v95797(VarCurr,11)
        <=> v95801(VarCurr,11) )
        & ( v95797(VarCurr,10)
        <=> v95801(VarCurr,10) )
        & ( v95797(VarCurr,9)
        <=> v95801(VarCurr,9) )
        & ( v95797(VarCurr,8)
        <=> v95801(VarCurr,8) )
        & ( v95797(VarCurr,7)
        <=> v95801(VarCurr,7) )
        & ( v95797(VarCurr,6)
        <=> v95801(VarCurr,6) )
        & ( v95797(VarCurr,5)
        <=> v95801(VarCurr,5) )
        & ( v95797(VarCurr,4)
        <=> v95801(VarCurr,4) )
        & ( v95797(VarCurr,3)
        <=> v95801(VarCurr,3) )
        & ( v95797(VarCurr,2)
        <=> v95801(VarCurr,2) )
        & ( v95797(VarCurr,1)
        <=> v95801(VarCurr,1) )
        & ( v95797(VarCurr,0)
        <=> v95801(VarCurr,0) ) ) ) ).

tff(addAssignment_58175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95801(VarCurr,B)
      <=> v95803(VarCurr,B) ) ) ).

tff(addAssignment_58174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95803(VarCurr,B)
      <=> v95824(VarCurr,B) ) ) ).

tff(addAssignment_58173,axiom,
    ! [VarCurr: state_type] :
      ( ( v95803(VarCurr,11)
      <=> v95822(VarCurr,5) )
      & ( v95803(VarCurr,10)
      <=> v95822(VarCurr,4) )
      & ( v95803(VarCurr,9)
      <=> v95822(VarCurr,3) )
      & ( v95803(VarCurr,8)
      <=> v95822(VarCurr,2) )
      & ( v95803(VarCurr,7)
      <=> v95822(VarCurr,1) )
      & ( v95803(VarCurr,6)
      <=> v95822(VarCurr,0) ) ) ).

tff(addAssignment_58172,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,0)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58171,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,1)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58170,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,2)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58169,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,3)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58168,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,4)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58167,axiom,
    ! [VarCurr: state_type] :
      ( v95824(VarCurr,5)
    <=> v95825(VarCurr) ) ).

tff(addAssignment_58166,axiom,
    ! [VarCurr: state_type] :
      ( v95825(VarCurr)
    <=> v95805(VarCurr,0) ) ).

tff(addAssignment_58165,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,0)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58164,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,1)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58163,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,2)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58162,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,3)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58161,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,4)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58160,axiom,
    ! [VarCurr: state_type] :
      ( v95822(VarCurr,5)
    <=> v95823(VarCurr) ) ).

tff(addAssignment_58159,axiom,
    ! [VarCurr: state_type] :
      ( v95823(VarCurr)
    <=> v95805(VarCurr,1) ) ).

tff(addAssignment_58158,axiom,
    ! [VarCurr: state_type] :
      ( v95805(VarCurr,0)
    <=> v95807(VarCurr,0) ) ).

tff(addAssignment_58157,axiom,
    ! [VarCurr: state_type] :
      ( v95807(VarCurr,0)
    <=> v95809(VarCurr,0) ) ).

tff(addAssignment_58156,axiom,
    ! [VarCurr: state_type] :
      ( v95809(VarCurr,0)
    <=> v95820(VarCurr,0) ) ).

tff(addAssignment_58155,axiom,
    ! [VarCurr: state_type] :
      ( v95811(VarCurr,0)
    <=> v95813(VarCurr,0) ) ).

tff(addAssignment_58154,axiom,
    ! [VarCurr: state_type] :
      ( v95813(VarCurr,0)
    <=> v95815(VarCurr,0) ) ).

tff(addAssignment_58153,axiom,
    ! [VarCurr: state_type] :
      ( v95815(VarCurr,0)
    <=> v95818(VarCurr,0) ) ).

tff(addAssignment_58152,axiom,
    ! [VarCurr: state_type] :
      ( v95805(VarCurr,1)
    <=> v95807(VarCurr,1) ) ).

tff(addAssignment_58151,axiom,
    ! [VarCurr: state_type] :
      ( v95807(VarCurr,1)
    <=> v95809(VarCurr,1) ) ).

tff(addAssignment_58150,axiom,
    ! [VarCurr: state_type] :
      ( v95809(VarCurr,1)
    <=> v95820(VarCurr,1) ) ).

tff(writeUnaryOperator_4360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95820(VarCurr,B)
      <=> ~ v95811(VarCurr,B) ) ) ).

tff(addAssignment_58149,axiom,
    ! [VarCurr: state_type] :
      ( v95811(VarCurr,1)
    <=> v95813(VarCurr,1) ) ).

tff(addAssignment_58148,axiom,
    ! [VarCurr: state_type] :
      ( v95813(VarCurr,1)
    <=> v95815(VarCurr,1) ) ).

tff(addAssignment_58147,axiom,
    ! [VarCurr: state_type] :
      ( v95815(VarCurr,1)
    <=> v95818(VarCurr,1) ) ).

tff(addAssignment_58146,axiom,
    ! [VarCurr: state_type] :
      ( v95818(VarCurr,0)
    <=> v95819(VarCurr) ) ).

tff(addAssignment_58145,axiom,
    ! [VarCurr: state_type] :
      ( v95818(VarCurr,1)
    <=> v95819(VarCurr) ) ).

tff(addAssignment_58144,axiom,
    ! [VarCurr: state_type] :
      ( v95819(VarCurr)
    <=> v95817(VarCurr,1) ) ).

tff(addAssignment_58143,axiom,
    ! [VarCurr: state_type] :
      ( v95817(VarCurr,1)
    <=> v95218(VarCurr,1) ) ).

tff(addAssignment_58142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95797(VarCurr,B)
      <=> v95799(VarCurr,B) ) ) ).

tff(addAssignment_58141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95799(VarCurr,B)
      <=> v11055(VarCurr,B) ) ) ).

tff(addAssignment_58140,axiom,
    ! [VarCurr: state_type] :
      ( v95746(VarCurr)
    <=> v95748(VarCurr) ) ).

tff(addAssignment_58139,axiom,
    ! [VarCurr: state_type] :
      ( v95748(VarCurr)
    <=> v95750(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_505,axiom,
    ! [VarCurr: state_type] :
      ( v95750(VarCurr)
    <=> ( ( v95752(VarCurr,11)
        <=> v95756(VarCurr,11) )
        & ( v95752(VarCurr,10)
        <=> v95756(VarCurr,10) )
        & ( v95752(VarCurr,9)
        <=> v95756(VarCurr,9) )
        & ( v95752(VarCurr,8)
        <=> v95756(VarCurr,8) )
        & ( v95752(VarCurr,7)
        <=> v95756(VarCurr,7) )
        & ( v95752(VarCurr,6)
        <=> v95756(VarCurr,6) )
        & ( v95752(VarCurr,5)
        <=> v95756(VarCurr,5) )
        & ( v95752(VarCurr,4)
        <=> v95756(VarCurr,4) )
        & ( v95752(VarCurr,3)
        <=> v95756(VarCurr,3) )
        & ( v95752(VarCurr,2)
        <=> v95756(VarCurr,2) )
        & ( v95752(VarCurr,1)
        <=> v95756(VarCurr,1) )
        & ( v95752(VarCurr,0)
        <=> v95756(VarCurr,0) ) ) ) ).

tff(addAssignment_58138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95756(VarCurr,B)
      <=> v95758(VarCurr,B) ) ) ).

tff(addAssignment_58137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95758(VarCurr,B)
      <=> v95787(VarCurr,B) ) ) ).

tff(addAssignment_58136,axiom,
    ! [VarCurr: state_type] :
      ( ( v95758(VarCurr,11)
      <=> v95785(VarCurr,5) )
      & ( v95758(VarCurr,10)
      <=> v95785(VarCurr,4) )
      & ( v95758(VarCurr,9)
      <=> v95785(VarCurr,3) )
      & ( v95758(VarCurr,8)
      <=> v95785(VarCurr,2) )
      & ( v95758(VarCurr,7)
      <=> v95785(VarCurr,1) )
      & ( v95758(VarCurr,6)
      <=> v95785(VarCurr,0) ) ) ).

tff(addAssignment_58135,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,0)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58134,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,1)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58133,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,2)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58132,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,3)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58131,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,4)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58130,axiom,
    ! [VarCurr: state_type] :
      ( v95787(VarCurr,5)
    <=> v95788(VarCurr) ) ).

tff(addAssignment_58129,axiom,
    ! [VarCurr: state_type] :
      ( v95788(VarCurr)
    <=> v95760(VarCurr,0) ) ).

tff(addAssignment_58128,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,0)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58127,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,1)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58126,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,2)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58125,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,3)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58124,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,4)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58123,axiom,
    ! [VarCurr: state_type] :
      ( v95785(VarCurr,5)
    <=> v95786(VarCurr) ) ).

tff(addAssignment_58122,axiom,
    ! [VarCurr: state_type] :
      ( v95786(VarCurr)
    <=> v95760(VarCurr,1) ) ).

tff(addAssignment_58121,axiom,
    ! [VarCurr: state_type] :
      ( v95760(VarCurr,0)
    <=> v95762(VarCurr,0) ) ).

tff(addAssignment_58120,axiom,
    ! [VarCurr: state_type] :
      ( v95762(VarCurr,0)
    <=> v95764(VarCurr,0) ) ).

tff(addAssignment_58119,axiom,
    ! [VarCurr: state_type] :
      ( v95764(VarCurr,0)
    <=> v95783(VarCurr,0) ) ).

tff(addAssignment_58118,axiom,
    ! [VarCurr: state_type] :
      ( v95766(VarCurr,0)
    <=> v95768(VarCurr,0) ) ).

tff(addAssignment_58117,axiom,
    ! [VarCurr: state_type] :
      ( v95768(VarCurr,0)
    <=> v95770(VarCurr,0) ) ).

tff(addAssignment_58116,axiom,
    ! [VarCurr: state_type] :
      ( v95770(VarCurr,0)
    <=> v95781(VarCurr,0) ) ).

tff(addAssignment_58115,axiom,
    ! [VarCurr: state_type] :
      ( v95760(VarCurr,1)
    <=> v95762(VarCurr,1) ) ).

tff(addAssignment_58114,axiom,
    ! [VarCurr: state_type] :
      ( v95762(VarCurr,1)
    <=> v95764(VarCurr,1) ) ).

tff(addAssignment_58113,axiom,
    ! [VarCurr: state_type] :
      ( v95764(VarCurr,1)
    <=> v95783(VarCurr,1) ) ).

tff(writeUnaryOperator_4359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95783(VarCurr,B)
      <=> ~ v95766(VarCurr,B) ) ) ).

tff(addAssignment_58112,axiom,
    ! [VarCurr: state_type] :
      ( v95766(VarCurr,1)
    <=> v95768(VarCurr,1) ) ).

tff(addAssignment_58111,axiom,
    ! [VarCurr: state_type] :
      ( v95768(VarCurr,1)
    <=> v95770(VarCurr,1) ) ).

tff(addAssignment_58110,axiom,
    ! [VarCurr: state_type] :
      ( v95770(VarCurr,1)
    <=> v95781(VarCurr,1) ) ).

tff(addAssignment_58109,axiom,
    ! [VarCurr: state_type] :
      ( v95781(VarCurr,0)
    <=> v95782(VarCurr) ) ).

tff(addAssignment_58108,axiom,
    ! [VarCurr: state_type] :
      ( v95781(VarCurr,1)
    <=> v95782(VarCurr) ) ).

tff(addAssignment_58107,axiom,
    ! [VarCurr: state_type] :
      ( v95782(VarCurr)
    <=> v95772(VarCurr,0) ) ).

tff(addAssignment_58106,axiom,
    ! [VarCurr: state_type] :
      ( v95772(VarCurr,0)
    <=> v94842(VarCurr,2) ) ).

tff(addAssignment_58105,axiom,
    ! [VarCurr: state_type] :
      ( v94842(VarCurr,2)
    <=> v94844(VarCurr,2) ) ).

tff(addAssignment_58104,axiom,
    ! [VarCurr: state_type] :
      ( v94844(VarCurr,2)
    <=> v94846(VarCurr,30) ) ).

tff(addAssignment_58103,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,30)
    <=> v94848(VarCurr,30) ) ).

tff(addAssignment_58102,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,30)
    <=> v95774(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_1066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95775(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95774(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1066,axiom,
    ! [VarNext: state_type] :
      ( v95775(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95774(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95775(VarNext)
      <=> v95776(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95776(VarNext)
      <=> ( v95778(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95778(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_58101,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,30)
    <=> v94880(VarCurr,30) ) ).

tff(addAssignment_58100,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,30)
    <=> v95101(VarCurr,30) ) ).

tff(addAssignment_58099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95752(VarCurr,B)
      <=> v95754(VarCurr,B) ) ) ).

tff(addAssignment_58098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95754(VarCurr,B)
      <=> v9099(VarCurr,B) ) ) ).

tff(addAssignment_58097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v94808(VarCurr,B)
      <=> v94810(VarCurr,B) ) ) ).

tff(addAssignment_58096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v94810(VarCurr,B)
      <=> v94812(VarCurr,B) ) ) ).

tff(addAssignment_58095,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,12)
    <=> v95669(VarCurr) ) ).

tff(addAssignment_58094,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,11)
    <=> v95626(VarCurr) ) ).

tff(addAssignment_58093,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,10)
    <=> v95583(VarCurr) ) ).

tff(addAssignment_58092,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,9)
    <=> v95540(VarCurr) ) ).

tff(addAssignment_58091,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,8)
    <=> v95497(VarCurr) ) ).

tff(addAssignment_58090,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,7)
    <=> v95454(VarCurr) ) ).

tff(addAssignment_58089,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,6)
    <=> v95411(VarCurr) ) ).

tff(addAssignment_58088,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,5)
    <=> v95368(VarCurr) ) ).

tff(addAssignment_58087,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,4)
    <=> v95325(VarCurr) ) ).

tff(addAssignment_58086,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,3)
    <=> v95282(VarCurr) ) ).

tff(addAssignment_58085,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,2)
    <=> v95239(VarCurr) ) ).

tff(addAssignment_58084,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,1)
    <=> v95190(VarCurr) ) ).

tff(addAssignment_58083,axiom,
    ! [VarCurr: state_type] :
      ( v94812(VarCurr,0)
    <=> v94814(VarCurr) ) ).

tff(addAssignment_58082,axiom,
    ! [VarCurr: state_type] :
      ( v95669(VarCurr)
    <=> v95671(VarCurr) ) ).

tff(addAssignment_58081,axiom,
    ! [VarCurr: state_type] :
      ( v95671(VarCurr)
    <=> v95673(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_504,axiom,
    ! [VarCurr: state_type] :
      ( v95673(VarCurr)
    <=> ( ( v95675(VarCurr,11)
        <=> v95679(VarCurr,11) )
        & ( v95675(VarCurr,10)
        <=> v95679(VarCurr,10) )
        & ( v95675(VarCurr,9)
        <=> v95679(VarCurr,9) )
        & ( v95675(VarCurr,8)
        <=> v95679(VarCurr,8) )
        & ( v95675(VarCurr,7)
        <=> v95679(VarCurr,7) )
        & ( v95675(VarCurr,6)
        <=> v95679(VarCurr,6) )
        & ( v95675(VarCurr,5)
        <=> v95679(VarCurr,5) )
        & ( v95675(VarCurr,4)
        <=> v95679(VarCurr,4) )
        & ( v95675(VarCurr,3)
        <=> v95679(VarCurr,3) )
        & ( v95675(VarCurr,2)
        <=> v95679(VarCurr,2) )
        & ( v95675(VarCurr,1)
        <=> v95679(VarCurr,1) )
        & ( v95675(VarCurr,0)
        <=> v95679(VarCurr,0) ) ) ) ).

tff(addAssignment_58080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95679(VarCurr,B)
      <=> v95681(VarCurr,B) ) ) ).

tff(addAssignment_58079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95681(VarCurr,B)
      <=> v95736(VarCurr,B) ) ) ).

tff(addAssignment_58078,axiom,
    ! [VarCurr: state_type] :
      ( ( v95681(VarCurr,11)
      <=> v95734(VarCurr,5) )
      & ( v95681(VarCurr,10)
      <=> v95734(VarCurr,4) )
      & ( v95681(VarCurr,9)
      <=> v95734(VarCurr,3) )
      & ( v95681(VarCurr,8)
      <=> v95734(VarCurr,2) )
      & ( v95681(VarCurr,7)
      <=> v95734(VarCurr,1) )
      & ( v95681(VarCurr,6)
      <=> v95734(VarCurr,0) ) ) ).

tff(addAssignment_58077,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,0)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58076,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,1)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58075,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,2)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58074,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,3)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58073,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,4)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58072,axiom,
    ! [VarCurr: state_type] :
      ( v95736(VarCurr,5)
    <=> v95737(VarCurr) ) ).

tff(addAssignment_58071,axiom,
    ! [VarCurr: state_type] :
      ( v95737(VarCurr)
    <=> v95683(VarCurr,0) ) ).

tff(addAssignment_58070,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,0)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58069,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,1)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58068,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,2)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58067,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,3)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58066,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,4)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58065,axiom,
    ! [VarCurr: state_type] :
      ( v95734(VarCurr,5)
    <=> v95735(VarCurr) ) ).

tff(addAssignment_58064,axiom,
    ! [VarCurr: state_type] :
      ( v95735(VarCurr)
    <=> v95683(VarCurr,1) ) ).

tff(addAssignment_58063,axiom,
    ! [VarCurr: state_type] :
      ( v95683(VarCurr,0)
    <=> v95685(VarCurr,0) ) ).

tff(addAssignment_58062,axiom,
    ! [VarCurr: state_type] :
      ( v95685(VarCurr,0)
    <=> v95687(VarCurr,0) ) ).

tff(addAssignment_58061,axiom,
    ! [VarCurr: state_type] :
      ( v95687(VarCurr,0)
    <=> v95724(VarCurr,0) ) ).

tff(addAssignment_58060,axiom,
    ! [VarCurr: state_type] :
      ( v95689(VarCurr,0)
    <=> v95691(VarCurr,0) ) ).

tff(addAssignment_58059,axiom,
    ! [VarCurr: state_type] :
      ( v95691(VarCurr,0)
    <=> v95693(VarCurr,0) ) ).

tff(addAssignment_58058,axiom,
    ! [VarCurr: state_type] :
      ( v95693(VarCurr,0)
    <=> v95723(VarCurr,0) ) ).

tff(addAssignment_58057,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,0)
    <=> v95218(VarCurr,0) ) ).

tff(addAssignment_58056,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,0)
    <=> v95220(VarCurr,0) ) ).

tff(addAssignment_58055,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,0)
    <=> v94846(VarCurr,16) ) ).

tff(addAssignment_58054,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,16)
    <=> v94848(VarCurr,16) ) ).

tff(addAssignment_58053,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,16)
    <=> v95726(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_1065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95727(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95726(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1065,axiom,
    ! [VarNext: state_type] :
      ( v95727(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95726(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95727(VarNext)
      <=> v95728(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95728(VarNext)
      <=> ( v95730(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95730(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_58052,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,16)
    <=> v94880(VarCurr,16) ) ).

tff(addAssignment_58051,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,16)
    <=> v95101(VarCurr,16) ) ).

tff(addAssignment_58050,axiom,
    ! [VarCurr: state_type] :
      ( v95683(VarCurr,1)
    <=> v95685(VarCurr,1) ) ).

tff(addAssignment_58049,axiom,
    ! [VarCurr: state_type] :
      ( v95685(VarCurr,1)
    <=> v95687(VarCurr,1) ) ).

tff(addAssignment_58048,axiom,
    ! [VarCurr: state_type] :
      ( v95687(VarCurr,1)
    <=> v95724(VarCurr,1) ) ).

tff(writeUnaryOperator_4356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95724(VarCurr,B)
      <=> ~ v95689(VarCurr,B) ) ) ).

tff(addAssignment_58047,axiom,
    ! [VarCurr: state_type] :
      ( v95689(VarCurr,1)
    <=> v95691(VarCurr,1) ) ).

tff(addAssignment_58046,axiom,
    ! [VarCurr: state_type] :
      ( v95691(VarCurr,1)
    <=> v95693(VarCurr,1) ) ).

tff(addAssignment_58045,axiom,
    ! [VarCurr: state_type] :
      ( v95693(VarCurr,1)
    <=> v95723(VarCurr,1) ) ).

tff(addAssignment_58044,axiom,
    ! [VarCurr: state_type] :
      ( v95723(VarCurr,0)
    <=> v95216(VarCurr,0) ) ).

tff(addAssignment_58043,axiom,
    ! [VarCurr: state_type] :
      ( v95723(VarCurr,1)
    <=> v95695(VarCurr) ) ).

tff(addAssignment_58042,axiom,
    ! [VarCurr: state_type] :
      ( v95695(VarCurr)
    <=> v95697(VarCurr) ) ).

tff(addAssignment_58041,axiom,
    ! [VarCurr: state_type] :
      ( v95697(VarCurr)
    <=> v95220(VarCurr,12) ) ).

tff(addAssignment_58040,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,12)
    <=> v95699(VarCurr,0) ) ).

tff(addAssignment_58039,axiom,
    ! [VarCurr: state_type] :
      ( v95699(VarCurr,0)
    <=> v95701(VarCurr,0) ) ).

tff(addAssignment_58038,axiom,
    ! [VarCurr: state_type] :
      ( v95701(VarCurr,0)
    <=> v95721(VarCurr,0) ) ).

tff(writeUnaryOperator_4355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,0) )
     => ( v95721(VarCurr,B)
      <=> ~ v95722(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,0) )
     => ( v95722(VarCurr,B)
      <=> ( v95703(VarCurr,B)
          & v95717(VarCurr,B) ) ) ) ).

tff(addAssignment_58037,axiom,
    ! [VarCurr: state_type] :
      ( v95717(VarCurr,0)
    <=> v95719(VarCurr,0) ) ).

tff(addAssignment_58036,axiom,
    ! [VarCurr: state_type] :
      ( v95719(VarCurr,0)
    <=> v95720(VarCurr,0) ) ).

tff(addAssignment_58035,axiom,
    ! [VarCurr: state_type] :
      ( v95720(VarCurr,0)
    <=> v94844(VarCurr,3) ) ).

tff(addAssignment_58034,axiom,
    ! [VarCurr: state_type] :
      ( ( v95720(VarCurr,47)
      <=> $false )
      & ( v95720(VarCurr,46)
      <=> $false )
      & ( v95720(VarCurr,45)
      <=> $false )
      & ( v95720(VarCurr,44)
      <=> $false )
      & ( v95720(VarCurr,43)
      <=> $false )
      & ( v95720(VarCurr,42)
      <=> $false )
      & ( v95720(VarCurr,41)
      <=> $false )
      & ( v95720(VarCurr,40)
      <=> $false )
      & ( v95720(VarCurr,39)
      <=> $false )
      & ( v95720(VarCurr,38)
      <=> $false )
      & ( v95720(VarCurr,37)
      <=> $false )
      & ( v95720(VarCurr,36)
      <=> $false )
      & ( v95720(VarCurr,35)
      <=> $false )
      & ( v95720(VarCurr,34)
      <=> $false )
      & ( v95720(VarCurr,33)
      <=> $false )
      & ( v95720(VarCurr,32)
      <=> $false )
      & ( v95720(VarCurr,31)
      <=> $false )
      & ( v95720(VarCurr,30)
      <=> $false )
      & ( v95720(VarCurr,29)
      <=> $false )
      & ( v95720(VarCurr,28)
      <=> $false )
      & ( v95720(VarCurr,27)
      <=> $false )
      & ( v95720(VarCurr,26)
      <=> $false )
      & ( v95720(VarCurr,25)
      <=> $false )
      & ( v95720(VarCurr,24)
      <=> $false )
      & ( v95720(VarCurr,23)
      <=> $false )
      & ( v95720(VarCurr,22)
      <=> $false )
      & ( v95720(VarCurr,21)
      <=> $false )
      & ( v95720(VarCurr,20)
      <=> $false )
      & ( v95720(VarCurr,19)
      <=> $false )
      & ( v95720(VarCurr,18)
      <=> $false )
      & ( v95720(VarCurr,17)
      <=> $false )
      & ( v95720(VarCurr,16)
      <=> $false )
      & ( v95720(VarCurr,15)
      <=> $false )
      & ( v95720(VarCurr,14)
      <=> $false )
      & ( v95720(VarCurr,13)
      <=> $false )
      & ( v95720(VarCurr,12)
      <=> $false )
      & ( v95720(VarCurr,11)
      <=> $false )
      & ( v95720(VarCurr,10)
      <=> $false )
      & ( v95720(VarCurr,9)
      <=> $false )
      & ( v95720(VarCurr,8)
      <=> $false )
      & ( v95720(VarCurr,7)
      <=> $false )
      & ( v95720(VarCurr,6)
      <=> $false )
      & ( v95720(VarCurr,5)
      <=> $false )
      & ( v95720(VarCurr,4)
      <=> $false )
      & ( v95720(VarCurr,3)
      <=> $false )
      & ( v95720(VarCurr,2)
      <=> $false )
      & ( v95720(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_58033,axiom,
    ! [VarCurr: state_type] :
      ( v95703(VarCurr,0)
    <=> v95705(VarCurr,0) ) ).

tff(addAssignment_58032,axiom,
    ! [VarCurr: state_type] :
      ( v95705(VarCurr,0)
    <=> v95714(VarCurr,0) ) ).

tff(addAssignment_58031,axiom,
    ! [VarCurr: state_type] :
      ( v95714(VarCurr,0)
    <=> v94844(VarCurr,3) ) ).

tff(addAssignment_58030,axiom,
    ! [VarCurr: state_type] :
      ( ( v95714(VarCurr,47)
      <=> $false )
      & ( v95714(VarCurr,46)
      <=> $false )
      & ( v95714(VarCurr,45)
      <=> $false )
      & ( v95714(VarCurr,44)
      <=> $false )
      & ( v95714(VarCurr,43)
      <=> $false )
      & ( v95714(VarCurr,42)
      <=> $false )
      & ( v95714(VarCurr,41)
      <=> $false )
      & ( v95714(VarCurr,40)
      <=> $false )
      & ( v95714(VarCurr,39)
      <=> $false )
      & ( v95714(VarCurr,38)
      <=> $false )
      & ( v95714(VarCurr,37)
      <=> $false )
      & ( v95714(VarCurr,36)
      <=> $false )
      & ( v95714(VarCurr,35)
      <=> $false )
      & ( v95714(VarCurr,34)
      <=> $false )
      & ( v95714(VarCurr,33)
      <=> $false )
      & ( v95714(VarCurr,32)
      <=> $false )
      & ( v95714(VarCurr,31)
      <=> $false )
      & ( v95714(VarCurr,30)
      <=> $false )
      & ( v95714(VarCurr,29)
      <=> $false )
      & ( v95714(VarCurr,28)
      <=> $false )
      & ( v95714(VarCurr,27)
      <=> $false )
      & ( v95714(VarCurr,26)
      <=> $false )
      & ( v95714(VarCurr,25)
      <=> $false )
      & ( v95714(VarCurr,24)
      <=> $false )
      & ( v95714(VarCurr,23)
      <=> $false )
      & ( v95714(VarCurr,22)
      <=> $false )
      & ( v95714(VarCurr,21)
      <=> $false )
      & ( v95714(VarCurr,20)
      <=> $false )
      & ( v95714(VarCurr,19)
      <=> $false )
      & ( v95714(VarCurr,18)
      <=> $false )
      & ( v95714(VarCurr,17)
      <=> $false )
      & ( v95714(VarCurr,16)
      <=> $false )
      & ( v95714(VarCurr,15)
      <=> $false )
      & ( v95714(VarCurr,14)
      <=> $false )
      & ( v95714(VarCurr,13)
      <=> $false )
      & ( v95714(VarCurr,12)
      <=> $false )
      & ( v95714(VarCurr,11)
      <=> $false )
      & ( v95714(VarCurr,10)
      <=> $false )
      & ( v95714(VarCurr,9)
      <=> $false )
      & ( v95714(VarCurr,8)
      <=> $false )
      & ( v95714(VarCurr,7)
      <=> $false )
      & ( v95714(VarCurr,6)
      <=> $false )
      & ( v95714(VarCurr,5)
      <=> $false )
      & ( v95714(VarCurr,4)
      <=> $false )
      & ( v95714(VarCurr,3)
      <=> $false )
      & ( v95714(VarCurr,2)
      <=> $false )
      & ( v95714(VarCurr,1)
      <=> $false ) ) ).

tff(bitBlastConstant_1446,axiom,
    ~ b00000000000000000000000000000000000000000000000(46) ).

tff(bitBlastConstant_1445,axiom,
    ~ b00000000000000000000000000000000000000000000000(45) ).

tff(bitBlastConstant_1444,axiom,
    ~ b00000000000000000000000000000000000000000000000(44) ).

tff(bitBlastConstant_1443,axiom,
    ~ b00000000000000000000000000000000000000000000000(43) ).

tff(bitBlastConstant_1442,axiom,
    ~ b00000000000000000000000000000000000000000000000(42) ).

tff(bitBlastConstant_1441,axiom,
    ~ b00000000000000000000000000000000000000000000000(41) ).

tff(bitBlastConstant_1440,axiom,
    ~ b00000000000000000000000000000000000000000000000(40) ).

tff(bitBlastConstant_1439,axiom,
    ~ b00000000000000000000000000000000000000000000000(39) ).

tff(bitBlastConstant_1438,axiom,
    ~ b00000000000000000000000000000000000000000000000(38) ).

tff(bitBlastConstant_1437,axiom,
    ~ b00000000000000000000000000000000000000000000000(37) ).

tff(bitBlastConstant_1436,axiom,
    ~ b00000000000000000000000000000000000000000000000(36) ).

tff(bitBlastConstant_1435,axiom,
    ~ b00000000000000000000000000000000000000000000000(35) ).

tff(bitBlastConstant_1434,axiom,
    ~ b00000000000000000000000000000000000000000000000(34) ).

tff(bitBlastConstant_1433,axiom,
    ~ b00000000000000000000000000000000000000000000000(33) ).

tff(bitBlastConstant_1432,axiom,
    ~ b00000000000000000000000000000000000000000000000(32) ).

tff(bitBlastConstant_1431,axiom,
    ~ b00000000000000000000000000000000000000000000000(31) ).

tff(bitBlastConstant_1430,axiom,
    ~ b00000000000000000000000000000000000000000000000(30) ).

tff(bitBlastConstant_1429,axiom,
    ~ b00000000000000000000000000000000000000000000000(29) ).

tff(bitBlastConstant_1428,axiom,
    ~ b00000000000000000000000000000000000000000000000(28) ).

tff(bitBlastConstant_1427,axiom,
    ~ b00000000000000000000000000000000000000000000000(27) ).

tff(bitBlastConstant_1426,axiom,
    ~ b00000000000000000000000000000000000000000000000(26) ).

tff(bitBlastConstant_1425,axiom,
    ~ b00000000000000000000000000000000000000000000000(25) ).

tff(bitBlastConstant_1424,axiom,
    ~ b00000000000000000000000000000000000000000000000(24) ).

tff(bitBlastConstant_1423,axiom,
    ~ b00000000000000000000000000000000000000000000000(23) ).

tff(bitBlastConstant_1422,axiom,
    ~ b00000000000000000000000000000000000000000000000(22) ).

tff(bitBlastConstant_1421,axiom,
    ~ b00000000000000000000000000000000000000000000000(21) ).

tff(bitBlastConstant_1420,axiom,
    ~ b00000000000000000000000000000000000000000000000(20) ).

tff(bitBlastConstant_1419,axiom,
    ~ b00000000000000000000000000000000000000000000000(19) ).

tff(bitBlastConstant_1418,axiom,
    ~ b00000000000000000000000000000000000000000000000(18) ).

tff(bitBlastConstant_1417,axiom,
    ~ b00000000000000000000000000000000000000000000000(17) ).

tff(bitBlastConstant_1416,axiom,
    ~ b00000000000000000000000000000000000000000000000(16) ).

tff(bitBlastConstant_1415,axiom,
    ~ b00000000000000000000000000000000000000000000000(15) ).

tff(bitBlastConstant_1414,axiom,
    ~ b00000000000000000000000000000000000000000000000(14) ).

tff(bitBlastConstant_1413,axiom,
    ~ b00000000000000000000000000000000000000000000000(13) ).

tff(bitBlastConstant_1412,axiom,
    ~ b00000000000000000000000000000000000000000000000(12) ).

tff(bitBlastConstant_1411,axiom,
    ~ b00000000000000000000000000000000000000000000000(11) ).

tff(bitBlastConstant_1410,axiom,
    ~ b00000000000000000000000000000000000000000000000(10) ).

tff(bitBlastConstant_1409,axiom,
    ~ b00000000000000000000000000000000000000000000000(9) ).

tff(bitBlastConstant_1408,axiom,
    ~ b00000000000000000000000000000000000000000000000(8) ).

tff(bitBlastConstant_1407,axiom,
    ~ b00000000000000000000000000000000000000000000000(7) ).

tff(bitBlastConstant_1406,axiom,
    ~ b00000000000000000000000000000000000000000000000(6) ).

tff(bitBlastConstant_1405,axiom,
    ~ b00000000000000000000000000000000000000000000000(5) ).

tff(bitBlastConstant_1404,axiom,
    ~ b00000000000000000000000000000000000000000000000(4) ).

tff(bitBlastConstant_1403,axiom,
    ~ b00000000000000000000000000000000000000000000000(3) ).

tff(bitBlastConstant_1402,axiom,
    ~ b00000000000000000000000000000000000000000000000(2) ).

tff(bitBlastConstant_1401,axiom,
    ~ b00000000000000000000000000000000000000000000000(1) ).

tff(bitBlastConstant_1400,axiom,
    ~ b00000000000000000000000000000000000000000000000(0) ).

tff(addAssignment_58029,axiom,
    ! [VarCurr: state_type] :
      ( v94844(VarCurr,3)
    <=> v94846(VarCurr,31) ) ).

tff(addAssignment_58028,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,31)
    <=> v94848(VarCurr,31) ) ).

tff(addAssignment_58027,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,31)
    <=> v95707(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_1064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95708(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95707(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1064,axiom,
    ! [VarNext: state_type] :
      ( v95708(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95707(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95708(VarNext)
      <=> v95709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95709(VarNext)
      <=> ( v95711(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95711(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_58026,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,31)
    <=> v94880(VarCurr,31) ) ).

tff(addAssignment_58025,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,31)
    <=> v95101(VarCurr,31) ) ).

tff(addAssignment_58024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95675(VarCurr,B)
      <=> v95677(VarCurr,B) ) ) ).

tff(addAssignment_58023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95677(VarCurr,B)
      <=> v49399(VarCurr,B) ) ) ).

tff(addAssignment_58022,axiom,
    ! [VarCurr: state_type] :
      ( v95626(VarCurr)
    <=> v95628(VarCurr) ) ).

tff(addAssignment_58021,axiom,
    ! [VarCurr: state_type] :
      ( v95628(VarCurr)
    <=> v95630(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_503,axiom,
    ! [VarCurr: state_type] :
      ( v95630(VarCurr)
    <=> ( ( v95632(VarCurr,11)
        <=> v95636(VarCurr,11) )
        & ( v95632(VarCurr,10)
        <=> v95636(VarCurr,10) )
        & ( v95632(VarCurr,9)
        <=> v95636(VarCurr,9) )
        & ( v95632(VarCurr,8)
        <=> v95636(VarCurr,8) )
        & ( v95632(VarCurr,7)
        <=> v95636(VarCurr,7) )
        & ( v95632(VarCurr,6)
        <=> v95636(VarCurr,6) )
        & ( v95632(VarCurr,5)
        <=> v95636(VarCurr,5) )
        & ( v95632(VarCurr,4)
        <=> v95636(VarCurr,4) )
        & ( v95632(VarCurr,3)
        <=> v95636(VarCurr,3) )
        & ( v95632(VarCurr,2)
        <=> v95636(VarCurr,2) )
        & ( v95632(VarCurr,1)
        <=> v95636(VarCurr,1) )
        & ( v95632(VarCurr,0)
        <=> v95636(VarCurr,0) ) ) ) ).

tff(addAssignment_58020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95636(VarCurr,B)
      <=> v95638(VarCurr,B) ) ) ).

tff(addAssignment_58019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95638(VarCurr,B)
      <=> v95665(VarCurr,B) ) ) ).

tff(addAssignment_58018,axiom,
    ! [VarCurr: state_type] :
      ( ( v95638(VarCurr,11)
      <=> v95663(VarCurr,5) )
      & ( v95638(VarCurr,10)
      <=> v95663(VarCurr,4) )
      & ( v95638(VarCurr,9)
      <=> v95663(VarCurr,3) )
      & ( v95638(VarCurr,8)
      <=> v95663(VarCurr,2) )
      & ( v95638(VarCurr,7)
      <=> v95663(VarCurr,1) )
      & ( v95638(VarCurr,6)
      <=> v95663(VarCurr,0) ) ) ).

tff(addAssignment_58017,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,0)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58016,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,1)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58015,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,2)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58014,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,3)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58013,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,4)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58012,axiom,
    ! [VarCurr: state_type] :
      ( v95665(VarCurr,5)
    <=> v95666(VarCurr) ) ).

tff(addAssignment_58011,axiom,
    ! [VarCurr: state_type] :
      ( v95666(VarCurr)
    <=> v95640(VarCurr,0) ) ).

tff(addAssignment_58010,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,0)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58009,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,1)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58008,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,2)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58007,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,3)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58006,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,4)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58005,axiom,
    ! [VarCurr: state_type] :
      ( v95663(VarCurr,5)
    <=> v95664(VarCurr) ) ).

tff(addAssignment_58004,axiom,
    ! [VarCurr: state_type] :
      ( v95664(VarCurr)
    <=> v95640(VarCurr,1) ) ).

tff(addAssignment_58003,axiom,
    ! [VarCurr: state_type] :
      ( v95640(VarCurr,0)
    <=> v95642(VarCurr,0) ) ).

tff(addAssignment_58002,axiom,
    ! [VarCurr: state_type] :
      ( v95642(VarCurr,0)
    <=> v95644(VarCurr,0) ) ).

tff(addAssignment_58001,axiom,
    ! [VarCurr: state_type] :
      ( v95644(VarCurr,0)
    <=> v95661(VarCurr,0) ) ).

tff(addAssignment_58000,axiom,
    ! [VarCurr: state_type] :
      ( v95646(VarCurr,0)
    <=> v95648(VarCurr,0) ) ).

tff(addAssignment_57999,axiom,
    ! [VarCurr: state_type] :
      ( v95648(VarCurr,0)
    <=> v95650(VarCurr,0) ) ).

tff(addAssignment_57998,axiom,
    ! [VarCurr: state_type] :
      ( v95650(VarCurr,0)
    <=> v95659(VarCurr,0) ) ).

tff(addAssignment_57997,axiom,
    ! [VarCurr: state_type] :
      ( v95640(VarCurr,1)
    <=> v95642(VarCurr,1) ) ).

tff(addAssignment_57996,axiom,
    ! [VarCurr: state_type] :
      ( v95642(VarCurr,1)
    <=> v95644(VarCurr,1) ) ).

tff(addAssignment_57995,axiom,
    ! [VarCurr: state_type] :
      ( v95644(VarCurr,1)
    <=> v95661(VarCurr,1) ) ).

tff(writeUnaryOperator_4353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95661(VarCurr,B)
      <=> ~ v95646(VarCurr,B) ) ) ).

tff(addAssignment_57994,axiom,
    ! [VarCurr: state_type] :
      ( v95646(VarCurr,1)
    <=> v95648(VarCurr,1) ) ).

tff(addAssignment_57993,axiom,
    ! [VarCurr: state_type] :
      ( v95648(VarCurr,1)
    <=> v95650(VarCurr,1) ) ).

tff(addAssignment_57992,axiom,
    ! [VarCurr: state_type] :
      ( v95650(VarCurr,1)
    <=> v95659(VarCurr,1) ) ).

tff(addAssignment_57991,axiom,
    ! [VarCurr: state_type] :
      ( v95659(VarCurr,0)
    <=> v95660(VarCurr) ) ).

tff(addAssignment_57990,axiom,
    ! [VarCurr: state_type] :
      ( v95659(VarCurr,1)
    <=> v95660(VarCurr) ) ).

tff(addAssignment_57989,axiom,
    ! [VarCurr: state_type] :
      ( v95660(VarCurr)
    <=> v95216(VarCurr,11) ) ).

tff(addAssignment_57988,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,11)
    <=> v95218(VarCurr,11) ) ).

tff(addAssignment_57987,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,11)
    <=> v95220(VarCurr,11) ) ).

tff(addAssignment_57986,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,11)
    <=> v94846(VarCurr,27) ) ).

tff(addAssignment_57985,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,27)
    <=> v94848(VarCurr,27) ) ).

tff(addAssignment_57984,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,27)
    <=> v95652(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_1063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95653(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95652(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1063,axiom,
    ! [VarNext: state_type] :
      ( v95653(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95652(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95653(VarNext)
      <=> v95654(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95654(VarNext)
      <=> ( v95656(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95656(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57983,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,27)
    <=> v94880(VarCurr,27) ) ).

tff(addAssignment_57982,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,27)
    <=> v95101(VarCurr,27) ) ).

tff(addAssignment_57981,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,11)
    <=> v94884(VarCurr,11) ) ).

tff(addAssignment_57980,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,11)
    <=> v94886(VarCurr,11) ) ).

tff(addAssignment_57979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95632(VarCurr,B)
      <=> v95634(VarCurr,B) ) ) ).

tff(addAssignment_57978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95634(VarCurr,B)
      <=> v47849(VarCurr,B) ) ) ).

tff(addAssignment_57977,axiom,
    ! [VarCurr: state_type] :
      ( v95583(VarCurr)
    <=> v95585(VarCurr) ) ).

tff(addAssignment_57976,axiom,
    ! [VarCurr: state_type] :
      ( v95585(VarCurr)
    <=> v95587(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_502,axiom,
    ! [VarCurr: state_type] :
      ( v95587(VarCurr)
    <=> ( ( v95589(VarCurr,11)
        <=> v95593(VarCurr,11) )
        & ( v95589(VarCurr,10)
        <=> v95593(VarCurr,10) )
        & ( v95589(VarCurr,9)
        <=> v95593(VarCurr,9) )
        & ( v95589(VarCurr,8)
        <=> v95593(VarCurr,8) )
        & ( v95589(VarCurr,7)
        <=> v95593(VarCurr,7) )
        & ( v95589(VarCurr,6)
        <=> v95593(VarCurr,6) )
        & ( v95589(VarCurr,5)
        <=> v95593(VarCurr,5) )
        & ( v95589(VarCurr,4)
        <=> v95593(VarCurr,4) )
        & ( v95589(VarCurr,3)
        <=> v95593(VarCurr,3) )
        & ( v95589(VarCurr,2)
        <=> v95593(VarCurr,2) )
        & ( v95589(VarCurr,1)
        <=> v95593(VarCurr,1) )
        & ( v95589(VarCurr,0)
        <=> v95593(VarCurr,0) ) ) ) ).

tff(addAssignment_57975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95593(VarCurr,B)
      <=> v95595(VarCurr,B) ) ) ).

tff(addAssignment_57974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95595(VarCurr,B)
      <=> v95622(VarCurr,B) ) ) ).

tff(addAssignment_57973,axiom,
    ! [VarCurr: state_type] :
      ( ( v95595(VarCurr,11)
      <=> v95620(VarCurr,5) )
      & ( v95595(VarCurr,10)
      <=> v95620(VarCurr,4) )
      & ( v95595(VarCurr,9)
      <=> v95620(VarCurr,3) )
      & ( v95595(VarCurr,8)
      <=> v95620(VarCurr,2) )
      & ( v95595(VarCurr,7)
      <=> v95620(VarCurr,1) )
      & ( v95595(VarCurr,6)
      <=> v95620(VarCurr,0) ) ) ).

tff(addAssignment_57972,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,0)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57971,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,1)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57970,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,2)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57969,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,3)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57968,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,4)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57967,axiom,
    ! [VarCurr: state_type] :
      ( v95622(VarCurr,5)
    <=> v95623(VarCurr) ) ).

tff(addAssignment_57966,axiom,
    ! [VarCurr: state_type] :
      ( v95623(VarCurr)
    <=> v95597(VarCurr,0) ) ).

tff(addAssignment_57965,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,0)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57964,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,1)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57963,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,2)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57962,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,3)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57961,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,4)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57960,axiom,
    ! [VarCurr: state_type] :
      ( v95620(VarCurr,5)
    <=> v95621(VarCurr) ) ).

tff(addAssignment_57959,axiom,
    ! [VarCurr: state_type] :
      ( v95621(VarCurr)
    <=> v95597(VarCurr,1) ) ).

tff(addAssignment_57958,axiom,
    ! [VarCurr: state_type] :
      ( v95597(VarCurr,0)
    <=> v95599(VarCurr,0) ) ).

tff(addAssignment_57957,axiom,
    ! [VarCurr: state_type] :
      ( v95599(VarCurr,0)
    <=> v95601(VarCurr,0) ) ).

tff(addAssignment_57956,axiom,
    ! [VarCurr: state_type] :
      ( v95601(VarCurr,0)
    <=> v95618(VarCurr,0) ) ).

tff(addAssignment_57955,axiom,
    ! [VarCurr: state_type] :
      ( v95603(VarCurr,0)
    <=> v95605(VarCurr,0) ) ).

tff(addAssignment_57954,axiom,
    ! [VarCurr: state_type] :
      ( v95605(VarCurr,0)
    <=> v95607(VarCurr,0) ) ).

tff(addAssignment_57953,axiom,
    ! [VarCurr: state_type] :
      ( v95607(VarCurr,0)
    <=> v95616(VarCurr,0) ) ).

tff(addAssignment_57952,axiom,
    ! [VarCurr: state_type] :
      ( v95597(VarCurr,1)
    <=> v95599(VarCurr,1) ) ).

tff(addAssignment_57951,axiom,
    ! [VarCurr: state_type] :
      ( v95599(VarCurr,1)
    <=> v95601(VarCurr,1) ) ).

tff(addAssignment_57950,axiom,
    ! [VarCurr: state_type] :
      ( v95601(VarCurr,1)
    <=> v95618(VarCurr,1) ) ).

tff(writeUnaryOperator_4351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95618(VarCurr,B)
      <=> ~ v95603(VarCurr,B) ) ) ).

tff(addAssignment_57949,axiom,
    ! [VarCurr: state_type] :
      ( v95603(VarCurr,1)
    <=> v95605(VarCurr,1) ) ).

tff(addAssignment_57948,axiom,
    ! [VarCurr: state_type] :
      ( v95605(VarCurr,1)
    <=> v95607(VarCurr,1) ) ).

tff(addAssignment_57947,axiom,
    ! [VarCurr: state_type] :
      ( v95607(VarCurr,1)
    <=> v95616(VarCurr,1) ) ).

tff(addAssignment_57946,axiom,
    ! [VarCurr: state_type] :
      ( v95616(VarCurr,0)
    <=> v95617(VarCurr) ) ).

tff(addAssignment_57945,axiom,
    ! [VarCurr: state_type] :
      ( v95616(VarCurr,1)
    <=> v95617(VarCurr) ) ).

tff(addAssignment_57944,axiom,
    ! [VarCurr: state_type] :
      ( v95617(VarCurr)
    <=> v95216(VarCurr,10) ) ).

tff(addAssignment_57943,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,10)
    <=> v95218(VarCurr,10) ) ).

tff(addAssignment_57942,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,10)
    <=> v95220(VarCurr,10) ) ).

tff(addAssignment_57941,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,10)
    <=> v94846(VarCurr,26) ) ).

tff(addAssignment_57940,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,26)
    <=> v94848(VarCurr,26) ) ).

tff(addAssignment_57939,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,26)
    <=> v95609(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_1062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95610(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95609(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1062,axiom,
    ! [VarNext: state_type] :
      ( v95610(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95609(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95610(VarNext)
      <=> v95611(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95611(VarNext)
      <=> ( v95613(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95613(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57938,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,26)
    <=> v94880(VarCurr,26) ) ).

tff(addAssignment_57937,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,26)
    <=> v95101(VarCurr,26) ) ).

tff(addAssignment_57936,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,10)
    <=> v94884(VarCurr,10) ) ).

tff(addAssignment_57935,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,10)
    <=> v94886(VarCurr,10) ) ).

tff(addAssignment_57934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95589(VarCurr,B)
      <=> v95591(VarCurr,B) ) ) ).

tff(addAssignment_57933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95591(VarCurr,B)
      <=> v46299(VarCurr,B) ) ) ).

tff(addAssignment_57932,axiom,
    ! [VarCurr: state_type] :
      ( v95540(VarCurr)
    <=> v95542(VarCurr) ) ).

tff(addAssignment_57931,axiom,
    ! [VarCurr: state_type] :
      ( v95542(VarCurr)
    <=> v95544(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_501,axiom,
    ! [VarCurr: state_type] :
      ( v95544(VarCurr)
    <=> ( ( v95546(VarCurr,11)
        <=> v95550(VarCurr,11) )
        & ( v95546(VarCurr,10)
        <=> v95550(VarCurr,10) )
        & ( v95546(VarCurr,9)
        <=> v95550(VarCurr,9) )
        & ( v95546(VarCurr,8)
        <=> v95550(VarCurr,8) )
        & ( v95546(VarCurr,7)
        <=> v95550(VarCurr,7) )
        & ( v95546(VarCurr,6)
        <=> v95550(VarCurr,6) )
        & ( v95546(VarCurr,5)
        <=> v95550(VarCurr,5) )
        & ( v95546(VarCurr,4)
        <=> v95550(VarCurr,4) )
        & ( v95546(VarCurr,3)
        <=> v95550(VarCurr,3) )
        & ( v95546(VarCurr,2)
        <=> v95550(VarCurr,2) )
        & ( v95546(VarCurr,1)
        <=> v95550(VarCurr,1) )
        & ( v95546(VarCurr,0)
        <=> v95550(VarCurr,0) ) ) ) ).

tff(addAssignment_57930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95550(VarCurr,B)
      <=> v95552(VarCurr,B) ) ) ).

tff(addAssignment_57929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95552(VarCurr,B)
      <=> v95579(VarCurr,B) ) ) ).

tff(addAssignment_57928,axiom,
    ! [VarCurr: state_type] :
      ( ( v95552(VarCurr,11)
      <=> v95577(VarCurr,5) )
      & ( v95552(VarCurr,10)
      <=> v95577(VarCurr,4) )
      & ( v95552(VarCurr,9)
      <=> v95577(VarCurr,3) )
      & ( v95552(VarCurr,8)
      <=> v95577(VarCurr,2) )
      & ( v95552(VarCurr,7)
      <=> v95577(VarCurr,1) )
      & ( v95552(VarCurr,6)
      <=> v95577(VarCurr,0) ) ) ).

tff(addAssignment_57927,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,0)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57926,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,1)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57925,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,2)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57924,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,3)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57923,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,4)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57922,axiom,
    ! [VarCurr: state_type] :
      ( v95579(VarCurr,5)
    <=> v95580(VarCurr) ) ).

tff(addAssignment_57921,axiom,
    ! [VarCurr: state_type] :
      ( v95580(VarCurr)
    <=> v95554(VarCurr,0) ) ).

tff(addAssignment_57920,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,0)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57919,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,1)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57918,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,2)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57917,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,3)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57916,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,4)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57915,axiom,
    ! [VarCurr: state_type] :
      ( v95577(VarCurr,5)
    <=> v95578(VarCurr) ) ).

tff(addAssignment_57914,axiom,
    ! [VarCurr: state_type] :
      ( v95578(VarCurr)
    <=> v95554(VarCurr,1) ) ).

tff(addAssignment_57913,axiom,
    ! [VarCurr: state_type] :
      ( v95554(VarCurr,0)
    <=> v95556(VarCurr,0) ) ).

tff(addAssignment_57912,axiom,
    ! [VarCurr: state_type] :
      ( v95556(VarCurr,0)
    <=> v95558(VarCurr,0) ) ).

tff(addAssignment_57911,axiom,
    ! [VarCurr: state_type] :
      ( v95558(VarCurr,0)
    <=> v95575(VarCurr,0) ) ).

tff(addAssignment_57910,axiom,
    ! [VarCurr: state_type] :
      ( v95560(VarCurr,0)
    <=> v95562(VarCurr,0) ) ).

tff(addAssignment_57909,axiom,
    ! [VarCurr: state_type] :
      ( v95562(VarCurr,0)
    <=> v95564(VarCurr,0) ) ).

tff(addAssignment_57908,axiom,
    ! [VarCurr: state_type] :
      ( v95564(VarCurr,0)
    <=> v95573(VarCurr,0) ) ).

tff(addAssignment_57907,axiom,
    ! [VarCurr: state_type] :
      ( v95554(VarCurr,1)
    <=> v95556(VarCurr,1) ) ).

tff(addAssignment_57906,axiom,
    ! [VarCurr: state_type] :
      ( v95556(VarCurr,1)
    <=> v95558(VarCurr,1) ) ).

tff(addAssignment_57905,axiom,
    ! [VarCurr: state_type] :
      ( v95558(VarCurr,1)
    <=> v95575(VarCurr,1) ) ).

tff(writeUnaryOperator_4349,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95575(VarCurr,B)
      <=> ~ v95560(VarCurr,B) ) ) ).

tff(addAssignment_57904,axiom,
    ! [VarCurr: state_type] :
      ( v95560(VarCurr,1)
    <=> v95562(VarCurr,1) ) ).

tff(addAssignment_57903,axiom,
    ! [VarCurr: state_type] :
      ( v95562(VarCurr,1)
    <=> v95564(VarCurr,1) ) ).

tff(addAssignment_57902,axiom,
    ! [VarCurr: state_type] :
      ( v95564(VarCurr,1)
    <=> v95573(VarCurr,1) ) ).

tff(addAssignment_57901,axiom,
    ! [VarCurr: state_type] :
      ( v95573(VarCurr,0)
    <=> v95574(VarCurr) ) ).

tff(addAssignment_57900,axiom,
    ! [VarCurr: state_type] :
      ( v95573(VarCurr,1)
    <=> v95574(VarCurr) ) ).

tff(addAssignment_57899,axiom,
    ! [VarCurr: state_type] :
      ( v95574(VarCurr)
    <=> v95216(VarCurr,9) ) ).

tff(addAssignment_57898,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,9)
    <=> v95218(VarCurr,9) ) ).

tff(addAssignment_57897,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,9)
    <=> v95220(VarCurr,9) ) ).

tff(addAssignment_57896,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,9)
    <=> v94846(VarCurr,25) ) ).

tff(addAssignment_57895,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,25)
    <=> v94848(VarCurr,25) ) ).

tff(addAssignment_57894,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,25)
    <=> v95566(VarNext,25) ) ).

tff(addCaseBooleanConditionEqualRanges1_1061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95567(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95566(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1061,axiom,
    ! [VarNext: state_type] :
      ( v95567(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95566(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95567(VarNext)
      <=> v95568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95568(VarNext)
      <=> ( v95570(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95570(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57893,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,25)
    <=> v94880(VarCurr,25) ) ).

tff(addAssignment_57892,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,25)
    <=> v95101(VarCurr,25) ) ).

tff(addAssignment_57891,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,9)
    <=> v94884(VarCurr,9) ) ).

tff(addAssignment_57890,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,9)
    <=> v94886(VarCurr,9) ) ).

tff(addAssignment_57889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95546(VarCurr,B)
      <=> v95548(VarCurr,B) ) ) ).

tff(addAssignment_57888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95548(VarCurr,B)
      <=> v44749(VarCurr,B) ) ) ).

tff(addAssignment_57887,axiom,
    ! [VarCurr: state_type] :
      ( v95497(VarCurr)
    <=> v95499(VarCurr) ) ).

tff(addAssignment_57886,axiom,
    ! [VarCurr: state_type] :
      ( v95499(VarCurr)
    <=> v95501(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_500,axiom,
    ! [VarCurr: state_type] :
      ( v95501(VarCurr)
    <=> ( ( v95503(VarCurr,11)
        <=> v95507(VarCurr,11) )
        & ( v95503(VarCurr,10)
        <=> v95507(VarCurr,10) )
        & ( v95503(VarCurr,9)
        <=> v95507(VarCurr,9) )
        & ( v95503(VarCurr,8)
        <=> v95507(VarCurr,8) )
        & ( v95503(VarCurr,7)
        <=> v95507(VarCurr,7) )
        & ( v95503(VarCurr,6)
        <=> v95507(VarCurr,6) )
        & ( v95503(VarCurr,5)
        <=> v95507(VarCurr,5) )
        & ( v95503(VarCurr,4)
        <=> v95507(VarCurr,4) )
        & ( v95503(VarCurr,3)
        <=> v95507(VarCurr,3) )
        & ( v95503(VarCurr,2)
        <=> v95507(VarCurr,2) )
        & ( v95503(VarCurr,1)
        <=> v95507(VarCurr,1) )
        & ( v95503(VarCurr,0)
        <=> v95507(VarCurr,0) ) ) ) ).

tff(addAssignment_57885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95507(VarCurr,B)
      <=> v95509(VarCurr,B) ) ) ).

tff(addAssignment_57884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95509(VarCurr,B)
      <=> v95536(VarCurr,B) ) ) ).

tff(addAssignment_57883,axiom,
    ! [VarCurr: state_type] :
      ( ( v95509(VarCurr,11)
      <=> v95534(VarCurr,5) )
      & ( v95509(VarCurr,10)
      <=> v95534(VarCurr,4) )
      & ( v95509(VarCurr,9)
      <=> v95534(VarCurr,3) )
      & ( v95509(VarCurr,8)
      <=> v95534(VarCurr,2) )
      & ( v95509(VarCurr,7)
      <=> v95534(VarCurr,1) )
      & ( v95509(VarCurr,6)
      <=> v95534(VarCurr,0) ) ) ).

tff(addAssignment_57882,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,0)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57881,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,1)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57880,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,2)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57879,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,3)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57878,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,4)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57877,axiom,
    ! [VarCurr: state_type] :
      ( v95536(VarCurr,5)
    <=> v95537(VarCurr) ) ).

tff(addAssignment_57876,axiom,
    ! [VarCurr: state_type] :
      ( v95537(VarCurr)
    <=> v95511(VarCurr,0) ) ).

tff(addAssignment_57875,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,0)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57874,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,1)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57873,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,2)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57872,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,3)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57871,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,4)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57870,axiom,
    ! [VarCurr: state_type] :
      ( v95534(VarCurr,5)
    <=> v95535(VarCurr) ) ).

tff(addAssignment_57869,axiom,
    ! [VarCurr: state_type] :
      ( v95535(VarCurr)
    <=> v95511(VarCurr,1) ) ).

tff(addAssignment_57868,axiom,
    ! [VarCurr: state_type] :
      ( v95511(VarCurr,0)
    <=> v95513(VarCurr,0) ) ).

tff(addAssignment_57867,axiom,
    ! [VarCurr: state_type] :
      ( v95513(VarCurr,0)
    <=> v95515(VarCurr,0) ) ).

tff(addAssignment_57866,axiom,
    ! [VarCurr: state_type] :
      ( v95515(VarCurr,0)
    <=> v95532(VarCurr,0) ) ).

tff(addAssignment_57865,axiom,
    ! [VarCurr: state_type] :
      ( v95517(VarCurr,0)
    <=> v95519(VarCurr,0) ) ).

tff(addAssignment_57864,axiom,
    ! [VarCurr: state_type] :
      ( v95519(VarCurr,0)
    <=> v95521(VarCurr,0) ) ).

tff(addAssignment_57863,axiom,
    ! [VarCurr: state_type] :
      ( v95521(VarCurr,0)
    <=> v95530(VarCurr,0) ) ).

tff(addAssignment_57862,axiom,
    ! [VarCurr: state_type] :
      ( v95511(VarCurr,1)
    <=> v95513(VarCurr,1) ) ).

tff(addAssignment_57861,axiom,
    ! [VarCurr: state_type] :
      ( v95513(VarCurr,1)
    <=> v95515(VarCurr,1) ) ).

tff(addAssignment_57860,axiom,
    ! [VarCurr: state_type] :
      ( v95515(VarCurr,1)
    <=> v95532(VarCurr,1) ) ).

tff(writeUnaryOperator_4347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95532(VarCurr,B)
      <=> ~ v95517(VarCurr,B) ) ) ).

tff(addAssignment_57859,axiom,
    ! [VarCurr: state_type] :
      ( v95517(VarCurr,1)
    <=> v95519(VarCurr,1) ) ).

tff(addAssignment_57858,axiom,
    ! [VarCurr: state_type] :
      ( v95519(VarCurr,1)
    <=> v95521(VarCurr,1) ) ).

tff(addAssignment_57857,axiom,
    ! [VarCurr: state_type] :
      ( v95521(VarCurr,1)
    <=> v95530(VarCurr,1) ) ).

tff(addAssignment_57856,axiom,
    ! [VarCurr: state_type] :
      ( v95530(VarCurr,0)
    <=> v95531(VarCurr) ) ).

tff(addAssignment_57855,axiom,
    ! [VarCurr: state_type] :
      ( v95530(VarCurr,1)
    <=> v95531(VarCurr) ) ).

tff(addAssignment_57854,axiom,
    ! [VarCurr: state_type] :
      ( v95531(VarCurr)
    <=> v95216(VarCurr,8) ) ).

tff(addAssignment_57853,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,8)
    <=> v95218(VarCurr,8) ) ).

tff(addAssignment_57852,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,8)
    <=> v95220(VarCurr,8) ) ).

tff(addAssignment_57851,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,8)
    <=> v94846(VarCurr,24) ) ).

tff(addAssignment_57850,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,24)
    <=> v94848(VarCurr,24) ) ).

tff(addAssignment_57849,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,24)
    <=> v95523(VarNext,24) ) ).

tff(addCaseBooleanConditionEqualRanges1_1060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95524(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95523(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1060,axiom,
    ! [VarNext: state_type] :
      ( v95524(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95523(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95524(VarNext)
      <=> v95525(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95525(VarNext)
      <=> ( v95527(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95527(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57848,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,24)
    <=> v94880(VarCurr,24) ) ).

tff(addAssignment_57847,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,24)
    <=> v95101(VarCurr,24) ) ).

tff(addAssignment_57846,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,8)
    <=> v94884(VarCurr,8) ) ).

tff(addAssignment_57845,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,8)
    <=> v94886(VarCurr,8) ) ).

tff(addAssignment_57844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95503(VarCurr,B)
      <=> v95505(VarCurr,B) ) ) ).

tff(addAssignment_57843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95505(VarCurr,B)
      <=> v43199(VarCurr,B) ) ) ).

tff(addAssignment_57842,axiom,
    ! [VarCurr: state_type] :
      ( v95454(VarCurr)
    <=> v95456(VarCurr) ) ).

tff(addAssignment_57841,axiom,
    ! [VarCurr: state_type] :
      ( v95456(VarCurr)
    <=> v95458(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_499,axiom,
    ! [VarCurr: state_type] :
      ( v95458(VarCurr)
    <=> ( ( v95460(VarCurr,11)
        <=> v95464(VarCurr,11) )
        & ( v95460(VarCurr,10)
        <=> v95464(VarCurr,10) )
        & ( v95460(VarCurr,9)
        <=> v95464(VarCurr,9) )
        & ( v95460(VarCurr,8)
        <=> v95464(VarCurr,8) )
        & ( v95460(VarCurr,7)
        <=> v95464(VarCurr,7) )
        & ( v95460(VarCurr,6)
        <=> v95464(VarCurr,6) )
        & ( v95460(VarCurr,5)
        <=> v95464(VarCurr,5) )
        & ( v95460(VarCurr,4)
        <=> v95464(VarCurr,4) )
        & ( v95460(VarCurr,3)
        <=> v95464(VarCurr,3) )
        & ( v95460(VarCurr,2)
        <=> v95464(VarCurr,2) )
        & ( v95460(VarCurr,1)
        <=> v95464(VarCurr,1) )
        & ( v95460(VarCurr,0)
        <=> v95464(VarCurr,0) ) ) ) ).

tff(addAssignment_57840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95464(VarCurr,B)
      <=> v95466(VarCurr,B) ) ) ).

tff(addAssignment_57839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95466(VarCurr,B)
      <=> v95493(VarCurr,B) ) ) ).

tff(addAssignment_57838,axiom,
    ! [VarCurr: state_type] :
      ( ( v95466(VarCurr,11)
      <=> v95491(VarCurr,5) )
      & ( v95466(VarCurr,10)
      <=> v95491(VarCurr,4) )
      & ( v95466(VarCurr,9)
      <=> v95491(VarCurr,3) )
      & ( v95466(VarCurr,8)
      <=> v95491(VarCurr,2) )
      & ( v95466(VarCurr,7)
      <=> v95491(VarCurr,1) )
      & ( v95466(VarCurr,6)
      <=> v95491(VarCurr,0) ) ) ).

tff(addAssignment_57837,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,0)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57836,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,1)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57835,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,2)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57834,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,3)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57833,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,4)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57832,axiom,
    ! [VarCurr: state_type] :
      ( v95493(VarCurr,5)
    <=> v95494(VarCurr) ) ).

tff(addAssignment_57831,axiom,
    ! [VarCurr: state_type] :
      ( v95494(VarCurr)
    <=> v95468(VarCurr,0) ) ).

tff(addAssignment_57830,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,0)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57829,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,1)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57828,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,2)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57827,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,3)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57826,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,4)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57825,axiom,
    ! [VarCurr: state_type] :
      ( v95491(VarCurr,5)
    <=> v95492(VarCurr) ) ).

tff(addAssignment_57824,axiom,
    ! [VarCurr: state_type] :
      ( v95492(VarCurr)
    <=> v95468(VarCurr,1) ) ).

tff(addAssignment_57823,axiom,
    ! [VarCurr: state_type] :
      ( v95468(VarCurr,0)
    <=> v95470(VarCurr,0) ) ).

tff(addAssignment_57822,axiom,
    ! [VarCurr: state_type] :
      ( v95470(VarCurr,0)
    <=> v95472(VarCurr,0) ) ).

tff(addAssignment_57821,axiom,
    ! [VarCurr: state_type] :
      ( v95472(VarCurr,0)
    <=> v95489(VarCurr,0) ) ).

tff(addAssignment_57820,axiom,
    ! [VarCurr: state_type] :
      ( v95474(VarCurr,0)
    <=> v95476(VarCurr,0) ) ).

tff(addAssignment_57819,axiom,
    ! [VarCurr: state_type] :
      ( v95476(VarCurr,0)
    <=> v95478(VarCurr,0) ) ).

tff(addAssignment_57818,axiom,
    ! [VarCurr: state_type] :
      ( v95478(VarCurr,0)
    <=> v95487(VarCurr,0) ) ).

tff(addAssignment_57817,axiom,
    ! [VarCurr: state_type] :
      ( v95468(VarCurr,1)
    <=> v95470(VarCurr,1) ) ).

tff(addAssignment_57816,axiom,
    ! [VarCurr: state_type] :
      ( v95470(VarCurr,1)
    <=> v95472(VarCurr,1) ) ).

tff(addAssignment_57815,axiom,
    ! [VarCurr: state_type] :
      ( v95472(VarCurr,1)
    <=> v95489(VarCurr,1) ) ).

tff(writeUnaryOperator_4345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95489(VarCurr,B)
      <=> ~ v95474(VarCurr,B) ) ) ).

tff(addAssignment_57814,axiom,
    ! [VarCurr: state_type] :
      ( v95474(VarCurr,1)
    <=> v95476(VarCurr,1) ) ).

tff(addAssignment_57813,axiom,
    ! [VarCurr: state_type] :
      ( v95476(VarCurr,1)
    <=> v95478(VarCurr,1) ) ).

tff(addAssignment_57812,axiom,
    ! [VarCurr: state_type] :
      ( v95478(VarCurr,1)
    <=> v95487(VarCurr,1) ) ).

tff(addAssignment_57811,axiom,
    ! [VarCurr: state_type] :
      ( v95487(VarCurr,0)
    <=> v95488(VarCurr) ) ).

tff(addAssignment_57810,axiom,
    ! [VarCurr: state_type] :
      ( v95487(VarCurr,1)
    <=> v95488(VarCurr) ) ).

tff(addAssignment_57809,axiom,
    ! [VarCurr: state_type] :
      ( v95488(VarCurr)
    <=> v95216(VarCurr,7) ) ).

tff(addAssignment_57808,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,7)
    <=> v95218(VarCurr,7) ) ).

tff(addAssignment_57807,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,7)
    <=> v95220(VarCurr,7) ) ).

tff(addAssignment_57806,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,7)
    <=> v94846(VarCurr,23) ) ).

tff(addAssignment_57805,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,23)
    <=> v94848(VarCurr,23) ) ).

tff(addAssignment_57804,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,23)
    <=> v95480(VarNext,23) ) ).

tff(addCaseBooleanConditionEqualRanges1_1059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95481(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95480(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1059,axiom,
    ! [VarNext: state_type] :
      ( v95481(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95480(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95481(VarNext)
      <=> v95482(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95482(VarNext)
      <=> ( v95484(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95484(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57803,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,23)
    <=> v94880(VarCurr,23) ) ).

tff(addAssignment_57802,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,23)
    <=> v95101(VarCurr,23) ) ).

tff(addAssignment_57801,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,7)
    <=> v94884(VarCurr,7) ) ).

tff(addAssignment_57800,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,7)
    <=> v94886(VarCurr,7) ) ).

tff(addAssignment_57799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95460(VarCurr,B)
      <=> v95462(VarCurr,B) ) ) ).

tff(addAssignment_57798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95462(VarCurr,B)
      <=> v41649(VarCurr,B) ) ) ).

tff(addAssignment_57797,axiom,
    ! [VarCurr: state_type] :
      ( v95411(VarCurr)
    <=> v95413(VarCurr) ) ).

tff(addAssignment_57796,axiom,
    ! [VarCurr: state_type] :
      ( v95413(VarCurr)
    <=> v95415(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_498,axiom,
    ! [VarCurr: state_type] :
      ( v95415(VarCurr)
    <=> ( ( v95417(VarCurr,11)
        <=> v95421(VarCurr,11) )
        & ( v95417(VarCurr,10)
        <=> v95421(VarCurr,10) )
        & ( v95417(VarCurr,9)
        <=> v95421(VarCurr,9) )
        & ( v95417(VarCurr,8)
        <=> v95421(VarCurr,8) )
        & ( v95417(VarCurr,7)
        <=> v95421(VarCurr,7) )
        & ( v95417(VarCurr,6)
        <=> v95421(VarCurr,6) )
        & ( v95417(VarCurr,5)
        <=> v95421(VarCurr,5) )
        & ( v95417(VarCurr,4)
        <=> v95421(VarCurr,4) )
        & ( v95417(VarCurr,3)
        <=> v95421(VarCurr,3) )
        & ( v95417(VarCurr,2)
        <=> v95421(VarCurr,2) )
        & ( v95417(VarCurr,1)
        <=> v95421(VarCurr,1) )
        & ( v95417(VarCurr,0)
        <=> v95421(VarCurr,0) ) ) ) ).

tff(addAssignment_57795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95421(VarCurr,B)
      <=> v95423(VarCurr,B) ) ) ).

tff(addAssignment_57794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95423(VarCurr,B)
      <=> v95450(VarCurr,B) ) ) ).

tff(addAssignment_57793,axiom,
    ! [VarCurr: state_type] :
      ( ( v95423(VarCurr,11)
      <=> v95448(VarCurr,5) )
      & ( v95423(VarCurr,10)
      <=> v95448(VarCurr,4) )
      & ( v95423(VarCurr,9)
      <=> v95448(VarCurr,3) )
      & ( v95423(VarCurr,8)
      <=> v95448(VarCurr,2) )
      & ( v95423(VarCurr,7)
      <=> v95448(VarCurr,1) )
      & ( v95423(VarCurr,6)
      <=> v95448(VarCurr,0) ) ) ).

tff(addAssignment_57792,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,0)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57791,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,1)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57790,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,2)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57789,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,3)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57788,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,4)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57787,axiom,
    ! [VarCurr: state_type] :
      ( v95450(VarCurr,5)
    <=> v95451(VarCurr) ) ).

tff(addAssignment_57786,axiom,
    ! [VarCurr: state_type] :
      ( v95451(VarCurr)
    <=> v95425(VarCurr,0) ) ).

tff(addAssignment_57785,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,0)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57784,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,1)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57783,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,2)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57782,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,3)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57781,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,4)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57780,axiom,
    ! [VarCurr: state_type] :
      ( v95448(VarCurr,5)
    <=> v95449(VarCurr) ) ).

tff(addAssignment_57779,axiom,
    ! [VarCurr: state_type] :
      ( v95449(VarCurr)
    <=> v95425(VarCurr,1) ) ).

tff(addAssignment_57778,axiom,
    ! [VarCurr: state_type] :
      ( v95425(VarCurr,0)
    <=> v95427(VarCurr,0) ) ).

tff(addAssignment_57777,axiom,
    ! [VarCurr: state_type] :
      ( v95427(VarCurr,0)
    <=> v95429(VarCurr,0) ) ).

tff(addAssignment_57776,axiom,
    ! [VarCurr: state_type] :
      ( v95429(VarCurr,0)
    <=> v95446(VarCurr,0) ) ).

tff(addAssignment_57775,axiom,
    ! [VarCurr: state_type] :
      ( v95431(VarCurr,0)
    <=> v95433(VarCurr,0) ) ).

tff(addAssignment_57774,axiom,
    ! [VarCurr: state_type] :
      ( v95433(VarCurr,0)
    <=> v95435(VarCurr,0) ) ).

tff(addAssignment_57773,axiom,
    ! [VarCurr: state_type] :
      ( v95435(VarCurr,0)
    <=> v95444(VarCurr,0) ) ).

tff(addAssignment_57772,axiom,
    ! [VarCurr: state_type] :
      ( v95425(VarCurr,1)
    <=> v95427(VarCurr,1) ) ).

tff(addAssignment_57771,axiom,
    ! [VarCurr: state_type] :
      ( v95427(VarCurr,1)
    <=> v95429(VarCurr,1) ) ).

tff(addAssignment_57770,axiom,
    ! [VarCurr: state_type] :
      ( v95429(VarCurr,1)
    <=> v95446(VarCurr,1) ) ).

tff(writeUnaryOperator_4343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95446(VarCurr,B)
      <=> ~ v95431(VarCurr,B) ) ) ).

tff(addAssignment_57769,axiom,
    ! [VarCurr: state_type] :
      ( v95431(VarCurr,1)
    <=> v95433(VarCurr,1) ) ).

tff(addAssignment_57768,axiom,
    ! [VarCurr: state_type] :
      ( v95433(VarCurr,1)
    <=> v95435(VarCurr,1) ) ).

tff(addAssignment_57767,axiom,
    ! [VarCurr: state_type] :
      ( v95435(VarCurr,1)
    <=> v95444(VarCurr,1) ) ).

tff(addAssignment_57766,axiom,
    ! [VarCurr: state_type] :
      ( v95444(VarCurr,0)
    <=> v95445(VarCurr) ) ).

tff(addAssignment_57765,axiom,
    ! [VarCurr: state_type] :
      ( v95444(VarCurr,1)
    <=> v95445(VarCurr) ) ).

tff(addAssignment_57764,axiom,
    ! [VarCurr: state_type] :
      ( v95445(VarCurr)
    <=> v95216(VarCurr,6) ) ).

tff(addAssignment_57763,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,6)
    <=> v95218(VarCurr,6) ) ).

tff(addAssignment_57762,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,6)
    <=> v95220(VarCurr,6) ) ).

tff(addAssignment_57761,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,6)
    <=> v94846(VarCurr,22) ) ).

tff(addAssignment_57760,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,22)
    <=> v94848(VarCurr,22) ) ).

tff(addAssignment_57759,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,22)
    <=> v95437(VarNext,22) ) ).

tff(addCaseBooleanConditionEqualRanges1_1058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95438(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95437(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1058,axiom,
    ! [VarNext: state_type] :
      ( v95438(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95437(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95438(VarNext)
      <=> v95439(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95439(VarNext)
      <=> ( v95441(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95441(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57758,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,22)
    <=> v94880(VarCurr,22) ) ).

tff(addAssignment_57757,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,22)
    <=> v95101(VarCurr,22) ) ).

tff(addAssignment_57756,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,6)
    <=> v94884(VarCurr,6) ) ).

tff(addAssignment_57755,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,6)
    <=> v94886(VarCurr,6) ) ).

tff(addAssignment_57754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95417(VarCurr,B)
      <=> v95419(VarCurr,B) ) ) ).

tff(addAssignment_57753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95419(VarCurr,B)
      <=> v40099(VarCurr,B) ) ) ).

tff(addAssignment_57752,axiom,
    ! [VarCurr: state_type] :
      ( v95368(VarCurr)
    <=> v95370(VarCurr) ) ).

tff(addAssignment_57751,axiom,
    ! [VarCurr: state_type] :
      ( v95370(VarCurr)
    <=> v95372(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_497,axiom,
    ! [VarCurr: state_type] :
      ( v95372(VarCurr)
    <=> ( ( v95374(VarCurr,11)
        <=> v95378(VarCurr,11) )
        & ( v95374(VarCurr,10)
        <=> v95378(VarCurr,10) )
        & ( v95374(VarCurr,9)
        <=> v95378(VarCurr,9) )
        & ( v95374(VarCurr,8)
        <=> v95378(VarCurr,8) )
        & ( v95374(VarCurr,7)
        <=> v95378(VarCurr,7) )
        & ( v95374(VarCurr,6)
        <=> v95378(VarCurr,6) )
        & ( v95374(VarCurr,5)
        <=> v95378(VarCurr,5) )
        & ( v95374(VarCurr,4)
        <=> v95378(VarCurr,4) )
        & ( v95374(VarCurr,3)
        <=> v95378(VarCurr,3) )
        & ( v95374(VarCurr,2)
        <=> v95378(VarCurr,2) )
        & ( v95374(VarCurr,1)
        <=> v95378(VarCurr,1) )
        & ( v95374(VarCurr,0)
        <=> v95378(VarCurr,0) ) ) ) ).

tff(addAssignment_57750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95378(VarCurr,B)
      <=> v95380(VarCurr,B) ) ) ).

tff(addAssignment_57749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95380(VarCurr,B)
      <=> v95407(VarCurr,B) ) ) ).

tff(addAssignment_57748,axiom,
    ! [VarCurr: state_type] :
      ( ( v95380(VarCurr,11)
      <=> v95405(VarCurr,5) )
      & ( v95380(VarCurr,10)
      <=> v95405(VarCurr,4) )
      & ( v95380(VarCurr,9)
      <=> v95405(VarCurr,3) )
      & ( v95380(VarCurr,8)
      <=> v95405(VarCurr,2) )
      & ( v95380(VarCurr,7)
      <=> v95405(VarCurr,1) )
      & ( v95380(VarCurr,6)
      <=> v95405(VarCurr,0) ) ) ).

tff(addAssignment_57747,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,0)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57746,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,1)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57745,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,2)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57744,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,3)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57743,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,4)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57742,axiom,
    ! [VarCurr: state_type] :
      ( v95407(VarCurr,5)
    <=> v95408(VarCurr) ) ).

tff(addAssignment_57741,axiom,
    ! [VarCurr: state_type] :
      ( v95408(VarCurr)
    <=> v95382(VarCurr,0) ) ).

tff(addAssignment_57740,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,0)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57739,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,1)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57738,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,2)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57737,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,3)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57736,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,4)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57735,axiom,
    ! [VarCurr: state_type] :
      ( v95405(VarCurr,5)
    <=> v95406(VarCurr) ) ).

tff(addAssignment_57734,axiom,
    ! [VarCurr: state_type] :
      ( v95406(VarCurr)
    <=> v95382(VarCurr,1) ) ).

tff(addAssignment_57733,axiom,
    ! [VarCurr: state_type] :
      ( v95382(VarCurr,0)
    <=> v95384(VarCurr,0) ) ).

tff(addAssignment_57732,axiom,
    ! [VarCurr: state_type] :
      ( v95384(VarCurr,0)
    <=> v95386(VarCurr,0) ) ).

tff(addAssignment_57731,axiom,
    ! [VarCurr: state_type] :
      ( v95386(VarCurr,0)
    <=> v95403(VarCurr,0) ) ).

tff(addAssignment_57730,axiom,
    ! [VarCurr: state_type] :
      ( v95388(VarCurr,0)
    <=> v95390(VarCurr,0) ) ).

tff(addAssignment_57729,axiom,
    ! [VarCurr: state_type] :
      ( v95390(VarCurr,0)
    <=> v95392(VarCurr,0) ) ).

tff(addAssignment_57728,axiom,
    ! [VarCurr: state_type] :
      ( v95392(VarCurr,0)
    <=> v95401(VarCurr,0) ) ).

tff(addAssignment_57727,axiom,
    ! [VarCurr: state_type] :
      ( v95382(VarCurr,1)
    <=> v95384(VarCurr,1) ) ).

tff(addAssignment_57726,axiom,
    ! [VarCurr: state_type] :
      ( v95384(VarCurr,1)
    <=> v95386(VarCurr,1) ) ).

tff(addAssignment_57725,axiom,
    ! [VarCurr: state_type] :
      ( v95386(VarCurr,1)
    <=> v95403(VarCurr,1) ) ).

tff(writeUnaryOperator_4341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95403(VarCurr,B)
      <=> ~ v95388(VarCurr,B) ) ) ).

tff(addAssignment_57724,axiom,
    ! [VarCurr: state_type] :
      ( v95388(VarCurr,1)
    <=> v95390(VarCurr,1) ) ).

tff(addAssignment_57723,axiom,
    ! [VarCurr: state_type] :
      ( v95390(VarCurr,1)
    <=> v95392(VarCurr,1) ) ).

tff(addAssignment_57722,axiom,
    ! [VarCurr: state_type] :
      ( v95392(VarCurr,1)
    <=> v95401(VarCurr,1) ) ).

tff(addAssignment_57721,axiom,
    ! [VarCurr: state_type] :
      ( v95401(VarCurr,0)
    <=> v95402(VarCurr) ) ).

tff(addAssignment_57720,axiom,
    ! [VarCurr: state_type] :
      ( v95401(VarCurr,1)
    <=> v95402(VarCurr) ) ).

tff(addAssignment_57719,axiom,
    ! [VarCurr: state_type] :
      ( v95402(VarCurr)
    <=> v95216(VarCurr,5) ) ).

tff(addAssignment_57718,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,5)
    <=> v95218(VarCurr,5) ) ).

tff(addAssignment_57717,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,5)
    <=> v95220(VarCurr,5) ) ).

tff(addAssignment_57716,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,5)
    <=> v94846(VarCurr,21) ) ).

tff(addAssignment_57715,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,21)
    <=> v94848(VarCurr,21) ) ).

tff(addAssignment_57714,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,21)
    <=> v95394(VarNext,21) ) ).

tff(addCaseBooleanConditionEqualRanges1_1057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95395(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95394(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1057,axiom,
    ! [VarNext: state_type] :
      ( v95395(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95394(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95395(VarNext)
      <=> v95396(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95396(VarNext)
      <=> ( v95398(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95398(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57713,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,21)
    <=> v94880(VarCurr,21) ) ).

tff(addAssignment_57712,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,21)
    <=> v95101(VarCurr,21) ) ).

tff(addAssignment_57711,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,5)
    <=> v94884(VarCurr,5) ) ).

tff(addAssignment_57710,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,5)
    <=> v94886(VarCurr,5) ) ).

tff(addAssignment_57709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95374(VarCurr,B)
      <=> v95376(VarCurr,B) ) ) ).

tff(addAssignment_57708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95376(VarCurr,B)
      <=> v38549(VarCurr,B) ) ) ).

tff(addAssignment_57707,axiom,
    ! [VarCurr: state_type] :
      ( v95325(VarCurr)
    <=> v95327(VarCurr) ) ).

tff(addAssignment_57706,axiom,
    ! [VarCurr: state_type] :
      ( v95327(VarCurr)
    <=> v95329(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_496,axiom,
    ! [VarCurr: state_type] :
      ( v95329(VarCurr)
    <=> ( ( v95331(VarCurr,11)
        <=> v95335(VarCurr,11) )
        & ( v95331(VarCurr,10)
        <=> v95335(VarCurr,10) )
        & ( v95331(VarCurr,9)
        <=> v95335(VarCurr,9) )
        & ( v95331(VarCurr,8)
        <=> v95335(VarCurr,8) )
        & ( v95331(VarCurr,7)
        <=> v95335(VarCurr,7) )
        & ( v95331(VarCurr,6)
        <=> v95335(VarCurr,6) )
        & ( v95331(VarCurr,5)
        <=> v95335(VarCurr,5) )
        & ( v95331(VarCurr,4)
        <=> v95335(VarCurr,4) )
        & ( v95331(VarCurr,3)
        <=> v95335(VarCurr,3) )
        & ( v95331(VarCurr,2)
        <=> v95335(VarCurr,2) )
        & ( v95331(VarCurr,1)
        <=> v95335(VarCurr,1) )
        & ( v95331(VarCurr,0)
        <=> v95335(VarCurr,0) ) ) ) ).

tff(addAssignment_57705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95335(VarCurr,B)
      <=> v95337(VarCurr,B) ) ) ).

tff(addAssignment_57704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95337(VarCurr,B)
      <=> v95364(VarCurr,B) ) ) ).

tff(addAssignment_57703,axiom,
    ! [VarCurr: state_type] :
      ( ( v95337(VarCurr,11)
      <=> v95362(VarCurr,5) )
      & ( v95337(VarCurr,10)
      <=> v95362(VarCurr,4) )
      & ( v95337(VarCurr,9)
      <=> v95362(VarCurr,3) )
      & ( v95337(VarCurr,8)
      <=> v95362(VarCurr,2) )
      & ( v95337(VarCurr,7)
      <=> v95362(VarCurr,1) )
      & ( v95337(VarCurr,6)
      <=> v95362(VarCurr,0) ) ) ).

tff(addAssignment_57702,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,0)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57701,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,1)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57700,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,2)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57699,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,3)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57698,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,4)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57697,axiom,
    ! [VarCurr: state_type] :
      ( v95364(VarCurr,5)
    <=> v95365(VarCurr) ) ).

tff(addAssignment_57696,axiom,
    ! [VarCurr: state_type] :
      ( v95365(VarCurr)
    <=> v95339(VarCurr,0) ) ).

tff(addAssignment_57695,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,0)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57694,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,1)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57693,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,2)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57692,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,3)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57691,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,4)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57690,axiom,
    ! [VarCurr: state_type] :
      ( v95362(VarCurr,5)
    <=> v95363(VarCurr) ) ).

tff(addAssignment_57689,axiom,
    ! [VarCurr: state_type] :
      ( v95363(VarCurr)
    <=> v95339(VarCurr,1) ) ).

tff(addAssignment_57688,axiom,
    ! [VarCurr: state_type] :
      ( v95339(VarCurr,0)
    <=> v95341(VarCurr,0) ) ).

tff(addAssignment_57687,axiom,
    ! [VarCurr: state_type] :
      ( v95341(VarCurr,0)
    <=> v95343(VarCurr,0) ) ).

tff(addAssignment_57686,axiom,
    ! [VarCurr: state_type] :
      ( v95343(VarCurr,0)
    <=> v95360(VarCurr,0) ) ).

tff(addAssignment_57685,axiom,
    ! [VarCurr: state_type] :
      ( v95345(VarCurr,0)
    <=> v95347(VarCurr,0) ) ).

tff(addAssignment_57684,axiom,
    ! [VarCurr: state_type] :
      ( v95347(VarCurr,0)
    <=> v95349(VarCurr,0) ) ).

tff(addAssignment_57683,axiom,
    ! [VarCurr: state_type] :
      ( v95349(VarCurr,0)
    <=> v95358(VarCurr,0) ) ).

tff(addAssignment_57682,axiom,
    ! [VarCurr: state_type] :
      ( v95339(VarCurr,1)
    <=> v95341(VarCurr,1) ) ).

tff(addAssignment_57681,axiom,
    ! [VarCurr: state_type] :
      ( v95341(VarCurr,1)
    <=> v95343(VarCurr,1) ) ).

tff(addAssignment_57680,axiom,
    ! [VarCurr: state_type] :
      ( v95343(VarCurr,1)
    <=> v95360(VarCurr,1) ) ).

tff(writeUnaryOperator_4339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95360(VarCurr,B)
      <=> ~ v95345(VarCurr,B) ) ) ).

tff(addAssignment_57679,axiom,
    ! [VarCurr: state_type] :
      ( v95345(VarCurr,1)
    <=> v95347(VarCurr,1) ) ).

tff(addAssignment_57678,axiom,
    ! [VarCurr: state_type] :
      ( v95347(VarCurr,1)
    <=> v95349(VarCurr,1) ) ).

tff(addAssignment_57677,axiom,
    ! [VarCurr: state_type] :
      ( v95349(VarCurr,1)
    <=> v95358(VarCurr,1) ) ).

tff(addAssignment_57676,axiom,
    ! [VarCurr: state_type] :
      ( v95358(VarCurr,0)
    <=> v95359(VarCurr) ) ).

tff(addAssignment_57675,axiom,
    ! [VarCurr: state_type] :
      ( v95358(VarCurr,1)
    <=> v95359(VarCurr) ) ).

tff(addAssignment_57674,axiom,
    ! [VarCurr: state_type] :
      ( v95359(VarCurr)
    <=> v95216(VarCurr,4) ) ).

tff(addAssignment_57673,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,4)
    <=> v95218(VarCurr,4) ) ).

tff(addAssignment_57672,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,4)
    <=> v95220(VarCurr,4) ) ).

tff(addAssignment_57671,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,4)
    <=> v94846(VarCurr,20) ) ).

tff(addAssignment_57670,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,20)
    <=> v94848(VarCurr,20) ) ).

tff(addAssignment_57669,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,20)
    <=> v95351(VarNext,20) ) ).

tff(addCaseBooleanConditionEqualRanges1_1056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95352(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95351(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1056,axiom,
    ! [VarNext: state_type] :
      ( v95352(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95351(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95352(VarNext)
      <=> v95353(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95353(VarNext)
      <=> ( v95355(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95355(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57668,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,20)
    <=> v94880(VarCurr,20) ) ).

tff(addAssignment_57667,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,20)
    <=> v95101(VarCurr,20) ) ).

tff(addAssignment_57666,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,4)
    <=> v94884(VarCurr,4) ) ).

tff(addAssignment_57665,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,4)
    <=> v94886(VarCurr,4) ) ).

tff(addAssignment_57664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95331(VarCurr,B)
      <=> v95333(VarCurr,B) ) ) ).

tff(addAssignment_57663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95333(VarCurr,B)
      <=> v36999(VarCurr,B) ) ) ).

tff(addAssignment_57662,axiom,
    ! [VarCurr: state_type] :
      ( v95282(VarCurr)
    <=> v95284(VarCurr) ) ).

tff(addAssignment_57661,axiom,
    ! [VarCurr: state_type] :
      ( v95284(VarCurr)
    <=> v95286(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_495,axiom,
    ! [VarCurr: state_type] :
      ( v95286(VarCurr)
    <=> ( ( v95288(VarCurr,11)
        <=> v95292(VarCurr,11) )
        & ( v95288(VarCurr,10)
        <=> v95292(VarCurr,10) )
        & ( v95288(VarCurr,9)
        <=> v95292(VarCurr,9) )
        & ( v95288(VarCurr,8)
        <=> v95292(VarCurr,8) )
        & ( v95288(VarCurr,7)
        <=> v95292(VarCurr,7) )
        & ( v95288(VarCurr,6)
        <=> v95292(VarCurr,6) )
        & ( v95288(VarCurr,5)
        <=> v95292(VarCurr,5) )
        & ( v95288(VarCurr,4)
        <=> v95292(VarCurr,4) )
        & ( v95288(VarCurr,3)
        <=> v95292(VarCurr,3) )
        & ( v95288(VarCurr,2)
        <=> v95292(VarCurr,2) )
        & ( v95288(VarCurr,1)
        <=> v95292(VarCurr,1) )
        & ( v95288(VarCurr,0)
        <=> v95292(VarCurr,0) ) ) ) ).

tff(addAssignment_57660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95292(VarCurr,B)
      <=> v95294(VarCurr,B) ) ) ).

tff(addAssignment_57659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95294(VarCurr,B)
      <=> v95321(VarCurr,B) ) ) ).

tff(addAssignment_57658,axiom,
    ! [VarCurr: state_type] :
      ( ( v95294(VarCurr,11)
      <=> v95319(VarCurr,5) )
      & ( v95294(VarCurr,10)
      <=> v95319(VarCurr,4) )
      & ( v95294(VarCurr,9)
      <=> v95319(VarCurr,3) )
      & ( v95294(VarCurr,8)
      <=> v95319(VarCurr,2) )
      & ( v95294(VarCurr,7)
      <=> v95319(VarCurr,1) )
      & ( v95294(VarCurr,6)
      <=> v95319(VarCurr,0) ) ) ).

tff(addAssignment_57657,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,0)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57656,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,1)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57655,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,2)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57654,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,3)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57653,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,4)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57652,axiom,
    ! [VarCurr: state_type] :
      ( v95321(VarCurr,5)
    <=> v95322(VarCurr) ) ).

tff(addAssignment_57651,axiom,
    ! [VarCurr: state_type] :
      ( v95322(VarCurr)
    <=> v95296(VarCurr,0) ) ).

tff(addAssignment_57650,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,0)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57649,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,1)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57648,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,2)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57647,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,3)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57646,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,4)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57645,axiom,
    ! [VarCurr: state_type] :
      ( v95319(VarCurr,5)
    <=> v95320(VarCurr) ) ).

tff(addAssignment_57644,axiom,
    ! [VarCurr: state_type] :
      ( v95320(VarCurr)
    <=> v95296(VarCurr,1) ) ).

tff(addAssignment_57643,axiom,
    ! [VarCurr: state_type] :
      ( v95296(VarCurr,0)
    <=> v95298(VarCurr,0) ) ).

tff(addAssignment_57642,axiom,
    ! [VarCurr: state_type] :
      ( v95298(VarCurr,0)
    <=> v95300(VarCurr,0) ) ).

tff(addAssignment_57641,axiom,
    ! [VarCurr: state_type] :
      ( v95300(VarCurr,0)
    <=> v95317(VarCurr,0) ) ).

tff(addAssignment_57640,axiom,
    ! [VarCurr: state_type] :
      ( v95302(VarCurr,0)
    <=> v95304(VarCurr,0) ) ).

tff(addAssignment_57639,axiom,
    ! [VarCurr: state_type] :
      ( v95304(VarCurr,0)
    <=> v95306(VarCurr,0) ) ).

tff(addAssignment_57638,axiom,
    ! [VarCurr: state_type] :
      ( v95306(VarCurr,0)
    <=> v95315(VarCurr,0) ) ).

tff(addAssignment_57637,axiom,
    ! [VarCurr: state_type] :
      ( v95296(VarCurr,1)
    <=> v95298(VarCurr,1) ) ).

tff(addAssignment_57636,axiom,
    ! [VarCurr: state_type] :
      ( v95298(VarCurr,1)
    <=> v95300(VarCurr,1) ) ).

tff(addAssignment_57635,axiom,
    ! [VarCurr: state_type] :
      ( v95300(VarCurr,1)
    <=> v95317(VarCurr,1) ) ).

tff(writeUnaryOperator_4337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95317(VarCurr,B)
      <=> ~ v95302(VarCurr,B) ) ) ).

tff(addAssignment_57634,axiom,
    ! [VarCurr: state_type] :
      ( v95302(VarCurr,1)
    <=> v95304(VarCurr,1) ) ).

tff(addAssignment_57633,axiom,
    ! [VarCurr: state_type] :
      ( v95304(VarCurr,1)
    <=> v95306(VarCurr,1) ) ).

tff(addAssignment_57632,axiom,
    ! [VarCurr: state_type] :
      ( v95306(VarCurr,1)
    <=> v95315(VarCurr,1) ) ).

tff(addAssignment_57631,axiom,
    ! [VarCurr: state_type] :
      ( v95315(VarCurr,0)
    <=> v95316(VarCurr) ) ).

tff(addAssignment_57630,axiom,
    ! [VarCurr: state_type] :
      ( v95315(VarCurr,1)
    <=> v95316(VarCurr) ) ).

tff(addAssignment_57629,axiom,
    ! [VarCurr: state_type] :
      ( v95316(VarCurr)
    <=> v95216(VarCurr,3) ) ).

tff(addAssignment_57628,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,3)
    <=> v95218(VarCurr,3) ) ).

tff(addAssignment_57627,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,3)
    <=> v95220(VarCurr,3) ) ).

tff(addAssignment_57626,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,3)
    <=> v94846(VarCurr,19) ) ).

tff(addAssignment_57625,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,19)
    <=> v94848(VarCurr,19) ) ).

tff(addAssignment_57624,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,19)
    <=> v95308(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_1055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95309(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95308(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1055,axiom,
    ! [VarNext: state_type] :
      ( v95309(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95308(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95309(VarNext)
      <=> v95310(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95310(VarNext)
      <=> ( v95312(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95312(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57623,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,19)
    <=> v94880(VarCurr,19) ) ).

tff(addAssignment_57622,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,19)
    <=> v95101(VarCurr,19) ) ).

tff(addAssignment_57621,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,3)
    <=> v94884(VarCurr,3) ) ).

tff(addAssignment_57620,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,3)
    <=> v94886(VarCurr,3) ) ).

tff(addAssignment_57619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95288(VarCurr,B)
      <=> v95290(VarCurr,B) ) ) ).

tff(addAssignment_57618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95290(VarCurr,B)
      <=> v35449(VarCurr,B) ) ) ).

tff(addAssignment_57617,axiom,
    ! [VarCurr: state_type] :
      ( v95239(VarCurr)
    <=> v95241(VarCurr) ) ).

tff(addAssignment_57616,axiom,
    ! [VarCurr: state_type] :
      ( v95241(VarCurr)
    <=> v95243(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_494,axiom,
    ! [VarCurr: state_type] :
      ( v95243(VarCurr)
    <=> ( ( v95245(VarCurr,11)
        <=> v95249(VarCurr,11) )
        & ( v95245(VarCurr,10)
        <=> v95249(VarCurr,10) )
        & ( v95245(VarCurr,9)
        <=> v95249(VarCurr,9) )
        & ( v95245(VarCurr,8)
        <=> v95249(VarCurr,8) )
        & ( v95245(VarCurr,7)
        <=> v95249(VarCurr,7) )
        & ( v95245(VarCurr,6)
        <=> v95249(VarCurr,6) )
        & ( v95245(VarCurr,5)
        <=> v95249(VarCurr,5) )
        & ( v95245(VarCurr,4)
        <=> v95249(VarCurr,4) )
        & ( v95245(VarCurr,3)
        <=> v95249(VarCurr,3) )
        & ( v95245(VarCurr,2)
        <=> v95249(VarCurr,2) )
        & ( v95245(VarCurr,1)
        <=> v95249(VarCurr,1) )
        & ( v95245(VarCurr,0)
        <=> v95249(VarCurr,0) ) ) ) ).

tff(addAssignment_57615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95249(VarCurr,B)
      <=> v95251(VarCurr,B) ) ) ).

tff(addAssignment_57614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95251(VarCurr,B)
      <=> v95278(VarCurr,B) ) ) ).

tff(addAssignment_57613,axiom,
    ! [VarCurr: state_type] :
      ( ( v95251(VarCurr,11)
      <=> v95276(VarCurr,5) )
      & ( v95251(VarCurr,10)
      <=> v95276(VarCurr,4) )
      & ( v95251(VarCurr,9)
      <=> v95276(VarCurr,3) )
      & ( v95251(VarCurr,8)
      <=> v95276(VarCurr,2) )
      & ( v95251(VarCurr,7)
      <=> v95276(VarCurr,1) )
      & ( v95251(VarCurr,6)
      <=> v95276(VarCurr,0) ) ) ).

tff(addAssignment_57612,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,0)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57611,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,1)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57610,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,2)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57609,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,3)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57608,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,4)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57607,axiom,
    ! [VarCurr: state_type] :
      ( v95278(VarCurr,5)
    <=> v95279(VarCurr) ) ).

tff(addAssignment_57606,axiom,
    ! [VarCurr: state_type] :
      ( v95279(VarCurr)
    <=> v95253(VarCurr,0) ) ).

tff(addAssignment_57605,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,0)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57604,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,1)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57603,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,2)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57602,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,3)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57601,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,4)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57600,axiom,
    ! [VarCurr: state_type] :
      ( v95276(VarCurr,5)
    <=> v95277(VarCurr) ) ).

tff(addAssignment_57599,axiom,
    ! [VarCurr: state_type] :
      ( v95277(VarCurr)
    <=> v95253(VarCurr,1) ) ).

tff(addAssignment_57598,axiom,
    ! [VarCurr: state_type] :
      ( v95253(VarCurr,0)
    <=> v95255(VarCurr,0) ) ).

tff(addAssignment_57597,axiom,
    ! [VarCurr: state_type] :
      ( v95255(VarCurr,0)
    <=> v95257(VarCurr,0) ) ).

tff(addAssignment_57596,axiom,
    ! [VarCurr: state_type] :
      ( v95257(VarCurr,0)
    <=> v95274(VarCurr,0) ) ).

tff(addAssignment_57595,axiom,
    ! [VarCurr: state_type] :
      ( v95259(VarCurr,0)
    <=> v95261(VarCurr,0) ) ).

tff(addAssignment_57594,axiom,
    ! [VarCurr: state_type] :
      ( v95261(VarCurr,0)
    <=> v95263(VarCurr,0) ) ).

tff(addAssignment_57593,axiom,
    ! [VarCurr: state_type] :
      ( v95263(VarCurr,0)
    <=> v95272(VarCurr,0) ) ).

tff(addAssignment_57592,axiom,
    ! [VarCurr: state_type] :
      ( v95253(VarCurr,1)
    <=> v95255(VarCurr,1) ) ).

tff(addAssignment_57591,axiom,
    ! [VarCurr: state_type] :
      ( v95255(VarCurr,1)
    <=> v95257(VarCurr,1) ) ).

tff(addAssignment_57590,axiom,
    ! [VarCurr: state_type] :
      ( v95257(VarCurr,1)
    <=> v95274(VarCurr,1) ) ).

tff(writeUnaryOperator_4335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95274(VarCurr,B)
      <=> ~ v95259(VarCurr,B) ) ) ).

tff(addAssignment_57589,axiom,
    ! [VarCurr: state_type] :
      ( v95259(VarCurr,1)
    <=> v95261(VarCurr,1) ) ).

tff(addAssignment_57588,axiom,
    ! [VarCurr: state_type] :
      ( v95261(VarCurr,1)
    <=> v95263(VarCurr,1) ) ).

tff(addAssignment_57587,axiom,
    ! [VarCurr: state_type] :
      ( v95263(VarCurr,1)
    <=> v95272(VarCurr,1) ) ).

tff(addAssignment_57586,axiom,
    ! [VarCurr: state_type] :
      ( v95272(VarCurr,0)
    <=> v95273(VarCurr) ) ).

tff(addAssignment_57585,axiom,
    ! [VarCurr: state_type] :
      ( v95272(VarCurr,1)
    <=> v95273(VarCurr) ) ).

tff(addAssignment_57584,axiom,
    ! [VarCurr: state_type] :
      ( v95273(VarCurr)
    <=> v95216(VarCurr,2) ) ).

tff(addAssignment_57583,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,2)
    <=> v95218(VarCurr,2) ) ).

tff(addAssignment_57582,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,2)
    <=> v95220(VarCurr,2) ) ).

tff(addAssignment_57581,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,2)
    <=> v94846(VarCurr,18) ) ).

tff(addAssignment_57580,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,18)
    <=> v94848(VarCurr,18) ) ).

tff(addAssignment_57579,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,18)
    <=> v95265(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_1054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95266(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95265(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1054,axiom,
    ! [VarNext: state_type] :
      ( v95266(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95265(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95266(VarNext)
      <=> v95267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95267(VarNext)
      <=> ( v95269(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95269(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57578,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,18)
    <=> v94880(VarCurr,18) ) ).

tff(addAssignment_57577,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,18)
    <=> v95101(VarCurr,18) ) ).

tff(addAssignment_57576,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,2)
    <=> v94884(VarCurr,2) ) ).

tff(addAssignment_57575,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,2)
    <=> v94886(VarCurr,2) ) ).

tff(addAssignment_57574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95245(VarCurr,B)
      <=> v95247(VarCurr,B) ) ) ).

tff(addAssignment_57573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95247(VarCurr,B)
      <=> v8510(VarCurr,B) ) ) ).

tff(addAssignment_57572,axiom,
    ! [VarCurr: state_type] :
      ( v95190(VarCurr)
    <=> v95192(VarCurr) ) ).

tff(addAssignment_57571,axiom,
    ! [VarCurr: state_type] :
      ( v95192(VarCurr)
    <=> v95194(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_493,axiom,
    ! [VarCurr: state_type] :
      ( v95194(VarCurr)
    <=> ( ( v95196(VarCurr,11)
        <=> v95200(VarCurr,11) )
        & ( v95196(VarCurr,10)
        <=> v95200(VarCurr,10) )
        & ( v95196(VarCurr,9)
        <=> v95200(VarCurr,9) )
        & ( v95196(VarCurr,8)
        <=> v95200(VarCurr,8) )
        & ( v95196(VarCurr,7)
        <=> v95200(VarCurr,7) )
        & ( v95196(VarCurr,6)
        <=> v95200(VarCurr,6) )
        & ( v95196(VarCurr,5)
        <=> v95200(VarCurr,5) )
        & ( v95196(VarCurr,4)
        <=> v95200(VarCurr,4) )
        & ( v95196(VarCurr,3)
        <=> v95200(VarCurr,3) )
        & ( v95196(VarCurr,2)
        <=> v95200(VarCurr,2) )
        & ( v95196(VarCurr,1)
        <=> v95200(VarCurr,1) )
        & ( v95196(VarCurr,0)
        <=> v95200(VarCurr,0) ) ) ) ).

tff(addAssignment_57570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95200(VarCurr,B)
      <=> v95202(VarCurr,B) ) ) ).

tff(addAssignment_57569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v95202(VarCurr,B)
      <=> v95235(VarCurr,B) ) ) ).

tff(addAssignment_57568,axiom,
    ! [VarCurr: state_type] :
      ( ( v95202(VarCurr,11)
      <=> v95233(VarCurr,5) )
      & ( v95202(VarCurr,10)
      <=> v95233(VarCurr,4) )
      & ( v95202(VarCurr,9)
      <=> v95233(VarCurr,3) )
      & ( v95202(VarCurr,8)
      <=> v95233(VarCurr,2) )
      & ( v95202(VarCurr,7)
      <=> v95233(VarCurr,1) )
      & ( v95202(VarCurr,6)
      <=> v95233(VarCurr,0) ) ) ).

tff(addAssignment_57567,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,0)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57566,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,1)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57565,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,2)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57564,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,3)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57563,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,4)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57562,axiom,
    ! [VarCurr: state_type] :
      ( v95235(VarCurr,5)
    <=> v95236(VarCurr) ) ).

tff(addAssignment_57561,axiom,
    ! [VarCurr: state_type] :
      ( v95236(VarCurr)
    <=> v95204(VarCurr,0) ) ).

tff(addAssignment_57560,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,0)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57559,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,1)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57558,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,2)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57557,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,3)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57556,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,4)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57555,axiom,
    ! [VarCurr: state_type] :
      ( v95233(VarCurr,5)
    <=> v95234(VarCurr) ) ).

tff(addAssignment_57554,axiom,
    ! [VarCurr: state_type] :
      ( v95234(VarCurr)
    <=> v95204(VarCurr,1) ) ).

tff(addAssignment_57553,axiom,
    ! [VarCurr: state_type] :
      ( v95204(VarCurr,0)
    <=> v95206(VarCurr,0) ) ).

tff(addAssignment_57552,axiom,
    ! [VarCurr: state_type] :
      ( v95206(VarCurr,0)
    <=> v95208(VarCurr,0) ) ).

tff(addAssignment_57551,axiom,
    ! [VarCurr: state_type] :
      ( v95208(VarCurr,0)
    <=> v95231(VarCurr,0) ) ).

tff(addAssignment_57550,axiom,
    ! [VarCurr: state_type] :
      ( v95210(VarCurr,0)
    <=> v95212(VarCurr,0) ) ).

tff(addAssignment_57549,axiom,
    ! [VarCurr: state_type] :
      ( v95212(VarCurr,0)
    <=> v95214(VarCurr,0) ) ).

tff(addAssignment_57548,axiom,
    ! [VarCurr: state_type] :
      ( v95214(VarCurr,0)
    <=> v95229(VarCurr,0) ) ).

tff(addAssignment_57547,axiom,
    ! [VarCurr: state_type] :
      ( v95204(VarCurr,1)
    <=> v95206(VarCurr,1) ) ).

tff(addAssignment_57546,axiom,
    ! [VarCurr: state_type] :
      ( v95206(VarCurr,1)
    <=> v95208(VarCurr,1) ) ).

tff(addAssignment_57545,axiom,
    ! [VarCurr: state_type] :
      ( v95208(VarCurr,1)
    <=> v95231(VarCurr,1) ) ).

tff(writeUnaryOperator_4333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95231(VarCurr,B)
      <=> ~ v95210(VarCurr,B) ) ) ).

tff(addAssignment_57544,axiom,
    ! [VarCurr: state_type] :
      ( v95210(VarCurr,1)
    <=> v95212(VarCurr,1) ) ).

tff(addAssignment_57543,axiom,
    ! [VarCurr: state_type] :
      ( v95212(VarCurr,1)
    <=> v95214(VarCurr,1) ) ).

tff(addAssignment_57542,axiom,
    ! [VarCurr: state_type] :
      ( v95214(VarCurr,1)
    <=> v95229(VarCurr,1) ) ).

tff(addAssignment_57541,axiom,
    ! [VarCurr: state_type] :
      ( v95229(VarCurr,0)
    <=> v95230(VarCurr) ) ).

tff(addAssignment_57540,axiom,
    ! [VarCurr: state_type] :
      ( v95229(VarCurr,1)
    <=> v95230(VarCurr) ) ).

tff(addAssignment_57539,axiom,
    ! [VarCurr: state_type] :
      ( v95230(VarCurr)
    <=> v95216(VarCurr,1) ) ).

tff(addAssignment_57538,axiom,
    ! [VarCurr: state_type] :
      ( v95216(VarCurr,1)
    <=> v95218(VarCurr,1) ) ).

tff(addAssignment_57537,axiom,
    ! [VarCurr: state_type] :
      ( v95218(VarCurr,1)
    <=> v95220(VarCurr,1) ) ).

tff(addAssignment_57536,axiom,
    ! [VarCurr: state_type] :
      ( v95220(VarCurr,1)
    <=> v94846(VarCurr,17) ) ).

tff(addAssignment_57535,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,17)
    <=> v94848(VarCurr,17) ) ).

tff(addAssignment_57534,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,17)
    <=> v95222(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_1053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95223(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95222(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1053,axiom,
    ! [VarNext: state_type] :
      ( v95223(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95222(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95223(VarNext)
      <=> v95224(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95224(VarNext)
      <=> ( v95226(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95226(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57533,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,17)
    <=> v94880(VarCurr,17) ) ).

tff(addAssignment_57532,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,17)
    <=> v95101(VarCurr,17) ) ).

tff(addAssignment_57531,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,1)
    <=> v94884(VarCurr,1) ) ).

tff(addAssignment_57530,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,1)
    <=> v94886(VarCurr,1) ) ).

tff(addAssignment_57529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95196(VarCurr,B)
      <=> v95198(VarCurr,B) ) ) ).

tff(addAssignment_57528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v95198(VarCurr,B)
      <=> v6242(VarCurr,B) ) ) ).

tff(addAssignment_57527,axiom,
    ! [VarCurr: state_type] :
      ( v94814(VarCurr)
    <=> v94816(VarCurr) ) ).

tff(addAssignment_57526,axiom,
    ! [VarCurr: state_type] :
      ( v94816(VarCurr)
    <=> v94818(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_492,axiom,
    ! [VarCurr: state_type] :
      ( v94818(VarCurr)
    <=> ( ( v94820(VarCurr,11)
        <=> v94824(VarCurr,11) )
        & ( v94820(VarCurr,10)
        <=> v94824(VarCurr,10) )
        & ( v94820(VarCurr,9)
        <=> v94824(VarCurr,9) )
        & ( v94820(VarCurr,8)
        <=> v94824(VarCurr,8) )
        & ( v94820(VarCurr,7)
        <=> v94824(VarCurr,7) )
        & ( v94820(VarCurr,6)
        <=> v94824(VarCurr,6) )
        & ( v94820(VarCurr,5)
        <=> v94824(VarCurr,5) )
        & ( v94820(VarCurr,4)
        <=> v94824(VarCurr,4) )
        & ( v94820(VarCurr,3)
        <=> v94824(VarCurr,3) )
        & ( v94820(VarCurr,2)
        <=> v94824(VarCurr,2) )
        & ( v94820(VarCurr,1)
        <=> v94824(VarCurr,1) )
        & ( v94820(VarCurr,0)
        <=> v94824(VarCurr,0) ) ) ) ).

tff(addAssignment_57525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94824(VarCurr,B)
      <=> v94826(VarCurr,B) ) ) ).

tff(addAssignment_57524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v94826(VarCurr,B)
      <=> v95186(VarCurr,B) ) ) ).

tff(addAssignment_57523,axiom,
    ! [VarCurr: state_type] :
      ( ( v94826(VarCurr,11)
      <=> v95184(VarCurr,5) )
      & ( v94826(VarCurr,10)
      <=> v95184(VarCurr,4) )
      & ( v94826(VarCurr,9)
      <=> v95184(VarCurr,3) )
      & ( v94826(VarCurr,8)
      <=> v95184(VarCurr,2) )
      & ( v94826(VarCurr,7)
      <=> v95184(VarCurr,1) )
      & ( v94826(VarCurr,6)
      <=> v95184(VarCurr,0) ) ) ).

tff(addAssignment_57522,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,0)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57521,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,1)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57520,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,2)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57519,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,3)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57518,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,4)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57517,axiom,
    ! [VarCurr: state_type] :
      ( v95186(VarCurr,5)
    <=> v95187(VarCurr) ) ).

tff(addAssignment_57516,axiom,
    ! [VarCurr: state_type] :
      ( v95187(VarCurr)
    <=> v94828(VarCurr,0) ) ).

tff(addAssignment_57515,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,0)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57514,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,1)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57513,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,2)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57512,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,3)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57511,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,4)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57510,axiom,
    ! [VarCurr: state_type] :
      ( v95184(VarCurr,5)
    <=> v95185(VarCurr) ) ).

tff(addAssignment_57509,axiom,
    ! [VarCurr: state_type] :
      ( v95185(VarCurr)
    <=> v94828(VarCurr,1) ) ).

tff(addAssignment_57508,axiom,
    ! [VarCurr: state_type] :
      ( v94828(VarCurr,0)
    <=> v94830(VarCurr,0) ) ).

tff(addAssignment_57507,axiom,
    ! [VarCurr: state_type] :
      ( v94830(VarCurr,0)
    <=> v94832(VarCurr,0) ) ).

tff(addAssignment_57506,axiom,
    ! [VarCurr: state_type] :
      ( v94832(VarCurr,0)
    <=> v95182(VarCurr,0) ) ).

tff(addAssignment_57505,axiom,
    ! [VarCurr: state_type] :
      ( v94834(VarCurr,0)
    <=> v94836(VarCurr,0) ) ).

tff(addAssignment_57504,axiom,
    ! [VarCurr: state_type] :
      ( v94836(VarCurr,0)
    <=> v94838(VarCurr,0) ) ).

tff(addAssignment_57503,axiom,
    ! [VarCurr: state_type] :
      ( v94838(VarCurr,0)
    <=> v95180(VarCurr,0) ) ).

tff(addAssignment_57502,axiom,
    ! [VarCurr: state_type] :
      ( v94828(VarCurr,1)
    <=> v94830(VarCurr,1) ) ).

tff(addAssignment_57501,axiom,
    ! [VarCurr: state_type] :
      ( v94830(VarCurr,1)
    <=> v94832(VarCurr,1) ) ).

tff(addAssignment_57500,axiom,
    ! [VarCurr: state_type] :
      ( v94832(VarCurr,1)
    <=> v95182(VarCurr,1) ) ).

tff(writeUnaryOperator_4331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v95182(VarCurr,B)
      <=> ~ v94834(VarCurr,B) ) ) ).

tff(addAssignment_57499,axiom,
    ! [VarCurr: state_type] :
      ( v94834(VarCurr,1)
    <=> v94836(VarCurr,1) ) ).

tff(addAssignment_57498,axiom,
    ! [VarCurr: state_type] :
      ( v94836(VarCurr,1)
    <=> v94838(VarCurr,1) ) ).

tff(addAssignment_57497,axiom,
    ! [VarCurr: state_type] :
      ( v94838(VarCurr,1)
    <=> v95180(VarCurr,1) ) ).

tff(addAssignment_57496,axiom,
    ! [VarCurr: state_type] :
      ( v95180(VarCurr,0)
    <=> v95181(VarCurr) ) ).

tff(addAssignment_57495,axiom,
    ! [VarCurr: state_type] :
      ( v95180(VarCurr,1)
    <=> v95181(VarCurr) ) ).

tff(addAssignment_57494,axiom,
    ! [VarCurr: state_type] :
      ( v95181(VarCurr)
    <=> v94840(VarCurr,0) ) ).

tff(addAssignment_57493,axiom,
    ! [VarCurr: state_type] :
      ( v94840(VarCurr,0)
    <=> v94842(VarCurr,0) ) ).

tff(addAssignment_57492,axiom,
    ! [VarCurr: state_type] :
      ( v94842(VarCurr,0)
    <=> v94844(VarCurr,0) ) ).

tff(addAssignment_57491,axiom,
    ! [VarCurr: state_type] :
      ( v94844(VarCurr,0)
    <=> v94846(VarCurr,28) ) ).

tff(addAssignment_57490,axiom,
    ! [VarCurr: state_type] :
      ( v94846(VarCurr,28)
    <=> v94848(VarCurr,28) ) ).

tff(addAssignment_57489,axiom,
    ! [VarNext: state_type] :
      ( v94848(VarNext,28)
    <=> v95163(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_1052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v95163(VarNext,B)
            <=> v94848(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1052,axiom,
    ! [VarNext: state_type] :
      ( v95164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95163(VarNext,B)
          <=> v95174(VarNext,B) ) ) ) ).

tff(addAssignment_57488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95174(VarNext,B)
          <=> v95172(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95172(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_573,axiom,
    ! [VarCurr: state_type] :
      ( v95175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v95172(VarCurr,B)
          <=> v94878(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8758,axiom,
    ! [VarCurr: state_type] :
      ( v95175(VarCurr)
    <=> ( v95176(VarCurr)
        & v95177(VarCurr) ) ) ).

tff(writeUnaryOperator_4330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95177(VarCurr)
    <=> v94864(VarCurr) ) ).

tff(writeUnaryOperator_4329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95176(VarCurr)
    <=> v94850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95164(VarNext)
      <=> v95165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95165(VarNext)
      <=> ( v95166(VarNext)
          & v95106(VarNext) ) ) ) ).

tff(writeUnaryOperator_4328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95166(VarNext)
      <=> v95168(VarNext) ) ) ).

tff(addAssignment_57487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95168(VarNext)
      <=> v95106(VarCurr) ) ) ).

tff(addAssignment_57486,axiom,
    ! [VarCurr: state_type] :
      ( v95106(VarCurr)
    <=> v95108(VarCurr) ) ).

tff(addAssignment_57485,axiom,
    ! [VarCurr: state_type] :
      ( v95108(VarCurr)
    <=> v95110(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8755,axiom,
    ! [VarCurr: state_type] :
      ( v95110(VarCurr)
    <=> ( v95161(VarCurr)
        | v95153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8754,axiom,
    ! [VarCurr: state_type] :
      ( v95161(VarCurr)
    <=> ( v95112(VarCurr)
        & v95118(VarCurr) ) ) ).

tff(addAssignment_57484,axiom,
    ! [VarCurr: state_type] :
      ( v95153(VarCurr)
    <=> v95155(VarCurr) ) ).

tff(addAssignment_57483,axiom,
    ! [VarCurr: state_type] :
      ( v95155(VarCurr)
    <=> v95157(VarCurr) ) ).

tff(addAssignment_57482,axiom,
    ! [VarCurr: state_type] :
      ( v95157(VarCurr)
    <=> v95159(VarCurr) ) ).

tff(addAssignment_57481,axiom,
    ! [VarCurr: state_type] :
      ( v95159(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95137(VarNext)
       => ( v95118(VarNext)
        <=> v95118(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1051,axiom,
    ! [VarNext: state_type] :
      ( v95137(VarNext)
     => ( v95118(VarNext)
      <=> v95147(VarNext) ) ) ).

tff(addAssignment_57480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95147(VarNext)
      <=> v95145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8753,axiom,
    ! [VarCurr: state_type] :
      ( v95145(VarCurr)
    <=> ( v95148(VarCurr)
        & v95149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8752,axiom,
    ! [VarCurr: state_type] :
      ( v95149(VarCurr)
    <=> ( v95124(VarCurr)
        | v95128(VarCurr) ) ) ).

tff(writeUnaryOperator_4327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95148(VarCurr)
    <=> v95120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95137(VarNext)
      <=> v95138(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95138(VarNext)
      <=> ( v95140(VarNext)
          & v95142(VarNext) ) ) ) ).

tff(writeUnaryOperator_4326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95142(VarCurr)
    <=> v95112(VarCurr) ) ).

tff(addAssignment_57479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95140(VarNext)
      <=> v95112(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_244,axiom,
    ( v95118(constB0)
  <=> $true ) ).

tff(addAssignment_57478,axiom,
    ! [VarCurr: state_type] :
      ( v95128(VarCurr)
    <=> v95130(VarCurr) ) ).

tff(addAssignment_57477,axiom,
    ! [VarCurr: state_type] :
      ( v95130(VarCurr)
    <=> v95132(VarCurr) ) ).

tff(addAssignment_57476,axiom,
    ! [VarCurr: state_type] :
      ( v95132(VarCurr)
    <=> v95134(VarCurr) ) ).

tff(addAssignment_57475,axiom,
    ! [VarCurr: state_type] :
      ( v95134(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_57474,axiom,
    ! [VarCurr: state_type] :
      ( v95124(VarCurr)
    <=> v95126(VarCurr) ) ).

tff(addAssignment_57473,axiom,
    ! [VarCurr: state_type] :
      ( v95126(VarCurr)
    <=> $true ) ).

tff(addAssignment_57472,axiom,
    ! [VarCurr: state_type] :
      ( v95120(VarCurr)
    <=> v95122(VarCurr) ) ).

tff(addAssignment_57471,axiom,
    ! [VarCurr: state_type] :
      ( v95122(VarCurr)
    <=> $false ) ).

tff(addAssignment_57470,axiom,
    ! [VarCurr: state_type] :
      ( v95112(VarCurr)
    <=> v95114(VarCurr) ) ).

tff(addAssignment_57469,axiom,
    ! [VarCurr: state_type] :
      ( v95114(VarCurr)
    <=> v95116(VarCurr) ) ).

tff(addAssignment_57468,axiom,
    ! [VarCurr: state_type] :
      ( v95116(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_57467,axiom,
    ! [VarCurr: state_type] :
      ( v94878(VarCurr,28)
    <=> v94880(VarCurr,28) ) ).

tff(addAssignment_57466,axiom,
    ! [VarCurr: state_type] :
      ( v94880(VarCurr,28)
    <=> v95101(VarCurr,28) ) ).

tff(addAssignment_57465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v95101(VarCurr,B)
      <=> v95104(VarCurr,B) ) ) ).

tff(addAssignment_57464,axiom,
    ! [VarCurr: state_type] :
      ( ( v95101(VarCurr,27)
      <=> v94882(VarCurr,11) )
      & ( v95101(VarCurr,26)
      <=> v94882(VarCurr,10) )
      & ( v95101(VarCurr,25)
      <=> v94882(VarCurr,9) )
      & ( v95101(VarCurr,24)
      <=> v94882(VarCurr,8) )
      & ( v95101(VarCurr,23)
      <=> v94882(VarCurr,7) )
      & ( v95101(VarCurr,22)
      <=> v94882(VarCurr,6) )
      & ( v95101(VarCurr,21)
      <=> v94882(VarCurr,5) )
      & ( v95101(VarCurr,20)
      <=> v94882(VarCurr,4) )
      & ( v95101(VarCurr,19)
      <=> v94882(VarCurr,3) )
      & ( v95101(VarCurr,18)
      <=> v94882(VarCurr,2) )
      & ( v95101(VarCurr,17)
      <=> v94882(VarCurr,1) )
      & ( v95101(VarCurr,16)
      <=> v94882(VarCurr,0) ) ) ).

tff(addAssignment_57463,axiom,
    ! [VarCurr: state_type] :
      ( ( v95101(VarCurr,31)
      <=> v95102(VarCurr,3) )
      & ( v95101(VarCurr,30)
      <=> v95102(VarCurr,2) )
      & ( v95101(VarCurr,29)
      <=> v95102(VarCurr,1) )
      & ( v95101(VarCurr,28)
      <=> v95102(VarCurr,0) ) ) ).

tff(addAssignment_57462,axiom,
    ! [VarCurr: state_type] :
      ( v95102(VarCurr,0)
    <=> v95103(VarCurr) ) ).

tff(addAssignment_57461,axiom,
    ! [VarCurr: state_type] :
      ( v95102(VarCurr,1)
    <=> v95103(VarCurr) ) ).

tff(addAssignment_57460,axiom,
    ! [VarCurr: state_type] :
      ( v95102(VarCurr,2)
    <=> v95103(VarCurr) ) ).

tff(addAssignment_57459,axiom,
    ! [VarCurr: state_type] :
      ( v95102(VarCurr,3)
    <=> v95103(VarCurr) ) ).

tff(addAssignment_57458,axiom,
    ! [VarCurr: state_type] :
      ( v95103(VarCurr)
    <=> v94882(VarCurr,0) ) ).

tff(addAssignment_57457,axiom,
    ! [VarCurr: state_type] :
      ( v94882(VarCurr,0)
    <=> v94884(VarCurr,0) ) ).

tff(addAssignment_57456,axiom,
    ! [VarCurr: state_type] :
      ( v94884(VarCurr,0)
    <=> v94886(VarCurr,0) ) ).

tff(addAssignment_57455,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,0)
    <=> v94888(VarCurr,0) ) ).

tff(addAssignment_57454,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,0)
    <=> v94890(VarCurr,0) ) ).

tff(addAssignment_57453,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,0)
    <=> v95094(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95095(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95094(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1050,axiom,
    ! [VarNext: state_type] :
      ( v95095(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95094(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95095(VarNext)
      <=> v95096(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95096(VarNext)
      <=> ( v95098(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95098(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57452,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,0)
    <=> v94902(VarCurr,0) ) ).

tff(addAssignment_57451,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,0)
    <=> v94904(VarCurr,0) ) ).

tff(addAssignment_57450,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,0)
    <=> v94906(VarCurr,0) ) ).

tff(addAssignment_57449,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,0)
    <=> v94911(VarCurr,0) ) ).

tff(addAssignment_57448,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,1)
    <=> v94888(VarCurr,1) ) ).

tff(addAssignment_57447,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,1)
    <=> v94890(VarCurr,1) ) ).

tff(addAssignment_57446,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,1)
    <=> v95086(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95087(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95086(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1049,axiom,
    ! [VarNext: state_type] :
      ( v95087(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95086(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95087(VarNext)
      <=> v95088(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95088(VarNext)
      <=> ( v95090(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95090(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57445,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,1)
    <=> v94902(VarCurr,1) ) ).

tff(addAssignment_57444,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,1)
    <=> v94904(VarCurr,1) ) ).

tff(addAssignment_57443,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,1)
    <=> v94906(VarCurr,1) ) ).

tff(addAssignment_57442,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,1)
    <=> v94911(VarCurr,1) ) ).

tff(addAssignment_57441,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,2)
    <=> v94888(VarCurr,2) ) ).

tff(addAssignment_57440,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,2)
    <=> v94890(VarCurr,2) ) ).

tff(addAssignment_57439,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,2)
    <=> v95078(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95079(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95078(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1048,axiom,
    ! [VarNext: state_type] :
      ( v95079(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95078(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95079(VarNext)
      <=> v95080(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8744,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95080(VarNext)
      <=> ( v95082(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95082(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57438,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,2)
    <=> v94902(VarCurr,2) ) ).

tff(addAssignment_57437,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,2)
    <=> v94904(VarCurr,2) ) ).

tff(addAssignment_57436,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,2)
    <=> v94906(VarCurr,2) ) ).

tff(addAssignment_57435,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,2)
    <=> v94911(VarCurr,2) ) ).

tff(addAssignment_57434,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,3)
    <=> v94888(VarCurr,3) ) ).

tff(addAssignment_57433,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,3)
    <=> v94890(VarCurr,3) ) ).

tff(addAssignment_57432,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,3)
    <=> v95070(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95071(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95070(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1047,axiom,
    ! [VarNext: state_type] :
      ( v95071(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95070(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8743,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95071(VarNext)
      <=> v95072(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95072(VarNext)
      <=> ( v95074(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95074(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57431,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,3)
    <=> v94902(VarCurr,3) ) ).

tff(addAssignment_57430,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,3)
    <=> v94904(VarCurr,3) ) ).

tff(addAssignment_57429,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,3)
    <=> v94906(VarCurr,3) ) ).

tff(addAssignment_57428,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,3)
    <=> v94911(VarCurr,3) ) ).

tff(addAssignment_57427,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,4)
    <=> v94888(VarCurr,4) ) ).

tff(addAssignment_57426,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,4)
    <=> v94890(VarCurr,4) ) ).

tff(addAssignment_57425,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,4)
    <=> v95062(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95063(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95062(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1046,axiom,
    ! [VarNext: state_type] :
      ( v95063(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95062(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95063(VarNext)
      <=> v95064(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95064(VarNext)
      <=> ( v95066(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95066(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57424,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,4)
    <=> v94902(VarCurr,4) ) ).

tff(addAssignment_57423,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,4)
    <=> v94904(VarCurr,4) ) ).

tff(addAssignment_57422,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,4)
    <=> v94906(VarCurr,4) ) ).

tff(addAssignment_57421,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,4)
    <=> v94911(VarCurr,4) ) ).

tff(addAssignment_57420,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,5)
    <=> v94888(VarCurr,5) ) ).

tff(addAssignment_57419,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,5)
    <=> v94890(VarCurr,5) ) ).

tff(addAssignment_57418,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,5)
    <=> v95054(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95055(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95054(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1045,axiom,
    ! [VarNext: state_type] :
      ( v95055(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95054(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95055(VarNext)
      <=> v95056(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95056(VarNext)
      <=> ( v95058(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95058(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57417,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,5)
    <=> v94902(VarCurr,5) ) ).

tff(addAssignment_57416,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,5)
    <=> v94904(VarCurr,5) ) ).

tff(addAssignment_57415,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,5)
    <=> v94906(VarCurr,5) ) ).

tff(addAssignment_57414,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,5)
    <=> v94911(VarCurr,5) ) ).

tff(addAssignment_57413,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,6)
    <=> v94888(VarCurr,6) ) ).

tff(addAssignment_57412,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,6)
    <=> v94890(VarCurr,6) ) ).

tff(addAssignment_57411,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,6)
    <=> v95046(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95047(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95046(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1044,axiom,
    ! [VarNext: state_type] :
      ( v95047(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95046(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95047(VarNext)
      <=> v95048(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8736,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95048(VarNext)
      <=> ( v95050(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95050(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57410,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,6)
    <=> v94902(VarCurr,6) ) ).

tff(addAssignment_57409,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,6)
    <=> v94904(VarCurr,6) ) ).

tff(addAssignment_57408,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,6)
    <=> v94906(VarCurr,6) ) ).

tff(addAssignment_57407,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,6)
    <=> v94911(VarCurr,6) ) ).

tff(addAssignment_57406,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,7)
    <=> v94888(VarCurr,7) ) ).

tff(addAssignment_57405,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,7)
    <=> v94890(VarCurr,7) ) ).

tff(addAssignment_57404,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,7)
    <=> v95038(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95039(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95038(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1043,axiom,
    ! [VarNext: state_type] :
      ( v95039(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95038(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95039(VarNext)
      <=> v95040(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95040(VarNext)
      <=> ( v95042(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95042(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57403,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,7)
    <=> v94902(VarCurr,7) ) ).

tff(addAssignment_57402,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,7)
    <=> v94904(VarCurr,7) ) ).

tff(addAssignment_57401,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,7)
    <=> v94906(VarCurr,7) ) ).

tff(addAssignment_57400,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,7)
    <=> v94911(VarCurr,7) ) ).

tff(addAssignment_57399,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,8)
    <=> v94888(VarCurr,8) ) ).

tff(addAssignment_57398,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,8)
    <=> v94890(VarCurr,8) ) ).

tff(addAssignment_57397,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,8)
    <=> v95030(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_1042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95031(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95030(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1042,axiom,
    ! [VarNext: state_type] :
      ( v95031(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95030(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95031(VarNext)
      <=> v95032(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95032(VarNext)
      <=> ( v95034(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95034(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57396,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,8)
    <=> v94902(VarCurr,8) ) ).

tff(addAssignment_57395,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,8)
    <=> v94904(VarCurr,8) ) ).

tff(addAssignment_57394,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,8)
    <=> v94906(VarCurr,8) ) ).

tff(addAssignment_57393,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,8)
    <=> v94911(VarCurr,8) ) ).

tff(addAssignment_57392,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,9)
    <=> v94888(VarCurr,9) ) ).

tff(addAssignment_57391,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,9)
    <=> v94890(VarCurr,9) ) ).

tff(addAssignment_57390,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,9)
    <=> v95022(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_1041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95023(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95022(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1041,axiom,
    ! [VarNext: state_type] :
      ( v95023(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95022(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95023(VarNext)
      <=> v95024(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95024(VarNext)
      <=> ( v95026(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95026(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57389,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,9)
    <=> v94902(VarCurr,9) ) ).

tff(addAssignment_57388,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,9)
    <=> v94904(VarCurr,9) ) ).

tff(addAssignment_57387,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,9)
    <=> v94906(VarCurr,9) ) ).

tff(addAssignment_57386,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,9)
    <=> v94911(VarCurr,9) ) ).

tff(addAssignment_57385,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,10)
    <=> v94888(VarCurr,10) ) ).

tff(addAssignment_57384,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,10)
    <=> v94890(VarCurr,10) ) ).

tff(addAssignment_57383,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,10)
    <=> v95014(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_1040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95015(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v95014(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1040,axiom,
    ! [VarNext: state_type] :
      ( v95015(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95014(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95015(VarNext)
      <=> v95016(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95016(VarNext)
      <=> ( v95018(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v95018(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57382,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,10)
    <=> v94902(VarCurr,10) ) ).

tff(addAssignment_57381,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,10)
    <=> v94904(VarCurr,10) ) ).

tff(addAssignment_57380,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,10)
    <=> v94906(VarCurr,10) ) ).

tff(addAssignment_57379,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,10)
    <=> v94911(VarCurr,10) ) ).

tff(addAssignment_57378,axiom,
    ! [VarCurr: state_type] :
      ( v94886(VarCurr,11)
    <=> v94888(VarCurr,11) ) ).

tff(addAssignment_57377,axiom,
    ! [VarCurr: state_type] :
      ( v94888(VarCurr,11)
    <=> v94890(VarCurr,11) ) ).

tff(addAssignment_57376,axiom,
    ! [VarNext: state_type] :
      ( v94890(VarNext,11)
    <=> v94996(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_1039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94997(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v94996(VarNext,B)
            <=> v94890(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1039,axiom,
    ! [VarNext: state_type] :
      ( v94997(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v94996(VarNext,B)
          <=> v95007(VarNext,B) ) ) ) ).

tff(addAssignment_57375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95007(VarNext,B)
          <=> v95005(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95005(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_572,axiom,
    ! [VarCurr: state_type] :
      ( v95008(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v95005(VarCurr,B)
          <=> v94900(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8727,axiom,
    ! [VarCurr: state_type] :
      ( v95008(VarCurr)
    <=> ( v95009(VarCurr)
        & v95010(VarCurr) ) ) ).

tff(writeUnaryOperator_4314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95010(VarCurr)
    <=> v94896(VarCurr) ) ).

tff(writeUnaryOperator_4313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v95009(VarCurr)
    <=> v94892(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94997(VarNext)
      <=> v94998(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94998(VarNext)
      <=> ( v94999(VarNext)
          & v94917(VarNext) ) ) ) ).

tff(writeUnaryOperator_4312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94999(VarNext)
      <=> v95001(VarNext) ) ) ).

tff(addAssignment_57374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v95001(VarNext)
      <=> v94917(VarCurr) ) ) ).

tff(addAssignment_57373,axiom,
    ! [VarCurr: state_type] :
      ( v94917(VarCurr)
    <=> v94919(VarCurr) ) ).

tff(addAssignment_57372,axiom,
    ! [VarCurr: state_type] :
      ( v94919(VarCurr)
    <=> v94921(VarCurr) ) ).

tff(addAssignment_57371,axiom,
    ! [VarCurr: state_type] :
      ( v94921(VarCurr)
    <=> v94923(VarCurr) ) ).

tff(addAssignment_57370,axiom,
    ! [VarCurr: state_type] :
      ( v94923(VarCurr)
    <=> v94925(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8724,axiom,
    ! [VarCurr: state_type] :
      ( v94925(VarCurr)
    <=> ( v94994(VarCurr)
        | v94985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8723,axiom,
    ! [VarCurr: state_type] :
      ( v94994(VarCurr)
    <=> ( v94927(VarCurr)
        & v94940(VarCurr) ) ) ).

tff(addAssignment_57369,axiom,
    ! [VarCurr: state_type] :
      ( v94985(VarCurr)
    <=> v94987(VarCurr) ) ).

tff(addAssignment_57368,axiom,
    ! [VarCurr: state_type] :
      ( v94987(VarCurr)
    <=> v94989(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8722,axiom,
    ! [VarCurr: state_type] :
      ( v94989(VarCurr)
    <=> ( v94991(VarCurr)
        & v4548(VarCurr) ) ) ).

tff(addAssignment_57367,axiom,
    ! [VarCurr: state_type] :
      ( v94991(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94969(VarNext)
       => ( v94940(VarNext)
        <=> v94940(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1038,axiom,
    ! [VarNext: state_type] :
      ( v94969(VarNext)
     => ( v94940(VarNext)
      <=> v94979(VarNext) ) ) ).

tff(addAssignment_57366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94979(VarNext)
      <=> v94977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8721,axiom,
    ! [VarCurr: state_type] :
      ( v94977(VarCurr)
    <=> ( v94980(VarCurr)
        & v94981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8720,axiom,
    ! [VarCurr: state_type] :
      ( v94981(VarCurr)
    <=> ( v94956(VarCurr)
        | v94960(VarCurr) ) ) ).

tff(writeUnaryOperator_4311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94980(VarCurr)
    <=> v94942(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94969(VarNext)
      <=> v94970(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94970(VarNext)
      <=> ( v94972(VarNext)
          & v94974(VarNext) ) ) ) ).

tff(writeUnaryOperator_4310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94974(VarCurr)
    <=> v94927(VarCurr) ) ).

tff(addAssignment_57365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94972(VarNext)
      <=> v94927(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_243,axiom,
    ( v94940(constB0)
  <=> $true ) ).

tff(addAssignment_57364,axiom,
    ! [VarCurr: state_type] :
      ( v94960(VarCurr)
    <=> v94962(VarCurr) ) ).

tff(addAssignment_57363,axiom,
    ! [VarCurr: state_type] :
      ( v94962(VarCurr)
    <=> v94964(VarCurr) ) ).

tff(addAssignment_57362,axiom,
    ! [VarCurr: state_type] :
      ( v94964(VarCurr)
    <=> v94966(VarCurr) ) ).

tff(addAssignment_57361,axiom,
    ! [VarCurr: state_type] :
      ( v94966(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_57360,axiom,
    ! [VarCurr: state_type] :
      ( v94956(VarCurr)
    <=> v94958(VarCurr) ) ).

tff(addAssignment_57359,axiom,
    ! [VarCurr: state_type] :
      ( v94958(VarCurr)
    <=> $true ) ).

tff(addAssignment_57358,axiom,
    ! [VarCurr: state_type] :
      ( v94942(VarCurr)
    <=> v94944(VarCurr) ) ).

tff(addAssignment_57357,axiom,
    ! [VarCurr: state_type] :
      ( v94944(VarCurr)
    <=> v94946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8717,axiom,
    ! [VarCurr: state_type] :
      ( v94946(VarCurr)
    <=> ( v94948(VarCurr)
        & v94954(VarCurr) ) ) ).

tff(writeUnaryOperator_4309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94954(VarCurr)
    <=> v94952(VarCurr) ) ).

tff(addAssignment_57356,axiom,
    ! [VarCurr: state_type] :
      ( v94952(VarCurr)
    <=> v626(VarCurr) ) ).

tff(addAssignment_57355,axiom,
    ! [VarCurr: state_type] :
      ( v94948(VarCurr)
    <=> v94950(VarCurr) ) ).

tff(addAssignment_57354,axiom,
    ! [VarCurr: state_type] :
      ( v94927(VarCurr)
    <=> v94929(VarCurr) ) ).

tff(addAssignment_57353,axiom,
    ! [VarCurr: state_type] :
      ( v94929(VarCurr)
    <=> v94931(VarCurr) ) ).

tff(addAssignment_57352,axiom,
    ! [VarCurr: state_type] :
      ( v94931(VarCurr)
    <=> v94933(VarCurr) ) ).

tff(writeUnaryOperator_4308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94933(VarCurr)
    <=> v94935(VarCurr) ) ).

tff(addAssignment_57351,axiom,
    ! [VarCurr: state_type] :
      ( v94935(VarCurr)
    <=> v94937(VarCurr) ) ).

tff(addAssignment_57350,axiom,
    ! [VarCurr: state_type] :
      ( v94937(VarCurr)
    <=> v1(VarCurr) ) ).

tff(addAssignment_57349,axiom,
    ! [VarCurr: state_type] :
      ( v94900(VarCurr,11)
    <=> v94902(VarCurr,11) ) ).

tff(addAssignment_57348,axiom,
    ! [VarCurr: state_type] :
      ( v94902(VarCurr,11)
    <=> v94904(VarCurr,11) ) ).

tff(addAssignment_57347,axiom,
    ! [VarCurr: state_type] :
      ( v94904(VarCurr,11)
    <=> v94906(VarCurr,11) ) ).

tff(addAssignment_57346,axiom,
    ! [VarCurr: state_type] :
      ( v94906(VarCurr,11)
    <=> v94911(VarCurr,11) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94908(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v94911(VarCurr,B)
          <=> v94912(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_571,axiom,
    ! [VarCurr: state_type] :
      ( v94908(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v94911(VarCurr,B)
          <=> b000000000001(B) ) ) ) ).

tff(addAssignment_57345,axiom,
    ! [VarCurr: state_type] :
      ( ( v94912(VarCurr,10)
      <=> v94886(VarCurr,11) )
      & ( v94912(VarCurr,9)
      <=> v94886(VarCurr,10) )
      & ( v94912(VarCurr,8)
      <=> v94886(VarCurr,9) )
      & ( v94912(VarCurr,7)
      <=> v94886(VarCurr,8) )
      & ( v94912(VarCurr,6)
      <=> v94886(VarCurr,7) )
      & ( v94912(VarCurr,5)
      <=> v94886(VarCurr,6) )
      & ( v94912(VarCurr,4)
      <=> v94886(VarCurr,5) )
      & ( v94912(VarCurr,3)
      <=> v94886(VarCurr,4) )
      & ( v94912(VarCurr,2)
      <=> v94886(VarCurr,3) )
      & ( v94912(VarCurr,1)
      <=> v94886(VarCurr,2) )
      & ( v94912(VarCurr,0)
      <=> v94886(VarCurr,1) ) ) ).

tff(addAssignment_57344,axiom,
    ! [VarCurr: state_type] :
      ( v94912(VarCurr,11)
    <=> v94913(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8716,axiom,
    ! [VarCurr: state_type] :
      ( v94913(VarCurr)
    <=> ( v94914(VarCurr)
      <~> v94886(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3675,axiom,
    ! [VarCurr: state_type] :
      ( v94914(VarCurr)
    <=> ( v94915(VarCurr)
      <~> v94886(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3674,axiom,
    ! [VarCurr: state_type] :
      ( v94915(VarCurr)
    <=> ( v94886(VarCurr,7)
      <~> v94886(VarCurr,4) ) ) ).

tff(addAssignment_57343,axiom,
    ! [VarCurr: state_type] :
      ( v94908(VarCurr)
    <=> v94910(VarCurr) ) ).

tff(addAssignment_57342,axiom,
    ! [VarCurr: state_type] :
      ( v94910(VarCurr)
    <=> v4343(VarCurr) ) ).

tff(addAssignment_57341,axiom,
    ! [VarCurr: state_type] :
      ( v94896(VarCurr)
    <=> v94898(VarCurr) ) ).

tff(addAssignment_57340,axiom,
    ! [VarCurr: state_type] :
      ( v94898(VarCurr)
    <=> v4555(VarCurr) ) ).

tff(addAssignment_57339,axiom,
    ! [VarCurr: state_type] :
      ( v94892(VarCurr)
    <=> v94894(VarCurr) ) ).

tff(addAssignment_57338,axiom,
    ! [VarCurr: state_type] :
      ( v94894(VarCurr)
    <=> v4544(VarCurr) ) ).

tff(addAssignment_57337,axiom,
    ! [VarCurr: state_type] :
      ( v94864(VarCurr)
    <=> v94866(VarCurr) ) ).

tff(addAssignment_57336,axiom,
    ! [VarCurr: state_type] :
      ( v94866(VarCurr)
    <=> v94868(VarCurr) ) ).

tff(addAssignment_57335,axiom,
    ! [VarCurr: state_type] :
      ( v94868(VarCurr)
    <=> v94870(VarCurr) ) ).

tff(addAssignment_57334,axiom,
    ! [VarCurr: state_type] :
      ( v94870(VarCurr)
    <=> v94872(VarCurr) ) ).

tff(addAssignment_57333,axiom,
    ! [VarCurr: state_type] :
      ( v94872(VarCurr)
    <=> v94874(VarCurr) ) ).

tff(addAssignment_57332,axiom,
    ! [VarCurr: state_type] :
      ( v94874(VarCurr)
    <=> v94876(VarCurr) ) ).

tff(addAssignment_57331,axiom,
    ! [VarCurr: state_type] :
      ( v94876(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_57330,axiom,
    ! [VarCurr: state_type] :
      ( v94850(VarCurr)
    <=> v94852(VarCurr) ) ).

tff(addAssignment_57329,axiom,
    ! [VarCurr: state_type] :
      ( v94852(VarCurr)
    <=> v94854(VarCurr) ) ).

tff(addAssignment_57328,axiom,
    ! [VarCurr: state_type] :
      ( v94854(VarCurr)
    <=> v94856(VarCurr) ) ).

tff(addAssignment_57327,axiom,
    ! [VarCurr: state_type] :
      ( v94856(VarCurr)
    <=> v94858(VarCurr) ) ).

tff(addAssignment_57326,axiom,
    ! [VarCurr: state_type] :
      ( v94858(VarCurr)
    <=> v94860(VarCurr) ) ).

tff(addAssignment_57325,axiom,
    ! [VarCurr: state_type] :
      ( v94860(VarCurr)
    <=> v94862(VarCurr) ) ).

tff(addAssignment_57324,axiom,
    ! [VarCurr: state_type] :
      ( v94862(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_57323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94820(VarCurr,B)
      <=> v94822(VarCurr,B) ) ) ).

tff(addAssignment_57322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94822(VarCurr,B)
      <=> v4121(VarCurr,B) ) ) ).

tff(addAssignment_57321,axiom,
    ! [VarCurr: state_type] :
      ( v94762(VarCurr)
    <=> v94764(VarCurr,1) ) ).

tff(addAssignment_57320,axiom,
    ! [VarCurr: state_type] :
      ( v94764(VarCurr,1)
    <=> v94766(VarCurr,1) ) ).

tff(addAssignment_57319,axiom,
    ! [VarNext: state_type] :
      ( v94766(VarNext,1)
    <=> v94788(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94789(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v94788(VarNext,B)
            <=> v94766(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1037,axiom,
    ! [VarNext: state_type] :
      ( v94789(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v94788(VarNext,B)
          <=> v94799(VarNext,B) ) ) ) ).

tff(addAssignment_57318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v94799(VarNext,B)
          <=> v94797(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v94797(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_570,axiom,
    ! [VarCurr: state_type] :
      ( v94800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v94797(VarCurr,B)
          <=> v94776(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8715,axiom,
    ! [VarCurr: state_type] :
      ( v94800(VarCurr)
    <=> ( v94801(VarCurr)
        & v94802(VarCurr) ) ) ).

tff(writeUnaryOperator_4307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94802(VarCurr)
    <=> v94772(VarCurr) ) ).

tff(writeUnaryOperator_4306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94801(VarCurr)
    <=> v94768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94789(VarNext)
      <=> v94790(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94790(VarNext)
      <=> ( v94791(VarNext)
          & v94784(VarNext) ) ) ) ).

tff(writeUnaryOperator_4305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94791(VarNext)
      <=> v94793(VarNext) ) ) ).

tff(addAssignment_57317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94793(VarNext)
      <=> v94784(VarCurr) ) ) ).

tff(addAssignment_57316,axiom,
    ! [VarCurr: state_type] :
      ( v94784(VarCurr)
    <=> v94786(VarCurr) ) ).

tff(addAssignment_57315,axiom,
    ! [VarCurr: state_type] :
      ( v94786(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_57314,axiom,
    ! [VarCurr: state_type] :
      ( v94776(VarCurr,1)
    <=> v94778(VarCurr,1) ) ).

tff(addAssignment_57313,axiom,
    ! [VarCurr: state_type] :
      ( v94778(VarCurr,1)
    <=> v94780(VarCurr,1) ) ).

tff(addAssignment_57312,axiom,
    ! [VarCurr: state_type] :
      ( v94780(VarCurr,1)
    <=> v94781(VarCurr,1) ) ).

tff(addAssignment_57311,axiom,
    ! [VarCurr: state_type] :
      ( v94781(VarCurr,0)
    <=> v94782(VarCurr) ) ).

tff(addAssignment_57310,axiom,
    ! [VarCurr: state_type] :
      ( v94781(VarCurr,1)
    <=> v4513(VarCurr) ) ).

tff(addAssignment_57309,axiom,
    ! [VarCurr: state_type] :
      ( v94772(VarCurr)
    <=> v94774(VarCurr) ) ).

tff(addAssignment_57308,axiom,
    ! [VarCurr: state_type] :
      ( v94774(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_57307,axiom,
    ! [VarCurr: state_type] :
      ( v94768(VarCurr)
    <=> v94770(VarCurr) ) ).

tff(addAssignment_57306,axiom,
    ! [VarCurr: state_type] :
      ( v94770(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8712,axiom,
    ! [VarCurr: state_type] :
      ( v94335(VarCurr)
    <=> ( v94726(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8711,axiom,
    ! [VarCurr: state_type] :
      ( v94726(VarCurr)
    <=> ( v94727(VarCurr)
        & v94756(VarCurr) ) ) ).

tff(writeUnaryOperator_4304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94756(VarCurr)
    <=> v89722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8710,axiom,
    ! [VarCurr: state_type] :
      ( v94727(VarCurr)
    <=> ( v94728(VarCurr)
        & v94755(VarCurr) ) ) ).

tff(writeUnaryOperator_4303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94755(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8709,axiom,
    ! [VarCurr: state_type] :
      ( v94728(VarCurr)
    <=> ( v94729(VarCurr)
        & v4513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8708,axiom,
    ! [VarCurr: state_type] :
      ( v94729(VarCurr)
    <=> ( v94730(VarCurr)
        | v94719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8707,axiom,
    ! [VarCurr: state_type] :
      ( v94730(VarCurr)
    <=> ( v94731(VarCurr)
        | v94743(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3673,axiom,
    ! [VarCurr: state_type] :
      ( v94743(VarCurr)
    <=> ( v94745(VarCurr)
        | v94526(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3672,axiom,
    ! [VarCurr: state_type] :
      ( v94745(VarCurr)
    <=> ( v94746(VarCurr)
        | v94526(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3671,axiom,
    ! [VarCurr: state_type] :
      ( v94746(VarCurr)
    <=> ( v94747(VarCurr)
        | v94526(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3670,axiom,
    ! [VarCurr: state_type] :
      ( v94747(VarCurr)
    <=> ( v94748(VarCurr)
        | v94526(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3669,axiom,
    ! [VarCurr: state_type] :
      ( v94748(VarCurr)
    <=> ( v94749(VarCurr)
        | v94526(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3668,axiom,
    ! [VarCurr: state_type] :
      ( v94749(VarCurr)
    <=> ( v94750(VarCurr)
        | v94526(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3667,axiom,
    ! [VarCurr: state_type] :
      ( v94750(VarCurr)
    <=> ( v94751(VarCurr)
        | v94526(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3666,axiom,
    ! [VarCurr: state_type] :
      ( v94751(VarCurr)
    <=> ( v94752(VarCurr)
        | v94526(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3665,axiom,
    ! [VarCurr: state_type] :
      ( v94752(VarCurr)
    <=> ( v94753(VarCurr)
        | v94526(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3664,axiom,
    ! [VarCurr: state_type] :
      ( v94753(VarCurr)
    <=> ( v94754(VarCurr)
        | v94526(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3663,axiom,
    ! [VarCurr: state_type] :
      ( v94754(VarCurr)
    <=> ( v94526(VarCurr,0)
        | v94526(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3662,axiom,
    ! [VarCurr: state_type] :
      ( v94731(VarCurr)
    <=> ( v94733(VarCurr)
        | v94337(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3661,axiom,
    ! [VarCurr: state_type] :
      ( v94733(VarCurr)
    <=> ( v94734(VarCurr)
        | v94337(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3660,axiom,
    ! [VarCurr: state_type] :
      ( v94734(VarCurr)
    <=> ( v94735(VarCurr)
        | v94337(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3659,axiom,
    ! [VarCurr: state_type] :
      ( v94735(VarCurr)
    <=> ( v94736(VarCurr)
        | v94337(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3658,axiom,
    ! [VarCurr: state_type] :
      ( v94736(VarCurr)
    <=> ( v94737(VarCurr)
        | v94337(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3657,axiom,
    ! [VarCurr: state_type] :
      ( v94737(VarCurr)
    <=> ( v94738(VarCurr)
        | v94337(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3656,axiom,
    ! [VarCurr: state_type] :
      ( v94738(VarCurr)
    <=> ( v94739(VarCurr)
        | v94337(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3655,axiom,
    ! [VarCurr: state_type] :
      ( v94739(VarCurr)
    <=> ( v94740(VarCurr)
        | v94337(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3654,axiom,
    ! [VarCurr: state_type] :
      ( v94740(VarCurr)
    <=> ( v94741(VarCurr)
        | v94337(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3653,axiom,
    ! [VarCurr: state_type] :
      ( v94741(VarCurr)
    <=> ( v94742(VarCurr)
        | v94337(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3652,axiom,
    ! [VarCurr: state_type] :
      ( v94742(VarCurr)
    <=> ( v94337(VarCurr,0)
        | v94337(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8706,axiom,
    ! [VarCurr: state_type] :
      ( v94719(VarCurr)
    <=> ( v94721(VarCurr)
        & v94722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8705,axiom,
    ! [VarCurr: state_type] :
      ( v94722(VarCurr)
    <=> ( v94723(VarCurr)
        | v94294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8704,axiom,
    ! [VarCurr: state_type] :
      ( v94723(VarCurr)
    <=> ( v90859(VarCurr)
        & v94724(VarCurr) ) ) ).

tff(writeUnaryOperator_4302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94724(VarCurr)
    <=> v90968(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_491,axiom,
    ! [VarCurr: state_type] :
      ( v94721(VarCurr)
    <=> ( ( v90800(VarCurr,1)
        <=> $true )
        & ( v90800(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94526(VarCurr,B)
      <=> ( v94714(VarCurr,B)
          & v94715(VarCurr,B) ) ) ) ).

tff(addAssignment_57305,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,0)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57304,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,1)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57303,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,2)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57302,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,3)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57301,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,4)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57300,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,5)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57299,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,6)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57298,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,7)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57297,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,8)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57296,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,9)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57295,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,10)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57294,axiom,
    ! [VarCurr: state_type] :
      ( v94715(VarCurr,11)
    <=> v94716(VarCurr) ) ).

tff(addAssignment_57293,axiom,
    ! [VarCurr: state_type] :
      ( v94716(VarCurr)
    <=> v94717(VarCurr) ) ).

tff(writeUnaryOperator_4301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94717(VarCurr)
    <=> v10059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94714(VarCurr,B)
      <=> ( v94528(VarCurr,B)
          & v90212(VarCurr,B) ) ) ) ).

tff(addAssignment_57292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94528(VarCurr,B)
      <=> v94530(VarCurr,B) ) ) ).

tff(addAssignment_57291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94530(VarCurr,B)
      <=> v94532(VarCurr,B) ) ) ).

tff(addAssignment_57290,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,11)
    <=> v94699(VarCurr) ) ).

tff(addAssignment_57289,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,10)
    <=> v94684(VarCurr) ) ).

tff(addAssignment_57288,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,9)
    <=> v94669(VarCurr) ) ).

tff(addAssignment_57287,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,8)
    <=> v94654(VarCurr) ) ).

tff(addAssignment_57286,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,7)
    <=> v94639(VarCurr) ) ).

tff(addAssignment_57285,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,6)
    <=> v94624(VarCurr) ) ).

tff(addAssignment_57284,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,5)
    <=> v94609(VarCurr) ) ).

tff(addAssignment_57283,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,4)
    <=> v94594(VarCurr) ) ).

tff(addAssignment_57282,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,3)
    <=> v94579(VarCurr) ) ).

tff(addAssignment_57281,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,2)
    <=> v94564(VarCurr) ) ).

tff(addAssignment_57280,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,1)
    <=> v94549(VarCurr) ) ).

tff(addAssignment_57279,axiom,
    ! [VarCurr: state_type] :
      ( v94532(VarCurr,0)
    <=> v94534(VarCurr) ) ).

tff(addAssignment_57278,axiom,
    ! [VarCurr: state_type] :
      ( v94699(VarCurr)
    <=> v94701(VarCurr) ) ).

tff(addAssignment_57277,axiom,
    ! [VarCurr: state_type] :
      ( v94701(VarCurr)
    <=> v94703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8703,axiom,
    ! [VarCurr: state_type] :
      ( v94703(VarCurr)
    <=> ( v94705(VarCurr)
        & v94709(VarCurr) ) ) ).

tff(addAssignment_57276,axiom,
    ! [VarCurr: state_type] :
      ( v94709(VarCurr)
    <=> v94711(VarCurr) ) ).

tff(addAssignment_57275,axiom,
    ! [VarCurr: state_type] :
      ( v94711(VarCurr)
    <=> v90752(VarCurr) ) ).

tff(addAssignment_57274,axiom,
    ! [VarCurr: state_type] :
      ( v94705(VarCurr)
    <=> v94707(VarCurr) ) ).

tff(addAssignment_57273,axiom,
    ! [VarCurr: state_type] :
      ( v94707(VarCurr)
    <=> v26555(VarCurr,0) ) ).

tff(addAssignment_57272,axiom,
    ! [VarCurr: state_type] :
      ( v94684(VarCurr)
    <=> v94686(VarCurr) ) ).

tff(addAssignment_57271,axiom,
    ! [VarCurr: state_type] :
      ( v94686(VarCurr)
    <=> v94688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8702,axiom,
    ! [VarCurr: state_type] :
      ( v94688(VarCurr)
    <=> ( v94690(VarCurr)
        & v94694(VarCurr) ) ) ).

tff(addAssignment_57270,axiom,
    ! [VarCurr: state_type] :
      ( v94694(VarCurr)
    <=> v94696(VarCurr) ) ).

tff(addAssignment_57269,axiom,
    ! [VarCurr: state_type] :
      ( v94696(VarCurr)
    <=> v90712(VarCurr) ) ).

tff(addAssignment_57268,axiom,
    ! [VarCurr: state_type] :
      ( v94690(VarCurr)
    <=> v94692(VarCurr) ) ).

tff(addAssignment_57267,axiom,
    ! [VarCurr: state_type] :
      ( v94692(VarCurr)
    <=> v25005(VarCurr,0) ) ).

tff(addAssignment_57266,axiom,
    ! [VarCurr: state_type] :
      ( v94669(VarCurr)
    <=> v94671(VarCurr) ) ).

tff(addAssignment_57265,axiom,
    ! [VarCurr: state_type] :
      ( v94671(VarCurr)
    <=> v94673(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8701,axiom,
    ! [VarCurr: state_type] :
      ( v94673(VarCurr)
    <=> ( v94675(VarCurr)
        & v94679(VarCurr) ) ) ).

tff(addAssignment_57264,axiom,
    ! [VarCurr: state_type] :
      ( v94679(VarCurr)
    <=> v94681(VarCurr) ) ).

tff(addAssignment_57263,axiom,
    ! [VarCurr: state_type] :
      ( v94681(VarCurr)
    <=> v90672(VarCurr) ) ).

tff(addAssignment_57262,axiom,
    ! [VarCurr: state_type] :
      ( v94675(VarCurr)
    <=> v94677(VarCurr) ) ).

tff(addAssignment_57261,axiom,
    ! [VarCurr: state_type] :
      ( v94677(VarCurr)
    <=> v23455(VarCurr,0) ) ).

tff(addAssignment_57260,axiom,
    ! [VarCurr: state_type] :
      ( v94654(VarCurr)
    <=> v94656(VarCurr) ) ).

tff(addAssignment_57259,axiom,
    ! [VarCurr: state_type] :
      ( v94656(VarCurr)
    <=> v94658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8700,axiom,
    ! [VarCurr: state_type] :
      ( v94658(VarCurr)
    <=> ( v94660(VarCurr)
        & v94664(VarCurr) ) ) ).

tff(addAssignment_57258,axiom,
    ! [VarCurr: state_type] :
      ( v94664(VarCurr)
    <=> v94666(VarCurr) ) ).

tff(addAssignment_57257,axiom,
    ! [VarCurr: state_type] :
      ( v94666(VarCurr)
    <=> v90632(VarCurr) ) ).

tff(addAssignment_57256,axiom,
    ! [VarCurr: state_type] :
      ( v94660(VarCurr)
    <=> v94662(VarCurr) ) ).

tff(addAssignment_57255,axiom,
    ! [VarCurr: state_type] :
      ( v94662(VarCurr)
    <=> v21905(VarCurr,0) ) ).

tff(addAssignment_57254,axiom,
    ! [VarCurr: state_type] :
      ( v94639(VarCurr)
    <=> v94641(VarCurr) ) ).

tff(addAssignment_57253,axiom,
    ! [VarCurr: state_type] :
      ( v94641(VarCurr)
    <=> v94643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8699,axiom,
    ! [VarCurr: state_type] :
      ( v94643(VarCurr)
    <=> ( v94645(VarCurr)
        & v94649(VarCurr) ) ) ).

tff(addAssignment_57252,axiom,
    ! [VarCurr: state_type] :
      ( v94649(VarCurr)
    <=> v94651(VarCurr) ) ).

tff(addAssignment_57251,axiom,
    ! [VarCurr: state_type] :
      ( v94651(VarCurr)
    <=> v90592(VarCurr) ) ).

tff(addAssignment_57250,axiom,
    ! [VarCurr: state_type] :
      ( v94645(VarCurr)
    <=> v94647(VarCurr) ) ).

tff(addAssignment_57249,axiom,
    ! [VarCurr: state_type] :
      ( v94647(VarCurr)
    <=> v20355(VarCurr,0) ) ).

tff(addAssignment_57248,axiom,
    ! [VarCurr: state_type] :
      ( v94624(VarCurr)
    <=> v94626(VarCurr) ) ).

tff(addAssignment_57247,axiom,
    ! [VarCurr: state_type] :
      ( v94626(VarCurr)
    <=> v94628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8698,axiom,
    ! [VarCurr: state_type] :
      ( v94628(VarCurr)
    <=> ( v94630(VarCurr)
        & v94634(VarCurr) ) ) ).

tff(addAssignment_57246,axiom,
    ! [VarCurr: state_type] :
      ( v94634(VarCurr)
    <=> v94636(VarCurr) ) ).

tff(addAssignment_57245,axiom,
    ! [VarCurr: state_type] :
      ( v94636(VarCurr)
    <=> v90552(VarCurr) ) ).

tff(addAssignment_57244,axiom,
    ! [VarCurr: state_type] :
      ( v94630(VarCurr)
    <=> v94632(VarCurr) ) ).

tff(addAssignment_57243,axiom,
    ! [VarCurr: state_type] :
      ( v94632(VarCurr)
    <=> v18805(VarCurr,0) ) ).

tff(addAssignment_57242,axiom,
    ! [VarCurr: state_type] :
      ( v94609(VarCurr)
    <=> v94611(VarCurr) ) ).

tff(addAssignment_57241,axiom,
    ! [VarCurr: state_type] :
      ( v94611(VarCurr)
    <=> v94613(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8697,axiom,
    ! [VarCurr: state_type] :
      ( v94613(VarCurr)
    <=> ( v94615(VarCurr)
        & v94619(VarCurr) ) ) ).

tff(addAssignment_57240,axiom,
    ! [VarCurr: state_type] :
      ( v94619(VarCurr)
    <=> v94621(VarCurr) ) ).

tff(addAssignment_57239,axiom,
    ! [VarCurr: state_type] :
      ( v94621(VarCurr)
    <=> v90512(VarCurr) ) ).

tff(addAssignment_57238,axiom,
    ! [VarCurr: state_type] :
      ( v94615(VarCurr)
    <=> v94617(VarCurr) ) ).

tff(addAssignment_57237,axiom,
    ! [VarCurr: state_type] :
      ( v94617(VarCurr)
    <=> v17255(VarCurr,0) ) ).

tff(addAssignment_57236,axiom,
    ! [VarCurr: state_type] :
      ( v94594(VarCurr)
    <=> v94596(VarCurr) ) ).

tff(addAssignment_57235,axiom,
    ! [VarCurr: state_type] :
      ( v94596(VarCurr)
    <=> v94598(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8696,axiom,
    ! [VarCurr: state_type] :
      ( v94598(VarCurr)
    <=> ( v94600(VarCurr)
        & v94604(VarCurr) ) ) ).

tff(addAssignment_57234,axiom,
    ! [VarCurr: state_type] :
      ( v94604(VarCurr)
    <=> v94606(VarCurr) ) ).

tff(addAssignment_57233,axiom,
    ! [VarCurr: state_type] :
      ( v94606(VarCurr)
    <=> v90472(VarCurr) ) ).

tff(addAssignment_57232,axiom,
    ! [VarCurr: state_type] :
      ( v94600(VarCurr)
    <=> v94602(VarCurr) ) ).

tff(addAssignment_57231,axiom,
    ! [VarCurr: state_type] :
      ( v94602(VarCurr)
    <=> v15705(VarCurr,0) ) ).

tff(addAssignment_57230,axiom,
    ! [VarCurr: state_type] :
      ( v94579(VarCurr)
    <=> v94581(VarCurr) ) ).

tff(addAssignment_57229,axiom,
    ! [VarCurr: state_type] :
      ( v94581(VarCurr)
    <=> v94583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8695,axiom,
    ! [VarCurr: state_type] :
      ( v94583(VarCurr)
    <=> ( v94585(VarCurr)
        & v94589(VarCurr) ) ) ).

tff(addAssignment_57228,axiom,
    ! [VarCurr: state_type] :
      ( v94589(VarCurr)
    <=> v94591(VarCurr) ) ).

tff(addAssignment_57227,axiom,
    ! [VarCurr: state_type] :
      ( v94591(VarCurr)
    <=> v90432(VarCurr) ) ).

tff(addAssignment_57226,axiom,
    ! [VarCurr: state_type] :
      ( v94585(VarCurr)
    <=> v94587(VarCurr) ) ).

tff(addAssignment_57225,axiom,
    ! [VarCurr: state_type] :
      ( v94587(VarCurr)
    <=> v14155(VarCurr,0) ) ).

tff(addAssignment_57224,axiom,
    ! [VarCurr: state_type] :
      ( v94564(VarCurr)
    <=> v94566(VarCurr) ) ).

tff(addAssignment_57223,axiom,
    ! [VarCurr: state_type] :
      ( v94566(VarCurr)
    <=> v94568(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8694,axiom,
    ! [VarCurr: state_type] :
      ( v94568(VarCurr)
    <=> ( v94570(VarCurr)
        & v94574(VarCurr) ) ) ).

tff(addAssignment_57222,axiom,
    ! [VarCurr: state_type] :
      ( v94574(VarCurr)
    <=> v94576(VarCurr) ) ).

tff(addAssignment_57221,axiom,
    ! [VarCurr: state_type] :
      ( v94576(VarCurr)
    <=> v90392(VarCurr) ) ).

tff(addAssignment_57220,axiom,
    ! [VarCurr: state_type] :
      ( v94570(VarCurr)
    <=> v94572(VarCurr) ) ).

tff(addAssignment_57219,axiom,
    ! [VarCurr: state_type] :
      ( v94572(VarCurr)
    <=> v12605(VarCurr,0) ) ).

tff(addAssignment_57218,axiom,
    ! [VarCurr: state_type] :
      ( v94549(VarCurr)
    <=> v94551(VarCurr) ) ).

tff(addAssignment_57217,axiom,
    ! [VarCurr: state_type] :
      ( v94551(VarCurr)
    <=> v94553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8693,axiom,
    ! [VarCurr: state_type] :
      ( v94553(VarCurr)
    <=> ( v94555(VarCurr)
        & v94559(VarCurr) ) ) ).

tff(addAssignment_57216,axiom,
    ! [VarCurr: state_type] :
      ( v94559(VarCurr)
    <=> v94561(VarCurr) ) ).

tff(addAssignment_57215,axiom,
    ! [VarCurr: state_type] :
      ( v94561(VarCurr)
    <=> v90352(VarCurr) ) ).

tff(addAssignment_57214,axiom,
    ! [VarCurr: state_type] :
      ( v94555(VarCurr)
    <=> v94557(VarCurr) ) ).

tff(addAssignment_57213,axiom,
    ! [VarCurr: state_type] :
      ( v94557(VarCurr)
    <=> v11055(VarCurr,0) ) ).

tff(addAssignment_57212,axiom,
    ! [VarCurr: state_type] :
      ( v94534(VarCurr)
    <=> v94536(VarCurr) ) ).

tff(addAssignment_57211,axiom,
    ! [VarCurr: state_type] :
      ( v94536(VarCurr)
    <=> v94538(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8692,axiom,
    ! [VarCurr: state_type] :
      ( v94538(VarCurr)
    <=> ( v94540(VarCurr)
        & v94544(VarCurr) ) ) ).

tff(addAssignment_57210,axiom,
    ! [VarCurr: state_type] :
      ( v94544(VarCurr)
    <=> v94546(VarCurr) ) ).

tff(addAssignment_57209,axiom,
    ! [VarCurr: state_type] :
      ( v94546(VarCurr)
    <=> v90312(VarCurr) ) ).

tff(addAssignment_57208,axiom,
    ! [VarCurr: state_type] :
      ( v94540(VarCurr)
    <=> v94542(VarCurr) ) ).

tff(addAssignment_57207,axiom,
    ! [VarCurr: state_type] :
      ( v94542(VarCurr)
    <=> v9099(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94337(VarCurr,B)
      <=> ( v94339(VarCurr,B)
          & v90212(VarCurr,B) ) ) ) ).

tff(addAssignment_57206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94339(VarCurr,B)
      <=> v94341(VarCurr,B) ) ) ).

tff(addAssignment_57205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94341(VarCurr,B)
      <=> v94343(VarCurr,B) ) ) ).

tff(addAssignment_57204,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,11)
    <=> v94510(VarCurr) ) ).

tff(addAssignment_57203,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,10)
    <=> v94495(VarCurr) ) ).

tff(addAssignment_57202,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,9)
    <=> v94480(VarCurr) ) ).

tff(addAssignment_57201,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,8)
    <=> v94465(VarCurr) ) ).

tff(addAssignment_57200,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,7)
    <=> v94450(VarCurr) ) ).

tff(addAssignment_57199,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,6)
    <=> v94435(VarCurr) ) ).

tff(addAssignment_57198,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,5)
    <=> v94420(VarCurr) ) ).

tff(addAssignment_57197,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,4)
    <=> v94405(VarCurr) ) ).

tff(addAssignment_57196,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,3)
    <=> v94390(VarCurr) ) ).

tff(addAssignment_57195,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,2)
    <=> v94375(VarCurr) ) ).

tff(addAssignment_57194,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,1)
    <=> v94360(VarCurr) ) ).

tff(addAssignment_57193,axiom,
    ! [VarCurr: state_type] :
      ( v94343(VarCurr,0)
    <=> v94345(VarCurr) ) ).

tff(addAssignment_57192,axiom,
    ! [VarCurr: state_type] :
      ( v94510(VarCurr)
    <=> v94512(VarCurr) ) ).

tff(addAssignment_57191,axiom,
    ! [VarCurr: state_type] :
      ( v94512(VarCurr)
    <=> v94514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8691,axiom,
    ! [VarCurr: state_type] :
      ( v94514(VarCurr)
    <=> ( v94516(VarCurr)
        & v94520(VarCurr) ) ) ).

tff(addAssignment_57190,axiom,
    ! [VarCurr: state_type] :
      ( v94520(VarCurr)
    <=> v94522(VarCurr) ) ).

tff(addAssignment_57189,axiom,
    ! [VarCurr: state_type] :
      ( v94522(VarCurr)
    <=> v90172(VarCurr) ) ).

tff(addAssignment_57188,axiom,
    ! [VarCurr: state_type] :
      ( v94516(VarCurr)
    <=> v94518(VarCurr) ) ).

tff(addAssignment_57187,axiom,
    ! [VarCurr: state_type] :
      ( v94518(VarCurr)
    <=> v47849(VarCurr,0) ) ).

tff(addAssignment_57186,axiom,
    ! [VarCurr: state_type] :
      ( v94495(VarCurr)
    <=> v94497(VarCurr) ) ).

tff(addAssignment_57185,axiom,
    ! [VarCurr: state_type] :
      ( v94497(VarCurr)
    <=> v94499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8690,axiom,
    ! [VarCurr: state_type] :
      ( v94499(VarCurr)
    <=> ( v94501(VarCurr)
        & v94505(VarCurr) ) ) ).

tff(addAssignment_57184,axiom,
    ! [VarCurr: state_type] :
      ( v94505(VarCurr)
    <=> v94507(VarCurr) ) ).

tff(addAssignment_57183,axiom,
    ! [VarCurr: state_type] :
      ( v94507(VarCurr)
    <=> v90132(VarCurr) ) ).

tff(addAssignment_57182,axiom,
    ! [VarCurr: state_type] :
      ( v94501(VarCurr)
    <=> v94503(VarCurr) ) ).

tff(addAssignment_57181,axiom,
    ! [VarCurr: state_type] :
      ( v94503(VarCurr)
    <=> v46299(VarCurr,0) ) ).

tff(addAssignment_57180,axiom,
    ! [VarCurr: state_type] :
      ( v94480(VarCurr)
    <=> v94482(VarCurr) ) ).

tff(addAssignment_57179,axiom,
    ! [VarCurr: state_type] :
      ( v94482(VarCurr)
    <=> v94484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8689,axiom,
    ! [VarCurr: state_type] :
      ( v94484(VarCurr)
    <=> ( v94486(VarCurr)
        & v94490(VarCurr) ) ) ).

tff(addAssignment_57178,axiom,
    ! [VarCurr: state_type] :
      ( v94490(VarCurr)
    <=> v94492(VarCurr) ) ).

tff(addAssignment_57177,axiom,
    ! [VarCurr: state_type] :
      ( v94492(VarCurr)
    <=> v90092(VarCurr) ) ).

tff(addAssignment_57176,axiom,
    ! [VarCurr: state_type] :
      ( v94486(VarCurr)
    <=> v94488(VarCurr) ) ).

tff(addAssignment_57175,axiom,
    ! [VarCurr: state_type] :
      ( v94488(VarCurr)
    <=> v44749(VarCurr,0) ) ).

tff(addAssignment_57174,axiom,
    ! [VarCurr: state_type] :
      ( v94465(VarCurr)
    <=> v94467(VarCurr) ) ).

tff(addAssignment_57173,axiom,
    ! [VarCurr: state_type] :
      ( v94467(VarCurr)
    <=> v94469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8688,axiom,
    ! [VarCurr: state_type] :
      ( v94469(VarCurr)
    <=> ( v94471(VarCurr)
        & v94475(VarCurr) ) ) ).

tff(addAssignment_57172,axiom,
    ! [VarCurr: state_type] :
      ( v94475(VarCurr)
    <=> v94477(VarCurr) ) ).

tff(addAssignment_57171,axiom,
    ! [VarCurr: state_type] :
      ( v94477(VarCurr)
    <=> v90052(VarCurr) ) ).

tff(addAssignment_57170,axiom,
    ! [VarCurr: state_type] :
      ( v94471(VarCurr)
    <=> v94473(VarCurr) ) ).

tff(addAssignment_57169,axiom,
    ! [VarCurr: state_type] :
      ( v94473(VarCurr)
    <=> v43199(VarCurr,0) ) ).

tff(addAssignment_57168,axiom,
    ! [VarCurr: state_type] :
      ( v94450(VarCurr)
    <=> v94452(VarCurr) ) ).

tff(addAssignment_57167,axiom,
    ! [VarCurr: state_type] :
      ( v94452(VarCurr)
    <=> v94454(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8687,axiom,
    ! [VarCurr: state_type] :
      ( v94454(VarCurr)
    <=> ( v94456(VarCurr)
        & v94460(VarCurr) ) ) ).

tff(addAssignment_57166,axiom,
    ! [VarCurr: state_type] :
      ( v94460(VarCurr)
    <=> v94462(VarCurr) ) ).

tff(addAssignment_57165,axiom,
    ! [VarCurr: state_type] :
      ( v94462(VarCurr)
    <=> v90012(VarCurr) ) ).

tff(addAssignment_57164,axiom,
    ! [VarCurr: state_type] :
      ( v94456(VarCurr)
    <=> v94458(VarCurr) ) ).

tff(addAssignment_57163,axiom,
    ! [VarCurr: state_type] :
      ( v94458(VarCurr)
    <=> v41649(VarCurr,0) ) ).

tff(addAssignment_57162,axiom,
    ! [VarCurr: state_type] :
      ( v94435(VarCurr)
    <=> v94437(VarCurr) ) ).

tff(addAssignment_57161,axiom,
    ! [VarCurr: state_type] :
      ( v94437(VarCurr)
    <=> v94439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8686,axiom,
    ! [VarCurr: state_type] :
      ( v94439(VarCurr)
    <=> ( v94441(VarCurr)
        & v94445(VarCurr) ) ) ).

tff(addAssignment_57160,axiom,
    ! [VarCurr: state_type] :
      ( v94445(VarCurr)
    <=> v94447(VarCurr) ) ).

tff(addAssignment_57159,axiom,
    ! [VarCurr: state_type] :
      ( v94447(VarCurr)
    <=> v89972(VarCurr) ) ).

tff(addAssignment_57158,axiom,
    ! [VarCurr: state_type] :
      ( v94441(VarCurr)
    <=> v94443(VarCurr) ) ).

tff(addAssignment_57157,axiom,
    ! [VarCurr: state_type] :
      ( v94443(VarCurr)
    <=> v40099(VarCurr,0) ) ).

tff(addAssignment_57156,axiom,
    ! [VarCurr: state_type] :
      ( v94420(VarCurr)
    <=> v94422(VarCurr) ) ).

tff(addAssignment_57155,axiom,
    ! [VarCurr: state_type] :
      ( v94422(VarCurr)
    <=> v94424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8685,axiom,
    ! [VarCurr: state_type] :
      ( v94424(VarCurr)
    <=> ( v94426(VarCurr)
        & v94430(VarCurr) ) ) ).

tff(addAssignment_57154,axiom,
    ! [VarCurr: state_type] :
      ( v94430(VarCurr)
    <=> v94432(VarCurr) ) ).

tff(addAssignment_57153,axiom,
    ! [VarCurr: state_type] :
      ( v94432(VarCurr)
    <=> v89932(VarCurr) ) ).

tff(addAssignment_57152,axiom,
    ! [VarCurr: state_type] :
      ( v94426(VarCurr)
    <=> v94428(VarCurr) ) ).

tff(addAssignment_57151,axiom,
    ! [VarCurr: state_type] :
      ( v94428(VarCurr)
    <=> v38549(VarCurr,0) ) ).

tff(addAssignment_57150,axiom,
    ! [VarCurr: state_type] :
      ( v94405(VarCurr)
    <=> v94407(VarCurr) ) ).

tff(addAssignment_57149,axiom,
    ! [VarCurr: state_type] :
      ( v94407(VarCurr)
    <=> v94409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8684,axiom,
    ! [VarCurr: state_type] :
      ( v94409(VarCurr)
    <=> ( v94411(VarCurr)
        & v94415(VarCurr) ) ) ).

tff(addAssignment_57148,axiom,
    ! [VarCurr: state_type] :
      ( v94415(VarCurr)
    <=> v94417(VarCurr) ) ).

tff(addAssignment_57147,axiom,
    ! [VarCurr: state_type] :
      ( v94417(VarCurr)
    <=> v89892(VarCurr) ) ).

tff(addAssignment_57146,axiom,
    ! [VarCurr: state_type] :
      ( v94411(VarCurr)
    <=> v94413(VarCurr) ) ).

tff(addAssignment_57145,axiom,
    ! [VarCurr: state_type] :
      ( v94413(VarCurr)
    <=> v36999(VarCurr,0) ) ).

tff(addAssignment_57144,axiom,
    ! [VarCurr: state_type] :
      ( v94390(VarCurr)
    <=> v94392(VarCurr) ) ).

tff(addAssignment_57143,axiom,
    ! [VarCurr: state_type] :
      ( v94392(VarCurr)
    <=> v94394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8683,axiom,
    ! [VarCurr: state_type] :
      ( v94394(VarCurr)
    <=> ( v94396(VarCurr)
        & v94400(VarCurr) ) ) ).

tff(addAssignment_57142,axiom,
    ! [VarCurr: state_type] :
      ( v94400(VarCurr)
    <=> v94402(VarCurr) ) ).

tff(addAssignment_57141,axiom,
    ! [VarCurr: state_type] :
      ( v94402(VarCurr)
    <=> v89852(VarCurr) ) ).

tff(addAssignment_57140,axiom,
    ! [VarCurr: state_type] :
      ( v94396(VarCurr)
    <=> v94398(VarCurr) ) ).

tff(addAssignment_57139,axiom,
    ! [VarCurr: state_type] :
      ( v94398(VarCurr)
    <=> v35449(VarCurr,0) ) ).

tff(addAssignment_57138,axiom,
    ! [VarCurr: state_type] :
      ( v94375(VarCurr)
    <=> v94377(VarCurr) ) ).

tff(addAssignment_57137,axiom,
    ! [VarCurr: state_type] :
      ( v94377(VarCurr)
    <=> v94379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8682,axiom,
    ! [VarCurr: state_type] :
      ( v94379(VarCurr)
    <=> ( v94381(VarCurr)
        & v94385(VarCurr) ) ) ).

tff(addAssignment_57136,axiom,
    ! [VarCurr: state_type] :
      ( v94385(VarCurr)
    <=> v94387(VarCurr) ) ).

tff(addAssignment_57135,axiom,
    ! [VarCurr: state_type] :
      ( v94387(VarCurr)
    <=> v89812(VarCurr) ) ).

tff(addAssignment_57134,axiom,
    ! [VarCurr: state_type] :
      ( v94381(VarCurr)
    <=> v94383(VarCurr) ) ).

tff(addAssignment_57133,axiom,
    ! [VarCurr: state_type] :
      ( v94383(VarCurr)
    <=> v8510(VarCurr,0) ) ).

tff(addAssignment_57132,axiom,
    ! [VarCurr: state_type] :
      ( v94360(VarCurr)
    <=> v94362(VarCurr) ) ).

tff(addAssignment_57131,axiom,
    ! [VarCurr: state_type] :
      ( v94362(VarCurr)
    <=> v94364(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8681,axiom,
    ! [VarCurr: state_type] :
      ( v94364(VarCurr)
    <=> ( v94366(VarCurr)
        & v94370(VarCurr) ) ) ).

tff(addAssignment_57130,axiom,
    ! [VarCurr: state_type] :
      ( v94370(VarCurr)
    <=> v94372(VarCurr) ) ).

tff(addAssignment_57129,axiom,
    ! [VarCurr: state_type] :
      ( v94372(VarCurr)
    <=> v89772(VarCurr) ) ).

tff(addAssignment_57128,axiom,
    ! [VarCurr: state_type] :
      ( v94366(VarCurr)
    <=> v94368(VarCurr) ) ).

tff(addAssignment_57127,axiom,
    ! [VarCurr: state_type] :
      ( v94368(VarCurr)
    <=> v6242(VarCurr,0) ) ).

tff(addAssignment_57126,axiom,
    ! [VarCurr: state_type] :
      ( v94345(VarCurr)
    <=> v94347(VarCurr) ) ).

tff(addAssignment_57125,axiom,
    ! [VarCurr: state_type] :
      ( v94347(VarCurr)
    <=> v94349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8680,axiom,
    ! [VarCurr: state_type] :
      ( v94349(VarCurr)
    <=> ( v94351(VarCurr)
        & v94355(VarCurr) ) ) ).

tff(addAssignment_57124,axiom,
    ! [VarCurr: state_type] :
      ( v94355(VarCurr)
    <=> v94357(VarCurr) ) ).

tff(addAssignment_57123,axiom,
    ! [VarCurr: state_type] :
      ( v94357(VarCurr)
    <=> v89732(VarCurr) ) ).

tff(addAssignment_57122,axiom,
    ! [VarCurr: state_type] :
      ( v94351(VarCurr)
    <=> v94353(VarCurr) ) ).

tff(addAssignment_57121,axiom,
    ! [VarCurr: state_type] :
      ( v94353(VarCurr)
    <=> v4121(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8679,axiom,
    ! [VarCurr: state_type] :
      ( v90990(VarCurr)
    <=> ( v94323(VarCurr)
        & v94329(VarCurr) ) ) ).

tff(writeUnaryOperator_4300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94329(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8678,axiom,
    ! [VarCurr: state_type] :
      ( v94323(VarCurr)
    <=> ( v94324(VarCurr)
        & v2040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8677,axiom,
    ! [VarCurr: state_type] :
      ( v94324(VarCurr)
    <=> ( v94325(VarCurr)
        | v94292(VarCurr) ) ) ).

tff(writeUnaryOperator_4299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94325(VarCurr)
    <=> v94326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8676,axiom,
    ! [VarCurr: state_type] :
      ( v94326(VarCurr)
    <=> ( v94327(VarCurr)
        & v93475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8675,axiom,
    ! [VarCurr: state_type] :
      ( v94327(VarCurr)
    <=> ( v94328(VarCurr)
        & v92642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8674,axiom,
    ! [VarCurr: state_type] :
      ( v94328(VarCurr)
    <=> ( v90992(VarCurr)
        & v91825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8673,axiom,
    ! [VarCurr: state_type] :
      ( v94292(VarCurr)
    <=> ( v94318(VarCurr)
        & v94319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8672,axiom,
    ! [VarCurr: state_type] :
      ( v94319(VarCurr)
    <=> ( v94320(VarCurr)
        | v94294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8671,axiom,
    ! [VarCurr: state_type] :
      ( v94320(VarCurr)
    <=> ( v90859(VarCurr)
        & v94321(VarCurr) ) ) ).

tff(writeUnaryOperator_4298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v94321(VarCurr)
    <=> v90968(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_490,axiom,
    ! [VarCurr: state_type] :
      ( v94318(VarCurr)
    <=> ( ( v90800(VarCurr,1)
        <=> $false )
        & ( v90800(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_57120,axiom,
    ! [VarCurr: state_type] :
      ( v94294(VarCurr)
    <=> v90861(VarCurr,0) ) ).

tff(addAssignment_57119,axiom,
    ! [VarCurr: state_type] :
      ( v90861(VarCurr,0)
    <=> v90863(VarCurr,0) ) ).

tff(addAssignment_57118,axiom,
    ! [VarNext: state_type] :
      ( v90863(VarNext,0)
    <=> v94310(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94311(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v94310(VarNext,B)
            <=> v90863(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1036,axiom,
    ! [VarNext: state_type] :
      ( v94311(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v94310(VarNext,B)
          <=> v90961(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94311(VarNext)
      <=> v94312(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94312(VarNext)
      <=> ( v94314(VarNext)
          & v90946(VarNext) ) ) ) ).

tff(writeUnaryOperator_4297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94314(VarNext)
      <=> v90955(VarNext) ) ) ).

tff(addAssignment_57117,axiom,
    ! [VarCurr: state_type] :
      ( v90873(VarCurr,0)
    <=> v90875(VarCurr,0) ) ).

tff(addAssignment_57116,axiom,
    ! [VarCurr: state_type] :
      ( v90875(VarCurr,0)
    <=> v90877(VarCurr,0) ) ).

tff(addAssignment_57115,axiom,
    ! [VarCurr: state_type] :
      ( v90877(VarCurr,0)
    <=> v90943(VarCurr,0) ) ).

tff(addAssignment_57114,axiom,
    ! [VarCurr: state_type] :
      ( v90944(VarCurr)
    <=> v94297(VarCurr) ) ).

tff(addAssignment_57113,axiom,
    ! [VarCurr: state_type] :
      ( v94297(VarCurr)
    <=> v94299(VarCurr) ) ).

tff(addAssignment_57112,axiom,
    ! [VarCurr: state_type] :
      ( v94299(VarCurr)
    <=> v90885(VarCurr,0) ) ).

tff(addAssignment_57111,axiom,
    ! [VarCurr: state_type] :
      ( v90885(VarCurr,0)
    <=> v90887(VarCurr,0) ) ).

tff(addAssignment_57110,axiom,
    ! [VarNext: state_type] :
      ( v90887(VarNext,0)
    <=> v94302(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94303(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v94302(VarNext,B)
            <=> v90887(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1035,axiom,
    ! [VarNext: state_type] :
      ( v94303(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v94302(VarNext,B)
          <=> v90937(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94303(VarNext)
      <=> v94304(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v94304(VarNext)
      <=> ( v94306(VarNext)
          & v90922(VarNext) ) ) ) ).

tff(writeUnaryOperator_4296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v94306(VarNext)
      <=> v90931(VarNext) ) ) ).

tff(addAssignment_57109,axiom,
    ! [VarCurr: state_type] :
      ( v90897(VarCurr,0)
    <=> v90899(VarCurr,0) ) ).

tff(addAssignment_57108,axiom,
    ! [VarCurr: state_type] :
      ( v90899(VarCurr,0)
    <=> v90913(VarCurr,0) ) ).

tff(addAssignment_57107,axiom,
    ! [VarCurr: state_type] :
      ( v90901(VarCurr,0)
    <=> v90908(VarCurr,0) ) ).

tff(addAssignment_57106,axiom,
    ! [VarCurr: state_type] :
      ( v90910(VarCurr)
    <=> v90905(VarCurr,0) ) ).

tff(addAssignment_57105,axiom,
    ! [VarCurr: state_type] :
      ( v90905(VarCurr,0)
    <=> v90907(VarCurr,0) ) ).

tff(addAssignment_57104,axiom,
    ! [VarCurr: state_type] :
      ( v93475(VarCurr)
    <=> v93477(VarCurr) ) ).

tff(addAssignment_57103,axiom,
    ! [VarCurr: state_type] :
      ( v93477(VarCurr)
    <=> v93479(VarCurr) ) ).

tff(addAssignment_57102,axiom,
    ! [VarCurr: state_type] :
      ( v93479(VarCurr)
    <=> v93481(VarCurr) ) ).

tff(addAssignment_57101,axiom,
    ! [VarCurr: state_type] :
      ( v93481(VarCurr)
    <=> v93483(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_489,axiom,
    ! [VarCurr: state_type] :
      ( v93483(VarCurr)
    <=> ( ( v93485(VarCurr,11)
        <=> v93536(VarCurr,11) )
        & ( v93485(VarCurr,10)
        <=> v93536(VarCurr,10) )
        & ( v93485(VarCurr,9)
        <=> v93536(VarCurr,9) )
        & ( v93485(VarCurr,8)
        <=> v93536(VarCurr,8) )
        & ( v93485(VarCurr,7)
        <=> v93536(VarCurr,7) )
        & ( v93485(VarCurr,6)
        <=> v93536(VarCurr,6) )
        & ( v93485(VarCurr,5)
        <=> v93536(VarCurr,5) )
        & ( v93485(VarCurr,4)
        <=> v93536(VarCurr,4) )
        & ( v93485(VarCurr,3)
        <=> v93536(VarCurr,3) )
        & ( v93485(VarCurr,2)
        <=> v93536(VarCurr,2) )
        & ( v93485(VarCurr,1)
        <=> v93536(VarCurr,1) )
        & ( v93485(VarCurr,0)
        <=> v93536(VarCurr,0) ) ) ) ).

tff(addAssignment_57100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93536(VarCurr,B)
      <=> v93538(VarCurr,B) ) ) ).

tff(addAssignment_57099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93538(VarCurr,B)
      <=> v93540(VarCurr,B) ) ) ).

tff(addAssignment_57098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93540(VarCurr,B)
      <=> v93542(VarCurr,B) ) ) ).

tff(addAssignment_57097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93542(VarCurr,B)
      <=> v93544(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93544(VarCurr,B)
      <=> ( v94284(VarCurr,B)
          | v94287(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94287(VarCurr,B)
      <=> ( v94041(VarCurr,B)
          & v94288(VarCurr,B) ) ) ) ).

tff(addAssignment_57096,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,0)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57095,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,1)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57094,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,2)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57093,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,3)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57092,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,4)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57091,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,5)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57090,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,6)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57089,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,7)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57088,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,8)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57087,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,9)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57086,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,10)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57085,axiom,
    ! [VarCurr: state_type] :
      ( v94288(VarCurr,11)
    <=> v94289(VarCurr) ) ).

tff(addAssignment_57084,axiom,
    ! [VarCurr: state_type] :
      ( v94289(VarCurr)
    <=> v94274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94284(VarCurr,B)
      <=> ( v93546(VarCurr,B)
          & v94285(VarCurr,B) ) ) ) ).

tff(addAssignment_57083,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,0)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57082,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,1)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57081,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,2)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57080,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,3)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57079,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,4)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57078,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,5)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57077,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,6)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57076,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,7)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57075,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,8)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57074,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,9)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57073,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,10)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57072,axiom,
    ! [VarCurr: state_type] :
      ( v94285(VarCurr,11)
    <=> v94286(VarCurr) ) ).

tff(addAssignment_57071,axiom,
    ! [VarCurr: state_type] :
      ( v94286(VarCurr)
    <=> v94031(VarCurr) ) ).

tff(addAssignment_57070,axiom,
    ! [VarCurr: state_type] :
      ( v94274(VarCurr)
    <=> v94276(VarCurr) ) ).

tff(addAssignment_57069,axiom,
    ! [VarCurr: state_type] :
      ( v94276(VarCurr)
    <=> v94278(VarCurr) ) ).

tff(addAssignment_57068,axiom,
    ! [VarCurr: state_type] :
      ( v94278(VarCurr)
    <=> v94280(VarCurr) ) ).

tff(addAssignment_57067,axiom,
    ! [VarCurr: state_type] :
      ( v94280(VarCurr)
    <=> v94282(VarCurr) ) ).

tff(addAssignment_57066,axiom,
    ! [VarCurr: state_type] :
      ( v94282(VarCurr)
    <=> v92708(VarCurr) ) ).

tff(addAssignment_57065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v94041(VarCurr,B)
      <=> v94043(VarCurr,B) ) ) ).

tff(addAssignment_57064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v94043(VarCurr,B)
      <=> v94045(VarCurr,B) ) ) ).

tff(addAssignment_57063,axiom,
    ! [VarCurr: state_type] :
      ( ( v94043(VarCurr,11)
      <=> $false )
      & ( v94043(VarCurr,10)
      <=> $false )
      & ( v94043(VarCurr,9)
      <=> $false )
      & ( v94043(VarCurr,8)
      <=> $false )
      & ( v94043(VarCurr,7)
      <=> $false )
      & ( v94043(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_57062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v94045(VarCurr,B)
      <=> v94047(VarCurr,B) ) ) ).

tff(addAssignment_57061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v94047(VarCurr,B)
      <=> v94049(VarCurr,B) ) ) ).

tff(addAssignment_57060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v94049(VarCurr,B)
      <=> v94051(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3651,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,5)
    <=> ( v94237(VarCurr)
      <~> v94053(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3650,axiom,
    ! [VarCurr: state_type] :
      ( v94237(VarCurr)
    <=> ( v94238(VarCurr)
      <~> v94053(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3649,axiom,
    ! [VarCurr: state_type] :
      ( v94238(VarCurr)
    <=> ( v94239(VarCurr)
      <~> v94053(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3648,axiom,
    ! [VarCurr: state_type] :
      ( v94239(VarCurr)
    <=> ( v94240(VarCurr)
      <~> v94053(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3647,axiom,
    ! [VarCurr: state_type] :
      ( v94240(VarCurr)
    <=> ( v94241(VarCurr)
      <~> v94053(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3646,axiom,
    ! [VarCurr: state_type] :
      ( v94241(VarCurr)
    <=> ( v94242(VarCurr)
      <~> v94053(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3645,axiom,
    ! [VarCurr: state_type] :
      ( v94242(VarCurr)
    <=> ( v94243(VarCurr)
      <~> v94053(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3644,axiom,
    ! [VarCurr: state_type] :
      ( v94243(VarCurr)
    <=> ( v94244(VarCurr)
      <~> v94053(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3643,axiom,
    ! [VarCurr: state_type] :
      ( v94244(VarCurr)
    <=> ( v94245(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3642,axiom,
    ! [VarCurr: state_type] :
      ( v94245(VarCurr)
    <=> ( v94246(VarCurr)
      <~> v94053(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3641,axiom,
    ! [VarCurr: state_type] :
      ( v94246(VarCurr)
    <=> ( v94247(VarCurr)
      <~> v94053(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3640,axiom,
    ! [VarCurr: state_type] :
      ( v94247(VarCurr)
    <=> ( v94248(VarCurr)
      <~> v94053(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3639,axiom,
    ! [VarCurr: state_type] :
      ( v94248(VarCurr)
    <=> ( v94249(VarCurr)
      <~> v94053(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3638,axiom,
    ! [VarCurr: state_type] :
      ( v94249(VarCurr)
    <=> ( v94250(VarCurr)
      <~> v94053(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3637,axiom,
    ! [VarCurr: state_type] :
      ( v94250(VarCurr)
    <=> ( v94251(VarCurr)
      <~> v94053(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3636,axiom,
    ! [VarCurr: state_type] :
      ( v94251(VarCurr)
    <=> ( v94252(VarCurr)
      <~> v94053(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3635,axiom,
    ! [VarCurr: state_type] :
      ( v94252(VarCurr)
    <=> ( v94253(VarCurr)
      <~> v94053(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3634,axiom,
    ! [VarCurr: state_type] :
      ( v94253(VarCurr)
    <=> ( v94254(VarCurr)
      <~> v94053(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3633,axiom,
    ! [VarCurr: state_type] :
      ( v94254(VarCurr)
    <=> ( v94255(VarCurr)
      <~> v94053(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3632,axiom,
    ! [VarCurr: state_type] :
      ( v94255(VarCurr)
    <=> ( v94256(VarCurr)
      <~> v94053(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3631,axiom,
    ! [VarCurr: state_type] :
      ( v94256(VarCurr)
    <=> ( v94257(VarCurr)
      <~> v94053(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3630,axiom,
    ! [VarCurr: state_type] :
      ( v94257(VarCurr)
    <=> ( v94258(VarCurr)
      <~> v94053(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3629,axiom,
    ! [VarCurr: state_type] :
      ( v94258(VarCurr)
    <=> ( v94259(VarCurr)
      <~> v94053(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3628,axiom,
    ! [VarCurr: state_type] :
      ( v94259(VarCurr)
    <=> ( v94260(VarCurr)
      <~> v94053(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3627,axiom,
    ! [VarCurr: state_type] :
      ( v94260(VarCurr)
    <=> ( v94261(VarCurr)
      <~> v94053(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3626,axiom,
    ! [VarCurr: state_type] :
      ( v94261(VarCurr)
    <=> ( v94262(VarCurr)
      <~> v94053(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3625,axiom,
    ! [VarCurr: state_type] :
      ( v94262(VarCurr)
    <=> ( v94263(VarCurr)
      <~> v94053(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3624,axiom,
    ! [VarCurr: state_type] :
      ( v94263(VarCurr)
    <=> ( v94264(VarCurr)
      <~> v94053(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3623,axiom,
    ! [VarCurr: state_type] :
      ( v94264(VarCurr)
    <=> ( v94265(VarCurr)
      <~> v94053(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3622,axiom,
    ! [VarCurr: state_type] :
      ( v94265(VarCurr)
    <=> ( v94266(VarCurr)
      <~> v94053(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3621,axiom,
    ! [VarCurr: state_type] :
      ( v94266(VarCurr)
    <=> ( v94267(VarCurr)
      <~> v94053(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3620,axiom,
    ! [VarCurr: state_type] :
      ( v94267(VarCurr)
    <=> ( v94268(VarCurr)
      <~> v94053(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3619,axiom,
    ! [VarCurr: state_type] :
      ( v94268(VarCurr)
    <=> ( v94269(VarCurr)
      <~> v94053(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3618,axiom,
    ! [VarCurr: state_type] :
      ( v94269(VarCurr)
    <=> ( v94270(VarCurr)
      <~> v94053(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3617,axiom,
    ! [VarCurr: state_type] :
      ( v94270(VarCurr)
    <=> ( v94271(VarCurr)
      <~> v94053(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3616,axiom,
    ! [VarCurr: state_type] :
      ( v94271(VarCurr)
    <=> ( v94053(VarCurr,71)
      <~> v94053(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3615,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,4)
    <=> ( v94201(VarCurr)
      <~> v94053(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3614,axiom,
    ! [VarCurr: state_type] :
      ( v94201(VarCurr)
    <=> ( v94202(VarCurr)
      <~> v94053(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3613,axiom,
    ! [VarCurr: state_type] :
      ( v94202(VarCurr)
    <=> ( v94203(VarCurr)
      <~> v94053(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3612,axiom,
    ! [VarCurr: state_type] :
      ( v94203(VarCurr)
    <=> ( v94204(VarCurr)
      <~> v94053(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3611,axiom,
    ! [VarCurr: state_type] :
      ( v94204(VarCurr)
    <=> ( v94205(VarCurr)
      <~> v94053(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3610,axiom,
    ! [VarCurr: state_type] :
      ( v94205(VarCurr)
    <=> ( v94206(VarCurr)
      <~> v94053(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3609,axiom,
    ! [VarCurr: state_type] :
      ( v94206(VarCurr)
    <=> ( v94207(VarCurr)
      <~> v94053(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3608,axiom,
    ! [VarCurr: state_type] :
      ( v94207(VarCurr)
    <=> ( v94208(VarCurr)
      <~> v94053(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3607,axiom,
    ! [VarCurr: state_type] :
      ( v94208(VarCurr)
    <=> ( v94209(VarCurr)
      <~> v94053(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3606,axiom,
    ! [VarCurr: state_type] :
      ( v94209(VarCurr)
    <=> ( v94210(VarCurr)
      <~> v94053(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3605,axiom,
    ! [VarCurr: state_type] :
      ( v94210(VarCurr)
    <=> ( v94211(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3604,axiom,
    ! [VarCurr: state_type] :
      ( v94211(VarCurr)
    <=> ( v94212(VarCurr)
      <~> v94053(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3603,axiom,
    ! [VarCurr: state_type] :
      ( v94212(VarCurr)
    <=> ( v94213(VarCurr)
      <~> v94053(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3602,axiom,
    ! [VarCurr: state_type] :
      ( v94213(VarCurr)
    <=> ( v94214(VarCurr)
      <~> v94053(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3601,axiom,
    ! [VarCurr: state_type] :
      ( v94214(VarCurr)
    <=> ( v94215(VarCurr)
      <~> v94053(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3600,axiom,
    ! [VarCurr: state_type] :
      ( v94215(VarCurr)
    <=> ( v94216(VarCurr)
      <~> v94053(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3599,axiom,
    ! [VarCurr: state_type] :
      ( v94216(VarCurr)
    <=> ( v94217(VarCurr)
      <~> v94053(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3598,axiom,
    ! [VarCurr: state_type] :
      ( v94217(VarCurr)
    <=> ( v94218(VarCurr)
      <~> v94053(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3597,axiom,
    ! [VarCurr: state_type] :
      ( v94218(VarCurr)
    <=> ( v94219(VarCurr)
      <~> v94053(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3596,axiom,
    ! [VarCurr: state_type] :
      ( v94219(VarCurr)
    <=> ( v94220(VarCurr)
      <~> v94053(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3595,axiom,
    ! [VarCurr: state_type] :
      ( v94220(VarCurr)
    <=> ( v94221(VarCurr)
      <~> v94053(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3594,axiom,
    ! [VarCurr: state_type] :
      ( v94221(VarCurr)
    <=> ( v94222(VarCurr)
      <~> v94053(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3593,axiom,
    ! [VarCurr: state_type] :
      ( v94222(VarCurr)
    <=> ( v94223(VarCurr)
      <~> v94053(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3592,axiom,
    ! [VarCurr: state_type] :
      ( v94223(VarCurr)
    <=> ( v94224(VarCurr)
      <~> v94053(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3591,axiom,
    ! [VarCurr: state_type] :
      ( v94224(VarCurr)
    <=> ( v94225(VarCurr)
      <~> v94053(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3590,axiom,
    ! [VarCurr: state_type] :
      ( v94225(VarCurr)
    <=> ( v94226(VarCurr)
      <~> v94053(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3589,axiom,
    ! [VarCurr: state_type] :
      ( v94226(VarCurr)
    <=> ( v94227(VarCurr)
      <~> v94053(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3588,axiom,
    ! [VarCurr: state_type] :
      ( v94227(VarCurr)
    <=> ( v94228(VarCurr)
      <~> v94053(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3587,axiom,
    ! [VarCurr: state_type] :
      ( v94228(VarCurr)
    <=> ( v94229(VarCurr)
      <~> v94053(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3586,axiom,
    ! [VarCurr: state_type] :
      ( v94229(VarCurr)
    <=> ( v94230(VarCurr)
      <~> v94053(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3585,axiom,
    ! [VarCurr: state_type] :
      ( v94230(VarCurr)
    <=> ( v94231(VarCurr)
      <~> v94053(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3584,axiom,
    ! [VarCurr: state_type] :
      ( v94231(VarCurr)
    <=> ( v94232(VarCurr)
      <~> v94053(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3583,axiom,
    ! [VarCurr: state_type] :
      ( v94232(VarCurr)
    <=> ( v94233(VarCurr)
      <~> v94053(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3582,axiom,
    ! [VarCurr: state_type] :
      ( v94233(VarCurr)
    <=> ( v94234(VarCurr)
      <~> v94053(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3581,axiom,
    ! [VarCurr: state_type] :
      ( v94234(VarCurr)
    <=> ( v94235(VarCurr)
      <~> v94053(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3580,axiom,
    ! [VarCurr: state_type] :
      ( v94235(VarCurr)
    <=> ( v94053(VarCurr,71)
      <~> v94053(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3579,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,3)
    <=> ( v94164(VarCurr)
      <~> v94053(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3578,axiom,
    ! [VarCurr: state_type] :
      ( v94164(VarCurr)
    <=> ( v94165(VarCurr)
      <~> v94053(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3577,axiom,
    ! [VarCurr: state_type] :
      ( v94165(VarCurr)
    <=> ( v94166(VarCurr)
      <~> v94053(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3576,axiom,
    ! [VarCurr: state_type] :
      ( v94166(VarCurr)
    <=> ( v94167(VarCurr)
      <~> v94053(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3575,axiom,
    ! [VarCurr: state_type] :
      ( v94167(VarCurr)
    <=> ( v94168(VarCurr)
      <~> v94053(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3574,axiom,
    ! [VarCurr: state_type] :
      ( v94168(VarCurr)
    <=> ( v94169(VarCurr)
      <~> v94053(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3573,axiom,
    ! [VarCurr: state_type] :
      ( v94169(VarCurr)
    <=> ( v94170(VarCurr)
      <~> v94053(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3572,axiom,
    ! [VarCurr: state_type] :
      ( v94170(VarCurr)
    <=> ( v94171(VarCurr)
      <~> v94053(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3571,axiom,
    ! [VarCurr: state_type] :
      ( v94171(VarCurr)
    <=> ( v94172(VarCurr)
      <~> v94053(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3570,axiom,
    ! [VarCurr: state_type] :
      ( v94172(VarCurr)
    <=> ( v94173(VarCurr)
      <~> v94053(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3569,axiom,
    ! [VarCurr: state_type] :
      ( v94173(VarCurr)
    <=> ( v94174(VarCurr)
      <~> v94053(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3568,axiom,
    ! [VarCurr: state_type] :
      ( v94174(VarCurr)
    <=> ( v94175(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3567,axiom,
    ! [VarCurr: state_type] :
      ( v94175(VarCurr)
    <=> ( v94176(VarCurr)
      <~> v94053(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3566,axiom,
    ! [VarCurr: state_type] :
      ( v94176(VarCurr)
    <=> ( v94177(VarCurr)
      <~> v94053(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3565,axiom,
    ! [VarCurr: state_type] :
      ( v94177(VarCurr)
    <=> ( v94178(VarCurr)
      <~> v94053(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3564,axiom,
    ! [VarCurr: state_type] :
      ( v94178(VarCurr)
    <=> ( v94179(VarCurr)
      <~> v94053(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3563,axiom,
    ! [VarCurr: state_type] :
      ( v94179(VarCurr)
    <=> ( v94180(VarCurr)
      <~> v94053(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3562,axiom,
    ! [VarCurr: state_type] :
      ( v94180(VarCurr)
    <=> ( v94181(VarCurr)
      <~> v94053(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3561,axiom,
    ! [VarCurr: state_type] :
      ( v94181(VarCurr)
    <=> ( v94182(VarCurr)
      <~> v94053(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3560,axiom,
    ! [VarCurr: state_type] :
      ( v94182(VarCurr)
    <=> ( v94183(VarCurr)
      <~> v94053(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3559,axiom,
    ! [VarCurr: state_type] :
      ( v94183(VarCurr)
    <=> ( v94184(VarCurr)
      <~> v94053(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3558,axiom,
    ! [VarCurr: state_type] :
      ( v94184(VarCurr)
    <=> ( v94185(VarCurr)
      <~> v94053(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3557,axiom,
    ! [VarCurr: state_type] :
      ( v94185(VarCurr)
    <=> ( v94186(VarCurr)
      <~> v94053(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3556,axiom,
    ! [VarCurr: state_type] :
      ( v94186(VarCurr)
    <=> ( v94187(VarCurr)
      <~> v94053(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3555,axiom,
    ! [VarCurr: state_type] :
      ( v94187(VarCurr)
    <=> ( v94188(VarCurr)
      <~> v94053(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3554,axiom,
    ! [VarCurr: state_type] :
      ( v94188(VarCurr)
    <=> ( v94189(VarCurr)
      <~> v94053(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3553,axiom,
    ! [VarCurr: state_type] :
      ( v94189(VarCurr)
    <=> ( v94190(VarCurr)
      <~> v94053(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3552,axiom,
    ! [VarCurr: state_type] :
      ( v94190(VarCurr)
    <=> ( v94191(VarCurr)
      <~> v94053(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3551,axiom,
    ! [VarCurr: state_type] :
      ( v94191(VarCurr)
    <=> ( v94192(VarCurr)
      <~> v94053(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3550,axiom,
    ! [VarCurr: state_type] :
      ( v94192(VarCurr)
    <=> ( v94193(VarCurr)
      <~> v94053(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3549,axiom,
    ! [VarCurr: state_type] :
      ( v94193(VarCurr)
    <=> ( v94194(VarCurr)
      <~> v94053(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3548,axiom,
    ! [VarCurr: state_type] :
      ( v94194(VarCurr)
    <=> ( v94195(VarCurr)
      <~> v94053(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3547,axiom,
    ! [VarCurr: state_type] :
      ( v94195(VarCurr)
    <=> ( v94196(VarCurr)
      <~> v94053(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3546,axiom,
    ! [VarCurr: state_type] :
      ( v94196(VarCurr)
    <=> ( v94197(VarCurr)
      <~> v94053(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3545,axiom,
    ! [VarCurr: state_type] :
      ( v94197(VarCurr)
    <=> ( v94198(VarCurr)
      <~> v94053(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3544,axiom,
    ! [VarCurr: state_type] :
      ( v94198(VarCurr)
    <=> ( v94199(VarCurr)
      <~> v94053(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3543,axiom,
    ! [VarCurr: state_type] :
      ( v94199(VarCurr)
    <=> ( v94053(VarCurr,71)
      <~> v94053(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3542,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,2)
    <=> ( v94126(VarCurr)
      <~> v94053(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3541,axiom,
    ! [VarCurr: state_type] :
      ( v94126(VarCurr)
    <=> ( v94127(VarCurr)
      <~> v94053(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3540,axiom,
    ! [VarCurr: state_type] :
      ( v94127(VarCurr)
    <=> ( v94128(VarCurr)
      <~> v94053(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3539,axiom,
    ! [VarCurr: state_type] :
      ( v94128(VarCurr)
    <=> ( v94129(VarCurr)
      <~> v94053(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3538,axiom,
    ! [VarCurr: state_type] :
      ( v94129(VarCurr)
    <=> ( v94130(VarCurr)
      <~> v94053(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3537,axiom,
    ! [VarCurr: state_type] :
      ( v94130(VarCurr)
    <=> ( v94131(VarCurr)
      <~> v94053(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3536,axiom,
    ! [VarCurr: state_type] :
      ( v94131(VarCurr)
    <=> ( v94132(VarCurr)
      <~> v94053(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3535,axiom,
    ! [VarCurr: state_type] :
      ( v94132(VarCurr)
    <=> ( v94133(VarCurr)
      <~> v94053(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3534,axiom,
    ! [VarCurr: state_type] :
      ( v94133(VarCurr)
    <=> ( v94134(VarCurr)
      <~> v94053(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3533,axiom,
    ! [VarCurr: state_type] :
      ( v94134(VarCurr)
    <=> ( v94135(VarCurr)
      <~> v94053(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3532,axiom,
    ! [VarCurr: state_type] :
      ( v94135(VarCurr)
    <=> ( v94136(VarCurr)
      <~> v94053(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3531,axiom,
    ! [VarCurr: state_type] :
      ( v94136(VarCurr)
    <=> ( v94137(VarCurr)
      <~> v94053(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3530,axiom,
    ! [VarCurr: state_type] :
      ( v94137(VarCurr)
    <=> ( v94138(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3529,axiom,
    ! [VarCurr: state_type] :
      ( v94138(VarCurr)
    <=> ( v94139(VarCurr)
      <~> v94053(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3528,axiom,
    ! [VarCurr: state_type] :
      ( v94139(VarCurr)
    <=> ( v94140(VarCurr)
      <~> v94053(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3527,axiom,
    ! [VarCurr: state_type] :
      ( v94140(VarCurr)
    <=> ( v94141(VarCurr)
      <~> v94053(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3526,axiom,
    ! [VarCurr: state_type] :
      ( v94141(VarCurr)
    <=> ( v94142(VarCurr)
      <~> v94053(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3525,axiom,
    ! [VarCurr: state_type] :
      ( v94142(VarCurr)
    <=> ( v94143(VarCurr)
      <~> v94053(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3524,axiom,
    ! [VarCurr: state_type] :
      ( v94143(VarCurr)
    <=> ( v94144(VarCurr)
      <~> v94053(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3523,axiom,
    ! [VarCurr: state_type] :
      ( v94144(VarCurr)
    <=> ( v94145(VarCurr)
      <~> v94053(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3522,axiom,
    ! [VarCurr: state_type] :
      ( v94145(VarCurr)
    <=> ( v94146(VarCurr)
      <~> v94053(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3521,axiom,
    ! [VarCurr: state_type] :
      ( v94146(VarCurr)
    <=> ( v94147(VarCurr)
      <~> v94053(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3520,axiom,
    ! [VarCurr: state_type] :
      ( v94147(VarCurr)
    <=> ( v94148(VarCurr)
      <~> v94053(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3519,axiom,
    ! [VarCurr: state_type] :
      ( v94148(VarCurr)
    <=> ( v94149(VarCurr)
      <~> v94053(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3518,axiom,
    ! [VarCurr: state_type] :
      ( v94149(VarCurr)
    <=> ( v94150(VarCurr)
      <~> v94053(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3517,axiom,
    ! [VarCurr: state_type] :
      ( v94150(VarCurr)
    <=> ( v94151(VarCurr)
      <~> v94053(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3516,axiom,
    ! [VarCurr: state_type] :
      ( v94151(VarCurr)
    <=> ( v94152(VarCurr)
      <~> v94053(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3515,axiom,
    ! [VarCurr: state_type] :
      ( v94152(VarCurr)
    <=> ( v94153(VarCurr)
      <~> v94053(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3514,axiom,
    ! [VarCurr: state_type] :
      ( v94153(VarCurr)
    <=> ( v94154(VarCurr)
      <~> v94053(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3513,axiom,
    ! [VarCurr: state_type] :
      ( v94154(VarCurr)
    <=> ( v94155(VarCurr)
      <~> v94053(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3512,axiom,
    ! [VarCurr: state_type] :
      ( v94155(VarCurr)
    <=> ( v94156(VarCurr)
      <~> v94053(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3511,axiom,
    ! [VarCurr: state_type] :
      ( v94156(VarCurr)
    <=> ( v94157(VarCurr)
      <~> v94053(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3510,axiom,
    ! [VarCurr: state_type] :
      ( v94157(VarCurr)
    <=> ( v94158(VarCurr)
      <~> v94053(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3509,axiom,
    ! [VarCurr: state_type] :
      ( v94158(VarCurr)
    <=> ( v94159(VarCurr)
      <~> v94053(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3508,axiom,
    ! [VarCurr: state_type] :
      ( v94159(VarCurr)
    <=> ( v94160(VarCurr)
      <~> v94053(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3507,axiom,
    ! [VarCurr: state_type] :
      ( v94160(VarCurr)
    <=> ( v94161(VarCurr)
      <~> v94053(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3506,axiom,
    ! [VarCurr: state_type] :
      ( v94161(VarCurr)
    <=> ( v94162(VarCurr)
      <~> v94053(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3505,axiom,
    ! [VarCurr: state_type] :
      ( v94162(VarCurr)
    <=> ( v94053(VarCurr,71)
      <~> v94053(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3504,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,1)
    <=> ( v94091(VarCurr)
      <~> v94053(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3503,axiom,
    ! [VarCurr: state_type] :
      ( v94091(VarCurr)
    <=> ( v94092(VarCurr)
      <~> v94053(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3502,axiom,
    ! [VarCurr: state_type] :
      ( v94092(VarCurr)
    <=> ( v94093(VarCurr)
      <~> v94053(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3501,axiom,
    ! [VarCurr: state_type] :
      ( v94093(VarCurr)
    <=> ( v94094(VarCurr)
      <~> v94053(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3500,axiom,
    ! [VarCurr: state_type] :
      ( v94094(VarCurr)
    <=> ( v94095(VarCurr)
      <~> v94053(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3499,axiom,
    ! [VarCurr: state_type] :
      ( v94095(VarCurr)
    <=> ( v94096(VarCurr)
      <~> v94053(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3498,axiom,
    ! [VarCurr: state_type] :
      ( v94096(VarCurr)
    <=> ( v94097(VarCurr)
      <~> v94053(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3497,axiom,
    ! [VarCurr: state_type] :
      ( v94097(VarCurr)
    <=> ( v94098(VarCurr)
      <~> v94053(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3496,axiom,
    ! [VarCurr: state_type] :
      ( v94098(VarCurr)
    <=> ( v94099(VarCurr)
      <~> v94053(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3495,axiom,
    ! [VarCurr: state_type] :
      ( v94099(VarCurr)
    <=> ( v94100(VarCurr)
      <~> v94053(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3494,axiom,
    ! [VarCurr: state_type] :
      ( v94100(VarCurr)
    <=> ( v94101(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3493,axiom,
    ! [VarCurr: state_type] :
      ( v94101(VarCurr)
    <=> ( v94102(VarCurr)
      <~> v94053(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3492,axiom,
    ! [VarCurr: state_type] :
      ( v94102(VarCurr)
    <=> ( v94103(VarCurr)
      <~> v94053(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3491,axiom,
    ! [VarCurr: state_type] :
      ( v94103(VarCurr)
    <=> ( v94104(VarCurr)
      <~> v94053(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3490,axiom,
    ! [VarCurr: state_type] :
      ( v94104(VarCurr)
    <=> ( v94105(VarCurr)
      <~> v94053(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3489,axiom,
    ! [VarCurr: state_type] :
      ( v94105(VarCurr)
    <=> ( v94106(VarCurr)
      <~> v94053(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3488,axiom,
    ! [VarCurr: state_type] :
      ( v94106(VarCurr)
    <=> ( v94107(VarCurr)
      <~> v94053(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3487,axiom,
    ! [VarCurr: state_type] :
      ( v94107(VarCurr)
    <=> ( v94108(VarCurr)
      <~> v94053(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3486,axiom,
    ! [VarCurr: state_type] :
      ( v94108(VarCurr)
    <=> ( v94109(VarCurr)
      <~> v94053(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3485,axiom,
    ! [VarCurr: state_type] :
      ( v94109(VarCurr)
    <=> ( v94110(VarCurr)
      <~> v94053(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3484,axiom,
    ! [VarCurr: state_type] :
      ( v94110(VarCurr)
    <=> ( v94111(VarCurr)
      <~> v94053(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3483,axiom,
    ! [VarCurr: state_type] :
      ( v94111(VarCurr)
    <=> ( v94112(VarCurr)
      <~> v94053(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3482,axiom,
    ! [VarCurr: state_type] :
      ( v94112(VarCurr)
    <=> ( v94113(VarCurr)
      <~> v94053(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3481,axiom,
    ! [VarCurr: state_type] :
      ( v94113(VarCurr)
    <=> ( v94114(VarCurr)
      <~> v94053(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3480,axiom,
    ! [VarCurr: state_type] :
      ( v94114(VarCurr)
    <=> ( v94115(VarCurr)
      <~> v94053(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3479,axiom,
    ! [VarCurr: state_type] :
      ( v94115(VarCurr)
    <=> ( v94116(VarCurr)
      <~> v94053(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3478,axiom,
    ! [VarCurr: state_type] :
      ( v94116(VarCurr)
    <=> ( v94117(VarCurr)
      <~> v94053(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3477,axiom,
    ! [VarCurr: state_type] :
      ( v94117(VarCurr)
    <=> ( v94118(VarCurr)
      <~> v94053(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3476,axiom,
    ! [VarCurr: state_type] :
      ( v94118(VarCurr)
    <=> ( v94119(VarCurr)
      <~> v94053(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3475,axiom,
    ! [VarCurr: state_type] :
      ( v94119(VarCurr)
    <=> ( v94120(VarCurr)
      <~> v94053(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3474,axiom,
    ! [VarCurr: state_type] :
      ( v94120(VarCurr)
    <=> ( v94121(VarCurr)
      <~> v94053(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3473,axiom,
    ! [VarCurr: state_type] :
      ( v94121(VarCurr)
    <=> ( v94122(VarCurr)
      <~> v94053(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3472,axiom,
    ! [VarCurr: state_type] :
      ( v94122(VarCurr)
    <=> ( v94123(VarCurr)
      <~> v94053(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3471,axiom,
    ! [VarCurr: state_type] :
      ( v94123(VarCurr)
    <=> ( v94124(VarCurr)
      <~> v94053(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3470,axiom,
    ! [VarCurr: state_type] :
      ( v94124(VarCurr)
    <=> ( v94053(VarCurr,70)
      <~> v94053(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8666,axiom,
    ! [VarCurr: state_type] :
      ( v94051(VarCurr,0)
    <=> ( v94055(VarCurr)
      <~> v94053(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3469,axiom,
    ! [VarCurr: state_type] :
      ( v94055(VarCurr)
    <=> ( v94056(VarCurr)
      <~> v94053(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3468,axiom,
    ! [VarCurr: state_type] :
      ( v94056(VarCurr)
    <=> ( v94057(VarCurr)
      <~> v94053(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3467,axiom,
    ! [VarCurr: state_type] :
      ( v94057(VarCurr)
    <=> ( v94058(VarCurr)
      <~> v94053(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3466,axiom,
    ! [VarCurr: state_type] :
      ( v94058(VarCurr)
    <=> ( v94059(VarCurr)
      <~> v94053(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3465,axiom,
    ! [VarCurr: state_type] :
      ( v94059(VarCurr)
    <=> ( v94060(VarCurr)
      <~> v94053(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3464,axiom,
    ! [VarCurr: state_type] :
      ( v94060(VarCurr)
    <=> ( v94061(VarCurr)
      <~> v94053(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3463,axiom,
    ! [VarCurr: state_type] :
      ( v94061(VarCurr)
    <=> ( v94062(VarCurr)
      <~> v94053(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3462,axiom,
    ! [VarCurr: state_type] :
      ( v94062(VarCurr)
    <=> ( v94063(VarCurr)
      <~> v94053(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3461,axiom,
    ! [VarCurr: state_type] :
      ( v94063(VarCurr)
    <=> ( v94064(VarCurr)
      <~> v94053(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3460,axiom,
    ! [VarCurr: state_type] :
      ( v94064(VarCurr)
    <=> ( v94065(VarCurr)
      <~> v94053(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3459,axiom,
    ! [VarCurr: state_type] :
      ( v94065(VarCurr)
    <=> ( v94066(VarCurr)
      <~> v94053(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3458,axiom,
    ! [VarCurr: state_type] :
      ( v94066(VarCurr)
    <=> ( v94067(VarCurr)
      <~> v94053(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3457,axiom,
    ! [VarCurr: state_type] :
      ( v94067(VarCurr)
    <=> ( v94068(VarCurr)
      <~> v94053(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3456,axiom,
    ! [VarCurr: state_type] :
      ( v94068(VarCurr)
    <=> ( v94069(VarCurr)
      <~> v94053(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3455,axiom,
    ! [VarCurr: state_type] :
      ( v94069(VarCurr)
    <=> ( v94070(VarCurr)
      <~> v94053(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3454,axiom,
    ! [VarCurr: state_type] :
      ( v94070(VarCurr)
    <=> ( v94071(VarCurr)
      <~> v94053(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3453,axiom,
    ! [VarCurr: state_type] :
      ( v94071(VarCurr)
    <=> ( v94072(VarCurr)
      <~> v94053(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3452,axiom,
    ! [VarCurr: state_type] :
      ( v94072(VarCurr)
    <=> ( v94073(VarCurr)
      <~> v94053(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3451,axiom,
    ! [VarCurr: state_type] :
      ( v94073(VarCurr)
    <=> ( v94074(VarCurr)
      <~> v94053(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3450,axiom,
    ! [VarCurr: state_type] :
      ( v94074(VarCurr)
    <=> ( v94075(VarCurr)
      <~> v94053(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3449,axiom,
    ! [VarCurr: state_type] :
      ( v94075(VarCurr)
    <=> ( v94076(VarCurr)
      <~> v94053(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3448,axiom,
    ! [VarCurr: state_type] :
      ( v94076(VarCurr)
    <=> ( v94077(VarCurr)
      <~> v94053(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3447,axiom,
    ! [VarCurr: state_type] :
      ( v94077(VarCurr)
    <=> ( v94078(VarCurr)
      <~> v94053(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3446,axiom,
    ! [VarCurr: state_type] :
      ( v94078(VarCurr)
    <=> ( v94079(VarCurr)
      <~> v94053(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3445,axiom,
    ! [VarCurr: state_type] :
      ( v94079(VarCurr)
    <=> ( v94080(VarCurr)
      <~> v94053(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3444,axiom,
    ! [VarCurr: state_type] :
      ( v94080(VarCurr)
    <=> ( v94081(VarCurr)
      <~> v94053(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3443,axiom,
    ! [VarCurr: state_type] :
      ( v94081(VarCurr)
    <=> ( v94082(VarCurr)
      <~> v94053(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3442,axiom,
    ! [VarCurr: state_type] :
      ( v94082(VarCurr)
    <=> ( v94083(VarCurr)
      <~> v94053(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3441,axiom,
    ! [VarCurr: state_type] :
      ( v94083(VarCurr)
    <=> ( v94084(VarCurr)
      <~> v94053(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3440,axiom,
    ! [VarCurr: state_type] :
      ( v94084(VarCurr)
    <=> ( v94085(VarCurr)
      <~> v94053(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3439,axiom,
    ! [VarCurr: state_type] :
      ( v94085(VarCurr)
    <=> ( v94086(VarCurr)
      <~> v94053(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3438,axiom,
    ! [VarCurr: state_type] :
      ( v94086(VarCurr)
    <=> ( v94087(VarCurr)
      <~> v94053(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3437,axiom,
    ! [VarCurr: state_type] :
      ( v94087(VarCurr)
    <=> ( v94088(VarCurr)
      <~> v94053(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3436,axiom,
    ! [VarCurr: state_type] :
      ( v94088(VarCurr)
    <=> ( v94089(VarCurr)
      <~> v94053(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3435,axiom,
    ! [VarCurr: state_type] :
      ( v94089(VarCurr)
    <=> ( v94053(VarCurr,69)
      <~> v94053(VarCurr,66) ) ) ).

tff(addAssignment_57059,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,62)
    <=> v93560(VarCurr,62) ) ).

tff(addAssignment_57058,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,23)
    <=> v93560(VarCurr,23) ) ).

tff(addAssignment_57057,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,61)
    <=> v93560(VarCurr,61) ) ).

tff(addAssignment_57056,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,22)
    <=> v93560(VarCurr,22) ) ).

tff(addAssignment_57055,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,27)
    <=> v93560(VarCurr,27) ) ).

tff(addAssignment_57054,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,47)
    <=> v93560(VarCurr,47) ) ).

tff(addAssignment_57053,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,60)
    <=> v93560(VarCurr,60) ) ).

tff(addAssignment_57052,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,5)
    <=> v93560(VarCurr,5) ) ).

tff(addAssignment_57051,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,8)
    <=> v93560(VarCurr,8) ) ).

tff(addAssignment_57050,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,15)
    <=> v93560(VarCurr,15) ) ).

tff(addAssignment_57049,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,21)
    <=> v93560(VarCurr,21) ) ).

tff(addAssignment_57048,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,26)
    <=> v93560(VarCurr,26) ) ).

tff(addAssignment_57047,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,46)
    <=> v93560(VarCurr,46) ) ).

tff(addAssignment_57046,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,51)
    <=> v93560(VarCurr,51) ) ).

tff(addAssignment_57045,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,59)
    <=> v93560(VarCurr,59) ) ).

tff(addAssignment_57044,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,68)
    <=> v93560(VarCurr,68) ) ).

tff(addAssignment_57043,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,71)
    <=> v93560(VarCurr,71) ) ).

tff(addAssignment_57042,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,4)
    <=> v93560(VarCurr,4) ) ).

tff(addAssignment_57041,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,7)
    <=> v93560(VarCurr,7) ) ).

tff(addAssignment_57040,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,10)
    <=> v93560(VarCurr,10) ) ).

tff(addAssignment_57039,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,12)
    <=> v93560(VarCurr,12) ) ).

tff(addAssignment_57038,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,14)
    <=> v93560(VarCurr,14) ) ).

tff(addAssignment_57037,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,18)
    <=> v93560(VarCurr,18) ) ).

tff(addAssignment_57036,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,20)
    <=> v93560(VarCurr,20) ) ).

tff(addAssignment_57035,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,25)
    <=> v93560(VarCurr,25) ) ).

tff(addAssignment_57034,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,29)
    <=> v93560(VarCurr,29) ) ).

tff(addAssignment_57033,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,32)
    <=> v93560(VarCurr,32) ) ).

tff(addAssignment_57032,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,39)
    <=> v93560(VarCurr,39) ) ).

tff(addAssignment_57031,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,41)
    <=> v93560(VarCurr,41) ) ).

tff(addAssignment_57030,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,45)
    <=> v93560(VarCurr,45) ) ).

tff(addAssignment_57029,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,50)
    <=> v93560(VarCurr,50) ) ).

tff(addAssignment_57028,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,55)
    <=> v93560(VarCurr,55) ) ).

tff(addAssignment_57027,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,58)
    <=> v93560(VarCurr,58) ) ).

tff(addAssignment_57026,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,67)
    <=> v93560(VarCurr,67) ) ).

tff(addAssignment_57025,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,70)
    <=> v93560(VarCurr,70) ) ).

tff(addAssignment_57024,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,0)
    <=> v93560(VarCurr,0) ) ).

tff(addAssignment_57023,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,1)
    <=> v93560(VarCurr,1) ) ).

tff(addAssignment_57022,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,2)
    <=> v93560(VarCurr,2) ) ).

tff(addAssignment_57021,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,3)
    <=> v93560(VarCurr,3) ) ).

tff(addAssignment_57020,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,6)
    <=> v93560(VarCurr,6) ) ).

tff(addAssignment_57019,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,9)
    <=> v93560(VarCurr,9) ) ).

tff(addAssignment_57018,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,11)
    <=> v93560(VarCurr,11) ) ).

tff(addAssignment_57017,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,13)
    <=> v93560(VarCurr,13) ) ).

tff(addAssignment_57016,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,16)
    <=> v93560(VarCurr,16) ) ).

tff(addAssignment_57015,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,17)
    <=> v93560(VarCurr,17) ) ).

tff(addAssignment_57014,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,19)
    <=> v93560(VarCurr,19) ) ).

tff(addAssignment_57013,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,24)
    <=> v93560(VarCurr,24) ) ).

tff(addAssignment_57012,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,28)
    <=> v93560(VarCurr,28) ) ).

tff(addAssignment_57011,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,30)
    <=> v93560(VarCurr,30) ) ).

tff(addAssignment_57010,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,31)
    <=> v93560(VarCurr,31) ) ).

tff(addAssignment_57009,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,33)
    <=> v93560(VarCurr,33) ) ).

tff(addAssignment_57008,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,34)
    <=> v93560(VarCurr,34) ) ).

tff(addAssignment_57007,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,35)
    <=> v93560(VarCurr,35) ) ).

tff(addAssignment_57006,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,36)
    <=> v93560(VarCurr,36) ) ).

tff(addAssignment_57005,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,37)
    <=> v93560(VarCurr,37) ) ).

tff(addAssignment_57004,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,38)
    <=> v93560(VarCurr,38) ) ).

tff(addAssignment_57003,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,40)
    <=> v93560(VarCurr,40) ) ).

tff(addAssignment_57002,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,42)
    <=> v93560(VarCurr,42) ) ).

tff(addAssignment_57001,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,43)
    <=> v93560(VarCurr,43) ) ).

tff(addAssignment_57000,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,44)
    <=> v93560(VarCurr,44) ) ).

tff(addAssignment_56999,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,48)
    <=> v93560(VarCurr,48) ) ).

tff(addAssignment_56998,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,49)
    <=> v93560(VarCurr,49) ) ).

tff(addAssignment_56997,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,52)
    <=> v93560(VarCurr,52) ) ).

tff(addAssignment_56996,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,53)
    <=> v93560(VarCurr,53) ) ).

tff(addAssignment_56995,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,54)
    <=> v93560(VarCurr,54) ) ).

tff(addAssignment_56994,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,56)
    <=> v93560(VarCurr,56) ) ).

tff(addAssignment_56993,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,57)
    <=> v93560(VarCurr,57) ) ).

tff(addAssignment_56992,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,63)
    <=> v93560(VarCurr,63) ) ).

tff(addAssignment_56991,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,64)
    <=> v93560(VarCurr,64) ) ).

tff(addAssignment_56990,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,65)
    <=> v93560(VarCurr,65) ) ).

tff(addAssignment_56989,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,66)
    <=> v93560(VarCurr,66) ) ).

tff(addAssignment_56988,axiom,
    ! [VarCurr: state_type] :
      ( v94053(VarCurr,69)
    <=> v93560(VarCurr,69) ) ).

tff(addAssignment_56987,axiom,
    ! [VarCurr: state_type] :
      ( v94031(VarCurr)
    <=> v94033(VarCurr) ) ).

tff(addAssignment_56986,axiom,
    ! [VarCurr: state_type] :
      ( v94033(VarCurr)
    <=> v94035(VarCurr) ) ).

tff(addAssignment_56985,axiom,
    ! [VarCurr: state_type] :
      ( v94035(VarCurr)
    <=> v94037(VarCurr) ) ).

tff(addAssignment_56984,axiom,
    ! [VarCurr: state_type] :
      ( v94037(VarCurr)
    <=> v94039(VarCurr) ) ).

tff(addAssignment_56983,axiom,
    ! [VarCurr: state_type] :
      ( v94039(VarCurr)
    <=> v92679(VarCurr) ) ).

tff(addAssignment_56982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93546(VarCurr,B)
      <=> v93548(VarCurr,B) ) ) ).

tff(addAssignment_56981,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93548(VarCurr,B)
      <=> v93550(VarCurr,B) ) ) ).

tff(addAssignment_56980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93550(VarCurr,B)
      <=> v93552(VarCurr,B) ) ) ).

tff(addAssignment_56979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93552(VarCurr,B)
      <=> v93554(VarCurr,B) ) ) ).

tff(addAssignment_56978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93554(VarCurr,B)
      <=> v93556(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3434,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,11)
    <=> ( v93991(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3433,axiom,
    ! [VarCurr: state_type] :
      ( v93991(VarCurr)
    <=> ( v93992(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3432,axiom,
    ! [VarCurr: state_type] :
      ( v93992(VarCurr)
    <=> ( v93993(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3431,axiom,
    ! [VarCurr: state_type] :
      ( v93993(VarCurr)
    <=> ( v93994(VarCurr)
      <~> v93558(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3430,axiom,
    ! [VarCurr: state_type] :
      ( v93994(VarCurr)
    <=> ( v93995(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3429,axiom,
    ! [VarCurr: state_type] :
      ( v93995(VarCurr)
    <=> ( v93996(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3428,axiom,
    ! [VarCurr: state_type] :
      ( v93996(VarCurr)
    <=> ( v93997(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3427,axiom,
    ! [VarCurr: state_type] :
      ( v93997(VarCurr)
    <=> ( v93998(VarCurr)
      <~> v93558(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3426,axiom,
    ! [VarCurr: state_type] :
      ( v93998(VarCurr)
    <=> ( v93999(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3425,axiom,
    ! [VarCurr: state_type] :
      ( v93999(VarCurr)
    <=> ( v94000(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3424,axiom,
    ! [VarCurr: state_type] :
      ( v94000(VarCurr)
    <=> ( v94001(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3423,axiom,
    ! [VarCurr: state_type] :
      ( v94001(VarCurr)
    <=> ( v94002(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3422,axiom,
    ! [VarCurr: state_type] :
      ( v94002(VarCurr)
    <=> ( v94003(VarCurr)
      <~> v93558(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3421,axiom,
    ! [VarCurr: state_type] :
      ( v94003(VarCurr)
    <=> ( v94004(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3420,axiom,
    ! [VarCurr: state_type] :
      ( v94004(VarCurr)
    <=> ( v94005(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3419,axiom,
    ! [VarCurr: state_type] :
      ( v94005(VarCurr)
    <=> ( v94006(VarCurr)
      <~> v93558(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3418,axiom,
    ! [VarCurr: state_type] :
      ( v94006(VarCurr)
    <=> ( v94007(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3417,axiom,
    ! [VarCurr: state_type] :
      ( v94007(VarCurr)
    <=> ( v94008(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3416,axiom,
    ! [VarCurr: state_type] :
      ( v94008(VarCurr)
    <=> ( v94009(VarCurr)
      <~> v93558(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3415,axiom,
    ! [VarCurr: state_type] :
      ( v94009(VarCurr)
    <=> ( v94010(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3414,axiom,
    ! [VarCurr: state_type] :
      ( v94010(VarCurr)
    <=> ( v94011(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3413,axiom,
    ! [VarCurr: state_type] :
      ( v94011(VarCurr)
    <=> ( v94012(VarCurr)
      <~> v93558(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3412,axiom,
    ! [VarCurr: state_type] :
      ( v94012(VarCurr)
    <=> ( v94013(VarCurr)
      <~> v93558(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3411,axiom,
    ! [VarCurr: state_type] :
      ( v94013(VarCurr)
    <=> ( v94014(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3410,axiom,
    ! [VarCurr: state_type] :
      ( v94014(VarCurr)
    <=> ( v94015(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3409,axiom,
    ! [VarCurr: state_type] :
      ( v94015(VarCurr)
    <=> ( v94016(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3408,axiom,
    ! [VarCurr: state_type] :
      ( v94016(VarCurr)
    <=> ( v94017(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3407,axiom,
    ! [VarCurr: state_type] :
      ( v94017(VarCurr)
    <=> ( v94018(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3406,axiom,
    ! [VarCurr: state_type] :
      ( v94018(VarCurr)
    <=> ( v94019(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3405,axiom,
    ! [VarCurr: state_type] :
      ( v94019(VarCurr)
    <=> ( v94020(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3404,axiom,
    ! [VarCurr: state_type] :
      ( v94020(VarCurr)
    <=> ( v94021(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3403,axiom,
    ! [VarCurr: state_type] :
      ( v94021(VarCurr)
    <=> ( v94022(VarCurr)
      <~> v93558(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3402,axiom,
    ! [VarCurr: state_type] :
      ( v94022(VarCurr)
    <=> ( v94023(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3401,axiom,
    ! [VarCurr: state_type] :
      ( v94023(VarCurr)
    <=> ( v94024(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3400,axiom,
    ! [VarCurr: state_type] :
      ( v94024(VarCurr)
    <=> ( v94025(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3399,axiom,
    ! [VarCurr: state_type] :
      ( v94025(VarCurr)
    <=> ( v94026(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3398,axiom,
    ! [VarCurr: state_type] :
      ( v94026(VarCurr)
    <=> ( v94027(VarCurr)
      <~> v93558(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3397,axiom,
    ! [VarCurr: state_type] :
      ( v94027(VarCurr)
    <=> ( v94028(VarCurr)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3396,axiom,
    ! [VarCurr: state_type] :
      ( v94028(VarCurr)
    <=> ( v94029(VarCurr)
      <~> v93558(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3395,axiom,
    ! [VarCurr: state_type] :
      ( v94029(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3394,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,10)
    <=> ( v93958(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3393,axiom,
    ! [VarCurr: state_type] :
      ( v93958(VarCurr)
    <=> ( v93959(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3392,axiom,
    ! [VarCurr: state_type] :
      ( v93959(VarCurr)
    <=> ( v93960(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3391,axiom,
    ! [VarCurr: state_type] :
      ( v93960(VarCurr)
    <=> ( v93961(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3390,axiom,
    ! [VarCurr: state_type] :
      ( v93961(VarCurr)
    <=> ( v93962(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3389,axiom,
    ! [VarCurr: state_type] :
      ( v93962(VarCurr)
    <=> ( v93963(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3388,axiom,
    ! [VarCurr: state_type] :
      ( v93963(VarCurr)
    <=> ( v93964(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3387,axiom,
    ! [VarCurr: state_type] :
      ( v93964(VarCurr)
    <=> ( v93965(VarCurr)
      <~> v93558(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3386,axiom,
    ! [VarCurr: state_type] :
      ( v93965(VarCurr)
    <=> ( v93966(VarCurr)
      <~> v93558(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3385,axiom,
    ! [VarCurr: state_type] :
      ( v93966(VarCurr)
    <=> ( v93967(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3384,axiom,
    ! [VarCurr: state_type] :
      ( v93967(VarCurr)
    <=> ( v93968(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3383,axiom,
    ! [VarCurr: state_type] :
      ( v93968(VarCurr)
    <=> ( v93969(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3382,axiom,
    ! [VarCurr: state_type] :
      ( v93969(VarCurr)
    <=> ( v93970(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3381,axiom,
    ! [VarCurr: state_type] :
      ( v93970(VarCurr)
    <=> ( v93971(VarCurr)
      <~> v93558(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3380,axiom,
    ! [VarCurr: state_type] :
      ( v93971(VarCurr)
    <=> ( v93972(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3379,axiom,
    ! [VarCurr: state_type] :
      ( v93972(VarCurr)
    <=> ( v93973(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3378,axiom,
    ! [VarCurr: state_type] :
      ( v93973(VarCurr)
    <=> ( v93974(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3377,axiom,
    ! [VarCurr: state_type] :
      ( v93974(VarCurr)
    <=> ( v93975(VarCurr)
      <~> v93558(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3376,axiom,
    ! [VarCurr: state_type] :
      ( v93975(VarCurr)
    <=> ( v93976(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3375,axiom,
    ! [VarCurr: state_type] :
      ( v93976(VarCurr)
    <=> ( v93977(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3374,axiom,
    ! [VarCurr: state_type] :
      ( v93977(VarCurr)
    <=> ( v93978(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3373,axiom,
    ! [VarCurr: state_type] :
      ( v93978(VarCurr)
    <=> ( v93979(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3372,axiom,
    ! [VarCurr: state_type] :
      ( v93979(VarCurr)
    <=> ( v93980(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3371,axiom,
    ! [VarCurr: state_type] :
      ( v93980(VarCurr)
    <=> ( v93981(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3370,axiom,
    ! [VarCurr: state_type] :
      ( v93981(VarCurr)
    <=> ( v93982(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3369,axiom,
    ! [VarCurr: state_type] :
      ( v93982(VarCurr)
    <=> ( v93983(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3368,axiom,
    ! [VarCurr: state_type] :
      ( v93983(VarCurr)
    <=> ( v93984(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3367,axiom,
    ! [VarCurr: state_type] :
      ( v93984(VarCurr)
    <=> ( v93985(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3366,axiom,
    ! [VarCurr: state_type] :
      ( v93985(VarCurr)
    <=> ( v93986(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3365,axiom,
    ! [VarCurr: state_type] :
      ( v93986(VarCurr)
    <=> ( v93987(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3364,axiom,
    ! [VarCurr: state_type] :
      ( v93987(VarCurr)
    <=> ( v93988(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3363,axiom,
    ! [VarCurr: state_type] :
      ( v93988(VarCurr)
    <=> ( v93989(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3362,axiom,
    ! [VarCurr: state_type] :
      ( v93989(VarCurr)
    <=> ( v93558(VarCurr,68)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3361,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,9)
    <=> ( v93918(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3360,axiom,
    ! [VarCurr: state_type] :
      ( v93918(VarCurr)
    <=> ( v93919(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3359,axiom,
    ! [VarCurr: state_type] :
      ( v93919(VarCurr)
    <=> ( v93920(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3358,axiom,
    ! [VarCurr: state_type] :
      ( v93920(VarCurr)
    <=> ( v93921(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3357,axiom,
    ! [VarCurr: state_type] :
      ( v93921(VarCurr)
    <=> ( v93922(VarCurr)
      <~> v93558(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3356,axiom,
    ! [VarCurr: state_type] :
      ( v93922(VarCurr)
    <=> ( v93923(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3355,axiom,
    ! [VarCurr: state_type] :
      ( v93923(VarCurr)
    <=> ( v93924(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3354,axiom,
    ! [VarCurr: state_type] :
      ( v93924(VarCurr)
    <=> ( v93925(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3353,axiom,
    ! [VarCurr: state_type] :
      ( v93925(VarCurr)
    <=> ( v93926(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3352,axiom,
    ! [VarCurr: state_type] :
      ( v93926(VarCurr)
    <=> ( v93927(VarCurr)
      <~> v93558(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3351,axiom,
    ! [VarCurr: state_type] :
      ( v93927(VarCurr)
    <=> ( v93928(VarCurr)
      <~> v93558(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3350,axiom,
    ! [VarCurr: state_type] :
      ( v93928(VarCurr)
    <=> ( v93929(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3349,axiom,
    ! [VarCurr: state_type] :
      ( v93929(VarCurr)
    <=> ( v93930(VarCurr)
      <~> v93558(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3348,axiom,
    ! [VarCurr: state_type] :
      ( v93930(VarCurr)
    <=> ( v93931(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3347,axiom,
    ! [VarCurr: state_type] :
      ( v93931(VarCurr)
    <=> ( v93932(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3346,axiom,
    ! [VarCurr: state_type] :
      ( v93932(VarCurr)
    <=> ( v93933(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3345,axiom,
    ! [VarCurr: state_type] :
      ( v93933(VarCurr)
    <=> ( v93934(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3344,axiom,
    ! [VarCurr: state_type] :
      ( v93934(VarCurr)
    <=> ( v93935(VarCurr)
      <~> v93558(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3343,axiom,
    ! [VarCurr: state_type] :
      ( v93935(VarCurr)
    <=> ( v93936(VarCurr)
      <~> v93558(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3342,axiom,
    ! [VarCurr: state_type] :
      ( v93936(VarCurr)
    <=> ( v93937(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3341,axiom,
    ! [VarCurr: state_type] :
      ( v93937(VarCurr)
    <=> ( v93938(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3340,axiom,
    ! [VarCurr: state_type] :
      ( v93938(VarCurr)
    <=> ( v93939(VarCurr)
      <~> v93558(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3339,axiom,
    ! [VarCurr: state_type] :
      ( v93939(VarCurr)
    <=> ( v93940(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3338,axiom,
    ! [VarCurr: state_type] :
      ( v93940(VarCurr)
    <=> ( v93941(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3337,axiom,
    ! [VarCurr: state_type] :
      ( v93941(VarCurr)
    <=> ( v93942(VarCurr)
      <~> v93558(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3336,axiom,
    ! [VarCurr: state_type] :
      ( v93942(VarCurr)
    <=> ( v93943(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3335,axiom,
    ! [VarCurr: state_type] :
      ( v93943(VarCurr)
    <=> ( v93944(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3334,axiom,
    ! [VarCurr: state_type] :
      ( v93944(VarCurr)
    <=> ( v93945(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3333,axiom,
    ! [VarCurr: state_type] :
      ( v93945(VarCurr)
    <=> ( v93946(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3332,axiom,
    ! [VarCurr: state_type] :
      ( v93946(VarCurr)
    <=> ( v93947(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3331,axiom,
    ! [VarCurr: state_type] :
      ( v93947(VarCurr)
    <=> ( v93948(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3330,axiom,
    ! [VarCurr: state_type] :
      ( v93948(VarCurr)
    <=> ( v93949(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3329,axiom,
    ! [VarCurr: state_type] :
      ( v93949(VarCurr)
    <=> ( v93950(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3328,axiom,
    ! [VarCurr: state_type] :
      ( v93950(VarCurr)
    <=> ( v93951(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3327,axiom,
    ! [VarCurr: state_type] :
      ( v93951(VarCurr)
    <=> ( v93952(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3326,axiom,
    ! [VarCurr: state_type] :
      ( v93952(VarCurr)
    <=> ( v93953(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3325,axiom,
    ! [VarCurr: state_type] :
      ( v93953(VarCurr)
    <=> ( v93954(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3324,axiom,
    ! [VarCurr: state_type] :
      ( v93954(VarCurr)
    <=> ( v93955(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3323,axiom,
    ! [VarCurr: state_type] :
      ( v93955(VarCurr)
    <=> ( v93956(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3322,axiom,
    ! [VarCurr: state_type] :
      ( v93956(VarCurr)
    <=> ( v93558(VarCurr,70)
      <~> v93558(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3321,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,8)
    <=> ( v93878(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3320,axiom,
    ! [VarCurr: state_type] :
      ( v93878(VarCurr)
    <=> ( v93879(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3319,axiom,
    ! [VarCurr: state_type] :
      ( v93879(VarCurr)
    <=> ( v93880(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3318,axiom,
    ! [VarCurr: state_type] :
      ( v93880(VarCurr)
    <=> ( v93881(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3317,axiom,
    ! [VarCurr: state_type] :
      ( v93881(VarCurr)
    <=> ( v93882(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3316,axiom,
    ! [VarCurr: state_type] :
      ( v93882(VarCurr)
    <=> ( v93883(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3315,axiom,
    ! [VarCurr: state_type] :
      ( v93883(VarCurr)
    <=> ( v93884(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3314,axiom,
    ! [VarCurr: state_type] :
      ( v93884(VarCurr)
    <=> ( v93885(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3313,axiom,
    ! [VarCurr: state_type] :
      ( v93885(VarCurr)
    <=> ( v93886(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3312,axiom,
    ! [VarCurr: state_type] :
      ( v93886(VarCurr)
    <=> ( v93887(VarCurr)
      <~> v93558(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3311,axiom,
    ! [VarCurr: state_type] :
      ( v93887(VarCurr)
    <=> ( v93888(VarCurr)
      <~> v93558(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3310,axiom,
    ! [VarCurr: state_type] :
      ( v93888(VarCurr)
    <=> ( v93889(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3309,axiom,
    ! [VarCurr: state_type] :
      ( v93889(VarCurr)
    <=> ( v93890(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3308,axiom,
    ! [VarCurr: state_type] :
      ( v93890(VarCurr)
    <=> ( v93891(VarCurr)
      <~> v93558(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3307,axiom,
    ! [VarCurr: state_type] :
      ( v93891(VarCurr)
    <=> ( v93892(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3306,axiom,
    ! [VarCurr: state_type] :
      ( v93892(VarCurr)
    <=> ( v93893(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3305,axiom,
    ! [VarCurr: state_type] :
      ( v93893(VarCurr)
    <=> ( v93894(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3304,axiom,
    ! [VarCurr: state_type] :
      ( v93894(VarCurr)
    <=> ( v93895(VarCurr)
      <~> v93558(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3303,axiom,
    ! [VarCurr: state_type] :
      ( v93895(VarCurr)
    <=> ( v93896(VarCurr)
      <~> v93558(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3302,axiom,
    ! [VarCurr: state_type] :
      ( v93896(VarCurr)
    <=> ( v93897(VarCurr)
      <~> v93558(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3301,axiom,
    ! [VarCurr: state_type] :
      ( v93897(VarCurr)
    <=> ( v93898(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3300,axiom,
    ! [VarCurr: state_type] :
      ( v93898(VarCurr)
    <=> ( v93899(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3299,axiom,
    ! [VarCurr: state_type] :
      ( v93899(VarCurr)
    <=> ( v93900(VarCurr)
      <~> v93558(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3298,axiom,
    ! [VarCurr: state_type] :
      ( v93900(VarCurr)
    <=> ( v93901(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3297,axiom,
    ! [VarCurr: state_type] :
      ( v93901(VarCurr)
    <=> ( v93902(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3296,axiom,
    ! [VarCurr: state_type] :
      ( v93902(VarCurr)
    <=> ( v93903(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3295,axiom,
    ! [VarCurr: state_type] :
      ( v93903(VarCurr)
    <=> ( v93904(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3294,axiom,
    ! [VarCurr: state_type] :
      ( v93904(VarCurr)
    <=> ( v93905(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3293,axiom,
    ! [VarCurr: state_type] :
      ( v93905(VarCurr)
    <=> ( v93906(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3292,axiom,
    ! [VarCurr: state_type] :
      ( v93906(VarCurr)
    <=> ( v93907(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3291,axiom,
    ! [VarCurr: state_type] :
      ( v93907(VarCurr)
    <=> ( v93908(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3290,axiom,
    ! [VarCurr: state_type] :
      ( v93908(VarCurr)
    <=> ( v93909(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3289,axiom,
    ! [VarCurr: state_type] :
      ( v93909(VarCurr)
    <=> ( v93910(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3288,axiom,
    ! [VarCurr: state_type] :
      ( v93910(VarCurr)
    <=> ( v93911(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3287,axiom,
    ! [VarCurr: state_type] :
      ( v93911(VarCurr)
    <=> ( v93912(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3286,axiom,
    ! [VarCurr: state_type] :
      ( v93912(VarCurr)
    <=> ( v93913(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3285,axiom,
    ! [VarCurr: state_type] :
      ( v93913(VarCurr)
    <=> ( v93914(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3284,axiom,
    ! [VarCurr: state_type] :
      ( v93914(VarCurr)
    <=> ( v93915(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3283,axiom,
    ! [VarCurr: state_type] :
      ( v93915(VarCurr)
    <=> ( v93916(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3282,axiom,
    ! [VarCurr: state_type] :
      ( v93916(VarCurr)
    <=> ( v93558(VarCurr,69)
      <~> v93558(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3281,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,7)
    <=> ( v93836(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3280,axiom,
    ! [VarCurr: state_type] :
      ( v93836(VarCurr)
    <=> ( v93837(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3279,axiom,
    ! [VarCurr: state_type] :
      ( v93837(VarCurr)
    <=> ( v93838(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3278,axiom,
    ! [VarCurr: state_type] :
      ( v93838(VarCurr)
    <=> ( v93839(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3277,axiom,
    ! [VarCurr: state_type] :
      ( v93839(VarCurr)
    <=> ( v93840(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3276,axiom,
    ! [VarCurr: state_type] :
      ( v93840(VarCurr)
    <=> ( v93841(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3275,axiom,
    ! [VarCurr: state_type] :
      ( v93841(VarCurr)
    <=> ( v93842(VarCurr)
      <~> v93558(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3274,axiom,
    ! [VarCurr: state_type] :
      ( v93842(VarCurr)
    <=> ( v93843(VarCurr)
      <~> v93558(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3273,axiom,
    ! [VarCurr: state_type] :
      ( v93843(VarCurr)
    <=> ( v93844(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3272,axiom,
    ! [VarCurr: state_type] :
      ( v93844(VarCurr)
    <=> ( v93845(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3271,axiom,
    ! [VarCurr: state_type] :
      ( v93845(VarCurr)
    <=> ( v93846(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3270,axiom,
    ! [VarCurr: state_type] :
      ( v93846(VarCurr)
    <=> ( v93847(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3269,axiom,
    ! [VarCurr: state_type] :
      ( v93847(VarCurr)
    <=> ( v93848(VarCurr)
      <~> v93558(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3268,axiom,
    ! [VarCurr: state_type] :
      ( v93848(VarCurr)
    <=> ( v93849(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3267,axiom,
    ! [VarCurr: state_type] :
      ( v93849(VarCurr)
    <=> ( v93850(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3266,axiom,
    ! [VarCurr: state_type] :
      ( v93850(VarCurr)
    <=> ( v93851(VarCurr)
      <~> v93558(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3265,axiom,
    ! [VarCurr: state_type] :
      ( v93851(VarCurr)
    <=> ( v93852(VarCurr)
      <~> v93558(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3264,axiom,
    ! [VarCurr: state_type] :
      ( v93852(VarCurr)
    <=> ( v93853(VarCurr)
      <~> v93558(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3263,axiom,
    ! [VarCurr: state_type] :
      ( v93853(VarCurr)
    <=> ( v93854(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3262,axiom,
    ! [VarCurr: state_type] :
      ( v93854(VarCurr)
    <=> ( v93855(VarCurr)
      <~> v93558(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3261,axiom,
    ! [VarCurr: state_type] :
      ( v93855(VarCurr)
    <=> ( v93856(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3260,axiom,
    ! [VarCurr: state_type] :
      ( v93856(VarCurr)
    <=> ( v93857(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3259,axiom,
    ! [VarCurr: state_type] :
      ( v93857(VarCurr)
    <=> ( v93858(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3258,axiom,
    ! [VarCurr: state_type] :
      ( v93858(VarCurr)
    <=> ( v93859(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3257,axiom,
    ! [VarCurr: state_type] :
      ( v93859(VarCurr)
    <=> ( v93860(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3256,axiom,
    ! [VarCurr: state_type] :
      ( v93860(VarCurr)
    <=> ( v93861(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3255,axiom,
    ! [VarCurr: state_type] :
      ( v93861(VarCurr)
    <=> ( v93862(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3254,axiom,
    ! [VarCurr: state_type] :
      ( v93862(VarCurr)
    <=> ( v93863(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3253,axiom,
    ! [VarCurr: state_type] :
      ( v93863(VarCurr)
    <=> ( v93864(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3252,axiom,
    ! [VarCurr: state_type] :
      ( v93864(VarCurr)
    <=> ( v93865(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3251,axiom,
    ! [VarCurr: state_type] :
      ( v93865(VarCurr)
    <=> ( v93866(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3250,axiom,
    ! [VarCurr: state_type] :
      ( v93866(VarCurr)
    <=> ( v93867(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3249,axiom,
    ! [VarCurr: state_type] :
      ( v93867(VarCurr)
    <=> ( v93868(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3248,axiom,
    ! [VarCurr: state_type] :
      ( v93868(VarCurr)
    <=> ( v93869(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3247,axiom,
    ! [VarCurr: state_type] :
      ( v93869(VarCurr)
    <=> ( v93870(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3246,axiom,
    ! [VarCurr: state_type] :
      ( v93870(VarCurr)
    <=> ( v93871(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3245,axiom,
    ! [VarCurr: state_type] :
      ( v93871(VarCurr)
    <=> ( v93872(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3244,axiom,
    ! [VarCurr: state_type] :
      ( v93872(VarCurr)
    <=> ( v93873(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3243,axiom,
    ! [VarCurr: state_type] :
      ( v93873(VarCurr)
    <=> ( v93874(VarCurr)
      <~> v93558(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3242,axiom,
    ! [VarCurr: state_type] :
      ( v93874(VarCurr)
    <=> ( v93875(VarCurr)
      <~> v93558(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3241,axiom,
    ! [VarCurr: state_type] :
      ( v93875(VarCurr)
    <=> ( v93876(VarCurr)
      <~> v93558(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3240,axiom,
    ! [VarCurr: state_type] :
      ( v93876(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3239,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,6)
    <=> ( v93793(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3238,axiom,
    ! [VarCurr: state_type] :
      ( v93793(VarCurr)
    <=> ( v93794(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3237,axiom,
    ! [VarCurr: state_type] :
      ( v93794(VarCurr)
    <=> ( v93795(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3236,axiom,
    ! [VarCurr: state_type] :
      ( v93795(VarCurr)
    <=> ( v93796(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3235,axiom,
    ! [VarCurr: state_type] :
      ( v93796(VarCurr)
    <=> ( v93797(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3234,axiom,
    ! [VarCurr: state_type] :
      ( v93797(VarCurr)
    <=> ( v93798(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3233,axiom,
    ! [VarCurr: state_type] :
      ( v93798(VarCurr)
    <=> ( v93799(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3232,axiom,
    ! [VarCurr: state_type] :
      ( v93799(VarCurr)
    <=> ( v93800(VarCurr)
      <~> v93558(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3231,axiom,
    ! [VarCurr: state_type] :
      ( v93800(VarCurr)
    <=> ( v93801(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3230,axiom,
    ! [VarCurr: state_type] :
      ( v93801(VarCurr)
    <=> ( v93802(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3229,axiom,
    ! [VarCurr: state_type] :
      ( v93802(VarCurr)
    <=> ( v93803(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3228,axiom,
    ! [VarCurr: state_type] :
      ( v93803(VarCurr)
    <=> ( v93804(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3227,axiom,
    ! [VarCurr: state_type] :
      ( v93804(VarCurr)
    <=> ( v93805(VarCurr)
      <~> v93558(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3226,axiom,
    ! [VarCurr: state_type] :
      ( v93805(VarCurr)
    <=> ( v93806(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3225,axiom,
    ! [VarCurr: state_type] :
      ( v93806(VarCurr)
    <=> ( v93807(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3224,axiom,
    ! [VarCurr: state_type] :
      ( v93807(VarCurr)
    <=> ( v93808(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3223,axiom,
    ! [VarCurr: state_type] :
      ( v93808(VarCurr)
    <=> ( v93809(VarCurr)
      <~> v93558(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3222,axiom,
    ! [VarCurr: state_type] :
      ( v93809(VarCurr)
    <=> ( v93810(VarCurr)
      <~> v93558(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3221,axiom,
    ! [VarCurr: state_type] :
      ( v93810(VarCurr)
    <=> ( v93811(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3220,axiom,
    ! [VarCurr: state_type] :
      ( v93811(VarCurr)
    <=> ( v93812(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3219,axiom,
    ! [VarCurr: state_type] :
      ( v93812(VarCurr)
    <=> ( v93813(VarCurr)
      <~> v93558(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3218,axiom,
    ! [VarCurr: state_type] :
      ( v93813(VarCurr)
    <=> ( v93814(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3217,axiom,
    ! [VarCurr: state_type] :
      ( v93814(VarCurr)
    <=> ( v93815(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3216,axiom,
    ! [VarCurr: state_type] :
      ( v93815(VarCurr)
    <=> ( v93816(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3215,axiom,
    ! [VarCurr: state_type] :
      ( v93816(VarCurr)
    <=> ( v93817(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3214,axiom,
    ! [VarCurr: state_type] :
      ( v93817(VarCurr)
    <=> ( v93818(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3213,axiom,
    ! [VarCurr: state_type] :
      ( v93818(VarCurr)
    <=> ( v93819(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3212,axiom,
    ! [VarCurr: state_type] :
      ( v93819(VarCurr)
    <=> ( v93820(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3211,axiom,
    ! [VarCurr: state_type] :
      ( v93820(VarCurr)
    <=> ( v93821(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3210,axiom,
    ! [VarCurr: state_type] :
      ( v93821(VarCurr)
    <=> ( v93822(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3209,axiom,
    ! [VarCurr: state_type] :
      ( v93822(VarCurr)
    <=> ( v93823(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3208,axiom,
    ! [VarCurr: state_type] :
      ( v93823(VarCurr)
    <=> ( v93824(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3207,axiom,
    ! [VarCurr: state_type] :
      ( v93824(VarCurr)
    <=> ( v93825(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3206,axiom,
    ! [VarCurr: state_type] :
      ( v93825(VarCurr)
    <=> ( v93826(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3205,axiom,
    ! [VarCurr: state_type] :
      ( v93826(VarCurr)
    <=> ( v93827(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3204,axiom,
    ! [VarCurr: state_type] :
      ( v93827(VarCurr)
    <=> ( v93828(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3203,axiom,
    ! [VarCurr: state_type] :
      ( v93828(VarCurr)
    <=> ( v93829(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3202,axiom,
    ! [VarCurr: state_type] :
      ( v93829(VarCurr)
    <=> ( v93830(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3201,axiom,
    ! [VarCurr: state_type] :
      ( v93830(VarCurr)
    <=> ( v93831(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3200,axiom,
    ! [VarCurr: state_type] :
      ( v93831(VarCurr)
    <=> ( v93832(VarCurr)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3199,axiom,
    ! [VarCurr: state_type] :
      ( v93832(VarCurr)
    <=> ( v93833(VarCurr)
      <~> v93558(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3198,axiom,
    ! [VarCurr: state_type] :
      ( v93833(VarCurr)
    <=> ( v93834(VarCurr)
      <~> v93558(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3197,axiom,
    ! [VarCurr: state_type] :
      ( v93834(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3196,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,5)
    <=> ( v93754(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3195,axiom,
    ! [VarCurr: state_type] :
      ( v93754(VarCurr)
    <=> ( v93755(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3194,axiom,
    ! [VarCurr: state_type] :
      ( v93755(VarCurr)
    <=> ( v93756(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3193,axiom,
    ! [VarCurr: state_type] :
      ( v93756(VarCurr)
    <=> ( v93757(VarCurr)
      <~> v93558(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3192,axiom,
    ! [VarCurr: state_type] :
      ( v93757(VarCurr)
    <=> ( v93758(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3191,axiom,
    ! [VarCurr: state_type] :
      ( v93758(VarCurr)
    <=> ( v93759(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3190,axiom,
    ! [VarCurr: state_type] :
      ( v93759(VarCurr)
    <=> ( v93760(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3189,axiom,
    ! [VarCurr: state_type] :
      ( v93760(VarCurr)
    <=> ( v93761(VarCurr)
      <~> v93558(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3188,axiom,
    ! [VarCurr: state_type] :
      ( v93761(VarCurr)
    <=> ( v93762(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3187,axiom,
    ! [VarCurr: state_type] :
      ( v93762(VarCurr)
    <=> ( v93763(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3186,axiom,
    ! [VarCurr: state_type] :
      ( v93763(VarCurr)
    <=> ( v93764(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3185,axiom,
    ! [VarCurr: state_type] :
      ( v93764(VarCurr)
    <=> ( v93765(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3184,axiom,
    ! [VarCurr: state_type] :
      ( v93765(VarCurr)
    <=> ( v93766(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3183,axiom,
    ! [VarCurr: state_type] :
      ( v93766(VarCurr)
    <=> ( v93767(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3182,axiom,
    ! [VarCurr: state_type] :
      ( v93767(VarCurr)
    <=> ( v93768(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3181,axiom,
    ! [VarCurr: state_type] :
      ( v93768(VarCurr)
    <=> ( v93769(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3180,axiom,
    ! [VarCurr: state_type] :
      ( v93769(VarCurr)
    <=> ( v93770(VarCurr)
      <~> v93558(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3179,axiom,
    ! [VarCurr: state_type] :
      ( v93770(VarCurr)
    <=> ( v93771(VarCurr)
      <~> v93558(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3178,axiom,
    ! [VarCurr: state_type] :
      ( v93771(VarCurr)
    <=> ( v93772(VarCurr)
      <~> v93558(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3177,axiom,
    ! [VarCurr: state_type] :
      ( v93772(VarCurr)
    <=> ( v93773(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3176,axiom,
    ! [VarCurr: state_type] :
      ( v93773(VarCurr)
    <=> ( v93774(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3175,axiom,
    ! [VarCurr: state_type] :
      ( v93774(VarCurr)
    <=> ( v93775(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3174,axiom,
    ! [VarCurr: state_type] :
      ( v93775(VarCurr)
    <=> ( v93776(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3173,axiom,
    ! [VarCurr: state_type] :
      ( v93776(VarCurr)
    <=> ( v93777(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3172,axiom,
    ! [VarCurr: state_type] :
      ( v93777(VarCurr)
    <=> ( v93778(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3171,axiom,
    ! [VarCurr: state_type] :
      ( v93778(VarCurr)
    <=> ( v93779(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3170,axiom,
    ! [VarCurr: state_type] :
      ( v93779(VarCurr)
    <=> ( v93780(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3169,axiom,
    ! [VarCurr: state_type] :
      ( v93780(VarCurr)
    <=> ( v93781(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3168,axiom,
    ! [VarCurr: state_type] :
      ( v93781(VarCurr)
    <=> ( v93782(VarCurr)
      <~> v93558(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3167,axiom,
    ! [VarCurr: state_type] :
      ( v93782(VarCurr)
    <=> ( v93783(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3166,axiom,
    ! [VarCurr: state_type] :
      ( v93783(VarCurr)
    <=> ( v93784(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3165,axiom,
    ! [VarCurr: state_type] :
      ( v93784(VarCurr)
    <=> ( v93785(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3164,axiom,
    ! [VarCurr: state_type] :
      ( v93785(VarCurr)
    <=> ( v93786(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3163,axiom,
    ! [VarCurr: state_type] :
      ( v93786(VarCurr)
    <=> ( v93787(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3162,axiom,
    ! [VarCurr: state_type] :
      ( v93787(VarCurr)
    <=> ( v93788(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3161,axiom,
    ! [VarCurr: state_type] :
      ( v93788(VarCurr)
    <=> ( v93789(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3160,axiom,
    ! [VarCurr: state_type] :
      ( v93789(VarCurr)
    <=> ( v93790(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3159,axiom,
    ! [VarCurr: state_type] :
      ( v93790(VarCurr)
    <=> ( v93791(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3158,axiom,
    ! [VarCurr: state_type] :
      ( v93791(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3157,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,4)
    <=> ( v93715(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3156,axiom,
    ! [VarCurr: state_type] :
      ( v93715(VarCurr)
    <=> ( v93716(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3155,axiom,
    ! [VarCurr: state_type] :
      ( v93716(VarCurr)
    <=> ( v93717(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3154,axiom,
    ! [VarCurr: state_type] :
      ( v93717(VarCurr)
    <=> ( v93718(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3153,axiom,
    ! [VarCurr: state_type] :
      ( v93718(VarCurr)
    <=> ( v93719(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3152,axiom,
    ! [VarCurr: state_type] :
      ( v93719(VarCurr)
    <=> ( v93720(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3151,axiom,
    ! [VarCurr: state_type] :
      ( v93720(VarCurr)
    <=> ( v93721(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3150,axiom,
    ! [VarCurr: state_type] :
      ( v93721(VarCurr)
    <=> ( v93722(VarCurr)
      <~> v93558(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3149,axiom,
    ! [VarCurr: state_type] :
      ( v93722(VarCurr)
    <=> ( v93723(VarCurr)
      <~> v93558(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3148,axiom,
    ! [VarCurr: state_type] :
      ( v93723(VarCurr)
    <=> ( v93724(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3147,axiom,
    ! [VarCurr: state_type] :
      ( v93724(VarCurr)
    <=> ( v93725(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3146,axiom,
    ! [VarCurr: state_type] :
      ( v93725(VarCurr)
    <=> ( v93726(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3145,axiom,
    ! [VarCurr: state_type] :
      ( v93726(VarCurr)
    <=> ( v93727(VarCurr)
      <~> v93558(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3144,axiom,
    ! [VarCurr: state_type] :
      ( v93727(VarCurr)
    <=> ( v93728(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3143,axiom,
    ! [VarCurr: state_type] :
      ( v93728(VarCurr)
    <=> ( v93729(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3142,axiom,
    ! [VarCurr: state_type] :
      ( v93729(VarCurr)
    <=> ( v93730(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3141,axiom,
    ! [VarCurr: state_type] :
      ( v93730(VarCurr)
    <=> ( v93731(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3140,axiom,
    ! [VarCurr: state_type] :
      ( v93731(VarCurr)
    <=> ( v93732(VarCurr)
      <~> v93558(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3139,axiom,
    ! [VarCurr: state_type] :
      ( v93732(VarCurr)
    <=> ( v93733(VarCurr)
      <~> v93558(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3138,axiom,
    ! [VarCurr: state_type] :
      ( v93733(VarCurr)
    <=> ( v93734(VarCurr)
      <~> v93558(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3137,axiom,
    ! [VarCurr: state_type] :
      ( v93734(VarCurr)
    <=> ( v93735(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3136,axiom,
    ! [VarCurr: state_type] :
      ( v93735(VarCurr)
    <=> ( v93736(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3135,axiom,
    ! [VarCurr: state_type] :
      ( v93736(VarCurr)
    <=> ( v93737(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3134,axiom,
    ! [VarCurr: state_type] :
      ( v93737(VarCurr)
    <=> ( v93738(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3133,axiom,
    ! [VarCurr: state_type] :
      ( v93738(VarCurr)
    <=> ( v93739(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3132,axiom,
    ! [VarCurr: state_type] :
      ( v93739(VarCurr)
    <=> ( v93740(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3131,axiom,
    ! [VarCurr: state_type] :
      ( v93740(VarCurr)
    <=> ( v93741(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3130,axiom,
    ! [VarCurr: state_type] :
      ( v93741(VarCurr)
    <=> ( v93742(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3129,axiom,
    ! [VarCurr: state_type] :
      ( v93742(VarCurr)
    <=> ( v93743(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3128,axiom,
    ! [VarCurr: state_type] :
      ( v93743(VarCurr)
    <=> ( v93744(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3127,axiom,
    ! [VarCurr: state_type] :
      ( v93744(VarCurr)
    <=> ( v93745(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3126,axiom,
    ! [VarCurr: state_type] :
      ( v93745(VarCurr)
    <=> ( v93746(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3125,axiom,
    ! [VarCurr: state_type] :
      ( v93746(VarCurr)
    <=> ( v93747(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3124,axiom,
    ! [VarCurr: state_type] :
      ( v93747(VarCurr)
    <=> ( v93748(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3123,axiom,
    ! [VarCurr: state_type] :
      ( v93748(VarCurr)
    <=> ( v93749(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3122,axiom,
    ! [VarCurr: state_type] :
      ( v93749(VarCurr)
    <=> ( v93750(VarCurr)
      <~> v93558(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3121,axiom,
    ! [VarCurr: state_type] :
      ( v93750(VarCurr)
    <=> ( v93751(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3120,axiom,
    ! [VarCurr: state_type] :
      ( v93751(VarCurr)
    <=> ( v93752(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3119,axiom,
    ! [VarCurr: state_type] :
      ( v93752(VarCurr)
    <=> ( v93558(VarCurr,70)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3118,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,3)
    <=> ( v93675(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3117,axiom,
    ! [VarCurr: state_type] :
      ( v93675(VarCurr)
    <=> ( v93676(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3116,axiom,
    ! [VarCurr: state_type] :
      ( v93676(VarCurr)
    <=> ( v93677(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3115,axiom,
    ! [VarCurr: state_type] :
      ( v93677(VarCurr)
    <=> ( v93678(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3114,axiom,
    ! [VarCurr: state_type] :
      ( v93678(VarCurr)
    <=> ( v93679(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3113,axiom,
    ! [VarCurr: state_type] :
      ( v93679(VarCurr)
    <=> ( v93680(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3112,axiom,
    ! [VarCurr: state_type] :
      ( v93680(VarCurr)
    <=> ( v93681(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3111,axiom,
    ! [VarCurr: state_type] :
      ( v93681(VarCurr)
    <=> ( v93682(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3110,axiom,
    ! [VarCurr: state_type] :
      ( v93682(VarCurr)
    <=> ( v93683(VarCurr)
      <~> v93558(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3109,axiom,
    ! [VarCurr: state_type] :
      ( v93683(VarCurr)
    <=> ( v93684(VarCurr)
      <~> v93558(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3108,axiom,
    ! [VarCurr: state_type] :
      ( v93684(VarCurr)
    <=> ( v93685(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3107,axiom,
    ! [VarCurr: state_type] :
      ( v93685(VarCurr)
    <=> ( v93686(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3106,axiom,
    ! [VarCurr: state_type] :
      ( v93686(VarCurr)
    <=> ( v93687(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3105,axiom,
    ! [VarCurr: state_type] :
      ( v93687(VarCurr)
    <=> ( v93688(VarCurr)
      <~> v93558(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3104,axiom,
    ! [VarCurr: state_type] :
      ( v93688(VarCurr)
    <=> ( v93689(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3103,axiom,
    ! [VarCurr: state_type] :
      ( v93689(VarCurr)
    <=> ( v93690(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3102,axiom,
    ! [VarCurr: state_type] :
      ( v93690(VarCurr)
    <=> ( v93691(VarCurr)
      <~> v93558(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3101,axiom,
    ! [VarCurr: state_type] :
      ( v93691(VarCurr)
    <=> ( v93692(VarCurr)
      <~> v93558(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3100,axiom,
    ! [VarCurr: state_type] :
      ( v93692(VarCurr)
    <=> ( v93693(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3099,axiom,
    ! [VarCurr: state_type] :
      ( v93693(VarCurr)
    <=> ( v93694(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3098,axiom,
    ! [VarCurr: state_type] :
      ( v93694(VarCurr)
    <=> ( v93695(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3097,axiom,
    ! [VarCurr: state_type] :
      ( v93695(VarCurr)
    <=> ( v93696(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3096,axiom,
    ! [VarCurr: state_type] :
      ( v93696(VarCurr)
    <=> ( v93697(VarCurr)
      <~> v93558(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3095,axiom,
    ! [VarCurr: state_type] :
      ( v93697(VarCurr)
    <=> ( v93698(VarCurr)
      <~> v93558(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3094,axiom,
    ! [VarCurr: state_type] :
      ( v93698(VarCurr)
    <=> ( v93699(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3093,axiom,
    ! [VarCurr: state_type] :
      ( v93699(VarCurr)
    <=> ( v93700(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3092,axiom,
    ! [VarCurr: state_type] :
      ( v93700(VarCurr)
    <=> ( v93701(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3091,axiom,
    ! [VarCurr: state_type] :
      ( v93701(VarCurr)
    <=> ( v93702(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3090,axiom,
    ! [VarCurr: state_type] :
      ( v93702(VarCurr)
    <=> ( v93703(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3089,axiom,
    ! [VarCurr: state_type] :
      ( v93703(VarCurr)
    <=> ( v93704(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3088,axiom,
    ! [VarCurr: state_type] :
      ( v93704(VarCurr)
    <=> ( v93705(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3087,axiom,
    ! [VarCurr: state_type] :
      ( v93705(VarCurr)
    <=> ( v93706(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3086,axiom,
    ! [VarCurr: state_type] :
      ( v93706(VarCurr)
    <=> ( v93707(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3085,axiom,
    ! [VarCurr: state_type] :
      ( v93707(VarCurr)
    <=> ( v93708(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3084,axiom,
    ! [VarCurr: state_type] :
      ( v93708(VarCurr)
    <=> ( v93709(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3083,axiom,
    ! [VarCurr: state_type] :
      ( v93709(VarCurr)
    <=> ( v93710(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3082,axiom,
    ! [VarCurr: state_type] :
      ( v93710(VarCurr)
    <=> ( v93711(VarCurr)
      <~> v93558(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3081,axiom,
    ! [VarCurr: state_type] :
      ( v93711(VarCurr)
    <=> ( v93712(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3080,axiom,
    ! [VarCurr: state_type] :
      ( v93712(VarCurr)
    <=> ( v93713(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3079,axiom,
    ! [VarCurr: state_type] :
      ( v93713(VarCurr)
    <=> ( v93558(VarCurr,70)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3078,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,2)
    <=> ( v93641(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3077,axiom,
    ! [VarCurr: state_type] :
      ( v93641(VarCurr)
    <=> ( v93642(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3076,axiom,
    ! [VarCurr: state_type] :
      ( v93642(VarCurr)
    <=> ( v93643(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3075,axiom,
    ! [VarCurr: state_type] :
      ( v93643(VarCurr)
    <=> ( v93644(VarCurr)
      <~> v93558(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3074,axiom,
    ! [VarCurr: state_type] :
      ( v93644(VarCurr)
    <=> ( v93645(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3073,axiom,
    ! [VarCurr: state_type] :
      ( v93645(VarCurr)
    <=> ( v93646(VarCurr)
      <~> v93558(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3072,axiom,
    ! [VarCurr: state_type] :
      ( v93646(VarCurr)
    <=> ( v93647(VarCurr)
      <~> v93558(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3071,axiom,
    ! [VarCurr: state_type] :
      ( v93647(VarCurr)
    <=> ( v93648(VarCurr)
      <~> v93558(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3070,axiom,
    ! [VarCurr: state_type] :
      ( v93648(VarCurr)
    <=> ( v93649(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3069,axiom,
    ! [VarCurr: state_type] :
      ( v93649(VarCurr)
    <=> ( v93650(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3068,axiom,
    ! [VarCurr: state_type] :
      ( v93650(VarCurr)
    <=> ( v93651(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3067,axiom,
    ! [VarCurr: state_type] :
      ( v93651(VarCurr)
    <=> ( v93652(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3066,axiom,
    ! [VarCurr: state_type] :
      ( v93652(VarCurr)
    <=> ( v93653(VarCurr)
      <~> v93558(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3065,axiom,
    ! [VarCurr: state_type] :
      ( v93653(VarCurr)
    <=> ( v93654(VarCurr)
      <~> v93558(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3064,axiom,
    ! [VarCurr: state_type] :
      ( v93654(VarCurr)
    <=> ( v93655(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3063,axiom,
    ! [VarCurr: state_type] :
      ( v93655(VarCurr)
    <=> ( v93656(VarCurr)
      <~> v93558(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3062,axiom,
    ! [VarCurr: state_type] :
      ( v93656(VarCurr)
    <=> ( v93657(VarCurr)
      <~> v93558(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3061,axiom,
    ! [VarCurr: state_type] :
      ( v93657(VarCurr)
    <=> ( v93658(VarCurr)
      <~> v93558(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3060,axiom,
    ! [VarCurr: state_type] :
      ( v93658(VarCurr)
    <=> ( v93659(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3059,axiom,
    ! [VarCurr: state_type] :
      ( v93659(VarCurr)
    <=> ( v93660(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3058,axiom,
    ! [VarCurr: state_type] :
      ( v93660(VarCurr)
    <=> ( v93661(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3057,axiom,
    ! [VarCurr: state_type] :
      ( v93661(VarCurr)
    <=> ( v93662(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3056,axiom,
    ! [VarCurr: state_type] :
      ( v93662(VarCurr)
    <=> ( v93663(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3055,axiom,
    ! [VarCurr: state_type] :
      ( v93663(VarCurr)
    <=> ( v93664(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3054,axiom,
    ! [VarCurr: state_type] :
      ( v93664(VarCurr)
    <=> ( v93665(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3053,axiom,
    ! [VarCurr: state_type] :
      ( v93665(VarCurr)
    <=> ( v93666(VarCurr)
      <~> v93558(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3052,axiom,
    ! [VarCurr: state_type] :
      ( v93666(VarCurr)
    <=> ( v93667(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3051,axiom,
    ! [VarCurr: state_type] :
      ( v93667(VarCurr)
    <=> ( v93668(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3050,axiom,
    ! [VarCurr: state_type] :
      ( v93668(VarCurr)
    <=> ( v93669(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3049,axiom,
    ! [VarCurr: state_type] :
      ( v93669(VarCurr)
    <=> ( v93670(VarCurr)
      <~> v93558(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3048,axiom,
    ! [VarCurr: state_type] :
      ( v93670(VarCurr)
    <=> ( v93671(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3047,axiom,
    ! [VarCurr: state_type] :
      ( v93671(VarCurr)
    <=> ( v93672(VarCurr)
      <~> v93558(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3046,axiom,
    ! [VarCurr: state_type] :
      ( v93672(VarCurr)
    <=> ( v93673(VarCurr)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3045,axiom,
    ! [VarCurr: state_type] :
      ( v93673(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3044,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,1)
    <=> ( v93607(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3043,axiom,
    ! [VarCurr: state_type] :
      ( v93607(VarCurr)
    <=> ( v93608(VarCurr)
      <~> v93558(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3042,axiom,
    ! [VarCurr: state_type] :
      ( v93608(VarCurr)
    <=> ( v93609(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3041,axiom,
    ! [VarCurr: state_type] :
      ( v93609(VarCurr)
    <=> ( v93610(VarCurr)
      <~> v93558(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3040,axiom,
    ! [VarCurr: state_type] :
      ( v93610(VarCurr)
    <=> ( v93611(VarCurr)
      <~> v93558(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3039,axiom,
    ! [VarCurr: state_type] :
      ( v93611(VarCurr)
    <=> ( v93612(VarCurr)
      <~> v93558(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3038,axiom,
    ! [VarCurr: state_type] :
      ( v93612(VarCurr)
    <=> ( v93613(VarCurr)
      <~> v93558(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3037,axiom,
    ! [VarCurr: state_type] :
      ( v93613(VarCurr)
    <=> ( v93614(VarCurr)
      <~> v93558(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3036,axiom,
    ! [VarCurr: state_type] :
      ( v93614(VarCurr)
    <=> ( v93615(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3035,axiom,
    ! [VarCurr: state_type] :
      ( v93615(VarCurr)
    <=> ( v93616(VarCurr)
      <~> v93558(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3034,axiom,
    ! [VarCurr: state_type] :
      ( v93616(VarCurr)
    <=> ( v93617(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3033,axiom,
    ! [VarCurr: state_type] :
      ( v93617(VarCurr)
    <=> ( v93618(VarCurr)
      <~> v93558(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3032,axiom,
    ! [VarCurr: state_type] :
      ( v93618(VarCurr)
    <=> ( v93619(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3031,axiom,
    ! [VarCurr: state_type] :
      ( v93619(VarCurr)
    <=> ( v93620(VarCurr)
      <~> v93558(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3030,axiom,
    ! [VarCurr: state_type] :
      ( v93620(VarCurr)
    <=> ( v93621(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3029,axiom,
    ! [VarCurr: state_type] :
      ( v93621(VarCurr)
    <=> ( v93622(VarCurr)
      <~> v93558(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3028,axiom,
    ! [VarCurr: state_type] :
      ( v93622(VarCurr)
    <=> ( v93623(VarCurr)
      <~> v93558(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3027,axiom,
    ! [VarCurr: state_type] :
      ( v93623(VarCurr)
    <=> ( v93624(VarCurr)
      <~> v93558(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3026,axiom,
    ! [VarCurr: state_type] :
      ( v93624(VarCurr)
    <=> ( v93625(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3025,axiom,
    ! [VarCurr: state_type] :
      ( v93625(VarCurr)
    <=> ( v93626(VarCurr)
      <~> v93558(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3024,axiom,
    ! [VarCurr: state_type] :
      ( v93626(VarCurr)
    <=> ( v93627(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3023,axiom,
    ! [VarCurr: state_type] :
      ( v93627(VarCurr)
    <=> ( v93628(VarCurr)
      <~> v93558(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3022,axiom,
    ! [VarCurr: state_type] :
      ( v93628(VarCurr)
    <=> ( v93629(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3021,axiom,
    ! [VarCurr: state_type] :
      ( v93629(VarCurr)
    <=> ( v93630(VarCurr)
      <~> v93558(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3020,axiom,
    ! [VarCurr: state_type] :
      ( v93630(VarCurr)
    <=> ( v93631(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3019,axiom,
    ! [VarCurr: state_type] :
      ( v93631(VarCurr)
    <=> ( v93632(VarCurr)
      <~> v93558(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3018,axiom,
    ! [VarCurr: state_type] :
      ( v93632(VarCurr)
    <=> ( v93633(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3017,axiom,
    ! [VarCurr: state_type] :
      ( v93633(VarCurr)
    <=> ( v93634(VarCurr)
      <~> v93558(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3016,axiom,
    ! [VarCurr: state_type] :
      ( v93634(VarCurr)
    <=> ( v93635(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3015,axiom,
    ! [VarCurr: state_type] :
      ( v93635(VarCurr)
    <=> ( v93636(VarCurr)
      <~> v93558(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3014,axiom,
    ! [VarCurr: state_type] :
      ( v93636(VarCurr)
    <=> ( v93637(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3013,axiom,
    ! [VarCurr: state_type] :
      ( v93637(VarCurr)
    <=> ( v93638(VarCurr)
      <~> v93558(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3012,axiom,
    ! [VarCurr: state_type] :
      ( v93638(VarCurr)
    <=> ( v93639(VarCurr)
      <~> v93558(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3011,axiom,
    ! [VarCurr: state_type] :
      ( v93639(VarCurr)
    <=> ( v93558(VarCurr,70)
      <~> v93558(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8665,axiom,
    ! [VarCurr: state_type] :
      ( v93556(VarCurr,0)
    <=> ( v93567(VarCurr)
      <~> v93558(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3010,axiom,
    ! [VarCurr: state_type] :
      ( v93567(VarCurr)
    <=> ( v93568(VarCurr)
      <~> v93558(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3009,axiom,
    ! [VarCurr: state_type] :
      ( v93568(VarCurr)
    <=> ( v93569(VarCurr)
      <~> v93558(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3008,axiom,
    ! [VarCurr: state_type] :
      ( v93569(VarCurr)
    <=> ( v93570(VarCurr)
      <~> v93558(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3007,axiom,
    ! [VarCurr: state_type] :
      ( v93570(VarCurr)
    <=> ( v93571(VarCurr)
      <~> v93558(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3006,axiom,
    ! [VarCurr: state_type] :
      ( v93571(VarCurr)
    <=> ( v93572(VarCurr)
      <~> v93558(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3005,axiom,
    ! [VarCurr: state_type] :
      ( v93572(VarCurr)
    <=> ( v93573(VarCurr)
      <~> v93558(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3004,axiom,
    ! [VarCurr: state_type] :
      ( v93573(VarCurr)
    <=> ( v93574(VarCurr)
      <~> v93558(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3003,axiom,
    ! [VarCurr: state_type] :
      ( v93574(VarCurr)
    <=> ( v93575(VarCurr)
      <~> v93558(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3002,axiom,
    ! [VarCurr: state_type] :
      ( v93575(VarCurr)
    <=> ( v93576(VarCurr)
      <~> v93558(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3001,axiom,
    ! [VarCurr: state_type] :
      ( v93576(VarCurr)
    <=> ( v93577(VarCurr)
      <~> v93558(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3000,axiom,
    ! [VarCurr: state_type] :
      ( v93577(VarCurr)
    <=> ( v93578(VarCurr)
      <~> v93558(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2999,axiom,
    ! [VarCurr: state_type] :
      ( v93578(VarCurr)
    <=> ( v93579(VarCurr)
      <~> v93558(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2998,axiom,
    ! [VarCurr: state_type] :
      ( v93579(VarCurr)
    <=> ( v93580(VarCurr)
      <~> v93558(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2997,axiom,
    ! [VarCurr: state_type] :
      ( v93580(VarCurr)
    <=> ( v93581(VarCurr)
      <~> v93558(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2996,axiom,
    ! [VarCurr: state_type] :
      ( v93581(VarCurr)
    <=> ( v93582(VarCurr)
      <~> v93558(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2995,axiom,
    ! [VarCurr: state_type] :
      ( v93582(VarCurr)
    <=> ( v93583(VarCurr)
      <~> v93558(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2994,axiom,
    ! [VarCurr: state_type] :
      ( v93583(VarCurr)
    <=> ( v93584(VarCurr)
      <~> v93558(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2993,axiom,
    ! [VarCurr: state_type] :
      ( v93584(VarCurr)
    <=> ( v93585(VarCurr)
      <~> v93558(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2992,axiom,
    ! [VarCurr: state_type] :
      ( v93585(VarCurr)
    <=> ( v93586(VarCurr)
      <~> v93558(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2991,axiom,
    ! [VarCurr: state_type] :
      ( v93586(VarCurr)
    <=> ( v93587(VarCurr)
      <~> v93558(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2990,axiom,
    ! [VarCurr: state_type] :
      ( v93587(VarCurr)
    <=> ( v93588(VarCurr)
      <~> v93558(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2989,axiom,
    ! [VarCurr: state_type] :
      ( v93588(VarCurr)
    <=> ( v93589(VarCurr)
      <~> v93558(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2988,axiom,
    ! [VarCurr: state_type] :
      ( v93589(VarCurr)
    <=> ( v93590(VarCurr)
      <~> v93558(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2987,axiom,
    ! [VarCurr: state_type] :
      ( v93590(VarCurr)
    <=> ( v93591(VarCurr)
      <~> v93558(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2986,axiom,
    ! [VarCurr: state_type] :
      ( v93591(VarCurr)
    <=> ( v93592(VarCurr)
      <~> v93558(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2985,axiom,
    ! [VarCurr: state_type] :
      ( v93592(VarCurr)
    <=> ( v93593(VarCurr)
      <~> v93558(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2984,axiom,
    ! [VarCurr: state_type] :
      ( v93593(VarCurr)
    <=> ( v93594(VarCurr)
      <~> v93558(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2983,axiom,
    ! [VarCurr: state_type] :
      ( v93594(VarCurr)
    <=> ( v93595(VarCurr)
      <~> v93558(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2982,axiom,
    ! [VarCurr: state_type] :
      ( v93595(VarCurr)
    <=> ( v93596(VarCurr)
      <~> v93558(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2981,axiom,
    ! [VarCurr: state_type] :
      ( v93596(VarCurr)
    <=> ( v93597(VarCurr)
      <~> v93558(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2980,axiom,
    ! [VarCurr: state_type] :
      ( v93597(VarCurr)
    <=> ( v93598(VarCurr)
      <~> v93558(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2979,axiom,
    ! [VarCurr: state_type] :
      ( v93598(VarCurr)
    <=> ( v93599(VarCurr)
      <~> v93558(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2978,axiom,
    ! [VarCurr: state_type] :
      ( v93599(VarCurr)
    <=> ( v93600(VarCurr)
      <~> v93558(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2977,axiom,
    ! [VarCurr: state_type] :
      ( v93600(VarCurr)
    <=> ( v93601(VarCurr)
      <~> v93558(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2976,axiom,
    ! [VarCurr: state_type] :
      ( v93601(VarCurr)
    <=> ( v93602(VarCurr)
      <~> v93558(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2975,axiom,
    ! [VarCurr: state_type] :
      ( v93602(VarCurr)
    <=> ( v93603(VarCurr)
      <~> v93558(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2974,axiom,
    ! [VarCurr: state_type] :
      ( v93603(VarCurr)
    <=> ( v93604(VarCurr)
      <~> v93558(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2973,axiom,
    ! [VarCurr: state_type] :
      ( v93604(VarCurr)
    <=> ( v93605(VarCurr)
      <~> v93558(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2972,axiom,
    ! [VarCurr: state_type] :
      ( v93605(VarCurr)
    <=> ( v93558(VarCurr,71)
      <~> v93558(VarCurr,70) ) ) ).

tff(addAssignment_56977,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,33)
    <=> v93560(VarCurr,33) ) ).

tff(addAssignment_56976,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,33)
    <=> v93562(VarCurr,33) ) ).

tff(addAssignment_56975,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,33)
    <=> v93564(VarCurr,33) ) ).

tff(addAssignment_56974,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,33)
    <=> v93565(VarCurr,33) ) ).

tff(addAssignment_56973,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,62)
    <=> v93560(VarCurr,62) ) ).

tff(addAssignment_56972,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,62)
    <=> v93562(VarCurr,62) ) ).

tff(addAssignment_56971,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,62)
    <=> v93564(VarCurr,62) ) ).

tff(addAssignment_56970,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,62)
    <=> v93565(VarCurr,62) ) ).

tff(addAssignment_56969,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,15)
    <=> v93560(VarCurr,15) ) ).

tff(addAssignment_56968,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,15)
    <=> v93562(VarCurr,15) ) ).

tff(addAssignment_56967,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,15)
    <=> v93564(VarCurr,15) ) ).

tff(addAssignment_56966,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,15)
    <=> v93565(VarCurr,15) ) ).

tff(addAssignment_56965,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,32)
    <=> v93560(VarCurr,32) ) ).

tff(addAssignment_56964,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,32)
    <=> v93562(VarCurr,32) ) ).

tff(addAssignment_56963,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,32)
    <=> v93564(VarCurr,32) ) ).

tff(addAssignment_56962,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,32)
    <=> v93565(VarCurr,32) ) ).

tff(addAssignment_56961,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,61)
    <=> v93560(VarCurr,61) ) ).

tff(addAssignment_56960,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,61)
    <=> v93562(VarCurr,61) ) ).

tff(addAssignment_56959,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,61)
    <=> v93564(VarCurr,61) ) ).

tff(addAssignment_56958,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,61)
    <=> v93565(VarCurr,61) ) ).

tff(addAssignment_56957,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,5)
    <=> v93560(VarCurr,5) ) ).

tff(addAssignment_56956,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,5)
    <=> v93562(VarCurr,5) ) ).

tff(addAssignment_56955,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,5)
    <=> v93564(VarCurr,5) ) ).

tff(addAssignment_56954,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,5)
    <=> v93565(VarCurr,5) ) ).

tff(addAssignment_56953,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,11)
    <=> v93560(VarCurr,11) ) ).

tff(addAssignment_56952,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,11)
    <=> v93562(VarCurr,11) ) ).

tff(addAssignment_56951,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,11)
    <=> v93564(VarCurr,11) ) ).

tff(addAssignment_56950,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,11)
    <=> v93565(VarCurr,11) ) ).

tff(addAssignment_56949,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,14)
    <=> v93560(VarCurr,14) ) ).

tff(addAssignment_56948,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,14)
    <=> v93562(VarCurr,14) ) ).

tff(addAssignment_56947,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,14)
    <=> v93564(VarCurr,14) ) ).

tff(addAssignment_56946,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,14)
    <=> v93565(VarCurr,14) ) ).

tff(addAssignment_56945,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,24)
    <=> v93560(VarCurr,24) ) ).

tff(addAssignment_56944,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,24)
    <=> v93562(VarCurr,24) ) ).

tff(addAssignment_56943,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,24)
    <=> v93564(VarCurr,24) ) ).

tff(addAssignment_56942,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,24)
    <=> v93565(VarCurr,24) ) ).

tff(addAssignment_56941,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,28)
    <=> v93560(VarCurr,28) ) ).

tff(addAssignment_56940,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,28)
    <=> v93562(VarCurr,28) ) ).

tff(addAssignment_56939,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,28)
    <=> v93564(VarCurr,28) ) ).

tff(addAssignment_56938,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,28)
    <=> v93565(VarCurr,28) ) ).

tff(addAssignment_56937,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,31)
    <=> v93560(VarCurr,31) ) ).

tff(addAssignment_56936,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,31)
    <=> v93562(VarCurr,31) ) ).

tff(addAssignment_56935,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,31)
    <=> v93564(VarCurr,31) ) ).

tff(addAssignment_56934,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,31)
    <=> v93565(VarCurr,31) ) ).

tff(addAssignment_56933,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,51)
    <=> v93560(VarCurr,51) ) ).

tff(addAssignment_56932,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,51)
    <=> v93562(VarCurr,51) ) ).

tff(addAssignment_56931,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,51)
    <=> v93564(VarCurr,51) ) ).

tff(addAssignment_56930,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,51)
    <=> v93565(VarCurr,51) ) ).

tff(addAssignment_56929,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,60)
    <=> v93560(VarCurr,60) ) ).

tff(addAssignment_56928,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,60)
    <=> v93562(VarCurr,60) ) ).

tff(addAssignment_56927,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,60)
    <=> v93564(VarCurr,60) ) ).

tff(addAssignment_56926,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,60)
    <=> v93565(VarCurr,60) ) ).

tff(addAssignment_56925,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,65)
    <=> v93560(VarCurr,65) ) ).

tff(addAssignment_56924,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,65)
    <=> v93562(VarCurr,65) ) ).

tff(addAssignment_56923,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,65)
    <=> v93564(VarCurr,65) ) ).

tff(addAssignment_56922,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,65)
    <=> v93565(VarCurr,65) ) ).

tff(addAssignment_56921,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,2)
    <=> v93560(VarCurr,2) ) ).

tff(addAssignment_56920,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,2)
    <=> v93562(VarCurr,2) ) ).

tff(addAssignment_56919,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,2)
    <=> v93564(VarCurr,2) ) ).

tff(addAssignment_56918,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,2)
    <=> v93565(VarCurr,2) ) ).

tff(addAssignment_56917,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,4)
    <=> v93560(VarCurr,4) ) ).

tff(addAssignment_56916,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,4)
    <=> v93562(VarCurr,4) ) ).

tff(addAssignment_56915,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,4)
    <=> v93564(VarCurr,4) ) ).

tff(addAssignment_56914,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,4)
    <=> v93565(VarCurr,4) ) ).

tff(addAssignment_56913,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,10)
    <=> v93560(VarCurr,10) ) ).

tff(addAssignment_56912,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,10)
    <=> v93562(VarCurr,10) ) ).

tff(addAssignment_56911,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,10)
    <=> v93564(VarCurr,10) ) ).

tff(addAssignment_56910,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,10)
    <=> v93565(VarCurr,10) ) ).

tff(addAssignment_56909,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,13)
    <=> v93560(VarCurr,13) ) ).

tff(addAssignment_56908,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,13)
    <=> v93562(VarCurr,13) ) ).

tff(addAssignment_56907,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,13)
    <=> v93564(VarCurr,13) ) ).

tff(addAssignment_56906,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,13)
    <=> v93565(VarCurr,13) ) ).

tff(addAssignment_56905,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,17)
    <=> v93560(VarCurr,17) ) ).

tff(addAssignment_56904,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,17)
    <=> v93562(VarCurr,17) ) ).

tff(addAssignment_56903,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,17)
    <=> v93564(VarCurr,17) ) ).

tff(addAssignment_56902,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,17)
    <=> v93565(VarCurr,17) ) ).

tff(addAssignment_56901,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,20)
    <=> v93560(VarCurr,20) ) ).

tff(addAssignment_56900,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,20)
    <=> v93562(VarCurr,20) ) ).

tff(addAssignment_56899,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,20)
    <=> v93564(VarCurr,20) ) ).

tff(addAssignment_56898,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,20)
    <=> v93565(VarCurr,20) ) ).

tff(addAssignment_56897,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,23)
    <=> v93560(VarCurr,23) ) ).

tff(addAssignment_56896,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,23)
    <=> v93562(VarCurr,23) ) ).

tff(addAssignment_56895,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,23)
    <=> v93564(VarCurr,23) ) ).

tff(addAssignment_56894,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,23)
    <=> v93565(VarCurr,23) ) ).

tff(addAssignment_56893,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,27)
    <=> v93560(VarCurr,27) ) ).

tff(addAssignment_56892,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,27)
    <=> v93562(VarCurr,27) ) ).

tff(addAssignment_56891,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,27)
    <=> v93564(VarCurr,27) ) ).

tff(addAssignment_56890,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,27)
    <=> v93565(VarCurr,27) ) ).

tff(addAssignment_56889,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,30)
    <=> v93560(VarCurr,30) ) ).

tff(addAssignment_56888,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,30)
    <=> v93562(VarCurr,30) ) ).

tff(addAssignment_56887,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,30)
    <=> v93564(VarCurr,30) ) ).

tff(addAssignment_56886,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,30)
    <=> v93565(VarCurr,30) ) ).

tff(addAssignment_56885,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,43)
    <=> v93560(VarCurr,43) ) ).

tff(addAssignment_56884,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,43)
    <=> v93562(VarCurr,43) ) ).

tff(addAssignment_56883,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,43)
    <=> v93564(VarCurr,43) ) ).

tff(addAssignment_56882,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,43)
    <=> v93565(VarCurr,43) ) ).

tff(addAssignment_56881,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,45)
    <=> v93560(VarCurr,45) ) ).

tff(addAssignment_56880,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,45)
    <=> v93562(VarCurr,45) ) ).

tff(addAssignment_56879,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,45)
    <=> v93564(VarCurr,45) ) ).

tff(addAssignment_56878,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,45)
    <=> v93565(VarCurr,45) ) ).

tff(addAssignment_56877,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,47)
    <=> v93560(VarCurr,47) ) ).

tff(addAssignment_56876,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,47)
    <=> v93562(VarCurr,47) ) ).

tff(addAssignment_56875,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,47)
    <=> v93564(VarCurr,47) ) ).

tff(addAssignment_56874,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,47)
    <=> v93565(VarCurr,47) ) ).

tff(addAssignment_56873,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,50)
    <=> v93560(VarCurr,50) ) ).

tff(addAssignment_56872,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,50)
    <=> v93562(VarCurr,50) ) ).

tff(addAssignment_56871,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,50)
    <=> v93564(VarCurr,50) ) ).

tff(addAssignment_56870,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,50)
    <=> v93565(VarCurr,50) ) ).

tff(addAssignment_56869,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,57)
    <=> v93560(VarCurr,57) ) ).

tff(addAssignment_56868,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,57)
    <=> v93562(VarCurr,57) ) ).

tff(addAssignment_56867,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,57)
    <=> v93564(VarCurr,57) ) ).

tff(addAssignment_56866,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,57)
    <=> v93565(VarCurr,57) ) ).

tff(addAssignment_56865,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,59)
    <=> v93560(VarCurr,59) ) ).

tff(addAssignment_56864,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,59)
    <=> v93562(VarCurr,59) ) ).

tff(addAssignment_56863,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,59)
    <=> v93564(VarCurr,59) ) ).

tff(addAssignment_56862,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,59)
    <=> v93565(VarCurr,59) ) ).

tff(addAssignment_56861,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,64)
    <=> v93560(VarCurr,64) ) ).

tff(addAssignment_56860,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,64)
    <=> v93562(VarCurr,64) ) ).

tff(addAssignment_56859,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,64)
    <=> v93564(VarCurr,64) ) ).

tff(addAssignment_56858,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,64)
    <=> v93565(VarCurr,64) ) ).

tff(addAssignment_56857,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,69)
    <=> v93560(VarCurr,69) ) ).

tff(addAssignment_56856,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,69)
    <=> v93562(VarCurr,69) ) ).

tff(addAssignment_56855,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,69)
    <=> v93564(VarCurr,69) ) ).

tff(addAssignment_56854,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,69)
    <=> v93565(VarCurr,69) ) ).

tff(addAssignment_56853,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,0)
    <=> v93560(VarCurr,0) ) ).

tff(addAssignment_56852,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,0)
    <=> v93562(VarCurr,0) ) ).

tff(addAssignment_56851,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,0)
    <=> v93564(VarCurr,0) ) ).

tff(addAssignment_56850,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,0)
    <=> v93565(VarCurr,0) ) ).

tff(addAssignment_56849,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,1)
    <=> v93560(VarCurr,1) ) ).

tff(addAssignment_56848,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,1)
    <=> v93562(VarCurr,1) ) ).

tff(addAssignment_56847,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,1)
    <=> v93564(VarCurr,1) ) ).

tff(addAssignment_56846,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,1)
    <=> v93565(VarCurr,1) ) ).

tff(addAssignment_56845,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,3)
    <=> v93560(VarCurr,3) ) ).

tff(addAssignment_56844,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,3)
    <=> v93562(VarCurr,3) ) ).

tff(addAssignment_56843,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,3)
    <=> v93564(VarCurr,3) ) ).

tff(addAssignment_56842,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,3)
    <=> v93565(VarCurr,3) ) ).

tff(addAssignment_56841,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,6)
    <=> v93560(VarCurr,6) ) ).

tff(addAssignment_56840,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,6)
    <=> v93562(VarCurr,6) ) ).

tff(addAssignment_56839,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,6)
    <=> v93564(VarCurr,6) ) ).

tff(addAssignment_56838,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,6)
    <=> v93565(VarCurr,6) ) ).

tff(addAssignment_56837,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,7)
    <=> v93560(VarCurr,7) ) ).

tff(addAssignment_56836,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,7)
    <=> v93562(VarCurr,7) ) ).

tff(addAssignment_56835,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,7)
    <=> v93564(VarCurr,7) ) ).

tff(addAssignment_56834,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,7)
    <=> v93565(VarCurr,7) ) ).

tff(addAssignment_56833,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,8)
    <=> v93560(VarCurr,8) ) ).

tff(addAssignment_56832,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,8)
    <=> v93562(VarCurr,8) ) ).

tff(addAssignment_56831,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,8)
    <=> v93564(VarCurr,8) ) ).

tff(addAssignment_56830,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,8)
    <=> v93565(VarCurr,8) ) ).

tff(addAssignment_56829,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,9)
    <=> v93560(VarCurr,9) ) ).

tff(addAssignment_56828,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,9)
    <=> v93562(VarCurr,9) ) ).

tff(addAssignment_56827,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,9)
    <=> v93564(VarCurr,9) ) ).

tff(addAssignment_56826,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,9)
    <=> v93565(VarCurr,9) ) ).

tff(addAssignment_56825,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,12)
    <=> v93560(VarCurr,12) ) ).

tff(addAssignment_56824,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,12)
    <=> v93562(VarCurr,12) ) ).

tff(addAssignment_56823,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,12)
    <=> v93564(VarCurr,12) ) ).

tff(addAssignment_56822,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,12)
    <=> v93565(VarCurr,12) ) ).

tff(addAssignment_56821,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,16)
    <=> v93560(VarCurr,16) ) ).

tff(addAssignment_56820,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,16)
    <=> v93562(VarCurr,16) ) ).

tff(addAssignment_56819,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,16)
    <=> v93564(VarCurr,16) ) ).

tff(addAssignment_56818,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,16)
    <=> v93565(VarCurr,16) ) ).

tff(addAssignment_56817,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,18)
    <=> v93560(VarCurr,18) ) ).

tff(addAssignment_56816,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,18)
    <=> v93562(VarCurr,18) ) ).

tff(addAssignment_56815,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,18)
    <=> v93564(VarCurr,18) ) ).

tff(addAssignment_56814,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,18)
    <=> v93565(VarCurr,18) ) ).

tff(addAssignment_56813,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,19)
    <=> v93560(VarCurr,19) ) ).

tff(addAssignment_56812,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,19)
    <=> v93562(VarCurr,19) ) ).

tff(addAssignment_56811,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,19)
    <=> v93564(VarCurr,19) ) ).

tff(addAssignment_56810,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,19)
    <=> v93565(VarCurr,19) ) ).

tff(addAssignment_56809,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,21)
    <=> v93560(VarCurr,21) ) ).

tff(addAssignment_56808,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,21)
    <=> v93562(VarCurr,21) ) ).

tff(addAssignment_56807,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,21)
    <=> v93564(VarCurr,21) ) ).

tff(addAssignment_56806,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,21)
    <=> v93565(VarCurr,21) ) ).

tff(addAssignment_56805,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,22)
    <=> v93560(VarCurr,22) ) ).

tff(addAssignment_56804,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,22)
    <=> v93562(VarCurr,22) ) ).

tff(addAssignment_56803,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,22)
    <=> v93564(VarCurr,22) ) ).

tff(addAssignment_56802,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,22)
    <=> v93565(VarCurr,22) ) ).

tff(addAssignment_56801,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,25)
    <=> v93560(VarCurr,25) ) ).

tff(addAssignment_56800,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,25)
    <=> v93562(VarCurr,25) ) ).

tff(addAssignment_56799,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,25)
    <=> v93564(VarCurr,25) ) ).

tff(addAssignment_56798,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,25)
    <=> v93565(VarCurr,25) ) ).

tff(addAssignment_56797,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,26)
    <=> v93560(VarCurr,26) ) ).

tff(addAssignment_56796,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,26)
    <=> v93562(VarCurr,26) ) ).

tff(addAssignment_56795,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,26)
    <=> v93564(VarCurr,26) ) ).

tff(addAssignment_56794,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,26)
    <=> v93565(VarCurr,26) ) ).

tff(addAssignment_56793,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,29)
    <=> v93560(VarCurr,29) ) ).

tff(addAssignment_56792,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,29)
    <=> v93562(VarCurr,29) ) ).

tff(addAssignment_56791,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,29)
    <=> v93564(VarCurr,29) ) ).

tff(addAssignment_56790,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,29)
    <=> v93565(VarCurr,29) ) ).

tff(addAssignment_56789,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,34)
    <=> v93560(VarCurr,34) ) ).

tff(addAssignment_56788,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,34)
    <=> v93562(VarCurr,34) ) ).

tff(addAssignment_56787,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,34)
    <=> v93564(VarCurr,34) ) ).

tff(addAssignment_56786,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,34)
    <=> v93565(VarCurr,34) ) ).

tff(addAssignment_56785,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,35)
    <=> v93560(VarCurr,35) ) ).

tff(addAssignment_56784,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,35)
    <=> v93562(VarCurr,35) ) ).

tff(addAssignment_56783,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,35)
    <=> v93564(VarCurr,35) ) ).

tff(addAssignment_56782,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,35)
    <=> v93565(VarCurr,35) ) ).

tff(addAssignment_56781,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,36)
    <=> v93560(VarCurr,36) ) ).

tff(addAssignment_56780,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,36)
    <=> v93562(VarCurr,36) ) ).

tff(addAssignment_56779,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,36)
    <=> v93564(VarCurr,36) ) ).

tff(addAssignment_56778,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,36)
    <=> v93565(VarCurr,36) ) ).

tff(addAssignment_56777,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,37)
    <=> v93560(VarCurr,37) ) ).

tff(addAssignment_56776,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,37)
    <=> v93562(VarCurr,37) ) ).

tff(addAssignment_56775,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,37)
    <=> v93564(VarCurr,37) ) ).

tff(addAssignment_56774,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,37)
    <=> v93565(VarCurr,37) ) ).

tff(addAssignment_56773,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,38)
    <=> v93560(VarCurr,38) ) ).

tff(addAssignment_56772,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,38)
    <=> v93562(VarCurr,38) ) ).

tff(addAssignment_56771,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,38)
    <=> v93564(VarCurr,38) ) ).

tff(addAssignment_56770,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,38)
    <=> v93565(VarCurr,38) ) ).

tff(addAssignment_56769,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,39)
    <=> v93560(VarCurr,39) ) ).

tff(addAssignment_56768,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,39)
    <=> v93562(VarCurr,39) ) ).

tff(addAssignment_56767,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,39)
    <=> v93564(VarCurr,39) ) ).

tff(addAssignment_56766,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,39)
    <=> v93565(VarCurr,39) ) ).

tff(addAssignment_56765,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,40)
    <=> v93560(VarCurr,40) ) ).

tff(addAssignment_56764,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,40)
    <=> v93562(VarCurr,40) ) ).

tff(addAssignment_56763,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,40)
    <=> v93564(VarCurr,40) ) ).

tff(addAssignment_56762,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,40)
    <=> v93565(VarCurr,40) ) ).

tff(addAssignment_56761,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,41)
    <=> v93560(VarCurr,41) ) ).

tff(addAssignment_56760,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,41)
    <=> v93562(VarCurr,41) ) ).

tff(addAssignment_56759,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,41)
    <=> v93564(VarCurr,41) ) ).

tff(addAssignment_56758,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,41)
    <=> v93565(VarCurr,41) ) ).

tff(addAssignment_56757,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,42)
    <=> v93560(VarCurr,42) ) ).

tff(addAssignment_56756,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,42)
    <=> v93562(VarCurr,42) ) ).

tff(addAssignment_56755,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,42)
    <=> v93564(VarCurr,42) ) ).

tff(addAssignment_56754,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,42)
    <=> v93565(VarCurr,42) ) ).

tff(addAssignment_56753,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,44)
    <=> v93560(VarCurr,44) ) ).

tff(addAssignment_56752,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,44)
    <=> v93562(VarCurr,44) ) ).

tff(addAssignment_56751,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,44)
    <=> v93564(VarCurr,44) ) ).

tff(addAssignment_56750,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,44)
    <=> v93565(VarCurr,44) ) ).

tff(addAssignment_56749,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,46)
    <=> v93560(VarCurr,46) ) ).

tff(addAssignment_56748,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,46)
    <=> v93562(VarCurr,46) ) ).

tff(addAssignment_56747,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,46)
    <=> v93564(VarCurr,46) ) ).

tff(addAssignment_56746,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,46)
    <=> v93565(VarCurr,46) ) ).

tff(addAssignment_56745,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,48)
    <=> v93560(VarCurr,48) ) ).

tff(addAssignment_56744,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,48)
    <=> v93562(VarCurr,48) ) ).

tff(addAssignment_56743,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,48)
    <=> v93564(VarCurr,48) ) ).

tff(addAssignment_56742,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,48)
    <=> v93565(VarCurr,48) ) ).

tff(addAssignment_56741,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,49)
    <=> v93560(VarCurr,49) ) ).

tff(addAssignment_56740,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,49)
    <=> v93562(VarCurr,49) ) ).

tff(addAssignment_56739,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,49)
    <=> v93564(VarCurr,49) ) ).

tff(addAssignment_56738,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,49)
    <=> v93565(VarCurr,49) ) ).

tff(addAssignment_56737,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,52)
    <=> v93560(VarCurr,52) ) ).

tff(addAssignment_56736,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,52)
    <=> v93562(VarCurr,52) ) ).

tff(addAssignment_56735,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,52)
    <=> v93564(VarCurr,52) ) ).

tff(addAssignment_56734,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,52)
    <=> v93565(VarCurr,52) ) ).

tff(addAssignment_56733,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,53)
    <=> v93560(VarCurr,53) ) ).

tff(addAssignment_56732,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,53)
    <=> v93562(VarCurr,53) ) ).

tff(addAssignment_56731,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,53)
    <=> v93564(VarCurr,53) ) ).

tff(addAssignment_56730,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,53)
    <=> v93565(VarCurr,53) ) ).

tff(addAssignment_56729,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,54)
    <=> v93560(VarCurr,54) ) ).

tff(addAssignment_56728,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,54)
    <=> v93562(VarCurr,54) ) ).

tff(addAssignment_56727,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,54)
    <=> v93564(VarCurr,54) ) ).

tff(addAssignment_56726,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,54)
    <=> v93565(VarCurr,54) ) ).

tff(addAssignment_56725,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,55)
    <=> v93560(VarCurr,55) ) ).

tff(addAssignment_56724,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,55)
    <=> v93562(VarCurr,55) ) ).

tff(addAssignment_56723,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,55)
    <=> v93564(VarCurr,55) ) ).

tff(addAssignment_56722,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,55)
    <=> v93565(VarCurr,55) ) ).

tff(addAssignment_56721,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,56)
    <=> v93560(VarCurr,56) ) ).

tff(addAssignment_56720,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,56)
    <=> v93562(VarCurr,56) ) ).

tff(addAssignment_56719,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,56)
    <=> v93564(VarCurr,56) ) ).

tff(addAssignment_56718,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,56)
    <=> v93565(VarCurr,56) ) ).

tff(addAssignment_56717,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,58)
    <=> v93560(VarCurr,58) ) ).

tff(addAssignment_56716,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,58)
    <=> v93562(VarCurr,58) ) ).

tff(addAssignment_56715,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,58)
    <=> v93564(VarCurr,58) ) ).

tff(addAssignment_56714,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,58)
    <=> v93565(VarCurr,58) ) ).

tff(addAssignment_56713,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,63)
    <=> v93560(VarCurr,63) ) ).

tff(addAssignment_56712,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,63)
    <=> v93562(VarCurr,63) ) ).

tff(addAssignment_56711,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,63)
    <=> v93564(VarCurr,63) ) ).

tff(addAssignment_56710,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,63)
    <=> v93565(VarCurr,63) ) ).

tff(addAssignment_56709,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,66)
    <=> v93560(VarCurr,66) ) ).

tff(addAssignment_56708,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,66)
    <=> v93562(VarCurr,66) ) ).

tff(addAssignment_56707,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,66)
    <=> v93564(VarCurr,66) ) ).

tff(addAssignment_56706,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,66)
    <=> v93565(VarCurr,66) ) ).

tff(addAssignment_56705,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,67)
    <=> v93560(VarCurr,67) ) ).

tff(addAssignment_56704,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,67)
    <=> v93562(VarCurr,67) ) ).

tff(addAssignment_56703,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,67)
    <=> v93564(VarCurr,67) ) ).

tff(addAssignment_56702,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,67)
    <=> v93565(VarCurr,67) ) ).

tff(addAssignment_56701,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,68)
    <=> v93560(VarCurr,68) ) ).

tff(addAssignment_56700,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,68)
    <=> v93562(VarCurr,68) ) ).

tff(addAssignment_56699,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,68)
    <=> v93564(VarCurr,68) ) ).

tff(addAssignment_56698,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,68)
    <=> v93565(VarCurr,68) ) ).

tff(addAssignment_56697,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,70)
    <=> v93560(VarCurr,70) ) ).

tff(addAssignment_56696,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,70)
    <=> v93562(VarCurr,70) ) ).

tff(addAssignment_56695,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,70)
    <=> v93564(VarCurr,70) ) ).

tff(addAssignment_56694,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,70)
    <=> v93565(VarCurr,70) ) ).

tff(addAssignment_56693,axiom,
    ! [VarCurr: state_type] :
      ( v93558(VarCurr,71)
    <=> v93560(VarCurr,71) ) ).

tff(addAssignment_56692,axiom,
    ! [VarCurr: state_type] :
      ( v93560(VarCurr,71)
    <=> v93562(VarCurr,71) ) ).

tff(addAssignment_56691,axiom,
    ! [VarCurr: state_type] :
      ( v93562(VarCurr,71)
    <=> v93564(VarCurr,71) ) ).

tff(addAssignment_56690,axiom,
    ! [VarCurr: state_type] :
      ( v93564(VarCurr,71)
    <=> v93565(VarCurr,71) ) ).

tff(addAssignment_56689,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,0)
    <=> v67495(VarCurr,0) ) ).

tff(addAssignment_56688,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,1)
    <=> v67495(VarCurr,6) ) ).

tff(addAssignment_56687,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,2)
    <=> v67495(VarCurr,12) ) ).

tff(addAssignment_56686,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,3)
    <=> v67495(VarCurr,18) ) ).

tff(addAssignment_56685,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,4)
    <=> v67495(VarCurr,24) ) ).

tff(addAssignment_56684,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,5)
    <=> v67495(VarCurr,30) ) ).

tff(addAssignment_56683,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,6)
    <=> v67495(VarCurr,36) ) ).

tff(addAssignment_56682,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,7)
    <=> v67495(VarCurr,42) ) ).

tff(addAssignment_56681,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,8)
    <=> v67495(VarCurr,48) ) ).

tff(addAssignment_56680,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,9)
    <=> v67495(VarCurr,54) ) ).

tff(addAssignment_56679,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,10)
    <=> v67495(VarCurr,60) ) ).

tff(addAssignment_56678,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,11)
    <=> v67495(VarCurr,66) ) ).

tff(addAssignment_56677,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,12)
    <=> v67495(VarCurr,67) ) ).

tff(addAssignment_56676,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,13)
    <=> v67495(VarCurr,61) ) ).

tff(addAssignment_56675,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,14)
    <=> v67495(VarCurr,55) ) ).

tff(addAssignment_56674,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,15)
    <=> v67495(VarCurr,49) ) ).

tff(addAssignment_56673,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,16)
    <=> v67495(VarCurr,43) ) ).

tff(addAssignment_56672,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,17)
    <=> v67495(VarCurr,37) ) ).

tff(addAssignment_56671,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,18)
    <=> v67495(VarCurr,31) ) ).

tff(addAssignment_56670,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,19)
    <=> v67495(VarCurr,25) ) ).

tff(addAssignment_56669,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,20)
    <=> v67495(VarCurr,19) ) ).

tff(addAssignment_56668,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,21)
    <=> v67495(VarCurr,13) ) ).

tff(addAssignment_56667,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,22)
    <=> v67495(VarCurr,7) ) ).

tff(addAssignment_56666,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,23)
    <=> v67495(VarCurr,1) ) ).

tff(addAssignment_56665,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,24)
    <=> v67495(VarCurr,2) ) ).

tff(addAssignment_56664,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,25)
    <=> v67495(VarCurr,8) ) ).

tff(addAssignment_56663,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,26)
    <=> v67495(VarCurr,14) ) ).

tff(addAssignment_56662,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,27)
    <=> v67495(VarCurr,20) ) ).

tff(addAssignment_56661,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,28)
    <=> v67495(VarCurr,26) ) ).

tff(addAssignment_56660,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,29)
    <=> v67495(VarCurr,32) ) ).

tff(addAssignment_56659,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,30)
    <=> v67495(VarCurr,38) ) ).

tff(addAssignment_56658,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,31)
    <=> v67495(VarCurr,44) ) ).

tff(addAssignment_56657,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,32)
    <=> v67495(VarCurr,50) ) ).

tff(addAssignment_56656,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,33)
    <=> v67495(VarCurr,56) ) ).

tff(addAssignment_56655,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,34)
    <=> v67495(VarCurr,62) ) ).

tff(addAssignment_56654,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,35)
    <=> v67495(VarCurr,68) ) ).

tff(addAssignment_56653,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,36)
    <=> v67495(VarCurr,69) ) ).

tff(addAssignment_56652,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,37)
    <=> v67495(VarCurr,63) ) ).

tff(addAssignment_56651,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,38)
    <=> v67495(VarCurr,57) ) ).

tff(addAssignment_56650,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,39)
    <=> v67495(VarCurr,51) ) ).

tff(addAssignment_56649,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,40)
    <=> v67495(VarCurr,45) ) ).

tff(addAssignment_56648,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,41)
    <=> v67495(VarCurr,39) ) ).

tff(addAssignment_56647,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,42)
    <=> v67495(VarCurr,33) ) ).

tff(addAssignment_56646,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,43)
    <=> v67495(VarCurr,27) ) ).

tff(addAssignment_56645,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,44)
    <=> v67495(VarCurr,21) ) ).

tff(addAssignment_56644,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,45)
    <=> v67495(VarCurr,15) ) ).

tff(addAssignment_56643,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,46)
    <=> v67495(VarCurr,9) ) ).

tff(addAssignment_56642,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,47)
    <=> v67495(VarCurr,3) ) ).

tff(addAssignment_56641,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,48)
    <=> v67495(VarCurr,4) ) ).

tff(addAssignment_56640,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,49)
    <=> v67495(VarCurr,10) ) ).

tff(addAssignment_56639,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,50)
    <=> v67495(VarCurr,16) ) ).

tff(addAssignment_56638,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,51)
    <=> v67495(VarCurr,22) ) ).

tff(addAssignment_56637,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,52)
    <=> v67495(VarCurr,28) ) ).

tff(addAssignment_56636,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,53)
    <=> v67495(VarCurr,34) ) ).

tff(addAssignment_56635,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,54)
    <=> v67495(VarCurr,40) ) ).

tff(addAssignment_56634,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,55)
    <=> v67495(VarCurr,46) ) ).

tff(addAssignment_56633,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,56)
    <=> v67495(VarCurr,52) ) ).

tff(addAssignment_56632,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,57)
    <=> v67495(VarCurr,58) ) ).

tff(addAssignment_56631,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,58)
    <=> v67495(VarCurr,64) ) ).

tff(addAssignment_56630,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,59)
    <=> v67495(VarCurr,70) ) ).

tff(addAssignment_56629,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,60)
    <=> v67495(VarCurr,71) ) ).

tff(addAssignment_56628,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,61)
    <=> v67495(VarCurr,65) ) ).

tff(addAssignment_56627,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,62)
    <=> v67495(VarCurr,59) ) ).

tff(addAssignment_56626,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,63)
    <=> v67495(VarCurr,53) ) ).

tff(addAssignment_56625,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,64)
    <=> v67495(VarCurr,47) ) ).

tff(addAssignment_56624,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,65)
    <=> v67495(VarCurr,41) ) ).

tff(addAssignment_56623,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,66)
    <=> v67495(VarCurr,35) ) ).

tff(addAssignment_56622,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,67)
    <=> v67495(VarCurr,29) ) ).

tff(addAssignment_56621,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,68)
    <=> v67495(VarCurr,23) ) ).

tff(addAssignment_56620,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,69)
    <=> v67495(VarCurr,17) ) ).

tff(addAssignment_56619,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,70)
    <=> v67495(VarCurr,11) ) ).

tff(addAssignment_56618,axiom,
    ! [VarCurr: state_type] :
      ( v93565(VarCurr,71)
    <=> v67495(VarCurr,5) ) ).

tff(addAssignment_56617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93485(VarCurr,B)
      <=> v93487(VarCurr,B) ) ) ).

tff(addAssignment_56616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93487(VarCurr,B)
      <=> v93489(VarCurr,B) ) ) ).

tff(addAssignment_56615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93489(VarCurr,B)
      <=> v93491(VarCurr,B) ) ) ).

tff(addAssignment_56614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93491(VarCurr,B)
      <=> v93493(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93493(VarCurr,B)
      <=> ( v93529(VarCurr,B)
          | v93532(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93532(VarCurr,B)
      <=> ( v93512(VarCurr,B)
          & v93533(VarCurr,B) ) ) ) ).

tff(addAssignment_56613,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,0)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56612,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,1)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56611,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,2)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56610,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,3)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56609,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,4)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56608,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,5)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56607,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,6)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56606,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,7)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56605,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,8)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56604,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,9)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56603,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,10)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56602,axiom,
    ! [VarCurr: state_type] :
      ( v93533(VarCurr,11)
    <=> v93534(VarCurr) ) ).

tff(addAssignment_56601,axiom,
    ! [VarCurr: state_type] :
      ( v93534(VarCurr)
    <=> v93519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93529(VarCurr,B)
      <=> ( v93495(VarCurr,B)
          & v93530(VarCurr,B) ) ) ) ).

tff(addAssignment_56600,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,0)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56599,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,1)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56598,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,2)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56597,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,3)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56596,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,4)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56595,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,5)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56594,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,6)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56593,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,7)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56592,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,8)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56591,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,9)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56590,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,10)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56589,axiom,
    ! [VarCurr: state_type] :
      ( v93530(VarCurr,11)
    <=> v93531(VarCurr) ) ).

tff(addAssignment_56588,axiom,
    ! [VarCurr: state_type] :
      ( v93531(VarCurr)
    <=> v93502(VarCurr) ) ).

tff(addAssignment_56587,axiom,
    ! [VarCurr: state_type] :
      ( v93519(VarCurr)
    <=> v93521(VarCurr) ) ).

tff(addAssignment_56586,axiom,
    ! [VarCurr: state_type] :
      ( v93521(VarCurr)
    <=> v93523(VarCurr) ) ).

tff(addAssignment_56585,axiom,
    ! [VarCurr: state_type] :
      ( v93523(VarCurr)
    <=> v93525(VarCurr) ) ).

tff(addAssignment_56584,axiom,
    ! [VarCurr: state_type] :
      ( v93525(VarCurr)
    <=> v93527(VarCurr) ) ).

tff(addAssignment_56583,axiom,
    ! [VarCurr: state_type] :
      ( v93527(VarCurr)
    <=> v92708(VarCurr) ) ).

tff(addAssignment_56582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93512(VarCurr,B)
      <=> v93514(VarCurr,B) ) ) ).

tff(addAssignment_56581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93514(VarCurr,B)
      <=> v93516(VarCurr,B) ) ) ).

tff(addAssignment_56580,axiom,
    ! [VarCurr: state_type] :
      ( ( v93516(VarCurr,5)
      <=> v52334(VarCurr,155) )
      & ( v93516(VarCurr,4)
      <=> v52334(VarCurr,154) )
      & ( v93516(VarCurr,3)
      <=> v52334(VarCurr,153) )
      & ( v93516(VarCurr,2)
      <=> v52334(VarCurr,152) )
      & ( v93516(VarCurr,1)
      <=> v52334(VarCurr,151) )
      & ( v93516(VarCurr,0)
      <=> v52334(VarCurr,150) ) ) ).

tff(addAssignment_56579,axiom,
    ! [VarCurr: state_type] :
      ( ( v93516(VarCurr,11)
      <=> $false )
      & ( v93516(VarCurr,10)
      <=> $false )
      & ( v93516(VarCurr,9)
      <=> $false )
      & ( v93516(VarCurr,8)
      <=> $false )
      & ( v93516(VarCurr,7)
      <=> $false )
      & ( v93516(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_56578,axiom,
    ! [VarCurr: state_type] :
      ( v93502(VarCurr)
    <=> v93504(VarCurr) ) ).

tff(addAssignment_56577,axiom,
    ! [VarCurr: state_type] :
      ( v93504(VarCurr)
    <=> v93506(VarCurr) ) ).

tff(addAssignment_56576,axiom,
    ! [VarCurr: state_type] :
      ( v93506(VarCurr)
    <=> v93508(VarCurr) ) ).

tff(addAssignment_56575,axiom,
    ! [VarCurr: state_type] :
      ( v93508(VarCurr)
    <=> v93510(VarCurr) ) ).

tff(addAssignment_56574,axiom,
    ! [VarCurr: state_type] :
      ( v93510(VarCurr)
    <=> v92679(VarCurr) ) ).

tff(addAssignment_56573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93495(VarCurr,B)
      <=> v93497(VarCurr,B) ) ) ).

tff(addAssignment_56572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93497(VarCurr,B)
      <=> v93499(VarCurr,B) ) ) ).

tff(addAssignment_56571,axiom,
    ! [VarCurr: state_type] :
      ( ( v93499(VarCurr,5)
      <=> v52334(VarCurr,167) )
      & ( v93499(VarCurr,4)
      <=> v52334(VarCurr,166) )
      & ( v93499(VarCurr,3)
      <=> v52334(VarCurr,165) )
      & ( v93499(VarCurr,2)
      <=> v52334(VarCurr,164) )
      & ( v93499(VarCurr,1)
      <=> v52334(VarCurr,163) )
      & ( v93499(VarCurr,0)
      <=> v52334(VarCurr,162) ) ) ).

tff(addAssignment_56570,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,6)
    <=> v52334(VarCurr,155) ) ).

tff(addAssignment_56569,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,7)
    <=> v52334(VarCurr,154) ) ).

tff(addAssignment_56568,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,8)
    <=> v52334(VarCurr,153) ) ).

tff(addAssignment_56567,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,9)
    <=> v52334(VarCurr,152) ) ).

tff(addAssignment_56566,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,10)
    <=> v52334(VarCurr,151) ) ).

tff(addAssignment_56565,axiom,
    ! [VarCurr: state_type] :
      ( v93499(VarCurr,11)
    <=> v52334(VarCurr,150) ) ).

tff(addAssignment_56564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,162) )
     => ( v52334(VarCurr,B)
      <=> v33839(VarCurr,B) ) ) ).

tff(addAssignment_56563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,162) )
     => ( v33839(VarCurr,B)
      <=> v33841(VarCurr,B) ) ) ).

tff(addAssignment_56562,axiom,
    ! [VarCurr: state_type] :
      ( ( v33841(VarCurr,167)
      <=> v29655(VarCurr,11) )
      & ( v33841(VarCurr,166)
      <=> v29655(VarCurr,10) )
      & ( v33841(VarCurr,165)
      <=> v29655(VarCurr,9) )
      & ( v33841(VarCurr,164)
      <=> v29655(VarCurr,8) )
      & ( v33841(VarCurr,163)
      <=> v29655(VarCurr,7) )
      & ( v33841(VarCurr,162)
      <=> v29655(VarCurr,6) ) ) ).

tff(addAssignment_56561,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,155)
    <=> v33839(VarCurr,155) ) ).

tff(addAssignment_56560,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,155)
    <=> v33841(VarCurr,155) ) ).

tff(addAssignment_56559,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,155)
    <=> v28105(VarCurr,11) ) ).

tff(addAssignment_56558,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,154)
    <=> v33839(VarCurr,154) ) ).

tff(addAssignment_56557,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,154)
    <=> v33841(VarCurr,154) ) ).

tff(addAssignment_56556,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,154)
    <=> v28105(VarCurr,10) ) ).

tff(addAssignment_56555,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,153)
    <=> v33839(VarCurr,153) ) ).

tff(addAssignment_56554,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,153)
    <=> v33841(VarCurr,153) ) ).

tff(addAssignment_56553,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,153)
    <=> v28105(VarCurr,9) ) ).

tff(addAssignment_56552,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,152)
    <=> v33839(VarCurr,152) ) ).

tff(addAssignment_56551,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,152)
    <=> v33841(VarCurr,152) ) ).

tff(addAssignment_56550,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,152)
    <=> v28105(VarCurr,8) ) ).

tff(addAssignment_56549,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,151)
    <=> v33839(VarCurr,151) ) ).

tff(addAssignment_56548,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,151)
    <=> v33841(VarCurr,151) ) ).

tff(addAssignment_56547,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,151)
    <=> v28105(VarCurr,7) ) ).

tff(addAssignment_56546,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,150)
    <=> v33839(VarCurr,150) ) ).

tff(addAssignment_56545,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,150)
    <=> v33841(VarCurr,150) ) ).

tff(addAssignment_56544,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,150)
    <=> v28105(VarCurr,6) ) ).

tff(addAssignment_56543,axiom,
    ! [VarCurr: state_type] :
      ( v92642(VarCurr)
    <=> v92644(VarCurr) ) ).

tff(addAssignment_56542,axiom,
    ! [VarCurr: state_type] :
      ( v92644(VarCurr)
    <=> v92646(VarCurr) ) ).

tff(addAssignment_56541,axiom,
    ! [VarCurr: state_type] :
      ( v92646(VarCurr)
    <=> v92648(VarCurr) ) ).

tff(addAssignment_56540,axiom,
    ! [VarCurr: state_type] :
      ( v92648(VarCurr)
    <=> v92650(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_488,axiom,
    ! [VarCurr: state_type] :
      ( v92650(VarCurr)
    <=> ( ( v92652(VarCurr,11)
        <=> v92719(VarCurr,11) )
        & ( v92652(VarCurr,10)
        <=> v92719(VarCurr,10) )
        & ( v92652(VarCurr,9)
        <=> v92719(VarCurr,9) )
        & ( v92652(VarCurr,8)
        <=> v92719(VarCurr,8) )
        & ( v92652(VarCurr,7)
        <=> v92719(VarCurr,7) )
        & ( v92652(VarCurr,6)
        <=> v92719(VarCurr,6) )
        & ( v92652(VarCurr,5)
        <=> v92719(VarCurr,5) )
        & ( v92652(VarCurr,4)
        <=> v92719(VarCurr,4) )
        & ( v92652(VarCurr,3)
        <=> v92719(VarCurr,3) )
        & ( v92652(VarCurr,2)
        <=> v92719(VarCurr,2) )
        & ( v92652(VarCurr,1)
        <=> v92719(VarCurr,1) )
        & ( v92652(VarCurr,0)
        <=> v92719(VarCurr,0) ) ) ) ).

tff(addAssignment_56539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92719(VarCurr,B)
      <=> v92721(VarCurr,B) ) ) ).

tff(addAssignment_56538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92721(VarCurr,B)
      <=> v92723(VarCurr,B) ) ) ).

tff(addAssignment_56537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92723(VarCurr,B)
      <=> v92725(VarCurr,B) ) ) ).

tff(addAssignment_56536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92725(VarCurr,B)
      <=> v92727(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92727(VarCurr,B)
      <=> ( v93467(VarCurr,B)
          | v93470(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93470(VarCurr,B)
      <=> ( v93224(VarCurr,B)
          & v93471(VarCurr,B) ) ) ) ).

tff(addAssignment_56535,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,0)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56534,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,1)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56533,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,2)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56532,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,3)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56531,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,4)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56530,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,5)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56529,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,6)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56528,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,7)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56527,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,8)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56526,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,9)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56525,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,10)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56524,axiom,
    ! [VarCurr: state_type] :
      ( v93471(VarCurr,11)
    <=> v93472(VarCurr) ) ).

tff(addAssignment_56523,axiom,
    ! [VarCurr: state_type] :
      ( v93472(VarCurr)
    <=> v93457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93467(VarCurr,B)
      <=> ( v92729(VarCurr,B)
          & v93468(VarCurr,B) ) ) ) ).

tff(addAssignment_56522,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,0)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56521,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,1)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56520,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,2)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56519,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,3)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56518,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,4)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56517,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,5)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56516,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,6)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56515,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,7)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56514,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,8)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56513,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,9)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56512,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,10)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56511,axiom,
    ! [VarCurr: state_type] :
      ( v93468(VarCurr,11)
    <=> v93469(VarCurr) ) ).

tff(addAssignment_56510,axiom,
    ! [VarCurr: state_type] :
      ( v93469(VarCurr)
    <=> v93214(VarCurr) ) ).

tff(addAssignment_56509,axiom,
    ! [VarCurr: state_type] :
      ( v93457(VarCurr)
    <=> v93459(VarCurr) ) ).

tff(addAssignment_56508,axiom,
    ! [VarCurr: state_type] :
      ( v93459(VarCurr)
    <=> v93461(VarCurr) ) ).

tff(addAssignment_56507,axiom,
    ! [VarCurr: state_type] :
      ( v93461(VarCurr)
    <=> v93463(VarCurr) ) ).

tff(addAssignment_56506,axiom,
    ! [VarCurr: state_type] :
      ( v93463(VarCurr)
    <=> v93465(VarCurr) ) ).

tff(addAssignment_56505,axiom,
    ! [VarCurr: state_type] :
      ( v93465(VarCurr)
    <=> v92708(VarCurr) ) ).

tff(addAssignment_56504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v93224(VarCurr,B)
      <=> v93226(VarCurr,B) ) ) ).

tff(addAssignment_56503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v93226(VarCurr,B)
      <=> v93228(VarCurr,B) ) ) ).

tff(addAssignment_56502,axiom,
    ! [VarCurr: state_type] :
      ( ( v93226(VarCurr,11)
      <=> $false )
      & ( v93226(VarCurr,10)
      <=> $false )
      & ( v93226(VarCurr,9)
      <=> $false )
      & ( v93226(VarCurr,8)
      <=> $false )
      & ( v93226(VarCurr,7)
      <=> $false )
      & ( v93226(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_56501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v93228(VarCurr,B)
      <=> v93230(VarCurr,B) ) ) ).

tff(addAssignment_56500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v93230(VarCurr,B)
      <=> v93232(VarCurr,B) ) ) ).

tff(addAssignment_56499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v93232(VarCurr,B)
      <=> v93234(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2971,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,5)
    <=> ( v93420(VarCurr)
      <~> v93236(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2970,axiom,
    ! [VarCurr: state_type] :
      ( v93420(VarCurr)
    <=> ( v93421(VarCurr)
      <~> v93236(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2969,axiom,
    ! [VarCurr: state_type] :
      ( v93421(VarCurr)
    <=> ( v93422(VarCurr)
      <~> v93236(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2968,axiom,
    ! [VarCurr: state_type] :
      ( v93422(VarCurr)
    <=> ( v93423(VarCurr)
      <~> v93236(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2967,axiom,
    ! [VarCurr: state_type] :
      ( v93423(VarCurr)
    <=> ( v93424(VarCurr)
      <~> v93236(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2966,axiom,
    ! [VarCurr: state_type] :
      ( v93424(VarCurr)
    <=> ( v93425(VarCurr)
      <~> v93236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2965,axiom,
    ! [VarCurr: state_type] :
      ( v93425(VarCurr)
    <=> ( v93426(VarCurr)
      <~> v93236(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2964,axiom,
    ! [VarCurr: state_type] :
      ( v93426(VarCurr)
    <=> ( v93427(VarCurr)
      <~> v93236(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2963,axiom,
    ! [VarCurr: state_type] :
      ( v93427(VarCurr)
    <=> ( v93428(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2962,axiom,
    ! [VarCurr: state_type] :
      ( v93428(VarCurr)
    <=> ( v93429(VarCurr)
      <~> v93236(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2961,axiom,
    ! [VarCurr: state_type] :
      ( v93429(VarCurr)
    <=> ( v93430(VarCurr)
      <~> v93236(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2960,axiom,
    ! [VarCurr: state_type] :
      ( v93430(VarCurr)
    <=> ( v93431(VarCurr)
      <~> v93236(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2959,axiom,
    ! [VarCurr: state_type] :
      ( v93431(VarCurr)
    <=> ( v93432(VarCurr)
      <~> v93236(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2958,axiom,
    ! [VarCurr: state_type] :
      ( v93432(VarCurr)
    <=> ( v93433(VarCurr)
      <~> v93236(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2957,axiom,
    ! [VarCurr: state_type] :
      ( v93433(VarCurr)
    <=> ( v93434(VarCurr)
      <~> v93236(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2956,axiom,
    ! [VarCurr: state_type] :
      ( v93434(VarCurr)
    <=> ( v93435(VarCurr)
      <~> v93236(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2955,axiom,
    ! [VarCurr: state_type] :
      ( v93435(VarCurr)
    <=> ( v93436(VarCurr)
      <~> v93236(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2954,axiom,
    ! [VarCurr: state_type] :
      ( v93436(VarCurr)
    <=> ( v93437(VarCurr)
      <~> v93236(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2953,axiom,
    ! [VarCurr: state_type] :
      ( v93437(VarCurr)
    <=> ( v93438(VarCurr)
      <~> v93236(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2952,axiom,
    ! [VarCurr: state_type] :
      ( v93438(VarCurr)
    <=> ( v93439(VarCurr)
      <~> v93236(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2951,axiom,
    ! [VarCurr: state_type] :
      ( v93439(VarCurr)
    <=> ( v93440(VarCurr)
      <~> v93236(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2950,axiom,
    ! [VarCurr: state_type] :
      ( v93440(VarCurr)
    <=> ( v93441(VarCurr)
      <~> v93236(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2949,axiom,
    ! [VarCurr: state_type] :
      ( v93441(VarCurr)
    <=> ( v93442(VarCurr)
      <~> v93236(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2948,axiom,
    ! [VarCurr: state_type] :
      ( v93442(VarCurr)
    <=> ( v93443(VarCurr)
      <~> v93236(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2947,axiom,
    ! [VarCurr: state_type] :
      ( v93443(VarCurr)
    <=> ( v93444(VarCurr)
      <~> v93236(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2946,axiom,
    ! [VarCurr: state_type] :
      ( v93444(VarCurr)
    <=> ( v93445(VarCurr)
      <~> v93236(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2945,axiom,
    ! [VarCurr: state_type] :
      ( v93445(VarCurr)
    <=> ( v93446(VarCurr)
      <~> v93236(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2944,axiom,
    ! [VarCurr: state_type] :
      ( v93446(VarCurr)
    <=> ( v93447(VarCurr)
      <~> v93236(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2943,axiom,
    ! [VarCurr: state_type] :
      ( v93447(VarCurr)
    <=> ( v93448(VarCurr)
      <~> v93236(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2942,axiom,
    ! [VarCurr: state_type] :
      ( v93448(VarCurr)
    <=> ( v93449(VarCurr)
      <~> v93236(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2941,axiom,
    ! [VarCurr: state_type] :
      ( v93449(VarCurr)
    <=> ( v93450(VarCurr)
      <~> v93236(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2940,axiom,
    ! [VarCurr: state_type] :
      ( v93450(VarCurr)
    <=> ( v93451(VarCurr)
      <~> v93236(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2939,axiom,
    ! [VarCurr: state_type] :
      ( v93451(VarCurr)
    <=> ( v93452(VarCurr)
      <~> v93236(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2938,axiom,
    ! [VarCurr: state_type] :
      ( v93452(VarCurr)
    <=> ( v93453(VarCurr)
      <~> v93236(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2937,axiom,
    ! [VarCurr: state_type] :
      ( v93453(VarCurr)
    <=> ( v93454(VarCurr)
      <~> v93236(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2936,axiom,
    ! [VarCurr: state_type] :
      ( v93454(VarCurr)
    <=> ( v93236(VarCurr,71)
      <~> v93236(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2935,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,4)
    <=> ( v93384(VarCurr)
      <~> v93236(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2934,axiom,
    ! [VarCurr: state_type] :
      ( v93384(VarCurr)
    <=> ( v93385(VarCurr)
      <~> v93236(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2933,axiom,
    ! [VarCurr: state_type] :
      ( v93385(VarCurr)
    <=> ( v93386(VarCurr)
      <~> v93236(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2932,axiom,
    ! [VarCurr: state_type] :
      ( v93386(VarCurr)
    <=> ( v93387(VarCurr)
      <~> v93236(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2931,axiom,
    ! [VarCurr: state_type] :
      ( v93387(VarCurr)
    <=> ( v93388(VarCurr)
      <~> v93236(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2930,axiom,
    ! [VarCurr: state_type] :
      ( v93388(VarCurr)
    <=> ( v93389(VarCurr)
      <~> v93236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2929,axiom,
    ! [VarCurr: state_type] :
      ( v93389(VarCurr)
    <=> ( v93390(VarCurr)
      <~> v93236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2928,axiom,
    ! [VarCurr: state_type] :
      ( v93390(VarCurr)
    <=> ( v93391(VarCurr)
      <~> v93236(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2927,axiom,
    ! [VarCurr: state_type] :
      ( v93391(VarCurr)
    <=> ( v93392(VarCurr)
      <~> v93236(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2926,axiom,
    ! [VarCurr: state_type] :
      ( v93392(VarCurr)
    <=> ( v93393(VarCurr)
      <~> v93236(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2925,axiom,
    ! [VarCurr: state_type] :
      ( v93393(VarCurr)
    <=> ( v93394(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2924,axiom,
    ! [VarCurr: state_type] :
      ( v93394(VarCurr)
    <=> ( v93395(VarCurr)
      <~> v93236(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2923,axiom,
    ! [VarCurr: state_type] :
      ( v93395(VarCurr)
    <=> ( v93396(VarCurr)
      <~> v93236(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2922,axiom,
    ! [VarCurr: state_type] :
      ( v93396(VarCurr)
    <=> ( v93397(VarCurr)
      <~> v93236(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2921,axiom,
    ! [VarCurr: state_type] :
      ( v93397(VarCurr)
    <=> ( v93398(VarCurr)
      <~> v93236(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2920,axiom,
    ! [VarCurr: state_type] :
      ( v93398(VarCurr)
    <=> ( v93399(VarCurr)
      <~> v93236(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2919,axiom,
    ! [VarCurr: state_type] :
      ( v93399(VarCurr)
    <=> ( v93400(VarCurr)
      <~> v93236(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2918,axiom,
    ! [VarCurr: state_type] :
      ( v93400(VarCurr)
    <=> ( v93401(VarCurr)
      <~> v93236(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2917,axiom,
    ! [VarCurr: state_type] :
      ( v93401(VarCurr)
    <=> ( v93402(VarCurr)
      <~> v93236(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2916,axiom,
    ! [VarCurr: state_type] :
      ( v93402(VarCurr)
    <=> ( v93403(VarCurr)
      <~> v93236(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2915,axiom,
    ! [VarCurr: state_type] :
      ( v93403(VarCurr)
    <=> ( v93404(VarCurr)
      <~> v93236(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2914,axiom,
    ! [VarCurr: state_type] :
      ( v93404(VarCurr)
    <=> ( v93405(VarCurr)
      <~> v93236(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2913,axiom,
    ! [VarCurr: state_type] :
      ( v93405(VarCurr)
    <=> ( v93406(VarCurr)
      <~> v93236(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2912,axiom,
    ! [VarCurr: state_type] :
      ( v93406(VarCurr)
    <=> ( v93407(VarCurr)
      <~> v93236(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2911,axiom,
    ! [VarCurr: state_type] :
      ( v93407(VarCurr)
    <=> ( v93408(VarCurr)
      <~> v93236(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2910,axiom,
    ! [VarCurr: state_type] :
      ( v93408(VarCurr)
    <=> ( v93409(VarCurr)
      <~> v93236(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2909,axiom,
    ! [VarCurr: state_type] :
      ( v93409(VarCurr)
    <=> ( v93410(VarCurr)
      <~> v93236(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2908,axiom,
    ! [VarCurr: state_type] :
      ( v93410(VarCurr)
    <=> ( v93411(VarCurr)
      <~> v93236(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2907,axiom,
    ! [VarCurr: state_type] :
      ( v93411(VarCurr)
    <=> ( v93412(VarCurr)
      <~> v93236(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2906,axiom,
    ! [VarCurr: state_type] :
      ( v93412(VarCurr)
    <=> ( v93413(VarCurr)
      <~> v93236(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2905,axiom,
    ! [VarCurr: state_type] :
      ( v93413(VarCurr)
    <=> ( v93414(VarCurr)
      <~> v93236(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2904,axiom,
    ! [VarCurr: state_type] :
      ( v93414(VarCurr)
    <=> ( v93415(VarCurr)
      <~> v93236(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2903,axiom,
    ! [VarCurr: state_type] :
      ( v93415(VarCurr)
    <=> ( v93416(VarCurr)
      <~> v93236(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2902,axiom,
    ! [VarCurr: state_type] :
      ( v93416(VarCurr)
    <=> ( v93417(VarCurr)
      <~> v93236(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2901,axiom,
    ! [VarCurr: state_type] :
      ( v93417(VarCurr)
    <=> ( v93418(VarCurr)
      <~> v93236(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2900,axiom,
    ! [VarCurr: state_type] :
      ( v93418(VarCurr)
    <=> ( v93236(VarCurr,71)
      <~> v93236(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2899,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,3)
    <=> ( v93347(VarCurr)
      <~> v93236(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2898,axiom,
    ! [VarCurr: state_type] :
      ( v93347(VarCurr)
    <=> ( v93348(VarCurr)
      <~> v93236(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2897,axiom,
    ! [VarCurr: state_type] :
      ( v93348(VarCurr)
    <=> ( v93349(VarCurr)
      <~> v93236(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2896,axiom,
    ! [VarCurr: state_type] :
      ( v93349(VarCurr)
    <=> ( v93350(VarCurr)
      <~> v93236(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2895,axiom,
    ! [VarCurr: state_type] :
      ( v93350(VarCurr)
    <=> ( v93351(VarCurr)
      <~> v93236(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2894,axiom,
    ! [VarCurr: state_type] :
      ( v93351(VarCurr)
    <=> ( v93352(VarCurr)
      <~> v93236(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2893,axiom,
    ! [VarCurr: state_type] :
      ( v93352(VarCurr)
    <=> ( v93353(VarCurr)
      <~> v93236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2892,axiom,
    ! [VarCurr: state_type] :
      ( v93353(VarCurr)
    <=> ( v93354(VarCurr)
      <~> v93236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2891,axiom,
    ! [VarCurr: state_type] :
      ( v93354(VarCurr)
    <=> ( v93355(VarCurr)
      <~> v93236(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2890,axiom,
    ! [VarCurr: state_type] :
      ( v93355(VarCurr)
    <=> ( v93356(VarCurr)
      <~> v93236(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2889,axiom,
    ! [VarCurr: state_type] :
      ( v93356(VarCurr)
    <=> ( v93357(VarCurr)
      <~> v93236(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2888,axiom,
    ! [VarCurr: state_type] :
      ( v93357(VarCurr)
    <=> ( v93358(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2887,axiom,
    ! [VarCurr: state_type] :
      ( v93358(VarCurr)
    <=> ( v93359(VarCurr)
      <~> v93236(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2886,axiom,
    ! [VarCurr: state_type] :
      ( v93359(VarCurr)
    <=> ( v93360(VarCurr)
      <~> v93236(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2885,axiom,
    ! [VarCurr: state_type] :
      ( v93360(VarCurr)
    <=> ( v93361(VarCurr)
      <~> v93236(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2884,axiom,
    ! [VarCurr: state_type] :
      ( v93361(VarCurr)
    <=> ( v93362(VarCurr)
      <~> v93236(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2883,axiom,
    ! [VarCurr: state_type] :
      ( v93362(VarCurr)
    <=> ( v93363(VarCurr)
      <~> v93236(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2882,axiom,
    ! [VarCurr: state_type] :
      ( v93363(VarCurr)
    <=> ( v93364(VarCurr)
      <~> v93236(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2881,axiom,
    ! [VarCurr: state_type] :
      ( v93364(VarCurr)
    <=> ( v93365(VarCurr)
      <~> v93236(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2880,axiom,
    ! [VarCurr: state_type] :
      ( v93365(VarCurr)
    <=> ( v93366(VarCurr)
      <~> v93236(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2879,axiom,
    ! [VarCurr: state_type] :
      ( v93366(VarCurr)
    <=> ( v93367(VarCurr)
      <~> v93236(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2878,axiom,
    ! [VarCurr: state_type] :
      ( v93367(VarCurr)
    <=> ( v93368(VarCurr)
      <~> v93236(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2877,axiom,
    ! [VarCurr: state_type] :
      ( v93368(VarCurr)
    <=> ( v93369(VarCurr)
      <~> v93236(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2876,axiom,
    ! [VarCurr: state_type] :
      ( v93369(VarCurr)
    <=> ( v93370(VarCurr)
      <~> v93236(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2875,axiom,
    ! [VarCurr: state_type] :
      ( v93370(VarCurr)
    <=> ( v93371(VarCurr)
      <~> v93236(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2874,axiom,
    ! [VarCurr: state_type] :
      ( v93371(VarCurr)
    <=> ( v93372(VarCurr)
      <~> v93236(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2873,axiom,
    ! [VarCurr: state_type] :
      ( v93372(VarCurr)
    <=> ( v93373(VarCurr)
      <~> v93236(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2872,axiom,
    ! [VarCurr: state_type] :
      ( v93373(VarCurr)
    <=> ( v93374(VarCurr)
      <~> v93236(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2871,axiom,
    ! [VarCurr: state_type] :
      ( v93374(VarCurr)
    <=> ( v93375(VarCurr)
      <~> v93236(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2870,axiom,
    ! [VarCurr: state_type] :
      ( v93375(VarCurr)
    <=> ( v93376(VarCurr)
      <~> v93236(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2869,axiom,
    ! [VarCurr: state_type] :
      ( v93376(VarCurr)
    <=> ( v93377(VarCurr)
      <~> v93236(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2868,axiom,
    ! [VarCurr: state_type] :
      ( v93377(VarCurr)
    <=> ( v93378(VarCurr)
      <~> v93236(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2867,axiom,
    ! [VarCurr: state_type] :
      ( v93378(VarCurr)
    <=> ( v93379(VarCurr)
      <~> v93236(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2866,axiom,
    ! [VarCurr: state_type] :
      ( v93379(VarCurr)
    <=> ( v93380(VarCurr)
      <~> v93236(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2865,axiom,
    ! [VarCurr: state_type] :
      ( v93380(VarCurr)
    <=> ( v93381(VarCurr)
      <~> v93236(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2864,axiom,
    ! [VarCurr: state_type] :
      ( v93381(VarCurr)
    <=> ( v93382(VarCurr)
      <~> v93236(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2863,axiom,
    ! [VarCurr: state_type] :
      ( v93382(VarCurr)
    <=> ( v93236(VarCurr,71)
      <~> v93236(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2862,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,2)
    <=> ( v93309(VarCurr)
      <~> v93236(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2861,axiom,
    ! [VarCurr: state_type] :
      ( v93309(VarCurr)
    <=> ( v93310(VarCurr)
      <~> v93236(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2860,axiom,
    ! [VarCurr: state_type] :
      ( v93310(VarCurr)
    <=> ( v93311(VarCurr)
      <~> v93236(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2859,axiom,
    ! [VarCurr: state_type] :
      ( v93311(VarCurr)
    <=> ( v93312(VarCurr)
      <~> v93236(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2858,axiom,
    ! [VarCurr: state_type] :
      ( v93312(VarCurr)
    <=> ( v93313(VarCurr)
      <~> v93236(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2857,axiom,
    ! [VarCurr: state_type] :
      ( v93313(VarCurr)
    <=> ( v93314(VarCurr)
      <~> v93236(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2856,axiom,
    ! [VarCurr: state_type] :
      ( v93314(VarCurr)
    <=> ( v93315(VarCurr)
      <~> v93236(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2855,axiom,
    ! [VarCurr: state_type] :
      ( v93315(VarCurr)
    <=> ( v93316(VarCurr)
      <~> v93236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2854,axiom,
    ! [VarCurr: state_type] :
      ( v93316(VarCurr)
    <=> ( v93317(VarCurr)
      <~> v93236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2853,axiom,
    ! [VarCurr: state_type] :
      ( v93317(VarCurr)
    <=> ( v93318(VarCurr)
      <~> v93236(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2852,axiom,
    ! [VarCurr: state_type] :
      ( v93318(VarCurr)
    <=> ( v93319(VarCurr)
      <~> v93236(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2851,axiom,
    ! [VarCurr: state_type] :
      ( v93319(VarCurr)
    <=> ( v93320(VarCurr)
      <~> v93236(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2850,axiom,
    ! [VarCurr: state_type] :
      ( v93320(VarCurr)
    <=> ( v93321(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2849,axiom,
    ! [VarCurr: state_type] :
      ( v93321(VarCurr)
    <=> ( v93322(VarCurr)
      <~> v93236(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2848,axiom,
    ! [VarCurr: state_type] :
      ( v93322(VarCurr)
    <=> ( v93323(VarCurr)
      <~> v93236(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2847,axiom,
    ! [VarCurr: state_type] :
      ( v93323(VarCurr)
    <=> ( v93324(VarCurr)
      <~> v93236(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2846,axiom,
    ! [VarCurr: state_type] :
      ( v93324(VarCurr)
    <=> ( v93325(VarCurr)
      <~> v93236(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2845,axiom,
    ! [VarCurr: state_type] :
      ( v93325(VarCurr)
    <=> ( v93326(VarCurr)
      <~> v93236(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2844,axiom,
    ! [VarCurr: state_type] :
      ( v93326(VarCurr)
    <=> ( v93327(VarCurr)
      <~> v93236(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2843,axiom,
    ! [VarCurr: state_type] :
      ( v93327(VarCurr)
    <=> ( v93328(VarCurr)
      <~> v93236(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2842,axiom,
    ! [VarCurr: state_type] :
      ( v93328(VarCurr)
    <=> ( v93329(VarCurr)
      <~> v93236(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2841,axiom,
    ! [VarCurr: state_type] :
      ( v93329(VarCurr)
    <=> ( v93330(VarCurr)
      <~> v93236(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2840,axiom,
    ! [VarCurr: state_type] :
      ( v93330(VarCurr)
    <=> ( v93331(VarCurr)
      <~> v93236(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2839,axiom,
    ! [VarCurr: state_type] :
      ( v93331(VarCurr)
    <=> ( v93332(VarCurr)
      <~> v93236(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2838,axiom,
    ! [VarCurr: state_type] :
      ( v93332(VarCurr)
    <=> ( v93333(VarCurr)
      <~> v93236(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2837,axiom,
    ! [VarCurr: state_type] :
      ( v93333(VarCurr)
    <=> ( v93334(VarCurr)
      <~> v93236(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2836,axiom,
    ! [VarCurr: state_type] :
      ( v93334(VarCurr)
    <=> ( v93335(VarCurr)
      <~> v93236(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2835,axiom,
    ! [VarCurr: state_type] :
      ( v93335(VarCurr)
    <=> ( v93336(VarCurr)
      <~> v93236(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2834,axiom,
    ! [VarCurr: state_type] :
      ( v93336(VarCurr)
    <=> ( v93337(VarCurr)
      <~> v93236(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2833,axiom,
    ! [VarCurr: state_type] :
      ( v93337(VarCurr)
    <=> ( v93338(VarCurr)
      <~> v93236(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2832,axiom,
    ! [VarCurr: state_type] :
      ( v93338(VarCurr)
    <=> ( v93339(VarCurr)
      <~> v93236(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2831,axiom,
    ! [VarCurr: state_type] :
      ( v93339(VarCurr)
    <=> ( v93340(VarCurr)
      <~> v93236(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2830,axiom,
    ! [VarCurr: state_type] :
      ( v93340(VarCurr)
    <=> ( v93341(VarCurr)
      <~> v93236(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2829,axiom,
    ! [VarCurr: state_type] :
      ( v93341(VarCurr)
    <=> ( v93342(VarCurr)
      <~> v93236(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2828,axiom,
    ! [VarCurr: state_type] :
      ( v93342(VarCurr)
    <=> ( v93343(VarCurr)
      <~> v93236(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2827,axiom,
    ! [VarCurr: state_type] :
      ( v93343(VarCurr)
    <=> ( v93344(VarCurr)
      <~> v93236(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2826,axiom,
    ! [VarCurr: state_type] :
      ( v93344(VarCurr)
    <=> ( v93345(VarCurr)
      <~> v93236(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2825,axiom,
    ! [VarCurr: state_type] :
      ( v93345(VarCurr)
    <=> ( v93236(VarCurr,71)
      <~> v93236(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2824,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,1)
    <=> ( v93274(VarCurr)
      <~> v93236(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2823,axiom,
    ! [VarCurr: state_type] :
      ( v93274(VarCurr)
    <=> ( v93275(VarCurr)
      <~> v93236(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2822,axiom,
    ! [VarCurr: state_type] :
      ( v93275(VarCurr)
    <=> ( v93276(VarCurr)
      <~> v93236(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2821,axiom,
    ! [VarCurr: state_type] :
      ( v93276(VarCurr)
    <=> ( v93277(VarCurr)
      <~> v93236(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2820,axiom,
    ! [VarCurr: state_type] :
      ( v93277(VarCurr)
    <=> ( v93278(VarCurr)
      <~> v93236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2819,axiom,
    ! [VarCurr: state_type] :
      ( v93278(VarCurr)
    <=> ( v93279(VarCurr)
      <~> v93236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2818,axiom,
    ! [VarCurr: state_type] :
      ( v93279(VarCurr)
    <=> ( v93280(VarCurr)
      <~> v93236(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2817,axiom,
    ! [VarCurr: state_type] :
      ( v93280(VarCurr)
    <=> ( v93281(VarCurr)
      <~> v93236(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2816,axiom,
    ! [VarCurr: state_type] :
      ( v93281(VarCurr)
    <=> ( v93282(VarCurr)
      <~> v93236(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2815,axiom,
    ! [VarCurr: state_type] :
      ( v93282(VarCurr)
    <=> ( v93283(VarCurr)
      <~> v93236(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2814,axiom,
    ! [VarCurr: state_type] :
      ( v93283(VarCurr)
    <=> ( v93284(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2813,axiom,
    ! [VarCurr: state_type] :
      ( v93284(VarCurr)
    <=> ( v93285(VarCurr)
      <~> v93236(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2812,axiom,
    ! [VarCurr: state_type] :
      ( v93285(VarCurr)
    <=> ( v93286(VarCurr)
      <~> v93236(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2811,axiom,
    ! [VarCurr: state_type] :
      ( v93286(VarCurr)
    <=> ( v93287(VarCurr)
      <~> v93236(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2810,axiom,
    ! [VarCurr: state_type] :
      ( v93287(VarCurr)
    <=> ( v93288(VarCurr)
      <~> v93236(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2809,axiom,
    ! [VarCurr: state_type] :
      ( v93288(VarCurr)
    <=> ( v93289(VarCurr)
      <~> v93236(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2808,axiom,
    ! [VarCurr: state_type] :
      ( v93289(VarCurr)
    <=> ( v93290(VarCurr)
      <~> v93236(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2807,axiom,
    ! [VarCurr: state_type] :
      ( v93290(VarCurr)
    <=> ( v93291(VarCurr)
      <~> v93236(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2806,axiom,
    ! [VarCurr: state_type] :
      ( v93291(VarCurr)
    <=> ( v93292(VarCurr)
      <~> v93236(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2805,axiom,
    ! [VarCurr: state_type] :
      ( v93292(VarCurr)
    <=> ( v93293(VarCurr)
      <~> v93236(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2804,axiom,
    ! [VarCurr: state_type] :
      ( v93293(VarCurr)
    <=> ( v93294(VarCurr)
      <~> v93236(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2803,axiom,
    ! [VarCurr: state_type] :
      ( v93294(VarCurr)
    <=> ( v93295(VarCurr)
      <~> v93236(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2802,axiom,
    ! [VarCurr: state_type] :
      ( v93295(VarCurr)
    <=> ( v93296(VarCurr)
      <~> v93236(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2801,axiom,
    ! [VarCurr: state_type] :
      ( v93296(VarCurr)
    <=> ( v93297(VarCurr)
      <~> v93236(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2800,axiom,
    ! [VarCurr: state_type] :
      ( v93297(VarCurr)
    <=> ( v93298(VarCurr)
      <~> v93236(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2799,axiom,
    ! [VarCurr: state_type] :
      ( v93298(VarCurr)
    <=> ( v93299(VarCurr)
      <~> v93236(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2798,axiom,
    ! [VarCurr: state_type] :
      ( v93299(VarCurr)
    <=> ( v93300(VarCurr)
      <~> v93236(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2797,axiom,
    ! [VarCurr: state_type] :
      ( v93300(VarCurr)
    <=> ( v93301(VarCurr)
      <~> v93236(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2796,axiom,
    ! [VarCurr: state_type] :
      ( v93301(VarCurr)
    <=> ( v93302(VarCurr)
      <~> v93236(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2795,axiom,
    ! [VarCurr: state_type] :
      ( v93302(VarCurr)
    <=> ( v93303(VarCurr)
      <~> v93236(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2794,axiom,
    ! [VarCurr: state_type] :
      ( v93303(VarCurr)
    <=> ( v93304(VarCurr)
      <~> v93236(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2793,axiom,
    ! [VarCurr: state_type] :
      ( v93304(VarCurr)
    <=> ( v93305(VarCurr)
      <~> v93236(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2792,axiom,
    ! [VarCurr: state_type] :
      ( v93305(VarCurr)
    <=> ( v93306(VarCurr)
      <~> v93236(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2791,axiom,
    ! [VarCurr: state_type] :
      ( v93306(VarCurr)
    <=> ( v93307(VarCurr)
      <~> v93236(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2790,axiom,
    ! [VarCurr: state_type] :
      ( v93307(VarCurr)
    <=> ( v93236(VarCurr,70)
      <~> v93236(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8664,axiom,
    ! [VarCurr: state_type] :
      ( v93234(VarCurr,0)
    <=> ( v93238(VarCurr)
      <~> v93236(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2789,axiom,
    ! [VarCurr: state_type] :
      ( v93238(VarCurr)
    <=> ( v93239(VarCurr)
      <~> v93236(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2788,axiom,
    ! [VarCurr: state_type] :
      ( v93239(VarCurr)
    <=> ( v93240(VarCurr)
      <~> v93236(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2787,axiom,
    ! [VarCurr: state_type] :
      ( v93240(VarCurr)
    <=> ( v93241(VarCurr)
      <~> v93236(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2786,axiom,
    ! [VarCurr: state_type] :
      ( v93241(VarCurr)
    <=> ( v93242(VarCurr)
      <~> v93236(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2785,axiom,
    ! [VarCurr: state_type] :
      ( v93242(VarCurr)
    <=> ( v93243(VarCurr)
      <~> v93236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2784,axiom,
    ! [VarCurr: state_type] :
      ( v93243(VarCurr)
    <=> ( v93244(VarCurr)
      <~> v93236(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2783,axiom,
    ! [VarCurr: state_type] :
      ( v93244(VarCurr)
    <=> ( v93245(VarCurr)
      <~> v93236(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2782,axiom,
    ! [VarCurr: state_type] :
      ( v93245(VarCurr)
    <=> ( v93246(VarCurr)
      <~> v93236(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2781,axiom,
    ! [VarCurr: state_type] :
      ( v93246(VarCurr)
    <=> ( v93247(VarCurr)
      <~> v93236(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2780,axiom,
    ! [VarCurr: state_type] :
      ( v93247(VarCurr)
    <=> ( v93248(VarCurr)
      <~> v93236(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2779,axiom,
    ! [VarCurr: state_type] :
      ( v93248(VarCurr)
    <=> ( v93249(VarCurr)
      <~> v93236(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2778,axiom,
    ! [VarCurr: state_type] :
      ( v93249(VarCurr)
    <=> ( v93250(VarCurr)
      <~> v93236(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2777,axiom,
    ! [VarCurr: state_type] :
      ( v93250(VarCurr)
    <=> ( v93251(VarCurr)
      <~> v93236(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2776,axiom,
    ! [VarCurr: state_type] :
      ( v93251(VarCurr)
    <=> ( v93252(VarCurr)
      <~> v93236(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2775,axiom,
    ! [VarCurr: state_type] :
      ( v93252(VarCurr)
    <=> ( v93253(VarCurr)
      <~> v93236(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2774,axiom,
    ! [VarCurr: state_type] :
      ( v93253(VarCurr)
    <=> ( v93254(VarCurr)
      <~> v93236(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2773,axiom,
    ! [VarCurr: state_type] :
      ( v93254(VarCurr)
    <=> ( v93255(VarCurr)
      <~> v93236(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2772,axiom,
    ! [VarCurr: state_type] :
      ( v93255(VarCurr)
    <=> ( v93256(VarCurr)
      <~> v93236(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2771,axiom,
    ! [VarCurr: state_type] :
      ( v93256(VarCurr)
    <=> ( v93257(VarCurr)
      <~> v93236(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2770,axiom,
    ! [VarCurr: state_type] :
      ( v93257(VarCurr)
    <=> ( v93258(VarCurr)
      <~> v93236(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2769,axiom,
    ! [VarCurr: state_type] :
      ( v93258(VarCurr)
    <=> ( v93259(VarCurr)
      <~> v93236(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2768,axiom,
    ! [VarCurr: state_type] :
      ( v93259(VarCurr)
    <=> ( v93260(VarCurr)
      <~> v93236(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2767,axiom,
    ! [VarCurr: state_type] :
      ( v93260(VarCurr)
    <=> ( v93261(VarCurr)
      <~> v93236(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2766,axiom,
    ! [VarCurr: state_type] :
      ( v93261(VarCurr)
    <=> ( v93262(VarCurr)
      <~> v93236(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2765,axiom,
    ! [VarCurr: state_type] :
      ( v93262(VarCurr)
    <=> ( v93263(VarCurr)
      <~> v93236(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2764,axiom,
    ! [VarCurr: state_type] :
      ( v93263(VarCurr)
    <=> ( v93264(VarCurr)
      <~> v93236(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2763,axiom,
    ! [VarCurr: state_type] :
      ( v93264(VarCurr)
    <=> ( v93265(VarCurr)
      <~> v93236(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2762,axiom,
    ! [VarCurr: state_type] :
      ( v93265(VarCurr)
    <=> ( v93266(VarCurr)
      <~> v93236(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2761,axiom,
    ! [VarCurr: state_type] :
      ( v93266(VarCurr)
    <=> ( v93267(VarCurr)
      <~> v93236(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2760,axiom,
    ! [VarCurr: state_type] :
      ( v93267(VarCurr)
    <=> ( v93268(VarCurr)
      <~> v93236(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2759,axiom,
    ! [VarCurr: state_type] :
      ( v93268(VarCurr)
    <=> ( v93269(VarCurr)
      <~> v93236(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2758,axiom,
    ! [VarCurr: state_type] :
      ( v93269(VarCurr)
    <=> ( v93270(VarCurr)
      <~> v93236(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2757,axiom,
    ! [VarCurr: state_type] :
      ( v93270(VarCurr)
    <=> ( v93271(VarCurr)
      <~> v93236(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2756,axiom,
    ! [VarCurr: state_type] :
      ( v93271(VarCurr)
    <=> ( v93272(VarCurr)
      <~> v93236(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2755,axiom,
    ! [VarCurr: state_type] :
      ( v93272(VarCurr)
    <=> ( v93236(VarCurr,69)
      <~> v93236(VarCurr,66) ) ) ).

tff(addAssignment_56498,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,62)
    <=> v92743(VarCurr,62) ) ).

tff(addAssignment_56497,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,23)
    <=> v92743(VarCurr,23) ) ).

tff(addAssignment_56496,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,61)
    <=> v92743(VarCurr,61) ) ).

tff(addAssignment_56495,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,22)
    <=> v92743(VarCurr,22) ) ).

tff(addAssignment_56494,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,27)
    <=> v92743(VarCurr,27) ) ).

tff(addAssignment_56493,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,47)
    <=> v92743(VarCurr,47) ) ).

tff(addAssignment_56492,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,60)
    <=> v92743(VarCurr,60) ) ).

tff(addAssignment_56491,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,5)
    <=> v92743(VarCurr,5) ) ).

tff(addAssignment_56490,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,8)
    <=> v92743(VarCurr,8) ) ).

tff(addAssignment_56489,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,15)
    <=> v92743(VarCurr,15) ) ).

tff(addAssignment_56488,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,21)
    <=> v92743(VarCurr,21) ) ).

tff(addAssignment_56487,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,26)
    <=> v92743(VarCurr,26) ) ).

tff(addAssignment_56486,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,46)
    <=> v92743(VarCurr,46) ) ).

tff(addAssignment_56485,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,51)
    <=> v92743(VarCurr,51) ) ).

tff(addAssignment_56484,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,59)
    <=> v92743(VarCurr,59) ) ).

tff(addAssignment_56483,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,68)
    <=> v92743(VarCurr,68) ) ).

tff(addAssignment_56482,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,71)
    <=> v92743(VarCurr,71) ) ).

tff(addAssignment_56481,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,4)
    <=> v92743(VarCurr,4) ) ).

tff(addAssignment_56480,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,7)
    <=> v92743(VarCurr,7) ) ).

tff(addAssignment_56479,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,10)
    <=> v92743(VarCurr,10) ) ).

tff(addAssignment_56478,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,12)
    <=> v92743(VarCurr,12) ) ).

tff(addAssignment_56477,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,14)
    <=> v92743(VarCurr,14) ) ).

tff(addAssignment_56476,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,18)
    <=> v92743(VarCurr,18) ) ).

tff(addAssignment_56475,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,20)
    <=> v92743(VarCurr,20) ) ).

tff(addAssignment_56474,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,25)
    <=> v92743(VarCurr,25) ) ).

tff(addAssignment_56473,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,29)
    <=> v92743(VarCurr,29) ) ).

tff(addAssignment_56472,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,32)
    <=> v92743(VarCurr,32) ) ).

tff(addAssignment_56471,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,39)
    <=> v92743(VarCurr,39) ) ).

tff(addAssignment_56470,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,41)
    <=> v92743(VarCurr,41) ) ).

tff(addAssignment_56469,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,45)
    <=> v92743(VarCurr,45) ) ).

tff(addAssignment_56468,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,50)
    <=> v92743(VarCurr,50) ) ).

tff(addAssignment_56467,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,55)
    <=> v92743(VarCurr,55) ) ).

tff(addAssignment_56466,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,58)
    <=> v92743(VarCurr,58) ) ).

tff(addAssignment_56465,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,67)
    <=> v92743(VarCurr,67) ) ).

tff(addAssignment_56464,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,70)
    <=> v92743(VarCurr,70) ) ).

tff(addAssignment_56463,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,0)
    <=> v92743(VarCurr,0) ) ).

tff(addAssignment_56462,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,1)
    <=> v92743(VarCurr,1) ) ).

tff(addAssignment_56461,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,2)
    <=> v92743(VarCurr,2) ) ).

tff(addAssignment_56460,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,3)
    <=> v92743(VarCurr,3) ) ).

tff(addAssignment_56459,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,6)
    <=> v92743(VarCurr,6) ) ).

tff(addAssignment_56458,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,9)
    <=> v92743(VarCurr,9) ) ).

tff(addAssignment_56457,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,11)
    <=> v92743(VarCurr,11) ) ).

tff(addAssignment_56456,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,13)
    <=> v92743(VarCurr,13) ) ).

tff(addAssignment_56455,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,16)
    <=> v92743(VarCurr,16) ) ).

tff(addAssignment_56454,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,17)
    <=> v92743(VarCurr,17) ) ).

tff(addAssignment_56453,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,19)
    <=> v92743(VarCurr,19) ) ).

tff(addAssignment_56452,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,24)
    <=> v92743(VarCurr,24) ) ).

tff(addAssignment_56451,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,28)
    <=> v92743(VarCurr,28) ) ).

tff(addAssignment_56450,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,30)
    <=> v92743(VarCurr,30) ) ).

tff(addAssignment_56449,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,31)
    <=> v92743(VarCurr,31) ) ).

tff(addAssignment_56448,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,33)
    <=> v92743(VarCurr,33) ) ).

tff(addAssignment_56447,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,34)
    <=> v92743(VarCurr,34) ) ).

tff(addAssignment_56446,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,35)
    <=> v92743(VarCurr,35) ) ).

tff(addAssignment_56445,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,36)
    <=> v92743(VarCurr,36) ) ).

tff(addAssignment_56444,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,37)
    <=> v92743(VarCurr,37) ) ).

tff(addAssignment_56443,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,38)
    <=> v92743(VarCurr,38) ) ).

tff(addAssignment_56442,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,40)
    <=> v92743(VarCurr,40) ) ).

tff(addAssignment_56441,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,42)
    <=> v92743(VarCurr,42) ) ).

tff(addAssignment_56440,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,43)
    <=> v92743(VarCurr,43) ) ).

tff(addAssignment_56439,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,44)
    <=> v92743(VarCurr,44) ) ).

tff(addAssignment_56438,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,48)
    <=> v92743(VarCurr,48) ) ).

tff(addAssignment_56437,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,49)
    <=> v92743(VarCurr,49) ) ).

tff(addAssignment_56436,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,52)
    <=> v92743(VarCurr,52) ) ).

tff(addAssignment_56435,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,53)
    <=> v92743(VarCurr,53) ) ).

tff(addAssignment_56434,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,54)
    <=> v92743(VarCurr,54) ) ).

tff(addAssignment_56433,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,56)
    <=> v92743(VarCurr,56) ) ).

tff(addAssignment_56432,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,57)
    <=> v92743(VarCurr,57) ) ).

tff(addAssignment_56431,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,63)
    <=> v92743(VarCurr,63) ) ).

tff(addAssignment_56430,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,64)
    <=> v92743(VarCurr,64) ) ).

tff(addAssignment_56429,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,65)
    <=> v92743(VarCurr,65) ) ).

tff(addAssignment_56428,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,66)
    <=> v92743(VarCurr,66) ) ).

tff(addAssignment_56427,axiom,
    ! [VarCurr: state_type] :
      ( v93236(VarCurr,69)
    <=> v92743(VarCurr,69) ) ).

tff(addAssignment_56426,axiom,
    ! [VarCurr: state_type] :
      ( v93214(VarCurr)
    <=> v93216(VarCurr) ) ).

tff(addAssignment_56425,axiom,
    ! [VarCurr: state_type] :
      ( v93216(VarCurr)
    <=> v93218(VarCurr) ) ).

tff(addAssignment_56424,axiom,
    ! [VarCurr: state_type] :
      ( v93218(VarCurr)
    <=> v93220(VarCurr) ) ).

tff(addAssignment_56423,axiom,
    ! [VarCurr: state_type] :
      ( v93220(VarCurr)
    <=> v93222(VarCurr) ) ).

tff(addAssignment_56422,axiom,
    ! [VarCurr: state_type] :
      ( v93222(VarCurr)
    <=> v92679(VarCurr) ) ).

tff(addAssignment_56421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92729(VarCurr,B)
      <=> v92731(VarCurr,B) ) ) ).

tff(addAssignment_56420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92731(VarCurr,B)
      <=> v92733(VarCurr,B) ) ) ).

tff(addAssignment_56419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92733(VarCurr,B)
      <=> v92735(VarCurr,B) ) ) ).

tff(addAssignment_56418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92735(VarCurr,B)
      <=> v92737(VarCurr,B) ) ) ).

tff(addAssignment_56417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92737(VarCurr,B)
      <=> v92739(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2754,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,11)
    <=> ( v93174(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2753,axiom,
    ! [VarCurr: state_type] :
      ( v93174(VarCurr)
    <=> ( v93175(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2752,axiom,
    ! [VarCurr: state_type] :
      ( v93175(VarCurr)
    <=> ( v93176(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2751,axiom,
    ! [VarCurr: state_type] :
      ( v93176(VarCurr)
    <=> ( v93177(VarCurr)
      <~> v92741(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2750,axiom,
    ! [VarCurr: state_type] :
      ( v93177(VarCurr)
    <=> ( v93178(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2749,axiom,
    ! [VarCurr: state_type] :
      ( v93178(VarCurr)
    <=> ( v93179(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2748,axiom,
    ! [VarCurr: state_type] :
      ( v93179(VarCurr)
    <=> ( v93180(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2747,axiom,
    ! [VarCurr: state_type] :
      ( v93180(VarCurr)
    <=> ( v93181(VarCurr)
      <~> v92741(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2746,axiom,
    ! [VarCurr: state_type] :
      ( v93181(VarCurr)
    <=> ( v93182(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2745,axiom,
    ! [VarCurr: state_type] :
      ( v93182(VarCurr)
    <=> ( v93183(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2744,axiom,
    ! [VarCurr: state_type] :
      ( v93183(VarCurr)
    <=> ( v93184(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2743,axiom,
    ! [VarCurr: state_type] :
      ( v93184(VarCurr)
    <=> ( v93185(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2742,axiom,
    ! [VarCurr: state_type] :
      ( v93185(VarCurr)
    <=> ( v93186(VarCurr)
      <~> v92741(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2741,axiom,
    ! [VarCurr: state_type] :
      ( v93186(VarCurr)
    <=> ( v93187(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2740,axiom,
    ! [VarCurr: state_type] :
      ( v93187(VarCurr)
    <=> ( v93188(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2739,axiom,
    ! [VarCurr: state_type] :
      ( v93188(VarCurr)
    <=> ( v93189(VarCurr)
      <~> v92741(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2738,axiom,
    ! [VarCurr: state_type] :
      ( v93189(VarCurr)
    <=> ( v93190(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2737,axiom,
    ! [VarCurr: state_type] :
      ( v93190(VarCurr)
    <=> ( v93191(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2736,axiom,
    ! [VarCurr: state_type] :
      ( v93191(VarCurr)
    <=> ( v93192(VarCurr)
      <~> v92741(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2735,axiom,
    ! [VarCurr: state_type] :
      ( v93192(VarCurr)
    <=> ( v93193(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2734,axiom,
    ! [VarCurr: state_type] :
      ( v93193(VarCurr)
    <=> ( v93194(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2733,axiom,
    ! [VarCurr: state_type] :
      ( v93194(VarCurr)
    <=> ( v93195(VarCurr)
      <~> v92741(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2732,axiom,
    ! [VarCurr: state_type] :
      ( v93195(VarCurr)
    <=> ( v93196(VarCurr)
      <~> v92741(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2731,axiom,
    ! [VarCurr: state_type] :
      ( v93196(VarCurr)
    <=> ( v93197(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2730,axiom,
    ! [VarCurr: state_type] :
      ( v93197(VarCurr)
    <=> ( v93198(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2729,axiom,
    ! [VarCurr: state_type] :
      ( v93198(VarCurr)
    <=> ( v93199(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2728,axiom,
    ! [VarCurr: state_type] :
      ( v93199(VarCurr)
    <=> ( v93200(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2727,axiom,
    ! [VarCurr: state_type] :
      ( v93200(VarCurr)
    <=> ( v93201(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2726,axiom,
    ! [VarCurr: state_type] :
      ( v93201(VarCurr)
    <=> ( v93202(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2725,axiom,
    ! [VarCurr: state_type] :
      ( v93202(VarCurr)
    <=> ( v93203(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2724,axiom,
    ! [VarCurr: state_type] :
      ( v93203(VarCurr)
    <=> ( v93204(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2723,axiom,
    ! [VarCurr: state_type] :
      ( v93204(VarCurr)
    <=> ( v93205(VarCurr)
      <~> v92741(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2722,axiom,
    ! [VarCurr: state_type] :
      ( v93205(VarCurr)
    <=> ( v93206(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2721,axiom,
    ! [VarCurr: state_type] :
      ( v93206(VarCurr)
    <=> ( v93207(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2720,axiom,
    ! [VarCurr: state_type] :
      ( v93207(VarCurr)
    <=> ( v93208(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2719,axiom,
    ! [VarCurr: state_type] :
      ( v93208(VarCurr)
    <=> ( v93209(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2718,axiom,
    ! [VarCurr: state_type] :
      ( v93209(VarCurr)
    <=> ( v93210(VarCurr)
      <~> v92741(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2717,axiom,
    ! [VarCurr: state_type] :
      ( v93210(VarCurr)
    <=> ( v93211(VarCurr)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2716,axiom,
    ! [VarCurr: state_type] :
      ( v93211(VarCurr)
    <=> ( v93212(VarCurr)
      <~> v92741(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2715,axiom,
    ! [VarCurr: state_type] :
      ( v93212(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2714,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,10)
    <=> ( v93141(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2713,axiom,
    ! [VarCurr: state_type] :
      ( v93141(VarCurr)
    <=> ( v93142(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2712,axiom,
    ! [VarCurr: state_type] :
      ( v93142(VarCurr)
    <=> ( v93143(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2711,axiom,
    ! [VarCurr: state_type] :
      ( v93143(VarCurr)
    <=> ( v93144(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2710,axiom,
    ! [VarCurr: state_type] :
      ( v93144(VarCurr)
    <=> ( v93145(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2709,axiom,
    ! [VarCurr: state_type] :
      ( v93145(VarCurr)
    <=> ( v93146(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2708,axiom,
    ! [VarCurr: state_type] :
      ( v93146(VarCurr)
    <=> ( v93147(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2707,axiom,
    ! [VarCurr: state_type] :
      ( v93147(VarCurr)
    <=> ( v93148(VarCurr)
      <~> v92741(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2706,axiom,
    ! [VarCurr: state_type] :
      ( v93148(VarCurr)
    <=> ( v93149(VarCurr)
      <~> v92741(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2705,axiom,
    ! [VarCurr: state_type] :
      ( v93149(VarCurr)
    <=> ( v93150(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2704,axiom,
    ! [VarCurr: state_type] :
      ( v93150(VarCurr)
    <=> ( v93151(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2703,axiom,
    ! [VarCurr: state_type] :
      ( v93151(VarCurr)
    <=> ( v93152(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2702,axiom,
    ! [VarCurr: state_type] :
      ( v93152(VarCurr)
    <=> ( v93153(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2701,axiom,
    ! [VarCurr: state_type] :
      ( v93153(VarCurr)
    <=> ( v93154(VarCurr)
      <~> v92741(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2700,axiom,
    ! [VarCurr: state_type] :
      ( v93154(VarCurr)
    <=> ( v93155(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2699,axiom,
    ! [VarCurr: state_type] :
      ( v93155(VarCurr)
    <=> ( v93156(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2698,axiom,
    ! [VarCurr: state_type] :
      ( v93156(VarCurr)
    <=> ( v93157(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2697,axiom,
    ! [VarCurr: state_type] :
      ( v93157(VarCurr)
    <=> ( v93158(VarCurr)
      <~> v92741(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2696,axiom,
    ! [VarCurr: state_type] :
      ( v93158(VarCurr)
    <=> ( v93159(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2695,axiom,
    ! [VarCurr: state_type] :
      ( v93159(VarCurr)
    <=> ( v93160(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2694,axiom,
    ! [VarCurr: state_type] :
      ( v93160(VarCurr)
    <=> ( v93161(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2693,axiom,
    ! [VarCurr: state_type] :
      ( v93161(VarCurr)
    <=> ( v93162(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2692,axiom,
    ! [VarCurr: state_type] :
      ( v93162(VarCurr)
    <=> ( v93163(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2691,axiom,
    ! [VarCurr: state_type] :
      ( v93163(VarCurr)
    <=> ( v93164(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2690,axiom,
    ! [VarCurr: state_type] :
      ( v93164(VarCurr)
    <=> ( v93165(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2689,axiom,
    ! [VarCurr: state_type] :
      ( v93165(VarCurr)
    <=> ( v93166(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2688,axiom,
    ! [VarCurr: state_type] :
      ( v93166(VarCurr)
    <=> ( v93167(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2687,axiom,
    ! [VarCurr: state_type] :
      ( v93167(VarCurr)
    <=> ( v93168(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2686,axiom,
    ! [VarCurr: state_type] :
      ( v93168(VarCurr)
    <=> ( v93169(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2685,axiom,
    ! [VarCurr: state_type] :
      ( v93169(VarCurr)
    <=> ( v93170(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2684,axiom,
    ! [VarCurr: state_type] :
      ( v93170(VarCurr)
    <=> ( v93171(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2683,axiom,
    ! [VarCurr: state_type] :
      ( v93171(VarCurr)
    <=> ( v93172(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2682,axiom,
    ! [VarCurr: state_type] :
      ( v93172(VarCurr)
    <=> ( v92741(VarCurr,68)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2681,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,9)
    <=> ( v93101(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2680,axiom,
    ! [VarCurr: state_type] :
      ( v93101(VarCurr)
    <=> ( v93102(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2679,axiom,
    ! [VarCurr: state_type] :
      ( v93102(VarCurr)
    <=> ( v93103(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2678,axiom,
    ! [VarCurr: state_type] :
      ( v93103(VarCurr)
    <=> ( v93104(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2677,axiom,
    ! [VarCurr: state_type] :
      ( v93104(VarCurr)
    <=> ( v93105(VarCurr)
      <~> v92741(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2676,axiom,
    ! [VarCurr: state_type] :
      ( v93105(VarCurr)
    <=> ( v93106(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2675,axiom,
    ! [VarCurr: state_type] :
      ( v93106(VarCurr)
    <=> ( v93107(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2674,axiom,
    ! [VarCurr: state_type] :
      ( v93107(VarCurr)
    <=> ( v93108(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2673,axiom,
    ! [VarCurr: state_type] :
      ( v93108(VarCurr)
    <=> ( v93109(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2672,axiom,
    ! [VarCurr: state_type] :
      ( v93109(VarCurr)
    <=> ( v93110(VarCurr)
      <~> v92741(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2671,axiom,
    ! [VarCurr: state_type] :
      ( v93110(VarCurr)
    <=> ( v93111(VarCurr)
      <~> v92741(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2670,axiom,
    ! [VarCurr: state_type] :
      ( v93111(VarCurr)
    <=> ( v93112(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2669,axiom,
    ! [VarCurr: state_type] :
      ( v93112(VarCurr)
    <=> ( v93113(VarCurr)
      <~> v92741(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2668,axiom,
    ! [VarCurr: state_type] :
      ( v93113(VarCurr)
    <=> ( v93114(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2667,axiom,
    ! [VarCurr: state_type] :
      ( v93114(VarCurr)
    <=> ( v93115(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2666,axiom,
    ! [VarCurr: state_type] :
      ( v93115(VarCurr)
    <=> ( v93116(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2665,axiom,
    ! [VarCurr: state_type] :
      ( v93116(VarCurr)
    <=> ( v93117(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2664,axiom,
    ! [VarCurr: state_type] :
      ( v93117(VarCurr)
    <=> ( v93118(VarCurr)
      <~> v92741(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2663,axiom,
    ! [VarCurr: state_type] :
      ( v93118(VarCurr)
    <=> ( v93119(VarCurr)
      <~> v92741(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2662,axiom,
    ! [VarCurr: state_type] :
      ( v93119(VarCurr)
    <=> ( v93120(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2661,axiom,
    ! [VarCurr: state_type] :
      ( v93120(VarCurr)
    <=> ( v93121(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2660,axiom,
    ! [VarCurr: state_type] :
      ( v93121(VarCurr)
    <=> ( v93122(VarCurr)
      <~> v92741(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2659,axiom,
    ! [VarCurr: state_type] :
      ( v93122(VarCurr)
    <=> ( v93123(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2658,axiom,
    ! [VarCurr: state_type] :
      ( v93123(VarCurr)
    <=> ( v93124(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2657,axiom,
    ! [VarCurr: state_type] :
      ( v93124(VarCurr)
    <=> ( v93125(VarCurr)
      <~> v92741(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2656,axiom,
    ! [VarCurr: state_type] :
      ( v93125(VarCurr)
    <=> ( v93126(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2655,axiom,
    ! [VarCurr: state_type] :
      ( v93126(VarCurr)
    <=> ( v93127(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2654,axiom,
    ! [VarCurr: state_type] :
      ( v93127(VarCurr)
    <=> ( v93128(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2653,axiom,
    ! [VarCurr: state_type] :
      ( v93128(VarCurr)
    <=> ( v93129(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2652,axiom,
    ! [VarCurr: state_type] :
      ( v93129(VarCurr)
    <=> ( v93130(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2651,axiom,
    ! [VarCurr: state_type] :
      ( v93130(VarCurr)
    <=> ( v93131(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2650,axiom,
    ! [VarCurr: state_type] :
      ( v93131(VarCurr)
    <=> ( v93132(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2649,axiom,
    ! [VarCurr: state_type] :
      ( v93132(VarCurr)
    <=> ( v93133(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2648,axiom,
    ! [VarCurr: state_type] :
      ( v93133(VarCurr)
    <=> ( v93134(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2647,axiom,
    ! [VarCurr: state_type] :
      ( v93134(VarCurr)
    <=> ( v93135(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2646,axiom,
    ! [VarCurr: state_type] :
      ( v93135(VarCurr)
    <=> ( v93136(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2645,axiom,
    ! [VarCurr: state_type] :
      ( v93136(VarCurr)
    <=> ( v93137(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2644,axiom,
    ! [VarCurr: state_type] :
      ( v93137(VarCurr)
    <=> ( v93138(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2643,axiom,
    ! [VarCurr: state_type] :
      ( v93138(VarCurr)
    <=> ( v93139(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2642,axiom,
    ! [VarCurr: state_type] :
      ( v93139(VarCurr)
    <=> ( v92741(VarCurr,70)
      <~> v92741(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2641,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,8)
    <=> ( v93061(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2640,axiom,
    ! [VarCurr: state_type] :
      ( v93061(VarCurr)
    <=> ( v93062(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2639,axiom,
    ! [VarCurr: state_type] :
      ( v93062(VarCurr)
    <=> ( v93063(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2638,axiom,
    ! [VarCurr: state_type] :
      ( v93063(VarCurr)
    <=> ( v93064(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2637,axiom,
    ! [VarCurr: state_type] :
      ( v93064(VarCurr)
    <=> ( v93065(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2636,axiom,
    ! [VarCurr: state_type] :
      ( v93065(VarCurr)
    <=> ( v93066(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2635,axiom,
    ! [VarCurr: state_type] :
      ( v93066(VarCurr)
    <=> ( v93067(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2634,axiom,
    ! [VarCurr: state_type] :
      ( v93067(VarCurr)
    <=> ( v93068(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2633,axiom,
    ! [VarCurr: state_type] :
      ( v93068(VarCurr)
    <=> ( v93069(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2632,axiom,
    ! [VarCurr: state_type] :
      ( v93069(VarCurr)
    <=> ( v93070(VarCurr)
      <~> v92741(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2631,axiom,
    ! [VarCurr: state_type] :
      ( v93070(VarCurr)
    <=> ( v93071(VarCurr)
      <~> v92741(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2630,axiom,
    ! [VarCurr: state_type] :
      ( v93071(VarCurr)
    <=> ( v93072(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2629,axiom,
    ! [VarCurr: state_type] :
      ( v93072(VarCurr)
    <=> ( v93073(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2628,axiom,
    ! [VarCurr: state_type] :
      ( v93073(VarCurr)
    <=> ( v93074(VarCurr)
      <~> v92741(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2627,axiom,
    ! [VarCurr: state_type] :
      ( v93074(VarCurr)
    <=> ( v93075(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2626,axiom,
    ! [VarCurr: state_type] :
      ( v93075(VarCurr)
    <=> ( v93076(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2625,axiom,
    ! [VarCurr: state_type] :
      ( v93076(VarCurr)
    <=> ( v93077(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2624,axiom,
    ! [VarCurr: state_type] :
      ( v93077(VarCurr)
    <=> ( v93078(VarCurr)
      <~> v92741(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2623,axiom,
    ! [VarCurr: state_type] :
      ( v93078(VarCurr)
    <=> ( v93079(VarCurr)
      <~> v92741(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2622,axiom,
    ! [VarCurr: state_type] :
      ( v93079(VarCurr)
    <=> ( v93080(VarCurr)
      <~> v92741(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2621,axiom,
    ! [VarCurr: state_type] :
      ( v93080(VarCurr)
    <=> ( v93081(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2620,axiom,
    ! [VarCurr: state_type] :
      ( v93081(VarCurr)
    <=> ( v93082(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2619,axiom,
    ! [VarCurr: state_type] :
      ( v93082(VarCurr)
    <=> ( v93083(VarCurr)
      <~> v92741(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2618,axiom,
    ! [VarCurr: state_type] :
      ( v93083(VarCurr)
    <=> ( v93084(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2617,axiom,
    ! [VarCurr: state_type] :
      ( v93084(VarCurr)
    <=> ( v93085(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2616,axiom,
    ! [VarCurr: state_type] :
      ( v93085(VarCurr)
    <=> ( v93086(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2615,axiom,
    ! [VarCurr: state_type] :
      ( v93086(VarCurr)
    <=> ( v93087(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2614,axiom,
    ! [VarCurr: state_type] :
      ( v93087(VarCurr)
    <=> ( v93088(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2613,axiom,
    ! [VarCurr: state_type] :
      ( v93088(VarCurr)
    <=> ( v93089(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2612,axiom,
    ! [VarCurr: state_type] :
      ( v93089(VarCurr)
    <=> ( v93090(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2611,axiom,
    ! [VarCurr: state_type] :
      ( v93090(VarCurr)
    <=> ( v93091(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2610,axiom,
    ! [VarCurr: state_type] :
      ( v93091(VarCurr)
    <=> ( v93092(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2609,axiom,
    ! [VarCurr: state_type] :
      ( v93092(VarCurr)
    <=> ( v93093(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2608,axiom,
    ! [VarCurr: state_type] :
      ( v93093(VarCurr)
    <=> ( v93094(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2607,axiom,
    ! [VarCurr: state_type] :
      ( v93094(VarCurr)
    <=> ( v93095(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2606,axiom,
    ! [VarCurr: state_type] :
      ( v93095(VarCurr)
    <=> ( v93096(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2605,axiom,
    ! [VarCurr: state_type] :
      ( v93096(VarCurr)
    <=> ( v93097(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2604,axiom,
    ! [VarCurr: state_type] :
      ( v93097(VarCurr)
    <=> ( v93098(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2603,axiom,
    ! [VarCurr: state_type] :
      ( v93098(VarCurr)
    <=> ( v93099(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2602,axiom,
    ! [VarCurr: state_type] :
      ( v93099(VarCurr)
    <=> ( v92741(VarCurr,69)
      <~> v92741(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2601,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,7)
    <=> ( v93019(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2600,axiom,
    ! [VarCurr: state_type] :
      ( v93019(VarCurr)
    <=> ( v93020(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2599,axiom,
    ! [VarCurr: state_type] :
      ( v93020(VarCurr)
    <=> ( v93021(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2598,axiom,
    ! [VarCurr: state_type] :
      ( v93021(VarCurr)
    <=> ( v93022(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2597,axiom,
    ! [VarCurr: state_type] :
      ( v93022(VarCurr)
    <=> ( v93023(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2596,axiom,
    ! [VarCurr: state_type] :
      ( v93023(VarCurr)
    <=> ( v93024(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2595,axiom,
    ! [VarCurr: state_type] :
      ( v93024(VarCurr)
    <=> ( v93025(VarCurr)
      <~> v92741(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2594,axiom,
    ! [VarCurr: state_type] :
      ( v93025(VarCurr)
    <=> ( v93026(VarCurr)
      <~> v92741(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2593,axiom,
    ! [VarCurr: state_type] :
      ( v93026(VarCurr)
    <=> ( v93027(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2592,axiom,
    ! [VarCurr: state_type] :
      ( v93027(VarCurr)
    <=> ( v93028(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2591,axiom,
    ! [VarCurr: state_type] :
      ( v93028(VarCurr)
    <=> ( v93029(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2590,axiom,
    ! [VarCurr: state_type] :
      ( v93029(VarCurr)
    <=> ( v93030(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2589,axiom,
    ! [VarCurr: state_type] :
      ( v93030(VarCurr)
    <=> ( v93031(VarCurr)
      <~> v92741(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2588,axiom,
    ! [VarCurr: state_type] :
      ( v93031(VarCurr)
    <=> ( v93032(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2587,axiom,
    ! [VarCurr: state_type] :
      ( v93032(VarCurr)
    <=> ( v93033(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2586,axiom,
    ! [VarCurr: state_type] :
      ( v93033(VarCurr)
    <=> ( v93034(VarCurr)
      <~> v92741(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2585,axiom,
    ! [VarCurr: state_type] :
      ( v93034(VarCurr)
    <=> ( v93035(VarCurr)
      <~> v92741(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2584,axiom,
    ! [VarCurr: state_type] :
      ( v93035(VarCurr)
    <=> ( v93036(VarCurr)
      <~> v92741(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2583,axiom,
    ! [VarCurr: state_type] :
      ( v93036(VarCurr)
    <=> ( v93037(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2582,axiom,
    ! [VarCurr: state_type] :
      ( v93037(VarCurr)
    <=> ( v93038(VarCurr)
      <~> v92741(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2581,axiom,
    ! [VarCurr: state_type] :
      ( v93038(VarCurr)
    <=> ( v93039(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2580,axiom,
    ! [VarCurr: state_type] :
      ( v93039(VarCurr)
    <=> ( v93040(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2579,axiom,
    ! [VarCurr: state_type] :
      ( v93040(VarCurr)
    <=> ( v93041(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2578,axiom,
    ! [VarCurr: state_type] :
      ( v93041(VarCurr)
    <=> ( v93042(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2577,axiom,
    ! [VarCurr: state_type] :
      ( v93042(VarCurr)
    <=> ( v93043(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2576,axiom,
    ! [VarCurr: state_type] :
      ( v93043(VarCurr)
    <=> ( v93044(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2575,axiom,
    ! [VarCurr: state_type] :
      ( v93044(VarCurr)
    <=> ( v93045(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2574,axiom,
    ! [VarCurr: state_type] :
      ( v93045(VarCurr)
    <=> ( v93046(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2573,axiom,
    ! [VarCurr: state_type] :
      ( v93046(VarCurr)
    <=> ( v93047(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2572,axiom,
    ! [VarCurr: state_type] :
      ( v93047(VarCurr)
    <=> ( v93048(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2571,axiom,
    ! [VarCurr: state_type] :
      ( v93048(VarCurr)
    <=> ( v93049(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2570,axiom,
    ! [VarCurr: state_type] :
      ( v93049(VarCurr)
    <=> ( v93050(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2569,axiom,
    ! [VarCurr: state_type] :
      ( v93050(VarCurr)
    <=> ( v93051(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2568,axiom,
    ! [VarCurr: state_type] :
      ( v93051(VarCurr)
    <=> ( v93052(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2567,axiom,
    ! [VarCurr: state_type] :
      ( v93052(VarCurr)
    <=> ( v93053(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2566,axiom,
    ! [VarCurr: state_type] :
      ( v93053(VarCurr)
    <=> ( v93054(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2565,axiom,
    ! [VarCurr: state_type] :
      ( v93054(VarCurr)
    <=> ( v93055(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2564,axiom,
    ! [VarCurr: state_type] :
      ( v93055(VarCurr)
    <=> ( v93056(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2563,axiom,
    ! [VarCurr: state_type] :
      ( v93056(VarCurr)
    <=> ( v93057(VarCurr)
      <~> v92741(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2562,axiom,
    ! [VarCurr: state_type] :
      ( v93057(VarCurr)
    <=> ( v93058(VarCurr)
      <~> v92741(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2561,axiom,
    ! [VarCurr: state_type] :
      ( v93058(VarCurr)
    <=> ( v93059(VarCurr)
      <~> v92741(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2560,axiom,
    ! [VarCurr: state_type] :
      ( v93059(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2559,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,6)
    <=> ( v92976(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2558,axiom,
    ! [VarCurr: state_type] :
      ( v92976(VarCurr)
    <=> ( v92977(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2557,axiom,
    ! [VarCurr: state_type] :
      ( v92977(VarCurr)
    <=> ( v92978(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2556,axiom,
    ! [VarCurr: state_type] :
      ( v92978(VarCurr)
    <=> ( v92979(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2555,axiom,
    ! [VarCurr: state_type] :
      ( v92979(VarCurr)
    <=> ( v92980(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2554,axiom,
    ! [VarCurr: state_type] :
      ( v92980(VarCurr)
    <=> ( v92981(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2553,axiom,
    ! [VarCurr: state_type] :
      ( v92981(VarCurr)
    <=> ( v92982(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2552,axiom,
    ! [VarCurr: state_type] :
      ( v92982(VarCurr)
    <=> ( v92983(VarCurr)
      <~> v92741(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2551,axiom,
    ! [VarCurr: state_type] :
      ( v92983(VarCurr)
    <=> ( v92984(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2550,axiom,
    ! [VarCurr: state_type] :
      ( v92984(VarCurr)
    <=> ( v92985(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2549,axiom,
    ! [VarCurr: state_type] :
      ( v92985(VarCurr)
    <=> ( v92986(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2548,axiom,
    ! [VarCurr: state_type] :
      ( v92986(VarCurr)
    <=> ( v92987(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2547,axiom,
    ! [VarCurr: state_type] :
      ( v92987(VarCurr)
    <=> ( v92988(VarCurr)
      <~> v92741(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2546,axiom,
    ! [VarCurr: state_type] :
      ( v92988(VarCurr)
    <=> ( v92989(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2545,axiom,
    ! [VarCurr: state_type] :
      ( v92989(VarCurr)
    <=> ( v92990(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2544,axiom,
    ! [VarCurr: state_type] :
      ( v92990(VarCurr)
    <=> ( v92991(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2543,axiom,
    ! [VarCurr: state_type] :
      ( v92991(VarCurr)
    <=> ( v92992(VarCurr)
      <~> v92741(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2542,axiom,
    ! [VarCurr: state_type] :
      ( v92992(VarCurr)
    <=> ( v92993(VarCurr)
      <~> v92741(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2541,axiom,
    ! [VarCurr: state_type] :
      ( v92993(VarCurr)
    <=> ( v92994(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2540,axiom,
    ! [VarCurr: state_type] :
      ( v92994(VarCurr)
    <=> ( v92995(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2539,axiom,
    ! [VarCurr: state_type] :
      ( v92995(VarCurr)
    <=> ( v92996(VarCurr)
      <~> v92741(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2538,axiom,
    ! [VarCurr: state_type] :
      ( v92996(VarCurr)
    <=> ( v92997(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2537,axiom,
    ! [VarCurr: state_type] :
      ( v92997(VarCurr)
    <=> ( v92998(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2536,axiom,
    ! [VarCurr: state_type] :
      ( v92998(VarCurr)
    <=> ( v92999(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2535,axiom,
    ! [VarCurr: state_type] :
      ( v92999(VarCurr)
    <=> ( v93000(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2534,axiom,
    ! [VarCurr: state_type] :
      ( v93000(VarCurr)
    <=> ( v93001(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2533,axiom,
    ! [VarCurr: state_type] :
      ( v93001(VarCurr)
    <=> ( v93002(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2532,axiom,
    ! [VarCurr: state_type] :
      ( v93002(VarCurr)
    <=> ( v93003(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2531,axiom,
    ! [VarCurr: state_type] :
      ( v93003(VarCurr)
    <=> ( v93004(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2530,axiom,
    ! [VarCurr: state_type] :
      ( v93004(VarCurr)
    <=> ( v93005(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2529,axiom,
    ! [VarCurr: state_type] :
      ( v93005(VarCurr)
    <=> ( v93006(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2528,axiom,
    ! [VarCurr: state_type] :
      ( v93006(VarCurr)
    <=> ( v93007(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2527,axiom,
    ! [VarCurr: state_type] :
      ( v93007(VarCurr)
    <=> ( v93008(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2526,axiom,
    ! [VarCurr: state_type] :
      ( v93008(VarCurr)
    <=> ( v93009(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2525,axiom,
    ! [VarCurr: state_type] :
      ( v93009(VarCurr)
    <=> ( v93010(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2524,axiom,
    ! [VarCurr: state_type] :
      ( v93010(VarCurr)
    <=> ( v93011(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2523,axiom,
    ! [VarCurr: state_type] :
      ( v93011(VarCurr)
    <=> ( v93012(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2522,axiom,
    ! [VarCurr: state_type] :
      ( v93012(VarCurr)
    <=> ( v93013(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2521,axiom,
    ! [VarCurr: state_type] :
      ( v93013(VarCurr)
    <=> ( v93014(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2520,axiom,
    ! [VarCurr: state_type] :
      ( v93014(VarCurr)
    <=> ( v93015(VarCurr)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2519,axiom,
    ! [VarCurr: state_type] :
      ( v93015(VarCurr)
    <=> ( v93016(VarCurr)
      <~> v92741(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2518,axiom,
    ! [VarCurr: state_type] :
      ( v93016(VarCurr)
    <=> ( v93017(VarCurr)
      <~> v92741(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2517,axiom,
    ! [VarCurr: state_type] :
      ( v93017(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2516,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,5)
    <=> ( v92937(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2515,axiom,
    ! [VarCurr: state_type] :
      ( v92937(VarCurr)
    <=> ( v92938(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2514,axiom,
    ! [VarCurr: state_type] :
      ( v92938(VarCurr)
    <=> ( v92939(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2513,axiom,
    ! [VarCurr: state_type] :
      ( v92939(VarCurr)
    <=> ( v92940(VarCurr)
      <~> v92741(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2512,axiom,
    ! [VarCurr: state_type] :
      ( v92940(VarCurr)
    <=> ( v92941(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2511,axiom,
    ! [VarCurr: state_type] :
      ( v92941(VarCurr)
    <=> ( v92942(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2510,axiom,
    ! [VarCurr: state_type] :
      ( v92942(VarCurr)
    <=> ( v92943(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2509,axiom,
    ! [VarCurr: state_type] :
      ( v92943(VarCurr)
    <=> ( v92944(VarCurr)
      <~> v92741(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2508,axiom,
    ! [VarCurr: state_type] :
      ( v92944(VarCurr)
    <=> ( v92945(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2507,axiom,
    ! [VarCurr: state_type] :
      ( v92945(VarCurr)
    <=> ( v92946(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2506,axiom,
    ! [VarCurr: state_type] :
      ( v92946(VarCurr)
    <=> ( v92947(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2505,axiom,
    ! [VarCurr: state_type] :
      ( v92947(VarCurr)
    <=> ( v92948(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2504,axiom,
    ! [VarCurr: state_type] :
      ( v92948(VarCurr)
    <=> ( v92949(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2503,axiom,
    ! [VarCurr: state_type] :
      ( v92949(VarCurr)
    <=> ( v92950(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2502,axiom,
    ! [VarCurr: state_type] :
      ( v92950(VarCurr)
    <=> ( v92951(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2501,axiom,
    ! [VarCurr: state_type] :
      ( v92951(VarCurr)
    <=> ( v92952(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2500,axiom,
    ! [VarCurr: state_type] :
      ( v92952(VarCurr)
    <=> ( v92953(VarCurr)
      <~> v92741(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2499,axiom,
    ! [VarCurr: state_type] :
      ( v92953(VarCurr)
    <=> ( v92954(VarCurr)
      <~> v92741(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2498,axiom,
    ! [VarCurr: state_type] :
      ( v92954(VarCurr)
    <=> ( v92955(VarCurr)
      <~> v92741(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2497,axiom,
    ! [VarCurr: state_type] :
      ( v92955(VarCurr)
    <=> ( v92956(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2496,axiom,
    ! [VarCurr: state_type] :
      ( v92956(VarCurr)
    <=> ( v92957(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2495,axiom,
    ! [VarCurr: state_type] :
      ( v92957(VarCurr)
    <=> ( v92958(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2494,axiom,
    ! [VarCurr: state_type] :
      ( v92958(VarCurr)
    <=> ( v92959(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2493,axiom,
    ! [VarCurr: state_type] :
      ( v92959(VarCurr)
    <=> ( v92960(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2492,axiom,
    ! [VarCurr: state_type] :
      ( v92960(VarCurr)
    <=> ( v92961(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2491,axiom,
    ! [VarCurr: state_type] :
      ( v92961(VarCurr)
    <=> ( v92962(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2490,axiom,
    ! [VarCurr: state_type] :
      ( v92962(VarCurr)
    <=> ( v92963(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2489,axiom,
    ! [VarCurr: state_type] :
      ( v92963(VarCurr)
    <=> ( v92964(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2488,axiom,
    ! [VarCurr: state_type] :
      ( v92964(VarCurr)
    <=> ( v92965(VarCurr)
      <~> v92741(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2487,axiom,
    ! [VarCurr: state_type] :
      ( v92965(VarCurr)
    <=> ( v92966(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2486,axiom,
    ! [VarCurr: state_type] :
      ( v92966(VarCurr)
    <=> ( v92967(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2485,axiom,
    ! [VarCurr: state_type] :
      ( v92967(VarCurr)
    <=> ( v92968(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2484,axiom,
    ! [VarCurr: state_type] :
      ( v92968(VarCurr)
    <=> ( v92969(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2483,axiom,
    ! [VarCurr: state_type] :
      ( v92969(VarCurr)
    <=> ( v92970(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2482,axiom,
    ! [VarCurr: state_type] :
      ( v92970(VarCurr)
    <=> ( v92971(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2481,axiom,
    ! [VarCurr: state_type] :
      ( v92971(VarCurr)
    <=> ( v92972(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2480,axiom,
    ! [VarCurr: state_type] :
      ( v92972(VarCurr)
    <=> ( v92973(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2479,axiom,
    ! [VarCurr: state_type] :
      ( v92973(VarCurr)
    <=> ( v92974(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2478,axiom,
    ! [VarCurr: state_type] :
      ( v92974(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2477,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,4)
    <=> ( v92898(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2476,axiom,
    ! [VarCurr: state_type] :
      ( v92898(VarCurr)
    <=> ( v92899(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2475,axiom,
    ! [VarCurr: state_type] :
      ( v92899(VarCurr)
    <=> ( v92900(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2474,axiom,
    ! [VarCurr: state_type] :
      ( v92900(VarCurr)
    <=> ( v92901(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2473,axiom,
    ! [VarCurr: state_type] :
      ( v92901(VarCurr)
    <=> ( v92902(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2472,axiom,
    ! [VarCurr: state_type] :
      ( v92902(VarCurr)
    <=> ( v92903(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2471,axiom,
    ! [VarCurr: state_type] :
      ( v92903(VarCurr)
    <=> ( v92904(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2470,axiom,
    ! [VarCurr: state_type] :
      ( v92904(VarCurr)
    <=> ( v92905(VarCurr)
      <~> v92741(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2469,axiom,
    ! [VarCurr: state_type] :
      ( v92905(VarCurr)
    <=> ( v92906(VarCurr)
      <~> v92741(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2468,axiom,
    ! [VarCurr: state_type] :
      ( v92906(VarCurr)
    <=> ( v92907(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2467,axiom,
    ! [VarCurr: state_type] :
      ( v92907(VarCurr)
    <=> ( v92908(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2466,axiom,
    ! [VarCurr: state_type] :
      ( v92908(VarCurr)
    <=> ( v92909(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2465,axiom,
    ! [VarCurr: state_type] :
      ( v92909(VarCurr)
    <=> ( v92910(VarCurr)
      <~> v92741(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2464,axiom,
    ! [VarCurr: state_type] :
      ( v92910(VarCurr)
    <=> ( v92911(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2463,axiom,
    ! [VarCurr: state_type] :
      ( v92911(VarCurr)
    <=> ( v92912(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2462,axiom,
    ! [VarCurr: state_type] :
      ( v92912(VarCurr)
    <=> ( v92913(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2461,axiom,
    ! [VarCurr: state_type] :
      ( v92913(VarCurr)
    <=> ( v92914(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2460,axiom,
    ! [VarCurr: state_type] :
      ( v92914(VarCurr)
    <=> ( v92915(VarCurr)
      <~> v92741(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2459,axiom,
    ! [VarCurr: state_type] :
      ( v92915(VarCurr)
    <=> ( v92916(VarCurr)
      <~> v92741(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2458,axiom,
    ! [VarCurr: state_type] :
      ( v92916(VarCurr)
    <=> ( v92917(VarCurr)
      <~> v92741(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2457,axiom,
    ! [VarCurr: state_type] :
      ( v92917(VarCurr)
    <=> ( v92918(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2456,axiom,
    ! [VarCurr: state_type] :
      ( v92918(VarCurr)
    <=> ( v92919(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2455,axiom,
    ! [VarCurr: state_type] :
      ( v92919(VarCurr)
    <=> ( v92920(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2454,axiom,
    ! [VarCurr: state_type] :
      ( v92920(VarCurr)
    <=> ( v92921(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2453,axiom,
    ! [VarCurr: state_type] :
      ( v92921(VarCurr)
    <=> ( v92922(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2452,axiom,
    ! [VarCurr: state_type] :
      ( v92922(VarCurr)
    <=> ( v92923(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2451,axiom,
    ! [VarCurr: state_type] :
      ( v92923(VarCurr)
    <=> ( v92924(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2450,axiom,
    ! [VarCurr: state_type] :
      ( v92924(VarCurr)
    <=> ( v92925(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2449,axiom,
    ! [VarCurr: state_type] :
      ( v92925(VarCurr)
    <=> ( v92926(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2448,axiom,
    ! [VarCurr: state_type] :
      ( v92926(VarCurr)
    <=> ( v92927(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2447,axiom,
    ! [VarCurr: state_type] :
      ( v92927(VarCurr)
    <=> ( v92928(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2446,axiom,
    ! [VarCurr: state_type] :
      ( v92928(VarCurr)
    <=> ( v92929(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2445,axiom,
    ! [VarCurr: state_type] :
      ( v92929(VarCurr)
    <=> ( v92930(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2444,axiom,
    ! [VarCurr: state_type] :
      ( v92930(VarCurr)
    <=> ( v92931(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2443,axiom,
    ! [VarCurr: state_type] :
      ( v92931(VarCurr)
    <=> ( v92932(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2442,axiom,
    ! [VarCurr: state_type] :
      ( v92932(VarCurr)
    <=> ( v92933(VarCurr)
      <~> v92741(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2441,axiom,
    ! [VarCurr: state_type] :
      ( v92933(VarCurr)
    <=> ( v92934(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2440,axiom,
    ! [VarCurr: state_type] :
      ( v92934(VarCurr)
    <=> ( v92935(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2439,axiom,
    ! [VarCurr: state_type] :
      ( v92935(VarCurr)
    <=> ( v92741(VarCurr,70)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2438,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,3)
    <=> ( v92858(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2437,axiom,
    ! [VarCurr: state_type] :
      ( v92858(VarCurr)
    <=> ( v92859(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2436,axiom,
    ! [VarCurr: state_type] :
      ( v92859(VarCurr)
    <=> ( v92860(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2435,axiom,
    ! [VarCurr: state_type] :
      ( v92860(VarCurr)
    <=> ( v92861(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2434,axiom,
    ! [VarCurr: state_type] :
      ( v92861(VarCurr)
    <=> ( v92862(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2433,axiom,
    ! [VarCurr: state_type] :
      ( v92862(VarCurr)
    <=> ( v92863(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2432,axiom,
    ! [VarCurr: state_type] :
      ( v92863(VarCurr)
    <=> ( v92864(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2431,axiom,
    ! [VarCurr: state_type] :
      ( v92864(VarCurr)
    <=> ( v92865(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2430,axiom,
    ! [VarCurr: state_type] :
      ( v92865(VarCurr)
    <=> ( v92866(VarCurr)
      <~> v92741(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2429,axiom,
    ! [VarCurr: state_type] :
      ( v92866(VarCurr)
    <=> ( v92867(VarCurr)
      <~> v92741(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2428,axiom,
    ! [VarCurr: state_type] :
      ( v92867(VarCurr)
    <=> ( v92868(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2427,axiom,
    ! [VarCurr: state_type] :
      ( v92868(VarCurr)
    <=> ( v92869(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2426,axiom,
    ! [VarCurr: state_type] :
      ( v92869(VarCurr)
    <=> ( v92870(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2425,axiom,
    ! [VarCurr: state_type] :
      ( v92870(VarCurr)
    <=> ( v92871(VarCurr)
      <~> v92741(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2424,axiom,
    ! [VarCurr: state_type] :
      ( v92871(VarCurr)
    <=> ( v92872(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2423,axiom,
    ! [VarCurr: state_type] :
      ( v92872(VarCurr)
    <=> ( v92873(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2422,axiom,
    ! [VarCurr: state_type] :
      ( v92873(VarCurr)
    <=> ( v92874(VarCurr)
      <~> v92741(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2421,axiom,
    ! [VarCurr: state_type] :
      ( v92874(VarCurr)
    <=> ( v92875(VarCurr)
      <~> v92741(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2420,axiom,
    ! [VarCurr: state_type] :
      ( v92875(VarCurr)
    <=> ( v92876(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2419,axiom,
    ! [VarCurr: state_type] :
      ( v92876(VarCurr)
    <=> ( v92877(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2418,axiom,
    ! [VarCurr: state_type] :
      ( v92877(VarCurr)
    <=> ( v92878(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2417,axiom,
    ! [VarCurr: state_type] :
      ( v92878(VarCurr)
    <=> ( v92879(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2416,axiom,
    ! [VarCurr: state_type] :
      ( v92879(VarCurr)
    <=> ( v92880(VarCurr)
      <~> v92741(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2415,axiom,
    ! [VarCurr: state_type] :
      ( v92880(VarCurr)
    <=> ( v92881(VarCurr)
      <~> v92741(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2414,axiom,
    ! [VarCurr: state_type] :
      ( v92881(VarCurr)
    <=> ( v92882(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2413,axiom,
    ! [VarCurr: state_type] :
      ( v92882(VarCurr)
    <=> ( v92883(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2412,axiom,
    ! [VarCurr: state_type] :
      ( v92883(VarCurr)
    <=> ( v92884(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2411,axiom,
    ! [VarCurr: state_type] :
      ( v92884(VarCurr)
    <=> ( v92885(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2410,axiom,
    ! [VarCurr: state_type] :
      ( v92885(VarCurr)
    <=> ( v92886(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2409,axiom,
    ! [VarCurr: state_type] :
      ( v92886(VarCurr)
    <=> ( v92887(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2408,axiom,
    ! [VarCurr: state_type] :
      ( v92887(VarCurr)
    <=> ( v92888(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2407,axiom,
    ! [VarCurr: state_type] :
      ( v92888(VarCurr)
    <=> ( v92889(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2406,axiom,
    ! [VarCurr: state_type] :
      ( v92889(VarCurr)
    <=> ( v92890(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2405,axiom,
    ! [VarCurr: state_type] :
      ( v92890(VarCurr)
    <=> ( v92891(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2404,axiom,
    ! [VarCurr: state_type] :
      ( v92891(VarCurr)
    <=> ( v92892(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2403,axiom,
    ! [VarCurr: state_type] :
      ( v92892(VarCurr)
    <=> ( v92893(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2402,axiom,
    ! [VarCurr: state_type] :
      ( v92893(VarCurr)
    <=> ( v92894(VarCurr)
      <~> v92741(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2401,axiom,
    ! [VarCurr: state_type] :
      ( v92894(VarCurr)
    <=> ( v92895(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2400,axiom,
    ! [VarCurr: state_type] :
      ( v92895(VarCurr)
    <=> ( v92896(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2399,axiom,
    ! [VarCurr: state_type] :
      ( v92896(VarCurr)
    <=> ( v92741(VarCurr,70)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2398,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,2)
    <=> ( v92824(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2397,axiom,
    ! [VarCurr: state_type] :
      ( v92824(VarCurr)
    <=> ( v92825(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2396,axiom,
    ! [VarCurr: state_type] :
      ( v92825(VarCurr)
    <=> ( v92826(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2395,axiom,
    ! [VarCurr: state_type] :
      ( v92826(VarCurr)
    <=> ( v92827(VarCurr)
      <~> v92741(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2394,axiom,
    ! [VarCurr: state_type] :
      ( v92827(VarCurr)
    <=> ( v92828(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2393,axiom,
    ! [VarCurr: state_type] :
      ( v92828(VarCurr)
    <=> ( v92829(VarCurr)
      <~> v92741(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2392,axiom,
    ! [VarCurr: state_type] :
      ( v92829(VarCurr)
    <=> ( v92830(VarCurr)
      <~> v92741(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2391,axiom,
    ! [VarCurr: state_type] :
      ( v92830(VarCurr)
    <=> ( v92831(VarCurr)
      <~> v92741(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2390,axiom,
    ! [VarCurr: state_type] :
      ( v92831(VarCurr)
    <=> ( v92832(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2389,axiom,
    ! [VarCurr: state_type] :
      ( v92832(VarCurr)
    <=> ( v92833(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2388,axiom,
    ! [VarCurr: state_type] :
      ( v92833(VarCurr)
    <=> ( v92834(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2387,axiom,
    ! [VarCurr: state_type] :
      ( v92834(VarCurr)
    <=> ( v92835(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2386,axiom,
    ! [VarCurr: state_type] :
      ( v92835(VarCurr)
    <=> ( v92836(VarCurr)
      <~> v92741(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2385,axiom,
    ! [VarCurr: state_type] :
      ( v92836(VarCurr)
    <=> ( v92837(VarCurr)
      <~> v92741(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2384,axiom,
    ! [VarCurr: state_type] :
      ( v92837(VarCurr)
    <=> ( v92838(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2383,axiom,
    ! [VarCurr: state_type] :
      ( v92838(VarCurr)
    <=> ( v92839(VarCurr)
      <~> v92741(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2382,axiom,
    ! [VarCurr: state_type] :
      ( v92839(VarCurr)
    <=> ( v92840(VarCurr)
      <~> v92741(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2381,axiom,
    ! [VarCurr: state_type] :
      ( v92840(VarCurr)
    <=> ( v92841(VarCurr)
      <~> v92741(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2380,axiom,
    ! [VarCurr: state_type] :
      ( v92841(VarCurr)
    <=> ( v92842(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2379,axiom,
    ! [VarCurr: state_type] :
      ( v92842(VarCurr)
    <=> ( v92843(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2378,axiom,
    ! [VarCurr: state_type] :
      ( v92843(VarCurr)
    <=> ( v92844(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2377,axiom,
    ! [VarCurr: state_type] :
      ( v92844(VarCurr)
    <=> ( v92845(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2376,axiom,
    ! [VarCurr: state_type] :
      ( v92845(VarCurr)
    <=> ( v92846(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2375,axiom,
    ! [VarCurr: state_type] :
      ( v92846(VarCurr)
    <=> ( v92847(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2374,axiom,
    ! [VarCurr: state_type] :
      ( v92847(VarCurr)
    <=> ( v92848(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2373,axiom,
    ! [VarCurr: state_type] :
      ( v92848(VarCurr)
    <=> ( v92849(VarCurr)
      <~> v92741(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2372,axiom,
    ! [VarCurr: state_type] :
      ( v92849(VarCurr)
    <=> ( v92850(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2371,axiom,
    ! [VarCurr: state_type] :
      ( v92850(VarCurr)
    <=> ( v92851(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2370,axiom,
    ! [VarCurr: state_type] :
      ( v92851(VarCurr)
    <=> ( v92852(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2369,axiom,
    ! [VarCurr: state_type] :
      ( v92852(VarCurr)
    <=> ( v92853(VarCurr)
      <~> v92741(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2368,axiom,
    ! [VarCurr: state_type] :
      ( v92853(VarCurr)
    <=> ( v92854(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2367,axiom,
    ! [VarCurr: state_type] :
      ( v92854(VarCurr)
    <=> ( v92855(VarCurr)
      <~> v92741(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2366,axiom,
    ! [VarCurr: state_type] :
      ( v92855(VarCurr)
    <=> ( v92856(VarCurr)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2365,axiom,
    ! [VarCurr: state_type] :
      ( v92856(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2364,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,1)
    <=> ( v92790(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2363,axiom,
    ! [VarCurr: state_type] :
      ( v92790(VarCurr)
    <=> ( v92791(VarCurr)
      <~> v92741(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2362,axiom,
    ! [VarCurr: state_type] :
      ( v92791(VarCurr)
    <=> ( v92792(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2361,axiom,
    ! [VarCurr: state_type] :
      ( v92792(VarCurr)
    <=> ( v92793(VarCurr)
      <~> v92741(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2360,axiom,
    ! [VarCurr: state_type] :
      ( v92793(VarCurr)
    <=> ( v92794(VarCurr)
      <~> v92741(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2359,axiom,
    ! [VarCurr: state_type] :
      ( v92794(VarCurr)
    <=> ( v92795(VarCurr)
      <~> v92741(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2358,axiom,
    ! [VarCurr: state_type] :
      ( v92795(VarCurr)
    <=> ( v92796(VarCurr)
      <~> v92741(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2357,axiom,
    ! [VarCurr: state_type] :
      ( v92796(VarCurr)
    <=> ( v92797(VarCurr)
      <~> v92741(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2356,axiom,
    ! [VarCurr: state_type] :
      ( v92797(VarCurr)
    <=> ( v92798(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2355,axiom,
    ! [VarCurr: state_type] :
      ( v92798(VarCurr)
    <=> ( v92799(VarCurr)
      <~> v92741(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2354,axiom,
    ! [VarCurr: state_type] :
      ( v92799(VarCurr)
    <=> ( v92800(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2353,axiom,
    ! [VarCurr: state_type] :
      ( v92800(VarCurr)
    <=> ( v92801(VarCurr)
      <~> v92741(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2352,axiom,
    ! [VarCurr: state_type] :
      ( v92801(VarCurr)
    <=> ( v92802(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2351,axiom,
    ! [VarCurr: state_type] :
      ( v92802(VarCurr)
    <=> ( v92803(VarCurr)
      <~> v92741(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2350,axiom,
    ! [VarCurr: state_type] :
      ( v92803(VarCurr)
    <=> ( v92804(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2349,axiom,
    ! [VarCurr: state_type] :
      ( v92804(VarCurr)
    <=> ( v92805(VarCurr)
      <~> v92741(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2348,axiom,
    ! [VarCurr: state_type] :
      ( v92805(VarCurr)
    <=> ( v92806(VarCurr)
      <~> v92741(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2347,axiom,
    ! [VarCurr: state_type] :
      ( v92806(VarCurr)
    <=> ( v92807(VarCurr)
      <~> v92741(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2346,axiom,
    ! [VarCurr: state_type] :
      ( v92807(VarCurr)
    <=> ( v92808(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2345,axiom,
    ! [VarCurr: state_type] :
      ( v92808(VarCurr)
    <=> ( v92809(VarCurr)
      <~> v92741(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2344,axiom,
    ! [VarCurr: state_type] :
      ( v92809(VarCurr)
    <=> ( v92810(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2343,axiom,
    ! [VarCurr: state_type] :
      ( v92810(VarCurr)
    <=> ( v92811(VarCurr)
      <~> v92741(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2342,axiom,
    ! [VarCurr: state_type] :
      ( v92811(VarCurr)
    <=> ( v92812(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2341,axiom,
    ! [VarCurr: state_type] :
      ( v92812(VarCurr)
    <=> ( v92813(VarCurr)
      <~> v92741(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2340,axiom,
    ! [VarCurr: state_type] :
      ( v92813(VarCurr)
    <=> ( v92814(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2339,axiom,
    ! [VarCurr: state_type] :
      ( v92814(VarCurr)
    <=> ( v92815(VarCurr)
      <~> v92741(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2338,axiom,
    ! [VarCurr: state_type] :
      ( v92815(VarCurr)
    <=> ( v92816(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2337,axiom,
    ! [VarCurr: state_type] :
      ( v92816(VarCurr)
    <=> ( v92817(VarCurr)
      <~> v92741(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2336,axiom,
    ! [VarCurr: state_type] :
      ( v92817(VarCurr)
    <=> ( v92818(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2335,axiom,
    ! [VarCurr: state_type] :
      ( v92818(VarCurr)
    <=> ( v92819(VarCurr)
      <~> v92741(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2334,axiom,
    ! [VarCurr: state_type] :
      ( v92819(VarCurr)
    <=> ( v92820(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2333,axiom,
    ! [VarCurr: state_type] :
      ( v92820(VarCurr)
    <=> ( v92821(VarCurr)
      <~> v92741(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2332,axiom,
    ! [VarCurr: state_type] :
      ( v92821(VarCurr)
    <=> ( v92822(VarCurr)
      <~> v92741(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2331,axiom,
    ! [VarCurr: state_type] :
      ( v92822(VarCurr)
    <=> ( v92741(VarCurr,70)
      <~> v92741(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8663,axiom,
    ! [VarCurr: state_type] :
      ( v92739(VarCurr,0)
    <=> ( v92750(VarCurr)
      <~> v92741(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2330,axiom,
    ! [VarCurr: state_type] :
      ( v92750(VarCurr)
    <=> ( v92751(VarCurr)
      <~> v92741(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2329,axiom,
    ! [VarCurr: state_type] :
      ( v92751(VarCurr)
    <=> ( v92752(VarCurr)
      <~> v92741(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2328,axiom,
    ! [VarCurr: state_type] :
      ( v92752(VarCurr)
    <=> ( v92753(VarCurr)
      <~> v92741(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2327,axiom,
    ! [VarCurr: state_type] :
      ( v92753(VarCurr)
    <=> ( v92754(VarCurr)
      <~> v92741(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2326,axiom,
    ! [VarCurr: state_type] :
      ( v92754(VarCurr)
    <=> ( v92755(VarCurr)
      <~> v92741(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2325,axiom,
    ! [VarCurr: state_type] :
      ( v92755(VarCurr)
    <=> ( v92756(VarCurr)
      <~> v92741(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2324,axiom,
    ! [VarCurr: state_type] :
      ( v92756(VarCurr)
    <=> ( v92757(VarCurr)
      <~> v92741(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2323,axiom,
    ! [VarCurr: state_type] :
      ( v92757(VarCurr)
    <=> ( v92758(VarCurr)
      <~> v92741(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2322,axiom,
    ! [VarCurr: state_type] :
      ( v92758(VarCurr)
    <=> ( v92759(VarCurr)
      <~> v92741(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2321,axiom,
    ! [VarCurr: state_type] :
      ( v92759(VarCurr)
    <=> ( v92760(VarCurr)
      <~> v92741(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2320,axiom,
    ! [VarCurr: state_type] :
      ( v92760(VarCurr)
    <=> ( v92761(VarCurr)
      <~> v92741(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2319,axiom,
    ! [VarCurr: state_type] :
      ( v92761(VarCurr)
    <=> ( v92762(VarCurr)
      <~> v92741(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2318,axiom,
    ! [VarCurr: state_type] :
      ( v92762(VarCurr)
    <=> ( v92763(VarCurr)
      <~> v92741(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2317,axiom,
    ! [VarCurr: state_type] :
      ( v92763(VarCurr)
    <=> ( v92764(VarCurr)
      <~> v92741(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2316,axiom,
    ! [VarCurr: state_type] :
      ( v92764(VarCurr)
    <=> ( v92765(VarCurr)
      <~> v92741(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2315,axiom,
    ! [VarCurr: state_type] :
      ( v92765(VarCurr)
    <=> ( v92766(VarCurr)
      <~> v92741(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2314,axiom,
    ! [VarCurr: state_type] :
      ( v92766(VarCurr)
    <=> ( v92767(VarCurr)
      <~> v92741(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2313,axiom,
    ! [VarCurr: state_type] :
      ( v92767(VarCurr)
    <=> ( v92768(VarCurr)
      <~> v92741(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2312,axiom,
    ! [VarCurr: state_type] :
      ( v92768(VarCurr)
    <=> ( v92769(VarCurr)
      <~> v92741(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2311,axiom,
    ! [VarCurr: state_type] :
      ( v92769(VarCurr)
    <=> ( v92770(VarCurr)
      <~> v92741(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2310,axiom,
    ! [VarCurr: state_type] :
      ( v92770(VarCurr)
    <=> ( v92771(VarCurr)
      <~> v92741(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2309,axiom,
    ! [VarCurr: state_type] :
      ( v92771(VarCurr)
    <=> ( v92772(VarCurr)
      <~> v92741(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2308,axiom,
    ! [VarCurr: state_type] :
      ( v92772(VarCurr)
    <=> ( v92773(VarCurr)
      <~> v92741(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2307,axiom,
    ! [VarCurr: state_type] :
      ( v92773(VarCurr)
    <=> ( v92774(VarCurr)
      <~> v92741(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2306,axiom,
    ! [VarCurr: state_type] :
      ( v92774(VarCurr)
    <=> ( v92775(VarCurr)
      <~> v92741(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2305,axiom,
    ! [VarCurr: state_type] :
      ( v92775(VarCurr)
    <=> ( v92776(VarCurr)
      <~> v92741(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2304,axiom,
    ! [VarCurr: state_type] :
      ( v92776(VarCurr)
    <=> ( v92777(VarCurr)
      <~> v92741(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2303,axiom,
    ! [VarCurr: state_type] :
      ( v92777(VarCurr)
    <=> ( v92778(VarCurr)
      <~> v92741(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2302,axiom,
    ! [VarCurr: state_type] :
      ( v92778(VarCurr)
    <=> ( v92779(VarCurr)
      <~> v92741(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2301,axiom,
    ! [VarCurr: state_type] :
      ( v92779(VarCurr)
    <=> ( v92780(VarCurr)
      <~> v92741(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2300,axiom,
    ! [VarCurr: state_type] :
      ( v92780(VarCurr)
    <=> ( v92781(VarCurr)
      <~> v92741(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2299,axiom,
    ! [VarCurr: state_type] :
      ( v92781(VarCurr)
    <=> ( v92782(VarCurr)
      <~> v92741(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2298,axiom,
    ! [VarCurr: state_type] :
      ( v92782(VarCurr)
    <=> ( v92783(VarCurr)
      <~> v92741(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2297,axiom,
    ! [VarCurr: state_type] :
      ( v92783(VarCurr)
    <=> ( v92784(VarCurr)
      <~> v92741(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2296,axiom,
    ! [VarCurr: state_type] :
      ( v92784(VarCurr)
    <=> ( v92785(VarCurr)
      <~> v92741(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2295,axiom,
    ! [VarCurr: state_type] :
      ( v92785(VarCurr)
    <=> ( v92786(VarCurr)
      <~> v92741(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2294,axiom,
    ! [VarCurr: state_type] :
      ( v92786(VarCurr)
    <=> ( v92787(VarCurr)
      <~> v92741(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2293,axiom,
    ! [VarCurr: state_type] :
      ( v92787(VarCurr)
    <=> ( v92788(VarCurr)
      <~> v92741(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2292,axiom,
    ! [VarCurr: state_type] :
      ( v92788(VarCurr)
    <=> ( v92741(VarCurr,71)
      <~> v92741(VarCurr,70) ) ) ).

tff(addAssignment_56416,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,33)
    <=> v92743(VarCurr,33) ) ).

tff(addAssignment_56415,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,33)
    <=> v92745(VarCurr,33) ) ).

tff(addAssignment_56414,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,33)
    <=> v92747(VarCurr,33) ) ).

tff(addAssignment_56413,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,33)
    <=> v92748(VarCurr,33) ) ).

tff(addAssignment_56412,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,62)
    <=> v92743(VarCurr,62) ) ).

tff(addAssignment_56411,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,62)
    <=> v92745(VarCurr,62) ) ).

tff(addAssignment_56410,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,62)
    <=> v92747(VarCurr,62) ) ).

tff(addAssignment_56409,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,62)
    <=> v92748(VarCurr,62) ) ).

tff(addAssignment_56408,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,15)
    <=> v92743(VarCurr,15) ) ).

tff(addAssignment_56407,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,15)
    <=> v92745(VarCurr,15) ) ).

tff(addAssignment_56406,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,15)
    <=> v92747(VarCurr,15) ) ).

tff(addAssignment_56405,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,15)
    <=> v92748(VarCurr,15) ) ).

tff(addAssignment_56404,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,32)
    <=> v92743(VarCurr,32) ) ).

tff(addAssignment_56403,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,32)
    <=> v92745(VarCurr,32) ) ).

tff(addAssignment_56402,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,32)
    <=> v92747(VarCurr,32) ) ).

tff(addAssignment_56401,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,32)
    <=> v92748(VarCurr,32) ) ).

tff(addAssignment_56400,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,61)
    <=> v92743(VarCurr,61) ) ).

tff(addAssignment_56399,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,61)
    <=> v92745(VarCurr,61) ) ).

tff(addAssignment_56398,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,61)
    <=> v92747(VarCurr,61) ) ).

tff(addAssignment_56397,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,61)
    <=> v92748(VarCurr,61) ) ).

tff(addAssignment_56396,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,5)
    <=> v92743(VarCurr,5) ) ).

tff(addAssignment_56395,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,5)
    <=> v92745(VarCurr,5) ) ).

tff(addAssignment_56394,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,5)
    <=> v92747(VarCurr,5) ) ).

tff(addAssignment_56393,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,5)
    <=> v92748(VarCurr,5) ) ).

tff(addAssignment_56392,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,11)
    <=> v92743(VarCurr,11) ) ).

tff(addAssignment_56391,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,11)
    <=> v92745(VarCurr,11) ) ).

tff(addAssignment_56390,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,11)
    <=> v92747(VarCurr,11) ) ).

tff(addAssignment_56389,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,11)
    <=> v92748(VarCurr,11) ) ).

tff(addAssignment_56388,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,14)
    <=> v92743(VarCurr,14) ) ).

tff(addAssignment_56387,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,14)
    <=> v92745(VarCurr,14) ) ).

tff(addAssignment_56386,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,14)
    <=> v92747(VarCurr,14) ) ).

tff(addAssignment_56385,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,14)
    <=> v92748(VarCurr,14) ) ).

tff(addAssignment_56384,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,24)
    <=> v92743(VarCurr,24) ) ).

tff(addAssignment_56383,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,24)
    <=> v92745(VarCurr,24) ) ).

tff(addAssignment_56382,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,24)
    <=> v92747(VarCurr,24) ) ).

tff(addAssignment_56381,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,24)
    <=> v92748(VarCurr,24) ) ).

tff(addAssignment_56380,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,28)
    <=> v92743(VarCurr,28) ) ).

tff(addAssignment_56379,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,28)
    <=> v92745(VarCurr,28) ) ).

tff(addAssignment_56378,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,28)
    <=> v92747(VarCurr,28) ) ).

tff(addAssignment_56377,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,28)
    <=> v92748(VarCurr,28) ) ).

tff(addAssignment_56376,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,31)
    <=> v92743(VarCurr,31) ) ).

tff(addAssignment_56375,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,31)
    <=> v92745(VarCurr,31) ) ).

tff(addAssignment_56374,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,31)
    <=> v92747(VarCurr,31) ) ).

tff(addAssignment_56373,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,31)
    <=> v92748(VarCurr,31) ) ).

tff(addAssignment_56372,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,51)
    <=> v92743(VarCurr,51) ) ).

tff(addAssignment_56371,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,51)
    <=> v92745(VarCurr,51) ) ).

tff(addAssignment_56370,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,51)
    <=> v92747(VarCurr,51) ) ).

tff(addAssignment_56369,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,51)
    <=> v92748(VarCurr,51) ) ).

tff(addAssignment_56368,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,60)
    <=> v92743(VarCurr,60) ) ).

tff(addAssignment_56367,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,60)
    <=> v92745(VarCurr,60) ) ).

tff(addAssignment_56366,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,60)
    <=> v92747(VarCurr,60) ) ).

tff(addAssignment_56365,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,60)
    <=> v92748(VarCurr,60) ) ).

tff(addAssignment_56364,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,65)
    <=> v92743(VarCurr,65) ) ).

tff(addAssignment_56363,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,65)
    <=> v92745(VarCurr,65) ) ).

tff(addAssignment_56362,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,65)
    <=> v92747(VarCurr,65) ) ).

tff(addAssignment_56361,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,65)
    <=> v92748(VarCurr,65) ) ).

tff(addAssignment_56360,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,2)
    <=> v92743(VarCurr,2) ) ).

tff(addAssignment_56359,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,2)
    <=> v92745(VarCurr,2) ) ).

tff(addAssignment_56358,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,2)
    <=> v92747(VarCurr,2) ) ).

tff(addAssignment_56357,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,2)
    <=> v92748(VarCurr,2) ) ).

tff(addAssignment_56356,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,4)
    <=> v92743(VarCurr,4) ) ).

tff(addAssignment_56355,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,4)
    <=> v92745(VarCurr,4) ) ).

tff(addAssignment_56354,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,4)
    <=> v92747(VarCurr,4) ) ).

tff(addAssignment_56353,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,4)
    <=> v92748(VarCurr,4) ) ).

tff(addAssignment_56352,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,10)
    <=> v92743(VarCurr,10) ) ).

tff(addAssignment_56351,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,10)
    <=> v92745(VarCurr,10) ) ).

tff(addAssignment_56350,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,10)
    <=> v92747(VarCurr,10) ) ).

tff(addAssignment_56349,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,10)
    <=> v92748(VarCurr,10) ) ).

tff(addAssignment_56348,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,13)
    <=> v92743(VarCurr,13) ) ).

tff(addAssignment_56347,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,13)
    <=> v92745(VarCurr,13) ) ).

tff(addAssignment_56346,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,13)
    <=> v92747(VarCurr,13) ) ).

tff(addAssignment_56345,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,13)
    <=> v92748(VarCurr,13) ) ).

tff(addAssignment_56344,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,17)
    <=> v92743(VarCurr,17) ) ).

tff(addAssignment_56343,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,17)
    <=> v92745(VarCurr,17) ) ).

tff(addAssignment_56342,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,17)
    <=> v92747(VarCurr,17) ) ).

tff(addAssignment_56341,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,17)
    <=> v92748(VarCurr,17) ) ).

tff(addAssignment_56340,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,20)
    <=> v92743(VarCurr,20) ) ).

tff(addAssignment_56339,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,20)
    <=> v92745(VarCurr,20) ) ).

tff(addAssignment_56338,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,20)
    <=> v92747(VarCurr,20) ) ).

tff(addAssignment_56337,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,20)
    <=> v92748(VarCurr,20) ) ).

tff(addAssignment_56336,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,23)
    <=> v92743(VarCurr,23) ) ).

tff(addAssignment_56335,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,23)
    <=> v92745(VarCurr,23) ) ).

tff(addAssignment_56334,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,23)
    <=> v92747(VarCurr,23) ) ).

tff(addAssignment_56333,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,23)
    <=> v92748(VarCurr,23) ) ).

tff(addAssignment_56332,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,27)
    <=> v92743(VarCurr,27) ) ).

tff(addAssignment_56331,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,27)
    <=> v92745(VarCurr,27) ) ).

tff(addAssignment_56330,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,27)
    <=> v92747(VarCurr,27) ) ).

tff(addAssignment_56329,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,27)
    <=> v92748(VarCurr,27) ) ).

tff(addAssignment_56328,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,30)
    <=> v92743(VarCurr,30) ) ).

tff(addAssignment_56327,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,30)
    <=> v92745(VarCurr,30) ) ).

tff(addAssignment_56326,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,30)
    <=> v92747(VarCurr,30) ) ).

tff(addAssignment_56325,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,30)
    <=> v92748(VarCurr,30) ) ).

tff(addAssignment_56324,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,43)
    <=> v92743(VarCurr,43) ) ).

tff(addAssignment_56323,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,43)
    <=> v92745(VarCurr,43) ) ).

tff(addAssignment_56322,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,43)
    <=> v92747(VarCurr,43) ) ).

tff(addAssignment_56321,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,43)
    <=> v92748(VarCurr,43) ) ).

tff(addAssignment_56320,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,45)
    <=> v92743(VarCurr,45) ) ).

tff(addAssignment_56319,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,45)
    <=> v92745(VarCurr,45) ) ).

tff(addAssignment_56318,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,45)
    <=> v92747(VarCurr,45) ) ).

tff(addAssignment_56317,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,45)
    <=> v92748(VarCurr,45) ) ).

tff(addAssignment_56316,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,47)
    <=> v92743(VarCurr,47) ) ).

tff(addAssignment_56315,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,47)
    <=> v92745(VarCurr,47) ) ).

tff(addAssignment_56314,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,47)
    <=> v92747(VarCurr,47) ) ).

tff(addAssignment_56313,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,47)
    <=> v92748(VarCurr,47) ) ).

tff(addAssignment_56312,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,50)
    <=> v92743(VarCurr,50) ) ).

tff(addAssignment_56311,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,50)
    <=> v92745(VarCurr,50) ) ).

tff(addAssignment_56310,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,50)
    <=> v92747(VarCurr,50) ) ).

tff(addAssignment_56309,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,50)
    <=> v92748(VarCurr,50) ) ).

tff(addAssignment_56308,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,57)
    <=> v92743(VarCurr,57) ) ).

tff(addAssignment_56307,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,57)
    <=> v92745(VarCurr,57) ) ).

tff(addAssignment_56306,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,57)
    <=> v92747(VarCurr,57) ) ).

tff(addAssignment_56305,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,57)
    <=> v92748(VarCurr,57) ) ).

tff(addAssignment_56304,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,59)
    <=> v92743(VarCurr,59) ) ).

tff(addAssignment_56303,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,59)
    <=> v92745(VarCurr,59) ) ).

tff(addAssignment_56302,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,59)
    <=> v92747(VarCurr,59) ) ).

tff(addAssignment_56301,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,59)
    <=> v92748(VarCurr,59) ) ).

tff(addAssignment_56300,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,64)
    <=> v92743(VarCurr,64) ) ).

tff(addAssignment_56299,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,64)
    <=> v92745(VarCurr,64) ) ).

tff(addAssignment_56298,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,64)
    <=> v92747(VarCurr,64) ) ).

tff(addAssignment_56297,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,64)
    <=> v92748(VarCurr,64) ) ).

tff(addAssignment_56296,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,69)
    <=> v92743(VarCurr,69) ) ).

tff(addAssignment_56295,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,69)
    <=> v92745(VarCurr,69) ) ).

tff(addAssignment_56294,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,69)
    <=> v92747(VarCurr,69) ) ).

tff(addAssignment_56293,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,69)
    <=> v92748(VarCurr,69) ) ).

tff(addAssignment_56292,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,0)
    <=> v92743(VarCurr,0) ) ).

tff(addAssignment_56291,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,0)
    <=> v92745(VarCurr,0) ) ).

tff(addAssignment_56290,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,0)
    <=> v92747(VarCurr,0) ) ).

tff(addAssignment_56289,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,0)
    <=> v92748(VarCurr,0) ) ).

tff(addAssignment_56288,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,1)
    <=> v92743(VarCurr,1) ) ).

tff(addAssignment_56287,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,1)
    <=> v92745(VarCurr,1) ) ).

tff(addAssignment_56286,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,1)
    <=> v92747(VarCurr,1) ) ).

tff(addAssignment_56285,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,1)
    <=> v92748(VarCurr,1) ) ).

tff(addAssignment_56284,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,3)
    <=> v92743(VarCurr,3) ) ).

tff(addAssignment_56283,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,3)
    <=> v92745(VarCurr,3) ) ).

tff(addAssignment_56282,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,3)
    <=> v92747(VarCurr,3) ) ).

tff(addAssignment_56281,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,3)
    <=> v92748(VarCurr,3) ) ).

tff(addAssignment_56280,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,6)
    <=> v92743(VarCurr,6) ) ).

tff(addAssignment_56279,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,6)
    <=> v92745(VarCurr,6) ) ).

tff(addAssignment_56278,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,6)
    <=> v92747(VarCurr,6) ) ).

tff(addAssignment_56277,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,6)
    <=> v92748(VarCurr,6) ) ).

tff(addAssignment_56276,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,7)
    <=> v92743(VarCurr,7) ) ).

tff(addAssignment_56275,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,7)
    <=> v92745(VarCurr,7) ) ).

tff(addAssignment_56274,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,7)
    <=> v92747(VarCurr,7) ) ).

tff(addAssignment_56273,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,7)
    <=> v92748(VarCurr,7) ) ).

tff(addAssignment_56272,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,8)
    <=> v92743(VarCurr,8) ) ).

tff(addAssignment_56271,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,8)
    <=> v92745(VarCurr,8) ) ).

tff(addAssignment_56270,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,8)
    <=> v92747(VarCurr,8) ) ).

tff(addAssignment_56269,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,8)
    <=> v92748(VarCurr,8) ) ).

tff(addAssignment_56268,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,9)
    <=> v92743(VarCurr,9) ) ).

tff(addAssignment_56267,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,9)
    <=> v92745(VarCurr,9) ) ).

tff(addAssignment_56266,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,9)
    <=> v92747(VarCurr,9) ) ).

tff(addAssignment_56265,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,9)
    <=> v92748(VarCurr,9) ) ).

tff(addAssignment_56264,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,12)
    <=> v92743(VarCurr,12) ) ).

tff(addAssignment_56263,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,12)
    <=> v92745(VarCurr,12) ) ).

tff(addAssignment_56262,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,12)
    <=> v92747(VarCurr,12) ) ).

tff(addAssignment_56261,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,12)
    <=> v92748(VarCurr,12) ) ).

tff(addAssignment_56260,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,16)
    <=> v92743(VarCurr,16) ) ).

tff(addAssignment_56259,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,16)
    <=> v92745(VarCurr,16) ) ).

tff(addAssignment_56258,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,16)
    <=> v92747(VarCurr,16) ) ).

tff(addAssignment_56257,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,16)
    <=> v92748(VarCurr,16) ) ).

tff(addAssignment_56256,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,18)
    <=> v92743(VarCurr,18) ) ).

tff(addAssignment_56255,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,18)
    <=> v92745(VarCurr,18) ) ).

tff(addAssignment_56254,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,18)
    <=> v92747(VarCurr,18) ) ).

tff(addAssignment_56253,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,18)
    <=> v92748(VarCurr,18) ) ).

tff(addAssignment_56252,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,19)
    <=> v92743(VarCurr,19) ) ).

tff(addAssignment_56251,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,19)
    <=> v92745(VarCurr,19) ) ).

tff(addAssignment_56250,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,19)
    <=> v92747(VarCurr,19) ) ).

tff(addAssignment_56249,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,19)
    <=> v92748(VarCurr,19) ) ).

tff(addAssignment_56248,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,21)
    <=> v92743(VarCurr,21) ) ).

tff(addAssignment_56247,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,21)
    <=> v92745(VarCurr,21) ) ).

tff(addAssignment_56246,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,21)
    <=> v92747(VarCurr,21) ) ).

tff(addAssignment_56245,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,21)
    <=> v92748(VarCurr,21) ) ).

tff(addAssignment_56244,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,22)
    <=> v92743(VarCurr,22) ) ).

tff(addAssignment_56243,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,22)
    <=> v92745(VarCurr,22) ) ).

tff(addAssignment_56242,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,22)
    <=> v92747(VarCurr,22) ) ).

tff(addAssignment_56241,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,22)
    <=> v92748(VarCurr,22) ) ).

tff(addAssignment_56240,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,25)
    <=> v92743(VarCurr,25) ) ).

tff(addAssignment_56239,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,25)
    <=> v92745(VarCurr,25) ) ).

tff(addAssignment_56238,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,25)
    <=> v92747(VarCurr,25) ) ).

tff(addAssignment_56237,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,25)
    <=> v92748(VarCurr,25) ) ).

tff(addAssignment_56236,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,26)
    <=> v92743(VarCurr,26) ) ).

tff(addAssignment_56235,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,26)
    <=> v92745(VarCurr,26) ) ).

tff(addAssignment_56234,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,26)
    <=> v92747(VarCurr,26) ) ).

tff(addAssignment_56233,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,26)
    <=> v92748(VarCurr,26) ) ).

tff(addAssignment_56232,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,29)
    <=> v92743(VarCurr,29) ) ).

tff(addAssignment_56231,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,29)
    <=> v92745(VarCurr,29) ) ).

tff(addAssignment_56230,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,29)
    <=> v92747(VarCurr,29) ) ).

tff(addAssignment_56229,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,29)
    <=> v92748(VarCurr,29) ) ).

tff(addAssignment_56228,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,34)
    <=> v92743(VarCurr,34) ) ).

tff(addAssignment_56227,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,34)
    <=> v92745(VarCurr,34) ) ).

tff(addAssignment_56226,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,34)
    <=> v92747(VarCurr,34) ) ).

tff(addAssignment_56225,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,34)
    <=> v92748(VarCurr,34) ) ).

tff(addAssignment_56224,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,35)
    <=> v92743(VarCurr,35) ) ).

tff(addAssignment_56223,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,35)
    <=> v92745(VarCurr,35) ) ).

tff(addAssignment_56222,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,35)
    <=> v92747(VarCurr,35) ) ).

tff(addAssignment_56221,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,35)
    <=> v92748(VarCurr,35) ) ).

tff(addAssignment_56220,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,36)
    <=> v92743(VarCurr,36) ) ).

tff(addAssignment_56219,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,36)
    <=> v92745(VarCurr,36) ) ).

tff(addAssignment_56218,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,36)
    <=> v92747(VarCurr,36) ) ).

tff(addAssignment_56217,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,36)
    <=> v92748(VarCurr,36) ) ).

tff(addAssignment_56216,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,37)
    <=> v92743(VarCurr,37) ) ).

tff(addAssignment_56215,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,37)
    <=> v92745(VarCurr,37) ) ).

tff(addAssignment_56214,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,37)
    <=> v92747(VarCurr,37) ) ).

tff(addAssignment_56213,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,37)
    <=> v92748(VarCurr,37) ) ).

tff(addAssignment_56212,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,38)
    <=> v92743(VarCurr,38) ) ).

tff(addAssignment_56211,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,38)
    <=> v92745(VarCurr,38) ) ).

tff(addAssignment_56210,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,38)
    <=> v92747(VarCurr,38) ) ).

tff(addAssignment_56209,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,38)
    <=> v92748(VarCurr,38) ) ).

tff(addAssignment_56208,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,39)
    <=> v92743(VarCurr,39) ) ).

tff(addAssignment_56207,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,39)
    <=> v92745(VarCurr,39) ) ).

tff(addAssignment_56206,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,39)
    <=> v92747(VarCurr,39) ) ).

tff(addAssignment_56205,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,39)
    <=> v92748(VarCurr,39) ) ).

tff(addAssignment_56204,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,40)
    <=> v92743(VarCurr,40) ) ).

tff(addAssignment_56203,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,40)
    <=> v92745(VarCurr,40) ) ).

tff(addAssignment_56202,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,40)
    <=> v92747(VarCurr,40) ) ).

tff(addAssignment_56201,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,40)
    <=> v92748(VarCurr,40) ) ).

tff(addAssignment_56200,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,41)
    <=> v92743(VarCurr,41) ) ).

tff(addAssignment_56199,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,41)
    <=> v92745(VarCurr,41) ) ).

tff(addAssignment_56198,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,41)
    <=> v92747(VarCurr,41) ) ).

tff(addAssignment_56197,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,41)
    <=> v92748(VarCurr,41) ) ).

tff(addAssignment_56196,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,42)
    <=> v92743(VarCurr,42) ) ).

tff(addAssignment_56195,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,42)
    <=> v92745(VarCurr,42) ) ).

tff(addAssignment_56194,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,42)
    <=> v92747(VarCurr,42) ) ).

tff(addAssignment_56193,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,42)
    <=> v92748(VarCurr,42) ) ).

tff(addAssignment_56192,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,44)
    <=> v92743(VarCurr,44) ) ).

tff(addAssignment_56191,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,44)
    <=> v92745(VarCurr,44) ) ).

tff(addAssignment_56190,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,44)
    <=> v92747(VarCurr,44) ) ).

tff(addAssignment_56189,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,44)
    <=> v92748(VarCurr,44) ) ).

tff(addAssignment_56188,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,46)
    <=> v92743(VarCurr,46) ) ).

tff(addAssignment_56187,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,46)
    <=> v92745(VarCurr,46) ) ).

tff(addAssignment_56186,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,46)
    <=> v92747(VarCurr,46) ) ).

tff(addAssignment_56185,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,46)
    <=> v92748(VarCurr,46) ) ).

tff(addAssignment_56184,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,48)
    <=> v92743(VarCurr,48) ) ).

tff(addAssignment_56183,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,48)
    <=> v92745(VarCurr,48) ) ).

tff(addAssignment_56182,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,48)
    <=> v92747(VarCurr,48) ) ).

tff(addAssignment_56181,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,48)
    <=> v92748(VarCurr,48) ) ).

tff(addAssignment_56180,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,49)
    <=> v92743(VarCurr,49) ) ).

tff(addAssignment_56179,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,49)
    <=> v92745(VarCurr,49) ) ).

tff(addAssignment_56178,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,49)
    <=> v92747(VarCurr,49) ) ).

tff(addAssignment_56177,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,49)
    <=> v92748(VarCurr,49) ) ).

tff(addAssignment_56176,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,52)
    <=> v92743(VarCurr,52) ) ).

tff(addAssignment_56175,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,52)
    <=> v92745(VarCurr,52) ) ).

tff(addAssignment_56174,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,52)
    <=> v92747(VarCurr,52) ) ).

tff(addAssignment_56173,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,52)
    <=> v92748(VarCurr,52) ) ).

tff(addAssignment_56172,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,53)
    <=> v92743(VarCurr,53) ) ).

tff(addAssignment_56171,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,53)
    <=> v92745(VarCurr,53) ) ).

tff(addAssignment_56170,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,53)
    <=> v92747(VarCurr,53) ) ).

tff(addAssignment_56169,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,53)
    <=> v92748(VarCurr,53) ) ).

tff(addAssignment_56168,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,54)
    <=> v92743(VarCurr,54) ) ).

tff(addAssignment_56167,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,54)
    <=> v92745(VarCurr,54) ) ).

tff(addAssignment_56166,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,54)
    <=> v92747(VarCurr,54) ) ).

tff(addAssignment_56165,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,54)
    <=> v92748(VarCurr,54) ) ).

tff(addAssignment_56164,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,55)
    <=> v92743(VarCurr,55) ) ).

tff(addAssignment_56163,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,55)
    <=> v92745(VarCurr,55) ) ).

tff(addAssignment_56162,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,55)
    <=> v92747(VarCurr,55) ) ).

tff(addAssignment_56161,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,55)
    <=> v92748(VarCurr,55) ) ).

tff(addAssignment_56160,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,56)
    <=> v92743(VarCurr,56) ) ).

tff(addAssignment_56159,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,56)
    <=> v92745(VarCurr,56) ) ).

tff(addAssignment_56158,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,56)
    <=> v92747(VarCurr,56) ) ).

tff(addAssignment_56157,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,56)
    <=> v92748(VarCurr,56) ) ).

tff(addAssignment_56156,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,58)
    <=> v92743(VarCurr,58) ) ).

tff(addAssignment_56155,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,58)
    <=> v92745(VarCurr,58) ) ).

tff(addAssignment_56154,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,58)
    <=> v92747(VarCurr,58) ) ).

tff(addAssignment_56153,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,58)
    <=> v92748(VarCurr,58) ) ).

tff(addAssignment_56152,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,63)
    <=> v92743(VarCurr,63) ) ).

tff(addAssignment_56151,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,63)
    <=> v92745(VarCurr,63) ) ).

tff(addAssignment_56150,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,63)
    <=> v92747(VarCurr,63) ) ).

tff(addAssignment_56149,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,63)
    <=> v92748(VarCurr,63) ) ).

tff(addAssignment_56148,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,66)
    <=> v92743(VarCurr,66) ) ).

tff(addAssignment_56147,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,66)
    <=> v92745(VarCurr,66) ) ).

tff(addAssignment_56146,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,66)
    <=> v92747(VarCurr,66) ) ).

tff(addAssignment_56145,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,66)
    <=> v92748(VarCurr,66) ) ).

tff(addAssignment_56144,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,67)
    <=> v92743(VarCurr,67) ) ).

tff(addAssignment_56143,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,67)
    <=> v92745(VarCurr,67) ) ).

tff(addAssignment_56142,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,67)
    <=> v92747(VarCurr,67) ) ).

tff(addAssignment_56141,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,67)
    <=> v92748(VarCurr,67) ) ).

tff(addAssignment_56140,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,68)
    <=> v92743(VarCurr,68) ) ).

tff(addAssignment_56139,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,68)
    <=> v92745(VarCurr,68) ) ).

tff(addAssignment_56138,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,68)
    <=> v92747(VarCurr,68) ) ).

tff(addAssignment_56137,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,68)
    <=> v92748(VarCurr,68) ) ).

tff(addAssignment_56136,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,70)
    <=> v92743(VarCurr,70) ) ).

tff(addAssignment_56135,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,70)
    <=> v92745(VarCurr,70) ) ).

tff(addAssignment_56134,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,70)
    <=> v92747(VarCurr,70) ) ).

tff(addAssignment_56133,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,70)
    <=> v92748(VarCurr,70) ) ).

tff(addAssignment_56132,axiom,
    ! [VarCurr: state_type] :
      ( v92741(VarCurr,71)
    <=> v92743(VarCurr,71) ) ).

tff(addAssignment_56131,axiom,
    ! [VarCurr: state_type] :
      ( v92743(VarCurr,71)
    <=> v92745(VarCurr,71) ) ).

tff(addAssignment_56130,axiom,
    ! [VarCurr: state_type] :
      ( v92745(VarCurr,71)
    <=> v92747(VarCurr,71) ) ).

tff(addAssignment_56129,axiom,
    ! [VarCurr: state_type] :
      ( v92747(VarCurr,71)
    <=> v92748(VarCurr,71) ) ).

tff(addAssignment_56128,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,0)
    <=> v52332(VarCurr,0) ) ).

tff(addAssignment_56127,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,1)
    <=> v52332(VarCurr,6) ) ).

tff(addAssignment_56126,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,2)
    <=> v52332(VarCurr,12) ) ).

tff(addAssignment_56125,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,3)
    <=> v52332(VarCurr,18) ) ).

tff(addAssignment_56124,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,4)
    <=> v52332(VarCurr,24) ) ).

tff(addAssignment_56123,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,5)
    <=> v52332(VarCurr,30) ) ).

tff(addAssignment_56122,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,6)
    <=> v52332(VarCurr,36) ) ).

tff(addAssignment_56121,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,7)
    <=> v52332(VarCurr,42) ) ).

tff(addAssignment_56120,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,8)
    <=> v52332(VarCurr,48) ) ).

tff(addAssignment_56119,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,9)
    <=> v52332(VarCurr,54) ) ).

tff(addAssignment_56118,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,10)
    <=> v52332(VarCurr,60) ) ).

tff(addAssignment_56117,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,11)
    <=> v52332(VarCurr,66) ) ).

tff(addAssignment_56116,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,12)
    <=> v52332(VarCurr,67) ) ).

tff(addAssignment_56115,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,13)
    <=> v52332(VarCurr,61) ) ).

tff(addAssignment_56114,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,14)
    <=> v52332(VarCurr,55) ) ).

tff(addAssignment_56113,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,15)
    <=> v52332(VarCurr,49) ) ).

tff(addAssignment_56112,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,16)
    <=> v52332(VarCurr,43) ) ).

tff(addAssignment_56111,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,17)
    <=> v52332(VarCurr,37) ) ).

tff(addAssignment_56110,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,18)
    <=> v52332(VarCurr,31) ) ).

tff(addAssignment_56109,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,19)
    <=> v52332(VarCurr,25) ) ).

tff(addAssignment_56108,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,20)
    <=> v52332(VarCurr,19) ) ).

tff(addAssignment_56107,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,21)
    <=> v52332(VarCurr,13) ) ).

tff(addAssignment_56106,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,22)
    <=> v52332(VarCurr,7) ) ).

tff(addAssignment_56105,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,23)
    <=> v52332(VarCurr,1) ) ).

tff(addAssignment_56104,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,24)
    <=> v52332(VarCurr,2) ) ).

tff(addAssignment_56103,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,25)
    <=> v52332(VarCurr,8) ) ).

tff(addAssignment_56102,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,26)
    <=> v52332(VarCurr,14) ) ).

tff(addAssignment_56101,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,27)
    <=> v52332(VarCurr,20) ) ).

tff(addAssignment_56100,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,28)
    <=> v52332(VarCurr,26) ) ).

tff(addAssignment_56099,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,29)
    <=> v52332(VarCurr,32) ) ).

tff(addAssignment_56098,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,30)
    <=> v52332(VarCurr,38) ) ).

tff(addAssignment_56097,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,31)
    <=> v52332(VarCurr,44) ) ).

tff(addAssignment_56096,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,32)
    <=> v52332(VarCurr,50) ) ).

tff(addAssignment_56095,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,33)
    <=> v52332(VarCurr,56) ) ).

tff(addAssignment_56094,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,34)
    <=> v52332(VarCurr,62) ) ).

tff(addAssignment_56093,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,35)
    <=> v52332(VarCurr,68) ) ).

tff(addAssignment_56092,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,36)
    <=> v52332(VarCurr,69) ) ).

tff(addAssignment_56091,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,37)
    <=> v52332(VarCurr,63) ) ).

tff(addAssignment_56090,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,38)
    <=> v52332(VarCurr,57) ) ).

tff(addAssignment_56089,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,39)
    <=> v52332(VarCurr,51) ) ).

tff(addAssignment_56088,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,40)
    <=> v52332(VarCurr,45) ) ).

tff(addAssignment_56087,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,41)
    <=> v52332(VarCurr,39) ) ).

tff(addAssignment_56086,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,42)
    <=> v52332(VarCurr,33) ) ).

tff(addAssignment_56085,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,43)
    <=> v52332(VarCurr,27) ) ).

tff(addAssignment_56084,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,44)
    <=> v52332(VarCurr,21) ) ).

tff(addAssignment_56083,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,45)
    <=> v52332(VarCurr,15) ) ).

tff(addAssignment_56082,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,46)
    <=> v52332(VarCurr,9) ) ).

tff(addAssignment_56081,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,47)
    <=> v52332(VarCurr,3) ) ).

tff(addAssignment_56080,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,48)
    <=> v52332(VarCurr,4) ) ).

tff(addAssignment_56079,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,49)
    <=> v52332(VarCurr,10) ) ).

tff(addAssignment_56078,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,50)
    <=> v52332(VarCurr,16) ) ).

tff(addAssignment_56077,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,51)
    <=> v52332(VarCurr,22) ) ).

tff(addAssignment_56076,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,52)
    <=> v52332(VarCurr,28) ) ).

tff(addAssignment_56075,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,53)
    <=> v52332(VarCurr,34) ) ).

tff(addAssignment_56074,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,54)
    <=> v52332(VarCurr,40) ) ).

tff(addAssignment_56073,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,55)
    <=> v52332(VarCurr,46) ) ).

tff(addAssignment_56072,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,56)
    <=> v52332(VarCurr,52) ) ).

tff(addAssignment_56071,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,57)
    <=> v52332(VarCurr,58) ) ).

tff(addAssignment_56070,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,58)
    <=> v52332(VarCurr,64) ) ).

tff(addAssignment_56069,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,59)
    <=> v52332(VarCurr,70) ) ).

tff(addAssignment_56068,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,60)
    <=> v52332(VarCurr,71) ) ).

tff(addAssignment_56067,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,61)
    <=> v52332(VarCurr,65) ) ).

tff(addAssignment_56066,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,62)
    <=> v52332(VarCurr,59) ) ).

tff(addAssignment_56065,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,63)
    <=> v52332(VarCurr,53) ) ).

tff(addAssignment_56064,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,64)
    <=> v52332(VarCurr,47) ) ).

tff(addAssignment_56063,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,65)
    <=> v52332(VarCurr,41) ) ).

tff(addAssignment_56062,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,66)
    <=> v52332(VarCurr,35) ) ).

tff(addAssignment_56061,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,67)
    <=> v52332(VarCurr,29) ) ).

tff(addAssignment_56060,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,68)
    <=> v52332(VarCurr,23) ) ).

tff(addAssignment_56059,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,69)
    <=> v52332(VarCurr,17) ) ).

tff(addAssignment_56058,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,70)
    <=> v52332(VarCurr,11) ) ).

tff(addAssignment_56057,axiom,
    ! [VarCurr: state_type] :
      ( v92748(VarCurr,71)
    <=> v52332(VarCurr,5) ) ).

tff(addAssignment_56056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92652(VarCurr,B)
      <=> v92654(VarCurr,B) ) ) ).

tff(addAssignment_56055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92654(VarCurr,B)
      <=> v92656(VarCurr,B) ) ) ).

tff(addAssignment_56054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92656(VarCurr,B)
      <=> v92658(VarCurr,B) ) ) ).

tff(addAssignment_56053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92658(VarCurr,B)
      <=> v92660(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92660(VarCurr,B)
      <=> ( v92712(VarCurr,B)
          | v92715(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92715(VarCurr,B)
      <=> ( v92691(VarCurr,B)
          & v92716(VarCurr,B) ) ) ) ).

tff(addAssignment_56052,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,0)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56051,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,1)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56050,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,2)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56049,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,3)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56048,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,4)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56047,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,5)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56046,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,6)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56045,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,7)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56044,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,8)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56043,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,9)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56042,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,10)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56041,axiom,
    ! [VarCurr: state_type] :
      ( v92716(VarCurr,11)
    <=> v92717(VarCurr) ) ).

tff(addAssignment_56040,axiom,
    ! [VarCurr: state_type] :
      ( v92717(VarCurr)
    <=> v92698(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92712(VarCurr,B)
      <=> ( v92662(VarCurr,B)
          & v92713(VarCurr,B) ) ) ) ).

tff(addAssignment_56039,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,0)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56038,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,1)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56037,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,2)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56036,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,3)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56035,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,4)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56034,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,5)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56033,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,6)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56032,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,7)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56031,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,8)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56030,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,9)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56029,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,10)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56028,axiom,
    ! [VarCurr: state_type] :
      ( v92713(VarCurr,11)
    <=> v92714(VarCurr) ) ).

tff(addAssignment_56027,axiom,
    ! [VarCurr: state_type] :
      ( v92714(VarCurr)
    <=> v92669(VarCurr) ) ).

tff(addAssignment_56026,axiom,
    ! [VarCurr: state_type] :
      ( v92698(VarCurr)
    <=> v92700(VarCurr) ) ).

tff(addAssignment_56025,axiom,
    ! [VarCurr: state_type] :
      ( v92700(VarCurr)
    <=> v92702(VarCurr) ) ).

tff(addAssignment_56024,axiom,
    ! [VarCurr: state_type] :
      ( v92702(VarCurr)
    <=> v92704(VarCurr) ) ).

tff(addAssignment_56023,axiom,
    ! [VarCurr: state_type] :
      ( v92704(VarCurr)
    <=> v92706(VarCurr) ) ).

tff(addAssignment_56022,axiom,
    ! [VarCurr: state_type] :
      ( v92706(VarCurr)
    <=> v92708(VarCurr) ) ).

tff(addAssignment_56021,axiom,
    ! [VarCurr: state_type] :
      ( v92708(VarCurr)
    <=> v92710(VarCurr) ) ).

tff(addAssignment_56020,axiom,
    ! [VarCurr: state_type] :
      ( v92710(VarCurr)
    <=> v92685(VarCurr) ) ).

tff(addAssignment_56019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92691(VarCurr,B)
      <=> v92693(VarCurr,B) ) ) ).

tff(addAssignment_56018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92693(VarCurr,B)
      <=> v92695(VarCurr,B) ) ) ).

tff(addAssignment_56017,axiom,
    ! [VarCurr: state_type] :
      ( ( v92695(VarCurr,5)
      <=> v52334(VarCurr,149) )
      & ( v92695(VarCurr,4)
      <=> v52334(VarCurr,148) )
      & ( v92695(VarCurr,3)
      <=> v52334(VarCurr,147) )
      & ( v92695(VarCurr,2)
      <=> v52334(VarCurr,146) )
      & ( v92695(VarCurr,1)
      <=> v52334(VarCurr,145) )
      & ( v92695(VarCurr,0)
      <=> v52334(VarCurr,144) ) ) ).

tff(addAssignment_56016,axiom,
    ! [VarCurr: state_type] :
      ( ( v92695(VarCurr,11)
      <=> $false )
      & ( v92695(VarCurr,10)
      <=> $false )
      & ( v92695(VarCurr,9)
      <=> $false )
      & ( v92695(VarCurr,8)
      <=> $false )
      & ( v92695(VarCurr,7)
      <=> $false )
      & ( v92695(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_56015,axiom,
    ! [VarCurr: state_type] :
      ( v92669(VarCurr)
    <=> v92671(VarCurr) ) ).

tff(addAssignment_56014,axiom,
    ! [VarCurr: state_type] :
      ( v92671(VarCurr)
    <=> v92673(VarCurr) ) ).

tff(addAssignment_56013,axiom,
    ! [VarCurr: state_type] :
      ( v92673(VarCurr)
    <=> v92675(VarCurr) ) ).

tff(addAssignment_56012,axiom,
    ! [VarCurr: state_type] :
      ( v92675(VarCurr)
    <=> v92677(VarCurr) ) ).

tff(addAssignment_56011,axiom,
    ! [VarCurr: state_type] :
      ( v92677(VarCurr)
    <=> v92679(VarCurr) ) ).

tff(addAssignment_56010,axiom,
    ! [VarCurr: state_type] :
      ( v92679(VarCurr)
    <=> v92681(VarCurr) ) ).

tff(addAssignment_56009,axiom,
    ! [VarCurr: state_type] :
      ( v92681(VarCurr)
    <=> v92683(VarCurr) ) ).

tff(writeUnaryOperator_4295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v92683(VarCurr)
    <=> v92685(VarCurr) ) ).

tff(writeUnaryOperator_4294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v92685(VarCurr)
    <=> v92688(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_2291,axiom,
    ! [VarCurr: state_type] :
      ( v92688(VarCurr)
    <=> ( v6625(VarCurr,11)
        & v9552(VarCurr) ) ) ).

tff(addAssignment_56008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92662(VarCurr,B)
      <=> v92664(VarCurr,B) ) ) ).

tff(addAssignment_56007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92664(VarCurr,B)
      <=> v92666(VarCurr,B) ) ) ).

tff(addAssignment_56006,axiom,
    ! [VarCurr: state_type] :
      ( ( v92666(VarCurr,5)
      <=> v52334(VarCurr,161) )
      & ( v92666(VarCurr,4)
      <=> v52334(VarCurr,160) )
      & ( v92666(VarCurr,3)
      <=> v52334(VarCurr,159) )
      & ( v92666(VarCurr,2)
      <=> v52334(VarCurr,158) )
      & ( v92666(VarCurr,1)
      <=> v52334(VarCurr,157) )
      & ( v92666(VarCurr,0)
      <=> v52334(VarCurr,156) ) ) ).

tff(addAssignment_56005,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,6)
    <=> v52334(VarCurr,149) ) ).

tff(addAssignment_56004,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,7)
    <=> v52334(VarCurr,148) ) ).

tff(addAssignment_56003,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,8)
    <=> v52334(VarCurr,147) ) ).

tff(addAssignment_56002,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,9)
    <=> v52334(VarCurr,146) ) ).

tff(addAssignment_56001,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,10)
    <=> v52334(VarCurr,145) ) ).

tff(addAssignment_56000,axiom,
    ! [VarCurr: state_type] :
      ( v92666(VarCurr,11)
    <=> v52334(VarCurr,144) ) ).

tff(addAssignment_55999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,162)
        & ~ $less(B,156) )
     => ( v52334(VarCurr,B)
      <=> v33839(VarCurr,B) ) ) ).

tff(addAssignment_55998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,162)
        & ~ $less(B,156) )
     => ( v33839(VarCurr,B)
      <=> v33841(VarCurr,B) ) ) ).

tff(addAssignment_55997,axiom,
    ! [VarCurr: state_type] :
      ( ( v33841(VarCurr,161)
      <=> v29655(VarCurr,5) )
      & ( v33841(VarCurr,160)
      <=> v29655(VarCurr,4) )
      & ( v33841(VarCurr,159)
      <=> v29655(VarCurr,3) )
      & ( v33841(VarCurr,158)
      <=> v29655(VarCurr,2) )
      & ( v33841(VarCurr,157)
      <=> v29655(VarCurr,1) )
      & ( v33841(VarCurr,156)
      <=> v29655(VarCurr,0) ) ) ).

tff(addAssignment_55996,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,149)
    <=> v33839(VarCurr,149) ) ).

tff(addAssignment_55995,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,149)
    <=> v33841(VarCurr,149) ) ).

tff(addAssignment_55994,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,149)
    <=> v28105(VarCurr,5) ) ).

tff(addAssignment_55993,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,148)
    <=> v33839(VarCurr,148) ) ).

tff(addAssignment_55992,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,148)
    <=> v33841(VarCurr,148) ) ).

tff(addAssignment_55991,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,148)
    <=> v28105(VarCurr,4) ) ).

tff(addAssignment_55990,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,147)
    <=> v33839(VarCurr,147) ) ).

tff(addAssignment_55989,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,147)
    <=> v33841(VarCurr,147) ) ).

tff(addAssignment_55988,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,147)
    <=> v28105(VarCurr,3) ) ).

tff(addAssignment_55987,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,146)
    <=> v33839(VarCurr,146) ) ).

tff(addAssignment_55986,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,146)
    <=> v33841(VarCurr,146) ) ).

tff(addAssignment_55985,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,146)
    <=> v28105(VarCurr,2) ) ).

tff(addAssignment_55984,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,145)
    <=> v33839(VarCurr,145) ) ).

tff(addAssignment_55983,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,145)
    <=> v33841(VarCurr,145) ) ).

tff(addAssignment_55982,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,145)
    <=> v28105(VarCurr,1) ) ).

tff(addAssignment_55981,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,144)
    <=> v33839(VarCurr,144) ) ).

tff(addAssignment_55980,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,144)
    <=> v33841(VarCurr,144) ) ).

tff(addAssignment_55979,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,144)
    <=> v28105(VarCurr,0) ) ).

tff(addAssignment_55978,axiom,
    ! [VarCurr: state_type] :
      ( v91825(VarCurr)
    <=> v91827(VarCurr) ) ).

tff(addAssignment_55977,axiom,
    ! [VarCurr: state_type] :
      ( v91827(VarCurr)
    <=> v91829(VarCurr) ) ).

tff(addAssignment_55976,axiom,
    ! [VarCurr: state_type] :
      ( v91829(VarCurr)
    <=> v91831(VarCurr) ) ).

tff(addAssignment_55975,axiom,
    ! [VarCurr: state_type] :
      ( v91831(VarCurr)
    <=> v91833(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_487,axiom,
    ! [VarCurr: state_type] :
      ( v91833(VarCurr)
    <=> ( ( v91835(VarCurr,11)
        <=> v91886(VarCurr,11) )
        & ( v91835(VarCurr,10)
        <=> v91886(VarCurr,10) )
        & ( v91835(VarCurr,9)
        <=> v91886(VarCurr,9) )
        & ( v91835(VarCurr,8)
        <=> v91886(VarCurr,8) )
        & ( v91835(VarCurr,7)
        <=> v91886(VarCurr,7) )
        & ( v91835(VarCurr,6)
        <=> v91886(VarCurr,6) )
        & ( v91835(VarCurr,5)
        <=> v91886(VarCurr,5) )
        & ( v91835(VarCurr,4)
        <=> v91886(VarCurr,4) )
        & ( v91835(VarCurr,3)
        <=> v91886(VarCurr,3) )
        & ( v91835(VarCurr,2)
        <=> v91886(VarCurr,2) )
        & ( v91835(VarCurr,1)
        <=> v91886(VarCurr,1) )
        & ( v91835(VarCurr,0)
        <=> v91886(VarCurr,0) ) ) ) ).

tff(addAssignment_55974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91886(VarCurr,B)
      <=> v91888(VarCurr,B) ) ) ).

tff(addAssignment_55973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91888(VarCurr,B)
      <=> v91890(VarCurr,B) ) ) ).

tff(addAssignment_55972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91890(VarCurr,B)
      <=> v91892(VarCurr,B) ) ) ).

tff(addAssignment_55971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91892(VarCurr,B)
      <=> v91894(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91894(VarCurr,B)
      <=> ( v92634(VarCurr,B)
          | v92637(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92637(VarCurr,B)
      <=> ( v92391(VarCurr,B)
          & v92638(VarCurr,B) ) ) ) ).

tff(addAssignment_55970,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,0)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55969,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,1)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55968,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,2)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55967,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,3)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55966,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,4)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55965,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,5)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55964,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,6)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55963,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,7)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55962,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,8)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55961,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,9)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55960,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,10)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55959,axiom,
    ! [VarCurr: state_type] :
      ( v92638(VarCurr,11)
    <=> v92639(VarCurr) ) ).

tff(addAssignment_55958,axiom,
    ! [VarCurr: state_type] :
      ( v92639(VarCurr)
    <=> v92624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92634(VarCurr,B)
      <=> ( v91896(VarCurr,B)
          & v92635(VarCurr,B) ) ) ) ).

tff(addAssignment_55957,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,0)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55956,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,1)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55955,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,2)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55954,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,3)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55953,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,4)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55952,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,5)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55951,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,6)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55950,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,7)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55949,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,8)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55948,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,9)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55947,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,10)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55946,axiom,
    ! [VarCurr: state_type] :
      ( v92635(VarCurr,11)
    <=> v92636(VarCurr) ) ).

tff(addAssignment_55945,axiom,
    ! [VarCurr: state_type] :
      ( v92636(VarCurr)
    <=> v92381(VarCurr) ) ).

tff(addAssignment_55944,axiom,
    ! [VarCurr: state_type] :
      ( v92624(VarCurr)
    <=> v92626(VarCurr) ) ).

tff(addAssignment_55943,axiom,
    ! [VarCurr: state_type] :
      ( v92626(VarCurr)
    <=> v92628(VarCurr) ) ).

tff(addAssignment_55942,axiom,
    ! [VarCurr: state_type] :
      ( v92628(VarCurr)
    <=> v92630(VarCurr) ) ).

tff(addAssignment_55941,axiom,
    ! [VarCurr: state_type] :
      ( v92630(VarCurr)
    <=> v92632(VarCurr) ) ).

tff(addAssignment_55940,axiom,
    ! [VarCurr: state_type] :
      ( v92632(VarCurr)
    <=> v91058(VarCurr) ) ).

tff(addAssignment_55939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v92391(VarCurr,B)
      <=> v92393(VarCurr,B) ) ) ).

tff(addAssignment_55938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v92393(VarCurr,B)
      <=> v92395(VarCurr,B) ) ) ).

tff(addAssignment_55937,axiom,
    ! [VarCurr: state_type] :
      ( ( v92393(VarCurr,11)
      <=> $false )
      & ( v92393(VarCurr,10)
      <=> $false )
      & ( v92393(VarCurr,9)
      <=> $false )
      & ( v92393(VarCurr,8)
      <=> $false )
      & ( v92393(VarCurr,7)
      <=> $false )
      & ( v92393(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_55936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v92395(VarCurr,B)
      <=> v92397(VarCurr,B) ) ) ).

tff(addAssignment_55935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v92397(VarCurr,B)
      <=> v92399(VarCurr,B) ) ) ).

tff(addAssignment_55934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v92399(VarCurr,B)
      <=> v92401(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2290,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,5)
    <=> ( v92587(VarCurr)
      <~> v92403(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2289,axiom,
    ! [VarCurr: state_type] :
      ( v92587(VarCurr)
    <=> ( v92588(VarCurr)
      <~> v92403(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2288,axiom,
    ! [VarCurr: state_type] :
      ( v92588(VarCurr)
    <=> ( v92589(VarCurr)
      <~> v92403(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2287,axiom,
    ! [VarCurr: state_type] :
      ( v92589(VarCurr)
    <=> ( v92590(VarCurr)
      <~> v92403(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2286,axiom,
    ! [VarCurr: state_type] :
      ( v92590(VarCurr)
    <=> ( v92591(VarCurr)
      <~> v92403(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2285,axiom,
    ! [VarCurr: state_type] :
      ( v92591(VarCurr)
    <=> ( v92592(VarCurr)
      <~> v92403(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2284,axiom,
    ! [VarCurr: state_type] :
      ( v92592(VarCurr)
    <=> ( v92593(VarCurr)
      <~> v92403(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2283,axiom,
    ! [VarCurr: state_type] :
      ( v92593(VarCurr)
    <=> ( v92594(VarCurr)
      <~> v92403(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2282,axiom,
    ! [VarCurr: state_type] :
      ( v92594(VarCurr)
    <=> ( v92595(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2281,axiom,
    ! [VarCurr: state_type] :
      ( v92595(VarCurr)
    <=> ( v92596(VarCurr)
      <~> v92403(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2280,axiom,
    ! [VarCurr: state_type] :
      ( v92596(VarCurr)
    <=> ( v92597(VarCurr)
      <~> v92403(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2279,axiom,
    ! [VarCurr: state_type] :
      ( v92597(VarCurr)
    <=> ( v92598(VarCurr)
      <~> v92403(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2278,axiom,
    ! [VarCurr: state_type] :
      ( v92598(VarCurr)
    <=> ( v92599(VarCurr)
      <~> v92403(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2277,axiom,
    ! [VarCurr: state_type] :
      ( v92599(VarCurr)
    <=> ( v92600(VarCurr)
      <~> v92403(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2276,axiom,
    ! [VarCurr: state_type] :
      ( v92600(VarCurr)
    <=> ( v92601(VarCurr)
      <~> v92403(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2275,axiom,
    ! [VarCurr: state_type] :
      ( v92601(VarCurr)
    <=> ( v92602(VarCurr)
      <~> v92403(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2274,axiom,
    ! [VarCurr: state_type] :
      ( v92602(VarCurr)
    <=> ( v92603(VarCurr)
      <~> v92403(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2273,axiom,
    ! [VarCurr: state_type] :
      ( v92603(VarCurr)
    <=> ( v92604(VarCurr)
      <~> v92403(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2272,axiom,
    ! [VarCurr: state_type] :
      ( v92604(VarCurr)
    <=> ( v92605(VarCurr)
      <~> v92403(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2271,axiom,
    ! [VarCurr: state_type] :
      ( v92605(VarCurr)
    <=> ( v92606(VarCurr)
      <~> v92403(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2270,axiom,
    ! [VarCurr: state_type] :
      ( v92606(VarCurr)
    <=> ( v92607(VarCurr)
      <~> v92403(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2269,axiom,
    ! [VarCurr: state_type] :
      ( v92607(VarCurr)
    <=> ( v92608(VarCurr)
      <~> v92403(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2268,axiom,
    ! [VarCurr: state_type] :
      ( v92608(VarCurr)
    <=> ( v92609(VarCurr)
      <~> v92403(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2267,axiom,
    ! [VarCurr: state_type] :
      ( v92609(VarCurr)
    <=> ( v92610(VarCurr)
      <~> v92403(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2266,axiom,
    ! [VarCurr: state_type] :
      ( v92610(VarCurr)
    <=> ( v92611(VarCurr)
      <~> v92403(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2265,axiom,
    ! [VarCurr: state_type] :
      ( v92611(VarCurr)
    <=> ( v92612(VarCurr)
      <~> v92403(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2264,axiom,
    ! [VarCurr: state_type] :
      ( v92612(VarCurr)
    <=> ( v92613(VarCurr)
      <~> v92403(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2263,axiom,
    ! [VarCurr: state_type] :
      ( v92613(VarCurr)
    <=> ( v92614(VarCurr)
      <~> v92403(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2262,axiom,
    ! [VarCurr: state_type] :
      ( v92614(VarCurr)
    <=> ( v92615(VarCurr)
      <~> v92403(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2261,axiom,
    ! [VarCurr: state_type] :
      ( v92615(VarCurr)
    <=> ( v92616(VarCurr)
      <~> v92403(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2260,axiom,
    ! [VarCurr: state_type] :
      ( v92616(VarCurr)
    <=> ( v92617(VarCurr)
      <~> v92403(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2259,axiom,
    ! [VarCurr: state_type] :
      ( v92617(VarCurr)
    <=> ( v92618(VarCurr)
      <~> v92403(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2258,axiom,
    ! [VarCurr: state_type] :
      ( v92618(VarCurr)
    <=> ( v92619(VarCurr)
      <~> v92403(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2257,axiom,
    ! [VarCurr: state_type] :
      ( v92619(VarCurr)
    <=> ( v92620(VarCurr)
      <~> v92403(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2256,axiom,
    ! [VarCurr: state_type] :
      ( v92620(VarCurr)
    <=> ( v92621(VarCurr)
      <~> v92403(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2255,axiom,
    ! [VarCurr: state_type] :
      ( v92621(VarCurr)
    <=> ( v92403(VarCurr,71)
      <~> v92403(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2254,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,4)
    <=> ( v92551(VarCurr)
      <~> v92403(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2253,axiom,
    ! [VarCurr: state_type] :
      ( v92551(VarCurr)
    <=> ( v92552(VarCurr)
      <~> v92403(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2252,axiom,
    ! [VarCurr: state_type] :
      ( v92552(VarCurr)
    <=> ( v92553(VarCurr)
      <~> v92403(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2251,axiom,
    ! [VarCurr: state_type] :
      ( v92553(VarCurr)
    <=> ( v92554(VarCurr)
      <~> v92403(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2250,axiom,
    ! [VarCurr: state_type] :
      ( v92554(VarCurr)
    <=> ( v92555(VarCurr)
      <~> v92403(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2249,axiom,
    ! [VarCurr: state_type] :
      ( v92555(VarCurr)
    <=> ( v92556(VarCurr)
      <~> v92403(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2248,axiom,
    ! [VarCurr: state_type] :
      ( v92556(VarCurr)
    <=> ( v92557(VarCurr)
      <~> v92403(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2247,axiom,
    ! [VarCurr: state_type] :
      ( v92557(VarCurr)
    <=> ( v92558(VarCurr)
      <~> v92403(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2246,axiom,
    ! [VarCurr: state_type] :
      ( v92558(VarCurr)
    <=> ( v92559(VarCurr)
      <~> v92403(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2245,axiom,
    ! [VarCurr: state_type] :
      ( v92559(VarCurr)
    <=> ( v92560(VarCurr)
      <~> v92403(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2244,axiom,
    ! [VarCurr: state_type] :
      ( v92560(VarCurr)
    <=> ( v92561(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2243,axiom,
    ! [VarCurr: state_type] :
      ( v92561(VarCurr)
    <=> ( v92562(VarCurr)
      <~> v92403(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2242,axiom,
    ! [VarCurr: state_type] :
      ( v92562(VarCurr)
    <=> ( v92563(VarCurr)
      <~> v92403(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2241,axiom,
    ! [VarCurr: state_type] :
      ( v92563(VarCurr)
    <=> ( v92564(VarCurr)
      <~> v92403(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2240,axiom,
    ! [VarCurr: state_type] :
      ( v92564(VarCurr)
    <=> ( v92565(VarCurr)
      <~> v92403(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2239,axiom,
    ! [VarCurr: state_type] :
      ( v92565(VarCurr)
    <=> ( v92566(VarCurr)
      <~> v92403(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2238,axiom,
    ! [VarCurr: state_type] :
      ( v92566(VarCurr)
    <=> ( v92567(VarCurr)
      <~> v92403(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2237,axiom,
    ! [VarCurr: state_type] :
      ( v92567(VarCurr)
    <=> ( v92568(VarCurr)
      <~> v92403(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2236,axiom,
    ! [VarCurr: state_type] :
      ( v92568(VarCurr)
    <=> ( v92569(VarCurr)
      <~> v92403(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2235,axiom,
    ! [VarCurr: state_type] :
      ( v92569(VarCurr)
    <=> ( v92570(VarCurr)
      <~> v92403(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2234,axiom,
    ! [VarCurr: state_type] :
      ( v92570(VarCurr)
    <=> ( v92571(VarCurr)
      <~> v92403(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2233,axiom,
    ! [VarCurr: state_type] :
      ( v92571(VarCurr)
    <=> ( v92572(VarCurr)
      <~> v92403(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2232,axiom,
    ! [VarCurr: state_type] :
      ( v92572(VarCurr)
    <=> ( v92573(VarCurr)
      <~> v92403(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2231,axiom,
    ! [VarCurr: state_type] :
      ( v92573(VarCurr)
    <=> ( v92574(VarCurr)
      <~> v92403(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2230,axiom,
    ! [VarCurr: state_type] :
      ( v92574(VarCurr)
    <=> ( v92575(VarCurr)
      <~> v92403(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2229,axiom,
    ! [VarCurr: state_type] :
      ( v92575(VarCurr)
    <=> ( v92576(VarCurr)
      <~> v92403(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2228,axiom,
    ! [VarCurr: state_type] :
      ( v92576(VarCurr)
    <=> ( v92577(VarCurr)
      <~> v92403(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2227,axiom,
    ! [VarCurr: state_type] :
      ( v92577(VarCurr)
    <=> ( v92578(VarCurr)
      <~> v92403(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2226,axiom,
    ! [VarCurr: state_type] :
      ( v92578(VarCurr)
    <=> ( v92579(VarCurr)
      <~> v92403(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2225,axiom,
    ! [VarCurr: state_type] :
      ( v92579(VarCurr)
    <=> ( v92580(VarCurr)
      <~> v92403(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2224,axiom,
    ! [VarCurr: state_type] :
      ( v92580(VarCurr)
    <=> ( v92581(VarCurr)
      <~> v92403(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2223,axiom,
    ! [VarCurr: state_type] :
      ( v92581(VarCurr)
    <=> ( v92582(VarCurr)
      <~> v92403(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2222,axiom,
    ! [VarCurr: state_type] :
      ( v92582(VarCurr)
    <=> ( v92583(VarCurr)
      <~> v92403(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2221,axiom,
    ! [VarCurr: state_type] :
      ( v92583(VarCurr)
    <=> ( v92584(VarCurr)
      <~> v92403(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2220,axiom,
    ! [VarCurr: state_type] :
      ( v92584(VarCurr)
    <=> ( v92585(VarCurr)
      <~> v92403(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2219,axiom,
    ! [VarCurr: state_type] :
      ( v92585(VarCurr)
    <=> ( v92403(VarCurr,71)
      <~> v92403(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2218,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,3)
    <=> ( v92514(VarCurr)
      <~> v92403(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2217,axiom,
    ! [VarCurr: state_type] :
      ( v92514(VarCurr)
    <=> ( v92515(VarCurr)
      <~> v92403(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2216,axiom,
    ! [VarCurr: state_type] :
      ( v92515(VarCurr)
    <=> ( v92516(VarCurr)
      <~> v92403(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2215,axiom,
    ! [VarCurr: state_type] :
      ( v92516(VarCurr)
    <=> ( v92517(VarCurr)
      <~> v92403(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2214,axiom,
    ! [VarCurr: state_type] :
      ( v92517(VarCurr)
    <=> ( v92518(VarCurr)
      <~> v92403(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2213,axiom,
    ! [VarCurr: state_type] :
      ( v92518(VarCurr)
    <=> ( v92519(VarCurr)
      <~> v92403(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2212,axiom,
    ! [VarCurr: state_type] :
      ( v92519(VarCurr)
    <=> ( v92520(VarCurr)
      <~> v92403(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2211,axiom,
    ! [VarCurr: state_type] :
      ( v92520(VarCurr)
    <=> ( v92521(VarCurr)
      <~> v92403(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2210,axiom,
    ! [VarCurr: state_type] :
      ( v92521(VarCurr)
    <=> ( v92522(VarCurr)
      <~> v92403(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2209,axiom,
    ! [VarCurr: state_type] :
      ( v92522(VarCurr)
    <=> ( v92523(VarCurr)
      <~> v92403(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2208,axiom,
    ! [VarCurr: state_type] :
      ( v92523(VarCurr)
    <=> ( v92524(VarCurr)
      <~> v92403(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2207,axiom,
    ! [VarCurr: state_type] :
      ( v92524(VarCurr)
    <=> ( v92525(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2206,axiom,
    ! [VarCurr: state_type] :
      ( v92525(VarCurr)
    <=> ( v92526(VarCurr)
      <~> v92403(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2205,axiom,
    ! [VarCurr: state_type] :
      ( v92526(VarCurr)
    <=> ( v92527(VarCurr)
      <~> v92403(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2204,axiom,
    ! [VarCurr: state_type] :
      ( v92527(VarCurr)
    <=> ( v92528(VarCurr)
      <~> v92403(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2203,axiom,
    ! [VarCurr: state_type] :
      ( v92528(VarCurr)
    <=> ( v92529(VarCurr)
      <~> v92403(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2202,axiom,
    ! [VarCurr: state_type] :
      ( v92529(VarCurr)
    <=> ( v92530(VarCurr)
      <~> v92403(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2201,axiom,
    ! [VarCurr: state_type] :
      ( v92530(VarCurr)
    <=> ( v92531(VarCurr)
      <~> v92403(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2200,axiom,
    ! [VarCurr: state_type] :
      ( v92531(VarCurr)
    <=> ( v92532(VarCurr)
      <~> v92403(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2199,axiom,
    ! [VarCurr: state_type] :
      ( v92532(VarCurr)
    <=> ( v92533(VarCurr)
      <~> v92403(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2198,axiom,
    ! [VarCurr: state_type] :
      ( v92533(VarCurr)
    <=> ( v92534(VarCurr)
      <~> v92403(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2197,axiom,
    ! [VarCurr: state_type] :
      ( v92534(VarCurr)
    <=> ( v92535(VarCurr)
      <~> v92403(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2196,axiom,
    ! [VarCurr: state_type] :
      ( v92535(VarCurr)
    <=> ( v92536(VarCurr)
      <~> v92403(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2195,axiom,
    ! [VarCurr: state_type] :
      ( v92536(VarCurr)
    <=> ( v92537(VarCurr)
      <~> v92403(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2194,axiom,
    ! [VarCurr: state_type] :
      ( v92537(VarCurr)
    <=> ( v92538(VarCurr)
      <~> v92403(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2193,axiom,
    ! [VarCurr: state_type] :
      ( v92538(VarCurr)
    <=> ( v92539(VarCurr)
      <~> v92403(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2192,axiom,
    ! [VarCurr: state_type] :
      ( v92539(VarCurr)
    <=> ( v92540(VarCurr)
      <~> v92403(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2191,axiom,
    ! [VarCurr: state_type] :
      ( v92540(VarCurr)
    <=> ( v92541(VarCurr)
      <~> v92403(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2190,axiom,
    ! [VarCurr: state_type] :
      ( v92541(VarCurr)
    <=> ( v92542(VarCurr)
      <~> v92403(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2189,axiom,
    ! [VarCurr: state_type] :
      ( v92542(VarCurr)
    <=> ( v92543(VarCurr)
      <~> v92403(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2188,axiom,
    ! [VarCurr: state_type] :
      ( v92543(VarCurr)
    <=> ( v92544(VarCurr)
      <~> v92403(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2187,axiom,
    ! [VarCurr: state_type] :
      ( v92544(VarCurr)
    <=> ( v92545(VarCurr)
      <~> v92403(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2186,axiom,
    ! [VarCurr: state_type] :
      ( v92545(VarCurr)
    <=> ( v92546(VarCurr)
      <~> v92403(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2185,axiom,
    ! [VarCurr: state_type] :
      ( v92546(VarCurr)
    <=> ( v92547(VarCurr)
      <~> v92403(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2184,axiom,
    ! [VarCurr: state_type] :
      ( v92547(VarCurr)
    <=> ( v92548(VarCurr)
      <~> v92403(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2183,axiom,
    ! [VarCurr: state_type] :
      ( v92548(VarCurr)
    <=> ( v92549(VarCurr)
      <~> v92403(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2182,axiom,
    ! [VarCurr: state_type] :
      ( v92549(VarCurr)
    <=> ( v92403(VarCurr,71)
      <~> v92403(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2181,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,2)
    <=> ( v92476(VarCurr)
      <~> v92403(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2180,axiom,
    ! [VarCurr: state_type] :
      ( v92476(VarCurr)
    <=> ( v92477(VarCurr)
      <~> v92403(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2179,axiom,
    ! [VarCurr: state_type] :
      ( v92477(VarCurr)
    <=> ( v92478(VarCurr)
      <~> v92403(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2178,axiom,
    ! [VarCurr: state_type] :
      ( v92478(VarCurr)
    <=> ( v92479(VarCurr)
      <~> v92403(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2177,axiom,
    ! [VarCurr: state_type] :
      ( v92479(VarCurr)
    <=> ( v92480(VarCurr)
      <~> v92403(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2176,axiom,
    ! [VarCurr: state_type] :
      ( v92480(VarCurr)
    <=> ( v92481(VarCurr)
      <~> v92403(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2175,axiom,
    ! [VarCurr: state_type] :
      ( v92481(VarCurr)
    <=> ( v92482(VarCurr)
      <~> v92403(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2174,axiom,
    ! [VarCurr: state_type] :
      ( v92482(VarCurr)
    <=> ( v92483(VarCurr)
      <~> v92403(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2173,axiom,
    ! [VarCurr: state_type] :
      ( v92483(VarCurr)
    <=> ( v92484(VarCurr)
      <~> v92403(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2172,axiom,
    ! [VarCurr: state_type] :
      ( v92484(VarCurr)
    <=> ( v92485(VarCurr)
      <~> v92403(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2171,axiom,
    ! [VarCurr: state_type] :
      ( v92485(VarCurr)
    <=> ( v92486(VarCurr)
      <~> v92403(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2170,axiom,
    ! [VarCurr: state_type] :
      ( v92486(VarCurr)
    <=> ( v92487(VarCurr)
      <~> v92403(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2169,axiom,
    ! [VarCurr: state_type] :
      ( v92487(VarCurr)
    <=> ( v92488(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2168,axiom,
    ! [VarCurr: state_type] :
      ( v92488(VarCurr)
    <=> ( v92489(VarCurr)
      <~> v92403(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2167,axiom,
    ! [VarCurr: state_type] :
      ( v92489(VarCurr)
    <=> ( v92490(VarCurr)
      <~> v92403(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2166,axiom,
    ! [VarCurr: state_type] :
      ( v92490(VarCurr)
    <=> ( v92491(VarCurr)
      <~> v92403(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2165,axiom,
    ! [VarCurr: state_type] :
      ( v92491(VarCurr)
    <=> ( v92492(VarCurr)
      <~> v92403(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2164,axiom,
    ! [VarCurr: state_type] :
      ( v92492(VarCurr)
    <=> ( v92493(VarCurr)
      <~> v92403(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2163,axiom,
    ! [VarCurr: state_type] :
      ( v92493(VarCurr)
    <=> ( v92494(VarCurr)
      <~> v92403(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2162,axiom,
    ! [VarCurr: state_type] :
      ( v92494(VarCurr)
    <=> ( v92495(VarCurr)
      <~> v92403(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2161,axiom,
    ! [VarCurr: state_type] :
      ( v92495(VarCurr)
    <=> ( v92496(VarCurr)
      <~> v92403(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2160,axiom,
    ! [VarCurr: state_type] :
      ( v92496(VarCurr)
    <=> ( v92497(VarCurr)
      <~> v92403(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2159,axiom,
    ! [VarCurr: state_type] :
      ( v92497(VarCurr)
    <=> ( v92498(VarCurr)
      <~> v92403(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2158,axiom,
    ! [VarCurr: state_type] :
      ( v92498(VarCurr)
    <=> ( v92499(VarCurr)
      <~> v92403(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2157,axiom,
    ! [VarCurr: state_type] :
      ( v92499(VarCurr)
    <=> ( v92500(VarCurr)
      <~> v92403(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2156,axiom,
    ! [VarCurr: state_type] :
      ( v92500(VarCurr)
    <=> ( v92501(VarCurr)
      <~> v92403(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2155,axiom,
    ! [VarCurr: state_type] :
      ( v92501(VarCurr)
    <=> ( v92502(VarCurr)
      <~> v92403(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2154,axiom,
    ! [VarCurr: state_type] :
      ( v92502(VarCurr)
    <=> ( v92503(VarCurr)
      <~> v92403(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2153,axiom,
    ! [VarCurr: state_type] :
      ( v92503(VarCurr)
    <=> ( v92504(VarCurr)
      <~> v92403(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2152,axiom,
    ! [VarCurr: state_type] :
      ( v92504(VarCurr)
    <=> ( v92505(VarCurr)
      <~> v92403(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2151,axiom,
    ! [VarCurr: state_type] :
      ( v92505(VarCurr)
    <=> ( v92506(VarCurr)
      <~> v92403(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2150,axiom,
    ! [VarCurr: state_type] :
      ( v92506(VarCurr)
    <=> ( v92507(VarCurr)
      <~> v92403(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2149,axiom,
    ! [VarCurr: state_type] :
      ( v92507(VarCurr)
    <=> ( v92508(VarCurr)
      <~> v92403(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2148,axiom,
    ! [VarCurr: state_type] :
      ( v92508(VarCurr)
    <=> ( v92509(VarCurr)
      <~> v92403(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2147,axiom,
    ! [VarCurr: state_type] :
      ( v92509(VarCurr)
    <=> ( v92510(VarCurr)
      <~> v92403(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2146,axiom,
    ! [VarCurr: state_type] :
      ( v92510(VarCurr)
    <=> ( v92511(VarCurr)
      <~> v92403(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2145,axiom,
    ! [VarCurr: state_type] :
      ( v92511(VarCurr)
    <=> ( v92512(VarCurr)
      <~> v92403(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2144,axiom,
    ! [VarCurr: state_type] :
      ( v92512(VarCurr)
    <=> ( v92403(VarCurr,71)
      <~> v92403(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2143,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,1)
    <=> ( v92441(VarCurr)
      <~> v92403(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2142,axiom,
    ! [VarCurr: state_type] :
      ( v92441(VarCurr)
    <=> ( v92442(VarCurr)
      <~> v92403(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2141,axiom,
    ! [VarCurr: state_type] :
      ( v92442(VarCurr)
    <=> ( v92443(VarCurr)
      <~> v92403(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2140,axiom,
    ! [VarCurr: state_type] :
      ( v92443(VarCurr)
    <=> ( v92444(VarCurr)
      <~> v92403(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2139,axiom,
    ! [VarCurr: state_type] :
      ( v92444(VarCurr)
    <=> ( v92445(VarCurr)
      <~> v92403(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2138,axiom,
    ! [VarCurr: state_type] :
      ( v92445(VarCurr)
    <=> ( v92446(VarCurr)
      <~> v92403(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2137,axiom,
    ! [VarCurr: state_type] :
      ( v92446(VarCurr)
    <=> ( v92447(VarCurr)
      <~> v92403(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2136,axiom,
    ! [VarCurr: state_type] :
      ( v92447(VarCurr)
    <=> ( v92448(VarCurr)
      <~> v92403(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2135,axiom,
    ! [VarCurr: state_type] :
      ( v92448(VarCurr)
    <=> ( v92449(VarCurr)
      <~> v92403(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2134,axiom,
    ! [VarCurr: state_type] :
      ( v92449(VarCurr)
    <=> ( v92450(VarCurr)
      <~> v92403(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2133,axiom,
    ! [VarCurr: state_type] :
      ( v92450(VarCurr)
    <=> ( v92451(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2132,axiom,
    ! [VarCurr: state_type] :
      ( v92451(VarCurr)
    <=> ( v92452(VarCurr)
      <~> v92403(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2131,axiom,
    ! [VarCurr: state_type] :
      ( v92452(VarCurr)
    <=> ( v92453(VarCurr)
      <~> v92403(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2130,axiom,
    ! [VarCurr: state_type] :
      ( v92453(VarCurr)
    <=> ( v92454(VarCurr)
      <~> v92403(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2129,axiom,
    ! [VarCurr: state_type] :
      ( v92454(VarCurr)
    <=> ( v92455(VarCurr)
      <~> v92403(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2128,axiom,
    ! [VarCurr: state_type] :
      ( v92455(VarCurr)
    <=> ( v92456(VarCurr)
      <~> v92403(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2127,axiom,
    ! [VarCurr: state_type] :
      ( v92456(VarCurr)
    <=> ( v92457(VarCurr)
      <~> v92403(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2126,axiom,
    ! [VarCurr: state_type] :
      ( v92457(VarCurr)
    <=> ( v92458(VarCurr)
      <~> v92403(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2125,axiom,
    ! [VarCurr: state_type] :
      ( v92458(VarCurr)
    <=> ( v92459(VarCurr)
      <~> v92403(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2124,axiom,
    ! [VarCurr: state_type] :
      ( v92459(VarCurr)
    <=> ( v92460(VarCurr)
      <~> v92403(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2123,axiom,
    ! [VarCurr: state_type] :
      ( v92460(VarCurr)
    <=> ( v92461(VarCurr)
      <~> v92403(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2122,axiom,
    ! [VarCurr: state_type] :
      ( v92461(VarCurr)
    <=> ( v92462(VarCurr)
      <~> v92403(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2121,axiom,
    ! [VarCurr: state_type] :
      ( v92462(VarCurr)
    <=> ( v92463(VarCurr)
      <~> v92403(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2120,axiom,
    ! [VarCurr: state_type] :
      ( v92463(VarCurr)
    <=> ( v92464(VarCurr)
      <~> v92403(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2119,axiom,
    ! [VarCurr: state_type] :
      ( v92464(VarCurr)
    <=> ( v92465(VarCurr)
      <~> v92403(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2118,axiom,
    ! [VarCurr: state_type] :
      ( v92465(VarCurr)
    <=> ( v92466(VarCurr)
      <~> v92403(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2117,axiom,
    ! [VarCurr: state_type] :
      ( v92466(VarCurr)
    <=> ( v92467(VarCurr)
      <~> v92403(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2116,axiom,
    ! [VarCurr: state_type] :
      ( v92467(VarCurr)
    <=> ( v92468(VarCurr)
      <~> v92403(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2115,axiom,
    ! [VarCurr: state_type] :
      ( v92468(VarCurr)
    <=> ( v92469(VarCurr)
      <~> v92403(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2114,axiom,
    ! [VarCurr: state_type] :
      ( v92469(VarCurr)
    <=> ( v92470(VarCurr)
      <~> v92403(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2113,axiom,
    ! [VarCurr: state_type] :
      ( v92470(VarCurr)
    <=> ( v92471(VarCurr)
      <~> v92403(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2112,axiom,
    ! [VarCurr: state_type] :
      ( v92471(VarCurr)
    <=> ( v92472(VarCurr)
      <~> v92403(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2111,axiom,
    ! [VarCurr: state_type] :
      ( v92472(VarCurr)
    <=> ( v92473(VarCurr)
      <~> v92403(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2110,axiom,
    ! [VarCurr: state_type] :
      ( v92473(VarCurr)
    <=> ( v92474(VarCurr)
      <~> v92403(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2109,axiom,
    ! [VarCurr: state_type] :
      ( v92474(VarCurr)
    <=> ( v92403(VarCurr,70)
      <~> v92403(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8662,axiom,
    ! [VarCurr: state_type] :
      ( v92401(VarCurr,0)
    <=> ( v92405(VarCurr)
      <~> v92403(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2108,axiom,
    ! [VarCurr: state_type] :
      ( v92405(VarCurr)
    <=> ( v92406(VarCurr)
      <~> v92403(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2107,axiom,
    ! [VarCurr: state_type] :
      ( v92406(VarCurr)
    <=> ( v92407(VarCurr)
      <~> v92403(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2106,axiom,
    ! [VarCurr: state_type] :
      ( v92407(VarCurr)
    <=> ( v92408(VarCurr)
      <~> v92403(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2105,axiom,
    ! [VarCurr: state_type] :
      ( v92408(VarCurr)
    <=> ( v92409(VarCurr)
      <~> v92403(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2104,axiom,
    ! [VarCurr: state_type] :
      ( v92409(VarCurr)
    <=> ( v92410(VarCurr)
      <~> v92403(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2103,axiom,
    ! [VarCurr: state_type] :
      ( v92410(VarCurr)
    <=> ( v92411(VarCurr)
      <~> v92403(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2102,axiom,
    ! [VarCurr: state_type] :
      ( v92411(VarCurr)
    <=> ( v92412(VarCurr)
      <~> v92403(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2101,axiom,
    ! [VarCurr: state_type] :
      ( v92412(VarCurr)
    <=> ( v92413(VarCurr)
      <~> v92403(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2100,axiom,
    ! [VarCurr: state_type] :
      ( v92413(VarCurr)
    <=> ( v92414(VarCurr)
      <~> v92403(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2099,axiom,
    ! [VarCurr: state_type] :
      ( v92414(VarCurr)
    <=> ( v92415(VarCurr)
      <~> v92403(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2098,axiom,
    ! [VarCurr: state_type] :
      ( v92415(VarCurr)
    <=> ( v92416(VarCurr)
      <~> v92403(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2097,axiom,
    ! [VarCurr: state_type] :
      ( v92416(VarCurr)
    <=> ( v92417(VarCurr)
      <~> v92403(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2096,axiom,
    ! [VarCurr: state_type] :
      ( v92417(VarCurr)
    <=> ( v92418(VarCurr)
      <~> v92403(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2095,axiom,
    ! [VarCurr: state_type] :
      ( v92418(VarCurr)
    <=> ( v92419(VarCurr)
      <~> v92403(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2094,axiom,
    ! [VarCurr: state_type] :
      ( v92419(VarCurr)
    <=> ( v92420(VarCurr)
      <~> v92403(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2093,axiom,
    ! [VarCurr: state_type] :
      ( v92420(VarCurr)
    <=> ( v92421(VarCurr)
      <~> v92403(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2092,axiom,
    ! [VarCurr: state_type] :
      ( v92421(VarCurr)
    <=> ( v92422(VarCurr)
      <~> v92403(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2091,axiom,
    ! [VarCurr: state_type] :
      ( v92422(VarCurr)
    <=> ( v92423(VarCurr)
      <~> v92403(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2090,axiom,
    ! [VarCurr: state_type] :
      ( v92423(VarCurr)
    <=> ( v92424(VarCurr)
      <~> v92403(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2089,axiom,
    ! [VarCurr: state_type] :
      ( v92424(VarCurr)
    <=> ( v92425(VarCurr)
      <~> v92403(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2088,axiom,
    ! [VarCurr: state_type] :
      ( v92425(VarCurr)
    <=> ( v92426(VarCurr)
      <~> v92403(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2087,axiom,
    ! [VarCurr: state_type] :
      ( v92426(VarCurr)
    <=> ( v92427(VarCurr)
      <~> v92403(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2086,axiom,
    ! [VarCurr: state_type] :
      ( v92427(VarCurr)
    <=> ( v92428(VarCurr)
      <~> v92403(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2085,axiom,
    ! [VarCurr: state_type] :
      ( v92428(VarCurr)
    <=> ( v92429(VarCurr)
      <~> v92403(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2084,axiom,
    ! [VarCurr: state_type] :
      ( v92429(VarCurr)
    <=> ( v92430(VarCurr)
      <~> v92403(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2083,axiom,
    ! [VarCurr: state_type] :
      ( v92430(VarCurr)
    <=> ( v92431(VarCurr)
      <~> v92403(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2082,axiom,
    ! [VarCurr: state_type] :
      ( v92431(VarCurr)
    <=> ( v92432(VarCurr)
      <~> v92403(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2081,axiom,
    ! [VarCurr: state_type] :
      ( v92432(VarCurr)
    <=> ( v92433(VarCurr)
      <~> v92403(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2080,axiom,
    ! [VarCurr: state_type] :
      ( v92433(VarCurr)
    <=> ( v92434(VarCurr)
      <~> v92403(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2079,axiom,
    ! [VarCurr: state_type] :
      ( v92434(VarCurr)
    <=> ( v92435(VarCurr)
      <~> v92403(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2078,axiom,
    ! [VarCurr: state_type] :
      ( v92435(VarCurr)
    <=> ( v92436(VarCurr)
      <~> v92403(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2077,axiom,
    ! [VarCurr: state_type] :
      ( v92436(VarCurr)
    <=> ( v92437(VarCurr)
      <~> v92403(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2076,axiom,
    ! [VarCurr: state_type] :
      ( v92437(VarCurr)
    <=> ( v92438(VarCurr)
      <~> v92403(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2075,axiom,
    ! [VarCurr: state_type] :
      ( v92438(VarCurr)
    <=> ( v92439(VarCurr)
      <~> v92403(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2074,axiom,
    ! [VarCurr: state_type] :
      ( v92439(VarCurr)
    <=> ( v92403(VarCurr,69)
      <~> v92403(VarCurr,66) ) ) ).

tff(addAssignment_55933,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,62)
    <=> v91910(VarCurr,62) ) ).

tff(addAssignment_55932,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,23)
    <=> v91910(VarCurr,23) ) ).

tff(addAssignment_55931,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,61)
    <=> v91910(VarCurr,61) ) ).

tff(addAssignment_55930,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,22)
    <=> v91910(VarCurr,22) ) ).

tff(addAssignment_55929,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,27)
    <=> v91910(VarCurr,27) ) ).

tff(addAssignment_55928,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,47)
    <=> v91910(VarCurr,47) ) ).

tff(addAssignment_55927,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,60)
    <=> v91910(VarCurr,60) ) ).

tff(addAssignment_55926,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,5)
    <=> v91910(VarCurr,5) ) ).

tff(addAssignment_55925,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,8)
    <=> v91910(VarCurr,8) ) ).

tff(addAssignment_55924,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,15)
    <=> v91910(VarCurr,15) ) ).

tff(addAssignment_55923,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,21)
    <=> v91910(VarCurr,21) ) ).

tff(addAssignment_55922,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,26)
    <=> v91910(VarCurr,26) ) ).

tff(addAssignment_55921,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,46)
    <=> v91910(VarCurr,46) ) ).

tff(addAssignment_55920,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,51)
    <=> v91910(VarCurr,51) ) ).

tff(addAssignment_55919,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,59)
    <=> v91910(VarCurr,59) ) ).

tff(addAssignment_55918,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,68)
    <=> v91910(VarCurr,68) ) ).

tff(addAssignment_55917,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,71)
    <=> v91910(VarCurr,71) ) ).

tff(addAssignment_55916,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,4)
    <=> v91910(VarCurr,4) ) ).

tff(addAssignment_55915,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,7)
    <=> v91910(VarCurr,7) ) ).

tff(addAssignment_55914,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,10)
    <=> v91910(VarCurr,10) ) ).

tff(addAssignment_55913,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,12)
    <=> v91910(VarCurr,12) ) ).

tff(addAssignment_55912,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,14)
    <=> v91910(VarCurr,14) ) ).

tff(addAssignment_55911,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,18)
    <=> v91910(VarCurr,18) ) ).

tff(addAssignment_55910,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,20)
    <=> v91910(VarCurr,20) ) ).

tff(addAssignment_55909,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,25)
    <=> v91910(VarCurr,25) ) ).

tff(addAssignment_55908,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,29)
    <=> v91910(VarCurr,29) ) ).

tff(addAssignment_55907,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,32)
    <=> v91910(VarCurr,32) ) ).

tff(addAssignment_55906,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,39)
    <=> v91910(VarCurr,39) ) ).

tff(addAssignment_55905,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,41)
    <=> v91910(VarCurr,41) ) ).

tff(addAssignment_55904,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,45)
    <=> v91910(VarCurr,45) ) ).

tff(addAssignment_55903,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,50)
    <=> v91910(VarCurr,50) ) ).

tff(addAssignment_55902,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,55)
    <=> v91910(VarCurr,55) ) ).

tff(addAssignment_55901,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,58)
    <=> v91910(VarCurr,58) ) ).

tff(addAssignment_55900,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,67)
    <=> v91910(VarCurr,67) ) ).

tff(addAssignment_55899,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,70)
    <=> v91910(VarCurr,70) ) ).

tff(addAssignment_55898,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,0)
    <=> v91910(VarCurr,0) ) ).

tff(addAssignment_55897,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,1)
    <=> v91910(VarCurr,1) ) ).

tff(addAssignment_55896,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,2)
    <=> v91910(VarCurr,2) ) ).

tff(addAssignment_55895,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,3)
    <=> v91910(VarCurr,3) ) ).

tff(addAssignment_55894,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,6)
    <=> v91910(VarCurr,6) ) ).

tff(addAssignment_55893,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,9)
    <=> v91910(VarCurr,9) ) ).

tff(addAssignment_55892,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,11)
    <=> v91910(VarCurr,11) ) ).

tff(addAssignment_55891,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,13)
    <=> v91910(VarCurr,13) ) ).

tff(addAssignment_55890,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,16)
    <=> v91910(VarCurr,16) ) ).

tff(addAssignment_55889,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,17)
    <=> v91910(VarCurr,17) ) ).

tff(addAssignment_55888,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,19)
    <=> v91910(VarCurr,19) ) ).

tff(addAssignment_55887,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,24)
    <=> v91910(VarCurr,24) ) ).

tff(addAssignment_55886,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,28)
    <=> v91910(VarCurr,28) ) ).

tff(addAssignment_55885,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,30)
    <=> v91910(VarCurr,30) ) ).

tff(addAssignment_55884,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,31)
    <=> v91910(VarCurr,31) ) ).

tff(addAssignment_55883,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,33)
    <=> v91910(VarCurr,33) ) ).

tff(addAssignment_55882,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,34)
    <=> v91910(VarCurr,34) ) ).

tff(addAssignment_55881,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,35)
    <=> v91910(VarCurr,35) ) ).

tff(addAssignment_55880,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,36)
    <=> v91910(VarCurr,36) ) ).

tff(addAssignment_55879,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,37)
    <=> v91910(VarCurr,37) ) ).

tff(addAssignment_55878,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,38)
    <=> v91910(VarCurr,38) ) ).

tff(addAssignment_55877,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,40)
    <=> v91910(VarCurr,40) ) ).

tff(addAssignment_55876,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,42)
    <=> v91910(VarCurr,42) ) ).

tff(addAssignment_55875,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,43)
    <=> v91910(VarCurr,43) ) ).

tff(addAssignment_55874,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,44)
    <=> v91910(VarCurr,44) ) ).

tff(addAssignment_55873,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,48)
    <=> v91910(VarCurr,48) ) ).

tff(addAssignment_55872,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,49)
    <=> v91910(VarCurr,49) ) ).

tff(addAssignment_55871,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,52)
    <=> v91910(VarCurr,52) ) ).

tff(addAssignment_55870,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,53)
    <=> v91910(VarCurr,53) ) ).

tff(addAssignment_55869,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,54)
    <=> v91910(VarCurr,54) ) ).

tff(addAssignment_55868,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,56)
    <=> v91910(VarCurr,56) ) ).

tff(addAssignment_55867,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,57)
    <=> v91910(VarCurr,57) ) ).

tff(addAssignment_55866,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,63)
    <=> v91910(VarCurr,63) ) ).

tff(addAssignment_55865,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,64)
    <=> v91910(VarCurr,64) ) ).

tff(addAssignment_55864,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,65)
    <=> v91910(VarCurr,65) ) ).

tff(addAssignment_55863,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,66)
    <=> v91910(VarCurr,66) ) ).

tff(addAssignment_55862,axiom,
    ! [VarCurr: state_type] :
      ( v92403(VarCurr,69)
    <=> v91910(VarCurr,69) ) ).

tff(addAssignment_55861,axiom,
    ! [VarCurr: state_type] :
      ( v92381(VarCurr)
    <=> v92383(VarCurr) ) ).

tff(addAssignment_55860,axiom,
    ! [VarCurr: state_type] :
      ( v92383(VarCurr)
    <=> v92385(VarCurr) ) ).

tff(addAssignment_55859,axiom,
    ! [VarCurr: state_type] :
      ( v92385(VarCurr)
    <=> v92387(VarCurr) ) ).

tff(addAssignment_55858,axiom,
    ! [VarCurr: state_type] :
      ( v92387(VarCurr)
    <=> v92389(VarCurr) ) ).

tff(addAssignment_55857,axiom,
    ! [VarCurr: state_type] :
      ( v92389(VarCurr)
    <=> v91029(VarCurr) ) ).

tff(addAssignment_55856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91896(VarCurr,B)
      <=> v91898(VarCurr,B) ) ) ).

tff(addAssignment_55855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91898(VarCurr,B)
      <=> v91900(VarCurr,B) ) ) ).

tff(addAssignment_55854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91900(VarCurr,B)
      <=> v91902(VarCurr,B) ) ) ).

tff(addAssignment_55853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91902(VarCurr,B)
      <=> v91904(VarCurr,B) ) ) ).

tff(addAssignment_55852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91904(VarCurr,B)
      <=> v91906(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2073,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,11)
    <=> ( v92341(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2072,axiom,
    ! [VarCurr: state_type] :
      ( v92341(VarCurr)
    <=> ( v92342(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2071,axiom,
    ! [VarCurr: state_type] :
      ( v92342(VarCurr)
    <=> ( v92343(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2070,axiom,
    ! [VarCurr: state_type] :
      ( v92343(VarCurr)
    <=> ( v92344(VarCurr)
      <~> v91908(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2069,axiom,
    ! [VarCurr: state_type] :
      ( v92344(VarCurr)
    <=> ( v92345(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2068,axiom,
    ! [VarCurr: state_type] :
      ( v92345(VarCurr)
    <=> ( v92346(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2067,axiom,
    ! [VarCurr: state_type] :
      ( v92346(VarCurr)
    <=> ( v92347(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2066,axiom,
    ! [VarCurr: state_type] :
      ( v92347(VarCurr)
    <=> ( v92348(VarCurr)
      <~> v91908(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2065,axiom,
    ! [VarCurr: state_type] :
      ( v92348(VarCurr)
    <=> ( v92349(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2064,axiom,
    ! [VarCurr: state_type] :
      ( v92349(VarCurr)
    <=> ( v92350(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2063,axiom,
    ! [VarCurr: state_type] :
      ( v92350(VarCurr)
    <=> ( v92351(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2062,axiom,
    ! [VarCurr: state_type] :
      ( v92351(VarCurr)
    <=> ( v92352(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2061,axiom,
    ! [VarCurr: state_type] :
      ( v92352(VarCurr)
    <=> ( v92353(VarCurr)
      <~> v91908(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2060,axiom,
    ! [VarCurr: state_type] :
      ( v92353(VarCurr)
    <=> ( v92354(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2059,axiom,
    ! [VarCurr: state_type] :
      ( v92354(VarCurr)
    <=> ( v92355(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2058,axiom,
    ! [VarCurr: state_type] :
      ( v92355(VarCurr)
    <=> ( v92356(VarCurr)
      <~> v91908(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2057,axiom,
    ! [VarCurr: state_type] :
      ( v92356(VarCurr)
    <=> ( v92357(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2056,axiom,
    ! [VarCurr: state_type] :
      ( v92357(VarCurr)
    <=> ( v92358(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2055,axiom,
    ! [VarCurr: state_type] :
      ( v92358(VarCurr)
    <=> ( v92359(VarCurr)
      <~> v91908(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2054,axiom,
    ! [VarCurr: state_type] :
      ( v92359(VarCurr)
    <=> ( v92360(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2053,axiom,
    ! [VarCurr: state_type] :
      ( v92360(VarCurr)
    <=> ( v92361(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2052,axiom,
    ! [VarCurr: state_type] :
      ( v92361(VarCurr)
    <=> ( v92362(VarCurr)
      <~> v91908(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2051,axiom,
    ! [VarCurr: state_type] :
      ( v92362(VarCurr)
    <=> ( v92363(VarCurr)
      <~> v91908(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2050,axiom,
    ! [VarCurr: state_type] :
      ( v92363(VarCurr)
    <=> ( v92364(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2049,axiom,
    ! [VarCurr: state_type] :
      ( v92364(VarCurr)
    <=> ( v92365(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2048,axiom,
    ! [VarCurr: state_type] :
      ( v92365(VarCurr)
    <=> ( v92366(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2047,axiom,
    ! [VarCurr: state_type] :
      ( v92366(VarCurr)
    <=> ( v92367(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2046,axiom,
    ! [VarCurr: state_type] :
      ( v92367(VarCurr)
    <=> ( v92368(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2045,axiom,
    ! [VarCurr: state_type] :
      ( v92368(VarCurr)
    <=> ( v92369(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2044,axiom,
    ! [VarCurr: state_type] :
      ( v92369(VarCurr)
    <=> ( v92370(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2043,axiom,
    ! [VarCurr: state_type] :
      ( v92370(VarCurr)
    <=> ( v92371(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2042,axiom,
    ! [VarCurr: state_type] :
      ( v92371(VarCurr)
    <=> ( v92372(VarCurr)
      <~> v91908(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2041,axiom,
    ! [VarCurr: state_type] :
      ( v92372(VarCurr)
    <=> ( v92373(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2040,axiom,
    ! [VarCurr: state_type] :
      ( v92373(VarCurr)
    <=> ( v92374(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2039,axiom,
    ! [VarCurr: state_type] :
      ( v92374(VarCurr)
    <=> ( v92375(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2038,axiom,
    ! [VarCurr: state_type] :
      ( v92375(VarCurr)
    <=> ( v92376(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2037,axiom,
    ! [VarCurr: state_type] :
      ( v92376(VarCurr)
    <=> ( v92377(VarCurr)
      <~> v91908(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2036,axiom,
    ! [VarCurr: state_type] :
      ( v92377(VarCurr)
    <=> ( v92378(VarCurr)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2035,axiom,
    ! [VarCurr: state_type] :
      ( v92378(VarCurr)
    <=> ( v92379(VarCurr)
      <~> v91908(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2034,axiom,
    ! [VarCurr: state_type] :
      ( v92379(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2033,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,10)
    <=> ( v92308(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2032,axiom,
    ! [VarCurr: state_type] :
      ( v92308(VarCurr)
    <=> ( v92309(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2031,axiom,
    ! [VarCurr: state_type] :
      ( v92309(VarCurr)
    <=> ( v92310(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2030,axiom,
    ! [VarCurr: state_type] :
      ( v92310(VarCurr)
    <=> ( v92311(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2029,axiom,
    ! [VarCurr: state_type] :
      ( v92311(VarCurr)
    <=> ( v92312(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2028,axiom,
    ! [VarCurr: state_type] :
      ( v92312(VarCurr)
    <=> ( v92313(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2027,axiom,
    ! [VarCurr: state_type] :
      ( v92313(VarCurr)
    <=> ( v92314(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2026,axiom,
    ! [VarCurr: state_type] :
      ( v92314(VarCurr)
    <=> ( v92315(VarCurr)
      <~> v91908(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2025,axiom,
    ! [VarCurr: state_type] :
      ( v92315(VarCurr)
    <=> ( v92316(VarCurr)
      <~> v91908(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2024,axiom,
    ! [VarCurr: state_type] :
      ( v92316(VarCurr)
    <=> ( v92317(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2023,axiom,
    ! [VarCurr: state_type] :
      ( v92317(VarCurr)
    <=> ( v92318(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2022,axiom,
    ! [VarCurr: state_type] :
      ( v92318(VarCurr)
    <=> ( v92319(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2021,axiom,
    ! [VarCurr: state_type] :
      ( v92319(VarCurr)
    <=> ( v92320(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2020,axiom,
    ! [VarCurr: state_type] :
      ( v92320(VarCurr)
    <=> ( v92321(VarCurr)
      <~> v91908(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2019,axiom,
    ! [VarCurr: state_type] :
      ( v92321(VarCurr)
    <=> ( v92322(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2018,axiom,
    ! [VarCurr: state_type] :
      ( v92322(VarCurr)
    <=> ( v92323(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2017,axiom,
    ! [VarCurr: state_type] :
      ( v92323(VarCurr)
    <=> ( v92324(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2016,axiom,
    ! [VarCurr: state_type] :
      ( v92324(VarCurr)
    <=> ( v92325(VarCurr)
      <~> v91908(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2015,axiom,
    ! [VarCurr: state_type] :
      ( v92325(VarCurr)
    <=> ( v92326(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2014,axiom,
    ! [VarCurr: state_type] :
      ( v92326(VarCurr)
    <=> ( v92327(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2013,axiom,
    ! [VarCurr: state_type] :
      ( v92327(VarCurr)
    <=> ( v92328(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2012,axiom,
    ! [VarCurr: state_type] :
      ( v92328(VarCurr)
    <=> ( v92329(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2011,axiom,
    ! [VarCurr: state_type] :
      ( v92329(VarCurr)
    <=> ( v92330(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2010,axiom,
    ! [VarCurr: state_type] :
      ( v92330(VarCurr)
    <=> ( v92331(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2009,axiom,
    ! [VarCurr: state_type] :
      ( v92331(VarCurr)
    <=> ( v92332(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2008,axiom,
    ! [VarCurr: state_type] :
      ( v92332(VarCurr)
    <=> ( v92333(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2007,axiom,
    ! [VarCurr: state_type] :
      ( v92333(VarCurr)
    <=> ( v92334(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2006,axiom,
    ! [VarCurr: state_type] :
      ( v92334(VarCurr)
    <=> ( v92335(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2005,axiom,
    ! [VarCurr: state_type] :
      ( v92335(VarCurr)
    <=> ( v92336(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2004,axiom,
    ! [VarCurr: state_type] :
      ( v92336(VarCurr)
    <=> ( v92337(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2003,axiom,
    ! [VarCurr: state_type] :
      ( v92337(VarCurr)
    <=> ( v92338(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2002,axiom,
    ! [VarCurr: state_type] :
      ( v92338(VarCurr)
    <=> ( v92339(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2001,axiom,
    ! [VarCurr: state_type] :
      ( v92339(VarCurr)
    <=> ( v91908(VarCurr,68)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_2000,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,9)
    <=> ( v92268(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1999,axiom,
    ! [VarCurr: state_type] :
      ( v92268(VarCurr)
    <=> ( v92269(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1998,axiom,
    ! [VarCurr: state_type] :
      ( v92269(VarCurr)
    <=> ( v92270(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1997,axiom,
    ! [VarCurr: state_type] :
      ( v92270(VarCurr)
    <=> ( v92271(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1996,axiom,
    ! [VarCurr: state_type] :
      ( v92271(VarCurr)
    <=> ( v92272(VarCurr)
      <~> v91908(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1995,axiom,
    ! [VarCurr: state_type] :
      ( v92272(VarCurr)
    <=> ( v92273(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1994,axiom,
    ! [VarCurr: state_type] :
      ( v92273(VarCurr)
    <=> ( v92274(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1993,axiom,
    ! [VarCurr: state_type] :
      ( v92274(VarCurr)
    <=> ( v92275(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1992,axiom,
    ! [VarCurr: state_type] :
      ( v92275(VarCurr)
    <=> ( v92276(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1991,axiom,
    ! [VarCurr: state_type] :
      ( v92276(VarCurr)
    <=> ( v92277(VarCurr)
      <~> v91908(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1990,axiom,
    ! [VarCurr: state_type] :
      ( v92277(VarCurr)
    <=> ( v92278(VarCurr)
      <~> v91908(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1989,axiom,
    ! [VarCurr: state_type] :
      ( v92278(VarCurr)
    <=> ( v92279(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1988,axiom,
    ! [VarCurr: state_type] :
      ( v92279(VarCurr)
    <=> ( v92280(VarCurr)
      <~> v91908(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1987,axiom,
    ! [VarCurr: state_type] :
      ( v92280(VarCurr)
    <=> ( v92281(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1986,axiom,
    ! [VarCurr: state_type] :
      ( v92281(VarCurr)
    <=> ( v92282(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1985,axiom,
    ! [VarCurr: state_type] :
      ( v92282(VarCurr)
    <=> ( v92283(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1984,axiom,
    ! [VarCurr: state_type] :
      ( v92283(VarCurr)
    <=> ( v92284(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1983,axiom,
    ! [VarCurr: state_type] :
      ( v92284(VarCurr)
    <=> ( v92285(VarCurr)
      <~> v91908(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1982,axiom,
    ! [VarCurr: state_type] :
      ( v92285(VarCurr)
    <=> ( v92286(VarCurr)
      <~> v91908(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1981,axiom,
    ! [VarCurr: state_type] :
      ( v92286(VarCurr)
    <=> ( v92287(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1980,axiom,
    ! [VarCurr: state_type] :
      ( v92287(VarCurr)
    <=> ( v92288(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1979,axiom,
    ! [VarCurr: state_type] :
      ( v92288(VarCurr)
    <=> ( v92289(VarCurr)
      <~> v91908(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1978,axiom,
    ! [VarCurr: state_type] :
      ( v92289(VarCurr)
    <=> ( v92290(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1977,axiom,
    ! [VarCurr: state_type] :
      ( v92290(VarCurr)
    <=> ( v92291(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1976,axiom,
    ! [VarCurr: state_type] :
      ( v92291(VarCurr)
    <=> ( v92292(VarCurr)
      <~> v91908(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1975,axiom,
    ! [VarCurr: state_type] :
      ( v92292(VarCurr)
    <=> ( v92293(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1974,axiom,
    ! [VarCurr: state_type] :
      ( v92293(VarCurr)
    <=> ( v92294(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1973,axiom,
    ! [VarCurr: state_type] :
      ( v92294(VarCurr)
    <=> ( v92295(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1972,axiom,
    ! [VarCurr: state_type] :
      ( v92295(VarCurr)
    <=> ( v92296(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1971,axiom,
    ! [VarCurr: state_type] :
      ( v92296(VarCurr)
    <=> ( v92297(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1970,axiom,
    ! [VarCurr: state_type] :
      ( v92297(VarCurr)
    <=> ( v92298(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1969,axiom,
    ! [VarCurr: state_type] :
      ( v92298(VarCurr)
    <=> ( v92299(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1968,axiom,
    ! [VarCurr: state_type] :
      ( v92299(VarCurr)
    <=> ( v92300(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1967,axiom,
    ! [VarCurr: state_type] :
      ( v92300(VarCurr)
    <=> ( v92301(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1966,axiom,
    ! [VarCurr: state_type] :
      ( v92301(VarCurr)
    <=> ( v92302(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1965,axiom,
    ! [VarCurr: state_type] :
      ( v92302(VarCurr)
    <=> ( v92303(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1964,axiom,
    ! [VarCurr: state_type] :
      ( v92303(VarCurr)
    <=> ( v92304(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1963,axiom,
    ! [VarCurr: state_type] :
      ( v92304(VarCurr)
    <=> ( v92305(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1962,axiom,
    ! [VarCurr: state_type] :
      ( v92305(VarCurr)
    <=> ( v92306(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1961,axiom,
    ! [VarCurr: state_type] :
      ( v92306(VarCurr)
    <=> ( v91908(VarCurr,70)
      <~> v91908(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1960,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,8)
    <=> ( v92228(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1959,axiom,
    ! [VarCurr: state_type] :
      ( v92228(VarCurr)
    <=> ( v92229(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1958,axiom,
    ! [VarCurr: state_type] :
      ( v92229(VarCurr)
    <=> ( v92230(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1957,axiom,
    ! [VarCurr: state_type] :
      ( v92230(VarCurr)
    <=> ( v92231(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1956,axiom,
    ! [VarCurr: state_type] :
      ( v92231(VarCurr)
    <=> ( v92232(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1955,axiom,
    ! [VarCurr: state_type] :
      ( v92232(VarCurr)
    <=> ( v92233(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1954,axiom,
    ! [VarCurr: state_type] :
      ( v92233(VarCurr)
    <=> ( v92234(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1953,axiom,
    ! [VarCurr: state_type] :
      ( v92234(VarCurr)
    <=> ( v92235(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1952,axiom,
    ! [VarCurr: state_type] :
      ( v92235(VarCurr)
    <=> ( v92236(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1951,axiom,
    ! [VarCurr: state_type] :
      ( v92236(VarCurr)
    <=> ( v92237(VarCurr)
      <~> v91908(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1950,axiom,
    ! [VarCurr: state_type] :
      ( v92237(VarCurr)
    <=> ( v92238(VarCurr)
      <~> v91908(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1949,axiom,
    ! [VarCurr: state_type] :
      ( v92238(VarCurr)
    <=> ( v92239(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1948,axiom,
    ! [VarCurr: state_type] :
      ( v92239(VarCurr)
    <=> ( v92240(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1947,axiom,
    ! [VarCurr: state_type] :
      ( v92240(VarCurr)
    <=> ( v92241(VarCurr)
      <~> v91908(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1946,axiom,
    ! [VarCurr: state_type] :
      ( v92241(VarCurr)
    <=> ( v92242(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1945,axiom,
    ! [VarCurr: state_type] :
      ( v92242(VarCurr)
    <=> ( v92243(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1944,axiom,
    ! [VarCurr: state_type] :
      ( v92243(VarCurr)
    <=> ( v92244(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1943,axiom,
    ! [VarCurr: state_type] :
      ( v92244(VarCurr)
    <=> ( v92245(VarCurr)
      <~> v91908(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1942,axiom,
    ! [VarCurr: state_type] :
      ( v92245(VarCurr)
    <=> ( v92246(VarCurr)
      <~> v91908(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1941,axiom,
    ! [VarCurr: state_type] :
      ( v92246(VarCurr)
    <=> ( v92247(VarCurr)
      <~> v91908(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1940,axiom,
    ! [VarCurr: state_type] :
      ( v92247(VarCurr)
    <=> ( v92248(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1939,axiom,
    ! [VarCurr: state_type] :
      ( v92248(VarCurr)
    <=> ( v92249(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1938,axiom,
    ! [VarCurr: state_type] :
      ( v92249(VarCurr)
    <=> ( v92250(VarCurr)
      <~> v91908(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1937,axiom,
    ! [VarCurr: state_type] :
      ( v92250(VarCurr)
    <=> ( v92251(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1936,axiom,
    ! [VarCurr: state_type] :
      ( v92251(VarCurr)
    <=> ( v92252(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1935,axiom,
    ! [VarCurr: state_type] :
      ( v92252(VarCurr)
    <=> ( v92253(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1934,axiom,
    ! [VarCurr: state_type] :
      ( v92253(VarCurr)
    <=> ( v92254(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1933,axiom,
    ! [VarCurr: state_type] :
      ( v92254(VarCurr)
    <=> ( v92255(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1932,axiom,
    ! [VarCurr: state_type] :
      ( v92255(VarCurr)
    <=> ( v92256(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1931,axiom,
    ! [VarCurr: state_type] :
      ( v92256(VarCurr)
    <=> ( v92257(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1930,axiom,
    ! [VarCurr: state_type] :
      ( v92257(VarCurr)
    <=> ( v92258(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1929,axiom,
    ! [VarCurr: state_type] :
      ( v92258(VarCurr)
    <=> ( v92259(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1928,axiom,
    ! [VarCurr: state_type] :
      ( v92259(VarCurr)
    <=> ( v92260(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1927,axiom,
    ! [VarCurr: state_type] :
      ( v92260(VarCurr)
    <=> ( v92261(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1926,axiom,
    ! [VarCurr: state_type] :
      ( v92261(VarCurr)
    <=> ( v92262(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1925,axiom,
    ! [VarCurr: state_type] :
      ( v92262(VarCurr)
    <=> ( v92263(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1924,axiom,
    ! [VarCurr: state_type] :
      ( v92263(VarCurr)
    <=> ( v92264(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1923,axiom,
    ! [VarCurr: state_type] :
      ( v92264(VarCurr)
    <=> ( v92265(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1922,axiom,
    ! [VarCurr: state_type] :
      ( v92265(VarCurr)
    <=> ( v92266(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1921,axiom,
    ! [VarCurr: state_type] :
      ( v92266(VarCurr)
    <=> ( v91908(VarCurr,69)
      <~> v91908(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1920,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,7)
    <=> ( v92186(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1919,axiom,
    ! [VarCurr: state_type] :
      ( v92186(VarCurr)
    <=> ( v92187(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1918,axiom,
    ! [VarCurr: state_type] :
      ( v92187(VarCurr)
    <=> ( v92188(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1917,axiom,
    ! [VarCurr: state_type] :
      ( v92188(VarCurr)
    <=> ( v92189(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1916,axiom,
    ! [VarCurr: state_type] :
      ( v92189(VarCurr)
    <=> ( v92190(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1915,axiom,
    ! [VarCurr: state_type] :
      ( v92190(VarCurr)
    <=> ( v92191(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1914,axiom,
    ! [VarCurr: state_type] :
      ( v92191(VarCurr)
    <=> ( v92192(VarCurr)
      <~> v91908(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1913,axiom,
    ! [VarCurr: state_type] :
      ( v92192(VarCurr)
    <=> ( v92193(VarCurr)
      <~> v91908(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1912,axiom,
    ! [VarCurr: state_type] :
      ( v92193(VarCurr)
    <=> ( v92194(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1911,axiom,
    ! [VarCurr: state_type] :
      ( v92194(VarCurr)
    <=> ( v92195(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1910,axiom,
    ! [VarCurr: state_type] :
      ( v92195(VarCurr)
    <=> ( v92196(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1909,axiom,
    ! [VarCurr: state_type] :
      ( v92196(VarCurr)
    <=> ( v92197(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1908,axiom,
    ! [VarCurr: state_type] :
      ( v92197(VarCurr)
    <=> ( v92198(VarCurr)
      <~> v91908(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1907,axiom,
    ! [VarCurr: state_type] :
      ( v92198(VarCurr)
    <=> ( v92199(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1906,axiom,
    ! [VarCurr: state_type] :
      ( v92199(VarCurr)
    <=> ( v92200(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1905,axiom,
    ! [VarCurr: state_type] :
      ( v92200(VarCurr)
    <=> ( v92201(VarCurr)
      <~> v91908(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1904,axiom,
    ! [VarCurr: state_type] :
      ( v92201(VarCurr)
    <=> ( v92202(VarCurr)
      <~> v91908(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1903,axiom,
    ! [VarCurr: state_type] :
      ( v92202(VarCurr)
    <=> ( v92203(VarCurr)
      <~> v91908(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1902,axiom,
    ! [VarCurr: state_type] :
      ( v92203(VarCurr)
    <=> ( v92204(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1901,axiom,
    ! [VarCurr: state_type] :
      ( v92204(VarCurr)
    <=> ( v92205(VarCurr)
      <~> v91908(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1900,axiom,
    ! [VarCurr: state_type] :
      ( v92205(VarCurr)
    <=> ( v92206(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1899,axiom,
    ! [VarCurr: state_type] :
      ( v92206(VarCurr)
    <=> ( v92207(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1898,axiom,
    ! [VarCurr: state_type] :
      ( v92207(VarCurr)
    <=> ( v92208(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1897,axiom,
    ! [VarCurr: state_type] :
      ( v92208(VarCurr)
    <=> ( v92209(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1896,axiom,
    ! [VarCurr: state_type] :
      ( v92209(VarCurr)
    <=> ( v92210(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1895,axiom,
    ! [VarCurr: state_type] :
      ( v92210(VarCurr)
    <=> ( v92211(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1894,axiom,
    ! [VarCurr: state_type] :
      ( v92211(VarCurr)
    <=> ( v92212(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1893,axiom,
    ! [VarCurr: state_type] :
      ( v92212(VarCurr)
    <=> ( v92213(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1892,axiom,
    ! [VarCurr: state_type] :
      ( v92213(VarCurr)
    <=> ( v92214(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1891,axiom,
    ! [VarCurr: state_type] :
      ( v92214(VarCurr)
    <=> ( v92215(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1890,axiom,
    ! [VarCurr: state_type] :
      ( v92215(VarCurr)
    <=> ( v92216(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1889,axiom,
    ! [VarCurr: state_type] :
      ( v92216(VarCurr)
    <=> ( v92217(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1888,axiom,
    ! [VarCurr: state_type] :
      ( v92217(VarCurr)
    <=> ( v92218(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1887,axiom,
    ! [VarCurr: state_type] :
      ( v92218(VarCurr)
    <=> ( v92219(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1886,axiom,
    ! [VarCurr: state_type] :
      ( v92219(VarCurr)
    <=> ( v92220(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1885,axiom,
    ! [VarCurr: state_type] :
      ( v92220(VarCurr)
    <=> ( v92221(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1884,axiom,
    ! [VarCurr: state_type] :
      ( v92221(VarCurr)
    <=> ( v92222(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1883,axiom,
    ! [VarCurr: state_type] :
      ( v92222(VarCurr)
    <=> ( v92223(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1882,axiom,
    ! [VarCurr: state_type] :
      ( v92223(VarCurr)
    <=> ( v92224(VarCurr)
      <~> v91908(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1881,axiom,
    ! [VarCurr: state_type] :
      ( v92224(VarCurr)
    <=> ( v92225(VarCurr)
      <~> v91908(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1880,axiom,
    ! [VarCurr: state_type] :
      ( v92225(VarCurr)
    <=> ( v92226(VarCurr)
      <~> v91908(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1879,axiom,
    ! [VarCurr: state_type] :
      ( v92226(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1878,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,6)
    <=> ( v92143(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1877,axiom,
    ! [VarCurr: state_type] :
      ( v92143(VarCurr)
    <=> ( v92144(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1876,axiom,
    ! [VarCurr: state_type] :
      ( v92144(VarCurr)
    <=> ( v92145(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1875,axiom,
    ! [VarCurr: state_type] :
      ( v92145(VarCurr)
    <=> ( v92146(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1874,axiom,
    ! [VarCurr: state_type] :
      ( v92146(VarCurr)
    <=> ( v92147(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1873,axiom,
    ! [VarCurr: state_type] :
      ( v92147(VarCurr)
    <=> ( v92148(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1872,axiom,
    ! [VarCurr: state_type] :
      ( v92148(VarCurr)
    <=> ( v92149(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1871,axiom,
    ! [VarCurr: state_type] :
      ( v92149(VarCurr)
    <=> ( v92150(VarCurr)
      <~> v91908(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1870,axiom,
    ! [VarCurr: state_type] :
      ( v92150(VarCurr)
    <=> ( v92151(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1869,axiom,
    ! [VarCurr: state_type] :
      ( v92151(VarCurr)
    <=> ( v92152(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1868,axiom,
    ! [VarCurr: state_type] :
      ( v92152(VarCurr)
    <=> ( v92153(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1867,axiom,
    ! [VarCurr: state_type] :
      ( v92153(VarCurr)
    <=> ( v92154(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1866,axiom,
    ! [VarCurr: state_type] :
      ( v92154(VarCurr)
    <=> ( v92155(VarCurr)
      <~> v91908(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1865,axiom,
    ! [VarCurr: state_type] :
      ( v92155(VarCurr)
    <=> ( v92156(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1864,axiom,
    ! [VarCurr: state_type] :
      ( v92156(VarCurr)
    <=> ( v92157(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1863,axiom,
    ! [VarCurr: state_type] :
      ( v92157(VarCurr)
    <=> ( v92158(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1862,axiom,
    ! [VarCurr: state_type] :
      ( v92158(VarCurr)
    <=> ( v92159(VarCurr)
      <~> v91908(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1861,axiom,
    ! [VarCurr: state_type] :
      ( v92159(VarCurr)
    <=> ( v92160(VarCurr)
      <~> v91908(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1860,axiom,
    ! [VarCurr: state_type] :
      ( v92160(VarCurr)
    <=> ( v92161(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1859,axiom,
    ! [VarCurr: state_type] :
      ( v92161(VarCurr)
    <=> ( v92162(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1858,axiom,
    ! [VarCurr: state_type] :
      ( v92162(VarCurr)
    <=> ( v92163(VarCurr)
      <~> v91908(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1857,axiom,
    ! [VarCurr: state_type] :
      ( v92163(VarCurr)
    <=> ( v92164(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1856,axiom,
    ! [VarCurr: state_type] :
      ( v92164(VarCurr)
    <=> ( v92165(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1855,axiom,
    ! [VarCurr: state_type] :
      ( v92165(VarCurr)
    <=> ( v92166(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1854,axiom,
    ! [VarCurr: state_type] :
      ( v92166(VarCurr)
    <=> ( v92167(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1853,axiom,
    ! [VarCurr: state_type] :
      ( v92167(VarCurr)
    <=> ( v92168(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1852,axiom,
    ! [VarCurr: state_type] :
      ( v92168(VarCurr)
    <=> ( v92169(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1851,axiom,
    ! [VarCurr: state_type] :
      ( v92169(VarCurr)
    <=> ( v92170(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1850,axiom,
    ! [VarCurr: state_type] :
      ( v92170(VarCurr)
    <=> ( v92171(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1849,axiom,
    ! [VarCurr: state_type] :
      ( v92171(VarCurr)
    <=> ( v92172(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1848,axiom,
    ! [VarCurr: state_type] :
      ( v92172(VarCurr)
    <=> ( v92173(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1847,axiom,
    ! [VarCurr: state_type] :
      ( v92173(VarCurr)
    <=> ( v92174(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1846,axiom,
    ! [VarCurr: state_type] :
      ( v92174(VarCurr)
    <=> ( v92175(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1845,axiom,
    ! [VarCurr: state_type] :
      ( v92175(VarCurr)
    <=> ( v92176(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1844,axiom,
    ! [VarCurr: state_type] :
      ( v92176(VarCurr)
    <=> ( v92177(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1843,axiom,
    ! [VarCurr: state_type] :
      ( v92177(VarCurr)
    <=> ( v92178(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1842,axiom,
    ! [VarCurr: state_type] :
      ( v92178(VarCurr)
    <=> ( v92179(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1841,axiom,
    ! [VarCurr: state_type] :
      ( v92179(VarCurr)
    <=> ( v92180(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1840,axiom,
    ! [VarCurr: state_type] :
      ( v92180(VarCurr)
    <=> ( v92181(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1839,axiom,
    ! [VarCurr: state_type] :
      ( v92181(VarCurr)
    <=> ( v92182(VarCurr)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1838,axiom,
    ! [VarCurr: state_type] :
      ( v92182(VarCurr)
    <=> ( v92183(VarCurr)
      <~> v91908(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1837,axiom,
    ! [VarCurr: state_type] :
      ( v92183(VarCurr)
    <=> ( v92184(VarCurr)
      <~> v91908(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1836,axiom,
    ! [VarCurr: state_type] :
      ( v92184(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1835,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,5)
    <=> ( v92104(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1834,axiom,
    ! [VarCurr: state_type] :
      ( v92104(VarCurr)
    <=> ( v92105(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1833,axiom,
    ! [VarCurr: state_type] :
      ( v92105(VarCurr)
    <=> ( v92106(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1832,axiom,
    ! [VarCurr: state_type] :
      ( v92106(VarCurr)
    <=> ( v92107(VarCurr)
      <~> v91908(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1831,axiom,
    ! [VarCurr: state_type] :
      ( v92107(VarCurr)
    <=> ( v92108(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1830,axiom,
    ! [VarCurr: state_type] :
      ( v92108(VarCurr)
    <=> ( v92109(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1829,axiom,
    ! [VarCurr: state_type] :
      ( v92109(VarCurr)
    <=> ( v92110(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1828,axiom,
    ! [VarCurr: state_type] :
      ( v92110(VarCurr)
    <=> ( v92111(VarCurr)
      <~> v91908(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1827,axiom,
    ! [VarCurr: state_type] :
      ( v92111(VarCurr)
    <=> ( v92112(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1826,axiom,
    ! [VarCurr: state_type] :
      ( v92112(VarCurr)
    <=> ( v92113(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1825,axiom,
    ! [VarCurr: state_type] :
      ( v92113(VarCurr)
    <=> ( v92114(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1824,axiom,
    ! [VarCurr: state_type] :
      ( v92114(VarCurr)
    <=> ( v92115(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1823,axiom,
    ! [VarCurr: state_type] :
      ( v92115(VarCurr)
    <=> ( v92116(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1822,axiom,
    ! [VarCurr: state_type] :
      ( v92116(VarCurr)
    <=> ( v92117(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1821,axiom,
    ! [VarCurr: state_type] :
      ( v92117(VarCurr)
    <=> ( v92118(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1820,axiom,
    ! [VarCurr: state_type] :
      ( v92118(VarCurr)
    <=> ( v92119(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1819,axiom,
    ! [VarCurr: state_type] :
      ( v92119(VarCurr)
    <=> ( v92120(VarCurr)
      <~> v91908(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1818,axiom,
    ! [VarCurr: state_type] :
      ( v92120(VarCurr)
    <=> ( v92121(VarCurr)
      <~> v91908(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1817,axiom,
    ! [VarCurr: state_type] :
      ( v92121(VarCurr)
    <=> ( v92122(VarCurr)
      <~> v91908(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1816,axiom,
    ! [VarCurr: state_type] :
      ( v92122(VarCurr)
    <=> ( v92123(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1815,axiom,
    ! [VarCurr: state_type] :
      ( v92123(VarCurr)
    <=> ( v92124(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1814,axiom,
    ! [VarCurr: state_type] :
      ( v92124(VarCurr)
    <=> ( v92125(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1813,axiom,
    ! [VarCurr: state_type] :
      ( v92125(VarCurr)
    <=> ( v92126(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1812,axiom,
    ! [VarCurr: state_type] :
      ( v92126(VarCurr)
    <=> ( v92127(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1811,axiom,
    ! [VarCurr: state_type] :
      ( v92127(VarCurr)
    <=> ( v92128(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1810,axiom,
    ! [VarCurr: state_type] :
      ( v92128(VarCurr)
    <=> ( v92129(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1809,axiom,
    ! [VarCurr: state_type] :
      ( v92129(VarCurr)
    <=> ( v92130(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1808,axiom,
    ! [VarCurr: state_type] :
      ( v92130(VarCurr)
    <=> ( v92131(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1807,axiom,
    ! [VarCurr: state_type] :
      ( v92131(VarCurr)
    <=> ( v92132(VarCurr)
      <~> v91908(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1806,axiom,
    ! [VarCurr: state_type] :
      ( v92132(VarCurr)
    <=> ( v92133(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1805,axiom,
    ! [VarCurr: state_type] :
      ( v92133(VarCurr)
    <=> ( v92134(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1804,axiom,
    ! [VarCurr: state_type] :
      ( v92134(VarCurr)
    <=> ( v92135(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1803,axiom,
    ! [VarCurr: state_type] :
      ( v92135(VarCurr)
    <=> ( v92136(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1802,axiom,
    ! [VarCurr: state_type] :
      ( v92136(VarCurr)
    <=> ( v92137(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1801,axiom,
    ! [VarCurr: state_type] :
      ( v92137(VarCurr)
    <=> ( v92138(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1800,axiom,
    ! [VarCurr: state_type] :
      ( v92138(VarCurr)
    <=> ( v92139(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1799,axiom,
    ! [VarCurr: state_type] :
      ( v92139(VarCurr)
    <=> ( v92140(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1798,axiom,
    ! [VarCurr: state_type] :
      ( v92140(VarCurr)
    <=> ( v92141(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1797,axiom,
    ! [VarCurr: state_type] :
      ( v92141(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1796,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,4)
    <=> ( v92065(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1795,axiom,
    ! [VarCurr: state_type] :
      ( v92065(VarCurr)
    <=> ( v92066(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1794,axiom,
    ! [VarCurr: state_type] :
      ( v92066(VarCurr)
    <=> ( v92067(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1793,axiom,
    ! [VarCurr: state_type] :
      ( v92067(VarCurr)
    <=> ( v92068(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1792,axiom,
    ! [VarCurr: state_type] :
      ( v92068(VarCurr)
    <=> ( v92069(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1791,axiom,
    ! [VarCurr: state_type] :
      ( v92069(VarCurr)
    <=> ( v92070(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1790,axiom,
    ! [VarCurr: state_type] :
      ( v92070(VarCurr)
    <=> ( v92071(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1789,axiom,
    ! [VarCurr: state_type] :
      ( v92071(VarCurr)
    <=> ( v92072(VarCurr)
      <~> v91908(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1788,axiom,
    ! [VarCurr: state_type] :
      ( v92072(VarCurr)
    <=> ( v92073(VarCurr)
      <~> v91908(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1787,axiom,
    ! [VarCurr: state_type] :
      ( v92073(VarCurr)
    <=> ( v92074(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1786,axiom,
    ! [VarCurr: state_type] :
      ( v92074(VarCurr)
    <=> ( v92075(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1785,axiom,
    ! [VarCurr: state_type] :
      ( v92075(VarCurr)
    <=> ( v92076(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1784,axiom,
    ! [VarCurr: state_type] :
      ( v92076(VarCurr)
    <=> ( v92077(VarCurr)
      <~> v91908(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1783,axiom,
    ! [VarCurr: state_type] :
      ( v92077(VarCurr)
    <=> ( v92078(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1782,axiom,
    ! [VarCurr: state_type] :
      ( v92078(VarCurr)
    <=> ( v92079(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1781,axiom,
    ! [VarCurr: state_type] :
      ( v92079(VarCurr)
    <=> ( v92080(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1780,axiom,
    ! [VarCurr: state_type] :
      ( v92080(VarCurr)
    <=> ( v92081(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1779,axiom,
    ! [VarCurr: state_type] :
      ( v92081(VarCurr)
    <=> ( v92082(VarCurr)
      <~> v91908(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1778,axiom,
    ! [VarCurr: state_type] :
      ( v92082(VarCurr)
    <=> ( v92083(VarCurr)
      <~> v91908(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1777,axiom,
    ! [VarCurr: state_type] :
      ( v92083(VarCurr)
    <=> ( v92084(VarCurr)
      <~> v91908(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1776,axiom,
    ! [VarCurr: state_type] :
      ( v92084(VarCurr)
    <=> ( v92085(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1775,axiom,
    ! [VarCurr: state_type] :
      ( v92085(VarCurr)
    <=> ( v92086(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1774,axiom,
    ! [VarCurr: state_type] :
      ( v92086(VarCurr)
    <=> ( v92087(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1773,axiom,
    ! [VarCurr: state_type] :
      ( v92087(VarCurr)
    <=> ( v92088(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1772,axiom,
    ! [VarCurr: state_type] :
      ( v92088(VarCurr)
    <=> ( v92089(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1771,axiom,
    ! [VarCurr: state_type] :
      ( v92089(VarCurr)
    <=> ( v92090(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1770,axiom,
    ! [VarCurr: state_type] :
      ( v92090(VarCurr)
    <=> ( v92091(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1769,axiom,
    ! [VarCurr: state_type] :
      ( v92091(VarCurr)
    <=> ( v92092(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1768,axiom,
    ! [VarCurr: state_type] :
      ( v92092(VarCurr)
    <=> ( v92093(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1767,axiom,
    ! [VarCurr: state_type] :
      ( v92093(VarCurr)
    <=> ( v92094(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1766,axiom,
    ! [VarCurr: state_type] :
      ( v92094(VarCurr)
    <=> ( v92095(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1765,axiom,
    ! [VarCurr: state_type] :
      ( v92095(VarCurr)
    <=> ( v92096(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1764,axiom,
    ! [VarCurr: state_type] :
      ( v92096(VarCurr)
    <=> ( v92097(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1763,axiom,
    ! [VarCurr: state_type] :
      ( v92097(VarCurr)
    <=> ( v92098(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1762,axiom,
    ! [VarCurr: state_type] :
      ( v92098(VarCurr)
    <=> ( v92099(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1761,axiom,
    ! [VarCurr: state_type] :
      ( v92099(VarCurr)
    <=> ( v92100(VarCurr)
      <~> v91908(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1760,axiom,
    ! [VarCurr: state_type] :
      ( v92100(VarCurr)
    <=> ( v92101(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1759,axiom,
    ! [VarCurr: state_type] :
      ( v92101(VarCurr)
    <=> ( v92102(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1758,axiom,
    ! [VarCurr: state_type] :
      ( v92102(VarCurr)
    <=> ( v91908(VarCurr,70)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1757,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,3)
    <=> ( v92025(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1756,axiom,
    ! [VarCurr: state_type] :
      ( v92025(VarCurr)
    <=> ( v92026(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1755,axiom,
    ! [VarCurr: state_type] :
      ( v92026(VarCurr)
    <=> ( v92027(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1754,axiom,
    ! [VarCurr: state_type] :
      ( v92027(VarCurr)
    <=> ( v92028(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1753,axiom,
    ! [VarCurr: state_type] :
      ( v92028(VarCurr)
    <=> ( v92029(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1752,axiom,
    ! [VarCurr: state_type] :
      ( v92029(VarCurr)
    <=> ( v92030(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1751,axiom,
    ! [VarCurr: state_type] :
      ( v92030(VarCurr)
    <=> ( v92031(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1750,axiom,
    ! [VarCurr: state_type] :
      ( v92031(VarCurr)
    <=> ( v92032(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1749,axiom,
    ! [VarCurr: state_type] :
      ( v92032(VarCurr)
    <=> ( v92033(VarCurr)
      <~> v91908(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1748,axiom,
    ! [VarCurr: state_type] :
      ( v92033(VarCurr)
    <=> ( v92034(VarCurr)
      <~> v91908(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1747,axiom,
    ! [VarCurr: state_type] :
      ( v92034(VarCurr)
    <=> ( v92035(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1746,axiom,
    ! [VarCurr: state_type] :
      ( v92035(VarCurr)
    <=> ( v92036(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1745,axiom,
    ! [VarCurr: state_type] :
      ( v92036(VarCurr)
    <=> ( v92037(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1744,axiom,
    ! [VarCurr: state_type] :
      ( v92037(VarCurr)
    <=> ( v92038(VarCurr)
      <~> v91908(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1743,axiom,
    ! [VarCurr: state_type] :
      ( v92038(VarCurr)
    <=> ( v92039(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1742,axiom,
    ! [VarCurr: state_type] :
      ( v92039(VarCurr)
    <=> ( v92040(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1741,axiom,
    ! [VarCurr: state_type] :
      ( v92040(VarCurr)
    <=> ( v92041(VarCurr)
      <~> v91908(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1740,axiom,
    ! [VarCurr: state_type] :
      ( v92041(VarCurr)
    <=> ( v92042(VarCurr)
      <~> v91908(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1739,axiom,
    ! [VarCurr: state_type] :
      ( v92042(VarCurr)
    <=> ( v92043(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1738,axiom,
    ! [VarCurr: state_type] :
      ( v92043(VarCurr)
    <=> ( v92044(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1737,axiom,
    ! [VarCurr: state_type] :
      ( v92044(VarCurr)
    <=> ( v92045(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1736,axiom,
    ! [VarCurr: state_type] :
      ( v92045(VarCurr)
    <=> ( v92046(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1735,axiom,
    ! [VarCurr: state_type] :
      ( v92046(VarCurr)
    <=> ( v92047(VarCurr)
      <~> v91908(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1734,axiom,
    ! [VarCurr: state_type] :
      ( v92047(VarCurr)
    <=> ( v92048(VarCurr)
      <~> v91908(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1733,axiom,
    ! [VarCurr: state_type] :
      ( v92048(VarCurr)
    <=> ( v92049(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1732,axiom,
    ! [VarCurr: state_type] :
      ( v92049(VarCurr)
    <=> ( v92050(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1731,axiom,
    ! [VarCurr: state_type] :
      ( v92050(VarCurr)
    <=> ( v92051(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1730,axiom,
    ! [VarCurr: state_type] :
      ( v92051(VarCurr)
    <=> ( v92052(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1729,axiom,
    ! [VarCurr: state_type] :
      ( v92052(VarCurr)
    <=> ( v92053(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1728,axiom,
    ! [VarCurr: state_type] :
      ( v92053(VarCurr)
    <=> ( v92054(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1727,axiom,
    ! [VarCurr: state_type] :
      ( v92054(VarCurr)
    <=> ( v92055(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1726,axiom,
    ! [VarCurr: state_type] :
      ( v92055(VarCurr)
    <=> ( v92056(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1725,axiom,
    ! [VarCurr: state_type] :
      ( v92056(VarCurr)
    <=> ( v92057(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1724,axiom,
    ! [VarCurr: state_type] :
      ( v92057(VarCurr)
    <=> ( v92058(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1723,axiom,
    ! [VarCurr: state_type] :
      ( v92058(VarCurr)
    <=> ( v92059(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1722,axiom,
    ! [VarCurr: state_type] :
      ( v92059(VarCurr)
    <=> ( v92060(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1721,axiom,
    ! [VarCurr: state_type] :
      ( v92060(VarCurr)
    <=> ( v92061(VarCurr)
      <~> v91908(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1720,axiom,
    ! [VarCurr: state_type] :
      ( v92061(VarCurr)
    <=> ( v92062(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1719,axiom,
    ! [VarCurr: state_type] :
      ( v92062(VarCurr)
    <=> ( v92063(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1718,axiom,
    ! [VarCurr: state_type] :
      ( v92063(VarCurr)
    <=> ( v91908(VarCurr,70)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1717,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,2)
    <=> ( v91991(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1716,axiom,
    ! [VarCurr: state_type] :
      ( v91991(VarCurr)
    <=> ( v91992(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1715,axiom,
    ! [VarCurr: state_type] :
      ( v91992(VarCurr)
    <=> ( v91993(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1714,axiom,
    ! [VarCurr: state_type] :
      ( v91993(VarCurr)
    <=> ( v91994(VarCurr)
      <~> v91908(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1713,axiom,
    ! [VarCurr: state_type] :
      ( v91994(VarCurr)
    <=> ( v91995(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1712,axiom,
    ! [VarCurr: state_type] :
      ( v91995(VarCurr)
    <=> ( v91996(VarCurr)
      <~> v91908(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1711,axiom,
    ! [VarCurr: state_type] :
      ( v91996(VarCurr)
    <=> ( v91997(VarCurr)
      <~> v91908(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1710,axiom,
    ! [VarCurr: state_type] :
      ( v91997(VarCurr)
    <=> ( v91998(VarCurr)
      <~> v91908(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1709,axiom,
    ! [VarCurr: state_type] :
      ( v91998(VarCurr)
    <=> ( v91999(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1708,axiom,
    ! [VarCurr: state_type] :
      ( v91999(VarCurr)
    <=> ( v92000(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1707,axiom,
    ! [VarCurr: state_type] :
      ( v92000(VarCurr)
    <=> ( v92001(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1706,axiom,
    ! [VarCurr: state_type] :
      ( v92001(VarCurr)
    <=> ( v92002(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1705,axiom,
    ! [VarCurr: state_type] :
      ( v92002(VarCurr)
    <=> ( v92003(VarCurr)
      <~> v91908(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1704,axiom,
    ! [VarCurr: state_type] :
      ( v92003(VarCurr)
    <=> ( v92004(VarCurr)
      <~> v91908(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1703,axiom,
    ! [VarCurr: state_type] :
      ( v92004(VarCurr)
    <=> ( v92005(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1702,axiom,
    ! [VarCurr: state_type] :
      ( v92005(VarCurr)
    <=> ( v92006(VarCurr)
      <~> v91908(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1701,axiom,
    ! [VarCurr: state_type] :
      ( v92006(VarCurr)
    <=> ( v92007(VarCurr)
      <~> v91908(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1700,axiom,
    ! [VarCurr: state_type] :
      ( v92007(VarCurr)
    <=> ( v92008(VarCurr)
      <~> v91908(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1699,axiom,
    ! [VarCurr: state_type] :
      ( v92008(VarCurr)
    <=> ( v92009(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1698,axiom,
    ! [VarCurr: state_type] :
      ( v92009(VarCurr)
    <=> ( v92010(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1697,axiom,
    ! [VarCurr: state_type] :
      ( v92010(VarCurr)
    <=> ( v92011(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1696,axiom,
    ! [VarCurr: state_type] :
      ( v92011(VarCurr)
    <=> ( v92012(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1695,axiom,
    ! [VarCurr: state_type] :
      ( v92012(VarCurr)
    <=> ( v92013(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1694,axiom,
    ! [VarCurr: state_type] :
      ( v92013(VarCurr)
    <=> ( v92014(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1693,axiom,
    ! [VarCurr: state_type] :
      ( v92014(VarCurr)
    <=> ( v92015(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1692,axiom,
    ! [VarCurr: state_type] :
      ( v92015(VarCurr)
    <=> ( v92016(VarCurr)
      <~> v91908(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1691,axiom,
    ! [VarCurr: state_type] :
      ( v92016(VarCurr)
    <=> ( v92017(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1690,axiom,
    ! [VarCurr: state_type] :
      ( v92017(VarCurr)
    <=> ( v92018(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1689,axiom,
    ! [VarCurr: state_type] :
      ( v92018(VarCurr)
    <=> ( v92019(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1688,axiom,
    ! [VarCurr: state_type] :
      ( v92019(VarCurr)
    <=> ( v92020(VarCurr)
      <~> v91908(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1687,axiom,
    ! [VarCurr: state_type] :
      ( v92020(VarCurr)
    <=> ( v92021(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1686,axiom,
    ! [VarCurr: state_type] :
      ( v92021(VarCurr)
    <=> ( v92022(VarCurr)
      <~> v91908(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1685,axiom,
    ! [VarCurr: state_type] :
      ( v92022(VarCurr)
    <=> ( v92023(VarCurr)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1684,axiom,
    ! [VarCurr: state_type] :
      ( v92023(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1683,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,1)
    <=> ( v91957(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1682,axiom,
    ! [VarCurr: state_type] :
      ( v91957(VarCurr)
    <=> ( v91958(VarCurr)
      <~> v91908(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1681,axiom,
    ! [VarCurr: state_type] :
      ( v91958(VarCurr)
    <=> ( v91959(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1680,axiom,
    ! [VarCurr: state_type] :
      ( v91959(VarCurr)
    <=> ( v91960(VarCurr)
      <~> v91908(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1679,axiom,
    ! [VarCurr: state_type] :
      ( v91960(VarCurr)
    <=> ( v91961(VarCurr)
      <~> v91908(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1678,axiom,
    ! [VarCurr: state_type] :
      ( v91961(VarCurr)
    <=> ( v91962(VarCurr)
      <~> v91908(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1677,axiom,
    ! [VarCurr: state_type] :
      ( v91962(VarCurr)
    <=> ( v91963(VarCurr)
      <~> v91908(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1676,axiom,
    ! [VarCurr: state_type] :
      ( v91963(VarCurr)
    <=> ( v91964(VarCurr)
      <~> v91908(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1675,axiom,
    ! [VarCurr: state_type] :
      ( v91964(VarCurr)
    <=> ( v91965(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1674,axiom,
    ! [VarCurr: state_type] :
      ( v91965(VarCurr)
    <=> ( v91966(VarCurr)
      <~> v91908(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1673,axiom,
    ! [VarCurr: state_type] :
      ( v91966(VarCurr)
    <=> ( v91967(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1672,axiom,
    ! [VarCurr: state_type] :
      ( v91967(VarCurr)
    <=> ( v91968(VarCurr)
      <~> v91908(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1671,axiom,
    ! [VarCurr: state_type] :
      ( v91968(VarCurr)
    <=> ( v91969(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1670,axiom,
    ! [VarCurr: state_type] :
      ( v91969(VarCurr)
    <=> ( v91970(VarCurr)
      <~> v91908(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1669,axiom,
    ! [VarCurr: state_type] :
      ( v91970(VarCurr)
    <=> ( v91971(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1668,axiom,
    ! [VarCurr: state_type] :
      ( v91971(VarCurr)
    <=> ( v91972(VarCurr)
      <~> v91908(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1667,axiom,
    ! [VarCurr: state_type] :
      ( v91972(VarCurr)
    <=> ( v91973(VarCurr)
      <~> v91908(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1666,axiom,
    ! [VarCurr: state_type] :
      ( v91973(VarCurr)
    <=> ( v91974(VarCurr)
      <~> v91908(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1665,axiom,
    ! [VarCurr: state_type] :
      ( v91974(VarCurr)
    <=> ( v91975(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1664,axiom,
    ! [VarCurr: state_type] :
      ( v91975(VarCurr)
    <=> ( v91976(VarCurr)
      <~> v91908(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1663,axiom,
    ! [VarCurr: state_type] :
      ( v91976(VarCurr)
    <=> ( v91977(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1662,axiom,
    ! [VarCurr: state_type] :
      ( v91977(VarCurr)
    <=> ( v91978(VarCurr)
      <~> v91908(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1661,axiom,
    ! [VarCurr: state_type] :
      ( v91978(VarCurr)
    <=> ( v91979(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1660,axiom,
    ! [VarCurr: state_type] :
      ( v91979(VarCurr)
    <=> ( v91980(VarCurr)
      <~> v91908(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1659,axiom,
    ! [VarCurr: state_type] :
      ( v91980(VarCurr)
    <=> ( v91981(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1658,axiom,
    ! [VarCurr: state_type] :
      ( v91981(VarCurr)
    <=> ( v91982(VarCurr)
      <~> v91908(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1657,axiom,
    ! [VarCurr: state_type] :
      ( v91982(VarCurr)
    <=> ( v91983(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1656,axiom,
    ! [VarCurr: state_type] :
      ( v91983(VarCurr)
    <=> ( v91984(VarCurr)
      <~> v91908(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1655,axiom,
    ! [VarCurr: state_type] :
      ( v91984(VarCurr)
    <=> ( v91985(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1654,axiom,
    ! [VarCurr: state_type] :
      ( v91985(VarCurr)
    <=> ( v91986(VarCurr)
      <~> v91908(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1653,axiom,
    ! [VarCurr: state_type] :
      ( v91986(VarCurr)
    <=> ( v91987(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1652,axiom,
    ! [VarCurr: state_type] :
      ( v91987(VarCurr)
    <=> ( v91988(VarCurr)
      <~> v91908(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1651,axiom,
    ! [VarCurr: state_type] :
      ( v91988(VarCurr)
    <=> ( v91989(VarCurr)
      <~> v91908(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1650,axiom,
    ! [VarCurr: state_type] :
      ( v91989(VarCurr)
    <=> ( v91908(VarCurr,70)
      <~> v91908(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8661,axiom,
    ! [VarCurr: state_type] :
      ( v91906(VarCurr,0)
    <=> ( v91917(VarCurr)
      <~> v91908(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1649,axiom,
    ! [VarCurr: state_type] :
      ( v91917(VarCurr)
    <=> ( v91918(VarCurr)
      <~> v91908(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1648,axiom,
    ! [VarCurr: state_type] :
      ( v91918(VarCurr)
    <=> ( v91919(VarCurr)
      <~> v91908(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1647,axiom,
    ! [VarCurr: state_type] :
      ( v91919(VarCurr)
    <=> ( v91920(VarCurr)
      <~> v91908(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1646,axiom,
    ! [VarCurr: state_type] :
      ( v91920(VarCurr)
    <=> ( v91921(VarCurr)
      <~> v91908(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1645,axiom,
    ! [VarCurr: state_type] :
      ( v91921(VarCurr)
    <=> ( v91922(VarCurr)
      <~> v91908(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1644,axiom,
    ! [VarCurr: state_type] :
      ( v91922(VarCurr)
    <=> ( v91923(VarCurr)
      <~> v91908(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1643,axiom,
    ! [VarCurr: state_type] :
      ( v91923(VarCurr)
    <=> ( v91924(VarCurr)
      <~> v91908(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1642,axiom,
    ! [VarCurr: state_type] :
      ( v91924(VarCurr)
    <=> ( v91925(VarCurr)
      <~> v91908(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1641,axiom,
    ! [VarCurr: state_type] :
      ( v91925(VarCurr)
    <=> ( v91926(VarCurr)
      <~> v91908(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1640,axiom,
    ! [VarCurr: state_type] :
      ( v91926(VarCurr)
    <=> ( v91927(VarCurr)
      <~> v91908(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1639,axiom,
    ! [VarCurr: state_type] :
      ( v91927(VarCurr)
    <=> ( v91928(VarCurr)
      <~> v91908(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1638,axiom,
    ! [VarCurr: state_type] :
      ( v91928(VarCurr)
    <=> ( v91929(VarCurr)
      <~> v91908(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1637,axiom,
    ! [VarCurr: state_type] :
      ( v91929(VarCurr)
    <=> ( v91930(VarCurr)
      <~> v91908(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1636,axiom,
    ! [VarCurr: state_type] :
      ( v91930(VarCurr)
    <=> ( v91931(VarCurr)
      <~> v91908(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1635,axiom,
    ! [VarCurr: state_type] :
      ( v91931(VarCurr)
    <=> ( v91932(VarCurr)
      <~> v91908(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1634,axiom,
    ! [VarCurr: state_type] :
      ( v91932(VarCurr)
    <=> ( v91933(VarCurr)
      <~> v91908(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1633,axiom,
    ! [VarCurr: state_type] :
      ( v91933(VarCurr)
    <=> ( v91934(VarCurr)
      <~> v91908(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1632,axiom,
    ! [VarCurr: state_type] :
      ( v91934(VarCurr)
    <=> ( v91935(VarCurr)
      <~> v91908(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1631,axiom,
    ! [VarCurr: state_type] :
      ( v91935(VarCurr)
    <=> ( v91936(VarCurr)
      <~> v91908(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1630,axiom,
    ! [VarCurr: state_type] :
      ( v91936(VarCurr)
    <=> ( v91937(VarCurr)
      <~> v91908(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1629,axiom,
    ! [VarCurr: state_type] :
      ( v91937(VarCurr)
    <=> ( v91938(VarCurr)
      <~> v91908(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1628,axiom,
    ! [VarCurr: state_type] :
      ( v91938(VarCurr)
    <=> ( v91939(VarCurr)
      <~> v91908(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1627,axiom,
    ! [VarCurr: state_type] :
      ( v91939(VarCurr)
    <=> ( v91940(VarCurr)
      <~> v91908(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1626,axiom,
    ! [VarCurr: state_type] :
      ( v91940(VarCurr)
    <=> ( v91941(VarCurr)
      <~> v91908(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1625,axiom,
    ! [VarCurr: state_type] :
      ( v91941(VarCurr)
    <=> ( v91942(VarCurr)
      <~> v91908(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1624,axiom,
    ! [VarCurr: state_type] :
      ( v91942(VarCurr)
    <=> ( v91943(VarCurr)
      <~> v91908(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1623,axiom,
    ! [VarCurr: state_type] :
      ( v91943(VarCurr)
    <=> ( v91944(VarCurr)
      <~> v91908(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1622,axiom,
    ! [VarCurr: state_type] :
      ( v91944(VarCurr)
    <=> ( v91945(VarCurr)
      <~> v91908(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1621,axiom,
    ! [VarCurr: state_type] :
      ( v91945(VarCurr)
    <=> ( v91946(VarCurr)
      <~> v91908(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1620,axiom,
    ! [VarCurr: state_type] :
      ( v91946(VarCurr)
    <=> ( v91947(VarCurr)
      <~> v91908(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1619,axiom,
    ! [VarCurr: state_type] :
      ( v91947(VarCurr)
    <=> ( v91948(VarCurr)
      <~> v91908(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1618,axiom,
    ! [VarCurr: state_type] :
      ( v91948(VarCurr)
    <=> ( v91949(VarCurr)
      <~> v91908(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1617,axiom,
    ! [VarCurr: state_type] :
      ( v91949(VarCurr)
    <=> ( v91950(VarCurr)
      <~> v91908(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1616,axiom,
    ! [VarCurr: state_type] :
      ( v91950(VarCurr)
    <=> ( v91951(VarCurr)
      <~> v91908(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1615,axiom,
    ! [VarCurr: state_type] :
      ( v91951(VarCurr)
    <=> ( v91952(VarCurr)
      <~> v91908(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1614,axiom,
    ! [VarCurr: state_type] :
      ( v91952(VarCurr)
    <=> ( v91953(VarCurr)
      <~> v91908(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1613,axiom,
    ! [VarCurr: state_type] :
      ( v91953(VarCurr)
    <=> ( v91954(VarCurr)
      <~> v91908(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1612,axiom,
    ! [VarCurr: state_type] :
      ( v91954(VarCurr)
    <=> ( v91955(VarCurr)
      <~> v91908(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1611,axiom,
    ! [VarCurr: state_type] :
      ( v91955(VarCurr)
    <=> ( v91908(VarCurr,71)
      <~> v91908(VarCurr,70) ) ) ).

tff(addAssignment_55851,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,33)
    <=> v91910(VarCurr,33) ) ).

tff(addAssignment_55850,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,33)
    <=> v91912(VarCurr,33) ) ).

tff(addAssignment_55849,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,33)
    <=> v91914(VarCurr,33) ) ).

tff(addAssignment_55848,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,33)
    <=> v91915(VarCurr,33) ) ).

tff(addAssignment_55847,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,62)
    <=> v91910(VarCurr,62) ) ).

tff(addAssignment_55846,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,62)
    <=> v91912(VarCurr,62) ) ).

tff(addAssignment_55845,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,62)
    <=> v91914(VarCurr,62) ) ).

tff(addAssignment_55844,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,62)
    <=> v91915(VarCurr,62) ) ).

tff(addAssignment_55843,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,15)
    <=> v91910(VarCurr,15) ) ).

tff(addAssignment_55842,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,15)
    <=> v91912(VarCurr,15) ) ).

tff(addAssignment_55841,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,15)
    <=> v91914(VarCurr,15) ) ).

tff(addAssignment_55840,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,15)
    <=> v91915(VarCurr,15) ) ).

tff(addAssignment_55839,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,32)
    <=> v91910(VarCurr,32) ) ).

tff(addAssignment_55838,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,32)
    <=> v91912(VarCurr,32) ) ).

tff(addAssignment_55837,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,32)
    <=> v91914(VarCurr,32) ) ).

tff(addAssignment_55836,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,32)
    <=> v91915(VarCurr,32) ) ).

tff(addAssignment_55835,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,61)
    <=> v91910(VarCurr,61) ) ).

tff(addAssignment_55834,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,61)
    <=> v91912(VarCurr,61) ) ).

tff(addAssignment_55833,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,61)
    <=> v91914(VarCurr,61) ) ).

tff(addAssignment_55832,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,61)
    <=> v91915(VarCurr,61) ) ).

tff(addAssignment_55831,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,5)
    <=> v91910(VarCurr,5) ) ).

tff(addAssignment_55830,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,5)
    <=> v91912(VarCurr,5) ) ).

tff(addAssignment_55829,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,5)
    <=> v91914(VarCurr,5) ) ).

tff(addAssignment_55828,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,5)
    <=> v91915(VarCurr,5) ) ).

tff(addAssignment_55827,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,11)
    <=> v91910(VarCurr,11) ) ).

tff(addAssignment_55826,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,11)
    <=> v91912(VarCurr,11) ) ).

tff(addAssignment_55825,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,11)
    <=> v91914(VarCurr,11) ) ).

tff(addAssignment_55824,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,11)
    <=> v91915(VarCurr,11) ) ).

tff(addAssignment_55823,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,14)
    <=> v91910(VarCurr,14) ) ).

tff(addAssignment_55822,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,14)
    <=> v91912(VarCurr,14) ) ).

tff(addAssignment_55821,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,14)
    <=> v91914(VarCurr,14) ) ).

tff(addAssignment_55820,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,14)
    <=> v91915(VarCurr,14) ) ).

tff(addAssignment_55819,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,24)
    <=> v91910(VarCurr,24) ) ).

tff(addAssignment_55818,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,24)
    <=> v91912(VarCurr,24) ) ).

tff(addAssignment_55817,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,24)
    <=> v91914(VarCurr,24) ) ).

tff(addAssignment_55816,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,24)
    <=> v91915(VarCurr,24) ) ).

tff(addAssignment_55815,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,28)
    <=> v91910(VarCurr,28) ) ).

tff(addAssignment_55814,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,28)
    <=> v91912(VarCurr,28) ) ).

tff(addAssignment_55813,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,28)
    <=> v91914(VarCurr,28) ) ).

tff(addAssignment_55812,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,28)
    <=> v91915(VarCurr,28) ) ).

tff(addAssignment_55811,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,31)
    <=> v91910(VarCurr,31) ) ).

tff(addAssignment_55810,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,31)
    <=> v91912(VarCurr,31) ) ).

tff(addAssignment_55809,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,31)
    <=> v91914(VarCurr,31) ) ).

tff(addAssignment_55808,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,31)
    <=> v91915(VarCurr,31) ) ).

tff(addAssignment_55807,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,51)
    <=> v91910(VarCurr,51) ) ).

tff(addAssignment_55806,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,51)
    <=> v91912(VarCurr,51) ) ).

tff(addAssignment_55805,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,51)
    <=> v91914(VarCurr,51) ) ).

tff(addAssignment_55804,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,51)
    <=> v91915(VarCurr,51) ) ).

tff(addAssignment_55803,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,60)
    <=> v91910(VarCurr,60) ) ).

tff(addAssignment_55802,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,60)
    <=> v91912(VarCurr,60) ) ).

tff(addAssignment_55801,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,60)
    <=> v91914(VarCurr,60) ) ).

tff(addAssignment_55800,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,60)
    <=> v91915(VarCurr,60) ) ).

tff(addAssignment_55799,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,65)
    <=> v91910(VarCurr,65) ) ).

tff(addAssignment_55798,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,65)
    <=> v91912(VarCurr,65) ) ).

tff(addAssignment_55797,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,65)
    <=> v91914(VarCurr,65) ) ).

tff(addAssignment_55796,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,65)
    <=> v91915(VarCurr,65) ) ).

tff(addAssignment_55795,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,2)
    <=> v91910(VarCurr,2) ) ).

tff(addAssignment_55794,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,2)
    <=> v91912(VarCurr,2) ) ).

tff(addAssignment_55793,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,2)
    <=> v91914(VarCurr,2) ) ).

tff(addAssignment_55792,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,2)
    <=> v91915(VarCurr,2) ) ).

tff(addAssignment_55791,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,4)
    <=> v91910(VarCurr,4) ) ).

tff(addAssignment_55790,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,4)
    <=> v91912(VarCurr,4) ) ).

tff(addAssignment_55789,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,4)
    <=> v91914(VarCurr,4) ) ).

tff(addAssignment_55788,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,4)
    <=> v91915(VarCurr,4) ) ).

tff(addAssignment_55787,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,10)
    <=> v91910(VarCurr,10) ) ).

tff(addAssignment_55786,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,10)
    <=> v91912(VarCurr,10) ) ).

tff(addAssignment_55785,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,10)
    <=> v91914(VarCurr,10) ) ).

tff(addAssignment_55784,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,10)
    <=> v91915(VarCurr,10) ) ).

tff(addAssignment_55783,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,13)
    <=> v91910(VarCurr,13) ) ).

tff(addAssignment_55782,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,13)
    <=> v91912(VarCurr,13) ) ).

tff(addAssignment_55781,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,13)
    <=> v91914(VarCurr,13) ) ).

tff(addAssignment_55780,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,13)
    <=> v91915(VarCurr,13) ) ).

tff(addAssignment_55779,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,17)
    <=> v91910(VarCurr,17) ) ).

tff(addAssignment_55778,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,17)
    <=> v91912(VarCurr,17) ) ).

tff(addAssignment_55777,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,17)
    <=> v91914(VarCurr,17) ) ).

tff(addAssignment_55776,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,17)
    <=> v91915(VarCurr,17) ) ).

tff(addAssignment_55775,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,20)
    <=> v91910(VarCurr,20) ) ).

tff(addAssignment_55774,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,20)
    <=> v91912(VarCurr,20) ) ).

tff(addAssignment_55773,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,20)
    <=> v91914(VarCurr,20) ) ).

tff(addAssignment_55772,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,20)
    <=> v91915(VarCurr,20) ) ).

tff(addAssignment_55771,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,23)
    <=> v91910(VarCurr,23) ) ).

tff(addAssignment_55770,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,23)
    <=> v91912(VarCurr,23) ) ).

tff(addAssignment_55769,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,23)
    <=> v91914(VarCurr,23) ) ).

tff(addAssignment_55768,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,23)
    <=> v91915(VarCurr,23) ) ).

tff(addAssignment_55767,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,27)
    <=> v91910(VarCurr,27) ) ).

tff(addAssignment_55766,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,27)
    <=> v91912(VarCurr,27) ) ).

tff(addAssignment_55765,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,27)
    <=> v91914(VarCurr,27) ) ).

tff(addAssignment_55764,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,27)
    <=> v91915(VarCurr,27) ) ).

tff(addAssignment_55763,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,30)
    <=> v91910(VarCurr,30) ) ).

tff(addAssignment_55762,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,30)
    <=> v91912(VarCurr,30) ) ).

tff(addAssignment_55761,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,30)
    <=> v91914(VarCurr,30) ) ).

tff(addAssignment_55760,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,30)
    <=> v91915(VarCurr,30) ) ).

tff(addAssignment_55759,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,43)
    <=> v91910(VarCurr,43) ) ).

tff(addAssignment_55758,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,43)
    <=> v91912(VarCurr,43) ) ).

tff(addAssignment_55757,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,43)
    <=> v91914(VarCurr,43) ) ).

tff(addAssignment_55756,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,43)
    <=> v91915(VarCurr,43) ) ).

tff(addAssignment_55755,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,45)
    <=> v91910(VarCurr,45) ) ).

tff(addAssignment_55754,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,45)
    <=> v91912(VarCurr,45) ) ).

tff(addAssignment_55753,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,45)
    <=> v91914(VarCurr,45) ) ).

tff(addAssignment_55752,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,45)
    <=> v91915(VarCurr,45) ) ).

tff(addAssignment_55751,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,47)
    <=> v91910(VarCurr,47) ) ).

tff(addAssignment_55750,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,47)
    <=> v91912(VarCurr,47) ) ).

tff(addAssignment_55749,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,47)
    <=> v91914(VarCurr,47) ) ).

tff(addAssignment_55748,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,47)
    <=> v91915(VarCurr,47) ) ).

tff(addAssignment_55747,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,50)
    <=> v91910(VarCurr,50) ) ).

tff(addAssignment_55746,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,50)
    <=> v91912(VarCurr,50) ) ).

tff(addAssignment_55745,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,50)
    <=> v91914(VarCurr,50) ) ).

tff(addAssignment_55744,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,50)
    <=> v91915(VarCurr,50) ) ).

tff(addAssignment_55743,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,57)
    <=> v91910(VarCurr,57) ) ).

tff(addAssignment_55742,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,57)
    <=> v91912(VarCurr,57) ) ).

tff(addAssignment_55741,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,57)
    <=> v91914(VarCurr,57) ) ).

tff(addAssignment_55740,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,57)
    <=> v91915(VarCurr,57) ) ).

tff(addAssignment_55739,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,59)
    <=> v91910(VarCurr,59) ) ).

tff(addAssignment_55738,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,59)
    <=> v91912(VarCurr,59) ) ).

tff(addAssignment_55737,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,59)
    <=> v91914(VarCurr,59) ) ).

tff(addAssignment_55736,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,59)
    <=> v91915(VarCurr,59) ) ).

tff(addAssignment_55735,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,64)
    <=> v91910(VarCurr,64) ) ).

tff(addAssignment_55734,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,64)
    <=> v91912(VarCurr,64) ) ).

tff(addAssignment_55733,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,64)
    <=> v91914(VarCurr,64) ) ).

tff(addAssignment_55732,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,64)
    <=> v91915(VarCurr,64) ) ).

tff(addAssignment_55731,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,69)
    <=> v91910(VarCurr,69) ) ).

tff(addAssignment_55730,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,69)
    <=> v91912(VarCurr,69) ) ).

tff(addAssignment_55729,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,69)
    <=> v91914(VarCurr,69) ) ).

tff(addAssignment_55728,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,69)
    <=> v91915(VarCurr,69) ) ).

tff(addAssignment_55727,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,0)
    <=> v91910(VarCurr,0) ) ).

tff(addAssignment_55726,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,0)
    <=> v91912(VarCurr,0) ) ).

tff(addAssignment_55725,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,0)
    <=> v91914(VarCurr,0) ) ).

tff(addAssignment_55724,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,0)
    <=> v91915(VarCurr,0) ) ).

tff(addAssignment_55723,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,1)
    <=> v91910(VarCurr,1) ) ).

tff(addAssignment_55722,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,1)
    <=> v91912(VarCurr,1) ) ).

tff(addAssignment_55721,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,1)
    <=> v91914(VarCurr,1) ) ).

tff(addAssignment_55720,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,1)
    <=> v91915(VarCurr,1) ) ).

tff(addAssignment_55719,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,3)
    <=> v91910(VarCurr,3) ) ).

tff(addAssignment_55718,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,3)
    <=> v91912(VarCurr,3) ) ).

tff(addAssignment_55717,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,3)
    <=> v91914(VarCurr,3) ) ).

tff(addAssignment_55716,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,3)
    <=> v91915(VarCurr,3) ) ).

tff(addAssignment_55715,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,6)
    <=> v91910(VarCurr,6) ) ).

tff(addAssignment_55714,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,6)
    <=> v91912(VarCurr,6) ) ).

tff(addAssignment_55713,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,6)
    <=> v91914(VarCurr,6) ) ).

tff(addAssignment_55712,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,6)
    <=> v91915(VarCurr,6) ) ).

tff(addAssignment_55711,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,7)
    <=> v91910(VarCurr,7) ) ).

tff(addAssignment_55710,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,7)
    <=> v91912(VarCurr,7) ) ).

tff(addAssignment_55709,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,7)
    <=> v91914(VarCurr,7) ) ).

tff(addAssignment_55708,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,7)
    <=> v91915(VarCurr,7) ) ).

tff(addAssignment_55707,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,8)
    <=> v91910(VarCurr,8) ) ).

tff(addAssignment_55706,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,8)
    <=> v91912(VarCurr,8) ) ).

tff(addAssignment_55705,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,8)
    <=> v91914(VarCurr,8) ) ).

tff(addAssignment_55704,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,8)
    <=> v91915(VarCurr,8) ) ).

tff(addAssignment_55703,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,9)
    <=> v91910(VarCurr,9) ) ).

tff(addAssignment_55702,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,9)
    <=> v91912(VarCurr,9) ) ).

tff(addAssignment_55701,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,9)
    <=> v91914(VarCurr,9) ) ).

tff(addAssignment_55700,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,9)
    <=> v91915(VarCurr,9) ) ).

tff(addAssignment_55699,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,12)
    <=> v91910(VarCurr,12) ) ).

tff(addAssignment_55698,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,12)
    <=> v91912(VarCurr,12) ) ).

tff(addAssignment_55697,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,12)
    <=> v91914(VarCurr,12) ) ).

tff(addAssignment_55696,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,12)
    <=> v91915(VarCurr,12) ) ).

tff(addAssignment_55695,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,16)
    <=> v91910(VarCurr,16) ) ).

tff(addAssignment_55694,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,16)
    <=> v91912(VarCurr,16) ) ).

tff(addAssignment_55693,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,16)
    <=> v91914(VarCurr,16) ) ).

tff(addAssignment_55692,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,16)
    <=> v91915(VarCurr,16) ) ).

tff(addAssignment_55691,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,18)
    <=> v91910(VarCurr,18) ) ).

tff(addAssignment_55690,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,18)
    <=> v91912(VarCurr,18) ) ).

tff(addAssignment_55689,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,18)
    <=> v91914(VarCurr,18) ) ).

tff(addAssignment_55688,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,18)
    <=> v91915(VarCurr,18) ) ).

tff(addAssignment_55687,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,19)
    <=> v91910(VarCurr,19) ) ).

tff(addAssignment_55686,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,19)
    <=> v91912(VarCurr,19) ) ).

tff(addAssignment_55685,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,19)
    <=> v91914(VarCurr,19) ) ).

tff(addAssignment_55684,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,19)
    <=> v91915(VarCurr,19) ) ).

tff(addAssignment_55683,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,21)
    <=> v91910(VarCurr,21) ) ).

tff(addAssignment_55682,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,21)
    <=> v91912(VarCurr,21) ) ).

tff(addAssignment_55681,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,21)
    <=> v91914(VarCurr,21) ) ).

tff(addAssignment_55680,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,21)
    <=> v91915(VarCurr,21) ) ).

tff(addAssignment_55679,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,22)
    <=> v91910(VarCurr,22) ) ).

tff(addAssignment_55678,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,22)
    <=> v91912(VarCurr,22) ) ).

tff(addAssignment_55677,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,22)
    <=> v91914(VarCurr,22) ) ).

tff(addAssignment_55676,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,22)
    <=> v91915(VarCurr,22) ) ).

tff(addAssignment_55675,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,25)
    <=> v91910(VarCurr,25) ) ).

tff(addAssignment_55674,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,25)
    <=> v91912(VarCurr,25) ) ).

tff(addAssignment_55673,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,25)
    <=> v91914(VarCurr,25) ) ).

tff(addAssignment_55672,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,25)
    <=> v91915(VarCurr,25) ) ).

tff(addAssignment_55671,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,26)
    <=> v91910(VarCurr,26) ) ).

tff(addAssignment_55670,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,26)
    <=> v91912(VarCurr,26) ) ).

tff(addAssignment_55669,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,26)
    <=> v91914(VarCurr,26) ) ).

tff(addAssignment_55668,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,26)
    <=> v91915(VarCurr,26) ) ).

tff(addAssignment_55667,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,29)
    <=> v91910(VarCurr,29) ) ).

tff(addAssignment_55666,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,29)
    <=> v91912(VarCurr,29) ) ).

tff(addAssignment_55665,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,29)
    <=> v91914(VarCurr,29) ) ).

tff(addAssignment_55664,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,29)
    <=> v91915(VarCurr,29) ) ).

tff(addAssignment_55663,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,34)
    <=> v91910(VarCurr,34) ) ).

tff(addAssignment_55662,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,34)
    <=> v91912(VarCurr,34) ) ).

tff(addAssignment_55661,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,34)
    <=> v91914(VarCurr,34) ) ).

tff(addAssignment_55660,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,34)
    <=> v91915(VarCurr,34) ) ).

tff(addAssignment_55659,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,35)
    <=> v91910(VarCurr,35) ) ).

tff(addAssignment_55658,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,35)
    <=> v91912(VarCurr,35) ) ).

tff(addAssignment_55657,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,35)
    <=> v91914(VarCurr,35) ) ).

tff(addAssignment_55656,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,35)
    <=> v91915(VarCurr,35) ) ).

tff(addAssignment_55655,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,36)
    <=> v91910(VarCurr,36) ) ).

tff(addAssignment_55654,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,36)
    <=> v91912(VarCurr,36) ) ).

tff(addAssignment_55653,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,36)
    <=> v91914(VarCurr,36) ) ).

tff(addAssignment_55652,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,36)
    <=> v91915(VarCurr,36) ) ).

tff(addAssignment_55651,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,37)
    <=> v91910(VarCurr,37) ) ).

tff(addAssignment_55650,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,37)
    <=> v91912(VarCurr,37) ) ).

tff(addAssignment_55649,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,37)
    <=> v91914(VarCurr,37) ) ).

tff(addAssignment_55648,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,37)
    <=> v91915(VarCurr,37) ) ).

tff(addAssignment_55647,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,38)
    <=> v91910(VarCurr,38) ) ).

tff(addAssignment_55646,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,38)
    <=> v91912(VarCurr,38) ) ).

tff(addAssignment_55645,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,38)
    <=> v91914(VarCurr,38) ) ).

tff(addAssignment_55644,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,38)
    <=> v91915(VarCurr,38) ) ).

tff(addAssignment_55643,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,39)
    <=> v91910(VarCurr,39) ) ).

tff(addAssignment_55642,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,39)
    <=> v91912(VarCurr,39) ) ).

tff(addAssignment_55641,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,39)
    <=> v91914(VarCurr,39) ) ).

tff(addAssignment_55640,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,39)
    <=> v91915(VarCurr,39) ) ).

tff(addAssignment_55639,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,40)
    <=> v91910(VarCurr,40) ) ).

tff(addAssignment_55638,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,40)
    <=> v91912(VarCurr,40) ) ).

tff(addAssignment_55637,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,40)
    <=> v91914(VarCurr,40) ) ).

tff(addAssignment_55636,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,40)
    <=> v91915(VarCurr,40) ) ).

tff(addAssignment_55635,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,41)
    <=> v91910(VarCurr,41) ) ).

tff(addAssignment_55634,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,41)
    <=> v91912(VarCurr,41) ) ).

tff(addAssignment_55633,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,41)
    <=> v91914(VarCurr,41) ) ).

tff(addAssignment_55632,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,41)
    <=> v91915(VarCurr,41) ) ).

tff(addAssignment_55631,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,42)
    <=> v91910(VarCurr,42) ) ).

tff(addAssignment_55630,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,42)
    <=> v91912(VarCurr,42) ) ).

tff(addAssignment_55629,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,42)
    <=> v91914(VarCurr,42) ) ).

tff(addAssignment_55628,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,42)
    <=> v91915(VarCurr,42) ) ).

tff(addAssignment_55627,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,44)
    <=> v91910(VarCurr,44) ) ).

tff(addAssignment_55626,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,44)
    <=> v91912(VarCurr,44) ) ).

tff(addAssignment_55625,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,44)
    <=> v91914(VarCurr,44) ) ).

tff(addAssignment_55624,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,44)
    <=> v91915(VarCurr,44) ) ).

tff(addAssignment_55623,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,46)
    <=> v91910(VarCurr,46) ) ).

tff(addAssignment_55622,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,46)
    <=> v91912(VarCurr,46) ) ).

tff(addAssignment_55621,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,46)
    <=> v91914(VarCurr,46) ) ).

tff(addAssignment_55620,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,46)
    <=> v91915(VarCurr,46) ) ).

tff(addAssignment_55619,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,48)
    <=> v91910(VarCurr,48) ) ).

tff(addAssignment_55618,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,48)
    <=> v91912(VarCurr,48) ) ).

tff(addAssignment_55617,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,48)
    <=> v91914(VarCurr,48) ) ).

tff(addAssignment_55616,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,48)
    <=> v91915(VarCurr,48) ) ).

tff(addAssignment_55615,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,49)
    <=> v91910(VarCurr,49) ) ).

tff(addAssignment_55614,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,49)
    <=> v91912(VarCurr,49) ) ).

tff(addAssignment_55613,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,49)
    <=> v91914(VarCurr,49) ) ).

tff(addAssignment_55612,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,49)
    <=> v91915(VarCurr,49) ) ).

tff(addAssignment_55611,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,52)
    <=> v91910(VarCurr,52) ) ).

tff(addAssignment_55610,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,52)
    <=> v91912(VarCurr,52) ) ).

tff(addAssignment_55609,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,52)
    <=> v91914(VarCurr,52) ) ).

tff(addAssignment_55608,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,52)
    <=> v91915(VarCurr,52) ) ).

tff(addAssignment_55607,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,53)
    <=> v91910(VarCurr,53) ) ).

tff(addAssignment_55606,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,53)
    <=> v91912(VarCurr,53) ) ).

tff(addAssignment_55605,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,53)
    <=> v91914(VarCurr,53) ) ).

tff(addAssignment_55604,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,53)
    <=> v91915(VarCurr,53) ) ).

tff(addAssignment_55603,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,54)
    <=> v91910(VarCurr,54) ) ).

tff(addAssignment_55602,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,54)
    <=> v91912(VarCurr,54) ) ).

tff(addAssignment_55601,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,54)
    <=> v91914(VarCurr,54) ) ).

tff(addAssignment_55600,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,54)
    <=> v91915(VarCurr,54) ) ).

tff(addAssignment_55599,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,55)
    <=> v91910(VarCurr,55) ) ).

tff(addAssignment_55598,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,55)
    <=> v91912(VarCurr,55) ) ).

tff(addAssignment_55597,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,55)
    <=> v91914(VarCurr,55) ) ).

tff(addAssignment_55596,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,55)
    <=> v91915(VarCurr,55) ) ).

tff(addAssignment_55595,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,56)
    <=> v91910(VarCurr,56) ) ).

tff(addAssignment_55594,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,56)
    <=> v91912(VarCurr,56) ) ).

tff(addAssignment_55593,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,56)
    <=> v91914(VarCurr,56) ) ).

tff(addAssignment_55592,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,56)
    <=> v91915(VarCurr,56) ) ).

tff(addAssignment_55591,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,58)
    <=> v91910(VarCurr,58) ) ).

tff(addAssignment_55590,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,58)
    <=> v91912(VarCurr,58) ) ).

tff(addAssignment_55589,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,58)
    <=> v91914(VarCurr,58) ) ).

tff(addAssignment_55588,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,58)
    <=> v91915(VarCurr,58) ) ).

tff(addAssignment_55587,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,63)
    <=> v91910(VarCurr,63) ) ).

tff(addAssignment_55586,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,63)
    <=> v91912(VarCurr,63) ) ).

tff(addAssignment_55585,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,63)
    <=> v91914(VarCurr,63) ) ).

tff(addAssignment_55584,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,63)
    <=> v91915(VarCurr,63) ) ).

tff(addAssignment_55583,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,66)
    <=> v91910(VarCurr,66) ) ).

tff(addAssignment_55582,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,66)
    <=> v91912(VarCurr,66) ) ).

tff(addAssignment_55581,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,66)
    <=> v91914(VarCurr,66) ) ).

tff(addAssignment_55580,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,66)
    <=> v91915(VarCurr,66) ) ).

tff(addAssignment_55579,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,67)
    <=> v91910(VarCurr,67) ) ).

tff(addAssignment_55578,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,67)
    <=> v91912(VarCurr,67) ) ).

tff(addAssignment_55577,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,67)
    <=> v91914(VarCurr,67) ) ).

tff(addAssignment_55576,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,67)
    <=> v91915(VarCurr,67) ) ).

tff(addAssignment_55575,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,68)
    <=> v91910(VarCurr,68) ) ).

tff(addAssignment_55574,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,68)
    <=> v91912(VarCurr,68) ) ).

tff(addAssignment_55573,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,68)
    <=> v91914(VarCurr,68) ) ).

tff(addAssignment_55572,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,68)
    <=> v91915(VarCurr,68) ) ).

tff(addAssignment_55571,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,70)
    <=> v91910(VarCurr,70) ) ).

tff(addAssignment_55570,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,70)
    <=> v91912(VarCurr,70) ) ).

tff(addAssignment_55569,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,70)
    <=> v91914(VarCurr,70) ) ).

tff(addAssignment_55568,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,70)
    <=> v91915(VarCurr,70) ) ).

tff(addAssignment_55567,axiom,
    ! [VarCurr: state_type] :
      ( v91908(VarCurr,71)
    <=> v91910(VarCurr,71) ) ).

tff(addAssignment_55566,axiom,
    ! [VarCurr: state_type] :
      ( v91910(VarCurr,71)
    <=> v91912(VarCurr,71) ) ).

tff(addAssignment_55565,axiom,
    ! [VarCurr: state_type] :
      ( v91912(VarCurr,71)
    <=> v91914(VarCurr,71) ) ).

tff(addAssignment_55564,axiom,
    ! [VarCurr: state_type] :
      ( v91914(VarCurr,71)
    <=> v91915(VarCurr,71) ) ).

tff(addAssignment_55563,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,0)
    <=> v6234(VarCurr,0) ) ).

tff(addAssignment_55562,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,1)
    <=> v6234(VarCurr,6) ) ).

tff(addAssignment_55561,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,2)
    <=> v6234(VarCurr,12) ) ).

tff(addAssignment_55560,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,3)
    <=> v6234(VarCurr,18) ) ).

tff(addAssignment_55559,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,4)
    <=> v6234(VarCurr,24) ) ).

tff(addAssignment_55558,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,5)
    <=> v6234(VarCurr,30) ) ).

tff(addAssignment_55557,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,6)
    <=> v6234(VarCurr,36) ) ).

tff(addAssignment_55556,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,7)
    <=> v6234(VarCurr,42) ) ).

tff(addAssignment_55555,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,8)
    <=> v6234(VarCurr,48) ) ).

tff(addAssignment_55554,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,9)
    <=> v6234(VarCurr,54) ) ).

tff(addAssignment_55553,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,10)
    <=> v6234(VarCurr,60) ) ).

tff(addAssignment_55552,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,11)
    <=> v6234(VarCurr,66) ) ).

tff(addAssignment_55551,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,12)
    <=> v6234(VarCurr,67) ) ).

tff(addAssignment_55550,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,13)
    <=> v6234(VarCurr,61) ) ).

tff(addAssignment_55549,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,14)
    <=> v6234(VarCurr,55) ) ).

tff(addAssignment_55548,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,15)
    <=> v6234(VarCurr,49) ) ).

tff(addAssignment_55547,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,16)
    <=> v6234(VarCurr,43) ) ).

tff(addAssignment_55546,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,17)
    <=> v6234(VarCurr,37) ) ).

tff(addAssignment_55545,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,18)
    <=> v6234(VarCurr,31) ) ).

tff(addAssignment_55544,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,19)
    <=> v6234(VarCurr,25) ) ).

tff(addAssignment_55543,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,20)
    <=> v6234(VarCurr,19) ) ).

tff(addAssignment_55542,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,21)
    <=> v6234(VarCurr,13) ) ).

tff(addAssignment_55541,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,22)
    <=> v6234(VarCurr,7) ) ).

tff(addAssignment_55540,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,23)
    <=> v6234(VarCurr,1) ) ).

tff(addAssignment_55539,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,24)
    <=> v6234(VarCurr,2) ) ).

tff(addAssignment_55538,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,25)
    <=> v6234(VarCurr,8) ) ).

tff(addAssignment_55537,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,26)
    <=> v6234(VarCurr,14) ) ).

tff(addAssignment_55536,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,27)
    <=> v6234(VarCurr,20) ) ).

tff(addAssignment_55535,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,28)
    <=> v6234(VarCurr,26) ) ).

tff(addAssignment_55534,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,29)
    <=> v6234(VarCurr,32) ) ).

tff(addAssignment_55533,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,30)
    <=> v6234(VarCurr,38) ) ).

tff(addAssignment_55532,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,31)
    <=> v6234(VarCurr,44) ) ).

tff(addAssignment_55531,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,32)
    <=> v6234(VarCurr,50) ) ).

tff(addAssignment_55530,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,33)
    <=> v6234(VarCurr,56) ) ).

tff(addAssignment_55529,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,34)
    <=> v6234(VarCurr,62) ) ).

tff(addAssignment_55528,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,35)
    <=> v6234(VarCurr,68) ) ).

tff(addAssignment_55527,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,36)
    <=> v6234(VarCurr,69) ) ).

tff(addAssignment_55526,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,37)
    <=> v6234(VarCurr,63) ) ).

tff(addAssignment_55525,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,38)
    <=> v6234(VarCurr,57) ) ).

tff(addAssignment_55524,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,39)
    <=> v6234(VarCurr,51) ) ).

tff(addAssignment_55523,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,40)
    <=> v6234(VarCurr,45) ) ).

tff(addAssignment_55522,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,41)
    <=> v6234(VarCurr,39) ) ).

tff(addAssignment_55521,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,42)
    <=> v6234(VarCurr,33) ) ).

tff(addAssignment_55520,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,43)
    <=> v6234(VarCurr,27) ) ).

tff(addAssignment_55519,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,44)
    <=> v6234(VarCurr,21) ) ).

tff(addAssignment_55518,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,45)
    <=> v6234(VarCurr,15) ) ).

tff(addAssignment_55517,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,46)
    <=> v6234(VarCurr,9) ) ).

tff(addAssignment_55516,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,47)
    <=> v6234(VarCurr,3) ) ).

tff(addAssignment_55515,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,48)
    <=> v6234(VarCurr,4) ) ).

tff(addAssignment_55514,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,49)
    <=> v6234(VarCurr,10) ) ).

tff(addAssignment_55513,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,50)
    <=> v6234(VarCurr,16) ) ).

tff(addAssignment_55512,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,51)
    <=> v6234(VarCurr,22) ) ).

tff(addAssignment_55511,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,52)
    <=> v6234(VarCurr,28) ) ).

tff(addAssignment_55510,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,53)
    <=> v6234(VarCurr,34) ) ).

tff(addAssignment_55509,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,54)
    <=> v6234(VarCurr,40) ) ).

tff(addAssignment_55508,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,55)
    <=> v6234(VarCurr,46) ) ).

tff(addAssignment_55507,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,56)
    <=> v6234(VarCurr,52) ) ).

tff(addAssignment_55506,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,57)
    <=> v6234(VarCurr,58) ) ).

tff(addAssignment_55505,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,58)
    <=> v6234(VarCurr,64) ) ).

tff(addAssignment_55504,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,59)
    <=> v6234(VarCurr,70) ) ).

tff(addAssignment_55503,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,60)
    <=> v6234(VarCurr,71) ) ).

tff(addAssignment_55502,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,61)
    <=> v6234(VarCurr,65) ) ).

tff(addAssignment_55501,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,62)
    <=> v6234(VarCurr,59) ) ).

tff(addAssignment_55500,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,63)
    <=> v6234(VarCurr,53) ) ).

tff(addAssignment_55499,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,64)
    <=> v6234(VarCurr,47) ) ).

tff(addAssignment_55498,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,65)
    <=> v6234(VarCurr,41) ) ).

tff(addAssignment_55497,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,66)
    <=> v6234(VarCurr,35) ) ).

tff(addAssignment_55496,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,67)
    <=> v6234(VarCurr,29) ) ).

tff(addAssignment_55495,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,68)
    <=> v6234(VarCurr,23) ) ).

tff(addAssignment_55494,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,69)
    <=> v6234(VarCurr,17) ) ).

tff(addAssignment_55493,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,70)
    <=> v6234(VarCurr,11) ) ).

tff(addAssignment_55492,axiom,
    ! [VarCurr: state_type] :
      ( v91915(VarCurr,71)
    <=> v6234(VarCurr,5) ) ).

tff(addAssignment_55491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91835(VarCurr,B)
      <=> v91837(VarCurr,B) ) ) ).

tff(addAssignment_55490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91837(VarCurr,B)
      <=> v91839(VarCurr,B) ) ) ).

tff(addAssignment_55489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91839(VarCurr,B)
      <=> v91841(VarCurr,B) ) ) ).

tff(addAssignment_55488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91841(VarCurr,B)
      <=> v91843(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91843(VarCurr,B)
      <=> ( v91879(VarCurr,B)
          | v91882(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91882(VarCurr,B)
      <=> ( v91862(VarCurr,B)
          & v91883(VarCurr,B) ) ) ) ).

tff(addAssignment_55487,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,0)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55486,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,1)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55485,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,2)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55484,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,3)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55483,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,4)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55482,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,5)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55481,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,6)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55480,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,7)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55479,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,8)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55478,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,9)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55477,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,10)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55476,axiom,
    ! [VarCurr: state_type] :
      ( v91883(VarCurr,11)
    <=> v91884(VarCurr) ) ).

tff(addAssignment_55475,axiom,
    ! [VarCurr: state_type] :
      ( v91884(VarCurr)
    <=> v91869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91879(VarCurr,B)
      <=> ( v91845(VarCurr,B)
          & v91880(VarCurr,B) ) ) ) ).

tff(addAssignment_55474,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,0)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55473,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,1)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55472,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,2)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55471,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,3)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55470,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,4)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55469,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,5)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55468,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,6)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55467,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,7)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55466,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,8)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55465,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,9)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55464,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,10)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55463,axiom,
    ! [VarCurr: state_type] :
      ( v91880(VarCurr,11)
    <=> v91881(VarCurr) ) ).

tff(addAssignment_55462,axiom,
    ! [VarCurr: state_type] :
      ( v91881(VarCurr)
    <=> v91852(VarCurr) ) ).

tff(addAssignment_55461,axiom,
    ! [VarCurr: state_type] :
      ( v91869(VarCurr)
    <=> v91871(VarCurr) ) ).

tff(addAssignment_55460,axiom,
    ! [VarCurr: state_type] :
      ( v91871(VarCurr)
    <=> v91873(VarCurr) ) ).

tff(addAssignment_55459,axiom,
    ! [VarCurr: state_type] :
      ( v91873(VarCurr)
    <=> v91875(VarCurr) ) ).

tff(addAssignment_55458,axiom,
    ! [VarCurr: state_type] :
      ( v91875(VarCurr)
    <=> v91877(VarCurr) ) ).

tff(addAssignment_55457,axiom,
    ! [VarCurr: state_type] :
      ( v91877(VarCurr)
    <=> v91058(VarCurr) ) ).

tff(addAssignment_55456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91862(VarCurr,B)
      <=> v91864(VarCurr,B) ) ) ).

tff(addAssignment_55455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91864(VarCurr,B)
      <=> v91866(VarCurr,B) ) ) ).

tff(addAssignment_55454,axiom,
    ! [VarCurr: state_type] :
      ( ( v91866(VarCurr,5)
      <=> v6236(VarCurr,155) )
      & ( v91866(VarCurr,4)
      <=> v6236(VarCurr,154) )
      & ( v91866(VarCurr,3)
      <=> v6236(VarCurr,153) )
      & ( v91866(VarCurr,2)
      <=> v6236(VarCurr,152) )
      & ( v91866(VarCurr,1)
      <=> v6236(VarCurr,151) )
      & ( v91866(VarCurr,0)
      <=> v6236(VarCurr,150) ) ) ).

tff(addAssignment_55453,axiom,
    ! [VarCurr: state_type] :
      ( ( v91866(VarCurr,11)
      <=> $false )
      & ( v91866(VarCurr,10)
      <=> $false )
      & ( v91866(VarCurr,9)
      <=> $false )
      & ( v91866(VarCurr,8)
      <=> $false )
      & ( v91866(VarCurr,7)
      <=> $false )
      & ( v91866(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_55452,axiom,
    ! [VarCurr: state_type] :
      ( v91852(VarCurr)
    <=> v91854(VarCurr) ) ).

tff(addAssignment_55451,axiom,
    ! [VarCurr: state_type] :
      ( v91854(VarCurr)
    <=> v91856(VarCurr) ) ).

tff(addAssignment_55450,axiom,
    ! [VarCurr: state_type] :
      ( v91856(VarCurr)
    <=> v91858(VarCurr) ) ).

tff(addAssignment_55449,axiom,
    ! [VarCurr: state_type] :
      ( v91858(VarCurr)
    <=> v91860(VarCurr) ) ).

tff(addAssignment_55448,axiom,
    ! [VarCurr: state_type] :
      ( v91860(VarCurr)
    <=> v91029(VarCurr) ) ).

tff(addAssignment_55447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91845(VarCurr,B)
      <=> v91847(VarCurr,B) ) ) ).

tff(addAssignment_55446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91847(VarCurr,B)
      <=> v91849(VarCurr,B) ) ) ).

tff(addAssignment_55445,axiom,
    ! [VarCurr: state_type] :
      ( ( v91849(VarCurr,5)
      <=> v6236(VarCurr,167) )
      & ( v91849(VarCurr,4)
      <=> v6236(VarCurr,166) )
      & ( v91849(VarCurr,3)
      <=> v6236(VarCurr,165) )
      & ( v91849(VarCurr,2)
      <=> v6236(VarCurr,164) )
      & ( v91849(VarCurr,1)
      <=> v6236(VarCurr,163) )
      & ( v91849(VarCurr,0)
      <=> v6236(VarCurr,162) ) ) ).

tff(addAssignment_55444,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,6)
    <=> v6236(VarCurr,155) ) ).

tff(addAssignment_55443,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,7)
    <=> v6236(VarCurr,154) ) ).

tff(addAssignment_55442,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,8)
    <=> v6236(VarCurr,153) ) ).

tff(addAssignment_55441,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,9)
    <=> v6236(VarCurr,152) ) ).

tff(addAssignment_55440,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,10)
    <=> v6236(VarCurr,151) ) ).

tff(addAssignment_55439,axiom,
    ! [VarCurr: state_type] :
      ( v91849(VarCurr,11)
    <=> v6236(VarCurr,150) ) ).

tff(addAssignment_55438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,162) )
     => ( v6236(VarCurr,B)
      <=> v6238(VarCurr,B) ) ) ).

tff(addAssignment_55437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,162) )
     => ( v6238(VarCurr,B)
      <=> v6240(VarCurr,B) ) ) ).

tff(addAssignment_55436,axiom,
    ! [VarCurr: state_type] :
      ( ( v6240(VarCurr,167)
      <=> v50949(VarCurr,11) )
      & ( v6240(VarCurr,166)
      <=> v50949(VarCurr,10) )
      & ( v6240(VarCurr,165)
      <=> v50949(VarCurr,9) )
      & ( v6240(VarCurr,164)
      <=> v50949(VarCurr,8) )
      & ( v6240(VarCurr,163)
      <=> v50949(VarCurr,7) )
      & ( v6240(VarCurr,162)
      <=> v50949(VarCurr,6) ) ) ).

tff(addAssignment_55435,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,155)
    <=> v6238(VarCurr,155) ) ).

tff(addAssignment_55434,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,155)
    <=> v6240(VarCurr,155) ) ).

tff(addAssignment_55433,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,155)
    <=> v49399(VarCurr,11) ) ).

tff(addAssignment_55432,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,154)
    <=> v6238(VarCurr,154) ) ).

tff(addAssignment_55431,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,154)
    <=> v6240(VarCurr,154) ) ).

tff(addAssignment_55430,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,154)
    <=> v49399(VarCurr,10) ) ).

tff(addAssignment_55429,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,153)
    <=> v6238(VarCurr,153) ) ).

tff(addAssignment_55428,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,153)
    <=> v6240(VarCurr,153) ) ).

tff(addAssignment_55427,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,153)
    <=> v49399(VarCurr,9) ) ).

tff(addAssignment_55426,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,152)
    <=> v6238(VarCurr,152) ) ).

tff(addAssignment_55425,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,152)
    <=> v6240(VarCurr,152) ) ).

tff(addAssignment_55424,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,152)
    <=> v49399(VarCurr,8) ) ).

tff(addAssignment_55423,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,151)
    <=> v6238(VarCurr,151) ) ).

tff(addAssignment_55422,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,151)
    <=> v6240(VarCurr,151) ) ).

tff(addAssignment_55421,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,151)
    <=> v49399(VarCurr,7) ) ).

tff(addAssignment_55420,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,150)
    <=> v6238(VarCurr,150) ) ).

tff(addAssignment_55419,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,150)
    <=> v6240(VarCurr,150) ) ).

tff(addAssignment_55418,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,150)
    <=> v49399(VarCurr,6) ) ).

tff(addAssignment_55417,axiom,
    ! [VarCurr: state_type] :
      ( v90992(VarCurr)
    <=> v90994(VarCurr) ) ).

tff(addAssignment_55416,axiom,
    ! [VarCurr: state_type] :
      ( v90994(VarCurr)
    <=> v90996(VarCurr) ) ).

tff(addAssignment_55415,axiom,
    ! [VarCurr: state_type] :
      ( v90996(VarCurr)
    <=> v90998(VarCurr) ) ).

tff(addAssignment_55414,axiom,
    ! [VarCurr: state_type] :
      ( v90998(VarCurr)
    <=> v91000(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_486,axiom,
    ! [VarCurr: state_type] :
      ( v91000(VarCurr)
    <=> ( ( v91002(VarCurr,11)
        <=> v91069(VarCurr,11) )
        & ( v91002(VarCurr,10)
        <=> v91069(VarCurr,10) )
        & ( v91002(VarCurr,9)
        <=> v91069(VarCurr,9) )
        & ( v91002(VarCurr,8)
        <=> v91069(VarCurr,8) )
        & ( v91002(VarCurr,7)
        <=> v91069(VarCurr,7) )
        & ( v91002(VarCurr,6)
        <=> v91069(VarCurr,6) )
        & ( v91002(VarCurr,5)
        <=> v91069(VarCurr,5) )
        & ( v91002(VarCurr,4)
        <=> v91069(VarCurr,4) )
        & ( v91002(VarCurr,3)
        <=> v91069(VarCurr,3) )
        & ( v91002(VarCurr,2)
        <=> v91069(VarCurr,2) )
        & ( v91002(VarCurr,1)
        <=> v91069(VarCurr,1) )
        & ( v91002(VarCurr,0)
        <=> v91069(VarCurr,0) ) ) ) ).

tff(addAssignment_55413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91069(VarCurr,B)
      <=> v91071(VarCurr,B) ) ) ).

tff(addAssignment_55412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91071(VarCurr,B)
      <=> v91073(VarCurr,B) ) ) ).

tff(addAssignment_55411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91073(VarCurr,B)
      <=> v91075(VarCurr,B) ) ) ).

tff(addAssignment_55410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91075(VarCurr,B)
      <=> v91077(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91077(VarCurr,B)
      <=> ( v91817(VarCurr,B)
          | v91820(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91820(VarCurr,B)
      <=> ( v91574(VarCurr,B)
          & v91821(VarCurr,B) ) ) ) ).

tff(addAssignment_55409,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,0)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55408,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,1)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55407,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,2)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55406,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,3)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55405,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,4)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55404,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,5)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55403,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,6)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55402,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,7)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55401,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,8)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55400,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,9)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55399,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,10)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55398,axiom,
    ! [VarCurr: state_type] :
      ( v91821(VarCurr,11)
    <=> v91822(VarCurr) ) ).

tff(addAssignment_55397,axiom,
    ! [VarCurr: state_type] :
      ( v91822(VarCurr)
    <=> v91807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91817(VarCurr,B)
      <=> ( v91079(VarCurr,B)
          & v91818(VarCurr,B) ) ) ) ).

tff(addAssignment_55396,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,0)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55395,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,1)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55394,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,2)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55393,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,3)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55392,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,4)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55391,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,5)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55390,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,6)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55389,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,7)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55388,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,8)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55387,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,9)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55386,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,10)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55385,axiom,
    ! [VarCurr: state_type] :
      ( v91818(VarCurr,11)
    <=> v91819(VarCurr) ) ).

tff(addAssignment_55384,axiom,
    ! [VarCurr: state_type] :
      ( v91819(VarCurr)
    <=> v91564(VarCurr) ) ).

tff(addAssignment_55383,axiom,
    ! [VarCurr: state_type] :
      ( v91807(VarCurr)
    <=> v91809(VarCurr) ) ).

tff(addAssignment_55382,axiom,
    ! [VarCurr: state_type] :
      ( v91809(VarCurr)
    <=> v91811(VarCurr) ) ).

tff(addAssignment_55381,axiom,
    ! [VarCurr: state_type] :
      ( v91811(VarCurr)
    <=> v91813(VarCurr) ) ).

tff(addAssignment_55380,axiom,
    ! [VarCurr: state_type] :
      ( v91813(VarCurr)
    <=> v91815(VarCurr) ) ).

tff(addAssignment_55379,axiom,
    ! [VarCurr: state_type] :
      ( v91815(VarCurr)
    <=> v91058(VarCurr) ) ).

tff(addAssignment_55378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91574(VarCurr,B)
      <=> v91576(VarCurr,B) ) ) ).

tff(addAssignment_55377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v91576(VarCurr,B)
      <=> v91578(VarCurr,B) ) ) ).

tff(addAssignment_55376,axiom,
    ! [VarCurr: state_type] :
      ( ( v91576(VarCurr,11)
      <=> $false )
      & ( v91576(VarCurr,10)
      <=> $false )
      & ( v91576(VarCurr,9)
      <=> $false )
      & ( v91576(VarCurr,8)
      <=> $false )
      & ( v91576(VarCurr,7)
      <=> $false )
      & ( v91576(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_55375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v91578(VarCurr,B)
      <=> v91580(VarCurr,B) ) ) ).

tff(addAssignment_55374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v91580(VarCurr,B)
      <=> v91582(VarCurr,B) ) ) ).

tff(addAssignment_55373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v91582(VarCurr,B)
      <=> v91584(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1610,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,5)
    <=> ( v91770(VarCurr)
      <~> v91586(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1609,axiom,
    ! [VarCurr: state_type] :
      ( v91770(VarCurr)
    <=> ( v91771(VarCurr)
      <~> v91586(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1608,axiom,
    ! [VarCurr: state_type] :
      ( v91771(VarCurr)
    <=> ( v91772(VarCurr)
      <~> v91586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1607,axiom,
    ! [VarCurr: state_type] :
      ( v91772(VarCurr)
    <=> ( v91773(VarCurr)
      <~> v91586(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1606,axiom,
    ! [VarCurr: state_type] :
      ( v91773(VarCurr)
    <=> ( v91774(VarCurr)
      <~> v91586(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1605,axiom,
    ! [VarCurr: state_type] :
      ( v91774(VarCurr)
    <=> ( v91775(VarCurr)
      <~> v91586(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1604,axiom,
    ! [VarCurr: state_type] :
      ( v91775(VarCurr)
    <=> ( v91776(VarCurr)
      <~> v91586(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1603,axiom,
    ! [VarCurr: state_type] :
      ( v91776(VarCurr)
    <=> ( v91777(VarCurr)
      <~> v91586(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1602,axiom,
    ! [VarCurr: state_type] :
      ( v91777(VarCurr)
    <=> ( v91778(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1601,axiom,
    ! [VarCurr: state_type] :
      ( v91778(VarCurr)
    <=> ( v91779(VarCurr)
      <~> v91586(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1600,axiom,
    ! [VarCurr: state_type] :
      ( v91779(VarCurr)
    <=> ( v91780(VarCurr)
      <~> v91586(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1599,axiom,
    ! [VarCurr: state_type] :
      ( v91780(VarCurr)
    <=> ( v91781(VarCurr)
      <~> v91586(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1598,axiom,
    ! [VarCurr: state_type] :
      ( v91781(VarCurr)
    <=> ( v91782(VarCurr)
      <~> v91586(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1597,axiom,
    ! [VarCurr: state_type] :
      ( v91782(VarCurr)
    <=> ( v91783(VarCurr)
      <~> v91586(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1596,axiom,
    ! [VarCurr: state_type] :
      ( v91783(VarCurr)
    <=> ( v91784(VarCurr)
      <~> v91586(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1595,axiom,
    ! [VarCurr: state_type] :
      ( v91784(VarCurr)
    <=> ( v91785(VarCurr)
      <~> v91586(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1594,axiom,
    ! [VarCurr: state_type] :
      ( v91785(VarCurr)
    <=> ( v91786(VarCurr)
      <~> v91586(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1593,axiom,
    ! [VarCurr: state_type] :
      ( v91786(VarCurr)
    <=> ( v91787(VarCurr)
      <~> v91586(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1592,axiom,
    ! [VarCurr: state_type] :
      ( v91787(VarCurr)
    <=> ( v91788(VarCurr)
      <~> v91586(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1591,axiom,
    ! [VarCurr: state_type] :
      ( v91788(VarCurr)
    <=> ( v91789(VarCurr)
      <~> v91586(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1590,axiom,
    ! [VarCurr: state_type] :
      ( v91789(VarCurr)
    <=> ( v91790(VarCurr)
      <~> v91586(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1589,axiom,
    ! [VarCurr: state_type] :
      ( v91790(VarCurr)
    <=> ( v91791(VarCurr)
      <~> v91586(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1588,axiom,
    ! [VarCurr: state_type] :
      ( v91791(VarCurr)
    <=> ( v91792(VarCurr)
      <~> v91586(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1587,axiom,
    ! [VarCurr: state_type] :
      ( v91792(VarCurr)
    <=> ( v91793(VarCurr)
      <~> v91586(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1586,axiom,
    ! [VarCurr: state_type] :
      ( v91793(VarCurr)
    <=> ( v91794(VarCurr)
      <~> v91586(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1585,axiom,
    ! [VarCurr: state_type] :
      ( v91794(VarCurr)
    <=> ( v91795(VarCurr)
      <~> v91586(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1584,axiom,
    ! [VarCurr: state_type] :
      ( v91795(VarCurr)
    <=> ( v91796(VarCurr)
      <~> v91586(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1583,axiom,
    ! [VarCurr: state_type] :
      ( v91796(VarCurr)
    <=> ( v91797(VarCurr)
      <~> v91586(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1582,axiom,
    ! [VarCurr: state_type] :
      ( v91797(VarCurr)
    <=> ( v91798(VarCurr)
      <~> v91586(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1581,axiom,
    ! [VarCurr: state_type] :
      ( v91798(VarCurr)
    <=> ( v91799(VarCurr)
      <~> v91586(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1580,axiom,
    ! [VarCurr: state_type] :
      ( v91799(VarCurr)
    <=> ( v91800(VarCurr)
      <~> v91586(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1579,axiom,
    ! [VarCurr: state_type] :
      ( v91800(VarCurr)
    <=> ( v91801(VarCurr)
      <~> v91586(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1578,axiom,
    ! [VarCurr: state_type] :
      ( v91801(VarCurr)
    <=> ( v91802(VarCurr)
      <~> v91586(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1577,axiom,
    ! [VarCurr: state_type] :
      ( v91802(VarCurr)
    <=> ( v91803(VarCurr)
      <~> v91586(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1576,axiom,
    ! [VarCurr: state_type] :
      ( v91803(VarCurr)
    <=> ( v91804(VarCurr)
      <~> v91586(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1575,axiom,
    ! [VarCurr: state_type] :
      ( v91804(VarCurr)
    <=> ( v91586(VarCurr,71)
      <~> v91586(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1574,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,4)
    <=> ( v91734(VarCurr)
      <~> v91586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1573,axiom,
    ! [VarCurr: state_type] :
      ( v91734(VarCurr)
    <=> ( v91735(VarCurr)
      <~> v91586(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1572,axiom,
    ! [VarCurr: state_type] :
      ( v91735(VarCurr)
    <=> ( v91736(VarCurr)
      <~> v91586(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1571,axiom,
    ! [VarCurr: state_type] :
      ( v91736(VarCurr)
    <=> ( v91737(VarCurr)
      <~> v91586(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1570,axiom,
    ! [VarCurr: state_type] :
      ( v91737(VarCurr)
    <=> ( v91738(VarCurr)
      <~> v91586(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1569,axiom,
    ! [VarCurr: state_type] :
      ( v91738(VarCurr)
    <=> ( v91739(VarCurr)
      <~> v91586(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1568,axiom,
    ! [VarCurr: state_type] :
      ( v91739(VarCurr)
    <=> ( v91740(VarCurr)
      <~> v91586(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1567,axiom,
    ! [VarCurr: state_type] :
      ( v91740(VarCurr)
    <=> ( v91741(VarCurr)
      <~> v91586(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1566,axiom,
    ! [VarCurr: state_type] :
      ( v91741(VarCurr)
    <=> ( v91742(VarCurr)
      <~> v91586(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1565,axiom,
    ! [VarCurr: state_type] :
      ( v91742(VarCurr)
    <=> ( v91743(VarCurr)
      <~> v91586(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1564,axiom,
    ! [VarCurr: state_type] :
      ( v91743(VarCurr)
    <=> ( v91744(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1563,axiom,
    ! [VarCurr: state_type] :
      ( v91744(VarCurr)
    <=> ( v91745(VarCurr)
      <~> v91586(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1562,axiom,
    ! [VarCurr: state_type] :
      ( v91745(VarCurr)
    <=> ( v91746(VarCurr)
      <~> v91586(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1561,axiom,
    ! [VarCurr: state_type] :
      ( v91746(VarCurr)
    <=> ( v91747(VarCurr)
      <~> v91586(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1560,axiom,
    ! [VarCurr: state_type] :
      ( v91747(VarCurr)
    <=> ( v91748(VarCurr)
      <~> v91586(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1559,axiom,
    ! [VarCurr: state_type] :
      ( v91748(VarCurr)
    <=> ( v91749(VarCurr)
      <~> v91586(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1558,axiom,
    ! [VarCurr: state_type] :
      ( v91749(VarCurr)
    <=> ( v91750(VarCurr)
      <~> v91586(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1557,axiom,
    ! [VarCurr: state_type] :
      ( v91750(VarCurr)
    <=> ( v91751(VarCurr)
      <~> v91586(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1556,axiom,
    ! [VarCurr: state_type] :
      ( v91751(VarCurr)
    <=> ( v91752(VarCurr)
      <~> v91586(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1555,axiom,
    ! [VarCurr: state_type] :
      ( v91752(VarCurr)
    <=> ( v91753(VarCurr)
      <~> v91586(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1554,axiom,
    ! [VarCurr: state_type] :
      ( v91753(VarCurr)
    <=> ( v91754(VarCurr)
      <~> v91586(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1553,axiom,
    ! [VarCurr: state_type] :
      ( v91754(VarCurr)
    <=> ( v91755(VarCurr)
      <~> v91586(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1552,axiom,
    ! [VarCurr: state_type] :
      ( v91755(VarCurr)
    <=> ( v91756(VarCurr)
      <~> v91586(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1551,axiom,
    ! [VarCurr: state_type] :
      ( v91756(VarCurr)
    <=> ( v91757(VarCurr)
      <~> v91586(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1550,axiom,
    ! [VarCurr: state_type] :
      ( v91757(VarCurr)
    <=> ( v91758(VarCurr)
      <~> v91586(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1549,axiom,
    ! [VarCurr: state_type] :
      ( v91758(VarCurr)
    <=> ( v91759(VarCurr)
      <~> v91586(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1548,axiom,
    ! [VarCurr: state_type] :
      ( v91759(VarCurr)
    <=> ( v91760(VarCurr)
      <~> v91586(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1547,axiom,
    ! [VarCurr: state_type] :
      ( v91760(VarCurr)
    <=> ( v91761(VarCurr)
      <~> v91586(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1546,axiom,
    ! [VarCurr: state_type] :
      ( v91761(VarCurr)
    <=> ( v91762(VarCurr)
      <~> v91586(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1545,axiom,
    ! [VarCurr: state_type] :
      ( v91762(VarCurr)
    <=> ( v91763(VarCurr)
      <~> v91586(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1544,axiom,
    ! [VarCurr: state_type] :
      ( v91763(VarCurr)
    <=> ( v91764(VarCurr)
      <~> v91586(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1543,axiom,
    ! [VarCurr: state_type] :
      ( v91764(VarCurr)
    <=> ( v91765(VarCurr)
      <~> v91586(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1542,axiom,
    ! [VarCurr: state_type] :
      ( v91765(VarCurr)
    <=> ( v91766(VarCurr)
      <~> v91586(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1541,axiom,
    ! [VarCurr: state_type] :
      ( v91766(VarCurr)
    <=> ( v91767(VarCurr)
      <~> v91586(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1540,axiom,
    ! [VarCurr: state_type] :
      ( v91767(VarCurr)
    <=> ( v91768(VarCurr)
      <~> v91586(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1539,axiom,
    ! [VarCurr: state_type] :
      ( v91768(VarCurr)
    <=> ( v91586(VarCurr,71)
      <~> v91586(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1538,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,3)
    <=> ( v91697(VarCurr)
      <~> v91586(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1537,axiom,
    ! [VarCurr: state_type] :
      ( v91697(VarCurr)
    <=> ( v91698(VarCurr)
      <~> v91586(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1536,axiom,
    ! [VarCurr: state_type] :
      ( v91698(VarCurr)
    <=> ( v91699(VarCurr)
      <~> v91586(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1535,axiom,
    ! [VarCurr: state_type] :
      ( v91699(VarCurr)
    <=> ( v91700(VarCurr)
      <~> v91586(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1534,axiom,
    ! [VarCurr: state_type] :
      ( v91700(VarCurr)
    <=> ( v91701(VarCurr)
      <~> v91586(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1533,axiom,
    ! [VarCurr: state_type] :
      ( v91701(VarCurr)
    <=> ( v91702(VarCurr)
      <~> v91586(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1532,axiom,
    ! [VarCurr: state_type] :
      ( v91702(VarCurr)
    <=> ( v91703(VarCurr)
      <~> v91586(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1531,axiom,
    ! [VarCurr: state_type] :
      ( v91703(VarCurr)
    <=> ( v91704(VarCurr)
      <~> v91586(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1530,axiom,
    ! [VarCurr: state_type] :
      ( v91704(VarCurr)
    <=> ( v91705(VarCurr)
      <~> v91586(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1529,axiom,
    ! [VarCurr: state_type] :
      ( v91705(VarCurr)
    <=> ( v91706(VarCurr)
      <~> v91586(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1528,axiom,
    ! [VarCurr: state_type] :
      ( v91706(VarCurr)
    <=> ( v91707(VarCurr)
      <~> v91586(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1527,axiom,
    ! [VarCurr: state_type] :
      ( v91707(VarCurr)
    <=> ( v91708(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1526,axiom,
    ! [VarCurr: state_type] :
      ( v91708(VarCurr)
    <=> ( v91709(VarCurr)
      <~> v91586(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1525,axiom,
    ! [VarCurr: state_type] :
      ( v91709(VarCurr)
    <=> ( v91710(VarCurr)
      <~> v91586(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1524,axiom,
    ! [VarCurr: state_type] :
      ( v91710(VarCurr)
    <=> ( v91711(VarCurr)
      <~> v91586(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1523,axiom,
    ! [VarCurr: state_type] :
      ( v91711(VarCurr)
    <=> ( v91712(VarCurr)
      <~> v91586(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1522,axiom,
    ! [VarCurr: state_type] :
      ( v91712(VarCurr)
    <=> ( v91713(VarCurr)
      <~> v91586(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1521,axiom,
    ! [VarCurr: state_type] :
      ( v91713(VarCurr)
    <=> ( v91714(VarCurr)
      <~> v91586(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1520,axiom,
    ! [VarCurr: state_type] :
      ( v91714(VarCurr)
    <=> ( v91715(VarCurr)
      <~> v91586(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1519,axiom,
    ! [VarCurr: state_type] :
      ( v91715(VarCurr)
    <=> ( v91716(VarCurr)
      <~> v91586(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1518,axiom,
    ! [VarCurr: state_type] :
      ( v91716(VarCurr)
    <=> ( v91717(VarCurr)
      <~> v91586(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1517,axiom,
    ! [VarCurr: state_type] :
      ( v91717(VarCurr)
    <=> ( v91718(VarCurr)
      <~> v91586(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1516,axiom,
    ! [VarCurr: state_type] :
      ( v91718(VarCurr)
    <=> ( v91719(VarCurr)
      <~> v91586(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1515,axiom,
    ! [VarCurr: state_type] :
      ( v91719(VarCurr)
    <=> ( v91720(VarCurr)
      <~> v91586(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1514,axiom,
    ! [VarCurr: state_type] :
      ( v91720(VarCurr)
    <=> ( v91721(VarCurr)
      <~> v91586(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1513,axiom,
    ! [VarCurr: state_type] :
      ( v91721(VarCurr)
    <=> ( v91722(VarCurr)
      <~> v91586(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1512,axiom,
    ! [VarCurr: state_type] :
      ( v91722(VarCurr)
    <=> ( v91723(VarCurr)
      <~> v91586(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1511,axiom,
    ! [VarCurr: state_type] :
      ( v91723(VarCurr)
    <=> ( v91724(VarCurr)
      <~> v91586(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1510,axiom,
    ! [VarCurr: state_type] :
      ( v91724(VarCurr)
    <=> ( v91725(VarCurr)
      <~> v91586(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1509,axiom,
    ! [VarCurr: state_type] :
      ( v91725(VarCurr)
    <=> ( v91726(VarCurr)
      <~> v91586(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1508,axiom,
    ! [VarCurr: state_type] :
      ( v91726(VarCurr)
    <=> ( v91727(VarCurr)
      <~> v91586(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1507,axiom,
    ! [VarCurr: state_type] :
      ( v91727(VarCurr)
    <=> ( v91728(VarCurr)
      <~> v91586(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1506,axiom,
    ! [VarCurr: state_type] :
      ( v91728(VarCurr)
    <=> ( v91729(VarCurr)
      <~> v91586(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1505,axiom,
    ! [VarCurr: state_type] :
      ( v91729(VarCurr)
    <=> ( v91730(VarCurr)
      <~> v91586(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1504,axiom,
    ! [VarCurr: state_type] :
      ( v91730(VarCurr)
    <=> ( v91731(VarCurr)
      <~> v91586(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1503,axiom,
    ! [VarCurr: state_type] :
      ( v91731(VarCurr)
    <=> ( v91732(VarCurr)
      <~> v91586(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1502,axiom,
    ! [VarCurr: state_type] :
      ( v91732(VarCurr)
    <=> ( v91586(VarCurr,71)
      <~> v91586(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1501,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,2)
    <=> ( v91659(VarCurr)
      <~> v91586(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1500,axiom,
    ! [VarCurr: state_type] :
      ( v91659(VarCurr)
    <=> ( v91660(VarCurr)
      <~> v91586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1499,axiom,
    ! [VarCurr: state_type] :
      ( v91660(VarCurr)
    <=> ( v91661(VarCurr)
      <~> v91586(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1498,axiom,
    ! [VarCurr: state_type] :
      ( v91661(VarCurr)
    <=> ( v91662(VarCurr)
      <~> v91586(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1497,axiom,
    ! [VarCurr: state_type] :
      ( v91662(VarCurr)
    <=> ( v91663(VarCurr)
      <~> v91586(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1496,axiom,
    ! [VarCurr: state_type] :
      ( v91663(VarCurr)
    <=> ( v91664(VarCurr)
      <~> v91586(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1495,axiom,
    ! [VarCurr: state_type] :
      ( v91664(VarCurr)
    <=> ( v91665(VarCurr)
      <~> v91586(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1494,axiom,
    ! [VarCurr: state_type] :
      ( v91665(VarCurr)
    <=> ( v91666(VarCurr)
      <~> v91586(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1493,axiom,
    ! [VarCurr: state_type] :
      ( v91666(VarCurr)
    <=> ( v91667(VarCurr)
      <~> v91586(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1492,axiom,
    ! [VarCurr: state_type] :
      ( v91667(VarCurr)
    <=> ( v91668(VarCurr)
      <~> v91586(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1491,axiom,
    ! [VarCurr: state_type] :
      ( v91668(VarCurr)
    <=> ( v91669(VarCurr)
      <~> v91586(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1490,axiom,
    ! [VarCurr: state_type] :
      ( v91669(VarCurr)
    <=> ( v91670(VarCurr)
      <~> v91586(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1489,axiom,
    ! [VarCurr: state_type] :
      ( v91670(VarCurr)
    <=> ( v91671(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1488,axiom,
    ! [VarCurr: state_type] :
      ( v91671(VarCurr)
    <=> ( v91672(VarCurr)
      <~> v91586(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1487,axiom,
    ! [VarCurr: state_type] :
      ( v91672(VarCurr)
    <=> ( v91673(VarCurr)
      <~> v91586(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1486,axiom,
    ! [VarCurr: state_type] :
      ( v91673(VarCurr)
    <=> ( v91674(VarCurr)
      <~> v91586(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1485,axiom,
    ! [VarCurr: state_type] :
      ( v91674(VarCurr)
    <=> ( v91675(VarCurr)
      <~> v91586(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1484,axiom,
    ! [VarCurr: state_type] :
      ( v91675(VarCurr)
    <=> ( v91676(VarCurr)
      <~> v91586(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1483,axiom,
    ! [VarCurr: state_type] :
      ( v91676(VarCurr)
    <=> ( v91677(VarCurr)
      <~> v91586(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1482,axiom,
    ! [VarCurr: state_type] :
      ( v91677(VarCurr)
    <=> ( v91678(VarCurr)
      <~> v91586(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1481,axiom,
    ! [VarCurr: state_type] :
      ( v91678(VarCurr)
    <=> ( v91679(VarCurr)
      <~> v91586(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1480,axiom,
    ! [VarCurr: state_type] :
      ( v91679(VarCurr)
    <=> ( v91680(VarCurr)
      <~> v91586(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1479,axiom,
    ! [VarCurr: state_type] :
      ( v91680(VarCurr)
    <=> ( v91681(VarCurr)
      <~> v91586(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1478,axiom,
    ! [VarCurr: state_type] :
      ( v91681(VarCurr)
    <=> ( v91682(VarCurr)
      <~> v91586(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1477,axiom,
    ! [VarCurr: state_type] :
      ( v91682(VarCurr)
    <=> ( v91683(VarCurr)
      <~> v91586(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1476,axiom,
    ! [VarCurr: state_type] :
      ( v91683(VarCurr)
    <=> ( v91684(VarCurr)
      <~> v91586(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1475,axiom,
    ! [VarCurr: state_type] :
      ( v91684(VarCurr)
    <=> ( v91685(VarCurr)
      <~> v91586(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1474,axiom,
    ! [VarCurr: state_type] :
      ( v91685(VarCurr)
    <=> ( v91686(VarCurr)
      <~> v91586(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1473,axiom,
    ! [VarCurr: state_type] :
      ( v91686(VarCurr)
    <=> ( v91687(VarCurr)
      <~> v91586(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1472,axiom,
    ! [VarCurr: state_type] :
      ( v91687(VarCurr)
    <=> ( v91688(VarCurr)
      <~> v91586(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1471,axiom,
    ! [VarCurr: state_type] :
      ( v91688(VarCurr)
    <=> ( v91689(VarCurr)
      <~> v91586(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1470,axiom,
    ! [VarCurr: state_type] :
      ( v91689(VarCurr)
    <=> ( v91690(VarCurr)
      <~> v91586(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1469,axiom,
    ! [VarCurr: state_type] :
      ( v91690(VarCurr)
    <=> ( v91691(VarCurr)
      <~> v91586(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1468,axiom,
    ! [VarCurr: state_type] :
      ( v91691(VarCurr)
    <=> ( v91692(VarCurr)
      <~> v91586(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1467,axiom,
    ! [VarCurr: state_type] :
      ( v91692(VarCurr)
    <=> ( v91693(VarCurr)
      <~> v91586(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1466,axiom,
    ! [VarCurr: state_type] :
      ( v91693(VarCurr)
    <=> ( v91694(VarCurr)
      <~> v91586(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1465,axiom,
    ! [VarCurr: state_type] :
      ( v91694(VarCurr)
    <=> ( v91695(VarCurr)
      <~> v91586(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1464,axiom,
    ! [VarCurr: state_type] :
      ( v91695(VarCurr)
    <=> ( v91586(VarCurr,71)
      <~> v91586(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1463,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,1)
    <=> ( v91624(VarCurr)
      <~> v91586(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1462,axiom,
    ! [VarCurr: state_type] :
      ( v91624(VarCurr)
    <=> ( v91625(VarCurr)
      <~> v91586(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1461,axiom,
    ! [VarCurr: state_type] :
      ( v91625(VarCurr)
    <=> ( v91626(VarCurr)
      <~> v91586(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1460,axiom,
    ! [VarCurr: state_type] :
      ( v91626(VarCurr)
    <=> ( v91627(VarCurr)
      <~> v91586(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1459,axiom,
    ! [VarCurr: state_type] :
      ( v91627(VarCurr)
    <=> ( v91628(VarCurr)
      <~> v91586(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1458,axiom,
    ! [VarCurr: state_type] :
      ( v91628(VarCurr)
    <=> ( v91629(VarCurr)
      <~> v91586(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1457,axiom,
    ! [VarCurr: state_type] :
      ( v91629(VarCurr)
    <=> ( v91630(VarCurr)
      <~> v91586(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1456,axiom,
    ! [VarCurr: state_type] :
      ( v91630(VarCurr)
    <=> ( v91631(VarCurr)
      <~> v91586(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1455,axiom,
    ! [VarCurr: state_type] :
      ( v91631(VarCurr)
    <=> ( v91632(VarCurr)
      <~> v91586(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1454,axiom,
    ! [VarCurr: state_type] :
      ( v91632(VarCurr)
    <=> ( v91633(VarCurr)
      <~> v91586(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1453,axiom,
    ! [VarCurr: state_type] :
      ( v91633(VarCurr)
    <=> ( v91634(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1452,axiom,
    ! [VarCurr: state_type] :
      ( v91634(VarCurr)
    <=> ( v91635(VarCurr)
      <~> v91586(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1451,axiom,
    ! [VarCurr: state_type] :
      ( v91635(VarCurr)
    <=> ( v91636(VarCurr)
      <~> v91586(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1450,axiom,
    ! [VarCurr: state_type] :
      ( v91636(VarCurr)
    <=> ( v91637(VarCurr)
      <~> v91586(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1449,axiom,
    ! [VarCurr: state_type] :
      ( v91637(VarCurr)
    <=> ( v91638(VarCurr)
      <~> v91586(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1448,axiom,
    ! [VarCurr: state_type] :
      ( v91638(VarCurr)
    <=> ( v91639(VarCurr)
      <~> v91586(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1447,axiom,
    ! [VarCurr: state_type] :
      ( v91639(VarCurr)
    <=> ( v91640(VarCurr)
      <~> v91586(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1446,axiom,
    ! [VarCurr: state_type] :
      ( v91640(VarCurr)
    <=> ( v91641(VarCurr)
      <~> v91586(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1445,axiom,
    ! [VarCurr: state_type] :
      ( v91641(VarCurr)
    <=> ( v91642(VarCurr)
      <~> v91586(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1444,axiom,
    ! [VarCurr: state_type] :
      ( v91642(VarCurr)
    <=> ( v91643(VarCurr)
      <~> v91586(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1443,axiom,
    ! [VarCurr: state_type] :
      ( v91643(VarCurr)
    <=> ( v91644(VarCurr)
      <~> v91586(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1442,axiom,
    ! [VarCurr: state_type] :
      ( v91644(VarCurr)
    <=> ( v91645(VarCurr)
      <~> v91586(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1441,axiom,
    ! [VarCurr: state_type] :
      ( v91645(VarCurr)
    <=> ( v91646(VarCurr)
      <~> v91586(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1440,axiom,
    ! [VarCurr: state_type] :
      ( v91646(VarCurr)
    <=> ( v91647(VarCurr)
      <~> v91586(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1439,axiom,
    ! [VarCurr: state_type] :
      ( v91647(VarCurr)
    <=> ( v91648(VarCurr)
      <~> v91586(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1438,axiom,
    ! [VarCurr: state_type] :
      ( v91648(VarCurr)
    <=> ( v91649(VarCurr)
      <~> v91586(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1437,axiom,
    ! [VarCurr: state_type] :
      ( v91649(VarCurr)
    <=> ( v91650(VarCurr)
      <~> v91586(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1436,axiom,
    ! [VarCurr: state_type] :
      ( v91650(VarCurr)
    <=> ( v91651(VarCurr)
      <~> v91586(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1435,axiom,
    ! [VarCurr: state_type] :
      ( v91651(VarCurr)
    <=> ( v91652(VarCurr)
      <~> v91586(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1434,axiom,
    ! [VarCurr: state_type] :
      ( v91652(VarCurr)
    <=> ( v91653(VarCurr)
      <~> v91586(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1433,axiom,
    ! [VarCurr: state_type] :
      ( v91653(VarCurr)
    <=> ( v91654(VarCurr)
      <~> v91586(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1432,axiom,
    ! [VarCurr: state_type] :
      ( v91654(VarCurr)
    <=> ( v91655(VarCurr)
      <~> v91586(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1431,axiom,
    ! [VarCurr: state_type] :
      ( v91655(VarCurr)
    <=> ( v91656(VarCurr)
      <~> v91586(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1430,axiom,
    ! [VarCurr: state_type] :
      ( v91656(VarCurr)
    <=> ( v91657(VarCurr)
      <~> v91586(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1429,axiom,
    ! [VarCurr: state_type] :
      ( v91657(VarCurr)
    <=> ( v91586(VarCurr,70)
      <~> v91586(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8660,axiom,
    ! [VarCurr: state_type] :
      ( v91584(VarCurr,0)
    <=> ( v91588(VarCurr)
      <~> v91586(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1428,axiom,
    ! [VarCurr: state_type] :
      ( v91588(VarCurr)
    <=> ( v91589(VarCurr)
      <~> v91586(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1427,axiom,
    ! [VarCurr: state_type] :
      ( v91589(VarCurr)
    <=> ( v91590(VarCurr)
      <~> v91586(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1426,axiom,
    ! [VarCurr: state_type] :
      ( v91590(VarCurr)
    <=> ( v91591(VarCurr)
      <~> v91586(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1425,axiom,
    ! [VarCurr: state_type] :
      ( v91591(VarCurr)
    <=> ( v91592(VarCurr)
      <~> v91586(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1424,axiom,
    ! [VarCurr: state_type] :
      ( v91592(VarCurr)
    <=> ( v91593(VarCurr)
      <~> v91586(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1423,axiom,
    ! [VarCurr: state_type] :
      ( v91593(VarCurr)
    <=> ( v91594(VarCurr)
      <~> v91586(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1422,axiom,
    ! [VarCurr: state_type] :
      ( v91594(VarCurr)
    <=> ( v91595(VarCurr)
      <~> v91586(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1421,axiom,
    ! [VarCurr: state_type] :
      ( v91595(VarCurr)
    <=> ( v91596(VarCurr)
      <~> v91586(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1420,axiom,
    ! [VarCurr: state_type] :
      ( v91596(VarCurr)
    <=> ( v91597(VarCurr)
      <~> v91586(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1419,axiom,
    ! [VarCurr: state_type] :
      ( v91597(VarCurr)
    <=> ( v91598(VarCurr)
      <~> v91586(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1418,axiom,
    ! [VarCurr: state_type] :
      ( v91598(VarCurr)
    <=> ( v91599(VarCurr)
      <~> v91586(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1417,axiom,
    ! [VarCurr: state_type] :
      ( v91599(VarCurr)
    <=> ( v91600(VarCurr)
      <~> v91586(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1416,axiom,
    ! [VarCurr: state_type] :
      ( v91600(VarCurr)
    <=> ( v91601(VarCurr)
      <~> v91586(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1415,axiom,
    ! [VarCurr: state_type] :
      ( v91601(VarCurr)
    <=> ( v91602(VarCurr)
      <~> v91586(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1414,axiom,
    ! [VarCurr: state_type] :
      ( v91602(VarCurr)
    <=> ( v91603(VarCurr)
      <~> v91586(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1413,axiom,
    ! [VarCurr: state_type] :
      ( v91603(VarCurr)
    <=> ( v91604(VarCurr)
      <~> v91586(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1412,axiom,
    ! [VarCurr: state_type] :
      ( v91604(VarCurr)
    <=> ( v91605(VarCurr)
      <~> v91586(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1411,axiom,
    ! [VarCurr: state_type] :
      ( v91605(VarCurr)
    <=> ( v91606(VarCurr)
      <~> v91586(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1410,axiom,
    ! [VarCurr: state_type] :
      ( v91606(VarCurr)
    <=> ( v91607(VarCurr)
      <~> v91586(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1409,axiom,
    ! [VarCurr: state_type] :
      ( v91607(VarCurr)
    <=> ( v91608(VarCurr)
      <~> v91586(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1408,axiom,
    ! [VarCurr: state_type] :
      ( v91608(VarCurr)
    <=> ( v91609(VarCurr)
      <~> v91586(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1407,axiom,
    ! [VarCurr: state_type] :
      ( v91609(VarCurr)
    <=> ( v91610(VarCurr)
      <~> v91586(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1406,axiom,
    ! [VarCurr: state_type] :
      ( v91610(VarCurr)
    <=> ( v91611(VarCurr)
      <~> v91586(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1405,axiom,
    ! [VarCurr: state_type] :
      ( v91611(VarCurr)
    <=> ( v91612(VarCurr)
      <~> v91586(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1404,axiom,
    ! [VarCurr: state_type] :
      ( v91612(VarCurr)
    <=> ( v91613(VarCurr)
      <~> v91586(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1403,axiom,
    ! [VarCurr: state_type] :
      ( v91613(VarCurr)
    <=> ( v91614(VarCurr)
      <~> v91586(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1402,axiom,
    ! [VarCurr: state_type] :
      ( v91614(VarCurr)
    <=> ( v91615(VarCurr)
      <~> v91586(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1401,axiom,
    ! [VarCurr: state_type] :
      ( v91615(VarCurr)
    <=> ( v91616(VarCurr)
      <~> v91586(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1400,axiom,
    ! [VarCurr: state_type] :
      ( v91616(VarCurr)
    <=> ( v91617(VarCurr)
      <~> v91586(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1399,axiom,
    ! [VarCurr: state_type] :
      ( v91617(VarCurr)
    <=> ( v91618(VarCurr)
      <~> v91586(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1398,axiom,
    ! [VarCurr: state_type] :
      ( v91618(VarCurr)
    <=> ( v91619(VarCurr)
      <~> v91586(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1397,axiom,
    ! [VarCurr: state_type] :
      ( v91619(VarCurr)
    <=> ( v91620(VarCurr)
      <~> v91586(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1396,axiom,
    ! [VarCurr: state_type] :
      ( v91620(VarCurr)
    <=> ( v91621(VarCurr)
      <~> v91586(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1395,axiom,
    ! [VarCurr: state_type] :
      ( v91621(VarCurr)
    <=> ( v91622(VarCurr)
      <~> v91586(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1394,axiom,
    ! [VarCurr: state_type] :
      ( v91622(VarCurr)
    <=> ( v91586(VarCurr,69)
      <~> v91586(VarCurr,66) ) ) ).

tff(addAssignment_55372,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,62)
    <=> v91093(VarCurr,62) ) ).

tff(addAssignment_55371,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,23)
    <=> v91093(VarCurr,23) ) ).

tff(addAssignment_55370,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,61)
    <=> v91093(VarCurr,61) ) ).

tff(addAssignment_55369,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,22)
    <=> v91093(VarCurr,22) ) ).

tff(addAssignment_55368,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,27)
    <=> v91093(VarCurr,27) ) ).

tff(addAssignment_55367,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,47)
    <=> v91093(VarCurr,47) ) ).

tff(addAssignment_55366,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,60)
    <=> v91093(VarCurr,60) ) ).

tff(addAssignment_55365,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,5)
    <=> v91093(VarCurr,5) ) ).

tff(addAssignment_55364,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,8)
    <=> v91093(VarCurr,8) ) ).

tff(addAssignment_55363,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,15)
    <=> v91093(VarCurr,15) ) ).

tff(addAssignment_55362,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,21)
    <=> v91093(VarCurr,21) ) ).

tff(addAssignment_55361,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,26)
    <=> v91093(VarCurr,26) ) ).

tff(addAssignment_55360,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,46)
    <=> v91093(VarCurr,46) ) ).

tff(addAssignment_55359,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,51)
    <=> v91093(VarCurr,51) ) ).

tff(addAssignment_55358,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,59)
    <=> v91093(VarCurr,59) ) ).

tff(addAssignment_55357,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,68)
    <=> v91093(VarCurr,68) ) ).

tff(addAssignment_55356,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,71)
    <=> v91093(VarCurr,71) ) ).

tff(addAssignment_55355,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,4)
    <=> v91093(VarCurr,4) ) ).

tff(addAssignment_55354,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,7)
    <=> v91093(VarCurr,7) ) ).

tff(addAssignment_55353,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,10)
    <=> v91093(VarCurr,10) ) ).

tff(addAssignment_55352,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,12)
    <=> v91093(VarCurr,12) ) ).

tff(addAssignment_55351,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,14)
    <=> v91093(VarCurr,14) ) ).

tff(addAssignment_55350,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,18)
    <=> v91093(VarCurr,18) ) ).

tff(addAssignment_55349,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,20)
    <=> v91093(VarCurr,20) ) ).

tff(addAssignment_55348,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,25)
    <=> v91093(VarCurr,25) ) ).

tff(addAssignment_55347,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,29)
    <=> v91093(VarCurr,29) ) ).

tff(addAssignment_55346,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,32)
    <=> v91093(VarCurr,32) ) ).

tff(addAssignment_55345,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,39)
    <=> v91093(VarCurr,39) ) ).

tff(addAssignment_55344,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,41)
    <=> v91093(VarCurr,41) ) ).

tff(addAssignment_55343,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,45)
    <=> v91093(VarCurr,45) ) ).

tff(addAssignment_55342,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,50)
    <=> v91093(VarCurr,50) ) ).

tff(addAssignment_55341,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,55)
    <=> v91093(VarCurr,55) ) ).

tff(addAssignment_55340,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,58)
    <=> v91093(VarCurr,58) ) ).

tff(addAssignment_55339,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,67)
    <=> v91093(VarCurr,67) ) ).

tff(addAssignment_55338,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,70)
    <=> v91093(VarCurr,70) ) ).

tff(addAssignment_55337,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,0)
    <=> v91093(VarCurr,0) ) ).

tff(addAssignment_55336,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,1)
    <=> v91093(VarCurr,1) ) ).

tff(addAssignment_55335,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,2)
    <=> v91093(VarCurr,2) ) ).

tff(addAssignment_55334,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,3)
    <=> v91093(VarCurr,3) ) ).

tff(addAssignment_55333,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,6)
    <=> v91093(VarCurr,6) ) ).

tff(addAssignment_55332,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,9)
    <=> v91093(VarCurr,9) ) ).

tff(addAssignment_55331,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,11)
    <=> v91093(VarCurr,11) ) ).

tff(addAssignment_55330,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,13)
    <=> v91093(VarCurr,13) ) ).

tff(addAssignment_55329,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,16)
    <=> v91093(VarCurr,16) ) ).

tff(addAssignment_55328,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,17)
    <=> v91093(VarCurr,17) ) ).

tff(addAssignment_55327,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,19)
    <=> v91093(VarCurr,19) ) ).

tff(addAssignment_55326,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,24)
    <=> v91093(VarCurr,24) ) ).

tff(addAssignment_55325,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,28)
    <=> v91093(VarCurr,28) ) ).

tff(addAssignment_55324,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,30)
    <=> v91093(VarCurr,30) ) ).

tff(addAssignment_55323,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,31)
    <=> v91093(VarCurr,31) ) ).

tff(addAssignment_55322,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,33)
    <=> v91093(VarCurr,33) ) ).

tff(addAssignment_55321,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,34)
    <=> v91093(VarCurr,34) ) ).

tff(addAssignment_55320,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,35)
    <=> v91093(VarCurr,35) ) ).

tff(addAssignment_55319,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,36)
    <=> v91093(VarCurr,36) ) ).

tff(addAssignment_55318,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,37)
    <=> v91093(VarCurr,37) ) ).

tff(addAssignment_55317,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,38)
    <=> v91093(VarCurr,38) ) ).

tff(addAssignment_55316,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,40)
    <=> v91093(VarCurr,40) ) ).

tff(addAssignment_55315,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,42)
    <=> v91093(VarCurr,42) ) ).

tff(addAssignment_55314,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,43)
    <=> v91093(VarCurr,43) ) ).

tff(addAssignment_55313,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,44)
    <=> v91093(VarCurr,44) ) ).

tff(addAssignment_55312,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,48)
    <=> v91093(VarCurr,48) ) ).

tff(addAssignment_55311,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,49)
    <=> v91093(VarCurr,49) ) ).

tff(addAssignment_55310,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,52)
    <=> v91093(VarCurr,52) ) ).

tff(addAssignment_55309,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,53)
    <=> v91093(VarCurr,53) ) ).

tff(addAssignment_55308,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,54)
    <=> v91093(VarCurr,54) ) ).

tff(addAssignment_55307,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,56)
    <=> v91093(VarCurr,56) ) ).

tff(addAssignment_55306,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,57)
    <=> v91093(VarCurr,57) ) ).

tff(addAssignment_55305,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,63)
    <=> v91093(VarCurr,63) ) ).

tff(addAssignment_55304,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,64)
    <=> v91093(VarCurr,64) ) ).

tff(addAssignment_55303,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,65)
    <=> v91093(VarCurr,65) ) ).

tff(addAssignment_55302,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,66)
    <=> v91093(VarCurr,66) ) ).

tff(addAssignment_55301,axiom,
    ! [VarCurr: state_type] :
      ( v91586(VarCurr,69)
    <=> v91093(VarCurr,69) ) ).

tff(addAssignment_55300,axiom,
    ! [VarCurr: state_type] :
      ( v91564(VarCurr)
    <=> v91566(VarCurr) ) ).

tff(addAssignment_55299,axiom,
    ! [VarCurr: state_type] :
      ( v91566(VarCurr)
    <=> v91568(VarCurr) ) ).

tff(addAssignment_55298,axiom,
    ! [VarCurr: state_type] :
      ( v91568(VarCurr)
    <=> v91570(VarCurr) ) ).

tff(addAssignment_55297,axiom,
    ! [VarCurr: state_type] :
      ( v91570(VarCurr)
    <=> v91572(VarCurr) ) ).

tff(addAssignment_55296,axiom,
    ! [VarCurr: state_type] :
      ( v91572(VarCurr)
    <=> v91029(VarCurr) ) ).

tff(addAssignment_55295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91079(VarCurr,B)
      <=> v91081(VarCurr,B) ) ) ).

tff(addAssignment_55294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91081(VarCurr,B)
      <=> v91083(VarCurr,B) ) ) ).

tff(addAssignment_55293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91083(VarCurr,B)
      <=> v91085(VarCurr,B) ) ) ).

tff(addAssignment_55292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91085(VarCurr,B)
      <=> v91087(VarCurr,B) ) ) ).

tff(addAssignment_55291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91087(VarCurr,B)
      <=> v91089(VarCurr,B) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1393,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,11)
    <=> ( v91524(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1392,axiom,
    ! [VarCurr: state_type] :
      ( v91524(VarCurr)
    <=> ( v91525(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1391,axiom,
    ! [VarCurr: state_type] :
      ( v91525(VarCurr)
    <=> ( v91526(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1390,axiom,
    ! [VarCurr: state_type] :
      ( v91526(VarCurr)
    <=> ( v91527(VarCurr)
      <~> v91091(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1389,axiom,
    ! [VarCurr: state_type] :
      ( v91527(VarCurr)
    <=> ( v91528(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1388,axiom,
    ! [VarCurr: state_type] :
      ( v91528(VarCurr)
    <=> ( v91529(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1387,axiom,
    ! [VarCurr: state_type] :
      ( v91529(VarCurr)
    <=> ( v91530(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1386,axiom,
    ! [VarCurr: state_type] :
      ( v91530(VarCurr)
    <=> ( v91531(VarCurr)
      <~> v91091(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1385,axiom,
    ! [VarCurr: state_type] :
      ( v91531(VarCurr)
    <=> ( v91532(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1384,axiom,
    ! [VarCurr: state_type] :
      ( v91532(VarCurr)
    <=> ( v91533(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1383,axiom,
    ! [VarCurr: state_type] :
      ( v91533(VarCurr)
    <=> ( v91534(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1382,axiom,
    ! [VarCurr: state_type] :
      ( v91534(VarCurr)
    <=> ( v91535(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1381,axiom,
    ! [VarCurr: state_type] :
      ( v91535(VarCurr)
    <=> ( v91536(VarCurr)
      <~> v91091(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1380,axiom,
    ! [VarCurr: state_type] :
      ( v91536(VarCurr)
    <=> ( v91537(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1379,axiom,
    ! [VarCurr: state_type] :
      ( v91537(VarCurr)
    <=> ( v91538(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1378,axiom,
    ! [VarCurr: state_type] :
      ( v91538(VarCurr)
    <=> ( v91539(VarCurr)
      <~> v91091(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1377,axiom,
    ! [VarCurr: state_type] :
      ( v91539(VarCurr)
    <=> ( v91540(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1376,axiom,
    ! [VarCurr: state_type] :
      ( v91540(VarCurr)
    <=> ( v91541(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1375,axiom,
    ! [VarCurr: state_type] :
      ( v91541(VarCurr)
    <=> ( v91542(VarCurr)
      <~> v91091(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1374,axiom,
    ! [VarCurr: state_type] :
      ( v91542(VarCurr)
    <=> ( v91543(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1373,axiom,
    ! [VarCurr: state_type] :
      ( v91543(VarCurr)
    <=> ( v91544(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1372,axiom,
    ! [VarCurr: state_type] :
      ( v91544(VarCurr)
    <=> ( v91545(VarCurr)
      <~> v91091(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1371,axiom,
    ! [VarCurr: state_type] :
      ( v91545(VarCurr)
    <=> ( v91546(VarCurr)
      <~> v91091(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1370,axiom,
    ! [VarCurr: state_type] :
      ( v91546(VarCurr)
    <=> ( v91547(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1369,axiom,
    ! [VarCurr: state_type] :
      ( v91547(VarCurr)
    <=> ( v91548(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1368,axiom,
    ! [VarCurr: state_type] :
      ( v91548(VarCurr)
    <=> ( v91549(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1367,axiom,
    ! [VarCurr: state_type] :
      ( v91549(VarCurr)
    <=> ( v91550(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1366,axiom,
    ! [VarCurr: state_type] :
      ( v91550(VarCurr)
    <=> ( v91551(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1365,axiom,
    ! [VarCurr: state_type] :
      ( v91551(VarCurr)
    <=> ( v91552(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1364,axiom,
    ! [VarCurr: state_type] :
      ( v91552(VarCurr)
    <=> ( v91553(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1363,axiom,
    ! [VarCurr: state_type] :
      ( v91553(VarCurr)
    <=> ( v91554(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1362,axiom,
    ! [VarCurr: state_type] :
      ( v91554(VarCurr)
    <=> ( v91555(VarCurr)
      <~> v91091(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1361,axiom,
    ! [VarCurr: state_type] :
      ( v91555(VarCurr)
    <=> ( v91556(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1360,axiom,
    ! [VarCurr: state_type] :
      ( v91556(VarCurr)
    <=> ( v91557(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1359,axiom,
    ! [VarCurr: state_type] :
      ( v91557(VarCurr)
    <=> ( v91558(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1358,axiom,
    ! [VarCurr: state_type] :
      ( v91558(VarCurr)
    <=> ( v91559(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1357,axiom,
    ! [VarCurr: state_type] :
      ( v91559(VarCurr)
    <=> ( v91560(VarCurr)
      <~> v91091(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1356,axiom,
    ! [VarCurr: state_type] :
      ( v91560(VarCurr)
    <=> ( v91561(VarCurr)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1355,axiom,
    ! [VarCurr: state_type] :
      ( v91561(VarCurr)
    <=> ( v91562(VarCurr)
      <~> v91091(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1354,axiom,
    ! [VarCurr: state_type] :
      ( v91562(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1353,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,10)
    <=> ( v91491(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1352,axiom,
    ! [VarCurr: state_type] :
      ( v91491(VarCurr)
    <=> ( v91492(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1351,axiom,
    ! [VarCurr: state_type] :
      ( v91492(VarCurr)
    <=> ( v91493(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1350,axiom,
    ! [VarCurr: state_type] :
      ( v91493(VarCurr)
    <=> ( v91494(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1349,axiom,
    ! [VarCurr: state_type] :
      ( v91494(VarCurr)
    <=> ( v91495(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1348,axiom,
    ! [VarCurr: state_type] :
      ( v91495(VarCurr)
    <=> ( v91496(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1347,axiom,
    ! [VarCurr: state_type] :
      ( v91496(VarCurr)
    <=> ( v91497(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1346,axiom,
    ! [VarCurr: state_type] :
      ( v91497(VarCurr)
    <=> ( v91498(VarCurr)
      <~> v91091(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1345,axiom,
    ! [VarCurr: state_type] :
      ( v91498(VarCurr)
    <=> ( v91499(VarCurr)
      <~> v91091(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1344,axiom,
    ! [VarCurr: state_type] :
      ( v91499(VarCurr)
    <=> ( v91500(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1343,axiom,
    ! [VarCurr: state_type] :
      ( v91500(VarCurr)
    <=> ( v91501(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1342,axiom,
    ! [VarCurr: state_type] :
      ( v91501(VarCurr)
    <=> ( v91502(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1341,axiom,
    ! [VarCurr: state_type] :
      ( v91502(VarCurr)
    <=> ( v91503(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1340,axiom,
    ! [VarCurr: state_type] :
      ( v91503(VarCurr)
    <=> ( v91504(VarCurr)
      <~> v91091(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1339,axiom,
    ! [VarCurr: state_type] :
      ( v91504(VarCurr)
    <=> ( v91505(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1338,axiom,
    ! [VarCurr: state_type] :
      ( v91505(VarCurr)
    <=> ( v91506(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1337,axiom,
    ! [VarCurr: state_type] :
      ( v91506(VarCurr)
    <=> ( v91507(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1336,axiom,
    ! [VarCurr: state_type] :
      ( v91507(VarCurr)
    <=> ( v91508(VarCurr)
      <~> v91091(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1335,axiom,
    ! [VarCurr: state_type] :
      ( v91508(VarCurr)
    <=> ( v91509(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1334,axiom,
    ! [VarCurr: state_type] :
      ( v91509(VarCurr)
    <=> ( v91510(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1333,axiom,
    ! [VarCurr: state_type] :
      ( v91510(VarCurr)
    <=> ( v91511(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1332,axiom,
    ! [VarCurr: state_type] :
      ( v91511(VarCurr)
    <=> ( v91512(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1331,axiom,
    ! [VarCurr: state_type] :
      ( v91512(VarCurr)
    <=> ( v91513(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1330,axiom,
    ! [VarCurr: state_type] :
      ( v91513(VarCurr)
    <=> ( v91514(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1329,axiom,
    ! [VarCurr: state_type] :
      ( v91514(VarCurr)
    <=> ( v91515(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1328,axiom,
    ! [VarCurr: state_type] :
      ( v91515(VarCurr)
    <=> ( v91516(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1327,axiom,
    ! [VarCurr: state_type] :
      ( v91516(VarCurr)
    <=> ( v91517(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1326,axiom,
    ! [VarCurr: state_type] :
      ( v91517(VarCurr)
    <=> ( v91518(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1325,axiom,
    ! [VarCurr: state_type] :
      ( v91518(VarCurr)
    <=> ( v91519(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1324,axiom,
    ! [VarCurr: state_type] :
      ( v91519(VarCurr)
    <=> ( v91520(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1323,axiom,
    ! [VarCurr: state_type] :
      ( v91520(VarCurr)
    <=> ( v91521(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1322,axiom,
    ! [VarCurr: state_type] :
      ( v91521(VarCurr)
    <=> ( v91522(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1321,axiom,
    ! [VarCurr: state_type] :
      ( v91522(VarCurr)
    <=> ( v91091(VarCurr,68)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1320,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,9)
    <=> ( v91451(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1319,axiom,
    ! [VarCurr: state_type] :
      ( v91451(VarCurr)
    <=> ( v91452(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1318,axiom,
    ! [VarCurr: state_type] :
      ( v91452(VarCurr)
    <=> ( v91453(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1317,axiom,
    ! [VarCurr: state_type] :
      ( v91453(VarCurr)
    <=> ( v91454(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1316,axiom,
    ! [VarCurr: state_type] :
      ( v91454(VarCurr)
    <=> ( v91455(VarCurr)
      <~> v91091(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1315,axiom,
    ! [VarCurr: state_type] :
      ( v91455(VarCurr)
    <=> ( v91456(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1314,axiom,
    ! [VarCurr: state_type] :
      ( v91456(VarCurr)
    <=> ( v91457(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1313,axiom,
    ! [VarCurr: state_type] :
      ( v91457(VarCurr)
    <=> ( v91458(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1312,axiom,
    ! [VarCurr: state_type] :
      ( v91458(VarCurr)
    <=> ( v91459(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1311,axiom,
    ! [VarCurr: state_type] :
      ( v91459(VarCurr)
    <=> ( v91460(VarCurr)
      <~> v91091(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1310,axiom,
    ! [VarCurr: state_type] :
      ( v91460(VarCurr)
    <=> ( v91461(VarCurr)
      <~> v91091(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1309,axiom,
    ! [VarCurr: state_type] :
      ( v91461(VarCurr)
    <=> ( v91462(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1308,axiom,
    ! [VarCurr: state_type] :
      ( v91462(VarCurr)
    <=> ( v91463(VarCurr)
      <~> v91091(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1307,axiom,
    ! [VarCurr: state_type] :
      ( v91463(VarCurr)
    <=> ( v91464(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1306,axiom,
    ! [VarCurr: state_type] :
      ( v91464(VarCurr)
    <=> ( v91465(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1305,axiom,
    ! [VarCurr: state_type] :
      ( v91465(VarCurr)
    <=> ( v91466(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1304,axiom,
    ! [VarCurr: state_type] :
      ( v91466(VarCurr)
    <=> ( v91467(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1303,axiom,
    ! [VarCurr: state_type] :
      ( v91467(VarCurr)
    <=> ( v91468(VarCurr)
      <~> v91091(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1302,axiom,
    ! [VarCurr: state_type] :
      ( v91468(VarCurr)
    <=> ( v91469(VarCurr)
      <~> v91091(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1301,axiom,
    ! [VarCurr: state_type] :
      ( v91469(VarCurr)
    <=> ( v91470(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1300,axiom,
    ! [VarCurr: state_type] :
      ( v91470(VarCurr)
    <=> ( v91471(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1299,axiom,
    ! [VarCurr: state_type] :
      ( v91471(VarCurr)
    <=> ( v91472(VarCurr)
      <~> v91091(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1298,axiom,
    ! [VarCurr: state_type] :
      ( v91472(VarCurr)
    <=> ( v91473(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1297,axiom,
    ! [VarCurr: state_type] :
      ( v91473(VarCurr)
    <=> ( v91474(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1296,axiom,
    ! [VarCurr: state_type] :
      ( v91474(VarCurr)
    <=> ( v91475(VarCurr)
      <~> v91091(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1295,axiom,
    ! [VarCurr: state_type] :
      ( v91475(VarCurr)
    <=> ( v91476(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1294,axiom,
    ! [VarCurr: state_type] :
      ( v91476(VarCurr)
    <=> ( v91477(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1293,axiom,
    ! [VarCurr: state_type] :
      ( v91477(VarCurr)
    <=> ( v91478(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1292,axiom,
    ! [VarCurr: state_type] :
      ( v91478(VarCurr)
    <=> ( v91479(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1291,axiom,
    ! [VarCurr: state_type] :
      ( v91479(VarCurr)
    <=> ( v91480(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1290,axiom,
    ! [VarCurr: state_type] :
      ( v91480(VarCurr)
    <=> ( v91481(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1289,axiom,
    ! [VarCurr: state_type] :
      ( v91481(VarCurr)
    <=> ( v91482(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1288,axiom,
    ! [VarCurr: state_type] :
      ( v91482(VarCurr)
    <=> ( v91483(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1287,axiom,
    ! [VarCurr: state_type] :
      ( v91483(VarCurr)
    <=> ( v91484(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1286,axiom,
    ! [VarCurr: state_type] :
      ( v91484(VarCurr)
    <=> ( v91485(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1285,axiom,
    ! [VarCurr: state_type] :
      ( v91485(VarCurr)
    <=> ( v91486(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1284,axiom,
    ! [VarCurr: state_type] :
      ( v91486(VarCurr)
    <=> ( v91487(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1283,axiom,
    ! [VarCurr: state_type] :
      ( v91487(VarCurr)
    <=> ( v91488(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1282,axiom,
    ! [VarCurr: state_type] :
      ( v91488(VarCurr)
    <=> ( v91489(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1281,axiom,
    ! [VarCurr: state_type] :
      ( v91489(VarCurr)
    <=> ( v91091(VarCurr,70)
      <~> v91091(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1280,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,8)
    <=> ( v91411(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1279,axiom,
    ! [VarCurr: state_type] :
      ( v91411(VarCurr)
    <=> ( v91412(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1278,axiom,
    ! [VarCurr: state_type] :
      ( v91412(VarCurr)
    <=> ( v91413(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1277,axiom,
    ! [VarCurr: state_type] :
      ( v91413(VarCurr)
    <=> ( v91414(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1276,axiom,
    ! [VarCurr: state_type] :
      ( v91414(VarCurr)
    <=> ( v91415(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1275,axiom,
    ! [VarCurr: state_type] :
      ( v91415(VarCurr)
    <=> ( v91416(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1274,axiom,
    ! [VarCurr: state_type] :
      ( v91416(VarCurr)
    <=> ( v91417(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1273,axiom,
    ! [VarCurr: state_type] :
      ( v91417(VarCurr)
    <=> ( v91418(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1272,axiom,
    ! [VarCurr: state_type] :
      ( v91418(VarCurr)
    <=> ( v91419(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1271,axiom,
    ! [VarCurr: state_type] :
      ( v91419(VarCurr)
    <=> ( v91420(VarCurr)
      <~> v91091(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1270,axiom,
    ! [VarCurr: state_type] :
      ( v91420(VarCurr)
    <=> ( v91421(VarCurr)
      <~> v91091(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1269,axiom,
    ! [VarCurr: state_type] :
      ( v91421(VarCurr)
    <=> ( v91422(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1268,axiom,
    ! [VarCurr: state_type] :
      ( v91422(VarCurr)
    <=> ( v91423(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1267,axiom,
    ! [VarCurr: state_type] :
      ( v91423(VarCurr)
    <=> ( v91424(VarCurr)
      <~> v91091(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1266,axiom,
    ! [VarCurr: state_type] :
      ( v91424(VarCurr)
    <=> ( v91425(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1265,axiom,
    ! [VarCurr: state_type] :
      ( v91425(VarCurr)
    <=> ( v91426(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1264,axiom,
    ! [VarCurr: state_type] :
      ( v91426(VarCurr)
    <=> ( v91427(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1263,axiom,
    ! [VarCurr: state_type] :
      ( v91427(VarCurr)
    <=> ( v91428(VarCurr)
      <~> v91091(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1262,axiom,
    ! [VarCurr: state_type] :
      ( v91428(VarCurr)
    <=> ( v91429(VarCurr)
      <~> v91091(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1261,axiom,
    ! [VarCurr: state_type] :
      ( v91429(VarCurr)
    <=> ( v91430(VarCurr)
      <~> v91091(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1260,axiom,
    ! [VarCurr: state_type] :
      ( v91430(VarCurr)
    <=> ( v91431(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1259,axiom,
    ! [VarCurr: state_type] :
      ( v91431(VarCurr)
    <=> ( v91432(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1258,axiom,
    ! [VarCurr: state_type] :
      ( v91432(VarCurr)
    <=> ( v91433(VarCurr)
      <~> v91091(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1257,axiom,
    ! [VarCurr: state_type] :
      ( v91433(VarCurr)
    <=> ( v91434(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1256,axiom,
    ! [VarCurr: state_type] :
      ( v91434(VarCurr)
    <=> ( v91435(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1255,axiom,
    ! [VarCurr: state_type] :
      ( v91435(VarCurr)
    <=> ( v91436(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1254,axiom,
    ! [VarCurr: state_type] :
      ( v91436(VarCurr)
    <=> ( v91437(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1253,axiom,
    ! [VarCurr: state_type] :
      ( v91437(VarCurr)
    <=> ( v91438(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1252,axiom,
    ! [VarCurr: state_type] :
      ( v91438(VarCurr)
    <=> ( v91439(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1251,axiom,
    ! [VarCurr: state_type] :
      ( v91439(VarCurr)
    <=> ( v91440(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1250,axiom,
    ! [VarCurr: state_type] :
      ( v91440(VarCurr)
    <=> ( v91441(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1249,axiom,
    ! [VarCurr: state_type] :
      ( v91441(VarCurr)
    <=> ( v91442(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1248,axiom,
    ! [VarCurr: state_type] :
      ( v91442(VarCurr)
    <=> ( v91443(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1247,axiom,
    ! [VarCurr: state_type] :
      ( v91443(VarCurr)
    <=> ( v91444(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1246,axiom,
    ! [VarCurr: state_type] :
      ( v91444(VarCurr)
    <=> ( v91445(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1245,axiom,
    ! [VarCurr: state_type] :
      ( v91445(VarCurr)
    <=> ( v91446(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1244,axiom,
    ! [VarCurr: state_type] :
      ( v91446(VarCurr)
    <=> ( v91447(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1243,axiom,
    ! [VarCurr: state_type] :
      ( v91447(VarCurr)
    <=> ( v91448(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1242,axiom,
    ! [VarCurr: state_type] :
      ( v91448(VarCurr)
    <=> ( v91449(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1241,axiom,
    ! [VarCurr: state_type] :
      ( v91449(VarCurr)
    <=> ( v91091(VarCurr,69)
      <~> v91091(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1240,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,7)
    <=> ( v91369(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1239,axiom,
    ! [VarCurr: state_type] :
      ( v91369(VarCurr)
    <=> ( v91370(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1238,axiom,
    ! [VarCurr: state_type] :
      ( v91370(VarCurr)
    <=> ( v91371(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1237,axiom,
    ! [VarCurr: state_type] :
      ( v91371(VarCurr)
    <=> ( v91372(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1236,axiom,
    ! [VarCurr: state_type] :
      ( v91372(VarCurr)
    <=> ( v91373(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1235,axiom,
    ! [VarCurr: state_type] :
      ( v91373(VarCurr)
    <=> ( v91374(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1234,axiom,
    ! [VarCurr: state_type] :
      ( v91374(VarCurr)
    <=> ( v91375(VarCurr)
      <~> v91091(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1233,axiom,
    ! [VarCurr: state_type] :
      ( v91375(VarCurr)
    <=> ( v91376(VarCurr)
      <~> v91091(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1232,axiom,
    ! [VarCurr: state_type] :
      ( v91376(VarCurr)
    <=> ( v91377(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1231,axiom,
    ! [VarCurr: state_type] :
      ( v91377(VarCurr)
    <=> ( v91378(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1230,axiom,
    ! [VarCurr: state_type] :
      ( v91378(VarCurr)
    <=> ( v91379(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1229,axiom,
    ! [VarCurr: state_type] :
      ( v91379(VarCurr)
    <=> ( v91380(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1228,axiom,
    ! [VarCurr: state_type] :
      ( v91380(VarCurr)
    <=> ( v91381(VarCurr)
      <~> v91091(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1227,axiom,
    ! [VarCurr: state_type] :
      ( v91381(VarCurr)
    <=> ( v91382(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1226,axiom,
    ! [VarCurr: state_type] :
      ( v91382(VarCurr)
    <=> ( v91383(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1225,axiom,
    ! [VarCurr: state_type] :
      ( v91383(VarCurr)
    <=> ( v91384(VarCurr)
      <~> v91091(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1224,axiom,
    ! [VarCurr: state_type] :
      ( v91384(VarCurr)
    <=> ( v91385(VarCurr)
      <~> v91091(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1223,axiom,
    ! [VarCurr: state_type] :
      ( v91385(VarCurr)
    <=> ( v91386(VarCurr)
      <~> v91091(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1222,axiom,
    ! [VarCurr: state_type] :
      ( v91386(VarCurr)
    <=> ( v91387(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1221,axiom,
    ! [VarCurr: state_type] :
      ( v91387(VarCurr)
    <=> ( v91388(VarCurr)
      <~> v91091(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1220,axiom,
    ! [VarCurr: state_type] :
      ( v91388(VarCurr)
    <=> ( v91389(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1219,axiom,
    ! [VarCurr: state_type] :
      ( v91389(VarCurr)
    <=> ( v91390(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1218,axiom,
    ! [VarCurr: state_type] :
      ( v91390(VarCurr)
    <=> ( v91391(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1217,axiom,
    ! [VarCurr: state_type] :
      ( v91391(VarCurr)
    <=> ( v91392(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1216,axiom,
    ! [VarCurr: state_type] :
      ( v91392(VarCurr)
    <=> ( v91393(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1215,axiom,
    ! [VarCurr: state_type] :
      ( v91393(VarCurr)
    <=> ( v91394(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1214,axiom,
    ! [VarCurr: state_type] :
      ( v91394(VarCurr)
    <=> ( v91395(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1213,axiom,
    ! [VarCurr: state_type] :
      ( v91395(VarCurr)
    <=> ( v91396(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1212,axiom,
    ! [VarCurr: state_type] :
      ( v91396(VarCurr)
    <=> ( v91397(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1211,axiom,
    ! [VarCurr: state_type] :
      ( v91397(VarCurr)
    <=> ( v91398(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1210,axiom,
    ! [VarCurr: state_type] :
      ( v91398(VarCurr)
    <=> ( v91399(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1209,axiom,
    ! [VarCurr: state_type] :
      ( v91399(VarCurr)
    <=> ( v91400(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1208,axiom,
    ! [VarCurr: state_type] :
      ( v91400(VarCurr)
    <=> ( v91401(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1207,axiom,
    ! [VarCurr: state_type] :
      ( v91401(VarCurr)
    <=> ( v91402(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1206,axiom,
    ! [VarCurr: state_type] :
      ( v91402(VarCurr)
    <=> ( v91403(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1205,axiom,
    ! [VarCurr: state_type] :
      ( v91403(VarCurr)
    <=> ( v91404(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1204,axiom,
    ! [VarCurr: state_type] :
      ( v91404(VarCurr)
    <=> ( v91405(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1203,axiom,
    ! [VarCurr: state_type] :
      ( v91405(VarCurr)
    <=> ( v91406(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1202,axiom,
    ! [VarCurr: state_type] :
      ( v91406(VarCurr)
    <=> ( v91407(VarCurr)
      <~> v91091(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1201,axiom,
    ! [VarCurr: state_type] :
      ( v91407(VarCurr)
    <=> ( v91408(VarCurr)
      <~> v91091(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1200,axiom,
    ! [VarCurr: state_type] :
      ( v91408(VarCurr)
    <=> ( v91409(VarCurr)
      <~> v91091(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1199,axiom,
    ! [VarCurr: state_type] :
      ( v91409(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1198,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,6)
    <=> ( v91326(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1197,axiom,
    ! [VarCurr: state_type] :
      ( v91326(VarCurr)
    <=> ( v91327(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1196,axiom,
    ! [VarCurr: state_type] :
      ( v91327(VarCurr)
    <=> ( v91328(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1195,axiom,
    ! [VarCurr: state_type] :
      ( v91328(VarCurr)
    <=> ( v91329(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1194,axiom,
    ! [VarCurr: state_type] :
      ( v91329(VarCurr)
    <=> ( v91330(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1193,axiom,
    ! [VarCurr: state_type] :
      ( v91330(VarCurr)
    <=> ( v91331(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1192,axiom,
    ! [VarCurr: state_type] :
      ( v91331(VarCurr)
    <=> ( v91332(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1191,axiom,
    ! [VarCurr: state_type] :
      ( v91332(VarCurr)
    <=> ( v91333(VarCurr)
      <~> v91091(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1190,axiom,
    ! [VarCurr: state_type] :
      ( v91333(VarCurr)
    <=> ( v91334(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1189,axiom,
    ! [VarCurr: state_type] :
      ( v91334(VarCurr)
    <=> ( v91335(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1188,axiom,
    ! [VarCurr: state_type] :
      ( v91335(VarCurr)
    <=> ( v91336(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1187,axiom,
    ! [VarCurr: state_type] :
      ( v91336(VarCurr)
    <=> ( v91337(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1186,axiom,
    ! [VarCurr: state_type] :
      ( v91337(VarCurr)
    <=> ( v91338(VarCurr)
      <~> v91091(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1185,axiom,
    ! [VarCurr: state_type] :
      ( v91338(VarCurr)
    <=> ( v91339(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1184,axiom,
    ! [VarCurr: state_type] :
      ( v91339(VarCurr)
    <=> ( v91340(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1183,axiom,
    ! [VarCurr: state_type] :
      ( v91340(VarCurr)
    <=> ( v91341(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1182,axiom,
    ! [VarCurr: state_type] :
      ( v91341(VarCurr)
    <=> ( v91342(VarCurr)
      <~> v91091(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1181,axiom,
    ! [VarCurr: state_type] :
      ( v91342(VarCurr)
    <=> ( v91343(VarCurr)
      <~> v91091(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1180,axiom,
    ! [VarCurr: state_type] :
      ( v91343(VarCurr)
    <=> ( v91344(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1179,axiom,
    ! [VarCurr: state_type] :
      ( v91344(VarCurr)
    <=> ( v91345(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1178,axiom,
    ! [VarCurr: state_type] :
      ( v91345(VarCurr)
    <=> ( v91346(VarCurr)
      <~> v91091(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1177,axiom,
    ! [VarCurr: state_type] :
      ( v91346(VarCurr)
    <=> ( v91347(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1176,axiom,
    ! [VarCurr: state_type] :
      ( v91347(VarCurr)
    <=> ( v91348(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1175,axiom,
    ! [VarCurr: state_type] :
      ( v91348(VarCurr)
    <=> ( v91349(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1174,axiom,
    ! [VarCurr: state_type] :
      ( v91349(VarCurr)
    <=> ( v91350(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1173,axiom,
    ! [VarCurr: state_type] :
      ( v91350(VarCurr)
    <=> ( v91351(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1172,axiom,
    ! [VarCurr: state_type] :
      ( v91351(VarCurr)
    <=> ( v91352(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1171,axiom,
    ! [VarCurr: state_type] :
      ( v91352(VarCurr)
    <=> ( v91353(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1170,axiom,
    ! [VarCurr: state_type] :
      ( v91353(VarCurr)
    <=> ( v91354(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1169,axiom,
    ! [VarCurr: state_type] :
      ( v91354(VarCurr)
    <=> ( v91355(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1168,axiom,
    ! [VarCurr: state_type] :
      ( v91355(VarCurr)
    <=> ( v91356(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1167,axiom,
    ! [VarCurr: state_type] :
      ( v91356(VarCurr)
    <=> ( v91357(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1166,axiom,
    ! [VarCurr: state_type] :
      ( v91357(VarCurr)
    <=> ( v91358(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1165,axiom,
    ! [VarCurr: state_type] :
      ( v91358(VarCurr)
    <=> ( v91359(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1164,axiom,
    ! [VarCurr: state_type] :
      ( v91359(VarCurr)
    <=> ( v91360(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1163,axiom,
    ! [VarCurr: state_type] :
      ( v91360(VarCurr)
    <=> ( v91361(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1162,axiom,
    ! [VarCurr: state_type] :
      ( v91361(VarCurr)
    <=> ( v91362(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1161,axiom,
    ! [VarCurr: state_type] :
      ( v91362(VarCurr)
    <=> ( v91363(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1160,axiom,
    ! [VarCurr: state_type] :
      ( v91363(VarCurr)
    <=> ( v91364(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1159,axiom,
    ! [VarCurr: state_type] :
      ( v91364(VarCurr)
    <=> ( v91365(VarCurr)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1158,axiom,
    ! [VarCurr: state_type] :
      ( v91365(VarCurr)
    <=> ( v91366(VarCurr)
      <~> v91091(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1157,axiom,
    ! [VarCurr: state_type] :
      ( v91366(VarCurr)
    <=> ( v91367(VarCurr)
      <~> v91091(VarCurr,69) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1156,axiom,
    ! [VarCurr: state_type] :
      ( v91367(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1155,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,5)
    <=> ( v91287(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1154,axiom,
    ! [VarCurr: state_type] :
      ( v91287(VarCurr)
    <=> ( v91288(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1153,axiom,
    ! [VarCurr: state_type] :
      ( v91288(VarCurr)
    <=> ( v91289(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1152,axiom,
    ! [VarCurr: state_type] :
      ( v91289(VarCurr)
    <=> ( v91290(VarCurr)
      <~> v91091(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1151,axiom,
    ! [VarCurr: state_type] :
      ( v91290(VarCurr)
    <=> ( v91291(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1150,axiom,
    ! [VarCurr: state_type] :
      ( v91291(VarCurr)
    <=> ( v91292(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1149,axiom,
    ! [VarCurr: state_type] :
      ( v91292(VarCurr)
    <=> ( v91293(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1148,axiom,
    ! [VarCurr: state_type] :
      ( v91293(VarCurr)
    <=> ( v91294(VarCurr)
      <~> v91091(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1147,axiom,
    ! [VarCurr: state_type] :
      ( v91294(VarCurr)
    <=> ( v91295(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1146,axiom,
    ! [VarCurr: state_type] :
      ( v91295(VarCurr)
    <=> ( v91296(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1145,axiom,
    ! [VarCurr: state_type] :
      ( v91296(VarCurr)
    <=> ( v91297(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1144,axiom,
    ! [VarCurr: state_type] :
      ( v91297(VarCurr)
    <=> ( v91298(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1143,axiom,
    ! [VarCurr: state_type] :
      ( v91298(VarCurr)
    <=> ( v91299(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1142,axiom,
    ! [VarCurr: state_type] :
      ( v91299(VarCurr)
    <=> ( v91300(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1141,axiom,
    ! [VarCurr: state_type] :
      ( v91300(VarCurr)
    <=> ( v91301(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1140,axiom,
    ! [VarCurr: state_type] :
      ( v91301(VarCurr)
    <=> ( v91302(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1139,axiom,
    ! [VarCurr: state_type] :
      ( v91302(VarCurr)
    <=> ( v91303(VarCurr)
      <~> v91091(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1138,axiom,
    ! [VarCurr: state_type] :
      ( v91303(VarCurr)
    <=> ( v91304(VarCurr)
      <~> v91091(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1137,axiom,
    ! [VarCurr: state_type] :
      ( v91304(VarCurr)
    <=> ( v91305(VarCurr)
      <~> v91091(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1136,axiom,
    ! [VarCurr: state_type] :
      ( v91305(VarCurr)
    <=> ( v91306(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1135,axiom,
    ! [VarCurr: state_type] :
      ( v91306(VarCurr)
    <=> ( v91307(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1134,axiom,
    ! [VarCurr: state_type] :
      ( v91307(VarCurr)
    <=> ( v91308(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1133,axiom,
    ! [VarCurr: state_type] :
      ( v91308(VarCurr)
    <=> ( v91309(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1132,axiom,
    ! [VarCurr: state_type] :
      ( v91309(VarCurr)
    <=> ( v91310(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1131,axiom,
    ! [VarCurr: state_type] :
      ( v91310(VarCurr)
    <=> ( v91311(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1130,axiom,
    ! [VarCurr: state_type] :
      ( v91311(VarCurr)
    <=> ( v91312(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1129,axiom,
    ! [VarCurr: state_type] :
      ( v91312(VarCurr)
    <=> ( v91313(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1128,axiom,
    ! [VarCurr: state_type] :
      ( v91313(VarCurr)
    <=> ( v91314(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1127,axiom,
    ! [VarCurr: state_type] :
      ( v91314(VarCurr)
    <=> ( v91315(VarCurr)
      <~> v91091(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1126,axiom,
    ! [VarCurr: state_type] :
      ( v91315(VarCurr)
    <=> ( v91316(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1125,axiom,
    ! [VarCurr: state_type] :
      ( v91316(VarCurr)
    <=> ( v91317(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1124,axiom,
    ! [VarCurr: state_type] :
      ( v91317(VarCurr)
    <=> ( v91318(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1123,axiom,
    ! [VarCurr: state_type] :
      ( v91318(VarCurr)
    <=> ( v91319(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1122,axiom,
    ! [VarCurr: state_type] :
      ( v91319(VarCurr)
    <=> ( v91320(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1121,axiom,
    ! [VarCurr: state_type] :
      ( v91320(VarCurr)
    <=> ( v91321(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1120,axiom,
    ! [VarCurr: state_type] :
      ( v91321(VarCurr)
    <=> ( v91322(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1119,axiom,
    ! [VarCurr: state_type] :
      ( v91322(VarCurr)
    <=> ( v91323(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1118,axiom,
    ! [VarCurr: state_type] :
      ( v91323(VarCurr)
    <=> ( v91324(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1117,axiom,
    ! [VarCurr: state_type] :
      ( v91324(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1116,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,4)
    <=> ( v91248(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1115,axiom,
    ! [VarCurr: state_type] :
      ( v91248(VarCurr)
    <=> ( v91249(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1114,axiom,
    ! [VarCurr: state_type] :
      ( v91249(VarCurr)
    <=> ( v91250(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1113,axiom,
    ! [VarCurr: state_type] :
      ( v91250(VarCurr)
    <=> ( v91251(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1112,axiom,
    ! [VarCurr: state_type] :
      ( v91251(VarCurr)
    <=> ( v91252(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1111,axiom,
    ! [VarCurr: state_type] :
      ( v91252(VarCurr)
    <=> ( v91253(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1110,axiom,
    ! [VarCurr: state_type] :
      ( v91253(VarCurr)
    <=> ( v91254(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1109,axiom,
    ! [VarCurr: state_type] :
      ( v91254(VarCurr)
    <=> ( v91255(VarCurr)
      <~> v91091(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1108,axiom,
    ! [VarCurr: state_type] :
      ( v91255(VarCurr)
    <=> ( v91256(VarCurr)
      <~> v91091(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1107,axiom,
    ! [VarCurr: state_type] :
      ( v91256(VarCurr)
    <=> ( v91257(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1106,axiom,
    ! [VarCurr: state_type] :
      ( v91257(VarCurr)
    <=> ( v91258(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1105,axiom,
    ! [VarCurr: state_type] :
      ( v91258(VarCurr)
    <=> ( v91259(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1104,axiom,
    ! [VarCurr: state_type] :
      ( v91259(VarCurr)
    <=> ( v91260(VarCurr)
      <~> v91091(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1103,axiom,
    ! [VarCurr: state_type] :
      ( v91260(VarCurr)
    <=> ( v91261(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1102,axiom,
    ! [VarCurr: state_type] :
      ( v91261(VarCurr)
    <=> ( v91262(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1101,axiom,
    ! [VarCurr: state_type] :
      ( v91262(VarCurr)
    <=> ( v91263(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1100,axiom,
    ! [VarCurr: state_type] :
      ( v91263(VarCurr)
    <=> ( v91264(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1099,axiom,
    ! [VarCurr: state_type] :
      ( v91264(VarCurr)
    <=> ( v91265(VarCurr)
      <~> v91091(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1098,axiom,
    ! [VarCurr: state_type] :
      ( v91265(VarCurr)
    <=> ( v91266(VarCurr)
      <~> v91091(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1097,axiom,
    ! [VarCurr: state_type] :
      ( v91266(VarCurr)
    <=> ( v91267(VarCurr)
      <~> v91091(VarCurr,33) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1096,axiom,
    ! [VarCurr: state_type] :
      ( v91267(VarCurr)
    <=> ( v91268(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1095,axiom,
    ! [VarCurr: state_type] :
      ( v91268(VarCurr)
    <=> ( v91269(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1094,axiom,
    ! [VarCurr: state_type] :
      ( v91269(VarCurr)
    <=> ( v91270(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1093,axiom,
    ! [VarCurr: state_type] :
      ( v91270(VarCurr)
    <=> ( v91271(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1092,axiom,
    ! [VarCurr: state_type] :
      ( v91271(VarCurr)
    <=> ( v91272(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1091,axiom,
    ! [VarCurr: state_type] :
      ( v91272(VarCurr)
    <=> ( v91273(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1090,axiom,
    ! [VarCurr: state_type] :
      ( v91273(VarCurr)
    <=> ( v91274(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1089,axiom,
    ! [VarCurr: state_type] :
      ( v91274(VarCurr)
    <=> ( v91275(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1088,axiom,
    ! [VarCurr: state_type] :
      ( v91275(VarCurr)
    <=> ( v91276(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1087,axiom,
    ! [VarCurr: state_type] :
      ( v91276(VarCurr)
    <=> ( v91277(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1086,axiom,
    ! [VarCurr: state_type] :
      ( v91277(VarCurr)
    <=> ( v91278(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1085,axiom,
    ! [VarCurr: state_type] :
      ( v91278(VarCurr)
    <=> ( v91279(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1084,axiom,
    ! [VarCurr: state_type] :
      ( v91279(VarCurr)
    <=> ( v91280(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1083,axiom,
    ! [VarCurr: state_type] :
      ( v91280(VarCurr)
    <=> ( v91281(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1082,axiom,
    ! [VarCurr: state_type] :
      ( v91281(VarCurr)
    <=> ( v91282(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1081,axiom,
    ! [VarCurr: state_type] :
      ( v91282(VarCurr)
    <=> ( v91283(VarCurr)
      <~> v91091(VarCurr,62) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1080,axiom,
    ! [VarCurr: state_type] :
      ( v91283(VarCurr)
    <=> ( v91284(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1079,axiom,
    ! [VarCurr: state_type] :
      ( v91284(VarCurr)
    <=> ( v91285(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1078,axiom,
    ! [VarCurr: state_type] :
      ( v91285(VarCurr)
    <=> ( v91091(VarCurr,70)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1077,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,3)
    <=> ( v91208(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1076,axiom,
    ! [VarCurr: state_type] :
      ( v91208(VarCurr)
    <=> ( v91209(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1075,axiom,
    ! [VarCurr: state_type] :
      ( v91209(VarCurr)
    <=> ( v91210(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1074,axiom,
    ! [VarCurr: state_type] :
      ( v91210(VarCurr)
    <=> ( v91211(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1073,axiom,
    ! [VarCurr: state_type] :
      ( v91211(VarCurr)
    <=> ( v91212(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1072,axiom,
    ! [VarCurr: state_type] :
      ( v91212(VarCurr)
    <=> ( v91213(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1071,axiom,
    ! [VarCurr: state_type] :
      ( v91213(VarCurr)
    <=> ( v91214(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1070,axiom,
    ! [VarCurr: state_type] :
      ( v91214(VarCurr)
    <=> ( v91215(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1069,axiom,
    ! [VarCurr: state_type] :
      ( v91215(VarCurr)
    <=> ( v91216(VarCurr)
      <~> v91091(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1068,axiom,
    ! [VarCurr: state_type] :
      ( v91216(VarCurr)
    <=> ( v91217(VarCurr)
      <~> v91091(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1067,axiom,
    ! [VarCurr: state_type] :
      ( v91217(VarCurr)
    <=> ( v91218(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1066,axiom,
    ! [VarCurr: state_type] :
      ( v91218(VarCurr)
    <=> ( v91219(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1065,axiom,
    ! [VarCurr: state_type] :
      ( v91219(VarCurr)
    <=> ( v91220(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1064,axiom,
    ! [VarCurr: state_type] :
      ( v91220(VarCurr)
    <=> ( v91221(VarCurr)
      <~> v91091(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1063,axiom,
    ! [VarCurr: state_type] :
      ( v91221(VarCurr)
    <=> ( v91222(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1062,axiom,
    ! [VarCurr: state_type] :
      ( v91222(VarCurr)
    <=> ( v91223(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1061,axiom,
    ! [VarCurr: state_type] :
      ( v91223(VarCurr)
    <=> ( v91224(VarCurr)
      <~> v91091(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1060,axiom,
    ! [VarCurr: state_type] :
      ( v91224(VarCurr)
    <=> ( v91225(VarCurr)
      <~> v91091(VarCurr,32) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1059,axiom,
    ! [VarCurr: state_type] :
      ( v91225(VarCurr)
    <=> ( v91226(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1058,axiom,
    ! [VarCurr: state_type] :
      ( v91226(VarCurr)
    <=> ( v91227(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1057,axiom,
    ! [VarCurr: state_type] :
      ( v91227(VarCurr)
    <=> ( v91228(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1056,axiom,
    ! [VarCurr: state_type] :
      ( v91228(VarCurr)
    <=> ( v91229(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1055,axiom,
    ! [VarCurr: state_type] :
      ( v91229(VarCurr)
    <=> ( v91230(VarCurr)
      <~> v91091(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1054,axiom,
    ! [VarCurr: state_type] :
      ( v91230(VarCurr)
    <=> ( v91231(VarCurr)
      <~> v91091(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1053,axiom,
    ! [VarCurr: state_type] :
      ( v91231(VarCurr)
    <=> ( v91232(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1052,axiom,
    ! [VarCurr: state_type] :
      ( v91232(VarCurr)
    <=> ( v91233(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1051,axiom,
    ! [VarCurr: state_type] :
      ( v91233(VarCurr)
    <=> ( v91234(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1050,axiom,
    ! [VarCurr: state_type] :
      ( v91234(VarCurr)
    <=> ( v91235(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1049,axiom,
    ! [VarCurr: state_type] :
      ( v91235(VarCurr)
    <=> ( v91236(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1048,axiom,
    ! [VarCurr: state_type] :
      ( v91236(VarCurr)
    <=> ( v91237(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1047,axiom,
    ! [VarCurr: state_type] :
      ( v91237(VarCurr)
    <=> ( v91238(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1046,axiom,
    ! [VarCurr: state_type] :
      ( v91238(VarCurr)
    <=> ( v91239(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1045,axiom,
    ! [VarCurr: state_type] :
      ( v91239(VarCurr)
    <=> ( v91240(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1044,axiom,
    ! [VarCurr: state_type] :
      ( v91240(VarCurr)
    <=> ( v91241(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1043,axiom,
    ! [VarCurr: state_type] :
      ( v91241(VarCurr)
    <=> ( v91242(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1042,axiom,
    ! [VarCurr: state_type] :
      ( v91242(VarCurr)
    <=> ( v91243(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1041,axiom,
    ! [VarCurr: state_type] :
      ( v91243(VarCurr)
    <=> ( v91244(VarCurr)
      <~> v91091(VarCurr,61) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1040,axiom,
    ! [VarCurr: state_type] :
      ( v91244(VarCurr)
    <=> ( v91245(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1039,axiom,
    ! [VarCurr: state_type] :
      ( v91245(VarCurr)
    <=> ( v91246(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1038,axiom,
    ! [VarCurr: state_type] :
      ( v91246(VarCurr)
    <=> ( v91091(VarCurr,70)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1037,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,2)
    <=> ( v91174(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1036,axiom,
    ! [VarCurr: state_type] :
      ( v91174(VarCurr)
    <=> ( v91175(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1035,axiom,
    ! [VarCurr: state_type] :
      ( v91175(VarCurr)
    <=> ( v91176(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1034,axiom,
    ! [VarCurr: state_type] :
      ( v91176(VarCurr)
    <=> ( v91177(VarCurr)
      <~> v91091(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1033,axiom,
    ! [VarCurr: state_type] :
      ( v91177(VarCurr)
    <=> ( v91178(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1032,axiom,
    ! [VarCurr: state_type] :
      ( v91178(VarCurr)
    <=> ( v91179(VarCurr)
      <~> v91091(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1031,axiom,
    ! [VarCurr: state_type] :
      ( v91179(VarCurr)
    <=> ( v91180(VarCurr)
      <~> v91091(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1030,axiom,
    ! [VarCurr: state_type] :
      ( v91180(VarCurr)
    <=> ( v91181(VarCurr)
      <~> v91091(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1029,axiom,
    ! [VarCurr: state_type] :
      ( v91181(VarCurr)
    <=> ( v91182(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1028,axiom,
    ! [VarCurr: state_type] :
      ( v91182(VarCurr)
    <=> ( v91183(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1027,axiom,
    ! [VarCurr: state_type] :
      ( v91183(VarCurr)
    <=> ( v91184(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1026,axiom,
    ! [VarCurr: state_type] :
      ( v91184(VarCurr)
    <=> ( v91185(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1025,axiom,
    ! [VarCurr: state_type] :
      ( v91185(VarCurr)
    <=> ( v91186(VarCurr)
      <~> v91091(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1024,axiom,
    ! [VarCurr: state_type] :
      ( v91186(VarCurr)
    <=> ( v91187(VarCurr)
      <~> v91091(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1023,axiom,
    ! [VarCurr: state_type] :
      ( v91187(VarCurr)
    <=> ( v91188(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1022,axiom,
    ! [VarCurr: state_type] :
      ( v91188(VarCurr)
    <=> ( v91189(VarCurr)
      <~> v91091(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1021,axiom,
    ! [VarCurr: state_type] :
      ( v91189(VarCurr)
    <=> ( v91190(VarCurr)
      <~> v91091(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1020,axiom,
    ! [VarCurr: state_type] :
      ( v91190(VarCurr)
    <=> ( v91191(VarCurr)
      <~> v91091(VarCurr,31) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1019,axiom,
    ! [VarCurr: state_type] :
      ( v91191(VarCurr)
    <=> ( v91192(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1018,axiom,
    ! [VarCurr: state_type] :
      ( v91192(VarCurr)
    <=> ( v91193(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1017,axiom,
    ! [VarCurr: state_type] :
      ( v91193(VarCurr)
    <=> ( v91194(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1016,axiom,
    ! [VarCurr: state_type] :
      ( v91194(VarCurr)
    <=> ( v91195(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1015,axiom,
    ! [VarCurr: state_type] :
      ( v91195(VarCurr)
    <=> ( v91196(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1014,axiom,
    ! [VarCurr: state_type] :
      ( v91196(VarCurr)
    <=> ( v91197(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1013,axiom,
    ! [VarCurr: state_type] :
      ( v91197(VarCurr)
    <=> ( v91198(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1012,axiom,
    ! [VarCurr: state_type] :
      ( v91198(VarCurr)
    <=> ( v91199(VarCurr)
      <~> v91091(VarCurr,51) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1011,axiom,
    ! [VarCurr: state_type] :
      ( v91199(VarCurr)
    <=> ( v91200(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1010,axiom,
    ! [VarCurr: state_type] :
      ( v91200(VarCurr)
    <=> ( v91201(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1009,axiom,
    ! [VarCurr: state_type] :
      ( v91201(VarCurr)
    <=> ( v91202(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1008,axiom,
    ! [VarCurr: state_type] :
      ( v91202(VarCurr)
    <=> ( v91203(VarCurr)
      <~> v91091(VarCurr,60) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1007,axiom,
    ! [VarCurr: state_type] :
      ( v91203(VarCurr)
    <=> ( v91204(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1006,axiom,
    ! [VarCurr: state_type] :
      ( v91204(VarCurr)
    <=> ( v91205(VarCurr)
      <~> v91091(VarCurr,65) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1005,axiom,
    ! [VarCurr: state_type] :
      ( v91205(VarCurr)
    <=> ( v91206(VarCurr)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1004,axiom,
    ! [VarCurr: state_type] :
      ( v91206(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,70) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1003,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,1)
    <=> ( v91140(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1002,axiom,
    ! [VarCurr: state_type] :
      ( v91140(VarCurr)
    <=> ( v91141(VarCurr)
      <~> v91091(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1001,axiom,
    ! [VarCurr: state_type] :
      ( v91141(VarCurr)
    <=> ( v91142(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1000,axiom,
    ! [VarCurr: state_type] :
      ( v91142(VarCurr)
    <=> ( v91143(VarCurr)
      <~> v91091(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_999,axiom,
    ! [VarCurr: state_type] :
      ( v91143(VarCurr)
    <=> ( v91144(VarCurr)
      <~> v91091(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_998,axiom,
    ! [VarCurr: state_type] :
      ( v91144(VarCurr)
    <=> ( v91145(VarCurr)
      <~> v91091(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_997,axiom,
    ! [VarCurr: state_type] :
      ( v91145(VarCurr)
    <=> ( v91146(VarCurr)
      <~> v91091(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_996,axiom,
    ! [VarCurr: state_type] :
      ( v91146(VarCurr)
    <=> ( v91147(VarCurr)
      <~> v91091(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_995,axiom,
    ! [VarCurr: state_type] :
      ( v91147(VarCurr)
    <=> ( v91148(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_994,axiom,
    ! [VarCurr: state_type] :
      ( v91148(VarCurr)
    <=> ( v91149(VarCurr)
      <~> v91091(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_993,axiom,
    ! [VarCurr: state_type] :
      ( v91149(VarCurr)
    <=> ( v91150(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_992,axiom,
    ! [VarCurr: state_type] :
      ( v91150(VarCurr)
    <=> ( v91151(VarCurr)
      <~> v91091(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_991,axiom,
    ! [VarCurr: state_type] :
      ( v91151(VarCurr)
    <=> ( v91152(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_990,axiom,
    ! [VarCurr: state_type] :
      ( v91152(VarCurr)
    <=> ( v91153(VarCurr)
      <~> v91091(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_989,axiom,
    ! [VarCurr: state_type] :
      ( v91153(VarCurr)
    <=> ( v91154(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_988,axiom,
    ! [VarCurr: state_type] :
      ( v91154(VarCurr)
    <=> ( v91155(VarCurr)
      <~> v91091(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_987,axiom,
    ! [VarCurr: state_type] :
      ( v91155(VarCurr)
    <=> ( v91156(VarCurr)
      <~> v91091(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_986,axiom,
    ! [VarCurr: state_type] :
      ( v91156(VarCurr)
    <=> ( v91157(VarCurr)
      <~> v91091(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_985,axiom,
    ! [VarCurr: state_type] :
      ( v91157(VarCurr)
    <=> ( v91158(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_984,axiom,
    ! [VarCurr: state_type] :
      ( v91158(VarCurr)
    <=> ( v91159(VarCurr)
      <~> v91091(VarCurr,43) ) ) ).

tff(writeBinaryOperatorShiftedRanges_983,axiom,
    ! [VarCurr: state_type] :
      ( v91159(VarCurr)
    <=> ( v91160(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_982,axiom,
    ! [VarCurr: state_type] :
      ( v91160(VarCurr)
    <=> ( v91161(VarCurr)
      <~> v91091(VarCurr,45) ) ) ).

tff(writeBinaryOperatorShiftedRanges_981,axiom,
    ! [VarCurr: state_type] :
      ( v91161(VarCurr)
    <=> ( v91162(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_980,axiom,
    ! [VarCurr: state_type] :
      ( v91162(VarCurr)
    <=> ( v91163(VarCurr)
      <~> v91091(VarCurr,47) ) ) ).

tff(writeBinaryOperatorShiftedRanges_979,axiom,
    ! [VarCurr: state_type] :
      ( v91163(VarCurr)
    <=> ( v91164(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_978,axiom,
    ! [VarCurr: state_type] :
      ( v91164(VarCurr)
    <=> ( v91165(VarCurr)
      <~> v91091(VarCurr,50) ) ) ).

tff(writeBinaryOperatorShiftedRanges_977,axiom,
    ! [VarCurr: state_type] :
      ( v91165(VarCurr)
    <=> ( v91166(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_976,axiom,
    ! [VarCurr: state_type] :
      ( v91166(VarCurr)
    <=> ( v91167(VarCurr)
      <~> v91091(VarCurr,57) ) ) ).

tff(writeBinaryOperatorShiftedRanges_975,axiom,
    ! [VarCurr: state_type] :
      ( v91167(VarCurr)
    <=> ( v91168(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_974,axiom,
    ! [VarCurr: state_type] :
      ( v91168(VarCurr)
    <=> ( v91169(VarCurr)
      <~> v91091(VarCurr,59) ) ) ).

tff(writeBinaryOperatorShiftedRanges_973,axiom,
    ! [VarCurr: state_type] :
      ( v91169(VarCurr)
    <=> ( v91170(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_972,axiom,
    ! [VarCurr: state_type] :
      ( v91170(VarCurr)
    <=> ( v91171(VarCurr)
      <~> v91091(VarCurr,64) ) ) ).

tff(writeBinaryOperatorShiftedRanges_971,axiom,
    ! [VarCurr: state_type] :
      ( v91171(VarCurr)
    <=> ( v91172(VarCurr)
      <~> v91091(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_970,axiom,
    ! [VarCurr: state_type] :
      ( v91172(VarCurr)
    <=> ( v91091(VarCurr,70)
      <~> v91091(VarCurr,69) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8659,axiom,
    ! [VarCurr: state_type] :
      ( v91089(VarCurr,0)
    <=> ( v91100(VarCurr)
      <~> v91091(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_969,axiom,
    ! [VarCurr: state_type] :
      ( v91100(VarCurr)
    <=> ( v91101(VarCurr)
      <~> v91091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_968,axiom,
    ! [VarCurr: state_type] :
      ( v91101(VarCurr)
    <=> ( v91102(VarCurr)
      <~> v91091(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_967,axiom,
    ! [VarCurr: state_type] :
      ( v91102(VarCurr)
    <=> ( v91103(VarCurr)
      <~> v91091(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_966,axiom,
    ! [VarCurr: state_type] :
      ( v91103(VarCurr)
    <=> ( v91104(VarCurr)
      <~> v91091(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_965,axiom,
    ! [VarCurr: state_type] :
      ( v91104(VarCurr)
    <=> ( v91105(VarCurr)
      <~> v91091(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_964,axiom,
    ! [VarCurr: state_type] :
      ( v91105(VarCurr)
    <=> ( v91106(VarCurr)
      <~> v91091(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_963,axiom,
    ! [VarCurr: state_type] :
      ( v91106(VarCurr)
    <=> ( v91107(VarCurr)
      <~> v91091(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_962,axiom,
    ! [VarCurr: state_type] :
      ( v91107(VarCurr)
    <=> ( v91108(VarCurr)
      <~> v91091(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_961,axiom,
    ! [VarCurr: state_type] :
      ( v91108(VarCurr)
    <=> ( v91109(VarCurr)
      <~> v91091(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_960,axiom,
    ! [VarCurr: state_type] :
      ( v91109(VarCurr)
    <=> ( v91110(VarCurr)
      <~> v91091(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_959,axiom,
    ! [VarCurr: state_type] :
      ( v91110(VarCurr)
    <=> ( v91111(VarCurr)
      <~> v91091(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_958,axiom,
    ! [VarCurr: state_type] :
      ( v91111(VarCurr)
    <=> ( v91112(VarCurr)
      <~> v91091(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_957,axiom,
    ! [VarCurr: state_type] :
      ( v91112(VarCurr)
    <=> ( v91113(VarCurr)
      <~> v91091(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_956,axiom,
    ! [VarCurr: state_type] :
      ( v91113(VarCurr)
    <=> ( v91114(VarCurr)
      <~> v91091(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_955,axiom,
    ! [VarCurr: state_type] :
      ( v91114(VarCurr)
    <=> ( v91115(VarCurr)
      <~> v91091(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_954,axiom,
    ! [VarCurr: state_type] :
      ( v91115(VarCurr)
    <=> ( v91116(VarCurr)
      <~> v91091(VarCurr,34) ) ) ).

tff(writeBinaryOperatorShiftedRanges_953,axiom,
    ! [VarCurr: state_type] :
      ( v91116(VarCurr)
    <=> ( v91117(VarCurr)
      <~> v91091(VarCurr,35) ) ) ).

tff(writeBinaryOperatorShiftedRanges_952,axiom,
    ! [VarCurr: state_type] :
      ( v91117(VarCurr)
    <=> ( v91118(VarCurr)
      <~> v91091(VarCurr,36) ) ) ).

tff(writeBinaryOperatorShiftedRanges_951,axiom,
    ! [VarCurr: state_type] :
      ( v91118(VarCurr)
    <=> ( v91119(VarCurr)
      <~> v91091(VarCurr,37) ) ) ).

tff(writeBinaryOperatorShiftedRanges_950,axiom,
    ! [VarCurr: state_type] :
      ( v91119(VarCurr)
    <=> ( v91120(VarCurr)
      <~> v91091(VarCurr,38) ) ) ).

tff(writeBinaryOperatorShiftedRanges_949,axiom,
    ! [VarCurr: state_type] :
      ( v91120(VarCurr)
    <=> ( v91121(VarCurr)
      <~> v91091(VarCurr,39) ) ) ).

tff(writeBinaryOperatorShiftedRanges_948,axiom,
    ! [VarCurr: state_type] :
      ( v91121(VarCurr)
    <=> ( v91122(VarCurr)
      <~> v91091(VarCurr,40) ) ) ).

tff(writeBinaryOperatorShiftedRanges_947,axiom,
    ! [VarCurr: state_type] :
      ( v91122(VarCurr)
    <=> ( v91123(VarCurr)
      <~> v91091(VarCurr,41) ) ) ).

tff(writeBinaryOperatorShiftedRanges_946,axiom,
    ! [VarCurr: state_type] :
      ( v91123(VarCurr)
    <=> ( v91124(VarCurr)
      <~> v91091(VarCurr,42) ) ) ).

tff(writeBinaryOperatorShiftedRanges_945,axiom,
    ! [VarCurr: state_type] :
      ( v91124(VarCurr)
    <=> ( v91125(VarCurr)
      <~> v91091(VarCurr,44) ) ) ).

tff(writeBinaryOperatorShiftedRanges_944,axiom,
    ! [VarCurr: state_type] :
      ( v91125(VarCurr)
    <=> ( v91126(VarCurr)
      <~> v91091(VarCurr,46) ) ) ).

tff(writeBinaryOperatorShiftedRanges_943,axiom,
    ! [VarCurr: state_type] :
      ( v91126(VarCurr)
    <=> ( v91127(VarCurr)
      <~> v91091(VarCurr,48) ) ) ).

tff(writeBinaryOperatorShiftedRanges_942,axiom,
    ! [VarCurr: state_type] :
      ( v91127(VarCurr)
    <=> ( v91128(VarCurr)
      <~> v91091(VarCurr,49) ) ) ).

tff(writeBinaryOperatorShiftedRanges_941,axiom,
    ! [VarCurr: state_type] :
      ( v91128(VarCurr)
    <=> ( v91129(VarCurr)
      <~> v91091(VarCurr,52) ) ) ).

tff(writeBinaryOperatorShiftedRanges_940,axiom,
    ! [VarCurr: state_type] :
      ( v91129(VarCurr)
    <=> ( v91130(VarCurr)
      <~> v91091(VarCurr,53) ) ) ).

tff(writeBinaryOperatorShiftedRanges_939,axiom,
    ! [VarCurr: state_type] :
      ( v91130(VarCurr)
    <=> ( v91131(VarCurr)
      <~> v91091(VarCurr,54) ) ) ).

tff(writeBinaryOperatorShiftedRanges_938,axiom,
    ! [VarCurr: state_type] :
      ( v91131(VarCurr)
    <=> ( v91132(VarCurr)
      <~> v91091(VarCurr,55) ) ) ).

tff(writeBinaryOperatorShiftedRanges_937,axiom,
    ! [VarCurr: state_type] :
      ( v91132(VarCurr)
    <=> ( v91133(VarCurr)
      <~> v91091(VarCurr,56) ) ) ).

tff(writeBinaryOperatorShiftedRanges_936,axiom,
    ! [VarCurr: state_type] :
      ( v91133(VarCurr)
    <=> ( v91134(VarCurr)
      <~> v91091(VarCurr,58) ) ) ).

tff(writeBinaryOperatorShiftedRanges_935,axiom,
    ! [VarCurr: state_type] :
      ( v91134(VarCurr)
    <=> ( v91135(VarCurr)
      <~> v91091(VarCurr,63) ) ) ).

tff(writeBinaryOperatorShiftedRanges_934,axiom,
    ! [VarCurr: state_type] :
      ( v91135(VarCurr)
    <=> ( v91136(VarCurr)
      <~> v91091(VarCurr,66) ) ) ).

tff(writeBinaryOperatorShiftedRanges_933,axiom,
    ! [VarCurr: state_type] :
      ( v91136(VarCurr)
    <=> ( v91137(VarCurr)
      <~> v91091(VarCurr,67) ) ) ).

tff(writeBinaryOperatorShiftedRanges_932,axiom,
    ! [VarCurr: state_type] :
      ( v91137(VarCurr)
    <=> ( v91138(VarCurr)
      <~> v91091(VarCurr,68) ) ) ).

tff(writeBinaryOperatorShiftedRanges_931,axiom,
    ! [VarCurr: state_type] :
      ( v91138(VarCurr)
    <=> ( v91091(VarCurr,71)
      <~> v91091(VarCurr,70) ) ) ).

tff(addAssignment_55290,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,33)
    <=> v91093(VarCurr,33) ) ).

tff(addAssignment_55289,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,33)
    <=> v91095(VarCurr,33) ) ).

tff(addAssignment_55288,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,33)
    <=> v91097(VarCurr,33) ) ).

tff(addAssignment_55287,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,33)
    <=> v91098(VarCurr,33) ) ).

tff(addAssignment_55286,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,62)
    <=> v91093(VarCurr,62) ) ).

tff(addAssignment_55285,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,62)
    <=> v91095(VarCurr,62) ) ).

tff(addAssignment_55284,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,62)
    <=> v91097(VarCurr,62) ) ).

tff(addAssignment_55283,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,62)
    <=> v91098(VarCurr,62) ) ).

tff(addAssignment_55282,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,15)
    <=> v91093(VarCurr,15) ) ).

tff(addAssignment_55281,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,15)
    <=> v91095(VarCurr,15) ) ).

tff(addAssignment_55280,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,15)
    <=> v91097(VarCurr,15) ) ).

tff(addAssignment_55279,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,15)
    <=> v91098(VarCurr,15) ) ).

tff(addAssignment_55278,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,32)
    <=> v91093(VarCurr,32) ) ).

tff(addAssignment_55277,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,32)
    <=> v91095(VarCurr,32) ) ).

tff(addAssignment_55276,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,32)
    <=> v91097(VarCurr,32) ) ).

tff(addAssignment_55275,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,32)
    <=> v91098(VarCurr,32) ) ).

tff(addAssignment_55274,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,61)
    <=> v91093(VarCurr,61) ) ).

tff(addAssignment_55273,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,61)
    <=> v91095(VarCurr,61) ) ).

tff(addAssignment_55272,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,61)
    <=> v91097(VarCurr,61) ) ).

tff(addAssignment_55271,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,61)
    <=> v91098(VarCurr,61) ) ).

tff(addAssignment_55270,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,5)
    <=> v91093(VarCurr,5) ) ).

tff(addAssignment_55269,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,5)
    <=> v91095(VarCurr,5) ) ).

tff(addAssignment_55268,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,5)
    <=> v91097(VarCurr,5) ) ).

tff(addAssignment_55267,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,5)
    <=> v91098(VarCurr,5) ) ).

tff(addAssignment_55266,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,11)
    <=> v91093(VarCurr,11) ) ).

tff(addAssignment_55265,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,11)
    <=> v91095(VarCurr,11) ) ).

tff(addAssignment_55264,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,11)
    <=> v91097(VarCurr,11) ) ).

tff(addAssignment_55263,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,11)
    <=> v91098(VarCurr,11) ) ).

tff(addAssignment_55262,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,14)
    <=> v91093(VarCurr,14) ) ).

tff(addAssignment_55261,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,14)
    <=> v91095(VarCurr,14) ) ).

tff(addAssignment_55260,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,14)
    <=> v91097(VarCurr,14) ) ).

tff(addAssignment_55259,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,14)
    <=> v91098(VarCurr,14) ) ).

tff(addAssignment_55258,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,24)
    <=> v91093(VarCurr,24) ) ).

tff(addAssignment_55257,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,24)
    <=> v91095(VarCurr,24) ) ).

tff(addAssignment_55256,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,24)
    <=> v91097(VarCurr,24) ) ).

tff(addAssignment_55255,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,24)
    <=> v91098(VarCurr,24) ) ).

tff(addAssignment_55254,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,28)
    <=> v91093(VarCurr,28) ) ).

tff(addAssignment_55253,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,28)
    <=> v91095(VarCurr,28) ) ).

tff(addAssignment_55252,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,28)
    <=> v91097(VarCurr,28) ) ).

tff(addAssignment_55251,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,28)
    <=> v91098(VarCurr,28) ) ).

tff(addAssignment_55250,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,31)
    <=> v91093(VarCurr,31) ) ).

tff(addAssignment_55249,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,31)
    <=> v91095(VarCurr,31) ) ).

tff(addAssignment_55248,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,31)
    <=> v91097(VarCurr,31) ) ).

tff(addAssignment_55247,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,31)
    <=> v91098(VarCurr,31) ) ).

tff(addAssignment_55246,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,51)
    <=> v91093(VarCurr,51) ) ).

tff(addAssignment_55245,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,51)
    <=> v91095(VarCurr,51) ) ).

tff(addAssignment_55244,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,51)
    <=> v91097(VarCurr,51) ) ).

tff(addAssignment_55243,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,51)
    <=> v91098(VarCurr,51) ) ).

tff(addAssignment_55242,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,60)
    <=> v91093(VarCurr,60) ) ).

tff(addAssignment_55241,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,60)
    <=> v91095(VarCurr,60) ) ).

tff(addAssignment_55240,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,60)
    <=> v91097(VarCurr,60) ) ).

tff(addAssignment_55239,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,60)
    <=> v91098(VarCurr,60) ) ).

tff(addAssignment_55238,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,65)
    <=> v91093(VarCurr,65) ) ).

tff(addAssignment_55237,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,65)
    <=> v91095(VarCurr,65) ) ).

tff(addAssignment_55236,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,65)
    <=> v91097(VarCurr,65) ) ).

tff(addAssignment_55235,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,65)
    <=> v91098(VarCurr,65) ) ).

tff(addAssignment_55234,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,2)
    <=> v91093(VarCurr,2) ) ).

tff(addAssignment_55233,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,2)
    <=> v91095(VarCurr,2) ) ).

tff(addAssignment_55232,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,2)
    <=> v91097(VarCurr,2) ) ).

tff(addAssignment_55231,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,2)
    <=> v91098(VarCurr,2) ) ).

tff(addAssignment_55230,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,4)
    <=> v91093(VarCurr,4) ) ).

tff(addAssignment_55229,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,4)
    <=> v91095(VarCurr,4) ) ).

tff(addAssignment_55228,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,4)
    <=> v91097(VarCurr,4) ) ).

tff(addAssignment_55227,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,4)
    <=> v91098(VarCurr,4) ) ).

tff(addAssignment_55226,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,10)
    <=> v91093(VarCurr,10) ) ).

tff(addAssignment_55225,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,10)
    <=> v91095(VarCurr,10) ) ).

tff(addAssignment_55224,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,10)
    <=> v91097(VarCurr,10) ) ).

tff(addAssignment_55223,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,10)
    <=> v91098(VarCurr,10) ) ).

tff(addAssignment_55222,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,13)
    <=> v91093(VarCurr,13) ) ).

tff(addAssignment_55221,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,13)
    <=> v91095(VarCurr,13) ) ).

tff(addAssignment_55220,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,13)
    <=> v91097(VarCurr,13) ) ).

tff(addAssignment_55219,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,13)
    <=> v91098(VarCurr,13) ) ).

tff(addAssignment_55218,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,17)
    <=> v91093(VarCurr,17) ) ).

tff(addAssignment_55217,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,17)
    <=> v91095(VarCurr,17) ) ).

tff(addAssignment_55216,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,17)
    <=> v91097(VarCurr,17) ) ).

tff(addAssignment_55215,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,17)
    <=> v91098(VarCurr,17) ) ).

tff(addAssignment_55214,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,20)
    <=> v91093(VarCurr,20) ) ).

tff(addAssignment_55213,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,20)
    <=> v91095(VarCurr,20) ) ).

tff(addAssignment_55212,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,20)
    <=> v91097(VarCurr,20) ) ).

tff(addAssignment_55211,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,20)
    <=> v91098(VarCurr,20) ) ).

tff(addAssignment_55210,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,23)
    <=> v91093(VarCurr,23) ) ).

tff(addAssignment_55209,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,23)
    <=> v91095(VarCurr,23) ) ).

tff(addAssignment_55208,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,23)
    <=> v91097(VarCurr,23) ) ).

tff(addAssignment_55207,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,23)
    <=> v91098(VarCurr,23) ) ).

tff(addAssignment_55206,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,27)
    <=> v91093(VarCurr,27) ) ).

tff(addAssignment_55205,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,27)
    <=> v91095(VarCurr,27) ) ).

tff(addAssignment_55204,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,27)
    <=> v91097(VarCurr,27) ) ).

tff(addAssignment_55203,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,27)
    <=> v91098(VarCurr,27) ) ).

tff(addAssignment_55202,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,30)
    <=> v91093(VarCurr,30) ) ).

tff(addAssignment_55201,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,30)
    <=> v91095(VarCurr,30) ) ).

tff(addAssignment_55200,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,30)
    <=> v91097(VarCurr,30) ) ).

tff(addAssignment_55199,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,30)
    <=> v91098(VarCurr,30) ) ).

tff(addAssignment_55198,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,43)
    <=> v91093(VarCurr,43) ) ).

tff(addAssignment_55197,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,43)
    <=> v91095(VarCurr,43) ) ).

tff(addAssignment_55196,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,43)
    <=> v91097(VarCurr,43) ) ).

tff(addAssignment_55195,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,43)
    <=> v91098(VarCurr,43) ) ).

tff(addAssignment_55194,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,45)
    <=> v91093(VarCurr,45) ) ).

tff(addAssignment_55193,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,45)
    <=> v91095(VarCurr,45) ) ).

tff(addAssignment_55192,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,45)
    <=> v91097(VarCurr,45) ) ).

tff(addAssignment_55191,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,45)
    <=> v91098(VarCurr,45) ) ).

tff(addAssignment_55190,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,47)
    <=> v91093(VarCurr,47) ) ).

tff(addAssignment_55189,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,47)
    <=> v91095(VarCurr,47) ) ).

tff(addAssignment_55188,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,47)
    <=> v91097(VarCurr,47) ) ).

tff(addAssignment_55187,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,47)
    <=> v91098(VarCurr,47) ) ).

tff(addAssignment_55186,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,50)
    <=> v91093(VarCurr,50) ) ).

tff(addAssignment_55185,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,50)
    <=> v91095(VarCurr,50) ) ).

tff(addAssignment_55184,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,50)
    <=> v91097(VarCurr,50) ) ).

tff(addAssignment_55183,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,50)
    <=> v91098(VarCurr,50) ) ).

tff(addAssignment_55182,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,57)
    <=> v91093(VarCurr,57) ) ).

tff(addAssignment_55181,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,57)
    <=> v91095(VarCurr,57) ) ).

tff(addAssignment_55180,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,57)
    <=> v91097(VarCurr,57) ) ).

tff(addAssignment_55179,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,57)
    <=> v91098(VarCurr,57) ) ).

tff(addAssignment_55178,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,59)
    <=> v91093(VarCurr,59) ) ).

tff(addAssignment_55177,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,59)
    <=> v91095(VarCurr,59) ) ).

tff(addAssignment_55176,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,59)
    <=> v91097(VarCurr,59) ) ).

tff(addAssignment_55175,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,59)
    <=> v91098(VarCurr,59) ) ).

tff(addAssignment_55174,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,64)
    <=> v91093(VarCurr,64) ) ).

tff(addAssignment_55173,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,64)
    <=> v91095(VarCurr,64) ) ).

tff(addAssignment_55172,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,64)
    <=> v91097(VarCurr,64) ) ).

tff(addAssignment_55171,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,64)
    <=> v91098(VarCurr,64) ) ).

tff(addAssignment_55170,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,69)
    <=> v91093(VarCurr,69) ) ).

tff(addAssignment_55169,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,69)
    <=> v91095(VarCurr,69) ) ).

tff(addAssignment_55168,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,69)
    <=> v91097(VarCurr,69) ) ).

tff(addAssignment_55167,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,69)
    <=> v91098(VarCurr,69) ) ).

tff(addAssignment_55166,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,0)
    <=> v91093(VarCurr,0) ) ).

tff(addAssignment_55165,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,0)
    <=> v91095(VarCurr,0) ) ).

tff(addAssignment_55164,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,0)
    <=> v91097(VarCurr,0) ) ).

tff(addAssignment_55163,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,0)
    <=> v91098(VarCurr,0) ) ).

tff(addAssignment_55162,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,1)
    <=> v91093(VarCurr,1) ) ).

tff(addAssignment_55161,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,1)
    <=> v91095(VarCurr,1) ) ).

tff(addAssignment_55160,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,1)
    <=> v91097(VarCurr,1) ) ).

tff(addAssignment_55159,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,1)
    <=> v91098(VarCurr,1) ) ).

tff(addAssignment_55158,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,3)
    <=> v91093(VarCurr,3) ) ).

tff(addAssignment_55157,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,3)
    <=> v91095(VarCurr,3) ) ).

tff(addAssignment_55156,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,3)
    <=> v91097(VarCurr,3) ) ).

tff(addAssignment_55155,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,3)
    <=> v91098(VarCurr,3) ) ).

tff(addAssignment_55154,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,6)
    <=> v91093(VarCurr,6) ) ).

tff(addAssignment_55153,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,6)
    <=> v91095(VarCurr,6) ) ).

tff(addAssignment_55152,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,6)
    <=> v91097(VarCurr,6) ) ).

tff(addAssignment_55151,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,6)
    <=> v91098(VarCurr,6) ) ).

tff(addAssignment_55150,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,7)
    <=> v91093(VarCurr,7) ) ).

tff(addAssignment_55149,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,7)
    <=> v91095(VarCurr,7) ) ).

tff(addAssignment_55148,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,7)
    <=> v91097(VarCurr,7) ) ).

tff(addAssignment_55147,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,7)
    <=> v91098(VarCurr,7) ) ).

tff(addAssignment_55146,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,8)
    <=> v91093(VarCurr,8) ) ).

tff(addAssignment_55145,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,8)
    <=> v91095(VarCurr,8) ) ).

tff(addAssignment_55144,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,8)
    <=> v91097(VarCurr,8) ) ).

tff(addAssignment_55143,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,8)
    <=> v91098(VarCurr,8) ) ).

tff(addAssignment_55142,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,9)
    <=> v91093(VarCurr,9) ) ).

tff(addAssignment_55141,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,9)
    <=> v91095(VarCurr,9) ) ).

tff(addAssignment_55140,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,9)
    <=> v91097(VarCurr,9) ) ).

tff(addAssignment_55139,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,9)
    <=> v91098(VarCurr,9) ) ).

tff(addAssignment_55138,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,12)
    <=> v91093(VarCurr,12) ) ).

tff(addAssignment_55137,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,12)
    <=> v91095(VarCurr,12) ) ).

tff(addAssignment_55136,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,12)
    <=> v91097(VarCurr,12) ) ).

tff(addAssignment_55135,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,12)
    <=> v91098(VarCurr,12) ) ).

tff(addAssignment_55134,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,16)
    <=> v91093(VarCurr,16) ) ).

tff(addAssignment_55133,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,16)
    <=> v91095(VarCurr,16) ) ).

tff(addAssignment_55132,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,16)
    <=> v91097(VarCurr,16) ) ).

tff(addAssignment_55131,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,16)
    <=> v91098(VarCurr,16) ) ).

tff(addAssignment_55130,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,18)
    <=> v91093(VarCurr,18) ) ).

tff(addAssignment_55129,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,18)
    <=> v91095(VarCurr,18) ) ).

tff(addAssignment_55128,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,18)
    <=> v91097(VarCurr,18) ) ).

tff(addAssignment_55127,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,18)
    <=> v91098(VarCurr,18) ) ).

tff(addAssignment_55126,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,19)
    <=> v91093(VarCurr,19) ) ).

tff(addAssignment_55125,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,19)
    <=> v91095(VarCurr,19) ) ).

tff(addAssignment_55124,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,19)
    <=> v91097(VarCurr,19) ) ).

tff(addAssignment_55123,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,19)
    <=> v91098(VarCurr,19) ) ).

tff(addAssignment_55122,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,21)
    <=> v91093(VarCurr,21) ) ).

tff(addAssignment_55121,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,21)
    <=> v91095(VarCurr,21) ) ).

tff(addAssignment_55120,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,21)
    <=> v91097(VarCurr,21) ) ).

tff(addAssignment_55119,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,21)
    <=> v91098(VarCurr,21) ) ).

tff(addAssignment_55118,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,22)
    <=> v91093(VarCurr,22) ) ).

tff(addAssignment_55117,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,22)
    <=> v91095(VarCurr,22) ) ).

tff(addAssignment_55116,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,22)
    <=> v91097(VarCurr,22) ) ).

tff(addAssignment_55115,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,22)
    <=> v91098(VarCurr,22) ) ).

tff(addAssignment_55114,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,25)
    <=> v91093(VarCurr,25) ) ).

tff(addAssignment_55113,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,25)
    <=> v91095(VarCurr,25) ) ).

tff(addAssignment_55112,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,25)
    <=> v91097(VarCurr,25) ) ).

tff(addAssignment_55111,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,25)
    <=> v91098(VarCurr,25) ) ).

tff(addAssignment_55110,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,26)
    <=> v91093(VarCurr,26) ) ).

tff(addAssignment_55109,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,26)
    <=> v91095(VarCurr,26) ) ).

tff(addAssignment_55108,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,26)
    <=> v91097(VarCurr,26) ) ).

tff(addAssignment_55107,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,26)
    <=> v91098(VarCurr,26) ) ).

tff(addAssignment_55106,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,29)
    <=> v91093(VarCurr,29) ) ).

tff(addAssignment_55105,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,29)
    <=> v91095(VarCurr,29) ) ).

tff(addAssignment_55104,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,29)
    <=> v91097(VarCurr,29) ) ).

tff(addAssignment_55103,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,29)
    <=> v91098(VarCurr,29) ) ).

tff(addAssignment_55102,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,34)
    <=> v91093(VarCurr,34) ) ).

tff(addAssignment_55101,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,34)
    <=> v91095(VarCurr,34) ) ).

tff(addAssignment_55100,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,34)
    <=> v91097(VarCurr,34) ) ).

tff(addAssignment_55099,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,34)
    <=> v91098(VarCurr,34) ) ).

tff(addAssignment_55098,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,35)
    <=> v91093(VarCurr,35) ) ).

tff(addAssignment_55097,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,35)
    <=> v91095(VarCurr,35) ) ).

tff(addAssignment_55096,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,35)
    <=> v91097(VarCurr,35) ) ).

tff(addAssignment_55095,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,35)
    <=> v91098(VarCurr,35) ) ).

tff(addAssignment_55094,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,36)
    <=> v91093(VarCurr,36) ) ).

tff(addAssignment_55093,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,36)
    <=> v91095(VarCurr,36) ) ).

tff(addAssignment_55092,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,36)
    <=> v91097(VarCurr,36) ) ).

tff(addAssignment_55091,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,36)
    <=> v91098(VarCurr,36) ) ).

tff(addAssignment_55090,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,37)
    <=> v91093(VarCurr,37) ) ).

tff(addAssignment_55089,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,37)
    <=> v91095(VarCurr,37) ) ).

tff(addAssignment_55088,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,37)
    <=> v91097(VarCurr,37) ) ).

tff(addAssignment_55087,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,37)
    <=> v91098(VarCurr,37) ) ).

tff(addAssignment_55086,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,38)
    <=> v91093(VarCurr,38) ) ).

tff(addAssignment_55085,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,38)
    <=> v91095(VarCurr,38) ) ).

tff(addAssignment_55084,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,38)
    <=> v91097(VarCurr,38) ) ).

tff(addAssignment_55083,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,38)
    <=> v91098(VarCurr,38) ) ).

tff(addAssignment_55082,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,39)
    <=> v91093(VarCurr,39) ) ).

tff(addAssignment_55081,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,39)
    <=> v91095(VarCurr,39) ) ).

tff(addAssignment_55080,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,39)
    <=> v91097(VarCurr,39) ) ).

tff(addAssignment_55079,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,39)
    <=> v91098(VarCurr,39) ) ).

tff(addAssignment_55078,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,40)
    <=> v91093(VarCurr,40) ) ).

tff(addAssignment_55077,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,40)
    <=> v91095(VarCurr,40) ) ).

tff(addAssignment_55076,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,40)
    <=> v91097(VarCurr,40) ) ).

tff(addAssignment_55075,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,40)
    <=> v91098(VarCurr,40) ) ).

tff(addAssignment_55074,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,41)
    <=> v91093(VarCurr,41) ) ).

tff(addAssignment_55073,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,41)
    <=> v91095(VarCurr,41) ) ).

tff(addAssignment_55072,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,41)
    <=> v91097(VarCurr,41) ) ).

tff(addAssignment_55071,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,41)
    <=> v91098(VarCurr,41) ) ).

tff(addAssignment_55070,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,42)
    <=> v91093(VarCurr,42) ) ).

tff(addAssignment_55069,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,42)
    <=> v91095(VarCurr,42) ) ).

tff(addAssignment_55068,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,42)
    <=> v91097(VarCurr,42) ) ).

tff(addAssignment_55067,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,42)
    <=> v91098(VarCurr,42) ) ).

tff(addAssignment_55066,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,44)
    <=> v91093(VarCurr,44) ) ).

tff(addAssignment_55065,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,44)
    <=> v91095(VarCurr,44) ) ).

tff(addAssignment_55064,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,44)
    <=> v91097(VarCurr,44) ) ).

tff(addAssignment_55063,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,44)
    <=> v91098(VarCurr,44) ) ).

tff(addAssignment_55062,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,46)
    <=> v91093(VarCurr,46) ) ).

tff(addAssignment_55061,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,46)
    <=> v91095(VarCurr,46) ) ).

tff(addAssignment_55060,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,46)
    <=> v91097(VarCurr,46) ) ).

tff(addAssignment_55059,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,46)
    <=> v91098(VarCurr,46) ) ).

tff(addAssignment_55058,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,48)
    <=> v91093(VarCurr,48) ) ).

tff(addAssignment_55057,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,48)
    <=> v91095(VarCurr,48) ) ).

tff(addAssignment_55056,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,48)
    <=> v91097(VarCurr,48) ) ).

tff(addAssignment_55055,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,48)
    <=> v91098(VarCurr,48) ) ).

tff(addAssignment_55054,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,49)
    <=> v91093(VarCurr,49) ) ).

tff(addAssignment_55053,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,49)
    <=> v91095(VarCurr,49) ) ).

tff(addAssignment_55052,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,49)
    <=> v91097(VarCurr,49) ) ).

tff(addAssignment_55051,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,49)
    <=> v91098(VarCurr,49) ) ).

tff(addAssignment_55050,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,52)
    <=> v91093(VarCurr,52) ) ).

tff(addAssignment_55049,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,52)
    <=> v91095(VarCurr,52) ) ).

tff(addAssignment_55048,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,52)
    <=> v91097(VarCurr,52) ) ).

tff(addAssignment_55047,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,52)
    <=> v91098(VarCurr,52) ) ).

tff(addAssignment_55046,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,53)
    <=> v91093(VarCurr,53) ) ).

tff(addAssignment_55045,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,53)
    <=> v91095(VarCurr,53) ) ).

tff(addAssignment_55044,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,53)
    <=> v91097(VarCurr,53) ) ).

tff(addAssignment_55043,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,53)
    <=> v91098(VarCurr,53) ) ).

tff(addAssignment_55042,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,54)
    <=> v91093(VarCurr,54) ) ).

tff(addAssignment_55041,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,54)
    <=> v91095(VarCurr,54) ) ).

tff(addAssignment_55040,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,54)
    <=> v91097(VarCurr,54) ) ).

tff(addAssignment_55039,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,54)
    <=> v91098(VarCurr,54) ) ).

tff(addAssignment_55038,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,55)
    <=> v91093(VarCurr,55) ) ).

tff(addAssignment_55037,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,55)
    <=> v91095(VarCurr,55) ) ).

tff(addAssignment_55036,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,55)
    <=> v91097(VarCurr,55) ) ).

tff(addAssignment_55035,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,55)
    <=> v91098(VarCurr,55) ) ).

tff(addAssignment_55034,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,56)
    <=> v91093(VarCurr,56) ) ).

tff(addAssignment_55033,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,56)
    <=> v91095(VarCurr,56) ) ).

tff(addAssignment_55032,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,56)
    <=> v91097(VarCurr,56) ) ).

tff(addAssignment_55031,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,56)
    <=> v91098(VarCurr,56) ) ).

tff(addAssignment_55030,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,58)
    <=> v91093(VarCurr,58) ) ).

tff(addAssignment_55029,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,58)
    <=> v91095(VarCurr,58) ) ).

tff(addAssignment_55028,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,58)
    <=> v91097(VarCurr,58) ) ).

tff(addAssignment_55027,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,58)
    <=> v91098(VarCurr,58) ) ).

tff(addAssignment_55026,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,63)
    <=> v91093(VarCurr,63) ) ).

tff(addAssignment_55025,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,63)
    <=> v91095(VarCurr,63) ) ).

tff(addAssignment_55024,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,63)
    <=> v91097(VarCurr,63) ) ).

tff(addAssignment_55023,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,63)
    <=> v91098(VarCurr,63) ) ).

tff(addAssignment_55022,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,66)
    <=> v91093(VarCurr,66) ) ).

tff(addAssignment_55021,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,66)
    <=> v91095(VarCurr,66) ) ).

tff(addAssignment_55020,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,66)
    <=> v91097(VarCurr,66) ) ).

tff(addAssignment_55019,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,66)
    <=> v91098(VarCurr,66) ) ).

tff(addAssignment_55018,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,67)
    <=> v91093(VarCurr,67) ) ).

tff(addAssignment_55017,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,67)
    <=> v91095(VarCurr,67) ) ).

tff(addAssignment_55016,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,67)
    <=> v91097(VarCurr,67) ) ).

tff(addAssignment_55015,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,67)
    <=> v91098(VarCurr,67) ) ).

tff(addAssignment_55014,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,68)
    <=> v91093(VarCurr,68) ) ).

tff(addAssignment_55013,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,68)
    <=> v91095(VarCurr,68) ) ).

tff(addAssignment_55012,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,68)
    <=> v91097(VarCurr,68) ) ).

tff(addAssignment_55011,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,68)
    <=> v91098(VarCurr,68) ) ).

tff(addAssignment_55010,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,70)
    <=> v91093(VarCurr,70) ) ).

tff(addAssignment_55009,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,70)
    <=> v91095(VarCurr,70) ) ).

tff(addAssignment_55008,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,70)
    <=> v91097(VarCurr,70) ) ).

tff(addAssignment_55007,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,70)
    <=> v91098(VarCurr,70) ) ).

tff(addAssignment_55006,axiom,
    ! [VarCurr: state_type] :
      ( v91091(VarCurr,71)
    <=> v91093(VarCurr,71) ) ).

tff(addAssignment_55005,axiom,
    ! [VarCurr: state_type] :
      ( v91093(VarCurr,71)
    <=> v91095(VarCurr,71) ) ).

tff(addAssignment_55004,axiom,
    ! [VarCurr: state_type] :
      ( v91095(VarCurr,71)
    <=> v91097(VarCurr,71) ) ).

tff(addAssignment_55003,axiom,
    ! [VarCurr: state_type] :
      ( v91097(VarCurr,71)
    <=> v91098(VarCurr,71) ) ).

tff(addAssignment_55002,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,0)
    <=> v53217(VarCurr,0) ) ).

tff(addAssignment_55001,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,1)
    <=> v53217(VarCurr,6) ) ).

tff(addAssignment_55000,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,2)
    <=> v53217(VarCurr,12) ) ).

tff(addAssignment_54999,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,3)
    <=> v53217(VarCurr,18) ) ).

tff(addAssignment_54998,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,4)
    <=> v53217(VarCurr,24) ) ).

tff(addAssignment_54997,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,5)
    <=> v53217(VarCurr,30) ) ).

tff(addAssignment_54996,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,6)
    <=> v53217(VarCurr,36) ) ).

tff(addAssignment_54995,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,7)
    <=> v53217(VarCurr,42) ) ).

tff(addAssignment_54994,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,8)
    <=> v53217(VarCurr,48) ) ).

tff(addAssignment_54993,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,9)
    <=> v53217(VarCurr,54) ) ).

tff(addAssignment_54992,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,10)
    <=> v53217(VarCurr,60) ) ).

tff(addAssignment_54991,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,11)
    <=> v53217(VarCurr,66) ) ).

tff(addAssignment_54990,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,12)
    <=> v53217(VarCurr,67) ) ).

tff(addAssignment_54989,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,13)
    <=> v53217(VarCurr,61) ) ).

tff(addAssignment_54988,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,14)
    <=> v53217(VarCurr,55) ) ).

tff(addAssignment_54987,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,15)
    <=> v53217(VarCurr,49) ) ).

tff(addAssignment_54986,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,16)
    <=> v53217(VarCurr,43) ) ).

tff(addAssignment_54985,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,17)
    <=> v53217(VarCurr,37) ) ).

tff(addAssignment_54984,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,18)
    <=> v53217(VarCurr,31) ) ).

tff(addAssignment_54983,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,19)
    <=> v53217(VarCurr,25) ) ).

tff(addAssignment_54982,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,20)
    <=> v53217(VarCurr,19) ) ).

tff(addAssignment_54981,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,21)
    <=> v53217(VarCurr,13) ) ).

tff(addAssignment_54980,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,22)
    <=> v53217(VarCurr,7) ) ).

tff(addAssignment_54979,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,23)
    <=> v53217(VarCurr,1) ) ).

tff(addAssignment_54978,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,24)
    <=> v53217(VarCurr,2) ) ).

tff(addAssignment_54977,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,25)
    <=> v53217(VarCurr,8) ) ).

tff(addAssignment_54976,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,26)
    <=> v53217(VarCurr,14) ) ).

tff(addAssignment_54975,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,27)
    <=> v53217(VarCurr,20) ) ).

tff(addAssignment_54974,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,28)
    <=> v53217(VarCurr,26) ) ).

tff(addAssignment_54973,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,29)
    <=> v53217(VarCurr,32) ) ).

tff(addAssignment_54972,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,30)
    <=> v53217(VarCurr,38) ) ).

tff(addAssignment_54971,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,31)
    <=> v53217(VarCurr,44) ) ).

tff(addAssignment_54970,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,32)
    <=> v53217(VarCurr,50) ) ).

tff(addAssignment_54969,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,33)
    <=> v53217(VarCurr,56) ) ).

tff(addAssignment_54968,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,34)
    <=> v53217(VarCurr,62) ) ).

tff(addAssignment_54967,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,35)
    <=> v53217(VarCurr,68) ) ).

tff(addAssignment_54966,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,36)
    <=> v53217(VarCurr,69) ) ).

tff(addAssignment_54965,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,37)
    <=> v53217(VarCurr,63) ) ).

tff(addAssignment_54964,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,38)
    <=> v53217(VarCurr,57) ) ).

tff(addAssignment_54963,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,39)
    <=> v53217(VarCurr,51) ) ).

tff(addAssignment_54962,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,40)
    <=> v53217(VarCurr,45) ) ).

tff(addAssignment_54961,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,41)
    <=> v53217(VarCurr,39) ) ).

tff(addAssignment_54960,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,42)
    <=> v53217(VarCurr,33) ) ).

tff(addAssignment_54959,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,43)
    <=> v53217(VarCurr,27) ) ).

tff(addAssignment_54958,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,44)
    <=> v53217(VarCurr,21) ) ).

tff(addAssignment_54957,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,45)
    <=> v53217(VarCurr,15) ) ).

tff(addAssignment_54956,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,46)
    <=> v53217(VarCurr,9) ) ).

tff(addAssignment_54955,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,47)
    <=> v53217(VarCurr,3) ) ).

tff(addAssignment_54954,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,48)
    <=> v53217(VarCurr,4) ) ).

tff(addAssignment_54953,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,49)
    <=> v53217(VarCurr,10) ) ).

tff(addAssignment_54952,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,50)
    <=> v53217(VarCurr,16) ) ).

tff(addAssignment_54951,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,51)
    <=> v53217(VarCurr,22) ) ).

tff(addAssignment_54950,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,52)
    <=> v53217(VarCurr,28) ) ).

tff(addAssignment_54949,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,53)
    <=> v53217(VarCurr,34) ) ).

tff(addAssignment_54948,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,54)
    <=> v53217(VarCurr,40) ) ).

tff(addAssignment_54947,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,55)
    <=> v53217(VarCurr,46) ) ).

tff(addAssignment_54946,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,56)
    <=> v53217(VarCurr,52) ) ).

tff(addAssignment_54945,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,57)
    <=> v53217(VarCurr,58) ) ).

tff(addAssignment_54944,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,58)
    <=> v53217(VarCurr,64) ) ).

tff(addAssignment_54943,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,59)
    <=> v53217(VarCurr,70) ) ).

tff(addAssignment_54942,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,60)
    <=> v53217(VarCurr,71) ) ).

tff(addAssignment_54941,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,61)
    <=> v53217(VarCurr,65) ) ).

tff(addAssignment_54940,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,62)
    <=> v53217(VarCurr,59) ) ).

tff(addAssignment_54939,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,63)
    <=> v53217(VarCurr,53) ) ).

tff(addAssignment_54938,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,64)
    <=> v53217(VarCurr,47) ) ).

tff(addAssignment_54937,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,65)
    <=> v53217(VarCurr,41) ) ).

tff(addAssignment_54936,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,66)
    <=> v53217(VarCurr,35) ) ).

tff(addAssignment_54935,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,67)
    <=> v53217(VarCurr,29) ) ).

tff(addAssignment_54934,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,68)
    <=> v53217(VarCurr,23) ) ).

tff(addAssignment_54933,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,69)
    <=> v53217(VarCurr,17) ) ).

tff(addAssignment_54932,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,70)
    <=> v53217(VarCurr,11) ) ).

tff(addAssignment_54931,axiom,
    ! [VarCurr: state_type] :
      ( v91098(VarCurr,71)
    <=> v53217(VarCurr,5) ) ).

tff(addAssignment_54930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91002(VarCurr,B)
      <=> v91004(VarCurr,B) ) ) ).

tff(addAssignment_54929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91004(VarCurr,B)
      <=> v91006(VarCurr,B) ) ) ).

tff(addAssignment_54928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91006(VarCurr,B)
      <=> v91008(VarCurr,B) ) ) ).

tff(addAssignment_54927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91008(VarCurr,B)
      <=> v91010(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91010(VarCurr,B)
      <=> ( v91062(VarCurr,B)
          | v91065(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91065(VarCurr,B)
      <=> ( v91041(VarCurr,B)
          & v91066(VarCurr,B) ) ) ) ).

tff(addAssignment_54926,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,0)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54925,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,1)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54924,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,2)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54923,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,3)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54922,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,4)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54921,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,5)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54920,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,6)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54919,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,7)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54918,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,8)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54917,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,9)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54916,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,10)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54915,axiom,
    ! [VarCurr: state_type] :
      ( v91066(VarCurr,11)
    <=> v91067(VarCurr) ) ).

tff(addAssignment_54914,axiom,
    ! [VarCurr: state_type] :
      ( v91067(VarCurr)
    <=> v91048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91062(VarCurr,B)
      <=> ( v91012(VarCurr,B)
          & v91063(VarCurr,B) ) ) ) ).

tff(addAssignment_54913,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,0)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54912,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,1)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54911,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,2)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54910,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,3)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54909,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,4)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54908,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,5)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54907,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,6)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54906,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,7)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54905,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,8)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54904,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,9)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54903,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,10)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54902,axiom,
    ! [VarCurr: state_type] :
      ( v91063(VarCurr,11)
    <=> v91064(VarCurr) ) ).

tff(addAssignment_54901,axiom,
    ! [VarCurr: state_type] :
      ( v91064(VarCurr)
    <=> v91019(VarCurr) ) ).

tff(addAssignment_54900,axiom,
    ! [VarCurr: state_type] :
      ( v91048(VarCurr)
    <=> v91050(VarCurr) ) ).

tff(addAssignment_54899,axiom,
    ! [VarCurr: state_type] :
      ( v91050(VarCurr)
    <=> v91052(VarCurr) ) ).

tff(addAssignment_54898,axiom,
    ! [VarCurr: state_type] :
      ( v91052(VarCurr)
    <=> v91054(VarCurr) ) ).

tff(addAssignment_54897,axiom,
    ! [VarCurr: state_type] :
      ( v91054(VarCurr)
    <=> v91056(VarCurr) ) ).

tff(addAssignment_54896,axiom,
    ! [VarCurr: state_type] :
      ( v91056(VarCurr)
    <=> v91058(VarCurr) ) ).

tff(addAssignment_54895,axiom,
    ! [VarCurr: state_type] :
      ( v91058(VarCurr)
    <=> v91060(VarCurr) ) ).

tff(addAssignment_54894,axiom,
    ! [VarCurr: state_type] :
      ( v91060(VarCurr)
    <=> v91035(VarCurr) ) ).

tff(addAssignment_54893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91041(VarCurr,B)
      <=> v91043(VarCurr,B) ) ) ).

tff(addAssignment_54892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91043(VarCurr,B)
      <=> v91045(VarCurr,B) ) ) ).

tff(addAssignment_54891,axiom,
    ! [VarCurr: state_type] :
      ( ( v91045(VarCurr,5)
      <=> v6236(VarCurr,149) )
      & ( v91045(VarCurr,4)
      <=> v6236(VarCurr,148) )
      & ( v91045(VarCurr,3)
      <=> v6236(VarCurr,147) )
      & ( v91045(VarCurr,2)
      <=> v6236(VarCurr,146) )
      & ( v91045(VarCurr,1)
      <=> v6236(VarCurr,145) )
      & ( v91045(VarCurr,0)
      <=> v6236(VarCurr,144) ) ) ).

tff(addAssignment_54890,axiom,
    ! [VarCurr: state_type] :
      ( ( v91045(VarCurr,11)
      <=> $false )
      & ( v91045(VarCurr,10)
      <=> $false )
      & ( v91045(VarCurr,9)
      <=> $false )
      & ( v91045(VarCurr,8)
      <=> $false )
      & ( v91045(VarCurr,7)
      <=> $false )
      & ( v91045(VarCurr,6)
      <=> $false ) ) ).

tff(addAssignment_54889,axiom,
    ! [VarCurr: state_type] :
      ( v91019(VarCurr)
    <=> v91021(VarCurr) ) ).

tff(addAssignment_54888,axiom,
    ! [VarCurr: state_type] :
      ( v91021(VarCurr)
    <=> v91023(VarCurr) ) ).

tff(addAssignment_54887,axiom,
    ! [VarCurr: state_type] :
      ( v91023(VarCurr)
    <=> v91025(VarCurr) ) ).

tff(addAssignment_54886,axiom,
    ! [VarCurr: state_type] :
      ( v91025(VarCurr)
    <=> v91027(VarCurr) ) ).

tff(addAssignment_54885,axiom,
    ! [VarCurr: state_type] :
      ( v91027(VarCurr)
    <=> v91029(VarCurr) ) ).

tff(addAssignment_54884,axiom,
    ! [VarCurr: state_type] :
      ( v91029(VarCurr)
    <=> v91031(VarCurr) ) ).

tff(addAssignment_54883,axiom,
    ! [VarCurr: state_type] :
      ( v91031(VarCurr)
    <=> v91033(VarCurr) ) ).

tff(writeUnaryOperator_4293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v91033(VarCurr)
    <=> v91035(VarCurr) ) ).

tff(writeUnaryOperator_4292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v91035(VarCurr)
    <=> v91038(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_930,axiom,
    ! [VarCurr: state_type] :
      ( v91038(VarCurr)
    <=> ( v6625(VarCurr,3)
        & v6729(VarCurr) ) ) ).

tff(addAssignment_54882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91012(VarCurr,B)
      <=> v91014(VarCurr,B) ) ) ).

tff(addAssignment_54881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v91014(VarCurr,B)
      <=> v91016(VarCurr,B) ) ) ).

tff(addAssignment_54880,axiom,
    ! [VarCurr: state_type] :
      ( ( v91016(VarCurr,5)
      <=> v6236(VarCurr,161) )
      & ( v91016(VarCurr,4)
      <=> v6236(VarCurr,160) )
      & ( v91016(VarCurr,3)
      <=> v6236(VarCurr,159) )
      & ( v91016(VarCurr,2)
      <=> v6236(VarCurr,158) )
      & ( v91016(VarCurr,1)
      <=> v6236(VarCurr,157) )
      & ( v91016(VarCurr,0)
      <=> v6236(VarCurr,156) ) ) ).

tff(addAssignment_54879,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,6)
    <=> v6236(VarCurr,149) ) ).

tff(addAssignment_54878,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,7)
    <=> v6236(VarCurr,148) ) ).

tff(addAssignment_54877,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,8)
    <=> v6236(VarCurr,147) ) ).

tff(addAssignment_54876,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,9)
    <=> v6236(VarCurr,146) ) ).

tff(addAssignment_54875,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,10)
    <=> v6236(VarCurr,145) ) ).

tff(addAssignment_54874,axiom,
    ! [VarCurr: state_type] :
      ( v91016(VarCurr,11)
    <=> v6236(VarCurr,144) ) ).

tff(addAssignment_54873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,162)
        & ~ $less(B,156) )
     => ( v6236(VarCurr,B)
      <=> v6238(VarCurr,B) ) ) ).

tff(addAssignment_54872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,162)
        & ~ $less(B,156) )
     => ( v6238(VarCurr,B)
      <=> v6240(VarCurr,B) ) ) ).

tff(addAssignment_54871,axiom,
    ! [VarCurr: state_type] :
      ( ( v6240(VarCurr,161)
      <=> v50949(VarCurr,5) )
      & ( v6240(VarCurr,160)
      <=> v50949(VarCurr,4) )
      & ( v6240(VarCurr,159)
      <=> v50949(VarCurr,3) )
      & ( v6240(VarCurr,158)
      <=> v50949(VarCurr,2) )
      & ( v6240(VarCurr,157)
      <=> v50949(VarCurr,1) )
      & ( v6240(VarCurr,156)
      <=> v50949(VarCurr,0) ) ) ).

tff(addAssignment_54870,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,149)
    <=> v6238(VarCurr,149) ) ).

tff(addAssignment_54869,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,149)
    <=> v6240(VarCurr,149) ) ).

tff(addAssignment_54868,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,149)
    <=> v49399(VarCurr,5) ) ).

tff(addAssignment_54867,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,148)
    <=> v6238(VarCurr,148) ) ).

tff(addAssignment_54866,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,148)
    <=> v6240(VarCurr,148) ) ).

tff(addAssignment_54865,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,148)
    <=> v49399(VarCurr,4) ) ).

tff(addAssignment_54864,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,147)
    <=> v6238(VarCurr,147) ) ).

tff(addAssignment_54863,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,147)
    <=> v6240(VarCurr,147) ) ).

tff(addAssignment_54862,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,147)
    <=> v49399(VarCurr,3) ) ).

tff(addAssignment_54861,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,146)
    <=> v6238(VarCurr,146) ) ).

tff(addAssignment_54860,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,146)
    <=> v6240(VarCurr,146) ) ).

tff(addAssignment_54859,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,146)
    <=> v49399(VarCurr,2) ) ).

tff(addAssignment_54858,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,145)
    <=> v6238(VarCurr,145) ) ).

tff(addAssignment_54857,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,145)
    <=> v6240(VarCurr,145) ) ).

tff(addAssignment_54856,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,145)
    <=> v49399(VarCurr,1) ) ).

tff(addAssignment_54855,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,144)
    <=> v6238(VarCurr,144) ) ).

tff(addAssignment_54854,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,144)
    <=> v6240(VarCurr,144) ) ).

tff(addAssignment_54853,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,144)
    <=> v49399(VarCurr,0) ) ).

tff(addAssignment_54852,axiom,
    ! [VarCurr: state_type] :
      ( v90978(VarCurr)
    <=> v90980(VarCurr) ) ).

tff(addAssignment_54851,axiom,
    ! [VarCurr: state_type] :
      ( v90980(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54850,axiom,
    ! [VarCurr: state_type] :
      ( v90974(VarCurr)
    <=> v90976(VarCurr) ) ).

tff(addAssignment_54849,axiom,
    ! [VarCurr: state_type] :
      ( v90976(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_54848,axiom,
    ! [VarCurr: state_type] :
      ( v90859(VarCurr)
    <=> v90861(VarCurr,1) ) ).

tff(addAssignment_54847,axiom,
    ! [VarCurr: state_type] :
      ( v90861(VarCurr,1)
    <=> v90863(VarCurr,1) ) ).

tff(addAssignment_54846,axiom,
    ! [VarNext: state_type] :
      ( v90863(VarNext,1)
    <=> v90950(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90951(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v90950(VarNext,B)
            <=> v90863(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1034,axiom,
    ! [VarNext: state_type] :
      ( v90951(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90950(VarNext,B)
          <=> v90961(VarNext,B) ) ) ) ).

tff(addAssignment_54845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90961(VarNext,B)
          <=> v90959(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90962(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90959(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_569,axiom,
    ! [VarCurr: state_type] :
      ( v90962(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90959(VarCurr,B)
          <=> v90873(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8658,axiom,
    ! [VarCurr: state_type] :
      ( v90962(VarCurr)
    <=> ( v90963(VarCurr)
        & v90964(VarCurr) ) ) ).

tff(writeUnaryOperator_4291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90964(VarCurr)
    <=> v90869(VarCurr) ) ).

tff(writeUnaryOperator_4290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90963(VarCurr)
    <=> v90865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90951(VarNext)
      <=> v90952(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90952(VarNext)
      <=> ( v90953(VarNext)
          & v90946(VarNext) ) ) ) ).

tff(writeUnaryOperator_4289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90953(VarNext)
      <=> v90955(VarNext) ) ) ).

tff(addAssignment_54844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90955(VarNext)
      <=> v90946(VarCurr) ) ) ).

tff(addAssignment_54843,axiom,
    ! [VarCurr: state_type] :
      ( v90946(VarCurr)
    <=> v90948(VarCurr) ) ).

tff(addAssignment_54842,axiom,
    ! [VarCurr: state_type] :
      ( v90948(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_54841,axiom,
    ! [VarCurr: state_type] :
      ( v90873(VarCurr,1)
    <=> v90875(VarCurr,1) ) ).

tff(addAssignment_54840,axiom,
    ! [VarCurr: state_type] :
      ( v90875(VarCurr,1)
    <=> v90877(VarCurr,1) ) ).

tff(addAssignment_54839,axiom,
    ! [VarCurr: state_type] :
      ( v90877(VarCurr,1)
    <=> v90943(VarCurr,1) ) ).

tff(addAssignment_54838,axiom,
    ! [VarCurr: state_type] :
      ( v90943(VarCurr,0)
    <=> v90944(VarCurr) ) ).

tff(addAssignment_54837,axiom,
    ! [VarCurr: state_type] :
      ( v90943(VarCurr,1)
    <=> v90879(VarCurr) ) ).

tff(addAssignment_54836,axiom,
    ! [VarCurr: state_type] :
      ( v90879(VarCurr)
    <=> v90881(VarCurr) ) ).

tff(addAssignment_54835,axiom,
    ! [VarCurr: state_type] :
      ( v90881(VarCurr)
    <=> v90883(VarCurr) ) ).

tff(addAssignment_54834,axiom,
    ! [VarCurr: state_type] :
      ( v90883(VarCurr)
    <=> v90885(VarCurr,1) ) ).

tff(addAssignment_54833,axiom,
    ! [VarCurr: state_type] :
      ( v90885(VarCurr,1)
    <=> v90887(VarCurr,1) ) ).

tff(addAssignment_54832,axiom,
    ! [VarNext: state_type] :
      ( v90887(VarNext,1)
    <=> v90926(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90927(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v90926(VarNext,B)
            <=> v90887(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1033,axiom,
    ! [VarNext: state_type] :
      ( v90927(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v90926(VarNext,B)
          <=> v90937(VarNext,B) ) ) ) ).

tff(addAssignment_54831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v90937(VarNext,B)
          <=> v90935(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90938(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v90935(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_568,axiom,
    ! [VarCurr: state_type] :
      ( v90938(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v90935(VarCurr,B)
          <=> v90897(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8655,axiom,
    ! [VarCurr: state_type] :
      ( v90938(VarCurr)
    <=> ( v90939(VarCurr)
        & v90940(VarCurr) ) ) ).

tff(writeUnaryOperator_4288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90940(VarCurr)
    <=> v90893(VarCurr) ) ).

tff(writeUnaryOperator_4287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90939(VarCurr)
    <=> v90889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90927(VarNext)
      <=> v90928(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90928(VarNext)
      <=> ( v90929(VarNext)
          & v90922(VarNext) ) ) ) ).

tff(writeUnaryOperator_4286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90929(VarNext)
      <=> v90931(VarNext) ) ) ).

tff(addAssignment_54830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90931(VarNext)
      <=> v90922(VarCurr) ) ) ).

tff(addAssignment_54829,axiom,
    ! [VarCurr: state_type] :
      ( v90922(VarCurr)
    <=> v90924(VarCurr) ) ).

tff(addAssignment_54828,axiom,
    ! [VarCurr: state_type] :
      ( v90924(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_54827,axiom,
    ! [VarCurr: state_type] :
      ( v90897(VarCurr,1)
    <=> v90899(VarCurr,1) ) ).

tff(addAssignment_54826,axiom,
    ! [VarCurr: state_type] :
      ( v90899(VarCurr,1)
    <=> v90913(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v90913(VarCurr,B)
      <=> ( v90914(VarCurr,B)
          | v90917(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v90917(VarCurr,B)
      <=> ( v90885(VarCurr,B)
          & v90918(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v90918(VarCurr,B)
      <=> ~ v90919(VarCurr,B) ) ) ).

tff(addAssignment_54825,axiom,
    ! [VarCurr: state_type] :
      ( v90919(VarCurr,0)
    <=> v90920(VarCurr) ) ).

tff(addAssignment_54824,axiom,
    ! [VarCurr: state_type] :
      ( v90919(VarCurr,1)
    <=> v90920(VarCurr) ) ).

tff(addAssignment_54823,axiom,
    ! [VarCurr: state_type] :
      ( v90919(VarCurr,2)
    <=> v90920(VarCurr) ) ).

tff(addAssignment_54822,axiom,
    ! [VarCurr: state_type] :
      ( v90920(VarCurr)
    <=> v90912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v90914(VarCurr,B)
      <=> ( v90901(VarCurr,B)
          & v90915(VarCurr,B) ) ) ) ).

tff(addAssignment_54821,axiom,
    ! [VarCurr: state_type] :
      ( v90915(VarCurr,0)
    <=> v90916(VarCurr) ) ).

tff(addAssignment_54820,axiom,
    ! [VarCurr: state_type] :
      ( v90915(VarCurr,1)
    <=> v90916(VarCurr) ) ).

tff(addAssignment_54819,axiom,
    ! [VarCurr: state_type] :
      ( v90915(VarCurr,2)
    <=> v90916(VarCurr) ) ).

tff(addAssignment_54818,axiom,
    ! [VarCurr: state_type] :
      ( v90916(VarCurr)
    <=> v90912(VarCurr) ) ).

tff(addAssignment_54817,axiom,
    ! [VarCurr: state_type] :
      ( v90912(VarCurr)
    <=> v1609(VarCurr) ) ).

tff(addAssignment_54816,axiom,
    ! [VarCurr: state_type] :
      ( v90901(VarCurr,1)
    <=> v90908(VarCurr,1) ) ).

tff(addAssignment_54815,axiom,
    ! [VarCurr: state_type] :
      ( v90908(VarCurr,0)
    <=> v90910(VarCurr) ) ).

tff(addAssignment_54814,axiom,
    ! [VarCurr: state_type] :
      ( v90908(VarCurr,1)
    <=> v90903(VarCurr) ) ).

tff(addAssignment_54813,axiom,
    ! [VarCurr: state_type] :
      ( v90908(VarCurr,2)
    <=> v90909(VarCurr) ) ).

tff(addAssignment_54812,axiom,
    ! [VarCurr: state_type] :
      ( v90903(VarCurr)
    <=> v90905(VarCurr,1) ) ).

tff(addAssignment_54811,axiom,
    ! [VarCurr: state_type] :
      ( v90905(VarCurr,1)
    <=> v90907(VarCurr,1) ) ).

tff(addAssignment_54810,axiom,
    ! [VarCurr: state_type] :
      ( v90893(VarCurr)
    <=> v90895(VarCurr) ) ).

tff(addAssignment_54809,axiom,
    ! [VarCurr: state_type] :
      ( v90895(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_54808,axiom,
    ! [VarCurr: state_type] :
      ( v90889(VarCurr)
    <=> v90891(VarCurr) ) ).

tff(addAssignment_54807,axiom,
    ! [VarCurr: state_type] :
      ( v90891(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_54806,axiom,
    ! [VarCurr: state_type] :
      ( v90869(VarCurr)
    <=> v90871(VarCurr) ) ).

tff(addAssignment_54805,axiom,
    ! [VarCurr: state_type] :
      ( v90871(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54804,axiom,
    ! [VarCurr: state_type] :
      ( v90865(VarCurr)
    <=> v90867(VarCurr) ) ).

tff(addAssignment_54803,axiom,
    ! [VarCurr: state_type] :
      ( v90867(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_54802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90800(VarCurr,B)
      <=> v90802(VarCurr,B) ) ) ).

tff(addAssignment_54801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90802(VarCurr,B)
      <=> v90804(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90842(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v90804(VarNext,B)
            <=> v90804(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1032,axiom,
    ! [VarNext: state_type] :
      ( v90842(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90804(VarNext,B)
          <=> v90852(VarNext,B) ) ) ) ).

tff(addAssignment_54800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90852(VarNext,B)
          <=> v90850(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90850(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_567,axiom,
    ! [VarCurr: state_type] :
      ( v90853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v90850(VarCurr,B)
          <=> v90814(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8652,axiom,
    ! [VarCurr: state_type] :
      ( v90853(VarCurr)
    <=> ( v90854(VarCurr)
        & v90855(VarCurr) ) ) ).

tff(writeUnaryOperator_4284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90855(VarCurr)
    <=> v90810(VarCurr) ) ).

tff(writeUnaryOperator_4283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90854(VarCurr)
    <=> v90806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90842(VarNext)
      <=> v90843(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90843(VarNext)
      <=> ( v90844(VarNext)
          & v90837(VarNext) ) ) ) ).

tff(writeUnaryOperator_4282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90844(VarNext)
      <=> v90846(VarNext) ) ) ).

tff(addAssignment_54799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90846(VarNext)
      <=> v90837(VarCurr) ) ) ).

tff(addAssignment_54798,axiom,
    ! [VarCurr: state_type] :
      ( v90837(VarCurr)
    <=> v90839(VarCurr) ) ).

tff(addAssignment_54797,axiom,
    ! [VarCurr: state_type] :
      ( v90839(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_54796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90814(VarCurr,B)
      <=> v90816(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90816(VarCurr,B)
      <=> ( v90829(VarCurr,B)
          | v90832(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90832(VarCurr,B)
      <=> ( v90802(VarCurr,B)
          & v90833(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90833(VarCurr,B)
      <=> ~ v90834(VarCurr,B) ) ) ).

tff(addAssignment_54795,axiom,
    ! [VarCurr: state_type] :
      ( v90834(VarCurr,0)
    <=> v90835(VarCurr) ) ).

tff(addAssignment_54794,axiom,
    ! [VarCurr: state_type] :
      ( v90834(VarCurr,1)
    <=> v90835(VarCurr) ) ).

tff(addAssignment_54793,axiom,
    ! [VarCurr: state_type] :
      ( v90835(VarCurr)
    <=> v90822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90829(VarCurr,B)
      <=> ( v90818(VarCurr,B)
          & v90830(VarCurr,B) ) ) ) ).

tff(addAssignment_54792,axiom,
    ! [VarCurr: state_type] :
      ( v90830(VarCurr,0)
    <=> v90831(VarCurr) ) ).

tff(addAssignment_54791,axiom,
    ! [VarCurr: state_type] :
      ( v90830(VarCurr,1)
    <=> v90831(VarCurr) ) ).

tff(addAssignment_54790,axiom,
    ! [VarCurr: state_type] :
      ( v90831(VarCurr)
    <=> v90822(VarCurr) ) ).

tff(addAssignment_54789,axiom,
    ! [VarCurr: state_type] :
      ( v90822(VarCurr)
    <=> v90824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8649,axiom,
    ! [VarCurr: state_type] :
      ( v90824(VarCurr)
    <=> ( v2354(VarCurr)
        & v90827(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_485,axiom,
    ! [VarCurr: state_type] :
      ( v90827(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1399,axiom,
    ~ b0110000001000(12) ).

tff(bitBlastConstant_1398,axiom,
    b0110000001000(11) ).

tff(bitBlastConstant_1397,axiom,
    b0110000001000(10) ).

tff(bitBlastConstant_1396,axiom,
    ~ b0110000001000(9) ).

tff(bitBlastConstant_1395,axiom,
    ~ b0110000001000(8) ).

tff(bitBlastConstant_1394,axiom,
    ~ b0110000001000(7) ).

tff(bitBlastConstant_1393,axiom,
    ~ b0110000001000(6) ).

tff(bitBlastConstant_1392,axiom,
    ~ b0110000001000(5) ).

tff(bitBlastConstant_1391,axiom,
    ~ b0110000001000(4) ).

tff(bitBlastConstant_1390,axiom,
    b0110000001000(3) ).

tff(bitBlastConstant_1389,axiom,
    ~ b0110000001000(2) ).

tff(bitBlastConstant_1388,axiom,
    ~ b0110000001000(1) ).

tff(bitBlastConstant_1387,axiom,
    ~ b0110000001000(0) ).

tff(addAssignment_54788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90818(VarCurr,B)
      <=> v90820(VarCurr,B) ) ) ).

tff(addAssignment_54787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v90820(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_54786,axiom,
    ! [VarCurr: state_type] :
      ( v90810(VarCurr)
    <=> v90812(VarCurr) ) ).

tff(addAssignment_54785,axiom,
    ! [VarCurr: state_type] :
      ( v90812(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54784,axiom,
    ! [VarCurr: state_type] :
      ( v90806(VarCurr)
    <=> v90808(VarCurr) ) ).

tff(addAssignment_54783,axiom,
    ! [VarCurr: state_type] :
      ( v90808(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90304(VarCurr,B)
      <=> ( v90792(VarCurr,B)
          & v90794(VarCurr,B) ) ) ) ).

tff(addAssignment_54782,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,0)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54781,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,1)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54780,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,2)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54779,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,3)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54778,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,4)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54777,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,5)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54776,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,6)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54775,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,7)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54774,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,8)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54773,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,9)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54772,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,10)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54771,axiom,
    ! [VarCurr: state_type] :
      ( v90794(VarCurr,11)
    <=> v90795(VarCurr) ) ).

tff(addAssignment_54770,axiom,
    ! [VarCurr: state_type] :
      ( v90795(VarCurr)
    <=> v90796(VarCurr) ) ).

tff(writeUnaryOperator_4280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90796(VarCurr)
    <=> v10059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90792(VarCurr,B)
      <=> ( v90793(VarCurr,B)
          & v90212(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90793(VarCurr,B)
      <=> ~ v90306(VarCurr,B) ) ) ).

tff(addAssignment_54769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90306(VarCurr,B)
      <=> v90308(VarCurr,B) ) ) ).

tff(addAssignment_54768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90308(VarCurr,B)
      <=> v90310(VarCurr,B) ) ) ).

tff(addAssignment_54767,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,11)
    <=> v90752(VarCurr) ) ).

tff(addAssignment_54766,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,10)
    <=> v90712(VarCurr) ) ).

tff(addAssignment_54765,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,9)
    <=> v90672(VarCurr) ) ).

tff(addAssignment_54764,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,8)
    <=> v90632(VarCurr) ) ).

tff(addAssignment_54763,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,7)
    <=> v90592(VarCurr) ) ).

tff(addAssignment_54762,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,6)
    <=> v90552(VarCurr) ) ).

tff(addAssignment_54761,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,5)
    <=> v90512(VarCurr) ) ).

tff(addAssignment_54760,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,4)
    <=> v90472(VarCurr) ) ).

tff(addAssignment_54759,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,3)
    <=> v90432(VarCurr) ) ).

tff(addAssignment_54758,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,2)
    <=> v90392(VarCurr) ) ).

tff(addAssignment_54757,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,1)
    <=> v90352(VarCurr) ) ).

tff(addAssignment_54756,axiom,
    ! [VarCurr: state_type] :
      ( v90310(VarCurr,0)
    <=> v90312(VarCurr) ) ).

tff(addAssignment_54755,axiom,
    ! [VarCurr: state_type] :
      ( v90752(VarCurr)
    <=> v90754(VarCurr) ) ).

tff(addAssignment_54754,axiom,
    ! [VarCurr: state_type] :
      ( v90754(VarCurr)
    <=> v90756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8648,axiom,
    ! [VarCurr: state_type] :
      ( v90756(VarCurr)
    <=> ( v90790(VarCurr)
      <~> v90786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8647,axiom,
    ! [VarCurr: state_type] :
      ( v90790(VarCurr)
    <=> ( v90758(VarCurr)
      <~> v90782(VarCurr) ) ) ).

tff(addAssignment_54753,axiom,
    ! [VarCurr: state_type] :
      ( v90786(VarCurr)
    <=> v90788(VarCurr) ) ).

tff(addAssignment_54752,axiom,
    ! [VarCurr: state_type] :
      ( v90788(VarCurr)
    <=> v26555(VarCurr,4) ) ).

tff(addAssignment_54751,axiom,
    ! [VarCurr: state_type] :
      ( v90782(VarCurr)
    <=> v90784(VarCurr) ) ).

tff(addAssignment_54750,axiom,
    ! [VarCurr: state_type] :
      ( v90784(VarCurr)
    <=> v26555(VarCurr,3) ) ).

tff(addAssignment_54749,axiom,
    ! [VarCurr: state_type] :
      ( v90758(VarCurr)
    <=> v90760(VarCurr) ) ).

tff(addAssignment_54748,axiom,
    ! [VarCurr: state_type] :
      ( v90760(VarCurr)
    <=> v90762(VarCurr) ) ).

tff(addAssignment_54747,axiom,
    ! [VarCurr: state_type] :
      ( v90762(VarCurr)
    <=> v90764(VarCurr) ) ).

tff(addAssignment_54746,axiom,
    ! [VarCurr: state_type] :
      ( v90764(VarCurr)
    <=> v90766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8646,axiom,
    ! [VarCurr: state_type] :
      ( v90766(VarCurr)
    <=> ( v90780(VarCurr)
      <~> v90776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8645,axiom,
    ! [VarCurr: state_type] :
      ( v90780(VarCurr)
    <=> ( v90768(VarCurr)
      <~> v90772(VarCurr) ) ) ).

tff(addAssignment_54745,axiom,
    ! [VarCurr: state_type] :
      ( v90776(VarCurr)
    <=> v90778(VarCurr) ) ).

tff(addAssignment_54744,axiom,
    ! [VarCurr: state_type] :
      ( v90778(VarCurr)
    <=> v26555(VarCurr,2) ) ).

tff(addAssignment_54743,axiom,
    ! [VarCurr: state_type] :
      ( v90772(VarCurr)
    <=> v90774(VarCurr) ) ).

tff(addAssignment_54742,axiom,
    ! [VarCurr: state_type] :
      ( v90774(VarCurr)
    <=> v26555(VarCurr,1) ) ).

tff(addAssignment_54741,axiom,
    ! [VarCurr: state_type] :
      ( v90768(VarCurr)
    <=> v90770(VarCurr) ) ).

tff(addAssignment_54740,axiom,
    ! [VarCurr: state_type] :
      ( v90770(VarCurr)
    <=> v26555(VarCurr,0) ) ).

tff(addAssignment_54739,axiom,
    ! [VarCurr: state_type] :
      ( v90712(VarCurr)
    <=> v90714(VarCurr) ) ).

tff(addAssignment_54738,axiom,
    ! [VarCurr: state_type] :
      ( v90714(VarCurr)
    <=> v90716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8644,axiom,
    ! [VarCurr: state_type] :
      ( v90716(VarCurr)
    <=> ( v90750(VarCurr)
      <~> v90746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8643,axiom,
    ! [VarCurr: state_type] :
      ( v90750(VarCurr)
    <=> ( v90718(VarCurr)
      <~> v90742(VarCurr) ) ) ).

tff(addAssignment_54737,axiom,
    ! [VarCurr: state_type] :
      ( v90746(VarCurr)
    <=> v90748(VarCurr) ) ).

tff(addAssignment_54736,axiom,
    ! [VarCurr: state_type] :
      ( v90748(VarCurr)
    <=> v25005(VarCurr,4) ) ).

tff(addAssignment_54735,axiom,
    ! [VarCurr: state_type] :
      ( v90742(VarCurr)
    <=> v90744(VarCurr) ) ).

tff(addAssignment_54734,axiom,
    ! [VarCurr: state_type] :
      ( v90744(VarCurr)
    <=> v25005(VarCurr,3) ) ).

tff(addAssignment_54733,axiom,
    ! [VarCurr: state_type] :
      ( v90718(VarCurr)
    <=> v90720(VarCurr) ) ).

tff(addAssignment_54732,axiom,
    ! [VarCurr: state_type] :
      ( v90720(VarCurr)
    <=> v90722(VarCurr) ) ).

tff(addAssignment_54731,axiom,
    ! [VarCurr: state_type] :
      ( v90722(VarCurr)
    <=> v90724(VarCurr) ) ).

tff(addAssignment_54730,axiom,
    ! [VarCurr: state_type] :
      ( v90724(VarCurr)
    <=> v90726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8642,axiom,
    ! [VarCurr: state_type] :
      ( v90726(VarCurr)
    <=> ( v90740(VarCurr)
      <~> v90736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8641,axiom,
    ! [VarCurr: state_type] :
      ( v90740(VarCurr)
    <=> ( v90728(VarCurr)
      <~> v90732(VarCurr) ) ) ).

tff(addAssignment_54729,axiom,
    ! [VarCurr: state_type] :
      ( v90736(VarCurr)
    <=> v90738(VarCurr) ) ).

tff(addAssignment_54728,axiom,
    ! [VarCurr: state_type] :
      ( v90738(VarCurr)
    <=> v25005(VarCurr,2) ) ).

tff(addAssignment_54727,axiom,
    ! [VarCurr: state_type] :
      ( v90732(VarCurr)
    <=> v90734(VarCurr) ) ).

tff(addAssignment_54726,axiom,
    ! [VarCurr: state_type] :
      ( v90734(VarCurr)
    <=> v25005(VarCurr,1) ) ).

tff(addAssignment_54725,axiom,
    ! [VarCurr: state_type] :
      ( v90728(VarCurr)
    <=> v90730(VarCurr) ) ).

tff(addAssignment_54724,axiom,
    ! [VarCurr: state_type] :
      ( v90730(VarCurr)
    <=> v25005(VarCurr,0) ) ).

tff(addAssignment_54723,axiom,
    ! [VarCurr: state_type] :
      ( v90672(VarCurr)
    <=> v90674(VarCurr) ) ).

tff(addAssignment_54722,axiom,
    ! [VarCurr: state_type] :
      ( v90674(VarCurr)
    <=> v90676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8640,axiom,
    ! [VarCurr: state_type] :
      ( v90676(VarCurr)
    <=> ( v90710(VarCurr)
      <~> v90706(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8639,axiom,
    ! [VarCurr: state_type] :
      ( v90710(VarCurr)
    <=> ( v90678(VarCurr)
      <~> v90702(VarCurr) ) ) ).

tff(addAssignment_54721,axiom,
    ! [VarCurr: state_type] :
      ( v90706(VarCurr)
    <=> v90708(VarCurr) ) ).

tff(addAssignment_54720,axiom,
    ! [VarCurr: state_type] :
      ( v90708(VarCurr)
    <=> v23455(VarCurr,4) ) ).

tff(addAssignment_54719,axiom,
    ! [VarCurr: state_type] :
      ( v90702(VarCurr)
    <=> v90704(VarCurr) ) ).

tff(addAssignment_54718,axiom,
    ! [VarCurr: state_type] :
      ( v90704(VarCurr)
    <=> v23455(VarCurr,3) ) ).

tff(addAssignment_54717,axiom,
    ! [VarCurr: state_type] :
      ( v90678(VarCurr)
    <=> v90680(VarCurr) ) ).

tff(addAssignment_54716,axiom,
    ! [VarCurr: state_type] :
      ( v90680(VarCurr)
    <=> v90682(VarCurr) ) ).

tff(addAssignment_54715,axiom,
    ! [VarCurr: state_type] :
      ( v90682(VarCurr)
    <=> v90684(VarCurr) ) ).

tff(addAssignment_54714,axiom,
    ! [VarCurr: state_type] :
      ( v90684(VarCurr)
    <=> v90686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8638,axiom,
    ! [VarCurr: state_type] :
      ( v90686(VarCurr)
    <=> ( v90700(VarCurr)
      <~> v90696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8637,axiom,
    ! [VarCurr: state_type] :
      ( v90700(VarCurr)
    <=> ( v90688(VarCurr)
      <~> v90692(VarCurr) ) ) ).

tff(addAssignment_54713,axiom,
    ! [VarCurr: state_type] :
      ( v90696(VarCurr)
    <=> v90698(VarCurr) ) ).

tff(addAssignment_54712,axiom,
    ! [VarCurr: state_type] :
      ( v90698(VarCurr)
    <=> v23455(VarCurr,2) ) ).

tff(addAssignment_54711,axiom,
    ! [VarCurr: state_type] :
      ( v90692(VarCurr)
    <=> v90694(VarCurr) ) ).

tff(addAssignment_54710,axiom,
    ! [VarCurr: state_type] :
      ( v90694(VarCurr)
    <=> v23455(VarCurr,1) ) ).

tff(addAssignment_54709,axiom,
    ! [VarCurr: state_type] :
      ( v90688(VarCurr)
    <=> v90690(VarCurr) ) ).

tff(addAssignment_54708,axiom,
    ! [VarCurr: state_type] :
      ( v90690(VarCurr)
    <=> v23455(VarCurr,0) ) ).

tff(addAssignment_54707,axiom,
    ! [VarCurr: state_type] :
      ( v90632(VarCurr)
    <=> v90634(VarCurr) ) ).

tff(addAssignment_54706,axiom,
    ! [VarCurr: state_type] :
      ( v90634(VarCurr)
    <=> v90636(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8636,axiom,
    ! [VarCurr: state_type] :
      ( v90636(VarCurr)
    <=> ( v90670(VarCurr)
      <~> v90666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8635,axiom,
    ! [VarCurr: state_type] :
      ( v90670(VarCurr)
    <=> ( v90638(VarCurr)
      <~> v90662(VarCurr) ) ) ).

tff(addAssignment_54705,axiom,
    ! [VarCurr: state_type] :
      ( v90666(VarCurr)
    <=> v90668(VarCurr) ) ).

tff(addAssignment_54704,axiom,
    ! [VarCurr: state_type] :
      ( v90668(VarCurr)
    <=> v21905(VarCurr,4) ) ).

tff(addAssignment_54703,axiom,
    ! [VarCurr: state_type] :
      ( v90662(VarCurr)
    <=> v90664(VarCurr) ) ).

tff(addAssignment_54702,axiom,
    ! [VarCurr: state_type] :
      ( v90664(VarCurr)
    <=> v21905(VarCurr,3) ) ).

tff(addAssignment_54701,axiom,
    ! [VarCurr: state_type] :
      ( v90638(VarCurr)
    <=> v90640(VarCurr) ) ).

tff(addAssignment_54700,axiom,
    ! [VarCurr: state_type] :
      ( v90640(VarCurr)
    <=> v90642(VarCurr) ) ).

tff(addAssignment_54699,axiom,
    ! [VarCurr: state_type] :
      ( v90642(VarCurr)
    <=> v90644(VarCurr) ) ).

tff(addAssignment_54698,axiom,
    ! [VarCurr: state_type] :
      ( v90644(VarCurr)
    <=> v90646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8634,axiom,
    ! [VarCurr: state_type] :
      ( v90646(VarCurr)
    <=> ( v90660(VarCurr)
      <~> v90656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8633,axiom,
    ! [VarCurr: state_type] :
      ( v90660(VarCurr)
    <=> ( v90648(VarCurr)
      <~> v90652(VarCurr) ) ) ).

tff(addAssignment_54697,axiom,
    ! [VarCurr: state_type] :
      ( v90656(VarCurr)
    <=> v90658(VarCurr) ) ).

tff(addAssignment_54696,axiom,
    ! [VarCurr: state_type] :
      ( v90658(VarCurr)
    <=> v21905(VarCurr,2) ) ).

tff(addAssignment_54695,axiom,
    ! [VarCurr: state_type] :
      ( v90652(VarCurr)
    <=> v90654(VarCurr) ) ).

tff(addAssignment_54694,axiom,
    ! [VarCurr: state_type] :
      ( v90654(VarCurr)
    <=> v21905(VarCurr,1) ) ).

tff(addAssignment_54693,axiom,
    ! [VarCurr: state_type] :
      ( v90648(VarCurr)
    <=> v90650(VarCurr) ) ).

tff(addAssignment_54692,axiom,
    ! [VarCurr: state_type] :
      ( v90650(VarCurr)
    <=> v21905(VarCurr,0) ) ).

tff(addAssignment_54691,axiom,
    ! [VarCurr: state_type] :
      ( v90592(VarCurr)
    <=> v90594(VarCurr) ) ).

tff(addAssignment_54690,axiom,
    ! [VarCurr: state_type] :
      ( v90594(VarCurr)
    <=> v90596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8632,axiom,
    ! [VarCurr: state_type] :
      ( v90596(VarCurr)
    <=> ( v90630(VarCurr)
      <~> v90626(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8631,axiom,
    ! [VarCurr: state_type] :
      ( v90630(VarCurr)
    <=> ( v90598(VarCurr)
      <~> v90622(VarCurr) ) ) ).

tff(addAssignment_54689,axiom,
    ! [VarCurr: state_type] :
      ( v90626(VarCurr)
    <=> v90628(VarCurr) ) ).

tff(addAssignment_54688,axiom,
    ! [VarCurr: state_type] :
      ( v90628(VarCurr)
    <=> v20355(VarCurr,4) ) ).

tff(addAssignment_54687,axiom,
    ! [VarCurr: state_type] :
      ( v90622(VarCurr)
    <=> v90624(VarCurr) ) ).

tff(addAssignment_54686,axiom,
    ! [VarCurr: state_type] :
      ( v90624(VarCurr)
    <=> v20355(VarCurr,3) ) ).

tff(addAssignment_54685,axiom,
    ! [VarCurr: state_type] :
      ( v90598(VarCurr)
    <=> v90600(VarCurr) ) ).

tff(addAssignment_54684,axiom,
    ! [VarCurr: state_type] :
      ( v90600(VarCurr)
    <=> v90602(VarCurr) ) ).

tff(addAssignment_54683,axiom,
    ! [VarCurr: state_type] :
      ( v90602(VarCurr)
    <=> v90604(VarCurr) ) ).

tff(addAssignment_54682,axiom,
    ! [VarCurr: state_type] :
      ( v90604(VarCurr)
    <=> v90606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8630,axiom,
    ! [VarCurr: state_type] :
      ( v90606(VarCurr)
    <=> ( v90620(VarCurr)
      <~> v90616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8629,axiom,
    ! [VarCurr: state_type] :
      ( v90620(VarCurr)
    <=> ( v90608(VarCurr)
      <~> v90612(VarCurr) ) ) ).

tff(addAssignment_54681,axiom,
    ! [VarCurr: state_type] :
      ( v90616(VarCurr)
    <=> v90618(VarCurr) ) ).

tff(addAssignment_54680,axiom,
    ! [VarCurr: state_type] :
      ( v90618(VarCurr)
    <=> v20355(VarCurr,2) ) ).

tff(addAssignment_54679,axiom,
    ! [VarCurr: state_type] :
      ( v90612(VarCurr)
    <=> v90614(VarCurr) ) ).

tff(addAssignment_54678,axiom,
    ! [VarCurr: state_type] :
      ( v90614(VarCurr)
    <=> v20355(VarCurr,1) ) ).

tff(addAssignment_54677,axiom,
    ! [VarCurr: state_type] :
      ( v90608(VarCurr)
    <=> v90610(VarCurr) ) ).

tff(addAssignment_54676,axiom,
    ! [VarCurr: state_type] :
      ( v90610(VarCurr)
    <=> v20355(VarCurr,0) ) ).

tff(addAssignment_54675,axiom,
    ! [VarCurr: state_type] :
      ( v90552(VarCurr)
    <=> v90554(VarCurr) ) ).

tff(addAssignment_54674,axiom,
    ! [VarCurr: state_type] :
      ( v90554(VarCurr)
    <=> v90556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8628,axiom,
    ! [VarCurr: state_type] :
      ( v90556(VarCurr)
    <=> ( v90590(VarCurr)
      <~> v90586(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8627,axiom,
    ! [VarCurr: state_type] :
      ( v90590(VarCurr)
    <=> ( v90558(VarCurr)
      <~> v90582(VarCurr) ) ) ).

tff(addAssignment_54673,axiom,
    ! [VarCurr: state_type] :
      ( v90586(VarCurr)
    <=> v90588(VarCurr) ) ).

tff(addAssignment_54672,axiom,
    ! [VarCurr: state_type] :
      ( v90588(VarCurr)
    <=> v18805(VarCurr,4) ) ).

tff(addAssignment_54671,axiom,
    ! [VarCurr: state_type] :
      ( v90582(VarCurr)
    <=> v90584(VarCurr) ) ).

tff(addAssignment_54670,axiom,
    ! [VarCurr: state_type] :
      ( v90584(VarCurr)
    <=> v18805(VarCurr,3) ) ).

tff(addAssignment_54669,axiom,
    ! [VarCurr: state_type] :
      ( v90558(VarCurr)
    <=> v90560(VarCurr) ) ).

tff(addAssignment_54668,axiom,
    ! [VarCurr: state_type] :
      ( v90560(VarCurr)
    <=> v90562(VarCurr) ) ).

tff(addAssignment_54667,axiom,
    ! [VarCurr: state_type] :
      ( v90562(VarCurr)
    <=> v90564(VarCurr) ) ).

tff(addAssignment_54666,axiom,
    ! [VarCurr: state_type] :
      ( v90564(VarCurr)
    <=> v90566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8626,axiom,
    ! [VarCurr: state_type] :
      ( v90566(VarCurr)
    <=> ( v90580(VarCurr)
      <~> v90576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8625,axiom,
    ! [VarCurr: state_type] :
      ( v90580(VarCurr)
    <=> ( v90568(VarCurr)
      <~> v90572(VarCurr) ) ) ).

tff(addAssignment_54665,axiom,
    ! [VarCurr: state_type] :
      ( v90576(VarCurr)
    <=> v90578(VarCurr) ) ).

tff(addAssignment_54664,axiom,
    ! [VarCurr: state_type] :
      ( v90578(VarCurr)
    <=> v18805(VarCurr,2) ) ).

tff(addAssignment_54663,axiom,
    ! [VarCurr: state_type] :
      ( v90572(VarCurr)
    <=> v90574(VarCurr) ) ).

tff(addAssignment_54662,axiom,
    ! [VarCurr: state_type] :
      ( v90574(VarCurr)
    <=> v18805(VarCurr,1) ) ).

tff(addAssignment_54661,axiom,
    ! [VarCurr: state_type] :
      ( v90568(VarCurr)
    <=> v90570(VarCurr) ) ).

tff(addAssignment_54660,axiom,
    ! [VarCurr: state_type] :
      ( v90570(VarCurr)
    <=> v18805(VarCurr,0) ) ).

tff(addAssignment_54659,axiom,
    ! [VarCurr: state_type] :
      ( v90512(VarCurr)
    <=> v90514(VarCurr) ) ).

tff(addAssignment_54658,axiom,
    ! [VarCurr: state_type] :
      ( v90514(VarCurr)
    <=> v90516(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8624,axiom,
    ! [VarCurr: state_type] :
      ( v90516(VarCurr)
    <=> ( v90550(VarCurr)
      <~> v90546(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8623,axiom,
    ! [VarCurr: state_type] :
      ( v90550(VarCurr)
    <=> ( v90518(VarCurr)
      <~> v90542(VarCurr) ) ) ).

tff(addAssignment_54657,axiom,
    ! [VarCurr: state_type] :
      ( v90546(VarCurr)
    <=> v90548(VarCurr) ) ).

tff(addAssignment_54656,axiom,
    ! [VarCurr: state_type] :
      ( v90548(VarCurr)
    <=> v17255(VarCurr,4) ) ).

tff(addAssignment_54655,axiom,
    ! [VarCurr: state_type] :
      ( v90542(VarCurr)
    <=> v90544(VarCurr) ) ).

tff(addAssignment_54654,axiom,
    ! [VarCurr: state_type] :
      ( v90544(VarCurr)
    <=> v17255(VarCurr,3) ) ).

tff(addAssignment_54653,axiom,
    ! [VarCurr: state_type] :
      ( v90518(VarCurr)
    <=> v90520(VarCurr) ) ).

tff(addAssignment_54652,axiom,
    ! [VarCurr: state_type] :
      ( v90520(VarCurr)
    <=> v90522(VarCurr) ) ).

tff(addAssignment_54651,axiom,
    ! [VarCurr: state_type] :
      ( v90522(VarCurr)
    <=> v90524(VarCurr) ) ).

tff(addAssignment_54650,axiom,
    ! [VarCurr: state_type] :
      ( v90524(VarCurr)
    <=> v90526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8622,axiom,
    ! [VarCurr: state_type] :
      ( v90526(VarCurr)
    <=> ( v90540(VarCurr)
      <~> v90536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8621,axiom,
    ! [VarCurr: state_type] :
      ( v90540(VarCurr)
    <=> ( v90528(VarCurr)
      <~> v90532(VarCurr) ) ) ).

tff(addAssignment_54649,axiom,
    ! [VarCurr: state_type] :
      ( v90536(VarCurr)
    <=> v90538(VarCurr) ) ).

tff(addAssignment_54648,axiom,
    ! [VarCurr: state_type] :
      ( v90538(VarCurr)
    <=> v17255(VarCurr,2) ) ).

tff(addAssignment_54647,axiom,
    ! [VarCurr: state_type] :
      ( v90532(VarCurr)
    <=> v90534(VarCurr) ) ).

tff(addAssignment_54646,axiom,
    ! [VarCurr: state_type] :
      ( v90534(VarCurr)
    <=> v17255(VarCurr,1) ) ).

tff(addAssignment_54645,axiom,
    ! [VarCurr: state_type] :
      ( v90528(VarCurr)
    <=> v90530(VarCurr) ) ).

tff(addAssignment_54644,axiom,
    ! [VarCurr: state_type] :
      ( v90530(VarCurr)
    <=> v17255(VarCurr,0) ) ).

tff(addAssignment_54643,axiom,
    ! [VarCurr: state_type] :
      ( v90472(VarCurr)
    <=> v90474(VarCurr) ) ).

tff(addAssignment_54642,axiom,
    ! [VarCurr: state_type] :
      ( v90474(VarCurr)
    <=> v90476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8620,axiom,
    ! [VarCurr: state_type] :
      ( v90476(VarCurr)
    <=> ( v90510(VarCurr)
      <~> v90506(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8619,axiom,
    ! [VarCurr: state_type] :
      ( v90510(VarCurr)
    <=> ( v90478(VarCurr)
      <~> v90502(VarCurr) ) ) ).

tff(addAssignment_54641,axiom,
    ! [VarCurr: state_type] :
      ( v90506(VarCurr)
    <=> v90508(VarCurr) ) ).

tff(addAssignment_54640,axiom,
    ! [VarCurr: state_type] :
      ( v90508(VarCurr)
    <=> v15705(VarCurr,4) ) ).

tff(addAssignment_54639,axiom,
    ! [VarCurr: state_type] :
      ( v90502(VarCurr)
    <=> v90504(VarCurr) ) ).

tff(addAssignment_54638,axiom,
    ! [VarCurr: state_type] :
      ( v90504(VarCurr)
    <=> v15705(VarCurr,3) ) ).

tff(addAssignment_54637,axiom,
    ! [VarCurr: state_type] :
      ( v90478(VarCurr)
    <=> v90480(VarCurr) ) ).

tff(addAssignment_54636,axiom,
    ! [VarCurr: state_type] :
      ( v90480(VarCurr)
    <=> v90482(VarCurr) ) ).

tff(addAssignment_54635,axiom,
    ! [VarCurr: state_type] :
      ( v90482(VarCurr)
    <=> v90484(VarCurr) ) ).

tff(addAssignment_54634,axiom,
    ! [VarCurr: state_type] :
      ( v90484(VarCurr)
    <=> v90486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8618,axiom,
    ! [VarCurr: state_type] :
      ( v90486(VarCurr)
    <=> ( v90500(VarCurr)
      <~> v90496(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8617,axiom,
    ! [VarCurr: state_type] :
      ( v90500(VarCurr)
    <=> ( v90488(VarCurr)
      <~> v90492(VarCurr) ) ) ).

tff(addAssignment_54633,axiom,
    ! [VarCurr: state_type] :
      ( v90496(VarCurr)
    <=> v90498(VarCurr) ) ).

tff(addAssignment_54632,axiom,
    ! [VarCurr: state_type] :
      ( v90498(VarCurr)
    <=> v15705(VarCurr,2) ) ).

tff(addAssignment_54631,axiom,
    ! [VarCurr: state_type] :
      ( v90492(VarCurr)
    <=> v90494(VarCurr) ) ).

tff(addAssignment_54630,axiom,
    ! [VarCurr: state_type] :
      ( v90494(VarCurr)
    <=> v15705(VarCurr,1) ) ).

tff(addAssignment_54629,axiom,
    ! [VarCurr: state_type] :
      ( v90488(VarCurr)
    <=> v90490(VarCurr) ) ).

tff(addAssignment_54628,axiom,
    ! [VarCurr: state_type] :
      ( v90490(VarCurr)
    <=> v15705(VarCurr,0) ) ).

tff(addAssignment_54627,axiom,
    ! [VarCurr: state_type] :
      ( v90432(VarCurr)
    <=> v90434(VarCurr) ) ).

tff(addAssignment_54626,axiom,
    ! [VarCurr: state_type] :
      ( v90434(VarCurr)
    <=> v90436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8616,axiom,
    ! [VarCurr: state_type] :
      ( v90436(VarCurr)
    <=> ( v90470(VarCurr)
      <~> v90466(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8615,axiom,
    ! [VarCurr: state_type] :
      ( v90470(VarCurr)
    <=> ( v90438(VarCurr)
      <~> v90462(VarCurr) ) ) ).

tff(addAssignment_54625,axiom,
    ! [VarCurr: state_type] :
      ( v90466(VarCurr)
    <=> v90468(VarCurr) ) ).

tff(addAssignment_54624,axiom,
    ! [VarCurr: state_type] :
      ( v90468(VarCurr)
    <=> v14155(VarCurr,4) ) ).

tff(addAssignment_54623,axiom,
    ! [VarCurr: state_type] :
      ( v90462(VarCurr)
    <=> v90464(VarCurr) ) ).

tff(addAssignment_54622,axiom,
    ! [VarCurr: state_type] :
      ( v90464(VarCurr)
    <=> v14155(VarCurr,3) ) ).

tff(addAssignment_54621,axiom,
    ! [VarCurr: state_type] :
      ( v90438(VarCurr)
    <=> v90440(VarCurr) ) ).

tff(addAssignment_54620,axiom,
    ! [VarCurr: state_type] :
      ( v90440(VarCurr)
    <=> v90442(VarCurr) ) ).

tff(addAssignment_54619,axiom,
    ! [VarCurr: state_type] :
      ( v90442(VarCurr)
    <=> v90444(VarCurr) ) ).

tff(addAssignment_54618,axiom,
    ! [VarCurr: state_type] :
      ( v90444(VarCurr)
    <=> v90446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8614,axiom,
    ! [VarCurr: state_type] :
      ( v90446(VarCurr)
    <=> ( v90460(VarCurr)
      <~> v90456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8613,axiom,
    ! [VarCurr: state_type] :
      ( v90460(VarCurr)
    <=> ( v90448(VarCurr)
      <~> v90452(VarCurr) ) ) ).

tff(addAssignment_54617,axiom,
    ! [VarCurr: state_type] :
      ( v90456(VarCurr)
    <=> v90458(VarCurr) ) ).

tff(addAssignment_54616,axiom,
    ! [VarCurr: state_type] :
      ( v90458(VarCurr)
    <=> v14155(VarCurr,2) ) ).

tff(addAssignment_54615,axiom,
    ! [VarCurr: state_type] :
      ( v90452(VarCurr)
    <=> v90454(VarCurr) ) ).

tff(addAssignment_54614,axiom,
    ! [VarCurr: state_type] :
      ( v90454(VarCurr)
    <=> v14155(VarCurr,1) ) ).

tff(addAssignment_54613,axiom,
    ! [VarCurr: state_type] :
      ( v90448(VarCurr)
    <=> v90450(VarCurr) ) ).

tff(addAssignment_54612,axiom,
    ! [VarCurr: state_type] :
      ( v90450(VarCurr)
    <=> v14155(VarCurr,0) ) ).

tff(addAssignment_54611,axiom,
    ! [VarCurr: state_type] :
      ( v90392(VarCurr)
    <=> v90394(VarCurr) ) ).

tff(addAssignment_54610,axiom,
    ! [VarCurr: state_type] :
      ( v90394(VarCurr)
    <=> v90396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8612,axiom,
    ! [VarCurr: state_type] :
      ( v90396(VarCurr)
    <=> ( v90430(VarCurr)
      <~> v90426(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8611,axiom,
    ! [VarCurr: state_type] :
      ( v90430(VarCurr)
    <=> ( v90398(VarCurr)
      <~> v90422(VarCurr) ) ) ).

tff(addAssignment_54609,axiom,
    ! [VarCurr: state_type] :
      ( v90426(VarCurr)
    <=> v90428(VarCurr) ) ).

tff(addAssignment_54608,axiom,
    ! [VarCurr: state_type] :
      ( v90428(VarCurr)
    <=> v12605(VarCurr,4) ) ).

tff(addAssignment_54607,axiom,
    ! [VarCurr: state_type] :
      ( v90422(VarCurr)
    <=> v90424(VarCurr) ) ).

tff(addAssignment_54606,axiom,
    ! [VarCurr: state_type] :
      ( v90424(VarCurr)
    <=> v12605(VarCurr,3) ) ).

tff(addAssignment_54605,axiom,
    ! [VarCurr: state_type] :
      ( v90398(VarCurr)
    <=> v90400(VarCurr) ) ).

tff(addAssignment_54604,axiom,
    ! [VarCurr: state_type] :
      ( v90400(VarCurr)
    <=> v90402(VarCurr) ) ).

tff(addAssignment_54603,axiom,
    ! [VarCurr: state_type] :
      ( v90402(VarCurr)
    <=> v90404(VarCurr) ) ).

tff(addAssignment_54602,axiom,
    ! [VarCurr: state_type] :
      ( v90404(VarCurr)
    <=> v90406(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8610,axiom,
    ! [VarCurr: state_type] :
      ( v90406(VarCurr)
    <=> ( v90420(VarCurr)
      <~> v90416(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8609,axiom,
    ! [VarCurr: state_type] :
      ( v90420(VarCurr)
    <=> ( v90408(VarCurr)
      <~> v90412(VarCurr) ) ) ).

tff(addAssignment_54601,axiom,
    ! [VarCurr: state_type] :
      ( v90416(VarCurr)
    <=> v90418(VarCurr) ) ).

tff(addAssignment_54600,axiom,
    ! [VarCurr: state_type] :
      ( v90418(VarCurr)
    <=> v12605(VarCurr,2) ) ).

tff(addAssignment_54599,axiom,
    ! [VarCurr: state_type] :
      ( v90412(VarCurr)
    <=> v90414(VarCurr) ) ).

tff(addAssignment_54598,axiom,
    ! [VarCurr: state_type] :
      ( v90414(VarCurr)
    <=> v12605(VarCurr,1) ) ).

tff(addAssignment_54597,axiom,
    ! [VarCurr: state_type] :
      ( v90408(VarCurr)
    <=> v90410(VarCurr) ) ).

tff(addAssignment_54596,axiom,
    ! [VarCurr: state_type] :
      ( v90410(VarCurr)
    <=> v12605(VarCurr,0) ) ).

tff(addAssignment_54595,axiom,
    ! [VarCurr: state_type] :
      ( v90352(VarCurr)
    <=> v90354(VarCurr) ) ).

tff(addAssignment_54594,axiom,
    ! [VarCurr: state_type] :
      ( v90354(VarCurr)
    <=> v90356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8608,axiom,
    ! [VarCurr: state_type] :
      ( v90356(VarCurr)
    <=> ( v90390(VarCurr)
      <~> v90386(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8607,axiom,
    ! [VarCurr: state_type] :
      ( v90390(VarCurr)
    <=> ( v90358(VarCurr)
      <~> v90382(VarCurr) ) ) ).

tff(addAssignment_54593,axiom,
    ! [VarCurr: state_type] :
      ( v90386(VarCurr)
    <=> v90388(VarCurr) ) ).

tff(addAssignment_54592,axiom,
    ! [VarCurr: state_type] :
      ( v90388(VarCurr)
    <=> v11055(VarCurr,4) ) ).

tff(addAssignment_54591,axiom,
    ! [VarCurr: state_type] :
      ( v90382(VarCurr)
    <=> v90384(VarCurr) ) ).

tff(addAssignment_54590,axiom,
    ! [VarCurr: state_type] :
      ( v90384(VarCurr)
    <=> v11055(VarCurr,3) ) ).

tff(addAssignment_54589,axiom,
    ! [VarCurr: state_type] :
      ( v90358(VarCurr)
    <=> v90360(VarCurr) ) ).

tff(addAssignment_54588,axiom,
    ! [VarCurr: state_type] :
      ( v90360(VarCurr)
    <=> v90362(VarCurr) ) ).

tff(addAssignment_54587,axiom,
    ! [VarCurr: state_type] :
      ( v90362(VarCurr)
    <=> v90364(VarCurr) ) ).

tff(addAssignment_54586,axiom,
    ! [VarCurr: state_type] :
      ( v90364(VarCurr)
    <=> v90366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8606,axiom,
    ! [VarCurr: state_type] :
      ( v90366(VarCurr)
    <=> ( v90380(VarCurr)
      <~> v90376(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8605,axiom,
    ! [VarCurr: state_type] :
      ( v90380(VarCurr)
    <=> ( v90368(VarCurr)
      <~> v90372(VarCurr) ) ) ).

tff(addAssignment_54585,axiom,
    ! [VarCurr: state_type] :
      ( v90376(VarCurr)
    <=> v90378(VarCurr) ) ).

tff(addAssignment_54584,axiom,
    ! [VarCurr: state_type] :
      ( v90378(VarCurr)
    <=> v11055(VarCurr,2) ) ).

tff(addAssignment_54583,axiom,
    ! [VarCurr: state_type] :
      ( v90372(VarCurr)
    <=> v90374(VarCurr) ) ).

tff(addAssignment_54582,axiom,
    ! [VarCurr: state_type] :
      ( v90374(VarCurr)
    <=> v11055(VarCurr,1) ) ).

tff(addAssignment_54581,axiom,
    ! [VarCurr: state_type] :
      ( v90368(VarCurr)
    <=> v90370(VarCurr) ) ).

tff(addAssignment_54580,axiom,
    ! [VarCurr: state_type] :
      ( v90370(VarCurr)
    <=> v11055(VarCurr,0) ) ).

tff(addAssignment_54579,axiom,
    ! [VarCurr: state_type] :
      ( v90312(VarCurr)
    <=> v90314(VarCurr) ) ).

tff(addAssignment_54578,axiom,
    ! [VarCurr: state_type] :
      ( v90314(VarCurr)
    <=> v90316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8604,axiom,
    ! [VarCurr: state_type] :
      ( v90316(VarCurr)
    <=> ( v90350(VarCurr)
      <~> v90346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8603,axiom,
    ! [VarCurr: state_type] :
      ( v90350(VarCurr)
    <=> ( v90318(VarCurr)
      <~> v90342(VarCurr) ) ) ).

tff(addAssignment_54577,axiom,
    ! [VarCurr: state_type] :
      ( v90346(VarCurr)
    <=> v90348(VarCurr) ) ).

tff(addAssignment_54576,axiom,
    ! [VarCurr: state_type] :
      ( v90348(VarCurr)
    <=> v9099(VarCurr,4) ) ).

tff(addAssignment_54575,axiom,
    ! [VarCurr: state_type] :
      ( v90342(VarCurr)
    <=> v90344(VarCurr) ) ).

tff(addAssignment_54574,axiom,
    ! [VarCurr: state_type] :
      ( v90344(VarCurr)
    <=> v9099(VarCurr,3) ) ).

tff(addAssignment_54573,axiom,
    ! [VarCurr: state_type] :
      ( v90318(VarCurr)
    <=> v90320(VarCurr) ) ).

tff(addAssignment_54572,axiom,
    ! [VarCurr: state_type] :
      ( v90320(VarCurr)
    <=> v90322(VarCurr) ) ).

tff(addAssignment_54571,axiom,
    ! [VarCurr: state_type] :
      ( v90322(VarCurr)
    <=> v90324(VarCurr) ) ).

tff(addAssignment_54570,axiom,
    ! [VarCurr: state_type] :
      ( v90324(VarCurr)
    <=> v90326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8602,axiom,
    ! [VarCurr: state_type] :
      ( v90326(VarCurr)
    <=> ( v90340(VarCurr)
      <~> v90336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8601,axiom,
    ! [VarCurr: state_type] :
      ( v90340(VarCurr)
    <=> ( v90328(VarCurr)
      <~> v90332(VarCurr) ) ) ).

tff(addAssignment_54569,axiom,
    ! [VarCurr: state_type] :
      ( v90336(VarCurr)
    <=> v90338(VarCurr) ) ).

tff(addAssignment_54568,axiom,
    ! [VarCurr: state_type] :
      ( v90338(VarCurr)
    <=> v9099(VarCurr,2) ) ).

tff(addAssignment_54567,axiom,
    ! [VarCurr: state_type] :
      ( v90332(VarCurr)
    <=> v90334(VarCurr) ) ).

tff(addAssignment_54566,axiom,
    ! [VarCurr: state_type] :
      ( v90334(VarCurr)
    <=> v9099(VarCurr,1) ) ).

tff(addAssignment_54565,axiom,
    ! [VarCurr: state_type] :
      ( v90328(VarCurr)
    <=> v90330(VarCurr) ) ).

tff(addAssignment_54564,axiom,
    ! [VarCurr: state_type] :
      ( v90330(VarCurr)
    <=> v9099(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v89724(VarCurr,B)
      <=> ( v90302(VarCurr,B)
          & v90212(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v90302(VarCurr,B)
      <=> ~ v89726(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90212(VarCurr,B)
          <=> v90281(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_566,axiom,
    ! [VarCurr: state_type] :
      ( v90280(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90212(VarCurr,B)
          <=> b000000000011(B) ) ) ) ).

tff(bitBlastConstant_1386,axiom,
    ~ b000000000011(11) ).

tff(bitBlastConstant_1385,axiom,
    ~ b000000000011(10) ).

tff(bitBlastConstant_1384,axiom,
    ~ b000000000011(9) ).

tff(bitBlastConstant_1383,axiom,
    ~ b000000000011(8) ).

tff(bitBlastConstant_1382,axiom,
    ~ b000000000011(7) ).

tff(bitBlastConstant_1381,axiom,
    ~ b000000000011(6) ).

tff(bitBlastConstant_1380,axiom,
    ~ b000000000011(5) ).

tff(bitBlastConstant_1379,axiom,
    ~ b000000000011(4) ).

tff(bitBlastConstant_1378,axiom,
    ~ b000000000011(3) ).

tff(bitBlastConstant_1377,axiom,
    ~ b000000000011(2) ).

tff(bitBlastConstant_1376,axiom,
    b000000000011(1) ).

tff(bitBlastConstant_1375,axiom,
    b000000000011(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90282(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90281(VarCurr,B)
          <=> v90283(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_565,axiom,
    ! [VarCurr: state_type] :
      ( v90282(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90281(VarCurr,B)
          <=> b000000000111(B) ) ) ) ).

tff(bitBlastConstant_1374,axiom,
    ~ b000000000111(11) ).

tff(bitBlastConstant_1373,axiom,
    ~ b000000000111(10) ).

tff(bitBlastConstant_1372,axiom,
    ~ b000000000111(9) ).

tff(bitBlastConstant_1371,axiom,
    ~ b000000000111(8) ).

tff(bitBlastConstant_1370,axiom,
    ~ b000000000111(7) ).

tff(bitBlastConstant_1369,axiom,
    ~ b000000000111(6) ).

tff(bitBlastConstant_1368,axiom,
    ~ b000000000111(5) ).

tff(bitBlastConstant_1367,axiom,
    ~ b000000000111(4) ).

tff(bitBlastConstant_1366,axiom,
    ~ b000000000111(3) ).

tff(bitBlastConstant_1365,axiom,
    b000000000111(2) ).

tff(bitBlastConstant_1364,axiom,
    b000000000111(1) ).

tff(bitBlastConstant_1363,axiom,
    b000000000111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90284(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90283(VarCurr,B)
          <=> v90285(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_564,axiom,
    ! [VarCurr: state_type] :
      ( v90284(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90283(VarCurr,B)
          <=> b000000001111(B) ) ) ) ).

tff(bitBlastConstant_1362,axiom,
    ~ b000000001111(11) ).

tff(bitBlastConstant_1361,axiom,
    ~ b000000001111(10) ).

tff(bitBlastConstant_1360,axiom,
    ~ b000000001111(9) ).

tff(bitBlastConstant_1359,axiom,
    ~ b000000001111(8) ).

tff(bitBlastConstant_1358,axiom,
    ~ b000000001111(7) ).

tff(bitBlastConstant_1357,axiom,
    ~ b000000001111(6) ).

tff(bitBlastConstant_1356,axiom,
    ~ b000000001111(5) ).

tff(bitBlastConstant_1355,axiom,
    ~ b000000001111(4) ).

tff(bitBlastConstant_1354,axiom,
    b000000001111(3) ).

tff(bitBlastConstant_1353,axiom,
    b000000001111(2) ).

tff(bitBlastConstant_1352,axiom,
    b000000001111(1) ).

tff(bitBlastConstant_1351,axiom,
    b000000001111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90286(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90285(VarCurr,B)
          <=> v90287(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_563,axiom,
    ! [VarCurr: state_type] :
      ( v90286(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90285(VarCurr,B)
          <=> b000000011111(B) ) ) ) ).

tff(bitBlastConstant_1350,axiom,
    ~ b000000011111(11) ).

tff(bitBlastConstant_1349,axiom,
    ~ b000000011111(10) ).

tff(bitBlastConstant_1348,axiom,
    ~ b000000011111(9) ).

tff(bitBlastConstant_1347,axiom,
    ~ b000000011111(8) ).

tff(bitBlastConstant_1346,axiom,
    ~ b000000011111(7) ).

tff(bitBlastConstant_1345,axiom,
    ~ b000000011111(6) ).

tff(bitBlastConstant_1344,axiom,
    ~ b000000011111(5) ).

tff(bitBlastConstant_1343,axiom,
    b000000011111(4) ).

tff(bitBlastConstant_1342,axiom,
    b000000011111(3) ).

tff(bitBlastConstant_1341,axiom,
    b000000011111(2) ).

tff(bitBlastConstant_1340,axiom,
    b000000011111(1) ).

tff(bitBlastConstant_1339,axiom,
    b000000011111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90288(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90287(VarCurr,B)
          <=> v90289(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_562,axiom,
    ! [VarCurr: state_type] :
      ( v90288(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90287(VarCurr,B)
          <=> b000000111111(B) ) ) ) ).

tff(bitBlastConstant_1338,axiom,
    ~ b000000111111(11) ).

tff(bitBlastConstant_1337,axiom,
    ~ b000000111111(10) ).

tff(bitBlastConstant_1336,axiom,
    ~ b000000111111(9) ).

tff(bitBlastConstant_1335,axiom,
    ~ b000000111111(8) ).

tff(bitBlastConstant_1334,axiom,
    ~ b000000111111(7) ).

tff(bitBlastConstant_1333,axiom,
    ~ b000000111111(6) ).

tff(bitBlastConstant_1332,axiom,
    b000000111111(5) ).

tff(bitBlastConstant_1331,axiom,
    b000000111111(4) ).

tff(bitBlastConstant_1330,axiom,
    b000000111111(3) ).

tff(bitBlastConstant_1329,axiom,
    b000000111111(2) ).

tff(bitBlastConstant_1328,axiom,
    b000000111111(1) ).

tff(bitBlastConstant_1327,axiom,
    b000000111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90290(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90289(VarCurr,B)
          <=> v90291(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_561,axiom,
    ! [VarCurr: state_type] :
      ( v90290(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90289(VarCurr,B)
          <=> b000001111111(B) ) ) ) ).

tff(bitBlastConstant_1326,axiom,
    ~ b000001111111(11) ).

tff(bitBlastConstant_1325,axiom,
    ~ b000001111111(10) ).

tff(bitBlastConstant_1324,axiom,
    ~ b000001111111(9) ).

tff(bitBlastConstant_1323,axiom,
    ~ b000001111111(8) ).

tff(bitBlastConstant_1322,axiom,
    ~ b000001111111(7) ).

tff(bitBlastConstant_1321,axiom,
    b000001111111(6) ).

tff(bitBlastConstant_1320,axiom,
    b000001111111(5) ).

tff(bitBlastConstant_1319,axiom,
    b000001111111(4) ).

tff(bitBlastConstant_1318,axiom,
    b000001111111(3) ).

tff(bitBlastConstant_1317,axiom,
    b000001111111(2) ).

tff(bitBlastConstant_1316,axiom,
    b000001111111(1) ).

tff(bitBlastConstant_1315,axiom,
    b000001111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90292(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90291(VarCurr,B)
          <=> v90293(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_560,axiom,
    ! [VarCurr: state_type] :
      ( v90292(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90291(VarCurr,B)
          <=> b000011111111(B) ) ) ) ).

tff(bitBlastConstant_1314,axiom,
    ~ b000011111111(11) ).

tff(bitBlastConstant_1313,axiom,
    ~ b000011111111(10) ).

tff(bitBlastConstant_1312,axiom,
    ~ b000011111111(9) ).

tff(bitBlastConstant_1311,axiom,
    ~ b000011111111(8) ).

tff(bitBlastConstant_1310,axiom,
    b000011111111(7) ).

tff(bitBlastConstant_1309,axiom,
    b000011111111(6) ).

tff(bitBlastConstant_1308,axiom,
    b000011111111(5) ).

tff(bitBlastConstant_1307,axiom,
    b000011111111(4) ).

tff(bitBlastConstant_1306,axiom,
    b000011111111(3) ).

tff(bitBlastConstant_1305,axiom,
    b000011111111(2) ).

tff(bitBlastConstant_1304,axiom,
    b000011111111(1) ).

tff(bitBlastConstant_1303,axiom,
    b000011111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90293(VarCurr,B)
          <=> v90295(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_559,axiom,
    ! [VarCurr: state_type] :
      ( v90294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90293(VarCurr,B)
          <=> b000111111111(B) ) ) ) ).

tff(bitBlastConstant_1302,axiom,
    ~ b000111111111(11) ).

tff(bitBlastConstant_1301,axiom,
    ~ b000111111111(10) ).

tff(bitBlastConstant_1300,axiom,
    ~ b000111111111(9) ).

tff(bitBlastConstant_1299,axiom,
    b000111111111(8) ).

tff(bitBlastConstant_1298,axiom,
    b000111111111(7) ).

tff(bitBlastConstant_1297,axiom,
    b000111111111(6) ).

tff(bitBlastConstant_1296,axiom,
    b000111111111(5) ).

tff(bitBlastConstant_1295,axiom,
    b000111111111(4) ).

tff(bitBlastConstant_1294,axiom,
    b000111111111(3) ).

tff(bitBlastConstant_1293,axiom,
    b000111111111(2) ).

tff(bitBlastConstant_1292,axiom,
    b000111111111(1) ).

tff(bitBlastConstant_1291,axiom,
    b000111111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90296(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90295(VarCurr,B)
          <=> v90297(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_558,axiom,
    ! [VarCurr: state_type] :
      ( v90296(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90295(VarCurr,B)
          <=> b001111111111(B) ) ) ) ).

tff(bitBlastConstant_1290,axiom,
    ~ b001111111111(11) ).

tff(bitBlastConstant_1289,axiom,
    ~ b001111111111(10) ).

tff(bitBlastConstant_1288,axiom,
    b001111111111(9) ).

tff(bitBlastConstant_1287,axiom,
    b001111111111(8) ).

tff(bitBlastConstant_1286,axiom,
    b001111111111(7) ).

tff(bitBlastConstant_1285,axiom,
    b001111111111(6) ).

tff(bitBlastConstant_1284,axiom,
    b001111111111(5) ).

tff(bitBlastConstant_1283,axiom,
    b001111111111(4) ).

tff(bitBlastConstant_1282,axiom,
    b001111111111(3) ).

tff(bitBlastConstant_1281,axiom,
    b001111111111(2) ).

tff(bitBlastConstant_1280,axiom,
    b001111111111(1) ).

tff(bitBlastConstant_1279,axiom,
    b001111111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90298(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90297(VarCurr,B)
          <=> v90299(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_557,axiom,
    ! [VarCurr: state_type] :
      ( v90298(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90297(VarCurr,B)
          <=> b011111111111(B) ) ) ) ).

tff(bitBlastConstant_1278,axiom,
    ~ b011111111111(11) ).

tff(bitBlastConstant_1277,axiom,
    b011111111111(10) ).

tff(bitBlastConstant_1276,axiom,
    b011111111111(9) ).

tff(bitBlastConstant_1275,axiom,
    b011111111111(8) ).

tff(bitBlastConstant_1274,axiom,
    b011111111111(7) ).

tff(bitBlastConstant_1273,axiom,
    b011111111111(6) ).

tff(bitBlastConstant_1272,axiom,
    b011111111111(5) ).

tff(bitBlastConstant_1271,axiom,
    b011111111111(4) ).

tff(bitBlastConstant_1270,axiom,
    b011111111111(3) ).

tff(bitBlastConstant_1269,axiom,
    b011111111111(2) ).

tff(bitBlastConstant_1268,axiom,
    b011111111111(1) ).

tff(bitBlastConstant_1267,axiom,
    b011111111111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90300(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90299(VarCurr,B)
          <=> b000000000001(B) ) ) ) ).

tff(bitBlastConstant_1266,axiom,
    ~ b000000000001(11) ).

tff(bitBlastConstant_1265,axiom,
    ~ b000000000001(10) ).

tff(bitBlastConstant_1264,axiom,
    ~ b000000000001(9) ).

tff(bitBlastConstant_1263,axiom,
    ~ b000000000001(8) ).

tff(bitBlastConstant_1262,axiom,
    ~ b000000000001(7) ).

tff(bitBlastConstant_1261,axiom,
    ~ b000000000001(6) ).

tff(bitBlastConstant_1260,axiom,
    ~ b000000000001(5) ).

tff(bitBlastConstant_1259,axiom,
    ~ b000000000001(4) ).

tff(bitBlastConstant_1258,axiom,
    ~ b000000000001(3) ).

tff(bitBlastConstant_1257,axiom,
    ~ b000000000001(2) ).

tff(bitBlastConstant_1256,axiom,
    ~ b000000000001(1) ).

tff(bitBlastConstant_1255,axiom,
    b000000000001(0) ).

tff(addConditionBooleanCondEqualRangesThenBranch_556,axiom,
    ! [VarCurr: state_type] :
      ( v90300(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v90299(VarCurr,B)
          <=> $true ) ) ) ).

tff(bitBlastConstant_1254,axiom,
    b111111111111(11) ).

tff(bitBlastConstant_1253,axiom,
    b111111111111(10) ).

tff(bitBlastConstant_1252,axiom,
    b111111111111(9) ).

tff(bitBlastConstant_1251,axiom,
    b111111111111(8) ).

tff(bitBlastConstant_1250,axiom,
    b111111111111(7) ).

tff(bitBlastConstant_1249,axiom,
    b111111111111(6) ).

tff(bitBlastConstant_1248,axiom,
    b111111111111(5) ).

tff(bitBlastConstant_1247,axiom,
    b111111111111(4) ).

tff(bitBlastConstant_1246,axiom,
    b111111111111(3) ).

tff(bitBlastConstant_1245,axiom,
    b111111111111(2) ).

tff(bitBlastConstant_1244,axiom,
    b111111111111(1) ).

tff(bitBlastConstant_1243,axiom,
    b111111111111(0) ).

tff(addBitVectorEqualityBitBlasted_484,axiom,
    ! [VarCurr: state_type] :
      ( v90300(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $true )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_483,axiom,
    ! [VarCurr: state_type] :
      ( v90298(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $true )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_482,axiom,
    ! [VarCurr: state_type] :
      ( v90296(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $true )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $false )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_481,axiom,
    ! [VarCurr: state_type] :
      ( v90294(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $true )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $false )
        & ( v90214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_480,axiom,
    ! [VarCurr: state_type] :
      ( v90292(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $true )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_479,axiom,
    ! [VarCurr: state_type] :
      ( v90290(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $true )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_478,axiom,
    ! [VarCurr: state_type] :
      ( v90288(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $true )
        & ( v90214(VarCurr,1)
        <=> $false )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_477,axiom,
    ! [VarCurr: state_type] :
      ( v90286(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $true )
        & ( v90214(VarCurr,1)
        <=> $false )
        & ( v90214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_476,axiom,
    ! [VarCurr: state_type] :
      ( v90284(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_475,axiom,
    ! [VarCurr: state_type] :
      ( v90282(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $true )
        & ( v90214(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_474,axiom,
    ! [VarCurr: state_type] :
      ( v90280(VarCurr)
    <=> ( ( v90214(VarCurr,3)
        <=> $false )
        & ( v90214(VarCurr,2)
        <=> $false )
        & ( v90214(VarCurr,1)
        <=> $false )
        & ( v90214(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54563,axiom,
    ! [VarCurr: state_type] :
      ( ( v90214(VarCurr,3)
      <=> v4201(VarCurr,6) )
      & ( v90214(VarCurr,2)
      <=> v4201(VarCurr,5) )
      & ( v90214(VarCurr,1)
      <=> v4201(VarCurr,4) )
      & ( v90214(VarCurr,0)
      <=> v4201(VarCurr,3) ) ) ).

tff(addAssignment_54562,axiom,
    ! [VarCurr: state_type] :
      ( ( v4201(VarCurr,6)
      <=> v90216(VarCurr,3) )
      & ( v4201(VarCurr,5)
      <=> v90216(VarCurr,2) )
      & ( v4201(VarCurr,4)
      <=> v90216(VarCurr,1) )
      & ( v4201(VarCurr,3)
      <=> v90216(VarCurr,0) ) ) ).

tff(addAssignment_54561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90216(VarCurr,B)
      <=> v90218(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1031,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90252(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v90218(VarNext,B)
            <=> v90218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1031,axiom,
    ! [VarNext: state_type] :
      ( v90252(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v90218(VarNext,B)
          <=> v90262(VarNext,B) ) ) ) ).

tff(addAssignment_54560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v90262(VarNext,B)
          <=> v90260(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v90260(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_555,axiom,
    ! [VarCurr: state_type] :
      ( v90263(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v90260(VarCurr,B)
          <=> v90228(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8600,axiom,
    ! [VarCurr: state_type] :
      ( v90263(VarCurr)
    <=> ( v90264(VarCurr)
        & v90265(VarCurr) ) ) ).

tff(writeUnaryOperator_4277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90265(VarCurr)
    <=> v90224(VarCurr) ) ).

tff(writeUnaryOperator_4276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90264(VarCurr)
    <=> v90220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90252(VarNext)
      <=> v90253(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90253(VarNext)
      <=> ( v90254(VarNext)
          & v90247(VarNext) ) ) ) ).

tff(writeUnaryOperator_4275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v90254(VarNext)
      <=> v90256(VarNext) ) ) ).

tff(addAssignment_54559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v90256(VarNext)
      <=> v90247(VarCurr) ) ) ).

tff(addAssignment_54558,axiom,
    ! [VarCurr: state_type] :
      ( v90247(VarCurr)
    <=> v90249(VarCurr) ) ).

tff(addAssignment_54557,axiom,
    ! [VarCurr: state_type] :
      ( v90249(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_54556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90228(VarCurr,B)
      <=> v90230(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90230(VarCurr,B)
      <=> ( v90239(VarCurr,B)
          | v90242(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90242(VarCurr,B)
      <=> ( v90216(VarCurr,B)
          & v90243(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90243(VarCurr,B)
      <=> ~ v90244(VarCurr,B) ) ) ).

tff(addAssignment_54555,axiom,
    ! [VarCurr: state_type] :
      ( v90244(VarCurr,0)
    <=> v90245(VarCurr) ) ).

tff(addAssignment_54554,axiom,
    ! [VarCurr: state_type] :
      ( v90244(VarCurr,1)
    <=> v90245(VarCurr) ) ).

tff(addAssignment_54553,axiom,
    ! [VarCurr: state_type] :
      ( v90244(VarCurr,2)
    <=> v90245(VarCurr) ) ).

tff(addAssignment_54552,axiom,
    ! [VarCurr: state_type] :
      ( v90244(VarCurr,3)
    <=> v90245(VarCurr) ) ).

tff(addAssignment_54551,axiom,
    ! [VarCurr: state_type] :
      ( v90245(VarCurr)
    <=> v90237(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v90239(VarCurr,B)
      <=> ( v90232(VarCurr,B)
          & v90240(VarCurr,B) ) ) ) ).

tff(addAssignment_54550,axiom,
    ! [VarCurr: state_type] :
      ( v90240(VarCurr,0)
    <=> v90241(VarCurr) ) ).

tff(addAssignment_54549,axiom,
    ! [VarCurr: state_type] :
      ( v90240(VarCurr,1)
    <=> v90241(VarCurr) ) ).

tff(addAssignment_54548,axiom,
    ! [VarCurr: state_type] :
      ( v90240(VarCurr,2)
    <=> v90241(VarCurr) ) ).

tff(addAssignment_54547,axiom,
    ! [VarCurr: state_type] :
      ( v90240(VarCurr,3)
    <=> v90241(VarCurr) ) ).

tff(addAssignment_54546,axiom,
    ! [VarCurr: state_type] :
      ( v90241(VarCurr)
    <=> v90237(VarCurr) ) ).

tff(addAssignment_54545,axiom,
    ! [VarCurr: state_type] :
      ( v90237(VarCurr)
    <=> v32577(VarCurr) ) ).

tff(addAssignment_54544,axiom,
    ! [VarCurr: state_type] :
      ( ( v90232(VarCurr,3)
      <=> v4221(VarCurr,6) )
      & ( v90232(VarCurr,2)
      <=> v4221(VarCurr,5) )
      & ( v90232(VarCurr,1)
      <=> v4221(VarCurr,4) )
      & ( v90232(VarCurr,0)
      <=> v4221(VarCurr,3) ) ) ).

tff(addAssignment_54543,axiom,
    ! [VarCurr: state_type] :
      ( ( v4221(VarCurr,6)
      <=> v90233(VarCurr,3) )
      & ( v4221(VarCurr,5)
      <=> v90233(VarCurr,2) )
      & ( v4221(VarCurr,4)
      <=> v90233(VarCurr,1) )
      & ( v4221(VarCurr,3)
      <=> v90233(VarCurr,0) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_15,axiom,
    ! [VarCurr: state_type] :
      ( ~ v90234(VarCurr)
     => ( ( v90233(VarCurr,4)
        <=> v4201(VarCurr,7) )
        & ( v90233(VarCurr,3)
        <=> v4201(VarCurr,6) )
        & ( v90233(VarCurr,2)
        <=> v4201(VarCurr,5) )
        & ( v90233(VarCurr,1)
        <=> v4201(VarCurr,4) )
        & ( v90233(VarCurr,0)
        <=> v4201(VarCurr,3) ) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_42,axiom,
    ! [VarCurr: state_type] :
      ( v90234(VarCurr)
     => ( ( v90233(VarCurr,4)
        <=> v2363(VarCurr,7) )
        & ( v90233(VarCurr,3)
        <=> v2363(VarCurr,6) )
        & ( v90233(VarCurr,2)
        <=> v2363(VarCurr,5) )
        & ( v90233(VarCurr,1)
        <=> v2363(VarCurr,4) )
        & ( v90233(VarCurr,0)
        <=> v2363(VarCurr,3) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8597,axiom,
    ! [VarCurr: state_type] :
      ( v90234(VarCurr)
    <=> ( v2354(VarCurr)
        & v90235(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_473,axiom,
    ! [VarCurr: state_type] :
      ( v90235(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54542,axiom,
    ! [VarCurr: state_type] :
      ( v90224(VarCurr)
    <=> v90226(VarCurr) ) ).

tff(addAssignment_54541,axiom,
    ! [VarCurr: state_type] :
      ( v90226(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54540,axiom,
    ! [VarCurr: state_type] :
      ( v90220(VarCurr)
    <=> v90222(VarCurr) ) ).

tff(addAssignment_54539,axiom,
    ! [VarCurr: state_type] :
      ( v90222(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_54538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v89726(VarCurr,B)
      <=> v89728(VarCurr,B) ) ) ).

tff(addAssignment_54537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v89728(VarCurr,B)
      <=> v89730(VarCurr,B) ) ) ).

tff(addAssignment_54536,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,11)
    <=> v90172(VarCurr) ) ).

tff(addAssignment_54535,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,10)
    <=> v90132(VarCurr) ) ).

tff(addAssignment_54534,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,9)
    <=> v90092(VarCurr) ) ).

tff(addAssignment_54533,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,8)
    <=> v90052(VarCurr) ) ).

tff(addAssignment_54532,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,7)
    <=> v90012(VarCurr) ) ).

tff(addAssignment_54531,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,6)
    <=> v89972(VarCurr) ) ).

tff(addAssignment_54530,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,5)
    <=> v89932(VarCurr) ) ).

tff(addAssignment_54529,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,4)
    <=> v89892(VarCurr) ) ).

tff(addAssignment_54528,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,3)
    <=> v89852(VarCurr) ) ).

tff(addAssignment_54527,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,2)
    <=> v89812(VarCurr) ) ).

tff(addAssignment_54526,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,1)
    <=> v89772(VarCurr) ) ).

tff(addAssignment_54525,axiom,
    ! [VarCurr: state_type] :
      ( v89730(VarCurr,0)
    <=> v89732(VarCurr) ) ).

tff(addAssignment_54524,axiom,
    ! [VarCurr: state_type] :
      ( v90172(VarCurr)
    <=> v90174(VarCurr) ) ).

tff(addAssignment_54523,axiom,
    ! [VarCurr: state_type] :
      ( v90174(VarCurr)
    <=> v90176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8596,axiom,
    ! [VarCurr: state_type] :
      ( v90176(VarCurr)
    <=> ( v90210(VarCurr)
      <~> v90206(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8595,axiom,
    ! [VarCurr: state_type] :
      ( v90210(VarCurr)
    <=> ( v90178(VarCurr)
      <~> v90202(VarCurr) ) ) ).

tff(addAssignment_54522,axiom,
    ! [VarCurr: state_type] :
      ( v90206(VarCurr)
    <=> v90208(VarCurr) ) ).

tff(addAssignment_54521,axiom,
    ! [VarCurr: state_type] :
      ( v90208(VarCurr)
    <=> v47849(VarCurr,4) ) ).

tff(addAssignment_54520,axiom,
    ! [VarCurr: state_type] :
      ( v90202(VarCurr)
    <=> v90204(VarCurr) ) ).

tff(addAssignment_54519,axiom,
    ! [VarCurr: state_type] :
      ( v90204(VarCurr)
    <=> v47849(VarCurr,3) ) ).

tff(addAssignment_54518,axiom,
    ! [VarCurr: state_type] :
      ( v90178(VarCurr)
    <=> v90180(VarCurr) ) ).

tff(addAssignment_54517,axiom,
    ! [VarCurr: state_type] :
      ( v90180(VarCurr)
    <=> v90182(VarCurr) ) ).

tff(addAssignment_54516,axiom,
    ! [VarCurr: state_type] :
      ( v90182(VarCurr)
    <=> v90184(VarCurr) ) ).

tff(addAssignment_54515,axiom,
    ! [VarCurr: state_type] :
      ( v90184(VarCurr)
    <=> v90186(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8594,axiom,
    ! [VarCurr: state_type] :
      ( v90186(VarCurr)
    <=> ( v90200(VarCurr)
      <~> v90196(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8593,axiom,
    ! [VarCurr: state_type] :
      ( v90200(VarCurr)
    <=> ( v90188(VarCurr)
      <~> v90192(VarCurr) ) ) ).

tff(addAssignment_54514,axiom,
    ! [VarCurr: state_type] :
      ( v90196(VarCurr)
    <=> v90198(VarCurr) ) ).

tff(addAssignment_54513,axiom,
    ! [VarCurr: state_type] :
      ( v90198(VarCurr)
    <=> v47849(VarCurr,2) ) ).

tff(addAssignment_54512,axiom,
    ! [VarCurr: state_type] :
      ( v90192(VarCurr)
    <=> v90194(VarCurr) ) ).

tff(addAssignment_54511,axiom,
    ! [VarCurr: state_type] :
      ( v90194(VarCurr)
    <=> v47849(VarCurr,1) ) ).

tff(addAssignment_54510,axiom,
    ! [VarCurr: state_type] :
      ( v90188(VarCurr)
    <=> v90190(VarCurr) ) ).

tff(addAssignment_54509,axiom,
    ! [VarCurr: state_type] :
      ( v90190(VarCurr)
    <=> v47849(VarCurr,0) ) ).

tff(addAssignment_54508,axiom,
    ! [VarCurr: state_type] :
      ( v90132(VarCurr)
    <=> v90134(VarCurr) ) ).

tff(addAssignment_54507,axiom,
    ! [VarCurr: state_type] :
      ( v90134(VarCurr)
    <=> v90136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8592,axiom,
    ! [VarCurr: state_type] :
      ( v90136(VarCurr)
    <=> ( v90170(VarCurr)
      <~> v90166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8591,axiom,
    ! [VarCurr: state_type] :
      ( v90170(VarCurr)
    <=> ( v90138(VarCurr)
      <~> v90162(VarCurr) ) ) ).

tff(addAssignment_54506,axiom,
    ! [VarCurr: state_type] :
      ( v90166(VarCurr)
    <=> v90168(VarCurr) ) ).

tff(addAssignment_54505,axiom,
    ! [VarCurr: state_type] :
      ( v90168(VarCurr)
    <=> v46299(VarCurr,4) ) ).

tff(addAssignment_54504,axiom,
    ! [VarCurr: state_type] :
      ( v90162(VarCurr)
    <=> v90164(VarCurr) ) ).

tff(addAssignment_54503,axiom,
    ! [VarCurr: state_type] :
      ( v90164(VarCurr)
    <=> v46299(VarCurr,3) ) ).

tff(addAssignment_54502,axiom,
    ! [VarCurr: state_type] :
      ( v90138(VarCurr)
    <=> v90140(VarCurr) ) ).

tff(addAssignment_54501,axiom,
    ! [VarCurr: state_type] :
      ( v90140(VarCurr)
    <=> v90142(VarCurr) ) ).

tff(addAssignment_54500,axiom,
    ! [VarCurr: state_type] :
      ( v90142(VarCurr)
    <=> v90144(VarCurr) ) ).

tff(addAssignment_54499,axiom,
    ! [VarCurr: state_type] :
      ( v90144(VarCurr)
    <=> v90146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8590,axiom,
    ! [VarCurr: state_type] :
      ( v90146(VarCurr)
    <=> ( v90160(VarCurr)
      <~> v90156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8589,axiom,
    ! [VarCurr: state_type] :
      ( v90160(VarCurr)
    <=> ( v90148(VarCurr)
      <~> v90152(VarCurr) ) ) ).

tff(addAssignment_54498,axiom,
    ! [VarCurr: state_type] :
      ( v90156(VarCurr)
    <=> v90158(VarCurr) ) ).

tff(addAssignment_54497,axiom,
    ! [VarCurr: state_type] :
      ( v90158(VarCurr)
    <=> v46299(VarCurr,2) ) ).

tff(addAssignment_54496,axiom,
    ! [VarCurr: state_type] :
      ( v90152(VarCurr)
    <=> v90154(VarCurr) ) ).

tff(addAssignment_54495,axiom,
    ! [VarCurr: state_type] :
      ( v90154(VarCurr)
    <=> v46299(VarCurr,1) ) ).

tff(addAssignment_54494,axiom,
    ! [VarCurr: state_type] :
      ( v90148(VarCurr)
    <=> v90150(VarCurr) ) ).

tff(addAssignment_54493,axiom,
    ! [VarCurr: state_type] :
      ( v90150(VarCurr)
    <=> v46299(VarCurr,0) ) ).

tff(addAssignment_54492,axiom,
    ! [VarCurr: state_type] :
      ( v90092(VarCurr)
    <=> v90094(VarCurr) ) ).

tff(addAssignment_54491,axiom,
    ! [VarCurr: state_type] :
      ( v90094(VarCurr)
    <=> v90096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8588,axiom,
    ! [VarCurr: state_type] :
      ( v90096(VarCurr)
    <=> ( v90130(VarCurr)
      <~> v90126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8587,axiom,
    ! [VarCurr: state_type] :
      ( v90130(VarCurr)
    <=> ( v90098(VarCurr)
      <~> v90122(VarCurr) ) ) ).

tff(addAssignment_54490,axiom,
    ! [VarCurr: state_type] :
      ( v90126(VarCurr)
    <=> v90128(VarCurr) ) ).

tff(addAssignment_54489,axiom,
    ! [VarCurr: state_type] :
      ( v90128(VarCurr)
    <=> v44749(VarCurr,4) ) ).

tff(addAssignment_54488,axiom,
    ! [VarCurr: state_type] :
      ( v90122(VarCurr)
    <=> v90124(VarCurr) ) ).

tff(addAssignment_54487,axiom,
    ! [VarCurr: state_type] :
      ( v90124(VarCurr)
    <=> v44749(VarCurr,3) ) ).

tff(addAssignment_54486,axiom,
    ! [VarCurr: state_type] :
      ( v90098(VarCurr)
    <=> v90100(VarCurr) ) ).

tff(addAssignment_54485,axiom,
    ! [VarCurr: state_type] :
      ( v90100(VarCurr)
    <=> v90102(VarCurr) ) ).

tff(addAssignment_54484,axiom,
    ! [VarCurr: state_type] :
      ( v90102(VarCurr)
    <=> v90104(VarCurr) ) ).

tff(addAssignment_54483,axiom,
    ! [VarCurr: state_type] :
      ( v90104(VarCurr)
    <=> v90106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8586,axiom,
    ! [VarCurr: state_type] :
      ( v90106(VarCurr)
    <=> ( v90120(VarCurr)
      <~> v90116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8585,axiom,
    ! [VarCurr: state_type] :
      ( v90120(VarCurr)
    <=> ( v90108(VarCurr)
      <~> v90112(VarCurr) ) ) ).

tff(addAssignment_54482,axiom,
    ! [VarCurr: state_type] :
      ( v90116(VarCurr)
    <=> v90118(VarCurr) ) ).

tff(addAssignment_54481,axiom,
    ! [VarCurr: state_type] :
      ( v90118(VarCurr)
    <=> v44749(VarCurr,2) ) ).

tff(addAssignment_54480,axiom,
    ! [VarCurr: state_type] :
      ( v90112(VarCurr)
    <=> v90114(VarCurr) ) ).

tff(addAssignment_54479,axiom,
    ! [VarCurr: state_type] :
      ( v90114(VarCurr)
    <=> v44749(VarCurr,1) ) ).

tff(addAssignment_54478,axiom,
    ! [VarCurr: state_type] :
      ( v90108(VarCurr)
    <=> v90110(VarCurr) ) ).

tff(addAssignment_54477,axiom,
    ! [VarCurr: state_type] :
      ( v90110(VarCurr)
    <=> v44749(VarCurr,0) ) ).

tff(addAssignment_54476,axiom,
    ! [VarCurr: state_type] :
      ( v90052(VarCurr)
    <=> v90054(VarCurr) ) ).

tff(addAssignment_54475,axiom,
    ! [VarCurr: state_type] :
      ( v90054(VarCurr)
    <=> v90056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8584,axiom,
    ! [VarCurr: state_type] :
      ( v90056(VarCurr)
    <=> ( v90090(VarCurr)
      <~> v90086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8583,axiom,
    ! [VarCurr: state_type] :
      ( v90090(VarCurr)
    <=> ( v90058(VarCurr)
      <~> v90082(VarCurr) ) ) ).

tff(addAssignment_54474,axiom,
    ! [VarCurr: state_type] :
      ( v90086(VarCurr)
    <=> v90088(VarCurr) ) ).

tff(addAssignment_54473,axiom,
    ! [VarCurr: state_type] :
      ( v90088(VarCurr)
    <=> v43199(VarCurr,4) ) ).

tff(addAssignment_54472,axiom,
    ! [VarCurr: state_type] :
      ( v90082(VarCurr)
    <=> v90084(VarCurr) ) ).

tff(addAssignment_54471,axiom,
    ! [VarCurr: state_type] :
      ( v90084(VarCurr)
    <=> v43199(VarCurr,3) ) ).

tff(addAssignment_54470,axiom,
    ! [VarCurr: state_type] :
      ( v90058(VarCurr)
    <=> v90060(VarCurr) ) ).

tff(addAssignment_54469,axiom,
    ! [VarCurr: state_type] :
      ( v90060(VarCurr)
    <=> v90062(VarCurr) ) ).

tff(addAssignment_54468,axiom,
    ! [VarCurr: state_type] :
      ( v90062(VarCurr)
    <=> v90064(VarCurr) ) ).

tff(addAssignment_54467,axiom,
    ! [VarCurr: state_type] :
      ( v90064(VarCurr)
    <=> v90066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8582,axiom,
    ! [VarCurr: state_type] :
      ( v90066(VarCurr)
    <=> ( v90080(VarCurr)
      <~> v90076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8581,axiom,
    ! [VarCurr: state_type] :
      ( v90080(VarCurr)
    <=> ( v90068(VarCurr)
      <~> v90072(VarCurr) ) ) ).

tff(addAssignment_54466,axiom,
    ! [VarCurr: state_type] :
      ( v90076(VarCurr)
    <=> v90078(VarCurr) ) ).

tff(addAssignment_54465,axiom,
    ! [VarCurr: state_type] :
      ( v90078(VarCurr)
    <=> v43199(VarCurr,2) ) ).

tff(addAssignment_54464,axiom,
    ! [VarCurr: state_type] :
      ( v90072(VarCurr)
    <=> v90074(VarCurr) ) ).

tff(addAssignment_54463,axiom,
    ! [VarCurr: state_type] :
      ( v90074(VarCurr)
    <=> v43199(VarCurr,1) ) ).

tff(addAssignment_54462,axiom,
    ! [VarCurr: state_type] :
      ( v90068(VarCurr)
    <=> v90070(VarCurr) ) ).

tff(addAssignment_54461,axiom,
    ! [VarCurr: state_type] :
      ( v90070(VarCurr)
    <=> v43199(VarCurr,0) ) ).

tff(addAssignment_54460,axiom,
    ! [VarCurr: state_type] :
      ( v90012(VarCurr)
    <=> v90014(VarCurr) ) ).

tff(addAssignment_54459,axiom,
    ! [VarCurr: state_type] :
      ( v90014(VarCurr)
    <=> v90016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8580,axiom,
    ! [VarCurr: state_type] :
      ( v90016(VarCurr)
    <=> ( v90050(VarCurr)
      <~> v90046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8579,axiom,
    ! [VarCurr: state_type] :
      ( v90050(VarCurr)
    <=> ( v90018(VarCurr)
      <~> v90042(VarCurr) ) ) ).

tff(addAssignment_54458,axiom,
    ! [VarCurr: state_type] :
      ( v90046(VarCurr)
    <=> v90048(VarCurr) ) ).

tff(addAssignment_54457,axiom,
    ! [VarCurr: state_type] :
      ( v90048(VarCurr)
    <=> v41649(VarCurr,4) ) ).

tff(addAssignment_54456,axiom,
    ! [VarCurr: state_type] :
      ( v90042(VarCurr)
    <=> v90044(VarCurr) ) ).

tff(addAssignment_54455,axiom,
    ! [VarCurr: state_type] :
      ( v90044(VarCurr)
    <=> v41649(VarCurr,3) ) ).

tff(addAssignment_54454,axiom,
    ! [VarCurr: state_type] :
      ( v90018(VarCurr)
    <=> v90020(VarCurr) ) ).

tff(addAssignment_54453,axiom,
    ! [VarCurr: state_type] :
      ( v90020(VarCurr)
    <=> v90022(VarCurr) ) ).

tff(addAssignment_54452,axiom,
    ! [VarCurr: state_type] :
      ( v90022(VarCurr)
    <=> v90024(VarCurr) ) ).

tff(addAssignment_54451,axiom,
    ! [VarCurr: state_type] :
      ( v90024(VarCurr)
    <=> v90026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8578,axiom,
    ! [VarCurr: state_type] :
      ( v90026(VarCurr)
    <=> ( v90040(VarCurr)
      <~> v90036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8577,axiom,
    ! [VarCurr: state_type] :
      ( v90040(VarCurr)
    <=> ( v90028(VarCurr)
      <~> v90032(VarCurr) ) ) ).

tff(addAssignment_54450,axiom,
    ! [VarCurr: state_type] :
      ( v90036(VarCurr)
    <=> v90038(VarCurr) ) ).

tff(addAssignment_54449,axiom,
    ! [VarCurr: state_type] :
      ( v90038(VarCurr)
    <=> v41649(VarCurr,2) ) ).

tff(addAssignment_54448,axiom,
    ! [VarCurr: state_type] :
      ( v90032(VarCurr)
    <=> v90034(VarCurr) ) ).

tff(addAssignment_54447,axiom,
    ! [VarCurr: state_type] :
      ( v90034(VarCurr)
    <=> v41649(VarCurr,1) ) ).

tff(addAssignment_54446,axiom,
    ! [VarCurr: state_type] :
      ( v90028(VarCurr)
    <=> v90030(VarCurr) ) ).

tff(addAssignment_54445,axiom,
    ! [VarCurr: state_type] :
      ( v90030(VarCurr)
    <=> v41649(VarCurr,0) ) ).

tff(addAssignment_54444,axiom,
    ! [VarCurr: state_type] :
      ( v89972(VarCurr)
    <=> v89974(VarCurr) ) ).

tff(addAssignment_54443,axiom,
    ! [VarCurr: state_type] :
      ( v89974(VarCurr)
    <=> v89976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8576,axiom,
    ! [VarCurr: state_type] :
      ( v89976(VarCurr)
    <=> ( v90010(VarCurr)
      <~> v90006(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8575,axiom,
    ! [VarCurr: state_type] :
      ( v90010(VarCurr)
    <=> ( v89978(VarCurr)
      <~> v90002(VarCurr) ) ) ).

tff(addAssignment_54442,axiom,
    ! [VarCurr: state_type] :
      ( v90006(VarCurr)
    <=> v90008(VarCurr) ) ).

tff(addAssignment_54441,axiom,
    ! [VarCurr: state_type] :
      ( v90008(VarCurr)
    <=> v40099(VarCurr,4) ) ).

tff(addAssignment_54440,axiom,
    ! [VarCurr: state_type] :
      ( v90002(VarCurr)
    <=> v90004(VarCurr) ) ).

tff(addAssignment_54439,axiom,
    ! [VarCurr: state_type] :
      ( v90004(VarCurr)
    <=> v40099(VarCurr,3) ) ).

tff(addAssignment_54438,axiom,
    ! [VarCurr: state_type] :
      ( v89978(VarCurr)
    <=> v89980(VarCurr) ) ).

tff(addAssignment_54437,axiom,
    ! [VarCurr: state_type] :
      ( v89980(VarCurr)
    <=> v89982(VarCurr) ) ).

tff(addAssignment_54436,axiom,
    ! [VarCurr: state_type] :
      ( v89982(VarCurr)
    <=> v89984(VarCurr) ) ).

tff(addAssignment_54435,axiom,
    ! [VarCurr: state_type] :
      ( v89984(VarCurr)
    <=> v89986(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8574,axiom,
    ! [VarCurr: state_type] :
      ( v89986(VarCurr)
    <=> ( v90000(VarCurr)
      <~> v89996(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8573,axiom,
    ! [VarCurr: state_type] :
      ( v90000(VarCurr)
    <=> ( v89988(VarCurr)
      <~> v89992(VarCurr) ) ) ).

tff(addAssignment_54434,axiom,
    ! [VarCurr: state_type] :
      ( v89996(VarCurr)
    <=> v89998(VarCurr) ) ).

tff(addAssignment_54433,axiom,
    ! [VarCurr: state_type] :
      ( v89998(VarCurr)
    <=> v40099(VarCurr,2) ) ).

tff(addAssignment_54432,axiom,
    ! [VarCurr: state_type] :
      ( v89992(VarCurr)
    <=> v89994(VarCurr) ) ).

tff(addAssignment_54431,axiom,
    ! [VarCurr: state_type] :
      ( v89994(VarCurr)
    <=> v40099(VarCurr,1) ) ).

tff(addAssignment_54430,axiom,
    ! [VarCurr: state_type] :
      ( v89988(VarCurr)
    <=> v89990(VarCurr) ) ).

tff(addAssignment_54429,axiom,
    ! [VarCurr: state_type] :
      ( v89990(VarCurr)
    <=> v40099(VarCurr,0) ) ).

tff(addAssignment_54428,axiom,
    ! [VarCurr: state_type] :
      ( v89932(VarCurr)
    <=> v89934(VarCurr) ) ).

tff(addAssignment_54427,axiom,
    ! [VarCurr: state_type] :
      ( v89934(VarCurr)
    <=> v89936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8572,axiom,
    ! [VarCurr: state_type] :
      ( v89936(VarCurr)
    <=> ( v89970(VarCurr)
      <~> v89966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8571,axiom,
    ! [VarCurr: state_type] :
      ( v89970(VarCurr)
    <=> ( v89938(VarCurr)
      <~> v89962(VarCurr) ) ) ).

tff(addAssignment_54426,axiom,
    ! [VarCurr: state_type] :
      ( v89966(VarCurr)
    <=> v89968(VarCurr) ) ).

tff(addAssignment_54425,axiom,
    ! [VarCurr: state_type] :
      ( v89968(VarCurr)
    <=> v38549(VarCurr,4) ) ).

tff(addAssignment_54424,axiom,
    ! [VarCurr: state_type] :
      ( v89962(VarCurr)
    <=> v89964(VarCurr) ) ).

tff(addAssignment_54423,axiom,
    ! [VarCurr: state_type] :
      ( v89964(VarCurr)
    <=> v38549(VarCurr,3) ) ).

tff(addAssignment_54422,axiom,
    ! [VarCurr: state_type] :
      ( v89938(VarCurr)
    <=> v89940(VarCurr) ) ).

tff(addAssignment_54421,axiom,
    ! [VarCurr: state_type] :
      ( v89940(VarCurr)
    <=> v89942(VarCurr) ) ).

tff(addAssignment_54420,axiom,
    ! [VarCurr: state_type] :
      ( v89942(VarCurr)
    <=> v89944(VarCurr) ) ).

tff(addAssignment_54419,axiom,
    ! [VarCurr: state_type] :
      ( v89944(VarCurr)
    <=> v89946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8570,axiom,
    ! [VarCurr: state_type] :
      ( v89946(VarCurr)
    <=> ( v89960(VarCurr)
      <~> v89956(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8569,axiom,
    ! [VarCurr: state_type] :
      ( v89960(VarCurr)
    <=> ( v89948(VarCurr)
      <~> v89952(VarCurr) ) ) ).

tff(addAssignment_54418,axiom,
    ! [VarCurr: state_type] :
      ( v89956(VarCurr)
    <=> v89958(VarCurr) ) ).

tff(addAssignment_54417,axiom,
    ! [VarCurr: state_type] :
      ( v89958(VarCurr)
    <=> v38549(VarCurr,2) ) ).

tff(addAssignment_54416,axiom,
    ! [VarCurr: state_type] :
      ( v89952(VarCurr)
    <=> v89954(VarCurr) ) ).

tff(addAssignment_54415,axiom,
    ! [VarCurr: state_type] :
      ( v89954(VarCurr)
    <=> v38549(VarCurr,1) ) ).

tff(addAssignment_54414,axiom,
    ! [VarCurr: state_type] :
      ( v89948(VarCurr)
    <=> v89950(VarCurr) ) ).

tff(addAssignment_54413,axiom,
    ! [VarCurr: state_type] :
      ( v89950(VarCurr)
    <=> v38549(VarCurr,0) ) ).

tff(addAssignment_54412,axiom,
    ! [VarCurr: state_type] :
      ( v89892(VarCurr)
    <=> v89894(VarCurr) ) ).

tff(addAssignment_54411,axiom,
    ! [VarCurr: state_type] :
      ( v89894(VarCurr)
    <=> v89896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8568,axiom,
    ! [VarCurr: state_type] :
      ( v89896(VarCurr)
    <=> ( v89930(VarCurr)
      <~> v89926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8567,axiom,
    ! [VarCurr: state_type] :
      ( v89930(VarCurr)
    <=> ( v89898(VarCurr)
      <~> v89922(VarCurr) ) ) ).

tff(addAssignment_54410,axiom,
    ! [VarCurr: state_type] :
      ( v89926(VarCurr)
    <=> v89928(VarCurr) ) ).

tff(addAssignment_54409,axiom,
    ! [VarCurr: state_type] :
      ( v89928(VarCurr)
    <=> v36999(VarCurr,4) ) ).

tff(addAssignment_54408,axiom,
    ! [VarCurr: state_type] :
      ( v89922(VarCurr)
    <=> v89924(VarCurr) ) ).

tff(addAssignment_54407,axiom,
    ! [VarCurr: state_type] :
      ( v89924(VarCurr)
    <=> v36999(VarCurr,3) ) ).

tff(addAssignment_54406,axiom,
    ! [VarCurr: state_type] :
      ( v89898(VarCurr)
    <=> v89900(VarCurr) ) ).

tff(addAssignment_54405,axiom,
    ! [VarCurr: state_type] :
      ( v89900(VarCurr)
    <=> v89902(VarCurr) ) ).

tff(addAssignment_54404,axiom,
    ! [VarCurr: state_type] :
      ( v89902(VarCurr)
    <=> v89904(VarCurr) ) ).

tff(addAssignment_54403,axiom,
    ! [VarCurr: state_type] :
      ( v89904(VarCurr)
    <=> v89906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8566,axiom,
    ! [VarCurr: state_type] :
      ( v89906(VarCurr)
    <=> ( v89920(VarCurr)
      <~> v89916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8565,axiom,
    ! [VarCurr: state_type] :
      ( v89920(VarCurr)
    <=> ( v89908(VarCurr)
      <~> v89912(VarCurr) ) ) ).

tff(addAssignment_54402,axiom,
    ! [VarCurr: state_type] :
      ( v89916(VarCurr)
    <=> v89918(VarCurr) ) ).

tff(addAssignment_54401,axiom,
    ! [VarCurr: state_type] :
      ( v89918(VarCurr)
    <=> v36999(VarCurr,2) ) ).

tff(addAssignment_54400,axiom,
    ! [VarCurr: state_type] :
      ( v89912(VarCurr)
    <=> v89914(VarCurr) ) ).

tff(addAssignment_54399,axiom,
    ! [VarCurr: state_type] :
      ( v89914(VarCurr)
    <=> v36999(VarCurr,1) ) ).

tff(addAssignment_54398,axiom,
    ! [VarCurr: state_type] :
      ( v89908(VarCurr)
    <=> v89910(VarCurr) ) ).

tff(addAssignment_54397,axiom,
    ! [VarCurr: state_type] :
      ( v89910(VarCurr)
    <=> v36999(VarCurr,0) ) ).

tff(addAssignment_54396,axiom,
    ! [VarCurr: state_type] :
      ( v89852(VarCurr)
    <=> v89854(VarCurr) ) ).

tff(addAssignment_54395,axiom,
    ! [VarCurr: state_type] :
      ( v89854(VarCurr)
    <=> v89856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8564,axiom,
    ! [VarCurr: state_type] :
      ( v89856(VarCurr)
    <=> ( v89890(VarCurr)
      <~> v89886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8563,axiom,
    ! [VarCurr: state_type] :
      ( v89890(VarCurr)
    <=> ( v89858(VarCurr)
      <~> v89882(VarCurr) ) ) ).

tff(addAssignment_54394,axiom,
    ! [VarCurr: state_type] :
      ( v89886(VarCurr)
    <=> v89888(VarCurr) ) ).

tff(addAssignment_54393,axiom,
    ! [VarCurr: state_type] :
      ( v89888(VarCurr)
    <=> v35449(VarCurr,4) ) ).

tff(addAssignment_54392,axiom,
    ! [VarCurr: state_type] :
      ( v89882(VarCurr)
    <=> v89884(VarCurr) ) ).

tff(addAssignment_54391,axiom,
    ! [VarCurr: state_type] :
      ( v89884(VarCurr)
    <=> v35449(VarCurr,3) ) ).

tff(addAssignment_54390,axiom,
    ! [VarCurr: state_type] :
      ( v89858(VarCurr)
    <=> v89860(VarCurr) ) ).

tff(addAssignment_54389,axiom,
    ! [VarCurr: state_type] :
      ( v89860(VarCurr)
    <=> v89862(VarCurr) ) ).

tff(addAssignment_54388,axiom,
    ! [VarCurr: state_type] :
      ( v89862(VarCurr)
    <=> v89864(VarCurr) ) ).

tff(addAssignment_54387,axiom,
    ! [VarCurr: state_type] :
      ( v89864(VarCurr)
    <=> v89866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8562,axiom,
    ! [VarCurr: state_type] :
      ( v89866(VarCurr)
    <=> ( v89880(VarCurr)
      <~> v89876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8561,axiom,
    ! [VarCurr: state_type] :
      ( v89880(VarCurr)
    <=> ( v89868(VarCurr)
      <~> v89872(VarCurr) ) ) ).

tff(addAssignment_54386,axiom,
    ! [VarCurr: state_type] :
      ( v89876(VarCurr)
    <=> v89878(VarCurr) ) ).

tff(addAssignment_54385,axiom,
    ! [VarCurr: state_type] :
      ( v89878(VarCurr)
    <=> v35449(VarCurr,2) ) ).

tff(addAssignment_54384,axiom,
    ! [VarCurr: state_type] :
      ( v89872(VarCurr)
    <=> v89874(VarCurr) ) ).

tff(addAssignment_54383,axiom,
    ! [VarCurr: state_type] :
      ( v89874(VarCurr)
    <=> v35449(VarCurr,1) ) ).

tff(addAssignment_54382,axiom,
    ! [VarCurr: state_type] :
      ( v89868(VarCurr)
    <=> v89870(VarCurr) ) ).

tff(addAssignment_54381,axiom,
    ! [VarCurr: state_type] :
      ( v89870(VarCurr)
    <=> v35449(VarCurr,0) ) ).

tff(addAssignment_54380,axiom,
    ! [VarCurr: state_type] :
      ( v89812(VarCurr)
    <=> v89814(VarCurr) ) ).

tff(addAssignment_54379,axiom,
    ! [VarCurr: state_type] :
      ( v89814(VarCurr)
    <=> v89816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8560,axiom,
    ! [VarCurr: state_type] :
      ( v89816(VarCurr)
    <=> ( v89850(VarCurr)
      <~> v89846(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8559,axiom,
    ! [VarCurr: state_type] :
      ( v89850(VarCurr)
    <=> ( v89818(VarCurr)
      <~> v89842(VarCurr) ) ) ).

tff(addAssignment_54378,axiom,
    ! [VarCurr: state_type] :
      ( v89846(VarCurr)
    <=> v89848(VarCurr) ) ).

tff(addAssignment_54377,axiom,
    ! [VarCurr: state_type] :
      ( v89848(VarCurr)
    <=> v8510(VarCurr,4) ) ).

tff(addAssignment_54376,axiom,
    ! [VarCurr: state_type] :
      ( v89842(VarCurr)
    <=> v89844(VarCurr) ) ).

tff(addAssignment_54375,axiom,
    ! [VarCurr: state_type] :
      ( v89844(VarCurr)
    <=> v8510(VarCurr,3) ) ).

tff(addAssignment_54374,axiom,
    ! [VarCurr: state_type] :
      ( v89818(VarCurr)
    <=> v89820(VarCurr) ) ).

tff(addAssignment_54373,axiom,
    ! [VarCurr: state_type] :
      ( v89820(VarCurr)
    <=> v89822(VarCurr) ) ).

tff(addAssignment_54372,axiom,
    ! [VarCurr: state_type] :
      ( v89822(VarCurr)
    <=> v89824(VarCurr) ) ).

tff(addAssignment_54371,axiom,
    ! [VarCurr: state_type] :
      ( v89824(VarCurr)
    <=> v89826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8558,axiom,
    ! [VarCurr: state_type] :
      ( v89826(VarCurr)
    <=> ( v89840(VarCurr)
      <~> v89836(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8557,axiom,
    ! [VarCurr: state_type] :
      ( v89840(VarCurr)
    <=> ( v89828(VarCurr)
      <~> v89832(VarCurr) ) ) ).

tff(addAssignment_54370,axiom,
    ! [VarCurr: state_type] :
      ( v89836(VarCurr)
    <=> v89838(VarCurr) ) ).

tff(addAssignment_54369,axiom,
    ! [VarCurr: state_type] :
      ( v89838(VarCurr)
    <=> v8510(VarCurr,2) ) ).

tff(addAssignment_54368,axiom,
    ! [VarCurr: state_type] :
      ( v89832(VarCurr)
    <=> v89834(VarCurr) ) ).

tff(addAssignment_54367,axiom,
    ! [VarCurr: state_type] :
      ( v89834(VarCurr)
    <=> v8510(VarCurr,1) ) ).

tff(addAssignment_54366,axiom,
    ! [VarCurr: state_type] :
      ( v89828(VarCurr)
    <=> v89830(VarCurr) ) ).

tff(addAssignment_54365,axiom,
    ! [VarCurr: state_type] :
      ( v89830(VarCurr)
    <=> v8510(VarCurr,0) ) ).

tff(addAssignment_54364,axiom,
    ! [VarCurr: state_type] :
      ( v89772(VarCurr)
    <=> v89774(VarCurr) ) ).

tff(addAssignment_54363,axiom,
    ! [VarCurr: state_type] :
      ( v89774(VarCurr)
    <=> v89776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8556,axiom,
    ! [VarCurr: state_type] :
      ( v89776(VarCurr)
    <=> ( v89810(VarCurr)
      <~> v89806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8555,axiom,
    ! [VarCurr: state_type] :
      ( v89810(VarCurr)
    <=> ( v89778(VarCurr)
      <~> v89802(VarCurr) ) ) ).

tff(addAssignment_54362,axiom,
    ! [VarCurr: state_type] :
      ( v89806(VarCurr)
    <=> v89808(VarCurr) ) ).

tff(addAssignment_54361,axiom,
    ! [VarCurr: state_type] :
      ( v89808(VarCurr)
    <=> v6242(VarCurr,4) ) ).

tff(addAssignment_54360,axiom,
    ! [VarCurr: state_type] :
      ( v89802(VarCurr)
    <=> v89804(VarCurr) ) ).

tff(addAssignment_54359,axiom,
    ! [VarCurr: state_type] :
      ( v89804(VarCurr)
    <=> v6242(VarCurr,3) ) ).

tff(addAssignment_54358,axiom,
    ! [VarCurr: state_type] :
      ( v89778(VarCurr)
    <=> v89780(VarCurr) ) ).

tff(addAssignment_54357,axiom,
    ! [VarCurr: state_type] :
      ( v89780(VarCurr)
    <=> v89782(VarCurr) ) ).

tff(addAssignment_54356,axiom,
    ! [VarCurr: state_type] :
      ( v89782(VarCurr)
    <=> v89784(VarCurr) ) ).

tff(addAssignment_54355,axiom,
    ! [VarCurr: state_type] :
      ( v89784(VarCurr)
    <=> v89786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8554,axiom,
    ! [VarCurr: state_type] :
      ( v89786(VarCurr)
    <=> ( v89800(VarCurr)
      <~> v89796(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8553,axiom,
    ! [VarCurr: state_type] :
      ( v89800(VarCurr)
    <=> ( v89788(VarCurr)
      <~> v89792(VarCurr) ) ) ).

tff(addAssignment_54354,axiom,
    ! [VarCurr: state_type] :
      ( v89796(VarCurr)
    <=> v89798(VarCurr) ) ).

tff(addAssignment_54353,axiom,
    ! [VarCurr: state_type] :
      ( v89798(VarCurr)
    <=> v6242(VarCurr,2) ) ).

tff(addAssignment_54352,axiom,
    ! [VarCurr: state_type] :
      ( v89792(VarCurr)
    <=> v89794(VarCurr) ) ).

tff(addAssignment_54351,axiom,
    ! [VarCurr: state_type] :
      ( v89794(VarCurr)
    <=> v6242(VarCurr,1) ) ).

tff(addAssignment_54350,axiom,
    ! [VarCurr: state_type] :
      ( v89788(VarCurr)
    <=> v89790(VarCurr) ) ).

tff(addAssignment_54349,axiom,
    ! [VarCurr: state_type] :
      ( v89790(VarCurr)
    <=> v6242(VarCurr,0) ) ).

tff(addAssignment_54348,axiom,
    ! [VarCurr: state_type] :
      ( v89732(VarCurr)
    <=> v89734(VarCurr) ) ).

tff(addAssignment_54347,axiom,
    ! [VarCurr: state_type] :
      ( v89734(VarCurr)
    <=> v89736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8552,axiom,
    ! [VarCurr: state_type] :
      ( v89736(VarCurr)
    <=> ( v89770(VarCurr)
      <~> v89766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8551,axiom,
    ! [VarCurr: state_type] :
      ( v89770(VarCurr)
    <=> ( v89738(VarCurr)
      <~> v89762(VarCurr) ) ) ).

tff(addAssignment_54346,axiom,
    ! [VarCurr: state_type] :
      ( v89766(VarCurr)
    <=> v89768(VarCurr) ) ).

tff(addAssignment_54345,axiom,
    ! [VarCurr: state_type] :
      ( v89768(VarCurr)
    <=> v4121(VarCurr,4) ) ).

tff(addAssignment_54344,axiom,
    ! [VarCurr: state_type] :
      ( v89762(VarCurr)
    <=> v89764(VarCurr) ) ).

tff(addAssignment_54343,axiom,
    ! [VarCurr: state_type] :
      ( v89764(VarCurr)
    <=> v4121(VarCurr,3) ) ).

tff(addAssignment_54342,axiom,
    ! [VarCurr: state_type] :
      ( v89738(VarCurr)
    <=> v89740(VarCurr) ) ).

tff(addAssignment_54341,axiom,
    ! [VarCurr: state_type] :
      ( v89740(VarCurr)
    <=> v89742(VarCurr) ) ).

tff(addAssignment_54340,axiom,
    ! [VarCurr: state_type] :
      ( v89742(VarCurr)
    <=> v89744(VarCurr) ) ).

tff(addAssignment_54339,axiom,
    ! [VarCurr: state_type] :
      ( v89744(VarCurr)
    <=> v89746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8550,axiom,
    ! [VarCurr: state_type] :
      ( v89746(VarCurr)
    <=> ( v89760(VarCurr)
      <~> v89756(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8549,axiom,
    ! [VarCurr: state_type] :
      ( v89760(VarCurr)
    <=> ( v89748(VarCurr)
      <~> v89752(VarCurr) ) ) ).

tff(addAssignment_54338,axiom,
    ! [VarCurr: state_type] :
      ( v89756(VarCurr)
    <=> v89758(VarCurr) ) ).

tff(addAssignment_54337,axiom,
    ! [VarCurr: state_type] :
      ( v89758(VarCurr)
    <=> v4121(VarCurr,2) ) ).

tff(addAssignment_54336,axiom,
    ! [VarCurr: state_type] :
      ( v89752(VarCurr)
    <=> v89754(VarCurr) ) ).

tff(addAssignment_54335,axiom,
    ! [VarCurr: state_type] :
      ( v89754(VarCurr)
    <=> v4121(VarCurr,1) ) ).

tff(addAssignment_54334,axiom,
    ! [VarCurr: state_type] :
      ( v89748(VarCurr)
    <=> v89750(VarCurr) ) ).

tff(addAssignment_54333,axiom,
    ! [VarCurr: state_type] :
      ( v89750(VarCurr)
    <=> v4121(VarCurr,0) ) ).

tff(addAssignment_54332,axiom,
    ! [VarCurr: state_type] :
      ( v89710(VarCurr)
    <=> v89712(VarCurr) ) ).

tff(addAssignment_54331,axiom,
    ! [VarCurr: state_type] :
      ( v89712(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54330,axiom,
    ! [VarCurr: state_type] :
      ( v89706(VarCurr)
    <=> v89708(VarCurr) ) ).

tff(addAssignment_54329,axiom,
    ! [VarCurr: state_type] :
      ( v89708(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_54328,axiom,
    ! [VarCurr: state_type] :
      ( v89684(VarCurr)
    <=> v89686(VarCurr) ) ).

tff(addAssignment_54327,axiom,
    ! [VarCurr: state_type] :
      ( v89686(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54326,axiom,
    ! [VarCurr: state_type] :
      ( v89680(VarCurr)
    <=> v89682(VarCurr) ) ).

tff(addAssignment_54325,axiom,
    ! [VarCurr: state_type] :
      ( v89682(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_472,axiom,
    ! [VarCurr: state_type] :
      ( v89671(VarCurr)
    <=> ( ( v33716(VarCurr,2)
        <=> $false )
        & ( v33716(VarCurr,1)
        <=> $true )
        & ( v33716(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89642(VarCurr,B)
      <=> v89644(VarCurr,B) ) ) ).

tff(addAssignment_54323,axiom,
    ! [VarCurr: state_type] :
      ( v89644(VarCurr,0)
    <=> v89661(VarCurr) ) ).

tff(addAssignment_54322,axiom,
    ! [VarCurr: state_type] :
      ( v89644(VarCurr,1)
    <=> v89659(VarCurr) ) ).

tff(addAssignment_54321,axiom,
    ! [VarCurr: state_type] :
      ( v89644(VarCurr,2)
    <=> v89654(VarCurr) ) ).

tff(addAssignment_54320,axiom,
    ! [VarCurr: state_type] :
      ( v89644(VarCurr,3)
    <=> v89647(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8548,axiom,
    ! [VarCurr: state_type] :
      ( v89659(VarCurr)
    <=> ( v89660(VarCurr)
        & v89663(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_929,axiom,
    ! [VarCurr: state_type] :
      ( v89663(VarCurr)
    <=> ( v89624(VarCurr,0)
        | v89624(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8547,axiom,
    ! [VarCurr: state_type] :
      ( v89660(VarCurr)
    <=> ( v89661(VarCurr)
        | v89662(VarCurr) ) ) ).

tff(writeUnaryOperator_4273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89662(VarCurr)
    <=> v89624(VarCurr,1) ) ).

tff(writeUnaryOperator_4272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89661(VarCurr)
    <=> v89624(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8546,axiom,
    ! [VarCurr: state_type] :
      ( v89654(VarCurr)
    <=> ( v89655(VarCurr)
        & v89658(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_928,axiom,
    ! [VarCurr: state_type] :
      ( v89658(VarCurr)
    <=> ( v89651(VarCurr)
        | v89624(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8545,axiom,
    ! [VarCurr: state_type] :
      ( v89655(VarCurr)
    <=> ( v89656(VarCurr)
        | v89657(VarCurr) ) ) ).

tff(writeUnaryOperator_4271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89657(VarCurr)
    <=> v89624(VarCurr,2) ) ).

tff(writeUnaryOperator_4270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89656(VarCurr)
    <=> v89651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8544,axiom,
    ! [VarCurr: state_type] :
      ( v89647(VarCurr)
    <=> ( v89648(VarCurr)
        & v89653(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_927,axiom,
    ! [VarCurr: state_type] :
      ( v89653(VarCurr)
    <=> ( v89650(VarCurr)
        | v89624(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8543,axiom,
    ! [VarCurr: state_type] :
      ( v89648(VarCurr)
    <=> ( v89649(VarCurr)
        | v89652(VarCurr) ) ) ).

tff(writeUnaryOperator_4269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89652(VarCurr)
    <=> v89624(VarCurr,3) ) ).

tff(writeUnaryOperator_4268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89649(VarCurr)
    <=> v89650(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_926,axiom,
    ! [VarCurr: state_type] :
      ( v89650(VarCurr)
    <=> ( v89651(VarCurr)
        & v89624(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_925,axiom,
    ! [VarCurr: state_type] :
      ( v89651(VarCurr)
    <=> ( v89624(VarCurr,0)
        & v89624(VarCurr,1) ) ) ).

tff(addAssignment_54319,axiom,
    ! [VarCurr: state_type] :
      ( v89634(VarCurr)
    <=> v89636(VarCurr) ) ).

tff(addAssignment_54318,axiom,
    ! [VarCurr: state_type] :
      ( v89636(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54317,axiom,
    ! [VarCurr: state_type] :
      ( v89630(VarCurr)
    <=> v89632(VarCurr) ) ).

tff(addAssignment_54316,axiom,
    ! [VarCurr: state_type] :
      ( v89632(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_54315,axiom,
    ! [VarCurr: state_type] :
      ( v89606(VarCurr,0)
    <=> v89607(VarCurr,0) ) ).

tff(addAssignment_54314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89607(VarCurr,B)
      <=> v89578(VarCurr,B) ) ) ).

tff(addAssignment_54313,axiom,
    ! [VarCurr: state_type] :
      ( ( v89607(VarCurr,15)
      <=> v89608(VarCurr,7) )
      & ( v89607(VarCurr,14)
      <=> v89608(VarCurr,6) )
      & ( v89607(VarCurr,13)
      <=> v89608(VarCurr,5) )
      & ( v89607(VarCurr,12)
      <=> v89608(VarCurr,4) )
      & ( v89607(VarCurr,11)
      <=> v89608(VarCurr,3) )
      & ( v89607(VarCurr,10)
      <=> v89608(VarCurr,2) )
      & ( v89607(VarCurr,9)
      <=> v89608(VarCurr,1) )
      & ( v89607(VarCurr,8)
      <=> v89608(VarCurr,0) ) ) ).

tff(addAssignment_54312,axiom,
    ! [VarCurr: state_type] :
      ( v89594(VarCurr)
    <=> v89596(VarCurr) ) ).

tff(addAssignment_54311,axiom,
    ! [VarCurr: state_type] :
      ( v89596(VarCurr)
    <=> v89598(VarCurr) ) ).

tff(addAssignment_54310,axiom,
    ! [VarCurr: state_type] :
      ( v89598(VarCurr)
    <=> v89600(VarCurr) ) ).

tff(addAssignment_54309,axiom,
    ! [VarCurr: state_type] :
      ( v89600(VarCurr)
    <=> v160(VarCurr) ) ).

tff(addAssignment_54308,axiom,
    ! [VarCurr: state_type] :
      ( v89586(VarCurr)
    <=> v89588(VarCurr) ) ).

tff(addAssignment_54307,axiom,
    ! [VarCurr: state_type] :
      ( v89588(VarCurr)
    <=> v89590(VarCurr) ) ).

tff(addAssignment_54306,axiom,
    ! [VarCurr: state_type] :
      ( v89590(VarCurr)
    <=> v89592(VarCurr) ) ).

tff(addAssignment_54305,axiom,
    ! [VarCurr: state_type] :
      ( v89592(VarCurr)
    <=> v150(VarCurr) ) ).

tff(addAssignment_54304,axiom,
    ! [VarCurr: state_type] :
      ( v89523(VarCurr)
    <=> v89525(VarCurr) ) ).

tff(addAssignment_54303,axiom,
    ! [VarCurr: state_type] :
      ( v89525(VarCurr)
    <=> v89527(VarCurr) ) ).

tff(addAssignment_54302,axiom,
    ! [VarCurr: state_type] :
      ( v89527(VarCurr)
    <=> v89529(VarCurr) ) ).

tff(addAssignment_54301,axiom,
    ! [VarCurr: state_type] :
      ( v89529(VarCurr)
    <=> v89531(VarCurr) ) ).

tff(addAssignment_54300,axiom,
    ! [VarCurr: state_type] :
      ( v89531(VarCurr)
    <=> v89533(VarCurr) ) ).

tff(addAssignment_54299,axiom,
    ! [VarCurr: state_type] :
      ( v89533(VarCurr)
    <=> v89535(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89561(VarNext)
       => ( v89535(VarNext)
        <=> v89535(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1030,axiom,
    ! [VarNext: state_type] :
      ( v89561(VarNext)
     => ( v89535(VarNext)
      <=> v89571(VarNext) ) ) ).

tff(addAssignment_54298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89571(VarNext)
      <=> v89569(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89572(VarCurr)
     => ( v89569(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_554,axiom,
    ! [VarCurr: state_type] :
      ( v89572(VarCurr)
     => ( v89569(VarCurr)
      <=> v89545(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8542,axiom,
    ! [VarCurr: state_type] :
      ( v89572(VarCurr)
    <=> ( v89573(VarCurr)
        & v89574(VarCurr) ) ) ).

tff(writeUnaryOperator_4267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89574(VarCurr)
    <=> v89541(VarCurr) ) ).

tff(writeUnaryOperator_4266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89573(VarCurr)
    <=> v89537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89561(VarNext)
      <=> v89562(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89562(VarNext)
      <=> ( v89563(VarNext)
          & v89556(VarNext) ) ) ) ).

tff(writeUnaryOperator_4265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89563(VarNext)
      <=> v89565(VarNext) ) ) ).

tff(addAssignment_54297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89565(VarNext)
      <=> v89556(VarCurr) ) ) ).

tff(addAssignment_54296,axiom,
    ! [VarCurr: state_type] :
      ( v89556(VarCurr)
    <=> v89558(VarCurr) ) ).

tff(addAssignment_54295,axiom,
    ! [VarCurr: state_type] :
      ( v89558(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_54294,axiom,
    ! [VarCurr: state_type] :
      ( v89545(VarCurr)
    <=> v89547(VarCurr) ) ).

tff(addAssignment_54293,axiom,
    ! [VarCurr: state_type] :
      ( v89547(VarCurr)
    <=> v89549(VarCurr) ) ).

tff(addAssignment_54292,axiom,
    ! [VarCurr: state_type] :
      ( v89549(VarCurr)
    <=> v89551(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34197(VarCurr)
     => ( v89551(VarCurr)
      <=> v89553(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_553,axiom,
    ! [VarCurr: state_type] :
      ( v34197(VarCurr)
     => ( v89551(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89554(VarCurr)
     => ( v89553(VarCurr)
      <=> v89531(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_552,axiom,
    ! [VarCurr: state_type] :
      ( v89554(VarCurr)
     => ( v89553(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorShiftedRanges_924,axiom,
    ! [VarCurr: state_type] :
      ( v89554(VarCurr)
    <=> ( v34406(VarCurr)
        | v4201(VarCurr,2) ) ) ).

tff(addAssignment_54291,axiom,
    ! [VarCurr: state_type] :
      ( v89541(VarCurr)
    <=> v89543(VarCurr) ) ).

tff(addAssignment_54290,axiom,
    ! [VarCurr: state_type] :
      ( v89543(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_54289,axiom,
    ! [VarCurr: state_type] :
      ( v89537(VarCurr)
    <=> v89539(VarCurr) ) ).

tff(addAssignment_54288,axiom,
    ! [VarCurr: state_type] :
      ( v89539(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8539,axiom,
    ! [VarCurr: state_type] :
      ( v89441(VarCurr)
    <=> ( v89511(VarCurr)
        & v89513(VarCurr) ) ) ).

tff(writeUnaryOperator_4264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89513(VarCurr)
    <=> v89443(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8538,axiom,
    ! [VarCurr: state_type] :
      ( v89511(VarCurr)
    <=> ( v89512(VarCurr)
        & v85794(VarCurr) ) ) ).

tff(writeUnaryOperator_4263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89512(VarCurr)
    <=> v89419(VarCurr,0) ) ).

tff(addAssignment_54287,axiom,
    ! [VarCurr: state_type] :
      ( v89443(VarCurr,7)
    <=> v89445(VarCurr,7) ) ).

tff(addAssignment_54286,axiom,
    ! [VarCurr: state_type] :
      ( v89445(VarCurr,7)
    <=> v89447(VarCurr,7) ) ).

tff(addAssignment_54285,axiom,
    ! [VarNext: state_type] :
      ( v89447(VarNext,7)
    <=> v89493(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89494(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v89493(VarNext,B)
            <=> v89447(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1029,axiom,
    ! [VarNext: state_type] :
      ( v89494(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89493(VarNext,B)
          <=> v89504(VarNext,B) ) ) ) ).

tff(addAssignment_54284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89504(VarNext,B)
          <=> v89502(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89505(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89502(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_551,axiom,
    ! [VarCurr: state_type] :
      ( v89505(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89502(VarCurr,B)
          <=> v89457(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8537,axiom,
    ! [VarCurr: state_type] :
      ( v89505(VarCurr)
    <=> ( v89506(VarCurr)
        & v89507(VarCurr) ) ) ).

tff(writeUnaryOperator_4262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89507(VarCurr)
    <=> v89453(VarCurr) ) ).

tff(writeUnaryOperator_4261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89506(VarCurr)
    <=> v89449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89494(VarNext)
      <=> v89495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89495(VarNext)
      <=> ( v89496(VarNext)
          & v89489(VarNext) ) ) ) ).

tff(writeUnaryOperator_4260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89496(VarNext)
      <=> v89498(VarNext) ) ) ).

tff(addAssignment_54283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89498(VarNext)
      <=> v89489(VarCurr) ) ) ).

tff(addAssignment_54282,axiom,
    ! [VarCurr: state_type] :
      ( v89489(VarCurr)
    <=> v89491(VarCurr) ) ).

tff(addAssignment_54281,axiom,
    ! [VarCurr: state_type] :
      ( v89491(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_54280,axiom,
    ! [VarCurr: state_type] :
      ( v89457(VarCurr,7)
    <=> v89459(VarCurr,7) ) ).

tff(addAssignment_54279,axiom,
    ! [VarCurr: state_type] :
      ( v89459(VarCurr,7)
    <=> v89461(VarCurr,7) ) ).

tff(addAssignment_54278,axiom,
    ! [VarCurr: state_type] :
      ( v89461(VarCurr,7)
    <=> v89483(VarCurr,7) ) ).

tff(addAssignment_54277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89483(VarCurr,B)
      <=> v89487(VarCurr,B) ) ) ).

tff(addAssignment_54276,axiom,
    ! [VarCurr: state_type] :
      ( ( v89483(VarCurr,5)
      <=> v89486(VarCurr,2) )
      & ( v89483(VarCurr,4)
      <=> v89486(VarCurr,1) )
      & ( v89483(VarCurr,3)
      <=> v89486(VarCurr,0) ) ) ).

tff(addAssignment_54275,axiom,
    ! [VarCurr: state_type] :
      ( v89483(VarCurr,6)
    <=> v89485(VarCurr) ) ).

tff(addAssignment_54274,axiom,
    ! [VarCurr: state_type] :
      ( v89483(VarCurr,7)
    <=> v89463(VarCurr) ) ).

tff(addAssignment_54273,axiom,
    ! [VarCurr: state_type] :
      ( v89483(VarCurr,8)
    <=> v89484(VarCurr) ) ).

tff(addAssignment_54272,axiom,
    ! [VarCurr: state_type] :
      ( v89463(VarCurr)
    <=> v89465(VarCurr) ) ).

tff(addAssignment_54271,axiom,
    ! [VarCurr: state_type] :
      ( v89465(VarCurr)
    <=> v89467(VarCurr) ) ).

tff(addAssignment_54270,axiom,
    ! [VarCurr: state_type] :
      ( v89467(VarCurr)
    <=> v89469(VarCurr) ) ).

tff(addAssignment_54269,axiom,
    ! [VarCurr: state_type] :
      ( v89469(VarCurr)
    <=> v89471(VarCurr) ) ).

tff(addAssignment_54268,axiom,
    ! [VarCurr: state_type] :
      ( v89471(VarCurr)
    <=> v3948(VarCurr,0) ) ).

tff(addAssignment_54267,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,0)
    <=> v3950(VarCurr,0) ) ).

tff(addAssignment_54266,axiom,
    ! [VarNext: state_type] :
      ( v3950(VarNext,0)
    <=> v89476(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89477(VarNext)
       => ! [B: $int] :
            ( ( $less(B,42)
              & ~ $less(B,0) )
           => ( v89476(VarNext,B)
            <=> v3950(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1028,axiom,
    ! [VarNext: state_type] :
      ( v89477(VarNext)
     => ! [B: $int] :
          ( ( $less(B,42)
            & ~ $less(B,0) )
         => ( v89476(VarNext,B)
          <=> v4046(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89477(VarNext)
      <=> v89478(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89478(VarNext)
      <=> ( v89480(VarNext)
          & v4011(VarNext) ) ) ) ).

tff(writeUnaryOperator_4259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89480(VarNext)
      <=> v4040(VarNext) ) ) ).

tff(addAssignment_54265,axiom,
    ! [VarCurr: state_type] :
      ( v3980(VarCurr,0)
    <=> v3982(VarCurr,0) ) ).

tff(addAssignment_54264,axiom,
    ! [VarCurr: state_type] :
      ( v3982(VarCurr,0)
    <=> v3987(VarCurr,0) ) ).

tff(addAssignment_54263,axiom,
    ! [VarCurr: state_type] :
      ( v4008(VarCurr)
    <=> v89474(VarCurr) ) ).

tff(addAssignment_54262,axiom,
    ! [VarCurr: state_type] :
      ( v89474(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_54261,axiom,
    ! [VarCurr: state_type] :
      ( v89453(VarCurr)
    <=> v89455(VarCurr) ) ).

tff(addAssignment_54260,axiom,
    ! [VarCurr: state_type] :
      ( v89455(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_54259,axiom,
    ! [VarCurr: state_type] :
      ( v89449(VarCurr)
    <=> v89451(VarCurr) ) ).

tff(addAssignment_54258,axiom,
    ! [VarCurr: state_type] :
      ( v89451(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_54257,axiom,
    ! [VarCurr: state_type] :
      ( v89429(VarCurr)
    <=> v89431(VarCurr) ) ).

tff(addAssignment_54256,axiom,
    ! [VarCurr: state_type] :
      ( v89431(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_54255,axiom,
    ! [VarCurr: state_type] :
      ( v89425(VarCurr)
    <=> v89427(VarCurr) ) ).

tff(addAssignment_54254,axiom,
    ! [VarCurr: state_type] :
      ( v89427(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_54253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v89249(VarCurr,B)
      <=> v89251(VarCurr,B) ) ) ).

tff(addAssignment_54252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v89251(VarCurr,B)
      <=> v84901(VarCurr,B) ) ) ).

tff(addAssignment_54251,axiom,
    ! [VarCurr: state_type] :
      ( v89393(VarCurr)
    <=> v89395(VarCurr) ) ).

tff(addAssignment_54250,axiom,
    ! [VarCurr: state_type] :
      ( v89395(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_54249,axiom,
    ! [VarCurr: state_type] :
      ( v89389(VarCurr)
    <=> v89391(VarCurr) ) ).

tff(addAssignment_54248,axiom,
    ! [VarCurr: state_type] :
      ( v89391(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_54247,axiom,
    ! [VarCurr: state_type] :
      ( v134(VarCurr,7)
    <=> v89340(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89340(VarCurr,B)
      <=> ( v89341(VarCurr,B)
          | v89379(VarCurr,B) ) ) ) ).

tff(addAssignment_54246,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,0)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54245,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,1)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54244,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,2)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54243,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,3)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54242,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,4)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54241,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,5)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54240,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,6)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54239,axiom,
    ! [VarCurr: state_type] :
      ( v89379(VarCurr,7)
    <=> v89380(VarCurr) ) ).

tff(addAssignment_54238,axiom,
    ! [VarCurr: state_type] :
      ( v89380(VarCurr)
    <=> v89381(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_471,axiom,
    ! [VarCurr: state_type] :
      ( v89381(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $true )
        & ( v136(VarCurr,2)
        <=> $false )
        & ( v136(VarCurr,1)
        <=> $false )
        & ( v136(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v89341(VarCurr,B)
      <=> ( v89342(VarCurr,B)
          | v89375(VarCurr,B) ) ) ) ).

tff(addAssignment_54237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v89375(VarCurr,B)
      <=> v89376(VarCurr,B) ) ) ).

tff(addAssignment_54236,axiom,
    ! [VarCurr: state_type] :
      ( v89375(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_54235,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,0)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54234,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,1)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54233,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,2)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54232,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,3)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54231,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,4)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54230,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,5)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54229,axiom,
    ! [VarCurr: state_type] :
      ( v89376(VarCurr,6)
    <=> v89377(VarCurr) ) ).

tff(addAssignment_54228,axiom,
    ! [VarCurr: state_type] :
      ( v89377(VarCurr)
    <=> v89378(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_470,axiom,
    ! [VarCurr: state_type] :
      ( v89378(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $true )
        & ( v136(VarCurr,1)
        <=> $true )
        & ( v136(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_14,axiom,
    ! [VarCurr: state_type] : ~ v89342(VarCurr,7) ).

tff(addAssignment_54227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v89342(VarCurr,B)
      <=> v89343(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v89343(VarCurr,B)
      <=> ( v89344(VarCurr,B)
          | v89371(VarCurr,B) ) ) ) ).

tff(addAssignment_54226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89371(VarCurr,B)
      <=> v89372(VarCurr,B) ) ) ).

tff(addAssignment_54225,axiom,
    ! [VarCurr: state_type] :
      ( v89371(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_54224,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,0)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54223,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,1)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54222,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,2)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54221,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,3)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54220,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,4)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54219,axiom,
    ! [VarCurr: state_type] :
      ( v89372(VarCurr,5)
    <=> v89373(VarCurr) ) ).

tff(addAssignment_54218,axiom,
    ! [VarCurr: state_type] :
      ( v89373(VarCurr)
    <=> v89374(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_469,axiom,
    ! [VarCurr: state_type] :
      ( v89374(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $true )
        & ( v136(VarCurr,1)
        <=> $true )
        & ( v136(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_13,axiom,
    ! [VarCurr: state_type] : ~ v89344(VarCurr,6) ).

tff(addAssignment_54217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89344(VarCurr,B)
      <=> v89345(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89345(VarCurr,B)
      <=> ( v89346(VarCurr,B)
          | v89367(VarCurr,B) ) ) ) ).

tff(addAssignment_54216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v89367(VarCurr,B)
      <=> v89368(VarCurr,B) ) ) ).

tff(addAssignment_54215,axiom,
    ! [VarCurr: state_type] :
      ( v89367(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_54214,axiom,
    ! [VarCurr: state_type] :
      ( v89368(VarCurr,0)
    <=> v89369(VarCurr) ) ).

tff(addAssignment_54213,axiom,
    ! [VarCurr: state_type] :
      ( v89368(VarCurr,1)
    <=> v89369(VarCurr) ) ).

tff(addAssignment_54212,axiom,
    ! [VarCurr: state_type] :
      ( v89368(VarCurr,2)
    <=> v89369(VarCurr) ) ).

tff(addAssignment_54211,axiom,
    ! [VarCurr: state_type] :
      ( v89368(VarCurr,3)
    <=> v89369(VarCurr) ) ).

tff(addAssignment_54210,axiom,
    ! [VarCurr: state_type] :
      ( v89368(VarCurr,4)
    <=> v89369(VarCurr) ) ).

tff(addAssignment_54209,axiom,
    ! [VarCurr: state_type] :
      ( v89369(VarCurr)
    <=> v89370(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_468,axiom,
    ! [VarCurr: state_type] :
      ( v89370(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $true )
        & ( v136(VarCurr,1)
        <=> $false )
        & ( v136(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_12,axiom,
    ! [VarCurr: state_type] : ~ v89346(VarCurr,5) ).

tff(addAssignment_54208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v89346(VarCurr,B)
      <=> v89347(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v89347(VarCurr,B)
      <=> ( v89348(VarCurr,B)
          | v89363(VarCurr,B) ) ) ) ).

tff(addAssignment_54207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89363(VarCurr,B)
      <=> v89364(VarCurr,B) ) ) ).

tff(addAssignment_54206,axiom,
    ! [VarCurr: state_type] :
      ( v89363(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_54205,axiom,
    ! [VarCurr: state_type] :
      ( v89364(VarCurr,0)
    <=> v89365(VarCurr) ) ).

tff(addAssignment_54204,axiom,
    ! [VarCurr: state_type] :
      ( v89364(VarCurr,1)
    <=> v89365(VarCurr) ) ).

tff(addAssignment_54203,axiom,
    ! [VarCurr: state_type] :
      ( v89364(VarCurr,2)
    <=> v89365(VarCurr) ) ).

tff(addAssignment_54202,axiom,
    ! [VarCurr: state_type] :
      ( v89364(VarCurr,3)
    <=> v89365(VarCurr) ) ).

tff(addAssignment_54201,axiom,
    ! [VarCurr: state_type] :
      ( v89365(VarCurr)
    <=> v89366(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_467,axiom,
    ! [VarCurr: state_type] :
      ( v89366(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $true )
        & ( v136(VarCurr,1)
        <=> $false )
        & ( v136(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_11,axiom,
    ! [VarCurr: state_type] : ~ v89348(VarCurr,4) ).

tff(addAssignment_54200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89348(VarCurr,B)
      <=> v89349(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v89349(VarCurr,B)
      <=> ( v89350(VarCurr,B)
          | v89359(VarCurr,B) ) ) ) ).

tff(addAssignment_54199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89359(VarCurr,B)
      <=> v89360(VarCurr,B) ) ) ).

tff(addAssignment_54198,axiom,
    ! [VarCurr: state_type] :
      ( v89359(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_54197,axiom,
    ! [VarCurr: state_type] :
      ( v89360(VarCurr,0)
    <=> v89361(VarCurr) ) ).

tff(addAssignment_54196,axiom,
    ! [VarCurr: state_type] :
      ( v89360(VarCurr,1)
    <=> v89361(VarCurr) ) ).

tff(addAssignment_54195,axiom,
    ! [VarCurr: state_type] :
      ( v89360(VarCurr,2)
    <=> v89361(VarCurr) ) ).

tff(addAssignment_54194,axiom,
    ! [VarCurr: state_type] :
      ( v89361(VarCurr)
    <=> v89362(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_466,axiom,
    ! [VarCurr: state_type] :
      ( v89362(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $false )
        & ( v136(VarCurr,1)
        <=> $true )
        & ( v136(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_10,axiom,
    ! [VarCurr: state_type] : ~ v89350(VarCurr,3) ).

tff(addAssignment_54193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89350(VarCurr,B)
      <=> v89351(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89351(VarCurr,B)
      <=> ( v89352(VarCurr,B)
          | v89355(VarCurr,B) ) ) ) ).

tff(addAssignment_54192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89355(VarCurr,B)
      <=> v89356(VarCurr,B) ) ) ).

tff(addAssignment_54191,axiom,
    ! [VarCurr: state_type] :
      ( v89355(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_54190,axiom,
    ! [VarCurr: state_type] :
      ( v89356(VarCurr,0)
    <=> v89357(VarCurr) ) ).

tff(addAssignment_54189,axiom,
    ! [VarCurr: state_type] :
      ( v89356(VarCurr,1)
    <=> v89357(VarCurr) ) ).

tff(addAssignment_54188,axiom,
    ! [VarCurr: state_type] :
      ( v89357(VarCurr)
    <=> v89358(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_465,axiom,
    ! [VarCurr: state_type] :
      ( v89358(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $false )
        & ( v136(VarCurr,1)
        <=> $true )
        & ( v136(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_9,axiom,
    ! [VarCurr: state_type] : ~ v89352(VarCurr,2) ).

tff(addAssignment_54187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89352(VarCurr,B)
      <=> v89353(VarCurr,B) ) ) ).

tff(addAssignment_54186,axiom,
    ! [VarCurr: state_type] :
      ( v89353(VarCurr,0)
    <=> v89354(VarCurr) ) ).

tff(addAssignment_54185,axiom,
    ! [VarCurr: state_type] :
      ( v89353(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_464,axiom,
    ! [VarCurr: state_type] :
      ( v89354(VarCurr)
    <=> ( ( v136(VarCurr,3)
        <=> $false )
        & ( v136(VarCurr,2)
        <=> $false )
        & ( v136(VarCurr,1)
        <=> $false )
        & ( v136(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89271(VarCurr,B)
      <=> v89273(VarCurr,B) ) ) ).

tff(addAssignment_54183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89273(VarCurr,B)
      <=> v89275(VarCurr,B) ) ) ).

tff(addAssignment_54182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89275(VarCurr,B)
      <=> v89333(VarCurr,B) ) ) ).

tff(addAssignment_54181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v89333(VarCurr,B)
      <=> v89277(VarCurr,B) ) ) ).

tff(addAssignment_54180,axiom,
    ! [VarCurr: state_type] :
      ( v89333(VarCurr,2)
    <=> v89335(VarCurr) ) ).

tff(addAssignment_54179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,3) )
     => ( v89333(VarCurr,B)
      <=> v89277(VarCurr,B) ) ) ).

tff(addAssignment_54178,axiom,
    ! [VarCurr: state_type] :
      ( ( v89333(VarCurr,11)
      <=> v89334(VarCurr,2) )
      & ( v89333(VarCurr,10)
      <=> v89334(VarCurr,1) )
      & ( v89333(VarCurr,9)
      <=> v89334(VarCurr,0) ) ) ).

tff(addAssignment_54177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89277(VarCurr,B)
      <=> v89279(VarCurr,B) ) ) ).

tff(addAssignment_54176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89279(VarCurr,B)
      <=> v89281(VarCurr,B) ) ) ).

tff(addAssignment_54175,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89281(VarNext,B)
      <=> v89316(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89317(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v89316(VarNext,B)
            <=> v89281(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1027,axiom,
    ! [VarNext: state_type] :
      ( v89317(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89316(VarNext,B)
          <=> v89327(VarNext,B) ) ) ) ).

tff(addAssignment_54174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89327(VarNext,B)
          <=> v89325(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89328(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89325(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_550,axiom,
    ! [VarCurr: state_type] :
      ( v89328(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v89325(VarCurr,B)
          <=> v89291(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8532,axiom,
    ! [VarCurr: state_type] :
      ( v89328(VarCurr)
    <=> ( v89329(VarCurr)
        & v89330(VarCurr) ) ) ).

tff(writeUnaryOperator_4258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89330(VarCurr)
    <=> v89287(VarCurr) ) ).

tff(writeUnaryOperator_4257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89329(VarCurr)
    <=> v89283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89317(VarNext)
      <=> v89318(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89318(VarNext)
      <=> ( v89319(VarNext)
          & v89312(VarNext) ) ) ) ).

tff(writeUnaryOperator_4256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89319(VarNext)
      <=> v89321(VarNext) ) ) ).

tff(addAssignment_54173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89321(VarNext)
      <=> v89312(VarCurr) ) ) ).

tff(addAssignment_54172,axiom,
    ! [VarCurr: state_type] :
      ( v89312(VarCurr)
    <=> v89314(VarCurr) ) ).

tff(addAssignment_54171,axiom,
    ! [VarCurr: state_type] :
      ( v89314(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_54170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89291(VarCurr,B)
      <=> v89293(VarCurr,B) ) ) ).

tff(addAssignment_54169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89293(VarCurr,B)
      <=> v89295(VarCurr,B) ) ) ).

tff(addAssignment_54168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v89295(VarCurr,B)
      <=> v89306(VarCurr,B) ) ) ).

tff(addAssignment_54167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89306(VarCurr,B)
      <=> v89310(VarCurr,B) ) ) ).

tff(addAssignment_54166,axiom,
    ! [VarCurr: state_type] :
      ( ( v89306(VarCurr,5)
      <=> v89297(VarCurr,2) )
      & ( v89306(VarCurr,4)
      <=> v89297(VarCurr,1) )
      & ( v89306(VarCurr,3)
      <=> v89297(VarCurr,0) ) ) ).

tff(addAssignment_54165,axiom,
    ! [VarCurr: state_type] :
      ( v89306(VarCurr,6)
    <=> v89309(VarCurr) ) ).

tff(addAssignment_54164,axiom,
    ! [VarCurr: state_type] :
      ( v89306(VarCurr,7)
    <=> v89308(VarCurr) ) ).

tff(addAssignment_54163,axiom,
    ! [VarCurr: state_type] :
      ( v89306(VarCurr,8)
    <=> v89307(VarCurr) ) ).

tff(addAssignment_54162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89297(VarCurr,B)
      <=> v89299(VarCurr,B) ) ) ).

tff(addAssignment_54161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89299(VarCurr,B)
      <=> v89301(VarCurr,B) ) ) ).

tff(addAssignment_54160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89301(VarCurr,B)
      <=> v89303(VarCurr,B) ) ) ).

tff(addAssignment_54159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89303(VarCurr,B)
      <=> v89305(VarCurr,B) ) ) ).

tff(addAssignment_54158,axiom,
    ! [VarCurr: state_type] :
      ( ( v89305(VarCurr,2)
      <=> v3948(VarCurr,28) )
      & ( v89305(VarCurr,1)
      <=> v3948(VarCurr,27) )
      & ( v89305(VarCurr,0)
      <=> v3948(VarCurr,26) ) ) ).

tff(addAssignment_54157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,29)
        & ~ $less(B,26) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_54156,axiom,
    ! [VarCurr: state_type] :
      ( v89287(VarCurr)
    <=> v89289(VarCurr) ) ).

tff(addAssignment_54155,axiom,
    ! [VarCurr: state_type] :
      ( v89289(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_54154,axiom,
    ! [VarCurr: state_type] :
      ( v89283(VarCurr)
    <=> v89285(VarCurr) ) ).

tff(addAssignment_54153,axiom,
    ! [VarCurr: state_type] :
      ( v89285(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_54152,axiom,
    ! [VarCurr: state_type] :
      ( v89263(VarCurr)
    <=> v89265(VarCurr) ) ).

tff(addAssignment_54151,axiom,
    ! [VarCurr: state_type] :
      ( v89265(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_54150,axiom,
    ! [VarCurr: state_type] :
      ( v89259(VarCurr)
    <=> v89261(VarCurr) ) ).

tff(addAssignment_54149,axiom,
    ! [VarCurr: state_type] :
      ( v89261(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_54148,axiom,
    ! [VarCurr: state_type] :
      ( v89249(VarCurr,7)
    <=> v89251(VarCurr,7) ) ).

tff(addAssignment_54147,axiom,
    ! [VarCurr: state_type] :
      ( v89251(VarCurr,7)
    <=> v84901(VarCurr,7) ) ).

tff(addAssignment_54146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v89214(VarCurr,B)
      <=> v89216(VarCurr,B) ) ) ).

tff(addAssignment_54145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,4) )
     => ( v89216(VarCurr,B)
      <=> v89218(VarCurr,B) ) ) ).

tff(addAssignment_54144,axiom,
    ! [VarCurr: state_type] :
      ( ( v89218(VarCurr,6)
      <=> v89219(VarCurr,2) )
      & ( v89218(VarCurr,5)
      <=> v89219(VarCurr,1) )
      & ( v89218(VarCurr,4)
      <=> v89219(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89219(VarCurr,B)
      <=> ( v89220(VarCurr,B)
          | v89240(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_923,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,0)
    <=> ( v89241(VarCurr,0)
        & v85128(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_922,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,1)
    <=> ( v89241(VarCurr,1)
        & v85128(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_921,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,2)
    <=> ( v89241(VarCurr,2)
        & v85128(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_920,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,3)
    <=> ( v89241(VarCurr,3)
        & v85128(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_919,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,4)
    <=> ( v89241(VarCurr,4)
        & v85128(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_918,axiom,
    ! [VarCurr: state_type] :
      ( v89240(VarCurr,5)
    <=> ( v89241(VarCurr,5)
        & v85128(VarCurr,8) ) ) ).

tff(addAssignment_54143,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,0)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_54142,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,1)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_54141,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,2)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_54140,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,3)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_54139,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,4)
    <=> v84975(VarCurr,0) ) ).

tff(addAssignment_54138,axiom,
    ! [VarCurr: state_type] :
      ( v89241(VarCurr,5)
    <=> v84975(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89220(VarCurr,B)
      <=> ( v89221(VarCurr,B)
          | v89238(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_917,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,0)
    <=> ( v89239(VarCurr,0)
        & v85150(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_916,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,1)
    <=> ( v89239(VarCurr,1)
        & v85150(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_915,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,2)
    <=> ( v89239(VarCurr,2)
        & v85150(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_914,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,3)
    <=> ( v89239(VarCurr,3)
        & v85150(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_913,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,4)
    <=> ( v89239(VarCurr,4)
        & v85150(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_912,axiom,
    ! [VarCurr: state_type] :
      ( v89238(VarCurr,5)
    <=> ( v89239(VarCurr,5)
        & v85150(VarCurr,8) ) ) ).

tff(addAssignment_54137,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,0)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_54136,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,1)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_54135,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,2)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_54134,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,3)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_54133,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,4)
    <=> v84975(VarCurr,1) ) ).

tff(addAssignment_54132,axiom,
    ! [VarCurr: state_type] :
      ( v89239(VarCurr,5)
    <=> v84975(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89221(VarCurr,B)
      <=> ( v89222(VarCurr,B)
          | v89236(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_911,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,0)
    <=> ( v89237(VarCurr,0)
        & v85172(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_910,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,1)
    <=> ( v89237(VarCurr,1)
        & v85172(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_909,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,2)
    <=> ( v89237(VarCurr,2)
        & v85172(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_908,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,3)
    <=> ( v89237(VarCurr,3)
        & v85172(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_907,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,4)
    <=> ( v89237(VarCurr,4)
        & v85172(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_906,axiom,
    ! [VarCurr: state_type] :
      ( v89236(VarCurr,5)
    <=> ( v89237(VarCurr,5)
        & v85172(VarCurr,8) ) ) ).

tff(addAssignment_54131,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,0)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_54130,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,1)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_54129,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,2)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_54128,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,3)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_54127,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,4)
    <=> v84975(VarCurr,2) ) ).

tff(addAssignment_54126,axiom,
    ! [VarCurr: state_type] :
      ( v89237(VarCurr,5)
    <=> v84975(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89222(VarCurr,B)
      <=> ( v89223(VarCurr,B)
          | v89234(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_905,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,0)
    <=> ( v89235(VarCurr,0)
        & v85194(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_904,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,1)
    <=> ( v89235(VarCurr,1)
        & v85194(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_903,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,2)
    <=> ( v89235(VarCurr,2)
        & v85194(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_902,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,3)
    <=> ( v89235(VarCurr,3)
        & v85194(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_901,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,4)
    <=> ( v89235(VarCurr,4)
        & v85194(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_900,axiom,
    ! [VarCurr: state_type] :
      ( v89234(VarCurr,5)
    <=> ( v89235(VarCurr,5)
        & v85194(VarCurr,8) ) ) ).

tff(addAssignment_54125,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,0)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_54124,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,1)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_54123,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,2)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_54122,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,3)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_54121,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,4)
    <=> v84975(VarCurr,3) ) ).

tff(addAssignment_54120,axiom,
    ! [VarCurr: state_type] :
      ( v89235(VarCurr,5)
    <=> v84975(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89223(VarCurr,B)
      <=> ( v89224(VarCurr,B)
          | v89232(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_899,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,0)
    <=> ( v89233(VarCurr,0)
        & v85216(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_898,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,1)
    <=> ( v89233(VarCurr,1)
        & v85216(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_897,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,2)
    <=> ( v89233(VarCurr,2)
        & v85216(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_896,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,3)
    <=> ( v89233(VarCurr,3)
        & v85216(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_895,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,4)
    <=> ( v89233(VarCurr,4)
        & v85216(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_894,axiom,
    ! [VarCurr: state_type] :
      ( v89232(VarCurr,5)
    <=> ( v89233(VarCurr,5)
        & v85216(VarCurr,8) ) ) ).

tff(addAssignment_54119,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,0)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_54118,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,1)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_54117,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,2)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_54116,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,3)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_54115,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,4)
    <=> v84975(VarCurr,4) ) ).

tff(addAssignment_54114,axiom,
    ! [VarCurr: state_type] :
      ( v89233(VarCurr,5)
    <=> v84975(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89224(VarCurr,B)
      <=> ( v89225(VarCurr,B)
          | v89230(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_893,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,0)
    <=> ( v89231(VarCurr,0)
        & v85238(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_892,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,1)
    <=> ( v89231(VarCurr,1)
        & v85238(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_891,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,2)
    <=> ( v89231(VarCurr,2)
        & v85238(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_890,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,3)
    <=> ( v89231(VarCurr,3)
        & v85238(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_889,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,4)
    <=> ( v89231(VarCurr,4)
        & v85238(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_888,axiom,
    ! [VarCurr: state_type] :
      ( v89230(VarCurr,5)
    <=> ( v89231(VarCurr,5)
        & v85238(VarCurr,8) ) ) ).

tff(addAssignment_54113,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,0)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_54112,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,1)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_54111,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,2)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_54110,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,3)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_54109,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,4)
    <=> v84975(VarCurr,5) ) ).

tff(addAssignment_54108,axiom,
    ! [VarCurr: state_type] :
      ( v89231(VarCurr,5)
    <=> v84975(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v89225(VarCurr,B)
      <=> ( v89226(VarCurr,B)
          | v89228(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorShiftedRanges_887,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,0)
    <=> ( v89229(VarCurr,0)
        & v85260(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_886,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,1)
    <=> ( v89229(VarCurr,1)
        & v85260(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_885,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,2)
    <=> ( v89229(VarCurr,2)
        & v85260(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_884,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,3)
    <=> ( v89229(VarCurr,3)
        & v85260(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_883,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,4)
    <=> ( v89229(VarCurr,4)
        & v85260(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_882,axiom,
    ! [VarCurr: state_type] :
      ( v89228(VarCurr,5)
    <=> ( v89229(VarCurr,5)
        & v85260(VarCurr,8) ) ) ).

tff(addAssignment_54107,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,0)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_54106,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,1)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_54105,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,2)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_54104,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,3)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_54103,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,4)
    <=> v84975(VarCurr,6) ) ).

tff(addAssignment_54102,axiom,
    ! [VarCurr: state_type] :
      ( v89229(VarCurr,5)
    <=> v84975(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_881,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,0)
    <=> ( v89227(VarCurr,0)
        & v85282(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_880,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,1)
    <=> ( v89227(VarCurr,1)
        & v85282(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_879,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,2)
    <=> ( v89227(VarCurr,2)
        & v85282(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_878,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,3)
    <=> ( v89227(VarCurr,3)
        & v85282(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_877,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,4)
    <=> ( v89227(VarCurr,4)
        & v85282(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_876,axiom,
    ! [VarCurr: state_type] :
      ( v89226(VarCurr,5)
    <=> ( v89227(VarCurr,5)
        & v85282(VarCurr,8) ) ) ).

tff(addAssignment_54101,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,0)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54100,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,1)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54099,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,2)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54098,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,3)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54097,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,4)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54096,axiom,
    ! [VarCurr: state_type] :
      ( v89227(VarCurr,5)
    <=> v84975(VarCurr,7) ) ).

tff(addAssignment_54095,axiom,
    ! [VarCurr: state_type] :
      ( v89200(VarCurr)
    <=> v89202(VarCurr) ) ).

tff(addAssignment_54094,axiom,
    ! [VarCurr: state_type] :
      ( v89202(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_54093,axiom,
    ! [VarCurr: state_type] :
      ( v89196(VarCurr)
    <=> v89198(VarCurr) ) ).

tff(addAssignment_54092,axiom,
    ! [VarCurr: state_type] :
      ( v89198(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_54091,axiom,
    ! [VarCurr: state_type] :
      ( v89174(VarCurr)
    <=> v89176(VarCurr) ) ).

tff(addAssignment_54090,axiom,
    ! [VarCurr: state_type] :
      ( v89176(VarCurr)
    <=> v89178(VarCurr) ) ).

tff(addAssignment_54089,axiom,
    ! [VarCurr: state_type] :
      ( v89178(VarCurr)
    <=> v89180(VarCurr) ) ).

tff(addAssignment_54088,axiom,
    ! [VarCurr: state_type] :
      ( v89180(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_54087,axiom,
    ! [VarCurr: state_type] :
      ( v89166(VarCurr)
    <=> v89168(VarCurr) ) ).

tff(addAssignment_54086,axiom,
    ! [VarCurr: state_type] :
      ( v89168(VarCurr)
    <=> v89170(VarCurr) ) ).

tff(addAssignment_54085,axiom,
    ! [VarCurr: state_type] :
      ( v89170(VarCurr)
    <=> v89172(VarCurr) ) ).

tff(addAssignment_54084,axiom,
    ! [VarCurr: state_type] :
      ( v89172(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_54083,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,0)
    <=> v89151(VarCurr) ) ).

tff(addAssignment_54082,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,1)
    <=> v89149(VarCurr) ) ).

tff(addAssignment_54081,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,2)
    <=> v89147(VarCurr) ) ).

tff(addAssignment_54080,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,3)
    <=> v89145(VarCurr) ) ).

tff(addAssignment_54079,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,4)
    <=> v89143(VarCurr) ) ).

tff(addAssignment_54078,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,5)
    <=> v89141(VarCurr) ) ).

tff(addAssignment_54077,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,6)
    <=> v89139(VarCurr) ) ).

tff(addAssignment_54076,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,7)
    <=> v89137(VarCurr) ) ).

tff(addAssignment_54075,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,8)
    <=> v89135(VarCurr) ) ).

tff(addAssignment_54074,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,9)
    <=> v89133(VarCurr) ) ).

tff(addAssignment_54073,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,10)
    <=> v89131(VarCurr) ) ).

tff(addAssignment_54072,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,11)
    <=> v89129(VarCurr) ) ).

tff(addAssignment_54071,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,12)
    <=> v89127(VarCurr) ) ).

tff(addAssignment_54070,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,13)
    <=> v89125(VarCurr) ) ).

tff(addAssignment_54069,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,14)
    <=> v89123(VarCurr) ) ).

tff(addAssignment_54068,axiom,
    ! [VarCurr: state_type] :
      ( v89119(VarCurr,15)
    <=> v89121(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_463,axiom,
    ! [VarCurr: state_type] :
      ( v89151(VarCurr)
    <=> ( ( v89152(VarCurr,3)
        <=> $false )
        & ( v89152(VarCurr,2)
        <=> $false )
        & ( v89152(VarCurr,1)
        <=> $false )
        & ( v89152(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89152(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54066,axiom,
    ! [VarCurr: state_type] :
      ( v89152(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_462,axiom,
    ! [VarCurr: state_type] :
      ( v89149(VarCurr)
    <=> ( ( v89150(VarCurr,3)
        <=> $false )
        & ( v89150(VarCurr,2)
        <=> $false )
        & ( v89150(VarCurr,1)
        <=> $false )
        & ( v89150(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89150(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54064,axiom,
    ! [VarCurr: state_type] :
      ( v89150(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_461,axiom,
    ! [VarCurr: state_type] :
      ( v89147(VarCurr)
    <=> ( ( v89148(VarCurr,3)
        <=> $false )
        & ( v89148(VarCurr,2)
        <=> $false )
        & ( v89148(VarCurr,1)
        <=> $true )
        & ( v89148(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89148(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54062,axiom,
    ! [VarCurr: state_type] :
      ( v89148(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_460,axiom,
    ! [VarCurr: state_type] :
      ( v89145(VarCurr)
    <=> ( ( v89146(VarCurr,3)
        <=> $false )
        & ( v89146(VarCurr,2)
        <=> $false )
        & ( v89146(VarCurr,1)
        <=> $true )
        & ( v89146(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89146(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54060,axiom,
    ! [VarCurr: state_type] :
      ( v89146(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_459,axiom,
    ! [VarCurr: state_type] :
      ( v89143(VarCurr)
    <=> ( ( v89144(VarCurr,3)
        <=> $false )
        & ( v89144(VarCurr,2)
        <=> $true )
        & ( v89144(VarCurr,1)
        <=> $false )
        & ( v89144(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89144(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54058,axiom,
    ! [VarCurr: state_type] :
      ( v89144(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_458,axiom,
    ! [VarCurr: state_type] :
      ( v89141(VarCurr)
    <=> ( ( v89142(VarCurr,3)
        <=> $false )
        & ( v89142(VarCurr,2)
        <=> $true )
        & ( v89142(VarCurr,1)
        <=> $false )
        & ( v89142(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89142(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54056,axiom,
    ! [VarCurr: state_type] :
      ( v89142(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_457,axiom,
    ! [VarCurr: state_type] :
      ( v89139(VarCurr)
    <=> ( ( v89140(VarCurr,3)
        <=> $false )
        & ( v89140(VarCurr,2)
        <=> $true )
        & ( v89140(VarCurr,1)
        <=> $true )
        & ( v89140(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89140(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54054,axiom,
    ! [VarCurr: state_type] :
      ( v89140(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_456,axiom,
    ! [VarCurr: state_type] :
      ( v89137(VarCurr)
    <=> ( ( v89138(VarCurr,3)
        <=> $false )
        & ( v89138(VarCurr,2)
        <=> $true )
        & ( v89138(VarCurr,1)
        <=> $true )
        & ( v89138(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89138(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54052,axiom,
    ! [VarCurr: state_type] :
      ( v89138(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_455,axiom,
    ! [VarCurr: state_type] :
      ( v89135(VarCurr)
    <=> ( ( v89136(VarCurr,3)
        <=> $true )
        & ( v89136(VarCurr,2)
        <=> $false )
        & ( v89136(VarCurr,1)
        <=> $false )
        & ( v89136(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89136(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54050,axiom,
    ! [VarCurr: state_type] :
      ( v89136(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_454,axiom,
    ! [VarCurr: state_type] :
      ( v89133(VarCurr)
    <=> ( ( v89134(VarCurr,3)
        <=> $true )
        & ( v89134(VarCurr,2)
        <=> $false )
        & ( v89134(VarCurr,1)
        <=> $false )
        & ( v89134(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89134(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54048,axiom,
    ! [VarCurr: state_type] :
      ( v89134(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_453,axiom,
    ! [VarCurr: state_type] :
      ( v89131(VarCurr)
    <=> ( ( v89132(VarCurr,3)
        <=> $true )
        & ( v89132(VarCurr,2)
        <=> $false )
        & ( v89132(VarCurr,1)
        <=> $true )
        & ( v89132(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89132(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54046,axiom,
    ! [VarCurr: state_type] :
      ( v89132(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_452,axiom,
    ! [VarCurr: state_type] :
      ( v89129(VarCurr)
    <=> ( ( v89130(VarCurr,3)
        <=> $true )
        & ( v89130(VarCurr,2)
        <=> $false )
        & ( v89130(VarCurr,1)
        <=> $true )
        & ( v89130(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89130(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54044,axiom,
    ! [VarCurr: state_type] :
      ( v89130(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_451,axiom,
    ! [VarCurr: state_type] :
      ( v89127(VarCurr)
    <=> ( ( v89128(VarCurr,3)
        <=> $true )
        & ( v89128(VarCurr,2)
        <=> $true )
        & ( v89128(VarCurr,1)
        <=> $false )
        & ( v89128(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89128(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54042,axiom,
    ! [VarCurr: state_type] :
      ( v89128(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_450,axiom,
    ! [VarCurr: state_type] :
      ( v89125(VarCurr)
    <=> ( ( v89126(VarCurr,3)
        <=> $true )
        & ( v89126(VarCurr,2)
        <=> $true )
        & ( v89126(VarCurr,1)
        <=> $false )
        & ( v89126(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89126(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54040,axiom,
    ! [VarCurr: state_type] :
      ( v89126(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_449,axiom,
    ! [VarCurr: state_type] :
      ( v89123(VarCurr)
    <=> ( ( v89124(VarCurr,3)
        <=> $true )
        & ( v89124(VarCurr,2)
        <=> $true )
        & ( v89124(VarCurr,1)
        <=> $true )
        & ( v89124(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_54039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89124(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54038,axiom,
    ! [VarCurr: state_type] :
      ( v89124(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_448,axiom,
    ! [VarCurr: state_type] :
      ( v89121(VarCurr)
    <=> ( ( v89122(VarCurr,3)
        <=> $true )
        & ( v89122(VarCurr,2)
        <=> $true )
        & ( v89122(VarCurr,1)
        <=> $true )
        & ( v89122(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89122(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54036,axiom,
    ! [VarCurr: state_type] :
      ( v89122(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v86881(VarCurr,B)
      <=> ( v86883(VarCurr,B)
          & v89082(VarCurr,B) ) ) ) ).

tff(addAssignment_54035,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,0)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54034,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,1)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54033,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,2)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54032,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,3)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54031,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,4)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54030,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,5)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54029,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,6)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54028,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,7)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54027,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,8)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54026,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,9)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54025,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,10)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54024,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,11)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54023,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,12)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54022,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,13)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54021,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,14)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54020,axiom,
    ! [VarCurr: state_type] :
      ( v89082(VarCurr,15)
    <=> v89083(VarCurr) ) ).

tff(addAssignment_54019,axiom,
    ! [VarCurr: state_type] :
      ( v89083(VarCurr)
    <=> v89084(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_875,axiom,
    ! [VarCurr: state_type] :
      ( v89084(VarCurr)
    <=> ( v89085(VarCurr)
        | v84297(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8529,axiom,
    ! [VarCurr: state_type] :
      ( v89085(VarCurr)
    <=> ( v89086(VarCurr)
        & v89115(VarCurr) ) ) ).

tff(writeUnaryOperator_4255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89115(VarCurr)
    <=> v84488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8528,axiom,
    ! [VarCurr: state_type] :
      ( v89086(VarCurr)
    <=> ( v89087(VarCurr)
        & v89114(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_874,axiom,
    ! [VarCurr: state_type] :
      ( v89114(VarCurr)
    <=> ( v84297(VarCurr,2)
        | v84297(VarCurr,4) ) ) ).

tff(writeUnaryOperator_4254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89087(VarCurr)
    <=> v89089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8527,axiom,
    ! [VarCurr: state_type] :
      ( v89089(VarCurr)
    <=> ( v89090(VarCurr)
        & v89108(VarCurr) ) ) ).

tff(writeUnaryOperator_4253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89108(VarCurr)
    <=> v89109(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8526,axiom,
    ! [VarCurr: state_type] :
      ( v89109(VarCurr)
    <=> ( v89110(VarCurr)
        & v89113(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_873,axiom,
    ! [VarCurr: state_type] :
      ( v89113(VarCurr)
    <=> ( v88372(VarCurr,3)
        | v89096(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8525,axiom,
    ! [VarCurr: state_type] :
      ( v89110(VarCurr)
    <=> ( v89111(VarCurr)
        | v89112(VarCurr) ) ) ).

tff(writeUnaryOperator_4252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89112(VarCurr)
    <=> v89096(VarCurr,3) ) ).

tff(writeUnaryOperator_4251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89111(VarCurr)
    <=> v88372(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8524,axiom,
    ! [VarCurr: state_type] :
      ( v89090(VarCurr)
    <=> ( v89091(VarCurr)
        & v89103(VarCurr) ) ) ).

tff(writeUnaryOperator_4250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89103(VarCurr)
    <=> v89104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8523,axiom,
    ! [VarCurr: state_type] :
      ( v89104(VarCurr)
    <=> ( v89105(VarCurr)
        & v89107(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_872,axiom,
    ! [VarCurr: state_type] :
      ( v89107(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v89096(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8522,axiom,
    ! [VarCurr: state_type] :
      ( v89105(VarCurr)
    <=> ( v88904(VarCurr)
        | v89106(VarCurr) ) ) ).

tff(writeUnaryOperator_4249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89106(VarCurr)
    <=> v89096(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8521,axiom,
    ! [VarCurr: state_type] :
      ( v89091(VarCurr)
    <=> ( v89092(VarCurr)
        & v89098(VarCurr) ) ) ).

tff(writeUnaryOperator_4248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89098(VarCurr)
    <=> v89099(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8520,axiom,
    ! [VarCurr: state_type] :
      ( v89099(VarCurr)
    <=> ( v89100(VarCurr)
        & v89102(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_871,axiom,
    ! [VarCurr: state_type] :
      ( v89102(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v89096(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8519,axiom,
    ! [VarCurr: state_type] :
      ( v89100(VarCurr)
    <=> ( v88897(VarCurr)
        | v89101(VarCurr) ) ) ).

tff(writeUnaryOperator_4247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89101(VarCurr)
    <=> v89096(VarCurr,1) ) ).

tff(writeUnaryOperator_4246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89092(VarCurr)
    <=> v89093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8518,axiom,
    ! [VarCurr: state_type] :
      ( v89093(VarCurr)
    <=> ( v89094(VarCurr)
        & v89097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8517,axiom,
    ! [VarCurr: state_type] :
      ( v89097(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v89096(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8516,axiom,
    ! [VarCurr: state_type] :
      ( v89094(VarCurr)
    <=> ( v88915(VarCurr)
        | v89095(VarCurr) ) ) ).

tff(writeUnaryOperator_4245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89095(VarCurr)
    <=> v89096(VarCurr,0) ) ).

tff(addAssignment_54018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v89096(VarCurr,B)
      <=> v88266(VarCurr,B) ) ) ).

tff(addAssignment_54017,axiom,
    ! [VarCurr: state_type] :
      ( v89096(VarCurr,3)
    <=> v88078(VarCurr) ) ).

tff(addAssignment_54016,axiom,
    ! [VarCurr: state_type] :
      ( v84297(VarCurr,1)
    <=> v89072(VarCurr,1) ) ).

tff(addAssignment_54015,axiom,
    ! [VarCurr: state_type] :
      ( v84297(VarCurr,4)
    <=> v89072(VarCurr,4) ) ).

tff(addAssignment_54014,axiom,
    ! [VarCurr: state_type] :
      ( v84297(VarCurr,2)
    <=> v89072(VarCurr,2) ) ).

tff(addAssignment_54013,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,0)
    <=> v89080(VarCurr) ) ).

tff(addAssignment_54012,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,1)
    <=> v89079(VarCurr) ) ).

tff(addAssignment_54011,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,2)
    <=> v89078(VarCurr) ) ).

tff(addAssignment_54010,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,3)
    <=> v89077(VarCurr) ) ).

tff(addAssignment_54009,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,4)
    <=> v89076(VarCurr) ) ).

tff(addAssignment_54008,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,5)
    <=> v89075(VarCurr) ) ).

tff(addAssignment_54007,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,6)
    <=> v89074(VarCurr) ) ).

tff(addAssignment_54006,axiom,
    ! [VarCurr: state_type] :
      ( v89072(VarCurr,7)
    <=> v89073(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_447,axiom,
    ! [VarCurr: state_type] :
      ( v89080(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_446,axiom,
    ! [VarCurr: state_type] :
      ( v89079(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_445,axiom,
    ! [VarCurr: state_type] :
      ( v89078(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_444,axiom,
    ! [VarCurr: state_type] :
      ( v89077(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $false )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_443,axiom,
    ! [VarCurr: state_type] :
      ( v89076(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_442,axiom,
    ! [VarCurr: state_type] :
      ( v89075(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_441,axiom,
    ! [VarCurr: state_type] :
      ( v89074(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_440,axiom,
    ! [VarCurr: state_type] :
      ( v89073(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_54005,axiom,
    ! [VarCurr: state_type] :
      ( v88266(VarCurr,2)
    <=> v88268(VarCurr,2) ) ).

tff(addAssignment_54004,axiom,
    ! [VarCurr: state_type] :
      ( v88268(VarCurr,2)
    <=> v88291(VarCurr,2) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_14,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89066(VarCurr)
     => ( v88278(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_41,axiom,
    ! [VarCurr: state_type] :
      ( v89066(VarCurr)
     => ( v88278(VarCurr,2)
      <=> v89069(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87299(VarCurr)
     => ( v89069(VarCurr)
      <=> v89070(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_40,axiom,
    ! [VarCurr: state_type] :
      ( v87299(VarCurr)
     => ( v89069(VarCurr)
      <=> v87204(VarCurr,24) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87547(VarCurr)
     => ( v89070(VarCurr)
      <=> v89071(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_39,axiom,
    ! [VarCurr: state_type] :
      ( v87547(VarCurr)
     => ( v89070(VarCurr)
      <=> v87204(VarCurr,25) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_13,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87560(VarCurr)
     => ( v89071(VarCurr)
      <=> v87204(VarCurr,27) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_38,axiom,
    ! [VarCurr: state_type] :
      ( v87560(VarCurr)
     => ( v89071(VarCurr)
      <=> v87204(VarCurr,26) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8515,axiom,
    ! [VarCurr: state_type] :
      ( v89066(VarCurr)
    <=> ( v89067(VarCurr)
        | v89054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8514,axiom,
    ! [VarCurr: state_type] :
      ( v89067(VarCurr)
    <=> ( v89068(VarCurr)
        | v88145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8513,axiom,
    ! [VarCurr: state_type] :
      ( v89068(VarCurr)
    <=> ( v88157(VarCurr)
        | v89042(VarCurr) ) ) ).

tff(addAssignment_54003,axiom,
    ! [VarCurr: state_type] :
      ( v89054(VarCurr)
    <=> v87645(VarCurr,4) ) ).

tff(addAssignment_54002,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,4)
    <=> v87647(VarCurr,4) ) ).

tff(addAssignment_54001,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,4)
    <=> v89058(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89059(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v89058(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1026,axiom,
    ! [VarNext: state_type] :
      ( v89059(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v89058(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89059(VarNext)
      <=> v89060(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89060(VarNext)
      <=> ( v89062(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89062(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_54000,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,4)
    <=> v87659(VarCurr,4) ) ).

tff(addAssignment_53999,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,4)
    <=> v87661(VarCurr,4) ) ).

tff(addAssignment_53998,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,4)
    <=> v87743(VarCurr,4) ) ).

tff(addBitVectorEqualityBitBlasted_439,axiom,
    ! [VarCurr: state_type] :
      ( v87747(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $true )
        & ( v87665(VarCurr,1)
        <=> $false )
        & ( v87665(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_53997,axiom,
    ! [VarCurr: state_type] :
      ( v89042(VarCurr)
    <=> v87645(VarCurr,6) ) ).

tff(addAssignment_53996,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,6)
    <=> v87647(VarCurr,6) ) ).

tff(addAssignment_53995,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,6)
    <=> v89046(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89047(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v89046(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1025,axiom,
    ! [VarNext: state_type] :
      ( v89047(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v89046(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89047(VarNext)
      <=> v89048(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89048(VarNext)
      <=> ( v89050(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89050(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53994,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,6)
    <=> v87659(VarCurr,6) ) ).

tff(addAssignment_53993,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,6)
    <=> v87661(VarCurr,6) ) ).

tff(addAssignment_53992,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,6)
    <=> v87743(VarCurr,6) ) ).

tff(addBitVectorEqualityBitBlasted_438,axiom,
    ! [VarCurr: state_type] :
      ( v87745(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $true )
        & ( v87665(VarCurr,1)
        <=> $true )
        & ( v87665(VarCurr,0)
        <=> $true ) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_12,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88157(VarCurr)
     => ( v88270(VarCurr,2)
      <=> v89013(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_37,axiom,
    ! [VarCurr: state_type] :
      ( v88157(VarCurr)
     => ( v88270(VarCurr,2)
      <=> v89009(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89014(VarCurr)
     => ( v89013(VarCurr)
      <=> v89017(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_36,axiom,
    ! [VarCurr: state_type] :
      ( v89014(VarCurr)
     => ( v89013(VarCurr)
      <=> v86956(VarCurr,25) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89018(VarCurr)
     => ( v89017(VarCurr)
      <=> v89024(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_35,axiom,
    ! [VarCurr: state_type] :
      ( v89018(VarCurr)
     => ( v89017(VarCurr)
      <=> v86956(VarCurr,26) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89025(VarCurr)
     => ( v89024(VarCurr)
      <=> v89031(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_34,axiom,
    ! [VarCurr: state_type] :
      ( v89025(VarCurr)
     => ( v89024(VarCurr)
      <=> v86956(VarCurr,27) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89032(VarCurr)
     => ( v89031(VarCurr)
      <=> v89038(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_33,axiom,
    ! [VarCurr: state_type] :
      ( v89032(VarCurr)
     => ( v89031(VarCurr)
      <=> v86956(VarCurr,28) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89039(VarCurr)
     => ( v89038(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_32,axiom,
    ! [VarCurr: state_type] :
      ( v89039(VarCurr)
     => ( v89038(VarCurr)
      <=> v86956(VarCurr,29) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8508,axiom,
    ! [VarCurr: state_type] :
      ( v89039(VarCurr)
    <=> ( v89040(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8507,axiom,
    ! [VarCurr: state_type] :
      ( v89040(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8506,axiom,
    ! [VarCurr: state_type] :
      ( v89032(VarCurr)
    <=> ( v89033(VarCurr)
        | v89035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8505,axiom,
    ! [VarCurr: state_type] :
      ( v89035(VarCurr)
    <=> ( v89036(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8504,axiom,
    ! [VarCurr: state_type] :
      ( v89036(VarCurr)
    <=> ( v88145(VarCurr)
        & v89037(VarCurr) ) ) ).

tff(writeUnaryOperator_4242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89037(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8503,axiom,
    ! [VarCurr: state_type] :
      ( v89033(VarCurr)
    <=> ( v89034(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8502,axiom,
    ! [VarCurr: state_type] :
      ( v89034(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8501,axiom,
    ! [VarCurr: state_type] :
      ( v89025(VarCurr)
    <=> ( v89026(VarCurr)
        | v89028(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8500,axiom,
    ! [VarCurr: state_type] :
      ( v89028(VarCurr)
    <=> ( v89029(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8499,axiom,
    ! [VarCurr: state_type] :
      ( v89029(VarCurr)
    <=> ( v88145(VarCurr)
        & v89030(VarCurr) ) ) ).

tff(writeUnaryOperator_4241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89030(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8498,axiom,
    ! [VarCurr: state_type] :
      ( v89026(VarCurr)
    <=> ( v89027(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8497,axiom,
    ! [VarCurr: state_type] :
      ( v89027(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8496,axiom,
    ! [VarCurr: state_type] :
      ( v89018(VarCurr)
    <=> ( v89019(VarCurr)
        | v89021(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8495,axiom,
    ! [VarCurr: state_type] :
      ( v89021(VarCurr)
    <=> ( v89022(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8494,axiom,
    ! [VarCurr: state_type] :
      ( v89022(VarCurr)
    <=> ( v88145(VarCurr)
        & v89023(VarCurr) ) ) ).

tff(writeUnaryOperator_4240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89023(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8493,axiom,
    ! [VarCurr: state_type] :
      ( v89019(VarCurr)
    <=> ( v89020(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8492,axiom,
    ! [VarCurr: state_type] :
      ( v89020(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8491,axiom,
    ! [VarCurr: state_type] :
      ( v89014(VarCurr)
    <=> ( v89015(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8490,axiom,
    ! [VarCurr: state_type] :
      ( v89015(VarCurr)
    <=> ( v88145(VarCurr)
        & v89016(VarCurr) ) ) ).

tff(writeUnaryOperator_4239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89016(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8489,axiom,
    ! [VarCurr: state_type] :
      ( v89009(VarCurr)
    <=> ( v89010(VarCurr)
        | v89012(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_870,axiom,
    ! [VarCurr: state_type] :
      ( v89012(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_869,axiom,
    ! [VarCurr: state_type] :
      ( v89010(VarCurr)
    <=> ( v89011(VarCurr)
        & v86956(VarCurr,3) ) ) ).

tff(writeUnaryOperator_4238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v89011(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(addAssignment_53991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88374(VarCurr,B)
      <=> v88376(VarCurr,B) ) ) ).

tff(addAssignment_53990,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88376(VarNext,B)
      <=> v89001(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v89001(VarNext,B)
            <=> v88376(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1024,axiom,
    ! [VarNext: state_type] :
      ( v89002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v89001(VarNext,B)
          <=> v88835(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89002(VarNext)
      <=> v89003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v89003(VarNext)
      <=> ( v89005(VarNext)
          & v88820(VarNext) ) ) ) ).

tff(writeUnaryOperator_4237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v89005(VarNext)
      <=> v88829(VarNext) ) ) ).

tff(addAssignment_53989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88386(VarCurr,B)
      <=> v88388(VarCurr,B) ) ) ).

tff(addAssignment_53988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88388(VarCurr,B)
      <=> v88390(VarCurr,B) ) ) ).

tff(addAssignment_53987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88390(VarCurr,B)
      <=> v88392(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88985(VarCurr)
     => ( v88392(VarCurr,3)
      <=> v88372(VarCurr,3) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_31,axiom,
    ! [VarCurr: state_type] :
      ( v88985(VarCurr)
     => ( v88392(VarCurr,3)
      <=> v88993(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_10,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88987(VarCurr)
        & ~ v88988(VarCurr) )
     => ( v88993(VarCurr)
      <=> v88998(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_17,axiom,
    ! [VarCurr: state_type] :
      ( v88988(VarCurr)
     => ( v88993(VarCurr)
      <=> v88996(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_17,axiom,
    ! [VarCurr: state_type] :
      ( v88987(VarCurr)
     => ( v88993(VarCurr)
      <=> v88994(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1023,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88811(VarCurr)
        & v88992(VarCurr) )
     => ( v88998(VarCurr)
      <=> v88999(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1023,axiom,
    ! [VarCurr: state_type] :
      ( v88811(VarCurr)
     => ( v88998(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorShiftedRanges_868,axiom,
    ! [VarCurr: state_type] :
      ( v88999(VarCurr)
    <=> ( v88372(VarCurr,3)
      <~> v87580(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1022,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88686(VarCurr)
        & v88808(VarCurr) )
     => ( v88996(VarCurr)
      <=> v88997(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1022,axiom,
    ! [VarCurr: state_type] :
      ( v88686(VarCurr)
     => ( v88996(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorShiftedRanges_867,axiom,
    ! [VarCurr: state_type] :
      ( v88997(VarCurr)
    <=> ( v88372(VarCurr,3)
      <~> v87580(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88815(VarCurr)
     => ( v88994(VarCurr)
      <=> v88995(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_549,axiom,
    ! [VarCurr: state_type] :
      ( v88815(VarCurr)
     => ( v88994(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorShiftedRanges_866,axiom,
    ! [VarCurr: state_type] :
      ( v88995(VarCurr)
    <=> ( v88372(VarCurr,3)
      <~> v87580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8486,axiom,
    ! [VarCurr: state_type] :
      ( v88985(VarCurr)
    <=> ( v88986(VarCurr)
        | v88990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8485,axiom,
    ! [VarCurr: state_type] :
      ( v88990(VarCurr)
    <=> ( v88991(VarCurr)
        & v88734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8484,axiom,
    ! [VarCurr: state_type] :
      ( v88991(VarCurr)
    <=> ( v88811(VarCurr)
        | v88992(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8483,axiom,
    ! [VarCurr: state_type] :
      ( v88992(VarCurr)
    <=> ( v88418(VarCurr)
        & v88661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8482,axiom,
    ! [VarCurr: state_type] :
      ( v88986(VarCurr)
    <=> ( v88987(VarCurr)
        | v88988(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8481,axiom,
    ! [VarCurr: state_type] :
      ( v88988(VarCurr)
    <=> ( v88989(VarCurr)
        & v88687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8480,axiom,
    ! [VarCurr: state_type] :
      ( v88989(VarCurr)
    <=> ( v88686(VarCurr)
        | v88808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8479,axiom,
    ! [VarCurr: state_type] :
      ( v88987(VarCurr)
    <=> ( v88394(VarCurr)
        & v88805(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88873(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88392(VarCurr,B)
          <=> v88372(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_548,axiom,
    ! [VarCurr: state_type] :
      ( v88873(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88392(VarCurr,B)
          <=> v88881(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_9,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88875(VarCurr)
        & ~ v88876(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88881(VarCurr,B)
          <=> v88951(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_16,axiom,
    ! [VarCurr: state_type] :
      ( v88876(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88881(VarCurr,B)
          <=> v88918(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_16,axiom,
    ! [VarCurr: state_type] :
      ( v88875(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88881(VarCurr,B)
          <=> v88882(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1021,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88811(VarCurr)
        & v88880(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88951(VarCurr,B)
          <=> v88952(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1021,axiom,
    ! [VarCurr: state_type] :
      ( v88811(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88951(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_53986,axiom,
    ! [VarCurr: state_type] :
      ( v88952(VarCurr,0)
    <=> v88980(VarCurr) ) ).

tff(addAssignment_53985,axiom,
    ! [VarCurr: state_type] :
      ( v88952(VarCurr,1)
    <=> v88975(VarCurr) ) ).

tff(addAssignment_53984,axiom,
    ! [VarCurr: state_type] :
      ( v88952(VarCurr,2)
    <=> v88954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8478,axiom,
    ! [VarCurr: state_type] :
      ( v88980(VarCurr)
    <=> ( v88981(VarCurr)
        & v88983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8477,axiom,
    ! [VarCurr: state_type] :
      ( v88983(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v88960(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8476,axiom,
    ! [VarCurr: state_type] :
      ( v88981(VarCurr)
    <=> ( v88915(VarCurr)
        | v88982(VarCurr) ) ) ).

tff(writeUnaryOperator_4236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88982(VarCurr)
    <=> v88960(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8475,axiom,
    ! [VarCurr: state_type] :
      ( v88975(VarCurr)
    <=> ( v88976(VarCurr)
        & v88979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8474,axiom,
    ! [VarCurr: state_type] :
      ( v88979(VarCurr)
    <=> ( v88959(VarCurr)
        | v88964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8473,axiom,
    ! [VarCurr: state_type] :
      ( v88976(VarCurr)
    <=> ( v88977(VarCurr)
        | v88978(VarCurr) ) ) ).

tff(writeUnaryOperator_4235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88978(VarCurr)
    <=> v88964(VarCurr) ) ).

tff(writeUnaryOperator_4234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88977(VarCurr)
    <=> v88959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8472,axiom,
    ! [VarCurr: state_type] :
      ( v88954(VarCurr)
    <=> ( v88955(VarCurr)
        & v88974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8471,axiom,
    ! [VarCurr: state_type] :
      ( v88974(VarCurr)
    <=> ( v88957(VarCurr)
        | v88970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8470,axiom,
    ! [VarCurr: state_type] :
      ( v88955(VarCurr)
    <=> ( v88956(VarCurr)
        | v88969(VarCurr) ) ) ).

tff(writeUnaryOperator_4233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88969(VarCurr)
    <=> v88970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8469,axiom,
    ! [VarCurr: state_type] :
      ( v88970(VarCurr)
    <=> ( v88971(VarCurr)
        & v88973(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_865,axiom,
    ! [VarCurr: state_type] :
      ( v88973(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v88960(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8468,axiom,
    ! [VarCurr: state_type] :
      ( v88971(VarCurr)
    <=> ( v88904(VarCurr)
        | v88972(VarCurr) ) ) ).

tff(writeUnaryOperator_4232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88972(VarCurr)
    <=> v88960(VarCurr,2) ) ).

tff(writeUnaryOperator_4231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88956(VarCurr)
    <=> v88957(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8467,axiom,
    ! [VarCurr: state_type] :
      ( v88957(VarCurr)
    <=> ( v88958(VarCurr)
        | v88968(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_864,axiom,
    ! [VarCurr: state_type] :
      ( v88968(VarCurr)
    <=> ( v88372(VarCurr,1)
        & v88960(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8466,axiom,
    ! [VarCurr: state_type] :
      ( v88958(VarCurr)
    <=> ( v88959(VarCurr)
        & v88964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8465,axiom,
    ! [VarCurr: state_type] :
      ( v88964(VarCurr)
    <=> ( v88965(VarCurr)
        & v88967(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_863,axiom,
    ! [VarCurr: state_type] :
      ( v88967(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v88960(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8464,axiom,
    ! [VarCurr: state_type] :
      ( v88965(VarCurr)
    <=> ( v88897(VarCurr)
        | v88966(VarCurr) ) ) ).

tff(writeUnaryOperator_4230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88966(VarCurr)
    <=> v88960(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8463,axiom,
    ! [VarCurr: state_type] :
      ( v88959(VarCurr)
    <=> ( v88372(VarCurr,0)
        & v88960(VarCurr,0) ) ) ).

tff(addAssignment_53983,axiom,
    ! [VarCurr: state_type] :
      ( v88960(VarCurr,0)
    <=> v88961(VarCurr) ) ).

tff(addAssignment_53982,axiom,
    ! [VarCurr: state_type] :
      ( ( v88960(VarCurr,2)
      <=> $false )
      & ( v88960(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8462,axiom,
    ! [VarCurr: state_type] :
      ( v88961(VarCurr)
    <=> ( v88962(VarCurr)
        | v88963(VarCurr) ) ) ).

tff(writeUnaryOperator_4229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88963(VarCurr)
    <=> v87580(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_862,axiom,
    ! [VarCurr: state_type] :
      ( v88962(VarCurr)
    <=> ( v88372(VarCurr,3)
        & v87580(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1020,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88686(VarCurr)
        & v88808(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88918(VarCurr,B)
          <=> v88919(VarCurr,B) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1020,axiom,
    ! [VarCurr: state_type] :
      ( v88686(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88918(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_53981,axiom,
    ! [VarCurr: state_type] :
      ( v88919(VarCurr,0)
    <=> v88947(VarCurr) ) ).

tff(addAssignment_53980,axiom,
    ! [VarCurr: state_type] :
      ( v88919(VarCurr,1)
    <=> v88942(VarCurr) ) ).

tff(addAssignment_53979,axiom,
    ! [VarCurr: state_type] :
      ( v88919(VarCurr,2)
    <=> v88921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8461,axiom,
    ! [VarCurr: state_type] :
      ( v88947(VarCurr)
    <=> ( v88948(VarCurr)
        & v88950(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8460,axiom,
    ! [VarCurr: state_type] :
      ( v88950(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v88927(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8459,axiom,
    ! [VarCurr: state_type] :
      ( v88948(VarCurr)
    <=> ( v88915(VarCurr)
        | v88949(VarCurr) ) ) ).

tff(writeUnaryOperator_4228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88949(VarCurr)
    <=> v88927(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8458,axiom,
    ! [VarCurr: state_type] :
      ( v88942(VarCurr)
    <=> ( v88943(VarCurr)
        & v88946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8457,axiom,
    ! [VarCurr: state_type] :
      ( v88946(VarCurr)
    <=> ( v88926(VarCurr)
        | v88931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8456,axiom,
    ! [VarCurr: state_type] :
      ( v88943(VarCurr)
    <=> ( v88944(VarCurr)
        | v88945(VarCurr) ) ) ).

tff(writeUnaryOperator_4227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88945(VarCurr)
    <=> v88931(VarCurr) ) ).

tff(writeUnaryOperator_4226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88944(VarCurr)
    <=> v88926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8455,axiom,
    ! [VarCurr: state_type] :
      ( v88921(VarCurr)
    <=> ( v88922(VarCurr)
        & v88941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8454,axiom,
    ! [VarCurr: state_type] :
      ( v88941(VarCurr)
    <=> ( v88924(VarCurr)
        | v88937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8453,axiom,
    ! [VarCurr: state_type] :
      ( v88922(VarCurr)
    <=> ( v88923(VarCurr)
        | v88936(VarCurr) ) ) ).

tff(writeUnaryOperator_4225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88936(VarCurr)
    <=> v88937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8452,axiom,
    ! [VarCurr: state_type] :
      ( v88937(VarCurr)
    <=> ( v88938(VarCurr)
        & v88940(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_861,axiom,
    ! [VarCurr: state_type] :
      ( v88940(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v88927(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8451,axiom,
    ! [VarCurr: state_type] :
      ( v88938(VarCurr)
    <=> ( v88904(VarCurr)
        | v88939(VarCurr) ) ) ).

tff(writeUnaryOperator_4224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88939(VarCurr)
    <=> v88927(VarCurr,2) ) ).

tff(writeUnaryOperator_4223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88923(VarCurr)
    <=> v88924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8450,axiom,
    ! [VarCurr: state_type] :
      ( v88924(VarCurr)
    <=> ( v88925(VarCurr)
        | v88935(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_860,axiom,
    ! [VarCurr: state_type] :
      ( v88935(VarCurr)
    <=> ( v88372(VarCurr,1)
        & v88927(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8449,axiom,
    ! [VarCurr: state_type] :
      ( v88925(VarCurr)
    <=> ( v88926(VarCurr)
        & v88931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8448,axiom,
    ! [VarCurr: state_type] :
      ( v88931(VarCurr)
    <=> ( v88932(VarCurr)
        & v88934(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_859,axiom,
    ! [VarCurr: state_type] :
      ( v88934(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v88927(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8447,axiom,
    ! [VarCurr: state_type] :
      ( v88932(VarCurr)
    <=> ( v88897(VarCurr)
        | v88933(VarCurr) ) ) ).

tff(writeUnaryOperator_4222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88933(VarCurr)
    <=> v88927(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8446,axiom,
    ! [VarCurr: state_type] :
      ( v88926(VarCurr)
    <=> ( v88372(VarCurr,0)
        & v88927(VarCurr,0) ) ) ).

tff(addAssignment_53978,axiom,
    ! [VarCurr: state_type] :
      ( v88927(VarCurr,0)
    <=> v88928(VarCurr) ) ).

tff(addAssignment_53977,axiom,
    ! [VarCurr: state_type] :
      ( ( v88927(VarCurr,2)
      <=> $false )
      & ( v88927(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8445,axiom,
    ! [VarCurr: state_type] :
      ( v88928(VarCurr)
    <=> ( v88929(VarCurr)
        | v88930(VarCurr) ) ) ).

tff(writeUnaryOperator_4221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88930(VarCurr)
    <=> v87580(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_858,axiom,
    ! [VarCurr: state_type] :
      ( v88929(VarCurr)
    <=> ( v88372(VarCurr,3)
        & v87580(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88882(VarCurr,B)
          <=> v88883(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_547,axiom,
    ! [VarCurr: state_type] :
      ( v88815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88882(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_53976,axiom,
    ! [VarCurr: state_type] :
      ( v88883(VarCurr,0)
    <=> v88913(VarCurr) ) ).

tff(addAssignment_53975,axiom,
    ! [VarCurr: state_type] :
      ( v88883(VarCurr,1)
    <=> v88908(VarCurr) ) ).

tff(addAssignment_53974,axiom,
    ! [VarCurr: state_type] :
      ( v88883(VarCurr,2)
    <=> v88885(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8444,axiom,
    ! [VarCurr: state_type] :
      ( v88913(VarCurr)
    <=> ( v88914(VarCurr)
        & v88917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8443,axiom,
    ! [VarCurr: state_type] :
      ( v88917(VarCurr)
    <=> ( v88372(VarCurr,0)
        | v88891(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8442,axiom,
    ! [VarCurr: state_type] :
      ( v88914(VarCurr)
    <=> ( v88915(VarCurr)
        | v88916(VarCurr) ) ) ).

tff(writeUnaryOperator_4220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88916(VarCurr)
    <=> v88891(VarCurr,0) ) ).

tff(writeUnaryOperator_4219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88915(VarCurr)
    <=> v88372(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8441,axiom,
    ! [VarCurr: state_type] :
      ( v88908(VarCurr)
    <=> ( v88909(VarCurr)
        & v88912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8440,axiom,
    ! [VarCurr: state_type] :
      ( v88912(VarCurr)
    <=> ( v88890(VarCurr)
        | v88895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8439,axiom,
    ! [VarCurr: state_type] :
      ( v88909(VarCurr)
    <=> ( v88910(VarCurr)
        | v88911(VarCurr) ) ) ).

tff(writeUnaryOperator_4218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88911(VarCurr)
    <=> v88895(VarCurr) ) ).

tff(writeUnaryOperator_4217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88910(VarCurr)
    <=> v88890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8438,axiom,
    ! [VarCurr: state_type] :
      ( v88885(VarCurr)
    <=> ( v88886(VarCurr)
        & v88907(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8437,axiom,
    ! [VarCurr: state_type] :
      ( v88907(VarCurr)
    <=> ( v88888(VarCurr)
        | v88902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8436,axiom,
    ! [VarCurr: state_type] :
      ( v88886(VarCurr)
    <=> ( v88887(VarCurr)
        | v88901(VarCurr) ) ) ).

tff(writeUnaryOperator_4216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88901(VarCurr)
    <=> v88902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8435,axiom,
    ! [VarCurr: state_type] :
      ( v88902(VarCurr)
    <=> ( v88903(VarCurr)
        & v88906(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_857,axiom,
    ! [VarCurr: state_type] :
      ( v88906(VarCurr)
    <=> ( v88372(VarCurr,2)
        | v88891(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8434,axiom,
    ! [VarCurr: state_type] :
      ( v88903(VarCurr)
    <=> ( v88904(VarCurr)
        | v88905(VarCurr) ) ) ).

tff(writeUnaryOperator_4215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88905(VarCurr)
    <=> v88891(VarCurr,2) ) ).

tff(writeUnaryOperator_4214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88904(VarCurr)
    <=> v88372(VarCurr,2) ) ).

tff(writeUnaryOperator_4213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88887(VarCurr)
    <=> v88888(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8433,axiom,
    ! [VarCurr: state_type] :
      ( v88888(VarCurr)
    <=> ( v88889(VarCurr)
        | v88900(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_856,axiom,
    ! [VarCurr: state_type] :
      ( v88900(VarCurr)
    <=> ( v88372(VarCurr,1)
        & v88891(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8432,axiom,
    ! [VarCurr: state_type] :
      ( v88889(VarCurr)
    <=> ( v88890(VarCurr)
        & v88895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8431,axiom,
    ! [VarCurr: state_type] :
      ( v88895(VarCurr)
    <=> ( v88896(VarCurr)
        & v88899(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_855,axiom,
    ! [VarCurr: state_type] :
      ( v88899(VarCurr)
    <=> ( v88372(VarCurr,1)
        | v88891(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8430,axiom,
    ! [VarCurr: state_type] :
      ( v88896(VarCurr)
    <=> ( v88897(VarCurr)
        | v88898(VarCurr) ) ) ).

tff(writeUnaryOperator_4212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88898(VarCurr)
    <=> v88891(VarCurr,1) ) ).

tff(writeUnaryOperator_4211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88897(VarCurr)
    <=> v88372(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8429,axiom,
    ! [VarCurr: state_type] :
      ( v88890(VarCurr)
    <=> ( v88372(VarCurr,0)
        & v88891(VarCurr,0) ) ) ).

tff(addAssignment_53973,axiom,
    ! [VarCurr: state_type] :
      ( v88891(VarCurr,0)
    <=> v88892(VarCurr) ) ).

tff(addAssignment_53972,axiom,
    ! [VarCurr: state_type] :
      ( ( v88891(VarCurr,2)
      <=> $false )
      & ( v88891(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8428,axiom,
    ! [VarCurr: state_type] :
      ( v88892(VarCurr)
    <=> ( v88893(VarCurr)
        | v88894(VarCurr) ) ) ).

tff(writeUnaryOperator_4210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88894(VarCurr)
    <=> v87580(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_854,axiom,
    ! [VarCurr: state_type] :
      ( v88893(VarCurr)
    <=> ( v88372(VarCurr,3)
        & v87580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8427,axiom,
    ! [VarCurr: state_type] :
      ( v88873(VarCurr)
    <=> ( v88874(VarCurr)
        | v88878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8426,axiom,
    ! [VarCurr: state_type] :
      ( v88878(VarCurr)
    <=> ( v88879(VarCurr)
        & v88734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8425,axiom,
    ! [VarCurr: state_type] :
      ( v88879(VarCurr)
    <=> ( v88811(VarCurr)
        | v88880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8424,axiom,
    ! [VarCurr: state_type] :
      ( v88880(VarCurr)
    <=> ( v88418(VarCurr)
        & v88661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8423,axiom,
    ! [VarCurr: state_type] :
      ( v88874(VarCurr)
    <=> ( v88875(VarCurr)
        | v88876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8422,axiom,
    ! [VarCurr: state_type] :
      ( v88876(VarCurr)
    <=> ( v88877(VarCurr)
        & v88687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8421,axiom,
    ! [VarCurr: state_type] :
      ( v88877(VarCurr)
    <=> ( v88686(VarCurr)
        | v88808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8420,axiom,
    ! [VarCurr: state_type] :
      ( v88875(VarCurr)
    <=> ( v88394(VarCurr)
        & v88805(VarCurr) ) ) ).

tff(addAssignment_53971,axiom,
    ! [VarCurr: state_type] :
      ( v88615(VarCurr)
    <=> v88617(VarCurr) ) ).

tff(addAssignment_53970,axiom,
    ! [VarCurr: state_type] :
      ( v88617(VarCurr)
    <=> v88619(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88856(VarNext)
       => ( v88619(VarNext)
        <=> v88619(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1019,axiom,
    ! [VarNext: state_type] :
      ( v88856(VarNext)
     => ( v88619(VarNext)
      <=> v88866(VarNext) ) ) ).

tff(addAssignment_53969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88866(VarNext)
      <=> v88864(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88867(VarCurr)
     => ( v88864(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_546,axiom,
    ! [VarCurr: state_type] :
      ( v88867(VarCurr)
     => ( v88864(VarCurr)
      <=> v88629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8419,axiom,
    ! [VarCurr: state_type] :
      ( v88867(VarCurr)
    <=> ( v88868(VarCurr)
        & v88869(VarCurr) ) ) ).

tff(writeUnaryOperator_4209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88869(VarCurr)
    <=> v88625(VarCurr) ) ).

tff(writeUnaryOperator_4208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88868(VarCurr)
    <=> v88621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88856(VarNext)
      <=> v88857(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88857(VarNext)
      <=> ( v88858(VarNext)
          & v88851(VarNext) ) ) ) ).

tff(writeUnaryOperator_4207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88858(VarNext)
      <=> v88860(VarNext) ) ) ).

tff(addAssignment_53968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88860(VarNext)
      <=> v88851(VarCurr) ) ) ).

tff(addAssignment_53967,axiom,
    ! [VarCurr: state_type] :
      ( v88851(VarCurr)
    <=> v88853(VarCurr) ) ).

tff(addAssignment_53966,axiom,
    ! [VarCurr: state_type] :
      ( v88853(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53965,axiom,
    ! [VarCurr: state_type] :
      ( v88629(VarCurr)
    <=> v88631(VarCurr) ) ).

tff(addAssignment_53964,axiom,
    ! [VarCurr: state_type] :
      ( v88631(VarCurr)
    <=> v88633(VarCurr) ) ).

tff(addAssignment_53963,axiom,
    ! [VarCurr: state_type] :
      ( v88633(VarCurr)
    <=> v88635(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88637(VarCurr)
     => ( v88635(VarCurr)
      <=> v88846(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_545,axiom,
    ! [VarCurr: state_type] :
      ( v88637(VarCurr)
     => ( v88635(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88847(VarCurr)
     => ( v88846(VarCurr)
      <=> v88615(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_544,axiom,
    ! [VarCurr: state_type] :
      ( v88847(VarCurr)
     => ( v88846(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8416,axiom,
    ! [VarCurr: state_type] :
      ( v88847(VarCurr)
    <=> ( v88848(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_437,axiom,
    ! [VarCurr: state_type] :
      ( v88848(VarCurr)
    <=> ( ( v88372(VarCurr,4)
        <=> v88849(VarCurr,4) )
        & ( v88372(VarCurr,3)
        <=> v88849(VarCurr,3) )
        & ( v88372(VarCurr,2)
        <=> v88849(VarCurr,2) )
        & ( v88372(VarCurr,1)
        <=> v88849(VarCurr,1) )
        & ( v88372(VarCurr,0)
        <=> v88849(VarCurr,0) ) ) ) ).

tff(addAssignment_53962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88849(VarCurr,B)
      <=> v88689(VarCurr,B) ) ) ).

tff(addAssignment_53961,axiom,
    ! [VarCurr: state_type] :
      ( v88849(VarCurr,4)
    <=> $false ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88842(VarCurr)
     => ( v88637(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_543,axiom,
    ! [VarCurr: state_type] :
      ( v88842(VarCurr)
     => ( v88637(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8415,axiom,
    ! [VarCurr: state_type] :
      ( v88842(VarCurr)
    <=> ( v88843(VarCurr)
        & v88805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8414,axiom,
    ! [VarCurr: state_type] :
      ( v88843(VarCurr)
    <=> ( v88844(VarCurr)
        & v88394(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8413,axiom,
    ! [VarCurr: state_type] :
      ( v88844(VarCurr)
    <=> ( v84321(VarCurr)
        & v88815(VarCurr) ) ) ).

tff(addAssignment_53960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v88372(VarCurr,B)
      <=> v88374(VarCurr,B) ) ) ).

tff(addAssignment_53959,axiom,
    ! [VarCurr: state_type] :
      ( v88374(VarCurr,4)
    <=> v88376(VarCurr,4) ) ).

tff(addAssignment_53958,axiom,
    ! [VarNext: state_type] :
      ( v88376(VarNext,4)
    <=> v88824(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88825(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v88824(VarNext,B)
            <=> v88376(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1018,axiom,
    ! [VarNext: state_type] :
      ( v88825(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v88824(VarNext,B)
          <=> v88835(VarNext,B) ) ) ) ).

tff(addAssignment_53957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v88835(VarNext,B)
          <=> v88833(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88836(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v88833(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_542,axiom,
    ! [VarCurr: state_type] :
      ( v88836(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v88833(VarCurr,B)
          <=> v88386(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8412,axiom,
    ! [VarCurr: state_type] :
      ( v88836(VarCurr)
    <=> ( v88837(VarCurr)
        & v88838(VarCurr) ) ) ).

tff(writeUnaryOperator_4206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88838(VarCurr)
    <=> v88382(VarCurr) ) ).

tff(writeUnaryOperator_4205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88837(VarCurr)
    <=> v88378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88825(VarNext)
      <=> v88826(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88826(VarNext)
      <=> ( v88827(VarNext)
          & v88820(VarNext) ) ) ) ).

tff(writeUnaryOperator_4204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88827(VarNext)
      <=> v88829(VarNext) ) ) ).

tff(addAssignment_53956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88829(VarNext)
      <=> v88820(VarCurr) ) ) ).

tff(addAssignment_53955,axiom,
    ! [VarCurr: state_type] :
      ( v88820(VarCurr)
    <=> v88822(VarCurr) ) ).

tff(addAssignment_53954,axiom,
    ! [VarCurr: state_type] :
      ( v88822(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53953,axiom,
    ! [VarCurr: state_type] :
      ( v88386(VarCurr,4)
    <=> v88388(VarCurr,4) ) ).

tff(addAssignment_53952,axiom,
    ! [VarCurr: state_type] :
      ( v88388(VarCurr,4)
    <=> v88390(VarCurr,4) ) ).

tff(addAssignment_53951,axiom,
    ! [VarCurr: state_type] :
      ( v88390(VarCurr,4)
    <=> v88392(VarCurr,4) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88802(VarCurr)
     => ( v88392(VarCurr,4)
      <=> v88372(VarCurr,4) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_30,axiom,
    ! [VarCurr: state_type] :
      ( v88802(VarCurr)
     => ( v88392(VarCurr,4)
      <=> v88813(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_8,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88804(VarCurr)
        & ~ v88806(VarCurr) )
     => ( v88813(VarCurr)
      <=> v88818(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_15,axiom,
    ! [VarCurr: state_type] :
      ( v88806(VarCurr)
     => ( v88813(VarCurr)
      <=> v88817(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_15,axiom,
    ! [VarCurr: state_type] :
      ( v88804(VarCurr)
     => ( v88813(VarCurr)
      <=> v88814(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1017,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88811(VarCurr)
        & v88812(VarCurr) )
     => ( v88818(VarCurr)
      <=> $false ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1017,axiom,
    ! [VarCurr: state_type] :
      ( v88811(VarCurr)
     => ( v88818(VarCurr)
      <=> $false ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1016,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v88686(VarCurr)
        & v88808(VarCurr) )
     => ( v88817(VarCurr)
      <=> $false ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1016,axiom,
    ! [VarCurr: state_type] :
      ( v88686(VarCurr)
     => ( v88817(VarCurr)
      <=> $false ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88815(VarCurr)
     => ( v88814(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_541,axiom,
    ! [VarCurr: state_type] :
      ( v88815(VarCurr)
     => ( v88814(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_436,axiom,
    ! [VarCurr: state_type] :
      ( v88815(VarCurr)
    <=> ( ( v88372(VarCurr,4)
        <=> v88816(VarCurr,4) )
        & ( v88372(VarCurr,3)
        <=> v88816(VarCurr,3) )
        & ( v88372(VarCurr,2)
        <=> v88816(VarCurr,2) )
        & ( v88372(VarCurr,1)
        <=> v88816(VarCurr,1) )
        & ( v88372(VarCurr,0)
        <=> v88816(VarCurr,0) ) ) ) ).

tff(addAssignment_53950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88816(VarCurr,B)
      <=> v88689(VarCurr,B) ) ) ).

tff(addAssignment_53949,axiom,
    ! [VarCurr: state_type] :
      ( v88816(VarCurr,4)
    <=> $false ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8409,axiom,
    ! [VarCurr: state_type] :
      ( v88802(VarCurr)
    <=> ( v88803(VarCurr)
        | v88809(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8408,axiom,
    ! [VarCurr: state_type] :
      ( v88809(VarCurr)
    <=> ( v88810(VarCurr)
        & v88734(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8407,axiom,
    ! [VarCurr: state_type] :
      ( v88810(VarCurr)
    <=> ( v88811(VarCurr)
        | v88812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8406,axiom,
    ! [VarCurr: state_type] :
      ( v88812(VarCurr)
    <=> ( v88418(VarCurr)
        & v88661(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_435,axiom,
    ! [VarCurr: state_type] :
      ( v88811(VarCurr)
    <=> ( ( v88639(VarCurr,7)
        <=> $true )
        & ( v88639(VarCurr,6)
        <=> $true )
        & ( v88639(VarCurr,5)
        <=> $false )
        & ( v88639(VarCurr,4)
        <=> $false )
        & ( v88639(VarCurr,3)
        <=> $true )
        & ( v88639(VarCurr,2)
        <=> $false )
        & ( v88639(VarCurr,1)
        <=> $false )
        & ( v88639(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1242,axiom,
    b11001000(7) ).

tff(bitBlastConstant_1241,axiom,
    b11001000(6) ).

tff(bitBlastConstant_1240,axiom,
    ~ b11001000(5) ).

tff(bitBlastConstant_1239,axiom,
    ~ b11001000(4) ).

tff(bitBlastConstant_1238,axiom,
    b11001000(3) ).

tff(bitBlastConstant_1237,axiom,
    ~ b11001000(2) ).

tff(bitBlastConstant_1236,axiom,
    ~ b11001000(1) ).

tff(bitBlastConstant_1235,axiom,
    ~ b11001000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8405,axiom,
    ! [VarCurr: state_type] :
      ( v88803(VarCurr)
    <=> ( v88804(VarCurr)
        | v88806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8404,axiom,
    ! [VarCurr: state_type] :
      ( v88806(VarCurr)
    <=> ( v88807(VarCurr)
        & v88687(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8403,axiom,
    ! [VarCurr: state_type] :
      ( v88807(VarCurr)
    <=> ( v88686(VarCurr)
        | v88808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8402,axiom,
    ! [VarCurr: state_type] :
      ( v88808(VarCurr)
    <=> ( v88615(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8401,axiom,
    ! [VarCurr: state_type] :
      ( v88804(VarCurr)
    <=> ( v88394(VarCurr)
        & v88805(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_434,axiom,
    ! [VarCurr: state_type] :
      ( v88805(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v88639(VarCurr,B)
      <=> v88641(VarCurr,B) ) ) ).

tff(addAssignment_53947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v88641(VarCurr,B)
      <=> v88643(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88784(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v88643(VarNext,B)
            <=> v88643(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1015,axiom,
    ! [VarNext: state_type] :
      ( v88784(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88643(VarNext,B)
          <=> v88794(VarNext,B) ) ) ) ).

tff(addAssignment_53946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88794(VarNext,B)
          <=> v88792(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88792(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_540,axiom,
    ! [VarCurr: state_type] :
      ( v88795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88792(VarCurr,B)
          <=> v88653(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8400,axiom,
    ! [VarCurr: state_type] :
      ( v88795(VarCurr)
    <=> ( v88796(VarCurr)
        & v88797(VarCurr) ) ) ).

tff(writeUnaryOperator_4203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88797(VarCurr)
    <=> v88649(VarCurr) ) ).

tff(writeUnaryOperator_4202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88796(VarCurr)
    <=> v88645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88784(VarNext)
      <=> v88785(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88785(VarNext)
      <=> ( v88786(VarNext)
          & v88779(VarNext) ) ) ) ).

tff(writeUnaryOperator_4201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88786(VarNext)
      <=> v88788(VarNext) ) ) ).

tff(addAssignment_53945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88788(VarNext)
      <=> v88779(VarCurr) ) ) ).

tff(addAssignment_53944,axiom,
    ! [VarCurr: state_type] :
      ( v88779(VarCurr)
    <=> v88781(VarCurr) ) ).

tff(addAssignment_53943,axiom,
    ! [VarCurr: state_type] :
      ( v88781(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v88653(VarCurr,B)
      <=> v88655(VarCurr,B) ) ) ).

tff(addAssignment_53941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v88655(VarCurr,B)
      <=> v88657(VarCurr,B) ) ) ).

tff(addAssignment_53940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v88657(VarCurr,B)
      <=> v88659(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88732(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88659(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_539,axiom,
    ! [VarCurr: state_type] :
      ( v88732(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88659(VarCurr,B)
          <=> v88735(VarCurr,B) ) ) ) ).

tff(addAssignment_53939,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,0)
    <=> v88775(VarCurr) ) ).

tff(addAssignment_53938,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,1)
    <=> v88773(VarCurr) ) ).

tff(addAssignment_53937,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,2)
    <=> v88768(VarCurr) ) ).

tff(addAssignment_53936,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,3)
    <=> v88763(VarCurr) ) ).

tff(addAssignment_53935,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,4)
    <=> v88758(VarCurr) ) ).

tff(addAssignment_53934,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,5)
    <=> v88753(VarCurr) ) ).

tff(addAssignment_53933,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,6)
    <=> v88748(VarCurr) ) ).

tff(addAssignment_53932,axiom,
    ! [VarCurr: state_type] :
      ( v88735(VarCurr,7)
    <=> v88737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8397,axiom,
    ! [VarCurr: state_type] :
      ( v88773(VarCurr)
    <=> ( v88774(VarCurr)
        & v88777(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_853,axiom,
    ! [VarCurr: state_type] :
      ( v88777(VarCurr)
    <=> ( v88639(VarCurr,0)
        | v88639(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8396,axiom,
    ! [VarCurr: state_type] :
      ( v88774(VarCurr)
    <=> ( v88775(VarCurr)
        | v88776(VarCurr) ) ) ).

tff(writeUnaryOperator_4200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88776(VarCurr)
    <=> v88639(VarCurr,1) ) ).

tff(writeUnaryOperator_4199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88775(VarCurr)
    <=> v88639(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8395,axiom,
    ! [VarCurr: state_type] :
      ( v88768(VarCurr)
    <=> ( v88769(VarCurr)
        & v88772(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_852,axiom,
    ! [VarCurr: state_type] :
      ( v88772(VarCurr)
    <=> ( v88745(VarCurr)
        | v88639(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8394,axiom,
    ! [VarCurr: state_type] :
      ( v88769(VarCurr)
    <=> ( v88770(VarCurr)
        | v88771(VarCurr) ) ) ).

tff(writeUnaryOperator_4198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88771(VarCurr)
    <=> v88639(VarCurr,2) ) ).

tff(writeUnaryOperator_4197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88770(VarCurr)
    <=> v88745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8393,axiom,
    ! [VarCurr: state_type] :
      ( v88763(VarCurr)
    <=> ( v88764(VarCurr)
        & v88767(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_851,axiom,
    ! [VarCurr: state_type] :
      ( v88767(VarCurr)
    <=> ( v88744(VarCurr)
        | v88639(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8392,axiom,
    ! [VarCurr: state_type] :
      ( v88764(VarCurr)
    <=> ( v88765(VarCurr)
        | v88766(VarCurr) ) ) ).

tff(writeUnaryOperator_4196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88766(VarCurr)
    <=> v88639(VarCurr,3) ) ).

tff(writeUnaryOperator_4195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88765(VarCurr)
    <=> v88744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8391,axiom,
    ! [VarCurr: state_type] :
      ( v88758(VarCurr)
    <=> ( v88759(VarCurr)
        & v88762(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_850,axiom,
    ! [VarCurr: state_type] :
      ( v88762(VarCurr)
    <=> ( v88743(VarCurr)
        | v88639(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8390,axiom,
    ! [VarCurr: state_type] :
      ( v88759(VarCurr)
    <=> ( v88760(VarCurr)
        | v88761(VarCurr) ) ) ).

tff(writeUnaryOperator_4194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88761(VarCurr)
    <=> v88639(VarCurr,4) ) ).

tff(writeUnaryOperator_4193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88760(VarCurr)
    <=> v88743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8389,axiom,
    ! [VarCurr: state_type] :
      ( v88753(VarCurr)
    <=> ( v88754(VarCurr)
        & v88757(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_849,axiom,
    ! [VarCurr: state_type] :
      ( v88757(VarCurr)
    <=> ( v88742(VarCurr)
        | v88639(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8388,axiom,
    ! [VarCurr: state_type] :
      ( v88754(VarCurr)
    <=> ( v88755(VarCurr)
        | v88756(VarCurr) ) ) ).

tff(writeUnaryOperator_4192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88756(VarCurr)
    <=> v88639(VarCurr,5) ) ).

tff(writeUnaryOperator_4191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88755(VarCurr)
    <=> v88742(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8387,axiom,
    ! [VarCurr: state_type] :
      ( v88748(VarCurr)
    <=> ( v88749(VarCurr)
        & v88752(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_848,axiom,
    ! [VarCurr: state_type] :
      ( v88752(VarCurr)
    <=> ( v88741(VarCurr)
        | v88639(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8386,axiom,
    ! [VarCurr: state_type] :
      ( v88749(VarCurr)
    <=> ( v88750(VarCurr)
        | v88751(VarCurr) ) ) ).

tff(writeUnaryOperator_4190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88751(VarCurr)
    <=> v88639(VarCurr,6) ) ).

tff(writeUnaryOperator_4189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88750(VarCurr)
    <=> v88741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8385,axiom,
    ! [VarCurr: state_type] :
      ( v88737(VarCurr)
    <=> ( v88738(VarCurr)
        & v88747(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_847,axiom,
    ! [VarCurr: state_type] :
      ( v88747(VarCurr)
    <=> ( v88740(VarCurr)
        | v88639(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8384,axiom,
    ! [VarCurr: state_type] :
      ( v88738(VarCurr)
    <=> ( v88739(VarCurr)
        | v88746(VarCurr) ) ) ).

tff(writeUnaryOperator_4188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88746(VarCurr)
    <=> v88639(VarCurr,7) ) ).

tff(writeUnaryOperator_4187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88739(VarCurr)
    <=> v88740(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_846,axiom,
    ! [VarCurr: state_type] :
      ( v88740(VarCurr)
    <=> ( v88741(VarCurr)
        & v88639(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_845,axiom,
    ! [VarCurr: state_type] :
      ( v88741(VarCurr)
    <=> ( v88742(VarCurr)
        & v88639(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_844,axiom,
    ! [VarCurr: state_type] :
      ( v88742(VarCurr)
    <=> ( v88743(VarCurr)
        & v88639(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_843,axiom,
    ! [VarCurr: state_type] :
      ( v88743(VarCurr)
    <=> ( v88744(VarCurr)
        & v88639(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_842,axiom,
    ! [VarCurr: state_type] :
      ( v88744(VarCurr)
    <=> ( v88745(VarCurr)
        & v88639(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_841,axiom,
    ! [VarCurr: state_type] :
      ( v88745(VarCurr)
    <=> ( v88639(VarCurr,0)
        & v88639(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8383,axiom,
    ! [VarCurr: state_type] :
      ( v88732(VarCurr)
    <=> ( v88733(VarCurr)
        & v88734(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_433,axiom,
    ! [VarCurr: state_type] :
      ( v88734(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $true )
        & ( v84299(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_4186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88733(VarCurr)
    <=> v88661(VarCurr) ) ).

tff(addAssignment_53931,axiom,
    ! [VarCurr: state_type] :
      ( v88661(VarCurr)
    <=> v88663(VarCurr) ) ).

tff(addAssignment_53930,axiom,
    ! [VarCurr: state_type] :
      ( v88663(VarCurr)
    <=> v88665(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88715(VarNext)
       => ( v88665(VarNext)
        <=> v88665(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1014,axiom,
    ! [VarNext: state_type] :
      ( v88715(VarNext)
     => ( v88665(VarNext)
      <=> v88725(VarNext) ) ) ).

tff(addAssignment_53929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88725(VarNext)
      <=> v88723(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88726(VarCurr)
     => ( v88723(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_538,axiom,
    ! [VarCurr: state_type] :
      ( v88726(VarCurr)
     => ( v88723(VarCurr)
      <=> v88675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8382,axiom,
    ! [VarCurr: state_type] :
      ( v88726(VarCurr)
    <=> ( v88727(VarCurr)
        & v88728(VarCurr) ) ) ).

tff(writeUnaryOperator_4185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88728(VarCurr)
    <=> v88671(VarCurr) ) ).

tff(writeUnaryOperator_4184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88727(VarCurr)
    <=> v88667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88715(VarNext)
      <=> v88716(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88716(VarNext)
      <=> ( v88717(VarNext)
          & v88710(VarNext) ) ) ) ).

tff(writeUnaryOperator_4183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88717(VarNext)
      <=> v88719(VarNext) ) ) ).

tff(addAssignment_53928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88719(VarNext)
      <=> v88710(VarCurr) ) ) ).

tff(addAssignment_53927,axiom,
    ! [VarCurr: state_type] :
      ( v88710(VarCurr)
    <=> v88712(VarCurr) ) ).

tff(addAssignment_53926,axiom,
    ! [VarCurr: state_type] :
      ( v88712(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53925,axiom,
    ! [VarCurr: state_type] :
      ( v88675(VarCurr)
    <=> v88677(VarCurr) ) ).

tff(addAssignment_53924,axiom,
    ! [VarCurr: state_type] :
      ( v88677(VarCurr)
    <=> v88679(VarCurr) ) ).

tff(addAssignment_53923,axiom,
    ! [VarCurr: state_type] :
      ( v88679(VarCurr)
    <=> v88681(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88683(VarCurr)
     => ( v88681(VarCurr)
      <=> v88705(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_537,axiom,
    ! [VarCurr: state_type] :
      ( v88683(VarCurr)
     => ( v88681(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88706(VarCurr)
     => ( v88705(VarCurr)
      <=> v88661(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_536,axiom,
    ! [VarCurr: state_type] :
      ( v88706(VarCurr)
     => ( v88705(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8379,axiom,
    ! [VarCurr: state_type] :
      ( v88706(VarCurr)
    <=> ( v88707(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_432,axiom,
    ! [VarCurr: state_type] :
      ( v88707(VarCurr)
    <=> ( ( v88372(VarCurr,4)
        <=> v88708(VarCurr,4) )
        & ( v88372(VarCurr,3)
        <=> v88708(VarCurr,3) )
        & ( v88372(VarCurr,2)
        <=> v88708(VarCurr,2) )
        & ( v88372(VarCurr,1)
        <=> v88708(VarCurr,1) )
        & ( v88372(VarCurr,0)
        <=> v88708(VarCurr,0) ) ) ) ).

tff(addAssignment_53922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88708(VarCurr,B)
      <=> v88689(VarCurr,B) ) ) ).

tff(addAssignment_53921,axiom,
    ! [VarCurr: state_type] :
      ( v88708(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_53920,axiom,
    ! [VarCurr: state_type] :
      ( v88689(VarCurr,3)
    <=> v87580(VarCurr) ) ).

tff(addAssignment_53919,axiom,
    ! [VarCurr: state_type] :
      ( v88689(VarCurr,0)
    <=> v88702(VarCurr) ) ).

tff(addAssignment_53918,axiom,
    ! [VarCurr: state_type] :
      ( v88689(VarCurr,1)
    <=> v88700(VarCurr) ) ).

tff(addAssignment_53917,axiom,
    ! [VarCurr: state_type] :
      ( v88689(VarCurr,2)
    <=> v88692(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8378,axiom,
    ! [VarCurr: state_type] :
      ( v88700(VarCurr)
    <=> ( v88701(VarCurr)
        & v88703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8377,axiom,
    ! [VarCurr: state_type] :
      ( v88703(VarCurr)
    <=> ( v87669(VarCurr,0)
        | v88697(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_840,axiom,
    ! [VarCurr: state_type] :
      ( v88701(VarCurr)
    <=> ( v88702(VarCurr)
        | v87669(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88702(VarCurr)
    <=> v87669(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8376,axiom,
    ! [VarCurr: state_type] :
      ( v88692(VarCurr)
    <=> ( v88693(VarCurr)
        & v88698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8375,axiom,
    ! [VarCurr: state_type] :
      ( v88698(VarCurr)
    <=> ( v88695(VarCurr)
        | v88699(VarCurr) ) ) ).

tff(writeUnaryOperator_4181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88699(VarCurr)
    <=> v87669(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_839,axiom,
    ! [VarCurr: state_type] :
      ( v88693(VarCurr)
    <=> ( v88694(VarCurr)
        | v87669(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88694(VarCurr)
    <=> v88695(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_838,axiom,
    ! [VarCurr: state_type] :
      ( v88695(VarCurr)
    <=> ( v87669(VarCurr,1)
        | v88696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8374,axiom,
    ! [VarCurr: state_type] :
      ( v88696(VarCurr)
    <=> ( v87669(VarCurr,0)
        & v88697(VarCurr) ) ) ).

tff(writeUnaryOperator_4179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88697(VarCurr)
    <=> v87669(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88685(VarCurr)
     => ( v88683(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_535,axiom,
    ! [VarCurr: state_type] :
      ( v88685(VarCurr)
     => ( v88683(VarCurr)
      <=> $true ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8373,axiom,
    ! [VarCurr: state_type] :
      ( v88685(VarCurr)
    <=> ( v88686(VarCurr)
        & v88687(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_431,axiom,
    ! [VarCurr: state_type] :
      ( v88687(VarCurr)
    <=> ( ( v84299(VarCurr,4)
        <=> $false )
        & ( v84299(VarCurr,3)
        <=> $false )
        & ( v84299(VarCurr,2)
        <=> $true )
        & ( v84299(VarCurr,1)
        <=> $false )
        & ( v84299(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeUnaryOperator_4178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88686(VarCurr)
    <=> v84321(VarCurr) ) ).

tff(addAssignment_53916,axiom,
    ! [VarCurr: state_type] :
      ( v88671(VarCurr)
    <=> v88673(VarCurr) ) ).

tff(addAssignment_53915,axiom,
    ! [VarCurr: state_type] :
      ( v88673(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53914,axiom,
    ! [VarCurr: state_type] :
      ( v88667(VarCurr)
    <=> v88669(VarCurr) ) ).

tff(addAssignment_53913,axiom,
    ! [VarCurr: state_type] :
      ( v88669(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53912,axiom,
    ! [VarCurr: state_type] :
      ( v88649(VarCurr)
    <=> v88651(VarCurr) ) ).

tff(addAssignment_53911,axiom,
    ! [VarCurr: state_type] :
      ( v88651(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53910,axiom,
    ! [VarCurr: state_type] :
      ( v88645(VarCurr)
    <=> v88647(VarCurr) ) ).

tff(addAssignment_53909,axiom,
    ! [VarCurr: state_type] :
      ( v88647(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53908,axiom,
    ! [VarCurr: state_type] :
      ( v88625(VarCurr)
    <=> v88627(VarCurr) ) ).

tff(addAssignment_53907,axiom,
    ! [VarCurr: state_type] :
      ( v88627(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53906,axiom,
    ! [VarCurr: state_type] :
      ( v88621(VarCurr)
    <=> v88623(VarCurr) ) ).

tff(addAssignment_53905,axiom,
    ! [VarCurr: state_type] :
      ( v88623(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_430,axiom,
    ! [VarCurr: state_type] :
      ( v88394(VarCurr)
    <=> ( ( v88396(VarCurr,6)
        <=> $false )
        & ( v88396(VarCurr,5)
        <=> $false )
        & ( v88396(VarCurr,4)
        <=> $false )
        & ( v88396(VarCurr,3)
        <=> $false )
        & ( v88396(VarCurr,2)
        <=> $false )
        & ( v88396(VarCurr,1)
        <=> $false )
        & ( v88396(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88396(VarCurr,B)
      <=> v88398(VarCurr,B) ) ) ).

tff(addAssignment_53903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88398(VarCurr,B)
      <=> v88400(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88597(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88400(VarNext,B)
            <=> v88400(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1013,axiom,
    ! [VarNext: state_type] :
      ( v88597(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88400(VarNext,B)
          <=> v88607(VarNext,B) ) ) ) ).

tff(addAssignment_53902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88607(VarNext,B)
          <=> v88605(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88608(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88605(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_534,axiom,
    ! [VarCurr: state_type] :
      ( v88608(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88605(VarCurr,B)
          <=> v88410(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8372,axiom,
    ! [VarCurr: state_type] :
      ( v88608(VarCurr)
    <=> ( v88609(VarCurr)
        & v88610(VarCurr) ) ) ).

tff(writeUnaryOperator_4177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88610(VarCurr)
    <=> v88406(VarCurr) ) ).

tff(writeUnaryOperator_4176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88609(VarCurr)
    <=> v88402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88597(VarNext)
      <=> v88598(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88598(VarNext)
      <=> ( v88599(VarNext)
          & v88592(VarNext) ) ) ) ).

tff(writeUnaryOperator_4175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88599(VarNext)
      <=> v88601(VarNext) ) ) ).

tff(addAssignment_53901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88601(VarNext)
      <=> v88592(VarCurr) ) ) ).

tff(addAssignment_53900,axiom,
    ! [VarCurr: state_type] :
      ( v88592(VarCurr)
    <=> v88594(VarCurr) ) ).

tff(addAssignment_53899,axiom,
    ! [VarCurr: state_type] :
      ( v88594(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53898,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88410(VarCurr,B)
      <=> v88412(VarCurr,B) ) ) ).

tff(addAssignment_53897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88412(VarCurr,B)
      <=> v88414(VarCurr,B) ) ) ).

tff(addAssignment_53896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88414(VarCurr,B)
      <=> v88416(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88546(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88416(VarCurr,B)
          <=> v88547(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_533,axiom,
    ! [VarCurr: state_type] :
      ( v88546(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88416(VarCurr,B)
          <=> v88425(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88548(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88547(VarCurr,B)
          <=> v88549(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_532,axiom,
    ! [VarCurr: state_type] :
      ( v88548(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88547(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_53895,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,0)
    <=> v88589(VarCurr) ) ).

tff(addAssignment_53894,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,1)
    <=> v88587(VarCurr) ) ).

tff(addAssignment_53893,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,2)
    <=> v88583(VarCurr) ) ).

tff(addAssignment_53892,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,3)
    <=> v88579(VarCurr) ) ).

tff(addAssignment_53891,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,4)
    <=> v88575(VarCurr) ) ).

tff(addAssignment_53890,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,5)
    <=> v88571(VarCurr) ) ).

tff(addAssignment_53889,axiom,
    ! [VarCurr: state_type] :
      ( v88549(VarCurr,6)
    <=> v88551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8369,axiom,
    ! [VarCurr: state_type] :
      ( v88587(VarCurr)
    <=> ( v88588(VarCurr)
        & v88590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8368,axiom,
    ! [VarCurr: state_type] :
      ( v88590(VarCurr)
    <=> ( v88396(VarCurr,0)
        | v88564(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_837,axiom,
    ! [VarCurr: state_type] :
      ( v88588(VarCurr)
    <=> ( v88589(VarCurr)
        | v88396(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88589(VarCurr)
    <=> v88396(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8367,axiom,
    ! [VarCurr: state_type] :
      ( v88583(VarCurr)
    <=> ( v88584(VarCurr)
        & v88586(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8366,axiom,
    ! [VarCurr: state_type] :
      ( v88586(VarCurr)
    <=> ( v88562(VarCurr)
        | v88565(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_836,axiom,
    ! [VarCurr: state_type] :
      ( v88584(VarCurr)
    <=> ( v88585(VarCurr)
        | v88396(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88585(VarCurr)
    <=> v88562(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8365,axiom,
    ! [VarCurr: state_type] :
      ( v88579(VarCurr)
    <=> ( v88580(VarCurr)
        & v88582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8364,axiom,
    ! [VarCurr: state_type] :
      ( v88582(VarCurr)
    <=> ( v88560(VarCurr)
        | v88566(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_835,axiom,
    ! [VarCurr: state_type] :
      ( v88580(VarCurr)
    <=> ( v88581(VarCurr)
        | v88396(VarCurr,3) ) ) ).

tff(writeUnaryOperator_4172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88581(VarCurr)
    <=> v88560(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8363,axiom,
    ! [VarCurr: state_type] :
      ( v88575(VarCurr)
    <=> ( v88576(VarCurr)
        & v88578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8362,axiom,
    ! [VarCurr: state_type] :
      ( v88578(VarCurr)
    <=> ( v88558(VarCurr)
        | v88567(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_834,axiom,
    ! [VarCurr: state_type] :
      ( v88576(VarCurr)
    <=> ( v88577(VarCurr)
        | v88396(VarCurr,4) ) ) ).

tff(writeUnaryOperator_4171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88577(VarCurr)
    <=> v88558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8361,axiom,
    ! [VarCurr: state_type] :
      ( v88571(VarCurr)
    <=> ( v88572(VarCurr)
        & v88574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8360,axiom,
    ! [VarCurr: state_type] :
      ( v88574(VarCurr)
    <=> ( v88556(VarCurr)
        | v88568(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_833,axiom,
    ! [VarCurr: state_type] :
      ( v88572(VarCurr)
    <=> ( v88573(VarCurr)
        | v88396(VarCurr,5) ) ) ).

tff(writeUnaryOperator_4170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88573(VarCurr)
    <=> v88556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8359,axiom,
    ! [VarCurr: state_type] :
      ( v88551(VarCurr)
    <=> ( v88552(VarCurr)
        & v88569(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8358,axiom,
    ! [VarCurr: state_type] :
      ( v88569(VarCurr)
    <=> ( v88554(VarCurr)
        | v88570(VarCurr) ) ) ).

tff(writeUnaryOperator_4169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88570(VarCurr)
    <=> v88396(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_832,axiom,
    ! [VarCurr: state_type] :
      ( v88552(VarCurr)
    <=> ( v88553(VarCurr)
        | v88396(VarCurr,6) ) ) ).

tff(writeUnaryOperator_4168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88553(VarCurr)
    <=> v88554(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_831,axiom,
    ! [VarCurr: state_type] :
      ( v88554(VarCurr)
    <=> ( v88396(VarCurr,5)
        | v88555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8357,axiom,
    ! [VarCurr: state_type] :
      ( v88555(VarCurr)
    <=> ( v88556(VarCurr)
        & v88568(VarCurr) ) ) ).

tff(writeUnaryOperator_4167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88568(VarCurr)
    <=> v88396(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_830,axiom,
    ! [VarCurr: state_type] :
      ( v88556(VarCurr)
    <=> ( v88396(VarCurr,4)
        | v88557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8356,axiom,
    ! [VarCurr: state_type] :
      ( v88557(VarCurr)
    <=> ( v88558(VarCurr)
        & v88567(VarCurr) ) ) ).

tff(writeUnaryOperator_4166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88567(VarCurr)
    <=> v88396(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_829,axiom,
    ! [VarCurr: state_type] :
      ( v88558(VarCurr)
    <=> ( v88396(VarCurr,3)
        | v88559(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8355,axiom,
    ! [VarCurr: state_type] :
      ( v88559(VarCurr)
    <=> ( v88560(VarCurr)
        & v88566(VarCurr) ) ) ).

tff(writeUnaryOperator_4165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88566(VarCurr)
    <=> v88396(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_828,axiom,
    ! [VarCurr: state_type] :
      ( v88560(VarCurr)
    <=> ( v88396(VarCurr,2)
        | v88561(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8354,axiom,
    ! [VarCurr: state_type] :
      ( v88561(VarCurr)
    <=> ( v88562(VarCurr)
        & v88565(VarCurr) ) ) ).

tff(writeUnaryOperator_4164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88565(VarCurr)
    <=> v88396(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_827,axiom,
    ! [VarCurr: state_type] :
      ( v88562(VarCurr)
    <=> ( v88396(VarCurr,1)
        | v88563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8353,axiom,
    ! [VarCurr: state_type] :
      ( v88563(VarCurr)
    <=> ( v88396(VarCurr,0)
        & v88564(VarCurr) ) ) ).

tff(writeUnaryOperator_4163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88564(VarCurr)
    <=> v88396(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_429,axiom,
    ! [VarCurr: state_type] :
      ( v88548(VarCurr)
    <=> ( ( v88396(VarCurr,6)
        <=> $false )
        & ( v88396(VarCurr,5)
        <=> $false )
        & ( v88396(VarCurr,4)
        <=> $false )
        & ( v88396(VarCurr,3)
        <=> $false )
        & ( v88396(VarCurr,2)
        <=> $false )
        & ( v88396(VarCurr,1)
        <=> $false )
        & ( v88396(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8352,axiom,
    ! [VarCurr: state_type] :
      ( v88546(VarCurr)
    <=> ( v84295(VarCurr)
        & v88418(VarCurr) ) ) ).

tff(addAssignment_53888,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,0)
    <=> v88544(VarCurr) ) ).

tff(addAssignment_53887,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,1)
    <=> v88543(VarCurr) ) ).

tff(addAssignment_53886,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,2)
    <=> v88542(VarCurr) ) ).

tff(addAssignment_53885,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,3)
    <=> v88427(VarCurr,3) ) ).

tff(addAssignment_53884,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,4)
    <=> v88427(VarCurr,4) ) ).

tff(addAssignment_53883,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,5)
    <=> v88541(VarCurr) ) ).

tff(addAssignment_53882,axiom,
    ! [VarCurr: state_type] :
      ( v88425(VarCurr,6)
    <=> v88427(VarCurr,6) ) ).

tff(writeUnaryOperator_4162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88544(VarCurr)
    <=> v88427(VarCurr,0) ) ).

tff(writeUnaryOperator_4161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88543(VarCurr)
    <=> v88427(VarCurr,1) ) ).

tff(writeUnaryOperator_4160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88542(VarCurr)
    <=> v88427(VarCurr,2) ) ).

tff(writeUnaryOperator_4159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88541(VarCurr)
    <=> v88427(VarCurr,5) ) ).

tff(addAssignment_53881,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,0)
    <=> v88429(VarCurr,0) ) ).

tff(addAssignment_53880,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,0)
    <=> v88431(VarCurr,0) ) ).

tff(addAssignment_53879,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,0)
    <=> v88533(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_1012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88534(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88533(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1012,axiom,
    ! [VarNext: state_type] :
      ( v88534(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88533(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88534(VarNext)
      <=> v88535(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88535(VarNext)
      <=> ( v88537(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88537(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53878,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,0)
    <=> v88443(VarCurr,0) ) ).

tff(addAssignment_53877,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,0)
    <=> v88462(VarCurr,0) ) ).

tff(addAssignment_53876,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,0)
    <=> v88447(VarCurr,0) ) ).

tff(addAssignment_53875,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,0)
    <=> v88450(VarCurr,0) ) ).

tff(addAssignment_53874,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53873,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,1)
    <=> v88429(VarCurr,1) ) ).

tff(addAssignment_53872,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,1)
    <=> v88431(VarCurr,1) ) ).

tff(addAssignment_53871,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,1)
    <=> v88525(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_1011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88526(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88525(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1011,axiom,
    ! [VarNext: state_type] :
      ( v88526(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88525(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88526(VarNext)
      <=> v88527(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88527(VarNext)
      <=> ( v88529(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88529(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53870,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,1)
    <=> v88443(VarCurr,1) ) ).

tff(addAssignment_53869,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,1)
    <=> v88462(VarCurr,1) ) ).

tff(addAssignment_53868,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,1)
    <=> v88447(VarCurr,1) ) ).

tff(addAssignment_53867,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,1)
    <=> v88450(VarCurr,1) ) ).

tff(addAssignment_53866,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_53865,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,2)
    <=> v88429(VarCurr,2) ) ).

tff(addAssignment_53864,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,2)
    <=> v88431(VarCurr,2) ) ).

tff(addAssignment_53863,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,2)
    <=> v88517(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88518(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88517(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1010,axiom,
    ! [VarNext: state_type] :
      ( v88518(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88517(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88518(VarNext)
      <=> v88519(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88519(VarNext)
      <=> ( v88521(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88521(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53862,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,2)
    <=> v88443(VarCurr,2) ) ).

tff(addAssignment_53861,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,2)
    <=> v88462(VarCurr,2) ) ).

tff(addAssignment_53860,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,2)
    <=> v88447(VarCurr,2) ) ).

tff(addAssignment_53859,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,2)
    <=> v88450(VarCurr,2) ) ).

tff(addAssignment_53858,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_53857,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,3)
    <=> v88429(VarCurr,3) ) ).

tff(addAssignment_53856,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,3)
    <=> v88431(VarCurr,3) ) ).

tff(addAssignment_53855,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,3)
    <=> v88509(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88510(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88509(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1009,axiom,
    ! [VarNext: state_type] :
      ( v88510(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88509(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88510(VarNext)
      <=> v88511(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88511(VarNext)
      <=> ( v88513(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88513(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53854,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,3)
    <=> v88443(VarCurr,3) ) ).

tff(addAssignment_53853,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,3)
    <=> v88462(VarCurr,3) ) ).

tff(addAssignment_53852,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,3)
    <=> v88447(VarCurr,3) ) ).

tff(addAssignment_53851,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,3)
    <=> v88450(VarCurr,3) ) ).

tff(addAssignment_53850,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_53849,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,4)
    <=> v88429(VarCurr,4) ) ).

tff(addAssignment_53848,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,4)
    <=> v88431(VarCurr,4) ) ).

tff(addAssignment_53847,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,4)
    <=> v88501(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_1008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88502(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88501(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1008,axiom,
    ! [VarNext: state_type] :
      ( v88502(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88501(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88502(VarNext)
      <=> v88503(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88503(VarNext)
      <=> ( v88505(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88505(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53846,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,4)
    <=> v88443(VarCurr,4) ) ).

tff(addAssignment_53845,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,4)
    <=> v88462(VarCurr,4) ) ).

tff(addAssignment_53844,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,4)
    <=> v88447(VarCurr,4) ) ).

tff(addAssignment_53843,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,4)
    <=> v88450(VarCurr,4) ) ).

tff(addAssignment_53842,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,4)
    <=> v1119(VarCurr,4) ) ).

tff(addAssignment_53841,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,5)
    <=> v88429(VarCurr,5) ) ).

tff(addAssignment_53840,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,5)
    <=> v88431(VarCurr,5) ) ).

tff(addAssignment_53839,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,5)
    <=> v88493(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88494(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88493(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1007,axiom,
    ! [VarNext: state_type] :
      ( v88494(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88493(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88494(VarNext)
      <=> v88495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88495(VarNext)
      <=> ( v88497(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88497(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53838,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,5)
    <=> v88443(VarCurr,5) ) ).

tff(addAssignment_53837,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,5)
    <=> v88462(VarCurr,5) ) ).

tff(addAssignment_53836,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,5)
    <=> v88447(VarCurr,5) ) ).

tff(addAssignment_53835,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,5)
    <=> v88450(VarCurr,5) ) ).

tff(addAssignment_53834,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,5)
    <=> v1119(VarCurr,5) ) ).

tff(addAssignment_53833,axiom,
    ! [VarCurr: state_type] :
      ( v88427(VarCurr,6)
    <=> v88429(VarCurr,6) ) ).

tff(addAssignment_53832,axiom,
    ! [VarCurr: state_type] :
      ( v88429(VarCurr,6)
    <=> v88431(VarCurr,6) ) ).

tff(addAssignment_53831,axiom,
    ! [VarNext: state_type] :
      ( v88431(VarNext,6)
    <=> v88475(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_1006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88476(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v88475(VarNext,B)
            <=> v88431(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1006,axiom,
    ! [VarNext: state_type] :
      ( v88476(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88475(VarNext,B)
          <=> v88486(VarNext,B) ) ) ) ).

tff(addAssignment_53830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88486(VarNext,B)
          <=> v88484(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88484(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_531,axiom,
    ! [VarCurr: state_type] :
      ( v88487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v88484(VarCurr,B)
          <=> v88441(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8339,axiom,
    ! [VarCurr: state_type] :
      ( v88487(VarCurr)
    <=> ( v88488(VarCurr)
        & v88489(VarCurr) ) ) ).

tff(writeUnaryOperator_4152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88489(VarCurr)
    <=> v88437(VarCurr) ) ).

tff(writeUnaryOperator_4151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88488(VarCurr)
    <=> v88433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88476(VarNext)
      <=> v88477(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88477(VarNext)
      <=> ( v88478(VarNext)
          & v88471(VarNext) ) ) ) ).

tff(writeUnaryOperator_4150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88478(VarNext)
      <=> v88480(VarNext) ) ) ).

tff(addAssignment_53829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88480(VarNext)
      <=> v88471(VarCurr) ) ) ).

tff(addAssignment_53828,axiom,
    ! [VarCurr: state_type] :
      ( v88471(VarCurr)
    <=> v88473(VarCurr) ) ).

tff(addAssignment_53827,axiom,
    ! [VarCurr: state_type] :
      ( v88473(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53826,axiom,
    ! [VarCurr: state_type] :
      ( v88441(VarCurr,6)
    <=> v88443(VarCurr,6) ) ).

tff(addAssignment_53825,axiom,
    ! [VarCurr: state_type] :
      ( v88443(VarCurr,6)
    <=> v88462(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88462(VarCurr,B)
      <=> ( v88463(VarCurr,B)
          | v88466(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88466(VarCurr,B)
      <=> ( v88429(VarCurr,B)
          & v88467(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88467(VarCurr,B)
      <=> ~ v88468(VarCurr,B) ) ) ).

tff(addAssignment_53824,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,0)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53823,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,1)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53822,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,2)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53821,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,3)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53820,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,4)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53819,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,5)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53818,axiom,
    ! [VarCurr: state_type] :
      ( v88468(VarCurr,6)
    <=> v88469(VarCurr) ) ).

tff(addAssignment_53817,axiom,
    ! [VarCurr: state_type] :
      ( v88469(VarCurr)
    <=> v88456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v88463(VarCurr,B)
      <=> ( v88445(VarCurr,B)
          & v88464(VarCurr,B) ) ) ) ).

tff(addAssignment_53816,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,0)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53815,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,1)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53814,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,2)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53813,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,3)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53812,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,4)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53811,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,5)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53810,axiom,
    ! [VarCurr: state_type] :
      ( v88464(VarCurr,6)
    <=> v88465(VarCurr) ) ).

tff(addAssignment_53809,axiom,
    ! [VarCurr: state_type] :
      ( v88465(VarCurr)
    <=> v88456(VarCurr) ) ).

tff(addAssignment_53808,axiom,
    ! [VarCurr: state_type] :
      ( v88456(VarCurr)
    <=> v88458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8336,axiom,
    ! [VarCurr: state_type] :
      ( v88458(VarCurr)
    <=> ( v1729(VarCurr)
        & v88461(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_428,axiom,
    ! [VarCurr: state_type] :
      ( v88461(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1234,axiom,
    ~ b0000011001000(12) ).

tff(bitBlastConstant_1233,axiom,
    ~ b0000011001000(11) ).

tff(bitBlastConstant_1232,axiom,
    ~ b0000011001000(10) ).

tff(bitBlastConstant_1231,axiom,
    ~ b0000011001000(9) ).

tff(bitBlastConstant_1230,axiom,
    ~ b0000011001000(8) ).

tff(bitBlastConstant_1229,axiom,
    b0000011001000(7) ).

tff(bitBlastConstant_1228,axiom,
    b0000011001000(6) ).

tff(bitBlastConstant_1227,axiom,
    ~ b0000011001000(5) ).

tff(bitBlastConstant_1226,axiom,
    ~ b0000011001000(4) ).

tff(bitBlastConstant_1225,axiom,
    b0000011001000(3) ).

tff(bitBlastConstant_1224,axiom,
    ~ b0000011001000(2) ).

tff(bitBlastConstant_1223,axiom,
    ~ b0000011001000(1) ).

tff(bitBlastConstant_1222,axiom,
    ~ b0000011001000(0) ).

tff(addAssignment_53807,axiom,
    ! [VarCurr: state_type] :
      ( v88445(VarCurr,6)
    <=> v88447(VarCurr,6) ) ).

tff(addAssignment_53806,axiom,
    ! [VarCurr: state_type] :
      ( v88447(VarCurr,6)
    <=> v88450(VarCurr,6) ) ).

tff(addAssignment_53805,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,0)
    <=> v88454(VarCurr) ) ).

tff(addAssignment_53804,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,1)
    <=> v88453(VarCurr) ) ).

tff(addAssignment_53803,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,2)
    <=> v88452(VarCurr) ) ).

tff(addAssignment_53802,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,3)
    <=> v88449(VarCurr,3) ) ).

tff(addAssignment_53801,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,4)
    <=> v88449(VarCurr,4) ) ).

tff(addAssignment_53800,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,5)
    <=> v88451(VarCurr) ) ).

tff(addAssignment_53799,axiom,
    ! [VarCurr: state_type] :
      ( v88450(VarCurr,6)
    <=> v88449(VarCurr,6) ) ).

tff(writeUnaryOperator_4148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88454(VarCurr)
    <=> v88449(VarCurr,0) ) ).

tff(writeUnaryOperator_4147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88453(VarCurr)
    <=> v88449(VarCurr,1) ) ).

tff(writeUnaryOperator_4146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88452(VarCurr)
    <=> v88449(VarCurr,2) ) ).

tff(writeUnaryOperator_4145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88451(VarCurr)
    <=> v88449(VarCurr,5) ) ).

tff(addAssignment_53798,axiom,
    ! [VarCurr: state_type] :
      ( v88449(VarCurr,6)
    <=> v1119(VarCurr,6) ) ).

tff(addAssignment_53797,axiom,
    ! [VarCurr: state_type] :
      ( v88437(VarCurr)
    <=> v88439(VarCurr) ) ).

tff(addAssignment_53796,axiom,
    ! [VarCurr: state_type] :
      ( v88439(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53795,axiom,
    ! [VarCurr: state_type] :
      ( v88433(VarCurr)
    <=> v88435(VarCurr) ) ).

tff(addAssignment_53794,axiom,
    ! [VarCurr: state_type] :
      ( v88435(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(writeUnaryOperator_4144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88418(VarCurr)
    <=> v88420(VarCurr) ) ).

tff(addAssignment_53793,axiom,
    ! [VarCurr: state_type] :
      ( v88420(VarCurr)
    <=> v88422(VarCurr) ) ).

tff(addAssignment_53792,axiom,
    ! [VarCurr: state_type] :
      ( v88422(VarCurr)
    <=> v4516(VarCurr) ) ).

tff(addAssignment_53791,axiom,
    ! [VarCurr: state_type] :
      ( v88406(VarCurr)
    <=> v88408(VarCurr) ) ).

tff(addAssignment_53790,axiom,
    ! [VarCurr: state_type] :
      ( v88408(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53789,axiom,
    ! [VarCurr: state_type] :
      ( v88402(VarCurr)
    <=> v88404(VarCurr) ) ).

tff(addAssignment_53788,axiom,
    ! [VarCurr: state_type] :
      ( v88404(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53787,axiom,
    ! [VarCurr: state_type] :
      ( v88382(VarCurr)
    <=> v88384(VarCurr) ) ).

tff(addAssignment_53786,axiom,
    ! [VarCurr: state_type] :
      ( v88384(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53785,axiom,
    ! [VarCurr: state_type] :
      ( v88378(VarCurr)
    <=> v88380(VarCurr) ) ).

tff(addAssignment_53784,axiom,
    ! [VarCurr: state_type] :
      ( v88380(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v86883(VarCurr,B)
      <=> ( v88352(VarCurr,B)
          & v88354(VarCurr,B) ) ) ) ).

tff(addAssignment_53783,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,0)
    <=> v88370(VarCurr) ) ).

tff(addAssignment_53782,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,1)
    <=> v88369(VarCurr) ) ).

tff(addAssignment_53781,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,2)
    <=> v88368(VarCurr) ) ).

tff(addAssignment_53780,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,3)
    <=> v88367(VarCurr) ) ).

tff(addAssignment_53779,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,4)
    <=> v88366(VarCurr) ) ).

tff(addAssignment_53778,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,5)
    <=> v88365(VarCurr) ) ).

tff(addAssignment_53777,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,6)
    <=> v88364(VarCurr) ) ).

tff(addAssignment_53776,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,7)
    <=> v88363(VarCurr) ) ).

tff(addAssignment_53775,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,8)
    <=> v88362(VarCurr) ) ).

tff(addAssignment_53774,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,9)
    <=> v88361(VarCurr) ) ).

tff(addAssignment_53773,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,10)
    <=> v88360(VarCurr) ) ).

tff(addAssignment_53772,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,11)
    <=> v88359(VarCurr) ) ).

tff(addAssignment_53771,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,12)
    <=> v88358(VarCurr) ) ).

tff(addAssignment_53770,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,13)
    <=> v88357(VarCurr) ) ).

tff(addAssignment_53769,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,14)
    <=> v88356(VarCurr) ) ).

tff(addAssignment_53768,axiom,
    ! [VarCurr: state_type] :
      ( v88354(VarCurr,15)
    <=> v88355(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_427,axiom,
    ! [VarCurr: state_type] :
      ( v88370(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_426,axiom,
    ! [VarCurr: state_type] :
      ( v88369(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_425,axiom,
    ! [VarCurr: state_type] :
      ( v88368(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_424,axiom,
    ! [VarCurr: state_type] :
      ( v88367(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_423,axiom,
    ! [VarCurr: state_type] :
      ( v88366(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_422,axiom,
    ! [VarCurr: state_type] :
      ( v88365(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_421,axiom,
    ! [VarCurr: state_type] :
      ( v88364(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_420,axiom,
    ! [VarCurr: state_type] :
      ( v88363(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $false )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_419,axiom,
    ! [VarCurr: state_type] :
      ( v88362(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_418,axiom,
    ! [VarCurr: state_type] :
      ( v88361(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_417,axiom,
    ! [VarCurr: state_type] :
      ( v88360(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_416,axiom,
    ! [VarCurr: state_type] :
      ( v88359(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $false )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_415,axiom,
    ! [VarCurr: state_type] :
      ( v88358(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_414,axiom,
    ! [VarCurr: state_type] :
      ( v88357(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $false )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_413,axiom,
    ! [VarCurr: state_type] :
      ( v88356(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_412,axiom,
    ! [VarCurr: state_type] :
      ( v88355(VarCurr)
    <=> ( ( v86950(VarCurr,3)
        <=> $true )
        & ( v86950(VarCurr,2)
        <=> $true )
        & ( v86950(VarCurr,1)
        <=> $true )
        & ( v86950(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_53767,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,0)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53766,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,1)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53765,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,2)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53764,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,3)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53763,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,4)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53762,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,5)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53761,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,6)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53760,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,7)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53759,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,8)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53758,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,9)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53757,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,10)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53756,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,11)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53755,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,12)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53754,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,13)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53753,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,14)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53752,axiom,
    ! [VarCurr: state_type] :
      ( v88352(VarCurr,15)
    <=> v88353(VarCurr) ) ).

tff(addAssignment_53751,axiom,
    ! [VarCurr: state_type] :
      ( v88353(VarCurr)
    <=> v86885(VarCurr) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_11,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87990(VarCurr)
     => ( v86950(VarCurr,3)
      <=> v88350(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_29,axiom,
    ! [VarCurr: state_type] :
      ( v87990(VarCurr)
     => ( v86950(VarCurr,3)
      <=> v88349(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_10,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ( v88350(VarCurr)
      <=> v88266(VarCurr,1) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_530,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ( v88350(VarCurr)
      <=> v88266(VarCurr,0) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ( v88349(VarCurr)
      <=> v88266(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_529,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ( v88349(VarCurr)
      <=> v88078(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_9,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87990(VarCurr)
     => ( v86950(VarCurr,2)
      <=> v88347(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_528,axiom,
    ! [VarCurr: state_type] :
      ( v87990(VarCurr)
     => ( v86950(VarCurr,2)
      <=> v86952(VarCurr,2) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87580(VarCurr)
     => ( v88347(VarCurr)
      <=> v88266(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_527,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
     => ( v88347(VarCurr)
      <=> v88078(VarCurr) ) ) ).

tff(addAssignment_53750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86950(VarCurr,B)
      <=> v86952(VarCurr,B) ) ) ).

tff(addAssignment_53749,axiom,
    ! [VarCurr: state_type] :
      ( v88266(VarCurr,1)
    <=> v88268(VarCurr,1) ) ).

tff(addAssignment_53748,axiom,
    ! [VarCurr: state_type] :
      ( v88268(VarCurr,1)
    <=> v88291(VarCurr,1) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_8,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88327(VarCurr)
     => ( v88278(VarCurr,1)
      <=> v88331(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_28,axiom,
    ! [VarCurr: state_type] :
      ( v88327(VarCurr)
     => ( v88278(VarCurr,1)
      <=> v87204(VarCurr,23) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88332(VarCurr)
     => ( v88331(VarCurr)
      <=> v88336(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_27,axiom,
    ! [VarCurr: state_type] :
      ( v88332(VarCurr)
     => ( v88331(VarCurr)
      <=> v87204(VarCurr,24) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88337(VarCurr)
     => ( v88336(VarCurr)
      <=> v88341(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_26,axiom,
    ! [VarCurr: state_type] :
      ( v88337(VarCurr)
     => ( v88336(VarCurr)
      <=> v87204(VarCurr,25) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88342(VarCurr)
     => ( v88341(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_25,axiom,
    ! [VarCurr: state_type] :
      ( v88342(VarCurr)
     => ( v88341(VarCurr)
      <=> v87204(VarCurr,26) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8335,axiom,
    ! [VarCurr: state_type] :
      ( v88342(VarCurr)
    <=> ( v88343(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8334,axiom,
    ! [VarCurr: state_type] :
      ( v88343(VarCurr)
    <=> ( v88344(VarCurr)
        & v88345(VarCurr) ) ) ).

tff(writeUnaryOperator_4143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88345(VarCurr)
    <=> v87774(VarCurr) ) ).

tff(writeUnaryOperator_4142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88344(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8333,axiom,
    ! [VarCurr: state_type] :
      ( v88337(VarCurr)
    <=> ( v88338(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8332,axiom,
    ! [VarCurr: state_type] :
      ( v88338(VarCurr)
    <=> ( v88339(VarCurr)
        & v88340(VarCurr) ) ) ).

tff(writeUnaryOperator_4141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88340(VarCurr)
    <=> v87774(VarCurr) ) ).

tff(writeUnaryOperator_4140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88339(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8331,axiom,
    ! [VarCurr: state_type] :
      ( v88332(VarCurr)
    <=> ( v88333(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8330,axiom,
    ! [VarCurr: state_type] :
      ( v88333(VarCurr)
    <=> ( v88334(VarCurr)
        & v88335(VarCurr) ) ) ).

tff(writeUnaryOperator_4139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88335(VarCurr)
    <=> v87774(VarCurr) ) ).

tff(writeUnaryOperator_4138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88334(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8329,axiom,
    ! [VarCurr: state_type] :
      ( v88327(VarCurr)
    <=> ( v88328(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8328,axiom,
    ! [VarCurr: state_type] :
      ( v88328(VarCurr)
    <=> ( v88329(VarCurr)
        & v88330(VarCurr) ) ) ).

tff(writeUnaryOperator_4137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88330(VarCurr)
    <=> v87774(VarCurr) ) ).

tff(writeUnaryOperator_4136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88329(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_7,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88293(VarCurr)
     => ( v88270(VarCurr,1)
      <=> v88298(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_24,axiom,
    ! [VarCurr: state_type] :
      ( v88293(VarCurr)
     => ( v88270(VarCurr,1)
      <=> v88294(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88299(VarCurr)
     => ( v88298(VarCurr)
      <=> v88302(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_23,axiom,
    ! [VarCurr: state_type] :
      ( v88299(VarCurr)
     => ( v88298(VarCurr)
      <=> v86956(VarCurr,24) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88303(VarCurr)
     => ( v88302(VarCurr)
      <=> v88309(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_22,axiom,
    ! [VarCurr: state_type] :
      ( v88303(VarCurr)
     => ( v88302(VarCurr)
      <=> v86956(VarCurr,25) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88310(VarCurr)
     => ( v88309(VarCurr)
      <=> v88316(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_21,axiom,
    ! [VarCurr: state_type] :
      ( v88310(VarCurr)
     => ( v88309(VarCurr)
      <=> v86956(VarCurr,26) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88317(VarCurr)
     => ( v88316(VarCurr)
      <=> v88323(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_20,axiom,
    ! [VarCurr: state_type] :
      ( v88317(VarCurr)
     => ( v88316(VarCurr)
      <=> v86956(VarCurr,27) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88324(VarCurr)
     => ( v88323(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_19,axiom,
    ! [VarCurr: state_type] :
      ( v88324(VarCurr)
     => ( v88323(VarCurr)
      <=> v86956(VarCurr,28) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8327,axiom,
    ! [VarCurr: state_type] :
      ( v88324(VarCurr)
    <=> ( v88325(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8326,axiom,
    ! [VarCurr: state_type] :
      ( v88325(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8325,axiom,
    ! [VarCurr: state_type] :
      ( v88317(VarCurr)
    <=> ( v88318(VarCurr)
        | v88320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8324,axiom,
    ! [VarCurr: state_type] :
      ( v88320(VarCurr)
    <=> ( v88321(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8323,axiom,
    ! [VarCurr: state_type] :
      ( v88321(VarCurr)
    <=> ( v88145(VarCurr)
        & v88322(VarCurr) ) ) ).

tff(writeUnaryOperator_4135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88322(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8322,axiom,
    ! [VarCurr: state_type] :
      ( v88318(VarCurr)
    <=> ( v88319(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8321,axiom,
    ! [VarCurr: state_type] :
      ( v88319(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8320,axiom,
    ! [VarCurr: state_type] :
      ( v88310(VarCurr)
    <=> ( v88311(VarCurr)
        | v88313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8319,axiom,
    ! [VarCurr: state_type] :
      ( v88313(VarCurr)
    <=> ( v88314(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8318,axiom,
    ! [VarCurr: state_type] :
      ( v88314(VarCurr)
    <=> ( v88145(VarCurr)
        & v88315(VarCurr) ) ) ).

tff(writeUnaryOperator_4134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88315(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8317,axiom,
    ! [VarCurr: state_type] :
      ( v88311(VarCurr)
    <=> ( v88312(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8316,axiom,
    ! [VarCurr: state_type] :
      ( v88312(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8315,axiom,
    ! [VarCurr: state_type] :
      ( v88303(VarCurr)
    <=> ( v88304(VarCurr)
        | v88306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8314,axiom,
    ! [VarCurr: state_type] :
      ( v88306(VarCurr)
    <=> ( v88307(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8313,axiom,
    ! [VarCurr: state_type] :
      ( v88307(VarCurr)
    <=> ( v88145(VarCurr)
        & v88308(VarCurr) ) ) ).

tff(writeUnaryOperator_4133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88308(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8312,axiom,
    ! [VarCurr: state_type] :
      ( v88304(VarCurr)
    <=> ( v88305(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8311,axiom,
    ! [VarCurr: state_type] :
      ( v88305(VarCurr)
    <=> ( v88145(VarCurr)
        & v87578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8310,axiom,
    ! [VarCurr: state_type] :
      ( v88299(VarCurr)
    <=> ( v88300(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8309,axiom,
    ! [VarCurr: state_type] :
      ( v88300(VarCurr)
    <=> ( v88145(VarCurr)
        & v88301(VarCurr) ) ) ).

tff(writeUnaryOperator_4132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88301(VarCurr)
    <=> v87578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8308,axiom,
    ! [VarCurr: state_type] :
      ( v88294(VarCurr)
    <=> ( v88295(VarCurr)
        | v88297(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_826,axiom,
    ! [VarCurr: state_type] :
      ( v88297(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_825,axiom,
    ! [VarCurr: state_type] :
      ( v88295(VarCurr)
    <=> ( v88296(VarCurr)
        & v86956(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88296(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8307,axiom,
    ! [VarCurr: state_type] :
      ( v88293(VarCurr)
    <=> ( v87798(VarCurr)
        | v88157(VarCurr) ) ) ).

tff(addAssignment_53747,axiom,
    ! [VarCurr: state_type] :
      ( v88266(VarCurr,0)
    <=> v88268(VarCurr,0) ) ).

tff(addAssignment_53746,axiom,
    ! [VarCurr: state_type] :
      ( v88268(VarCurr,0)
    <=> v88291(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88082(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88291(VarCurr,B)
          <=> v88278(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_526,axiom,
    ! [VarCurr: state_type] :
      ( v88082(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v88291(VarCurr,B)
          <=> v88270(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88280(VarCurr)
     => ( v88278(VarCurr,0)
      <=> v88282(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_18,axiom,
    ! [VarCurr: state_type] :
      ( v88280(VarCurr)
     => ( v88278(VarCurr,0)
      <=> v87204(VarCurr,22) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88283(VarCurr)
     => ( v88282(VarCurr)
      <=> v88285(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_17,axiom,
    ! [VarCurr: state_type] :
      ( v88283(VarCurr)
     => ( v88282(VarCurr)
      <=> v87204(VarCurr,23) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88286(VarCurr)
     => ( v88285(VarCurr)
      <=> v88288(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_16,axiom,
    ! [VarCurr: state_type] :
      ( v88286(VarCurr)
     => ( v88285(VarCurr)
      <=> v87204(VarCurr,24) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88289(VarCurr)
     => ( v88288(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_15,axiom,
    ! [VarCurr: state_type] :
      ( v88289(VarCurr)
     => ( v88288(VarCurr)
      <=> v87204(VarCurr,25) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8306,axiom,
    ! [VarCurr: state_type] :
      ( v88289(VarCurr)
    <=> ( v88290(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeUnaryOperator_4130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88290(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8305,axiom,
    ! [VarCurr: state_type] :
      ( v88286(VarCurr)
    <=> ( v88287(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeUnaryOperator_4129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88287(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8304,axiom,
    ! [VarCurr: state_type] :
      ( v88283(VarCurr)
    <=> ( v88284(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeUnaryOperator_4128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88284(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8303,axiom,
    ! [VarCurr: state_type] :
      ( v88280(VarCurr)
    <=> ( v88281(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeUnaryOperator_4127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88281(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8302,axiom,
    ! [VarCurr: state_type] :
      ( v88270(VarCurr,0)
    <=> ( v88272(VarCurr)
        & v88273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8301,axiom,
    ! [VarCurr: state_type] :
      ( v88273(VarCurr)
    <=> ( v88274(VarCurr)
        | v88276(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_824,axiom,
    ! [VarCurr: state_type] :
      ( v88276(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_823,axiom,
    ! [VarCurr: state_type] :
      ( v88274(VarCurr)
    <=> ( v88275(VarCurr)
        & v86956(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88275(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeUnaryOperator_4125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88272(VarCurr)
    <=> v87643(VarCurr) ) ).

tff(addAssignment_53745,axiom,
    ! [VarCurr: state_type] :
      ( v88078(VarCurr)
    <=> v88080(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88082(VarCurr)
     => ( v88080(VarCurr)
      <=> v88199(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_525,axiom,
    ! [VarCurr: state_type] :
      ( v88082(VarCurr)
     => ( v88080(VarCurr)
      <=> v88143(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88213(VarCurr)
     => ( v88199(VarCurr)
      <=> v88215(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_14,axiom,
    ! [VarCurr: state_type] :
      ( v88213(VarCurr)
     => ( v88199(VarCurr)
      <=> v87204(VarCurr,22) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88216(VarCurr)
     => ( v88215(VarCurr)
      <=> v88222(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_13,axiom,
    ! [VarCurr: state_type] :
      ( v88216(VarCurr)
     => ( v88215(VarCurr)
      <=> v87204(VarCurr,23) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88223(VarCurr)
     => ( v88222(VarCurr)
      <=> v88232(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_12,axiom,
    ! [VarCurr: state_type] :
      ( v88223(VarCurr)
     => ( v88222(VarCurr)
      <=> v87204(VarCurr,24) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88233(VarCurr)
     => ( v88232(VarCurr)
      <=> v88245(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_11,axiom,
    ! [VarCurr: state_type] :
      ( v88233(VarCurr)
     => ( v88232(VarCurr)
      <=> v87204(VarCurr,25) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88246(VarCurr)
     => ( v88245(VarCurr)
      <=> v88255(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_10,axiom,
    ! [VarCurr: state_type] :
      ( v88246(VarCurr)
     => ( v88245(VarCurr)
      <=> v87204(VarCurr,26) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88256(VarCurr)
     => ( v88255(VarCurr)
      <=> v88261(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_9,axiom,
    ! [VarCurr: state_type] :
      ( v88256(VarCurr)
     => ( v88255(VarCurr)
      <=> v87204(VarCurr,27) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88262(VarCurr)
     => ( v88261(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_8,axiom,
    ! [VarCurr: state_type] :
      ( v88262(VarCurr)
     => ( v88261(VarCurr)
      <=> v87204(VarCurr,28) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8300,axiom,
    ! [VarCurr: state_type] :
      ( v88262(VarCurr)
    <=> ( v88263(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8299,axiom,
    ! [VarCurr: state_type] :
      ( v88263(VarCurr)
    <=> ( v87578(VarCurr)
        & v88157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8298,axiom,
    ! [VarCurr: state_type] :
      ( v88256(VarCurr)
    <=> ( v88257(VarCurr)
        | v88259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8297,axiom,
    ! [VarCurr: state_type] :
      ( v88259(VarCurr)
    <=> ( v88260(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8296,axiom,
    ! [VarCurr: state_type] :
      ( v88260(VarCurr)
    <=> ( v87578(VarCurr)
        & v88157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8295,axiom,
    ! [VarCurr: state_type] :
      ( v88257(VarCurr)
    <=> ( v88258(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_822,axiom,
    ! [VarCurr: state_type] :
      ( v88258(VarCurr)
    <=> ( v87578(VarCurr)
        & v87665(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8294,axiom,
    ! [VarCurr: state_type] :
      ( v88246(VarCurr)
    <=> ( v88247(VarCurr)
        | v88253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8293,axiom,
    ! [VarCurr: state_type] :
      ( v88253(VarCurr)
    <=> ( v88254(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8292,axiom,
    ! [VarCurr: state_type] :
      ( v88254(VarCurr)
    <=> ( v87578(VarCurr)
        & v88157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8291,axiom,
    ! [VarCurr: state_type] :
      ( v88247(VarCurr)
    <=> ( v88248(VarCurr)
        | v88251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8290,axiom,
    ! [VarCurr: state_type] :
      ( v88251(VarCurr)
    <=> ( v88252(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_821,axiom,
    ! [VarCurr: state_type] :
      ( v88252(VarCurr)
    <=> ( v87578(VarCurr)
        & v87665(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8289,axiom,
    ! [VarCurr: state_type] :
      ( v88248(VarCurr)
    <=> ( v88249(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8288,axiom,
    ! [VarCurr: state_type] :
      ( v88249(VarCurr)
    <=> ( v87578(VarCurr)
        & v88250(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8287,axiom,
    ! [VarCurr: state_type] :
      ( v88250(VarCurr)
    <=> ( v87774(VarCurr)
        | v87786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8286,axiom,
    ! [VarCurr: state_type] :
      ( v88233(VarCurr)
    <=> ( v88234(VarCurr)
        | v88243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8285,axiom,
    ! [VarCurr: state_type] :
      ( v88243(VarCurr)
    <=> ( v88244(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8284,axiom,
    ! [VarCurr: state_type] :
      ( v88244(VarCurr)
    <=> ( v87578(VarCurr)
        & v88157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8283,axiom,
    ! [VarCurr: state_type] :
      ( v88234(VarCurr)
    <=> ( v88235(VarCurr)
        | v88241(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8282,axiom,
    ! [VarCurr: state_type] :
      ( v88241(VarCurr)
    <=> ( v88242(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_820,axiom,
    ! [VarCurr: state_type] :
      ( v88242(VarCurr)
    <=> ( v87578(VarCurr)
        & v87665(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8281,axiom,
    ! [VarCurr: state_type] :
      ( v88235(VarCurr)
    <=> ( v88236(VarCurr)
        | v88238(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8280,axiom,
    ! [VarCurr: state_type] :
      ( v88238(VarCurr)
    <=> ( v88239(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8279,axiom,
    ! [VarCurr: state_type] :
      ( v88239(VarCurr)
    <=> ( v87578(VarCurr)
        & v88240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8278,axiom,
    ! [VarCurr: state_type] :
      ( v88240(VarCurr)
    <=> ( v87774(VarCurr)
        | v87786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8277,axiom,
    ! [VarCurr: state_type] :
      ( v88236(VarCurr)
    <=> ( v88237(VarCurr)
        & v88201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8276,axiom,
    ! [VarCurr: state_type] :
      ( v88237(VarCurr)
    <=> ( v87578(VarCurr)
        & v87643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8275,axiom,
    ! [VarCurr: state_type] :
      ( v88223(VarCurr)
    <=> ( v88224(VarCurr)
        | v88230(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8274,axiom,
    ! [VarCurr: state_type] :
      ( v88230(VarCurr)
    <=> ( v88231(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_819,axiom,
    ! [VarCurr: state_type] :
      ( v88231(VarCurr)
    <=> ( v87578(VarCurr)
        & v87665(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8273,axiom,
    ! [VarCurr: state_type] :
      ( v88224(VarCurr)
    <=> ( v88225(VarCurr)
        | v88227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8272,axiom,
    ! [VarCurr: state_type] :
      ( v88227(VarCurr)
    <=> ( v88228(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8271,axiom,
    ! [VarCurr: state_type] :
      ( v88228(VarCurr)
    <=> ( v87578(VarCurr)
        & v88229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8270,axiom,
    ! [VarCurr: state_type] :
      ( v88229(VarCurr)
    <=> ( v87774(VarCurr)
        | v87786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8269,axiom,
    ! [VarCurr: state_type] :
      ( v88225(VarCurr)
    <=> ( v88226(VarCurr)
        & v87560(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8268,axiom,
    ! [VarCurr: state_type] :
      ( v88226(VarCurr)
    <=> ( v87578(VarCurr)
        & v87643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8267,axiom,
    ! [VarCurr: state_type] :
      ( v88216(VarCurr)
    <=> ( v88217(VarCurr)
        | v88219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8266,axiom,
    ! [VarCurr: state_type] :
      ( v88219(VarCurr)
    <=> ( v88220(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8265,axiom,
    ! [VarCurr: state_type] :
      ( v88220(VarCurr)
    <=> ( v87578(VarCurr)
        & v88221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8264,axiom,
    ! [VarCurr: state_type] :
      ( v88221(VarCurr)
    <=> ( v87774(VarCurr)
        | v87786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8263,axiom,
    ! [VarCurr: state_type] :
      ( v88217(VarCurr)
    <=> ( v88218(VarCurr)
        & v87547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8262,axiom,
    ! [VarCurr: state_type] :
      ( v88218(VarCurr)
    <=> ( v87578(VarCurr)
        & v87643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8261,axiom,
    ! [VarCurr: state_type] :
      ( v88213(VarCurr)
    <=> ( v88214(VarCurr)
        & v87299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8260,axiom,
    ! [VarCurr: state_type] :
      ( v88214(VarCurr)
    <=> ( v87578(VarCurr)
        & v87643(VarCurr) ) ) ).

tff(addAssignment_53744,axiom,
    ! [VarCurr: state_type] :
      ( v88201(VarCurr)
    <=> v87301(VarCurr,3) ) ).

tff(addAssignment_53743,axiom,
    ! [VarCurr: state_type] :
      ( v87301(VarCurr,3)
    <=> v87303(VarCurr,3) ) ).

tff(addAssignment_53742,axiom,
    ! [VarNext: state_type] :
      ( v87303(VarNext,3)
    <=> v88205(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_1005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88206(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v88205(VarNext,B)
            <=> v87303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1005,axiom,
    ! [VarNext: state_type] :
      ( v88206(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88205(VarNext,B)
          <=> v87540(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88206(VarNext)
      <=> v88207(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88207(VarNext)
      <=> ( v88209(VarNext)
          & v87523(VarNext) ) ) ) ).

tff(writeUnaryOperator_4124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88209(VarNext)
      <=> v87534(VarNext) ) ) ).

tff(addAssignment_53741,axiom,
    ! [VarCurr: state_type] :
      ( v87313(VarCurr,3)
    <=> v87315(VarCurr,3) ) ).

tff(addAssignment_53740,axiom,
    ! [VarCurr: state_type] :
      ( v87315(VarCurr,3)
    <=> v87317(VarCurr,3) ) ).

tff(addAssignment_53739,axiom,
    ! [VarCurr: state_type] :
      ( v87317(VarCurr,3)
    <=> v87518(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_818,axiom,
    ! [VarCurr: state_type] :
      ( v87519(VarCurr)
    <=> ( v87321(VarCurr,1)
        & v87321(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8257,axiom,
    ! [VarCurr: state_type] :
      ( v88143(VarCurr)
    <=> ( v87578(VarCurr)
        & v88169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8256,axiom,
    ! [VarCurr: state_type] :
      ( v88169(VarCurr)
    <=> ( v88170(VarCurr)
        | v88193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8255,axiom,
    ! [VarCurr: state_type] :
      ( v88193(VarCurr)
    <=> ( v88157(VarCurr)
        & v88194(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8254,axiom,
    ! [VarCurr: state_type] :
      ( v88194(VarCurr)
    <=> ( v88195(VarCurr)
        | v88197(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_817,axiom,
    ! [VarCurr: state_type] :
      ( v88197(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_816,axiom,
    ! [VarCurr: state_type] :
      ( v88195(VarCurr)
    <=> ( v88196(VarCurr)
        & v86956(VarCurr,4) ) ) ).

tff(writeUnaryOperator_4123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88196(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8253,axiom,
    ! [VarCurr: state_type] :
      ( v88170(VarCurr)
    <=> ( v88171(VarCurr)
        | v88188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8252,axiom,
    ! [VarCurr: state_type] :
      ( v88188(VarCurr)
    <=> ( v88145(VarCurr)
        & v88189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8251,axiom,
    ! [VarCurr: state_type] :
      ( v88189(VarCurr)
    <=> ( v88190(VarCurr)
        | v88192(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_815,axiom,
    ! [VarCurr: state_type] :
      ( v88192(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_814,axiom,
    ! [VarCurr: state_type] :
      ( v88190(VarCurr)
    <=> ( v88191(VarCurr)
        & v86956(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88191(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8250,axiom,
    ! [VarCurr: state_type] :
      ( v88171(VarCurr)
    <=> ( v88172(VarCurr)
        | v88183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8249,axiom,
    ! [VarCurr: state_type] :
      ( v88183(VarCurr)
    <=> ( v87798(VarCurr)
        & v88184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8248,axiom,
    ! [VarCurr: state_type] :
      ( v88184(VarCurr)
    <=> ( v88185(VarCurr)
        | v88187(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_813,axiom,
    ! [VarCurr: state_type] :
      ( v88187(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_812,axiom,
    ! [VarCurr: state_type] :
      ( v88185(VarCurr)
    <=> ( v88186(VarCurr)
        & v86956(VarCurr,3) ) ) ).

tff(writeUnaryOperator_4121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88186(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8247,axiom,
    ! [VarCurr: state_type] :
      ( v88172(VarCurr)
    <=> ( v88173(VarCurr)
        | v88178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8246,axiom,
    ! [VarCurr: state_type] :
      ( v88178(VarCurr)
    <=> ( v87774(VarCurr)
        & v88179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8245,axiom,
    ! [VarCurr: state_type] :
      ( v88179(VarCurr)
    <=> ( v88180(VarCurr)
        | v88182(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_811,axiom,
    ! [VarCurr: state_type] :
      ( v88182(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_810,axiom,
    ! [VarCurr: state_type] :
      ( v88180(VarCurr)
    <=> ( v88181(VarCurr)
        & v86956(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88181(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8244,axiom,
    ! [VarCurr: state_type] :
      ( v88173(VarCurr)
    <=> ( v87643(VarCurr)
        & v88174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8243,axiom,
    ! [VarCurr: state_type] :
      ( v88174(VarCurr)
    <=> ( v88175(VarCurr)
        | v88177(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_809,axiom,
    ! [VarCurr: state_type] :
      ( v88177(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_808,axiom,
    ! [VarCurr: state_type] :
      ( v88175(VarCurr)
    <=> ( v88176(VarCurr)
        & v86956(VarCurr,1) ) ) ).

tff(writeUnaryOperator_4119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88176(VarCurr)
    <=> v87988(VarCurr) ) ).

tff(addAssignment_53738,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,5)
    <=> v86958(VarCurr,6) ) ).

tff(addAssignment_53737,axiom,
    ! [VarCurr: state_type] :
      ( v88157(VarCurr)
    <=> v87645(VarCurr,7) ) ).

tff(addAssignment_53736,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,7)
    <=> v87647(VarCurr,7) ) ).

tff(addAssignment_53735,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,7)
    <=> v88161(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_1004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88162(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v88161(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1004,axiom,
    ! [VarNext: state_type] :
      ( v88162(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88161(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88162(VarNext)
      <=> v88163(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88163(VarNext)
      <=> ( v88165(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88165(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53734,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,7)
    <=> v87659(VarCurr,7) ) ).

tff(addAssignment_53733,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,7)
    <=> v87661(VarCurr,7) ) ).

tff(addAssignment_53732,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,7)
    <=> v87743(VarCurr,7) ) ).

tff(addBitVectorEqualityBitBlasted_411,axiom,
    ! [VarCurr: state_type] :
      ( v87744(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $false )
        & ( v87665(VarCurr,1)
        <=> $false )
        & ( v87665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53731,axiom,
    ! [VarCurr: state_type] :
      ( v88145(VarCurr)
    <=> v87645(VarCurr,5) ) ).

tff(addAssignment_53730,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,5)
    <=> v87647(VarCurr,5) ) ).

tff(addAssignment_53729,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,5)
    <=> v88149(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_1003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88150(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v88149(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1003,axiom,
    ! [VarNext: state_type] :
      ( v88150(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v88149(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88150(VarNext)
      <=> v88151(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88151(VarNext)
      <=> ( v88153(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88153(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53728,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,5)
    <=> v87659(VarCurr,5) ) ).

tff(addAssignment_53727,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,5)
    <=> v87661(VarCurr,5) ) ).

tff(addAssignment_53726,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,5)
    <=> v87743(VarCurr,5) ) ).

tff(addBitVectorEqualityBitBlasted_410,axiom,
    ! [VarCurr: state_type] :
      ( v87746(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $true )
        & ( v87665(VarCurr,1)
        <=> $true )
        & ( v87665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53725,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,4)
    <=> v86958(VarCurr,5) ) ).

tff(addAssignment_53724,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,3)
    <=> v86958(VarCurr,4) ) ).

tff(addAssignment_53723,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,2)
    <=> v86958(VarCurr,3) ) ).

tff(addAssignment_53722,axiom,
    ! [VarCurr: state_type] :
      ( v88082(VarCurr)
    <=> v88084(VarCurr) ) ).

tff(addAssignment_53721,axiom,
    ! [VarCurr: state_type] :
      ( v88084(VarCurr)
    <=> v88086(VarCurr) ) ).

tff(addAssignment_53720,axiom,
    ! [VarCurr: state_type] :
      ( v88086(VarCurr)
    <=> v88088(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_1002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88126(VarNext)
       => ( v88088(VarNext)
        <=> v88088(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1002,axiom,
    ! [VarNext: state_type] :
      ( v88126(VarNext)
     => ( v88088(VarNext)
      <=> v88136(VarNext) ) ) ).

tff(addAssignment_53719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88136(VarNext)
      <=> v88134(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88137(VarCurr)
     => ( v88134(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_524,axiom,
    ! [VarCurr: state_type] :
      ( v88137(VarCurr)
     => ( v88134(VarCurr)
      <=> v88098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8238,axiom,
    ! [VarCurr: state_type] :
      ( v88137(VarCurr)
    <=> ( v88138(VarCurr)
        & v88139(VarCurr) ) ) ).

tff(writeUnaryOperator_4116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88139(VarCurr)
    <=> v88094(VarCurr) ) ).

tff(writeUnaryOperator_4115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88138(VarCurr)
    <=> v88090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88126(VarNext)
      <=> v88127(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88127(VarNext)
      <=> ( v88128(VarNext)
          & v88121(VarNext) ) ) ) ).

tff(writeUnaryOperator_4114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88128(VarNext)
      <=> v88130(VarNext) ) ) ).

tff(addAssignment_53718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88130(VarNext)
      <=> v88121(VarCurr) ) ) ).

tff(addAssignment_53717,axiom,
    ! [VarCurr: state_type] :
      ( v88121(VarCurr)
    <=> v88123(VarCurr) ) ).

tff(addAssignment_53716,axiom,
    ! [VarCurr: state_type] :
      ( v88123(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53715,axiom,
    ! [VarCurr: state_type] :
      ( v88098(VarCurr)
    <=> v88100(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8235,axiom,
    ! [VarCurr: state_type] :
      ( v88100(VarCurr)
    <=> ( v88113(VarCurr)
        | v88116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8234,axiom,
    ! [VarCurr: state_type] :
      ( v88116(VarCurr)
    <=> ( v88086(VarCurr)
        & v88117(VarCurr) ) ) ).

tff(writeUnaryOperator_4113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88117(VarCurr)
    <=> v88118(VarCurr) ) ).

tff(addAssignment_53714,axiom,
    ! [VarCurr: state_type] :
      ( v88118(VarCurr)
    <=> v88119(VarCurr) ) ).

tff(addAssignment_53713,axiom,
    ! [VarCurr: state_type] :
      ( v88119(VarCurr)
    <=> v88106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8233,axiom,
    ! [VarCurr: state_type] :
      ( v88113(VarCurr)
    <=> ( v88102(VarCurr)
        & v88114(VarCurr) ) ) ).

tff(addAssignment_53712,axiom,
    ! [VarCurr: state_type] :
      ( v88114(VarCurr)
    <=> v88115(VarCurr) ) ).

tff(addAssignment_53711,axiom,
    ! [VarCurr: state_type] :
      ( v88115(VarCurr)
    <=> v88106(VarCurr) ) ).

tff(addAssignment_53710,axiom,
    ! [VarCurr: state_type] :
      ( v88106(VarCurr)
    <=> v88108(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8232,axiom,
    ! [VarCurr: state_type] :
      ( v88108(VarCurr)
    <=> ( v1729(VarCurr)
        & v88111(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_409,axiom,
    ! [VarCurr: state_type] :
      ( v88111(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1221,axiom,
    ~ b0000101000000(12) ).

tff(bitBlastConstant_1220,axiom,
    ~ b0000101000000(11) ).

tff(bitBlastConstant_1219,axiom,
    ~ b0000101000000(10) ).

tff(bitBlastConstant_1218,axiom,
    ~ b0000101000000(9) ).

tff(bitBlastConstant_1217,axiom,
    b0000101000000(8) ).

tff(bitBlastConstant_1216,axiom,
    ~ b0000101000000(7) ).

tff(bitBlastConstant_1215,axiom,
    b0000101000000(6) ).

tff(bitBlastConstant_1214,axiom,
    ~ b0000101000000(5) ).

tff(bitBlastConstant_1213,axiom,
    ~ b0000101000000(4) ).

tff(bitBlastConstant_1212,axiom,
    ~ b0000101000000(3) ).

tff(bitBlastConstant_1211,axiom,
    ~ b0000101000000(2) ).

tff(bitBlastConstant_1210,axiom,
    ~ b0000101000000(1) ).

tff(bitBlastConstant_1209,axiom,
    ~ b0000101000000(0) ).

tff(addAssignment_53709,axiom,
    ! [VarCurr: state_type] :
      ( v88102(VarCurr)
    <=> v88104(VarCurr) ) ).

tff(addAssignment_53708,axiom,
    ! [VarCurr: state_type] :
      ( v88104(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53707,axiom,
    ! [VarCurr: state_type] :
      ( v88094(VarCurr)
    <=> v88096(VarCurr) ) ).

tff(addAssignment_53706,axiom,
    ! [VarCurr: state_type] :
      ( v88096(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53705,axiom,
    ! [VarCurr: state_type] :
      ( v88090(VarCurr)
    <=> v88092(VarCurr) ) ).

tff(addAssignment_53704,axiom,
    ! [VarCurr: state_type] :
      ( v88092(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53703,axiom,
    ! [VarCurr: state_type] :
      ( v86952(VarCurr,2)
    <=> v86954(VarCurr,2) ) ).

tff(addAssignment_53702,axiom,
    ! [VarCurr: state_type] :
      ( v86954(VarCurr,2)
    <=> v87986(VarCurr,2) ) ).

tff(addAssignment_53701,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,1)
    <=> v86958(VarCurr,2) ) ).

tff(addAssignment_53700,axiom,
    ! [VarCurr: state_type] :
      ( v87988(VarCurr)
    <=> v87321(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8231,axiom,
    ! [VarCurr: state_type] :
      ( v87990(VarCurr)
    <=> ( v87412(VarCurr)
        | v88075(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_408,axiom,
    ! [VarCurr: state_type] :
      ( v88075(VarCurr)
    <=> ( ( v87992(VarCurr,3)
        <=> $true )
        & ( v87992(VarCurr,2)
        <=> $false )
        & ( v87992(VarCurr,1)
        <=> $true )
        & ( v87992(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_4112,axiom,
    ! [VarCurr: state_type] :
      ( v87992(VarCurr,3)
    <=> ~ v88052(VarCurr,2) ) ).

tff(addAssignment_53699,axiom,
    ! [VarCurr: state_type] :
      ( v87992(VarCurr,2)
    <=> v87994(VarCurr,3) ) ).

tff(writeUnaryOperator_4111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v87992(VarCurr,B)
      <=> ~ v88052(VarCurr,B) ) ) ).

tff(addAssignment_53698,axiom,
    ! [VarCurr: state_type] :
      ( v88052(VarCurr,2)
    <=> v87994(VarCurr,2) ) ).

tff(addAssignment_53697,axiom,
    ! [VarCurr: state_type] :
      ( v87994(VarCurr,2)
    <=> v87996(VarCurr,2) ) ).

tff(addAssignment_53696,axiom,
    ! [VarNext: state_type] :
      ( v87996(VarNext,2)
    <=> v88065(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_1001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88066(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v88065(VarNext,B)
            <=> v87996(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1001,axiom,
    ! [VarNext: state_type] :
      ( v88066(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88065(VarNext,B)
          <=> v88045(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88066(VarNext)
      <=> v88067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88067(VarNext)
      <=> ( v88069(VarNext)
          & v88030(VarNext) ) ) ) ).

tff(writeUnaryOperator_4110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88069(VarNext)
      <=> v88039(VarNext) ) ) ).

tff(addAssignment_53695,axiom,
    ! [VarCurr: state_type] :
      ( v88006(VarCurr,2)
    <=> v88008(VarCurr,2) ) ).

tff(addAssignment_53694,axiom,
    ! [VarCurr: state_type] :
      ( v88008(VarCurr,2)
    <=> v88021(VarCurr,2) ) ).

tff(addAssignment_53693,axiom,
    ! [VarCurr: state_type] :
      ( v88010(VarCurr,2)
    <=> v88013(VarCurr,2) ) ).

tff(writeUnaryOperator_4109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88014(VarCurr,2)
    <=> v88012(VarCurr,3) ) ).

tff(addAssignment_53692,axiom,
    ! [VarCurr: state_type] :
      ( v88012(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_53691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88052(VarCurr,B)
      <=> v87994(VarCurr,B) ) ) ).

tff(addAssignment_53690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v87994(VarCurr,B)
      <=> v87996(VarCurr,B) ) ) ).

tff(addAssignment_53689,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v87996(VarNext,B)
      <=> v88056(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88057(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v88056(VarNext,B)
            <=> v87996(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1000,axiom,
    ! [VarNext: state_type] :
      ( v88057(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88056(VarNext,B)
          <=> v88045(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88057(VarNext)
      <=> v88058(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88058(VarNext)
      <=> ( v88060(VarNext)
          & v88030(VarNext) ) ) ) ).

tff(writeUnaryOperator_4108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88060(VarNext)
      <=> v88039(VarNext) ) ) ).

tff(addAssignment_53688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88006(VarCurr,B)
      <=> v88008(VarCurr,B) ) ) ).

tff(addAssignment_53687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88008(VarCurr,B)
      <=> v88021(VarCurr,B) ) ) ).

tff(addAssignment_53686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88010(VarCurr,B)
      <=> v88013(VarCurr,B) ) ) ).

tff(writeUnaryOperator_4107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88014(VarCurr,B)
      <=> ~ v88012(VarCurr,B) ) ) ).

tff(addAssignment_53685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v88012(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_53684,axiom,
    ! [VarCurr: state_type] :
      ( v87994(VarCurr,3)
    <=> v87996(VarCurr,3) ) ).

tff(addAssignment_53683,axiom,
    ! [VarNext: state_type] :
      ( v87996(VarNext,3)
    <=> v88034(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88035(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v88034(VarNext,B)
            <=> v87996(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_999,axiom,
    ! [VarNext: state_type] :
      ( v88035(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88034(VarNext,B)
          <=> v88045(VarNext,B) ) ) ) ).

tff(addAssignment_53682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88045(VarNext,B)
          <=> v88043(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88043(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_523,axiom,
    ! [VarCurr: state_type] :
      ( v88046(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v88043(VarCurr,B)
          <=> v88006(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8226,axiom,
    ! [VarCurr: state_type] :
      ( v88046(VarCurr)
    <=> ( v88047(VarCurr)
        & v88048(VarCurr) ) ) ).

tff(writeUnaryOperator_4106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88048(VarCurr)
    <=> v88002(VarCurr) ) ).

tff(writeUnaryOperator_4105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v88047(VarCurr)
    <=> v87998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88035(VarNext)
      <=> v88036(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88036(VarNext)
      <=> ( v88037(VarNext)
          & v88030(VarNext) ) ) ) ).

tff(writeUnaryOperator_4104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v88037(VarNext)
      <=> v88039(VarNext) ) ) ).

tff(addAssignment_53681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v88039(VarNext)
      <=> v88030(VarCurr) ) ) ).

tff(addAssignment_53680,axiom,
    ! [VarCurr: state_type] :
      ( v88030(VarCurr)
    <=> v88032(VarCurr) ) ).

tff(addAssignment_53679,axiom,
    ! [VarCurr: state_type] :
      ( v88032(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53678,axiom,
    ! [VarCurr: state_type] :
      ( v88006(VarCurr,3)
    <=> v88008(VarCurr,3) ) ).

tff(addAssignment_53677,axiom,
    ! [VarCurr: state_type] :
      ( v88008(VarCurr,3)
    <=> v88021(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88021(VarCurr,B)
      <=> ( v88022(VarCurr,B)
          | v88025(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88025(VarCurr,B)
      <=> ( v87994(VarCurr,B)
          & v88026(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88026(VarCurr,B)
      <=> ~ v88027(VarCurr,B) ) ) ).

tff(addAssignment_53676,axiom,
    ! [VarCurr: state_type] :
      ( v88027(VarCurr,0)
    <=> v88028(VarCurr) ) ).

tff(addAssignment_53675,axiom,
    ! [VarCurr: state_type] :
      ( v88027(VarCurr,1)
    <=> v88028(VarCurr) ) ).

tff(addAssignment_53674,axiom,
    ! [VarCurr: state_type] :
      ( v88027(VarCurr,2)
    <=> v88028(VarCurr) ) ).

tff(addAssignment_53673,axiom,
    ! [VarCurr: state_type] :
      ( v88027(VarCurr,3)
    <=> v88028(VarCurr) ) ).

tff(addAssignment_53672,axiom,
    ! [VarCurr: state_type] :
      ( v88028(VarCurr)
    <=> v88016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v88022(VarCurr,B)
      <=> ( v88010(VarCurr,B)
          & v88023(VarCurr,B) ) ) ) ).

tff(addAssignment_53671,axiom,
    ! [VarCurr: state_type] :
      ( v88023(VarCurr,0)
    <=> v88024(VarCurr) ) ).

tff(addAssignment_53670,axiom,
    ! [VarCurr: state_type] :
      ( v88023(VarCurr,1)
    <=> v88024(VarCurr) ) ).

tff(addAssignment_53669,axiom,
    ! [VarCurr: state_type] :
      ( v88023(VarCurr,2)
    <=> v88024(VarCurr) ) ).

tff(addAssignment_53668,axiom,
    ! [VarCurr: state_type] :
      ( v88023(VarCurr,3)
    <=> v88024(VarCurr) ) ).

tff(addAssignment_53667,axiom,
    ! [VarCurr: state_type] :
      ( v88024(VarCurr)
    <=> v88016(VarCurr) ) ).

tff(addAssignment_53666,axiom,
    ! [VarCurr: state_type] :
      ( v88016(VarCurr)
    <=> v88018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8223,axiom,
    ! [VarCurr: state_type] :
      ( v88018(VarCurr)
    <=> ( v1729(VarCurr)
        & v88020(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_407,axiom,
    ! [VarCurr: state_type] :
      ( v88020(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53665,axiom,
    ! [VarCurr: state_type] :
      ( v88010(VarCurr,3)
    <=> v88013(VarCurr,3) ) ).

tff(addAssignment_53664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v88013(VarCurr,B)
      <=> v88014(VarCurr,B) ) ) ).

tff(addAssignment_53663,axiom,
    ! [VarCurr: state_type] :
      ( v88013(VarCurr,3)
    <=> v88012(VarCurr,2) ) ).

tff(addAssignment_53662,axiom,
    ! [VarCurr: state_type] :
      ( v88012(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_53661,axiom,
    ! [VarCurr: state_type] :
      ( v88002(VarCurr)
    <=> v88004(VarCurr) ) ).

tff(addAssignment_53660,axiom,
    ! [VarCurr: state_type] :
      ( v88004(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53659,axiom,
    ! [VarCurr: state_type] :
      ( v87998(VarCurr)
    <=> v88000(VarCurr) ) ).

tff(addAssignment_53658,axiom,
    ! [VarCurr: state_type] :
      ( v88000(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86952(VarCurr,B)
      <=> v86954(VarCurr,B) ) ) ).

tff(addAssignment_53656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86954(VarCurr,B)
      <=> v87986(VarCurr,B) ) ) ).

tff(addAssignment_53655,axiom,
    ! [VarCurr: state_type] :
      ( v87986(VarCurr,0)
    <=> v87263(VarCurr,1) ) ).

tff(addAssignment_53654,axiom,
    ! [VarCurr: state_type] :
      ( v87986(VarCurr,1)
    <=> v86956(VarCurr,0) ) ).

tff(addAssignment_53653,axiom,
    ! [VarCurr: state_type] :
      ( v87986(VarCurr,2)
    <=> v87987(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_807,axiom,
    ! [VarCurr: state_type] :
      ( v87987(VarCurr)
    <=> ( v87988(VarCurr)
        & v86956(VarCurr,1) ) ) ).

tff(addAssignment_53652,axiom,
    ! [VarCurr: state_type] :
      ( v87263(VarCurr,1)
    <=> v87985(VarCurr,1) ) ).

tff(addAssignment_53651,axiom,
    ! [VarCurr: state_type] :
      ( v87985(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_53650,axiom,
    ! [VarCurr: state_type] :
      ( v87985(VarCurr,1)
    <=> v86958(VarCurr,0) ) ).

tff(addAssignment_53649,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,0)
    <=> v86958(VarCurr,1) ) ).

tff(addAssignment_53648,axiom,
    ! [VarCurr: state_type] :
      ( v86960(VarCurr,1)
    <=> v86962(VarCurr,1) ) ).

tff(addAssignment_53647,axiom,
    ! [VarNext: state_type] :
      ( v86962(VarNext,1)
    <=> v87977(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87978(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v87977(VarNext,B)
            <=> v86962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_998,axiom,
    ! [VarNext: state_type] :
      ( v87978(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87977(VarNext,B)
          <=> v87239(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87978(VarNext)
      <=> v87979(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87979(VarNext)
      <=> ( v87981(VarNext)
          & v87224(VarNext) ) ) ) ).

tff(writeUnaryOperator_4102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87981(VarNext)
      <=> v87233(VarNext) ) ) ).

tff(addAssignment_53646,axiom,
    ! [VarCurr: state_type] :
      ( v86972(VarCurr,1)
    <=> v86974(VarCurr,1) ) ).

tff(addAssignment_53645,axiom,
    ! [VarCurr: state_type] :
      ( v86974(VarCurr,1)
    <=> v87207(VarCurr,1) ) ).

tff(addAssignment_53644,axiom,
    ! [VarCurr: state_type] :
      ( v86976(VarCurr,1)
    <=> v86978(VarCurr,1) ) ).

tff(addAssignment_53643,axiom,
    ! [VarCurr: state_type] :
      ( v86978(VarCurr,1)
    <=> v86980(VarCurr,1) ) ).

tff(addAssignment_53642,axiom,
    ! [VarCurr: state_type] :
      ( v86960(VarCurr,0)
    <=> v86962(VarCurr,0) ) ).

tff(addAssignment_53641,axiom,
    ! [VarNext: state_type] :
      ( v86962(VarNext,0)
    <=> v87969(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87970(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v87969(VarNext,B)
            <=> v86962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_997,axiom,
    ! [VarNext: state_type] :
      ( v87970(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87969(VarNext,B)
          <=> v87239(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87970(VarNext)
      <=> v87971(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87971(VarNext)
      <=> ( v87973(VarNext)
          & v87224(VarNext) ) ) ) ).

tff(writeUnaryOperator_4101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87973(VarNext)
      <=> v87233(VarNext) ) ) ).

tff(addAssignment_53640,axiom,
    ! [VarCurr: state_type] :
      ( v86972(VarCurr,0)
    <=> v86974(VarCurr,0) ) ).

tff(addAssignment_53639,axiom,
    ! [VarCurr: state_type] :
      ( v86974(VarCurr,0)
    <=> v87207(VarCurr,0) ) ).

tff(addAssignment_53638,axiom,
    ! [VarCurr: state_type] :
      ( v87194(VarCurr)
    <=> v87196(VarCurr) ) ).

tff(addAssignment_53637,axiom,
    ! [VarCurr: state_type] :
      ( v87196(VarCurr)
    <=> v87198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8218,axiom,
    ! [VarCurr: state_type] :
      ( v87198(VarCurr)
    <=> ( v87200(VarCurr)
        | v87967(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_806,axiom,
    ! [VarCurr: state_type] :
      ( v87967(VarCurr)
    <=> ( v86958(VarCurr,31)
        & v1051(VarCurr) ) ) ).

tff(addAssignment_53636,axiom,
    ! [VarCurr: state_type] :
      ( v87200(VarCurr)
    <=> v87202(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_805,axiom,
    ! [VarCurr: state_type] :
      ( v87202(VarCurr)
    <=> ( v87959(VarCurr)
        | v87965(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_804,axiom,
    ! [VarCurr: state_type] :
      ( v87959(VarCurr)
    <=> ( v87960(VarCurr)
        | v87965(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_803,axiom,
    ! [VarCurr: state_type] :
      ( v87960(VarCurr)
    <=> ( v87961(VarCurr)
        | v87965(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_802,axiom,
    ! [VarCurr: state_type] :
      ( v87961(VarCurr)
    <=> ( v87962(VarCurr)
        | v87965(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_801,axiom,
    ! [VarCurr: state_type] :
      ( v87962(VarCurr)
    <=> ( v87963(VarCurr)
        | v87965(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_800,axiom,
    ! [VarCurr: state_type] :
      ( v87963(VarCurr)
    <=> ( v87964(VarCurr)
        | v87965(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_799,axiom,
    ! [VarCurr: state_type] :
      ( v87964(VarCurr)
    <=> ( v87965(VarCurr,0)
        | v87965(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_798,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,0)
    <=> ( v87204(VarCurr,22)
        & v87265(VarCurr,0) ) ) ).

tff(writeBinaryOperatorShiftedRanges_797,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,1)
    <=> ( v87204(VarCurr,23)
        & v87265(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_796,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,2)
    <=> ( v87204(VarCurr,24)
        & v87265(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_795,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,3)
    <=> ( v87204(VarCurr,25)
        & v87265(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_794,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,4)
    <=> ( v87204(VarCurr,26)
        & v87265(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_793,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,5)
    <=> ( v87204(VarCurr,27)
        & v87265(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_792,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,6)
    <=> ( v87204(VarCurr,28)
        & v87265(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_791,axiom,
    ! [VarCurr: state_type] :
      ( v87965(VarCurr,7)
    <=> ( v87204(VarCurr,29)
        & v87265(VarCurr,7) ) ) ).

tff(addAssignment_53635,axiom,
    ! [VarCurr: state_type] :
      ( v87265(VarCurr,7)
    <=> $true ) ).

tff(addAssignment_53634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87265(VarCurr,B)
      <=> v87267(VarCurr,B) ) ) ).

tff(addAssignment_53633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87267(VarCurr,B)
      <=> v87269(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87941(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v87269(VarNext,B)
            <=> v87269(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_996,axiom,
    ! [VarNext: state_type] :
      ( v87941(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v87269(VarNext,B)
          <=> v87951(VarNext,B) ) ) ) ).

tff(addAssignment_53632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v87951(VarNext,B)
          <=> v87949(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87952(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v87949(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_522,axiom,
    ! [VarCurr: state_type] :
      ( v87952(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v87949(VarCurr,B)
          <=> v87287(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8217,axiom,
    ! [VarCurr: state_type] :
      ( v87952(VarCurr)
    <=> ( v87953(VarCurr)
        & v87954(VarCurr) ) ) ).

tff(writeUnaryOperator_4100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87954(VarCurr)
    <=> v87279(VarCurr) ) ).

tff(writeUnaryOperator_4099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87953(VarCurr)
    <=> v87271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87941(VarNext)
      <=> v87942(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87942(VarNext)
      <=> ( v87943(VarNext)
          & v87936(VarNext) ) ) ) ).

tff(writeUnaryOperator_4098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87943(VarNext)
      <=> v87945(VarNext) ) ) ).

tff(addAssignment_53631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87945(VarNext)
      <=> v87936(VarCurr) ) ) ).

tff(addAssignment_53630,axiom,
    ! [VarCurr: state_type] :
      ( v87936(VarCurr)
    <=> v87938(VarCurr) ) ).

tff(addAssignment_53629,axiom,
    ! [VarCurr: state_type] :
      ( v87938(VarCurr)
    <=> v87527(VarCurr) ) ).

tff(addAssignment_53628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87287(VarCurr,B)
      <=> v87289(VarCurr,B) ) ) ).

tff(addAssignment_53627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87289(VarCurr,B)
      <=> v87291(VarCurr,B) ) ) ).

tff(addAssignment_53626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87291(VarCurr,B)
      <=> v87293(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87293(VarCurr,B)
      <=> ( v87903(VarCurr,B)
          | v87931(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87931(VarCurr,B)
      <=> ( v87932(VarCurr,B)
          & b1000000(B) ) ) ) ).

tff(bitBlastConstant_1208,axiom,
    b1000000(6) ).

tff(bitBlastConstant_1207,axiom,
    ~ b1000000(5) ).

tff(bitBlastConstant_1206,axiom,
    ~ b1000000(4) ).

tff(bitBlastConstant_1205,axiom,
    ~ b1000000(3) ).

tff(bitBlastConstant_1204,axiom,
    ~ b1000000(2) ).

tff(bitBlastConstant_1203,axiom,
    ~ b1000000(1) ).

tff(bitBlastConstant_1202,axiom,
    ~ b1000000(0) ).

tff(addAssignment_53625,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,0)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53624,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,1)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53623,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,2)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53622,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,3)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53621,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,4)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53620,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,5)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53619,axiom,
    ! [VarCurr: state_type] :
      ( v87932(VarCurr,6)
    <=> v87933(VarCurr) ) ).

tff(addAssignment_53618,axiom,
    ! [VarCurr: state_type] :
      ( v87933(VarCurr)
    <=> v87934(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_406,axiom,
    ! [VarCurr: state_type] :
      ( v87934(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $false )
        & ( v87295(VarCurr,1)
        <=> $false )
        & ( v87295(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87903(VarCurr,B)
      <=> ( v87904(VarCurr,B)
          | v87927(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87927(VarCurr,B)
      <=> ( v87928(VarCurr,B)
          & b1100000(B) ) ) ) ).

tff(bitBlastConstant_1201,axiom,
    b1100000(6) ).

tff(bitBlastConstant_1200,axiom,
    b1100000(5) ).

tff(bitBlastConstant_1199,axiom,
    ~ b1100000(4) ).

tff(bitBlastConstant_1198,axiom,
    ~ b1100000(3) ).

tff(bitBlastConstant_1197,axiom,
    ~ b1100000(2) ).

tff(bitBlastConstant_1196,axiom,
    ~ b1100000(1) ).

tff(bitBlastConstant_1195,axiom,
    ~ b1100000(0) ).

tff(addAssignment_53617,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,0)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53616,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,1)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53615,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,2)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53614,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,3)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53613,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,4)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53612,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,5)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53611,axiom,
    ! [VarCurr: state_type] :
      ( v87928(VarCurr,6)
    <=> v87929(VarCurr) ) ).

tff(addAssignment_53610,axiom,
    ! [VarCurr: state_type] :
      ( v87929(VarCurr)
    <=> v87930(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_405,axiom,
    ! [VarCurr: state_type] :
      ( v87930(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $false )
        & ( v87295(VarCurr,1)
        <=> $true )
        & ( v87295(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87904(VarCurr,B)
      <=> ( v87905(VarCurr,B)
          | v87923(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87923(VarCurr,B)
      <=> ( v87924(VarCurr,B)
          & b1110000(B) ) ) ) ).

tff(bitBlastConstant_1194,axiom,
    b1110000(6) ).

tff(bitBlastConstant_1193,axiom,
    b1110000(5) ).

tff(bitBlastConstant_1192,axiom,
    b1110000(4) ).

tff(bitBlastConstant_1191,axiom,
    ~ b1110000(3) ).

tff(bitBlastConstant_1190,axiom,
    ~ b1110000(2) ).

tff(bitBlastConstant_1189,axiom,
    ~ b1110000(1) ).

tff(bitBlastConstant_1188,axiom,
    ~ b1110000(0) ).

tff(addAssignment_53609,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,0)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53608,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,1)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53607,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,2)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53606,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,3)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53605,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,4)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53604,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,5)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53603,axiom,
    ! [VarCurr: state_type] :
      ( v87924(VarCurr,6)
    <=> v87925(VarCurr) ) ).

tff(addAssignment_53602,axiom,
    ! [VarCurr: state_type] :
      ( v87925(VarCurr)
    <=> v87926(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_404,axiom,
    ! [VarCurr: state_type] :
      ( v87926(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $false )
        & ( v87295(VarCurr,1)
        <=> $true )
        & ( v87295(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87905(VarCurr,B)
      <=> ( v87906(VarCurr,B)
          | v87919(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87919(VarCurr,B)
      <=> ( v87920(VarCurr,B)
          & b1111000(B) ) ) ) ).

tff(bitBlastConstant_1187,axiom,
    b1111000(6) ).

tff(bitBlastConstant_1186,axiom,
    b1111000(5) ).

tff(bitBlastConstant_1185,axiom,
    b1111000(4) ).

tff(bitBlastConstant_1184,axiom,
    b1111000(3) ).

tff(bitBlastConstant_1183,axiom,
    ~ b1111000(2) ).

tff(bitBlastConstant_1182,axiom,
    ~ b1111000(1) ).

tff(bitBlastConstant_1181,axiom,
    ~ b1111000(0) ).

tff(addAssignment_53601,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,0)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53600,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,1)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53599,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,2)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53598,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,3)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53597,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,4)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53596,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,5)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53595,axiom,
    ! [VarCurr: state_type] :
      ( v87920(VarCurr,6)
    <=> v87921(VarCurr) ) ).

tff(addAssignment_53594,axiom,
    ! [VarCurr: state_type] :
      ( v87921(VarCurr)
    <=> v87922(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_403,axiom,
    ! [VarCurr: state_type] :
      ( v87922(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $true )
        & ( v87295(VarCurr,1)
        <=> $false )
        & ( v87295(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87906(VarCurr,B)
      <=> ( v87907(VarCurr,B)
          | v87915(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87915(VarCurr,B)
      <=> ( v87916(VarCurr,B)
          & b1111100(B) ) ) ) ).

tff(bitBlastConstant_1180,axiom,
    b1111100(6) ).

tff(bitBlastConstant_1179,axiom,
    b1111100(5) ).

tff(bitBlastConstant_1178,axiom,
    b1111100(4) ).

tff(bitBlastConstant_1177,axiom,
    b1111100(3) ).

tff(bitBlastConstant_1176,axiom,
    b1111100(2) ).

tff(bitBlastConstant_1175,axiom,
    ~ b1111100(1) ).

tff(bitBlastConstant_1174,axiom,
    ~ b1111100(0) ).

tff(addAssignment_53593,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,0)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53592,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,1)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53591,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,2)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53590,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,3)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53589,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,4)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53588,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,5)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53587,axiom,
    ! [VarCurr: state_type] :
      ( v87916(VarCurr,6)
    <=> v87917(VarCurr) ) ).

tff(addAssignment_53586,axiom,
    ! [VarCurr: state_type] :
      ( v87917(VarCurr)
    <=> v87918(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_402,axiom,
    ! [VarCurr: state_type] :
      ( v87918(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $true )
        & ( v87295(VarCurr,1)
        <=> $false )
        & ( v87295(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87907(VarCurr,B)
      <=> ( v87908(VarCurr,B)
          | v87911(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v87911(VarCurr,B)
      <=> ( v87912(VarCurr,B)
          & b1111110(B) ) ) ) ).

tff(bitBlastConstant_1173,axiom,
    b1111110(6) ).

tff(bitBlastConstant_1172,axiom,
    b1111110(5) ).

tff(bitBlastConstant_1171,axiom,
    b1111110(4) ).

tff(bitBlastConstant_1170,axiom,
    b1111110(3) ).

tff(bitBlastConstant_1169,axiom,
    b1111110(2) ).

tff(bitBlastConstant_1168,axiom,
    b1111110(1) ).

tff(bitBlastConstant_1167,axiom,
    ~ b1111110(0) ).

tff(addAssignment_53585,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,0)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53584,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,1)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53583,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,2)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53582,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,3)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53581,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,4)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53580,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,5)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53579,axiom,
    ! [VarCurr: state_type] :
      ( v87912(VarCurr,6)
    <=> v87913(VarCurr) ) ).

tff(addAssignment_53578,axiom,
    ! [VarCurr: state_type] :
      ( v87913(VarCurr)
    <=> v87914(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_401,axiom,
    ! [VarCurr: state_type] :
      ( v87914(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $true )
        & ( v87295(VarCurr,1)
        <=> $true )
        & ( v87295(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53577,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,0)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53576,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,1)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53575,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,2)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53574,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,3)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53573,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,4)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53572,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,5)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53571,axiom,
    ! [VarCurr: state_type] :
      ( v87908(VarCurr,6)
    <=> v87909(VarCurr) ) ).

tff(addAssignment_53570,axiom,
    ! [VarCurr: state_type] :
      ( v87909(VarCurr)
    <=> v87910(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_400,axiom,
    ! [VarCurr: state_type] :
      ( v87910(VarCurr)
    <=> ( ( v87295(VarCurr,2)
        <=> $true )
        & ( v87295(VarCurr,1)
        <=> $true )
        & ( v87295(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_53569,axiom,
    ! [VarCurr: state_type] :
      ( v87295(VarCurr,0)
    <=> v87892(VarCurr) ) ).

tff(addAssignment_53568,axiom,
    ! [VarCurr: state_type] :
      ( v87295(VarCurr,1)
    <=> v87887(VarCurr) ) ).

tff(addAssignment_53567,axiom,
    ! [VarCurr: state_type] :
      ( v87295(VarCurr,2)
    <=> v87816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8214,axiom,
    ! [VarCurr: state_type] :
      ( v87892(VarCurr)
    <=> ( v87893(VarCurr)
        & v87895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8213,axiom,
    ! [VarCurr: state_type] :
      ( v87895(VarCurr)
    <=> ( v87641(VarCurr,0)
        | v87822(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8212,axiom,
    ! [VarCurr: state_type] :
      ( v87893(VarCurr)
    <=> ( v87869(VarCurr)
        | v87894(VarCurr) ) ) ).

tff(writeUnaryOperator_4097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87894(VarCurr)
    <=> v87822(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8211,axiom,
    ! [VarCurr: state_type] :
      ( v87887(VarCurr)
    <=> ( v87888(VarCurr)
        & v87891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8210,axiom,
    ! [VarCurr: state_type] :
      ( v87891(VarCurr)
    <=> ( v87821(VarCurr)
        | v87863(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8209,axiom,
    ! [VarCurr: state_type] :
      ( v87888(VarCurr)
    <=> ( v87889(VarCurr)
        | v87890(VarCurr) ) ) ).

tff(writeUnaryOperator_4096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87890(VarCurr)
    <=> v87863(VarCurr) ) ).

tff(writeUnaryOperator_4095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87889(VarCurr)
    <=> v87821(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8208,axiom,
    ! [VarCurr: state_type] :
      ( v87816(VarCurr)
    <=> ( v87817(VarCurr)
        & v87886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8207,axiom,
    ! [VarCurr: state_type] :
      ( v87886(VarCurr)
    <=> ( v87819(VarCurr)
        | v87875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8206,axiom,
    ! [VarCurr: state_type] :
      ( v87817(VarCurr)
    <=> ( v87818(VarCurr)
        | v87874(VarCurr) ) ) ).

tff(writeUnaryOperator_4094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87874(VarCurr)
    <=> v87875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8205,axiom,
    ! [VarCurr: state_type] :
      ( v87875(VarCurr)
    <=> ( v87876(VarCurr)
        & v87885(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_790,axiom,
    ! [VarCurr: state_type] :
      ( v87885(VarCurr)
    <=> ( v87878(VarCurr)
        | v87822(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8204,axiom,
    ! [VarCurr: state_type] :
      ( v87876(VarCurr)
    <=> ( v87877(VarCurr)
        | v87884(VarCurr) ) ) ).

tff(writeUnaryOperator_4093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87884(VarCurr)
    <=> v87822(VarCurr,2) ) ).

tff(writeUnaryOperator_4092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87877(VarCurr)
    <=> v87878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8203,axiom,
    ! [VarCurr: state_type] :
      ( v87878(VarCurr)
    <=> ( v87879(VarCurr)
        & v87882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8202,axiom,
    ! [VarCurr: state_type] :
      ( v87882(VarCurr)
    <=> ( v87881(VarCurr)
        | v87883(VarCurr) ) ) ).

tff(writeUnaryOperator_4091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87883(VarCurr)
    <=> v87641(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_789,axiom,
    ! [VarCurr: state_type] :
      ( v87879(VarCurr)
    <=> ( v87880(VarCurr)
        | v87641(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87880(VarCurr)
    <=> v87881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8201,axiom,
    ! [VarCurr: state_type] :
      ( v87881(VarCurr)
    <=> ( v87869(VarCurr)
        & v87870(VarCurr) ) ) ).

tff(writeUnaryOperator_4089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87818(VarCurr)
    <=> v87819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8200,axiom,
    ! [VarCurr: state_type] :
      ( v87819(VarCurr)
    <=> ( v87820(VarCurr)
        | v87873(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_788,axiom,
    ! [VarCurr: state_type] :
      ( v87873(VarCurr)
    <=> ( v87866(VarCurr)
        & v87822(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8199,axiom,
    ! [VarCurr: state_type] :
      ( v87820(VarCurr)
    <=> ( v87821(VarCurr)
        & v87863(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8198,axiom,
    ! [VarCurr: state_type] :
      ( v87863(VarCurr)
    <=> ( v87864(VarCurr)
        & v87872(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_787,axiom,
    ! [VarCurr: state_type] :
      ( v87872(VarCurr)
    <=> ( v87866(VarCurr)
        | v87822(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8197,axiom,
    ! [VarCurr: state_type] :
      ( v87864(VarCurr)
    <=> ( v87865(VarCurr)
        | v87871(VarCurr) ) ) ).

tff(writeUnaryOperator_4088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87871(VarCurr)
    <=> v87822(VarCurr,1) ) ).

tff(writeUnaryOperator_4087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87865(VarCurr)
    <=> v87866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8196,axiom,
    ! [VarCurr: state_type] :
      ( v87866(VarCurr)
    <=> ( v87867(VarCurr)
        & v87868(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8195,axiom,
    ! [VarCurr: state_type] :
      ( v87868(VarCurr)
    <=> ( v87869(VarCurr)
        | v87870(VarCurr) ) ) ).

tff(writeUnaryOperator_4086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87870(VarCurr)
    <=> v87641(VarCurr,1) ) ).

tff(writeUnaryOperator_4085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87869(VarCurr)
    <=> v87641(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_786,axiom,
    ! [VarCurr: state_type] :
      ( v87867(VarCurr)
    <=> ( v87641(VarCurr,0)
        | v87641(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8194,axiom,
    ! [VarCurr: state_type] :
      ( v87821(VarCurr)
    <=> ( v87641(VarCurr,0)
        & v87822(VarCurr,0) ) ) ).

tff(addAssignment_53566,axiom,
    ! [VarCurr: state_type] :
      ( v87822(VarCurr,0)
    <=> v87859(VarCurr) ) ).

tff(addAssignment_53565,axiom,
    ! [VarCurr: state_type] :
      ( v87822(VarCurr,1)
    <=> v87854(VarCurr) ) ).

tff(addAssignment_53564,axiom,
    ! [VarCurr: state_type] :
      ( v87822(VarCurr,2)
    <=> v87824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8193,axiom,
    ! [VarCurr: state_type] :
      ( v87859(VarCurr)
    <=> ( v87860(VarCurr)
        & v87862(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8192,axiom,
    ! [VarCurr: state_type] :
      ( v87862(VarCurr)
    <=> ( v87576(VarCurr,0)
        | v87297(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8191,axiom,
    ! [VarCurr: state_type] :
      ( v87860(VarCurr)
    <=> ( v87836(VarCurr)
        | v87861(VarCurr) ) ) ).

tff(writeUnaryOperator_4084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87861(VarCurr)
    <=> v87297(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8190,axiom,
    ! [VarCurr: state_type] :
      ( v87854(VarCurr)
    <=> ( v87855(VarCurr)
        & v87858(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8189,axiom,
    ! [VarCurr: state_type] :
      ( v87858(VarCurr)
    <=> ( v87829(VarCurr)
        | v87830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8188,axiom,
    ! [VarCurr: state_type] :
      ( v87855(VarCurr)
    <=> ( v87856(VarCurr)
        | v87857(VarCurr) ) ) ).

tff(writeUnaryOperator_4083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87857(VarCurr)
    <=> v87830(VarCurr) ) ).

tff(writeUnaryOperator_4082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87856(VarCurr)
    <=> v87829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8187,axiom,
    ! [VarCurr: state_type] :
      ( v87824(VarCurr)
    <=> ( v87825(VarCurr)
        & v87853(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8186,axiom,
    ! [VarCurr: state_type] :
      ( v87853(VarCurr)
    <=> ( v87827(VarCurr)
        | v87842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8185,axiom,
    ! [VarCurr: state_type] :
      ( v87825(VarCurr)
    <=> ( v87826(VarCurr)
        | v87841(VarCurr) ) ) ).

tff(writeUnaryOperator_4081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87841(VarCurr)
    <=> v87842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8184,axiom,
    ! [VarCurr: state_type] :
      ( v87842(VarCurr)
    <=> ( v87843(VarCurr)
        & v87852(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_785,axiom,
    ! [VarCurr: state_type] :
      ( v87852(VarCurr)
    <=> ( v87845(VarCurr)
        | v87297(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8183,axiom,
    ! [VarCurr: state_type] :
      ( v87843(VarCurr)
    <=> ( v87844(VarCurr)
        | v87851(VarCurr) ) ) ).

tff(writeUnaryOperator_4080,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87851(VarCurr)
    <=> v87297(VarCurr,2) ) ).

tff(writeUnaryOperator_4079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87844(VarCurr)
    <=> v87845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8182,axiom,
    ! [VarCurr: state_type] :
      ( v87845(VarCurr)
    <=> ( v87846(VarCurr)
        & v87849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8181,axiom,
    ! [VarCurr: state_type] :
      ( v87849(VarCurr)
    <=> ( v87848(VarCurr)
        | v87850(VarCurr) ) ) ).

tff(writeUnaryOperator_4078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87850(VarCurr)
    <=> v87576(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_784,axiom,
    ! [VarCurr: state_type] :
      ( v87846(VarCurr)
    <=> ( v87847(VarCurr)
        | v87576(VarCurr,2) ) ) ).

tff(writeUnaryOperator_4077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87847(VarCurr)
    <=> v87848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8180,axiom,
    ! [VarCurr: state_type] :
      ( v87848(VarCurr)
    <=> ( v87836(VarCurr)
        & v87837(VarCurr) ) ) ).

tff(writeUnaryOperator_4076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87826(VarCurr)
    <=> v87827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8179,axiom,
    ! [VarCurr: state_type] :
      ( v87827(VarCurr)
    <=> ( v87828(VarCurr)
        | v87840(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_783,axiom,
    ! [VarCurr: state_type] :
      ( v87840(VarCurr)
    <=> ( v87833(VarCurr)
        & v87297(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8178,axiom,
    ! [VarCurr: state_type] :
      ( v87828(VarCurr)
    <=> ( v87829(VarCurr)
        & v87830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8177,axiom,
    ! [VarCurr: state_type] :
      ( v87830(VarCurr)
    <=> ( v87831(VarCurr)
        & v87839(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_782,axiom,
    ! [VarCurr: state_type] :
      ( v87839(VarCurr)
    <=> ( v87833(VarCurr)
        | v87297(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8176,axiom,
    ! [VarCurr: state_type] :
      ( v87831(VarCurr)
    <=> ( v87832(VarCurr)
        | v87838(VarCurr) ) ) ).

tff(writeUnaryOperator_4075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87838(VarCurr)
    <=> v87297(VarCurr,1) ) ).

tff(writeUnaryOperator_4074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87832(VarCurr)
    <=> v87833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8175,axiom,
    ! [VarCurr: state_type] :
      ( v87833(VarCurr)
    <=> ( v87834(VarCurr)
        & v87835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8174,axiom,
    ! [VarCurr: state_type] :
      ( v87835(VarCurr)
    <=> ( v87836(VarCurr)
        | v87837(VarCurr) ) ) ).

tff(writeUnaryOperator_4073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87837(VarCurr)
    <=> v87576(VarCurr,1) ) ).

tff(writeUnaryOperator_4072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87836(VarCurr)
    <=> v87576(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_781,axiom,
    ! [VarCurr: state_type] :
      ( v87834(VarCurr)
    <=> ( v87576(VarCurr,0)
        | v87576(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8173,axiom,
    ! [VarCurr: state_type] :
      ( v87829(VarCurr)
    <=> ( v87576(VarCurr,0)
        & v87297(VarCurr,0) ) ) ).

tff(addAssignment_53563,axiom,
    ! [VarCurr: state_type] :
      ( v87641(VarCurr,2)
    <=> v87809(VarCurr,2) ) ).

tff(addAssignment_53562,axiom,
    ! [VarCurr: state_type] :
      ( v87641(VarCurr,1)
    <=> v87809(VarCurr,1) ) ).

tff(addAssignment_53561,axiom,
    ! [VarCurr: state_type] :
      ( v87641(VarCurr,0)
    <=> v87809(VarCurr,0) ) ).

tff(addZeroExtensionConstraint_8,axiom,
    ! [VarCurr: state_type] : ~ v87809(VarCurr,2) ).

tff(addAssignment_53560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v87809(VarCurr,B)
      <=> v87810(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87643(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87810(VarCurr,B)
          <=> v87811(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_521,axiom,
    ! [VarCurr: state_type] :
      ( v87643(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87810(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87774(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87811(VarCurr,B)
          <=> v87812(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_520,axiom,
    ! [VarCurr: state_type] :
      ( v87774(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87811(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87813(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87812(VarCurr,B)
          <=> $true ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_519,axiom,
    ! [VarCurr: state_type] :
      ( v87813(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87812(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8172,axiom,
    ! [VarCurr: state_type] :
      ( v87813(VarCurr)
    <=> ( v87786(VarCurr)
        | v87798(VarCurr) ) ) ).

tff(addAssignment_53559,axiom,
    ! [VarCurr: state_type] :
      ( v87798(VarCurr)
    <=> v87645(VarCurr,3) ) ).

tff(addAssignment_53558,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,3)
    <=> v87647(VarCurr,3) ) ).

tff(addAssignment_53557,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,3)
    <=> v87802(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87803(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v87802(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_995,axiom,
    ! [VarNext: state_type] :
      ( v87803(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87802(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87803(VarNext)
      <=> v87804(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87804(VarNext)
      <=> ( v87806(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87806(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53556,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,3)
    <=> v87659(VarCurr,3) ) ).

tff(addAssignment_53555,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,3)
    <=> v87661(VarCurr,3) ) ).

tff(addAssignment_53554,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,3)
    <=> v87743(VarCurr,3) ) ).

tff(addBitVectorEqualityBitBlasted_399,axiom,
    ! [VarCurr: state_type] :
      ( v87748(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $true )
        & ( v87665(VarCurr,1)
        <=> $false )
        & ( v87665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53553,axiom,
    ! [VarCurr: state_type] :
      ( v87786(VarCurr)
    <=> v87645(VarCurr,2) ) ).

tff(addAssignment_53552,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,2)
    <=> v87647(VarCurr,2) ) ).

tff(addAssignment_53551,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,2)
    <=> v87790(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87791(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v87790(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_994,axiom,
    ! [VarNext: state_type] :
      ( v87791(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87790(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87791(VarNext)
      <=> v87792(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87792(VarNext)
      <=> ( v87794(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87794(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53550,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,2)
    <=> v87659(VarCurr,2) ) ).

tff(addAssignment_53549,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,2)
    <=> v87661(VarCurr,2) ) ).

tff(addAssignment_53548,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,2)
    <=> v87743(VarCurr,2) ) ).

tff(addBitVectorEqualityBitBlasted_398,axiom,
    ! [VarCurr: state_type] :
      ( v87749(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $false )
        & ( v87665(VarCurr,1)
        <=> $true )
        & ( v87665(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_53547,axiom,
    ! [VarCurr: state_type] :
      ( v87774(VarCurr)
    <=> v87645(VarCurr,1) ) ).

tff(addAssignment_53546,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,1)
    <=> v87647(VarCurr,1) ) ).

tff(addAssignment_53545,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,1)
    <=> v87778(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87779(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v87778(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_993,axiom,
    ! [VarNext: state_type] :
      ( v87779(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87778(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87779(VarNext)
      <=> v87780(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87780(VarNext)
      <=> ( v87782(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87782(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53544,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,1)
    <=> v87659(VarCurr,1) ) ).

tff(addAssignment_53543,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,1)
    <=> v87661(VarCurr,1) ) ).

tff(addAssignment_53542,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,1)
    <=> v87743(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_397,axiom,
    ! [VarCurr: state_type] :
      ( v87750(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $false )
        & ( v87665(VarCurr,1)
        <=> $true )
        & ( v87665(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53541,axiom,
    ! [VarCurr: state_type] :
      ( v87643(VarCurr)
    <=> v87645(VarCurr,0) ) ).

tff(addAssignment_53540,axiom,
    ! [VarCurr: state_type] :
      ( v87645(VarCurr,0)
    <=> v87647(VarCurr,0) ) ).

tff(addAssignment_53539,axiom,
    ! [VarNext: state_type] :
      ( v87647(VarNext,0)
    <=> v87756(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87757(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v87756(VarNext,B)
            <=> v87647(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_992,axiom,
    ! [VarNext: state_type] :
      ( v87757(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87756(VarNext,B)
          <=> v87767(VarNext,B) ) ) ) ).

tff(addAssignment_53538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87767(VarNext,B)
          <=> v87765(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87768(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87765(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_518,axiom,
    ! [VarCurr: state_type] :
      ( v87768(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v87765(VarCurr,B)
          <=> v87657(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8165,axiom,
    ! [VarCurr: state_type] :
      ( v87768(VarCurr)
    <=> ( v87769(VarCurr)
        & v87770(VarCurr) ) ) ).

tff(writeUnaryOperator_4068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87770(VarCurr)
    <=> v87653(VarCurr) ) ).

tff(writeUnaryOperator_4067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87769(VarCurr)
    <=> v87649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87757(VarNext)
      <=> v87758(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87758(VarNext)
      <=> ( v87759(VarNext)
          & v87752(VarNext) ) ) ) ).

tff(writeUnaryOperator_4066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87759(VarNext)
      <=> v87761(VarNext) ) ) ).

tff(addAssignment_53537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87761(VarNext)
      <=> v87752(VarCurr) ) ) ).

tff(addAssignment_53536,axiom,
    ! [VarCurr: state_type] :
      ( v87752(VarCurr)
    <=> v87754(VarCurr) ) ).

tff(addAssignment_53535,axiom,
    ! [VarCurr: state_type] :
      ( v87754(VarCurr)
    <=> v87527(VarCurr) ) ).

tff(addAssignment_53534,axiom,
    ! [VarCurr: state_type] :
      ( v87657(VarCurr,0)
    <=> v87659(VarCurr,0) ) ).

tff(addAssignment_53533,axiom,
    ! [VarCurr: state_type] :
      ( v87659(VarCurr,0)
    <=> v87661(VarCurr,0) ) ).

tff(addAssignment_53532,axiom,
    ! [VarCurr: state_type] :
      ( v87661(VarCurr,0)
    <=> v87743(VarCurr,0) ) ).

tff(addAssignment_53531,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,0)
    <=> v87663(VarCurr) ) ).

tff(addAssignment_53530,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,1)
    <=> v87750(VarCurr) ) ).

tff(addAssignment_53529,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,2)
    <=> v87749(VarCurr) ) ).

tff(addAssignment_53528,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,3)
    <=> v87748(VarCurr) ) ).

tff(addAssignment_53527,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,4)
    <=> v87747(VarCurr) ) ).

tff(addAssignment_53526,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,5)
    <=> v87746(VarCurr) ) ).

tff(addAssignment_53525,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,6)
    <=> v87745(VarCurr) ) ).

tff(addAssignment_53524,axiom,
    ! [VarCurr: state_type] :
      ( v87743(VarCurr,7)
    <=> v87744(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_396,axiom,
    ! [VarCurr: state_type] :
      ( v87663(VarCurr)
    <=> ( ( v87665(VarCurr,2)
        <=> $false )
        & ( v87665(VarCurr,1)
        <=> $false )
        & ( v87665(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_53523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v87665(VarCurr,B)
      <=> v87667(VarCurr,B) ) ) ).

tff(addAssignment_53522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v87667(VarCurr,B)
      <=> v87669(VarCurr,B) ) ) ).

tff(addAssignment_53521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87669(VarCurr,B)
      <=> v87671(VarCurr,B) ) ) ).

tff(writeUnaryOperator_4065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87669(VarCurr,0)
    <=> v87730(VarCurr) ) ).

tff(addAssignment_53520,axiom,
    ! [VarCurr: state_type] :
      ( v87730(VarCurr)
    <=> v87671(VarCurr,0) ) ).

tff(addAssignment_53519,axiom,
    ! [VarCurr: state_type] :
      ( v87671(VarCurr,0)
    <=> v87673(VarCurr,0) ) ).

tff(addAssignment_53518,axiom,
    ! [VarNext: state_type] :
      ( v87673(VarNext,0)
    <=> v87734(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87735(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87734(VarNext,B)
            <=> v87673(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_991,axiom,
    ! [VarNext: state_type] :
      ( v87735(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87734(VarNext,B)
          <=> v87723(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87735(VarNext)
      <=> v87736(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87736(VarNext)
      <=> ( v87738(VarNext)
          & v87708(VarNext) ) ) ) ).

tff(writeUnaryOperator_4064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87738(VarNext)
      <=> v87717(VarNext) ) ) ).

tff(addAssignment_53517,axiom,
    ! [VarCurr: state_type] :
      ( v87683(VarCurr,0)
    <=> v87685(VarCurr,0) ) ).

tff(addAssignment_53516,axiom,
    ! [VarCurr: state_type] :
      ( v87685(VarCurr,0)
    <=> v87699(VarCurr,0) ) ).

tff(addAssignment_53515,axiom,
    ! [VarCurr: state_type] :
      ( v87687(VarCurr,0)
    <=> v87690(VarCurr,0) ) ).

tff(writeUnaryOperator_4063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87691(VarCurr)
    <=> v87689(VarCurr,0) ) ).

tff(addAssignment_53514,axiom,
    ! [VarCurr: state_type] :
      ( v87689(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87671(VarCurr,B)
      <=> v87673(VarCurr,B) ) ) ).

tff(addAssignment_53512,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87673(VarNext,B)
      <=> v87712(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87713(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87712(VarNext,B)
            <=> v87673(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_990,axiom,
    ! [VarNext: state_type] :
      ( v87713(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87712(VarNext,B)
          <=> v87723(VarNext,B) ) ) ) ).

tff(addAssignment_53511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87723(VarNext,B)
          <=> v87721(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87721(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_517,axiom,
    ! [VarCurr: state_type] :
      ( v87724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87721(VarCurr,B)
          <=> v87683(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8160,axiom,
    ! [VarCurr: state_type] :
      ( v87724(VarCurr)
    <=> ( v87725(VarCurr)
        & v87726(VarCurr) ) ) ).

tff(writeUnaryOperator_4062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87726(VarCurr)
    <=> v87679(VarCurr) ) ).

tff(writeUnaryOperator_4061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87725(VarCurr)
    <=> v87675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87713(VarNext)
      <=> v87714(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87714(VarNext)
      <=> ( v87715(VarNext)
          & v87708(VarNext) ) ) ) ).

tff(writeUnaryOperator_4060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87715(VarNext)
      <=> v87717(VarNext) ) ) ).

tff(addAssignment_53510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87717(VarNext)
      <=> v87708(VarCurr) ) ) ).

tff(addAssignment_53509,axiom,
    ! [VarCurr: state_type] :
      ( v87708(VarCurr)
    <=> v87710(VarCurr) ) ).

tff(addAssignment_53508,axiom,
    ! [VarCurr: state_type] :
      ( v87710(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87683(VarCurr,B)
      <=> v87685(VarCurr,B) ) ) ).

tff(addAssignment_53506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87685(VarCurr,B)
      <=> v87699(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87699(VarCurr,B)
      <=> ( v87700(VarCurr,B)
          | v87703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87703(VarCurr,B)
      <=> ( v87671(VarCurr,B)
          & v87704(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87704(VarCurr,B)
      <=> ~ v87705(VarCurr,B) ) ) ).

tff(addAssignment_53505,axiom,
    ! [VarCurr: state_type] :
      ( v87705(VarCurr,0)
    <=> v87706(VarCurr) ) ).

tff(addAssignment_53504,axiom,
    ! [VarCurr: state_type] :
      ( v87705(VarCurr,1)
    <=> v87706(VarCurr) ) ).

tff(addAssignment_53503,axiom,
    ! [VarCurr: state_type] :
      ( v87705(VarCurr,2)
    <=> v87706(VarCurr) ) ).

tff(addAssignment_53502,axiom,
    ! [VarCurr: state_type] :
      ( v87705(VarCurr,3)
    <=> v87706(VarCurr) ) ).

tff(addAssignment_53501,axiom,
    ! [VarCurr: state_type] :
      ( v87706(VarCurr)
    <=> v87693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87700(VarCurr,B)
      <=> ( v87687(VarCurr,B)
          & v87701(VarCurr,B) ) ) ) ).

tff(addAssignment_53500,axiom,
    ! [VarCurr: state_type] :
      ( v87701(VarCurr,0)
    <=> v87702(VarCurr) ) ).

tff(addAssignment_53499,axiom,
    ! [VarCurr: state_type] :
      ( v87701(VarCurr,1)
    <=> v87702(VarCurr) ) ).

tff(addAssignment_53498,axiom,
    ! [VarCurr: state_type] :
      ( v87701(VarCurr,2)
    <=> v87702(VarCurr) ) ).

tff(addAssignment_53497,axiom,
    ! [VarCurr: state_type] :
      ( v87701(VarCurr,3)
    <=> v87702(VarCurr) ) ).

tff(addAssignment_53496,axiom,
    ! [VarCurr: state_type] :
      ( v87702(VarCurr)
    <=> v87693(VarCurr) ) ).

tff(addAssignment_53495,axiom,
    ! [VarCurr: state_type] :
      ( v87693(VarCurr)
    <=> v87695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8157,axiom,
    ! [VarCurr: state_type] :
      ( v87695(VarCurr)
    <=> ( v1729(VarCurr)
        & v87698(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_395,axiom,
    ! [VarCurr: state_type] :
      ( v87698(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $true )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1166,axiom,
    ~ b0001000011000(12) ).

tff(bitBlastConstant_1165,axiom,
    ~ b0001000011000(11) ).

tff(bitBlastConstant_1164,axiom,
    ~ b0001000011000(10) ).

tff(bitBlastConstant_1163,axiom,
    b0001000011000(9) ).

tff(bitBlastConstant_1162,axiom,
    ~ b0001000011000(8) ).

tff(bitBlastConstant_1161,axiom,
    ~ b0001000011000(7) ).

tff(bitBlastConstant_1160,axiom,
    ~ b0001000011000(6) ).

tff(bitBlastConstant_1159,axiom,
    ~ b0001000011000(5) ).

tff(bitBlastConstant_1158,axiom,
    b0001000011000(4) ).

tff(bitBlastConstant_1157,axiom,
    b0001000011000(3) ).

tff(bitBlastConstant_1156,axiom,
    ~ b0001000011000(2) ).

tff(bitBlastConstant_1155,axiom,
    ~ b0001000011000(1) ).

tff(bitBlastConstant_1154,axiom,
    ~ b0001000011000(0) ).

tff(addAssignment_53494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87687(VarCurr,B)
      <=> v87690(VarCurr,B) ) ) ).

tff(addAssignment_53493,axiom,
    ! [VarCurr: state_type] :
      ( v87690(VarCurr,0)
    <=> v87691(VarCurr) ) ).

tff(addAssignment_53492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,1) )
     => ( v87690(VarCurr,B)
      <=> v87689(VarCurr,B) ) ) ).

tff(addAssignment_53491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v87689(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_53490,axiom,
    ! [VarCurr: state_type] :
      ( v87679(VarCurr)
    <=> v87681(VarCurr) ) ).

tff(addAssignment_53489,axiom,
    ! [VarCurr: state_type] :
      ( v87681(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53488,axiom,
    ! [VarCurr: state_type] :
      ( v87675(VarCurr)
    <=> v87677(VarCurr) ) ).

tff(addAssignment_53487,axiom,
    ! [VarCurr: state_type] :
      ( v87677(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53486,axiom,
    ! [VarCurr: state_type] :
      ( v87653(VarCurr)
    <=> v87655(VarCurr) ) ).

tff(addAssignment_53485,axiom,
    ! [VarCurr: state_type] :
      ( v87655(VarCurr)
    <=> v87283(VarCurr) ) ).

tff(addAssignment_53484,axiom,
    ! [VarCurr: state_type] :
      ( v87649(VarCurr)
    <=> v87651(VarCurr) ) ).

tff(addAssignment_53483,axiom,
    ! [VarCurr: state_type] :
      ( v87651(VarCurr)
    <=> v87275(VarCurr) ) ).

tff(addAssignment_53482,axiom,
    ! [VarCurr: state_type] :
      ( v87576(VarCurr,2)
    <=> v87638(VarCurr,2) ) ).

tff(addAssignment_53481,axiom,
    ! [VarCurr: state_type] :
      ( v87576(VarCurr,1)
    <=> v87638(VarCurr,1) ) ).

tff(addAssignment_53480,axiom,
    ! [VarCurr: state_type] :
      ( v87576(VarCurr,0)
    <=> v87638(VarCurr,0) ) ).

tff(addZeroExtensionConstraint_7,axiom,
    ! [VarCurr: state_type] : ~ v87638(VarCurr,1) ).

tff(addZeroExtensionConstraint_6,axiom,
    ! [VarCurr: state_type] : ~ v87638(VarCurr,2) ).

tff(addAssignment_53479,axiom,
    ! [VarCurr: state_type] :
      ( v87638(VarCurr,0)
    <=> v87639(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87578(VarCurr)
     => ( v87639(VarCurr)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_516,axiom,
    ! [VarCurr: state_type] :
      ( v87578(VarCurr)
     => ( v87639(VarCurr)
      <=> $true ) ) ).

tff(addAssignment_53478,axiom,
    ! [VarCurr: state_type] :
      ( v87578(VarCurr)
    <=> v87580(VarCurr) ) ).

tff(addAssignment_53477,axiom,
    ! [VarCurr: state_type] :
      ( v87580(VarCurr)
    <=> v87582(VarCurr) ) ).

tff(addAssignment_53476,axiom,
    ! [VarCurr: state_type] :
      ( v87582(VarCurr)
    <=> v87584(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87622(VarNext)
       => ( v87584(VarNext)
        <=> v87584(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_989,axiom,
    ! [VarNext: state_type] :
      ( v87622(VarNext)
     => ( v87584(VarNext)
      <=> v87632(VarNext) ) ) ).

tff(addAssignment_53475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87632(VarNext)
      <=> v87630(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87633(VarCurr)
     => ( v87630(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_515,axiom,
    ! [VarCurr: state_type] :
      ( v87633(VarCurr)
     => ( v87630(VarCurr)
      <=> v87594(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8156,axiom,
    ! [VarCurr: state_type] :
      ( v87633(VarCurr)
    <=> ( v87634(VarCurr)
        & v87635(VarCurr) ) ) ).

tff(writeUnaryOperator_4058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87635(VarCurr)
    <=> v87590(VarCurr) ) ).

tff(writeUnaryOperator_4057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87634(VarCurr)
    <=> v87586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87622(VarNext)
      <=> v87623(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87623(VarNext)
      <=> ( v87624(VarNext)
          & v87617(VarNext) ) ) ) ).

tff(writeUnaryOperator_4056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87624(VarNext)
      <=> v87626(VarNext) ) ) ).

tff(addAssignment_53474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87626(VarNext)
      <=> v87617(VarCurr) ) ) ).

tff(addAssignment_53473,axiom,
    ! [VarCurr: state_type] :
      ( v87617(VarCurr)
    <=> v87619(VarCurr) ) ).

tff(addAssignment_53472,axiom,
    ! [VarCurr: state_type] :
      ( v87619(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53471,axiom,
    ! [VarCurr: state_type] :
      ( v87594(VarCurr)
    <=> v87596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8153,axiom,
    ! [VarCurr: state_type] :
      ( v87596(VarCurr)
    <=> ( v87609(VarCurr)
        | v87612(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8152,axiom,
    ! [VarCurr: state_type] :
      ( v87612(VarCurr)
    <=> ( v87582(VarCurr)
        & v87613(VarCurr) ) ) ).

tff(writeUnaryOperator_4055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87613(VarCurr)
    <=> v87614(VarCurr) ) ).

tff(addAssignment_53470,axiom,
    ! [VarCurr: state_type] :
      ( v87614(VarCurr)
    <=> v87615(VarCurr) ) ).

tff(addAssignment_53469,axiom,
    ! [VarCurr: state_type] :
      ( v87615(VarCurr)
    <=> v87602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8151,axiom,
    ! [VarCurr: state_type] :
      ( v87609(VarCurr)
    <=> ( v87598(VarCurr)
        & v87610(VarCurr) ) ) ).

tff(addAssignment_53468,axiom,
    ! [VarCurr: state_type] :
      ( v87610(VarCurr)
    <=> v87611(VarCurr) ) ).

tff(addAssignment_53467,axiom,
    ! [VarCurr: state_type] :
      ( v87611(VarCurr)
    <=> v87602(VarCurr) ) ).

tff(addAssignment_53466,axiom,
    ! [VarCurr: state_type] :
      ( v87602(VarCurr)
    <=> v87604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8150,axiom,
    ! [VarCurr: state_type] :
      ( v87604(VarCurr)
    <=> ( v1729(VarCurr)
        & v87607(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_394,axiom,
    ! [VarCurr: state_type] :
      ( v87607(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1153,axiom,
    ~ b0000100001000(12) ).

tff(bitBlastConstant_1152,axiom,
    ~ b0000100001000(11) ).

tff(bitBlastConstant_1151,axiom,
    ~ b0000100001000(10) ).

tff(bitBlastConstant_1150,axiom,
    ~ b0000100001000(9) ).

tff(bitBlastConstant_1149,axiom,
    b0000100001000(8) ).

tff(bitBlastConstant_1148,axiom,
    ~ b0000100001000(7) ).

tff(bitBlastConstant_1147,axiom,
    ~ b0000100001000(6) ).

tff(bitBlastConstant_1146,axiom,
    ~ b0000100001000(5) ).

tff(bitBlastConstant_1145,axiom,
    ~ b0000100001000(4) ).

tff(bitBlastConstant_1144,axiom,
    b0000100001000(3) ).

tff(bitBlastConstant_1143,axiom,
    ~ b0000100001000(2) ).

tff(bitBlastConstant_1142,axiom,
    ~ b0000100001000(1) ).

tff(bitBlastConstant_1141,axiom,
    ~ b0000100001000(0) ).

tff(addAssignment_53465,axiom,
    ! [VarCurr: state_type] :
      ( v87598(VarCurr)
    <=> v87600(VarCurr) ) ).

tff(addAssignment_53464,axiom,
    ! [VarCurr: state_type] :
      ( v87600(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53463,axiom,
    ! [VarCurr: state_type] :
      ( v87590(VarCurr)
    <=> v87592(VarCurr) ) ).

tff(addAssignment_53462,axiom,
    ! [VarCurr: state_type] :
      ( v87592(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53461,axiom,
    ! [VarCurr: state_type] :
      ( v87586(VarCurr)
    <=> v87588(VarCurr) ) ).

tff(addAssignment_53460,axiom,
    ! [VarCurr: state_type] :
      ( v87588(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53459,axiom,
    ! [VarCurr: state_type] :
      ( v87297(VarCurr,2)
    <=> v87572(VarCurr,2) ) ).

tff(addAssignment_53458,axiom,
    ! [VarCurr: state_type] :
      ( v87297(VarCurr,1)
    <=> v87572(VarCurr,1) ) ).

tff(addAssignment_53457,axiom,
    ! [VarCurr: state_type] :
      ( v87297(VarCurr,0)
    <=> v87572(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87299(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87572(VarCurr,B)
          <=> v87573(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_514,axiom,
    ! [VarCurr: state_type] :
      ( v87299(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87572(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87547(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87573(VarCurr,B)
          <=> v87574(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_513,axiom,
    ! [VarCurr: state_type] :
      ( v87547(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87573(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87574(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_512,axiom,
    ! [VarCurr: state_type] :
      ( v87560(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v87574(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(addAssignment_53456,axiom,
    ! [VarCurr: state_type] :
      ( v87560(VarCurr)
    <=> v87301(VarCurr,2) ) ).

tff(addAssignment_53455,axiom,
    ! [VarCurr: state_type] :
      ( v87301(VarCurr,2)
    <=> v87303(VarCurr,2) ) ).

tff(addAssignment_53454,axiom,
    ! [VarNext: state_type] :
      ( v87303(VarNext,2)
    <=> v87565(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87566(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87565(VarNext,B)
            <=> v87303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_988,axiom,
    ! [VarNext: state_type] :
      ( v87566(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87565(VarNext,B)
          <=> v87540(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87566(VarNext)
      <=> v87567(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87567(VarNext)
      <=> ( v87569(VarNext)
          & v87523(VarNext) ) ) ) ).

tff(writeUnaryOperator_4054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87569(VarNext)
      <=> v87534(VarNext) ) ) ).

tff(addAssignment_53453,axiom,
    ! [VarCurr: state_type] :
      ( v87313(VarCurr,2)
    <=> v87315(VarCurr,2) ) ).

tff(addAssignment_53452,axiom,
    ! [VarCurr: state_type] :
      ( v87315(VarCurr,2)
    <=> v87317(VarCurr,2) ) ).

tff(addAssignment_53451,axiom,
    ! [VarCurr: state_type] :
      ( v87317(VarCurr,2)
    <=> v87518(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_780,axiom,
    ! [VarCurr: state_type] :
      ( v87520(VarCurr)
    <=> ( v87321(VarCurr,1)
        & v87563(VarCurr) ) ) ).

tff(writeUnaryOperator_4053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87563(VarCurr)
    <=> v87321(VarCurr,0) ) ).

tff(addAssignment_53450,axiom,
    ! [VarCurr: state_type] :
      ( v87547(VarCurr)
    <=> v87301(VarCurr,1) ) ).

tff(addAssignment_53449,axiom,
    ! [VarCurr: state_type] :
      ( v87301(VarCurr,1)
    <=> v87303(VarCurr,1) ) ).

tff(addAssignment_53448,axiom,
    ! [VarNext: state_type] :
      ( v87303(VarNext,1)
    <=> v87552(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87553(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87552(VarNext,B)
            <=> v87303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_987,axiom,
    ! [VarNext: state_type] :
      ( v87553(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87552(VarNext,B)
          <=> v87540(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87553(VarNext)
      <=> v87554(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87554(VarNext)
      <=> ( v87556(VarNext)
          & v87523(VarNext) ) ) ) ).

tff(writeUnaryOperator_4052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87556(VarNext)
      <=> v87534(VarNext) ) ) ).

tff(addAssignment_53447,axiom,
    ! [VarCurr: state_type] :
      ( v87313(VarCurr,1)
    <=> v87315(VarCurr,1) ) ).

tff(addAssignment_53446,axiom,
    ! [VarCurr: state_type] :
      ( v87315(VarCurr,1)
    <=> v87317(VarCurr,1) ) ).

tff(addAssignment_53445,axiom,
    ! [VarCurr: state_type] :
      ( v87317(VarCurr,1)
    <=> v87518(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8145,axiom,
    ! [VarCurr: state_type] :
      ( v87521(VarCurr)
    <=> ( v87550(VarCurr)
        & v87321(VarCurr,0) ) ) ).

tff(writeUnaryOperator_4051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87550(VarCurr)
    <=> v87321(VarCurr,1) ) ).

tff(addAssignment_53444,axiom,
    ! [VarCurr: state_type] :
      ( v87299(VarCurr)
    <=> v87301(VarCurr,0) ) ).

tff(addAssignment_53443,axiom,
    ! [VarCurr: state_type] :
      ( v87301(VarCurr,0)
    <=> v87303(VarCurr,0) ) ).

tff(addAssignment_53442,axiom,
    ! [VarNext: state_type] :
      ( v87303(VarNext,0)
    <=> v87529(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87530(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87529(VarNext,B)
            <=> v87303(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_986,axiom,
    ! [VarNext: state_type] :
      ( v87530(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87529(VarNext,B)
          <=> v87540(VarNext,B) ) ) ) ).

tff(addAssignment_53441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87540(VarNext,B)
          <=> v87538(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87541(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87538(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_511,axiom,
    ! [VarCurr: state_type] :
      ( v87541(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87538(VarCurr,B)
          <=> v87313(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8144,axiom,
    ! [VarCurr: state_type] :
      ( v87541(VarCurr)
    <=> ( v87542(VarCurr)
        & v87543(VarCurr) ) ) ).

tff(writeUnaryOperator_4050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87543(VarCurr)
    <=> v87309(VarCurr) ) ).

tff(writeUnaryOperator_4049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87542(VarCurr)
    <=> v87305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87530(VarNext)
      <=> v87531(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87531(VarNext)
      <=> ( v87532(VarNext)
          & v87523(VarNext) ) ) ) ).

tff(writeUnaryOperator_4048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87532(VarNext)
      <=> v87534(VarNext) ) ) ).

tff(addAssignment_53440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87534(VarNext)
      <=> v87523(VarCurr) ) ) ).

tff(addAssignment_53439,axiom,
    ! [VarCurr: state_type] :
      ( v87523(VarCurr)
    <=> v87525(VarCurr) ) ).

tff(addAssignment_53438,axiom,
    ! [VarCurr: state_type] :
      ( v87525(VarCurr)
    <=> v87527(VarCurr) ) ).

tff(addAssignment_53437,axiom,
    ! [VarCurr: state_type] :
      ( v87527(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53436,axiom,
    ! [VarCurr: state_type] :
      ( v87313(VarCurr,0)
    <=> v87315(VarCurr,0) ) ).

tff(addAssignment_53435,axiom,
    ! [VarCurr: state_type] :
      ( v87315(VarCurr,0)
    <=> v87317(VarCurr,0) ) ).

tff(addAssignment_53434,axiom,
    ! [VarCurr: state_type] :
      ( v87317(VarCurr,0)
    <=> v87518(VarCurr,0) ) ).

tff(addAssignment_53433,axiom,
    ! [VarCurr: state_type] :
      ( v87518(VarCurr,0)
    <=> v87319(VarCurr) ) ).

tff(addAssignment_53432,axiom,
    ! [VarCurr: state_type] :
      ( v87518(VarCurr,1)
    <=> v87521(VarCurr) ) ).

tff(addAssignment_53431,axiom,
    ! [VarCurr: state_type] :
      ( v87518(VarCurr,2)
    <=> v87520(VarCurr) ) ).

tff(addAssignment_53430,axiom,
    ! [VarCurr: state_type] :
      ( v87518(VarCurr,3)
    <=> v87519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8141,axiom,
    ! [VarCurr: state_type] :
      ( v87319(VarCurr)
    <=> ( v87516(VarCurr)
        & v87517(VarCurr) ) ) ).

tff(writeUnaryOperator_4047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87517(VarCurr)
    <=> v87321(VarCurr,0) ) ).

tff(writeUnaryOperator_4046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87516(VarCurr)
    <=> v87321(VarCurr,1) ) ).

tff(addAssignment_53429,axiom,
    ! [VarCurr: state_type] :
      ( v87321(VarCurr,0)
    <=> v87323(VarCurr,0) ) ).

tff(addAssignment_53428,axiom,
    ! [VarCurr: state_type] :
      ( v87323(VarCurr,0)
    <=> v87325(VarCurr,0) ) ).

tff(addAssignment_53427,axiom,
    ! [VarCurr: state_type] :
      ( v87325(VarCurr,0)
    <=> v87327(VarCurr,0) ) ).

tff(addAssignment_53426,axiom,
    ! [VarNext: state_type] :
      ( v87327(VarNext,0)
    <=> v87508(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_985,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87509(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v87508(VarNext,B)
            <=> v87327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_985,axiom,
    ! [VarNext: state_type] :
      ( v87509(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87508(VarNext,B)
          <=> v87501(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87509(VarNext)
      <=> v87510(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87510(VarNext)
      <=> ( v87512(VarNext)
          & v87486(VarNext) ) ) ) ).

tff(writeUnaryOperator_4045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87512(VarNext)
      <=> v87495(VarNext) ) ) ).

tff(addAssignment_53425,axiom,
    ! [VarCurr: state_type] :
      ( v87337(VarCurr,0)
    <=> v87339(VarCurr,0) ) ).

tff(addAssignment_53424,axiom,
    ! [VarCurr: state_type] :
      ( v87339(VarCurr,0)
    <=> v87341(VarCurr,0) ) ).

tff(addAssignment_53423,axiom,
    ! [VarCurr: state_type] :
      ( v87341(VarCurr,0)
    <=> v87343(VarCurr,0) ) ).

tff(addAssignment_53422,axiom,
    ! [VarCurr: state_type] :
      ( v87343(VarCurr,0)
    <=> v87476(VarCurr,0) ) ).

tff(addAssignment_53421,axiom,
    ! [VarCurr: state_type] :
      ( v87321(VarCurr,1)
    <=> v87323(VarCurr,1) ) ).

tff(addAssignment_53420,axiom,
    ! [VarCurr: state_type] :
      ( v87323(VarCurr,1)
    <=> v87325(VarCurr,1) ) ).

tff(addAssignment_53419,axiom,
    ! [VarCurr: state_type] :
      ( v87325(VarCurr,1)
    <=> v87327(VarCurr,1) ) ).

tff(addAssignment_53418,axiom,
    ! [VarNext: state_type] :
      ( v87327(VarNext,1)
    <=> v87490(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87491(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v87490(VarNext,B)
            <=> v87327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_984,axiom,
    ! [VarNext: state_type] :
      ( v87491(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87490(VarNext,B)
          <=> v87501(VarNext,B) ) ) ) ).

tff(addAssignment_53417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87501(VarNext,B)
          <=> v87499(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87502(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87499(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_510,axiom,
    ! [VarCurr: state_type] :
      ( v87502(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87499(VarCurr,B)
          <=> v87337(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8138,axiom,
    ! [VarCurr: state_type] :
      ( v87502(VarCurr)
    <=> ( v87503(VarCurr)
        & v87504(VarCurr) ) ) ).

tff(writeUnaryOperator_4044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87504(VarCurr)
    <=> v87333(VarCurr) ) ).

tff(writeUnaryOperator_4043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87503(VarCurr)
    <=> v87329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87491(VarNext)
      <=> v87492(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87492(VarNext)
      <=> ( v87493(VarNext)
          & v87486(VarNext) ) ) ) ).

tff(writeUnaryOperator_4042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87493(VarNext)
      <=> v87495(VarNext) ) ) ).

tff(addAssignment_53416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87495(VarNext)
      <=> v87486(VarCurr) ) ) ).

tff(addAssignment_53415,axiom,
    ! [VarCurr: state_type] :
      ( v87486(VarCurr)
    <=> v87488(VarCurr) ) ).

tff(addAssignment_53414,axiom,
    ! [VarCurr: state_type] :
      ( v87488(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53413,axiom,
    ! [VarCurr: state_type] :
      ( v87337(VarCurr,1)
    <=> v87339(VarCurr,1) ) ).

tff(addAssignment_53412,axiom,
    ! [VarCurr: state_type] :
      ( v87339(VarCurr,1)
    <=> v87341(VarCurr,1) ) ).

tff(addAssignment_53411,axiom,
    ! [VarCurr: state_type] :
      ( v87341(VarCurr,1)
    <=> v87343(VarCurr,1) ) ).

tff(addAssignment_53410,axiom,
    ! [VarCurr: state_type] :
      ( v87343(VarCurr,1)
    <=> v87476(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87477(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87476(VarCurr,B)
          <=> v87480(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_509,axiom,
    ! [VarCurr: state_type] :
      ( v87477(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87476(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87481(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87480(VarCurr,B)
          <=> v87483(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_508,axiom,
    ! [VarCurr: state_type] :
      ( v87481(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87480(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87484(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87483(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_507,axiom,
    ! [VarCurr: state_type] :
      ( v87484(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v87483(VarCurr,B)
          <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_393,axiom,
    ! [VarCurr: state_type] :
      ( v87484(VarCurr)
    <=> ( ( v87345(VarCurr,3)
        <=> $true )
        & ( v87345(VarCurr,2)
        <=> $true )
        & ( v87345(VarCurr,1)
        <=> $true )
        & ( v87345(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8135,axiom,
    ! [VarCurr: state_type] :
      ( v87481(VarCurr)
    <=> ( v87482(VarCurr)
        & v87410(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_392,axiom,
    ! [VarCurr: state_type] :
      ( v87482(VarCurr)
    <=> ( ( v87345(VarCurr,3)
        <=> $true )
        & ( v87345(VarCurr,2)
        <=> $true )
        & ( v87345(VarCurr,1)
        <=> $true )
        & ( v87345(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8134,axiom,
    ! [VarCurr: state_type] :
      ( v87477(VarCurr)
    <=> ( v87478(VarCurr)
        & v87479(VarCurr) ) ) ).

tff(writeUnaryOperator_4041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87479(VarCurr)
    <=> v87410(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_391,axiom,
    ! [VarCurr: state_type] :
      ( v87478(VarCurr)
    <=> ( ( v87345(VarCurr,3)
        <=> $true )
        & ( v87345(VarCurr,2)
        <=> $true )
        & ( v87345(VarCurr,1)
        <=> $true )
        & ( v87345(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_53409,axiom,
    ! [VarCurr: state_type] :
      ( v87410(VarCurr)
    <=> v87412(VarCurr) ) ).

tff(writeUnaryOperator_4040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87412(VarCurr)
    <=> v87414(VarCurr) ) ).

tff(addAssignment_53408,axiom,
    ! [VarCurr: state_type] :
      ( v87414(VarCurr)
    <=> v87416(VarCurr) ) ).

tff(addAssignment_53407,axiom,
    ! [VarCurr: state_type] :
      ( v87416(VarCurr)
    <=> v87418(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87459(VarNext)
       => ( v87418(VarNext)
        <=> v87418(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_983,axiom,
    ! [VarNext: state_type] :
      ( v87459(VarNext)
     => ( v87418(VarNext)
      <=> v87469(VarNext) ) ) ).

tff(addAssignment_53406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87469(VarNext)
      <=> v87467(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87470(VarCurr)
     => ( v87467(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_506,axiom,
    ! [VarCurr: state_type] :
      ( v87470(VarCurr)
     => ( v87467(VarCurr)
      <=> v87428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8133,axiom,
    ! [VarCurr: state_type] :
      ( v87470(VarCurr)
    <=> ( v87471(VarCurr)
        & v87472(VarCurr) ) ) ).

tff(writeUnaryOperator_4039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87472(VarCurr)
    <=> v87424(VarCurr) ) ).

tff(writeUnaryOperator_4038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87471(VarCurr)
    <=> v87420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87459(VarNext)
      <=> v87460(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87460(VarNext)
      <=> ( v87461(VarNext)
          & v87454(VarNext) ) ) ) ).

tff(writeUnaryOperator_4037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87461(VarNext)
      <=> v87463(VarNext) ) ) ).

tff(addAssignment_53405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87463(VarNext)
      <=> v87454(VarCurr) ) ) ).

tff(addAssignment_53404,axiom,
    ! [VarCurr: state_type] :
      ( v87454(VarCurr)
    <=> v87456(VarCurr) ) ).

tff(addAssignment_53403,axiom,
    ! [VarCurr: state_type] :
      ( v87456(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53402,axiom,
    ! [VarCurr: state_type] :
      ( v87428(VarCurr)
    <=> v87430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8130,axiom,
    ! [VarCurr: state_type] :
      ( v87430(VarCurr)
    <=> ( v87446(VarCurr)
        | v87449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8129,axiom,
    ! [VarCurr: state_type] :
      ( v87449(VarCurr)
    <=> ( v87416(VarCurr)
        & v87450(VarCurr) ) ) ).

tff(writeUnaryOperator_4036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87450(VarCurr)
    <=> v87451(VarCurr) ) ).

tff(addAssignment_53401,axiom,
    ! [VarCurr: state_type] :
      ( v87451(VarCurr)
    <=> v87452(VarCurr) ) ).

tff(addAssignment_53400,axiom,
    ! [VarCurr: state_type] :
      ( v87452(VarCurr)
    <=> v87439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8128,axiom,
    ! [VarCurr: state_type] :
      ( v87446(VarCurr)
    <=> ( v87432(VarCurr)
        & v87447(VarCurr) ) ) ).

tff(addAssignment_53399,axiom,
    ! [VarCurr: state_type] :
      ( v87447(VarCurr)
    <=> v87448(VarCurr) ) ).

tff(addAssignment_53398,axiom,
    ! [VarCurr: state_type] :
      ( v87448(VarCurr)
    <=> v87439(VarCurr) ) ).

tff(addAssignment_53397,axiom,
    ! [VarCurr: state_type] :
      ( v87439(VarCurr)
    <=> v87441(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8127,axiom,
    ! [VarCurr: state_type] :
      ( v87441(VarCurr)
    <=> ( v1729(VarCurr)
        & v87444(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_390,axiom,
    ! [VarCurr: state_type] :
      ( v87444(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1140,axiom,
    ~ b0000100101000(12) ).

tff(bitBlastConstant_1139,axiom,
    ~ b0000100101000(11) ).

tff(bitBlastConstant_1138,axiom,
    ~ b0000100101000(10) ).

tff(bitBlastConstant_1137,axiom,
    ~ b0000100101000(9) ).

tff(bitBlastConstant_1136,axiom,
    b0000100101000(8) ).

tff(bitBlastConstant_1135,axiom,
    ~ b0000100101000(7) ).

tff(bitBlastConstant_1134,axiom,
    ~ b0000100101000(6) ).

tff(bitBlastConstant_1133,axiom,
    b0000100101000(5) ).

tff(bitBlastConstant_1132,axiom,
    ~ b0000100101000(4) ).

tff(bitBlastConstant_1131,axiom,
    b0000100101000(3) ).

tff(bitBlastConstant_1130,axiom,
    ~ b0000100101000(2) ).

tff(bitBlastConstant_1129,axiom,
    ~ b0000100101000(1) ).

tff(bitBlastConstant_1128,axiom,
    ~ b0000100101000(0) ).

tff(addAssignment_53396,axiom,
    ! [VarCurr: state_type] :
      ( v87432(VarCurr)
    <=> v87434(VarCurr) ) ).

tff(writeUnaryOperator_4035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87434(VarCurr)
    <=> v87436(VarCurr) ) ).

tff(addAssignment_53395,axiom,
    ! [VarCurr: state_type] :
      ( v87436(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53394,axiom,
    ! [VarCurr: state_type] :
      ( v87424(VarCurr)
    <=> v87426(VarCurr) ) ).

tff(addAssignment_53393,axiom,
    ! [VarCurr: state_type] :
      ( v87426(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53392,axiom,
    ! [VarCurr: state_type] :
      ( v87420(VarCurr)
    <=> v87422(VarCurr) ) ).

tff(addAssignment_53391,axiom,
    ! [VarCurr: state_type] :
      ( v87422(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(writeUnaryOperator_4034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87345(VarCurr,B)
      <=> ~ v87347(VarCurr,B) ) ) ).

tff(addAssignment_53390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87347(VarCurr,B)
      <=> v87349(VarCurr,B) ) ) ).

tff(addAssignment_53389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87349(VarCurr,B)
      <=> v87351(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87392(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v87351(VarNext,B)
            <=> v87351(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_982,axiom,
    ! [VarNext: state_type] :
      ( v87392(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87351(VarNext,B)
          <=> v87402(VarNext,B) ) ) ) ).

tff(addAssignment_53388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87402(VarNext,B)
          <=> v87400(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87403(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87400(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_505,axiom,
    ! [VarCurr: state_type] :
      ( v87403(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v87400(VarCurr,B)
          <=> v87361(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8126,axiom,
    ! [VarCurr: state_type] :
      ( v87403(VarCurr)
    <=> ( v87404(VarCurr)
        & v87405(VarCurr) ) ) ).

tff(writeUnaryOperator_4033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87405(VarCurr)
    <=> v87357(VarCurr) ) ).

tff(writeUnaryOperator_4032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87404(VarCurr)
    <=> v87353(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87392(VarNext)
      <=> v87393(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87393(VarNext)
      <=> ( v87394(VarNext)
          & v87387(VarNext) ) ) ) ).

tff(writeUnaryOperator_4031,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87394(VarNext)
      <=> v87396(VarNext) ) ) ).

tff(addAssignment_53387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87396(VarNext)
      <=> v87387(VarCurr) ) ) ).

tff(addAssignment_53386,axiom,
    ! [VarCurr: state_type] :
      ( v87387(VarCurr)
    <=> v87389(VarCurr) ) ).

tff(addAssignment_53385,axiom,
    ! [VarCurr: state_type] :
      ( v87389(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87361(VarCurr,B)
      <=> v87363(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87363(VarCurr,B)
      <=> ( v87379(VarCurr,B)
          | v87382(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87382(VarCurr,B)
      <=> ( v87349(VarCurr,B)
          & v87383(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87383(VarCurr,B)
      <=> ~ v87384(VarCurr,B) ) ) ).

tff(addAssignment_53383,axiom,
    ! [VarCurr: state_type] :
      ( v87384(VarCurr,0)
    <=> v87385(VarCurr) ) ).

tff(addAssignment_53382,axiom,
    ! [VarCurr: state_type] :
      ( v87384(VarCurr,1)
    <=> v87385(VarCurr) ) ).

tff(addAssignment_53381,axiom,
    ! [VarCurr: state_type] :
      ( v87384(VarCurr,2)
    <=> v87385(VarCurr) ) ).

tff(addAssignment_53380,axiom,
    ! [VarCurr: state_type] :
      ( v87384(VarCurr,3)
    <=> v87385(VarCurr) ) ).

tff(addAssignment_53379,axiom,
    ! [VarCurr: state_type] :
      ( v87385(VarCurr)
    <=> v87372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87379(VarCurr,B)
      <=> ( v87365(VarCurr,B)
          & v87380(VarCurr,B) ) ) ) ).

tff(addAssignment_53378,axiom,
    ! [VarCurr: state_type] :
      ( v87380(VarCurr,0)
    <=> v87381(VarCurr) ) ).

tff(addAssignment_53377,axiom,
    ! [VarCurr: state_type] :
      ( v87380(VarCurr,1)
    <=> v87381(VarCurr) ) ).

tff(addAssignment_53376,axiom,
    ! [VarCurr: state_type] :
      ( v87380(VarCurr,2)
    <=> v87381(VarCurr) ) ).

tff(addAssignment_53375,axiom,
    ! [VarCurr: state_type] :
      ( v87380(VarCurr,3)
    <=> v87381(VarCurr) ) ).

tff(addAssignment_53374,axiom,
    ! [VarCurr: state_type] :
      ( v87381(VarCurr)
    <=> v87372(VarCurr) ) ).

tff(addAssignment_53373,axiom,
    ! [VarCurr: state_type] :
      ( v87372(VarCurr)
    <=> v87374(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8123,axiom,
    ! [VarCurr: state_type] :
      ( v87374(VarCurr)
    <=> ( v1729(VarCurr)
        & v87377(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_389,axiom,
    ! [VarCurr: state_type] :
      ( v87377(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1127,axiom,
    ~ b0000000001000(12) ).

tff(bitBlastConstant_1126,axiom,
    ~ b0000000001000(11) ).

tff(bitBlastConstant_1125,axiom,
    ~ b0000000001000(10) ).

tff(bitBlastConstant_1124,axiom,
    ~ b0000000001000(9) ).

tff(bitBlastConstant_1123,axiom,
    ~ b0000000001000(8) ).

tff(bitBlastConstant_1122,axiom,
    ~ b0000000001000(7) ).

tff(bitBlastConstant_1121,axiom,
    ~ b0000000001000(6) ).

tff(bitBlastConstant_1120,axiom,
    ~ b0000000001000(5) ).

tff(bitBlastConstant_1119,axiom,
    ~ b0000000001000(4) ).

tff(bitBlastConstant_1118,axiom,
    b0000000001000(3) ).

tff(bitBlastConstant_1117,axiom,
    ~ b0000000001000(2) ).

tff(bitBlastConstant_1116,axiom,
    ~ b0000000001000(1) ).

tff(bitBlastConstant_1115,axiom,
    ~ b0000000001000(0) ).

tff(addAssignment_53372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87365(VarCurr,B)
      <=> v87367(VarCurr,B) ) ) ).

tff(writeUnaryOperator_4029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87367(VarCurr,B)
      <=> ~ v87369(VarCurr,B) ) ) ).

tff(addAssignment_53371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v87369(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_53370,axiom,
    ! [VarCurr: state_type] :
      ( v87357(VarCurr)
    <=> v87359(VarCurr) ) ).

tff(addAssignment_53369,axiom,
    ! [VarCurr: state_type] :
      ( v87359(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53368,axiom,
    ! [VarCurr: state_type] :
      ( v87353(VarCurr)
    <=> v87355(VarCurr) ) ).

tff(addAssignment_53367,axiom,
    ! [VarCurr: state_type] :
      ( v87355(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53366,axiom,
    ! [VarCurr: state_type] :
      ( v87333(VarCurr)
    <=> v87335(VarCurr) ) ).

tff(addAssignment_53365,axiom,
    ! [VarCurr: state_type] :
      ( v87335(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53364,axiom,
    ! [VarCurr: state_type] :
      ( v87329(VarCurr)
    <=> v87331(VarCurr) ) ).

tff(addAssignment_53363,axiom,
    ! [VarCurr: state_type] :
      ( v87331(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53362,axiom,
    ! [VarCurr: state_type] :
      ( v87309(VarCurr)
    <=> v87311(VarCurr) ) ).

tff(addAssignment_53361,axiom,
    ! [VarCurr: state_type] :
      ( v87311(VarCurr)
    <=> v87283(VarCurr) ) ).

tff(addAssignment_53360,axiom,
    ! [VarCurr: state_type] :
      ( v87305(VarCurr)
    <=> v87307(VarCurr) ) ).

tff(addAssignment_53359,axiom,
    ! [VarCurr: state_type] :
      ( v87307(VarCurr)
    <=> v87275(VarCurr) ) ).

tff(addAssignment_53358,axiom,
    ! [VarCurr: state_type] :
      ( v87279(VarCurr)
    <=> v87281(VarCurr) ) ).

tff(addAssignment_53357,axiom,
    ! [VarCurr: state_type] :
      ( v87281(VarCurr)
    <=> v87283(VarCurr) ) ).

tff(addAssignment_53356,axiom,
    ! [VarCurr: state_type] :
      ( v87283(VarCurr)
    <=> v87285(VarCurr) ) ).

tff(addAssignment_53355,axiom,
    ! [VarCurr: state_type] :
      ( v87285(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_53354,axiom,
    ! [VarCurr: state_type] :
      ( v87271(VarCurr)
    <=> v87273(VarCurr) ) ).

tff(addAssignment_53353,axiom,
    ! [VarCurr: state_type] :
      ( v87273(VarCurr)
    <=> v87275(VarCurr) ) ).

tff(addAssignment_53352,axiom,
    ! [VarCurr: state_type] :
      ( v87275(VarCurr)
    <=> v87277(VarCurr) ) ).

tff(addAssignment_53351,axiom,
    ! [VarCurr: state_type] :
      ( v87277(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_53350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,22) )
     => ( v87204(VarCurr,B)
      <=> v87261(VarCurr,B) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_6,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87206(VarCurr)
     => ( ( v87261(VarCurr,29)
        <=> v86956(VarCurr,30) )
        & ( v87261(VarCurr,28)
        <=> v86956(VarCurr,29) )
        & ( v87261(VarCurr,27)
        <=> v86956(VarCurr,28) )
        & ( v87261(VarCurr,26)
        <=> v86956(VarCurr,27) )
        & ( v87261(VarCurr,25)
        <=> v86956(VarCurr,26) )
        & ( v87261(VarCurr,24)
        <=> v86956(VarCurr,25) )
        & ( v87261(VarCurr,23)
        <=> v86956(VarCurr,24) )
        & ( v87261(VarCurr,22)
        <=> v86956(VarCurr,23) )
        & ( v87261(VarCurr,21)
        <=> v86956(VarCurr,22) )
        & ( v87261(VarCurr,20)
        <=> v86956(VarCurr,21) )
        & ( v87261(VarCurr,19)
        <=> v86956(VarCurr,20) )
        & ( v87261(VarCurr,18)
        <=> v86956(VarCurr,19) )
        & ( v87261(VarCurr,17)
        <=> v86956(VarCurr,18) )
        & ( v87261(VarCurr,16)
        <=> v86956(VarCurr,17) )
        & ( v87261(VarCurr,15)
        <=> v86956(VarCurr,16) )
        & ( v87261(VarCurr,14)
        <=> v86956(VarCurr,15) )
        & ( v87261(VarCurr,13)
        <=> v86956(VarCurr,14) )
        & ( v87261(VarCurr,12)
        <=> v86956(VarCurr,13) )
        & ( v87261(VarCurr,11)
        <=> v86956(VarCurr,12) )
        & ( v87261(VarCurr,10)
        <=> v86956(VarCurr,11) )
        & ( v87261(VarCurr,9)
        <=> v86956(VarCurr,10) )
        & ( v87261(VarCurr,8)
        <=> v86956(VarCurr,9) )
        & ( v87261(VarCurr,7)
        <=> v86956(VarCurr,8) )
        & ( v87261(VarCurr,6)
        <=> v86956(VarCurr,7) )
        & ( v87261(VarCurr,5)
        <=> v86956(VarCurr,6) )
        & ( v87261(VarCurr,4)
        <=> v86956(VarCurr,5) )
        & ( v87261(VarCurr,3)
        <=> v86956(VarCurr,4) )
        & ( v87261(VarCurr,2)
        <=> v86956(VarCurr,3) )
        & ( v87261(VarCurr,1)
        <=> v86956(VarCurr,2) )
        & ( v87261(VarCurr,0)
        <=> v86956(VarCurr,1) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_504,axiom,
    ! [VarCurr: state_type] :
      ( v87206(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,30)
            & ~ $less(B,0) )
         => ( v87261(VarCurr,B)
          <=> v87262(VarCurr,B) ) ) ) ).

tff(addAssignment_53349,axiom,
    ! [VarCurr: state_type] :
      ( v87262(VarCurr,0)
    <=> v87263(VarCurr,0) ) ).

tff(addAssignment_53348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,1) )
     => ( v87262(VarCurr,B)
      <=> v86956(VarCurr,B) ) ) ).

tff(addAssignment_53347,axiom,
    ! [VarCurr: state_type] :
      ( v86956(VarCurr,30)
    <=> v86958(VarCurr,31) ) ).

tff(addAssignment_53346,axiom,
    ! [VarCurr: state_type] :
      ( v86958(VarCurr,31)
    <=> v86960(VarCurr,31) ) ).

tff(addAssignment_53345,axiom,
    ! [VarCurr: state_type] :
      ( v86960(VarCurr,31)
    <=> v86962(VarCurr,31) ) ).

tff(addAssignment_53344,axiom,
    ! [VarNext: state_type] :
      ( v86962(VarNext,31)
    <=> v87254(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v87254(VarNext,B)
            <=> v86962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_981,axiom,
    ! [VarNext: state_type] :
      ( v87255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87254(VarNext,B)
          <=> v87239(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87255(VarNext)
      <=> v87256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87256(VarNext)
      <=> ( v87258(VarNext)
          & v87224(VarNext) ) ) ) ).

tff(writeUnaryOperator_4028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87258(VarNext)
      <=> v87233(VarNext) ) ) ).

tff(addAssignment_53343,axiom,
    ! [VarCurr: state_type] :
      ( v86972(VarCurr,31)
    <=> v86974(VarCurr,31) ) ).

tff(addAssignment_53342,axiom,
    ! [VarCurr: state_type] :
      ( v86974(VarCurr,31)
    <=> v87207(VarCurr,31) ) ).

tff(addAssignment_53341,axiom,
    ! [VarCurr: state_type] :
      ( v86976(VarCurr,31)
    <=> v86978(VarCurr,31) ) ).

tff(addAssignment_53340,axiom,
    ! [VarCurr: state_type] :
      ( v86978(VarCurr,31)
    <=> v86980(VarCurr,31) ) ).

tff(addAssignment_53339,axiom,
    ! [VarCurr: state_type] :
      ( ( v86956(VarCurr,29)
      <=> v86958(VarCurr,30) )
      & ( v86956(VarCurr,28)
      <=> v86958(VarCurr,29) )
      & ( v86956(VarCurr,27)
      <=> v86958(VarCurr,28) )
      & ( v86956(VarCurr,26)
      <=> v86958(VarCurr,27) )
      & ( v86956(VarCurr,25)
      <=> v86958(VarCurr,26) )
      & ( v86956(VarCurr,24)
      <=> v86958(VarCurr,25) )
      & ( v86956(VarCurr,23)
      <=> v86958(VarCurr,24) )
      & ( v86956(VarCurr,22)
      <=> v86958(VarCurr,23) ) ) ).

tff(addAssignment_53338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,24) )
     => ( v86958(VarCurr,B)
      <=> v86960(VarCurr,B) ) ) ).

tff(addAssignment_53337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86960(VarCurr,B)
      <=> v86962(VarCurr,B) ) ) ).

tff(addAssignment_53336,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86962(VarNext,B)
      <=> v87246(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87247(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v87246(VarNext,B)
            <=> v86962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_980,axiom,
    ! [VarNext: state_type] :
      ( v87247(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87246(VarNext,B)
          <=> v87239(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87247(VarNext)
      <=> v87248(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87248(VarNext)
      <=> ( v87250(VarNext)
          & v87224(VarNext) ) ) ) ).

tff(writeUnaryOperator_4027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87250(VarNext)
      <=> v87233(VarNext) ) ) ).

tff(addAssignment_53335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86972(VarCurr,B)
      <=> v86974(VarCurr,B) ) ) ).

tff(addAssignment_53334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86974(VarCurr,B)
      <=> v87207(VarCurr,B) ) ) ).

tff(addAssignment_53333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86976(VarCurr,B)
      <=> v86978(VarCurr,B) ) ) ).

tff(addAssignment_53332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,23) )
     => ( v86978(VarCurr,B)
      <=> v86980(VarCurr,B) ) ) ).

tff(addAssignment_53331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,0) )
     => ( v86958(VarCurr,B)
      <=> v86960(VarCurr,B) ) ) ).

tff(addAssignment_53330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86960(VarCurr,B)
      <=> v86962(VarCurr,B) ) ) ).

tff(addAssignment_53329,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86962(VarNext,B)
      <=> v87228(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87229(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v87228(VarNext,B)
            <=> v86962(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_979,axiom,
    ! [VarNext: state_type] :
      ( v87229(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87228(VarNext,B)
          <=> v87239(VarNext,B) ) ) ) ).

tff(addAssignment_53328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87239(VarNext,B)
          <=> v87237(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87240(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87237(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_503,axiom,
    ! [VarCurr: state_type] :
      ( v87240(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v87237(VarCurr,B)
          <=> v86972(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8118,axiom,
    ! [VarCurr: state_type] :
      ( v87240(VarCurr)
    <=> ( v87241(VarCurr)
        & v87242(VarCurr) ) ) ).

tff(writeUnaryOperator_4026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87242(VarCurr)
    <=> v86968(VarCurr) ) ).

tff(writeUnaryOperator_4025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87241(VarCurr)
    <=> v86964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87229(VarNext)
      <=> v87230(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87230(VarNext)
      <=> ( v87231(VarNext)
          & v87224(VarNext) ) ) ) ).

tff(writeUnaryOperator_4024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v87231(VarNext)
      <=> v87233(VarNext) ) ) ).

tff(addAssignment_53327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v87233(VarNext)
      <=> v87224(VarCurr) ) ) ).

tff(addAssignment_53326,axiom,
    ! [VarCurr: state_type] :
      ( v87224(VarCurr)
    <=> v87226(VarCurr) ) ).

tff(addAssignment_53325,axiom,
    ! [VarCurr: state_type] :
      ( v87226(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86972(VarCurr,B)
      <=> v86974(VarCurr,B) ) ) ).

tff(addAssignment_53323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86974(VarCurr,B)
      <=> v87207(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87207(VarCurr,B)
      <=> ( v87208(VarCurr,B)
          | v87215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87215(VarCurr,B)
      <=> ( v87216(VarCurr,B)
          & v87220(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87220(VarCurr,B)
      <=> ~ v87221(VarCurr,B) ) ) ).

tff(addAssignment_53322,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,0)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53321,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,1)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53320,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,2)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53319,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,3)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53318,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,4)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53317,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,5)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53316,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,6)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53315,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,7)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53314,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,8)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53313,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,9)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53312,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,10)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53311,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,11)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53310,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,12)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53309,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,13)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53308,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,14)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53307,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,15)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53306,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,16)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53305,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,17)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53304,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,18)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53303,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,19)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53302,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,20)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53301,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,21)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53300,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,22)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53299,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,23)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53298,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,24)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53297,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,25)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53296,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,26)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53295,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,27)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53294,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,28)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53293,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,29)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53292,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,30)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53291,axiom,
    ! [VarCurr: state_type] :
      ( v87221(VarCurr,31)
    <=> v87222(VarCurr) ) ).

tff(addAssignment_53290,axiom,
    ! [VarCurr: state_type] :
      ( v87222(VarCurr)
    <=> v87194(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87216(VarCurr,B)
      <=> ( v86960(VarCurr,B)
          & v87217(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87217(VarCurr,B)
      <=> ~ v87218(VarCurr,B) ) ) ).

tff(addAssignment_53289,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,0)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53288,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,1)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53287,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,2)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53286,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,3)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53285,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,4)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53284,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,5)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53283,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,6)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53282,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,7)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53281,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,8)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53280,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,9)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53279,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,10)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53278,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,11)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53277,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,12)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53276,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,13)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53275,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,14)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53274,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,15)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53273,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,16)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53272,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,17)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53271,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,18)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53270,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,19)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53269,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,20)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53268,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,21)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53267,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,22)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53266,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,23)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53265,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,24)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53264,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,25)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53263,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,26)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53262,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,27)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53261,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,28)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53260,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,29)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53259,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,30)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53258,axiom,
    ! [VarCurr: state_type] :
      ( v87218(VarCurr,31)
    <=> v87219(VarCurr) ) ).

tff(addAssignment_53257,axiom,
    ! [VarCurr: state_type] :
      ( v87219(VarCurr)
    <=> v87168(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87208(VarCurr,B)
      <=> ( v87209(VarCurr,B)
          & v87212(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_4021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87212(VarCurr,B)
      <=> ~ v87213(VarCurr,B) ) ) ).

tff(addAssignment_53256,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,0)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53255,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,1)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53254,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,2)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53253,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,3)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53252,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,4)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53251,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,5)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53250,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,6)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53249,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,7)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53248,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,8)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53247,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,9)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53246,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,10)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53245,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,11)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53244,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,12)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53243,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,13)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53242,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,14)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53241,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,15)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53240,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,16)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53239,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,17)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53238,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,18)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53237,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,19)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53236,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,20)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53235,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,21)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53234,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,22)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53233,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,23)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53232,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,24)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53231,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,25)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53230,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,26)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53229,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,27)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53228,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,28)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53227,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,29)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53226,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,30)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53225,axiom,
    ! [VarCurr: state_type] :
      ( v87213(VarCurr,31)
    <=> v87214(VarCurr) ) ).

tff(addAssignment_53224,axiom,
    ! [VarCurr: state_type] :
      ( v87214(VarCurr)
    <=> v87194(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v87209(VarCurr,B)
      <=> ( v86976(VarCurr,B)
          & v87210(VarCurr,B) ) ) ) ).

tff(addAssignment_53223,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,0)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53222,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,1)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53221,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,2)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53220,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,3)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53219,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,4)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53218,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,5)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53217,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,6)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53216,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,7)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53215,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,8)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53214,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,9)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53213,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,10)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53212,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,11)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53211,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,12)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53210,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,13)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53209,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,14)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53208,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,15)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53207,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,16)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53206,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,17)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53205,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,18)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53204,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,19)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53203,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,20)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53202,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,21)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53201,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,22)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53200,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,23)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53199,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,24)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53198,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,25)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53197,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,26)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53196,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,27)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53195,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,28)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53194,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,29)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53193,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,30)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53192,axiom,
    ! [VarCurr: state_type] :
      ( v87210(VarCurr,31)
    <=> v87211(VarCurr) ) ).

tff(addAssignment_53191,axiom,
    ! [VarCurr: state_type] :
      ( v87211(VarCurr)
    <=> v87168(VarCurr) ) ).

tff(addAssignment_53190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86976(VarCurr,B)
      <=> v86978(VarCurr,B) ) ) ).

tff(addAssignment_53189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,23)
        & ~ $less(B,2) )
     => ( v86978(VarCurr,B)
      <=> v86980(VarCurr,B) ) ) ).

tff(addAssignment_53188,axiom,
    ! [VarCurr: state_type] :
      ( v87206(VarCurr)
    <=> v1051(VarCurr) ) ).

tff(addAssignment_53187,axiom,
    ! [VarCurr: state_type] :
      ( v87168(VarCurr)
    <=> v87170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8115,axiom,
    ! [VarCurr: state_type] :
      ( v87170(VarCurr)
    <=> ( v87172(VarCurr)
        | v87188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8114,axiom,
    ! [VarCurr: state_type] :
      ( v87188(VarCurr)
    <=> ( v87190(VarCurr)
        & v777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8113,axiom,
    ! [VarCurr: state_type] :
      ( v87190(VarCurr)
    <=> ( v5414(VarCurr)
        & v87191(VarCurr) ) ) ).

tff(writeUnaryOperator_4020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87191(VarCurr)
    <=> v779(VarCurr) ) ).

tff(addAssignment_53186,axiom,
    ! [VarCurr: state_type] :
      ( v87172(VarCurr)
    <=> v87174(VarCurr) ) ).

tff(addAssignment_53185,axiom,
    ! [VarCurr: state_type] :
      ( v87174(VarCurr)
    <=> v87176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8112,axiom,
    ! [VarCurr: state_type] :
      ( v87176(VarCurr)
    <=> ( v87183(VarCurr)
        & v87186(VarCurr) ) ) ).

tff(writeUnaryOperator_4019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87186(VarCurr)
    <=> v82909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8111,axiom,
    ! [VarCurr: state_type] :
      ( v87183(VarCurr)
    <=> ( v87184(VarCurr)
        & v87185(VarCurr) ) ) ).

tff(writeUnaryOperator_4018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87185(VarCurr)
    <=> v87180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8110,axiom,
    ! [VarCurr: state_type] :
      ( v87184(VarCurr)
    <=> ( v5753(VarCurr)
        & v87178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8109,axiom,
    ! [VarCurr: state_type] :
      ( v87180(VarCurr)
    <=> ( v5801(VarCurr)
        | v82153(VarCurr) ) ) ).

tff(addAssignment_53184,axiom,
    ! [VarCurr: state_type] :
      ( v87178(VarCurr)
    <=> v910(VarCurr,5) ) ).

tff(addAssignment_53183,axiom,
    ! [VarCurr: state_type] :
      ( v86976(VarCurr,0)
    <=> v86978(VarCurr,0) ) ).

tff(addAssignment_53182,axiom,
    ! [VarCurr: state_type] :
      ( v86978(VarCurr,0)
    <=> v86980(VarCurr,0) ) ).

tff(addAssignment_53181,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,0)
    <=> v87164(VarCurr) ) ).

tff(addAssignment_53180,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,1)
    <=> v87162(VarCurr) ) ).

tff(addAssignment_53179,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,2)
    <=> v87157(VarCurr) ) ).

tff(addAssignment_53178,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,3)
    <=> v87152(VarCurr) ) ).

tff(addAssignment_53177,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,4)
    <=> v87147(VarCurr) ) ).

tff(addAssignment_53176,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,5)
    <=> v87142(VarCurr) ) ).

tff(addAssignment_53175,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,6)
    <=> v87137(VarCurr) ) ).

tff(addAssignment_53174,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,7)
    <=> v87132(VarCurr) ) ).

tff(addAssignment_53173,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,8)
    <=> v87127(VarCurr) ) ).

tff(addAssignment_53172,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,9)
    <=> v87122(VarCurr) ) ).

tff(addAssignment_53171,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,10)
    <=> v87117(VarCurr) ) ).

tff(addAssignment_53170,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,11)
    <=> v87112(VarCurr) ) ).

tff(addAssignment_53169,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,12)
    <=> v87107(VarCurr) ) ).

tff(addAssignment_53168,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,13)
    <=> v87102(VarCurr) ) ).

tff(addAssignment_53167,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,14)
    <=> v87097(VarCurr) ) ).

tff(addAssignment_53166,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,15)
    <=> v87092(VarCurr) ) ).

tff(addAssignment_53165,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,16)
    <=> v87087(VarCurr) ) ).

tff(addAssignment_53164,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,17)
    <=> v87082(VarCurr) ) ).

tff(addAssignment_53163,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,18)
    <=> v87077(VarCurr) ) ).

tff(addAssignment_53162,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,19)
    <=> v87072(VarCurr) ) ).

tff(addAssignment_53161,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,20)
    <=> v87067(VarCurr) ) ).

tff(addAssignment_53160,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,21)
    <=> v87062(VarCurr) ) ).

tff(addAssignment_53159,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,22)
    <=> v87057(VarCurr) ) ).

tff(addAssignment_53158,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,23)
    <=> v87052(VarCurr) ) ).

tff(addAssignment_53157,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,24)
    <=> v87047(VarCurr) ) ).

tff(addAssignment_53156,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,25)
    <=> v87042(VarCurr) ) ).

tff(addAssignment_53155,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,26)
    <=> v87037(VarCurr) ) ).

tff(addAssignment_53154,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,27)
    <=> v87032(VarCurr) ) ).

tff(addAssignment_53153,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,28)
    <=> v87027(VarCurr) ) ).

tff(addAssignment_53152,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,29)
    <=> v87022(VarCurr) ) ).

tff(addAssignment_53151,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,30)
    <=> v87017(VarCurr) ) ).

tff(addAssignment_53150,axiom,
    ! [VarCurr: state_type] :
      ( v86980(VarCurr,31)
    <=> v86982(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8108,axiom,
    ! [VarCurr: state_type] :
      ( v87162(VarCurr)
    <=> ( v87163(VarCurr)
        & v87166(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_779,axiom,
    ! [VarCurr: state_type] :
      ( v87166(VarCurr)
    <=> ( v86958(VarCurr,0)
        | v86958(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8107,axiom,
    ! [VarCurr: state_type] :
      ( v87163(VarCurr)
    <=> ( v87164(VarCurr)
        | v87165(VarCurr) ) ) ).

tff(writeUnaryOperator_4017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87165(VarCurr)
    <=> v86958(VarCurr,1) ) ).

tff(writeUnaryOperator_4016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87164(VarCurr)
    <=> v86958(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8106,axiom,
    ! [VarCurr: state_type] :
      ( v87157(VarCurr)
    <=> ( v87158(VarCurr)
        & v87161(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_778,axiom,
    ! [VarCurr: state_type] :
      ( v87161(VarCurr)
    <=> ( v87014(VarCurr)
        | v86958(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8105,axiom,
    ! [VarCurr: state_type] :
      ( v87158(VarCurr)
    <=> ( v87159(VarCurr)
        | v87160(VarCurr) ) ) ).

tff(writeUnaryOperator_4015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87160(VarCurr)
    <=> v86958(VarCurr,2) ) ).

tff(writeUnaryOperator_4014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87159(VarCurr)
    <=> v87014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8104,axiom,
    ! [VarCurr: state_type] :
      ( v87152(VarCurr)
    <=> ( v87153(VarCurr)
        & v87156(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_777,axiom,
    ! [VarCurr: state_type] :
      ( v87156(VarCurr)
    <=> ( v87013(VarCurr)
        | v86958(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8103,axiom,
    ! [VarCurr: state_type] :
      ( v87153(VarCurr)
    <=> ( v87154(VarCurr)
        | v87155(VarCurr) ) ) ).

tff(writeUnaryOperator_4013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87155(VarCurr)
    <=> v86958(VarCurr,3) ) ).

tff(writeUnaryOperator_4012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87154(VarCurr)
    <=> v87013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8102,axiom,
    ! [VarCurr: state_type] :
      ( v87147(VarCurr)
    <=> ( v87148(VarCurr)
        & v87151(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_776,axiom,
    ! [VarCurr: state_type] :
      ( v87151(VarCurr)
    <=> ( v87012(VarCurr)
        | v86958(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8101,axiom,
    ! [VarCurr: state_type] :
      ( v87148(VarCurr)
    <=> ( v87149(VarCurr)
        | v87150(VarCurr) ) ) ).

tff(writeUnaryOperator_4011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87150(VarCurr)
    <=> v86958(VarCurr,4) ) ).

tff(writeUnaryOperator_4010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87149(VarCurr)
    <=> v87012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8100,axiom,
    ! [VarCurr: state_type] :
      ( v87142(VarCurr)
    <=> ( v87143(VarCurr)
        & v87146(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_775,axiom,
    ! [VarCurr: state_type] :
      ( v87146(VarCurr)
    <=> ( v87011(VarCurr)
        | v86958(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8099,axiom,
    ! [VarCurr: state_type] :
      ( v87143(VarCurr)
    <=> ( v87144(VarCurr)
        | v87145(VarCurr) ) ) ).

tff(writeUnaryOperator_4009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87145(VarCurr)
    <=> v86958(VarCurr,5) ) ).

tff(writeUnaryOperator_4008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87144(VarCurr)
    <=> v87011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8098,axiom,
    ! [VarCurr: state_type] :
      ( v87137(VarCurr)
    <=> ( v87138(VarCurr)
        & v87141(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_774,axiom,
    ! [VarCurr: state_type] :
      ( v87141(VarCurr)
    <=> ( v87010(VarCurr)
        | v86958(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8097,axiom,
    ! [VarCurr: state_type] :
      ( v87138(VarCurr)
    <=> ( v87139(VarCurr)
        | v87140(VarCurr) ) ) ).

tff(writeUnaryOperator_4007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87140(VarCurr)
    <=> v86958(VarCurr,6) ) ).

tff(writeUnaryOperator_4006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87139(VarCurr)
    <=> v87010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8096,axiom,
    ! [VarCurr: state_type] :
      ( v87132(VarCurr)
    <=> ( v87133(VarCurr)
        & v87136(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_773,axiom,
    ! [VarCurr: state_type] :
      ( v87136(VarCurr)
    <=> ( v87009(VarCurr)
        | v86958(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8095,axiom,
    ! [VarCurr: state_type] :
      ( v87133(VarCurr)
    <=> ( v87134(VarCurr)
        | v87135(VarCurr) ) ) ).

tff(writeUnaryOperator_4005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87135(VarCurr)
    <=> v86958(VarCurr,7) ) ).

tff(writeUnaryOperator_4004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87134(VarCurr)
    <=> v87009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8094,axiom,
    ! [VarCurr: state_type] :
      ( v87127(VarCurr)
    <=> ( v87128(VarCurr)
        & v87131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_772,axiom,
    ! [VarCurr: state_type] :
      ( v87131(VarCurr)
    <=> ( v87008(VarCurr)
        | v86958(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8093,axiom,
    ! [VarCurr: state_type] :
      ( v87128(VarCurr)
    <=> ( v87129(VarCurr)
        | v87130(VarCurr) ) ) ).

tff(writeUnaryOperator_4003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87130(VarCurr)
    <=> v86958(VarCurr,8) ) ).

tff(writeUnaryOperator_4002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87129(VarCurr)
    <=> v87008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8092,axiom,
    ! [VarCurr: state_type] :
      ( v87122(VarCurr)
    <=> ( v87123(VarCurr)
        & v87126(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_771,axiom,
    ! [VarCurr: state_type] :
      ( v87126(VarCurr)
    <=> ( v87007(VarCurr)
        | v86958(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8091,axiom,
    ! [VarCurr: state_type] :
      ( v87123(VarCurr)
    <=> ( v87124(VarCurr)
        | v87125(VarCurr) ) ) ).

tff(writeUnaryOperator_4001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87125(VarCurr)
    <=> v86958(VarCurr,9) ) ).

tff(writeUnaryOperator_4000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87124(VarCurr)
    <=> v87007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8090,axiom,
    ! [VarCurr: state_type] :
      ( v87117(VarCurr)
    <=> ( v87118(VarCurr)
        & v87121(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_770,axiom,
    ! [VarCurr: state_type] :
      ( v87121(VarCurr)
    <=> ( v87006(VarCurr)
        | v86958(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8089,axiom,
    ! [VarCurr: state_type] :
      ( v87118(VarCurr)
    <=> ( v87119(VarCurr)
        | v87120(VarCurr) ) ) ).

tff(writeUnaryOperator_3999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87120(VarCurr)
    <=> v86958(VarCurr,10) ) ).

tff(writeUnaryOperator_3998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87119(VarCurr)
    <=> v87006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8088,axiom,
    ! [VarCurr: state_type] :
      ( v87112(VarCurr)
    <=> ( v87113(VarCurr)
        & v87116(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_769,axiom,
    ! [VarCurr: state_type] :
      ( v87116(VarCurr)
    <=> ( v87005(VarCurr)
        | v86958(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8087,axiom,
    ! [VarCurr: state_type] :
      ( v87113(VarCurr)
    <=> ( v87114(VarCurr)
        | v87115(VarCurr) ) ) ).

tff(writeUnaryOperator_3997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87115(VarCurr)
    <=> v86958(VarCurr,11) ) ).

tff(writeUnaryOperator_3996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87114(VarCurr)
    <=> v87005(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8086,axiom,
    ! [VarCurr: state_type] :
      ( v87107(VarCurr)
    <=> ( v87108(VarCurr)
        & v87111(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_768,axiom,
    ! [VarCurr: state_type] :
      ( v87111(VarCurr)
    <=> ( v87004(VarCurr)
        | v86958(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8085,axiom,
    ! [VarCurr: state_type] :
      ( v87108(VarCurr)
    <=> ( v87109(VarCurr)
        | v87110(VarCurr) ) ) ).

tff(writeUnaryOperator_3995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87110(VarCurr)
    <=> v86958(VarCurr,12) ) ).

tff(writeUnaryOperator_3994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87109(VarCurr)
    <=> v87004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8084,axiom,
    ! [VarCurr: state_type] :
      ( v87102(VarCurr)
    <=> ( v87103(VarCurr)
        & v87106(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_767,axiom,
    ! [VarCurr: state_type] :
      ( v87106(VarCurr)
    <=> ( v87003(VarCurr)
        | v86958(VarCurr,13) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8083,axiom,
    ! [VarCurr: state_type] :
      ( v87103(VarCurr)
    <=> ( v87104(VarCurr)
        | v87105(VarCurr) ) ) ).

tff(writeUnaryOperator_3993,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87105(VarCurr)
    <=> v86958(VarCurr,13) ) ).

tff(writeUnaryOperator_3992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87104(VarCurr)
    <=> v87003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8082,axiom,
    ! [VarCurr: state_type] :
      ( v87097(VarCurr)
    <=> ( v87098(VarCurr)
        & v87101(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_766,axiom,
    ! [VarCurr: state_type] :
      ( v87101(VarCurr)
    <=> ( v87002(VarCurr)
        | v86958(VarCurr,14) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8081,axiom,
    ! [VarCurr: state_type] :
      ( v87098(VarCurr)
    <=> ( v87099(VarCurr)
        | v87100(VarCurr) ) ) ).

tff(writeUnaryOperator_3991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87100(VarCurr)
    <=> v86958(VarCurr,14) ) ).

tff(writeUnaryOperator_3990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87099(VarCurr)
    <=> v87002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8080,axiom,
    ! [VarCurr: state_type] :
      ( v87092(VarCurr)
    <=> ( v87093(VarCurr)
        & v87096(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_765,axiom,
    ! [VarCurr: state_type] :
      ( v87096(VarCurr)
    <=> ( v87001(VarCurr)
        | v86958(VarCurr,15) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8079,axiom,
    ! [VarCurr: state_type] :
      ( v87093(VarCurr)
    <=> ( v87094(VarCurr)
        | v87095(VarCurr) ) ) ).

tff(writeUnaryOperator_3989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87095(VarCurr)
    <=> v86958(VarCurr,15) ) ).

tff(writeUnaryOperator_3988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87094(VarCurr)
    <=> v87001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8078,axiom,
    ! [VarCurr: state_type] :
      ( v87087(VarCurr)
    <=> ( v87088(VarCurr)
        & v87091(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_764,axiom,
    ! [VarCurr: state_type] :
      ( v87091(VarCurr)
    <=> ( v87000(VarCurr)
        | v86958(VarCurr,16) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8077,axiom,
    ! [VarCurr: state_type] :
      ( v87088(VarCurr)
    <=> ( v87089(VarCurr)
        | v87090(VarCurr) ) ) ).

tff(writeUnaryOperator_3987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87090(VarCurr)
    <=> v86958(VarCurr,16) ) ).

tff(writeUnaryOperator_3986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87089(VarCurr)
    <=> v87000(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8076,axiom,
    ! [VarCurr: state_type] :
      ( v87082(VarCurr)
    <=> ( v87083(VarCurr)
        & v87086(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_763,axiom,
    ! [VarCurr: state_type] :
      ( v87086(VarCurr)
    <=> ( v86999(VarCurr)
        | v86958(VarCurr,17) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8075,axiom,
    ! [VarCurr: state_type] :
      ( v87083(VarCurr)
    <=> ( v87084(VarCurr)
        | v87085(VarCurr) ) ) ).

tff(writeUnaryOperator_3985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87085(VarCurr)
    <=> v86958(VarCurr,17) ) ).

tff(writeUnaryOperator_3984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87084(VarCurr)
    <=> v86999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8074,axiom,
    ! [VarCurr: state_type] :
      ( v87077(VarCurr)
    <=> ( v87078(VarCurr)
        & v87081(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_762,axiom,
    ! [VarCurr: state_type] :
      ( v87081(VarCurr)
    <=> ( v86998(VarCurr)
        | v86958(VarCurr,18) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8073,axiom,
    ! [VarCurr: state_type] :
      ( v87078(VarCurr)
    <=> ( v87079(VarCurr)
        | v87080(VarCurr) ) ) ).

tff(writeUnaryOperator_3983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87080(VarCurr)
    <=> v86958(VarCurr,18) ) ).

tff(writeUnaryOperator_3982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87079(VarCurr)
    <=> v86998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8072,axiom,
    ! [VarCurr: state_type] :
      ( v87072(VarCurr)
    <=> ( v87073(VarCurr)
        & v87076(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_761,axiom,
    ! [VarCurr: state_type] :
      ( v87076(VarCurr)
    <=> ( v86997(VarCurr)
        | v86958(VarCurr,19) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8071,axiom,
    ! [VarCurr: state_type] :
      ( v87073(VarCurr)
    <=> ( v87074(VarCurr)
        | v87075(VarCurr) ) ) ).

tff(writeUnaryOperator_3981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87075(VarCurr)
    <=> v86958(VarCurr,19) ) ).

tff(writeUnaryOperator_3980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87074(VarCurr)
    <=> v86997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8070,axiom,
    ! [VarCurr: state_type] :
      ( v87067(VarCurr)
    <=> ( v87068(VarCurr)
        & v87071(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_760,axiom,
    ! [VarCurr: state_type] :
      ( v87071(VarCurr)
    <=> ( v86996(VarCurr)
        | v86958(VarCurr,20) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8069,axiom,
    ! [VarCurr: state_type] :
      ( v87068(VarCurr)
    <=> ( v87069(VarCurr)
        | v87070(VarCurr) ) ) ).

tff(writeUnaryOperator_3979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87070(VarCurr)
    <=> v86958(VarCurr,20) ) ).

tff(writeUnaryOperator_3978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87069(VarCurr)
    <=> v86996(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8068,axiom,
    ! [VarCurr: state_type] :
      ( v87062(VarCurr)
    <=> ( v87063(VarCurr)
        & v87066(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_759,axiom,
    ! [VarCurr: state_type] :
      ( v87066(VarCurr)
    <=> ( v86995(VarCurr)
        | v86958(VarCurr,21) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8067,axiom,
    ! [VarCurr: state_type] :
      ( v87063(VarCurr)
    <=> ( v87064(VarCurr)
        | v87065(VarCurr) ) ) ).

tff(writeUnaryOperator_3977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87065(VarCurr)
    <=> v86958(VarCurr,21) ) ).

tff(writeUnaryOperator_3976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87064(VarCurr)
    <=> v86995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8066,axiom,
    ! [VarCurr: state_type] :
      ( v87057(VarCurr)
    <=> ( v87058(VarCurr)
        & v87061(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_758,axiom,
    ! [VarCurr: state_type] :
      ( v87061(VarCurr)
    <=> ( v86994(VarCurr)
        | v86958(VarCurr,22) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8065,axiom,
    ! [VarCurr: state_type] :
      ( v87058(VarCurr)
    <=> ( v87059(VarCurr)
        | v87060(VarCurr) ) ) ).

tff(writeUnaryOperator_3975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87060(VarCurr)
    <=> v86958(VarCurr,22) ) ).

tff(writeUnaryOperator_3974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87059(VarCurr)
    <=> v86994(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8064,axiom,
    ! [VarCurr: state_type] :
      ( v87052(VarCurr)
    <=> ( v87053(VarCurr)
        & v87056(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_757,axiom,
    ! [VarCurr: state_type] :
      ( v87056(VarCurr)
    <=> ( v86993(VarCurr)
        | v86958(VarCurr,23) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8063,axiom,
    ! [VarCurr: state_type] :
      ( v87053(VarCurr)
    <=> ( v87054(VarCurr)
        | v87055(VarCurr) ) ) ).

tff(writeUnaryOperator_3973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87055(VarCurr)
    <=> v86958(VarCurr,23) ) ).

tff(writeUnaryOperator_3972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87054(VarCurr)
    <=> v86993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8062,axiom,
    ! [VarCurr: state_type] :
      ( v87047(VarCurr)
    <=> ( v87048(VarCurr)
        & v87051(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_756,axiom,
    ! [VarCurr: state_type] :
      ( v87051(VarCurr)
    <=> ( v86992(VarCurr)
        | v86958(VarCurr,24) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8061,axiom,
    ! [VarCurr: state_type] :
      ( v87048(VarCurr)
    <=> ( v87049(VarCurr)
        | v87050(VarCurr) ) ) ).

tff(writeUnaryOperator_3971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87050(VarCurr)
    <=> v86958(VarCurr,24) ) ).

tff(writeUnaryOperator_3970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87049(VarCurr)
    <=> v86992(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8060,axiom,
    ! [VarCurr: state_type] :
      ( v87042(VarCurr)
    <=> ( v87043(VarCurr)
        & v87046(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_755,axiom,
    ! [VarCurr: state_type] :
      ( v87046(VarCurr)
    <=> ( v86991(VarCurr)
        | v86958(VarCurr,25) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8059,axiom,
    ! [VarCurr: state_type] :
      ( v87043(VarCurr)
    <=> ( v87044(VarCurr)
        | v87045(VarCurr) ) ) ).

tff(writeUnaryOperator_3969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87045(VarCurr)
    <=> v86958(VarCurr,25) ) ).

tff(writeUnaryOperator_3968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87044(VarCurr)
    <=> v86991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8058,axiom,
    ! [VarCurr: state_type] :
      ( v87037(VarCurr)
    <=> ( v87038(VarCurr)
        & v87041(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_754,axiom,
    ! [VarCurr: state_type] :
      ( v87041(VarCurr)
    <=> ( v86990(VarCurr)
        | v86958(VarCurr,26) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8057,axiom,
    ! [VarCurr: state_type] :
      ( v87038(VarCurr)
    <=> ( v87039(VarCurr)
        | v87040(VarCurr) ) ) ).

tff(writeUnaryOperator_3967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87040(VarCurr)
    <=> v86958(VarCurr,26) ) ).

tff(writeUnaryOperator_3966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87039(VarCurr)
    <=> v86990(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8056,axiom,
    ! [VarCurr: state_type] :
      ( v87032(VarCurr)
    <=> ( v87033(VarCurr)
        & v87036(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_753,axiom,
    ! [VarCurr: state_type] :
      ( v87036(VarCurr)
    <=> ( v86989(VarCurr)
        | v86958(VarCurr,27) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8055,axiom,
    ! [VarCurr: state_type] :
      ( v87033(VarCurr)
    <=> ( v87034(VarCurr)
        | v87035(VarCurr) ) ) ).

tff(writeUnaryOperator_3965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87035(VarCurr)
    <=> v86958(VarCurr,27) ) ).

tff(writeUnaryOperator_3964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87034(VarCurr)
    <=> v86989(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8054,axiom,
    ! [VarCurr: state_type] :
      ( v87027(VarCurr)
    <=> ( v87028(VarCurr)
        & v87031(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_752,axiom,
    ! [VarCurr: state_type] :
      ( v87031(VarCurr)
    <=> ( v86988(VarCurr)
        | v86958(VarCurr,28) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8053,axiom,
    ! [VarCurr: state_type] :
      ( v87028(VarCurr)
    <=> ( v87029(VarCurr)
        | v87030(VarCurr) ) ) ).

tff(writeUnaryOperator_3963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87030(VarCurr)
    <=> v86958(VarCurr,28) ) ).

tff(writeUnaryOperator_3962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87029(VarCurr)
    <=> v86988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8052,axiom,
    ! [VarCurr: state_type] :
      ( v87022(VarCurr)
    <=> ( v87023(VarCurr)
        & v87026(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_751,axiom,
    ! [VarCurr: state_type] :
      ( v87026(VarCurr)
    <=> ( v86987(VarCurr)
        | v86958(VarCurr,29) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8051,axiom,
    ! [VarCurr: state_type] :
      ( v87023(VarCurr)
    <=> ( v87024(VarCurr)
        | v87025(VarCurr) ) ) ).

tff(writeUnaryOperator_3961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87025(VarCurr)
    <=> v86958(VarCurr,29) ) ).

tff(writeUnaryOperator_3960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87024(VarCurr)
    <=> v86987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8050,axiom,
    ! [VarCurr: state_type] :
      ( v87017(VarCurr)
    <=> ( v87018(VarCurr)
        & v87021(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_750,axiom,
    ! [VarCurr: state_type] :
      ( v87021(VarCurr)
    <=> ( v86986(VarCurr)
        | v86958(VarCurr,30) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8049,axiom,
    ! [VarCurr: state_type] :
      ( v87018(VarCurr)
    <=> ( v87019(VarCurr)
        | v87020(VarCurr) ) ) ).

tff(writeUnaryOperator_3959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87020(VarCurr)
    <=> v86958(VarCurr,30) ) ).

tff(writeUnaryOperator_3958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87019(VarCurr)
    <=> v86986(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8048,axiom,
    ! [VarCurr: state_type] :
      ( v86982(VarCurr)
    <=> ( v86983(VarCurr)
        & v87016(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_749,axiom,
    ! [VarCurr: state_type] :
      ( v87016(VarCurr)
    <=> ( v86985(VarCurr)
        | v86958(VarCurr,31) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8047,axiom,
    ! [VarCurr: state_type] :
      ( v86983(VarCurr)
    <=> ( v86984(VarCurr)
        | v87015(VarCurr) ) ) ).

tff(writeUnaryOperator_3957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v87015(VarCurr)
    <=> v86958(VarCurr,31) ) ).

tff(writeUnaryOperator_3956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86984(VarCurr)
    <=> v86985(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_748,axiom,
    ! [VarCurr: state_type] :
      ( v86985(VarCurr)
    <=> ( v86986(VarCurr)
        & v86958(VarCurr,30) ) ) ).

tff(writeBinaryOperatorShiftedRanges_747,axiom,
    ! [VarCurr: state_type] :
      ( v86986(VarCurr)
    <=> ( v86987(VarCurr)
        & v86958(VarCurr,29) ) ) ).

tff(writeBinaryOperatorShiftedRanges_746,axiom,
    ! [VarCurr: state_type] :
      ( v86987(VarCurr)
    <=> ( v86988(VarCurr)
        & v86958(VarCurr,28) ) ) ).

tff(writeBinaryOperatorShiftedRanges_745,axiom,
    ! [VarCurr: state_type] :
      ( v86988(VarCurr)
    <=> ( v86989(VarCurr)
        & v86958(VarCurr,27) ) ) ).

tff(writeBinaryOperatorShiftedRanges_744,axiom,
    ! [VarCurr: state_type] :
      ( v86989(VarCurr)
    <=> ( v86990(VarCurr)
        & v86958(VarCurr,26) ) ) ).

tff(writeBinaryOperatorShiftedRanges_743,axiom,
    ! [VarCurr: state_type] :
      ( v86990(VarCurr)
    <=> ( v86991(VarCurr)
        & v86958(VarCurr,25) ) ) ).

tff(writeBinaryOperatorShiftedRanges_742,axiom,
    ! [VarCurr: state_type] :
      ( v86991(VarCurr)
    <=> ( v86992(VarCurr)
        & v86958(VarCurr,24) ) ) ).

tff(writeBinaryOperatorShiftedRanges_741,axiom,
    ! [VarCurr: state_type] :
      ( v86992(VarCurr)
    <=> ( v86993(VarCurr)
        & v86958(VarCurr,23) ) ) ).

tff(writeBinaryOperatorShiftedRanges_740,axiom,
    ! [VarCurr: state_type] :
      ( v86993(VarCurr)
    <=> ( v86994(VarCurr)
        & v86958(VarCurr,22) ) ) ).

tff(writeBinaryOperatorShiftedRanges_739,axiom,
    ! [VarCurr: state_type] :
      ( v86994(VarCurr)
    <=> ( v86995(VarCurr)
        & v86958(VarCurr,21) ) ) ).

tff(writeBinaryOperatorShiftedRanges_738,axiom,
    ! [VarCurr: state_type] :
      ( v86995(VarCurr)
    <=> ( v86996(VarCurr)
        & v86958(VarCurr,20) ) ) ).

tff(writeBinaryOperatorShiftedRanges_737,axiom,
    ! [VarCurr: state_type] :
      ( v86996(VarCurr)
    <=> ( v86997(VarCurr)
        & v86958(VarCurr,19) ) ) ).

tff(writeBinaryOperatorShiftedRanges_736,axiom,
    ! [VarCurr: state_type] :
      ( v86997(VarCurr)
    <=> ( v86998(VarCurr)
        & v86958(VarCurr,18) ) ) ).

tff(writeBinaryOperatorShiftedRanges_735,axiom,
    ! [VarCurr: state_type] :
      ( v86998(VarCurr)
    <=> ( v86999(VarCurr)
        & v86958(VarCurr,17) ) ) ).

tff(writeBinaryOperatorShiftedRanges_734,axiom,
    ! [VarCurr: state_type] :
      ( v86999(VarCurr)
    <=> ( v87000(VarCurr)
        & v86958(VarCurr,16) ) ) ).

tff(writeBinaryOperatorShiftedRanges_733,axiom,
    ! [VarCurr: state_type] :
      ( v87000(VarCurr)
    <=> ( v87001(VarCurr)
        & v86958(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_732,axiom,
    ! [VarCurr: state_type] :
      ( v87001(VarCurr)
    <=> ( v87002(VarCurr)
        & v86958(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_731,axiom,
    ! [VarCurr: state_type] :
      ( v87002(VarCurr)
    <=> ( v87003(VarCurr)
        & v86958(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_730,axiom,
    ! [VarCurr: state_type] :
      ( v87003(VarCurr)
    <=> ( v87004(VarCurr)
        & v86958(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_729,axiom,
    ! [VarCurr: state_type] :
      ( v87004(VarCurr)
    <=> ( v87005(VarCurr)
        & v86958(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_728,axiom,
    ! [VarCurr: state_type] :
      ( v87005(VarCurr)
    <=> ( v87006(VarCurr)
        & v86958(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_727,axiom,
    ! [VarCurr: state_type] :
      ( v87006(VarCurr)
    <=> ( v87007(VarCurr)
        & v86958(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_726,axiom,
    ! [VarCurr: state_type] :
      ( v87007(VarCurr)
    <=> ( v87008(VarCurr)
        & v86958(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_725,axiom,
    ! [VarCurr: state_type] :
      ( v87008(VarCurr)
    <=> ( v87009(VarCurr)
        & v86958(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_724,axiom,
    ! [VarCurr: state_type] :
      ( v87009(VarCurr)
    <=> ( v87010(VarCurr)
        & v86958(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_723,axiom,
    ! [VarCurr: state_type] :
      ( v87010(VarCurr)
    <=> ( v87011(VarCurr)
        & v86958(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_722,axiom,
    ! [VarCurr: state_type] :
      ( v87011(VarCurr)
    <=> ( v87012(VarCurr)
        & v86958(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_721,axiom,
    ! [VarCurr: state_type] :
      ( v87012(VarCurr)
    <=> ( v87013(VarCurr)
        & v86958(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_720,axiom,
    ! [VarCurr: state_type] :
      ( v87013(VarCurr)
    <=> ( v87014(VarCurr)
        & v86958(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_719,axiom,
    ! [VarCurr: state_type] :
      ( v87014(VarCurr)
    <=> ( v86958(VarCurr,0)
        & v86958(VarCurr,1) ) ) ).

tff(addAssignment_53149,axiom,
    ! [VarCurr: state_type] :
      ( v86968(VarCurr)
    <=> v86970(VarCurr) ) ).

tff(addAssignment_53148,axiom,
    ! [VarCurr: state_type] :
      ( v86970(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53147,axiom,
    ! [VarCurr: state_type] :
      ( v86964(VarCurr)
    <=> v86966(VarCurr) ) ).

tff(addAssignment_53146,axiom,
    ! [VarCurr: state_type] :
      ( v86966(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53145,axiom,
    ! [VarCurr: state_type] :
      ( v86885(VarCurr)
    <=> v86887(VarCurr) ) ).

tff(addAssignment_53144,axiom,
    ! [VarCurr: state_type] :
      ( v86887(VarCurr)
    <=> v86889(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86933(VarNext)
       => ( v86889(VarNext)
        <=> v86889(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_978,axiom,
    ! [VarNext: state_type] :
      ( v86933(VarNext)
     => ( v86889(VarNext)
      <=> v86943(VarNext) ) ) ).

tff(addAssignment_53143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86943(VarNext)
      <=> v86941(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86944(VarCurr)
     => ( v86941(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_502,axiom,
    ! [VarCurr: state_type] :
      ( v86944(VarCurr)
     => ( v86941(VarCurr)
      <=> v86899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8046,axiom,
    ! [VarCurr: state_type] :
      ( v86944(VarCurr)
    <=> ( v86945(VarCurr)
        & v86946(VarCurr) ) ) ).

tff(writeUnaryOperator_3955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86946(VarCurr)
    <=> v86895(VarCurr) ) ).

tff(writeUnaryOperator_3954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86945(VarCurr)
    <=> v86891(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86933(VarNext)
      <=> v86934(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86934(VarNext)
      <=> ( v86935(VarNext)
          & v86928(VarNext) ) ) ) ).

tff(writeUnaryOperator_3953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86935(VarNext)
      <=> v86937(VarNext) ) ) ).

tff(addAssignment_53142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86937(VarNext)
      <=> v86928(VarCurr) ) ) ).

tff(addAssignment_53141,axiom,
    ! [VarCurr: state_type] :
      ( v86928(VarCurr)
    <=> v86930(VarCurr) ) ).

tff(addAssignment_53140,axiom,
    ! [VarCurr: state_type] :
      ( v86930(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53139,axiom,
    ! [VarCurr: state_type] :
      ( v86899(VarCurr)
    <=> v86901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8043,axiom,
    ! [VarCurr: state_type] :
      ( v86901(VarCurr)
    <=> ( v86912(VarCurr)
        | v86919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8042,axiom,
    ! [VarCurr: state_type] :
      ( v86919(VarCurr)
    <=> ( v86920(VarCurr)
        & v86924(VarCurr) ) ) ).

tff(writeUnaryOperator_3952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86924(VarCurr)
    <=> v86925(VarCurr) ) ).

tff(addAssignment_53138,axiom,
    ! [VarCurr: state_type] :
      ( v86925(VarCurr)
    <=> v86926(VarCurr) ) ).

tff(addAssignment_53137,axiom,
    ! [VarCurr: state_type] :
      ( v86926(VarCurr)
    <=> v86907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8041,axiom,
    ! [VarCurr: state_type] :
      ( v86920(VarCurr)
    <=> ( v86887(VarCurr)
        & v86921(VarCurr) ) ) ).

tff(writeUnaryOperator_3951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86921(VarCurr)
    <=> v86922(VarCurr) ) ).

tff(addAssignment_53136,axiom,
    ! [VarCurr: state_type] :
      ( v86922(VarCurr)
    <=> v86923(VarCurr) ) ).

tff(addAssignment_53135,axiom,
    ! [VarCurr: state_type] :
      ( v86923(VarCurr)
    <=> v86905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8040,axiom,
    ! [VarCurr: state_type] :
      ( v86912(VarCurr)
    <=> ( v86913(VarCurr)
        & v86916(VarCurr) ) ) ).

tff(writeUnaryOperator_3950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86916(VarCurr)
    <=> v86917(VarCurr) ) ).

tff(addAssignment_53134,axiom,
    ! [VarCurr: state_type] :
      ( v86917(VarCurr)
    <=> v86918(VarCurr) ) ).

tff(addAssignment_53133,axiom,
    ! [VarCurr: state_type] :
      ( v86918(VarCurr)
    <=> v86907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8039,axiom,
    ! [VarCurr: state_type] :
      ( v86913(VarCurr)
    <=> ( v86903(VarCurr)
        & v86914(VarCurr) ) ) ).

tff(addAssignment_53132,axiom,
    ! [VarCurr: state_type] :
      ( v86914(VarCurr)
    <=> v86915(VarCurr) ) ).

tff(addAssignment_53131,axiom,
    ! [VarCurr: state_type] :
      ( v86915(VarCurr)
    <=> v86905(VarCurr) ) ).

tff(addAssignment_53130,axiom,
    ! [VarCurr: state_type] :
      ( v86907(VarCurr)
    <=> v86909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8038,axiom,
    ! [VarCurr: state_type] :
      ( v86909(VarCurr)
    <=> ( v86885(VarCurr)
        & v86877(VarCurr) ) ) ).

tff(addAssignment_53129,axiom,
    ! [VarCurr: state_type] :
      ( v86905(VarCurr)
    <=> v86713(VarCurr) ) ).

tff(addAssignment_53128,axiom,
    ! [VarCurr: state_type] :
      ( v86903(VarCurr)
    <=> v86715(VarCurr) ) ).

tff(addAssignment_53127,axiom,
    ! [VarCurr: state_type] :
      ( v86895(VarCurr)
    <=> v86897(VarCurr) ) ).

tff(addAssignment_53126,axiom,
    ! [VarCurr: state_type] :
      ( v86897(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53125,axiom,
    ! [VarCurr: state_type] :
      ( v86891(VarCurr)
    <=> v86893(VarCurr) ) ).

tff(addAssignment_53124,axiom,
    ! [VarCurr: state_type] :
      ( v86893(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53123,axiom,
    ! [VarCurr: state_type] :
      ( v86807(VarCurr)
    <=> v86809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8037,axiom,
    ! [VarCurr: state_type] :
      ( v86809(VarCurr)
    <=> ( v86870(VarCurr)
        & v86871(VarCurr) ) ) ).

tff(writeUnaryOperator_3949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86871(VarCurr)
    <=> v84321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8036,axiom,
    ! [VarCurr: state_type] :
      ( v86870(VarCurr)
    <=> ( v86811(VarCurr)
        & v84583(VarCurr) ) ) ).

tff(addAssignment_53122,axiom,
    ! [VarCurr: state_type] :
      ( v86811(VarCurr)
    <=> v86813(VarCurr) ) ).

tff(addAssignment_53121,axiom,
    ! [VarCurr: state_type] :
      ( v86813(VarCurr)
    <=> v86815(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86853(VarNext)
       => ( v86815(VarNext)
        <=> v86815(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_977,axiom,
    ! [VarNext: state_type] :
      ( v86853(VarNext)
     => ( v86815(VarNext)
      <=> v86863(VarNext) ) ) ).

tff(addAssignment_53120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86863(VarNext)
      <=> v86861(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86864(VarCurr)
     => ( v86861(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_501,axiom,
    ! [VarCurr: state_type] :
      ( v86864(VarCurr)
     => ( v86861(VarCurr)
      <=> v86825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8035,axiom,
    ! [VarCurr: state_type] :
      ( v86864(VarCurr)
    <=> ( v86865(VarCurr)
        & v86866(VarCurr) ) ) ).

tff(writeUnaryOperator_3948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86866(VarCurr)
    <=> v86821(VarCurr) ) ).

tff(writeUnaryOperator_3947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86865(VarCurr)
    <=> v86817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86853(VarNext)
      <=> v86854(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86854(VarNext)
      <=> ( v86855(VarNext)
          & v86848(VarNext) ) ) ) ).

tff(writeUnaryOperator_3946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86855(VarNext)
      <=> v86857(VarNext) ) ) ).

tff(addAssignment_53119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86857(VarNext)
      <=> v86848(VarCurr) ) ) ).

tff(addAssignment_53118,axiom,
    ! [VarCurr: state_type] :
      ( v86848(VarCurr)
    <=> v86850(VarCurr) ) ).

tff(addAssignment_53117,axiom,
    ! [VarCurr: state_type] :
      ( v86850(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_53116,axiom,
    ! [VarCurr: state_type] :
      ( v86825(VarCurr)
    <=> v86827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8032,axiom,
    ! [VarCurr: state_type] :
      ( v86827(VarCurr)
    <=> ( v86840(VarCurr)
        | v86843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8031,axiom,
    ! [VarCurr: state_type] :
      ( v86843(VarCurr)
    <=> ( v86813(VarCurr)
        & v86844(VarCurr) ) ) ).

tff(writeUnaryOperator_3945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86844(VarCurr)
    <=> v86845(VarCurr) ) ).

tff(addAssignment_53115,axiom,
    ! [VarCurr: state_type] :
      ( v86845(VarCurr)
    <=> v86846(VarCurr) ) ).

tff(addAssignment_53114,axiom,
    ! [VarCurr: state_type] :
      ( v86846(VarCurr)
    <=> v86833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8030,axiom,
    ! [VarCurr: state_type] :
      ( v86840(VarCurr)
    <=> ( v86829(VarCurr)
        & v86841(VarCurr) ) ) ).

tff(addAssignment_53113,axiom,
    ! [VarCurr: state_type] :
      ( v86841(VarCurr)
    <=> v86842(VarCurr) ) ).

tff(addAssignment_53112,axiom,
    ! [VarCurr: state_type] :
      ( v86842(VarCurr)
    <=> v86833(VarCurr) ) ).

tff(addAssignment_53111,axiom,
    ! [VarCurr: state_type] :
      ( v86833(VarCurr)
    <=> v86835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8029,axiom,
    ! [VarCurr: state_type] :
      ( v86835(VarCurr)
    <=> ( v1729(VarCurr)
        & v86838(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_388,axiom,
    ! [VarCurr: state_type] :
      ( v86838(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1114,axiom,
    ~ b0000001000000(12) ).

tff(bitBlastConstant_1113,axiom,
    ~ b0000001000000(11) ).

tff(bitBlastConstant_1112,axiom,
    ~ b0000001000000(10) ).

tff(bitBlastConstant_1111,axiom,
    ~ b0000001000000(9) ).

tff(bitBlastConstant_1110,axiom,
    ~ b0000001000000(8) ).

tff(bitBlastConstant_1109,axiom,
    ~ b0000001000000(7) ).

tff(bitBlastConstant_1108,axiom,
    b0000001000000(6) ).

tff(bitBlastConstant_1107,axiom,
    ~ b0000001000000(5) ).

tff(bitBlastConstant_1106,axiom,
    ~ b0000001000000(4) ).

tff(bitBlastConstant_1105,axiom,
    ~ b0000001000000(3) ).

tff(bitBlastConstant_1104,axiom,
    ~ b0000001000000(2) ).

tff(bitBlastConstant_1103,axiom,
    ~ b0000001000000(1) ).

tff(bitBlastConstant_1102,axiom,
    ~ b0000001000000(0) ).

tff(addAssignment_53110,axiom,
    ! [VarCurr: state_type] :
      ( v86829(VarCurr)
    <=> v86831(VarCurr) ) ).

tff(addAssignment_53109,axiom,
    ! [VarCurr: state_type] :
      ( v86831(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_53108,axiom,
    ! [VarCurr: state_type] :
      ( v86821(VarCurr)
    <=> v86823(VarCurr) ) ).

tff(addAssignment_53107,axiom,
    ! [VarCurr: state_type] :
      ( v86823(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53106,axiom,
    ! [VarCurr: state_type] :
      ( v86817(VarCurr)
    <=> v86819(VarCurr) ) ).

tff(addAssignment_53105,axiom,
    ! [VarCurr: state_type] :
      ( v86819(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_53104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v86735(VarCurr,B)
      <=> v86737(VarCurr,B) ) ) ).

tff(addAssignment_53103,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,0)
    <=> v86803(VarCurr) ) ).

tff(addAssignment_53102,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,1)
    <=> v86801(VarCurr) ) ).

tff(addAssignment_53101,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,2)
    <=> v86796(VarCurr) ) ).

tff(addAssignment_53100,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,3)
    <=> v86791(VarCurr) ) ).

tff(addAssignment_53099,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,4)
    <=> v86786(VarCurr) ) ).

tff(addAssignment_53098,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,5)
    <=> v86781(VarCurr) ) ).

tff(addAssignment_53097,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,6)
    <=> v86776(VarCurr) ) ).

tff(addAssignment_53096,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,7)
    <=> v86771(VarCurr) ) ).

tff(addAssignment_53095,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,8)
    <=> v86766(VarCurr) ) ).

tff(addAssignment_53094,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,9)
    <=> v86761(VarCurr) ) ).

tff(addAssignment_53093,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,10)
    <=> v86756(VarCurr) ) ).

tff(addAssignment_53092,axiom,
    ! [VarCurr: state_type] :
      ( v86737(VarCurr,11)
    <=> v86741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8028,axiom,
    ! [VarCurr: state_type] :
      ( v86801(VarCurr)
    <=> ( v86802(VarCurr)
        & v86805(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_718,axiom,
    ! [VarCurr: state_type] :
      ( v86805(VarCurr)
    <=> ( v86717(VarCurr,0)
        | v86717(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8027,axiom,
    ! [VarCurr: state_type] :
      ( v86802(VarCurr)
    <=> ( v86803(VarCurr)
        | v86804(VarCurr) ) ) ).

tff(writeUnaryOperator_3944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86804(VarCurr)
    <=> v86717(VarCurr,1) ) ).

tff(writeUnaryOperator_3943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86803(VarCurr)
    <=> v86717(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8026,axiom,
    ! [VarCurr: state_type] :
      ( v86796(VarCurr)
    <=> ( v86797(VarCurr)
        & v86800(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_717,axiom,
    ! [VarCurr: state_type] :
      ( v86800(VarCurr)
    <=> ( v86753(VarCurr)
        | v86717(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8025,axiom,
    ! [VarCurr: state_type] :
      ( v86797(VarCurr)
    <=> ( v86798(VarCurr)
        | v86799(VarCurr) ) ) ).

tff(writeUnaryOperator_3942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86799(VarCurr)
    <=> v86717(VarCurr,2) ) ).

tff(writeUnaryOperator_3941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86798(VarCurr)
    <=> v86753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8024,axiom,
    ! [VarCurr: state_type] :
      ( v86791(VarCurr)
    <=> ( v86792(VarCurr)
        & v86795(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_716,axiom,
    ! [VarCurr: state_type] :
      ( v86795(VarCurr)
    <=> ( v86752(VarCurr)
        | v86717(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8023,axiom,
    ! [VarCurr: state_type] :
      ( v86792(VarCurr)
    <=> ( v86793(VarCurr)
        | v86794(VarCurr) ) ) ).

tff(writeUnaryOperator_3940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86794(VarCurr)
    <=> v86717(VarCurr,3) ) ).

tff(writeUnaryOperator_3939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86793(VarCurr)
    <=> v86752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8022,axiom,
    ! [VarCurr: state_type] :
      ( v86786(VarCurr)
    <=> ( v86787(VarCurr)
        & v86790(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_715,axiom,
    ! [VarCurr: state_type] :
      ( v86790(VarCurr)
    <=> ( v86751(VarCurr)
        | v86717(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8021,axiom,
    ! [VarCurr: state_type] :
      ( v86787(VarCurr)
    <=> ( v86788(VarCurr)
        | v86789(VarCurr) ) ) ).

tff(writeUnaryOperator_3938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86789(VarCurr)
    <=> v86717(VarCurr,4) ) ).

tff(writeUnaryOperator_3937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86788(VarCurr)
    <=> v86751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8020,axiom,
    ! [VarCurr: state_type] :
      ( v86781(VarCurr)
    <=> ( v86782(VarCurr)
        & v86785(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_714,axiom,
    ! [VarCurr: state_type] :
      ( v86785(VarCurr)
    <=> ( v86750(VarCurr)
        | v86717(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8019,axiom,
    ! [VarCurr: state_type] :
      ( v86782(VarCurr)
    <=> ( v86783(VarCurr)
        | v86784(VarCurr) ) ) ).

tff(writeUnaryOperator_3936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86784(VarCurr)
    <=> v86717(VarCurr,5) ) ).

tff(writeUnaryOperator_3935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86783(VarCurr)
    <=> v86750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8018,axiom,
    ! [VarCurr: state_type] :
      ( v86776(VarCurr)
    <=> ( v86777(VarCurr)
        & v86780(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_713,axiom,
    ! [VarCurr: state_type] :
      ( v86780(VarCurr)
    <=> ( v86749(VarCurr)
        | v86717(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8017,axiom,
    ! [VarCurr: state_type] :
      ( v86777(VarCurr)
    <=> ( v86778(VarCurr)
        | v86779(VarCurr) ) ) ).

tff(writeUnaryOperator_3934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86779(VarCurr)
    <=> v86717(VarCurr,6) ) ).

tff(writeUnaryOperator_3933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86778(VarCurr)
    <=> v86749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8016,axiom,
    ! [VarCurr: state_type] :
      ( v86771(VarCurr)
    <=> ( v86772(VarCurr)
        & v86775(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_712,axiom,
    ! [VarCurr: state_type] :
      ( v86775(VarCurr)
    <=> ( v86748(VarCurr)
        | v86717(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8015,axiom,
    ! [VarCurr: state_type] :
      ( v86772(VarCurr)
    <=> ( v86773(VarCurr)
        | v86774(VarCurr) ) ) ).

tff(writeUnaryOperator_3932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86774(VarCurr)
    <=> v86717(VarCurr,7) ) ).

tff(writeUnaryOperator_3931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86773(VarCurr)
    <=> v86748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8014,axiom,
    ! [VarCurr: state_type] :
      ( v86766(VarCurr)
    <=> ( v86767(VarCurr)
        & v86770(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_711,axiom,
    ! [VarCurr: state_type] :
      ( v86770(VarCurr)
    <=> ( v86747(VarCurr)
        | v86717(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8013,axiom,
    ! [VarCurr: state_type] :
      ( v86767(VarCurr)
    <=> ( v86768(VarCurr)
        | v86769(VarCurr) ) ) ).

tff(writeUnaryOperator_3930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86769(VarCurr)
    <=> v86717(VarCurr,8) ) ).

tff(writeUnaryOperator_3929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86768(VarCurr)
    <=> v86747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8012,axiom,
    ! [VarCurr: state_type] :
      ( v86761(VarCurr)
    <=> ( v86762(VarCurr)
        & v86765(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_710,axiom,
    ! [VarCurr: state_type] :
      ( v86765(VarCurr)
    <=> ( v86746(VarCurr)
        | v86717(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8011,axiom,
    ! [VarCurr: state_type] :
      ( v86762(VarCurr)
    <=> ( v86763(VarCurr)
        | v86764(VarCurr) ) ) ).

tff(writeUnaryOperator_3928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86764(VarCurr)
    <=> v86717(VarCurr,9) ) ).

tff(writeUnaryOperator_3927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86763(VarCurr)
    <=> v86746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8010,axiom,
    ! [VarCurr: state_type] :
      ( v86756(VarCurr)
    <=> ( v86757(VarCurr)
        & v86760(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_709,axiom,
    ! [VarCurr: state_type] :
      ( v86760(VarCurr)
    <=> ( v86745(VarCurr)
        | v86717(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8009,axiom,
    ! [VarCurr: state_type] :
      ( v86757(VarCurr)
    <=> ( v86758(VarCurr)
        | v86759(VarCurr) ) ) ).

tff(writeUnaryOperator_3926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86759(VarCurr)
    <=> v86717(VarCurr,10) ) ).

tff(writeUnaryOperator_3925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86758(VarCurr)
    <=> v86745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8008,axiom,
    ! [VarCurr: state_type] :
      ( v86741(VarCurr)
    <=> ( v86742(VarCurr)
        & v86755(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_708,axiom,
    ! [VarCurr: state_type] :
      ( v86755(VarCurr)
    <=> ( v86744(VarCurr)
        | v86717(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8007,axiom,
    ! [VarCurr: state_type] :
      ( v86742(VarCurr)
    <=> ( v86743(VarCurr)
        | v86754(VarCurr) ) ) ).

tff(writeUnaryOperator_3924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86754(VarCurr)
    <=> v86717(VarCurr,11) ) ).

tff(writeUnaryOperator_3923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86743(VarCurr)
    <=> v86744(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_707,axiom,
    ! [VarCurr: state_type] :
      ( v86744(VarCurr)
    <=> ( v86745(VarCurr)
        & v86717(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_706,axiom,
    ! [VarCurr: state_type] :
      ( v86745(VarCurr)
    <=> ( v86746(VarCurr)
        & v86717(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_705,axiom,
    ! [VarCurr: state_type] :
      ( v86746(VarCurr)
    <=> ( v86747(VarCurr)
        & v86717(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_704,axiom,
    ! [VarCurr: state_type] :
      ( v86747(VarCurr)
    <=> ( v86748(VarCurr)
        & v86717(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_703,axiom,
    ! [VarCurr: state_type] :
      ( v86748(VarCurr)
    <=> ( v86749(VarCurr)
        & v86717(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_702,axiom,
    ! [VarCurr: state_type] :
      ( v86749(VarCurr)
    <=> ( v86750(VarCurr)
        & v86717(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_701,axiom,
    ! [VarCurr: state_type] :
      ( v86750(VarCurr)
    <=> ( v86751(VarCurr)
        & v86717(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_700,axiom,
    ! [VarCurr: state_type] :
      ( v86751(VarCurr)
    <=> ( v86752(VarCurr)
        & v86717(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_699,axiom,
    ! [VarCurr: state_type] :
      ( v86752(VarCurr)
    <=> ( v86753(VarCurr)
        & v86717(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_698,axiom,
    ! [VarCurr: state_type] :
      ( v86753(VarCurr)
    <=> ( v86717(VarCurr,0)
        & v86717(VarCurr,1) ) ) ).

tff(addAssignment_53091,axiom,
    ! [VarCurr: state_type] :
      ( v86727(VarCurr)
    <=> v86729(VarCurr) ) ).

tff(addAssignment_53090,axiom,
    ! [VarCurr: state_type] :
      ( v86729(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_53089,axiom,
    ! [VarCurr: state_type] :
      ( v86723(VarCurr)
    <=> v86725(VarCurr) ) ).

tff(addAssignment_53088,axiom,
    ! [VarCurr: state_type] :
      ( v86725(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_53087,axiom,
    ! [VarCurr: state_type] :
      ( v85790(VarCurr)
    <=> v85792(VarCurr) ) ).

tff(addAssignment_53086,axiom,
    ! [VarCurr: state_type] :
      ( v85792(VarCurr)
    <=> v85794(VarCurr) ) ).

tff(addAssignment_53085,axiom,
    ! [VarCurr: state_type] :
      ( v85794(VarCurr)
    <=> v174(VarCurr,5) ) ).

tff(addAssignment_53084,axiom,
    ! [VarCurr: state_type] :
      ( v174(VarCurr,5)
    <=> v176(VarCurr,5) ) ).

tff(addAssignment_53083,axiom,
    ! [VarNext: state_type] :
      ( v176(VarNext,5)
    <=> v86703(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86704(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v86703(VarNext,B)
            <=> v176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_976,axiom,
    ! [VarNext: state_type] :
      ( v86704(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86703(VarNext,B)
          <=> v734(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86704(VarNext)
      <=> v86705(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86705(VarNext)
      <=> ( v86707(VarNext)
          & v210(VarNext) ) ) ) ).

tff(writeUnaryOperator_3922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86707(VarNext)
      <=> v728(VarNext) ) ) ).

tff(addAssignment_53082,axiom,
    ! [VarCurr: state_type] :
      ( v186(VarCurr,5)
    <=> v188(VarCurr,5) ) ).

tff(addAssignment_53081,axiom,
    ! [VarCurr: state_type] :
      ( v188(VarCurr,5)
    <=> v190(VarCurr,5) ) ).

tff(addAssignment_53080,axiom,
    ! [VarCurr: state_type] :
      ( v190(VarCurr,5)
    <=> v205(VarCurr,5) ) ).

tff(addAssignment_53079,axiom,
    ! [VarCurr: state_type] :
      ( v206(VarCurr)
    <=> v85797(VarCurr) ) ).

tff(addAssignment_53078,axiom,
    ! [VarCurr: state_type] :
      ( v85797(VarCurr)
    <=> v85799(VarCurr) ) ).

tff(addAssignment_53077,axiom,
    ! [VarCurr: state_type] :
      ( v85799(VarCurr)
    <=> v85801(VarCurr) ) ).

tff(addAssignment_53076,axiom,
    ! [VarCurr: state_type] :
      ( v85801(VarCurr)
    <=> v85803(VarCurr) ) ).

tff(addAssignment_53075,axiom,
    ! [VarCurr: state_type] :
      ( v85803(VarCurr)
    <=> v202(VarCurr,1) ) ).

tff(addAssignment_53074,axiom,
    ! [VarCurr: state_type] :
      ( v202(VarCurr,1)
    <=> v204(VarCurr,1) ) ).

tff(addAssignment_53073,axiom,
    ! [VarNext: state_type] :
      ( v204(VarNext,1)
    <=> v86685(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86686(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v86685(VarNext,B)
            <=> v204(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_975,axiom,
    ! [VarNext: state_type] :
      ( v86686(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v86685(VarNext,B)
          <=> v86696(VarNext,B) ) ) ) ).

tff(addAssignment_53072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v86696(VarNext,B)
          <=> v86694(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v86694(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_500,axiom,
    ! [VarCurr: state_type] :
      ( v86697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v86694(VarCurr,B)
          <=> v85821(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8004,axiom,
    ! [VarCurr: state_type] :
      ( v86697(VarCurr)
    <=> ( v86698(VarCurr)
        & v86699(VarCurr) ) ) ).

tff(writeUnaryOperator_3921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86699(VarCurr)
    <=> v85813(VarCurr) ) ).

tff(writeUnaryOperator_3920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86698(VarCurr)
    <=> v85805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86686(VarNext)
      <=> v86687(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86687(VarNext)
      <=> ( v86688(VarNext)
          & v86681(VarNext) ) ) ) ).

tff(writeUnaryOperator_3919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86688(VarNext)
      <=> v86690(VarNext) ) ) ).

tff(addAssignment_53071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86690(VarNext)
      <=> v86681(VarCurr) ) ) ).

tff(addAssignment_53070,axiom,
    ! [VarCurr: state_type] :
      ( v86681(VarCurr)
    <=> v86683(VarCurr) ) ).

tff(addAssignment_53069,axiom,
    ! [VarCurr: state_type] :
      ( v86683(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_53068,axiom,
    ! [VarCurr: state_type] :
      ( v85821(VarCurr,1)
    <=> v85823(VarCurr,1) ) ).

tff(addAssignment_53067,axiom,
    ! [VarCurr: state_type] :
      ( v85823(VarCurr,1)
    <=> v86672(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86672(VarCurr,B)
      <=> ( v86673(VarCurr,B)
          | v86676(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86676(VarCurr,B)
      <=> ( v202(VarCurr,B)
          & v86677(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86677(VarCurr,B)
      <=> ~ v86678(VarCurr,B) ) ) ).

tff(addAssignment_53066,axiom,
    ! [VarCurr: state_type] :
      ( v86678(VarCurr,0)
    <=> v86679(VarCurr) ) ).

tff(addAssignment_53065,axiom,
    ! [VarCurr: state_type] :
      ( v86678(VarCurr,1)
    <=> v86679(VarCurr) ) ).

tff(addAssignment_53064,axiom,
    ! [VarCurr: state_type] :
      ( v86679(VarCurr)
    <=> v86671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v86673(VarCurr,B)
      <=> ( v85825(VarCurr,B)
          & v86674(VarCurr,B) ) ) ) ).

tff(addAssignment_53063,axiom,
    ! [VarCurr: state_type] :
      ( v86674(VarCurr,0)
    <=> v86675(VarCurr) ) ).

tff(addAssignment_53062,axiom,
    ! [VarCurr: state_type] :
      ( v86674(VarCurr,1)
    <=> v86675(VarCurr) ) ).

tff(addAssignment_53061,axiom,
    ! [VarCurr: state_type] :
      ( v86675(VarCurr)
    <=> v86671(VarCurr) ) ).

tff(addAssignment_53060,axiom,
    ! [VarCurr: state_type] :
      ( v86671(VarCurr)
    <=> v86612(VarCurr) ) ).

tff(addAssignment_53059,axiom,
    ! [VarCurr: state_type] :
      ( v85825(VarCurr,1)
    <=> v86668(VarCurr,1) ) ).

tff(addAssignment_53058,axiom,
    ! [VarCurr: state_type] :
      ( v86668(VarCurr,0)
    <=> v86669(VarCurr) ) ).

tff(addAssignment_53057,axiom,
    ! [VarCurr: state_type] :
      ( v86668(VarCurr,1)
    <=> v85827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8001,axiom,
    ! [VarCurr: state_type] :
      ( v85827(VarCurr)
    <=> ( v86659(VarCurr)
        & v86612(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8000,axiom,
    ! [VarCurr: state_type] :
      ( v86659(VarCurr)
    <=> ( v86660(VarCurr)
        & v85898(VarCurr) ) ) ).

tff(writeUnaryOperator_3917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86660(VarCurr)
    <=> v86661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7999,axiom,
    ! [VarCurr: state_type] :
      ( v86661(VarCurr)
    <=> ( v86662(VarCurr)
        & v86407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7998,axiom,
    ! [VarCurr: state_type] :
      ( v86662(VarCurr)
    <=> ( v86663(VarCurr)
        & v86343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7997,axiom,
    ! [VarCurr: state_type] :
      ( v86663(VarCurr)
    <=> ( v86664(VarCurr)
        & v86279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7996,axiom,
    ! [VarCurr: state_type] :
      ( v86664(VarCurr)
    <=> ( v86665(VarCurr)
        & v86215(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7995,axiom,
    ! [VarCurr: state_type] :
      ( v86665(VarCurr)
    <=> ( v86666(VarCurr)
        & v86151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7994,axiom,
    ! [VarCurr: state_type] :
      ( v86666(VarCurr)
    <=> ( v86667(VarCurr)
        & v86087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7993,axiom,
    ! [VarCurr: state_type] :
      ( v86667(VarCurr)
    <=> ( v85829(VarCurr)
        & v86023(VarCurr) ) ) ).

tff(addAssignment_53056,axiom,
    ! [VarCurr: state_type] :
      ( v86612(VarCurr)
    <=> v86614(VarCurr,1) ) ).

tff(addAssignment_53055,axiom,
    ! [VarCurr: state_type] :
      ( v86614(VarCurr,1)
    <=> v86616(VarCurr,1) ) ).

tff(addAssignment_53054,axiom,
    ! [VarNext: state_type] :
      ( v86616(VarNext,1)
    <=> v86641(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86642(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v86641(VarNext,B)
            <=> v86616(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_974,axiom,
    ! [VarNext: state_type] :
      ( v86642(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86641(VarNext,B)
          <=> v86652(VarNext,B) ) ) ) ).

tff(addAssignment_53053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86652(VarNext,B)
          <=> v86650(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86653(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86650(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_499,axiom,
    ! [VarCurr: state_type] :
      ( v86653(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86650(VarCurr,B)
          <=> v86626(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7992,axiom,
    ! [VarCurr: state_type] :
      ( v86653(VarCurr)
    <=> ( v86654(VarCurr)
        & v86655(VarCurr) ) ) ).

tff(writeUnaryOperator_3916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86655(VarCurr)
    <=> v86622(VarCurr) ) ).

tff(writeUnaryOperator_3915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86654(VarCurr)
    <=> v86618(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86642(VarNext)
      <=> v86643(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86643(VarNext)
      <=> ( v86644(VarNext)
          & v86637(VarNext) ) ) ) ).

tff(writeUnaryOperator_3914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86644(VarNext)
      <=> v86646(VarNext) ) ) ).

tff(addAssignment_53052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86646(VarNext)
      <=> v86637(VarCurr) ) ) ).

tff(addAssignment_53051,axiom,
    ! [VarCurr: state_type] :
      ( v86637(VarCurr)
    <=> v86639(VarCurr) ) ).

tff(addAssignment_53050,axiom,
    ! [VarCurr: state_type] :
      ( v86639(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_53049,axiom,
    ! [VarCurr: state_type] :
      ( v86626(VarCurr,1)
    <=> v86628(VarCurr,1) ) ).

tff(addAssignment_53048,axiom,
    ! [VarCurr: state_type] :
      ( v86628(VarCurr,1)
    <=> v86630(VarCurr,1) ) ).

tff(addAssignment_53047,axiom,
    ! [VarCurr: state_type] :
      ( v86630(VarCurr,1)
    <=> v86633(VarCurr,1) ) ).

tff(addAssignment_53046,axiom,
    ! [VarCurr: state_type] :
      ( v86633(VarCurr,0)
    <=> v86635(VarCurr) ) ).

tff(addAssignment_53045,axiom,
    ! [VarCurr: state_type] :
      ( v86633(VarCurr,1)
    <=> v86632(VarCurr) ) ).

tff(addAssignment_53044,axiom,
    ! [VarCurr: state_type] :
      ( v86633(VarCurr,2)
    <=> v86634(VarCurr) ) ).

tff(addAssignment_53043,axiom,
    ! [VarCurr: state_type] :
      ( v86632(VarCurr)
    <=> v1631(VarCurr) ) ).

tff(addAssignment_53042,axiom,
    ! [VarCurr: state_type] :
      ( v86622(VarCurr)
    <=> v86624(VarCurr) ) ).

tff(addAssignment_53041,axiom,
    ! [VarCurr: state_type] :
      ( v86624(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_53040,axiom,
    ! [VarCurr: state_type] :
      ( v86618(VarCurr)
    <=> v86620(VarCurr) ) ).

tff(addAssignment_53039,axiom,
    ! [VarCurr: state_type] :
      ( v86620(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_53038,axiom,
    ! [VarCurr: state_type] :
      ( v85829(VarCurr)
    <=> v85831(VarCurr) ) ).

tff(addAssignment_53037,axiom,
    ! [VarCurr: state_type] :
      ( v85831(VarCurr)
    <=> v85833(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86595(VarNext)
       => ( v85833(VarNext)
        <=> v85833(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_973,axiom,
    ! [VarNext: state_type] :
      ( v86595(VarNext)
     => ( v85833(VarNext)
      <=> v86605(VarNext) ) ) ).

tff(addAssignment_53036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86605(VarNext)
      <=> v86603(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86606(VarCurr)
     => ( v86603(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_498,axiom,
    ! [VarCurr: state_type] :
      ( v86606(VarCurr)
     => ( v86603(VarCurr)
      <=> v85843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7989,axiom,
    ! [VarCurr: state_type] :
      ( v86606(VarCurr)
    <=> ( v86607(VarCurr)
        & v86608(VarCurr) ) ) ).

tff(writeUnaryOperator_3913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86608(VarCurr)
    <=> v85839(VarCurr) ) ).

tff(writeUnaryOperator_3912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86607(VarCurr)
    <=> v85835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86595(VarNext)
      <=> v86596(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86596(VarNext)
      <=> ( v86597(VarNext)
          & v86590(VarNext) ) ) ) ).

tff(writeUnaryOperator_3911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86597(VarNext)
      <=> v86599(VarNext) ) ) ).

tff(addAssignment_53035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86599(VarNext)
      <=> v86590(VarCurr) ) ) ).

tff(addAssignment_53034,axiom,
    ! [VarCurr: state_type] :
      ( v86590(VarCurr)
    <=> v86592(VarCurr) ) ).

tff(addAssignment_53033,axiom,
    ! [VarCurr: state_type] :
      ( v86592(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_53032,axiom,
    ! [VarCurr: state_type] :
      ( v85843(VarCurr)
    <=> v85845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7986,axiom,
    ! [VarCurr: state_type] :
      ( v85845(VarCurr)
    <=> ( v86582(VarCurr)
        | v86585(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7985,axiom,
    ! [VarCurr: state_type] :
      ( v86585(VarCurr)
    <=> ( v85831(VarCurr)
        & v86586(VarCurr) ) ) ).

tff(writeUnaryOperator_3910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86586(VarCurr)
    <=> v86587(VarCurr) ) ).

tff(addAssignment_53031,axiom,
    ! [VarCurr: state_type] :
      ( v86587(VarCurr)
    <=> v86588(VarCurr) ) ).

tff(addAssignment_53030,axiom,
    ! [VarCurr: state_type] :
      ( v86588(VarCurr)
    <=> v85858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7984,axiom,
    ! [VarCurr: state_type] :
      ( v86582(VarCurr)
    <=> ( v85847(VarCurr)
        & v86583(VarCurr) ) ) ).

tff(addAssignment_53029,axiom,
    ! [VarCurr: state_type] :
      ( v86583(VarCurr)
    <=> v86584(VarCurr) ) ).

tff(addAssignment_53028,axiom,
    ! [VarCurr: state_type] :
      ( v86584(VarCurr)
    <=> v85858(VarCurr) ) ).

tff(addAssignment_53027,axiom,
    ! [VarCurr: state_type] :
      ( v85858(VarCurr)
    <=> v85860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7983,axiom,
    ! [VarCurr: state_type] :
      ( v85860(VarCurr)
    <=> ( v85851(VarCurr,0)
        | v86575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7982,axiom,
    ! [VarCurr: state_type] :
      ( v86575(VarCurr)
    <=> ( v86576(VarCurr)
        & v86580(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_387,axiom,
    ! [VarCurr: state_type] :
      ( v86580(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $false )
        & ( v85876(VarCurr,4)
        <=> $false )
        & ( v85876(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7981,axiom,
    ! [VarCurr: state_type] :
      ( v86576(VarCurr)
    <=> ( v86577(VarCurr)
        & v86579(VarCurr) ) ) ).

tff(writeUnaryOperator_3909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86579(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7980,axiom,
    ! [VarCurr: state_type] :
      ( v86577(VarCurr)
    <=> ( v86578(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86578(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_53026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85876(VarCurr,B)
      <=> v85878(VarCurr,B) ) ) ).

tff(addAssignment_53025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85878(VarCurr,B)
      <=> v85880(VarCurr,B) ) ) ).

tff(addAssignment_53024,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85880(VarNext,B)
      <=> v86557(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v86557(VarNext,B)
            <=> v85880(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_972,axiom,
    ! [VarNext: state_type] :
      ( v86558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86557(VarNext,B)
          <=> v86568(VarNext,B) ) ) ) ).

tff(addAssignment_53023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86568(VarNext,B)
          <=> v86566(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86566(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_497,axiom,
    ! [VarCurr: state_type] :
      ( v86569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86566(VarCurr,B)
          <=> v85890(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7979,axiom,
    ! [VarCurr: state_type] :
      ( v86569(VarCurr)
    <=> ( v86570(VarCurr)
        & v86571(VarCurr) ) ) ).

tff(writeUnaryOperator_3907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86571(VarCurr)
    <=> v85886(VarCurr) ) ).

tff(writeUnaryOperator_3906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86570(VarCurr)
    <=> v85882(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86558(VarNext)
      <=> v86559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86559(VarNext)
      <=> ( v86560(VarNext)
          & v86553(VarNext) ) ) ) ).

tff(writeUnaryOperator_3905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86560(VarNext)
      <=> v86562(VarNext) ) ) ).

tff(addAssignment_53022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86562(VarNext)
      <=> v86553(VarCurr) ) ) ).

tff(addAssignment_53021,axiom,
    ! [VarCurr: state_type] :
      ( v86553(VarCurr)
    <=> v86555(VarCurr) ) ).

tff(addAssignment_53020,axiom,
    ! [VarCurr: state_type] :
      ( v86555(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_53019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85890(VarCurr,B)
      <=> v85892(VarCurr,B) ) ) ).

tff(addAssignment_53018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85892(VarCurr,B)
      <=> v85894(VarCurr,B) ) ) ).

tff(addAssignment_53017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85894(VarCurr,B)
      <=> v85896(VarCurr,B) ) ) ).

tff(addAssignment_53016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v85896(VarCurr,B)
      <=> v86479(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85868(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86479(VarCurr,B)
          <=> v86494(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_496,axiom,
    ! [VarCurr: state_type] :
      ( v85868(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86479(VarCurr,B)
          <=> v86480(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86495(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86494(VarCurr,B)
          <=> v86499(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_495,axiom,
    ! [VarCurr: state_type] :
      ( v86495(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86494(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86499(VarCurr,B)
          <=> v86504(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_494,axiom,
    ! [VarCurr: state_type] :
      ( v86500(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86499(VarCurr,B)
          <=> b001000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86505(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86504(VarCurr,B)
          <=> v86509(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_493,axiom,
    ! [VarCurr: state_type] :
      ( v86505(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86504(VarCurr,B)
          <=> b010000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86509(VarCurr,B)
          <=> v86514(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_492,axiom,
    ! [VarCurr: state_type] :
      ( v86510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86509(VarCurr,B)
          <=> b011000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86515(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86514(VarCurr,B)
          <=> v86519(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_491,axiom,
    ! [VarCurr: state_type] :
      ( v86515(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86514(VarCurr,B)
          <=> b100000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86519(VarCurr,B)
          <=> v86524(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_490,axiom,
    ! [VarCurr: state_type] :
      ( v86520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86519(VarCurr,B)
          <=> b101000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86524(VarCurr,B)
          <=> v86529(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_489,axiom,
    ! [VarCurr: state_type] :
      ( v86525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86524(VarCurr,B)
          <=> b110000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86530(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86529(VarCurr,B)
          <=> v86534(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_488,axiom,
    ! [VarCurr: state_type] :
      ( v86530(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86529(VarCurr,B)
          <=> b111000(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86535(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86534(VarCurr,B)
          <=> v85876(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_487,axiom,
    ! [VarCurr: state_type] :
      ( v86535(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v86534(VarCurr,B)
          <=> v86551(VarCurr,B) ) ) ) ).

tff(addAssignment_53015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v86551(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_53014,axiom,
    ! [VarCurr: state_type] :
      ( ( v86551(VarCurr,5)
      <=> v86471(VarCurr,2) )
      & ( v86551(VarCurr,4)
      <=> v86471(VarCurr,1) )
      & ( v86551(VarCurr,3)
      <=> v86471(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7976,axiom,
    ! [VarCurr: state_type] :
      ( v86535(VarCurr)
    <=> ( v86536(VarCurr)
        & v86543(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_697,axiom,
    ! [VarCurr: state_type] :
      ( v86543(VarCurr)
    <=> ( v86545(VarCurr)
        | v85851(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_696,axiom,
    ! [VarCurr: state_type] :
      ( v86545(VarCurr)
    <=> ( v86546(VarCurr)
        | v85851(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_695,axiom,
    ! [VarCurr: state_type] :
      ( v86546(VarCurr)
    <=> ( v86547(VarCurr)
        | v85851(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_694,axiom,
    ! [VarCurr: state_type] :
      ( v86547(VarCurr)
    <=> ( v86548(VarCurr)
        | v85851(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_693,axiom,
    ! [VarCurr: state_type] :
      ( v86548(VarCurr)
    <=> ( v86549(VarCurr)
        | v85851(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_692,axiom,
    ! [VarCurr: state_type] :
      ( v86549(VarCurr)
    <=> ( v86550(VarCurr)
        | v85851(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_691,axiom,
    ! [VarCurr: state_type] :
      ( v86550(VarCurr)
    <=> ( v85851(VarCurr,0)
        | v85851(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7975,axiom,
    ! [VarCurr: state_type] :
      ( v86536(VarCurr)
    <=> ( v86537(VarCurr)
        & v86407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7974,axiom,
    ! [VarCurr: state_type] :
      ( v86537(VarCurr)
    <=> ( v86538(VarCurr)
        & v86343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7973,axiom,
    ! [VarCurr: state_type] :
      ( v86538(VarCurr)
    <=> ( v86539(VarCurr)
        & v86279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7972,axiom,
    ! [VarCurr: state_type] :
      ( v86539(VarCurr)
    <=> ( v86540(VarCurr)
        & v86215(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7971,axiom,
    ! [VarCurr: state_type] :
      ( v86540(VarCurr)
    <=> ( v86541(VarCurr)
        & v86151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7970,axiom,
    ! [VarCurr: state_type] :
      ( v86541(VarCurr)
    <=> ( v86542(VarCurr)
        & v86087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7969,axiom,
    ! [VarCurr: state_type] :
      ( v86542(VarCurr)
    <=> ( v85829(VarCurr)
        & v86023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7968,axiom,
    ! [VarCurr: state_type] :
      ( v86530(VarCurr)
    <=> ( v86531(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7967,axiom,
    ! [VarCurr: state_type] :
      ( v86531(VarCurr)
    <=> ( v86532(VarCurr)
        & v86533(VarCurr) ) ) ).

tff(writeUnaryOperator_3904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86533(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86532(VarCurr)
    <=> v86407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7966,axiom,
    ! [VarCurr: state_type] :
      ( v86525(VarCurr)
    <=> ( v86526(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7965,axiom,
    ! [VarCurr: state_type] :
      ( v86526(VarCurr)
    <=> ( v86527(VarCurr)
        & v86528(VarCurr) ) ) ).

tff(writeUnaryOperator_3902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86528(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86527(VarCurr)
    <=> v86343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7964,axiom,
    ! [VarCurr: state_type] :
      ( v86520(VarCurr)
    <=> ( v86521(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7963,axiom,
    ! [VarCurr: state_type] :
      ( v86521(VarCurr)
    <=> ( v86522(VarCurr)
        & v86523(VarCurr) ) ) ).

tff(writeUnaryOperator_3900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86523(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86522(VarCurr)
    <=> v86279(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7962,axiom,
    ! [VarCurr: state_type] :
      ( v86515(VarCurr)
    <=> ( v86516(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7961,axiom,
    ! [VarCurr: state_type] :
      ( v86516(VarCurr)
    <=> ( v86517(VarCurr)
        & v86518(VarCurr) ) ) ).

tff(writeUnaryOperator_3898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86518(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86517(VarCurr)
    <=> v86215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7960,axiom,
    ! [VarCurr: state_type] :
      ( v86510(VarCurr)
    <=> ( v86511(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7959,axiom,
    ! [VarCurr: state_type] :
      ( v86511(VarCurr)
    <=> ( v86512(VarCurr)
        & v86513(VarCurr) ) ) ).

tff(writeUnaryOperator_3896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86513(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86512(VarCurr)
    <=> v86151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7958,axiom,
    ! [VarCurr: state_type] :
      ( v86505(VarCurr)
    <=> ( v86506(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7957,axiom,
    ! [VarCurr: state_type] :
      ( v86506(VarCurr)
    <=> ( v86507(VarCurr)
        & v86508(VarCurr) ) ) ).

tff(writeUnaryOperator_3894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86508(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86507(VarCurr)
    <=> v86087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7956,axiom,
    ! [VarCurr: state_type] :
      ( v86500(VarCurr)
    <=> ( v86501(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7955,axiom,
    ! [VarCurr: state_type] :
      ( v86501(VarCurr)
    <=> ( v86502(VarCurr)
        & v86503(VarCurr) ) ) ).

tff(writeUnaryOperator_3892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86503(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86502(VarCurr)
    <=> v86023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7954,axiom,
    ! [VarCurr: state_type] :
      ( v86495(VarCurr)
    <=> ( v86496(VarCurr)
        & v85874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7953,axiom,
    ! [VarCurr: state_type] :
      ( v86496(VarCurr)
    <=> ( v86497(VarCurr)
        & v86498(VarCurr) ) ) ).

tff(writeUnaryOperator_3890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86498(VarCurr)
    <=> v85898(VarCurr) ) ).

tff(writeUnaryOperator_3889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86497(VarCurr)
    <=> v85829(VarCurr) ) ).

tff(addAssignment_53013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v86480(VarCurr,B)
      <=> v86481(VarCurr,B) ) ) ).

tff(addAssignment_53012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v86480(VarCurr,B)
      <=> v85876(VarCurr,B) ) ) ).

tff(addAssignment_53011,axiom,
    ! [VarCurr: state_type] :
      ( v86481(VarCurr,0)
    <=> v86491(VarCurr) ) ).

tff(addAssignment_53010,axiom,
    ! [VarCurr: state_type] :
      ( v86481(VarCurr,1)
    <=> v86489(VarCurr) ) ).

tff(addAssignment_53009,axiom,
    ! [VarCurr: state_type] :
      ( v86481(VarCurr,2)
    <=> v86483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7952,axiom,
    ! [VarCurr: state_type] :
      ( v86489(VarCurr)
    <=> ( v86490(VarCurr)
        & v86493(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_690,axiom,
    ! [VarCurr: state_type] :
      ( v86493(VarCurr)
    <=> ( v85876(VarCurr,0)
        | v85876(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7951,axiom,
    ! [VarCurr: state_type] :
      ( v86490(VarCurr)
    <=> ( v86491(VarCurr)
        | v86492(VarCurr) ) ) ).

tff(writeUnaryOperator_3888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86492(VarCurr)
    <=> v85876(VarCurr,1) ) ).

tff(writeUnaryOperator_3887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86491(VarCurr)
    <=> v85876(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7950,axiom,
    ! [VarCurr: state_type] :
      ( v86483(VarCurr)
    <=> ( v86484(VarCurr)
        & v86488(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_689,axiom,
    ! [VarCurr: state_type] :
      ( v86488(VarCurr)
    <=> ( v86486(VarCurr)
        | v85876(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7949,axiom,
    ! [VarCurr: state_type] :
      ( v86484(VarCurr)
    <=> ( v86485(VarCurr)
        | v86487(VarCurr) ) ) ).

tff(writeUnaryOperator_3886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86487(VarCurr)
    <=> v85876(VarCurr,2) ) ).

tff(writeUnaryOperator_3885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86485(VarCurr)
    <=> v86486(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_688,axiom,
    ! [VarCurr: state_type] :
      ( v86486(VarCurr)
    <=> ( v85876(VarCurr,0)
        & v85876(VarCurr,1) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86471(VarCurr,B)
          <=> v86473(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_486,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86471(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86473(VarCurr,B)
          <=> v86474(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_485,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86473(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86474(VarCurr,B)
          <=> v86475(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_484,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86474(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86475(VarCurr,B)
          <=> v86476(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_483,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86475(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86476(VarCurr,B)
          <=> v86477(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_482,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86476(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86477(VarCurr,B)
          <=> v86478(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_481,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86477(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85851(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86478(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_480,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v86478(VarCurr,B)
          <=> $true ) ) ) ).

tff(addAssignment_53008,axiom,
    ! [VarCurr: state_type] :
      ( v86407(VarCurr)
    <=> v86409(VarCurr) ) ).

tff(addAssignment_53007,axiom,
    ! [VarCurr: state_type] :
      ( v86409(VarCurr)
    <=> v86411(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_971,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86454(VarNext)
       => ( v86411(VarNext)
        <=> v86411(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_971,axiom,
    ! [VarNext: state_type] :
      ( v86454(VarNext)
     => ( v86411(VarNext)
      <=> v86464(VarNext) ) ) ).

tff(addAssignment_53006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86464(VarNext)
      <=> v86462(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86465(VarCurr)
     => ( v86462(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_479,axiom,
    ! [VarCurr: state_type] :
      ( v86465(VarCurr)
     => ( v86462(VarCurr)
      <=> v86421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7948,axiom,
    ! [VarCurr: state_type] :
      ( v86465(VarCurr)
    <=> ( v86466(VarCurr)
        & v86467(VarCurr) ) ) ).

tff(writeUnaryOperator_3884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86467(VarCurr)
    <=> v86417(VarCurr) ) ).

tff(writeUnaryOperator_3883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86466(VarCurr)
    <=> v86413(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86454(VarNext)
      <=> v86455(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86455(VarNext)
      <=> ( v86456(VarNext)
          & v86449(VarNext) ) ) ) ).

tff(writeUnaryOperator_3882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86456(VarNext)
      <=> v86458(VarNext) ) ) ).

tff(addAssignment_53005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86458(VarNext)
      <=> v86449(VarCurr) ) ) ).

tff(addAssignment_53004,axiom,
    ! [VarCurr: state_type] :
      ( v86449(VarCurr)
    <=> v86451(VarCurr) ) ).

tff(addAssignment_53003,axiom,
    ! [VarCurr: state_type] :
      ( v86451(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_53002,axiom,
    ! [VarCurr: state_type] :
      ( v86421(VarCurr)
    <=> v86423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7945,axiom,
    ! [VarCurr: state_type] :
      ( v86423(VarCurr)
    <=> ( v86441(VarCurr)
        | v86444(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7944,axiom,
    ! [VarCurr: state_type] :
      ( v86444(VarCurr)
    <=> ( v86409(VarCurr)
        & v86445(VarCurr) ) ) ).

tff(writeUnaryOperator_3881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86445(VarCurr)
    <=> v86446(VarCurr) ) ).

tff(addAssignment_53001,axiom,
    ! [VarCurr: state_type] :
      ( v86446(VarCurr)
    <=> v86447(VarCurr) ) ).

tff(addAssignment_53000,axiom,
    ! [VarCurr: state_type] :
      ( v86447(VarCurr)
    <=> v86430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7943,axiom,
    ! [VarCurr: state_type] :
      ( v86441(VarCurr)
    <=> ( v86425(VarCurr)
        & v86442(VarCurr) ) ) ).

tff(addAssignment_52999,axiom,
    ! [VarCurr: state_type] :
      ( v86442(VarCurr)
    <=> v86443(VarCurr) ) ).

tff(addAssignment_52998,axiom,
    ! [VarCurr: state_type] :
      ( v86443(VarCurr)
    <=> v86430(VarCurr) ) ).

tff(addAssignment_52997,axiom,
    ! [VarCurr: state_type] :
      ( v86430(VarCurr)
    <=> v86432(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_687,axiom,
    ! [VarCurr: state_type] :
      ( v86432(VarCurr)
    <=> ( v85851(VarCurr,7)
        | v86434(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7942,axiom,
    ! [VarCurr: state_type] :
      ( v86434(VarCurr)
    <=> ( v86435(VarCurr)
        & v86439(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_386,axiom,
    ! [VarCurr: state_type] :
      ( v86439(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $true )
        & ( v85876(VarCurr,4)
        <=> $true )
        & ( v85876(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7941,axiom,
    ! [VarCurr: state_type] :
      ( v86435(VarCurr)
    <=> ( v86436(VarCurr)
        & v86438(VarCurr) ) ) ).

tff(writeUnaryOperator_3880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86438(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7940,axiom,
    ! [VarCurr: state_type] :
      ( v86436(VarCurr)
    <=> ( v86437(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86437(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52996,axiom,
    ! [VarCurr: state_type] :
      ( v86425(VarCurr)
    <=> v86427(VarCurr) ) ).

tff(writeUnaryOperator_3878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86427(VarCurr)
    <=> v85851(VarCurr,7) ) ).

tff(addAssignment_52995,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,7)
    <=> v85853(VarCurr,7) ) ).

tff(addAssignment_52994,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,7)
    <=> v85855(VarCurr,7) ) ).

tff(addAssignment_52993,axiom,
    ! [VarCurr: state_type] :
      ( v86417(VarCurr)
    <=> v86419(VarCurr) ) ).

tff(addAssignment_52992,axiom,
    ! [VarCurr: state_type] :
      ( v86419(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52991,axiom,
    ! [VarCurr: state_type] :
      ( v86413(VarCurr)
    <=> v86415(VarCurr) ) ).

tff(addAssignment_52990,axiom,
    ! [VarCurr: state_type] :
      ( v86415(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52989,axiom,
    ! [VarCurr: state_type] :
      ( v86343(VarCurr)
    <=> v86345(VarCurr) ) ).

tff(addAssignment_52988,axiom,
    ! [VarCurr: state_type] :
      ( v86345(VarCurr)
    <=> v86347(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86390(VarNext)
       => ( v86347(VarNext)
        <=> v86347(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_970,axiom,
    ! [VarNext: state_type] :
      ( v86390(VarNext)
     => ( v86347(VarNext)
      <=> v86400(VarNext) ) ) ).

tff(addAssignment_52987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86400(VarNext)
      <=> v86398(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86401(VarCurr)
     => ( v86398(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_478,axiom,
    ! [VarCurr: state_type] :
      ( v86401(VarCurr)
     => ( v86398(VarCurr)
      <=> v86357(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7939,axiom,
    ! [VarCurr: state_type] :
      ( v86401(VarCurr)
    <=> ( v86402(VarCurr)
        & v86403(VarCurr) ) ) ).

tff(writeUnaryOperator_3877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86403(VarCurr)
    <=> v86353(VarCurr) ) ).

tff(writeUnaryOperator_3876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86402(VarCurr)
    <=> v86349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86390(VarNext)
      <=> v86391(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86391(VarNext)
      <=> ( v86392(VarNext)
          & v86385(VarNext) ) ) ) ).

tff(writeUnaryOperator_3875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86392(VarNext)
      <=> v86394(VarNext) ) ) ).

tff(addAssignment_52986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86394(VarNext)
      <=> v86385(VarCurr) ) ) ).

tff(addAssignment_52985,axiom,
    ! [VarCurr: state_type] :
      ( v86385(VarCurr)
    <=> v86387(VarCurr) ) ).

tff(addAssignment_52984,axiom,
    ! [VarCurr: state_type] :
      ( v86387(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52983,axiom,
    ! [VarCurr: state_type] :
      ( v86357(VarCurr)
    <=> v86359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7936,axiom,
    ! [VarCurr: state_type] :
      ( v86359(VarCurr)
    <=> ( v86377(VarCurr)
        | v86380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7935,axiom,
    ! [VarCurr: state_type] :
      ( v86380(VarCurr)
    <=> ( v86345(VarCurr)
        & v86381(VarCurr) ) ) ).

tff(writeUnaryOperator_3874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86381(VarCurr)
    <=> v86382(VarCurr) ) ).

tff(addAssignment_52982,axiom,
    ! [VarCurr: state_type] :
      ( v86382(VarCurr)
    <=> v86383(VarCurr) ) ).

tff(addAssignment_52981,axiom,
    ! [VarCurr: state_type] :
      ( v86383(VarCurr)
    <=> v86366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7934,axiom,
    ! [VarCurr: state_type] :
      ( v86377(VarCurr)
    <=> ( v86361(VarCurr)
        & v86378(VarCurr) ) ) ).

tff(addAssignment_52980,axiom,
    ! [VarCurr: state_type] :
      ( v86378(VarCurr)
    <=> v86379(VarCurr) ) ).

tff(addAssignment_52979,axiom,
    ! [VarCurr: state_type] :
      ( v86379(VarCurr)
    <=> v86366(VarCurr) ) ).

tff(addAssignment_52978,axiom,
    ! [VarCurr: state_type] :
      ( v86366(VarCurr)
    <=> v86368(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_686,axiom,
    ! [VarCurr: state_type] :
      ( v86368(VarCurr)
    <=> ( v85851(VarCurr,6)
        | v86370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7933,axiom,
    ! [VarCurr: state_type] :
      ( v86370(VarCurr)
    <=> ( v86371(VarCurr)
        & v86375(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_385,axiom,
    ! [VarCurr: state_type] :
      ( v86375(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $true )
        & ( v85876(VarCurr,4)
        <=> $true )
        & ( v85876(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7932,axiom,
    ! [VarCurr: state_type] :
      ( v86371(VarCurr)
    <=> ( v86372(VarCurr)
        & v86374(VarCurr) ) ) ).

tff(writeUnaryOperator_3873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86374(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7931,axiom,
    ! [VarCurr: state_type] :
      ( v86372(VarCurr)
    <=> ( v86373(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86373(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52977,axiom,
    ! [VarCurr: state_type] :
      ( v86361(VarCurr)
    <=> v86363(VarCurr) ) ).

tff(writeUnaryOperator_3871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86363(VarCurr)
    <=> v85851(VarCurr,6) ) ).

tff(addAssignment_52976,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,6)
    <=> v85853(VarCurr,6) ) ).

tff(addAssignment_52975,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,6)
    <=> v85855(VarCurr,6) ) ).

tff(addAssignment_52974,axiom,
    ! [VarCurr: state_type] :
      ( v86353(VarCurr)
    <=> v86355(VarCurr) ) ).

tff(addAssignment_52973,axiom,
    ! [VarCurr: state_type] :
      ( v86355(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52972,axiom,
    ! [VarCurr: state_type] :
      ( v86349(VarCurr)
    <=> v86351(VarCurr) ) ).

tff(addAssignment_52971,axiom,
    ! [VarCurr: state_type] :
      ( v86351(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52970,axiom,
    ! [VarCurr: state_type] :
      ( v86279(VarCurr)
    <=> v86281(VarCurr) ) ).

tff(addAssignment_52969,axiom,
    ! [VarCurr: state_type] :
      ( v86281(VarCurr)
    <=> v86283(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86326(VarNext)
       => ( v86283(VarNext)
        <=> v86283(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_969,axiom,
    ! [VarNext: state_type] :
      ( v86326(VarNext)
     => ( v86283(VarNext)
      <=> v86336(VarNext) ) ) ).

tff(addAssignment_52968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86336(VarNext)
      <=> v86334(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86337(VarCurr)
     => ( v86334(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_477,axiom,
    ! [VarCurr: state_type] :
      ( v86337(VarCurr)
     => ( v86334(VarCurr)
      <=> v86293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7930,axiom,
    ! [VarCurr: state_type] :
      ( v86337(VarCurr)
    <=> ( v86338(VarCurr)
        & v86339(VarCurr) ) ) ).

tff(writeUnaryOperator_3870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86339(VarCurr)
    <=> v86289(VarCurr) ) ).

tff(writeUnaryOperator_3869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86338(VarCurr)
    <=> v86285(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86326(VarNext)
      <=> v86327(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86327(VarNext)
      <=> ( v86328(VarNext)
          & v86321(VarNext) ) ) ) ).

tff(writeUnaryOperator_3868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86328(VarNext)
      <=> v86330(VarNext) ) ) ).

tff(addAssignment_52967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86330(VarNext)
      <=> v86321(VarCurr) ) ) ).

tff(addAssignment_52966,axiom,
    ! [VarCurr: state_type] :
      ( v86321(VarCurr)
    <=> v86323(VarCurr) ) ).

tff(addAssignment_52965,axiom,
    ! [VarCurr: state_type] :
      ( v86323(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52964,axiom,
    ! [VarCurr: state_type] :
      ( v86293(VarCurr)
    <=> v86295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7927,axiom,
    ! [VarCurr: state_type] :
      ( v86295(VarCurr)
    <=> ( v86313(VarCurr)
        | v86316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7926,axiom,
    ! [VarCurr: state_type] :
      ( v86316(VarCurr)
    <=> ( v86281(VarCurr)
        & v86317(VarCurr) ) ) ).

tff(writeUnaryOperator_3867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86317(VarCurr)
    <=> v86318(VarCurr) ) ).

tff(addAssignment_52963,axiom,
    ! [VarCurr: state_type] :
      ( v86318(VarCurr)
    <=> v86319(VarCurr) ) ).

tff(addAssignment_52962,axiom,
    ! [VarCurr: state_type] :
      ( v86319(VarCurr)
    <=> v86302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7925,axiom,
    ! [VarCurr: state_type] :
      ( v86313(VarCurr)
    <=> ( v86297(VarCurr)
        & v86314(VarCurr) ) ) ).

tff(addAssignment_52961,axiom,
    ! [VarCurr: state_type] :
      ( v86314(VarCurr)
    <=> v86315(VarCurr) ) ).

tff(addAssignment_52960,axiom,
    ! [VarCurr: state_type] :
      ( v86315(VarCurr)
    <=> v86302(VarCurr) ) ).

tff(addAssignment_52959,axiom,
    ! [VarCurr: state_type] :
      ( v86302(VarCurr)
    <=> v86304(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_685,axiom,
    ! [VarCurr: state_type] :
      ( v86304(VarCurr)
    <=> ( v85851(VarCurr,5)
        | v86306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7924,axiom,
    ! [VarCurr: state_type] :
      ( v86306(VarCurr)
    <=> ( v86307(VarCurr)
        & v86311(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_384,axiom,
    ! [VarCurr: state_type] :
      ( v86311(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $true )
        & ( v85876(VarCurr,4)
        <=> $false )
        & ( v85876(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7923,axiom,
    ! [VarCurr: state_type] :
      ( v86307(VarCurr)
    <=> ( v86308(VarCurr)
        & v86310(VarCurr) ) ) ).

tff(writeUnaryOperator_3866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86310(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7922,axiom,
    ! [VarCurr: state_type] :
      ( v86308(VarCurr)
    <=> ( v86309(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86309(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52958,axiom,
    ! [VarCurr: state_type] :
      ( v86297(VarCurr)
    <=> v86299(VarCurr) ) ).

tff(writeUnaryOperator_3864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86299(VarCurr)
    <=> v85851(VarCurr,5) ) ).

tff(addAssignment_52957,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,5)
    <=> v85853(VarCurr,5) ) ).

tff(addAssignment_52956,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,5)
    <=> v85855(VarCurr,5) ) ).

tff(addAssignment_52955,axiom,
    ! [VarCurr: state_type] :
      ( v86289(VarCurr)
    <=> v86291(VarCurr) ) ).

tff(addAssignment_52954,axiom,
    ! [VarCurr: state_type] :
      ( v86291(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52953,axiom,
    ! [VarCurr: state_type] :
      ( v86285(VarCurr)
    <=> v86287(VarCurr) ) ).

tff(addAssignment_52952,axiom,
    ! [VarCurr: state_type] :
      ( v86287(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52951,axiom,
    ! [VarCurr: state_type] :
      ( v86215(VarCurr)
    <=> v86217(VarCurr) ) ).

tff(addAssignment_52950,axiom,
    ! [VarCurr: state_type] :
      ( v86217(VarCurr)
    <=> v86219(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86262(VarNext)
       => ( v86219(VarNext)
        <=> v86219(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_968,axiom,
    ! [VarNext: state_type] :
      ( v86262(VarNext)
     => ( v86219(VarNext)
      <=> v86272(VarNext) ) ) ).

tff(addAssignment_52949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86272(VarNext)
      <=> v86270(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86273(VarCurr)
     => ( v86270(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_476,axiom,
    ! [VarCurr: state_type] :
      ( v86273(VarCurr)
     => ( v86270(VarCurr)
      <=> v86229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7921,axiom,
    ! [VarCurr: state_type] :
      ( v86273(VarCurr)
    <=> ( v86274(VarCurr)
        & v86275(VarCurr) ) ) ).

tff(writeUnaryOperator_3863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86275(VarCurr)
    <=> v86225(VarCurr) ) ).

tff(writeUnaryOperator_3862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86274(VarCurr)
    <=> v86221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86262(VarNext)
      <=> v86263(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86263(VarNext)
      <=> ( v86264(VarNext)
          & v86257(VarNext) ) ) ) ).

tff(writeUnaryOperator_3861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86264(VarNext)
      <=> v86266(VarNext) ) ) ).

tff(addAssignment_52948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86266(VarNext)
      <=> v86257(VarCurr) ) ) ).

tff(addAssignment_52947,axiom,
    ! [VarCurr: state_type] :
      ( v86257(VarCurr)
    <=> v86259(VarCurr) ) ).

tff(addAssignment_52946,axiom,
    ! [VarCurr: state_type] :
      ( v86259(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52945,axiom,
    ! [VarCurr: state_type] :
      ( v86229(VarCurr)
    <=> v86231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7918,axiom,
    ! [VarCurr: state_type] :
      ( v86231(VarCurr)
    <=> ( v86249(VarCurr)
        | v86252(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7917,axiom,
    ! [VarCurr: state_type] :
      ( v86252(VarCurr)
    <=> ( v86217(VarCurr)
        & v86253(VarCurr) ) ) ).

tff(writeUnaryOperator_3860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86253(VarCurr)
    <=> v86254(VarCurr) ) ).

tff(addAssignment_52944,axiom,
    ! [VarCurr: state_type] :
      ( v86254(VarCurr)
    <=> v86255(VarCurr) ) ).

tff(addAssignment_52943,axiom,
    ! [VarCurr: state_type] :
      ( v86255(VarCurr)
    <=> v86238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7916,axiom,
    ! [VarCurr: state_type] :
      ( v86249(VarCurr)
    <=> ( v86233(VarCurr)
        & v86250(VarCurr) ) ) ).

tff(addAssignment_52942,axiom,
    ! [VarCurr: state_type] :
      ( v86250(VarCurr)
    <=> v86251(VarCurr) ) ).

tff(addAssignment_52941,axiom,
    ! [VarCurr: state_type] :
      ( v86251(VarCurr)
    <=> v86238(VarCurr) ) ).

tff(addAssignment_52940,axiom,
    ! [VarCurr: state_type] :
      ( v86238(VarCurr)
    <=> v86240(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_684,axiom,
    ! [VarCurr: state_type] :
      ( v86240(VarCurr)
    <=> ( v85851(VarCurr,4)
        | v86242(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7915,axiom,
    ! [VarCurr: state_type] :
      ( v86242(VarCurr)
    <=> ( v86243(VarCurr)
        & v86247(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_383,axiom,
    ! [VarCurr: state_type] :
      ( v86247(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $true )
        & ( v85876(VarCurr,4)
        <=> $false )
        & ( v85876(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7914,axiom,
    ! [VarCurr: state_type] :
      ( v86243(VarCurr)
    <=> ( v86244(VarCurr)
        & v86246(VarCurr) ) ) ).

tff(writeUnaryOperator_3859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86246(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7913,axiom,
    ! [VarCurr: state_type] :
      ( v86244(VarCurr)
    <=> ( v86245(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86245(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52939,axiom,
    ! [VarCurr: state_type] :
      ( v86233(VarCurr)
    <=> v86235(VarCurr) ) ).

tff(writeUnaryOperator_3857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86235(VarCurr)
    <=> v85851(VarCurr,4) ) ).

tff(addAssignment_52938,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,4)
    <=> v85853(VarCurr,4) ) ).

tff(addAssignment_52937,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,4)
    <=> v85855(VarCurr,4) ) ).

tff(addAssignment_52936,axiom,
    ! [VarCurr: state_type] :
      ( v86225(VarCurr)
    <=> v86227(VarCurr) ) ).

tff(addAssignment_52935,axiom,
    ! [VarCurr: state_type] :
      ( v86227(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52934,axiom,
    ! [VarCurr: state_type] :
      ( v86221(VarCurr)
    <=> v86223(VarCurr) ) ).

tff(addAssignment_52933,axiom,
    ! [VarCurr: state_type] :
      ( v86223(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52932,axiom,
    ! [VarCurr: state_type] :
      ( v86151(VarCurr)
    <=> v86153(VarCurr) ) ).

tff(addAssignment_52931,axiom,
    ! [VarCurr: state_type] :
      ( v86153(VarCurr)
    <=> v86155(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86198(VarNext)
       => ( v86155(VarNext)
        <=> v86155(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_967,axiom,
    ! [VarNext: state_type] :
      ( v86198(VarNext)
     => ( v86155(VarNext)
      <=> v86208(VarNext) ) ) ).

tff(addAssignment_52930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86208(VarNext)
      <=> v86206(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86209(VarCurr)
     => ( v86206(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_475,axiom,
    ! [VarCurr: state_type] :
      ( v86209(VarCurr)
     => ( v86206(VarCurr)
      <=> v86165(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7912,axiom,
    ! [VarCurr: state_type] :
      ( v86209(VarCurr)
    <=> ( v86210(VarCurr)
        & v86211(VarCurr) ) ) ).

tff(writeUnaryOperator_3856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86211(VarCurr)
    <=> v86161(VarCurr) ) ).

tff(writeUnaryOperator_3855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86210(VarCurr)
    <=> v86157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86198(VarNext)
      <=> v86199(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86199(VarNext)
      <=> ( v86200(VarNext)
          & v86193(VarNext) ) ) ) ).

tff(writeUnaryOperator_3854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86200(VarNext)
      <=> v86202(VarNext) ) ) ).

tff(addAssignment_52929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86202(VarNext)
      <=> v86193(VarCurr) ) ) ).

tff(addAssignment_52928,axiom,
    ! [VarCurr: state_type] :
      ( v86193(VarCurr)
    <=> v86195(VarCurr) ) ).

tff(addAssignment_52927,axiom,
    ! [VarCurr: state_type] :
      ( v86195(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52926,axiom,
    ! [VarCurr: state_type] :
      ( v86165(VarCurr)
    <=> v86167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7909,axiom,
    ! [VarCurr: state_type] :
      ( v86167(VarCurr)
    <=> ( v86185(VarCurr)
        | v86188(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7908,axiom,
    ! [VarCurr: state_type] :
      ( v86188(VarCurr)
    <=> ( v86153(VarCurr)
        & v86189(VarCurr) ) ) ).

tff(writeUnaryOperator_3853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86189(VarCurr)
    <=> v86190(VarCurr) ) ).

tff(addAssignment_52925,axiom,
    ! [VarCurr: state_type] :
      ( v86190(VarCurr)
    <=> v86191(VarCurr) ) ).

tff(addAssignment_52924,axiom,
    ! [VarCurr: state_type] :
      ( v86191(VarCurr)
    <=> v86174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7907,axiom,
    ! [VarCurr: state_type] :
      ( v86185(VarCurr)
    <=> ( v86169(VarCurr)
        & v86186(VarCurr) ) ) ).

tff(addAssignment_52923,axiom,
    ! [VarCurr: state_type] :
      ( v86186(VarCurr)
    <=> v86187(VarCurr) ) ).

tff(addAssignment_52922,axiom,
    ! [VarCurr: state_type] :
      ( v86187(VarCurr)
    <=> v86174(VarCurr) ) ).

tff(addAssignment_52921,axiom,
    ! [VarCurr: state_type] :
      ( v86174(VarCurr)
    <=> v86176(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_683,axiom,
    ! [VarCurr: state_type] :
      ( v86176(VarCurr)
    <=> ( v85851(VarCurr,3)
        | v86178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7906,axiom,
    ! [VarCurr: state_type] :
      ( v86178(VarCurr)
    <=> ( v86179(VarCurr)
        & v86183(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_382,axiom,
    ! [VarCurr: state_type] :
      ( v86183(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $false )
        & ( v85876(VarCurr,4)
        <=> $true )
        & ( v85876(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7905,axiom,
    ! [VarCurr: state_type] :
      ( v86179(VarCurr)
    <=> ( v86180(VarCurr)
        & v86182(VarCurr) ) ) ).

tff(writeUnaryOperator_3852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86182(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7904,axiom,
    ! [VarCurr: state_type] :
      ( v86180(VarCurr)
    <=> ( v86181(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86181(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52920,axiom,
    ! [VarCurr: state_type] :
      ( v86169(VarCurr)
    <=> v86171(VarCurr) ) ).

tff(writeUnaryOperator_3850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86171(VarCurr)
    <=> v85851(VarCurr,3) ) ).

tff(addAssignment_52919,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,3)
    <=> v85853(VarCurr,3) ) ).

tff(addAssignment_52918,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,3)
    <=> v85855(VarCurr,3) ) ).

tff(addAssignment_52917,axiom,
    ! [VarCurr: state_type] :
      ( v86161(VarCurr)
    <=> v86163(VarCurr) ) ).

tff(addAssignment_52916,axiom,
    ! [VarCurr: state_type] :
      ( v86163(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52915,axiom,
    ! [VarCurr: state_type] :
      ( v86157(VarCurr)
    <=> v86159(VarCurr) ) ).

tff(addAssignment_52914,axiom,
    ! [VarCurr: state_type] :
      ( v86159(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52913,axiom,
    ! [VarCurr: state_type] :
      ( v86087(VarCurr)
    <=> v86089(VarCurr) ) ).

tff(addAssignment_52912,axiom,
    ! [VarCurr: state_type] :
      ( v86089(VarCurr)
    <=> v86091(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86134(VarNext)
       => ( v86091(VarNext)
        <=> v86091(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_966,axiom,
    ! [VarNext: state_type] :
      ( v86134(VarNext)
     => ( v86091(VarNext)
      <=> v86144(VarNext) ) ) ).

tff(addAssignment_52911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86144(VarNext)
      <=> v86142(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86145(VarCurr)
     => ( v86142(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_474,axiom,
    ! [VarCurr: state_type] :
      ( v86145(VarCurr)
     => ( v86142(VarCurr)
      <=> v86101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7903,axiom,
    ! [VarCurr: state_type] :
      ( v86145(VarCurr)
    <=> ( v86146(VarCurr)
        & v86147(VarCurr) ) ) ).

tff(writeUnaryOperator_3849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86147(VarCurr)
    <=> v86097(VarCurr) ) ).

tff(writeUnaryOperator_3848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86146(VarCurr)
    <=> v86093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86134(VarNext)
      <=> v86135(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86135(VarNext)
      <=> ( v86136(VarNext)
          & v86129(VarNext) ) ) ) ).

tff(writeUnaryOperator_3847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86136(VarNext)
      <=> v86138(VarNext) ) ) ).

tff(addAssignment_52910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86138(VarNext)
      <=> v86129(VarCurr) ) ) ).

tff(addAssignment_52909,axiom,
    ! [VarCurr: state_type] :
      ( v86129(VarCurr)
    <=> v86131(VarCurr) ) ).

tff(addAssignment_52908,axiom,
    ! [VarCurr: state_type] :
      ( v86131(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52907,axiom,
    ! [VarCurr: state_type] :
      ( v86101(VarCurr)
    <=> v86103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7900,axiom,
    ! [VarCurr: state_type] :
      ( v86103(VarCurr)
    <=> ( v86121(VarCurr)
        | v86124(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7899,axiom,
    ! [VarCurr: state_type] :
      ( v86124(VarCurr)
    <=> ( v86089(VarCurr)
        & v86125(VarCurr) ) ) ).

tff(writeUnaryOperator_3846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86125(VarCurr)
    <=> v86126(VarCurr) ) ).

tff(addAssignment_52906,axiom,
    ! [VarCurr: state_type] :
      ( v86126(VarCurr)
    <=> v86127(VarCurr) ) ).

tff(addAssignment_52905,axiom,
    ! [VarCurr: state_type] :
      ( v86127(VarCurr)
    <=> v86110(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7898,axiom,
    ! [VarCurr: state_type] :
      ( v86121(VarCurr)
    <=> ( v86105(VarCurr)
        & v86122(VarCurr) ) ) ).

tff(addAssignment_52904,axiom,
    ! [VarCurr: state_type] :
      ( v86122(VarCurr)
    <=> v86123(VarCurr) ) ).

tff(addAssignment_52903,axiom,
    ! [VarCurr: state_type] :
      ( v86123(VarCurr)
    <=> v86110(VarCurr) ) ).

tff(addAssignment_52902,axiom,
    ! [VarCurr: state_type] :
      ( v86110(VarCurr)
    <=> v86112(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_682,axiom,
    ! [VarCurr: state_type] :
      ( v86112(VarCurr)
    <=> ( v85851(VarCurr,2)
        | v86114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7897,axiom,
    ! [VarCurr: state_type] :
      ( v86114(VarCurr)
    <=> ( v86115(VarCurr)
        & v86119(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_381,axiom,
    ! [VarCurr: state_type] :
      ( v86119(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $false )
        & ( v85876(VarCurr,4)
        <=> $true )
        & ( v85876(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7896,axiom,
    ! [VarCurr: state_type] :
      ( v86115(VarCurr)
    <=> ( v86116(VarCurr)
        & v86118(VarCurr) ) ) ).

tff(writeUnaryOperator_3845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86118(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7895,axiom,
    ! [VarCurr: state_type] :
      ( v86116(VarCurr)
    <=> ( v86117(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86117(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52901,axiom,
    ! [VarCurr: state_type] :
      ( v86105(VarCurr)
    <=> v86107(VarCurr) ) ).

tff(writeUnaryOperator_3843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86107(VarCurr)
    <=> v85851(VarCurr,2) ) ).

tff(addAssignment_52900,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,2)
    <=> v85853(VarCurr,2) ) ).

tff(addAssignment_52899,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,2)
    <=> v85855(VarCurr,2) ) ).

tff(addAssignment_52898,axiom,
    ! [VarCurr: state_type] :
      ( v86097(VarCurr)
    <=> v86099(VarCurr) ) ).

tff(addAssignment_52897,axiom,
    ! [VarCurr: state_type] :
      ( v86099(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52896,axiom,
    ! [VarCurr: state_type] :
      ( v86093(VarCurr)
    <=> v86095(VarCurr) ) ).

tff(addAssignment_52895,axiom,
    ! [VarCurr: state_type] :
      ( v86095(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52894,axiom,
    ! [VarCurr: state_type] :
      ( v86023(VarCurr)
    <=> v86025(VarCurr) ) ).

tff(addAssignment_52893,axiom,
    ! [VarCurr: state_type] :
      ( v86025(VarCurr)
    <=> v86027(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86070(VarNext)
       => ( v86027(VarNext)
        <=> v86027(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_965,axiom,
    ! [VarNext: state_type] :
      ( v86070(VarNext)
     => ( v86027(VarNext)
      <=> v86080(VarNext) ) ) ).

tff(addAssignment_52892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86080(VarNext)
      <=> v86078(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86081(VarCurr)
     => ( v86078(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_473,axiom,
    ! [VarCurr: state_type] :
      ( v86081(VarCurr)
     => ( v86078(VarCurr)
      <=> v86037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7894,axiom,
    ! [VarCurr: state_type] :
      ( v86081(VarCurr)
    <=> ( v86082(VarCurr)
        & v86083(VarCurr) ) ) ).

tff(writeUnaryOperator_3842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86083(VarCurr)
    <=> v86033(VarCurr) ) ).

tff(writeUnaryOperator_3841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86082(VarCurr)
    <=> v86029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86070(VarNext)
      <=> v86071(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86071(VarNext)
      <=> ( v86072(VarNext)
          & v86065(VarNext) ) ) ) ).

tff(writeUnaryOperator_3840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86072(VarNext)
      <=> v86074(VarNext) ) ) ).

tff(addAssignment_52891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86074(VarNext)
      <=> v86065(VarCurr) ) ) ).

tff(addAssignment_52890,axiom,
    ! [VarCurr: state_type] :
      ( v86065(VarCurr)
    <=> v86067(VarCurr) ) ).

tff(addAssignment_52889,axiom,
    ! [VarCurr: state_type] :
      ( v86067(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52888,axiom,
    ! [VarCurr: state_type] :
      ( v86037(VarCurr)
    <=> v86039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7891,axiom,
    ! [VarCurr: state_type] :
      ( v86039(VarCurr)
    <=> ( v86057(VarCurr)
        | v86060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7890,axiom,
    ! [VarCurr: state_type] :
      ( v86060(VarCurr)
    <=> ( v86025(VarCurr)
        & v86061(VarCurr) ) ) ).

tff(writeUnaryOperator_3839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86061(VarCurr)
    <=> v86062(VarCurr) ) ).

tff(addAssignment_52887,axiom,
    ! [VarCurr: state_type] :
      ( v86062(VarCurr)
    <=> v86063(VarCurr) ) ).

tff(addAssignment_52886,axiom,
    ! [VarCurr: state_type] :
      ( v86063(VarCurr)
    <=> v86046(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7889,axiom,
    ! [VarCurr: state_type] :
      ( v86057(VarCurr)
    <=> ( v86041(VarCurr)
        & v86058(VarCurr) ) ) ).

tff(addAssignment_52885,axiom,
    ! [VarCurr: state_type] :
      ( v86058(VarCurr)
    <=> v86059(VarCurr) ) ).

tff(addAssignment_52884,axiom,
    ! [VarCurr: state_type] :
      ( v86059(VarCurr)
    <=> v86046(VarCurr) ) ).

tff(addAssignment_52883,axiom,
    ! [VarCurr: state_type] :
      ( v86046(VarCurr)
    <=> v86048(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_681,axiom,
    ! [VarCurr: state_type] :
      ( v86048(VarCurr)
    <=> ( v85851(VarCurr,1)
        | v86050(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7888,axiom,
    ! [VarCurr: state_type] :
      ( v86050(VarCurr)
    <=> ( v86051(VarCurr)
        & v86055(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_380,axiom,
    ! [VarCurr: state_type] :
      ( v86055(VarCurr)
    <=> ( ( v85876(VarCurr,5)
        <=> $false )
        & ( v85876(VarCurr,4)
        <=> $false )
        & ( v85876(VarCurr,3)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7887,axiom,
    ! [VarCurr: state_type] :
      ( v86051(VarCurr)
    <=> ( v86052(VarCurr)
        & v86054(VarCurr) ) ) ).

tff(writeUnaryOperator_3838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86054(VarCurr)
    <=> v85874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7886,axiom,
    ! [VarCurr: state_type] :
      ( v86052(VarCurr)
    <=> ( v86053(VarCurr)
        & v85868(VarCurr) ) ) ).

tff(writeUnaryOperator_3837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86053(VarCurr)
    <=> v85862(VarCurr) ) ).

tff(addAssignment_52882,axiom,
    ! [VarCurr: state_type] :
      ( v86041(VarCurr)
    <=> v86043(VarCurr) ) ).

tff(writeUnaryOperator_3836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86043(VarCurr)
    <=> v85851(VarCurr,1) ) ).

tff(addAssignment_52881,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,1)
    <=> v85853(VarCurr,1) ) ).

tff(addAssignment_52880,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,1)
    <=> v85855(VarCurr,1) ) ).

tff(addAssignment_52879,axiom,
    ! [VarCurr: state_type] :
      ( v86033(VarCurr)
    <=> v86035(VarCurr) ) ).

tff(addAssignment_52878,axiom,
    ! [VarCurr: state_type] :
      ( v86035(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52877,axiom,
    ! [VarCurr: state_type] :
      ( v86029(VarCurr)
    <=> v86031(VarCurr) ) ).

tff(addAssignment_52876,axiom,
    ! [VarCurr: state_type] :
      ( v86031(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52875,axiom,
    ! [VarCurr: state_type] :
      ( v85898(VarCurr)
    <=> v85900(VarCurr) ) ).

tff(addAssignment_52874,axiom,
    ! [VarCurr: state_type] :
      ( v85900(VarCurr)
    <=> v85902(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86006(VarNext)
       => ( v85902(VarNext)
        <=> v85902(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_964,axiom,
    ! [VarNext: state_type] :
      ( v86006(VarNext)
     => ( v85902(VarNext)
      <=> v86016(VarNext) ) ) ).

tff(addAssignment_52873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86016(VarNext)
      <=> v86014(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86017(VarCurr)
     => ( v86014(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_472,axiom,
    ! [VarCurr: state_type] :
      ( v86017(VarCurr)
     => ( v86014(VarCurr)
      <=> v85912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7885,axiom,
    ! [VarCurr: state_type] :
      ( v86017(VarCurr)
    <=> ( v86018(VarCurr)
        & v86019(VarCurr) ) ) ).

tff(writeUnaryOperator_3835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86019(VarCurr)
    <=> v85908(VarCurr) ) ).

tff(writeUnaryOperator_3834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v86018(VarCurr)
    <=> v85904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86006(VarNext)
      <=> v86007(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86007(VarNext)
      <=> ( v86008(VarNext)
          & v85944(VarNext) ) ) ) ).

tff(writeUnaryOperator_3833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v86008(VarNext)
      <=> v86010(VarNext) ) ) ).

tff(addAssignment_52872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v86010(VarNext)
      <=> v85944(VarCurr) ) ) ).

tff(addAssignment_52871,axiom,
    ! [VarCurr: state_type] :
      ( v85944(VarCurr)
    <=> v85946(VarCurr) ) ).

tff(addAssignment_52870,axiom,
    ! [VarCurr: state_type] :
      ( v85946(VarCurr)
    <=> v85948(VarCurr) ) ).

tff(addAssignment_52869,axiom,
    ! [VarCurr: state_type] :
      ( v85948(VarCurr)
    <=> v85950(VarCurr) ) ).

tff(addAssignment_52868,axiom,
    ! [VarCurr: state_type] :
      ( v85950(VarCurr)
    <=> v85952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7882,axiom,
    ! [VarCurr: state_type] :
      ( v85952(VarCurr)
    <=> ( v86003(VarCurr)
        | v85995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7881,axiom,
    ! [VarCurr: state_type] :
      ( v86003(VarCurr)
    <=> ( v85954(VarCurr)
        & v85960(VarCurr) ) ) ).

tff(addAssignment_52867,axiom,
    ! [VarCurr: state_type] :
      ( v85995(VarCurr)
    <=> v85997(VarCurr) ) ).

tff(addAssignment_52866,axiom,
    ! [VarCurr: state_type] :
      ( v85997(VarCurr)
    <=> v85999(VarCurr) ) ).

tff(addAssignment_52865,axiom,
    ! [VarCurr: state_type] :
      ( v85999(VarCurr)
    <=> v86001(VarCurr) ) ).

tff(addAssignment_52864,axiom,
    ! [VarCurr: state_type] :
      ( v86001(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85979(VarNext)
       => ( v85960(VarNext)
        <=> v85960(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_963,axiom,
    ! [VarNext: state_type] :
      ( v85979(VarNext)
     => ( v85960(VarNext)
      <=> v85989(VarNext) ) ) ).

tff(addAssignment_52863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85989(VarNext)
      <=> v85987(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7880,axiom,
    ! [VarCurr: state_type] :
      ( v85987(VarCurr)
    <=> ( v85990(VarCurr)
        & v85991(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7879,axiom,
    ! [VarCurr: state_type] :
      ( v85991(VarCurr)
    <=> ( v85966(VarCurr)
        | v85970(VarCurr) ) ) ).

tff(writeUnaryOperator_3832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85990(VarCurr)
    <=> v85962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85979(VarNext)
      <=> v85980(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85980(VarNext)
      <=> ( v85982(VarNext)
          & v85984(VarNext) ) ) ) ).

tff(writeUnaryOperator_3831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85984(VarCurr)
    <=> v85954(VarCurr) ) ).

tff(addAssignment_52862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85982(VarNext)
      <=> v85954(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_242,axiom,
    ( v85960(constB0)
  <=> $true ) ).

tff(addAssignment_52861,axiom,
    ! [VarCurr: state_type] :
      ( v85970(VarCurr)
    <=> v85972(VarCurr) ) ).

tff(addAssignment_52860,axiom,
    ! [VarCurr: state_type] :
      ( v85972(VarCurr)
    <=> v85974(VarCurr) ) ).

tff(addAssignment_52859,axiom,
    ! [VarCurr: state_type] :
      ( v85974(VarCurr)
    <=> v85976(VarCurr) ) ).

tff(addAssignment_52858,axiom,
    ! [VarCurr: state_type] :
      ( v85976(VarCurr)
    <=> v1548(VarCurr) ) ).

tff(addAssignment_52857,axiom,
    ! [VarCurr: state_type] :
      ( v85966(VarCurr)
    <=> v85968(VarCurr) ) ).

tff(addAssignment_52856,axiom,
    ! [VarCurr: state_type] :
      ( v85968(VarCurr)
    <=> $true ) ).

tff(addAssignment_52855,axiom,
    ! [VarCurr: state_type] :
      ( v85962(VarCurr)
    <=> v85964(VarCurr) ) ).

tff(addAssignment_52854,axiom,
    ! [VarCurr: state_type] :
      ( v85964(VarCurr)
    <=> $false ) ).

tff(addAssignment_52853,axiom,
    ! [VarCurr: state_type] :
      ( v85954(VarCurr)
    <=> v85956(VarCurr) ) ).

tff(addAssignment_52852,axiom,
    ! [VarCurr: state_type] :
      ( v85956(VarCurr)
    <=> v85958(VarCurr) ) ).

tff(addAssignment_52851,axiom,
    ! [VarCurr: state_type] :
      ( v85958(VarCurr)
    <=> v1230(VarCurr) ) ).

tff(addAssignment_52850,axiom,
    ! [VarCurr: state_type] :
      ( v85912(VarCurr)
    <=> v85914(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7876,axiom,
    ! [VarCurr: state_type] :
      ( v85914(VarCurr)
    <=> ( v85928(VarCurr)
        | v85935(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7875,axiom,
    ! [VarCurr: state_type] :
      ( v85935(VarCurr)
    <=> ( v85936(VarCurr)
        & v85940(VarCurr) ) ) ).

tff(writeUnaryOperator_3830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85940(VarCurr)
    <=> v85941(VarCurr) ) ).

tff(addAssignment_52849,axiom,
    ! [VarCurr: state_type] :
      ( v85941(VarCurr)
    <=> v85942(VarCurr) ) ).

tff(addAssignment_52848,axiom,
    ! [VarCurr: state_type] :
      ( v85942(VarCurr)
    <=> v85926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7874,axiom,
    ! [VarCurr: state_type] :
      ( v85936(VarCurr)
    <=> ( v85900(VarCurr)
        & v85937(VarCurr) ) ) ).

tff(writeUnaryOperator_3829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85937(VarCurr)
    <=> v85938(VarCurr) ) ).

tff(addAssignment_52847,axiom,
    ! [VarCurr: state_type] :
      ( v85938(VarCurr)
    <=> v85939(VarCurr) ) ).

tff(addAssignment_52846,axiom,
    ! [VarCurr: state_type] :
      ( v85939(VarCurr)
    <=> v85924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7873,axiom,
    ! [VarCurr: state_type] :
      ( v85928(VarCurr)
    <=> ( v85929(VarCurr)
        & v85932(VarCurr) ) ) ).

tff(writeUnaryOperator_3828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85932(VarCurr)
    <=> v85933(VarCurr) ) ).

tff(addAssignment_52845,axiom,
    ! [VarCurr: state_type] :
      ( v85933(VarCurr)
    <=> v85934(VarCurr) ) ).

tff(addAssignment_52844,axiom,
    ! [VarCurr: state_type] :
      ( v85934(VarCurr)
    <=> v85926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7872,axiom,
    ! [VarCurr: state_type] :
      ( v85929(VarCurr)
    <=> ( v85916(VarCurr)
        & v85930(VarCurr) ) ) ).

tff(addAssignment_52843,axiom,
    ! [VarCurr: state_type] :
      ( v85930(VarCurr)
    <=> v85931(VarCurr) ) ).

tff(addAssignment_52842,axiom,
    ! [VarCurr: state_type] :
      ( v85931(VarCurr)
    <=> v85924(VarCurr) ) ).

tff(addAssignment_52841,axiom,
    ! [VarCurr: state_type] :
      ( v85926(VarCurr)
    <=> v85827(VarCurr) ) ).

tff(addAssignment_52840,axiom,
    ! [VarCurr: state_type] :
      ( v85924(VarCurr)
    <=> v85918(VarCurr) ) ).

tff(addAssignment_52839,axiom,
    ! [VarCurr: state_type] :
      ( v85916(VarCurr)
    <=> v85918(VarCurr) ) ).

tff(addAssignment_52838,axiom,
    ! [VarCurr: state_type] :
      ( v85918(VarCurr)
    <=> v85920(VarCurr) ) ).

tff(addAssignment_52837,axiom,
    ! [VarCurr: state_type] :
      ( v85920(VarCurr)
    <=> v85922(VarCurr) ) ).

tff(addAssignment_52836,axiom,
    ! [VarCurr: state_type] :
      ( v85908(VarCurr)
    <=> v85910(VarCurr) ) ).

tff(addAssignment_52835,axiom,
    ! [VarCurr: state_type] :
      ( v85910(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52834,axiom,
    ! [VarCurr: state_type] :
      ( v85904(VarCurr)
    <=> v85906(VarCurr) ) ).

tff(addAssignment_52833,axiom,
    ! [VarCurr: state_type] :
      ( v85906(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52832,axiom,
    ! [VarCurr: state_type] :
      ( v85886(VarCurr)
    <=> v85888(VarCurr) ) ).

tff(addAssignment_52831,axiom,
    ! [VarCurr: state_type] :
      ( v85888(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52830,axiom,
    ! [VarCurr: state_type] :
      ( v85882(VarCurr)
    <=> v85884(VarCurr) ) ).

tff(addAssignment_52829,axiom,
    ! [VarCurr: state_type] :
      ( v85884(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52828,axiom,
    ! [VarCurr: state_type] :
      ( v85874(VarCurr)
    <=> v85870(VarCurr,1) ) ).

tff(addAssignment_52827,axiom,
    ! [VarCurr: state_type] :
      ( v85870(VarCurr,1)
    <=> v85872(VarCurr,1) ) ).

tff(addAssignment_52826,axiom,
    ! [VarCurr: state_type] :
      ( v85868(VarCurr)
    <=> v85870(VarCurr,2) ) ).

tff(addAssignment_52825,axiom,
    ! [VarCurr: state_type] :
      ( v85870(VarCurr,2)
    <=> v85872(VarCurr,2) ) ).

tff(addAssignment_52824,axiom,
    ! [VarCurr: state_type] :
      ( v85862(VarCurr)
    <=> v85864(VarCurr,34) ) ).

tff(addAssignment_52823,axiom,
    ! [VarCurr: state_type] :
      ( v85864(VarCurr,34)
    <=> v85866(VarCurr,34) ) ).

tff(addAssignment_52822,axiom,
    ! [VarCurr: state_type] :
      ( v85847(VarCurr)
    <=> v85849(VarCurr) ) ).

tff(writeUnaryOperator_3827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85849(VarCurr)
    <=> v85851(VarCurr,0) ) ).

tff(addAssignment_52821,axiom,
    ! [VarCurr: state_type] :
      ( v85851(VarCurr,0)
    <=> v85853(VarCurr,0) ) ).

tff(addAssignment_52820,axiom,
    ! [VarCurr: state_type] :
      ( v85853(VarCurr,0)
    <=> v85855(VarCurr,0) ) ).

tff(addAssignment_52819,axiom,
    ! [VarCurr: state_type] :
      ( v85839(VarCurr)
    <=> v85841(VarCurr) ) ).

tff(addAssignment_52818,axiom,
    ! [VarCurr: state_type] :
      ( v85841(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52817,axiom,
    ! [VarCurr: state_type] :
      ( v85835(VarCurr)
    <=> v85837(VarCurr) ) ).

tff(addAssignment_52816,axiom,
    ! [VarCurr: state_type] :
      ( v85837(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52815,axiom,
    ! [VarCurr: state_type] :
      ( v85813(VarCurr)
    <=> v85815(VarCurr) ) ).

tff(addAssignment_52814,axiom,
    ! [VarCurr: state_type] :
      ( v85815(VarCurr)
    <=> v85817(VarCurr) ) ).

tff(addAssignment_52813,axiom,
    ! [VarCurr: state_type] :
      ( v85817(VarCurr)
    <=> v85819(VarCurr) ) ).

tff(addAssignment_52812,axiom,
    ! [VarCurr: state_type] :
      ( v85819(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_52811,axiom,
    ! [VarCurr: state_type] :
      ( v85805(VarCurr)
    <=> v85807(VarCurr) ) ).

tff(addAssignment_52810,axiom,
    ! [VarCurr: state_type] :
      ( v85807(VarCurr)
    <=> v85809(VarCurr) ) ).

tff(addAssignment_52809,axiom,
    ! [VarCurr: state_type] :
      ( v85809(VarCurr)
    <=> v85811(VarCurr) ) ).

tff(addAssignment_52808,axiom,
    ! [VarCurr: state_type] :
      ( v85811(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_52807,axiom,
    ! [VarCurr: state_type] :
      ( v85786(VarCurr)
    <=> v85788(VarCurr) ) ).

tff(addAssignment_52806,axiom,
    ! [VarCurr: state_type] :
      ( v85788(VarCurr)
    <=> v172(VarCurr) ) ).

tff(addAssignment_52805,axiom,
    ! [VarCurr: state_type] :
      ( v85782(VarCurr)
    <=> v85784(VarCurr) ) ).

tff(addAssignment_52804,axiom,
    ! [VarCurr: state_type] :
      ( v85784(VarCurr)
    <=> v2942(VarCurr) ) ).

tff(addAssignment_52803,axiom,
    ! [VarCurr: state_type] :
      ( v85778(VarCurr)
    <=> v85780(VarCurr) ) ).

tff(addAssignment_52802,axiom,
    ! [VarCurr: state_type] :
      ( v85780(VarCurr)
    <=> v5189(VarCurr) ) ).

tff(addAssignment_52801,axiom,
    ! [VarCurr: state_type] :
      ( v85760(VarCurr)
    <=> v85762(VarCurr) ) ).

tff(addAssignment_52800,axiom,
    ! [VarCurr: state_type] :
      ( v85762(VarCurr)
    <=> v85734(VarCurr) ) ).

tff(addAssignment_52799,axiom,
    ! [VarCurr: state_type] :
      ( v85756(VarCurr)
    <=> v85758(VarCurr) ) ).

tff(addAssignment_52798,axiom,
    ! [VarCurr: state_type] :
      ( v85758(VarCurr)
    <=> v85726(VarCurr) ) ).

tff(addAssignment_52797,axiom,
    ! [VarCurr: state_type] :
      ( v85730(VarCurr)
    <=> v85732(VarCurr) ) ).

tff(addAssignment_52796,axiom,
    ! [VarCurr: state_type] :
      ( v85732(VarCurr)
    <=> v85734(VarCurr) ) ).

tff(addAssignment_52795,axiom,
    ! [VarCurr: state_type] :
      ( v85734(VarCurr)
    <=> v85736(VarCurr) ) ).

tff(addAssignment_52794,axiom,
    ! [VarCurr: state_type] :
      ( v85736(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_52793,axiom,
    ! [VarCurr: state_type] :
      ( v85722(VarCurr)
    <=> v85724(VarCurr) ) ).

tff(addAssignment_52792,axiom,
    ! [VarCurr: state_type] :
      ( v85724(VarCurr)
    <=> v85726(VarCurr) ) ).

tff(addAssignment_52791,axiom,
    ! [VarCurr: state_type] :
      ( v85726(VarCurr)
    <=> v85728(VarCurr) ) ).

tff(addAssignment_52790,axiom,
    ! [VarCurr: state_type] :
      ( v85728(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_52789,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,0)
    <=> v85700(VarCurr) ) ).

tff(addAssignment_52788,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,1)
    <=> v85699(VarCurr) ) ).

tff(addAssignment_52787,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,2)
    <=> v85698(VarCurr) ) ).

tff(addAssignment_52786,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,3)
    <=> v85697(VarCurr) ) ).

tff(addAssignment_52785,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,4)
    <=> v85696(VarCurr) ) ).

tff(addAssignment_52784,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,5)
    <=> v85695(VarCurr) ) ).

tff(addAssignment_52783,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,6)
    <=> v85694(VarCurr) ) ).

tff(addAssignment_52782,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,7)
    <=> v85693(VarCurr) ) ).

tff(addAssignment_52781,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,8)
    <=> v85692(VarCurr) ) ).

tff(addAssignment_52780,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,9)
    <=> v85691(VarCurr) ) ).

tff(addAssignment_52779,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,10)
    <=> v85690(VarCurr) ) ).

tff(addAssignment_52778,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,11)
    <=> v85689(VarCurr) ) ).

tff(addAssignment_52777,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,12)
    <=> v85688(VarCurr) ) ).

tff(addAssignment_52776,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,13)
    <=> v85687(VarCurr) ) ).

tff(addAssignment_52775,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,14)
    <=> v85686(VarCurr) ) ).

tff(addAssignment_52774,axiom,
    ! [VarCurr: state_type] :
      ( v85126(VarCurr,15)
    <=> v85685(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_379,axiom,
    ! [VarCurr: state_type] :
      ( v85700(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_378,axiom,
    ! [VarCurr: state_type] :
      ( v85699(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_377,axiom,
    ! [VarCurr: state_type] :
      ( v85698(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_376,axiom,
    ! [VarCurr: state_type] :
      ( v85697(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_375,axiom,
    ! [VarCurr: state_type] :
      ( v85696(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_374,axiom,
    ! [VarCurr: state_type] :
      ( v85695(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_373,axiom,
    ! [VarCurr: state_type] :
      ( v85694(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_372,axiom,
    ! [VarCurr: state_type] :
      ( v85693(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $false )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_371,axiom,
    ! [VarCurr: state_type] :
      ( v85692(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_370,axiom,
    ! [VarCurr: state_type] :
      ( v85691(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_369,axiom,
    ! [VarCurr: state_type] :
      ( v85690(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_368,axiom,
    ! [VarCurr: state_type] :
      ( v85689(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $false )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_367,axiom,
    ! [VarCurr: state_type] :
      ( v85688(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_366,axiom,
    ! [VarCurr: state_type] :
      ( v85687(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $false )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_365,axiom,
    ! [VarCurr: state_type] :
      ( v85686(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_364,axiom,
    ! [VarCurr: state_type] :
      ( v85685(VarCurr)
    <=> ( ( v85128(VarCurr,6)
        <=> $true )
        & ( v85128(VarCurr,5)
        <=> $true )
        & ( v85128(VarCurr,4)
        <=> $true )
        & ( v85128(VarCurr,3)
        <=> $true ) ) ) ).

tff(addAssignment_52773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85128(VarCurr,B)
      <=> v85130(VarCurr,B) ) ) ).

tff(addAssignment_52772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85130(VarCurr,B)
      <=> v85132(VarCurr,B) ) ) ).

tff(addAssignment_52771,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85132(VarNext,B)
      <=> v85667(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85668(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85667(VarNext,B)
            <=> v85132(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_962,axiom,
    ! [VarNext: state_type] :
      ( v85668(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85667(VarNext,B)
          <=> v85678(VarNext,B) ) ) ) ).

tff(addAssignment_52770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85678(VarNext,B)
          <=> v85676(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85679(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85676(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_471,axiom,
    ! [VarCurr: state_type] :
      ( v85679(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85676(VarCurr,B)
          <=> v85142(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7871,axiom,
    ! [VarCurr: state_type] :
      ( v85679(VarCurr)
    <=> ( v85680(VarCurr)
        & v85681(VarCurr) ) ) ).

tff(writeUnaryOperator_3826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85681(VarCurr)
    <=> v85138(VarCurr) ) ).

tff(writeUnaryOperator_3825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85680(VarCurr)
    <=> v85134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85668(VarNext)
      <=> v85669(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85669(VarNext)
      <=> ( v85670(VarNext)
          & v85663(VarNext) ) ) ) ).

tff(writeUnaryOperator_3824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85670(VarNext)
      <=> v85672(VarNext) ) ) ).

tff(addAssignment_52769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85672(VarNext)
      <=> v85663(VarCurr) ) ) ).

tff(addAssignment_52768,axiom,
    ! [VarCurr: state_type] :
      ( v85663(VarCurr)
    <=> v85665(VarCurr) ) ).

tff(addAssignment_52767,axiom,
    ! [VarCurr: state_type] :
      ( v85665(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85142(VarCurr,B)
      <=> v85144(VarCurr,B) ) ) ).

tff(addAssignment_52765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85144(VarCurr,B)
      <=> v85654(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85654(VarCurr,B)
      <=> ( v85655(VarCurr,B)
          | v85658(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85658(VarCurr,B)
      <=> ( v85130(VarCurr,B)
          & v85659(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85659(VarCurr,B)
      <=> ~ v85660(VarCurr,B) ) ) ).

tff(addAssignment_52764,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,0)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52763,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,1)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52762,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,2)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52761,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,3)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52760,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,4)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52759,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,5)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52758,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,6)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52757,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,7)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52756,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,8)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52755,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,9)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52754,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,10)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52753,axiom,
    ! [VarCurr: state_type] :
      ( v85660(VarCurr,11)
    <=> v85661(VarCurr) ) ).

tff(addAssignment_52752,axiom,
    ! [VarCurr: state_type] :
      ( v85661(VarCurr)
    <=> v85648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85655(VarCurr,B)
      <=> ( v85146(VarCurr,B)
          & v85656(VarCurr,B) ) ) ) ).

tff(addAssignment_52751,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,0)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52750,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,1)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52749,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,2)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52748,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,3)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52747,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,4)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52746,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,5)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52745,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,6)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52744,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,7)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52743,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,8)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52742,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,9)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52741,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,10)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52740,axiom,
    ! [VarCurr: state_type] :
      ( v85656(VarCurr,11)
    <=> v85657(VarCurr) ) ).

tff(addAssignment_52739,axiom,
    ! [VarCurr: state_type] :
      ( v85657(VarCurr)
    <=> v85648(VarCurr) ) ).

tff(addAssignment_52738,axiom,
    ! [VarCurr: state_type] :
      ( v85648(VarCurr)
    <=> v85650(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7868,axiom,
    ! [VarCurr: state_type] :
      ( v85650(VarCurr)
    <=> ( v85652(VarCurr)
        | v84953(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7867,axiom,
    ! [VarCurr: state_type] :
      ( v85652(VarCurr)
    <=> ( v85653(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_363,axiom,
    ! [VarCurr: state_type] :
      ( v85653(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $false )
        & ( v84917(VarCurr,1)
        <=> $false )
        & ( v84917(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_52737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85146(VarCurr,B)
      <=> v85148(VarCurr,B) ) ) ).

tff(addAssignment_52736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85148(VarCurr,B)
      <=> v85646(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85646(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_470,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85646(VarCurr,B)
          <=> v85150(VarCurr,B) ) ) ) ).

tff(addAssignment_52735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85150(VarCurr,B)
      <=> v85152(VarCurr,B) ) ) ).

tff(addAssignment_52734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85152(VarCurr,B)
      <=> v85154(VarCurr,B) ) ) ).

tff(addAssignment_52733,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85154(VarNext,B)
      <=> v85629(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85630(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85629(VarNext,B)
            <=> v85154(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_961,axiom,
    ! [VarNext: state_type] :
      ( v85630(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85629(VarNext,B)
          <=> v85640(VarNext,B) ) ) ) ).

tff(addAssignment_52732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85640(VarNext,B)
          <=> v85638(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85641(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85638(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_469,axiom,
    ! [VarCurr: state_type] :
      ( v85641(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85638(VarCurr,B)
          <=> v85164(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7866,axiom,
    ! [VarCurr: state_type] :
      ( v85641(VarCurr)
    <=> ( v85642(VarCurr)
        & v85643(VarCurr) ) ) ).

tff(writeUnaryOperator_3822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85643(VarCurr)
    <=> v85160(VarCurr) ) ).

tff(writeUnaryOperator_3821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85642(VarCurr)
    <=> v85156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85630(VarNext)
      <=> v85631(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85631(VarNext)
      <=> ( v85632(VarNext)
          & v85625(VarNext) ) ) ) ).

tff(writeUnaryOperator_3820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85632(VarNext)
      <=> v85634(VarNext) ) ) ).

tff(addAssignment_52731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85634(VarNext)
      <=> v85625(VarCurr) ) ) ).

tff(addAssignment_52730,axiom,
    ! [VarCurr: state_type] :
      ( v85625(VarCurr)
    <=> v85627(VarCurr) ) ).

tff(addAssignment_52729,axiom,
    ! [VarCurr: state_type] :
      ( v85627(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85164(VarCurr,B)
      <=> v85166(VarCurr,B) ) ) ).

tff(addAssignment_52727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85166(VarCurr,B)
      <=> v85616(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85616(VarCurr,B)
      <=> ( v85617(VarCurr,B)
          | v85620(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85620(VarCurr,B)
      <=> ( v85152(VarCurr,B)
          & v85621(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85621(VarCurr,B)
      <=> ~ v85622(VarCurr,B) ) ) ).

tff(addAssignment_52726,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,0)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52725,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,1)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52724,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,2)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52723,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,3)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52722,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,4)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52721,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,5)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52720,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,6)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52719,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,7)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52718,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,8)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52717,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,9)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52716,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,10)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52715,axiom,
    ! [VarCurr: state_type] :
      ( v85622(VarCurr,11)
    <=> v85623(VarCurr) ) ).

tff(addAssignment_52714,axiom,
    ! [VarCurr: state_type] :
      ( v85623(VarCurr)
    <=> v85609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85617(VarCurr,B)
      <=> ( v85168(VarCurr,B)
          & v85618(VarCurr,B) ) ) ) ).

tff(addAssignment_52713,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,0)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52712,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,1)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52711,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,2)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52710,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,3)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52709,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,4)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52708,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,5)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52707,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,6)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52706,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,7)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52705,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,8)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52704,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,9)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52703,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,10)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52702,axiom,
    ! [VarCurr: state_type] :
      ( v85618(VarCurr,11)
    <=> v85619(VarCurr) ) ).

tff(addAssignment_52701,axiom,
    ! [VarCurr: state_type] :
      ( v85619(VarCurr)
    <=> v85609(VarCurr) ) ).

tff(addAssignment_52700,axiom,
    ! [VarCurr: state_type] :
      ( v85609(VarCurr)
    <=> v85611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7863,axiom,
    ! [VarCurr: state_type] :
      ( v85611(VarCurr)
    <=> ( v85613(VarCurr)
        | v85615(VarCurr) ) ) ).

tff(addAssignment_52699,axiom,
    ! [VarCurr: state_type] :
      ( v85615(VarCurr)
    <=> v85018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7862,axiom,
    ! [VarCurr: state_type] :
      ( v85613(VarCurr)
    <=> ( v85614(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85614(VarCurr)
    <=> v84915(VarCurr,1) ) ).

tff(addAssignment_52698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85168(VarCurr,B)
      <=> v85170(VarCurr,B) ) ) ).

tff(addAssignment_52697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85170(VarCurr,B)
      <=> v85607(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85607(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_468,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85607(VarCurr,B)
          <=> v85172(VarCurr,B) ) ) ) ).

tff(addAssignment_52696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85172(VarCurr,B)
      <=> v85174(VarCurr,B) ) ) ).

tff(addAssignment_52695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85174(VarCurr,B)
      <=> v85176(VarCurr,B) ) ) ).

tff(addAssignment_52694,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85176(VarNext,B)
      <=> v85590(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85591(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85590(VarNext,B)
            <=> v85176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_960,axiom,
    ! [VarNext: state_type] :
      ( v85591(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85590(VarNext,B)
          <=> v85601(VarNext,B) ) ) ) ).

tff(addAssignment_52693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85601(VarNext,B)
          <=> v85599(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85602(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85599(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_467,axiom,
    ! [VarCurr: state_type] :
      ( v85602(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85599(VarCurr,B)
          <=> v85186(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7861,axiom,
    ! [VarCurr: state_type] :
      ( v85602(VarCurr)
    <=> ( v85603(VarCurr)
        & v85604(VarCurr) ) ) ).

tff(writeUnaryOperator_3817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85604(VarCurr)
    <=> v85182(VarCurr) ) ).

tff(writeUnaryOperator_3816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85603(VarCurr)
    <=> v85178(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85591(VarNext)
      <=> v85592(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85592(VarNext)
      <=> ( v85593(VarNext)
          & v85586(VarNext) ) ) ) ).

tff(writeUnaryOperator_3815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85593(VarNext)
      <=> v85595(VarNext) ) ) ).

tff(addAssignment_52692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85595(VarNext)
      <=> v85586(VarCurr) ) ) ).

tff(addAssignment_52691,axiom,
    ! [VarCurr: state_type] :
      ( v85586(VarCurr)
    <=> v85588(VarCurr) ) ).

tff(addAssignment_52690,axiom,
    ! [VarCurr: state_type] :
      ( v85588(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85186(VarCurr,B)
      <=> v85188(VarCurr,B) ) ) ).

tff(addAssignment_52688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85188(VarCurr,B)
      <=> v85577(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85577(VarCurr,B)
      <=> ( v85578(VarCurr,B)
          | v85581(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85581(VarCurr,B)
      <=> ( v85174(VarCurr,B)
          & v85582(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85582(VarCurr,B)
      <=> ~ v85583(VarCurr,B) ) ) ).

tff(addAssignment_52687,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,0)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52686,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,1)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52685,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,2)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52684,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,3)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52683,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,4)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52682,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,5)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52681,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,6)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52680,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,7)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52679,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,8)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52678,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,9)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52677,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,10)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52676,axiom,
    ! [VarCurr: state_type] :
      ( v85583(VarCurr,11)
    <=> v85584(VarCurr) ) ).

tff(addAssignment_52675,axiom,
    ! [VarCurr: state_type] :
      ( v85584(VarCurr)
    <=> v85570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85578(VarCurr,B)
      <=> ( v85190(VarCurr,B)
          & v85579(VarCurr,B) ) ) ) ).

tff(addAssignment_52674,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,0)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52673,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,1)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52672,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,2)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52671,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,3)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52670,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,4)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52669,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,5)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52668,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,6)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52667,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,7)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52666,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,8)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52665,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,9)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52664,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,10)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52663,axiom,
    ! [VarCurr: state_type] :
      ( v85579(VarCurr,11)
    <=> v85580(VarCurr) ) ).

tff(addAssignment_52662,axiom,
    ! [VarCurr: state_type] :
      ( v85580(VarCurr)
    <=> v85570(VarCurr) ) ).

tff(addAssignment_52661,axiom,
    ! [VarCurr: state_type] :
      ( v85570(VarCurr)
    <=> v85572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7858,axiom,
    ! [VarCurr: state_type] :
      ( v85572(VarCurr)
    <=> ( v85574(VarCurr)
        | v85576(VarCurr) ) ) ).

tff(addAssignment_52660,axiom,
    ! [VarCurr: state_type] :
      ( v85576(VarCurr)
    <=> v85017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7857,axiom,
    ! [VarCurr: state_type] :
      ( v85574(VarCurr)
    <=> ( v85575(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85575(VarCurr)
    <=> v84915(VarCurr,2) ) ).

tff(addAssignment_52659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85190(VarCurr,B)
      <=> v85192(VarCurr,B) ) ) ).

tff(addAssignment_52658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85192(VarCurr,B)
      <=> v85568(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85568(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_466,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85568(VarCurr,B)
          <=> v85194(VarCurr,B) ) ) ) ).

tff(addAssignment_52657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85194(VarCurr,B)
      <=> v85196(VarCurr,B) ) ) ).

tff(addAssignment_52656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85196(VarCurr,B)
      <=> v85198(VarCurr,B) ) ) ).

tff(addAssignment_52655,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85198(VarNext,B)
      <=> v85551(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85552(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85551(VarNext,B)
            <=> v85198(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_959,axiom,
    ! [VarNext: state_type] :
      ( v85552(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85551(VarNext,B)
          <=> v85562(VarNext,B) ) ) ) ).

tff(addAssignment_52654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85562(VarNext,B)
          <=> v85560(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85560(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_465,axiom,
    ! [VarCurr: state_type] :
      ( v85563(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85560(VarCurr,B)
          <=> v85208(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7856,axiom,
    ! [VarCurr: state_type] :
      ( v85563(VarCurr)
    <=> ( v85564(VarCurr)
        & v85565(VarCurr) ) ) ).

tff(writeUnaryOperator_3812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85565(VarCurr)
    <=> v85204(VarCurr) ) ).

tff(writeUnaryOperator_3811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85564(VarCurr)
    <=> v85200(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85552(VarNext)
      <=> v85553(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85553(VarNext)
      <=> ( v85554(VarNext)
          & v85547(VarNext) ) ) ) ).

tff(writeUnaryOperator_3810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85554(VarNext)
      <=> v85556(VarNext) ) ) ).

tff(addAssignment_52653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85556(VarNext)
      <=> v85547(VarCurr) ) ) ).

tff(addAssignment_52652,axiom,
    ! [VarCurr: state_type] :
      ( v85547(VarCurr)
    <=> v85549(VarCurr) ) ).

tff(addAssignment_52651,axiom,
    ! [VarCurr: state_type] :
      ( v85549(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85208(VarCurr,B)
      <=> v85210(VarCurr,B) ) ) ).

tff(addAssignment_52649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85210(VarCurr,B)
      <=> v85538(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85538(VarCurr,B)
      <=> ( v85539(VarCurr,B)
          | v85542(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85542(VarCurr,B)
      <=> ( v85196(VarCurr,B)
          & v85543(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85543(VarCurr,B)
      <=> ~ v85544(VarCurr,B) ) ) ).

tff(addAssignment_52648,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,0)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52647,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,1)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52646,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,2)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52645,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,3)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52644,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,4)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52643,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,5)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52642,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,6)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52641,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,7)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52640,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,8)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52639,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,9)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52638,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,10)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52637,axiom,
    ! [VarCurr: state_type] :
      ( v85544(VarCurr,11)
    <=> v85545(VarCurr) ) ).

tff(addAssignment_52636,axiom,
    ! [VarCurr: state_type] :
      ( v85545(VarCurr)
    <=> v85531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85539(VarCurr,B)
      <=> ( v85212(VarCurr,B)
          & v85540(VarCurr,B) ) ) ) ).

tff(addAssignment_52635,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,0)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52634,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,1)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52633,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,2)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52632,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,3)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52631,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,4)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52630,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,5)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52629,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,6)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52628,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,7)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52627,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,8)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52626,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,9)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52625,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,10)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52624,axiom,
    ! [VarCurr: state_type] :
      ( v85540(VarCurr,11)
    <=> v85541(VarCurr) ) ).

tff(addAssignment_52623,axiom,
    ! [VarCurr: state_type] :
      ( v85541(VarCurr)
    <=> v85531(VarCurr) ) ).

tff(addAssignment_52622,axiom,
    ! [VarCurr: state_type] :
      ( v85531(VarCurr)
    <=> v85533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7853,axiom,
    ! [VarCurr: state_type] :
      ( v85533(VarCurr)
    <=> ( v85535(VarCurr)
        | v85537(VarCurr) ) ) ).

tff(addAssignment_52621,axiom,
    ! [VarCurr: state_type] :
      ( v85537(VarCurr)
    <=> v85016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7852,axiom,
    ! [VarCurr: state_type] :
      ( v85535(VarCurr)
    <=> ( v85536(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85536(VarCurr)
    <=> v84915(VarCurr,3) ) ).

tff(addAssignment_52620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85212(VarCurr,B)
      <=> v85214(VarCurr,B) ) ) ).

tff(addAssignment_52619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85214(VarCurr,B)
      <=> v85529(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85529(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_464,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85529(VarCurr,B)
          <=> v85216(VarCurr,B) ) ) ) ).

tff(addAssignment_52618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85216(VarCurr,B)
      <=> v85218(VarCurr,B) ) ) ).

tff(addAssignment_52617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85218(VarCurr,B)
      <=> v85220(VarCurr,B) ) ) ).

tff(addAssignment_52616,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85220(VarNext,B)
      <=> v85512(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85513(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85512(VarNext,B)
            <=> v85220(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_958,axiom,
    ! [VarNext: state_type] :
      ( v85513(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85512(VarNext,B)
          <=> v85523(VarNext,B) ) ) ) ).

tff(addAssignment_52615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85523(VarNext,B)
          <=> v85521(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85521(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_463,axiom,
    ! [VarCurr: state_type] :
      ( v85524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85521(VarCurr,B)
          <=> v85230(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7851,axiom,
    ! [VarCurr: state_type] :
      ( v85524(VarCurr)
    <=> ( v85525(VarCurr)
        & v85526(VarCurr) ) ) ).

tff(writeUnaryOperator_3807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85526(VarCurr)
    <=> v85226(VarCurr) ) ).

tff(writeUnaryOperator_3806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85525(VarCurr)
    <=> v85222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85513(VarNext)
      <=> v85514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85514(VarNext)
      <=> ( v85515(VarNext)
          & v85508(VarNext) ) ) ) ).

tff(writeUnaryOperator_3805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85515(VarNext)
      <=> v85517(VarNext) ) ) ).

tff(addAssignment_52614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85517(VarNext)
      <=> v85508(VarCurr) ) ) ).

tff(addAssignment_52613,axiom,
    ! [VarCurr: state_type] :
      ( v85508(VarCurr)
    <=> v85510(VarCurr) ) ).

tff(addAssignment_52612,axiom,
    ! [VarCurr: state_type] :
      ( v85510(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85230(VarCurr,B)
      <=> v85232(VarCurr,B) ) ) ).

tff(addAssignment_52610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85232(VarCurr,B)
      <=> v85499(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85499(VarCurr,B)
      <=> ( v85500(VarCurr,B)
          | v85503(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85503(VarCurr,B)
      <=> ( v85218(VarCurr,B)
          & v85504(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85504(VarCurr,B)
      <=> ~ v85505(VarCurr,B) ) ) ).

tff(addAssignment_52609,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,0)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52608,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,1)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52607,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,2)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52606,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,3)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52605,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,4)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52604,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,5)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52603,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,6)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52602,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,7)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52601,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,8)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52600,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,9)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52599,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,10)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52598,axiom,
    ! [VarCurr: state_type] :
      ( v85505(VarCurr,11)
    <=> v85506(VarCurr) ) ).

tff(addAssignment_52597,axiom,
    ! [VarCurr: state_type] :
      ( v85506(VarCurr)
    <=> v85492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85500(VarCurr,B)
      <=> ( v85234(VarCurr,B)
          & v85501(VarCurr,B) ) ) ) ).

tff(addAssignment_52596,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,0)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52595,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,1)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52594,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,2)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52593,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,3)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52592,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,4)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52591,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,5)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52590,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,6)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52589,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,7)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52588,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,8)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52587,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,9)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52586,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,10)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52585,axiom,
    ! [VarCurr: state_type] :
      ( v85501(VarCurr,11)
    <=> v85502(VarCurr) ) ).

tff(addAssignment_52584,axiom,
    ! [VarCurr: state_type] :
      ( v85502(VarCurr)
    <=> v85492(VarCurr) ) ).

tff(addAssignment_52583,axiom,
    ! [VarCurr: state_type] :
      ( v85492(VarCurr)
    <=> v85494(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7848,axiom,
    ! [VarCurr: state_type] :
      ( v85494(VarCurr)
    <=> ( v85496(VarCurr)
        | v85498(VarCurr) ) ) ).

tff(addAssignment_52582,axiom,
    ! [VarCurr: state_type] :
      ( v85498(VarCurr)
    <=> v85015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7847,axiom,
    ! [VarCurr: state_type] :
      ( v85496(VarCurr)
    <=> ( v85497(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85497(VarCurr)
    <=> v84915(VarCurr,4) ) ).

tff(addAssignment_52581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85234(VarCurr,B)
      <=> v85236(VarCurr,B) ) ) ).

tff(addAssignment_52580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85236(VarCurr,B)
      <=> v85490(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85490(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_462,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85490(VarCurr,B)
          <=> v85238(VarCurr,B) ) ) ) ).

tff(addAssignment_52579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85238(VarCurr,B)
      <=> v85240(VarCurr,B) ) ) ).

tff(addAssignment_52578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85240(VarCurr,B)
      <=> v85242(VarCurr,B) ) ) ).

tff(addAssignment_52577,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85242(VarNext,B)
      <=> v85473(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85474(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85473(VarNext,B)
            <=> v85242(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_957,axiom,
    ! [VarNext: state_type] :
      ( v85474(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85473(VarNext,B)
          <=> v85484(VarNext,B) ) ) ) ).

tff(addAssignment_52576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85484(VarNext,B)
          <=> v85482(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85485(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85482(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_461,axiom,
    ! [VarCurr: state_type] :
      ( v85485(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85482(VarCurr,B)
          <=> v85252(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7846,axiom,
    ! [VarCurr: state_type] :
      ( v85485(VarCurr)
    <=> ( v85486(VarCurr)
        & v85487(VarCurr) ) ) ).

tff(writeUnaryOperator_3802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85487(VarCurr)
    <=> v85248(VarCurr) ) ).

tff(writeUnaryOperator_3801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85486(VarCurr)
    <=> v85244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85474(VarNext)
      <=> v85475(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85475(VarNext)
      <=> ( v85476(VarNext)
          & v85469(VarNext) ) ) ) ).

tff(writeUnaryOperator_3800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85476(VarNext)
      <=> v85478(VarNext) ) ) ).

tff(addAssignment_52575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85478(VarNext)
      <=> v85469(VarCurr) ) ) ).

tff(addAssignment_52574,axiom,
    ! [VarCurr: state_type] :
      ( v85469(VarCurr)
    <=> v85471(VarCurr) ) ).

tff(addAssignment_52573,axiom,
    ! [VarCurr: state_type] :
      ( v85471(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85252(VarCurr,B)
      <=> v85254(VarCurr,B) ) ) ).

tff(addAssignment_52571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85254(VarCurr,B)
      <=> v85460(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85460(VarCurr,B)
      <=> ( v85461(VarCurr,B)
          | v85464(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85464(VarCurr,B)
      <=> ( v85240(VarCurr,B)
          & v85465(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85465(VarCurr,B)
      <=> ~ v85466(VarCurr,B) ) ) ).

tff(addAssignment_52570,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,0)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52569,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,1)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52568,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,2)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52567,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,3)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52566,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,4)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52565,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,5)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52564,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,6)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52563,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,7)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52562,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,8)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52561,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,9)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52560,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,10)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52559,axiom,
    ! [VarCurr: state_type] :
      ( v85466(VarCurr,11)
    <=> v85467(VarCurr) ) ).

tff(addAssignment_52558,axiom,
    ! [VarCurr: state_type] :
      ( v85467(VarCurr)
    <=> v85453(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85461(VarCurr,B)
      <=> ( v85256(VarCurr,B)
          & v85462(VarCurr,B) ) ) ) ).

tff(addAssignment_52557,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,0)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52556,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,1)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52555,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,2)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52554,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,3)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52553,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,4)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52552,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,5)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52551,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,6)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52550,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,7)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52549,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,8)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52548,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,9)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52547,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,10)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52546,axiom,
    ! [VarCurr: state_type] :
      ( v85462(VarCurr,11)
    <=> v85463(VarCurr) ) ).

tff(addAssignment_52545,axiom,
    ! [VarCurr: state_type] :
      ( v85463(VarCurr)
    <=> v85453(VarCurr) ) ).

tff(addAssignment_52544,axiom,
    ! [VarCurr: state_type] :
      ( v85453(VarCurr)
    <=> v85455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7843,axiom,
    ! [VarCurr: state_type] :
      ( v85455(VarCurr)
    <=> ( v85457(VarCurr)
        | v85459(VarCurr) ) ) ).

tff(addAssignment_52543,axiom,
    ! [VarCurr: state_type] :
      ( v85459(VarCurr)
    <=> v85014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7842,axiom,
    ! [VarCurr: state_type] :
      ( v85457(VarCurr)
    <=> ( v85458(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85458(VarCurr)
    <=> v84915(VarCurr,5) ) ).

tff(addAssignment_52542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85256(VarCurr,B)
      <=> v85258(VarCurr,B) ) ) ).

tff(addAssignment_52541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85258(VarCurr,B)
      <=> v85451(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85451(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_460,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85451(VarCurr,B)
          <=> v85260(VarCurr,B) ) ) ) ).

tff(addAssignment_52540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85260(VarCurr,B)
      <=> v85262(VarCurr,B) ) ) ).

tff(addAssignment_52539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85262(VarCurr,B)
      <=> v85264(VarCurr,B) ) ) ).

tff(addAssignment_52538,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85264(VarNext,B)
      <=> v85434(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85435(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85434(VarNext,B)
            <=> v85264(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_956,axiom,
    ! [VarNext: state_type] :
      ( v85435(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85434(VarNext,B)
          <=> v85445(VarNext,B) ) ) ) ).

tff(addAssignment_52537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85445(VarNext,B)
          <=> v85443(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85446(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85443(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_459,axiom,
    ! [VarCurr: state_type] :
      ( v85446(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85443(VarCurr,B)
          <=> v85274(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7841,axiom,
    ! [VarCurr: state_type] :
      ( v85446(VarCurr)
    <=> ( v85447(VarCurr)
        & v85448(VarCurr) ) ) ).

tff(writeUnaryOperator_3797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85448(VarCurr)
    <=> v85270(VarCurr) ) ).

tff(writeUnaryOperator_3796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85447(VarCurr)
    <=> v85266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85435(VarNext)
      <=> v85436(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85436(VarNext)
      <=> ( v85437(VarNext)
          & v85430(VarNext) ) ) ) ).

tff(writeUnaryOperator_3795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85437(VarNext)
      <=> v85439(VarNext) ) ) ).

tff(addAssignment_52536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85439(VarNext)
      <=> v85430(VarCurr) ) ) ).

tff(addAssignment_52535,axiom,
    ! [VarCurr: state_type] :
      ( v85430(VarCurr)
    <=> v85432(VarCurr) ) ).

tff(addAssignment_52534,axiom,
    ! [VarCurr: state_type] :
      ( v85432(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85274(VarCurr,B)
      <=> v85276(VarCurr,B) ) ) ).

tff(addAssignment_52532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85276(VarCurr,B)
      <=> v85421(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85421(VarCurr,B)
      <=> ( v85422(VarCurr,B)
          | v85425(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85425(VarCurr,B)
      <=> ( v85262(VarCurr,B)
          & v85426(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85426(VarCurr,B)
      <=> ~ v85427(VarCurr,B) ) ) ).

tff(addAssignment_52531,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,0)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52530,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,1)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52529,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,2)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52528,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,3)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52527,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,4)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52526,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,5)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52525,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,6)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52524,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,7)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52523,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,8)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52522,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,9)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52521,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,10)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52520,axiom,
    ! [VarCurr: state_type] :
      ( v85427(VarCurr,11)
    <=> v85428(VarCurr) ) ).

tff(addAssignment_52519,axiom,
    ! [VarCurr: state_type] :
      ( v85428(VarCurr)
    <=> v85414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85422(VarCurr,B)
      <=> ( v85278(VarCurr,B)
          & v85423(VarCurr,B) ) ) ) ).

tff(addAssignment_52518,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,0)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52517,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,1)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52516,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,2)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52515,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,3)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52514,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,4)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52513,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,5)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52512,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,6)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52511,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,7)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52510,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,8)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52509,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,9)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52508,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,10)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52507,axiom,
    ! [VarCurr: state_type] :
      ( v85423(VarCurr,11)
    <=> v85424(VarCurr) ) ).

tff(addAssignment_52506,axiom,
    ! [VarCurr: state_type] :
      ( v85424(VarCurr)
    <=> v85414(VarCurr) ) ).

tff(addAssignment_52505,axiom,
    ! [VarCurr: state_type] :
      ( v85414(VarCurr)
    <=> v85416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7838,axiom,
    ! [VarCurr: state_type] :
      ( v85416(VarCurr)
    <=> ( v85418(VarCurr)
        | v85420(VarCurr) ) ) ).

tff(addAssignment_52504,axiom,
    ! [VarCurr: state_type] :
      ( v85420(VarCurr)
    <=> v85013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7837,axiom,
    ! [VarCurr: state_type] :
      ( v85418(VarCurr)
    <=> ( v85419(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85419(VarCurr)
    <=> v84915(VarCurr,6) ) ).

tff(addAssignment_52503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85278(VarCurr,B)
      <=> v85280(VarCurr,B) ) ) ).

tff(addAssignment_52502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85280(VarCurr,B)
      <=> v85412(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84915(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85412(VarCurr,B)
          <=> v85304(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_458,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85412(VarCurr,B)
          <=> v85282(VarCurr,B) ) ) ) ).

tff(addAssignment_52501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85282(VarCurr,B)
      <=> v85284(VarCurr,B) ) ) ).

tff(addAssignment_52500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85284(VarCurr,B)
      <=> v85286(VarCurr,B) ) ) ).

tff(addAssignment_52499,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85286(VarNext,B)
      <=> v85395(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85396(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v85395(VarNext,B)
            <=> v85286(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_955,axiom,
    ! [VarNext: state_type] :
      ( v85396(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85395(VarNext,B)
          <=> v85406(VarNext,B) ) ) ) ).

tff(addAssignment_52498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85406(VarNext,B)
          <=> v85404(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85404(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_457,axiom,
    ! [VarCurr: state_type] :
      ( v85407(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v85404(VarCurr,B)
          <=> v85296(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7836,axiom,
    ! [VarCurr: state_type] :
      ( v85407(VarCurr)
    <=> ( v85408(VarCurr)
        & v85409(VarCurr) ) ) ).

tff(writeUnaryOperator_3792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85409(VarCurr)
    <=> v85292(VarCurr) ) ).

tff(writeUnaryOperator_3791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85408(VarCurr)
    <=> v85288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85396(VarNext)
      <=> v85397(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85397(VarNext)
      <=> ( v85398(VarNext)
          & v85391(VarNext) ) ) ) ).

tff(writeUnaryOperator_3790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85398(VarNext)
      <=> v85400(VarNext) ) ) ).

tff(addAssignment_52497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85400(VarNext)
      <=> v85391(VarCurr) ) ) ).

tff(addAssignment_52496,axiom,
    ! [VarCurr: state_type] :
      ( v85391(VarCurr)
    <=> v85393(VarCurr) ) ).

tff(addAssignment_52495,axiom,
    ! [VarCurr: state_type] :
      ( v85393(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85296(VarCurr,B)
      <=> v85298(VarCurr,B) ) ) ).

tff(addAssignment_52493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85298(VarCurr,B)
      <=> v85382(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85382(VarCurr,B)
      <=> ( v85383(VarCurr,B)
          | v85386(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85386(VarCurr,B)
      <=> ( v85284(VarCurr,B)
          & v85387(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85387(VarCurr,B)
      <=> ~ v85388(VarCurr,B) ) ) ).

tff(addAssignment_52492,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,0)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52491,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,1)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52490,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,2)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52489,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,3)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52488,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,4)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52487,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,5)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52486,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,6)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52485,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,7)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52484,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,8)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52483,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,9)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52482,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,10)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52481,axiom,
    ! [VarCurr: state_type] :
      ( v85388(VarCurr,11)
    <=> v85389(VarCurr) ) ).

tff(addAssignment_52480,axiom,
    ! [VarCurr: state_type] :
      ( v85389(VarCurr)
    <=> v85375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v85383(VarCurr,B)
      <=> ( v85300(VarCurr,B)
          & v85384(VarCurr,B) ) ) ) ).

tff(addAssignment_52479,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,0)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52478,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,1)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52477,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,2)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52476,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,3)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52475,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,4)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52474,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,5)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52473,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,6)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52472,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,7)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52471,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,8)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52470,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,9)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52469,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,10)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52468,axiom,
    ! [VarCurr: state_type] :
      ( v85384(VarCurr,11)
    <=> v85385(VarCurr) ) ).

tff(addAssignment_52467,axiom,
    ! [VarCurr: state_type] :
      ( v85385(VarCurr)
    <=> v85375(VarCurr) ) ).

tff(addAssignment_52466,axiom,
    ! [VarCurr: state_type] :
      ( v85375(VarCurr)
    <=> v85377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7833,axiom,
    ! [VarCurr: state_type] :
      ( v85377(VarCurr)
    <=> ( v85379(VarCurr)
        | v85381(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_680,axiom,
    ! [VarCurr: state_type] :
      ( v85381(VarCurr)
    <=> ( v85013(VarCurr)
        | v84953(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7832,axiom,
    ! [VarCurr: state_type] :
      ( v85379(VarCurr)
    <=> ( v85380(VarCurr)
        & v84939(VarCurr) ) ) ).

tff(writeUnaryOperator_3788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85380(VarCurr)
    <=> v84915(VarCurr,7) ) ).

tff(addAssignment_52465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85300(VarCurr,B)
      <=> v85302(VarCurr,B) ) ) ).

tff(addAssignment_52464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85302(VarCurr,B)
      <=> v85304(VarCurr,B) ) ) ).

tff(addAssignment_52463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85304(VarCurr,B)
      <=> v85371(VarCurr,B) ) ) ).

tff(addAssignment_52462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85371(VarCurr,B)
      <=> v85306(VarCurr,B) ) ) ).

tff(addAssignment_52461,axiom,
    ! [VarCurr: state_type] :
      ( v85371(VarCurr,2)
    <=> v85373(VarCurr) ) ).

tff(addAssignment_52460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,9)
        & ~ $less(B,3) )
     => ( v85371(VarCurr,B)
      <=> v85306(VarCurr,B) ) ) ).

tff(addAssignment_52459,axiom,
    ! [VarCurr: state_type] :
      ( ( v85371(VarCurr,11)
      <=> v85372(VarCurr,2) )
      & ( v85371(VarCurr,10)
      <=> v85372(VarCurr,1) )
      & ( v85371(VarCurr,9)
      <=> v85372(VarCurr,0) ) ) ).

tff(addAssignment_52458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85306(VarCurr,B)
      <=> v85308(VarCurr,B) ) ) ).

tff(addAssignment_52457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85308(VarCurr,B)
      <=> v85310(VarCurr,B) ) ) ).

tff(addAssignment_52456,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85310(VarNext,B)
      <=> v85354(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85355(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v85354(VarNext,B)
            <=> v85310(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_954,axiom,
    ! [VarNext: state_type] :
      ( v85355(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v85354(VarNext,B)
          <=> v85365(VarNext,B) ) ) ) ).

tff(addAssignment_52455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v85365(VarNext,B)
          <=> v85363(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85366(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v85363(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_456,axiom,
    ! [VarCurr: state_type] :
      ( v85366(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v85363(VarCurr,B)
          <=> v85320(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7831,axiom,
    ! [VarCurr: state_type] :
      ( v85366(VarCurr)
    <=> ( v85367(VarCurr)
        & v85368(VarCurr) ) ) ).

tff(writeUnaryOperator_3787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85368(VarCurr)
    <=> v85316(VarCurr) ) ).

tff(writeUnaryOperator_3786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85367(VarCurr)
    <=> v85312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85355(VarNext)
      <=> v85356(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85356(VarNext)
      <=> ( v85357(VarNext)
          & v85350(VarNext) ) ) ) ).

tff(writeUnaryOperator_3785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85357(VarNext)
      <=> v85359(VarNext) ) ) ).

tff(addAssignment_52454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85359(VarNext)
      <=> v85350(VarCurr) ) ) ).

tff(addAssignment_52453,axiom,
    ! [VarCurr: state_type] :
      ( v85350(VarCurr)
    <=> v85352(VarCurr) ) ).

tff(addAssignment_52452,axiom,
    ! [VarCurr: state_type] :
      ( v85352(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85320(VarCurr,B)
      <=> v85322(VarCurr,B) ) ) ).

tff(addAssignment_52450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85322(VarCurr,B)
      <=> v85324(VarCurr,B) ) ) ).

tff(addAssignment_52449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,3) )
     => ( v85324(VarCurr,B)
      <=> v85345(VarCurr,B) ) ) ).

tff(addAssignment_52448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85345(VarCurr,B)
      <=> v85348(VarCurr,B) ) ) ).

tff(addAssignment_52447,axiom,
    ! [VarCurr: state_type] :
      ( ( v85345(VarCurr,5)
      <=> v85336(VarCurr,2) )
      & ( v85345(VarCurr,4)
      <=> v85336(VarCurr,1) )
      & ( v85345(VarCurr,3)
      <=> v85336(VarCurr,0) ) ) ).

tff(addAssignment_52446,axiom,
    ! [VarCurr: state_type] :
      ( v85345(VarCurr,6)
    <=> v85326(VarCurr) ) ).

tff(addAssignment_52445,axiom,
    ! [VarCurr: state_type] :
      ( v85345(VarCurr,7)
    <=> v85347(VarCurr) ) ).

tff(addAssignment_52444,axiom,
    ! [VarCurr: state_type] :
      ( v85345(VarCurr,8)
    <=> v85346(VarCurr) ) ).

tff(addAssignment_52443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85336(VarCurr,B)
      <=> v85338(VarCurr,B) ) ) ).

tff(addAssignment_52442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85338(VarCurr,B)
      <=> v85340(VarCurr,B) ) ) ).

tff(addAssignment_52441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85340(VarCurr,B)
      <=> v85342(VarCurr,B) ) ) ).

tff(addAssignment_52440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85342(VarCurr,B)
      <=> v85344(VarCurr,B) ) ) ).

tff(addAssignment_52439,axiom,
    ! [VarCurr: state_type] :
      ( ( v85344(VarCurr,2)
      <=> v3948(VarCurr,40) )
      & ( v85344(VarCurr,1)
      <=> v3948(VarCurr,39) )
      & ( v85344(VarCurr,0)
      <=> v3948(VarCurr,38) ) ) ).

tff(addAssignment_52438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,41)
        & ~ $less(B,38) )
     => ( v3948(VarCurr,B)
      <=> v3950(VarCurr,B) ) ) ).

tff(addAssignment_52437,axiom,
    ! [VarCurr: state_type] :
      ( v85326(VarCurr)
    <=> v85328(VarCurr) ) ).

tff(addAssignment_52436,axiom,
    ! [VarCurr: state_type] :
      ( v85328(VarCurr)
    <=> v85330(VarCurr) ) ).

tff(addAssignment_52435,axiom,
    ! [VarCurr: state_type] :
      ( v85330(VarCurr)
    <=> v85332(VarCurr) ) ).

tff(addAssignment_52434,axiom,
    ! [VarCurr: state_type] :
      ( v85332(VarCurr)
    <=> v85334(VarCurr) ) ).

tff(addAssignment_52433,axiom,
    ! [VarCurr: state_type] :
      ( v85334(VarCurr)
    <=> v3948(VarCurr,41) ) ).

tff(addAssignment_52432,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,41)
    <=> v3950(VarCurr,41) ) ).

tff(addAssignment_52431,axiom,
    ! [VarCurr: state_type] :
      ( v85316(VarCurr)
    <=> v85318(VarCurr) ) ).

tff(addAssignment_52430,axiom,
    ! [VarCurr: state_type] :
      ( v85318(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52429,axiom,
    ! [VarCurr: state_type] :
      ( v85312(VarCurr)
    <=> v85314(VarCurr) ) ).

tff(addAssignment_52428,axiom,
    ! [VarCurr: state_type] :
      ( v85314(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52427,axiom,
    ! [VarCurr: state_type] :
      ( v85292(VarCurr)
    <=> v85294(VarCurr) ) ).

tff(addAssignment_52426,axiom,
    ! [VarCurr: state_type] :
      ( v85294(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52425,axiom,
    ! [VarCurr: state_type] :
      ( v85288(VarCurr)
    <=> v85290(VarCurr) ) ).

tff(addAssignment_52424,axiom,
    ! [VarCurr: state_type] :
      ( v85290(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52423,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,7)
    <=> v85081(VarCurr,7) ) ).

tff(addAssignment_52422,axiom,
    ! [VarCurr: state_type] :
      ( v85270(VarCurr)
    <=> v85272(VarCurr) ) ).

tff(addAssignment_52421,axiom,
    ! [VarCurr: state_type] :
      ( v85272(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52420,axiom,
    ! [VarCurr: state_type] :
      ( v85266(VarCurr)
    <=> v85268(VarCurr) ) ).

tff(addAssignment_52419,axiom,
    ! [VarCurr: state_type] :
      ( v85268(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52418,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,6)
    <=> v85081(VarCurr,6) ) ).

tff(addAssignment_52417,axiom,
    ! [VarCurr: state_type] :
      ( v85248(VarCurr)
    <=> v85250(VarCurr) ) ).

tff(addAssignment_52416,axiom,
    ! [VarCurr: state_type] :
      ( v85250(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52415,axiom,
    ! [VarCurr: state_type] :
      ( v85244(VarCurr)
    <=> v85246(VarCurr) ) ).

tff(addAssignment_52414,axiom,
    ! [VarCurr: state_type] :
      ( v85246(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52413,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,5)
    <=> v85081(VarCurr,5) ) ).

tff(addAssignment_52412,axiom,
    ! [VarCurr: state_type] :
      ( v85226(VarCurr)
    <=> v85228(VarCurr) ) ).

tff(addAssignment_52411,axiom,
    ! [VarCurr: state_type] :
      ( v85228(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52410,axiom,
    ! [VarCurr: state_type] :
      ( v85222(VarCurr)
    <=> v85224(VarCurr) ) ).

tff(addAssignment_52409,axiom,
    ! [VarCurr: state_type] :
      ( v85224(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52408,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,4)
    <=> v85081(VarCurr,4) ) ).

tff(addAssignment_52407,axiom,
    ! [VarCurr: state_type] :
      ( v85204(VarCurr)
    <=> v85206(VarCurr) ) ).

tff(addAssignment_52406,axiom,
    ! [VarCurr: state_type] :
      ( v85206(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52405,axiom,
    ! [VarCurr: state_type] :
      ( v85200(VarCurr)
    <=> v85202(VarCurr) ) ).

tff(addAssignment_52404,axiom,
    ! [VarCurr: state_type] :
      ( v85202(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52403,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,3)
    <=> v85081(VarCurr,3) ) ).

tff(addAssignment_52402,axiom,
    ! [VarCurr: state_type] :
      ( v85182(VarCurr)
    <=> v85184(VarCurr) ) ).

tff(addAssignment_52401,axiom,
    ! [VarCurr: state_type] :
      ( v85184(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52400,axiom,
    ! [VarCurr: state_type] :
      ( v85178(VarCurr)
    <=> v85180(VarCurr) ) ).

tff(addAssignment_52399,axiom,
    ! [VarCurr: state_type] :
      ( v85180(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52398,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,2)
    <=> v85081(VarCurr,2) ) ).

tff(addAssignment_52397,axiom,
    ! [VarCurr: state_type] :
      ( v85160(VarCurr)
    <=> v85162(VarCurr) ) ).

tff(addAssignment_52396,axiom,
    ! [VarCurr: state_type] :
      ( v85162(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52395,axiom,
    ! [VarCurr: state_type] :
      ( v85156(VarCurr)
    <=> v85158(VarCurr) ) ).

tff(addAssignment_52394,axiom,
    ! [VarCurr: state_type] :
      ( v85158(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52393,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,1)
    <=> v85081(VarCurr,1) ) ).

tff(addAssignment_52392,axiom,
    ! [VarCurr: state_type] :
      ( v85138(VarCurr)
    <=> v85140(VarCurr) ) ).

tff(addAssignment_52391,axiom,
    ! [VarCurr: state_type] :
      ( v85140(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52390,axiom,
    ! [VarCurr: state_type] :
      ( v85134(VarCurr)
    <=> v85136(VarCurr) ) ).

tff(addAssignment_52389,axiom,
    ! [VarCurr: state_type] :
      ( v85136(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_52388,axiom,
    ! [VarCurr: state_type] :
      ( v84915(VarCurr,0)
    <=> v85081(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v85081(VarCurr,B)
      <=> ( v85082(VarCurr,B)
          | v85120(VarCurr,B) ) ) ) ).

tff(addAssignment_52387,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,0)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52386,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,1)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52385,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,2)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52384,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,3)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52383,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,4)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52382,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,5)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52381,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,6)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52380,axiom,
    ! [VarCurr: state_type] :
      ( v85120(VarCurr,7)
    <=> v85121(VarCurr) ) ).

tff(addAssignment_52379,axiom,
    ! [VarCurr: state_type] :
      ( v85121(VarCurr)
    <=> v85122(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_362,axiom,
    ! [VarCurr: state_type] :
      ( v85122(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $true )
        & ( v84917(VarCurr,2)
        <=> $false )
        & ( v84917(VarCurr,1)
        <=> $false )
        & ( v84917(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v85082(VarCurr,B)
      <=> ( v85083(VarCurr,B)
          | v85116(VarCurr,B) ) ) ) ).

tff(addAssignment_52378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v85116(VarCurr,B)
      <=> v85117(VarCurr,B) ) ) ).

tff(addAssignment_52377,axiom,
    ! [VarCurr: state_type] :
      ( v85116(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_52376,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,0)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52375,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,1)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52374,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,2)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52373,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,3)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52372,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,4)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52371,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,5)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52370,axiom,
    ! [VarCurr: state_type] :
      ( v85117(VarCurr,6)
    <=> v85118(VarCurr) ) ).

tff(addAssignment_52369,axiom,
    ! [VarCurr: state_type] :
      ( v85118(VarCurr)
    <=> v85119(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_361,axiom,
    ! [VarCurr: state_type] :
      ( v85119(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $true )
        & ( v84917(VarCurr,1)
        <=> $true )
        & ( v84917(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_5,axiom,
    ! [VarCurr: state_type] : ~ v85083(VarCurr,7) ).

tff(addAssignment_52368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v85083(VarCurr,B)
      <=> v85084(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v85084(VarCurr,B)
      <=> ( v85085(VarCurr,B)
          | v85112(VarCurr,B) ) ) ) ).

tff(addAssignment_52367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85112(VarCurr,B)
      <=> v85113(VarCurr,B) ) ) ).

tff(addAssignment_52366,axiom,
    ! [VarCurr: state_type] :
      ( v85112(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_52365,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,0)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52364,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,1)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52363,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,2)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52362,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,3)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52361,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,4)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52360,axiom,
    ! [VarCurr: state_type] :
      ( v85113(VarCurr,5)
    <=> v85114(VarCurr) ) ).

tff(addAssignment_52359,axiom,
    ! [VarCurr: state_type] :
      ( v85114(VarCurr)
    <=> v85115(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_360,axiom,
    ! [VarCurr: state_type] :
      ( v85115(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $true )
        & ( v84917(VarCurr,1)
        <=> $true )
        & ( v84917(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_4,axiom,
    ! [VarCurr: state_type] : ~ v85085(VarCurr,6) ).

tff(addAssignment_52358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85085(VarCurr,B)
      <=> v85086(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1121,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v85086(VarCurr,B)
      <=> ( v85087(VarCurr,B)
          | v85108(VarCurr,B) ) ) ) ).

tff(addAssignment_52357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v85108(VarCurr,B)
      <=> v85109(VarCurr,B) ) ) ).

tff(addAssignment_52356,axiom,
    ! [VarCurr: state_type] :
      ( v85108(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_52355,axiom,
    ! [VarCurr: state_type] :
      ( v85109(VarCurr,0)
    <=> v85110(VarCurr) ) ).

tff(addAssignment_52354,axiom,
    ! [VarCurr: state_type] :
      ( v85109(VarCurr,1)
    <=> v85110(VarCurr) ) ).

tff(addAssignment_52353,axiom,
    ! [VarCurr: state_type] :
      ( v85109(VarCurr,2)
    <=> v85110(VarCurr) ) ).

tff(addAssignment_52352,axiom,
    ! [VarCurr: state_type] :
      ( v85109(VarCurr,3)
    <=> v85110(VarCurr) ) ).

tff(addAssignment_52351,axiom,
    ! [VarCurr: state_type] :
      ( v85109(VarCurr,4)
    <=> v85110(VarCurr) ) ).

tff(addAssignment_52350,axiom,
    ! [VarCurr: state_type] :
      ( v85110(VarCurr)
    <=> v85111(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_359,axiom,
    ! [VarCurr: state_type] :
      ( v85111(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $true )
        & ( v84917(VarCurr,1)
        <=> $false )
        & ( v84917(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_3,axiom,
    ! [VarCurr: state_type] : ~ v85087(VarCurr,5) ).

tff(addAssignment_52349,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v85087(VarCurr,B)
      <=> v85088(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v85088(VarCurr,B)
      <=> ( v85089(VarCurr,B)
          | v85104(VarCurr,B) ) ) ) ).

tff(addAssignment_52348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v85104(VarCurr,B)
      <=> v85105(VarCurr,B) ) ) ).

tff(addAssignment_52347,axiom,
    ! [VarCurr: state_type] :
      ( v85104(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_52346,axiom,
    ! [VarCurr: state_type] :
      ( v85105(VarCurr,0)
    <=> v85106(VarCurr) ) ).

tff(addAssignment_52345,axiom,
    ! [VarCurr: state_type] :
      ( v85105(VarCurr,1)
    <=> v85106(VarCurr) ) ).

tff(addAssignment_52344,axiom,
    ! [VarCurr: state_type] :
      ( v85105(VarCurr,2)
    <=> v85106(VarCurr) ) ).

tff(addAssignment_52343,axiom,
    ! [VarCurr: state_type] :
      ( v85105(VarCurr,3)
    <=> v85106(VarCurr) ) ).

tff(addAssignment_52342,axiom,
    ! [VarCurr: state_type] :
      ( v85106(VarCurr)
    <=> v85107(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_358,axiom,
    ! [VarCurr: state_type] :
      ( v85107(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $true )
        & ( v84917(VarCurr,1)
        <=> $false )
        & ( v84917(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint_2,axiom,
    ! [VarCurr: state_type] : ~ v85089(VarCurr,4) ).

tff(addAssignment_52341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v85089(VarCurr,B)
      <=> v85090(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v85090(VarCurr,B)
      <=> ( v85091(VarCurr,B)
          | v85100(VarCurr,B) ) ) ) ).

tff(addAssignment_52340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85100(VarCurr,B)
      <=> v85101(VarCurr,B) ) ) ).

tff(addAssignment_52339,axiom,
    ! [VarCurr: state_type] :
      ( v85100(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_52338,axiom,
    ! [VarCurr: state_type] :
      ( v85101(VarCurr,0)
    <=> v85102(VarCurr) ) ).

tff(addAssignment_52337,axiom,
    ! [VarCurr: state_type] :
      ( v85101(VarCurr,1)
    <=> v85102(VarCurr) ) ).

tff(addAssignment_52336,axiom,
    ! [VarCurr: state_type] :
      ( v85101(VarCurr,2)
    <=> v85102(VarCurr) ) ).

tff(addAssignment_52335,axiom,
    ! [VarCurr: state_type] :
      ( v85102(VarCurr)
    <=> v85103(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_357,axiom,
    ! [VarCurr: state_type] :
      ( v85103(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $false )
        & ( v84917(VarCurr,1)
        <=> $true )
        & ( v84917(VarCurr,0)
        <=> $true ) ) ) ).

tff(addZeroExtensionConstraint_1,axiom,
    ! [VarCurr: state_type] : ~ v85091(VarCurr,3) ).

tff(addAssignment_52334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85091(VarCurr,B)
      <=> v85092(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v85092(VarCurr,B)
      <=> ( v85093(VarCurr,B)
          | v85096(VarCurr,B) ) ) ) ).

tff(addAssignment_52333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85096(VarCurr,B)
      <=> v85097(VarCurr,B) ) ) ).

tff(addAssignment_52332,axiom,
    ! [VarCurr: state_type] :
      ( v85096(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_52331,axiom,
    ! [VarCurr: state_type] :
      ( v85097(VarCurr,0)
    <=> v85098(VarCurr) ) ).

tff(addAssignment_52330,axiom,
    ! [VarCurr: state_type] :
      ( v85097(VarCurr,1)
    <=> v85098(VarCurr) ) ).

tff(addAssignment_52329,axiom,
    ! [VarCurr: state_type] :
      ( v85098(VarCurr)
    <=> v85099(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_356,axiom,
    ! [VarCurr: state_type] :
      ( v85099(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $false )
        & ( v84917(VarCurr,1)
        <=> $true )
        & ( v84917(VarCurr,0)
        <=> $false ) ) ) ).

tff(addZeroExtensionConstraint,axiom,
    ! [VarCurr: state_type] : ~ v85093(VarCurr,2) ).

tff(addAssignment_52328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v85093(VarCurr,B)
      <=> v85094(VarCurr,B) ) ) ).

tff(addAssignment_52327,axiom,
    ! [VarCurr: state_type] :
      ( v85094(VarCurr,0)
    <=> v85095(VarCurr) ) ).

tff(addAssignment_52326,axiom,
    ! [VarCurr: state_type] :
      ( v85094(VarCurr,1)
    <=> $false ) ).

tff(addBitVectorEqualityBitBlasted_355,axiom,
    ! [VarCurr: state_type] :
      ( v85095(VarCurr)
    <=> ( ( v84917(VarCurr,3)
        <=> $false )
        & ( v84917(VarCurr,2)
        <=> $false )
        & ( v84917(VarCurr,1)
        <=> $false )
        & ( v84917(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_52325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v84917(VarCurr,B)
      <=> v84919(VarCurr,B) ) ) ).

tff(addAssignment_52324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v84919(VarCurr,B)
      <=> v84921(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85065(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v84921(VarNext,B)
            <=> v84921(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_953,axiom,
    ! [VarNext: state_type] :
      ( v85065(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v84921(VarNext,B)
          <=> v85075(VarNext,B) ) ) ) ).

tff(addAssignment_52323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v85075(VarNext,B)
          <=> v85073(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85076(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v85073(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_455,axiom,
    ! [VarCurr: state_type] :
      ( v85076(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v85073(VarCurr,B)
          <=> v84931(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7828,axiom,
    ! [VarCurr: state_type] :
      ( v85076(VarCurr)
    <=> ( v85077(VarCurr)
        & v85078(VarCurr) ) ) ).

tff(writeUnaryOperator_3784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85078(VarCurr)
    <=> v84927(VarCurr) ) ).

tff(writeUnaryOperator_3783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85077(VarCurr)
    <=> v84923(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85065(VarNext)
      <=> v85066(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85066(VarNext)
      <=> ( v85067(VarNext)
          & v85060(VarNext) ) ) ) ).

tff(writeUnaryOperator_3782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v85067(VarNext)
      <=> v85069(VarNext) ) ) ).

tff(addAssignment_52322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v85069(VarNext)
      <=> v85060(VarCurr) ) ) ).

tff(addAssignment_52321,axiom,
    ! [VarCurr: state_type] :
      ( v85060(VarCurr)
    <=> v85062(VarCurr) ) ).

tff(addAssignment_52320,axiom,
    ! [VarCurr: state_type] :
      ( v85062(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v84931(VarCurr,B)
      <=> v84933(VarCurr,B) ) ) ).

tff(addAssignment_52318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v84933(VarCurr,B)
      <=> v84935(VarCurr,B) ) ) ).

tff(addAssignment_52317,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v84935(VarCurr,B)
      <=> v84937(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85009(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v84937(VarCurr,B)
          <=> v85038(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_454,axiom,
    ! [VarCurr: state_type] :
      ( v85009(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v84937(VarCurr,B)
          <=> v85019(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85039(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v85038(VarCurr,B)
          <=> v84917(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_453,axiom,
    ! [VarCurr: state_type] :
      ( v85039(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v85038(VarCurr,B)
          <=> v85042(VarCurr,B) ) ) ) ).

tff(addAssignment_52316,axiom,
    ! [VarCurr: state_type] :
      ( v85042(VarCurr,0)
    <=> v85035(VarCurr) ) ).

tff(addAssignment_52315,axiom,
    ! [VarCurr: state_type] :
      ( v85042(VarCurr,1)
    <=> v85056(VarCurr) ) ).

tff(addAssignment_52314,axiom,
    ! [VarCurr: state_type] :
      ( v85042(VarCurr,2)
    <=> v85052(VarCurr) ) ).

tff(addAssignment_52313,axiom,
    ! [VarCurr: state_type] :
      ( v85042(VarCurr,3)
    <=> v85044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7825,axiom,
    ! [VarCurr: state_type] :
      ( v85056(VarCurr)
    <=> ( v85057(VarCurr)
        & v85058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7824,axiom,
    ! [VarCurr: state_type] :
      ( v85058(VarCurr)
    <=> ( v84917(VarCurr,0)
        | v85036(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_679,axiom,
    ! [VarCurr: state_type] :
      ( v85057(VarCurr)
    <=> ( v85035(VarCurr)
        | v84917(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7823,axiom,
    ! [VarCurr: state_type] :
      ( v85052(VarCurr)
    <=> ( v85053(VarCurr)
        & v85055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7822,axiom,
    ! [VarCurr: state_type] :
      ( v85055(VarCurr)
    <=> ( v85031(VarCurr)
        | v85049(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_678,axiom,
    ! [VarCurr: state_type] :
      ( v85053(VarCurr)
    <=> ( v84917(VarCurr,2)
        | v85054(VarCurr) ) ) ).

tff(writeUnaryOperator_3781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85054(VarCurr)
    <=> v85049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7821,axiom,
    ! [VarCurr: state_type] :
      ( v85044(VarCurr)
    <=> ( v85045(VarCurr)
        & v85051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7820,axiom,
    ! [VarCurr: state_type] :
      ( v85051(VarCurr)
    <=> ( v85026(VarCurr)
        | v85047(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_677,axiom,
    ! [VarCurr: state_type] :
      ( v85045(VarCurr)
    <=> ( v84917(VarCurr,3)
        | v85046(VarCurr) ) ) ).

tff(writeUnaryOperator_3780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85046(VarCurr)
    <=> v85047(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_676,axiom,
    ! [VarCurr: state_type] :
      ( v85047(VarCurr)
    <=> ( v84917(VarCurr,2)
        | v85048(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7819,axiom,
    ! [VarCurr: state_type] :
      ( v85048(VarCurr)
    <=> ( v85031(VarCurr)
        & v85049(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_675,axiom,
    ! [VarCurr: state_type] :
      ( v85049(VarCurr)
    <=> ( v84917(VarCurr,1)
        | v85050(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7818,axiom,
    ! [VarCurr: state_type] :
      ( v85050(VarCurr)
    <=> ( v84917(VarCurr,0)
        & v85036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7817,axiom,
    ! [VarCurr: state_type] :
      ( v85039(VarCurr)
    <=> ( v85040(VarCurr)
        & v85041(VarCurr) ) ) ).

tff(writeUnaryOperator_3779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85041(VarCurr)
    <=> v84939(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_674,axiom,
    ! [VarCurr: state_type] :
      ( v85040(VarCurr)
    <=> ( v85013(VarCurr)
        | v84953(VarCurr,7) ) ) ).

tff(addAssignment_52312,axiom,
    ! [VarCurr: state_type] :
      ( v85019(VarCurr,0)
    <=> v85035(VarCurr) ) ).

tff(addAssignment_52311,axiom,
    ! [VarCurr: state_type] :
      ( v85019(VarCurr,1)
    <=> v85033(VarCurr) ) ).

tff(addAssignment_52310,axiom,
    ! [VarCurr: state_type] :
      ( v85019(VarCurr,2)
    <=> v85028(VarCurr) ) ).

tff(addAssignment_52309,axiom,
    ! [VarCurr: state_type] :
      ( v85019(VarCurr,3)
    <=> v85021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7816,axiom,
    ! [VarCurr: state_type] :
      ( v85033(VarCurr)
    <=> ( v85034(VarCurr)
        & v85037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_673,axiom,
    ! [VarCurr: state_type] :
      ( v85037(VarCurr)
    <=> ( v84917(VarCurr,0)
        | v84917(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7815,axiom,
    ! [VarCurr: state_type] :
      ( v85034(VarCurr)
    <=> ( v85035(VarCurr)
        | v85036(VarCurr) ) ) ).

tff(writeUnaryOperator_3778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85036(VarCurr)
    <=> v84917(VarCurr,1) ) ).

tff(writeUnaryOperator_3777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85035(VarCurr)
    <=> v84917(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7814,axiom,
    ! [VarCurr: state_type] :
      ( v85028(VarCurr)
    <=> ( v85029(VarCurr)
        & v85032(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_672,axiom,
    ! [VarCurr: state_type] :
      ( v85032(VarCurr)
    <=> ( v85025(VarCurr)
        | v84917(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7813,axiom,
    ! [VarCurr: state_type] :
      ( v85029(VarCurr)
    <=> ( v85030(VarCurr)
        | v85031(VarCurr) ) ) ).

tff(writeUnaryOperator_3776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85031(VarCurr)
    <=> v84917(VarCurr,2) ) ).

tff(writeUnaryOperator_3775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85030(VarCurr)
    <=> v85025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7812,axiom,
    ! [VarCurr: state_type] :
      ( v85021(VarCurr)
    <=> ( v85022(VarCurr)
        & v85027(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_671,axiom,
    ! [VarCurr: state_type] :
      ( v85027(VarCurr)
    <=> ( v85024(VarCurr)
        | v84917(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7811,axiom,
    ! [VarCurr: state_type] :
      ( v85022(VarCurr)
    <=> ( v85023(VarCurr)
        | v85026(VarCurr) ) ) ).

tff(writeUnaryOperator_3774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85026(VarCurr)
    <=> v84917(VarCurr,3) ) ).

tff(writeUnaryOperator_3773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85023(VarCurr)
    <=> v85024(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_670,axiom,
    ! [VarCurr: state_type] :
      ( v85024(VarCurr)
    <=> ( v85025(VarCurr)
        & v84917(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_669,axiom,
    ! [VarCurr: state_type] :
      ( v85025(VarCurr)
    <=> ( v84917(VarCurr,0)
        & v84917(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7810,axiom,
    ! [VarCurr: state_type] :
      ( v85009(VarCurr)
    <=> ( v84939(VarCurr)
        & v85010(VarCurr) ) ) ).

tff(writeUnaryOperator_3772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85010(VarCurr)
    <=> v85011(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_668,axiom,
    ! [VarCurr: state_type] :
      ( v85011(VarCurr)
    <=> ( v85013(VarCurr)
        | v84953(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_667,axiom,
    ! [VarCurr: state_type] :
      ( v85013(VarCurr)
    <=> ( v85014(VarCurr)
        | v84953(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_666,axiom,
    ! [VarCurr: state_type] :
      ( v85014(VarCurr)
    <=> ( v85015(VarCurr)
        | v84953(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_665,axiom,
    ! [VarCurr: state_type] :
      ( v85015(VarCurr)
    <=> ( v85016(VarCurr)
        | v84953(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_664,axiom,
    ! [VarCurr: state_type] :
      ( v85016(VarCurr)
    <=> ( v85017(VarCurr)
        | v84953(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_663,axiom,
    ! [VarCurr: state_type] :
      ( v85017(VarCurr)
    <=> ( v85018(VarCurr)
        | v84953(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_662,axiom,
    ! [VarCurr: state_type] :
      ( v85018(VarCurr)
    <=> ( v84953(VarCurr,0)
        | v84953(VarCurr,1) ) ) ).

tff(addAssignment_52308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84953(VarCurr,B)
      <=> v84955(VarCurr,B) ) ) ).

tff(addAssignment_52307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84955(VarCurr,B)
      <=> v84957(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84992(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v84957(VarNext,B)
            <=> v84957(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_952,axiom,
    ! [VarNext: state_type] :
      ( v84992(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v84957(VarNext,B)
          <=> v85002(VarNext,B) ) ) ) ).

tff(addAssignment_52306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v85002(VarNext,B)
          <=> v85000(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85003(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v85000(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_452,axiom,
    ! [VarCurr: state_type] :
      ( v85003(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v85000(VarCurr,B)
          <=> v84967(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7809,axiom,
    ! [VarCurr: state_type] :
      ( v85003(VarCurr)
    <=> ( v85004(VarCurr)
        & v85005(VarCurr) ) ) ).

tff(writeUnaryOperator_3771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85005(VarCurr)
    <=> v84963(VarCurr) ) ).

tff(writeUnaryOperator_3770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v85004(VarCurr)
    <=> v84959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84992(VarNext)
      <=> v84993(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84993(VarNext)
      <=> ( v84994(VarNext)
          & v84987(VarNext) ) ) ) ).

tff(writeUnaryOperator_3769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84994(VarNext)
      <=> v84996(VarNext) ) ) ).

tff(addAssignment_52305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84996(VarNext)
      <=> v84987(VarCurr) ) ) ).

tff(addAssignment_52304,axiom,
    ! [VarCurr: state_type] :
      ( v84987(VarCurr)
    <=> v84989(VarCurr) ) ).

tff(addAssignment_52303,axiom,
    ! [VarCurr: state_type] :
      ( v84989(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_52302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84967(VarCurr,B)
      <=> v84969(VarCurr,B) ) ) ).

tff(addAssignment_52301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84969(VarCurr,B)
      <=> v84971(VarCurr,B) ) ) ).

tff(addAssignment_52300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84971(VarCurr,B)
      <=> v84973(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84973(VarCurr,B)
      <=> ( v84975(VarCurr,B)
          & v84983(VarCurr,B) ) ) ) ).

tff(addAssignment_52299,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,0)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52298,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,1)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52297,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,2)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52296,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,3)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52295,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,4)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52294,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,5)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52293,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,6)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52292,axiom,
    ! [VarCurr: state_type] :
      ( v84983(VarCurr,7)
    <=> v84984(VarCurr) ) ).

tff(addAssignment_52291,axiom,
    ! [VarCurr: state_type] :
      ( v84984(VarCurr)
    <=> v84985(VarCurr) ) ).

tff(writeUnaryOperator_3768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84985(VarCurr)
    <=> v84979(VarCurr) ) ).

tff(addAssignment_52290,axiom,
    ! [VarCurr: state_type] :
      ( v84979(VarCurr)
    <=> v84981(VarCurr) ) ).

tff(addAssignment_52289,axiom,
    ! [VarCurr: state_type] :
      ( v84981(VarCurr)
    <=> v2900(VarCurr) ) ).

tff(addAssignment_52288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84975(VarCurr,B)
      <=> v84977(VarCurr,B) ) ) ).

tff(addAssignment_52287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v84977(VarCurr,B)
      <=> v120(VarCurr,B) ) ) ).

tff(addAssignment_52286,axiom,
    ! [VarCurr: state_type] :
      ( v84963(VarCurr)
    <=> v84965(VarCurr) ) ).

tff(addAssignment_52285,axiom,
    ! [VarCurr: state_type] :
      ( v84965(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52284,axiom,
    ! [VarCurr: state_type] :
      ( v84959(VarCurr)
    <=> v84961(VarCurr) ) ).

tff(addAssignment_52283,axiom,
    ! [VarCurr: state_type] :
      ( v84961(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7806,axiom,
    ! [VarCurr: state_type] :
      ( v84939(VarCurr)
    <=> ( v5189(VarCurr)
        & v84951(VarCurr) ) ) ).

tff(writeUnaryOperator_3767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84951(VarCurr)
    <=> v84941(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_661,axiom,
    ! [VarCurr: state_type] :
      ( v84941(VarCurr)
    <=> ( v84944(VarCurr)
        & v5165(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_660,axiom,
    ! [VarCurr: state_type] :
      ( v84944(VarCurr)
    <=> ( v84945(VarCurr)
        & v5165(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_659,axiom,
    ! [VarCurr: state_type] :
      ( v84945(VarCurr)
    <=> ( v84946(VarCurr)
        & v5165(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_658,axiom,
    ! [VarCurr: state_type] :
      ( v84946(VarCurr)
    <=> ( v84947(VarCurr)
        & v5165(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_657,axiom,
    ! [VarCurr: state_type] :
      ( v84947(VarCurr)
    <=> ( v84948(VarCurr)
        & v5165(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_656,axiom,
    ! [VarCurr: state_type] :
      ( v84948(VarCurr)
    <=> ( v84949(VarCurr)
        & v5165(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_655,axiom,
    ! [VarCurr: state_type] :
      ( v84949(VarCurr)
    <=> ( v5165(VarCurr,0)
        & v5165(VarCurr,1) ) ) ).

tff(addAssignment_52282,axiom,
    ! [VarCurr: state_type] :
      ( v84927(VarCurr)
    <=> v84929(VarCurr) ) ).

tff(addAssignment_52281,axiom,
    ! [VarCurr: state_type] :
      ( v84929(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_52280,axiom,
    ! [VarCurr: state_type] :
      ( v84923(VarCurr)
    <=> v84925(VarCurr) ) ).

tff(addAssignment_52279,axiom,
    ! [VarCurr: state_type] :
      ( v84925(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7805,axiom,
    ! [VarCurr: state_type] :
      ( v84553(VarCurr)
    <=> ( v84795(VarCurr)
        | v84894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7804,axiom,
    ! [VarCurr: state_type] :
      ( v84894(VarCurr)
    <=> ( v84583(VarCurr)
        & v84895(VarCurr) ) ) ).

tff(writeUnaryOperator_3766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84895(VarCurr)
    <=> v84753(VarCurr) ) ).

tff(writeUnaryOperator_3765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84795(VarCurr)
    <=> v84797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7803,axiom,
    ! [VarCurr: state_type] :
      ( v84797(VarCurr)
    <=> ( v84798(VarCurr)
        | v84893(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_654,axiom,
    ! [VarCurr: state_type] :
      ( v84893(VarCurr)
    <=> ( v84612(VarCurr)
        & v84692(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7802,axiom,
    ! [VarCurr: state_type] :
      ( v84798(VarCurr)
    <=> ( v84799(VarCurr)
        & v84888(VarCurr) ) ) ).

tff(writeUnaryOperator_3764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84888(VarCurr)
    <=> v84889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7801,axiom,
    ! [VarCurr: state_type] :
      ( v84889(VarCurr)
    <=> ( v84890(VarCurr)
        & v84892(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_653,axiom,
    ! [VarCurr: state_type] :
      ( v84892(VarCurr)
    <=> ( v84555(VarCurr,12)
        | v84692(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7800,axiom,
    ! [VarCurr: state_type] :
      ( v84890(VarCurr)
    <=> ( v84612(VarCurr)
        | v84891(VarCurr) ) ) ).

tff(writeUnaryOperator_3763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84891(VarCurr)
    <=> v84692(VarCurr,12) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7799,axiom,
    ! [VarCurr: state_type] :
      ( v84799(VarCurr)
    <=> ( v84800(VarCurr)
        | v84887(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_652,axiom,
    ! [VarCurr: state_type] :
      ( v84887(VarCurr)
    <=> ( v84617(VarCurr)
        & v84692(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7798,axiom,
    ! [VarCurr: state_type] :
      ( v84800(VarCurr)
    <=> ( v84801(VarCurr)
        & v84882(VarCurr) ) ) ).

tff(writeUnaryOperator_3762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84882(VarCurr)
    <=> v84883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7797,axiom,
    ! [VarCurr: state_type] :
      ( v84883(VarCurr)
    <=> ( v84884(VarCurr)
        & v84886(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_651,axiom,
    ! [VarCurr: state_type] :
      ( v84886(VarCurr)
    <=> ( v84555(VarCurr,11)
        | v84692(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7796,axiom,
    ! [VarCurr: state_type] :
      ( v84884(VarCurr)
    <=> ( v84617(VarCurr)
        | v84885(VarCurr) ) ) ).

tff(writeUnaryOperator_3761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84885(VarCurr)
    <=> v84692(VarCurr,11) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7795,axiom,
    ! [VarCurr: state_type] :
      ( v84801(VarCurr)
    <=> ( v84802(VarCurr)
        | v84881(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_650,axiom,
    ! [VarCurr: state_type] :
      ( v84881(VarCurr)
    <=> ( v84622(VarCurr)
        & v84692(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7794,axiom,
    ! [VarCurr: state_type] :
      ( v84802(VarCurr)
    <=> ( v84803(VarCurr)
        & v84876(VarCurr) ) ) ).

tff(writeUnaryOperator_3760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84876(VarCurr)
    <=> v84877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7793,axiom,
    ! [VarCurr: state_type] :
      ( v84877(VarCurr)
    <=> ( v84878(VarCurr)
        & v84880(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_649,axiom,
    ! [VarCurr: state_type] :
      ( v84880(VarCurr)
    <=> ( v84555(VarCurr,10)
        | v84692(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7792,axiom,
    ! [VarCurr: state_type] :
      ( v84878(VarCurr)
    <=> ( v84622(VarCurr)
        | v84879(VarCurr) ) ) ).

tff(writeUnaryOperator_3759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84879(VarCurr)
    <=> v84692(VarCurr,10) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7791,axiom,
    ! [VarCurr: state_type] :
      ( v84803(VarCurr)
    <=> ( v84804(VarCurr)
        | v84875(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_648,axiom,
    ! [VarCurr: state_type] :
      ( v84875(VarCurr)
    <=> ( v84627(VarCurr)
        & v84692(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7790,axiom,
    ! [VarCurr: state_type] :
      ( v84804(VarCurr)
    <=> ( v84805(VarCurr)
        & v84870(VarCurr) ) ) ).

tff(writeUnaryOperator_3758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84870(VarCurr)
    <=> v84871(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7789,axiom,
    ! [VarCurr: state_type] :
      ( v84871(VarCurr)
    <=> ( v84872(VarCurr)
        & v84874(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_647,axiom,
    ! [VarCurr: state_type] :
      ( v84874(VarCurr)
    <=> ( v84555(VarCurr,9)
        | v84692(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7788,axiom,
    ! [VarCurr: state_type] :
      ( v84872(VarCurr)
    <=> ( v84627(VarCurr)
        | v84873(VarCurr) ) ) ).

tff(writeUnaryOperator_3757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84873(VarCurr)
    <=> v84692(VarCurr,9) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7787,axiom,
    ! [VarCurr: state_type] :
      ( v84805(VarCurr)
    <=> ( v84806(VarCurr)
        | v84869(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_646,axiom,
    ! [VarCurr: state_type] :
      ( v84869(VarCurr)
    <=> ( v84632(VarCurr)
        & v84692(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7786,axiom,
    ! [VarCurr: state_type] :
      ( v84806(VarCurr)
    <=> ( v84807(VarCurr)
        & v84864(VarCurr) ) ) ).

tff(writeUnaryOperator_3756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84864(VarCurr)
    <=> v84865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7785,axiom,
    ! [VarCurr: state_type] :
      ( v84865(VarCurr)
    <=> ( v84866(VarCurr)
        & v84868(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_645,axiom,
    ! [VarCurr: state_type] :
      ( v84868(VarCurr)
    <=> ( v84555(VarCurr,8)
        | v84692(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7784,axiom,
    ! [VarCurr: state_type] :
      ( v84866(VarCurr)
    <=> ( v84632(VarCurr)
        | v84867(VarCurr) ) ) ).

tff(writeUnaryOperator_3755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84867(VarCurr)
    <=> v84692(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7783,axiom,
    ! [VarCurr: state_type] :
      ( v84807(VarCurr)
    <=> ( v84808(VarCurr)
        | v84863(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_644,axiom,
    ! [VarCurr: state_type] :
      ( v84863(VarCurr)
    <=> ( v84637(VarCurr)
        & v84692(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7782,axiom,
    ! [VarCurr: state_type] :
      ( v84808(VarCurr)
    <=> ( v84809(VarCurr)
        & v84858(VarCurr) ) ) ).

tff(writeUnaryOperator_3754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84858(VarCurr)
    <=> v84859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7781,axiom,
    ! [VarCurr: state_type] :
      ( v84859(VarCurr)
    <=> ( v84860(VarCurr)
        & v84862(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_643,axiom,
    ! [VarCurr: state_type] :
      ( v84862(VarCurr)
    <=> ( v84555(VarCurr,7)
        | v84692(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7780,axiom,
    ! [VarCurr: state_type] :
      ( v84860(VarCurr)
    <=> ( v84637(VarCurr)
        | v84861(VarCurr) ) ) ).

tff(writeUnaryOperator_3753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84861(VarCurr)
    <=> v84692(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7779,axiom,
    ! [VarCurr: state_type] :
      ( v84809(VarCurr)
    <=> ( v84810(VarCurr)
        | v84857(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_642,axiom,
    ! [VarCurr: state_type] :
      ( v84857(VarCurr)
    <=> ( v84642(VarCurr)
        & v84692(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7778,axiom,
    ! [VarCurr: state_type] :
      ( v84810(VarCurr)
    <=> ( v84811(VarCurr)
        & v84852(VarCurr) ) ) ).

tff(writeUnaryOperator_3752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84852(VarCurr)
    <=> v84853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7777,axiom,
    ! [VarCurr: state_type] :
      ( v84853(VarCurr)
    <=> ( v84854(VarCurr)
        & v84856(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_641,axiom,
    ! [VarCurr: state_type] :
      ( v84856(VarCurr)
    <=> ( v84555(VarCurr,6)
        | v84692(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7776,axiom,
    ! [VarCurr: state_type] :
      ( v84854(VarCurr)
    <=> ( v84642(VarCurr)
        | v84855(VarCurr) ) ) ).

tff(writeUnaryOperator_3751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84855(VarCurr)
    <=> v84692(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7775,axiom,
    ! [VarCurr: state_type] :
      ( v84811(VarCurr)
    <=> ( v84812(VarCurr)
        | v84851(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_640,axiom,
    ! [VarCurr: state_type] :
      ( v84851(VarCurr)
    <=> ( v84647(VarCurr)
        & v84692(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7774,axiom,
    ! [VarCurr: state_type] :
      ( v84812(VarCurr)
    <=> ( v84813(VarCurr)
        & v84846(VarCurr) ) ) ).

tff(writeUnaryOperator_3750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84846(VarCurr)
    <=> v84847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7773,axiom,
    ! [VarCurr: state_type] :
      ( v84847(VarCurr)
    <=> ( v84848(VarCurr)
        & v84850(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_639,axiom,
    ! [VarCurr: state_type] :
      ( v84850(VarCurr)
    <=> ( v84555(VarCurr,5)
        | v84692(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7772,axiom,
    ! [VarCurr: state_type] :
      ( v84848(VarCurr)
    <=> ( v84647(VarCurr)
        | v84849(VarCurr) ) ) ).

tff(writeUnaryOperator_3749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84849(VarCurr)
    <=> v84692(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7771,axiom,
    ! [VarCurr: state_type] :
      ( v84813(VarCurr)
    <=> ( v84814(VarCurr)
        | v84845(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_638,axiom,
    ! [VarCurr: state_type] :
      ( v84845(VarCurr)
    <=> ( v84652(VarCurr)
        & v84692(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7770,axiom,
    ! [VarCurr: state_type] :
      ( v84814(VarCurr)
    <=> ( v84815(VarCurr)
        & v84840(VarCurr) ) ) ).

tff(writeUnaryOperator_3748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84840(VarCurr)
    <=> v84841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7769,axiom,
    ! [VarCurr: state_type] :
      ( v84841(VarCurr)
    <=> ( v84842(VarCurr)
        & v84844(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_637,axiom,
    ! [VarCurr: state_type] :
      ( v84844(VarCurr)
    <=> ( v84555(VarCurr,4)
        | v84692(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7768,axiom,
    ! [VarCurr: state_type] :
      ( v84842(VarCurr)
    <=> ( v84652(VarCurr)
        | v84843(VarCurr) ) ) ).

tff(writeUnaryOperator_3747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84843(VarCurr)
    <=> v84692(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7767,axiom,
    ! [VarCurr: state_type] :
      ( v84815(VarCurr)
    <=> ( v84816(VarCurr)
        | v84839(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_636,axiom,
    ! [VarCurr: state_type] :
      ( v84839(VarCurr)
    <=> ( v84657(VarCurr)
        & v84692(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7766,axiom,
    ! [VarCurr: state_type] :
      ( v84816(VarCurr)
    <=> ( v84817(VarCurr)
        & v84834(VarCurr) ) ) ).

tff(writeUnaryOperator_3746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84834(VarCurr)
    <=> v84835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7765,axiom,
    ! [VarCurr: state_type] :
      ( v84835(VarCurr)
    <=> ( v84836(VarCurr)
        & v84838(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_635,axiom,
    ! [VarCurr: state_type] :
      ( v84838(VarCurr)
    <=> ( v84555(VarCurr,3)
        | v84692(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7764,axiom,
    ! [VarCurr: state_type] :
      ( v84836(VarCurr)
    <=> ( v84657(VarCurr)
        | v84837(VarCurr) ) ) ).

tff(writeUnaryOperator_3745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84837(VarCurr)
    <=> v84692(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7763,axiom,
    ! [VarCurr: state_type] :
      ( v84817(VarCurr)
    <=> ( v84818(VarCurr)
        | v84833(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_634,axiom,
    ! [VarCurr: state_type] :
      ( v84833(VarCurr)
    <=> ( v84662(VarCurr)
        & v84692(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7762,axiom,
    ! [VarCurr: state_type] :
      ( v84818(VarCurr)
    <=> ( v84819(VarCurr)
        & v84828(VarCurr) ) ) ).

tff(writeUnaryOperator_3744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84828(VarCurr)
    <=> v84829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7761,axiom,
    ! [VarCurr: state_type] :
      ( v84829(VarCurr)
    <=> ( v84830(VarCurr)
        & v84832(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_633,axiom,
    ! [VarCurr: state_type] :
      ( v84832(VarCurr)
    <=> ( v84555(VarCurr,2)
        | v84692(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7760,axiom,
    ! [VarCurr: state_type] :
      ( v84830(VarCurr)
    <=> ( v84662(VarCurr)
        | v84831(VarCurr) ) ) ).

tff(writeUnaryOperator_3743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84831(VarCurr)
    <=> v84692(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7759,axiom,
    ! [VarCurr: state_type] :
      ( v84819(VarCurr)
    <=> ( v84820(VarCurr)
        | v84827(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_632,axiom,
    ! [VarCurr: state_type] :
      ( v84827(VarCurr)
    <=> ( v84667(VarCurr)
        & v84692(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7758,axiom,
    ! [VarCurr: state_type] :
      ( v84820(VarCurr)
    <=> ( v84821(VarCurr)
        & v84822(VarCurr) ) ) ).

tff(writeUnaryOperator_3742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84822(VarCurr)
    <=> v84823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7757,axiom,
    ! [VarCurr: state_type] :
      ( v84823(VarCurr)
    <=> ( v84824(VarCurr)
        & v84826(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_631,axiom,
    ! [VarCurr: state_type] :
      ( v84826(VarCurr)
    <=> ( v84555(VarCurr,1)
        | v84692(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7756,axiom,
    ! [VarCurr: state_type] :
      ( v84824(VarCurr)
    <=> ( v84667(VarCurr)
        | v84825(VarCurr) ) ) ).

tff(writeUnaryOperator_3741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84825(VarCurr)
    <=> v84692(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7755,axiom,
    ! [VarCurr: state_type] :
      ( v84821(VarCurr)
    <=> ( v84666(VarCurr)
        & v84692(VarCurr,0) ) ) ).

tff(addAssignment_52278,axiom,
    ! [VarCurr: state_type] :
      ( v84753(VarCurr)
    <=> v84755(VarCurr) ) ).

tff(addAssignment_52277,axiom,
    ! [VarCurr: state_type] :
      ( v84755(VarCurr)
    <=> v84757(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84778(VarNext)
       => ( v84757(VarNext)
        <=> v84757(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_951,axiom,
    ! [VarNext: state_type] :
      ( v84778(VarNext)
     => ( v84757(VarNext)
      <=> v84788(VarNext) ) ) ).

tff(addAssignment_52276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84788(VarNext)
      <=> v84786(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84789(VarCurr)
     => ( v84786(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_451,axiom,
    ! [VarCurr: state_type] :
      ( v84789(VarCurr)
     => ( v84786(VarCurr)
      <=> v84767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7754,axiom,
    ! [VarCurr: state_type] :
      ( v84789(VarCurr)
    <=> ( v84790(VarCurr)
        & v84791(VarCurr) ) ) ).

tff(writeUnaryOperator_3740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84791(VarCurr)
    <=> v84763(VarCurr) ) ).

tff(writeUnaryOperator_3739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84790(VarCurr)
    <=> v84759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84778(VarNext)
      <=> v84779(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84779(VarNext)
      <=> ( v84780(VarNext)
          & v84773(VarNext) ) ) ) ).

tff(writeUnaryOperator_3738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84780(VarNext)
      <=> v84782(VarNext) ) ) ).

tff(addAssignment_52275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84782(VarNext)
      <=> v84773(VarCurr) ) ) ).

tff(addAssignment_52274,axiom,
    ! [VarCurr: state_type] :
      ( v84773(VarCurr)
    <=> v84775(VarCurr) ) ).

tff(addAssignment_52273,axiom,
    ! [VarCurr: state_type] :
      ( v84775(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52272,axiom,
    ! [VarCurr: state_type] :
      ( v84767(VarCurr)
    <=> v84769(VarCurr) ) ).

tff(addAssignment_52271,axiom,
    ! [VarCurr: state_type] :
      ( v84769(VarCurr)
    <=> v84771(VarCurr) ) ).

tff(addAssignment_52270,axiom,
    ! [VarCurr: state_type] :
      ( v84771(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(addAssignment_52269,axiom,
    ! [VarCurr: state_type] :
      ( v84763(VarCurr)
    <=> v84765(VarCurr) ) ).

tff(addAssignment_52268,axiom,
    ! [VarCurr: state_type] :
      ( v84765(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52267,axiom,
    ! [VarCurr: state_type] :
      ( v84759(VarCurr)
    <=> v84761(VarCurr) ) ).

tff(addAssignment_52266,axiom,
    ! [VarCurr: state_type] :
      ( v84761(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84692(VarCurr,B)
      <=> ( v84694(VarCurr,B)
        <~> v84716(VarCurr,B) ) ) ) ).

tff(addAssignment_52265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84694(VarCurr,B)
      <=> v84696(VarCurr,B) ) ) ).

tff(addAssignment_52264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84696(VarCurr,B)
      <=> v84698(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_950,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84735(VarNext)
       => ! [B: $int] :
            ( ( $less(B,13)
              & ~ $less(B,0) )
           => ( v84698(VarNext,B)
            <=> v84698(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_950,axiom,
    ! [VarNext: state_type] :
      ( v84735(VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84698(VarNext,B)
          <=> v84745(VarNext,B) ) ) ) ).

tff(addAssignment_52263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84745(VarNext,B)
          <=> v84743(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84746(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84743(VarCurr,B)
          <=> bxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_450,axiom,
    ! [VarCurr: state_type] :
      ( v84746(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84743(VarCurr,B)
          <=> v84708(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7751,axiom,
    ! [VarCurr: state_type] :
      ( v84746(VarCurr)
    <=> ( v84747(VarCurr)
        & v84748(VarCurr) ) ) ).

tff(writeUnaryOperator_3737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84748(VarCurr)
    <=> v84704(VarCurr) ) ).

tff(writeUnaryOperator_3736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84747(VarCurr)
    <=> v84700(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84735(VarNext)
      <=> v84736(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84736(VarNext)
      <=> ( v84737(VarNext)
          & v84730(VarNext) ) ) ) ).

tff(writeUnaryOperator_3735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84737(VarNext)
      <=> v84739(VarNext) ) ) ).

tff(addAssignment_52262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84739(VarNext)
      <=> v84730(VarCurr) ) ) ).

tff(addAssignment_52261,axiom,
    ! [VarCurr: state_type] :
      ( v84730(VarCurr)
    <=> v84732(VarCurr) ) ).

tff(addAssignment_52260,axiom,
    ! [VarCurr: state_type] :
      ( v84732(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84708(VarCurr,B)
      <=> v84710(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84710(VarCurr,B)
      <=> ( v84722(VarCurr,B)
          | v84725(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84725(VarCurr,B)
      <=> ( v84696(VarCurr,B)
          & v84726(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84726(VarCurr,B)
      <=> ~ v84727(VarCurr,B) ) ) ).

tff(addAssignment_52258,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,0)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52257,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,1)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52256,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,2)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52255,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,3)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52254,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,4)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52253,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,5)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52252,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,6)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52251,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,7)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52250,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,8)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52249,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,9)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52248,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,10)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52247,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,11)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52246,axiom,
    ! [VarCurr: state_type] :
      ( v84727(VarCurr,12)
    <=> v84728(VarCurr) ) ).

tff(addAssignment_52245,axiom,
    ! [VarCurr: state_type] :
      ( v84728(VarCurr)
    <=> v84720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84722(VarCurr,B)
      <=> ( v84712(VarCurr,B)
          & v84723(VarCurr,B) ) ) ) ).

tff(addAssignment_52244,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,0)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52243,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,1)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52242,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,2)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52241,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,3)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52240,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,4)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52239,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,5)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52238,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,6)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52237,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,7)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52236,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,8)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52235,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,9)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52234,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,10)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52233,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,11)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52232,axiom,
    ! [VarCurr: state_type] :
      ( v84723(VarCurr,12)
    <=> v84724(VarCurr) ) ).

tff(addAssignment_52231,axiom,
    ! [VarCurr: state_type] :
      ( v84724(VarCurr)
    <=> v84720(VarCurr) ) ).

tff(addAssignment_52230,axiom,
    ! [VarCurr: state_type] :
      ( v84720(VarCurr)
    <=> v84578(VarCurr) ) ).

tff(addAssignment_52229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84712(VarCurr,B)
      <=> v84714(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84714(VarCurr,B)
      <=> ( v1119(VarCurr,B)
        <~> v84716(VarCurr,B) ) ) ) ).

tff(addAssignment_52228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84716(VarCurr,B)
      <=> b0100000100000(B) ) ) ).

tff(bitBlastConstant_1101,axiom,
    ~ b0100000100000(12) ).

tff(bitBlastConstant_1100,axiom,
    b0100000100000(11) ).

tff(bitBlastConstant_1099,axiom,
    ~ b0100000100000(10) ).

tff(bitBlastConstant_1098,axiom,
    ~ b0100000100000(9) ).

tff(bitBlastConstant_1097,axiom,
    ~ b0100000100000(8) ).

tff(bitBlastConstant_1096,axiom,
    ~ b0100000100000(7) ).

tff(bitBlastConstant_1095,axiom,
    ~ b0100000100000(6) ).

tff(bitBlastConstant_1094,axiom,
    b0100000100000(5) ).

tff(bitBlastConstant_1093,axiom,
    ~ b0100000100000(4) ).

tff(bitBlastConstant_1092,axiom,
    ~ b0100000100000(3) ).

tff(bitBlastConstant_1091,axiom,
    ~ b0100000100000(2) ).

tff(bitBlastConstant_1090,axiom,
    ~ b0100000100000(1) ).

tff(bitBlastConstant_1089,axiom,
    ~ b0100000100000(0) ).

tff(addAssignment_52227,axiom,
    ! [VarCurr: state_type] :
      ( v84704(VarCurr)
    <=> v84706(VarCurr) ) ).

tff(addAssignment_52226,axiom,
    ! [VarCurr: state_type] :
      ( v84706(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52225,axiom,
    ! [VarCurr: state_type] :
      ( v84700(VarCurr)
    <=> v84702(VarCurr) ) ).

tff(addAssignment_52224,axiom,
    ! [VarCurr: state_type] :
      ( v84702(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_52223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84555(VarCurr,B)
      <=> v84557(VarCurr,B) ) ) ).

tff(addAssignment_52222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84557(VarCurr,B)
      <=> v84559(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84675(VarNext)
       => ! [B: $int] :
            ( ( $less(B,13)
              & ~ $less(B,0) )
           => ( v84559(VarNext,B)
            <=> v84559(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_949,axiom,
    ! [VarNext: state_type] :
      ( v84675(VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84559(VarNext,B)
          <=> v84685(VarNext,B) ) ) ) ).

tff(addAssignment_52221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84685(VarNext,B)
          <=> v84683(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84686(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84683(VarCurr,B)
          <=> bxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_449,axiom,
    ! [VarCurr: state_type] :
      ( v84686(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84683(VarCurr,B)
          <=> v84569(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7748,axiom,
    ! [VarCurr: state_type] :
      ( v84686(VarCurr)
    <=> ( v84687(VarCurr)
        & v84688(VarCurr) ) ) ).

tff(writeUnaryOperator_3733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84688(VarCurr)
    <=> v84565(VarCurr) ) ).

tff(writeUnaryOperator_3732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84687(VarCurr)
    <=> v84561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84675(VarNext)
      <=> v84676(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84676(VarNext)
      <=> ( v84677(VarNext)
          & v84670(VarNext) ) ) ) ).

tff(writeUnaryOperator_3731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84677(VarNext)
      <=> v84679(VarNext) ) ) ).

tff(addAssignment_52220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84679(VarNext)
      <=> v84670(VarCurr) ) ) ).

tff(addAssignment_52219,axiom,
    ! [VarCurr: state_type] :
      ( v84670(VarCurr)
    <=> v84672(VarCurr) ) ).

tff(addAssignment_52218,axiom,
    ! [VarCurr: state_type] :
      ( v84672(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84569(VarCurr,B)
      <=> v84571(VarCurr,B) ) ) ).

tff(addAssignment_52216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84571(VarCurr,B)
      <=> v84573(VarCurr,B) ) ) ).

tff(addAssignment_52215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v84573(VarCurr,B)
      <=> v84575(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84589(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84575(VarCurr,B)
          <=> v84591(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_448,axiom,
    ! [VarCurr: state_type] :
      ( v84589(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84575(VarCurr,B)
          <=> v1119(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84592(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84591(VarCurr,B)
          <=> v84596(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_447,axiom,
    ! [VarCurr: state_type] :
      ( v84592(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v84591(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_1088,axiom,
    ~ b0000000000000(12) ).

tff(bitBlastConstant_1087,axiom,
    ~ b0000000000000(11) ).

tff(bitBlastConstant_1086,axiom,
    ~ b0000000000000(10) ).

tff(bitBlastConstant_1085,axiom,
    ~ b0000000000000(9) ).

tff(bitBlastConstant_1084,axiom,
    ~ b0000000000000(8) ).

tff(bitBlastConstant_1083,axiom,
    ~ b0000000000000(7) ).

tff(bitBlastConstant_1082,axiom,
    ~ b0000000000000(6) ).

tff(bitBlastConstant_1081,axiom,
    ~ b0000000000000(5) ).

tff(bitBlastConstant_1080,axiom,
    ~ b0000000000000(4) ).

tff(bitBlastConstant_1079,axiom,
    ~ b0000000000000(3) ).

tff(bitBlastConstant_1078,axiom,
    ~ b0000000000000(2) ).

tff(bitBlastConstant_1077,axiom,
    ~ b0000000000000(1) ).

tff(bitBlastConstant_1076,axiom,
    ~ b0000000000000(0) ).

tff(addAssignment_52214,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,0)
    <=> v84666(VarCurr) ) ).

tff(addAssignment_52213,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,1)
    <=> v84664(VarCurr) ) ).

tff(addAssignment_52212,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,2)
    <=> v84659(VarCurr) ) ).

tff(addAssignment_52211,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,3)
    <=> v84654(VarCurr) ) ).

tff(addAssignment_52210,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,4)
    <=> v84649(VarCurr) ) ).

tff(addAssignment_52209,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,5)
    <=> v84644(VarCurr) ) ).

tff(addAssignment_52208,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,6)
    <=> v84639(VarCurr) ) ).

tff(addAssignment_52207,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,7)
    <=> v84634(VarCurr) ) ).

tff(addAssignment_52206,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,8)
    <=> v84629(VarCurr) ) ).

tff(addAssignment_52205,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,9)
    <=> v84624(VarCurr) ) ).

tff(addAssignment_52204,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,10)
    <=> v84619(VarCurr) ) ).

tff(addAssignment_52203,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,11)
    <=> v84614(VarCurr) ) ).

tff(addAssignment_52202,axiom,
    ! [VarCurr: state_type] :
      ( v84596(VarCurr,12)
    <=> v84598(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7745,axiom,
    ! [VarCurr: state_type] :
      ( v84664(VarCurr)
    <=> ( v84665(VarCurr)
        & v84668(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_630,axiom,
    ! [VarCurr: state_type] :
      ( v84668(VarCurr)
    <=> ( v84555(VarCurr,0)
        | v84555(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7744,axiom,
    ! [VarCurr: state_type] :
      ( v84665(VarCurr)
    <=> ( v84666(VarCurr)
        | v84667(VarCurr) ) ) ).

tff(writeUnaryOperator_3730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84667(VarCurr)
    <=> v84555(VarCurr,1) ) ).

tff(writeUnaryOperator_3729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84666(VarCurr)
    <=> v84555(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7743,axiom,
    ! [VarCurr: state_type] :
      ( v84659(VarCurr)
    <=> ( v84660(VarCurr)
        & v84663(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_629,axiom,
    ! [VarCurr: state_type] :
      ( v84663(VarCurr)
    <=> ( v84611(VarCurr)
        | v84555(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7742,axiom,
    ! [VarCurr: state_type] :
      ( v84660(VarCurr)
    <=> ( v84661(VarCurr)
        | v84662(VarCurr) ) ) ).

tff(writeUnaryOperator_3728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84662(VarCurr)
    <=> v84555(VarCurr,2) ) ).

tff(writeUnaryOperator_3727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84661(VarCurr)
    <=> v84611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7741,axiom,
    ! [VarCurr: state_type] :
      ( v84654(VarCurr)
    <=> ( v84655(VarCurr)
        & v84658(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_628,axiom,
    ! [VarCurr: state_type] :
      ( v84658(VarCurr)
    <=> ( v84610(VarCurr)
        | v84555(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7740,axiom,
    ! [VarCurr: state_type] :
      ( v84655(VarCurr)
    <=> ( v84656(VarCurr)
        | v84657(VarCurr) ) ) ).

tff(writeUnaryOperator_3726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84657(VarCurr)
    <=> v84555(VarCurr,3) ) ).

tff(writeUnaryOperator_3725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84656(VarCurr)
    <=> v84610(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7739,axiom,
    ! [VarCurr: state_type] :
      ( v84649(VarCurr)
    <=> ( v84650(VarCurr)
        & v84653(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_627,axiom,
    ! [VarCurr: state_type] :
      ( v84653(VarCurr)
    <=> ( v84609(VarCurr)
        | v84555(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7738,axiom,
    ! [VarCurr: state_type] :
      ( v84650(VarCurr)
    <=> ( v84651(VarCurr)
        | v84652(VarCurr) ) ) ).

tff(writeUnaryOperator_3724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84652(VarCurr)
    <=> v84555(VarCurr,4) ) ).

tff(writeUnaryOperator_3723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84651(VarCurr)
    <=> v84609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7737,axiom,
    ! [VarCurr: state_type] :
      ( v84644(VarCurr)
    <=> ( v84645(VarCurr)
        & v84648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_626,axiom,
    ! [VarCurr: state_type] :
      ( v84648(VarCurr)
    <=> ( v84608(VarCurr)
        | v84555(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7736,axiom,
    ! [VarCurr: state_type] :
      ( v84645(VarCurr)
    <=> ( v84646(VarCurr)
        | v84647(VarCurr) ) ) ).

tff(writeUnaryOperator_3722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84647(VarCurr)
    <=> v84555(VarCurr,5) ) ).

tff(writeUnaryOperator_3721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84646(VarCurr)
    <=> v84608(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7735,axiom,
    ! [VarCurr: state_type] :
      ( v84639(VarCurr)
    <=> ( v84640(VarCurr)
        & v84643(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_625,axiom,
    ! [VarCurr: state_type] :
      ( v84643(VarCurr)
    <=> ( v84607(VarCurr)
        | v84555(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7734,axiom,
    ! [VarCurr: state_type] :
      ( v84640(VarCurr)
    <=> ( v84641(VarCurr)
        | v84642(VarCurr) ) ) ).

tff(writeUnaryOperator_3720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84642(VarCurr)
    <=> v84555(VarCurr,6) ) ).

tff(writeUnaryOperator_3719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84641(VarCurr)
    <=> v84607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7733,axiom,
    ! [VarCurr: state_type] :
      ( v84634(VarCurr)
    <=> ( v84635(VarCurr)
        & v84638(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_624,axiom,
    ! [VarCurr: state_type] :
      ( v84638(VarCurr)
    <=> ( v84606(VarCurr)
        | v84555(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7732,axiom,
    ! [VarCurr: state_type] :
      ( v84635(VarCurr)
    <=> ( v84636(VarCurr)
        | v84637(VarCurr) ) ) ).

tff(writeUnaryOperator_3718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84637(VarCurr)
    <=> v84555(VarCurr,7) ) ).

tff(writeUnaryOperator_3717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84636(VarCurr)
    <=> v84606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7731,axiom,
    ! [VarCurr: state_type] :
      ( v84629(VarCurr)
    <=> ( v84630(VarCurr)
        & v84633(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_623,axiom,
    ! [VarCurr: state_type] :
      ( v84633(VarCurr)
    <=> ( v84605(VarCurr)
        | v84555(VarCurr,8) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7730,axiom,
    ! [VarCurr: state_type] :
      ( v84630(VarCurr)
    <=> ( v84631(VarCurr)
        | v84632(VarCurr) ) ) ).

tff(writeUnaryOperator_3716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84632(VarCurr)
    <=> v84555(VarCurr,8) ) ).

tff(writeUnaryOperator_3715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84631(VarCurr)
    <=> v84605(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7729,axiom,
    ! [VarCurr: state_type] :
      ( v84624(VarCurr)
    <=> ( v84625(VarCurr)
        & v84628(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_622,axiom,
    ! [VarCurr: state_type] :
      ( v84628(VarCurr)
    <=> ( v84604(VarCurr)
        | v84555(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7728,axiom,
    ! [VarCurr: state_type] :
      ( v84625(VarCurr)
    <=> ( v84626(VarCurr)
        | v84627(VarCurr) ) ) ).

tff(writeUnaryOperator_3714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84627(VarCurr)
    <=> v84555(VarCurr,9) ) ).

tff(writeUnaryOperator_3713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84626(VarCurr)
    <=> v84604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7727,axiom,
    ! [VarCurr: state_type] :
      ( v84619(VarCurr)
    <=> ( v84620(VarCurr)
        & v84623(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_621,axiom,
    ! [VarCurr: state_type] :
      ( v84623(VarCurr)
    <=> ( v84603(VarCurr)
        | v84555(VarCurr,10) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7726,axiom,
    ! [VarCurr: state_type] :
      ( v84620(VarCurr)
    <=> ( v84621(VarCurr)
        | v84622(VarCurr) ) ) ).

tff(writeUnaryOperator_3712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84622(VarCurr)
    <=> v84555(VarCurr,10) ) ).

tff(writeUnaryOperator_3711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84621(VarCurr)
    <=> v84603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7725,axiom,
    ! [VarCurr: state_type] :
      ( v84614(VarCurr)
    <=> ( v84615(VarCurr)
        & v84618(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_620,axiom,
    ! [VarCurr: state_type] :
      ( v84618(VarCurr)
    <=> ( v84602(VarCurr)
        | v84555(VarCurr,11) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7724,axiom,
    ! [VarCurr: state_type] :
      ( v84615(VarCurr)
    <=> ( v84616(VarCurr)
        | v84617(VarCurr) ) ) ).

tff(writeUnaryOperator_3710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84617(VarCurr)
    <=> v84555(VarCurr,11) ) ).

tff(writeUnaryOperator_3709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84616(VarCurr)
    <=> v84602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7723,axiom,
    ! [VarCurr: state_type] :
      ( v84598(VarCurr)
    <=> ( v84599(VarCurr)
        & v84613(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_619,axiom,
    ! [VarCurr: state_type] :
      ( v84613(VarCurr)
    <=> ( v84601(VarCurr)
        | v84555(VarCurr,12) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7722,axiom,
    ! [VarCurr: state_type] :
      ( v84599(VarCurr)
    <=> ( v84600(VarCurr)
        | v84612(VarCurr) ) ) ).

tff(writeUnaryOperator_3708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84612(VarCurr)
    <=> v84555(VarCurr,12) ) ).

tff(writeUnaryOperator_3707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84600(VarCurr)
    <=> v84601(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_618,axiom,
    ! [VarCurr: state_type] :
      ( v84601(VarCurr)
    <=> ( v84602(VarCurr)
        & v84555(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_617,axiom,
    ! [VarCurr: state_type] :
      ( v84602(VarCurr)
    <=> ( v84603(VarCurr)
        & v84555(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_616,axiom,
    ! [VarCurr: state_type] :
      ( v84603(VarCurr)
    <=> ( v84604(VarCurr)
        & v84555(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_615,axiom,
    ! [VarCurr: state_type] :
      ( v84604(VarCurr)
    <=> ( v84605(VarCurr)
        & v84555(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_614,axiom,
    ! [VarCurr: state_type] :
      ( v84605(VarCurr)
    <=> ( v84606(VarCurr)
        & v84555(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_613,axiom,
    ! [VarCurr: state_type] :
      ( v84606(VarCurr)
    <=> ( v84607(VarCurr)
        & v84555(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_612,axiom,
    ! [VarCurr: state_type] :
      ( v84607(VarCurr)
    <=> ( v84608(VarCurr)
        & v84555(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_611,axiom,
    ! [VarCurr: state_type] :
      ( v84608(VarCurr)
    <=> ( v84609(VarCurr)
        & v84555(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_610,axiom,
    ! [VarCurr: state_type] :
      ( v84609(VarCurr)
    <=> ( v84610(VarCurr)
        & v84555(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_609,axiom,
    ! [VarCurr: state_type] :
      ( v84610(VarCurr)
    <=> ( v84611(VarCurr)
        & v84555(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_608,axiom,
    ! [VarCurr: state_type] :
      ( v84611(VarCurr)
    <=> ( v84555(VarCurr,0)
        & v84555(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7721,axiom,
    ! [VarCurr: state_type] :
      ( v84592(VarCurr)
    <=> ( v84593(VarCurr)
        | v84321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7720,axiom,
    ! [VarCurr: state_type] :
      ( v84593(VarCurr)
    <=> ( v84594(VarCurr)
        | v84595(VarCurr) ) ) ).

tff(writeUnaryOperator_3706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84595(VarCurr)
    <=> v84583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7719,axiom,
    ! [VarCurr: state_type] :
      ( v84594(VarCurr)
    <=> ( v84553(VarCurr)
        | v84578(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7718,axiom,
    ! [VarCurr: state_type] :
      ( v84589(VarCurr)
    <=> ( v1729(VarCurr)
        & v84590(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_354,axiom,
    ! [VarCurr: state_type] :
      ( v84590(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1075,axiom,
    ~ b0000000111000(12) ).

tff(bitBlastConstant_1074,axiom,
    ~ b0000000111000(11) ).

tff(bitBlastConstant_1073,axiom,
    ~ b0000000111000(10) ).

tff(bitBlastConstant_1072,axiom,
    ~ b0000000111000(9) ).

tff(bitBlastConstant_1071,axiom,
    ~ b0000000111000(8) ).

tff(bitBlastConstant_1070,axiom,
    ~ b0000000111000(7) ).

tff(bitBlastConstant_1069,axiom,
    ~ b0000000111000(6) ).

tff(bitBlastConstant_1068,axiom,
    b0000000111000(5) ).

tff(bitBlastConstant_1067,axiom,
    b0000000111000(4) ).

tff(bitBlastConstant_1066,axiom,
    b0000000111000(3) ).

tff(bitBlastConstant_1065,axiom,
    ~ b0000000111000(2) ).

tff(bitBlastConstant_1064,axiom,
    ~ b0000000111000(1) ).

tff(bitBlastConstant_1063,axiom,
    ~ b0000000111000(0) ).

tff(addAssignment_52201,axiom,
    ! [VarCurr: state_type] :
      ( v84583(VarCurr)
    <=> v84585(VarCurr) ) ).

tff(addAssignment_52200,axiom,
    ! [VarCurr: state_type] :
      ( v84585(VarCurr)
    <=> v4574(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7717,axiom,
    ! [VarCurr: state_type] :
      ( v84578(VarCurr)
    <=> ( v1729(VarCurr)
        & v84581(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_353,axiom,
    ! [VarCurr: state_type] :
      ( v84581(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1062,axiom,
    ~ b0000000100000(12) ).

tff(bitBlastConstant_1061,axiom,
    ~ b0000000100000(11) ).

tff(bitBlastConstant_1060,axiom,
    ~ b0000000100000(10) ).

tff(bitBlastConstant_1059,axiom,
    ~ b0000000100000(9) ).

tff(bitBlastConstant_1058,axiom,
    ~ b0000000100000(8) ).

tff(bitBlastConstant_1057,axiom,
    ~ b0000000100000(7) ).

tff(bitBlastConstant_1056,axiom,
    ~ b0000000100000(6) ).

tff(bitBlastConstant_1055,axiom,
    b0000000100000(5) ).

tff(bitBlastConstant_1054,axiom,
    ~ b0000000100000(4) ).

tff(bitBlastConstant_1053,axiom,
    ~ b0000000100000(3) ).

tff(bitBlastConstant_1052,axiom,
    ~ b0000000100000(2) ).

tff(bitBlastConstant_1051,axiom,
    ~ b0000000100000(1) ).

tff(bitBlastConstant_1050,axiom,
    ~ b0000000100000(0) ).

tff(addAssignment_52199,axiom,
    ! [VarCurr: state_type] :
      ( v84565(VarCurr)
    <=> v84567(VarCurr) ) ).

tff(addAssignment_52198,axiom,
    ! [VarCurr: state_type] :
      ( v84567(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52197,axiom,
    ! [VarCurr: state_type] :
      ( v84561(VarCurr)
    <=> v84563(VarCurr) ) ).

tff(addAssignment_52196,axiom,
    ! [VarCurr: state_type] :
      ( v84563(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeUnaryOperator_3705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84488(VarCurr)
    <=> v84490(VarCurr) ) ).

tff(addAssignment_52195,axiom,
    ! [VarCurr: state_type] :
      ( v84490(VarCurr)
    <=> v84492(VarCurr) ) ).

tff(addAssignment_52194,axiom,
    ! [VarCurr: state_type] :
      ( v84492(VarCurr)
    <=> v84494(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84535(VarNext)
       => ( v84494(VarNext)
        <=> v84494(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_948,axiom,
    ! [VarNext: state_type] :
      ( v84535(VarNext)
     => ( v84494(VarNext)
      <=> v84545(VarNext) ) ) ).

tff(addAssignment_52193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84545(VarNext)
      <=> v84543(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84546(VarCurr)
     => ( v84543(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_446,axiom,
    ! [VarCurr: state_type] :
      ( v84546(VarCurr)
     => ( v84543(VarCurr)
      <=> v84504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7716,axiom,
    ! [VarCurr: state_type] :
      ( v84546(VarCurr)
    <=> ( v84547(VarCurr)
        & v84548(VarCurr) ) ) ).

tff(writeUnaryOperator_3704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84548(VarCurr)
    <=> v84500(VarCurr) ) ).

tff(writeUnaryOperator_3703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84547(VarCurr)
    <=> v84496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84535(VarNext)
      <=> v84536(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84536(VarNext)
      <=> ( v84537(VarNext)
          & v84530(VarNext) ) ) ) ).

tff(writeUnaryOperator_3702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84537(VarNext)
      <=> v84539(VarNext) ) ) ).

tff(addAssignment_52192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84539(VarNext)
      <=> v84530(VarCurr) ) ) ).

tff(addAssignment_52191,axiom,
    ! [VarCurr: state_type] :
      ( v84530(VarCurr)
    <=> v84532(VarCurr) ) ).

tff(addAssignment_52190,axiom,
    ! [VarCurr: state_type] :
      ( v84532(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52189,axiom,
    ! [VarCurr: state_type] :
      ( v84504(VarCurr)
    <=> v84506(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7713,axiom,
    ! [VarCurr: state_type] :
      ( v84506(VarCurr)
    <=> ( v84522(VarCurr)
        | v84525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7712,axiom,
    ! [VarCurr: state_type] :
      ( v84525(VarCurr)
    <=> ( v84492(VarCurr)
        & v84526(VarCurr) ) ) ).

tff(writeUnaryOperator_3701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84526(VarCurr)
    <=> v84527(VarCurr) ) ).

tff(addAssignment_52188,axiom,
    ! [VarCurr: state_type] :
      ( v84527(VarCurr)
    <=> v84528(VarCurr) ) ).

tff(addAssignment_52187,axiom,
    ! [VarCurr: state_type] :
      ( v84528(VarCurr)
    <=> v84515(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7711,axiom,
    ! [VarCurr: state_type] :
      ( v84522(VarCurr)
    <=> ( v84508(VarCurr)
        & v84523(VarCurr) ) ) ).

tff(addAssignment_52186,axiom,
    ! [VarCurr: state_type] :
      ( v84523(VarCurr)
    <=> v84524(VarCurr) ) ).

tff(addAssignment_52185,axiom,
    ! [VarCurr: state_type] :
      ( v84524(VarCurr)
    <=> v84515(VarCurr) ) ).

tff(addAssignment_52184,axiom,
    ! [VarCurr: state_type] :
      ( v84515(VarCurr)
    <=> v84517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7710,axiom,
    ! [VarCurr: state_type] :
      ( v84517(VarCurr)
    <=> ( v1729(VarCurr)
        & v84520(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_352,axiom,
    ! [VarCurr: state_type] :
      ( v84520(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $true )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1049,axiom,
    ~ b0000110100000(12) ).

tff(bitBlastConstant_1048,axiom,
    ~ b0000110100000(11) ).

tff(bitBlastConstant_1047,axiom,
    ~ b0000110100000(10) ).

tff(bitBlastConstant_1046,axiom,
    ~ b0000110100000(9) ).

tff(bitBlastConstant_1045,axiom,
    b0000110100000(8) ).

tff(bitBlastConstant_1044,axiom,
    b0000110100000(7) ).

tff(bitBlastConstant_1043,axiom,
    ~ b0000110100000(6) ).

tff(bitBlastConstant_1042,axiom,
    b0000110100000(5) ).

tff(bitBlastConstant_1041,axiom,
    ~ b0000110100000(4) ).

tff(bitBlastConstant_1040,axiom,
    ~ b0000110100000(3) ).

tff(bitBlastConstant_1039,axiom,
    ~ b0000110100000(2) ).

tff(bitBlastConstant_1038,axiom,
    ~ b0000110100000(1) ).

tff(bitBlastConstant_1037,axiom,
    ~ b0000110100000(0) ).

tff(addAssignment_52183,axiom,
    ! [VarCurr: state_type] :
      ( v84508(VarCurr)
    <=> v84510(VarCurr) ) ).

tff(writeUnaryOperator_3700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84510(VarCurr)
    <=> v84512(VarCurr) ) ).

tff(addAssignment_52182,axiom,
    ! [VarCurr: state_type] :
      ( v84512(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_52181,axiom,
    ! [VarCurr: state_type] :
      ( v84500(VarCurr)
    <=> v84502(VarCurr) ) ).

tff(addAssignment_52180,axiom,
    ! [VarCurr: state_type] :
      ( v84502(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52179,axiom,
    ! [VarCurr: state_type] :
      ( v84496(VarCurr)
    <=> v84498(VarCurr) ) ).

tff(addAssignment_52178,axiom,
    ! [VarCurr: state_type] :
      ( v84498(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_52177,axiom,
    ! [VarCurr: state_type] :
      ( v84321(VarCurr)
    <=> v84323(VarCurr) ) ).

tff(addAssignment_52176,axiom,
    ! [VarCurr: state_type] :
      ( v84323(VarCurr)
    <=> v84325(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84471(VarNext)
       => ( v84325(VarNext)
        <=> v84325(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_947,axiom,
    ! [VarNext: state_type] :
      ( v84471(VarNext)
     => ( v84325(VarNext)
      <=> v84481(VarNext) ) ) ).

tff(addAssignment_52175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84481(VarNext)
      <=> v84479(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84482(VarCurr)
     => ( v84479(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_445,axiom,
    ! [VarCurr: state_type] :
      ( v84482(VarCurr)
     => ( v84479(VarCurr)
      <=> v84335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7709,axiom,
    ! [VarCurr: state_type] :
      ( v84482(VarCurr)
    <=> ( v84483(VarCurr)
        & v84484(VarCurr) ) ) ).

tff(writeUnaryOperator_3699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84484(VarCurr)
    <=> v84331(VarCurr) ) ).

tff(writeUnaryOperator_3698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84483(VarCurr)
    <=> v84327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84471(VarNext)
      <=> v84472(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84472(VarNext)
      <=> ( v84473(VarNext)
          & v84466(VarNext) ) ) ) ).

tff(writeUnaryOperator_3697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84473(VarNext)
      <=> v84475(VarNext) ) ) ).

tff(addAssignment_52174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84475(VarNext)
      <=> v84466(VarCurr) ) ) ).

tff(addAssignment_52173,axiom,
    ! [VarCurr: state_type] :
      ( v84466(VarCurr)
    <=> v84468(VarCurr) ) ).

tff(addAssignment_52172,axiom,
    ! [VarCurr: state_type] :
      ( v84468(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52171,axiom,
    ! [VarCurr: state_type] :
      ( v84335(VarCurr)
    <=> v84337(VarCurr) ) ).

tff(addAssignment_52170,axiom,
    ! [VarCurr: state_type] :
      ( v84337(VarCurr)
    <=> v84339(VarCurr) ) ).

tff(addAssignment_52169,axiom,
    ! [VarCurr: state_type] :
      ( v84339(VarCurr)
    <=> v84341(VarCurr) ) ).

tff(addAssignment_52168,axiom,
    ! [VarCurr: state_type] :
      ( v84341(VarCurr)
    <=> v84343(VarCurr) ) ).

tff(addAssignment_52167,axiom,
    ! [VarCurr: state_type] :
      ( v84343(VarCurr)
    <=> v84345(VarCurr) ) ).

tff(addAssignment_52166,axiom,
    ! [VarCurr: state_type] :
      ( v84345(VarCurr)
    <=> v84347(VarCurr) ) ).

tff(addAssignment_52165,axiom,
    ! [VarCurr: state_type] :
      ( v84347(VarCurr)
    <=> v84349(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84449(VarNext)
       => ( v84349(VarNext)
        <=> v84349(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_946,axiom,
    ! [VarNext: state_type] :
      ( v84449(VarNext)
     => ( v84349(VarNext)
      <=> v84459(VarNext) ) ) ).

tff(addAssignment_52164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84459(VarNext)
      <=> v84457(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84460(VarCurr)
     => ( v84457(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_444,axiom,
    ! [VarCurr: state_type] :
      ( v84460(VarCurr)
     => ( v84457(VarCurr)
      <=> v84359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7706,axiom,
    ! [VarCurr: state_type] :
      ( v84460(VarCurr)
    <=> ( v84461(VarCurr)
        & v84462(VarCurr) ) ) ).

tff(writeUnaryOperator_3696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84462(VarCurr)
    <=> v84355(VarCurr) ) ).

tff(writeUnaryOperator_3695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84461(VarCurr)
    <=> v84351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84449(VarNext)
      <=> v84450(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84450(VarNext)
      <=> ( v84451(VarNext)
          & v84444(VarNext) ) ) ) ).

tff(writeUnaryOperator_3694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84451(VarNext)
      <=> v84453(VarNext) ) ) ).

tff(addAssignment_52163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84453(VarNext)
      <=> v84444(VarCurr) ) ) ).

tff(addAssignment_52162,axiom,
    ! [VarCurr: state_type] :
      ( v84444(VarCurr)
    <=> v84446(VarCurr) ) ).

tff(addAssignment_52161,axiom,
    ! [VarCurr: state_type] :
      ( v84446(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_52160,axiom,
    ! [VarCurr: state_type] :
      ( v84359(VarCurr)
    <=> v84361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7703,axiom,
    ! [VarCurr: state_type] :
      ( v84361(VarCurr)
    <=> ( v84436(VarCurr)
        | v84439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7702,axiom,
    ! [VarCurr: state_type] :
      ( v84439(VarCurr)
    <=> ( v84347(VarCurr)
        & v84440(VarCurr) ) ) ).

tff(writeUnaryOperator_3693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84440(VarCurr)
    <=> v84441(VarCurr) ) ).

tff(addAssignment_52159,axiom,
    ! [VarCurr: state_type] :
      ( v84441(VarCurr)
    <=> v84442(VarCurr) ) ).

tff(addAssignment_52158,axiom,
    ! [VarCurr: state_type] :
      ( v84442(VarCurr)
    <=> v84434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7701,axiom,
    ! [VarCurr: state_type] :
      ( v84436(VarCurr)
    <=> ( v84363(VarCurr)
        & v84437(VarCurr) ) ) ).

tff(addAssignment_52157,axiom,
    ! [VarCurr: state_type] :
      ( v84437(VarCurr)
    <=> v84438(VarCurr) ) ).

tff(addAssignment_52156,axiom,
    ! [VarCurr: state_type] :
      ( v84438(VarCurr)
    <=> v84434(VarCurr) ) ).

tff(addAssignment_52155,axiom,
    ! [VarCurr: state_type] :
      ( v84434(VarCurr)
    <=> v1609(VarCurr) ) ).

tff(addAssignment_52154,axiom,
    ! [VarCurr: state_type] :
      ( v84363(VarCurr)
    <=> v84365(VarCurr) ) ).

tff(addAssignment_52153,axiom,
    ! [VarCurr: state_type] :
      ( v84365(VarCurr)
    <=> v84367(VarCurr) ) ).

tff(addAssignment_52152,axiom,
    ! [VarCurr: state_type] :
      ( v84367(VarCurr)
    <=> v84369(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84416(VarNext)
       => ( v84369(VarNext)
        <=> v84369(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_945,axiom,
    ! [VarNext: state_type] :
      ( v84416(VarNext)
     => ( v84369(VarNext)
      <=> v84426(VarNext) ) ) ).

tff(addAssignment_52151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84426(VarNext)
      <=> v84424(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84427(VarCurr)
     => ( v84424(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_443,axiom,
    ! [VarCurr: state_type] :
      ( v84427(VarCurr)
     => ( v84424(VarCurr)
      <=> v84379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7700,axiom,
    ! [VarCurr: state_type] :
      ( v84427(VarCurr)
    <=> ( v84428(VarCurr)
        & v84429(VarCurr) ) ) ).

tff(writeUnaryOperator_3692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84429(VarCurr)
    <=> v84375(VarCurr) ) ).

tff(writeUnaryOperator_3691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84428(VarCurr)
    <=> v84371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84416(VarNext)
      <=> v84417(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84417(VarNext)
      <=> ( v84418(VarNext)
          & v84411(VarNext) ) ) ) ).

tff(writeUnaryOperator_3690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84418(VarNext)
      <=> v84420(VarNext) ) ) ).

tff(addAssignment_52150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84420(VarNext)
      <=> v84411(VarCurr) ) ) ).

tff(addAssignment_52149,axiom,
    ! [VarCurr: state_type] :
      ( v84411(VarCurr)
    <=> v84413(VarCurr) ) ).

tff(addAssignment_52148,axiom,
    ! [VarCurr: state_type] :
      ( v84413(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_52147,axiom,
    ! [VarCurr: state_type] :
      ( v84379(VarCurr)
    <=> v84381(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7697,axiom,
    ! [VarCurr: state_type] :
      ( v84381(VarCurr)
    <=> ( v84403(VarCurr)
        | v84406(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7696,axiom,
    ! [VarCurr: state_type] :
      ( v84406(VarCurr)
    <=> ( v84367(VarCurr)
        & v84407(VarCurr) ) ) ).

tff(writeUnaryOperator_3689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84407(VarCurr)
    <=> v84408(VarCurr) ) ).

tff(addAssignment_52146,axiom,
    ! [VarCurr: state_type] :
      ( v84408(VarCurr)
    <=> v84409(VarCurr) ) ).

tff(addAssignment_52145,axiom,
    ! [VarCurr: state_type] :
      ( v84409(VarCurr)
    <=> v84395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7695,axiom,
    ! [VarCurr: state_type] :
      ( v84403(VarCurr)
    <=> ( v84383(VarCurr)
        & v84404(VarCurr) ) ) ).

tff(addAssignment_52144,axiom,
    ! [VarCurr: state_type] :
      ( v84404(VarCurr)
    <=> v84405(VarCurr) ) ).

tff(addAssignment_52143,axiom,
    ! [VarCurr: state_type] :
      ( v84405(VarCurr)
    <=> v84395(VarCurr) ) ).

tff(addAssignment_52142,axiom,
    ! [VarCurr: state_type] :
      ( v84395(VarCurr)
    <=> v84397(VarCurr) ) ).

tff(addAssignment_52141,axiom,
    ! [VarCurr: state_type] :
      ( v84397(VarCurr)
    <=> v84399(VarCurr,1) ) ).

tff(addAssignment_52140,axiom,
    ! [VarCurr: state_type] :
      ( v84399(VarCurr,1)
    <=> v84401(VarCurr,1) ) ).

tff(addAssignment_52139,axiom,
    ! [VarCurr: state_type] :
      ( v84383(VarCurr)
    <=> v84385(VarCurr) ) ).

tff(addAssignment_52138,axiom,
    ! [VarCurr: state_type] :
      ( v84385(VarCurr)
    <=> v84387(VarCurr) ) ).

tff(addAssignment_52137,axiom,
    ! [VarCurr: state_type] :
      ( v84387(VarCurr)
    <=> v84389(VarCurr) ) ).

tff(addAssignment_52136,axiom,
    ! [VarCurr: state_type] :
      ( v84389(VarCurr)
    <=> v84391(VarCurr) ) ).

tff(addAssignment_52135,axiom,
    ! [VarCurr: state_type] :
      ( v84391(VarCurr)
    <=> v84393(VarCurr) ) ).

tff(addAssignment_52134,axiom,
    ! [VarCurr: state_type] :
      ( v84375(VarCurr)
    <=> v84377(VarCurr) ) ).

tff(addAssignment_52133,axiom,
    ! [VarCurr: state_type] :
      ( v84377(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_52132,axiom,
    ! [VarCurr: state_type] :
      ( v84371(VarCurr)
    <=> v84373(VarCurr) ) ).

tff(addAssignment_52131,axiom,
    ! [VarCurr: state_type] :
      ( v84373(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_52130,axiom,
    ! [VarCurr: state_type] :
      ( v84355(VarCurr)
    <=> v84357(VarCurr) ) ).

tff(addAssignment_52129,axiom,
    ! [VarCurr: state_type] :
      ( v84357(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_52128,axiom,
    ! [VarCurr: state_type] :
      ( v84351(VarCurr)
    <=> v84353(VarCurr) ) ).

tff(addAssignment_52127,axiom,
    ! [VarCurr: state_type] :
      ( v84353(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_52126,axiom,
    ! [VarCurr: state_type] :
      ( v84331(VarCurr)
    <=> v84333(VarCurr) ) ).

tff(addAssignment_52125,axiom,
    ! [VarCurr: state_type] :
      ( v84333(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52124,axiom,
    ! [VarCurr: state_type] :
      ( v84327(VarCurr)
    <=> v84329(VarCurr) ) ).

tff(addAssignment_52123,axiom,
    ! [VarCurr: state_type] :
      ( v84329(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_52122,axiom,
    ! [VarCurr: state_type] :
      ( v84309(VarCurr)
    <=> v84311(VarCurr) ) ).

tff(addAssignment_52121,axiom,
    ! [VarCurr: state_type] :
      ( v84311(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52120,axiom,
    ! [VarCurr: state_type] :
      ( v84305(VarCurr)
    <=> v84307(VarCurr) ) ).

tff(addAssignment_52119,axiom,
    ! [VarCurr: state_type] :
      ( v84307(VarCurr)
    <=> v18(VarCurr) ) ).

tff(writeUnaryOperator_3688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84185(VarCurr)
    <=> v84187(VarCurr) ) ).

tff(addAssignment_52118,axiom,
    ! [VarCurr: state_type] :
      ( v84187(VarCurr)
    <=> v84189(VarCurr) ) ).

tff(addAssignment_52117,axiom,
    ! [VarCurr: state_type] :
      ( v84189(VarCurr)
    <=> v84191(VarCurr) ) ).

tff(addAssignment_52116,axiom,
    ! [VarCurr: state_type] :
      ( v84191(VarCurr)
    <=> v84193(VarCurr,0) ) ).

tff(addAssignment_52115,axiom,
    ! [VarCurr: state_type] :
      ( v84193(VarCurr,0)
    <=> v84195(VarCurr,0) ) ).

tff(addAssignment_52114,axiom,
    ! [VarNext: state_type] :
      ( v84195(VarNext,0)
    <=> v84286(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_944,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84287(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84286(VarNext,B)
            <=> v84195(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_944,axiom,
    ! [VarNext: state_type] :
      ( v84287(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84286(VarNext,B)
          <=> v84268(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84287(VarNext)
      <=> v84288(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84288(VarNext)
      <=> ( v84290(VarNext)
          & v84253(VarNext) ) ) ) ).

tff(writeUnaryOperator_3687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84290(VarNext)
      <=> v84262(VarNext) ) ) ).

tff(addAssignment_52113,axiom,
    ! [VarCurr: state_type] :
      ( v84205(VarCurr,0)
    <=> v84207(VarCurr,0) ) ).

tff(addAssignment_52112,axiom,
    ! [VarCurr: state_type] :
      ( v84207(VarCurr,0)
    <=> v84209(VarCurr,0) ) ).

tff(addAssignment_52111,axiom,
    ! [VarCurr: state_type] :
      ( v84209(VarCurr,0)
    <=> v84251(VarCurr,0) ) ).

tff(addAssignment_52110,axiom,
    ! [VarCurr: state_type] :
      ( v84211(VarCurr)
    <=> v84193(VarCurr,1) ) ).

tff(addAssignment_52109,axiom,
    ! [VarCurr: state_type] :
      ( v84193(VarCurr,1)
    <=> v84195(VarCurr,1) ) ).

tff(addAssignment_52108,axiom,
    ! [VarNext: state_type] :
      ( v84195(VarNext,1)
    <=> v84278(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84279(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84278(VarNext,B)
            <=> v84195(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_943,axiom,
    ! [VarNext: state_type] :
      ( v84279(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84278(VarNext,B)
          <=> v84268(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84279(VarNext)
      <=> v84280(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84280(VarNext)
      <=> ( v84282(VarNext)
          & v84253(VarNext) ) ) ) ).

tff(writeUnaryOperator_3686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84282(VarNext)
      <=> v84262(VarNext) ) ) ).

tff(addAssignment_52107,axiom,
    ! [VarCurr: state_type] :
      ( v84205(VarCurr,1)
    <=> v84207(VarCurr,1) ) ).

tff(addAssignment_52106,axiom,
    ! [VarCurr: state_type] :
      ( v84207(VarCurr,1)
    <=> v84209(VarCurr,1) ) ).

tff(addAssignment_52105,axiom,
    ! [VarCurr: state_type] :
      ( v84209(VarCurr,1)
    <=> v84251(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7690,axiom,
    ! [VarCurr: state_type] :
      ( v84213(VarCurr)
    <=> ( v84275(VarCurr)
        & v84276(VarCurr) ) ) ).

tff(writeUnaryOperator_3685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84276(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7689,axiom,
    ! [VarCurr: state_type] :
      ( v84275(VarCurr)
    <=> ( v84215(VarCurr)
        & v4574(VarCurr) ) ) ).

tff(addAssignment_52104,axiom,
    ! [VarCurr: state_type] :
      ( v84215(VarCurr)
    <=> v84193(VarCurr,2) ) ).

tff(addAssignment_52103,axiom,
    ! [VarCurr: state_type] :
      ( v84193(VarCurr,2)
    <=> v84195(VarCurr,2) ) ).

tff(addAssignment_52102,axiom,
    ! [VarNext: state_type] :
      ( v84195(VarNext,2)
    <=> v84257(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84258(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84257(VarNext,B)
            <=> v84195(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_942,axiom,
    ! [VarNext: state_type] :
      ( v84258(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84257(VarNext,B)
          <=> v84268(VarNext,B) ) ) ) ).

tff(addAssignment_52101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84268(VarNext,B)
          <=> v84266(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84269(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84266(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_442,axiom,
    ! [VarCurr: state_type] :
      ( v84269(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84266(VarCurr,B)
          <=> v84205(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7688,axiom,
    ! [VarCurr: state_type] :
      ( v84269(VarCurr)
    <=> ( v84270(VarCurr)
        & v84271(VarCurr) ) ) ).

tff(writeUnaryOperator_3684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84271(VarCurr)
    <=> v84201(VarCurr) ) ).

tff(writeUnaryOperator_3683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84270(VarCurr)
    <=> v84197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84258(VarNext)
      <=> v84259(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84259(VarNext)
      <=> ( v84260(VarNext)
          & v84253(VarNext) ) ) ) ).

tff(writeUnaryOperator_3682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84260(VarNext)
      <=> v84262(VarNext) ) ) ).

tff(addAssignment_52100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84262(VarNext)
      <=> v84253(VarCurr) ) ) ).

tff(addAssignment_52099,axiom,
    ! [VarCurr: state_type] :
      ( v84253(VarCurr)
    <=> v84255(VarCurr) ) ).

tff(addAssignment_52098,axiom,
    ! [VarCurr: state_type] :
      ( v84255(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_52097,axiom,
    ! [VarCurr: state_type] :
      ( v84205(VarCurr,2)
    <=> v84207(VarCurr,2) ) ).

tff(addAssignment_52096,axiom,
    ! [VarCurr: state_type] :
      ( v84207(VarCurr,2)
    <=> v84209(VarCurr,2) ) ).

tff(addAssignment_52095,axiom,
    ! [VarCurr: state_type] :
      ( v84209(VarCurr,2)
    <=> v84251(VarCurr,2) ) ).

tff(addAssignment_52094,axiom,
    ! [VarCurr: state_type] :
      ( v84251(VarCurr,0)
    <=> v84211(VarCurr) ) ).

tff(addAssignment_52093,axiom,
    ! [VarCurr: state_type] :
      ( v84251(VarCurr,1)
    <=> v84213(VarCurr) ) ).

tff(addAssignment_52092,axiom,
    ! [VarCurr: state_type] :
      ( v84251(VarCurr,2)
    <=> v84217(VarCurr) ) ).

tff(addAssignment_52091,axiom,
    ! [VarCurr: state_type] :
      ( v84217(VarCurr)
    <=> v84219(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84235(VarNext)
       => ( v84219(VarNext)
        <=> v84219(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_941,axiom,
    ! [VarNext: state_type] :
      ( v84235(VarNext)
     => ( v84219(VarNext)
      <=> v84245(VarNext) ) ) ).

tff(addAssignment_52090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84245(VarNext)
      <=> v84243(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84246(VarCurr)
     => ( v84243(VarCurr)
      <=> x84230(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_441,axiom,
    ! [VarCurr: state_type] :
      ( v84246(VarCurr)
     => ( v84243(VarCurr)
      <=> v84225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7685,axiom,
    ! [VarCurr: state_type] :
      ( v84246(VarCurr)
    <=> ( v84247(VarCurr)
        & v84248(VarCurr) ) ) ).

tff(writeUnaryOperator_3681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84248(VarCurr)
    <=> v84223(VarCurr) ) ).

tff(writeUnaryOperator_3680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84247(VarCurr)
    <=> v84221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84235(VarNext)
      <=> v84236(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84236(VarNext)
      <=> ( v84237(VarNext)
          & v84232(VarNext) ) ) ) ).

tff(writeUnaryOperator_3679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84237(VarNext)
      <=> v84239(VarNext) ) ) ).

tff(addAssignment_52089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84239(VarNext)
      <=> v84232(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_241,axiom,
    ( v84219(constB0)
  <=> $false ) ).

tff(addAssignment_52088,axiom,
    ! [VarCurr: state_type] :
      ( v84232(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_52087,axiom,
    ! [VarCurr: state_type] :
      ( v84225(VarCurr)
    <=> v84227(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_351,axiom,
    ! [VarCurr: state_type] :
      ( v84227(VarCurr)
    <=> ( ( v4530(VarCurr,5)
        <=> $false )
        & ( v4530(VarCurr,4)
        <=> $false )
        & ( v4530(VarCurr,3)
        <=> $false )
        & ( v4530(VarCurr,2)
        <=> $true )
        & ( v4530(VarCurr,1)
        <=> $false )
        & ( v4530(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1036,axiom,
    ~ b000100(5) ).

tff(bitBlastConstant_1035,axiom,
    ~ b000100(4) ).

tff(bitBlastConstant_1034,axiom,
    ~ b000100(3) ).

tff(bitBlastConstant_1033,axiom,
    b000100(2) ).

tff(bitBlastConstant_1032,axiom,
    ~ b000100(1) ).

tff(bitBlastConstant_1031,axiom,
    ~ b000100(0) ).

tff(addAssignment_52086,axiom,
    ! [VarCurr: state_type] :
      ( v84223(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_52085,axiom,
    ! [VarCurr: state_type] :
      ( v84221(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_52084,axiom,
    ! [VarCurr: state_type] :
      ( v84201(VarCurr)
    <=> v84203(VarCurr) ) ).

tff(addAssignment_52083,axiom,
    ! [VarCurr: state_type] :
      ( v84203(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_52082,axiom,
    ! [VarCurr: state_type] :
      ( v84197(VarCurr)
    <=> v84199(VarCurr) ) ).

tff(addAssignment_52081,axiom,
    ! [VarCurr: state_type] :
      ( v84199(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_350,axiom,
    ! [VarCurr: state_type] :
      ( v83165(VarCurr)
    <=> ( ( v83167(VarCurr,1)
        <=> $true )
        & ( v83167(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_52080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83167(VarCurr,B)
      <=> v83169(VarCurr,B) ) ) ).

tff(addAssignment_52079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83169(VarCurr,B)
      <=> v83171(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84167(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v83171(VarNext,B)
            <=> v83171(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_940,axiom,
    ! [VarNext: state_type] :
      ( v84167(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v83171(VarNext,B)
          <=> v84177(VarNext,B) ) ) ) ).

tff(addAssignment_52078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v84177(VarNext,B)
          <=> v84175(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v84175(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_440,axiom,
    ! [VarCurr: state_type] :
      ( v84178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v84175(VarCurr,B)
          <=> v83181(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7682,axiom,
    ! [VarCurr: state_type] :
      ( v84178(VarCurr)
    <=> ( v84179(VarCurr)
        & v84180(VarCurr) ) ) ).

tff(writeUnaryOperator_3678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84180(VarCurr)
    <=> v83177(VarCurr) ) ).

tff(writeUnaryOperator_3677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84179(VarCurr)
    <=> v83173(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84167(VarNext)
      <=> v84168(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84168(VarNext)
      <=> ( v84169(VarNext)
          & v84162(VarNext) ) ) ) ).

tff(writeUnaryOperator_3676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84169(VarNext)
      <=> v84171(VarNext) ) ) ).

tff(addAssignment_52077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84171(VarNext)
      <=> v84162(VarCurr) ) ) ).

tff(addAssignment_52076,axiom,
    ! [VarCurr: state_type] :
      ( v84162(VarCurr)
    <=> v84164(VarCurr) ) ).

tff(addAssignment_52075,axiom,
    ! [VarCurr: state_type] :
      ( v84164(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83181(VarCurr,B)
      <=> v83183(VarCurr,B) ) ) ).

tff(addAssignment_52073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83183(VarCurr,B)
      <=> v83185(VarCurr,B) ) ) ).

tff(addAssignment_52072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83185(VarCurr,B)
      <=> v83187(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83189(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v83187(VarCurr,B)
          <=> v84158(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_439,axiom,
    ! [VarCurr: state_type] :
      ( v83189(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v83187(VarCurr,B)
          <=> v84151(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84159(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v84158(VarCurr,B)
          <=> v83167(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_438,axiom,
    ! [VarCurr: state_type] :
      ( v84159(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v84158(VarCurr,B)
          <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7679,axiom,
    ! [VarCurr: state_type] :
      ( v84159(VarCurr)
    <=> ( v83163(VarCurr)
        | v84160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7678,axiom,
    ! [VarCurr: state_type] :
      ( v84160(VarCurr)
    <=> ( v83165(VarCurr)
        & v84099(VarCurr) ) ) ).

tff(addAssignment_52071,axiom,
    ! [VarCurr: state_type] :
      ( v84151(VarCurr,0)
    <=> v84155(VarCurr) ) ).

tff(addAssignment_52070,axiom,
    ! [VarCurr: state_type] :
      ( v84151(VarCurr,1)
    <=> v84153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7677,axiom,
    ! [VarCurr: state_type] :
      ( v84153(VarCurr)
    <=> ( v84154(VarCurr)
        & v84157(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_607,axiom,
    ! [VarCurr: state_type] :
      ( v84157(VarCurr)
    <=> ( v83167(VarCurr,0)
        | v83167(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7676,axiom,
    ! [VarCurr: state_type] :
      ( v84154(VarCurr)
    <=> ( v84155(VarCurr)
        | v84156(VarCurr) ) ) ).

tff(writeUnaryOperator_3675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84156(VarCurr)
    <=> v83167(VarCurr,1) ) ).

tff(writeUnaryOperator_3674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84155(VarCurr)
    <=> v83167(VarCurr,0) ) ).

tff(addAssignment_52069,axiom,
    ! [VarCurr: state_type] :
      ( v84099(VarCurr)
    <=> v84101(VarCurr) ) ).

tff(addAssignment_52068,axiom,
    ! [VarCurr: state_type] :
      ( v84101(VarCurr)
    <=> v84103(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84134(VarNext)
       => ( v84103(VarNext)
        <=> v84103(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_939,axiom,
    ! [VarNext: state_type] :
      ( v84134(VarNext)
     => ( v84103(VarNext)
      <=> v84144(VarNext) ) ) ).

tff(addAssignment_52067,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84144(VarNext)
      <=> v84142(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84145(VarCurr)
     => ( v84142(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_437,axiom,
    ! [VarCurr: state_type] :
      ( v84145(VarCurr)
     => ( v84142(VarCurr)
      <=> v84113(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7675,axiom,
    ! [VarCurr: state_type] :
      ( v84145(VarCurr)
    <=> ( v84146(VarCurr)
        & v84147(VarCurr) ) ) ).

tff(writeUnaryOperator_3673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84147(VarCurr)
    <=> v84109(VarCurr) ) ).

tff(writeUnaryOperator_3672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84146(VarCurr)
    <=> v84105(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84134(VarNext)
      <=> v84135(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84135(VarNext)
      <=> ( v84136(VarNext)
          & v84129(VarNext) ) ) ) ).

tff(writeUnaryOperator_3671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84136(VarNext)
      <=> v84138(VarNext) ) ) ).

tff(addAssignment_52066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84138(VarNext)
      <=> v84129(VarCurr) ) ) ).

tff(addAssignment_52065,axiom,
    ! [VarCurr: state_type] :
      ( v84129(VarCurr)
    <=> v84131(VarCurr) ) ).

tff(addAssignment_52064,axiom,
    ! [VarCurr: state_type] :
      ( v84131(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52063,axiom,
    ! [VarCurr: state_type] :
      ( v84113(VarCurr)
    <=> v84115(VarCurr) ) ).

tff(addAssignment_52062,axiom,
    ! [VarCurr: state_type] :
      ( v84115(VarCurr)
    <=> v84117(VarCurr) ) ).

tff(addAssignment_52061,axiom,
    ! [VarCurr: state_type] :
      ( v84117(VarCurr)
    <=> v84119(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84123(VarCurr)
     => ( v84119(VarCurr)
      <=> v84126(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_436,axiom,
    ! [VarCurr: state_type] :
      ( v84123(VarCurr)
     => ( v84119(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84127(VarCurr)
     => ( v84126(VarCurr)
      <=> v84099(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_435,axiom,
    ! [VarCurr: state_type] :
      ( v84127(VarCurr)
     => ( v84126(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7672,axiom,
    ! [VarCurr: state_type] :
      ( v84127(VarCurr)
    <=> ( v83165(VarCurr)
        & v84099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7671,axiom,
    ! [VarCurr: state_type] :
      ( v84123(VarCurr)
    <=> ( v84124(VarCurr)
        & v83211(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_606,axiom,
    ! [VarCurr: state_type] :
      ( v84124(VarCurr)
    <=> ( v84121(VarCurr,0)
        | v84121(VarCurr,1) ) ) ).

tff(addAssignment_52060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v84121(VarCurr,B)
      <=> v5805(VarCurr,B) ) ) ).

tff(addAssignment_52059,axiom,
    ! [VarCurr: state_type] :
      ( v84109(VarCurr)
    <=> v84111(VarCurr) ) ).

tff(addAssignment_52058,axiom,
    ! [VarCurr: state_type] :
      ( v84111(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_52057,axiom,
    ! [VarCurr: state_type] :
      ( v84105(VarCurr)
    <=> v84107(VarCurr) ) ).

tff(addAssignment_52056,axiom,
    ! [VarCurr: state_type] :
      ( v84107(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_52055,axiom,
    ! [VarCurr: state_type] :
      ( v83189(VarCurr)
    <=> v83191(VarCurr,0) ) ).

tff(addAssignment_52054,axiom,
    ! [VarCurr: state_type] :
      ( v83191(VarCurr,0)
    <=> v83193(VarCurr,0) ) ).

tff(addAssignment_52053,axiom,
    ! [VarNext: state_type] :
      ( v83193(VarNext,0)
    <=> v84091(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84092(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84091(VarNext,B)
            <=> v83193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_938,axiom,
    ! [VarNext: state_type] :
      ( v84092(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84091(VarNext,B)
          <=> v84076(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84092(VarNext)
      <=> v84093(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84093(VarNext)
      <=> ( v84095(VarNext)
          & v84061(VarNext) ) ) ) ).

tff(writeUnaryOperator_3670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84095(VarNext)
      <=> v84070(VarNext) ) ) ).

tff(addAssignment_52052,axiom,
    ! [VarCurr: state_type] :
      ( v83203(VarCurr,0)
    <=> v83205(VarCurr,0) ) ).

tff(addAssignment_52051,axiom,
    ! [VarCurr: state_type] :
      ( v83205(VarCurr,0)
    <=> v83207(VarCurr,0) ) ).

tff(addAssignment_52050,axiom,
    ! [VarCurr: state_type] :
      ( v83207(VarCurr,0)
    <=> v84059(VarCurr,0) ) ).

tff(addAssignment_52049,axiom,
    ! [VarCurr: state_type] :
      ( v83209(VarCurr)
    <=> v83191(VarCurr,1) ) ).

tff(addAssignment_52048,axiom,
    ! [VarCurr: state_type] :
      ( v83191(VarCurr,1)
    <=> v83193(VarCurr,1) ) ).

tff(addAssignment_52047,axiom,
    ! [VarNext: state_type] :
      ( v83193(VarNext,1)
    <=> v84083(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84084(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84083(VarNext,B)
            <=> v83193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_937,axiom,
    ! [VarNext: state_type] :
      ( v84084(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84083(VarNext,B)
          <=> v84076(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84084(VarNext)
      <=> v84085(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84085(VarNext)
      <=> ( v84087(VarNext)
          & v84061(VarNext) ) ) ) ).

tff(writeUnaryOperator_3669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84087(VarNext)
      <=> v84070(VarNext) ) ) ).

tff(addAssignment_52046,axiom,
    ! [VarCurr: state_type] :
      ( v83203(VarCurr,1)
    <=> v83205(VarCurr,1) ) ).

tff(addAssignment_52045,axiom,
    ! [VarCurr: state_type] :
      ( v83205(VarCurr,1)
    <=> v83207(VarCurr,1) ) ).

tff(addAssignment_52044,axiom,
    ! [VarCurr: state_type] :
      ( v83207(VarCurr,1)
    <=> v84059(VarCurr,1) ) ).

tff(addAssignment_52043,axiom,
    ! [VarCurr: state_type] :
      ( v83211(VarCurr)
    <=> v83191(VarCurr,2) ) ).

tff(addAssignment_52042,axiom,
    ! [VarCurr: state_type] :
      ( v83191(VarCurr,2)
    <=> v83193(VarCurr,2) ) ).

tff(addAssignment_52041,axiom,
    ! [VarNext: state_type] :
      ( v83193(VarNext,2)
    <=> v84065(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84066(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v84065(VarNext,B)
            <=> v83193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_936,axiom,
    ! [VarNext: state_type] :
      ( v84066(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84065(VarNext,B)
          <=> v84076(VarNext,B) ) ) ) ).

tff(addAssignment_52040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84076(VarNext,B)
          <=> v84074(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84074(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_434,axiom,
    ! [VarCurr: state_type] :
      ( v84077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v84074(VarCurr,B)
          <=> v83203(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7666,axiom,
    ! [VarCurr: state_type] :
      ( v84077(VarCurr)
    <=> ( v84078(VarCurr)
        & v84079(VarCurr) ) ) ).

tff(writeUnaryOperator_3668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84079(VarCurr)
    <=> v83199(VarCurr) ) ).

tff(writeUnaryOperator_3667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84078(VarCurr)
    <=> v83195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84066(VarNext)
      <=> v84067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84067(VarNext)
      <=> ( v84068(VarNext)
          & v84061(VarNext) ) ) ) ).

tff(writeUnaryOperator_3666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84068(VarNext)
      <=> v84070(VarNext) ) ) ).

tff(addAssignment_52039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84070(VarNext)
      <=> v84061(VarCurr) ) ) ).

tff(addAssignment_52038,axiom,
    ! [VarCurr: state_type] :
      ( v84061(VarCurr)
    <=> v84063(VarCurr) ) ).

tff(addAssignment_52037,axiom,
    ! [VarCurr: state_type] :
      ( v84063(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_52036,axiom,
    ! [VarCurr: state_type] :
      ( v83203(VarCurr,2)
    <=> v83205(VarCurr,2) ) ).

tff(addAssignment_52035,axiom,
    ! [VarCurr: state_type] :
      ( v83205(VarCurr,2)
    <=> v83207(VarCurr,2) ) ).

tff(addAssignment_52034,axiom,
    ! [VarCurr: state_type] :
      ( v83207(VarCurr,2)
    <=> v84059(VarCurr,2) ) ).

tff(addAssignment_52033,axiom,
    ! [VarCurr: state_type] :
      ( v84059(VarCurr,0)
    <=> v83209(VarCurr) ) ).

tff(addAssignment_52032,axiom,
    ! [VarCurr: state_type] :
      ( v84059(VarCurr,1)
    <=> v83211(VarCurr) ) ).

tff(addAssignment_52031,axiom,
    ! [VarCurr: state_type] :
      ( v84059(VarCurr,2)
    <=> v83213(VarCurr) ) ).

tff(addAssignment_52030,axiom,
    ! [VarCurr: state_type] :
      ( v83213(VarCurr)
    <=> v83215(VarCurr) ) ).

tff(addAssignment_52029,axiom,
    ! [VarCurr: state_type] :
      ( v83215(VarCurr)
    <=> v83217(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1047(VarCurr)
     => ( v83217(VarCurr)
      <=> v84056(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_433,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
     => ( v83217(VarCurr)
      <=> v83219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7663,axiom,
    ! [VarCurr: state_type] :
      ( v84056(VarCurr)
    <=> ( v84057(VarCurr)
        & v1025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7662,axiom,
    ! [VarCurr: state_type] :
      ( v84057(VarCurr)
    <=> ( v5773(VarCurr)
        & v84058(VarCurr) ) ) ).

tff(writeUnaryOperator_3665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84058(VarCurr)
    <=> v5775(VarCurr) ) ).

tff(addAssignment_52028,axiom,
    ! [VarCurr: state_type] :
      ( v83219(VarCurr)
    <=> v83221(VarCurr) ) ).

tff(addAssignment_52027,axiom,
    ! [VarCurr: state_type] :
      ( v83221(VarCurr)
    <=> v83223(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84039(VarNext)
       => ( v83223(VarNext)
        <=> v83223(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_935,axiom,
    ! [VarNext: state_type] :
      ( v84039(VarNext)
     => ( v83223(VarNext)
      <=> v84049(VarNext) ) ) ).

tff(addAssignment_52026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84049(VarNext)
      <=> v84047(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84050(VarCurr)
     => ( v84047(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_432,axiom,
    ! [VarCurr: state_type] :
      ( v84050(VarCurr)
     => ( v84047(VarCurr)
      <=> v83233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7661,axiom,
    ! [VarCurr: state_type] :
      ( v84050(VarCurr)
    <=> ( v84051(VarCurr)
        & v84052(VarCurr) ) ) ).

tff(writeUnaryOperator_3664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84052(VarCurr)
    <=> v83229(VarCurr) ) ).

tff(writeUnaryOperator_3663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84051(VarCurr)
    <=> v83225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84039(VarNext)
      <=> v84040(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84040(VarNext)
      <=> ( v84041(VarNext)
          & v84034(VarNext) ) ) ) ).

tff(writeUnaryOperator_3662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84041(VarNext)
      <=> v84043(VarNext) ) ) ).

tff(addAssignment_52025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84043(VarNext)
      <=> v84034(VarCurr) ) ) ).

tff(addAssignment_52024,axiom,
    ! [VarCurr: state_type] :
      ( v84034(VarCurr)
    <=> v84036(VarCurr) ) ).

tff(addAssignment_52023,axiom,
    ! [VarCurr: state_type] :
      ( v84036(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_52022,axiom,
    ! [VarCurr: state_type] :
      ( v83233(VarCurr)
    <=> v83235(VarCurr) ) ).

tff(addAssignment_52021,axiom,
    ! [VarCurr: state_type] :
      ( v83235(VarCurr)
    <=> v83237(VarCurr) ) ).

tff(addAssignment_52020,axiom,
    ! [VarCurr: state_type] :
      ( v83237(VarCurr)
    <=> v83239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7658,axiom,
    ! [VarCurr: state_type] :
      ( v83239(VarCurr)
    <=> ( v84030(VarCurr)
        & v59955(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7657,axiom,
    ! [VarCurr: state_type] :
      ( v84030(VarCurr)
    <=> ( v84031(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7656,axiom,
    ! [VarCurr: state_type] :
      ( v84031(VarCurr)
    <=> ( v5773(VarCurr)
        & v84032(VarCurr) ) ) ).

tff(writeUnaryOperator_3661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84032(VarCurr)
    <=> v5775(VarCurr) ) ).

tff(addAssignment_52019,axiom,
    ! [VarCurr: state_type] :
      ( v5775(VarCurr)
    <=> v964(VarCurr,2) ) ).

tff(addAssignment_52018,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,2)
    <=> v966(VarCurr,2) ) ).

tff(addAssignment_52017,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,2)
    <=> v5526(VarCurr,2) ) ).

tff(addAssignment_52016,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,2)
    <=> v5523(VarCurr,2) ) ).

tff(addAssignment_52015,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,2)
    <=> v5525(VarCurr,2) ) ).

tff(addAssignment_52014,axiom,
    ! [VarNext: state_type] :
      ( v5525(VarNext,2)
    <=> v84012(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84013(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v84012(VarNext,B)
            <=> v5525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_934,axiom,
    ! [VarNext: state_type] :
      ( v84013(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v84012(VarNext,B)
          <=> v84023(VarNext,B) ) ) ) ).

tff(addAssignment_52013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v84023(VarNext,B)
          <=> v84021(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84024(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v84021(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_431,axiom,
    ! [VarCurr: state_type] :
      ( v84024(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v84021(VarCurr,B)
          <=> v83988(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7655,axiom,
    ! [VarCurr: state_type] :
      ( v84024(VarCurr)
    <=> ( v84025(VarCurr)
        & v84026(VarCurr) ) ) ).

tff(writeUnaryOperator_3660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84026(VarCurr)
    <=> v83984(VarCurr) ) ).

tff(writeUnaryOperator_3659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v84025(VarCurr)
    <=> v83980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84013(VarNext)
      <=> v84014(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84014(VarNext)
      <=> ( v84015(VarNext)
          & v84008(VarNext) ) ) ) ).

tff(writeUnaryOperator_3658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v84015(VarNext)
      <=> v84017(VarNext) ) ) ).

tff(addAssignment_52012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v84017(VarNext)
      <=> v84008(VarCurr) ) ) ).

tff(addAssignment_52011,axiom,
    ! [VarCurr: state_type] :
      ( v84008(VarCurr)
    <=> v84010(VarCurr) ) ).

tff(addAssignment_52010,axiom,
    ! [VarCurr: state_type] :
      ( v84010(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_52009,axiom,
    ! [VarCurr: state_type] :
      ( v83988(VarCurr,2)
    <=> v83990(VarCurr,2) ) ).

tff(addAssignment_52008,axiom,
    ! [VarCurr: state_type] :
      ( v83990(VarCurr,2)
    <=> v83999(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83999(VarCurr,B)
      <=> ( v84000(VarCurr,B)
          | v84003(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v84003(VarCurr,B)
      <=> ( v5523(VarCurr,B)
          & v84004(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v84004(VarCurr,B)
      <=> ~ v84005(VarCurr,B) ) ) ).

tff(addAssignment_52007,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,0)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52006,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,1)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52005,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,2)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52004,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,3)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52003,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,4)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52002,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,5)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52001,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,6)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_52000,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,7)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51999,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,8)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51998,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,9)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51997,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,10)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51996,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,11)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51995,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,12)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51994,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,13)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51993,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,14)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51992,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,15)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51991,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,16)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51990,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,17)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51989,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,18)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51988,axiom,
    ! [VarCurr: state_type] :
      ( v84005(VarCurr,19)
    <=> v84006(VarCurr) ) ).

tff(addAssignment_51987,axiom,
    ! [VarCurr: state_type] :
      ( v84006(VarCurr)
    <=> v83994(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v84000(VarCurr,B)
      <=> ( v83992(VarCurr,B)
          & v84001(VarCurr,B) ) ) ) ).

tff(addAssignment_51986,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,0)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51985,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,1)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51984,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,2)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51983,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,3)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51982,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,4)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51981,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,5)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51980,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,6)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51979,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,7)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51978,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,8)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51977,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,9)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51976,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,10)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51975,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,11)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51974,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,12)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51973,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,13)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51972,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,14)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51971,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,15)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51970,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,16)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51969,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,17)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51968,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,18)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51967,axiom,
    ! [VarCurr: state_type] :
      ( v84001(VarCurr,19)
    <=> v84002(VarCurr) ) ).

tff(addAssignment_51966,axiom,
    ! [VarCurr: state_type] :
      ( v84002(VarCurr)
    <=> v83994(VarCurr) ) ).

tff(addAssignment_51965,axiom,
    ! [VarCurr: state_type] :
      ( v83994(VarCurr)
    <=> v83996(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7652,axiom,
    ! [VarCurr: state_type] :
      ( v83996(VarCurr)
    <=> ( v83998(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_349,axiom,
    ! [VarCurr: state_type] :
      ( v83998(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51964,axiom,
    ! [VarCurr: state_type] :
      ( v83992(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51963,axiom,
    ! [VarCurr: state_type] :
      ( v83984(VarCurr)
    <=> v83986(VarCurr) ) ).

tff(addAssignment_51962,axiom,
    ! [VarCurr: state_type] :
      ( v83986(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51961,axiom,
    ! [VarCurr: state_type] :
      ( v83980(VarCurr)
    <=> v83982(VarCurr) ) ).

tff(addAssignment_51960,axiom,
    ! [VarCurr: state_type] :
      ( v83982(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51959,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,2)
    <=> v5516(VarCurr,2) ) ).

tff(addAssignment_51958,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,2)
    <=> v5518(VarCurr,2) ) ).

tff(addAssignment_51957,axiom,
    ! [VarNext: state_type] :
      ( v5518(VarNext,2)
    <=> v83962(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83963(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83962(VarNext,B)
            <=> v5518(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_933,axiom,
    ! [VarNext: state_type] :
      ( v83963(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83962(VarNext,B)
          <=> v83973(VarNext,B) ) ) ) ).

tff(addAssignment_51956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83973(VarNext,B)
          <=> v83971(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83974(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83971(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_430,axiom,
    ! [VarCurr: state_type] :
      ( v83974(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83971(VarCurr,B)
          <=> v83938(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7651,axiom,
    ! [VarCurr: state_type] :
      ( v83974(VarCurr)
    <=> ( v83975(VarCurr)
        & v83976(VarCurr) ) ) ).

tff(writeUnaryOperator_3656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83976(VarCurr)
    <=> v83934(VarCurr) ) ).

tff(writeUnaryOperator_3655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83975(VarCurr)
    <=> v83930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83963(VarNext)
      <=> v83964(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83964(VarNext)
      <=> ( v83965(VarNext)
          & v83958(VarNext) ) ) ) ).

tff(writeUnaryOperator_3654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83965(VarNext)
      <=> v83967(VarNext) ) ) ).

tff(addAssignment_51955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83967(VarNext)
      <=> v83958(VarCurr) ) ) ).

tff(addAssignment_51954,axiom,
    ! [VarCurr: state_type] :
      ( v83958(VarCurr)
    <=> v83960(VarCurr) ) ).

tff(addAssignment_51953,axiom,
    ! [VarCurr: state_type] :
      ( v83960(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51952,axiom,
    ! [VarCurr: state_type] :
      ( v83938(VarCurr,2)
    <=> v83940(VarCurr,2) ) ).

tff(addAssignment_51951,axiom,
    ! [VarCurr: state_type] :
      ( v83940(VarCurr,2)
    <=> v83949(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83949(VarCurr,B)
      <=> ( v83950(VarCurr,B)
          | v83953(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83953(VarCurr,B)
      <=> ( v5516(VarCurr,B)
          & v83954(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83954(VarCurr,B)
      <=> ~ v83955(VarCurr,B) ) ) ).

tff(addAssignment_51950,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,0)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51949,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,1)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51948,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,2)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51947,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,3)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51946,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,4)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51945,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,5)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51944,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,6)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51943,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,7)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51942,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,8)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51941,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,9)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51940,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,10)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51939,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,11)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51938,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,12)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51937,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,13)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51936,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,14)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51935,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,15)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51934,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,16)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51933,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,17)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51932,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,18)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51931,axiom,
    ! [VarCurr: state_type] :
      ( v83955(VarCurr,19)
    <=> v83956(VarCurr) ) ).

tff(addAssignment_51930,axiom,
    ! [VarCurr: state_type] :
      ( v83956(VarCurr)
    <=> v83944(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83950(VarCurr,B)
      <=> ( v83942(VarCurr,B)
          & v83951(VarCurr,B) ) ) ) ).

tff(addAssignment_51929,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,0)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51928,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,1)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51927,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,2)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51926,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,3)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51925,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,4)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51924,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,5)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51923,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,6)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51922,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,7)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51921,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,8)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51920,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,9)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51919,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,10)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51918,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,11)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51917,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,12)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51916,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,13)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51915,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,14)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51914,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,15)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51913,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,16)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51912,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,17)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51911,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,18)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51910,axiom,
    ! [VarCurr: state_type] :
      ( v83951(VarCurr,19)
    <=> v83952(VarCurr) ) ).

tff(addAssignment_51909,axiom,
    ! [VarCurr: state_type] :
      ( v83952(VarCurr)
    <=> v83944(VarCurr) ) ).

tff(addAssignment_51908,axiom,
    ! [VarCurr: state_type] :
      ( v83944(VarCurr)
    <=> v83946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7648,axiom,
    ! [VarCurr: state_type] :
      ( v83946(VarCurr)
    <=> ( v83948(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_348,axiom,
    ! [VarCurr: state_type] :
      ( v83948(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51907,axiom,
    ! [VarCurr: state_type] :
      ( v83942(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51906,axiom,
    ! [VarCurr: state_type] :
      ( v83934(VarCurr)
    <=> v83936(VarCurr) ) ).

tff(addAssignment_51905,axiom,
    ! [VarCurr: state_type] :
      ( v83936(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51904,axiom,
    ! [VarCurr: state_type] :
      ( v83930(VarCurr)
    <=> v83932(VarCurr) ) ).

tff(addAssignment_51903,axiom,
    ! [VarCurr: state_type] :
      ( v83932(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51902,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,2)
    <=> v5509(VarCurr,2) ) ).

tff(addAssignment_51901,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,2)
    <=> v5511(VarCurr,2) ) ).

tff(addAssignment_51900,axiom,
    ! [VarNext: state_type] :
      ( v5511(VarNext,2)
    <=> v83912(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83913(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83912(VarNext,B)
            <=> v5511(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_932,axiom,
    ! [VarNext: state_type] :
      ( v83913(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83912(VarNext,B)
          <=> v83923(VarNext,B) ) ) ) ).

tff(addAssignment_51899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83923(VarNext,B)
          <=> v83921(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83924(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83921(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_429,axiom,
    ! [VarCurr: state_type] :
      ( v83924(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83921(VarCurr,B)
          <=> v83888(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7647,axiom,
    ! [VarCurr: state_type] :
      ( v83924(VarCurr)
    <=> ( v83925(VarCurr)
        & v83926(VarCurr) ) ) ).

tff(writeUnaryOperator_3652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83926(VarCurr)
    <=> v83884(VarCurr) ) ).

tff(writeUnaryOperator_3651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83925(VarCurr)
    <=> v83880(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83913(VarNext)
      <=> v83914(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83914(VarNext)
      <=> ( v83915(VarNext)
          & v83908(VarNext) ) ) ) ).

tff(writeUnaryOperator_3650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83915(VarNext)
      <=> v83917(VarNext) ) ) ).

tff(addAssignment_51898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83917(VarNext)
      <=> v83908(VarCurr) ) ) ).

tff(addAssignment_51897,axiom,
    ! [VarCurr: state_type] :
      ( v83908(VarCurr)
    <=> v83910(VarCurr) ) ).

tff(addAssignment_51896,axiom,
    ! [VarCurr: state_type] :
      ( v83910(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51895,axiom,
    ! [VarCurr: state_type] :
      ( v83888(VarCurr,2)
    <=> v83890(VarCurr,2) ) ).

tff(addAssignment_51894,axiom,
    ! [VarCurr: state_type] :
      ( v83890(VarCurr,2)
    <=> v83899(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83899(VarCurr,B)
      <=> ( v83900(VarCurr,B)
          | v83903(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83903(VarCurr,B)
      <=> ( v5509(VarCurr,B)
          & v83904(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83904(VarCurr,B)
      <=> ~ v83905(VarCurr,B) ) ) ).

tff(addAssignment_51893,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,0)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51892,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,1)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51891,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,2)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51890,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,3)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51889,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,4)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51888,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,5)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51887,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,6)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51886,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,7)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51885,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,8)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51884,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,9)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51883,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,10)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51882,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,11)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51881,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,12)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51880,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,13)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51879,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,14)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51878,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,15)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51877,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,16)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51876,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,17)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51875,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,18)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51874,axiom,
    ! [VarCurr: state_type] :
      ( v83905(VarCurr,19)
    <=> v83906(VarCurr) ) ).

tff(addAssignment_51873,axiom,
    ! [VarCurr: state_type] :
      ( v83906(VarCurr)
    <=> v83894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83900(VarCurr,B)
      <=> ( v83892(VarCurr,B)
          & v83901(VarCurr,B) ) ) ) ).

tff(addAssignment_51872,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,0)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51871,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,1)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51870,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,2)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51869,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,3)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51868,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,4)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51867,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,5)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51866,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,6)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51865,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,7)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51864,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,8)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51863,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,9)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51862,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,10)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51861,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,11)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51860,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,12)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51859,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,13)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51858,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,14)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51857,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,15)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51856,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,16)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51855,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,17)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51854,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,18)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51853,axiom,
    ! [VarCurr: state_type] :
      ( v83901(VarCurr,19)
    <=> v83902(VarCurr) ) ).

tff(addAssignment_51852,axiom,
    ! [VarCurr: state_type] :
      ( v83902(VarCurr)
    <=> v83894(VarCurr) ) ).

tff(addAssignment_51851,axiom,
    ! [VarCurr: state_type] :
      ( v83894(VarCurr)
    <=> v83896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7644,axiom,
    ! [VarCurr: state_type] :
      ( v83896(VarCurr)
    <=> ( v83898(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_347,axiom,
    ! [VarCurr: state_type] :
      ( v83898(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51850,axiom,
    ! [VarCurr: state_type] :
      ( v83892(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51849,axiom,
    ! [VarCurr: state_type] :
      ( v83884(VarCurr)
    <=> v83886(VarCurr) ) ).

tff(addAssignment_51848,axiom,
    ! [VarCurr: state_type] :
      ( v83886(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51847,axiom,
    ! [VarCurr: state_type] :
      ( v83880(VarCurr)
    <=> v83882(VarCurr) ) ).

tff(addAssignment_51846,axiom,
    ! [VarCurr: state_type] :
      ( v83882(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51845,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,2)
    <=> v5502(VarCurr,2) ) ).

tff(addAssignment_51844,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,2)
    <=> v5504(VarCurr,2) ) ).

tff(addAssignment_51843,axiom,
    ! [VarNext: state_type] :
      ( v5504(VarNext,2)
    <=> v83862(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83863(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83862(VarNext,B)
            <=> v5504(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_931,axiom,
    ! [VarNext: state_type] :
      ( v83863(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83862(VarNext,B)
          <=> v83873(VarNext,B) ) ) ) ).

tff(addAssignment_51842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83873(VarNext,B)
          <=> v83871(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83874(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83871(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_428,axiom,
    ! [VarCurr: state_type] :
      ( v83874(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83871(VarCurr,B)
          <=> v83838(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7643,axiom,
    ! [VarCurr: state_type] :
      ( v83874(VarCurr)
    <=> ( v83875(VarCurr)
        & v83876(VarCurr) ) ) ).

tff(writeUnaryOperator_3648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83876(VarCurr)
    <=> v83834(VarCurr) ) ).

tff(writeUnaryOperator_3647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83875(VarCurr)
    <=> v83830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83863(VarNext)
      <=> v83864(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83864(VarNext)
      <=> ( v83865(VarNext)
          & v83858(VarNext) ) ) ) ).

tff(writeUnaryOperator_3646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83865(VarNext)
      <=> v83867(VarNext) ) ) ).

tff(addAssignment_51841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83867(VarNext)
      <=> v83858(VarCurr) ) ) ).

tff(addAssignment_51840,axiom,
    ! [VarCurr: state_type] :
      ( v83858(VarCurr)
    <=> v83860(VarCurr) ) ).

tff(addAssignment_51839,axiom,
    ! [VarCurr: state_type] :
      ( v83860(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51838,axiom,
    ! [VarCurr: state_type] :
      ( v83838(VarCurr,2)
    <=> v83840(VarCurr,2) ) ).

tff(addAssignment_51837,axiom,
    ! [VarCurr: state_type] :
      ( v83840(VarCurr,2)
    <=> v83849(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83849(VarCurr,B)
      <=> ( v83850(VarCurr,B)
          | v83853(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83853(VarCurr,B)
      <=> ( v5502(VarCurr,B)
          & v83854(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83854(VarCurr,B)
      <=> ~ v83855(VarCurr,B) ) ) ).

tff(addAssignment_51836,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,0)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51835,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,1)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51834,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,2)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51833,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,3)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51832,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,4)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51831,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,5)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51830,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,6)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51829,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,7)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51828,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,8)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51827,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,9)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51826,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,10)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51825,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,11)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51824,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,12)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51823,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,13)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51822,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,14)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51821,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,15)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51820,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,16)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51819,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,17)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51818,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,18)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51817,axiom,
    ! [VarCurr: state_type] :
      ( v83855(VarCurr,19)
    <=> v83856(VarCurr) ) ).

tff(addAssignment_51816,axiom,
    ! [VarCurr: state_type] :
      ( v83856(VarCurr)
    <=> v83844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83850(VarCurr,B)
      <=> ( v83842(VarCurr,B)
          & v83851(VarCurr,B) ) ) ) ).

tff(addAssignment_51815,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,0)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51814,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,1)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51813,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,2)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51812,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,3)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51811,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,4)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51810,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,5)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51809,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,6)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51808,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,7)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51807,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,8)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51806,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,9)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51805,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,10)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51804,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,11)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51803,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,12)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51802,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,13)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51801,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,14)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51800,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,15)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51799,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,16)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51798,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,17)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51797,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,18)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51796,axiom,
    ! [VarCurr: state_type] :
      ( v83851(VarCurr,19)
    <=> v83852(VarCurr) ) ).

tff(addAssignment_51795,axiom,
    ! [VarCurr: state_type] :
      ( v83852(VarCurr)
    <=> v83844(VarCurr) ) ).

tff(addAssignment_51794,axiom,
    ! [VarCurr: state_type] :
      ( v83844(VarCurr)
    <=> v83846(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7640,axiom,
    ! [VarCurr: state_type] :
      ( v83846(VarCurr)
    <=> ( v83848(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_346,axiom,
    ! [VarCurr: state_type] :
      ( v83848(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51793,axiom,
    ! [VarCurr: state_type] :
      ( v83842(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51792,axiom,
    ! [VarCurr: state_type] :
      ( v83834(VarCurr)
    <=> v83836(VarCurr) ) ).

tff(addAssignment_51791,axiom,
    ! [VarCurr: state_type] :
      ( v83836(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51790,axiom,
    ! [VarCurr: state_type] :
      ( v83830(VarCurr)
    <=> v83832(VarCurr) ) ).

tff(addAssignment_51789,axiom,
    ! [VarCurr: state_type] :
      ( v83832(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51788,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,2)
    <=> v5495(VarCurr,2) ) ).

tff(addAssignment_51787,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,2)
    <=> v5497(VarCurr,2) ) ).

tff(addAssignment_51786,axiom,
    ! [VarNext: state_type] :
      ( v5497(VarNext,2)
    <=> v83812(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83813(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83812(VarNext,B)
            <=> v5497(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_930,axiom,
    ! [VarNext: state_type] :
      ( v83813(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83812(VarNext,B)
          <=> v83823(VarNext,B) ) ) ) ).

tff(addAssignment_51785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83823(VarNext,B)
          <=> v83821(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83821(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_427,axiom,
    ! [VarCurr: state_type] :
      ( v83824(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83821(VarCurr,B)
          <=> v83788(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7639,axiom,
    ! [VarCurr: state_type] :
      ( v83824(VarCurr)
    <=> ( v83825(VarCurr)
        & v83826(VarCurr) ) ) ).

tff(writeUnaryOperator_3644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83826(VarCurr)
    <=> v83784(VarCurr) ) ).

tff(writeUnaryOperator_3643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83825(VarCurr)
    <=> v83780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83813(VarNext)
      <=> v83814(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83814(VarNext)
      <=> ( v83815(VarNext)
          & v83808(VarNext) ) ) ) ).

tff(writeUnaryOperator_3642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83815(VarNext)
      <=> v83817(VarNext) ) ) ).

tff(addAssignment_51784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83817(VarNext)
      <=> v83808(VarCurr) ) ) ).

tff(addAssignment_51783,axiom,
    ! [VarCurr: state_type] :
      ( v83808(VarCurr)
    <=> v83810(VarCurr) ) ).

tff(addAssignment_51782,axiom,
    ! [VarCurr: state_type] :
      ( v83810(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51781,axiom,
    ! [VarCurr: state_type] :
      ( v83788(VarCurr,2)
    <=> v83790(VarCurr,2) ) ).

tff(addAssignment_51780,axiom,
    ! [VarCurr: state_type] :
      ( v83790(VarCurr,2)
    <=> v83799(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83799(VarCurr,B)
      <=> ( v83800(VarCurr,B)
          | v83803(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83803(VarCurr,B)
      <=> ( v5495(VarCurr,B)
          & v83804(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83804(VarCurr,B)
      <=> ~ v83805(VarCurr,B) ) ) ).

tff(addAssignment_51779,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,0)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51778,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,1)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51777,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,2)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51776,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,3)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51775,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,4)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51774,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,5)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51773,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,6)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51772,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,7)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51771,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,8)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51770,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,9)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51769,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,10)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51768,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,11)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51767,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,12)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51766,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,13)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51765,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,14)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51764,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,15)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51763,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,16)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51762,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,17)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51761,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,18)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51760,axiom,
    ! [VarCurr: state_type] :
      ( v83805(VarCurr,19)
    <=> v83806(VarCurr) ) ).

tff(addAssignment_51759,axiom,
    ! [VarCurr: state_type] :
      ( v83806(VarCurr)
    <=> v83794(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83800(VarCurr,B)
      <=> ( v83792(VarCurr,B)
          & v83801(VarCurr,B) ) ) ) ).

tff(addAssignment_51758,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,0)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51757,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,1)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51756,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,2)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51755,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,3)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51754,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,4)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51753,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,5)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51752,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,6)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51751,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,7)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51750,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,8)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51749,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,9)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51748,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,10)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51747,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,11)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51746,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,12)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51745,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,13)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51744,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,14)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51743,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,15)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51742,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,16)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51741,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,17)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51740,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,18)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51739,axiom,
    ! [VarCurr: state_type] :
      ( v83801(VarCurr,19)
    <=> v83802(VarCurr) ) ).

tff(addAssignment_51738,axiom,
    ! [VarCurr: state_type] :
      ( v83802(VarCurr)
    <=> v83794(VarCurr) ) ).

tff(addAssignment_51737,axiom,
    ! [VarCurr: state_type] :
      ( v83794(VarCurr)
    <=> v83796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7636,axiom,
    ! [VarCurr: state_type] :
      ( v83796(VarCurr)
    <=> ( v83798(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_345,axiom,
    ! [VarCurr: state_type] :
      ( v83798(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51736,axiom,
    ! [VarCurr: state_type] :
      ( v83792(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51735,axiom,
    ! [VarCurr: state_type] :
      ( v83784(VarCurr)
    <=> v83786(VarCurr) ) ).

tff(addAssignment_51734,axiom,
    ! [VarCurr: state_type] :
      ( v83786(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51733,axiom,
    ! [VarCurr: state_type] :
      ( v83780(VarCurr)
    <=> v83782(VarCurr) ) ).

tff(addAssignment_51732,axiom,
    ! [VarCurr: state_type] :
      ( v83782(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51731,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,2)
    <=> v5489(VarCurr,2) ) ).

tff(addAssignment_51730,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,2)
    <=> v5491(VarCurr,2) ) ).

tff(addAssignment_51729,axiom,
    ! [VarNext: state_type] :
      ( v5491(VarNext,2)
    <=> v83762(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83763(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83762(VarNext,B)
            <=> v5491(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_929,axiom,
    ! [VarNext: state_type] :
      ( v83763(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83762(VarNext,B)
          <=> v83773(VarNext,B) ) ) ) ).

tff(addAssignment_51728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83773(VarNext,B)
          <=> v83771(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83774(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83771(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_426,axiom,
    ! [VarCurr: state_type] :
      ( v83774(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83771(VarCurr,B)
          <=> v83738(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7635,axiom,
    ! [VarCurr: state_type] :
      ( v83774(VarCurr)
    <=> ( v83775(VarCurr)
        & v83776(VarCurr) ) ) ).

tff(writeUnaryOperator_3640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83776(VarCurr)
    <=> v83734(VarCurr) ) ).

tff(writeUnaryOperator_3639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83775(VarCurr)
    <=> v83730(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83763(VarNext)
      <=> v83764(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83764(VarNext)
      <=> ( v83765(VarNext)
          & v83758(VarNext) ) ) ) ).

tff(writeUnaryOperator_3638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83765(VarNext)
      <=> v83767(VarNext) ) ) ).

tff(addAssignment_51727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83767(VarNext)
      <=> v83758(VarCurr) ) ) ).

tff(addAssignment_51726,axiom,
    ! [VarCurr: state_type] :
      ( v83758(VarCurr)
    <=> v83760(VarCurr) ) ).

tff(addAssignment_51725,axiom,
    ! [VarCurr: state_type] :
      ( v83760(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51724,axiom,
    ! [VarCurr: state_type] :
      ( v83738(VarCurr,2)
    <=> v83740(VarCurr,2) ) ).

tff(addAssignment_51723,axiom,
    ! [VarCurr: state_type] :
      ( v83740(VarCurr,2)
    <=> v83749(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83749(VarCurr,B)
      <=> ( v83750(VarCurr,B)
          | v83753(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83753(VarCurr,B)
      <=> ( v5489(VarCurr,B)
          & v83754(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83754(VarCurr,B)
      <=> ~ v83755(VarCurr,B) ) ) ).

tff(addAssignment_51722,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,0)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51721,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,1)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51720,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,2)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51719,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,3)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51718,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,4)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51717,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,5)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51716,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,6)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51715,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,7)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51714,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,8)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51713,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,9)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51712,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,10)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51711,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,11)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51710,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,12)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51709,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,13)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51708,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,14)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51707,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,15)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51706,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,16)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51705,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,17)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51704,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,18)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51703,axiom,
    ! [VarCurr: state_type] :
      ( v83755(VarCurr,19)
    <=> v83756(VarCurr) ) ).

tff(addAssignment_51702,axiom,
    ! [VarCurr: state_type] :
      ( v83756(VarCurr)
    <=> v83744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83750(VarCurr,B)
      <=> ( v83742(VarCurr,B)
          & v83751(VarCurr,B) ) ) ) ).

tff(addAssignment_51701,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,0)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51700,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,1)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51699,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,2)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51698,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,3)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51697,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,4)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51696,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,5)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51695,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,6)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51694,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,7)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51693,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,8)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51692,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,9)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51691,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,10)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51690,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,11)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51689,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,12)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51688,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,13)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51687,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,14)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51686,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,15)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51685,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,16)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51684,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,17)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51683,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,18)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51682,axiom,
    ! [VarCurr: state_type] :
      ( v83751(VarCurr,19)
    <=> v83752(VarCurr) ) ).

tff(addAssignment_51681,axiom,
    ! [VarCurr: state_type] :
      ( v83752(VarCurr)
    <=> v83744(VarCurr) ) ).

tff(addAssignment_51680,axiom,
    ! [VarCurr: state_type] :
      ( v83744(VarCurr)
    <=> v83746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7632,axiom,
    ! [VarCurr: state_type] :
      ( v83746(VarCurr)
    <=> ( v83748(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_344,axiom,
    ! [VarCurr: state_type] :
      ( v83748(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51679,axiom,
    ! [VarCurr: state_type] :
      ( v83742(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51678,axiom,
    ! [VarCurr: state_type] :
      ( v83734(VarCurr)
    <=> v83736(VarCurr) ) ).

tff(addAssignment_51677,axiom,
    ! [VarCurr: state_type] :
      ( v83736(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51676,axiom,
    ! [VarCurr: state_type] :
      ( v83730(VarCurr)
    <=> v83732(VarCurr) ) ).

tff(addAssignment_51675,axiom,
    ! [VarCurr: state_type] :
      ( v83732(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51674,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,2)
    <=> v5482(VarCurr,2) ) ).

tff(addAssignment_51673,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,2)
    <=> v5484(VarCurr,2) ) ).

tff(addAssignment_51672,axiom,
    ! [VarNext: state_type] :
      ( v5484(VarNext,2)
    <=> v83712(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83713(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83712(VarNext,B)
            <=> v5484(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_928,axiom,
    ! [VarNext: state_type] :
      ( v83713(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83712(VarNext,B)
          <=> v83723(VarNext,B) ) ) ) ).

tff(addAssignment_51671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83723(VarNext,B)
          <=> v83721(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83721(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_425,axiom,
    ! [VarCurr: state_type] :
      ( v83724(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83721(VarCurr,B)
          <=> v83688(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7631,axiom,
    ! [VarCurr: state_type] :
      ( v83724(VarCurr)
    <=> ( v83725(VarCurr)
        & v83726(VarCurr) ) ) ).

tff(writeUnaryOperator_3636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83726(VarCurr)
    <=> v83684(VarCurr) ) ).

tff(writeUnaryOperator_3635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83725(VarCurr)
    <=> v83680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83713(VarNext)
      <=> v83714(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83714(VarNext)
      <=> ( v83715(VarNext)
          & v83708(VarNext) ) ) ) ).

tff(writeUnaryOperator_3634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83715(VarNext)
      <=> v83717(VarNext) ) ) ).

tff(addAssignment_51670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83717(VarNext)
      <=> v83708(VarCurr) ) ) ).

tff(addAssignment_51669,axiom,
    ! [VarCurr: state_type] :
      ( v83708(VarCurr)
    <=> v83710(VarCurr) ) ).

tff(addAssignment_51668,axiom,
    ! [VarCurr: state_type] :
      ( v83710(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51667,axiom,
    ! [VarCurr: state_type] :
      ( v83688(VarCurr,2)
    <=> v83690(VarCurr,2) ) ).

tff(addAssignment_51666,axiom,
    ! [VarCurr: state_type] :
      ( v83690(VarCurr,2)
    <=> v83699(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83699(VarCurr,B)
      <=> ( v83700(VarCurr,B)
          | v83703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83703(VarCurr,B)
      <=> ( v5482(VarCurr,B)
          & v83704(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83704(VarCurr,B)
      <=> ~ v83705(VarCurr,B) ) ) ).

tff(addAssignment_51665,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,0)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51664,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,1)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51663,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,2)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51662,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,3)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51661,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,4)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51660,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,5)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51659,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,6)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51658,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,7)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51657,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,8)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51656,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,9)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51655,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,10)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51654,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,11)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51653,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,12)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51652,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,13)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51651,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,14)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51650,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,15)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51649,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,16)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51648,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,17)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51647,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,18)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51646,axiom,
    ! [VarCurr: state_type] :
      ( v83705(VarCurr,19)
    <=> v83706(VarCurr) ) ).

tff(addAssignment_51645,axiom,
    ! [VarCurr: state_type] :
      ( v83706(VarCurr)
    <=> v83694(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83700(VarCurr,B)
      <=> ( v83692(VarCurr,B)
          & v83701(VarCurr,B) ) ) ) ).

tff(addAssignment_51644,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,0)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51643,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,1)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51642,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,2)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51641,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,3)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51640,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,4)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51639,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,5)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51638,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,6)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51637,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,7)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51636,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,8)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51635,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,9)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51634,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,10)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51633,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,11)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51632,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,12)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51631,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,13)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51630,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,14)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51629,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,15)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51628,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,16)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51627,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,17)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51626,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,18)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51625,axiom,
    ! [VarCurr: state_type] :
      ( v83701(VarCurr,19)
    <=> v83702(VarCurr) ) ).

tff(addAssignment_51624,axiom,
    ! [VarCurr: state_type] :
      ( v83702(VarCurr)
    <=> v83694(VarCurr) ) ).

tff(addAssignment_51623,axiom,
    ! [VarCurr: state_type] :
      ( v83694(VarCurr)
    <=> v83696(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7628,axiom,
    ! [VarCurr: state_type] :
      ( v83696(VarCurr)
    <=> ( v83698(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_343,axiom,
    ! [VarCurr: state_type] :
      ( v83698(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51622,axiom,
    ! [VarCurr: state_type] :
      ( v83692(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51621,axiom,
    ! [VarCurr: state_type] :
      ( v83684(VarCurr)
    <=> v83686(VarCurr) ) ).

tff(addAssignment_51620,axiom,
    ! [VarCurr: state_type] :
      ( v83686(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51619,axiom,
    ! [VarCurr: state_type] :
      ( v83680(VarCurr)
    <=> v83682(VarCurr) ) ).

tff(addAssignment_51618,axiom,
    ! [VarCurr: state_type] :
      ( v83682(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51617,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,2)
    <=> v5475(VarCurr,2) ) ).

tff(addAssignment_51616,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,2)
    <=> v5477(VarCurr,2) ) ).

tff(addAssignment_51615,axiom,
    ! [VarNext: state_type] :
      ( v5477(VarNext,2)
    <=> v83662(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83663(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83662(VarNext,B)
            <=> v5477(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_927,axiom,
    ! [VarNext: state_type] :
      ( v83663(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83662(VarNext,B)
          <=> v83673(VarNext,B) ) ) ) ).

tff(addAssignment_51614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83673(VarNext,B)
          <=> v83671(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83674(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83671(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_424,axiom,
    ! [VarCurr: state_type] :
      ( v83674(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83671(VarCurr,B)
          <=> v83638(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7627,axiom,
    ! [VarCurr: state_type] :
      ( v83674(VarCurr)
    <=> ( v83675(VarCurr)
        & v83676(VarCurr) ) ) ).

tff(writeUnaryOperator_3632,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83676(VarCurr)
    <=> v83634(VarCurr) ) ).

tff(writeUnaryOperator_3631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83675(VarCurr)
    <=> v83630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83663(VarNext)
      <=> v83664(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83664(VarNext)
      <=> ( v83665(VarNext)
          & v83658(VarNext) ) ) ) ).

tff(writeUnaryOperator_3630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83665(VarNext)
      <=> v83667(VarNext) ) ) ).

tff(addAssignment_51613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83667(VarNext)
      <=> v83658(VarCurr) ) ) ).

tff(addAssignment_51612,axiom,
    ! [VarCurr: state_type] :
      ( v83658(VarCurr)
    <=> v83660(VarCurr) ) ).

tff(addAssignment_51611,axiom,
    ! [VarCurr: state_type] :
      ( v83660(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51610,axiom,
    ! [VarCurr: state_type] :
      ( v83638(VarCurr,2)
    <=> v83640(VarCurr,2) ) ).

tff(addAssignment_51609,axiom,
    ! [VarCurr: state_type] :
      ( v83640(VarCurr,2)
    <=> v83649(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83649(VarCurr,B)
      <=> ( v83650(VarCurr,B)
          | v83653(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83653(VarCurr,B)
      <=> ( v5475(VarCurr,B)
          & v83654(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83654(VarCurr,B)
      <=> ~ v83655(VarCurr,B) ) ) ).

tff(addAssignment_51608,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,0)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51607,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,1)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51606,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,2)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51605,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,3)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51604,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,4)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51603,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,5)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51602,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,6)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51601,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,7)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51600,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,8)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51599,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,9)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51598,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,10)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51597,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,11)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51596,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,12)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51595,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,13)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51594,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,14)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51593,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,15)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51592,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,16)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51591,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,17)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51590,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,18)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51589,axiom,
    ! [VarCurr: state_type] :
      ( v83655(VarCurr,19)
    <=> v83656(VarCurr) ) ).

tff(addAssignment_51588,axiom,
    ! [VarCurr: state_type] :
      ( v83656(VarCurr)
    <=> v83644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83650(VarCurr,B)
      <=> ( v83642(VarCurr,B)
          & v83651(VarCurr,B) ) ) ) ).

tff(addAssignment_51587,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,0)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51586,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,1)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51585,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,2)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51584,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,3)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51583,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,4)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51582,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,5)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51581,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,6)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51580,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,7)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51579,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,8)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51578,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,9)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51577,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,10)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51576,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,11)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51575,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,12)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51574,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,13)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51573,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,14)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51572,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,15)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51571,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,16)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51570,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,17)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51569,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,18)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51568,axiom,
    ! [VarCurr: state_type] :
      ( v83651(VarCurr,19)
    <=> v83652(VarCurr) ) ).

tff(addAssignment_51567,axiom,
    ! [VarCurr: state_type] :
      ( v83652(VarCurr)
    <=> v83644(VarCurr) ) ).

tff(addAssignment_51566,axiom,
    ! [VarCurr: state_type] :
      ( v83644(VarCurr)
    <=> v83646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7624,axiom,
    ! [VarCurr: state_type] :
      ( v83646(VarCurr)
    <=> ( v83648(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_342,axiom,
    ! [VarCurr: state_type] :
      ( v83648(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $true )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51565,axiom,
    ! [VarCurr: state_type] :
      ( v83642(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51564,axiom,
    ! [VarCurr: state_type] :
      ( v83634(VarCurr)
    <=> v83636(VarCurr) ) ).

tff(addAssignment_51563,axiom,
    ! [VarCurr: state_type] :
      ( v83636(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51562,axiom,
    ! [VarCurr: state_type] :
      ( v83630(VarCurr)
    <=> v83632(VarCurr) ) ).

tff(addAssignment_51561,axiom,
    ! [VarCurr: state_type] :
      ( v83632(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51560,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,2)
    <=> v5468(VarCurr,2) ) ).

tff(addAssignment_51559,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,2)
    <=> v5470(VarCurr,2) ) ).

tff(addAssignment_51558,axiom,
    ! [VarNext: state_type] :
      ( v5470(VarNext,2)
    <=> v83612(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83613(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83612(VarNext,B)
            <=> v5470(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_926,axiom,
    ! [VarNext: state_type] :
      ( v83613(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83612(VarNext,B)
          <=> v83623(VarNext,B) ) ) ) ).

tff(addAssignment_51557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83623(VarNext,B)
          <=> v83621(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83621(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_423,axiom,
    ! [VarCurr: state_type] :
      ( v83624(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83621(VarCurr,B)
          <=> v83588(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7623,axiom,
    ! [VarCurr: state_type] :
      ( v83624(VarCurr)
    <=> ( v83625(VarCurr)
        & v83626(VarCurr) ) ) ).

tff(writeUnaryOperator_3628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83626(VarCurr)
    <=> v83584(VarCurr) ) ).

tff(writeUnaryOperator_3627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83625(VarCurr)
    <=> v83580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83613(VarNext)
      <=> v83614(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83614(VarNext)
      <=> ( v83615(VarNext)
          & v83608(VarNext) ) ) ) ).

tff(writeUnaryOperator_3626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83615(VarNext)
      <=> v83617(VarNext) ) ) ).

tff(addAssignment_51556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83617(VarNext)
      <=> v83608(VarCurr) ) ) ).

tff(addAssignment_51555,axiom,
    ! [VarCurr: state_type] :
      ( v83608(VarCurr)
    <=> v83610(VarCurr) ) ).

tff(addAssignment_51554,axiom,
    ! [VarCurr: state_type] :
      ( v83610(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51553,axiom,
    ! [VarCurr: state_type] :
      ( v83588(VarCurr,2)
    <=> v83590(VarCurr,2) ) ).

tff(addAssignment_51552,axiom,
    ! [VarCurr: state_type] :
      ( v83590(VarCurr,2)
    <=> v83599(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83599(VarCurr,B)
      <=> ( v83600(VarCurr,B)
          | v83603(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83603(VarCurr,B)
      <=> ( v5468(VarCurr,B)
          & v83604(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83604(VarCurr,B)
      <=> ~ v83605(VarCurr,B) ) ) ).

tff(addAssignment_51551,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,0)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51550,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,1)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51549,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,2)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51548,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,3)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51547,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,4)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51546,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,5)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51545,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,6)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51544,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,7)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51543,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,8)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51542,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,9)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51541,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,10)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51540,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,11)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51539,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,12)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51538,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,13)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51537,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,14)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51536,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,15)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51535,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,16)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51534,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,17)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51533,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,18)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51532,axiom,
    ! [VarCurr: state_type] :
      ( v83605(VarCurr,19)
    <=> v83606(VarCurr) ) ).

tff(addAssignment_51531,axiom,
    ! [VarCurr: state_type] :
      ( v83606(VarCurr)
    <=> v83594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83600(VarCurr,B)
      <=> ( v83592(VarCurr,B)
          & v83601(VarCurr,B) ) ) ) ).

tff(addAssignment_51530,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,0)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51529,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,1)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51528,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,2)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51527,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,3)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51526,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,4)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51525,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,5)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51524,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,6)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51523,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,7)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51522,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,8)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51521,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,9)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51520,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,10)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51519,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,11)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51518,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,12)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51517,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,13)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51516,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,14)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51515,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,15)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51514,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,16)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51513,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,17)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51512,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,18)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51511,axiom,
    ! [VarCurr: state_type] :
      ( v83601(VarCurr,19)
    <=> v83602(VarCurr) ) ).

tff(addAssignment_51510,axiom,
    ! [VarCurr: state_type] :
      ( v83602(VarCurr)
    <=> v83594(VarCurr) ) ).

tff(addAssignment_51509,axiom,
    ! [VarCurr: state_type] :
      ( v83594(VarCurr)
    <=> v83596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7620,axiom,
    ! [VarCurr: state_type] :
      ( v83596(VarCurr)
    <=> ( v83598(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_341,axiom,
    ! [VarCurr: state_type] :
      ( v83598(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51508,axiom,
    ! [VarCurr: state_type] :
      ( v83592(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51507,axiom,
    ! [VarCurr: state_type] :
      ( v83584(VarCurr)
    <=> v83586(VarCurr) ) ).

tff(addAssignment_51506,axiom,
    ! [VarCurr: state_type] :
      ( v83586(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51505,axiom,
    ! [VarCurr: state_type] :
      ( v83580(VarCurr)
    <=> v83582(VarCurr) ) ).

tff(addAssignment_51504,axiom,
    ! [VarCurr: state_type] :
      ( v83582(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51503,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,2)
    <=> v5461(VarCurr,2) ) ).

tff(addAssignment_51502,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,2)
    <=> v5463(VarCurr,2) ) ).

tff(addAssignment_51501,axiom,
    ! [VarNext: state_type] :
      ( v5463(VarNext,2)
    <=> v83562(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83563(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83562(VarNext,B)
            <=> v5463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_925,axiom,
    ! [VarNext: state_type] :
      ( v83563(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83562(VarNext,B)
          <=> v83573(VarNext,B) ) ) ) ).

tff(addAssignment_51500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83573(VarNext,B)
          <=> v83571(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83571(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_422,axiom,
    ! [VarCurr: state_type] :
      ( v83574(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83571(VarCurr,B)
          <=> v83538(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7619,axiom,
    ! [VarCurr: state_type] :
      ( v83574(VarCurr)
    <=> ( v83575(VarCurr)
        & v83576(VarCurr) ) ) ).

tff(writeUnaryOperator_3624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83576(VarCurr)
    <=> v83534(VarCurr) ) ).

tff(writeUnaryOperator_3623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83575(VarCurr)
    <=> v83530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83563(VarNext)
      <=> v83564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83564(VarNext)
      <=> ( v83565(VarNext)
          & v83558(VarNext) ) ) ) ).

tff(writeUnaryOperator_3622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83565(VarNext)
      <=> v83567(VarNext) ) ) ).

tff(addAssignment_51499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83567(VarNext)
      <=> v83558(VarCurr) ) ) ).

tff(addAssignment_51498,axiom,
    ! [VarCurr: state_type] :
      ( v83558(VarCurr)
    <=> v83560(VarCurr) ) ).

tff(addAssignment_51497,axiom,
    ! [VarCurr: state_type] :
      ( v83560(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51496,axiom,
    ! [VarCurr: state_type] :
      ( v83538(VarCurr,2)
    <=> v83540(VarCurr,2) ) ).

tff(addAssignment_51495,axiom,
    ! [VarCurr: state_type] :
      ( v83540(VarCurr,2)
    <=> v83549(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83549(VarCurr,B)
      <=> ( v83550(VarCurr,B)
          | v83553(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83553(VarCurr,B)
      <=> ( v5461(VarCurr,B)
          & v83554(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83554(VarCurr,B)
      <=> ~ v83555(VarCurr,B) ) ) ).

tff(addAssignment_51494,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,0)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51493,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,1)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51492,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,2)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51491,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,3)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51490,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,4)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51489,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,5)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51488,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,6)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51487,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,7)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51486,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,8)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51485,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,9)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51484,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,10)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51483,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,11)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51482,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,12)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51481,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,13)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51480,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,14)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51479,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,15)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51478,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,16)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51477,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,17)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51476,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,18)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51475,axiom,
    ! [VarCurr: state_type] :
      ( v83555(VarCurr,19)
    <=> v83556(VarCurr) ) ).

tff(addAssignment_51474,axiom,
    ! [VarCurr: state_type] :
      ( v83556(VarCurr)
    <=> v83544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83550(VarCurr,B)
      <=> ( v83542(VarCurr,B)
          & v83551(VarCurr,B) ) ) ) ).

tff(addAssignment_51473,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,0)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51472,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,1)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51471,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,2)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51470,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,3)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51469,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,4)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51468,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,5)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51467,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,6)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51466,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,7)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51465,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,8)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51464,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,9)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51463,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,10)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51462,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,11)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51461,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,12)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51460,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,13)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51459,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,14)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51458,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,15)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51457,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,16)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51456,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,17)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51455,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,18)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51454,axiom,
    ! [VarCurr: state_type] :
      ( v83551(VarCurr,19)
    <=> v83552(VarCurr) ) ).

tff(addAssignment_51453,axiom,
    ! [VarCurr: state_type] :
      ( v83552(VarCurr)
    <=> v83544(VarCurr) ) ).

tff(addAssignment_51452,axiom,
    ! [VarCurr: state_type] :
      ( v83544(VarCurr)
    <=> v83546(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7616,axiom,
    ! [VarCurr: state_type] :
      ( v83546(VarCurr)
    <=> ( v83548(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_340,axiom,
    ! [VarCurr: state_type] :
      ( v83548(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51451,axiom,
    ! [VarCurr: state_type] :
      ( v83542(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51450,axiom,
    ! [VarCurr: state_type] :
      ( v83534(VarCurr)
    <=> v83536(VarCurr) ) ).

tff(addAssignment_51449,axiom,
    ! [VarCurr: state_type] :
      ( v83536(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51448,axiom,
    ! [VarCurr: state_type] :
      ( v83530(VarCurr)
    <=> v83532(VarCurr) ) ).

tff(addAssignment_51447,axiom,
    ! [VarCurr: state_type] :
      ( v83532(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51446,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,2)
    <=> v5454(VarCurr,2) ) ).

tff(addAssignment_51445,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,2)
    <=> v5456(VarCurr,2) ) ).

tff(addAssignment_51444,axiom,
    ! [VarNext: state_type] :
      ( v5456(VarNext,2)
    <=> v83512(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83513(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83512(VarNext,B)
            <=> v5456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_924,axiom,
    ! [VarNext: state_type] :
      ( v83513(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83512(VarNext,B)
          <=> v83523(VarNext,B) ) ) ) ).

tff(addAssignment_51443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83523(VarNext,B)
          <=> v83521(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83521(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_421,axiom,
    ! [VarCurr: state_type] :
      ( v83524(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83521(VarCurr,B)
          <=> v83488(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7615,axiom,
    ! [VarCurr: state_type] :
      ( v83524(VarCurr)
    <=> ( v83525(VarCurr)
        & v83526(VarCurr) ) ) ).

tff(writeUnaryOperator_3620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83526(VarCurr)
    <=> v83484(VarCurr) ) ).

tff(writeUnaryOperator_3619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83525(VarCurr)
    <=> v83480(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83513(VarNext)
      <=> v83514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83514(VarNext)
      <=> ( v83515(VarNext)
          & v83508(VarNext) ) ) ) ).

tff(writeUnaryOperator_3618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83515(VarNext)
      <=> v83517(VarNext) ) ) ).

tff(addAssignment_51442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83517(VarNext)
      <=> v83508(VarCurr) ) ) ).

tff(addAssignment_51441,axiom,
    ! [VarCurr: state_type] :
      ( v83508(VarCurr)
    <=> v83510(VarCurr) ) ).

tff(addAssignment_51440,axiom,
    ! [VarCurr: state_type] :
      ( v83510(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51439,axiom,
    ! [VarCurr: state_type] :
      ( v83488(VarCurr,2)
    <=> v83490(VarCurr,2) ) ).

tff(addAssignment_51438,axiom,
    ! [VarCurr: state_type] :
      ( v83490(VarCurr,2)
    <=> v83499(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83499(VarCurr,B)
      <=> ( v83500(VarCurr,B)
          | v83503(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83503(VarCurr,B)
      <=> ( v5454(VarCurr,B)
          & v83504(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83504(VarCurr,B)
      <=> ~ v83505(VarCurr,B) ) ) ).

tff(addAssignment_51437,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,0)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51436,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,1)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51435,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,2)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51434,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,3)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51433,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,4)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51432,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,5)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51431,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,6)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51430,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,7)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51429,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,8)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51428,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,9)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51427,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,10)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51426,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,11)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51425,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,12)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51424,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,13)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51423,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,14)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51422,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,15)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51421,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,16)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51420,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,17)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51419,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,18)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51418,axiom,
    ! [VarCurr: state_type] :
      ( v83505(VarCurr,19)
    <=> v83506(VarCurr) ) ).

tff(addAssignment_51417,axiom,
    ! [VarCurr: state_type] :
      ( v83506(VarCurr)
    <=> v83494(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83500(VarCurr,B)
      <=> ( v83492(VarCurr,B)
          & v83501(VarCurr,B) ) ) ) ).

tff(addAssignment_51416,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,0)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51415,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,1)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51414,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,2)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51413,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,3)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51412,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,4)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51411,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,5)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51410,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,6)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51409,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,7)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51408,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,8)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51407,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,9)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51406,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,10)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51405,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,11)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51404,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,12)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51403,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,13)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51402,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,14)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51401,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,15)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51400,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,16)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51399,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,17)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51398,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,18)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51397,axiom,
    ! [VarCurr: state_type] :
      ( v83501(VarCurr,19)
    <=> v83502(VarCurr) ) ).

tff(addAssignment_51396,axiom,
    ! [VarCurr: state_type] :
      ( v83502(VarCurr)
    <=> v83494(VarCurr) ) ).

tff(addAssignment_51395,axiom,
    ! [VarCurr: state_type] :
      ( v83494(VarCurr)
    <=> v83496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7612,axiom,
    ! [VarCurr: state_type] :
      ( v83496(VarCurr)
    <=> ( v83498(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_339,axiom,
    ! [VarCurr: state_type] :
      ( v83498(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51394,axiom,
    ! [VarCurr: state_type] :
      ( v83492(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51393,axiom,
    ! [VarCurr: state_type] :
      ( v83484(VarCurr)
    <=> v83486(VarCurr) ) ).

tff(addAssignment_51392,axiom,
    ! [VarCurr: state_type] :
      ( v83486(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51391,axiom,
    ! [VarCurr: state_type] :
      ( v83480(VarCurr)
    <=> v83482(VarCurr) ) ).

tff(addAssignment_51390,axiom,
    ! [VarCurr: state_type] :
      ( v83482(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51389,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,2)
    <=> v5447(VarCurr,2) ) ).

tff(addAssignment_51388,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,2)
    <=> v5449(VarCurr,2) ) ).

tff(addAssignment_51387,axiom,
    ! [VarNext: state_type] :
      ( v5449(VarNext,2)
    <=> v83462(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83463(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83462(VarNext,B)
            <=> v5449(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_923,axiom,
    ! [VarNext: state_type] :
      ( v83463(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83462(VarNext,B)
          <=> v83473(VarNext,B) ) ) ) ).

tff(addAssignment_51386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83473(VarNext,B)
          <=> v83471(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83474(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83471(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_420,axiom,
    ! [VarCurr: state_type] :
      ( v83474(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83471(VarCurr,B)
          <=> v83438(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7611,axiom,
    ! [VarCurr: state_type] :
      ( v83474(VarCurr)
    <=> ( v83475(VarCurr)
        & v83476(VarCurr) ) ) ).

tff(writeUnaryOperator_3616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83476(VarCurr)
    <=> v83434(VarCurr) ) ).

tff(writeUnaryOperator_3615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83475(VarCurr)
    <=> v83430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83463(VarNext)
      <=> v83464(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83464(VarNext)
      <=> ( v83465(VarNext)
          & v83458(VarNext) ) ) ) ).

tff(writeUnaryOperator_3614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83465(VarNext)
      <=> v83467(VarNext) ) ) ).

tff(addAssignment_51385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83467(VarNext)
      <=> v83458(VarCurr) ) ) ).

tff(addAssignment_51384,axiom,
    ! [VarCurr: state_type] :
      ( v83458(VarCurr)
    <=> v83460(VarCurr) ) ).

tff(addAssignment_51383,axiom,
    ! [VarCurr: state_type] :
      ( v83460(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51382,axiom,
    ! [VarCurr: state_type] :
      ( v83438(VarCurr,2)
    <=> v83440(VarCurr,2) ) ).

tff(addAssignment_51381,axiom,
    ! [VarCurr: state_type] :
      ( v83440(VarCurr,2)
    <=> v83449(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83449(VarCurr,B)
      <=> ( v83450(VarCurr,B)
          | v83453(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83453(VarCurr,B)
      <=> ( v5447(VarCurr,B)
          & v83454(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83454(VarCurr,B)
      <=> ~ v83455(VarCurr,B) ) ) ).

tff(addAssignment_51380,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,0)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51379,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,1)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51378,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,2)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51377,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,3)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51376,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,4)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51375,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,5)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51374,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,6)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51373,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,7)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51372,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,8)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51371,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,9)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51370,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,10)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51369,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,11)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51368,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,12)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51367,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,13)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51366,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,14)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51365,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,15)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51364,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,16)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51363,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,17)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51362,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,18)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51361,axiom,
    ! [VarCurr: state_type] :
      ( v83455(VarCurr,19)
    <=> v83456(VarCurr) ) ).

tff(addAssignment_51360,axiom,
    ! [VarCurr: state_type] :
      ( v83456(VarCurr)
    <=> v83444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83450(VarCurr,B)
      <=> ( v83442(VarCurr,B)
          & v83451(VarCurr,B) ) ) ) ).

tff(addAssignment_51359,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,0)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51358,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,1)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51357,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,2)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51356,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,3)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51355,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,4)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51354,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,5)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51353,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,6)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51352,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,7)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51351,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,8)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51350,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,9)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51349,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,10)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51348,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,11)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51347,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,12)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51346,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,13)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51345,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,14)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51344,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,15)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51343,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,16)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51342,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,17)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51341,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,18)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51340,axiom,
    ! [VarCurr: state_type] :
      ( v83451(VarCurr,19)
    <=> v83452(VarCurr) ) ).

tff(addAssignment_51339,axiom,
    ! [VarCurr: state_type] :
      ( v83452(VarCurr)
    <=> v83444(VarCurr) ) ).

tff(addAssignment_51338,axiom,
    ! [VarCurr: state_type] :
      ( v83444(VarCurr)
    <=> v83446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7608,axiom,
    ! [VarCurr: state_type] :
      ( v83446(VarCurr)
    <=> ( v83448(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_338,axiom,
    ! [VarCurr: state_type] :
      ( v83448(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $true )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51337,axiom,
    ! [VarCurr: state_type] :
      ( v83442(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51336,axiom,
    ! [VarCurr: state_type] :
      ( v83434(VarCurr)
    <=> v83436(VarCurr) ) ).

tff(addAssignment_51335,axiom,
    ! [VarCurr: state_type] :
      ( v83436(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51334,axiom,
    ! [VarCurr: state_type] :
      ( v83430(VarCurr)
    <=> v83432(VarCurr) ) ).

tff(addAssignment_51333,axiom,
    ! [VarCurr: state_type] :
      ( v83432(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51332,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,2)
    <=> v5440(VarCurr,2) ) ).

tff(addAssignment_51331,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,2)
    <=> v5442(VarCurr,2) ) ).

tff(addAssignment_51330,axiom,
    ! [VarNext: state_type] :
      ( v5442(VarNext,2)
    <=> v83412(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83413(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83412(VarNext,B)
            <=> v5442(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_922,axiom,
    ! [VarNext: state_type] :
      ( v83413(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83412(VarNext,B)
          <=> v83423(VarNext,B) ) ) ) ).

tff(addAssignment_51329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83423(VarNext,B)
          <=> v83421(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83424(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83421(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_419,axiom,
    ! [VarCurr: state_type] :
      ( v83424(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83421(VarCurr,B)
          <=> v83388(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7607,axiom,
    ! [VarCurr: state_type] :
      ( v83424(VarCurr)
    <=> ( v83425(VarCurr)
        & v83426(VarCurr) ) ) ).

tff(writeUnaryOperator_3612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83426(VarCurr)
    <=> v83384(VarCurr) ) ).

tff(writeUnaryOperator_3611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83425(VarCurr)
    <=> v83380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83413(VarNext)
      <=> v83414(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83414(VarNext)
      <=> ( v83415(VarNext)
          & v83408(VarNext) ) ) ) ).

tff(writeUnaryOperator_3610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83415(VarNext)
      <=> v83417(VarNext) ) ) ).

tff(addAssignment_51328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83417(VarNext)
      <=> v83408(VarCurr) ) ) ).

tff(addAssignment_51327,axiom,
    ! [VarCurr: state_type] :
      ( v83408(VarCurr)
    <=> v83410(VarCurr) ) ).

tff(addAssignment_51326,axiom,
    ! [VarCurr: state_type] :
      ( v83410(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51325,axiom,
    ! [VarCurr: state_type] :
      ( v83388(VarCurr,2)
    <=> v83390(VarCurr,2) ) ).

tff(addAssignment_51324,axiom,
    ! [VarCurr: state_type] :
      ( v83390(VarCurr,2)
    <=> v83399(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83399(VarCurr,B)
      <=> ( v83400(VarCurr,B)
          | v83403(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83403(VarCurr,B)
      <=> ( v5440(VarCurr,B)
          & v83404(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83404(VarCurr,B)
      <=> ~ v83405(VarCurr,B) ) ) ).

tff(addAssignment_51323,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,0)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51322,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,1)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51321,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,2)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51320,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,3)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51319,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,4)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51318,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,5)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51317,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,6)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51316,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,7)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51315,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,8)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51314,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,9)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51313,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,10)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51312,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,11)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51311,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,12)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51310,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,13)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51309,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,14)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51308,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,15)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51307,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,16)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51306,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,17)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51305,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,18)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51304,axiom,
    ! [VarCurr: state_type] :
      ( v83405(VarCurr,19)
    <=> v83406(VarCurr) ) ).

tff(addAssignment_51303,axiom,
    ! [VarCurr: state_type] :
      ( v83406(VarCurr)
    <=> v83394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83400(VarCurr,B)
      <=> ( v83392(VarCurr,B)
          & v83401(VarCurr,B) ) ) ) ).

tff(addAssignment_51302,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,0)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51301,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,1)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51300,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,2)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51299,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,3)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51298,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,4)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51297,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,5)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51296,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,6)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51295,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,7)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51294,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,8)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51293,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,9)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51292,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,10)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51291,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,11)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51290,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,12)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51289,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,13)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51288,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,14)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51287,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,15)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51286,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,16)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51285,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,17)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51284,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,18)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51283,axiom,
    ! [VarCurr: state_type] :
      ( v83401(VarCurr,19)
    <=> v83402(VarCurr) ) ).

tff(addAssignment_51282,axiom,
    ! [VarCurr: state_type] :
      ( v83402(VarCurr)
    <=> v83394(VarCurr) ) ).

tff(addAssignment_51281,axiom,
    ! [VarCurr: state_type] :
      ( v83394(VarCurr)
    <=> v83396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7604,axiom,
    ! [VarCurr: state_type] :
      ( v83396(VarCurr)
    <=> ( v83398(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_337,axiom,
    ! [VarCurr: state_type] :
      ( v83398(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51280,axiom,
    ! [VarCurr: state_type] :
      ( v83392(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51279,axiom,
    ! [VarCurr: state_type] :
      ( v83384(VarCurr)
    <=> v83386(VarCurr) ) ).

tff(addAssignment_51278,axiom,
    ! [VarCurr: state_type] :
      ( v83386(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51277,axiom,
    ! [VarCurr: state_type] :
      ( v83380(VarCurr)
    <=> v83382(VarCurr) ) ).

tff(addAssignment_51276,axiom,
    ! [VarCurr: state_type] :
      ( v83382(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51275,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,2)
    <=> v5433(VarCurr,2) ) ).

tff(addAssignment_51274,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,2)
    <=> v5435(VarCurr,2) ) ).

tff(addAssignment_51273,axiom,
    ! [VarNext: state_type] :
      ( v5435(VarNext,2)
    <=> v83362(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83363(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83362(VarNext,B)
            <=> v5435(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_921,axiom,
    ! [VarNext: state_type] :
      ( v83363(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83362(VarNext,B)
          <=> v83373(VarNext,B) ) ) ) ).

tff(addAssignment_51272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83373(VarNext,B)
          <=> v83371(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83374(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83371(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_418,axiom,
    ! [VarCurr: state_type] :
      ( v83374(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83371(VarCurr,B)
          <=> v83338(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7603,axiom,
    ! [VarCurr: state_type] :
      ( v83374(VarCurr)
    <=> ( v83375(VarCurr)
        & v83376(VarCurr) ) ) ).

tff(writeUnaryOperator_3608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83376(VarCurr)
    <=> v83334(VarCurr) ) ).

tff(writeUnaryOperator_3607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83375(VarCurr)
    <=> v83330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83363(VarNext)
      <=> v83364(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83364(VarNext)
      <=> ( v83365(VarNext)
          & v83358(VarNext) ) ) ) ).

tff(writeUnaryOperator_3606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83365(VarNext)
      <=> v83367(VarNext) ) ) ).

tff(addAssignment_51271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83367(VarNext)
      <=> v83358(VarCurr) ) ) ).

tff(addAssignment_51270,axiom,
    ! [VarCurr: state_type] :
      ( v83358(VarCurr)
    <=> v83360(VarCurr) ) ).

tff(addAssignment_51269,axiom,
    ! [VarCurr: state_type] :
      ( v83360(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51268,axiom,
    ! [VarCurr: state_type] :
      ( v83338(VarCurr,2)
    <=> v83340(VarCurr,2) ) ).

tff(addAssignment_51267,axiom,
    ! [VarCurr: state_type] :
      ( v83340(VarCurr,2)
    <=> v83349(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83349(VarCurr,B)
      <=> ( v83350(VarCurr,B)
          | v83353(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83353(VarCurr,B)
      <=> ( v5433(VarCurr,B)
          & v83354(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83354(VarCurr,B)
      <=> ~ v83355(VarCurr,B) ) ) ).

tff(addAssignment_51266,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,0)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51265,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,1)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51264,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,2)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51263,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,3)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51262,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,4)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51261,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,5)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51260,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,6)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51259,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,7)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51258,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,8)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51257,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,9)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51256,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,10)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51255,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,11)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51254,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,12)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51253,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,13)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51252,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,14)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51251,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,15)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51250,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,16)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51249,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,17)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51248,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,18)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51247,axiom,
    ! [VarCurr: state_type] :
      ( v83355(VarCurr,19)
    <=> v83356(VarCurr) ) ).

tff(addAssignment_51246,axiom,
    ! [VarCurr: state_type] :
      ( v83356(VarCurr)
    <=> v83344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83350(VarCurr,B)
      <=> ( v83342(VarCurr,B)
          & v83351(VarCurr,B) ) ) ) ).

tff(addAssignment_51245,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,0)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51244,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,1)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51243,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,2)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51242,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,3)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51241,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,4)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51240,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,5)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51239,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,6)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51238,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,7)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51237,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,8)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51236,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,9)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51235,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,10)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51234,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,11)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51233,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,12)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51232,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,13)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51231,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,14)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51230,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,15)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51229,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,16)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51228,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,17)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51227,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,18)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51226,axiom,
    ! [VarCurr: state_type] :
      ( v83351(VarCurr,19)
    <=> v83352(VarCurr) ) ).

tff(addAssignment_51225,axiom,
    ! [VarCurr: state_type] :
      ( v83352(VarCurr)
    <=> v83344(VarCurr) ) ).

tff(addAssignment_51224,axiom,
    ! [VarCurr: state_type] :
      ( v83344(VarCurr)
    <=> v83346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7600,axiom,
    ! [VarCurr: state_type] :
      ( v83346(VarCurr)
    <=> ( v83348(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_336,axiom,
    ! [VarCurr: state_type] :
      ( v83348(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $true )
        & ( v83042(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_51223,axiom,
    ! [VarCurr: state_type] :
      ( v83342(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51222,axiom,
    ! [VarCurr: state_type] :
      ( v83334(VarCurr)
    <=> v83336(VarCurr) ) ).

tff(addAssignment_51221,axiom,
    ! [VarCurr: state_type] :
      ( v83336(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51220,axiom,
    ! [VarCurr: state_type] :
      ( v83330(VarCurr)
    <=> v83332(VarCurr) ) ).

tff(addAssignment_51219,axiom,
    ! [VarCurr: state_type] :
      ( v83332(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51218,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,2)
    <=> v5426(VarCurr,2) ) ).

tff(addAssignment_51217,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,2)
    <=> v5428(VarCurr,2) ) ).

tff(addAssignment_51216,axiom,
    ! [VarNext: state_type] :
      ( v5428(VarNext,2)
    <=> v83312(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83313(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83312(VarNext,B)
            <=> v5428(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_920,axiom,
    ! [VarNext: state_type] :
      ( v83313(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83312(VarNext,B)
          <=> v83323(VarNext,B) ) ) ) ).

tff(addAssignment_51215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83323(VarNext,B)
          <=> v83321(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83324(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83321(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_417,axiom,
    ! [VarCurr: state_type] :
      ( v83324(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83321(VarCurr,B)
          <=> v83288(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7599,axiom,
    ! [VarCurr: state_type] :
      ( v83324(VarCurr)
    <=> ( v83325(VarCurr)
        & v83326(VarCurr) ) ) ).

tff(writeUnaryOperator_3604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83326(VarCurr)
    <=> v83284(VarCurr) ) ).

tff(writeUnaryOperator_3603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83325(VarCurr)
    <=> v83280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83313(VarNext)
      <=> v83314(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83314(VarNext)
      <=> ( v83315(VarNext)
          & v83308(VarNext) ) ) ) ).

tff(writeUnaryOperator_3602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83315(VarNext)
      <=> v83317(VarNext) ) ) ).

tff(addAssignment_51214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83317(VarNext)
      <=> v83308(VarCurr) ) ) ).

tff(addAssignment_51213,axiom,
    ! [VarCurr: state_type] :
      ( v83308(VarCurr)
    <=> v83310(VarCurr) ) ).

tff(addAssignment_51212,axiom,
    ! [VarCurr: state_type] :
      ( v83310(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51211,axiom,
    ! [VarCurr: state_type] :
      ( v83288(VarCurr,2)
    <=> v83290(VarCurr,2) ) ).

tff(addAssignment_51210,axiom,
    ! [VarCurr: state_type] :
      ( v83290(VarCurr,2)
    <=> v83299(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83299(VarCurr,B)
      <=> ( v83300(VarCurr,B)
          | v83303(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83303(VarCurr,B)
      <=> ( v5426(VarCurr,B)
          & v83304(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83304(VarCurr,B)
      <=> ~ v83305(VarCurr,B) ) ) ).

tff(addAssignment_51209,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,0)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51208,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,1)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51207,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,2)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51206,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,3)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51205,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,4)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51204,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,5)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51203,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,6)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51202,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,7)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51201,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,8)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51200,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,9)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51199,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,10)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51198,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,11)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51197,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,12)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51196,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,13)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51195,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,14)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51194,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,15)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51193,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,16)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51192,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,17)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51191,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,18)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51190,axiom,
    ! [VarCurr: state_type] :
      ( v83305(VarCurr,19)
    <=> v83306(VarCurr) ) ).

tff(addAssignment_51189,axiom,
    ! [VarCurr: state_type] :
      ( v83306(VarCurr)
    <=> v83294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83300(VarCurr,B)
      <=> ( v83292(VarCurr,B)
          & v83301(VarCurr,B) ) ) ) ).

tff(addAssignment_51188,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,0)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51187,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,1)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51186,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,2)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51185,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,3)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51184,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,4)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51183,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,5)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51182,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,6)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51181,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,7)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51180,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,8)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51179,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,9)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51178,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,10)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51177,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,11)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51176,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,12)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51175,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,13)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51174,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,14)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51173,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,15)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51172,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,16)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51171,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,17)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51170,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,18)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51169,axiom,
    ! [VarCurr: state_type] :
      ( v83301(VarCurr,19)
    <=> v83302(VarCurr) ) ).

tff(addAssignment_51168,axiom,
    ! [VarCurr: state_type] :
      ( v83302(VarCurr)
    <=> v83294(VarCurr) ) ).

tff(addAssignment_51167,axiom,
    ! [VarCurr: state_type] :
      ( v83294(VarCurr)
    <=> v83296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7596,axiom,
    ! [VarCurr: state_type] :
      ( v83296(VarCurr)
    <=> ( v83298(VarCurr)
        & v83064(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_335,axiom,
    ! [VarCurr: state_type] :
      ( v83298(VarCurr)
    <=> ( ( v83042(VarCurr,3)
        <=> $false )
        & ( v83042(VarCurr,2)
        <=> $false )
        & ( v83042(VarCurr,1)
        <=> $false )
        & ( v83042(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51166,axiom,
    ! [VarCurr: state_type] :
      ( v83292(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51165,axiom,
    ! [VarCurr: state_type] :
      ( v83284(VarCurr)
    <=> v83286(VarCurr) ) ).

tff(addAssignment_51164,axiom,
    ! [VarCurr: state_type] :
      ( v83286(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51163,axiom,
    ! [VarCurr: state_type] :
      ( v83280(VarCurr)
    <=> v83282(VarCurr) ) ).

tff(addAssignment_51162,axiom,
    ! [VarCurr: state_type] :
      ( v83282(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51161,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,2)
    <=> v5420(VarCurr,2) ) ).

tff(addAssignment_51160,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,2)
    <=> v5422(VarCurr,2) ) ).

tff(addAssignment_51159,axiom,
    ! [VarNext: state_type] :
      ( v5422(VarNext,2)
    <=> v83262(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83263(VarNext)
       => ! [B: $int] :
            ( ( $less(B,20)
              & ~ $less(B,0) )
           => ( v83262(VarNext,B)
            <=> v5422(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_919,axiom,
    ! [VarNext: state_type] :
      ( v83263(VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83262(VarNext,B)
          <=> v83273(VarNext,B) ) ) ) ).

tff(addAssignment_51158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83273(VarNext,B)
          <=> v83271(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83274(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83271(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_416,axiom,
    ! [VarCurr: state_type] :
      ( v83274(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,20)
            & ~ $less(B,0) )
         => ( v83271(VarCurr,B)
          <=> v82920(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7595,axiom,
    ! [VarCurr: state_type] :
      ( v83274(VarCurr)
    <=> ( v83275(VarCurr)
        & v83276(VarCurr) ) ) ).

tff(writeUnaryOperator_3600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83276(VarCurr)
    <=> v82916(VarCurr) ) ).

tff(writeUnaryOperator_3599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83275(VarCurr)
    <=> v82912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83263(VarNext)
      <=> v83264(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83264(VarNext)
      <=> ( v83265(VarNext)
          & v83256(VarNext) ) ) ) ).

tff(writeUnaryOperator_3598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v83265(VarNext)
      <=> v83267(VarNext) ) ) ).

tff(addAssignment_51157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v83267(VarNext)
      <=> v83256(VarCurr) ) ) ).

tff(addAssignment_51156,axiom,
    ! [VarCurr: state_type] :
      ( v83256(VarCurr)
    <=> v83258(VarCurr) ) ).

tff(addAssignment_51155,axiom,
    ! [VarCurr: state_type] :
      ( v83258(VarCurr)
    <=> v83260(VarCurr) ) ).

tff(addAssignment_51154,axiom,
    ! [VarCurr: state_type] :
      ( v83260(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_51153,axiom,
    ! [VarCurr: state_type] :
      ( v82920(VarCurr,2)
    <=> v82922(VarCurr,2) ) ).

tff(addAssignment_51152,axiom,
    ! [VarCurr: state_type] :
      ( v82922(VarCurr,2)
    <=> v83246(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83246(VarCurr,B)
      <=> ( v83247(VarCurr,B)
          | v83250(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83250(VarCurr,B)
      <=> ( v5420(VarCurr,B)
          & v83251(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83251(VarCurr,B)
      <=> ~ v83252(VarCurr,B) ) ) ).

tff(addAssignment_51151,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,0)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51150,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,1)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51149,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,2)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51148,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,3)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51147,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,4)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51146,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,5)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51145,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,6)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51144,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,7)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51143,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,8)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51142,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,9)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51141,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,10)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51140,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,11)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51139,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,12)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51138,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,13)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51137,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,14)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51136,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,15)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51135,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,16)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51134,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,17)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51133,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,18)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51132,axiom,
    ! [VarCurr: state_type] :
      ( v83252(VarCurr,19)
    <=> v83253(VarCurr) ) ).

tff(addAssignment_51131,axiom,
    ! [VarCurr: state_type] :
      ( v83253(VarCurr)
    <=> v83038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v83247(VarCurr,B)
      <=> ( v82924(VarCurr,B)
          & v83248(VarCurr,B) ) ) ) ).

tff(addAssignment_51130,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,0)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51129,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,1)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51128,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,2)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51127,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,3)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51126,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,4)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51125,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,5)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51124,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,6)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51123,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,7)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51122,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,8)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51121,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,9)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51120,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,10)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51119,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,11)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51118,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,12)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51117,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,13)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51116,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,14)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51115,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,15)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51114,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,16)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51113,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,17)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51112,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,18)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51111,axiom,
    ! [VarCurr: state_type] :
      ( v83248(VarCurr,19)
    <=> v83249(VarCurr) ) ).

tff(addAssignment_51110,axiom,
    ! [VarCurr: state_type] :
      ( v83249(VarCurr)
    <=> v83038(VarCurr) ) ).

tff(addAssignment_51109,axiom,
    ! [VarCurr: state_type] :
      ( v82924(VarCurr,2)
    <=> v82926(VarCurr,2) ) ).

tff(addAssignment_51108,axiom,
    ! [VarCurr: state_type] :
      ( v82926(VarCurr,2)
    <=> v82928(VarCurr,2) ) ).

tff(addAssignment_51107,axiom,
    ! [VarCurr: state_type] :
      ( v82928(VarCurr,2)
    <=> v82930(VarCurr,2) ) ).

tff(addAssignment_51106,axiom,
    ! [VarCurr: state_type] :
      ( v82930(VarCurr,2)
    <=> v82932(VarCurr,2) ) ).

tff(addAssignment_51105,axiom,
    ! [VarCurr: state_type] :
      ( v82932(VarCurr,2)
    <=> v83008(VarCurr,2) ) ).

tff(addAssignment_51104,axiom,
    ! [VarCurr: state_type] :
      ( v83032(VarCurr,0)
    <=> v83243(VarCurr,0) ) ).

tff(addAssignment_51103,axiom,
    ! [VarCurr: state_type] :
      ( v83243(VarCurr,0)
    <=> v83245(VarCurr,0) ) ).

tff(addAssignment_51102,axiom,
    ! [VarCurr: state_type] :
      ( v83229(VarCurr)
    <=> v83231(VarCurr) ) ).

tff(addAssignment_51101,axiom,
    ! [VarCurr: state_type] :
      ( v83231(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_51100,axiom,
    ! [VarCurr: state_type] :
      ( v83225(VarCurr)
    <=> v83227(VarCurr) ) ).

tff(addAssignment_51099,axiom,
    ! [VarCurr: state_type] :
      ( v83227(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_51098,axiom,
    ! [VarCurr: state_type] :
      ( v83199(VarCurr)
    <=> v83201(VarCurr) ) ).

tff(addAssignment_51097,axiom,
    ! [VarCurr: state_type] :
      ( v83201(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51096,axiom,
    ! [VarCurr: state_type] :
      ( v83195(VarCurr)
    <=> v83197(VarCurr) ) ).

tff(addAssignment_51095,axiom,
    ! [VarCurr: state_type] :
      ( v83197(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51094,axiom,
    ! [VarCurr: state_type] :
      ( v83177(VarCurr)
    <=> v83179(VarCurr) ) ).

tff(addAssignment_51093,axiom,
    ! [VarCurr: state_type] :
      ( v83179(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51092,axiom,
    ! [VarCurr: state_type] :
      ( v83173(VarCurr)
    <=> v83175(VarCurr) ) ).

tff(addAssignment_51091,axiom,
    ! [VarCurr: state_type] :
      ( v83175(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51090,axiom,
    ! [VarCurr: state_type] :
      ( v83140(VarCurr,2)
    <=> v83142(VarCurr,2) ) ).

tff(addAssignment_51089,axiom,
    ! [VarCurr: state_type] :
      ( v83142(VarCurr,2)
    <=> v83143(VarCurr,2) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83144(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83143(VarCurr,B)
          <=> v83147(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_415,axiom,
    ! [VarCurr: state_type] :
      ( v83144(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83143(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_51088,axiom,
    ! [VarCurr: state_type] :
      ( v83147(VarCurr,0)
    <=> v83157(VarCurr) ) ).

tff(addAssignment_51087,axiom,
    ! [VarCurr: state_type] :
      ( v83147(VarCurr,1)
    <=> v83155(VarCurr) ) ).

tff(addAssignment_51086,axiom,
    ! [VarCurr: state_type] :
      ( v83147(VarCurr,2)
    <=> v83149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7592,axiom,
    ! [VarCurr: state_type] :
      ( v83155(VarCurr)
    <=> ( v83156(VarCurr)
        & v83159(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_605,axiom,
    ! [VarCurr: state_type] :
      ( v83159(VarCurr)
    <=> ( v83122(VarCurr,0)
        | v83122(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7591,axiom,
    ! [VarCurr: state_type] :
      ( v83156(VarCurr)
    <=> ( v83157(VarCurr)
        | v83158(VarCurr) ) ) ).

tff(writeUnaryOperator_3596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83158(VarCurr)
    <=> v83122(VarCurr,1) ) ).

tff(writeUnaryOperator_3595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83157(VarCurr)
    <=> v83122(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7590,axiom,
    ! [VarCurr: state_type] :
      ( v83149(VarCurr)
    <=> ( v83150(VarCurr)
        & v83154(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_604,axiom,
    ! [VarCurr: state_type] :
      ( v83154(VarCurr)
    <=> ( v83152(VarCurr)
        | v83122(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7589,axiom,
    ! [VarCurr: state_type] :
      ( v83150(VarCurr)
    <=> ( v83151(VarCurr)
        | v83153(VarCurr) ) ) ).

tff(writeUnaryOperator_3594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83153(VarCurr)
    <=> v83122(VarCurr,2) ) ).

tff(writeUnaryOperator_3593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83151(VarCurr)
    <=> v83152(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_603,axiom,
    ! [VarCurr: state_type] :
      ( v83152(VarCurr)
    <=> ( v83122(VarCurr,0)
        & v83122(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7588,axiom,
    ! [VarCurr: state_type] :
      ( v83144(VarCurr)
    <=> ( v83145(VarCurr)
        & v83146(VarCurr) ) ) ).

tff(writeUnaryOperator_3592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83146(VarCurr)
    <=> v1051(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_334,axiom,
    ! [VarCurr: state_type] :
      ( v83145(VarCurr)
    <=> ( ( v83122(VarCurr,2)
        <=> $false )
        & ( v83122(VarCurr,1)
        <=> $true )
        & ( v83122(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_51085,axiom,
    ! [VarCurr: state_type] :
      ( v83132(VarCurr)
    <=> v83134(VarCurr) ) ).

tff(addAssignment_51084,axiom,
    ! [VarCurr: state_type] :
      ( v83134(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51083,axiom,
    ! [VarCurr: state_type] :
      ( v83128(VarCurr)
    <=> v83130(VarCurr) ) ).

tff(addAssignment_51082,axiom,
    ! [VarCurr: state_type] :
      ( v83130(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51081,axiom,
    ! [VarCurr: state_type] :
      ( v83110(VarCurr)
    <=> v83112(VarCurr) ) ).

tff(addAssignment_51080,axiom,
    ! [VarCurr: state_type] :
      ( v83112(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51079,axiom,
    ! [VarCurr: state_type] :
      ( v83106(VarCurr)
    <=> v83108(VarCurr) ) ).

tff(addAssignment_51078,axiom,
    ! [VarCurr: state_type] :
      ( v83108(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51077,axiom,
    ! [VarCurr: state_type] :
      ( v83084(VarCurr)
    <=> v83086(VarCurr) ) ).

tff(addAssignment_51076,axiom,
    ! [VarCurr: state_type] :
      ( v83086(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51075,axiom,
    ! [VarCurr: state_type] :
      ( v83080(VarCurr)
    <=> v83082(VarCurr) ) ).

tff(addAssignment_51074,axiom,
    ! [VarCurr: state_type] :
      ( v83082(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51073,axiom,
    ! [VarCurr: state_type] :
      ( v83052(VarCurr)
    <=> v83054(VarCurr) ) ).

tff(addAssignment_51072,axiom,
    ! [VarCurr: state_type] :
      ( v83054(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51071,axiom,
    ! [VarCurr: state_type] :
      ( v83048(VarCurr)
    <=> v83050(VarCurr) ) ).

tff(addAssignment_51070,axiom,
    ! [VarCurr: state_type] :
      ( v83050(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_51069,axiom,
    ! [VarCurr: state_type] :
      ( v82924(VarCurr,19)
    <=> v82926(VarCurr,19) ) ).

tff(addAssignment_51068,axiom,
    ! [VarCurr: state_type] :
      ( v82926(VarCurr,19)
    <=> v82928(VarCurr,19) ) ).

tff(addAssignment_51067,axiom,
    ! [VarCurr: state_type] :
      ( v82928(VarCurr,19)
    <=> v82930(VarCurr,19) ) ).

tff(addAssignment_51066,axiom,
    ! [VarCurr: state_type] :
      ( v82930(VarCurr,19)
    <=> v82932(VarCurr,19) ) ).

tff(addAssignment_51065,axiom,
    ! [VarCurr: state_type] :
      ( v82932(VarCurr,19)
    <=> v83008(VarCurr,19) ) ).

tff(addAssignment_51064,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,0)
    <=> v83035(VarCurr) ) ).

tff(addAssignment_51063,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,1)
    <=> v83033(VarCurr) ) ).

tff(addAssignment_51062,axiom,
    ! [VarCurr: state_type] :
      ( ( v83008(VarCurr,4)
      <=> v83028(VarCurr,2) )
      & ( v83008(VarCurr,3)
      <=> v83028(VarCurr,1) )
      & ( v83008(VarCurr,2)
      <=> v83028(VarCurr,0) ) ) ).

tff(addAssignment_51061,axiom,
    ! [VarCurr: state_type] :
      ( ( v83008(VarCurr,7)
      <=> v83025(VarCurr,2) )
      & ( v83008(VarCurr,6)
      <=> v83025(VarCurr,1) )
      & ( v83008(VarCurr,5)
      <=> v83025(VarCurr,0) ) ) ).

tff(addAssignment_51060,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,8)
    <=> v83023(VarCurr) ) ).

tff(addAssignment_51059,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,9)
    <=> v83022(VarCurr) ) ).

tff(addAssignment_51058,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,10)
    <=> v83017(VarCurr) ) ).

tff(addAssignment_51057,axiom,
    ! [VarCurr: state_type] :
      ( ( v83008(VarCurr,13)
      <=> v83014(VarCurr,2) )
      & ( v83008(VarCurr,12)
      <=> v83014(VarCurr,1) )
      & ( v83008(VarCurr,11)
      <=> v83014(VarCurr,0) ) ) ).

tff(addAssignment_51056,axiom,
    ! [VarCurr: state_type] :
      ( ( v83008(VarCurr,16)
      <=> v83013(VarCurr,2) )
      & ( v83008(VarCurr,15)
      <=> v83013(VarCurr,1) )
      & ( v83008(VarCurr,14)
      <=> v83013(VarCurr,0) ) ) ).

tff(addAssignment_51055,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,17)
    <=> v83012(VarCurr) ) ).

tff(addAssignment_51054,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,18)
    <=> v83010(VarCurr) ) ).

tff(addAssignment_51053,axiom,
    ! [VarCurr: state_type] :
      ( v83008(VarCurr,19)
    <=> v83009(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82934(VarCurr)
     => ( v83035(VarCurr)
      <=> v83036(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_414,axiom,
    ! [VarCurr: state_type] :
      ( v82934(VarCurr)
     => ( v83035(VarCurr)
      <=> v5218(VarCurr) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_5,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1051(VarCurr)
     => ( v83033(VarCurr)
      <=> v83034(VarCurr,1) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_7,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
     => ( v83033(VarCurr)
      <=> v83034(VarCurr,2) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83029(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83028(VarCurr,B)
          <=> v83032(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_413,axiom,
    ! [VarCurr: state_type] :
      ( v83029(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83028(VarCurr,B)
          <=> v83031(VarCurr,B) ) ) ) ).

tff(addAssignment_51052,axiom,
    ! [VarCurr: state_type] :
      ( v83031(VarCurr,0)
    <=> v8(VarCurr,0) ) ).

tff(addAssignment_51051,axiom,
    ! [VarCurr: state_type] :
      ( ( v83031(VarCurr,2)
      <=> $false )
      & ( v83031(VarCurr,1)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7587,axiom,
    ! [VarCurr: state_type] :
      ( v83029(VarCurr)
    <=> ( v82934(VarCurr)
        & v83030(VarCurr) ) ) ).

tff(writeUnaryOperator_3591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83030(VarCurr)
    <=> v82965(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82934(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83025(VarCurr,B)
          <=> v83027(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_412,axiom,
    ! [VarCurr: state_type] :
      ( v82934(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v83025(VarCurr,B)
          <=> v83026(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82934(VarCurr)
     => ( v83023(VarCurr)
      <=> v83024(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_411,axiom,
    ! [VarCurr: state_type] :
      ( v82934(VarCurr)
     => ( v83023(VarCurr)
      <=> v5414(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83018(VarCurr)
     => ( v83017(VarCurr)
      <=> v83021(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_410,axiom,
    ! [VarCurr: state_type] :
      ( v83018(VarCurr)
     => ( v83017(VarCurr)
      <=> v83020(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7586,axiom,
    ! [VarCurr: state_type] :
      ( v83018(VarCurr)
    <=> ( v82934(VarCurr)
        & v83019(VarCurr) ) ) ).

tff(writeUnaryOperator_3590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83019(VarCurr)
    <=> v82965(VarCurr) ) ).

tff(addAssignment_51050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v83014(VarCurr,B)
      <=> v83016(VarCurr,B) ) ) ).

tff(addAssignment_51049,axiom,
    ! [VarCurr: state_type] :
      ( v83014(VarCurr,2)
    <=> v83015(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7585,axiom,
    ! [VarCurr: state_type] :
      ( v83010(VarCurr)
    <=> ( v82934(VarCurr)
        & v83011(VarCurr) ) ) ).

tff(writeUnaryOperator_3589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83011(VarCurr)
    <=> v82965(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7584,axiom,
    ! [VarCurr: state_type] :
      ( v83009(VarCurr)
    <=> ( v82934(VarCurr)
        & v82965(VarCurr) ) ) ).

tff(addAssignment_51048,axiom,
    ! [VarCurr: state_type] :
      ( v82965(VarCurr)
    <=> v82967(VarCurr,3) ) ).

tff(addAssignment_51047,axiom,
    ! [VarCurr: state_type] :
      ( v82967(VarCurr,3)
    <=> v82969(VarCurr,3) ) ).

tff(addAssignment_51046,axiom,
    ! [VarNext: state_type] :
      ( v82969(VarNext,3)
    <=> v82991(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82992(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v82991(VarNext,B)
            <=> v82969(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_918,axiom,
    ! [VarNext: state_type] :
      ( v82992(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v82991(VarNext,B)
          <=> v83002(VarNext,B) ) ) ) ).

tff(addAssignment_51045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v83002(VarNext,B)
          <=> v83000(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83003(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v83000(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_409,axiom,
    ! [VarCurr: state_type] :
      ( v83003(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v83000(VarCurr,B)
          <=> v82979(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7583,axiom,
    ! [VarCurr: state_type] :
      ( v83003(VarCurr)
    <=> ( v83004(VarCurr)
        & v83005(VarCurr) ) ) ).

tff(writeUnaryOperator_3588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83005(VarCurr)
    <=> v82975(VarCurr) ) ).

tff(writeUnaryOperator_3587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v83004(VarCurr)
    <=> v82971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82992(VarNext)
      <=> v82993(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82993(VarNext)
      <=> ( v82994(VarNext)
          & v82987(VarNext) ) ) ) ).

tff(writeUnaryOperator_3586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82994(VarNext)
      <=> v82996(VarNext) ) ) ).

tff(addAssignment_51044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82996(VarNext)
      <=> v82987(VarCurr) ) ) ).

tff(addAssignment_51043,axiom,
    ! [VarCurr: state_type] :
      ( v82987(VarCurr)
    <=> v82989(VarCurr) ) ).

tff(addAssignment_51042,axiom,
    ! [VarCurr: state_type] :
      ( v82989(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_51041,axiom,
    ! [VarCurr: state_type] :
      ( v82979(VarCurr,3)
    <=> v82981(VarCurr,3) ) ).

tff(addAssignment_51040,axiom,
    ! [VarCurr: state_type] :
      ( v82981(VarCurr,3)
    <=> v82983(VarCurr,3) ) ).

tff(addAssignment_51039,axiom,
    ! [VarCurr: state_type] :
      ( v82983(VarCurr,3)
    <=> v82984(VarCurr,3) ) ).

tff(addAssignment_51038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v82984(VarCurr,B)
      <=> v82985(VarCurr,B) ) ) ).

tff(addAssignment_51037,axiom,
    ! [VarCurr: state_type] :
      ( v82984(VarCurr,3)
    <=> v779(VarCurr) ) ).

tff(addAssignment_51036,axiom,
    ! [VarCurr: state_type] :
      ( v82975(VarCurr)
    <=> v82977(VarCurr) ) ).

tff(addAssignment_51035,axiom,
    ! [VarCurr: state_type] :
      ( v82977(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51034,axiom,
    ! [VarCurr: state_type] :
      ( v82971(VarCurr)
    <=> v82973(VarCurr) ) ).

tff(addAssignment_51033,axiom,
    ! [VarCurr: state_type] :
      ( v82973(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51032,axiom,
    ! [VarCurr: state_type] :
      ( v82944(VarCurr)
    <=> v82946(VarCurr) ) ).

tff(addAssignment_51031,axiom,
    ! [VarCurr: state_type] :
      ( v82946(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_51030,axiom,
    ! [VarCurr: state_type] :
      ( v82940(VarCurr)
    <=> v82942(VarCurr) ) ).

tff(addAssignment_51029,axiom,
    ! [VarCurr: state_type] :
      ( v82942(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_51028,axiom,
    ! [VarCurr: state_type] :
      ( v82916(VarCurr)
    <=> v82918(VarCurr) ) ).

tff(addAssignment_51027,axiom,
    ! [VarCurr: state_type] :
      ( v82918(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_51026,axiom,
    ! [VarCurr: state_type] :
      ( v82912(VarCurr)
    <=> v82914(VarCurr) ) ).

tff(addAssignment_51025,axiom,
    ! [VarCurr: state_type] :
      ( v82914(VarCurr)
    <=> v978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7580,axiom,
    ! [VarCurr: state_type] :
      ( v82153(VarCurr)
    <=> ( v82904(VarCurr)
        | v82906(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_602,axiom,
    ! [VarCurr: state_type] :
      ( v82906(VarCurr)
    <=> ( v82894(VarCurr,0)
        | v82894(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_601,axiom,
    ! [VarCurr: state_type] :
      ( v82904(VarCurr)
    <=> ( v82113(VarCurr,0)
        | v82113(VarCurr,1) ) ) ).

tff(addAssignment_51024,axiom,
    ! [VarCurr: state_type] :
      ( ( v82894(VarCurr,1)
      <=> v82093(VarCurr,3) )
      & ( v82894(VarCurr,0)
      <=> v82093(VarCurr,2) ) ) ).

tff(addAssignment_51023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v82093(VarCurr,B)
      <=> v82095(VarCurr,B) ) ) ).

tff(addAssignment_51022,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v82095(VarNext,B)
      <=> v82896(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82897(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v82896(VarNext,B)
            <=> v82095(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_917,axiom,
    ! [VarNext: state_type] :
      ( v82897(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v82896(VarNext,B)
          <=> v82141(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82897(VarNext)
      <=> v82898(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82898(VarNext)
      <=> ( v82900(VarNext)
          & v82126(VarNext) ) ) ) ).

tff(writeUnaryOperator_3585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82900(VarNext)
      <=> v82135(VarNext) ) ) ).

tff(addAssignment_51021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v82105(VarCurr,B)
      <=> v82107(VarCurr,B) ) ) ).

tff(addAssignment_51020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v82107(VarCurr,B)
      <=> v82116(VarCurr,B) ) ) ).

tff(addAssignment_51019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,2) )
     => ( v82109(VarCurr,B)
      <=> v82110(VarCurr,B) ) ) ).

tff(addAssignment_51018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82113(VarCurr,B)
      <=> v82156(VarCurr,B) ) ) ).

tff(addAssignment_51017,axiom,
    ! [VarCurr: state_type] :
      ( v82156(VarCurr,1)
    <=> v82526(VarCurr) ) ).

tff(addAssignment_51016,axiom,
    ! [VarCurr: state_type] :
      ( v82156(VarCurr,0)
    <=> v82158(VarCurr) ) ).

tff(addAssignment_51015,axiom,
    ! [VarCurr: state_type] :
      ( v82526(VarCurr)
    <=> v82528(VarCurr,0) ) ).

tff(addAssignment_51014,axiom,
    ! [VarCurr: state_type] :
      ( v82528(VarCurr,0)
    <=> v82530(VarCurr,0) ) ).

tff(addAssignment_51013,axiom,
    ! [VarNext: state_type] :
      ( v82530(VarNext,0)
    <=> v82876(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82877(VarNext)
       => ! [B: $int] :
            ( ( $less(B,65)
              & ~ $less(B,0) )
           => ( v82876(VarNext,B)
            <=> v82530(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_916,axiom,
    ! [VarNext: state_type] :
      ( v82877(VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82876(VarNext,B)
          <=> v82887(VarNext,B) ) ) ) ).

tff(addAssignment_51012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82887(VarNext,B)
          <=> v82885(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82888(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82885(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_408,axiom,
    ! [VarCurr: state_type] :
      ( v82888(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82885(VarCurr,B)
          <=> v82552(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7577,axiom,
    ! [VarCurr: state_type] :
      ( v82888(VarCurr)
    <=> ( v82889(VarCurr)
        & v82890(VarCurr) ) ) ).

tff(writeUnaryOperator_3584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82890(VarCurr)
    <=> v82542(VarCurr) ) ).

tff(writeUnaryOperator_3583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82889(VarCurr)
    <=> v82532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82877(VarNext)
      <=> v82878(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82878(VarNext)
      <=> ( v82879(VarNext)
          & v82829(VarNext) ) ) ) ).

tff(writeUnaryOperator_3582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82879(VarNext)
      <=> v82881(VarNext) ) ) ).

tff(addAssignment_51011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82881(VarNext)
      <=> v82829(VarCurr) ) ) ).

tff(addAssignment_51010,axiom,
    ! [VarCurr: state_type] :
      ( v82829(VarCurr)
    <=> v82831(VarCurr) ) ).

tff(addAssignment_51009,axiom,
    ! [VarCurr: state_type] :
      ( v82831(VarCurr)
    <=> v82833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7574,axiom,
    ! [VarCurr: state_type] :
      ( v82833(VarCurr)
    <=> ( v82874(VarCurr)
        | v82870(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7573,axiom,
    ! [VarCurr: state_type] :
      ( v82874(VarCurr)
    <=> ( v82835(VarCurr)
        & v82839(VarCurr) ) ) ).

tff(addAssignment_51008,axiom,
    ! [VarCurr: state_type] :
      ( v82870(VarCurr)
    <=> v82872(VarCurr) ) ).

tff(addAssignment_51007,axiom,
    ! [VarCurr: state_type] :
      ( v82872(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82854(VarNext)
       => ( v82839(VarNext)
        <=> v82839(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_915,axiom,
    ! [VarNext: state_type] :
      ( v82854(VarNext)
     => ( v82839(VarNext)
      <=> v82864(VarNext) ) ) ).

tff(addAssignment_51006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82864(VarNext)
      <=> v82862(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7572,axiom,
    ! [VarCurr: state_type] :
      ( v82862(VarCurr)
    <=> ( v82865(VarCurr)
        & v82866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7571,axiom,
    ! [VarCurr: state_type] :
      ( v82866(VarCurr)
    <=> ( v82845(VarCurr)
        | v82849(VarCurr) ) ) ).

tff(writeUnaryOperator_3581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82865(VarCurr)
    <=> v82841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82854(VarNext)
      <=> v82855(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82855(VarNext)
      <=> ( v82857(VarNext)
          & v82859(VarNext) ) ) ) ).

tff(writeUnaryOperator_3580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82859(VarCurr)
    <=> v82835(VarCurr) ) ).

tff(addAssignment_51005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82857(VarNext)
      <=> v82835(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_240,axiom,
    ( v82839(constB0)
  <=> $true ) ).

tff(addAssignment_51004,axiom,
    ! [VarCurr: state_type] :
      ( v82849(VarCurr)
    <=> v82851(VarCurr) ) ).

tff(addAssignment_51003,axiom,
    ! [VarCurr: state_type] :
      ( v82851(VarCurr)
    <=> v82046(VarCurr) ) ).

tff(addAssignment_51002,axiom,
    ! [VarCurr: state_type] :
      ( v82845(VarCurr)
    <=> v82847(VarCurr) ) ).

tff(addAssignment_51001,axiom,
    ! [VarCurr: state_type] :
      ( v82847(VarCurr)
    <=> v82040(VarCurr,1) ) ).

tff(addAssignment_51000,axiom,
    ! [VarCurr: state_type] :
      ( v82841(VarCurr)
    <=> v82843(VarCurr) ) ).

tff(addAssignment_50999,axiom,
    ! [VarCurr: state_type] :
      ( v82843(VarCurr)
    <=> $false ) ).

tff(addAssignment_50998,axiom,
    ! [VarCurr: state_type] :
      ( v82835(VarCurr)
    <=> v82837(VarCurr) ) ).

tff(addAssignment_50997,axiom,
    ! [VarCurr: state_type] :
      ( v82837(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_50996,axiom,
    ! [VarCurr: state_type] :
      ( v82552(VarCurr,0)
    <=> v82554(VarCurr,0) ) ).

tff(addAssignment_50995,axiom,
    ! [VarCurr: state_type] :
      ( v82554(VarCurr,0)
    <=> v82827(VarCurr,0) ) ).

tff(addAssignment_50994,axiom,
    ! [VarCurr: state_type] :
      ( v82827(VarCurr,0)
    <=> v82556(VarCurr) ) ).

tff(addAssignment_50993,axiom,
    ! [VarCurr: state_type] :
      ( ( v82827(VarCurr,64)
      <=> v82018(VarCurr,127) )
      & ( v82827(VarCurr,63)
      <=> v82018(VarCurr,126) )
      & ( v82827(VarCurr,62)
      <=> v82018(VarCurr,125) )
      & ( v82827(VarCurr,61)
      <=> v82018(VarCurr,124) )
      & ( v82827(VarCurr,60)
      <=> v82018(VarCurr,123) )
      & ( v82827(VarCurr,59)
      <=> v82018(VarCurr,122) )
      & ( v82827(VarCurr,58)
      <=> v82018(VarCurr,121) )
      & ( v82827(VarCurr,57)
      <=> v82018(VarCurr,120) )
      & ( v82827(VarCurr,56)
      <=> v82018(VarCurr,119) )
      & ( v82827(VarCurr,55)
      <=> v82018(VarCurr,118) )
      & ( v82827(VarCurr,54)
      <=> v82018(VarCurr,117) )
      & ( v82827(VarCurr,53)
      <=> v82018(VarCurr,116) )
      & ( v82827(VarCurr,52)
      <=> v82018(VarCurr,115) )
      & ( v82827(VarCurr,51)
      <=> v82018(VarCurr,114) )
      & ( v82827(VarCurr,50)
      <=> v82018(VarCurr,113) )
      & ( v82827(VarCurr,49)
      <=> v82018(VarCurr,112) )
      & ( v82827(VarCurr,48)
      <=> v82018(VarCurr,111) )
      & ( v82827(VarCurr,47)
      <=> v82018(VarCurr,110) )
      & ( v82827(VarCurr,46)
      <=> v82018(VarCurr,109) )
      & ( v82827(VarCurr,45)
      <=> v82018(VarCurr,108) )
      & ( v82827(VarCurr,44)
      <=> v82018(VarCurr,107) )
      & ( v82827(VarCurr,43)
      <=> v82018(VarCurr,106) )
      & ( v82827(VarCurr,42)
      <=> v82018(VarCurr,105) )
      & ( v82827(VarCurr,41)
      <=> v82018(VarCurr,104) )
      & ( v82827(VarCurr,40)
      <=> v82018(VarCurr,103) )
      & ( v82827(VarCurr,39)
      <=> v82018(VarCurr,102) )
      & ( v82827(VarCurr,38)
      <=> v82018(VarCurr,101) )
      & ( v82827(VarCurr,37)
      <=> v82018(VarCurr,100) )
      & ( v82827(VarCurr,36)
      <=> v82018(VarCurr,99) )
      & ( v82827(VarCurr,35)
      <=> v82018(VarCurr,98) )
      & ( v82827(VarCurr,34)
      <=> v82018(VarCurr,97) )
      & ( v82827(VarCurr,33)
      <=> v82018(VarCurr,96) )
      & ( v82827(VarCurr,32)
      <=> v82018(VarCurr,95) )
      & ( v82827(VarCurr,31)
      <=> v82018(VarCurr,94) )
      & ( v82827(VarCurr,30)
      <=> v82018(VarCurr,93) )
      & ( v82827(VarCurr,29)
      <=> v82018(VarCurr,92) )
      & ( v82827(VarCurr,28)
      <=> v82018(VarCurr,91) )
      & ( v82827(VarCurr,27)
      <=> v82018(VarCurr,90) )
      & ( v82827(VarCurr,26)
      <=> v82018(VarCurr,89) )
      & ( v82827(VarCurr,25)
      <=> v82018(VarCurr,88) )
      & ( v82827(VarCurr,24)
      <=> v82018(VarCurr,87) )
      & ( v82827(VarCurr,23)
      <=> v82018(VarCurr,86) )
      & ( v82827(VarCurr,22)
      <=> v82018(VarCurr,85) )
      & ( v82827(VarCurr,21)
      <=> v82018(VarCurr,84) )
      & ( v82827(VarCurr,20)
      <=> v82018(VarCurr,83) )
      & ( v82827(VarCurr,19)
      <=> v82018(VarCurr,82) )
      & ( v82827(VarCurr,18)
      <=> v82018(VarCurr,81) )
      & ( v82827(VarCurr,17)
      <=> v82018(VarCurr,80) )
      & ( v82827(VarCurr,16)
      <=> v82018(VarCurr,79) )
      & ( v82827(VarCurr,15)
      <=> v82018(VarCurr,78) )
      & ( v82827(VarCurr,14)
      <=> v82018(VarCurr,77) )
      & ( v82827(VarCurr,13)
      <=> v82018(VarCurr,76) )
      & ( v82827(VarCurr,12)
      <=> v82018(VarCurr,75) )
      & ( v82827(VarCurr,11)
      <=> v82018(VarCurr,74) )
      & ( v82827(VarCurr,10)
      <=> v82018(VarCurr,73) )
      & ( v82827(VarCurr,9)
      <=> v82018(VarCurr,72) )
      & ( v82827(VarCurr,8)
      <=> v82018(VarCurr,71) )
      & ( v82827(VarCurr,7)
      <=> v82018(VarCurr,70) )
      & ( v82827(VarCurr,6)
      <=> v82018(VarCurr,69) )
      & ( v82827(VarCurr,5)
      <=> v82018(VarCurr,68) )
      & ( v82827(VarCurr,4)
      <=> v82018(VarCurr,67) )
      & ( v82827(VarCurr,3)
      <=> v82018(VarCurr,66) )
      & ( v82827(VarCurr,2)
      <=> v82018(VarCurr,65) )
      & ( v82827(VarCurr,1)
      <=> v82018(VarCurr,64) ) ) ).

tff(addAssignment_50992,axiom,
    ! [VarCurr: state_type] :
      ( v82556(VarCurr)
    <=> v82558(VarCurr) ) ).

tff(addAssignment_50991,axiom,
    ! [VarCurr: state_type] :
      ( v82558(VarCurr)
    <=> v82560(VarCurr) ) ).

tff(writeUnaryOperator_3579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82560(VarCurr)
    <=> v82826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7568,axiom,
    ! [VarCurr: state_type] :
      ( v82826(VarCurr)
    <=> ( v82562(VarCurr)
        | v82822(VarCurr) ) ) ).

tff(addAssignment_50990,axiom,
    ! [VarCurr: state_type] :
      ( v82822(VarCurr)
    <=> v82824(VarCurr) ) ).

tff(addAssignment_50989,axiom,
    ! [VarCurr: state_type] :
      ( v82824(VarCurr)
    <=> v67177(VarCurr) ) ).

tff(addAssignment_50988,axiom,
    ! [VarCurr: state_type] :
      ( v82562(VarCurr)
    <=> v82564(VarCurr) ) ).

tff(addAssignment_50987,axiom,
    ! [VarCurr: state_type] :
      ( v82564(VarCurr)
    <=> v82566(VarCurr) ) ).

tff(addAssignment_50986,axiom,
    ! [VarCurr: state_type] :
      ( v82566(VarCurr)
    <=> v82568(VarCurr) ) ).

tff(addAssignment_50985,axiom,
    ! [VarCurr: state_type] :
      ( v82568(VarCurr)
    <=> v82570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7567,axiom,
    ! [VarCurr: state_type] :
      ( v82570(VarCurr)
    <=> ( v82820(VarCurr)
        & v82762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7566,axiom,
    ! [VarCurr: state_type] :
      ( v82820(VarCurr)
    <=> ( v82572(VarCurr)
        & v82657(VarCurr) ) ) ).

tff(addAssignment_50984,axiom,
    ! [VarCurr: state_type] :
      ( v82762(VarCurr)
    <=> v82764(VarCurr) ) ).

tff(addAssignment_50983,axiom,
    ! [VarCurr: state_type] :
      ( v82764(VarCurr)
    <=> v82766(VarCurr) ) ).

tff(addAssignment_50982,axiom,
    ! [VarCurr: state_type] :
      ( v82766(VarCurr)
    <=> v82768(VarCurr) ) ).

tff(addAssignment_50981,axiom,
    ! [VarCurr: state_type] :
      ( v82768(VarCurr)
    <=> v82770(VarCurr) ) ).

tff(writeUnaryOperator_3578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82770(VarCurr)
    <=> v82818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7565,axiom,
    ! [VarCurr: state_type] :
      ( v82818(VarCurr)
    <=> ( v82772(VarCurr)
        | v82795(VarCurr) ) ) ).

tff(addAssignment_50980,axiom,
    ! [VarCurr: state_type] :
      ( v82795(VarCurr)
    <=> v82797(VarCurr) ) ).

tff(addAssignment_50979,axiom,
    ! [VarCurr: state_type] :
      ( v82797(VarCurr)
    <=> v79421(VarCurr,0) ) ).

tff(addAssignment_50978,axiom,
    ! [VarCurr: state_type] :
      ( v79421(VarCurr,0)
    <=> v82799(VarCurr) ) ).

tff(addAssignment_50977,axiom,
    ! [VarCurr: state_type] :
      ( v82799(VarCurr)
    <=> v82801(VarCurr) ) ).

tff(writeUnaryOperator_3577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82801(VarCurr)
    <=> v82815(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7564,axiom,
    ! [VarCurr: state_type] :
      ( v82815(VarCurr)
    <=> ( v82816(VarCurr)
        | v82811(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7563,axiom,
    ! [VarCurr: state_type] :
      ( v82816(VarCurr)
    <=> ( v82803(VarCurr)
        | v82807(VarCurr) ) ) ).

tff(addAssignment_50976,axiom,
    ! [VarCurr: state_type] :
      ( v82811(VarCurr)
    <=> v82813(VarCurr) ) ).

tff(addAssignment_50975,axiom,
    ! [VarCurr: state_type] :
      ( v82813(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_50974,axiom,
    ! [VarCurr: state_type] :
      ( v82807(VarCurr)
    <=> v82809(VarCurr) ) ).

tff(addAssignment_50973,axiom,
    ! [VarCurr: state_type] :
      ( v82809(VarCurr)
    <=> v77088(VarCurr) ) ).

tff(addAssignment_50972,axiom,
    ! [VarCurr: state_type] :
      ( v82803(VarCurr)
    <=> v82805(VarCurr) ) ).

tff(addAssignment_50971,axiom,
    ! [VarCurr: state_type] :
      ( v82805(VarCurr)
    <=> v67267(VarCurr) ) ).

tff(addAssignment_50970,axiom,
    ! [VarCurr: state_type] :
      ( v82772(VarCurr)
    <=> v82774(VarCurr) ) ).

tff(addAssignment_50969,axiom,
    ! [VarCurr: state_type] :
      ( v82774(VarCurr)
    <=> v79421(VarCurr,1) ) ).

tff(addAssignment_50968,axiom,
    ! [VarCurr: state_type] :
      ( v79421(VarCurr,1)
    <=> v82776(VarCurr) ) ).

tff(addAssignment_50967,axiom,
    ! [VarCurr: state_type] :
      ( v82776(VarCurr)
    <=> v82778(VarCurr) ) ).

tff(writeUnaryOperator_3576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82778(VarCurr)
    <=> v82792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7562,axiom,
    ! [VarCurr: state_type] :
      ( v82792(VarCurr)
    <=> ( v82793(VarCurr)
        | v82788(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7561,axiom,
    ! [VarCurr: state_type] :
      ( v82793(VarCurr)
    <=> ( v82780(VarCurr)
        | v82784(VarCurr) ) ) ).

tff(addAssignment_50966,axiom,
    ! [VarCurr: state_type] :
      ( v82788(VarCurr)
    <=> v82790(VarCurr) ) ).

tff(addAssignment_50965,axiom,
    ! [VarCurr: state_type] :
      ( v82790(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_50964,axiom,
    ! [VarCurr: state_type] :
      ( v82784(VarCurr)
    <=> v82786(VarCurr) ) ).

tff(addAssignment_50963,axiom,
    ! [VarCurr: state_type] :
      ( v82786(VarCurr)
    <=> v67277(VarCurr) ) ).

tff(addAssignment_50962,axiom,
    ! [VarCurr: state_type] :
      ( v82780(VarCurr)
    <=> v82782(VarCurr) ) ).

tff(addAssignment_50961,axiom,
    ! [VarCurr: state_type] :
      ( v82782(VarCurr)
    <=> v77078(VarCurr) ) ).

tff(addAssignment_50960,axiom,
    ! [VarCurr: state_type] :
      ( v82657(VarCurr)
    <=> v82659(VarCurr) ) ).

tff(addAssignment_50959,axiom,
    ! [VarCurr: state_type] :
      ( v82659(VarCurr)
    <=> v82661(VarCurr) ) ).

tff(addAssignment_50958,axiom,
    ! [VarCurr: state_type] :
      ( v82661(VarCurr)
    <=> v82663(VarCurr) ) ).

tff(addAssignment_50957,axiom,
    ! [VarCurr: state_type] :
      ( v82663(VarCurr)
    <=> v82665(VarCurr) ) ).

tff(writeUnaryOperator_3575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82665(VarCurr)
    <=> v82759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7560,axiom,
    ! [VarCurr: state_type] :
      ( v82759(VarCurr)
    <=> ( v82760(VarCurr)
        | v82736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7559,axiom,
    ! [VarCurr: state_type] :
      ( v82760(VarCurr)
    <=> ( v82667(VarCurr)
        | v82691(VarCurr) ) ) ).

tff(addAssignment_50956,axiom,
    ! [VarCurr: state_type] :
      ( v82736(VarCurr)
    <=> v82738(VarCurr) ) ).

tff(addAssignment_50955,axiom,
    ! [VarCurr: state_type] :
      ( v82738(VarCurr)
    <=> v79421(VarCurr,2) ) ).

tff(addAssignment_50954,axiom,
    ! [VarCurr: state_type] :
      ( v79421(VarCurr,2)
    <=> v82740(VarCurr) ) ).

tff(addAssignment_50953,axiom,
    ! [VarCurr: state_type] :
      ( v82740(VarCurr)
    <=> v82742(VarCurr) ) ).

tff(writeUnaryOperator_3574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82742(VarCurr)
    <=> v82756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7558,axiom,
    ! [VarCurr: state_type] :
      ( v82756(VarCurr)
    <=> ( v82757(VarCurr)
        | v82752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7557,axiom,
    ! [VarCurr: state_type] :
      ( v82757(VarCurr)
    <=> ( v82744(VarCurr)
        | v82748(VarCurr) ) ) ).

tff(addAssignment_50952,axiom,
    ! [VarCurr: state_type] :
      ( v82752(VarCurr)
    <=> v82754(VarCurr) ) ).

tff(addAssignment_50951,axiom,
    ! [VarCurr: state_type] :
      ( v82754(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_50950,axiom,
    ! [VarCurr: state_type] :
      ( v82748(VarCurr)
    <=> v82750(VarCurr) ) ).

tff(addAssignment_50949,axiom,
    ! [VarCurr: state_type] :
      ( v82750(VarCurr)
    <=> v69775(VarCurr) ) ).

tff(addAssignment_50948,axiom,
    ! [VarCurr: state_type] :
      ( v82744(VarCurr)
    <=> v82746(VarCurr) ) ).

tff(addAssignment_50947,axiom,
    ! [VarCurr: state_type] :
      ( v82746(VarCurr)
    <=> v77238(VarCurr) ) ).

tff(addAssignment_50946,axiom,
    ! [VarCurr: state_type] :
      ( v82691(VarCurr)
    <=> v82693(VarCurr) ) ).

tff(addAssignment_50945,axiom,
    ! [VarCurr: state_type] :
      ( v82693(VarCurr)
    <=> v79421(VarCurr,3) ) ).

tff(addAssignment_50944,axiom,
    ! [VarCurr: state_type] :
      ( v79421(VarCurr,3)
    <=> v82696(VarCurr) ) ).

tff(addAssignment_50943,axiom,
    ! [VarCurr: state_type] :
      ( v82696(VarCurr)
    <=> v82698(VarCurr) ) ).

tff(writeUnaryOperator_3573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82698(VarCurr)
    <=> v82734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7556,axiom,
    ! [VarCurr: state_type] :
      ( v82734(VarCurr)
    <=> ( v82700(VarCurr)
        | v82704(VarCurr) ) ) ).

tff(addAssignment_50942,axiom,
    ! [VarCurr: state_type] :
      ( v82704(VarCurr)
    <=> v82706(VarCurr) ) ).

tff(addAssignment_50941,axiom,
    ! [VarCurr: state_type] :
      ( v82706(VarCurr)
    <=> v82708(VarCurr) ) ).

tff(addAssignment_50940,axiom,
    ! [VarCurr: state_type] :
      ( v82708(VarCurr)
    <=> v82710(VarCurr) ) ).

tff(addAssignment_50939,axiom,
    ! [VarCurr: state_type] :
      ( v82710(VarCurr)
    <=> v82712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7555,axiom,
    ! [VarCurr: state_type] :
      ( v82712(VarCurr)
    <=> ( v82714(VarCurr)
        | v82729(VarCurr) ) ) ).

tff(addAssignment_50938,axiom,
    ! [VarCurr: state_type] :
      ( v82729(VarCurr)
    <=> v82731(VarCurr) ) ).

tff(addAssignment_50937,axiom,
    ! [VarCurr: state_type] :
      ( v82731(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_50936,axiom,
    ! [VarCurr: state_type] :
      ( v82714(VarCurr)
    <=> v82716(VarCurr) ) ).

tff(addAssignment_50935,axiom,
    ! [VarCurr: state_type] :
      ( v82716(VarCurr)
    <=> v82718(VarCurr) ) ).

tff(addAssignment_50934,axiom,
    ! [VarCurr: state_type] :
      ( v82718(VarCurr)
    <=> v82720(VarCurr) ) ).

tff(addAssignment_50933,axiom,
    ! [VarCurr: state_type] :
      ( v82720(VarCurr)
    <=> v82722(VarCurr) ) ).

tff(writeUnaryOperator_3572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82722(VarCurr)
    <=> v82724(VarCurr) ) ).

tff(addAssignment_50932,axiom,
    ! [VarCurr: state_type] :
      ( v82724(VarCurr)
    <=> v82726(VarCurr) ) ).

tff(addAssignment_50931,axiom,
    ! [VarCurr: state_type] :
      ( v82726(VarCurr)
    <=> v71540(VarCurr) ) ).

tff(addAssignment_50930,axiom,
    ! [VarCurr: state_type] :
      ( v82700(VarCurr)
    <=> v82702(VarCurr) ) ).

tff(addAssignment_50929,axiom,
    ! [VarCurr: state_type] :
      ( v82702(VarCurr)
    <=> v77328(VarCurr) ) ).

tff(addAssignment_50928,axiom,
    ! [VarCurr: state_type] :
      ( v82667(VarCurr)
    <=> v82669(VarCurr) ) ).

tff(addAssignment_50927,axiom,
    ! [VarCurr: state_type] :
      ( v82669(VarCurr)
    <=> v82671(VarCurr) ) ).

tff(addAssignment_50926,axiom,
    ! [VarCurr: state_type] :
      ( v82671(VarCurr)
    <=> v82673(VarCurr) ) ).

tff(addAssignment_50925,axiom,
    ! [VarCurr: state_type] :
      ( v82673(VarCurr)
    <=> v82675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7554,axiom,
    ! [VarCurr: state_type] :
      ( v82675(VarCurr)
    <=> ( v82689(VarCurr)
        & v82685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7553,axiom,
    ! [VarCurr: state_type] :
      ( v82689(VarCurr)
    <=> ( v82677(VarCurr)
        & v82681(VarCurr) ) ) ).

tff(addAssignment_50924,axiom,
    ! [VarCurr: state_type] :
      ( v82685(VarCurr)
    <=> v82687(VarCurr) ) ).

tff(addAssignment_50923,axiom,
    ! [VarCurr: state_type] :
      ( v82687(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_50922,axiom,
    ! [VarCurr: state_type] :
      ( v82681(VarCurr)
    <=> v82683(VarCurr) ) ).

tff(addAssignment_50921,axiom,
    ! [VarCurr: state_type] :
      ( v82683(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_50920,axiom,
    ! [VarCurr: state_type] :
      ( v82677(VarCurr)
    <=> v82679(VarCurr) ) ).

tff(addAssignment_50919,axiom,
    ! [VarCurr: state_type] :
      ( v82679(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_50918,axiom,
    ! [VarCurr: state_type] :
      ( v82572(VarCurr)
    <=> v82574(VarCurr) ) ).

tff(addAssignment_50917,axiom,
    ! [VarCurr: state_type] :
      ( v82574(VarCurr)
    <=> v82576(VarCurr) ) ).

tff(addAssignment_50916,axiom,
    ! [VarCurr: state_type] :
      ( v82576(VarCurr)
    <=> v82578(VarCurr) ) ).

tff(addAssignment_50915,axiom,
    ! [VarCurr: state_type] :
      ( v82578(VarCurr)
    <=> v82580(VarCurr) ) ).

tff(writeUnaryOperator_3571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82580(VarCurr)
    <=> v82654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7552,axiom,
    ! [VarCurr: state_type] :
      ( v82654(VarCurr)
    <=> ( v82655(VarCurr)
        | v82630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7551,axiom,
    ! [VarCurr: state_type] :
      ( v82655(VarCurr)
    <=> ( v82582(VarCurr)
        | v82606(VarCurr) ) ) ).

tff(addAssignment_50914,axiom,
    ! [VarCurr: state_type] :
      ( v82630(VarCurr)
    <=> v82632(VarCurr) ) ).

tff(addAssignment_50913,axiom,
    ! [VarCurr: state_type] :
      ( v82632(VarCurr)
    <=> v82634(VarCurr) ) ).

tff(addAssignment_50912,axiom,
    ! [VarCurr: state_type] :
      ( v82634(VarCurr)
    <=> v82636(VarCurr) ) ).

tff(addAssignment_50911,axiom,
    ! [VarCurr: state_type] :
      ( v82636(VarCurr)
    <=> v82638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7550,axiom,
    ! [VarCurr: state_type] :
      ( v82638(VarCurr)
    <=> ( v82652(VarCurr)
        & v82648(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7549,axiom,
    ! [VarCurr: state_type] :
      ( v82652(VarCurr)
    <=> ( v82640(VarCurr)
        & v82644(VarCurr) ) ) ).

tff(addAssignment_50910,axiom,
    ! [VarCurr: state_type] :
      ( v82648(VarCurr)
    <=> v82650(VarCurr) ) ).

tff(addAssignment_50909,axiom,
    ! [VarCurr: state_type] :
      ( v82650(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_50908,axiom,
    ! [VarCurr: state_type] :
      ( v82644(VarCurr)
    <=> v82646(VarCurr) ) ).

tff(addAssignment_50907,axiom,
    ! [VarCurr: state_type] :
      ( v82646(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_50906,axiom,
    ! [VarCurr: state_type] :
      ( v82640(VarCurr)
    <=> v82642(VarCurr) ) ).

tff(addAssignment_50905,axiom,
    ! [VarCurr: state_type] :
      ( v82642(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_50904,axiom,
    ! [VarCurr: state_type] :
      ( v82606(VarCurr)
    <=> v82608(VarCurr) ) ).

tff(addAssignment_50903,axiom,
    ! [VarCurr: state_type] :
      ( v82608(VarCurr)
    <=> v82610(VarCurr) ) ).

tff(addAssignment_50902,axiom,
    ! [VarCurr: state_type] :
      ( v82610(VarCurr)
    <=> v82612(VarCurr) ) ).

tff(addAssignment_50901,axiom,
    ! [VarCurr: state_type] :
      ( v82612(VarCurr)
    <=> v82614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7548,axiom,
    ! [VarCurr: state_type] :
      ( v82614(VarCurr)
    <=> ( v82628(VarCurr)
        & v82624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7547,axiom,
    ! [VarCurr: state_type] :
      ( v82628(VarCurr)
    <=> ( v82616(VarCurr)
        & v82620(VarCurr) ) ) ).

tff(addAssignment_50900,axiom,
    ! [VarCurr: state_type] :
      ( v82624(VarCurr)
    <=> v82626(VarCurr) ) ).

tff(addAssignment_50899,axiom,
    ! [VarCurr: state_type] :
      ( v82626(VarCurr)
    <=> v67217(VarCurr) ) ).

tff(addAssignment_50898,axiom,
    ! [VarCurr: state_type] :
      ( v82620(VarCurr)
    <=> v82622(VarCurr) ) ).

tff(addAssignment_50897,axiom,
    ! [VarCurr: state_type] :
      ( v82622(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_50896,axiom,
    ! [VarCurr: state_type] :
      ( v82616(VarCurr)
    <=> v82618(VarCurr) ) ).

tff(addAssignment_50895,axiom,
    ! [VarCurr: state_type] :
      ( v82618(VarCurr)
    <=> v81911(VarCurr) ) ).

tff(addAssignment_50894,axiom,
    ! [VarCurr: state_type] :
      ( v82582(VarCurr)
    <=> v82584(VarCurr) ) ).

tff(addAssignment_50893,axiom,
    ! [VarCurr: state_type] :
      ( v82584(VarCurr)
    <=> v82586(VarCurr) ) ).

tff(addAssignment_50892,axiom,
    ! [VarCurr: state_type] :
      ( v82586(VarCurr)
    <=> v82588(VarCurr) ) ).

tff(addAssignment_50891,axiom,
    ! [VarCurr: state_type] :
      ( v82588(VarCurr)
    <=> v82590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7546,axiom,
    ! [VarCurr: state_type] :
      ( v82590(VarCurr)
    <=> ( v82604(VarCurr)
        & v82600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7545,axiom,
    ! [VarCurr: state_type] :
      ( v82604(VarCurr)
    <=> ( v82592(VarCurr)
        & v82596(VarCurr) ) ) ).

tff(addAssignment_50890,axiom,
    ! [VarCurr: state_type] :
      ( v82600(VarCurr)
    <=> v82602(VarCurr) ) ).

tff(addAssignment_50889,axiom,
    ! [VarCurr: state_type] :
      ( v82602(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_50888,axiom,
    ! [VarCurr: state_type] :
      ( v82596(VarCurr)
    <=> v82598(VarCurr) ) ).

tff(addAssignment_50887,axiom,
    ! [VarCurr: state_type] :
      ( v82598(VarCurr)
    <=> v81524(VarCurr) ) ).

tff(addAssignment_50886,axiom,
    ! [VarCurr: state_type] :
      ( v82592(VarCurr)
    <=> v82594(VarCurr) ) ).

tff(addAssignment_50885,axiom,
    ! [VarCurr: state_type] :
      ( v82594(VarCurr)
    <=> v81911(VarCurr) ) ).

tff(addAssignment_50884,axiom,
    ! [VarCurr: state_type] :
      ( v82542(VarCurr)
    <=> v82544(VarCurr) ) ).

tff(addAssignment_50883,axiom,
    ! [VarCurr: state_type] :
      ( v82544(VarCurr)
    <=> v82546(VarCurr) ) ).

tff(addAssignment_50882,axiom,
    ! [VarCurr: state_type] :
      ( v82546(VarCurr)
    <=> v82548(VarCurr) ) ).

tff(addAssignment_50881,axiom,
    ! [VarCurr: state_type] :
      ( v82548(VarCurr)
    <=> v82550(VarCurr) ) ).

tff(addAssignment_50880,axiom,
    ! [VarCurr: state_type] :
      ( v82550(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_50879,axiom,
    ! [VarCurr: state_type] :
      ( v82532(VarCurr)
    <=> v82534(VarCurr) ) ).

tff(addAssignment_50878,axiom,
    ! [VarCurr: state_type] :
      ( v82534(VarCurr)
    <=> v82536(VarCurr) ) ).

tff(addAssignment_50877,axiom,
    ! [VarCurr: state_type] :
      ( v82536(VarCurr)
    <=> v82538(VarCurr) ) ).

tff(addAssignment_50876,axiom,
    ! [VarCurr: state_type] :
      ( v82538(VarCurr)
    <=> v82540(VarCurr) ) ).

tff(addAssignment_50875,axiom,
    ! [VarCurr: state_type] :
      ( v82540(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_50874,axiom,
    ! [VarCurr: state_type] :
      ( v82158(VarCurr)
    <=> v82160(VarCurr,0) ) ).

tff(addAssignment_50873,axiom,
    ! [VarCurr: state_type] :
      ( v82160(VarCurr,0)
    <=> v82162(VarCurr,0) ) ).

tff(addAssignment_50872,axiom,
    ! [VarNext: state_type] :
      ( v82162(VarNext,0)
    <=> v82508(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82509(VarNext)
       => ! [B: $int] :
            ( ( $less(B,65)
              & ~ $less(B,0) )
           => ( v82508(VarNext,B)
            <=> v82162(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_914,axiom,
    ! [VarNext: state_type] :
      ( v82509(VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82508(VarNext,B)
          <=> v82519(VarNext,B) ) ) ) ).

tff(addAssignment_50871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82519(VarNext,B)
          <=> v82517(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82517(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_407,axiom,
    ! [VarCurr: state_type] :
      ( v82520(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82517(VarCurr,B)
          <=> v82184(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7544,axiom,
    ! [VarCurr: state_type] :
      ( v82520(VarCurr)
    <=> ( v82521(VarCurr)
        & v82522(VarCurr) ) ) ).

tff(writeUnaryOperator_3570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82522(VarCurr)
    <=> v82174(VarCurr) ) ).

tff(writeUnaryOperator_3569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82521(VarCurr)
    <=> v82164(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82509(VarNext)
      <=> v82510(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82510(VarNext)
      <=> ( v82511(VarNext)
          & v82461(VarNext) ) ) ) ).

tff(writeUnaryOperator_3568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82511(VarNext)
      <=> v82513(VarNext) ) ) ).

tff(addAssignment_50870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82513(VarNext)
      <=> v82461(VarCurr) ) ) ).

tff(addAssignment_50869,axiom,
    ! [VarCurr: state_type] :
      ( v82461(VarCurr)
    <=> v82463(VarCurr) ) ).

tff(addAssignment_50868,axiom,
    ! [VarCurr: state_type] :
      ( v82463(VarCurr)
    <=> v82465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7541,axiom,
    ! [VarCurr: state_type] :
      ( v82465(VarCurr)
    <=> ( v82506(VarCurr)
        | v82502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7540,axiom,
    ! [VarCurr: state_type] :
      ( v82506(VarCurr)
    <=> ( v82467(VarCurr)
        & v82471(VarCurr) ) ) ).

tff(addAssignment_50867,axiom,
    ! [VarCurr: state_type] :
      ( v82502(VarCurr)
    <=> v82504(VarCurr) ) ).

tff(addAssignment_50866,axiom,
    ! [VarCurr: state_type] :
      ( v82504(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82486(VarNext)
       => ( v82471(VarNext)
        <=> v82471(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_913,axiom,
    ! [VarNext: state_type] :
      ( v82486(VarNext)
     => ( v82471(VarNext)
      <=> v82496(VarNext) ) ) ).

tff(addAssignment_50865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82496(VarNext)
      <=> v82494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7539,axiom,
    ! [VarCurr: state_type] :
      ( v82494(VarCurr)
    <=> ( v82497(VarCurr)
        & v82498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7538,axiom,
    ! [VarCurr: state_type] :
      ( v82498(VarCurr)
    <=> ( v82477(VarCurr)
        | v82481(VarCurr) ) ) ).

tff(writeUnaryOperator_3567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82497(VarCurr)
    <=> v82473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82486(VarNext)
      <=> v82487(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82487(VarNext)
      <=> ( v82489(VarNext)
          & v82491(VarNext) ) ) ) ).

tff(writeUnaryOperator_3566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82491(VarCurr)
    <=> v82467(VarCurr) ) ).

tff(addAssignment_50864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82489(VarNext)
      <=> v82467(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_239,axiom,
    ( v82471(constB0)
  <=> $true ) ).

tff(addAssignment_50863,axiom,
    ! [VarCurr: state_type] :
      ( v82481(VarCurr)
    <=> v82483(VarCurr) ) ).

tff(addAssignment_50862,axiom,
    ! [VarCurr: state_type] :
      ( v82483(VarCurr)
    <=> v67094(VarCurr) ) ).

tff(addAssignment_50861,axiom,
    ! [VarCurr: state_type] :
      ( v82477(VarCurr)
    <=> v82479(VarCurr) ) ).

tff(addAssignment_50860,axiom,
    ! [VarCurr: state_type] :
      ( v82479(VarCurr)
    <=> v67081(VarCurr,1) ) ).

tff(addAssignment_50859,axiom,
    ! [VarCurr: state_type] :
      ( v82473(VarCurr)
    <=> v82475(VarCurr) ) ).

tff(addAssignment_50858,axiom,
    ! [VarCurr: state_type] :
      ( v82475(VarCurr)
    <=> $false ) ).

tff(addAssignment_50857,axiom,
    ! [VarCurr: state_type] :
      ( v82467(VarCurr)
    <=> v82469(VarCurr) ) ).

tff(addAssignment_50856,axiom,
    ! [VarCurr: state_type] :
      ( v82469(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_50855,axiom,
    ! [VarCurr: state_type] :
      ( v82184(VarCurr,0)
    <=> v82186(VarCurr,0) ) ).

tff(addAssignment_50854,axiom,
    ! [VarCurr: state_type] :
      ( v82186(VarCurr,0)
    <=> v82459(VarCurr,0) ) ).

tff(addAssignment_50853,axiom,
    ! [VarCurr: state_type] :
      ( v82459(VarCurr,0)
    <=> v82188(VarCurr) ) ).

tff(addAssignment_50852,axiom,
    ! [VarCurr: state_type] :
      ( ( v82459(VarCurr,64)
      <=> v67058(VarCurr,127) )
      & ( v82459(VarCurr,63)
      <=> v67058(VarCurr,126) )
      & ( v82459(VarCurr,62)
      <=> v67058(VarCurr,125) )
      & ( v82459(VarCurr,61)
      <=> v67058(VarCurr,124) )
      & ( v82459(VarCurr,60)
      <=> v67058(VarCurr,123) )
      & ( v82459(VarCurr,59)
      <=> v67058(VarCurr,122) )
      & ( v82459(VarCurr,58)
      <=> v67058(VarCurr,121) )
      & ( v82459(VarCurr,57)
      <=> v67058(VarCurr,120) )
      & ( v82459(VarCurr,56)
      <=> v67058(VarCurr,119) )
      & ( v82459(VarCurr,55)
      <=> v67058(VarCurr,118) )
      & ( v82459(VarCurr,54)
      <=> v67058(VarCurr,117) )
      & ( v82459(VarCurr,53)
      <=> v67058(VarCurr,116) )
      & ( v82459(VarCurr,52)
      <=> v67058(VarCurr,115) )
      & ( v82459(VarCurr,51)
      <=> v67058(VarCurr,114) )
      & ( v82459(VarCurr,50)
      <=> v67058(VarCurr,113) )
      & ( v82459(VarCurr,49)
      <=> v67058(VarCurr,112) )
      & ( v82459(VarCurr,48)
      <=> v67058(VarCurr,111) )
      & ( v82459(VarCurr,47)
      <=> v67058(VarCurr,110) )
      & ( v82459(VarCurr,46)
      <=> v67058(VarCurr,109) )
      & ( v82459(VarCurr,45)
      <=> v67058(VarCurr,108) )
      & ( v82459(VarCurr,44)
      <=> v67058(VarCurr,107) )
      & ( v82459(VarCurr,43)
      <=> v67058(VarCurr,106) )
      & ( v82459(VarCurr,42)
      <=> v67058(VarCurr,105) )
      & ( v82459(VarCurr,41)
      <=> v67058(VarCurr,104) )
      & ( v82459(VarCurr,40)
      <=> v67058(VarCurr,103) )
      & ( v82459(VarCurr,39)
      <=> v67058(VarCurr,102) )
      & ( v82459(VarCurr,38)
      <=> v67058(VarCurr,101) )
      & ( v82459(VarCurr,37)
      <=> v67058(VarCurr,100) )
      & ( v82459(VarCurr,36)
      <=> v67058(VarCurr,99) )
      & ( v82459(VarCurr,35)
      <=> v67058(VarCurr,98) )
      & ( v82459(VarCurr,34)
      <=> v67058(VarCurr,97) )
      & ( v82459(VarCurr,33)
      <=> v67058(VarCurr,96) )
      & ( v82459(VarCurr,32)
      <=> v67058(VarCurr,95) )
      & ( v82459(VarCurr,31)
      <=> v67058(VarCurr,94) )
      & ( v82459(VarCurr,30)
      <=> v67058(VarCurr,93) )
      & ( v82459(VarCurr,29)
      <=> v67058(VarCurr,92) )
      & ( v82459(VarCurr,28)
      <=> v67058(VarCurr,91) )
      & ( v82459(VarCurr,27)
      <=> v67058(VarCurr,90) )
      & ( v82459(VarCurr,26)
      <=> v67058(VarCurr,89) )
      & ( v82459(VarCurr,25)
      <=> v67058(VarCurr,88) )
      & ( v82459(VarCurr,24)
      <=> v67058(VarCurr,87) )
      & ( v82459(VarCurr,23)
      <=> v67058(VarCurr,86) )
      & ( v82459(VarCurr,22)
      <=> v67058(VarCurr,85) )
      & ( v82459(VarCurr,21)
      <=> v67058(VarCurr,84) )
      & ( v82459(VarCurr,20)
      <=> v67058(VarCurr,83) )
      & ( v82459(VarCurr,19)
      <=> v67058(VarCurr,82) )
      & ( v82459(VarCurr,18)
      <=> v67058(VarCurr,81) )
      & ( v82459(VarCurr,17)
      <=> v67058(VarCurr,80) )
      & ( v82459(VarCurr,16)
      <=> v67058(VarCurr,79) )
      & ( v82459(VarCurr,15)
      <=> v67058(VarCurr,78) )
      & ( v82459(VarCurr,14)
      <=> v67058(VarCurr,77) )
      & ( v82459(VarCurr,13)
      <=> v67058(VarCurr,76) )
      & ( v82459(VarCurr,12)
      <=> v67058(VarCurr,75) )
      & ( v82459(VarCurr,11)
      <=> v67058(VarCurr,74) )
      & ( v82459(VarCurr,10)
      <=> v67058(VarCurr,73) )
      & ( v82459(VarCurr,9)
      <=> v67058(VarCurr,72) )
      & ( v82459(VarCurr,8)
      <=> v67058(VarCurr,71) )
      & ( v82459(VarCurr,7)
      <=> v67058(VarCurr,70) )
      & ( v82459(VarCurr,6)
      <=> v67058(VarCurr,69) )
      & ( v82459(VarCurr,5)
      <=> v67058(VarCurr,68) )
      & ( v82459(VarCurr,4)
      <=> v67058(VarCurr,67) )
      & ( v82459(VarCurr,3)
      <=> v67058(VarCurr,66) )
      & ( v82459(VarCurr,2)
      <=> v67058(VarCurr,65) )
      & ( v82459(VarCurr,1)
      <=> v67058(VarCurr,64) ) ) ).

tff(addAssignment_50851,axiom,
    ! [VarCurr: state_type] :
      ( v82188(VarCurr)
    <=> v82190(VarCurr) ) ).

tff(addAssignment_50850,axiom,
    ! [VarCurr: state_type] :
      ( v82190(VarCurr)
    <=> v82192(VarCurr) ) ).

tff(writeUnaryOperator_3565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82192(VarCurr)
    <=> v82458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7535,axiom,
    ! [VarCurr: state_type] :
      ( v82458(VarCurr)
    <=> ( v82194(VarCurr)
        | v82454(VarCurr) ) ) ).

tff(addAssignment_50849,axiom,
    ! [VarCurr: state_type] :
      ( v82454(VarCurr)
    <=> v82456(VarCurr) ) ).

tff(addAssignment_50848,axiom,
    ! [VarCurr: state_type] :
      ( v82456(VarCurr)
    <=> v5845(VarCurr) ) ).

tff(addAssignment_50847,axiom,
    ! [VarCurr: state_type] :
      ( v82194(VarCurr)
    <=> v82196(VarCurr) ) ).

tff(addAssignment_50846,axiom,
    ! [VarCurr: state_type] :
      ( v82196(VarCurr)
    <=> v82198(VarCurr) ) ).

tff(addAssignment_50845,axiom,
    ! [VarCurr: state_type] :
      ( v82198(VarCurr)
    <=> v82200(VarCurr) ) ).

tff(addAssignment_50844,axiom,
    ! [VarCurr: state_type] :
      ( v82200(VarCurr)
    <=> v82202(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7534,axiom,
    ! [VarCurr: state_type] :
      ( v82202(VarCurr)
    <=> ( v82452(VarCurr)
        & v82394(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7533,axiom,
    ! [VarCurr: state_type] :
      ( v82452(VarCurr)
    <=> ( v82204(VarCurr)
        & v82289(VarCurr) ) ) ).

tff(addAssignment_50843,axiom,
    ! [VarCurr: state_type] :
      ( v82394(VarCurr)
    <=> v82396(VarCurr) ) ).

tff(addAssignment_50842,axiom,
    ! [VarCurr: state_type] :
      ( v82396(VarCurr)
    <=> v82398(VarCurr) ) ).

tff(addAssignment_50841,axiom,
    ! [VarCurr: state_type] :
      ( v82398(VarCurr)
    <=> v82400(VarCurr) ) ).

tff(addAssignment_50840,axiom,
    ! [VarCurr: state_type] :
      ( v82400(VarCurr)
    <=> v82402(VarCurr) ) ).

tff(writeUnaryOperator_3564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82402(VarCurr)
    <=> v82450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7532,axiom,
    ! [VarCurr: state_type] :
      ( v82450(VarCurr)
    <=> ( v82404(VarCurr)
        | v82427(VarCurr) ) ) ).

tff(addAssignment_50839,axiom,
    ! [VarCurr: state_type] :
      ( v82427(VarCurr)
    <=> v82429(VarCurr) ) ).

tff(addAssignment_50838,axiom,
    ! [VarCurr: state_type] :
      ( v82429(VarCurr)
    <=> v64461(VarCurr,0) ) ).

tff(addAssignment_50837,axiom,
    ! [VarCurr: state_type] :
      ( v64461(VarCurr,0)
    <=> v82431(VarCurr) ) ).

tff(addAssignment_50836,axiom,
    ! [VarCurr: state_type] :
      ( v82431(VarCurr)
    <=> v82433(VarCurr) ) ).

tff(writeUnaryOperator_3563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82433(VarCurr)
    <=> v82447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7531,axiom,
    ! [VarCurr: state_type] :
      ( v82447(VarCurr)
    <=> ( v82448(VarCurr)
        | v82443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7530,axiom,
    ! [VarCurr: state_type] :
      ( v82448(VarCurr)
    <=> ( v82435(VarCurr)
        | v82439(VarCurr) ) ) ).

tff(addAssignment_50835,axiom,
    ! [VarCurr: state_type] :
      ( v82443(VarCurr)
    <=> v82445(VarCurr) ) ).

tff(addAssignment_50834,axiom,
    ! [VarCurr: state_type] :
      ( v82445(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_50833,axiom,
    ! [VarCurr: state_type] :
      ( v82439(VarCurr)
    <=> v82441(VarCurr) ) ).

tff(addAssignment_50832,axiom,
    ! [VarCurr: state_type] :
      ( v82441(VarCurr)
    <=> v62127(VarCurr) ) ).

tff(addAssignment_50831,axiom,
    ! [VarCurr: state_type] :
      ( v82435(VarCurr)
    <=> v82437(VarCurr) ) ).

tff(addAssignment_50830,axiom,
    ! [VarCurr: state_type] :
      ( v82437(VarCurr)
    <=> v5935(VarCurr) ) ).

tff(addAssignment_50829,axiom,
    ! [VarCurr: state_type] :
      ( v82404(VarCurr)
    <=> v82406(VarCurr) ) ).

tff(addAssignment_50828,axiom,
    ! [VarCurr: state_type] :
      ( v82406(VarCurr)
    <=> v64461(VarCurr,1) ) ).

tff(addAssignment_50827,axiom,
    ! [VarCurr: state_type] :
      ( v64461(VarCurr,1)
    <=> v82408(VarCurr) ) ).

tff(addAssignment_50826,axiom,
    ! [VarCurr: state_type] :
      ( v82408(VarCurr)
    <=> v82410(VarCurr) ) ).

tff(writeUnaryOperator_3562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82410(VarCurr)
    <=> v82424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7529,axiom,
    ! [VarCurr: state_type] :
      ( v82424(VarCurr)
    <=> ( v82425(VarCurr)
        | v82420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7528,axiom,
    ! [VarCurr: state_type] :
      ( v82425(VarCurr)
    <=> ( v82412(VarCurr)
        | v82416(VarCurr) ) ) ).

tff(addAssignment_50825,axiom,
    ! [VarCurr: state_type] :
      ( v82420(VarCurr)
    <=> v82422(VarCurr) ) ).

tff(addAssignment_50824,axiom,
    ! [VarCurr: state_type] :
      ( v82422(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_50823,axiom,
    ! [VarCurr: state_type] :
      ( v82416(VarCurr)
    <=> v82418(VarCurr) ) ).

tff(addAssignment_50822,axiom,
    ! [VarCurr: state_type] :
      ( v82418(VarCurr)
    <=> v5945(VarCurr) ) ).

tff(addAssignment_50821,axiom,
    ! [VarCurr: state_type] :
      ( v82412(VarCurr)
    <=> v82414(VarCurr) ) ).

tff(addAssignment_50820,axiom,
    ! [VarCurr: state_type] :
      ( v82414(VarCurr)
    <=> v62117(VarCurr) ) ).

tff(addAssignment_50819,axiom,
    ! [VarCurr: state_type] :
      ( v82289(VarCurr)
    <=> v82291(VarCurr) ) ).

tff(addAssignment_50818,axiom,
    ! [VarCurr: state_type] :
      ( v82291(VarCurr)
    <=> v82293(VarCurr) ) ).

tff(addAssignment_50817,axiom,
    ! [VarCurr: state_type] :
      ( v82293(VarCurr)
    <=> v82295(VarCurr) ) ).

tff(addAssignment_50816,axiom,
    ! [VarCurr: state_type] :
      ( v82295(VarCurr)
    <=> v82297(VarCurr) ) ).

tff(writeUnaryOperator_3561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82297(VarCurr)
    <=> v82391(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7527,axiom,
    ! [VarCurr: state_type] :
      ( v82391(VarCurr)
    <=> ( v82392(VarCurr)
        | v82368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7526,axiom,
    ! [VarCurr: state_type] :
      ( v82392(VarCurr)
    <=> ( v82299(VarCurr)
        | v82323(VarCurr) ) ) ).

tff(addAssignment_50815,axiom,
    ! [VarCurr: state_type] :
      ( v82368(VarCurr)
    <=> v82370(VarCurr) ) ).

tff(addAssignment_50814,axiom,
    ! [VarCurr: state_type] :
      ( v82370(VarCurr)
    <=> v64461(VarCurr,2) ) ).

tff(addAssignment_50813,axiom,
    ! [VarCurr: state_type] :
      ( v64461(VarCurr,2)
    <=> v82372(VarCurr) ) ).

tff(addAssignment_50812,axiom,
    ! [VarCurr: state_type] :
      ( v82372(VarCurr)
    <=> v82374(VarCurr) ) ).

tff(writeUnaryOperator_3560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82374(VarCurr)
    <=> v82388(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7525,axiom,
    ! [VarCurr: state_type] :
      ( v82388(VarCurr)
    <=> ( v82389(VarCurr)
        | v82384(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7524,axiom,
    ! [VarCurr: state_type] :
      ( v82389(VarCurr)
    <=> ( v82376(VarCurr)
        | v82380(VarCurr) ) ) ).

tff(addAssignment_50811,axiom,
    ! [VarCurr: state_type] :
      ( v82384(VarCurr)
    <=> v82386(VarCurr) ) ).

tff(addAssignment_50810,axiom,
    ! [VarCurr: state_type] :
      ( v82386(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_50809,axiom,
    ! [VarCurr: state_type] :
      ( v82380(VarCurr)
    <=> v82382(VarCurr) ) ).

tff(addAssignment_50808,axiom,
    ! [VarCurr: state_type] :
      ( v82382(VarCurr)
    <=> v54676(VarCurr) ) ).

tff(addAssignment_50807,axiom,
    ! [VarCurr: state_type] :
      ( v82376(VarCurr)
    <=> v82378(VarCurr) ) ).

tff(addAssignment_50806,axiom,
    ! [VarCurr: state_type] :
      ( v82378(VarCurr)
    <=> v62277(VarCurr) ) ).

tff(addAssignment_50805,axiom,
    ! [VarCurr: state_type] :
      ( v82323(VarCurr)
    <=> v82325(VarCurr) ) ).

tff(addAssignment_50804,axiom,
    ! [VarCurr: state_type] :
      ( v82325(VarCurr)
    <=> v64461(VarCurr,3) ) ).

tff(addAssignment_50803,axiom,
    ! [VarCurr: state_type] :
      ( v64461(VarCurr,3)
    <=> v82328(VarCurr) ) ).

tff(addAssignment_50802,axiom,
    ! [VarCurr: state_type] :
      ( v82328(VarCurr)
    <=> v82330(VarCurr) ) ).

tff(writeUnaryOperator_3559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82330(VarCurr)
    <=> v82366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7523,axiom,
    ! [VarCurr: state_type] :
      ( v82366(VarCurr)
    <=> ( v82332(VarCurr)
        | v82336(VarCurr) ) ) ).

tff(addAssignment_50801,axiom,
    ! [VarCurr: state_type] :
      ( v82336(VarCurr)
    <=> v82338(VarCurr) ) ).

tff(addAssignment_50800,axiom,
    ! [VarCurr: state_type] :
      ( v82338(VarCurr)
    <=> v82340(VarCurr) ) ).

tff(addAssignment_50799,axiom,
    ! [VarCurr: state_type] :
      ( v82340(VarCurr)
    <=> v82342(VarCurr) ) ).

tff(addAssignment_50798,axiom,
    ! [VarCurr: state_type] :
      ( v82342(VarCurr)
    <=> v82344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7522,axiom,
    ! [VarCurr: state_type] :
      ( v82344(VarCurr)
    <=> ( v82346(VarCurr)
        | v82361(VarCurr) ) ) ).

tff(addAssignment_50797,axiom,
    ! [VarCurr: state_type] :
      ( v82361(VarCurr)
    <=> v82363(VarCurr) ) ).

tff(addAssignment_50796,axiom,
    ! [VarCurr: state_type] :
      ( v82363(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_50795,axiom,
    ! [VarCurr: state_type] :
      ( v82346(VarCurr)
    <=> v82348(VarCurr) ) ).

tff(addAssignment_50794,axiom,
    ! [VarCurr: state_type] :
      ( v82348(VarCurr)
    <=> v82350(VarCurr) ) ).

tff(addAssignment_50793,axiom,
    ! [VarCurr: state_type] :
      ( v82350(VarCurr)
    <=> v82352(VarCurr) ) ).

tff(addAssignment_50792,axiom,
    ! [VarCurr: state_type] :
      ( v82352(VarCurr)
    <=> v82354(VarCurr) ) ).

tff(writeUnaryOperator_3558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82354(VarCurr)
    <=> v82356(VarCurr) ) ).

tff(addAssignment_50791,axiom,
    ! [VarCurr: state_type] :
      ( v82356(VarCurr)
    <=> v82358(VarCurr) ) ).

tff(addAssignment_50790,axiom,
    ! [VarCurr: state_type] :
      ( v82358(VarCurr)
    <=> v56441(VarCurr) ) ).

tff(addAssignment_50789,axiom,
    ! [VarCurr: state_type] :
      ( v82332(VarCurr)
    <=> v82334(VarCurr) ) ).

tff(addAssignment_50788,axiom,
    ! [VarCurr: state_type] :
      ( v82334(VarCurr)
    <=> v62367(VarCurr) ) ).

tff(addAssignment_50787,axiom,
    ! [VarCurr: state_type] :
      ( v82299(VarCurr)
    <=> v82301(VarCurr) ) ).

tff(addAssignment_50786,axiom,
    ! [VarCurr: state_type] :
      ( v82301(VarCurr)
    <=> v82303(VarCurr) ) ).

tff(addAssignment_50785,axiom,
    ! [VarCurr: state_type] :
      ( v82303(VarCurr)
    <=> v82305(VarCurr) ) ).

tff(addAssignment_50784,axiom,
    ! [VarCurr: state_type] :
      ( v82305(VarCurr)
    <=> v82307(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7521,axiom,
    ! [VarCurr: state_type] :
      ( v82307(VarCurr)
    <=> ( v82321(VarCurr)
        & v82317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7520,axiom,
    ! [VarCurr: state_type] :
      ( v82321(VarCurr)
    <=> ( v82309(VarCurr)
        & v82313(VarCurr) ) ) ).

tff(addAssignment_50783,axiom,
    ! [VarCurr: state_type] :
      ( v82317(VarCurr)
    <=> v82319(VarCurr) ) ).

tff(addAssignment_50782,axiom,
    ! [VarCurr: state_type] :
      ( v82319(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_50781,axiom,
    ! [VarCurr: state_type] :
      ( v82313(VarCurr)
    <=> v82315(VarCurr) ) ).

tff(addAssignment_50780,axiom,
    ! [VarCurr: state_type] :
      ( v82315(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_50779,axiom,
    ! [VarCurr: state_type] :
      ( v82309(VarCurr)
    <=> v82311(VarCurr) ) ).

tff(addAssignment_50778,axiom,
    ! [VarCurr: state_type] :
      ( v82311(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_50777,axiom,
    ! [VarCurr: state_type] :
      ( v82204(VarCurr)
    <=> v82206(VarCurr) ) ).

tff(addAssignment_50776,axiom,
    ! [VarCurr: state_type] :
      ( v82206(VarCurr)
    <=> v82208(VarCurr) ) ).

tff(addAssignment_50775,axiom,
    ! [VarCurr: state_type] :
      ( v82208(VarCurr)
    <=> v82210(VarCurr) ) ).

tff(addAssignment_50774,axiom,
    ! [VarCurr: state_type] :
      ( v82210(VarCurr)
    <=> v82212(VarCurr) ) ).

tff(writeUnaryOperator_3557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82212(VarCurr)
    <=> v82286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7519,axiom,
    ! [VarCurr: state_type] :
      ( v82286(VarCurr)
    <=> ( v82287(VarCurr)
        | v82262(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7518,axiom,
    ! [VarCurr: state_type] :
      ( v82287(VarCurr)
    <=> ( v82214(VarCurr)
        | v82238(VarCurr) ) ) ).

tff(addAssignment_50773,axiom,
    ! [VarCurr: state_type] :
      ( v82262(VarCurr)
    <=> v82264(VarCurr) ) ).

tff(addAssignment_50772,axiom,
    ! [VarCurr: state_type] :
      ( v82264(VarCurr)
    <=> v82266(VarCurr) ) ).

tff(addAssignment_50771,axiom,
    ! [VarCurr: state_type] :
      ( v82266(VarCurr)
    <=> v82268(VarCurr) ) ).

tff(addAssignment_50770,axiom,
    ! [VarCurr: state_type] :
      ( v82268(VarCurr)
    <=> v82270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7517,axiom,
    ! [VarCurr: state_type] :
      ( v82270(VarCurr)
    <=> ( v82284(VarCurr)
        & v82280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7516,axiom,
    ! [VarCurr: state_type] :
      ( v82284(VarCurr)
    <=> ( v82272(VarCurr)
        & v82276(VarCurr) ) ) ).

tff(addAssignment_50769,axiom,
    ! [VarCurr: state_type] :
      ( v82280(VarCurr)
    <=> v82282(VarCurr) ) ).

tff(addAssignment_50768,axiom,
    ! [VarCurr: state_type] :
      ( v82282(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_50767,axiom,
    ! [VarCurr: state_type] :
      ( v82276(VarCurr)
    <=> v82278(VarCurr) ) ).

tff(addAssignment_50766,axiom,
    ! [VarCurr: state_type] :
      ( v82278(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_50765,axiom,
    ! [VarCurr: state_type] :
      ( v82272(VarCurr)
    <=> v82274(VarCurr) ) ).

tff(addAssignment_50764,axiom,
    ! [VarCurr: state_type] :
      ( v82274(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_50763,axiom,
    ! [VarCurr: state_type] :
      ( v82238(VarCurr)
    <=> v82240(VarCurr) ) ).

tff(addAssignment_50762,axiom,
    ! [VarCurr: state_type] :
      ( v82240(VarCurr)
    <=> v82242(VarCurr) ) ).

tff(addAssignment_50761,axiom,
    ! [VarCurr: state_type] :
      ( v82242(VarCurr)
    <=> v82244(VarCurr) ) ).

tff(addAssignment_50760,axiom,
    ! [VarCurr: state_type] :
      ( v82244(VarCurr)
    <=> v82246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7515,axiom,
    ! [VarCurr: state_type] :
      ( v82246(VarCurr)
    <=> ( v82260(VarCurr)
        & v82256(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7514,axiom,
    ! [VarCurr: state_type] :
      ( v82260(VarCurr)
    <=> ( v82248(VarCurr)
        & v82252(VarCurr) ) ) ).

tff(addAssignment_50759,axiom,
    ! [VarCurr: state_type] :
      ( v82256(VarCurr)
    <=> v82258(VarCurr) ) ).

tff(addAssignment_50758,axiom,
    ! [VarCurr: state_type] :
      ( v82258(VarCurr)
    <=> v5885(VarCurr) ) ).

tff(addAssignment_50757,axiom,
    ! [VarCurr: state_type] :
      ( v82252(VarCurr)
    <=> v82254(VarCurr) ) ).

tff(addAssignment_50756,axiom,
    ! [VarCurr: state_type] :
      ( v82254(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_50755,axiom,
    ! [VarCurr: state_type] :
      ( v82248(VarCurr)
    <=> v82250(VarCurr) ) ).

tff(addAssignment_50754,axiom,
    ! [VarCurr: state_type] :
      ( v82250(VarCurr)
    <=> v66951(VarCurr) ) ).

tff(addAssignment_50753,axiom,
    ! [VarCurr: state_type] :
      ( v82214(VarCurr)
    <=> v82216(VarCurr) ) ).

tff(addAssignment_50752,axiom,
    ! [VarCurr: state_type] :
      ( v82216(VarCurr)
    <=> v82218(VarCurr) ) ).

tff(addAssignment_50751,axiom,
    ! [VarCurr: state_type] :
      ( v82218(VarCurr)
    <=> v82220(VarCurr) ) ).

tff(addAssignment_50750,axiom,
    ! [VarCurr: state_type] :
      ( v82220(VarCurr)
    <=> v82222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7513,axiom,
    ! [VarCurr: state_type] :
      ( v82222(VarCurr)
    <=> ( v82236(VarCurr)
        & v82232(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7512,axiom,
    ! [VarCurr: state_type] :
      ( v82236(VarCurr)
    <=> ( v82224(VarCurr)
        & v82228(VarCurr) ) ) ).

tff(addAssignment_50749,axiom,
    ! [VarCurr: state_type] :
      ( v82232(VarCurr)
    <=> v82234(VarCurr) ) ).

tff(addAssignment_50748,axiom,
    ! [VarCurr: state_type] :
      ( v82234(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_50747,axiom,
    ! [VarCurr: state_type] :
      ( v82228(VarCurr)
    <=> v82230(VarCurr) ) ).

tff(addAssignment_50746,axiom,
    ! [VarCurr: state_type] :
      ( v82230(VarCurr)
    <=> v66564(VarCurr) ) ).

tff(addAssignment_50745,axiom,
    ! [VarCurr: state_type] :
      ( v82224(VarCurr)
    <=> v82226(VarCurr) ) ).

tff(addAssignment_50744,axiom,
    ! [VarCurr: state_type] :
      ( v82226(VarCurr)
    <=> v66951(VarCurr) ) ).

tff(addAssignment_50743,axiom,
    ! [VarCurr: state_type] :
      ( v82174(VarCurr)
    <=> v82176(VarCurr) ) ).

tff(addAssignment_50742,axiom,
    ! [VarCurr: state_type] :
      ( v82176(VarCurr)
    <=> v82178(VarCurr) ) ).

tff(addAssignment_50741,axiom,
    ! [VarCurr: state_type] :
      ( v82178(VarCurr)
    <=> v82180(VarCurr) ) ).

tff(addAssignment_50740,axiom,
    ! [VarCurr: state_type] :
      ( v82180(VarCurr)
    <=> v82182(VarCurr) ) ).

tff(addAssignment_50739,axiom,
    ! [VarCurr: state_type] :
      ( v82182(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_50738,axiom,
    ! [VarCurr: state_type] :
      ( v82164(VarCurr)
    <=> v82166(VarCurr) ) ).

tff(addAssignment_50737,axiom,
    ! [VarCurr: state_type] :
      ( v82166(VarCurr)
    <=> v82168(VarCurr) ) ).

tff(addAssignment_50736,axiom,
    ! [VarCurr: state_type] :
      ( v82168(VarCurr)
    <=> v82170(VarCurr) ) ).

tff(addAssignment_50735,axiom,
    ! [VarCurr: state_type] :
      ( v82170(VarCurr)
    <=> v82172(VarCurr) ) ).

tff(addAssignment_50734,axiom,
    ! [VarCurr: state_type] :
      ( v82172(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7511,axiom,
    ! [VarCurr: state_type] :
      ( v5801(VarCurr)
    <=> ( v82148(VarCurr)
        | v82150(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_600,axiom,
    ! [VarCurr: state_type] :
      ( v82150(VarCurr)
    <=> ( v82091(VarCurr,0)
        | v82091(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_599,axiom,
    ! [VarCurr: state_type] :
      ( v82148(VarCurr)
    <=> ( v5803(VarCurr,0)
        | v5803(VarCurr,1) ) ) ).

tff(addAssignment_50733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82091(VarCurr,B)
      <=> v82093(VarCurr,B) ) ) ).

tff(addAssignment_50732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82093(VarCurr,B)
      <=> v82095(VarCurr,B) ) ) ).

tff(addAssignment_50731,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82095(VarNext,B)
      <=> v82130(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82131(VarNext)
       => ! [B: $int] :
            ( ( $less(B,36)
              & ~ $less(B,0) )
           => ( v82130(VarNext,B)
            <=> v82095(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_912,axiom,
    ! [VarNext: state_type] :
      ( v82131(VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v82130(VarNext,B)
          <=> v82141(VarNext,B) ) ) ) ).

tff(addAssignment_50730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v82141(VarNext,B)
          <=> v82139(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82142(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v82139(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_406,axiom,
    ! [VarCurr: state_type] :
      ( v82142(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,36)
            & ~ $less(B,0) )
         => ( v82139(VarCurr,B)
          <=> v82105(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7510,axiom,
    ! [VarCurr: state_type] :
      ( v82142(VarCurr)
    <=> ( v82143(VarCurr)
        & v82144(VarCurr) ) ) ).

tff(writeUnaryOperator_3556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82144(VarCurr)
    <=> v82101(VarCurr) ) ).

tff(writeUnaryOperator_3555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82143(VarCurr)
    <=> v82097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82131(VarNext)
      <=> v82132(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82132(VarNext)
      <=> ( v82133(VarNext)
          & v82126(VarNext) ) ) ) ).

tff(writeUnaryOperator_3554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82133(VarNext)
      <=> v82135(VarNext) ) ) ).

tff(addAssignment_50729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82135(VarNext)
      <=> v82126(VarCurr) ) ) ).

tff(addAssignment_50728,axiom,
    ! [VarCurr: state_type] :
      ( v82126(VarCurr)
    <=> v82128(VarCurr) ) ).

tff(addAssignment_50727,axiom,
    ! [VarCurr: state_type] :
      ( v82128(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_50726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82105(VarCurr,B)
      <=> v82107(VarCurr,B) ) ) ).

tff(addAssignment_50725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82107(VarCurr,B)
      <=> v82116(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v82116(VarCurr,B)
      <=> ( v82117(VarCurr,B)
          | v82120(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v82120(VarCurr,B)
      <=> ( v82093(VarCurr,B)
          & v82121(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v82121(VarCurr,B)
      <=> ~ v82122(VarCurr,B) ) ) ).

tff(addAssignment_50724,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,0)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50723,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,1)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50722,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,2)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50721,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,3)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50720,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,4)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50719,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,5)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50718,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,6)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50717,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,7)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50716,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,8)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50715,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,9)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50714,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,10)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50713,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,11)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50712,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,12)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50711,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,13)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50710,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,14)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50709,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,15)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50708,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,16)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50707,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,17)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50706,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,18)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50705,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,19)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50704,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,20)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50703,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,21)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50702,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,22)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50701,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,23)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50700,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,24)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50699,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,25)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50698,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,26)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50697,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,27)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50696,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,28)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50695,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,29)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50694,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,30)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50693,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,31)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50692,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,32)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50691,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,33)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50690,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,34)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50689,axiom,
    ! [VarCurr: state_type] :
      ( v82122(VarCurr,35)
    <=> v82123(VarCurr) ) ).

tff(addAssignment_50688,axiom,
    ! [VarCurr: state_type] :
      ( v82123(VarCurr)
    <=> v82115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v82117(VarCurr,B)
      <=> ( v82109(VarCurr,B)
          & v82118(VarCurr,B) ) ) ) ).

tff(addAssignment_50687,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,0)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50686,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,1)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50685,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,2)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50684,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,3)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50683,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,4)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50682,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,5)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50681,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,6)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50680,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,7)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50679,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,8)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50678,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,9)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50677,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,10)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50676,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,11)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50675,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,12)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50674,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,13)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50673,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,14)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50672,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,15)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50671,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,16)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50670,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,17)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50669,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,18)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50668,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,19)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50667,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,20)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50666,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,21)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50665,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,22)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50664,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,23)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50663,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,24)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50662,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,25)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50661,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,26)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50660,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,27)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50659,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,28)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50658,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,29)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50657,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,30)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50656,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,31)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50655,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,32)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50654,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,33)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50653,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,34)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50652,axiom,
    ! [VarCurr: state_type] :
      ( v82118(VarCurr,35)
    <=> v82119(VarCurr) ) ).

tff(addAssignment_50651,axiom,
    ! [VarCurr: state_type] :
      ( v82119(VarCurr)
    <=> v82115(VarCurr) ) ).

tff(addAssignment_50650,axiom,
    ! [VarCurr: state_type] :
      ( v82115(VarCurr)
    <=> $true ) ).

tff(addAssignment_50649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82109(VarCurr,B)
      <=> v82110(VarCurr,B) ) ) ).

tff(addAssignment_50648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v82110(VarCurr,B)
      <=> v5803(VarCurr,B) ) ) ).

tff(addAssignment_50647,axiom,
    ! [VarCurr: state_type] :
      ( ( v82110(VarCurr,3)
      <=> v82113(VarCurr,1) )
      & ( v82110(VarCurr,2)
      <=> v82113(VarCurr,0) ) ) ).

tff(addAssignment_50646,axiom,
    ! [VarCurr: state_type] :
      ( ( v82110(VarCurr,19)
      <=> v82112(VarCurr,15) )
      & ( v82110(VarCurr,18)
      <=> v82112(VarCurr,14) )
      & ( v82110(VarCurr,17)
      <=> v82112(VarCurr,13) )
      & ( v82110(VarCurr,16)
      <=> v82112(VarCurr,12) )
      & ( v82110(VarCurr,15)
      <=> v82112(VarCurr,11) )
      & ( v82110(VarCurr,14)
      <=> v82112(VarCurr,10) )
      & ( v82110(VarCurr,13)
      <=> v82112(VarCurr,9) )
      & ( v82110(VarCurr,12)
      <=> v82112(VarCurr,8) )
      & ( v82110(VarCurr,11)
      <=> v82112(VarCurr,7) )
      & ( v82110(VarCurr,10)
      <=> v82112(VarCurr,6) )
      & ( v82110(VarCurr,9)
      <=> v82112(VarCurr,5) )
      & ( v82110(VarCurr,8)
      <=> v82112(VarCurr,4) )
      & ( v82110(VarCurr,7)
      <=> v82112(VarCurr,3) )
      & ( v82110(VarCurr,6)
      <=> v82112(VarCurr,2) )
      & ( v82110(VarCurr,5)
      <=> v82112(VarCurr,1) )
      & ( v82110(VarCurr,4)
      <=> v82112(VarCurr,0) ) ) ).

tff(addAssignment_50645,axiom,
    ! [VarCurr: state_type] :
      ( ( v82110(VarCurr,35)
      <=> v82111(VarCurr,15) )
      & ( v82110(VarCurr,34)
      <=> v82111(VarCurr,14) )
      & ( v82110(VarCurr,33)
      <=> v82111(VarCurr,13) )
      & ( v82110(VarCurr,32)
      <=> v82111(VarCurr,12) )
      & ( v82110(VarCurr,31)
      <=> v82111(VarCurr,11) )
      & ( v82110(VarCurr,30)
      <=> v82111(VarCurr,10) )
      & ( v82110(VarCurr,29)
      <=> v82111(VarCurr,9) )
      & ( v82110(VarCurr,28)
      <=> v82111(VarCurr,8) )
      & ( v82110(VarCurr,27)
      <=> v82111(VarCurr,7) )
      & ( v82110(VarCurr,26)
      <=> v82111(VarCurr,6) )
      & ( v82110(VarCurr,25)
      <=> v82111(VarCurr,5) )
      & ( v82110(VarCurr,24)
      <=> v82111(VarCurr,4) )
      & ( v82110(VarCurr,23)
      <=> v82111(VarCurr,3) )
      & ( v82110(VarCurr,22)
      <=> v82111(VarCurr,2) )
      & ( v82110(VarCurr,21)
      <=> v82111(VarCurr,1) )
      & ( v82110(VarCurr,20)
      <=> v82111(VarCurr,0) ) ) ).

tff(addAssignment_50644,axiom,
    ! [VarCurr: state_type] :
      ( v82101(VarCurr)
    <=> v82103(VarCurr) ) ).

tff(addAssignment_50643,axiom,
    ! [VarCurr: state_type] :
      ( v82103(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_50642,axiom,
    ! [VarCurr: state_type] :
      ( v82097(VarCurr)
    <=> v82099(VarCurr) ) ).

tff(addAssignment_50641,axiom,
    ! [VarCurr: state_type] :
      ( v82099(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_50640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v5803(VarCurr,B)
      <=> v5805(VarCurr,B) ) ) ).

tff(addAssignment_50639,axiom,
    ! [VarCurr: state_type] :
      ( v5805(VarCurr,1)
    <=> v67139(VarCurr) ) ).

tff(addAssignment_50638,axiom,
    ! [VarCurr: state_type] :
      ( v5805(VarCurr,0)
    <=> v5807(VarCurr) ) ).

tff(addAssignment_50637,axiom,
    ! [VarCurr: state_type] :
      ( v67139(VarCurr)
    <=> v67141(VarCurr,0) ) ).

tff(addAssignment_50636,axiom,
    ! [VarCurr: state_type] :
      ( v67141(VarCurr,0)
    <=> v67143(VarCurr,0) ) ).

tff(addAssignment_50635,axiom,
    ! [VarNext: state_type] :
      ( v67143(VarNext,0)
    <=> v82073(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82074(VarNext)
       => ! [B: $int] :
            ( ( $less(B,65)
              & ~ $less(B,0) )
           => ( v82073(VarNext,B)
            <=> v67143(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_911,axiom,
    ! [VarNext: state_type] :
      ( v82074(VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82073(VarNext,B)
          <=> v82084(VarNext,B) ) ) ) ).

tff(addAssignment_50634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82084(VarNext,B)
          <=> v82082(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82082(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_405,axiom,
    ! [VarCurr: state_type] :
      ( v82085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v82082(VarCurr,B)
          <=> v67173(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7507,axiom,
    ! [VarCurr: state_type] :
      ( v82085(VarCurr)
    <=> ( v82086(VarCurr)
        & v82087(VarCurr) ) ) ).

tff(writeUnaryOperator_3552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82087(VarCurr)
    <=> v67159(VarCurr) ) ).

tff(writeUnaryOperator_3551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82086(VarCurr)
    <=> v67145(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82074(VarNext)
      <=> v82075(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82075(VarNext)
      <=> ( v82076(VarNext)
          & v82020(VarNext) ) ) ) ).

tff(writeUnaryOperator_3550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82076(VarNext)
      <=> v82078(VarNext) ) ) ).

tff(addAssignment_50633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82078(VarNext)
      <=> v82020(VarCurr) ) ) ).

tff(addAssignment_50632,axiom,
    ! [VarCurr: state_type] :
      ( v82020(VarCurr)
    <=> v82022(VarCurr) ) ).

tff(addAssignment_50631,axiom,
    ! [VarCurr: state_type] :
      ( v82022(VarCurr)
    <=> v82024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7504,axiom,
    ! [VarCurr: state_type] :
      ( v82024(VarCurr)
    <=> ( v82071(VarCurr)
        | v82067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7503,axiom,
    ! [VarCurr: state_type] :
      ( v82071(VarCurr)
    <=> ( v82026(VarCurr)
        & v82030(VarCurr) ) ) ).

tff(addAssignment_50630,axiom,
    ! [VarCurr: state_type] :
      ( v82067(VarCurr)
    <=> v82069(VarCurr) ) ).

tff(addAssignment_50629,axiom,
    ! [VarCurr: state_type] :
      ( v82069(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v82051(VarNext)
       => ( v82030(VarNext)
        <=> v82030(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_910,axiom,
    ! [VarNext: state_type] :
      ( v82051(VarNext)
     => ( v82030(VarNext)
      <=> v82061(VarNext) ) ) ).

tff(addAssignment_50628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82061(VarNext)
      <=> v82059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7502,axiom,
    ! [VarCurr: state_type] :
      ( v82059(VarCurr)
    <=> ( v82062(VarCurr)
        & v82063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7501,axiom,
    ! [VarCurr: state_type] :
      ( v82063(VarCurr)
    <=> ( v82036(VarCurr)
        | v82042(VarCurr) ) ) ).

tff(writeUnaryOperator_3549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82062(VarCurr)
    <=> v82032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82051(VarNext)
      <=> v82052(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82052(VarNext)
      <=> ( v82054(VarNext)
          & v82056(VarNext) ) ) ) ).

tff(writeUnaryOperator_3548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82056(VarCurr)
    <=> v82026(VarCurr) ) ).

tff(addAssignment_50627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v82054(VarNext)
      <=> v82026(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_238,axiom,
    ( v82030(constB0)
  <=> $true ) ).

tff(addAssignment_50626,axiom,
    ! [VarCurr: state_type] :
      ( v82042(VarCurr)
    <=> v82044(VarCurr) ) ).

tff(addAssignment_50625,axiom,
    ! [VarCurr: state_type] :
      ( v82044(VarCurr)
    <=> v82046(VarCurr) ) ).

tff(addAssignment_50624,axiom,
    ! [VarCurr: state_type] :
      ( v82046(VarCurr)
    <=> v82048(VarCurr) ) ).

tff(addAssignment_50623,axiom,
    ! [VarCurr: state_type] :
      ( v82048(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_50622,axiom,
    ! [VarCurr: state_type] :
      ( v82036(VarCurr)
    <=> v82038(VarCurr) ) ).

tff(addAssignment_50621,axiom,
    ! [VarCurr: state_type] :
      ( v82038(VarCurr)
    <=> v82040(VarCurr,1) ) ).

tff(addAssignment_50620,axiom,
    ! [VarCurr: state_type] :
      ( v82040(VarCurr,1)
    <=> v67083(VarCurr,2) ) ).

tff(addAssignment_50619,axiom,
    ! [VarCurr: state_type] :
      ( v82032(VarCurr)
    <=> v82034(VarCurr) ) ).

tff(addAssignment_50618,axiom,
    ! [VarCurr: state_type] :
      ( v82034(VarCurr)
    <=> $false ) ).

tff(addAssignment_50617,axiom,
    ! [VarCurr: state_type] :
      ( v82026(VarCurr)
    <=> v82028(VarCurr) ) ).

tff(addAssignment_50616,axiom,
    ! [VarCurr: state_type] :
      ( v82028(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_50615,axiom,
    ! [VarCurr: state_type] :
      ( v67173(VarCurr,0)
    <=> v67175(VarCurr,0) ) ).

tff(addAssignment_50614,axiom,
    ! [VarCurr: state_type] :
      ( v67175(VarCurr,0)
    <=> v82017(VarCurr,0) ) ).

tff(addAssignment_50613,axiom,
    ! [VarCurr: state_type] :
      ( v82017(VarCurr,0)
    <=> v67177(VarCurr) ) ).

tff(addAssignment_50612,axiom,
    ! [VarCurr: state_type] :
      ( ( v82017(VarCurr,64)
      <=> v82018(VarCurr,63) )
      & ( v82017(VarCurr,63)
      <=> v82018(VarCurr,62) )
      & ( v82017(VarCurr,62)
      <=> v82018(VarCurr,61) )
      & ( v82017(VarCurr,61)
      <=> v82018(VarCurr,60) )
      & ( v82017(VarCurr,60)
      <=> v82018(VarCurr,59) )
      & ( v82017(VarCurr,59)
      <=> v82018(VarCurr,58) )
      & ( v82017(VarCurr,58)
      <=> v82018(VarCurr,57) )
      & ( v82017(VarCurr,57)
      <=> v82018(VarCurr,56) )
      & ( v82017(VarCurr,56)
      <=> v82018(VarCurr,55) )
      & ( v82017(VarCurr,55)
      <=> v82018(VarCurr,54) )
      & ( v82017(VarCurr,54)
      <=> v82018(VarCurr,53) )
      & ( v82017(VarCurr,53)
      <=> v82018(VarCurr,52) )
      & ( v82017(VarCurr,52)
      <=> v82018(VarCurr,51) )
      & ( v82017(VarCurr,51)
      <=> v82018(VarCurr,50) )
      & ( v82017(VarCurr,50)
      <=> v82018(VarCurr,49) )
      & ( v82017(VarCurr,49)
      <=> v82018(VarCurr,48) )
      & ( v82017(VarCurr,48)
      <=> v82018(VarCurr,47) )
      & ( v82017(VarCurr,47)
      <=> v82018(VarCurr,46) )
      & ( v82017(VarCurr,46)
      <=> v82018(VarCurr,45) )
      & ( v82017(VarCurr,45)
      <=> v82018(VarCurr,44) )
      & ( v82017(VarCurr,44)
      <=> v82018(VarCurr,43) )
      & ( v82017(VarCurr,43)
      <=> v82018(VarCurr,42) )
      & ( v82017(VarCurr,42)
      <=> v82018(VarCurr,41) )
      & ( v82017(VarCurr,41)
      <=> v82018(VarCurr,40) )
      & ( v82017(VarCurr,40)
      <=> v82018(VarCurr,39) )
      & ( v82017(VarCurr,39)
      <=> v82018(VarCurr,38) )
      & ( v82017(VarCurr,38)
      <=> v82018(VarCurr,37) )
      & ( v82017(VarCurr,37)
      <=> v82018(VarCurr,36) )
      & ( v82017(VarCurr,36)
      <=> v82018(VarCurr,35) )
      & ( v82017(VarCurr,35)
      <=> v82018(VarCurr,34) )
      & ( v82017(VarCurr,34)
      <=> v82018(VarCurr,33) )
      & ( v82017(VarCurr,33)
      <=> v82018(VarCurr,32) )
      & ( v82017(VarCurr,32)
      <=> v82018(VarCurr,31) )
      & ( v82017(VarCurr,31)
      <=> v82018(VarCurr,30) )
      & ( v82017(VarCurr,30)
      <=> v82018(VarCurr,29) )
      & ( v82017(VarCurr,29)
      <=> v82018(VarCurr,28) )
      & ( v82017(VarCurr,28)
      <=> v82018(VarCurr,27) )
      & ( v82017(VarCurr,27)
      <=> v82018(VarCurr,26) )
      & ( v82017(VarCurr,26)
      <=> v82018(VarCurr,25) )
      & ( v82017(VarCurr,25)
      <=> v82018(VarCurr,24) )
      & ( v82017(VarCurr,24)
      <=> v82018(VarCurr,23) )
      & ( v82017(VarCurr,23)
      <=> v82018(VarCurr,22) )
      & ( v82017(VarCurr,22)
      <=> v82018(VarCurr,21) )
      & ( v82017(VarCurr,21)
      <=> v82018(VarCurr,20) )
      & ( v82017(VarCurr,20)
      <=> v82018(VarCurr,19) )
      & ( v82017(VarCurr,19)
      <=> v82018(VarCurr,18) )
      & ( v82017(VarCurr,18)
      <=> v82018(VarCurr,17) )
      & ( v82017(VarCurr,17)
      <=> v82018(VarCurr,16) )
      & ( v82017(VarCurr,16)
      <=> v82018(VarCurr,15) )
      & ( v82017(VarCurr,15)
      <=> v82018(VarCurr,14) )
      & ( v82017(VarCurr,14)
      <=> v82018(VarCurr,13) )
      & ( v82017(VarCurr,13)
      <=> v82018(VarCurr,12) )
      & ( v82017(VarCurr,12)
      <=> v82018(VarCurr,11) )
      & ( v82017(VarCurr,11)
      <=> v82018(VarCurr,10) )
      & ( v82017(VarCurr,10)
      <=> v82018(VarCurr,9) )
      & ( v82017(VarCurr,9)
      <=> v82018(VarCurr,8) )
      & ( v82017(VarCurr,8)
      <=> v82018(VarCurr,7) )
      & ( v82017(VarCurr,7)
      <=> v82018(VarCurr,6) )
      & ( v82017(VarCurr,6)
      <=> v82018(VarCurr,5) )
      & ( v82017(VarCurr,5)
      <=> v82018(VarCurr,4) )
      & ( v82017(VarCurr,4)
      <=> v82018(VarCurr,3) )
      & ( v82017(VarCurr,3)
      <=> v82018(VarCurr,2) )
      & ( v82017(VarCurr,2)
      <=> v82018(VarCurr,1) )
      & ( v82017(VarCurr,1)
      <=> v82018(VarCurr,0) ) ) ).

tff(addAssignment_50611,axiom,
    ! [VarCurr: state_type] :
      ( v67177(VarCurr)
    <=> v67179(VarCurr) ) ).

tff(addAssignment_50610,axiom,
    ! [VarCurr: state_type] :
      ( v67179(VarCurr)
    <=> v67181(VarCurr) ) ).

tff(writeUnaryOperator_3547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67181(VarCurr)
    <=> v82014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7498,axiom,
    ! [VarCurr: state_type] :
      ( v82014(VarCurr)
    <=> ( v82015(VarCurr)
        & v81810(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7497,axiom,
    ! [VarCurr: state_type] :
      ( v82015(VarCurr)
    <=> ( v82016(VarCurr)
        & v77642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7496,axiom,
    ! [VarCurr: state_type] :
      ( v82016(VarCurr)
    <=> ( v67183(VarCurr)
        & v77503(VarCurr) ) ) ).

tff(addAssignment_50609,axiom,
    ! [VarCurr: state_type] :
      ( v81810(VarCurr)
    <=> v81812(VarCurr) ) ).

tff(addAssignment_50608,axiom,
    ! [VarCurr: state_type] :
      ( v81812(VarCurr)
    <=> v81814(VarCurr) ) ).

tff(addAssignment_50607,axiom,
    ! [VarCurr: state_type] :
      ( v81814(VarCurr)
    <=> v81816(VarCurr) ) ).

tff(addAssignment_50606,axiom,
    ! [VarCurr: state_type] :
      ( v81816(VarCurr)
    <=> v81818(VarCurr) ) ).

tff(writeUnaryOperator_3546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81818(VarCurr)
    <=> v82012(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7495,axiom,
    ! [VarCurr: state_type] :
      ( v82012(VarCurr)
    <=> ( v81820(VarCurr)
        | v81929(VarCurr) ) ) ).

tff(addAssignment_50605,axiom,
    ! [VarCurr: state_type] :
      ( v81929(VarCurr)
    <=> v81931(VarCurr) ) ).

tff(addAssignment_50604,axiom,
    ! [VarCurr: state_type] :
      ( v81931(VarCurr)
    <=> v81933(VarCurr) ) ).

tff(addAssignment_50603,axiom,
    ! [VarCurr: state_type] :
      ( v81933(VarCurr)
    <=> v81935(VarCurr) ) ).

tff(addAssignment_50602,axiom,
    ! [VarCurr: state_type] :
      ( v81935(VarCurr)
    <=> v81937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7494,axiom,
    ! [VarCurr: state_type] :
      ( v81937(VarCurr)
    <=> ( v81939(VarCurr)
        & v81981(VarCurr) ) ) ).

tff(addAssignment_50601,axiom,
    ! [VarCurr: state_type] :
      ( v81981(VarCurr)
    <=> v81983(VarCurr) ) ).

tff(addAssignment_50600,axiom,
    ! [VarCurr: state_type] :
      ( v81983(VarCurr)
    <=> v81985(VarCurr) ) ).

tff(addAssignment_50599,axiom,
    ! [VarCurr: state_type] :
      ( v81985(VarCurr)
    <=> v81987(VarCurr) ) ).

tff(addAssignment_50598,axiom,
    ! [VarCurr: state_type] :
      ( v81987(VarCurr)
    <=> v81989(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7493,axiom,
    ! [VarCurr: state_type] :
      ( v81989(VarCurr)
    <=> ( v81991(VarCurr)
        | v81995(VarCurr) ) ) ).

tff(addAssignment_50597,axiom,
    ! [VarCurr: state_type] :
      ( v81995(VarCurr)
    <=> v81997(VarCurr) ) ).

tff(addAssignment_50596,axiom,
    ! [VarCurr: state_type] :
      ( v81997(VarCurr)
    <=> v81999(VarCurr) ) ).

tff(addAssignment_50595,axiom,
    ! [VarCurr: state_type] :
      ( v81999(VarCurr)
    <=> v82001(VarCurr) ) ).

tff(addAssignment_50594,axiom,
    ! [VarCurr: state_type] :
      ( v82001(VarCurr)
    <=> v82003(VarCurr) ) ).

tff(writeUnaryOperator_3545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v82003(VarCurr)
    <=> v82005(VarCurr) ) ).

tff(addAssignment_50593,axiom,
    ! [VarCurr: state_type] :
      ( v82005(VarCurr)
    <=> v82007(VarCurr) ) ).

tff(addAssignment_50592,axiom,
    ! [VarCurr: state_type] :
      ( v82007(VarCurr)
    <=> v81786(VarCurr) ) ).

tff(addAssignment_50591,axiom,
    ! [VarCurr: state_type] :
      ( v81991(VarCurr)
    <=> v81993(VarCurr) ) ).

tff(addAssignment_50590,axiom,
    ! [VarCurr: state_type] :
      ( v81993(VarCurr)
    <=> v81901(VarCurr) ) ).

tff(addAssignment_50589,axiom,
    ! [VarCurr: state_type] :
      ( v81939(VarCurr)
    <=> v81941(VarCurr) ) ).

tff(addAssignment_50588,axiom,
    ! [VarCurr: state_type] :
      ( v81941(VarCurr)
    <=> v67197(VarCurr,0) ) ).

tff(addAssignment_50587,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,0)
    <=> v81943(VarCurr) ) ).

tff(addAssignment_50586,axiom,
    ! [VarCurr: state_type] :
      ( v81943(VarCurr)
    <=> v81945(VarCurr) ) ).

tff(writeUnaryOperator_3544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81945(VarCurr)
    <=> v81979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7492,axiom,
    ! [VarCurr: state_type] :
      ( v81979(VarCurr)
    <=> ( v81947(VarCurr)
        | v81975(VarCurr) ) ) ).

tff(addAssignment_50585,axiom,
    ! [VarCurr: state_type] :
      ( v81975(VarCurr)
    <=> v81977(VarCurr) ) ).

tff(addAssignment_50584,axiom,
    ! [VarCurr: state_type] :
      ( v81977(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_50583,axiom,
    ! [VarCurr: state_type] :
      ( v81947(VarCurr)
    <=> v81949(VarCurr) ) ).

tff(addAssignment_50582,axiom,
    ! [VarCurr: state_type] :
      ( v81949(VarCurr)
    <=> v67207(VarCurr,0) ) ).

tff(addAssignment_50581,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,0)
    <=> v81951(VarCurr) ) ).

tff(addAssignment_50580,axiom,
    ! [VarCurr: state_type] :
      ( v81951(VarCurr)
    <=> v81953(VarCurr) ) ).

tff(writeUnaryOperator_3543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81953(VarCurr)
    <=> v81971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7491,axiom,
    ! [VarCurr: state_type] :
      ( v81971(VarCurr)
    <=> ( v81972(VarCurr)
        & v81967(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7490,axiom,
    ! [VarCurr: state_type] :
      ( v81972(VarCurr)
    <=> ( v81973(VarCurr)
        & v81963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7489,axiom,
    ! [VarCurr: state_type] :
      ( v81973(VarCurr)
    <=> ( v81955(VarCurr)
        & v81959(VarCurr) ) ) ).

tff(addAssignment_50579,axiom,
    ! [VarCurr: state_type] :
      ( v81967(VarCurr)
    <=> v81969(VarCurr) ) ).

tff(addAssignment_50578,axiom,
    ! [VarCurr: state_type] :
      ( v81969(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_50577,axiom,
    ! [VarCurr: state_type] :
      ( v81963(VarCurr)
    <=> v81965(VarCurr) ) ).

tff(addAssignment_50576,axiom,
    ! [VarCurr: state_type] :
      ( v81965(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_50575,axiom,
    ! [VarCurr: state_type] :
      ( v81959(VarCurr)
    <=> v81961(VarCurr) ) ).

tff(addAssignment_50574,axiom,
    ! [VarCurr: state_type] :
      ( v81961(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_50573,axiom,
    ! [VarCurr: state_type] :
      ( v81955(VarCurr)
    <=> v81957(VarCurr) ) ).

tff(addAssignment_50572,axiom,
    ! [VarCurr: state_type] :
      ( v81957(VarCurr)
    <=> v67217(VarCurr) ) ).

tff(addAssignment_50571,axiom,
    ! [VarCurr: state_type] :
      ( v81820(VarCurr)
    <=> v81822(VarCurr) ) ).

tff(addAssignment_50570,axiom,
    ! [VarCurr: state_type] :
      ( v81822(VarCurr)
    <=> v81824(VarCurr) ) ).

tff(addAssignment_50569,axiom,
    ! [VarCurr: state_type] :
      ( v81824(VarCurr)
    <=> v81826(VarCurr) ) ).

tff(addAssignment_50568,axiom,
    ! [VarCurr: state_type] :
      ( v81826(VarCurr)
    <=> v81828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7488,axiom,
    ! [VarCurr: state_type] :
      ( v81828(VarCurr)
    <=> ( v81830(VarCurr)
        & v81872(VarCurr) ) ) ).

tff(addAssignment_50567,axiom,
    ! [VarCurr: state_type] :
      ( v81872(VarCurr)
    <=> v81874(VarCurr) ) ).

tff(addAssignment_50566,axiom,
    ! [VarCurr: state_type] :
      ( v81874(VarCurr)
    <=> v81876(VarCurr) ) ).

tff(addAssignment_50565,axiom,
    ! [VarCurr: state_type] :
      ( v81876(VarCurr)
    <=> v81878(VarCurr) ) ).

tff(addAssignment_50564,axiom,
    ! [VarCurr: state_type] :
      ( v81878(VarCurr)
    <=> v81880(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7487,axiom,
    ! [VarCurr: state_type] :
      ( v81880(VarCurr)
    <=> ( v81882(VarCurr)
        | v81897(VarCurr) ) ) ).

tff(addAssignment_50563,axiom,
    ! [VarCurr: state_type] :
      ( v81897(VarCurr)
    <=> v81899(VarCurr) ) ).

tff(addAssignment_50562,axiom,
    ! [VarCurr: state_type] :
      ( v81899(VarCurr)
    <=> v81901(VarCurr) ) ).

tff(addAssignment_50561,axiom,
    ! [VarCurr: state_type] :
      ( v81901(VarCurr)
    <=> v81903(VarCurr) ) ).

tff(addAssignment_50560,axiom,
    ! [VarCurr: state_type] :
      ( v81903(VarCurr)
    <=> v81905(VarCurr) ) ).

tff(writeUnaryOperator_3542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81905(VarCurr)
    <=> v81907(VarCurr) ) ).

tff(addAssignment_50559,axiom,
    ! [VarCurr: state_type] :
      ( v81907(VarCurr)
    <=> v81909(VarCurr) ) ).

tff(addAssignment_50558,axiom,
    ! [VarCurr: state_type] :
      ( v81909(VarCurr)
    <=> v81911(VarCurr) ) ).

tff(addAssignment_50557,axiom,
    ! [VarCurr: state_type] :
      ( v81911(VarCurr)
    <=> v81913(VarCurr) ) ).

tff(addAssignment_50556,axiom,
    ! [VarCurr: state_type] :
      ( v81913(VarCurr)
    <=> v81915(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_333,axiom,
    ! [VarCurr: state_type] :
      ( v81915(VarCurr)
    <=> ( ( v81917(VarCurr,3)
        <=> v81921(VarCurr,3) )
        & ( v81917(VarCurr,2)
        <=> v81921(VarCurr,2) )
        & ( v81917(VarCurr,1)
        <=> v81921(VarCurr,1) )
        & ( v81917(VarCurr,0)
        <=> v81921(VarCurr,0) ) ) ) ).

tff(addAssignment_50555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81921(VarCurr,B)
      <=> v81923(VarCurr,B) ) ) ).

tff(addAssignment_50554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81923(VarCurr,B)
      <=> v77218(VarCurr,B) ) ) ).

tff(addAssignment_50553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81917(VarCurr,B)
      <=> v81919(VarCurr,B) ) ) ).

tff(addAssignment_50552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81919(VarCurr,B)
      <=> v77058(VarCurr,B) ) ) ).

tff(addAssignment_50551,axiom,
    ! [VarCurr: state_type] :
      ( v81882(VarCurr)
    <=> v81884(VarCurr) ) ).

tff(addAssignment_50550,axiom,
    ! [VarCurr: state_type] :
      ( v81884(VarCurr)
    <=> v81886(VarCurr) ) ).

tff(addAssignment_50549,axiom,
    ! [VarCurr: state_type] :
      ( v81886(VarCurr)
    <=> v81888(VarCurr) ) ).

tff(addAssignment_50548,axiom,
    ! [VarCurr: state_type] :
      ( v81888(VarCurr)
    <=> v81890(VarCurr) ) ).

tff(writeUnaryOperator_3541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81890(VarCurr)
    <=> v81892(VarCurr) ) ).

tff(addAssignment_50547,axiom,
    ! [VarCurr: state_type] :
      ( v81892(VarCurr)
    <=> v81894(VarCurr) ) ).

tff(addAssignment_50546,axiom,
    ! [VarCurr: state_type] :
      ( v81894(VarCurr)
    <=> v79405(VarCurr) ) ).

tff(addAssignment_50545,axiom,
    ! [VarCurr: state_type] :
      ( v81830(VarCurr)
    <=> v81832(VarCurr) ) ).

tff(addAssignment_50544,axiom,
    ! [VarCurr: state_type] :
      ( v81832(VarCurr)
    <=> v67197(VarCurr,1) ) ).

tff(addAssignment_50543,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,1)
    <=> v81834(VarCurr) ) ).

tff(addAssignment_50542,axiom,
    ! [VarCurr: state_type] :
      ( v81834(VarCurr)
    <=> v81836(VarCurr) ) ).

tff(writeUnaryOperator_3540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81836(VarCurr)
    <=> v81870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7486,axiom,
    ! [VarCurr: state_type] :
      ( v81870(VarCurr)
    <=> ( v81838(VarCurr)
        | v81866(VarCurr) ) ) ).

tff(addAssignment_50541,axiom,
    ! [VarCurr: state_type] :
      ( v81866(VarCurr)
    <=> v81868(VarCurr) ) ).

tff(addAssignment_50540,axiom,
    ! [VarCurr: state_type] :
      ( v81868(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_50539,axiom,
    ! [VarCurr: state_type] :
      ( v81838(VarCurr)
    <=> v81840(VarCurr) ) ).

tff(addAssignment_50538,axiom,
    ! [VarCurr: state_type] :
      ( v81840(VarCurr)
    <=> v67207(VarCurr,1) ) ).

tff(addAssignment_50537,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,1)
    <=> v81842(VarCurr) ) ).

tff(addAssignment_50536,axiom,
    ! [VarCurr: state_type] :
      ( v81842(VarCurr)
    <=> v81844(VarCurr) ) ).

tff(writeUnaryOperator_3539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81844(VarCurr)
    <=> v81862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7485,axiom,
    ! [VarCurr: state_type] :
      ( v81862(VarCurr)
    <=> ( v81863(VarCurr)
        & v81858(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7484,axiom,
    ! [VarCurr: state_type] :
      ( v81863(VarCurr)
    <=> ( v81864(VarCurr)
        & v81854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7483,axiom,
    ! [VarCurr: state_type] :
      ( v81864(VarCurr)
    <=> ( v81846(VarCurr)
        & v81850(VarCurr) ) ) ).

tff(addAssignment_50535,axiom,
    ! [VarCurr: state_type] :
      ( v81858(VarCurr)
    <=> v81860(VarCurr) ) ).

tff(addAssignment_50534,axiom,
    ! [VarCurr: state_type] :
      ( v81860(VarCurr)
    <=> v77437(VarCurr) ) ).

tff(addAssignment_50533,axiom,
    ! [VarCurr: state_type] :
      ( v81854(VarCurr)
    <=> v81856(VarCurr) ) ).

tff(addAssignment_50532,axiom,
    ! [VarCurr: state_type] :
      ( v81856(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_50531,axiom,
    ! [VarCurr: state_type] :
      ( v81850(VarCurr)
    <=> v81852(VarCurr) ) ).

tff(addAssignment_50530,axiom,
    ! [VarCurr: state_type] :
      ( v81852(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_50529,axiom,
    ! [VarCurr: state_type] :
      ( v81846(VarCurr)
    <=> v81848(VarCurr) ) ).

tff(addAssignment_50528,axiom,
    ! [VarCurr: state_type] :
      ( v81848(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_50527,axiom,
    ! [VarCurr: state_type] :
      ( v77642(VarCurr)
    <=> v77644(VarCurr) ) ).

tff(addAssignment_50526,axiom,
    ! [VarCurr: state_type] :
      ( v77644(VarCurr)
    <=> v77646(VarCurr) ) ).

tff(addAssignment_50525,axiom,
    ! [VarCurr: state_type] :
      ( v77646(VarCurr)
    <=> v77648(VarCurr) ) ).

tff(addAssignment_50524,axiom,
    ! [VarCurr: state_type] :
      ( v77648(VarCurr)
    <=> v77650(VarCurr) ) ).

tff(writeUnaryOperator_3538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77650(VarCurr)
    <=> v81807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7482,axiom,
    ! [VarCurr: state_type] :
      ( v81807(VarCurr)
    <=> ( v81808(VarCurr)
        | v79917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7481,axiom,
    ! [VarCurr: state_type] :
      ( v81808(VarCurr)
    <=> ( v77652(VarCurr)
        | v77694(VarCurr) ) ) ).

tff(addAssignment_50523,axiom,
    ! [VarCurr: state_type] :
      ( v79917(VarCurr)
    <=> v79919(VarCurr) ) ).

tff(addAssignment_50522,axiom,
    ! [VarCurr: state_type] :
      ( v79919(VarCurr)
    <=> v79921(VarCurr) ) ).

tff(addAssignment_50521,axiom,
    ! [VarCurr: state_type] :
      ( v79921(VarCurr)
    <=> v79923(VarCurr) ) ).

tff(addAssignment_50520,axiom,
    ! [VarCurr: state_type] :
      ( v79923(VarCurr)
    <=> v79925(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7480,axiom,
    ! [VarCurr: state_type] :
      ( v79925(VarCurr)
    <=> ( v79927(VarCurr)
        & v79969(VarCurr) ) ) ).

tff(addAssignment_50519,axiom,
    ! [VarCurr: state_type] :
      ( v79969(VarCurr)
    <=> v79971(VarCurr) ) ).

tff(addAssignment_50518,axiom,
    ! [VarCurr: state_type] :
      ( v79971(VarCurr)
    <=> v79973(VarCurr) ) ).

tff(addAssignment_50517,axiom,
    ! [VarCurr: state_type] :
      ( v79973(VarCurr)
    <=> v79975(VarCurr) ) ).

tff(addAssignment_50516,axiom,
    ! [VarCurr: state_type] :
      ( v79975(VarCurr)
    <=> v79977(VarCurr) ) ).

tff(writeUnaryOperator_3537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79977(VarCurr)
    <=> v79979(VarCurr) ) ).

tff(addAssignment_50515,axiom,
    ! [VarCurr: state_type] :
      ( v79979(VarCurr)
    <=> v79981(VarCurr) ) ).

tff(addAssignment_50514,axiom,
    ! [VarCurr: state_type] :
      ( v79981(VarCurr)
    <=> v79983(VarCurr) ) ).

tff(addAssignment_50513,axiom,
    ! [VarCurr: state_type] :
      ( v79983(VarCurr)
    <=> v79985(VarCurr) ) ).

tff(addAssignment_50512,axiom,
    ! [VarCurr: state_type] :
      ( v79985(VarCurr)
    <=> v79987(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_332,axiom,
    ! [VarCurr: state_type] :
      ( v79987(VarCurr)
    <=> ( ( v79989(VarCurr,15)
        <=> v81541(VarCurr,15) )
        & ( v79989(VarCurr,14)
        <=> v81541(VarCurr,14) )
        & ( v79989(VarCurr,13)
        <=> v81541(VarCurr,13) )
        & ( v79989(VarCurr,12)
        <=> v81541(VarCurr,12) )
        & ( v79989(VarCurr,11)
        <=> v81541(VarCurr,11) )
        & ( v79989(VarCurr,10)
        <=> v81541(VarCurr,10) )
        & ( v79989(VarCurr,9)
        <=> v81541(VarCurr,9) )
        & ( v79989(VarCurr,8)
        <=> v81541(VarCurr,8) )
        & ( v79989(VarCurr,7)
        <=> v81541(VarCurr,7) )
        & ( v79989(VarCurr,6)
        <=> v81541(VarCurr,6) )
        & ( v79989(VarCurr,5)
        <=> v81541(VarCurr,5) )
        & ( v79989(VarCurr,4)
        <=> v81541(VarCurr,4) )
        & ( v79989(VarCurr,3)
        <=> v81541(VarCurr,3) )
        & ( v79989(VarCurr,2)
        <=> v81541(VarCurr,2) )
        & ( v79989(VarCurr,1)
        <=> v81541(VarCurr,1) )
        & ( v79989(VarCurr,0)
        <=> v81541(VarCurr,0) ) ) ) ).

tff(addAssignment_50511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v81541(VarCurr,B)
      <=> v81543(VarCurr,B) ) ) ).

tff(addAssignment_50510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v81543(VarCurr,B)
      <=> v81545(VarCurr,B) ) ) ).

tff(addAssignment_50509,axiom,
    ! [VarCurr: state_type] :
      ( v81543(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_50508,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,0)
    <=> v81772(VarCurr) ) ).

tff(addAssignment_50507,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,1)
    <=> v81757(VarCurr) ) ).

tff(addAssignment_50506,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,2)
    <=> v81742(VarCurr) ) ).

tff(addAssignment_50505,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,3)
    <=> v81727(VarCurr) ) ).

tff(addAssignment_50504,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,4)
    <=> v81712(VarCurr) ) ).

tff(addAssignment_50503,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,5)
    <=> v81697(VarCurr) ) ).

tff(addAssignment_50502,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,6)
    <=> v81682(VarCurr) ) ).

tff(addAssignment_50501,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,7)
    <=> v81667(VarCurr) ) ).

tff(addAssignment_50500,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,8)
    <=> v81652(VarCurr) ) ).

tff(addAssignment_50499,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,9)
    <=> v81637(VarCurr) ) ).

tff(addAssignment_50498,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,10)
    <=> v81622(VarCurr) ) ).

tff(addAssignment_50497,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,11)
    <=> v81607(VarCurr) ) ).

tff(addAssignment_50496,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,12)
    <=> v81592(VarCurr) ) ).

tff(addAssignment_50495,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,13)
    <=> v81577(VarCurr) ) ).

tff(addAssignment_50494,axiom,
    ! [VarCurr: state_type] :
      ( v81545(VarCurr,14)
    <=> v81547(VarCurr) ) ).

tff(addAssignment_50493,axiom,
    ! [VarCurr: state_type] :
      ( v81772(VarCurr)
    <=> v81774(VarCurr) ) ).

tff(addAssignment_50492,axiom,
    ! [VarCurr: state_type] :
      ( v81774(VarCurr)
    <=> v81776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7479,axiom,
    ! [VarCurr: state_type] :
      ( v81776(VarCurr)
    <=> ( v81778(VarCurr)
        & v81782(VarCurr) ) ) ).

tff(addAssignment_50491,axiom,
    ! [VarCurr: state_type] :
      ( v81782(VarCurr)
    <=> v81784(VarCurr) ) ).

tff(addAssignment_50490,axiom,
    ! [VarCurr: state_type] :
      ( v81784(VarCurr)
    <=> v81786(VarCurr) ) ).

tff(addAssignment_50489,axiom,
    ! [VarCurr: state_type] :
      ( v81786(VarCurr)
    <=> v81788(VarCurr) ) ).

tff(addAssignment_50488,axiom,
    ! [VarCurr: state_type] :
      ( v81788(VarCurr)
    <=> v81790(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_331,axiom,
    ! [VarCurr: state_type] :
      ( v81790(VarCurr)
    <=> ( ( v81792(VarCurr,3)
        <=> v81796(VarCurr,3) )
        & ( v81792(VarCurr,2)
        <=> v81796(VarCurr,2) )
        & ( v81792(VarCurr,1)
        <=> v81796(VarCurr,1) )
        & ( v81792(VarCurr,0)
        <=> v81796(VarCurr,0) ) ) ) ).

tff(addAssignment_50487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81796(VarCurr,B)
      <=> v81798(VarCurr,B) ) ) ).

tff(addAssignment_50486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81798(VarCurr,B)
      <=> v77218(VarCurr,B) ) ) ).

tff(addAssignment_50485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81792(VarCurr,B)
      <=> v81794(VarCurr,B) ) ) ).

tff(addAssignment_50484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81794(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_50483,axiom,
    ! [VarCurr: state_type] :
      ( v81778(VarCurr)
    <=> v81780(VarCurr) ) ).

tff(addAssignment_50482,axiom,
    ! [VarCurr: state_type] :
      ( v81780(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50481,axiom,
    ! [VarCurr: state_type] :
      ( v81757(VarCurr)
    <=> v81759(VarCurr) ) ).

tff(addAssignment_50480,axiom,
    ! [VarCurr: state_type] :
      ( v81759(VarCurr)
    <=> v81761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7478,axiom,
    ! [VarCurr: state_type] :
      ( v81761(VarCurr)
    <=> ( v81763(VarCurr)
        & v81767(VarCurr) ) ) ).

tff(addAssignment_50479,axiom,
    ! [VarCurr: state_type] :
      ( v81767(VarCurr)
    <=> v81769(VarCurr) ) ).

tff(addAssignment_50478,axiom,
    ! [VarCurr: state_type] :
      ( v81769(VarCurr)
    <=> v79866(VarCurr) ) ).

tff(addAssignment_50477,axiom,
    ! [VarCurr: state_type] :
      ( v81763(VarCurr)
    <=> v81765(VarCurr) ) ).

tff(addAssignment_50476,axiom,
    ! [VarCurr: state_type] :
      ( v81765(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50475,axiom,
    ! [VarCurr: state_type] :
      ( v81742(VarCurr)
    <=> v81744(VarCurr) ) ).

tff(addAssignment_50474,axiom,
    ! [VarCurr: state_type] :
      ( v81744(VarCurr)
    <=> v81746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7477,axiom,
    ! [VarCurr: state_type] :
      ( v81746(VarCurr)
    <=> ( v81748(VarCurr)
        & v81752(VarCurr) ) ) ).

tff(addAssignment_50473,axiom,
    ! [VarCurr: state_type] :
      ( v81752(VarCurr)
    <=> v81754(VarCurr) ) ).

tff(addAssignment_50472,axiom,
    ! [VarCurr: state_type] :
      ( v81754(VarCurr)
    <=> v79836(VarCurr) ) ).

tff(addAssignment_50471,axiom,
    ! [VarCurr: state_type] :
      ( v81748(VarCurr)
    <=> v81750(VarCurr) ) ).

tff(addAssignment_50470,axiom,
    ! [VarCurr: state_type] :
      ( v81750(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50469,axiom,
    ! [VarCurr: state_type] :
      ( v81727(VarCurr)
    <=> v81729(VarCurr) ) ).

tff(addAssignment_50468,axiom,
    ! [VarCurr: state_type] :
      ( v81729(VarCurr)
    <=> v81731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7476,axiom,
    ! [VarCurr: state_type] :
      ( v81731(VarCurr)
    <=> ( v81733(VarCurr)
        & v81737(VarCurr) ) ) ).

tff(addAssignment_50467,axiom,
    ! [VarCurr: state_type] :
      ( v81737(VarCurr)
    <=> v81739(VarCurr) ) ).

tff(addAssignment_50466,axiom,
    ! [VarCurr: state_type] :
      ( v81739(VarCurr)
    <=> v79806(VarCurr) ) ).

tff(addAssignment_50465,axiom,
    ! [VarCurr: state_type] :
      ( v81733(VarCurr)
    <=> v81735(VarCurr) ) ).

tff(addAssignment_50464,axiom,
    ! [VarCurr: state_type] :
      ( v81735(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50463,axiom,
    ! [VarCurr: state_type] :
      ( v81712(VarCurr)
    <=> v81714(VarCurr) ) ).

tff(addAssignment_50462,axiom,
    ! [VarCurr: state_type] :
      ( v81714(VarCurr)
    <=> v81716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7475,axiom,
    ! [VarCurr: state_type] :
      ( v81716(VarCurr)
    <=> ( v81718(VarCurr)
        & v81722(VarCurr) ) ) ).

tff(addAssignment_50461,axiom,
    ! [VarCurr: state_type] :
      ( v81722(VarCurr)
    <=> v81724(VarCurr) ) ).

tff(addAssignment_50460,axiom,
    ! [VarCurr: state_type] :
      ( v81724(VarCurr)
    <=> v79776(VarCurr) ) ).

tff(addAssignment_50459,axiom,
    ! [VarCurr: state_type] :
      ( v81718(VarCurr)
    <=> v81720(VarCurr) ) ).

tff(addAssignment_50458,axiom,
    ! [VarCurr: state_type] :
      ( v81720(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50457,axiom,
    ! [VarCurr: state_type] :
      ( v81697(VarCurr)
    <=> v81699(VarCurr) ) ).

tff(addAssignment_50456,axiom,
    ! [VarCurr: state_type] :
      ( v81699(VarCurr)
    <=> v81701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7474,axiom,
    ! [VarCurr: state_type] :
      ( v81701(VarCurr)
    <=> ( v81703(VarCurr)
        & v81707(VarCurr) ) ) ).

tff(addAssignment_50455,axiom,
    ! [VarCurr: state_type] :
      ( v81707(VarCurr)
    <=> v81709(VarCurr) ) ).

tff(addAssignment_50454,axiom,
    ! [VarCurr: state_type] :
      ( v81709(VarCurr)
    <=> v79746(VarCurr) ) ).

tff(addAssignment_50453,axiom,
    ! [VarCurr: state_type] :
      ( v81703(VarCurr)
    <=> v81705(VarCurr) ) ).

tff(addAssignment_50452,axiom,
    ! [VarCurr: state_type] :
      ( v81705(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50451,axiom,
    ! [VarCurr: state_type] :
      ( v81682(VarCurr)
    <=> v81684(VarCurr) ) ).

tff(addAssignment_50450,axiom,
    ! [VarCurr: state_type] :
      ( v81684(VarCurr)
    <=> v81686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7473,axiom,
    ! [VarCurr: state_type] :
      ( v81686(VarCurr)
    <=> ( v81688(VarCurr)
        & v81692(VarCurr) ) ) ).

tff(addAssignment_50449,axiom,
    ! [VarCurr: state_type] :
      ( v81692(VarCurr)
    <=> v81694(VarCurr) ) ).

tff(addAssignment_50448,axiom,
    ! [VarCurr: state_type] :
      ( v81694(VarCurr)
    <=> v79716(VarCurr) ) ).

tff(addAssignment_50447,axiom,
    ! [VarCurr: state_type] :
      ( v81688(VarCurr)
    <=> v81690(VarCurr) ) ).

tff(addAssignment_50446,axiom,
    ! [VarCurr: state_type] :
      ( v81690(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50445,axiom,
    ! [VarCurr: state_type] :
      ( v81667(VarCurr)
    <=> v81669(VarCurr) ) ).

tff(addAssignment_50444,axiom,
    ! [VarCurr: state_type] :
      ( v81669(VarCurr)
    <=> v81671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7472,axiom,
    ! [VarCurr: state_type] :
      ( v81671(VarCurr)
    <=> ( v81673(VarCurr)
        & v81677(VarCurr) ) ) ).

tff(addAssignment_50443,axiom,
    ! [VarCurr: state_type] :
      ( v81677(VarCurr)
    <=> v81679(VarCurr) ) ).

tff(addAssignment_50442,axiom,
    ! [VarCurr: state_type] :
      ( v81679(VarCurr)
    <=> v79686(VarCurr) ) ).

tff(addAssignment_50441,axiom,
    ! [VarCurr: state_type] :
      ( v81673(VarCurr)
    <=> v81675(VarCurr) ) ).

tff(addAssignment_50440,axiom,
    ! [VarCurr: state_type] :
      ( v81675(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50439,axiom,
    ! [VarCurr: state_type] :
      ( v81652(VarCurr)
    <=> v81654(VarCurr) ) ).

tff(addAssignment_50438,axiom,
    ! [VarCurr: state_type] :
      ( v81654(VarCurr)
    <=> v81656(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7471,axiom,
    ! [VarCurr: state_type] :
      ( v81656(VarCurr)
    <=> ( v81658(VarCurr)
        & v81662(VarCurr) ) ) ).

tff(addAssignment_50437,axiom,
    ! [VarCurr: state_type] :
      ( v81662(VarCurr)
    <=> v81664(VarCurr) ) ).

tff(addAssignment_50436,axiom,
    ! [VarCurr: state_type] :
      ( v81664(VarCurr)
    <=> v79656(VarCurr) ) ).

tff(addAssignment_50435,axiom,
    ! [VarCurr: state_type] :
      ( v81658(VarCurr)
    <=> v81660(VarCurr) ) ).

tff(addAssignment_50434,axiom,
    ! [VarCurr: state_type] :
      ( v81660(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50433,axiom,
    ! [VarCurr: state_type] :
      ( v81637(VarCurr)
    <=> v81639(VarCurr) ) ).

tff(addAssignment_50432,axiom,
    ! [VarCurr: state_type] :
      ( v81639(VarCurr)
    <=> v81641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7470,axiom,
    ! [VarCurr: state_type] :
      ( v81641(VarCurr)
    <=> ( v81643(VarCurr)
        & v81647(VarCurr) ) ) ).

tff(addAssignment_50431,axiom,
    ! [VarCurr: state_type] :
      ( v81647(VarCurr)
    <=> v81649(VarCurr) ) ).

tff(addAssignment_50430,axiom,
    ! [VarCurr: state_type] :
      ( v81649(VarCurr)
    <=> v79626(VarCurr) ) ).

tff(addAssignment_50429,axiom,
    ! [VarCurr: state_type] :
      ( v81643(VarCurr)
    <=> v81645(VarCurr) ) ).

tff(addAssignment_50428,axiom,
    ! [VarCurr: state_type] :
      ( v81645(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50427,axiom,
    ! [VarCurr: state_type] :
      ( v81622(VarCurr)
    <=> v81624(VarCurr) ) ).

tff(addAssignment_50426,axiom,
    ! [VarCurr: state_type] :
      ( v81624(VarCurr)
    <=> v81626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7469,axiom,
    ! [VarCurr: state_type] :
      ( v81626(VarCurr)
    <=> ( v81628(VarCurr)
        & v81632(VarCurr) ) ) ).

tff(addAssignment_50425,axiom,
    ! [VarCurr: state_type] :
      ( v81632(VarCurr)
    <=> v81634(VarCurr) ) ).

tff(addAssignment_50424,axiom,
    ! [VarCurr: state_type] :
      ( v81634(VarCurr)
    <=> v79596(VarCurr) ) ).

tff(addAssignment_50423,axiom,
    ! [VarCurr: state_type] :
      ( v81628(VarCurr)
    <=> v81630(VarCurr) ) ).

tff(addAssignment_50422,axiom,
    ! [VarCurr: state_type] :
      ( v81630(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50421,axiom,
    ! [VarCurr: state_type] :
      ( v81607(VarCurr)
    <=> v81609(VarCurr) ) ).

tff(addAssignment_50420,axiom,
    ! [VarCurr: state_type] :
      ( v81609(VarCurr)
    <=> v81611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7468,axiom,
    ! [VarCurr: state_type] :
      ( v81611(VarCurr)
    <=> ( v81613(VarCurr)
        & v81617(VarCurr) ) ) ).

tff(addAssignment_50419,axiom,
    ! [VarCurr: state_type] :
      ( v81617(VarCurr)
    <=> v81619(VarCurr) ) ).

tff(addAssignment_50418,axiom,
    ! [VarCurr: state_type] :
      ( v81619(VarCurr)
    <=> v79566(VarCurr) ) ).

tff(addAssignment_50417,axiom,
    ! [VarCurr: state_type] :
      ( v81613(VarCurr)
    <=> v81615(VarCurr) ) ).

tff(addAssignment_50416,axiom,
    ! [VarCurr: state_type] :
      ( v81615(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50415,axiom,
    ! [VarCurr: state_type] :
      ( v81592(VarCurr)
    <=> v81594(VarCurr) ) ).

tff(addAssignment_50414,axiom,
    ! [VarCurr: state_type] :
      ( v81594(VarCurr)
    <=> v81596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7467,axiom,
    ! [VarCurr: state_type] :
      ( v81596(VarCurr)
    <=> ( v81598(VarCurr)
        & v81602(VarCurr) ) ) ).

tff(addAssignment_50413,axiom,
    ! [VarCurr: state_type] :
      ( v81602(VarCurr)
    <=> v81604(VarCurr) ) ).

tff(addAssignment_50412,axiom,
    ! [VarCurr: state_type] :
      ( v81604(VarCurr)
    <=> v79536(VarCurr) ) ).

tff(addAssignment_50411,axiom,
    ! [VarCurr: state_type] :
      ( v81598(VarCurr)
    <=> v81600(VarCurr) ) ).

tff(addAssignment_50410,axiom,
    ! [VarCurr: state_type] :
      ( v81600(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50409,axiom,
    ! [VarCurr: state_type] :
      ( v81577(VarCurr)
    <=> v81579(VarCurr) ) ).

tff(addAssignment_50408,axiom,
    ! [VarCurr: state_type] :
      ( v81579(VarCurr)
    <=> v81581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7466,axiom,
    ! [VarCurr: state_type] :
      ( v81581(VarCurr)
    <=> ( v81583(VarCurr)
        & v81587(VarCurr) ) ) ).

tff(addAssignment_50407,axiom,
    ! [VarCurr: state_type] :
      ( v81587(VarCurr)
    <=> v81589(VarCurr) ) ).

tff(addAssignment_50406,axiom,
    ! [VarCurr: state_type] :
      ( v81589(VarCurr)
    <=> v79506(VarCurr) ) ).

tff(addAssignment_50405,axiom,
    ! [VarCurr: state_type] :
      ( v81583(VarCurr)
    <=> v81585(VarCurr) ) ).

tff(addAssignment_50404,axiom,
    ! [VarCurr: state_type] :
      ( v81585(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50403,axiom,
    ! [VarCurr: state_type] :
      ( v81547(VarCurr)
    <=> v81549(VarCurr) ) ).

tff(addAssignment_50402,axiom,
    ! [VarCurr: state_type] :
      ( v81549(VarCurr)
    <=> v81551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7465,axiom,
    ! [VarCurr: state_type] :
      ( v81551(VarCurr)
    <=> ( v81553(VarCurr)
        & v81572(VarCurr) ) ) ).

tff(addAssignment_50401,axiom,
    ! [VarCurr: state_type] :
      ( v81572(VarCurr)
    <=> v81574(VarCurr) ) ).

tff(addAssignment_50400,axiom,
    ! [VarCurr: state_type] :
      ( v81574(VarCurr)
    <=> v79476(VarCurr) ) ).

tff(addAssignment_50399,axiom,
    ! [VarCurr: state_type] :
      ( v81553(VarCurr)
    <=> v81555(VarCurr) ) ).

tff(addAssignment_50398,axiom,
    ! [VarCurr: state_type] :
      ( v81555(VarCurr)
    <=> v81557(VarCurr) ) ).

tff(addAssignment_50397,axiom,
    ! [VarCurr: state_type] :
      ( v81557(VarCurr)
    <=> v81559(VarCurr) ) ).

tff(addAssignment_50396,axiom,
    ! [VarCurr: state_type] :
      ( v81559(VarCurr)
    <=> v81561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7464,axiom,
    ! [VarCurr: state_type] :
      ( v81561(VarCurr)
    <=> ( v81563(VarCurr)
        & v81567(VarCurr) ) ) ).

tff(addAssignment_50395,axiom,
    ! [VarCurr: state_type] :
      ( v81567(VarCurr)
    <=> v81569(VarCurr) ) ).

tff(addAssignment_50394,axiom,
    ! [VarCurr: state_type] :
      ( v81569(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_50393,axiom,
    ! [VarCurr: state_type] :
      ( v81563(VarCurr)
    <=> v81565(VarCurr) ) ).

tff(addAssignment_50392,axiom,
    ! [VarCurr: state_type] :
      ( v81565(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_50391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v79989(VarCurr,B)
      <=> v79991(VarCurr,B) ) ) ).

tff(addAssignment_50390,axiom,
    ! [VarCurr: state_type] :
      ( ( v79991(VarCurr,14)
      <=> v77770(VarCurr,29) )
      & ( v79991(VarCurr,13)
      <=> v77770(VarCurr,28) )
      & ( v79991(VarCurr,12)
      <=> v77770(VarCurr,27) )
      & ( v79991(VarCurr,11)
      <=> v77770(VarCurr,26) )
      & ( v79991(VarCurr,10)
      <=> v77770(VarCurr,25) )
      & ( v79991(VarCurr,9)
      <=> v77770(VarCurr,24) )
      & ( v79991(VarCurr,8)
      <=> v77770(VarCurr,23) )
      & ( v79991(VarCurr,7)
      <=> v77770(VarCurr,22) )
      & ( v79991(VarCurr,6)
      <=> v77770(VarCurr,21) )
      & ( v79991(VarCurr,5)
      <=> v77770(VarCurr,20) )
      & ( v79991(VarCurr,4)
      <=> v77770(VarCurr,19) )
      & ( v79991(VarCurr,3)
      <=> v77770(VarCurr,18) )
      & ( v79991(VarCurr,2)
      <=> v77770(VarCurr,17) )
      & ( v79991(VarCurr,1)
      <=> v77770(VarCurr,16) )
      & ( v79991(VarCurr,0)
      <=> v77770(VarCurr,15) ) ) ).

tff(addAssignment_50389,axiom,
    ! [VarCurr: state_type] :
      ( v79991(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_50388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,15) )
     => ( v77770(VarCurr,B)
      <=> v79420(VarCurr,B) ) ) ).

tff(addAssignment_50387,axiom,
    ! [VarCurr: state_type] :
      ( v79438(VarCurr)
    <=> v81512(VarCurr) ) ).

tff(addAssignment_50386,axiom,
    ! [VarCurr: state_type] :
      ( v81512(VarCurr)
    <=> v81514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7463,axiom,
    ! [VarCurr: state_type] :
      ( v81514(VarCurr)
    <=> ( v81516(VarCurr)
        & v81520(VarCurr) ) ) ).

tff(addAssignment_50385,axiom,
    ! [VarCurr: state_type] :
      ( v81520(VarCurr)
    <=> v81522(VarCurr) ) ).

tff(addAssignment_50384,axiom,
    ! [VarCurr: state_type] :
      ( v81522(VarCurr)
    <=> v81524(VarCurr) ) ).

tff(addAssignment_50383,axiom,
    ! [VarCurr: state_type] :
      ( v81524(VarCurr)
    <=> v81526(VarCurr) ) ).

tff(addAssignment_50382,axiom,
    ! [VarCurr: state_type] :
      ( v81526(VarCurr)
    <=> v81528(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_330,axiom,
    ! [VarCurr: state_type] :
      ( v81528(VarCurr)
    <=> ( ( v81530(VarCurr,3)
        <=> v81534(VarCurr,3) )
        & ( v81530(VarCurr,2)
        <=> v81534(VarCurr,2) )
        & ( v81530(VarCurr,1)
        <=> v81534(VarCurr,1) )
        & ( v81530(VarCurr,0)
        <=> v81534(VarCurr,0) ) ) ) ).

tff(addAssignment_50381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81534(VarCurr,B)
      <=> v81536(VarCurr,B) ) ) ).

tff(addAssignment_50380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81536(VarCurr,B)
      <=> v77218(VarCurr,B) ) ) ).

tff(addAssignment_50379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81530(VarCurr,B)
      <=> v81532(VarCurr,B) ) ) ).

tff(addAssignment_50378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81532(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50377,axiom,
    ! [VarCurr: state_type] :
      ( v81516(VarCurr)
    <=> v81518(VarCurr) ) ).

tff(addAssignment_50376,axiom,
    ! [VarCurr: state_type] :
      ( v81518(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50375,axiom,
    ! [VarCurr: state_type] :
      ( v79437(VarCurr)
    <=> v81443(VarCurr) ) ).

tff(addAssignment_50374,axiom,
    ! [VarCurr: state_type] :
      ( v81443(VarCurr)
    <=> v81445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7462,axiom,
    ! [VarCurr: state_type] :
      ( v81445(VarCurr)
    <=> ( v81447(VarCurr)
        & v81451(VarCurr) ) ) ).

tff(addAssignment_50373,axiom,
    ! [VarCurr: state_type] :
      ( v81451(VarCurr)
    <=> v81453(VarCurr) ) ).

tff(addAssignment_50372,axiom,
    ! [VarCurr: state_type] :
      ( v81453(VarCurr)
    <=> v81455(VarCurr) ) ).

tff(addAssignment_50371,axiom,
    ! [VarCurr: state_type] :
      ( v81455(VarCurr)
    <=> v81457(VarCurr) ) ).

tff(addAssignment_50370,axiom,
    ! [VarCurr: state_type] :
      ( v81457(VarCurr)
    <=> v81459(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_329,axiom,
    ! [VarCurr: state_type] :
      ( v81459(VarCurr)
    <=> ( ( v81461(VarCurr,3)
        <=> v81465(VarCurr,3) )
        & ( v81461(VarCurr,2)
        <=> v81465(VarCurr,2) )
        & ( v81461(VarCurr,1)
        <=> v81465(VarCurr,1) )
        & ( v81461(VarCurr,0)
        <=> v81465(VarCurr,0) ) ) ) ).

tff(addAssignment_50369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81465(VarCurr,B)
      <=> v81467(VarCurr,B) ) ) ).

tff(addAssignment_50368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81467(VarCurr,B)
      <=> v81469(VarCurr,B) ) ) ).

tff(addAssignment_50367,axiom,
    ! [VarCurr: state_type] :
      ( ( v81469(VarCurr,3)
      <=> v77817(VarCurr,59) )
      & ( v81469(VarCurr,2)
      <=> v77817(VarCurr,58) )
      & ( v81469(VarCurr,1)
      <=> v77817(VarCurr,57) )
      & ( v81469(VarCurr,0)
      <=> v77817(VarCurr,56) ) ) ).

tff(addAssignment_50366,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,59)
      <=> v80037(VarCurr,3) )
      & ( v77817(VarCurr,58)
      <=> v80037(VarCurr,2) )
      & ( v77817(VarCurr,57)
      <=> v80037(VarCurr,1) )
      & ( v77817(VarCurr,56)
      <=> v80037(VarCurr,0) ) ) ).

tff(addAssignment_50365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50361,axiom,
    ! [VarCurr: state_type] :
      ( v80215(VarCurr,3)
    <=> v81472(VarCurr) ) ).

tff(addAssignment_50360,axiom,
    ! [VarCurr: state_type] :
      ( v80215(VarCurr,2)
    <=> v81480(VarCurr) ) ).

tff(addAssignment_50359,axiom,
    ! [VarCurr: state_type] :
      ( v80215(VarCurr,1)
    <=> v81488(VarCurr) ) ).

tff(addAssignment_50358,axiom,
    ! [VarCurr: state_type] :
      ( v80215(VarCurr,0)
    <=> v81501(VarCurr) ) ).

tff(addAssignment_50357,axiom,
    ! [VarCurr: state_type] :
      ( v81501(VarCurr)
    <=> v81503(VarCurr) ) ).

tff(addAssignment_50356,axiom,
    ! [VarCurr: state_type] :
      ( v81503(VarCurr)
    <=> v81505(VarCurr) ) ).

tff(addAssignment_50355,axiom,
    ! [VarCurr: state_type] :
      ( v81505(VarCurr)
    <=> v81507(VarCurr) ) ).

tff(addAssignment_50354,axiom,
    ! [VarCurr: state_type] :
      ( v81507(VarCurr)
    <=> v77837(VarCurr,67) ) ).

tff(addAssignment_50353,axiom,
    ! [VarCurr: state_type] :
      ( v81488(VarCurr)
    <=> v81490(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7461,axiom,
    ! [VarCurr: state_type] :
      ( v81490(VarCurr)
    <=> ( v81492(VarCurr)
      <~> v81496(VarCurr) ) ) ).

tff(addAssignment_50352,axiom,
    ! [VarCurr: state_type] :
      ( v81496(VarCurr)
    <=> v81498(VarCurr) ) ).

tff(addAssignment_50351,axiom,
    ! [VarCurr: state_type] :
      ( v81498(VarCurr)
    <=> v77837(VarCurr,67) ) ).

tff(addAssignment_50350,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,67)
    <=> v77894(VarCurr,67) ) ).

tff(addAssignment_50349,axiom,
    ! [VarCurr: state_type] :
      ( v81492(VarCurr)
    <=> v81494(VarCurr) ) ).

tff(addAssignment_50348,axiom,
    ! [VarCurr: state_type] :
      ( v81494(VarCurr)
    <=> v77837(VarCurr,64) ) ).

tff(addAssignment_50347,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,64)
    <=> v77894(VarCurr,64) ) ).

tff(addAssignment_50346,axiom,
    ! [VarCurr: state_type] :
      ( v81480(VarCurr)
    <=> v81482(VarCurr) ) ).

tff(addAssignment_50345,axiom,
    ! [VarCurr: state_type] :
      ( v81482(VarCurr)
    <=> v81484(VarCurr) ) ).

tff(addAssignment_50344,axiom,
    ! [VarCurr: state_type] :
      ( v81484(VarCurr)
    <=> v81486(VarCurr) ) ).

tff(addAssignment_50343,axiom,
    ! [VarCurr: state_type] :
      ( v81486(VarCurr)
    <=> v77837(VarCurr,65) ) ).

tff(addAssignment_50342,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,65)
    <=> v77894(VarCurr,65) ) ).

tff(addAssignment_50341,axiom,
    ! [VarCurr: state_type] :
      ( v81472(VarCurr)
    <=> v81474(VarCurr) ) ).

tff(addAssignment_50340,axiom,
    ! [VarCurr: state_type] :
      ( v81474(VarCurr)
    <=> v81476(VarCurr) ) ).

tff(addAssignment_50339,axiom,
    ! [VarCurr: state_type] :
      ( v81476(VarCurr)
    <=> v81478(VarCurr) ) ).

tff(addAssignment_50338,axiom,
    ! [VarCurr: state_type] :
      ( v81478(VarCurr)
    <=> v77837(VarCurr,66) ) ).

tff(addAssignment_50337,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,66)
    <=> v77894(VarCurr,66) ) ).

tff(addAssignment_50336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81461(VarCurr,B)
      <=> v81463(VarCurr,B) ) ) ).

tff(addAssignment_50335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81463(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50334,axiom,
    ! [VarCurr: state_type] :
      ( v81447(VarCurr)
    <=> v81449(VarCurr) ) ).

tff(addAssignment_50333,axiom,
    ! [VarCurr: state_type] :
      ( v81449(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50332,axiom,
    ! [VarCurr: state_type] :
      ( v79436(VarCurr)
    <=> v81354(VarCurr) ) ).

tff(addAssignment_50331,axiom,
    ! [VarCurr: state_type] :
      ( v81354(VarCurr)
    <=> v81356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7460,axiom,
    ! [VarCurr: state_type] :
      ( v81356(VarCurr)
    <=> ( v81358(VarCurr)
        & v81362(VarCurr) ) ) ).

tff(addAssignment_50330,axiom,
    ! [VarCurr: state_type] :
      ( v81362(VarCurr)
    <=> v81364(VarCurr) ) ).

tff(addAssignment_50329,axiom,
    ! [VarCurr: state_type] :
      ( v81364(VarCurr)
    <=> v81366(VarCurr) ) ).

tff(addAssignment_50328,axiom,
    ! [VarCurr: state_type] :
      ( v81366(VarCurr)
    <=> v81368(VarCurr) ) ).

tff(addAssignment_50327,axiom,
    ! [VarCurr: state_type] :
      ( v81368(VarCurr)
    <=> v81370(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_328,axiom,
    ! [VarCurr: state_type] :
      ( v81370(VarCurr)
    <=> ( ( v81372(VarCurr,3)
        <=> v81376(VarCurr,3) )
        & ( v81372(VarCurr,2)
        <=> v81376(VarCurr,2) )
        & ( v81372(VarCurr,1)
        <=> v81376(VarCurr,1) )
        & ( v81372(VarCurr,0)
        <=> v81376(VarCurr,0) ) ) ) ).

tff(addAssignment_50326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81376(VarCurr,B)
      <=> v81378(VarCurr,B) ) ) ).

tff(addAssignment_50325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81378(VarCurr,B)
      <=> v81380(VarCurr,B) ) ) ).

tff(addAssignment_50324,axiom,
    ! [VarCurr: state_type] :
      ( ( v81380(VarCurr,3)
      <=> v77817(VarCurr,63) )
      & ( v81380(VarCurr,2)
      <=> v77817(VarCurr,62) )
      & ( v81380(VarCurr,1)
      <=> v77817(VarCurr,61) )
      & ( v81380(VarCurr,0)
      <=> v77817(VarCurr,60) ) ) ).

tff(addAssignment_50323,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,63)
      <=> v80037(VarCurr,7) )
      & ( v77817(VarCurr,62)
      <=> v80037(VarCurr,6) )
      & ( v77817(VarCurr,61)
      <=> v80037(VarCurr,5) )
      & ( v77817(VarCurr,60)
      <=> v80037(VarCurr,4) ) ) ).

tff(addAssignment_50322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50318,axiom,
    ! [VarCurr: state_type] :
      ( v80214(VarCurr,3)
    <=> v81383(VarCurr) ) ).

tff(addAssignment_50317,axiom,
    ! [VarCurr: state_type] :
      ( v80214(VarCurr,2)
    <=> v81396(VarCurr) ) ).

tff(addAssignment_50316,axiom,
    ! [VarCurr: state_type] :
      ( v80214(VarCurr,1)
    <=> v81409(VarCurr) ) ).

tff(addAssignment_50315,axiom,
    ! [VarCurr: state_type] :
      ( v80214(VarCurr,0)
    <=> v81427(VarCurr) ) ).

tff(addAssignment_50314,axiom,
    ! [VarCurr: state_type] :
      ( v81427(VarCurr)
    <=> v81429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7459,axiom,
    ! [VarCurr: state_type] :
      ( v81429(VarCurr)
    <=> ( v81431(VarCurr)
      <~> v81435(VarCurr) ) ) ).

tff(addAssignment_50313,axiom,
    ! [VarCurr: state_type] :
      ( v81435(VarCurr)
    <=> v81437(VarCurr) ) ).

tff(addAssignment_50312,axiom,
    ! [VarCurr: state_type] :
      ( v81437(VarCurr)
    <=> v77837(VarCurr,71) ) ).

tff(addAssignment_50311,axiom,
    ! [VarCurr: state_type] :
      ( v81431(VarCurr)
    <=> v81433(VarCurr) ) ).

tff(addAssignment_50310,axiom,
    ! [VarCurr: state_type] :
      ( v81433(VarCurr)
    <=> v77837(VarCurr,68) ) ).

tff(addAssignment_50309,axiom,
    ! [VarCurr: state_type] :
      ( v81409(VarCurr)
    <=> v81411(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7458,axiom,
    ! [VarCurr: state_type] :
      ( v81411(VarCurr)
    <=> ( v81425(VarCurr)
      <~> v81421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7457,axiom,
    ! [VarCurr: state_type] :
      ( v81425(VarCurr)
    <=> ( v81413(VarCurr)
      <~> v81417(VarCurr) ) ) ).

tff(addAssignment_50308,axiom,
    ! [VarCurr: state_type] :
      ( v81421(VarCurr)
    <=> v81423(VarCurr) ) ).

tff(addAssignment_50307,axiom,
    ! [VarCurr: state_type] :
      ( v81423(VarCurr)
    <=> v77837(VarCurr,71) ) ).

tff(addAssignment_50306,axiom,
    ! [VarCurr: state_type] :
      ( v81417(VarCurr)
    <=> v81419(VarCurr) ) ).

tff(addAssignment_50305,axiom,
    ! [VarCurr: state_type] :
      ( v81419(VarCurr)
    <=> v77837(VarCurr,69) ) ).

tff(addAssignment_50304,axiom,
    ! [VarCurr: state_type] :
      ( v81413(VarCurr)
    <=> v81415(VarCurr) ) ).

tff(addAssignment_50303,axiom,
    ! [VarCurr: state_type] :
      ( v81415(VarCurr)
    <=> v77837(VarCurr,68) ) ).

tff(addAssignment_50302,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,68)
    <=> v77894(VarCurr,68) ) ).

tff(addAssignment_50301,axiom,
    ! [VarCurr: state_type] :
      ( v81396(VarCurr)
    <=> v81398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7456,axiom,
    ! [VarCurr: state_type] :
      ( v81398(VarCurr)
    <=> ( v81400(VarCurr)
      <~> v81404(VarCurr) ) ) ).

tff(addAssignment_50300,axiom,
    ! [VarCurr: state_type] :
      ( v81404(VarCurr)
    <=> v81406(VarCurr) ) ).

tff(addAssignment_50299,axiom,
    ! [VarCurr: state_type] :
      ( v81406(VarCurr)
    <=> v77837(VarCurr,70) ) ).

tff(addAssignment_50298,axiom,
    ! [VarCurr: state_type] :
      ( v81400(VarCurr)
    <=> v81402(VarCurr) ) ).

tff(addAssignment_50297,axiom,
    ! [VarCurr: state_type] :
      ( v81402(VarCurr)
    <=> v77837(VarCurr,69) ) ).

tff(addAssignment_50296,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,69)
    <=> v77894(VarCurr,69) ) ).

tff(addAssignment_50295,axiom,
    ! [VarCurr: state_type] :
      ( v81383(VarCurr)
    <=> v81385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7455,axiom,
    ! [VarCurr: state_type] :
      ( v81385(VarCurr)
    <=> ( v81387(VarCurr)
      <~> v81391(VarCurr) ) ) ).

tff(addAssignment_50294,axiom,
    ! [VarCurr: state_type] :
      ( v81391(VarCurr)
    <=> v81393(VarCurr) ) ).

tff(addAssignment_50293,axiom,
    ! [VarCurr: state_type] :
      ( v81393(VarCurr)
    <=> v77837(VarCurr,71) ) ).

tff(addAssignment_50292,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,71)
    <=> v77894(VarCurr,71) ) ).

tff(addAssignment_50291,axiom,
    ! [VarCurr: state_type] :
      ( v81387(VarCurr)
    <=> v81389(VarCurr) ) ).

tff(addAssignment_50290,axiom,
    ! [VarCurr: state_type] :
      ( v81389(VarCurr)
    <=> v77837(VarCurr,70) ) ).

tff(addAssignment_50289,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,70)
    <=> v77894(VarCurr,70) ) ).

tff(addAssignment_50288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81372(VarCurr,B)
      <=> v81374(VarCurr,B) ) ) ).

tff(addAssignment_50287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81374(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50286,axiom,
    ! [VarCurr: state_type] :
      ( v81358(VarCurr)
    <=> v81360(VarCurr) ) ).

tff(addAssignment_50285,axiom,
    ! [VarCurr: state_type] :
      ( v81360(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50284,axiom,
    ! [VarCurr: state_type] :
      ( v79435(VarCurr)
    <=> v81280(VarCurr) ) ).

tff(addAssignment_50283,axiom,
    ! [VarCurr: state_type] :
      ( v81280(VarCurr)
    <=> v81282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7454,axiom,
    ! [VarCurr: state_type] :
      ( v81282(VarCurr)
    <=> ( v81284(VarCurr)
        & v81288(VarCurr) ) ) ).

tff(addAssignment_50282,axiom,
    ! [VarCurr: state_type] :
      ( v81288(VarCurr)
    <=> v81290(VarCurr) ) ).

tff(addAssignment_50281,axiom,
    ! [VarCurr: state_type] :
      ( v81290(VarCurr)
    <=> v81292(VarCurr) ) ).

tff(addAssignment_50280,axiom,
    ! [VarCurr: state_type] :
      ( v81292(VarCurr)
    <=> v81294(VarCurr) ) ).

tff(addAssignment_50279,axiom,
    ! [VarCurr: state_type] :
      ( v81294(VarCurr)
    <=> v81296(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_327,axiom,
    ! [VarCurr: state_type] :
      ( v81296(VarCurr)
    <=> ( ( v81298(VarCurr,3)
        <=> v81302(VarCurr,3) )
        & ( v81298(VarCurr,2)
        <=> v81302(VarCurr,2) )
        & ( v81298(VarCurr,1)
        <=> v81302(VarCurr,1) )
        & ( v81298(VarCurr,0)
        <=> v81302(VarCurr,0) ) ) ) ).

tff(addAssignment_50278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81302(VarCurr,B)
      <=> v81304(VarCurr,B) ) ) ).

tff(addAssignment_50277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81304(VarCurr,B)
      <=> v81306(VarCurr,B) ) ) ).

tff(addAssignment_50276,axiom,
    ! [VarCurr: state_type] :
      ( ( v81306(VarCurr,3)
      <=> v77817(VarCurr,67) )
      & ( v81306(VarCurr,2)
      <=> v77817(VarCurr,66) )
      & ( v81306(VarCurr,1)
      <=> v77817(VarCurr,65) )
      & ( v81306(VarCurr,0)
      <=> v77817(VarCurr,64) ) ) ).

tff(addAssignment_50275,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,67)
      <=> v80037(VarCurr,11) )
      & ( v77817(VarCurr,66)
      <=> v80037(VarCurr,10) )
      & ( v77817(VarCurr,65)
      <=> v80037(VarCurr,9) )
      & ( v77817(VarCurr,64)
      <=> v80037(VarCurr,8) ) ) ).

tff(addAssignment_50274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50270,axiom,
    ! [VarCurr: state_type] :
      ( v80213(VarCurr,3)
    <=> v81309(VarCurr) ) ).

tff(addAssignment_50269,axiom,
    ! [VarCurr: state_type] :
      ( v80213(VarCurr,2)
    <=> v81317(VarCurr) ) ).

tff(addAssignment_50268,axiom,
    ! [VarCurr: state_type] :
      ( v80213(VarCurr,1)
    <=> v81330(VarCurr) ) ).

tff(addAssignment_50267,axiom,
    ! [VarCurr: state_type] :
      ( v80213(VarCurr,0)
    <=> v81343(VarCurr) ) ).

tff(addAssignment_50266,axiom,
    ! [VarCurr: state_type] :
      ( v81343(VarCurr)
    <=> v81345(VarCurr) ) ).

tff(addAssignment_50265,axiom,
    ! [VarCurr: state_type] :
      ( v81345(VarCurr)
    <=> v81347(VarCurr) ) ).

tff(addAssignment_50264,axiom,
    ! [VarCurr: state_type] :
      ( v81347(VarCurr)
    <=> v81349(VarCurr) ) ).

tff(addAssignment_50263,axiom,
    ! [VarCurr: state_type] :
      ( v81349(VarCurr)
    <=> v77837(VarCurr,74) ) ).

tff(addAssignment_50262,axiom,
    ! [VarCurr: state_type] :
      ( v81330(VarCurr)
    <=> v81332(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7453,axiom,
    ! [VarCurr: state_type] :
      ( v81332(VarCurr)
    <=> ( v81334(VarCurr)
      <~> v81338(VarCurr) ) ) ).

tff(addAssignment_50261,axiom,
    ! [VarCurr: state_type] :
      ( v81338(VarCurr)
    <=> v81340(VarCurr) ) ).

tff(addAssignment_50260,axiom,
    ! [VarCurr: state_type] :
      ( v81340(VarCurr)
    <=> v77837(VarCurr,75) ) ).

tff(addAssignment_50259,axiom,
    ! [VarCurr: state_type] :
      ( v81334(VarCurr)
    <=> v81336(VarCurr) ) ).

tff(addAssignment_50258,axiom,
    ! [VarCurr: state_type] :
      ( v81336(VarCurr)
    <=> v77837(VarCurr,74) ) ).

tff(addAssignment_50257,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,74)
    <=> v77894(VarCurr,74) ) ).

tff(addAssignment_50256,axiom,
    ! [VarCurr: state_type] :
      ( v81317(VarCurr)
    <=> v81319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7452,axiom,
    ! [VarCurr: state_type] :
      ( v81319(VarCurr)
    <=> ( v81321(VarCurr)
      <~> v81325(VarCurr) ) ) ).

tff(addAssignment_50255,axiom,
    ! [VarCurr: state_type] :
      ( v81325(VarCurr)
    <=> v81327(VarCurr) ) ).

tff(addAssignment_50254,axiom,
    ! [VarCurr: state_type] :
      ( v81327(VarCurr)
    <=> v77837(VarCurr,75) ) ).

tff(addAssignment_50253,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,75)
    <=> v77894(VarCurr,75) ) ).

tff(addAssignment_50252,axiom,
    ! [VarCurr: state_type] :
      ( v81321(VarCurr)
    <=> v81323(VarCurr) ) ).

tff(addAssignment_50251,axiom,
    ! [VarCurr: state_type] :
      ( v81323(VarCurr)
    <=> v77837(VarCurr,72) ) ).

tff(addAssignment_50250,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,72)
    <=> v77894(VarCurr,72) ) ).

tff(addAssignment_50249,axiom,
    ! [VarCurr: state_type] :
      ( v81309(VarCurr)
    <=> v81311(VarCurr) ) ).

tff(addAssignment_50248,axiom,
    ! [VarCurr: state_type] :
      ( v81311(VarCurr)
    <=> v81313(VarCurr) ) ).

tff(addAssignment_50247,axiom,
    ! [VarCurr: state_type] :
      ( v81313(VarCurr)
    <=> v81315(VarCurr) ) ).

tff(addAssignment_50246,axiom,
    ! [VarCurr: state_type] :
      ( v81315(VarCurr)
    <=> v77837(VarCurr,73) ) ).

tff(addAssignment_50245,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,73)
    <=> v77894(VarCurr,73) ) ).

tff(addAssignment_50244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81298(VarCurr,B)
      <=> v81300(VarCurr,B) ) ) ).

tff(addAssignment_50243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81300(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50242,axiom,
    ! [VarCurr: state_type] :
      ( v81284(VarCurr)
    <=> v81286(VarCurr) ) ).

tff(addAssignment_50241,axiom,
    ! [VarCurr: state_type] :
      ( v81286(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50240,axiom,
    ! [VarCurr: state_type] :
      ( v79434(VarCurr)
    <=> v81146(VarCurr) ) ).

tff(addAssignment_50239,axiom,
    ! [VarCurr: state_type] :
      ( v81146(VarCurr)
    <=> v81148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7451,axiom,
    ! [VarCurr: state_type] :
      ( v81148(VarCurr)
    <=> ( v81150(VarCurr)
        & v81154(VarCurr) ) ) ).

tff(addAssignment_50238,axiom,
    ! [VarCurr: state_type] :
      ( v81154(VarCurr)
    <=> v81156(VarCurr) ) ).

tff(addAssignment_50237,axiom,
    ! [VarCurr: state_type] :
      ( v81156(VarCurr)
    <=> v81158(VarCurr) ) ).

tff(addAssignment_50236,axiom,
    ! [VarCurr: state_type] :
      ( v81158(VarCurr)
    <=> v81160(VarCurr) ) ).

tff(addAssignment_50235,axiom,
    ! [VarCurr: state_type] :
      ( v81160(VarCurr)
    <=> v81162(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_326,axiom,
    ! [VarCurr: state_type] :
      ( v81162(VarCurr)
    <=> ( ( v81164(VarCurr,3)
        <=> v81168(VarCurr,3) )
        & ( v81164(VarCurr,2)
        <=> v81168(VarCurr,2) )
        & ( v81164(VarCurr,1)
        <=> v81168(VarCurr,1) )
        & ( v81164(VarCurr,0)
        <=> v81168(VarCurr,0) ) ) ) ).

tff(addAssignment_50234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81168(VarCurr,B)
      <=> v81170(VarCurr,B) ) ) ).

tff(addAssignment_50233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81170(VarCurr,B)
      <=> v81172(VarCurr,B) ) ) ).

tff(addAssignment_50232,axiom,
    ! [VarCurr: state_type] :
      ( ( v81172(VarCurr,3)
      <=> v77817(VarCurr,71) )
      & ( v81172(VarCurr,2)
      <=> v77817(VarCurr,70) )
      & ( v81172(VarCurr,1)
      <=> v77817(VarCurr,69) )
      & ( v81172(VarCurr,0)
      <=> v77817(VarCurr,68) ) ) ).

tff(addAssignment_50231,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,71)
      <=> v80037(VarCurr,15) )
      & ( v77817(VarCurr,70)
      <=> v80037(VarCurr,14) )
      & ( v77817(VarCurr,69)
      <=> v80037(VarCurr,13) )
      & ( v77817(VarCurr,68)
      <=> v80037(VarCurr,12) ) ) ).

tff(addAssignment_50230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50226,axiom,
    ! [VarCurr: state_type] :
      ( v80212(VarCurr,3)
    <=> v81175(VarCurr) ) ).

tff(addAssignment_50225,axiom,
    ! [VarCurr: state_type] :
      ( v80212(VarCurr,2)
    <=> v81208(VarCurr) ) ).

tff(addAssignment_50224,axiom,
    ! [VarCurr: state_type] :
      ( v80212(VarCurr,1)
    <=> v81246(VarCurr) ) ).

tff(addAssignment_50223,axiom,
    ! [VarCurr: state_type] :
      ( v80212(VarCurr,0)
    <=> v81264(VarCurr) ) ).

tff(addAssignment_50222,axiom,
    ! [VarCurr: state_type] :
      ( v81264(VarCurr)
    <=> v81266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7450,axiom,
    ! [VarCurr: state_type] :
      ( v81266(VarCurr)
    <=> ( v81268(VarCurr)
      <~> v81272(VarCurr) ) ) ).

tff(addAssignment_50221,axiom,
    ! [VarCurr: state_type] :
      ( v81272(VarCurr)
    <=> v81274(VarCurr) ) ).

tff(addAssignment_50220,axiom,
    ! [VarCurr: state_type] :
      ( v81274(VarCurr)
    <=> v77837(VarCurr,78) ) ).

tff(addAssignment_50219,axiom,
    ! [VarCurr: state_type] :
      ( v81268(VarCurr)
    <=> v81270(VarCurr) ) ).

tff(addAssignment_50218,axiom,
    ! [VarCurr: state_type] :
      ( v81270(VarCurr)
    <=> v77837(VarCurr,76) ) ).

tff(addAssignment_50217,axiom,
    ! [VarCurr: state_type] :
      ( v81246(VarCurr)
    <=> v81248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7449,axiom,
    ! [VarCurr: state_type] :
      ( v81248(VarCurr)
    <=> ( v81262(VarCurr)
      <~> v81258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7448,axiom,
    ! [VarCurr: state_type] :
      ( v81262(VarCurr)
    <=> ( v81250(VarCurr)
      <~> v81254(VarCurr) ) ) ).

tff(addAssignment_50216,axiom,
    ! [VarCurr: state_type] :
      ( v81258(VarCurr)
    <=> v81260(VarCurr) ) ).

tff(addAssignment_50215,axiom,
    ! [VarCurr: state_type] :
      ( v81260(VarCurr)
    <=> v77837(VarCurr,79) ) ).

tff(addAssignment_50214,axiom,
    ! [VarCurr: state_type] :
      ( v81254(VarCurr)
    <=> v81256(VarCurr) ) ).

tff(addAssignment_50213,axiom,
    ! [VarCurr: state_type] :
      ( v81256(VarCurr)
    <=> v77837(VarCurr,78) ) ).

tff(addAssignment_50212,axiom,
    ! [VarCurr: state_type] :
      ( v81250(VarCurr)
    <=> v81252(VarCurr) ) ).

tff(addAssignment_50211,axiom,
    ! [VarCurr: state_type] :
      ( v81252(VarCurr)
    <=> v77837(VarCurr,77) ) ).

tff(addAssignment_50210,axiom,
    ! [VarCurr: state_type] :
      ( v81208(VarCurr)
    <=> v81210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7447,axiom,
    ! [VarCurr: state_type] :
      ( v81210(VarCurr)
    <=> ( v81244(VarCurr)
      <~> v81240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7446,axiom,
    ! [VarCurr: state_type] :
      ( v81244(VarCurr)
    <=> ( v81212(VarCurr)
      <~> v81226(VarCurr) ) ) ).

tff(addAssignment_50209,axiom,
    ! [VarCurr: state_type] :
      ( v81240(VarCurr)
    <=> v81242(VarCurr) ) ).

tff(addAssignment_50208,axiom,
    ! [VarCurr: state_type] :
      ( v81242(VarCurr)
    <=> v77837(VarCurr,79) ) ).

tff(addAssignment_50207,axiom,
    ! [VarCurr: state_type] :
      ( v81226(VarCurr)
    <=> v81228(VarCurr) ) ).

tff(addAssignment_50206,axiom,
    ! [VarCurr: state_type] :
      ( v81228(VarCurr)
    <=> v77837(VarCurr,78) ) ).

tff(addAssignment_50205,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,78)
    <=> v77894(VarCurr,78) ) ).

tff(addAssignment_50204,axiom,
    ! [VarCurr: state_type] :
      ( v77916(VarCurr)
    <=> v81231(VarCurr) ) ).

tff(addAssignment_50203,axiom,
    ! [VarCurr: state_type] :
      ( v81231(VarCurr)
    <=> v81233(VarCurr) ) ).

tff(writeUnaryOperator_3536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81233(VarCurr)
    <=> v81235(VarCurr) ) ).

tff(addAssignment_50202,axiom,
    ! [VarCurr: state_type] :
      ( v81235(VarCurr)
    <=> v81237(VarCurr) ) ).

tff(addAssignment_50201,axiom,
    ! [VarCurr: state_type] :
      ( v81237(VarCurr)
    <=> v80114(VarCurr) ) ).

tff(addAssignment_50200,axiom,
    ! [VarCurr: state_type] :
      ( v81212(VarCurr)
    <=> v81214(VarCurr) ) ).

tff(addAssignment_50199,axiom,
    ! [VarCurr: state_type] :
      ( v81214(VarCurr)
    <=> v77837(VarCurr,76) ) ).

tff(addAssignment_50198,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,76)
    <=> v77894(VarCurr,76) ) ).

tff(addAssignment_50197,axiom,
    ! [VarCurr: state_type] :
      ( v77918(VarCurr)
    <=> v81217(VarCurr) ) ).

tff(addAssignment_50196,axiom,
    ! [VarCurr: state_type] :
      ( v81217(VarCurr)
    <=> v81219(VarCurr) ) ).

tff(writeUnaryOperator_3535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81219(VarCurr)
    <=> v81221(VarCurr) ) ).

tff(addAssignment_50195,axiom,
    ! [VarCurr: state_type] :
      ( v81221(VarCurr)
    <=> v81223(VarCurr) ) ).

tff(addAssignment_50194,axiom,
    ! [VarCurr: state_type] :
      ( v81223(VarCurr)
    <=> v80064(VarCurr) ) ).

tff(addAssignment_50193,axiom,
    ! [VarCurr: state_type] :
      ( v81175(VarCurr)
    <=> v81177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7445,axiom,
    ! [VarCurr: state_type] :
      ( v81177(VarCurr)
    <=> ( v81179(VarCurr)
      <~> v81193(VarCurr) ) ) ).

tff(addAssignment_50192,axiom,
    ! [VarCurr: state_type] :
      ( v81193(VarCurr)
    <=> v81195(VarCurr) ) ).

tff(addAssignment_50191,axiom,
    ! [VarCurr: state_type] :
      ( v81195(VarCurr)
    <=> v77837(VarCurr,79) ) ).

tff(addAssignment_50190,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,79)
    <=> v77894(VarCurr,79) ) ).

tff(addAssignment_50189,axiom,
    ! [VarCurr: state_type] :
      ( v77915(VarCurr)
    <=> v81198(VarCurr) ) ).

tff(addAssignment_50188,axiom,
    ! [VarCurr: state_type] :
      ( v81198(VarCurr)
    <=> v81200(VarCurr) ) ).

tff(writeUnaryOperator_3534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81200(VarCurr)
    <=> v81202(VarCurr) ) ).

tff(addAssignment_50187,axiom,
    ! [VarCurr: state_type] :
      ( v81202(VarCurr)
    <=> v81204(VarCurr) ) ).

tff(addAssignment_50186,axiom,
    ! [VarCurr: state_type] :
      ( v81204(VarCurr)
    <=> v80190(VarCurr) ) ).

tff(addAssignment_50185,axiom,
    ! [VarCurr: state_type] :
      ( v81179(VarCurr)
    <=> v81181(VarCurr) ) ).

tff(addAssignment_50184,axiom,
    ! [VarCurr: state_type] :
      ( v81181(VarCurr)
    <=> v77837(VarCurr,77) ) ).

tff(addAssignment_50183,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,77)
    <=> v77894(VarCurr,77) ) ).

tff(addAssignment_50182,axiom,
    ! [VarCurr: state_type] :
      ( v77917(VarCurr)
    <=> v81184(VarCurr) ) ).

tff(addAssignment_50181,axiom,
    ! [VarCurr: state_type] :
      ( v81184(VarCurr)
    <=> v81186(VarCurr) ) ).

tff(writeUnaryOperator_3533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v81186(VarCurr)
    <=> v81188(VarCurr) ) ).

tff(addAssignment_50180,axiom,
    ! [VarCurr: state_type] :
      ( v81188(VarCurr)
    <=> v81190(VarCurr) ) ).

tff(addAssignment_50179,axiom,
    ! [VarCurr: state_type] :
      ( v81190(VarCurr)
    <=> v80089(VarCurr) ) ).

tff(addAssignment_50178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81164(VarCurr,B)
      <=> v81166(VarCurr,B) ) ) ).

tff(addAssignment_50177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81166(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50176,axiom,
    ! [VarCurr: state_type] :
      ( v81150(VarCurr)
    <=> v81152(VarCurr) ) ).

tff(addAssignment_50175,axiom,
    ! [VarCurr: state_type] :
      ( v81152(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50174,axiom,
    ! [VarCurr: state_type] :
      ( v79433(VarCurr)
    <=> v81057(VarCurr) ) ).

tff(addAssignment_50173,axiom,
    ! [VarCurr: state_type] :
      ( v81057(VarCurr)
    <=> v81059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7444,axiom,
    ! [VarCurr: state_type] :
      ( v81059(VarCurr)
    <=> ( v81061(VarCurr)
        & v81065(VarCurr) ) ) ).

tff(addAssignment_50172,axiom,
    ! [VarCurr: state_type] :
      ( v81065(VarCurr)
    <=> v81067(VarCurr) ) ).

tff(addAssignment_50171,axiom,
    ! [VarCurr: state_type] :
      ( v81067(VarCurr)
    <=> v81069(VarCurr) ) ).

tff(addAssignment_50170,axiom,
    ! [VarCurr: state_type] :
      ( v81069(VarCurr)
    <=> v81071(VarCurr) ) ).

tff(addAssignment_50169,axiom,
    ! [VarCurr: state_type] :
      ( v81071(VarCurr)
    <=> v81073(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_325,axiom,
    ! [VarCurr: state_type] :
      ( v81073(VarCurr)
    <=> ( ( v81075(VarCurr,3)
        <=> v81079(VarCurr,3) )
        & ( v81075(VarCurr,2)
        <=> v81079(VarCurr,2) )
        & ( v81075(VarCurr,1)
        <=> v81079(VarCurr,1) )
        & ( v81075(VarCurr,0)
        <=> v81079(VarCurr,0) ) ) ) ).

tff(addAssignment_50168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81079(VarCurr,B)
      <=> v81081(VarCurr,B) ) ) ).

tff(addAssignment_50167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81081(VarCurr,B)
      <=> v81083(VarCurr,B) ) ) ).

tff(addAssignment_50166,axiom,
    ! [VarCurr: state_type] :
      ( ( v81083(VarCurr,3)
      <=> v77817(VarCurr,75) )
      & ( v81083(VarCurr,2)
      <=> v77817(VarCurr,74) )
      & ( v81083(VarCurr,1)
      <=> v77817(VarCurr,73) )
      & ( v81083(VarCurr,0)
      <=> v77817(VarCurr,72) ) ) ).

tff(addAssignment_50165,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,75)
      <=> v80037(VarCurr,19) )
      & ( v77817(VarCurr,74)
      <=> v80037(VarCurr,18) )
      & ( v77817(VarCurr,73)
      <=> v80037(VarCurr,17) )
      & ( v77817(VarCurr,72)
      <=> v80037(VarCurr,16) ) ) ).

tff(addAssignment_50164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50160,axiom,
    ! [VarCurr: state_type] :
      ( v80211(VarCurr,3)
    <=> v81086(VarCurr) ) ).

tff(addAssignment_50159,axiom,
    ! [VarCurr: state_type] :
      ( v80211(VarCurr,2)
    <=> v81099(VarCurr) ) ).

tff(addAssignment_50158,axiom,
    ! [VarCurr: state_type] :
      ( v80211(VarCurr,1)
    <=> v81117(VarCurr) ) ).

tff(addAssignment_50157,axiom,
    ! [VarCurr: state_type] :
      ( v80211(VarCurr,0)
    <=> v81130(VarCurr) ) ).

tff(addAssignment_50156,axiom,
    ! [VarCurr: state_type] :
      ( v81130(VarCurr)
    <=> v81132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7443,axiom,
    ! [VarCurr: state_type] :
      ( v81132(VarCurr)
    <=> ( v81134(VarCurr)
      <~> v81138(VarCurr) ) ) ).

tff(addAssignment_50155,axiom,
    ! [VarCurr: state_type] :
      ( v81138(VarCurr)
    <=> v81140(VarCurr) ) ).

tff(addAssignment_50154,axiom,
    ! [VarCurr: state_type] :
      ( v81140(VarCurr)
    <=> v77837(VarCurr,83) ) ).

tff(addAssignment_50153,axiom,
    ! [VarCurr: state_type] :
      ( v81134(VarCurr)
    <=> v81136(VarCurr) ) ).

tff(addAssignment_50152,axiom,
    ! [VarCurr: state_type] :
      ( v81136(VarCurr)
    <=> v77837(VarCurr,82) ) ).

tff(addAssignment_50151,axiom,
    ! [VarCurr: state_type] :
      ( v81117(VarCurr)
    <=> v81119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7442,axiom,
    ! [VarCurr: state_type] :
      ( v81119(VarCurr)
    <=> ( v81121(VarCurr)
      <~> v81125(VarCurr) ) ) ).

tff(addAssignment_50150,axiom,
    ! [VarCurr: state_type] :
      ( v81125(VarCurr)
    <=> v81127(VarCurr) ) ).

tff(addAssignment_50149,axiom,
    ! [VarCurr: state_type] :
      ( v81127(VarCurr)
    <=> v77837(VarCurr,82) ) ).

tff(addAssignment_50148,axiom,
    ! [VarCurr: state_type] :
      ( v81121(VarCurr)
    <=> v81123(VarCurr) ) ).

tff(addAssignment_50147,axiom,
    ! [VarCurr: state_type] :
      ( v81123(VarCurr)
    <=> v77837(VarCurr,80) ) ).

tff(addAssignment_50146,axiom,
    ! [VarCurr: state_type] :
      ( v81099(VarCurr)
    <=> v81101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7441,axiom,
    ! [VarCurr: state_type] :
      ( v81101(VarCurr)
    <=> ( v81115(VarCurr)
      <~> v81111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7440,axiom,
    ! [VarCurr: state_type] :
      ( v81115(VarCurr)
    <=> ( v81103(VarCurr)
      <~> v81107(VarCurr) ) ) ).

tff(addAssignment_50145,axiom,
    ! [VarCurr: state_type] :
      ( v81111(VarCurr)
    <=> v81113(VarCurr) ) ).

tff(addAssignment_50144,axiom,
    ! [VarCurr: state_type] :
      ( v81113(VarCurr)
    <=> v77837(VarCurr,83) ) ).

tff(addAssignment_50143,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,83)
    <=> v77894(VarCurr,83) ) ).

tff(addAssignment_50142,axiom,
    ! [VarCurr: state_type] :
      ( v81107(VarCurr)
    <=> v81109(VarCurr) ) ).

tff(addAssignment_50141,axiom,
    ! [VarCurr: state_type] :
      ( v81109(VarCurr)
    <=> v77837(VarCurr,81) ) ).

tff(addAssignment_50140,axiom,
    ! [VarCurr: state_type] :
      ( v81103(VarCurr)
    <=> v81105(VarCurr) ) ).

tff(addAssignment_50139,axiom,
    ! [VarCurr: state_type] :
      ( v81105(VarCurr)
    <=> v77837(VarCurr,80) ) ).

tff(addAssignment_50138,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,80)
    <=> v77894(VarCurr,80) ) ).

tff(addAssignment_50137,axiom,
    ! [VarCurr: state_type] :
      ( v81086(VarCurr)
    <=> v81088(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7439,axiom,
    ! [VarCurr: state_type] :
      ( v81088(VarCurr)
    <=> ( v81090(VarCurr)
      <~> v81094(VarCurr) ) ) ).

tff(addAssignment_50136,axiom,
    ! [VarCurr: state_type] :
      ( v81094(VarCurr)
    <=> v81096(VarCurr) ) ).

tff(addAssignment_50135,axiom,
    ! [VarCurr: state_type] :
      ( v81096(VarCurr)
    <=> v77837(VarCurr,82) ) ).

tff(addAssignment_50134,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,82)
    <=> v77894(VarCurr,82) ) ).

tff(addAssignment_50133,axiom,
    ! [VarCurr: state_type] :
      ( v81090(VarCurr)
    <=> v81092(VarCurr) ) ).

tff(addAssignment_50132,axiom,
    ! [VarCurr: state_type] :
      ( v81092(VarCurr)
    <=> v77837(VarCurr,81) ) ).

tff(addAssignment_50131,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,81)
    <=> v77894(VarCurr,81) ) ).

tff(addAssignment_50130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81075(VarCurr,B)
      <=> v81077(VarCurr,B) ) ) ).

tff(addAssignment_50129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v81077(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50128,axiom,
    ! [VarCurr: state_type] :
      ( v81061(VarCurr)
    <=> v81063(VarCurr) ) ).

tff(addAssignment_50127,axiom,
    ! [VarCurr: state_type] :
      ( v81063(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50126,axiom,
    ! [VarCurr: state_type] :
      ( v79432(VarCurr)
    <=> v80938(VarCurr) ) ).

tff(addAssignment_50125,axiom,
    ! [VarCurr: state_type] :
      ( v80938(VarCurr)
    <=> v80940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7438,axiom,
    ! [VarCurr: state_type] :
      ( v80940(VarCurr)
    <=> ( v80942(VarCurr)
        & v80946(VarCurr) ) ) ).

tff(addAssignment_50124,axiom,
    ! [VarCurr: state_type] :
      ( v80946(VarCurr)
    <=> v80948(VarCurr) ) ).

tff(addAssignment_50123,axiom,
    ! [VarCurr: state_type] :
      ( v80948(VarCurr)
    <=> v80950(VarCurr) ) ).

tff(addAssignment_50122,axiom,
    ! [VarCurr: state_type] :
      ( v80950(VarCurr)
    <=> v80952(VarCurr) ) ).

tff(addAssignment_50121,axiom,
    ! [VarCurr: state_type] :
      ( v80952(VarCurr)
    <=> v80954(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_324,axiom,
    ! [VarCurr: state_type] :
      ( v80954(VarCurr)
    <=> ( ( v80956(VarCurr,3)
        <=> v80960(VarCurr,3) )
        & ( v80956(VarCurr,2)
        <=> v80960(VarCurr,2) )
        & ( v80956(VarCurr,1)
        <=> v80960(VarCurr,1) )
        & ( v80956(VarCurr,0)
        <=> v80960(VarCurr,0) ) ) ) ).

tff(addAssignment_50120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80960(VarCurr,B)
      <=> v80962(VarCurr,B) ) ) ).

tff(addAssignment_50119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80962(VarCurr,B)
      <=> v80964(VarCurr,B) ) ) ).

tff(addAssignment_50118,axiom,
    ! [VarCurr: state_type] :
      ( ( v80964(VarCurr,3)
      <=> v77817(VarCurr,79) )
      & ( v80964(VarCurr,2)
      <=> v77817(VarCurr,78) )
      & ( v80964(VarCurr,1)
      <=> v77817(VarCurr,77) )
      & ( v80964(VarCurr,0)
      <=> v77817(VarCurr,76) ) ) ).

tff(addAssignment_50117,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,79)
      <=> v80037(VarCurr,23) )
      & ( v77817(VarCurr,78)
      <=> v80037(VarCurr,22) )
      & ( v77817(VarCurr,77)
      <=> v80037(VarCurr,21) )
      & ( v77817(VarCurr,76)
      <=> v80037(VarCurr,20) ) ) ).

tff(addAssignment_50116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50112,axiom,
    ! [VarCurr: state_type] :
      ( v80210(VarCurr,3)
    <=> v80967(VarCurr) ) ).

tff(addAssignment_50111,axiom,
    ! [VarCurr: state_type] :
      ( v80210(VarCurr,2)
    <=> v80985(VarCurr) ) ).

tff(addAssignment_50110,axiom,
    ! [VarCurr: state_type] :
      ( v80210(VarCurr,1)
    <=> v81018(VarCurr) ) ).

tff(addAssignment_50109,axiom,
    ! [VarCurr: state_type] :
      ( v80210(VarCurr,0)
    <=> v81036(VarCurr) ) ).

tff(addAssignment_50108,axiom,
    ! [VarCurr: state_type] :
      ( v81036(VarCurr)
    <=> v81038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7437,axiom,
    ! [VarCurr: state_type] :
      ( v81038(VarCurr)
    <=> ( v81052(VarCurr)
      <~> v81048(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7436,axiom,
    ! [VarCurr: state_type] :
      ( v81052(VarCurr)
    <=> ( v81040(VarCurr)
      <~> v81044(VarCurr) ) ) ).

tff(addAssignment_50107,axiom,
    ! [VarCurr: state_type] :
      ( v81048(VarCurr)
    <=> v81050(VarCurr) ) ).

tff(addAssignment_50106,axiom,
    ! [VarCurr: state_type] :
      ( v81050(VarCurr)
    <=> v77837(VarCurr,87) ) ).

tff(addAssignment_50105,axiom,
    ! [VarCurr: state_type] :
      ( v81044(VarCurr)
    <=> v81046(VarCurr) ) ).

tff(addAssignment_50104,axiom,
    ! [VarCurr: state_type] :
      ( v81046(VarCurr)
    <=> v77837(VarCurr,86) ) ).

tff(addAssignment_50103,axiom,
    ! [VarCurr: state_type] :
      ( v81040(VarCurr)
    <=> v81042(VarCurr) ) ).

tff(addAssignment_50102,axiom,
    ! [VarCurr: state_type] :
      ( v81042(VarCurr)
    <=> v77837(VarCurr,84) ) ).

tff(addAssignment_50101,axiom,
    ! [VarCurr: state_type] :
      ( v81018(VarCurr)
    <=> v81020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7435,axiom,
    ! [VarCurr: state_type] :
      ( v81020(VarCurr)
    <=> ( v81034(VarCurr)
      <~> v81030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7434,axiom,
    ! [VarCurr: state_type] :
      ( v81034(VarCurr)
    <=> ( v81022(VarCurr)
      <~> v81026(VarCurr) ) ) ).

tff(addAssignment_50100,axiom,
    ! [VarCurr: state_type] :
      ( v81030(VarCurr)
    <=> v81032(VarCurr) ) ).

tff(addAssignment_50099,axiom,
    ! [VarCurr: state_type] :
      ( v81032(VarCurr)
    <=> v77837(VarCurr,86) ) ).

tff(addAssignment_50098,axiom,
    ! [VarCurr: state_type] :
      ( v81026(VarCurr)
    <=> v81028(VarCurr) ) ).

tff(addAssignment_50097,axiom,
    ! [VarCurr: state_type] :
      ( v81028(VarCurr)
    <=> v77837(VarCurr,85) ) ).

tff(addAssignment_50096,axiom,
    ! [VarCurr: state_type] :
      ( v81022(VarCurr)
    <=> v81024(VarCurr) ) ).

tff(addAssignment_50095,axiom,
    ! [VarCurr: state_type] :
      ( v81024(VarCurr)
    <=> v77837(VarCurr,84) ) ).

tff(addAssignment_50094,axiom,
    ! [VarCurr: state_type] :
      ( v80985(VarCurr)
    <=> v80987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7433,axiom,
    ! [VarCurr: state_type] :
      ( v80987(VarCurr)
    <=> ( v80989(VarCurr)
      <~> v81013(VarCurr) ) ) ).

tff(addAssignment_50093,axiom,
    ! [VarCurr: state_type] :
      ( v81013(VarCurr)
    <=> v81015(VarCurr) ) ).

tff(addAssignment_50092,axiom,
    ! [VarCurr: state_type] :
      ( v81015(VarCurr)
    <=> v77837(VarCurr,87) ) ).

tff(addAssignment_50091,axiom,
    ! [VarCurr: state_type] :
      ( v80989(VarCurr)
    <=> v80991(VarCurr) ) ).

tff(addAssignment_50090,axiom,
    ! [VarCurr: state_type] :
      ( v80991(VarCurr)
    <=> v80993(VarCurr) ) ).

tff(addAssignment_50089,axiom,
    ! [VarCurr: state_type] :
      ( v80993(VarCurr)
    <=> v80995(VarCurr) ) ).

tff(addAssignment_50088,axiom,
    ! [VarCurr: state_type] :
      ( v80995(VarCurr)
    <=> v80997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7432,axiom,
    ! [VarCurr: state_type] :
      ( v80997(VarCurr)
    <=> ( v81011(VarCurr)
      <~> v81007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7431,axiom,
    ! [VarCurr: state_type] :
      ( v81011(VarCurr)
    <=> ( v80999(VarCurr)
      <~> v81003(VarCurr) ) ) ).

tff(addAssignment_50087,axiom,
    ! [VarCurr: state_type] :
      ( v81007(VarCurr)
    <=> v81009(VarCurr) ) ).

tff(addAssignment_50086,axiom,
    ! [VarCurr: state_type] :
      ( v81009(VarCurr)
    <=> v77837(VarCurr,86) ) ).

tff(addAssignment_50085,axiom,
    ! [VarCurr: state_type] :
      ( v81003(VarCurr)
    <=> v81005(VarCurr) ) ).

tff(addAssignment_50084,axiom,
    ! [VarCurr: state_type] :
      ( v81005(VarCurr)
    <=> v77837(VarCurr,85) ) ).

tff(addAssignment_50083,axiom,
    ! [VarCurr: state_type] :
      ( v80999(VarCurr)
    <=> v81001(VarCurr) ) ).

tff(addAssignment_50082,axiom,
    ! [VarCurr: state_type] :
      ( v81001(VarCurr)
    <=> v77837(VarCurr,84) ) ).

tff(addAssignment_50081,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,84)
    <=> v77894(VarCurr,84) ) ).

tff(addAssignment_50080,axiom,
    ! [VarCurr: state_type] :
      ( v80967(VarCurr)
    <=> v80969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7430,axiom,
    ! [VarCurr: state_type] :
      ( v80969(VarCurr)
    <=> ( v80983(VarCurr)
      <~> v80979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7429,axiom,
    ! [VarCurr: state_type] :
      ( v80983(VarCurr)
    <=> ( v80971(VarCurr)
      <~> v80975(VarCurr) ) ) ).

tff(addAssignment_50079,axiom,
    ! [VarCurr: state_type] :
      ( v80979(VarCurr)
    <=> v80981(VarCurr) ) ).

tff(addAssignment_50078,axiom,
    ! [VarCurr: state_type] :
      ( v80981(VarCurr)
    <=> v77837(VarCurr,87) ) ).

tff(addAssignment_50077,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,87)
    <=> v77894(VarCurr,87) ) ).

tff(addAssignment_50076,axiom,
    ! [VarCurr: state_type] :
      ( v80975(VarCurr)
    <=> v80977(VarCurr) ) ).

tff(addAssignment_50075,axiom,
    ! [VarCurr: state_type] :
      ( v80977(VarCurr)
    <=> v77837(VarCurr,86) ) ).

tff(addAssignment_50074,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,86)
    <=> v77894(VarCurr,86) ) ).

tff(addAssignment_50073,axiom,
    ! [VarCurr: state_type] :
      ( v80971(VarCurr)
    <=> v80973(VarCurr) ) ).

tff(addAssignment_50072,axiom,
    ! [VarCurr: state_type] :
      ( v80973(VarCurr)
    <=> v77837(VarCurr,85) ) ).

tff(addAssignment_50071,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,85)
    <=> v77894(VarCurr,85) ) ).

tff(addAssignment_50070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80956(VarCurr,B)
      <=> v80958(VarCurr,B) ) ) ).

tff(addAssignment_50069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80958(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50068,axiom,
    ! [VarCurr: state_type] :
      ( v80942(VarCurr)
    <=> v80944(VarCurr) ) ).

tff(addAssignment_50067,axiom,
    ! [VarCurr: state_type] :
      ( v80944(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50066,axiom,
    ! [VarCurr: state_type] :
      ( v79431(VarCurr)
    <=> v80859(VarCurr) ) ).

tff(addAssignment_50065,axiom,
    ! [VarCurr: state_type] :
      ( v80859(VarCurr)
    <=> v80861(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7428,axiom,
    ! [VarCurr: state_type] :
      ( v80861(VarCurr)
    <=> ( v80863(VarCurr)
        & v80867(VarCurr) ) ) ).

tff(addAssignment_50064,axiom,
    ! [VarCurr: state_type] :
      ( v80867(VarCurr)
    <=> v80869(VarCurr) ) ).

tff(addAssignment_50063,axiom,
    ! [VarCurr: state_type] :
      ( v80869(VarCurr)
    <=> v80871(VarCurr) ) ).

tff(addAssignment_50062,axiom,
    ! [VarCurr: state_type] :
      ( v80871(VarCurr)
    <=> v80873(VarCurr) ) ).

tff(addAssignment_50061,axiom,
    ! [VarCurr: state_type] :
      ( v80873(VarCurr)
    <=> v80875(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_323,axiom,
    ! [VarCurr: state_type] :
      ( v80875(VarCurr)
    <=> ( ( v80877(VarCurr,3)
        <=> v80881(VarCurr,3) )
        & ( v80877(VarCurr,2)
        <=> v80881(VarCurr,2) )
        & ( v80877(VarCurr,1)
        <=> v80881(VarCurr,1) )
        & ( v80877(VarCurr,0)
        <=> v80881(VarCurr,0) ) ) ) ).

tff(addAssignment_50060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80881(VarCurr,B)
      <=> v80883(VarCurr,B) ) ) ).

tff(addAssignment_50059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80883(VarCurr,B)
      <=> v80885(VarCurr,B) ) ) ).

tff(addAssignment_50058,axiom,
    ! [VarCurr: state_type] :
      ( ( v80885(VarCurr,3)
      <=> v77817(VarCurr,83) )
      & ( v80885(VarCurr,2)
      <=> v77817(VarCurr,82) )
      & ( v80885(VarCurr,1)
      <=> v77817(VarCurr,81) )
      & ( v80885(VarCurr,0)
      <=> v77817(VarCurr,80) ) ) ).

tff(addAssignment_50057,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,83)
      <=> v80037(VarCurr,27) )
      & ( v77817(VarCurr,82)
      <=> v80037(VarCurr,26) )
      & ( v77817(VarCurr,81)
      <=> v80037(VarCurr,25) )
      & ( v77817(VarCurr,80)
      <=> v80037(VarCurr,24) ) ) ).

tff(addAssignment_50056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50052,axiom,
    ! [VarCurr: state_type] :
      ( v80209(VarCurr,3)
    <=> v80888(VarCurr) ) ).

tff(addAssignment_50051,axiom,
    ! [VarCurr: state_type] :
      ( v80209(VarCurr,2)
    <=> v80901(VarCurr) ) ).

tff(addAssignment_50050,axiom,
    ! [VarCurr: state_type] :
      ( v80209(VarCurr,1)
    <=> v80914(VarCurr) ) ).

tff(addAssignment_50049,axiom,
    ! [VarCurr: state_type] :
      ( v80209(VarCurr,0)
    <=> v80927(VarCurr) ) ).

tff(addAssignment_50048,axiom,
    ! [VarCurr: state_type] :
      ( v80927(VarCurr)
    <=> v80929(VarCurr) ) ).

tff(addAssignment_50047,axiom,
    ! [VarCurr: state_type] :
      ( v80929(VarCurr)
    <=> v80931(VarCurr) ) ).

tff(addAssignment_50046,axiom,
    ! [VarCurr: state_type] :
      ( v80931(VarCurr)
    <=> v80933(VarCurr) ) ).

tff(addAssignment_50045,axiom,
    ! [VarCurr: state_type] :
      ( v80933(VarCurr)
    <=> v77837(VarCurr,89) ) ).

tff(addAssignment_50044,axiom,
    ! [VarCurr: state_type] :
      ( v80914(VarCurr)
    <=> v80916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7427,axiom,
    ! [VarCurr: state_type] :
      ( v80916(VarCurr)
    <=> ( v80918(VarCurr)
      <~> v80922(VarCurr) ) ) ).

tff(addAssignment_50043,axiom,
    ! [VarCurr: state_type] :
      ( v80922(VarCurr)
    <=> v80924(VarCurr) ) ).

tff(addAssignment_50042,axiom,
    ! [VarCurr: state_type] :
      ( v80924(VarCurr)
    <=> v77837(VarCurr,90) ) ).

tff(addAssignment_50041,axiom,
    ! [VarCurr: state_type] :
      ( v80918(VarCurr)
    <=> v80920(VarCurr) ) ).

tff(addAssignment_50040,axiom,
    ! [VarCurr: state_type] :
      ( v80920(VarCurr)
    <=> v77837(VarCurr,89) ) ).

tff(addAssignment_50039,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,89)
    <=> v77894(VarCurr,89) ) ).

tff(addAssignment_50038,axiom,
    ! [VarCurr: state_type] :
      ( v80901(VarCurr)
    <=> v80903(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7426,axiom,
    ! [VarCurr: state_type] :
      ( v80903(VarCurr)
    <=> ( v80905(VarCurr)
      <~> v80909(VarCurr) ) ) ).

tff(addAssignment_50037,axiom,
    ! [VarCurr: state_type] :
      ( v80909(VarCurr)
    <=> v80911(VarCurr) ) ).

tff(addAssignment_50036,axiom,
    ! [VarCurr: state_type] :
      ( v80911(VarCurr)
    <=> v77837(VarCurr,91) ) ).

tff(addAssignment_50035,axiom,
    ! [VarCurr: state_type] :
      ( v80905(VarCurr)
    <=> v80907(VarCurr) ) ).

tff(addAssignment_50034,axiom,
    ! [VarCurr: state_type] :
      ( v80907(VarCurr)
    <=> v77837(VarCurr,90) ) ).

tff(addAssignment_50033,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,90)
    <=> v77894(VarCurr,90) ) ).

tff(addAssignment_50032,axiom,
    ! [VarCurr: state_type] :
      ( v80888(VarCurr)
    <=> v80890(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7425,axiom,
    ! [VarCurr: state_type] :
      ( v80890(VarCurr)
    <=> ( v80892(VarCurr)
      <~> v80896(VarCurr) ) ) ).

tff(addAssignment_50031,axiom,
    ! [VarCurr: state_type] :
      ( v80896(VarCurr)
    <=> v80898(VarCurr) ) ).

tff(addAssignment_50030,axiom,
    ! [VarCurr: state_type] :
      ( v80898(VarCurr)
    <=> v77837(VarCurr,91) ) ).

tff(addAssignment_50029,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,91)
    <=> v77894(VarCurr,91) ) ).

tff(addAssignment_50028,axiom,
    ! [VarCurr: state_type] :
      ( v80892(VarCurr)
    <=> v80894(VarCurr) ) ).

tff(addAssignment_50027,axiom,
    ! [VarCurr: state_type] :
      ( v80894(VarCurr)
    <=> v77837(VarCurr,88) ) ).

tff(addAssignment_50026,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,88)
    <=> v77894(VarCurr,88) ) ).

tff(addAssignment_50025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80877(VarCurr,B)
      <=> v80879(VarCurr,B) ) ) ).

tff(addAssignment_50024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80879(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_50023,axiom,
    ! [VarCurr: state_type] :
      ( v80863(VarCurr)
    <=> v80865(VarCurr) ) ).

tff(addAssignment_50022,axiom,
    ! [VarCurr: state_type] :
      ( v80865(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_50021,axiom,
    ! [VarCurr: state_type] :
      ( v79430(VarCurr)
    <=> v80750(VarCurr) ) ).

tff(addAssignment_50020,axiom,
    ! [VarCurr: state_type] :
      ( v80750(VarCurr)
    <=> v80752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7424,axiom,
    ! [VarCurr: state_type] :
      ( v80752(VarCurr)
    <=> ( v80754(VarCurr)
        & v80758(VarCurr) ) ) ).

tff(addAssignment_50019,axiom,
    ! [VarCurr: state_type] :
      ( v80758(VarCurr)
    <=> v80760(VarCurr) ) ).

tff(addAssignment_50018,axiom,
    ! [VarCurr: state_type] :
      ( v80760(VarCurr)
    <=> v80762(VarCurr) ) ).

tff(addAssignment_50017,axiom,
    ! [VarCurr: state_type] :
      ( v80762(VarCurr)
    <=> v80764(VarCurr) ) ).

tff(addAssignment_50016,axiom,
    ! [VarCurr: state_type] :
      ( v80764(VarCurr)
    <=> v80766(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_322,axiom,
    ! [VarCurr: state_type] :
      ( v80766(VarCurr)
    <=> ( ( v80768(VarCurr,3)
        <=> v80772(VarCurr,3) )
        & ( v80768(VarCurr,2)
        <=> v80772(VarCurr,2) )
        & ( v80768(VarCurr,1)
        <=> v80772(VarCurr,1) )
        & ( v80768(VarCurr,0)
        <=> v80772(VarCurr,0) ) ) ) ).

tff(addAssignment_50015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80772(VarCurr,B)
      <=> v80774(VarCurr,B) ) ) ).

tff(addAssignment_50014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80774(VarCurr,B)
      <=> v80776(VarCurr,B) ) ) ).

tff(addAssignment_50013,axiom,
    ! [VarCurr: state_type] :
      ( ( v80776(VarCurr,3)
      <=> v77817(VarCurr,87) )
      & ( v80776(VarCurr,2)
      <=> v77817(VarCurr,86) )
      & ( v80776(VarCurr,1)
      <=> v77817(VarCurr,85) )
      & ( v80776(VarCurr,0)
      <=> v77817(VarCurr,84) ) ) ).

tff(addAssignment_50012,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,87)
      <=> v80037(VarCurr,31) )
      & ( v77817(VarCurr,86)
      <=> v80037(VarCurr,30) )
      & ( v77817(VarCurr,85)
      <=> v80037(VarCurr,29) )
      & ( v77817(VarCurr,84)
      <=> v80037(VarCurr,28) ) ) ).

tff(addAssignment_50011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_50010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_50009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_50008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_50007,axiom,
    ! [VarCurr: state_type] :
      ( v80208(VarCurr,3)
    <=> v80779(VarCurr) ) ).

tff(addAssignment_50006,axiom,
    ! [VarCurr: state_type] :
      ( v80208(VarCurr,2)
    <=> v80797(VarCurr) ) ).

tff(addAssignment_50005,axiom,
    ! [VarCurr: state_type] :
      ( v80208(VarCurr,1)
    <=> v80815(VarCurr) ) ).

tff(addAssignment_50004,axiom,
    ! [VarCurr: state_type] :
      ( v80208(VarCurr,0)
    <=> v80833(VarCurr) ) ).

tff(addAssignment_50003,axiom,
    ! [VarCurr: state_type] :
      ( v80833(VarCurr)
    <=> v80835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7423,axiom,
    ! [VarCurr: state_type] :
      ( v80835(VarCurr)
    <=> ( v80837(VarCurr)
      <~> v80841(VarCurr) ) ) ).

tff(addAssignment_50002,axiom,
    ! [VarCurr: state_type] :
      ( v80841(VarCurr)
    <=> v80843(VarCurr) ) ).

tff(addAssignment_50001,axiom,
    ! [VarCurr: state_type] :
      ( v80843(VarCurr)
    <=> v77837(VarCurr,93) ) ).

tff(addAssignment_50000,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,93)
    <=> v77894(VarCurr,93) ) ).

tff(addAssignment_49999,axiom,
    ! [VarCurr: state_type] :
      ( v77911(VarCurr)
    <=> v80846(VarCurr) ) ).

tff(addAssignment_49998,axiom,
    ! [VarCurr: state_type] :
      ( v80846(VarCurr)
    <=> v80848(VarCurr) ) ).

tff(writeUnaryOperator_3532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80848(VarCurr)
    <=> v80850(VarCurr) ) ).

tff(addAssignment_49997,axiom,
    ! [VarCurr: state_type] :
      ( v80850(VarCurr)
    <=> v80852(VarCurr) ) ).

tff(addAssignment_49996,axiom,
    ! [VarCurr: state_type] :
      ( v80852(VarCurr)
    <=> v80089(VarCurr) ) ).

tff(addAssignment_49995,axiom,
    ! [VarCurr: state_type] :
      ( v80837(VarCurr)
    <=> v80839(VarCurr) ) ).

tff(addAssignment_49994,axiom,
    ! [VarCurr: state_type] :
      ( v80839(VarCurr)
    <=> v77837(VarCurr,92) ) ).

tff(addAssignment_49993,axiom,
    ! [VarCurr: state_type] :
      ( v80815(VarCurr)
    <=> v80817(VarCurr) ) ).

tff(addAssignment_49992,axiom,
    ! [VarCurr: state_type] :
      ( v80817(VarCurr)
    <=> v80819(VarCurr) ) ).

tff(addAssignment_49991,axiom,
    ! [VarCurr: state_type] :
      ( v80819(VarCurr)
    <=> v80821(VarCurr) ) ).

tff(addAssignment_49990,axiom,
    ! [VarCurr: state_type] :
      ( v80821(VarCurr)
    <=> v77837(VarCurr,94) ) ).

tff(addAssignment_49989,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,94)
    <=> v77894(VarCurr,94) ) ).

tff(addAssignment_49988,axiom,
    ! [VarCurr: state_type] :
      ( v77910(VarCurr)
    <=> v80824(VarCurr) ) ).

tff(addAssignment_49987,axiom,
    ! [VarCurr: state_type] :
      ( v80824(VarCurr)
    <=> v80826(VarCurr) ) ).

tff(writeUnaryOperator_3531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80826(VarCurr)
    <=> v80828(VarCurr) ) ).

tff(addAssignment_49986,axiom,
    ! [VarCurr: state_type] :
      ( v80828(VarCurr)
    <=> v80830(VarCurr) ) ).

tff(addAssignment_49985,axiom,
    ! [VarCurr: state_type] :
      ( v80830(VarCurr)
    <=> v80114(VarCurr) ) ).

tff(addAssignment_49984,axiom,
    ! [VarCurr: state_type] :
      ( v80797(VarCurr)
    <=> v80799(VarCurr) ) ).

tff(addAssignment_49983,axiom,
    ! [VarCurr: state_type] :
      ( v80799(VarCurr)
    <=> v80801(VarCurr) ) ).

tff(addAssignment_49982,axiom,
    ! [VarCurr: state_type] :
      ( v80801(VarCurr)
    <=> v80803(VarCurr) ) ).

tff(addAssignment_49981,axiom,
    ! [VarCurr: state_type] :
      ( v80803(VarCurr)
    <=> v77837(VarCurr,95) ) ).

tff(addAssignment_49980,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,95)
    <=> v77894(VarCurr,95) ) ).

tff(addAssignment_49979,axiom,
    ! [VarCurr: state_type] :
      ( v77909(VarCurr)
    <=> v80806(VarCurr) ) ).

tff(addAssignment_49978,axiom,
    ! [VarCurr: state_type] :
      ( v80806(VarCurr)
    <=> v80808(VarCurr) ) ).

tff(writeUnaryOperator_3530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80808(VarCurr)
    <=> v80810(VarCurr) ) ).

tff(addAssignment_49977,axiom,
    ! [VarCurr: state_type] :
      ( v80810(VarCurr)
    <=> v80812(VarCurr) ) ).

tff(addAssignment_49976,axiom,
    ! [VarCurr: state_type] :
      ( v80812(VarCurr)
    <=> v80190(VarCurr) ) ).

tff(addAssignment_49975,axiom,
    ! [VarCurr: state_type] :
      ( v80779(VarCurr)
    <=> v80781(VarCurr) ) ).

tff(addAssignment_49974,axiom,
    ! [VarCurr: state_type] :
      ( v80781(VarCurr)
    <=> v80783(VarCurr) ) ).

tff(addAssignment_49973,axiom,
    ! [VarCurr: state_type] :
      ( v80783(VarCurr)
    <=> v80785(VarCurr) ) ).

tff(addAssignment_49972,axiom,
    ! [VarCurr: state_type] :
      ( v80785(VarCurr)
    <=> v77837(VarCurr,92) ) ).

tff(addAssignment_49971,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,92)
    <=> v77894(VarCurr,92) ) ).

tff(addAssignment_49970,axiom,
    ! [VarCurr: state_type] :
      ( v77912(VarCurr)
    <=> v80788(VarCurr) ) ).

tff(addAssignment_49969,axiom,
    ! [VarCurr: state_type] :
      ( v80788(VarCurr)
    <=> v80790(VarCurr) ) ).

tff(writeUnaryOperator_3529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80790(VarCurr)
    <=> v80792(VarCurr) ) ).

tff(addAssignment_49968,axiom,
    ! [VarCurr: state_type] :
      ( v80792(VarCurr)
    <=> v80794(VarCurr) ) ).

tff(addAssignment_49967,axiom,
    ! [VarCurr: state_type] :
      ( v80794(VarCurr)
    <=> v80064(VarCurr) ) ).

tff(addAssignment_49966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80768(VarCurr,B)
      <=> v80770(VarCurr,B) ) ) ).

tff(addAssignment_49965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80770(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49964,axiom,
    ! [VarCurr: state_type] :
      ( v80754(VarCurr)
    <=> v80756(VarCurr) ) ).

tff(addAssignment_49963,axiom,
    ! [VarCurr: state_type] :
      ( v80756(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49962,axiom,
    ! [VarCurr: state_type] :
      ( v79429(VarCurr)
    <=> v80636(VarCurr) ) ).

tff(addAssignment_49961,axiom,
    ! [VarCurr: state_type] :
      ( v80636(VarCurr)
    <=> v80638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7422,axiom,
    ! [VarCurr: state_type] :
      ( v80638(VarCurr)
    <=> ( v80640(VarCurr)
        & v80644(VarCurr) ) ) ).

tff(addAssignment_49960,axiom,
    ! [VarCurr: state_type] :
      ( v80644(VarCurr)
    <=> v80646(VarCurr) ) ).

tff(addAssignment_49959,axiom,
    ! [VarCurr: state_type] :
      ( v80646(VarCurr)
    <=> v80648(VarCurr) ) ).

tff(addAssignment_49958,axiom,
    ! [VarCurr: state_type] :
      ( v80648(VarCurr)
    <=> v80650(VarCurr) ) ).

tff(addAssignment_49957,axiom,
    ! [VarCurr: state_type] :
      ( v80650(VarCurr)
    <=> v80652(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_321,axiom,
    ! [VarCurr: state_type] :
      ( v80652(VarCurr)
    <=> ( ( v80654(VarCurr,3)
        <=> v80658(VarCurr,3) )
        & ( v80654(VarCurr,2)
        <=> v80658(VarCurr,2) )
        & ( v80654(VarCurr,1)
        <=> v80658(VarCurr,1) )
        & ( v80654(VarCurr,0)
        <=> v80658(VarCurr,0) ) ) ) ).

tff(addAssignment_49956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80658(VarCurr,B)
      <=> v80660(VarCurr,B) ) ) ).

tff(addAssignment_49955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80660(VarCurr,B)
      <=> v80662(VarCurr,B) ) ) ).

tff(addAssignment_49954,axiom,
    ! [VarCurr: state_type] :
      ( ( v80662(VarCurr,3)
      <=> v77817(VarCurr,91) )
      & ( v80662(VarCurr,2)
      <=> v77817(VarCurr,90) )
      & ( v80662(VarCurr,1)
      <=> v77817(VarCurr,89) )
      & ( v80662(VarCurr,0)
      <=> v77817(VarCurr,88) ) ) ).

tff(addAssignment_49953,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,91)
      <=> v80037(VarCurr,35) )
      & ( v77817(VarCurr,90)
      <=> v80037(VarCurr,34) )
      & ( v77817(VarCurr,89)
      <=> v80037(VarCurr,33) )
      & ( v77817(VarCurr,88)
      <=> v80037(VarCurr,32) ) ) ).

tff(addAssignment_49952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49948,axiom,
    ! [VarCurr: state_type] :
      ( v80207(VarCurr,3)
    <=> v80665(VarCurr) ) ).

tff(addAssignment_49947,axiom,
    ! [VarCurr: state_type] :
      ( v80207(VarCurr,2)
    <=> v80683(VarCurr) ) ).

tff(addAssignment_49946,axiom,
    ! [VarCurr: state_type] :
      ( v80207(VarCurr,1)
    <=> v80701(VarCurr) ) ).

tff(addAssignment_49945,axiom,
    ! [VarCurr: state_type] :
      ( v80207(VarCurr,0)
    <=> v80734(VarCurr) ) ).

tff(addAssignment_49944,axiom,
    ! [VarCurr: state_type] :
      ( v80734(VarCurr)
    <=> v80736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7421,axiom,
    ! [VarCurr: state_type] :
      ( v80736(VarCurr)
    <=> ( v80738(VarCurr)
      <~> v80742(VarCurr) ) ) ).

tff(addAssignment_49943,axiom,
    ! [VarCurr: state_type] :
      ( v80742(VarCurr)
    <=> v80744(VarCurr) ) ).

tff(addAssignment_49942,axiom,
    ! [VarCurr: state_type] :
      ( v80744(VarCurr)
    <=> v77837(VarCurr,99) ) ).

tff(addAssignment_49941,axiom,
    ! [VarCurr: state_type] :
      ( v80738(VarCurr)
    <=> v80740(VarCurr) ) ).

tff(addAssignment_49940,axiom,
    ! [VarCurr: state_type] :
      ( v80740(VarCurr)
    <=> v77837(VarCurr,97) ) ).

tff(addAssignment_49939,axiom,
    ! [VarCurr: state_type] :
      ( v80701(VarCurr)
    <=> v80703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7420,axiom,
    ! [VarCurr: state_type] :
      ( v80703(VarCurr)
    <=> ( v80705(VarCurr)
      <~> v80729(VarCurr) ) ) ).

tff(addAssignment_49938,axiom,
    ! [VarCurr: state_type] :
      ( v80729(VarCurr)
    <=> v80731(VarCurr) ) ).

tff(addAssignment_49937,axiom,
    ! [VarCurr: state_type] :
      ( v80731(VarCurr)
    <=> v77837(VarCurr,99) ) ).

tff(addAssignment_49936,axiom,
    ! [VarCurr: state_type] :
      ( v80705(VarCurr)
    <=> v80707(VarCurr) ) ).

tff(addAssignment_49935,axiom,
    ! [VarCurr: state_type] :
      ( v80707(VarCurr)
    <=> v80709(VarCurr) ) ).

tff(addAssignment_49934,axiom,
    ! [VarCurr: state_type] :
      ( v80709(VarCurr)
    <=> v80711(VarCurr) ) ).

tff(addAssignment_49933,axiom,
    ! [VarCurr: state_type] :
      ( v80711(VarCurr)
    <=> v80713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7419,axiom,
    ! [VarCurr: state_type] :
      ( v80713(VarCurr)
    <=> ( v80727(VarCurr)
      <~> v80723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7418,axiom,
    ! [VarCurr: state_type] :
      ( v80727(VarCurr)
    <=> ( v80715(VarCurr)
      <~> v80719(VarCurr) ) ) ).

tff(addAssignment_49932,axiom,
    ! [VarCurr: state_type] :
      ( v80723(VarCurr)
    <=> v80725(VarCurr) ) ).

tff(addAssignment_49931,axiom,
    ! [VarCurr: state_type] :
      ( v80725(VarCurr)
    <=> v77837(VarCurr,98) ) ).

tff(addAssignment_49930,axiom,
    ! [VarCurr: state_type] :
      ( v80719(VarCurr)
    <=> v80721(VarCurr) ) ).

tff(addAssignment_49929,axiom,
    ! [VarCurr: state_type] :
      ( v80721(VarCurr)
    <=> v77837(VarCurr,97) ) ).

tff(addAssignment_49928,axiom,
    ! [VarCurr: state_type] :
      ( v80715(VarCurr)
    <=> v80717(VarCurr) ) ).

tff(addAssignment_49927,axiom,
    ! [VarCurr: state_type] :
      ( v80717(VarCurr)
    <=> v77837(VarCurr,96) ) ).

tff(addAssignment_49926,axiom,
    ! [VarCurr: state_type] :
      ( v80683(VarCurr)
    <=> v80685(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7417,axiom,
    ! [VarCurr: state_type] :
      ( v80685(VarCurr)
    <=> ( v80699(VarCurr)
      <~> v80695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7416,axiom,
    ! [VarCurr: state_type] :
      ( v80699(VarCurr)
    <=> ( v80687(VarCurr)
      <~> v80691(VarCurr) ) ) ).

tff(addAssignment_49925,axiom,
    ! [VarCurr: state_type] :
      ( v80695(VarCurr)
    <=> v80697(VarCurr) ) ).

tff(addAssignment_49924,axiom,
    ! [VarCurr: state_type] :
      ( v80697(VarCurr)
    <=> v77837(VarCurr,97) ) ).

tff(addAssignment_49923,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,97)
    <=> v77894(VarCurr,97) ) ).

tff(addAssignment_49922,axiom,
    ! [VarCurr: state_type] :
      ( v80691(VarCurr)
    <=> v80693(VarCurr) ) ).

tff(addAssignment_49921,axiom,
    ! [VarCurr: state_type] :
      ( v80693(VarCurr)
    <=> v77837(VarCurr,98) ) ).

tff(addAssignment_49920,axiom,
    ! [VarCurr: state_type] :
      ( v80687(VarCurr)
    <=> v80689(VarCurr) ) ).

tff(addAssignment_49919,axiom,
    ! [VarCurr: state_type] :
      ( v80689(VarCurr)
    <=> v77837(VarCurr,99) ) ).

tff(addAssignment_49918,axiom,
    ! [VarCurr: state_type] :
      ( v80665(VarCurr)
    <=> v80667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7415,axiom,
    ! [VarCurr: state_type] :
      ( v80667(VarCurr)
    <=> ( v80681(VarCurr)
      <~> v80677(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7414,axiom,
    ! [VarCurr: state_type] :
      ( v80681(VarCurr)
    <=> ( v80669(VarCurr)
      <~> v80673(VarCurr) ) ) ).

tff(addAssignment_49917,axiom,
    ! [VarCurr: state_type] :
      ( v80677(VarCurr)
    <=> v80679(VarCurr) ) ).

tff(addAssignment_49916,axiom,
    ! [VarCurr: state_type] :
      ( v80679(VarCurr)
    <=> v77837(VarCurr,98) ) ).

tff(addAssignment_49915,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,98)
    <=> v77894(VarCurr,98) ) ).

tff(addAssignment_49914,axiom,
    ! [VarCurr: state_type] :
      ( v80673(VarCurr)
    <=> v80675(VarCurr) ) ).

tff(addAssignment_49913,axiom,
    ! [VarCurr: state_type] :
      ( v80675(VarCurr)
    <=> v77837(VarCurr,99) ) ).

tff(addAssignment_49912,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,99)
    <=> v77894(VarCurr,99) ) ).

tff(addAssignment_49911,axiom,
    ! [VarCurr: state_type] :
      ( v80669(VarCurr)
    <=> v80671(VarCurr) ) ).

tff(addAssignment_49910,axiom,
    ! [VarCurr: state_type] :
      ( v80671(VarCurr)
    <=> v77837(VarCurr,96) ) ).

tff(addAssignment_49909,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,96)
    <=> v77894(VarCurr,96) ) ).

tff(addAssignment_49908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80654(VarCurr,B)
      <=> v80656(VarCurr,B) ) ) ).

tff(addAssignment_49907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80656(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49906,axiom,
    ! [VarCurr: state_type] :
      ( v80640(VarCurr)
    <=> v80642(VarCurr) ) ).

tff(addAssignment_49905,axiom,
    ! [VarCurr: state_type] :
      ( v80642(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49904,axiom,
    ! [VarCurr: state_type] :
      ( v79428(VarCurr)
    <=> v80542(VarCurr) ) ).

tff(addAssignment_49903,axiom,
    ! [VarCurr: state_type] :
      ( v80542(VarCurr)
    <=> v80544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7413,axiom,
    ! [VarCurr: state_type] :
      ( v80544(VarCurr)
    <=> ( v80546(VarCurr)
        & v80550(VarCurr) ) ) ).

tff(addAssignment_49902,axiom,
    ! [VarCurr: state_type] :
      ( v80550(VarCurr)
    <=> v80552(VarCurr) ) ).

tff(addAssignment_49901,axiom,
    ! [VarCurr: state_type] :
      ( v80552(VarCurr)
    <=> v80554(VarCurr) ) ).

tff(addAssignment_49900,axiom,
    ! [VarCurr: state_type] :
      ( v80554(VarCurr)
    <=> v80556(VarCurr) ) ).

tff(addAssignment_49899,axiom,
    ! [VarCurr: state_type] :
      ( v80556(VarCurr)
    <=> v80558(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_320,axiom,
    ! [VarCurr: state_type] :
      ( v80558(VarCurr)
    <=> ( ( v80560(VarCurr,3)
        <=> v80564(VarCurr,3) )
        & ( v80560(VarCurr,2)
        <=> v80564(VarCurr,2) )
        & ( v80560(VarCurr,1)
        <=> v80564(VarCurr,1) )
        & ( v80560(VarCurr,0)
        <=> v80564(VarCurr,0) ) ) ) ).

tff(addAssignment_49898,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80564(VarCurr,B)
      <=> v80566(VarCurr,B) ) ) ).

tff(addAssignment_49897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80566(VarCurr,B)
      <=> v80568(VarCurr,B) ) ) ).

tff(addAssignment_49896,axiom,
    ! [VarCurr: state_type] :
      ( ( v80568(VarCurr,3)
      <=> v77817(VarCurr,95) )
      & ( v80568(VarCurr,2)
      <=> v77817(VarCurr,94) )
      & ( v80568(VarCurr,1)
      <=> v77817(VarCurr,93) )
      & ( v80568(VarCurr,0)
      <=> v77817(VarCurr,92) ) ) ).

tff(addAssignment_49895,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,95)
      <=> v80037(VarCurr,39) )
      & ( v77817(VarCurr,94)
      <=> v80037(VarCurr,38) )
      & ( v77817(VarCurr,93)
      <=> v80037(VarCurr,37) )
      & ( v77817(VarCurr,92)
      <=> v80037(VarCurr,36) ) ) ).

tff(addAssignment_49894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49890,axiom,
    ! [VarCurr: state_type] :
      ( v80206(VarCurr,3)
    <=> v80571(VarCurr) ) ).

tff(addAssignment_49889,axiom,
    ! [VarCurr: state_type] :
      ( v80206(VarCurr,2)
    <=> v80584(VarCurr) ) ).

tff(addAssignment_49888,axiom,
    ! [VarCurr: state_type] :
      ( v80206(VarCurr,1)
    <=> v80597(VarCurr) ) ).

tff(addAssignment_49887,axiom,
    ! [VarCurr: state_type] :
      ( v80206(VarCurr,0)
    <=> v80615(VarCurr) ) ).

tff(addAssignment_49886,axiom,
    ! [VarCurr: state_type] :
      ( v80615(VarCurr)
    <=> v80617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7412,axiom,
    ! [VarCurr: state_type] :
      ( v80617(VarCurr)
    <=> ( v80631(VarCurr)
      <~> v80627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7411,axiom,
    ! [VarCurr: state_type] :
      ( v80631(VarCurr)
    <=> ( v80619(VarCurr)
      <~> v80623(VarCurr) ) ) ).

tff(addAssignment_49885,axiom,
    ! [VarCurr: state_type] :
      ( v80627(VarCurr)
    <=> v80629(VarCurr) ) ).

tff(addAssignment_49884,axiom,
    ! [VarCurr: state_type] :
      ( v80629(VarCurr)
    <=> v77837(VarCurr,103) ) ).

tff(addAssignment_49883,axiom,
    ! [VarCurr: state_type] :
      ( v80623(VarCurr)
    <=> v80625(VarCurr) ) ).

tff(addAssignment_49882,axiom,
    ! [VarCurr: state_type] :
      ( v80625(VarCurr)
    <=> v77837(VarCurr,100) ) ).

tff(addAssignment_49881,axiom,
    ! [VarCurr: state_type] :
      ( v80619(VarCurr)
    <=> v80621(VarCurr) ) ).

tff(addAssignment_49880,axiom,
    ! [VarCurr: state_type] :
      ( v80621(VarCurr)
    <=> v77837(VarCurr,101) ) ).

tff(addAssignment_49879,axiom,
    ! [VarCurr: state_type] :
      ( v80597(VarCurr)
    <=> v80599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7410,axiom,
    ! [VarCurr: state_type] :
      ( v80599(VarCurr)
    <=> ( v80613(VarCurr)
      <~> v80609(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7409,axiom,
    ! [VarCurr: state_type] :
      ( v80613(VarCurr)
    <=> ( v80601(VarCurr)
      <~> v80605(VarCurr) ) ) ).

tff(addAssignment_49878,axiom,
    ! [VarCurr: state_type] :
      ( v80609(VarCurr)
    <=> v80611(VarCurr) ) ).

tff(addAssignment_49877,axiom,
    ! [VarCurr: state_type] :
      ( v80611(VarCurr)
    <=> v77837(VarCurr,103) ) ).

tff(addAssignment_49876,axiom,
    ! [VarCurr: state_type] :
      ( v80605(VarCurr)
    <=> v80607(VarCurr) ) ).

tff(addAssignment_49875,axiom,
    ! [VarCurr: state_type] :
      ( v80607(VarCurr)
    <=> v77837(VarCurr,102) ) ).

tff(addAssignment_49874,axiom,
    ! [VarCurr: state_type] :
      ( v80601(VarCurr)
    <=> v80603(VarCurr) ) ).

tff(addAssignment_49873,axiom,
    ! [VarCurr: state_type] :
      ( v80603(VarCurr)
    <=> v77837(VarCurr,100) ) ).

tff(addAssignment_49872,axiom,
    ! [VarCurr: state_type] :
      ( v80584(VarCurr)
    <=> v80586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7408,axiom,
    ! [VarCurr: state_type] :
      ( v80586(VarCurr)
    <=> ( v80588(VarCurr)
      <~> v80592(VarCurr) ) ) ).

tff(addAssignment_49871,axiom,
    ! [VarCurr: state_type] :
      ( v80592(VarCurr)
    <=> v80594(VarCurr) ) ).

tff(addAssignment_49870,axiom,
    ! [VarCurr: state_type] :
      ( v80594(VarCurr)
    <=> v77837(VarCurr,103) ) ).

tff(addAssignment_49869,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,103)
    <=> v77894(VarCurr,103) ) ).

tff(addAssignment_49868,axiom,
    ! [VarCurr: state_type] :
      ( v80588(VarCurr)
    <=> v80590(VarCurr) ) ).

tff(addAssignment_49867,axiom,
    ! [VarCurr: state_type] :
      ( v80590(VarCurr)
    <=> v77837(VarCurr,101) ) ).

tff(addAssignment_49866,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,101)
    <=> v77894(VarCurr,101) ) ).

tff(addAssignment_49865,axiom,
    ! [VarCurr: state_type] :
      ( v80571(VarCurr)
    <=> v80573(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7407,axiom,
    ! [VarCurr: state_type] :
      ( v80573(VarCurr)
    <=> ( v80575(VarCurr)
      <~> v80579(VarCurr) ) ) ).

tff(addAssignment_49864,axiom,
    ! [VarCurr: state_type] :
      ( v80579(VarCurr)
    <=> v80581(VarCurr) ) ).

tff(addAssignment_49863,axiom,
    ! [VarCurr: state_type] :
      ( v80581(VarCurr)
    <=> v77837(VarCurr,102) ) ).

tff(addAssignment_49862,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,102)
    <=> v77894(VarCurr,102) ) ).

tff(addAssignment_49861,axiom,
    ! [VarCurr: state_type] :
      ( v80575(VarCurr)
    <=> v80577(VarCurr) ) ).

tff(addAssignment_49860,axiom,
    ! [VarCurr: state_type] :
      ( v80577(VarCurr)
    <=> v77837(VarCurr,100) ) ).

tff(addAssignment_49859,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,100)
    <=> v77894(VarCurr,100) ) ).

tff(addAssignment_49858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80560(VarCurr,B)
      <=> v80562(VarCurr,B) ) ) ).

tff(addAssignment_49857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80562(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49856,axiom,
    ! [VarCurr: state_type] :
      ( v80546(VarCurr)
    <=> v80548(VarCurr) ) ).

tff(addAssignment_49855,axiom,
    ! [VarCurr: state_type] :
      ( v80548(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49854,axiom,
    ! [VarCurr: state_type] :
      ( v79427(VarCurr)
    <=> v80453(VarCurr) ) ).

tff(addAssignment_49853,axiom,
    ! [VarCurr: state_type] :
      ( v80453(VarCurr)
    <=> v80455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7406,axiom,
    ! [VarCurr: state_type] :
      ( v80455(VarCurr)
    <=> ( v80457(VarCurr)
        & v80461(VarCurr) ) ) ).

tff(addAssignment_49852,axiom,
    ! [VarCurr: state_type] :
      ( v80461(VarCurr)
    <=> v80463(VarCurr) ) ).

tff(addAssignment_49851,axiom,
    ! [VarCurr: state_type] :
      ( v80463(VarCurr)
    <=> v80465(VarCurr) ) ).

tff(addAssignment_49850,axiom,
    ! [VarCurr: state_type] :
      ( v80465(VarCurr)
    <=> v80467(VarCurr) ) ).

tff(addAssignment_49849,axiom,
    ! [VarCurr: state_type] :
      ( v80467(VarCurr)
    <=> v80469(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_319,axiom,
    ! [VarCurr: state_type] :
      ( v80469(VarCurr)
    <=> ( ( v80471(VarCurr,3)
        <=> v80475(VarCurr,3) )
        & ( v80471(VarCurr,2)
        <=> v80475(VarCurr,2) )
        & ( v80471(VarCurr,1)
        <=> v80475(VarCurr,1) )
        & ( v80471(VarCurr,0)
        <=> v80475(VarCurr,0) ) ) ) ).

tff(addAssignment_49848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80475(VarCurr,B)
      <=> v80477(VarCurr,B) ) ) ).

tff(addAssignment_49847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80477(VarCurr,B)
      <=> v80479(VarCurr,B) ) ) ).

tff(addAssignment_49846,axiom,
    ! [VarCurr: state_type] :
      ( ( v80479(VarCurr,3)
      <=> v77817(VarCurr,99) )
      & ( v80479(VarCurr,2)
      <=> v77817(VarCurr,98) )
      & ( v80479(VarCurr,1)
      <=> v77817(VarCurr,97) )
      & ( v80479(VarCurr,0)
      <=> v77817(VarCurr,96) ) ) ).

tff(addAssignment_49845,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,99)
      <=> v80037(VarCurr,43) )
      & ( v77817(VarCurr,98)
      <=> v80037(VarCurr,42) )
      & ( v77817(VarCurr,97)
      <=> v80037(VarCurr,41) )
      & ( v77817(VarCurr,96)
      <=> v80037(VarCurr,40) ) ) ).

tff(addAssignment_49844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49840,axiom,
    ! [VarCurr: state_type] :
      ( v80205(VarCurr,3)
    <=> v80482(VarCurr) ) ).

tff(addAssignment_49839,axiom,
    ! [VarCurr: state_type] :
      ( v80205(VarCurr,2)
    <=> v80500(VarCurr) ) ).

tff(addAssignment_49838,axiom,
    ! [VarCurr: state_type] :
      ( v80205(VarCurr,1)
    <=> v80513(VarCurr) ) ).

tff(addAssignment_49837,axiom,
    ! [VarCurr: state_type] :
      ( v80205(VarCurr,0)
    <=> v80526(VarCurr) ) ).

tff(addAssignment_49836,axiom,
    ! [VarCurr: state_type] :
      ( v80526(VarCurr)
    <=> v80528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7405,axiom,
    ! [VarCurr: state_type] :
      ( v80528(VarCurr)
    <=> ( v80530(VarCurr)
      <~> v80534(VarCurr) ) ) ).

tff(addAssignment_49835,axiom,
    ! [VarCurr: state_type] :
      ( v80534(VarCurr)
    <=> v80536(VarCurr) ) ).

tff(addAssignment_49834,axiom,
    ! [VarCurr: state_type] :
      ( v80536(VarCurr)
    <=> v77837(VarCurr,106) ) ).

tff(addAssignment_49833,axiom,
    ! [VarCurr: state_type] :
      ( v80530(VarCurr)
    <=> v80532(VarCurr) ) ).

tff(addAssignment_49832,axiom,
    ! [VarCurr: state_type] :
      ( v80532(VarCurr)
    <=> v77837(VarCurr,105) ) ).

tff(addAssignment_49831,axiom,
    ! [VarCurr: state_type] :
      ( v80513(VarCurr)
    <=> v80515(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7404,axiom,
    ! [VarCurr: state_type] :
      ( v80515(VarCurr)
    <=> ( v80517(VarCurr)
      <~> v80521(VarCurr) ) ) ).

tff(addAssignment_49830,axiom,
    ! [VarCurr: state_type] :
      ( v80521(VarCurr)
    <=> v80523(VarCurr) ) ).

tff(addAssignment_49829,axiom,
    ! [VarCurr: state_type] :
      ( v80523(VarCurr)
    <=> v77837(VarCurr,107) ) ).

tff(addAssignment_49828,axiom,
    ! [VarCurr: state_type] :
      ( v80517(VarCurr)
    <=> v80519(VarCurr) ) ).

tff(addAssignment_49827,axiom,
    ! [VarCurr: state_type] :
      ( v80519(VarCurr)
    <=> v77837(VarCurr,105) ) ).

tff(addAssignment_49826,axiom,
    ! [VarCurr: state_type] :
      ( v80500(VarCurr)
    <=> v80502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7403,axiom,
    ! [VarCurr: state_type] :
      ( v80502(VarCurr)
    <=> ( v80504(VarCurr)
      <~> v80508(VarCurr) ) ) ).

tff(addAssignment_49825,axiom,
    ! [VarCurr: state_type] :
      ( v80508(VarCurr)
    <=> v80510(VarCurr) ) ).

tff(addAssignment_49824,axiom,
    ! [VarCurr: state_type] :
      ( v80510(VarCurr)
    <=> v77837(VarCurr,106) ) ).

tff(addAssignment_49823,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,106)
    <=> v77894(VarCurr,106) ) ).

tff(addAssignment_49822,axiom,
    ! [VarCurr: state_type] :
      ( v80504(VarCurr)
    <=> v80506(VarCurr) ) ).

tff(addAssignment_49821,axiom,
    ! [VarCurr: state_type] :
      ( v80506(VarCurr)
    <=> v77837(VarCurr,104) ) ).

tff(addAssignment_49820,axiom,
    ! [VarCurr: state_type] :
      ( v80482(VarCurr)
    <=> v80484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7402,axiom,
    ! [VarCurr: state_type] :
      ( v80484(VarCurr)
    <=> ( v80498(VarCurr)
      <~> v80494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7401,axiom,
    ! [VarCurr: state_type] :
      ( v80498(VarCurr)
    <=> ( v80486(VarCurr)
      <~> v80490(VarCurr) ) ) ).

tff(addAssignment_49819,axiom,
    ! [VarCurr: state_type] :
      ( v80494(VarCurr)
    <=> v80496(VarCurr) ) ).

tff(addAssignment_49818,axiom,
    ! [VarCurr: state_type] :
      ( v80496(VarCurr)
    <=> v77837(VarCurr,107) ) ).

tff(addAssignment_49817,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,107)
    <=> v77894(VarCurr,107) ) ).

tff(addAssignment_49816,axiom,
    ! [VarCurr: state_type] :
      ( v80490(VarCurr)
    <=> v80492(VarCurr) ) ).

tff(addAssignment_49815,axiom,
    ! [VarCurr: state_type] :
      ( v80492(VarCurr)
    <=> v77837(VarCurr,105) ) ).

tff(addAssignment_49814,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,105)
    <=> v77894(VarCurr,105) ) ).

tff(addAssignment_49813,axiom,
    ! [VarCurr: state_type] :
      ( v80486(VarCurr)
    <=> v80488(VarCurr) ) ).

tff(addAssignment_49812,axiom,
    ! [VarCurr: state_type] :
      ( v80488(VarCurr)
    <=> v77837(VarCurr,104) ) ).

tff(addAssignment_49811,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,104)
    <=> v77894(VarCurr,104) ) ).

tff(addAssignment_49810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80471(VarCurr,B)
      <=> v80473(VarCurr,B) ) ) ).

tff(addAssignment_49809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80473(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49808,axiom,
    ! [VarCurr: state_type] :
      ( v80457(VarCurr)
    <=> v80459(VarCurr) ) ).

tff(addAssignment_49807,axiom,
    ! [VarCurr: state_type] :
      ( v80459(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49806,axiom,
    ! [VarCurr: state_type] :
      ( v79426(VarCurr)
    <=> v80334(VarCurr) ) ).

tff(addAssignment_49805,axiom,
    ! [VarCurr: state_type] :
      ( v80334(VarCurr)
    <=> v80336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7400,axiom,
    ! [VarCurr: state_type] :
      ( v80336(VarCurr)
    <=> ( v80338(VarCurr)
        & v80342(VarCurr) ) ) ).

tff(addAssignment_49804,axiom,
    ! [VarCurr: state_type] :
      ( v80342(VarCurr)
    <=> v80344(VarCurr) ) ).

tff(addAssignment_49803,axiom,
    ! [VarCurr: state_type] :
      ( v80344(VarCurr)
    <=> v80346(VarCurr) ) ).

tff(addAssignment_49802,axiom,
    ! [VarCurr: state_type] :
      ( v80346(VarCurr)
    <=> v80348(VarCurr) ) ).

tff(addAssignment_49801,axiom,
    ! [VarCurr: state_type] :
      ( v80348(VarCurr)
    <=> v80350(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_318,axiom,
    ! [VarCurr: state_type] :
      ( v80350(VarCurr)
    <=> ( ( v80352(VarCurr,3)
        <=> v80356(VarCurr,3) )
        & ( v80352(VarCurr,2)
        <=> v80356(VarCurr,2) )
        & ( v80352(VarCurr,1)
        <=> v80356(VarCurr,1) )
        & ( v80352(VarCurr,0)
        <=> v80356(VarCurr,0) ) ) ) ).

tff(addAssignment_49800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80356(VarCurr,B)
      <=> v80358(VarCurr,B) ) ) ).

tff(addAssignment_49799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80358(VarCurr,B)
      <=> v80360(VarCurr,B) ) ) ).

tff(addAssignment_49798,axiom,
    ! [VarCurr: state_type] :
      ( ( v80360(VarCurr,3)
      <=> v77817(VarCurr,103) )
      & ( v80360(VarCurr,2)
      <=> v77817(VarCurr,102) )
      & ( v80360(VarCurr,1)
      <=> v77817(VarCurr,101) )
      & ( v80360(VarCurr,0)
      <=> v77817(VarCurr,100) ) ) ).

tff(addAssignment_49797,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,103)
      <=> v80037(VarCurr,47) )
      & ( v77817(VarCurr,102)
      <=> v80037(VarCurr,46) )
      & ( v77817(VarCurr,101)
      <=> v80037(VarCurr,45) )
      & ( v77817(VarCurr,100)
      <=> v80037(VarCurr,44) ) ) ).

tff(addAssignment_49796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49792,axiom,
    ! [VarCurr: state_type] :
      ( v80204(VarCurr,3)
    <=> v80363(VarCurr) ) ).

tff(addAssignment_49791,axiom,
    ! [VarCurr: state_type] :
      ( v80204(VarCurr,2)
    <=> v80396(VarCurr) ) ).

tff(addAssignment_49790,axiom,
    ! [VarCurr: state_type] :
      ( v80204(VarCurr,1)
    <=> v80404(VarCurr) ) ).

tff(addAssignment_49789,axiom,
    ! [VarCurr: state_type] :
      ( v80204(VarCurr,0)
    <=> v80422(VarCurr) ) ).

tff(addAssignment_49788,axiom,
    ! [VarCurr: state_type] :
      ( v80422(VarCurr)
    <=> v80424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7399,axiom,
    ! [VarCurr: state_type] :
      ( v80424(VarCurr)
    <=> ( v80448(VarCurr)
      <~> v80434(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7398,axiom,
    ! [VarCurr: state_type] :
      ( v80448(VarCurr)
    <=> ( v80426(VarCurr)
      <~> v80430(VarCurr) ) ) ).

tff(addAssignment_49787,axiom,
    ! [VarCurr: state_type] :
      ( v80434(VarCurr)
    <=> v80436(VarCurr) ) ).

tff(addAssignment_49786,axiom,
    ! [VarCurr: state_type] :
      ( v80436(VarCurr)
    <=> v77837(VarCurr,110) ) ).

tff(addAssignment_49785,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,110)
    <=> v77894(VarCurr,110) ) ).

tff(addAssignment_49784,axiom,
    ! [VarCurr: state_type] :
      ( v77904(VarCurr)
    <=> v80439(VarCurr) ) ).

tff(addAssignment_49783,axiom,
    ! [VarCurr: state_type] :
      ( v80439(VarCurr)
    <=> v80441(VarCurr) ) ).

tff(writeUnaryOperator_3528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80441(VarCurr)
    <=> v80443(VarCurr) ) ).

tff(addAssignment_49782,axiom,
    ! [VarCurr: state_type] :
      ( v80443(VarCurr)
    <=> v80445(VarCurr) ) ).

tff(addAssignment_49781,axiom,
    ! [VarCurr: state_type] :
      ( v80445(VarCurr)
    <=> v80114(VarCurr) ) ).

tff(addAssignment_49780,axiom,
    ! [VarCurr: state_type] :
      ( v80430(VarCurr)
    <=> v80432(VarCurr) ) ).

tff(addAssignment_49779,axiom,
    ! [VarCurr: state_type] :
      ( v80432(VarCurr)
    <=> v77837(VarCurr,109) ) ).

tff(addAssignment_49778,axiom,
    ! [VarCurr: state_type] :
      ( v80426(VarCurr)
    <=> v80428(VarCurr) ) ).

tff(addAssignment_49777,axiom,
    ! [VarCurr: state_type] :
      ( v80428(VarCurr)
    <=> v77837(VarCurr,108) ) ).

tff(addAssignment_49776,axiom,
    ! [VarCurr: state_type] :
      ( v80404(VarCurr)
    <=> v80406(VarCurr) ) ).

tff(addAssignment_49775,axiom,
    ! [VarCurr: state_type] :
      ( v80406(VarCurr)
    <=> v80408(VarCurr) ) ).

tff(addAssignment_49774,axiom,
    ! [VarCurr: state_type] :
      ( v80408(VarCurr)
    <=> v80410(VarCurr) ) ).

tff(addAssignment_49773,axiom,
    ! [VarCurr: state_type] :
      ( v80410(VarCurr)
    <=> v77837(VarCurr,111) ) ).

tff(addAssignment_49772,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,111)
    <=> v77894(VarCurr,111) ) ).

tff(addAssignment_49771,axiom,
    ! [VarCurr: state_type] :
      ( v77903(VarCurr)
    <=> v80413(VarCurr) ) ).

tff(addAssignment_49770,axiom,
    ! [VarCurr: state_type] :
      ( v80413(VarCurr)
    <=> v80415(VarCurr) ) ).

tff(writeUnaryOperator_3527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80415(VarCurr)
    <=> v80417(VarCurr) ) ).

tff(addAssignment_49769,axiom,
    ! [VarCurr: state_type] :
      ( v80417(VarCurr)
    <=> v80419(VarCurr) ) ).

tff(addAssignment_49768,axiom,
    ! [VarCurr: state_type] :
      ( v80419(VarCurr)
    <=> v80190(VarCurr) ) ).

tff(addAssignment_49767,axiom,
    ! [VarCurr: state_type] :
      ( v80396(VarCurr)
    <=> v80398(VarCurr) ) ).

tff(addAssignment_49766,axiom,
    ! [VarCurr: state_type] :
      ( v80398(VarCurr)
    <=> v80400(VarCurr) ) ).

tff(addAssignment_49765,axiom,
    ! [VarCurr: state_type] :
      ( v80400(VarCurr)
    <=> v80402(VarCurr) ) ).

tff(addAssignment_49764,axiom,
    ! [VarCurr: state_type] :
      ( v80402(VarCurr)
    <=> v77837(VarCurr,108) ) ).

tff(addAssignment_49763,axiom,
    ! [VarCurr: state_type] :
      ( v80363(VarCurr)
    <=> v80365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7397,axiom,
    ! [VarCurr: state_type] :
      ( v80365(VarCurr)
    <=> ( v80367(VarCurr)
      <~> v80381(VarCurr) ) ) ).

tff(addAssignment_49762,axiom,
    ! [VarCurr: state_type] :
      ( v80381(VarCurr)
    <=> v80383(VarCurr) ) ).

tff(addAssignment_49761,axiom,
    ! [VarCurr: state_type] :
      ( v80383(VarCurr)
    <=> v77837(VarCurr,109) ) ).

tff(addAssignment_49760,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,109)
    <=> v77894(VarCurr,109) ) ).

tff(addAssignment_49759,axiom,
    ! [VarCurr: state_type] :
      ( v77905(VarCurr)
    <=> v80386(VarCurr) ) ).

tff(addAssignment_49758,axiom,
    ! [VarCurr: state_type] :
      ( v80386(VarCurr)
    <=> v80388(VarCurr) ) ).

tff(writeUnaryOperator_3526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80388(VarCurr)
    <=> v80390(VarCurr) ) ).

tff(addAssignment_49757,axiom,
    ! [VarCurr: state_type] :
      ( v80390(VarCurr)
    <=> v80392(VarCurr) ) ).

tff(addAssignment_49756,axiom,
    ! [VarCurr: state_type] :
      ( v80392(VarCurr)
    <=> v80089(VarCurr) ) ).

tff(addAssignment_49755,axiom,
    ! [VarCurr: state_type] :
      ( v80367(VarCurr)
    <=> v80369(VarCurr) ) ).

tff(addAssignment_49754,axiom,
    ! [VarCurr: state_type] :
      ( v80369(VarCurr)
    <=> v77837(VarCurr,108) ) ).

tff(addAssignment_49753,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,108)
    <=> v77894(VarCurr,108) ) ).

tff(addAssignment_49752,axiom,
    ! [VarCurr: state_type] :
      ( v77906(VarCurr)
    <=> v80372(VarCurr) ) ).

tff(addAssignment_49751,axiom,
    ! [VarCurr: state_type] :
      ( v80372(VarCurr)
    <=> v80374(VarCurr) ) ).

tff(writeUnaryOperator_3525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80374(VarCurr)
    <=> v80376(VarCurr) ) ).

tff(addAssignment_49750,axiom,
    ! [VarCurr: state_type] :
      ( v80376(VarCurr)
    <=> v80378(VarCurr) ) ).

tff(addAssignment_49749,axiom,
    ! [VarCurr: state_type] :
      ( v80378(VarCurr)
    <=> v80064(VarCurr) ) ).

tff(addAssignment_49748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80352(VarCurr,B)
      <=> v80354(VarCurr,B) ) ) ).

tff(addAssignment_49747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80354(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49746,axiom,
    ! [VarCurr: state_type] :
      ( v80338(VarCurr)
    <=> v80340(VarCurr) ) ).

tff(addAssignment_49745,axiom,
    ! [VarCurr: state_type] :
      ( v80340(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49744,axiom,
    ! [VarCurr: state_type] :
      ( v79425(VarCurr)
    <=> v80220(VarCurr) ) ).

tff(addAssignment_49743,axiom,
    ! [VarCurr: state_type] :
      ( v80220(VarCurr)
    <=> v80222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7396,axiom,
    ! [VarCurr: state_type] :
      ( v80222(VarCurr)
    <=> ( v80224(VarCurr)
        & v80228(VarCurr) ) ) ).

tff(addAssignment_49742,axiom,
    ! [VarCurr: state_type] :
      ( v80228(VarCurr)
    <=> v80230(VarCurr) ) ).

tff(addAssignment_49741,axiom,
    ! [VarCurr: state_type] :
      ( v80230(VarCurr)
    <=> v80232(VarCurr) ) ).

tff(addAssignment_49740,axiom,
    ! [VarCurr: state_type] :
      ( v80232(VarCurr)
    <=> v80234(VarCurr) ) ).

tff(addAssignment_49739,axiom,
    ! [VarCurr: state_type] :
      ( v80234(VarCurr)
    <=> v80236(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_317,axiom,
    ! [VarCurr: state_type] :
      ( v80236(VarCurr)
    <=> ( ( v80238(VarCurr,3)
        <=> v80242(VarCurr,3) )
        & ( v80238(VarCurr,2)
        <=> v80242(VarCurr,2) )
        & ( v80238(VarCurr,1)
        <=> v80242(VarCurr,1) )
        & ( v80238(VarCurr,0)
        <=> v80242(VarCurr,0) ) ) ) ).

tff(addAssignment_49738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80242(VarCurr,B)
      <=> v80244(VarCurr,B) ) ) ).

tff(addAssignment_49737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80244(VarCurr,B)
      <=> v80246(VarCurr,B) ) ) ).

tff(addAssignment_49736,axiom,
    ! [VarCurr: state_type] :
      ( ( v80246(VarCurr,3)
      <=> v77817(VarCurr,107) )
      & ( v80246(VarCurr,2)
      <=> v77817(VarCurr,106) )
      & ( v80246(VarCurr,1)
      <=> v77817(VarCurr,105) )
      & ( v80246(VarCurr,0)
      <=> v77817(VarCurr,104) ) ) ).

tff(addAssignment_49735,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,107)
      <=> v80037(VarCurr,51) )
      & ( v77817(VarCurr,106)
      <=> v80037(VarCurr,50) )
      & ( v77817(VarCurr,105)
      <=> v80037(VarCurr,49) )
      & ( v77817(VarCurr,104)
      <=> v80037(VarCurr,48) ) ) ).

tff(addAssignment_49734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49730,axiom,
    ! [VarCurr: state_type] :
      ( v80203(VarCurr,3)
    <=> v80249(VarCurr) ) ).

tff(addAssignment_49729,axiom,
    ! [VarCurr: state_type] :
      ( v80203(VarCurr,2)
    <=> v80282(VarCurr) ) ).

tff(addAssignment_49728,axiom,
    ! [VarCurr: state_type] :
      ( v80203(VarCurr,1)
    <=> v80300(VarCurr) ) ).

tff(addAssignment_49727,axiom,
    ! [VarCurr: state_type] :
      ( v80203(VarCurr,0)
    <=> v80313(VarCurr) ) ).

tff(addAssignment_49726,axiom,
    ! [VarCurr: state_type] :
      ( v80313(VarCurr)
    <=> v80315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7395,axiom,
    ! [VarCurr: state_type] :
      ( v80315(VarCurr)
    <=> ( v80329(VarCurr)
      <~> v80325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7394,axiom,
    ! [VarCurr: state_type] :
      ( v80329(VarCurr)
    <=> ( v80317(VarCurr)
      <~> v80321(VarCurr) ) ) ).

tff(addAssignment_49725,axiom,
    ! [VarCurr: state_type] :
      ( v80325(VarCurr)
    <=> v80327(VarCurr) ) ).

tff(addAssignment_49724,axiom,
    ! [VarCurr: state_type] :
      ( v80327(VarCurr)
    <=> v77837(VarCurr,115) ) ).

tff(addAssignment_49723,axiom,
    ! [VarCurr: state_type] :
      ( v80321(VarCurr)
    <=> v80323(VarCurr) ) ).

tff(addAssignment_49722,axiom,
    ! [VarCurr: state_type] :
      ( v80323(VarCurr)
    <=> v77837(VarCurr,114) ) ).

tff(addAssignment_49721,axiom,
    ! [VarCurr: state_type] :
      ( v80317(VarCurr)
    <=> v80319(VarCurr) ) ).

tff(addAssignment_49720,axiom,
    ! [VarCurr: state_type] :
      ( v80319(VarCurr)
    <=> v77837(VarCurr,113) ) ).

tff(addAssignment_49719,axiom,
    ! [VarCurr: state_type] :
      ( v80300(VarCurr)
    <=> v80302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7393,axiom,
    ! [VarCurr: state_type] :
      ( v80302(VarCurr)
    <=> ( v80304(VarCurr)
      <~> v80308(VarCurr) ) ) ).

tff(addAssignment_49718,axiom,
    ! [VarCurr: state_type] :
      ( v80308(VarCurr)
    <=> v80310(VarCurr) ) ).

tff(addAssignment_49717,axiom,
    ! [VarCurr: state_type] :
      ( v80310(VarCurr)
    <=> v77837(VarCurr,112) ) ).

tff(addAssignment_49716,axiom,
    ! [VarCurr: state_type] :
      ( v80304(VarCurr)
    <=> v80306(VarCurr) ) ).

tff(addAssignment_49715,axiom,
    ! [VarCurr: state_type] :
      ( v80306(VarCurr)
    <=> v77837(VarCurr,113) ) ).

tff(addAssignment_49714,axiom,
    ! [VarCurr: state_type] :
      ( v80282(VarCurr)
    <=> v80284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7392,axiom,
    ! [VarCurr: state_type] :
      ( v80284(VarCurr)
    <=> ( v80298(VarCurr)
      <~> v80294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7391,axiom,
    ! [VarCurr: state_type] :
      ( v80298(VarCurr)
    <=> ( v80286(VarCurr)
      <~> v80290(VarCurr) ) ) ).

tff(addAssignment_49713,axiom,
    ! [VarCurr: state_type] :
      ( v80294(VarCurr)
    <=> v80296(VarCurr) ) ).

tff(addAssignment_49712,axiom,
    ! [VarCurr: state_type] :
      ( v80296(VarCurr)
    <=> v77837(VarCurr,114) ) ).

tff(addAssignment_49711,axiom,
    ! [VarCurr: state_type] :
      ( v80290(VarCurr)
    <=> v80292(VarCurr) ) ).

tff(addAssignment_49710,axiom,
    ! [VarCurr: state_type] :
      ( v80292(VarCurr)
    <=> v77837(VarCurr,113) ) ).

tff(addAssignment_49709,axiom,
    ! [VarCurr: state_type] :
      ( v80286(VarCurr)
    <=> v80288(VarCurr) ) ).

tff(addAssignment_49708,axiom,
    ! [VarCurr: state_type] :
      ( v80288(VarCurr)
    <=> v77837(VarCurr,112) ) ).

tff(addAssignment_49707,axiom,
    ! [VarCurr: state_type] :
      ( v80249(VarCurr)
    <=> v80251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7390,axiom,
    ! [VarCurr: state_type] :
      ( v80251(VarCurr)
    <=> ( v80253(VarCurr)
      <~> v80277(VarCurr) ) ) ).

tff(addAssignment_49706,axiom,
    ! [VarCurr: state_type] :
      ( v80277(VarCurr)
    <=> v80279(VarCurr) ) ).

tff(addAssignment_49705,axiom,
    ! [VarCurr: state_type] :
      ( v80279(VarCurr)
    <=> v77837(VarCurr,115) ) ).

tff(addAssignment_49704,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,115)
    <=> v77894(VarCurr,115) ) ).

tff(addAssignment_49703,axiom,
    ! [VarCurr: state_type] :
      ( v80253(VarCurr)
    <=> v80255(VarCurr) ) ).

tff(addAssignment_49702,axiom,
    ! [VarCurr: state_type] :
      ( v80255(VarCurr)
    <=> v80257(VarCurr) ) ).

tff(addAssignment_49701,axiom,
    ! [VarCurr: state_type] :
      ( v80257(VarCurr)
    <=> v80259(VarCurr) ) ).

tff(addAssignment_49700,axiom,
    ! [VarCurr: state_type] :
      ( v80259(VarCurr)
    <=> v80261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7389,axiom,
    ! [VarCurr: state_type] :
      ( v80261(VarCurr)
    <=> ( v80275(VarCurr)
      <~> v80271(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7388,axiom,
    ! [VarCurr: state_type] :
      ( v80275(VarCurr)
    <=> ( v80263(VarCurr)
      <~> v80267(VarCurr) ) ) ).

tff(addAssignment_49699,axiom,
    ! [VarCurr: state_type] :
      ( v80271(VarCurr)
    <=> v80273(VarCurr) ) ).

tff(addAssignment_49698,axiom,
    ! [VarCurr: state_type] :
      ( v80273(VarCurr)
    <=> v77837(VarCurr,114) ) ).

tff(addAssignment_49697,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,114)
    <=> v77894(VarCurr,114) ) ).

tff(addAssignment_49696,axiom,
    ! [VarCurr: state_type] :
      ( v80267(VarCurr)
    <=> v80269(VarCurr) ) ).

tff(addAssignment_49695,axiom,
    ! [VarCurr: state_type] :
      ( v80269(VarCurr)
    <=> v77837(VarCurr,113) ) ).

tff(addAssignment_49694,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,113)
    <=> v77894(VarCurr,113) ) ).

tff(addAssignment_49693,axiom,
    ! [VarCurr: state_type] :
      ( v80263(VarCurr)
    <=> v80265(VarCurr) ) ).

tff(addAssignment_49692,axiom,
    ! [VarCurr: state_type] :
      ( v80265(VarCurr)
    <=> v77837(VarCurr,112) ) ).

tff(addAssignment_49691,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,112)
    <=> v77894(VarCurr,112) ) ).

tff(addAssignment_49690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80238(VarCurr,B)
      <=> v80240(VarCurr,B) ) ) ).

tff(addAssignment_49689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80240(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49688,axiom,
    ! [VarCurr: state_type] :
      ( v80224(VarCurr)
    <=> v80226(VarCurr) ) ).

tff(addAssignment_49687,axiom,
    ! [VarCurr: state_type] :
      ( v80226(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49686,axiom,
    ! [VarCurr: state_type] :
      ( v79424(VarCurr)
    <=> v79994(VarCurr) ) ).

tff(addAssignment_49685,axiom,
    ! [VarCurr: state_type] :
      ( v79994(VarCurr)
    <=> v79996(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7387,axiom,
    ! [VarCurr: state_type] :
      ( v79996(VarCurr)
    <=> ( v79998(VarCurr)
        & v80017(VarCurr) ) ) ).

tff(addAssignment_49684,axiom,
    ! [VarCurr: state_type] :
      ( v80017(VarCurr)
    <=> v80019(VarCurr) ) ).

tff(addAssignment_49683,axiom,
    ! [VarCurr: state_type] :
      ( v80019(VarCurr)
    <=> v80021(VarCurr) ) ).

tff(addAssignment_49682,axiom,
    ! [VarCurr: state_type] :
      ( v80021(VarCurr)
    <=> v80023(VarCurr) ) ).

tff(addAssignment_49681,axiom,
    ! [VarCurr: state_type] :
      ( v80023(VarCurr)
    <=> v80025(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_316,axiom,
    ! [VarCurr: state_type] :
      ( v80025(VarCurr)
    <=> ( ( v80027(VarCurr,3)
        <=> v80031(VarCurr,3) )
        & ( v80027(VarCurr,2)
        <=> v80031(VarCurr,2) )
        & ( v80027(VarCurr,1)
        <=> v80031(VarCurr,1) )
        & ( v80027(VarCurr,0)
        <=> v80031(VarCurr,0) ) ) ) ).

tff(addAssignment_49680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80031(VarCurr,B)
      <=> v80033(VarCurr,B) ) ) ).

tff(addAssignment_49679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80033(VarCurr,B)
      <=> v80035(VarCurr,B) ) ) ).

tff(addAssignment_49678,axiom,
    ! [VarCurr: state_type] :
      ( ( v80035(VarCurr,3)
      <=> v77817(VarCurr,111) )
      & ( v80035(VarCurr,2)
      <=> v77817(VarCurr,110) )
      & ( v80035(VarCurr,1)
      <=> v77817(VarCurr,109) )
      & ( v80035(VarCurr,0)
      <=> v77817(VarCurr,108) ) ) ).

tff(addAssignment_49677,axiom,
    ! [VarCurr: state_type] :
      ( ( v77817(VarCurr,111)
      <=> v80037(VarCurr,55) )
      & ( v77817(VarCurr,110)
      <=> v80037(VarCurr,54) )
      & ( v77817(VarCurr,109)
      <=> v80037(VarCurr,53) )
      & ( v77817(VarCurr,108)
      <=> v80037(VarCurr,52) ) ) ).

tff(addAssignment_49676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v80037(VarCurr,B)
      <=> v80039(VarCurr,B) ) ) ).

tff(addAssignment_49675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v80039(VarCurr,B)
      <=> v80041(VarCurr,B) ) ) ).

tff(addAssignment_49674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v80041(VarCurr,B)
      <=> v80043(VarCurr,B) ) ) ).

tff(addAssignment_49673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v80043(VarCurr,B)
      <=> v80202(VarCurr,B) ) ) ).

tff(addAssignment_49672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80202(VarCurr,B)
      <=> v80215(VarCurr,B) ) ) ).

tff(addAssignment_49671,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,7)
      <=> v80214(VarCurr,3) )
      & ( v80202(VarCurr,6)
      <=> v80214(VarCurr,2) )
      & ( v80202(VarCurr,5)
      <=> v80214(VarCurr,1) )
      & ( v80202(VarCurr,4)
      <=> v80214(VarCurr,0) ) ) ).

tff(addAssignment_49670,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,11)
      <=> v80213(VarCurr,3) )
      & ( v80202(VarCurr,10)
      <=> v80213(VarCurr,2) )
      & ( v80202(VarCurr,9)
      <=> v80213(VarCurr,1) )
      & ( v80202(VarCurr,8)
      <=> v80213(VarCurr,0) ) ) ).

tff(addAssignment_49669,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,15)
      <=> v80212(VarCurr,3) )
      & ( v80202(VarCurr,14)
      <=> v80212(VarCurr,2) )
      & ( v80202(VarCurr,13)
      <=> v80212(VarCurr,1) )
      & ( v80202(VarCurr,12)
      <=> v80212(VarCurr,0) ) ) ).

tff(addAssignment_49668,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,19)
      <=> v80211(VarCurr,3) )
      & ( v80202(VarCurr,18)
      <=> v80211(VarCurr,2) )
      & ( v80202(VarCurr,17)
      <=> v80211(VarCurr,1) )
      & ( v80202(VarCurr,16)
      <=> v80211(VarCurr,0) ) ) ).

tff(addAssignment_49667,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,23)
      <=> v80210(VarCurr,3) )
      & ( v80202(VarCurr,22)
      <=> v80210(VarCurr,2) )
      & ( v80202(VarCurr,21)
      <=> v80210(VarCurr,1) )
      & ( v80202(VarCurr,20)
      <=> v80210(VarCurr,0) ) ) ).

tff(addAssignment_49666,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,27)
      <=> v80209(VarCurr,3) )
      & ( v80202(VarCurr,26)
      <=> v80209(VarCurr,2) )
      & ( v80202(VarCurr,25)
      <=> v80209(VarCurr,1) )
      & ( v80202(VarCurr,24)
      <=> v80209(VarCurr,0) ) ) ).

tff(addAssignment_49665,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,31)
      <=> v80208(VarCurr,3) )
      & ( v80202(VarCurr,30)
      <=> v80208(VarCurr,2) )
      & ( v80202(VarCurr,29)
      <=> v80208(VarCurr,1) )
      & ( v80202(VarCurr,28)
      <=> v80208(VarCurr,0) ) ) ).

tff(addAssignment_49664,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,35)
      <=> v80207(VarCurr,3) )
      & ( v80202(VarCurr,34)
      <=> v80207(VarCurr,2) )
      & ( v80202(VarCurr,33)
      <=> v80207(VarCurr,1) )
      & ( v80202(VarCurr,32)
      <=> v80207(VarCurr,0) ) ) ).

tff(addAssignment_49663,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,39)
      <=> v80206(VarCurr,3) )
      & ( v80202(VarCurr,38)
      <=> v80206(VarCurr,2) )
      & ( v80202(VarCurr,37)
      <=> v80206(VarCurr,1) )
      & ( v80202(VarCurr,36)
      <=> v80206(VarCurr,0) ) ) ).

tff(addAssignment_49662,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,43)
      <=> v80205(VarCurr,3) )
      & ( v80202(VarCurr,42)
      <=> v80205(VarCurr,2) )
      & ( v80202(VarCurr,41)
      <=> v80205(VarCurr,1) )
      & ( v80202(VarCurr,40)
      <=> v80205(VarCurr,0) ) ) ).

tff(addAssignment_49661,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,47)
      <=> v80204(VarCurr,3) )
      & ( v80202(VarCurr,46)
      <=> v80204(VarCurr,2) )
      & ( v80202(VarCurr,45)
      <=> v80204(VarCurr,1) )
      & ( v80202(VarCurr,44)
      <=> v80204(VarCurr,0) ) ) ).

tff(addAssignment_49660,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,51)
      <=> v80203(VarCurr,3) )
      & ( v80202(VarCurr,50)
      <=> v80203(VarCurr,2) )
      & ( v80202(VarCurr,49)
      <=> v80203(VarCurr,1) )
      & ( v80202(VarCurr,48)
      <=> v80203(VarCurr,0) ) ) ).

tff(addAssignment_49659,axiom,
    ! [VarCurr: state_type] :
      ( ( v80202(VarCurr,55)
      <=> v80045(VarCurr,3) )
      & ( v80202(VarCurr,54)
      <=> v80045(VarCurr,2) )
      & ( v80202(VarCurr,53)
      <=> v80045(VarCurr,1) )
      & ( v80202(VarCurr,52)
      <=> v80045(VarCurr,0) ) ) ).

tff(addAssignment_49658,axiom,
    ! [VarCurr: state_type] :
      ( v80045(VarCurr,3)
    <=> v80047(VarCurr) ) ).

tff(addAssignment_49657,axiom,
    ! [VarCurr: state_type] :
      ( v80045(VarCurr,2)
    <=> v80128(VarCurr) ) ).

tff(addAssignment_49656,axiom,
    ! [VarCurr: state_type] :
      ( v80045(VarCurr,1)
    <=> v80141(VarCurr) ) ).

tff(addAssignment_49655,axiom,
    ! [VarCurr: state_type] :
      ( v80045(VarCurr,0)
    <=> v80149(VarCurr) ) ).

tff(addAssignment_49654,axiom,
    ! [VarCurr: state_type] :
      ( v80149(VarCurr)
    <=> v80151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7386,axiom,
    ! [VarCurr: state_type] :
      ( v80151(VarCurr)
    <=> ( v80153(VarCurr)
      <~> v80177(VarCurr) ) ) ).

tff(addAssignment_49653,axiom,
    ! [VarCurr: state_type] :
      ( v80177(VarCurr)
    <=> v80179(VarCurr) ) ).

tff(addAssignment_49652,axiom,
    ! [VarCurr: state_type] :
      ( v80179(VarCurr)
    <=> v77837(VarCurr,119) ) ).

tff(addAssignment_49651,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,119)
    <=> v77894(VarCurr,119) ) ).

tff(addAssignment_49650,axiom,
    ! [VarCurr: state_type] :
      ( v77897(VarCurr)
    <=> v80182(VarCurr) ) ).

tff(addAssignment_49649,axiom,
    ! [VarCurr: state_type] :
      ( v80182(VarCurr)
    <=> v80184(VarCurr) ) ).

tff(writeUnaryOperator_3524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80184(VarCurr)
    <=> v80186(VarCurr) ) ).

tff(addAssignment_49648,axiom,
    ! [VarCurr: state_type] :
      ( v80186(VarCurr)
    <=> v80188(VarCurr) ) ).

tff(addAssignment_49647,axiom,
    ! [VarCurr: state_type] :
      ( v80188(VarCurr)
    <=> v80190(VarCurr) ) ).

tff(addAssignment_49646,axiom,
    ! [VarCurr: state_type] :
      ( v80190(VarCurr)
    <=> v80192(VarCurr) ) ).

tff(addAssignment_49645,axiom,
    ! [VarCurr: state_type] :
      ( v80192(VarCurr)
    <=> v80194(VarCurr) ) ).

tff(writeUnaryOperator_3523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80194(VarCurr)
    <=> v80196(VarCurr) ) ).

tff(addAssignment_49644,axiom,
    ! [VarCurr: state_type] :
      ( v80196(VarCurr)
    <=> v80198(VarCurr) ) ).

tff(addAssignment_49643,axiom,
    ! [VarCurr: state_type] :
      ( v80198(VarCurr)
    <=> v77859(VarCurr,3) ) ).

tff(addAssignment_49642,axiom,
    ! [VarCurr: state_type] :
      ( v80153(VarCurr)
    <=> v80155(VarCurr) ) ).

tff(addAssignment_49641,axiom,
    ! [VarCurr: state_type] :
      ( v80155(VarCurr)
    <=> v80157(VarCurr) ) ).

tff(addAssignment_49640,axiom,
    ! [VarCurr: state_type] :
      ( v80157(VarCurr)
    <=> v80159(VarCurr) ) ).

tff(addAssignment_49639,axiom,
    ! [VarCurr: state_type] :
      ( v80159(VarCurr)
    <=> v80161(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7385,axiom,
    ! [VarCurr: state_type] :
      ( v80161(VarCurr)
    <=> ( v80175(VarCurr)
      <~> v80171(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7384,axiom,
    ! [VarCurr: state_type] :
      ( v80175(VarCurr)
    <=> ( v80163(VarCurr)
      <~> v80167(VarCurr) ) ) ).

tff(addAssignment_49638,axiom,
    ! [VarCurr: state_type] :
      ( v80171(VarCurr)
    <=> v80173(VarCurr) ) ).

tff(addAssignment_49637,axiom,
    ! [VarCurr: state_type] :
      ( v80173(VarCurr)
    <=> v77837(VarCurr,118) ) ).

tff(addAssignment_49636,axiom,
    ! [VarCurr: state_type] :
      ( v80167(VarCurr)
    <=> v80169(VarCurr) ) ).

tff(addAssignment_49635,axiom,
    ! [VarCurr: state_type] :
      ( v80169(VarCurr)
    <=> v77837(VarCurr,117) ) ).

tff(addAssignment_49634,axiom,
    ! [VarCurr: state_type] :
      ( v80163(VarCurr)
    <=> v80165(VarCurr) ) ).

tff(addAssignment_49633,axiom,
    ! [VarCurr: state_type] :
      ( v80165(VarCurr)
    <=> v77837(VarCurr,116) ) ).

tff(addAssignment_49632,axiom,
    ! [VarCurr: state_type] :
      ( v80141(VarCurr)
    <=> v80143(VarCurr) ) ).

tff(addAssignment_49631,axiom,
    ! [VarCurr: state_type] :
      ( v80143(VarCurr)
    <=> v80145(VarCurr) ) ).

tff(addAssignment_49630,axiom,
    ! [VarCurr: state_type] :
      ( v80145(VarCurr)
    <=> v80147(VarCurr) ) ).

tff(addAssignment_49629,axiom,
    ! [VarCurr: state_type] :
      ( v80147(VarCurr)
    <=> v77837(VarCurr,116) ) ).

tff(addAssignment_49628,axiom,
    ! [VarCurr: state_type] :
      ( v80128(VarCurr)
    <=> v80130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7383,axiom,
    ! [VarCurr: state_type] :
      ( v80130(VarCurr)
    <=> ( v80132(VarCurr)
      <~> v80136(VarCurr) ) ) ).

tff(addAssignment_49627,axiom,
    ! [VarCurr: state_type] :
      ( v80136(VarCurr)
    <=> v80138(VarCurr) ) ).

tff(addAssignment_49626,axiom,
    ! [VarCurr: state_type] :
      ( v80138(VarCurr)
    <=> v77837(VarCurr,117) ) ).

tff(addAssignment_49625,axiom,
    ! [VarCurr: state_type] :
      ( v80132(VarCurr)
    <=> v80134(VarCurr) ) ).

tff(addAssignment_49624,axiom,
    ! [VarCurr: state_type] :
      ( v80134(VarCurr)
    <=> v77837(VarCurr,116) ) ).

tff(addAssignment_49623,axiom,
    ! [VarCurr: state_type] :
      ( v80047(VarCurr)
    <=> v80049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7382,axiom,
    ! [VarCurr: state_type] :
      ( v80049(VarCurr)
    <=> ( v80126(VarCurr)
      <~> v80101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7381,axiom,
    ! [VarCurr: state_type] :
      ( v80126(VarCurr)
    <=> ( v80051(VarCurr)
      <~> v80076(VarCurr) ) ) ).

tff(addAssignment_49622,axiom,
    ! [VarCurr: state_type] :
      ( v80101(VarCurr)
    <=> v80103(VarCurr) ) ).

tff(addAssignment_49621,axiom,
    ! [VarCurr: state_type] :
      ( v80103(VarCurr)
    <=> v77837(VarCurr,118) ) ).

tff(addAssignment_49620,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,118)
    <=> v77894(VarCurr,118) ) ).

tff(addAssignment_49619,axiom,
    ! [VarCurr: state_type] :
      ( v77898(VarCurr)
    <=> v80106(VarCurr) ) ).

tff(addAssignment_49618,axiom,
    ! [VarCurr: state_type] :
      ( v80106(VarCurr)
    <=> v80108(VarCurr) ) ).

tff(writeUnaryOperator_3522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80108(VarCurr)
    <=> v80110(VarCurr) ) ).

tff(addAssignment_49617,axiom,
    ! [VarCurr: state_type] :
      ( v80110(VarCurr)
    <=> v80112(VarCurr) ) ).

tff(addAssignment_49616,axiom,
    ! [VarCurr: state_type] :
      ( v80112(VarCurr)
    <=> v80114(VarCurr) ) ).

tff(addAssignment_49615,axiom,
    ! [VarCurr: state_type] :
      ( v80114(VarCurr)
    <=> v80116(VarCurr) ) ).

tff(addAssignment_49614,axiom,
    ! [VarCurr: state_type] :
      ( v80116(VarCurr)
    <=> v80118(VarCurr) ) ).

tff(writeUnaryOperator_3521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80118(VarCurr)
    <=> v80120(VarCurr) ) ).

tff(addAssignment_49613,axiom,
    ! [VarCurr: state_type] :
      ( v80120(VarCurr)
    <=> v80122(VarCurr) ) ).

tff(addAssignment_49612,axiom,
    ! [VarCurr: state_type] :
      ( v80122(VarCurr)
    <=> v77859(VarCurr,2) ) ).

tff(addAssignment_49611,axiom,
    ! [VarCurr: state_type] :
      ( v80076(VarCurr)
    <=> v80078(VarCurr) ) ).

tff(addAssignment_49610,axiom,
    ! [VarCurr: state_type] :
      ( v80078(VarCurr)
    <=> v77837(VarCurr,117) ) ).

tff(addAssignment_49609,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,117)
    <=> v77894(VarCurr,117) ) ).

tff(addAssignment_49608,axiom,
    ! [VarCurr: state_type] :
      ( v77899(VarCurr)
    <=> v80081(VarCurr) ) ).

tff(addAssignment_49607,axiom,
    ! [VarCurr: state_type] :
      ( v80081(VarCurr)
    <=> v80083(VarCurr) ) ).

tff(writeUnaryOperator_3520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80083(VarCurr)
    <=> v80085(VarCurr) ) ).

tff(addAssignment_49606,axiom,
    ! [VarCurr: state_type] :
      ( v80085(VarCurr)
    <=> v80087(VarCurr) ) ).

tff(addAssignment_49605,axiom,
    ! [VarCurr: state_type] :
      ( v80087(VarCurr)
    <=> v80089(VarCurr) ) ).

tff(addAssignment_49604,axiom,
    ! [VarCurr: state_type] :
      ( v80089(VarCurr)
    <=> v80091(VarCurr) ) ).

tff(addAssignment_49603,axiom,
    ! [VarCurr: state_type] :
      ( v80091(VarCurr)
    <=> v80093(VarCurr) ) ).

tff(writeUnaryOperator_3519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80093(VarCurr)
    <=> v80095(VarCurr) ) ).

tff(addAssignment_49602,axiom,
    ! [VarCurr: state_type] :
      ( v80095(VarCurr)
    <=> v80097(VarCurr) ) ).

tff(addAssignment_49601,axiom,
    ! [VarCurr: state_type] :
      ( v80097(VarCurr)
    <=> v77859(VarCurr,1) ) ).

tff(addAssignment_49600,axiom,
    ! [VarCurr: state_type] :
      ( v80051(VarCurr)
    <=> v80053(VarCurr) ) ).

tff(addAssignment_49599,axiom,
    ! [VarCurr: state_type] :
      ( v80053(VarCurr)
    <=> v77837(VarCurr,116) ) ).

tff(addAssignment_49598,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,116)
    <=> v77894(VarCurr,116) ) ).

tff(addAssignment_49597,axiom,
    ! [VarCurr: state_type] :
      ( v77900(VarCurr)
    <=> v80056(VarCurr) ) ).

tff(addAssignment_49596,axiom,
    ! [VarCurr: state_type] :
      ( v80056(VarCurr)
    <=> v80058(VarCurr) ) ).

tff(writeUnaryOperator_3518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80058(VarCurr)
    <=> v80060(VarCurr) ) ).

tff(addAssignment_49595,axiom,
    ! [VarCurr: state_type] :
      ( v80060(VarCurr)
    <=> v80062(VarCurr) ) ).

tff(addAssignment_49594,axiom,
    ! [VarCurr: state_type] :
      ( v80062(VarCurr)
    <=> v80064(VarCurr) ) ).

tff(addAssignment_49593,axiom,
    ! [VarCurr: state_type] :
      ( v80064(VarCurr)
    <=> v80066(VarCurr) ) ).

tff(addAssignment_49592,axiom,
    ! [VarCurr: state_type] :
      ( v80066(VarCurr)
    <=> v80068(VarCurr) ) ).

tff(writeUnaryOperator_3517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v80068(VarCurr)
    <=> v80070(VarCurr) ) ).

tff(addAssignment_49591,axiom,
    ! [VarCurr: state_type] :
      ( v80070(VarCurr)
    <=> v80072(VarCurr) ) ).

tff(addAssignment_49590,axiom,
    ! [VarCurr: state_type] :
      ( v80072(VarCurr)
    <=> v77859(VarCurr,0) ) ).

tff(addAssignment_49589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80027(VarCurr,B)
      <=> v80029(VarCurr,B) ) ) ).

tff(addAssignment_49588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v80029(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49587,axiom,
    ! [VarCurr: state_type] :
      ( v79998(VarCurr)
    <=> v80000(VarCurr) ) ).

tff(addAssignment_49586,axiom,
    ! [VarCurr: state_type] :
      ( v80000(VarCurr)
    <=> v80002(VarCurr) ) ).

tff(addAssignment_49585,axiom,
    ! [VarCurr: state_type] :
      ( v80002(VarCurr)
    <=> v80004(VarCurr) ) ).

tff(addAssignment_49584,axiom,
    ! [VarCurr: state_type] :
      ( v80004(VarCurr)
    <=> v80006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7380,axiom,
    ! [VarCurr: state_type] :
      ( v80006(VarCurr)
    <=> ( v80008(VarCurr)
        & v80012(VarCurr) ) ) ).

tff(addAssignment_49583,axiom,
    ! [VarCurr: state_type] :
      ( v80012(VarCurr)
    <=> v80014(VarCurr) ) ).

tff(addAssignment_49582,axiom,
    ! [VarCurr: state_type] :
      ( v80014(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_49581,axiom,
    ! [VarCurr: state_type] :
      ( v80008(VarCurr)
    <=> v80010(VarCurr) ) ).

tff(addAssignment_49580,axiom,
    ! [VarCurr: state_type] :
      ( v80010(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_49579,axiom,
    ! [VarCurr: state_type] :
      ( v79927(VarCurr)
    <=> v79929(VarCurr) ) ).

tff(addAssignment_49578,axiom,
    ! [VarCurr: state_type] :
      ( v79929(VarCurr)
    <=> v67197(VarCurr,2) ) ).

tff(addAssignment_49577,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,2)
    <=> v79931(VarCurr) ) ).

tff(addAssignment_49576,axiom,
    ! [VarCurr: state_type] :
      ( v79931(VarCurr)
    <=> v79933(VarCurr) ) ).

tff(writeUnaryOperator_3516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79933(VarCurr)
    <=> v79967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7379,axiom,
    ! [VarCurr: state_type] :
      ( v79967(VarCurr)
    <=> ( v79935(VarCurr)
        | v79963(VarCurr) ) ) ).

tff(addAssignment_49575,axiom,
    ! [VarCurr: state_type] :
      ( v79963(VarCurr)
    <=> v79965(VarCurr) ) ).

tff(addAssignment_49574,axiom,
    ! [VarCurr: state_type] :
      ( v79965(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_49573,axiom,
    ! [VarCurr: state_type] :
      ( v79935(VarCurr)
    <=> v79937(VarCurr) ) ).

tff(addAssignment_49572,axiom,
    ! [VarCurr: state_type] :
      ( v79937(VarCurr)
    <=> v67207(VarCurr,2) ) ).

tff(addAssignment_49571,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,2)
    <=> v79939(VarCurr) ) ).

tff(addAssignment_49570,axiom,
    ! [VarCurr: state_type] :
      ( v79939(VarCurr)
    <=> v79941(VarCurr) ) ).

tff(writeUnaryOperator_3515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79941(VarCurr)
    <=> v79959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7378,axiom,
    ! [VarCurr: state_type] :
      ( v79959(VarCurr)
    <=> ( v79960(VarCurr)
        & v79955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7377,axiom,
    ! [VarCurr: state_type] :
      ( v79960(VarCurr)
    <=> ( v79961(VarCurr)
        & v79951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7376,axiom,
    ! [VarCurr: state_type] :
      ( v79961(VarCurr)
    <=> ( v79943(VarCurr)
        & v79947(VarCurr) ) ) ).

tff(addAssignment_49569,axiom,
    ! [VarCurr: state_type] :
      ( v79955(VarCurr)
    <=> v79957(VarCurr) ) ).

tff(addAssignment_49568,axiom,
    ! [VarCurr: state_type] :
      ( v79957(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_49567,axiom,
    ! [VarCurr: state_type] :
      ( v79951(VarCurr)
    <=> v79953(VarCurr) ) ).

tff(addAssignment_49566,axiom,
    ! [VarCurr: state_type] :
      ( v79953(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_49565,axiom,
    ! [VarCurr: state_type] :
      ( v79947(VarCurr)
    <=> v79949(VarCurr) ) ).

tff(addAssignment_49564,axiom,
    ! [VarCurr: state_type] :
      ( v79949(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_49563,axiom,
    ! [VarCurr: state_type] :
      ( v79943(VarCurr)
    <=> v79945(VarCurr) ) ).

tff(addAssignment_49562,axiom,
    ! [VarCurr: state_type] :
      ( v79945(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_49561,axiom,
    ! [VarCurr: state_type] :
      ( v77694(VarCurr)
    <=> v77696(VarCurr) ) ).

tff(addAssignment_49560,axiom,
    ! [VarCurr: state_type] :
      ( v77696(VarCurr)
    <=> v77698(VarCurr) ) ).

tff(addAssignment_49559,axiom,
    ! [VarCurr: state_type] :
      ( v77698(VarCurr)
    <=> v77700(VarCurr) ) ).

tff(addAssignment_49558,axiom,
    ! [VarCurr: state_type] :
      ( v77700(VarCurr)
    <=> v77702(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7375,axiom,
    ! [VarCurr: state_type] :
      ( v77702(VarCurr)
    <=> ( v77704(VarCurr)
        & v77746(VarCurr) ) ) ).

tff(addAssignment_49557,axiom,
    ! [VarCurr: state_type] :
      ( v77746(VarCurr)
    <=> v77748(VarCurr) ) ).

tff(addAssignment_49556,axiom,
    ! [VarCurr: state_type] :
      ( v77748(VarCurr)
    <=> v77750(VarCurr) ) ).

tff(addAssignment_49555,axiom,
    ! [VarCurr: state_type] :
      ( v77750(VarCurr)
    <=> v77752(VarCurr) ) ).

tff(addAssignment_49554,axiom,
    ! [VarCurr: state_type] :
      ( v77752(VarCurr)
    <=> v77754(VarCurr) ) ).

tff(writeUnaryOperator_3514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77754(VarCurr)
    <=> v77756(VarCurr) ) ).

tff(addAssignment_49553,axiom,
    ! [VarCurr: state_type] :
      ( v77756(VarCurr)
    <=> v77758(VarCurr) ) ).

tff(addAssignment_49552,axiom,
    ! [VarCurr: state_type] :
      ( v77758(VarCurr)
    <=> v77760(VarCurr) ) ).

tff(addAssignment_49551,axiom,
    ! [VarCurr: state_type] :
      ( v77760(VarCurr)
    <=> v77762(VarCurr) ) ).

tff(addAssignment_49550,axiom,
    ! [VarCurr: state_type] :
      ( v77762(VarCurr)
    <=> v77764(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_315,axiom,
    ! [VarCurr: state_type] :
      ( v77764(VarCurr)
    <=> ( ( v77766(VarCurr,15)
        <=> v79441(VarCurr,15) )
        & ( v77766(VarCurr,14)
        <=> v79441(VarCurr,14) )
        & ( v77766(VarCurr,13)
        <=> v79441(VarCurr,13) )
        & ( v77766(VarCurr,12)
        <=> v79441(VarCurr,12) )
        & ( v77766(VarCurr,11)
        <=> v79441(VarCurr,11) )
        & ( v77766(VarCurr,10)
        <=> v79441(VarCurr,10) )
        & ( v77766(VarCurr,9)
        <=> v79441(VarCurr,9) )
        & ( v77766(VarCurr,8)
        <=> v79441(VarCurr,8) )
        & ( v77766(VarCurr,7)
        <=> v79441(VarCurr,7) )
        & ( v77766(VarCurr,6)
        <=> v79441(VarCurr,6) )
        & ( v77766(VarCurr,5)
        <=> v79441(VarCurr,5) )
        & ( v77766(VarCurr,4)
        <=> v79441(VarCurr,4) )
        & ( v77766(VarCurr,3)
        <=> v79441(VarCurr,3) )
        & ( v77766(VarCurr,2)
        <=> v79441(VarCurr,2) )
        & ( v77766(VarCurr,1)
        <=> v79441(VarCurr,1) )
        & ( v77766(VarCurr,0)
        <=> v79441(VarCurr,0) ) ) ) ).

tff(addAssignment_49549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v79441(VarCurr,B)
      <=> v79443(VarCurr,B) ) ) ).

tff(addAssignment_49548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v79443(VarCurr,B)
      <=> v79445(VarCurr,B) ) ) ).

tff(addAssignment_49547,axiom,
    ! [VarCurr: state_type] :
      ( v79443(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_49546,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,0)
    <=> v79882(VarCurr) ) ).

tff(addAssignment_49545,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,1)
    <=> v79852(VarCurr) ) ).

tff(addAssignment_49544,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,2)
    <=> v79822(VarCurr) ) ).

tff(addAssignment_49543,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,3)
    <=> v79792(VarCurr) ) ).

tff(addAssignment_49542,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,4)
    <=> v79762(VarCurr) ) ).

tff(addAssignment_49541,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,5)
    <=> v79732(VarCurr) ) ).

tff(addAssignment_49540,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,6)
    <=> v79702(VarCurr) ) ).

tff(addAssignment_49539,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,7)
    <=> v79672(VarCurr) ) ).

tff(addAssignment_49538,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,8)
    <=> v79642(VarCurr) ) ).

tff(addAssignment_49537,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,9)
    <=> v79612(VarCurr) ) ).

tff(addAssignment_49536,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,10)
    <=> v79582(VarCurr) ) ).

tff(addAssignment_49535,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,11)
    <=> v79552(VarCurr) ) ).

tff(addAssignment_49534,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,12)
    <=> v79522(VarCurr) ) ).

tff(addAssignment_49533,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,13)
    <=> v79492(VarCurr) ) ).

tff(addAssignment_49532,axiom,
    ! [VarCurr: state_type] :
      ( v79445(VarCurr,14)
    <=> v79447(VarCurr) ) ).

tff(addAssignment_49531,axiom,
    ! [VarCurr: state_type] :
      ( v79882(VarCurr)
    <=> v79884(VarCurr) ) ).

tff(addAssignment_49530,axiom,
    ! [VarCurr: state_type] :
      ( v79884(VarCurr)
    <=> v79886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7374,axiom,
    ! [VarCurr: state_type] :
      ( v79886(VarCurr)
    <=> ( v79888(VarCurr)
        & v79892(VarCurr) ) ) ).

tff(addAssignment_49529,axiom,
    ! [VarCurr: state_type] :
      ( v79892(VarCurr)
    <=> v79894(VarCurr) ) ).

tff(addAssignment_49528,axiom,
    ! [VarCurr: state_type] :
      ( v79894(VarCurr)
    <=> v79896(VarCurr) ) ).

tff(addAssignment_49527,axiom,
    ! [VarCurr: state_type] :
      ( v79896(VarCurr)
    <=> v79898(VarCurr) ) ).

tff(addAssignment_49526,axiom,
    ! [VarCurr: state_type] :
      ( v79898(VarCurr)
    <=> v79900(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_314,axiom,
    ! [VarCurr: state_type] :
      ( v79900(VarCurr)
    <=> ( ( v79902(VarCurr,3)
        <=> v79906(VarCurr,3) )
        & ( v79902(VarCurr,2)
        <=> v79906(VarCurr,2) )
        & ( v79902(VarCurr,1)
        <=> v79906(VarCurr,1) )
        & ( v79902(VarCurr,0)
        <=> v79906(VarCurr,0) ) ) ) ).

tff(addAssignment_49525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79906(VarCurr,B)
      <=> v79908(VarCurr,B) ) ) ).

tff(addAssignment_49524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79908(VarCurr,B)
      <=> v77058(VarCurr,B) ) ) ).

tff(addAssignment_49523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79902(VarCurr,B)
      <=> v79904(VarCurr,B) ) ) ).

tff(addAssignment_49522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79904(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49521,axiom,
    ! [VarCurr: state_type] :
      ( v79888(VarCurr)
    <=> v79890(VarCurr) ) ).

tff(addAssignment_49520,axiom,
    ! [VarCurr: state_type] :
      ( v79890(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49519,axiom,
    ! [VarCurr: state_type] :
      ( v79852(VarCurr)
    <=> v79854(VarCurr) ) ).

tff(addAssignment_49518,axiom,
    ! [VarCurr: state_type] :
      ( v79854(VarCurr)
    <=> v79856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7373,axiom,
    ! [VarCurr: state_type] :
      ( v79856(VarCurr)
    <=> ( v79858(VarCurr)
        & v79862(VarCurr) ) ) ).

tff(addAssignment_49517,axiom,
    ! [VarCurr: state_type] :
      ( v79862(VarCurr)
    <=> v79864(VarCurr) ) ).

tff(addAssignment_49516,axiom,
    ! [VarCurr: state_type] :
      ( v79864(VarCurr)
    <=> v79866(VarCurr) ) ).

tff(addAssignment_49515,axiom,
    ! [VarCurr: state_type] :
      ( v79866(VarCurr)
    <=> v79868(VarCurr) ) ).

tff(addAssignment_49514,axiom,
    ! [VarCurr: state_type] :
      ( v79868(VarCurr)
    <=> v79870(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_313,axiom,
    ! [VarCurr: state_type] :
      ( v79870(VarCurr)
    <=> ( ( v79872(VarCurr,3)
        <=> v79876(VarCurr,3) )
        & ( v79872(VarCurr,2)
        <=> v79876(VarCurr,2) )
        & ( v79872(VarCurr,1)
        <=> v79876(VarCurr,1) )
        & ( v79872(VarCurr,0)
        <=> v79876(VarCurr,0) ) ) ) ).

tff(addAssignment_49513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79876(VarCurr,B)
      <=> v79878(VarCurr,B) ) ) ).

tff(addAssignment_49512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79878(VarCurr,B)
      <=> v78649(VarCurr,B) ) ) ).

tff(addAssignment_49511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79872(VarCurr,B)
      <=> v79874(VarCurr,B) ) ) ).

tff(addAssignment_49510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79874(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49509,axiom,
    ! [VarCurr: state_type] :
      ( v79858(VarCurr)
    <=> v79860(VarCurr) ) ).

tff(addAssignment_49508,axiom,
    ! [VarCurr: state_type] :
      ( v79860(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49507,axiom,
    ! [VarCurr: state_type] :
      ( v79822(VarCurr)
    <=> v79824(VarCurr) ) ).

tff(addAssignment_49506,axiom,
    ! [VarCurr: state_type] :
      ( v79824(VarCurr)
    <=> v79826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7372,axiom,
    ! [VarCurr: state_type] :
      ( v79826(VarCurr)
    <=> ( v79828(VarCurr)
        & v79832(VarCurr) ) ) ).

tff(addAssignment_49505,axiom,
    ! [VarCurr: state_type] :
      ( v79832(VarCurr)
    <=> v79834(VarCurr) ) ).

tff(addAssignment_49504,axiom,
    ! [VarCurr: state_type] :
      ( v79834(VarCurr)
    <=> v79836(VarCurr) ) ).

tff(addAssignment_49503,axiom,
    ! [VarCurr: state_type] :
      ( v79836(VarCurr)
    <=> v79838(VarCurr) ) ).

tff(addAssignment_49502,axiom,
    ! [VarCurr: state_type] :
      ( v79838(VarCurr)
    <=> v79840(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_312,axiom,
    ! [VarCurr: state_type] :
      ( v79840(VarCurr)
    <=> ( ( v79842(VarCurr,3)
        <=> v79846(VarCurr,3) )
        & ( v79842(VarCurr,2)
        <=> v79846(VarCurr,2) )
        & ( v79842(VarCurr,1)
        <=> v79846(VarCurr,1) )
        & ( v79842(VarCurr,0)
        <=> v79846(VarCurr,0) ) ) ) ).

tff(addAssignment_49501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79846(VarCurr,B)
      <=> v79848(VarCurr,B) ) ) ).

tff(addAssignment_49500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79848(VarCurr,B)
      <=> v78114(VarCurr,B) ) ) ).

tff(addAssignment_49499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79842(VarCurr,B)
      <=> v79844(VarCurr,B) ) ) ).

tff(addAssignment_49498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79844(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49497,axiom,
    ! [VarCurr: state_type] :
      ( v79828(VarCurr)
    <=> v79830(VarCurr) ) ).

tff(addAssignment_49496,axiom,
    ! [VarCurr: state_type] :
      ( v79830(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49495,axiom,
    ! [VarCurr: state_type] :
      ( v79792(VarCurr)
    <=> v79794(VarCurr) ) ).

tff(addAssignment_49494,axiom,
    ! [VarCurr: state_type] :
      ( v79794(VarCurr)
    <=> v79796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7371,axiom,
    ! [VarCurr: state_type] :
      ( v79796(VarCurr)
    <=> ( v79798(VarCurr)
        & v79802(VarCurr) ) ) ).

tff(addAssignment_49493,axiom,
    ! [VarCurr: state_type] :
      ( v79802(VarCurr)
    <=> v79804(VarCurr) ) ).

tff(addAssignment_49492,axiom,
    ! [VarCurr: state_type] :
      ( v79804(VarCurr)
    <=> v79806(VarCurr) ) ).

tff(addAssignment_49491,axiom,
    ! [VarCurr: state_type] :
      ( v79806(VarCurr)
    <=> v79808(VarCurr) ) ).

tff(addAssignment_49490,axiom,
    ! [VarCurr: state_type] :
      ( v79808(VarCurr)
    <=> v79810(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_311,axiom,
    ! [VarCurr: state_type] :
      ( v79810(VarCurr)
    <=> ( ( v79812(VarCurr,3)
        <=> v79816(VarCurr,3) )
        & ( v79812(VarCurr,2)
        <=> v79816(VarCurr,2) )
        & ( v79812(VarCurr,1)
        <=> v79816(VarCurr,1) )
        & ( v79812(VarCurr,0)
        <=> v79816(VarCurr,0) ) ) ) ).

tff(addAssignment_49489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79816(VarCurr,B)
      <=> v79818(VarCurr,B) ) ) ).

tff(addAssignment_49488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79818(VarCurr,B)
      <=> v78229(VarCurr,B) ) ) ).

tff(addAssignment_49487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79812(VarCurr,B)
      <=> v79814(VarCurr,B) ) ) ).

tff(addAssignment_49486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79814(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49485,axiom,
    ! [VarCurr: state_type] :
      ( v79798(VarCurr)
    <=> v79800(VarCurr) ) ).

tff(addAssignment_49484,axiom,
    ! [VarCurr: state_type] :
      ( v79800(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49483,axiom,
    ! [VarCurr: state_type] :
      ( v79762(VarCurr)
    <=> v79764(VarCurr) ) ).

tff(addAssignment_49482,axiom,
    ! [VarCurr: state_type] :
      ( v79764(VarCurr)
    <=> v79766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7370,axiom,
    ! [VarCurr: state_type] :
      ( v79766(VarCurr)
    <=> ( v79768(VarCurr)
        & v79772(VarCurr) ) ) ).

tff(addAssignment_49481,axiom,
    ! [VarCurr: state_type] :
      ( v79772(VarCurr)
    <=> v79774(VarCurr) ) ).

tff(addAssignment_49480,axiom,
    ! [VarCurr: state_type] :
      ( v79774(VarCurr)
    <=> v79776(VarCurr) ) ).

tff(addAssignment_49479,axiom,
    ! [VarCurr: state_type] :
      ( v79776(VarCurr)
    <=> v79778(VarCurr) ) ).

tff(addAssignment_49478,axiom,
    ! [VarCurr: state_type] :
      ( v79778(VarCurr)
    <=> v79780(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_310,axiom,
    ! [VarCurr: state_type] :
      ( v79780(VarCurr)
    <=> ( ( v79782(VarCurr,3)
        <=> v79786(VarCurr,3) )
        & ( v79782(VarCurr,2)
        <=> v79786(VarCurr,2) )
        & ( v79782(VarCurr,1)
        <=> v79786(VarCurr,1) )
        & ( v79782(VarCurr,0)
        <=> v79786(VarCurr,0) ) ) ) ).

tff(addAssignment_49477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79786(VarCurr,B)
      <=> v79788(VarCurr,B) ) ) ).

tff(addAssignment_49476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79788(VarCurr,B)
      <=> v78439(VarCurr,B) ) ) ).

tff(addAssignment_49475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79782(VarCurr,B)
      <=> v79784(VarCurr,B) ) ) ).

tff(addAssignment_49474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79784(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49473,axiom,
    ! [VarCurr: state_type] :
      ( v79768(VarCurr)
    <=> v79770(VarCurr) ) ).

tff(addAssignment_49472,axiom,
    ! [VarCurr: state_type] :
      ( v79770(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49471,axiom,
    ! [VarCurr: state_type] :
      ( v79732(VarCurr)
    <=> v79734(VarCurr) ) ).

tff(addAssignment_49470,axiom,
    ! [VarCurr: state_type] :
      ( v79734(VarCurr)
    <=> v79736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7369,axiom,
    ! [VarCurr: state_type] :
      ( v79736(VarCurr)
    <=> ( v79738(VarCurr)
        & v79742(VarCurr) ) ) ).

tff(addAssignment_49469,axiom,
    ! [VarCurr: state_type] :
      ( v79742(VarCurr)
    <=> v79744(VarCurr) ) ).

tff(addAssignment_49468,axiom,
    ! [VarCurr: state_type] :
      ( v79744(VarCurr)
    <=> v79746(VarCurr) ) ).

tff(addAssignment_49467,axiom,
    ! [VarCurr: state_type] :
      ( v79746(VarCurr)
    <=> v79748(VarCurr) ) ).

tff(addAssignment_49466,axiom,
    ! [VarCurr: state_type] :
      ( v79748(VarCurr)
    <=> v79750(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_309,axiom,
    ! [VarCurr: state_type] :
      ( v79750(VarCurr)
    <=> ( ( v79752(VarCurr,3)
        <=> v79756(VarCurr,3) )
        & ( v79752(VarCurr,2)
        <=> v79756(VarCurr,2) )
        & ( v79752(VarCurr,1)
        <=> v79756(VarCurr,1) )
        & ( v79752(VarCurr,0)
        <=> v79756(VarCurr,0) ) ) ) ).

tff(addAssignment_49465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79756(VarCurr,B)
      <=> v79758(VarCurr,B) ) ) ).

tff(addAssignment_49464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79758(VarCurr,B)
      <=> v78839(VarCurr,B) ) ) ).

tff(addAssignment_49463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79752(VarCurr,B)
      <=> v79754(VarCurr,B) ) ) ).

tff(addAssignment_49462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79754(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49461,axiom,
    ! [VarCurr: state_type] :
      ( v79738(VarCurr)
    <=> v79740(VarCurr) ) ).

tff(addAssignment_49460,axiom,
    ! [VarCurr: state_type] :
      ( v79740(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49459,axiom,
    ! [VarCurr: state_type] :
      ( v79702(VarCurr)
    <=> v79704(VarCurr) ) ).

tff(addAssignment_49458,axiom,
    ! [VarCurr: state_type] :
      ( v79704(VarCurr)
    <=> v79706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7368,axiom,
    ! [VarCurr: state_type] :
      ( v79706(VarCurr)
    <=> ( v79708(VarCurr)
        & v79712(VarCurr) ) ) ).

tff(addAssignment_49457,axiom,
    ! [VarCurr: state_type] :
      ( v79712(VarCurr)
    <=> v79714(VarCurr) ) ).

tff(addAssignment_49456,axiom,
    ! [VarCurr: state_type] :
      ( v79714(VarCurr)
    <=> v79716(VarCurr) ) ).

tff(addAssignment_49455,axiom,
    ! [VarCurr: state_type] :
      ( v79716(VarCurr)
    <=> v79718(VarCurr) ) ).

tff(addAssignment_49454,axiom,
    ! [VarCurr: state_type] :
      ( v79718(VarCurr)
    <=> v79720(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_308,axiom,
    ! [VarCurr: state_type] :
      ( v79720(VarCurr)
    <=> ( ( v79722(VarCurr,3)
        <=> v79726(VarCurr,3) )
        & ( v79722(VarCurr,2)
        <=> v79726(VarCurr,2) )
        & ( v79722(VarCurr,1)
        <=> v79726(VarCurr,1) )
        & ( v79722(VarCurr,0)
        <=> v79726(VarCurr,0) ) ) ) ).

tff(addAssignment_49453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79726(VarCurr,B)
      <=> v79728(VarCurr,B) ) ) ).

tff(addAssignment_49452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79728(VarCurr,B)
      <=> v78959(VarCurr,B) ) ) ).

tff(addAssignment_49451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79722(VarCurr,B)
      <=> v79724(VarCurr,B) ) ) ).

tff(addAssignment_49450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79724(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49449,axiom,
    ! [VarCurr: state_type] :
      ( v79708(VarCurr)
    <=> v79710(VarCurr) ) ).

tff(addAssignment_49448,axiom,
    ! [VarCurr: state_type] :
      ( v79710(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49447,axiom,
    ! [VarCurr: state_type] :
      ( v79672(VarCurr)
    <=> v79674(VarCurr) ) ).

tff(addAssignment_49446,axiom,
    ! [VarCurr: state_type] :
      ( v79674(VarCurr)
    <=> v79676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7367,axiom,
    ! [VarCurr: state_type] :
      ( v79676(VarCurr)
    <=> ( v79678(VarCurr)
        & v79682(VarCurr) ) ) ).

tff(addAssignment_49445,axiom,
    ! [VarCurr: state_type] :
      ( v79682(VarCurr)
    <=> v79684(VarCurr) ) ).

tff(addAssignment_49444,axiom,
    ! [VarCurr: state_type] :
      ( v79684(VarCurr)
    <=> v79686(VarCurr) ) ).

tff(addAssignment_49443,axiom,
    ! [VarCurr: state_type] :
      ( v79686(VarCurr)
    <=> v79688(VarCurr) ) ).

tff(addAssignment_49442,axiom,
    ! [VarCurr: state_type] :
      ( v79688(VarCurr)
    <=> v79690(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_307,axiom,
    ! [VarCurr: state_type] :
      ( v79690(VarCurr)
    <=> ( ( v79692(VarCurr,3)
        <=> v79696(VarCurr,3) )
        & ( v79692(VarCurr,2)
        <=> v79696(VarCurr,2) )
        & ( v79692(VarCurr,1)
        <=> v79696(VarCurr,1) )
        & ( v79692(VarCurr,0)
        <=> v79696(VarCurr,0) ) ) ) ).

tff(addAssignment_49441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79696(VarCurr,B)
      <=> v79698(VarCurr,B) ) ) ).

tff(addAssignment_49440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79698(VarCurr,B)
      <=> v77815(VarCurr,B) ) ) ).

tff(addAssignment_49439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79692(VarCurr,B)
      <=> v79694(VarCurr,B) ) ) ).

tff(addAssignment_49438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79694(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49437,axiom,
    ! [VarCurr: state_type] :
      ( v79678(VarCurr)
    <=> v79680(VarCurr) ) ).

tff(addAssignment_49436,axiom,
    ! [VarCurr: state_type] :
      ( v79680(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49435,axiom,
    ! [VarCurr: state_type] :
      ( v79642(VarCurr)
    <=> v79644(VarCurr) ) ).

tff(addAssignment_49434,axiom,
    ! [VarCurr: state_type] :
      ( v79644(VarCurr)
    <=> v79646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7366,axiom,
    ! [VarCurr: state_type] :
      ( v79646(VarCurr)
    <=> ( v79648(VarCurr)
        & v79652(VarCurr) ) ) ).

tff(addAssignment_49433,axiom,
    ! [VarCurr: state_type] :
      ( v79652(VarCurr)
    <=> v79654(VarCurr) ) ).

tff(addAssignment_49432,axiom,
    ! [VarCurr: state_type] :
      ( v79654(VarCurr)
    <=> v79656(VarCurr) ) ).

tff(addAssignment_49431,axiom,
    ! [VarCurr: state_type] :
      ( v79656(VarCurr)
    <=> v79658(VarCurr) ) ).

tff(addAssignment_49430,axiom,
    ! [VarCurr: state_type] :
      ( v79658(VarCurr)
    <=> v79660(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_306,axiom,
    ! [VarCurr: state_type] :
      ( v79660(VarCurr)
    <=> ( ( v79662(VarCurr,3)
        <=> v79666(VarCurr,3) )
        & ( v79662(VarCurr,2)
        <=> v79666(VarCurr,2) )
        & ( v79662(VarCurr,1)
        <=> v79666(VarCurr,1) )
        & ( v79662(VarCurr,0)
        <=> v79666(VarCurr,0) ) ) ) ).

tff(addAssignment_49429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79666(VarCurr,B)
      <=> v79668(VarCurr,B) ) ) ).

tff(addAssignment_49428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79668(VarCurr,B)
      <=> v79349(VarCurr,B) ) ) ).

tff(addAssignment_49427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79662(VarCurr,B)
      <=> v79664(VarCurr,B) ) ) ).

tff(addAssignment_49426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79664(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49425,axiom,
    ! [VarCurr: state_type] :
      ( v79648(VarCurr)
    <=> v79650(VarCurr) ) ).

tff(addAssignment_49424,axiom,
    ! [VarCurr: state_type] :
      ( v79650(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49423,axiom,
    ! [VarCurr: state_type] :
      ( v79612(VarCurr)
    <=> v79614(VarCurr) ) ).

tff(addAssignment_49422,axiom,
    ! [VarCurr: state_type] :
      ( v79614(VarCurr)
    <=> v79616(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7365,axiom,
    ! [VarCurr: state_type] :
      ( v79616(VarCurr)
    <=> ( v79618(VarCurr)
        & v79622(VarCurr) ) ) ).

tff(addAssignment_49421,axiom,
    ! [VarCurr: state_type] :
      ( v79622(VarCurr)
    <=> v79624(VarCurr) ) ).

tff(addAssignment_49420,axiom,
    ! [VarCurr: state_type] :
      ( v79624(VarCurr)
    <=> v79626(VarCurr) ) ).

tff(addAssignment_49419,axiom,
    ! [VarCurr: state_type] :
      ( v79626(VarCurr)
    <=> v79628(VarCurr) ) ).

tff(addAssignment_49418,axiom,
    ! [VarCurr: state_type] :
      ( v79628(VarCurr)
    <=> v79630(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_305,axiom,
    ! [VarCurr: state_type] :
      ( v79630(VarCurr)
    <=> ( ( v79632(VarCurr,3)
        <=> v79636(VarCurr,3) )
        & ( v79632(VarCurr,2)
        <=> v79636(VarCurr,2) )
        & ( v79632(VarCurr,1)
        <=> v79636(VarCurr,1) )
        & ( v79632(VarCurr,0)
        <=> v79636(VarCurr,0) ) ) ) ).

tff(addAssignment_49417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79636(VarCurr,B)
      <=> v79638(VarCurr,B) ) ) ).

tff(addAssignment_49416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79638(VarCurr,B)
      <=> v78309(VarCurr,B) ) ) ).

tff(addAssignment_49415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79632(VarCurr,B)
      <=> v79634(VarCurr,B) ) ) ).

tff(addAssignment_49414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79634(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49413,axiom,
    ! [VarCurr: state_type] :
      ( v79618(VarCurr)
    <=> v79620(VarCurr) ) ).

tff(addAssignment_49412,axiom,
    ! [VarCurr: state_type] :
      ( v79620(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49411,axiom,
    ! [VarCurr: state_type] :
      ( v79582(VarCurr)
    <=> v79584(VarCurr) ) ).

tff(addAssignment_49410,axiom,
    ! [VarCurr: state_type] :
      ( v79584(VarCurr)
    <=> v79586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7364,axiom,
    ! [VarCurr: state_type] :
      ( v79586(VarCurr)
    <=> ( v79588(VarCurr)
        & v79592(VarCurr) ) ) ).

tff(addAssignment_49409,axiom,
    ! [VarCurr: state_type] :
      ( v79592(VarCurr)
    <=> v79594(VarCurr) ) ).

tff(addAssignment_49408,axiom,
    ! [VarCurr: state_type] :
      ( v79594(VarCurr)
    <=> v79596(VarCurr) ) ).

tff(addAssignment_49407,axiom,
    ! [VarCurr: state_type] :
      ( v79596(VarCurr)
    <=> v79598(VarCurr) ) ).

tff(addAssignment_49406,axiom,
    ! [VarCurr: state_type] :
      ( v79598(VarCurr)
    <=> v79600(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_304,axiom,
    ! [VarCurr: state_type] :
      ( v79600(VarCurr)
    <=> ( ( v79602(VarCurr,3)
        <=> v79606(VarCurr,3) )
        & ( v79602(VarCurr,2)
        <=> v79606(VarCurr,2) )
        & ( v79602(VarCurr,1)
        <=> v79606(VarCurr,1) )
        & ( v79602(VarCurr,0)
        <=> v79606(VarCurr,0) ) ) ) ).

tff(addAssignment_49405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79606(VarCurr,B)
      <=> v79608(VarCurr,B) ) ) ).

tff(addAssignment_49404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79608(VarCurr,B)
      <=> v79049(VarCurr,B) ) ) ).

tff(addAssignment_49403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79602(VarCurr,B)
      <=> v79604(VarCurr,B) ) ) ).

tff(addAssignment_49402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79604(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49401,axiom,
    ! [VarCurr: state_type] :
      ( v79588(VarCurr)
    <=> v79590(VarCurr) ) ).

tff(addAssignment_49400,axiom,
    ! [VarCurr: state_type] :
      ( v79590(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49399,axiom,
    ! [VarCurr: state_type] :
      ( v79552(VarCurr)
    <=> v79554(VarCurr) ) ).

tff(addAssignment_49398,axiom,
    ! [VarCurr: state_type] :
      ( v79554(VarCurr)
    <=> v79556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7363,axiom,
    ! [VarCurr: state_type] :
      ( v79556(VarCurr)
    <=> ( v79558(VarCurr)
        & v79562(VarCurr) ) ) ).

tff(addAssignment_49397,axiom,
    ! [VarCurr: state_type] :
      ( v79562(VarCurr)
    <=> v79564(VarCurr) ) ).

tff(addAssignment_49396,axiom,
    ! [VarCurr: state_type] :
      ( v79564(VarCurr)
    <=> v79566(VarCurr) ) ).

tff(addAssignment_49395,axiom,
    ! [VarCurr: state_type] :
      ( v79566(VarCurr)
    <=> v79568(VarCurr) ) ).

tff(addAssignment_49394,axiom,
    ! [VarCurr: state_type] :
      ( v79568(VarCurr)
    <=> v79570(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_303,axiom,
    ! [VarCurr: state_type] :
      ( v79570(VarCurr)
    <=> ( ( v79572(VarCurr,3)
        <=> v79576(VarCurr,3) )
        & ( v79572(VarCurr,2)
        <=> v79576(VarCurr,2) )
        & ( v79572(VarCurr,1)
        <=> v79576(VarCurr,1) )
        & ( v79572(VarCurr,0)
        <=> v79576(VarCurr,0) ) ) ) ).

tff(addAssignment_49393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79576(VarCurr,B)
      <=> v79578(VarCurr,B) ) ) ).

tff(addAssignment_49392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79578(VarCurr,B)
      <=> v78534(VarCurr,B) ) ) ).

tff(addAssignment_49391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79572(VarCurr,B)
      <=> v79574(VarCurr,B) ) ) ).

tff(addAssignment_49390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79574(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49389,axiom,
    ! [VarCurr: state_type] :
      ( v79558(VarCurr)
    <=> v79560(VarCurr) ) ).

tff(addAssignment_49388,axiom,
    ! [VarCurr: state_type] :
      ( v79560(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49387,axiom,
    ! [VarCurr: state_type] :
      ( v79522(VarCurr)
    <=> v79524(VarCurr) ) ).

tff(addAssignment_49386,axiom,
    ! [VarCurr: state_type] :
      ( v79524(VarCurr)
    <=> v79526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7362,axiom,
    ! [VarCurr: state_type] :
      ( v79526(VarCurr)
    <=> ( v79528(VarCurr)
        & v79532(VarCurr) ) ) ).

tff(addAssignment_49385,axiom,
    ! [VarCurr: state_type] :
      ( v79532(VarCurr)
    <=> v79534(VarCurr) ) ).

tff(addAssignment_49384,axiom,
    ! [VarCurr: state_type] :
      ( v79534(VarCurr)
    <=> v79536(VarCurr) ) ).

tff(addAssignment_49383,axiom,
    ! [VarCurr: state_type] :
      ( v79536(VarCurr)
    <=> v79538(VarCurr) ) ).

tff(addAssignment_49382,axiom,
    ! [VarCurr: state_type] :
      ( v79538(VarCurr)
    <=> v79540(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_302,axiom,
    ! [VarCurr: state_type] :
      ( v79540(VarCurr)
    <=> ( ( v79542(VarCurr,3)
        <=> v79546(VarCurr,3) )
        & ( v79542(VarCurr,2)
        <=> v79546(VarCurr,2) )
        & ( v79542(VarCurr,1)
        <=> v79546(VarCurr,1) )
        & ( v79542(VarCurr,0)
        <=> v79546(VarCurr,0) ) ) ) ).

tff(addAssignment_49381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79546(VarCurr,B)
      <=> v79548(VarCurr,B) ) ) ).

tff(addAssignment_49380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79548(VarCurr,B)
      <=> v79144(VarCurr,B) ) ) ).

tff(addAssignment_49379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79542(VarCurr,B)
      <=> v79544(VarCurr,B) ) ) ).

tff(addAssignment_49378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79544(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49377,axiom,
    ! [VarCurr: state_type] :
      ( v79528(VarCurr)
    <=> v79530(VarCurr) ) ).

tff(addAssignment_49376,axiom,
    ! [VarCurr: state_type] :
      ( v79530(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49375,axiom,
    ! [VarCurr: state_type] :
      ( v79492(VarCurr)
    <=> v79494(VarCurr) ) ).

tff(addAssignment_49374,axiom,
    ! [VarCurr: state_type] :
      ( v79494(VarCurr)
    <=> v79496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7361,axiom,
    ! [VarCurr: state_type] :
      ( v79496(VarCurr)
    <=> ( v79498(VarCurr)
        & v79502(VarCurr) ) ) ).

tff(addAssignment_49373,axiom,
    ! [VarCurr: state_type] :
      ( v79502(VarCurr)
    <=> v79504(VarCurr) ) ).

tff(addAssignment_49372,axiom,
    ! [VarCurr: state_type] :
      ( v79504(VarCurr)
    <=> v79506(VarCurr) ) ).

tff(addAssignment_49371,axiom,
    ! [VarCurr: state_type] :
      ( v79506(VarCurr)
    <=> v79508(VarCurr) ) ).

tff(addAssignment_49370,axiom,
    ! [VarCurr: state_type] :
      ( v79508(VarCurr)
    <=> v79510(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_301,axiom,
    ! [VarCurr: state_type] :
      ( v79510(VarCurr)
    <=> ( ( v79512(VarCurr,3)
        <=> v79516(VarCurr,3) )
        & ( v79512(VarCurr,2)
        <=> v79516(VarCurr,2) )
        & ( v79512(VarCurr,1)
        <=> v79516(VarCurr,1) )
        & ( v79512(VarCurr,0)
        <=> v79516(VarCurr,0) ) ) ) ).

tff(addAssignment_49369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79516(VarCurr,B)
      <=> v79518(VarCurr,B) ) ) ).

tff(addAssignment_49368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79518(VarCurr,B)
      <=> v79259(VarCurr,B) ) ) ).

tff(addAssignment_49367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79512(VarCurr,B)
      <=> v79514(VarCurr,B) ) ) ).

tff(addAssignment_49366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79514(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49365,axiom,
    ! [VarCurr: state_type] :
      ( v79498(VarCurr)
    <=> v79500(VarCurr) ) ).

tff(addAssignment_49364,axiom,
    ! [VarCurr: state_type] :
      ( v79500(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49363,axiom,
    ! [VarCurr: state_type] :
      ( v79447(VarCurr)
    <=> v79449(VarCurr) ) ).

tff(addAssignment_49362,axiom,
    ! [VarCurr: state_type] :
      ( v79449(VarCurr)
    <=> v79451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7360,axiom,
    ! [VarCurr: state_type] :
      ( v79451(VarCurr)
    <=> ( v79453(VarCurr)
        & v79472(VarCurr) ) ) ).

tff(addAssignment_49361,axiom,
    ! [VarCurr: state_type] :
      ( v79472(VarCurr)
    <=> v79474(VarCurr) ) ).

tff(addAssignment_49360,axiom,
    ! [VarCurr: state_type] :
      ( v79474(VarCurr)
    <=> v79476(VarCurr) ) ).

tff(addAssignment_49359,axiom,
    ! [VarCurr: state_type] :
      ( v79476(VarCurr)
    <=> v79478(VarCurr) ) ).

tff(addAssignment_49358,axiom,
    ! [VarCurr: state_type] :
      ( v79478(VarCurr)
    <=> v79480(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_300,axiom,
    ! [VarCurr: state_type] :
      ( v79480(VarCurr)
    <=> ( ( v79482(VarCurr,3)
        <=> v79486(VarCurr,3) )
        & ( v79482(VarCurr,2)
        <=> v79486(VarCurr,2) )
        & ( v79482(VarCurr,1)
        <=> v79486(VarCurr,1) )
        & ( v79482(VarCurr,0)
        <=> v79486(VarCurr,0) ) ) ) ).

tff(addAssignment_49357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79486(VarCurr,B)
      <=> v79488(VarCurr,B) ) ) ).

tff(addAssignment_49356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79488(VarCurr,B)
      <=> v78719(VarCurr,B) ) ) ).

tff(addAssignment_49355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79482(VarCurr,B)
      <=> v79484(VarCurr,B) ) ) ).

tff(addAssignment_49354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79484(VarCurr,B)
      <=> v77318(VarCurr,B) ) ) ).

tff(addAssignment_49353,axiom,
    ! [VarCurr: state_type] :
      ( v79453(VarCurr)
    <=> v79455(VarCurr) ) ).

tff(addAssignment_49352,axiom,
    ! [VarCurr: state_type] :
      ( v79455(VarCurr)
    <=> v79457(VarCurr) ) ).

tff(addAssignment_49351,axiom,
    ! [VarCurr: state_type] :
      ( v79457(VarCurr)
    <=> v79459(VarCurr) ) ).

tff(addAssignment_49350,axiom,
    ! [VarCurr: state_type] :
      ( v79459(VarCurr)
    <=> v79461(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7359,axiom,
    ! [VarCurr: state_type] :
      ( v79461(VarCurr)
    <=> ( v79463(VarCurr)
        & v79467(VarCurr) ) ) ).

tff(addAssignment_49349,axiom,
    ! [VarCurr: state_type] :
      ( v79467(VarCurr)
    <=> v79469(VarCurr) ) ).

tff(addAssignment_49348,axiom,
    ! [VarCurr: state_type] :
      ( v79469(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_49347,axiom,
    ! [VarCurr: state_type] :
      ( v79463(VarCurr)
    <=> v79465(VarCurr) ) ).

tff(addAssignment_49346,axiom,
    ! [VarCurr: state_type] :
      ( v79465(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_49345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v77766(VarCurr,B)
      <=> v77768(VarCurr,B) ) ) ).

tff(addAssignment_49344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v77768(VarCurr,B)
      <=> v77770(VarCurr,B) ) ) ).

tff(addAssignment_49343,axiom,
    ! [VarCurr: state_type] :
      ( v77768(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_49342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v77770(VarCurr,B)
      <=> v79420(VarCurr,B) ) ) ).

tff(addAssignment_49341,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,0)
    <=> v79391(VarCurr) ) ).

tff(addAssignment_49340,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,1)
    <=> v79321(VarCurr) ) ).

tff(addAssignment_49339,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,2)
    <=> v79231(VarCurr) ) ).

tff(addAssignment_49338,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,3)
    <=> v79116(VarCurr) ) ).

tff(addAssignment_49337,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,4)
    <=> v79021(VarCurr) ) ).

tff(addAssignment_49336,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,5)
    <=> v78931(VarCurr) ) ).

tff(addAssignment_49335,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,6)
    <=> v78811(VarCurr) ) ).

tff(addAssignment_49334,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,7)
    <=> v78691(VarCurr) ) ).

tff(addAssignment_49333,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,8)
    <=> v78621(VarCurr) ) ).

tff(addAssignment_49332,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,9)
    <=> v78506(VarCurr) ) ).

tff(addAssignment_49331,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,10)
    <=> v78411(VarCurr) ) ).

tff(addAssignment_49330,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,11)
    <=> v78281(VarCurr) ) ).

tff(addAssignment_49329,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,12)
    <=> v78201(VarCurr) ) ).

tff(addAssignment_49328,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,13)
    <=> v78086(VarCurr) ) ).

tff(addAssignment_49327,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,14)
    <=> v77772(VarCurr) ) ).

tff(addAssignment_49326,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,15)
    <=> v79438(VarCurr) ) ).

tff(addAssignment_49325,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,16)
    <=> v79437(VarCurr) ) ).

tff(addAssignment_49324,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,17)
    <=> v79436(VarCurr) ) ).

tff(addAssignment_49323,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,18)
    <=> v79435(VarCurr) ) ).

tff(addAssignment_49322,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,19)
    <=> v79434(VarCurr) ) ).

tff(addAssignment_49321,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,20)
    <=> v79433(VarCurr) ) ).

tff(addAssignment_49320,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,21)
    <=> v79432(VarCurr) ) ).

tff(addAssignment_49319,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,22)
    <=> v79431(VarCurr) ) ).

tff(addAssignment_49318,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,23)
    <=> v79430(VarCurr) ) ).

tff(addAssignment_49317,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,24)
    <=> v79429(VarCurr) ) ).

tff(addAssignment_49316,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,25)
    <=> v79428(VarCurr) ) ).

tff(addAssignment_49315,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,26)
    <=> v79427(VarCurr) ) ).

tff(addAssignment_49314,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,27)
    <=> v79426(VarCurr) ) ).

tff(addAssignment_49313,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,28)
    <=> v79425(VarCurr) ) ).

tff(addAssignment_49312,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,29)
    <=> v79424(VarCurr) ) ).

tff(addAssignment_49311,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,30)
    <=> v79423(VarCurr) ) ).

tff(addAssignment_49310,axiom,
    ! [VarCurr: state_type] :
      ( v79420(VarCurr,31)
    <=> v79422(VarCurr) ) ).

tff(addAssignment_49309,axiom,
    ! [VarCurr: state_type] :
      ( ( v79420(VarCurr,35)
      <=> v79421(VarCurr,3) )
      & ( v79420(VarCurr,34)
      <=> v79421(VarCurr,2) )
      & ( v79420(VarCurr,33)
      <=> v79421(VarCurr,1) )
      & ( v79420(VarCurr,32)
      <=> v79421(VarCurr,0) ) ) ).

tff(addAssignment_49308,axiom,
    ! [VarCurr: state_type] :
      ( v79391(VarCurr)
    <=> v79393(VarCurr) ) ).

tff(addAssignment_49307,axiom,
    ! [VarCurr: state_type] :
      ( v79393(VarCurr)
    <=> v79395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7358,axiom,
    ! [VarCurr: state_type] :
      ( v79395(VarCurr)
    <=> ( v79397(VarCurr)
        & v79401(VarCurr) ) ) ).

tff(addAssignment_49306,axiom,
    ! [VarCurr: state_type] :
      ( v79401(VarCurr)
    <=> v79403(VarCurr) ) ).

tff(addAssignment_49305,axiom,
    ! [VarCurr: state_type] :
      ( v79403(VarCurr)
    <=> v79405(VarCurr) ) ).

tff(addAssignment_49304,axiom,
    ! [VarCurr: state_type] :
      ( v79405(VarCurr)
    <=> v79407(VarCurr) ) ).

tff(addAssignment_49303,axiom,
    ! [VarCurr: state_type] :
      ( v79407(VarCurr)
    <=> v79409(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_299,axiom,
    ! [VarCurr: state_type] :
      ( v79409(VarCurr)
    <=> ( ( v79411(VarCurr,3)
        <=> v79415(VarCurr,3) )
        & ( v79411(VarCurr,2)
        <=> v79415(VarCurr,2) )
        & ( v79411(VarCurr,1)
        <=> v79415(VarCurr,1) )
        & ( v79411(VarCurr,0)
        <=> v79415(VarCurr,0) ) ) ) ).

tff(addAssignment_49302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79415(VarCurr,B)
      <=> v79417(VarCurr,B) ) ) ).

tff(addAssignment_49301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79417(VarCurr,B)
      <=> v77058(VarCurr,B) ) ) ).

tff(addAssignment_49300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79411(VarCurr,B)
      <=> v79413(VarCurr,B) ) ) ).

tff(addAssignment_49299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79413(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49298,axiom,
    ! [VarCurr: state_type] :
      ( v79397(VarCurr)
    <=> v79399(VarCurr) ) ).

tff(addAssignment_49297,axiom,
    ! [VarCurr: state_type] :
      ( v79399(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49296,axiom,
    ! [VarCurr: state_type] :
      ( v79321(VarCurr)
    <=> v79323(VarCurr) ) ).

tff(addAssignment_49295,axiom,
    ! [VarCurr: state_type] :
      ( v79323(VarCurr)
    <=> v79325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7357,axiom,
    ! [VarCurr: state_type] :
      ( v79325(VarCurr)
    <=> ( v79327(VarCurr)
        & v79331(VarCurr) ) ) ).

tff(addAssignment_49294,axiom,
    ! [VarCurr: state_type] :
      ( v79331(VarCurr)
    <=> v79333(VarCurr) ) ).

tff(addAssignment_49293,axiom,
    ! [VarCurr: state_type] :
      ( v79333(VarCurr)
    <=> v79335(VarCurr) ) ).

tff(addAssignment_49292,axiom,
    ! [VarCurr: state_type] :
      ( v79335(VarCurr)
    <=> v79337(VarCurr) ) ).

tff(addAssignment_49291,axiom,
    ! [VarCurr: state_type] :
      ( v79337(VarCurr)
    <=> v79339(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_298,axiom,
    ! [VarCurr: state_type] :
      ( v79339(VarCurr)
    <=> ( ( v79341(VarCurr,3)
        <=> v79345(VarCurr,3) )
        & ( v79341(VarCurr,2)
        <=> v79345(VarCurr,2) )
        & ( v79341(VarCurr,1)
        <=> v79345(VarCurr,1) )
        & ( v79341(VarCurr,0)
        <=> v79345(VarCurr,0) ) ) ) ).

tff(addAssignment_49290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79345(VarCurr,B)
      <=> v79347(VarCurr,B) ) ) ).

tff(addAssignment_49289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79347(VarCurr,B)
      <=> v79349(VarCurr,B) ) ) ).

tff(addAssignment_49288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79349(VarCurr,B)
      <=> v77817(VarCurr,B) ) ) ).

tff(addAssignment_49287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49282,axiom,
    ! [VarCurr: state_type] :
      ( v78082(VarCurr,3)
    <=> v79352(VarCurr) ) ).

tff(addAssignment_49281,axiom,
    ! [VarCurr: state_type] :
      ( v78082(VarCurr,2)
    <=> v79360(VarCurr) ) ).

tff(addAssignment_49280,axiom,
    ! [VarCurr: state_type] :
      ( v78082(VarCurr,1)
    <=> v79368(VarCurr) ) ).

tff(addAssignment_49279,axiom,
    ! [VarCurr: state_type] :
      ( v78082(VarCurr,0)
    <=> v79381(VarCurr) ) ).

tff(addAssignment_49278,axiom,
    ! [VarCurr: state_type] :
      ( v79381(VarCurr)
    <=> v79383(VarCurr) ) ).

tff(addAssignment_49277,axiom,
    ! [VarCurr: state_type] :
      ( v79383(VarCurr)
    <=> v79385(VarCurr) ) ).

tff(addAssignment_49276,axiom,
    ! [VarCurr: state_type] :
      ( v79385(VarCurr)
    <=> v79387(VarCurr) ) ).

tff(addAssignment_49275,axiom,
    ! [VarCurr: state_type] :
      ( v79387(VarCurr)
    <=> v77837(VarCurr,7) ) ).

tff(addAssignment_49274,axiom,
    ! [VarCurr: state_type] :
      ( v79368(VarCurr)
    <=> v79370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7356,axiom,
    ! [VarCurr: state_type] :
      ( v79370(VarCurr)
    <=> ( v79372(VarCurr)
      <~> v79376(VarCurr) ) ) ).

tff(addAssignment_49273,axiom,
    ! [VarCurr: state_type] :
      ( v79376(VarCurr)
    <=> v79378(VarCurr) ) ).

tff(addAssignment_49272,axiom,
    ! [VarCurr: state_type] :
      ( v79378(VarCurr)
    <=> v77837(VarCurr,7) ) ).

tff(addAssignment_49271,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,7)
    <=> v77894(VarCurr,7) ) ).

tff(addAssignment_49270,axiom,
    ! [VarCurr: state_type] :
      ( v79372(VarCurr)
    <=> v79374(VarCurr) ) ).

tff(addAssignment_49269,axiom,
    ! [VarCurr: state_type] :
      ( v79374(VarCurr)
    <=> v77837(VarCurr,4) ) ).

tff(addAssignment_49268,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,4)
    <=> v77894(VarCurr,4) ) ).

tff(addAssignment_49267,axiom,
    ! [VarCurr: state_type] :
      ( v79360(VarCurr)
    <=> v79362(VarCurr) ) ).

tff(addAssignment_49266,axiom,
    ! [VarCurr: state_type] :
      ( v79362(VarCurr)
    <=> v79364(VarCurr) ) ).

tff(addAssignment_49265,axiom,
    ! [VarCurr: state_type] :
      ( v79364(VarCurr)
    <=> v79366(VarCurr) ) ).

tff(addAssignment_49264,axiom,
    ! [VarCurr: state_type] :
      ( v79366(VarCurr)
    <=> v77837(VarCurr,5) ) ).

tff(addAssignment_49263,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,5)
    <=> v77894(VarCurr,5) ) ).

tff(addAssignment_49262,axiom,
    ! [VarCurr: state_type] :
      ( v79352(VarCurr)
    <=> v79354(VarCurr) ) ).

tff(addAssignment_49261,axiom,
    ! [VarCurr: state_type] :
      ( v79354(VarCurr)
    <=> v79356(VarCurr) ) ).

tff(addAssignment_49260,axiom,
    ! [VarCurr: state_type] :
      ( v79356(VarCurr)
    <=> v79358(VarCurr) ) ).

tff(addAssignment_49259,axiom,
    ! [VarCurr: state_type] :
      ( v79358(VarCurr)
    <=> v77837(VarCurr,6) ) ).

tff(addAssignment_49258,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,6)
    <=> v77894(VarCurr,6) ) ).

tff(addAssignment_49257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79341(VarCurr,B)
      <=> v79343(VarCurr,B) ) ) ).

tff(addAssignment_49256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79343(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49255,axiom,
    ! [VarCurr: state_type] :
      ( v79327(VarCurr)
    <=> v79329(VarCurr) ) ).

tff(addAssignment_49254,axiom,
    ! [VarCurr: state_type] :
      ( v79329(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49253,axiom,
    ! [VarCurr: state_type] :
      ( v79231(VarCurr)
    <=> v79233(VarCurr) ) ).

tff(addAssignment_49252,axiom,
    ! [VarCurr: state_type] :
      ( v79233(VarCurr)
    <=> v79235(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7355,axiom,
    ! [VarCurr: state_type] :
      ( v79235(VarCurr)
    <=> ( v79237(VarCurr)
        & v79241(VarCurr) ) ) ).

tff(addAssignment_49251,axiom,
    ! [VarCurr: state_type] :
      ( v79241(VarCurr)
    <=> v79243(VarCurr) ) ).

tff(addAssignment_49250,axiom,
    ! [VarCurr: state_type] :
      ( v79243(VarCurr)
    <=> v79245(VarCurr) ) ).

tff(addAssignment_49249,axiom,
    ! [VarCurr: state_type] :
      ( v79245(VarCurr)
    <=> v79247(VarCurr) ) ).

tff(addAssignment_49248,axiom,
    ! [VarCurr: state_type] :
      ( v79247(VarCurr)
    <=> v79249(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_297,axiom,
    ! [VarCurr: state_type] :
      ( v79249(VarCurr)
    <=> ( ( v79251(VarCurr,3)
        <=> v79255(VarCurr,3) )
        & ( v79251(VarCurr,2)
        <=> v79255(VarCurr,2) )
        & ( v79251(VarCurr,1)
        <=> v79255(VarCurr,1) )
        & ( v79251(VarCurr,0)
        <=> v79255(VarCurr,0) ) ) ) ).

tff(addAssignment_49247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79255(VarCurr,B)
      <=> v79257(VarCurr,B) ) ) ).

tff(addAssignment_49246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79257(VarCurr,B)
      <=> v79259(VarCurr,B) ) ) ).

tff(addAssignment_49245,axiom,
    ! [VarCurr: state_type] :
      ( ( v79259(VarCurr,3)
      <=> v77817(VarCurr,7) )
      & ( v79259(VarCurr,2)
      <=> v77817(VarCurr,6) )
      & ( v79259(VarCurr,1)
      <=> v77817(VarCurr,5) )
      & ( v79259(VarCurr,0)
      <=> v77817(VarCurr,4) ) ) ).

tff(addAssignment_49244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49239,axiom,
    ! [VarCurr: state_type] :
      ( v78081(VarCurr,3)
    <=> v79262(VarCurr) ) ).

tff(addAssignment_49238,axiom,
    ! [VarCurr: state_type] :
      ( v78081(VarCurr,2)
    <=> v79275(VarCurr) ) ).

tff(addAssignment_49237,axiom,
    ! [VarCurr: state_type] :
      ( v78081(VarCurr,1)
    <=> v79288(VarCurr) ) ).

tff(addAssignment_49236,axiom,
    ! [VarCurr: state_type] :
      ( v78081(VarCurr,0)
    <=> v79306(VarCurr) ) ).

tff(addAssignment_49235,axiom,
    ! [VarCurr: state_type] :
      ( v79306(VarCurr)
    <=> v79308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7354,axiom,
    ! [VarCurr: state_type] :
      ( v79308(VarCurr)
    <=> ( v79310(VarCurr)
      <~> v79314(VarCurr) ) ) ).

tff(addAssignment_49234,axiom,
    ! [VarCurr: state_type] :
      ( v79314(VarCurr)
    <=> v79316(VarCurr) ) ).

tff(addAssignment_49233,axiom,
    ! [VarCurr: state_type] :
      ( v79316(VarCurr)
    <=> v77837(VarCurr,11) ) ).

tff(addAssignment_49232,axiom,
    ! [VarCurr: state_type] :
      ( v79310(VarCurr)
    <=> v79312(VarCurr) ) ).

tff(addAssignment_49231,axiom,
    ! [VarCurr: state_type] :
      ( v79312(VarCurr)
    <=> v77837(VarCurr,8) ) ).

tff(addAssignment_49230,axiom,
    ! [VarCurr: state_type] :
      ( v79288(VarCurr)
    <=> v79290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7353,axiom,
    ! [VarCurr: state_type] :
      ( v79290(VarCurr)
    <=> ( v79304(VarCurr)
      <~> v79300(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7352,axiom,
    ! [VarCurr: state_type] :
      ( v79304(VarCurr)
    <=> ( v79292(VarCurr)
      <~> v79296(VarCurr) ) ) ).

tff(addAssignment_49229,axiom,
    ! [VarCurr: state_type] :
      ( v79300(VarCurr)
    <=> v79302(VarCurr) ) ).

tff(addAssignment_49228,axiom,
    ! [VarCurr: state_type] :
      ( v79302(VarCurr)
    <=> v77837(VarCurr,9) ) ).

tff(addAssignment_49227,axiom,
    ! [VarCurr: state_type] :
      ( v79296(VarCurr)
    <=> v79298(VarCurr) ) ).

tff(addAssignment_49226,axiom,
    ! [VarCurr: state_type] :
      ( v79298(VarCurr)
    <=> v77837(VarCurr,11) ) ).

tff(addAssignment_49225,axiom,
    ! [VarCurr: state_type] :
      ( v79292(VarCurr)
    <=> v79294(VarCurr) ) ).

tff(addAssignment_49224,axiom,
    ! [VarCurr: state_type] :
      ( v79294(VarCurr)
    <=> v77837(VarCurr,8) ) ).

tff(addAssignment_49223,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,8)
    <=> v77894(VarCurr,8) ) ).

tff(addAssignment_49222,axiom,
    ! [VarCurr: state_type] :
      ( v79275(VarCurr)
    <=> v79277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7351,axiom,
    ! [VarCurr: state_type] :
      ( v79277(VarCurr)
    <=> ( v79279(VarCurr)
      <~> v79283(VarCurr) ) ) ).

tff(addAssignment_49221,axiom,
    ! [VarCurr: state_type] :
      ( v79283(VarCurr)
    <=> v79285(VarCurr) ) ).

tff(addAssignment_49220,axiom,
    ! [VarCurr: state_type] :
      ( v79285(VarCurr)
    <=> v77837(VarCurr,10) ) ).

tff(addAssignment_49219,axiom,
    ! [VarCurr: state_type] :
      ( v79279(VarCurr)
    <=> v79281(VarCurr) ) ).

tff(addAssignment_49218,axiom,
    ! [VarCurr: state_type] :
      ( v79281(VarCurr)
    <=> v77837(VarCurr,9) ) ).

tff(addAssignment_49217,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,9)
    <=> v77894(VarCurr,9) ) ).

tff(addAssignment_49216,axiom,
    ! [VarCurr: state_type] :
      ( v79262(VarCurr)
    <=> v79264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7350,axiom,
    ! [VarCurr: state_type] :
      ( v79264(VarCurr)
    <=> ( v79266(VarCurr)
      <~> v79270(VarCurr) ) ) ).

tff(addAssignment_49215,axiom,
    ! [VarCurr: state_type] :
      ( v79270(VarCurr)
    <=> v79272(VarCurr) ) ).

tff(addAssignment_49214,axiom,
    ! [VarCurr: state_type] :
      ( v79272(VarCurr)
    <=> v77837(VarCurr,11) ) ).

tff(addAssignment_49213,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,11)
    <=> v77894(VarCurr,11) ) ).

tff(addAssignment_49212,axiom,
    ! [VarCurr: state_type] :
      ( v79266(VarCurr)
    <=> v79268(VarCurr) ) ).

tff(addAssignment_49211,axiom,
    ! [VarCurr: state_type] :
      ( v79268(VarCurr)
    <=> v77837(VarCurr,10) ) ).

tff(addAssignment_49210,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,10)
    <=> v77894(VarCurr,10) ) ).

tff(addAssignment_49209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79251(VarCurr,B)
      <=> v79253(VarCurr,B) ) ) ).

tff(addAssignment_49208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79253(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49207,axiom,
    ! [VarCurr: state_type] :
      ( v79237(VarCurr)
    <=> v79239(VarCurr) ) ).

tff(addAssignment_49206,axiom,
    ! [VarCurr: state_type] :
      ( v79239(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49205,axiom,
    ! [VarCurr: state_type] :
      ( v79116(VarCurr)
    <=> v79118(VarCurr) ) ).

tff(addAssignment_49204,axiom,
    ! [VarCurr: state_type] :
      ( v79118(VarCurr)
    <=> v79120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7349,axiom,
    ! [VarCurr: state_type] :
      ( v79120(VarCurr)
    <=> ( v79122(VarCurr)
        & v79126(VarCurr) ) ) ).

tff(addAssignment_49203,axiom,
    ! [VarCurr: state_type] :
      ( v79126(VarCurr)
    <=> v79128(VarCurr) ) ).

tff(addAssignment_49202,axiom,
    ! [VarCurr: state_type] :
      ( v79128(VarCurr)
    <=> v79130(VarCurr) ) ).

tff(addAssignment_49201,axiom,
    ! [VarCurr: state_type] :
      ( v79130(VarCurr)
    <=> v79132(VarCurr) ) ).

tff(addAssignment_49200,axiom,
    ! [VarCurr: state_type] :
      ( v79132(VarCurr)
    <=> v79134(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_296,axiom,
    ! [VarCurr: state_type] :
      ( v79134(VarCurr)
    <=> ( ( v79136(VarCurr,3)
        <=> v79140(VarCurr,3) )
        & ( v79136(VarCurr,2)
        <=> v79140(VarCurr,2) )
        & ( v79136(VarCurr,1)
        <=> v79140(VarCurr,1) )
        & ( v79136(VarCurr,0)
        <=> v79140(VarCurr,0) ) ) ) ).

tff(addAssignment_49199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79140(VarCurr,B)
      <=> v79142(VarCurr,B) ) ) ).

tff(addAssignment_49198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79142(VarCurr,B)
      <=> v79144(VarCurr,B) ) ) ).

tff(addAssignment_49197,axiom,
    ! [VarCurr: state_type] :
      ( ( v79144(VarCurr,3)
      <=> v77817(VarCurr,11) )
      & ( v79144(VarCurr,2)
      <=> v77817(VarCurr,10) )
      & ( v79144(VarCurr,1)
      <=> v77817(VarCurr,9) )
      & ( v79144(VarCurr,0)
      <=> v77817(VarCurr,8) ) ) ).

tff(addAssignment_49196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49191,axiom,
    ! [VarCurr: state_type] :
      ( v78080(VarCurr,3)
    <=> v79147(VarCurr) ) ).

tff(addAssignment_49190,axiom,
    ! [VarCurr: state_type] :
      ( v78080(VarCurr,2)
    <=> v79165(VarCurr) ) ).

tff(addAssignment_49189,axiom,
    ! [VarCurr: state_type] :
      ( v78080(VarCurr,1)
    <=> v79198(VarCurr) ) ).

tff(addAssignment_49188,axiom,
    ! [VarCurr: state_type] :
      ( v78080(VarCurr,0)
    <=> v79221(VarCurr) ) ).

tff(addAssignment_49187,axiom,
    ! [VarCurr: state_type] :
      ( v79221(VarCurr)
    <=> v79223(VarCurr) ) ).

tff(addAssignment_49186,axiom,
    ! [VarCurr: state_type] :
      ( v79223(VarCurr)
    <=> v79225(VarCurr) ) ).

tff(addAssignment_49185,axiom,
    ! [VarCurr: state_type] :
      ( v79225(VarCurr)
    <=> v79227(VarCurr) ) ).

tff(addAssignment_49184,axiom,
    ! [VarCurr: state_type] :
      ( v79227(VarCurr)
    <=> v77837(VarCurr,14) ) ).

tff(addAssignment_49183,axiom,
    ! [VarCurr: state_type] :
      ( v79198(VarCurr)
    <=> v79200(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7348,axiom,
    ! [VarCurr: state_type] :
      ( v79200(VarCurr)
    <=> ( v79202(VarCurr)
      <~> v79206(VarCurr) ) ) ).

tff(addAssignment_49182,axiom,
    ! [VarCurr: state_type] :
      ( v79206(VarCurr)
    <=> v79208(VarCurr) ) ).

tff(addAssignment_49181,axiom,
    ! [VarCurr: state_type] :
      ( v79208(VarCurr)
    <=> v77837(VarCurr,14) ) ).

tff(addAssignment_49180,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,14)
    <=> v77894(VarCurr,14) ) ).

tff(addAssignment_49179,axiom,
    ! [VarCurr: state_type] :
      ( v77939(VarCurr)
    <=> v79211(VarCurr) ) ).

tff(addAssignment_49178,axiom,
    ! [VarCurr: state_type] :
      ( v79211(VarCurr)
    <=> v79213(VarCurr) ) ).

tff(writeUnaryOperator_3513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79213(VarCurr)
    <=> v79215(VarCurr) ) ).

tff(addAssignment_49177,axiom,
    ! [VarCurr: state_type] :
      ( v79215(VarCurr)
    <=> v79217(VarCurr) ) ).

tff(addAssignment_49176,axiom,
    ! [VarCurr: state_type] :
      ( v79217(VarCurr)
    <=> v77981(VarCurr) ) ).

tff(addAssignment_49175,axiom,
    ! [VarCurr: state_type] :
      ( v79202(VarCurr)
    <=> v79204(VarCurr) ) ).

tff(addAssignment_49174,axiom,
    ! [VarCurr: state_type] :
      ( v79204(VarCurr)
    <=> v77837(VarCurr,15) ) ).

tff(addAssignment_49173,axiom,
    ! [VarCurr: state_type] :
      ( v79165(VarCurr)
    <=> v79167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7347,axiom,
    ! [VarCurr: state_type] :
      ( v79167(VarCurr)
    <=> ( v79169(VarCurr)
      <~> v79183(VarCurr) ) ) ).

tff(addAssignment_49172,axiom,
    ! [VarCurr: state_type] :
      ( v79183(VarCurr)
    <=> v79185(VarCurr) ) ).

tff(addAssignment_49171,axiom,
    ! [VarCurr: state_type] :
      ( v79185(VarCurr)
    <=> v77837(VarCurr,15) ) ).

tff(addAssignment_49170,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,15)
    <=> v77894(VarCurr,15) ) ).

tff(addAssignment_49169,axiom,
    ! [VarCurr: state_type] :
      ( v77938(VarCurr)
    <=> v79188(VarCurr) ) ).

tff(addAssignment_49168,axiom,
    ! [VarCurr: state_type] :
      ( v79188(VarCurr)
    <=> v79190(VarCurr) ) ).

tff(writeUnaryOperator_3512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79190(VarCurr)
    <=> v79192(VarCurr) ) ).

tff(addAssignment_49167,axiom,
    ! [VarCurr: state_type] :
      ( v79192(VarCurr)
    <=> v79194(VarCurr) ) ).

tff(addAssignment_49166,axiom,
    ! [VarCurr: state_type] :
      ( v79194(VarCurr)
    <=> v78057(VarCurr) ) ).

tff(addAssignment_49165,axiom,
    ! [VarCurr: state_type] :
      ( v79169(VarCurr)
    <=> v79171(VarCurr) ) ).

tff(addAssignment_49164,axiom,
    ! [VarCurr: state_type] :
      ( v79171(VarCurr)
    <=> v77837(VarCurr,12) ) ).

tff(addAssignment_49163,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,12)
    <=> v77894(VarCurr,12) ) ).

tff(addAssignment_49162,axiom,
    ! [VarCurr: state_type] :
      ( v77941(VarCurr)
    <=> v79174(VarCurr) ) ).

tff(addAssignment_49161,axiom,
    ! [VarCurr: state_type] :
      ( v79174(VarCurr)
    <=> v79176(VarCurr) ) ).

tff(writeUnaryOperator_3511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79176(VarCurr)
    <=> v79178(VarCurr) ) ).

tff(addAssignment_49160,axiom,
    ! [VarCurr: state_type] :
      ( v79178(VarCurr)
    <=> v79180(VarCurr) ) ).

tff(addAssignment_49159,axiom,
    ! [VarCurr: state_type] :
      ( v79180(VarCurr)
    <=> v77849(VarCurr) ) ).

tff(addAssignment_49158,axiom,
    ! [VarCurr: state_type] :
      ( v79147(VarCurr)
    <=> v79149(VarCurr) ) ).

tff(addAssignment_49157,axiom,
    ! [VarCurr: state_type] :
      ( v79149(VarCurr)
    <=> v79151(VarCurr) ) ).

tff(addAssignment_49156,axiom,
    ! [VarCurr: state_type] :
      ( v79151(VarCurr)
    <=> v79153(VarCurr) ) ).

tff(addAssignment_49155,axiom,
    ! [VarCurr: state_type] :
      ( v79153(VarCurr)
    <=> v77837(VarCurr,13) ) ).

tff(addAssignment_49154,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,13)
    <=> v77894(VarCurr,13) ) ).

tff(addAssignment_49153,axiom,
    ! [VarCurr: state_type] :
      ( v77940(VarCurr)
    <=> v79156(VarCurr) ) ).

tff(addAssignment_49152,axiom,
    ! [VarCurr: state_type] :
      ( v79156(VarCurr)
    <=> v79158(VarCurr) ) ).

tff(writeUnaryOperator_3510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v79158(VarCurr)
    <=> v79160(VarCurr) ) ).

tff(addAssignment_49151,axiom,
    ! [VarCurr: state_type] :
      ( v79160(VarCurr)
    <=> v79162(VarCurr) ) ).

tff(addAssignment_49150,axiom,
    ! [VarCurr: state_type] :
      ( v79162(VarCurr)
    <=> v77956(VarCurr) ) ).

tff(addAssignment_49149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79136(VarCurr,B)
      <=> v79138(VarCurr,B) ) ) ).

tff(addAssignment_49148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79138(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49147,axiom,
    ! [VarCurr: state_type] :
      ( v79122(VarCurr)
    <=> v79124(VarCurr) ) ).

tff(addAssignment_49146,axiom,
    ! [VarCurr: state_type] :
      ( v79124(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49145,axiom,
    ! [VarCurr: state_type] :
      ( v79021(VarCurr)
    <=> v79023(VarCurr) ) ).

tff(addAssignment_49144,axiom,
    ! [VarCurr: state_type] :
      ( v79023(VarCurr)
    <=> v79025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7346,axiom,
    ! [VarCurr: state_type] :
      ( v79025(VarCurr)
    <=> ( v79027(VarCurr)
        & v79031(VarCurr) ) ) ).

tff(addAssignment_49143,axiom,
    ! [VarCurr: state_type] :
      ( v79031(VarCurr)
    <=> v79033(VarCurr) ) ).

tff(addAssignment_49142,axiom,
    ! [VarCurr: state_type] :
      ( v79033(VarCurr)
    <=> v79035(VarCurr) ) ).

tff(addAssignment_49141,axiom,
    ! [VarCurr: state_type] :
      ( v79035(VarCurr)
    <=> v79037(VarCurr) ) ).

tff(addAssignment_49140,axiom,
    ! [VarCurr: state_type] :
      ( v79037(VarCurr)
    <=> v79039(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_295,axiom,
    ! [VarCurr: state_type] :
      ( v79039(VarCurr)
    <=> ( ( v79041(VarCurr,3)
        <=> v79045(VarCurr,3) )
        & ( v79041(VarCurr,2)
        <=> v79045(VarCurr,2) )
        & ( v79041(VarCurr,1)
        <=> v79045(VarCurr,1) )
        & ( v79041(VarCurr,0)
        <=> v79045(VarCurr,0) ) ) ) ).

tff(addAssignment_49139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79045(VarCurr,B)
      <=> v79047(VarCurr,B) ) ) ).

tff(addAssignment_49138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79047(VarCurr,B)
      <=> v79049(VarCurr,B) ) ) ).

tff(addAssignment_49137,axiom,
    ! [VarCurr: state_type] :
      ( ( v79049(VarCurr,3)
      <=> v77817(VarCurr,15) )
      & ( v79049(VarCurr,2)
      <=> v77817(VarCurr,14) )
      & ( v79049(VarCurr,1)
      <=> v77817(VarCurr,13) )
      & ( v79049(VarCurr,0)
      <=> v77817(VarCurr,12) ) ) ).

tff(addAssignment_49136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49131,axiom,
    ! [VarCurr: state_type] :
      ( v78079(VarCurr,3)
    <=> v79052(VarCurr) ) ).

tff(addAssignment_49130,axiom,
    ! [VarCurr: state_type] :
      ( v78079(VarCurr,2)
    <=> v79065(VarCurr) ) ).

tff(addAssignment_49129,axiom,
    ! [VarCurr: state_type] :
      ( v78079(VarCurr,1)
    <=> v79083(VarCurr) ) ).

tff(addAssignment_49128,axiom,
    ! [VarCurr: state_type] :
      ( v78079(VarCurr,0)
    <=> v79101(VarCurr) ) ).

tff(addAssignment_49127,axiom,
    ! [VarCurr: state_type] :
      ( v79101(VarCurr)
    <=> v79103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7345,axiom,
    ! [VarCurr: state_type] :
      ( v79103(VarCurr)
    <=> ( v79105(VarCurr)
      <~> v79109(VarCurr) ) ) ).

tff(addAssignment_49126,axiom,
    ! [VarCurr: state_type] :
      ( v79109(VarCurr)
    <=> v79111(VarCurr) ) ).

tff(addAssignment_49125,axiom,
    ! [VarCurr: state_type] :
      ( v79111(VarCurr)
    <=> v77837(VarCurr,18) ) ).

tff(addAssignment_49124,axiom,
    ! [VarCurr: state_type] :
      ( v79105(VarCurr)
    <=> v79107(VarCurr) ) ).

tff(addAssignment_49123,axiom,
    ! [VarCurr: state_type] :
      ( v79107(VarCurr)
    <=> v77837(VarCurr,16) ) ).

tff(addAssignment_49122,axiom,
    ! [VarCurr: state_type] :
      ( v79083(VarCurr)
    <=> v79085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7344,axiom,
    ! [VarCurr: state_type] :
      ( v79085(VarCurr)
    <=> ( v79099(VarCurr)
      <~> v79095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7343,axiom,
    ! [VarCurr: state_type] :
      ( v79099(VarCurr)
    <=> ( v79087(VarCurr)
      <~> v79091(VarCurr) ) ) ).

tff(addAssignment_49121,axiom,
    ! [VarCurr: state_type] :
      ( v79095(VarCurr)
    <=> v79097(VarCurr) ) ).

tff(addAssignment_49120,axiom,
    ! [VarCurr: state_type] :
      ( v79097(VarCurr)
    <=> v77837(VarCurr,19) ) ).

tff(addAssignment_49119,axiom,
    ! [VarCurr: state_type] :
      ( v79091(VarCurr)
    <=> v79093(VarCurr) ) ).

tff(addAssignment_49118,axiom,
    ! [VarCurr: state_type] :
      ( v79093(VarCurr)
    <=> v77837(VarCurr,18) ) ).

tff(addAssignment_49117,axiom,
    ! [VarCurr: state_type] :
      ( v79087(VarCurr)
    <=> v79089(VarCurr) ) ).

tff(addAssignment_49116,axiom,
    ! [VarCurr: state_type] :
      ( v79089(VarCurr)
    <=> v77837(VarCurr,17) ) ).

tff(addAssignment_49115,axiom,
    ! [VarCurr: state_type] :
      ( v79065(VarCurr)
    <=> v79067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7342,axiom,
    ! [VarCurr: state_type] :
      ( v79067(VarCurr)
    <=> ( v79081(VarCurr)
      <~> v79077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7341,axiom,
    ! [VarCurr: state_type] :
      ( v79081(VarCurr)
    <=> ( v79069(VarCurr)
      <~> v79073(VarCurr) ) ) ).

tff(addAssignment_49114,axiom,
    ! [VarCurr: state_type] :
      ( v79077(VarCurr)
    <=> v79079(VarCurr) ) ).

tff(addAssignment_49113,axiom,
    ! [VarCurr: state_type] :
      ( v79079(VarCurr)
    <=> v77837(VarCurr,19) ) ).

tff(addAssignment_49112,axiom,
    ! [VarCurr: state_type] :
      ( v79073(VarCurr)
    <=> v79075(VarCurr) ) ).

tff(addAssignment_49111,axiom,
    ! [VarCurr: state_type] :
      ( v79075(VarCurr)
    <=> v77837(VarCurr,18) ) ).

tff(addAssignment_49110,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,18)
    <=> v77894(VarCurr,18) ) ).

tff(addAssignment_49109,axiom,
    ! [VarCurr: state_type] :
      ( v79069(VarCurr)
    <=> v79071(VarCurr) ) ).

tff(addAssignment_49108,axiom,
    ! [VarCurr: state_type] :
      ( v79071(VarCurr)
    <=> v77837(VarCurr,16) ) ).

tff(addAssignment_49107,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,16)
    <=> v77894(VarCurr,16) ) ).

tff(addAssignment_49106,axiom,
    ! [VarCurr: state_type] :
      ( v79052(VarCurr)
    <=> v79054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7340,axiom,
    ! [VarCurr: state_type] :
      ( v79054(VarCurr)
    <=> ( v79056(VarCurr)
      <~> v79060(VarCurr) ) ) ).

tff(addAssignment_49105,axiom,
    ! [VarCurr: state_type] :
      ( v79060(VarCurr)
    <=> v79062(VarCurr) ) ).

tff(addAssignment_49104,axiom,
    ! [VarCurr: state_type] :
      ( v79062(VarCurr)
    <=> v77837(VarCurr,19) ) ).

tff(addAssignment_49103,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,19)
    <=> v77894(VarCurr,19) ) ).

tff(addAssignment_49102,axiom,
    ! [VarCurr: state_type] :
      ( v79056(VarCurr)
    <=> v79058(VarCurr) ) ).

tff(addAssignment_49101,axiom,
    ! [VarCurr: state_type] :
      ( v79058(VarCurr)
    <=> v77837(VarCurr,17) ) ).

tff(addAssignment_49100,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,17)
    <=> v77894(VarCurr,17) ) ).

tff(addAssignment_49099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79041(VarCurr,B)
      <=> v79043(VarCurr,B) ) ) ).

tff(addAssignment_49098,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v79043(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49097,axiom,
    ! [VarCurr: state_type] :
      ( v79027(VarCurr)
    <=> v79029(VarCurr) ) ).

tff(addAssignment_49096,axiom,
    ! [VarCurr: state_type] :
      ( v79029(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49095,axiom,
    ! [VarCurr: state_type] :
      ( v78931(VarCurr)
    <=> v78933(VarCurr) ) ).

tff(addAssignment_49094,axiom,
    ! [VarCurr: state_type] :
      ( v78933(VarCurr)
    <=> v78935(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7339,axiom,
    ! [VarCurr: state_type] :
      ( v78935(VarCurr)
    <=> ( v78937(VarCurr)
        & v78941(VarCurr) ) ) ).

tff(addAssignment_49093,axiom,
    ! [VarCurr: state_type] :
      ( v78941(VarCurr)
    <=> v78943(VarCurr) ) ).

tff(addAssignment_49092,axiom,
    ! [VarCurr: state_type] :
      ( v78943(VarCurr)
    <=> v78945(VarCurr) ) ).

tff(addAssignment_49091,axiom,
    ! [VarCurr: state_type] :
      ( v78945(VarCurr)
    <=> v78947(VarCurr) ) ).

tff(addAssignment_49090,axiom,
    ! [VarCurr: state_type] :
      ( v78947(VarCurr)
    <=> v78949(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_294,axiom,
    ! [VarCurr: state_type] :
      ( v78949(VarCurr)
    <=> ( ( v78951(VarCurr,3)
        <=> v78955(VarCurr,3) )
        & ( v78951(VarCurr,2)
        <=> v78955(VarCurr,2) )
        & ( v78951(VarCurr,1)
        <=> v78955(VarCurr,1) )
        & ( v78951(VarCurr,0)
        <=> v78955(VarCurr,0) ) ) ) ).

tff(addAssignment_49089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78955(VarCurr,B)
      <=> v78957(VarCurr,B) ) ) ).

tff(addAssignment_49088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78957(VarCurr,B)
      <=> v78959(VarCurr,B) ) ) ).

tff(addAssignment_49087,axiom,
    ! [VarCurr: state_type] :
      ( ( v78959(VarCurr,3)
      <=> v77817(VarCurr,19) )
      & ( v78959(VarCurr,2)
      <=> v77817(VarCurr,18) )
      & ( v78959(VarCurr,1)
      <=> v77817(VarCurr,17) )
      & ( v78959(VarCurr,0)
      <=> v77817(VarCurr,16) ) ) ).

tff(addAssignment_49086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49081,axiom,
    ! [VarCurr: state_type] :
      ( v78078(VarCurr,3)
    <=> v78962(VarCurr) ) ).

tff(addAssignment_49080,axiom,
    ! [VarCurr: state_type] :
      ( v78078(VarCurr,2)
    <=> v78975(VarCurr) ) ).

tff(addAssignment_49079,axiom,
    ! [VarCurr: state_type] :
      ( v78078(VarCurr,1)
    <=> v78993(VarCurr) ) ).

tff(addAssignment_49078,axiom,
    ! [VarCurr: state_type] :
      ( v78078(VarCurr,0)
    <=> v79006(VarCurr) ) ).

tff(addAssignment_49077,axiom,
    ! [VarCurr: state_type] :
      ( v79006(VarCurr)
    <=> v79008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7338,axiom,
    ! [VarCurr: state_type] :
      ( v79008(VarCurr)
    <=> ( v79010(VarCurr)
      <~> v79014(VarCurr) ) ) ).

tff(addAssignment_49076,axiom,
    ! [VarCurr: state_type] :
      ( v79014(VarCurr)
    <=> v79016(VarCurr) ) ).

tff(addAssignment_49075,axiom,
    ! [VarCurr: state_type] :
      ( v79016(VarCurr)
    <=> v77837(VarCurr,23) ) ).

tff(addAssignment_49074,axiom,
    ! [VarCurr: state_type] :
      ( v79010(VarCurr)
    <=> v79012(VarCurr) ) ).

tff(addAssignment_49073,axiom,
    ! [VarCurr: state_type] :
      ( v79012(VarCurr)
    <=> v77837(VarCurr,22) ) ).

tff(addAssignment_49072,axiom,
    ! [VarCurr: state_type] :
      ( v78993(VarCurr)
    <=> v78995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7337,axiom,
    ! [VarCurr: state_type] :
      ( v78995(VarCurr)
    <=> ( v78997(VarCurr)
      <~> v79001(VarCurr) ) ) ).

tff(addAssignment_49071,axiom,
    ! [VarCurr: state_type] :
      ( v79001(VarCurr)
    <=> v79003(VarCurr) ) ).

tff(addAssignment_49070,axiom,
    ! [VarCurr: state_type] :
      ( v79003(VarCurr)
    <=> v77837(VarCurr,22) ) ).

tff(addAssignment_49069,axiom,
    ! [VarCurr: state_type] :
      ( v78997(VarCurr)
    <=> v78999(VarCurr) ) ).

tff(addAssignment_49068,axiom,
    ! [VarCurr: state_type] :
      ( v78999(VarCurr)
    <=> v77837(VarCurr,20) ) ).

tff(addAssignment_49067,axiom,
    ! [VarCurr: state_type] :
      ( v78975(VarCurr)
    <=> v78977(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7336,axiom,
    ! [VarCurr: state_type] :
      ( v78977(VarCurr)
    <=> ( v78991(VarCurr)
      <~> v78987(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7335,axiom,
    ! [VarCurr: state_type] :
      ( v78991(VarCurr)
    <=> ( v78979(VarCurr)
      <~> v78983(VarCurr) ) ) ).

tff(addAssignment_49066,axiom,
    ! [VarCurr: state_type] :
      ( v78987(VarCurr)
    <=> v78989(VarCurr) ) ).

tff(addAssignment_49065,axiom,
    ! [VarCurr: state_type] :
      ( v78989(VarCurr)
    <=> v77837(VarCurr,23) ) ).

tff(addAssignment_49064,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,23)
    <=> v77894(VarCurr,23) ) ).

tff(addAssignment_49063,axiom,
    ! [VarCurr: state_type] :
      ( v78983(VarCurr)
    <=> v78985(VarCurr) ) ).

tff(addAssignment_49062,axiom,
    ! [VarCurr: state_type] :
      ( v78985(VarCurr)
    <=> v77837(VarCurr,21) ) ).

tff(addAssignment_49061,axiom,
    ! [VarCurr: state_type] :
      ( v78979(VarCurr)
    <=> v78981(VarCurr) ) ).

tff(addAssignment_49060,axiom,
    ! [VarCurr: state_type] :
      ( v78981(VarCurr)
    <=> v77837(VarCurr,20) ) ).

tff(addAssignment_49059,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,20)
    <=> v77894(VarCurr,20) ) ).

tff(addAssignment_49058,axiom,
    ! [VarCurr: state_type] :
      ( v78962(VarCurr)
    <=> v78964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7334,axiom,
    ! [VarCurr: state_type] :
      ( v78964(VarCurr)
    <=> ( v78966(VarCurr)
      <~> v78970(VarCurr) ) ) ).

tff(addAssignment_49057,axiom,
    ! [VarCurr: state_type] :
      ( v78970(VarCurr)
    <=> v78972(VarCurr) ) ).

tff(addAssignment_49056,axiom,
    ! [VarCurr: state_type] :
      ( v78972(VarCurr)
    <=> v77837(VarCurr,22) ) ).

tff(addAssignment_49055,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,22)
    <=> v77894(VarCurr,22) ) ).

tff(addAssignment_49054,axiom,
    ! [VarCurr: state_type] :
      ( v78966(VarCurr)
    <=> v78968(VarCurr) ) ).

tff(addAssignment_49053,axiom,
    ! [VarCurr: state_type] :
      ( v78968(VarCurr)
    <=> v77837(VarCurr,21) ) ).

tff(addAssignment_49052,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,21)
    <=> v77894(VarCurr,21) ) ).

tff(addAssignment_49051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78951(VarCurr,B)
      <=> v78953(VarCurr,B) ) ) ).

tff(addAssignment_49050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78953(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_49049,axiom,
    ! [VarCurr: state_type] :
      ( v78937(VarCurr)
    <=> v78939(VarCurr) ) ).

tff(addAssignment_49048,axiom,
    ! [VarCurr: state_type] :
      ( v78939(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_49047,axiom,
    ! [VarCurr: state_type] :
      ( v78811(VarCurr)
    <=> v78813(VarCurr) ) ).

tff(addAssignment_49046,axiom,
    ! [VarCurr: state_type] :
      ( v78813(VarCurr)
    <=> v78815(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7333,axiom,
    ! [VarCurr: state_type] :
      ( v78815(VarCurr)
    <=> ( v78817(VarCurr)
        & v78821(VarCurr) ) ) ).

tff(addAssignment_49045,axiom,
    ! [VarCurr: state_type] :
      ( v78821(VarCurr)
    <=> v78823(VarCurr) ) ).

tff(addAssignment_49044,axiom,
    ! [VarCurr: state_type] :
      ( v78823(VarCurr)
    <=> v78825(VarCurr) ) ).

tff(addAssignment_49043,axiom,
    ! [VarCurr: state_type] :
      ( v78825(VarCurr)
    <=> v78827(VarCurr) ) ).

tff(addAssignment_49042,axiom,
    ! [VarCurr: state_type] :
      ( v78827(VarCurr)
    <=> v78829(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_293,axiom,
    ! [VarCurr: state_type] :
      ( v78829(VarCurr)
    <=> ( ( v78831(VarCurr,3)
        <=> v78835(VarCurr,3) )
        & ( v78831(VarCurr,2)
        <=> v78835(VarCurr,2) )
        & ( v78831(VarCurr,1)
        <=> v78835(VarCurr,1) )
        & ( v78831(VarCurr,0)
        <=> v78835(VarCurr,0) ) ) ) ).

tff(addAssignment_49041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78835(VarCurr,B)
      <=> v78837(VarCurr,B) ) ) ).

tff(addAssignment_49040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78837(VarCurr,B)
      <=> v78839(VarCurr,B) ) ) ).

tff(addAssignment_49039,axiom,
    ! [VarCurr: state_type] :
      ( ( v78839(VarCurr,3)
      <=> v77817(VarCurr,23) )
      & ( v78839(VarCurr,2)
      <=> v77817(VarCurr,22) )
      & ( v78839(VarCurr,1)
      <=> v77817(VarCurr,21) )
      & ( v78839(VarCurr,0)
      <=> v77817(VarCurr,20) ) ) ).

tff(addAssignment_49038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_49037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_49036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_49035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_49034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_49033,axiom,
    ! [VarCurr: state_type] :
      ( v78077(VarCurr,3)
    <=> v78842(VarCurr) ) ).

tff(addAssignment_49032,axiom,
    ! [VarCurr: state_type] :
      ( v78077(VarCurr,2)
    <=> v78860(VarCurr) ) ).

tff(addAssignment_49031,axiom,
    ! [VarCurr: state_type] :
      ( v78077(VarCurr,1)
    <=> v78893(VarCurr) ) ).

tff(addAssignment_49030,axiom,
    ! [VarCurr: state_type] :
      ( v78077(VarCurr,0)
    <=> v78911(VarCurr) ) ).

tff(addAssignment_49029,axiom,
    ! [VarCurr: state_type] :
      ( v78911(VarCurr)
    <=> v78913(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7332,axiom,
    ! [VarCurr: state_type] :
      ( v78913(VarCurr)
    <=> ( v78927(VarCurr)
      <~> v78923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7331,axiom,
    ! [VarCurr: state_type] :
      ( v78927(VarCurr)
    <=> ( v78915(VarCurr)
      <~> v78919(VarCurr) ) ) ).

tff(addAssignment_49028,axiom,
    ! [VarCurr: state_type] :
      ( v78923(VarCurr)
    <=> v78925(VarCurr) ) ).

tff(addAssignment_49027,axiom,
    ! [VarCurr: state_type] :
      ( v78925(VarCurr)
    <=> v77837(VarCurr,27) ) ).

tff(addAssignment_49026,axiom,
    ! [VarCurr: state_type] :
      ( v78919(VarCurr)
    <=> v78921(VarCurr) ) ).

tff(addAssignment_49025,axiom,
    ! [VarCurr: state_type] :
      ( v78921(VarCurr)
    <=> v77837(VarCurr,26) ) ).

tff(addAssignment_49024,axiom,
    ! [VarCurr: state_type] :
      ( v78915(VarCurr)
    <=> v78917(VarCurr) ) ).

tff(addAssignment_49023,axiom,
    ! [VarCurr: state_type] :
      ( v78917(VarCurr)
    <=> v77837(VarCurr,24) ) ).

tff(addAssignment_49022,axiom,
    ! [VarCurr: state_type] :
      ( v78893(VarCurr)
    <=> v78895(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7330,axiom,
    ! [VarCurr: state_type] :
      ( v78895(VarCurr)
    <=> ( v78909(VarCurr)
      <~> v78905(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7329,axiom,
    ! [VarCurr: state_type] :
      ( v78909(VarCurr)
    <=> ( v78897(VarCurr)
      <~> v78901(VarCurr) ) ) ).

tff(addAssignment_49021,axiom,
    ! [VarCurr: state_type] :
      ( v78905(VarCurr)
    <=> v78907(VarCurr) ) ).

tff(addAssignment_49020,axiom,
    ! [VarCurr: state_type] :
      ( v78907(VarCurr)
    <=> v77837(VarCurr,26) ) ).

tff(addAssignment_49019,axiom,
    ! [VarCurr: state_type] :
      ( v78901(VarCurr)
    <=> v78903(VarCurr) ) ).

tff(addAssignment_49018,axiom,
    ! [VarCurr: state_type] :
      ( v78903(VarCurr)
    <=> v77837(VarCurr,25) ) ).

tff(addAssignment_49017,axiom,
    ! [VarCurr: state_type] :
      ( v78897(VarCurr)
    <=> v78899(VarCurr) ) ).

tff(addAssignment_49016,axiom,
    ! [VarCurr: state_type] :
      ( v78899(VarCurr)
    <=> v77837(VarCurr,24) ) ).

tff(addAssignment_49015,axiom,
    ! [VarCurr: state_type] :
      ( v78860(VarCurr)
    <=> v78862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7328,axiom,
    ! [VarCurr: state_type] :
      ( v78862(VarCurr)
    <=> ( v78864(VarCurr)
      <~> v78888(VarCurr) ) ) ).

tff(addAssignment_49014,axiom,
    ! [VarCurr: state_type] :
      ( v78888(VarCurr)
    <=> v78890(VarCurr) ) ).

tff(addAssignment_49013,axiom,
    ! [VarCurr: state_type] :
      ( v78890(VarCurr)
    <=> v77837(VarCurr,27) ) ).

tff(addAssignment_49012,axiom,
    ! [VarCurr: state_type] :
      ( v78864(VarCurr)
    <=> v78866(VarCurr) ) ).

tff(addAssignment_49011,axiom,
    ! [VarCurr: state_type] :
      ( v78866(VarCurr)
    <=> v78868(VarCurr) ) ).

tff(addAssignment_49010,axiom,
    ! [VarCurr: state_type] :
      ( v78868(VarCurr)
    <=> v78870(VarCurr) ) ).

tff(addAssignment_49009,axiom,
    ! [VarCurr: state_type] :
      ( v78870(VarCurr)
    <=> v78872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7327,axiom,
    ! [VarCurr: state_type] :
      ( v78872(VarCurr)
    <=> ( v78886(VarCurr)
      <~> v78882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7326,axiom,
    ! [VarCurr: state_type] :
      ( v78886(VarCurr)
    <=> ( v78874(VarCurr)
      <~> v78878(VarCurr) ) ) ).

tff(addAssignment_49008,axiom,
    ! [VarCurr: state_type] :
      ( v78882(VarCurr)
    <=> v78884(VarCurr) ) ).

tff(addAssignment_49007,axiom,
    ! [VarCurr: state_type] :
      ( v78884(VarCurr)
    <=> v77837(VarCurr,26) ) ).

tff(addAssignment_49006,axiom,
    ! [VarCurr: state_type] :
      ( v78878(VarCurr)
    <=> v78880(VarCurr) ) ).

tff(addAssignment_49005,axiom,
    ! [VarCurr: state_type] :
      ( v78880(VarCurr)
    <=> v77837(VarCurr,25) ) ).

tff(addAssignment_49004,axiom,
    ! [VarCurr: state_type] :
      ( v78874(VarCurr)
    <=> v78876(VarCurr) ) ).

tff(addAssignment_49003,axiom,
    ! [VarCurr: state_type] :
      ( v78876(VarCurr)
    <=> v77837(VarCurr,24) ) ).

tff(addAssignment_49002,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,24)
    <=> v77894(VarCurr,24) ) ).

tff(addAssignment_49001,axiom,
    ! [VarCurr: state_type] :
      ( v78842(VarCurr)
    <=> v78844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7325,axiom,
    ! [VarCurr: state_type] :
      ( v78844(VarCurr)
    <=> ( v78858(VarCurr)
      <~> v78854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7324,axiom,
    ! [VarCurr: state_type] :
      ( v78858(VarCurr)
    <=> ( v78846(VarCurr)
      <~> v78850(VarCurr) ) ) ).

tff(addAssignment_49000,axiom,
    ! [VarCurr: state_type] :
      ( v78854(VarCurr)
    <=> v78856(VarCurr) ) ).

tff(addAssignment_48999,axiom,
    ! [VarCurr: state_type] :
      ( v78856(VarCurr)
    <=> v77837(VarCurr,27) ) ).

tff(addAssignment_48998,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,27)
    <=> v77894(VarCurr,27) ) ).

tff(addAssignment_48997,axiom,
    ! [VarCurr: state_type] :
      ( v78850(VarCurr)
    <=> v78852(VarCurr) ) ).

tff(addAssignment_48996,axiom,
    ! [VarCurr: state_type] :
      ( v78852(VarCurr)
    <=> v77837(VarCurr,26) ) ).

tff(addAssignment_48995,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,26)
    <=> v77894(VarCurr,26) ) ).

tff(addAssignment_48994,axiom,
    ! [VarCurr: state_type] :
      ( v78846(VarCurr)
    <=> v78848(VarCurr) ) ).

tff(addAssignment_48993,axiom,
    ! [VarCurr: state_type] :
      ( v78848(VarCurr)
    <=> v77837(VarCurr,25) ) ).

tff(addAssignment_48992,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,25)
    <=> v77894(VarCurr,25) ) ).

tff(addAssignment_48991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78831(VarCurr,B)
      <=> v78833(VarCurr,B) ) ) ).

tff(addAssignment_48990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78833(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48989,axiom,
    ! [VarCurr: state_type] :
      ( v78817(VarCurr)
    <=> v78819(VarCurr) ) ).

tff(addAssignment_48988,axiom,
    ! [VarCurr: state_type] :
      ( v78819(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48987,axiom,
    ! [VarCurr: state_type] :
      ( v78691(VarCurr)
    <=> v78693(VarCurr) ) ).

tff(addAssignment_48986,axiom,
    ! [VarCurr: state_type] :
      ( v78693(VarCurr)
    <=> v78695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7323,axiom,
    ! [VarCurr: state_type] :
      ( v78695(VarCurr)
    <=> ( v78697(VarCurr)
        & v78701(VarCurr) ) ) ).

tff(addAssignment_48985,axiom,
    ! [VarCurr: state_type] :
      ( v78701(VarCurr)
    <=> v78703(VarCurr) ) ).

tff(addAssignment_48984,axiom,
    ! [VarCurr: state_type] :
      ( v78703(VarCurr)
    <=> v78705(VarCurr) ) ).

tff(addAssignment_48983,axiom,
    ! [VarCurr: state_type] :
      ( v78705(VarCurr)
    <=> v78707(VarCurr) ) ).

tff(addAssignment_48982,axiom,
    ! [VarCurr: state_type] :
      ( v78707(VarCurr)
    <=> v78709(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_292,axiom,
    ! [VarCurr: state_type] :
      ( v78709(VarCurr)
    <=> ( ( v78711(VarCurr,3)
        <=> v78715(VarCurr,3) )
        & ( v78711(VarCurr,2)
        <=> v78715(VarCurr,2) )
        & ( v78711(VarCurr,1)
        <=> v78715(VarCurr,1) )
        & ( v78711(VarCurr,0)
        <=> v78715(VarCurr,0) ) ) ) ).

tff(addAssignment_48981,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78715(VarCurr,B)
      <=> v78717(VarCurr,B) ) ) ).

tff(addAssignment_48980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78717(VarCurr,B)
      <=> v78719(VarCurr,B) ) ) ).

tff(addAssignment_48979,axiom,
    ! [VarCurr: state_type] :
      ( ( v78719(VarCurr,3)
      <=> v77817(VarCurr,27) )
      & ( v78719(VarCurr,2)
      <=> v77817(VarCurr,26) )
      & ( v78719(VarCurr,1)
      <=> v77817(VarCurr,25) )
      & ( v78719(VarCurr,0)
      <=> v77817(VarCurr,24) ) ) ).

tff(addAssignment_48978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48973,axiom,
    ! [VarCurr: state_type] :
      ( v78076(VarCurr,3)
    <=> v78722(VarCurr) ) ).

tff(addAssignment_48972,axiom,
    ! [VarCurr: state_type] :
      ( v78076(VarCurr,2)
    <=> v78755(VarCurr) ) ).

tff(addAssignment_48971,axiom,
    ! [VarCurr: state_type] :
      ( v78076(VarCurr,1)
    <=> v78778(VarCurr) ) ).

tff(addAssignment_48970,axiom,
    ! [VarCurr: state_type] :
      ( v78076(VarCurr,0)
    <=> v78801(VarCurr) ) ).

tff(addAssignment_48969,axiom,
    ! [VarCurr: state_type] :
      ( v78801(VarCurr)
    <=> v78803(VarCurr) ) ).

tff(addAssignment_48968,axiom,
    ! [VarCurr: state_type] :
      ( v78803(VarCurr)
    <=> v78805(VarCurr) ) ).

tff(addAssignment_48967,axiom,
    ! [VarCurr: state_type] :
      ( v78805(VarCurr)
    <=> v78807(VarCurr) ) ).

tff(addAssignment_48966,axiom,
    ! [VarCurr: state_type] :
      ( v78807(VarCurr)
    <=> v77837(VarCurr,29) ) ).

tff(addAssignment_48965,axiom,
    ! [VarCurr: state_type] :
      ( v78778(VarCurr)
    <=> v78780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7322,axiom,
    ! [VarCurr: state_type] :
      ( v78780(VarCurr)
    <=> ( v78782(VarCurr)
      <~> v78786(VarCurr) ) ) ).

tff(addAssignment_48964,axiom,
    ! [VarCurr: state_type] :
      ( v78786(VarCurr)
    <=> v78788(VarCurr) ) ).

tff(addAssignment_48963,axiom,
    ! [VarCurr: state_type] :
      ( v78788(VarCurr)
    <=> v77837(VarCurr,29) ) ).

tff(addAssignment_48962,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,29)
    <=> v77894(VarCurr,29) ) ).

tff(addAssignment_48961,axiom,
    ! [VarCurr: state_type] :
      ( v77934(VarCurr)
    <=> v78791(VarCurr) ) ).

tff(addAssignment_48960,axiom,
    ! [VarCurr: state_type] :
      ( v78791(VarCurr)
    <=> v78793(VarCurr) ) ).

tff(writeUnaryOperator_3509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78793(VarCurr)
    <=> v78795(VarCurr) ) ).

tff(addAssignment_48959,axiom,
    ! [VarCurr: state_type] :
      ( v78795(VarCurr)
    <=> v78797(VarCurr) ) ).

tff(addAssignment_48958,axiom,
    ! [VarCurr: state_type] :
      ( v78797(VarCurr)
    <=> v77956(VarCurr) ) ).

tff(addAssignment_48957,axiom,
    ! [VarCurr: state_type] :
      ( v78782(VarCurr)
    <=> v78784(VarCurr) ) ).

tff(addAssignment_48956,axiom,
    ! [VarCurr: state_type] :
      ( v78784(VarCurr)
    <=> v77837(VarCurr,30) ) ).

tff(addAssignment_48955,axiom,
    ! [VarCurr: state_type] :
      ( v78755(VarCurr)
    <=> v78757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7321,axiom,
    ! [VarCurr: state_type] :
      ( v78757(VarCurr)
    <=> ( v78759(VarCurr)
      <~> v78763(VarCurr) ) ) ).

tff(addAssignment_48954,axiom,
    ! [VarCurr: state_type] :
      ( v78763(VarCurr)
    <=> v78765(VarCurr) ) ).

tff(addAssignment_48953,axiom,
    ! [VarCurr: state_type] :
      ( v78765(VarCurr)
    <=> v77837(VarCurr,30) ) ).

tff(addAssignment_48952,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,30)
    <=> v77894(VarCurr,30) ) ).

tff(addAssignment_48951,axiom,
    ! [VarCurr: state_type] :
      ( v77933(VarCurr)
    <=> v78768(VarCurr) ) ).

tff(addAssignment_48950,axiom,
    ! [VarCurr: state_type] :
      ( v78768(VarCurr)
    <=> v78770(VarCurr) ) ).

tff(writeUnaryOperator_3508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78770(VarCurr)
    <=> v78772(VarCurr) ) ).

tff(addAssignment_48949,axiom,
    ! [VarCurr: state_type] :
      ( v78772(VarCurr)
    <=> v78774(VarCurr) ) ).

tff(addAssignment_48948,axiom,
    ! [VarCurr: state_type] :
      ( v78774(VarCurr)
    <=> v77981(VarCurr) ) ).

tff(addAssignment_48947,axiom,
    ! [VarCurr: state_type] :
      ( v78759(VarCurr)
    <=> v78761(VarCurr) ) ).

tff(addAssignment_48946,axiom,
    ! [VarCurr: state_type] :
      ( v78761(VarCurr)
    <=> v77837(VarCurr,31) ) ).

tff(addAssignment_48945,axiom,
    ! [VarCurr: state_type] :
      ( v78722(VarCurr)
    <=> v78724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7320,axiom,
    ! [VarCurr: state_type] :
      ( v78724(VarCurr)
    <=> ( v78726(VarCurr)
      <~> v78740(VarCurr) ) ) ).

tff(addAssignment_48944,axiom,
    ! [VarCurr: state_type] :
      ( v78740(VarCurr)
    <=> v78742(VarCurr) ) ).

tff(addAssignment_48943,axiom,
    ! [VarCurr: state_type] :
      ( v78742(VarCurr)
    <=> v77837(VarCurr,31) ) ).

tff(addAssignment_48942,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,31)
    <=> v77894(VarCurr,31) ) ).

tff(addAssignment_48941,axiom,
    ! [VarCurr: state_type] :
      ( v77932(VarCurr)
    <=> v78745(VarCurr) ) ).

tff(addAssignment_48940,axiom,
    ! [VarCurr: state_type] :
      ( v78745(VarCurr)
    <=> v78747(VarCurr) ) ).

tff(writeUnaryOperator_3507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78747(VarCurr)
    <=> v78749(VarCurr) ) ).

tff(addAssignment_48939,axiom,
    ! [VarCurr: state_type] :
      ( v78749(VarCurr)
    <=> v78751(VarCurr) ) ).

tff(addAssignment_48938,axiom,
    ! [VarCurr: state_type] :
      ( v78751(VarCurr)
    <=> v78057(VarCurr) ) ).

tff(addAssignment_48937,axiom,
    ! [VarCurr: state_type] :
      ( v78726(VarCurr)
    <=> v78728(VarCurr) ) ).

tff(addAssignment_48936,axiom,
    ! [VarCurr: state_type] :
      ( v78728(VarCurr)
    <=> v77837(VarCurr,28) ) ).

tff(addAssignment_48935,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,28)
    <=> v77894(VarCurr,28) ) ).

tff(addAssignment_48934,axiom,
    ! [VarCurr: state_type] :
      ( v77935(VarCurr)
    <=> v78731(VarCurr) ) ).

tff(addAssignment_48933,axiom,
    ! [VarCurr: state_type] :
      ( v78731(VarCurr)
    <=> v78733(VarCurr) ) ).

tff(writeUnaryOperator_3506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78733(VarCurr)
    <=> v78735(VarCurr) ) ).

tff(addAssignment_48932,axiom,
    ! [VarCurr: state_type] :
      ( v78735(VarCurr)
    <=> v78737(VarCurr) ) ).

tff(addAssignment_48931,axiom,
    ! [VarCurr: state_type] :
      ( v78737(VarCurr)
    <=> v77849(VarCurr) ) ).

tff(addAssignment_48930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78711(VarCurr,B)
      <=> v78713(VarCurr,B) ) ) ).

tff(addAssignment_48929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78713(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48928,axiom,
    ! [VarCurr: state_type] :
      ( v78697(VarCurr)
    <=> v78699(VarCurr) ) ).

tff(addAssignment_48927,axiom,
    ! [VarCurr: state_type] :
      ( v78699(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48926,axiom,
    ! [VarCurr: state_type] :
      ( v78621(VarCurr)
    <=> v78623(VarCurr) ) ).

tff(addAssignment_48925,axiom,
    ! [VarCurr: state_type] :
      ( v78623(VarCurr)
    <=> v78625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7319,axiom,
    ! [VarCurr: state_type] :
      ( v78625(VarCurr)
    <=> ( v78627(VarCurr)
        & v78631(VarCurr) ) ) ).

tff(addAssignment_48924,axiom,
    ! [VarCurr: state_type] :
      ( v78631(VarCurr)
    <=> v78633(VarCurr) ) ).

tff(addAssignment_48923,axiom,
    ! [VarCurr: state_type] :
      ( v78633(VarCurr)
    <=> v78635(VarCurr) ) ).

tff(addAssignment_48922,axiom,
    ! [VarCurr: state_type] :
      ( v78635(VarCurr)
    <=> v78637(VarCurr) ) ).

tff(addAssignment_48921,axiom,
    ! [VarCurr: state_type] :
      ( v78637(VarCurr)
    <=> v78639(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_291,axiom,
    ! [VarCurr: state_type] :
      ( v78639(VarCurr)
    <=> ( ( v78641(VarCurr,3)
        <=> v78645(VarCurr,3) )
        & ( v78641(VarCurr,2)
        <=> v78645(VarCurr,2) )
        & ( v78641(VarCurr,1)
        <=> v78645(VarCurr,1) )
        & ( v78641(VarCurr,0)
        <=> v78645(VarCurr,0) ) ) ) ).

tff(addAssignment_48920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78645(VarCurr,B)
      <=> v78647(VarCurr,B) ) ) ).

tff(addAssignment_48919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78647(VarCurr,B)
      <=> v78649(VarCurr,B) ) ) ).

tff(addAssignment_48918,axiom,
    ! [VarCurr: state_type] :
      ( ( v78649(VarCurr,3)
      <=> v77817(VarCurr,31) )
      & ( v78649(VarCurr,2)
      <=> v77817(VarCurr,30) )
      & ( v78649(VarCurr,1)
      <=> v77817(VarCurr,29) )
      & ( v78649(VarCurr,0)
      <=> v77817(VarCurr,28) ) ) ).

tff(addAssignment_48917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48912,axiom,
    ! [VarCurr: state_type] :
      ( v78075(VarCurr,3)
    <=> v78652(VarCurr) ) ).

tff(addAssignment_48911,axiom,
    ! [VarCurr: state_type] :
      ( v78075(VarCurr,2)
    <=> v78660(VarCurr) ) ).

tff(addAssignment_48910,axiom,
    ! [VarCurr: state_type] :
      ( v78075(VarCurr,1)
    <=> v78668(VarCurr) ) ).

tff(addAssignment_48909,axiom,
    ! [VarCurr: state_type] :
      ( v78075(VarCurr,0)
    <=> v78676(VarCurr) ) ).

tff(addAssignment_48908,axiom,
    ! [VarCurr: state_type] :
      ( v78676(VarCurr)
    <=> v78678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7318,axiom,
    ! [VarCurr: state_type] :
      ( v78678(VarCurr)
    <=> ( v78680(VarCurr)
      <~> v78684(VarCurr) ) ) ).

tff(addAssignment_48907,axiom,
    ! [VarCurr: state_type] :
      ( v78684(VarCurr)
    <=> v78686(VarCurr) ) ).

tff(addAssignment_48906,axiom,
    ! [VarCurr: state_type] :
      ( v78686(VarCurr)
    <=> v77837(VarCurr,32) ) ).

tff(addAssignment_48905,axiom,
    ! [VarCurr: state_type] :
      ( v78680(VarCurr)
    <=> v78682(VarCurr) ) ).

tff(addAssignment_48904,axiom,
    ! [VarCurr: state_type] :
      ( v78682(VarCurr)
    <=> v77837(VarCurr,33) ) ).

tff(addAssignment_48903,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,33)
    <=> v77894(VarCurr,33) ) ).

tff(addAssignment_48902,axiom,
    ! [VarCurr: state_type] :
      ( v78668(VarCurr)
    <=> v78670(VarCurr) ) ).

tff(addAssignment_48901,axiom,
    ! [VarCurr: state_type] :
      ( v78670(VarCurr)
    <=> v78672(VarCurr) ) ).

tff(addAssignment_48900,axiom,
    ! [VarCurr: state_type] :
      ( v78672(VarCurr)
    <=> v78674(VarCurr) ) ).

tff(addAssignment_48899,axiom,
    ! [VarCurr: state_type] :
      ( v78674(VarCurr)
    <=> v77837(VarCurr,34) ) ).

tff(addAssignment_48898,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,34)
    <=> v77894(VarCurr,34) ) ).

tff(addAssignment_48897,axiom,
    ! [VarCurr: state_type] :
      ( v78660(VarCurr)
    <=> v78662(VarCurr) ) ).

tff(addAssignment_48896,axiom,
    ! [VarCurr: state_type] :
      ( v78662(VarCurr)
    <=> v78664(VarCurr) ) ).

tff(addAssignment_48895,axiom,
    ! [VarCurr: state_type] :
      ( v78664(VarCurr)
    <=> v78666(VarCurr) ) ).

tff(addAssignment_48894,axiom,
    ! [VarCurr: state_type] :
      ( v78666(VarCurr)
    <=> v77837(VarCurr,35) ) ).

tff(addAssignment_48893,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,35)
    <=> v77894(VarCurr,35) ) ).

tff(addAssignment_48892,axiom,
    ! [VarCurr: state_type] :
      ( v78652(VarCurr)
    <=> v78654(VarCurr) ) ).

tff(addAssignment_48891,axiom,
    ! [VarCurr: state_type] :
      ( v78654(VarCurr)
    <=> v78656(VarCurr) ) ).

tff(addAssignment_48890,axiom,
    ! [VarCurr: state_type] :
      ( v78656(VarCurr)
    <=> v78658(VarCurr) ) ).

tff(addAssignment_48889,axiom,
    ! [VarCurr: state_type] :
      ( v78658(VarCurr)
    <=> v77837(VarCurr,32) ) ).

tff(addAssignment_48888,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,32)
    <=> v77894(VarCurr,32) ) ).

tff(addAssignment_48887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78641(VarCurr,B)
      <=> v78643(VarCurr,B) ) ) ).

tff(addAssignment_48886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78643(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48885,axiom,
    ! [VarCurr: state_type] :
      ( v78627(VarCurr)
    <=> v78629(VarCurr) ) ).

tff(addAssignment_48884,axiom,
    ! [VarCurr: state_type] :
      ( v78629(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48883,axiom,
    ! [VarCurr: state_type] :
      ( v78506(VarCurr)
    <=> v78508(VarCurr) ) ).

tff(addAssignment_48882,axiom,
    ! [VarCurr: state_type] :
      ( v78508(VarCurr)
    <=> v78510(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7317,axiom,
    ! [VarCurr: state_type] :
      ( v78510(VarCurr)
    <=> ( v78512(VarCurr)
        & v78516(VarCurr) ) ) ).

tff(addAssignment_48881,axiom,
    ! [VarCurr: state_type] :
      ( v78516(VarCurr)
    <=> v78518(VarCurr) ) ).

tff(addAssignment_48880,axiom,
    ! [VarCurr: state_type] :
      ( v78518(VarCurr)
    <=> v78520(VarCurr) ) ).

tff(addAssignment_48879,axiom,
    ! [VarCurr: state_type] :
      ( v78520(VarCurr)
    <=> v78522(VarCurr) ) ).

tff(addAssignment_48878,axiom,
    ! [VarCurr: state_type] :
      ( v78522(VarCurr)
    <=> v78524(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_290,axiom,
    ! [VarCurr: state_type] :
      ( v78524(VarCurr)
    <=> ( ( v78526(VarCurr,3)
        <=> v78530(VarCurr,3) )
        & ( v78526(VarCurr,2)
        <=> v78530(VarCurr,2) )
        & ( v78526(VarCurr,1)
        <=> v78530(VarCurr,1) )
        & ( v78526(VarCurr,0)
        <=> v78530(VarCurr,0) ) ) ) ).

tff(addAssignment_48877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78530(VarCurr,B)
      <=> v78532(VarCurr,B) ) ) ).

tff(addAssignment_48876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78532(VarCurr,B)
      <=> v78534(VarCurr,B) ) ) ).

tff(addAssignment_48875,axiom,
    ! [VarCurr: state_type] :
      ( ( v78534(VarCurr,3)
      <=> v77817(VarCurr,35) )
      & ( v78534(VarCurr,2)
      <=> v77817(VarCurr,34) )
      & ( v78534(VarCurr,1)
      <=> v77817(VarCurr,33) )
      & ( v78534(VarCurr,0)
      <=> v77817(VarCurr,32) ) ) ).

tff(addAssignment_48874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48870,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48869,axiom,
    ! [VarCurr: state_type] :
      ( v78074(VarCurr,3)
    <=> v78537(VarCurr) ) ).

tff(addAssignment_48868,axiom,
    ! [VarCurr: state_type] :
      ( v78074(VarCurr,2)
    <=> v78555(VarCurr) ) ).

tff(addAssignment_48867,axiom,
    ! [VarCurr: state_type] :
      ( v78074(VarCurr,1)
    <=> v78573(VarCurr) ) ).

tff(addAssignment_48866,axiom,
    ! [VarCurr: state_type] :
      ( v78074(VarCurr,0)
    <=> v78606(VarCurr) ) ).

tff(addAssignment_48865,axiom,
    ! [VarCurr: state_type] :
      ( v78606(VarCurr)
    <=> v78608(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7316,axiom,
    ! [VarCurr: state_type] :
      ( v78608(VarCurr)
    <=> ( v78610(VarCurr)
      <~> v78614(VarCurr) ) ) ).

tff(addAssignment_48864,axiom,
    ! [VarCurr: state_type] :
      ( v78614(VarCurr)
    <=> v78616(VarCurr) ) ).

tff(addAssignment_48863,axiom,
    ! [VarCurr: state_type] :
      ( v78616(VarCurr)
    <=> v77837(VarCurr,39) ) ).

tff(addAssignment_48862,axiom,
    ! [VarCurr: state_type] :
      ( v78610(VarCurr)
    <=> v78612(VarCurr) ) ).

tff(addAssignment_48861,axiom,
    ! [VarCurr: state_type] :
      ( v78612(VarCurr)
    <=> v77837(VarCurr,37) ) ).

tff(addAssignment_48860,axiom,
    ! [VarCurr: state_type] :
      ( v78573(VarCurr)
    <=> v78575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7315,axiom,
    ! [VarCurr: state_type] :
      ( v78575(VarCurr)
    <=> ( v78577(VarCurr)
      <~> v78601(VarCurr) ) ) ).

tff(addAssignment_48859,axiom,
    ! [VarCurr: state_type] :
      ( v78601(VarCurr)
    <=> v78603(VarCurr) ) ).

tff(addAssignment_48858,axiom,
    ! [VarCurr: state_type] :
      ( v78603(VarCurr)
    <=> v77837(VarCurr,39) ) ).

tff(addAssignment_48857,axiom,
    ! [VarCurr: state_type] :
      ( v78577(VarCurr)
    <=> v78579(VarCurr) ) ).

tff(addAssignment_48856,axiom,
    ! [VarCurr: state_type] :
      ( v78579(VarCurr)
    <=> v78581(VarCurr) ) ).

tff(addAssignment_48855,axiom,
    ! [VarCurr: state_type] :
      ( v78581(VarCurr)
    <=> v78583(VarCurr) ) ).

tff(addAssignment_48854,axiom,
    ! [VarCurr: state_type] :
      ( v78583(VarCurr)
    <=> v78585(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7314,axiom,
    ! [VarCurr: state_type] :
      ( v78585(VarCurr)
    <=> ( v78599(VarCurr)
      <~> v78595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7313,axiom,
    ! [VarCurr: state_type] :
      ( v78599(VarCurr)
    <=> ( v78587(VarCurr)
      <~> v78591(VarCurr) ) ) ).

tff(addAssignment_48853,axiom,
    ! [VarCurr: state_type] :
      ( v78595(VarCurr)
    <=> v78597(VarCurr) ) ).

tff(addAssignment_48852,axiom,
    ! [VarCurr: state_type] :
      ( v78597(VarCurr)
    <=> v77837(VarCurr,38) ) ).

tff(addAssignment_48851,axiom,
    ! [VarCurr: state_type] :
      ( v78591(VarCurr)
    <=> v78593(VarCurr) ) ).

tff(addAssignment_48850,axiom,
    ! [VarCurr: state_type] :
      ( v78593(VarCurr)
    <=> v77837(VarCurr,37) ) ).

tff(addAssignment_48849,axiom,
    ! [VarCurr: state_type] :
      ( v78587(VarCurr)
    <=> v78589(VarCurr) ) ).

tff(addAssignment_48848,axiom,
    ! [VarCurr: state_type] :
      ( v78589(VarCurr)
    <=> v77837(VarCurr,36) ) ).

tff(addAssignment_48847,axiom,
    ! [VarCurr: state_type] :
      ( v78555(VarCurr)
    <=> v78557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7312,axiom,
    ! [VarCurr: state_type] :
      ( v78557(VarCurr)
    <=> ( v78571(VarCurr)
      <~> v78567(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7311,axiom,
    ! [VarCurr: state_type] :
      ( v78571(VarCurr)
    <=> ( v78559(VarCurr)
      <~> v78563(VarCurr) ) ) ).

tff(addAssignment_48846,axiom,
    ! [VarCurr: state_type] :
      ( v78567(VarCurr)
    <=> v78569(VarCurr) ) ).

tff(addAssignment_48845,axiom,
    ! [VarCurr: state_type] :
      ( v78569(VarCurr)
    <=> v77837(VarCurr,39) ) ).

tff(addAssignment_48844,axiom,
    ! [VarCurr: state_type] :
      ( v78563(VarCurr)
    <=> v78565(VarCurr) ) ).

tff(addAssignment_48843,axiom,
    ! [VarCurr: state_type] :
      ( v78565(VarCurr)
    <=> v77837(VarCurr,38) ) ).

tff(addAssignment_48842,axiom,
    ! [VarCurr: state_type] :
      ( v78559(VarCurr)
    <=> v78561(VarCurr) ) ).

tff(addAssignment_48841,axiom,
    ! [VarCurr: state_type] :
      ( v78561(VarCurr)
    <=> v77837(VarCurr,37) ) ).

tff(addAssignment_48840,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,37)
    <=> v77894(VarCurr,37) ) ).

tff(addAssignment_48839,axiom,
    ! [VarCurr: state_type] :
      ( v78537(VarCurr)
    <=> v78539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7310,axiom,
    ! [VarCurr: state_type] :
      ( v78539(VarCurr)
    <=> ( v78553(VarCurr)
      <~> v78549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7309,axiom,
    ! [VarCurr: state_type] :
      ( v78553(VarCurr)
    <=> ( v78541(VarCurr)
      <~> v78545(VarCurr) ) ) ).

tff(addAssignment_48838,axiom,
    ! [VarCurr: state_type] :
      ( v78549(VarCurr)
    <=> v78551(VarCurr) ) ).

tff(addAssignment_48837,axiom,
    ! [VarCurr: state_type] :
      ( v78551(VarCurr)
    <=> v77837(VarCurr,39) ) ).

tff(addAssignment_48836,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,39)
    <=> v77894(VarCurr,39) ) ).

tff(addAssignment_48835,axiom,
    ! [VarCurr: state_type] :
      ( v78545(VarCurr)
    <=> v78547(VarCurr) ) ).

tff(addAssignment_48834,axiom,
    ! [VarCurr: state_type] :
      ( v78547(VarCurr)
    <=> v77837(VarCurr,38) ) ).

tff(addAssignment_48833,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,38)
    <=> v77894(VarCurr,38) ) ).

tff(addAssignment_48832,axiom,
    ! [VarCurr: state_type] :
      ( v78541(VarCurr)
    <=> v78543(VarCurr) ) ).

tff(addAssignment_48831,axiom,
    ! [VarCurr: state_type] :
      ( v78543(VarCurr)
    <=> v77837(VarCurr,36) ) ).

tff(addAssignment_48830,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,36)
    <=> v77894(VarCurr,36) ) ).

tff(addAssignment_48829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78526(VarCurr,B)
      <=> v78528(VarCurr,B) ) ) ).

tff(addAssignment_48828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78528(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48827,axiom,
    ! [VarCurr: state_type] :
      ( v78512(VarCurr)
    <=> v78514(VarCurr) ) ).

tff(addAssignment_48826,axiom,
    ! [VarCurr: state_type] :
      ( v78514(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48825,axiom,
    ! [VarCurr: state_type] :
      ( v78411(VarCurr)
    <=> v78413(VarCurr) ) ).

tff(addAssignment_48824,axiom,
    ! [VarCurr: state_type] :
      ( v78413(VarCurr)
    <=> v78415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7308,axiom,
    ! [VarCurr: state_type] :
      ( v78415(VarCurr)
    <=> ( v78417(VarCurr)
        & v78421(VarCurr) ) ) ).

tff(addAssignment_48823,axiom,
    ! [VarCurr: state_type] :
      ( v78421(VarCurr)
    <=> v78423(VarCurr) ) ).

tff(addAssignment_48822,axiom,
    ! [VarCurr: state_type] :
      ( v78423(VarCurr)
    <=> v78425(VarCurr) ) ).

tff(addAssignment_48821,axiom,
    ! [VarCurr: state_type] :
      ( v78425(VarCurr)
    <=> v78427(VarCurr) ) ).

tff(addAssignment_48820,axiom,
    ! [VarCurr: state_type] :
      ( v78427(VarCurr)
    <=> v78429(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_289,axiom,
    ! [VarCurr: state_type] :
      ( v78429(VarCurr)
    <=> ( ( v78431(VarCurr,3)
        <=> v78435(VarCurr,3) )
        & ( v78431(VarCurr,2)
        <=> v78435(VarCurr,2) )
        & ( v78431(VarCurr,1)
        <=> v78435(VarCurr,1) )
        & ( v78431(VarCurr,0)
        <=> v78435(VarCurr,0) ) ) ) ).

tff(addAssignment_48819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78435(VarCurr,B)
      <=> v78437(VarCurr,B) ) ) ).

tff(addAssignment_48818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78437(VarCurr,B)
      <=> v78439(VarCurr,B) ) ) ).

tff(addAssignment_48817,axiom,
    ! [VarCurr: state_type] :
      ( ( v78439(VarCurr,3)
      <=> v77817(VarCurr,39) )
      & ( v78439(VarCurr,2)
      <=> v77817(VarCurr,38) )
      & ( v78439(VarCurr,1)
      <=> v77817(VarCurr,37) )
      & ( v78439(VarCurr,0)
      <=> v77817(VarCurr,36) ) ) ).

tff(addAssignment_48816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48811,axiom,
    ! [VarCurr: state_type] :
      ( v78073(VarCurr,3)
    <=> v78442(VarCurr) ) ).

tff(addAssignment_48810,axiom,
    ! [VarCurr: state_type] :
      ( v78073(VarCurr,2)
    <=> v78455(VarCurr) ) ).

tff(addAssignment_48809,axiom,
    ! [VarCurr: state_type] :
      ( v78073(VarCurr,1)
    <=> v78468(VarCurr) ) ).

tff(addAssignment_48808,axiom,
    ! [VarCurr: state_type] :
      ( v78073(VarCurr,0)
    <=> v78486(VarCurr) ) ).

tff(addAssignment_48807,axiom,
    ! [VarCurr: state_type] :
      ( v78486(VarCurr)
    <=> v78488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7307,axiom,
    ! [VarCurr: state_type] :
      ( v78488(VarCurr)
    <=> ( v78502(VarCurr)
      <~> v78498(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7306,axiom,
    ! [VarCurr: state_type] :
      ( v78502(VarCurr)
    <=> ( v78490(VarCurr)
      <~> v78494(VarCurr) ) ) ).

tff(addAssignment_48806,axiom,
    ! [VarCurr: state_type] :
      ( v78498(VarCurr)
    <=> v78500(VarCurr) ) ).

tff(addAssignment_48805,axiom,
    ! [VarCurr: state_type] :
      ( v78500(VarCurr)
    <=> v77837(VarCurr,43) ) ).

tff(addAssignment_48804,axiom,
    ! [VarCurr: state_type] :
      ( v78494(VarCurr)
    <=> v78496(VarCurr) ) ).

tff(addAssignment_48803,axiom,
    ! [VarCurr: state_type] :
      ( v78496(VarCurr)
    <=> v77837(VarCurr,41) ) ).

tff(addAssignment_48802,axiom,
    ! [VarCurr: state_type] :
      ( v78490(VarCurr)
    <=> v78492(VarCurr) ) ).

tff(addAssignment_48801,axiom,
    ! [VarCurr: state_type] :
      ( v78492(VarCurr)
    <=> v77837(VarCurr,40) ) ).

tff(addAssignment_48800,axiom,
    ! [VarCurr: state_type] :
      ( v78468(VarCurr)
    <=> v78470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7305,axiom,
    ! [VarCurr: state_type] :
      ( v78470(VarCurr)
    <=> ( v78484(VarCurr)
      <~> v78480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7304,axiom,
    ! [VarCurr: state_type] :
      ( v78484(VarCurr)
    <=> ( v78472(VarCurr)
      <~> v78476(VarCurr) ) ) ).

tff(addAssignment_48799,axiom,
    ! [VarCurr: state_type] :
      ( v78480(VarCurr)
    <=> v78482(VarCurr) ) ).

tff(addAssignment_48798,axiom,
    ! [VarCurr: state_type] :
      ( v78482(VarCurr)
    <=> v77837(VarCurr,43) ) ).

tff(addAssignment_48797,axiom,
    ! [VarCurr: state_type] :
      ( v78476(VarCurr)
    <=> v78478(VarCurr) ) ).

tff(addAssignment_48796,axiom,
    ! [VarCurr: state_type] :
      ( v78478(VarCurr)
    <=> v77837(VarCurr,42) ) ).

tff(addAssignment_48795,axiom,
    ! [VarCurr: state_type] :
      ( v78472(VarCurr)
    <=> v78474(VarCurr) ) ).

tff(addAssignment_48794,axiom,
    ! [VarCurr: state_type] :
      ( v78474(VarCurr)
    <=> v77837(VarCurr,40) ) ).

tff(addAssignment_48793,axiom,
    ! [VarCurr: state_type] :
      ( v78455(VarCurr)
    <=> v78457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7303,axiom,
    ! [VarCurr: state_type] :
      ( v78457(VarCurr)
    <=> ( v78459(VarCurr)
      <~> v78463(VarCurr) ) ) ).

tff(addAssignment_48792,axiom,
    ! [VarCurr: state_type] :
      ( v78463(VarCurr)
    <=> v78465(VarCurr) ) ).

tff(addAssignment_48791,axiom,
    ! [VarCurr: state_type] :
      ( v78465(VarCurr)
    <=> v77837(VarCurr,41) ) ).

tff(addAssignment_48790,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,41)
    <=> v77894(VarCurr,41) ) ).

tff(addAssignment_48789,axiom,
    ! [VarCurr: state_type] :
      ( v78459(VarCurr)
    <=> v78461(VarCurr) ) ).

tff(addAssignment_48788,axiom,
    ! [VarCurr: state_type] :
      ( v78461(VarCurr)
    <=> v77837(VarCurr,43) ) ).

tff(addAssignment_48787,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,43)
    <=> v77894(VarCurr,43) ) ).

tff(addAssignment_48786,axiom,
    ! [VarCurr: state_type] :
      ( v78442(VarCurr)
    <=> v78444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7302,axiom,
    ! [VarCurr: state_type] :
      ( v78444(VarCurr)
    <=> ( v78446(VarCurr)
      <~> v78450(VarCurr) ) ) ).

tff(addAssignment_48785,axiom,
    ! [VarCurr: state_type] :
      ( v78450(VarCurr)
    <=> v78452(VarCurr) ) ).

tff(addAssignment_48784,axiom,
    ! [VarCurr: state_type] :
      ( v78452(VarCurr)
    <=> v77837(VarCurr,42) ) ).

tff(addAssignment_48783,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,42)
    <=> v77894(VarCurr,42) ) ).

tff(addAssignment_48782,axiom,
    ! [VarCurr: state_type] :
      ( v78446(VarCurr)
    <=> v78448(VarCurr) ) ).

tff(addAssignment_48781,axiom,
    ! [VarCurr: state_type] :
      ( v78448(VarCurr)
    <=> v77837(VarCurr,40) ) ).

tff(addAssignment_48780,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,40)
    <=> v77894(VarCurr,40) ) ).

tff(addAssignment_48779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78431(VarCurr,B)
      <=> v78433(VarCurr,B) ) ) ).

tff(addAssignment_48778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78433(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48777,axiom,
    ! [VarCurr: state_type] :
      ( v78417(VarCurr)
    <=> v78419(VarCurr) ) ).

tff(addAssignment_48776,axiom,
    ! [VarCurr: state_type] :
      ( v78419(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48775,axiom,
    ! [VarCurr: state_type] :
      ( v78281(VarCurr)
    <=> v78283(VarCurr) ) ).

tff(addAssignment_48774,axiom,
    ! [VarCurr: state_type] :
      ( v78283(VarCurr)
    <=> v78285(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7301,axiom,
    ! [VarCurr: state_type] :
      ( v78285(VarCurr)
    <=> ( v78287(VarCurr)
        & v78291(VarCurr) ) ) ).

tff(addAssignment_48773,axiom,
    ! [VarCurr: state_type] :
      ( v78291(VarCurr)
    <=> v78293(VarCurr) ) ).

tff(addAssignment_48772,axiom,
    ! [VarCurr: state_type] :
      ( v78293(VarCurr)
    <=> v78295(VarCurr) ) ).

tff(addAssignment_48771,axiom,
    ! [VarCurr: state_type] :
      ( v78295(VarCurr)
    <=> v78297(VarCurr) ) ).

tff(addAssignment_48770,axiom,
    ! [VarCurr: state_type] :
      ( v78297(VarCurr)
    <=> v78299(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_288,axiom,
    ! [VarCurr: state_type] :
      ( v78299(VarCurr)
    <=> ( ( v78301(VarCurr,3)
        <=> v78305(VarCurr,3) )
        & ( v78301(VarCurr,2)
        <=> v78305(VarCurr,2) )
        & ( v78301(VarCurr,1)
        <=> v78305(VarCurr,1) )
        & ( v78301(VarCurr,0)
        <=> v78305(VarCurr,0) ) ) ) ).

tff(addAssignment_48769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78305(VarCurr,B)
      <=> v78307(VarCurr,B) ) ) ).

tff(addAssignment_48768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78307(VarCurr,B)
      <=> v78309(VarCurr,B) ) ) ).

tff(addAssignment_48767,axiom,
    ! [VarCurr: state_type] :
      ( ( v78309(VarCurr,3)
      <=> v77817(VarCurr,43) )
      & ( v78309(VarCurr,2)
      <=> v77817(VarCurr,42) )
      & ( v78309(VarCurr,1)
      <=> v77817(VarCurr,41) )
      & ( v78309(VarCurr,0)
      <=> v77817(VarCurr,40) ) ) ).

tff(addAssignment_48766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48762,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48761,axiom,
    ! [VarCurr: state_type] :
      ( v78072(VarCurr,3)
    <=> v78312(VarCurr) ) ).

tff(addAssignment_48760,axiom,
    ! [VarCurr: state_type] :
      ( v78072(VarCurr,2)
    <=> v78360(VarCurr) ) ).

tff(addAssignment_48759,axiom,
    ! [VarCurr: state_type] :
      ( v78072(VarCurr,1)
    <=> v78383(VarCurr) ) ).

tff(addAssignment_48758,axiom,
    ! [VarCurr: state_type] :
      ( v78072(VarCurr,0)
    <=> v78396(VarCurr) ) ).

tff(addAssignment_48757,axiom,
    ! [VarCurr: state_type] :
      ( v78396(VarCurr)
    <=> v78398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7300,axiom,
    ! [VarCurr: state_type] :
      ( v78398(VarCurr)
    <=> ( v78400(VarCurr)
      <~> v78404(VarCurr) ) ) ).

tff(addAssignment_48756,axiom,
    ! [VarCurr: state_type] :
      ( v78404(VarCurr)
    <=> v78406(VarCurr) ) ).

tff(addAssignment_48755,axiom,
    ! [VarCurr: state_type] :
      ( v78406(VarCurr)
    <=> v77837(VarCurr,46) ) ).

tff(addAssignment_48754,axiom,
    ! [VarCurr: state_type] :
      ( v78400(VarCurr)
    <=> v78402(VarCurr) ) ).

tff(addAssignment_48753,axiom,
    ! [VarCurr: state_type] :
      ( v78402(VarCurr)
    <=> v77837(VarCurr,45) ) ).

tff(addAssignment_48752,axiom,
    ! [VarCurr: state_type] :
      ( v78383(VarCurr)
    <=> v78385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7299,axiom,
    ! [VarCurr: state_type] :
      ( v78385(VarCurr)
    <=> ( v78387(VarCurr)
      <~> v78391(VarCurr) ) ) ).

tff(addAssignment_48751,axiom,
    ! [VarCurr: state_type] :
      ( v78391(VarCurr)
    <=> v78393(VarCurr) ) ).

tff(addAssignment_48750,axiom,
    ! [VarCurr: state_type] :
      ( v78393(VarCurr)
    <=> v77837(VarCurr,47) ) ).

tff(addAssignment_48749,axiom,
    ! [VarCurr: state_type] :
      ( v78387(VarCurr)
    <=> v78389(VarCurr) ) ).

tff(addAssignment_48748,axiom,
    ! [VarCurr: state_type] :
      ( v78389(VarCurr)
    <=> v77837(VarCurr,45) ) ).

tff(addAssignment_48747,axiom,
    ! [VarCurr: state_type] :
      ( v78360(VarCurr)
    <=> v78362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7298,axiom,
    ! [VarCurr: state_type] :
      ( v78362(VarCurr)
    <=> ( v78364(VarCurr)
      <~> v78368(VarCurr) ) ) ).

tff(addAssignment_48746,axiom,
    ! [VarCurr: state_type] :
      ( v78368(VarCurr)
    <=> v78370(VarCurr) ) ).

tff(addAssignment_48745,axiom,
    ! [VarCurr: state_type] :
      ( v78370(VarCurr)
    <=> v77837(VarCurr,46) ) ).

tff(addAssignment_48744,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,46)
    <=> v77894(VarCurr,46) ) ).

tff(addAssignment_48743,axiom,
    ! [VarCurr: state_type] :
      ( v77927(VarCurr)
    <=> v78373(VarCurr) ) ).

tff(addAssignment_48742,axiom,
    ! [VarCurr: state_type] :
      ( v78373(VarCurr)
    <=> v78375(VarCurr) ) ).

tff(writeUnaryOperator_3505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78375(VarCurr)
    <=> v78377(VarCurr) ) ).

tff(addAssignment_48741,axiom,
    ! [VarCurr: state_type] :
      ( v78377(VarCurr)
    <=> v78379(VarCurr) ) ).

tff(addAssignment_48740,axiom,
    ! [VarCurr: state_type] :
      ( v78379(VarCurr)
    <=> v77981(VarCurr) ) ).

tff(addAssignment_48739,axiom,
    ! [VarCurr: state_type] :
      ( v78364(VarCurr)
    <=> v78366(VarCurr) ) ).

tff(addAssignment_48738,axiom,
    ! [VarCurr: state_type] :
      ( v78366(VarCurr)
    <=> v77837(VarCurr,44) ) ).

tff(addAssignment_48737,axiom,
    ! [VarCurr: state_type] :
      ( v78312(VarCurr)
    <=> v78314(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7297,axiom,
    ! [VarCurr: state_type] :
      ( v78314(VarCurr)
    <=> ( v78358(VarCurr)
      <~> v78344(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7296,axiom,
    ! [VarCurr: state_type] :
      ( v78358(VarCurr)
    <=> ( v78316(VarCurr)
      <~> v78330(VarCurr) ) ) ).

tff(addAssignment_48736,axiom,
    ! [VarCurr: state_type] :
      ( v78344(VarCurr)
    <=> v78346(VarCurr) ) ).

tff(addAssignment_48735,axiom,
    ! [VarCurr: state_type] :
      ( v78346(VarCurr)
    <=> v77837(VarCurr,47) ) ).

tff(addAssignment_48734,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,47)
    <=> v77894(VarCurr,47) ) ).

tff(addAssignment_48733,axiom,
    ! [VarCurr: state_type] :
      ( v77926(VarCurr)
    <=> v78349(VarCurr) ) ).

tff(addAssignment_48732,axiom,
    ! [VarCurr: state_type] :
      ( v78349(VarCurr)
    <=> v78351(VarCurr) ) ).

tff(writeUnaryOperator_3504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78351(VarCurr)
    <=> v78353(VarCurr) ) ).

tff(addAssignment_48731,axiom,
    ! [VarCurr: state_type] :
      ( v78353(VarCurr)
    <=> v78355(VarCurr) ) ).

tff(addAssignment_48730,axiom,
    ! [VarCurr: state_type] :
      ( v78355(VarCurr)
    <=> v78057(VarCurr) ) ).

tff(addAssignment_48729,axiom,
    ! [VarCurr: state_type] :
      ( v78330(VarCurr)
    <=> v78332(VarCurr) ) ).

tff(addAssignment_48728,axiom,
    ! [VarCurr: state_type] :
      ( v78332(VarCurr)
    <=> v77837(VarCurr,45) ) ).

tff(addAssignment_48727,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,45)
    <=> v77894(VarCurr,45) ) ).

tff(addAssignment_48726,axiom,
    ! [VarCurr: state_type] :
      ( v77928(VarCurr)
    <=> v78335(VarCurr) ) ).

tff(addAssignment_48725,axiom,
    ! [VarCurr: state_type] :
      ( v78335(VarCurr)
    <=> v78337(VarCurr) ) ).

tff(writeUnaryOperator_3503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78337(VarCurr)
    <=> v78339(VarCurr) ) ).

tff(addAssignment_48724,axiom,
    ! [VarCurr: state_type] :
      ( v78339(VarCurr)
    <=> v78341(VarCurr) ) ).

tff(addAssignment_48723,axiom,
    ! [VarCurr: state_type] :
      ( v78341(VarCurr)
    <=> v77956(VarCurr) ) ).

tff(addAssignment_48722,axiom,
    ! [VarCurr: state_type] :
      ( v78316(VarCurr)
    <=> v78318(VarCurr) ) ).

tff(addAssignment_48721,axiom,
    ! [VarCurr: state_type] :
      ( v78318(VarCurr)
    <=> v77837(VarCurr,44) ) ).

tff(addAssignment_48720,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,44)
    <=> v77894(VarCurr,44) ) ).

tff(addAssignment_48719,axiom,
    ! [VarCurr: state_type] :
      ( v77929(VarCurr)
    <=> v78321(VarCurr) ) ).

tff(addAssignment_48718,axiom,
    ! [VarCurr: state_type] :
      ( v78321(VarCurr)
    <=> v78323(VarCurr) ) ).

tff(writeUnaryOperator_3502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78323(VarCurr)
    <=> v78325(VarCurr) ) ).

tff(addAssignment_48717,axiom,
    ! [VarCurr: state_type] :
      ( v78325(VarCurr)
    <=> v78327(VarCurr) ) ).

tff(addAssignment_48716,axiom,
    ! [VarCurr: state_type] :
      ( v78327(VarCurr)
    <=> v77849(VarCurr) ) ).

tff(addAssignment_48715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78301(VarCurr,B)
      <=> v78303(VarCurr,B) ) ) ).

tff(addAssignment_48714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78303(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48713,axiom,
    ! [VarCurr: state_type] :
      ( v78287(VarCurr)
    <=> v78289(VarCurr) ) ).

tff(addAssignment_48712,axiom,
    ! [VarCurr: state_type] :
      ( v78289(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48711,axiom,
    ! [VarCurr: state_type] :
      ( v78201(VarCurr)
    <=> v78203(VarCurr) ) ).

tff(addAssignment_48710,axiom,
    ! [VarCurr: state_type] :
      ( v78203(VarCurr)
    <=> v78205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7295,axiom,
    ! [VarCurr: state_type] :
      ( v78205(VarCurr)
    <=> ( v78207(VarCurr)
        & v78211(VarCurr) ) ) ).

tff(addAssignment_48709,axiom,
    ! [VarCurr: state_type] :
      ( v78211(VarCurr)
    <=> v78213(VarCurr) ) ).

tff(addAssignment_48708,axiom,
    ! [VarCurr: state_type] :
      ( v78213(VarCurr)
    <=> v78215(VarCurr) ) ).

tff(addAssignment_48707,axiom,
    ! [VarCurr: state_type] :
      ( v78215(VarCurr)
    <=> v78217(VarCurr) ) ).

tff(addAssignment_48706,axiom,
    ! [VarCurr: state_type] :
      ( v78217(VarCurr)
    <=> v78219(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_287,axiom,
    ! [VarCurr: state_type] :
      ( v78219(VarCurr)
    <=> ( ( v78221(VarCurr,3)
        <=> v78225(VarCurr,3) )
        & ( v78221(VarCurr,2)
        <=> v78225(VarCurr,2) )
        & ( v78221(VarCurr,1)
        <=> v78225(VarCurr,1) )
        & ( v78221(VarCurr,0)
        <=> v78225(VarCurr,0) ) ) ) ).

tff(addAssignment_48705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78225(VarCurr,B)
      <=> v78227(VarCurr,B) ) ) ).

tff(addAssignment_48704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78227(VarCurr,B)
      <=> v78229(VarCurr,B) ) ) ).

tff(addAssignment_48703,axiom,
    ! [VarCurr: state_type] :
      ( ( v78229(VarCurr,3)
      <=> v77817(VarCurr,47) )
      & ( v78229(VarCurr,2)
      <=> v77817(VarCurr,46) )
      & ( v78229(VarCurr,1)
      <=> v77817(VarCurr,45) )
      & ( v78229(VarCurr,0)
      <=> v77817(VarCurr,44) ) ) ).

tff(addAssignment_48702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48697,axiom,
    ! [VarCurr: state_type] :
      ( v78071(VarCurr,3)
    <=> v78232(VarCurr) ) ).

tff(addAssignment_48696,axiom,
    ! [VarCurr: state_type] :
      ( v78071(VarCurr,2)
    <=> v78245(VarCurr) ) ).

tff(addAssignment_48695,axiom,
    ! [VarCurr: state_type] :
      ( v78071(VarCurr,1)
    <=> v78253(VarCurr) ) ).

tff(addAssignment_48694,axiom,
    ! [VarCurr: state_type] :
      ( v78071(VarCurr,0)
    <=> v78261(VarCurr) ) ).

tff(addAssignment_48693,axiom,
    ! [VarCurr: state_type] :
      ( v78261(VarCurr)
    <=> v78263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7294,axiom,
    ! [VarCurr: state_type] :
      ( v78263(VarCurr)
    <=> ( v78277(VarCurr)
      <~> v78273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7293,axiom,
    ! [VarCurr: state_type] :
      ( v78277(VarCurr)
    <=> ( v78265(VarCurr)
      <~> v78269(VarCurr) ) ) ).

tff(addAssignment_48692,axiom,
    ! [VarCurr: state_type] :
      ( v78273(VarCurr)
    <=> v78275(VarCurr) ) ).

tff(addAssignment_48691,axiom,
    ! [VarCurr: state_type] :
      ( v78275(VarCurr)
    <=> v77837(VarCurr,50) ) ).

tff(addAssignment_48690,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,50)
    <=> v77894(VarCurr,50) ) ).

tff(addAssignment_48689,axiom,
    ! [VarCurr: state_type] :
      ( v78269(VarCurr)
    <=> v78271(VarCurr) ) ).

tff(addAssignment_48688,axiom,
    ! [VarCurr: state_type] :
      ( v78271(VarCurr)
    <=> v77837(VarCurr,49) ) ).

tff(addAssignment_48687,axiom,
    ! [VarCurr: state_type] :
      ( v78265(VarCurr)
    <=> v78267(VarCurr) ) ).

tff(addAssignment_48686,axiom,
    ! [VarCurr: state_type] :
      ( v78267(VarCurr)
    <=> v77837(VarCurr,48) ) ).

tff(addAssignment_48685,axiom,
    ! [VarCurr: state_type] :
      ( v78253(VarCurr)
    <=> v78255(VarCurr) ) ).

tff(addAssignment_48684,axiom,
    ! [VarCurr: state_type] :
      ( v78255(VarCurr)
    <=> v78257(VarCurr) ) ).

tff(addAssignment_48683,axiom,
    ! [VarCurr: state_type] :
      ( v78257(VarCurr)
    <=> v78259(VarCurr) ) ).

tff(addAssignment_48682,axiom,
    ! [VarCurr: state_type] :
      ( v78259(VarCurr)
    <=> v77837(VarCurr,51) ) ).

tff(addAssignment_48681,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,51)
    <=> v77894(VarCurr,51) ) ).

tff(addAssignment_48680,axiom,
    ! [VarCurr: state_type] :
      ( v78245(VarCurr)
    <=> v78247(VarCurr) ) ).

tff(addAssignment_48679,axiom,
    ! [VarCurr: state_type] :
      ( v78247(VarCurr)
    <=> v78249(VarCurr) ) ).

tff(addAssignment_48678,axiom,
    ! [VarCurr: state_type] :
      ( v78249(VarCurr)
    <=> v78251(VarCurr) ) ).

tff(addAssignment_48677,axiom,
    ! [VarCurr: state_type] :
      ( v78251(VarCurr)
    <=> v77837(VarCurr,48) ) ).

tff(addAssignment_48676,axiom,
    ! [VarCurr: state_type] :
      ( v78232(VarCurr)
    <=> v78234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7292,axiom,
    ! [VarCurr: state_type] :
      ( v78234(VarCurr)
    <=> ( v78236(VarCurr)
      <~> v78240(VarCurr) ) ) ).

tff(addAssignment_48675,axiom,
    ! [VarCurr: state_type] :
      ( v78240(VarCurr)
    <=> v78242(VarCurr) ) ).

tff(addAssignment_48674,axiom,
    ! [VarCurr: state_type] :
      ( v78242(VarCurr)
    <=> v77837(VarCurr,49) ) ).

tff(addAssignment_48673,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,49)
    <=> v77894(VarCurr,49) ) ).

tff(addAssignment_48672,axiom,
    ! [VarCurr: state_type] :
      ( v78236(VarCurr)
    <=> v78238(VarCurr) ) ).

tff(addAssignment_48671,axiom,
    ! [VarCurr: state_type] :
      ( v78238(VarCurr)
    <=> v77837(VarCurr,48) ) ).

tff(addAssignment_48670,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,48)
    <=> v77894(VarCurr,48) ) ).

tff(addAssignment_48669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78221(VarCurr,B)
      <=> v78223(VarCurr,B) ) ) ).

tff(addAssignment_48668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78223(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48667,axiom,
    ! [VarCurr: state_type] :
      ( v78207(VarCurr)
    <=> v78209(VarCurr) ) ).

tff(addAssignment_48666,axiom,
    ! [VarCurr: state_type] :
      ( v78209(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48665,axiom,
    ! [VarCurr: state_type] :
      ( v78086(VarCurr)
    <=> v78088(VarCurr) ) ).

tff(addAssignment_48664,axiom,
    ! [VarCurr: state_type] :
      ( v78088(VarCurr)
    <=> v78090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7291,axiom,
    ! [VarCurr: state_type] :
      ( v78090(VarCurr)
    <=> ( v78092(VarCurr)
        & v78096(VarCurr) ) ) ).

tff(addAssignment_48663,axiom,
    ! [VarCurr: state_type] :
      ( v78096(VarCurr)
    <=> v78098(VarCurr) ) ).

tff(addAssignment_48662,axiom,
    ! [VarCurr: state_type] :
      ( v78098(VarCurr)
    <=> v78100(VarCurr) ) ).

tff(addAssignment_48661,axiom,
    ! [VarCurr: state_type] :
      ( v78100(VarCurr)
    <=> v78102(VarCurr) ) ).

tff(addAssignment_48660,axiom,
    ! [VarCurr: state_type] :
      ( v78102(VarCurr)
    <=> v78104(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_286,axiom,
    ! [VarCurr: state_type] :
      ( v78104(VarCurr)
    <=> ( ( v78106(VarCurr,3)
        <=> v78110(VarCurr,3) )
        & ( v78106(VarCurr,2)
        <=> v78110(VarCurr,2) )
        & ( v78106(VarCurr,1)
        <=> v78110(VarCurr,1) )
        & ( v78106(VarCurr,0)
        <=> v78110(VarCurr,0) ) ) ) ).

tff(addAssignment_48659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78110(VarCurr,B)
      <=> v78112(VarCurr,B) ) ) ).

tff(addAssignment_48658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78112(VarCurr,B)
      <=> v78114(VarCurr,B) ) ) ).

tff(addAssignment_48657,axiom,
    ! [VarCurr: state_type] :
      ( ( v78114(VarCurr,3)
      <=> v77817(VarCurr,51) )
      & ( v78114(VarCurr,2)
      <=> v77817(VarCurr,50) )
      & ( v78114(VarCurr,1)
      <=> v77817(VarCurr,49) )
      & ( v78114(VarCurr,0)
      <=> v77817(VarCurr,48) ) ) ).

tff(addAssignment_48656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48651,axiom,
    ! [VarCurr: state_type] :
      ( v78070(VarCurr,3)
    <=> v78117(VarCurr) ) ).

tff(addAssignment_48650,axiom,
    ! [VarCurr: state_type] :
      ( v78070(VarCurr,2)
    <=> v78150(VarCurr) ) ).

tff(addAssignment_48649,axiom,
    ! [VarCurr: state_type] :
      ( v78070(VarCurr,1)
    <=> v78168(VarCurr) ) ).

tff(addAssignment_48648,axiom,
    ! [VarCurr: state_type] :
      ( v78070(VarCurr,0)
    <=> v78181(VarCurr) ) ).

tff(addAssignment_48647,axiom,
    ! [VarCurr: state_type] :
      ( v78181(VarCurr)
    <=> v78183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7290,axiom,
    ! [VarCurr: state_type] :
      ( v78183(VarCurr)
    <=> ( v78197(VarCurr)
      <~> v78193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7289,axiom,
    ! [VarCurr: state_type] :
      ( v78197(VarCurr)
    <=> ( v78185(VarCurr)
      <~> v78189(VarCurr) ) ) ).

tff(addAssignment_48646,axiom,
    ! [VarCurr: state_type] :
      ( v78193(VarCurr)
    <=> v78195(VarCurr) ) ).

tff(addAssignment_48645,axiom,
    ! [VarCurr: state_type] :
      ( v78195(VarCurr)
    <=> v77837(VarCurr,55) ) ).

tff(addAssignment_48644,axiom,
    ! [VarCurr: state_type] :
      ( v78189(VarCurr)
    <=> v78191(VarCurr) ) ).

tff(addAssignment_48643,axiom,
    ! [VarCurr: state_type] :
      ( v78191(VarCurr)
    <=> v77837(VarCurr,54) ) ).

tff(addAssignment_48642,axiom,
    ! [VarCurr: state_type] :
      ( v78185(VarCurr)
    <=> v78187(VarCurr) ) ).

tff(addAssignment_48641,axiom,
    ! [VarCurr: state_type] :
      ( v78187(VarCurr)
    <=> v77837(VarCurr,53) ) ).

tff(addAssignment_48640,axiom,
    ! [VarCurr: state_type] :
      ( v78168(VarCurr)
    <=> v78170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7288,axiom,
    ! [VarCurr: state_type] :
      ( v78170(VarCurr)
    <=> ( v78172(VarCurr)
      <~> v78176(VarCurr) ) ) ).

tff(addAssignment_48639,axiom,
    ! [VarCurr: state_type] :
      ( v78176(VarCurr)
    <=> v78178(VarCurr) ) ).

tff(addAssignment_48638,axiom,
    ! [VarCurr: state_type] :
      ( v78178(VarCurr)
    <=> v77837(VarCurr,53) ) ).

tff(addAssignment_48637,axiom,
    ! [VarCurr: state_type] :
      ( v78172(VarCurr)
    <=> v78174(VarCurr) ) ).

tff(addAssignment_48636,axiom,
    ! [VarCurr: state_type] :
      ( v78174(VarCurr)
    <=> v77837(VarCurr,52) ) ).

tff(addAssignment_48635,axiom,
    ! [VarCurr: state_type] :
      ( v78150(VarCurr)
    <=> v78152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7287,axiom,
    ! [VarCurr: state_type] :
      ( v78152(VarCurr)
    <=> ( v78166(VarCurr)
      <~> v78162(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7286,axiom,
    ! [VarCurr: state_type] :
      ( v78166(VarCurr)
    <=> ( v78154(VarCurr)
      <~> v78158(VarCurr) ) ) ).

tff(addAssignment_48634,axiom,
    ! [VarCurr: state_type] :
      ( v78162(VarCurr)
    <=> v78164(VarCurr) ) ).

tff(addAssignment_48633,axiom,
    ! [VarCurr: state_type] :
      ( v78164(VarCurr)
    <=> v77837(VarCurr,54) ) ).

tff(addAssignment_48632,axiom,
    ! [VarCurr: state_type] :
      ( v78158(VarCurr)
    <=> v78160(VarCurr) ) ).

tff(addAssignment_48631,axiom,
    ! [VarCurr: state_type] :
      ( v78160(VarCurr)
    <=> v77837(VarCurr,53) ) ).

tff(addAssignment_48630,axiom,
    ! [VarCurr: state_type] :
      ( v78154(VarCurr)
    <=> v78156(VarCurr) ) ).

tff(addAssignment_48629,axiom,
    ! [VarCurr: state_type] :
      ( v78156(VarCurr)
    <=> v77837(VarCurr,52) ) ).

tff(addAssignment_48628,axiom,
    ! [VarCurr: state_type] :
      ( v78117(VarCurr)
    <=> v78119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7285,axiom,
    ! [VarCurr: state_type] :
      ( v78119(VarCurr)
    <=> ( v78121(VarCurr)
      <~> v78145(VarCurr) ) ) ).

tff(addAssignment_48627,axiom,
    ! [VarCurr: state_type] :
      ( v78145(VarCurr)
    <=> v78147(VarCurr) ) ).

tff(addAssignment_48626,axiom,
    ! [VarCurr: state_type] :
      ( v78147(VarCurr)
    <=> v77837(VarCurr,55) ) ).

tff(addAssignment_48625,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,55)
    <=> v77894(VarCurr,55) ) ).

tff(addAssignment_48624,axiom,
    ! [VarCurr: state_type] :
      ( v78121(VarCurr)
    <=> v78123(VarCurr) ) ).

tff(addAssignment_48623,axiom,
    ! [VarCurr: state_type] :
      ( v78123(VarCurr)
    <=> v78125(VarCurr) ) ).

tff(addAssignment_48622,axiom,
    ! [VarCurr: state_type] :
      ( v78125(VarCurr)
    <=> v78127(VarCurr) ) ).

tff(addAssignment_48621,axiom,
    ! [VarCurr: state_type] :
      ( v78127(VarCurr)
    <=> v78129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7284,axiom,
    ! [VarCurr: state_type] :
      ( v78129(VarCurr)
    <=> ( v78143(VarCurr)
      <~> v78139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7283,axiom,
    ! [VarCurr: state_type] :
      ( v78143(VarCurr)
    <=> ( v78131(VarCurr)
      <~> v78135(VarCurr) ) ) ).

tff(addAssignment_48620,axiom,
    ! [VarCurr: state_type] :
      ( v78139(VarCurr)
    <=> v78141(VarCurr) ) ).

tff(addAssignment_48619,axiom,
    ! [VarCurr: state_type] :
      ( v78141(VarCurr)
    <=> v77837(VarCurr,54) ) ).

tff(addAssignment_48618,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,54)
    <=> v77894(VarCurr,54) ) ).

tff(addAssignment_48617,axiom,
    ! [VarCurr: state_type] :
      ( v78135(VarCurr)
    <=> v78137(VarCurr) ) ).

tff(addAssignment_48616,axiom,
    ! [VarCurr: state_type] :
      ( v78137(VarCurr)
    <=> v77837(VarCurr,53) ) ).

tff(addAssignment_48615,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,53)
    <=> v77894(VarCurr,53) ) ).

tff(addAssignment_48614,axiom,
    ! [VarCurr: state_type] :
      ( v78131(VarCurr)
    <=> v78133(VarCurr) ) ).

tff(addAssignment_48613,axiom,
    ! [VarCurr: state_type] :
      ( v78133(VarCurr)
    <=> v77837(VarCurr,52) ) ).

tff(addAssignment_48612,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,52)
    <=> v77894(VarCurr,52) ) ).

tff(addAssignment_48611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78106(VarCurr,B)
      <=> v78108(VarCurr,B) ) ) ).

tff(addAssignment_48610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78108(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48609,axiom,
    ! [VarCurr: state_type] :
      ( v78092(VarCurr)
    <=> v78094(VarCurr) ) ).

tff(addAssignment_48608,axiom,
    ! [VarCurr: state_type] :
      ( v78094(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48607,axiom,
    ! [VarCurr: state_type] :
      ( v77772(VarCurr)
    <=> v77774(VarCurr) ) ).

tff(addAssignment_48606,axiom,
    ! [VarCurr: state_type] :
      ( v77774(VarCurr)
    <=> v77776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7282,axiom,
    ! [VarCurr: state_type] :
      ( v77776(VarCurr)
    <=> ( v77778(VarCurr)
        & v77797(VarCurr) ) ) ).

tff(addAssignment_48605,axiom,
    ! [VarCurr: state_type] :
      ( v77797(VarCurr)
    <=> v77799(VarCurr) ) ).

tff(addAssignment_48604,axiom,
    ! [VarCurr: state_type] :
      ( v77799(VarCurr)
    <=> v77801(VarCurr) ) ).

tff(addAssignment_48603,axiom,
    ! [VarCurr: state_type] :
      ( v77801(VarCurr)
    <=> v77803(VarCurr) ) ).

tff(addAssignment_48602,axiom,
    ! [VarCurr: state_type] :
      ( v77803(VarCurr)
    <=> v77805(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_285,axiom,
    ! [VarCurr: state_type] :
      ( v77805(VarCurr)
    <=> ( ( v77807(VarCurr,3)
        <=> v77811(VarCurr,3) )
        & ( v77807(VarCurr,2)
        <=> v77811(VarCurr,2) )
        & ( v77807(VarCurr,1)
        <=> v77811(VarCurr,1) )
        & ( v77807(VarCurr,0)
        <=> v77811(VarCurr,0) ) ) ) ).

tff(addAssignment_48601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77811(VarCurr,B)
      <=> v77813(VarCurr,B) ) ) ).

tff(addAssignment_48600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77813(VarCurr,B)
      <=> v77815(VarCurr,B) ) ) ).

tff(addAssignment_48599,axiom,
    ! [VarCurr: state_type] :
      ( ( v77815(VarCurr,3)
      <=> v77817(VarCurr,55) )
      & ( v77815(VarCurr,2)
      <=> v77817(VarCurr,54) )
      & ( v77815(VarCurr,1)
      <=> v77817(VarCurr,53) )
      & ( v77815(VarCurr,0)
      <=> v77817(VarCurr,52) ) ) ).

tff(addAssignment_48598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v77817(VarCurr,B)
      <=> v77819(VarCurr,B) ) ) ).

tff(addAssignment_48597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v77819(VarCurr,B)
      <=> v77821(VarCurr,B) ) ) ).

tff(addAssignment_48596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v77821(VarCurr,B)
      <=> v77823(VarCurr,B) ) ) ).

tff(addAssignment_48595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v77823(VarCurr,B)
      <=> v77825(VarCurr,B) ) ) ).

tff(addAssignment_48594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v77825(VarCurr,B)
      <=> v78069(VarCurr,B) ) ) ).

tff(addAssignment_48593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v78069(VarCurr,B)
      <=> v78082(VarCurr,B) ) ) ).

tff(addAssignment_48592,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,7)
      <=> v78081(VarCurr,3) )
      & ( v78069(VarCurr,6)
      <=> v78081(VarCurr,2) )
      & ( v78069(VarCurr,5)
      <=> v78081(VarCurr,1) )
      & ( v78069(VarCurr,4)
      <=> v78081(VarCurr,0) ) ) ).

tff(addAssignment_48591,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,11)
      <=> v78080(VarCurr,3) )
      & ( v78069(VarCurr,10)
      <=> v78080(VarCurr,2) )
      & ( v78069(VarCurr,9)
      <=> v78080(VarCurr,1) )
      & ( v78069(VarCurr,8)
      <=> v78080(VarCurr,0) ) ) ).

tff(addAssignment_48590,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,15)
      <=> v78079(VarCurr,3) )
      & ( v78069(VarCurr,14)
      <=> v78079(VarCurr,2) )
      & ( v78069(VarCurr,13)
      <=> v78079(VarCurr,1) )
      & ( v78069(VarCurr,12)
      <=> v78079(VarCurr,0) ) ) ).

tff(addAssignment_48589,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,19)
      <=> v78078(VarCurr,3) )
      & ( v78069(VarCurr,18)
      <=> v78078(VarCurr,2) )
      & ( v78069(VarCurr,17)
      <=> v78078(VarCurr,1) )
      & ( v78069(VarCurr,16)
      <=> v78078(VarCurr,0) ) ) ).

tff(addAssignment_48588,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,23)
      <=> v78077(VarCurr,3) )
      & ( v78069(VarCurr,22)
      <=> v78077(VarCurr,2) )
      & ( v78069(VarCurr,21)
      <=> v78077(VarCurr,1) )
      & ( v78069(VarCurr,20)
      <=> v78077(VarCurr,0) ) ) ).

tff(addAssignment_48587,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,27)
      <=> v78076(VarCurr,3) )
      & ( v78069(VarCurr,26)
      <=> v78076(VarCurr,2) )
      & ( v78069(VarCurr,25)
      <=> v78076(VarCurr,1) )
      & ( v78069(VarCurr,24)
      <=> v78076(VarCurr,0) ) ) ).

tff(addAssignment_48586,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,31)
      <=> v78075(VarCurr,3) )
      & ( v78069(VarCurr,30)
      <=> v78075(VarCurr,2) )
      & ( v78069(VarCurr,29)
      <=> v78075(VarCurr,1) )
      & ( v78069(VarCurr,28)
      <=> v78075(VarCurr,0) ) ) ).

tff(addAssignment_48585,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,35)
      <=> v78074(VarCurr,3) )
      & ( v78069(VarCurr,34)
      <=> v78074(VarCurr,2) )
      & ( v78069(VarCurr,33)
      <=> v78074(VarCurr,1) )
      & ( v78069(VarCurr,32)
      <=> v78074(VarCurr,0) ) ) ).

tff(addAssignment_48584,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,39)
      <=> v78073(VarCurr,3) )
      & ( v78069(VarCurr,38)
      <=> v78073(VarCurr,2) )
      & ( v78069(VarCurr,37)
      <=> v78073(VarCurr,1) )
      & ( v78069(VarCurr,36)
      <=> v78073(VarCurr,0) ) ) ).

tff(addAssignment_48583,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,43)
      <=> v78072(VarCurr,3) )
      & ( v78069(VarCurr,42)
      <=> v78072(VarCurr,2) )
      & ( v78069(VarCurr,41)
      <=> v78072(VarCurr,1) )
      & ( v78069(VarCurr,40)
      <=> v78072(VarCurr,0) ) ) ).

tff(addAssignment_48582,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,47)
      <=> v78071(VarCurr,3) )
      & ( v78069(VarCurr,46)
      <=> v78071(VarCurr,2) )
      & ( v78069(VarCurr,45)
      <=> v78071(VarCurr,1) )
      & ( v78069(VarCurr,44)
      <=> v78071(VarCurr,0) ) ) ).

tff(addAssignment_48581,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,51)
      <=> v78070(VarCurr,3) )
      & ( v78069(VarCurr,50)
      <=> v78070(VarCurr,2) )
      & ( v78069(VarCurr,49)
      <=> v78070(VarCurr,1) )
      & ( v78069(VarCurr,48)
      <=> v78070(VarCurr,0) ) ) ).

tff(addAssignment_48580,axiom,
    ! [VarCurr: state_type] :
      ( ( v78069(VarCurr,55)
      <=> v77827(VarCurr,3) )
      & ( v78069(VarCurr,54)
      <=> v77827(VarCurr,2) )
      & ( v78069(VarCurr,53)
      <=> v77827(VarCurr,1) )
      & ( v78069(VarCurr,52)
      <=> v77827(VarCurr,0) ) ) ).

tff(addAssignment_48579,axiom,
    ! [VarCurr: state_type] :
      ( v77827(VarCurr,3)
    <=> v77829(VarCurr) ) ).

tff(addAssignment_48578,axiom,
    ! [VarCurr: state_type] :
      ( v77827(VarCurr,2)
    <=> v77995(VarCurr) ) ).

tff(addAssignment_48577,axiom,
    ! [VarCurr: state_type] :
      ( v77827(VarCurr,1)
    <=> v78008(VarCurr) ) ).

tff(addAssignment_48576,axiom,
    ! [VarCurr: state_type] :
      ( v77827(VarCurr,0)
    <=> v78016(VarCurr) ) ).

tff(addAssignment_48575,axiom,
    ! [VarCurr: state_type] :
      ( v78016(VarCurr)
    <=> v78018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7281,axiom,
    ! [VarCurr: state_type] :
      ( v78018(VarCurr)
    <=> ( v78020(VarCurr)
      <~> v78044(VarCurr) ) ) ).

tff(addAssignment_48574,axiom,
    ! [VarCurr: state_type] :
      ( v78044(VarCurr)
    <=> v78046(VarCurr) ) ).

tff(addAssignment_48573,axiom,
    ! [VarCurr: state_type] :
      ( v78046(VarCurr)
    <=> v77837(VarCurr,59) ) ).

tff(addAssignment_48572,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,59)
    <=> v77894(VarCurr,59) ) ).

tff(addAssignment_48571,axiom,
    ! [VarCurr: state_type] :
      ( v77921(VarCurr)
    <=> v78049(VarCurr) ) ).

tff(addAssignment_48570,axiom,
    ! [VarCurr: state_type] :
      ( v78049(VarCurr)
    <=> v78051(VarCurr) ) ).

tff(writeUnaryOperator_3501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78051(VarCurr)
    <=> v78053(VarCurr) ) ).

tff(addAssignment_48569,axiom,
    ! [VarCurr: state_type] :
      ( v78053(VarCurr)
    <=> v78055(VarCurr) ) ).

tff(addAssignment_48568,axiom,
    ! [VarCurr: state_type] :
      ( v78055(VarCurr)
    <=> v78057(VarCurr) ) ).

tff(addAssignment_48567,axiom,
    ! [VarCurr: state_type] :
      ( v78057(VarCurr)
    <=> v78059(VarCurr) ) ).

tff(addAssignment_48566,axiom,
    ! [VarCurr: state_type] :
      ( v78059(VarCurr)
    <=> v78061(VarCurr) ) ).

tff(writeUnaryOperator_3500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v78061(VarCurr)
    <=> v78063(VarCurr) ) ).

tff(addAssignment_48565,axiom,
    ! [VarCurr: state_type] :
      ( v78063(VarCurr)
    <=> v78065(VarCurr) ) ).

tff(addAssignment_48564,axiom,
    ! [VarCurr: state_type] :
      ( v78065(VarCurr)
    <=> v77859(VarCurr,3) ) ).

tff(addAssignment_48563,axiom,
    ! [VarCurr: state_type] :
      ( v77859(VarCurr,3)
    <=> v77861(VarCurr,3) ) ).

tff(addAssignment_48562,axiom,
    ! [VarCurr: state_type] :
      ( v77861(VarCurr,3)
    <=> v77863(VarCurr,3) ) ).

tff(addAssignment_48561,axiom,
    ! [VarCurr: state_type] :
      ( v77863(VarCurr,3)
    <=> v77889(VarCurr,3) ) ).

tff(addAssignment_48560,axiom,
    ! [VarCurr: state_type] :
      ( v77884(VarCurr,3)
    <=> v77886(VarCurr,3) ) ).

tff(addAssignment_48559,axiom,
    ! [VarCurr: state_type] :
      ( v77886(VarCurr,3)
    <=> v77888(VarCurr,3) ) ).

tff(addAssignment_48558,axiom,
    ! [VarCurr: state_type] :
      ( v77888(VarCurr,3)
    <=> v67307(VarCurr,3) ) ).

tff(addAssignment_48557,axiom,
    ! [VarCurr: state_type] :
      ( v77878(VarCurr,3)
    <=> v77880(VarCurr,3) ) ).

tff(addAssignment_48556,axiom,
    ! [VarCurr: state_type] :
      ( v77880(VarCurr,3)
    <=> v77882(VarCurr,3) ) ).

tff(addAssignment_48555,axiom,
    ! [VarCurr: state_type] :
      ( v77882(VarCurr,3)
    <=> v69805(VarCurr,3) ) ).

tff(addAssignment_48554,axiom,
    ! [VarCurr: state_type] :
      ( v78020(VarCurr)
    <=> v78022(VarCurr) ) ).

tff(addAssignment_48553,axiom,
    ! [VarCurr: state_type] :
      ( v78022(VarCurr)
    <=> v78024(VarCurr) ) ).

tff(addAssignment_48552,axiom,
    ! [VarCurr: state_type] :
      ( v78024(VarCurr)
    <=> v78026(VarCurr) ) ).

tff(addAssignment_48551,axiom,
    ! [VarCurr: state_type] :
      ( v78026(VarCurr)
    <=> v78028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7280,axiom,
    ! [VarCurr: state_type] :
      ( v78028(VarCurr)
    <=> ( v78042(VarCurr)
      <~> v78038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7279,axiom,
    ! [VarCurr: state_type] :
      ( v78042(VarCurr)
    <=> ( v78030(VarCurr)
      <~> v78034(VarCurr) ) ) ).

tff(addAssignment_48550,axiom,
    ! [VarCurr: state_type] :
      ( v78038(VarCurr)
    <=> v78040(VarCurr) ) ).

tff(addAssignment_48549,axiom,
    ! [VarCurr: state_type] :
      ( v78040(VarCurr)
    <=> v77837(VarCurr,58) ) ).

tff(addAssignment_48548,axiom,
    ! [VarCurr: state_type] :
      ( v78034(VarCurr)
    <=> v78036(VarCurr) ) ).

tff(addAssignment_48547,axiom,
    ! [VarCurr: state_type] :
      ( v78036(VarCurr)
    <=> v77837(VarCurr,57) ) ).

tff(addAssignment_48546,axiom,
    ! [VarCurr: state_type] :
      ( v78030(VarCurr)
    <=> v78032(VarCurr) ) ).

tff(addAssignment_48545,axiom,
    ! [VarCurr: state_type] :
      ( v78032(VarCurr)
    <=> v77837(VarCurr,56) ) ).

tff(addAssignment_48544,axiom,
    ! [VarCurr: state_type] :
      ( v78008(VarCurr)
    <=> v78010(VarCurr) ) ).

tff(addAssignment_48543,axiom,
    ! [VarCurr: state_type] :
      ( v78010(VarCurr)
    <=> v78012(VarCurr) ) ).

tff(addAssignment_48542,axiom,
    ! [VarCurr: state_type] :
      ( v78012(VarCurr)
    <=> v78014(VarCurr) ) ).

tff(addAssignment_48541,axiom,
    ! [VarCurr: state_type] :
      ( v78014(VarCurr)
    <=> v77837(VarCurr,56) ) ).

tff(addAssignment_48540,axiom,
    ! [VarCurr: state_type] :
      ( v77995(VarCurr)
    <=> v77997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7278,axiom,
    ! [VarCurr: state_type] :
      ( v77997(VarCurr)
    <=> ( v77999(VarCurr)
      <~> v78003(VarCurr) ) ) ).

tff(addAssignment_48539,axiom,
    ! [VarCurr: state_type] :
      ( v78003(VarCurr)
    <=> v78005(VarCurr) ) ).

tff(addAssignment_48538,axiom,
    ! [VarCurr: state_type] :
      ( v78005(VarCurr)
    <=> v77837(VarCurr,57) ) ).

tff(addAssignment_48537,axiom,
    ! [VarCurr: state_type] :
      ( v77999(VarCurr)
    <=> v78001(VarCurr) ) ).

tff(addAssignment_48536,axiom,
    ! [VarCurr: state_type] :
      ( v78001(VarCurr)
    <=> v77837(VarCurr,56) ) ).

tff(addAssignment_48535,axiom,
    ! [VarCurr: state_type] :
      ( v77829(VarCurr)
    <=> v77831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7277,axiom,
    ! [VarCurr: state_type] :
      ( v77831(VarCurr)
    <=> ( v77993(VarCurr)
      <~> v77968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7276,axiom,
    ! [VarCurr: state_type] :
      ( v77993(VarCurr)
    <=> ( v77833(VarCurr)
      <~> v77943(VarCurr) ) ) ).

tff(addAssignment_48534,axiom,
    ! [VarCurr: state_type] :
      ( v77968(VarCurr)
    <=> v77970(VarCurr) ) ).

tff(addAssignment_48533,axiom,
    ! [VarCurr: state_type] :
      ( v77970(VarCurr)
    <=> v77837(VarCurr,58) ) ).

tff(addAssignment_48532,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,58)
    <=> v77894(VarCurr,58) ) ).

tff(addAssignment_48531,axiom,
    ! [VarCurr: state_type] :
      ( v77922(VarCurr)
    <=> v77973(VarCurr) ) ).

tff(addAssignment_48530,axiom,
    ! [VarCurr: state_type] :
      ( v77973(VarCurr)
    <=> v77975(VarCurr) ) ).

tff(writeUnaryOperator_3499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77975(VarCurr)
    <=> v77977(VarCurr) ) ).

tff(addAssignment_48529,axiom,
    ! [VarCurr: state_type] :
      ( v77977(VarCurr)
    <=> v77979(VarCurr) ) ).

tff(addAssignment_48528,axiom,
    ! [VarCurr: state_type] :
      ( v77979(VarCurr)
    <=> v77981(VarCurr) ) ).

tff(addAssignment_48527,axiom,
    ! [VarCurr: state_type] :
      ( v77981(VarCurr)
    <=> v77983(VarCurr) ) ).

tff(addAssignment_48526,axiom,
    ! [VarCurr: state_type] :
      ( v77983(VarCurr)
    <=> v77985(VarCurr) ) ).

tff(writeUnaryOperator_3498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77985(VarCurr)
    <=> v77987(VarCurr) ) ).

tff(addAssignment_48525,axiom,
    ! [VarCurr: state_type] :
      ( v77987(VarCurr)
    <=> v77989(VarCurr) ) ).

tff(addAssignment_48524,axiom,
    ! [VarCurr: state_type] :
      ( v77989(VarCurr)
    <=> v77859(VarCurr,2) ) ).

tff(addAssignment_48523,axiom,
    ! [VarCurr: state_type] :
      ( v77859(VarCurr,2)
    <=> v77861(VarCurr,2) ) ).

tff(addAssignment_48522,axiom,
    ! [VarCurr: state_type] :
      ( v77861(VarCurr,2)
    <=> v77863(VarCurr,2) ) ).

tff(addAssignment_48521,axiom,
    ! [VarCurr: state_type] :
      ( v77863(VarCurr,2)
    <=> v77889(VarCurr,2) ) ).

tff(addAssignment_48520,axiom,
    ! [VarCurr: state_type] :
      ( v77884(VarCurr,2)
    <=> v77886(VarCurr,2) ) ).

tff(addAssignment_48519,axiom,
    ! [VarCurr: state_type] :
      ( v77886(VarCurr,2)
    <=> v77888(VarCurr,2) ) ).

tff(addAssignment_48518,axiom,
    ! [VarCurr: state_type] :
      ( v77888(VarCurr,2)
    <=> v67307(VarCurr,2) ) ).

tff(addAssignment_48517,axiom,
    ! [VarCurr: state_type] :
      ( v77878(VarCurr,2)
    <=> v77880(VarCurr,2) ) ).

tff(addAssignment_48516,axiom,
    ! [VarCurr: state_type] :
      ( v77880(VarCurr,2)
    <=> v77882(VarCurr,2) ) ).

tff(addAssignment_48515,axiom,
    ! [VarCurr: state_type] :
      ( v77882(VarCurr,2)
    <=> v69805(VarCurr,2) ) ).

tff(addAssignment_48514,axiom,
    ! [VarCurr: state_type] :
      ( v77943(VarCurr)
    <=> v77945(VarCurr) ) ).

tff(addAssignment_48513,axiom,
    ! [VarCurr: state_type] :
      ( v77945(VarCurr)
    <=> v77837(VarCurr,57) ) ).

tff(addAssignment_48512,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,57)
    <=> v77894(VarCurr,57) ) ).

tff(addAssignment_48511,axiom,
    ! [VarCurr: state_type] :
      ( v77923(VarCurr)
    <=> v77948(VarCurr) ) ).

tff(addAssignment_48510,axiom,
    ! [VarCurr: state_type] :
      ( v77948(VarCurr)
    <=> v77950(VarCurr) ) ).

tff(writeUnaryOperator_3497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77950(VarCurr)
    <=> v77952(VarCurr) ) ).

tff(addAssignment_48509,axiom,
    ! [VarCurr: state_type] :
      ( v77952(VarCurr)
    <=> v77954(VarCurr) ) ).

tff(addAssignment_48508,axiom,
    ! [VarCurr: state_type] :
      ( v77954(VarCurr)
    <=> v77956(VarCurr) ) ).

tff(addAssignment_48507,axiom,
    ! [VarCurr: state_type] :
      ( v77956(VarCurr)
    <=> v77958(VarCurr) ) ).

tff(addAssignment_48506,axiom,
    ! [VarCurr: state_type] :
      ( v77958(VarCurr)
    <=> v77960(VarCurr) ) ).

tff(writeUnaryOperator_3496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77960(VarCurr)
    <=> v77962(VarCurr) ) ).

tff(addAssignment_48505,axiom,
    ! [VarCurr: state_type] :
      ( v77962(VarCurr)
    <=> v77964(VarCurr) ) ).

tff(addAssignment_48504,axiom,
    ! [VarCurr: state_type] :
      ( v77964(VarCurr)
    <=> v77859(VarCurr,1) ) ).

tff(addAssignment_48503,axiom,
    ! [VarCurr: state_type] :
      ( v77859(VarCurr,1)
    <=> v77861(VarCurr,1) ) ).

tff(addAssignment_48502,axiom,
    ! [VarCurr: state_type] :
      ( v77861(VarCurr,1)
    <=> v77863(VarCurr,1) ) ).

tff(addAssignment_48501,axiom,
    ! [VarCurr: state_type] :
      ( v77863(VarCurr,1)
    <=> v77889(VarCurr,1) ) ).

tff(addAssignment_48500,axiom,
    ! [VarCurr: state_type] :
      ( v77884(VarCurr,1)
    <=> v77886(VarCurr,1) ) ).

tff(addAssignment_48499,axiom,
    ! [VarCurr: state_type] :
      ( v77886(VarCurr,1)
    <=> v77888(VarCurr,1) ) ).

tff(addAssignment_48498,axiom,
    ! [VarCurr: state_type] :
      ( v77888(VarCurr,1)
    <=> v67307(VarCurr,1) ) ).

tff(addAssignment_48497,axiom,
    ! [VarCurr: state_type] :
      ( v77878(VarCurr,1)
    <=> v77880(VarCurr,1) ) ).

tff(addAssignment_48496,axiom,
    ! [VarCurr: state_type] :
      ( v77880(VarCurr,1)
    <=> v77882(VarCurr,1) ) ).

tff(addAssignment_48495,axiom,
    ! [VarCurr: state_type] :
      ( v77882(VarCurr,1)
    <=> v69805(VarCurr,1) ) ).

tff(addAssignment_48494,axiom,
    ! [VarCurr: state_type] :
      ( v77833(VarCurr)
    <=> v77835(VarCurr) ) ).

tff(addAssignment_48493,axiom,
    ! [VarCurr: state_type] :
      ( v77835(VarCurr)
    <=> v77837(VarCurr,56) ) ).

tff(addAssignment_48492,axiom,
    ! [VarCurr: state_type] :
      ( v77837(VarCurr,56)
    <=> v77894(VarCurr,56) ) ).

tff(addAssignment_48491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v77894(VarCurr,B)
      <=> v77936(VarCurr,B) ) ) ).

tff(addAssignment_48490,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,31)
      <=> v77930(VarCurr,15) )
      & ( v77894(VarCurr,30)
      <=> v77930(VarCurr,14) )
      & ( v77894(VarCurr,29)
      <=> v77930(VarCurr,13) )
      & ( v77894(VarCurr,28)
      <=> v77930(VarCurr,12) )
      & ( v77894(VarCurr,27)
      <=> v77930(VarCurr,11) )
      & ( v77894(VarCurr,26)
      <=> v77930(VarCurr,10) )
      & ( v77894(VarCurr,25)
      <=> v77930(VarCurr,9) )
      & ( v77894(VarCurr,24)
      <=> v77930(VarCurr,8) )
      & ( v77894(VarCurr,23)
      <=> v77930(VarCurr,7) )
      & ( v77894(VarCurr,22)
      <=> v77930(VarCurr,6) )
      & ( v77894(VarCurr,21)
      <=> v77930(VarCurr,5) )
      & ( v77894(VarCurr,20)
      <=> v77930(VarCurr,4) )
      & ( v77894(VarCurr,19)
      <=> v77930(VarCurr,3) )
      & ( v77894(VarCurr,18)
      <=> v77930(VarCurr,2) )
      & ( v77894(VarCurr,17)
      <=> v77930(VarCurr,1) )
      & ( v77894(VarCurr,16)
      <=> v77930(VarCurr,0) ) ) ).

tff(addAssignment_48489,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,47)
      <=> v77924(VarCurr,15) )
      & ( v77894(VarCurr,46)
      <=> v77924(VarCurr,14) )
      & ( v77894(VarCurr,45)
      <=> v77924(VarCurr,13) )
      & ( v77894(VarCurr,44)
      <=> v77924(VarCurr,12) )
      & ( v77894(VarCurr,43)
      <=> v77924(VarCurr,11) )
      & ( v77894(VarCurr,42)
      <=> v77924(VarCurr,10) )
      & ( v77894(VarCurr,41)
      <=> v77924(VarCurr,9) )
      & ( v77894(VarCurr,40)
      <=> v77924(VarCurr,8) )
      & ( v77894(VarCurr,39)
      <=> v77924(VarCurr,7) )
      & ( v77894(VarCurr,38)
      <=> v77924(VarCurr,6) )
      & ( v77894(VarCurr,37)
      <=> v77924(VarCurr,5) )
      & ( v77894(VarCurr,36)
      <=> v77924(VarCurr,4) )
      & ( v77894(VarCurr,35)
      <=> v77924(VarCurr,3) )
      & ( v77894(VarCurr,34)
      <=> v77924(VarCurr,2) )
      & ( v77894(VarCurr,33)
      <=> v77924(VarCurr,1) )
      & ( v77894(VarCurr,32)
      <=> v77924(VarCurr,0) ) ) ).

tff(addAssignment_48488,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,63)
      <=> v77919(VarCurr,15) )
      & ( v77894(VarCurr,62)
      <=> v77919(VarCurr,14) )
      & ( v77894(VarCurr,61)
      <=> v77919(VarCurr,13) )
      & ( v77894(VarCurr,60)
      <=> v77919(VarCurr,12) )
      & ( v77894(VarCurr,59)
      <=> v77919(VarCurr,11) )
      & ( v77894(VarCurr,58)
      <=> v77919(VarCurr,10) )
      & ( v77894(VarCurr,57)
      <=> v77919(VarCurr,9) )
      & ( v77894(VarCurr,56)
      <=> v77919(VarCurr,8) )
      & ( v77894(VarCurr,55)
      <=> v77919(VarCurr,7) )
      & ( v77894(VarCurr,54)
      <=> v77919(VarCurr,6) )
      & ( v77894(VarCurr,53)
      <=> v77919(VarCurr,5) )
      & ( v77894(VarCurr,52)
      <=> v77919(VarCurr,4) )
      & ( v77894(VarCurr,51)
      <=> v77919(VarCurr,3) )
      & ( v77894(VarCurr,50)
      <=> v77919(VarCurr,2) )
      & ( v77894(VarCurr,49)
      <=> v77919(VarCurr,1) )
      & ( v77894(VarCurr,48)
      <=> v77919(VarCurr,0) ) ) ).

tff(addAssignment_48487,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,79)
      <=> v77913(VarCurr,15) )
      & ( v77894(VarCurr,78)
      <=> v77913(VarCurr,14) )
      & ( v77894(VarCurr,77)
      <=> v77913(VarCurr,13) )
      & ( v77894(VarCurr,76)
      <=> v77913(VarCurr,12) )
      & ( v77894(VarCurr,75)
      <=> v77913(VarCurr,11) )
      & ( v77894(VarCurr,74)
      <=> v77913(VarCurr,10) )
      & ( v77894(VarCurr,73)
      <=> v77913(VarCurr,9) )
      & ( v77894(VarCurr,72)
      <=> v77913(VarCurr,8) )
      & ( v77894(VarCurr,71)
      <=> v77913(VarCurr,7) )
      & ( v77894(VarCurr,70)
      <=> v77913(VarCurr,6) )
      & ( v77894(VarCurr,69)
      <=> v77913(VarCurr,5) )
      & ( v77894(VarCurr,68)
      <=> v77913(VarCurr,4) )
      & ( v77894(VarCurr,67)
      <=> v77913(VarCurr,3) )
      & ( v77894(VarCurr,66)
      <=> v77913(VarCurr,2) )
      & ( v77894(VarCurr,65)
      <=> v77913(VarCurr,1) )
      & ( v77894(VarCurr,64)
      <=> v77913(VarCurr,0) ) ) ).

tff(addAssignment_48486,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,95)
      <=> v77907(VarCurr,15) )
      & ( v77894(VarCurr,94)
      <=> v77907(VarCurr,14) )
      & ( v77894(VarCurr,93)
      <=> v77907(VarCurr,13) )
      & ( v77894(VarCurr,92)
      <=> v77907(VarCurr,12) )
      & ( v77894(VarCurr,91)
      <=> v77907(VarCurr,11) )
      & ( v77894(VarCurr,90)
      <=> v77907(VarCurr,10) )
      & ( v77894(VarCurr,89)
      <=> v77907(VarCurr,9) )
      & ( v77894(VarCurr,88)
      <=> v77907(VarCurr,8) )
      & ( v77894(VarCurr,87)
      <=> v77907(VarCurr,7) )
      & ( v77894(VarCurr,86)
      <=> v77907(VarCurr,6) )
      & ( v77894(VarCurr,85)
      <=> v77907(VarCurr,5) )
      & ( v77894(VarCurr,84)
      <=> v77907(VarCurr,4) )
      & ( v77894(VarCurr,83)
      <=> v77907(VarCurr,3) )
      & ( v77894(VarCurr,82)
      <=> v77907(VarCurr,2) )
      & ( v77894(VarCurr,81)
      <=> v77907(VarCurr,1) )
      & ( v77894(VarCurr,80)
      <=> v77907(VarCurr,0) ) ) ).

tff(addAssignment_48485,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,111)
      <=> v77901(VarCurr,15) )
      & ( v77894(VarCurr,110)
      <=> v77901(VarCurr,14) )
      & ( v77894(VarCurr,109)
      <=> v77901(VarCurr,13) )
      & ( v77894(VarCurr,108)
      <=> v77901(VarCurr,12) )
      & ( v77894(VarCurr,107)
      <=> v77901(VarCurr,11) )
      & ( v77894(VarCurr,106)
      <=> v77901(VarCurr,10) )
      & ( v77894(VarCurr,105)
      <=> v77901(VarCurr,9) )
      & ( v77894(VarCurr,104)
      <=> v77901(VarCurr,8) )
      & ( v77894(VarCurr,103)
      <=> v77901(VarCurr,7) )
      & ( v77894(VarCurr,102)
      <=> v77901(VarCurr,6) )
      & ( v77894(VarCurr,101)
      <=> v77901(VarCurr,5) )
      & ( v77894(VarCurr,100)
      <=> v77901(VarCurr,4) )
      & ( v77894(VarCurr,99)
      <=> v77901(VarCurr,3) )
      & ( v77894(VarCurr,98)
      <=> v77901(VarCurr,2) )
      & ( v77894(VarCurr,97)
      <=> v77901(VarCurr,1) )
      & ( v77894(VarCurr,96)
      <=> v77901(VarCurr,0) ) ) ).

tff(addAssignment_48484,axiom,
    ! [VarCurr: state_type] :
      ( ( v77894(VarCurr,127)
      <=> v77895(VarCurr,15) )
      & ( v77894(VarCurr,126)
      <=> v77895(VarCurr,14) )
      & ( v77894(VarCurr,125)
      <=> v77895(VarCurr,13) )
      & ( v77894(VarCurr,124)
      <=> v77895(VarCurr,12) )
      & ( v77894(VarCurr,123)
      <=> v77895(VarCurr,11) )
      & ( v77894(VarCurr,122)
      <=> v77895(VarCurr,10) )
      & ( v77894(VarCurr,121)
      <=> v77895(VarCurr,9) )
      & ( v77894(VarCurr,120)
      <=> v77895(VarCurr,8) )
      & ( v77894(VarCurr,119)
      <=> v77895(VarCurr,7) )
      & ( v77894(VarCurr,118)
      <=> v77895(VarCurr,6) )
      & ( v77894(VarCurr,117)
      <=> v77895(VarCurr,5) )
      & ( v77894(VarCurr,116)
      <=> v77895(VarCurr,4) )
      & ( v77894(VarCurr,115)
      <=> v77895(VarCurr,3) )
      & ( v77894(VarCurr,114)
      <=> v77895(VarCurr,2) )
      & ( v77894(VarCurr,113)
      <=> v77895(VarCurr,1) )
      & ( v77894(VarCurr,112)
      <=> v77895(VarCurr,0) ) ) ).

tff(addAssignment_48483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77936(VarCurr,B)
      <=> v77937(VarCurr,B) ) ) ).

tff(addAssignment_48482,axiom,
    ! [VarCurr: state_type] :
      ( ( v77936(VarCurr,7)
      <=> v77937(VarCurr,3) )
      & ( v77936(VarCurr,6)
      <=> v77937(VarCurr,2) )
      & ( v77936(VarCurr,5)
      <=> v77937(VarCurr,1) )
      & ( v77936(VarCurr,4)
      <=> v77937(VarCurr,0) ) ) ).

tff(addAssignment_48481,axiom,
    ! [VarCurr: state_type] :
      ( ( v77936(VarCurr,11)
      <=> v77937(VarCurr,3) )
      & ( v77936(VarCurr,10)
      <=> v77937(VarCurr,2) )
      & ( v77936(VarCurr,9)
      <=> v77937(VarCurr,1) )
      & ( v77936(VarCurr,8)
      <=> v77937(VarCurr,0) ) ) ).

tff(addAssignment_48480,axiom,
    ! [VarCurr: state_type] :
      ( ( v77936(VarCurr,15)
      <=> v77937(VarCurr,3) )
      & ( v77936(VarCurr,14)
      <=> v77937(VarCurr,2) )
      & ( v77936(VarCurr,13)
      <=> v77937(VarCurr,1) )
      & ( v77936(VarCurr,12)
      <=> v77937(VarCurr,0) ) ) ).

tff(addAssignment_48479,axiom,
    ! [VarCurr: state_type] :
      ( v77937(VarCurr,0)
    <=> v77941(VarCurr) ) ).

tff(addAssignment_48478,axiom,
    ! [VarCurr: state_type] :
      ( v77937(VarCurr,1)
    <=> v77940(VarCurr) ) ).

tff(addAssignment_48477,axiom,
    ! [VarCurr: state_type] :
      ( v77937(VarCurr,2)
    <=> v77939(VarCurr) ) ).

tff(addAssignment_48476,axiom,
    ! [VarCurr: state_type] :
      ( v77937(VarCurr,3)
    <=> v77938(VarCurr) ) ).

tff(addAssignment_48475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77930(VarCurr,B)
      <=> v77931(VarCurr,B) ) ) ).

tff(addAssignment_48474,axiom,
    ! [VarCurr: state_type] :
      ( ( v77930(VarCurr,7)
      <=> v77931(VarCurr,3) )
      & ( v77930(VarCurr,6)
      <=> v77931(VarCurr,2) )
      & ( v77930(VarCurr,5)
      <=> v77931(VarCurr,1) )
      & ( v77930(VarCurr,4)
      <=> v77931(VarCurr,0) ) ) ).

tff(addAssignment_48473,axiom,
    ! [VarCurr: state_type] :
      ( ( v77930(VarCurr,11)
      <=> v77931(VarCurr,3) )
      & ( v77930(VarCurr,10)
      <=> v77931(VarCurr,2) )
      & ( v77930(VarCurr,9)
      <=> v77931(VarCurr,1) )
      & ( v77930(VarCurr,8)
      <=> v77931(VarCurr,0) ) ) ).

tff(addAssignment_48472,axiom,
    ! [VarCurr: state_type] :
      ( ( v77930(VarCurr,15)
      <=> v77931(VarCurr,3) )
      & ( v77930(VarCurr,14)
      <=> v77931(VarCurr,2) )
      & ( v77930(VarCurr,13)
      <=> v77931(VarCurr,1) )
      & ( v77930(VarCurr,12)
      <=> v77931(VarCurr,0) ) ) ).

tff(addAssignment_48471,axiom,
    ! [VarCurr: state_type] :
      ( v77931(VarCurr,0)
    <=> v77935(VarCurr) ) ).

tff(addAssignment_48470,axiom,
    ! [VarCurr: state_type] :
      ( v77931(VarCurr,1)
    <=> v77934(VarCurr) ) ).

tff(addAssignment_48469,axiom,
    ! [VarCurr: state_type] :
      ( v77931(VarCurr,2)
    <=> v77933(VarCurr) ) ).

tff(addAssignment_48468,axiom,
    ! [VarCurr: state_type] :
      ( v77931(VarCurr,3)
    <=> v77932(VarCurr) ) ).

tff(addAssignment_48467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77924(VarCurr,B)
      <=> v77925(VarCurr,B) ) ) ).

tff(addAssignment_48466,axiom,
    ! [VarCurr: state_type] :
      ( ( v77924(VarCurr,7)
      <=> v77925(VarCurr,3) )
      & ( v77924(VarCurr,6)
      <=> v77925(VarCurr,2) )
      & ( v77924(VarCurr,5)
      <=> v77925(VarCurr,1) )
      & ( v77924(VarCurr,4)
      <=> v77925(VarCurr,0) ) ) ).

tff(addAssignment_48465,axiom,
    ! [VarCurr: state_type] :
      ( ( v77924(VarCurr,11)
      <=> v77925(VarCurr,3) )
      & ( v77924(VarCurr,10)
      <=> v77925(VarCurr,2) )
      & ( v77924(VarCurr,9)
      <=> v77925(VarCurr,1) )
      & ( v77924(VarCurr,8)
      <=> v77925(VarCurr,0) ) ) ).

tff(addAssignment_48464,axiom,
    ! [VarCurr: state_type] :
      ( ( v77924(VarCurr,15)
      <=> v77925(VarCurr,3) )
      & ( v77924(VarCurr,14)
      <=> v77925(VarCurr,2) )
      & ( v77924(VarCurr,13)
      <=> v77925(VarCurr,1) )
      & ( v77924(VarCurr,12)
      <=> v77925(VarCurr,0) ) ) ).

tff(addAssignment_48463,axiom,
    ! [VarCurr: state_type] :
      ( v77925(VarCurr,0)
    <=> v77929(VarCurr) ) ).

tff(addAssignment_48462,axiom,
    ! [VarCurr: state_type] :
      ( v77925(VarCurr,1)
    <=> v77928(VarCurr) ) ).

tff(addAssignment_48461,axiom,
    ! [VarCurr: state_type] :
      ( v77925(VarCurr,2)
    <=> v77927(VarCurr) ) ).

tff(addAssignment_48460,axiom,
    ! [VarCurr: state_type] :
      ( v77925(VarCurr,3)
    <=> v77926(VarCurr) ) ).

tff(addAssignment_48459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77919(VarCurr,B)
      <=> v77920(VarCurr,B) ) ) ).

tff(addAssignment_48458,axiom,
    ! [VarCurr: state_type] :
      ( ( v77919(VarCurr,7)
      <=> v77920(VarCurr,3) )
      & ( v77919(VarCurr,6)
      <=> v77920(VarCurr,2) )
      & ( v77919(VarCurr,5)
      <=> v77920(VarCurr,1) )
      & ( v77919(VarCurr,4)
      <=> v77920(VarCurr,0) ) ) ).

tff(addAssignment_48457,axiom,
    ! [VarCurr: state_type] :
      ( ( v77919(VarCurr,11)
      <=> v77920(VarCurr,3) )
      & ( v77919(VarCurr,10)
      <=> v77920(VarCurr,2) )
      & ( v77919(VarCurr,9)
      <=> v77920(VarCurr,1) )
      & ( v77919(VarCurr,8)
      <=> v77920(VarCurr,0) ) ) ).

tff(addAssignment_48456,axiom,
    ! [VarCurr: state_type] :
      ( ( v77919(VarCurr,15)
      <=> v77920(VarCurr,3) )
      & ( v77919(VarCurr,14)
      <=> v77920(VarCurr,2) )
      & ( v77919(VarCurr,13)
      <=> v77920(VarCurr,1) )
      & ( v77919(VarCurr,12)
      <=> v77920(VarCurr,0) ) ) ).

tff(addAssignment_48455,axiom,
    ! [VarCurr: state_type] :
      ( v77920(VarCurr,0)
    <=> v77839(VarCurr) ) ).

tff(addAssignment_48454,axiom,
    ! [VarCurr: state_type] :
      ( v77920(VarCurr,1)
    <=> v77923(VarCurr) ) ).

tff(addAssignment_48453,axiom,
    ! [VarCurr: state_type] :
      ( v77920(VarCurr,2)
    <=> v77922(VarCurr) ) ).

tff(addAssignment_48452,axiom,
    ! [VarCurr: state_type] :
      ( v77920(VarCurr,3)
    <=> v77921(VarCurr) ) ).

tff(addAssignment_48451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77913(VarCurr,B)
      <=> v77914(VarCurr,B) ) ) ).

tff(addAssignment_48450,axiom,
    ! [VarCurr: state_type] :
      ( ( v77913(VarCurr,7)
      <=> v77914(VarCurr,3) )
      & ( v77913(VarCurr,6)
      <=> v77914(VarCurr,2) )
      & ( v77913(VarCurr,5)
      <=> v77914(VarCurr,1) )
      & ( v77913(VarCurr,4)
      <=> v77914(VarCurr,0) ) ) ).

tff(addAssignment_48449,axiom,
    ! [VarCurr: state_type] :
      ( ( v77913(VarCurr,11)
      <=> v77914(VarCurr,3) )
      & ( v77913(VarCurr,10)
      <=> v77914(VarCurr,2) )
      & ( v77913(VarCurr,9)
      <=> v77914(VarCurr,1) )
      & ( v77913(VarCurr,8)
      <=> v77914(VarCurr,0) ) ) ).

tff(addAssignment_48448,axiom,
    ! [VarCurr: state_type] :
      ( ( v77913(VarCurr,15)
      <=> v77914(VarCurr,3) )
      & ( v77913(VarCurr,14)
      <=> v77914(VarCurr,2) )
      & ( v77913(VarCurr,13)
      <=> v77914(VarCurr,1) )
      & ( v77913(VarCurr,12)
      <=> v77914(VarCurr,0) ) ) ).

tff(addAssignment_48447,axiom,
    ! [VarCurr: state_type] :
      ( v77914(VarCurr,0)
    <=> v77918(VarCurr) ) ).

tff(addAssignment_48446,axiom,
    ! [VarCurr: state_type] :
      ( v77914(VarCurr,1)
    <=> v77917(VarCurr) ) ).

tff(addAssignment_48445,axiom,
    ! [VarCurr: state_type] :
      ( v77914(VarCurr,2)
    <=> v77916(VarCurr) ) ).

tff(addAssignment_48444,axiom,
    ! [VarCurr: state_type] :
      ( v77914(VarCurr,3)
    <=> v77915(VarCurr) ) ).

tff(addAssignment_48443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77907(VarCurr,B)
      <=> v77908(VarCurr,B) ) ) ).

tff(addAssignment_48442,axiom,
    ! [VarCurr: state_type] :
      ( ( v77907(VarCurr,7)
      <=> v77908(VarCurr,3) )
      & ( v77907(VarCurr,6)
      <=> v77908(VarCurr,2) )
      & ( v77907(VarCurr,5)
      <=> v77908(VarCurr,1) )
      & ( v77907(VarCurr,4)
      <=> v77908(VarCurr,0) ) ) ).

tff(addAssignment_48441,axiom,
    ! [VarCurr: state_type] :
      ( ( v77907(VarCurr,11)
      <=> v77908(VarCurr,3) )
      & ( v77907(VarCurr,10)
      <=> v77908(VarCurr,2) )
      & ( v77907(VarCurr,9)
      <=> v77908(VarCurr,1) )
      & ( v77907(VarCurr,8)
      <=> v77908(VarCurr,0) ) ) ).

tff(addAssignment_48440,axiom,
    ! [VarCurr: state_type] :
      ( ( v77907(VarCurr,15)
      <=> v77908(VarCurr,3) )
      & ( v77907(VarCurr,14)
      <=> v77908(VarCurr,2) )
      & ( v77907(VarCurr,13)
      <=> v77908(VarCurr,1) )
      & ( v77907(VarCurr,12)
      <=> v77908(VarCurr,0) ) ) ).

tff(addAssignment_48439,axiom,
    ! [VarCurr: state_type] :
      ( v77908(VarCurr,0)
    <=> v77912(VarCurr) ) ).

tff(addAssignment_48438,axiom,
    ! [VarCurr: state_type] :
      ( v77908(VarCurr,1)
    <=> v77911(VarCurr) ) ).

tff(addAssignment_48437,axiom,
    ! [VarCurr: state_type] :
      ( v77908(VarCurr,2)
    <=> v77910(VarCurr) ) ).

tff(addAssignment_48436,axiom,
    ! [VarCurr: state_type] :
      ( v77908(VarCurr,3)
    <=> v77909(VarCurr) ) ).

tff(addAssignment_48435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77901(VarCurr,B)
      <=> v77902(VarCurr,B) ) ) ).

tff(addAssignment_48434,axiom,
    ! [VarCurr: state_type] :
      ( ( v77901(VarCurr,7)
      <=> v77902(VarCurr,3) )
      & ( v77901(VarCurr,6)
      <=> v77902(VarCurr,2) )
      & ( v77901(VarCurr,5)
      <=> v77902(VarCurr,1) )
      & ( v77901(VarCurr,4)
      <=> v77902(VarCurr,0) ) ) ).

tff(addAssignment_48433,axiom,
    ! [VarCurr: state_type] :
      ( ( v77901(VarCurr,11)
      <=> v77902(VarCurr,3) )
      & ( v77901(VarCurr,10)
      <=> v77902(VarCurr,2) )
      & ( v77901(VarCurr,9)
      <=> v77902(VarCurr,1) )
      & ( v77901(VarCurr,8)
      <=> v77902(VarCurr,0) ) ) ).

tff(addAssignment_48432,axiom,
    ! [VarCurr: state_type] :
      ( ( v77901(VarCurr,15)
      <=> v77902(VarCurr,3) )
      & ( v77901(VarCurr,14)
      <=> v77902(VarCurr,2) )
      & ( v77901(VarCurr,13)
      <=> v77902(VarCurr,1) )
      & ( v77901(VarCurr,12)
      <=> v77902(VarCurr,0) ) ) ).

tff(addAssignment_48431,axiom,
    ! [VarCurr: state_type] :
      ( v77902(VarCurr,0)
    <=> v77906(VarCurr) ) ).

tff(addAssignment_48430,axiom,
    ! [VarCurr: state_type] :
      ( v77902(VarCurr,1)
    <=> v77905(VarCurr) ) ).

tff(addAssignment_48429,axiom,
    ! [VarCurr: state_type] :
      ( v77902(VarCurr,2)
    <=> v77904(VarCurr) ) ).

tff(addAssignment_48428,axiom,
    ! [VarCurr: state_type] :
      ( v77902(VarCurr,3)
    <=> v77903(VarCurr) ) ).

tff(addAssignment_48427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77895(VarCurr,B)
      <=> v77896(VarCurr,B) ) ) ).

tff(addAssignment_48426,axiom,
    ! [VarCurr: state_type] :
      ( ( v77895(VarCurr,7)
      <=> v77896(VarCurr,3) )
      & ( v77895(VarCurr,6)
      <=> v77896(VarCurr,2) )
      & ( v77895(VarCurr,5)
      <=> v77896(VarCurr,1) )
      & ( v77895(VarCurr,4)
      <=> v77896(VarCurr,0) ) ) ).

tff(addAssignment_48425,axiom,
    ! [VarCurr: state_type] :
      ( ( v77895(VarCurr,11)
      <=> v77896(VarCurr,3) )
      & ( v77895(VarCurr,10)
      <=> v77896(VarCurr,2) )
      & ( v77895(VarCurr,9)
      <=> v77896(VarCurr,1) )
      & ( v77895(VarCurr,8)
      <=> v77896(VarCurr,0) ) ) ).

tff(addAssignment_48424,axiom,
    ! [VarCurr: state_type] :
      ( ( v77895(VarCurr,15)
      <=> v77896(VarCurr,3) )
      & ( v77895(VarCurr,14)
      <=> v77896(VarCurr,2) )
      & ( v77895(VarCurr,13)
      <=> v77896(VarCurr,1) )
      & ( v77895(VarCurr,12)
      <=> v77896(VarCurr,0) ) ) ).

tff(addAssignment_48423,axiom,
    ! [VarCurr: state_type] :
      ( v77896(VarCurr,0)
    <=> v77900(VarCurr) ) ).

tff(addAssignment_48422,axiom,
    ! [VarCurr: state_type] :
      ( v77896(VarCurr,1)
    <=> v77899(VarCurr) ) ).

tff(addAssignment_48421,axiom,
    ! [VarCurr: state_type] :
      ( v77896(VarCurr,2)
    <=> v77898(VarCurr) ) ).

tff(addAssignment_48420,axiom,
    ! [VarCurr: state_type] :
      ( v77896(VarCurr,3)
    <=> v77897(VarCurr) ) ).

tff(addAssignment_48419,axiom,
    ! [VarCurr: state_type] :
      ( v77839(VarCurr)
    <=> v77841(VarCurr) ) ).

tff(addAssignment_48418,axiom,
    ! [VarCurr: state_type] :
      ( v77841(VarCurr)
    <=> v77843(VarCurr) ) ).

tff(writeUnaryOperator_3495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77843(VarCurr)
    <=> v77845(VarCurr) ) ).

tff(addAssignment_48417,axiom,
    ! [VarCurr: state_type] :
      ( v77845(VarCurr)
    <=> v77847(VarCurr) ) ).

tff(addAssignment_48416,axiom,
    ! [VarCurr: state_type] :
      ( v77847(VarCurr)
    <=> v77849(VarCurr) ) ).

tff(addAssignment_48415,axiom,
    ! [VarCurr: state_type] :
      ( v77849(VarCurr)
    <=> v77851(VarCurr) ) ).

tff(addAssignment_48414,axiom,
    ! [VarCurr: state_type] :
      ( v77851(VarCurr)
    <=> v77853(VarCurr) ) ).

tff(writeUnaryOperator_3494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77853(VarCurr)
    <=> v77855(VarCurr) ) ).

tff(addAssignment_48413,axiom,
    ! [VarCurr: state_type] :
      ( v77855(VarCurr)
    <=> v77857(VarCurr) ) ).

tff(addAssignment_48412,axiom,
    ! [VarCurr: state_type] :
      ( v77857(VarCurr)
    <=> v77859(VarCurr,0) ) ).

tff(addAssignment_48411,axiom,
    ! [VarCurr: state_type] :
      ( v77859(VarCurr,0)
    <=> v77861(VarCurr,0) ) ).

tff(addAssignment_48410,axiom,
    ! [VarCurr: state_type] :
      ( v77861(VarCurr,0)
    <=> v77863(VarCurr,0) ) ).

tff(addAssignment_48409,axiom,
    ! [VarCurr: state_type] :
      ( v77863(VarCurr,0)
    <=> v77889(VarCurr,0) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_7,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v77890(VarCurr)
        & ~ v77891(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v77889(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_14,axiom,
    ! [VarCurr: state_type] :
      ( v77891(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v77889(VarCurr,B)
          <=> v77884(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_14,axiom,
    ! [VarCurr: state_type] :
      ( v77890(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v77889(VarCurr,B)
          <=> v77878(VarCurr,B) ) ) ) ).

tff(addBitVectorEqualityBitBlasted_284,axiom,
    ! [VarCurr: state_type] :
      ( v77891(VarCurr)
    <=> ( v77865(VarCurr)
      <=> $true ) ) ).

tff(addBitVectorEqualityBitBlasted_283,axiom,
    ! [VarCurr: state_type] :
      ( v77890(VarCurr)
    <=> ( v77865(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_48408,axiom,
    ! [VarCurr: state_type] :
      ( v77884(VarCurr,0)
    <=> v77886(VarCurr,0) ) ).

tff(addAssignment_48407,axiom,
    ! [VarCurr: state_type] :
      ( v77886(VarCurr,0)
    <=> v77888(VarCurr,0) ) ).

tff(addAssignment_48406,axiom,
    ! [VarCurr: state_type] :
      ( v77888(VarCurr,0)
    <=> v67307(VarCurr,0) ) ).

tff(addAssignment_48405,axiom,
    ! [VarCurr: state_type] :
      ( v77878(VarCurr,0)
    <=> v77880(VarCurr,0) ) ).

tff(addAssignment_48404,axiom,
    ! [VarCurr: state_type] :
      ( v77880(VarCurr,0)
    <=> v77882(VarCurr,0) ) ).

tff(addAssignment_48403,axiom,
    ! [VarCurr: state_type] :
      ( v77882(VarCurr,0)
    <=> v69805(VarCurr,0) ) ).

tff(addAssignment_48402,axiom,
    ! [VarCurr: state_type] :
      ( v77865(VarCurr)
    <=> v77867(VarCurr) ) ).

tff(addAssignment_48401,axiom,
    ! [VarCurr: state_type] :
      ( v77867(VarCurr)
    <=> v77869(VarCurr) ) ).

tff(writeUnaryOperator_3493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77869(VarCurr)
    <=> v77871(VarCurr) ) ).

tff(addAssignment_48400,axiom,
    ! [VarCurr: state_type] :
      ( v77871(VarCurr)
    <=> v77873(VarCurr) ) ).

tff(addAssignment_48399,axiom,
    ! [VarCurr: state_type] :
      ( v77873(VarCurr)
    <=> v77875(VarCurr) ) ).

tff(addAssignment_48398,axiom,
    ! [VarCurr: state_type] :
      ( v77875(VarCurr)
    <=> v69785(VarCurr) ) ).

tff(addAssignment_48397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77807(VarCurr,B)
      <=> v77809(VarCurr,B) ) ) ).

tff(addAssignment_48396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77809(VarCurr,B)
      <=> v67247(VarCurr,B) ) ) ).

tff(addAssignment_48395,axiom,
    ! [VarCurr: state_type] :
      ( v77778(VarCurr)
    <=> v77780(VarCurr) ) ).

tff(addAssignment_48394,axiom,
    ! [VarCurr: state_type] :
      ( v77780(VarCurr)
    <=> v77782(VarCurr) ) ).

tff(addAssignment_48393,axiom,
    ! [VarCurr: state_type] :
      ( v77782(VarCurr)
    <=> v77784(VarCurr) ) ).

tff(addAssignment_48392,axiom,
    ! [VarCurr: state_type] :
      ( v77784(VarCurr)
    <=> v77786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7275,axiom,
    ! [VarCurr: state_type] :
      ( v77786(VarCurr)
    <=> ( v77788(VarCurr)
        & v77792(VarCurr) ) ) ).

tff(addAssignment_48391,axiom,
    ! [VarCurr: state_type] :
      ( v77792(VarCurr)
    <=> v77794(VarCurr) ) ).

tff(addAssignment_48390,axiom,
    ! [VarCurr: state_type] :
      ( v77794(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_48389,axiom,
    ! [VarCurr: state_type] :
      ( v77788(VarCurr)
    <=> v77790(VarCurr) ) ).

tff(addAssignment_48388,axiom,
    ! [VarCurr: state_type] :
      ( v77790(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48387,axiom,
    ! [VarCurr: state_type] :
      ( v77704(VarCurr)
    <=> v77706(VarCurr) ) ).

tff(addAssignment_48386,axiom,
    ! [VarCurr: state_type] :
      ( v77706(VarCurr)
    <=> v67197(VarCurr,3) ) ).

tff(addAssignment_48385,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,3)
    <=> v77708(VarCurr) ) ).

tff(addAssignment_48384,axiom,
    ! [VarCurr: state_type] :
      ( v77708(VarCurr)
    <=> v77710(VarCurr) ) ).

tff(writeUnaryOperator_3492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77710(VarCurr)
    <=> v77744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7274,axiom,
    ! [VarCurr: state_type] :
      ( v77744(VarCurr)
    <=> ( v77712(VarCurr)
        | v77740(VarCurr) ) ) ).

tff(addAssignment_48383,axiom,
    ! [VarCurr: state_type] :
      ( v77740(VarCurr)
    <=> v77742(VarCurr) ) ).

tff(addAssignment_48382,axiom,
    ! [VarCurr: state_type] :
      ( v77742(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48381,axiom,
    ! [VarCurr: state_type] :
      ( v77712(VarCurr)
    <=> v77714(VarCurr) ) ).

tff(addAssignment_48380,axiom,
    ! [VarCurr: state_type] :
      ( v77714(VarCurr)
    <=> v67207(VarCurr,3) ) ).

tff(addAssignment_48379,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,3)
    <=> v77716(VarCurr) ) ).

tff(addAssignment_48378,axiom,
    ! [VarCurr: state_type] :
      ( v77716(VarCurr)
    <=> v77718(VarCurr) ) ).

tff(writeUnaryOperator_3491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77718(VarCurr)
    <=> v77736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7273,axiom,
    ! [VarCurr: state_type] :
      ( v77736(VarCurr)
    <=> ( v77737(VarCurr)
        & v77732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7272,axiom,
    ! [VarCurr: state_type] :
      ( v77737(VarCurr)
    <=> ( v77738(VarCurr)
        & v77728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7271,axiom,
    ! [VarCurr: state_type] :
      ( v77738(VarCurr)
    <=> ( v77720(VarCurr)
        & v77724(VarCurr) ) ) ).

tff(addAssignment_48377,axiom,
    ! [VarCurr: state_type] :
      ( v77732(VarCurr)
    <=> v77734(VarCurr) ) ).

tff(addAssignment_48376,axiom,
    ! [VarCurr: state_type] :
      ( v77734(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48375,axiom,
    ! [VarCurr: state_type] :
      ( v77728(VarCurr)
    <=> v77730(VarCurr) ) ).

tff(addAssignment_48374,axiom,
    ! [VarCurr: state_type] :
      ( v77730(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_48373,axiom,
    ! [VarCurr: state_type] :
      ( v77724(VarCurr)
    <=> v77726(VarCurr) ) ).

tff(addAssignment_48372,axiom,
    ! [VarCurr: state_type] :
      ( v77726(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48371,axiom,
    ! [VarCurr: state_type] :
      ( v77720(VarCurr)
    <=> v77722(VarCurr) ) ).

tff(addAssignment_48370,axiom,
    ! [VarCurr: state_type] :
      ( v77722(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48369,axiom,
    ! [VarCurr: state_type] :
      ( v77652(VarCurr)
    <=> v77654(VarCurr) ) ).

tff(addAssignment_48368,axiom,
    ! [VarCurr: state_type] :
      ( v77654(VarCurr)
    <=> v67197(VarCurr,4) ) ).

tff(addAssignment_48367,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,4)
    <=> v77656(VarCurr) ) ).

tff(addAssignment_48366,axiom,
    ! [VarCurr: state_type] :
      ( v77656(VarCurr)
    <=> v77658(VarCurr) ) ).

tff(writeUnaryOperator_3490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77658(VarCurr)
    <=> v77692(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7270,axiom,
    ! [VarCurr: state_type] :
      ( v77692(VarCurr)
    <=> ( v77660(VarCurr)
        | v77688(VarCurr) ) ) ).

tff(addAssignment_48365,axiom,
    ! [VarCurr: state_type] :
      ( v77688(VarCurr)
    <=> v77690(VarCurr) ) ).

tff(addAssignment_48364,axiom,
    ! [VarCurr: state_type] :
      ( v77690(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48363,axiom,
    ! [VarCurr: state_type] :
      ( v77660(VarCurr)
    <=> v77662(VarCurr) ) ).

tff(addAssignment_48362,axiom,
    ! [VarCurr: state_type] :
      ( v77662(VarCurr)
    <=> v67207(VarCurr,4) ) ).

tff(addAssignment_48361,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,4)
    <=> v77664(VarCurr) ) ).

tff(addAssignment_48360,axiom,
    ! [VarCurr: state_type] :
      ( v77664(VarCurr)
    <=> v77666(VarCurr) ) ).

tff(writeUnaryOperator_3489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77666(VarCurr)
    <=> v77684(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7269,axiom,
    ! [VarCurr: state_type] :
      ( v77684(VarCurr)
    <=> ( v77685(VarCurr)
        & v77680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7268,axiom,
    ! [VarCurr: state_type] :
      ( v77685(VarCurr)
    <=> ( v77686(VarCurr)
        & v77676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7267,axiom,
    ! [VarCurr: state_type] :
      ( v77686(VarCurr)
    <=> ( v77668(VarCurr)
        & v77672(VarCurr) ) ) ).

tff(addAssignment_48359,axiom,
    ! [VarCurr: state_type] :
      ( v77680(VarCurr)
    <=> v77682(VarCurr) ) ).

tff(addAssignment_48358,axiom,
    ! [VarCurr: state_type] :
      ( v77682(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48357,axiom,
    ! [VarCurr: state_type] :
      ( v77676(VarCurr)
    <=> v77678(VarCurr) ) ).

tff(addAssignment_48356,axiom,
    ! [VarCurr: state_type] :
      ( v77678(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_48355,axiom,
    ! [VarCurr: state_type] :
      ( v77672(VarCurr)
    <=> v77674(VarCurr) ) ).

tff(addAssignment_48354,axiom,
    ! [VarCurr: state_type] :
      ( v77674(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48353,axiom,
    ! [VarCurr: state_type] :
      ( v77668(VarCurr)
    <=> v77670(VarCurr) ) ).

tff(addAssignment_48352,axiom,
    ! [VarCurr: state_type] :
      ( v77670(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48351,axiom,
    ! [VarCurr: state_type] :
      ( v77503(VarCurr)
    <=> v77505(VarCurr) ) ).

tff(addAssignment_48350,axiom,
    ! [VarCurr: state_type] :
      ( v77505(VarCurr)
    <=> v77507(VarCurr) ) ).

tff(addAssignment_48349,axiom,
    ! [VarCurr: state_type] :
      ( v77507(VarCurr)
    <=> v77509(VarCurr) ) ).

tff(addAssignment_48348,axiom,
    ! [VarCurr: state_type] :
      ( v77509(VarCurr)
    <=> v77511(VarCurr) ) ).

tff(writeUnaryOperator_3488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77511(VarCurr)
    <=> v77639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7266,axiom,
    ! [VarCurr: state_type] :
      ( v77639(VarCurr)
    <=> ( v77640(VarCurr)
        | v77597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7265,axiom,
    ! [VarCurr: state_type] :
      ( v77640(VarCurr)
    <=> ( v77513(VarCurr)
        | v77555(VarCurr) ) ) ).

tff(addAssignment_48347,axiom,
    ! [VarCurr: state_type] :
      ( v77597(VarCurr)
    <=> v77599(VarCurr) ) ).

tff(addAssignment_48346,axiom,
    ! [VarCurr: state_type] :
      ( v77599(VarCurr)
    <=> v67197(VarCurr,5) ) ).

tff(addAssignment_48345,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,5)
    <=> v77601(VarCurr) ) ).

tff(addAssignment_48344,axiom,
    ! [VarCurr: state_type] :
      ( v77601(VarCurr)
    <=> v77603(VarCurr) ) ).

tff(writeUnaryOperator_3487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77603(VarCurr)
    <=> v77637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7264,axiom,
    ! [VarCurr: state_type] :
      ( v77637(VarCurr)
    <=> ( v77605(VarCurr)
        | v77633(VarCurr) ) ) ).

tff(addAssignment_48343,axiom,
    ! [VarCurr: state_type] :
      ( v77633(VarCurr)
    <=> v77635(VarCurr) ) ).

tff(addAssignment_48342,axiom,
    ! [VarCurr: state_type] :
      ( v77635(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48341,axiom,
    ! [VarCurr: state_type] :
      ( v77605(VarCurr)
    <=> v77607(VarCurr) ) ).

tff(addAssignment_48340,axiom,
    ! [VarCurr: state_type] :
      ( v77607(VarCurr)
    <=> v67207(VarCurr,5) ) ).

tff(addAssignment_48339,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,5)
    <=> v77609(VarCurr) ) ).

tff(addAssignment_48338,axiom,
    ! [VarCurr: state_type] :
      ( v77609(VarCurr)
    <=> v77611(VarCurr) ) ).

tff(writeUnaryOperator_3486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77611(VarCurr)
    <=> v77629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7263,axiom,
    ! [VarCurr: state_type] :
      ( v77629(VarCurr)
    <=> ( v77630(VarCurr)
        & v77625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7262,axiom,
    ! [VarCurr: state_type] :
      ( v77630(VarCurr)
    <=> ( v77631(VarCurr)
        & v77621(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7261,axiom,
    ! [VarCurr: state_type] :
      ( v77631(VarCurr)
    <=> ( v77613(VarCurr)
        & v77617(VarCurr) ) ) ).

tff(addAssignment_48337,axiom,
    ! [VarCurr: state_type] :
      ( v77625(VarCurr)
    <=> v77627(VarCurr) ) ).

tff(addAssignment_48336,axiom,
    ! [VarCurr: state_type] :
      ( v77627(VarCurr)
    <=> v77437(VarCurr) ) ).

tff(addAssignment_48335,axiom,
    ! [VarCurr: state_type] :
      ( v77621(VarCurr)
    <=> v77623(VarCurr) ) ).

tff(addAssignment_48334,axiom,
    ! [VarCurr: state_type] :
      ( v77623(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_48333,axiom,
    ! [VarCurr: state_type] :
      ( v77617(VarCurr)
    <=> v77619(VarCurr) ) ).

tff(addAssignment_48332,axiom,
    ! [VarCurr: state_type] :
      ( v77619(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48331,axiom,
    ! [VarCurr: state_type] :
      ( v77613(VarCurr)
    <=> v77615(VarCurr) ) ).

tff(addAssignment_48330,axiom,
    ! [VarCurr: state_type] :
      ( v77615(VarCurr)
    <=> v67217(VarCurr) ) ).

tff(addAssignment_48329,axiom,
    ! [VarCurr: state_type] :
      ( v77555(VarCurr)
    <=> v77557(VarCurr) ) ).

tff(addAssignment_48328,axiom,
    ! [VarCurr: state_type] :
      ( v77557(VarCurr)
    <=> v67197(VarCurr,6) ) ).

tff(addAssignment_48327,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,6)
    <=> v77559(VarCurr) ) ).

tff(addAssignment_48326,axiom,
    ! [VarCurr: state_type] :
      ( v77559(VarCurr)
    <=> v77561(VarCurr) ) ).

tff(writeUnaryOperator_3485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77561(VarCurr)
    <=> v77595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7260,axiom,
    ! [VarCurr: state_type] :
      ( v77595(VarCurr)
    <=> ( v77563(VarCurr)
        | v77591(VarCurr) ) ) ).

tff(addAssignment_48325,axiom,
    ! [VarCurr: state_type] :
      ( v77591(VarCurr)
    <=> v77593(VarCurr) ) ).

tff(addAssignment_48324,axiom,
    ! [VarCurr: state_type] :
      ( v77593(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48323,axiom,
    ! [VarCurr: state_type] :
      ( v77563(VarCurr)
    <=> v77565(VarCurr) ) ).

tff(addAssignment_48322,axiom,
    ! [VarCurr: state_type] :
      ( v77565(VarCurr)
    <=> v67207(VarCurr,6) ) ).

tff(addAssignment_48321,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,6)
    <=> v77567(VarCurr) ) ).

tff(addAssignment_48320,axiom,
    ! [VarCurr: state_type] :
      ( v77567(VarCurr)
    <=> v77569(VarCurr) ) ).

tff(writeUnaryOperator_3484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77569(VarCurr)
    <=> v77587(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7259,axiom,
    ! [VarCurr: state_type] :
      ( v77587(VarCurr)
    <=> ( v77588(VarCurr)
        & v77583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7258,axiom,
    ! [VarCurr: state_type] :
      ( v77588(VarCurr)
    <=> ( v77589(VarCurr)
        & v77579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7257,axiom,
    ! [VarCurr: state_type] :
      ( v77589(VarCurr)
    <=> ( v77571(VarCurr)
        & v77575(VarCurr) ) ) ).

tff(addAssignment_48319,axiom,
    ! [VarCurr: state_type] :
      ( v77583(VarCurr)
    <=> v77585(VarCurr) ) ).

tff(addAssignment_48318,axiom,
    ! [VarCurr: state_type] :
      ( v77585(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48317,axiom,
    ! [VarCurr: state_type] :
      ( v77579(VarCurr)
    <=> v77581(VarCurr) ) ).

tff(addAssignment_48316,axiom,
    ! [VarCurr: state_type] :
      ( v77581(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_48315,axiom,
    ! [VarCurr: state_type] :
      ( v77575(VarCurr)
    <=> v77577(VarCurr) ) ).

tff(addAssignment_48314,axiom,
    ! [VarCurr: state_type] :
      ( v77577(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48313,axiom,
    ! [VarCurr: state_type] :
      ( v77571(VarCurr)
    <=> v77573(VarCurr) ) ).

tff(addAssignment_48312,axiom,
    ! [VarCurr: state_type] :
      ( v77573(VarCurr)
    <=> v67217(VarCurr) ) ).

tff(addAssignment_48311,axiom,
    ! [VarCurr: state_type] :
      ( v77513(VarCurr)
    <=> v77515(VarCurr) ) ).

tff(addAssignment_48310,axiom,
    ! [VarCurr: state_type] :
      ( v77515(VarCurr)
    <=> v67197(VarCurr,7) ) ).

tff(addAssignment_48309,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,7)
    <=> v77517(VarCurr) ) ).

tff(addAssignment_48308,axiom,
    ! [VarCurr: state_type] :
      ( v77517(VarCurr)
    <=> v77519(VarCurr) ) ).

tff(writeUnaryOperator_3483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77519(VarCurr)
    <=> v77553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7256,axiom,
    ! [VarCurr: state_type] :
      ( v77553(VarCurr)
    <=> ( v77521(VarCurr)
        | v77549(VarCurr) ) ) ).

tff(addAssignment_48307,axiom,
    ! [VarCurr: state_type] :
      ( v77549(VarCurr)
    <=> v77551(VarCurr) ) ).

tff(addAssignment_48306,axiom,
    ! [VarCurr: state_type] :
      ( v77551(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48305,axiom,
    ! [VarCurr: state_type] :
      ( v77521(VarCurr)
    <=> v77523(VarCurr) ) ).

tff(addAssignment_48304,axiom,
    ! [VarCurr: state_type] :
      ( v77523(VarCurr)
    <=> v67207(VarCurr,7) ) ).

tff(addAssignment_48303,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,7)
    <=> v77525(VarCurr) ) ).

tff(addAssignment_48302,axiom,
    ! [VarCurr: state_type] :
      ( v77525(VarCurr)
    <=> v77527(VarCurr) ) ).

tff(writeUnaryOperator_3482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77527(VarCurr)
    <=> v77545(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7255,axiom,
    ! [VarCurr: state_type] :
      ( v77545(VarCurr)
    <=> ( v77546(VarCurr)
        & v77541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7254,axiom,
    ! [VarCurr: state_type] :
      ( v77546(VarCurr)
    <=> ( v77547(VarCurr)
        & v77537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7253,axiom,
    ! [VarCurr: state_type] :
      ( v77547(VarCurr)
    <=> ( v77529(VarCurr)
        & v77533(VarCurr) ) ) ).

tff(addAssignment_48301,axiom,
    ! [VarCurr: state_type] :
      ( v77541(VarCurr)
    <=> v77543(VarCurr) ) ).

tff(addAssignment_48300,axiom,
    ! [VarCurr: state_type] :
      ( v77543(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48299,axiom,
    ! [VarCurr: state_type] :
      ( v77537(VarCurr)
    <=> v77539(VarCurr) ) ).

tff(addAssignment_48298,axiom,
    ! [VarCurr: state_type] :
      ( v77539(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_48297,axiom,
    ! [VarCurr: state_type] :
      ( v77533(VarCurr)
    <=> v77535(VarCurr) ) ).

tff(addAssignment_48296,axiom,
    ! [VarCurr: state_type] :
      ( v77535(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_48295,axiom,
    ! [VarCurr: state_type] :
      ( v77529(VarCurr)
    <=> v77531(VarCurr) ) ).

tff(addAssignment_48294,axiom,
    ! [VarCurr: state_type] :
      ( v77531(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48293,axiom,
    ! [VarCurr: state_type] :
      ( v67183(VarCurr)
    <=> v67185(VarCurr) ) ).

tff(addAssignment_48292,axiom,
    ! [VarCurr: state_type] :
      ( v67185(VarCurr)
    <=> v67187(VarCurr) ) ).

tff(addAssignment_48291,axiom,
    ! [VarCurr: state_type] :
      ( v67187(VarCurr)
    <=> v67189(VarCurr) ) ).

tff(addAssignment_48290,axiom,
    ! [VarCurr: state_type] :
      ( v67189(VarCurr)
    <=> v67191(VarCurr) ) ).

tff(writeUnaryOperator_3481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67191(VarCurr)
    <=> v77500(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7252,axiom,
    ! [VarCurr: state_type] :
      ( v77500(VarCurr)
    <=> ( v77501(VarCurr)
        | v77458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7251,axiom,
    ! [VarCurr: state_type] :
      ( v77501(VarCurr)
    <=> ( v67193(VarCurr)
        | v77394(VarCurr) ) ) ).

tff(addAssignment_48289,axiom,
    ! [VarCurr: state_type] :
      ( v77458(VarCurr)
    <=> v77460(VarCurr) ) ).

tff(addAssignment_48288,axiom,
    ! [VarCurr: state_type] :
      ( v77460(VarCurr)
    <=> v67197(VarCurr,8) ) ).

tff(addAssignment_48287,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,8)
    <=> v77462(VarCurr) ) ).

tff(addAssignment_48286,axiom,
    ! [VarCurr: state_type] :
      ( v77462(VarCurr)
    <=> v77464(VarCurr) ) ).

tff(writeUnaryOperator_3480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77464(VarCurr)
    <=> v77498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7250,axiom,
    ! [VarCurr: state_type] :
      ( v77498(VarCurr)
    <=> ( v77466(VarCurr)
        | v77494(VarCurr) ) ) ).

tff(addAssignment_48285,axiom,
    ! [VarCurr: state_type] :
      ( v77494(VarCurr)
    <=> v77496(VarCurr) ) ).

tff(addAssignment_48284,axiom,
    ! [VarCurr: state_type] :
      ( v77496(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48283,axiom,
    ! [VarCurr: state_type] :
      ( v77466(VarCurr)
    <=> v77468(VarCurr) ) ).

tff(addAssignment_48282,axiom,
    ! [VarCurr: state_type] :
      ( v77468(VarCurr)
    <=> v67207(VarCurr,8) ) ).

tff(addAssignment_48281,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,8)
    <=> v77470(VarCurr) ) ).

tff(addAssignment_48280,axiom,
    ! [VarCurr: state_type] :
      ( v77470(VarCurr)
    <=> v77472(VarCurr) ) ).

tff(writeUnaryOperator_3479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77472(VarCurr)
    <=> v77490(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7249,axiom,
    ! [VarCurr: state_type] :
      ( v77490(VarCurr)
    <=> ( v77491(VarCurr)
        & v77486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7248,axiom,
    ! [VarCurr: state_type] :
      ( v77491(VarCurr)
    <=> ( v77492(VarCurr)
        & v77482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7247,axiom,
    ! [VarCurr: state_type] :
      ( v77492(VarCurr)
    <=> ( v77474(VarCurr)
        & v77478(VarCurr) ) ) ).

tff(addAssignment_48279,axiom,
    ! [VarCurr: state_type] :
      ( v77486(VarCurr)
    <=> v77488(VarCurr) ) ).

tff(addAssignment_48278,axiom,
    ! [VarCurr: state_type] :
      ( v77488(VarCurr)
    <=> v77437(VarCurr) ) ).

tff(addAssignment_48277,axiom,
    ! [VarCurr: state_type] :
      ( v77482(VarCurr)
    <=> v77484(VarCurr) ) ).

tff(addAssignment_48276,axiom,
    ! [VarCurr: state_type] :
      ( v77484(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_48275,axiom,
    ! [VarCurr: state_type] :
      ( v77478(VarCurr)
    <=> v77480(VarCurr) ) ).

tff(addAssignment_48274,axiom,
    ! [VarCurr: state_type] :
      ( v77480(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_48273,axiom,
    ! [VarCurr: state_type] :
      ( v77474(VarCurr)
    <=> v77476(VarCurr) ) ).

tff(addAssignment_48272,axiom,
    ! [VarCurr: state_type] :
      ( v77476(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48271,axiom,
    ! [VarCurr: state_type] :
      ( v77394(VarCurr)
    <=> v77396(VarCurr) ) ).

tff(addAssignment_48270,axiom,
    ! [VarCurr: state_type] :
      ( v77396(VarCurr)
    <=> v67197(VarCurr,9) ) ).

tff(addAssignment_48269,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,9)
    <=> v77398(VarCurr) ) ).

tff(addAssignment_48268,axiom,
    ! [VarCurr: state_type] :
      ( v77398(VarCurr)
    <=> v77400(VarCurr) ) ).

tff(writeUnaryOperator_3478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77400(VarCurr)
    <=> v77456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7246,axiom,
    ! [VarCurr: state_type] :
      ( v77456(VarCurr)
    <=> ( v77402(VarCurr)
        | v77452(VarCurr) ) ) ).

tff(addAssignment_48267,axiom,
    ! [VarCurr: state_type] :
      ( v77452(VarCurr)
    <=> v77454(VarCurr) ) ).

tff(addAssignment_48266,axiom,
    ! [VarCurr: state_type] :
      ( v77454(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48265,axiom,
    ! [VarCurr: state_type] :
      ( v77402(VarCurr)
    <=> v77404(VarCurr) ) ).

tff(addAssignment_48264,axiom,
    ! [VarCurr: state_type] :
      ( v77404(VarCurr)
    <=> v67207(VarCurr,9) ) ).

tff(addAssignment_48263,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,9)
    <=> v77406(VarCurr) ) ).

tff(addAssignment_48262,axiom,
    ! [VarCurr: state_type] :
      ( v77406(VarCurr)
    <=> v77408(VarCurr) ) ).

tff(writeUnaryOperator_3477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77408(VarCurr)
    <=> v77448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7245,axiom,
    ! [VarCurr: state_type] :
      ( v77448(VarCurr)
    <=> ( v77449(VarCurr)
        & v77433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7244,axiom,
    ! [VarCurr: state_type] :
      ( v77449(VarCurr)
    <=> ( v77450(VarCurr)
        & v77418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7243,axiom,
    ! [VarCurr: state_type] :
      ( v77450(VarCurr)
    <=> ( v77410(VarCurr)
        & v77414(VarCurr) ) ) ).

tff(addAssignment_48261,axiom,
    ! [VarCurr: state_type] :
      ( v77433(VarCurr)
    <=> v77435(VarCurr) ) ).

tff(addAssignment_48260,axiom,
    ! [VarCurr: state_type] :
      ( v77435(VarCurr)
    <=> v77437(VarCurr) ) ).

tff(addAssignment_48259,axiom,
    ! [VarCurr: state_type] :
      ( v77437(VarCurr)
    <=> v77439(VarCurr) ) ).

tff(addAssignment_48258,axiom,
    ! [VarCurr: state_type] :
      ( v77439(VarCurr)
    <=> v77441(VarCurr) ) ).

tff(writeUnaryOperator_3476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77441(VarCurr)
    <=> v77443(VarCurr) ) ).

tff(addAssignment_48257,axiom,
    ! [VarCurr: state_type] :
      ( v77443(VarCurr)
    <=> v77445(VarCurr) ) ).

tff(addAssignment_48256,axiom,
    ! [VarCurr: state_type] :
      ( v77445(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48255,axiom,
    ! [VarCurr: state_type] :
      ( v77418(VarCurr)
    <=> v77420(VarCurr) ) ).

tff(addAssignment_48254,axiom,
    ! [VarCurr: state_type] :
      ( v77420(VarCurr)
    <=> v77422(VarCurr) ) ).

tff(addAssignment_48253,axiom,
    ! [VarCurr: state_type] :
      ( v77422(VarCurr)
    <=> v77424(VarCurr) ) ).

tff(addAssignment_48252,axiom,
    ! [VarCurr: state_type] :
      ( v77424(VarCurr)
    <=> v77426(VarCurr) ) ).

tff(writeUnaryOperator_3475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77426(VarCurr)
    <=> v77428(VarCurr) ) ).

tff(addAssignment_48251,axiom,
    ! [VarCurr: state_type] :
      ( v77428(VarCurr)
    <=> v77430(VarCurr) ) ).

tff(addAssignment_48250,axiom,
    ! [VarCurr: state_type] :
      ( v77430(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_48249,axiom,
    ! [VarCurr: state_type] :
      ( v77414(VarCurr)
    <=> v77416(VarCurr) ) ).

tff(addAssignment_48248,axiom,
    ! [VarCurr: state_type] :
      ( v77416(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48247,axiom,
    ! [VarCurr: state_type] :
      ( v77410(VarCurr)
    <=> v77412(VarCurr) ) ).

tff(addAssignment_48246,axiom,
    ! [VarCurr: state_type] :
      ( v77412(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48245,axiom,
    ! [VarCurr: state_type] :
      ( v67193(VarCurr)
    <=> v67195(VarCurr) ) ).

tff(addAssignment_48244,axiom,
    ! [VarCurr: state_type] :
      ( v67195(VarCurr)
    <=> v67197(VarCurr,10) ) ).

tff(addAssignment_48243,axiom,
    ! [VarCurr: state_type] :
      ( v67197(VarCurr,10)
    <=> v67199(VarCurr) ) ).

tff(addAssignment_48242,axiom,
    ! [VarCurr: state_type] :
      ( v67199(VarCurr)
    <=> v67201(VarCurr) ) ).

tff(writeUnaryOperator_3474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67201(VarCurr)
    <=> v77392(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7242,axiom,
    ! [VarCurr: state_type] :
      ( v77392(VarCurr)
    <=> ( v67203(VarCurr)
        | v77388(VarCurr) ) ) ).

tff(addAssignment_48241,axiom,
    ! [VarCurr: state_type] :
      ( v77388(VarCurr)
    <=> v77390(VarCurr) ) ).

tff(addAssignment_48240,axiom,
    ! [VarCurr: state_type] :
      ( v77390(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_48239,axiom,
    ! [VarCurr: state_type] :
      ( v67203(VarCurr)
    <=> v67205(VarCurr) ) ).

tff(addAssignment_48238,axiom,
    ! [VarCurr: state_type] :
      ( v67205(VarCurr)
    <=> v67207(VarCurr,10) ) ).

tff(addAssignment_48237,axiom,
    ! [VarCurr: state_type] :
      ( v67207(VarCurr,10)
    <=> v67209(VarCurr) ) ).

tff(addAssignment_48236,axiom,
    ! [VarCurr: state_type] :
      ( v67209(VarCurr)
    <=> v67211(VarCurr) ) ).

tff(writeUnaryOperator_3473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67211(VarCurr)
    <=> v77384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7241,axiom,
    ! [VarCurr: state_type] :
      ( v77384(VarCurr)
    <=> ( v77385(VarCurr)
        & v77294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7240,axiom,
    ! [VarCurr: state_type] :
      ( v77385(VarCurr)
    <=> ( v77386(VarCurr)
        & v77194(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7239,axiom,
    ! [VarCurr: state_type] :
      ( v77386(VarCurr)
    <=> ( v67213(VarCurr)
        & v77024(VarCurr) ) ) ).

tff(addAssignment_48235,axiom,
    ! [VarCurr: state_type] :
      ( v77294(VarCurr)
    <=> v77296(VarCurr) ) ).

tff(addAssignment_48234,axiom,
    ! [VarCurr: state_type] :
      ( v77296(VarCurr)
    <=> v77298(VarCurr) ) ).

tff(addAssignment_48233,axiom,
    ! [VarCurr: state_type] :
      ( v77298(VarCurr)
    <=> v77300(VarCurr) ) ).

tff(addAssignment_48232,axiom,
    ! [VarCurr: state_type] :
      ( v77300(VarCurr)
    <=> v77302(VarCurr) ) ).

tff(writeUnaryOperator_3472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77302(VarCurr)
    <=> v77382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7238,axiom,
    ! [VarCurr: state_type] :
      ( v77382(VarCurr)
    <=> ( v77304(VarCurr)
        & v77362(VarCurr) ) ) ).

tff(addAssignment_48231,axiom,
    ! [VarCurr: state_type] :
      ( v77362(VarCurr)
    <=> v77364(VarCurr) ) ).

tff(addAssignment_48230,axiom,
    ! [VarCurr: state_type] :
      ( v77364(VarCurr)
    <=> v77366(VarCurr) ) ).

tff(addAssignment_48229,axiom,
    ! [VarCurr: state_type] :
      ( v77366(VarCurr)
    <=> v77368(VarCurr) ) ).

tff(addAssignment_48228,axiom,
    ! [VarCurr: state_type] :
      ( v77368(VarCurr)
    <=> v77370(VarCurr) ) ).

tff(writeUnaryOperator_3471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77370(VarCurr)
    <=> v77380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7237,axiom,
    ! [VarCurr: state_type] :
      ( v77380(VarCurr)
    <=> ( v77372(VarCurr)
        | v77376(VarCurr) ) ) ).

tff(addAssignment_48227,axiom,
    ! [VarCurr: state_type] :
      ( v77376(VarCurr)
    <=> v77378(VarCurr) ) ).

tff(addAssignment_48226,axiom,
    ! [VarCurr: state_type] :
      ( v77378(VarCurr)
    <=> v77318(VarCurr,0) ) ).

tff(addAssignment_48225,axiom,
    ! [VarCurr: state_type] :
      ( v77318(VarCurr,0)
    <=> v77320(VarCurr,0) ) ).

tff(addAssignment_48224,axiom,
    ! [VarCurr: state_type] :
      ( v77320(VarCurr,0)
    <=> v77322(VarCurr,0) ) ).

tff(addAssignment_48223,axiom,
    ! [VarCurr: state_type] :
      ( v77322(VarCurr,0)
    <=> v77354(VarCurr,0) ) ).

tff(addAssignment_48222,axiom,
    ! [VarCurr: state_type] :
      ( v77351(VarCurr,0)
    <=> v77353(VarCurr,0) ) ).

tff(addAssignment_48221,axiom,
    ! [VarCurr: state_type] :
      ( v77353(VarCurr,0)
    <=> v71560(VarCurr,0) ) ).

tff(addAssignment_48220,axiom,
    ! [VarCurr: state_type] :
      ( v77324(VarCurr,0)
    <=> v77326(VarCurr,0) ) ).

tff(addAssignment_48219,axiom,
    ! [VarCurr: state_type] :
      ( v77326(VarCurr,0)
    <=> v77348(VarCurr,0) ) ).

tff(addAssignment_48218,axiom,
    ! [VarCurr: state_type] :
      ( v77372(VarCurr)
    <=> v77374(VarCurr) ) ).

tff(addAssignment_48217,axiom,
    ! [VarCurr: state_type] :
      ( v77374(VarCurr)
    <=> v77318(VarCurr,1) ) ).

tff(addAssignment_48216,axiom,
    ! [VarCurr: state_type] :
      ( v77318(VarCurr,1)
    <=> v77320(VarCurr,1) ) ).

tff(addAssignment_48215,axiom,
    ! [VarCurr: state_type] :
      ( v77320(VarCurr,1)
    <=> v77322(VarCurr,1) ) ).

tff(addAssignment_48214,axiom,
    ! [VarCurr: state_type] :
      ( v77322(VarCurr,1)
    <=> v77354(VarCurr,1) ) ).

tff(addAssignment_48213,axiom,
    ! [VarCurr: state_type] :
      ( v77351(VarCurr,1)
    <=> v77353(VarCurr,1) ) ).

tff(addAssignment_48212,axiom,
    ! [VarCurr: state_type] :
      ( v77353(VarCurr,1)
    <=> v71560(VarCurr,1) ) ).

tff(addAssignment_48211,axiom,
    ! [VarCurr: state_type] :
      ( v77324(VarCurr,1)
    <=> v77326(VarCurr,1) ) ).

tff(addAssignment_48210,axiom,
    ! [VarCurr: state_type] :
      ( v77326(VarCurr,1)
    <=> v77348(VarCurr,1) ) ).

tff(addAssignment_48209,axiom,
    ! [VarCurr: state_type] :
      ( v77304(VarCurr)
    <=> v77306(VarCurr) ) ).

tff(addAssignment_48208,axiom,
    ! [VarCurr: state_type] :
      ( v77306(VarCurr)
    <=> v77308(VarCurr) ) ).

tff(addAssignment_48207,axiom,
    ! [VarCurr: state_type] :
      ( v77308(VarCurr)
    <=> v77310(VarCurr) ) ).

tff(addAssignment_48206,axiom,
    ! [VarCurr: state_type] :
      ( v77310(VarCurr)
    <=> v77312(VarCurr) ) ).

tff(writeUnaryOperator_3470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77312(VarCurr)
    <=> v77360(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7236,axiom,
    ! [VarCurr: state_type] :
      ( v77360(VarCurr)
    <=> ( v77314(VarCurr)
        | v77356(VarCurr) ) ) ).

tff(addAssignment_48205,axiom,
    ! [VarCurr: state_type] :
      ( v77356(VarCurr)
    <=> v77358(VarCurr) ) ).

tff(addAssignment_48204,axiom,
    ! [VarCurr: state_type] :
      ( v77358(VarCurr)
    <=> v77318(VarCurr,2) ) ).

tff(addAssignment_48203,axiom,
    ! [VarCurr: state_type] :
      ( v77318(VarCurr,2)
    <=> v77320(VarCurr,2) ) ).

tff(addAssignment_48202,axiom,
    ! [VarCurr: state_type] :
      ( v77320(VarCurr,2)
    <=> v77322(VarCurr,2) ) ).

tff(addAssignment_48201,axiom,
    ! [VarCurr: state_type] :
      ( v77322(VarCurr,2)
    <=> v77354(VarCurr,2) ) ).

tff(addAssignment_48200,axiom,
    ! [VarCurr: state_type] :
      ( v77351(VarCurr,2)
    <=> v77353(VarCurr,2) ) ).

tff(addAssignment_48199,axiom,
    ! [VarCurr: state_type] :
      ( v77353(VarCurr,2)
    <=> v71560(VarCurr,2) ) ).

tff(addAssignment_48198,axiom,
    ! [VarCurr: state_type] :
      ( v77324(VarCurr,2)
    <=> v77326(VarCurr,2) ) ).

tff(addAssignment_48197,axiom,
    ! [VarCurr: state_type] :
      ( v77326(VarCurr,2)
    <=> v77348(VarCurr,2) ) ).

tff(addAssignment_48196,axiom,
    ! [VarCurr: state_type] :
      ( v77314(VarCurr)
    <=> v77316(VarCurr) ) ).

tff(addAssignment_48195,axiom,
    ! [VarCurr: state_type] :
      ( v77316(VarCurr)
    <=> v77318(VarCurr,3) ) ).

tff(addAssignment_48194,axiom,
    ! [VarCurr: state_type] :
      ( v77318(VarCurr,3)
    <=> v77320(VarCurr,3) ) ).

tff(addAssignment_48193,axiom,
    ! [VarCurr: state_type] :
      ( v77320(VarCurr,3)
    <=> v77322(VarCurr,3) ) ).

tff(addAssignment_48192,axiom,
    ! [VarCurr: state_type] :
      ( v77322(VarCurr,3)
    <=> v77354(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77354(VarCurr,B)
      <=> ( v77324(VarCurr,B)
          & v77351(VarCurr,B) ) ) ) ).

tff(addAssignment_48191,axiom,
    ! [VarCurr: state_type] :
      ( v77351(VarCurr,3)
    <=> v77353(VarCurr,3) ) ).

tff(addAssignment_48190,axiom,
    ! [VarCurr: state_type] :
      ( v77353(VarCurr,3)
    <=> v71560(VarCurr,3) ) ).

tff(addAssignment_48189,axiom,
    ! [VarCurr: state_type] :
      ( v77324(VarCurr,3)
    <=> v77326(VarCurr,3) ) ).

tff(addAssignment_48188,axiom,
    ! [VarCurr: state_type] :
      ( v77326(VarCurr,3)
    <=> v77348(VarCurr,3) ) ).

tff(addAssignment_48187,axiom,
    ! [VarCurr: state_type] :
      ( v77348(VarCurr,0)
    <=> v77349(VarCurr) ) ).

tff(addAssignment_48186,axiom,
    ! [VarCurr: state_type] :
      ( v77348(VarCurr,1)
    <=> v77349(VarCurr) ) ).

tff(addAssignment_48185,axiom,
    ! [VarCurr: state_type] :
      ( v77348(VarCurr,2)
    <=> v77349(VarCurr) ) ).

tff(addAssignment_48184,axiom,
    ! [VarCurr: state_type] :
      ( v77348(VarCurr,3)
    <=> v77349(VarCurr) ) ).

tff(addAssignment_48183,axiom,
    ! [VarCurr: state_type] :
      ( v77349(VarCurr)
    <=> v77328(VarCurr) ) ).

tff(addAssignment_48182,axiom,
    ! [VarCurr: state_type] :
      ( v77328(VarCurr)
    <=> v77330(VarCurr) ) ).

tff(addAssignment_48181,axiom,
    ! [VarCurr: state_type] :
      ( v77330(VarCurr)
    <=> v77332(VarCurr) ) ).

tff(writeUnaryOperator_3469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77332(VarCurr)
    <=> v77346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7235,axiom,
    ! [VarCurr: state_type] :
      ( v77346(VarCurr)
    <=> ( v77347(VarCurr)
        & v77342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7234,axiom,
    ! [VarCurr: state_type] :
      ( v77347(VarCurr)
    <=> ( v77334(VarCurr)
        & v77338(VarCurr) ) ) ).

tff(addAssignment_48180,axiom,
    ! [VarCurr: state_type] :
      ( v77342(VarCurr)
    <=> v77344(VarCurr) ) ).

tff(addAssignment_48179,axiom,
    ! [VarCurr: state_type] :
      ( v77344(VarCurr)
    <=> v69775(VarCurr) ) ).

tff(addAssignment_48178,axiom,
    ! [VarCurr: state_type] :
      ( v77338(VarCurr)
    <=> v77340(VarCurr) ) ).

tff(addAssignment_48177,axiom,
    ! [VarCurr: state_type] :
      ( v77340(VarCurr)
    <=> v67277(VarCurr) ) ).

tff(addAssignment_48176,axiom,
    ! [VarCurr: state_type] :
      ( v77334(VarCurr)
    <=> v77336(VarCurr) ) ).

tff(addAssignment_48175,axiom,
    ! [VarCurr: state_type] :
      ( v77336(VarCurr)
    <=> v77088(VarCurr) ) ).

tff(addAssignment_48174,axiom,
    ! [VarCurr: state_type] :
      ( v77194(VarCurr)
    <=> v77196(VarCurr) ) ).

tff(addAssignment_48173,axiom,
    ! [VarCurr: state_type] :
      ( v77196(VarCurr)
    <=> v77198(VarCurr) ) ).

tff(addAssignment_48172,axiom,
    ! [VarCurr: state_type] :
      ( v77198(VarCurr)
    <=> v77200(VarCurr) ) ).

tff(addAssignment_48171,axiom,
    ! [VarCurr: state_type] :
      ( v77200(VarCurr)
    <=> v77202(VarCurr) ) ).

tff(writeUnaryOperator_3468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77202(VarCurr)
    <=> v77292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7233,axiom,
    ! [VarCurr: state_type] :
      ( v77292(VarCurr)
    <=> ( v77204(VarCurr)
        & v77272(VarCurr) ) ) ).

tff(addAssignment_48170,axiom,
    ! [VarCurr: state_type] :
      ( v77272(VarCurr)
    <=> v77274(VarCurr) ) ).

tff(addAssignment_48169,axiom,
    ! [VarCurr: state_type] :
      ( v77274(VarCurr)
    <=> v77276(VarCurr) ) ).

tff(addAssignment_48168,axiom,
    ! [VarCurr: state_type] :
      ( v77276(VarCurr)
    <=> v77278(VarCurr) ) ).

tff(addAssignment_48167,axiom,
    ! [VarCurr: state_type] :
      ( v77278(VarCurr)
    <=> v77280(VarCurr) ) ).

tff(writeUnaryOperator_3467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77280(VarCurr)
    <=> v77290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7232,axiom,
    ! [VarCurr: state_type] :
      ( v77290(VarCurr)
    <=> ( v77282(VarCurr)
        | v77286(VarCurr) ) ) ).

tff(addAssignment_48166,axiom,
    ! [VarCurr: state_type] :
      ( v77286(VarCurr)
    <=> v77288(VarCurr) ) ).

tff(addAssignment_48165,axiom,
    ! [VarCurr: state_type] :
      ( v77288(VarCurr)
    <=> v77218(VarCurr,0) ) ).

tff(addAssignment_48164,axiom,
    ! [VarCurr: state_type] :
      ( v77218(VarCurr,0)
    <=> v77220(VarCurr,0) ) ).

tff(addAssignment_48163,axiom,
    ! [VarCurr: state_type] :
      ( v77220(VarCurr,0)
    <=> v77222(VarCurr,0) ) ).

tff(addAssignment_48162,axiom,
    ! [VarCurr: state_type] :
      ( v77222(VarCurr,0)
    <=> v77264(VarCurr,0) ) ).

tff(addAssignment_48161,axiom,
    ! [VarCurr: state_type] :
      ( v77261(VarCurr,0)
    <=> v77263(VarCurr,0) ) ).

tff(addAssignment_48160,axiom,
    ! [VarCurr: state_type] :
      ( v77263(VarCurr,0)
    <=> v69805(VarCurr,0) ) ).

tff(addAssignment_48159,axiom,
    ! [VarCurr: state_type] :
      ( v77224(VarCurr,0)
    <=> v77226(VarCurr,0) ) ).

tff(addAssignment_48158,axiom,
    ! [VarCurr: state_type] :
      ( v77226(VarCurr,0)
    <=> v77258(VarCurr,0) ) ).

tff(addAssignment_48157,axiom,
    ! [VarCurr: state_type] :
      ( v77282(VarCurr)
    <=> v77284(VarCurr) ) ).

tff(addAssignment_48156,axiom,
    ! [VarCurr: state_type] :
      ( v77284(VarCurr)
    <=> v77218(VarCurr,1) ) ).

tff(addAssignment_48155,axiom,
    ! [VarCurr: state_type] :
      ( v77218(VarCurr,1)
    <=> v77220(VarCurr,1) ) ).

tff(addAssignment_48154,axiom,
    ! [VarCurr: state_type] :
      ( v77220(VarCurr,1)
    <=> v77222(VarCurr,1) ) ).

tff(addAssignment_48153,axiom,
    ! [VarCurr: state_type] :
      ( v77222(VarCurr,1)
    <=> v77264(VarCurr,1) ) ).

tff(addAssignment_48152,axiom,
    ! [VarCurr: state_type] :
      ( v77261(VarCurr,1)
    <=> v77263(VarCurr,1) ) ).

tff(addAssignment_48151,axiom,
    ! [VarCurr: state_type] :
      ( v77263(VarCurr,1)
    <=> v69805(VarCurr,1) ) ).

tff(addAssignment_48150,axiom,
    ! [VarCurr: state_type] :
      ( v77224(VarCurr,1)
    <=> v77226(VarCurr,1) ) ).

tff(addAssignment_48149,axiom,
    ! [VarCurr: state_type] :
      ( v77226(VarCurr,1)
    <=> v77258(VarCurr,1) ) ).

tff(addAssignment_48148,axiom,
    ! [VarCurr: state_type] :
      ( v77204(VarCurr)
    <=> v77206(VarCurr) ) ).

tff(addAssignment_48147,axiom,
    ! [VarCurr: state_type] :
      ( v77206(VarCurr)
    <=> v77208(VarCurr) ) ).

tff(addAssignment_48146,axiom,
    ! [VarCurr: state_type] :
      ( v77208(VarCurr)
    <=> v77210(VarCurr) ) ).

tff(addAssignment_48145,axiom,
    ! [VarCurr: state_type] :
      ( v77210(VarCurr)
    <=> v77212(VarCurr) ) ).

tff(writeUnaryOperator_3466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77212(VarCurr)
    <=> v77270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7231,axiom,
    ! [VarCurr: state_type] :
      ( v77270(VarCurr)
    <=> ( v77214(VarCurr)
        | v77266(VarCurr) ) ) ).

tff(addAssignment_48144,axiom,
    ! [VarCurr: state_type] :
      ( v77266(VarCurr)
    <=> v77268(VarCurr) ) ).

tff(addAssignment_48143,axiom,
    ! [VarCurr: state_type] :
      ( v77268(VarCurr)
    <=> v77218(VarCurr,2) ) ).

tff(addAssignment_48142,axiom,
    ! [VarCurr: state_type] :
      ( v77218(VarCurr,2)
    <=> v77220(VarCurr,2) ) ).

tff(addAssignment_48141,axiom,
    ! [VarCurr: state_type] :
      ( v77220(VarCurr,2)
    <=> v77222(VarCurr,2) ) ).

tff(addAssignment_48140,axiom,
    ! [VarCurr: state_type] :
      ( v77222(VarCurr,2)
    <=> v77264(VarCurr,2) ) ).

tff(addAssignment_48139,axiom,
    ! [VarCurr: state_type] :
      ( v77261(VarCurr,2)
    <=> v77263(VarCurr,2) ) ).

tff(addAssignment_48138,axiom,
    ! [VarCurr: state_type] :
      ( v77263(VarCurr,2)
    <=> v69805(VarCurr,2) ) ).

tff(addAssignment_48137,axiom,
    ! [VarCurr: state_type] :
      ( v77224(VarCurr,2)
    <=> v77226(VarCurr,2) ) ).

tff(addAssignment_48136,axiom,
    ! [VarCurr: state_type] :
      ( v77226(VarCurr,2)
    <=> v77258(VarCurr,2) ) ).

tff(addAssignment_48135,axiom,
    ! [VarCurr: state_type] :
      ( v77214(VarCurr)
    <=> v77216(VarCurr) ) ).

tff(addAssignment_48134,axiom,
    ! [VarCurr: state_type] :
      ( v77216(VarCurr)
    <=> v77218(VarCurr,3) ) ).

tff(addAssignment_48133,axiom,
    ! [VarCurr: state_type] :
      ( v77218(VarCurr,3)
    <=> v77220(VarCurr,3) ) ).

tff(addAssignment_48132,axiom,
    ! [VarCurr: state_type] :
      ( v77220(VarCurr,3)
    <=> v77222(VarCurr,3) ) ).

tff(addAssignment_48131,axiom,
    ! [VarCurr: state_type] :
      ( v77222(VarCurr,3)
    <=> v77264(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77264(VarCurr,B)
      <=> ( v77224(VarCurr,B)
          & v77261(VarCurr,B) ) ) ) ).

tff(addAssignment_48130,axiom,
    ! [VarCurr: state_type] :
      ( v77261(VarCurr,3)
    <=> v77263(VarCurr,3) ) ).

tff(addAssignment_48129,axiom,
    ! [VarCurr: state_type] :
      ( v77263(VarCurr,3)
    <=> v69805(VarCurr,3) ) ).

tff(addAssignment_48128,axiom,
    ! [VarCurr: state_type] :
      ( v77224(VarCurr,3)
    <=> v77226(VarCurr,3) ) ).

tff(addAssignment_48127,axiom,
    ! [VarCurr: state_type] :
      ( v77226(VarCurr,3)
    <=> v77258(VarCurr,3) ) ).

tff(addAssignment_48126,axiom,
    ! [VarCurr: state_type] :
      ( v77258(VarCurr,0)
    <=> v77259(VarCurr) ) ).

tff(addAssignment_48125,axiom,
    ! [VarCurr: state_type] :
      ( v77258(VarCurr,1)
    <=> v77259(VarCurr) ) ).

tff(addAssignment_48124,axiom,
    ! [VarCurr: state_type] :
      ( v77258(VarCurr,2)
    <=> v77259(VarCurr) ) ).

tff(addAssignment_48123,axiom,
    ! [VarCurr: state_type] :
      ( v77258(VarCurr,3)
    <=> v77259(VarCurr) ) ).

tff(addAssignment_48122,axiom,
    ! [VarCurr: state_type] :
      ( v77259(VarCurr)
    <=> v77228(VarCurr) ) ).

tff(addAssignment_48121,axiom,
    ! [VarCurr: state_type] :
      ( v77228(VarCurr)
    <=> v77230(VarCurr) ) ).

tff(addAssignment_48120,axiom,
    ! [VarCurr: state_type] :
      ( v77230(VarCurr)
    <=> v77232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7230,axiom,
    ! [VarCurr: state_type] :
      ( v77232(VarCurr)
    <=> ( v77234(VarCurr)
        | v77254(VarCurr) ) ) ).

tff(addAssignment_48119,axiom,
    ! [VarCurr: state_type] :
      ( v77254(VarCurr)
    <=> v77256(VarCurr) ) ).

tff(addAssignment_48118,axiom,
    ! [VarCurr: state_type] :
      ( v77256(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_48117,axiom,
    ! [VarCurr: state_type] :
      ( v77234(VarCurr)
    <=> v77236(VarCurr) ) ).

tff(addAssignment_48116,axiom,
    ! [VarCurr: state_type] :
      ( v77236(VarCurr)
    <=> v77238(VarCurr) ) ).

tff(addAssignment_48115,axiom,
    ! [VarCurr: state_type] :
      ( v77238(VarCurr)
    <=> v77240(VarCurr) ) ).

tff(addAssignment_48114,axiom,
    ! [VarCurr: state_type] :
      ( v77240(VarCurr)
    <=> v77242(VarCurr) ) ).

tff(writeUnaryOperator_3465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77242(VarCurr)
    <=> v77252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7229,axiom,
    ! [VarCurr: state_type] :
      ( v77252(VarCurr)
    <=> ( v77244(VarCurr)
        & v77248(VarCurr) ) ) ).

tff(addAssignment_48113,axiom,
    ! [VarCurr: state_type] :
      ( v77248(VarCurr)
    <=> v77250(VarCurr) ) ).

tff(addAssignment_48112,axiom,
    ! [VarCurr: state_type] :
      ( v77250(VarCurr)
    <=> v67277(VarCurr) ) ).

tff(addAssignment_48111,axiom,
    ! [VarCurr: state_type] :
      ( v77244(VarCurr)
    <=> v77246(VarCurr) ) ).

tff(addAssignment_48110,axiom,
    ! [VarCurr: state_type] :
      ( v77246(VarCurr)
    <=> v77088(VarCurr) ) ).

tff(addAssignment_48109,axiom,
    ! [VarCurr: state_type] :
      ( v77024(VarCurr)
    <=> v77026(VarCurr) ) ).

tff(addAssignment_48108,axiom,
    ! [VarCurr: state_type] :
      ( v77026(VarCurr)
    <=> v77028(VarCurr) ) ).

tff(addAssignment_48107,axiom,
    ! [VarCurr: state_type] :
      ( v77028(VarCurr)
    <=> v77030(VarCurr) ) ).

tff(addAssignment_48106,axiom,
    ! [VarCurr: state_type] :
      ( v77030(VarCurr)
    <=> v77032(VarCurr) ) ).

tff(writeUnaryOperator_3464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77032(VarCurr)
    <=> v77034(VarCurr) ) ).

tff(addAssignment_48105,axiom,
    ! [VarCurr: state_type] :
      ( v77034(VarCurr)
    <=> v77036(VarCurr) ) ).

tff(addAssignment_48104,axiom,
    ! [VarCurr: state_type] :
      ( v77036(VarCurr)
    <=> v77038(VarCurr) ) ).

tff(addAssignment_48103,axiom,
    ! [VarCurr: state_type] :
      ( v77038(VarCurr)
    <=> v77040(VarCurr) ) ).

tff(addAssignment_48102,axiom,
    ! [VarCurr: state_type] :
      ( v77040(VarCurr)
    <=> v77042(VarCurr) ) ).

tff(writeUnaryOperator_3463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77042(VarCurr)
    <=> v77191(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7228,axiom,
    ! [VarCurr: state_type] :
      ( v77191(VarCurr)
    <=> ( v77044(VarCurr)
        & v77171(VarCurr) ) ) ).

tff(addAssignment_48101,axiom,
    ! [VarCurr: state_type] :
      ( v77171(VarCurr)
    <=> v77173(VarCurr) ) ).

tff(addAssignment_48100,axiom,
    ! [VarCurr: state_type] :
      ( v77173(VarCurr)
    <=> v77175(VarCurr) ) ).

tff(addAssignment_48099,axiom,
    ! [VarCurr: state_type] :
      ( v77175(VarCurr)
    <=> v77177(VarCurr) ) ).

tff(addAssignment_48098,axiom,
    ! [VarCurr: state_type] :
      ( v77177(VarCurr)
    <=> v77179(VarCurr) ) ).

tff(writeUnaryOperator_3462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77179(VarCurr)
    <=> v77189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7227,axiom,
    ! [VarCurr: state_type] :
      ( v77189(VarCurr)
    <=> ( v77181(VarCurr)
        | v77185(VarCurr) ) ) ).

tff(addAssignment_48097,axiom,
    ! [VarCurr: state_type] :
      ( v77185(VarCurr)
    <=> v77187(VarCurr) ) ).

tff(addAssignment_48096,axiom,
    ! [VarCurr: state_type] :
      ( v77187(VarCurr)
    <=> v77058(VarCurr,0) ) ).

tff(addAssignment_48095,axiom,
    ! [VarCurr: state_type] :
      ( v77058(VarCurr,0)
    <=> v77060(VarCurr,0) ) ).

tff(addAssignment_48094,axiom,
    ! [VarCurr: state_type] :
      ( v77060(VarCurr,0)
    <=> v77062(VarCurr,0) ) ).

tff(addAssignment_48093,axiom,
    ! [VarCurr: state_type] :
      ( v77062(VarCurr,0)
    <=> v77163(VarCurr,0) ) ).

tff(addAssignment_48092,axiom,
    ! [VarCurr: state_type] :
      ( v77160(VarCurr,0)
    <=> v77162(VarCurr,0) ) ).

tff(addAssignment_48091,axiom,
    ! [VarCurr: state_type] :
      ( v77162(VarCurr,0)
    <=> v67307(VarCurr,0) ) ).

tff(addAssignment_48090,axiom,
    ! [VarCurr: state_type] :
      ( v77064(VarCurr,0)
    <=> v77066(VarCurr,0) ) ).

tff(addAssignment_48089,axiom,
    ! [VarCurr: state_type] :
      ( v77066(VarCurr,0)
    <=> v77157(VarCurr,0) ) ).

tff(addAssignment_48088,axiom,
    ! [VarCurr: state_type] :
      ( v77181(VarCurr)
    <=> v77183(VarCurr) ) ).

tff(addAssignment_48087,axiom,
    ! [VarCurr: state_type] :
      ( v77183(VarCurr)
    <=> v77058(VarCurr,1) ) ).

tff(addAssignment_48086,axiom,
    ! [VarCurr: state_type] :
      ( v77058(VarCurr,1)
    <=> v77060(VarCurr,1) ) ).

tff(addAssignment_48085,axiom,
    ! [VarCurr: state_type] :
      ( v77060(VarCurr,1)
    <=> v77062(VarCurr,1) ) ).

tff(addAssignment_48084,axiom,
    ! [VarCurr: state_type] :
      ( v77062(VarCurr,1)
    <=> v77163(VarCurr,1) ) ).

tff(addAssignment_48083,axiom,
    ! [VarCurr: state_type] :
      ( v77160(VarCurr,1)
    <=> v77162(VarCurr,1) ) ).

tff(addAssignment_48082,axiom,
    ! [VarCurr: state_type] :
      ( v77162(VarCurr,1)
    <=> v67307(VarCurr,1) ) ).

tff(addAssignment_48081,axiom,
    ! [VarCurr: state_type] :
      ( v77064(VarCurr,1)
    <=> v77066(VarCurr,1) ) ).

tff(addAssignment_48080,axiom,
    ! [VarCurr: state_type] :
      ( v77066(VarCurr,1)
    <=> v77157(VarCurr,1) ) ).

tff(addAssignment_48079,axiom,
    ! [VarCurr: state_type] :
      ( v77044(VarCurr)
    <=> v77046(VarCurr) ) ).

tff(addAssignment_48078,axiom,
    ! [VarCurr: state_type] :
      ( v77046(VarCurr)
    <=> v77048(VarCurr) ) ).

tff(addAssignment_48077,axiom,
    ! [VarCurr: state_type] :
      ( v77048(VarCurr)
    <=> v77050(VarCurr) ) ).

tff(addAssignment_48076,axiom,
    ! [VarCurr: state_type] :
      ( v77050(VarCurr)
    <=> v77052(VarCurr) ) ).

tff(writeUnaryOperator_3461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77052(VarCurr)
    <=> v77169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7226,axiom,
    ! [VarCurr: state_type] :
      ( v77169(VarCurr)
    <=> ( v77054(VarCurr)
        | v77165(VarCurr) ) ) ).

tff(addAssignment_48075,axiom,
    ! [VarCurr: state_type] :
      ( v77165(VarCurr)
    <=> v77167(VarCurr) ) ).

tff(addAssignment_48074,axiom,
    ! [VarCurr: state_type] :
      ( v77167(VarCurr)
    <=> v77058(VarCurr,2) ) ).

tff(addAssignment_48073,axiom,
    ! [VarCurr: state_type] :
      ( v77058(VarCurr,2)
    <=> v77060(VarCurr,2) ) ).

tff(addAssignment_48072,axiom,
    ! [VarCurr: state_type] :
      ( v77060(VarCurr,2)
    <=> v77062(VarCurr,2) ) ).

tff(addAssignment_48071,axiom,
    ! [VarCurr: state_type] :
      ( v77062(VarCurr,2)
    <=> v77163(VarCurr,2) ) ).

tff(addAssignment_48070,axiom,
    ! [VarCurr: state_type] :
      ( v77160(VarCurr,2)
    <=> v77162(VarCurr,2) ) ).

tff(addAssignment_48069,axiom,
    ! [VarCurr: state_type] :
      ( v77162(VarCurr,2)
    <=> v67307(VarCurr,2) ) ).

tff(addAssignment_48068,axiom,
    ! [VarCurr: state_type] :
      ( v77064(VarCurr,2)
    <=> v77066(VarCurr,2) ) ).

tff(addAssignment_48067,axiom,
    ! [VarCurr: state_type] :
      ( v77066(VarCurr,2)
    <=> v77157(VarCurr,2) ) ).

tff(addAssignment_48066,axiom,
    ! [VarCurr: state_type] :
      ( v77054(VarCurr)
    <=> v77056(VarCurr) ) ).

tff(addAssignment_48065,axiom,
    ! [VarCurr: state_type] :
      ( v77056(VarCurr)
    <=> v77058(VarCurr,3) ) ).

tff(addAssignment_48064,axiom,
    ! [VarCurr: state_type] :
      ( v77058(VarCurr,3)
    <=> v77060(VarCurr,3) ) ).

tff(addAssignment_48063,axiom,
    ! [VarCurr: state_type] :
      ( v77060(VarCurr,3)
    <=> v77062(VarCurr,3) ) ).

tff(addAssignment_48062,axiom,
    ! [VarCurr: state_type] :
      ( v77062(VarCurr,3)
    <=> v77163(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v77163(VarCurr,B)
      <=> ( v77064(VarCurr,B)
          & v77160(VarCurr,B) ) ) ) ).

tff(addAssignment_48061,axiom,
    ! [VarCurr: state_type] :
      ( v77160(VarCurr,3)
    <=> v77162(VarCurr,3) ) ).

tff(addAssignment_48060,axiom,
    ! [VarCurr: state_type] :
      ( v77162(VarCurr,3)
    <=> v67307(VarCurr,3) ) ).

tff(addAssignment_48059,axiom,
    ! [VarCurr: state_type] :
      ( v77064(VarCurr,3)
    <=> v77066(VarCurr,3) ) ).

tff(addAssignment_48058,axiom,
    ! [VarCurr: state_type] :
      ( v77066(VarCurr,3)
    <=> v77157(VarCurr,3) ) ).

tff(addAssignment_48057,axiom,
    ! [VarCurr: state_type] :
      ( v77157(VarCurr,0)
    <=> v77158(VarCurr) ) ).

tff(addAssignment_48056,axiom,
    ! [VarCurr: state_type] :
      ( v77157(VarCurr,1)
    <=> v77158(VarCurr) ) ).

tff(addAssignment_48055,axiom,
    ! [VarCurr: state_type] :
      ( v77157(VarCurr,2)
    <=> v77158(VarCurr) ) ).

tff(addAssignment_48054,axiom,
    ! [VarCurr: state_type] :
      ( v77157(VarCurr,3)
    <=> v77158(VarCurr) ) ).

tff(addAssignment_48053,axiom,
    ! [VarCurr: state_type] :
      ( v77158(VarCurr)
    <=> v77068(VarCurr) ) ).

tff(addAssignment_48052,axiom,
    ! [VarCurr: state_type] :
      ( v77068(VarCurr)
    <=> v77070(VarCurr) ) ).

tff(addAssignment_48051,axiom,
    ! [VarCurr: state_type] :
      ( v77070(VarCurr)
    <=> v77072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7225,axiom,
    ! [VarCurr: state_type] :
      ( v77072(VarCurr)
    <=> ( v77074(VarCurr)
        | v77153(VarCurr) ) ) ).

tff(addAssignment_48050,axiom,
    ! [VarCurr: state_type] :
      ( v77153(VarCurr)
    <=> v77155(VarCurr) ) ).

tff(addAssignment_48049,axiom,
    ! [VarCurr: state_type] :
      ( v77155(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_48048,axiom,
    ! [VarCurr: state_type] :
      ( v77074(VarCurr)
    <=> v77076(VarCurr) ) ).

tff(addAssignment_48047,axiom,
    ! [VarCurr: state_type] :
      ( v77076(VarCurr)
    <=> v77078(VarCurr) ) ).

tff(addAssignment_48046,axiom,
    ! [VarCurr: state_type] :
      ( v77078(VarCurr)
    <=> v77080(VarCurr) ) ).

tff(addAssignment_48045,axiom,
    ! [VarCurr: state_type] :
      ( v77080(VarCurr)
    <=> v77082(VarCurr) ) ).

tff(writeUnaryOperator_3460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77082(VarCurr)
    <=> v77151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7224,axiom,
    ! [VarCurr: state_type] :
      ( v77151(VarCurr)
    <=> ( v77084(VarCurr)
        & v77147(VarCurr) ) ) ).

tff(addAssignment_48044,axiom,
    ! [VarCurr: state_type] :
      ( v77147(VarCurr)
    <=> v77149(VarCurr) ) ).

tff(addAssignment_48043,axiom,
    ! [VarCurr: state_type] :
      ( v77149(VarCurr)
    <=> v69775(VarCurr) ) ).

tff(addAssignment_48042,axiom,
    ! [VarCurr: state_type] :
      ( v77084(VarCurr)
    <=> v77086(VarCurr) ) ).

tff(addAssignment_48041,axiom,
    ! [VarCurr: state_type] :
      ( v77086(VarCurr)
    <=> v77088(VarCurr) ) ).

tff(addAssignment_48040,axiom,
    ! [VarCurr: state_type] :
      ( v77088(VarCurr)
    <=> v77090(VarCurr) ) ).

tff(addAssignment_48039,axiom,
    ! [VarCurr: state_type] :
      ( v77090(VarCurr)
    <=> v77092(VarCurr) ) ).

tff(writeUnaryOperator_3459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77092(VarCurr)
    <=> v77094(VarCurr) ) ).

tff(addAssignment_48038,axiom,
    ! [VarCurr: state_type] :
      ( v77094(VarCurr)
    <=> v77096(VarCurr) ) ).

tff(addAssignment_48037,axiom,
    ! [VarCurr: state_type] :
      ( v77096(VarCurr)
    <=> v77098(VarCurr) ) ).

tff(addAssignment_48036,axiom,
    ! [VarCurr: state_type] :
      ( v77098(VarCurr)
    <=> v77100(VarCurr) ) ).

tff(addAssignment_48035,axiom,
    ! [VarCurr: state_type] :
      ( v77100(VarCurr)
    <=> v77102(VarCurr) ) ).

tff(writeUnaryOperator_3458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77102(VarCurr)
    <=> v77144(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7223,axiom,
    ! [VarCurr: state_type] :
      ( v77144(VarCurr)
    <=> ( v77104(VarCurr)
        & v77124(VarCurr) ) ) ).

tff(addAssignment_48034,axiom,
    ! [VarCurr: state_type] :
      ( v77124(VarCurr)
    <=> v77126(VarCurr) ) ).

tff(addAssignment_48033,axiom,
    ! [VarCurr: state_type] :
      ( v77126(VarCurr)
    <=> v77128(VarCurr) ) ).

tff(addAssignment_48032,axiom,
    ! [VarCurr: state_type] :
      ( v77128(VarCurr)
    <=> v77130(VarCurr) ) ).

tff(addAssignment_48031,axiom,
    ! [VarCurr: state_type] :
      ( v77130(VarCurr)
    <=> v77132(VarCurr) ) ).

tff(writeUnaryOperator_3457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77132(VarCurr)
    <=> v77142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7222,axiom,
    ! [VarCurr: state_type] :
      ( v77142(VarCurr)
    <=> ( v77134(VarCurr)
        | v77138(VarCurr) ) ) ).

tff(addAssignment_48030,axiom,
    ! [VarCurr: state_type] :
      ( v77138(VarCurr)
    <=> v77140(VarCurr) ) ).

tff(addAssignment_48029,axiom,
    ! [VarCurr: state_type] :
      ( v77140(VarCurr)
    <=> v74280(VarCurr,0) ) ).

tff(addAssignment_48028,axiom,
    ! [VarCurr: state_type] :
      ( v77134(VarCurr)
    <=> v77136(VarCurr) ) ).

tff(addAssignment_48027,axiom,
    ! [VarCurr: state_type] :
      ( v77136(VarCurr)
    <=> v74280(VarCurr,1) ) ).

tff(addAssignment_48026,axiom,
    ! [VarCurr: state_type] :
      ( v77104(VarCurr)
    <=> v77106(VarCurr) ) ).

tff(addAssignment_48025,axiom,
    ! [VarCurr: state_type] :
      ( v77106(VarCurr)
    <=> v77108(VarCurr) ) ).

tff(addAssignment_48024,axiom,
    ! [VarCurr: state_type] :
      ( v77108(VarCurr)
    <=> v77110(VarCurr) ) ).

tff(addAssignment_48023,axiom,
    ! [VarCurr: state_type] :
      ( v77110(VarCurr)
    <=> v77112(VarCurr) ) ).

tff(writeUnaryOperator_3456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v77112(VarCurr)
    <=> v77122(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7221,axiom,
    ! [VarCurr: state_type] :
      ( v77122(VarCurr)
    <=> ( v77114(VarCurr)
        | v77118(VarCurr) ) ) ).

tff(addAssignment_48022,axiom,
    ! [VarCurr: state_type] :
      ( v77118(VarCurr)
    <=> v77120(VarCurr) ) ).

tff(addAssignment_48021,axiom,
    ! [VarCurr: state_type] :
      ( v77120(VarCurr)
    <=> v74280(VarCurr,2) ) ).

tff(addAssignment_48020,axiom,
    ! [VarCurr: state_type] :
      ( v77114(VarCurr)
    <=> v77116(VarCurr) ) ).

tff(addAssignment_48019,axiom,
    ! [VarCurr: state_type] :
      ( v77116(VarCurr)
    <=> v74280(VarCurr,3) ) ).

tff(addAssignment_48018,axiom,
    ! [VarCurr: state_type] :
      ( v67213(VarCurr)
    <=> v67215(VarCurr) ) ).

tff(addAssignment_48017,axiom,
    ! [VarCurr: state_type] :
      ( v67215(VarCurr)
    <=> v67217(VarCurr) ) ).

tff(addAssignment_48016,axiom,
    ! [VarCurr: state_type] :
      ( v67217(VarCurr)
    <=> v67219(VarCurr) ) ).

tff(addAssignment_48015,axiom,
    ! [VarCurr: state_type] :
      ( v67219(VarCurr)
    <=> v67221(VarCurr) ) ).

tff(writeUnaryOperator_3455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67221(VarCurr)
    <=> v67223(VarCurr) ) ).

tff(addAssignment_48014,axiom,
    ! [VarCurr: state_type] :
      ( v67223(VarCurr)
    <=> v67225(VarCurr) ) ).

tff(addAssignment_48013,axiom,
    ! [VarCurr: state_type] :
      ( v67225(VarCurr)
    <=> v67227(VarCurr) ) ).

tff(addAssignment_48012,axiom,
    ! [VarCurr: state_type] :
      ( v67227(VarCurr)
    <=> v67229(VarCurr) ) ).

tff(addAssignment_48011,axiom,
    ! [VarCurr: state_type] :
      ( v67229(VarCurr)
    <=> v67231(VarCurr) ) ).

tff(writeUnaryOperator_3454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67231(VarCurr)
    <=> v77021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7220,axiom,
    ! [VarCurr: state_type] :
      ( v77021(VarCurr)
    <=> ( v67233(VarCurr)
        & v75669(VarCurr) ) ) ).

tff(addAssignment_48010,axiom,
    ! [VarCurr: state_type] :
      ( v75669(VarCurr)
    <=> v75671(VarCurr) ) ).

tff(addAssignment_48009,axiom,
    ! [VarCurr: state_type] :
      ( v75671(VarCurr)
    <=> v75673(VarCurr) ) ).

tff(addAssignment_48008,axiom,
    ! [VarCurr: state_type] :
      ( v75673(VarCurr)
    <=> v75675(VarCurr) ) ).

tff(addAssignment_48007,axiom,
    ! [VarCurr: state_type] :
      ( v75675(VarCurr)
    <=> v75677(VarCurr) ) ).

tff(writeUnaryOperator_3453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v75677(VarCurr)
    <=> v77019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7219,axiom,
    ! [VarCurr: state_type] :
      ( v77019(VarCurr)
    <=> ( v75679(VarCurr)
        | v76349(VarCurr) ) ) ).

tff(addAssignment_48006,axiom,
    ! [VarCurr: state_type] :
      ( v76349(VarCurr)
    <=> v76351(VarCurr) ) ).

tff(addAssignment_48005,axiom,
    ! [VarCurr: state_type] :
      ( v76351(VarCurr)
    <=> v67247(VarCurr,0) ) ).

tff(addAssignment_48004,axiom,
    ! [VarCurr: state_type] :
      ( v67247(VarCurr,0)
    <=> v67249(VarCurr,0) ) ).

tff(addAssignment_48003,axiom,
    ! [VarCurr: state_type] :
      ( v67249(VarCurr,0)
    <=> v67251(VarCurr,0) ) ).

tff(addAssignment_48002,axiom,
    ! [VarCurr: state_type] :
      ( v67251(VarCurr,0)
    <=> v74995(VarCurr,0) ) ).

tff(addAssignment_48001,axiom,
    ! [VarCurr: state_type] :
      ( v74276(VarCurr,0)
    <=> v74278(VarCurr,0) ) ).

tff(addAssignment_48000,axiom,
    ! [VarCurr: state_type] :
      ( v74278(VarCurr,0)
    <=> v74280(VarCurr,0) ) ).

tff(addAssignment_47999,axiom,
    ! [VarCurr: state_type] :
      ( v74280(VarCurr,0)
    <=> v67309(VarCurr,12) ) ).

tff(addAssignment_47998,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,12)
    <=> v67311(VarCurr,12) ) ).

tff(addAssignment_47997,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,12)
    <=> v67313(VarCurr,12) ) ).

tff(addAssignment_47996,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,12)
    <=> v67315(VarCurr,12) ) ).

tff(addAssignment_47995,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,12)
    <=> v67317(VarCurr,12) ) ).

tff(addAssignment_47994,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,12)
    <=> v68771(VarCurr,12) ) ).

tff(addAssignment_47993,axiom,
    ! [VarCurr: state_type] :
      ( v68772(VarCurr,0)
    <=> v76353(VarCurr) ) ).

tff(addAssignment_47992,axiom,
    ! [VarCurr: state_type] :
      ( v76353(VarCurr)
    <=> v76355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7218,axiom,
    ! [VarCurr: state_type] :
      ( v76355(VarCurr)
    <=> ( v77017(VarCurr)
      <~> v76885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7217,axiom,
    ! [VarCurr: state_type] :
      ( v77017(VarCurr)
    <=> ( v76357(VarCurr)
      <~> v76621(VarCurr) ) ) ).

tff(addAssignment_47991,axiom,
    ! [VarCurr: state_type] :
      ( v76885(VarCurr)
    <=> v76887(VarCurr) ) ).

tff(addAssignment_47990,axiom,
    ! [VarCurr: state_type] :
      ( v76887(VarCurr)
    <=> v76889(VarCurr) ) ).

tff(addAssignment_47989,axiom,
    ! [VarCurr: state_type] :
      ( v76889(VarCurr)
    <=> v76891(VarCurr) ) ).

tff(addAssignment_47988,axiom,
    ! [VarCurr: state_type] :
      ( v76891(VarCurr)
    <=> v76893(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7216,axiom,
    ! [VarCurr: state_type] :
      ( v76893(VarCurr)
    <=> ( v77015(VarCurr)
      <~> v77003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7215,axiom,
    ! [VarCurr: state_type] :
      ( v77015(VarCurr)
    <=> ( v76895(VarCurr)
      <~> v76919(VarCurr) ) ) ).

tff(addAssignment_47987,axiom,
    ! [VarCurr: state_type] :
      ( v77003(VarCurr)
    <=> v77005(VarCurr) ) ).

tff(addAssignment_47986,axiom,
    ! [VarCurr: state_type] :
      ( v77005(VarCurr)
    <=> v74937(VarCurr,0) ) ).

tff(addAssignment_47985,axiom,
    ! [VarCurr: state_type] :
      ( v74937(VarCurr,0)
    <=> v74939(VarCurr,0) ) ).

tff(addAssignment_47984,axiom,
    ! [VarCurr: state_type] :
      ( v74939(VarCurr,0)
    <=> v68676(VarCurr,4) ) ).

tff(addAssignment_47983,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,4)
    <=> v68678(VarCurr,4) ) ).

tff(addAssignment_47982,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,4)
    <=> v77007(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v77008(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v77007(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_909,axiom,
    ! [VarNext: state_type] :
      ( v77008(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v77007(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v77008(VarNext)
      <=> v77009(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v77009(VarNext)
      <=> ( v77011(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v77011(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_47981,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,4)
    <=> v68702(VarCurr,4) ) ).

tff(addAssignment_47980,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,4)
    <=> v68731(VarCurr,4) ) ).

tff(addAssignment_47979,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,12)
    <=> v74950(VarCurr,0) ) ).

tff(addAssignment_47978,axiom,
    ! [VarCurr: state_type] :
      ( v74950(VarCurr,0)
    <=> v74952(VarCurr,0) ) ).

tff(addAssignment_47977,axiom,
    ! [VarCurr: state_type] :
      ( v74952(VarCurr,0)
    <=> v74969(VarCurr,0) ) ).

tff(addAssignment_47976,axiom,
    ! [VarCurr: state_type] :
      ( v74962(VarCurr,0)
    <=> v74964(VarCurr,0) ) ).

tff(addAssignment_47975,axiom,
    ! [VarCurr: state_type] :
      ( v74964(VarCurr,0)
    <=> v68455(VarCurr,12) ) ).

tff(addAssignment_47974,axiom,
    ! [VarCurr: state_type] :
      ( v74954(VarCurr,0)
    <=> v74956(VarCurr,0) ) ).

tff(addAssignment_47973,axiom,
    ! [VarCurr: state_type] :
      ( v74956(VarCurr,0)
    <=> v68455(VarCurr,8) ) ).

tff(addAssignment_47972,axiom,
    ! [VarCurr: state_type] :
      ( v76919(VarCurr)
    <=> v76921(VarCurr) ) ).

tff(addAssignment_47971,axiom,
    ! [VarCurr: state_type] :
      ( v76921(VarCurr)
    <=> v76923(VarCurr) ) ).

tff(addAssignment_47970,axiom,
    ! [VarCurr: state_type] :
      ( v76923(VarCurr)
    <=> v76925(VarCurr) ) ).

tff(addAssignment_47969,axiom,
    ! [VarCurr: state_type] :
      ( v76925(VarCurr)
    <=> v76927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7212,axiom,
    ! [VarCurr: state_type] :
      ( v76927(VarCurr)
    <=> ( v77001(VarCurr)
      <~> v76977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7211,axiom,
    ! [VarCurr: state_type] :
      ( v77001(VarCurr)
    <=> ( v76929(VarCurr)
      <~> v76953(VarCurr) ) ) ).

tff(addAssignment_47968,axiom,
    ! [VarCurr: state_type] :
      ( v76977(VarCurr)
    <=> v76979(VarCurr) ) ).

tff(addAssignment_47967,axiom,
    ! [VarCurr: state_type] :
      ( v76979(VarCurr)
    <=> v76981(VarCurr) ) ).

tff(addAssignment_47966,axiom,
    ! [VarCurr: state_type] :
      ( v76981(VarCurr)
    <=> v76983(VarCurr) ) ).

tff(addAssignment_47965,axiom,
    ! [VarCurr: state_type] :
      ( v76983(VarCurr)
    <=> v76985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7210,axiom,
    ! [VarCurr: state_type] :
      ( v76985(VarCurr)
    <=> ( v76999(VarCurr)
      <~> v76995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7209,axiom,
    ! [VarCurr: state_type] :
      ( v76999(VarCurr)
    <=> ( v76987(VarCurr)
      <~> v76991(VarCurr) ) ) ).

tff(addAssignment_47964,axiom,
    ! [VarCurr: state_type] :
      ( v76995(VarCurr)
    <=> v76997(VarCurr) ) ).

tff(addAssignment_47963,axiom,
    ! [VarCurr: state_type] :
      ( v76997(VarCurr)
    <=> v67349(VarCurr,118) ) ).

tff(addAssignment_47962,axiom,
    ! [VarCurr: state_type] :
      ( v76991(VarCurr)
    <=> v76993(VarCurr) ) ).

tff(addAssignment_47961,axiom,
    ! [VarCurr: state_type] :
      ( v76993(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_47960,axiom,
    ! [VarCurr: state_type] :
      ( v76987(VarCurr)
    <=> v76989(VarCurr) ) ).

tff(addAssignment_47959,axiom,
    ! [VarCurr: state_type] :
      ( v76989(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_47958,axiom,
    ! [VarCurr: state_type] :
      ( v76953(VarCurr)
    <=> v76955(VarCurr) ) ).

tff(addAssignment_47957,axiom,
    ! [VarCurr: state_type] :
      ( v76955(VarCurr)
    <=> v76957(VarCurr) ) ).

tff(addAssignment_47956,axiom,
    ! [VarCurr: state_type] :
      ( v76957(VarCurr)
    <=> v76959(VarCurr) ) ).

tff(addAssignment_47955,axiom,
    ! [VarCurr: state_type] :
      ( v76959(VarCurr)
    <=> v76961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7208,axiom,
    ! [VarCurr: state_type] :
      ( v76961(VarCurr)
    <=> ( v76975(VarCurr)
      <~> v76971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7207,axiom,
    ! [VarCurr: state_type] :
      ( v76975(VarCurr)
    <=> ( v76963(VarCurr)
      <~> v76967(VarCurr) ) ) ).

tff(addAssignment_47954,axiom,
    ! [VarCurr: state_type] :
      ( v76971(VarCurr)
    <=> v76973(VarCurr) ) ).

tff(addAssignment_47953,axiom,
    ! [VarCurr: state_type] :
      ( v76973(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_47952,axiom,
    ! [VarCurr: state_type] :
      ( v76967(VarCurr)
    <=> v76969(VarCurr) ) ).

tff(addAssignment_47951,axiom,
    ! [VarCurr: state_type] :
      ( v76969(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_47950,axiom,
    ! [VarCurr: state_type] :
      ( v76963(VarCurr)
    <=> v76965(VarCurr) ) ).

tff(addAssignment_47949,axiom,
    ! [VarCurr: state_type] :
      ( v76965(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_47948,axiom,
    ! [VarCurr: state_type] :
      ( v76929(VarCurr)
    <=> v76931(VarCurr) ) ).

tff(addAssignment_47947,axiom,
    ! [VarCurr: state_type] :
      ( v76931(VarCurr)
    <=> v76933(VarCurr) ) ).

tff(addAssignment_47946,axiom,
    ! [VarCurr: state_type] :
      ( v76933(VarCurr)
    <=> v76935(VarCurr) ) ).

tff(addAssignment_47945,axiom,
    ! [VarCurr: state_type] :
      ( v76935(VarCurr)
    <=> v76937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7206,axiom,
    ! [VarCurr: state_type] :
      ( v76937(VarCurr)
    <=> ( v76951(VarCurr)
      <~> v76947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7205,axiom,
    ! [VarCurr: state_type] :
      ( v76951(VarCurr)
    <=> ( v76939(VarCurr)
      <~> v76943(VarCurr) ) ) ).

tff(addAssignment_47944,axiom,
    ! [VarCurr: state_type] :
      ( v76947(VarCurr)
    <=> v76949(VarCurr) ) ).

tff(addAssignment_47943,axiom,
    ! [VarCurr: state_type] :
      ( v76949(VarCurr)
    <=> v67349(VarCurr,110) ) ).

tff(addAssignment_47942,axiom,
    ! [VarCurr: state_type] :
      ( v76943(VarCurr)
    <=> v76945(VarCurr) ) ).

tff(addAssignment_47941,axiom,
    ! [VarCurr: state_type] :
      ( v76945(VarCurr)
    <=> v67349(VarCurr,109) ) ).

tff(addAssignment_47940,axiom,
    ! [VarCurr: state_type] :
      ( v76939(VarCurr)
    <=> v76941(VarCurr) ) ).

tff(addAssignment_47939,axiom,
    ! [VarCurr: state_type] :
      ( v76941(VarCurr)
    <=> v67349(VarCurr,108) ) ).

tff(addAssignment_47938,axiom,
    ! [VarCurr: state_type] :
      ( v76895(VarCurr)
    <=> v76897(VarCurr) ) ).

tff(addAssignment_47937,axiom,
    ! [VarCurr: state_type] :
      ( v76897(VarCurr)
    <=> v76899(VarCurr) ) ).

tff(addAssignment_47936,axiom,
    ! [VarCurr: state_type] :
      ( v76899(VarCurr)
    <=> v76901(VarCurr) ) ).

tff(addAssignment_47935,axiom,
    ! [VarCurr: state_type] :
      ( v76901(VarCurr)
    <=> v76903(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7204,axiom,
    ! [VarCurr: state_type] :
      ( v76903(VarCurr)
    <=> ( v76917(VarCurr)
      <~> v76913(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7203,axiom,
    ! [VarCurr: state_type] :
      ( v76917(VarCurr)
    <=> ( v76905(VarCurr)
      <~> v76909(VarCurr) ) ) ).

tff(addAssignment_47934,axiom,
    ! [VarCurr: state_type] :
      ( v76913(VarCurr)
    <=> v76915(VarCurr) ) ).

tff(addAssignment_47933,axiom,
    ! [VarCurr: state_type] :
      ( v76915(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_47932,axiom,
    ! [VarCurr: state_type] :
      ( v76909(VarCurr)
    <=> v76911(VarCurr) ) ).

tff(addAssignment_47931,axiom,
    ! [VarCurr: state_type] :
      ( v76911(VarCurr)
    <=> v67349(VarCurr,124) ) ).

tff(addAssignment_47930,axiom,
    ! [VarCurr: state_type] :
      ( v76905(VarCurr)
    <=> v76907(VarCurr) ) ).

tff(addAssignment_47929,axiom,
    ! [VarCurr: state_type] :
      ( v76907(VarCurr)
    <=> v67349(VarCurr,119) ) ).

tff(addAssignment_47928,axiom,
    ! [VarCurr: state_type] :
      ( v76621(VarCurr)
    <=> v76623(VarCurr) ) ).

tff(addAssignment_47927,axiom,
    ! [VarCurr: state_type] :
      ( v76623(VarCurr)
    <=> v76625(VarCurr) ) ).

tff(addAssignment_47926,axiom,
    ! [VarCurr: state_type] :
      ( v76625(VarCurr)
    <=> v76627(VarCurr) ) ).

tff(addAssignment_47925,axiom,
    ! [VarCurr: state_type] :
      ( v76627(VarCurr)
    <=> v76629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7202,axiom,
    ! [VarCurr: state_type] :
      ( v76629(VarCurr)
    <=> ( v76883(VarCurr)
      <~> v76799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7201,axiom,
    ! [VarCurr: state_type] :
      ( v76883(VarCurr)
    <=> ( v76631(VarCurr)
      <~> v76715(VarCurr) ) ) ).

tff(addAssignment_47924,axiom,
    ! [VarCurr: state_type] :
      ( v76799(VarCurr)
    <=> v76801(VarCurr) ) ).

tff(addAssignment_47923,axiom,
    ! [VarCurr: state_type] :
      ( v76801(VarCurr)
    <=> v76803(VarCurr) ) ).

tff(addAssignment_47922,axiom,
    ! [VarCurr: state_type] :
      ( v76803(VarCurr)
    <=> v76805(VarCurr) ) ).

tff(addAssignment_47921,axiom,
    ! [VarCurr: state_type] :
      ( v76805(VarCurr)
    <=> v76807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7200,axiom,
    ! [VarCurr: state_type] :
      ( v76807(VarCurr)
    <=> ( v76881(VarCurr)
      <~> v76857(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7199,axiom,
    ! [VarCurr: state_type] :
      ( v76881(VarCurr)
    <=> ( v76809(VarCurr)
      <~> v76833(VarCurr) ) ) ).

tff(addAssignment_47920,axiom,
    ! [VarCurr: state_type] :
      ( v76857(VarCurr)
    <=> v76859(VarCurr) ) ).

tff(addAssignment_47919,axiom,
    ! [VarCurr: state_type] :
      ( v76859(VarCurr)
    <=> v76861(VarCurr) ) ).

tff(addAssignment_47918,axiom,
    ! [VarCurr: state_type] :
      ( v76861(VarCurr)
    <=> v76863(VarCurr) ) ).

tff(addAssignment_47917,axiom,
    ! [VarCurr: state_type] :
      ( v76863(VarCurr)
    <=> v76865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7198,axiom,
    ! [VarCurr: state_type] :
      ( v76865(VarCurr)
    <=> ( v76879(VarCurr)
      <~> v76875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7197,axiom,
    ! [VarCurr: state_type] :
      ( v76879(VarCurr)
    <=> ( v76867(VarCurr)
      <~> v76871(VarCurr) ) ) ).

tff(addAssignment_47916,axiom,
    ! [VarCurr: state_type] :
      ( v76875(VarCurr)
    <=> v76877(VarCurr) ) ).

tff(addAssignment_47915,axiom,
    ! [VarCurr: state_type] :
      ( v76877(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_47914,axiom,
    ! [VarCurr: state_type] :
      ( v76871(VarCurr)
    <=> v76873(VarCurr) ) ).

tff(addAssignment_47913,axiom,
    ! [VarCurr: state_type] :
      ( v76873(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_47912,axiom,
    ! [VarCurr: state_type] :
      ( v76867(VarCurr)
    <=> v76869(VarCurr) ) ).

tff(addAssignment_47911,axiom,
    ! [VarCurr: state_type] :
      ( v76869(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_47910,axiom,
    ! [VarCurr: state_type] :
      ( v76833(VarCurr)
    <=> v76835(VarCurr) ) ).

tff(addAssignment_47909,axiom,
    ! [VarCurr: state_type] :
      ( v76835(VarCurr)
    <=> v76837(VarCurr) ) ).

tff(addAssignment_47908,axiom,
    ! [VarCurr: state_type] :
      ( v76837(VarCurr)
    <=> v76839(VarCurr) ) ).

tff(addAssignment_47907,axiom,
    ! [VarCurr: state_type] :
      ( v76839(VarCurr)
    <=> v76841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7196,axiom,
    ! [VarCurr: state_type] :
      ( v76841(VarCurr)
    <=> ( v76855(VarCurr)
      <~> v76851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7195,axiom,
    ! [VarCurr: state_type] :
      ( v76855(VarCurr)
    <=> ( v76843(VarCurr)
      <~> v76847(VarCurr) ) ) ).

tff(addAssignment_47906,axiom,
    ! [VarCurr: state_type] :
      ( v76851(VarCurr)
    <=> v76853(VarCurr) ) ).

tff(addAssignment_47905,axiom,
    ! [VarCurr: state_type] :
      ( v76853(VarCurr)
    <=> v67349(VarCurr,101) ) ).

tff(addAssignment_47904,axiom,
    ! [VarCurr: state_type] :
      ( v76847(VarCurr)
    <=> v76849(VarCurr) ) ).

tff(addAssignment_47903,axiom,
    ! [VarCurr: state_type] :
      ( v76849(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_47902,axiom,
    ! [VarCurr: state_type] :
      ( v76843(VarCurr)
    <=> v76845(VarCurr) ) ).

tff(addAssignment_47901,axiom,
    ! [VarCurr: state_type] :
      ( v76845(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_47900,axiom,
    ! [VarCurr: state_type] :
      ( v76809(VarCurr)
    <=> v76811(VarCurr) ) ).

tff(addAssignment_47899,axiom,
    ! [VarCurr: state_type] :
      ( v76811(VarCurr)
    <=> v76813(VarCurr) ) ).

tff(addAssignment_47898,axiom,
    ! [VarCurr: state_type] :
      ( v76813(VarCurr)
    <=> v76815(VarCurr) ) ).

tff(addAssignment_47897,axiom,
    ! [VarCurr: state_type] :
      ( v76815(VarCurr)
    <=> v76817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7194,axiom,
    ! [VarCurr: state_type] :
      ( v76817(VarCurr)
    <=> ( v76831(VarCurr)
      <~> v76827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7193,axiom,
    ! [VarCurr: state_type] :
      ( v76831(VarCurr)
    <=> ( v76819(VarCurr)
      <~> v76823(VarCurr) ) ) ).

tff(addAssignment_47896,axiom,
    ! [VarCurr: state_type] :
      ( v76827(VarCurr)
    <=> v76829(VarCurr) ) ).

tff(addAssignment_47895,axiom,
    ! [VarCurr: state_type] :
      ( v76829(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_47894,axiom,
    ! [VarCurr: state_type] :
      ( v76823(VarCurr)
    <=> v76825(VarCurr) ) ).

tff(addAssignment_47893,axiom,
    ! [VarCurr: state_type] :
      ( v76825(VarCurr)
    <=> v67349(VarCurr,93) ) ).

tff(addAssignment_47892,axiom,
    ! [VarCurr: state_type] :
      ( v76819(VarCurr)
    <=> v76821(VarCurr) ) ).

tff(addAssignment_47891,axiom,
    ! [VarCurr: state_type] :
      ( v76821(VarCurr)
    <=> v67349(VarCurr,92) ) ).

tff(addAssignment_47890,axiom,
    ! [VarCurr: state_type] :
      ( v76715(VarCurr)
    <=> v76717(VarCurr) ) ).

tff(addAssignment_47889,axiom,
    ! [VarCurr: state_type] :
      ( v76717(VarCurr)
    <=> v76719(VarCurr) ) ).

tff(addAssignment_47888,axiom,
    ! [VarCurr: state_type] :
      ( v76719(VarCurr)
    <=> v76721(VarCurr) ) ).

tff(addAssignment_47887,axiom,
    ! [VarCurr: state_type] :
      ( v76721(VarCurr)
    <=> v76723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7192,axiom,
    ! [VarCurr: state_type] :
      ( v76723(VarCurr)
    <=> ( v76797(VarCurr)
      <~> v76773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7191,axiom,
    ! [VarCurr: state_type] :
      ( v76797(VarCurr)
    <=> ( v76725(VarCurr)
      <~> v76749(VarCurr) ) ) ).

tff(addAssignment_47886,axiom,
    ! [VarCurr: state_type] :
      ( v76773(VarCurr)
    <=> v76775(VarCurr) ) ).

tff(addAssignment_47885,axiom,
    ! [VarCurr: state_type] :
      ( v76775(VarCurr)
    <=> v76777(VarCurr) ) ).

tff(addAssignment_47884,axiom,
    ! [VarCurr: state_type] :
      ( v76777(VarCurr)
    <=> v76779(VarCurr) ) ).

tff(addAssignment_47883,axiom,
    ! [VarCurr: state_type] :
      ( v76779(VarCurr)
    <=> v76781(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7190,axiom,
    ! [VarCurr: state_type] :
      ( v76781(VarCurr)
    <=> ( v76795(VarCurr)
      <~> v76791(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7189,axiom,
    ! [VarCurr: state_type] :
      ( v76795(VarCurr)
    <=> ( v76783(VarCurr)
      <~> v76787(VarCurr) ) ) ).

tff(addAssignment_47882,axiom,
    ! [VarCurr: state_type] :
      ( v76791(VarCurr)
    <=> v76793(VarCurr) ) ).

tff(addAssignment_47881,axiom,
    ! [VarCurr: state_type] :
      ( v76793(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_47880,axiom,
    ! [VarCurr: state_type] :
      ( v76787(VarCurr)
    <=> v76789(VarCurr) ) ).

tff(addAssignment_47879,axiom,
    ! [VarCurr: state_type] :
      ( v76789(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_47878,axiom,
    ! [VarCurr: state_type] :
      ( v76783(VarCurr)
    <=> v76785(VarCurr) ) ).

tff(addAssignment_47877,axiom,
    ! [VarCurr: state_type] :
      ( v76785(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_47876,axiom,
    ! [VarCurr: state_type] :
      ( v76749(VarCurr)
    <=> v76751(VarCurr) ) ).

tff(addAssignment_47875,axiom,
    ! [VarCurr: state_type] :
      ( v76751(VarCurr)
    <=> v76753(VarCurr) ) ).

tff(addAssignment_47874,axiom,
    ! [VarCurr: state_type] :
      ( v76753(VarCurr)
    <=> v76755(VarCurr) ) ).

tff(addAssignment_47873,axiom,
    ! [VarCurr: state_type] :
      ( v76755(VarCurr)
    <=> v76757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7188,axiom,
    ! [VarCurr: state_type] :
      ( v76757(VarCurr)
    <=> ( v76771(VarCurr)
      <~> v76767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7187,axiom,
    ! [VarCurr: state_type] :
      ( v76771(VarCurr)
    <=> ( v76759(VarCurr)
      <~> v76763(VarCurr) ) ) ).

tff(addAssignment_47872,axiom,
    ! [VarCurr: state_type] :
      ( v76767(VarCurr)
    <=> v76769(VarCurr) ) ).

tff(addAssignment_47871,axiom,
    ! [VarCurr: state_type] :
      ( v76769(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_47870,axiom,
    ! [VarCurr: state_type] :
      ( v76763(VarCurr)
    <=> v76765(VarCurr) ) ).

tff(addAssignment_47869,axiom,
    ! [VarCurr: state_type] :
      ( v76765(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_47868,axiom,
    ! [VarCurr: state_type] :
      ( v76759(VarCurr)
    <=> v76761(VarCurr) ) ).

tff(addAssignment_47867,axiom,
    ! [VarCurr: state_type] :
      ( v76761(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_47866,axiom,
    ! [VarCurr: state_type] :
      ( v76725(VarCurr)
    <=> v76727(VarCurr) ) ).

tff(addAssignment_47865,axiom,
    ! [VarCurr: state_type] :
      ( v76727(VarCurr)
    <=> v76729(VarCurr) ) ).

tff(addAssignment_47864,axiom,
    ! [VarCurr: state_type] :
      ( v76729(VarCurr)
    <=> v76731(VarCurr) ) ).

tff(addAssignment_47863,axiom,
    ! [VarCurr: state_type] :
      ( v76731(VarCurr)
    <=> v76733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7186,axiom,
    ! [VarCurr: state_type] :
      ( v76733(VarCurr)
    <=> ( v76747(VarCurr)
      <~> v76743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7185,axiom,
    ! [VarCurr: state_type] :
      ( v76747(VarCurr)
    <=> ( v76735(VarCurr)
      <~> v76739(VarCurr) ) ) ).

tff(addAssignment_47862,axiom,
    ! [VarCurr: state_type] :
      ( v76743(VarCurr)
    <=> v76745(VarCurr) ) ).

tff(addAssignment_47861,axiom,
    ! [VarCurr: state_type] :
      ( v76745(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_47860,axiom,
    ! [VarCurr: state_type] :
      ( v76739(VarCurr)
    <=> v76741(VarCurr) ) ).

tff(addAssignment_47859,axiom,
    ! [VarCurr: state_type] :
      ( v76741(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_47858,axiom,
    ! [VarCurr: state_type] :
      ( v76735(VarCurr)
    <=> v76737(VarCurr) ) ).

tff(addAssignment_47857,axiom,
    ! [VarCurr: state_type] :
      ( v76737(VarCurr)
    <=> v67349(VarCurr,74) ) ).

tff(addAssignment_47856,axiom,
    ! [VarCurr: state_type] :
      ( v76631(VarCurr)
    <=> v76633(VarCurr) ) ).

tff(addAssignment_47855,axiom,
    ! [VarCurr: state_type] :
      ( v76633(VarCurr)
    <=> v76635(VarCurr) ) ).

tff(addAssignment_47854,axiom,
    ! [VarCurr: state_type] :
      ( v76635(VarCurr)
    <=> v76637(VarCurr) ) ).

tff(addAssignment_47853,axiom,
    ! [VarCurr: state_type] :
      ( v76637(VarCurr)
    <=> v76639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7184,axiom,
    ! [VarCurr: state_type] :
      ( v76639(VarCurr)
    <=> ( v76713(VarCurr)
      <~> v76689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7183,axiom,
    ! [VarCurr: state_type] :
      ( v76713(VarCurr)
    <=> ( v76641(VarCurr)
      <~> v76665(VarCurr) ) ) ).

tff(addAssignment_47852,axiom,
    ! [VarCurr: state_type] :
      ( v76689(VarCurr)
    <=> v76691(VarCurr) ) ).

tff(addAssignment_47851,axiom,
    ! [VarCurr: state_type] :
      ( v76691(VarCurr)
    <=> v76693(VarCurr) ) ).

tff(addAssignment_47850,axiom,
    ! [VarCurr: state_type] :
      ( v76693(VarCurr)
    <=> v76695(VarCurr) ) ).

tff(addAssignment_47849,axiom,
    ! [VarCurr: state_type] :
      ( v76695(VarCurr)
    <=> v76697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7182,axiom,
    ! [VarCurr: state_type] :
      ( v76697(VarCurr)
    <=> ( v76711(VarCurr)
      <~> v76707(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7181,axiom,
    ! [VarCurr: state_type] :
      ( v76711(VarCurr)
    <=> ( v76699(VarCurr)
      <~> v76703(VarCurr) ) ) ).

tff(addAssignment_47848,axiom,
    ! [VarCurr: state_type] :
      ( v76707(VarCurr)
    <=> v76709(VarCurr) ) ).

tff(addAssignment_47847,axiom,
    ! [VarCurr: state_type] :
      ( v76709(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_47846,axiom,
    ! [VarCurr: state_type] :
      ( v76703(VarCurr)
    <=> v76705(VarCurr) ) ).

tff(addAssignment_47845,axiom,
    ! [VarCurr: state_type] :
      ( v76705(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_47844,axiom,
    ! [VarCurr: state_type] :
      ( v76699(VarCurr)
    <=> v76701(VarCurr) ) ).

tff(addAssignment_47843,axiom,
    ! [VarCurr: state_type] :
      ( v76701(VarCurr)
    <=> v67349(VarCurr,67) ) ).

tff(addAssignment_47842,axiom,
    ! [VarCurr: state_type] :
      ( v76665(VarCurr)
    <=> v76667(VarCurr) ) ).

tff(addAssignment_47841,axiom,
    ! [VarCurr: state_type] :
      ( v76667(VarCurr)
    <=> v76669(VarCurr) ) ).

tff(addAssignment_47840,axiom,
    ! [VarCurr: state_type] :
      ( v76669(VarCurr)
    <=> v76671(VarCurr) ) ).

tff(addAssignment_47839,axiom,
    ! [VarCurr: state_type] :
      ( v76671(VarCurr)
    <=> v76673(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7180,axiom,
    ! [VarCurr: state_type] :
      ( v76673(VarCurr)
    <=> ( v76687(VarCurr)
      <~> v76683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7179,axiom,
    ! [VarCurr: state_type] :
      ( v76687(VarCurr)
    <=> ( v76675(VarCurr)
      <~> v76679(VarCurr) ) ) ).

tff(addAssignment_47838,axiom,
    ! [VarCurr: state_type] :
      ( v76683(VarCurr)
    <=> v76685(VarCurr) ) ).

tff(addAssignment_47837,axiom,
    ! [VarCurr: state_type] :
      ( v76685(VarCurr)
    <=> v67349(VarCurr,60) ) ).

tff(addAssignment_47836,axiom,
    ! [VarCurr: state_type] :
      ( v76679(VarCurr)
    <=> v76681(VarCurr) ) ).

tff(addAssignment_47835,axiom,
    ! [VarCurr: state_type] :
      ( v76681(VarCurr)
    <=> v67349(VarCurr,59) ) ).

tff(addAssignment_47834,axiom,
    ! [VarCurr: state_type] :
      ( v76675(VarCurr)
    <=> v76677(VarCurr) ) ).

tff(addAssignment_47833,axiom,
    ! [VarCurr: state_type] :
      ( v76677(VarCurr)
    <=> v67349(VarCurr,58) ) ).

tff(addAssignment_47832,axiom,
    ! [VarCurr: state_type] :
      ( v76641(VarCurr)
    <=> v76643(VarCurr) ) ).

tff(addAssignment_47831,axiom,
    ! [VarCurr: state_type] :
      ( v76643(VarCurr)
    <=> v76645(VarCurr) ) ).

tff(addAssignment_47830,axiom,
    ! [VarCurr: state_type] :
      ( v76645(VarCurr)
    <=> v76647(VarCurr) ) ).

tff(addAssignment_47829,axiom,
    ! [VarCurr: state_type] :
      ( v76647(VarCurr)
    <=> v76649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7178,axiom,
    ! [VarCurr: state_type] :
      ( v76649(VarCurr)
    <=> ( v76663(VarCurr)
      <~> v76659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7177,axiom,
    ! [VarCurr: state_type] :
      ( v76663(VarCurr)
    <=> ( v76651(VarCurr)
      <~> v76655(VarCurr) ) ) ).

tff(addAssignment_47828,axiom,
    ! [VarCurr: state_type] :
      ( v76659(VarCurr)
    <=> v76661(VarCurr) ) ).

tff(addAssignment_47827,axiom,
    ! [VarCurr: state_type] :
      ( v76661(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_47826,axiom,
    ! [VarCurr: state_type] :
      ( v76655(VarCurr)
    <=> v76657(VarCurr) ) ).

tff(addAssignment_47825,axiom,
    ! [VarCurr: state_type] :
      ( v76657(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_47824,axiom,
    ! [VarCurr: state_type] :
      ( v76651(VarCurr)
    <=> v76653(VarCurr) ) ).

tff(addAssignment_47823,axiom,
    ! [VarCurr: state_type] :
      ( v76653(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_47822,axiom,
    ! [VarCurr: state_type] :
      ( v76357(VarCurr)
    <=> v76359(VarCurr) ) ).

tff(addAssignment_47821,axiom,
    ! [VarCurr: state_type] :
      ( v76359(VarCurr)
    <=> v76361(VarCurr) ) ).

tff(addAssignment_47820,axiom,
    ! [VarCurr: state_type] :
      ( v76361(VarCurr)
    <=> v76363(VarCurr) ) ).

tff(addAssignment_47819,axiom,
    ! [VarCurr: state_type] :
      ( v76363(VarCurr)
    <=> v76365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7176,axiom,
    ! [VarCurr: state_type] :
      ( v76365(VarCurr)
    <=> ( v76619(VarCurr)
      <~> v76535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7175,axiom,
    ! [VarCurr: state_type] :
      ( v76619(VarCurr)
    <=> ( v76367(VarCurr)
      <~> v76451(VarCurr) ) ) ).

tff(addAssignment_47818,axiom,
    ! [VarCurr: state_type] :
      ( v76535(VarCurr)
    <=> v76537(VarCurr) ) ).

tff(addAssignment_47817,axiom,
    ! [VarCurr: state_type] :
      ( v76537(VarCurr)
    <=> v76539(VarCurr) ) ).

tff(addAssignment_47816,axiom,
    ! [VarCurr: state_type] :
      ( v76539(VarCurr)
    <=> v76541(VarCurr) ) ).

tff(addAssignment_47815,axiom,
    ! [VarCurr: state_type] :
      ( v76541(VarCurr)
    <=> v76543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7174,axiom,
    ! [VarCurr: state_type] :
      ( v76543(VarCurr)
    <=> ( v76617(VarCurr)
      <~> v76593(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7173,axiom,
    ! [VarCurr: state_type] :
      ( v76617(VarCurr)
    <=> ( v76545(VarCurr)
      <~> v76569(VarCurr) ) ) ).

tff(addAssignment_47814,axiom,
    ! [VarCurr: state_type] :
      ( v76593(VarCurr)
    <=> v76595(VarCurr) ) ).

tff(addAssignment_47813,axiom,
    ! [VarCurr: state_type] :
      ( v76595(VarCurr)
    <=> v76597(VarCurr) ) ).

tff(addAssignment_47812,axiom,
    ! [VarCurr: state_type] :
      ( v76597(VarCurr)
    <=> v76599(VarCurr) ) ).

tff(addAssignment_47811,axiom,
    ! [VarCurr: state_type] :
      ( v76599(VarCurr)
    <=> v76601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7172,axiom,
    ! [VarCurr: state_type] :
      ( v76601(VarCurr)
    <=> ( v76615(VarCurr)
      <~> v76611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7171,axiom,
    ! [VarCurr: state_type] :
      ( v76615(VarCurr)
    <=> ( v76603(VarCurr)
      <~> v76607(VarCurr) ) ) ).

tff(addAssignment_47810,axiom,
    ! [VarCurr: state_type] :
      ( v76611(VarCurr)
    <=> v76613(VarCurr) ) ).

tff(addAssignment_47809,axiom,
    ! [VarCurr: state_type] :
      ( v76613(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_47808,axiom,
    ! [VarCurr: state_type] :
      ( v76607(VarCurr)
    <=> v76609(VarCurr) ) ).

tff(addAssignment_47807,axiom,
    ! [VarCurr: state_type] :
      ( v76609(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_47806,axiom,
    ! [VarCurr: state_type] :
      ( v76603(VarCurr)
    <=> v76605(VarCurr) ) ).

tff(addAssignment_47805,axiom,
    ! [VarCurr: state_type] :
      ( v76605(VarCurr)
    <=> v67349(VarCurr,50) ) ).

tff(addAssignment_47804,axiom,
    ! [VarCurr: state_type] :
      ( v76569(VarCurr)
    <=> v76571(VarCurr) ) ).

tff(addAssignment_47803,axiom,
    ! [VarCurr: state_type] :
      ( v76571(VarCurr)
    <=> v76573(VarCurr) ) ).

tff(addAssignment_47802,axiom,
    ! [VarCurr: state_type] :
      ( v76573(VarCurr)
    <=> v76575(VarCurr) ) ).

tff(addAssignment_47801,axiom,
    ! [VarCurr: state_type] :
      ( v76575(VarCurr)
    <=> v76577(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7170,axiom,
    ! [VarCurr: state_type] :
      ( v76577(VarCurr)
    <=> ( v76591(VarCurr)
      <~> v76587(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7169,axiom,
    ! [VarCurr: state_type] :
      ( v76591(VarCurr)
    <=> ( v76579(VarCurr)
      <~> v76583(VarCurr) ) ) ).

tff(addAssignment_47800,axiom,
    ! [VarCurr: state_type] :
      ( v76587(VarCurr)
    <=> v76589(VarCurr) ) ).

tff(addAssignment_47799,axiom,
    ! [VarCurr: state_type] :
      ( v76589(VarCurr)
    <=> v67349(VarCurr,49) ) ).

tff(addAssignment_47798,axiom,
    ! [VarCurr: state_type] :
      ( v76583(VarCurr)
    <=> v76585(VarCurr) ) ).

tff(addAssignment_47797,axiom,
    ! [VarCurr: state_type] :
      ( v76585(VarCurr)
    <=> v67349(VarCurr,48) ) ).

tff(addAssignment_47796,axiom,
    ! [VarCurr: state_type] :
      ( v76579(VarCurr)
    <=> v76581(VarCurr) ) ).

tff(addAssignment_47795,axiom,
    ! [VarCurr: state_type] :
      ( v76581(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_47794,axiom,
    ! [VarCurr: state_type] :
      ( v76545(VarCurr)
    <=> v76547(VarCurr) ) ).

tff(addAssignment_47793,axiom,
    ! [VarCurr: state_type] :
      ( v76547(VarCurr)
    <=> v76549(VarCurr) ) ).

tff(addAssignment_47792,axiom,
    ! [VarCurr: state_type] :
      ( v76549(VarCurr)
    <=> v76551(VarCurr) ) ).

tff(addAssignment_47791,axiom,
    ! [VarCurr: state_type] :
      ( v76551(VarCurr)
    <=> v76553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7168,axiom,
    ! [VarCurr: state_type] :
      ( v76553(VarCurr)
    <=> ( v76567(VarCurr)
      <~> v76563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7167,axiom,
    ! [VarCurr: state_type] :
      ( v76567(VarCurr)
    <=> ( v76555(VarCurr)
      <~> v76559(VarCurr) ) ) ).

tff(addAssignment_47790,axiom,
    ! [VarCurr: state_type] :
      ( v76563(VarCurr)
    <=> v76565(VarCurr) ) ).

tff(addAssignment_47789,axiom,
    ! [VarCurr: state_type] :
      ( v76565(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_47788,axiom,
    ! [VarCurr: state_type] :
      ( v76559(VarCurr)
    <=> v76561(VarCurr) ) ).

tff(addAssignment_47787,axiom,
    ! [VarCurr: state_type] :
      ( v76561(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_47786,axiom,
    ! [VarCurr: state_type] :
      ( v76555(VarCurr)
    <=> v76557(VarCurr) ) ).

tff(addAssignment_47785,axiom,
    ! [VarCurr: state_type] :
      ( v76557(VarCurr)
    <=> v67349(VarCurr,41) ) ).

tff(addAssignment_47784,axiom,
    ! [VarCurr: state_type] :
      ( v76451(VarCurr)
    <=> v76453(VarCurr) ) ).

tff(addAssignment_47783,axiom,
    ! [VarCurr: state_type] :
      ( v76453(VarCurr)
    <=> v76455(VarCurr) ) ).

tff(addAssignment_47782,axiom,
    ! [VarCurr: state_type] :
      ( v76455(VarCurr)
    <=> v76457(VarCurr) ) ).

tff(addAssignment_47781,axiom,
    ! [VarCurr: state_type] :
      ( v76457(VarCurr)
    <=> v76459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7166,axiom,
    ! [VarCurr: state_type] :
      ( v76459(VarCurr)
    <=> ( v76533(VarCurr)
      <~> v76509(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7165,axiom,
    ! [VarCurr: state_type] :
      ( v76533(VarCurr)
    <=> ( v76461(VarCurr)
      <~> v76485(VarCurr) ) ) ).

tff(addAssignment_47780,axiom,
    ! [VarCurr: state_type] :
      ( v76509(VarCurr)
    <=> v76511(VarCurr) ) ).

tff(addAssignment_47779,axiom,
    ! [VarCurr: state_type] :
      ( v76511(VarCurr)
    <=> v76513(VarCurr) ) ).

tff(addAssignment_47778,axiom,
    ! [VarCurr: state_type] :
      ( v76513(VarCurr)
    <=> v76515(VarCurr) ) ).

tff(addAssignment_47777,axiom,
    ! [VarCurr: state_type] :
      ( v76515(VarCurr)
    <=> v76517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7164,axiom,
    ! [VarCurr: state_type] :
      ( v76517(VarCurr)
    <=> ( v76531(VarCurr)
      <~> v76527(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7163,axiom,
    ! [VarCurr: state_type] :
      ( v76531(VarCurr)
    <=> ( v76519(VarCurr)
      <~> v76523(VarCurr) ) ) ).

tff(addAssignment_47776,axiom,
    ! [VarCurr: state_type] :
      ( v76527(VarCurr)
    <=> v76529(VarCurr) ) ).

tff(addAssignment_47775,axiom,
    ! [VarCurr: state_type] :
      ( v76529(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_47774,axiom,
    ! [VarCurr: state_type] :
      ( v76523(VarCurr)
    <=> v76525(VarCurr) ) ).

tff(addAssignment_47773,axiom,
    ! [VarCurr: state_type] :
      ( v76525(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_47772,axiom,
    ! [VarCurr: state_type] :
      ( v76519(VarCurr)
    <=> v76521(VarCurr) ) ).

tff(addAssignment_47771,axiom,
    ! [VarCurr: state_type] :
      ( v76521(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_47770,axiom,
    ! [VarCurr: state_type] :
      ( v76485(VarCurr)
    <=> v76487(VarCurr) ) ).

tff(addAssignment_47769,axiom,
    ! [VarCurr: state_type] :
      ( v76487(VarCurr)
    <=> v76489(VarCurr) ) ).

tff(addAssignment_47768,axiom,
    ! [VarCurr: state_type] :
      ( v76489(VarCurr)
    <=> v76491(VarCurr) ) ).

tff(addAssignment_47767,axiom,
    ! [VarCurr: state_type] :
      ( v76491(VarCurr)
    <=> v76493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7162,axiom,
    ! [VarCurr: state_type] :
      ( v76493(VarCurr)
    <=> ( v76507(VarCurr)
      <~> v76503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7161,axiom,
    ! [VarCurr: state_type] :
      ( v76507(VarCurr)
    <=> ( v76495(VarCurr)
      <~> v76499(VarCurr) ) ) ).

tff(addAssignment_47766,axiom,
    ! [VarCurr: state_type] :
      ( v76503(VarCurr)
    <=> v76505(VarCurr) ) ).

tff(addAssignment_47765,axiom,
    ! [VarCurr: state_type] :
      ( v76505(VarCurr)
    <=> v67349(VarCurr,33) ) ).

tff(addAssignment_47764,axiom,
    ! [VarCurr: state_type] :
      ( v76499(VarCurr)
    <=> v76501(VarCurr) ) ).

tff(addAssignment_47763,axiom,
    ! [VarCurr: state_type] :
      ( v76501(VarCurr)
    <=> v67349(VarCurr,32) ) ).

tff(addAssignment_47762,axiom,
    ! [VarCurr: state_type] :
      ( v76495(VarCurr)
    <=> v76497(VarCurr) ) ).

tff(addAssignment_47761,axiom,
    ! [VarCurr: state_type] :
      ( v76497(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_47760,axiom,
    ! [VarCurr: state_type] :
      ( v76461(VarCurr)
    <=> v76463(VarCurr) ) ).

tff(addAssignment_47759,axiom,
    ! [VarCurr: state_type] :
      ( v76463(VarCurr)
    <=> v76465(VarCurr) ) ).

tff(addAssignment_47758,axiom,
    ! [VarCurr: state_type] :
      ( v76465(VarCurr)
    <=> v76467(VarCurr) ) ).

tff(addAssignment_47757,axiom,
    ! [VarCurr: state_type] :
      ( v76467(VarCurr)
    <=> v76469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7160,axiom,
    ! [VarCurr: state_type] :
      ( v76469(VarCurr)
    <=> ( v76483(VarCurr)
      <~> v76479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7159,axiom,
    ! [VarCurr: state_type] :
      ( v76483(VarCurr)
    <=> ( v76471(VarCurr)
      <~> v76475(VarCurr) ) ) ).

tff(addAssignment_47756,axiom,
    ! [VarCurr: state_type] :
      ( v76479(VarCurr)
    <=> v76481(VarCurr) ) ).

tff(addAssignment_47755,axiom,
    ! [VarCurr: state_type] :
      ( v76481(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_47754,axiom,
    ! [VarCurr: state_type] :
      ( v76475(VarCurr)
    <=> v76477(VarCurr) ) ).

tff(addAssignment_47753,axiom,
    ! [VarCurr: state_type] :
      ( v76477(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_47752,axiom,
    ! [VarCurr: state_type] :
      ( v76471(VarCurr)
    <=> v76473(VarCurr) ) ).

tff(addAssignment_47751,axiom,
    ! [VarCurr: state_type] :
      ( v76473(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_47750,axiom,
    ! [VarCurr: state_type] :
      ( v76367(VarCurr)
    <=> v76369(VarCurr) ) ).

tff(addAssignment_47749,axiom,
    ! [VarCurr: state_type] :
      ( v76369(VarCurr)
    <=> v76371(VarCurr) ) ).

tff(addAssignment_47748,axiom,
    ! [VarCurr: state_type] :
      ( v76371(VarCurr)
    <=> v76373(VarCurr) ) ).

tff(addAssignment_47747,axiom,
    ! [VarCurr: state_type] :
      ( v76373(VarCurr)
    <=> v76375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7158,axiom,
    ! [VarCurr: state_type] :
      ( v76375(VarCurr)
    <=> ( v76449(VarCurr)
      <~> v76425(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7157,axiom,
    ! [VarCurr: state_type] :
      ( v76449(VarCurr)
    <=> ( v76377(VarCurr)
      <~> v76401(VarCurr) ) ) ).

tff(addAssignment_47746,axiom,
    ! [VarCurr: state_type] :
      ( v76425(VarCurr)
    <=> v76427(VarCurr) ) ).

tff(addAssignment_47745,axiom,
    ! [VarCurr: state_type] :
      ( v76427(VarCurr)
    <=> v76429(VarCurr) ) ).

tff(addAssignment_47744,axiom,
    ! [VarCurr: state_type] :
      ( v76429(VarCurr)
    <=> v76431(VarCurr) ) ).

tff(addAssignment_47743,axiom,
    ! [VarCurr: state_type] :
      ( v76431(VarCurr)
    <=> v76433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7156,axiom,
    ! [VarCurr: state_type] :
      ( v76433(VarCurr)
    <=> ( v76447(VarCurr)
      <~> v76443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7155,axiom,
    ! [VarCurr: state_type] :
      ( v76447(VarCurr)
    <=> ( v76435(VarCurr)
      <~> v76439(VarCurr) ) ) ).

tff(addAssignment_47742,axiom,
    ! [VarCurr: state_type] :
      ( v76443(VarCurr)
    <=> v76445(VarCurr) ) ).

tff(addAssignment_47741,axiom,
    ! [VarCurr: state_type] :
      ( v76445(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_47740,axiom,
    ! [VarCurr: state_type] :
      ( v76439(VarCurr)
    <=> v76441(VarCurr) ) ).

tff(addAssignment_47739,axiom,
    ! [VarCurr: state_type] :
      ( v76441(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_47738,axiom,
    ! [VarCurr: state_type] :
      ( v76435(VarCurr)
    <=> v76437(VarCurr) ) ).

tff(addAssignment_47737,axiom,
    ! [VarCurr: state_type] :
      ( v76437(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_47736,axiom,
    ! [VarCurr: state_type] :
      ( v76401(VarCurr)
    <=> v76403(VarCurr) ) ).

tff(addAssignment_47735,axiom,
    ! [VarCurr: state_type] :
      ( v76403(VarCurr)
    <=> v76405(VarCurr) ) ).

tff(addAssignment_47734,axiom,
    ! [VarCurr: state_type] :
      ( v76405(VarCurr)
    <=> v76407(VarCurr) ) ).

tff(addAssignment_47733,axiom,
    ! [VarCurr: state_type] :
      ( v76407(VarCurr)
    <=> v76409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7154,axiom,
    ! [VarCurr: state_type] :
      ( v76409(VarCurr)
    <=> ( v76423(VarCurr)
      <~> v76419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7153,axiom,
    ! [VarCurr: state_type] :
      ( v76423(VarCurr)
    <=> ( v76411(VarCurr)
      <~> v76415(VarCurr) ) ) ).

tff(addAssignment_47732,axiom,
    ! [VarCurr: state_type] :
      ( v76419(VarCurr)
    <=> v76421(VarCurr) ) ).

tff(addAssignment_47731,axiom,
    ! [VarCurr: state_type] :
      ( v76421(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_47730,axiom,
    ! [VarCurr: state_type] :
      ( v76415(VarCurr)
    <=> v76417(VarCurr) ) ).

tff(addAssignment_47729,axiom,
    ! [VarCurr: state_type] :
      ( v76417(VarCurr)
    <=> v67349(VarCurr,14) ) ).

tff(addAssignment_47728,axiom,
    ! [VarCurr: state_type] :
      ( v76411(VarCurr)
    <=> v76413(VarCurr) ) ).

tff(addAssignment_47727,axiom,
    ! [VarCurr: state_type] :
      ( v76413(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_47726,axiom,
    ! [VarCurr: state_type] :
      ( v76377(VarCurr)
    <=> v76379(VarCurr) ) ).

tff(addAssignment_47725,axiom,
    ! [VarCurr: state_type] :
      ( v76379(VarCurr)
    <=> v76381(VarCurr) ) ).

tff(addAssignment_47724,axiom,
    ! [VarCurr: state_type] :
      ( v76381(VarCurr)
    <=> v76383(VarCurr) ) ).

tff(addAssignment_47723,axiom,
    ! [VarCurr: state_type] :
      ( v76383(VarCurr)
    <=> v76385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7152,axiom,
    ! [VarCurr: state_type] :
      ( v76385(VarCurr)
    <=> ( v76399(VarCurr)
      <~> v76395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7151,axiom,
    ! [VarCurr: state_type] :
      ( v76399(VarCurr)
    <=> ( v76387(VarCurr)
      <~> v76391(VarCurr) ) ) ).

tff(addAssignment_47722,axiom,
    ! [VarCurr: state_type] :
      ( v76395(VarCurr)
    <=> v76397(VarCurr) ) ).

tff(addAssignment_47721,axiom,
    ! [VarCurr: state_type] :
      ( v76397(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_47720,axiom,
    ! [VarCurr: state_type] :
      ( v76391(VarCurr)
    <=> v76393(VarCurr) ) ).

tff(addAssignment_47719,axiom,
    ! [VarCurr: state_type] :
      ( v76393(VarCurr)
    <=> v67349(VarCurr,7) ) ).

tff(addAssignment_47718,axiom,
    ! [VarCurr: state_type] :
      ( v76387(VarCurr)
    <=> v76389(VarCurr) ) ).

tff(addAssignment_47717,axiom,
    ! [VarCurr: state_type] :
      ( v76389(VarCurr)
    <=> v67349(VarCurr,0) ) ).

tff(addAssignment_47716,axiom,
    ! [VarCurr: state_type] :
      ( v67253(VarCurr,0)
    <=> v67255(VarCurr,0) ) ).

tff(addAssignment_47715,axiom,
    ! [VarCurr: state_type] :
      ( v67255(VarCurr,0)
    <=> v74273(VarCurr,0) ) ).

tff(addAssignment_47714,axiom,
    ! [VarCurr: state_type] :
      ( v75679(VarCurr)
    <=> v75681(VarCurr) ) ).

tff(addAssignment_47713,axiom,
    ! [VarCurr: state_type] :
      ( v75681(VarCurr)
    <=> v67247(VarCurr,1) ) ).

tff(addAssignment_47712,axiom,
    ! [VarCurr: state_type] :
      ( v67247(VarCurr,1)
    <=> v67249(VarCurr,1) ) ).

tff(addAssignment_47711,axiom,
    ! [VarCurr: state_type] :
      ( v67249(VarCurr,1)
    <=> v67251(VarCurr,1) ) ).

tff(addAssignment_47710,axiom,
    ! [VarCurr: state_type] :
      ( v67251(VarCurr,1)
    <=> v74995(VarCurr,1) ) ).

tff(addAssignment_47709,axiom,
    ! [VarCurr: state_type] :
      ( v74276(VarCurr,1)
    <=> v74278(VarCurr,1) ) ).

tff(addAssignment_47708,axiom,
    ! [VarCurr: state_type] :
      ( v74278(VarCurr,1)
    <=> v74280(VarCurr,1) ) ).

tff(addAssignment_47707,axiom,
    ! [VarCurr: state_type] :
      ( v74280(VarCurr,1)
    <=> v67309(VarCurr,13) ) ).

tff(addAssignment_47706,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,13)
    <=> v67311(VarCurr,13) ) ).

tff(addAssignment_47705,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,13)
    <=> v67313(VarCurr,13) ) ).

tff(addAssignment_47704,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,13)
    <=> v67315(VarCurr,13) ) ).

tff(addAssignment_47703,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,13)
    <=> v67317(VarCurr,13) ) ).

tff(addAssignment_47702,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,13)
    <=> v68771(VarCurr,13) ) ).

tff(addAssignment_47701,axiom,
    ! [VarCurr: state_type] :
      ( v68772(VarCurr,1)
    <=> v75683(VarCurr) ) ).

tff(addAssignment_47700,axiom,
    ! [VarCurr: state_type] :
      ( v75683(VarCurr)
    <=> v75685(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7150,axiom,
    ! [VarCurr: state_type] :
      ( v75685(VarCurr)
    <=> ( v76347(VarCurr)
      <~> v76215(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7149,axiom,
    ! [VarCurr: state_type] :
      ( v76347(VarCurr)
    <=> ( v75687(VarCurr)
      <~> v75951(VarCurr) ) ) ).

tff(addAssignment_47699,axiom,
    ! [VarCurr: state_type] :
      ( v76215(VarCurr)
    <=> v76217(VarCurr) ) ).

tff(addAssignment_47698,axiom,
    ! [VarCurr: state_type] :
      ( v76217(VarCurr)
    <=> v76219(VarCurr) ) ).

tff(addAssignment_47697,axiom,
    ! [VarCurr: state_type] :
      ( v76219(VarCurr)
    <=> v76221(VarCurr) ) ).

tff(addAssignment_47696,axiom,
    ! [VarCurr: state_type] :
      ( v76221(VarCurr)
    <=> v76223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7148,axiom,
    ! [VarCurr: state_type] :
      ( v76223(VarCurr)
    <=> ( v76345(VarCurr)
      <~> v76333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7147,axiom,
    ! [VarCurr: state_type] :
      ( v76345(VarCurr)
    <=> ( v76225(VarCurr)
      <~> v76249(VarCurr) ) ) ).

tff(addAssignment_47695,axiom,
    ! [VarCurr: state_type] :
      ( v76333(VarCurr)
    <=> v76335(VarCurr) ) ).

tff(addAssignment_47694,axiom,
    ! [VarCurr: state_type] :
      ( v76335(VarCurr)
    <=> v74937(VarCurr,1) ) ).

tff(addAssignment_47693,axiom,
    ! [VarCurr: state_type] :
      ( v74937(VarCurr,1)
    <=> v74939(VarCurr,1) ) ).

tff(addAssignment_47692,axiom,
    ! [VarCurr: state_type] :
      ( v74939(VarCurr,1)
    <=> v68676(VarCurr,5) ) ).

tff(addAssignment_47691,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,5)
    <=> v68678(VarCurr,5) ) ).

tff(addAssignment_47690,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,5)
    <=> v76337(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v76338(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v76337(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_908,axiom,
    ! [VarNext: state_type] :
      ( v76338(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v76337(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v76338(VarNext)
      <=> v76339(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v76339(VarNext)
      <=> ( v76341(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v76341(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_47689,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,5)
    <=> v68702(VarCurr,5) ) ).

tff(addAssignment_47688,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,5)
    <=> v68731(VarCurr,5) ) ).

tff(addAssignment_47687,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,13)
    <=> v74950(VarCurr,1) ) ).

tff(addAssignment_47686,axiom,
    ! [VarCurr: state_type] :
      ( v74950(VarCurr,1)
    <=> v74952(VarCurr,1) ) ).

tff(addAssignment_47685,axiom,
    ! [VarCurr: state_type] :
      ( v74952(VarCurr,1)
    <=> v74969(VarCurr,1) ) ).

tff(addAssignment_47684,axiom,
    ! [VarCurr: state_type] :
      ( v74962(VarCurr,1)
    <=> v74964(VarCurr,1) ) ).

tff(addAssignment_47683,axiom,
    ! [VarCurr: state_type] :
      ( v74964(VarCurr,1)
    <=> v68455(VarCurr,13) ) ).

tff(addAssignment_47682,axiom,
    ! [VarCurr: state_type] :
      ( v74954(VarCurr,1)
    <=> v74956(VarCurr,1) ) ).

tff(addAssignment_47681,axiom,
    ! [VarCurr: state_type] :
      ( v74956(VarCurr,1)
    <=> v68455(VarCurr,9) ) ).

tff(addAssignment_47680,axiom,
    ! [VarCurr: state_type] :
      ( v76249(VarCurr)
    <=> v76251(VarCurr) ) ).

tff(addAssignment_47679,axiom,
    ! [VarCurr: state_type] :
      ( v76251(VarCurr)
    <=> v76253(VarCurr) ) ).

tff(addAssignment_47678,axiom,
    ! [VarCurr: state_type] :
      ( v76253(VarCurr)
    <=> v76255(VarCurr) ) ).

tff(addAssignment_47677,axiom,
    ! [VarCurr: state_type] :
      ( v76255(VarCurr)
    <=> v76257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7144,axiom,
    ! [VarCurr: state_type] :
      ( v76257(VarCurr)
    <=> ( v76331(VarCurr)
      <~> v76307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7143,axiom,
    ! [VarCurr: state_type] :
      ( v76331(VarCurr)
    <=> ( v76259(VarCurr)
      <~> v76283(VarCurr) ) ) ).

tff(addAssignment_47676,axiom,
    ! [VarCurr: state_type] :
      ( v76307(VarCurr)
    <=> v76309(VarCurr) ) ).

tff(addAssignment_47675,axiom,
    ! [VarCurr: state_type] :
      ( v76309(VarCurr)
    <=> v76311(VarCurr) ) ).

tff(addAssignment_47674,axiom,
    ! [VarCurr: state_type] :
      ( v76311(VarCurr)
    <=> v76313(VarCurr) ) ).

tff(addAssignment_47673,axiom,
    ! [VarCurr: state_type] :
      ( v76313(VarCurr)
    <=> v76315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7142,axiom,
    ! [VarCurr: state_type] :
      ( v76315(VarCurr)
    <=> ( v76329(VarCurr)
      <~> v76325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7141,axiom,
    ! [VarCurr: state_type] :
      ( v76329(VarCurr)
    <=> ( v76317(VarCurr)
      <~> v76321(VarCurr) ) ) ).

tff(addAssignment_47672,axiom,
    ! [VarCurr: state_type] :
      ( v76325(VarCurr)
    <=> v76327(VarCurr) ) ).

tff(addAssignment_47671,axiom,
    ! [VarCurr: state_type] :
      ( v76327(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_47670,axiom,
    ! [VarCurr: state_type] :
      ( v76321(VarCurr)
    <=> v76323(VarCurr) ) ).

tff(addAssignment_47669,axiom,
    ! [VarCurr: state_type] :
      ( v76323(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_47668,axiom,
    ! [VarCurr: state_type] :
      ( v76317(VarCurr)
    <=> v76319(VarCurr) ) ).

tff(addAssignment_47667,axiom,
    ! [VarCurr: state_type] :
      ( v76319(VarCurr)
    <=> v67349(VarCurr,111) ) ).

tff(addAssignment_47666,axiom,
    ! [VarCurr: state_type] :
      ( v76283(VarCurr)
    <=> v76285(VarCurr) ) ).

tff(addAssignment_47665,axiom,
    ! [VarCurr: state_type] :
      ( v76285(VarCurr)
    <=> v76287(VarCurr) ) ).

tff(addAssignment_47664,axiom,
    ! [VarCurr: state_type] :
      ( v76287(VarCurr)
    <=> v76289(VarCurr) ) ).

tff(addAssignment_47663,axiom,
    ! [VarCurr: state_type] :
      ( v76289(VarCurr)
    <=> v76291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7140,axiom,
    ! [VarCurr: state_type] :
      ( v76291(VarCurr)
    <=> ( v76305(VarCurr)
      <~> v76301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7139,axiom,
    ! [VarCurr: state_type] :
      ( v76305(VarCurr)
    <=> ( v76293(VarCurr)
      <~> v76297(VarCurr) ) ) ).

tff(addAssignment_47662,axiom,
    ! [VarCurr: state_type] :
      ( v76301(VarCurr)
    <=> v76303(VarCurr) ) ).

tff(addAssignment_47661,axiom,
    ! [VarCurr: state_type] :
      ( v76303(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_47660,axiom,
    ! [VarCurr: state_type] :
      ( v76297(VarCurr)
    <=> v76299(VarCurr) ) ).

tff(addAssignment_47659,axiom,
    ! [VarCurr: state_type] :
      ( v76299(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_47658,axiom,
    ! [VarCurr: state_type] :
      ( v76293(VarCurr)
    <=> v76295(VarCurr) ) ).

tff(addAssignment_47657,axiom,
    ! [VarCurr: state_type] :
      ( v76295(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_47656,axiom,
    ! [VarCurr: state_type] :
      ( v76259(VarCurr)
    <=> v76261(VarCurr) ) ).

tff(addAssignment_47655,axiom,
    ! [VarCurr: state_type] :
      ( v76261(VarCurr)
    <=> v76263(VarCurr) ) ).

tff(addAssignment_47654,axiom,
    ! [VarCurr: state_type] :
      ( v76263(VarCurr)
    <=> v76265(VarCurr) ) ).

tff(addAssignment_47653,axiom,
    ! [VarCurr: state_type] :
      ( v76265(VarCurr)
    <=> v76267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7138,axiom,
    ! [VarCurr: state_type] :
      ( v76267(VarCurr)
    <=> ( v76281(VarCurr)
      <~> v76277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7137,axiom,
    ! [VarCurr: state_type] :
      ( v76281(VarCurr)
    <=> ( v76269(VarCurr)
      <~> v76273(VarCurr) ) ) ).

tff(addAssignment_47652,axiom,
    ! [VarCurr: state_type] :
      ( v76277(VarCurr)
    <=> v76279(VarCurr) ) ).

tff(addAssignment_47651,axiom,
    ! [VarCurr: state_type] :
      ( v76279(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_47650,axiom,
    ! [VarCurr: state_type] :
      ( v76273(VarCurr)
    <=> v76275(VarCurr) ) ).

tff(addAssignment_47649,axiom,
    ! [VarCurr: state_type] :
      ( v76275(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_47648,axiom,
    ! [VarCurr: state_type] :
      ( v76269(VarCurr)
    <=> v76271(VarCurr) ) ).

tff(addAssignment_47647,axiom,
    ! [VarCurr: state_type] :
      ( v76271(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_47646,axiom,
    ! [VarCurr: state_type] :
      ( v76225(VarCurr)
    <=> v76227(VarCurr) ) ).

tff(addAssignment_47645,axiom,
    ! [VarCurr: state_type] :
      ( v76227(VarCurr)
    <=> v76229(VarCurr) ) ).

tff(addAssignment_47644,axiom,
    ! [VarCurr: state_type] :
      ( v76229(VarCurr)
    <=> v76231(VarCurr) ) ).

tff(addAssignment_47643,axiom,
    ! [VarCurr: state_type] :
      ( v76231(VarCurr)
    <=> v76233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7136,axiom,
    ! [VarCurr: state_type] :
      ( v76233(VarCurr)
    <=> ( v76247(VarCurr)
      <~> v76243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7135,axiom,
    ! [VarCurr: state_type] :
      ( v76247(VarCurr)
    <=> ( v76235(VarCurr)
      <~> v76239(VarCurr) ) ) ).

tff(addAssignment_47642,axiom,
    ! [VarCurr: state_type] :
      ( v76243(VarCurr)
    <=> v76245(VarCurr) ) ).

tff(addAssignment_47641,axiom,
    ! [VarCurr: state_type] :
      ( v76245(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_47640,axiom,
    ! [VarCurr: state_type] :
      ( v76239(VarCurr)
    <=> v76241(VarCurr) ) ).

tff(addAssignment_47639,axiom,
    ! [VarCurr: state_type] :
      ( v76241(VarCurr)
    <=> v67349(VarCurr,125) ) ).

tff(addAssignment_47638,axiom,
    ! [VarCurr: state_type] :
      ( v76235(VarCurr)
    <=> v76237(VarCurr) ) ).

tff(addAssignment_47637,axiom,
    ! [VarCurr: state_type] :
      ( v76237(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_47636,axiom,
    ! [VarCurr: state_type] :
      ( v75951(VarCurr)
    <=> v75953(VarCurr) ) ).

tff(addAssignment_47635,axiom,
    ! [VarCurr: state_type] :
      ( v75953(VarCurr)
    <=> v75955(VarCurr) ) ).

tff(addAssignment_47634,axiom,
    ! [VarCurr: state_type] :
      ( v75955(VarCurr)
    <=> v75957(VarCurr) ) ).

tff(addAssignment_47633,axiom,
    ! [VarCurr: state_type] :
      ( v75957(VarCurr)
    <=> v75959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7134,axiom,
    ! [VarCurr: state_type] :
      ( v75959(VarCurr)
    <=> ( v76213(VarCurr)
      <~> v76129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7133,axiom,
    ! [VarCurr: state_type] :
      ( v76213(VarCurr)
    <=> ( v75961(VarCurr)
      <~> v76045(VarCurr) ) ) ).

tff(addAssignment_47632,axiom,
    ! [VarCurr: state_type] :
      ( v76129(VarCurr)
    <=> v76131(VarCurr) ) ).

tff(addAssignment_47631,axiom,
    ! [VarCurr: state_type] :
      ( v76131(VarCurr)
    <=> v76133(VarCurr) ) ).

tff(addAssignment_47630,axiom,
    ! [VarCurr: state_type] :
      ( v76133(VarCurr)
    <=> v76135(VarCurr) ) ).

tff(addAssignment_47629,axiom,
    ! [VarCurr: state_type] :
      ( v76135(VarCurr)
    <=> v76137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7132,axiom,
    ! [VarCurr: state_type] :
      ( v76137(VarCurr)
    <=> ( v76211(VarCurr)
      <~> v76187(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7131,axiom,
    ! [VarCurr: state_type] :
      ( v76211(VarCurr)
    <=> ( v76139(VarCurr)
      <~> v76163(VarCurr) ) ) ).

tff(addAssignment_47628,axiom,
    ! [VarCurr: state_type] :
      ( v76187(VarCurr)
    <=> v76189(VarCurr) ) ).

tff(addAssignment_47627,axiom,
    ! [VarCurr: state_type] :
      ( v76189(VarCurr)
    <=> v76191(VarCurr) ) ).

tff(addAssignment_47626,axiom,
    ! [VarCurr: state_type] :
      ( v76191(VarCurr)
    <=> v76193(VarCurr) ) ).

tff(addAssignment_47625,axiom,
    ! [VarCurr: state_type] :
      ( v76193(VarCurr)
    <=> v76195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7130,axiom,
    ! [VarCurr: state_type] :
      ( v76195(VarCurr)
    <=> ( v76209(VarCurr)
      <~> v76205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7129,axiom,
    ! [VarCurr: state_type] :
      ( v76209(VarCurr)
    <=> ( v76197(VarCurr)
      <~> v76201(VarCurr) ) ) ).

tff(addAssignment_47624,axiom,
    ! [VarCurr: state_type] :
      ( v76205(VarCurr)
    <=> v76207(VarCurr) ) ).

tff(addAssignment_47623,axiom,
    ! [VarCurr: state_type] :
      ( v76207(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_47622,axiom,
    ! [VarCurr: state_type] :
      ( v76201(VarCurr)
    <=> v76203(VarCurr) ) ).

tff(addAssignment_47621,axiom,
    ! [VarCurr: state_type] :
      ( v76203(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_47620,axiom,
    ! [VarCurr: state_type] :
      ( v76197(VarCurr)
    <=> v76199(VarCurr) ) ).

tff(addAssignment_47619,axiom,
    ! [VarCurr: state_type] :
      ( v76199(VarCurr)
    <=> v67349(VarCurr,96) ) ).

tff(addAssignment_47618,axiom,
    ! [VarCurr: state_type] :
      ( v76163(VarCurr)
    <=> v76165(VarCurr) ) ).

tff(addAssignment_47617,axiom,
    ! [VarCurr: state_type] :
      ( v76165(VarCurr)
    <=> v76167(VarCurr) ) ).

tff(addAssignment_47616,axiom,
    ! [VarCurr: state_type] :
      ( v76167(VarCurr)
    <=> v76169(VarCurr) ) ).

tff(addAssignment_47615,axiom,
    ! [VarCurr: state_type] :
      ( v76169(VarCurr)
    <=> v76171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7128,axiom,
    ! [VarCurr: state_type] :
      ( v76171(VarCurr)
    <=> ( v76185(VarCurr)
      <~> v76181(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7127,axiom,
    ! [VarCurr: state_type] :
      ( v76185(VarCurr)
    <=> ( v76173(VarCurr)
      <~> v76177(VarCurr) ) ) ).

tff(addAssignment_47614,axiom,
    ! [VarCurr: state_type] :
      ( v76181(VarCurr)
    <=> v76183(VarCurr) ) ).

tff(addAssignment_47613,axiom,
    ! [VarCurr: state_type] :
      ( v76183(VarCurr)
    <=> v67349(VarCurr,94) ) ).

tff(addAssignment_47612,axiom,
    ! [VarCurr: state_type] :
      ( v76177(VarCurr)
    <=> v76179(VarCurr) ) ).

tff(addAssignment_47611,axiom,
    ! [VarCurr: state_type] :
      ( v76179(VarCurr)
    <=> v67349(VarCurr,90) ) ).

tff(addAssignment_47610,axiom,
    ! [VarCurr: state_type] :
      ( v76173(VarCurr)
    <=> v76175(VarCurr) ) ).

tff(addAssignment_47609,axiom,
    ! [VarCurr: state_type] :
      ( v76175(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_47608,axiom,
    ! [VarCurr: state_type] :
      ( v76139(VarCurr)
    <=> v76141(VarCurr) ) ).

tff(addAssignment_47607,axiom,
    ! [VarCurr: state_type] :
      ( v76141(VarCurr)
    <=> v76143(VarCurr) ) ).

tff(addAssignment_47606,axiom,
    ! [VarCurr: state_type] :
      ( v76143(VarCurr)
    <=> v76145(VarCurr) ) ).

tff(addAssignment_47605,axiom,
    ! [VarCurr: state_type] :
      ( v76145(VarCurr)
    <=> v76147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7126,axiom,
    ! [VarCurr: state_type] :
      ( v76147(VarCurr)
    <=> ( v76161(VarCurr)
      <~> v76157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7125,axiom,
    ! [VarCurr: state_type] :
      ( v76161(VarCurr)
    <=> ( v76149(VarCurr)
      <~> v76153(VarCurr) ) ) ).

tff(addAssignment_47604,axiom,
    ! [VarCurr: state_type] :
      ( v76157(VarCurr)
    <=> v76159(VarCurr) ) ).

tff(addAssignment_47603,axiom,
    ! [VarCurr: state_type] :
      ( v76159(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_47602,axiom,
    ! [VarCurr: state_type] :
      ( v76153(VarCurr)
    <=> v76155(VarCurr) ) ).

tff(addAssignment_47601,axiom,
    ! [VarCurr: state_type] :
      ( v76155(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_47600,axiom,
    ! [VarCurr: state_type] :
      ( v76149(VarCurr)
    <=> v76151(VarCurr) ) ).

tff(addAssignment_47599,axiom,
    ! [VarCurr: state_type] :
      ( v76151(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_47598,axiom,
    ! [VarCurr: state_type] :
      ( v76045(VarCurr)
    <=> v76047(VarCurr) ) ).

tff(addAssignment_47597,axiom,
    ! [VarCurr: state_type] :
      ( v76047(VarCurr)
    <=> v76049(VarCurr) ) ).

tff(addAssignment_47596,axiom,
    ! [VarCurr: state_type] :
      ( v76049(VarCurr)
    <=> v76051(VarCurr) ) ).

tff(addAssignment_47595,axiom,
    ! [VarCurr: state_type] :
      ( v76051(VarCurr)
    <=> v76053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7124,axiom,
    ! [VarCurr: state_type] :
      ( v76053(VarCurr)
    <=> ( v76127(VarCurr)
      <~> v76103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7123,axiom,
    ! [VarCurr: state_type] :
      ( v76127(VarCurr)
    <=> ( v76055(VarCurr)
      <~> v76079(VarCurr) ) ) ).

tff(addAssignment_47594,axiom,
    ! [VarCurr: state_type] :
      ( v76103(VarCurr)
    <=> v76105(VarCurr) ) ).

tff(addAssignment_47593,axiom,
    ! [VarCurr: state_type] :
      ( v76105(VarCurr)
    <=> v76107(VarCurr) ) ).

tff(addAssignment_47592,axiom,
    ! [VarCurr: state_type] :
      ( v76107(VarCurr)
    <=> v76109(VarCurr) ) ).

tff(addAssignment_47591,axiom,
    ! [VarCurr: state_type] :
      ( v76109(VarCurr)
    <=> v76111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7122,axiom,
    ! [VarCurr: state_type] :
      ( v76111(VarCurr)
    <=> ( v76125(VarCurr)
      <~> v76121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7121,axiom,
    ! [VarCurr: state_type] :
      ( v76125(VarCurr)
    <=> ( v76113(VarCurr)
      <~> v76117(VarCurr) ) ) ).

tff(addAssignment_47590,axiom,
    ! [VarCurr: state_type] :
      ( v76121(VarCurr)
    <=> v76123(VarCurr) ) ).

tff(addAssignment_47589,axiom,
    ! [VarCurr: state_type] :
      ( v76123(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_47588,axiom,
    ! [VarCurr: state_type] :
      ( v76117(VarCurr)
    <=> v76119(VarCurr) ) ).

tff(addAssignment_47587,axiom,
    ! [VarCurr: state_type] :
      ( v76119(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_47586,axiom,
    ! [VarCurr: state_type] :
      ( v76113(VarCurr)
    <=> v76115(VarCurr) ) ).

tff(addAssignment_47585,axiom,
    ! [VarCurr: state_type] :
      ( v76115(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_47584,axiom,
    ! [VarCurr: state_type] :
      ( v76079(VarCurr)
    <=> v76081(VarCurr) ) ).

tff(addAssignment_47583,axiom,
    ! [VarCurr: state_type] :
      ( v76081(VarCurr)
    <=> v76083(VarCurr) ) ).

tff(addAssignment_47582,axiom,
    ! [VarCurr: state_type] :
      ( v76083(VarCurr)
    <=> v76085(VarCurr) ) ).

tff(addAssignment_47581,axiom,
    ! [VarCurr: state_type] :
      ( v76085(VarCurr)
    <=> v76087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7120,axiom,
    ! [VarCurr: state_type] :
      ( v76087(VarCurr)
    <=> ( v76101(VarCurr)
      <~> v76097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7119,axiom,
    ! [VarCurr: state_type] :
      ( v76101(VarCurr)
    <=> ( v76089(VarCurr)
      <~> v76093(VarCurr) ) ) ).

tff(addAssignment_47580,axiom,
    ! [VarCurr: state_type] :
      ( v76097(VarCurr)
    <=> v76099(VarCurr) ) ).

tff(addAssignment_47579,axiom,
    ! [VarCurr: state_type] :
      ( v76099(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_47578,axiom,
    ! [VarCurr: state_type] :
      ( v76093(VarCurr)
    <=> v76095(VarCurr) ) ).

tff(addAssignment_47577,axiom,
    ! [VarCurr: state_type] :
      ( v76095(VarCurr)
    <=> v67349(VarCurr,77) ) ).

tff(addAssignment_47576,axiom,
    ! [VarCurr: state_type] :
      ( v76089(VarCurr)
    <=> v76091(VarCurr) ) ).

tff(addAssignment_47575,axiom,
    ! [VarCurr: state_type] :
      ( v76091(VarCurr)
    <=> v67349(VarCurr,75) ) ).

tff(addAssignment_47574,axiom,
    ! [VarCurr: state_type] :
      ( v76055(VarCurr)
    <=> v76057(VarCurr) ) ).

tff(addAssignment_47573,axiom,
    ! [VarCurr: state_type] :
      ( v76057(VarCurr)
    <=> v76059(VarCurr) ) ).

tff(addAssignment_47572,axiom,
    ! [VarCurr: state_type] :
      ( v76059(VarCurr)
    <=> v76061(VarCurr) ) ).

tff(addAssignment_47571,axiom,
    ! [VarCurr: state_type] :
      ( v76061(VarCurr)
    <=> v76063(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7118,axiom,
    ! [VarCurr: state_type] :
      ( v76063(VarCurr)
    <=> ( v76077(VarCurr)
      <~> v76073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7117,axiom,
    ! [VarCurr: state_type] :
      ( v76077(VarCurr)
    <=> ( v76065(VarCurr)
      <~> v76069(VarCurr) ) ) ).

tff(addAssignment_47570,axiom,
    ! [VarCurr: state_type] :
      ( v76073(VarCurr)
    <=> v76075(VarCurr) ) ).

tff(addAssignment_47569,axiom,
    ! [VarCurr: state_type] :
      ( v76075(VarCurr)
    <=> v67349(VarCurr,74) ) ).

tff(addAssignment_47568,axiom,
    ! [VarCurr: state_type] :
      ( v76069(VarCurr)
    <=> v76071(VarCurr) ) ).

tff(addAssignment_47567,axiom,
    ! [VarCurr: state_type] :
      ( v76071(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_47566,axiom,
    ! [VarCurr: state_type] :
      ( v76065(VarCurr)
    <=> v76067(VarCurr) ) ).

tff(addAssignment_47565,axiom,
    ! [VarCurr: state_type] :
      ( v76067(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_47564,axiom,
    ! [VarCurr: state_type] :
      ( v75961(VarCurr)
    <=> v75963(VarCurr) ) ).

tff(addAssignment_47563,axiom,
    ! [VarCurr: state_type] :
      ( v75963(VarCurr)
    <=> v75965(VarCurr) ) ).

tff(addAssignment_47562,axiom,
    ! [VarCurr: state_type] :
      ( v75965(VarCurr)
    <=> v75967(VarCurr) ) ).

tff(addAssignment_47561,axiom,
    ! [VarCurr: state_type] :
      ( v75967(VarCurr)
    <=> v75969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7116,axiom,
    ! [VarCurr: state_type] :
      ( v75969(VarCurr)
    <=> ( v76043(VarCurr)
      <~> v76019(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7115,axiom,
    ! [VarCurr: state_type] :
      ( v76043(VarCurr)
    <=> ( v75971(VarCurr)
      <~> v75995(VarCurr) ) ) ).

tff(addAssignment_47560,axiom,
    ! [VarCurr: state_type] :
      ( v76019(VarCurr)
    <=> v76021(VarCurr) ) ).

tff(addAssignment_47559,axiom,
    ! [VarCurr: state_type] :
      ( v76021(VarCurr)
    <=> v76023(VarCurr) ) ).

tff(addAssignment_47558,axiom,
    ! [VarCurr: state_type] :
      ( v76023(VarCurr)
    <=> v76025(VarCurr) ) ).

tff(addAssignment_47557,axiom,
    ! [VarCurr: state_type] :
      ( v76025(VarCurr)
    <=> v76027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7114,axiom,
    ! [VarCurr: state_type] :
      ( v76027(VarCurr)
    <=> ( v76041(VarCurr)
      <~> v76037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7113,axiom,
    ! [VarCurr: state_type] :
      ( v76041(VarCurr)
    <=> ( v76029(VarCurr)
      <~> v76033(VarCurr) ) ) ).

tff(addAssignment_47556,axiom,
    ! [VarCurr: state_type] :
      ( v76037(VarCurr)
    <=> v76039(VarCurr) ) ).

tff(addAssignment_47555,axiom,
    ! [VarCurr: state_type] :
      ( v76039(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_47554,axiom,
    ! [VarCurr: state_type] :
      ( v76033(VarCurr)
    <=> v76035(VarCurr) ) ).

tff(addAssignment_47553,axiom,
    ! [VarCurr: state_type] :
      ( v76035(VarCurr)
    <=> v67349(VarCurr,67) ) ).

tff(addAssignment_47552,axiom,
    ! [VarCurr: state_type] :
      ( v76029(VarCurr)
    <=> v76031(VarCurr) ) ).

tff(addAssignment_47551,axiom,
    ! [VarCurr: state_type] :
      ( v76031(VarCurr)
    <=> v67349(VarCurr,64) ) ).

tff(addAssignment_47550,axiom,
    ! [VarCurr: state_type] :
      ( v75995(VarCurr)
    <=> v75997(VarCurr) ) ).

tff(addAssignment_47549,axiom,
    ! [VarCurr: state_type] :
      ( v75997(VarCurr)
    <=> v75999(VarCurr) ) ).

tff(addAssignment_47548,axiom,
    ! [VarCurr: state_type] :
      ( v75999(VarCurr)
    <=> v76001(VarCurr) ) ).

tff(addAssignment_47547,axiom,
    ! [VarCurr: state_type] :
      ( v76001(VarCurr)
    <=> v76003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7112,axiom,
    ! [VarCurr: state_type] :
      ( v76003(VarCurr)
    <=> ( v76017(VarCurr)
      <~> v76013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7111,axiom,
    ! [VarCurr: state_type] :
      ( v76017(VarCurr)
    <=> ( v76005(VarCurr)
      <~> v76009(VarCurr) ) ) ).

tff(addAssignment_47546,axiom,
    ! [VarCurr: state_type] :
      ( v76013(VarCurr)
    <=> v76015(VarCurr) ) ).

tff(addAssignment_47545,axiom,
    ! [VarCurr: state_type] :
      ( v76015(VarCurr)
    <=> v67349(VarCurr,61) ) ).

tff(addAssignment_47544,axiom,
    ! [VarCurr: state_type] :
      ( v76009(VarCurr)
    <=> v76011(VarCurr) ) ).

tff(addAssignment_47543,axiom,
    ! [VarCurr: state_type] :
      ( v76011(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_47542,axiom,
    ! [VarCurr: state_type] :
      ( v76005(VarCurr)
    <=> v76007(VarCurr) ) ).

tff(addAssignment_47541,axiom,
    ! [VarCurr: state_type] :
      ( v76007(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_47540,axiom,
    ! [VarCurr: state_type] :
      ( v75971(VarCurr)
    <=> v75973(VarCurr) ) ).

tff(addAssignment_47539,axiom,
    ! [VarCurr: state_type] :
      ( v75973(VarCurr)
    <=> v75975(VarCurr) ) ).

tff(addAssignment_47538,axiom,
    ! [VarCurr: state_type] :
      ( v75975(VarCurr)
    <=> v75977(VarCurr) ) ).

tff(addAssignment_47537,axiom,
    ! [VarCurr: state_type] :
      ( v75977(VarCurr)
    <=> v75979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7110,axiom,
    ! [VarCurr: state_type] :
      ( v75979(VarCurr)
    <=> ( v75993(VarCurr)
      <~> v75989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7109,axiom,
    ! [VarCurr: state_type] :
      ( v75993(VarCurr)
    <=> ( v75981(VarCurr)
      <~> v75985(VarCurr) ) ) ).

tff(addAssignment_47536,axiom,
    ! [VarCurr: state_type] :
      ( v75989(VarCurr)
    <=> v75991(VarCurr) ) ).

tff(addAssignment_47535,axiom,
    ! [VarCurr: state_type] :
      ( v75991(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_47534,axiom,
    ! [VarCurr: state_type] :
      ( v75985(VarCurr)
    <=> v75987(VarCurr) ) ).

tff(addAssignment_47533,axiom,
    ! [VarCurr: state_type] :
      ( v75987(VarCurr)
    <=> v67349(VarCurr,51) ) ).

tff(addAssignment_47532,axiom,
    ! [VarCurr: state_type] :
      ( v75981(VarCurr)
    <=> v75983(VarCurr) ) ).

tff(addAssignment_47531,axiom,
    ! [VarCurr: state_type] :
      ( v75983(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_47530,axiom,
    ! [VarCurr: state_type] :
      ( v75687(VarCurr)
    <=> v75689(VarCurr) ) ).

tff(addAssignment_47529,axiom,
    ! [VarCurr: state_type] :
      ( v75689(VarCurr)
    <=> v75691(VarCurr) ) ).

tff(addAssignment_47528,axiom,
    ! [VarCurr: state_type] :
      ( v75691(VarCurr)
    <=> v75693(VarCurr) ) ).

tff(addAssignment_47527,axiom,
    ! [VarCurr: state_type] :
      ( v75693(VarCurr)
    <=> v75695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7108,axiom,
    ! [VarCurr: state_type] :
      ( v75695(VarCurr)
    <=> ( v75949(VarCurr)
      <~> v75865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7107,axiom,
    ! [VarCurr: state_type] :
      ( v75949(VarCurr)
    <=> ( v75697(VarCurr)
      <~> v75781(VarCurr) ) ) ).

tff(addAssignment_47526,axiom,
    ! [VarCurr: state_type] :
      ( v75865(VarCurr)
    <=> v75867(VarCurr) ) ).

tff(addAssignment_47525,axiom,
    ! [VarCurr: state_type] :
      ( v75867(VarCurr)
    <=> v75869(VarCurr) ) ).

tff(addAssignment_47524,axiom,
    ! [VarCurr: state_type] :
      ( v75869(VarCurr)
    <=> v75871(VarCurr) ) ).

tff(addAssignment_47523,axiom,
    ! [VarCurr: state_type] :
      ( v75871(VarCurr)
    <=> v75873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7106,axiom,
    ! [VarCurr: state_type] :
      ( v75873(VarCurr)
    <=> ( v75947(VarCurr)
      <~> v75923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7105,axiom,
    ! [VarCurr: state_type] :
      ( v75947(VarCurr)
    <=> ( v75875(VarCurr)
      <~> v75899(VarCurr) ) ) ).

tff(addAssignment_47522,axiom,
    ! [VarCurr: state_type] :
      ( v75923(VarCurr)
    <=> v75925(VarCurr) ) ).

tff(addAssignment_47521,axiom,
    ! [VarCurr: state_type] :
      ( v75925(VarCurr)
    <=> v75927(VarCurr) ) ).

tff(addAssignment_47520,axiom,
    ! [VarCurr: state_type] :
      ( v75927(VarCurr)
    <=> v75929(VarCurr) ) ).

tff(addAssignment_47519,axiom,
    ! [VarCurr: state_type] :
      ( v75929(VarCurr)
    <=> v75931(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7104,axiom,
    ! [VarCurr: state_type] :
      ( v75931(VarCurr)
    <=> ( v75945(VarCurr)
      <~> v75941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7103,axiom,
    ! [VarCurr: state_type] :
      ( v75945(VarCurr)
    <=> ( v75933(VarCurr)
      <~> v75937(VarCurr) ) ) ).

tff(addAssignment_47518,axiom,
    ! [VarCurr: state_type] :
      ( v75941(VarCurr)
    <=> v75943(VarCurr) ) ).

tff(addAssignment_47517,axiom,
    ! [VarCurr: state_type] :
      ( v75943(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_47516,axiom,
    ! [VarCurr: state_type] :
      ( v75937(VarCurr)
    <=> v75939(VarCurr) ) ).

tff(addAssignment_47515,axiom,
    ! [VarCurr: state_type] :
      ( v75939(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_47514,axiom,
    ! [VarCurr: state_type] :
      ( v75933(VarCurr)
    <=> v75935(VarCurr) ) ).

tff(addAssignment_47513,axiom,
    ! [VarCurr: state_type] :
      ( v75935(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_47512,axiom,
    ! [VarCurr: state_type] :
      ( v75899(VarCurr)
    <=> v75901(VarCurr) ) ).

tff(addAssignment_47511,axiom,
    ! [VarCurr: state_type] :
      ( v75901(VarCurr)
    <=> v75903(VarCurr) ) ).

tff(addAssignment_47510,axiom,
    ! [VarCurr: state_type] :
      ( v75903(VarCurr)
    <=> v75905(VarCurr) ) ).

tff(addAssignment_47509,axiom,
    ! [VarCurr: state_type] :
      ( v75905(VarCurr)
    <=> v75907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7102,axiom,
    ! [VarCurr: state_type] :
      ( v75907(VarCurr)
    <=> ( v75921(VarCurr)
      <~> v75917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7101,axiom,
    ! [VarCurr: state_type] :
      ( v75921(VarCurr)
    <=> ( v75909(VarCurr)
      <~> v75913(VarCurr) ) ) ).

tff(addAssignment_47508,axiom,
    ! [VarCurr: state_type] :
      ( v75917(VarCurr)
    <=> v75919(VarCurr) ) ).

tff(addAssignment_47507,axiom,
    ! [VarCurr: state_type] :
      ( v75919(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_47506,axiom,
    ! [VarCurr: state_type] :
      ( v75913(VarCurr)
    <=> v75915(VarCurr) ) ).

tff(addAssignment_47505,axiom,
    ! [VarCurr: state_type] :
      ( v75915(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_47504,axiom,
    ! [VarCurr: state_type] :
      ( v75909(VarCurr)
    <=> v75911(VarCurr) ) ).

tff(addAssignment_47503,axiom,
    ! [VarCurr: state_type] :
      ( v75911(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_47502,axiom,
    ! [VarCurr: state_type] :
      ( v75875(VarCurr)
    <=> v75877(VarCurr) ) ).

tff(addAssignment_47501,axiom,
    ! [VarCurr: state_type] :
      ( v75877(VarCurr)
    <=> v75879(VarCurr) ) ).

tff(addAssignment_47500,axiom,
    ! [VarCurr: state_type] :
      ( v75879(VarCurr)
    <=> v75881(VarCurr) ) ).

tff(addAssignment_47499,axiom,
    ! [VarCurr: state_type] :
      ( v75881(VarCurr)
    <=> v75883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7100,axiom,
    ! [VarCurr: state_type] :
      ( v75883(VarCurr)
    <=> ( v75897(VarCurr)
      <~> v75893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7099,axiom,
    ! [VarCurr: state_type] :
      ( v75897(VarCurr)
    <=> ( v75885(VarCurr)
      <~> v75889(VarCurr) ) ) ).

tff(addAssignment_47498,axiom,
    ! [VarCurr: state_type] :
      ( v75893(VarCurr)
    <=> v75895(VarCurr) ) ).

tff(addAssignment_47497,axiom,
    ! [VarCurr: state_type] :
      ( v75895(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_47496,axiom,
    ! [VarCurr: state_type] :
      ( v75889(VarCurr)
    <=> v75891(VarCurr) ) ).

tff(addAssignment_47495,axiom,
    ! [VarCurr: state_type] :
      ( v75891(VarCurr)
    <=> v67349(VarCurr,36) ) ).

tff(addAssignment_47494,axiom,
    ! [VarCurr: state_type] :
      ( v75885(VarCurr)
    <=> v75887(VarCurr) ) ).

tff(addAssignment_47493,axiom,
    ! [VarCurr: state_type] :
      ( v75887(VarCurr)
    <=> v67349(VarCurr,34) ) ).

tff(addAssignment_47492,axiom,
    ! [VarCurr: state_type] :
      ( v75781(VarCurr)
    <=> v75783(VarCurr) ) ).

tff(addAssignment_47491,axiom,
    ! [VarCurr: state_type] :
      ( v75783(VarCurr)
    <=> v75785(VarCurr) ) ).

tff(addAssignment_47490,axiom,
    ! [VarCurr: state_type] :
      ( v75785(VarCurr)
    <=> v75787(VarCurr) ) ).

tff(addAssignment_47489,axiom,
    ! [VarCurr: state_type] :
      ( v75787(VarCurr)
    <=> v75789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7098,axiom,
    ! [VarCurr: state_type] :
      ( v75789(VarCurr)
    <=> ( v75863(VarCurr)
      <~> v75839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7097,axiom,
    ! [VarCurr: state_type] :
      ( v75863(VarCurr)
    <=> ( v75791(VarCurr)
      <~> v75815(VarCurr) ) ) ).

tff(addAssignment_47488,axiom,
    ! [VarCurr: state_type] :
      ( v75839(VarCurr)
    <=> v75841(VarCurr) ) ).

tff(addAssignment_47487,axiom,
    ! [VarCurr: state_type] :
      ( v75841(VarCurr)
    <=> v75843(VarCurr) ) ).

tff(addAssignment_47486,axiom,
    ! [VarCurr: state_type] :
      ( v75843(VarCurr)
    <=> v75845(VarCurr) ) ).

tff(addAssignment_47485,axiom,
    ! [VarCurr: state_type] :
      ( v75845(VarCurr)
    <=> v75847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7096,axiom,
    ! [VarCurr: state_type] :
      ( v75847(VarCurr)
    <=> ( v75861(VarCurr)
      <~> v75857(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7095,axiom,
    ! [VarCurr: state_type] :
      ( v75861(VarCurr)
    <=> ( v75849(VarCurr)
      <~> v75853(VarCurr) ) ) ).

tff(addAssignment_47484,axiom,
    ! [VarCurr: state_type] :
      ( v75857(VarCurr)
    <=> v75859(VarCurr) ) ).

tff(addAssignment_47483,axiom,
    ! [VarCurr: state_type] :
      ( v75859(VarCurr)
    <=> v67349(VarCurr,30) ) ).

tff(addAssignment_47482,axiom,
    ! [VarCurr: state_type] :
      ( v75853(VarCurr)
    <=> v75855(VarCurr) ) ).

tff(addAssignment_47481,axiom,
    ! [VarCurr: state_type] :
      ( v75855(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_47480,axiom,
    ! [VarCurr: state_type] :
      ( v75849(VarCurr)
    <=> v75851(VarCurr) ) ).

tff(addAssignment_47479,axiom,
    ! [VarCurr: state_type] :
      ( v75851(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_47478,axiom,
    ! [VarCurr: state_type] :
      ( v75815(VarCurr)
    <=> v75817(VarCurr) ) ).

tff(addAssignment_47477,axiom,
    ! [VarCurr: state_type] :
      ( v75817(VarCurr)
    <=> v75819(VarCurr) ) ).

tff(addAssignment_47476,axiom,
    ! [VarCurr: state_type] :
      ( v75819(VarCurr)
    <=> v75821(VarCurr) ) ).

tff(addAssignment_47475,axiom,
    ! [VarCurr: state_type] :
      ( v75821(VarCurr)
    <=> v75823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7094,axiom,
    ! [VarCurr: state_type] :
      ( v75823(VarCurr)
    <=> ( v75837(VarCurr)
      <~> v75833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7093,axiom,
    ! [VarCurr: state_type] :
      ( v75837(VarCurr)
    <=> ( v75825(VarCurr)
      <~> v75829(VarCurr) ) ) ).

tff(addAssignment_47474,axiom,
    ! [VarCurr: state_type] :
      ( v75833(VarCurr)
    <=> v75835(VarCurr) ) ).

tff(addAssignment_47473,axiom,
    ! [VarCurr: state_type] :
      ( v75835(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_47472,axiom,
    ! [VarCurr: state_type] :
      ( v75829(VarCurr)
    <=> v75831(VarCurr) ) ).

tff(addAssignment_47471,axiom,
    ! [VarCurr: state_type] :
      ( v75831(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_47470,axiom,
    ! [VarCurr: state_type] :
      ( v75825(VarCurr)
    <=> v75827(VarCurr) ) ).

tff(addAssignment_47469,axiom,
    ! [VarCurr: state_type] :
      ( v75827(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_47468,axiom,
    ! [VarCurr: state_type] :
      ( v75791(VarCurr)
    <=> v75793(VarCurr) ) ).

tff(addAssignment_47467,axiom,
    ! [VarCurr: state_type] :
      ( v75793(VarCurr)
    <=> v75795(VarCurr) ) ).

tff(addAssignment_47466,axiom,
    ! [VarCurr: state_type] :
      ( v75795(VarCurr)
    <=> v75797(VarCurr) ) ).

tff(addAssignment_47465,axiom,
    ! [VarCurr: state_type] :
      ( v75797(VarCurr)
    <=> v75799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7092,axiom,
    ! [VarCurr: state_type] :
      ( v75799(VarCurr)
    <=> ( v75813(VarCurr)
      <~> v75809(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7091,axiom,
    ! [VarCurr: state_type] :
      ( v75813(VarCurr)
    <=> ( v75801(VarCurr)
      <~> v75805(VarCurr) ) ) ).

tff(addAssignment_47464,axiom,
    ! [VarCurr: state_type] :
      ( v75809(VarCurr)
    <=> v75811(VarCurr) ) ).

tff(addAssignment_47463,axiom,
    ! [VarCurr: state_type] :
      ( v75811(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_47462,axiom,
    ! [VarCurr: state_type] :
      ( v75805(VarCurr)
    <=> v75807(VarCurr) ) ).

tff(addAssignment_47461,axiom,
    ! [VarCurr: state_type] :
      ( v75807(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_47460,axiom,
    ! [VarCurr: state_type] :
      ( v75801(VarCurr)
    <=> v75803(VarCurr) ) ).

tff(addAssignment_47459,axiom,
    ! [VarCurr: state_type] :
      ( v75803(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_47458,axiom,
    ! [VarCurr: state_type] :
      ( v75697(VarCurr)
    <=> v75699(VarCurr) ) ).

tff(addAssignment_47457,axiom,
    ! [VarCurr: state_type] :
      ( v75699(VarCurr)
    <=> v75701(VarCurr) ) ).

tff(addAssignment_47456,axiom,
    ! [VarCurr: state_type] :
      ( v75701(VarCurr)
    <=> v75703(VarCurr) ) ).

tff(addAssignment_47455,axiom,
    ! [VarCurr: state_type] :
      ( v75703(VarCurr)
    <=> v75705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7090,axiom,
    ! [VarCurr: state_type] :
      ( v75705(VarCurr)
    <=> ( v75779(VarCurr)
      <~> v75755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7089,axiom,
    ! [VarCurr: state_type] :
      ( v75779(VarCurr)
    <=> ( v75707(VarCurr)
      <~> v75731(VarCurr) ) ) ).

tff(addAssignment_47454,axiom,
    ! [VarCurr: state_type] :
      ( v75755(VarCurr)
    <=> v75757(VarCurr) ) ).

tff(addAssignment_47453,axiom,
    ! [VarCurr: state_type] :
      ( v75757(VarCurr)
    <=> v75759(VarCurr) ) ).

tff(addAssignment_47452,axiom,
    ! [VarCurr: state_type] :
      ( v75759(VarCurr)
    <=> v75761(VarCurr) ) ).

tff(addAssignment_47451,axiom,
    ! [VarCurr: state_type] :
      ( v75761(VarCurr)
    <=> v75763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7088,axiom,
    ! [VarCurr: state_type] :
      ( v75763(VarCurr)
    <=> ( v75777(VarCurr)
      <~> v75773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7087,axiom,
    ! [VarCurr: state_type] :
      ( v75777(VarCurr)
    <=> ( v75765(VarCurr)
      <~> v75769(VarCurr) ) ) ).

tff(addAssignment_47450,axiom,
    ! [VarCurr: state_type] :
      ( v75773(VarCurr)
    <=> v75775(VarCurr) ) ).

tff(addAssignment_47449,axiom,
    ! [VarCurr: state_type] :
      ( v75775(VarCurr)
    <=> v67349(VarCurr,17) ) ).

tff(addAssignment_47448,axiom,
    ! [VarCurr: state_type] :
      ( v75769(VarCurr)
    <=> v75771(VarCurr) ) ).

tff(addAssignment_47447,axiom,
    ! [VarCurr: state_type] :
      ( v75771(VarCurr)
    <=> v67349(VarCurr,15) ) ).

tff(addAssignment_47446,axiom,
    ! [VarCurr: state_type] :
      ( v75765(VarCurr)
    <=> v75767(VarCurr) ) ).

tff(addAssignment_47445,axiom,
    ! [VarCurr: state_type] :
      ( v75767(VarCurr)
    <=> v67349(VarCurr,14) ) ).

tff(addAssignment_47444,axiom,
    ! [VarCurr: state_type] :
      ( v75731(VarCurr)
    <=> v75733(VarCurr) ) ).

tff(addAssignment_47443,axiom,
    ! [VarCurr: state_type] :
      ( v75733(VarCurr)
    <=> v75735(VarCurr) ) ).

tff(addAssignment_47442,axiom,
    ! [VarCurr: state_type] :
      ( v75735(VarCurr)
    <=> v75737(VarCurr) ) ).

tff(addAssignment_47441,axiom,
    ! [VarCurr: state_type] :
      ( v75737(VarCurr)
    <=> v75739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7086,axiom,
    ! [VarCurr: state_type] :
      ( v75739(VarCurr)
    <=> ( v75753(VarCurr)
      <~> v75749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7085,axiom,
    ! [VarCurr: state_type] :
      ( v75753(VarCurr)
    <=> ( v75741(VarCurr)
      <~> v75745(VarCurr) ) ) ).

tff(addAssignment_47440,axiom,
    ! [VarCurr: state_type] :
      ( v75749(VarCurr)
    <=> v75751(VarCurr) ) ).

tff(addAssignment_47439,axiom,
    ! [VarCurr: state_type] :
      ( v75751(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_47438,axiom,
    ! [VarCurr: state_type] :
      ( v75745(VarCurr)
    <=> v75747(VarCurr) ) ).

tff(addAssignment_47437,axiom,
    ! [VarCurr: state_type] :
      ( v75747(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_47436,axiom,
    ! [VarCurr: state_type] :
      ( v75741(VarCurr)
    <=> v75743(VarCurr) ) ).

tff(addAssignment_47435,axiom,
    ! [VarCurr: state_type] :
      ( v75743(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_47434,axiom,
    ! [VarCurr: state_type] :
      ( v75707(VarCurr)
    <=> v75709(VarCurr) ) ).

tff(addAssignment_47433,axiom,
    ! [VarCurr: state_type] :
      ( v75709(VarCurr)
    <=> v75711(VarCurr) ) ).

tff(addAssignment_47432,axiom,
    ! [VarCurr: state_type] :
      ( v75711(VarCurr)
    <=> v75713(VarCurr) ) ).

tff(addAssignment_47431,axiom,
    ! [VarCurr: state_type] :
      ( v75713(VarCurr)
    <=> v75715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7084,axiom,
    ! [VarCurr: state_type] :
      ( v75715(VarCurr)
    <=> ( v75729(VarCurr)
      <~> v75725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7083,axiom,
    ! [VarCurr: state_type] :
      ( v75729(VarCurr)
    <=> ( v75717(VarCurr)
      <~> v75721(VarCurr) ) ) ).

tff(addAssignment_47430,axiom,
    ! [VarCurr: state_type] :
      ( v75725(VarCurr)
    <=> v75727(VarCurr) ) ).

tff(addAssignment_47429,axiom,
    ! [VarCurr: state_type] :
      ( v75727(VarCurr)
    <=> v67349(VarCurr,7) ) ).

tff(addAssignment_47428,axiom,
    ! [VarCurr: state_type] :
      ( v75721(VarCurr)
    <=> v75723(VarCurr) ) ).

tff(addAssignment_47427,axiom,
    ! [VarCurr: state_type] :
      ( v75723(VarCurr)
    <=> v67349(VarCurr,4) ) ).

tff(addAssignment_47426,axiom,
    ! [VarCurr: state_type] :
      ( v75717(VarCurr)
    <=> v75719(VarCurr) ) ).

tff(addAssignment_47425,axiom,
    ! [VarCurr: state_type] :
      ( v75719(VarCurr)
    <=> v67349(VarCurr,1) ) ).

tff(addAssignment_47424,axiom,
    ! [VarCurr: state_type] :
      ( v67253(VarCurr,1)
    <=> v67255(VarCurr,1) ) ).

tff(addAssignment_47423,axiom,
    ! [VarCurr: state_type] :
      ( v67255(VarCurr,1)
    <=> v74273(VarCurr,1) ) ).

tff(addAssignment_47422,axiom,
    ! [VarCurr: state_type] :
      ( v67233(VarCurr)
    <=> v67235(VarCurr) ) ).

tff(addAssignment_47421,axiom,
    ! [VarCurr: state_type] :
      ( v67235(VarCurr)
    <=> v67237(VarCurr) ) ).

tff(addAssignment_47420,axiom,
    ! [VarCurr: state_type] :
      ( v67237(VarCurr)
    <=> v67239(VarCurr) ) ).

tff(addAssignment_47419,axiom,
    ! [VarCurr: state_type] :
      ( v67239(VarCurr)
    <=> v67241(VarCurr) ) ).

tff(writeUnaryOperator_3450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67241(VarCurr)
    <=> v75667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7082,axiom,
    ! [VarCurr: state_type] :
      ( v75667(VarCurr)
    <=> ( v67243(VarCurr)
        | v74997(VarCurr) ) ) ).

tff(addAssignment_47418,axiom,
    ! [VarCurr: state_type] :
      ( v74997(VarCurr)
    <=> v74999(VarCurr) ) ).

tff(addAssignment_47417,axiom,
    ! [VarCurr: state_type] :
      ( v74999(VarCurr)
    <=> v67247(VarCurr,2) ) ).

tff(addAssignment_47416,axiom,
    ! [VarCurr: state_type] :
      ( v67247(VarCurr,2)
    <=> v67249(VarCurr,2) ) ).

tff(addAssignment_47415,axiom,
    ! [VarCurr: state_type] :
      ( v67249(VarCurr,2)
    <=> v67251(VarCurr,2) ) ).

tff(addAssignment_47414,axiom,
    ! [VarCurr: state_type] :
      ( v67251(VarCurr,2)
    <=> v74995(VarCurr,2) ) ).

tff(addAssignment_47413,axiom,
    ! [VarCurr: state_type] :
      ( v74276(VarCurr,2)
    <=> v74278(VarCurr,2) ) ).

tff(addAssignment_47412,axiom,
    ! [VarCurr: state_type] :
      ( v74278(VarCurr,2)
    <=> v74280(VarCurr,2) ) ).

tff(addAssignment_47411,axiom,
    ! [VarCurr: state_type] :
      ( v74280(VarCurr,2)
    <=> v67309(VarCurr,14) ) ).

tff(addAssignment_47410,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,14)
    <=> v67311(VarCurr,14) ) ).

tff(addAssignment_47409,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,14)
    <=> v67313(VarCurr,14) ) ).

tff(addAssignment_47408,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,14)
    <=> v67315(VarCurr,14) ) ).

tff(addAssignment_47407,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,14)
    <=> v67317(VarCurr,14) ) ).

tff(addAssignment_47406,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,14)
    <=> v68771(VarCurr,14) ) ).

tff(addAssignment_47405,axiom,
    ! [VarCurr: state_type] :
      ( v68772(VarCurr,2)
    <=> v75001(VarCurr) ) ).

tff(addAssignment_47404,axiom,
    ! [VarCurr: state_type] :
      ( v75001(VarCurr)
    <=> v75003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7081,axiom,
    ! [VarCurr: state_type] :
      ( v75003(VarCurr)
    <=> ( v75665(VarCurr)
      <~> v75533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7080,axiom,
    ! [VarCurr: state_type] :
      ( v75665(VarCurr)
    <=> ( v75005(VarCurr)
      <~> v75269(VarCurr) ) ) ).

tff(addAssignment_47403,axiom,
    ! [VarCurr: state_type] :
      ( v75533(VarCurr)
    <=> v75535(VarCurr) ) ).

tff(addAssignment_47402,axiom,
    ! [VarCurr: state_type] :
      ( v75535(VarCurr)
    <=> v75537(VarCurr) ) ).

tff(addAssignment_47401,axiom,
    ! [VarCurr: state_type] :
      ( v75537(VarCurr)
    <=> v75539(VarCurr) ) ).

tff(addAssignment_47400,axiom,
    ! [VarCurr: state_type] :
      ( v75539(VarCurr)
    <=> v75541(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7079,axiom,
    ! [VarCurr: state_type] :
      ( v75541(VarCurr)
    <=> ( v75663(VarCurr)
      <~> v75651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7078,axiom,
    ! [VarCurr: state_type] :
      ( v75663(VarCurr)
    <=> ( v75543(VarCurr)
      <~> v75567(VarCurr) ) ) ).

tff(addAssignment_47399,axiom,
    ! [VarCurr: state_type] :
      ( v75651(VarCurr)
    <=> v75653(VarCurr) ) ).

tff(addAssignment_47398,axiom,
    ! [VarCurr: state_type] :
      ( v75653(VarCurr)
    <=> v74937(VarCurr,2) ) ).

tff(addAssignment_47397,axiom,
    ! [VarCurr: state_type] :
      ( v74937(VarCurr,2)
    <=> v74939(VarCurr,2) ) ).

tff(addAssignment_47396,axiom,
    ! [VarCurr: state_type] :
      ( v74939(VarCurr,2)
    <=> v68676(VarCurr,6) ) ).

tff(addAssignment_47395,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,6)
    <=> v68678(VarCurr,6) ) ).

tff(addAssignment_47394,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,6)
    <=> v75655(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v75656(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v75655(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_907,axiom,
    ! [VarNext: state_type] :
      ( v75656(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v75655(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v75656(VarNext)
      <=> v75657(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v75657(VarNext)
      <=> ( v75659(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v75659(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_47393,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,6)
    <=> v68702(VarCurr,6) ) ).

tff(addAssignment_47392,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,6)
    <=> v68731(VarCurr,6) ) ).

tff(addAssignment_47391,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,14)
    <=> v74950(VarCurr,2) ) ).

tff(addAssignment_47390,axiom,
    ! [VarCurr: state_type] :
      ( v74950(VarCurr,2)
    <=> v74952(VarCurr,2) ) ).

tff(addAssignment_47389,axiom,
    ! [VarCurr: state_type] :
      ( v74952(VarCurr,2)
    <=> v74969(VarCurr,2) ) ).

tff(addAssignment_47388,axiom,
    ! [VarCurr: state_type] :
      ( v74962(VarCurr,2)
    <=> v74964(VarCurr,2) ) ).

tff(addAssignment_47387,axiom,
    ! [VarCurr: state_type] :
      ( v74964(VarCurr,2)
    <=> v68455(VarCurr,14) ) ).

tff(addAssignment_47386,axiom,
    ! [VarCurr: state_type] :
      ( v74954(VarCurr,2)
    <=> v74956(VarCurr,2) ) ).

tff(addAssignment_47385,axiom,
    ! [VarCurr: state_type] :
      ( v74956(VarCurr,2)
    <=> v68455(VarCurr,10) ) ).

tff(addAssignment_47384,axiom,
    ! [VarCurr: state_type] :
      ( v75567(VarCurr)
    <=> v75569(VarCurr) ) ).

tff(addAssignment_47383,axiom,
    ! [VarCurr: state_type] :
      ( v75569(VarCurr)
    <=> v75571(VarCurr) ) ).

tff(addAssignment_47382,axiom,
    ! [VarCurr: state_type] :
      ( v75571(VarCurr)
    <=> v75573(VarCurr) ) ).

tff(addAssignment_47381,axiom,
    ! [VarCurr: state_type] :
      ( v75573(VarCurr)
    <=> v75575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7075,axiom,
    ! [VarCurr: state_type] :
      ( v75575(VarCurr)
    <=> ( v75649(VarCurr)
      <~> v75625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7074,axiom,
    ! [VarCurr: state_type] :
      ( v75649(VarCurr)
    <=> ( v75577(VarCurr)
      <~> v75601(VarCurr) ) ) ).

tff(addAssignment_47380,axiom,
    ! [VarCurr: state_type] :
      ( v75625(VarCurr)
    <=> v75627(VarCurr) ) ).

tff(addAssignment_47379,axiom,
    ! [VarCurr: state_type] :
      ( v75627(VarCurr)
    <=> v75629(VarCurr) ) ).

tff(addAssignment_47378,axiom,
    ! [VarCurr: state_type] :
      ( v75629(VarCurr)
    <=> v75631(VarCurr) ) ).

tff(addAssignment_47377,axiom,
    ! [VarCurr: state_type] :
      ( v75631(VarCurr)
    <=> v75633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7073,axiom,
    ! [VarCurr: state_type] :
      ( v75633(VarCurr)
    <=> ( v75647(VarCurr)
      <~> v75643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7072,axiom,
    ! [VarCurr: state_type] :
      ( v75647(VarCurr)
    <=> ( v75635(VarCurr)
      <~> v75639(VarCurr) ) ) ).

tff(addAssignment_47376,axiom,
    ! [VarCurr: state_type] :
      ( v75643(VarCurr)
    <=> v75645(VarCurr) ) ).

tff(addAssignment_47375,axiom,
    ! [VarCurr: state_type] :
      ( v75645(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_47374,axiom,
    ! [VarCurr: state_type] :
      ( v75639(VarCurr)
    <=> v75641(VarCurr) ) ).

tff(addAssignment_47373,axiom,
    ! [VarCurr: state_type] :
      ( v75641(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_47372,axiom,
    ! [VarCurr: state_type] :
      ( v75635(VarCurr)
    <=> v75637(VarCurr) ) ).

tff(addAssignment_47371,axiom,
    ! [VarCurr: state_type] :
      ( v75637(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_47370,axiom,
    ! [VarCurr: state_type] :
      ( v75601(VarCurr)
    <=> v75603(VarCurr) ) ).

tff(addAssignment_47369,axiom,
    ! [VarCurr: state_type] :
      ( v75603(VarCurr)
    <=> v75605(VarCurr) ) ).

tff(addAssignment_47368,axiom,
    ! [VarCurr: state_type] :
      ( v75605(VarCurr)
    <=> v75607(VarCurr) ) ).

tff(addAssignment_47367,axiom,
    ! [VarCurr: state_type] :
      ( v75607(VarCurr)
    <=> v75609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7071,axiom,
    ! [VarCurr: state_type] :
      ( v75609(VarCurr)
    <=> ( v75623(VarCurr)
      <~> v75619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7070,axiom,
    ! [VarCurr: state_type] :
      ( v75623(VarCurr)
    <=> ( v75611(VarCurr)
      <~> v75615(VarCurr) ) ) ).

tff(addAssignment_47366,axiom,
    ! [VarCurr: state_type] :
      ( v75619(VarCurr)
    <=> v75621(VarCurr) ) ).

tff(addAssignment_47365,axiom,
    ! [VarCurr: state_type] :
      ( v75621(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_47364,axiom,
    ! [VarCurr: state_type] :
      ( v75615(VarCurr)
    <=> v75617(VarCurr) ) ).

tff(addAssignment_47363,axiom,
    ! [VarCurr: state_type] :
      ( v75617(VarCurr)
    <=> v67349(VarCurr,108) ) ).

tff(addAssignment_47362,axiom,
    ! [VarCurr: state_type] :
      ( v75611(VarCurr)
    <=> v75613(VarCurr) ) ).

tff(addAssignment_47361,axiom,
    ! [VarCurr: state_type] :
      ( v75613(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_47360,axiom,
    ! [VarCurr: state_type] :
      ( v75577(VarCurr)
    <=> v75579(VarCurr) ) ).

tff(addAssignment_47359,axiom,
    ! [VarCurr: state_type] :
      ( v75579(VarCurr)
    <=> v75581(VarCurr) ) ).

tff(addAssignment_47358,axiom,
    ! [VarCurr: state_type] :
      ( v75581(VarCurr)
    <=> v75583(VarCurr) ) ).

tff(addAssignment_47357,axiom,
    ! [VarCurr: state_type] :
      ( v75583(VarCurr)
    <=> v75585(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7069,axiom,
    ! [VarCurr: state_type] :
      ( v75585(VarCurr)
    <=> ( v75599(VarCurr)
      <~> v75595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7068,axiom,
    ! [VarCurr: state_type] :
      ( v75599(VarCurr)
    <=> ( v75587(VarCurr)
      <~> v75591(VarCurr) ) ) ).

tff(addAssignment_47356,axiom,
    ! [VarCurr: state_type] :
      ( v75595(VarCurr)
    <=> v75597(VarCurr) ) ).

tff(addAssignment_47355,axiom,
    ! [VarCurr: state_type] :
      ( v75597(VarCurr)
    <=> v67349(VarCurr,104) ) ).

tff(addAssignment_47354,axiom,
    ! [VarCurr: state_type] :
      ( v75591(VarCurr)
    <=> v75593(VarCurr) ) ).

tff(addAssignment_47353,axiom,
    ! [VarCurr: state_type] :
      ( v75593(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_47352,axiom,
    ! [VarCurr: state_type] :
      ( v75587(VarCurr)
    <=> v75589(VarCurr) ) ).

tff(addAssignment_47351,axiom,
    ! [VarCurr: state_type] :
      ( v75589(VarCurr)
    <=> v67349(VarCurr,101) ) ).

tff(addAssignment_47350,axiom,
    ! [VarCurr: state_type] :
      ( v75543(VarCurr)
    <=> v75545(VarCurr) ) ).

tff(addAssignment_47349,axiom,
    ! [VarCurr: state_type] :
      ( v75545(VarCurr)
    <=> v75547(VarCurr) ) ).

tff(addAssignment_47348,axiom,
    ! [VarCurr: state_type] :
      ( v75547(VarCurr)
    <=> v75549(VarCurr) ) ).

tff(addAssignment_47347,axiom,
    ! [VarCurr: state_type] :
      ( v75549(VarCurr)
    <=> v75551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7067,axiom,
    ! [VarCurr: state_type] :
      ( v75551(VarCurr)
    <=> ( v75565(VarCurr)
      <~> v75561(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7066,axiom,
    ! [VarCurr: state_type] :
      ( v75565(VarCurr)
    <=> ( v75553(VarCurr)
      <~> v75557(VarCurr) ) ) ).

tff(addAssignment_47346,axiom,
    ! [VarCurr: state_type] :
      ( v75561(VarCurr)
    <=> v75563(VarCurr) ) ).

tff(addAssignment_47345,axiom,
    ! [VarCurr: state_type] :
      ( v75563(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_47344,axiom,
    ! [VarCurr: state_type] :
      ( v75557(VarCurr)
    <=> v75559(VarCurr) ) ).

tff(addAssignment_47343,axiom,
    ! [VarCurr: state_type] :
      ( v75559(VarCurr)
    <=> v67349(VarCurr,126) ) ).

tff(addAssignment_47342,axiom,
    ! [VarCurr: state_type] :
      ( v75553(VarCurr)
    <=> v75555(VarCurr) ) ).

tff(addAssignment_47341,axiom,
    ! [VarCurr: state_type] :
      ( v75555(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_47340,axiom,
    ! [VarCurr: state_type] :
      ( v75269(VarCurr)
    <=> v75271(VarCurr) ) ).

tff(addAssignment_47339,axiom,
    ! [VarCurr: state_type] :
      ( v75271(VarCurr)
    <=> v75273(VarCurr) ) ).

tff(addAssignment_47338,axiom,
    ! [VarCurr: state_type] :
      ( v75273(VarCurr)
    <=> v75275(VarCurr) ) ).

tff(addAssignment_47337,axiom,
    ! [VarCurr: state_type] :
      ( v75275(VarCurr)
    <=> v75277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7065,axiom,
    ! [VarCurr: state_type] :
      ( v75277(VarCurr)
    <=> ( v75531(VarCurr)
      <~> v75447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7064,axiom,
    ! [VarCurr: state_type] :
      ( v75531(VarCurr)
    <=> ( v75279(VarCurr)
      <~> v75363(VarCurr) ) ) ).

tff(addAssignment_47336,axiom,
    ! [VarCurr: state_type] :
      ( v75447(VarCurr)
    <=> v75449(VarCurr) ) ).

tff(addAssignment_47335,axiom,
    ! [VarCurr: state_type] :
      ( v75449(VarCurr)
    <=> v75451(VarCurr) ) ).

tff(addAssignment_47334,axiom,
    ! [VarCurr: state_type] :
      ( v75451(VarCurr)
    <=> v75453(VarCurr) ) ).

tff(addAssignment_47333,axiom,
    ! [VarCurr: state_type] :
      ( v75453(VarCurr)
    <=> v75455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7063,axiom,
    ! [VarCurr: state_type] :
      ( v75455(VarCurr)
    <=> ( v75529(VarCurr)
      <~> v75505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7062,axiom,
    ! [VarCurr: state_type] :
      ( v75529(VarCurr)
    <=> ( v75457(VarCurr)
      <~> v75481(VarCurr) ) ) ).

tff(addAssignment_47332,axiom,
    ! [VarCurr: state_type] :
      ( v75505(VarCurr)
    <=> v75507(VarCurr) ) ).

tff(addAssignment_47331,axiom,
    ! [VarCurr: state_type] :
      ( v75507(VarCurr)
    <=> v75509(VarCurr) ) ).

tff(addAssignment_47330,axiom,
    ! [VarCurr: state_type] :
      ( v75509(VarCurr)
    <=> v75511(VarCurr) ) ).

tff(addAssignment_47329,axiom,
    ! [VarCurr: state_type] :
      ( v75511(VarCurr)
    <=> v75513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7061,axiom,
    ! [VarCurr: state_type] :
      ( v75513(VarCurr)
    <=> ( v75527(VarCurr)
      <~> v75523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7060,axiom,
    ! [VarCurr: state_type] :
      ( v75527(VarCurr)
    <=> ( v75515(VarCurr)
      <~> v75519(VarCurr) ) ) ).

tff(addAssignment_47328,axiom,
    ! [VarCurr: state_type] :
      ( v75523(VarCurr)
    <=> v75525(VarCurr) ) ).

tff(addAssignment_47327,axiom,
    ! [VarCurr: state_type] :
      ( v75525(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_47326,axiom,
    ! [VarCurr: state_type] :
      ( v75519(VarCurr)
    <=> v75521(VarCurr) ) ).

tff(addAssignment_47325,axiom,
    ! [VarCurr: state_type] :
      ( v75521(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_47324,axiom,
    ! [VarCurr: state_type] :
      ( v75515(VarCurr)
    <=> v75517(VarCurr) ) ).

tff(addAssignment_47323,axiom,
    ! [VarCurr: state_type] :
      ( v75517(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_47322,axiom,
    ! [VarCurr: state_type] :
      ( v75481(VarCurr)
    <=> v75483(VarCurr) ) ).

tff(addAssignment_47321,axiom,
    ! [VarCurr: state_type] :
      ( v75483(VarCurr)
    <=> v75485(VarCurr) ) ).

tff(addAssignment_47320,axiom,
    ! [VarCurr: state_type] :
      ( v75485(VarCurr)
    <=> v75487(VarCurr) ) ).

tff(addAssignment_47319,axiom,
    ! [VarCurr: state_type] :
      ( v75487(VarCurr)
    <=> v75489(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7059,axiom,
    ! [VarCurr: state_type] :
      ( v75489(VarCurr)
    <=> ( v75503(VarCurr)
      <~> v75499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7058,axiom,
    ! [VarCurr: state_type] :
      ( v75503(VarCurr)
    <=> ( v75491(VarCurr)
      <~> v75495(VarCurr) ) ) ).

tff(addAssignment_47318,axiom,
    ! [VarCurr: state_type] :
      ( v75499(VarCurr)
    <=> v75501(VarCurr) ) ).

tff(addAssignment_47317,axiom,
    ! [VarCurr: state_type] :
      ( v75501(VarCurr)
    <=> v67349(VarCurr,95) ) ).

tff(addAssignment_47316,axiom,
    ! [VarCurr: state_type] :
      ( v75495(VarCurr)
    <=> v75497(VarCurr) ) ).

tff(addAssignment_47315,axiom,
    ! [VarCurr: state_type] :
      ( v75497(VarCurr)
    <=> v67349(VarCurr,90) ) ).

tff(addAssignment_47314,axiom,
    ! [VarCurr: state_type] :
      ( v75491(VarCurr)
    <=> v75493(VarCurr) ) ).

tff(addAssignment_47313,axiom,
    ! [VarCurr: state_type] :
      ( v75493(VarCurr)
    <=> v67349(VarCurr,91) ) ).

tff(addAssignment_47312,axiom,
    ! [VarCurr: state_type] :
      ( v75457(VarCurr)
    <=> v75459(VarCurr) ) ).

tff(addAssignment_47311,axiom,
    ! [VarCurr: state_type] :
      ( v75459(VarCurr)
    <=> v75461(VarCurr) ) ).

tff(addAssignment_47310,axiom,
    ! [VarCurr: state_type] :
      ( v75461(VarCurr)
    <=> v75463(VarCurr) ) ).

tff(addAssignment_47309,axiom,
    ! [VarCurr: state_type] :
      ( v75463(VarCurr)
    <=> v75465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7057,axiom,
    ! [VarCurr: state_type] :
      ( v75465(VarCurr)
    <=> ( v75479(VarCurr)
      <~> v75475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7056,axiom,
    ! [VarCurr: state_type] :
      ( v75479(VarCurr)
    <=> ( v75467(VarCurr)
      <~> v75471(VarCurr) ) ) ).

tff(addAssignment_47308,axiom,
    ! [VarCurr: state_type] :
      ( v75475(VarCurr)
    <=> v75477(VarCurr) ) ).

tff(addAssignment_47307,axiom,
    ! [VarCurr: state_type] :
      ( v75477(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_47306,axiom,
    ! [VarCurr: state_type] :
      ( v75471(VarCurr)
    <=> v75473(VarCurr) ) ).

tff(addAssignment_47305,axiom,
    ! [VarCurr: state_type] :
      ( v75473(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_47304,axiom,
    ! [VarCurr: state_type] :
      ( v75467(VarCurr)
    <=> v75469(VarCurr) ) ).

tff(addAssignment_47303,axiom,
    ! [VarCurr: state_type] :
      ( v75469(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_47302,axiom,
    ! [VarCurr: state_type] :
      ( v75363(VarCurr)
    <=> v75365(VarCurr) ) ).

tff(addAssignment_47301,axiom,
    ! [VarCurr: state_type] :
      ( v75365(VarCurr)
    <=> v75367(VarCurr) ) ).

tff(addAssignment_47300,axiom,
    ! [VarCurr: state_type] :
      ( v75367(VarCurr)
    <=> v75369(VarCurr) ) ).

tff(addAssignment_47299,axiom,
    ! [VarCurr: state_type] :
      ( v75369(VarCurr)
    <=> v75371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7055,axiom,
    ! [VarCurr: state_type] :
      ( v75371(VarCurr)
    <=> ( v75445(VarCurr)
      <~> v75421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7054,axiom,
    ! [VarCurr: state_type] :
      ( v75445(VarCurr)
    <=> ( v75373(VarCurr)
      <~> v75397(VarCurr) ) ) ).

tff(addAssignment_47298,axiom,
    ! [VarCurr: state_type] :
      ( v75421(VarCurr)
    <=> v75423(VarCurr) ) ).

tff(addAssignment_47297,axiom,
    ! [VarCurr: state_type] :
      ( v75423(VarCurr)
    <=> v75425(VarCurr) ) ).

tff(addAssignment_47296,axiom,
    ! [VarCurr: state_type] :
      ( v75425(VarCurr)
    <=> v75427(VarCurr) ) ).

tff(addAssignment_47295,axiom,
    ! [VarCurr: state_type] :
      ( v75427(VarCurr)
    <=> v75429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7053,axiom,
    ! [VarCurr: state_type] :
      ( v75429(VarCurr)
    <=> ( v75443(VarCurr)
      <~> v75439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7052,axiom,
    ! [VarCurr: state_type] :
      ( v75443(VarCurr)
    <=> ( v75431(VarCurr)
      <~> v75435(VarCurr) ) ) ).

tff(addAssignment_47294,axiom,
    ! [VarCurr: state_type] :
      ( v75439(VarCurr)
    <=> v75441(VarCurr) ) ).

tff(addAssignment_47293,axiom,
    ! [VarCurr: state_type] :
      ( v75441(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_47292,axiom,
    ! [VarCurr: state_type] :
      ( v75435(VarCurr)
    <=> v75437(VarCurr) ) ).

tff(addAssignment_47291,axiom,
    ! [VarCurr: state_type] :
      ( v75437(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_47290,axiom,
    ! [VarCurr: state_type] :
      ( v75431(VarCurr)
    <=> v75433(VarCurr) ) ).

tff(addAssignment_47289,axiom,
    ! [VarCurr: state_type] :
      ( v75433(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_47288,axiom,
    ! [VarCurr: state_type] :
      ( v75397(VarCurr)
    <=> v75399(VarCurr) ) ).

tff(addAssignment_47287,axiom,
    ! [VarCurr: state_type] :
      ( v75399(VarCurr)
    <=> v75401(VarCurr) ) ).

tff(addAssignment_47286,axiom,
    ! [VarCurr: state_type] :
      ( v75401(VarCurr)
    <=> v75403(VarCurr) ) ).

tff(addAssignment_47285,axiom,
    ! [VarCurr: state_type] :
      ( v75403(VarCurr)
    <=> v75405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7051,axiom,
    ! [VarCurr: state_type] :
      ( v75405(VarCurr)
    <=> ( v75419(VarCurr)
      <~> v75415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7050,axiom,
    ! [VarCurr: state_type] :
      ( v75419(VarCurr)
    <=> ( v75407(VarCurr)
      <~> v75411(VarCurr) ) ) ).

tff(addAssignment_47284,axiom,
    ! [VarCurr: state_type] :
      ( v75415(VarCurr)
    <=> v75417(VarCurr) ) ).

tff(addAssignment_47283,axiom,
    ! [VarCurr: state_type] :
      ( v75417(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_47282,axiom,
    ! [VarCurr: state_type] :
      ( v75411(VarCurr)
    <=> v75413(VarCurr) ) ).

tff(addAssignment_47281,axiom,
    ! [VarCurr: state_type] :
      ( v75413(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_47280,axiom,
    ! [VarCurr: state_type] :
      ( v75407(VarCurr)
    <=> v75409(VarCurr) ) ).

tff(addAssignment_47279,axiom,
    ! [VarCurr: state_type] :
      ( v75409(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_47278,axiom,
    ! [VarCurr: state_type] :
      ( v75373(VarCurr)
    <=> v75375(VarCurr) ) ).

tff(addAssignment_47277,axiom,
    ! [VarCurr: state_type] :
      ( v75375(VarCurr)
    <=> v75377(VarCurr) ) ).

tff(addAssignment_47276,axiom,
    ! [VarCurr: state_type] :
      ( v75377(VarCurr)
    <=> v75379(VarCurr) ) ).

tff(addAssignment_47275,axiom,
    ! [VarCurr: state_type] :
      ( v75379(VarCurr)
    <=> v75381(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7049,axiom,
    ! [VarCurr: state_type] :
      ( v75381(VarCurr)
    <=> ( v75395(VarCurr)
      <~> v75391(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7048,axiom,
    ! [VarCurr: state_type] :
      ( v75395(VarCurr)
    <=> ( v75383(VarCurr)
      <~> v75387(VarCurr) ) ) ).

tff(addAssignment_47274,axiom,
    ! [VarCurr: state_type] :
      ( v75391(VarCurr)
    <=> v75393(VarCurr) ) ).

tff(addAssignment_47273,axiom,
    ! [VarCurr: state_type] :
      ( v75393(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_47272,axiom,
    ! [VarCurr: state_type] :
      ( v75387(VarCurr)
    <=> v75389(VarCurr) ) ).

tff(addAssignment_47271,axiom,
    ! [VarCurr: state_type] :
      ( v75389(VarCurr)
    <=> v67349(VarCurr,75) ) ).

tff(addAssignment_47270,axiom,
    ! [VarCurr: state_type] :
      ( v75383(VarCurr)
    <=> v75385(VarCurr) ) ).

tff(addAssignment_47269,axiom,
    ! [VarCurr: state_type] :
      ( v75385(VarCurr)
    <=> v67349(VarCurr,72) ) ).

tff(addAssignment_47268,axiom,
    ! [VarCurr: state_type] :
      ( v75279(VarCurr)
    <=> v75281(VarCurr) ) ).

tff(addAssignment_47267,axiom,
    ! [VarCurr: state_type] :
      ( v75281(VarCurr)
    <=> v75283(VarCurr) ) ).

tff(addAssignment_47266,axiom,
    ! [VarCurr: state_type] :
      ( v75283(VarCurr)
    <=> v75285(VarCurr) ) ).

tff(addAssignment_47265,axiom,
    ! [VarCurr: state_type] :
      ( v75285(VarCurr)
    <=> v75287(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7047,axiom,
    ! [VarCurr: state_type] :
      ( v75287(VarCurr)
    <=> ( v75361(VarCurr)
      <~> v75337(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7046,axiom,
    ! [VarCurr: state_type] :
      ( v75361(VarCurr)
    <=> ( v75289(VarCurr)
      <~> v75313(VarCurr) ) ) ).

tff(addAssignment_47264,axiom,
    ! [VarCurr: state_type] :
      ( v75337(VarCurr)
    <=> v75339(VarCurr) ) ).

tff(addAssignment_47263,axiom,
    ! [VarCurr: state_type] :
      ( v75339(VarCurr)
    <=> v75341(VarCurr) ) ).

tff(addAssignment_47262,axiom,
    ! [VarCurr: state_type] :
      ( v75341(VarCurr)
    <=> v75343(VarCurr) ) ).

tff(addAssignment_47261,axiom,
    ! [VarCurr: state_type] :
      ( v75343(VarCurr)
    <=> v75345(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7045,axiom,
    ! [VarCurr: state_type] :
      ( v75345(VarCurr)
    <=> ( v75359(VarCurr)
      <~> v75355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7044,axiom,
    ! [VarCurr: state_type] :
      ( v75359(VarCurr)
    <=> ( v75347(VarCurr)
      <~> v75351(VarCurr) ) ) ).

tff(addAssignment_47260,axiom,
    ! [VarCurr: state_type] :
      ( v75355(VarCurr)
    <=> v75357(VarCurr) ) ).

tff(addAssignment_47259,axiom,
    ! [VarCurr: state_type] :
      ( v75357(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_47258,axiom,
    ! [VarCurr: state_type] :
      ( v75351(VarCurr)
    <=> v75353(VarCurr) ) ).

tff(addAssignment_47257,axiom,
    ! [VarCurr: state_type] :
      ( v75353(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_47256,axiom,
    ! [VarCurr: state_type] :
      ( v75347(VarCurr)
    <=> v75349(VarCurr) ) ).

tff(addAssignment_47255,axiom,
    ! [VarCurr: state_type] :
      ( v75349(VarCurr)
    <=> v67349(VarCurr,65) ) ).

tff(addAssignment_47254,axiom,
    ! [VarCurr: state_type] :
      ( v75313(VarCurr)
    <=> v75315(VarCurr) ) ).

tff(addAssignment_47253,axiom,
    ! [VarCurr: state_type] :
      ( v75315(VarCurr)
    <=> v75317(VarCurr) ) ).

tff(addAssignment_47252,axiom,
    ! [VarCurr: state_type] :
      ( v75317(VarCurr)
    <=> v75319(VarCurr) ) ).

tff(addAssignment_47251,axiom,
    ! [VarCurr: state_type] :
      ( v75319(VarCurr)
    <=> v75321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7043,axiom,
    ! [VarCurr: state_type] :
      ( v75321(VarCurr)
    <=> ( v75335(VarCurr)
      <~> v75331(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7042,axiom,
    ! [VarCurr: state_type] :
      ( v75335(VarCurr)
    <=> ( v75323(VarCurr)
      <~> v75327(VarCurr) ) ) ).

tff(addAssignment_47250,axiom,
    ! [VarCurr: state_type] :
      ( v75331(VarCurr)
    <=> v75333(VarCurr) ) ).

tff(addAssignment_47249,axiom,
    ! [VarCurr: state_type] :
      ( v75333(VarCurr)
    <=> v67349(VarCurr,62) ) ).

tff(addAssignment_47248,axiom,
    ! [VarCurr: state_type] :
      ( v75327(VarCurr)
    <=> v75329(VarCurr) ) ).

tff(addAssignment_47247,axiom,
    ! [VarCurr: state_type] :
      ( v75329(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_47246,axiom,
    ! [VarCurr: state_type] :
      ( v75323(VarCurr)
    <=> v75325(VarCurr) ) ).

tff(addAssignment_47245,axiom,
    ! [VarCurr: state_type] :
      ( v75325(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_47244,axiom,
    ! [VarCurr: state_type] :
      ( v75289(VarCurr)
    <=> v75291(VarCurr) ) ).

tff(addAssignment_47243,axiom,
    ! [VarCurr: state_type] :
      ( v75291(VarCurr)
    <=> v75293(VarCurr) ) ).

tff(addAssignment_47242,axiom,
    ! [VarCurr: state_type] :
      ( v75293(VarCurr)
    <=> v75295(VarCurr) ) ).

tff(addAssignment_47241,axiom,
    ! [VarCurr: state_type] :
      ( v75295(VarCurr)
    <=> v75297(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7041,axiom,
    ! [VarCurr: state_type] :
      ( v75297(VarCurr)
    <=> ( v75311(VarCurr)
      <~> v75307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7040,axiom,
    ! [VarCurr: state_type] :
      ( v75311(VarCurr)
    <=> ( v75299(VarCurr)
      <~> v75303(VarCurr) ) ) ).

tff(addAssignment_47240,axiom,
    ! [VarCurr: state_type] :
      ( v75307(VarCurr)
    <=> v75309(VarCurr) ) ).

tff(addAssignment_47239,axiom,
    ! [VarCurr: state_type] :
      ( v75309(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_47238,axiom,
    ! [VarCurr: state_type] :
      ( v75303(VarCurr)
    <=> v75305(VarCurr) ) ).

tff(addAssignment_47237,axiom,
    ! [VarCurr: state_type] :
      ( v75305(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_47236,axiom,
    ! [VarCurr: state_type] :
      ( v75299(VarCurr)
    <=> v75301(VarCurr) ) ).

tff(addAssignment_47235,axiom,
    ! [VarCurr: state_type] :
      ( v75301(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_47234,axiom,
    ! [VarCurr: state_type] :
      ( v75005(VarCurr)
    <=> v75007(VarCurr) ) ).

tff(addAssignment_47233,axiom,
    ! [VarCurr: state_type] :
      ( v75007(VarCurr)
    <=> v75009(VarCurr) ) ).

tff(addAssignment_47232,axiom,
    ! [VarCurr: state_type] :
      ( v75009(VarCurr)
    <=> v75011(VarCurr) ) ).

tff(addAssignment_47231,axiom,
    ! [VarCurr: state_type] :
      ( v75011(VarCurr)
    <=> v75013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7039,axiom,
    ! [VarCurr: state_type] :
      ( v75013(VarCurr)
    <=> ( v75267(VarCurr)
      <~> v75183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7038,axiom,
    ! [VarCurr: state_type] :
      ( v75267(VarCurr)
    <=> ( v75015(VarCurr)
      <~> v75099(VarCurr) ) ) ).

tff(addAssignment_47230,axiom,
    ! [VarCurr: state_type] :
      ( v75183(VarCurr)
    <=> v75185(VarCurr) ) ).

tff(addAssignment_47229,axiom,
    ! [VarCurr: state_type] :
      ( v75185(VarCurr)
    <=> v75187(VarCurr) ) ).

tff(addAssignment_47228,axiom,
    ! [VarCurr: state_type] :
      ( v75187(VarCurr)
    <=> v75189(VarCurr) ) ).

tff(addAssignment_47227,axiom,
    ! [VarCurr: state_type] :
      ( v75189(VarCurr)
    <=> v75191(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7037,axiom,
    ! [VarCurr: state_type] :
      ( v75191(VarCurr)
    <=> ( v75265(VarCurr)
      <~> v75241(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7036,axiom,
    ! [VarCurr: state_type] :
      ( v75265(VarCurr)
    <=> ( v75193(VarCurr)
      <~> v75217(VarCurr) ) ) ).

tff(addAssignment_47226,axiom,
    ! [VarCurr: state_type] :
      ( v75241(VarCurr)
    <=> v75243(VarCurr) ) ).

tff(addAssignment_47225,axiom,
    ! [VarCurr: state_type] :
      ( v75243(VarCurr)
    <=> v75245(VarCurr) ) ).

tff(addAssignment_47224,axiom,
    ! [VarCurr: state_type] :
      ( v75245(VarCurr)
    <=> v75247(VarCurr) ) ).

tff(addAssignment_47223,axiom,
    ! [VarCurr: state_type] :
      ( v75247(VarCurr)
    <=> v75249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7035,axiom,
    ! [VarCurr: state_type] :
      ( v75249(VarCurr)
    <=> ( v75263(VarCurr)
      <~> v75259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7034,axiom,
    ! [VarCurr: state_type] :
      ( v75263(VarCurr)
    <=> ( v75251(VarCurr)
      <~> v75255(VarCurr) ) ) ).

tff(addAssignment_47222,axiom,
    ! [VarCurr: state_type] :
      ( v75259(VarCurr)
    <=> v75261(VarCurr) ) ).

tff(addAssignment_47221,axiom,
    ! [VarCurr: state_type] :
      ( v75261(VarCurr)
    <=> v67349(VarCurr,48) ) ).

tff(addAssignment_47220,axiom,
    ! [VarCurr: state_type] :
      ( v75255(VarCurr)
    <=> v75257(VarCurr) ) ).

tff(addAssignment_47219,axiom,
    ! [VarCurr: state_type] :
      ( v75257(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_47218,axiom,
    ! [VarCurr: state_type] :
      ( v75251(VarCurr)
    <=> v75253(VarCurr) ) ).

tff(addAssignment_47217,axiom,
    ! [VarCurr: state_type] :
      ( v75253(VarCurr)
    <=> v67349(VarCurr,44) ) ).

tff(addAssignment_47216,axiom,
    ! [VarCurr: state_type] :
      ( v75217(VarCurr)
    <=> v75219(VarCurr) ) ).

tff(addAssignment_47215,axiom,
    ! [VarCurr: state_type] :
      ( v75219(VarCurr)
    <=> v75221(VarCurr) ) ).

tff(addAssignment_47214,axiom,
    ! [VarCurr: state_type] :
      ( v75221(VarCurr)
    <=> v75223(VarCurr) ) ).

tff(addAssignment_47213,axiom,
    ! [VarCurr: state_type] :
      ( v75223(VarCurr)
    <=> v75225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7033,axiom,
    ! [VarCurr: state_type] :
      ( v75225(VarCurr)
    <=> ( v75239(VarCurr)
      <~> v75235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7032,axiom,
    ! [VarCurr: state_type] :
      ( v75239(VarCurr)
    <=> ( v75227(VarCurr)
      <~> v75231(VarCurr) ) ) ).

tff(addAssignment_47212,axiom,
    ! [VarCurr: state_type] :
      ( v75235(VarCurr)
    <=> v75237(VarCurr) ) ).

tff(addAssignment_47211,axiom,
    ! [VarCurr: state_type] :
      ( v75237(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_47210,axiom,
    ! [VarCurr: state_type] :
      ( v75231(VarCurr)
    <=> v75233(VarCurr) ) ).

tff(addAssignment_47209,axiom,
    ! [VarCurr: state_type] :
      ( v75233(VarCurr)
    <=> v67349(VarCurr,41) ) ).

tff(addAssignment_47208,axiom,
    ! [VarCurr: state_type] :
      ( v75227(VarCurr)
    <=> v75229(VarCurr) ) ).

tff(addAssignment_47207,axiom,
    ! [VarCurr: state_type] :
      ( v75229(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_47206,axiom,
    ! [VarCurr: state_type] :
      ( v75193(VarCurr)
    <=> v75195(VarCurr) ) ).

tff(addAssignment_47205,axiom,
    ! [VarCurr: state_type] :
      ( v75195(VarCurr)
    <=> v75197(VarCurr) ) ).

tff(addAssignment_47204,axiom,
    ! [VarCurr: state_type] :
      ( v75197(VarCurr)
    <=> v75199(VarCurr) ) ).

tff(addAssignment_47203,axiom,
    ! [VarCurr: state_type] :
      ( v75199(VarCurr)
    <=> v75201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7031,axiom,
    ! [VarCurr: state_type] :
      ( v75201(VarCurr)
    <=> ( v75215(VarCurr)
      <~> v75211(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7030,axiom,
    ! [VarCurr: state_type] :
      ( v75215(VarCurr)
    <=> ( v75203(VarCurr)
      <~> v75207(VarCurr) ) ) ).

tff(addAssignment_47202,axiom,
    ! [VarCurr: state_type] :
      ( v75211(VarCurr)
    <=> v75213(VarCurr) ) ).

tff(addAssignment_47201,axiom,
    ! [VarCurr: state_type] :
      ( v75213(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_47200,axiom,
    ! [VarCurr: state_type] :
      ( v75207(VarCurr)
    <=> v75209(VarCurr) ) ).

tff(addAssignment_47199,axiom,
    ! [VarCurr: state_type] :
      ( v75209(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_47198,axiom,
    ! [VarCurr: state_type] :
      ( v75203(VarCurr)
    <=> v75205(VarCurr) ) ).

tff(addAssignment_47197,axiom,
    ! [VarCurr: state_type] :
      ( v75205(VarCurr)
    <=> v67349(VarCurr,35) ) ).

tff(addAssignment_47196,axiom,
    ! [VarCurr: state_type] :
      ( v75099(VarCurr)
    <=> v75101(VarCurr) ) ).

tff(addAssignment_47195,axiom,
    ! [VarCurr: state_type] :
      ( v75101(VarCurr)
    <=> v75103(VarCurr) ) ).

tff(addAssignment_47194,axiom,
    ! [VarCurr: state_type] :
      ( v75103(VarCurr)
    <=> v75105(VarCurr) ) ).

tff(addAssignment_47193,axiom,
    ! [VarCurr: state_type] :
      ( v75105(VarCurr)
    <=> v75107(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7029,axiom,
    ! [VarCurr: state_type] :
      ( v75107(VarCurr)
    <=> ( v75181(VarCurr)
      <~> v75157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7028,axiom,
    ! [VarCurr: state_type] :
      ( v75181(VarCurr)
    <=> ( v75109(VarCurr)
      <~> v75133(VarCurr) ) ) ).

tff(addAssignment_47192,axiom,
    ! [VarCurr: state_type] :
      ( v75157(VarCurr)
    <=> v75159(VarCurr) ) ).

tff(addAssignment_47191,axiom,
    ! [VarCurr: state_type] :
      ( v75159(VarCurr)
    <=> v75161(VarCurr) ) ).

tff(addAssignment_47190,axiom,
    ! [VarCurr: state_type] :
      ( v75161(VarCurr)
    <=> v75163(VarCurr) ) ).

tff(addAssignment_47189,axiom,
    ! [VarCurr: state_type] :
      ( v75163(VarCurr)
    <=> v75165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7027,axiom,
    ! [VarCurr: state_type] :
      ( v75165(VarCurr)
    <=> ( v75179(VarCurr)
      <~> v75175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7026,axiom,
    ! [VarCurr: state_type] :
      ( v75179(VarCurr)
    <=> ( v75167(VarCurr)
      <~> v75171(VarCurr) ) ) ).

tff(addAssignment_47188,axiom,
    ! [VarCurr: state_type] :
      ( v75175(VarCurr)
    <=> v75177(VarCurr) ) ).

tff(addAssignment_47187,axiom,
    ! [VarCurr: state_type] :
      ( v75177(VarCurr)
    <=> v67349(VarCurr,31) ) ).

tff(addAssignment_47186,axiom,
    ! [VarCurr: state_type] :
      ( v75171(VarCurr)
    <=> v75173(VarCurr) ) ).

tff(addAssignment_47185,axiom,
    ! [VarCurr: state_type] :
      ( v75173(VarCurr)
    <=> v67349(VarCurr,30) ) ).

tff(addAssignment_47184,axiom,
    ! [VarCurr: state_type] :
      ( v75167(VarCurr)
    <=> v75169(VarCurr) ) ).

tff(addAssignment_47183,axiom,
    ! [VarCurr: state_type] :
      ( v75169(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_47182,axiom,
    ! [VarCurr: state_type] :
      ( v75133(VarCurr)
    <=> v75135(VarCurr) ) ).

tff(addAssignment_47181,axiom,
    ! [VarCurr: state_type] :
      ( v75135(VarCurr)
    <=> v75137(VarCurr) ) ).

tff(addAssignment_47180,axiom,
    ! [VarCurr: state_type] :
      ( v75137(VarCurr)
    <=> v75139(VarCurr) ) ).

tff(addAssignment_47179,axiom,
    ! [VarCurr: state_type] :
      ( v75139(VarCurr)
    <=> v75141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7025,axiom,
    ! [VarCurr: state_type] :
      ( v75141(VarCurr)
    <=> ( v75155(VarCurr)
      <~> v75151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7024,axiom,
    ! [VarCurr: state_type] :
      ( v75155(VarCurr)
    <=> ( v75143(VarCurr)
      <~> v75147(VarCurr) ) ) ).

tff(addAssignment_47178,axiom,
    ! [VarCurr: state_type] :
      ( v75151(VarCurr)
    <=> v75153(VarCurr) ) ).

tff(addAssignment_47177,axiom,
    ! [VarCurr: state_type] :
      ( v75153(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_47176,axiom,
    ! [VarCurr: state_type] :
      ( v75147(VarCurr)
    <=> v75149(VarCurr) ) ).

tff(addAssignment_47175,axiom,
    ! [VarCurr: state_type] :
      ( v75149(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_47174,axiom,
    ! [VarCurr: state_type] :
      ( v75143(VarCurr)
    <=> v75145(VarCurr) ) ).

tff(addAssignment_47173,axiom,
    ! [VarCurr: state_type] :
      ( v75145(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_47172,axiom,
    ! [VarCurr: state_type] :
      ( v75109(VarCurr)
    <=> v75111(VarCurr) ) ).

tff(addAssignment_47171,axiom,
    ! [VarCurr: state_type] :
      ( v75111(VarCurr)
    <=> v75113(VarCurr) ) ).

tff(addAssignment_47170,axiom,
    ! [VarCurr: state_type] :
      ( v75113(VarCurr)
    <=> v75115(VarCurr) ) ).

tff(addAssignment_47169,axiom,
    ! [VarCurr: state_type] :
      ( v75115(VarCurr)
    <=> v75117(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7023,axiom,
    ! [VarCurr: state_type] :
      ( v75117(VarCurr)
    <=> ( v75131(VarCurr)
      <~> v75127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7022,axiom,
    ! [VarCurr: state_type] :
      ( v75131(VarCurr)
    <=> ( v75119(VarCurr)
      <~> v75123(VarCurr) ) ) ).

tff(addAssignment_47168,axiom,
    ! [VarCurr: state_type] :
      ( v75127(VarCurr)
    <=> v75129(VarCurr) ) ).

tff(addAssignment_47167,axiom,
    ! [VarCurr: state_type] :
      ( v75129(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_47166,axiom,
    ! [VarCurr: state_type] :
      ( v75123(VarCurr)
    <=> v75125(VarCurr) ) ).

tff(addAssignment_47165,axiom,
    ! [VarCurr: state_type] :
      ( v75125(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_47164,axiom,
    ! [VarCurr: state_type] :
      ( v75119(VarCurr)
    <=> v75121(VarCurr) ) ).

tff(addAssignment_47163,axiom,
    ! [VarCurr: state_type] :
      ( v75121(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_47162,axiom,
    ! [VarCurr: state_type] :
      ( v75015(VarCurr)
    <=> v75017(VarCurr) ) ).

tff(addAssignment_47161,axiom,
    ! [VarCurr: state_type] :
      ( v75017(VarCurr)
    <=> v75019(VarCurr) ) ).

tff(addAssignment_47160,axiom,
    ! [VarCurr: state_type] :
      ( v75019(VarCurr)
    <=> v75021(VarCurr) ) ).

tff(addAssignment_47159,axiom,
    ! [VarCurr: state_type] :
      ( v75021(VarCurr)
    <=> v75023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7021,axiom,
    ! [VarCurr: state_type] :
      ( v75023(VarCurr)
    <=> ( v75097(VarCurr)
      <~> v75073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7020,axiom,
    ! [VarCurr: state_type] :
      ( v75097(VarCurr)
    <=> ( v75025(VarCurr)
      <~> v75049(VarCurr) ) ) ).

tff(addAssignment_47158,axiom,
    ! [VarCurr: state_type] :
      ( v75073(VarCurr)
    <=> v75075(VarCurr) ) ).

tff(addAssignment_47157,axiom,
    ! [VarCurr: state_type] :
      ( v75075(VarCurr)
    <=> v75077(VarCurr) ) ).

tff(addAssignment_47156,axiom,
    ! [VarCurr: state_type] :
      ( v75077(VarCurr)
    <=> v75079(VarCurr) ) ).

tff(addAssignment_47155,axiom,
    ! [VarCurr: state_type] :
      ( v75079(VarCurr)
    <=> v75081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7019,axiom,
    ! [VarCurr: state_type] :
      ( v75081(VarCurr)
    <=> ( v75095(VarCurr)
      <~> v75091(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7018,axiom,
    ! [VarCurr: state_type] :
      ( v75095(VarCurr)
    <=> ( v75083(VarCurr)
      <~> v75087(VarCurr) ) ) ).

tff(addAssignment_47154,axiom,
    ! [VarCurr: state_type] :
      ( v75091(VarCurr)
    <=> v75093(VarCurr) ) ).

tff(addAssignment_47153,axiom,
    ! [VarCurr: state_type] :
      ( v75093(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_47152,axiom,
    ! [VarCurr: state_type] :
      ( v75087(VarCurr)
    <=> v75089(VarCurr) ) ).

tff(addAssignment_47151,axiom,
    ! [VarCurr: state_type] :
      ( v75089(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_47150,axiom,
    ! [VarCurr: state_type] :
      ( v75083(VarCurr)
    <=> v75085(VarCurr) ) ).

tff(addAssignment_47149,axiom,
    ! [VarCurr: state_type] :
      ( v75085(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_47148,axiom,
    ! [VarCurr: state_type] :
      ( v75049(VarCurr)
    <=> v75051(VarCurr) ) ).

tff(addAssignment_47147,axiom,
    ! [VarCurr: state_type] :
      ( v75051(VarCurr)
    <=> v75053(VarCurr) ) ).

tff(addAssignment_47146,axiom,
    ! [VarCurr: state_type] :
      ( v75053(VarCurr)
    <=> v75055(VarCurr) ) ).

tff(addAssignment_47145,axiom,
    ! [VarCurr: state_type] :
      ( v75055(VarCurr)
    <=> v75057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7017,axiom,
    ! [VarCurr: state_type] :
      ( v75057(VarCurr)
    <=> ( v75071(VarCurr)
      <~> v75067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7016,axiom,
    ! [VarCurr: state_type] :
      ( v75071(VarCurr)
    <=> ( v75059(VarCurr)
      <~> v75063(VarCurr) ) ) ).

tff(addAssignment_47144,axiom,
    ! [VarCurr: state_type] :
      ( v75067(VarCurr)
    <=> v75069(VarCurr) ) ).

tff(addAssignment_47143,axiom,
    ! [VarCurr: state_type] :
      ( v75069(VarCurr)
    <=> v67349(VarCurr,15) ) ).

tff(addAssignment_47142,axiom,
    ! [VarCurr: state_type] :
      ( v75063(VarCurr)
    <=> v75065(VarCurr) ) ).

tff(addAssignment_47141,axiom,
    ! [VarCurr: state_type] :
      ( v75065(VarCurr)
    <=> v67349(VarCurr,12) ) ).

tff(addAssignment_47140,axiom,
    ! [VarCurr: state_type] :
      ( v75059(VarCurr)
    <=> v75061(VarCurr) ) ).

tff(addAssignment_47139,axiom,
    ! [VarCurr: state_type] :
      ( v75061(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_47138,axiom,
    ! [VarCurr: state_type] :
      ( v75025(VarCurr)
    <=> v75027(VarCurr) ) ).

tff(addAssignment_47137,axiom,
    ! [VarCurr: state_type] :
      ( v75027(VarCurr)
    <=> v75029(VarCurr) ) ).

tff(addAssignment_47136,axiom,
    ! [VarCurr: state_type] :
      ( v75029(VarCurr)
    <=> v75031(VarCurr) ) ).

tff(addAssignment_47135,axiom,
    ! [VarCurr: state_type] :
      ( v75031(VarCurr)
    <=> v75033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7015,axiom,
    ! [VarCurr: state_type] :
      ( v75033(VarCurr)
    <=> ( v75047(VarCurr)
      <~> v75043(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7014,axiom,
    ! [VarCurr: state_type] :
      ( v75047(VarCurr)
    <=> ( v75035(VarCurr)
      <~> v75039(VarCurr) ) ) ).

tff(addAssignment_47134,axiom,
    ! [VarCurr: state_type] :
      ( v75043(VarCurr)
    <=> v75045(VarCurr) ) ).

tff(addAssignment_47133,axiom,
    ! [VarCurr: state_type] :
      ( v75045(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_47132,axiom,
    ! [VarCurr: state_type] :
      ( v75039(VarCurr)
    <=> v75041(VarCurr) ) ).

tff(addAssignment_47131,axiom,
    ! [VarCurr: state_type] :
      ( v75041(VarCurr)
    <=> v67349(VarCurr,5) ) ).

tff(addAssignment_47130,axiom,
    ! [VarCurr: state_type] :
      ( v75035(VarCurr)
    <=> v75037(VarCurr) ) ).

tff(addAssignment_47129,axiom,
    ! [VarCurr: state_type] :
      ( v75037(VarCurr)
    <=> v67349(VarCurr,2) ) ).

tff(addAssignment_47128,axiom,
    ! [VarCurr: state_type] :
      ( v67253(VarCurr,2)
    <=> v67255(VarCurr,2) ) ).

tff(addAssignment_47127,axiom,
    ! [VarCurr: state_type] :
      ( v67255(VarCurr,2)
    <=> v74273(VarCurr,2) ) ).

tff(addAssignment_47126,axiom,
    ! [VarCurr: state_type] :
      ( v67243(VarCurr)
    <=> v67245(VarCurr) ) ).

tff(addAssignment_47125,axiom,
    ! [VarCurr: state_type] :
      ( v67245(VarCurr)
    <=> v67247(VarCurr,3) ) ).

tff(addAssignment_47124,axiom,
    ! [VarCurr: state_type] :
      ( v67247(VarCurr,3)
    <=> v67249(VarCurr,3) ) ).

tff(addAssignment_47123,axiom,
    ! [VarCurr: state_type] :
      ( v67249(VarCurr,3)
    <=> v67251(VarCurr,3) ) ).

tff(addAssignment_47122,axiom,
    ! [VarCurr: state_type] :
      ( v67251(VarCurr,3)
    <=> v74995(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v74995(VarCurr,B)
      <=> ( v67253(VarCurr,B)
          & v74276(VarCurr,B) ) ) ) ).

tff(addAssignment_47121,axiom,
    ! [VarCurr: state_type] :
      ( v74276(VarCurr,3)
    <=> v74278(VarCurr,3) ) ).

tff(addAssignment_47120,axiom,
    ! [VarCurr: state_type] :
      ( v74278(VarCurr,3)
    <=> v74280(VarCurr,3) ) ).

tff(addAssignment_47119,axiom,
    ! [VarCurr: state_type] :
      ( v74280(VarCurr,3)
    <=> v67309(VarCurr,15) ) ).

tff(addAssignment_47118,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,15)
    <=> v67311(VarCurr,15) ) ).

tff(addAssignment_47117,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,15)
    <=> v67313(VarCurr,15) ) ).

tff(addAssignment_47116,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,15)
    <=> v67315(VarCurr,15) ) ).

tff(addAssignment_47115,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,15)
    <=> v67317(VarCurr,15) ) ).

tff(addAssignment_47114,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,15)
    <=> v68771(VarCurr,15) ) ).

tff(addAssignment_47113,axiom,
    ! [VarCurr: state_type] :
      ( v68772(VarCurr,3)
    <=> v74283(VarCurr) ) ).

tff(addAssignment_47112,axiom,
    ! [VarCurr: state_type] :
      ( v74283(VarCurr)
    <=> v74285(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7013,axiom,
    ! [VarCurr: state_type] :
      ( v74285(VarCurr)
    <=> ( v74994(VarCurr)
      <~> v74815(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7012,axiom,
    ! [VarCurr: state_type] :
      ( v74994(VarCurr)
    <=> ( v74287(VarCurr)
      <~> v74551(VarCurr) ) ) ).

tff(addAssignment_47111,axiom,
    ! [VarCurr: state_type] :
      ( v74815(VarCurr)
    <=> v74817(VarCurr) ) ).

tff(addAssignment_47110,axiom,
    ! [VarCurr: state_type] :
      ( v74817(VarCurr)
    <=> v74819(VarCurr) ) ).

tff(addAssignment_47109,axiom,
    ! [VarCurr: state_type] :
      ( v74819(VarCurr)
    <=> v74821(VarCurr) ) ).

tff(addAssignment_47108,axiom,
    ! [VarCurr: state_type] :
      ( v74821(VarCurr)
    <=> v74823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7011,axiom,
    ! [VarCurr: state_type] :
      ( v74823(VarCurr)
    <=> ( v74992(VarCurr)
      <~> v74933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7010,axiom,
    ! [VarCurr: state_type] :
      ( v74992(VarCurr)
    <=> ( v74825(VarCurr)
      <~> v74849(VarCurr) ) ) ).

tff(addAssignment_47107,axiom,
    ! [VarCurr: state_type] :
      ( v74933(VarCurr)
    <=> v74935(VarCurr) ) ).

tff(addAssignment_47106,axiom,
    ! [VarCurr: state_type] :
      ( v74935(VarCurr)
    <=> v74937(VarCurr,3) ) ).

tff(addAssignment_47105,axiom,
    ! [VarCurr: state_type] :
      ( v74937(VarCurr,3)
    <=> v74939(VarCurr,3) ) ).

tff(addAssignment_47104,axiom,
    ! [VarCurr: state_type] :
      ( v74939(VarCurr,3)
    <=> v68676(VarCurr,7) ) ).

tff(addAssignment_47103,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,7)
    <=> v68678(VarCurr,7) ) ).

tff(addAssignment_47102,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,7)
    <=> v74984(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v74985(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v74984(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_906,axiom,
    ! [VarNext: state_type] :
      ( v74985(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v74984(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v74985(VarNext)
      <=> v74986(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v74986(VarNext)
      <=> ( v74988(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v74988(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_47101,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,7)
    <=> v68702(VarCurr,7) ) ).

tff(addAssignment_47100,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,7)
    <=> v68731(VarCurr,7) ) ).

tff(addAssignment_47099,axiom,
    ! [VarCurr: state_type] :
      ( v68732(VarCurr)
    <=> v74942(VarCurr) ) ).

tff(addAssignment_47098,axiom,
    ! [VarCurr: state_type] :
      ( v74942(VarCurr)
    <=> v74944(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7007,axiom,
    ! [VarCurr: state_type] :
      ( v74944(VarCurr)
    <=> ( v74946(VarCurr)
      <~> v74977(VarCurr) ) ) ).

tff(addAssignment_47097,axiom,
    ! [VarCurr: state_type] :
      ( v74977(VarCurr)
    <=> v74979(VarCurr) ) ).

tff(addAssignment_47096,axiom,
    ! [VarCurr: state_type] :
      ( v74979(VarCurr)
    <=> v74981(VarCurr) ) ).

tff(addAssignment_47095,axiom,
    ! [VarCurr: state_type] :
      ( v74981(VarCurr)
    <=> $false ) ).

tff(addAssignment_47094,axiom,
    ! [VarCurr: state_type] :
      ( v74946(VarCurr)
    <=> v74948(VarCurr) ) ).

tff(addAssignment_47093,axiom,
    ! [VarCurr: state_type] :
      ( v74948(VarCurr)
    <=> v68625(VarCurr,15) ) ).

tff(addAssignment_47092,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,15)
    <=> v74950(VarCurr,3) ) ).

tff(addAssignment_47091,axiom,
    ! [VarCurr: state_type] :
      ( v74950(VarCurr,3)
    <=> v74952(VarCurr,3) ) ).

tff(addAssignment_47090,axiom,
    ! [VarCurr: state_type] :
      ( v74952(VarCurr,3)
    <=> v74969(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v74969(VarCurr,B)
      <=> ( v74970(VarCurr,B)
          | v74973(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v74973(VarCurr,B)
      <=> ( v74962(VarCurr,B)
          & v74974(VarCurr,B) ) ) ) ).

tff(addAssignment_47089,axiom,
    ! [VarCurr: state_type] :
      ( v74974(VarCurr,0)
    <=> v74975(VarCurr) ) ).

tff(addAssignment_47088,axiom,
    ! [VarCurr: state_type] :
      ( v74974(VarCurr,1)
    <=> v74975(VarCurr) ) ).

tff(addAssignment_47087,axiom,
    ! [VarCurr: state_type] :
      ( v74974(VarCurr,2)
    <=> v74975(VarCurr) ) ).

tff(addAssignment_47086,axiom,
    ! [VarCurr: state_type] :
      ( v74974(VarCurr,3)
    <=> v74975(VarCurr) ) ).

tff(addAssignment_47085,axiom,
    ! [VarCurr: state_type] :
      ( v74975(VarCurr)
    <=> v74966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v74970(VarCurr,B)
      <=> ( v74954(VarCurr,B)
          & v74971(VarCurr,B) ) ) ) ).

tff(addAssignment_47084,axiom,
    ! [VarCurr: state_type] :
      ( v74971(VarCurr,0)
    <=> v74972(VarCurr) ) ).

tff(addAssignment_47083,axiom,
    ! [VarCurr: state_type] :
      ( v74971(VarCurr,1)
    <=> v74972(VarCurr) ) ).

tff(addAssignment_47082,axiom,
    ! [VarCurr: state_type] :
      ( v74971(VarCurr,2)
    <=> v74972(VarCurr) ) ).

tff(addAssignment_47081,axiom,
    ! [VarCurr: state_type] :
      ( v74971(VarCurr,3)
    <=> v74972(VarCurr) ) ).

tff(addAssignment_47080,axiom,
    ! [VarCurr: state_type] :
      ( v74972(VarCurr)
    <=> v74958(VarCurr) ) ).

tff(addAssignment_47079,axiom,
    ! [VarCurr: state_type] :
      ( v74966(VarCurr)
    <=> v74968(VarCurr) ) ).

tff(addAssignment_47078,axiom,
    ! [VarCurr: state_type] :
      ( v74968(VarCurr)
    <=> v67530(VarCurr,32) ) ).

tff(addAssignment_47077,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,32)
    <=> v52381(VarCurr,32) ) ).

tff(addAssignment_47076,axiom,
    ! [VarCurr: state_type] :
      ( v74962(VarCurr,3)
    <=> v74964(VarCurr,3) ) ).

tff(addAssignment_47075,axiom,
    ! [VarCurr: state_type] :
      ( v74964(VarCurr,3)
    <=> v68455(VarCurr,15) ) ).

tff(addAssignment_47074,axiom,
    ! [VarCurr: state_type] :
      ( v74958(VarCurr)
    <=> v74960(VarCurr) ) ).

tff(addAssignment_47073,axiom,
    ! [VarCurr: state_type] :
      ( v74960(VarCurr)
    <=> v67520(VarCurr,32) ) ).

tff(addAssignment_47072,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,32)
    <=> v52363(VarCurr,32) ) ).

tff(addAssignment_47071,axiom,
    ! [VarCurr: state_type] :
      ( v74954(VarCurr,3)
    <=> v74956(VarCurr,3) ) ).

tff(addAssignment_47070,axiom,
    ! [VarCurr: state_type] :
      ( v74956(VarCurr,3)
    <=> v68455(VarCurr,11) ) ).

tff(addAssignment_47069,axiom,
    ! [VarCurr: state_type] :
      ( v74849(VarCurr)
    <=> v74851(VarCurr) ) ).

tff(addAssignment_47068,axiom,
    ! [VarCurr: state_type] :
      ( v74851(VarCurr)
    <=> v74853(VarCurr) ) ).

tff(addAssignment_47067,axiom,
    ! [VarCurr: state_type] :
      ( v74853(VarCurr)
    <=> v74855(VarCurr) ) ).

tff(addAssignment_47066,axiom,
    ! [VarCurr: state_type] :
      ( v74855(VarCurr)
    <=> v74857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7006,axiom,
    ! [VarCurr: state_type] :
      ( v74857(VarCurr)
    <=> ( v74931(VarCurr)
      <~> v74907(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7005,axiom,
    ! [VarCurr: state_type] :
      ( v74931(VarCurr)
    <=> ( v74859(VarCurr)
      <~> v74883(VarCurr) ) ) ).

tff(addAssignment_47065,axiom,
    ! [VarCurr: state_type] :
      ( v74907(VarCurr)
    <=> v74909(VarCurr) ) ).

tff(addAssignment_47064,axiom,
    ! [VarCurr: state_type] :
      ( v74909(VarCurr)
    <=> v74911(VarCurr) ) ).

tff(addAssignment_47063,axiom,
    ! [VarCurr: state_type] :
      ( v74911(VarCurr)
    <=> v74913(VarCurr) ) ).

tff(addAssignment_47062,axiom,
    ! [VarCurr: state_type] :
      ( v74913(VarCurr)
    <=> v74915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7004,axiom,
    ! [VarCurr: state_type] :
      ( v74915(VarCurr)
    <=> ( v74929(VarCurr)
      <~> v74925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7003,axiom,
    ! [VarCurr: state_type] :
      ( v74929(VarCurr)
    <=> ( v74917(VarCurr)
      <~> v74921(VarCurr) ) ) ).

tff(addAssignment_47061,axiom,
    ! [VarCurr: state_type] :
      ( v74925(VarCurr)
    <=> v74927(VarCurr) ) ).

tff(addAssignment_47060,axiom,
    ! [VarCurr: state_type] :
      ( v74927(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_47059,axiom,
    ! [VarCurr: state_type] :
      ( v74921(VarCurr)
    <=> v74923(VarCurr) ) ).

tff(addAssignment_47058,axiom,
    ! [VarCurr: state_type] :
      ( v74923(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_47057,axiom,
    ! [VarCurr: state_type] :
      ( v74917(VarCurr)
    <=> v74919(VarCurr) ) ).

tff(addAssignment_47056,axiom,
    ! [VarCurr: state_type] :
      ( v74919(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_47055,axiom,
    ! [VarCurr: state_type] :
      ( v74883(VarCurr)
    <=> v74885(VarCurr) ) ).

tff(addAssignment_47054,axiom,
    ! [VarCurr: state_type] :
      ( v74885(VarCurr)
    <=> v74887(VarCurr) ) ).

tff(addAssignment_47053,axiom,
    ! [VarCurr: state_type] :
      ( v74887(VarCurr)
    <=> v74889(VarCurr) ) ).

tff(addAssignment_47052,axiom,
    ! [VarCurr: state_type] :
      ( v74889(VarCurr)
    <=> v74891(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7002,axiom,
    ! [VarCurr: state_type] :
      ( v74891(VarCurr)
    <=> ( v74905(VarCurr)
      <~> v74901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7001,axiom,
    ! [VarCurr: state_type] :
      ( v74905(VarCurr)
    <=> ( v74893(VarCurr)
      <~> v74897(VarCurr) ) ) ).

tff(addAssignment_47051,axiom,
    ! [VarCurr: state_type] :
      ( v74901(VarCurr)
    <=> v74903(VarCurr) ) ).

tff(addAssignment_47050,axiom,
    ! [VarCurr: state_type] :
      ( v74903(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_47049,axiom,
    ! [VarCurr: state_type] :
      ( v74897(VarCurr)
    <=> v74899(VarCurr) ) ).

tff(addAssignment_47048,axiom,
    ! [VarCurr: state_type] :
      ( v74899(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_47047,axiom,
    ! [VarCurr: state_type] :
      ( v74893(VarCurr)
    <=> v74895(VarCurr) ) ).

tff(addAssignment_47046,axiom,
    ! [VarCurr: state_type] :
      ( v74895(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_47045,axiom,
    ! [VarCurr: state_type] :
      ( v74859(VarCurr)
    <=> v74861(VarCurr) ) ).

tff(addAssignment_47044,axiom,
    ! [VarCurr: state_type] :
      ( v74861(VarCurr)
    <=> v74863(VarCurr) ) ).

tff(addAssignment_47043,axiom,
    ! [VarCurr: state_type] :
      ( v74863(VarCurr)
    <=> v74865(VarCurr) ) ).

tff(addAssignment_47042,axiom,
    ! [VarCurr: state_type] :
      ( v74865(VarCurr)
    <=> v74867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7000,axiom,
    ! [VarCurr: state_type] :
      ( v74867(VarCurr)
    <=> ( v74881(VarCurr)
      <~> v74877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6999,axiom,
    ! [VarCurr: state_type] :
      ( v74881(VarCurr)
    <=> ( v74869(VarCurr)
      <~> v74873(VarCurr) ) ) ).

tff(addAssignment_47041,axiom,
    ! [VarCurr: state_type] :
      ( v74877(VarCurr)
    <=> v74879(VarCurr) ) ).

tff(addAssignment_47040,axiom,
    ! [VarCurr: state_type] :
      ( v74879(VarCurr)
    <=> v67349(VarCurr,109) ) ).

tff(addAssignment_47039,axiom,
    ! [VarCurr: state_type] :
      ( v74873(VarCurr)
    <=> v74875(VarCurr) ) ).

tff(addAssignment_47038,axiom,
    ! [VarCurr: state_type] :
      ( v74875(VarCurr)
    <=> v67349(VarCurr,108) ) ).

tff(addAssignment_47037,axiom,
    ! [VarCurr: state_type] :
      ( v74869(VarCurr)
    <=> v74871(VarCurr) ) ).

tff(addAssignment_47036,axiom,
    ! [VarCurr: state_type] :
      ( v74871(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_47035,axiom,
    ! [VarCurr: state_type] :
      ( v74825(VarCurr)
    <=> v74827(VarCurr) ) ).

tff(addAssignment_47034,axiom,
    ! [VarCurr: state_type] :
      ( v74827(VarCurr)
    <=> v74829(VarCurr) ) ).

tff(addAssignment_47033,axiom,
    ! [VarCurr: state_type] :
      ( v74829(VarCurr)
    <=> v74831(VarCurr) ) ).

tff(addAssignment_47032,axiom,
    ! [VarCurr: state_type] :
      ( v74831(VarCurr)
    <=> v74833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6998,axiom,
    ! [VarCurr: state_type] :
      ( v74833(VarCurr)
    <=> ( v74847(VarCurr)
      <~> v74843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6997,axiom,
    ! [VarCurr: state_type] :
      ( v74847(VarCurr)
    <=> ( v74835(VarCurr)
      <~> v74839(VarCurr) ) ) ).

tff(addAssignment_47031,axiom,
    ! [VarCurr: state_type] :
      ( v74843(VarCurr)
    <=> v74845(VarCurr) ) ).

tff(addAssignment_47030,axiom,
    ! [VarCurr: state_type] :
      ( v74845(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_47029,axiom,
    ! [VarCurr: state_type] :
      ( v74839(VarCurr)
    <=> v74841(VarCurr) ) ).

tff(addAssignment_47028,axiom,
    ! [VarCurr: state_type] :
      ( v74841(VarCurr)
    <=> v67349(VarCurr,127) ) ).

tff(addAssignment_47027,axiom,
    ! [VarCurr: state_type] :
      ( v74835(VarCurr)
    <=> v74837(VarCurr) ) ).

tff(addAssignment_47026,axiom,
    ! [VarCurr: state_type] :
      ( v74837(VarCurr)
    <=> v67349(VarCurr,118) ) ).

tff(addAssignment_47025,axiom,
    ! [VarCurr: state_type] :
      ( v74551(VarCurr)
    <=> v74553(VarCurr) ) ).

tff(addAssignment_47024,axiom,
    ! [VarCurr: state_type] :
      ( v74553(VarCurr)
    <=> v74555(VarCurr) ) ).

tff(addAssignment_47023,axiom,
    ! [VarCurr: state_type] :
      ( v74555(VarCurr)
    <=> v74557(VarCurr) ) ).

tff(addAssignment_47022,axiom,
    ! [VarCurr: state_type] :
      ( v74557(VarCurr)
    <=> v74559(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6996,axiom,
    ! [VarCurr: state_type] :
      ( v74559(VarCurr)
    <=> ( v74813(VarCurr)
      <~> v74729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6995,axiom,
    ! [VarCurr: state_type] :
      ( v74813(VarCurr)
    <=> ( v74561(VarCurr)
      <~> v74645(VarCurr) ) ) ).

tff(addAssignment_47021,axiom,
    ! [VarCurr: state_type] :
      ( v74729(VarCurr)
    <=> v74731(VarCurr) ) ).

tff(addAssignment_47020,axiom,
    ! [VarCurr: state_type] :
      ( v74731(VarCurr)
    <=> v74733(VarCurr) ) ).

tff(addAssignment_47019,axiom,
    ! [VarCurr: state_type] :
      ( v74733(VarCurr)
    <=> v74735(VarCurr) ) ).

tff(addAssignment_47018,axiom,
    ! [VarCurr: state_type] :
      ( v74735(VarCurr)
    <=> v74737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6994,axiom,
    ! [VarCurr: state_type] :
      ( v74737(VarCurr)
    <=> ( v74811(VarCurr)
      <~> v74787(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6993,axiom,
    ! [VarCurr: state_type] :
      ( v74811(VarCurr)
    <=> ( v74739(VarCurr)
      <~> v74763(VarCurr) ) ) ).

tff(addAssignment_47017,axiom,
    ! [VarCurr: state_type] :
      ( v74787(VarCurr)
    <=> v74789(VarCurr) ) ).

tff(addAssignment_47016,axiom,
    ! [VarCurr: state_type] :
      ( v74789(VarCurr)
    <=> v74791(VarCurr) ) ).

tff(addAssignment_47015,axiom,
    ! [VarCurr: state_type] :
      ( v74791(VarCurr)
    <=> v74793(VarCurr) ) ).

tff(addAssignment_47014,axiom,
    ! [VarCurr: state_type] :
      ( v74793(VarCurr)
    <=> v74795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6992,axiom,
    ! [VarCurr: state_type] :
      ( v74795(VarCurr)
    <=> ( v74809(VarCurr)
      <~> v74805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6991,axiom,
    ! [VarCurr: state_type] :
      ( v74809(VarCurr)
    <=> ( v74797(VarCurr)
      <~> v74801(VarCurr) ) ) ).

tff(addAssignment_47013,axiom,
    ! [VarCurr: state_type] :
      ( v74805(VarCurr)
    <=> v74807(VarCurr) ) ).

tff(addAssignment_47012,axiom,
    ! [VarCurr: state_type] :
      ( v74807(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_47011,axiom,
    ! [VarCurr: state_type] :
      ( v74801(VarCurr)
    <=> v74803(VarCurr) ) ).

tff(addAssignment_47010,axiom,
    ! [VarCurr: state_type] :
      ( v74803(VarCurr)
    <=> v67349(VarCurr,104) ) ).

tff(addAssignment_47009,axiom,
    ! [VarCurr: state_type] :
      ( v74797(VarCurr)
    <=> v74799(VarCurr) ) ).

tff(addAssignment_47008,axiom,
    ! [VarCurr: state_type] :
      ( v74799(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_47007,axiom,
    ! [VarCurr: state_type] :
      ( v74763(VarCurr)
    <=> v74765(VarCurr) ) ).

tff(addAssignment_47006,axiom,
    ! [VarCurr: state_type] :
      ( v74765(VarCurr)
    <=> v74767(VarCurr) ) ).

tff(addAssignment_47005,axiom,
    ! [VarCurr: state_type] :
      ( v74767(VarCurr)
    <=> v74769(VarCurr) ) ).

tff(addAssignment_47004,axiom,
    ! [VarCurr: state_type] :
      ( v74769(VarCurr)
    <=> v74771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6990,axiom,
    ! [VarCurr: state_type] :
      ( v74771(VarCurr)
    <=> ( v74785(VarCurr)
      <~> v74781(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6989,axiom,
    ! [VarCurr: state_type] :
      ( v74785(VarCurr)
    <=> ( v74773(VarCurr)
      <~> v74777(VarCurr) ) ) ).

tff(addAssignment_47003,axiom,
    ! [VarCurr: state_type] :
      ( v74781(VarCurr)
    <=> v74783(VarCurr) ) ).

tff(addAssignment_47002,axiom,
    ! [VarCurr: state_type] :
      ( v74783(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_47001,axiom,
    ! [VarCurr: state_type] :
      ( v74777(VarCurr)
    <=> v74779(VarCurr) ) ).

tff(addAssignment_47000,axiom,
    ! [VarCurr: state_type] :
      ( v74779(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_46999,axiom,
    ! [VarCurr: state_type] :
      ( v74773(VarCurr)
    <=> v74775(VarCurr) ) ).

tff(addAssignment_46998,axiom,
    ! [VarCurr: state_type] :
      ( v74775(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_46997,axiom,
    ! [VarCurr: state_type] :
      ( v74739(VarCurr)
    <=> v74741(VarCurr) ) ).

tff(addAssignment_46996,axiom,
    ! [VarCurr: state_type] :
      ( v74741(VarCurr)
    <=> v74743(VarCurr) ) ).

tff(addAssignment_46995,axiom,
    ! [VarCurr: state_type] :
      ( v74743(VarCurr)
    <=> v74745(VarCurr) ) ).

tff(addAssignment_46994,axiom,
    ! [VarCurr: state_type] :
      ( v74745(VarCurr)
    <=> v74747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6988,axiom,
    ! [VarCurr: state_type] :
      ( v74747(VarCurr)
    <=> ( v74761(VarCurr)
      <~> v74757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6987,axiom,
    ! [VarCurr: state_type] :
      ( v74761(VarCurr)
    <=> ( v74749(VarCurr)
      <~> v74753(VarCurr) ) ) ).

tff(addAssignment_46993,axiom,
    ! [VarCurr: state_type] :
      ( v74757(VarCurr)
    <=> v74759(VarCurr) ) ).

tff(addAssignment_46992,axiom,
    ! [VarCurr: state_type] :
      ( v74759(VarCurr)
    <=> v67349(VarCurr,96) ) ).

tff(addAssignment_46991,axiom,
    ! [VarCurr: state_type] :
      ( v74753(VarCurr)
    <=> v74755(VarCurr) ) ).

tff(addAssignment_46990,axiom,
    ! [VarCurr: state_type] :
      ( v74755(VarCurr)
    <=> v67349(VarCurr,92) ) ).

tff(addAssignment_46989,axiom,
    ! [VarCurr: state_type] :
      ( v74749(VarCurr)
    <=> v74751(VarCurr) ) ).

tff(addAssignment_46988,axiom,
    ! [VarCurr: state_type] :
      ( v74751(VarCurr)
    <=> v67349(VarCurr,91) ) ).

tff(addAssignment_46987,axiom,
    ! [VarCurr: state_type] :
      ( v74645(VarCurr)
    <=> v74647(VarCurr) ) ).

tff(addAssignment_46986,axiom,
    ! [VarCurr: state_type] :
      ( v74647(VarCurr)
    <=> v74649(VarCurr) ) ).

tff(addAssignment_46985,axiom,
    ! [VarCurr: state_type] :
      ( v74649(VarCurr)
    <=> v74651(VarCurr) ) ).

tff(addAssignment_46984,axiom,
    ! [VarCurr: state_type] :
      ( v74651(VarCurr)
    <=> v74653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6986,axiom,
    ! [VarCurr: state_type] :
      ( v74653(VarCurr)
    <=> ( v74727(VarCurr)
      <~> v74703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6985,axiom,
    ! [VarCurr: state_type] :
      ( v74727(VarCurr)
    <=> ( v74655(VarCurr)
      <~> v74679(VarCurr) ) ) ).

tff(addAssignment_46983,axiom,
    ! [VarCurr: state_type] :
      ( v74703(VarCurr)
    <=> v74705(VarCurr) ) ).

tff(addAssignment_46982,axiom,
    ! [VarCurr: state_type] :
      ( v74705(VarCurr)
    <=> v74707(VarCurr) ) ).

tff(addAssignment_46981,axiom,
    ! [VarCurr: state_type] :
      ( v74707(VarCurr)
    <=> v74709(VarCurr) ) ).

tff(addAssignment_46980,axiom,
    ! [VarCurr: state_type] :
      ( v74709(VarCurr)
    <=> v74711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6984,axiom,
    ! [VarCurr: state_type] :
      ( v74711(VarCurr)
    <=> ( v74725(VarCurr)
      <~> v74721(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6983,axiom,
    ! [VarCurr: state_type] :
      ( v74725(VarCurr)
    <=> ( v74713(VarCurr)
      <~> v74717(VarCurr) ) ) ).

tff(addAssignment_46979,axiom,
    ! [VarCurr: state_type] :
      ( v74721(VarCurr)
    <=> v74723(VarCurr) ) ).

tff(addAssignment_46978,axiom,
    ! [VarCurr: state_type] :
      ( v74723(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_46977,axiom,
    ! [VarCurr: state_type] :
      ( v74717(VarCurr)
    <=> v74719(VarCurr) ) ).

tff(addAssignment_46976,axiom,
    ! [VarCurr: state_type] :
      ( v74719(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_46975,axiom,
    ! [VarCurr: state_type] :
      ( v74713(VarCurr)
    <=> v74715(VarCurr) ) ).

tff(addAssignment_46974,axiom,
    ! [VarCurr: state_type] :
      ( v74715(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_46973,axiom,
    ! [VarCurr: state_type] :
      ( v74679(VarCurr)
    <=> v74681(VarCurr) ) ).

tff(addAssignment_46972,axiom,
    ! [VarCurr: state_type] :
      ( v74681(VarCurr)
    <=> v74683(VarCurr) ) ).

tff(addAssignment_46971,axiom,
    ! [VarCurr: state_type] :
      ( v74683(VarCurr)
    <=> v74685(VarCurr) ) ).

tff(addAssignment_46970,axiom,
    ! [VarCurr: state_type] :
      ( v74685(VarCurr)
    <=> v74687(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6982,axiom,
    ! [VarCurr: state_type] :
      ( v74687(VarCurr)
    <=> ( v74701(VarCurr)
      <~> v74697(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6981,axiom,
    ! [VarCurr: state_type] :
      ( v74701(VarCurr)
    <=> ( v74689(VarCurr)
      <~> v74693(VarCurr) ) ) ).

tff(addAssignment_46969,axiom,
    ! [VarCurr: state_type] :
      ( v74697(VarCurr)
    <=> v74699(VarCurr) ) ).

tff(addAssignment_46968,axiom,
    ! [VarCurr: state_type] :
      ( v74699(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_46967,axiom,
    ! [VarCurr: state_type] :
      ( v74693(VarCurr)
    <=> v74695(VarCurr) ) ).

tff(addAssignment_46966,axiom,
    ! [VarCurr: state_type] :
      ( v74695(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_46965,axiom,
    ! [VarCurr: state_type] :
      ( v74689(VarCurr)
    <=> v74691(VarCurr) ) ).

tff(addAssignment_46964,axiom,
    ! [VarCurr: state_type] :
      ( v74691(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_46963,axiom,
    ! [VarCurr: state_type] :
      ( v74655(VarCurr)
    <=> v74657(VarCurr) ) ).

tff(addAssignment_46962,axiom,
    ! [VarCurr: state_type] :
      ( v74657(VarCurr)
    <=> v74659(VarCurr) ) ).

tff(addAssignment_46961,axiom,
    ! [VarCurr: state_type] :
      ( v74659(VarCurr)
    <=> v74661(VarCurr) ) ).

tff(addAssignment_46960,axiom,
    ! [VarCurr: state_type] :
      ( v74661(VarCurr)
    <=> v74663(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6980,axiom,
    ! [VarCurr: state_type] :
      ( v74663(VarCurr)
    <=> ( v74677(VarCurr)
      <~> v74673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6979,axiom,
    ! [VarCurr: state_type] :
      ( v74677(VarCurr)
    <=> ( v74665(VarCurr)
      <~> v74669(VarCurr) ) ) ).

tff(addAssignment_46959,axiom,
    ! [VarCurr: state_type] :
      ( v74673(VarCurr)
    <=> v74675(VarCurr) ) ).

tff(addAssignment_46958,axiom,
    ! [VarCurr: state_type] :
      ( v74675(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_46957,axiom,
    ! [VarCurr: state_type] :
      ( v74669(VarCurr)
    <=> v74671(VarCurr) ) ).

tff(addAssignment_46956,axiom,
    ! [VarCurr: state_type] :
      ( v74671(VarCurr)
    <=> v67349(VarCurr,77) ) ).

tff(addAssignment_46955,axiom,
    ! [VarCurr: state_type] :
      ( v74665(VarCurr)
    <=> v74667(VarCurr) ) ).

tff(addAssignment_46954,axiom,
    ! [VarCurr: state_type] :
      ( v74667(VarCurr)
    <=> v67349(VarCurr,73) ) ).

tff(addAssignment_46953,axiom,
    ! [VarCurr: state_type] :
      ( v74561(VarCurr)
    <=> v74563(VarCurr) ) ).

tff(addAssignment_46952,axiom,
    ! [VarCurr: state_type] :
      ( v74563(VarCurr)
    <=> v74565(VarCurr) ) ).

tff(addAssignment_46951,axiom,
    ! [VarCurr: state_type] :
      ( v74565(VarCurr)
    <=> v74567(VarCurr) ) ).

tff(addAssignment_46950,axiom,
    ! [VarCurr: state_type] :
      ( v74567(VarCurr)
    <=> v74569(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6978,axiom,
    ! [VarCurr: state_type] :
      ( v74569(VarCurr)
    <=> ( v74643(VarCurr)
      <~> v74619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6977,axiom,
    ! [VarCurr: state_type] :
      ( v74643(VarCurr)
    <=> ( v74571(VarCurr)
      <~> v74595(VarCurr) ) ) ).

tff(addAssignment_46949,axiom,
    ! [VarCurr: state_type] :
      ( v74619(VarCurr)
    <=> v74621(VarCurr) ) ).

tff(addAssignment_46948,axiom,
    ! [VarCurr: state_type] :
      ( v74621(VarCurr)
    <=> v74623(VarCurr) ) ).

tff(addAssignment_46947,axiom,
    ! [VarCurr: state_type] :
      ( v74623(VarCurr)
    <=> v74625(VarCurr) ) ).

tff(addAssignment_46946,axiom,
    ! [VarCurr: state_type] :
      ( v74625(VarCurr)
    <=> v74627(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6976,axiom,
    ! [VarCurr: state_type] :
      ( v74627(VarCurr)
    <=> ( v74641(VarCurr)
      <~> v74637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6975,axiom,
    ! [VarCurr: state_type] :
      ( v74641(VarCurr)
    <=> ( v74629(VarCurr)
      <~> v74633(VarCurr) ) ) ).

tff(addAssignment_46945,axiom,
    ! [VarCurr: state_type] :
      ( v74637(VarCurr)
    <=> v74639(VarCurr) ) ).

tff(addAssignment_46944,axiom,
    ! [VarCurr: state_type] :
      ( v74639(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_46943,axiom,
    ! [VarCurr: state_type] :
      ( v74633(VarCurr)
    <=> v74635(VarCurr) ) ).

tff(addAssignment_46942,axiom,
    ! [VarCurr: state_type] :
      ( v74635(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_46941,axiom,
    ! [VarCurr: state_type] :
      ( v74629(VarCurr)
    <=> v74631(VarCurr) ) ).

tff(addAssignment_46940,axiom,
    ! [VarCurr: state_type] :
      ( v74631(VarCurr)
    <=> v67349(VarCurr,66) ) ).

tff(addAssignment_46939,axiom,
    ! [VarCurr: state_type] :
      ( v74595(VarCurr)
    <=> v74597(VarCurr) ) ).

tff(addAssignment_46938,axiom,
    ! [VarCurr: state_type] :
      ( v74597(VarCurr)
    <=> v74599(VarCurr) ) ).

tff(addAssignment_46937,axiom,
    ! [VarCurr: state_type] :
      ( v74599(VarCurr)
    <=> v74601(VarCurr) ) ).

tff(addAssignment_46936,axiom,
    ! [VarCurr: state_type] :
      ( v74601(VarCurr)
    <=> v74603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6974,axiom,
    ! [VarCurr: state_type] :
      ( v74603(VarCurr)
    <=> ( v74617(VarCurr)
      <~> v74613(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6973,axiom,
    ! [VarCurr: state_type] :
      ( v74617(VarCurr)
    <=> ( v74605(VarCurr)
      <~> v74609(VarCurr) ) ) ).

tff(addAssignment_46935,axiom,
    ! [VarCurr: state_type] :
      ( v74613(VarCurr)
    <=> v74615(VarCurr) ) ).

tff(addAssignment_46934,axiom,
    ! [VarCurr: state_type] :
      ( v74615(VarCurr)
    <=> v67349(VarCurr,63) ) ).

tff(addAssignment_46933,axiom,
    ! [VarCurr: state_type] :
      ( v74609(VarCurr)
    <=> v74611(VarCurr) ) ).

tff(addAssignment_46932,axiom,
    ! [VarCurr: state_type] :
      ( v74611(VarCurr)
    <=> v67349(VarCurr,58) ) ).

tff(addAssignment_46931,axiom,
    ! [VarCurr: state_type] :
      ( v74605(VarCurr)
    <=> v74607(VarCurr) ) ).

tff(addAssignment_46930,axiom,
    ! [VarCurr: state_type] :
      ( v74607(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_46929,axiom,
    ! [VarCurr: state_type] :
      ( v74571(VarCurr)
    <=> v74573(VarCurr) ) ).

tff(addAssignment_46928,axiom,
    ! [VarCurr: state_type] :
      ( v74573(VarCurr)
    <=> v74575(VarCurr) ) ).

tff(addAssignment_46927,axiom,
    ! [VarCurr: state_type] :
      ( v74575(VarCurr)
    <=> v74577(VarCurr) ) ).

tff(addAssignment_46926,axiom,
    ! [VarCurr: state_type] :
      ( v74577(VarCurr)
    <=> v74579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6972,axiom,
    ! [VarCurr: state_type] :
      ( v74579(VarCurr)
    <=> ( v74593(VarCurr)
      <~> v74589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6971,axiom,
    ! [VarCurr: state_type] :
      ( v74593(VarCurr)
    <=> ( v74581(VarCurr)
      <~> v74585(VarCurr) ) ) ).

tff(addAssignment_46925,axiom,
    ! [VarCurr: state_type] :
      ( v74589(VarCurr)
    <=> v74591(VarCurr) ) ).

tff(addAssignment_46924,axiom,
    ! [VarCurr: state_type] :
      ( v74591(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_46923,axiom,
    ! [VarCurr: state_type] :
      ( v74585(VarCurr)
    <=> v74587(VarCurr) ) ).

tff(addAssignment_46922,axiom,
    ! [VarCurr: state_type] :
      ( v74587(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_46921,axiom,
    ! [VarCurr: state_type] :
      ( v74581(VarCurr)
    <=> v74583(VarCurr) ) ).

tff(addAssignment_46920,axiom,
    ! [VarCurr: state_type] :
      ( v74583(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_46919,axiom,
    ! [VarCurr: state_type] :
      ( v74287(VarCurr)
    <=> v74289(VarCurr) ) ).

tff(addAssignment_46918,axiom,
    ! [VarCurr: state_type] :
      ( v74289(VarCurr)
    <=> v74291(VarCurr) ) ).

tff(addAssignment_46917,axiom,
    ! [VarCurr: state_type] :
      ( v74291(VarCurr)
    <=> v74293(VarCurr) ) ).

tff(addAssignment_46916,axiom,
    ! [VarCurr: state_type] :
      ( v74293(VarCurr)
    <=> v74295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6970,axiom,
    ! [VarCurr: state_type] :
      ( v74295(VarCurr)
    <=> ( v74549(VarCurr)
      <~> v74465(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6969,axiom,
    ! [VarCurr: state_type] :
      ( v74549(VarCurr)
    <=> ( v74297(VarCurr)
      <~> v74381(VarCurr) ) ) ).

tff(addAssignment_46915,axiom,
    ! [VarCurr: state_type] :
      ( v74465(VarCurr)
    <=> v74467(VarCurr) ) ).

tff(addAssignment_46914,axiom,
    ! [VarCurr: state_type] :
      ( v74467(VarCurr)
    <=> v74469(VarCurr) ) ).

tff(addAssignment_46913,axiom,
    ! [VarCurr: state_type] :
      ( v74469(VarCurr)
    <=> v74471(VarCurr) ) ).

tff(addAssignment_46912,axiom,
    ! [VarCurr: state_type] :
      ( v74471(VarCurr)
    <=> v74473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6968,axiom,
    ! [VarCurr: state_type] :
      ( v74473(VarCurr)
    <=> ( v74547(VarCurr)
      <~> v74523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6967,axiom,
    ! [VarCurr: state_type] :
      ( v74547(VarCurr)
    <=> ( v74475(VarCurr)
      <~> v74499(VarCurr) ) ) ).

tff(addAssignment_46911,axiom,
    ! [VarCurr: state_type] :
      ( v74523(VarCurr)
    <=> v74525(VarCurr) ) ).

tff(addAssignment_46910,axiom,
    ! [VarCurr: state_type] :
      ( v74525(VarCurr)
    <=> v74527(VarCurr) ) ).

tff(addAssignment_46909,axiom,
    ! [VarCurr: state_type] :
      ( v74527(VarCurr)
    <=> v74529(VarCurr) ) ).

tff(addAssignment_46908,axiom,
    ! [VarCurr: state_type] :
      ( v74529(VarCurr)
    <=> v74531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6966,axiom,
    ! [VarCurr: state_type] :
      ( v74531(VarCurr)
    <=> ( v74545(VarCurr)
      <~> v74541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6965,axiom,
    ! [VarCurr: state_type] :
      ( v74545(VarCurr)
    <=> ( v74533(VarCurr)
      <~> v74537(VarCurr) ) ) ).

tff(addAssignment_46907,axiom,
    ! [VarCurr: state_type] :
      ( v74541(VarCurr)
    <=> v74543(VarCurr) ) ).

tff(addAssignment_46906,axiom,
    ! [VarCurr: state_type] :
      ( v74543(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_46905,axiom,
    ! [VarCurr: state_type] :
      ( v74537(VarCurr)
    <=> v74539(VarCurr) ) ).

tff(addAssignment_46904,axiom,
    ! [VarCurr: state_type] :
      ( v74539(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_46903,axiom,
    ! [VarCurr: state_type] :
      ( v74533(VarCurr)
    <=> v74535(VarCurr) ) ).

tff(addAssignment_46902,axiom,
    ! [VarCurr: state_type] :
      ( v74535(VarCurr)
    <=> v67349(VarCurr,49) ) ).

tff(addAssignment_46901,axiom,
    ! [VarCurr: state_type] :
      ( v74499(VarCurr)
    <=> v74501(VarCurr) ) ).

tff(addAssignment_46900,axiom,
    ! [VarCurr: state_type] :
      ( v74501(VarCurr)
    <=> v74503(VarCurr) ) ).

tff(addAssignment_46899,axiom,
    ! [VarCurr: state_type] :
      ( v74503(VarCurr)
    <=> v74505(VarCurr) ) ).

tff(addAssignment_46898,axiom,
    ! [VarCurr: state_type] :
      ( v74505(VarCurr)
    <=> v74507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6964,axiom,
    ! [VarCurr: state_type] :
      ( v74507(VarCurr)
    <=> ( v74521(VarCurr)
      <~> v74517(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6963,axiom,
    ! [VarCurr: state_type] :
      ( v74521(VarCurr)
    <=> ( v74509(VarCurr)
      <~> v74513(VarCurr) ) ) ).

tff(addAssignment_46897,axiom,
    ! [VarCurr: state_type] :
      ( v74517(VarCurr)
    <=> v74519(VarCurr) ) ).

tff(addAssignment_46896,axiom,
    ! [VarCurr: state_type] :
      ( v74519(VarCurr)
    <=> v67349(VarCurr,48) ) ).

tff(addAssignment_46895,axiom,
    ! [VarCurr: state_type] :
      ( v74513(VarCurr)
    <=> v74515(VarCurr) ) ).

tff(addAssignment_46894,axiom,
    ! [VarCurr: state_type] :
      ( v74515(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_46893,axiom,
    ! [VarCurr: state_type] :
      ( v74509(VarCurr)
    <=> v74511(VarCurr) ) ).

tff(addAssignment_46892,axiom,
    ! [VarCurr: state_type] :
      ( v74511(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_46891,axiom,
    ! [VarCurr: state_type] :
      ( v74475(VarCurr)
    <=> v74477(VarCurr) ) ).

tff(addAssignment_46890,axiom,
    ! [VarCurr: state_type] :
      ( v74477(VarCurr)
    <=> v74479(VarCurr) ) ).

tff(addAssignment_46889,axiom,
    ! [VarCurr: state_type] :
      ( v74479(VarCurr)
    <=> v74481(VarCurr) ) ).

tff(addAssignment_46888,axiom,
    ! [VarCurr: state_type] :
      ( v74481(VarCurr)
    <=> v74483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6962,axiom,
    ! [VarCurr: state_type] :
      ( v74483(VarCurr)
    <=> ( v74497(VarCurr)
      <~> v74493(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6961,axiom,
    ! [VarCurr: state_type] :
      ( v74497(VarCurr)
    <=> ( v74485(VarCurr)
      <~> v74489(VarCurr) ) ) ).

tff(addAssignment_46887,axiom,
    ! [VarCurr: state_type] :
      ( v74493(VarCurr)
    <=> v74495(VarCurr) ) ).

tff(addAssignment_46886,axiom,
    ! [VarCurr: state_type] :
      ( v74495(VarCurr)
    <=> v67349(VarCurr,44) ) ).

tff(addAssignment_46885,axiom,
    ! [VarCurr: state_type] :
      ( v74489(VarCurr)
    <=> v74491(VarCurr) ) ).

tff(addAssignment_46884,axiom,
    ! [VarCurr: state_type] :
      ( v74491(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_46883,axiom,
    ! [VarCurr: state_type] :
      ( v74485(VarCurr)
    <=> v74487(VarCurr) ) ).

tff(addAssignment_46882,axiom,
    ! [VarCurr: state_type] :
      ( v74487(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_46881,axiom,
    ! [VarCurr: state_type] :
      ( v74381(VarCurr)
    <=> v74383(VarCurr) ) ).

tff(addAssignment_46880,axiom,
    ! [VarCurr: state_type] :
      ( v74383(VarCurr)
    <=> v74385(VarCurr) ) ).

tff(addAssignment_46879,axiom,
    ! [VarCurr: state_type] :
      ( v74385(VarCurr)
    <=> v74387(VarCurr) ) ).

tff(addAssignment_46878,axiom,
    ! [VarCurr: state_type] :
      ( v74387(VarCurr)
    <=> v74389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6960,axiom,
    ! [VarCurr: state_type] :
      ( v74389(VarCurr)
    <=> ( v74463(VarCurr)
      <~> v74439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6959,axiom,
    ! [VarCurr: state_type] :
      ( v74463(VarCurr)
    <=> ( v74391(VarCurr)
      <~> v74415(VarCurr) ) ) ).

tff(addAssignment_46877,axiom,
    ! [VarCurr: state_type] :
      ( v74439(VarCurr)
    <=> v74441(VarCurr) ) ).

tff(addAssignment_46876,axiom,
    ! [VarCurr: state_type] :
      ( v74441(VarCurr)
    <=> v74443(VarCurr) ) ).

tff(addAssignment_46875,axiom,
    ! [VarCurr: state_type] :
      ( v74443(VarCurr)
    <=> v74445(VarCurr) ) ).

tff(addAssignment_46874,axiom,
    ! [VarCurr: state_type] :
      ( v74445(VarCurr)
    <=> v74447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6958,axiom,
    ! [VarCurr: state_type] :
      ( v74447(VarCurr)
    <=> ( v74461(VarCurr)
      <~> v74457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6957,axiom,
    ! [VarCurr: state_type] :
      ( v74461(VarCurr)
    <=> ( v74449(VarCurr)
      <~> v74453(VarCurr) ) ) ).

tff(addAssignment_46873,axiom,
    ! [VarCurr: state_type] :
      ( v74457(VarCurr)
    <=> v74459(VarCurr) ) ).

tff(addAssignment_46872,axiom,
    ! [VarCurr: state_type] :
      ( v74459(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_46871,axiom,
    ! [VarCurr: state_type] :
      ( v74453(VarCurr)
    <=> v74455(VarCurr) ) ).

tff(addAssignment_46870,axiom,
    ! [VarCurr: state_type] :
      ( v74455(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_46869,axiom,
    ! [VarCurr: state_type] :
      ( v74449(VarCurr)
    <=> v74451(VarCurr) ) ).

tff(addAssignment_46868,axiom,
    ! [VarCurr: state_type] :
      ( v74451(VarCurr)
    <=> v67349(VarCurr,36) ) ).

tff(addAssignment_46867,axiom,
    ! [VarCurr: state_type] :
      ( v74415(VarCurr)
    <=> v74417(VarCurr) ) ).

tff(addAssignment_46866,axiom,
    ! [VarCurr: state_type] :
      ( v74417(VarCurr)
    <=> v74419(VarCurr) ) ).

tff(addAssignment_46865,axiom,
    ! [VarCurr: state_type] :
      ( v74419(VarCurr)
    <=> v74421(VarCurr) ) ).

tff(addAssignment_46864,axiom,
    ! [VarCurr: state_type] :
      ( v74421(VarCurr)
    <=> v74423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6956,axiom,
    ! [VarCurr: state_type] :
      ( v74423(VarCurr)
    <=> ( v74437(VarCurr)
      <~> v74433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6955,axiom,
    ! [VarCurr: state_type] :
      ( v74437(VarCurr)
    <=> ( v74425(VarCurr)
      <~> v74429(VarCurr) ) ) ).

tff(addAssignment_46863,axiom,
    ! [VarCurr: state_type] :
      ( v74433(VarCurr)
    <=> v74435(VarCurr) ) ).

tff(addAssignment_46862,axiom,
    ! [VarCurr: state_type] :
      ( v74435(VarCurr)
    <=> v67349(VarCurr,32) ) ).

tff(addAssignment_46861,axiom,
    ! [VarCurr: state_type] :
      ( v74429(VarCurr)
    <=> v74431(VarCurr) ) ).

tff(addAssignment_46860,axiom,
    ! [VarCurr: state_type] :
      ( v74431(VarCurr)
    <=> v67349(VarCurr,31) ) ).

tff(addAssignment_46859,axiom,
    ! [VarCurr: state_type] :
      ( v74425(VarCurr)
    <=> v74427(VarCurr) ) ).

tff(addAssignment_46858,axiom,
    ! [VarCurr: state_type] :
      ( v74427(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_46857,axiom,
    ! [VarCurr: state_type] :
      ( v74391(VarCurr)
    <=> v74393(VarCurr) ) ).

tff(addAssignment_46856,axiom,
    ! [VarCurr: state_type] :
      ( v74393(VarCurr)
    <=> v74395(VarCurr) ) ).

tff(addAssignment_46855,axiom,
    ! [VarCurr: state_type] :
      ( v74395(VarCurr)
    <=> v74397(VarCurr) ) ).

tff(addAssignment_46854,axiom,
    ! [VarCurr: state_type] :
      ( v74397(VarCurr)
    <=> v74399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6954,axiom,
    ! [VarCurr: state_type] :
      ( v74399(VarCurr)
    <=> ( v74413(VarCurr)
      <~> v74409(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6953,axiom,
    ! [VarCurr: state_type] :
      ( v74413(VarCurr)
    <=> ( v74401(VarCurr)
      <~> v74405(VarCurr) ) ) ).

tff(addAssignment_46853,axiom,
    ! [VarCurr: state_type] :
      ( v74409(VarCurr)
    <=> v74411(VarCurr) ) ).

tff(addAssignment_46852,axiom,
    ! [VarCurr: state_type] :
      ( v74411(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_46851,axiom,
    ! [VarCurr: state_type] :
      ( v74405(VarCurr)
    <=> v74407(VarCurr) ) ).

tff(addAssignment_46850,axiom,
    ! [VarCurr: state_type] :
      ( v74407(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_46849,axiom,
    ! [VarCurr: state_type] :
      ( v74401(VarCurr)
    <=> v74403(VarCurr) ) ).

tff(addAssignment_46848,axiom,
    ! [VarCurr: state_type] :
      ( v74403(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_46847,axiom,
    ! [VarCurr: state_type] :
      ( v74297(VarCurr)
    <=> v74299(VarCurr) ) ).

tff(addAssignment_46846,axiom,
    ! [VarCurr: state_type] :
      ( v74299(VarCurr)
    <=> v74301(VarCurr) ) ).

tff(addAssignment_46845,axiom,
    ! [VarCurr: state_type] :
      ( v74301(VarCurr)
    <=> v74303(VarCurr) ) ).

tff(addAssignment_46844,axiom,
    ! [VarCurr: state_type] :
      ( v74303(VarCurr)
    <=> v74305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6952,axiom,
    ! [VarCurr: state_type] :
      ( v74305(VarCurr)
    <=> ( v74379(VarCurr)
      <~> v74355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6951,axiom,
    ! [VarCurr: state_type] :
      ( v74379(VarCurr)
    <=> ( v74307(VarCurr)
      <~> v74331(VarCurr) ) ) ).

tff(addAssignment_46843,axiom,
    ! [VarCurr: state_type] :
      ( v74355(VarCurr)
    <=> v74357(VarCurr) ) ).

tff(addAssignment_46842,axiom,
    ! [VarCurr: state_type] :
      ( v74357(VarCurr)
    <=> v74359(VarCurr) ) ).

tff(addAssignment_46841,axiom,
    ! [VarCurr: state_type] :
      ( v74359(VarCurr)
    <=> v74361(VarCurr) ) ).

tff(addAssignment_46840,axiom,
    ! [VarCurr: state_type] :
      ( v74361(VarCurr)
    <=> v74363(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6950,axiom,
    ! [VarCurr: state_type] :
      ( v74363(VarCurr)
    <=> ( v74377(VarCurr)
      <~> v74373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6949,axiom,
    ! [VarCurr: state_type] :
      ( v74377(VarCurr)
    <=> ( v74365(VarCurr)
      <~> v74369(VarCurr) ) ) ).

tff(addAssignment_46839,axiom,
    ! [VarCurr: state_type] :
      ( v74373(VarCurr)
    <=> v74375(VarCurr) ) ).

tff(addAssignment_46838,axiom,
    ! [VarCurr: state_type] :
      ( v74375(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_46837,axiom,
    ! [VarCurr: state_type] :
      ( v74369(VarCurr)
    <=> v74371(VarCurr) ) ).

tff(addAssignment_46836,axiom,
    ! [VarCurr: state_type] :
      ( v74371(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_46835,axiom,
    ! [VarCurr: state_type] :
      ( v74365(VarCurr)
    <=> v74367(VarCurr) ) ).

tff(addAssignment_46834,axiom,
    ! [VarCurr: state_type] :
      ( v74367(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_46833,axiom,
    ! [VarCurr: state_type] :
      ( v74331(VarCurr)
    <=> v74333(VarCurr) ) ).

tff(addAssignment_46832,axiom,
    ! [VarCurr: state_type] :
      ( v74333(VarCurr)
    <=> v74335(VarCurr) ) ).

tff(addAssignment_46831,axiom,
    ! [VarCurr: state_type] :
      ( v74335(VarCurr)
    <=> v74337(VarCurr) ) ).

tff(addAssignment_46830,axiom,
    ! [VarCurr: state_type] :
      ( v74337(VarCurr)
    <=> v74339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6948,axiom,
    ! [VarCurr: state_type] :
      ( v74339(VarCurr)
    <=> ( v74353(VarCurr)
      <~> v74349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6947,axiom,
    ! [VarCurr: state_type] :
      ( v74353(VarCurr)
    <=> ( v74341(VarCurr)
      <~> v74345(VarCurr) ) ) ).

tff(addAssignment_46829,axiom,
    ! [VarCurr: state_type] :
      ( v74349(VarCurr)
    <=> v74351(VarCurr) ) ).

tff(addAssignment_46828,axiom,
    ! [VarCurr: state_type] :
      ( v74351(VarCurr)
    <=> v67349(VarCurr,17) ) ).

tff(addAssignment_46827,axiom,
    ! [VarCurr: state_type] :
      ( v74345(VarCurr)
    <=> v74347(VarCurr) ) ).

tff(addAssignment_46826,axiom,
    ! [VarCurr: state_type] :
      ( v74347(VarCurr)
    <=> v67349(VarCurr,13) ) ).

tff(addAssignment_46825,axiom,
    ! [VarCurr: state_type] :
      ( v74341(VarCurr)
    <=> v74343(VarCurr) ) ).

tff(addAssignment_46824,axiom,
    ! [VarCurr: state_type] :
      ( v74343(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_46823,axiom,
    ! [VarCurr: state_type] :
      ( v74307(VarCurr)
    <=> v74309(VarCurr) ) ).

tff(addAssignment_46822,axiom,
    ! [VarCurr: state_type] :
      ( v74309(VarCurr)
    <=> v74311(VarCurr) ) ).

tff(addAssignment_46821,axiom,
    ! [VarCurr: state_type] :
      ( v74311(VarCurr)
    <=> v74313(VarCurr) ) ).

tff(addAssignment_46820,axiom,
    ! [VarCurr: state_type] :
      ( v74313(VarCurr)
    <=> v74315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6946,axiom,
    ! [VarCurr: state_type] :
      ( v74315(VarCurr)
    <=> ( v74329(VarCurr)
      <~> v74325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6945,axiom,
    ! [VarCurr: state_type] :
      ( v74329(VarCurr)
    <=> ( v74317(VarCurr)
      <~> v74321(VarCurr) ) ) ).

tff(addAssignment_46819,axiom,
    ! [VarCurr: state_type] :
      ( v74325(VarCurr)
    <=> v74327(VarCurr) ) ).

tff(addAssignment_46818,axiom,
    ! [VarCurr: state_type] :
      ( v74327(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_46817,axiom,
    ! [VarCurr: state_type] :
      ( v74321(VarCurr)
    <=> v74323(VarCurr) ) ).

tff(addAssignment_46816,axiom,
    ! [VarCurr: state_type] :
      ( v74323(VarCurr)
    <=> v67349(VarCurr,6) ) ).

tff(addAssignment_46815,axiom,
    ! [VarCurr: state_type] :
      ( v74317(VarCurr)
    <=> v74319(VarCurr) ) ).

tff(addAssignment_46814,axiom,
    ! [VarCurr: state_type] :
      ( v74319(VarCurr)
    <=> v67349(VarCurr,3) ) ).

tff(addAssignment_46813,axiom,
    ! [VarCurr: state_type] :
      ( v67253(VarCurr,3)
    <=> v67255(VarCurr,3) ) ).

tff(addAssignment_46812,axiom,
    ! [VarCurr: state_type] :
      ( v67255(VarCurr,3)
    <=> v74273(VarCurr,3) ) ).

tff(addAssignment_46811,axiom,
    ! [VarCurr: state_type] :
      ( v74273(VarCurr,0)
    <=> v74274(VarCurr) ) ).

tff(addAssignment_46810,axiom,
    ! [VarCurr: state_type] :
      ( v74273(VarCurr,1)
    <=> v74274(VarCurr) ) ).

tff(addAssignment_46809,axiom,
    ! [VarCurr: state_type] :
      ( v74273(VarCurr,2)
    <=> v74274(VarCurr) ) ).

tff(addAssignment_46808,axiom,
    ! [VarCurr: state_type] :
      ( v74273(VarCurr,3)
    <=> v74274(VarCurr) ) ).

tff(addAssignment_46807,axiom,
    ! [VarCurr: state_type] :
      ( v74274(VarCurr)
    <=> v67257(VarCurr) ) ).

tff(addAssignment_46806,axiom,
    ! [VarCurr: state_type] :
      ( v67257(VarCurr)
    <=> v67259(VarCurr) ) ).

tff(addAssignment_46805,axiom,
    ! [VarCurr: state_type] :
      ( v67259(VarCurr)
    <=> v67261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6944,axiom,
    ! [VarCurr: state_type] :
      ( v67261(VarCurr)
    <=> ( v67263(VarCurr)
        | v71516(VarCurr) ) ) ).

tff(addAssignment_46804,axiom,
    ! [VarCurr: state_type] :
      ( v71516(VarCurr)
    <=> v71518(VarCurr) ) ).

tff(addAssignment_46803,axiom,
    ! [VarCurr: state_type] :
      ( v71518(VarCurr)
    <=> v71520(VarCurr) ) ).

tff(addAssignment_46802,axiom,
    ! [VarCurr: state_type] :
      ( v71520(VarCurr)
    <=> v71522(VarCurr) ) ).

tff(addAssignment_46801,axiom,
    ! [VarCurr: state_type] :
      ( v71522(VarCurr)
    <=> v71524(VarCurr) ) ).

tff(writeUnaryOperator_3447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v71524(VarCurr)
    <=> v74271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6943,axiom,
    ! [VarCurr: state_type] :
      ( v74271(VarCurr)
    <=> ( v71526(VarCurr)
        | v74267(VarCurr) ) ) ).

tff(addAssignment_46800,axiom,
    ! [VarCurr: state_type] :
      ( v74267(VarCurr)
    <=> v74269(VarCurr) ) ).

tff(addAssignment_46799,axiom,
    ! [VarCurr: state_type] :
      ( v74269(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_46798,axiom,
    ! [VarCurr: state_type] :
      ( v71526(VarCurr)
    <=> v71528(VarCurr) ) ).

tff(addAssignment_46797,axiom,
    ! [VarCurr: state_type] :
      ( v71528(VarCurr)
    <=> v71530(VarCurr) ) ).

tff(addAssignment_46796,axiom,
    ! [VarCurr: state_type] :
      ( v71530(VarCurr)
    <=> v71532(VarCurr) ) ).

tff(addAssignment_46795,axiom,
    ! [VarCurr: state_type] :
      ( v71532(VarCurr)
    <=> v71534(VarCurr) ) ).

tff(writeUnaryOperator_3446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v71534(VarCurr)
    <=> v74265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6942,axiom,
    ! [VarCurr: state_type] :
      ( v74265(VarCurr)
    <=> ( v71536(VarCurr)
        | v74259(VarCurr) ) ) ).

tff(addAssignment_46794,axiom,
    ! [VarCurr: state_type] :
      ( v74259(VarCurr)
    <=> v74261(VarCurr) ) ).

tff(addAssignment_46793,axiom,
    ! [VarCurr: state_type] :
      ( v74261(VarCurr)
    <=> v74263(VarCurr) ) ).

tff(addAssignment_46792,axiom,
    ! [VarCurr: state_type] :
      ( v74263(VarCurr)
    <=> v59166(VarCurr) ) ).

tff(addAssignment_46791,axiom,
    ! [VarCurr: state_type] :
      ( v71536(VarCurr)
    <=> v71538(VarCurr) ) ).

tff(addAssignment_46790,axiom,
    ! [VarCurr: state_type] :
      ( v71538(VarCurr)
    <=> v71540(VarCurr) ) ).

tff(addAssignment_46789,axiom,
    ! [VarCurr: state_type] :
      ( v71540(VarCurr)
    <=> v71542(VarCurr) ) ).

tff(addAssignment_46788,axiom,
    ! [VarCurr: state_type] :
      ( v71542(VarCurr)
    <=> v71544(VarCurr) ) ).

tff(writeUnaryOperator_3445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v71544(VarCurr)
    <=> v74257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6941,axiom,
    ! [VarCurr: state_type] :
      ( v74257(VarCurr)
    <=> ( v71546(VarCurr)
        & v72905(VarCurr) ) ) ).

tff(addAssignment_46787,axiom,
    ! [VarCurr: state_type] :
      ( v72905(VarCurr)
    <=> v72907(VarCurr) ) ).

tff(addAssignment_46786,axiom,
    ! [VarCurr: state_type] :
      ( v72907(VarCurr)
    <=> v72909(VarCurr) ) ).

tff(addAssignment_46785,axiom,
    ! [VarCurr: state_type] :
      ( v72909(VarCurr)
    <=> v72911(VarCurr) ) ).

tff(addAssignment_46784,axiom,
    ! [VarCurr: state_type] :
      ( v72911(VarCurr)
    <=> v72913(VarCurr) ) ).

tff(writeUnaryOperator_3444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v72913(VarCurr)
    <=> v74255(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6940,axiom,
    ! [VarCurr: state_type] :
      ( v74255(VarCurr)
    <=> ( v72915(VarCurr)
        | v73585(VarCurr) ) ) ).

tff(addAssignment_46783,axiom,
    ! [VarCurr: state_type] :
      ( v73585(VarCurr)
    <=> v73587(VarCurr) ) ).

tff(addAssignment_46782,axiom,
    ! [VarCurr: state_type] :
      ( v73587(VarCurr)
    <=> v71560(VarCurr,0) ) ).

tff(addAssignment_46781,axiom,
    ! [VarCurr: state_type] :
      ( v71560(VarCurr,0)
    <=> v67309(VarCurr,0) ) ).

tff(addAssignment_46780,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,0)
    <=> v67311(VarCurr,0) ) ).

tff(addAssignment_46779,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,0)
    <=> v67313(VarCurr,0) ) ).

tff(addAssignment_46778,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,0)
    <=> v67315(VarCurr,0) ) ).

tff(addAssignment_46777,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,0)
    <=> v67317(VarCurr,0) ) ).

tff(addAssignment_46776,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,0)
    <=> v68771(VarCurr,0) ) ).

tff(addAssignment_46775,axiom,
    ! [VarCurr: state_type] :
      ( v68774(VarCurr,0)
    <=> v73589(VarCurr) ) ).

tff(addAssignment_46774,axiom,
    ! [VarCurr: state_type] :
      ( v73589(VarCurr)
    <=> v73591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6939,axiom,
    ! [VarCurr: state_type] :
      ( v73591(VarCurr)
    <=> ( v74253(VarCurr)
      <~> v74121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6938,axiom,
    ! [VarCurr: state_type] :
      ( v74253(VarCurr)
    <=> ( v73593(VarCurr)
      <~> v73857(VarCurr) ) ) ).

tff(addAssignment_46773,axiom,
    ! [VarCurr: state_type] :
      ( v74121(VarCurr)
    <=> v74123(VarCurr) ) ).

tff(addAssignment_46772,axiom,
    ! [VarCurr: state_type] :
      ( v74123(VarCurr)
    <=> v74125(VarCurr) ) ).

tff(addAssignment_46771,axiom,
    ! [VarCurr: state_type] :
      ( v74125(VarCurr)
    <=> v74127(VarCurr) ) ).

tff(addAssignment_46770,axiom,
    ! [VarCurr: state_type] :
      ( v74127(VarCurr)
    <=> v74129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6937,axiom,
    ! [VarCurr: state_type] :
      ( v74129(VarCurr)
    <=> ( v74251(VarCurr)
      <~> v74239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6936,axiom,
    ! [VarCurr: state_type] :
      ( v74251(VarCurr)
    <=> ( v74131(VarCurr)
      <~> v74155(VarCurr) ) ) ).

tff(addAssignment_46769,axiom,
    ! [VarCurr: state_type] :
      ( v74239(VarCurr)
    <=> v74241(VarCurr) ) ).

tff(addAssignment_46768,axiom,
    ! [VarCurr: state_type] :
      ( v74241(VarCurr)
    <=> v72217(VarCurr,0) ) ).

tff(addAssignment_46767,axiom,
    ! [VarCurr: state_type] :
      ( v72217(VarCurr,0)
    <=> v72219(VarCurr,0) ) ).

tff(addAssignment_46766,axiom,
    ! [VarCurr: state_type] :
      ( v72219(VarCurr,0)
    <=> v68595(VarCurr,1) ) ).

tff(addAssignment_46765,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,1)
    <=> v68597(VarCurr,1) ) ).

tff(addAssignment_46764,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,1)
    <=> v74243(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_905,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v74244(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v74243(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_905,axiom,
    ! [VarNext: state_type] :
      ( v74244(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v74243(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v74244(VarNext)
      <=> v74245(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v74245(VarNext)
      <=> ( v74247(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v74247(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_46763,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,1)
    <=> v68621(VarCurr,1) ) ).

tff(addAssignment_46762,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,1)
    <=> v68624(VarCurr,1) ) ).

tff(addAssignment_46761,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,0)
    <=> v68455(VarCurr,0) ) ).

tff(addAssignment_46760,axiom,
    ! [VarCurr: state_type] :
      ( v74155(VarCurr)
    <=> v74157(VarCurr) ) ).

tff(addAssignment_46759,axiom,
    ! [VarCurr: state_type] :
      ( v74157(VarCurr)
    <=> v74159(VarCurr) ) ).

tff(addAssignment_46758,axiom,
    ! [VarCurr: state_type] :
      ( v74159(VarCurr)
    <=> v74161(VarCurr) ) ).

tff(addAssignment_46757,axiom,
    ! [VarCurr: state_type] :
      ( v74161(VarCurr)
    <=> v74163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6933,axiom,
    ! [VarCurr: state_type] :
      ( v74163(VarCurr)
    <=> ( v74237(VarCurr)
      <~> v74213(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6932,axiom,
    ! [VarCurr: state_type] :
      ( v74237(VarCurr)
    <=> ( v74165(VarCurr)
      <~> v74189(VarCurr) ) ) ).

tff(addAssignment_46756,axiom,
    ! [VarCurr: state_type] :
      ( v74213(VarCurr)
    <=> v74215(VarCurr) ) ).

tff(addAssignment_46755,axiom,
    ! [VarCurr: state_type] :
      ( v74215(VarCurr)
    <=> v74217(VarCurr) ) ).

tff(addAssignment_46754,axiom,
    ! [VarCurr: state_type] :
      ( v74217(VarCurr)
    <=> v74219(VarCurr) ) ).

tff(addAssignment_46753,axiom,
    ! [VarCurr: state_type] :
      ( v74219(VarCurr)
    <=> v74221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6931,axiom,
    ! [VarCurr: state_type] :
      ( v74221(VarCurr)
    <=> ( v74235(VarCurr)
      <~> v74231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6930,axiom,
    ! [VarCurr: state_type] :
      ( v74235(VarCurr)
    <=> ( v74223(VarCurr)
      <~> v74227(VarCurr) ) ) ).

tff(addAssignment_46752,axiom,
    ! [VarCurr: state_type] :
      ( v74231(VarCurr)
    <=> v74233(VarCurr) ) ).

tff(addAssignment_46751,axiom,
    ! [VarCurr: state_type] :
      ( v74233(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_46750,axiom,
    ! [VarCurr: state_type] :
      ( v74227(VarCurr)
    <=> v74229(VarCurr) ) ).

tff(addAssignment_46749,axiom,
    ! [VarCurr: state_type] :
      ( v74229(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_46748,axiom,
    ! [VarCurr: state_type] :
      ( v74223(VarCurr)
    <=> v74225(VarCurr) ) ).

tff(addAssignment_46747,axiom,
    ! [VarCurr: state_type] :
      ( v74225(VarCurr)
    <=> v67349(VarCurr,110) ) ).

tff(addAssignment_46746,axiom,
    ! [VarCurr: state_type] :
      ( v74189(VarCurr)
    <=> v74191(VarCurr) ) ).

tff(addAssignment_46745,axiom,
    ! [VarCurr: state_type] :
      ( v74191(VarCurr)
    <=> v74193(VarCurr) ) ).

tff(addAssignment_46744,axiom,
    ! [VarCurr: state_type] :
      ( v74193(VarCurr)
    <=> v74195(VarCurr) ) ).

tff(addAssignment_46743,axiom,
    ! [VarCurr: state_type] :
      ( v74195(VarCurr)
    <=> v74197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6929,axiom,
    ! [VarCurr: state_type] :
      ( v74197(VarCurr)
    <=> ( v74211(VarCurr)
      <~> v74207(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6928,axiom,
    ! [VarCurr: state_type] :
      ( v74211(VarCurr)
    <=> ( v74199(VarCurr)
      <~> v74203(VarCurr) ) ) ).

tff(addAssignment_46742,axiom,
    ! [VarCurr: state_type] :
      ( v74207(VarCurr)
    <=> v74209(VarCurr) ) ).

tff(addAssignment_46741,axiom,
    ! [VarCurr: state_type] :
      ( v74209(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_46740,axiom,
    ! [VarCurr: state_type] :
      ( v74203(VarCurr)
    <=> v74205(VarCurr) ) ).

tff(addAssignment_46739,axiom,
    ! [VarCurr: state_type] :
      ( v74205(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_46738,axiom,
    ! [VarCurr: state_type] :
      ( v74199(VarCurr)
    <=> v74201(VarCurr) ) ).

tff(addAssignment_46737,axiom,
    ! [VarCurr: state_type] :
      ( v74201(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_46736,axiom,
    ! [VarCurr: state_type] :
      ( v74165(VarCurr)
    <=> v74167(VarCurr) ) ).

tff(addAssignment_46735,axiom,
    ! [VarCurr: state_type] :
      ( v74167(VarCurr)
    <=> v74169(VarCurr) ) ).

tff(addAssignment_46734,axiom,
    ! [VarCurr: state_type] :
      ( v74169(VarCurr)
    <=> v74171(VarCurr) ) ).

tff(addAssignment_46733,axiom,
    ! [VarCurr: state_type] :
      ( v74171(VarCurr)
    <=> v74173(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6927,axiom,
    ! [VarCurr: state_type] :
      ( v74173(VarCurr)
    <=> ( v74187(VarCurr)
      <~> v74183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6926,axiom,
    ! [VarCurr: state_type] :
      ( v74187(VarCurr)
    <=> ( v74175(VarCurr)
      <~> v74179(VarCurr) ) ) ).

tff(addAssignment_46732,axiom,
    ! [VarCurr: state_type] :
      ( v74183(VarCurr)
    <=> v74185(VarCurr) ) ).

tff(addAssignment_46731,axiom,
    ! [VarCurr: state_type] :
      ( v74185(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_46730,axiom,
    ! [VarCurr: state_type] :
      ( v74179(VarCurr)
    <=> v74181(VarCurr) ) ).

tff(addAssignment_46729,axiom,
    ! [VarCurr: state_type] :
      ( v74181(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_46728,axiom,
    ! [VarCurr: state_type] :
      ( v74175(VarCurr)
    <=> v74177(VarCurr) ) ).

tff(addAssignment_46727,axiom,
    ! [VarCurr: state_type] :
      ( v74177(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_46726,axiom,
    ! [VarCurr: state_type] :
      ( v74131(VarCurr)
    <=> v74133(VarCurr) ) ).

tff(addAssignment_46725,axiom,
    ! [VarCurr: state_type] :
      ( v74133(VarCurr)
    <=> v74135(VarCurr) ) ).

tff(addAssignment_46724,axiom,
    ! [VarCurr: state_type] :
      ( v74135(VarCurr)
    <=> v74137(VarCurr) ) ).

tff(addAssignment_46723,axiom,
    ! [VarCurr: state_type] :
      ( v74137(VarCurr)
    <=> v74139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6925,axiom,
    ! [VarCurr: state_type] :
      ( v74139(VarCurr)
    <=> ( v74153(VarCurr)
      <~> v74149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6924,axiom,
    ! [VarCurr: state_type] :
      ( v74153(VarCurr)
    <=> ( v74141(VarCurr)
      <~> v74145(VarCurr) ) ) ).

tff(addAssignment_46722,axiom,
    ! [VarCurr: state_type] :
      ( v74149(VarCurr)
    <=> v74151(VarCurr) ) ).

tff(addAssignment_46721,axiom,
    ! [VarCurr: state_type] :
      ( v74151(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_46720,axiom,
    ! [VarCurr: state_type] :
      ( v74145(VarCurr)
    <=> v74147(VarCurr) ) ).

tff(addAssignment_46719,axiom,
    ! [VarCurr: state_type] :
      ( v74147(VarCurr)
    <=> v67349(VarCurr,120) ) ).

tff(addAssignment_46718,axiom,
    ! [VarCurr: state_type] :
      ( v74141(VarCurr)
    <=> v74143(VarCurr) ) ).

tff(addAssignment_46717,axiom,
    ! [VarCurr: state_type] :
      ( v74143(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_46716,axiom,
    ! [VarCurr: state_type] :
      ( v73857(VarCurr)
    <=> v73859(VarCurr) ) ).

tff(addAssignment_46715,axiom,
    ! [VarCurr: state_type] :
      ( v73859(VarCurr)
    <=> v73861(VarCurr) ) ).

tff(addAssignment_46714,axiom,
    ! [VarCurr: state_type] :
      ( v73861(VarCurr)
    <=> v73863(VarCurr) ) ).

tff(addAssignment_46713,axiom,
    ! [VarCurr: state_type] :
      ( v73863(VarCurr)
    <=> v73865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6923,axiom,
    ! [VarCurr: state_type] :
      ( v73865(VarCurr)
    <=> ( v74119(VarCurr)
      <~> v74035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6922,axiom,
    ! [VarCurr: state_type] :
      ( v74119(VarCurr)
    <=> ( v73867(VarCurr)
      <~> v73951(VarCurr) ) ) ).

tff(addAssignment_46712,axiom,
    ! [VarCurr: state_type] :
      ( v74035(VarCurr)
    <=> v74037(VarCurr) ) ).

tff(addAssignment_46711,axiom,
    ! [VarCurr: state_type] :
      ( v74037(VarCurr)
    <=> v74039(VarCurr) ) ).

tff(addAssignment_46710,axiom,
    ! [VarCurr: state_type] :
      ( v74039(VarCurr)
    <=> v74041(VarCurr) ) ).

tff(addAssignment_46709,axiom,
    ! [VarCurr: state_type] :
      ( v74041(VarCurr)
    <=> v74043(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6921,axiom,
    ! [VarCurr: state_type] :
      ( v74043(VarCurr)
    <=> ( v74117(VarCurr)
      <~> v74093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6920,axiom,
    ! [VarCurr: state_type] :
      ( v74117(VarCurr)
    <=> ( v74045(VarCurr)
      <~> v74069(VarCurr) ) ) ).

tff(addAssignment_46708,axiom,
    ! [VarCurr: state_type] :
      ( v74093(VarCurr)
    <=> v74095(VarCurr) ) ).

tff(addAssignment_46707,axiom,
    ! [VarCurr: state_type] :
      ( v74095(VarCurr)
    <=> v74097(VarCurr) ) ).

tff(addAssignment_46706,axiom,
    ! [VarCurr: state_type] :
      ( v74097(VarCurr)
    <=> v74099(VarCurr) ) ).

tff(addAssignment_46705,axiom,
    ! [VarCurr: state_type] :
      ( v74099(VarCurr)
    <=> v74101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6919,axiom,
    ! [VarCurr: state_type] :
      ( v74101(VarCurr)
    <=> ( v74115(VarCurr)
      <~> v74111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6918,axiom,
    ! [VarCurr: state_type] :
      ( v74115(VarCurr)
    <=> ( v74103(VarCurr)
      <~> v74107(VarCurr) ) ) ).

tff(addAssignment_46704,axiom,
    ! [VarCurr: state_type] :
      ( v74111(VarCurr)
    <=> v74113(VarCurr) ) ).

tff(addAssignment_46703,axiom,
    ! [VarCurr: state_type] :
      ( v74113(VarCurr)
    <=> v67349(VarCurr,95) ) ).

tff(addAssignment_46702,axiom,
    ! [VarCurr: state_type] :
      ( v74107(VarCurr)
    <=> v74109(VarCurr) ) ).

tff(addAssignment_46701,axiom,
    ! [VarCurr: state_type] :
      ( v74109(VarCurr)
    <=> v67349(VarCurr,91) ) ).

tff(addAssignment_46700,axiom,
    ! [VarCurr: state_type] :
      ( v74103(VarCurr)
    <=> v74105(VarCurr) ) ).

tff(addAssignment_46699,axiom,
    ! [VarCurr: state_type] :
      ( v74105(VarCurr)
    <=> v67349(VarCurr,90) ) ).

tff(addAssignment_46698,axiom,
    ! [VarCurr: state_type] :
      ( v74069(VarCurr)
    <=> v74071(VarCurr) ) ).

tff(addAssignment_46697,axiom,
    ! [VarCurr: state_type] :
      ( v74071(VarCurr)
    <=> v74073(VarCurr) ) ).

tff(addAssignment_46696,axiom,
    ! [VarCurr: state_type] :
      ( v74073(VarCurr)
    <=> v74075(VarCurr) ) ).

tff(addAssignment_46695,axiom,
    ! [VarCurr: state_type] :
      ( v74075(VarCurr)
    <=> v74077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6917,axiom,
    ! [VarCurr: state_type] :
      ( v74077(VarCurr)
    <=> ( v74091(VarCurr)
      <~> v74087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6916,axiom,
    ! [VarCurr: state_type] :
      ( v74091(VarCurr)
    <=> ( v74079(VarCurr)
      <~> v74083(VarCurr) ) ) ).

tff(addAssignment_46694,axiom,
    ! [VarCurr: state_type] :
      ( v74087(VarCurr)
    <=> v74089(VarCurr) ) ).

tff(addAssignment_46693,axiom,
    ! [VarCurr: state_type] :
      ( v74089(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_46692,axiom,
    ! [VarCurr: state_type] :
      ( v74083(VarCurr)
    <=> v74085(VarCurr) ) ).

tff(addAssignment_46691,axiom,
    ! [VarCurr: state_type] :
      ( v74085(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_46690,axiom,
    ! [VarCurr: state_type] :
      ( v74079(VarCurr)
    <=> v74081(VarCurr) ) ).

tff(addAssignment_46689,axiom,
    ! [VarCurr: state_type] :
      ( v74081(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_46688,axiom,
    ! [VarCurr: state_type] :
      ( v74045(VarCurr)
    <=> v74047(VarCurr) ) ).

tff(addAssignment_46687,axiom,
    ! [VarCurr: state_type] :
      ( v74047(VarCurr)
    <=> v74049(VarCurr) ) ).

tff(addAssignment_46686,axiom,
    ! [VarCurr: state_type] :
      ( v74049(VarCurr)
    <=> v74051(VarCurr) ) ).

tff(addAssignment_46685,axiom,
    ! [VarCurr: state_type] :
      ( v74051(VarCurr)
    <=> v74053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6915,axiom,
    ! [VarCurr: state_type] :
      ( v74053(VarCurr)
    <=> ( v74067(VarCurr)
      <~> v74063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6914,axiom,
    ! [VarCurr: state_type] :
      ( v74067(VarCurr)
    <=> ( v74055(VarCurr)
      <~> v74059(VarCurr) ) ) ).

tff(addAssignment_46684,axiom,
    ! [VarCurr: state_type] :
      ( v74063(VarCurr)
    <=> v74065(VarCurr) ) ).

tff(addAssignment_46683,axiom,
    ! [VarCurr: state_type] :
      ( v74065(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_46682,axiom,
    ! [VarCurr: state_type] :
      ( v74059(VarCurr)
    <=> v74061(VarCurr) ) ).

tff(addAssignment_46681,axiom,
    ! [VarCurr: state_type] :
      ( v74061(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_46680,axiom,
    ! [VarCurr: state_type] :
      ( v74055(VarCurr)
    <=> v74057(VarCurr) ) ).

tff(addAssignment_46679,axiom,
    ! [VarCurr: state_type] :
      ( v74057(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_46678,axiom,
    ! [VarCurr: state_type] :
      ( v73951(VarCurr)
    <=> v73953(VarCurr) ) ).

tff(addAssignment_46677,axiom,
    ! [VarCurr: state_type] :
      ( v73953(VarCurr)
    <=> v73955(VarCurr) ) ).

tff(addAssignment_46676,axiom,
    ! [VarCurr: state_type] :
      ( v73955(VarCurr)
    <=> v73957(VarCurr) ) ).

tff(addAssignment_46675,axiom,
    ! [VarCurr: state_type] :
      ( v73957(VarCurr)
    <=> v73959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6913,axiom,
    ! [VarCurr: state_type] :
      ( v73959(VarCurr)
    <=> ( v74033(VarCurr)
      <~> v74009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6912,axiom,
    ! [VarCurr: state_type] :
      ( v74033(VarCurr)
    <=> ( v73961(VarCurr)
      <~> v73985(VarCurr) ) ) ).

tff(addAssignment_46674,axiom,
    ! [VarCurr: state_type] :
      ( v74009(VarCurr)
    <=> v74011(VarCurr) ) ).

tff(addAssignment_46673,axiom,
    ! [VarCurr: state_type] :
      ( v74011(VarCurr)
    <=> v74013(VarCurr) ) ).

tff(addAssignment_46672,axiom,
    ! [VarCurr: state_type] :
      ( v74013(VarCurr)
    <=> v74015(VarCurr) ) ).

tff(addAssignment_46671,axiom,
    ! [VarCurr: state_type] :
      ( v74015(VarCurr)
    <=> v74017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6911,axiom,
    ! [VarCurr: state_type] :
      ( v74017(VarCurr)
    <=> ( v74031(VarCurr)
      <~> v74027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6910,axiom,
    ! [VarCurr: state_type] :
      ( v74031(VarCurr)
    <=> ( v74019(VarCurr)
      <~> v74023(VarCurr) ) ) ).

tff(addAssignment_46670,axiom,
    ! [VarCurr: state_type] :
      ( v74027(VarCurr)
    <=> v74029(VarCurr) ) ).

tff(addAssignment_46669,axiom,
    ! [VarCurr: state_type] :
      ( v74029(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_46668,axiom,
    ! [VarCurr: state_type] :
      ( v74023(VarCurr)
    <=> v74025(VarCurr) ) ).

tff(addAssignment_46667,axiom,
    ! [VarCurr: state_type] :
      ( v74025(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_46666,axiom,
    ! [VarCurr: state_type] :
      ( v74019(VarCurr)
    <=> v74021(VarCurr) ) ).

tff(addAssignment_46665,axiom,
    ! [VarCurr: state_type] :
      ( v74021(VarCurr)
    <=> v67349(VarCurr,77) ) ).

tff(addAssignment_46664,axiom,
    ! [VarCurr: state_type] :
      ( v73985(VarCurr)
    <=> v73987(VarCurr) ) ).

tff(addAssignment_46663,axiom,
    ! [VarCurr: state_type] :
      ( v73987(VarCurr)
    <=> v73989(VarCurr) ) ).

tff(addAssignment_46662,axiom,
    ! [VarCurr: state_type] :
      ( v73989(VarCurr)
    <=> v73991(VarCurr) ) ).

tff(addAssignment_46661,axiom,
    ! [VarCurr: state_type] :
      ( v73991(VarCurr)
    <=> v73993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6909,axiom,
    ! [VarCurr: state_type] :
      ( v73993(VarCurr)
    <=> ( v74007(VarCurr)
      <~> v74003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6908,axiom,
    ! [VarCurr: state_type] :
      ( v74007(VarCurr)
    <=> ( v73995(VarCurr)
      <~> v73999(VarCurr) ) ) ).

tff(addAssignment_46660,axiom,
    ! [VarCurr: state_type] :
      ( v74003(VarCurr)
    <=> v74005(VarCurr) ) ).

tff(addAssignment_46659,axiom,
    ! [VarCurr: state_type] :
      ( v74005(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_46658,axiom,
    ! [VarCurr: state_type] :
      ( v73999(VarCurr)
    <=> v74001(VarCurr) ) ).

tff(addAssignment_46657,axiom,
    ! [VarCurr: state_type] :
      ( v74001(VarCurr)
    <=> v67349(VarCurr,74) ) ).

tff(addAssignment_46656,axiom,
    ! [VarCurr: state_type] :
      ( v73995(VarCurr)
    <=> v73997(VarCurr) ) ).

tff(addAssignment_46655,axiom,
    ! [VarCurr: state_type] :
      ( v73997(VarCurr)
    <=> v67349(VarCurr,73) ) ).

tff(addAssignment_46654,axiom,
    ! [VarCurr: state_type] :
      ( v73961(VarCurr)
    <=> v73963(VarCurr) ) ).

tff(addAssignment_46653,axiom,
    ! [VarCurr: state_type] :
      ( v73963(VarCurr)
    <=> v73965(VarCurr) ) ).

tff(addAssignment_46652,axiom,
    ! [VarCurr: state_type] :
      ( v73965(VarCurr)
    <=> v73967(VarCurr) ) ).

tff(addAssignment_46651,axiom,
    ! [VarCurr: state_type] :
      ( v73967(VarCurr)
    <=> v73969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6907,axiom,
    ! [VarCurr: state_type] :
      ( v73969(VarCurr)
    <=> ( v73983(VarCurr)
      <~> v73979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6906,axiom,
    ! [VarCurr: state_type] :
      ( v73983(VarCurr)
    <=> ( v73971(VarCurr)
      <~> v73975(VarCurr) ) ) ).

tff(addAssignment_46650,axiom,
    ! [VarCurr: state_type] :
      ( v73979(VarCurr)
    <=> v73981(VarCurr) ) ).

tff(addAssignment_46649,axiom,
    ! [VarCurr: state_type] :
      ( v73981(VarCurr)
    <=> v67349(VarCurr,72) ) ).

tff(addAssignment_46648,axiom,
    ! [VarCurr: state_type] :
      ( v73975(VarCurr)
    <=> v73977(VarCurr) ) ).

tff(addAssignment_46647,axiom,
    ! [VarCurr: state_type] :
      ( v73977(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_46646,axiom,
    ! [VarCurr: state_type] :
      ( v73971(VarCurr)
    <=> v73973(VarCurr) ) ).

tff(addAssignment_46645,axiom,
    ! [VarCurr: state_type] :
      ( v73973(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_46644,axiom,
    ! [VarCurr: state_type] :
      ( v73867(VarCurr)
    <=> v73869(VarCurr) ) ).

tff(addAssignment_46643,axiom,
    ! [VarCurr: state_type] :
      ( v73869(VarCurr)
    <=> v73871(VarCurr) ) ).

tff(addAssignment_46642,axiom,
    ! [VarCurr: state_type] :
      ( v73871(VarCurr)
    <=> v73873(VarCurr) ) ).

tff(addAssignment_46641,axiom,
    ! [VarCurr: state_type] :
      ( v73873(VarCurr)
    <=> v73875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6905,axiom,
    ! [VarCurr: state_type] :
      ( v73875(VarCurr)
    <=> ( v73949(VarCurr)
      <~> v73925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6904,axiom,
    ! [VarCurr: state_type] :
      ( v73949(VarCurr)
    <=> ( v73877(VarCurr)
      <~> v73901(VarCurr) ) ) ).

tff(addAssignment_46640,axiom,
    ! [VarCurr: state_type] :
      ( v73925(VarCurr)
    <=> v73927(VarCurr) ) ).

tff(addAssignment_46639,axiom,
    ! [VarCurr: state_type] :
      ( v73927(VarCurr)
    <=> v73929(VarCurr) ) ).

tff(addAssignment_46638,axiom,
    ! [VarCurr: state_type] :
      ( v73929(VarCurr)
    <=> v73931(VarCurr) ) ).

tff(addAssignment_46637,axiom,
    ! [VarCurr: state_type] :
      ( v73931(VarCurr)
    <=> v73933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6903,axiom,
    ! [VarCurr: state_type] :
      ( v73933(VarCurr)
    <=> ( v73947(VarCurr)
      <~> v73943(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6902,axiom,
    ! [VarCurr: state_type] :
      ( v73947(VarCurr)
    <=> ( v73935(VarCurr)
      <~> v73939(VarCurr) ) ) ).

tff(addAssignment_46636,axiom,
    ! [VarCurr: state_type] :
      ( v73943(VarCurr)
    <=> v73945(VarCurr) ) ).

tff(addAssignment_46635,axiom,
    ! [VarCurr: state_type] :
      ( v73945(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_46634,axiom,
    ! [VarCurr: state_type] :
      ( v73939(VarCurr)
    <=> v73941(VarCurr) ) ).

tff(addAssignment_46633,axiom,
    ! [VarCurr: state_type] :
      ( v73941(VarCurr)
    <=> v67349(VarCurr,65) ) ).

tff(addAssignment_46632,axiom,
    ! [VarCurr: state_type] :
      ( v73935(VarCurr)
    <=> v73937(VarCurr) ) ).

tff(addAssignment_46631,axiom,
    ! [VarCurr: state_type] :
      ( v73937(VarCurr)
    <=> v67349(VarCurr,64) ) ).

tff(addAssignment_46630,axiom,
    ! [VarCurr: state_type] :
      ( v73901(VarCurr)
    <=> v73903(VarCurr) ) ).

tff(addAssignment_46629,axiom,
    ! [VarCurr: state_type] :
      ( v73903(VarCurr)
    <=> v73905(VarCurr) ) ).

tff(addAssignment_46628,axiom,
    ! [VarCurr: state_type] :
      ( v73905(VarCurr)
    <=> v73907(VarCurr) ) ).

tff(addAssignment_46627,axiom,
    ! [VarCurr: state_type] :
      ( v73907(VarCurr)
    <=> v73909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6901,axiom,
    ! [VarCurr: state_type] :
      ( v73909(VarCurr)
    <=> ( v73923(VarCurr)
      <~> v73919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6900,axiom,
    ! [VarCurr: state_type] :
      ( v73923(VarCurr)
    <=> ( v73911(VarCurr)
      <~> v73915(VarCurr) ) ) ).

tff(addAssignment_46626,axiom,
    ! [VarCurr: state_type] :
      ( v73919(VarCurr)
    <=> v73921(VarCurr) ) ).

tff(addAssignment_46625,axiom,
    ! [VarCurr: state_type] :
      ( v73921(VarCurr)
    <=> v67349(VarCurr,60) ) ).

tff(addAssignment_46624,axiom,
    ! [VarCurr: state_type] :
      ( v73915(VarCurr)
    <=> v73917(VarCurr) ) ).

tff(addAssignment_46623,axiom,
    ! [VarCurr: state_type] :
      ( v73917(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_46622,axiom,
    ! [VarCurr: state_type] :
      ( v73911(VarCurr)
    <=> v73913(VarCurr) ) ).

tff(addAssignment_46621,axiom,
    ! [VarCurr: state_type] :
      ( v73913(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_46620,axiom,
    ! [VarCurr: state_type] :
      ( v73877(VarCurr)
    <=> v73879(VarCurr) ) ).

tff(addAssignment_46619,axiom,
    ! [VarCurr: state_type] :
      ( v73879(VarCurr)
    <=> v73881(VarCurr) ) ).

tff(addAssignment_46618,axiom,
    ! [VarCurr: state_type] :
      ( v73881(VarCurr)
    <=> v73883(VarCurr) ) ).

tff(addAssignment_46617,axiom,
    ! [VarCurr: state_type] :
      ( v73883(VarCurr)
    <=> v73885(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6899,axiom,
    ! [VarCurr: state_type] :
      ( v73885(VarCurr)
    <=> ( v73899(VarCurr)
      <~> v73895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6898,axiom,
    ! [VarCurr: state_type] :
      ( v73899(VarCurr)
    <=> ( v73887(VarCurr)
      <~> v73891(VarCurr) ) ) ).

tff(addAssignment_46616,axiom,
    ! [VarCurr: state_type] :
      ( v73895(VarCurr)
    <=> v73897(VarCurr) ) ).

tff(addAssignment_46615,axiom,
    ! [VarCurr: state_type] :
      ( v73897(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_46614,axiom,
    ! [VarCurr: state_type] :
      ( v73891(VarCurr)
    <=> v73893(VarCurr) ) ).

tff(addAssignment_46613,axiom,
    ! [VarCurr: state_type] :
      ( v73893(VarCurr)
    <=> v67349(VarCurr,50) ) ).

tff(addAssignment_46612,axiom,
    ! [VarCurr: state_type] :
      ( v73887(VarCurr)
    <=> v73889(VarCurr) ) ).

tff(addAssignment_46611,axiom,
    ! [VarCurr: state_type] :
      ( v73889(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_46610,axiom,
    ! [VarCurr: state_type] :
      ( v73593(VarCurr)
    <=> v73595(VarCurr) ) ).

tff(addAssignment_46609,axiom,
    ! [VarCurr: state_type] :
      ( v73595(VarCurr)
    <=> v73597(VarCurr) ) ).

tff(addAssignment_46608,axiom,
    ! [VarCurr: state_type] :
      ( v73597(VarCurr)
    <=> v73599(VarCurr) ) ).

tff(addAssignment_46607,axiom,
    ! [VarCurr: state_type] :
      ( v73599(VarCurr)
    <=> v73601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6897,axiom,
    ! [VarCurr: state_type] :
      ( v73601(VarCurr)
    <=> ( v73855(VarCurr)
      <~> v73771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6896,axiom,
    ! [VarCurr: state_type] :
      ( v73855(VarCurr)
    <=> ( v73603(VarCurr)
      <~> v73687(VarCurr) ) ) ).

tff(addAssignment_46606,axiom,
    ! [VarCurr: state_type] :
      ( v73771(VarCurr)
    <=> v73773(VarCurr) ) ).

tff(addAssignment_46605,axiom,
    ! [VarCurr: state_type] :
      ( v73773(VarCurr)
    <=> v73775(VarCurr) ) ).

tff(addAssignment_46604,axiom,
    ! [VarCurr: state_type] :
      ( v73775(VarCurr)
    <=> v73777(VarCurr) ) ).

tff(addAssignment_46603,axiom,
    ! [VarCurr: state_type] :
      ( v73777(VarCurr)
    <=> v73779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6895,axiom,
    ! [VarCurr: state_type] :
      ( v73779(VarCurr)
    <=> ( v73853(VarCurr)
      <~> v73829(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6894,axiom,
    ! [VarCurr: state_type] :
      ( v73853(VarCurr)
    <=> ( v73781(VarCurr)
      <~> v73805(VarCurr) ) ) ).

tff(addAssignment_46602,axiom,
    ! [VarCurr: state_type] :
      ( v73829(VarCurr)
    <=> v73831(VarCurr) ) ).

tff(addAssignment_46601,axiom,
    ! [VarCurr: state_type] :
      ( v73831(VarCurr)
    <=> v73833(VarCurr) ) ).

tff(addAssignment_46600,axiom,
    ! [VarCurr: state_type] :
      ( v73833(VarCurr)
    <=> v73835(VarCurr) ) ).

tff(addAssignment_46599,axiom,
    ! [VarCurr: state_type] :
      ( v73835(VarCurr)
    <=> v73837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6893,axiom,
    ! [VarCurr: state_type] :
      ( v73837(VarCurr)
    <=> ( v73851(VarCurr)
      <~> v73847(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6892,axiom,
    ! [VarCurr: state_type] :
      ( v73851(VarCurr)
    <=> ( v73839(VarCurr)
      <~> v73843(VarCurr) ) ) ).

tff(addAssignment_46598,axiom,
    ! [VarCurr: state_type] :
      ( v73847(VarCurr)
    <=> v73849(VarCurr) ) ).

tff(addAssignment_46597,axiom,
    ! [VarCurr: state_type] :
      ( v73849(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_46596,axiom,
    ! [VarCurr: state_type] :
      ( v73843(VarCurr)
    <=> v73845(VarCurr) ) ).

tff(addAssignment_46595,axiom,
    ! [VarCurr: state_type] :
      ( v73845(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_46594,axiom,
    ! [VarCurr: state_type] :
      ( v73839(VarCurr)
    <=> v73841(VarCurr) ) ).

tff(addAssignment_46593,axiom,
    ! [VarCurr: state_type] :
      ( v73841(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_46592,axiom,
    ! [VarCurr: state_type] :
      ( v73805(VarCurr)
    <=> v73807(VarCurr) ) ).

tff(addAssignment_46591,axiom,
    ! [VarCurr: state_type] :
      ( v73807(VarCurr)
    <=> v73809(VarCurr) ) ).

tff(addAssignment_46590,axiom,
    ! [VarCurr: state_type] :
      ( v73809(VarCurr)
    <=> v73811(VarCurr) ) ).

tff(addAssignment_46589,axiom,
    ! [VarCurr: state_type] :
      ( v73811(VarCurr)
    <=> v73813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6891,axiom,
    ! [VarCurr: state_type] :
      ( v73813(VarCurr)
    <=> ( v73827(VarCurr)
      <~> v73823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6890,axiom,
    ! [VarCurr: state_type] :
      ( v73827(VarCurr)
    <=> ( v73815(VarCurr)
      <~> v73819(VarCurr) ) ) ).

tff(addAssignment_46588,axiom,
    ! [VarCurr: state_type] :
      ( v73823(VarCurr)
    <=> v73825(VarCurr) ) ).

tff(addAssignment_46587,axiom,
    ! [VarCurr: state_type] :
      ( v73825(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_46586,axiom,
    ! [VarCurr: state_type] :
      ( v73819(VarCurr)
    <=> v73821(VarCurr) ) ).

tff(addAssignment_46585,axiom,
    ! [VarCurr: state_type] :
      ( v73821(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_46584,axiom,
    ! [VarCurr: state_type] :
      ( v73815(VarCurr)
    <=> v73817(VarCurr) ) ).

tff(addAssignment_46583,axiom,
    ! [VarCurr: state_type] :
      ( v73817(VarCurr)
    <=> v67349(VarCurr,35) ) ).

tff(addAssignment_46582,axiom,
    ! [VarCurr: state_type] :
      ( v73781(VarCurr)
    <=> v73783(VarCurr) ) ).

tff(addAssignment_46581,axiom,
    ! [VarCurr: state_type] :
      ( v73783(VarCurr)
    <=> v73785(VarCurr) ) ).

tff(addAssignment_46580,axiom,
    ! [VarCurr: state_type] :
      ( v73785(VarCurr)
    <=> v73787(VarCurr) ) ).

tff(addAssignment_46579,axiom,
    ! [VarCurr: state_type] :
      ( v73787(VarCurr)
    <=> v73789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6889,axiom,
    ! [VarCurr: state_type] :
      ( v73789(VarCurr)
    <=> ( v73803(VarCurr)
      <~> v73799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6888,axiom,
    ! [VarCurr: state_type] :
      ( v73803(VarCurr)
    <=> ( v73791(VarCurr)
      <~> v73795(VarCurr) ) ) ).

tff(addAssignment_46578,axiom,
    ! [VarCurr: state_type] :
      ( v73799(VarCurr)
    <=> v73801(VarCurr) ) ).

tff(addAssignment_46577,axiom,
    ! [VarCurr: state_type] :
      ( v73801(VarCurr)
    <=> v67349(VarCurr,31) ) ).

tff(addAssignment_46576,axiom,
    ! [VarCurr: state_type] :
      ( v73795(VarCurr)
    <=> v73797(VarCurr) ) ).

tff(addAssignment_46575,axiom,
    ! [VarCurr: state_type] :
      ( v73797(VarCurr)
    <=> v67349(VarCurr,30) ) ).

tff(addAssignment_46574,axiom,
    ! [VarCurr: state_type] :
      ( v73791(VarCurr)
    <=> v73793(VarCurr) ) ).

tff(addAssignment_46573,axiom,
    ! [VarCurr: state_type] :
      ( v73793(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_46572,axiom,
    ! [VarCurr: state_type] :
      ( v73687(VarCurr)
    <=> v73689(VarCurr) ) ).

tff(addAssignment_46571,axiom,
    ! [VarCurr: state_type] :
      ( v73689(VarCurr)
    <=> v73691(VarCurr) ) ).

tff(addAssignment_46570,axiom,
    ! [VarCurr: state_type] :
      ( v73691(VarCurr)
    <=> v73693(VarCurr) ) ).

tff(addAssignment_46569,axiom,
    ! [VarCurr: state_type] :
      ( v73693(VarCurr)
    <=> v73695(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6887,axiom,
    ! [VarCurr: state_type] :
      ( v73695(VarCurr)
    <=> ( v73769(VarCurr)
      <~> v73745(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6886,axiom,
    ! [VarCurr: state_type] :
      ( v73769(VarCurr)
    <=> ( v73697(VarCurr)
      <~> v73721(VarCurr) ) ) ).

tff(addAssignment_46568,axiom,
    ! [VarCurr: state_type] :
      ( v73745(VarCurr)
    <=> v73747(VarCurr) ) ).

tff(addAssignment_46567,axiom,
    ! [VarCurr: state_type] :
      ( v73747(VarCurr)
    <=> v73749(VarCurr) ) ).

tff(addAssignment_46566,axiom,
    ! [VarCurr: state_type] :
      ( v73749(VarCurr)
    <=> v73751(VarCurr) ) ).

tff(addAssignment_46565,axiom,
    ! [VarCurr: state_type] :
      ( v73751(VarCurr)
    <=> v73753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6885,axiom,
    ! [VarCurr: state_type] :
      ( v73753(VarCurr)
    <=> ( v73767(VarCurr)
      <~> v73763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6884,axiom,
    ! [VarCurr: state_type] :
      ( v73767(VarCurr)
    <=> ( v73755(VarCurr)
      <~> v73759(VarCurr) ) ) ).

tff(addAssignment_46564,axiom,
    ! [VarCurr: state_type] :
      ( v73763(VarCurr)
    <=> v73765(VarCurr) ) ).

tff(addAssignment_46563,axiom,
    ! [VarCurr: state_type] :
      ( v73765(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_46562,axiom,
    ! [VarCurr: state_type] :
      ( v73759(VarCurr)
    <=> v73761(VarCurr) ) ).

tff(addAssignment_46561,axiom,
    ! [VarCurr: state_type] :
      ( v73761(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_46560,axiom,
    ! [VarCurr: state_type] :
      ( v73755(VarCurr)
    <=> v73757(VarCurr) ) ).

tff(addAssignment_46559,axiom,
    ! [VarCurr: state_type] :
      ( v73757(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_46558,axiom,
    ! [VarCurr: state_type] :
      ( v73721(VarCurr)
    <=> v73723(VarCurr) ) ).

tff(addAssignment_46557,axiom,
    ! [VarCurr: state_type] :
      ( v73723(VarCurr)
    <=> v73725(VarCurr) ) ).

tff(addAssignment_46556,axiom,
    ! [VarCurr: state_type] :
      ( v73725(VarCurr)
    <=> v73727(VarCurr) ) ).

tff(addAssignment_46555,axiom,
    ! [VarCurr: state_type] :
      ( v73727(VarCurr)
    <=> v73729(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6883,axiom,
    ! [VarCurr: state_type] :
      ( v73729(VarCurr)
    <=> ( v73743(VarCurr)
      <~> v73739(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6882,axiom,
    ! [VarCurr: state_type] :
      ( v73743(VarCurr)
    <=> ( v73731(VarCurr)
      <~> v73735(VarCurr) ) ) ).

tff(addAssignment_46554,axiom,
    ! [VarCurr: state_type] :
      ( v73739(VarCurr)
    <=> v73741(VarCurr) ) ).

tff(addAssignment_46553,axiom,
    ! [VarCurr: state_type] :
      ( v73741(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_46552,axiom,
    ! [VarCurr: state_type] :
      ( v73735(VarCurr)
    <=> v73737(VarCurr) ) ).

tff(addAssignment_46551,axiom,
    ! [VarCurr: state_type] :
      ( v73737(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_46550,axiom,
    ! [VarCurr: state_type] :
      ( v73731(VarCurr)
    <=> v73733(VarCurr) ) ).

tff(addAssignment_46549,axiom,
    ! [VarCurr: state_type] :
      ( v73733(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_46548,axiom,
    ! [VarCurr: state_type] :
      ( v73697(VarCurr)
    <=> v73699(VarCurr) ) ).

tff(addAssignment_46547,axiom,
    ! [VarCurr: state_type] :
      ( v73699(VarCurr)
    <=> v73701(VarCurr) ) ).

tff(addAssignment_46546,axiom,
    ! [VarCurr: state_type] :
      ( v73701(VarCurr)
    <=> v73703(VarCurr) ) ).

tff(addAssignment_46545,axiom,
    ! [VarCurr: state_type] :
      ( v73703(VarCurr)
    <=> v73705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6881,axiom,
    ! [VarCurr: state_type] :
      ( v73705(VarCurr)
    <=> ( v73719(VarCurr)
      <~> v73715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6880,axiom,
    ! [VarCurr: state_type] :
      ( v73719(VarCurr)
    <=> ( v73707(VarCurr)
      <~> v73711(VarCurr) ) ) ).

tff(addAssignment_46544,axiom,
    ! [VarCurr: state_type] :
      ( v73715(VarCurr)
    <=> v73717(VarCurr) ) ).

tff(addAssignment_46543,axiom,
    ! [VarCurr: state_type] :
      ( v73717(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_46542,axiom,
    ! [VarCurr: state_type] :
      ( v73711(VarCurr)
    <=> v73713(VarCurr) ) ).

tff(addAssignment_46541,axiom,
    ! [VarCurr: state_type] :
      ( v73713(VarCurr)
    <=> v67349(VarCurr,17) ) ).

tff(addAssignment_46540,axiom,
    ! [VarCurr: state_type] :
      ( v73707(VarCurr)
    <=> v73709(VarCurr) ) ).

tff(addAssignment_46539,axiom,
    ! [VarCurr: state_type] :
      ( v73709(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_46538,axiom,
    ! [VarCurr: state_type] :
      ( v73603(VarCurr)
    <=> v73605(VarCurr) ) ).

tff(addAssignment_46537,axiom,
    ! [VarCurr: state_type] :
      ( v73605(VarCurr)
    <=> v73607(VarCurr) ) ).

tff(addAssignment_46536,axiom,
    ! [VarCurr: state_type] :
      ( v73607(VarCurr)
    <=> v73609(VarCurr) ) ).

tff(addAssignment_46535,axiom,
    ! [VarCurr: state_type] :
      ( v73609(VarCurr)
    <=> v73611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6879,axiom,
    ! [VarCurr: state_type] :
      ( v73611(VarCurr)
    <=> ( v73685(VarCurr)
      <~> v73661(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6878,axiom,
    ! [VarCurr: state_type] :
      ( v73685(VarCurr)
    <=> ( v73613(VarCurr)
      <~> v73637(VarCurr) ) ) ).

tff(addAssignment_46534,axiom,
    ! [VarCurr: state_type] :
      ( v73661(VarCurr)
    <=> v73663(VarCurr) ) ).

tff(addAssignment_46533,axiom,
    ! [VarCurr: state_type] :
      ( v73663(VarCurr)
    <=> v73665(VarCurr) ) ).

tff(addAssignment_46532,axiom,
    ! [VarCurr: state_type] :
      ( v73665(VarCurr)
    <=> v73667(VarCurr) ) ).

tff(addAssignment_46531,axiom,
    ! [VarCurr: state_type] :
      ( v73667(VarCurr)
    <=> v73669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6877,axiom,
    ! [VarCurr: state_type] :
      ( v73669(VarCurr)
    <=> ( v73683(VarCurr)
      <~> v73679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6876,axiom,
    ! [VarCurr: state_type] :
      ( v73683(VarCurr)
    <=> ( v73671(VarCurr)
      <~> v73675(VarCurr) ) ) ).

tff(addAssignment_46530,axiom,
    ! [VarCurr: state_type] :
      ( v73679(VarCurr)
    <=> v73681(VarCurr) ) ).

tff(addAssignment_46529,axiom,
    ! [VarCurr: state_type] :
      ( v73681(VarCurr)
    <=> v67349(VarCurr,14) ) ).

tff(addAssignment_46528,axiom,
    ! [VarCurr: state_type] :
      ( v73675(VarCurr)
    <=> v73677(VarCurr) ) ).

tff(addAssignment_46527,axiom,
    ! [VarCurr: state_type] :
      ( v73677(VarCurr)
    <=> v67349(VarCurr,13) ) ).

tff(addAssignment_46526,axiom,
    ! [VarCurr: state_type] :
      ( v73671(VarCurr)
    <=> v73673(VarCurr) ) ).

tff(addAssignment_46525,axiom,
    ! [VarCurr: state_type] :
      ( v73673(VarCurr)
    <=> v67349(VarCurr,12) ) ).

tff(addAssignment_46524,axiom,
    ! [VarCurr: state_type] :
      ( v73637(VarCurr)
    <=> v73639(VarCurr) ) ).

tff(addAssignment_46523,axiom,
    ! [VarCurr: state_type] :
      ( v73639(VarCurr)
    <=> v73641(VarCurr) ) ).

tff(addAssignment_46522,axiom,
    ! [VarCurr: state_type] :
      ( v73641(VarCurr)
    <=> v73643(VarCurr) ) ).

tff(addAssignment_46521,axiom,
    ! [VarCurr: state_type] :
      ( v73643(VarCurr)
    <=> v73645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6875,axiom,
    ! [VarCurr: state_type] :
      ( v73645(VarCurr)
    <=> ( v73659(VarCurr)
      <~> v73655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6874,axiom,
    ! [VarCurr: state_type] :
      ( v73659(VarCurr)
    <=> ( v73647(VarCurr)
      <~> v73651(VarCurr) ) ) ).

tff(addAssignment_46520,axiom,
    ! [VarCurr: state_type] :
      ( v73655(VarCurr)
    <=> v73657(VarCurr) ) ).

tff(addAssignment_46519,axiom,
    ! [VarCurr: state_type] :
      ( v73657(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_46518,axiom,
    ! [VarCurr: state_type] :
      ( v73651(VarCurr)
    <=> v73653(VarCurr) ) ).

tff(addAssignment_46517,axiom,
    ! [VarCurr: state_type] :
      ( v73653(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_46516,axiom,
    ! [VarCurr: state_type] :
      ( v73647(VarCurr)
    <=> v73649(VarCurr) ) ).

tff(addAssignment_46515,axiom,
    ! [VarCurr: state_type] :
      ( v73649(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_46514,axiom,
    ! [VarCurr: state_type] :
      ( v73613(VarCurr)
    <=> v73615(VarCurr) ) ).

tff(addAssignment_46513,axiom,
    ! [VarCurr: state_type] :
      ( v73615(VarCurr)
    <=> v73617(VarCurr) ) ).

tff(addAssignment_46512,axiom,
    ! [VarCurr: state_type] :
      ( v73617(VarCurr)
    <=> v73619(VarCurr) ) ).

tff(addAssignment_46511,axiom,
    ! [VarCurr: state_type] :
      ( v73619(VarCurr)
    <=> v73621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6873,axiom,
    ! [VarCurr: state_type] :
      ( v73621(VarCurr)
    <=> ( v73635(VarCurr)
      <~> v73631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6872,axiom,
    ! [VarCurr: state_type] :
      ( v73635(VarCurr)
    <=> ( v73623(VarCurr)
      <~> v73627(VarCurr) ) ) ).

tff(addAssignment_46510,axiom,
    ! [VarCurr: state_type] :
      ( v73631(VarCurr)
    <=> v73633(VarCurr) ) ).

tff(addAssignment_46509,axiom,
    ! [VarCurr: state_type] :
      ( v73633(VarCurr)
    <=> v67349(VarCurr,5) ) ).

tff(addAssignment_46508,axiom,
    ! [VarCurr: state_type] :
      ( v73627(VarCurr)
    <=> v73629(VarCurr) ) ).

tff(addAssignment_46507,axiom,
    ! [VarCurr: state_type] :
      ( v73629(VarCurr)
    <=> v67349(VarCurr,4) ) ).

tff(addAssignment_46506,axiom,
    ! [VarCurr: state_type] :
      ( v73623(VarCurr)
    <=> v73625(VarCurr) ) ).

tff(addAssignment_46505,axiom,
    ! [VarCurr: state_type] :
      ( v73625(VarCurr)
    <=> v67349(VarCurr,0) ) ).

tff(addAssignment_46504,axiom,
    ! [VarCurr: state_type] :
      ( v72915(VarCurr)
    <=> v72917(VarCurr) ) ).

tff(addAssignment_46503,axiom,
    ! [VarCurr: state_type] :
      ( v72917(VarCurr)
    <=> v71560(VarCurr,1) ) ).

tff(addAssignment_46502,axiom,
    ! [VarCurr: state_type] :
      ( v71560(VarCurr,1)
    <=> v67309(VarCurr,1) ) ).

tff(addAssignment_46501,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,1)
    <=> v67311(VarCurr,1) ) ).

tff(addAssignment_46500,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,1)
    <=> v67313(VarCurr,1) ) ).

tff(addAssignment_46499,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,1)
    <=> v67315(VarCurr,1) ) ).

tff(addAssignment_46498,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,1)
    <=> v67317(VarCurr,1) ) ).

tff(addAssignment_46497,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,1)
    <=> v68771(VarCurr,1) ) ).

tff(addAssignment_46496,axiom,
    ! [VarCurr: state_type] :
      ( v68774(VarCurr,1)
    <=> v72919(VarCurr) ) ).

tff(addAssignment_46495,axiom,
    ! [VarCurr: state_type] :
      ( v72919(VarCurr)
    <=> v72921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6871,axiom,
    ! [VarCurr: state_type] :
      ( v72921(VarCurr)
    <=> ( v73583(VarCurr)
      <~> v73451(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6870,axiom,
    ! [VarCurr: state_type] :
      ( v73583(VarCurr)
    <=> ( v72923(VarCurr)
      <~> v73187(VarCurr) ) ) ).

tff(addAssignment_46494,axiom,
    ! [VarCurr: state_type] :
      ( v73451(VarCurr)
    <=> v73453(VarCurr) ) ).

tff(addAssignment_46493,axiom,
    ! [VarCurr: state_type] :
      ( v73453(VarCurr)
    <=> v73455(VarCurr) ) ).

tff(addAssignment_46492,axiom,
    ! [VarCurr: state_type] :
      ( v73455(VarCurr)
    <=> v73457(VarCurr) ) ).

tff(addAssignment_46491,axiom,
    ! [VarCurr: state_type] :
      ( v73457(VarCurr)
    <=> v73459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6869,axiom,
    ! [VarCurr: state_type] :
      ( v73459(VarCurr)
    <=> ( v73581(VarCurr)
      <~> v73569(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6868,axiom,
    ! [VarCurr: state_type] :
      ( v73581(VarCurr)
    <=> ( v73461(VarCurr)
      <~> v73485(VarCurr) ) ) ).

tff(addAssignment_46490,axiom,
    ! [VarCurr: state_type] :
      ( v73569(VarCurr)
    <=> v73571(VarCurr) ) ).

tff(addAssignment_46489,axiom,
    ! [VarCurr: state_type] :
      ( v73571(VarCurr)
    <=> v72217(VarCurr,1) ) ).

tff(addAssignment_46488,axiom,
    ! [VarCurr: state_type] :
      ( v72217(VarCurr,1)
    <=> v72219(VarCurr,1) ) ).

tff(addAssignment_46487,axiom,
    ! [VarCurr: state_type] :
      ( v72219(VarCurr,1)
    <=> v68595(VarCurr,2) ) ).

tff(addAssignment_46486,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,2)
    <=> v68597(VarCurr,2) ) ).

tff(addAssignment_46485,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,2)
    <=> v73573(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v73574(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v73573(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_904,axiom,
    ! [VarNext: state_type] :
      ( v73574(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v73573(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v73574(VarNext)
      <=> v73575(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v73575(VarNext)
      <=> ( v73577(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v73577(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_46484,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,2)
    <=> v68621(VarCurr,2) ) ).

tff(addAssignment_46483,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,2)
    <=> v68624(VarCurr,2) ) ).

tff(addAssignment_46482,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,1)
    <=> v68455(VarCurr,1) ) ).

tff(addAssignment_46481,axiom,
    ! [VarCurr: state_type] :
      ( v73485(VarCurr)
    <=> v73487(VarCurr) ) ).

tff(addAssignment_46480,axiom,
    ! [VarCurr: state_type] :
      ( v73487(VarCurr)
    <=> v73489(VarCurr) ) ).

tff(addAssignment_46479,axiom,
    ! [VarCurr: state_type] :
      ( v73489(VarCurr)
    <=> v73491(VarCurr) ) ).

tff(addAssignment_46478,axiom,
    ! [VarCurr: state_type] :
      ( v73491(VarCurr)
    <=> v73493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6865,axiom,
    ! [VarCurr: state_type] :
      ( v73493(VarCurr)
    <=> ( v73567(VarCurr)
      <~> v73543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6864,axiom,
    ! [VarCurr: state_type] :
      ( v73567(VarCurr)
    <=> ( v73495(VarCurr)
      <~> v73519(VarCurr) ) ) ).

tff(addAssignment_46477,axiom,
    ! [VarCurr: state_type] :
      ( v73543(VarCurr)
    <=> v73545(VarCurr) ) ).

tff(addAssignment_46476,axiom,
    ! [VarCurr: state_type] :
      ( v73545(VarCurr)
    <=> v73547(VarCurr) ) ).

tff(addAssignment_46475,axiom,
    ! [VarCurr: state_type] :
      ( v73547(VarCurr)
    <=> v73549(VarCurr) ) ).

tff(addAssignment_46474,axiom,
    ! [VarCurr: state_type] :
      ( v73549(VarCurr)
    <=> v73551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6863,axiom,
    ! [VarCurr: state_type] :
      ( v73551(VarCurr)
    <=> ( v73565(VarCurr)
      <~> v73561(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6862,axiom,
    ! [VarCurr: state_type] :
      ( v73565(VarCurr)
    <=> ( v73553(VarCurr)
      <~> v73557(VarCurr) ) ) ).

tff(addAssignment_46473,axiom,
    ! [VarCurr: state_type] :
      ( v73561(VarCurr)
    <=> v73563(VarCurr) ) ).

tff(addAssignment_46472,axiom,
    ! [VarCurr: state_type] :
      ( v73563(VarCurr)
    <=> v67349(VarCurr,118) ) ).

tff(addAssignment_46471,axiom,
    ! [VarCurr: state_type] :
      ( v73557(VarCurr)
    <=> v73559(VarCurr) ) ).

tff(addAssignment_46470,axiom,
    ! [VarCurr: state_type] :
      ( v73559(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_46469,axiom,
    ! [VarCurr: state_type] :
      ( v73553(VarCurr)
    <=> v73555(VarCurr) ) ).

tff(addAssignment_46468,axiom,
    ! [VarCurr: state_type] :
      ( v73555(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_46467,axiom,
    ! [VarCurr: state_type] :
      ( v73519(VarCurr)
    <=> v73521(VarCurr) ) ).

tff(addAssignment_46466,axiom,
    ! [VarCurr: state_type] :
      ( v73521(VarCurr)
    <=> v73523(VarCurr) ) ).

tff(addAssignment_46465,axiom,
    ! [VarCurr: state_type] :
      ( v73523(VarCurr)
    <=> v73525(VarCurr) ) ).

tff(addAssignment_46464,axiom,
    ! [VarCurr: state_type] :
      ( v73525(VarCurr)
    <=> v73527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6861,axiom,
    ! [VarCurr: state_type] :
      ( v73527(VarCurr)
    <=> ( v73541(VarCurr)
      <~> v73537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6860,axiom,
    ! [VarCurr: state_type] :
      ( v73541(VarCurr)
    <=> ( v73529(VarCurr)
      <~> v73533(VarCurr) ) ) ).

tff(addAssignment_46463,axiom,
    ! [VarCurr: state_type] :
      ( v73537(VarCurr)
    <=> v73539(VarCurr) ) ).

tff(addAssignment_46462,axiom,
    ! [VarCurr: state_type] :
      ( v73539(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_46461,axiom,
    ! [VarCurr: state_type] :
      ( v73533(VarCurr)
    <=> v73535(VarCurr) ) ).

tff(addAssignment_46460,axiom,
    ! [VarCurr: state_type] :
      ( v73535(VarCurr)
    <=> v67349(VarCurr,111) ) ).

tff(addAssignment_46459,axiom,
    ! [VarCurr: state_type] :
      ( v73529(VarCurr)
    <=> v73531(VarCurr) ) ).

tff(addAssignment_46458,axiom,
    ! [VarCurr: state_type] :
      ( v73531(VarCurr)
    <=> v67349(VarCurr,110) ) ).

tff(addAssignment_46457,axiom,
    ! [VarCurr: state_type] :
      ( v73495(VarCurr)
    <=> v73497(VarCurr) ) ).

tff(addAssignment_46456,axiom,
    ! [VarCurr: state_type] :
      ( v73497(VarCurr)
    <=> v73499(VarCurr) ) ).

tff(addAssignment_46455,axiom,
    ! [VarCurr: state_type] :
      ( v73499(VarCurr)
    <=> v73501(VarCurr) ) ).

tff(addAssignment_46454,axiom,
    ! [VarCurr: state_type] :
      ( v73501(VarCurr)
    <=> v73503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6859,axiom,
    ! [VarCurr: state_type] :
      ( v73503(VarCurr)
    <=> ( v73517(VarCurr)
      <~> v73513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6858,axiom,
    ! [VarCurr: state_type] :
      ( v73517(VarCurr)
    <=> ( v73505(VarCurr)
      <~> v73509(VarCurr) ) ) ).

tff(addAssignment_46453,axiom,
    ! [VarCurr: state_type] :
      ( v73513(VarCurr)
    <=> v73515(VarCurr) ) ).

tff(addAssignment_46452,axiom,
    ! [VarCurr: state_type] :
      ( v73515(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_46451,axiom,
    ! [VarCurr: state_type] :
      ( v73509(VarCurr)
    <=> v73511(VarCurr) ) ).

tff(addAssignment_46450,axiom,
    ! [VarCurr: state_type] :
      ( v73511(VarCurr)
    <=> v67349(VarCurr,104) ) ).

tff(addAssignment_46449,axiom,
    ! [VarCurr: state_type] :
      ( v73505(VarCurr)
    <=> v73507(VarCurr) ) ).

tff(addAssignment_46448,axiom,
    ! [VarCurr: state_type] :
      ( v73507(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_46447,axiom,
    ! [VarCurr: state_type] :
      ( v73461(VarCurr)
    <=> v73463(VarCurr) ) ).

tff(addAssignment_46446,axiom,
    ! [VarCurr: state_type] :
      ( v73463(VarCurr)
    <=> v73465(VarCurr) ) ).

tff(addAssignment_46445,axiom,
    ! [VarCurr: state_type] :
      ( v73465(VarCurr)
    <=> v73467(VarCurr) ) ).

tff(addAssignment_46444,axiom,
    ! [VarCurr: state_type] :
      ( v73467(VarCurr)
    <=> v73469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6857,axiom,
    ! [VarCurr: state_type] :
      ( v73469(VarCurr)
    <=> ( v73483(VarCurr)
      <~> v73479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6856,axiom,
    ! [VarCurr: state_type] :
      ( v73483(VarCurr)
    <=> ( v73471(VarCurr)
      <~> v73475(VarCurr) ) ) ).

tff(addAssignment_46443,axiom,
    ! [VarCurr: state_type] :
      ( v73479(VarCurr)
    <=> v73481(VarCurr) ) ).

tff(addAssignment_46442,axiom,
    ! [VarCurr: state_type] :
      ( v73481(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_46441,axiom,
    ! [VarCurr: state_type] :
      ( v73475(VarCurr)
    <=> v73477(VarCurr) ) ).

tff(addAssignment_46440,axiom,
    ! [VarCurr: state_type] :
      ( v73477(VarCurr)
    <=> v67349(VarCurr,121) ) ).

tff(addAssignment_46439,axiom,
    ! [VarCurr: state_type] :
      ( v73471(VarCurr)
    <=> v73473(VarCurr) ) ).

tff(addAssignment_46438,axiom,
    ! [VarCurr: state_type] :
      ( v73473(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_46437,axiom,
    ! [VarCurr: state_type] :
      ( v73187(VarCurr)
    <=> v73189(VarCurr) ) ).

tff(addAssignment_46436,axiom,
    ! [VarCurr: state_type] :
      ( v73189(VarCurr)
    <=> v73191(VarCurr) ) ).

tff(addAssignment_46435,axiom,
    ! [VarCurr: state_type] :
      ( v73191(VarCurr)
    <=> v73193(VarCurr) ) ).

tff(addAssignment_46434,axiom,
    ! [VarCurr: state_type] :
      ( v73193(VarCurr)
    <=> v73195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6855,axiom,
    ! [VarCurr: state_type] :
      ( v73195(VarCurr)
    <=> ( v73449(VarCurr)
      <~> v73365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6854,axiom,
    ! [VarCurr: state_type] :
      ( v73449(VarCurr)
    <=> ( v73197(VarCurr)
      <~> v73281(VarCurr) ) ) ).

tff(addAssignment_46433,axiom,
    ! [VarCurr: state_type] :
      ( v73365(VarCurr)
    <=> v73367(VarCurr) ) ).

tff(addAssignment_46432,axiom,
    ! [VarCurr: state_type] :
      ( v73367(VarCurr)
    <=> v73369(VarCurr) ) ).

tff(addAssignment_46431,axiom,
    ! [VarCurr: state_type] :
      ( v73369(VarCurr)
    <=> v73371(VarCurr) ) ).

tff(addAssignment_46430,axiom,
    ! [VarCurr: state_type] :
      ( v73371(VarCurr)
    <=> v73373(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6853,axiom,
    ! [VarCurr: state_type] :
      ( v73373(VarCurr)
    <=> ( v73447(VarCurr)
      <~> v73423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6852,axiom,
    ! [VarCurr: state_type] :
      ( v73447(VarCurr)
    <=> ( v73375(VarCurr)
      <~> v73399(VarCurr) ) ) ).

tff(addAssignment_46429,axiom,
    ! [VarCurr: state_type] :
      ( v73423(VarCurr)
    <=> v73425(VarCurr) ) ).

tff(addAssignment_46428,axiom,
    ! [VarCurr: state_type] :
      ( v73425(VarCurr)
    <=> v73427(VarCurr) ) ).

tff(addAssignment_46427,axiom,
    ! [VarCurr: state_type] :
      ( v73427(VarCurr)
    <=> v73429(VarCurr) ) ).

tff(addAssignment_46426,axiom,
    ! [VarCurr: state_type] :
      ( v73429(VarCurr)
    <=> v73431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6851,axiom,
    ! [VarCurr: state_type] :
      ( v73431(VarCurr)
    <=> ( v73445(VarCurr)
      <~> v73441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6850,axiom,
    ! [VarCurr: state_type] :
      ( v73445(VarCurr)
    <=> ( v73433(VarCurr)
      <~> v73437(VarCurr) ) ) ).

tff(addAssignment_46425,axiom,
    ! [VarCurr: state_type] :
      ( v73441(VarCurr)
    <=> v73443(VarCurr) ) ).

tff(addAssignment_46424,axiom,
    ! [VarCurr: state_type] :
      ( v73443(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_46423,axiom,
    ! [VarCurr: state_type] :
      ( v73437(VarCurr)
    <=> v73439(VarCurr) ) ).

tff(addAssignment_46422,axiom,
    ! [VarCurr: state_type] :
      ( v73439(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_46421,axiom,
    ! [VarCurr: state_type] :
      ( v73433(VarCurr)
    <=> v73435(VarCurr) ) ).

tff(addAssignment_46420,axiom,
    ! [VarCurr: state_type] :
      ( v73435(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_46419,axiom,
    ! [VarCurr: state_type] :
      ( v73399(VarCurr)
    <=> v73401(VarCurr) ) ).

tff(addAssignment_46418,axiom,
    ! [VarCurr: state_type] :
      ( v73401(VarCurr)
    <=> v73403(VarCurr) ) ).

tff(addAssignment_46417,axiom,
    ! [VarCurr: state_type] :
      ( v73403(VarCurr)
    <=> v73405(VarCurr) ) ).

tff(addAssignment_46416,axiom,
    ! [VarCurr: state_type] :
      ( v73405(VarCurr)
    <=> v73407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6849,axiom,
    ! [VarCurr: state_type] :
      ( v73407(VarCurr)
    <=> ( v73421(VarCurr)
      <~> v73417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6848,axiom,
    ! [VarCurr: state_type] :
      ( v73421(VarCurr)
    <=> ( v73409(VarCurr)
      <~> v73413(VarCurr) ) ) ).

tff(addAssignment_46415,axiom,
    ! [VarCurr: state_type] :
      ( v73417(VarCurr)
    <=> v73419(VarCurr) ) ).

tff(addAssignment_46414,axiom,
    ! [VarCurr: state_type] :
      ( v73419(VarCurr)
    <=> v67349(VarCurr,101) ) ).

tff(addAssignment_46413,axiom,
    ! [VarCurr: state_type] :
      ( v73413(VarCurr)
    <=> v73415(VarCurr) ) ).

tff(addAssignment_46412,axiom,
    ! [VarCurr: state_type] :
      ( v73415(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_46411,axiom,
    ! [VarCurr: state_type] :
      ( v73409(VarCurr)
    <=> v73411(VarCurr) ) ).

tff(addAssignment_46410,axiom,
    ! [VarCurr: state_type] :
      ( v73411(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_46409,axiom,
    ! [VarCurr: state_type] :
      ( v73375(VarCurr)
    <=> v73377(VarCurr) ) ).

tff(addAssignment_46408,axiom,
    ! [VarCurr: state_type] :
      ( v73377(VarCurr)
    <=> v73379(VarCurr) ) ).

tff(addAssignment_46407,axiom,
    ! [VarCurr: state_type] :
      ( v73379(VarCurr)
    <=> v73381(VarCurr) ) ).

tff(addAssignment_46406,axiom,
    ! [VarCurr: state_type] :
      ( v73381(VarCurr)
    <=> v73383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6847,axiom,
    ! [VarCurr: state_type] :
      ( v73383(VarCurr)
    <=> ( v73397(VarCurr)
      <~> v73393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6846,axiom,
    ! [VarCurr: state_type] :
      ( v73397(VarCurr)
    <=> ( v73385(VarCurr)
      <~> v73389(VarCurr) ) ) ).

tff(addAssignment_46405,axiom,
    ! [VarCurr: state_type] :
      ( v73393(VarCurr)
    <=> v73395(VarCurr) ) ).

tff(addAssignment_46404,axiom,
    ! [VarCurr: state_type] :
      ( v73395(VarCurr)
    <=> v67349(VarCurr,95) ) ).

tff(addAssignment_46403,axiom,
    ! [VarCurr: state_type] :
      ( v73389(VarCurr)
    <=> v73391(VarCurr) ) ).

tff(addAssignment_46402,axiom,
    ! [VarCurr: state_type] :
      ( v73391(VarCurr)
    <=> v67349(VarCurr,92) ) ).

tff(addAssignment_46401,axiom,
    ! [VarCurr: state_type] :
      ( v73385(VarCurr)
    <=> v73387(VarCurr) ) ).

tff(addAssignment_46400,axiom,
    ! [VarCurr: state_type] :
      ( v73387(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_46399,axiom,
    ! [VarCurr: state_type] :
      ( v73281(VarCurr)
    <=> v73283(VarCurr) ) ).

tff(addAssignment_46398,axiom,
    ! [VarCurr: state_type] :
      ( v73283(VarCurr)
    <=> v73285(VarCurr) ) ).

tff(addAssignment_46397,axiom,
    ! [VarCurr: state_type] :
      ( v73285(VarCurr)
    <=> v73287(VarCurr) ) ).

tff(addAssignment_46396,axiom,
    ! [VarCurr: state_type] :
      ( v73287(VarCurr)
    <=> v73289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6845,axiom,
    ! [VarCurr: state_type] :
      ( v73289(VarCurr)
    <=> ( v73363(VarCurr)
      <~> v73339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6844,axiom,
    ! [VarCurr: state_type] :
      ( v73363(VarCurr)
    <=> ( v73291(VarCurr)
      <~> v73315(VarCurr) ) ) ).

tff(addAssignment_46395,axiom,
    ! [VarCurr: state_type] :
      ( v73339(VarCurr)
    <=> v73341(VarCurr) ) ).

tff(addAssignment_46394,axiom,
    ! [VarCurr: state_type] :
      ( v73341(VarCurr)
    <=> v73343(VarCurr) ) ).

tff(addAssignment_46393,axiom,
    ! [VarCurr: state_type] :
      ( v73343(VarCurr)
    <=> v73345(VarCurr) ) ).

tff(addAssignment_46392,axiom,
    ! [VarCurr: state_type] :
      ( v73345(VarCurr)
    <=> v73347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6843,axiom,
    ! [VarCurr: state_type] :
      ( v73347(VarCurr)
    <=> ( v73361(VarCurr)
      <~> v73357(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6842,axiom,
    ! [VarCurr: state_type] :
      ( v73361(VarCurr)
    <=> ( v73349(VarCurr)
      <~> v73353(VarCurr) ) ) ).

tff(addAssignment_46391,axiom,
    ! [VarCurr: state_type] :
      ( v73357(VarCurr)
    <=> v73359(VarCurr) ) ).

tff(addAssignment_46390,axiom,
    ! [VarCurr: state_type] :
      ( v73359(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_46389,axiom,
    ! [VarCurr: state_type] :
      ( v73353(VarCurr)
    <=> v73355(VarCurr) ) ).

tff(addAssignment_46388,axiom,
    ! [VarCurr: state_type] :
      ( v73355(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_46387,axiom,
    ! [VarCurr: state_type] :
      ( v73349(VarCurr)
    <=> v73351(VarCurr) ) ).

tff(addAssignment_46386,axiom,
    ! [VarCurr: state_type] :
      ( v73351(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_46385,axiom,
    ! [VarCurr: state_type] :
      ( v73315(VarCurr)
    <=> v73317(VarCurr) ) ).

tff(addAssignment_46384,axiom,
    ! [VarCurr: state_type] :
      ( v73317(VarCurr)
    <=> v73319(VarCurr) ) ).

tff(addAssignment_46383,axiom,
    ! [VarCurr: state_type] :
      ( v73319(VarCurr)
    <=> v73321(VarCurr) ) ).

tff(addAssignment_46382,axiom,
    ! [VarCurr: state_type] :
      ( v73321(VarCurr)
    <=> v73323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6841,axiom,
    ! [VarCurr: state_type] :
      ( v73323(VarCurr)
    <=> ( v73337(VarCurr)
      <~> v73333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6840,axiom,
    ! [VarCurr: state_type] :
      ( v73337(VarCurr)
    <=> ( v73325(VarCurr)
      <~> v73329(VarCurr) ) ) ).

tff(addAssignment_46381,axiom,
    ! [VarCurr: state_type] :
      ( v73333(VarCurr)
    <=> v73335(VarCurr) ) ).

tff(addAssignment_46380,axiom,
    ! [VarCurr: state_type] :
      ( v73335(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_46379,axiom,
    ! [VarCurr: state_type] :
      ( v73329(VarCurr)
    <=> v73331(VarCurr) ) ).

tff(addAssignment_46378,axiom,
    ! [VarCurr: state_type] :
      ( v73331(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_46377,axiom,
    ! [VarCurr: state_type] :
      ( v73325(VarCurr)
    <=> v73327(VarCurr) ) ).

tff(addAssignment_46376,axiom,
    ! [VarCurr: state_type] :
      ( v73327(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_46375,axiom,
    ! [VarCurr: state_type] :
      ( v73291(VarCurr)
    <=> v73293(VarCurr) ) ).

tff(addAssignment_46374,axiom,
    ! [VarCurr: state_type] :
      ( v73293(VarCurr)
    <=> v73295(VarCurr) ) ).

tff(addAssignment_46373,axiom,
    ! [VarCurr: state_type] :
      ( v73295(VarCurr)
    <=> v73297(VarCurr) ) ).

tff(addAssignment_46372,axiom,
    ! [VarCurr: state_type] :
      ( v73297(VarCurr)
    <=> v73299(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6839,axiom,
    ! [VarCurr: state_type] :
      ( v73299(VarCurr)
    <=> ( v73313(VarCurr)
      <~> v73309(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6838,axiom,
    ! [VarCurr: state_type] :
      ( v73313(VarCurr)
    <=> ( v73301(VarCurr)
      <~> v73305(VarCurr) ) ) ).

tff(addAssignment_46371,axiom,
    ! [VarCurr: state_type] :
      ( v73309(VarCurr)
    <=> v73311(VarCurr) ) ).

tff(addAssignment_46370,axiom,
    ! [VarCurr: state_type] :
      ( v73311(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_46369,axiom,
    ! [VarCurr: state_type] :
      ( v73305(VarCurr)
    <=> v73307(VarCurr) ) ).

tff(addAssignment_46368,axiom,
    ! [VarCurr: state_type] :
      ( v73307(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_46367,axiom,
    ! [VarCurr: state_type] :
      ( v73301(VarCurr)
    <=> v73303(VarCurr) ) ).

tff(addAssignment_46366,axiom,
    ! [VarCurr: state_type] :
      ( v73303(VarCurr)
    <=> v67349(VarCurr,75) ) ).

tff(addAssignment_46365,axiom,
    ! [VarCurr: state_type] :
      ( v73197(VarCurr)
    <=> v73199(VarCurr) ) ).

tff(addAssignment_46364,axiom,
    ! [VarCurr: state_type] :
      ( v73199(VarCurr)
    <=> v73201(VarCurr) ) ).

tff(addAssignment_46363,axiom,
    ! [VarCurr: state_type] :
      ( v73201(VarCurr)
    <=> v73203(VarCurr) ) ).

tff(addAssignment_46362,axiom,
    ! [VarCurr: state_type] :
      ( v73203(VarCurr)
    <=> v73205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6837,axiom,
    ! [VarCurr: state_type] :
      ( v73205(VarCurr)
    <=> ( v73279(VarCurr)
      <~> v73255(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6836,axiom,
    ! [VarCurr: state_type] :
      ( v73279(VarCurr)
    <=> ( v73207(VarCurr)
      <~> v73231(VarCurr) ) ) ).

tff(addAssignment_46361,axiom,
    ! [VarCurr: state_type] :
      ( v73255(VarCurr)
    <=> v73257(VarCurr) ) ).

tff(addAssignment_46360,axiom,
    ! [VarCurr: state_type] :
      ( v73257(VarCurr)
    <=> v73259(VarCurr) ) ).

tff(addAssignment_46359,axiom,
    ! [VarCurr: state_type] :
      ( v73259(VarCurr)
    <=> v73261(VarCurr) ) ).

tff(addAssignment_46358,axiom,
    ! [VarCurr: state_type] :
      ( v73261(VarCurr)
    <=> v73263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6835,axiom,
    ! [VarCurr: state_type] :
      ( v73263(VarCurr)
    <=> ( v73277(VarCurr)
      <~> v73273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6834,axiom,
    ! [VarCurr: state_type] :
      ( v73277(VarCurr)
    <=> ( v73265(VarCurr)
      <~> v73269(VarCurr) ) ) ).

tff(addAssignment_46357,axiom,
    ! [VarCurr: state_type] :
      ( v73273(VarCurr)
    <=> v73275(VarCurr) ) ).

tff(addAssignment_46356,axiom,
    ! [VarCurr: state_type] :
      ( v73275(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_46355,axiom,
    ! [VarCurr: state_type] :
      ( v73269(VarCurr)
    <=> v73271(VarCurr) ) ).

tff(addAssignment_46354,axiom,
    ! [VarCurr: state_type] :
      ( v73271(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_46353,axiom,
    ! [VarCurr: state_type] :
      ( v73265(VarCurr)
    <=> v73267(VarCurr) ) ).

tff(addAssignment_46352,axiom,
    ! [VarCurr: state_type] :
      ( v73267(VarCurr)
    <=> v67349(VarCurr,66) ) ).

tff(addAssignment_46351,axiom,
    ! [VarCurr: state_type] :
      ( v73231(VarCurr)
    <=> v73233(VarCurr) ) ).

tff(addAssignment_46350,axiom,
    ! [VarCurr: state_type] :
      ( v73233(VarCurr)
    <=> v73235(VarCurr) ) ).

tff(addAssignment_46349,axiom,
    ! [VarCurr: state_type] :
      ( v73235(VarCurr)
    <=> v73237(VarCurr) ) ).

tff(addAssignment_46348,axiom,
    ! [VarCurr: state_type] :
      ( v73237(VarCurr)
    <=> v73239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6833,axiom,
    ! [VarCurr: state_type] :
      ( v73239(VarCurr)
    <=> ( v73253(VarCurr)
      <~> v73249(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6832,axiom,
    ! [VarCurr: state_type] :
      ( v73253(VarCurr)
    <=> ( v73241(VarCurr)
      <~> v73245(VarCurr) ) ) ).

tff(addAssignment_46347,axiom,
    ! [VarCurr: state_type] :
      ( v73249(VarCurr)
    <=> v73251(VarCurr) ) ).

tff(addAssignment_46346,axiom,
    ! [VarCurr: state_type] :
      ( v73251(VarCurr)
    <=> v67349(VarCurr,61) ) ).

tff(addAssignment_46345,axiom,
    ! [VarCurr: state_type] :
      ( v73245(VarCurr)
    <=> v73247(VarCurr) ) ).

tff(addAssignment_46344,axiom,
    ! [VarCurr: state_type] :
      ( v73247(VarCurr)
    <=> v67349(VarCurr,58) ) ).

tff(addAssignment_46343,axiom,
    ! [VarCurr: state_type] :
      ( v73241(VarCurr)
    <=> v73243(VarCurr) ) ).

tff(addAssignment_46342,axiom,
    ! [VarCurr: state_type] :
      ( v73243(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_46341,axiom,
    ! [VarCurr: state_type] :
      ( v73207(VarCurr)
    <=> v73209(VarCurr) ) ).

tff(addAssignment_46340,axiom,
    ! [VarCurr: state_type] :
      ( v73209(VarCurr)
    <=> v73211(VarCurr) ) ).

tff(addAssignment_46339,axiom,
    ! [VarCurr: state_type] :
      ( v73211(VarCurr)
    <=> v73213(VarCurr) ) ).

tff(addAssignment_46338,axiom,
    ! [VarCurr: state_type] :
      ( v73213(VarCurr)
    <=> v73215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6831,axiom,
    ! [VarCurr: state_type] :
      ( v73215(VarCurr)
    <=> ( v73229(VarCurr)
      <~> v73225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6830,axiom,
    ! [VarCurr: state_type] :
      ( v73229(VarCurr)
    <=> ( v73217(VarCurr)
      <~> v73221(VarCurr) ) ) ).

tff(addAssignment_46337,axiom,
    ! [VarCurr: state_type] :
      ( v73225(VarCurr)
    <=> v73227(VarCurr) ) ).

tff(addAssignment_46336,axiom,
    ! [VarCurr: state_type] :
      ( v73227(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_46335,axiom,
    ! [VarCurr: state_type] :
      ( v73221(VarCurr)
    <=> v73223(VarCurr) ) ).

tff(addAssignment_46334,axiom,
    ! [VarCurr: state_type] :
      ( v73223(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_46333,axiom,
    ! [VarCurr: state_type] :
      ( v73217(VarCurr)
    <=> v73219(VarCurr) ) ).

tff(addAssignment_46332,axiom,
    ! [VarCurr: state_type] :
      ( v73219(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_46331,axiom,
    ! [VarCurr: state_type] :
      ( v72923(VarCurr)
    <=> v72925(VarCurr) ) ).

tff(addAssignment_46330,axiom,
    ! [VarCurr: state_type] :
      ( v72925(VarCurr)
    <=> v72927(VarCurr) ) ).

tff(addAssignment_46329,axiom,
    ! [VarCurr: state_type] :
      ( v72927(VarCurr)
    <=> v72929(VarCurr) ) ).

tff(addAssignment_46328,axiom,
    ! [VarCurr: state_type] :
      ( v72929(VarCurr)
    <=> v72931(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6829,axiom,
    ! [VarCurr: state_type] :
      ( v72931(VarCurr)
    <=> ( v73185(VarCurr)
      <~> v73101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6828,axiom,
    ! [VarCurr: state_type] :
      ( v73185(VarCurr)
    <=> ( v72933(VarCurr)
      <~> v73017(VarCurr) ) ) ).

tff(addAssignment_46327,axiom,
    ! [VarCurr: state_type] :
      ( v73101(VarCurr)
    <=> v73103(VarCurr) ) ).

tff(addAssignment_46326,axiom,
    ! [VarCurr: state_type] :
      ( v73103(VarCurr)
    <=> v73105(VarCurr) ) ).

tff(addAssignment_46325,axiom,
    ! [VarCurr: state_type] :
      ( v73105(VarCurr)
    <=> v73107(VarCurr) ) ).

tff(addAssignment_46324,axiom,
    ! [VarCurr: state_type] :
      ( v73107(VarCurr)
    <=> v73109(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6827,axiom,
    ! [VarCurr: state_type] :
      ( v73109(VarCurr)
    <=> ( v73183(VarCurr)
      <~> v73159(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6826,axiom,
    ! [VarCurr: state_type] :
      ( v73183(VarCurr)
    <=> ( v73111(VarCurr)
      <~> v73135(VarCurr) ) ) ).

tff(addAssignment_46323,axiom,
    ! [VarCurr: state_type] :
      ( v73159(VarCurr)
    <=> v73161(VarCurr) ) ).

tff(addAssignment_46322,axiom,
    ! [VarCurr: state_type] :
      ( v73161(VarCurr)
    <=> v73163(VarCurr) ) ).

tff(addAssignment_46321,axiom,
    ! [VarCurr: state_type] :
      ( v73163(VarCurr)
    <=> v73165(VarCurr) ) ).

tff(addAssignment_46320,axiom,
    ! [VarCurr: state_type] :
      ( v73165(VarCurr)
    <=> v73167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6825,axiom,
    ! [VarCurr: state_type] :
      ( v73167(VarCurr)
    <=> ( v73181(VarCurr)
      <~> v73177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6824,axiom,
    ! [VarCurr: state_type] :
      ( v73181(VarCurr)
    <=> ( v73169(VarCurr)
      <~> v73173(VarCurr) ) ) ).

tff(addAssignment_46319,axiom,
    ! [VarCurr: state_type] :
      ( v73177(VarCurr)
    <=> v73179(VarCurr) ) ).

tff(addAssignment_46318,axiom,
    ! [VarCurr: state_type] :
      ( v73179(VarCurr)
    <=> v67349(VarCurr,51) ) ).

tff(addAssignment_46317,axiom,
    ! [VarCurr: state_type] :
      ( v73173(VarCurr)
    <=> v73175(VarCurr) ) ).

tff(addAssignment_46316,axiom,
    ! [VarCurr: state_type] :
      ( v73175(VarCurr)
    <=> v67349(VarCurr,50) ) ).

tff(addAssignment_46315,axiom,
    ! [VarCurr: state_type] :
      ( v73169(VarCurr)
    <=> v73171(VarCurr) ) ).

tff(addAssignment_46314,axiom,
    ! [VarCurr: state_type] :
      ( v73171(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_46313,axiom,
    ! [VarCurr: state_type] :
      ( v73135(VarCurr)
    <=> v73137(VarCurr) ) ).

tff(addAssignment_46312,axiom,
    ! [VarCurr: state_type] :
      ( v73137(VarCurr)
    <=> v73139(VarCurr) ) ).

tff(addAssignment_46311,axiom,
    ! [VarCurr: state_type] :
      ( v73139(VarCurr)
    <=> v73141(VarCurr) ) ).

tff(addAssignment_46310,axiom,
    ! [VarCurr: state_type] :
      ( v73141(VarCurr)
    <=> v73143(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6823,axiom,
    ! [VarCurr: state_type] :
      ( v73143(VarCurr)
    <=> ( v73157(VarCurr)
      <~> v73153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6822,axiom,
    ! [VarCurr: state_type] :
      ( v73157(VarCurr)
    <=> ( v73145(VarCurr)
      <~> v73149(VarCurr) ) ) ).

tff(addAssignment_46309,axiom,
    ! [VarCurr: state_type] :
      ( v73153(VarCurr)
    <=> v73155(VarCurr) ) ).

tff(addAssignment_46308,axiom,
    ! [VarCurr: state_type] :
      ( v73155(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_46307,axiom,
    ! [VarCurr: state_type] :
      ( v73149(VarCurr)
    <=> v73151(VarCurr) ) ).

tff(addAssignment_46306,axiom,
    ! [VarCurr: state_type] :
      ( v73151(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_46305,axiom,
    ! [VarCurr: state_type] :
      ( v73145(VarCurr)
    <=> v73147(VarCurr) ) ).

tff(addAssignment_46304,axiom,
    ! [VarCurr: state_type] :
      ( v73147(VarCurr)
    <=> v67349(VarCurr,44) ) ).

tff(addAssignment_46303,axiom,
    ! [VarCurr: state_type] :
      ( v73111(VarCurr)
    <=> v73113(VarCurr) ) ).

tff(addAssignment_46302,axiom,
    ! [VarCurr: state_type] :
      ( v73113(VarCurr)
    <=> v73115(VarCurr) ) ).

tff(addAssignment_46301,axiom,
    ! [VarCurr: state_type] :
      ( v73115(VarCurr)
    <=> v73117(VarCurr) ) ).

tff(addAssignment_46300,axiom,
    ! [VarCurr: state_type] :
      ( v73117(VarCurr)
    <=> v73119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6821,axiom,
    ! [VarCurr: state_type] :
      ( v73119(VarCurr)
    <=> ( v73133(VarCurr)
      <~> v73129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6820,axiom,
    ! [VarCurr: state_type] :
      ( v73133(VarCurr)
    <=> ( v73121(VarCurr)
      <~> v73125(VarCurr) ) ) ).

tff(addAssignment_46299,axiom,
    ! [VarCurr: state_type] :
      ( v73129(VarCurr)
    <=> v73131(VarCurr) ) ).

tff(addAssignment_46298,axiom,
    ! [VarCurr: state_type] :
      ( v73131(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_46297,axiom,
    ! [VarCurr: state_type] :
      ( v73125(VarCurr)
    <=> v73127(VarCurr) ) ).

tff(addAssignment_46296,axiom,
    ! [VarCurr: state_type] :
      ( v73127(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_46295,axiom,
    ! [VarCurr: state_type] :
      ( v73121(VarCurr)
    <=> v73123(VarCurr) ) ).

tff(addAssignment_46294,axiom,
    ! [VarCurr: state_type] :
      ( v73123(VarCurr)
    <=> v67349(VarCurr,41) ) ).

tff(addAssignment_46293,axiom,
    ! [VarCurr: state_type] :
      ( v73017(VarCurr)
    <=> v73019(VarCurr) ) ).

tff(addAssignment_46292,axiom,
    ! [VarCurr: state_type] :
      ( v73019(VarCurr)
    <=> v73021(VarCurr) ) ).

tff(addAssignment_46291,axiom,
    ! [VarCurr: state_type] :
      ( v73021(VarCurr)
    <=> v73023(VarCurr) ) ).

tff(addAssignment_46290,axiom,
    ! [VarCurr: state_type] :
      ( v73023(VarCurr)
    <=> v73025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6819,axiom,
    ! [VarCurr: state_type] :
      ( v73025(VarCurr)
    <=> ( v73099(VarCurr)
      <~> v73075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6818,axiom,
    ! [VarCurr: state_type] :
      ( v73099(VarCurr)
    <=> ( v73027(VarCurr)
      <~> v73051(VarCurr) ) ) ).

tff(addAssignment_46289,axiom,
    ! [VarCurr: state_type] :
      ( v73075(VarCurr)
    <=> v73077(VarCurr) ) ).

tff(addAssignment_46288,axiom,
    ! [VarCurr: state_type] :
      ( v73077(VarCurr)
    <=> v73079(VarCurr) ) ).

tff(addAssignment_46287,axiom,
    ! [VarCurr: state_type] :
      ( v73079(VarCurr)
    <=> v73081(VarCurr) ) ).

tff(addAssignment_46286,axiom,
    ! [VarCurr: state_type] :
      ( v73081(VarCurr)
    <=> v73083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6817,axiom,
    ! [VarCurr: state_type] :
      ( v73083(VarCurr)
    <=> ( v73097(VarCurr)
      <~> v73093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6816,axiom,
    ! [VarCurr: state_type] :
      ( v73097(VarCurr)
    <=> ( v73085(VarCurr)
      <~> v73089(VarCurr) ) ) ).

tff(addAssignment_46285,axiom,
    ! [VarCurr: state_type] :
      ( v73093(VarCurr)
    <=> v73095(VarCurr) ) ).

tff(addAssignment_46284,axiom,
    ! [VarCurr: state_type] :
      ( v73095(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_46283,axiom,
    ! [VarCurr: state_type] :
      ( v73089(VarCurr)
    <=> v73091(VarCurr) ) ).

tff(addAssignment_46282,axiom,
    ! [VarCurr: state_type] :
      ( v73091(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_46281,axiom,
    ! [VarCurr: state_type] :
      ( v73085(VarCurr)
    <=> v73087(VarCurr) ) ).

tff(addAssignment_46280,axiom,
    ! [VarCurr: state_type] :
      ( v73087(VarCurr)
    <=> v67349(VarCurr,35) ) ).

tff(addAssignment_46279,axiom,
    ! [VarCurr: state_type] :
      ( v73051(VarCurr)
    <=> v73053(VarCurr) ) ).

tff(addAssignment_46278,axiom,
    ! [VarCurr: state_type] :
      ( v73053(VarCurr)
    <=> v73055(VarCurr) ) ).

tff(addAssignment_46277,axiom,
    ! [VarCurr: state_type] :
      ( v73055(VarCurr)
    <=> v73057(VarCurr) ) ).

tff(addAssignment_46276,axiom,
    ! [VarCurr: state_type] :
      ( v73057(VarCurr)
    <=> v73059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6815,axiom,
    ! [VarCurr: state_type] :
      ( v73059(VarCurr)
    <=> ( v73073(VarCurr)
      <~> v73069(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6814,axiom,
    ! [VarCurr: state_type] :
      ( v73073(VarCurr)
    <=> ( v73061(VarCurr)
      <~> v73065(VarCurr) ) ) ).

tff(addAssignment_46275,axiom,
    ! [VarCurr: state_type] :
      ( v73069(VarCurr)
    <=> v73071(VarCurr) ) ).

tff(addAssignment_46274,axiom,
    ! [VarCurr: state_type] :
      ( v73071(VarCurr)
    <=> v67349(VarCurr,32) ) ).

tff(addAssignment_46273,axiom,
    ! [VarCurr: state_type] :
      ( v73065(VarCurr)
    <=> v73067(VarCurr) ) ).

tff(addAssignment_46272,axiom,
    ! [VarCurr: state_type] :
      ( v73067(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_46271,axiom,
    ! [VarCurr: state_type] :
      ( v73061(VarCurr)
    <=> v73063(VarCurr) ) ).

tff(addAssignment_46270,axiom,
    ! [VarCurr: state_type] :
      ( v73063(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_46269,axiom,
    ! [VarCurr: state_type] :
      ( v73027(VarCurr)
    <=> v73029(VarCurr) ) ).

tff(addAssignment_46268,axiom,
    ! [VarCurr: state_type] :
      ( v73029(VarCurr)
    <=> v73031(VarCurr) ) ).

tff(addAssignment_46267,axiom,
    ! [VarCurr: state_type] :
      ( v73031(VarCurr)
    <=> v73033(VarCurr) ) ).

tff(addAssignment_46266,axiom,
    ! [VarCurr: state_type] :
      ( v73033(VarCurr)
    <=> v73035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6813,axiom,
    ! [VarCurr: state_type] :
      ( v73035(VarCurr)
    <=> ( v73049(VarCurr)
      <~> v73045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6812,axiom,
    ! [VarCurr: state_type] :
      ( v73049(VarCurr)
    <=> ( v73037(VarCurr)
      <~> v73041(VarCurr) ) ) ).

tff(addAssignment_46265,axiom,
    ! [VarCurr: state_type] :
      ( v73045(VarCurr)
    <=> v73047(VarCurr) ) ).

tff(addAssignment_46264,axiom,
    ! [VarCurr: state_type] :
      ( v73047(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_46263,axiom,
    ! [VarCurr: state_type] :
      ( v73041(VarCurr)
    <=> v73043(VarCurr) ) ).

tff(addAssignment_46262,axiom,
    ! [VarCurr: state_type] :
      ( v73043(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_46261,axiom,
    ! [VarCurr: state_type] :
      ( v73037(VarCurr)
    <=> v73039(VarCurr) ) ).

tff(addAssignment_46260,axiom,
    ! [VarCurr: state_type] :
      ( v73039(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_46259,axiom,
    ! [VarCurr: state_type] :
      ( v72933(VarCurr)
    <=> v72935(VarCurr) ) ).

tff(addAssignment_46258,axiom,
    ! [VarCurr: state_type] :
      ( v72935(VarCurr)
    <=> v72937(VarCurr) ) ).

tff(addAssignment_46257,axiom,
    ! [VarCurr: state_type] :
      ( v72937(VarCurr)
    <=> v72939(VarCurr) ) ).

tff(addAssignment_46256,axiom,
    ! [VarCurr: state_type] :
      ( v72939(VarCurr)
    <=> v72941(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6811,axiom,
    ! [VarCurr: state_type] :
      ( v72941(VarCurr)
    <=> ( v73015(VarCurr)
      <~> v72991(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6810,axiom,
    ! [VarCurr: state_type] :
      ( v73015(VarCurr)
    <=> ( v72943(VarCurr)
      <~> v72967(VarCurr) ) ) ).

tff(addAssignment_46255,axiom,
    ! [VarCurr: state_type] :
      ( v72991(VarCurr)
    <=> v72993(VarCurr) ) ).

tff(addAssignment_46254,axiom,
    ! [VarCurr: state_type] :
      ( v72993(VarCurr)
    <=> v72995(VarCurr) ) ).

tff(addAssignment_46253,axiom,
    ! [VarCurr: state_type] :
      ( v72995(VarCurr)
    <=> v72997(VarCurr) ) ).

tff(addAssignment_46252,axiom,
    ! [VarCurr: state_type] :
      ( v72997(VarCurr)
    <=> v72999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6809,axiom,
    ! [VarCurr: state_type] :
      ( v72999(VarCurr)
    <=> ( v73013(VarCurr)
      <~> v73009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6808,axiom,
    ! [VarCurr: state_type] :
      ( v73013(VarCurr)
    <=> ( v73001(VarCurr)
      <~> v73005(VarCurr) ) ) ).

tff(addAssignment_46251,axiom,
    ! [VarCurr: state_type] :
      ( v73009(VarCurr)
    <=> v73011(VarCurr) ) ).

tff(addAssignment_46250,axiom,
    ! [VarCurr: state_type] :
      ( v73011(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_46249,axiom,
    ! [VarCurr: state_type] :
      ( v73005(VarCurr)
    <=> v73007(VarCurr) ) ).

tff(addAssignment_46248,axiom,
    ! [VarCurr: state_type] :
      ( v73007(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_46247,axiom,
    ! [VarCurr: state_type] :
      ( v73001(VarCurr)
    <=> v73003(VarCurr) ) ).

tff(addAssignment_46246,axiom,
    ! [VarCurr: state_type] :
      ( v73003(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_46245,axiom,
    ! [VarCurr: state_type] :
      ( v72967(VarCurr)
    <=> v72969(VarCurr) ) ).

tff(addAssignment_46244,axiom,
    ! [VarCurr: state_type] :
      ( v72969(VarCurr)
    <=> v72971(VarCurr) ) ).

tff(addAssignment_46243,axiom,
    ! [VarCurr: state_type] :
      ( v72971(VarCurr)
    <=> v72973(VarCurr) ) ).

tff(addAssignment_46242,axiom,
    ! [VarCurr: state_type] :
      ( v72973(VarCurr)
    <=> v72975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6807,axiom,
    ! [VarCurr: state_type] :
      ( v72975(VarCurr)
    <=> ( v72989(VarCurr)
      <~> v72985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6806,axiom,
    ! [VarCurr: state_type] :
      ( v72989(VarCurr)
    <=> ( v72977(VarCurr)
      <~> v72981(VarCurr) ) ) ).

tff(addAssignment_46241,axiom,
    ! [VarCurr: state_type] :
      ( v72985(VarCurr)
    <=> v72987(VarCurr) ) ).

tff(addAssignment_46240,axiom,
    ! [VarCurr: state_type] :
      ( v72987(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_46239,axiom,
    ! [VarCurr: state_type] :
      ( v72981(VarCurr)
    <=> v72983(VarCurr) ) ).

tff(addAssignment_46238,axiom,
    ! [VarCurr: state_type] :
      ( v72983(VarCurr)
    <=> v67349(VarCurr,15) ) ).

tff(addAssignment_46237,axiom,
    ! [VarCurr: state_type] :
      ( v72977(VarCurr)
    <=> v72979(VarCurr) ) ).

tff(addAssignment_46236,axiom,
    ! [VarCurr: state_type] :
      ( v72979(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_46235,axiom,
    ! [VarCurr: state_type] :
      ( v72943(VarCurr)
    <=> v72945(VarCurr) ) ).

tff(addAssignment_46234,axiom,
    ! [VarCurr: state_type] :
      ( v72945(VarCurr)
    <=> v72947(VarCurr) ) ).

tff(addAssignment_46233,axiom,
    ! [VarCurr: state_type] :
      ( v72947(VarCurr)
    <=> v72949(VarCurr) ) ).

tff(addAssignment_46232,axiom,
    ! [VarCurr: state_type] :
      ( v72949(VarCurr)
    <=> v72951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6805,axiom,
    ! [VarCurr: state_type] :
      ( v72951(VarCurr)
    <=> ( v72965(VarCurr)
      <~> v72961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6804,axiom,
    ! [VarCurr: state_type] :
      ( v72965(VarCurr)
    <=> ( v72953(VarCurr)
      <~> v72957(VarCurr) ) ) ).

tff(addAssignment_46231,axiom,
    ! [VarCurr: state_type] :
      ( v72961(VarCurr)
    <=> v72963(VarCurr) ) ).

tff(addAssignment_46230,axiom,
    ! [VarCurr: state_type] :
      ( v72963(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_46229,axiom,
    ! [VarCurr: state_type] :
      ( v72957(VarCurr)
    <=> v72959(VarCurr) ) ).

tff(addAssignment_46228,axiom,
    ! [VarCurr: state_type] :
      ( v72959(VarCurr)
    <=> v67349(VarCurr,6) ) ).

tff(addAssignment_46227,axiom,
    ! [VarCurr: state_type] :
      ( v72953(VarCurr)
    <=> v72955(VarCurr) ) ).

tff(addAssignment_46226,axiom,
    ! [VarCurr: state_type] :
      ( v72955(VarCurr)
    <=> v67349(VarCurr,1) ) ).

tff(addAssignment_46225,axiom,
    ! [VarCurr: state_type] :
      ( v71546(VarCurr)
    <=> v71548(VarCurr) ) ).

tff(addAssignment_46224,axiom,
    ! [VarCurr: state_type] :
      ( v71548(VarCurr)
    <=> v71550(VarCurr) ) ).

tff(addAssignment_46223,axiom,
    ! [VarCurr: state_type] :
      ( v71550(VarCurr)
    <=> v71552(VarCurr) ) ).

tff(addAssignment_46222,axiom,
    ! [VarCurr: state_type] :
      ( v71552(VarCurr)
    <=> v71554(VarCurr) ) ).

tff(writeUnaryOperator_3441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v71554(VarCurr)
    <=> v72903(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6803,axiom,
    ! [VarCurr: state_type] :
      ( v72903(VarCurr)
    <=> ( v71556(VarCurr)
        | v72233(VarCurr) ) ) ).

tff(addAssignment_46221,axiom,
    ! [VarCurr: state_type] :
      ( v72233(VarCurr)
    <=> v72235(VarCurr) ) ).

tff(addAssignment_46220,axiom,
    ! [VarCurr: state_type] :
      ( v72235(VarCurr)
    <=> v71560(VarCurr,2) ) ).

tff(addAssignment_46219,axiom,
    ! [VarCurr: state_type] :
      ( v71560(VarCurr,2)
    <=> v67309(VarCurr,2) ) ).

tff(addAssignment_46218,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,2)
    <=> v67311(VarCurr,2) ) ).

tff(addAssignment_46217,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,2)
    <=> v67313(VarCurr,2) ) ).

tff(addAssignment_46216,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,2)
    <=> v67315(VarCurr,2) ) ).

tff(addAssignment_46215,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,2)
    <=> v67317(VarCurr,2) ) ).

tff(addAssignment_46214,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,2)
    <=> v68771(VarCurr,2) ) ).

tff(addAssignment_46213,axiom,
    ! [VarCurr: state_type] :
      ( v68774(VarCurr,2)
    <=> v72237(VarCurr) ) ).

tff(addAssignment_46212,axiom,
    ! [VarCurr: state_type] :
      ( v72237(VarCurr)
    <=> v72239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6802,axiom,
    ! [VarCurr: state_type] :
      ( v72239(VarCurr)
    <=> ( v72901(VarCurr)
      <~> v72769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6801,axiom,
    ! [VarCurr: state_type] :
      ( v72901(VarCurr)
    <=> ( v72241(VarCurr)
      <~> v72505(VarCurr) ) ) ).

tff(addAssignment_46211,axiom,
    ! [VarCurr: state_type] :
      ( v72769(VarCurr)
    <=> v72771(VarCurr) ) ).

tff(addAssignment_46210,axiom,
    ! [VarCurr: state_type] :
      ( v72771(VarCurr)
    <=> v72773(VarCurr) ) ).

tff(addAssignment_46209,axiom,
    ! [VarCurr: state_type] :
      ( v72773(VarCurr)
    <=> v72775(VarCurr) ) ).

tff(addAssignment_46208,axiom,
    ! [VarCurr: state_type] :
      ( v72775(VarCurr)
    <=> v72777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6800,axiom,
    ! [VarCurr: state_type] :
      ( v72777(VarCurr)
    <=> ( v72899(VarCurr)
      <~> v72887(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6799,axiom,
    ! [VarCurr: state_type] :
      ( v72899(VarCurr)
    <=> ( v72779(VarCurr)
      <~> v72803(VarCurr) ) ) ).

tff(addAssignment_46207,axiom,
    ! [VarCurr: state_type] :
      ( v72887(VarCurr)
    <=> v72889(VarCurr) ) ).

tff(addAssignment_46206,axiom,
    ! [VarCurr: state_type] :
      ( v72889(VarCurr)
    <=> v72217(VarCurr,2) ) ).

tff(addAssignment_46205,axiom,
    ! [VarCurr: state_type] :
      ( v72217(VarCurr,2)
    <=> v72219(VarCurr,2) ) ).

tff(addAssignment_46204,axiom,
    ! [VarCurr: state_type] :
      ( v72219(VarCurr,2)
    <=> v68595(VarCurr,3) ) ).

tff(addAssignment_46203,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,3)
    <=> v68597(VarCurr,3) ) ).

tff(addAssignment_46202,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,3)
    <=> v72891(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v72892(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v72891(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_903,axiom,
    ! [VarNext: state_type] :
      ( v72892(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v72891(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v72892(VarNext)
      <=> v72893(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v72893(VarNext)
      <=> ( v72895(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v72895(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_46201,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,3)
    <=> v68621(VarCurr,3) ) ).

tff(addAssignment_46200,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,3)
    <=> v68624(VarCurr,3) ) ).

tff(addAssignment_46199,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,2)
    <=> v68455(VarCurr,2) ) ).

tff(addAssignment_46198,axiom,
    ! [VarCurr: state_type] :
      ( v72803(VarCurr)
    <=> v72805(VarCurr) ) ).

tff(addAssignment_46197,axiom,
    ! [VarCurr: state_type] :
      ( v72805(VarCurr)
    <=> v72807(VarCurr) ) ).

tff(addAssignment_46196,axiom,
    ! [VarCurr: state_type] :
      ( v72807(VarCurr)
    <=> v72809(VarCurr) ) ).

tff(addAssignment_46195,axiom,
    ! [VarCurr: state_type] :
      ( v72809(VarCurr)
    <=> v72811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6796,axiom,
    ! [VarCurr: state_type] :
      ( v72811(VarCurr)
    <=> ( v72885(VarCurr)
      <~> v72861(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6795,axiom,
    ! [VarCurr: state_type] :
      ( v72885(VarCurr)
    <=> ( v72813(VarCurr)
      <~> v72837(VarCurr) ) ) ).

tff(addAssignment_46194,axiom,
    ! [VarCurr: state_type] :
      ( v72861(VarCurr)
    <=> v72863(VarCurr) ) ).

tff(addAssignment_46193,axiom,
    ! [VarCurr: state_type] :
      ( v72863(VarCurr)
    <=> v72865(VarCurr) ) ).

tff(addAssignment_46192,axiom,
    ! [VarCurr: state_type] :
      ( v72865(VarCurr)
    <=> v72867(VarCurr) ) ).

tff(addAssignment_46191,axiom,
    ! [VarCurr: state_type] :
      ( v72867(VarCurr)
    <=> v72869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6794,axiom,
    ! [VarCurr: state_type] :
      ( v72869(VarCurr)
    <=> ( v72883(VarCurr)
      <~> v72879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6793,axiom,
    ! [VarCurr: state_type] :
      ( v72883(VarCurr)
    <=> ( v72871(VarCurr)
      <~> v72875(VarCurr) ) ) ).

tff(addAssignment_46190,axiom,
    ! [VarCurr: state_type] :
      ( v72879(VarCurr)
    <=> v72881(VarCurr) ) ).

tff(addAssignment_46189,axiom,
    ! [VarCurr: state_type] :
      ( v72881(VarCurr)
    <=> v67349(VarCurr,118) ) ).

tff(addAssignment_46188,axiom,
    ! [VarCurr: state_type] :
      ( v72875(VarCurr)
    <=> v72877(VarCurr) ) ).

tff(addAssignment_46187,axiom,
    ! [VarCurr: state_type] :
      ( v72877(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_46186,axiom,
    ! [VarCurr: state_type] :
      ( v72871(VarCurr)
    <=> v72873(VarCurr) ) ).

tff(addAssignment_46185,axiom,
    ! [VarCurr: state_type] :
      ( v72873(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_46184,axiom,
    ! [VarCurr: state_type] :
      ( v72837(VarCurr)
    <=> v72839(VarCurr) ) ).

tff(addAssignment_46183,axiom,
    ! [VarCurr: state_type] :
      ( v72839(VarCurr)
    <=> v72841(VarCurr) ) ).

tff(addAssignment_46182,axiom,
    ! [VarCurr: state_type] :
      ( v72841(VarCurr)
    <=> v72843(VarCurr) ) ).

tff(addAssignment_46181,axiom,
    ! [VarCurr: state_type] :
      ( v72843(VarCurr)
    <=> v72845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6792,axiom,
    ! [VarCurr: state_type] :
      ( v72845(VarCurr)
    <=> ( v72859(VarCurr)
      <~> v72855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6791,axiom,
    ! [VarCurr: state_type] :
      ( v72859(VarCurr)
    <=> ( v72847(VarCurr)
      <~> v72851(VarCurr) ) ) ).

tff(addAssignment_46180,axiom,
    ! [VarCurr: state_type] :
      ( v72855(VarCurr)
    <=> v72857(VarCurr) ) ).

tff(addAssignment_46179,axiom,
    ! [VarCurr: state_type] :
      ( v72857(VarCurr)
    <=> v67349(VarCurr,111) ) ).

tff(addAssignment_46178,axiom,
    ! [VarCurr: state_type] :
      ( v72851(VarCurr)
    <=> v72853(VarCurr) ) ).

tff(addAssignment_46177,axiom,
    ! [VarCurr: state_type] :
      ( v72853(VarCurr)
    <=> v67349(VarCurr,108) ) ).

tff(addAssignment_46176,axiom,
    ! [VarCurr: state_type] :
      ( v72847(VarCurr)
    <=> v72849(VarCurr) ) ).

tff(addAssignment_46175,axiom,
    ! [VarCurr: state_type] :
      ( v72849(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_46174,axiom,
    ! [VarCurr: state_type] :
      ( v72813(VarCurr)
    <=> v72815(VarCurr) ) ).

tff(addAssignment_46173,axiom,
    ! [VarCurr: state_type] :
      ( v72815(VarCurr)
    <=> v72817(VarCurr) ) ).

tff(addAssignment_46172,axiom,
    ! [VarCurr: state_type] :
      ( v72817(VarCurr)
    <=> v72819(VarCurr) ) ).

tff(addAssignment_46171,axiom,
    ! [VarCurr: state_type] :
      ( v72819(VarCurr)
    <=> v72821(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6790,axiom,
    ! [VarCurr: state_type] :
      ( v72821(VarCurr)
    <=> ( v72835(VarCurr)
      <~> v72831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6789,axiom,
    ! [VarCurr: state_type] :
      ( v72835(VarCurr)
    <=> ( v72823(VarCurr)
      <~> v72827(VarCurr) ) ) ).

tff(addAssignment_46170,axiom,
    ! [VarCurr: state_type] :
      ( v72831(VarCurr)
    <=> v72833(VarCurr) ) ).

tff(addAssignment_46169,axiom,
    ! [VarCurr: state_type] :
      ( v72833(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_46168,axiom,
    ! [VarCurr: state_type] :
      ( v72827(VarCurr)
    <=> v72829(VarCurr) ) ).

tff(addAssignment_46167,axiom,
    ! [VarCurr: state_type] :
      ( v72829(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_46166,axiom,
    ! [VarCurr: state_type] :
      ( v72823(VarCurr)
    <=> v72825(VarCurr) ) ).

tff(addAssignment_46165,axiom,
    ! [VarCurr: state_type] :
      ( v72825(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_46164,axiom,
    ! [VarCurr: state_type] :
      ( v72779(VarCurr)
    <=> v72781(VarCurr) ) ).

tff(addAssignment_46163,axiom,
    ! [VarCurr: state_type] :
      ( v72781(VarCurr)
    <=> v72783(VarCurr) ) ).

tff(addAssignment_46162,axiom,
    ! [VarCurr: state_type] :
      ( v72783(VarCurr)
    <=> v72785(VarCurr) ) ).

tff(addAssignment_46161,axiom,
    ! [VarCurr: state_type] :
      ( v72785(VarCurr)
    <=> v72787(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6788,axiom,
    ! [VarCurr: state_type] :
      ( v72787(VarCurr)
    <=> ( v72801(VarCurr)
      <~> v72797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6787,axiom,
    ! [VarCurr: state_type] :
      ( v72801(VarCurr)
    <=> ( v72789(VarCurr)
      <~> v72793(VarCurr) ) ) ).

tff(addAssignment_46160,axiom,
    ! [VarCurr: state_type] :
      ( v72797(VarCurr)
    <=> v72799(VarCurr) ) ).

tff(addAssignment_46159,axiom,
    ! [VarCurr: state_type] :
      ( v72799(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_46158,axiom,
    ! [VarCurr: state_type] :
      ( v72793(VarCurr)
    <=> v72795(VarCurr) ) ).

tff(addAssignment_46157,axiom,
    ! [VarCurr: state_type] :
      ( v72795(VarCurr)
    <=> v67349(VarCurr,122) ) ).

tff(addAssignment_46156,axiom,
    ! [VarCurr: state_type] :
      ( v72789(VarCurr)
    <=> v72791(VarCurr) ) ).

tff(addAssignment_46155,axiom,
    ! [VarCurr: state_type] :
      ( v72791(VarCurr)
    <=> v67349(VarCurr,119) ) ).

tff(addAssignment_46154,axiom,
    ! [VarCurr: state_type] :
      ( v72505(VarCurr)
    <=> v72507(VarCurr) ) ).

tff(addAssignment_46153,axiom,
    ! [VarCurr: state_type] :
      ( v72507(VarCurr)
    <=> v72509(VarCurr) ) ).

tff(addAssignment_46152,axiom,
    ! [VarCurr: state_type] :
      ( v72509(VarCurr)
    <=> v72511(VarCurr) ) ).

tff(addAssignment_46151,axiom,
    ! [VarCurr: state_type] :
      ( v72511(VarCurr)
    <=> v72513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6786,axiom,
    ! [VarCurr: state_type] :
      ( v72513(VarCurr)
    <=> ( v72767(VarCurr)
      <~> v72683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6785,axiom,
    ! [VarCurr: state_type] :
      ( v72767(VarCurr)
    <=> ( v72515(VarCurr)
      <~> v72599(VarCurr) ) ) ).

tff(addAssignment_46150,axiom,
    ! [VarCurr: state_type] :
      ( v72683(VarCurr)
    <=> v72685(VarCurr) ) ).

tff(addAssignment_46149,axiom,
    ! [VarCurr: state_type] :
      ( v72685(VarCurr)
    <=> v72687(VarCurr) ) ).

tff(addAssignment_46148,axiom,
    ! [VarCurr: state_type] :
      ( v72687(VarCurr)
    <=> v72689(VarCurr) ) ).

tff(addAssignment_46147,axiom,
    ! [VarCurr: state_type] :
      ( v72689(VarCurr)
    <=> v72691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6784,axiom,
    ! [VarCurr: state_type] :
      ( v72691(VarCurr)
    <=> ( v72765(VarCurr)
      <~> v72741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6783,axiom,
    ! [VarCurr: state_type] :
      ( v72765(VarCurr)
    <=> ( v72693(VarCurr)
      <~> v72717(VarCurr) ) ) ).

tff(addAssignment_46146,axiom,
    ! [VarCurr: state_type] :
      ( v72741(VarCurr)
    <=> v72743(VarCurr) ) ).

tff(addAssignment_46145,axiom,
    ! [VarCurr: state_type] :
      ( v72743(VarCurr)
    <=> v72745(VarCurr) ) ).

tff(addAssignment_46144,axiom,
    ! [VarCurr: state_type] :
      ( v72745(VarCurr)
    <=> v72747(VarCurr) ) ).

tff(addAssignment_46143,axiom,
    ! [VarCurr: state_type] :
      ( v72747(VarCurr)
    <=> v72749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6782,axiom,
    ! [VarCurr: state_type] :
      ( v72749(VarCurr)
    <=> ( v72763(VarCurr)
      <~> v72759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6781,axiom,
    ! [VarCurr: state_type] :
      ( v72763(VarCurr)
    <=> ( v72751(VarCurr)
      <~> v72755(VarCurr) ) ) ).

tff(addAssignment_46142,axiom,
    ! [VarCurr: state_type] :
      ( v72759(VarCurr)
    <=> v72761(VarCurr) ) ).

tff(addAssignment_46141,axiom,
    ! [VarCurr: state_type] :
      ( v72761(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_46140,axiom,
    ! [VarCurr: state_type] :
      ( v72755(VarCurr)
    <=> v72757(VarCurr) ) ).

tff(addAssignment_46139,axiom,
    ! [VarCurr: state_type] :
      ( v72757(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_46138,axiom,
    ! [VarCurr: state_type] :
      ( v72751(VarCurr)
    <=> v72753(VarCurr) ) ).

tff(addAssignment_46137,axiom,
    ! [VarCurr: state_type] :
      ( v72753(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_46136,axiom,
    ! [VarCurr: state_type] :
      ( v72717(VarCurr)
    <=> v72719(VarCurr) ) ).

tff(addAssignment_46135,axiom,
    ! [VarCurr: state_type] :
      ( v72719(VarCurr)
    <=> v72721(VarCurr) ) ).

tff(addAssignment_46134,axiom,
    ! [VarCurr: state_type] :
      ( v72721(VarCurr)
    <=> v72723(VarCurr) ) ).

tff(addAssignment_46133,axiom,
    ! [VarCurr: state_type] :
      ( v72723(VarCurr)
    <=> v72725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6780,axiom,
    ! [VarCurr: state_type] :
      ( v72725(VarCurr)
    <=> ( v72739(VarCurr)
      <~> v72735(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6779,axiom,
    ! [VarCurr: state_type] :
      ( v72739(VarCurr)
    <=> ( v72727(VarCurr)
      <~> v72731(VarCurr) ) ) ).

tff(addAssignment_46132,axiom,
    ! [VarCurr: state_type] :
      ( v72735(VarCurr)
    <=> v72737(VarCurr) ) ).

tff(addAssignment_46131,axiom,
    ! [VarCurr: state_type] :
      ( v72737(VarCurr)
    <=> v67349(VarCurr,96) ) ).

tff(addAssignment_46130,axiom,
    ! [VarCurr: state_type] :
      ( v72731(VarCurr)
    <=> v72733(VarCurr) ) ).

tff(addAssignment_46129,axiom,
    ! [VarCurr: state_type] :
      ( v72733(VarCurr)
    <=> v67349(VarCurr,93) ) ).

tff(addAssignment_46128,axiom,
    ! [VarCurr: state_type] :
      ( v72727(VarCurr)
    <=> v72729(VarCurr) ) ).

tff(addAssignment_46127,axiom,
    ! [VarCurr: state_type] :
      ( v72729(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_46126,axiom,
    ! [VarCurr: state_type] :
      ( v72693(VarCurr)
    <=> v72695(VarCurr) ) ).

tff(addAssignment_46125,axiom,
    ! [VarCurr: state_type] :
      ( v72695(VarCurr)
    <=> v72697(VarCurr) ) ).

tff(addAssignment_46124,axiom,
    ! [VarCurr: state_type] :
      ( v72697(VarCurr)
    <=> v72699(VarCurr) ) ).

tff(addAssignment_46123,axiom,
    ! [VarCurr: state_type] :
      ( v72699(VarCurr)
    <=> v72701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6778,axiom,
    ! [VarCurr: state_type] :
      ( v72701(VarCurr)
    <=> ( v72715(VarCurr)
      <~> v72711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6777,axiom,
    ! [VarCurr: state_type] :
      ( v72715(VarCurr)
    <=> ( v72703(VarCurr)
      <~> v72707(VarCurr) ) ) ).

tff(addAssignment_46122,axiom,
    ! [VarCurr: state_type] :
      ( v72711(VarCurr)
    <=> v72713(VarCurr) ) ).

tff(addAssignment_46121,axiom,
    ! [VarCurr: state_type] :
      ( v72713(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_46120,axiom,
    ! [VarCurr: state_type] :
      ( v72707(VarCurr)
    <=> v72709(VarCurr) ) ).

tff(addAssignment_46119,axiom,
    ! [VarCurr: state_type] :
      ( v72709(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_46118,axiom,
    ! [VarCurr: state_type] :
      ( v72703(VarCurr)
    <=> v72705(VarCurr) ) ).

tff(addAssignment_46117,axiom,
    ! [VarCurr: state_type] :
      ( v72705(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_46116,axiom,
    ! [VarCurr: state_type] :
      ( v72599(VarCurr)
    <=> v72601(VarCurr) ) ).

tff(addAssignment_46115,axiom,
    ! [VarCurr: state_type] :
      ( v72601(VarCurr)
    <=> v72603(VarCurr) ) ).

tff(addAssignment_46114,axiom,
    ! [VarCurr: state_type] :
      ( v72603(VarCurr)
    <=> v72605(VarCurr) ) ).

tff(addAssignment_46113,axiom,
    ! [VarCurr: state_type] :
      ( v72605(VarCurr)
    <=> v72607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6776,axiom,
    ! [VarCurr: state_type] :
      ( v72607(VarCurr)
    <=> ( v72681(VarCurr)
      <~> v72657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6775,axiom,
    ! [VarCurr: state_type] :
      ( v72681(VarCurr)
    <=> ( v72609(VarCurr)
      <~> v72633(VarCurr) ) ) ).

tff(addAssignment_46112,axiom,
    ! [VarCurr: state_type] :
      ( v72657(VarCurr)
    <=> v72659(VarCurr) ) ).

tff(addAssignment_46111,axiom,
    ! [VarCurr: state_type] :
      ( v72659(VarCurr)
    <=> v72661(VarCurr) ) ).

tff(addAssignment_46110,axiom,
    ! [VarCurr: state_type] :
      ( v72661(VarCurr)
    <=> v72663(VarCurr) ) ).

tff(addAssignment_46109,axiom,
    ! [VarCurr: state_type] :
      ( v72663(VarCurr)
    <=> v72665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6774,axiom,
    ! [VarCurr: state_type] :
      ( v72665(VarCurr)
    <=> ( v72679(VarCurr)
      <~> v72675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6773,axiom,
    ! [VarCurr: state_type] :
      ( v72679(VarCurr)
    <=> ( v72667(VarCurr)
      <~> v72671(VarCurr) ) ) ).

tff(addAssignment_46108,axiom,
    ! [VarCurr: state_type] :
      ( v72675(VarCurr)
    <=> v72677(VarCurr) ) ).

tff(addAssignment_46107,axiom,
    ! [VarCurr: state_type] :
      ( v72677(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_46106,axiom,
    ! [VarCurr: state_type] :
      ( v72671(VarCurr)
    <=> v72673(VarCurr) ) ).

tff(addAssignment_46105,axiom,
    ! [VarCurr: state_type] :
      ( v72673(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_46104,axiom,
    ! [VarCurr: state_type] :
      ( v72667(VarCurr)
    <=> v72669(VarCurr) ) ).

tff(addAssignment_46103,axiom,
    ! [VarCurr: state_type] :
      ( v72669(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_46102,axiom,
    ! [VarCurr: state_type] :
      ( v72633(VarCurr)
    <=> v72635(VarCurr) ) ).

tff(addAssignment_46101,axiom,
    ! [VarCurr: state_type] :
      ( v72635(VarCurr)
    <=> v72637(VarCurr) ) ).

tff(addAssignment_46100,axiom,
    ! [VarCurr: state_type] :
      ( v72637(VarCurr)
    <=> v72639(VarCurr) ) ).

tff(addAssignment_46099,axiom,
    ! [VarCurr: state_type] :
      ( v72639(VarCurr)
    <=> v72641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6772,axiom,
    ! [VarCurr: state_type] :
      ( v72641(VarCurr)
    <=> ( v72655(VarCurr)
      <~> v72651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6771,axiom,
    ! [VarCurr: state_type] :
      ( v72655(VarCurr)
    <=> ( v72643(VarCurr)
      <~> v72647(VarCurr) ) ) ).

tff(addAssignment_46098,axiom,
    ! [VarCurr: state_type] :
      ( v72651(VarCurr)
    <=> v72653(VarCurr) ) ).

tff(addAssignment_46097,axiom,
    ! [VarCurr: state_type] :
      ( v72653(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_46096,axiom,
    ! [VarCurr: state_type] :
      ( v72647(VarCurr)
    <=> v72649(VarCurr) ) ).

tff(addAssignment_46095,axiom,
    ! [VarCurr: state_type] :
      ( v72649(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_46094,axiom,
    ! [VarCurr: state_type] :
      ( v72643(VarCurr)
    <=> v72645(VarCurr) ) ).

tff(addAssignment_46093,axiom,
    ! [VarCurr: state_type] :
      ( v72645(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_46092,axiom,
    ! [VarCurr: state_type] :
      ( v72609(VarCurr)
    <=> v72611(VarCurr) ) ).

tff(addAssignment_46091,axiom,
    ! [VarCurr: state_type] :
      ( v72611(VarCurr)
    <=> v72613(VarCurr) ) ).

tff(addAssignment_46090,axiom,
    ! [VarCurr: state_type] :
      ( v72613(VarCurr)
    <=> v72615(VarCurr) ) ).

tff(addAssignment_46089,axiom,
    ! [VarCurr: state_type] :
      ( v72615(VarCurr)
    <=> v72617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6770,axiom,
    ! [VarCurr: state_type] :
      ( v72617(VarCurr)
    <=> ( v72631(VarCurr)
      <~> v72627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6769,axiom,
    ! [VarCurr: state_type] :
      ( v72631(VarCurr)
    <=> ( v72619(VarCurr)
      <~> v72623(VarCurr) ) ) ).

tff(addAssignment_46088,axiom,
    ! [VarCurr: state_type] :
      ( v72627(VarCurr)
    <=> v72629(VarCurr) ) ).

tff(addAssignment_46087,axiom,
    ! [VarCurr: state_type] :
      ( v72629(VarCurr)
    <=> v67349(VarCurr,77) ) ).

tff(addAssignment_46086,axiom,
    ! [VarCurr: state_type] :
      ( v72623(VarCurr)
    <=> v72625(VarCurr) ) ).

tff(addAssignment_46085,axiom,
    ! [VarCurr: state_type] :
      ( v72625(VarCurr)
    <=> v67349(VarCurr,72) ) ).

tff(addAssignment_46084,axiom,
    ! [VarCurr: state_type] :
      ( v72619(VarCurr)
    <=> v72621(VarCurr) ) ).

tff(addAssignment_46083,axiom,
    ! [VarCurr: state_type] :
      ( v72621(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_46082,axiom,
    ! [VarCurr: state_type] :
      ( v72515(VarCurr)
    <=> v72517(VarCurr) ) ).

tff(addAssignment_46081,axiom,
    ! [VarCurr: state_type] :
      ( v72517(VarCurr)
    <=> v72519(VarCurr) ) ).

tff(addAssignment_46080,axiom,
    ! [VarCurr: state_type] :
      ( v72519(VarCurr)
    <=> v72521(VarCurr) ) ).

tff(addAssignment_46079,axiom,
    ! [VarCurr: state_type] :
      ( v72521(VarCurr)
    <=> v72523(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6768,axiom,
    ! [VarCurr: state_type] :
      ( v72523(VarCurr)
    <=> ( v72597(VarCurr)
      <~> v72573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6767,axiom,
    ! [VarCurr: state_type] :
      ( v72597(VarCurr)
    <=> ( v72525(VarCurr)
      <~> v72549(VarCurr) ) ) ).

tff(addAssignment_46078,axiom,
    ! [VarCurr: state_type] :
      ( v72573(VarCurr)
    <=> v72575(VarCurr) ) ).

tff(addAssignment_46077,axiom,
    ! [VarCurr: state_type] :
      ( v72575(VarCurr)
    <=> v72577(VarCurr) ) ).

tff(addAssignment_46076,axiom,
    ! [VarCurr: state_type] :
      ( v72577(VarCurr)
    <=> v72579(VarCurr) ) ).

tff(addAssignment_46075,axiom,
    ! [VarCurr: state_type] :
      ( v72579(VarCurr)
    <=> v72581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6766,axiom,
    ! [VarCurr: state_type] :
      ( v72581(VarCurr)
    <=> ( v72595(VarCurr)
      <~> v72591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6765,axiom,
    ! [VarCurr: state_type] :
      ( v72595(VarCurr)
    <=> ( v72583(VarCurr)
      <~> v72587(VarCurr) ) ) ).

tff(addAssignment_46074,axiom,
    ! [VarCurr: state_type] :
      ( v72591(VarCurr)
    <=> v72593(VarCurr) ) ).

tff(addAssignment_46073,axiom,
    ! [VarCurr: state_type] :
      ( v72593(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_46072,axiom,
    ! [VarCurr: state_type] :
      ( v72587(VarCurr)
    <=> v72589(VarCurr) ) ).

tff(addAssignment_46071,axiom,
    ! [VarCurr: state_type] :
      ( v72589(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_46070,axiom,
    ! [VarCurr: state_type] :
      ( v72583(VarCurr)
    <=> v72585(VarCurr) ) ).

tff(addAssignment_46069,axiom,
    ! [VarCurr: state_type] :
      ( v72585(VarCurr)
    <=> v67349(VarCurr,67) ) ).

tff(addAssignment_46068,axiom,
    ! [VarCurr: state_type] :
      ( v72549(VarCurr)
    <=> v72551(VarCurr) ) ).

tff(addAssignment_46067,axiom,
    ! [VarCurr: state_type] :
      ( v72551(VarCurr)
    <=> v72553(VarCurr) ) ).

tff(addAssignment_46066,axiom,
    ! [VarCurr: state_type] :
      ( v72553(VarCurr)
    <=> v72555(VarCurr) ) ).

tff(addAssignment_46065,axiom,
    ! [VarCurr: state_type] :
      ( v72555(VarCurr)
    <=> v72557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6764,axiom,
    ! [VarCurr: state_type] :
      ( v72557(VarCurr)
    <=> ( v72571(VarCurr)
      <~> v72567(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6763,axiom,
    ! [VarCurr: state_type] :
      ( v72571(VarCurr)
    <=> ( v72559(VarCurr)
      <~> v72563(VarCurr) ) ) ).

tff(addAssignment_46064,axiom,
    ! [VarCurr: state_type] :
      ( v72567(VarCurr)
    <=> v72569(VarCurr) ) ).

tff(addAssignment_46063,axiom,
    ! [VarCurr: state_type] :
      ( v72569(VarCurr)
    <=> v67349(VarCurr,62) ) ).

tff(addAssignment_46062,axiom,
    ! [VarCurr: state_type] :
      ( v72563(VarCurr)
    <=> v72565(VarCurr) ) ).

tff(addAssignment_46061,axiom,
    ! [VarCurr: state_type] :
      ( v72565(VarCurr)
    <=> v67349(VarCurr,59) ) ).

tff(addAssignment_46060,axiom,
    ! [VarCurr: state_type] :
      ( v72559(VarCurr)
    <=> v72561(VarCurr) ) ).

tff(addAssignment_46059,axiom,
    ! [VarCurr: state_type] :
      ( v72561(VarCurr)
    <=> v67349(VarCurr,58) ) ).

tff(addAssignment_46058,axiom,
    ! [VarCurr: state_type] :
      ( v72525(VarCurr)
    <=> v72527(VarCurr) ) ).

tff(addAssignment_46057,axiom,
    ! [VarCurr: state_type] :
      ( v72527(VarCurr)
    <=> v72529(VarCurr) ) ).

tff(addAssignment_46056,axiom,
    ! [VarCurr: state_type] :
      ( v72529(VarCurr)
    <=> v72531(VarCurr) ) ).

tff(addAssignment_46055,axiom,
    ! [VarCurr: state_type] :
      ( v72531(VarCurr)
    <=> v72533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6762,axiom,
    ! [VarCurr: state_type] :
      ( v72533(VarCurr)
    <=> ( v72547(VarCurr)
      <~> v72543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6761,axiom,
    ! [VarCurr: state_type] :
      ( v72547(VarCurr)
    <=> ( v72535(VarCurr)
      <~> v72539(VarCurr) ) ) ).

tff(addAssignment_46054,axiom,
    ! [VarCurr: state_type] :
      ( v72543(VarCurr)
    <=> v72545(VarCurr) ) ).

tff(addAssignment_46053,axiom,
    ! [VarCurr: state_type] :
      ( v72545(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_46052,axiom,
    ! [VarCurr: state_type] :
      ( v72539(VarCurr)
    <=> v72541(VarCurr) ) ).

tff(addAssignment_46051,axiom,
    ! [VarCurr: state_type] :
      ( v72541(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_46050,axiom,
    ! [VarCurr: state_type] :
      ( v72535(VarCurr)
    <=> v72537(VarCurr) ) ).

tff(addAssignment_46049,axiom,
    ! [VarCurr: state_type] :
      ( v72537(VarCurr)
    <=> v67349(VarCurr,51) ) ).

tff(addAssignment_46048,axiom,
    ! [VarCurr: state_type] :
      ( v72241(VarCurr)
    <=> v72243(VarCurr) ) ).

tff(addAssignment_46047,axiom,
    ! [VarCurr: state_type] :
      ( v72243(VarCurr)
    <=> v72245(VarCurr) ) ).

tff(addAssignment_46046,axiom,
    ! [VarCurr: state_type] :
      ( v72245(VarCurr)
    <=> v72247(VarCurr) ) ).

tff(addAssignment_46045,axiom,
    ! [VarCurr: state_type] :
      ( v72247(VarCurr)
    <=> v72249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6760,axiom,
    ! [VarCurr: state_type] :
      ( v72249(VarCurr)
    <=> ( v72503(VarCurr)
      <~> v72419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6759,axiom,
    ! [VarCurr: state_type] :
      ( v72503(VarCurr)
    <=> ( v72251(VarCurr)
      <~> v72335(VarCurr) ) ) ).

tff(addAssignment_46044,axiom,
    ! [VarCurr: state_type] :
      ( v72419(VarCurr)
    <=> v72421(VarCurr) ) ).

tff(addAssignment_46043,axiom,
    ! [VarCurr: state_type] :
      ( v72421(VarCurr)
    <=> v72423(VarCurr) ) ).

tff(addAssignment_46042,axiom,
    ! [VarCurr: state_type] :
      ( v72423(VarCurr)
    <=> v72425(VarCurr) ) ).

tff(addAssignment_46041,axiom,
    ! [VarCurr: state_type] :
      ( v72425(VarCurr)
    <=> v72427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6758,axiom,
    ! [VarCurr: state_type] :
      ( v72427(VarCurr)
    <=> ( v72501(VarCurr)
      <~> v72477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6757,axiom,
    ! [VarCurr: state_type] :
      ( v72501(VarCurr)
    <=> ( v72429(VarCurr)
      <~> v72453(VarCurr) ) ) ).

tff(addAssignment_46040,axiom,
    ! [VarCurr: state_type] :
      ( v72477(VarCurr)
    <=> v72479(VarCurr) ) ).

tff(addAssignment_46039,axiom,
    ! [VarCurr: state_type] :
      ( v72479(VarCurr)
    <=> v72481(VarCurr) ) ).

tff(addAssignment_46038,axiom,
    ! [VarCurr: state_type] :
      ( v72481(VarCurr)
    <=> v72483(VarCurr) ) ).

tff(addAssignment_46037,axiom,
    ! [VarCurr: state_type] :
      ( v72483(VarCurr)
    <=> v72485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6756,axiom,
    ! [VarCurr: state_type] :
      ( v72485(VarCurr)
    <=> ( v72499(VarCurr)
      <~> v72495(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6755,axiom,
    ! [VarCurr: state_type] :
      ( v72499(VarCurr)
    <=> ( v72487(VarCurr)
      <~> v72491(VarCurr) ) ) ).

tff(addAssignment_46036,axiom,
    ! [VarCurr: state_type] :
      ( v72495(VarCurr)
    <=> v72497(VarCurr) ) ).

tff(addAssignment_46035,axiom,
    ! [VarCurr: state_type] :
      ( v72497(VarCurr)
    <=> v67349(VarCurr,48) ) ).

tff(addAssignment_46034,axiom,
    ! [VarCurr: state_type] :
      ( v72491(VarCurr)
    <=> v72493(VarCurr) ) ).

tff(addAssignment_46033,axiom,
    ! [VarCurr: state_type] :
      ( v72493(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_46032,axiom,
    ! [VarCurr: state_type] :
      ( v72487(VarCurr)
    <=> v72489(VarCurr) ) ).

tff(addAssignment_46031,axiom,
    ! [VarCurr: state_type] :
      ( v72489(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_46030,axiom,
    ! [VarCurr: state_type] :
      ( v72453(VarCurr)
    <=> v72455(VarCurr) ) ).

tff(addAssignment_46029,axiom,
    ! [VarCurr: state_type] :
      ( v72455(VarCurr)
    <=> v72457(VarCurr) ) ).

tff(addAssignment_46028,axiom,
    ! [VarCurr: state_type] :
      ( v72457(VarCurr)
    <=> v72459(VarCurr) ) ).

tff(addAssignment_46027,axiom,
    ! [VarCurr: state_type] :
      ( v72459(VarCurr)
    <=> v72461(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6754,axiom,
    ! [VarCurr: state_type] :
      ( v72461(VarCurr)
    <=> ( v72475(VarCurr)
      <~> v72471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6753,axiom,
    ! [VarCurr: state_type] :
      ( v72475(VarCurr)
    <=> ( v72463(VarCurr)
      <~> v72467(VarCurr) ) ) ).

tff(addAssignment_46026,axiom,
    ! [VarCurr: state_type] :
      ( v72471(VarCurr)
    <=> v72473(VarCurr) ) ).

tff(addAssignment_46025,axiom,
    ! [VarCurr: state_type] :
      ( v72473(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_46024,axiom,
    ! [VarCurr: state_type] :
      ( v72467(VarCurr)
    <=> v72469(VarCurr) ) ).

tff(addAssignment_46023,axiom,
    ! [VarCurr: state_type] :
      ( v72469(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_46022,axiom,
    ! [VarCurr: state_type] :
      ( v72463(VarCurr)
    <=> v72465(VarCurr) ) ).

tff(addAssignment_46021,axiom,
    ! [VarCurr: state_type] :
      ( v72465(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_46020,axiom,
    ! [VarCurr: state_type] :
      ( v72429(VarCurr)
    <=> v72431(VarCurr) ) ).

tff(addAssignment_46019,axiom,
    ! [VarCurr: state_type] :
      ( v72431(VarCurr)
    <=> v72433(VarCurr) ) ).

tff(addAssignment_46018,axiom,
    ! [VarCurr: state_type] :
      ( v72433(VarCurr)
    <=> v72435(VarCurr) ) ).

tff(addAssignment_46017,axiom,
    ! [VarCurr: state_type] :
      ( v72435(VarCurr)
    <=> v72437(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6752,axiom,
    ! [VarCurr: state_type] :
      ( v72437(VarCurr)
    <=> ( v72451(VarCurr)
      <~> v72447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6751,axiom,
    ! [VarCurr: state_type] :
      ( v72451(VarCurr)
    <=> ( v72439(VarCurr)
      <~> v72443(VarCurr) ) ) ).

tff(addAssignment_46016,axiom,
    ! [VarCurr: state_type] :
      ( v72447(VarCurr)
    <=> v72449(VarCurr) ) ).

tff(addAssignment_46015,axiom,
    ! [VarCurr: state_type] :
      ( v72449(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_46014,axiom,
    ! [VarCurr: state_type] :
      ( v72443(VarCurr)
    <=> v72445(VarCurr) ) ).

tff(addAssignment_46013,axiom,
    ! [VarCurr: state_type] :
      ( v72445(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_46012,axiom,
    ! [VarCurr: state_type] :
      ( v72439(VarCurr)
    <=> v72441(VarCurr) ) ).

tff(addAssignment_46011,axiom,
    ! [VarCurr: state_type] :
      ( v72441(VarCurr)
    <=> v67349(VarCurr,36) ) ).

tff(addAssignment_46010,axiom,
    ! [VarCurr: state_type] :
      ( v72335(VarCurr)
    <=> v72337(VarCurr) ) ).

tff(addAssignment_46009,axiom,
    ! [VarCurr: state_type] :
      ( v72337(VarCurr)
    <=> v72339(VarCurr) ) ).

tff(addAssignment_46008,axiom,
    ! [VarCurr: state_type] :
      ( v72339(VarCurr)
    <=> v72341(VarCurr) ) ).

tff(addAssignment_46007,axiom,
    ! [VarCurr: state_type] :
      ( v72341(VarCurr)
    <=> v72343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6750,axiom,
    ! [VarCurr: state_type] :
      ( v72343(VarCurr)
    <=> ( v72417(VarCurr)
      <~> v72393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6749,axiom,
    ! [VarCurr: state_type] :
      ( v72417(VarCurr)
    <=> ( v72345(VarCurr)
      <~> v72369(VarCurr) ) ) ).

tff(addAssignment_46006,axiom,
    ! [VarCurr: state_type] :
      ( v72393(VarCurr)
    <=> v72395(VarCurr) ) ).

tff(addAssignment_46005,axiom,
    ! [VarCurr: state_type] :
      ( v72395(VarCurr)
    <=> v72397(VarCurr) ) ).

tff(addAssignment_46004,axiom,
    ! [VarCurr: state_type] :
      ( v72397(VarCurr)
    <=> v72399(VarCurr) ) ).

tff(addAssignment_46003,axiom,
    ! [VarCurr: state_type] :
      ( v72399(VarCurr)
    <=> v72401(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6748,axiom,
    ! [VarCurr: state_type] :
      ( v72401(VarCurr)
    <=> ( v72415(VarCurr)
      <~> v72411(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6747,axiom,
    ! [VarCurr: state_type] :
      ( v72415(VarCurr)
    <=> ( v72403(VarCurr)
      <~> v72407(VarCurr) ) ) ).

tff(addAssignment_46002,axiom,
    ! [VarCurr: state_type] :
      ( v72411(VarCurr)
    <=> v72413(VarCurr) ) ).

tff(addAssignment_46001,axiom,
    ! [VarCurr: state_type] :
      ( v72413(VarCurr)
    <=> v67349(VarCurr,33) ) ).

tff(addAssignment_46000,axiom,
    ! [VarCurr: state_type] :
      ( v72407(VarCurr)
    <=> v72409(VarCurr) ) ).

tff(addAssignment_45999,axiom,
    ! [VarCurr: state_type] :
      ( v72409(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_45998,axiom,
    ! [VarCurr: state_type] :
      ( v72403(VarCurr)
    <=> v72405(VarCurr) ) ).

tff(addAssignment_45997,axiom,
    ! [VarCurr: state_type] :
      ( v72405(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_45996,axiom,
    ! [VarCurr: state_type] :
      ( v72369(VarCurr)
    <=> v72371(VarCurr) ) ).

tff(addAssignment_45995,axiom,
    ! [VarCurr: state_type] :
      ( v72371(VarCurr)
    <=> v72373(VarCurr) ) ).

tff(addAssignment_45994,axiom,
    ! [VarCurr: state_type] :
      ( v72373(VarCurr)
    <=> v72375(VarCurr) ) ).

tff(addAssignment_45993,axiom,
    ! [VarCurr: state_type] :
      ( v72375(VarCurr)
    <=> v72377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6746,axiom,
    ! [VarCurr: state_type] :
      ( v72377(VarCurr)
    <=> ( v72391(VarCurr)
      <~> v72387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6745,axiom,
    ! [VarCurr: state_type] :
      ( v72391(VarCurr)
    <=> ( v72379(VarCurr)
      <~> v72383(VarCurr) ) ) ).

tff(addAssignment_45992,axiom,
    ! [VarCurr: state_type] :
      ( v72387(VarCurr)
    <=> v72389(VarCurr) ) ).

tff(addAssignment_45991,axiom,
    ! [VarCurr: state_type] :
      ( v72389(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_45990,axiom,
    ! [VarCurr: state_type] :
      ( v72383(VarCurr)
    <=> v72385(VarCurr) ) ).

tff(addAssignment_45989,axiom,
    ! [VarCurr: state_type] :
      ( v72385(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_45988,axiom,
    ! [VarCurr: state_type] :
      ( v72379(VarCurr)
    <=> v72381(VarCurr) ) ).

tff(addAssignment_45987,axiom,
    ! [VarCurr: state_type] :
      ( v72381(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_45986,axiom,
    ! [VarCurr: state_type] :
      ( v72345(VarCurr)
    <=> v72347(VarCurr) ) ).

tff(addAssignment_45985,axiom,
    ! [VarCurr: state_type] :
      ( v72347(VarCurr)
    <=> v72349(VarCurr) ) ).

tff(addAssignment_45984,axiom,
    ! [VarCurr: state_type] :
      ( v72349(VarCurr)
    <=> v72351(VarCurr) ) ).

tff(addAssignment_45983,axiom,
    ! [VarCurr: state_type] :
      ( v72351(VarCurr)
    <=> v72353(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6744,axiom,
    ! [VarCurr: state_type] :
      ( v72353(VarCurr)
    <=> ( v72367(VarCurr)
      <~> v72363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6743,axiom,
    ! [VarCurr: state_type] :
      ( v72367(VarCurr)
    <=> ( v72355(VarCurr)
      <~> v72359(VarCurr) ) ) ).

tff(addAssignment_45982,axiom,
    ! [VarCurr: state_type] :
      ( v72363(VarCurr)
    <=> v72365(VarCurr) ) ).

tff(addAssignment_45981,axiom,
    ! [VarCurr: state_type] :
      ( v72365(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_45980,axiom,
    ! [VarCurr: state_type] :
      ( v72359(VarCurr)
    <=> v72361(VarCurr) ) ).

tff(addAssignment_45979,axiom,
    ! [VarCurr: state_type] :
      ( v72361(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_45978,axiom,
    ! [VarCurr: state_type] :
      ( v72355(VarCurr)
    <=> v72357(VarCurr) ) ).

tff(addAssignment_45977,axiom,
    ! [VarCurr: state_type] :
      ( v72357(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_45976,axiom,
    ! [VarCurr: state_type] :
      ( v72251(VarCurr)
    <=> v72253(VarCurr) ) ).

tff(addAssignment_45975,axiom,
    ! [VarCurr: state_type] :
      ( v72253(VarCurr)
    <=> v72255(VarCurr) ) ).

tff(addAssignment_45974,axiom,
    ! [VarCurr: state_type] :
      ( v72255(VarCurr)
    <=> v72257(VarCurr) ) ).

tff(addAssignment_45973,axiom,
    ! [VarCurr: state_type] :
      ( v72257(VarCurr)
    <=> v72259(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6742,axiom,
    ! [VarCurr: state_type] :
      ( v72259(VarCurr)
    <=> ( v72333(VarCurr)
      <~> v72309(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6741,axiom,
    ! [VarCurr: state_type] :
      ( v72333(VarCurr)
    <=> ( v72261(VarCurr)
      <~> v72285(VarCurr) ) ) ).

tff(addAssignment_45972,axiom,
    ! [VarCurr: state_type] :
      ( v72309(VarCurr)
    <=> v72311(VarCurr) ) ).

tff(addAssignment_45971,axiom,
    ! [VarCurr: state_type] :
      ( v72311(VarCurr)
    <=> v72313(VarCurr) ) ).

tff(addAssignment_45970,axiom,
    ! [VarCurr: state_type] :
      ( v72313(VarCurr)
    <=> v72315(VarCurr) ) ).

tff(addAssignment_45969,axiom,
    ! [VarCurr: state_type] :
      ( v72315(VarCurr)
    <=> v72317(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6740,axiom,
    ! [VarCurr: state_type] :
      ( v72317(VarCurr)
    <=> ( v72331(VarCurr)
      <~> v72327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6739,axiom,
    ! [VarCurr: state_type] :
      ( v72331(VarCurr)
    <=> ( v72319(VarCurr)
      <~> v72323(VarCurr) ) ) ).

tff(addAssignment_45968,axiom,
    ! [VarCurr: state_type] :
      ( v72327(VarCurr)
    <=> v72329(VarCurr) ) ).

tff(addAssignment_45967,axiom,
    ! [VarCurr: state_type] :
      ( v72329(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_45966,axiom,
    ! [VarCurr: state_type] :
      ( v72323(VarCurr)
    <=> v72325(VarCurr) ) ).

tff(addAssignment_45965,axiom,
    ! [VarCurr: state_type] :
      ( v72325(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_45964,axiom,
    ! [VarCurr: state_type] :
      ( v72319(VarCurr)
    <=> v72321(VarCurr) ) ).

tff(addAssignment_45963,axiom,
    ! [VarCurr: state_type] :
      ( v72321(VarCurr)
    <=> v67349(VarCurr,17) ) ).

tff(addAssignment_45962,axiom,
    ! [VarCurr: state_type] :
      ( v72285(VarCurr)
    <=> v72287(VarCurr) ) ).

tff(addAssignment_45961,axiom,
    ! [VarCurr: state_type] :
      ( v72287(VarCurr)
    <=> v72289(VarCurr) ) ).

tff(addAssignment_45960,axiom,
    ! [VarCurr: state_type] :
      ( v72289(VarCurr)
    <=> v72291(VarCurr) ) ).

tff(addAssignment_45959,axiom,
    ! [VarCurr: state_type] :
      ( v72291(VarCurr)
    <=> v72293(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6738,axiom,
    ! [VarCurr: state_type] :
      ( v72293(VarCurr)
    <=> ( v72307(VarCurr)
      <~> v72303(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6737,axiom,
    ! [VarCurr: state_type] :
      ( v72307(VarCurr)
    <=> ( v72295(VarCurr)
      <~> v72299(VarCurr) ) ) ).

tff(addAssignment_45958,axiom,
    ! [VarCurr: state_type] :
      ( v72303(VarCurr)
    <=> v72305(VarCurr) ) ).

tff(addAssignment_45957,axiom,
    ! [VarCurr: state_type] :
      ( v72305(VarCurr)
    <=> v67349(VarCurr,12) ) ).

tff(addAssignment_45956,axiom,
    ! [VarCurr: state_type] :
      ( v72299(VarCurr)
    <=> v72301(VarCurr) ) ).

tff(addAssignment_45955,axiom,
    ! [VarCurr: state_type] :
      ( v72301(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_45954,axiom,
    ! [VarCurr: state_type] :
      ( v72295(VarCurr)
    <=> v72297(VarCurr) ) ).

tff(addAssignment_45953,axiom,
    ! [VarCurr: state_type] :
      ( v72297(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_45952,axiom,
    ! [VarCurr: state_type] :
      ( v72261(VarCurr)
    <=> v72263(VarCurr) ) ).

tff(addAssignment_45951,axiom,
    ! [VarCurr: state_type] :
      ( v72263(VarCurr)
    <=> v72265(VarCurr) ) ).

tff(addAssignment_45950,axiom,
    ! [VarCurr: state_type] :
      ( v72265(VarCurr)
    <=> v72267(VarCurr) ) ).

tff(addAssignment_45949,axiom,
    ! [VarCurr: state_type] :
      ( v72267(VarCurr)
    <=> v72269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6736,axiom,
    ! [VarCurr: state_type] :
      ( v72269(VarCurr)
    <=> ( v72283(VarCurr)
      <~> v72279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6735,axiom,
    ! [VarCurr: state_type] :
      ( v72283(VarCurr)
    <=> ( v72271(VarCurr)
      <~> v72275(VarCurr) ) ) ).

tff(addAssignment_45948,axiom,
    ! [VarCurr: state_type] :
      ( v72279(VarCurr)
    <=> v72281(VarCurr) ) ).

tff(addAssignment_45947,axiom,
    ! [VarCurr: state_type] :
      ( v72281(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_45946,axiom,
    ! [VarCurr: state_type] :
      ( v72275(VarCurr)
    <=> v72277(VarCurr) ) ).

tff(addAssignment_45945,axiom,
    ! [VarCurr: state_type] :
      ( v72277(VarCurr)
    <=> v67349(VarCurr,7) ) ).

tff(addAssignment_45944,axiom,
    ! [VarCurr: state_type] :
      ( v72271(VarCurr)
    <=> v72273(VarCurr) ) ).

tff(addAssignment_45943,axiom,
    ! [VarCurr: state_type] :
      ( v72273(VarCurr)
    <=> v67349(VarCurr,2) ) ).

tff(addAssignment_45942,axiom,
    ! [VarCurr: state_type] :
      ( v71556(VarCurr)
    <=> v71558(VarCurr) ) ).

tff(addAssignment_45941,axiom,
    ! [VarCurr: state_type] :
      ( v71558(VarCurr)
    <=> v71560(VarCurr,3) ) ).

tff(addAssignment_45940,axiom,
    ! [VarCurr: state_type] :
      ( v71560(VarCurr,3)
    <=> v67309(VarCurr,3) ) ).

tff(addAssignment_45939,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,3)
    <=> v67311(VarCurr,3) ) ).

tff(addAssignment_45938,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,3)
    <=> v67313(VarCurr,3) ) ).

tff(addAssignment_45937,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,3)
    <=> v67315(VarCurr,3) ) ).

tff(addAssignment_45936,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,3)
    <=> v67317(VarCurr,3) ) ).

tff(addAssignment_45935,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,3)
    <=> v68771(VarCurr,3) ) ).

tff(addAssignment_45934,axiom,
    ! [VarCurr: state_type] :
      ( v68774(VarCurr,3)
    <=> v71563(VarCurr) ) ).

tff(addAssignment_45933,axiom,
    ! [VarCurr: state_type] :
      ( v71563(VarCurr)
    <=> v71565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6734,axiom,
    ! [VarCurr: state_type] :
      ( v71565(VarCurr)
    <=> ( v72231(VarCurr)
      <~> v72095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6733,axiom,
    ! [VarCurr: state_type] :
      ( v72231(VarCurr)
    <=> ( v71567(VarCurr)
      <~> v71831(VarCurr) ) ) ).

tff(addAssignment_45932,axiom,
    ! [VarCurr: state_type] :
      ( v72095(VarCurr)
    <=> v72097(VarCurr) ) ).

tff(addAssignment_45931,axiom,
    ! [VarCurr: state_type] :
      ( v72097(VarCurr)
    <=> v72099(VarCurr) ) ).

tff(addAssignment_45930,axiom,
    ! [VarCurr: state_type] :
      ( v72099(VarCurr)
    <=> v72101(VarCurr) ) ).

tff(addAssignment_45929,axiom,
    ! [VarCurr: state_type] :
      ( v72101(VarCurr)
    <=> v72103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6732,axiom,
    ! [VarCurr: state_type] :
      ( v72103(VarCurr)
    <=> ( v72229(VarCurr)
      <~> v72213(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6731,axiom,
    ! [VarCurr: state_type] :
      ( v72229(VarCurr)
    <=> ( v72105(VarCurr)
      <~> v72129(VarCurr) ) ) ).

tff(addAssignment_45928,axiom,
    ! [VarCurr: state_type] :
      ( v72213(VarCurr)
    <=> v72215(VarCurr) ) ).

tff(addAssignment_45927,axiom,
    ! [VarCurr: state_type] :
      ( v72215(VarCurr)
    <=> v72217(VarCurr,3) ) ).

tff(addAssignment_45926,axiom,
    ! [VarCurr: state_type] :
      ( v72217(VarCurr,3)
    <=> v72219(VarCurr,3) ) ).

tff(addAssignment_45925,axiom,
    ! [VarCurr: state_type] :
      ( v72219(VarCurr,3)
    <=> v68595(VarCurr,4) ) ).

tff(addAssignment_45924,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,4)
    <=> v68597(VarCurr,4) ) ).

tff(addAssignment_45923,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,4)
    <=> v72221(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v72222(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v72221(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_902,axiom,
    ! [VarNext: state_type] :
      ( v72222(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v72221(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v72222(VarNext)
      <=> v72223(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v72223(VarNext)
      <=> ( v72225(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v72225(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_45922,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,4)
    <=> v68621(VarCurr,4) ) ).

tff(addAssignment_45921,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,4)
    <=> v68624(VarCurr,4) ) ).

tff(addAssignment_45920,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,3)
    <=> v68455(VarCurr,3) ) ).

tff(addAssignment_45919,axiom,
    ! [VarCurr: state_type] :
      ( v72129(VarCurr)
    <=> v72131(VarCurr) ) ).

tff(addAssignment_45918,axiom,
    ! [VarCurr: state_type] :
      ( v72131(VarCurr)
    <=> v72133(VarCurr) ) ).

tff(addAssignment_45917,axiom,
    ! [VarCurr: state_type] :
      ( v72133(VarCurr)
    <=> v72135(VarCurr) ) ).

tff(addAssignment_45916,axiom,
    ! [VarCurr: state_type] :
      ( v72135(VarCurr)
    <=> v72137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6728,axiom,
    ! [VarCurr: state_type] :
      ( v72137(VarCurr)
    <=> ( v72211(VarCurr)
      <~> v72187(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6727,axiom,
    ! [VarCurr: state_type] :
      ( v72211(VarCurr)
    <=> ( v72139(VarCurr)
      <~> v72163(VarCurr) ) ) ).

tff(addAssignment_45915,axiom,
    ! [VarCurr: state_type] :
      ( v72187(VarCurr)
    <=> v72189(VarCurr) ) ).

tff(addAssignment_45914,axiom,
    ! [VarCurr: state_type] :
      ( v72189(VarCurr)
    <=> v72191(VarCurr) ) ).

tff(addAssignment_45913,axiom,
    ! [VarCurr: state_type] :
      ( v72191(VarCurr)
    <=> v72193(VarCurr) ) ).

tff(addAssignment_45912,axiom,
    ! [VarCurr: state_type] :
      ( v72193(VarCurr)
    <=> v72195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6726,axiom,
    ! [VarCurr: state_type] :
      ( v72195(VarCurr)
    <=> ( v72209(VarCurr)
      <~> v72205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6725,axiom,
    ! [VarCurr: state_type] :
      ( v72209(VarCurr)
    <=> ( v72197(VarCurr)
      <~> v72201(VarCurr) ) ) ).

tff(addAssignment_45911,axiom,
    ! [VarCurr: state_type] :
      ( v72205(VarCurr)
    <=> v72207(VarCurr) ) ).

tff(addAssignment_45910,axiom,
    ! [VarCurr: state_type] :
      ( v72207(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_45909,axiom,
    ! [VarCurr: state_type] :
      ( v72201(VarCurr)
    <=> v72203(VarCurr) ) ).

tff(addAssignment_45908,axiom,
    ! [VarCurr: state_type] :
      ( v72203(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_45907,axiom,
    ! [VarCurr: state_type] :
      ( v72197(VarCurr)
    <=> v72199(VarCurr) ) ).

tff(addAssignment_45906,axiom,
    ! [VarCurr: state_type] :
      ( v72199(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_45905,axiom,
    ! [VarCurr: state_type] :
      ( v72163(VarCurr)
    <=> v72165(VarCurr) ) ).

tff(addAssignment_45904,axiom,
    ! [VarCurr: state_type] :
      ( v72165(VarCurr)
    <=> v72167(VarCurr) ) ).

tff(addAssignment_45903,axiom,
    ! [VarCurr: state_type] :
      ( v72167(VarCurr)
    <=> v72169(VarCurr) ) ).

tff(addAssignment_45902,axiom,
    ! [VarCurr: state_type] :
      ( v72169(VarCurr)
    <=> v72171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6724,axiom,
    ! [VarCurr: state_type] :
      ( v72171(VarCurr)
    <=> ( v72185(VarCurr)
      <~> v72181(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6723,axiom,
    ! [VarCurr: state_type] :
      ( v72185(VarCurr)
    <=> ( v72173(VarCurr)
      <~> v72177(VarCurr) ) ) ).

tff(addAssignment_45901,axiom,
    ! [VarCurr: state_type] :
      ( v72181(VarCurr)
    <=> v72183(VarCurr) ) ).

tff(addAssignment_45900,axiom,
    ! [VarCurr: state_type] :
      ( v72183(VarCurr)
    <=> v67349(VarCurr,109) ) ).

tff(addAssignment_45899,axiom,
    ! [VarCurr: state_type] :
      ( v72177(VarCurr)
    <=> v72179(VarCurr) ) ).

tff(addAssignment_45898,axiom,
    ! [VarCurr: state_type] :
      ( v72179(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_45897,axiom,
    ! [VarCurr: state_type] :
      ( v72173(VarCurr)
    <=> v72175(VarCurr) ) ).

tff(addAssignment_45896,axiom,
    ! [VarCurr: state_type] :
      ( v72175(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_45895,axiom,
    ! [VarCurr: state_type] :
      ( v72139(VarCurr)
    <=> v72141(VarCurr) ) ).

tff(addAssignment_45894,axiom,
    ! [VarCurr: state_type] :
      ( v72141(VarCurr)
    <=> v72143(VarCurr) ) ).

tff(addAssignment_45893,axiom,
    ! [VarCurr: state_type] :
      ( v72143(VarCurr)
    <=> v72145(VarCurr) ) ).

tff(addAssignment_45892,axiom,
    ! [VarCurr: state_type] :
      ( v72145(VarCurr)
    <=> v72147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6722,axiom,
    ! [VarCurr: state_type] :
      ( v72147(VarCurr)
    <=> ( v72161(VarCurr)
      <~> v72157(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6721,axiom,
    ! [VarCurr: state_type] :
      ( v72161(VarCurr)
    <=> ( v72149(VarCurr)
      <~> v72153(VarCurr) ) ) ).

tff(addAssignment_45891,axiom,
    ! [VarCurr: state_type] :
      ( v72157(VarCurr)
    <=> v72159(VarCurr) ) ).

tff(addAssignment_45890,axiom,
    ! [VarCurr: state_type] :
      ( v72159(VarCurr)
    <=> v67349(VarCurr,104) ) ).

tff(addAssignment_45889,axiom,
    ! [VarCurr: state_type] :
      ( v72153(VarCurr)
    <=> v72155(VarCurr) ) ).

tff(addAssignment_45888,axiom,
    ! [VarCurr: state_type] :
      ( v72155(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_45887,axiom,
    ! [VarCurr: state_type] :
      ( v72149(VarCurr)
    <=> v72151(VarCurr) ) ).

tff(addAssignment_45886,axiom,
    ! [VarCurr: state_type] :
      ( v72151(VarCurr)
    <=> v67349(VarCurr,101) ) ).

tff(addAssignment_45885,axiom,
    ! [VarCurr: state_type] :
      ( v72105(VarCurr)
    <=> v72107(VarCurr) ) ).

tff(addAssignment_45884,axiom,
    ! [VarCurr: state_type] :
      ( v72107(VarCurr)
    <=> v72109(VarCurr) ) ).

tff(addAssignment_45883,axiom,
    ! [VarCurr: state_type] :
      ( v72109(VarCurr)
    <=> v72111(VarCurr) ) ).

tff(addAssignment_45882,axiom,
    ! [VarCurr: state_type] :
      ( v72111(VarCurr)
    <=> v72113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6720,axiom,
    ! [VarCurr: state_type] :
      ( v72113(VarCurr)
    <=> ( v72127(VarCurr)
      <~> v72123(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6719,axiom,
    ! [VarCurr: state_type] :
      ( v72127(VarCurr)
    <=> ( v72115(VarCurr)
      <~> v72119(VarCurr) ) ) ).

tff(addAssignment_45881,axiom,
    ! [VarCurr: state_type] :
      ( v72123(VarCurr)
    <=> v72125(VarCurr) ) ).

tff(addAssignment_45880,axiom,
    ! [VarCurr: state_type] :
      ( v72125(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_45879,axiom,
    ! [VarCurr: state_type] :
      ( v72119(VarCurr)
    <=> v72121(VarCurr) ) ).

tff(addAssignment_45878,axiom,
    ! [VarCurr: state_type] :
      ( v72121(VarCurr)
    <=> v67349(VarCurr,123) ) ).

tff(addAssignment_45877,axiom,
    ! [VarCurr: state_type] :
      ( v72115(VarCurr)
    <=> v72117(VarCurr) ) ).

tff(addAssignment_45876,axiom,
    ! [VarCurr: state_type] :
      ( v72117(VarCurr)
    <=> v67349(VarCurr,119) ) ).

tff(addAssignment_45875,axiom,
    ! [VarCurr: state_type] :
      ( v71831(VarCurr)
    <=> v71833(VarCurr) ) ).

tff(addAssignment_45874,axiom,
    ! [VarCurr: state_type] :
      ( v71833(VarCurr)
    <=> v71835(VarCurr) ) ).

tff(addAssignment_45873,axiom,
    ! [VarCurr: state_type] :
      ( v71835(VarCurr)
    <=> v71837(VarCurr) ) ).

tff(addAssignment_45872,axiom,
    ! [VarCurr: state_type] :
      ( v71837(VarCurr)
    <=> v71839(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6718,axiom,
    ! [VarCurr: state_type] :
      ( v71839(VarCurr)
    <=> ( v72093(VarCurr)
      <~> v72009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6717,axiom,
    ! [VarCurr: state_type] :
      ( v72093(VarCurr)
    <=> ( v71841(VarCurr)
      <~> v71925(VarCurr) ) ) ).

tff(addAssignment_45871,axiom,
    ! [VarCurr: state_type] :
      ( v72009(VarCurr)
    <=> v72011(VarCurr) ) ).

tff(addAssignment_45870,axiom,
    ! [VarCurr: state_type] :
      ( v72011(VarCurr)
    <=> v72013(VarCurr) ) ).

tff(addAssignment_45869,axiom,
    ! [VarCurr: state_type] :
      ( v72013(VarCurr)
    <=> v72015(VarCurr) ) ).

tff(addAssignment_45868,axiom,
    ! [VarCurr: state_type] :
      ( v72015(VarCurr)
    <=> v72017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6716,axiom,
    ! [VarCurr: state_type] :
      ( v72017(VarCurr)
    <=> ( v72091(VarCurr)
      <~> v72067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6715,axiom,
    ! [VarCurr: state_type] :
      ( v72091(VarCurr)
    <=> ( v72019(VarCurr)
      <~> v72043(VarCurr) ) ) ).

tff(addAssignment_45867,axiom,
    ! [VarCurr: state_type] :
      ( v72067(VarCurr)
    <=> v72069(VarCurr) ) ).

tff(addAssignment_45866,axiom,
    ! [VarCurr: state_type] :
      ( v72069(VarCurr)
    <=> v72071(VarCurr) ) ).

tff(addAssignment_45865,axiom,
    ! [VarCurr: state_type] :
      ( v72071(VarCurr)
    <=> v72073(VarCurr) ) ).

tff(addAssignment_45864,axiom,
    ! [VarCurr: state_type] :
      ( v72073(VarCurr)
    <=> v72075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6714,axiom,
    ! [VarCurr: state_type] :
      ( v72075(VarCurr)
    <=> ( v72089(VarCurr)
      <~> v72085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6713,axiom,
    ! [VarCurr: state_type] :
      ( v72089(VarCurr)
    <=> ( v72077(VarCurr)
      <~> v72081(VarCurr) ) ) ).

tff(addAssignment_45863,axiom,
    ! [VarCurr: state_type] :
      ( v72085(VarCurr)
    <=> v72087(VarCurr) ) ).

tff(addAssignment_45862,axiom,
    ! [VarCurr: state_type] :
      ( v72087(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_45861,axiom,
    ! [VarCurr: state_type] :
      ( v72081(VarCurr)
    <=> v72083(VarCurr) ) ).

tff(addAssignment_45860,axiom,
    ! [VarCurr: state_type] :
      ( v72083(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_45859,axiom,
    ! [VarCurr: state_type] :
      ( v72077(VarCurr)
    <=> v72079(VarCurr) ) ).

tff(addAssignment_45858,axiom,
    ! [VarCurr: state_type] :
      ( v72079(VarCurr)
    <=> v67349(VarCurr,96) ) ).

tff(addAssignment_45857,axiom,
    ! [VarCurr: state_type] :
      ( v72043(VarCurr)
    <=> v72045(VarCurr) ) ).

tff(addAssignment_45856,axiom,
    ! [VarCurr: state_type] :
      ( v72045(VarCurr)
    <=> v72047(VarCurr) ) ).

tff(addAssignment_45855,axiom,
    ! [VarCurr: state_type] :
      ( v72047(VarCurr)
    <=> v72049(VarCurr) ) ).

tff(addAssignment_45854,axiom,
    ! [VarCurr: state_type] :
      ( v72049(VarCurr)
    <=> v72051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6712,axiom,
    ! [VarCurr: state_type] :
      ( v72051(VarCurr)
    <=> ( v72065(VarCurr)
      <~> v72061(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6711,axiom,
    ! [VarCurr: state_type] :
      ( v72065(VarCurr)
    <=> ( v72053(VarCurr)
      <~> v72057(VarCurr) ) ) ).

tff(addAssignment_45853,axiom,
    ! [VarCurr: state_type] :
      ( v72061(VarCurr)
    <=> v72063(VarCurr) ) ).

tff(addAssignment_45852,axiom,
    ! [VarCurr: state_type] :
      ( v72063(VarCurr)
    <=> v67349(VarCurr,94) ) ).

tff(addAssignment_45851,axiom,
    ! [VarCurr: state_type] :
      ( v72057(VarCurr)
    <=> v72059(VarCurr) ) ).

tff(addAssignment_45850,axiom,
    ! [VarCurr: state_type] :
      ( v72059(VarCurr)
    <=> v67349(VarCurr,90) ) ).

tff(addAssignment_45849,axiom,
    ! [VarCurr: state_type] :
      ( v72053(VarCurr)
    <=> v72055(VarCurr) ) ).

tff(addAssignment_45848,axiom,
    ! [VarCurr: state_type] :
      ( v72055(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_45847,axiom,
    ! [VarCurr: state_type] :
      ( v72019(VarCurr)
    <=> v72021(VarCurr) ) ).

tff(addAssignment_45846,axiom,
    ! [VarCurr: state_type] :
      ( v72021(VarCurr)
    <=> v72023(VarCurr) ) ).

tff(addAssignment_45845,axiom,
    ! [VarCurr: state_type] :
      ( v72023(VarCurr)
    <=> v72025(VarCurr) ) ).

tff(addAssignment_45844,axiom,
    ! [VarCurr: state_type] :
      ( v72025(VarCurr)
    <=> v72027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6710,axiom,
    ! [VarCurr: state_type] :
      ( v72027(VarCurr)
    <=> ( v72041(VarCurr)
      <~> v72037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6709,axiom,
    ! [VarCurr: state_type] :
      ( v72041(VarCurr)
    <=> ( v72029(VarCurr)
      <~> v72033(VarCurr) ) ) ).

tff(addAssignment_45843,axiom,
    ! [VarCurr: state_type] :
      ( v72037(VarCurr)
    <=> v72039(VarCurr) ) ).

tff(addAssignment_45842,axiom,
    ! [VarCurr: state_type] :
      ( v72039(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_45841,axiom,
    ! [VarCurr: state_type] :
      ( v72033(VarCurr)
    <=> v72035(VarCurr) ) ).

tff(addAssignment_45840,axiom,
    ! [VarCurr: state_type] :
      ( v72035(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_45839,axiom,
    ! [VarCurr: state_type] :
      ( v72029(VarCurr)
    <=> v72031(VarCurr) ) ).

tff(addAssignment_45838,axiom,
    ! [VarCurr: state_type] :
      ( v72031(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_45837,axiom,
    ! [VarCurr: state_type] :
      ( v71925(VarCurr)
    <=> v71927(VarCurr) ) ).

tff(addAssignment_45836,axiom,
    ! [VarCurr: state_type] :
      ( v71927(VarCurr)
    <=> v71929(VarCurr) ) ).

tff(addAssignment_45835,axiom,
    ! [VarCurr: state_type] :
      ( v71929(VarCurr)
    <=> v71931(VarCurr) ) ).

tff(addAssignment_45834,axiom,
    ! [VarCurr: state_type] :
      ( v71931(VarCurr)
    <=> v71933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6708,axiom,
    ! [VarCurr: state_type] :
      ( v71933(VarCurr)
    <=> ( v72007(VarCurr)
      <~> v71983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6707,axiom,
    ! [VarCurr: state_type] :
      ( v72007(VarCurr)
    <=> ( v71935(VarCurr)
      <~> v71959(VarCurr) ) ) ).

tff(addAssignment_45833,axiom,
    ! [VarCurr: state_type] :
      ( v71983(VarCurr)
    <=> v71985(VarCurr) ) ).

tff(addAssignment_45832,axiom,
    ! [VarCurr: state_type] :
      ( v71985(VarCurr)
    <=> v71987(VarCurr) ) ).

tff(addAssignment_45831,axiom,
    ! [VarCurr: state_type] :
      ( v71987(VarCurr)
    <=> v71989(VarCurr) ) ).

tff(addAssignment_45830,axiom,
    ! [VarCurr: state_type] :
      ( v71989(VarCurr)
    <=> v71991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6706,axiom,
    ! [VarCurr: state_type] :
      ( v71991(VarCurr)
    <=> ( v72005(VarCurr)
      <~> v72001(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6705,axiom,
    ! [VarCurr: state_type] :
      ( v72005(VarCurr)
    <=> ( v71993(VarCurr)
      <~> v71997(VarCurr) ) ) ).

tff(addAssignment_45829,axiom,
    ! [VarCurr: state_type] :
      ( v72001(VarCurr)
    <=> v72003(VarCurr) ) ).

tff(addAssignment_45828,axiom,
    ! [VarCurr: state_type] :
      ( v72003(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_45827,axiom,
    ! [VarCurr: state_type] :
      ( v71997(VarCurr)
    <=> v71999(VarCurr) ) ).

tff(addAssignment_45826,axiom,
    ! [VarCurr: state_type] :
      ( v71999(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_45825,axiom,
    ! [VarCurr: state_type] :
      ( v71993(VarCurr)
    <=> v71995(VarCurr) ) ).

tff(addAssignment_45824,axiom,
    ! [VarCurr: state_type] :
      ( v71995(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_45823,axiom,
    ! [VarCurr: state_type] :
      ( v71959(VarCurr)
    <=> v71961(VarCurr) ) ).

tff(addAssignment_45822,axiom,
    ! [VarCurr: state_type] :
      ( v71961(VarCurr)
    <=> v71963(VarCurr) ) ).

tff(addAssignment_45821,axiom,
    ! [VarCurr: state_type] :
      ( v71963(VarCurr)
    <=> v71965(VarCurr) ) ).

tff(addAssignment_45820,axiom,
    ! [VarCurr: state_type] :
      ( v71965(VarCurr)
    <=> v71967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6704,axiom,
    ! [VarCurr: state_type] :
      ( v71967(VarCurr)
    <=> ( v71981(VarCurr)
      <~> v71977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6703,axiom,
    ! [VarCurr: state_type] :
      ( v71981(VarCurr)
    <=> ( v71969(VarCurr)
      <~> v71973(VarCurr) ) ) ).

tff(addAssignment_45819,axiom,
    ! [VarCurr: state_type] :
      ( v71977(VarCurr)
    <=> v71979(VarCurr) ) ).

tff(addAssignment_45818,axiom,
    ! [VarCurr: state_type] :
      ( v71979(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_45817,axiom,
    ! [VarCurr: state_type] :
      ( v71973(VarCurr)
    <=> v71975(VarCurr) ) ).

tff(addAssignment_45816,axiom,
    ! [VarCurr: state_type] :
      ( v71975(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_45815,axiom,
    ! [VarCurr: state_type] :
      ( v71969(VarCurr)
    <=> v71971(VarCurr) ) ).

tff(addAssignment_45814,axiom,
    ! [VarCurr: state_type] :
      ( v71971(VarCurr)
    <=> v67349(VarCurr,73) ) ).

tff(addAssignment_45813,axiom,
    ! [VarCurr: state_type] :
      ( v71935(VarCurr)
    <=> v71937(VarCurr) ) ).

tff(addAssignment_45812,axiom,
    ! [VarCurr: state_type] :
      ( v71937(VarCurr)
    <=> v71939(VarCurr) ) ).

tff(addAssignment_45811,axiom,
    ! [VarCurr: state_type] :
      ( v71939(VarCurr)
    <=> v71941(VarCurr) ) ).

tff(addAssignment_45810,axiom,
    ! [VarCurr: state_type] :
      ( v71941(VarCurr)
    <=> v71943(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6702,axiom,
    ! [VarCurr: state_type] :
      ( v71943(VarCurr)
    <=> ( v71957(VarCurr)
      <~> v71953(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6701,axiom,
    ! [VarCurr: state_type] :
      ( v71957(VarCurr)
    <=> ( v71945(VarCurr)
      <~> v71949(VarCurr) ) ) ).

tff(addAssignment_45809,axiom,
    ! [VarCurr: state_type] :
      ( v71953(VarCurr)
    <=> v71955(VarCurr) ) ).

tff(addAssignment_45808,axiom,
    ! [VarCurr: state_type] :
      ( v71955(VarCurr)
    <=> v67349(VarCurr,72) ) ).

tff(addAssignment_45807,axiom,
    ! [VarCurr: state_type] :
      ( v71949(VarCurr)
    <=> v71951(VarCurr) ) ).

tff(addAssignment_45806,axiom,
    ! [VarCurr: state_type] :
      ( v71951(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_45805,axiom,
    ! [VarCurr: state_type] :
      ( v71945(VarCurr)
    <=> v71947(VarCurr) ) ).

tff(addAssignment_45804,axiom,
    ! [VarCurr: state_type] :
      ( v71947(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_45803,axiom,
    ! [VarCurr: state_type] :
      ( v71841(VarCurr)
    <=> v71843(VarCurr) ) ).

tff(addAssignment_45802,axiom,
    ! [VarCurr: state_type] :
      ( v71843(VarCurr)
    <=> v71845(VarCurr) ) ).

tff(addAssignment_45801,axiom,
    ! [VarCurr: state_type] :
      ( v71845(VarCurr)
    <=> v71847(VarCurr) ) ).

tff(addAssignment_45800,axiom,
    ! [VarCurr: state_type] :
      ( v71847(VarCurr)
    <=> v71849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6700,axiom,
    ! [VarCurr: state_type] :
      ( v71849(VarCurr)
    <=> ( v71923(VarCurr)
      <~> v71899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6699,axiom,
    ! [VarCurr: state_type] :
      ( v71923(VarCurr)
    <=> ( v71851(VarCurr)
      <~> v71875(VarCurr) ) ) ).

tff(addAssignment_45799,axiom,
    ! [VarCurr: state_type] :
      ( v71899(VarCurr)
    <=> v71901(VarCurr) ) ).

tff(addAssignment_45798,axiom,
    ! [VarCurr: state_type] :
      ( v71901(VarCurr)
    <=> v71903(VarCurr) ) ).

tff(addAssignment_45797,axiom,
    ! [VarCurr: state_type] :
      ( v71903(VarCurr)
    <=> v71905(VarCurr) ) ).

tff(addAssignment_45796,axiom,
    ! [VarCurr: state_type] :
      ( v71905(VarCurr)
    <=> v71907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6698,axiom,
    ! [VarCurr: state_type] :
      ( v71907(VarCurr)
    <=> ( v71921(VarCurr)
      <~> v71917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6697,axiom,
    ! [VarCurr: state_type] :
      ( v71921(VarCurr)
    <=> ( v71909(VarCurr)
      <~> v71913(VarCurr) ) ) ).

tff(addAssignment_45795,axiom,
    ! [VarCurr: state_type] :
      ( v71917(VarCurr)
    <=> v71919(VarCurr) ) ).

tff(addAssignment_45794,axiom,
    ! [VarCurr: state_type] :
      ( v71919(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_45793,axiom,
    ! [VarCurr: state_type] :
      ( v71913(VarCurr)
    <=> v71915(VarCurr) ) ).

tff(addAssignment_45792,axiom,
    ! [VarCurr: state_type] :
      ( v71915(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_45791,axiom,
    ! [VarCurr: state_type] :
      ( v71909(VarCurr)
    <=> v71911(VarCurr) ) ).

tff(addAssignment_45790,axiom,
    ! [VarCurr: state_type] :
      ( v71911(VarCurr)
    <=> v67349(VarCurr,64) ) ).

tff(addAssignment_45789,axiom,
    ! [VarCurr: state_type] :
      ( v71875(VarCurr)
    <=> v71877(VarCurr) ) ).

tff(addAssignment_45788,axiom,
    ! [VarCurr: state_type] :
      ( v71877(VarCurr)
    <=> v71879(VarCurr) ) ).

tff(addAssignment_45787,axiom,
    ! [VarCurr: state_type] :
      ( v71879(VarCurr)
    <=> v71881(VarCurr) ) ).

tff(addAssignment_45786,axiom,
    ! [VarCurr: state_type] :
      ( v71881(VarCurr)
    <=> v71883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6696,axiom,
    ! [VarCurr: state_type] :
      ( v71883(VarCurr)
    <=> ( v71897(VarCurr)
      <~> v71893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6695,axiom,
    ! [VarCurr: state_type] :
      ( v71897(VarCurr)
    <=> ( v71885(VarCurr)
      <~> v71889(VarCurr) ) ) ).

tff(addAssignment_45785,axiom,
    ! [VarCurr: state_type] :
      ( v71893(VarCurr)
    <=> v71895(VarCurr) ) ).

tff(addAssignment_45784,axiom,
    ! [VarCurr: state_type] :
      ( v71895(VarCurr)
    <=> v67349(VarCurr,63) ) ).

tff(addAssignment_45783,axiom,
    ! [VarCurr: state_type] :
      ( v71889(VarCurr)
    <=> v71891(VarCurr) ) ).

tff(addAssignment_45782,axiom,
    ! [VarCurr: state_type] :
      ( v71891(VarCurr)
    <=> v67349(VarCurr,59) ) ).

tff(addAssignment_45781,axiom,
    ! [VarCurr: state_type] :
      ( v71885(VarCurr)
    <=> v71887(VarCurr) ) ).

tff(addAssignment_45780,axiom,
    ! [VarCurr: state_type] :
      ( v71887(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_45779,axiom,
    ! [VarCurr: state_type] :
      ( v71851(VarCurr)
    <=> v71853(VarCurr) ) ).

tff(addAssignment_45778,axiom,
    ! [VarCurr: state_type] :
      ( v71853(VarCurr)
    <=> v71855(VarCurr) ) ).

tff(addAssignment_45777,axiom,
    ! [VarCurr: state_type] :
      ( v71855(VarCurr)
    <=> v71857(VarCurr) ) ).

tff(addAssignment_45776,axiom,
    ! [VarCurr: state_type] :
      ( v71857(VarCurr)
    <=> v71859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6694,axiom,
    ! [VarCurr: state_type] :
      ( v71859(VarCurr)
    <=> ( v71873(VarCurr)
      <~> v71869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6693,axiom,
    ! [VarCurr: state_type] :
      ( v71873(VarCurr)
    <=> ( v71861(VarCurr)
      <~> v71865(VarCurr) ) ) ).

tff(addAssignment_45775,axiom,
    ! [VarCurr: state_type] :
      ( v71869(VarCurr)
    <=> v71871(VarCurr) ) ).

tff(addAssignment_45774,axiom,
    ! [VarCurr: state_type] :
      ( v71871(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_45773,axiom,
    ! [VarCurr: state_type] :
      ( v71865(VarCurr)
    <=> v71867(VarCurr) ) ).

tff(addAssignment_45772,axiom,
    ! [VarCurr: state_type] :
      ( v71867(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_45771,axiom,
    ! [VarCurr: state_type] :
      ( v71861(VarCurr)
    <=> v71863(VarCurr) ) ).

tff(addAssignment_45770,axiom,
    ! [VarCurr: state_type] :
      ( v71863(VarCurr)
    <=> v67349(VarCurr,49) ) ).

tff(addAssignment_45769,axiom,
    ! [VarCurr: state_type] :
      ( v71567(VarCurr)
    <=> v71569(VarCurr) ) ).

tff(addAssignment_45768,axiom,
    ! [VarCurr: state_type] :
      ( v71569(VarCurr)
    <=> v71571(VarCurr) ) ).

tff(addAssignment_45767,axiom,
    ! [VarCurr: state_type] :
      ( v71571(VarCurr)
    <=> v71573(VarCurr) ) ).

tff(addAssignment_45766,axiom,
    ! [VarCurr: state_type] :
      ( v71573(VarCurr)
    <=> v71575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6692,axiom,
    ! [VarCurr: state_type] :
      ( v71575(VarCurr)
    <=> ( v71829(VarCurr)
      <~> v71745(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6691,axiom,
    ! [VarCurr: state_type] :
      ( v71829(VarCurr)
    <=> ( v71577(VarCurr)
      <~> v71661(VarCurr) ) ) ).

tff(addAssignment_45765,axiom,
    ! [VarCurr: state_type] :
      ( v71745(VarCurr)
    <=> v71747(VarCurr) ) ).

tff(addAssignment_45764,axiom,
    ! [VarCurr: state_type] :
      ( v71747(VarCurr)
    <=> v71749(VarCurr) ) ).

tff(addAssignment_45763,axiom,
    ! [VarCurr: state_type] :
      ( v71749(VarCurr)
    <=> v71751(VarCurr) ) ).

tff(addAssignment_45762,axiom,
    ! [VarCurr: state_type] :
      ( v71751(VarCurr)
    <=> v71753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6690,axiom,
    ! [VarCurr: state_type] :
      ( v71753(VarCurr)
    <=> ( v71827(VarCurr)
      <~> v71803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6689,axiom,
    ! [VarCurr: state_type] :
      ( v71827(VarCurr)
    <=> ( v71755(VarCurr)
      <~> v71779(VarCurr) ) ) ).

tff(addAssignment_45761,axiom,
    ! [VarCurr: state_type] :
      ( v71803(VarCurr)
    <=> v71805(VarCurr) ) ).

tff(addAssignment_45760,axiom,
    ! [VarCurr: state_type] :
      ( v71805(VarCurr)
    <=> v71807(VarCurr) ) ).

tff(addAssignment_45759,axiom,
    ! [VarCurr: state_type] :
      ( v71807(VarCurr)
    <=> v71809(VarCurr) ) ).

tff(addAssignment_45758,axiom,
    ! [VarCurr: state_type] :
      ( v71809(VarCurr)
    <=> v71811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6688,axiom,
    ! [VarCurr: state_type] :
      ( v71811(VarCurr)
    <=> ( v71825(VarCurr)
      <~> v71821(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6687,axiom,
    ! [VarCurr: state_type] :
      ( v71825(VarCurr)
    <=> ( v71813(VarCurr)
      <~> v71817(VarCurr) ) ) ).

tff(addAssignment_45757,axiom,
    ! [VarCurr: state_type] :
      ( v71821(VarCurr)
    <=> v71823(VarCurr) ) ).

tff(addAssignment_45756,axiom,
    ! [VarCurr: state_type] :
      ( v71823(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_45755,axiom,
    ! [VarCurr: state_type] :
      ( v71817(VarCurr)
    <=> v71819(VarCurr) ) ).

tff(addAssignment_45754,axiom,
    ! [VarCurr: state_type] :
      ( v71819(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_45753,axiom,
    ! [VarCurr: state_type] :
      ( v71813(VarCurr)
    <=> v71815(VarCurr) ) ).

tff(addAssignment_45752,axiom,
    ! [VarCurr: state_type] :
      ( v71815(VarCurr)
    <=> v67349(VarCurr,44) ) ).

tff(addAssignment_45751,axiom,
    ! [VarCurr: state_type] :
      ( v71779(VarCurr)
    <=> v71781(VarCurr) ) ).

tff(addAssignment_45750,axiom,
    ! [VarCurr: state_type] :
      ( v71781(VarCurr)
    <=> v71783(VarCurr) ) ).

tff(addAssignment_45749,axiom,
    ! [VarCurr: state_type] :
      ( v71783(VarCurr)
    <=> v71785(VarCurr) ) ).

tff(addAssignment_45748,axiom,
    ! [VarCurr: state_type] :
      ( v71785(VarCurr)
    <=> v71787(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6686,axiom,
    ! [VarCurr: state_type] :
      ( v71787(VarCurr)
    <=> ( v71801(VarCurr)
      <~> v71797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6685,axiom,
    ! [VarCurr: state_type] :
      ( v71801(VarCurr)
    <=> ( v71789(VarCurr)
      <~> v71793(VarCurr) ) ) ).

tff(addAssignment_45747,axiom,
    ! [VarCurr: state_type] :
      ( v71797(VarCurr)
    <=> v71799(VarCurr) ) ).

tff(addAssignment_45746,axiom,
    ! [VarCurr: state_type] :
      ( v71799(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_45745,axiom,
    ! [VarCurr: state_type] :
      ( v71793(VarCurr)
    <=> v71795(VarCurr) ) ).

tff(addAssignment_45744,axiom,
    ! [VarCurr: state_type] :
      ( v71795(VarCurr)
    <=> v67349(VarCurr,41) ) ).

tff(addAssignment_45743,axiom,
    ! [VarCurr: state_type] :
      ( v71789(VarCurr)
    <=> v71791(VarCurr) ) ).

tff(addAssignment_45742,axiom,
    ! [VarCurr: state_type] :
      ( v71791(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_45741,axiom,
    ! [VarCurr: state_type] :
      ( v71755(VarCurr)
    <=> v71757(VarCurr) ) ).

tff(addAssignment_45740,axiom,
    ! [VarCurr: state_type] :
      ( v71757(VarCurr)
    <=> v71759(VarCurr) ) ).

tff(addAssignment_45739,axiom,
    ! [VarCurr: state_type] :
      ( v71759(VarCurr)
    <=> v71761(VarCurr) ) ).

tff(addAssignment_45738,axiom,
    ! [VarCurr: state_type] :
      ( v71761(VarCurr)
    <=> v71763(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6684,axiom,
    ! [VarCurr: state_type] :
      ( v71763(VarCurr)
    <=> ( v71777(VarCurr)
      <~> v71773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6683,axiom,
    ! [VarCurr: state_type] :
      ( v71777(VarCurr)
    <=> ( v71765(VarCurr)
      <~> v71769(VarCurr) ) ) ).

tff(addAssignment_45737,axiom,
    ! [VarCurr: state_type] :
      ( v71773(VarCurr)
    <=> v71775(VarCurr) ) ).

tff(addAssignment_45736,axiom,
    ! [VarCurr: state_type] :
      ( v71775(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_45735,axiom,
    ! [VarCurr: state_type] :
      ( v71769(VarCurr)
    <=> v71771(VarCurr) ) ).

tff(addAssignment_45734,axiom,
    ! [VarCurr: state_type] :
      ( v71771(VarCurr)
    <=> v67349(VarCurr,36) ) ).

tff(addAssignment_45733,axiom,
    ! [VarCurr: state_type] :
      ( v71765(VarCurr)
    <=> v71767(VarCurr) ) ).

tff(addAssignment_45732,axiom,
    ! [VarCurr: state_type] :
      ( v71767(VarCurr)
    <=> v67349(VarCurr,34) ) ).

tff(addAssignment_45731,axiom,
    ! [VarCurr: state_type] :
      ( v71661(VarCurr)
    <=> v71663(VarCurr) ) ).

tff(addAssignment_45730,axiom,
    ! [VarCurr: state_type] :
      ( v71663(VarCurr)
    <=> v71665(VarCurr) ) ).

tff(addAssignment_45729,axiom,
    ! [VarCurr: state_type] :
      ( v71665(VarCurr)
    <=> v71667(VarCurr) ) ).

tff(addAssignment_45728,axiom,
    ! [VarCurr: state_type] :
      ( v71667(VarCurr)
    <=> v71669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6682,axiom,
    ! [VarCurr: state_type] :
      ( v71669(VarCurr)
    <=> ( v71743(VarCurr)
      <~> v71719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6681,axiom,
    ! [VarCurr: state_type] :
      ( v71743(VarCurr)
    <=> ( v71671(VarCurr)
      <~> v71695(VarCurr) ) ) ).

tff(addAssignment_45727,axiom,
    ! [VarCurr: state_type] :
      ( v71719(VarCurr)
    <=> v71721(VarCurr) ) ).

tff(addAssignment_45726,axiom,
    ! [VarCurr: state_type] :
      ( v71721(VarCurr)
    <=> v71723(VarCurr) ) ).

tff(addAssignment_45725,axiom,
    ! [VarCurr: state_type] :
      ( v71723(VarCurr)
    <=> v71725(VarCurr) ) ).

tff(addAssignment_45724,axiom,
    ! [VarCurr: state_type] :
      ( v71725(VarCurr)
    <=> v71727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6680,axiom,
    ! [VarCurr: state_type] :
      ( v71727(VarCurr)
    <=> ( v71741(VarCurr)
      <~> v71737(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6679,axiom,
    ! [VarCurr: state_type] :
      ( v71741(VarCurr)
    <=> ( v71729(VarCurr)
      <~> v71733(VarCurr) ) ) ).

tff(addAssignment_45723,axiom,
    ! [VarCurr: state_type] :
      ( v71737(VarCurr)
    <=> v71739(VarCurr) ) ).

tff(addAssignment_45722,axiom,
    ! [VarCurr: state_type] :
      ( v71739(VarCurr)
    <=> v67349(VarCurr,30) ) ).

tff(addAssignment_45721,axiom,
    ! [VarCurr: state_type] :
      ( v71733(VarCurr)
    <=> v71735(VarCurr) ) ).

tff(addAssignment_45720,axiom,
    ! [VarCurr: state_type] :
      ( v71735(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_45719,axiom,
    ! [VarCurr: state_type] :
      ( v71729(VarCurr)
    <=> v71731(VarCurr) ) ).

tff(addAssignment_45718,axiom,
    ! [VarCurr: state_type] :
      ( v71731(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_45717,axiom,
    ! [VarCurr: state_type] :
      ( v71695(VarCurr)
    <=> v71697(VarCurr) ) ).

tff(addAssignment_45716,axiom,
    ! [VarCurr: state_type] :
      ( v71697(VarCurr)
    <=> v71699(VarCurr) ) ).

tff(addAssignment_45715,axiom,
    ! [VarCurr: state_type] :
      ( v71699(VarCurr)
    <=> v71701(VarCurr) ) ).

tff(addAssignment_45714,axiom,
    ! [VarCurr: state_type] :
      ( v71701(VarCurr)
    <=> v71703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6678,axiom,
    ! [VarCurr: state_type] :
      ( v71703(VarCurr)
    <=> ( v71717(VarCurr)
      <~> v71713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6677,axiom,
    ! [VarCurr: state_type] :
      ( v71717(VarCurr)
    <=> ( v71705(VarCurr)
      <~> v71709(VarCurr) ) ) ).

tff(addAssignment_45713,axiom,
    ! [VarCurr: state_type] :
      ( v71713(VarCurr)
    <=> v71715(VarCurr) ) ).

tff(addAssignment_45712,axiom,
    ! [VarCurr: state_type] :
      ( v71715(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_45711,axiom,
    ! [VarCurr: state_type] :
      ( v71709(VarCurr)
    <=> v71711(VarCurr) ) ).

tff(addAssignment_45710,axiom,
    ! [VarCurr: state_type] :
      ( v71711(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_45709,axiom,
    ! [VarCurr: state_type] :
      ( v71705(VarCurr)
    <=> v71707(VarCurr) ) ).

tff(addAssignment_45708,axiom,
    ! [VarCurr: state_type] :
      ( v71707(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_45707,axiom,
    ! [VarCurr: state_type] :
      ( v71671(VarCurr)
    <=> v71673(VarCurr) ) ).

tff(addAssignment_45706,axiom,
    ! [VarCurr: state_type] :
      ( v71673(VarCurr)
    <=> v71675(VarCurr) ) ).

tff(addAssignment_45705,axiom,
    ! [VarCurr: state_type] :
      ( v71675(VarCurr)
    <=> v71677(VarCurr) ) ).

tff(addAssignment_45704,axiom,
    ! [VarCurr: state_type] :
      ( v71677(VarCurr)
    <=> v71679(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6676,axiom,
    ! [VarCurr: state_type] :
      ( v71679(VarCurr)
    <=> ( v71693(VarCurr)
      <~> v71689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6675,axiom,
    ! [VarCurr: state_type] :
      ( v71693(VarCurr)
    <=> ( v71681(VarCurr)
      <~> v71685(VarCurr) ) ) ).

tff(addAssignment_45703,axiom,
    ! [VarCurr: state_type] :
      ( v71689(VarCurr)
    <=> v71691(VarCurr) ) ).

tff(addAssignment_45702,axiom,
    ! [VarCurr: state_type] :
      ( v71691(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_45701,axiom,
    ! [VarCurr: state_type] :
      ( v71685(VarCurr)
    <=> v71687(VarCurr) ) ).

tff(addAssignment_45700,axiom,
    ! [VarCurr: state_type] :
      ( v71687(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_45699,axiom,
    ! [VarCurr: state_type] :
      ( v71681(VarCurr)
    <=> v71683(VarCurr) ) ).

tff(addAssignment_45698,axiom,
    ! [VarCurr: state_type] :
      ( v71683(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_45697,axiom,
    ! [VarCurr: state_type] :
      ( v71577(VarCurr)
    <=> v71579(VarCurr) ) ).

tff(addAssignment_45696,axiom,
    ! [VarCurr: state_type] :
      ( v71579(VarCurr)
    <=> v71581(VarCurr) ) ).

tff(addAssignment_45695,axiom,
    ! [VarCurr: state_type] :
      ( v71581(VarCurr)
    <=> v71583(VarCurr) ) ).

tff(addAssignment_45694,axiom,
    ! [VarCurr: state_type] :
      ( v71583(VarCurr)
    <=> v71585(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6674,axiom,
    ! [VarCurr: state_type] :
      ( v71585(VarCurr)
    <=> ( v71659(VarCurr)
      <~> v71635(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6673,axiom,
    ! [VarCurr: state_type] :
      ( v71659(VarCurr)
    <=> ( v71587(VarCurr)
      <~> v71611(VarCurr) ) ) ).

tff(addAssignment_45693,axiom,
    ! [VarCurr: state_type] :
      ( v71635(VarCurr)
    <=> v71637(VarCurr) ) ).

tff(addAssignment_45692,axiom,
    ! [VarCurr: state_type] :
      ( v71637(VarCurr)
    <=> v71639(VarCurr) ) ).

tff(addAssignment_45691,axiom,
    ! [VarCurr: state_type] :
      ( v71639(VarCurr)
    <=> v71641(VarCurr) ) ).

tff(addAssignment_45690,axiom,
    ! [VarCurr: state_type] :
      ( v71641(VarCurr)
    <=> v71643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6672,axiom,
    ! [VarCurr: state_type] :
      ( v71643(VarCurr)
    <=> ( v71657(VarCurr)
      <~> v71653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6671,axiom,
    ! [VarCurr: state_type] :
      ( v71657(VarCurr)
    <=> ( v71645(VarCurr)
      <~> v71649(VarCurr) ) ) ).

tff(addAssignment_45689,axiom,
    ! [VarCurr: state_type] :
      ( v71653(VarCurr)
    <=> v71655(VarCurr) ) ).

tff(addAssignment_45688,axiom,
    ! [VarCurr: state_type] :
      ( v71655(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_45687,axiom,
    ! [VarCurr: state_type] :
      ( v71649(VarCurr)
    <=> v71651(VarCurr) ) ).

tff(addAssignment_45686,axiom,
    ! [VarCurr: state_type] :
      ( v71651(VarCurr)
    <=> v67349(VarCurr,13) ) ).

tff(addAssignment_45685,axiom,
    ! [VarCurr: state_type] :
      ( v71645(VarCurr)
    <=> v71647(VarCurr) ) ).

tff(addAssignment_45684,axiom,
    ! [VarCurr: state_type] :
      ( v71647(VarCurr)
    <=> v67349(VarCurr,12) ) ).

tff(addAssignment_45683,axiom,
    ! [VarCurr: state_type] :
      ( v71611(VarCurr)
    <=> v71613(VarCurr) ) ).

tff(addAssignment_45682,axiom,
    ! [VarCurr: state_type] :
      ( v71613(VarCurr)
    <=> v71615(VarCurr) ) ).

tff(addAssignment_45681,axiom,
    ! [VarCurr: state_type] :
      ( v71615(VarCurr)
    <=> v71617(VarCurr) ) ).

tff(addAssignment_45680,axiom,
    ! [VarCurr: state_type] :
      ( v71617(VarCurr)
    <=> v71619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6670,axiom,
    ! [VarCurr: state_type] :
      ( v71619(VarCurr)
    <=> ( v71633(VarCurr)
      <~> v71629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6669,axiom,
    ! [VarCurr: state_type] :
      ( v71633(VarCurr)
    <=> ( v71621(VarCurr)
      <~> v71625(VarCurr) ) ) ).

tff(addAssignment_45679,axiom,
    ! [VarCurr: state_type] :
      ( v71629(VarCurr)
    <=> v71631(VarCurr) ) ).

tff(addAssignment_45678,axiom,
    ! [VarCurr: state_type] :
      ( v71631(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_45677,axiom,
    ! [VarCurr: state_type] :
      ( v71625(VarCurr)
    <=> v71627(VarCurr) ) ).

tff(addAssignment_45676,axiom,
    ! [VarCurr: state_type] :
      ( v71627(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_45675,axiom,
    ! [VarCurr: state_type] :
      ( v71621(VarCurr)
    <=> v71623(VarCurr) ) ).

tff(addAssignment_45674,axiom,
    ! [VarCurr: state_type] :
      ( v71623(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_45673,axiom,
    ! [VarCurr: state_type] :
      ( v71587(VarCurr)
    <=> v71589(VarCurr) ) ).

tff(addAssignment_45672,axiom,
    ! [VarCurr: state_type] :
      ( v71589(VarCurr)
    <=> v71591(VarCurr) ) ).

tff(addAssignment_45671,axiom,
    ! [VarCurr: state_type] :
      ( v71591(VarCurr)
    <=> v71593(VarCurr) ) ).

tff(addAssignment_45670,axiom,
    ! [VarCurr: state_type] :
      ( v71593(VarCurr)
    <=> v71595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6668,axiom,
    ! [VarCurr: state_type] :
      ( v71595(VarCurr)
    <=> ( v71609(VarCurr)
      <~> v71605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6667,axiom,
    ! [VarCurr: state_type] :
      ( v71609(VarCurr)
    <=> ( v71597(VarCurr)
      <~> v71601(VarCurr) ) ) ).

tff(addAssignment_45669,axiom,
    ! [VarCurr: state_type] :
      ( v71605(VarCurr)
    <=> v71607(VarCurr) ) ).

tff(addAssignment_45668,axiom,
    ! [VarCurr: state_type] :
      ( v71607(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_45667,axiom,
    ! [VarCurr: state_type] :
      ( v71601(VarCurr)
    <=> v71603(VarCurr) ) ).

tff(addAssignment_45666,axiom,
    ! [VarCurr: state_type] :
      ( v71603(VarCurr)
    <=> v67349(VarCurr,4) ) ).

tff(addAssignment_45665,axiom,
    ! [VarCurr: state_type] :
      ( v71597(VarCurr)
    <=> v71599(VarCurr) ) ).

tff(addAssignment_45664,axiom,
    ! [VarCurr: state_type] :
      ( v71599(VarCurr)
    <=> v67349(VarCurr,3) ) ).

tff(addAssignment_45663,axiom,
    ! [VarCurr: state_type] :
      ( v67263(VarCurr)
    <=> v67265(VarCurr) ) ).

tff(addAssignment_45662,axiom,
    ! [VarCurr: state_type] :
      ( v67265(VarCurr)
    <=> v67267(VarCurr) ) ).

tff(addAssignment_45661,axiom,
    ! [VarCurr: state_type] :
      ( v67267(VarCurr)
    <=> v67269(VarCurr) ) ).

tff(addAssignment_45660,axiom,
    ! [VarCurr: state_type] :
      ( v67269(VarCurr)
    <=> v67271(VarCurr) ) ).

tff(writeUnaryOperator_3438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67271(VarCurr)
    <=> v71514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6666,axiom,
    ! [VarCurr: state_type] :
      ( v71514(VarCurr)
    <=> ( v67273(VarCurr)
        & v69771(VarCurr) ) ) ).

tff(addAssignment_45659,axiom,
    ! [VarCurr: state_type] :
      ( v69771(VarCurr)
    <=> v69773(VarCurr) ) ).

tff(addAssignment_45658,axiom,
    ! [VarCurr: state_type] :
      ( v69773(VarCurr)
    <=> v69775(VarCurr) ) ).

tff(addAssignment_45657,axiom,
    ! [VarCurr: state_type] :
      ( v69775(VarCurr)
    <=> v69777(VarCurr) ) ).

tff(addAssignment_45656,axiom,
    ! [VarCurr: state_type] :
      ( v69777(VarCurr)
    <=> v69779(VarCurr) ) ).

tff(writeUnaryOperator_3437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v69779(VarCurr)
    <=> v69781(VarCurr) ) ).

tff(addAssignment_45655,axiom,
    ! [VarCurr: state_type] :
      ( v69781(VarCurr)
    <=> v69783(VarCurr) ) ).

tff(addAssignment_45654,axiom,
    ! [VarCurr: state_type] :
      ( v69783(VarCurr)
    <=> v69785(VarCurr) ) ).

tff(addAssignment_45653,axiom,
    ! [VarCurr: state_type] :
      ( v69785(VarCurr)
    <=> v69787(VarCurr) ) ).

tff(addAssignment_45652,axiom,
    ! [VarCurr: state_type] :
      ( v69787(VarCurr)
    <=> v69789(VarCurr) ) ).

tff(writeUnaryOperator_3436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v69789(VarCurr)
    <=> v71511(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6665,axiom,
    ! [VarCurr: state_type] :
      ( v71511(VarCurr)
    <=> ( v69791(VarCurr)
        & v70879(VarCurr) ) ) ).

tff(addAssignment_45651,axiom,
    ! [VarCurr: state_type] :
      ( v70879(VarCurr)
    <=> v70881(VarCurr) ) ).

tff(addAssignment_45650,axiom,
    ! [VarCurr: state_type] :
      ( v70881(VarCurr)
    <=> v70883(VarCurr) ) ).

tff(addAssignment_45649,axiom,
    ! [VarCurr: state_type] :
      ( v70883(VarCurr)
    <=> v70885(VarCurr) ) ).

tff(addAssignment_45648,axiom,
    ! [VarCurr: state_type] :
      ( v70885(VarCurr)
    <=> v70887(VarCurr) ) ).

tff(writeUnaryOperator_3435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v70887(VarCurr)
    <=> v71509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6664,axiom,
    ! [VarCurr: state_type] :
      ( v71509(VarCurr)
    <=> ( v70889(VarCurr)
        | v71199(VarCurr) ) ) ).

tff(addAssignment_45647,axiom,
    ! [VarCurr: state_type] :
      ( v71199(VarCurr)
    <=> v71201(VarCurr) ) ).

tff(addAssignment_45646,axiom,
    ! [VarCurr: state_type] :
      ( v71201(VarCurr)
    <=> v69805(VarCurr,0) ) ).

tff(addAssignment_45645,axiom,
    ! [VarCurr: state_type] :
      ( v69805(VarCurr,0)
    <=> v67309(VarCurr,4) ) ).

tff(addAssignment_45644,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,4)
    <=> v67311(VarCurr,4) ) ).

tff(addAssignment_45643,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,4)
    <=> v67313(VarCurr,4) ) ).

tff(addAssignment_45642,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,4)
    <=> v67315(VarCurr,4) ) ).

tff(addAssignment_45641,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,4)
    <=> v67317(VarCurr,4) ) ).

tff(addAssignment_45640,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,4)
    <=> v68771(VarCurr,4) ) ).

tff(addAssignment_45639,axiom,
    ! [VarCurr: state_type] :
      ( v68773(VarCurr,0)
    <=> v71203(VarCurr) ) ).

tff(addAssignment_45638,axiom,
    ! [VarCurr: state_type] :
      ( v71203(VarCurr)
    <=> v71205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6663,axiom,
    ! [VarCurr: state_type] :
      ( v71205(VarCurr)
    <=> ( v71507(VarCurr)
      <~> v71495(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6662,axiom,
    ! [VarCurr: state_type] :
      ( v71507(VarCurr)
    <=> ( v71207(VarCurr)
      <~> v71363(VarCurr) ) ) ).

tff(addAssignment_45637,axiom,
    ! [VarCurr: state_type] :
      ( v71495(VarCurr)
    <=> v71497(VarCurr) ) ).

tff(addAssignment_45636,axiom,
    ! [VarCurr: state_type] :
      ( v71497(VarCurr)
    <=> v70526(VarCurr,0) ) ).

tff(addAssignment_45635,axiom,
    ! [VarCurr: state_type] :
      ( v70526(VarCurr,0)
    <=> v70528(VarCurr,0) ) ).

tff(addAssignment_45634,axiom,
    ! [VarCurr: state_type] :
      ( v70528(VarCurr,0)
    <=> v68595(VarCurr,5) ) ).

tff(addAssignment_45633,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,5)
    <=> v68597(VarCurr,5) ) ).

tff(addAssignment_45632,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,5)
    <=> v71499(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71500(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v71499(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_901,axiom,
    ! [VarNext: state_type] :
      ( v71500(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v71499(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71500(VarNext)
      <=> v71501(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71501(VarNext)
      <=> ( v71503(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71503(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_45631,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,5)
    <=> v68621(VarCurr,5) ) ).

tff(addAssignment_45630,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,5)
    <=> v68624(VarCurr,5) ) ).

tff(addAssignment_45629,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,4)
    <=> v70530(VarCurr,0) ) ).

tff(addAssignment_45628,axiom,
    ! [VarCurr: state_type] :
      ( v70530(VarCurr,0)
    <=> v70532(VarCurr,0) ) ).

tff(addAssignment_45627,axiom,
    ! [VarCurr: state_type] :
      ( v70532(VarCurr,0)
    <=> v70549(VarCurr,0) ) ).

tff(addAssignment_45626,axiom,
    ! [VarCurr: state_type] :
      ( v70542(VarCurr,0)
    <=> v70544(VarCurr,0) ) ).

tff(addAssignment_45625,axiom,
    ! [VarCurr: state_type] :
      ( v70544(VarCurr,0)
    <=> v68455(VarCurr,4) ) ).

tff(addAssignment_45624,axiom,
    ! [VarCurr: state_type] :
      ( v70534(VarCurr,0)
    <=> v70536(VarCurr,0) ) ).

tff(addAssignment_45623,axiom,
    ! [VarCurr: state_type] :
      ( v70536(VarCurr,0)
    <=> v68455(VarCurr,0) ) ).

tff(addAssignment_45622,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,0)
    <=> v68457(VarCurr,0) ) ).

tff(addAssignment_45621,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,0)
    <=> v68459(VarCurr,0) ) ).

tff(addAssignment_45620,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,0)
    <=> v68548(VarCurr,0) ) ).

tff(addAssignment_45619,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,0)
    <=> v68469(VarCurr,0) ) ).

tff(addAssignment_45618,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,0)
    <=> v68471(VarCurr,0) ) ).

tff(addAssignment_45617,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,0)
    <=> v67432(VarCurr,128) ) ).

tff(addAssignment_45616,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,128)
    <=> v67434(VarCurr,128) ) ).

tff(addAssignment_45615,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,128)
    <=> v68473(VarCurr,0) ) ).

tff(addAssignment_45614,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,0)
    <=> v68475(VarCurr,0) ) ).

tff(addAssignment_45613,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,0)
    <=> v68531(VarCurr,0) ) ).

tff(addAssignment_45612,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,0)
    <=> v68530(VarCurr,0) ) ).

tff(addAssignment_45611,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,0)
    <=> v6234(VarCurr,56) ) ).

tff(addAssignment_45610,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,0)
    <=> v68526(VarCurr,0) ) ).

tff(addAssignment_45609,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,0)
    <=> v53217(VarCurr,56) ) ).

tff(addAssignment_45608,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,0)
    <=> v68522(VarCurr,0) ) ).

tff(addAssignment_45607,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_45606,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,0)
    <=> v68463(VarCurr,0) ) ).

tff(addAssignment_45605,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,0)
    <=> v68464(VarCurr,0) ) ).

tff(addAssignment_45604,axiom,
    ! [VarCurr: state_type] :
      ( v71363(VarCurr)
    <=> v71365(VarCurr) ) ).

tff(addAssignment_45603,axiom,
    ! [VarCurr: state_type] :
      ( v71365(VarCurr)
    <=> v71367(VarCurr) ) ).

tff(addAssignment_45602,axiom,
    ! [VarCurr: state_type] :
      ( v71367(VarCurr)
    <=> v71369(VarCurr) ) ).

tff(addAssignment_45601,axiom,
    ! [VarCurr: state_type] :
      ( v71369(VarCurr)
    <=> v71371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6659,axiom,
    ! [VarCurr: state_type] :
      ( v71371(VarCurr)
    <=> ( v71493(VarCurr)
      <~> v71469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6658,axiom,
    ! [VarCurr: state_type] :
      ( v71493(VarCurr)
    <=> ( v71373(VarCurr)
      <~> v71421(VarCurr) ) ) ).

tff(addAssignment_45600,axiom,
    ! [VarCurr: state_type] :
      ( v71469(VarCurr)
    <=> v71471(VarCurr) ) ).

tff(addAssignment_45599,axiom,
    ! [VarCurr: state_type] :
      ( v71471(VarCurr)
    <=> v71473(VarCurr) ) ).

tff(addAssignment_45598,axiom,
    ! [VarCurr: state_type] :
      ( v71473(VarCurr)
    <=> v71475(VarCurr) ) ).

tff(addAssignment_45597,axiom,
    ! [VarCurr: state_type] :
      ( v71475(VarCurr)
    <=> v71477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6657,axiom,
    ! [VarCurr: state_type] :
      ( v71477(VarCurr)
    <=> ( v71491(VarCurr)
      <~> v71487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6656,axiom,
    ! [VarCurr: state_type] :
      ( v71491(VarCurr)
    <=> ( v71479(VarCurr)
      <~> v71483(VarCurr) ) ) ).

tff(addAssignment_45596,axiom,
    ! [VarCurr: state_type] :
      ( v71487(VarCurr)
    <=> v71489(VarCurr) ) ).

tff(addAssignment_45595,axiom,
    ! [VarCurr: state_type] :
      ( v71489(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_45594,axiom,
    ! [VarCurr: state_type] :
      ( v71483(VarCurr)
    <=> v71485(VarCurr) ) ).

tff(addAssignment_45593,axiom,
    ! [VarCurr: state_type] :
      ( v71485(VarCurr)
    <=> v67349(VarCurr,124) ) ).

tff(addAssignment_45592,axiom,
    ! [VarCurr: state_type] :
      ( v71479(VarCurr)
    <=> v71481(VarCurr) ) ).

tff(addAssignment_45591,axiom,
    ! [VarCurr: state_type] :
      ( v71481(VarCurr)
    <=> v67349(VarCurr,120) ) ).

tff(addAssignment_45590,axiom,
    ! [VarCurr: state_type] :
      ( v71421(VarCurr)
    <=> v71423(VarCurr) ) ).

tff(addAssignment_45589,axiom,
    ! [VarCurr: state_type] :
      ( v71423(VarCurr)
    <=> v71425(VarCurr) ) ).

tff(addAssignment_45588,axiom,
    ! [VarCurr: state_type] :
      ( v71425(VarCurr)
    <=> v71427(VarCurr) ) ).

tff(addAssignment_45587,axiom,
    ! [VarCurr: state_type] :
      ( v71427(VarCurr)
    <=> v71429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6655,axiom,
    ! [VarCurr: state_type] :
      ( v71429(VarCurr)
    <=> ( v71467(VarCurr)
      <~> v71455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6654,axiom,
    ! [VarCurr: state_type] :
      ( v71467(VarCurr)
    <=> ( v71431(VarCurr)
      <~> v71443(VarCurr) ) ) ).

tff(addAssignment_45586,axiom,
    ! [VarCurr: state_type] :
      ( v71455(VarCurr)
    <=> v71457(VarCurr) ) ).

tff(addAssignment_45585,axiom,
    ! [VarCurr: state_type] :
      ( v71457(VarCurr)
    <=> v67349(VarCurr,116) ) ).

tff(addAssignment_45584,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,116)
    <=> v68249(VarCurr,52) ) ).

tff(addAssignment_45583,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,52)
    <=> v68251(VarCurr,52) ) ).

tff(addAssignment_45582,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,52)
    <=> v68253(VarCurr,52) ) ).

tff(addAssignment_45581,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,52)
    <=> v68255(VarCurr,52) ) ).

tff(addAssignment_45580,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,52)
    <=> v67359(VarCurr,116) ) ).

tff(addAssignment_45579,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,116)
    <=> v67580(VarCurr,116) ) ).

tff(addAssignment_45578,axiom,
    ! [VarCurr: state_type] :
      ( v67583(VarCurr,0)
    <=> v68258(VarCurr,52) ) ).

tff(addAssignment_45577,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,52)
    <=> v68260(VarCurr,52) ) ).

tff(addAssignment_45576,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,52)
    <=> v71459(VarNext,52) ) ).

tff(addCaseBooleanConditionEqualRanges1_900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71460(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71459(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_900,axiom,
    ! [VarNext: state_type] :
      ( v71460(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71459(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71460(VarNext)
      <=> v71461(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71461(VarNext)
      <=> ( v71463(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71463(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45575,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,52)
    <=> v68284(VarCurr,52) ) ).

tff(addAssignment_45574,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,52)
    <=> v67391(VarCurr,116) ) ).

tff(addAssignment_45573,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,116)
    <=> v70457(VarCurr,0) ) ).

tff(addAssignment_45572,axiom,
    ! [VarCurr: state_type] :
      ( v70457(VarCurr,0)
    <=> v70459(VarCurr,0) ) ).

tff(addAssignment_45571,axiom,
    ! [VarCurr: state_type] :
      ( v70459(VarCurr,0)
    <=> v70476(VarCurr,0) ) ).

tff(addAssignment_45570,axiom,
    ! [VarCurr: state_type] :
      ( v70469(VarCurr,0)
    <=> v70471(VarCurr,0) ) ).

tff(addAssignment_45569,axiom,
    ! [VarCurr: state_type] :
      ( v70471(VarCurr,0)
    <=> v67401(VarCurr,116) ) ).

tff(addAssignment_45568,axiom,
    ! [VarCurr: state_type] :
      ( v70461(VarCurr,0)
    <=> v70463(VarCurr,0) ) ).

tff(addAssignment_45567,axiom,
    ! [VarCurr: state_type] :
      ( v70463(VarCurr,0)
    <=> v67401(VarCurr,120) ) ).

tff(addAssignment_45566,axiom,
    ! [VarCurr: state_type] :
      ( v71443(VarCurr)
    <=> v71445(VarCurr) ) ).

tff(addAssignment_45565,axiom,
    ! [VarCurr: state_type] :
      ( v71445(VarCurr)
    <=> v67349(VarCurr,112) ) ).

tff(addAssignment_45564,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,112)
    <=> v68249(VarCurr,48) ) ).

tff(addAssignment_45563,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,48)
    <=> v68251(VarCurr,48) ) ).

tff(addAssignment_45562,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,48)
    <=> v68253(VarCurr,48) ) ).

tff(addAssignment_45561,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,48)
    <=> v68255(VarCurr,48) ) ).

tff(addAssignment_45560,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,48)
    <=> v67359(VarCurr,112) ) ).

tff(addAssignment_45559,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,112)
    <=> v67580(VarCurr,112) ) ).

tff(addAssignment_45558,axiom,
    ! [VarCurr: state_type] :
      ( v67584(VarCurr,0)
    <=> v68258(VarCurr,48) ) ).

tff(addAssignment_45557,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,48)
    <=> v68260(VarCurr,48) ) ).

tff(addAssignment_45556,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,48)
    <=> v71447(VarNext,48) ) ).

tff(addCaseBooleanConditionEqualRanges1_899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71448(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71447(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_899,axiom,
    ! [VarNext: state_type] :
      ( v71448(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71447(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71448(VarNext)
      <=> v71449(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71449(VarNext)
      <=> ( v71451(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71451(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45555,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,48)
    <=> v68284(VarCurr,48) ) ).

tff(addAssignment_45554,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,48)
    <=> v67391(VarCurr,112) ) ).

tff(addAssignment_45553,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,112)
    <=> v70417(VarCurr,0) ) ).

tff(addAssignment_45552,axiom,
    ! [VarCurr: state_type] :
      ( v70417(VarCurr,0)
    <=> v70419(VarCurr,0) ) ).

tff(addAssignment_45551,axiom,
    ! [VarCurr: state_type] :
      ( v70419(VarCurr,0)
    <=> v70436(VarCurr,0) ) ).

tff(addAssignment_45550,axiom,
    ! [VarCurr: state_type] :
      ( v70429(VarCurr,0)
    <=> v70431(VarCurr,0) ) ).

tff(addAssignment_45549,axiom,
    ! [VarCurr: state_type] :
      ( v70431(VarCurr,0)
    <=> v67401(VarCurr,112) ) ).

tff(addAssignment_45548,axiom,
    ! [VarCurr: state_type] :
      ( v70421(VarCurr,0)
    <=> v70423(VarCurr,0) ) ).

tff(addAssignment_45547,axiom,
    ! [VarCurr: state_type] :
      ( v70423(VarCurr,0)
    <=> v67401(VarCurr,116) ) ).

tff(addAssignment_45546,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,116)
    <=> v68294(VarCurr,52) ) ).

tff(addAssignment_45545,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,52)
    <=> v68296(VarCurr,52) ) ).

tff(addAssignment_45544,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,52)
    <=> v68385(VarCurr,52) ) ).

tff(addAssignment_45543,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,52)
    <=> v68306(VarCurr,52) ) ).

tff(addAssignment_45542,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,52)
    <=> v67430(VarCurr,116) ) ).

tff(addAssignment_45541,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,116)
    <=> v67432(VarCurr,116) ) ).

tff(addAssignment_45540,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,116)
    <=> v67434(VarCurr,116) ) ).

tff(addAssignment_45539,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,116)
    <=> v68308(VarCurr,52) ) ).

tff(addAssignment_45538,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,52)
    <=> v68310(VarCurr,52) ) ).

tff(addAssignment_45537,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,52)
    <=> v68368(VarCurr,52) ) ).

tff(addAssignment_45536,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,52)
    <=> v68366(VarCurr,52) ) ).

tff(addAssignment_45535,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,52)
    <=> v68367(VarCurr,52) ) ).

tff(addAssignment_45534,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,52)
    <=> v68361(VarCurr,52) ) ).

tff(addAssignment_45533,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,52)
    <=> v68362(VarCurr,52) ) ).

tff(addAssignment_45532,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,52)
    <=> v68357(VarCurr,52) ) ).

tff(addAssignment_45531,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,52)
    <=> $false ) ).

tff(addAssignment_45530,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,52)
    <=> v68300(VarCurr,52) ) ).

tff(addAssignment_45529,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,52)
    <=> v68301(VarCurr,52) ) ).

tff(addAssignment_45528,axiom,
    ! [VarCurr: state_type] :
      ( v71431(VarCurr)
    <=> v71433(VarCurr) ) ).

tff(addAssignment_45527,axiom,
    ! [VarCurr: state_type] :
      ( v71433(VarCurr)
    <=> v67349(VarCurr,108) ) ).

tff(addAssignment_45526,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,108)
    <=> v68249(VarCurr,44) ) ).

tff(addAssignment_45525,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,44)
    <=> v68251(VarCurr,44) ) ).

tff(addAssignment_45524,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,44)
    <=> v68253(VarCurr,44) ) ).

tff(addAssignment_45523,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,44)
    <=> v68255(VarCurr,44) ) ).

tff(addAssignment_45522,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,44)
    <=> v67359(VarCurr,108) ) ).

tff(addAssignment_45521,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,108)
    <=> v67580(VarCurr,108) ) ).

tff(addAssignment_45520,axiom,
    ! [VarCurr: state_type] :
      ( v67585(VarCurr,0)
    <=> v68258(VarCurr,44) ) ).

tff(addAssignment_45519,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,44)
    <=> v68260(VarCurr,44) ) ).

tff(addAssignment_45518,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,44)
    <=> v71435(VarNext,44) ) ).

tff(addCaseBooleanConditionEqualRanges1_898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71436(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71435(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_898,axiom,
    ! [VarNext: state_type] :
      ( v71436(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71435(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71436(VarNext)
      <=> v71437(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71437(VarNext)
      <=> ( v71439(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71439(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45517,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,44)
    <=> v68284(VarCurr,44) ) ).

tff(addAssignment_45516,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,44)
    <=> v67391(VarCurr,108) ) ).

tff(addAssignment_45515,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,108)
    <=> v70377(VarCurr,0) ) ).

tff(addAssignment_45514,axiom,
    ! [VarCurr: state_type] :
      ( v70377(VarCurr,0)
    <=> v70379(VarCurr,0) ) ).

tff(addAssignment_45513,axiom,
    ! [VarCurr: state_type] :
      ( v70379(VarCurr,0)
    <=> v70396(VarCurr,0) ) ).

tff(addAssignment_45512,axiom,
    ! [VarCurr: state_type] :
      ( v70389(VarCurr,0)
    <=> v70391(VarCurr,0) ) ).

tff(addAssignment_45511,axiom,
    ! [VarCurr: state_type] :
      ( v70391(VarCurr,0)
    <=> v67401(VarCurr,108) ) ).

tff(addAssignment_45510,axiom,
    ! [VarCurr: state_type] :
      ( v70381(VarCurr,0)
    <=> v70383(VarCurr,0) ) ).

tff(addAssignment_45509,axiom,
    ! [VarCurr: state_type] :
      ( v70383(VarCurr,0)
    <=> v67401(VarCurr,112) ) ).

tff(addAssignment_45508,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,112)
    <=> v68294(VarCurr,48) ) ).

tff(addAssignment_45507,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,48)
    <=> v68296(VarCurr,48) ) ).

tff(addAssignment_45506,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,48)
    <=> v68385(VarCurr,48) ) ).

tff(addAssignment_45505,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,48)
    <=> v68306(VarCurr,48) ) ).

tff(addAssignment_45504,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,48)
    <=> v67430(VarCurr,112) ) ).

tff(addAssignment_45503,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,112)
    <=> v67432(VarCurr,112) ) ).

tff(addAssignment_45502,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,112)
    <=> v67434(VarCurr,112) ) ).

tff(addAssignment_45501,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,112)
    <=> v68308(VarCurr,48) ) ).

tff(addAssignment_45500,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,48)
    <=> v68310(VarCurr,48) ) ).

tff(addAssignment_45499,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,48)
    <=> v68368(VarCurr,48) ) ).

tff(addAssignment_45498,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,48)
    <=> v68366(VarCurr,48) ) ).

tff(addAssignment_45497,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,48)
    <=> v68367(VarCurr,48) ) ).

tff(addAssignment_45496,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,48)
    <=> v68361(VarCurr,48) ) ).

tff(addAssignment_45495,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,48)
    <=> v68362(VarCurr,48) ) ).

tff(addAssignment_45494,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,48)
    <=> v68357(VarCurr,48) ) ).

tff(addAssignment_45493,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,48)
    <=> $false ) ).

tff(addAssignment_45492,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,48)
    <=> v68300(VarCurr,48) ) ).

tff(addAssignment_45491,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,48)
    <=> v68301(VarCurr,48) ) ).

tff(addAssignment_45490,axiom,
    ! [VarCurr: state_type] :
      ( v71373(VarCurr)
    <=> v71375(VarCurr) ) ).

tff(addAssignment_45489,axiom,
    ! [VarCurr: state_type] :
      ( v71375(VarCurr)
    <=> v71377(VarCurr) ) ).

tff(addAssignment_45488,axiom,
    ! [VarCurr: state_type] :
      ( v71377(VarCurr)
    <=> v71379(VarCurr) ) ).

tff(addAssignment_45487,axiom,
    ! [VarCurr: state_type] :
      ( v71379(VarCurr)
    <=> v71381(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6647,axiom,
    ! [VarCurr: state_type] :
      ( v71381(VarCurr)
    <=> ( v71419(VarCurr)
      <~> v71407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6646,axiom,
    ! [VarCurr: state_type] :
      ( v71419(VarCurr)
    <=> ( v71383(VarCurr)
      <~> v71395(VarCurr) ) ) ).

tff(addAssignment_45486,axiom,
    ! [VarCurr: state_type] :
      ( v71407(VarCurr)
    <=> v71409(VarCurr) ) ).

tff(addAssignment_45485,axiom,
    ! [VarCurr: state_type] :
      ( v71409(VarCurr)
    <=> v67349(VarCurr,104) ) ).

tff(addAssignment_45484,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,104)
    <=> v68249(VarCurr,40) ) ).

tff(addAssignment_45483,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,40)
    <=> v68251(VarCurr,40) ) ).

tff(addAssignment_45482,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,40)
    <=> v68253(VarCurr,40) ) ).

tff(addAssignment_45481,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,40)
    <=> v68255(VarCurr,40) ) ).

tff(addAssignment_45480,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,40)
    <=> v67359(VarCurr,104) ) ).

tff(addAssignment_45479,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,104)
    <=> v67580(VarCurr,104) ) ).

tff(addAssignment_45478,axiom,
    ! [VarCurr: state_type] :
      ( v67586(VarCurr,0)
    <=> v68258(VarCurr,40) ) ).

tff(addAssignment_45477,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,40)
    <=> v68260(VarCurr,40) ) ).

tff(addAssignment_45476,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,40)
    <=> v71411(VarNext,40) ) ).

tff(addCaseBooleanConditionEqualRanges1_897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71412(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71411(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_897,axiom,
    ! [VarNext: state_type] :
      ( v71412(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71411(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71412(VarNext)
      <=> v71413(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71413(VarNext)
      <=> ( v71415(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71415(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45475,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,40)
    <=> v68284(VarCurr,40) ) ).

tff(addAssignment_45474,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,40)
    <=> v67391(VarCurr,104) ) ).

tff(addAssignment_45473,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,104)
    <=> v70325(VarCurr,0) ) ).

tff(addAssignment_45472,axiom,
    ! [VarCurr: state_type] :
      ( v70325(VarCurr,0)
    <=> v70327(VarCurr,0) ) ).

tff(addAssignment_45471,axiom,
    ! [VarCurr: state_type] :
      ( v70327(VarCurr,0)
    <=> v70344(VarCurr,0) ) ).

tff(addAssignment_45470,axiom,
    ! [VarCurr: state_type] :
      ( v70337(VarCurr,0)
    <=> v70339(VarCurr,0) ) ).

tff(addAssignment_45469,axiom,
    ! [VarCurr: state_type] :
      ( v70339(VarCurr,0)
    <=> v67401(VarCurr,104) ) ).

tff(addAssignment_45468,axiom,
    ! [VarCurr: state_type] :
      ( v70329(VarCurr,0)
    <=> v70331(VarCurr,0) ) ).

tff(addAssignment_45467,axiom,
    ! [VarCurr: state_type] :
      ( v70331(VarCurr,0)
    <=> v67401(VarCurr,108) ) ).

tff(addAssignment_45466,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,108)
    <=> v68294(VarCurr,44) ) ).

tff(addAssignment_45465,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,44)
    <=> v68296(VarCurr,44) ) ).

tff(addAssignment_45464,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,44)
    <=> v68385(VarCurr,44) ) ).

tff(addAssignment_45463,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,44)
    <=> v68306(VarCurr,44) ) ).

tff(addAssignment_45462,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,44)
    <=> v67430(VarCurr,108) ) ).

tff(addAssignment_45461,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,108)
    <=> v67432(VarCurr,108) ) ).

tff(addAssignment_45460,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,108)
    <=> v67434(VarCurr,108) ) ).

tff(addAssignment_45459,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,108)
    <=> v68308(VarCurr,44) ) ).

tff(addAssignment_45458,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,44)
    <=> v68310(VarCurr,44) ) ).

tff(addAssignment_45457,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,44)
    <=> v68368(VarCurr,44) ) ).

tff(addAssignment_45456,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,44)
    <=> v68366(VarCurr,44) ) ).

tff(addAssignment_45455,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,44)
    <=> v68367(VarCurr,44) ) ).

tff(addAssignment_45454,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,44)
    <=> v68361(VarCurr,44) ) ).

tff(addAssignment_45453,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,44)
    <=> v68362(VarCurr,44) ) ).

tff(addAssignment_45452,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,44)
    <=> v68357(VarCurr,44) ) ).

tff(addAssignment_45451,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,44)
    <=> $false ) ).

tff(addAssignment_45450,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,44)
    <=> v68300(VarCurr,44) ) ).

tff(addAssignment_45449,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,44)
    <=> v68301(VarCurr,44) ) ).

tff(addAssignment_45448,axiom,
    ! [VarCurr: state_type] :
      ( v71395(VarCurr)
    <=> v71397(VarCurr) ) ).

tff(addAssignment_45447,axiom,
    ! [VarCurr: state_type] :
      ( v71397(VarCurr)
    <=> v67349(VarCurr,100) ) ).

tff(addAssignment_45446,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,100)
    <=> v68249(VarCurr,36) ) ).

tff(addAssignment_45445,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,36)
    <=> v68251(VarCurr,36) ) ).

tff(addAssignment_45444,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,36)
    <=> v68253(VarCurr,36) ) ).

tff(addAssignment_45443,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,36)
    <=> v68255(VarCurr,36) ) ).

tff(addAssignment_45442,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,36)
    <=> v67359(VarCurr,100) ) ).

tff(addAssignment_45441,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,100)
    <=> v67580(VarCurr,100) ) ).

tff(addAssignment_45440,axiom,
    ! [VarCurr: state_type] :
      ( v67587(VarCurr,0)
    <=> v68258(VarCurr,36) ) ).

tff(addAssignment_45439,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,36)
    <=> v68260(VarCurr,36) ) ).

tff(addAssignment_45438,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,36)
    <=> v71399(VarNext,36) ) ).

tff(addCaseBooleanConditionEqualRanges1_896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71400(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71399(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_896,axiom,
    ! [VarNext: state_type] :
      ( v71400(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71399(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71400(VarNext)
      <=> v71401(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71401(VarNext)
      <=> ( v71403(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71403(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45437,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,36)
    <=> v68284(VarCurr,36) ) ).

tff(addAssignment_45436,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,36)
    <=> v67391(VarCurr,100) ) ).

tff(addAssignment_45435,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,100)
    <=> v70285(VarCurr,0) ) ).

tff(addAssignment_45434,axiom,
    ! [VarCurr: state_type] :
      ( v70285(VarCurr,0)
    <=> v70287(VarCurr,0) ) ).

tff(addAssignment_45433,axiom,
    ! [VarCurr: state_type] :
      ( v70287(VarCurr,0)
    <=> v70304(VarCurr,0) ) ).

tff(addAssignment_45432,axiom,
    ! [VarCurr: state_type] :
      ( v70297(VarCurr,0)
    <=> v70299(VarCurr,0) ) ).

tff(addAssignment_45431,axiom,
    ! [VarCurr: state_type] :
      ( v70299(VarCurr,0)
    <=> v67401(VarCurr,100) ) ).

tff(addAssignment_45430,axiom,
    ! [VarCurr: state_type] :
      ( v70289(VarCurr,0)
    <=> v70291(VarCurr,0) ) ).

tff(addAssignment_45429,axiom,
    ! [VarCurr: state_type] :
      ( v70291(VarCurr,0)
    <=> v67401(VarCurr,104) ) ).

tff(addAssignment_45428,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,104)
    <=> v68294(VarCurr,40) ) ).

tff(addAssignment_45427,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,40)
    <=> v68296(VarCurr,40) ) ).

tff(addAssignment_45426,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,40)
    <=> v68385(VarCurr,40) ) ).

tff(addAssignment_45425,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,40)
    <=> v68306(VarCurr,40) ) ).

tff(addAssignment_45424,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,40)
    <=> v67430(VarCurr,104) ) ).

tff(addAssignment_45423,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,104)
    <=> v67432(VarCurr,104) ) ).

tff(addAssignment_45422,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,104)
    <=> v67434(VarCurr,104) ) ).

tff(addAssignment_45421,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,104)
    <=> v68308(VarCurr,40) ) ).

tff(addAssignment_45420,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,40)
    <=> v68310(VarCurr,40) ) ).

tff(addAssignment_45419,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,40)
    <=> v68368(VarCurr,40) ) ).

tff(addAssignment_45418,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,40)
    <=> v68366(VarCurr,40) ) ).

tff(addAssignment_45417,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,40)
    <=> v68367(VarCurr,40) ) ).

tff(addAssignment_45416,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,40)
    <=> v68361(VarCurr,40) ) ).

tff(addAssignment_45415,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,40)
    <=> v68362(VarCurr,40) ) ).

tff(addAssignment_45414,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,40)
    <=> v68357(VarCurr,40) ) ).

tff(addAssignment_45413,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,40)
    <=> $false ) ).

tff(addAssignment_45412,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,40)
    <=> v68300(VarCurr,40) ) ).

tff(addAssignment_45411,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,40)
    <=> v68301(VarCurr,40) ) ).

tff(addAssignment_45410,axiom,
    ! [VarCurr: state_type] :
      ( v71383(VarCurr)
    <=> v71385(VarCurr) ) ).

tff(addAssignment_45409,axiom,
    ! [VarCurr: state_type] :
      ( v71385(VarCurr)
    <=> v67349(VarCurr,96) ) ).

tff(addAssignment_45408,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,96)
    <=> v68249(VarCurr,32) ) ).

tff(addAssignment_45407,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,32)
    <=> v68251(VarCurr,32) ) ).

tff(addAssignment_45406,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,32)
    <=> v68253(VarCurr,32) ) ).

tff(addAssignment_45405,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,32)
    <=> v68255(VarCurr,32) ) ).

tff(addAssignment_45404,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,32)
    <=> v67359(VarCurr,96) ) ).

tff(addAssignment_45403,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,96)
    <=> v67580(VarCurr,96) ) ).

tff(addAssignment_45402,axiom,
    ! [VarCurr: state_type] :
      ( v67588(VarCurr,0)
    <=> v68258(VarCurr,32) ) ).

tff(addAssignment_45401,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,32)
    <=> v68260(VarCurr,32) ) ).

tff(addAssignment_45400,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,32)
    <=> v71387(VarNext,32) ) ).

tff(addCaseBooleanConditionEqualRanges1_895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71388(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71387(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_895,axiom,
    ! [VarNext: state_type] :
      ( v71388(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71387(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71388(VarNext)
      <=> v71389(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71389(VarNext)
      <=> ( v71391(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71391(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45399,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,32)
    <=> v68284(VarCurr,32) ) ).

tff(addAssignment_45398,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,32)
    <=> v67391(VarCurr,96) ) ).

tff(addAssignment_45397,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,96)
    <=> v70245(VarCurr,0) ) ).

tff(addAssignment_45396,axiom,
    ! [VarCurr: state_type] :
      ( v70245(VarCurr,0)
    <=> v70247(VarCurr,0) ) ).

tff(addAssignment_45395,axiom,
    ! [VarCurr: state_type] :
      ( v70247(VarCurr,0)
    <=> v70264(VarCurr,0) ) ).

tff(addAssignment_45394,axiom,
    ! [VarCurr: state_type] :
      ( v70257(VarCurr,0)
    <=> v70259(VarCurr,0) ) ).

tff(addAssignment_45393,axiom,
    ! [VarCurr: state_type] :
      ( v70259(VarCurr,0)
    <=> v67401(VarCurr,96) ) ).

tff(addAssignment_45392,axiom,
    ! [VarCurr: state_type] :
      ( v70249(VarCurr,0)
    <=> v70251(VarCurr,0) ) ).

tff(addAssignment_45391,axiom,
    ! [VarCurr: state_type] :
      ( v70251(VarCurr,0)
    <=> v67401(VarCurr,100) ) ).

tff(addAssignment_45390,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,100)
    <=> v68294(VarCurr,36) ) ).

tff(addAssignment_45389,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,36)
    <=> v68296(VarCurr,36) ) ).

tff(addAssignment_45388,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,36)
    <=> v68385(VarCurr,36) ) ).

tff(addAssignment_45387,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,36)
    <=> v68306(VarCurr,36) ) ).

tff(addAssignment_45386,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,36)
    <=> v67430(VarCurr,100) ) ).

tff(addAssignment_45385,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,100)
    <=> v67432(VarCurr,100) ) ).

tff(addAssignment_45384,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,100)
    <=> v67434(VarCurr,100) ) ).

tff(addAssignment_45383,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,100)
    <=> v68308(VarCurr,36) ) ).

tff(addAssignment_45382,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,36)
    <=> v68310(VarCurr,36) ) ).

tff(addAssignment_45381,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,36)
    <=> v68368(VarCurr,36) ) ).

tff(addAssignment_45380,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,36)
    <=> v68366(VarCurr,36) ) ).

tff(addAssignment_45379,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,36)
    <=> v68367(VarCurr,36) ) ).

tff(addAssignment_45378,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,36)
    <=> v68361(VarCurr,36) ) ).

tff(addAssignment_45377,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,36)
    <=> v68362(VarCurr,36) ) ).

tff(addAssignment_45376,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,36)
    <=> v68357(VarCurr,36) ) ).

tff(addAssignment_45375,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,36)
    <=> $false ) ).

tff(addAssignment_45374,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,36)
    <=> v68300(VarCurr,36) ) ).

tff(addAssignment_45373,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,36)
    <=> v68301(VarCurr,36) ) ).

tff(addAssignment_45372,axiom,
    ! [VarCurr: state_type] :
      ( v71207(VarCurr)
    <=> v71209(VarCurr) ) ).

tff(addAssignment_45371,axiom,
    ! [VarCurr: state_type] :
      ( v71209(VarCurr)
    <=> v71211(VarCurr) ) ).

tff(addAssignment_45370,axiom,
    ! [VarCurr: state_type] :
      ( v71211(VarCurr)
    <=> v71213(VarCurr) ) ).

tff(addAssignment_45369,axiom,
    ! [VarCurr: state_type] :
      ( v71213(VarCurr)
    <=> v71215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6639,axiom,
    ! [VarCurr: state_type] :
      ( v71215(VarCurr)
    <=> ( v71361(VarCurr)
      <~> v71313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6638,axiom,
    ! [VarCurr: state_type] :
      ( v71361(VarCurr)
    <=> ( v71217(VarCurr)
      <~> v71265(VarCurr) ) ) ).

tff(addAssignment_45368,axiom,
    ! [VarCurr: state_type] :
      ( v71313(VarCurr)
    <=> v71315(VarCurr) ) ).

tff(addAssignment_45367,axiom,
    ! [VarCurr: state_type] :
      ( v71315(VarCurr)
    <=> v71317(VarCurr) ) ).

tff(addAssignment_45366,axiom,
    ! [VarCurr: state_type] :
      ( v71317(VarCurr)
    <=> v71319(VarCurr) ) ).

tff(addAssignment_45365,axiom,
    ! [VarCurr: state_type] :
      ( v71319(VarCurr)
    <=> v71321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6637,axiom,
    ! [VarCurr: state_type] :
      ( v71321(VarCurr)
    <=> ( v71359(VarCurr)
      <~> v71347(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6636,axiom,
    ! [VarCurr: state_type] :
      ( v71359(VarCurr)
    <=> ( v71323(VarCurr)
      <~> v71335(VarCurr) ) ) ).

tff(addAssignment_45364,axiom,
    ! [VarCurr: state_type] :
      ( v71347(VarCurr)
    <=> v71349(VarCurr) ) ).

tff(addAssignment_45363,axiom,
    ! [VarCurr: state_type] :
      ( v71349(VarCurr)
    <=> v67349(VarCurr,92) ) ).

tff(addAssignment_45362,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,92)
    <=> v68249(VarCurr,28) ) ).

tff(addAssignment_45361,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,28)
    <=> v68251(VarCurr,28) ) ).

tff(addAssignment_45360,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,28)
    <=> v68253(VarCurr,28) ) ).

tff(addAssignment_45359,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,28)
    <=> v68255(VarCurr,28) ) ).

tff(addAssignment_45358,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,28)
    <=> v67359(VarCurr,92) ) ).

tff(addAssignment_45357,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,92)
    <=> v67580(VarCurr,92) ) ).

tff(addAssignment_45356,axiom,
    ! [VarCurr: state_type] :
      ( v67589(VarCurr,0)
    <=> v68258(VarCurr,28) ) ).

tff(addAssignment_45355,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,28)
    <=> v68260(VarCurr,28) ) ).

tff(addAssignment_45354,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,28)
    <=> v71351(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71352(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71351(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_894,axiom,
    ! [VarNext: state_type] :
      ( v71352(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71351(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71352(VarNext)
      <=> v71353(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71353(VarNext)
      <=> ( v71355(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71355(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45353,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,28)
    <=> v68284(VarCurr,28) ) ).

tff(addAssignment_45352,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,28)
    <=> v67391(VarCurr,92) ) ).

tff(addAssignment_45351,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,92)
    <=> v70181(VarCurr,0) ) ).

tff(addAssignment_45350,axiom,
    ! [VarCurr: state_type] :
      ( v70181(VarCurr,0)
    <=> v70183(VarCurr,0) ) ).

tff(addAssignment_45349,axiom,
    ! [VarCurr: state_type] :
      ( v70183(VarCurr,0)
    <=> v70200(VarCurr,0) ) ).

tff(addAssignment_45348,axiom,
    ! [VarCurr: state_type] :
      ( v70193(VarCurr,0)
    <=> v70195(VarCurr,0) ) ).

tff(addAssignment_45347,axiom,
    ! [VarCurr: state_type] :
      ( v70195(VarCurr,0)
    <=> v67401(VarCurr,92) ) ).

tff(addAssignment_45346,axiom,
    ! [VarCurr: state_type] :
      ( v70185(VarCurr,0)
    <=> v70187(VarCurr,0) ) ).

tff(addAssignment_45345,axiom,
    ! [VarCurr: state_type] :
      ( v70187(VarCurr,0)
    <=> v67401(VarCurr,96) ) ).

tff(addAssignment_45344,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,96)
    <=> v68294(VarCurr,32) ) ).

tff(addAssignment_45343,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,32)
    <=> v68296(VarCurr,32) ) ).

tff(addAssignment_45342,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,32)
    <=> v68385(VarCurr,32) ) ).

tff(addAssignment_45341,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,32)
    <=> v68306(VarCurr,32) ) ).

tff(addAssignment_45340,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,32)
    <=> v67430(VarCurr,96) ) ).

tff(addAssignment_45339,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,96)
    <=> v67432(VarCurr,96) ) ).

tff(addAssignment_45338,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,96)
    <=> v67434(VarCurr,96) ) ).

tff(addAssignment_45337,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,96)
    <=> v68308(VarCurr,32) ) ).

tff(addAssignment_45336,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,32)
    <=> v68310(VarCurr,32) ) ).

tff(addAssignment_45335,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,32)
    <=> v68368(VarCurr,32) ) ).

tff(addAssignment_45334,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,32)
    <=> v68366(VarCurr,32) ) ).

tff(addAssignment_45333,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,32)
    <=> v68367(VarCurr,32) ) ).

tff(addAssignment_45332,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,32)
    <=> v68361(VarCurr,32) ) ).

tff(addAssignment_45331,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,32)
    <=> v68362(VarCurr,32) ) ).

tff(addAssignment_45330,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,32)
    <=> v68357(VarCurr,32) ) ).

tff(addAssignment_45329,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,32)
    <=> $false ) ).

tff(addAssignment_45328,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,32)
    <=> v68300(VarCurr,32) ) ).

tff(addAssignment_45327,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,32)
    <=> v68301(VarCurr,32) ) ).

tff(addAssignment_45326,axiom,
    ! [VarCurr: state_type] :
      ( v71335(VarCurr)
    <=> v71337(VarCurr) ) ).

tff(addAssignment_45325,axiom,
    ! [VarCurr: state_type] :
      ( v71337(VarCurr)
    <=> v67349(VarCurr,88) ) ).

tff(addAssignment_45324,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,88)
    <=> v68249(VarCurr,24) ) ).

tff(addAssignment_45323,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,24)
    <=> v68251(VarCurr,24) ) ).

tff(addAssignment_45322,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,24)
    <=> v68253(VarCurr,24) ) ).

tff(addAssignment_45321,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,24)
    <=> v68255(VarCurr,24) ) ).

tff(addAssignment_45320,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,24)
    <=> v67359(VarCurr,88) ) ).

tff(addAssignment_45319,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,88)
    <=> v67580(VarCurr,88) ) ).

tff(addAssignment_45318,axiom,
    ! [VarCurr: state_type] :
      ( v67590(VarCurr,0)
    <=> v68258(VarCurr,24) ) ).

tff(addAssignment_45317,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,24)
    <=> v68260(VarCurr,24) ) ).

tff(addAssignment_45316,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,24)
    <=> v71339(VarNext,24) ) ).

tff(addCaseBooleanConditionEqualRanges1_893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71340(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71339(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_893,axiom,
    ! [VarNext: state_type] :
      ( v71340(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71339(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71340(VarNext)
      <=> v71341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71341(VarNext)
      <=> ( v71343(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71343(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45315,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,24)
    <=> v68284(VarCurr,24) ) ).

tff(addAssignment_45314,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,24)
    <=> v67391(VarCurr,88) ) ).

tff(addAssignment_45313,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,88)
    <=> v70141(VarCurr,0) ) ).

tff(addAssignment_45312,axiom,
    ! [VarCurr: state_type] :
      ( v70141(VarCurr,0)
    <=> v70143(VarCurr,0) ) ).

tff(addAssignment_45311,axiom,
    ! [VarCurr: state_type] :
      ( v70143(VarCurr,0)
    <=> v70160(VarCurr,0) ) ).

tff(addAssignment_45310,axiom,
    ! [VarCurr: state_type] :
      ( v70153(VarCurr,0)
    <=> v70155(VarCurr,0) ) ).

tff(addAssignment_45309,axiom,
    ! [VarCurr: state_type] :
      ( v70155(VarCurr,0)
    <=> v67401(VarCurr,88) ) ).

tff(addAssignment_45308,axiom,
    ! [VarCurr: state_type] :
      ( v70145(VarCurr,0)
    <=> v70147(VarCurr,0) ) ).

tff(addAssignment_45307,axiom,
    ! [VarCurr: state_type] :
      ( v70147(VarCurr,0)
    <=> v67401(VarCurr,92) ) ).

tff(addAssignment_45306,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,92)
    <=> v68294(VarCurr,28) ) ).

tff(addAssignment_45305,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,28)
    <=> v68296(VarCurr,28) ) ).

tff(addAssignment_45304,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,28)
    <=> v68385(VarCurr,28) ) ).

tff(addAssignment_45303,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,28)
    <=> v68306(VarCurr,28) ) ).

tff(addAssignment_45302,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,28)
    <=> v67430(VarCurr,92) ) ).

tff(addAssignment_45301,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,92)
    <=> v67432(VarCurr,92) ) ).

tff(addAssignment_45300,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,92)
    <=> v67434(VarCurr,92) ) ).

tff(addAssignment_45299,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,92)
    <=> v68308(VarCurr,28) ) ).

tff(addAssignment_45298,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,28)
    <=> v68310(VarCurr,28) ) ).

tff(addAssignment_45297,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,28)
    <=> v68368(VarCurr,28) ) ).

tff(addAssignment_45296,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,28)
    <=> v68366(VarCurr,28) ) ).

tff(addAssignment_45295,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,28)
    <=> v68367(VarCurr,28) ) ).

tff(addAssignment_45294,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,28)
    <=> v68361(VarCurr,28) ) ).

tff(addAssignment_45293,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,28)
    <=> v68362(VarCurr,28) ) ).

tff(addAssignment_45292,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,28)
    <=> v68357(VarCurr,28) ) ).

tff(addAssignment_45291,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,28)
    <=> $false ) ).

tff(addAssignment_45290,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,28)
    <=> v68300(VarCurr,28) ) ).

tff(addAssignment_45289,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,28)
    <=> v68301(VarCurr,28) ) ).

tff(addAssignment_45288,axiom,
    ! [VarCurr: state_type] :
      ( v71323(VarCurr)
    <=> v71325(VarCurr) ) ).

tff(addAssignment_45287,axiom,
    ! [VarCurr: state_type] :
      ( v71325(VarCurr)
    <=> v67349(VarCurr,84) ) ).

tff(addAssignment_45286,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,84)
    <=> v68249(VarCurr,20) ) ).

tff(addAssignment_45285,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,20)
    <=> v68251(VarCurr,20) ) ).

tff(addAssignment_45284,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,20)
    <=> v68253(VarCurr,20) ) ).

tff(addAssignment_45283,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,20)
    <=> v68255(VarCurr,20) ) ).

tff(addAssignment_45282,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,20)
    <=> v67359(VarCurr,84) ) ).

tff(addAssignment_45281,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,84)
    <=> v67580(VarCurr,84) ) ).

tff(addAssignment_45280,axiom,
    ! [VarCurr: state_type] :
      ( v67591(VarCurr,0)
    <=> v68258(VarCurr,20) ) ).

tff(addAssignment_45279,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,20)
    <=> v68260(VarCurr,20) ) ).

tff(addAssignment_45278,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,20)
    <=> v71327(VarNext,20) ) ).

tff(addCaseBooleanConditionEqualRanges1_892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71328(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71327(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_892,axiom,
    ! [VarNext: state_type] :
      ( v71328(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71327(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71328(VarNext)
      <=> v71329(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71329(VarNext)
      <=> ( v71331(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71331(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45277,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,20)
    <=> v68284(VarCurr,20) ) ).

tff(addAssignment_45276,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,20)
    <=> v67391(VarCurr,84) ) ).

tff(addAssignment_45275,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,84)
    <=> v70101(VarCurr,0) ) ).

tff(addAssignment_45274,axiom,
    ! [VarCurr: state_type] :
      ( v70101(VarCurr,0)
    <=> v70103(VarCurr,0) ) ).

tff(addAssignment_45273,axiom,
    ! [VarCurr: state_type] :
      ( v70103(VarCurr,0)
    <=> v70120(VarCurr,0) ) ).

tff(addAssignment_45272,axiom,
    ! [VarCurr: state_type] :
      ( v70113(VarCurr,0)
    <=> v70115(VarCurr,0) ) ).

tff(addAssignment_45271,axiom,
    ! [VarCurr: state_type] :
      ( v70115(VarCurr,0)
    <=> v67401(VarCurr,84) ) ).

tff(addAssignment_45270,axiom,
    ! [VarCurr: state_type] :
      ( v70105(VarCurr,0)
    <=> v70107(VarCurr,0) ) ).

tff(addAssignment_45269,axiom,
    ! [VarCurr: state_type] :
      ( v70107(VarCurr,0)
    <=> v67401(VarCurr,88) ) ).

tff(addAssignment_45268,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,88)
    <=> v68294(VarCurr,24) ) ).

tff(addAssignment_45267,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,24)
    <=> v68296(VarCurr,24) ) ).

tff(addAssignment_45266,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,24)
    <=> v68385(VarCurr,24) ) ).

tff(addAssignment_45265,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,24)
    <=> v68306(VarCurr,24) ) ).

tff(addAssignment_45264,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,24)
    <=> v67430(VarCurr,88) ) ).

tff(addAssignment_45263,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,88)
    <=> v67432(VarCurr,88) ) ).

tff(addAssignment_45262,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,88)
    <=> v67434(VarCurr,88) ) ).

tff(addAssignment_45261,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,88)
    <=> v68308(VarCurr,24) ) ).

tff(addAssignment_45260,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,24)
    <=> v68310(VarCurr,24) ) ).

tff(addAssignment_45259,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,24)
    <=> v68368(VarCurr,24) ) ).

tff(addAssignment_45258,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,24)
    <=> v68366(VarCurr,24) ) ).

tff(addAssignment_45257,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,24)
    <=> v68367(VarCurr,24) ) ).

tff(addAssignment_45256,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,24)
    <=> v68361(VarCurr,24) ) ).

tff(addAssignment_45255,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,24)
    <=> v68362(VarCurr,24) ) ).

tff(addAssignment_45254,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,24)
    <=> v68357(VarCurr,24) ) ).

tff(addAssignment_45253,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,24)
    <=> $false ) ).

tff(addAssignment_45252,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,24)
    <=> v68300(VarCurr,24) ) ).

tff(addAssignment_45251,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,24)
    <=> v68301(VarCurr,24) ) ).

tff(addAssignment_45250,axiom,
    ! [VarCurr: state_type] :
      ( v71265(VarCurr)
    <=> v71267(VarCurr) ) ).

tff(addAssignment_45249,axiom,
    ! [VarCurr: state_type] :
      ( v71267(VarCurr)
    <=> v71269(VarCurr) ) ).

tff(addAssignment_45248,axiom,
    ! [VarCurr: state_type] :
      ( v71269(VarCurr)
    <=> v71271(VarCurr) ) ).

tff(addAssignment_45247,axiom,
    ! [VarCurr: state_type] :
      ( v71271(VarCurr)
    <=> v71273(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6629,axiom,
    ! [VarCurr: state_type] :
      ( v71273(VarCurr)
    <=> ( v71311(VarCurr)
      <~> v71299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6628,axiom,
    ! [VarCurr: state_type] :
      ( v71311(VarCurr)
    <=> ( v71275(VarCurr)
      <~> v71287(VarCurr) ) ) ).

tff(addAssignment_45246,axiom,
    ! [VarCurr: state_type] :
      ( v71299(VarCurr)
    <=> v71301(VarCurr) ) ).

tff(addAssignment_45245,axiom,
    ! [VarCurr: state_type] :
      ( v71301(VarCurr)
    <=> v67349(VarCurr,80) ) ).

tff(addAssignment_45244,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,80)
    <=> v68249(VarCurr,16) ) ).

tff(addAssignment_45243,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,16)
    <=> v68251(VarCurr,16) ) ).

tff(addAssignment_45242,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,16)
    <=> v68253(VarCurr,16) ) ).

tff(addAssignment_45241,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,16)
    <=> v68255(VarCurr,16) ) ).

tff(addAssignment_45240,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,16)
    <=> v67359(VarCurr,80) ) ).

tff(addAssignment_45239,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,80)
    <=> v67580(VarCurr,80) ) ).

tff(addAssignment_45238,axiom,
    ! [VarCurr: state_type] :
      ( v67592(VarCurr,0)
    <=> v68258(VarCurr,16) ) ).

tff(addAssignment_45237,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,16)
    <=> v68260(VarCurr,16) ) ).

tff(addAssignment_45236,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,16)
    <=> v71303(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71304(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71303(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_891,axiom,
    ! [VarNext: state_type] :
      ( v71304(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71303(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71304(VarNext)
      <=> v71305(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71305(VarNext)
      <=> ( v71307(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71307(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45235,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,16)
    <=> v68284(VarCurr,16) ) ).

tff(addAssignment_45234,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,16)
    <=> v67391(VarCurr,80) ) ).

tff(addAssignment_45233,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,80)
    <=> v70049(VarCurr,0) ) ).

tff(addAssignment_45232,axiom,
    ! [VarCurr: state_type] :
      ( v70049(VarCurr,0)
    <=> v70051(VarCurr,0) ) ).

tff(addAssignment_45231,axiom,
    ! [VarCurr: state_type] :
      ( v70051(VarCurr,0)
    <=> v70068(VarCurr,0) ) ).

tff(addAssignment_45230,axiom,
    ! [VarCurr: state_type] :
      ( v70061(VarCurr,0)
    <=> v70063(VarCurr,0) ) ).

tff(addAssignment_45229,axiom,
    ! [VarCurr: state_type] :
      ( v70063(VarCurr,0)
    <=> v67401(VarCurr,80) ) ).

tff(addAssignment_45228,axiom,
    ! [VarCurr: state_type] :
      ( v70053(VarCurr,0)
    <=> v70055(VarCurr,0) ) ).

tff(addAssignment_45227,axiom,
    ! [VarCurr: state_type] :
      ( v70055(VarCurr,0)
    <=> v67401(VarCurr,84) ) ).

tff(addAssignment_45226,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,84)
    <=> v68294(VarCurr,20) ) ).

tff(addAssignment_45225,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,20)
    <=> v68296(VarCurr,20) ) ).

tff(addAssignment_45224,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,20)
    <=> v68385(VarCurr,20) ) ).

tff(addAssignment_45223,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,20)
    <=> v68306(VarCurr,20) ) ).

tff(addAssignment_45222,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,20)
    <=> v67430(VarCurr,84) ) ).

tff(addAssignment_45221,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,84)
    <=> v67432(VarCurr,84) ) ).

tff(addAssignment_45220,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,84)
    <=> v67434(VarCurr,84) ) ).

tff(addAssignment_45219,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,84)
    <=> v68308(VarCurr,20) ) ).

tff(addAssignment_45218,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,20)
    <=> v68310(VarCurr,20) ) ).

tff(addAssignment_45217,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,20)
    <=> v68368(VarCurr,20) ) ).

tff(addAssignment_45216,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,20)
    <=> v68366(VarCurr,20) ) ).

tff(addAssignment_45215,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,20)
    <=> v68367(VarCurr,20) ) ).

tff(addAssignment_45214,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,20)
    <=> v68361(VarCurr,20) ) ).

tff(addAssignment_45213,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,20)
    <=> v68362(VarCurr,20) ) ).

tff(addAssignment_45212,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,20)
    <=> v68357(VarCurr,20) ) ).

tff(addAssignment_45211,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,20)
    <=> $false ) ).

tff(addAssignment_45210,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,20)
    <=> v68300(VarCurr,20) ) ).

tff(addAssignment_45209,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,20)
    <=> v68301(VarCurr,20) ) ).

tff(addAssignment_45208,axiom,
    ! [VarCurr: state_type] :
      ( v71287(VarCurr)
    <=> v71289(VarCurr) ) ).

tff(addAssignment_45207,axiom,
    ! [VarCurr: state_type] :
      ( v71289(VarCurr)
    <=> v67349(VarCurr,76) ) ).

tff(addAssignment_45206,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,76)
    <=> v68249(VarCurr,12) ) ).

tff(addAssignment_45205,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,12)
    <=> v68251(VarCurr,12) ) ).

tff(addAssignment_45204,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,12)
    <=> v68253(VarCurr,12) ) ).

tff(addAssignment_45203,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,12)
    <=> v68255(VarCurr,12) ) ).

tff(addAssignment_45202,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,12)
    <=> v67359(VarCurr,76) ) ).

tff(addAssignment_45201,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,76)
    <=> v67580(VarCurr,76) ) ).

tff(addAssignment_45200,axiom,
    ! [VarCurr: state_type] :
      ( v67593(VarCurr,0)
    <=> v68258(VarCurr,12) ) ).

tff(addAssignment_45199,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,12)
    <=> v68260(VarCurr,12) ) ).

tff(addAssignment_45198,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,12)
    <=> v71291(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71292(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71291(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_890,axiom,
    ! [VarNext: state_type] :
      ( v71292(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71291(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71292(VarNext)
      <=> v71293(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71293(VarNext)
      <=> ( v71295(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71295(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45197,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,12)
    <=> v68284(VarCurr,12) ) ).

tff(addAssignment_45196,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,12)
    <=> v67391(VarCurr,76) ) ).

tff(addAssignment_45195,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,76)
    <=> v70009(VarCurr,0) ) ).

tff(addAssignment_45194,axiom,
    ! [VarCurr: state_type] :
      ( v70009(VarCurr,0)
    <=> v70011(VarCurr,0) ) ).

tff(addAssignment_45193,axiom,
    ! [VarCurr: state_type] :
      ( v70011(VarCurr,0)
    <=> v70028(VarCurr,0) ) ).

tff(addAssignment_45192,axiom,
    ! [VarCurr: state_type] :
      ( v70021(VarCurr,0)
    <=> v70023(VarCurr,0) ) ).

tff(addAssignment_45191,axiom,
    ! [VarCurr: state_type] :
      ( v70023(VarCurr,0)
    <=> v67401(VarCurr,76) ) ).

tff(addAssignment_45190,axiom,
    ! [VarCurr: state_type] :
      ( v70013(VarCurr,0)
    <=> v70015(VarCurr,0) ) ).

tff(addAssignment_45189,axiom,
    ! [VarCurr: state_type] :
      ( v70015(VarCurr,0)
    <=> v67401(VarCurr,80) ) ).

tff(addAssignment_45188,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,80)
    <=> v68294(VarCurr,16) ) ).

tff(addAssignment_45187,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,16)
    <=> v68296(VarCurr,16) ) ).

tff(addAssignment_45186,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,16)
    <=> v68385(VarCurr,16) ) ).

tff(addAssignment_45185,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,16)
    <=> v68306(VarCurr,16) ) ).

tff(addAssignment_45184,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,16)
    <=> v67430(VarCurr,80) ) ).

tff(addAssignment_45183,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,80)
    <=> v67432(VarCurr,80) ) ).

tff(addAssignment_45182,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,80)
    <=> v67434(VarCurr,80) ) ).

tff(addAssignment_45181,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,80)
    <=> v68308(VarCurr,16) ) ).

tff(addAssignment_45180,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,16)
    <=> v68310(VarCurr,16) ) ).

tff(addAssignment_45179,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,16)
    <=> v68368(VarCurr,16) ) ).

tff(addAssignment_45178,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,16)
    <=> v68366(VarCurr,16) ) ).

tff(addAssignment_45177,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,16)
    <=> v68367(VarCurr,16) ) ).

tff(addAssignment_45176,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,16)
    <=> v68361(VarCurr,16) ) ).

tff(addAssignment_45175,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,16)
    <=> v68362(VarCurr,16) ) ).

tff(addAssignment_45174,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,16)
    <=> v68357(VarCurr,16) ) ).

tff(addAssignment_45173,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,16)
    <=> $false ) ).

tff(addAssignment_45172,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,16)
    <=> v68300(VarCurr,16) ) ).

tff(addAssignment_45171,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,16)
    <=> v68301(VarCurr,16) ) ).

tff(addAssignment_45170,axiom,
    ! [VarCurr: state_type] :
      ( v71275(VarCurr)
    <=> v71277(VarCurr) ) ).

tff(addAssignment_45169,axiom,
    ! [VarCurr: state_type] :
      ( v71277(VarCurr)
    <=> v67349(VarCurr,72) ) ).

tff(addAssignment_45168,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,72)
    <=> v68249(VarCurr,8) ) ).

tff(addAssignment_45167,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,8)
    <=> v68251(VarCurr,8) ) ).

tff(addAssignment_45166,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,8)
    <=> v68253(VarCurr,8) ) ).

tff(addAssignment_45165,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,8)
    <=> v68255(VarCurr,8) ) ).

tff(addAssignment_45164,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,8)
    <=> v67359(VarCurr,72) ) ).

tff(addAssignment_45163,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,72)
    <=> v67580(VarCurr,72) ) ).

tff(addAssignment_45162,axiom,
    ! [VarCurr: state_type] :
      ( v67594(VarCurr,0)
    <=> v68258(VarCurr,8) ) ).

tff(addAssignment_45161,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,8)
    <=> v68260(VarCurr,8) ) ).

tff(addAssignment_45160,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,8)
    <=> v71279(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71280(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71279(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_889,axiom,
    ! [VarNext: state_type] :
      ( v71280(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71279(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71280(VarNext)
      <=> v71281(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71281(VarNext)
      <=> ( v71283(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71283(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45159,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,8)
    <=> v68284(VarCurr,8) ) ).

tff(addAssignment_45158,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,8)
    <=> v67391(VarCurr,72) ) ).

tff(addAssignment_45157,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,72)
    <=> v69969(VarCurr,0) ) ).

tff(addAssignment_45156,axiom,
    ! [VarCurr: state_type] :
      ( v69969(VarCurr,0)
    <=> v69971(VarCurr,0) ) ).

tff(addAssignment_45155,axiom,
    ! [VarCurr: state_type] :
      ( v69971(VarCurr,0)
    <=> v69988(VarCurr,0) ) ).

tff(addAssignment_45154,axiom,
    ! [VarCurr: state_type] :
      ( v69981(VarCurr,0)
    <=> v69983(VarCurr,0) ) ).

tff(addAssignment_45153,axiom,
    ! [VarCurr: state_type] :
      ( v69983(VarCurr,0)
    <=> v67401(VarCurr,72) ) ).

tff(addAssignment_45152,axiom,
    ! [VarCurr: state_type] :
      ( v69973(VarCurr,0)
    <=> v69975(VarCurr,0) ) ).

tff(addAssignment_45151,axiom,
    ! [VarCurr: state_type] :
      ( v69975(VarCurr,0)
    <=> v67401(VarCurr,76) ) ).

tff(addAssignment_45150,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,76)
    <=> v68294(VarCurr,12) ) ).

tff(addAssignment_45149,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,12)
    <=> v68296(VarCurr,12) ) ).

tff(addAssignment_45148,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,12)
    <=> v68385(VarCurr,12) ) ).

tff(addAssignment_45147,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,12)
    <=> v68306(VarCurr,12) ) ).

tff(addAssignment_45146,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,12)
    <=> v67430(VarCurr,76) ) ).

tff(addAssignment_45145,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,76)
    <=> v67432(VarCurr,76) ) ).

tff(addAssignment_45144,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,76)
    <=> v67434(VarCurr,76) ) ).

tff(addAssignment_45143,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,76)
    <=> v68308(VarCurr,12) ) ).

tff(addAssignment_45142,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,12)
    <=> v68310(VarCurr,12) ) ).

tff(addAssignment_45141,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,12)
    <=> v68368(VarCurr,12) ) ).

tff(addAssignment_45140,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,12)
    <=> v68366(VarCurr,12) ) ).

tff(addAssignment_45139,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,12)
    <=> v68367(VarCurr,12) ) ).

tff(addAssignment_45138,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,12)
    <=> v68361(VarCurr,12) ) ).

tff(addAssignment_45137,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,12)
    <=> v68362(VarCurr,12) ) ).

tff(addAssignment_45136,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,12)
    <=> v68357(VarCurr,12) ) ).

tff(addAssignment_45135,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_45134,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,12)
    <=> v68300(VarCurr,12) ) ).

tff(addAssignment_45133,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,12)
    <=> v68301(VarCurr,12) ) ).

tff(addAssignment_45132,axiom,
    ! [VarCurr: state_type] :
      ( v71217(VarCurr)
    <=> v71219(VarCurr) ) ).

tff(addAssignment_45131,axiom,
    ! [VarCurr: state_type] :
      ( v71219(VarCurr)
    <=> v71221(VarCurr) ) ).

tff(addAssignment_45130,axiom,
    ! [VarCurr: state_type] :
      ( v71221(VarCurr)
    <=> v71223(VarCurr) ) ).

tff(addAssignment_45129,axiom,
    ! [VarCurr: state_type] :
      ( v71223(VarCurr)
    <=> v71225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6621,axiom,
    ! [VarCurr: state_type] :
      ( v71225(VarCurr)
    <=> ( v71263(VarCurr)
      <~> v71251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6620,axiom,
    ! [VarCurr: state_type] :
      ( v71263(VarCurr)
    <=> ( v71227(VarCurr)
      <~> v71239(VarCurr) ) ) ).

tff(addAssignment_45128,axiom,
    ! [VarCurr: state_type] :
      ( v71251(VarCurr)
    <=> v71253(VarCurr) ) ).

tff(addAssignment_45127,axiom,
    ! [VarCurr: state_type] :
      ( v71253(VarCurr)
    <=> v67349(VarCurr,68) ) ).

tff(addAssignment_45126,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,68)
    <=> v68249(VarCurr,4) ) ).

tff(addAssignment_45125,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,4)
    <=> v68251(VarCurr,4) ) ).

tff(addAssignment_45124,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,4)
    <=> v68253(VarCurr,4) ) ).

tff(addAssignment_45123,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,4)
    <=> v68255(VarCurr,4) ) ).

tff(addAssignment_45122,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,4)
    <=> v67359(VarCurr,68) ) ).

tff(addAssignment_45121,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,68)
    <=> v67580(VarCurr,68) ) ).

tff(addAssignment_45120,axiom,
    ! [VarCurr: state_type] :
      ( v67595(VarCurr,0)
    <=> v68258(VarCurr,4) ) ).

tff(addAssignment_45119,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,4)
    <=> v68260(VarCurr,4) ) ).

tff(addAssignment_45118,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,4)
    <=> v71255(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71256(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71255(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_888,axiom,
    ! [VarNext: state_type] :
      ( v71256(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71255(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71256(VarNext)
      <=> v71257(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71257(VarNext)
      <=> ( v71259(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71259(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45117,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,4)
    <=> v68284(VarCurr,4) ) ).

tff(addAssignment_45116,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,4)
    <=> v67391(VarCurr,68) ) ).

tff(addAssignment_45115,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,68)
    <=> v69917(VarCurr,0) ) ).

tff(addAssignment_45114,axiom,
    ! [VarCurr: state_type] :
      ( v69917(VarCurr,0)
    <=> v69919(VarCurr,0) ) ).

tff(addAssignment_45113,axiom,
    ! [VarCurr: state_type] :
      ( v69919(VarCurr,0)
    <=> v69936(VarCurr,0) ) ).

tff(addAssignment_45112,axiom,
    ! [VarCurr: state_type] :
      ( v69929(VarCurr,0)
    <=> v69931(VarCurr,0) ) ).

tff(addAssignment_45111,axiom,
    ! [VarCurr: state_type] :
      ( v69931(VarCurr,0)
    <=> v67401(VarCurr,68) ) ).

tff(addAssignment_45110,axiom,
    ! [VarCurr: state_type] :
      ( v69921(VarCurr,0)
    <=> v69923(VarCurr,0) ) ).

tff(addAssignment_45109,axiom,
    ! [VarCurr: state_type] :
      ( v69923(VarCurr,0)
    <=> v67401(VarCurr,72) ) ).

tff(addAssignment_45108,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,72)
    <=> v68294(VarCurr,8) ) ).

tff(addAssignment_45107,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,8)
    <=> v68296(VarCurr,8) ) ).

tff(addAssignment_45106,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,8)
    <=> v68385(VarCurr,8) ) ).

tff(addAssignment_45105,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,8)
    <=> v68306(VarCurr,8) ) ).

tff(addAssignment_45104,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,8)
    <=> v67430(VarCurr,72) ) ).

tff(addAssignment_45103,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,72)
    <=> v67432(VarCurr,72) ) ).

tff(addAssignment_45102,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,72)
    <=> v67434(VarCurr,72) ) ).

tff(addAssignment_45101,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,72)
    <=> v68308(VarCurr,8) ) ).

tff(addAssignment_45100,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,8)
    <=> v68310(VarCurr,8) ) ).

tff(addAssignment_45099,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,8)
    <=> v68368(VarCurr,8) ) ).

tff(addAssignment_45098,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,8)
    <=> v68366(VarCurr,8) ) ).

tff(addAssignment_45097,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,8)
    <=> v68367(VarCurr,8) ) ).

tff(addAssignment_45096,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,8)
    <=> v68361(VarCurr,8) ) ).

tff(addAssignment_45095,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,8)
    <=> v68362(VarCurr,8) ) ).

tff(addAssignment_45094,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,8)
    <=> v68357(VarCurr,8) ) ).

tff(addAssignment_45093,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_45092,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,8)
    <=> v68300(VarCurr,8) ) ).

tff(addAssignment_45091,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,8)
    <=> v68301(VarCurr,8) ) ).

tff(addAssignment_45090,axiom,
    ! [VarCurr: state_type] :
      ( v71239(VarCurr)
    <=> v71241(VarCurr) ) ).

tff(addAssignment_45089,axiom,
    ! [VarCurr: state_type] :
      ( v71241(VarCurr)
    <=> v67349(VarCurr,64) ) ).

tff(addAssignment_45088,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,64)
    <=> v68249(VarCurr,0) ) ).

tff(addAssignment_45087,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,0)
    <=> v68251(VarCurr,0) ) ).

tff(addAssignment_45086,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,0)
    <=> v68253(VarCurr,0) ) ).

tff(addAssignment_45085,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,0)
    <=> v68255(VarCurr,0) ) ).

tff(addAssignment_45084,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,0)
    <=> v67359(VarCurr,64) ) ).

tff(addAssignment_45083,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,64)
    <=> v67580(VarCurr,64) ) ).

tff(addAssignment_45082,axiom,
    ! [VarCurr: state_type] :
      ( v67596(VarCurr,0)
    <=> v68258(VarCurr,0) ) ).

tff(addAssignment_45081,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,0)
    <=> v68260(VarCurr,0) ) ).

tff(addAssignment_45080,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,0)
    <=> v71243(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71244(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71243(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_887,axiom,
    ! [VarNext: state_type] :
      ( v71244(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71243(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71244(VarNext)
      <=> v71245(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71245(VarNext)
      <=> ( v71247(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71247(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_45079,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,0)
    <=> v68284(VarCurr,0) ) ).

tff(addAssignment_45078,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,0)
    <=> v67391(VarCurr,64) ) ).

tff(addAssignment_45077,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,64)
    <=> v69877(VarCurr,0) ) ).

tff(addAssignment_45076,axiom,
    ! [VarCurr: state_type] :
      ( v69877(VarCurr,0)
    <=> v69879(VarCurr,0) ) ).

tff(addAssignment_45075,axiom,
    ! [VarCurr: state_type] :
      ( v69879(VarCurr,0)
    <=> v69896(VarCurr,0) ) ).

tff(addAssignment_45074,axiom,
    ! [VarCurr: state_type] :
      ( v69889(VarCurr,0)
    <=> v69891(VarCurr,0) ) ).

tff(addAssignment_45073,axiom,
    ! [VarCurr: state_type] :
      ( v69891(VarCurr,0)
    <=> v67401(VarCurr,64) ) ).

tff(addAssignment_45072,axiom,
    ! [VarCurr: state_type] :
      ( v69881(VarCurr,0)
    <=> v69883(VarCurr,0) ) ).

tff(addAssignment_45071,axiom,
    ! [VarCurr: state_type] :
      ( v69883(VarCurr,0)
    <=> v67401(VarCurr,68) ) ).

tff(addAssignment_45070,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,68)
    <=> v68294(VarCurr,4) ) ).

tff(addAssignment_45069,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,4)
    <=> v68296(VarCurr,4) ) ).

tff(addAssignment_45068,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,4)
    <=> v68385(VarCurr,4) ) ).

tff(addAssignment_45067,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,4)
    <=> v68306(VarCurr,4) ) ).

tff(addAssignment_45066,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,4)
    <=> v67430(VarCurr,68) ) ).

tff(addAssignment_45065,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,68)
    <=> v67432(VarCurr,68) ) ).

tff(addAssignment_45064,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,68)
    <=> v67434(VarCurr,68) ) ).

tff(addAssignment_45063,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,68)
    <=> v68308(VarCurr,4) ) ).

tff(addAssignment_45062,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,4)
    <=> v68310(VarCurr,4) ) ).

tff(addAssignment_45061,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,4)
    <=> v68368(VarCurr,4) ) ).

tff(addAssignment_45060,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,4)
    <=> v68366(VarCurr,4) ) ).

tff(addAssignment_45059,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,4)
    <=> v68367(VarCurr,4) ) ).

tff(addAssignment_45058,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,68)
    <=> v67496(VarCurr,68) ) ).

tff(addAssignment_45057,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,140)
    <=> v33839(VarCurr,140) ) ).

tff(addAssignment_45056,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,140)
    <=> v33841(VarCurr,140) ) ).

tff(addAssignment_45055,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,140)
    <=> v26555(VarCurr,8) ) ).

tff(addAssignment_45054,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,4)
    <=> v68361(VarCurr,4) ) ).

tff(addAssignment_45053,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,4)
    <=> v68362(VarCurr,4) ) ).

tff(addAssignment_45052,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,4)
    <=> v68357(VarCurr,4) ) ).

tff(addAssignment_45051,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_45050,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,4)
    <=> v68300(VarCurr,4) ) ).

tff(addAssignment_45049,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,4)
    <=> v68301(VarCurr,4) ) ).

tff(addAssignment_45048,axiom,
    ! [VarCurr: state_type] :
      ( v71227(VarCurr)
    <=> v71229(VarCurr) ) ).

tff(addAssignment_45047,axiom,
    ! [VarCurr: state_type] :
      ( v71229(VarCurr)
    <=> v67349(VarCurr,60) ) ).

tff(addAssignment_45046,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,60)
    <=> v67351(VarCurr,60) ) ).

tff(addAssignment_45045,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,60)
    <=> v67353(VarCurr,60) ) ).

tff(addAssignment_45044,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,60)
    <=> v67355(VarCurr,60) ) ).

tff(addAssignment_45043,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,60)
    <=> v67357(VarCurr,60) ) ).

tff(addAssignment_45042,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,60)
    <=> v67359(VarCurr,60) ) ).

tff(addAssignment_45041,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,60)
    <=> v67580(VarCurr,60) ) ).

tff(addAssignment_45040,axiom,
    ! [VarCurr: state_type] :
      ( v67597(VarCurr,0)
    <=> v67363(VarCurr,60) ) ).

tff(addAssignment_45039,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,60)
    <=> v67365(VarCurr,60) ) ).

tff(addAssignment_45038,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,60)
    <=> v71231(VarNext,60) ) ).

tff(addCaseBooleanConditionEqualRanges1_886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71232(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71231(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_886,axiom,
    ! [VarNext: state_type] :
      ( v71232(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71231(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71232(VarNext)
      <=> v71233(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71233(VarNext)
      <=> ( v71235(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71235(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_45037,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,60)
    <=> v67389(VarCurr,60) ) ).

tff(addAssignment_45036,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,60)
    <=> v67391(VarCurr,60) ) ).

tff(addAssignment_45035,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,60)
    <=> v69837(VarCurr,0) ) ).

tff(addAssignment_45034,axiom,
    ! [VarCurr: state_type] :
      ( v69837(VarCurr,0)
    <=> v69839(VarCurr,0) ) ).

tff(addAssignment_45033,axiom,
    ! [VarCurr: state_type] :
      ( v69839(VarCurr,0)
    <=> v69856(VarCurr,0) ) ).

tff(addAssignment_45032,axiom,
    ! [VarCurr: state_type] :
      ( v69849(VarCurr,0)
    <=> v69851(VarCurr,0) ) ).

tff(addAssignment_45031,axiom,
    ! [VarCurr: state_type] :
      ( v69851(VarCurr,0)
    <=> v67401(VarCurr,60) ) ).

tff(addAssignment_45030,axiom,
    ! [VarCurr: state_type] :
      ( v69841(VarCurr,0)
    <=> v69843(VarCurr,0) ) ).

tff(addAssignment_45029,axiom,
    ! [VarCurr: state_type] :
      ( v69843(VarCurr,0)
    <=> v67401(VarCurr,64) ) ).

tff(addAssignment_45028,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,64)
    <=> v68294(VarCurr,0) ) ).

tff(addAssignment_45027,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,0)
    <=> v68296(VarCurr,0) ) ).

tff(addAssignment_45026,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,0)
    <=> v68385(VarCurr,0) ) ).

tff(addAssignment_45025,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,0)
    <=> v68306(VarCurr,0) ) ).

tff(addAssignment_45024,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,0)
    <=> v67430(VarCurr,64) ) ).

tff(addAssignment_45023,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,64)
    <=> v67432(VarCurr,64) ) ).

tff(addAssignment_45022,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,64)
    <=> v67434(VarCurr,64) ) ).

tff(addAssignment_45021,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,64)
    <=> v68308(VarCurr,0) ) ).

tff(addAssignment_45020,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,0)
    <=> v68310(VarCurr,0) ) ).

tff(addAssignment_45019,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,0)
    <=> v68368(VarCurr,0) ) ).

tff(addAssignment_45018,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,0)
    <=> v68366(VarCurr,0) ) ).

tff(addAssignment_45017,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,0)
    <=> v68367(VarCurr,0) ) ).

tff(addAssignment_45016,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,64)
    <=> v67496(VarCurr,64) ) ).

tff(addAssignment_45015,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,130)
    <=> v33839(VarCurr,130) ) ).

tff(addAssignment_45014,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,130)
    <=> v33841(VarCurr,130) ) ).

tff(addAssignment_45013,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,130)
    <=> v25005(VarCurr,10) ) ).

tff(addAssignment_45012,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,0)
    <=> v68361(VarCurr,0) ) ).

tff(addAssignment_45011,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,0)
    <=> v68362(VarCurr,0) ) ).

tff(addAssignment_45010,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,0)
    <=> v68357(VarCurr,0) ) ).

tff(addAssignment_45009,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_45008,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,0)
    <=> v68300(VarCurr,0) ) ).

tff(addAssignment_45007,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,0)
    <=> v68301(VarCurr,0) ) ).

tff(addAssignment_45006,axiom,
    ! [VarCurr: state_type] :
      ( v70889(VarCurr)
    <=> v70891(VarCurr) ) ).

tff(addAssignment_45005,axiom,
    ! [VarCurr: state_type] :
      ( v70891(VarCurr)
    <=> v69805(VarCurr,1) ) ).

tff(addAssignment_45004,axiom,
    ! [VarCurr: state_type] :
      ( v69805(VarCurr,1)
    <=> v67309(VarCurr,5) ) ).

tff(addAssignment_45003,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,5)
    <=> v67311(VarCurr,5) ) ).

tff(addAssignment_45002,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,5)
    <=> v67313(VarCurr,5) ) ).

tff(addAssignment_45001,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,5)
    <=> v67315(VarCurr,5) ) ).

tff(addAssignment_45000,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,5)
    <=> v67317(VarCurr,5) ) ).

tff(addAssignment_44999,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,5)
    <=> v68771(VarCurr,5) ) ).

tff(addAssignment_44998,axiom,
    ! [VarCurr: state_type] :
      ( v68773(VarCurr,1)
    <=> v70893(VarCurr) ) ).

tff(addAssignment_44997,axiom,
    ! [VarCurr: state_type] :
      ( v70893(VarCurr)
    <=> v70895(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6613,axiom,
    ! [VarCurr: state_type] :
      ( v70895(VarCurr)
    <=> ( v71197(VarCurr)
      <~> v71185(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6612,axiom,
    ! [VarCurr: state_type] :
      ( v71197(VarCurr)
    <=> ( v70897(VarCurr)
      <~> v71053(VarCurr) ) ) ).

tff(addAssignment_44996,axiom,
    ! [VarCurr: state_type] :
      ( v71185(VarCurr)
    <=> v71187(VarCurr) ) ).

tff(addAssignment_44995,axiom,
    ! [VarCurr: state_type] :
      ( v71187(VarCurr)
    <=> v70526(VarCurr,1) ) ).

tff(addAssignment_44994,axiom,
    ! [VarCurr: state_type] :
      ( v70526(VarCurr,1)
    <=> v70528(VarCurr,1) ) ).

tff(addAssignment_44993,axiom,
    ! [VarCurr: state_type] :
      ( v70528(VarCurr,1)
    <=> v68595(VarCurr,6) ) ).

tff(addAssignment_44992,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,6)
    <=> v68597(VarCurr,6) ) ).

tff(addAssignment_44991,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,6)
    <=> v71189(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71190(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v71189(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_885,axiom,
    ! [VarNext: state_type] :
      ( v71190(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v71189(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71190(VarNext)
      <=> v71191(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71191(VarNext)
      <=> ( v71193(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71193(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_44990,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,6)
    <=> v68621(VarCurr,6) ) ).

tff(addAssignment_44989,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,6)
    <=> v68624(VarCurr,6) ) ).

tff(addAssignment_44988,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,5)
    <=> v70530(VarCurr,1) ) ).

tff(addAssignment_44987,axiom,
    ! [VarCurr: state_type] :
      ( v70530(VarCurr,1)
    <=> v70532(VarCurr,1) ) ).

tff(addAssignment_44986,axiom,
    ! [VarCurr: state_type] :
      ( v70532(VarCurr,1)
    <=> v70549(VarCurr,1) ) ).

tff(addAssignment_44985,axiom,
    ! [VarCurr: state_type] :
      ( v70542(VarCurr,1)
    <=> v70544(VarCurr,1) ) ).

tff(addAssignment_44984,axiom,
    ! [VarCurr: state_type] :
      ( v70544(VarCurr,1)
    <=> v68455(VarCurr,5) ) ).

tff(addAssignment_44983,axiom,
    ! [VarCurr: state_type] :
      ( v70534(VarCurr,1)
    <=> v70536(VarCurr,1) ) ).

tff(addAssignment_44982,axiom,
    ! [VarCurr: state_type] :
      ( v70536(VarCurr,1)
    <=> v68455(VarCurr,1) ) ).

tff(addAssignment_44981,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,1)
    <=> v68457(VarCurr,1) ) ).

tff(addAssignment_44980,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,1)
    <=> v68459(VarCurr,1) ) ).

tff(addAssignment_44979,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,1)
    <=> v68548(VarCurr,1) ) ).

tff(addAssignment_44978,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,1)
    <=> v68469(VarCurr,1) ) ).

tff(addAssignment_44977,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,1)
    <=> v68471(VarCurr,1) ) ).

tff(addAssignment_44976,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,1)
    <=> v67432(VarCurr,129) ) ).

tff(addAssignment_44975,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,129)
    <=> v67434(VarCurr,129) ) ).

tff(addAssignment_44974,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,129)
    <=> v68473(VarCurr,1) ) ).

tff(addAssignment_44973,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,1)
    <=> v68475(VarCurr,1) ) ).

tff(addAssignment_44972,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,1)
    <=> v68531(VarCurr,1) ) ).

tff(addAssignment_44971,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,1)
    <=> v68530(VarCurr,1) ) ).

tff(addAssignment_44970,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,1)
    <=> v6234(VarCurr,57) ) ).

tff(addAssignment_44969,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,1)
    <=> v68526(VarCurr,1) ) ).

tff(addAssignment_44968,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,1)
    <=> v53217(VarCurr,57) ) ).

tff(addAssignment_44967,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,1)
    <=> v68522(VarCurr,1) ) ).

tff(addAssignment_44966,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_44965,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,1)
    <=> v68463(VarCurr,1) ) ).

tff(addAssignment_44964,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,1)
    <=> v68464(VarCurr,1) ) ).

tff(addAssignment_44963,axiom,
    ! [VarCurr: state_type] :
      ( v71053(VarCurr)
    <=> v71055(VarCurr) ) ).

tff(addAssignment_44962,axiom,
    ! [VarCurr: state_type] :
      ( v71055(VarCurr)
    <=> v71057(VarCurr) ) ).

tff(addAssignment_44961,axiom,
    ! [VarCurr: state_type] :
      ( v71057(VarCurr)
    <=> v71059(VarCurr) ) ).

tff(addAssignment_44960,axiom,
    ! [VarCurr: state_type] :
      ( v71059(VarCurr)
    <=> v71061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6609,axiom,
    ! [VarCurr: state_type] :
      ( v71061(VarCurr)
    <=> ( v71183(VarCurr)
      <~> v71159(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6608,axiom,
    ! [VarCurr: state_type] :
      ( v71183(VarCurr)
    <=> ( v71063(VarCurr)
      <~> v71111(VarCurr) ) ) ).

tff(addAssignment_44959,axiom,
    ! [VarCurr: state_type] :
      ( v71159(VarCurr)
    <=> v71161(VarCurr) ) ).

tff(addAssignment_44958,axiom,
    ! [VarCurr: state_type] :
      ( v71161(VarCurr)
    <=> v71163(VarCurr) ) ).

tff(addAssignment_44957,axiom,
    ! [VarCurr: state_type] :
      ( v71163(VarCurr)
    <=> v71165(VarCurr) ) ).

tff(addAssignment_44956,axiom,
    ! [VarCurr: state_type] :
      ( v71165(VarCurr)
    <=> v71167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6607,axiom,
    ! [VarCurr: state_type] :
      ( v71167(VarCurr)
    <=> ( v71181(VarCurr)
      <~> v71177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6606,axiom,
    ! [VarCurr: state_type] :
      ( v71181(VarCurr)
    <=> ( v71169(VarCurr)
      <~> v71173(VarCurr) ) ) ).

tff(addAssignment_44955,axiom,
    ! [VarCurr: state_type] :
      ( v71177(VarCurr)
    <=> v71179(VarCurr) ) ).

tff(addAssignment_44954,axiom,
    ! [VarCurr: state_type] :
      ( v71179(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_44953,axiom,
    ! [VarCurr: state_type] :
      ( v71173(VarCurr)
    <=> v71175(VarCurr) ) ).

tff(addAssignment_44952,axiom,
    ! [VarCurr: state_type] :
      ( v71175(VarCurr)
    <=> v67349(VarCurr,125) ) ).

tff(addAssignment_44951,axiom,
    ! [VarCurr: state_type] :
      ( v71169(VarCurr)
    <=> v71171(VarCurr) ) ).

tff(addAssignment_44950,axiom,
    ! [VarCurr: state_type] :
      ( v71171(VarCurr)
    <=> v67349(VarCurr,121) ) ).

tff(addAssignment_44949,axiom,
    ! [VarCurr: state_type] :
      ( v71111(VarCurr)
    <=> v71113(VarCurr) ) ).

tff(addAssignment_44948,axiom,
    ! [VarCurr: state_type] :
      ( v71113(VarCurr)
    <=> v71115(VarCurr) ) ).

tff(addAssignment_44947,axiom,
    ! [VarCurr: state_type] :
      ( v71115(VarCurr)
    <=> v71117(VarCurr) ) ).

tff(addAssignment_44946,axiom,
    ! [VarCurr: state_type] :
      ( v71117(VarCurr)
    <=> v71119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6605,axiom,
    ! [VarCurr: state_type] :
      ( v71119(VarCurr)
    <=> ( v71157(VarCurr)
      <~> v71145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6604,axiom,
    ! [VarCurr: state_type] :
      ( v71157(VarCurr)
    <=> ( v71121(VarCurr)
      <~> v71133(VarCurr) ) ) ).

tff(addAssignment_44945,axiom,
    ! [VarCurr: state_type] :
      ( v71145(VarCurr)
    <=> v71147(VarCurr) ) ).

tff(addAssignment_44944,axiom,
    ! [VarCurr: state_type] :
      ( v71147(VarCurr)
    <=> v67349(VarCurr,117) ) ).

tff(addAssignment_44943,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,117)
    <=> v68249(VarCurr,53) ) ).

tff(addAssignment_44942,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,53)
    <=> v68251(VarCurr,53) ) ).

tff(addAssignment_44941,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,53)
    <=> v68253(VarCurr,53) ) ).

tff(addAssignment_44940,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,53)
    <=> v68255(VarCurr,53) ) ).

tff(addAssignment_44939,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,53)
    <=> v67359(VarCurr,117) ) ).

tff(addAssignment_44938,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,117)
    <=> v67580(VarCurr,117) ) ).

tff(addAssignment_44937,axiom,
    ! [VarCurr: state_type] :
      ( v67583(VarCurr,1)
    <=> v68258(VarCurr,53) ) ).

tff(addAssignment_44936,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,53)
    <=> v68260(VarCurr,53) ) ).

tff(addAssignment_44935,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,53)
    <=> v71149(VarNext,53) ) ).

tff(addCaseBooleanConditionEqualRanges1_884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71150(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71149(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_884,axiom,
    ! [VarNext: state_type] :
      ( v71150(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71149(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71150(VarNext)
      <=> v71151(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71151(VarNext)
      <=> ( v71153(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71153(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44934,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,53)
    <=> v68284(VarCurr,53) ) ).

tff(addAssignment_44933,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,53)
    <=> v67391(VarCurr,117) ) ).

tff(addAssignment_44932,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,117)
    <=> v70457(VarCurr,1) ) ).

tff(addAssignment_44931,axiom,
    ! [VarCurr: state_type] :
      ( v70457(VarCurr,1)
    <=> v70459(VarCurr,1) ) ).

tff(addAssignment_44930,axiom,
    ! [VarCurr: state_type] :
      ( v70459(VarCurr,1)
    <=> v70476(VarCurr,1) ) ).

tff(addAssignment_44929,axiom,
    ! [VarCurr: state_type] :
      ( v70469(VarCurr,1)
    <=> v70471(VarCurr,1) ) ).

tff(addAssignment_44928,axiom,
    ! [VarCurr: state_type] :
      ( v70471(VarCurr,1)
    <=> v67401(VarCurr,117) ) ).

tff(addAssignment_44927,axiom,
    ! [VarCurr: state_type] :
      ( v70461(VarCurr,1)
    <=> v70463(VarCurr,1) ) ).

tff(addAssignment_44926,axiom,
    ! [VarCurr: state_type] :
      ( v70463(VarCurr,1)
    <=> v67401(VarCurr,121) ) ).

tff(addAssignment_44925,axiom,
    ! [VarCurr: state_type] :
      ( v71133(VarCurr)
    <=> v71135(VarCurr) ) ).

tff(addAssignment_44924,axiom,
    ! [VarCurr: state_type] :
      ( v71135(VarCurr)
    <=> v67349(VarCurr,113) ) ).

tff(addAssignment_44923,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,113)
    <=> v68249(VarCurr,49) ) ).

tff(addAssignment_44922,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,49)
    <=> v68251(VarCurr,49) ) ).

tff(addAssignment_44921,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,49)
    <=> v68253(VarCurr,49) ) ).

tff(addAssignment_44920,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,49)
    <=> v68255(VarCurr,49) ) ).

tff(addAssignment_44919,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,49)
    <=> v67359(VarCurr,113) ) ).

tff(addAssignment_44918,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,113)
    <=> v67580(VarCurr,113) ) ).

tff(addAssignment_44917,axiom,
    ! [VarCurr: state_type] :
      ( v67584(VarCurr,1)
    <=> v68258(VarCurr,49) ) ).

tff(addAssignment_44916,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,49)
    <=> v68260(VarCurr,49) ) ).

tff(addAssignment_44915,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,49)
    <=> v71137(VarNext,49) ) ).

tff(addCaseBooleanConditionEqualRanges1_883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71138(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71137(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_883,axiom,
    ! [VarNext: state_type] :
      ( v71138(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71137(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71138(VarNext)
      <=> v71139(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71139(VarNext)
      <=> ( v71141(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71141(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44914,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,49)
    <=> v68284(VarCurr,49) ) ).

tff(addAssignment_44913,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,49)
    <=> v67391(VarCurr,113) ) ).

tff(addAssignment_44912,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,113)
    <=> v70417(VarCurr,1) ) ).

tff(addAssignment_44911,axiom,
    ! [VarCurr: state_type] :
      ( v70417(VarCurr,1)
    <=> v70419(VarCurr,1) ) ).

tff(addAssignment_44910,axiom,
    ! [VarCurr: state_type] :
      ( v70419(VarCurr,1)
    <=> v70436(VarCurr,1) ) ).

tff(addAssignment_44909,axiom,
    ! [VarCurr: state_type] :
      ( v70429(VarCurr,1)
    <=> v70431(VarCurr,1) ) ).

tff(addAssignment_44908,axiom,
    ! [VarCurr: state_type] :
      ( v70431(VarCurr,1)
    <=> v67401(VarCurr,113) ) ).

tff(addAssignment_44907,axiom,
    ! [VarCurr: state_type] :
      ( v70421(VarCurr,1)
    <=> v70423(VarCurr,1) ) ).

tff(addAssignment_44906,axiom,
    ! [VarCurr: state_type] :
      ( v70423(VarCurr,1)
    <=> v67401(VarCurr,117) ) ).

tff(addAssignment_44905,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,117)
    <=> v68294(VarCurr,53) ) ).

tff(addAssignment_44904,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,53)
    <=> v68296(VarCurr,53) ) ).

tff(addAssignment_44903,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,53)
    <=> v68385(VarCurr,53) ) ).

tff(addAssignment_44902,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,53)
    <=> v68306(VarCurr,53) ) ).

tff(addAssignment_44901,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,53)
    <=> v67430(VarCurr,117) ) ).

tff(addAssignment_44900,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,117)
    <=> v67432(VarCurr,117) ) ).

tff(addAssignment_44899,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,117)
    <=> v67434(VarCurr,117) ) ).

tff(addAssignment_44898,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,117)
    <=> v68308(VarCurr,53) ) ).

tff(addAssignment_44897,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,53)
    <=> v68310(VarCurr,53) ) ).

tff(addAssignment_44896,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,53)
    <=> v68368(VarCurr,53) ) ).

tff(addAssignment_44895,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,53)
    <=> v68366(VarCurr,53) ) ).

tff(addAssignment_44894,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,53)
    <=> v68367(VarCurr,53) ) ).

tff(addAssignment_44893,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,53)
    <=> v68361(VarCurr,53) ) ).

tff(addAssignment_44892,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,53)
    <=> v68362(VarCurr,53) ) ).

tff(addAssignment_44891,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,53)
    <=> v68357(VarCurr,53) ) ).

tff(addAssignment_44890,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,53)
    <=> $false ) ).

tff(addAssignment_44889,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,53)
    <=> v68300(VarCurr,53) ) ).

tff(addAssignment_44888,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,53)
    <=> v68301(VarCurr,53) ) ).

tff(addAssignment_44887,axiom,
    ! [VarCurr: state_type] :
      ( v71121(VarCurr)
    <=> v71123(VarCurr) ) ).

tff(addAssignment_44886,axiom,
    ! [VarCurr: state_type] :
      ( v71123(VarCurr)
    <=> v67349(VarCurr,109) ) ).

tff(addAssignment_44885,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,109)
    <=> v68249(VarCurr,45) ) ).

tff(addAssignment_44884,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,45)
    <=> v68251(VarCurr,45) ) ).

tff(addAssignment_44883,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,45)
    <=> v68253(VarCurr,45) ) ).

tff(addAssignment_44882,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,45)
    <=> v68255(VarCurr,45) ) ).

tff(addAssignment_44881,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,45)
    <=> v67359(VarCurr,109) ) ).

tff(addAssignment_44880,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,109)
    <=> v67580(VarCurr,109) ) ).

tff(addAssignment_44879,axiom,
    ! [VarCurr: state_type] :
      ( v67585(VarCurr,1)
    <=> v68258(VarCurr,45) ) ).

tff(addAssignment_44878,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,45)
    <=> v68260(VarCurr,45) ) ).

tff(addAssignment_44877,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,45)
    <=> v71125(VarNext,45) ) ).

tff(addCaseBooleanConditionEqualRanges1_882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71126(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71125(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_882,axiom,
    ! [VarNext: state_type] :
      ( v71126(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71125(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71126(VarNext)
      <=> v71127(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71127(VarNext)
      <=> ( v71129(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71129(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44876,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,45)
    <=> v68284(VarCurr,45) ) ).

tff(addAssignment_44875,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,45)
    <=> v67391(VarCurr,109) ) ).

tff(addAssignment_44874,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,109)
    <=> v70377(VarCurr,1) ) ).

tff(addAssignment_44873,axiom,
    ! [VarCurr: state_type] :
      ( v70377(VarCurr,1)
    <=> v70379(VarCurr,1) ) ).

tff(addAssignment_44872,axiom,
    ! [VarCurr: state_type] :
      ( v70379(VarCurr,1)
    <=> v70396(VarCurr,1) ) ).

tff(addAssignment_44871,axiom,
    ! [VarCurr: state_type] :
      ( v70389(VarCurr,1)
    <=> v70391(VarCurr,1) ) ).

tff(addAssignment_44870,axiom,
    ! [VarCurr: state_type] :
      ( v70391(VarCurr,1)
    <=> v67401(VarCurr,109) ) ).

tff(addAssignment_44869,axiom,
    ! [VarCurr: state_type] :
      ( v70381(VarCurr,1)
    <=> v70383(VarCurr,1) ) ).

tff(addAssignment_44868,axiom,
    ! [VarCurr: state_type] :
      ( v70383(VarCurr,1)
    <=> v67401(VarCurr,113) ) ).

tff(addAssignment_44867,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,113)
    <=> v68294(VarCurr,49) ) ).

tff(addAssignment_44866,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,49)
    <=> v68296(VarCurr,49) ) ).

tff(addAssignment_44865,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,49)
    <=> v68385(VarCurr,49) ) ).

tff(addAssignment_44864,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,49)
    <=> v68306(VarCurr,49) ) ).

tff(addAssignment_44863,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,49)
    <=> v67430(VarCurr,113) ) ).

tff(addAssignment_44862,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,113)
    <=> v67432(VarCurr,113) ) ).

tff(addAssignment_44861,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,113)
    <=> v67434(VarCurr,113) ) ).

tff(addAssignment_44860,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,113)
    <=> v68308(VarCurr,49) ) ).

tff(addAssignment_44859,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,49)
    <=> v68310(VarCurr,49) ) ).

tff(addAssignment_44858,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,49)
    <=> v68368(VarCurr,49) ) ).

tff(addAssignment_44857,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,49)
    <=> v68366(VarCurr,49) ) ).

tff(addAssignment_44856,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,49)
    <=> v68367(VarCurr,49) ) ).

tff(addAssignment_44855,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,49)
    <=> v68361(VarCurr,49) ) ).

tff(addAssignment_44854,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,49)
    <=> v68362(VarCurr,49) ) ).

tff(addAssignment_44853,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,49)
    <=> v68357(VarCurr,49) ) ).

tff(addAssignment_44852,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,49)
    <=> $false ) ).

tff(addAssignment_44851,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,49)
    <=> v68300(VarCurr,49) ) ).

tff(addAssignment_44850,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,49)
    <=> v68301(VarCurr,49) ) ).

tff(addAssignment_44849,axiom,
    ! [VarCurr: state_type] :
      ( v71063(VarCurr)
    <=> v71065(VarCurr) ) ).

tff(addAssignment_44848,axiom,
    ! [VarCurr: state_type] :
      ( v71065(VarCurr)
    <=> v71067(VarCurr) ) ).

tff(addAssignment_44847,axiom,
    ! [VarCurr: state_type] :
      ( v71067(VarCurr)
    <=> v71069(VarCurr) ) ).

tff(addAssignment_44846,axiom,
    ! [VarCurr: state_type] :
      ( v71069(VarCurr)
    <=> v71071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6597,axiom,
    ! [VarCurr: state_type] :
      ( v71071(VarCurr)
    <=> ( v71109(VarCurr)
      <~> v71097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6596,axiom,
    ! [VarCurr: state_type] :
      ( v71109(VarCurr)
    <=> ( v71073(VarCurr)
      <~> v71085(VarCurr) ) ) ).

tff(addAssignment_44845,axiom,
    ! [VarCurr: state_type] :
      ( v71097(VarCurr)
    <=> v71099(VarCurr) ) ).

tff(addAssignment_44844,axiom,
    ! [VarCurr: state_type] :
      ( v71099(VarCurr)
    <=> v67349(VarCurr,105) ) ).

tff(addAssignment_44843,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,105)
    <=> v68249(VarCurr,41) ) ).

tff(addAssignment_44842,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,41)
    <=> v68251(VarCurr,41) ) ).

tff(addAssignment_44841,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,41)
    <=> v68253(VarCurr,41) ) ).

tff(addAssignment_44840,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,41)
    <=> v68255(VarCurr,41) ) ).

tff(addAssignment_44839,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,41)
    <=> v67359(VarCurr,105) ) ).

tff(addAssignment_44838,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,105)
    <=> v67580(VarCurr,105) ) ).

tff(addAssignment_44837,axiom,
    ! [VarCurr: state_type] :
      ( v67586(VarCurr,1)
    <=> v68258(VarCurr,41) ) ).

tff(addAssignment_44836,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,41)
    <=> v68260(VarCurr,41) ) ).

tff(addAssignment_44835,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,41)
    <=> v71101(VarNext,41) ) ).

tff(addCaseBooleanConditionEqualRanges1_881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71102(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71101(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_881,axiom,
    ! [VarNext: state_type] :
      ( v71102(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71101(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71102(VarNext)
      <=> v71103(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71103(VarNext)
      <=> ( v71105(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71105(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44834,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,41)
    <=> v68284(VarCurr,41) ) ).

tff(addAssignment_44833,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,41)
    <=> v67391(VarCurr,105) ) ).

tff(addAssignment_44832,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,105)
    <=> v70325(VarCurr,1) ) ).

tff(addAssignment_44831,axiom,
    ! [VarCurr: state_type] :
      ( v70325(VarCurr,1)
    <=> v70327(VarCurr,1) ) ).

tff(addAssignment_44830,axiom,
    ! [VarCurr: state_type] :
      ( v70327(VarCurr,1)
    <=> v70344(VarCurr,1) ) ).

tff(addAssignment_44829,axiom,
    ! [VarCurr: state_type] :
      ( v70337(VarCurr,1)
    <=> v70339(VarCurr,1) ) ).

tff(addAssignment_44828,axiom,
    ! [VarCurr: state_type] :
      ( v70339(VarCurr,1)
    <=> v67401(VarCurr,105) ) ).

tff(addAssignment_44827,axiom,
    ! [VarCurr: state_type] :
      ( v70329(VarCurr,1)
    <=> v70331(VarCurr,1) ) ).

tff(addAssignment_44826,axiom,
    ! [VarCurr: state_type] :
      ( v70331(VarCurr,1)
    <=> v67401(VarCurr,109) ) ).

tff(addAssignment_44825,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,109)
    <=> v68294(VarCurr,45) ) ).

tff(addAssignment_44824,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,45)
    <=> v68296(VarCurr,45) ) ).

tff(addAssignment_44823,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,45)
    <=> v68385(VarCurr,45) ) ).

tff(addAssignment_44822,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,45)
    <=> v68306(VarCurr,45) ) ).

tff(addAssignment_44821,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,45)
    <=> v67430(VarCurr,109) ) ).

tff(addAssignment_44820,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,109)
    <=> v67432(VarCurr,109) ) ).

tff(addAssignment_44819,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,109)
    <=> v67434(VarCurr,109) ) ).

tff(addAssignment_44818,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,109)
    <=> v68308(VarCurr,45) ) ).

tff(addAssignment_44817,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,45)
    <=> v68310(VarCurr,45) ) ).

tff(addAssignment_44816,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,45)
    <=> v68368(VarCurr,45) ) ).

tff(addAssignment_44815,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,45)
    <=> v68366(VarCurr,45) ) ).

tff(addAssignment_44814,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,45)
    <=> v68367(VarCurr,45) ) ).

tff(addAssignment_44813,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,45)
    <=> v68361(VarCurr,45) ) ).

tff(addAssignment_44812,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,45)
    <=> v68362(VarCurr,45) ) ).

tff(addAssignment_44811,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,45)
    <=> v68357(VarCurr,45) ) ).

tff(addAssignment_44810,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,45)
    <=> $false ) ).

tff(addAssignment_44809,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,45)
    <=> v68300(VarCurr,45) ) ).

tff(addAssignment_44808,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,45)
    <=> v68301(VarCurr,45) ) ).

tff(addAssignment_44807,axiom,
    ! [VarCurr: state_type] :
      ( v71085(VarCurr)
    <=> v71087(VarCurr) ) ).

tff(addAssignment_44806,axiom,
    ! [VarCurr: state_type] :
      ( v71087(VarCurr)
    <=> v67349(VarCurr,101) ) ).

tff(addAssignment_44805,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,101)
    <=> v68249(VarCurr,37) ) ).

tff(addAssignment_44804,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,37)
    <=> v68251(VarCurr,37) ) ).

tff(addAssignment_44803,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,37)
    <=> v68253(VarCurr,37) ) ).

tff(addAssignment_44802,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,37)
    <=> v68255(VarCurr,37) ) ).

tff(addAssignment_44801,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,37)
    <=> v67359(VarCurr,101) ) ).

tff(addAssignment_44800,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,101)
    <=> v67580(VarCurr,101) ) ).

tff(addAssignment_44799,axiom,
    ! [VarCurr: state_type] :
      ( v67587(VarCurr,1)
    <=> v68258(VarCurr,37) ) ).

tff(addAssignment_44798,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,37)
    <=> v68260(VarCurr,37) ) ).

tff(addAssignment_44797,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,37)
    <=> v71089(VarNext,37) ) ).

tff(addCaseBooleanConditionEqualRanges1_880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71090(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71089(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_880,axiom,
    ! [VarNext: state_type] :
      ( v71090(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71089(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71090(VarNext)
      <=> v71091(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71091(VarNext)
      <=> ( v71093(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71093(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44796,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,37)
    <=> v68284(VarCurr,37) ) ).

tff(addAssignment_44795,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,37)
    <=> v67391(VarCurr,101) ) ).

tff(addAssignment_44794,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,101)
    <=> v70285(VarCurr,1) ) ).

tff(addAssignment_44793,axiom,
    ! [VarCurr: state_type] :
      ( v70285(VarCurr,1)
    <=> v70287(VarCurr,1) ) ).

tff(addAssignment_44792,axiom,
    ! [VarCurr: state_type] :
      ( v70287(VarCurr,1)
    <=> v70304(VarCurr,1) ) ).

tff(addAssignment_44791,axiom,
    ! [VarCurr: state_type] :
      ( v70297(VarCurr,1)
    <=> v70299(VarCurr,1) ) ).

tff(addAssignment_44790,axiom,
    ! [VarCurr: state_type] :
      ( v70299(VarCurr,1)
    <=> v67401(VarCurr,101) ) ).

tff(addAssignment_44789,axiom,
    ! [VarCurr: state_type] :
      ( v70289(VarCurr,1)
    <=> v70291(VarCurr,1) ) ).

tff(addAssignment_44788,axiom,
    ! [VarCurr: state_type] :
      ( v70291(VarCurr,1)
    <=> v67401(VarCurr,105) ) ).

tff(addAssignment_44787,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,105)
    <=> v68294(VarCurr,41) ) ).

tff(addAssignment_44786,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,41)
    <=> v68296(VarCurr,41) ) ).

tff(addAssignment_44785,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,41)
    <=> v68385(VarCurr,41) ) ).

tff(addAssignment_44784,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,41)
    <=> v68306(VarCurr,41) ) ).

tff(addAssignment_44783,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,41)
    <=> v67430(VarCurr,105) ) ).

tff(addAssignment_44782,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,105)
    <=> v67432(VarCurr,105) ) ).

tff(addAssignment_44781,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,105)
    <=> v67434(VarCurr,105) ) ).

tff(addAssignment_44780,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,105)
    <=> v68308(VarCurr,41) ) ).

tff(addAssignment_44779,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,41)
    <=> v68310(VarCurr,41) ) ).

tff(addAssignment_44778,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,41)
    <=> v68368(VarCurr,41) ) ).

tff(addAssignment_44777,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,41)
    <=> v68366(VarCurr,41) ) ).

tff(addAssignment_44776,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,41)
    <=> v68367(VarCurr,41) ) ).

tff(addAssignment_44775,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,41)
    <=> v68361(VarCurr,41) ) ).

tff(addAssignment_44774,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,41)
    <=> v68362(VarCurr,41) ) ).

tff(addAssignment_44773,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,41)
    <=> v68357(VarCurr,41) ) ).

tff(addAssignment_44772,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,41)
    <=> $false ) ).

tff(addAssignment_44771,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,41)
    <=> v68300(VarCurr,41) ) ).

tff(addAssignment_44770,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,41)
    <=> v68301(VarCurr,41) ) ).

tff(addAssignment_44769,axiom,
    ! [VarCurr: state_type] :
      ( v71073(VarCurr)
    <=> v71075(VarCurr) ) ).

tff(addAssignment_44768,axiom,
    ! [VarCurr: state_type] :
      ( v71075(VarCurr)
    <=> v67349(VarCurr,97) ) ).

tff(addAssignment_44767,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,97)
    <=> v68249(VarCurr,33) ) ).

tff(addAssignment_44766,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,33)
    <=> v68251(VarCurr,33) ) ).

tff(addAssignment_44765,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,33)
    <=> v68253(VarCurr,33) ) ).

tff(addAssignment_44764,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,33)
    <=> v68255(VarCurr,33) ) ).

tff(addAssignment_44763,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,33)
    <=> v67359(VarCurr,97) ) ).

tff(addAssignment_44762,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,97)
    <=> v67580(VarCurr,97) ) ).

tff(addAssignment_44761,axiom,
    ! [VarCurr: state_type] :
      ( v67588(VarCurr,1)
    <=> v68258(VarCurr,33) ) ).

tff(addAssignment_44760,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,33)
    <=> v68260(VarCurr,33) ) ).

tff(addAssignment_44759,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,33)
    <=> v71077(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71078(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71077(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_879,axiom,
    ! [VarNext: state_type] :
      ( v71078(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71077(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71078(VarNext)
      <=> v71079(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71079(VarNext)
      <=> ( v71081(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71081(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44758,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,33)
    <=> v68284(VarCurr,33) ) ).

tff(addAssignment_44757,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,33)
    <=> v67391(VarCurr,97) ) ).

tff(addAssignment_44756,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,97)
    <=> v70245(VarCurr,1) ) ).

tff(addAssignment_44755,axiom,
    ! [VarCurr: state_type] :
      ( v70245(VarCurr,1)
    <=> v70247(VarCurr,1) ) ).

tff(addAssignment_44754,axiom,
    ! [VarCurr: state_type] :
      ( v70247(VarCurr,1)
    <=> v70264(VarCurr,1) ) ).

tff(addAssignment_44753,axiom,
    ! [VarCurr: state_type] :
      ( v70257(VarCurr,1)
    <=> v70259(VarCurr,1) ) ).

tff(addAssignment_44752,axiom,
    ! [VarCurr: state_type] :
      ( v70259(VarCurr,1)
    <=> v67401(VarCurr,97) ) ).

tff(addAssignment_44751,axiom,
    ! [VarCurr: state_type] :
      ( v70249(VarCurr,1)
    <=> v70251(VarCurr,1) ) ).

tff(addAssignment_44750,axiom,
    ! [VarCurr: state_type] :
      ( v70251(VarCurr,1)
    <=> v67401(VarCurr,101) ) ).

tff(addAssignment_44749,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,101)
    <=> v68294(VarCurr,37) ) ).

tff(addAssignment_44748,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,37)
    <=> v68296(VarCurr,37) ) ).

tff(addAssignment_44747,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,37)
    <=> v68385(VarCurr,37) ) ).

tff(addAssignment_44746,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,37)
    <=> v68306(VarCurr,37) ) ).

tff(addAssignment_44745,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,37)
    <=> v67430(VarCurr,101) ) ).

tff(addAssignment_44744,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,101)
    <=> v67432(VarCurr,101) ) ).

tff(addAssignment_44743,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,101)
    <=> v67434(VarCurr,101) ) ).

tff(addAssignment_44742,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,101)
    <=> v68308(VarCurr,37) ) ).

tff(addAssignment_44741,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,37)
    <=> v68310(VarCurr,37) ) ).

tff(addAssignment_44740,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,37)
    <=> v68368(VarCurr,37) ) ).

tff(addAssignment_44739,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,37)
    <=> v68366(VarCurr,37) ) ).

tff(addAssignment_44738,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,37)
    <=> v68367(VarCurr,37) ) ).

tff(addAssignment_44737,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,37)
    <=> v68361(VarCurr,37) ) ).

tff(addAssignment_44736,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,37)
    <=> v68362(VarCurr,37) ) ).

tff(addAssignment_44735,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,37)
    <=> v68357(VarCurr,37) ) ).

tff(addAssignment_44734,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,37)
    <=> $false ) ).

tff(addAssignment_44733,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,37)
    <=> v68300(VarCurr,37) ) ).

tff(addAssignment_44732,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,37)
    <=> v68301(VarCurr,37) ) ).

tff(addAssignment_44731,axiom,
    ! [VarCurr: state_type] :
      ( v70897(VarCurr)
    <=> v70899(VarCurr) ) ).

tff(addAssignment_44730,axiom,
    ! [VarCurr: state_type] :
      ( v70899(VarCurr)
    <=> v70901(VarCurr) ) ).

tff(addAssignment_44729,axiom,
    ! [VarCurr: state_type] :
      ( v70901(VarCurr)
    <=> v70903(VarCurr) ) ).

tff(addAssignment_44728,axiom,
    ! [VarCurr: state_type] :
      ( v70903(VarCurr)
    <=> v70905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6589,axiom,
    ! [VarCurr: state_type] :
      ( v70905(VarCurr)
    <=> ( v71051(VarCurr)
      <~> v71003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6588,axiom,
    ! [VarCurr: state_type] :
      ( v71051(VarCurr)
    <=> ( v70907(VarCurr)
      <~> v70955(VarCurr) ) ) ).

tff(addAssignment_44727,axiom,
    ! [VarCurr: state_type] :
      ( v71003(VarCurr)
    <=> v71005(VarCurr) ) ).

tff(addAssignment_44726,axiom,
    ! [VarCurr: state_type] :
      ( v71005(VarCurr)
    <=> v71007(VarCurr) ) ).

tff(addAssignment_44725,axiom,
    ! [VarCurr: state_type] :
      ( v71007(VarCurr)
    <=> v71009(VarCurr) ) ).

tff(addAssignment_44724,axiom,
    ! [VarCurr: state_type] :
      ( v71009(VarCurr)
    <=> v71011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6587,axiom,
    ! [VarCurr: state_type] :
      ( v71011(VarCurr)
    <=> ( v71049(VarCurr)
      <~> v71037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6586,axiom,
    ! [VarCurr: state_type] :
      ( v71049(VarCurr)
    <=> ( v71013(VarCurr)
      <~> v71025(VarCurr) ) ) ).

tff(addAssignment_44723,axiom,
    ! [VarCurr: state_type] :
      ( v71037(VarCurr)
    <=> v71039(VarCurr) ) ).

tff(addAssignment_44722,axiom,
    ! [VarCurr: state_type] :
      ( v71039(VarCurr)
    <=> v67349(VarCurr,93) ) ).

tff(addAssignment_44721,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,93)
    <=> v68249(VarCurr,29) ) ).

tff(addAssignment_44720,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,29)
    <=> v68251(VarCurr,29) ) ).

tff(addAssignment_44719,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,29)
    <=> v68253(VarCurr,29) ) ).

tff(addAssignment_44718,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,29)
    <=> v68255(VarCurr,29) ) ).

tff(addAssignment_44717,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,29)
    <=> v67359(VarCurr,93) ) ).

tff(addAssignment_44716,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,93)
    <=> v67580(VarCurr,93) ) ).

tff(addAssignment_44715,axiom,
    ! [VarCurr: state_type] :
      ( v67589(VarCurr,1)
    <=> v68258(VarCurr,29) ) ).

tff(addAssignment_44714,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,29)
    <=> v68260(VarCurr,29) ) ).

tff(addAssignment_44713,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,29)
    <=> v71041(VarNext,29) ) ).

tff(addCaseBooleanConditionEqualRanges1_878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71042(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71041(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_878,axiom,
    ! [VarNext: state_type] :
      ( v71042(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71041(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71042(VarNext)
      <=> v71043(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71043(VarNext)
      <=> ( v71045(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71045(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44712,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,29)
    <=> v68284(VarCurr,29) ) ).

tff(addAssignment_44711,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,29)
    <=> v67391(VarCurr,93) ) ).

tff(addAssignment_44710,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,93)
    <=> v70181(VarCurr,1) ) ).

tff(addAssignment_44709,axiom,
    ! [VarCurr: state_type] :
      ( v70181(VarCurr,1)
    <=> v70183(VarCurr,1) ) ).

tff(addAssignment_44708,axiom,
    ! [VarCurr: state_type] :
      ( v70183(VarCurr,1)
    <=> v70200(VarCurr,1) ) ).

tff(addAssignment_44707,axiom,
    ! [VarCurr: state_type] :
      ( v70193(VarCurr,1)
    <=> v70195(VarCurr,1) ) ).

tff(addAssignment_44706,axiom,
    ! [VarCurr: state_type] :
      ( v70195(VarCurr,1)
    <=> v67401(VarCurr,93) ) ).

tff(addAssignment_44705,axiom,
    ! [VarCurr: state_type] :
      ( v70185(VarCurr,1)
    <=> v70187(VarCurr,1) ) ).

tff(addAssignment_44704,axiom,
    ! [VarCurr: state_type] :
      ( v70187(VarCurr,1)
    <=> v67401(VarCurr,97) ) ).

tff(addAssignment_44703,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,97)
    <=> v68294(VarCurr,33) ) ).

tff(addAssignment_44702,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,33)
    <=> v68296(VarCurr,33) ) ).

tff(addAssignment_44701,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,33)
    <=> v68385(VarCurr,33) ) ).

tff(addAssignment_44700,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,33)
    <=> v68306(VarCurr,33) ) ).

tff(addAssignment_44699,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,33)
    <=> v67430(VarCurr,97) ) ).

tff(addAssignment_44698,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,97)
    <=> v67432(VarCurr,97) ) ).

tff(addAssignment_44697,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,97)
    <=> v67434(VarCurr,97) ) ).

tff(addAssignment_44696,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,97)
    <=> v68308(VarCurr,33) ) ).

tff(addAssignment_44695,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,33)
    <=> v68310(VarCurr,33) ) ).

tff(addAssignment_44694,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,33)
    <=> v68368(VarCurr,33) ) ).

tff(addAssignment_44693,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,33)
    <=> v68366(VarCurr,33) ) ).

tff(addAssignment_44692,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,33)
    <=> v68367(VarCurr,33) ) ).

tff(addAssignment_44691,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,33)
    <=> v68361(VarCurr,33) ) ).

tff(addAssignment_44690,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,33)
    <=> v68362(VarCurr,33) ) ).

tff(addAssignment_44689,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,33)
    <=> v68357(VarCurr,33) ) ).

tff(addAssignment_44688,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,33)
    <=> $false ) ).

tff(addAssignment_44687,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,33)
    <=> v68300(VarCurr,33) ) ).

tff(addAssignment_44686,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,33)
    <=> v68301(VarCurr,33) ) ).

tff(addAssignment_44685,axiom,
    ! [VarCurr: state_type] :
      ( v71025(VarCurr)
    <=> v71027(VarCurr) ) ).

tff(addAssignment_44684,axiom,
    ! [VarCurr: state_type] :
      ( v71027(VarCurr)
    <=> v67349(VarCurr,89) ) ).

tff(addAssignment_44683,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,89)
    <=> v68249(VarCurr,25) ) ).

tff(addAssignment_44682,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,25)
    <=> v68251(VarCurr,25) ) ).

tff(addAssignment_44681,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,25)
    <=> v68253(VarCurr,25) ) ).

tff(addAssignment_44680,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,25)
    <=> v68255(VarCurr,25) ) ).

tff(addAssignment_44679,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,25)
    <=> v67359(VarCurr,89) ) ).

tff(addAssignment_44678,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,89)
    <=> v67580(VarCurr,89) ) ).

tff(addAssignment_44677,axiom,
    ! [VarCurr: state_type] :
      ( v67590(VarCurr,1)
    <=> v68258(VarCurr,25) ) ).

tff(addAssignment_44676,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,25)
    <=> v68260(VarCurr,25) ) ).

tff(addAssignment_44675,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,25)
    <=> v71029(VarNext,25) ) ).

tff(addCaseBooleanConditionEqualRanges1_877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71030(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71029(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_877,axiom,
    ! [VarNext: state_type] :
      ( v71030(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71029(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71030(VarNext)
      <=> v71031(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71031(VarNext)
      <=> ( v71033(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71033(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44674,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,25)
    <=> v68284(VarCurr,25) ) ).

tff(addAssignment_44673,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,25)
    <=> v67391(VarCurr,89) ) ).

tff(addAssignment_44672,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,89)
    <=> v70141(VarCurr,1) ) ).

tff(addAssignment_44671,axiom,
    ! [VarCurr: state_type] :
      ( v70141(VarCurr,1)
    <=> v70143(VarCurr,1) ) ).

tff(addAssignment_44670,axiom,
    ! [VarCurr: state_type] :
      ( v70143(VarCurr,1)
    <=> v70160(VarCurr,1) ) ).

tff(addAssignment_44669,axiom,
    ! [VarCurr: state_type] :
      ( v70153(VarCurr,1)
    <=> v70155(VarCurr,1) ) ).

tff(addAssignment_44668,axiom,
    ! [VarCurr: state_type] :
      ( v70155(VarCurr,1)
    <=> v67401(VarCurr,89) ) ).

tff(addAssignment_44667,axiom,
    ! [VarCurr: state_type] :
      ( v70145(VarCurr,1)
    <=> v70147(VarCurr,1) ) ).

tff(addAssignment_44666,axiom,
    ! [VarCurr: state_type] :
      ( v70147(VarCurr,1)
    <=> v67401(VarCurr,93) ) ).

tff(addAssignment_44665,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,93)
    <=> v68294(VarCurr,29) ) ).

tff(addAssignment_44664,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,29)
    <=> v68296(VarCurr,29) ) ).

tff(addAssignment_44663,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,29)
    <=> v68385(VarCurr,29) ) ).

tff(addAssignment_44662,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,29)
    <=> v68306(VarCurr,29) ) ).

tff(addAssignment_44661,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,29)
    <=> v67430(VarCurr,93) ) ).

tff(addAssignment_44660,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,93)
    <=> v67432(VarCurr,93) ) ).

tff(addAssignment_44659,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,93)
    <=> v67434(VarCurr,93) ) ).

tff(addAssignment_44658,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,93)
    <=> v68308(VarCurr,29) ) ).

tff(addAssignment_44657,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,29)
    <=> v68310(VarCurr,29) ) ).

tff(addAssignment_44656,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,29)
    <=> v68368(VarCurr,29) ) ).

tff(addAssignment_44655,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,29)
    <=> v68366(VarCurr,29) ) ).

tff(addAssignment_44654,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,29)
    <=> v68367(VarCurr,29) ) ).

tff(addAssignment_44653,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,29)
    <=> v68361(VarCurr,29) ) ).

tff(addAssignment_44652,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,29)
    <=> v68362(VarCurr,29) ) ).

tff(addAssignment_44651,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,29)
    <=> v68357(VarCurr,29) ) ).

tff(addAssignment_44650,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,29)
    <=> $false ) ).

tff(addAssignment_44649,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,29)
    <=> v68300(VarCurr,29) ) ).

tff(addAssignment_44648,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,29)
    <=> v68301(VarCurr,29) ) ).

tff(addAssignment_44647,axiom,
    ! [VarCurr: state_type] :
      ( v71013(VarCurr)
    <=> v71015(VarCurr) ) ).

tff(addAssignment_44646,axiom,
    ! [VarCurr: state_type] :
      ( v71015(VarCurr)
    <=> v67349(VarCurr,85) ) ).

tff(addAssignment_44645,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,85)
    <=> v68249(VarCurr,21) ) ).

tff(addAssignment_44644,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,21)
    <=> v68251(VarCurr,21) ) ).

tff(addAssignment_44643,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,21)
    <=> v68253(VarCurr,21) ) ).

tff(addAssignment_44642,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,21)
    <=> v68255(VarCurr,21) ) ).

tff(addAssignment_44641,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,21)
    <=> v67359(VarCurr,85) ) ).

tff(addAssignment_44640,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,85)
    <=> v67580(VarCurr,85) ) ).

tff(addAssignment_44639,axiom,
    ! [VarCurr: state_type] :
      ( v67591(VarCurr,1)
    <=> v68258(VarCurr,21) ) ).

tff(addAssignment_44638,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,21)
    <=> v68260(VarCurr,21) ) ).

tff(addAssignment_44637,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,21)
    <=> v71017(VarNext,21) ) ).

tff(addCaseBooleanConditionEqualRanges1_876,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71018(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v71017(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_876,axiom,
    ! [VarNext: state_type] :
      ( v71018(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v71017(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71018(VarNext)
      <=> v71019(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v71019(VarNext)
      <=> ( v71021(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v71021(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44636,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,21)
    <=> v68284(VarCurr,21) ) ).

tff(addAssignment_44635,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,21)
    <=> v67391(VarCurr,85) ) ).

tff(addAssignment_44634,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,85)
    <=> v70101(VarCurr,1) ) ).

tff(addAssignment_44633,axiom,
    ! [VarCurr: state_type] :
      ( v70101(VarCurr,1)
    <=> v70103(VarCurr,1) ) ).

tff(addAssignment_44632,axiom,
    ! [VarCurr: state_type] :
      ( v70103(VarCurr,1)
    <=> v70120(VarCurr,1) ) ).

tff(addAssignment_44631,axiom,
    ! [VarCurr: state_type] :
      ( v70113(VarCurr,1)
    <=> v70115(VarCurr,1) ) ).

tff(addAssignment_44630,axiom,
    ! [VarCurr: state_type] :
      ( v70115(VarCurr,1)
    <=> v67401(VarCurr,85) ) ).

tff(addAssignment_44629,axiom,
    ! [VarCurr: state_type] :
      ( v70105(VarCurr,1)
    <=> v70107(VarCurr,1) ) ).

tff(addAssignment_44628,axiom,
    ! [VarCurr: state_type] :
      ( v70107(VarCurr,1)
    <=> v67401(VarCurr,89) ) ).

tff(addAssignment_44627,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,89)
    <=> v68294(VarCurr,25) ) ).

tff(addAssignment_44626,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,25)
    <=> v68296(VarCurr,25) ) ).

tff(addAssignment_44625,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,25)
    <=> v68385(VarCurr,25) ) ).

tff(addAssignment_44624,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,25)
    <=> v68306(VarCurr,25) ) ).

tff(addAssignment_44623,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,25)
    <=> v67430(VarCurr,89) ) ).

tff(addAssignment_44622,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,89)
    <=> v67432(VarCurr,89) ) ).

tff(addAssignment_44621,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,89)
    <=> v67434(VarCurr,89) ) ).

tff(addAssignment_44620,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,89)
    <=> v68308(VarCurr,25) ) ).

tff(addAssignment_44619,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,25)
    <=> v68310(VarCurr,25) ) ).

tff(addAssignment_44618,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,25)
    <=> v68368(VarCurr,25) ) ).

tff(addAssignment_44617,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,25)
    <=> v68366(VarCurr,25) ) ).

tff(addAssignment_44616,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,25)
    <=> v68367(VarCurr,25) ) ).

tff(addAssignment_44615,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,25)
    <=> v68361(VarCurr,25) ) ).

tff(addAssignment_44614,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,25)
    <=> v68362(VarCurr,25) ) ).

tff(addAssignment_44613,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,25)
    <=> v68357(VarCurr,25) ) ).

tff(addAssignment_44612,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,25)
    <=> $false ) ).

tff(addAssignment_44611,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,25)
    <=> v68300(VarCurr,25) ) ).

tff(addAssignment_44610,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,25)
    <=> v68301(VarCurr,25) ) ).

tff(addAssignment_44609,axiom,
    ! [VarCurr: state_type] :
      ( v70955(VarCurr)
    <=> v70957(VarCurr) ) ).

tff(addAssignment_44608,axiom,
    ! [VarCurr: state_type] :
      ( v70957(VarCurr)
    <=> v70959(VarCurr) ) ).

tff(addAssignment_44607,axiom,
    ! [VarCurr: state_type] :
      ( v70959(VarCurr)
    <=> v70961(VarCurr) ) ).

tff(addAssignment_44606,axiom,
    ! [VarCurr: state_type] :
      ( v70961(VarCurr)
    <=> v70963(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6579,axiom,
    ! [VarCurr: state_type] :
      ( v70963(VarCurr)
    <=> ( v71001(VarCurr)
      <~> v70989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6578,axiom,
    ! [VarCurr: state_type] :
      ( v71001(VarCurr)
    <=> ( v70965(VarCurr)
      <~> v70977(VarCurr) ) ) ).

tff(addAssignment_44605,axiom,
    ! [VarCurr: state_type] :
      ( v70989(VarCurr)
    <=> v70991(VarCurr) ) ).

tff(addAssignment_44604,axiom,
    ! [VarCurr: state_type] :
      ( v70991(VarCurr)
    <=> v67349(VarCurr,81) ) ).

tff(addAssignment_44603,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,81)
    <=> v68249(VarCurr,17) ) ).

tff(addAssignment_44602,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,17)
    <=> v68251(VarCurr,17) ) ).

tff(addAssignment_44601,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,17)
    <=> v68253(VarCurr,17) ) ).

tff(addAssignment_44600,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,17)
    <=> v68255(VarCurr,17) ) ).

tff(addAssignment_44599,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,17)
    <=> v67359(VarCurr,81) ) ).

tff(addAssignment_44598,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,81)
    <=> v67580(VarCurr,81) ) ).

tff(addAssignment_44597,axiom,
    ! [VarCurr: state_type] :
      ( v67592(VarCurr,1)
    <=> v68258(VarCurr,17) ) ).

tff(addAssignment_44596,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,17)
    <=> v68260(VarCurr,17) ) ).

tff(addAssignment_44595,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,17)
    <=> v70993(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70994(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70993(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_875,axiom,
    ! [VarNext: state_type] :
      ( v70994(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70993(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70994(VarNext)
      <=> v70995(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70995(VarNext)
      <=> ( v70997(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70997(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44594,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,17)
    <=> v68284(VarCurr,17) ) ).

tff(addAssignment_44593,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,17)
    <=> v67391(VarCurr,81) ) ).

tff(addAssignment_44592,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,81)
    <=> v70049(VarCurr,1) ) ).

tff(addAssignment_44591,axiom,
    ! [VarCurr: state_type] :
      ( v70049(VarCurr,1)
    <=> v70051(VarCurr,1) ) ).

tff(addAssignment_44590,axiom,
    ! [VarCurr: state_type] :
      ( v70051(VarCurr,1)
    <=> v70068(VarCurr,1) ) ).

tff(addAssignment_44589,axiom,
    ! [VarCurr: state_type] :
      ( v70061(VarCurr,1)
    <=> v70063(VarCurr,1) ) ).

tff(addAssignment_44588,axiom,
    ! [VarCurr: state_type] :
      ( v70063(VarCurr,1)
    <=> v67401(VarCurr,81) ) ).

tff(addAssignment_44587,axiom,
    ! [VarCurr: state_type] :
      ( v70053(VarCurr,1)
    <=> v70055(VarCurr,1) ) ).

tff(addAssignment_44586,axiom,
    ! [VarCurr: state_type] :
      ( v70055(VarCurr,1)
    <=> v67401(VarCurr,85) ) ).

tff(addAssignment_44585,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,85)
    <=> v68294(VarCurr,21) ) ).

tff(addAssignment_44584,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,21)
    <=> v68296(VarCurr,21) ) ).

tff(addAssignment_44583,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,21)
    <=> v68385(VarCurr,21) ) ).

tff(addAssignment_44582,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,21)
    <=> v68306(VarCurr,21) ) ).

tff(addAssignment_44581,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,21)
    <=> v67430(VarCurr,85) ) ).

tff(addAssignment_44580,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,85)
    <=> v67432(VarCurr,85) ) ).

tff(addAssignment_44579,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,85)
    <=> v67434(VarCurr,85) ) ).

tff(addAssignment_44578,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,85)
    <=> v68308(VarCurr,21) ) ).

tff(addAssignment_44577,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,21)
    <=> v68310(VarCurr,21) ) ).

tff(addAssignment_44576,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,21)
    <=> v68368(VarCurr,21) ) ).

tff(addAssignment_44575,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,21)
    <=> v68366(VarCurr,21) ) ).

tff(addAssignment_44574,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,21)
    <=> v68367(VarCurr,21) ) ).

tff(addAssignment_44573,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,21)
    <=> v68361(VarCurr,21) ) ).

tff(addAssignment_44572,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,21)
    <=> v68362(VarCurr,21) ) ).

tff(addAssignment_44571,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,21)
    <=> v68357(VarCurr,21) ) ).

tff(addAssignment_44570,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,21)
    <=> $false ) ).

tff(addAssignment_44569,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,21)
    <=> v68300(VarCurr,21) ) ).

tff(addAssignment_44568,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,21)
    <=> v68301(VarCurr,21) ) ).

tff(addAssignment_44567,axiom,
    ! [VarCurr: state_type] :
      ( v70977(VarCurr)
    <=> v70979(VarCurr) ) ).

tff(addAssignment_44566,axiom,
    ! [VarCurr: state_type] :
      ( v70979(VarCurr)
    <=> v67349(VarCurr,77) ) ).

tff(addAssignment_44565,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,77)
    <=> v68249(VarCurr,13) ) ).

tff(addAssignment_44564,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,13)
    <=> v68251(VarCurr,13) ) ).

tff(addAssignment_44563,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,13)
    <=> v68253(VarCurr,13) ) ).

tff(addAssignment_44562,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,13)
    <=> v68255(VarCurr,13) ) ).

tff(addAssignment_44561,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,13)
    <=> v67359(VarCurr,77) ) ).

tff(addAssignment_44560,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,77)
    <=> v67580(VarCurr,77) ) ).

tff(addAssignment_44559,axiom,
    ! [VarCurr: state_type] :
      ( v67593(VarCurr,1)
    <=> v68258(VarCurr,13) ) ).

tff(addAssignment_44558,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,13)
    <=> v68260(VarCurr,13) ) ).

tff(addAssignment_44557,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,13)
    <=> v70981(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70982(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70981(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_874,axiom,
    ! [VarNext: state_type] :
      ( v70982(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70981(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70982(VarNext)
      <=> v70983(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70983(VarNext)
      <=> ( v70985(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70985(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44556,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,13)
    <=> v68284(VarCurr,13) ) ).

tff(addAssignment_44555,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,13)
    <=> v67391(VarCurr,77) ) ).

tff(addAssignment_44554,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,77)
    <=> v70009(VarCurr,1) ) ).

tff(addAssignment_44553,axiom,
    ! [VarCurr: state_type] :
      ( v70009(VarCurr,1)
    <=> v70011(VarCurr,1) ) ).

tff(addAssignment_44552,axiom,
    ! [VarCurr: state_type] :
      ( v70011(VarCurr,1)
    <=> v70028(VarCurr,1) ) ).

tff(addAssignment_44551,axiom,
    ! [VarCurr: state_type] :
      ( v70021(VarCurr,1)
    <=> v70023(VarCurr,1) ) ).

tff(addAssignment_44550,axiom,
    ! [VarCurr: state_type] :
      ( v70023(VarCurr,1)
    <=> v67401(VarCurr,77) ) ).

tff(addAssignment_44549,axiom,
    ! [VarCurr: state_type] :
      ( v70013(VarCurr,1)
    <=> v70015(VarCurr,1) ) ).

tff(addAssignment_44548,axiom,
    ! [VarCurr: state_type] :
      ( v70015(VarCurr,1)
    <=> v67401(VarCurr,81) ) ).

tff(addAssignment_44547,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,81)
    <=> v68294(VarCurr,17) ) ).

tff(addAssignment_44546,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,17)
    <=> v68296(VarCurr,17) ) ).

tff(addAssignment_44545,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,17)
    <=> v68385(VarCurr,17) ) ).

tff(addAssignment_44544,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,17)
    <=> v68306(VarCurr,17) ) ).

tff(addAssignment_44543,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,17)
    <=> v67430(VarCurr,81) ) ).

tff(addAssignment_44542,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,81)
    <=> v67432(VarCurr,81) ) ).

tff(addAssignment_44541,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,81)
    <=> v67434(VarCurr,81) ) ).

tff(addAssignment_44540,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,81)
    <=> v68308(VarCurr,17) ) ).

tff(addAssignment_44539,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,17)
    <=> v68310(VarCurr,17) ) ).

tff(addAssignment_44538,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,17)
    <=> v68368(VarCurr,17) ) ).

tff(addAssignment_44537,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,17)
    <=> v68366(VarCurr,17) ) ).

tff(addAssignment_44536,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,17)
    <=> v68367(VarCurr,17) ) ).

tff(addAssignment_44535,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,17)
    <=> v68361(VarCurr,17) ) ).

tff(addAssignment_44534,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,17)
    <=> v68362(VarCurr,17) ) ).

tff(addAssignment_44533,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,17)
    <=> v68357(VarCurr,17) ) ).

tff(addAssignment_44532,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,17)
    <=> $false ) ).

tff(addAssignment_44531,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,17)
    <=> v68300(VarCurr,17) ) ).

tff(addAssignment_44530,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,17)
    <=> v68301(VarCurr,17) ) ).

tff(addAssignment_44529,axiom,
    ! [VarCurr: state_type] :
      ( v70965(VarCurr)
    <=> v70967(VarCurr) ) ).

tff(addAssignment_44528,axiom,
    ! [VarCurr: state_type] :
      ( v70967(VarCurr)
    <=> v67349(VarCurr,73) ) ).

tff(addAssignment_44527,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,73)
    <=> v68249(VarCurr,9) ) ).

tff(addAssignment_44526,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,9)
    <=> v68251(VarCurr,9) ) ).

tff(addAssignment_44525,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,9)
    <=> v68253(VarCurr,9) ) ).

tff(addAssignment_44524,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,9)
    <=> v68255(VarCurr,9) ) ).

tff(addAssignment_44523,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,9)
    <=> v67359(VarCurr,73) ) ).

tff(addAssignment_44522,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,73)
    <=> v67580(VarCurr,73) ) ).

tff(addAssignment_44521,axiom,
    ! [VarCurr: state_type] :
      ( v67594(VarCurr,1)
    <=> v68258(VarCurr,9) ) ).

tff(addAssignment_44520,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,9)
    <=> v68260(VarCurr,9) ) ).

tff(addAssignment_44519,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,9)
    <=> v70969(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70970(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70969(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_873,axiom,
    ! [VarNext: state_type] :
      ( v70970(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70969(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70970(VarNext)
      <=> v70971(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70971(VarNext)
      <=> ( v70973(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70973(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44518,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,9)
    <=> v68284(VarCurr,9) ) ).

tff(addAssignment_44517,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,9)
    <=> v67391(VarCurr,73) ) ).

tff(addAssignment_44516,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,73)
    <=> v69969(VarCurr,1) ) ).

tff(addAssignment_44515,axiom,
    ! [VarCurr: state_type] :
      ( v69969(VarCurr,1)
    <=> v69971(VarCurr,1) ) ).

tff(addAssignment_44514,axiom,
    ! [VarCurr: state_type] :
      ( v69971(VarCurr,1)
    <=> v69988(VarCurr,1) ) ).

tff(addAssignment_44513,axiom,
    ! [VarCurr: state_type] :
      ( v69981(VarCurr,1)
    <=> v69983(VarCurr,1) ) ).

tff(addAssignment_44512,axiom,
    ! [VarCurr: state_type] :
      ( v69983(VarCurr,1)
    <=> v67401(VarCurr,73) ) ).

tff(addAssignment_44511,axiom,
    ! [VarCurr: state_type] :
      ( v69973(VarCurr,1)
    <=> v69975(VarCurr,1) ) ).

tff(addAssignment_44510,axiom,
    ! [VarCurr: state_type] :
      ( v69975(VarCurr,1)
    <=> v67401(VarCurr,77) ) ).

tff(addAssignment_44509,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,77)
    <=> v68294(VarCurr,13) ) ).

tff(addAssignment_44508,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,13)
    <=> v68296(VarCurr,13) ) ).

tff(addAssignment_44507,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,13)
    <=> v68385(VarCurr,13) ) ).

tff(addAssignment_44506,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,13)
    <=> v68306(VarCurr,13) ) ).

tff(addAssignment_44505,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,13)
    <=> v67430(VarCurr,77) ) ).

tff(addAssignment_44504,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,77)
    <=> v67432(VarCurr,77) ) ).

tff(addAssignment_44503,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,77)
    <=> v67434(VarCurr,77) ) ).

tff(addAssignment_44502,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,77)
    <=> v68308(VarCurr,13) ) ).

tff(addAssignment_44501,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,13)
    <=> v68310(VarCurr,13) ) ).

tff(addAssignment_44500,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,13)
    <=> v68368(VarCurr,13) ) ).

tff(addAssignment_44499,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,13)
    <=> v68366(VarCurr,13) ) ).

tff(addAssignment_44498,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,13)
    <=> v68367(VarCurr,13) ) ).

tff(addAssignment_44497,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,13)
    <=> v68361(VarCurr,13) ) ).

tff(addAssignment_44496,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,13)
    <=> v68362(VarCurr,13) ) ).

tff(addAssignment_44495,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,13)
    <=> v68357(VarCurr,13) ) ).

tff(addAssignment_44494,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_44493,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,13)
    <=> v68300(VarCurr,13) ) ).

tff(addAssignment_44492,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,13)
    <=> v68301(VarCurr,13) ) ).

tff(addAssignment_44491,axiom,
    ! [VarCurr: state_type] :
      ( v70907(VarCurr)
    <=> v70909(VarCurr) ) ).

tff(addAssignment_44490,axiom,
    ! [VarCurr: state_type] :
      ( v70909(VarCurr)
    <=> v70911(VarCurr) ) ).

tff(addAssignment_44489,axiom,
    ! [VarCurr: state_type] :
      ( v70911(VarCurr)
    <=> v70913(VarCurr) ) ).

tff(addAssignment_44488,axiom,
    ! [VarCurr: state_type] :
      ( v70913(VarCurr)
    <=> v70915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6571,axiom,
    ! [VarCurr: state_type] :
      ( v70915(VarCurr)
    <=> ( v70953(VarCurr)
      <~> v70941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6570,axiom,
    ! [VarCurr: state_type] :
      ( v70953(VarCurr)
    <=> ( v70917(VarCurr)
      <~> v70929(VarCurr) ) ) ).

tff(addAssignment_44487,axiom,
    ! [VarCurr: state_type] :
      ( v70941(VarCurr)
    <=> v70943(VarCurr) ) ).

tff(addAssignment_44486,axiom,
    ! [VarCurr: state_type] :
      ( v70943(VarCurr)
    <=> v67349(VarCurr,69) ) ).

tff(addAssignment_44485,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,69)
    <=> v68249(VarCurr,5) ) ).

tff(addAssignment_44484,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,5)
    <=> v68251(VarCurr,5) ) ).

tff(addAssignment_44483,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,5)
    <=> v68253(VarCurr,5) ) ).

tff(addAssignment_44482,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,5)
    <=> v68255(VarCurr,5) ) ).

tff(addAssignment_44481,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,5)
    <=> v67359(VarCurr,69) ) ).

tff(addAssignment_44480,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,69)
    <=> v67580(VarCurr,69) ) ).

tff(addAssignment_44479,axiom,
    ! [VarCurr: state_type] :
      ( v67595(VarCurr,1)
    <=> v68258(VarCurr,5) ) ).

tff(addAssignment_44478,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,5)
    <=> v68260(VarCurr,5) ) ).

tff(addAssignment_44477,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,5)
    <=> v70945(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70946(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70945(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_872,axiom,
    ! [VarNext: state_type] :
      ( v70946(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70945(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70946(VarNext)
      <=> v70947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70947(VarNext)
      <=> ( v70949(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70949(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44476,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,5)
    <=> v68284(VarCurr,5) ) ).

tff(addAssignment_44475,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,5)
    <=> v67391(VarCurr,69) ) ).

tff(addAssignment_44474,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,69)
    <=> v69917(VarCurr,1) ) ).

tff(addAssignment_44473,axiom,
    ! [VarCurr: state_type] :
      ( v69917(VarCurr,1)
    <=> v69919(VarCurr,1) ) ).

tff(addAssignment_44472,axiom,
    ! [VarCurr: state_type] :
      ( v69919(VarCurr,1)
    <=> v69936(VarCurr,1) ) ).

tff(addAssignment_44471,axiom,
    ! [VarCurr: state_type] :
      ( v69929(VarCurr,1)
    <=> v69931(VarCurr,1) ) ).

tff(addAssignment_44470,axiom,
    ! [VarCurr: state_type] :
      ( v69931(VarCurr,1)
    <=> v67401(VarCurr,69) ) ).

tff(addAssignment_44469,axiom,
    ! [VarCurr: state_type] :
      ( v69921(VarCurr,1)
    <=> v69923(VarCurr,1) ) ).

tff(addAssignment_44468,axiom,
    ! [VarCurr: state_type] :
      ( v69923(VarCurr,1)
    <=> v67401(VarCurr,73) ) ).

tff(addAssignment_44467,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,73)
    <=> v68294(VarCurr,9) ) ).

tff(addAssignment_44466,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,9)
    <=> v68296(VarCurr,9) ) ).

tff(addAssignment_44465,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,9)
    <=> v68385(VarCurr,9) ) ).

tff(addAssignment_44464,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,9)
    <=> v68306(VarCurr,9) ) ).

tff(addAssignment_44463,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,9)
    <=> v67430(VarCurr,73) ) ).

tff(addAssignment_44462,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,73)
    <=> v67432(VarCurr,73) ) ).

tff(addAssignment_44461,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,73)
    <=> v67434(VarCurr,73) ) ).

tff(addAssignment_44460,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,73)
    <=> v68308(VarCurr,9) ) ).

tff(addAssignment_44459,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,9)
    <=> v68310(VarCurr,9) ) ).

tff(addAssignment_44458,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,9)
    <=> v68368(VarCurr,9) ) ).

tff(addAssignment_44457,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,9)
    <=> v68366(VarCurr,9) ) ).

tff(addAssignment_44456,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,9)
    <=> v68367(VarCurr,9) ) ).

tff(addAssignment_44455,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,9)
    <=> v68361(VarCurr,9) ) ).

tff(addAssignment_44454,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,9)
    <=> v68362(VarCurr,9) ) ).

tff(addAssignment_44453,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,9)
    <=> v68357(VarCurr,9) ) ).

tff(addAssignment_44452,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_44451,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,9)
    <=> v68300(VarCurr,9) ) ).

tff(addAssignment_44450,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,9)
    <=> v68301(VarCurr,9) ) ).

tff(addAssignment_44449,axiom,
    ! [VarCurr: state_type] :
      ( v70929(VarCurr)
    <=> v70931(VarCurr) ) ).

tff(addAssignment_44448,axiom,
    ! [VarCurr: state_type] :
      ( v70931(VarCurr)
    <=> v67349(VarCurr,65) ) ).

tff(addAssignment_44447,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,65)
    <=> v68249(VarCurr,1) ) ).

tff(addAssignment_44446,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,1)
    <=> v68251(VarCurr,1) ) ).

tff(addAssignment_44445,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,1)
    <=> v68253(VarCurr,1) ) ).

tff(addAssignment_44444,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,1)
    <=> v68255(VarCurr,1) ) ).

tff(addAssignment_44443,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,1)
    <=> v67359(VarCurr,65) ) ).

tff(addAssignment_44442,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,65)
    <=> v67580(VarCurr,65) ) ).

tff(addAssignment_44441,axiom,
    ! [VarCurr: state_type] :
      ( v67596(VarCurr,1)
    <=> v68258(VarCurr,1) ) ).

tff(addAssignment_44440,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,1)
    <=> v68260(VarCurr,1) ) ).

tff(addAssignment_44439,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,1)
    <=> v70933(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70934(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70933(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_871,axiom,
    ! [VarNext: state_type] :
      ( v70934(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70933(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70934(VarNext)
      <=> v70935(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70935(VarNext)
      <=> ( v70937(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70937(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44438,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,1)
    <=> v68284(VarCurr,1) ) ).

tff(addAssignment_44437,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,1)
    <=> v67391(VarCurr,65) ) ).

tff(addAssignment_44436,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,65)
    <=> v69877(VarCurr,1) ) ).

tff(addAssignment_44435,axiom,
    ! [VarCurr: state_type] :
      ( v69877(VarCurr,1)
    <=> v69879(VarCurr,1) ) ).

tff(addAssignment_44434,axiom,
    ! [VarCurr: state_type] :
      ( v69879(VarCurr,1)
    <=> v69896(VarCurr,1) ) ).

tff(addAssignment_44433,axiom,
    ! [VarCurr: state_type] :
      ( v69889(VarCurr,1)
    <=> v69891(VarCurr,1) ) ).

tff(addAssignment_44432,axiom,
    ! [VarCurr: state_type] :
      ( v69891(VarCurr,1)
    <=> v67401(VarCurr,65) ) ).

tff(addAssignment_44431,axiom,
    ! [VarCurr: state_type] :
      ( v69881(VarCurr,1)
    <=> v69883(VarCurr,1) ) ).

tff(addAssignment_44430,axiom,
    ! [VarCurr: state_type] :
      ( v69883(VarCurr,1)
    <=> v67401(VarCurr,69) ) ).

tff(addAssignment_44429,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,69)
    <=> v68294(VarCurr,5) ) ).

tff(addAssignment_44428,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,5)
    <=> v68296(VarCurr,5) ) ).

tff(addAssignment_44427,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,5)
    <=> v68385(VarCurr,5) ) ).

tff(addAssignment_44426,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,5)
    <=> v68306(VarCurr,5) ) ).

tff(addAssignment_44425,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,5)
    <=> v67430(VarCurr,69) ) ).

tff(addAssignment_44424,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,69)
    <=> v67432(VarCurr,69) ) ).

tff(addAssignment_44423,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,69)
    <=> v67434(VarCurr,69) ) ).

tff(addAssignment_44422,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,69)
    <=> v68308(VarCurr,5) ) ).

tff(addAssignment_44421,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,5)
    <=> v68310(VarCurr,5) ) ).

tff(addAssignment_44420,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,5)
    <=> v68368(VarCurr,5) ) ).

tff(addAssignment_44419,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,5)
    <=> v68366(VarCurr,5) ) ).

tff(addAssignment_44418,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,5)
    <=> v68367(VarCurr,5) ) ).

tff(addAssignment_44417,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,69)
    <=> v67496(VarCurr,69) ) ).

tff(addAssignment_44416,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,141)
    <=> v33839(VarCurr,141) ) ).

tff(addAssignment_44415,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,141)
    <=> v33841(VarCurr,141) ) ).

tff(addAssignment_44414,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,141)
    <=> v26555(VarCurr,9) ) ).

tff(addAssignment_44413,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,5)
    <=> v68361(VarCurr,5) ) ).

tff(addAssignment_44412,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,5)
    <=> v68362(VarCurr,5) ) ).

tff(addAssignment_44411,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,5)
    <=> v68357(VarCurr,5) ) ).

tff(addAssignment_44410,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_44409,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,5)
    <=> v68300(VarCurr,5) ) ).

tff(addAssignment_44408,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,5)
    <=> v68301(VarCurr,5) ) ).

tff(addAssignment_44407,axiom,
    ! [VarCurr: state_type] :
      ( v70917(VarCurr)
    <=> v70919(VarCurr) ) ).

tff(addAssignment_44406,axiom,
    ! [VarCurr: state_type] :
      ( v70919(VarCurr)
    <=> v67349(VarCurr,61) ) ).

tff(addAssignment_44405,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,61)
    <=> v67351(VarCurr,61) ) ).

tff(addAssignment_44404,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,61)
    <=> v67353(VarCurr,61) ) ).

tff(addAssignment_44403,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,61)
    <=> v67355(VarCurr,61) ) ).

tff(addAssignment_44402,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,61)
    <=> v67357(VarCurr,61) ) ).

tff(addAssignment_44401,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,61)
    <=> v67359(VarCurr,61) ) ).

tff(addAssignment_44400,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,61)
    <=> v67580(VarCurr,61) ) ).

tff(addAssignment_44399,axiom,
    ! [VarCurr: state_type] :
      ( v67597(VarCurr,1)
    <=> v67363(VarCurr,61) ) ).

tff(addAssignment_44398,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,61)
    <=> v67365(VarCurr,61) ) ).

tff(addAssignment_44397,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,61)
    <=> v70921(VarNext,61) ) ).

tff(addCaseBooleanConditionEqualRanges1_870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70922(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70921(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_870,axiom,
    ! [VarNext: state_type] :
      ( v70922(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70921(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70922(VarNext)
      <=> v70923(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70923(VarNext)
      <=> ( v70925(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70925(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_44396,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,61)
    <=> v67389(VarCurr,61) ) ).

tff(addAssignment_44395,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,61)
    <=> v67391(VarCurr,61) ) ).

tff(addAssignment_44394,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,61)
    <=> v69837(VarCurr,1) ) ).

tff(addAssignment_44393,axiom,
    ! [VarCurr: state_type] :
      ( v69837(VarCurr,1)
    <=> v69839(VarCurr,1) ) ).

tff(addAssignment_44392,axiom,
    ! [VarCurr: state_type] :
      ( v69839(VarCurr,1)
    <=> v69856(VarCurr,1) ) ).

tff(addAssignment_44391,axiom,
    ! [VarCurr: state_type] :
      ( v69849(VarCurr,1)
    <=> v69851(VarCurr,1) ) ).

tff(addAssignment_44390,axiom,
    ! [VarCurr: state_type] :
      ( v69851(VarCurr,1)
    <=> v67401(VarCurr,61) ) ).

tff(addAssignment_44389,axiom,
    ! [VarCurr: state_type] :
      ( v69841(VarCurr,1)
    <=> v69843(VarCurr,1) ) ).

tff(addAssignment_44388,axiom,
    ! [VarCurr: state_type] :
      ( v69843(VarCurr,1)
    <=> v67401(VarCurr,65) ) ).

tff(addAssignment_44387,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,65)
    <=> v68294(VarCurr,1) ) ).

tff(addAssignment_44386,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,1)
    <=> v68296(VarCurr,1) ) ).

tff(addAssignment_44385,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,1)
    <=> v68385(VarCurr,1) ) ).

tff(addAssignment_44384,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,1)
    <=> v68306(VarCurr,1) ) ).

tff(addAssignment_44383,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,1)
    <=> v67430(VarCurr,65) ) ).

tff(addAssignment_44382,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,65)
    <=> v67432(VarCurr,65) ) ).

tff(addAssignment_44381,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,65)
    <=> v67434(VarCurr,65) ) ).

tff(addAssignment_44380,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,65)
    <=> v68308(VarCurr,1) ) ).

tff(addAssignment_44379,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,1)
    <=> v68310(VarCurr,1) ) ).

tff(addAssignment_44378,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,1)
    <=> v68368(VarCurr,1) ) ).

tff(addAssignment_44377,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,1)
    <=> v68366(VarCurr,1) ) ).

tff(addAssignment_44376,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,1)
    <=> v68367(VarCurr,1) ) ).

tff(addAssignment_44375,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,65)
    <=> v67496(VarCurr,65) ) ).

tff(addAssignment_44374,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,131)
    <=> v33839(VarCurr,131) ) ).

tff(addAssignment_44373,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,131)
    <=> v33841(VarCurr,131) ) ).

tff(addAssignment_44372,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,131)
    <=> v25005(VarCurr,11) ) ).

tff(addAssignment_44371,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,1)
    <=> v68361(VarCurr,1) ) ).

tff(addAssignment_44370,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,1)
    <=> v68362(VarCurr,1) ) ).

tff(addAssignment_44369,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,1)
    <=> v68357(VarCurr,1) ) ).

tff(addAssignment_44368,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_44367,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,1)
    <=> v68300(VarCurr,1) ) ).

tff(addAssignment_44366,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,1)
    <=> v68301(VarCurr,1) ) ).

tff(addAssignment_44365,axiom,
    ! [VarCurr: state_type] :
      ( v69791(VarCurr)
    <=> v69793(VarCurr) ) ).

tff(addAssignment_44364,axiom,
    ! [VarCurr: state_type] :
      ( v69793(VarCurr)
    <=> v69795(VarCurr) ) ).

tff(addAssignment_44363,axiom,
    ! [VarCurr: state_type] :
      ( v69795(VarCurr)
    <=> v69797(VarCurr) ) ).

tff(addAssignment_44362,axiom,
    ! [VarCurr: state_type] :
      ( v69797(VarCurr)
    <=> v69799(VarCurr) ) ).

tff(writeUnaryOperator_3402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v69799(VarCurr)
    <=> v70877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6563,axiom,
    ! [VarCurr: state_type] :
      ( v70877(VarCurr)
    <=> ( v69801(VarCurr)
        | v70567(VarCurr) ) ) ).

tff(addAssignment_44361,axiom,
    ! [VarCurr: state_type] :
      ( v70567(VarCurr)
    <=> v70569(VarCurr) ) ).

tff(addAssignment_44360,axiom,
    ! [VarCurr: state_type] :
      ( v70569(VarCurr)
    <=> v69805(VarCurr,2) ) ).

tff(addAssignment_44359,axiom,
    ! [VarCurr: state_type] :
      ( v69805(VarCurr,2)
    <=> v67309(VarCurr,6) ) ).

tff(addAssignment_44358,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,6)
    <=> v67311(VarCurr,6) ) ).

tff(addAssignment_44357,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,6)
    <=> v67313(VarCurr,6) ) ).

tff(addAssignment_44356,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,6)
    <=> v67315(VarCurr,6) ) ).

tff(addAssignment_44355,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,6)
    <=> v67317(VarCurr,6) ) ).

tff(addAssignment_44354,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,6)
    <=> v68771(VarCurr,6) ) ).

tff(addAssignment_44353,axiom,
    ! [VarCurr: state_type] :
      ( v68773(VarCurr,2)
    <=> v70571(VarCurr) ) ).

tff(addAssignment_44352,axiom,
    ! [VarCurr: state_type] :
      ( v70571(VarCurr)
    <=> v70573(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6562,axiom,
    ! [VarCurr: state_type] :
      ( v70573(VarCurr)
    <=> ( v70875(VarCurr)
      <~> v70863(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6561,axiom,
    ! [VarCurr: state_type] :
      ( v70875(VarCurr)
    <=> ( v70575(VarCurr)
      <~> v70731(VarCurr) ) ) ).

tff(addAssignment_44351,axiom,
    ! [VarCurr: state_type] :
      ( v70863(VarCurr)
    <=> v70865(VarCurr) ) ).

tff(addAssignment_44350,axiom,
    ! [VarCurr: state_type] :
      ( v70865(VarCurr)
    <=> v70526(VarCurr,2) ) ).

tff(addAssignment_44349,axiom,
    ! [VarCurr: state_type] :
      ( v70526(VarCurr,2)
    <=> v70528(VarCurr,2) ) ).

tff(addAssignment_44348,axiom,
    ! [VarCurr: state_type] :
      ( v70528(VarCurr,2)
    <=> v68595(VarCurr,7) ) ).

tff(addAssignment_44347,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,7)
    <=> v68597(VarCurr,7) ) ).

tff(addAssignment_44346,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,7)
    <=> v70867(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70868(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v70867(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_869,axiom,
    ! [VarNext: state_type] :
      ( v70868(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v70867(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70868(VarNext)
      <=> v70869(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70869(VarNext)
      <=> ( v70871(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70871(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_44345,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,7)
    <=> v68621(VarCurr,7) ) ).

tff(addAssignment_44344,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,7)
    <=> v68624(VarCurr,7) ) ).

tff(addAssignment_44343,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,6)
    <=> v70530(VarCurr,2) ) ).

tff(addAssignment_44342,axiom,
    ! [VarCurr: state_type] :
      ( v70530(VarCurr,2)
    <=> v70532(VarCurr,2) ) ).

tff(addAssignment_44341,axiom,
    ! [VarCurr: state_type] :
      ( v70532(VarCurr,2)
    <=> v70549(VarCurr,2) ) ).

tff(addAssignment_44340,axiom,
    ! [VarCurr: state_type] :
      ( v70542(VarCurr,2)
    <=> v70544(VarCurr,2) ) ).

tff(addAssignment_44339,axiom,
    ! [VarCurr: state_type] :
      ( v70544(VarCurr,2)
    <=> v68455(VarCurr,6) ) ).

tff(addAssignment_44338,axiom,
    ! [VarCurr: state_type] :
      ( v70534(VarCurr,2)
    <=> v70536(VarCurr,2) ) ).

tff(addAssignment_44337,axiom,
    ! [VarCurr: state_type] :
      ( v70536(VarCurr,2)
    <=> v68455(VarCurr,2) ) ).

tff(addAssignment_44336,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,2)
    <=> v68457(VarCurr,2) ) ).

tff(addAssignment_44335,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,2)
    <=> v68459(VarCurr,2) ) ).

tff(addAssignment_44334,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,2)
    <=> v68548(VarCurr,2) ) ).

tff(addAssignment_44333,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,2)
    <=> v68469(VarCurr,2) ) ).

tff(addAssignment_44332,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,2)
    <=> v68471(VarCurr,2) ) ).

tff(addAssignment_44331,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,2)
    <=> v67432(VarCurr,130) ) ).

tff(addAssignment_44330,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,130)
    <=> v67434(VarCurr,130) ) ).

tff(addAssignment_44329,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,130)
    <=> v68473(VarCurr,2) ) ).

tff(addAssignment_44328,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,2)
    <=> v68475(VarCurr,2) ) ).

tff(addAssignment_44327,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,2)
    <=> v68531(VarCurr,2) ) ).

tff(addAssignment_44326,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,2)
    <=> v68530(VarCurr,2) ) ).

tff(addAssignment_44325,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,2)
    <=> v6234(VarCurr,58) ) ).

tff(addAssignment_44324,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,2)
    <=> v68526(VarCurr,2) ) ).

tff(addAssignment_44323,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,2)
    <=> v53217(VarCurr,58) ) ).

tff(addAssignment_44322,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,2)
    <=> v68522(VarCurr,2) ) ).

tff(addAssignment_44321,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_44320,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,2)
    <=> v68463(VarCurr,2) ) ).

tff(addAssignment_44319,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,2)
    <=> v68464(VarCurr,2) ) ).

tff(addAssignment_44318,axiom,
    ! [VarCurr: state_type] :
      ( v70731(VarCurr)
    <=> v70733(VarCurr) ) ).

tff(addAssignment_44317,axiom,
    ! [VarCurr: state_type] :
      ( v70733(VarCurr)
    <=> v70735(VarCurr) ) ).

tff(addAssignment_44316,axiom,
    ! [VarCurr: state_type] :
      ( v70735(VarCurr)
    <=> v70737(VarCurr) ) ).

tff(addAssignment_44315,axiom,
    ! [VarCurr: state_type] :
      ( v70737(VarCurr)
    <=> v70739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6558,axiom,
    ! [VarCurr: state_type] :
      ( v70739(VarCurr)
    <=> ( v70861(VarCurr)
      <~> v70837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6557,axiom,
    ! [VarCurr: state_type] :
      ( v70861(VarCurr)
    <=> ( v70741(VarCurr)
      <~> v70789(VarCurr) ) ) ).

tff(addAssignment_44314,axiom,
    ! [VarCurr: state_type] :
      ( v70837(VarCurr)
    <=> v70839(VarCurr) ) ).

tff(addAssignment_44313,axiom,
    ! [VarCurr: state_type] :
      ( v70839(VarCurr)
    <=> v70841(VarCurr) ) ).

tff(addAssignment_44312,axiom,
    ! [VarCurr: state_type] :
      ( v70841(VarCurr)
    <=> v70843(VarCurr) ) ).

tff(addAssignment_44311,axiom,
    ! [VarCurr: state_type] :
      ( v70843(VarCurr)
    <=> v70845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6556,axiom,
    ! [VarCurr: state_type] :
      ( v70845(VarCurr)
    <=> ( v70859(VarCurr)
      <~> v70855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6555,axiom,
    ! [VarCurr: state_type] :
      ( v70859(VarCurr)
    <=> ( v70847(VarCurr)
      <~> v70851(VarCurr) ) ) ).

tff(addAssignment_44310,axiom,
    ! [VarCurr: state_type] :
      ( v70855(VarCurr)
    <=> v70857(VarCurr) ) ).

tff(addAssignment_44309,axiom,
    ! [VarCurr: state_type] :
      ( v70857(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_44308,axiom,
    ! [VarCurr: state_type] :
      ( v70851(VarCurr)
    <=> v70853(VarCurr) ) ).

tff(addAssignment_44307,axiom,
    ! [VarCurr: state_type] :
      ( v70853(VarCurr)
    <=> v67349(VarCurr,126) ) ).

tff(addAssignment_44306,axiom,
    ! [VarCurr: state_type] :
      ( v70847(VarCurr)
    <=> v70849(VarCurr) ) ).

tff(addAssignment_44305,axiom,
    ! [VarCurr: state_type] :
      ( v70849(VarCurr)
    <=> v67349(VarCurr,122) ) ).

tff(addAssignment_44304,axiom,
    ! [VarCurr: state_type] :
      ( v70789(VarCurr)
    <=> v70791(VarCurr) ) ).

tff(addAssignment_44303,axiom,
    ! [VarCurr: state_type] :
      ( v70791(VarCurr)
    <=> v70793(VarCurr) ) ).

tff(addAssignment_44302,axiom,
    ! [VarCurr: state_type] :
      ( v70793(VarCurr)
    <=> v70795(VarCurr) ) ).

tff(addAssignment_44301,axiom,
    ! [VarCurr: state_type] :
      ( v70795(VarCurr)
    <=> v70797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6554,axiom,
    ! [VarCurr: state_type] :
      ( v70797(VarCurr)
    <=> ( v70835(VarCurr)
      <~> v70823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6553,axiom,
    ! [VarCurr: state_type] :
      ( v70835(VarCurr)
    <=> ( v70799(VarCurr)
      <~> v70811(VarCurr) ) ) ).

tff(addAssignment_44300,axiom,
    ! [VarCurr: state_type] :
      ( v70823(VarCurr)
    <=> v70825(VarCurr) ) ).

tff(addAssignment_44299,axiom,
    ! [VarCurr: state_type] :
      ( v70825(VarCurr)
    <=> v67349(VarCurr,118) ) ).

tff(addAssignment_44298,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,118)
    <=> v68249(VarCurr,54) ) ).

tff(addAssignment_44297,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,54)
    <=> v68251(VarCurr,54) ) ).

tff(addAssignment_44296,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,54)
    <=> v68253(VarCurr,54) ) ).

tff(addAssignment_44295,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,54)
    <=> v68255(VarCurr,54) ) ).

tff(addAssignment_44294,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,54)
    <=> v67359(VarCurr,118) ) ).

tff(addAssignment_44293,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,118)
    <=> v67580(VarCurr,118) ) ).

tff(addAssignment_44292,axiom,
    ! [VarCurr: state_type] :
      ( v67583(VarCurr,2)
    <=> v68258(VarCurr,54) ) ).

tff(addAssignment_44291,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,54)
    <=> v68260(VarCurr,54) ) ).

tff(addAssignment_44290,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,54)
    <=> v70827(VarNext,54) ) ).

tff(addCaseBooleanConditionEqualRanges1_868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70828(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70827(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_868,axiom,
    ! [VarNext: state_type] :
      ( v70828(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70827(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70828(VarNext)
      <=> v70829(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70829(VarNext)
      <=> ( v70831(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70831(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44289,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,54)
    <=> v68284(VarCurr,54) ) ).

tff(addAssignment_44288,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,54)
    <=> v67391(VarCurr,118) ) ).

tff(addAssignment_44287,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,118)
    <=> v70457(VarCurr,2) ) ).

tff(addAssignment_44286,axiom,
    ! [VarCurr: state_type] :
      ( v70457(VarCurr,2)
    <=> v70459(VarCurr,2) ) ).

tff(addAssignment_44285,axiom,
    ! [VarCurr: state_type] :
      ( v70459(VarCurr,2)
    <=> v70476(VarCurr,2) ) ).

tff(addAssignment_44284,axiom,
    ! [VarCurr: state_type] :
      ( v70469(VarCurr,2)
    <=> v70471(VarCurr,2) ) ).

tff(addAssignment_44283,axiom,
    ! [VarCurr: state_type] :
      ( v70471(VarCurr,2)
    <=> v67401(VarCurr,118) ) ).

tff(addAssignment_44282,axiom,
    ! [VarCurr: state_type] :
      ( v70461(VarCurr,2)
    <=> v70463(VarCurr,2) ) ).

tff(addAssignment_44281,axiom,
    ! [VarCurr: state_type] :
      ( v70463(VarCurr,2)
    <=> v67401(VarCurr,122) ) ).

tff(addAssignment_44280,axiom,
    ! [VarCurr: state_type] :
      ( v70811(VarCurr)
    <=> v70813(VarCurr) ) ).

tff(addAssignment_44279,axiom,
    ! [VarCurr: state_type] :
      ( v70813(VarCurr)
    <=> v67349(VarCurr,114) ) ).

tff(addAssignment_44278,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,114)
    <=> v68249(VarCurr,50) ) ).

tff(addAssignment_44277,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,50)
    <=> v68251(VarCurr,50) ) ).

tff(addAssignment_44276,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,50)
    <=> v68253(VarCurr,50) ) ).

tff(addAssignment_44275,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,50)
    <=> v68255(VarCurr,50) ) ).

tff(addAssignment_44274,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,50)
    <=> v67359(VarCurr,114) ) ).

tff(addAssignment_44273,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,114)
    <=> v67580(VarCurr,114) ) ).

tff(addAssignment_44272,axiom,
    ! [VarCurr: state_type] :
      ( v67584(VarCurr,2)
    <=> v68258(VarCurr,50) ) ).

tff(addAssignment_44271,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,50)
    <=> v68260(VarCurr,50) ) ).

tff(addAssignment_44270,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,50)
    <=> v70815(VarNext,50) ) ).

tff(addCaseBooleanConditionEqualRanges1_867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70816(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70815(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_867,axiom,
    ! [VarNext: state_type] :
      ( v70816(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70815(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70816(VarNext)
      <=> v70817(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70817(VarNext)
      <=> ( v70819(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70819(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44269,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,50)
    <=> v68284(VarCurr,50) ) ).

tff(addAssignment_44268,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,50)
    <=> v67391(VarCurr,114) ) ).

tff(addAssignment_44267,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,114)
    <=> v70417(VarCurr,2) ) ).

tff(addAssignment_44266,axiom,
    ! [VarCurr: state_type] :
      ( v70417(VarCurr,2)
    <=> v70419(VarCurr,2) ) ).

tff(addAssignment_44265,axiom,
    ! [VarCurr: state_type] :
      ( v70419(VarCurr,2)
    <=> v70436(VarCurr,2) ) ).

tff(addAssignment_44264,axiom,
    ! [VarCurr: state_type] :
      ( v70429(VarCurr,2)
    <=> v70431(VarCurr,2) ) ).

tff(addAssignment_44263,axiom,
    ! [VarCurr: state_type] :
      ( v70431(VarCurr,2)
    <=> v67401(VarCurr,114) ) ).

tff(addAssignment_44262,axiom,
    ! [VarCurr: state_type] :
      ( v70421(VarCurr,2)
    <=> v70423(VarCurr,2) ) ).

tff(addAssignment_44261,axiom,
    ! [VarCurr: state_type] :
      ( v70423(VarCurr,2)
    <=> v67401(VarCurr,118) ) ).

tff(addAssignment_44260,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,118)
    <=> v68294(VarCurr,54) ) ).

tff(addAssignment_44259,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,54)
    <=> v68296(VarCurr,54) ) ).

tff(addAssignment_44258,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,54)
    <=> v68385(VarCurr,54) ) ).

tff(addAssignment_44257,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,54)
    <=> v68306(VarCurr,54) ) ).

tff(addAssignment_44256,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,54)
    <=> v67430(VarCurr,118) ) ).

tff(addAssignment_44255,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,118)
    <=> v67432(VarCurr,118) ) ).

tff(addAssignment_44254,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,118)
    <=> v67434(VarCurr,118) ) ).

tff(addAssignment_44253,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,118)
    <=> v68308(VarCurr,54) ) ).

tff(addAssignment_44252,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,54)
    <=> v68310(VarCurr,54) ) ).

tff(addAssignment_44251,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,54)
    <=> v68368(VarCurr,54) ) ).

tff(addAssignment_44250,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,54)
    <=> v68366(VarCurr,54) ) ).

tff(addAssignment_44249,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,54)
    <=> v68367(VarCurr,54) ) ).

tff(addAssignment_44248,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,54)
    <=> v68361(VarCurr,54) ) ).

tff(addAssignment_44247,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,54)
    <=> v68362(VarCurr,54) ) ).

tff(addAssignment_44246,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,54)
    <=> v68357(VarCurr,54) ) ).

tff(addAssignment_44245,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,54)
    <=> $false ) ).

tff(addAssignment_44244,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,54)
    <=> v68300(VarCurr,54) ) ).

tff(addAssignment_44243,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,54)
    <=> v68301(VarCurr,54) ) ).

tff(addAssignment_44242,axiom,
    ! [VarCurr: state_type] :
      ( v70799(VarCurr)
    <=> v70801(VarCurr) ) ).

tff(addAssignment_44241,axiom,
    ! [VarCurr: state_type] :
      ( v70801(VarCurr)
    <=> v67349(VarCurr,110) ) ).

tff(addAssignment_44240,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,110)
    <=> v68249(VarCurr,46) ) ).

tff(addAssignment_44239,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,46)
    <=> v68251(VarCurr,46) ) ).

tff(addAssignment_44238,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,46)
    <=> v68253(VarCurr,46) ) ).

tff(addAssignment_44237,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,46)
    <=> v68255(VarCurr,46) ) ).

tff(addAssignment_44236,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,46)
    <=> v67359(VarCurr,110) ) ).

tff(addAssignment_44235,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,110)
    <=> v67580(VarCurr,110) ) ).

tff(addAssignment_44234,axiom,
    ! [VarCurr: state_type] :
      ( v67585(VarCurr,2)
    <=> v68258(VarCurr,46) ) ).

tff(addAssignment_44233,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,46)
    <=> v68260(VarCurr,46) ) ).

tff(addAssignment_44232,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,46)
    <=> v70803(VarNext,46) ) ).

tff(addCaseBooleanConditionEqualRanges1_866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70804(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70803(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_866,axiom,
    ! [VarNext: state_type] :
      ( v70804(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70803(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70804(VarNext)
      <=> v70805(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70805(VarNext)
      <=> ( v70807(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70807(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44231,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,46)
    <=> v68284(VarCurr,46) ) ).

tff(addAssignment_44230,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,46)
    <=> v67391(VarCurr,110) ) ).

tff(addAssignment_44229,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,110)
    <=> v70377(VarCurr,2) ) ).

tff(addAssignment_44228,axiom,
    ! [VarCurr: state_type] :
      ( v70377(VarCurr,2)
    <=> v70379(VarCurr,2) ) ).

tff(addAssignment_44227,axiom,
    ! [VarCurr: state_type] :
      ( v70379(VarCurr,2)
    <=> v70396(VarCurr,2) ) ).

tff(addAssignment_44226,axiom,
    ! [VarCurr: state_type] :
      ( v70389(VarCurr,2)
    <=> v70391(VarCurr,2) ) ).

tff(addAssignment_44225,axiom,
    ! [VarCurr: state_type] :
      ( v70391(VarCurr,2)
    <=> v67401(VarCurr,110) ) ).

tff(addAssignment_44224,axiom,
    ! [VarCurr: state_type] :
      ( v70381(VarCurr,2)
    <=> v70383(VarCurr,2) ) ).

tff(addAssignment_44223,axiom,
    ! [VarCurr: state_type] :
      ( v70383(VarCurr,2)
    <=> v67401(VarCurr,114) ) ).

tff(addAssignment_44222,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,114)
    <=> v68294(VarCurr,50) ) ).

tff(addAssignment_44221,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,50)
    <=> v68296(VarCurr,50) ) ).

tff(addAssignment_44220,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,50)
    <=> v68385(VarCurr,50) ) ).

tff(addAssignment_44219,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,50)
    <=> v68306(VarCurr,50) ) ).

tff(addAssignment_44218,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,50)
    <=> v67430(VarCurr,114) ) ).

tff(addAssignment_44217,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,114)
    <=> v67432(VarCurr,114) ) ).

tff(addAssignment_44216,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,114)
    <=> v67434(VarCurr,114) ) ).

tff(addAssignment_44215,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,114)
    <=> v68308(VarCurr,50) ) ).

tff(addAssignment_44214,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,50)
    <=> v68310(VarCurr,50) ) ).

tff(addAssignment_44213,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,50)
    <=> v68368(VarCurr,50) ) ).

tff(addAssignment_44212,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,50)
    <=> v68366(VarCurr,50) ) ).

tff(addAssignment_44211,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,50)
    <=> v68367(VarCurr,50) ) ).

tff(addAssignment_44210,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,50)
    <=> v68361(VarCurr,50) ) ).

tff(addAssignment_44209,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,50)
    <=> v68362(VarCurr,50) ) ).

tff(addAssignment_44208,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,50)
    <=> v68357(VarCurr,50) ) ).

tff(addAssignment_44207,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,50)
    <=> $false ) ).

tff(addAssignment_44206,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,50)
    <=> v68300(VarCurr,50) ) ).

tff(addAssignment_44205,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,50)
    <=> v68301(VarCurr,50) ) ).

tff(addAssignment_44204,axiom,
    ! [VarCurr: state_type] :
      ( v70741(VarCurr)
    <=> v70743(VarCurr) ) ).

tff(addAssignment_44203,axiom,
    ! [VarCurr: state_type] :
      ( v70743(VarCurr)
    <=> v70745(VarCurr) ) ).

tff(addAssignment_44202,axiom,
    ! [VarCurr: state_type] :
      ( v70745(VarCurr)
    <=> v70747(VarCurr) ) ).

tff(addAssignment_44201,axiom,
    ! [VarCurr: state_type] :
      ( v70747(VarCurr)
    <=> v70749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6546,axiom,
    ! [VarCurr: state_type] :
      ( v70749(VarCurr)
    <=> ( v70787(VarCurr)
      <~> v70775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6545,axiom,
    ! [VarCurr: state_type] :
      ( v70787(VarCurr)
    <=> ( v70751(VarCurr)
      <~> v70763(VarCurr) ) ) ).

tff(addAssignment_44200,axiom,
    ! [VarCurr: state_type] :
      ( v70775(VarCurr)
    <=> v70777(VarCurr) ) ).

tff(addAssignment_44199,axiom,
    ! [VarCurr: state_type] :
      ( v70777(VarCurr)
    <=> v67349(VarCurr,106) ) ).

tff(addAssignment_44198,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,106)
    <=> v68249(VarCurr,42) ) ).

tff(addAssignment_44197,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,42)
    <=> v68251(VarCurr,42) ) ).

tff(addAssignment_44196,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,42)
    <=> v68253(VarCurr,42) ) ).

tff(addAssignment_44195,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,42)
    <=> v68255(VarCurr,42) ) ).

tff(addAssignment_44194,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,42)
    <=> v67359(VarCurr,106) ) ).

tff(addAssignment_44193,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,106)
    <=> v67580(VarCurr,106) ) ).

tff(addAssignment_44192,axiom,
    ! [VarCurr: state_type] :
      ( v67586(VarCurr,2)
    <=> v68258(VarCurr,42) ) ).

tff(addAssignment_44191,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,42)
    <=> v68260(VarCurr,42) ) ).

tff(addAssignment_44190,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,42)
    <=> v70779(VarNext,42) ) ).

tff(addCaseBooleanConditionEqualRanges1_865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70780(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70779(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_865,axiom,
    ! [VarNext: state_type] :
      ( v70780(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70779(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70780(VarNext)
      <=> v70781(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70781(VarNext)
      <=> ( v70783(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70783(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44189,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,42)
    <=> v68284(VarCurr,42) ) ).

tff(addAssignment_44188,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,42)
    <=> v67391(VarCurr,106) ) ).

tff(addAssignment_44187,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,106)
    <=> v70325(VarCurr,2) ) ).

tff(addAssignment_44186,axiom,
    ! [VarCurr: state_type] :
      ( v70325(VarCurr,2)
    <=> v70327(VarCurr,2) ) ).

tff(addAssignment_44185,axiom,
    ! [VarCurr: state_type] :
      ( v70327(VarCurr,2)
    <=> v70344(VarCurr,2) ) ).

tff(addAssignment_44184,axiom,
    ! [VarCurr: state_type] :
      ( v70337(VarCurr,2)
    <=> v70339(VarCurr,2) ) ).

tff(addAssignment_44183,axiom,
    ! [VarCurr: state_type] :
      ( v70339(VarCurr,2)
    <=> v67401(VarCurr,106) ) ).

tff(addAssignment_44182,axiom,
    ! [VarCurr: state_type] :
      ( v70329(VarCurr,2)
    <=> v70331(VarCurr,2) ) ).

tff(addAssignment_44181,axiom,
    ! [VarCurr: state_type] :
      ( v70331(VarCurr,2)
    <=> v67401(VarCurr,110) ) ).

tff(addAssignment_44180,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,110)
    <=> v68294(VarCurr,46) ) ).

tff(addAssignment_44179,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,46)
    <=> v68296(VarCurr,46) ) ).

tff(addAssignment_44178,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,46)
    <=> v68385(VarCurr,46) ) ).

tff(addAssignment_44177,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,46)
    <=> v68306(VarCurr,46) ) ).

tff(addAssignment_44176,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,46)
    <=> v67430(VarCurr,110) ) ).

tff(addAssignment_44175,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,110)
    <=> v67432(VarCurr,110) ) ).

tff(addAssignment_44174,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,110)
    <=> v67434(VarCurr,110) ) ).

tff(addAssignment_44173,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,110)
    <=> v68308(VarCurr,46) ) ).

tff(addAssignment_44172,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,46)
    <=> v68310(VarCurr,46) ) ).

tff(addAssignment_44171,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,46)
    <=> v68368(VarCurr,46) ) ).

tff(addAssignment_44170,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,46)
    <=> v68366(VarCurr,46) ) ).

tff(addAssignment_44169,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,46)
    <=> v68367(VarCurr,46) ) ).

tff(addAssignment_44168,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,46)
    <=> v68361(VarCurr,46) ) ).

tff(addAssignment_44167,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,46)
    <=> v68362(VarCurr,46) ) ).

tff(addAssignment_44166,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,46)
    <=> v68357(VarCurr,46) ) ).

tff(addAssignment_44165,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,46)
    <=> $false ) ).

tff(addAssignment_44164,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,46)
    <=> v68300(VarCurr,46) ) ).

tff(addAssignment_44163,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,46)
    <=> v68301(VarCurr,46) ) ).

tff(addAssignment_44162,axiom,
    ! [VarCurr: state_type] :
      ( v70763(VarCurr)
    <=> v70765(VarCurr) ) ).

tff(addAssignment_44161,axiom,
    ! [VarCurr: state_type] :
      ( v70765(VarCurr)
    <=> v67349(VarCurr,102) ) ).

tff(addAssignment_44160,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,102)
    <=> v68249(VarCurr,38) ) ).

tff(addAssignment_44159,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,38)
    <=> v68251(VarCurr,38) ) ).

tff(addAssignment_44158,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,38)
    <=> v68253(VarCurr,38) ) ).

tff(addAssignment_44157,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,38)
    <=> v68255(VarCurr,38) ) ).

tff(addAssignment_44156,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,38)
    <=> v67359(VarCurr,102) ) ).

tff(addAssignment_44155,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,102)
    <=> v67580(VarCurr,102) ) ).

tff(addAssignment_44154,axiom,
    ! [VarCurr: state_type] :
      ( v67587(VarCurr,2)
    <=> v68258(VarCurr,38) ) ).

tff(addAssignment_44153,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,38)
    <=> v68260(VarCurr,38) ) ).

tff(addAssignment_44152,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,38)
    <=> v70767(VarNext,38) ) ).

tff(addCaseBooleanConditionEqualRanges1_864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70768(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70767(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_864,axiom,
    ! [VarNext: state_type] :
      ( v70768(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70767(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70768(VarNext)
      <=> v70769(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70769(VarNext)
      <=> ( v70771(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70771(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44151,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,38)
    <=> v68284(VarCurr,38) ) ).

tff(addAssignment_44150,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,38)
    <=> v67391(VarCurr,102) ) ).

tff(addAssignment_44149,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,102)
    <=> v70285(VarCurr,2) ) ).

tff(addAssignment_44148,axiom,
    ! [VarCurr: state_type] :
      ( v70285(VarCurr,2)
    <=> v70287(VarCurr,2) ) ).

tff(addAssignment_44147,axiom,
    ! [VarCurr: state_type] :
      ( v70287(VarCurr,2)
    <=> v70304(VarCurr,2) ) ).

tff(addAssignment_44146,axiom,
    ! [VarCurr: state_type] :
      ( v70297(VarCurr,2)
    <=> v70299(VarCurr,2) ) ).

tff(addAssignment_44145,axiom,
    ! [VarCurr: state_type] :
      ( v70299(VarCurr,2)
    <=> v67401(VarCurr,102) ) ).

tff(addAssignment_44144,axiom,
    ! [VarCurr: state_type] :
      ( v70289(VarCurr,2)
    <=> v70291(VarCurr,2) ) ).

tff(addAssignment_44143,axiom,
    ! [VarCurr: state_type] :
      ( v70291(VarCurr,2)
    <=> v67401(VarCurr,106) ) ).

tff(addAssignment_44142,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,106)
    <=> v68294(VarCurr,42) ) ).

tff(addAssignment_44141,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,42)
    <=> v68296(VarCurr,42) ) ).

tff(addAssignment_44140,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,42)
    <=> v68385(VarCurr,42) ) ).

tff(addAssignment_44139,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,42)
    <=> v68306(VarCurr,42) ) ).

tff(addAssignment_44138,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,42)
    <=> v67430(VarCurr,106) ) ).

tff(addAssignment_44137,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,106)
    <=> v67432(VarCurr,106) ) ).

tff(addAssignment_44136,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,106)
    <=> v67434(VarCurr,106) ) ).

tff(addAssignment_44135,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,106)
    <=> v68308(VarCurr,42) ) ).

tff(addAssignment_44134,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,42)
    <=> v68310(VarCurr,42) ) ).

tff(addAssignment_44133,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,42)
    <=> v68368(VarCurr,42) ) ).

tff(addAssignment_44132,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,42)
    <=> v68366(VarCurr,42) ) ).

tff(addAssignment_44131,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,42)
    <=> v68367(VarCurr,42) ) ).

tff(addAssignment_44130,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,42)
    <=> v68361(VarCurr,42) ) ).

tff(addAssignment_44129,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,42)
    <=> v68362(VarCurr,42) ) ).

tff(addAssignment_44128,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,42)
    <=> v68357(VarCurr,42) ) ).

tff(addAssignment_44127,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,42)
    <=> $false ) ).

tff(addAssignment_44126,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,42)
    <=> v68300(VarCurr,42) ) ).

tff(addAssignment_44125,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,42)
    <=> v68301(VarCurr,42) ) ).

tff(addAssignment_44124,axiom,
    ! [VarCurr: state_type] :
      ( v70751(VarCurr)
    <=> v70753(VarCurr) ) ).

tff(addAssignment_44123,axiom,
    ! [VarCurr: state_type] :
      ( v70753(VarCurr)
    <=> v67349(VarCurr,98) ) ).

tff(addAssignment_44122,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,98)
    <=> v68249(VarCurr,34) ) ).

tff(addAssignment_44121,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,34)
    <=> v68251(VarCurr,34) ) ).

tff(addAssignment_44120,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,34)
    <=> v68253(VarCurr,34) ) ).

tff(addAssignment_44119,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,34)
    <=> v68255(VarCurr,34) ) ).

tff(addAssignment_44118,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,34)
    <=> v67359(VarCurr,98) ) ).

tff(addAssignment_44117,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,98)
    <=> v67580(VarCurr,98) ) ).

tff(addAssignment_44116,axiom,
    ! [VarCurr: state_type] :
      ( v67588(VarCurr,2)
    <=> v68258(VarCurr,34) ) ).

tff(addAssignment_44115,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,34)
    <=> v68260(VarCurr,34) ) ).

tff(addAssignment_44114,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,34)
    <=> v70755(VarNext,34) ) ).

tff(addCaseBooleanConditionEqualRanges1_863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70756(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70755(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_863,axiom,
    ! [VarNext: state_type] :
      ( v70756(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70755(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70756(VarNext)
      <=> v70757(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70757(VarNext)
      <=> ( v70759(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70759(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44113,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,34)
    <=> v68284(VarCurr,34) ) ).

tff(addAssignment_44112,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,34)
    <=> v67391(VarCurr,98) ) ).

tff(addAssignment_44111,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,98)
    <=> v70245(VarCurr,2) ) ).

tff(addAssignment_44110,axiom,
    ! [VarCurr: state_type] :
      ( v70245(VarCurr,2)
    <=> v70247(VarCurr,2) ) ).

tff(addAssignment_44109,axiom,
    ! [VarCurr: state_type] :
      ( v70247(VarCurr,2)
    <=> v70264(VarCurr,2) ) ).

tff(addAssignment_44108,axiom,
    ! [VarCurr: state_type] :
      ( v70257(VarCurr,2)
    <=> v70259(VarCurr,2) ) ).

tff(addAssignment_44107,axiom,
    ! [VarCurr: state_type] :
      ( v70259(VarCurr,2)
    <=> v67401(VarCurr,98) ) ).

tff(addAssignment_44106,axiom,
    ! [VarCurr: state_type] :
      ( v70249(VarCurr,2)
    <=> v70251(VarCurr,2) ) ).

tff(addAssignment_44105,axiom,
    ! [VarCurr: state_type] :
      ( v70251(VarCurr,2)
    <=> v67401(VarCurr,102) ) ).

tff(addAssignment_44104,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,102)
    <=> v68294(VarCurr,38) ) ).

tff(addAssignment_44103,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,38)
    <=> v68296(VarCurr,38) ) ).

tff(addAssignment_44102,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,38)
    <=> v68385(VarCurr,38) ) ).

tff(addAssignment_44101,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,38)
    <=> v68306(VarCurr,38) ) ).

tff(addAssignment_44100,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,38)
    <=> v67430(VarCurr,102) ) ).

tff(addAssignment_44099,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,102)
    <=> v67432(VarCurr,102) ) ).

tff(addAssignment_44098,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,102)
    <=> v67434(VarCurr,102) ) ).

tff(addAssignment_44097,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,102)
    <=> v68308(VarCurr,38) ) ).

tff(addAssignment_44096,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,38)
    <=> v68310(VarCurr,38) ) ).

tff(addAssignment_44095,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,38)
    <=> v68368(VarCurr,38) ) ).

tff(addAssignment_44094,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,38)
    <=> v68366(VarCurr,38) ) ).

tff(addAssignment_44093,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,38)
    <=> v68367(VarCurr,38) ) ).

tff(addAssignment_44092,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,38)
    <=> v68361(VarCurr,38) ) ).

tff(addAssignment_44091,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,38)
    <=> v68362(VarCurr,38) ) ).

tff(addAssignment_44090,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,38)
    <=> v68357(VarCurr,38) ) ).

tff(addAssignment_44089,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,38)
    <=> $false ) ).

tff(addAssignment_44088,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,38)
    <=> v68300(VarCurr,38) ) ).

tff(addAssignment_44087,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,38)
    <=> v68301(VarCurr,38) ) ).

tff(addAssignment_44086,axiom,
    ! [VarCurr: state_type] :
      ( v70575(VarCurr)
    <=> v70577(VarCurr) ) ).

tff(addAssignment_44085,axiom,
    ! [VarCurr: state_type] :
      ( v70577(VarCurr)
    <=> v70579(VarCurr) ) ).

tff(addAssignment_44084,axiom,
    ! [VarCurr: state_type] :
      ( v70579(VarCurr)
    <=> v70581(VarCurr) ) ).

tff(addAssignment_44083,axiom,
    ! [VarCurr: state_type] :
      ( v70581(VarCurr)
    <=> v70583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6538,axiom,
    ! [VarCurr: state_type] :
      ( v70583(VarCurr)
    <=> ( v70729(VarCurr)
      <~> v70681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6537,axiom,
    ! [VarCurr: state_type] :
      ( v70729(VarCurr)
    <=> ( v70585(VarCurr)
      <~> v70633(VarCurr) ) ) ).

tff(addAssignment_44082,axiom,
    ! [VarCurr: state_type] :
      ( v70681(VarCurr)
    <=> v70683(VarCurr) ) ).

tff(addAssignment_44081,axiom,
    ! [VarCurr: state_type] :
      ( v70683(VarCurr)
    <=> v70685(VarCurr) ) ).

tff(addAssignment_44080,axiom,
    ! [VarCurr: state_type] :
      ( v70685(VarCurr)
    <=> v70687(VarCurr) ) ).

tff(addAssignment_44079,axiom,
    ! [VarCurr: state_type] :
      ( v70687(VarCurr)
    <=> v70689(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6536,axiom,
    ! [VarCurr: state_type] :
      ( v70689(VarCurr)
    <=> ( v70727(VarCurr)
      <~> v70715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6535,axiom,
    ! [VarCurr: state_type] :
      ( v70727(VarCurr)
    <=> ( v70691(VarCurr)
      <~> v70703(VarCurr) ) ) ).

tff(addAssignment_44078,axiom,
    ! [VarCurr: state_type] :
      ( v70715(VarCurr)
    <=> v70717(VarCurr) ) ).

tff(addAssignment_44077,axiom,
    ! [VarCurr: state_type] :
      ( v70717(VarCurr)
    <=> v67349(VarCurr,94) ) ).

tff(addAssignment_44076,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,94)
    <=> v68249(VarCurr,30) ) ).

tff(addAssignment_44075,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,30)
    <=> v68251(VarCurr,30) ) ).

tff(addAssignment_44074,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,30)
    <=> v68253(VarCurr,30) ) ).

tff(addAssignment_44073,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,30)
    <=> v68255(VarCurr,30) ) ).

tff(addAssignment_44072,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,30)
    <=> v67359(VarCurr,94) ) ).

tff(addAssignment_44071,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,94)
    <=> v67580(VarCurr,94) ) ).

tff(addAssignment_44070,axiom,
    ! [VarCurr: state_type] :
      ( v67589(VarCurr,2)
    <=> v68258(VarCurr,30) ) ).

tff(addAssignment_44069,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,30)
    <=> v68260(VarCurr,30) ) ).

tff(addAssignment_44068,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,30)
    <=> v70719(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70720(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70719(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_862,axiom,
    ! [VarNext: state_type] :
      ( v70720(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70719(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70720(VarNext)
      <=> v70721(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70721(VarNext)
      <=> ( v70723(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70723(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44067,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,30)
    <=> v68284(VarCurr,30) ) ).

tff(addAssignment_44066,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,30)
    <=> v67391(VarCurr,94) ) ).

tff(addAssignment_44065,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,94)
    <=> v70181(VarCurr,2) ) ).

tff(addAssignment_44064,axiom,
    ! [VarCurr: state_type] :
      ( v70181(VarCurr,2)
    <=> v70183(VarCurr,2) ) ).

tff(addAssignment_44063,axiom,
    ! [VarCurr: state_type] :
      ( v70183(VarCurr,2)
    <=> v70200(VarCurr,2) ) ).

tff(addAssignment_44062,axiom,
    ! [VarCurr: state_type] :
      ( v70193(VarCurr,2)
    <=> v70195(VarCurr,2) ) ).

tff(addAssignment_44061,axiom,
    ! [VarCurr: state_type] :
      ( v70195(VarCurr,2)
    <=> v67401(VarCurr,94) ) ).

tff(addAssignment_44060,axiom,
    ! [VarCurr: state_type] :
      ( v70185(VarCurr,2)
    <=> v70187(VarCurr,2) ) ).

tff(addAssignment_44059,axiom,
    ! [VarCurr: state_type] :
      ( v70187(VarCurr,2)
    <=> v67401(VarCurr,98) ) ).

tff(addAssignment_44058,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,98)
    <=> v68294(VarCurr,34) ) ).

tff(addAssignment_44057,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,34)
    <=> v68296(VarCurr,34) ) ).

tff(addAssignment_44056,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,34)
    <=> v68385(VarCurr,34) ) ).

tff(addAssignment_44055,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,34)
    <=> v68306(VarCurr,34) ) ).

tff(addAssignment_44054,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,34)
    <=> v67430(VarCurr,98) ) ).

tff(addAssignment_44053,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,98)
    <=> v67432(VarCurr,98) ) ).

tff(addAssignment_44052,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,98)
    <=> v67434(VarCurr,98) ) ).

tff(addAssignment_44051,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,98)
    <=> v68308(VarCurr,34) ) ).

tff(addAssignment_44050,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,34)
    <=> v68310(VarCurr,34) ) ).

tff(addAssignment_44049,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,34)
    <=> v68368(VarCurr,34) ) ).

tff(addAssignment_44048,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,34)
    <=> v68366(VarCurr,34) ) ).

tff(addAssignment_44047,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,34)
    <=> v68367(VarCurr,34) ) ).

tff(addAssignment_44046,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,34)
    <=> v68361(VarCurr,34) ) ).

tff(addAssignment_44045,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,34)
    <=> v68362(VarCurr,34) ) ).

tff(addAssignment_44044,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,34)
    <=> v68357(VarCurr,34) ) ).

tff(addAssignment_44043,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,34)
    <=> $false ) ).

tff(addAssignment_44042,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,34)
    <=> v68300(VarCurr,34) ) ).

tff(addAssignment_44041,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,34)
    <=> v68301(VarCurr,34) ) ).

tff(addAssignment_44040,axiom,
    ! [VarCurr: state_type] :
      ( v70703(VarCurr)
    <=> v70705(VarCurr) ) ).

tff(addAssignment_44039,axiom,
    ! [VarCurr: state_type] :
      ( v70705(VarCurr)
    <=> v67349(VarCurr,90) ) ).

tff(addAssignment_44038,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,90)
    <=> v68249(VarCurr,26) ) ).

tff(addAssignment_44037,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,26)
    <=> v68251(VarCurr,26) ) ).

tff(addAssignment_44036,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,26)
    <=> v68253(VarCurr,26) ) ).

tff(addAssignment_44035,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,26)
    <=> v68255(VarCurr,26) ) ).

tff(addAssignment_44034,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,26)
    <=> v67359(VarCurr,90) ) ).

tff(addAssignment_44033,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,90)
    <=> v67580(VarCurr,90) ) ).

tff(addAssignment_44032,axiom,
    ! [VarCurr: state_type] :
      ( v67590(VarCurr,2)
    <=> v68258(VarCurr,26) ) ).

tff(addAssignment_44031,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,26)
    <=> v68260(VarCurr,26) ) ).

tff(addAssignment_44030,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,26)
    <=> v70707(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70708(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70707(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_861,axiom,
    ! [VarNext: state_type] :
      ( v70708(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70707(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70708(VarNext)
      <=> v70709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70709(VarNext)
      <=> ( v70711(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70711(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_44029,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,26)
    <=> v68284(VarCurr,26) ) ).

tff(addAssignment_44028,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,26)
    <=> v67391(VarCurr,90) ) ).

tff(addAssignment_44027,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,90)
    <=> v70141(VarCurr,2) ) ).

tff(addAssignment_44026,axiom,
    ! [VarCurr: state_type] :
      ( v70141(VarCurr,2)
    <=> v70143(VarCurr,2) ) ).

tff(addAssignment_44025,axiom,
    ! [VarCurr: state_type] :
      ( v70143(VarCurr,2)
    <=> v70160(VarCurr,2) ) ).

tff(addAssignment_44024,axiom,
    ! [VarCurr: state_type] :
      ( v70153(VarCurr,2)
    <=> v70155(VarCurr,2) ) ).

tff(addAssignment_44023,axiom,
    ! [VarCurr: state_type] :
      ( v70155(VarCurr,2)
    <=> v67401(VarCurr,90) ) ).

tff(addAssignment_44022,axiom,
    ! [VarCurr: state_type] :
      ( v70145(VarCurr,2)
    <=> v70147(VarCurr,2) ) ).

tff(addAssignment_44021,axiom,
    ! [VarCurr: state_type] :
      ( v70147(VarCurr,2)
    <=> v67401(VarCurr,94) ) ).

tff(addAssignment_44020,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,94)
    <=> v68294(VarCurr,30) ) ).

tff(addAssignment_44019,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,30)
    <=> v68296(VarCurr,30) ) ).

tff(addAssignment_44018,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,30)
    <=> v68385(VarCurr,30) ) ).

tff(addAssignment_44017,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,30)
    <=> v68306(VarCurr,30) ) ).

tff(addAssignment_44016,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,30)
    <=> v67430(VarCurr,94) ) ).

tff(addAssignment_44015,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,94)
    <=> v67432(VarCurr,94) ) ).

tff(addAssignment_44014,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,94)
    <=> v67434(VarCurr,94) ) ).

tff(addAssignment_44013,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,94)
    <=> v68308(VarCurr,30) ) ).

tff(addAssignment_44012,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,30)
    <=> v68310(VarCurr,30) ) ).

tff(addAssignment_44011,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,30)
    <=> v68368(VarCurr,30) ) ).

tff(addAssignment_44010,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,30)
    <=> v68366(VarCurr,30) ) ).

tff(addAssignment_44009,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,30)
    <=> v68367(VarCurr,30) ) ).

tff(addAssignment_44008,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,30)
    <=> v68361(VarCurr,30) ) ).

tff(addAssignment_44007,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,30)
    <=> v68362(VarCurr,30) ) ).

tff(addAssignment_44006,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,30)
    <=> v68357(VarCurr,30) ) ).

tff(addAssignment_44005,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_44004,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,30)
    <=> v68300(VarCurr,30) ) ).

tff(addAssignment_44003,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,30)
    <=> v68301(VarCurr,30) ) ).

tff(addAssignment_44002,axiom,
    ! [VarCurr: state_type] :
      ( v70691(VarCurr)
    <=> v70693(VarCurr) ) ).

tff(addAssignment_44001,axiom,
    ! [VarCurr: state_type] :
      ( v70693(VarCurr)
    <=> v67349(VarCurr,86) ) ).

tff(addAssignment_44000,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,86)
    <=> v68249(VarCurr,22) ) ).

tff(addAssignment_43999,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,22)
    <=> v68251(VarCurr,22) ) ).

tff(addAssignment_43998,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,22)
    <=> v68253(VarCurr,22) ) ).

tff(addAssignment_43997,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,22)
    <=> v68255(VarCurr,22) ) ).

tff(addAssignment_43996,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,22)
    <=> v67359(VarCurr,86) ) ).

tff(addAssignment_43995,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,86)
    <=> v67580(VarCurr,86) ) ).

tff(addAssignment_43994,axiom,
    ! [VarCurr: state_type] :
      ( v67591(VarCurr,2)
    <=> v68258(VarCurr,22) ) ).

tff(addAssignment_43993,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,22)
    <=> v68260(VarCurr,22) ) ).

tff(addAssignment_43992,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,22)
    <=> v70695(VarNext,22) ) ).

tff(addCaseBooleanConditionEqualRanges1_860,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70696(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70695(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_860,axiom,
    ! [VarNext: state_type] :
      ( v70696(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70695(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70696(VarNext)
      <=> v70697(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70697(VarNext)
      <=> ( v70699(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70699(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43991,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,22)
    <=> v68284(VarCurr,22) ) ).

tff(addAssignment_43990,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,22)
    <=> v67391(VarCurr,86) ) ).

tff(addAssignment_43989,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,86)
    <=> v70101(VarCurr,2) ) ).

tff(addAssignment_43988,axiom,
    ! [VarCurr: state_type] :
      ( v70101(VarCurr,2)
    <=> v70103(VarCurr,2) ) ).

tff(addAssignment_43987,axiom,
    ! [VarCurr: state_type] :
      ( v70103(VarCurr,2)
    <=> v70120(VarCurr,2) ) ).

tff(addAssignment_43986,axiom,
    ! [VarCurr: state_type] :
      ( v70113(VarCurr,2)
    <=> v70115(VarCurr,2) ) ).

tff(addAssignment_43985,axiom,
    ! [VarCurr: state_type] :
      ( v70115(VarCurr,2)
    <=> v67401(VarCurr,86) ) ).

tff(addAssignment_43984,axiom,
    ! [VarCurr: state_type] :
      ( v70105(VarCurr,2)
    <=> v70107(VarCurr,2) ) ).

tff(addAssignment_43983,axiom,
    ! [VarCurr: state_type] :
      ( v70107(VarCurr,2)
    <=> v67401(VarCurr,90) ) ).

tff(addAssignment_43982,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,90)
    <=> v68294(VarCurr,26) ) ).

tff(addAssignment_43981,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,26)
    <=> v68296(VarCurr,26) ) ).

tff(addAssignment_43980,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,26)
    <=> v68385(VarCurr,26) ) ).

tff(addAssignment_43979,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,26)
    <=> v68306(VarCurr,26) ) ).

tff(addAssignment_43978,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,26)
    <=> v67430(VarCurr,90) ) ).

tff(addAssignment_43977,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,90)
    <=> v67432(VarCurr,90) ) ).

tff(addAssignment_43976,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,90)
    <=> v67434(VarCurr,90) ) ).

tff(addAssignment_43975,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,90)
    <=> v68308(VarCurr,26) ) ).

tff(addAssignment_43974,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,26)
    <=> v68310(VarCurr,26) ) ).

tff(addAssignment_43973,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,26)
    <=> v68368(VarCurr,26) ) ).

tff(addAssignment_43972,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,26)
    <=> v68366(VarCurr,26) ) ).

tff(addAssignment_43971,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,26)
    <=> v68367(VarCurr,26) ) ).

tff(addAssignment_43970,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,26)
    <=> v68361(VarCurr,26) ) ).

tff(addAssignment_43969,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,26)
    <=> v68362(VarCurr,26) ) ).

tff(addAssignment_43968,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,26)
    <=> v68357(VarCurr,26) ) ).

tff(addAssignment_43967,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,26)
    <=> $false ) ).

tff(addAssignment_43966,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,26)
    <=> v68300(VarCurr,26) ) ).

tff(addAssignment_43965,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,26)
    <=> v68301(VarCurr,26) ) ).

tff(addAssignment_43964,axiom,
    ! [VarCurr: state_type] :
      ( v70633(VarCurr)
    <=> v70635(VarCurr) ) ).

tff(addAssignment_43963,axiom,
    ! [VarCurr: state_type] :
      ( v70635(VarCurr)
    <=> v70637(VarCurr) ) ).

tff(addAssignment_43962,axiom,
    ! [VarCurr: state_type] :
      ( v70637(VarCurr)
    <=> v70639(VarCurr) ) ).

tff(addAssignment_43961,axiom,
    ! [VarCurr: state_type] :
      ( v70639(VarCurr)
    <=> v70641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6528,axiom,
    ! [VarCurr: state_type] :
      ( v70641(VarCurr)
    <=> ( v70679(VarCurr)
      <~> v70667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6527,axiom,
    ! [VarCurr: state_type] :
      ( v70679(VarCurr)
    <=> ( v70643(VarCurr)
      <~> v70655(VarCurr) ) ) ).

tff(addAssignment_43960,axiom,
    ! [VarCurr: state_type] :
      ( v70667(VarCurr)
    <=> v70669(VarCurr) ) ).

tff(addAssignment_43959,axiom,
    ! [VarCurr: state_type] :
      ( v70669(VarCurr)
    <=> v67349(VarCurr,82) ) ).

tff(addAssignment_43958,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,82)
    <=> v68249(VarCurr,18) ) ).

tff(addAssignment_43957,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,18)
    <=> v68251(VarCurr,18) ) ).

tff(addAssignment_43956,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,18)
    <=> v68253(VarCurr,18) ) ).

tff(addAssignment_43955,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,18)
    <=> v68255(VarCurr,18) ) ).

tff(addAssignment_43954,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,18)
    <=> v67359(VarCurr,82) ) ).

tff(addAssignment_43953,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,82)
    <=> v67580(VarCurr,82) ) ).

tff(addAssignment_43952,axiom,
    ! [VarCurr: state_type] :
      ( v67592(VarCurr,2)
    <=> v68258(VarCurr,18) ) ).

tff(addAssignment_43951,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,18)
    <=> v68260(VarCurr,18) ) ).

tff(addAssignment_43950,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,18)
    <=> v70671(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70672(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70671(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_859,axiom,
    ! [VarNext: state_type] :
      ( v70672(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70671(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70672(VarNext)
      <=> v70673(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70673(VarNext)
      <=> ( v70675(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70675(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43949,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,18)
    <=> v68284(VarCurr,18) ) ).

tff(addAssignment_43948,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,18)
    <=> v67391(VarCurr,82) ) ).

tff(addAssignment_43947,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,82)
    <=> v70049(VarCurr,2) ) ).

tff(addAssignment_43946,axiom,
    ! [VarCurr: state_type] :
      ( v70049(VarCurr,2)
    <=> v70051(VarCurr,2) ) ).

tff(addAssignment_43945,axiom,
    ! [VarCurr: state_type] :
      ( v70051(VarCurr,2)
    <=> v70068(VarCurr,2) ) ).

tff(addAssignment_43944,axiom,
    ! [VarCurr: state_type] :
      ( v70061(VarCurr,2)
    <=> v70063(VarCurr,2) ) ).

tff(addAssignment_43943,axiom,
    ! [VarCurr: state_type] :
      ( v70063(VarCurr,2)
    <=> v67401(VarCurr,82) ) ).

tff(addAssignment_43942,axiom,
    ! [VarCurr: state_type] :
      ( v70053(VarCurr,2)
    <=> v70055(VarCurr,2) ) ).

tff(addAssignment_43941,axiom,
    ! [VarCurr: state_type] :
      ( v70055(VarCurr,2)
    <=> v67401(VarCurr,86) ) ).

tff(addAssignment_43940,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,86)
    <=> v68294(VarCurr,22) ) ).

tff(addAssignment_43939,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,22)
    <=> v68296(VarCurr,22) ) ).

tff(addAssignment_43938,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,22)
    <=> v68385(VarCurr,22) ) ).

tff(addAssignment_43937,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,22)
    <=> v68306(VarCurr,22) ) ).

tff(addAssignment_43936,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,22)
    <=> v67430(VarCurr,86) ) ).

tff(addAssignment_43935,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,86)
    <=> v67432(VarCurr,86) ) ).

tff(addAssignment_43934,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,86)
    <=> v67434(VarCurr,86) ) ).

tff(addAssignment_43933,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,86)
    <=> v68308(VarCurr,22) ) ).

tff(addAssignment_43932,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,22)
    <=> v68310(VarCurr,22) ) ).

tff(addAssignment_43931,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,22)
    <=> v68368(VarCurr,22) ) ).

tff(addAssignment_43930,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,22)
    <=> v68366(VarCurr,22) ) ).

tff(addAssignment_43929,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,22)
    <=> v68367(VarCurr,22) ) ).

tff(addAssignment_43928,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,22)
    <=> v68361(VarCurr,22) ) ).

tff(addAssignment_43927,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,22)
    <=> v68362(VarCurr,22) ) ).

tff(addAssignment_43926,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,22)
    <=> v68357(VarCurr,22) ) ).

tff(addAssignment_43925,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,22)
    <=> $false ) ).

tff(addAssignment_43924,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,22)
    <=> v68300(VarCurr,22) ) ).

tff(addAssignment_43923,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,22)
    <=> v68301(VarCurr,22) ) ).

tff(addAssignment_43922,axiom,
    ! [VarCurr: state_type] :
      ( v70655(VarCurr)
    <=> v70657(VarCurr) ) ).

tff(addAssignment_43921,axiom,
    ! [VarCurr: state_type] :
      ( v70657(VarCurr)
    <=> v67349(VarCurr,78) ) ).

tff(addAssignment_43920,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,78)
    <=> v68249(VarCurr,14) ) ).

tff(addAssignment_43919,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,14)
    <=> v68251(VarCurr,14) ) ).

tff(addAssignment_43918,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,14)
    <=> v68253(VarCurr,14) ) ).

tff(addAssignment_43917,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,14)
    <=> v68255(VarCurr,14) ) ).

tff(addAssignment_43916,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,14)
    <=> v67359(VarCurr,78) ) ).

tff(addAssignment_43915,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,78)
    <=> v67580(VarCurr,78) ) ).

tff(addAssignment_43914,axiom,
    ! [VarCurr: state_type] :
      ( v67593(VarCurr,2)
    <=> v68258(VarCurr,14) ) ).

tff(addAssignment_43913,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,14)
    <=> v68260(VarCurr,14) ) ).

tff(addAssignment_43912,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,14)
    <=> v70659(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70660(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70659(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_858,axiom,
    ! [VarNext: state_type] :
      ( v70660(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70659(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70660(VarNext)
      <=> v70661(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70661(VarNext)
      <=> ( v70663(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70663(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43911,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,14)
    <=> v68284(VarCurr,14) ) ).

tff(addAssignment_43910,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,14)
    <=> v67391(VarCurr,78) ) ).

tff(addAssignment_43909,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,78)
    <=> v70009(VarCurr,2) ) ).

tff(addAssignment_43908,axiom,
    ! [VarCurr: state_type] :
      ( v70009(VarCurr,2)
    <=> v70011(VarCurr,2) ) ).

tff(addAssignment_43907,axiom,
    ! [VarCurr: state_type] :
      ( v70011(VarCurr,2)
    <=> v70028(VarCurr,2) ) ).

tff(addAssignment_43906,axiom,
    ! [VarCurr: state_type] :
      ( v70021(VarCurr,2)
    <=> v70023(VarCurr,2) ) ).

tff(addAssignment_43905,axiom,
    ! [VarCurr: state_type] :
      ( v70023(VarCurr,2)
    <=> v67401(VarCurr,78) ) ).

tff(addAssignment_43904,axiom,
    ! [VarCurr: state_type] :
      ( v70013(VarCurr,2)
    <=> v70015(VarCurr,2) ) ).

tff(addAssignment_43903,axiom,
    ! [VarCurr: state_type] :
      ( v70015(VarCurr,2)
    <=> v67401(VarCurr,82) ) ).

tff(addAssignment_43902,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,82)
    <=> v68294(VarCurr,18) ) ).

tff(addAssignment_43901,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,18)
    <=> v68296(VarCurr,18) ) ).

tff(addAssignment_43900,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,18)
    <=> v68385(VarCurr,18) ) ).

tff(addAssignment_43899,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,18)
    <=> v68306(VarCurr,18) ) ).

tff(addAssignment_43898,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,18)
    <=> v67430(VarCurr,82) ) ).

tff(addAssignment_43897,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,82)
    <=> v67432(VarCurr,82) ) ).

tff(addAssignment_43896,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,82)
    <=> v67434(VarCurr,82) ) ).

tff(addAssignment_43895,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,82)
    <=> v68308(VarCurr,18) ) ).

tff(addAssignment_43894,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,18)
    <=> v68310(VarCurr,18) ) ).

tff(addAssignment_43893,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,18)
    <=> v68368(VarCurr,18) ) ).

tff(addAssignment_43892,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,18)
    <=> v68366(VarCurr,18) ) ).

tff(addAssignment_43891,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,18)
    <=> v68367(VarCurr,18) ) ).

tff(addAssignment_43890,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,18)
    <=> v68361(VarCurr,18) ) ).

tff(addAssignment_43889,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,18)
    <=> v68362(VarCurr,18) ) ).

tff(addAssignment_43888,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,18)
    <=> v68357(VarCurr,18) ) ).

tff(addAssignment_43887,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,18)
    <=> $false ) ).

tff(addAssignment_43886,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,18)
    <=> v68300(VarCurr,18) ) ).

tff(addAssignment_43885,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,18)
    <=> v68301(VarCurr,18) ) ).

tff(addAssignment_43884,axiom,
    ! [VarCurr: state_type] :
      ( v70643(VarCurr)
    <=> v70645(VarCurr) ) ).

tff(addAssignment_43883,axiom,
    ! [VarCurr: state_type] :
      ( v70645(VarCurr)
    <=> v67349(VarCurr,74) ) ).

tff(addAssignment_43882,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,74)
    <=> v68249(VarCurr,10) ) ).

tff(addAssignment_43881,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,10)
    <=> v68251(VarCurr,10) ) ).

tff(addAssignment_43880,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,10)
    <=> v68253(VarCurr,10) ) ).

tff(addAssignment_43879,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,10)
    <=> v68255(VarCurr,10) ) ).

tff(addAssignment_43878,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,10)
    <=> v67359(VarCurr,74) ) ).

tff(addAssignment_43877,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,74)
    <=> v67580(VarCurr,74) ) ).

tff(addAssignment_43876,axiom,
    ! [VarCurr: state_type] :
      ( v67594(VarCurr,2)
    <=> v68258(VarCurr,10) ) ).

tff(addAssignment_43875,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,10)
    <=> v68260(VarCurr,10) ) ).

tff(addAssignment_43874,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,10)
    <=> v70647(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70648(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70647(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_857,axiom,
    ! [VarNext: state_type] :
      ( v70648(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70647(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70648(VarNext)
      <=> v70649(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70649(VarNext)
      <=> ( v70651(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70651(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43873,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,10)
    <=> v68284(VarCurr,10) ) ).

tff(addAssignment_43872,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,10)
    <=> v67391(VarCurr,74) ) ).

tff(addAssignment_43871,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,74)
    <=> v69969(VarCurr,2) ) ).

tff(addAssignment_43870,axiom,
    ! [VarCurr: state_type] :
      ( v69969(VarCurr,2)
    <=> v69971(VarCurr,2) ) ).

tff(addAssignment_43869,axiom,
    ! [VarCurr: state_type] :
      ( v69971(VarCurr,2)
    <=> v69988(VarCurr,2) ) ).

tff(addAssignment_43868,axiom,
    ! [VarCurr: state_type] :
      ( v69981(VarCurr,2)
    <=> v69983(VarCurr,2) ) ).

tff(addAssignment_43867,axiom,
    ! [VarCurr: state_type] :
      ( v69983(VarCurr,2)
    <=> v67401(VarCurr,74) ) ).

tff(addAssignment_43866,axiom,
    ! [VarCurr: state_type] :
      ( v69973(VarCurr,2)
    <=> v69975(VarCurr,2) ) ).

tff(addAssignment_43865,axiom,
    ! [VarCurr: state_type] :
      ( v69975(VarCurr,2)
    <=> v67401(VarCurr,78) ) ).

tff(addAssignment_43864,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,78)
    <=> v68294(VarCurr,14) ) ).

tff(addAssignment_43863,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,14)
    <=> v68296(VarCurr,14) ) ).

tff(addAssignment_43862,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,14)
    <=> v68385(VarCurr,14) ) ).

tff(addAssignment_43861,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,14)
    <=> v68306(VarCurr,14) ) ).

tff(addAssignment_43860,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,14)
    <=> v67430(VarCurr,78) ) ).

tff(addAssignment_43859,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,78)
    <=> v67432(VarCurr,78) ) ).

tff(addAssignment_43858,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,78)
    <=> v67434(VarCurr,78) ) ).

tff(addAssignment_43857,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,78)
    <=> v68308(VarCurr,14) ) ).

tff(addAssignment_43856,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,14)
    <=> v68310(VarCurr,14) ) ).

tff(addAssignment_43855,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,14)
    <=> v68368(VarCurr,14) ) ).

tff(addAssignment_43854,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,14)
    <=> v68366(VarCurr,14) ) ).

tff(addAssignment_43853,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,14)
    <=> v68367(VarCurr,14) ) ).

tff(addAssignment_43852,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,14)
    <=> v68361(VarCurr,14) ) ).

tff(addAssignment_43851,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,14)
    <=> v68362(VarCurr,14) ) ).

tff(addAssignment_43850,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,14)
    <=> v68357(VarCurr,14) ) ).

tff(addAssignment_43849,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_43848,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,14)
    <=> v68300(VarCurr,14) ) ).

tff(addAssignment_43847,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,14)
    <=> v68301(VarCurr,14) ) ).

tff(addAssignment_43846,axiom,
    ! [VarCurr: state_type] :
      ( v70585(VarCurr)
    <=> v70587(VarCurr) ) ).

tff(addAssignment_43845,axiom,
    ! [VarCurr: state_type] :
      ( v70587(VarCurr)
    <=> v70589(VarCurr) ) ).

tff(addAssignment_43844,axiom,
    ! [VarCurr: state_type] :
      ( v70589(VarCurr)
    <=> v70591(VarCurr) ) ).

tff(addAssignment_43843,axiom,
    ! [VarCurr: state_type] :
      ( v70591(VarCurr)
    <=> v70593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6520,axiom,
    ! [VarCurr: state_type] :
      ( v70593(VarCurr)
    <=> ( v70631(VarCurr)
      <~> v70619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6519,axiom,
    ! [VarCurr: state_type] :
      ( v70631(VarCurr)
    <=> ( v70595(VarCurr)
      <~> v70607(VarCurr) ) ) ).

tff(addAssignment_43842,axiom,
    ! [VarCurr: state_type] :
      ( v70619(VarCurr)
    <=> v70621(VarCurr) ) ).

tff(addAssignment_43841,axiom,
    ! [VarCurr: state_type] :
      ( v70621(VarCurr)
    <=> v67349(VarCurr,70) ) ).

tff(addAssignment_43840,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,70)
    <=> v68249(VarCurr,6) ) ).

tff(addAssignment_43839,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,6)
    <=> v68251(VarCurr,6) ) ).

tff(addAssignment_43838,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,6)
    <=> v68253(VarCurr,6) ) ).

tff(addAssignment_43837,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,6)
    <=> v68255(VarCurr,6) ) ).

tff(addAssignment_43836,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,6)
    <=> v67359(VarCurr,70) ) ).

tff(addAssignment_43835,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,70)
    <=> v67580(VarCurr,70) ) ).

tff(addAssignment_43834,axiom,
    ! [VarCurr: state_type] :
      ( v67595(VarCurr,2)
    <=> v68258(VarCurr,6) ) ).

tff(addAssignment_43833,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,6)
    <=> v68260(VarCurr,6) ) ).

tff(addAssignment_43832,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,6)
    <=> v70623(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70624(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70623(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_856,axiom,
    ! [VarNext: state_type] :
      ( v70624(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70623(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70624(VarNext)
      <=> v70625(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70625(VarNext)
      <=> ( v70627(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70627(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43831,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,6)
    <=> v68284(VarCurr,6) ) ).

tff(addAssignment_43830,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,6)
    <=> v67391(VarCurr,70) ) ).

tff(addAssignment_43829,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,70)
    <=> v69917(VarCurr,2) ) ).

tff(addAssignment_43828,axiom,
    ! [VarCurr: state_type] :
      ( v69917(VarCurr,2)
    <=> v69919(VarCurr,2) ) ).

tff(addAssignment_43827,axiom,
    ! [VarCurr: state_type] :
      ( v69919(VarCurr,2)
    <=> v69936(VarCurr,2) ) ).

tff(addAssignment_43826,axiom,
    ! [VarCurr: state_type] :
      ( v69929(VarCurr,2)
    <=> v69931(VarCurr,2) ) ).

tff(addAssignment_43825,axiom,
    ! [VarCurr: state_type] :
      ( v69931(VarCurr,2)
    <=> v67401(VarCurr,70) ) ).

tff(addAssignment_43824,axiom,
    ! [VarCurr: state_type] :
      ( v69921(VarCurr,2)
    <=> v69923(VarCurr,2) ) ).

tff(addAssignment_43823,axiom,
    ! [VarCurr: state_type] :
      ( v69923(VarCurr,2)
    <=> v67401(VarCurr,74) ) ).

tff(addAssignment_43822,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,74)
    <=> v68294(VarCurr,10) ) ).

tff(addAssignment_43821,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,10)
    <=> v68296(VarCurr,10) ) ).

tff(addAssignment_43820,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,10)
    <=> v68385(VarCurr,10) ) ).

tff(addAssignment_43819,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,10)
    <=> v68306(VarCurr,10) ) ).

tff(addAssignment_43818,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,10)
    <=> v67430(VarCurr,74) ) ).

tff(addAssignment_43817,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,74)
    <=> v67432(VarCurr,74) ) ).

tff(addAssignment_43816,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,74)
    <=> v67434(VarCurr,74) ) ).

tff(addAssignment_43815,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,74)
    <=> v68308(VarCurr,10) ) ).

tff(addAssignment_43814,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,10)
    <=> v68310(VarCurr,10) ) ).

tff(addAssignment_43813,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,10)
    <=> v68368(VarCurr,10) ) ).

tff(addAssignment_43812,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,10)
    <=> v68366(VarCurr,10) ) ).

tff(addAssignment_43811,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,10)
    <=> v68367(VarCurr,10) ) ).

tff(addAssignment_43810,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,10)
    <=> v68361(VarCurr,10) ) ).

tff(addAssignment_43809,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,10)
    <=> v68362(VarCurr,10) ) ).

tff(addAssignment_43808,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,10)
    <=> v68357(VarCurr,10) ) ).

tff(addAssignment_43807,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_43806,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,10)
    <=> v68300(VarCurr,10) ) ).

tff(addAssignment_43805,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,10)
    <=> v68301(VarCurr,10) ) ).

tff(addAssignment_43804,axiom,
    ! [VarCurr: state_type] :
      ( v70607(VarCurr)
    <=> v70609(VarCurr) ) ).

tff(addAssignment_43803,axiom,
    ! [VarCurr: state_type] :
      ( v70609(VarCurr)
    <=> v67349(VarCurr,66) ) ).

tff(addAssignment_43802,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,66)
    <=> v68249(VarCurr,2) ) ).

tff(addAssignment_43801,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,2)
    <=> v68251(VarCurr,2) ) ).

tff(addAssignment_43800,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,2)
    <=> v68253(VarCurr,2) ) ).

tff(addAssignment_43799,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,2)
    <=> v68255(VarCurr,2) ) ).

tff(addAssignment_43798,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,2)
    <=> v67359(VarCurr,66) ) ).

tff(addAssignment_43797,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,66)
    <=> v67580(VarCurr,66) ) ).

tff(addAssignment_43796,axiom,
    ! [VarCurr: state_type] :
      ( v67596(VarCurr,2)
    <=> v68258(VarCurr,2) ) ).

tff(addAssignment_43795,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,2)
    <=> v68260(VarCurr,2) ) ).

tff(addAssignment_43794,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,2)
    <=> v70611(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70612(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70611(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_855,axiom,
    ! [VarNext: state_type] :
      ( v70612(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70611(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70612(VarNext)
      <=> v70613(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70613(VarNext)
      <=> ( v70615(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70615(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43793,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,2)
    <=> v68284(VarCurr,2) ) ).

tff(addAssignment_43792,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,2)
    <=> v67391(VarCurr,66) ) ).

tff(addAssignment_43791,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,66)
    <=> v69877(VarCurr,2) ) ).

tff(addAssignment_43790,axiom,
    ! [VarCurr: state_type] :
      ( v69877(VarCurr,2)
    <=> v69879(VarCurr,2) ) ).

tff(addAssignment_43789,axiom,
    ! [VarCurr: state_type] :
      ( v69879(VarCurr,2)
    <=> v69896(VarCurr,2) ) ).

tff(addAssignment_43788,axiom,
    ! [VarCurr: state_type] :
      ( v69889(VarCurr,2)
    <=> v69891(VarCurr,2) ) ).

tff(addAssignment_43787,axiom,
    ! [VarCurr: state_type] :
      ( v69891(VarCurr,2)
    <=> v67401(VarCurr,66) ) ).

tff(addAssignment_43786,axiom,
    ! [VarCurr: state_type] :
      ( v69881(VarCurr,2)
    <=> v69883(VarCurr,2) ) ).

tff(addAssignment_43785,axiom,
    ! [VarCurr: state_type] :
      ( v69883(VarCurr,2)
    <=> v67401(VarCurr,70) ) ).

tff(addAssignment_43784,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,70)
    <=> v68294(VarCurr,6) ) ).

tff(addAssignment_43783,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,6)
    <=> v68296(VarCurr,6) ) ).

tff(addAssignment_43782,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,6)
    <=> v68385(VarCurr,6) ) ).

tff(addAssignment_43781,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,6)
    <=> v68306(VarCurr,6) ) ).

tff(addAssignment_43780,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,6)
    <=> v67430(VarCurr,70) ) ).

tff(addAssignment_43779,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,70)
    <=> v67432(VarCurr,70) ) ).

tff(addAssignment_43778,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,70)
    <=> v67434(VarCurr,70) ) ).

tff(addAssignment_43777,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,70)
    <=> v68308(VarCurr,6) ) ).

tff(addAssignment_43776,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,6)
    <=> v68310(VarCurr,6) ) ).

tff(addAssignment_43775,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,6)
    <=> v68368(VarCurr,6) ) ).

tff(addAssignment_43774,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,6)
    <=> v68366(VarCurr,6) ) ).

tff(addAssignment_43773,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,6)
    <=> v68367(VarCurr,6) ) ).

tff(addAssignment_43772,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,70)
    <=> v67496(VarCurr,70) ) ).

tff(addAssignment_43771,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,142)
    <=> v33839(VarCurr,142) ) ).

tff(addAssignment_43770,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,142)
    <=> v33841(VarCurr,142) ) ).

tff(addAssignment_43769,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,142)
    <=> v26555(VarCurr,10) ) ).

tff(addAssignment_43768,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,6)
    <=> v68361(VarCurr,6) ) ).

tff(addAssignment_43767,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,6)
    <=> v68362(VarCurr,6) ) ).

tff(addAssignment_43766,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,6)
    <=> v68357(VarCurr,6) ) ).

tff(addAssignment_43765,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_43764,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,6)
    <=> v68300(VarCurr,6) ) ).

tff(addAssignment_43763,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,6)
    <=> v68301(VarCurr,6) ) ).

tff(addAssignment_43762,axiom,
    ! [VarCurr: state_type] :
      ( v70595(VarCurr)
    <=> v70597(VarCurr) ) ).

tff(addAssignment_43761,axiom,
    ! [VarCurr: state_type] :
      ( v70597(VarCurr)
    <=> v67349(VarCurr,62) ) ).

tff(addAssignment_43760,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,62)
    <=> v67351(VarCurr,62) ) ).

tff(addAssignment_43759,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,62)
    <=> v67353(VarCurr,62) ) ).

tff(addAssignment_43758,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,62)
    <=> v67355(VarCurr,62) ) ).

tff(addAssignment_43757,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,62)
    <=> v67357(VarCurr,62) ) ).

tff(addAssignment_43756,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,62)
    <=> v67359(VarCurr,62) ) ).

tff(addAssignment_43755,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,62)
    <=> v67580(VarCurr,62) ) ).

tff(addAssignment_43754,axiom,
    ! [VarCurr: state_type] :
      ( v67597(VarCurr,2)
    <=> v67363(VarCurr,62) ) ).

tff(addAssignment_43753,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,62)
    <=> v67365(VarCurr,62) ) ).

tff(addAssignment_43752,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,62)
    <=> v70599(VarNext,62) ) ).

tff(addCaseBooleanConditionEqualRanges1_854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70600(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70599(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_854,axiom,
    ! [VarNext: state_type] :
      ( v70600(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70599(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70600(VarNext)
      <=> v70601(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70601(VarNext)
      <=> ( v70603(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70603(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_43751,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,62)
    <=> v67389(VarCurr,62) ) ).

tff(addAssignment_43750,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,62)
    <=> v67391(VarCurr,62) ) ).

tff(addAssignment_43749,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,62)
    <=> v69837(VarCurr,2) ) ).

tff(addAssignment_43748,axiom,
    ! [VarCurr: state_type] :
      ( v69837(VarCurr,2)
    <=> v69839(VarCurr,2) ) ).

tff(addAssignment_43747,axiom,
    ! [VarCurr: state_type] :
      ( v69839(VarCurr,2)
    <=> v69856(VarCurr,2) ) ).

tff(addAssignment_43746,axiom,
    ! [VarCurr: state_type] :
      ( v69849(VarCurr,2)
    <=> v69851(VarCurr,2) ) ).

tff(addAssignment_43745,axiom,
    ! [VarCurr: state_type] :
      ( v69851(VarCurr,2)
    <=> v67401(VarCurr,62) ) ).

tff(addAssignment_43744,axiom,
    ! [VarCurr: state_type] :
      ( v69841(VarCurr,2)
    <=> v69843(VarCurr,2) ) ).

tff(addAssignment_43743,axiom,
    ! [VarCurr: state_type] :
      ( v69843(VarCurr,2)
    <=> v67401(VarCurr,66) ) ).

tff(addAssignment_43742,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,66)
    <=> v68294(VarCurr,2) ) ).

tff(addAssignment_43741,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,2)
    <=> v68296(VarCurr,2) ) ).

tff(addAssignment_43740,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,2)
    <=> v68385(VarCurr,2) ) ).

tff(addAssignment_43739,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,2)
    <=> v68306(VarCurr,2) ) ).

tff(addAssignment_43738,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,2)
    <=> v67430(VarCurr,66) ) ).

tff(addAssignment_43737,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,66)
    <=> v67432(VarCurr,66) ) ).

tff(addAssignment_43736,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,66)
    <=> v67434(VarCurr,66) ) ).

tff(addAssignment_43735,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,66)
    <=> v68308(VarCurr,2) ) ).

tff(addAssignment_43734,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,2)
    <=> v68310(VarCurr,2) ) ).

tff(addAssignment_43733,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,2)
    <=> v68368(VarCurr,2) ) ).

tff(addAssignment_43732,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,2)
    <=> v68366(VarCurr,2) ) ).

tff(addAssignment_43731,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,2)
    <=> v68367(VarCurr,2) ) ).

tff(addAssignment_43730,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,66)
    <=> v67496(VarCurr,66) ) ).

tff(addAssignment_43729,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,138)
    <=> v33839(VarCurr,138) ) ).

tff(addAssignment_43728,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,138)
    <=> v33841(VarCurr,138) ) ).

tff(addAssignment_43727,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,138)
    <=> v26555(VarCurr,6) ) ).

tff(addAssignment_43726,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,2)
    <=> v68361(VarCurr,2) ) ).

tff(addAssignment_43725,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,2)
    <=> v68362(VarCurr,2) ) ).

tff(addAssignment_43724,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,2)
    <=> v68357(VarCurr,2) ) ).

tff(addAssignment_43723,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_43722,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,2)
    <=> v68300(VarCurr,2) ) ).

tff(addAssignment_43721,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,2)
    <=> v68301(VarCurr,2) ) ).

tff(addAssignment_43720,axiom,
    ! [VarCurr: state_type] :
      ( v69801(VarCurr)
    <=> v69803(VarCurr) ) ).

tff(addAssignment_43719,axiom,
    ! [VarCurr: state_type] :
      ( v69803(VarCurr)
    <=> v69805(VarCurr,3) ) ).

tff(addAssignment_43718,axiom,
    ! [VarCurr: state_type] :
      ( v69805(VarCurr,3)
    <=> v67309(VarCurr,7) ) ).

tff(addAssignment_43717,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,7)
    <=> v67311(VarCurr,7) ) ).

tff(addAssignment_43716,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,7)
    <=> v67313(VarCurr,7) ) ).

tff(addAssignment_43715,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,7)
    <=> v67315(VarCurr,7) ) ).

tff(addAssignment_43714,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,7)
    <=> v67317(VarCurr,7) ) ).

tff(addAssignment_43713,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,7)
    <=> v68771(VarCurr,7) ) ).

tff(addAssignment_43712,axiom,
    ! [VarCurr: state_type] :
      ( v68773(VarCurr,3)
    <=> v69808(VarCurr) ) ).

tff(addAssignment_43711,axiom,
    ! [VarCurr: state_type] :
      ( v69808(VarCurr)
    <=> v69810(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6512,axiom,
    ! [VarCurr: state_type] :
      ( v69810(VarCurr)
    <=> ( v70565(VarCurr)
      <~> v70522(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6511,axiom,
    ! [VarCurr: state_type] :
      ( v70565(VarCurr)
    <=> ( v69812(VarCurr)
      <~> v70220(VarCurr) ) ) ).

tff(addAssignment_43710,axiom,
    ! [VarCurr: state_type] :
      ( v70522(VarCurr)
    <=> v70524(VarCurr) ) ).

tff(addAssignment_43709,axiom,
    ! [VarCurr: state_type] :
      ( v70524(VarCurr)
    <=> v70526(VarCurr,3) ) ).

tff(addAssignment_43708,axiom,
    ! [VarCurr: state_type] :
      ( v70526(VarCurr,3)
    <=> v70528(VarCurr,3) ) ).

tff(addAssignment_43707,axiom,
    ! [VarCurr: state_type] :
      ( v70528(VarCurr,3)
    <=> v68595(VarCurr,8) ) ).

tff(addAssignment_43706,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,8)
    <=> v68597(VarCurr,8) ) ).

tff(addAssignment_43705,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,8)
    <=> v70557(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_853,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v70557(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_853,axiom,
    ! [VarNext: state_type] :
      ( v70558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v70557(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70558(VarNext)
      <=> v70559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70559(VarNext)
      <=> ( v70561(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70561(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_43704,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,8)
    <=> v68621(VarCurr,8) ) ).

tff(addAssignment_43703,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,8)
    <=> v68624(VarCurr,8) ) ).

tff(addAssignment_43702,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,7)
    <=> v70530(VarCurr,3) ) ).

tff(addAssignment_43701,axiom,
    ! [VarCurr: state_type] :
      ( v70530(VarCurr,3)
    <=> v70532(VarCurr,3) ) ).

tff(addAssignment_43700,axiom,
    ! [VarCurr: state_type] :
      ( v70532(VarCurr,3)
    <=> v70549(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70549(VarCurr,B)
      <=> ( v70550(VarCurr,B)
          | v70553(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70553(VarCurr,B)
      <=> ( v70542(VarCurr,B)
          & v70554(VarCurr,B) ) ) ) ).

tff(addAssignment_43699,axiom,
    ! [VarCurr: state_type] :
      ( v70554(VarCurr,0)
    <=> v70555(VarCurr) ) ).

tff(addAssignment_43698,axiom,
    ! [VarCurr: state_type] :
      ( v70554(VarCurr,1)
    <=> v70555(VarCurr) ) ).

tff(addAssignment_43697,axiom,
    ! [VarCurr: state_type] :
      ( v70554(VarCurr,2)
    <=> v70555(VarCurr) ) ).

tff(addAssignment_43696,axiom,
    ! [VarCurr: state_type] :
      ( v70554(VarCurr,3)
    <=> v70555(VarCurr) ) ).

tff(addAssignment_43695,axiom,
    ! [VarCurr: state_type] :
      ( v70555(VarCurr)
    <=> v70546(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70550(VarCurr,B)
      <=> ( v70534(VarCurr,B)
          & v70551(VarCurr,B) ) ) ) ).

tff(addAssignment_43694,axiom,
    ! [VarCurr: state_type] :
      ( v70551(VarCurr,0)
    <=> v70552(VarCurr) ) ).

tff(addAssignment_43693,axiom,
    ! [VarCurr: state_type] :
      ( v70551(VarCurr,1)
    <=> v70552(VarCurr) ) ).

tff(addAssignment_43692,axiom,
    ! [VarCurr: state_type] :
      ( v70551(VarCurr,2)
    <=> v70552(VarCurr) ) ).

tff(addAssignment_43691,axiom,
    ! [VarCurr: state_type] :
      ( v70551(VarCurr,3)
    <=> v70552(VarCurr) ) ).

tff(addAssignment_43690,axiom,
    ! [VarCurr: state_type] :
      ( v70552(VarCurr)
    <=> v70538(VarCurr) ) ).

tff(addAssignment_43689,axiom,
    ! [VarCurr: state_type] :
      ( v70546(VarCurr)
    <=> v70548(VarCurr) ) ).

tff(addAssignment_43688,axiom,
    ! [VarCurr: state_type] :
      ( v70548(VarCurr)
    <=> v67530(VarCurr,34) ) ).

tff(addAssignment_43687,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,34)
    <=> v52381(VarCurr,34) ) ).

tff(addAssignment_43686,axiom,
    ! [VarCurr: state_type] :
      ( v70542(VarCurr,3)
    <=> v70544(VarCurr,3) ) ).

tff(addAssignment_43685,axiom,
    ! [VarCurr: state_type] :
      ( v70544(VarCurr,3)
    <=> v68455(VarCurr,7) ) ).

tff(addAssignment_43684,axiom,
    ! [VarCurr: state_type] :
      ( v70538(VarCurr)
    <=> v70540(VarCurr) ) ).

tff(addAssignment_43683,axiom,
    ! [VarCurr: state_type] :
      ( v70540(VarCurr)
    <=> v67520(VarCurr,34) ) ).

tff(addAssignment_43682,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,34)
    <=> v52363(VarCurr,34) ) ).

tff(addAssignment_43681,axiom,
    ! [VarCurr: state_type] :
      ( v70534(VarCurr,3)
    <=> v70536(VarCurr,3) ) ).

tff(addAssignment_43680,axiom,
    ! [VarCurr: state_type] :
      ( v70536(VarCurr,3)
    <=> v68455(VarCurr,3) ) ).

tff(addAssignment_43679,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,3)
    <=> v68457(VarCurr,3) ) ).

tff(addAssignment_43678,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,3)
    <=> v68459(VarCurr,3) ) ).

tff(addAssignment_43677,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,3)
    <=> v68548(VarCurr,3) ) ).

tff(addAssignment_43676,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,3)
    <=> v68469(VarCurr,3) ) ).

tff(addAssignment_43675,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,3)
    <=> v68471(VarCurr,3) ) ).

tff(addAssignment_43674,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,3)
    <=> v67432(VarCurr,131) ) ).

tff(addAssignment_43673,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,131)
    <=> v67434(VarCurr,131) ) ).

tff(addAssignment_43672,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,131)
    <=> v68473(VarCurr,3) ) ).

tff(addAssignment_43671,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,3)
    <=> v68475(VarCurr,3) ) ).

tff(addAssignment_43670,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,3)
    <=> v68531(VarCurr,3) ) ).

tff(addAssignment_43669,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,3)
    <=> v68530(VarCurr,3) ) ).

tff(addAssignment_43668,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,3)
    <=> v6234(VarCurr,59) ) ).

tff(addAssignment_43667,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,3)
    <=> v68526(VarCurr,3) ) ).

tff(addAssignment_43666,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,3)
    <=> v53217(VarCurr,59) ) ).

tff(addAssignment_43665,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,3)
    <=> v68522(VarCurr,3) ) ).

tff(addAssignment_43664,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_43663,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,3)
    <=> v68463(VarCurr,3) ) ).

tff(addAssignment_43662,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,3)
    <=> v68464(VarCurr,3) ) ).

tff(addAssignment_43661,axiom,
    ! [VarCurr: state_type] :
      ( v70220(VarCurr)
    <=> v70222(VarCurr) ) ).

tff(addAssignment_43660,axiom,
    ! [VarCurr: state_type] :
      ( v70222(VarCurr)
    <=> v70224(VarCurr) ) ).

tff(addAssignment_43659,axiom,
    ! [VarCurr: state_type] :
      ( v70224(VarCurr)
    <=> v70226(VarCurr) ) ).

tff(addAssignment_43658,axiom,
    ! [VarCurr: state_type] :
      ( v70226(VarCurr)
    <=> v70228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6508,axiom,
    ! [VarCurr: state_type] :
      ( v70228(VarCurr)
    <=> ( v70520(VarCurr)
      <~> v70494(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6507,axiom,
    ! [VarCurr: state_type] :
      ( v70520(VarCurr)
    <=> ( v70230(VarCurr)
      <~> v70362(VarCurr) ) ) ).

tff(addAssignment_43657,axiom,
    ! [VarCurr: state_type] :
      ( v70494(VarCurr)
    <=> v70496(VarCurr) ) ).

tff(addAssignment_43656,axiom,
    ! [VarCurr: state_type] :
      ( v70496(VarCurr)
    <=> v70498(VarCurr) ) ).

tff(addAssignment_43655,axiom,
    ! [VarCurr: state_type] :
      ( v70498(VarCurr)
    <=> v70500(VarCurr) ) ).

tff(addAssignment_43654,axiom,
    ! [VarCurr: state_type] :
      ( v70500(VarCurr)
    <=> v70502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6506,axiom,
    ! [VarCurr: state_type] :
      ( v70502(VarCurr)
    <=> ( v70518(VarCurr)
      <~> v70512(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6505,axiom,
    ! [VarCurr: state_type] :
      ( v70518(VarCurr)
    <=> ( v70504(VarCurr)
      <~> v70508(VarCurr) ) ) ).

tff(addAssignment_43653,axiom,
    ! [VarCurr: state_type] :
      ( v70512(VarCurr)
    <=> v70514(VarCurr) ) ).

tff(addAssignment_43652,axiom,
    ! [VarCurr: state_type] :
      ( v70514(VarCurr)
    <=> v70516(VarCurr) ) ).

tff(addAssignment_43651,axiom,
    ! [VarCurr: state_type] :
      ( v70516(VarCurr)
    <=> v68583(VarCurr,0) ) ).

tff(addAssignment_43650,axiom,
    ! [VarCurr: state_type] :
      ( v68583(VarCurr,0)
    <=> v68585(VarCurr,0) ) ).

tff(addAssignment_43649,axiom,
    ! [VarCurr: state_type] :
      ( v68585(VarCurr,0)
    <=> v68587(VarCurr,0) ) ).

tff(addAssignment_43648,axiom,
    ! [VarCurr: state_type] :
      ( v68587(VarCurr,0)
    <=> v68589(VarCurr,0) ) ).

tff(addAssignment_43647,axiom,
    ! [VarCurr: state_type] :
      ( v68589(VarCurr,0)
    <=> v68662(VarCurr,0) ) ).

tff(addAssignment_43646,axiom,
    ! [VarCurr: state_type] :
      ( v70508(VarCurr)
    <=> v70510(VarCurr) ) ).

tff(addAssignment_43645,axiom,
    ! [VarCurr: state_type] :
      ( v70510(VarCurr)
    <=> v67349(VarCurr,127) ) ).

tff(addAssignment_43644,axiom,
    ! [VarCurr: state_type] :
      ( v70504(VarCurr)
    <=> v70506(VarCurr) ) ).

tff(addAssignment_43643,axiom,
    ! [VarCurr: state_type] :
      ( v70506(VarCurr)
    <=> v67349(VarCurr,123) ) ).

tff(addAssignment_43642,axiom,
    ! [VarCurr: state_type] :
      ( v70362(VarCurr)
    <=> v70364(VarCurr) ) ).

tff(addAssignment_43641,axiom,
    ! [VarCurr: state_type] :
      ( v70364(VarCurr)
    <=> v70366(VarCurr) ) ).

tff(addAssignment_43640,axiom,
    ! [VarCurr: state_type] :
      ( v70366(VarCurr)
    <=> v70368(VarCurr) ) ).

tff(addAssignment_43639,axiom,
    ! [VarCurr: state_type] :
      ( v70368(VarCurr)
    <=> v70370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6504,axiom,
    ! [VarCurr: state_type] :
      ( v70370(VarCurr)
    <=> ( v70492(VarCurr)
      <~> v70452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6503,axiom,
    ! [VarCurr: state_type] :
      ( v70492(VarCurr)
    <=> ( v70372(VarCurr)
      <~> v70412(VarCurr) ) ) ).

tff(addAssignment_43638,axiom,
    ! [VarCurr: state_type] :
      ( v70452(VarCurr)
    <=> v70454(VarCurr) ) ).

tff(addAssignment_43637,axiom,
    ! [VarCurr: state_type] :
      ( v70454(VarCurr)
    <=> v67349(VarCurr,119) ) ).

tff(addAssignment_43636,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,119)
    <=> v68249(VarCurr,55) ) ).

tff(addAssignment_43635,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,55)
    <=> v68251(VarCurr,55) ) ).

tff(addAssignment_43634,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,55)
    <=> v68253(VarCurr,55) ) ).

tff(addAssignment_43633,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,55)
    <=> v68255(VarCurr,55) ) ).

tff(addAssignment_43632,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,55)
    <=> v67359(VarCurr,119) ) ).

tff(addAssignment_43631,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,119)
    <=> v67580(VarCurr,119) ) ).

tff(addAssignment_43630,axiom,
    ! [VarCurr: state_type] :
      ( v67583(VarCurr,3)
    <=> v68258(VarCurr,55) ) ).

tff(addAssignment_43629,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,55)
    <=> v68260(VarCurr,55) ) ).

tff(addAssignment_43628,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,55)
    <=> v70484(VarNext,55) ) ).

tff(addCaseBooleanConditionEqualRanges1_852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70485(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70484(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_852,axiom,
    ! [VarNext: state_type] :
      ( v70485(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70484(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70485(VarNext)
      <=> v70486(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70486(VarNext)
      <=> ( v70488(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70488(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43627,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,55)
    <=> v68284(VarCurr,55) ) ).

tff(addAssignment_43626,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,55)
    <=> v67391(VarCurr,119) ) ).

tff(addAssignment_43625,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,119)
    <=> v70457(VarCurr,3) ) ).

tff(addAssignment_43624,axiom,
    ! [VarCurr: state_type] :
      ( v70457(VarCurr,3)
    <=> v70459(VarCurr,3) ) ).

tff(addAssignment_43623,axiom,
    ! [VarCurr: state_type] :
      ( v70459(VarCurr,3)
    <=> v70476(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70476(VarCurr,B)
      <=> ( v70477(VarCurr,B)
          | v70480(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70480(VarCurr,B)
      <=> ( v70469(VarCurr,B)
          & v70481(VarCurr,B) ) ) ) ).

tff(addAssignment_43622,axiom,
    ! [VarCurr: state_type] :
      ( v70481(VarCurr,0)
    <=> v70482(VarCurr) ) ).

tff(addAssignment_43621,axiom,
    ! [VarCurr: state_type] :
      ( v70481(VarCurr,1)
    <=> v70482(VarCurr) ) ).

tff(addAssignment_43620,axiom,
    ! [VarCurr: state_type] :
      ( v70481(VarCurr,2)
    <=> v70482(VarCurr) ) ).

tff(addAssignment_43619,axiom,
    ! [VarCurr: state_type] :
      ( v70481(VarCurr,3)
    <=> v70482(VarCurr) ) ).

tff(addAssignment_43618,axiom,
    ! [VarCurr: state_type] :
      ( v70482(VarCurr)
    <=> v70473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70477(VarCurr,B)
      <=> ( v70461(VarCurr,B)
          & v70478(VarCurr,B) ) ) ) ).

tff(addAssignment_43617,axiom,
    ! [VarCurr: state_type] :
      ( v70478(VarCurr,0)
    <=> v70479(VarCurr) ) ).

tff(addAssignment_43616,axiom,
    ! [VarCurr: state_type] :
      ( v70478(VarCurr,1)
    <=> v70479(VarCurr) ) ).

tff(addAssignment_43615,axiom,
    ! [VarCurr: state_type] :
      ( v70478(VarCurr,2)
    <=> v70479(VarCurr) ) ).

tff(addAssignment_43614,axiom,
    ! [VarCurr: state_type] :
      ( v70478(VarCurr,3)
    <=> v70479(VarCurr) ) ).

tff(addAssignment_43613,axiom,
    ! [VarCurr: state_type] :
      ( v70479(VarCurr)
    <=> v70465(VarCurr) ) ).

tff(addAssignment_43612,axiom,
    ! [VarCurr: state_type] :
      ( v70473(VarCurr)
    <=> v70475(VarCurr) ) ).

tff(addAssignment_43611,axiom,
    ! [VarCurr: state_type] :
      ( v70475(VarCurr)
    <=> v67530(VarCurr,29) ) ).

tff(addAssignment_43610,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,29)
    <=> v52381(VarCurr,29) ) ).

tff(addAssignment_43609,axiom,
    ! [VarCurr: state_type] :
      ( v70469(VarCurr,3)
    <=> v70471(VarCurr,3) ) ).

tff(addAssignment_43608,axiom,
    ! [VarCurr: state_type] :
      ( v70471(VarCurr,3)
    <=> v67401(VarCurr,119) ) ).

tff(addAssignment_43607,axiom,
    ! [VarCurr: state_type] :
      ( v70465(VarCurr)
    <=> v70467(VarCurr) ) ).

tff(addAssignment_43606,axiom,
    ! [VarCurr: state_type] :
      ( v70467(VarCurr)
    <=> v67520(VarCurr,29) ) ).

tff(addAssignment_43605,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,29)
    <=> v52363(VarCurr,29) ) ).

tff(addAssignment_43604,axiom,
    ! [VarCurr: state_type] :
      ( v70461(VarCurr,3)
    <=> v70463(VarCurr,3) ) ).

tff(addAssignment_43603,axiom,
    ! [VarCurr: state_type] :
      ( v70463(VarCurr,3)
    <=> v67401(VarCurr,123) ) ).

tff(addAssignment_43602,axiom,
    ! [VarCurr: state_type] :
      ( v70412(VarCurr)
    <=> v70414(VarCurr) ) ).

tff(addAssignment_43601,axiom,
    ! [VarCurr: state_type] :
      ( v70414(VarCurr)
    <=> v67349(VarCurr,115) ) ).

tff(addAssignment_43600,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,115)
    <=> v68249(VarCurr,51) ) ).

tff(addAssignment_43599,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,51)
    <=> v68251(VarCurr,51) ) ).

tff(addAssignment_43598,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,51)
    <=> v68253(VarCurr,51) ) ).

tff(addAssignment_43597,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,51)
    <=> v68255(VarCurr,51) ) ).

tff(addAssignment_43596,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,51)
    <=> v67359(VarCurr,115) ) ).

tff(addAssignment_43595,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,115)
    <=> v67580(VarCurr,115) ) ).

tff(addAssignment_43594,axiom,
    ! [VarCurr: state_type] :
      ( v67584(VarCurr,3)
    <=> v68258(VarCurr,51) ) ).

tff(addAssignment_43593,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,51)
    <=> v68260(VarCurr,51) ) ).

tff(addAssignment_43592,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,51)
    <=> v70444(VarNext,51) ) ).

tff(addCaseBooleanConditionEqualRanges1_851,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70445(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70444(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_851,axiom,
    ! [VarNext: state_type] :
      ( v70445(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70444(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70445(VarNext)
      <=> v70446(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70446(VarNext)
      <=> ( v70448(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70448(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43591,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,51)
    <=> v68284(VarCurr,51) ) ).

tff(addAssignment_43590,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,51)
    <=> v67391(VarCurr,115) ) ).

tff(addAssignment_43589,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,115)
    <=> v70417(VarCurr,3) ) ).

tff(addAssignment_43588,axiom,
    ! [VarCurr: state_type] :
      ( v70417(VarCurr,3)
    <=> v70419(VarCurr,3) ) ).

tff(addAssignment_43587,axiom,
    ! [VarCurr: state_type] :
      ( v70419(VarCurr,3)
    <=> v70436(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70436(VarCurr,B)
      <=> ( v70437(VarCurr,B)
          | v70440(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70440(VarCurr,B)
      <=> ( v70429(VarCurr,B)
          & v70441(VarCurr,B) ) ) ) ).

tff(addAssignment_43586,axiom,
    ! [VarCurr: state_type] :
      ( v70441(VarCurr,0)
    <=> v70442(VarCurr) ) ).

tff(addAssignment_43585,axiom,
    ! [VarCurr: state_type] :
      ( v70441(VarCurr,1)
    <=> v70442(VarCurr) ) ).

tff(addAssignment_43584,axiom,
    ! [VarCurr: state_type] :
      ( v70441(VarCurr,2)
    <=> v70442(VarCurr) ) ).

tff(addAssignment_43583,axiom,
    ! [VarCurr: state_type] :
      ( v70441(VarCurr,3)
    <=> v70442(VarCurr) ) ).

tff(addAssignment_43582,axiom,
    ! [VarCurr: state_type] :
      ( v70442(VarCurr)
    <=> v70433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70437(VarCurr,B)
      <=> ( v70421(VarCurr,B)
          & v70438(VarCurr,B) ) ) ) ).

tff(addAssignment_43581,axiom,
    ! [VarCurr: state_type] :
      ( v70438(VarCurr,0)
    <=> v70439(VarCurr) ) ).

tff(addAssignment_43580,axiom,
    ! [VarCurr: state_type] :
      ( v70438(VarCurr,1)
    <=> v70439(VarCurr) ) ).

tff(addAssignment_43579,axiom,
    ! [VarCurr: state_type] :
      ( v70438(VarCurr,2)
    <=> v70439(VarCurr) ) ).

tff(addAssignment_43578,axiom,
    ! [VarCurr: state_type] :
      ( v70438(VarCurr,3)
    <=> v70439(VarCurr) ) ).

tff(addAssignment_43577,axiom,
    ! [VarCurr: state_type] :
      ( v70439(VarCurr)
    <=> v70425(VarCurr) ) ).

tff(addAssignment_43576,axiom,
    ! [VarCurr: state_type] :
      ( v70433(VarCurr)
    <=> v70435(VarCurr) ) ).

tff(addAssignment_43575,axiom,
    ! [VarCurr: state_type] :
      ( v70435(VarCurr)
    <=> v67530(VarCurr,28) ) ).

tff(addAssignment_43574,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,28)
    <=> v52381(VarCurr,28) ) ).

tff(addAssignment_43573,axiom,
    ! [VarCurr: state_type] :
      ( v70429(VarCurr,3)
    <=> v70431(VarCurr,3) ) ).

tff(addAssignment_43572,axiom,
    ! [VarCurr: state_type] :
      ( v70431(VarCurr,3)
    <=> v67401(VarCurr,115) ) ).

tff(addAssignment_43571,axiom,
    ! [VarCurr: state_type] :
      ( v70425(VarCurr)
    <=> v70427(VarCurr) ) ).

tff(addAssignment_43570,axiom,
    ! [VarCurr: state_type] :
      ( v70427(VarCurr)
    <=> v67520(VarCurr,28) ) ).

tff(addAssignment_43569,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,28)
    <=> v52363(VarCurr,28) ) ).

tff(addAssignment_43568,axiom,
    ! [VarCurr: state_type] :
      ( v70421(VarCurr,3)
    <=> v70423(VarCurr,3) ) ).

tff(addAssignment_43567,axiom,
    ! [VarCurr: state_type] :
      ( v70423(VarCurr,3)
    <=> v67401(VarCurr,119) ) ).

tff(addAssignment_43566,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,119)
    <=> v68294(VarCurr,55) ) ).

tff(addAssignment_43565,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,55)
    <=> v68296(VarCurr,55) ) ).

tff(addAssignment_43564,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,55)
    <=> v68385(VarCurr,55) ) ).

tff(addAssignment_43563,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,55)
    <=> v68306(VarCurr,55) ) ).

tff(addAssignment_43562,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,55)
    <=> v67430(VarCurr,119) ) ).

tff(addAssignment_43561,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,119)
    <=> v67432(VarCurr,119) ) ).

tff(addAssignment_43560,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,119)
    <=> v67434(VarCurr,119) ) ).

tff(addAssignment_43559,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,119)
    <=> v68308(VarCurr,55) ) ).

tff(addAssignment_43558,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,55)
    <=> v68310(VarCurr,55) ) ).

tff(addAssignment_43557,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,55)
    <=> v68368(VarCurr,55) ) ).

tff(addAssignment_43556,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,55)
    <=> v68366(VarCurr,55) ) ).

tff(addAssignment_43555,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,55)
    <=> v68367(VarCurr,55) ) ).

tff(addAssignment_43554,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,55)
    <=> v68361(VarCurr,55) ) ).

tff(addAssignment_43553,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,55)
    <=> v68362(VarCurr,55) ) ).

tff(addAssignment_43552,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,55)
    <=> v68357(VarCurr,55) ) ).

tff(addAssignment_43551,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,55)
    <=> $false ) ).

tff(addAssignment_43550,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,55)
    <=> v68300(VarCurr,55) ) ).

tff(addAssignment_43549,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,55)
    <=> v68301(VarCurr,55) ) ).

tff(addAssignment_43548,axiom,
    ! [VarCurr: state_type] :
      ( v70372(VarCurr)
    <=> v70374(VarCurr) ) ).

tff(addAssignment_43547,axiom,
    ! [VarCurr: state_type] :
      ( v70374(VarCurr)
    <=> v67349(VarCurr,111) ) ).

tff(addAssignment_43546,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,111)
    <=> v68249(VarCurr,47) ) ).

tff(addAssignment_43545,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,47)
    <=> v68251(VarCurr,47) ) ).

tff(addAssignment_43544,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,47)
    <=> v68253(VarCurr,47) ) ).

tff(addAssignment_43543,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,47)
    <=> v68255(VarCurr,47) ) ).

tff(addAssignment_43542,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,47)
    <=> v67359(VarCurr,111) ) ).

tff(addAssignment_43541,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,111)
    <=> v67580(VarCurr,111) ) ).

tff(addAssignment_43540,axiom,
    ! [VarCurr: state_type] :
      ( v67585(VarCurr,3)
    <=> v68258(VarCurr,47) ) ).

tff(addAssignment_43539,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,47)
    <=> v68260(VarCurr,47) ) ).

tff(addAssignment_43538,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,47)
    <=> v70404(VarNext,47) ) ).

tff(addCaseBooleanConditionEqualRanges1_850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70405(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70404(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_850,axiom,
    ! [VarNext: state_type] :
      ( v70405(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70404(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70405(VarNext)
      <=> v70406(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70406(VarNext)
      <=> ( v70408(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70408(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43537,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,47)
    <=> v68284(VarCurr,47) ) ).

tff(addAssignment_43536,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,47)
    <=> v67391(VarCurr,111) ) ).

tff(addAssignment_43535,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,111)
    <=> v70377(VarCurr,3) ) ).

tff(addAssignment_43534,axiom,
    ! [VarCurr: state_type] :
      ( v70377(VarCurr,3)
    <=> v70379(VarCurr,3) ) ).

tff(addAssignment_43533,axiom,
    ! [VarCurr: state_type] :
      ( v70379(VarCurr,3)
    <=> v70396(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70396(VarCurr,B)
      <=> ( v70397(VarCurr,B)
          | v70400(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70400(VarCurr,B)
      <=> ( v70389(VarCurr,B)
          & v70401(VarCurr,B) ) ) ) ).

tff(addAssignment_43532,axiom,
    ! [VarCurr: state_type] :
      ( v70401(VarCurr,0)
    <=> v70402(VarCurr) ) ).

tff(addAssignment_43531,axiom,
    ! [VarCurr: state_type] :
      ( v70401(VarCurr,1)
    <=> v70402(VarCurr) ) ).

tff(addAssignment_43530,axiom,
    ! [VarCurr: state_type] :
      ( v70401(VarCurr,2)
    <=> v70402(VarCurr) ) ).

tff(addAssignment_43529,axiom,
    ! [VarCurr: state_type] :
      ( v70401(VarCurr,3)
    <=> v70402(VarCurr) ) ).

tff(addAssignment_43528,axiom,
    ! [VarCurr: state_type] :
      ( v70402(VarCurr)
    <=> v70393(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70397(VarCurr,B)
      <=> ( v70381(VarCurr,B)
          & v70398(VarCurr,B) ) ) ) ).

tff(addAssignment_43527,axiom,
    ! [VarCurr: state_type] :
      ( v70398(VarCurr,0)
    <=> v70399(VarCurr) ) ).

tff(addAssignment_43526,axiom,
    ! [VarCurr: state_type] :
      ( v70398(VarCurr,1)
    <=> v70399(VarCurr) ) ).

tff(addAssignment_43525,axiom,
    ! [VarCurr: state_type] :
      ( v70398(VarCurr,2)
    <=> v70399(VarCurr) ) ).

tff(addAssignment_43524,axiom,
    ! [VarCurr: state_type] :
      ( v70398(VarCurr,3)
    <=> v70399(VarCurr) ) ).

tff(addAssignment_43523,axiom,
    ! [VarCurr: state_type] :
      ( v70399(VarCurr)
    <=> v70385(VarCurr) ) ).

tff(addAssignment_43522,axiom,
    ! [VarCurr: state_type] :
      ( v70393(VarCurr)
    <=> v70395(VarCurr) ) ).

tff(addAssignment_43521,axiom,
    ! [VarCurr: state_type] :
      ( v70395(VarCurr)
    <=> v67530(VarCurr,27) ) ).

tff(addAssignment_43520,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,27)
    <=> v52381(VarCurr,27) ) ).

tff(addAssignment_43519,axiom,
    ! [VarCurr: state_type] :
      ( v70389(VarCurr,3)
    <=> v70391(VarCurr,3) ) ).

tff(addAssignment_43518,axiom,
    ! [VarCurr: state_type] :
      ( v70391(VarCurr,3)
    <=> v67401(VarCurr,111) ) ).

tff(addAssignment_43517,axiom,
    ! [VarCurr: state_type] :
      ( v70385(VarCurr)
    <=> v70387(VarCurr) ) ).

tff(addAssignment_43516,axiom,
    ! [VarCurr: state_type] :
      ( v70387(VarCurr)
    <=> v67520(VarCurr,27) ) ).

tff(addAssignment_43515,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,27)
    <=> v52363(VarCurr,27) ) ).

tff(addAssignment_43514,axiom,
    ! [VarCurr: state_type] :
      ( v70381(VarCurr,3)
    <=> v70383(VarCurr,3) ) ).

tff(addAssignment_43513,axiom,
    ! [VarCurr: state_type] :
      ( v70383(VarCurr,3)
    <=> v67401(VarCurr,115) ) ).

tff(addAssignment_43512,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,115)
    <=> v68294(VarCurr,51) ) ).

tff(addAssignment_43511,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,51)
    <=> v68296(VarCurr,51) ) ).

tff(addAssignment_43510,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,51)
    <=> v68385(VarCurr,51) ) ).

tff(addAssignment_43509,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,51)
    <=> v68306(VarCurr,51) ) ).

tff(addAssignment_43508,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,51)
    <=> v67430(VarCurr,115) ) ).

tff(addAssignment_43507,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,115)
    <=> v67432(VarCurr,115) ) ).

tff(addAssignment_43506,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,115)
    <=> v67434(VarCurr,115) ) ).

tff(addAssignment_43505,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,115)
    <=> v68308(VarCurr,51) ) ).

tff(addAssignment_43504,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,51)
    <=> v68310(VarCurr,51) ) ).

tff(addAssignment_43503,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,51)
    <=> v68368(VarCurr,51) ) ).

tff(addAssignment_43502,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,51)
    <=> v68366(VarCurr,51) ) ).

tff(addAssignment_43501,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,51)
    <=> v68367(VarCurr,51) ) ).

tff(addAssignment_43500,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,51)
    <=> v68361(VarCurr,51) ) ).

tff(addAssignment_43499,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,51)
    <=> v68362(VarCurr,51) ) ).

tff(addAssignment_43498,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,51)
    <=> v68357(VarCurr,51) ) ).

tff(addAssignment_43497,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,51)
    <=> $false ) ).

tff(addAssignment_43496,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,51)
    <=> v68300(VarCurr,51) ) ).

tff(addAssignment_43495,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,51)
    <=> v68301(VarCurr,51) ) ).

tff(addAssignment_43494,axiom,
    ! [VarCurr: state_type] :
      ( v70230(VarCurr)
    <=> v70232(VarCurr) ) ).

tff(addAssignment_43493,axiom,
    ! [VarCurr: state_type] :
      ( v70232(VarCurr)
    <=> v70234(VarCurr) ) ).

tff(addAssignment_43492,axiom,
    ! [VarCurr: state_type] :
      ( v70234(VarCurr)
    <=> v70236(VarCurr) ) ).

tff(addAssignment_43491,axiom,
    ! [VarCurr: state_type] :
      ( v70236(VarCurr)
    <=> v70238(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6496,axiom,
    ! [VarCurr: state_type] :
      ( v70238(VarCurr)
    <=> ( v70360(VarCurr)
      <~> v70320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6495,axiom,
    ! [VarCurr: state_type] :
      ( v70360(VarCurr)
    <=> ( v70240(VarCurr)
      <~> v70280(VarCurr) ) ) ).

tff(addAssignment_43490,axiom,
    ! [VarCurr: state_type] :
      ( v70320(VarCurr)
    <=> v70322(VarCurr) ) ).

tff(addAssignment_43489,axiom,
    ! [VarCurr: state_type] :
      ( v70322(VarCurr)
    <=> v67349(VarCurr,107) ) ).

tff(addAssignment_43488,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,107)
    <=> v68249(VarCurr,43) ) ).

tff(addAssignment_43487,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,43)
    <=> v68251(VarCurr,43) ) ).

tff(addAssignment_43486,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,43)
    <=> v68253(VarCurr,43) ) ).

tff(addAssignment_43485,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,43)
    <=> v68255(VarCurr,43) ) ).

tff(addAssignment_43484,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,43)
    <=> v67359(VarCurr,107) ) ).

tff(addAssignment_43483,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,107)
    <=> v67580(VarCurr,107) ) ).

tff(addAssignment_43482,axiom,
    ! [VarCurr: state_type] :
      ( v67586(VarCurr,3)
    <=> v68258(VarCurr,43) ) ).

tff(addAssignment_43481,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,43)
    <=> v68260(VarCurr,43) ) ).

tff(addAssignment_43480,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,43)
    <=> v70352(VarNext,43) ) ).

tff(addCaseBooleanConditionEqualRanges1_849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70353(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70352(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_849,axiom,
    ! [VarNext: state_type] :
      ( v70353(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70352(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70353(VarNext)
      <=> v70354(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70354(VarNext)
      <=> ( v70356(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70356(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43479,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,43)
    <=> v68284(VarCurr,43) ) ).

tff(addAssignment_43478,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,43)
    <=> v67391(VarCurr,107) ) ).

tff(addAssignment_43477,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,107)
    <=> v70325(VarCurr,3) ) ).

tff(addAssignment_43476,axiom,
    ! [VarCurr: state_type] :
      ( v70325(VarCurr,3)
    <=> v70327(VarCurr,3) ) ).

tff(addAssignment_43475,axiom,
    ! [VarCurr: state_type] :
      ( v70327(VarCurr,3)
    <=> v70344(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70344(VarCurr,B)
      <=> ( v70345(VarCurr,B)
          | v70348(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70348(VarCurr,B)
      <=> ( v70337(VarCurr,B)
          & v70349(VarCurr,B) ) ) ) ).

tff(addAssignment_43474,axiom,
    ! [VarCurr: state_type] :
      ( v70349(VarCurr,0)
    <=> v70350(VarCurr) ) ).

tff(addAssignment_43473,axiom,
    ! [VarCurr: state_type] :
      ( v70349(VarCurr,1)
    <=> v70350(VarCurr) ) ).

tff(addAssignment_43472,axiom,
    ! [VarCurr: state_type] :
      ( v70349(VarCurr,2)
    <=> v70350(VarCurr) ) ).

tff(addAssignment_43471,axiom,
    ! [VarCurr: state_type] :
      ( v70349(VarCurr,3)
    <=> v70350(VarCurr) ) ).

tff(addAssignment_43470,axiom,
    ! [VarCurr: state_type] :
      ( v70350(VarCurr)
    <=> v70341(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70345(VarCurr,B)
      <=> ( v70329(VarCurr,B)
          & v70346(VarCurr,B) ) ) ) ).

tff(addAssignment_43469,axiom,
    ! [VarCurr: state_type] :
      ( v70346(VarCurr,0)
    <=> v70347(VarCurr) ) ).

tff(addAssignment_43468,axiom,
    ! [VarCurr: state_type] :
      ( v70346(VarCurr,1)
    <=> v70347(VarCurr) ) ).

tff(addAssignment_43467,axiom,
    ! [VarCurr: state_type] :
      ( v70346(VarCurr,2)
    <=> v70347(VarCurr) ) ).

tff(addAssignment_43466,axiom,
    ! [VarCurr: state_type] :
      ( v70346(VarCurr,3)
    <=> v70347(VarCurr) ) ).

tff(addAssignment_43465,axiom,
    ! [VarCurr: state_type] :
      ( v70347(VarCurr)
    <=> v70333(VarCurr) ) ).

tff(addAssignment_43464,axiom,
    ! [VarCurr: state_type] :
      ( v70341(VarCurr)
    <=> v70343(VarCurr) ) ).

tff(addAssignment_43463,axiom,
    ! [VarCurr: state_type] :
      ( v70343(VarCurr)
    <=> v67530(VarCurr,26) ) ).

tff(addAssignment_43462,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,26)
    <=> v52381(VarCurr,26) ) ).

tff(addAssignment_43461,axiom,
    ! [VarCurr: state_type] :
      ( v70337(VarCurr,3)
    <=> v70339(VarCurr,3) ) ).

tff(addAssignment_43460,axiom,
    ! [VarCurr: state_type] :
      ( v70339(VarCurr,3)
    <=> v67401(VarCurr,107) ) ).

tff(addAssignment_43459,axiom,
    ! [VarCurr: state_type] :
      ( v70333(VarCurr)
    <=> v70335(VarCurr) ) ).

tff(addAssignment_43458,axiom,
    ! [VarCurr: state_type] :
      ( v70335(VarCurr)
    <=> v67520(VarCurr,26) ) ).

tff(addAssignment_43457,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,26)
    <=> v52363(VarCurr,26) ) ).

tff(addAssignment_43456,axiom,
    ! [VarCurr: state_type] :
      ( v70329(VarCurr,3)
    <=> v70331(VarCurr,3) ) ).

tff(addAssignment_43455,axiom,
    ! [VarCurr: state_type] :
      ( v70331(VarCurr,3)
    <=> v67401(VarCurr,111) ) ).

tff(addAssignment_43454,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,111)
    <=> v68294(VarCurr,47) ) ).

tff(addAssignment_43453,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,47)
    <=> v68296(VarCurr,47) ) ).

tff(addAssignment_43452,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,47)
    <=> v68385(VarCurr,47) ) ).

tff(addAssignment_43451,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,47)
    <=> v68306(VarCurr,47) ) ).

tff(addAssignment_43450,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,47)
    <=> v67430(VarCurr,111) ) ).

tff(addAssignment_43449,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,111)
    <=> v67432(VarCurr,111) ) ).

tff(addAssignment_43448,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,111)
    <=> v67434(VarCurr,111) ) ).

tff(addAssignment_43447,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,111)
    <=> v68308(VarCurr,47) ) ).

tff(addAssignment_43446,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,47)
    <=> v68310(VarCurr,47) ) ).

tff(addAssignment_43445,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,47)
    <=> v68368(VarCurr,47) ) ).

tff(addAssignment_43444,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,47)
    <=> v68366(VarCurr,47) ) ).

tff(addAssignment_43443,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,47)
    <=> v68367(VarCurr,47) ) ).

tff(addAssignment_43442,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,47)
    <=> v68361(VarCurr,47) ) ).

tff(addAssignment_43441,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,47)
    <=> v68362(VarCurr,47) ) ).

tff(addAssignment_43440,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,47)
    <=> v68357(VarCurr,47) ) ).

tff(addAssignment_43439,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,47)
    <=> $false ) ).

tff(addAssignment_43438,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,47)
    <=> v68300(VarCurr,47) ) ).

tff(addAssignment_43437,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,47)
    <=> v68301(VarCurr,47) ) ).

tff(addAssignment_43436,axiom,
    ! [VarCurr: state_type] :
      ( v70280(VarCurr)
    <=> v70282(VarCurr) ) ).

tff(addAssignment_43435,axiom,
    ! [VarCurr: state_type] :
      ( v70282(VarCurr)
    <=> v67349(VarCurr,103) ) ).

tff(addAssignment_43434,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,103)
    <=> v68249(VarCurr,39) ) ).

tff(addAssignment_43433,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,39)
    <=> v68251(VarCurr,39) ) ).

tff(addAssignment_43432,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,39)
    <=> v68253(VarCurr,39) ) ).

tff(addAssignment_43431,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,39)
    <=> v68255(VarCurr,39) ) ).

tff(addAssignment_43430,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,39)
    <=> v67359(VarCurr,103) ) ).

tff(addAssignment_43429,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,103)
    <=> v67580(VarCurr,103) ) ).

tff(addAssignment_43428,axiom,
    ! [VarCurr: state_type] :
      ( v67587(VarCurr,3)
    <=> v68258(VarCurr,39) ) ).

tff(addAssignment_43427,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,39)
    <=> v68260(VarCurr,39) ) ).

tff(addAssignment_43426,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,39)
    <=> v70312(VarNext,39) ) ).

tff(addCaseBooleanConditionEqualRanges1_848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70313(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70312(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_848,axiom,
    ! [VarNext: state_type] :
      ( v70313(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70312(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70313(VarNext)
      <=> v70314(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70314(VarNext)
      <=> ( v70316(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70316(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43425,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,39)
    <=> v68284(VarCurr,39) ) ).

tff(addAssignment_43424,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,39)
    <=> v67391(VarCurr,103) ) ).

tff(addAssignment_43423,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,103)
    <=> v70285(VarCurr,3) ) ).

tff(addAssignment_43422,axiom,
    ! [VarCurr: state_type] :
      ( v70285(VarCurr,3)
    <=> v70287(VarCurr,3) ) ).

tff(addAssignment_43421,axiom,
    ! [VarCurr: state_type] :
      ( v70287(VarCurr,3)
    <=> v70304(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70304(VarCurr,B)
      <=> ( v70305(VarCurr,B)
          | v70308(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70308(VarCurr,B)
      <=> ( v70297(VarCurr,B)
          & v70309(VarCurr,B) ) ) ) ).

tff(addAssignment_43420,axiom,
    ! [VarCurr: state_type] :
      ( v70309(VarCurr,0)
    <=> v70310(VarCurr) ) ).

tff(addAssignment_43419,axiom,
    ! [VarCurr: state_type] :
      ( v70309(VarCurr,1)
    <=> v70310(VarCurr) ) ).

tff(addAssignment_43418,axiom,
    ! [VarCurr: state_type] :
      ( v70309(VarCurr,2)
    <=> v70310(VarCurr) ) ).

tff(addAssignment_43417,axiom,
    ! [VarCurr: state_type] :
      ( v70309(VarCurr,3)
    <=> v70310(VarCurr) ) ).

tff(addAssignment_43416,axiom,
    ! [VarCurr: state_type] :
      ( v70310(VarCurr)
    <=> v70301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70305(VarCurr,B)
      <=> ( v70289(VarCurr,B)
          & v70306(VarCurr,B) ) ) ) ).

tff(addAssignment_43415,axiom,
    ! [VarCurr: state_type] :
      ( v70306(VarCurr,0)
    <=> v70307(VarCurr) ) ).

tff(addAssignment_43414,axiom,
    ! [VarCurr: state_type] :
      ( v70306(VarCurr,1)
    <=> v70307(VarCurr) ) ).

tff(addAssignment_43413,axiom,
    ! [VarCurr: state_type] :
      ( v70306(VarCurr,2)
    <=> v70307(VarCurr) ) ).

tff(addAssignment_43412,axiom,
    ! [VarCurr: state_type] :
      ( v70306(VarCurr,3)
    <=> v70307(VarCurr) ) ).

tff(addAssignment_43411,axiom,
    ! [VarCurr: state_type] :
      ( v70307(VarCurr)
    <=> v70293(VarCurr) ) ).

tff(addAssignment_43410,axiom,
    ! [VarCurr: state_type] :
      ( v70301(VarCurr)
    <=> v70303(VarCurr) ) ).

tff(addAssignment_43409,axiom,
    ! [VarCurr: state_type] :
      ( v70303(VarCurr)
    <=> v67530(VarCurr,25) ) ).

tff(addAssignment_43408,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,25)
    <=> v52381(VarCurr,25) ) ).

tff(addAssignment_43407,axiom,
    ! [VarCurr: state_type] :
      ( v70297(VarCurr,3)
    <=> v70299(VarCurr,3) ) ).

tff(addAssignment_43406,axiom,
    ! [VarCurr: state_type] :
      ( v70299(VarCurr,3)
    <=> v67401(VarCurr,103) ) ).

tff(addAssignment_43405,axiom,
    ! [VarCurr: state_type] :
      ( v70293(VarCurr)
    <=> v70295(VarCurr) ) ).

tff(addAssignment_43404,axiom,
    ! [VarCurr: state_type] :
      ( v70295(VarCurr)
    <=> v67520(VarCurr,25) ) ).

tff(addAssignment_43403,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,25)
    <=> v52363(VarCurr,25) ) ).

tff(addAssignment_43402,axiom,
    ! [VarCurr: state_type] :
      ( v70289(VarCurr,3)
    <=> v70291(VarCurr,3) ) ).

tff(addAssignment_43401,axiom,
    ! [VarCurr: state_type] :
      ( v70291(VarCurr,3)
    <=> v67401(VarCurr,107) ) ).

tff(addAssignment_43400,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,107)
    <=> v68294(VarCurr,43) ) ).

tff(addAssignment_43399,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,43)
    <=> v68296(VarCurr,43) ) ).

tff(addAssignment_43398,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,43)
    <=> v68385(VarCurr,43) ) ).

tff(addAssignment_43397,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,43)
    <=> v68306(VarCurr,43) ) ).

tff(addAssignment_43396,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,43)
    <=> v67430(VarCurr,107) ) ).

tff(addAssignment_43395,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,107)
    <=> v67432(VarCurr,107) ) ).

tff(addAssignment_43394,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,107)
    <=> v67434(VarCurr,107) ) ).

tff(addAssignment_43393,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,107)
    <=> v68308(VarCurr,43) ) ).

tff(addAssignment_43392,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,43)
    <=> v68310(VarCurr,43) ) ).

tff(addAssignment_43391,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,43)
    <=> v68368(VarCurr,43) ) ).

tff(addAssignment_43390,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,43)
    <=> v68366(VarCurr,43) ) ).

tff(addAssignment_43389,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,43)
    <=> v68367(VarCurr,43) ) ).

tff(addAssignment_43388,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,43)
    <=> v68361(VarCurr,43) ) ).

tff(addAssignment_43387,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,43)
    <=> v68362(VarCurr,43) ) ).

tff(addAssignment_43386,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,43)
    <=> v68357(VarCurr,43) ) ).

tff(addAssignment_43385,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,43)
    <=> $false ) ).

tff(addAssignment_43384,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,43)
    <=> v68300(VarCurr,43) ) ).

tff(addAssignment_43383,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,43)
    <=> v68301(VarCurr,43) ) ).

tff(addAssignment_43382,axiom,
    ! [VarCurr: state_type] :
      ( v70240(VarCurr)
    <=> v70242(VarCurr) ) ).

tff(addAssignment_43381,axiom,
    ! [VarCurr: state_type] :
      ( v70242(VarCurr)
    <=> v67349(VarCurr,99) ) ).

tff(addAssignment_43380,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,99)
    <=> v68249(VarCurr,35) ) ).

tff(addAssignment_43379,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,35)
    <=> v68251(VarCurr,35) ) ).

tff(addAssignment_43378,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,35)
    <=> v68253(VarCurr,35) ) ).

tff(addAssignment_43377,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,35)
    <=> v68255(VarCurr,35) ) ).

tff(addAssignment_43376,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,35)
    <=> v67359(VarCurr,99) ) ).

tff(addAssignment_43375,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,99)
    <=> v67580(VarCurr,99) ) ).

tff(addAssignment_43374,axiom,
    ! [VarCurr: state_type] :
      ( v67588(VarCurr,3)
    <=> v68258(VarCurr,35) ) ).

tff(addAssignment_43373,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,35)
    <=> v68260(VarCurr,35) ) ).

tff(addAssignment_43372,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,35)
    <=> v70272(VarNext,35) ) ).

tff(addCaseBooleanConditionEqualRanges1_847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70273(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70272(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_847,axiom,
    ! [VarNext: state_type] :
      ( v70273(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70272(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70273(VarNext)
      <=> v70274(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70274(VarNext)
      <=> ( v70276(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70276(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43371,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,35)
    <=> v68284(VarCurr,35) ) ).

tff(addAssignment_43370,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,35)
    <=> v67391(VarCurr,99) ) ).

tff(addAssignment_43369,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,99)
    <=> v70245(VarCurr,3) ) ).

tff(addAssignment_43368,axiom,
    ! [VarCurr: state_type] :
      ( v70245(VarCurr,3)
    <=> v70247(VarCurr,3) ) ).

tff(addAssignment_43367,axiom,
    ! [VarCurr: state_type] :
      ( v70247(VarCurr,3)
    <=> v70264(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70264(VarCurr,B)
      <=> ( v70265(VarCurr,B)
          | v70268(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70268(VarCurr,B)
      <=> ( v70257(VarCurr,B)
          & v70269(VarCurr,B) ) ) ) ).

tff(addAssignment_43366,axiom,
    ! [VarCurr: state_type] :
      ( v70269(VarCurr,0)
    <=> v70270(VarCurr) ) ).

tff(addAssignment_43365,axiom,
    ! [VarCurr: state_type] :
      ( v70269(VarCurr,1)
    <=> v70270(VarCurr) ) ).

tff(addAssignment_43364,axiom,
    ! [VarCurr: state_type] :
      ( v70269(VarCurr,2)
    <=> v70270(VarCurr) ) ).

tff(addAssignment_43363,axiom,
    ! [VarCurr: state_type] :
      ( v70269(VarCurr,3)
    <=> v70270(VarCurr) ) ).

tff(addAssignment_43362,axiom,
    ! [VarCurr: state_type] :
      ( v70270(VarCurr)
    <=> v70261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70265(VarCurr,B)
      <=> ( v70249(VarCurr,B)
          & v70266(VarCurr,B) ) ) ) ).

tff(addAssignment_43361,axiom,
    ! [VarCurr: state_type] :
      ( v70266(VarCurr,0)
    <=> v70267(VarCurr) ) ).

tff(addAssignment_43360,axiom,
    ! [VarCurr: state_type] :
      ( v70266(VarCurr,1)
    <=> v70267(VarCurr) ) ).

tff(addAssignment_43359,axiom,
    ! [VarCurr: state_type] :
      ( v70266(VarCurr,2)
    <=> v70267(VarCurr) ) ).

tff(addAssignment_43358,axiom,
    ! [VarCurr: state_type] :
      ( v70266(VarCurr,3)
    <=> v70267(VarCurr) ) ).

tff(addAssignment_43357,axiom,
    ! [VarCurr: state_type] :
      ( v70267(VarCurr)
    <=> v70253(VarCurr) ) ).

tff(addAssignment_43356,axiom,
    ! [VarCurr: state_type] :
      ( v70261(VarCurr)
    <=> v70263(VarCurr) ) ).

tff(addAssignment_43355,axiom,
    ! [VarCurr: state_type] :
      ( v70263(VarCurr)
    <=> v67530(VarCurr,24) ) ).

tff(addAssignment_43354,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,24)
    <=> v52381(VarCurr,24) ) ).

tff(addAssignment_43353,axiom,
    ! [VarCurr: state_type] :
      ( v70257(VarCurr,3)
    <=> v70259(VarCurr,3) ) ).

tff(addAssignment_43352,axiom,
    ! [VarCurr: state_type] :
      ( v70259(VarCurr,3)
    <=> v67401(VarCurr,99) ) ).

tff(addAssignment_43351,axiom,
    ! [VarCurr: state_type] :
      ( v70253(VarCurr)
    <=> v70255(VarCurr) ) ).

tff(addAssignment_43350,axiom,
    ! [VarCurr: state_type] :
      ( v70255(VarCurr)
    <=> v67520(VarCurr,24) ) ).

tff(addAssignment_43349,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,24)
    <=> v52363(VarCurr,24) ) ).

tff(addAssignment_43348,axiom,
    ! [VarCurr: state_type] :
      ( v70249(VarCurr,3)
    <=> v70251(VarCurr,3) ) ).

tff(addAssignment_43347,axiom,
    ! [VarCurr: state_type] :
      ( v70251(VarCurr,3)
    <=> v67401(VarCurr,103) ) ).

tff(addAssignment_43346,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,103)
    <=> v68294(VarCurr,39) ) ).

tff(addAssignment_43345,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,39)
    <=> v68296(VarCurr,39) ) ).

tff(addAssignment_43344,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,39)
    <=> v68385(VarCurr,39) ) ).

tff(addAssignment_43343,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,39)
    <=> v68306(VarCurr,39) ) ).

tff(addAssignment_43342,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,39)
    <=> v67430(VarCurr,103) ) ).

tff(addAssignment_43341,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,103)
    <=> v67432(VarCurr,103) ) ).

tff(addAssignment_43340,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,103)
    <=> v67434(VarCurr,103) ) ).

tff(addAssignment_43339,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,103)
    <=> v68308(VarCurr,39) ) ).

tff(addAssignment_43338,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,39)
    <=> v68310(VarCurr,39) ) ).

tff(addAssignment_43337,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,39)
    <=> v68368(VarCurr,39) ) ).

tff(addAssignment_43336,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,39)
    <=> v68366(VarCurr,39) ) ).

tff(addAssignment_43335,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,39)
    <=> v68367(VarCurr,39) ) ).

tff(addAssignment_43334,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,39)
    <=> v68361(VarCurr,39) ) ).

tff(addAssignment_43333,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,39)
    <=> v68362(VarCurr,39) ) ).

tff(addAssignment_43332,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,39)
    <=> v68357(VarCurr,39) ) ).

tff(addAssignment_43331,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,39)
    <=> $false ) ).

tff(addAssignment_43330,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,39)
    <=> v68300(VarCurr,39) ) ).

tff(addAssignment_43329,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,39)
    <=> v68301(VarCurr,39) ) ).

tff(addAssignment_43328,axiom,
    ! [VarCurr: state_type] :
      ( v69812(VarCurr)
    <=> v69814(VarCurr) ) ).

tff(addAssignment_43327,axiom,
    ! [VarCurr: state_type] :
      ( v69814(VarCurr)
    <=> v69816(VarCurr) ) ).

tff(addAssignment_43326,axiom,
    ! [VarCurr: state_type] :
      ( v69816(VarCurr)
    <=> v69818(VarCurr) ) ).

tff(addAssignment_43325,axiom,
    ! [VarCurr: state_type] :
      ( v69818(VarCurr)
    <=> v69820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6488,axiom,
    ! [VarCurr: state_type] :
      ( v69820(VarCurr)
    <=> ( v70218(VarCurr)
      <~> v70086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6487,axiom,
    ! [VarCurr: state_type] :
      ( v70218(VarCurr)
    <=> ( v69822(VarCurr)
      <~> v69954(VarCurr) ) ) ).

tff(addAssignment_43324,axiom,
    ! [VarCurr: state_type] :
      ( v70086(VarCurr)
    <=> v70088(VarCurr) ) ).

tff(addAssignment_43323,axiom,
    ! [VarCurr: state_type] :
      ( v70088(VarCurr)
    <=> v70090(VarCurr) ) ).

tff(addAssignment_43322,axiom,
    ! [VarCurr: state_type] :
      ( v70090(VarCurr)
    <=> v70092(VarCurr) ) ).

tff(addAssignment_43321,axiom,
    ! [VarCurr: state_type] :
      ( v70092(VarCurr)
    <=> v70094(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6486,axiom,
    ! [VarCurr: state_type] :
      ( v70094(VarCurr)
    <=> ( v70216(VarCurr)
      <~> v70176(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6485,axiom,
    ! [VarCurr: state_type] :
      ( v70216(VarCurr)
    <=> ( v70096(VarCurr)
      <~> v70136(VarCurr) ) ) ).

tff(addAssignment_43320,axiom,
    ! [VarCurr: state_type] :
      ( v70176(VarCurr)
    <=> v70178(VarCurr) ) ).

tff(addAssignment_43319,axiom,
    ! [VarCurr: state_type] :
      ( v70178(VarCurr)
    <=> v67349(VarCurr,95) ) ).

tff(addAssignment_43318,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,95)
    <=> v68249(VarCurr,31) ) ).

tff(addAssignment_43317,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,31)
    <=> v68251(VarCurr,31) ) ).

tff(addAssignment_43316,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,31)
    <=> v68253(VarCurr,31) ) ).

tff(addAssignment_43315,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,31)
    <=> v68255(VarCurr,31) ) ).

tff(addAssignment_43314,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,31)
    <=> v67359(VarCurr,95) ) ).

tff(addAssignment_43313,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,95)
    <=> v67580(VarCurr,95) ) ).

tff(addAssignment_43312,axiom,
    ! [VarCurr: state_type] :
      ( v67589(VarCurr,3)
    <=> v68258(VarCurr,31) ) ).

tff(addAssignment_43311,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,31)
    <=> v68260(VarCurr,31) ) ).

tff(addAssignment_43310,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,31)
    <=> v70208(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70209(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70208(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_846,axiom,
    ! [VarNext: state_type] :
      ( v70209(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70208(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70209(VarNext)
      <=> v70210(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70210(VarNext)
      <=> ( v70212(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3378,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70212(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43309,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,31)
    <=> v68284(VarCurr,31) ) ).

tff(addAssignment_43308,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,31)
    <=> v67391(VarCurr,95) ) ).

tff(addAssignment_43307,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,95)
    <=> v70181(VarCurr,3) ) ).

tff(addAssignment_43306,axiom,
    ! [VarCurr: state_type] :
      ( v70181(VarCurr,3)
    <=> v70183(VarCurr,3) ) ).

tff(addAssignment_43305,axiom,
    ! [VarCurr: state_type] :
      ( v70183(VarCurr,3)
    <=> v70200(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70200(VarCurr,B)
      <=> ( v70201(VarCurr,B)
          | v70204(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70204(VarCurr,B)
      <=> ( v70193(VarCurr,B)
          & v70205(VarCurr,B) ) ) ) ).

tff(addAssignment_43304,axiom,
    ! [VarCurr: state_type] :
      ( v70205(VarCurr,0)
    <=> v70206(VarCurr) ) ).

tff(addAssignment_43303,axiom,
    ! [VarCurr: state_type] :
      ( v70205(VarCurr,1)
    <=> v70206(VarCurr) ) ).

tff(addAssignment_43302,axiom,
    ! [VarCurr: state_type] :
      ( v70205(VarCurr,2)
    <=> v70206(VarCurr) ) ).

tff(addAssignment_43301,axiom,
    ! [VarCurr: state_type] :
      ( v70205(VarCurr,3)
    <=> v70206(VarCurr) ) ).

tff(addAssignment_43300,axiom,
    ! [VarCurr: state_type] :
      ( v70206(VarCurr)
    <=> v70197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70201(VarCurr,B)
      <=> ( v70185(VarCurr,B)
          & v70202(VarCurr,B) ) ) ) ).

tff(addAssignment_43299,axiom,
    ! [VarCurr: state_type] :
      ( v70202(VarCurr,0)
    <=> v70203(VarCurr) ) ).

tff(addAssignment_43298,axiom,
    ! [VarCurr: state_type] :
      ( v70202(VarCurr,1)
    <=> v70203(VarCurr) ) ).

tff(addAssignment_43297,axiom,
    ! [VarCurr: state_type] :
      ( v70202(VarCurr,2)
    <=> v70203(VarCurr) ) ).

tff(addAssignment_43296,axiom,
    ! [VarCurr: state_type] :
      ( v70202(VarCurr,3)
    <=> v70203(VarCurr) ) ).

tff(addAssignment_43295,axiom,
    ! [VarCurr: state_type] :
      ( v70203(VarCurr)
    <=> v70189(VarCurr) ) ).

tff(addAssignment_43294,axiom,
    ! [VarCurr: state_type] :
      ( v70197(VarCurr)
    <=> v70199(VarCurr) ) ).

tff(addAssignment_43293,axiom,
    ! [VarCurr: state_type] :
      ( v70199(VarCurr)
    <=> v67530(VarCurr,23) ) ).

tff(addAssignment_43292,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,23)
    <=> v52381(VarCurr,23) ) ).

tff(addAssignment_43291,axiom,
    ! [VarCurr: state_type] :
      ( v70193(VarCurr,3)
    <=> v70195(VarCurr,3) ) ).

tff(addAssignment_43290,axiom,
    ! [VarCurr: state_type] :
      ( v70195(VarCurr,3)
    <=> v67401(VarCurr,95) ) ).

tff(addAssignment_43289,axiom,
    ! [VarCurr: state_type] :
      ( v70189(VarCurr)
    <=> v70191(VarCurr) ) ).

tff(addAssignment_43288,axiom,
    ! [VarCurr: state_type] :
      ( v70191(VarCurr)
    <=> v67520(VarCurr,23) ) ).

tff(addAssignment_43287,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,23)
    <=> v52363(VarCurr,23) ) ).

tff(addAssignment_43286,axiom,
    ! [VarCurr: state_type] :
      ( v70185(VarCurr,3)
    <=> v70187(VarCurr,3) ) ).

tff(addAssignment_43285,axiom,
    ! [VarCurr: state_type] :
      ( v70187(VarCurr,3)
    <=> v67401(VarCurr,99) ) ).

tff(addAssignment_43284,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,99)
    <=> v68294(VarCurr,35) ) ).

tff(addAssignment_43283,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,35)
    <=> v68296(VarCurr,35) ) ).

tff(addAssignment_43282,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,35)
    <=> v68385(VarCurr,35) ) ).

tff(addAssignment_43281,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,35)
    <=> v68306(VarCurr,35) ) ).

tff(addAssignment_43280,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,35)
    <=> v67430(VarCurr,99) ) ).

tff(addAssignment_43279,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,99)
    <=> v67432(VarCurr,99) ) ).

tff(addAssignment_43278,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,99)
    <=> v67434(VarCurr,99) ) ).

tff(addAssignment_43277,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,99)
    <=> v68308(VarCurr,35) ) ).

tff(addAssignment_43276,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,35)
    <=> v68310(VarCurr,35) ) ).

tff(addAssignment_43275,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,35)
    <=> v68368(VarCurr,35) ) ).

tff(addAssignment_43274,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,35)
    <=> v68366(VarCurr,35) ) ).

tff(addAssignment_43273,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,35)
    <=> v68367(VarCurr,35) ) ).

tff(addAssignment_43272,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,35)
    <=> v68361(VarCurr,35) ) ).

tff(addAssignment_43271,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,35)
    <=> v68362(VarCurr,35) ) ).

tff(addAssignment_43270,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,35)
    <=> v68357(VarCurr,35) ) ).

tff(addAssignment_43269,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,35)
    <=> $false ) ).

tff(addAssignment_43268,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,35)
    <=> v68300(VarCurr,35) ) ).

tff(addAssignment_43267,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,35)
    <=> v68301(VarCurr,35) ) ).

tff(addAssignment_43266,axiom,
    ! [VarCurr: state_type] :
      ( v70136(VarCurr)
    <=> v70138(VarCurr) ) ).

tff(addAssignment_43265,axiom,
    ! [VarCurr: state_type] :
      ( v70138(VarCurr)
    <=> v67349(VarCurr,91) ) ).

tff(addAssignment_43264,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,91)
    <=> v68249(VarCurr,27) ) ).

tff(addAssignment_43263,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,27)
    <=> v68251(VarCurr,27) ) ).

tff(addAssignment_43262,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,27)
    <=> v68253(VarCurr,27) ) ).

tff(addAssignment_43261,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,27)
    <=> v68255(VarCurr,27) ) ).

tff(addAssignment_43260,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,27)
    <=> v67359(VarCurr,91) ) ).

tff(addAssignment_43259,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,91)
    <=> v67580(VarCurr,91) ) ).

tff(addAssignment_43258,axiom,
    ! [VarCurr: state_type] :
      ( v67590(VarCurr,3)
    <=> v68258(VarCurr,27) ) ).

tff(addAssignment_43257,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,27)
    <=> v68260(VarCurr,27) ) ).

tff(addAssignment_43256,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,27)
    <=> v70168(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70169(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70168(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_845,axiom,
    ! [VarNext: state_type] :
      ( v70169(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70168(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70169(VarNext)
      <=> v70170(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70170(VarNext)
      <=> ( v70172(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70172(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43255,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,27)
    <=> v68284(VarCurr,27) ) ).

tff(addAssignment_43254,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,27)
    <=> v67391(VarCurr,91) ) ).

tff(addAssignment_43253,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,91)
    <=> v70141(VarCurr,3) ) ).

tff(addAssignment_43252,axiom,
    ! [VarCurr: state_type] :
      ( v70141(VarCurr,3)
    <=> v70143(VarCurr,3) ) ).

tff(addAssignment_43251,axiom,
    ! [VarCurr: state_type] :
      ( v70143(VarCurr,3)
    <=> v70160(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70160(VarCurr,B)
      <=> ( v70161(VarCurr,B)
          | v70164(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70164(VarCurr,B)
      <=> ( v70153(VarCurr,B)
          & v70165(VarCurr,B) ) ) ) ).

tff(addAssignment_43250,axiom,
    ! [VarCurr: state_type] :
      ( v70165(VarCurr,0)
    <=> v70166(VarCurr) ) ).

tff(addAssignment_43249,axiom,
    ! [VarCurr: state_type] :
      ( v70165(VarCurr,1)
    <=> v70166(VarCurr) ) ).

tff(addAssignment_43248,axiom,
    ! [VarCurr: state_type] :
      ( v70165(VarCurr,2)
    <=> v70166(VarCurr) ) ).

tff(addAssignment_43247,axiom,
    ! [VarCurr: state_type] :
      ( v70165(VarCurr,3)
    <=> v70166(VarCurr) ) ).

tff(addAssignment_43246,axiom,
    ! [VarCurr: state_type] :
      ( v70166(VarCurr)
    <=> v70157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70161(VarCurr,B)
      <=> ( v70145(VarCurr,B)
          & v70162(VarCurr,B) ) ) ) ).

tff(addAssignment_43245,axiom,
    ! [VarCurr: state_type] :
      ( v70162(VarCurr,0)
    <=> v70163(VarCurr) ) ).

tff(addAssignment_43244,axiom,
    ! [VarCurr: state_type] :
      ( v70162(VarCurr,1)
    <=> v70163(VarCurr) ) ).

tff(addAssignment_43243,axiom,
    ! [VarCurr: state_type] :
      ( v70162(VarCurr,2)
    <=> v70163(VarCurr) ) ).

tff(addAssignment_43242,axiom,
    ! [VarCurr: state_type] :
      ( v70162(VarCurr,3)
    <=> v70163(VarCurr) ) ).

tff(addAssignment_43241,axiom,
    ! [VarCurr: state_type] :
      ( v70163(VarCurr)
    <=> v70149(VarCurr) ) ).

tff(addAssignment_43240,axiom,
    ! [VarCurr: state_type] :
      ( v70157(VarCurr)
    <=> v70159(VarCurr) ) ).

tff(addAssignment_43239,axiom,
    ! [VarCurr: state_type] :
      ( v70159(VarCurr)
    <=> v67530(VarCurr,22) ) ).

tff(addAssignment_43238,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,22)
    <=> v52381(VarCurr,22) ) ).

tff(addAssignment_43237,axiom,
    ! [VarCurr: state_type] :
      ( v70153(VarCurr,3)
    <=> v70155(VarCurr,3) ) ).

tff(addAssignment_43236,axiom,
    ! [VarCurr: state_type] :
      ( v70155(VarCurr,3)
    <=> v67401(VarCurr,91) ) ).

tff(addAssignment_43235,axiom,
    ! [VarCurr: state_type] :
      ( v70149(VarCurr)
    <=> v70151(VarCurr) ) ).

tff(addAssignment_43234,axiom,
    ! [VarCurr: state_type] :
      ( v70151(VarCurr)
    <=> v67520(VarCurr,22) ) ).

tff(addAssignment_43233,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,22)
    <=> v52363(VarCurr,22) ) ).

tff(addAssignment_43232,axiom,
    ! [VarCurr: state_type] :
      ( v70145(VarCurr,3)
    <=> v70147(VarCurr,3) ) ).

tff(addAssignment_43231,axiom,
    ! [VarCurr: state_type] :
      ( v70147(VarCurr,3)
    <=> v67401(VarCurr,95) ) ).

tff(addAssignment_43230,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,95)
    <=> v68294(VarCurr,31) ) ).

tff(addAssignment_43229,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,31)
    <=> v68296(VarCurr,31) ) ).

tff(addAssignment_43228,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,31)
    <=> v68385(VarCurr,31) ) ).

tff(addAssignment_43227,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,31)
    <=> v68306(VarCurr,31) ) ).

tff(addAssignment_43226,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,31)
    <=> v67430(VarCurr,95) ) ).

tff(addAssignment_43225,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,95)
    <=> v67432(VarCurr,95) ) ).

tff(addAssignment_43224,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,95)
    <=> v67434(VarCurr,95) ) ).

tff(addAssignment_43223,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,95)
    <=> v68308(VarCurr,31) ) ).

tff(addAssignment_43222,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,31)
    <=> v68310(VarCurr,31) ) ).

tff(addAssignment_43221,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,31)
    <=> v68368(VarCurr,31) ) ).

tff(addAssignment_43220,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,31)
    <=> v68366(VarCurr,31) ) ).

tff(addAssignment_43219,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,31)
    <=> v68367(VarCurr,31) ) ).

tff(addAssignment_43218,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,31)
    <=> v68361(VarCurr,31) ) ).

tff(addAssignment_43217,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,31)
    <=> v68362(VarCurr,31) ) ).

tff(addAssignment_43216,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,31)
    <=> v68357(VarCurr,31) ) ).

tff(addAssignment_43215,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_43214,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,31)
    <=> v68300(VarCurr,31) ) ).

tff(addAssignment_43213,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,31)
    <=> v68301(VarCurr,31) ) ).

tff(addAssignment_43212,axiom,
    ! [VarCurr: state_type] :
      ( v70096(VarCurr)
    <=> v70098(VarCurr) ) ).

tff(addAssignment_43211,axiom,
    ! [VarCurr: state_type] :
      ( v70098(VarCurr)
    <=> v67349(VarCurr,87) ) ).

tff(addAssignment_43210,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,87)
    <=> v68249(VarCurr,23) ) ).

tff(addAssignment_43209,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,23)
    <=> v68251(VarCurr,23) ) ).

tff(addAssignment_43208,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,23)
    <=> v68253(VarCurr,23) ) ).

tff(addAssignment_43207,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,23)
    <=> v68255(VarCurr,23) ) ).

tff(addAssignment_43206,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,23)
    <=> v67359(VarCurr,87) ) ).

tff(addAssignment_43205,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,87)
    <=> v67580(VarCurr,87) ) ).

tff(addAssignment_43204,axiom,
    ! [VarCurr: state_type] :
      ( v67591(VarCurr,3)
    <=> v68258(VarCurr,23) ) ).

tff(addAssignment_43203,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,23)
    <=> v68260(VarCurr,23) ) ).

tff(addAssignment_43202,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,23)
    <=> v70128(VarNext,23) ) ).

tff(addCaseBooleanConditionEqualRanges1_844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70129(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70128(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_844,axiom,
    ! [VarNext: state_type] :
      ( v70129(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70128(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70129(VarNext)
      <=> v70130(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70130(VarNext)
      <=> ( v70132(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70132(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43201,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,23)
    <=> v68284(VarCurr,23) ) ).

tff(addAssignment_43200,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,23)
    <=> v67391(VarCurr,87) ) ).

tff(addAssignment_43199,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,87)
    <=> v70101(VarCurr,3) ) ).

tff(addAssignment_43198,axiom,
    ! [VarCurr: state_type] :
      ( v70101(VarCurr,3)
    <=> v70103(VarCurr,3) ) ).

tff(addAssignment_43197,axiom,
    ! [VarCurr: state_type] :
      ( v70103(VarCurr,3)
    <=> v70120(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70120(VarCurr,B)
      <=> ( v70121(VarCurr,B)
          | v70124(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70124(VarCurr,B)
      <=> ( v70113(VarCurr,B)
          & v70125(VarCurr,B) ) ) ) ).

tff(addAssignment_43196,axiom,
    ! [VarCurr: state_type] :
      ( v70125(VarCurr,0)
    <=> v70126(VarCurr) ) ).

tff(addAssignment_43195,axiom,
    ! [VarCurr: state_type] :
      ( v70125(VarCurr,1)
    <=> v70126(VarCurr) ) ).

tff(addAssignment_43194,axiom,
    ! [VarCurr: state_type] :
      ( v70125(VarCurr,2)
    <=> v70126(VarCurr) ) ).

tff(addAssignment_43193,axiom,
    ! [VarCurr: state_type] :
      ( v70125(VarCurr,3)
    <=> v70126(VarCurr) ) ).

tff(addAssignment_43192,axiom,
    ! [VarCurr: state_type] :
      ( v70126(VarCurr)
    <=> v70117(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70121(VarCurr,B)
      <=> ( v70105(VarCurr,B)
          & v70122(VarCurr,B) ) ) ) ).

tff(addAssignment_43191,axiom,
    ! [VarCurr: state_type] :
      ( v70122(VarCurr,0)
    <=> v70123(VarCurr) ) ).

tff(addAssignment_43190,axiom,
    ! [VarCurr: state_type] :
      ( v70122(VarCurr,1)
    <=> v70123(VarCurr) ) ).

tff(addAssignment_43189,axiom,
    ! [VarCurr: state_type] :
      ( v70122(VarCurr,2)
    <=> v70123(VarCurr) ) ).

tff(addAssignment_43188,axiom,
    ! [VarCurr: state_type] :
      ( v70122(VarCurr,3)
    <=> v70123(VarCurr) ) ).

tff(addAssignment_43187,axiom,
    ! [VarCurr: state_type] :
      ( v70123(VarCurr)
    <=> v70109(VarCurr) ) ).

tff(addAssignment_43186,axiom,
    ! [VarCurr: state_type] :
      ( v70117(VarCurr)
    <=> v70119(VarCurr) ) ).

tff(addAssignment_43185,axiom,
    ! [VarCurr: state_type] :
      ( v70119(VarCurr)
    <=> v67530(VarCurr,21) ) ).

tff(addAssignment_43184,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,21)
    <=> v52381(VarCurr,21) ) ).

tff(addAssignment_43183,axiom,
    ! [VarCurr: state_type] :
      ( v70113(VarCurr,3)
    <=> v70115(VarCurr,3) ) ).

tff(addAssignment_43182,axiom,
    ! [VarCurr: state_type] :
      ( v70115(VarCurr,3)
    <=> v67401(VarCurr,87) ) ).

tff(addAssignment_43181,axiom,
    ! [VarCurr: state_type] :
      ( v70109(VarCurr)
    <=> v70111(VarCurr) ) ).

tff(addAssignment_43180,axiom,
    ! [VarCurr: state_type] :
      ( v70111(VarCurr)
    <=> v67520(VarCurr,21) ) ).

tff(addAssignment_43179,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,21)
    <=> v52363(VarCurr,21) ) ).

tff(addAssignment_43178,axiom,
    ! [VarCurr: state_type] :
      ( v70105(VarCurr,3)
    <=> v70107(VarCurr,3) ) ).

tff(addAssignment_43177,axiom,
    ! [VarCurr: state_type] :
      ( v70107(VarCurr,3)
    <=> v67401(VarCurr,91) ) ).

tff(addAssignment_43176,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,91)
    <=> v68294(VarCurr,27) ) ).

tff(addAssignment_43175,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,27)
    <=> v68296(VarCurr,27) ) ).

tff(addAssignment_43174,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,27)
    <=> v68385(VarCurr,27) ) ).

tff(addAssignment_43173,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,27)
    <=> v68306(VarCurr,27) ) ).

tff(addAssignment_43172,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,27)
    <=> v67430(VarCurr,91) ) ).

tff(addAssignment_43171,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,91)
    <=> v67432(VarCurr,91) ) ).

tff(addAssignment_43170,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,91)
    <=> v67434(VarCurr,91) ) ).

tff(addAssignment_43169,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,91)
    <=> v68308(VarCurr,27) ) ).

tff(addAssignment_43168,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,27)
    <=> v68310(VarCurr,27) ) ).

tff(addAssignment_43167,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,27)
    <=> v68368(VarCurr,27) ) ).

tff(addAssignment_43166,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,27)
    <=> v68366(VarCurr,27) ) ).

tff(addAssignment_43165,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,27)
    <=> v68367(VarCurr,27) ) ).

tff(addAssignment_43164,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,27)
    <=> v68361(VarCurr,27) ) ).

tff(addAssignment_43163,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,27)
    <=> v68362(VarCurr,27) ) ).

tff(addAssignment_43162,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,27)
    <=> v68357(VarCurr,27) ) ).

tff(addAssignment_43161,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,27)
    <=> $false ) ).

tff(addAssignment_43160,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,27)
    <=> v68300(VarCurr,27) ) ).

tff(addAssignment_43159,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,27)
    <=> v68301(VarCurr,27) ) ).

tff(addAssignment_43158,axiom,
    ! [VarCurr: state_type] :
      ( v69954(VarCurr)
    <=> v69956(VarCurr) ) ).

tff(addAssignment_43157,axiom,
    ! [VarCurr: state_type] :
      ( v69956(VarCurr)
    <=> v69958(VarCurr) ) ).

tff(addAssignment_43156,axiom,
    ! [VarCurr: state_type] :
      ( v69958(VarCurr)
    <=> v69960(VarCurr) ) ).

tff(addAssignment_43155,axiom,
    ! [VarCurr: state_type] :
      ( v69960(VarCurr)
    <=> v69962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6478,axiom,
    ! [VarCurr: state_type] :
      ( v69962(VarCurr)
    <=> ( v70084(VarCurr)
      <~> v70044(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6477,axiom,
    ! [VarCurr: state_type] :
      ( v70084(VarCurr)
    <=> ( v69964(VarCurr)
      <~> v70004(VarCurr) ) ) ).

tff(addAssignment_43154,axiom,
    ! [VarCurr: state_type] :
      ( v70044(VarCurr)
    <=> v70046(VarCurr) ) ).

tff(addAssignment_43153,axiom,
    ! [VarCurr: state_type] :
      ( v70046(VarCurr)
    <=> v67349(VarCurr,83) ) ).

tff(addAssignment_43152,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,83)
    <=> v68249(VarCurr,19) ) ).

tff(addAssignment_43151,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,19)
    <=> v68251(VarCurr,19) ) ).

tff(addAssignment_43150,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,19)
    <=> v68253(VarCurr,19) ) ).

tff(addAssignment_43149,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,19)
    <=> v68255(VarCurr,19) ) ).

tff(addAssignment_43148,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,19)
    <=> v67359(VarCurr,83) ) ).

tff(addAssignment_43147,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,83)
    <=> v67580(VarCurr,83) ) ).

tff(addAssignment_43146,axiom,
    ! [VarCurr: state_type] :
      ( v67592(VarCurr,3)
    <=> v68258(VarCurr,19) ) ).

tff(addAssignment_43145,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,19)
    <=> v68260(VarCurr,19) ) ).

tff(addAssignment_43144,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,19)
    <=> v70076(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70077(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70076(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_843,axiom,
    ! [VarNext: state_type] :
      ( v70077(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70076(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70077(VarNext)
      <=> v70078(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70078(VarNext)
      <=> ( v70080(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70080(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43143,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,19)
    <=> v68284(VarCurr,19) ) ).

tff(addAssignment_43142,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,19)
    <=> v67391(VarCurr,83) ) ).

tff(addAssignment_43141,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,83)
    <=> v70049(VarCurr,3) ) ).

tff(addAssignment_43140,axiom,
    ! [VarCurr: state_type] :
      ( v70049(VarCurr,3)
    <=> v70051(VarCurr,3) ) ).

tff(addAssignment_43139,axiom,
    ! [VarCurr: state_type] :
      ( v70051(VarCurr,3)
    <=> v70068(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70068(VarCurr,B)
      <=> ( v70069(VarCurr,B)
          | v70072(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70072(VarCurr,B)
      <=> ( v70061(VarCurr,B)
          & v70073(VarCurr,B) ) ) ) ).

tff(addAssignment_43138,axiom,
    ! [VarCurr: state_type] :
      ( v70073(VarCurr,0)
    <=> v70074(VarCurr) ) ).

tff(addAssignment_43137,axiom,
    ! [VarCurr: state_type] :
      ( v70073(VarCurr,1)
    <=> v70074(VarCurr) ) ).

tff(addAssignment_43136,axiom,
    ! [VarCurr: state_type] :
      ( v70073(VarCurr,2)
    <=> v70074(VarCurr) ) ).

tff(addAssignment_43135,axiom,
    ! [VarCurr: state_type] :
      ( v70073(VarCurr,3)
    <=> v70074(VarCurr) ) ).

tff(addAssignment_43134,axiom,
    ! [VarCurr: state_type] :
      ( v70074(VarCurr)
    <=> v70065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70069(VarCurr,B)
      <=> ( v70053(VarCurr,B)
          & v70070(VarCurr,B) ) ) ) ).

tff(addAssignment_43133,axiom,
    ! [VarCurr: state_type] :
      ( v70070(VarCurr,0)
    <=> v70071(VarCurr) ) ).

tff(addAssignment_43132,axiom,
    ! [VarCurr: state_type] :
      ( v70070(VarCurr,1)
    <=> v70071(VarCurr) ) ).

tff(addAssignment_43131,axiom,
    ! [VarCurr: state_type] :
      ( v70070(VarCurr,2)
    <=> v70071(VarCurr) ) ).

tff(addAssignment_43130,axiom,
    ! [VarCurr: state_type] :
      ( v70070(VarCurr,3)
    <=> v70071(VarCurr) ) ).

tff(addAssignment_43129,axiom,
    ! [VarCurr: state_type] :
      ( v70071(VarCurr)
    <=> v70057(VarCurr) ) ).

tff(addAssignment_43128,axiom,
    ! [VarCurr: state_type] :
      ( v70065(VarCurr)
    <=> v70067(VarCurr) ) ).

tff(addAssignment_43127,axiom,
    ! [VarCurr: state_type] :
      ( v70067(VarCurr)
    <=> v67530(VarCurr,20) ) ).

tff(addAssignment_43126,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,20)
    <=> v52381(VarCurr,20) ) ).

tff(addAssignment_43125,axiom,
    ! [VarCurr: state_type] :
      ( v70061(VarCurr,3)
    <=> v70063(VarCurr,3) ) ).

tff(addAssignment_43124,axiom,
    ! [VarCurr: state_type] :
      ( v70063(VarCurr,3)
    <=> v67401(VarCurr,83) ) ).

tff(addAssignment_43123,axiom,
    ! [VarCurr: state_type] :
      ( v70057(VarCurr)
    <=> v70059(VarCurr) ) ).

tff(addAssignment_43122,axiom,
    ! [VarCurr: state_type] :
      ( v70059(VarCurr)
    <=> v67520(VarCurr,20) ) ).

tff(addAssignment_43121,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,20)
    <=> v52363(VarCurr,20) ) ).

tff(addAssignment_43120,axiom,
    ! [VarCurr: state_type] :
      ( v70053(VarCurr,3)
    <=> v70055(VarCurr,3) ) ).

tff(addAssignment_43119,axiom,
    ! [VarCurr: state_type] :
      ( v70055(VarCurr,3)
    <=> v67401(VarCurr,87) ) ).

tff(addAssignment_43118,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,87)
    <=> v68294(VarCurr,23) ) ).

tff(addAssignment_43117,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,23)
    <=> v68296(VarCurr,23) ) ).

tff(addAssignment_43116,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,23)
    <=> v68385(VarCurr,23) ) ).

tff(addAssignment_43115,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,23)
    <=> v68306(VarCurr,23) ) ).

tff(addAssignment_43114,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,23)
    <=> v67430(VarCurr,87) ) ).

tff(addAssignment_43113,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,87)
    <=> v67432(VarCurr,87) ) ).

tff(addAssignment_43112,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,87)
    <=> v67434(VarCurr,87) ) ).

tff(addAssignment_43111,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,87)
    <=> v68308(VarCurr,23) ) ).

tff(addAssignment_43110,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,23)
    <=> v68310(VarCurr,23) ) ).

tff(addAssignment_43109,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,23)
    <=> v68368(VarCurr,23) ) ).

tff(addAssignment_43108,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,23)
    <=> v68366(VarCurr,23) ) ).

tff(addAssignment_43107,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,23)
    <=> v68367(VarCurr,23) ) ).

tff(addAssignment_43106,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,23)
    <=> v68361(VarCurr,23) ) ).

tff(addAssignment_43105,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,23)
    <=> v68362(VarCurr,23) ) ).

tff(addAssignment_43104,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,23)
    <=> v68357(VarCurr,23) ) ).

tff(addAssignment_43103,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,23)
    <=> $false ) ).

tff(addAssignment_43102,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,23)
    <=> v68300(VarCurr,23) ) ).

tff(addAssignment_43101,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,23)
    <=> v68301(VarCurr,23) ) ).

tff(addAssignment_43100,axiom,
    ! [VarCurr: state_type] :
      ( v70004(VarCurr)
    <=> v70006(VarCurr) ) ).

tff(addAssignment_43099,axiom,
    ! [VarCurr: state_type] :
      ( v70006(VarCurr)
    <=> v67349(VarCurr,79) ) ).

tff(addAssignment_43098,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,79)
    <=> v68249(VarCurr,15) ) ).

tff(addAssignment_43097,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,15)
    <=> v68251(VarCurr,15) ) ).

tff(addAssignment_43096,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,15)
    <=> v68253(VarCurr,15) ) ).

tff(addAssignment_43095,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,15)
    <=> v68255(VarCurr,15) ) ).

tff(addAssignment_43094,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,15)
    <=> v67359(VarCurr,79) ) ).

tff(addAssignment_43093,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,79)
    <=> v67580(VarCurr,79) ) ).

tff(addAssignment_43092,axiom,
    ! [VarCurr: state_type] :
      ( v67593(VarCurr,3)
    <=> v68258(VarCurr,15) ) ).

tff(addAssignment_43091,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,15)
    <=> v68260(VarCurr,15) ) ).

tff(addAssignment_43090,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,15)
    <=> v70036(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70037(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v70036(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_842,axiom,
    ! [VarNext: state_type] :
      ( v70037(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v70036(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70037(VarNext)
      <=> v70038(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v70038(VarNext)
      <=> ( v70040(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70040(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43089,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,15)
    <=> v68284(VarCurr,15) ) ).

tff(addAssignment_43088,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,15)
    <=> v67391(VarCurr,79) ) ).

tff(addAssignment_43087,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,79)
    <=> v70009(VarCurr,3) ) ).

tff(addAssignment_43086,axiom,
    ! [VarCurr: state_type] :
      ( v70009(VarCurr,3)
    <=> v70011(VarCurr,3) ) ).

tff(addAssignment_43085,axiom,
    ! [VarCurr: state_type] :
      ( v70011(VarCurr,3)
    <=> v70028(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70028(VarCurr,B)
      <=> ( v70029(VarCurr,B)
          | v70032(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70032(VarCurr,B)
      <=> ( v70021(VarCurr,B)
          & v70033(VarCurr,B) ) ) ) ).

tff(addAssignment_43084,axiom,
    ! [VarCurr: state_type] :
      ( v70033(VarCurr,0)
    <=> v70034(VarCurr) ) ).

tff(addAssignment_43083,axiom,
    ! [VarCurr: state_type] :
      ( v70033(VarCurr,1)
    <=> v70034(VarCurr) ) ).

tff(addAssignment_43082,axiom,
    ! [VarCurr: state_type] :
      ( v70033(VarCurr,2)
    <=> v70034(VarCurr) ) ).

tff(addAssignment_43081,axiom,
    ! [VarCurr: state_type] :
      ( v70033(VarCurr,3)
    <=> v70034(VarCurr) ) ).

tff(addAssignment_43080,axiom,
    ! [VarCurr: state_type] :
      ( v70034(VarCurr)
    <=> v70025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v70029(VarCurr,B)
      <=> ( v70013(VarCurr,B)
          & v70030(VarCurr,B) ) ) ) ).

tff(addAssignment_43079,axiom,
    ! [VarCurr: state_type] :
      ( v70030(VarCurr,0)
    <=> v70031(VarCurr) ) ).

tff(addAssignment_43078,axiom,
    ! [VarCurr: state_type] :
      ( v70030(VarCurr,1)
    <=> v70031(VarCurr) ) ).

tff(addAssignment_43077,axiom,
    ! [VarCurr: state_type] :
      ( v70030(VarCurr,2)
    <=> v70031(VarCurr) ) ).

tff(addAssignment_43076,axiom,
    ! [VarCurr: state_type] :
      ( v70030(VarCurr,3)
    <=> v70031(VarCurr) ) ).

tff(addAssignment_43075,axiom,
    ! [VarCurr: state_type] :
      ( v70031(VarCurr)
    <=> v70017(VarCurr) ) ).

tff(addAssignment_43074,axiom,
    ! [VarCurr: state_type] :
      ( v70025(VarCurr)
    <=> v70027(VarCurr) ) ).

tff(addAssignment_43073,axiom,
    ! [VarCurr: state_type] :
      ( v70027(VarCurr)
    <=> v67530(VarCurr,19) ) ).

tff(addAssignment_43072,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,19)
    <=> v52381(VarCurr,19) ) ).

tff(addAssignment_43071,axiom,
    ! [VarCurr: state_type] :
      ( v70021(VarCurr,3)
    <=> v70023(VarCurr,3) ) ).

tff(addAssignment_43070,axiom,
    ! [VarCurr: state_type] :
      ( v70023(VarCurr,3)
    <=> v67401(VarCurr,79) ) ).

tff(addAssignment_43069,axiom,
    ! [VarCurr: state_type] :
      ( v70017(VarCurr)
    <=> v70019(VarCurr) ) ).

tff(addAssignment_43068,axiom,
    ! [VarCurr: state_type] :
      ( v70019(VarCurr)
    <=> v67520(VarCurr,19) ) ).

tff(addAssignment_43067,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,19)
    <=> v52363(VarCurr,19) ) ).

tff(addAssignment_43066,axiom,
    ! [VarCurr: state_type] :
      ( v70013(VarCurr,3)
    <=> v70015(VarCurr,3) ) ).

tff(addAssignment_43065,axiom,
    ! [VarCurr: state_type] :
      ( v70015(VarCurr,3)
    <=> v67401(VarCurr,83) ) ).

tff(addAssignment_43064,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,83)
    <=> v68294(VarCurr,19) ) ).

tff(addAssignment_43063,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,19)
    <=> v68296(VarCurr,19) ) ).

tff(addAssignment_43062,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,19)
    <=> v68385(VarCurr,19) ) ).

tff(addAssignment_43061,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,19)
    <=> v68306(VarCurr,19) ) ).

tff(addAssignment_43060,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,19)
    <=> v67430(VarCurr,83) ) ).

tff(addAssignment_43059,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,83)
    <=> v67432(VarCurr,83) ) ).

tff(addAssignment_43058,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,83)
    <=> v67434(VarCurr,83) ) ).

tff(addAssignment_43057,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,83)
    <=> v68308(VarCurr,19) ) ).

tff(addAssignment_43056,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,19)
    <=> v68310(VarCurr,19) ) ).

tff(addAssignment_43055,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,19)
    <=> v68368(VarCurr,19) ) ).

tff(addAssignment_43054,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,19)
    <=> v68366(VarCurr,19) ) ).

tff(addAssignment_43053,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,19)
    <=> v68367(VarCurr,19) ) ).

tff(addAssignment_43052,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,19)
    <=> v68361(VarCurr,19) ) ).

tff(addAssignment_43051,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,19)
    <=> v68362(VarCurr,19) ) ).

tff(addAssignment_43050,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,19)
    <=> v68357(VarCurr,19) ) ).

tff(addAssignment_43049,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,19)
    <=> $false ) ).

tff(addAssignment_43048,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,19)
    <=> v68300(VarCurr,19) ) ).

tff(addAssignment_43047,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,19)
    <=> v68301(VarCurr,19) ) ).

tff(addAssignment_43046,axiom,
    ! [VarCurr: state_type] :
      ( v69964(VarCurr)
    <=> v69966(VarCurr) ) ).

tff(addAssignment_43045,axiom,
    ! [VarCurr: state_type] :
      ( v69966(VarCurr)
    <=> v67349(VarCurr,75) ) ).

tff(addAssignment_43044,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,75)
    <=> v68249(VarCurr,11) ) ).

tff(addAssignment_43043,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,11)
    <=> v68251(VarCurr,11) ) ).

tff(addAssignment_43042,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,11)
    <=> v68253(VarCurr,11) ) ).

tff(addAssignment_43041,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,11)
    <=> v68255(VarCurr,11) ) ).

tff(addAssignment_43040,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,11)
    <=> v67359(VarCurr,75) ) ).

tff(addAssignment_43039,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,75)
    <=> v67580(VarCurr,75) ) ).

tff(addAssignment_43038,axiom,
    ! [VarCurr: state_type] :
      ( v67594(VarCurr,3)
    <=> v68258(VarCurr,11) ) ).

tff(addAssignment_43037,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,11)
    <=> v68260(VarCurr,11) ) ).

tff(addAssignment_43036,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,11)
    <=> v69996(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69997(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69996(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_841,axiom,
    ! [VarNext: state_type] :
      ( v69997(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69996(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69997(VarNext)
      <=> v69998(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69998(VarNext)
      <=> ( v70000(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v70000(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_43035,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,11)
    <=> v68284(VarCurr,11) ) ).

tff(addAssignment_43034,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,11)
    <=> v67391(VarCurr,75) ) ).

tff(addAssignment_43033,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,75)
    <=> v69969(VarCurr,3) ) ).

tff(addAssignment_43032,axiom,
    ! [VarCurr: state_type] :
      ( v69969(VarCurr,3)
    <=> v69971(VarCurr,3) ) ).

tff(addAssignment_43031,axiom,
    ! [VarCurr: state_type] :
      ( v69971(VarCurr,3)
    <=> v69988(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69988(VarCurr,B)
      <=> ( v69989(VarCurr,B)
          | v69992(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69992(VarCurr,B)
      <=> ( v69981(VarCurr,B)
          & v69993(VarCurr,B) ) ) ) ).

tff(addAssignment_43030,axiom,
    ! [VarCurr: state_type] :
      ( v69993(VarCurr,0)
    <=> v69994(VarCurr) ) ).

tff(addAssignment_43029,axiom,
    ! [VarCurr: state_type] :
      ( v69993(VarCurr,1)
    <=> v69994(VarCurr) ) ).

tff(addAssignment_43028,axiom,
    ! [VarCurr: state_type] :
      ( v69993(VarCurr,2)
    <=> v69994(VarCurr) ) ).

tff(addAssignment_43027,axiom,
    ! [VarCurr: state_type] :
      ( v69993(VarCurr,3)
    <=> v69994(VarCurr) ) ).

tff(addAssignment_43026,axiom,
    ! [VarCurr: state_type] :
      ( v69994(VarCurr)
    <=> v69985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69989(VarCurr,B)
      <=> ( v69973(VarCurr,B)
          & v69990(VarCurr,B) ) ) ) ).

tff(addAssignment_43025,axiom,
    ! [VarCurr: state_type] :
      ( v69990(VarCurr,0)
    <=> v69991(VarCurr) ) ).

tff(addAssignment_43024,axiom,
    ! [VarCurr: state_type] :
      ( v69990(VarCurr,1)
    <=> v69991(VarCurr) ) ).

tff(addAssignment_43023,axiom,
    ! [VarCurr: state_type] :
      ( v69990(VarCurr,2)
    <=> v69991(VarCurr) ) ).

tff(addAssignment_43022,axiom,
    ! [VarCurr: state_type] :
      ( v69990(VarCurr,3)
    <=> v69991(VarCurr) ) ).

tff(addAssignment_43021,axiom,
    ! [VarCurr: state_type] :
      ( v69991(VarCurr)
    <=> v69977(VarCurr) ) ).

tff(addAssignment_43020,axiom,
    ! [VarCurr: state_type] :
      ( v69985(VarCurr)
    <=> v69987(VarCurr) ) ).

tff(addAssignment_43019,axiom,
    ! [VarCurr: state_type] :
      ( v69987(VarCurr)
    <=> v67530(VarCurr,18) ) ).

tff(addAssignment_43018,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,18)
    <=> v52381(VarCurr,18) ) ).

tff(addAssignment_43017,axiom,
    ! [VarCurr: state_type] :
      ( v69981(VarCurr,3)
    <=> v69983(VarCurr,3) ) ).

tff(addAssignment_43016,axiom,
    ! [VarCurr: state_type] :
      ( v69983(VarCurr,3)
    <=> v67401(VarCurr,75) ) ).

tff(addAssignment_43015,axiom,
    ! [VarCurr: state_type] :
      ( v69977(VarCurr)
    <=> v69979(VarCurr) ) ).

tff(addAssignment_43014,axiom,
    ! [VarCurr: state_type] :
      ( v69979(VarCurr)
    <=> v67520(VarCurr,18) ) ).

tff(addAssignment_43013,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,18)
    <=> v52363(VarCurr,18) ) ).

tff(addAssignment_43012,axiom,
    ! [VarCurr: state_type] :
      ( v69973(VarCurr,3)
    <=> v69975(VarCurr,3) ) ).

tff(addAssignment_43011,axiom,
    ! [VarCurr: state_type] :
      ( v69975(VarCurr,3)
    <=> v67401(VarCurr,79) ) ).

tff(addAssignment_43010,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,79)
    <=> v68294(VarCurr,15) ) ).

tff(addAssignment_43009,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,15)
    <=> v68296(VarCurr,15) ) ).

tff(addAssignment_43008,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,15)
    <=> v68385(VarCurr,15) ) ).

tff(addAssignment_43007,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,15)
    <=> v68306(VarCurr,15) ) ).

tff(addAssignment_43006,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,15)
    <=> v67430(VarCurr,79) ) ).

tff(addAssignment_43005,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,79)
    <=> v67432(VarCurr,79) ) ).

tff(addAssignment_43004,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,79)
    <=> v67434(VarCurr,79) ) ).

tff(addAssignment_43003,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,79)
    <=> v68308(VarCurr,15) ) ).

tff(addAssignment_43002,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,15)
    <=> v68310(VarCurr,15) ) ).

tff(addAssignment_43001,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,15)
    <=> v68368(VarCurr,15) ) ).

tff(addAssignment_43000,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,15)
    <=> v68366(VarCurr,15) ) ).

tff(addAssignment_42999,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,15)
    <=> v68367(VarCurr,15) ) ).

tff(addAssignment_42998,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,15)
    <=> v68361(VarCurr,15) ) ).

tff(addAssignment_42997,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,15)
    <=> v68362(VarCurr,15) ) ).

tff(addAssignment_42996,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,15)
    <=> v68357(VarCurr,15) ) ).

tff(addAssignment_42995,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_42994,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,15)
    <=> v68300(VarCurr,15) ) ).

tff(addAssignment_42993,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,15)
    <=> v68301(VarCurr,15) ) ).

tff(addAssignment_42992,axiom,
    ! [VarCurr: state_type] :
      ( v69822(VarCurr)
    <=> v69824(VarCurr) ) ).

tff(addAssignment_42991,axiom,
    ! [VarCurr: state_type] :
      ( v69824(VarCurr)
    <=> v69826(VarCurr) ) ).

tff(addAssignment_42990,axiom,
    ! [VarCurr: state_type] :
      ( v69826(VarCurr)
    <=> v69828(VarCurr) ) ).

tff(addAssignment_42989,axiom,
    ! [VarCurr: state_type] :
      ( v69828(VarCurr)
    <=> v69830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6470,axiom,
    ! [VarCurr: state_type] :
      ( v69830(VarCurr)
    <=> ( v69952(VarCurr)
      <~> v69912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6469,axiom,
    ! [VarCurr: state_type] :
      ( v69952(VarCurr)
    <=> ( v69832(VarCurr)
      <~> v69872(VarCurr) ) ) ).

tff(addAssignment_42988,axiom,
    ! [VarCurr: state_type] :
      ( v69912(VarCurr)
    <=> v69914(VarCurr) ) ).

tff(addAssignment_42987,axiom,
    ! [VarCurr: state_type] :
      ( v69914(VarCurr)
    <=> v67349(VarCurr,71) ) ).

tff(addAssignment_42986,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,71)
    <=> v68249(VarCurr,7) ) ).

tff(addAssignment_42985,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,7)
    <=> v68251(VarCurr,7) ) ).

tff(addAssignment_42984,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,7)
    <=> v68253(VarCurr,7) ) ).

tff(addAssignment_42983,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,7)
    <=> v68255(VarCurr,7) ) ).

tff(addAssignment_42982,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,7)
    <=> v67359(VarCurr,71) ) ).

tff(addAssignment_42981,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,71)
    <=> v67580(VarCurr,71) ) ).

tff(addAssignment_42980,axiom,
    ! [VarCurr: state_type] :
      ( v67595(VarCurr,3)
    <=> v68258(VarCurr,7) ) ).

tff(addAssignment_42979,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,7)
    <=> v68260(VarCurr,7) ) ).

tff(addAssignment_42978,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,7)
    <=> v69944(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69945(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69944(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_840,axiom,
    ! [VarNext: state_type] :
      ( v69945(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69944(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69945(VarNext)
      <=> v69946(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69946(VarNext)
      <=> ( v69948(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69948(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_42977,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,7)
    <=> v68284(VarCurr,7) ) ).

tff(addAssignment_42976,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,7)
    <=> v67391(VarCurr,71) ) ).

tff(addAssignment_42975,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,71)
    <=> v69917(VarCurr,3) ) ).

tff(addAssignment_42974,axiom,
    ! [VarCurr: state_type] :
      ( v69917(VarCurr,3)
    <=> v69919(VarCurr,3) ) ).

tff(addAssignment_42973,axiom,
    ! [VarCurr: state_type] :
      ( v69919(VarCurr,3)
    <=> v69936(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69936(VarCurr,B)
      <=> ( v69937(VarCurr,B)
          | v69940(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69940(VarCurr,B)
      <=> ( v69929(VarCurr,B)
          & v69941(VarCurr,B) ) ) ) ).

tff(addAssignment_42972,axiom,
    ! [VarCurr: state_type] :
      ( v69941(VarCurr,0)
    <=> v69942(VarCurr) ) ).

tff(addAssignment_42971,axiom,
    ! [VarCurr: state_type] :
      ( v69941(VarCurr,1)
    <=> v69942(VarCurr) ) ).

tff(addAssignment_42970,axiom,
    ! [VarCurr: state_type] :
      ( v69941(VarCurr,2)
    <=> v69942(VarCurr) ) ).

tff(addAssignment_42969,axiom,
    ! [VarCurr: state_type] :
      ( v69941(VarCurr,3)
    <=> v69942(VarCurr) ) ).

tff(addAssignment_42968,axiom,
    ! [VarCurr: state_type] :
      ( v69942(VarCurr)
    <=> v69933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69937(VarCurr,B)
      <=> ( v69921(VarCurr,B)
          & v69938(VarCurr,B) ) ) ) ).

tff(addAssignment_42967,axiom,
    ! [VarCurr: state_type] :
      ( v69938(VarCurr,0)
    <=> v69939(VarCurr) ) ).

tff(addAssignment_42966,axiom,
    ! [VarCurr: state_type] :
      ( v69938(VarCurr,1)
    <=> v69939(VarCurr) ) ).

tff(addAssignment_42965,axiom,
    ! [VarCurr: state_type] :
      ( v69938(VarCurr,2)
    <=> v69939(VarCurr) ) ).

tff(addAssignment_42964,axiom,
    ! [VarCurr: state_type] :
      ( v69938(VarCurr,3)
    <=> v69939(VarCurr) ) ).

tff(addAssignment_42963,axiom,
    ! [VarCurr: state_type] :
      ( v69939(VarCurr)
    <=> v69925(VarCurr) ) ).

tff(addAssignment_42962,axiom,
    ! [VarCurr: state_type] :
      ( v69933(VarCurr)
    <=> v69935(VarCurr) ) ).

tff(addAssignment_42961,axiom,
    ! [VarCurr: state_type] :
      ( v69935(VarCurr)
    <=> v67530(VarCurr,17) ) ).

tff(addAssignment_42960,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,17)
    <=> v52381(VarCurr,17) ) ).

tff(addAssignment_42959,axiom,
    ! [VarCurr: state_type] :
      ( v69929(VarCurr,3)
    <=> v69931(VarCurr,3) ) ).

tff(addAssignment_42958,axiom,
    ! [VarCurr: state_type] :
      ( v69931(VarCurr,3)
    <=> v67401(VarCurr,71) ) ).

tff(addAssignment_42957,axiom,
    ! [VarCurr: state_type] :
      ( v69925(VarCurr)
    <=> v69927(VarCurr) ) ).

tff(addAssignment_42956,axiom,
    ! [VarCurr: state_type] :
      ( v69927(VarCurr)
    <=> v67520(VarCurr,17) ) ).

tff(addAssignment_42955,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,17)
    <=> v52363(VarCurr,17) ) ).

tff(addAssignment_42954,axiom,
    ! [VarCurr: state_type] :
      ( v69921(VarCurr,3)
    <=> v69923(VarCurr,3) ) ).

tff(addAssignment_42953,axiom,
    ! [VarCurr: state_type] :
      ( v69923(VarCurr,3)
    <=> v67401(VarCurr,75) ) ).

tff(addAssignment_42952,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,75)
    <=> v68294(VarCurr,11) ) ).

tff(addAssignment_42951,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,11)
    <=> v68296(VarCurr,11) ) ).

tff(addAssignment_42950,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,11)
    <=> v68385(VarCurr,11) ) ).

tff(addAssignment_42949,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,11)
    <=> v68306(VarCurr,11) ) ).

tff(addAssignment_42948,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,11)
    <=> v67430(VarCurr,75) ) ).

tff(addAssignment_42947,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,75)
    <=> v67432(VarCurr,75) ) ).

tff(addAssignment_42946,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,75)
    <=> v67434(VarCurr,75) ) ).

tff(addAssignment_42945,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,75)
    <=> v68308(VarCurr,11) ) ).

tff(addAssignment_42944,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,11)
    <=> v68310(VarCurr,11) ) ).

tff(addAssignment_42943,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,11)
    <=> v68368(VarCurr,11) ) ).

tff(addAssignment_42942,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,11)
    <=> v68366(VarCurr,11) ) ).

tff(addAssignment_42941,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,11)
    <=> v68367(VarCurr,11) ) ).

tff(addAssignment_42940,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,11)
    <=> v68361(VarCurr,11) ) ).

tff(addAssignment_42939,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,11)
    <=> v68362(VarCurr,11) ) ).

tff(addAssignment_42938,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,11)
    <=> v68357(VarCurr,11) ) ).

tff(addAssignment_42937,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_42936,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,11)
    <=> v68300(VarCurr,11) ) ).

tff(addAssignment_42935,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,11)
    <=> v68301(VarCurr,11) ) ).

tff(addAssignment_42934,axiom,
    ! [VarCurr: state_type] :
      ( v69872(VarCurr)
    <=> v69874(VarCurr) ) ).

tff(addAssignment_42933,axiom,
    ! [VarCurr: state_type] :
      ( v69874(VarCurr)
    <=> v67349(VarCurr,67) ) ).

tff(addAssignment_42932,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,67)
    <=> v68249(VarCurr,3) ) ).

tff(addAssignment_42931,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,3)
    <=> v68251(VarCurr,3) ) ).

tff(addAssignment_42930,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,3)
    <=> v68253(VarCurr,3) ) ).

tff(addAssignment_42929,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,3)
    <=> v68255(VarCurr,3) ) ).

tff(addAssignment_42928,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,3)
    <=> v67359(VarCurr,67) ) ).

tff(addAssignment_42927,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,67)
    <=> v67580(VarCurr,67) ) ).

tff(addAssignment_42926,axiom,
    ! [VarCurr: state_type] :
      ( v67596(VarCurr,3)
    <=> v68258(VarCurr,3) ) ).

tff(addAssignment_42925,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,3)
    <=> v68260(VarCurr,3) ) ).

tff(addAssignment_42924,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,3)
    <=> v69904(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69905(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69904(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_839,axiom,
    ! [VarNext: state_type] :
      ( v69905(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69904(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69905(VarNext)
      <=> v69906(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69906(VarNext)
      <=> ( v69908(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69908(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_42923,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,3)
    <=> v68284(VarCurr,3) ) ).

tff(addAssignment_42922,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,3)
    <=> v67391(VarCurr,67) ) ).

tff(addAssignment_42921,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,67)
    <=> v69877(VarCurr,3) ) ).

tff(addAssignment_42920,axiom,
    ! [VarCurr: state_type] :
      ( v69877(VarCurr,3)
    <=> v69879(VarCurr,3) ) ).

tff(addAssignment_42919,axiom,
    ! [VarCurr: state_type] :
      ( v69879(VarCurr,3)
    <=> v69896(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69896(VarCurr,B)
      <=> ( v69897(VarCurr,B)
          | v69900(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69900(VarCurr,B)
      <=> ( v69889(VarCurr,B)
          & v69901(VarCurr,B) ) ) ) ).

tff(addAssignment_42918,axiom,
    ! [VarCurr: state_type] :
      ( v69901(VarCurr,0)
    <=> v69902(VarCurr) ) ).

tff(addAssignment_42917,axiom,
    ! [VarCurr: state_type] :
      ( v69901(VarCurr,1)
    <=> v69902(VarCurr) ) ).

tff(addAssignment_42916,axiom,
    ! [VarCurr: state_type] :
      ( v69901(VarCurr,2)
    <=> v69902(VarCurr) ) ).

tff(addAssignment_42915,axiom,
    ! [VarCurr: state_type] :
      ( v69901(VarCurr,3)
    <=> v69902(VarCurr) ) ).

tff(addAssignment_42914,axiom,
    ! [VarCurr: state_type] :
      ( v69902(VarCurr)
    <=> v69893(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69897(VarCurr,B)
      <=> ( v69881(VarCurr,B)
          & v69898(VarCurr,B) ) ) ) ).

tff(addAssignment_42913,axiom,
    ! [VarCurr: state_type] :
      ( v69898(VarCurr,0)
    <=> v69899(VarCurr) ) ).

tff(addAssignment_42912,axiom,
    ! [VarCurr: state_type] :
      ( v69898(VarCurr,1)
    <=> v69899(VarCurr) ) ).

tff(addAssignment_42911,axiom,
    ! [VarCurr: state_type] :
      ( v69898(VarCurr,2)
    <=> v69899(VarCurr) ) ).

tff(addAssignment_42910,axiom,
    ! [VarCurr: state_type] :
      ( v69898(VarCurr,3)
    <=> v69899(VarCurr) ) ).

tff(addAssignment_42909,axiom,
    ! [VarCurr: state_type] :
      ( v69899(VarCurr)
    <=> v69885(VarCurr) ) ).

tff(addAssignment_42908,axiom,
    ! [VarCurr: state_type] :
      ( v69893(VarCurr)
    <=> v69895(VarCurr) ) ).

tff(addAssignment_42907,axiom,
    ! [VarCurr: state_type] :
      ( v69895(VarCurr)
    <=> v67530(VarCurr,16) ) ).

tff(addAssignment_42906,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,16)
    <=> v52381(VarCurr,16) ) ).

tff(addAssignment_42905,axiom,
    ! [VarCurr: state_type] :
      ( v69889(VarCurr,3)
    <=> v69891(VarCurr,3) ) ).

tff(addAssignment_42904,axiom,
    ! [VarCurr: state_type] :
      ( v69891(VarCurr,3)
    <=> v67401(VarCurr,67) ) ).

tff(addAssignment_42903,axiom,
    ! [VarCurr: state_type] :
      ( v69885(VarCurr)
    <=> v69887(VarCurr) ) ).

tff(addAssignment_42902,axiom,
    ! [VarCurr: state_type] :
      ( v69887(VarCurr)
    <=> v67520(VarCurr,16) ) ).

tff(addAssignment_42901,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,16)
    <=> v52363(VarCurr,16) ) ).

tff(addAssignment_42900,axiom,
    ! [VarCurr: state_type] :
      ( v69881(VarCurr,3)
    <=> v69883(VarCurr,3) ) ).

tff(addAssignment_42899,axiom,
    ! [VarCurr: state_type] :
      ( v69883(VarCurr,3)
    <=> v67401(VarCurr,71) ) ).

tff(addAssignment_42898,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,71)
    <=> v68294(VarCurr,7) ) ).

tff(addAssignment_42897,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,7)
    <=> v68296(VarCurr,7) ) ).

tff(addAssignment_42896,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,7)
    <=> v68385(VarCurr,7) ) ).

tff(addAssignment_42895,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,7)
    <=> v68306(VarCurr,7) ) ).

tff(addAssignment_42894,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,7)
    <=> v67430(VarCurr,71) ) ).

tff(addAssignment_42893,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,71)
    <=> v67432(VarCurr,71) ) ).

tff(addAssignment_42892,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,71)
    <=> v67434(VarCurr,71) ) ).

tff(addAssignment_42891,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,71)
    <=> v68308(VarCurr,7) ) ).

tff(addAssignment_42890,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,7)
    <=> v68310(VarCurr,7) ) ).

tff(addAssignment_42889,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,7)
    <=> v68368(VarCurr,7) ) ).

tff(addAssignment_42888,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,7)
    <=> v68366(VarCurr,7) ) ).

tff(addAssignment_42887,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,7)
    <=> v68367(VarCurr,7) ) ).

tff(addAssignment_42886,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,71)
    <=> v67496(VarCurr,71) ) ).

tff(addAssignment_42885,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,143)
    <=> v33839(VarCurr,143) ) ).

tff(addAssignment_42884,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,143)
    <=> v33841(VarCurr,143) ) ).

tff(addAssignment_42883,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,143)
    <=> v26555(VarCurr,11) ) ).

tff(addAssignment_42882,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,7)
    <=> v68361(VarCurr,7) ) ).

tff(addAssignment_42881,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,7)
    <=> v68362(VarCurr,7) ) ).

tff(addAssignment_42880,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,7)
    <=> v68357(VarCurr,7) ) ).

tff(addAssignment_42879,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_42878,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,7)
    <=> v68300(VarCurr,7) ) ).

tff(addAssignment_42877,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,7)
    <=> v68301(VarCurr,7) ) ).

tff(addAssignment_42876,axiom,
    ! [VarCurr: state_type] :
      ( v69832(VarCurr)
    <=> v69834(VarCurr) ) ).

tff(addAssignment_42875,axiom,
    ! [VarCurr: state_type] :
      ( v69834(VarCurr)
    <=> v67349(VarCurr,63) ) ).

tff(addAssignment_42874,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,63)
    <=> v67351(VarCurr,63) ) ).

tff(addAssignment_42873,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,63)
    <=> v67353(VarCurr,63) ) ).

tff(addAssignment_42872,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,63)
    <=> v67355(VarCurr,63) ) ).

tff(addAssignment_42871,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,63)
    <=> v67357(VarCurr,63) ) ).

tff(addAssignment_42870,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,63)
    <=> v67359(VarCurr,63) ) ).

tff(addAssignment_42869,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,63)
    <=> v67580(VarCurr,63) ) ).

tff(addAssignment_42868,axiom,
    ! [VarCurr: state_type] :
      ( v67597(VarCurr,3)
    <=> v67363(VarCurr,63) ) ).

tff(addAssignment_42867,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,63)
    <=> v67365(VarCurr,63) ) ).

tff(addAssignment_42866,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,63)
    <=> v69864(VarNext,63) ) ).

tff(addCaseBooleanConditionEqualRanges1_838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69865(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69864(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_838,axiom,
    ! [VarNext: state_type] :
      ( v69865(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69864(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69865(VarNext)
      <=> v69866(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69866(VarNext)
      <=> ( v69868(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69868(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42865,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,63)
    <=> v67389(VarCurr,63) ) ).

tff(addAssignment_42864,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,63)
    <=> v67391(VarCurr,63) ) ).

tff(addAssignment_42863,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,63)
    <=> v69837(VarCurr,3) ) ).

tff(addAssignment_42862,axiom,
    ! [VarCurr: state_type] :
      ( v69837(VarCurr,3)
    <=> v69839(VarCurr,3) ) ).

tff(addAssignment_42861,axiom,
    ! [VarCurr: state_type] :
      ( v69839(VarCurr,3)
    <=> v69856(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69856(VarCurr,B)
      <=> ( v69857(VarCurr,B)
          | v69860(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69860(VarCurr,B)
      <=> ( v69849(VarCurr,B)
          & v69861(VarCurr,B) ) ) ) ).

tff(addAssignment_42860,axiom,
    ! [VarCurr: state_type] :
      ( v69861(VarCurr,0)
    <=> v69862(VarCurr) ) ).

tff(addAssignment_42859,axiom,
    ! [VarCurr: state_type] :
      ( v69861(VarCurr,1)
    <=> v69862(VarCurr) ) ).

tff(addAssignment_42858,axiom,
    ! [VarCurr: state_type] :
      ( v69861(VarCurr,2)
    <=> v69862(VarCurr) ) ).

tff(addAssignment_42857,axiom,
    ! [VarCurr: state_type] :
      ( v69861(VarCurr,3)
    <=> v69862(VarCurr) ) ).

tff(addAssignment_42856,axiom,
    ! [VarCurr: state_type] :
      ( v69862(VarCurr)
    <=> v69853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v69857(VarCurr,B)
      <=> ( v69841(VarCurr,B)
          & v69858(VarCurr,B) ) ) ) ).

tff(addAssignment_42855,axiom,
    ! [VarCurr: state_type] :
      ( v69858(VarCurr,0)
    <=> v69859(VarCurr) ) ).

tff(addAssignment_42854,axiom,
    ! [VarCurr: state_type] :
      ( v69858(VarCurr,1)
    <=> v69859(VarCurr) ) ).

tff(addAssignment_42853,axiom,
    ! [VarCurr: state_type] :
      ( v69858(VarCurr,2)
    <=> v69859(VarCurr) ) ).

tff(addAssignment_42852,axiom,
    ! [VarCurr: state_type] :
      ( v69858(VarCurr,3)
    <=> v69859(VarCurr) ) ).

tff(addAssignment_42851,axiom,
    ! [VarCurr: state_type] :
      ( v69859(VarCurr)
    <=> v69845(VarCurr) ) ).

tff(addAssignment_42850,axiom,
    ! [VarCurr: state_type] :
      ( v69853(VarCurr)
    <=> v69855(VarCurr) ) ).

tff(addAssignment_42849,axiom,
    ! [VarCurr: state_type] :
      ( v69855(VarCurr)
    <=> v67530(VarCurr,15) ) ).

tff(addAssignment_42848,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,15)
    <=> v52381(VarCurr,15) ) ).

tff(addAssignment_42847,axiom,
    ! [VarCurr: state_type] :
      ( v69849(VarCurr,3)
    <=> v69851(VarCurr,3) ) ).

tff(addAssignment_42846,axiom,
    ! [VarCurr: state_type] :
      ( v69851(VarCurr,3)
    <=> v67401(VarCurr,63) ) ).

tff(addAssignment_42845,axiom,
    ! [VarCurr: state_type] :
      ( v69845(VarCurr)
    <=> v69847(VarCurr) ) ).

tff(addAssignment_42844,axiom,
    ! [VarCurr: state_type] :
      ( v69847(VarCurr)
    <=> v67520(VarCurr,15) ) ).

tff(addAssignment_42843,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,15)
    <=> v52363(VarCurr,15) ) ).

tff(addAssignment_42842,axiom,
    ! [VarCurr: state_type] :
      ( v69841(VarCurr,3)
    <=> v69843(VarCurr,3) ) ).

tff(addAssignment_42841,axiom,
    ! [VarCurr: state_type] :
      ( v69843(VarCurr,3)
    <=> v67401(VarCurr,67) ) ).

tff(addAssignment_42840,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,67)
    <=> v68294(VarCurr,3) ) ).

tff(addAssignment_42839,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,3)
    <=> v68296(VarCurr,3) ) ).

tff(addAssignment_42838,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,3)
    <=> v68385(VarCurr,3) ) ).

tff(addAssignment_42837,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,3)
    <=> v68306(VarCurr,3) ) ).

tff(addAssignment_42836,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,3)
    <=> v67430(VarCurr,67) ) ).

tff(addAssignment_42835,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,67)
    <=> v67432(VarCurr,67) ) ).

tff(addAssignment_42834,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,67)
    <=> v67434(VarCurr,67) ) ).

tff(addAssignment_42833,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,67)
    <=> v68308(VarCurr,3) ) ).

tff(addAssignment_42832,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,3)
    <=> v68310(VarCurr,3) ) ).

tff(addAssignment_42831,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,3)
    <=> v68368(VarCurr,3) ) ).

tff(addAssignment_42830,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,3)
    <=> v68366(VarCurr,3) ) ).

tff(addAssignment_42829,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,3)
    <=> v68367(VarCurr,3) ) ).

tff(addAssignment_42828,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,67)
    <=> v67496(VarCurr,67) ) ).

tff(addAssignment_42827,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,139)
    <=> v33839(VarCurr,139) ) ).

tff(addAssignment_42826,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,139)
    <=> v33841(VarCurr,139) ) ).

tff(addAssignment_42825,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,139)
    <=> v26555(VarCurr,7) ) ).

tff(addAssignment_42824,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,3)
    <=> v68361(VarCurr,3) ) ).

tff(addAssignment_42823,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,3)
    <=> v68362(VarCurr,3) ) ).

tff(addAssignment_42822,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,3)
    <=> v68357(VarCurr,3) ) ).

tff(addAssignment_42821,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_42820,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,3)
    <=> v68300(VarCurr,3) ) ).

tff(addAssignment_42819,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,3)
    <=> v68301(VarCurr,3) ) ).

tff(addAssignment_42818,axiom,
    ! [VarCurr: state_type] :
      ( v67273(VarCurr)
    <=> v67275(VarCurr) ) ).

tff(addAssignment_42817,axiom,
    ! [VarCurr: state_type] :
      ( v67275(VarCurr)
    <=> v67277(VarCurr) ) ).

tff(addAssignment_42816,axiom,
    ! [VarCurr: state_type] :
      ( v67277(VarCurr)
    <=> v67279(VarCurr) ) ).

tff(addAssignment_42815,axiom,
    ! [VarCurr: state_type] :
      ( v67279(VarCurr)
    <=> v67281(VarCurr) ) ).

tff(writeUnaryOperator_3369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67281(VarCurr)
    <=> v67283(VarCurr) ) ).

tff(addAssignment_42814,axiom,
    ! [VarCurr: state_type] :
      ( v67283(VarCurr)
    <=> v67285(VarCurr) ) ).

tff(addAssignment_42813,axiom,
    ! [VarCurr: state_type] :
      ( v67285(VarCurr)
    <=> v67287(VarCurr) ) ).

tff(addAssignment_42812,axiom,
    ! [VarCurr: state_type] :
      ( v67287(VarCurr)
    <=> v67289(VarCurr) ) ).

tff(addAssignment_42811,axiom,
    ! [VarCurr: state_type] :
      ( v67289(VarCurr)
    <=> v67291(VarCurr) ) ).

tff(writeUnaryOperator_3368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67291(VarCurr)
    <=> v69768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6462,axiom,
    ! [VarCurr: state_type] :
      ( v69768(VarCurr)
    <=> ( v67293(VarCurr)
        & v69104(VarCurr) ) ) ).

tff(addAssignment_42810,axiom,
    ! [VarCurr: state_type] :
      ( v69104(VarCurr)
    <=> v69106(VarCurr) ) ).

tff(addAssignment_42809,axiom,
    ! [VarCurr: state_type] :
      ( v69106(VarCurr)
    <=> v69108(VarCurr) ) ).

tff(addAssignment_42808,axiom,
    ! [VarCurr: state_type] :
      ( v69108(VarCurr)
    <=> v69110(VarCurr) ) ).

tff(addAssignment_42807,axiom,
    ! [VarCurr: state_type] :
      ( v69110(VarCurr)
    <=> v69112(VarCurr) ) ).

tff(writeUnaryOperator_3367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v69112(VarCurr)
    <=> v69766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6461,axiom,
    ! [VarCurr: state_type] :
      ( v69766(VarCurr)
    <=> ( v69114(VarCurr)
        | v69440(VarCurr) ) ) ).

tff(addAssignment_42806,axiom,
    ! [VarCurr: state_type] :
      ( v69440(VarCurr)
    <=> v69442(VarCurr) ) ).

tff(addAssignment_42805,axiom,
    ! [VarCurr: state_type] :
      ( v69442(VarCurr)
    <=> v67307(VarCurr,0) ) ).

tff(addAssignment_42804,axiom,
    ! [VarCurr: state_type] :
      ( v67307(VarCurr,0)
    <=> v67309(VarCurr,8) ) ).

tff(addAssignment_42803,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,8)
    <=> v67311(VarCurr,8) ) ).

tff(addAssignment_42802,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,8)
    <=> v67313(VarCurr,8) ) ).

tff(addAssignment_42801,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,8)
    <=> v67315(VarCurr,8) ) ).

tff(addAssignment_42800,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,8)
    <=> v67317(VarCurr,8) ) ).

tff(addAssignment_42799,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,8)
    <=> v68771(VarCurr,8) ) ).

tff(addAssignment_42798,axiom,
    ! [VarCurr: state_type] :
      ( v67319(VarCurr,0)
    <=> v69444(VarCurr) ) ).

tff(addAssignment_42797,axiom,
    ! [VarCurr: state_type] :
      ( v69444(VarCurr)
    <=> v69446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6460,axiom,
    ! [VarCurr: state_type] :
      ( v69446(VarCurr)
    <=> ( v69764(VarCurr)
      <~> v69752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6459,axiom,
    ! [VarCurr: state_type] :
      ( v69764(VarCurr)
    <=> ( v69448(VarCurr)
      <~> v69604(VarCurr) ) ) ).

tff(addAssignment_42796,axiom,
    ! [VarCurr: state_type] :
      ( v69752(VarCurr)
    <=> v69754(VarCurr) ) ).

tff(addAssignment_42795,axiom,
    ! [VarCurr: state_type] :
      ( v69754(VarCurr)
    <=> v68672(VarCurr,0) ) ).

tff(addAssignment_42794,axiom,
    ! [VarCurr: state_type] :
      ( v68672(VarCurr,0)
    <=> v68674(VarCurr,0) ) ).

tff(addAssignment_42793,axiom,
    ! [VarCurr: state_type] :
      ( v68674(VarCurr,0)
    <=> v68676(VarCurr,0) ) ).

tff(addAssignment_42792,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,0)
    <=> v68678(VarCurr,0) ) ).

tff(addAssignment_42791,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,0)
    <=> v69756(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69757(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v69756(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_837,axiom,
    ! [VarNext: state_type] :
      ( v69757(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v69756(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69757(VarNext)
      <=> v69758(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69758(VarNext)
      <=> ( v69760(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69760(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_42790,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,0)
    <=> v68702(VarCurr,0) ) ).

tff(addAssignment_42789,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,0)
    <=> v68731(VarCurr,0) ) ).

tff(addAssignment_42788,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,8)
    <=> v68705(VarCurr,0) ) ).

tff(addAssignment_42787,axiom,
    ! [VarCurr: state_type] :
      ( v68705(VarCurr,0)
    <=> v68707(VarCurr,0) ) ).

tff(addAssignment_42786,axiom,
    ! [VarCurr: state_type] :
      ( v68707(VarCurr,0)
    <=> v68724(VarCurr,0) ) ).

tff(addAssignment_42785,axiom,
    ! [VarCurr: state_type] :
      ( v68717(VarCurr,0)
    <=> v68719(VarCurr,0) ) ).

tff(addAssignment_42784,axiom,
    ! [VarCurr: state_type] :
      ( v68719(VarCurr,0)
    <=> v68455(VarCurr,8) ) ).

tff(addAssignment_42783,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,8)
    <=> v68457(VarCurr,8) ) ).

tff(addAssignment_42782,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,8)
    <=> v68459(VarCurr,8) ) ).

tff(addAssignment_42781,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,8)
    <=> v68548(VarCurr,8) ) ).

tff(addAssignment_42780,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,8)
    <=> v68469(VarCurr,8) ) ).

tff(addAssignment_42779,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,8)
    <=> v68471(VarCurr,8) ) ).

tff(addAssignment_42778,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,8)
    <=> v67432(VarCurr,136) ) ).

tff(addAssignment_42777,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,136)
    <=> v67434(VarCurr,136) ) ).

tff(addAssignment_42776,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,136)
    <=> v68473(VarCurr,8) ) ).

tff(addAssignment_42775,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,8)
    <=> v68475(VarCurr,8) ) ).

tff(addAssignment_42774,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,8)
    <=> v68531(VarCurr,8) ) ).

tff(addAssignment_42773,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,8)
    <=> v68530(VarCurr,8) ) ).

tff(addAssignment_42772,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,8)
    <=> v6234(VarCurr,64) ) ).

tff(addAssignment_42771,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,8)
    <=> v68526(VarCurr,8) ) ).

tff(addAssignment_42770,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,8)
    <=> v53217(VarCurr,64) ) ).

tff(addAssignment_42769,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,8)
    <=> v68522(VarCurr,8) ) ).

tff(addAssignment_42768,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_42767,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,8)
    <=> v68463(VarCurr,8) ) ).

tff(addAssignment_42766,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,8)
    <=> v68464(VarCurr,8) ) ).

tff(addAssignment_42765,axiom,
    ! [VarCurr: state_type] :
      ( v68709(VarCurr,0)
    <=> v68711(VarCurr,0) ) ).

tff(addAssignment_42764,axiom,
    ! [VarCurr: state_type] :
      ( v68711(VarCurr,0)
    <=> v68455(VarCurr,4) ) ).

tff(addAssignment_42763,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,4)
    <=> v68457(VarCurr,4) ) ).

tff(addAssignment_42762,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,4)
    <=> v68459(VarCurr,4) ) ).

tff(addAssignment_42761,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,4)
    <=> v68548(VarCurr,4) ) ).

tff(addAssignment_42760,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,4)
    <=> v68469(VarCurr,4) ) ).

tff(addAssignment_42759,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,4)
    <=> v68471(VarCurr,4) ) ).

tff(addAssignment_42758,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,4)
    <=> v67432(VarCurr,132) ) ).

tff(addAssignment_42757,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,132)
    <=> v67434(VarCurr,132) ) ).

tff(addAssignment_42756,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,132)
    <=> v68473(VarCurr,4) ) ).

tff(addAssignment_42755,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,4)
    <=> v68475(VarCurr,4) ) ).

tff(addAssignment_42754,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,4)
    <=> v68531(VarCurr,4) ) ).

tff(addAssignment_42753,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,4)
    <=> v68530(VarCurr,4) ) ).

tff(addAssignment_42752,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,4)
    <=> v6234(VarCurr,60) ) ).

tff(addAssignment_42751,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,4)
    <=> v68526(VarCurr,4) ) ).

tff(addAssignment_42750,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,4)
    <=> v53217(VarCurr,60) ) ).

tff(addAssignment_42749,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,4)
    <=> v68522(VarCurr,4) ) ).

tff(addAssignment_42748,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_42747,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,4)
    <=> v68463(VarCurr,4) ) ).

tff(addAssignment_42746,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,4)
    <=> v68464(VarCurr,4) ) ).

tff(addAssignment_42745,axiom,
    ! [VarCurr: state_type] :
      ( v69604(VarCurr)
    <=> v69606(VarCurr) ) ).

tff(addAssignment_42744,axiom,
    ! [VarCurr: state_type] :
      ( v69606(VarCurr)
    <=> v69608(VarCurr) ) ).

tff(addAssignment_42743,axiom,
    ! [VarCurr: state_type] :
      ( v69608(VarCurr)
    <=> v69610(VarCurr) ) ).

tff(addAssignment_42742,axiom,
    ! [VarCurr: state_type] :
      ( v69610(VarCurr)
    <=> v69612(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6456,axiom,
    ! [VarCurr: state_type] :
      ( v69612(VarCurr)
    <=> ( v69750(VarCurr)
      <~> v69710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6455,axiom,
    ! [VarCurr: state_type] :
      ( v69750(VarCurr)
    <=> ( v69614(VarCurr)
      <~> v69662(VarCurr) ) ) ).

tff(addAssignment_42741,axiom,
    ! [VarCurr: state_type] :
      ( v69710(VarCurr)
    <=> v69712(VarCurr) ) ).

tff(addAssignment_42740,axiom,
    ! [VarCurr: state_type] :
      ( v69712(VarCurr)
    <=> v69714(VarCurr) ) ).

tff(addAssignment_42739,axiom,
    ! [VarCurr: state_type] :
      ( v69714(VarCurr)
    <=> v69716(VarCurr) ) ).

tff(addAssignment_42738,axiom,
    ! [VarCurr: state_type] :
      ( v69716(VarCurr)
    <=> v69718(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6454,axiom,
    ! [VarCurr: state_type] :
      ( v69718(VarCurr)
    <=> ( v69748(VarCurr)
      <~> v69744(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6453,axiom,
    ! [VarCurr: state_type] :
      ( v69748(VarCurr)
    <=> ( v69720(VarCurr)
      <~> v69732(VarCurr) ) ) ).

tff(addAssignment_42737,axiom,
    ! [VarCurr: state_type] :
      ( v69744(VarCurr)
    <=> v69746(VarCurr) ) ).

tff(addAssignment_42736,axiom,
    ! [VarCurr: state_type] :
      ( v69746(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_42735,axiom,
    ! [VarCurr: state_type] :
      ( v69732(VarCurr)
    <=> v69734(VarCurr) ) ).

tff(addAssignment_42734,axiom,
    ! [VarCurr: state_type] :
      ( v69734(VarCurr)
    <=> v67349(VarCurr,124) ) ).

tff(addAssignment_42733,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,124)
    <=> v68249(VarCurr,60) ) ).

tff(addAssignment_42732,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,60)
    <=> v68251(VarCurr,60) ) ).

tff(addAssignment_42731,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,60)
    <=> v68253(VarCurr,60) ) ).

tff(addAssignment_42730,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,60)
    <=> v68255(VarCurr,60) ) ).

tff(addAssignment_42729,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,60)
    <=> v67359(VarCurr,124) ) ).

tff(addAssignment_42728,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,124)
    <=> v67580(VarCurr,124) ) ).

tff(addAssignment_42727,axiom,
    ! [VarCurr: state_type] :
      ( v67581(VarCurr,0)
    <=> v68258(VarCurr,60) ) ).

tff(addAssignment_42726,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,60)
    <=> v68260(VarCurr,60) ) ).

tff(addAssignment_42725,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,60)
    <=> v69736(VarNext,60) ) ).

tff(addCaseBooleanConditionEqualRanges1_836,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69737(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69736(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_836,axiom,
    ! [VarNext: state_type] :
      ( v69737(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69736(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69737(VarNext)
      <=> v69738(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69738(VarNext)
      <=> ( v69740(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69740(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_42724,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,60)
    <=> v68284(VarCurr,60) ) ).

tff(addAssignment_42723,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,60)
    <=> v67391(VarCurr,124) ) ).

tff(addAssignment_42722,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,124)
    <=> v68447(VarCurr,0) ) ).

tff(addAssignment_42721,axiom,
    ! [VarCurr: state_type] :
      ( v68447(VarCurr,0)
    <=> v68449(VarCurr,0) ) ).

tff(addAssignment_42720,axiom,
    ! [VarCurr: state_type] :
      ( v68449(VarCurr,0)
    <=> v68561(VarCurr,0) ) ).

tff(addAssignment_42719,axiom,
    ! [VarCurr: state_type] :
      ( v68554(VarCurr,0)
    <=> v68556(VarCurr,0) ) ).

tff(addAssignment_42718,axiom,
    ! [VarCurr: state_type] :
      ( v68556(VarCurr,0)
    <=> v67401(VarCurr,124) ) ).

tff(addAssignment_42717,axiom,
    ! [VarCurr: state_type] :
      ( v68451(VarCurr,0)
    <=> v68453(VarCurr,0) ) ).

tff(addAssignment_42716,axiom,
    ! [VarCurr: state_type] :
      ( v68453(VarCurr,0)
    <=> v68455(VarCurr,12) ) ).

tff(addAssignment_42715,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,12)
    <=> v68457(VarCurr,12) ) ).

tff(addAssignment_42714,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,12)
    <=> v68459(VarCurr,12) ) ).

tff(addAssignment_42713,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,12)
    <=> v68548(VarCurr,12) ) ).

tff(addAssignment_42712,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,12)
    <=> v68469(VarCurr,12) ) ).

tff(addAssignment_42711,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,12)
    <=> v68471(VarCurr,12) ) ).

tff(addAssignment_42710,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,12)
    <=> v67432(VarCurr,140) ) ).

tff(addAssignment_42709,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,140)
    <=> v67434(VarCurr,140) ) ).

tff(addAssignment_42708,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,140)
    <=> v68473(VarCurr,12) ) ).

tff(addAssignment_42707,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,12)
    <=> v68475(VarCurr,12) ) ).

tff(addAssignment_42706,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,12)
    <=> v68531(VarCurr,12) ) ).

tff(addAssignment_42705,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,12)
    <=> v68530(VarCurr,12) ) ).

tff(addAssignment_42704,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,12)
    <=> v6234(VarCurr,68) ) ).

tff(addAssignment_42703,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,12)
    <=> v68526(VarCurr,12) ) ).

tff(addAssignment_42702,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,12)
    <=> v53217(VarCurr,68) ) ).

tff(addAssignment_42701,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,12)
    <=> v68522(VarCurr,12) ) ).

tff(addAssignment_42700,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_42699,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,12)
    <=> v68463(VarCurr,12) ) ).

tff(addAssignment_42698,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,12)
    <=> v68464(VarCurr,12) ) ).

tff(addAssignment_42697,axiom,
    ! [VarCurr: state_type] :
      ( v69720(VarCurr)
    <=> v69722(VarCurr) ) ).

tff(addAssignment_42696,axiom,
    ! [VarCurr: state_type] :
      ( v69722(VarCurr)
    <=> v67349(VarCurr,120) ) ).

tff(addAssignment_42695,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,120)
    <=> v68249(VarCurr,56) ) ).

tff(addAssignment_42694,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,56)
    <=> v68251(VarCurr,56) ) ).

tff(addAssignment_42693,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,56)
    <=> v68253(VarCurr,56) ) ).

tff(addAssignment_42692,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,56)
    <=> v68255(VarCurr,56) ) ).

tff(addAssignment_42691,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,56)
    <=> v67359(VarCurr,120) ) ).

tff(addAssignment_42690,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,120)
    <=> v67580(VarCurr,120) ) ).

tff(addAssignment_42689,axiom,
    ! [VarCurr: state_type] :
      ( v67582(VarCurr,0)
    <=> v68258(VarCurr,56) ) ).

tff(addAssignment_42688,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,56)
    <=> v68260(VarCurr,56) ) ).

tff(addAssignment_42687,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,56)
    <=> v69724(VarNext,56) ) ).

tff(addCaseBooleanConditionEqualRanges1_835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69725(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69724(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_835,axiom,
    ! [VarNext: state_type] :
      ( v69725(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69724(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69725(VarNext)
      <=> v69726(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69726(VarNext)
      <=> ( v69728(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69728(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_42686,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,56)
    <=> v68284(VarCurr,56) ) ).

tff(addAssignment_42685,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,56)
    <=> v67391(VarCurr,120) ) ).

tff(addAssignment_42684,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,120)
    <=> v68286(VarCurr,0) ) ).

tff(addAssignment_42683,axiom,
    ! [VarCurr: state_type] :
      ( v68286(VarCurr,0)
    <=> v68288(VarCurr,0) ) ).

tff(addAssignment_42682,axiom,
    ! [VarCurr: state_type] :
      ( v68288(VarCurr,0)
    <=> v68398(VarCurr,0) ) ).

tff(addAssignment_42681,axiom,
    ! [VarCurr: state_type] :
      ( v68391(VarCurr,0)
    <=> v68393(VarCurr,0) ) ).

tff(addAssignment_42680,axiom,
    ! [VarCurr: state_type] :
      ( v68393(VarCurr,0)
    <=> v67401(VarCurr,120) ) ).

tff(addAssignment_42679,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,120)
    <=> v68294(VarCurr,56) ) ).

tff(addAssignment_42678,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,56)
    <=> v68296(VarCurr,56) ) ).

tff(addAssignment_42677,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,56)
    <=> v68385(VarCurr,56) ) ).

tff(addAssignment_42676,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,56)
    <=> v68306(VarCurr,56) ) ).

tff(addAssignment_42675,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,56)
    <=> v67430(VarCurr,120) ) ).

tff(addAssignment_42674,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,120)
    <=> v67432(VarCurr,120) ) ).

tff(addAssignment_42673,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,120)
    <=> v67434(VarCurr,120) ) ).

tff(addAssignment_42672,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,120)
    <=> v68308(VarCurr,56) ) ).

tff(addAssignment_42671,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,56)
    <=> v68310(VarCurr,56) ) ).

tff(addAssignment_42670,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,56)
    <=> v68368(VarCurr,56) ) ).

tff(addAssignment_42669,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,56)
    <=> v68366(VarCurr,56) ) ).

tff(addAssignment_42668,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,56)
    <=> v68367(VarCurr,56) ) ).

tff(addAssignment_42667,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,56)
    <=> v68361(VarCurr,56) ) ).

tff(addAssignment_42666,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,56)
    <=> v68362(VarCurr,56) ) ).

tff(addAssignment_42665,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,56)
    <=> v68357(VarCurr,56) ) ).

tff(addAssignment_42664,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,56)
    <=> $false ) ).

tff(addAssignment_42663,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,56)
    <=> v68300(VarCurr,56) ) ).

tff(addAssignment_42662,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,56)
    <=> v68301(VarCurr,56) ) ).

tff(addAssignment_42661,axiom,
    ! [VarCurr: state_type] :
      ( v68290(VarCurr,0)
    <=> v68292(VarCurr,0) ) ).

tff(addAssignment_42660,axiom,
    ! [VarCurr: state_type] :
      ( v68292(VarCurr,0)
    <=> v67401(VarCurr,124) ) ).

tff(addAssignment_42659,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,124)
    <=> v68294(VarCurr,60) ) ).

tff(addAssignment_42658,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,60)
    <=> v68296(VarCurr,60) ) ).

tff(addAssignment_42657,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,60)
    <=> v68385(VarCurr,60) ) ).

tff(addAssignment_42656,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,60)
    <=> v68306(VarCurr,60) ) ).

tff(addAssignment_42655,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,60)
    <=> v67430(VarCurr,124) ) ).

tff(addAssignment_42654,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,124)
    <=> v67432(VarCurr,124) ) ).

tff(addAssignment_42653,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,124)
    <=> v67434(VarCurr,124) ) ).

tff(addAssignment_42652,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,124)
    <=> v68308(VarCurr,60) ) ).

tff(addAssignment_42651,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,60)
    <=> v68310(VarCurr,60) ) ).

tff(addAssignment_42650,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,60)
    <=> v68368(VarCurr,60) ) ).

tff(addAssignment_42649,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,60)
    <=> v68366(VarCurr,60) ) ).

tff(addAssignment_42648,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,60)
    <=> v68367(VarCurr,60) ) ).

tff(addAssignment_42647,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,60)
    <=> v68361(VarCurr,60) ) ).

tff(addAssignment_42646,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,60)
    <=> v68362(VarCurr,60) ) ).

tff(addAssignment_42645,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,60)
    <=> v68357(VarCurr,60) ) ).

tff(addAssignment_42644,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,60)
    <=> $false ) ).

tff(addAssignment_42643,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,60)
    <=> v68300(VarCurr,60) ) ).

tff(addAssignment_42642,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,60)
    <=> v68301(VarCurr,60) ) ).

tff(addAssignment_42641,axiom,
    ! [VarCurr: state_type] :
      ( v69662(VarCurr)
    <=> v69664(VarCurr) ) ).

tff(addAssignment_42640,axiom,
    ! [VarCurr: state_type] :
      ( v69664(VarCurr)
    <=> v69666(VarCurr) ) ).

tff(addAssignment_42639,axiom,
    ! [VarCurr: state_type] :
      ( v69666(VarCurr)
    <=> v69668(VarCurr) ) ).

tff(addAssignment_42638,axiom,
    ! [VarCurr: state_type] :
      ( v69668(VarCurr)
    <=> v69670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6448,axiom,
    ! [VarCurr: state_type] :
      ( v69670(VarCurr)
    <=> ( v69708(VarCurr)
      <~> v69696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6447,axiom,
    ! [VarCurr: state_type] :
      ( v69708(VarCurr)
    <=> ( v69672(VarCurr)
      <~> v69684(VarCurr) ) ) ).

tff(addAssignment_42637,axiom,
    ! [VarCurr: state_type] :
      ( v69696(VarCurr)
    <=> v69698(VarCurr) ) ).

tff(addAssignment_42636,axiom,
    ! [VarCurr: state_type] :
      ( v69698(VarCurr)
    <=> v67349(VarCurr,56) ) ).

tff(addAssignment_42635,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,56)
    <=> v67351(VarCurr,56) ) ).

tff(addAssignment_42634,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,56)
    <=> v67353(VarCurr,56) ) ).

tff(addAssignment_42633,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,56)
    <=> v67355(VarCurr,56) ) ).

tff(addAssignment_42632,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,56)
    <=> v67357(VarCurr,56) ) ).

tff(addAssignment_42631,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,56)
    <=> v67359(VarCurr,56) ) ).

tff(addAssignment_42630,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,56)
    <=> v67580(VarCurr,56) ) ).

tff(addAssignment_42629,axiom,
    ! [VarCurr: state_type] :
      ( v67598(VarCurr,0)
    <=> v67363(VarCurr,56) ) ).

tff(addAssignment_42628,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,56)
    <=> v67365(VarCurr,56) ) ).

tff(addAssignment_42627,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,56)
    <=> v69700(VarNext,56) ) ).

tff(addCaseBooleanConditionEqualRanges1_834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69701(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69700(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_834,axiom,
    ! [VarNext: state_type] :
      ( v69701(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69700(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69701(VarNext)
      <=> v69702(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69702(VarNext)
      <=> ( v69704(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69704(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42626,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,56)
    <=> v67389(VarCurr,56) ) ).

tff(addAssignment_42625,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,56)
    <=> v67391(VarCurr,56) ) ).

tff(addAssignment_42624,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,56)
    <=> v68198(VarCurr,0) ) ).

tff(addAssignment_42623,axiom,
    ! [VarCurr: state_type] :
      ( v68198(VarCurr,0)
    <=> v68200(VarCurr,0) ) ).

tff(addAssignment_42622,axiom,
    ! [VarCurr: state_type] :
      ( v68200(VarCurr,0)
    <=> v68217(VarCurr,0) ) ).

tff(addAssignment_42621,axiom,
    ! [VarCurr: state_type] :
      ( v68210(VarCurr,0)
    <=> v68212(VarCurr,0) ) ).

tff(addAssignment_42620,axiom,
    ! [VarCurr: state_type] :
      ( v68212(VarCurr,0)
    <=> v67401(VarCurr,56) ) ).

tff(addAssignment_42619,axiom,
    ! [VarCurr: state_type] :
      ( v68202(VarCurr,0)
    <=> v68204(VarCurr,0) ) ).

tff(addAssignment_42618,axiom,
    ! [VarCurr: state_type] :
      ( v68204(VarCurr,0)
    <=> v67401(VarCurr,60) ) ).

tff(addAssignment_42617,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,60)
    <=> v67403(VarCurr,60) ) ).

tff(addAssignment_42616,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,60)
    <=> v67405(VarCurr,60) ) ).

tff(addAssignment_42615,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,60)
    <=> v67514(VarCurr,60) ) ).

tff(addAssignment_42614,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,60)
    <=> v67428(VarCurr,60) ) ).

tff(addAssignment_42613,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,60)
    <=> v67430(VarCurr,60) ) ).

tff(addAssignment_42612,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,60)
    <=> v67432(VarCurr,60) ) ).

tff(addAssignment_42611,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,60)
    <=> v67434(VarCurr,60) ) ).

tff(addAssignment_42610,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,60)
    <=> v67436(VarCurr,60) ) ).

tff(addAssignment_42609,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,60)
    <=> v67438(VarCurr,60) ) ).

tff(addAssignment_42608,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,60)
    <=> v67497(VarCurr,60) ) ).

tff(addAssignment_42607,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,60)
    <=> v67493(VarCurr,60) ) ).

tff(addAssignment_42606,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,60)
    <=> v67495(VarCurr,60) ) ).

tff(addAssignment_42605,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,60)
    <=> v67496(VarCurr,60) ) ).

tff(addAssignment_42604,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,126)
    <=> v33839(VarCurr,126) ) ).

tff(addAssignment_42603,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,126)
    <=> v33841(VarCurr,126) ) ).

tff(addAssignment_42602,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,126)
    <=> v25005(VarCurr,6) ) ).

tff(addAssignment_42601,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,60)
    <=> v67489(VarCurr,60) ) ).

tff(addAssignment_42600,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,60)
    <=> v6234(VarCurr,60) ) ).

tff(addAssignment_42599,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,60)
    <=> v67485(VarCurr,60) ) ).

tff(addAssignment_42598,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,60)
    <=> $false ) ).

tff(addAssignment_42597,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,60)
    <=> v67409(VarCurr,60) ) ).

tff(addAssignment_42596,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,60)
    <=> v67423(VarCurr,60) ) ).

tff(addAssignment_42595,axiom,
    ! [VarCurr: state_type] :
      ( v69684(VarCurr)
    <=> v69686(VarCurr) ) ).

tff(addAssignment_42594,axiom,
    ! [VarCurr: state_type] :
      ( v69686(VarCurr)
    <=> v67349(VarCurr,52) ) ).

tff(addAssignment_42593,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,52)
    <=> v67351(VarCurr,52) ) ).

tff(addAssignment_42592,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,52)
    <=> v67353(VarCurr,52) ) ).

tff(addAssignment_42591,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,52)
    <=> v67355(VarCurr,52) ) ).

tff(addAssignment_42590,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,52)
    <=> v67357(VarCurr,52) ) ).

tff(addAssignment_42589,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,52)
    <=> v67359(VarCurr,52) ) ).

tff(addAssignment_42588,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,52)
    <=> v67580(VarCurr,52) ) ).

tff(addAssignment_42587,axiom,
    ! [VarCurr: state_type] :
      ( v67599(VarCurr,0)
    <=> v67363(VarCurr,52) ) ).

tff(addAssignment_42586,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,52)
    <=> v67365(VarCurr,52) ) ).

tff(addAssignment_42585,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,52)
    <=> v69688(VarNext,52) ) ).

tff(addCaseBooleanConditionEqualRanges1_833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69689(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69688(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_833,axiom,
    ! [VarNext: state_type] :
      ( v69689(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69688(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69689(VarNext)
      <=> v69690(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69690(VarNext)
      <=> ( v69692(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69692(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42584,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,52)
    <=> v67389(VarCurr,52) ) ).

tff(addAssignment_42583,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,52)
    <=> v67391(VarCurr,52) ) ).

tff(addAssignment_42582,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,52)
    <=> v68158(VarCurr,0) ) ).

tff(addAssignment_42581,axiom,
    ! [VarCurr: state_type] :
      ( v68158(VarCurr,0)
    <=> v68160(VarCurr,0) ) ).

tff(addAssignment_42580,axiom,
    ! [VarCurr: state_type] :
      ( v68160(VarCurr,0)
    <=> v68177(VarCurr,0) ) ).

tff(addAssignment_42579,axiom,
    ! [VarCurr: state_type] :
      ( v68170(VarCurr,0)
    <=> v68172(VarCurr,0) ) ).

tff(addAssignment_42578,axiom,
    ! [VarCurr: state_type] :
      ( v68172(VarCurr,0)
    <=> v67401(VarCurr,52) ) ).

tff(addAssignment_42577,axiom,
    ! [VarCurr: state_type] :
      ( v68162(VarCurr,0)
    <=> v68164(VarCurr,0) ) ).

tff(addAssignment_42576,axiom,
    ! [VarCurr: state_type] :
      ( v68164(VarCurr,0)
    <=> v67401(VarCurr,56) ) ).

tff(addAssignment_42575,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,56)
    <=> v67403(VarCurr,56) ) ).

tff(addAssignment_42574,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,56)
    <=> v67405(VarCurr,56) ) ).

tff(addAssignment_42573,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,56)
    <=> v67514(VarCurr,56) ) ).

tff(addAssignment_42572,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,56)
    <=> v67428(VarCurr,56) ) ).

tff(addAssignment_42571,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,56)
    <=> v67430(VarCurr,56) ) ).

tff(addAssignment_42570,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,56)
    <=> v67432(VarCurr,56) ) ).

tff(addAssignment_42569,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,56)
    <=> v67434(VarCurr,56) ) ).

tff(addAssignment_42568,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,56)
    <=> v67436(VarCurr,56) ) ).

tff(addAssignment_42567,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,56)
    <=> v67438(VarCurr,56) ) ).

tff(addAssignment_42566,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,56)
    <=> v67497(VarCurr,56) ) ).

tff(addAssignment_42565,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,56)
    <=> v67493(VarCurr,56) ) ).

tff(addAssignment_42564,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,56)
    <=> v67495(VarCurr,56) ) ).

tff(addAssignment_42563,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,56)
    <=> v67496(VarCurr,56) ) ).

tff(addAssignment_42562,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,116)
    <=> v33839(VarCurr,116) ) ).

tff(addAssignment_42561,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,116)
    <=> v33841(VarCurr,116) ) ).

tff(addAssignment_42560,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,116)
    <=> v23455(VarCurr,8) ) ).

tff(addAssignment_42559,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,56)
    <=> v67489(VarCurr,56) ) ).

tff(addAssignment_42558,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,56)
    <=> v6234(VarCurr,56) ) ).

tff(addAssignment_42557,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,56)
    <=> v67485(VarCurr,56) ) ).

tff(addAssignment_42556,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,56)
    <=> $false ) ).

tff(addAssignment_42555,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,56)
    <=> v67409(VarCurr,56) ) ).

tff(addAssignment_42554,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,56)
    <=> v67423(VarCurr,56) ) ).

tff(addAssignment_42553,axiom,
    ! [VarCurr: state_type] :
      ( v69672(VarCurr)
    <=> v69674(VarCurr) ) ).

tff(addAssignment_42552,axiom,
    ! [VarCurr: state_type] :
      ( v69674(VarCurr)
    <=> v67349(VarCurr,48) ) ).

tff(addAssignment_42551,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,48)
    <=> v67351(VarCurr,48) ) ).

tff(addAssignment_42550,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,48)
    <=> v67353(VarCurr,48) ) ).

tff(addAssignment_42549,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,48)
    <=> v67355(VarCurr,48) ) ).

tff(addAssignment_42548,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,48)
    <=> v67357(VarCurr,48) ) ).

tff(addAssignment_42547,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,48)
    <=> v67359(VarCurr,48) ) ).

tff(addAssignment_42546,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,48)
    <=> v67580(VarCurr,48) ) ).

tff(addAssignment_42545,axiom,
    ! [VarCurr: state_type] :
      ( v67600(VarCurr,0)
    <=> v67363(VarCurr,48) ) ).

tff(addAssignment_42544,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,48)
    <=> v67365(VarCurr,48) ) ).

tff(addAssignment_42543,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,48)
    <=> v69676(VarNext,48) ) ).

tff(addCaseBooleanConditionEqualRanges1_832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69677(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69676(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_832,axiom,
    ! [VarNext: state_type] :
      ( v69677(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69676(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69677(VarNext)
      <=> v69678(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69678(VarNext)
      <=> ( v69680(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69680(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42542,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,48)
    <=> v67389(VarCurr,48) ) ).

tff(addAssignment_42541,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,48)
    <=> v67391(VarCurr,48) ) ).

tff(addAssignment_42540,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,48)
    <=> v68118(VarCurr,0) ) ).

tff(addAssignment_42539,axiom,
    ! [VarCurr: state_type] :
      ( v68118(VarCurr,0)
    <=> v68120(VarCurr,0) ) ).

tff(addAssignment_42538,axiom,
    ! [VarCurr: state_type] :
      ( v68120(VarCurr,0)
    <=> v68137(VarCurr,0) ) ).

tff(addAssignment_42537,axiom,
    ! [VarCurr: state_type] :
      ( v68130(VarCurr,0)
    <=> v68132(VarCurr,0) ) ).

tff(addAssignment_42536,axiom,
    ! [VarCurr: state_type] :
      ( v68132(VarCurr,0)
    <=> v67401(VarCurr,48) ) ).

tff(addAssignment_42535,axiom,
    ! [VarCurr: state_type] :
      ( v68122(VarCurr,0)
    <=> v68124(VarCurr,0) ) ).

tff(addAssignment_42534,axiom,
    ! [VarCurr: state_type] :
      ( v68124(VarCurr,0)
    <=> v67401(VarCurr,52) ) ).

tff(addAssignment_42533,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,52)
    <=> v67403(VarCurr,52) ) ).

tff(addAssignment_42532,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,52)
    <=> v67405(VarCurr,52) ) ).

tff(addAssignment_42531,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,52)
    <=> v67514(VarCurr,52) ) ).

tff(addAssignment_42530,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,52)
    <=> v67428(VarCurr,52) ) ).

tff(addAssignment_42529,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,52)
    <=> v67430(VarCurr,52) ) ).

tff(addAssignment_42528,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,52)
    <=> v67432(VarCurr,52) ) ).

tff(addAssignment_42527,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,52)
    <=> v67434(VarCurr,52) ) ).

tff(addAssignment_42526,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,52)
    <=> v67436(VarCurr,52) ) ).

tff(addAssignment_42525,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,52)
    <=> v67438(VarCurr,52) ) ).

tff(addAssignment_42524,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,52)
    <=> v67497(VarCurr,52) ) ).

tff(addAssignment_42523,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,52)
    <=> v67493(VarCurr,52) ) ).

tff(addAssignment_42522,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,52)
    <=> v67495(VarCurr,52) ) ).

tff(addAssignment_42521,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,52)
    <=> v67496(VarCurr,52) ) ).

tff(addAssignment_42520,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,106)
    <=> v33839(VarCurr,106) ) ).

tff(addAssignment_42519,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,106)
    <=> v33841(VarCurr,106) ) ).

tff(addAssignment_42518,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,106)
    <=> v21905(VarCurr,10) ) ).

tff(addAssignment_42517,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,52)
    <=> v67489(VarCurr,52) ) ).

tff(addAssignment_42516,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,52)
    <=> v6234(VarCurr,52) ) ).

tff(addAssignment_42515,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,52)
    <=> v67485(VarCurr,52) ) ).

tff(addAssignment_42514,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,52)
    <=> $false ) ).

tff(addAssignment_42513,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,52)
    <=> v67409(VarCurr,52) ) ).

tff(addAssignment_42512,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,52)
    <=> v67423(VarCurr,52) ) ).

tff(addAssignment_42511,axiom,
    ! [VarCurr: state_type] :
      ( v69614(VarCurr)
    <=> v69616(VarCurr) ) ).

tff(addAssignment_42510,axiom,
    ! [VarCurr: state_type] :
      ( v69616(VarCurr)
    <=> v69618(VarCurr) ) ).

tff(addAssignment_42509,axiom,
    ! [VarCurr: state_type] :
      ( v69618(VarCurr)
    <=> v69620(VarCurr) ) ).

tff(addAssignment_42508,axiom,
    ! [VarCurr: state_type] :
      ( v69620(VarCurr)
    <=> v69622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6440,axiom,
    ! [VarCurr: state_type] :
      ( v69622(VarCurr)
    <=> ( v69660(VarCurr)
      <~> v69648(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6439,axiom,
    ! [VarCurr: state_type] :
      ( v69660(VarCurr)
    <=> ( v69624(VarCurr)
      <~> v69636(VarCurr) ) ) ).

tff(addAssignment_42507,axiom,
    ! [VarCurr: state_type] :
      ( v69648(VarCurr)
    <=> v69650(VarCurr) ) ).

tff(addAssignment_42506,axiom,
    ! [VarCurr: state_type] :
      ( v69650(VarCurr)
    <=> v67349(VarCurr,44) ) ).

tff(addAssignment_42505,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,44)
    <=> v67351(VarCurr,44) ) ).

tff(addAssignment_42504,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,44)
    <=> v67353(VarCurr,44) ) ).

tff(addAssignment_42503,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,44)
    <=> v67355(VarCurr,44) ) ).

tff(addAssignment_42502,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,44)
    <=> v67357(VarCurr,44) ) ).

tff(addAssignment_42501,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,44)
    <=> v67359(VarCurr,44) ) ).

tff(addAssignment_42500,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,44)
    <=> v67580(VarCurr,44) ) ).

tff(addAssignment_42499,axiom,
    ! [VarCurr: state_type] :
      ( v67601(VarCurr,0)
    <=> v67363(VarCurr,44) ) ).

tff(addAssignment_42498,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,44)
    <=> v67365(VarCurr,44) ) ).

tff(addAssignment_42497,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,44)
    <=> v69652(VarNext,44) ) ).

tff(addCaseBooleanConditionEqualRanges1_831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69653(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69652(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_831,axiom,
    ! [VarNext: state_type] :
      ( v69653(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69652(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69653(VarNext)
      <=> v69654(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69654(VarNext)
      <=> ( v69656(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69656(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42496,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,44)
    <=> v67389(VarCurr,44) ) ).

tff(addAssignment_42495,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,44)
    <=> v67391(VarCurr,44) ) ).

tff(addAssignment_42494,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,44)
    <=> v68066(VarCurr,0) ) ).

tff(addAssignment_42493,axiom,
    ! [VarCurr: state_type] :
      ( v68066(VarCurr,0)
    <=> v68068(VarCurr,0) ) ).

tff(addAssignment_42492,axiom,
    ! [VarCurr: state_type] :
      ( v68068(VarCurr,0)
    <=> v68085(VarCurr,0) ) ).

tff(addAssignment_42491,axiom,
    ! [VarCurr: state_type] :
      ( v68078(VarCurr,0)
    <=> v68080(VarCurr,0) ) ).

tff(addAssignment_42490,axiom,
    ! [VarCurr: state_type] :
      ( v68080(VarCurr,0)
    <=> v67401(VarCurr,44) ) ).

tff(addAssignment_42489,axiom,
    ! [VarCurr: state_type] :
      ( v68070(VarCurr,0)
    <=> v68072(VarCurr,0) ) ).

tff(addAssignment_42488,axiom,
    ! [VarCurr: state_type] :
      ( v68072(VarCurr,0)
    <=> v67401(VarCurr,48) ) ).

tff(addAssignment_42487,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,48)
    <=> v67403(VarCurr,48) ) ).

tff(addAssignment_42486,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,48)
    <=> v67405(VarCurr,48) ) ).

tff(addAssignment_42485,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,48)
    <=> v67514(VarCurr,48) ) ).

tff(addAssignment_42484,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,48)
    <=> v67428(VarCurr,48) ) ).

tff(addAssignment_42483,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,48)
    <=> v67430(VarCurr,48) ) ).

tff(addAssignment_42482,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,48)
    <=> v67432(VarCurr,48) ) ).

tff(addAssignment_42481,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,48)
    <=> v67434(VarCurr,48) ) ).

tff(addAssignment_42480,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,48)
    <=> v67436(VarCurr,48) ) ).

tff(addAssignment_42479,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,48)
    <=> v67438(VarCurr,48) ) ).

tff(addAssignment_42478,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,48)
    <=> v67497(VarCurr,48) ) ).

tff(addAssignment_42477,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,48)
    <=> v67493(VarCurr,48) ) ).

tff(addAssignment_42476,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,48)
    <=> v67495(VarCurr,48) ) ).

tff(addAssignment_42475,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,48)
    <=> v67496(VarCurr,48) ) ).

tff(addAssignment_42474,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,102)
    <=> v33839(VarCurr,102) ) ).

tff(addAssignment_42473,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,102)
    <=> v33841(VarCurr,102) ) ).

tff(addAssignment_42472,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,102)
    <=> v21905(VarCurr,6) ) ).

tff(addAssignment_42471,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,48)
    <=> v67489(VarCurr,48) ) ).

tff(addAssignment_42470,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,48)
    <=> v6234(VarCurr,48) ) ).

tff(addAssignment_42469,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,48)
    <=> v67485(VarCurr,48) ) ).

tff(addAssignment_42468,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,48)
    <=> $false ) ).

tff(addAssignment_42467,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,48)
    <=> v67409(VarCurr,48) ) ).

tff(addAssignment_42466,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,48)
    <=> v67423(VarCurr,48) ) ).

tff(addAssignment_42465,axiom,
    ! [VarCurr: state_type] :
      ( v69636(VarCurr)
    <=> v69638(VarCurr) ) ).

tff(addAssignment_42464,axiom,
    ! [VarCurr: state_type] :
      ( v69638(VarCurr)
    <=> v67349(VarCurr,40) ) ).

tff(addAssignment_42463,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,40)
    <=> v67351(VarCurr,40) ) ).

tff(addAssignment_42462,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,40)
    <=> v67353(VarCurr,40) ) ).

tff(addAssignment_42461,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,40)
    <=> v67355(VarCurr,40) ) ).

tff(addAssignment_42460,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,40)
    <=> v67357(VarCurr,40) ) ).

tff(addAssignment_42459,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,40)
    <=> v67359(VarCurr,40) ) ).

tff(addAssignment_42458,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,40)
    <=> v67580(VarCurr,40) ) ).

tff(addAssignment_42457,axiom,
    ! [VarCurr: state_type] :
      ( v67602(VarCurr,0)
    <=> v67363(VarCurr,40) ) ).

tff(addAssignment_42456,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,40)
    <=> v67365(VarCurr,40) ) ).

tff(addAssignment_42455,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,40)
    <=> v69640(VarNext,40) ) ).

tff(addCaseBooleanConditionEqualRanges1_830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69641(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69640(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_830,axiom,
    ! [VarNext: state_type] :
      ( v69641(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69640(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69641(VarNext)
      <=> v69642(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69642(VarNext)
      <=> ( v69644(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69644(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42454,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,40)
    <=> v67389(VarCurr,40) ) ).

tff(addAssignment_42453,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,40)
    <=> v67391(VarCurr,40) ) ).

tff(addAssignment_42452,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,40)
    <=> v68026(VarCurr,0) ) ).

tff(addAssignment_42451,axiom,
    ! [VarCurr: state_type] :
      ( v68026(VarCurr,0)
    <=> v68028(VarCurr,0) ) ).

tff(addAssignment_42450,axiom,
    ! [VarCurr: state_type] :
      ( v68028(VarCurr,0)
    <=> v68045(VarCurr,0) ) ).

tff(addAssignment_42449,axiom,
    ! [VarCurr: state_type] :
      ( v68038(VarCurr,0)
    <=> v68040(VarCurr,0) ) ).

tff(addAssignment_42448,axiom,
    ! [VarCurr: state_type] :
      ( v68040(VarCurr,0)
    <=> v67401(VarCurr,40) ) ).

tff(addAssignment_42447,axiom,
    ! [VarCurr: state_type] :
      ( v68030(VarCurr,0)
    <=> v68032(VarCurr,0) ) ).

tff(addAssignment_42446,axiom,
    ! [VarCurr: state_type] :
      ( v68032(VarCurr,0)
    <=> v67401(VarCurr,44) ) ).

tff(addAssignment_42445,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,44)
    <=> v67403(VarCurr,44) ) ).

tff(addAssignment_42444,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,44)
    <=> v67405(VarCurr,44) ) ).

tff(addAssignment_42443,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,44)
    <=> v67514(VarCurr,44) ) ).

tff(addAssignment_42442,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,44)
    <=> v67428(VarCurr,44) ) ).

tff(addAssignment_42441,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,44)
    <=> v67430(VarCurr,44) ) ).

tff(addAssignment_42440,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,44)
    <=> v67432(VarCurr,44) ) ).

tff(addAssignment_42439,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,44)
    <=> v67434(VarCurr,44) ) ).

tff(addAssignment_42438,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,44)
    <=> v67436(VarCurr,44) ) ).

tff(addAssignment_42437,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,44)
    <=> v67438(VarCurr,44) ) ).

tff(addAssignment_42436,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,44)
    <=> v67497(VarCurr,44) ) ).

tff(addAssignment_42435,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,44)
    <=> v67493(VarCurr,44) ) ).

tff(addAssignment_42434,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,44)
    <=> v67495(VarCurr,44) ) ).

tff(addAssignment_42433,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,44)
    <=> v67496(VarCurr,44) ) ).

tff(addAssignment_42432,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,92)
    <=> v33839(VarCurr,92) ) ).

tff(addAssignment_42431,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,92)
    <=> v33841(VarCurr,92) ) ).

tff(addAssignment_42430,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,92)
    <=> v20355(VarCurr,8) ) ).

tff(addAssignment_42429,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,44)
    <=> v67489(VarCurr,44) ) ).

tff(addAssignment_42428,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,44)
    <=> v6234(VarCurr,44) ) ).

tff(addAssignment_42427,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,44)
    <=> v67485(VarCurr,44) ) ).

tff(addAssignment_42426,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,44)
    <=> $false ) ).

tff(addAssignment_42425,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,44)
    <=> v67409(VarCurr,44) ) ).

tff(addAssignment_42424,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,44)
    <=> v67423(VarCurr,44) ) ).

tff(addAssignment_42423,axiom,
    ! [VarCurr: state_type] :
      ( v69624(VarCurr)
    <=> v69626(VarCurr) ) ).

tff(addAssignment_42422,axiom,
    ! [VarCurr: state_type] :
      ( v69626(VarCurr)
    <=> v67349(VarCurr,36) ) ).

tff(addAssignment_42421,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,36)
    <=> v67351(VarCurr,36) ) ).

tff(addAssignment_42420,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,36)
    <=> v67353(VarCurr,36) ) ).

tff(addAssignment_42419,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,36)
    <=> v67355(VarCurr,36) ) ).

tff(addAssignment_42418,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,36)
    <=> v67357(VarCurr,36) ) ).

tff(addAssignment_42417,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,36)
    <=> v67359(VarCurr,36) ) ).

tff(addAssignment_42416,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,36)
    <=> v67580(VarCurr,36) ) ).

tff(addAssignment_42415,axiom,
    ! [VarCurr: state_type] :
      ( v67603(VarCurr,0)
    <=> v67363(VarCurr,36) ) ).

tff(addAssignment_42414,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,36)
    <=> v67365(VarCurr,36) ) ).

tff(addAssignment_42413,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,36)
    <=> v69628(VarNext,36) ) ).

tff(addCaseBooleanConditionEqualRanges1_829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69629(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69628(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_829,axiom,
    ! [VarNext: state_type] :
      ( v69629(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69628(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69629(VarNext)
      <=> v69630(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69630(VarNext)
      <=> ( v69632(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69632(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42412,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,36)
    <=> v67389(VarCurr,36) ) ).

tff(addAssignment_42411,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,36)
    <=> v67391(VarCurr,36) ) ).

tff(addAssignment_42410,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,36)
    <=> v67986(VarCurr,0) ) ).

tff(addAssignment_42409,axiom,
    ! [VarCurr: state_type] :
      ( v67986(VarCurr,0)
    <=> v67988(VarCurr,0) ) ).

tff(addAssignment_42408,axiom,
    ! [VarCurr: state_type] :
      ( v67988(VarCurr,0)
    <=> v68005(VarCurr,0) ) ).

tff(addAssignment_42407,axiom,
    ! [VarCurr: state_type] :
      ( v67998(VarCurr,0)
    <=> v68000(VarCurr,0) ) ).

tff(addAssignment_42406,axiom,
    ! [VarCurr: state_type] :
      ( v68000(VarCurr,0)
    <=> v67401(VarCurr,36) ) ).

tff(addAssignment_42405,axiom,
    ! [VarCurr: state_type] :
      ( v67990(VarCurr,0)
    <=> v67992(VarCurr,0) ) ).

tff(addAssignment_42404,axiom,
    ! [VarCurr: state_type] :
      ( v67992(VarCurr,0)
    <=> v67401(VarCurr,40) ) ).

tff(addAssignment_42403,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,40)
    <=> v67403(VarCurr,40) ) ).

tff(addAssignment_42402,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,40)
    <=> v67405(VarCurr,40) ) ).

tff(addAssignment_42401,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,40)
    <=> v67514(VarCurr,40) ) ).

tff(addAssignment_42400,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,40)
    <=> v67428(VarCurr,40) ) ).

tff(addAssignment_42399,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,40)
    <=> v67430(VarCurr,40) ) ).

tff(addAssignment_42398,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,40)
    <=> v67432(VarCurr,40) ) ).

tff(addAssignment_42397,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,40)
    <=> v67434(VarCurr,40) ) ).

tff(addAssignment_42396,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,40)
    <=> v67436(VarCurr,40) ) ).

tff(addAssignment_42395,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,40)
    <=> v67438(VarCurr,40) ) ).

tff(addAssignment_42394,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,40)
    <=> v67497(VarCurr,40) ) ).

tff(addAssignment_42393,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,40)
    <=> v67493(VarCurr,40) ) ).

tff(addAssignment_42392,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,40)
    <=> v67495(VarCurr,40) ) ).

tff(addAssignment_42391,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,40)
    <=> v67496(VarCurr,40) ) ).

tff(addAssignment_42390,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,82)
    <=> v33839(VarCurr,82) ) ).

tff(addAssignment_42389,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,82)
    <=> v33841(VarCurr,82) ) ).

tff(addAssignment_42388,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,82)
    <=> v18805(VarCurr,10) ) ).

tff(addAssignment_42387,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,40)
    <=> v67489(VarCurr,40) ) ).

tff(addAssignment_42386,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,40)
    <=> v6234(VarCurr,40) ) ).

tff(addAssignment_42385,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,40)
    <=> v67485(VarCurr,40) ) ).

tff(addAssignment_42384,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,40)
    <=> $false ) ).

tff(addAssignment_42383,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,40)
    <=> v67409(VarCurr,40) ) ).

tff(addAssignment_42382,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,40)
    <=> v67423(VarCurr,40) ) ).

tff(addAssignment_42381,axiom,
    ! [VarCurr: state_type] :
      ( v69448(VarCurr)
    <=> v69450(VarCurr) ) ).

tff(addAssignment_42380,axiom,
    ! [VarCurr: state_type] :
      ( v69450(VarCurr)
    <=> v69452(VarCurr) ) ).

tff(addAssignment_42379,axiom,
    ! [VarCurr: state_type] :
      ( v69452(VarCurr)
    <=> v69454(VarCurr) ) ).

tff(addAssignment_42378,axiom,
    ! [VarCurr: state_type] :
      ( v69454(VarCurr)
    <=> v69456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6432,axiom,
    ! [VarCurr: state_type] :
      ( v69456(VarCurr)
    <=> ( v69602(VarCurr)
      <~> v69554(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6431,axiom,
    ! [VarCurr: state_type] :
      ( v69602(VarCurr)
    <=> ( v69458(VarCurr)
      <~> v69506(VarCurr) ) ) ).

tff(addAssignment_42377,axiom,
    ! [VarCurr: state_type] :
      ( v69554(VarCurr)
    <=> v69556(VarCurr) ) ).

tff(addAssignment_42376,axiom,
    ! [VarCurr: state_type] :
      ( v69556(VarCurr)
    <=> v69558(VarCurr) ) ).

tff(addAssignment_42375,axiom,
    ! [VarCurr: state_type] :
      ( v69558(VarCurr)
    <=> v69560(VarCurr) ) ).

tff(addAssignment_42374,axiom,
    ! [VarCurr: state_type] :
      ( v69560(VarCurr)
    <=> v69562(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6430,axiom,
    ! [VarCurr: state_type] :
      ( v69562(VarCurr)
    <=> ( v69600(VarCurr)
      <~> v69588(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6429,axiom,
    ! [VarCurr: state_type] :
      ( v69600(VarCurr)
    <=> ( v69564(VarCurr)
      <~> v69576(VarCurr) ) ) ).

tff(addAssignment_42373,axiom,
    ! [VarCurr: state_type] :
      ( v69588(VarCurr)
    <=> v69590(VarCurr) ) ).

tff(addAssignment_42372,axiom,
    ! [VarCurr: state_type] :
      ( v69590(VarCurr)
    <=> v67349(VarCurr,32) ) ).

tff(addAssignment_42371,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,32)
    <=> v67351(VarCurr,32) ) ).

tff(addAssignment_42370,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,32)
    <=> v67353(VarCurr,32) ) ).

tff(addAssignment_42369,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,32)
    <=> v67355(VarCurr,32) ) ).

tff(addAssignment_42368,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,32)
    <=> v67357(VarCurr,32) ) ).

tff(addAssignment_42367,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,32)
    <=> v67359(VarCurr,32) ) ).

tff(addAssignment_42366,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,32)
    <=> v67580(VarCurr,32) ) ).

tff(addAssignment_42365,axiom,
    ! [VarCurr: state_type] :
      ( v67604(VarCurr,0)
    <=> v67363(VarCurr,32) ) ).

tff(addAssignment_42364,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,32)
    <=> v67365(VarCurr,32) ) ).

tff(addAssignment_42363,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,32)
    <=> v69592(VarNext,32) ) ).

tff(addCaseBooleanConditionEqualRanges1_828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69593(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69592(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_828,axiom,
    ! [VarNext: state_type] :
      ( v69593(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69592(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69593(VarNext)
      <=> v69594(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69594(VarNext)
      <=> ( v69596(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69596(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42362,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,32)
    <=> v67389(VarCurr,32) ) ).

tff(addAssignment_42361,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,32)
    <=> v67391(VarCurr,32) ) ).

tff(addAssignment_42360,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,32)
    <=> v67922(VarCurr,0) ) ).

tff(addAssignment_42359,axiom,
    ! [VarCurr: state_type] :
      ( v67922(VarCurr,0)
    <=> v67924(VarCurr,0) ) ).

tff(addAssignment_42358,axiom,
    ! [VarCurr: state_type] :
      ( v67924(VarCurr,0)
    <=> v67941(VarCurr,0) ) ).

tff(addAssignment_42357,axiom,
    ! [VarCurr: state_type] :
      ( v67934(VarCurr,0)
    <=> v67936(VarCurr,0) ) ).

tff(addAssignment_42356,axiom,
    ! [VarCurr: state_type] :
      ( v67936(VarCurr,0)
    <=> v67401(VarCurr,32) ) ).

tff(addAssignment_42355,axiom,
    ! [VarCurr: state_type] :
      ( v67926(VarCurr,0)
    <=> v67928(VarCurr,0) ) ).

tff(addAssignment_42354,axiom,
    ! [VarCurr: state_type] :
      ( v67928(VarCurr,0)
    <=> v67401(VarCurr,36) ) ).

tff(addAssignment_42353,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,36)
    <=> v67403(VarCurr,36) ) ).

tff(addAssignment_42352,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,36)
    <=> v67405(VarCurr,36) ) ).

tff(addAssignment_42351,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,36)
    <=> v67514(VarCurr,36) ) ).

tff(addAssignment_42350,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,36)
    <=> v67428(VarCurr,36) ) ).

tff(addAssignment_42349,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,36)
    <=> v67430(VarCurr,36) ) ).

tff(addAssignment_42348,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,36)
    <=> v67432(VarCurr,36) ) ).

tff(addAssignment_42347,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,36)
    <=> v67434(VarCurr,36) ) ).

tff(addAssignment_42346,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,36)
    <=> v67436(VarCurr,36) ) ).

tff(addAssignment_42345,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,36)
    <=> v67438(VarCurr,36) ) ).

tff(addAssignment_42344,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,36)
    <=> v67497(VarCurr,36) ) ).

tff(addAssignment_42343,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,36)
    <=> v67493(VarCurr,36) ) ).

tff(addAssignment_42342,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,36)
    <=> v67495(VarCurr,36) ) ).

tff(addAssignment_42341,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,36)
    <=> v67496(VarCurr,36) ) ).

tff(addAssignment_42340,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,78)
    <=> v33839(VarCurr,78) ) ).

tff(addAssignment_42339,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,78)
    <=> v33841(VarCurr,78) ) ).

tff(addAssignment_42338,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,78)
    <=> v18805(VarCurr,6) ) ).

tff(addAssignment_42337,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,36)
    <=> v67489(VarCurr,36) ) ).

tff(addAssignment_42336,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,36)
    <=> v6234(VarCurr,36) ) ).

tff(addAssignment_42335,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,36)
    <=> v67485(VarCurr,36) ) ).

tff(addAssignment_42334,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,36)
    <=> $false ) ).

tff(addAssignment_42333,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,36)
    <=> v67409(VarCurr,36) ) ).

tff(addAssignment_42332,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,36)
    <=> v67423(VarCurr,36) ) ).

tff(addAssignment_42331,axiom,
    ! [VarCurr: state_type] :
      ( v69576(VarCurr)
    <=> v69578(VarCurr) ) ).

tff(addAssignment_42330,axiom,
    ! [VarCurr: state_type] :
      ( v69578(VarCurr)
    <=> v67349(VarCurr,28) ) ).

tff(addAssignment_42329,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,28)
    <=> v67351(VarCurr,28) ) ).

tff(addAssignment_42328,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,28)
    <=> v67353(VarCurr,28) ) ).

tff(addAssignment_42327,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,28)
    <=> v67355(VarCurr,28) ) ).

tff(addAssignment_42326,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,28)
    <=> v67357(VarCurr,28) ) ).

tff(addAssignment_42325,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,28)
    <=> v67359(VarCurr,28) ) ).

tff(addAssignment_42324,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,28)
    <=> v67580(VarCurr,28) ) ).

tff(addAssignment_42323,axiom,
    ! [VarCurr: state_type] :
      ( v67605(VarCurr,0)
    <=> v67363(VarCurr,28) ) ).

tff(addAssignment_42322,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,28)
    <=> v67365(VarCurr,28) ) ).

tff(addAssignment_42321,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,28)
    <=> v69580(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69581(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69580(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_827,axiom,
    ! [VarNext: state_type] :
      ( v69581(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69580(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69581(VarNext)
      <=> v69582(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69582(VarNext)
      <=> ( v69584(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69584(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42320,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,28)
    <=> v67389(VarCurr,28) ) ).

tff(addAssignment_42319,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,28)
    <=> v67391(VarCurr,28) ) ).

tff(addAssignment_42318,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,28)
    <=> v67882(VarCurr,0) ) ).

tff(addAssignment_42317,axiom,
    ! [VarCurr: state_type] :
      ( v67882(VarCurr,0)
    <=> v67884(VarCurr,0) ) ).

tff(addAssignment_42316,axiom,
    ! [VarCurr: state_type] :
      ( v67884(VarCurr,0)
    <=> v67901(VarCurr,0) ) ).

tff(addAssignment_42315,axiom,
    ! [VarCurr: state_type] :
      ( v67894(VarCurr,0)
    <=> v67896(VarCurr,0) ) ).

tff(addAssignment_42314,axiom,
    ! [VarCurr: state_type] :
      ( v67896(VarCurr,0)
    <=> v67401(VarCurr,28) ) ).

tff(addAssignment_42313,axiom,
    ! [VarCurr: state_type] :
      ( v67886(VarCurr,0)
    <=> v67888(VarCurr,0) ) ).

tff(addAssignment_42312,axiom,
    ! [VarCurr: state_type] :
      ( v67888(VarCurr,0)
    <=> v67401(VarCurr,32) ) ).

tff(addAssignment_42311,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,32)
    <=> v67403(VarCurr,32) ) ).

tff(addAssignment_42310,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,32)
    <=> v67405(VarCurr,32) ) ).

tff(addAssignment_42309,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,32)
    <=> v67514(VarCurr,32) ) ).

tff(addAssignment_42308,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,32)
    <=> v67428(VarCurr,32) ) ).

tff(addAssignment_42307,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,32)
    <=> v67430(VarCurr,32) ) ).

tff(addAssignment_42306,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,32)
    <=> v67432(VarCurr,32) ) ).

tff(addAssignment_42305,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,32)
    <=> v67434(VarCurr,32) ) ).

tff(addAssignment_42304,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,32)
    <=> v67436(VarCurr,32) ) ).

tff(addAssignment_42303,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,32)
    <=> v67438(VarCurr,32) ) ).

tff(addAssignment_42302,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,32)
    <=> v67497(VarCurr,32) ) ).

tff(addAssignment_42301,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,32)
    <=> v67493(VarCurr,32) ) ).

tff(addAssignment_42300,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,32)
    <=> v67495(VarCurr,32) ) ).

tff(addAssignment_42299,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,32)
    <=> v67496(VarCurr,32) ) ).

tff(addAssignment_42298,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,68)
    <=> v33839(VarCurr,68) ) ).

tff(addAssignment_42297,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,68)
    <=> v33841(VarCurr,68) ) ).

tff(addAssignment_42296,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,68)
    <=> v17255(VarCurr,8) ) ).

tff(addAssignment_42295,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,32)
    <=> v67489(VarCurr,32) ) ).

tff(addAssignment_42294,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,32)
    <=> v6234(VarCurr,32) ) ).

tff(addAssignment_42293,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,32)
    <=> v67485(VarCurr,32) ) ).

tff(addAssignment_42292,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,32)
    <=> $false ) ).

tff(addAssignment_42291,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,32)
    <=> v67409(VarCurr,32) ) ).

tff(addAssignment_42290,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,32)
    <=> v67423(VarCurr,32) ) ).

tff(addAssignment_42289,axiom,
    ! [VarCurr: state_type] :
      ( v69564(VarCurr)
    <=> v69566(VarCurr) ) ).

tff(addAssignment_42288,axiom,
    ! [VarCurr: state_type] :
      ( v69566(VarCurr)
    <=> v67349(VarCurr,24) ) ).

tff(addAssignment_42287,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,24)
    <=> v67351(VarCurr,24) ) ).

tff(addAssignment_42286,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,24)
    <=> v67353(VarCurr,24) ) ).

tff(addAssignment_42285,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,24)
    <=> v67355(VarCurr,24) ) ).

tff(addAssignment_42284,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,24)
    <=> v67357(VarCurr,24) ) ).

tff(addAssignment_42283,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,24)
    <=> v67359(VarCurr,24) ) ).

tff(addAssignment_42282,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,24)
    <=> v67580(VarCurr,24) ) ).

tff(addAssignment_42281,axiom,
    ! [VarCurr: state_type] :
      ( v67606(VarCurr,0)
    <=> v67363(VarCurr,24) ) ).

tff(addAssignment_42280,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,24)
    <=> v67365(VarCurr,24) ) ).

tff(addAssignment_42279,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,24)
    <=> v69568(VarNext,24) ) ).

tff(addCaseBooleanConditionEqualRanges1_826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69569(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69568(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_826,axiom,
    ! [VarNext: state_type] :
      ( v69569(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69568(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69569(VarNext)
      <=> v69570(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69570(VarNext)
      <=> ( v69572(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69572(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42278,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,24)
    <=> v67389(VarCurr,24) ) ).

tff(addAssignment_42277,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,24)
    <=> v67391(VarCurr,24) ) ).

tff(addAssignment_42276,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,24)
    <=> v67842(VarCurr,0) ) ).

tff(addAssignment_42275,axiom,
    ! [VarCurr: state_type] :
      ( v67842(VarCurr,0)
    <=> v67844(VarCurr,0) ) ).

tff(addAssignment_42274,axiom,
    ! [VarCurr: state_type] :
      ( v67844(VarCurr,0)
    <=> v67861(VarCurr,0) ) ).

tff(addAssignment_42273,axiom,
    ! [VarCurr: state_type] :
      ( v67854(VarCurr,0)
    <=> v67856(VarCurr,0) ) ).

tff(addAssignment_42272,axiom,
    ! [VarCurr: state_type] :
      ( v67856(VarCurr,0)
    <=> v67401(VarCurr,24) ) ).

tff(addAssignment_42271,axiom,
    ! [VarCurr: state_type] :
      ( v67846(VarCurr,0)
    <=> v67848(VarCurr,0) ) ).

tff(addAssignment_42270,axiom,
    ! [VarCurr: state_type] :
      ( v67848(VarCurr,0)
    <=> v67401(VarCurr,28) ) ).

tff(addAssignment_42269,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,28)
    <=> v67403(VarCurr,28) ) ).

tff(addAssignment_42268,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,28)
    <=> v67405(VarCurr,28) ) ).

tff(addAssignment_42267,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,28)
    <=> v67514(VarCurr,28) ) ).

tff(addAssignment_42266,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,28)
    <=> v67428(VarCurr,28) ) ).

tff(addAssignment_42265,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,28)
    <=> v67430(VarCurr,28) ) ).

tff(addAssignment_42264,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,28)
    <=> v67432(VarCurr,28) ) ).

tff(addAssignment_42263,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,28)
    <=> v67434(VarCurr,28) ) ).

tff(addAssignment_42262,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,28)
    <=> v67436(VarCurr,28) ) ).

tff(addAssignment_42261,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,28)
    <=> v67438(VarCurr,28) ) ).

tff(addAssignment_42260,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,28)
    <=> v67497(VarCurr,28) ) ).

tff(addAssignment_42259,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,28)
    <=> v67493(VarCurr,28) ) ).

tff(addAssignment_42258,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,28)
    <=> v67495(VarCurr,28) ) ).

tff(addAssignment_42257,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,28)
    <=> v67496(VarCurr,28) ) ).

tff(addAssignment_42256,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,58)
    <=> v33839(VarCurr,58) ) ).

tff(addAssignment_42255,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,58)
    <=> v33841(VarCurr,58) ) ).

tff(addAssignment_42254,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,58)
    <=> v15705(VarCurr,10) ) ).

tff(addAssignment_42253,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,28)
    <=> v67489(VarCurr,28) ) ).

tff(addAssignment_42252,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,28)
    <=> v6234(VarCurr,28) ) ).

tff(addAssignment_42251,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,28)
    <=> v67485(VarCurr,28) ) ).

tff(addAssignment_42250,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,28)
    <=> $false ) ).

tff(addAssignment_42249,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,28)
    <=> v67409(VarCurr,28) ) ).

tff(addAssignment_42248,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,28)
    <=> v67423(VarCurr,28) ) ).

tff(addAssignment_42247,axiom,
    ! [VarCurr: state_type] :
      ( v69506(VarCurr)
    <=> v69508(VarCurr) ) ).

tff(addAssignment_42246,axiom,
    ! [VarCurr: state_type] :
      ( v69508(VarCurr)
    <=> v69510(VarCurr) ) ).

tff(addAssignment_42245,axiom,
    ! [VarCurr: state_type] :
      ( v69510(VarCurr)
    <=> v69512(VarCurr) ) ).

tff(addAssignment_42244,axiom,
    ! [VarCurr: state_type] :
      ( v69512(VarCurr)
    <=> v69514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6422,axiom,
    ! [VarCurr: state_type] :
      ( v69514(VarCurr)
    <=> ( v69552(VarCurr)
      <~> v69540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6421,axiom,
    ! [VarCurr: state_type] :
      ( v69552(VarCurr)
    <=> ( v69516(VarCurr)
      <~> v69528(VarCurr) ) ) ).

tff(addAssignment_42243,axiom,
    ! [VarCurr: state_type] :
      ( v69540(VarCurr)
    <=> v69542(VarCurr) ) ).

tff(addAssignment_42242,axiom,
    ! [VarCurr: state_type] :
      ( v69542(VarCurr)
    <=> v67349(VarCurr,20) ) ).

tff(addAssignment_42241,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,20)
    <=> v67351(VarCurr,20) ) ).

tff(addAssignment_42240,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,20)
    <=> v67353(VarCurr,20) ) ).

tff(addAssignment_42239,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,20)
    <=> v67355(VarCurr,20) ) ).

tff(addAssignment_42238,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,20)
    <=> v67357(VarCurr,20) ) ).

tff(addAssignment_42237,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,20)
    <=> v67359(VarCurr,20) ) ).

tff(addAssignment_42236,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,20)
    <=> v67580(VarCurr,20) ) ).

tff(addAssignment_42235,axiom,
    ! [VarCurr: state_type] :
      ( v67607(VarCurr,0)
    <=> v67363(VarCurr,20) ) ).

tff(addAssignment_42234,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,20)
    <=> v67365(VarCurr,20) ) ).

tff(addAssignment_42233,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,20)
    <=> v69544(VarNext,20) ) ).

tff(addCaseBooleanConditionEqualRanges1_825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69544(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_825,axiom,
    ! [VarNext: state_type] :
      ( v69545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69544(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69545(VarNext)
      <=> v69546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69546(VarNext)
      <=> ( v69548(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69548(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42232,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,20)
    <=> v67389(VarCurr,20) ) ).

tff(addAssignment_42231,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,20)
    <=> v67391(VarCurr,20) ) ).

tff(addAssignment_42230,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,20)
    <=> v67790(VarCurr,0) ) ).

tff(addAssignment_42229,axiom,
    ! [VarCurr: state_type] :
      ( v67790(VarCurr,0)
    <=> v67792(VarCurr,0) ) ).

tff(addAssignment_42228,axiom,
    ! [VarCurr: state_type] :
      ( v67792(VarCurr,0)
    <=> v67809(VarCurr,0) ) ).

tff(addAssignment_42227,axiom,
    ! [VarCurr: state_type] :
      ( v67802(VarCurr,0)
    <=> v67804(VarCurr,0) ) ).

tff(addAssignment_42226,axiom,
    ! [VarCurr: state_type] :
      ( v67804(VarCurr,0)
    <=> v67401(VarCurr,20) ) ).

tff(addAssignment_42225,axiom,
    ! [VarCurr: state_type] :
      ( v67794(VarCurr,0)
    <=> v67796(VarCurr,0) ) ).

tff(addAssignment_42224,axiom,
    ! [VarCurr: state_type] :
      ( v67796(VarCurr,0)
    <=> v67401(VarCurr,24) ) ).

tff(addAssignment_42223,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,24)
    <=> v67403(VarCurr,24) ) ).

tff(addAssignment_42222,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,24)
    <=> v67405(VarCurr,24) ) ).

tff(addAssignment_42221,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,24)
    <=> v67514(VarCurr,24) ) ).

tff(addAssignment_42220,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,24)
    <=> v67428(VarCurr,24) ) ).

tff(addAssignment_42219,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,24)
    <=> v67430(VarCurr,24) ) ).

tff(addAssignment_42218,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,24)
    <=> v67432(VarCurr,24) ) ).

tff(addAssignment_42217,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,24)
    <=> v67434(VarCurr,24) ) ).

tff(addAssignment_42216,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,24)
    <=> v67436(VarCurr,24) ) ).

tff(addAssignment_42215,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,24)
    <=> v67438(VarCurr,24) ) ).

tff(addAssignment_42214,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,24)
    <=> v67497(VarCurr,24) ) ).

tff(addAssignment_42213,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,24)
    <=> v67493(VarCurr,24) ) ).

tff(addAssignment_42212,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,24)
    <=> v67495(VarCurr,24) ) ).

tff(addAssignment_42211,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,24)
    <=> v67496(VarCurr,24) ) ).

tff(addAssignment_42210,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,54)
    <=> v33839(VarCurr,54) ) ).

tff(addAssignment_42209,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,54)
    <=> v33841(VarCurr,54) ) ).

tff(addAssignment_42208,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,54)
    <=> v15705(VarCurr,6) ) ).

tff(addAssignment_42207,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,24)
    <=> v67489(VarCurr,24) ) ).

tff(addAssignment_42206,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,24)
    <=> v6234(VarCurr,24) ) ).

tff(addAssignment_42205,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,24)
    <=> v67485(VarCurr,24) ) ).

tff(addAssignment_42204,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,24)
    <=> $false ) ).

tff(addAssignment_42203,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,24)
    <=> v67409(VarCurr,24) ) ).

tff(addAssignment_42202,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,24)
    <=> v67423(VarCurr,24) ) ).

tff(addAssignment_42201,axiom,
    ! [VarCurr: state_type] :
      ( v69528(VarCurr)
    <=> v69530(VarCurr) ) ).

tff(addAssignment_42200,axiom,
    ! [VarCurr: state_type] :
      ( v69530(VarCurr)
    <=> v67349(VarCurr,16) ) ).

tff(addAssignment_42199,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,16)
    <=> v67351(VarCurr,16) ) ).

tff(addAssignment_42198,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,16)
    <=> v67353(VarCurr,16) ) ).

tff(addAssignment_42197,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,16)
    <=> v67355(VarCurr,16) ) ).

tff(addAssignment_42196,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,16)
    <=> v67357(VarCurr,16) ) ).

tff(addAssignment_42195,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,16)
    <=> v67359(VarCurr,16) ) ).

tff(addAssignment_42194,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,16)
    <=> v67580(VarCurr,16) ) ).

tff(addAssignment_42193,axiom,
    ! [VarCurr: state_type] :
      ( v67608(VarCurr,0)
    <=> v67363(VarCurr,16) ) ).

tff(addAssignment_42192,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,16)
    <=> v67365(VarCurr,16) ) ).

tff(addAssignment_42191,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,16)
    <=> v69532(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69533(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69532(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_824,axiom,
    ! [VarNext: state_type] :
      ( v69533(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69532(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69533(VarNext)
      <=> v69534(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69534(VarNext)
      <=> ( v69536(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69536(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42190,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,16)
    <=> v67389(VarCurr,16) ) ).

tff(addAssignment_42189,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,16)
    <=> v67391(VarCurr,16) ) ).

tff(addAssignment_42188,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,16)
    <=> v67750(VarCurr,0) ) ).

tff(addAssignment_42187,axiom,
    ! [VarCurr: state_type] :
      ( v67750(VarCurr,0)
    <=> v67752(VarCurr,0) ) ).

tff(addAssignment_42186,axiom,
    ! [VarCurr: state_type] :
      ( v67752(VarCurr,0)
    <=> v67769(VarCurr,0) ) ).

tff(addAssignment_42185,axiom,
    ! [VarCurr: state_type] :
      ( v67762(VarCurr,0)
    <=> v67764(VarCurr,0) ) ).

tff(addAssignment_42184,axiom,
    ! [VarCurr: state_type] :
      ( v67764(VarCurr,0)
    <=> v67401(VarCurr,16) ) ).

tff(addAssignment_42183,axiom,
    ! [VarCurr: state_type] :
      ( v67754(VarCurr,0)
    <=> v67756(VarCurr,0) ) ).

tff(addAssignment_42182,axiom,
    ! [VarCurr: state_type] :
      ( v67756(VarCurr,0)
    <=> v67401(VarCurr,20) ) ).

tff(addAssignment_42181,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,20)
    <=> v67403(VarCurr,20) ) ).

tff(addAssignment_42180,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,20)
    <=> v67405(VarCurr,20) ) ).

tff(addAssignment_42179,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,20)
    <=> v67514(VarCurr,20) ) ).

tff(addAssignment_42178,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,20)
    <=> v67428(VarCurr,20) ) ).

tff(addAssignment_42177,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,20)
    <=> v67430(VarCurr,20) ) ).

tff(addAssignment_42176,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,20)
    <=> v67432(VarCurr,20) ) ).

tff(addAssignment_42175,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,20)
    <=> v67434(VarCurr,20) ) ).

tff(addAssignment_42174,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,20)
    <=> v67436(VarCurr,20) ) ).

tff(addAssignment_42173,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,20)
    <=> v67438(VarCurr,20) ) ).

tff(addAssignment_42172,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,20)
    <=> v67497(VarCurr,20) ) ).

tff(addAssignment_42171,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,20)
    <=> v67493(VarCurr,20) ) ).

tff(addAssignment_42170,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,20)
    <=> v67495(VarCurr,20) ) ).

tff(addAssignment_42169,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,20)
    <=> v67496(VarCurr,20) ) ).

tff(addAssignment_42168,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,44)
    <=> v33839(VarCurr,44) ) ).

tff(addAssignment_42167,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,44)
    <=> v33841(VarCurr,44) ) ).

tff(addAssignment_42166,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,44)
    <=> v14155(VarCurr,8) ) ).

tff(addAssignment_42165,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,20)
    <=> v67489(VarCurr,20) ) ).

tff(addAssignment_42164,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,20)
    <=> v6234(VarCurr,20) ) ).

tff(addAssignment_42163,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,20)
    <=> v67485(VarCurr,20) ) ).

tff(addAssignment_42162,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,20)
    <=> $false ) ).

tff(addAssignment_42161,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,20)
    <=> v67409(VarCurr,20) ) ).

tff(addAssignment_42160,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,20)
    <=> v67423(VarCurr,20) ) ).

tff(addAssignment_42159,axiom,
    ! [VarCurr: state_type] :
      ( v69516(VarCurr)
    <=> v69518(VarCurr) ) ).

tff(addAssignment_42158,axiom,
    ! [VarCurr: state_type] :
      ( v69518(VarCurr)
    <=> v67349(VarCurr,12) ) ).

tff(addAssignment_42157,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,12)
    <=> v67351(VarCurr,12) ) ).

tff(addAssignment_42156,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,12)
    <=> v67353(VarCurr,12) ) ).

tff(addAssignment_42155,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,12)
    <=> v67355(VarCurr,12) ) ).

tff(addAssignment_42154,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,12)
    <=> v67357(VarCurr,12) ) ).

tff(addAssignment_42153,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,12)
    <=> v67359(VarCurr,12) ) ).

tff(addAssignment_42152,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,12)
    <=> v67580(VarCurr,12) ) ).

tff(addAssignment_42151,axiom,
    ! [VarCurr: state_type] :
      ( v67609(VarCurr,0)
    <=> v67363(VarCurr,12) ) ).

tff(addAssignment_42150,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,12)
    <=> v67365(VarCurr,12) ) ).

tff(addAssignment_42149,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,12)
    <=> v69520(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69521(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69520(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_823,axiom,
    ! [VarNext: state_type] :
      ( v69521(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69520(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69521(VarNext)
      <=> v69522(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69522(VarNext)
      <=> ( v69524(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69524(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42148,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,12)
    <=> v67389(VarCurr,12) ) ).

tff(addAssignment_42147,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,12)
    <=> v67391(VarCurr,12) ) ).

tff(addAssignment_42146,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,12)
    <=> v67710(VarCurr,0) ) ).

tff(addAssignment_42145,axiom,
    ! [VarCurr: state_type] :
      ( v67710(VarCurr,0)
    <=> v67712(VarCurr,0) ) ).

tff(addAssignment_42144,axiom,
    ! [VarCurr: state_type] :
      ( v67712(VarCurr,0)
    <=> v67729(VarCurr,0) ) ).

tff(addAssignment_42143,axiom,
    ! [VarCurr: state_type] :
      ( v67722(VarCurr,0)
    <=> v67724(VarCurr,0) ) ).

tff(addAssignment_42142,axiom,
    ! [VarCurr: state_type] :
      ( v67724(VarCurr,0)
    <=> v67401(VarCurr,12) ) ).

tff(addAssignment_42141,axiom,
    ! [VarCurr: state_type] :
      ( v67714(VarCurr,0)
    <=> v67716(VarCurr,0) ) ).

tff(addAssignment_42140,axiom,
    ! [VarCurr: state_type] :
      ( v67716(VarCurr,0)
    <=> v67401(VarCurr,16) ) ).

tff(addAssignment_42139,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,16)
    <=> v67403(VarCurr,16) ) ).

tff(addAssignment_42138,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,16)
    <=> v67405(VarCurr,16) ) ).

tff(addAssignment_42137,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,16)
    <=> v67514(VarCurr,16) ) ).

tff(addAssignment_42136,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,16)
    <=> v67428(VarCurr,16) ) ).

tff(addAssignment_42135,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,16)
    <=> v67430(VarCurr,16) ) ).

tff(addAssignment_42134,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,16)
    <=> v67432(VarCurr,16) ) ).

tff(addAssignment_42133,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,16)
    <=> v67434(VarCurr,16) ) ).

tff(addAssignment_42132,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,16)
    <=> v67436(VarCurr,16) ) ).

tff(addAssignment_42131,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,16)
    <=> v67438(VarCurr,16) ) ).

tff(addAssignment_42130,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,16)
    <=> v67497(VarCurr,16) ) ).

tff(addAssignment_42129,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,16)
    <=> v67493(VarCurr,16) ) ).

tff(addAssignment_42128,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,16)
    <=> v67495(VarCurr,16) ) ).

tff(addAssignment_42127,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,16)
    <=> v67496(VarCurr,16) ) ).

tff(addAssignment_42126,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,34)
    <=> v33839(VarCurr,34) ) ).

tff(addAssignment_42125,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,16)
    <=> v67489(VarCurr,16) ) ).

tff(addAssignment_42124,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,16)
    <=> v6234(VarCurr,16) ) ).

tff(addAssignment_42123,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,16)
    <=> v67485(VarCurr,16) ) ).

tff(addAssignment_42122,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,16)
    <=> $false ) ).

tff(addAssignment_42121,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,16)
    <=> v67409(VarCurr,16) ) ).

tff(addAssignment_42120,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,16)
    <=> v67423(VarCurr,16) ) ).

tff(addAssignment_42119,axiom,
    ! [VarCurr: state_type] :
      ( v69458(VarCurr)
    <=> v69460(VarCurr) ) ).

tff(addAssignment_42118,axiom,
    ! [VarCurr: state_type] :
      ( v69460(VarCurr)
    <=> v69462(VarCurr) ) ).

tff(addAssignment_42117,axiom,
    ! [VarCurr: state_type] :
      ( v69462(VarCurr)
    <=> v69464(VarCurr) ) ).

tff(addAssignment_42116,axiom,
    ! [VarCurr: state_type] :
      ( v69464(VarCurr)
    <=> v69466(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6414,axiom,
    ! [VarCurr: state_type] :
      ( v69466(VarCurr)
    <=> ( v69504(VarCurr)
      <~> v69492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6413,axiom,
    ! [VarCurr: state_type] :
      ( v69504(VarCurr)
    <=> ( v69468(VarCurr)
      <~> v69480(VarCurr) ) ) ).

tff(addAssignment_42115,axiom,
    ! [VarCurr: state_type] :
      ( v69492(VarCurr)
    <=> v69494(VarCurr) ) ).

tff(addAssignment_42114,axiom,
    ! [VarCurr: state_type] :
      ( v69494(VarCurr)
    <=> v67349(VarCurr,8) ) ).

tff(addAssignment_42113,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,8)
    <=> v67351(VarCurr,8) ) ).

tff(addAssignment_42112,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,8)
    <=> v67353(VarCurr,8) ) ).

tff(addAssignment_42111,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,8)
    <=> v67355(VarCurr,8) ) ).

tff(addAssignment_42110,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,8)
    <=> v67357(VarCurr,8) ) ).

tff(addAssignment_42109,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,8)
    <=> v67359(VarCurr,8) ) ).

tff(addAssignment_42108,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,8)
    <=> v67580(VarCurr,8) ) ).

tff(addAssignment_42107,axiom,
    ! [VarCurr: state_type] :
      ( v67610(VarCurr,0)
    <=> v67363(VarCurr,8) ) ).

tff(addAssignment_42106,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,8)
    <=> v67365(VarCurr,8) ) ).

tff(addAssignment_42105,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,8)
    <=> v69496(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69497(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69496(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_822,axiom,
    ! [VarNext: state_type] :
      ( v69497(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69496(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69497(VarNext)
      <=> v69498(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69498(VarNext)
      <=> ( v69500(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69500(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42104,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,8)
    <=> v67389(VarCurr,8) ) ).

tff(addAssignment_42103,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,8)
    <=> v67391(VarCurr,8) ) ).

tff(addAssignment_42102,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,8)
    <=> v67658(VarCurr,0) ) ).

tff(addAssignment_42101,axiom,
    ! [VarCurr: state_type] :
      ( v67658(VarCurr,0)
    <=> v67660(VarCurr,0) ) ).

tff(addAssignment_42100,axiom,
    ! [VarCurr: state_type] :
      ( v67660(VarCurr,0)
    <=> v67677(VarCurr,0) ) ).

tff(addAssignment_42099,axiom,
    ! [VarCurr: state_type] :
      ( v67670(VarCurr,0)
    <=> v67672(VarCurr,0) ) ).

tff(addAssignment_42098,axiom,
    ! [VarCurr: state_type] :
      ( v67672(VarCurr,0)
    <=> v67401(VarCurr,8) ) ).

tff(addAssignment_42097,axiom,
    ! [VarCurr: state_type] :
      ( v67662(VarCurr,0)
    <=> v67664(VarCurr,0) ) ).

tff(addAssignment_42096,axiom,
    ! [VarCurr: state_type] :
      ( v67664(VarCurr,0)
    <=> v67401(VarCurr,12) ) ).

tff(addAssignment_42095,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,12)
    <=> v67403(VarCurr,12) ) ).

tff(addAssignment_42094,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,12)
    <=> v67405(VarCurr,12) ) ).

tff(addAssignment_42093,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,12)
    <=> v67514(VarCurr,12) ) ).

tff(addAssignment_42092,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,12)
    <=> v67428(VarCurr,12) ) ).

tff(addAssignment_42091,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,12)
    <=> v67430(VarCurr,12) ) ).

tff(addAssignment_42090,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,12)
    <=> v67432(VarCurr,12) ) ).

tff(addAssignment_42089,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,12)
    <=> v67434(VarCurr,12) ) ).

tff(addAssignment_42088,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,12)
    <=> v67436(VarCurr,12) ) ).

tff(addAssignment_42087,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,12)
    <=> v67438(VarCurr,12) ) ).

tff(addAssignment_42086,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,12)
    <=> v67497(VarCurr,12) ) ).

tff(addAssignment_42085,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,12)
    <=> v67493(VarCurr,12) ) ).

tff(addAssignment_42084,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,12)
    <=> v67495(VarCurr,12) ) ).

tff(addAssignment_42083,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,12)
    <=> v67496(VarCurr,12) ) ).

tff(addAssignment_42082,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,30)
    <=> v33839(VarCurr,30) ) ).

tff(addAssignment_42081,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,12)
    <=> v67489(VarCurr,12) ) ).

tff(addAssignment_42080,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,12)
    <=> v6234(VarCurr,12) ) ).

tff(addAssignment_42079,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,12)
    <=> v67485(VarCurr,12) ) ).

tff(addAssignment_42078,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_42077,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,12)
    <=> v67409(VarCurr,12) ) ).

tff(addAssignment_42076,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,12)
    <=> v67423(VarCurr,12) ) ).

tff(addAssignment_42075,axiom,
    ! [VarCurr: state_type] :
      ( v69480(VarCurr)
    <=> v69482(VarCurr) ) ).

tff(addAssignment_42074,axiom,
    ! [VarCurr: state_type] :
      ( v69482(VarCurr)
    <=> v67349(VarCurr,4) ) ).

tff(addAssignment_42073,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,4)
    <=> v67351(VarCurr,4) ) ).

tff(addAssignment_42072,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,4)
    <=> v67353(VarCurr,4) ) ).

tff(addAssignment_42071,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,4)
    <=> v67355(VarCurr,4) ) ).

tff(addAssignment_42070,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,4)
    <=> v67357(VarCurr,4) ) ).

tff(addAssignment_42069,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,4)
    <=> v67359(VarCurr,4) ) ).

tff(addAssignment_42068,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,4)
    <=> v67580(VarCurr,4) ) ).

tff(addAssignment_42067,axiom,
    ! [VarCurr: state_type] :
      ( v67611(VarCurr,0)
    <=> v67363(VarCurr,4) ) ).

tff(addAssignment_42066,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,4)
    <=> v67365(VarCurr,4) ) ).

tff(addAssignment_42065,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,4)
    <=> v69484(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69485(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69484(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_821,axiom,
    ! [VarNext: state_type] :
      ( v69485(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69484(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69485(VarNext)
      <=> v69486(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69486(VarNext)
      <=> ( v69488(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69488(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42064,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,4)
    <=> v67389(VarCurr,4) ) ).

tff(addAssignment_42063,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,4)
    <=> v67391(VarCurr,4) ) ).

tff(addAssignment_42062,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,4)
    <=> v67618(VarCurr,0) ) ).

tff(addAssignment_42061,axiom,
    ! [VarCurr: state_type] :
      ( v67618(VarCurr,0)
    <=> v67620(VarCurr,0) ) ).

tff(addAssignment_42060,axiom,
    ! [VarCurr: state_type] :
      ( v67620(VarCurr,0)
    <=> v67637(VarCurr,0) ) ).

tff(addAssignment_42059,axiom,
    ! [VarCurr: state_type] :
      ( v67630(VarCurr,0)
    <=> v67632(VarCurr,0) ) ).

tff(addAssignment_42058,axiom,
    ! [VarCurr: state_type] :
      ( v67632(VarCurr,0)
    <=> v67401(VarCurr,4) ) ).

tff(addAssignment_42057,axiom,
    ! [VarCurr: state_type] :
      ( v67622(VarCurr,0)
    <=> v67624(VarCurr,0) ) ).

tff(addAssignment_42056,axiom,
    ! [VarCurr: state_type] :
      ( v67624(VarCurr,0)
    <=> v67401(VarCurr,8) ) ).

tff(addAssignment_42055,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,8)
    <=> v67403(VarCurr,8) ) ).

tff(addAssignment_42054,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,8)
    <=> v67405(VarCurr,8) ) ).

tff(addAssignment_42053,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,8)
    <=> v67514(VarCurr,8) ) ).

tff(addAssignment_42052,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,8)
    <=> v67428(VarCurr,8) ) ).

tff(addAssignment_42051,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,8)
    <=> v67430(VarCurr,8) ) ).

tff(addAssignment_42050,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,8)
    <=> v67432(VarCurr,8) ) ).

tff(addAssignment_42049,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,8)
    <=> v67434(VarCurr,8) ) ).

tff(addAssignment_42048,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,8)
    <=> v67436(VarCurr,8) ) ).

tff(addAssignment_42047,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,8)
    <=> v67438(VarCurr,8) ) ).

tff(addAssignment_42046,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,8)
    <=> v67497(VarCurr,8) ) ).

tff(addAssignment_42045,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,8)
    <=> v67493(VarCurr,8) ) ).

tff(addAssignment_42044,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,8)
    <=> v67495(VarCurr,8) ) ).

tff(addAssignment_42043,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,8)
    <=> v67496(VarCurr,8) ) ).

tff(addAssignment_42042,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,20)
    <=> v33839(VarCurr,20) ) ).

tff(addAssignment_42041,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,8)
    <=> v67489(VarCurr,8) ) ).

tff(addAssignment_42040,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,8)
    <=> v6234(VarCurr,8) ) ).

tff(addAssignment_42039,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,8)
    <=> v67485(VarCurr,8) ) ).

tff(addAssignment_42038,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_42037,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,8)
    <=> v67409(VarCurr,8) ) ).

tff(addAssignment_42036,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,8)
    <=> v67423(VarCurr,8) ) ).

tff(addAssignment_42035,axiom,
    ! [VarCurr: state_type] :
      ( v69468(VarCurr)
    <=> v69470(VarCurr) ) ).

tff(addAssignment_42034,axiom,
    ! [VarCurr: state_type] :
      ( v69470(VarCurr)
    <=> v67349(VarCurr,0) ) ).

tff(addAssignment_42033,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,0)
    <=> v67351(VarCurr,0) ) ).

tff(addAssignment_42032,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,0)
    <=> v67353(VarCurr,0) ) ).

tff(addAssignment_42031,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,0)
    <=> v67355(VarCurr,0) ) ).

tff(addAssignment_42030,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,0)
    <=> v67357(VarCurr,0) ) ).

tff(addAssignment_42029,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,0)
    <=> v67359(VarCurr,0) ) ).

tff(addAssignment_42028,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,0)
    <=> v67580(VarCurr,0) ) ).

tff(addAssignment_42027,axiom,
    ! [VarCurr: state_type] :
      ( v67361(VarCurr,0)
    <=> v67363(VarCurr,0) ) ).

tff(addAssignment_42026,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,0)
    <=> v67365(VarCurr,0) ) ).

tff(addAssignment_42025,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,0)
    <=> v69472(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69473(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69472(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_820,axiom,
    ! [VarNext: state_type] :
      ( v69473(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69472(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69473(VarNext)
      <=> v69474(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69474(VarNext)
      <=> ( v69476(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69476(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_42024,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,0)
    <=> v67389(VarCurr,0) ) ).

tff(addAssignment_42023,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,0)
    <=> v67391(VarCurr,0) ) ).

tff(addAssignment_42022,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,0)
    <=> v67393(VarCurr,0) ) ).

tff(addAssignment_42021,axiom,
    ! [VarCurr: state_type] :
      ( v67393(VarCurr,0)
    <=> v67395(VarCurr,0) ) ).

tff(addAssignment_42020,axiom,
    ! [VarCurr: state_type] :
      ( v67395(VarCurr,0)
    <=> v67531(VarCurr,0) ) ).

tff(addAssignment_42019,axiom,
    ! [VarCurr: state_type] :
      ( v67522(VarCurr,0)
    <=> v67524(VarCurr,0) ) ).

tff(addAssignment_42018,axiom,
    ! [VarCurr: state_type] :
      ( v67524(VarCurr,0)
    <=> v67401(VarCurr,0) ) ).

tff(addAssignment_42017,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,0)
    <=> v67403(VarCurr,0) ) ).

tff(addAssignment_42016,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,0)
    <=> v67405(VarCurr,0) ) ).

tff(addAssignment_42015,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,0)
    <=> v67514(VarCurr,0) ) ).

tff(addAssignment_42014,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,0)
    <=> v67428(VarCurr,0) ) ).

tff(addAssignment_42013,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,0)
    <=> v67430(VarCurr,0) ) ).

tff(addAssignment_42012,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,0)
    <=> v67432(VarCurr,0) ) ).

tff(addAssignment_42011,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,0)
    <=> v67434(VarCurr,0) ) ).

tff(addAssignment_42010,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,0)
    <=> v67436(VarCurr,0) ) ).

tff(addAssignment_42009,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,0)
    <=> v67438(VarCurr,0) ) ).

tff(addAssignment_42008,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,0)
    <=> v67497(VarCurr,0) ) ).

tff(addAssignment_42007,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,0)
    <=> v67493(VarCurr,0) ) ).

tff(addAssignment_42006,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,0)
    <=> v67495(VarCurr,0) ) ).

tff(addAssignment_42005,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,0)
    <=> v67496(VarCurr,0) ) ).

tff(addAssignment_42004,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,6)
    <=> v33839(VarCurr,6) ) ).

tff(addAssignment_42003,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,0)
    <=> v67489(VarCurr,0) ) ).

tff(addAssignment_42002,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,0)
    <=> v6234(VarCurr,0) ) ).

tff(addAssignment_42001,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,0)
    <=> v67485(VarCurr,0) ) ).

tff(addAssignment_42000,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_41999,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,0)
    <=> v67409(VarCurr,0) ) ).

tff(addAssignment_41998,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,0)
    <=> v67423(VarCurr,0) ) ).

tff(addAssignment_41997,axiom,
    ! [VarCurr: state_type] :
      ( v67397(VarCurr,0)
    <=> v67399(VarCurr,0) ) ).

tff(addAssignment_41996,axiom,
    ! [VarCurr: state_type] :
      ( v67399(VarCurr,0)
    <=> v67401(VarCurr,4) ) ).

tff(addAssignment_41995,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,4)
    <=> v67403(VarCurr,4) ) ).

tff(addAssignment_41994,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,4)
    <=> v67405(VarCurr,4) ) ).

tff(addAssignment_41993,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,4)
    <=> v67514(VarCurr,4) ) ).

tff(addAssignment_41992,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,4)
    <=> v67428(VarCurr,4) ) ).

tff(addAssignment_41991,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,4)
    <=> v67430(VarCurr,4) ) ).

tff(addAssignment_41990,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,4)
    <=> v67432(VarCurr,4) ) ).

tff(addAssignment_41989,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,4)
    <=> v67434(VarCurr,4) ) ).

tff(addAssignment_41988,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,4)
    <=> v67436(VarCurr,4) ) ).

tff(addAssignment_41987,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,4)
    <=> v67438(VarCurr,4) ) ).

tff(addAssignment_41986,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,4)
    <=> v67497(VarCurr,4) ) ).

tff(addAssignment_41985,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,4)
    <=> v67493(VarCurr,4) ) ).

tff(addAssignment_41984,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,4)
    <=> v67495(VarCurr,4) ) ).

tff(addAssignment_41983,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,4)
    <=> v67496(VarCurr,4) ) ).

tff(addAssignment_41982,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,10)
    <=> v33839(VarCurr,10) ) ).

tff(addAssignment_41981,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,4)
    <=> v67489(VarCurr,4) ) ).

tff(addAssignment_41980,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,4)
    <=> v6234(VarCurr,4) ) ).

tff(addAssignment_41979,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,4)
    <=> v67485(VarCurr,4) ) ).

tff(addAssignment_41978,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_41977,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,4)
    <=> v67409(VarCurr,4) ) ).

tff(addAssignment_41976,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,4)
    <=> v67423(VarCurr,4) ) ).

tff(addAssignment_41975,axiom,
    ! [VarCurr: state_type] :
      ( v69114(VarCurr)
    <=> v69116(VarCurr) ) ).

tff(addAssignment_41974,axiom,
    ! [VarCurr: state_type] :
      ( v69116(VarCurr)
    <=> v67307(VarCurr,1) ) ).

tff(addAssignment_41973,axiom,
    ! [VarCurr: state_type] :
      ( v67307(VarCurr,1)
    <=> v67309(VarCurr,9) ) ).

tff(addAssignment_41972,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,9)
    <=> v67311(VarCurr,9) ) ).

tff(addAssignment_41971,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,9)
    <=> v67313(VarCurr,9) ) ).

tff(addAssignment_41970,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,9)
    <=> v67315(VarCurr,9) ) ).

tff(addAssignment_41969,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,9)
    <=> v67317(VarCurr,9) ) ).

tff(addAssignment_41968,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,9)
    <=> v68771(VarCurr,9) ) ).

tff(addAssignment_41967,axiom,
    ! [VarCurr: state_type] :
      ( v67319(VarCurr,1)
    <=> v69118(VarCurr) ) ).

tff(addAssignment_41966,axiom,
    ! [VarCurr: state_type] :
      ( v69118(VarCurr)
    <=> v69120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6406,axiom,
    ! [VarCurr: state_type] :
      ( v69120(VarCurr)
    <=> ( v69438(VarCurr)
      <~> v69426(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6405,axiom,
    ! [VarCurr: state_type] :
      ( v69438(VarCurr)
    <=> ( v69122(VarCurr)
      <~> v69278(VarCurr) ) ) ).

tff(addAssignment_41965,axiom,
    ! [VarCurr: state_type] :
      ( v69426(VarCurr)
    <=> v69428(VarCurr) ) ).

tff(addAssignment_41964,axiom,
    ! [VarCurr: state_type] :
      ( v69428(VarCurr)
    <=> v68672(VarCurr,1) ) ).

tff(addAssignment_41963,axiom,
    ! [VarCurr: state_type] :
      ( v68672(VarCurr,1)
    <=> v68674(VarCurr,1) ) ).

tff(addAssignment_41962,axiom,
    ! [VarCurr: state_type] :
      ( v68674(VarCurr,1)
    <=> v68676(VarCurr,1) ) ).

tff(addAssignment_41961,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,1)
    <=> v68678(VarCurr,1) ) ).

tff(addAssignment_41960,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,1)
    <=> v69430(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69431(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v69430(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_819,axiom,
    ! [VarNext: state_type] :
      ( v69431(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v69430(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69431(VarNext)
      <=> v69432(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69432(VarNext)
      <=> ( v69434(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69434(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_41959,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,1)
    <=> v68702(VarCurr,1) ) ).

tff(addAssignment_41958,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,1)
    <=> v68731(VarCurr,1) ) ).

tff(addAssignment_41957,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,9)
    <=> v68705(VarCurr,1) ) ).

tff(addAssignment_41956,axiom,
    ! [VarCurr: state_type] :
      ( v68705(VarCurr,1)
    <=> v68707(VarCurr,1) ) ).

tff(addAssignment_41955,axiom,
    ! [VarCurr: state_type] :
      ( v68707(VarCurr,1)
    <=> v68724(VarCurr,1) ) ).

tff(addAssignment_41954,axiom,
    ! [VarCurr: state_type] :
      ( v68717(VarCurr,1)
    <=> v68719(VarCurr,1) ) ).

tff(addAssignment_41953,axiom,
    ! [VarCurr: state_type] :
      ( v68719(VarCurr,1)
    <=> v68455(VarCurr,9) ) ).

tff(addAssignment_41952,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,9)
    <=> v68457(VarCurr,9) ) ).

tff(addAssignment_41951,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,9)
    <=> v68459(VarCurr,9) ) ).

tff(addAssignment_41950,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,9)
    <=> v68548(VarCurr,9) ) ).

tff(addAssignment_41949,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,9)
    <=> v68469(VarCurr,9) ) ).

tff(addAssignment_41948,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,9)
    <=> v68471(VarCurr,9) ) ).

tff(addAssignment_41947,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,9)
    <=> v67432(VarCurr,137) ) ).

tff(addAssignment_41946,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,137)
    <=> v67434(VarCurr,137) ) ).

tff(addAssignment_41945,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,137)
    <=> v68473(VarCurr,9) ) ).

tff(addAssignment_41944,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,9)
    <=> v68475(VarCurr,9) ) ).

tff(addAssignment_41943,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,9)
    <=> v68531(VarCurr,9) ) ).

tff(addAssignment_41942,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,9)
    <=> v68530(VarCurr,9) ) ).

tff(addAssignment_41941,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,9)
    <=> v6234(VarCurr,65) ) ).

tff(addAssignment_41940,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,9)
    <=> v68526(VarCurr,9) ) ).

tff(addAssignment_41939,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,9)
    <=> v53217(VarCurr,65) ) ).

tff(addAssignment_41938,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,9)
    <=> v68522(VarCurr,9) ) ).

tff(addAssignment_41937,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_41936,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,9)
    <=> v68463(VarCurr,9) ) ).

tff(addAssignment_41935,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,9)
    <=> v68464(VarCurr,9) ) ).

tff(addAssignment_41934,axiom,
    ! [VarCurr: state_type] :
      ( v68709(VarCurr,1)
    <=> v68711(VarCurr,1) ) ).

tff(addAssignment_41933,axiom,
    ! [VarCurr: state_type] :
      ( v68711(VarCurr,1)
    <=> v68455(VarCurr,5) ) ).

tff(addAssignment_41932,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,5)
    <=> v68457(VarCurr,5) ) ).

tff(addAssignment_41931,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,5)
    <=> v68459(VarCurr,5) ) ).

tff(addAssignment_41930,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,5)
    <=> v68548(VarCurr,5) ) ).

tff(addAssignment_41929,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,5)
    <=> v68469(VarCurr,5) ) ).

tff(addAssignment_41928,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,5)
    <=> v68471(VarCurr,5) ) ).

tff(addAssignment_41927,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,5)
    <=> v67432(VarCurr,133) ) ).

tff(addAssignment_41926,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,133)
    <=> v67434(VarCurr,133) ) ).

tff(addAssignment_41925,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,133)
    <=> v68473(VarCurr,5) ) ).

tff(addAssignment_41924,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,5)
    <=> v68475(VarCurr,5) ) ).

tff(addAssignment_41923,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,5)
    <=> v68531(VarCurr,5) ) ).

tff(addAssignment_41922,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,5)
    <=> v68530(VarCurr,5) ) ).

tff(addAssignment_41921,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,5)
    <=> v6234(VarCurr,61) ) ).

tff(addAssignment_41920,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,5)
    <=> v68526(VarCurr,5) ) ).

tff(addAssignment_41919,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,5)
    <=> v53217(VarCurr,61) ) ).

tff(addAssignment_41918,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,5)
    <=> v68522(VarCurr,5) ) ).

tff(addAssignment_41917,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_41916,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,5)
    <=> v68463(VarCurr,5) ) ).

tff(addAssignment_41915,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,5)
    <=> v68464(VarCurr,5) ) ).

tff(addAssignment_41914,axiom,
    ! [VarCurr: state_type] :
      ( v69278(VarCurr)
    <=> v69280(VarCurr) ) ).

tff(addAssignment_41913,axiom,
    ! [VarCurr: state_type] :
      ( v69280(VarCurr)
    <=> v69282(VarCurr) ) ).

tff(addAssignment_41912,axiom,
    ! [VarCurr: state_type] :
      ( v69282(VarCurr)
    <=> v69284(VarCurr) ) ).

tff(addAssignment_41911,axiom,
    ! [VarCurr: state_type] :
      ( v69284(VarCurr)
    <=> v69286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6402,axiom,
    ! [VarCurr: state_type] :
      ( v69286(VarCurr)
    <=> ( v69424(VarCurr)
      <~> v69384(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6401,axiom,
    ! [VarCurr: state_type] :
      ( v69424(VarCurr)
    <=> ( v69288(VarCurr)
      <~> v69336(VarCurr) ) ) ).

tff(addAssignment_41910,axiom,
    ! [VarCurr: state_type] :
      ( v69384(VarCurr)
    <=> v69386(VarCurr) ) ).

tff(addAssignment_41909,axiom,
    ! [VarCurr: state_type] :
      ( v69386(VarCurr)
    <=> v69388(VarCurr) ) ).

tff(addAssignment_41908,axiom,
    ! [VarCurr: state_type] :
      ( v69388(VarCurr)
    <=> v69390(VarCurr) ) ).

tff(addAssignment_41907,axiom,
    ! [VarCurr: state_type] :
      ( v69390(VarCurr)
    <=> v69392(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6400,axiom,
    ! [VarCurr: state_type] :
      ( v69392(VarCurr)
    <=> ( v69422(VarCurr)
      <~> v69418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6399,axiom,
    ! [VarCurr: state_type] :
      ( v69422(VarCurr)
    <=> ( v69394(VarCurr)
      <~> v69406(VarCurr) ) ) ).

tff(addAssignment_41906,axiom,
    ! [VarCurr: state_type] :
      ( v69418(VarCurr)
    <=> v69420(VarCurr) ) ).

tff(addAssignment_41905,axiom,
    ! [VarCurr: state_type] :
      ( v69420(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_41904,axiom,
    ! [VarCurr: state_type] :
      ( v69406(VarCurr)
    <=> v69408(VarCurr) ) ).

tff(addAssignment_41903,axiom,
    ! [VarCurr: state_type] :
      ( v69408(VarCurr)
    <=> v67349(VarCurr,125) ) ).

tff(addAssignment_41902,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,125)
    <=> v68249(VarCurr,61) ) ).

tff(addAssignment_41901,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,61)
    <=> v68251(VarCurr,61) ) ).

tff(addAssignment_41900,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,61)
    <=> v68253(VarCurr,61) ) ).

tff(addAssignment_41899,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,61)
    <=> v68255(VarCurr,61) ) ).

tff(addAssignment_41898,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,61)
    <=> v67359(VarCurr,125) ) ).

tff(addAssignment_41897,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,125)
    <=> v67580(VarCurr,125) ) ).

tff(addAssignment_41896,axiom,
    ! [VarCurr: state_type] :
      ( v67581(VarCurr,1)
    <=> v68258(VarCurr,61) ) ).

tff(addAssignment_41895,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,61)
    <=> v68260(VarCurr,61) ) ).

tff(addAssignment_41894,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,61)
    <=> v69410(VarNext,61) ) ).

tff(addCaseBooleanConditionEqualRanges1_818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69411(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69410(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_818,axiom,
    ! [VarNext: state_type] :
      ( v69411(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69410(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69411(VarNext)
      <=> v69412(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69412(VarNext)
      <=> ( v69414(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69414(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_41893,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,61)
    <=> v68284(VarCurr,61) ) ).

tff(addAssignment_41892,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,61)
    <=> v67391(VarCurr,125) ) ).

tff(addAssignment_41891,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,125)
    <=> v68447(VarCurr,1) ) ).

tff(addAssignment_41890,axiom,
    ! [VarCurr: state_type] :
      ( v68447(VarCurr,1)
    <=> v68449(VarCurr,1) ) ).

tff(addAssignment_41889,axiom,
    ! [VarCurr: state_type] :
      ( v68449(VarCurr,1)
    <=> v68561(VarCurr,1) ) ).

tff(addAssignment_41888,axiom,
    ! [VarCurr: state_type] :
      ( v68554(VarCurr,1)
    <=> v68556(VarCurr,1) ) ).

tff(addAssignment_41887,axiom,
    ! [VarCurr: state_type] :
      ( v68556(VarCurr,1)
    <=> v67401(VarCurr,125) ) ).

tff(addAssignment_41886,axiom,
    ! [VarCurr: state_type] :
      ( v68451(VarCurr,1)
    <=> v68453(VarCurr,1) ) ).

tff(addAssignment_41885,axiom,
    ! [VarCurr: state_type] :
      ( v68453(VarCurr,1)
    <=> v68455(VarCurr,13) ) ).

tff(addAssignment_41884,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,13)
    <=> v68457(VarCurr,13) ) ).

tff(addAssignment_41883,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,13)
    <=> v68459(VarCurr,13) ) ).

tff(addAssignment_41882,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,13)
    <=> v68548(VarCurr,13) ) ).

tff(addAssignment_41881,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,13)
    <=> v68469(VarCurr,13) ) ).

tff(addAssignment_41880,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,13)
    <=> v68471(VarCurr,13) ) ).

tff(addAssignment_41879,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,13)
    <=> v67432(VarCurr,141) ) ).

tff(addAssignment_41878,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,141)
    <=> v67434(VarCurr,141) ) ).

tff(addAssignment_41877,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,141)
    <=> v68473(VarCurr,13) ) ).

tff(addAssignment_41876,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,13)
    <=> v68475(VarCurr,13) ) ).

tff(addAssignment_41875,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,13)
    <=> v68531(VarCurr,13) ) ).

tff(addAssignment_41874,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,13)
    <=> v68530(VarCurr,13) ) ).

tff(addAssignment_41873,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,13)
    <=> v6234(VarCurr,69) ) ).

tff(addAssignment_41872,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,13)
    <=> v68526(VarCurr,13) ) ).

tff(addAssignment_41871,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,13)
    <=> v53217(VarCurr,69) ) ).

tff(addAssignment_41870,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,13)
    <=> v68522(VarCurr,13) ) ).

tff(addAssignment_41869,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_41868,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,13)
    <=> v68463(VarCurr,13) ) ).

tff(addAssignment_41867,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,13)
    <=> v68464(VarCurr,13) ) ).

tff(addAssignment_41866,axiom,
    ! [VarCurr: state_type] :
      ( v69394(VarCurr)
    <=> v69396(VarCurr) ) ).

tff(addAssignment_41865,axiom,
    ! [VarCurr: state_type] :
      ( v69396(VarCurr)
    <=> v67349(VarCurr,121) ) ).

tff(addAssignment_41864,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,121)
    <=> v68249(VarCurr,57) ) ).

tff(addAssignment_41863,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,57)
    <=> v68251(VarCurr,57) ) ).

tff(addAssignment_41862,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,57)
    <=> v68253(VarCurr,57) ) ).

tff(addAssignment_41861,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,57)
    <=> v68255(VarCurr,57) ) ).

tff(addAssignment_41860,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,57)
    <=> v67359(VarCurr,121) ) ).

tff(addAssignment_41859,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,121)
    <=> v67580(VarCurr,121) ) ).

tff(addAssignment_41858,axiom,
    ! [VarCurr: state_type] :
      ( v67582(VarCurr,1)
    <=> v68258(VarCurr,57) ) ).

tff(addAssignment_41857,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,57)
    <=> v68260(VarCurr,57) ) ).

tff(addAssignment_41856,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,57)
    <=> v69398(VarNext,57) ) ).

tff(addCaseBooleanConditionEqualRanges1_817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69399(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69398(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_817,axiom,
    ! [VarNext: state_type] :
      ( v69399(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69398(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69399(VarNext)
      <=> v69400(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69400(VarNext)
      <=> ( v69402(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69402(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_41855,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,57)
    <=> v68284(VarCurr,57) ) ).

tff(addAssignment_41854,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,57)
    <=> v67391(VarCurr,121) ) ).

tff(addAssignment_41853,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,121)
    <=> v68286(VarCurr,1) ) ).

tff(addAssignment_41852,axiom,
    ! [VarCurr: state_type] :
      ( v68286(VarCurr,1)
    <=> v68288(VarCurr,1) ) ).

tff(addAssignment_41851,axiom,
    ! [VarCurr: state_type] :
      ( v68288(VarCurr,1)
    <=> v68398(VarCurr,1) ) ).

tff(addAssignment_41850,axiom,
    ! [VarCurr: state_type] :
      ( v68391(VarCurr,1)
    <=> v68393(VarCurr,1) ) ).

tff(addAssignment_41849,axiom,
    ! [VarCurr: state_type] :
      ( v68393(VarCurr,1)
    <=> v67401(VarCurr,121) ) ).

tff(addAssignment_41848,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,121)
    <=> v68294(VarCurr,57) ) ).

tff(addAssignment_41847,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,57)
    <=> v68296(VarCurr,57) ) ).

tff(addAssignment_41846,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,57)
    <=> v68385(VarCurr,57) ) ).

tff(addAssignment_41845,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,57)
    <=> v68306(VarCurr,57) ) ).

tff(addAssignment_41844,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,57)
    <=> v67430(VarCurr,121) ) ).

tff(addAssignment_41843,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,121)
    <=> v67432(VarCurr,121) ) ).

tff(addAssignment_41842,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,121)
    <=> v67434(VarCurr,121) ) ).

tff(addAssignment_41841,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,121)
    <=> v68308(VarCurr,57) ) ).

tff(addAssignment_41840,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,57)
    <=> v68310(VarCurr,57) ) ).

tff(addAssignment_41839,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,57)
    <=> v68368(VarCurr,57) ) ).

tff(addAssignment_41838,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,57)
    <=> v68366(VarCurr,57) ) ).

tff(addAssignment_41837,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,57)
    <=> v68367(VarCurr,57) ) ).

tff(addAssignment_41836,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,57)
    <=> v68361(VarCurr,57) ) ).

tff(addAssignment_41835,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,57)
    <=> v68362(VarCurr,57) ) ).

tff(addAssignment_41834,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,57)
    <=> v68357(VarCurr,57) ) ).

tff(addAssignment_41833,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,57)
    <=> $false ) ).

tff(addAssignment_41832,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,57)
    <=> v68300(VarCurr,57) ) ).

tff(addAssignment_41831,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,57)
    <=> v68301(VarCurr,57) ) ).

tff(addAssignment_41830,axiom,
    ! [VarCurr: state_type] :
      ( v68290(VarCurr,1)
    <=> v68292(VarCurr,1) ) ).

tff(addAssignment_41829,axiom,
    ! [VarCurr: state_type] :
      ( v68292(VarCurr,1)
    <=> v67401(VarCurr,125) ) ).

tff(addAssignment_41828,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,125)
    <=> v68294(VarCurr,61) ) ).

tff(addAssignment_41827,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,61)
    <=> v68296(VarCurr,61) ) ).

tff(addAssignment_41826,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,61)
    <=> v68385(VarCurr,61) ) ).

tff(addAssignment_41825,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,61)
    <=> v68306(VarCurr,61) ) ).

tff(addAssignment_41824,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,61)
    <=> v67430(VarCurr,125) ) ).

tff(addAssignment_41823,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,125)
    <=> v67432(VarCurr,125) ) ).

tff(addAssignment_41822,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,125)
    <=> v67434(VarCurr,125) ) ).

tff(addAssignment_41821,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,125)
    <=> v68308(VarCurr,61) ) ).

tff(addAssignment_41820,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,61)
    <=> v68310(VarCurr,61) ) ).

tff(addAssignment_41819,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,61)
    <=> v68368(VarCurr,61) ) ).

tff(addAssignment_41818,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,61)
    <=> v68366(VarCurr,61) ) ).

tff(addAssignment_41817,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,61)
    <=> v68367(VarCurr,61) ) ).

tff(addAssignment_41816,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,61)
    <=> v68361(VarCurr,61) ) ).

tff(addAssignment_41815,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,61)
    <=> v68362(VarCurr,61) ) ).

tff(addAssignment_41814,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,61)
    <=> v68357(VarCurr,61) ) ).

tff(addAssignment_41813,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,61)
    <=> $false ) ).

tff(addAssignment_41812,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,61)
    <=> v68300(VarCurr,61) ) ).

tff(addAssignment_41811,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,61)
    <=> v68301(VarCurr,61) ) ).

tff(addAssignment_41810,axiom,
    ! [VarCurr: state_type] :
      ( v69336(VarCurr)
    <=> v69338(VarCurr) ) ).

tff(addAssignment_41809,axiom,
    ! [VarCurr: state_type] :
      ( v69338(VarCurr)
    <=> v69340(VarCurr) ) ).

tff(addAssignment_41808,axiom,
    ! [VarCurr: state_type] :
      ( v69340(VarCurr)
    <=> v69342(VarCurr) ) ).

tff(addAssignment_41807,axiom,
    ! [VarCurr: state_type] :
      ( v69342(VarCurr)
    <=> v69344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6394,axiom,
    ! [VarCurr: state_type] :
      ( v69344(VarCurr)
    <=> ( v69382(VarCurr)
      <~> v69370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6393,axiom,
    ! [VarCurr: state_type] :
      ( v69382(VarCurr)
    <=> ( v69346(VarCurr)
      <~> v69358(VarCurr) ) ) ).

tff(addAssignment_41806,axiom,
    ! [VarCurr: state_type] :
      ( v69370(VarCurr)
    <=> v69372(VarCurr) ) ).

tff(addAssignment_41805,axiom,
    ! [VarCurr: state_type] :
      ( v69372(VarCurr)
    <=> v67349(VarCurr,57) ) ).

tff(addAssignment_41804,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,57)
    <=> v67351(VarCurr,57) ) ).

tff(addAssignment_41803,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,57)
    <=> v67353(VarCurr,57) ) ).

tff(addAssignment_41802,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,57)
    <=> v67355(VarCurr,57) ) ).

tff(addAssignment_41801,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,57)
    <=> v67357(VarCurr,57) ) ).

tff(addAssignment_41800,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,57)
    <=> v67359(VarCurr,57) ) ).

tff(addAssignment_41799,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,57)
    <=> v67580(VarCurr,57) ) ).

tff(addAssignment_41798,axiom,
    ! [VarCurr: state_type] :
      ( v67598(VarCurr,1)
    <=> v67363(VarCurr,57) ) ).

tff(addAssignment_41797,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,57)
    <=> v67365(VarCurr,57) ) ).

tff(addAssignment_41796,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,57)
    <=> v69374(VarNext,57) ) ).

tff(addCaseBooleanConditionEqualRanges1_816,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69375(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69374(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_816,axiom,
    ! [VarNext: state_type] :
      ( v69375(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69374(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69375(VarNext)
      <=> v69376(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69376(VarNext)
      <=> ( v69378(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69378(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41795,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,57)
    <=> v67389(VarCurr,57) ) ).

tff(addAssignment_41794,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,57)
    <=> v67391(VarCurr,57) ) ).

tff(addAssignment_41793,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,57)
    <=> v68198(VarCurr,1) ) ).

tff(addAssignment_41792,axiom,
    ! [VarCurr: state_type] :
      ( v68198(VarCurr,1)
    <=> v68200(VarCurr,1) ) ).

tff(addAssignment_41791,axiom,
    ! [VarCurr: state_type] :
      ( v68200(VarCurr,1)
    <=> v68217(VarCurr,1) ) ).

tff(addAssignment_41790,axiom,
    ! [VarCurr: state_type] :
      ( v68210(VarCurr,1)
    <=> v68212(VarCurr,1) ) ).

tff(addAssignment_41789,axiom,
    ! [VarCurr: state_type] :
      ( v68212(VarCurr,1)
    <=> v67401(VarCurr,57) ) ).

tff(addAssignment_41788,axiom,
    ! [VarCurr: state_type] :
      ( v68202(VarCurr,1)
    <=> v68204(VarCurr,1) ) ).

tff(addAssignment_41787,axiom,
    ! [VarCurr: state_type] :
      ( v68204(VarCurr,1)
    <=> v67401(VarCurr,61) ) ).

tff(addAssignment_41786,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,61)
    <=> v67403(VarCurr,61) ) ).

tff(addAssignment_41785,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,61)
    <=> v67405(VarCurr,61) ) ).

tff(addAssignment_41784,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,61)
    <=> v67514(VarCurr,61) ) ).

tff(addAssignment_41783,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,61)
    <=> v67428(VarCurr,61) ) ).

tff(addAssignment_41782,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,61)
    <=> v67430(VarCurr,61) ) ).

tff(addAssignment_41781,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,61)
    <=> v67432(VarCurr,61) ) ).

tff(addAssignment_41780,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,61)
    <=> v67434(VarCurr,61) ) ).

tff(addAssignment_41779,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,61)
    <=> v67436(VarCurr,61) ) ).

tff(addAssignment_41778,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,61)
    <=> v67438(VarCurr,61) ) ).

tff(addAssignment_41777,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,61)
    <=> v67497(VarCurr,61) ) ).

tff(addAssignment_41776,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,61)
    <=> v67493(VarCurr,61) ) ).

tff(addAssignment_41775,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,61)
    <=> v67495(VarCurr,61) ) ).

tff(addAssignment_41774,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,61)
    <=> v67496(VarCurr,61) ) ).

tff(addAssignment_41773,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,127)
    <=> v33839(VarCurr,127) ) ).

tff(addAssignment_41772,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,127)
    <=> v33841(VarCurr,127) ) ).

tff(addAssignment_41771,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,127)
    <=> v25005(VarCurr,7) ) ).

tff(addAssignment_41770,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,61)
    <=> v67489(VarCurr,61) ) ).

tff(addAssignment_41769,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,61)
    <=> v6234(VarCurr,61) ) ).

tff(addAssignment_41768,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,61)
    <=> v67485(VarCurr,61) ) ).

tff(addAssignment_41767,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,61)
    <=> $false ) ).

tff(addAssignment_41766,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,61)
    <=> v67409(VarCurr,61) ) ).

tff(addAssignment_41765,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,61)
    <=> v67423(VarCurr,61) ) ).

tff(addAssignment_41764,axiom,
    ! [VarCurr: state_type] :
      ( v69358(VarCurr)
    <=> v69360(VarCurr) ) ).

tff(addAssignment_41763,axiom,
    ! [VarCurr: state_type] :
      ( v69360(VarCurr)
    <=> v67349(VarCurr,53) ) ).

tff(addAssignment_41762,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,53)
    <=> v67351(VarCurr,53) ) ).

tff(addAssignment_41761,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,53)
    <=> v67353(VarCurr,53) ) ).

tff(addAssignment_41760,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,53)
    <=> v67355(VarCurr,53) ) ).

tff(addAssignment_41759,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,53)
    <=> v67357(VarCurr,53) ) ).

tff(addAssignment_41758,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,53)
    <=> v67359(VarCurr,53) ) ).

tff(addAssignment_41757,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,53)
    <=> v67580(VarCurr,53) ) ).

tff(addAssignment_41756,axiom,
    ! [VarCurr: state_type] :
      ( v67599(VarCurr,1)
    <=> v67363(VarCurr,53) ) ).

tff(addAssignment_41755,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,53)
    <=> v67365(VarCurr,53) ) ).

tff(addAssignment_41754,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,53)
    <=> v69362(VarNext,53) ) ).

tff(addCaseBooleanConditionEqualRanges1_815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69363(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69362(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_815,axiom,
    ! [VarNext: state_type] :
      ( v69363(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69362(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69363(VarNext)
      <=> v69364(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69364(VarNext)
      <=> ( v69366(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69366(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41753,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,53)
    <=> v67389(VarCurr,53) ) ).

tff(addAssignment_41752,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,53)
    <=> v67391(VarCurr,53) ) ).

tff(addAssignment_41751,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,53)
    <=> v68158(VarCurr,1) ) ).

tff(addAssignment_41750,axiom,
    ! [VarCurr: state_type] :
      ( v68158(VarCurr,1)
    <=> v68160(VarCurr,1) ) ).

tff(addAssignment_41749,axiom,
    ! [VarCurr: state_type] :
      ( v68160(VarCurr,1)
    <=> v68177(VarCurr,1) ) ).

tff(addAssignment_41748,axiom,
    ! [VarCurr: state_type] :
      ( v68170(VarCurr,1)
    <=> v68172(VarCurr,1) ) ).

tff(addAssignment_41747,axiom,
    ! [VarCurr: state_type] :
      ( v68172(VarCurr,1)
    <=> v67401(VarCurr,53) ) ).

tff(addAssignment_41746,axiom,
    ! [VarCurr: state_type] :
      ( v68162(VarCurr,1)
    <=> v68164(VarCurr,1) ) ).

tff(addAssignment_41745,axiom,
    ! [VarCurr: state_type] :
      ( v68164(VarCurr,1)
    <=> v67401(VarCurr,57) ) ).

tff(addAssignment_41744,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,57)
    <=> v67403(VarCurr,57) ) ).

tff(addAssignment_41743,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,57)
    <=> v67405(VarCurr,57) ) ).

tff(addAssignment_41742,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,57)
    <=> v67514(VarCurr,57) ) ).

tff(addAssignment_41741,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,57)
    <=> v67428(VarCurr,57) ) ).

tff(addAssignment_41740,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,57)
    <=> v67430(VarCurr,57) ) ).

tff(addAssignment_41739,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,57)
    <=> v67432(VarCurr,57) ) ).

tff(addAssignment_41738,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,57)
    <=> v67434(VarCurr,57) ) ).

tff(addAssignment_41737,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,57)
    <=> v67436(VarCurr,57) ) ).

tff(addAssignment_41736,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,57)
    <=> v67438(VarCurr,57) ) ).

tff(addAssignment_41735,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,57)
    <=> v67497(VarCurr,57) ) ).

tff(addAssignment_41734,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,57)
    <=> v67493(VarCurr,57) ) ).

tff(addAssignment_41733,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,57)
    <=> v67495(VarCurr,57) ) ).

tff(addAssignment_41732,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,57)
    <=> v67496(VarCurr,57) ) ).

tff(addAssignment_41731,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,117)
    <=> v33839(VarCurr,117) ) ).

tff(addAssignment_41730,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,117)
    <=> v33841(VarCurr,117) ) ).

tff(addAssignment_41729,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,117)
    <=> v23455(VarCurr,9) ) ).

tff(addAssignment_41728,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,57)
    <=> v67489(VarCurr,57) ) ).

tff(addAssignment_41727,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,57)
    <=> v6234(VarCurr,57) ) ).

tff(addAssignment_41726,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,57)
    <=> v67485(VarCurr,57) ) ).

tff(addAssignment_41725,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,57)
    <=> $false ) ).

tff(addAssignment_41724,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,57)
    <=> v67409(VarCurr,57) ) ).

tff(addAssignment_41723,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,57)
    <=> v67423(VarCurr,57) ) ).

tff(addAssignment_41722,axiom,
    ! [VarCurr: state_type] :
      ( v69346(VarCurr)
    <=> v69348(VarCurr) ) ).

tff(addAssignment_41721,axiom,
    ! [VarCurr: state_type] :
      ( v69348(VarCurr)
    <=> v67349(VarCurr,49) ) ).

tff(addAssignment_41720,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,49)
    <=> v67351(VarCurr,49) ) ).

tff(addAssignment_41719,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,49)
    <=> v67353(VarCurr,49) ) ).

tff(addAssignment_41718,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,49)
    <=> v67355(VarCurr,49) ) ).

tff(addAssignment_41717,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,49)
    <=> v67357(VarCurr,49) ) ).

tff(addAssignment_41716,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,49)
    <=> v67359(VarCurr,49) ) ).

tff(addAssignment_41715,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,49)
    <=> v67580(VarCurr,49) ) ).

tff(addAssignment_41714,axiom,
    ! [VarCurr: state_type] :
      ( v67600(VarCurr,1)
    <=> v67363(VarCurr,49) ) ).

tff(addAssignment_41713,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,49)
    <=> v67365(VarCurr,49) ) ).

tff(addAssignment_41712,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,49)
    <=> v69350(VarNext,49) ) ).

tff(addCaseBooleanConditionEqualRanges1_814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69351(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69350(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_814,axiom,
    ! [VarNext: state_type] :
      ( v69351(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69350(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69351(VarNext)
      <=> v69352(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69352(VarNext)
      <=> ( v69354(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69354(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41711,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,49)
    <=> v67389(VarCurr,49) ) ).

tff(addAssignment_41710,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,49)
    <=> v67391(VarCurr,49) ) ).

tff(addAssignment_41709,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,49)
    <=> v68118(VarCurr,1) ) ).

tff(addAssignment_41708,axiom,
    ! [VarCurr: state_type] :
      ( v68118(VarCurr,1)
    <=> v68120(VarCurr,1) ) ).

tff(addAssignment_41707,axiom,
    ! [VarCurr: state_type] :
      ( v68120(VarCurr,1)
    <=> v68137(VarCurr,1) ) ).

tff(addAssignment_41706,axiom,
    ! [VarCurr: state_type] :
      ( v68130(VarCurr,1)
    <=> v68132(VarCurr,1) ) ).

tff(addAssignment_41705,axiom,
    ! [VarCurr: state_type] :
      ( v68132(VarCurr,1)
    <=> v67401(VarCurr,49) ) ).

tff(addAssignment_41704,axiom,
    ! [VarCurr: state_type] :
      ( v68122(VarCurr,1)
    <=> v68124(VarCurr,1) ) ).

tff(addAssignment_41703,axiom,
    ! [VarCurr: state_type] :
      ( v68124(VarCurr,1)
    <=> v67401(VarCurr,53) ) ).

tff(addAssignment_41702,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,53)
    <=> v67403(VarCurr,53) ) ).

tff(addAssignment_41701,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,53)
    <=> v67405(VarCurr,53) ) ).

tff(addAssignment_41700,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,53)
    <=> v67514(VarCurr,53) ) ).

tff(addAssignment_41699,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,53)
    <=> v67428(VarCurr,53) ) ).

tff(addAssignment_41698,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,53)
    <=> v67430(VarCurr,53) ) ).

tff(addAssignment_41697,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,53)
    <=> v67432(VarCurr,53) ) ).

tff(addAssignment_41696,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,53)
    <=> v67434(VarCurr,53) ) ).

tff(addAssignment_41695,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,53)
    <=> v67436(VarCurr,53) ) ).

tff(addAssignment_41694,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,53)
    <=> v67438(VarCurr,53) ) ).

tff(addAssignment_41693,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,53)
    <=> v67497(VarCurr,53) ) ).

tff(addAssignment_41692,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,53)
    <=> v67493(VarCurr,53) ) ).

tff(addAssignment_41691,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,53)
    <=> v67495(VarCurr,53) ) ).

tff(addAssignment_41690,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,53)
    <=> v67496(VarCurr,53) ) ).

tff(addAssignment_41689,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,107)
    <=> v33839(VarCurr,107) ) ).

tff(addAssignment_41688,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,107)
    <=> v33841(VarCurr,107) ) ).

tff(addAssignment_41687,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,107)
    <=> v21905(VarCurr,11) ) ).

tff(addAssignment_41686,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,53)
    <=> v67489(VarCurr,53) ) ).

tff(addAssignment_41685,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,53)
    <=> v6234(VarCurr,53) ) ).

tff(addAssignment_41684,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,53)
    <=> v67485(VarCurr,53) ) ).

tff(addAssignment_41683,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,53)
    <=> $false ) ).

tff(addAssignment_41682,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,53)
    <=> v67409(VarCurr,53) ) ).

tff(addAssignment_41681,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,53)
    <=> v67423(VarCurr,53) ) ).

tff(addAssignment_41680,axiom,
    ! [VarCurr: state_type] :
      ( v69288(VarCurr)
    <=> v69290(VarCurr) ) ).

tff(addAssignment_41679,axiom,
    ! [VarCurr: state_type] :
      ( v69290(VarCurr)
    <=> v69292(VarCurr) ) ).

tff(addAssignment_41678,axiom,
    ! [VarCurr: state_type] :
      ( v69292(VarCurr)
    <=> v69294(VarCurr) ) ).

tff(addAssignment_41677,axiom,
    ! [VarCurr: state_type] :
      ( v69294(VarCurr)
    <=> v69296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6386,axiom,
    ! [VarCurr: state_type] :
      ( v69296(VarCurr)
    <=> ( v69334(VarCurr)
      <~> v69322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6385,axiom,
    ! [VarCurr: state_type] :
      ( v69334(VarCurr)
    <=> ( v69298(VarCurr)
      <~> v69310(VarCurr) ) ) ).

tff(addAssignment_41676,axiom,
    ! [VarCurr: state_type] :
      ( v69322(VarCurr)
    <=> v69324(VarCurr) ) ).

tff(addAssignment_41675,axiom,
    ! [VarCurr: state_type] :
      ( v69324(VarCurr)
    <=> v67349(VarCurr,45) ) ).

tff(addAssignment_41674,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,45)
    <=> v67351(VarCurr,45) ) ).

tff(addAssignment_41673,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,45)
    <=> v67353(VarCurr,45) ) ).

tff(addAssignment_41672,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,45)
    <=> v67355(VarCurr,45) ) ).

tff(addAssignment_41671,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,45)
    <=> v67357(VarCurr,45) ) ).

tff(addAssignment_41670,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,45)
    <=> v67359(VarCurr,45) ) ).

tff(addAssignment_41669,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,45)
    <=> v67580(VarCurr,45) ) ).

tff(addAssignment_41668,axiom,
    ! [VarCurr: state_type] :
      ( v67601(VarCurr,1)
    <=> v67363(VarCurr,45) ) ).

tff(addAssignment_41667,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,45)
    <=> v67365(VarCurr,45) ) ).

tff(addAssignment_41666,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,45)
    <=> v69326(VarNext,45) ) ).

tff(addCaseBooleanConditionEqualRanges1_813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69327(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69326(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_813,axiom,
    ! [VarNext: state_type] :
      ( v69327(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69326(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69327(VarNext)
      <=> v69328(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69328(VarNext)
      <=> ( v69330(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69330(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41665,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,45)
    <=> v67389(VarCurr,45) ) ).

tff(addAssignment_41664,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,45)
    <=> v67391(VarCurr,45) ) ).

tff(addAssignment_41663,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,45)
    <=> v68066(VarCurr,1) ) ).

tff(addAssignment_41662,axiom,
    ! [VarCurr: state_type] :
      ( v68066(VarCurr,1)
    <=> v68068(VarCurr,1) ) ).

tff(addAssignment_41661,axiom,
    ! [VarCurr: state_type] :
      ( v68068(VarCurr,1)
    <=> v68085(VarCurr,1) ) ).

tff(addAssignment_41660,axiom,
    ! [VarCurr: state_type] :
      ( v68078(VarCurr,1)
    <=> v68080(VarCurr,1) ) ).

tff(addAssignment_41659,axiom,
    ! [VarCurr: state_type] :
      ( v68080(VarCurr,1)
    <=> v67401(VarCurr,45) ) ).

tff(addAssignment_41658,axiom,
    ! [VarCurr: state_type] :
      ( v68070(VarCurr,1)
    <=> v68072(VarCurr,1) ) ).

tff(addAssignment_41657,axiom,
    ! [VarCurr: state_type] :
      ( v68072(VarCurr,1)
    <=> v67401(VarCurr,49) ) ).

tff(addAssignment_41656,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,49)
    <=> v67403(VarCurr,49) ) ).

tff(addAssignment_41655,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,49)
    <=> v67405(VarCurr,49) ) ).

tff(addAssignment_41654,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,49)
    <=> v67514(VarCurr,49) ) ).

tff(addAssignment_41653,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,49)
    <=> v67428(VarCurr,49) ) ).

tff(addAssignment_41652,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,49)
    <=> v67430(VarCurr,49) ) ).

tff(addAssignment_41651,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,49)
    <=> v67432(VarCurr,49) ) ).

tff(addAssignment_41650,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,49)
    <=> v67434(VarCurr,49) ) ).

tff(addAssignment_41649,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,49)
    <=> v67436(VarCurr,49) ) ).

tff(addAssignment_41648,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,49)
    <=> v67438(VarCurr,49) ) ).

tff(addAssignment_41647,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,49)
    <=> v67497(VarCurr,49) ) ).

tff(addAssignment_41646,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,49)
    <=> v67493(VarCurr,49) ) ).

tff(addAssignment_41645,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,49)
    <=> v67495(VarCurr,49) ) ).

tff(addAssignment_41644,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,49)
    <=> v67496(VarCurr,49) ) ).

tff(addAssignment_41643,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,103)
    <=> v33839(VarCurr,103) ) ).

tff(addAssignment_41642,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,103)
    <=> v33841(VarCurr,103) ) ).

tff(addAssignment_41641,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,103)
    <=> v21905(VarCurr,7) ) ).

tff(addAssignment_41640,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,49)
    <=> v67489(VarCurr,49) ) ).

tff(addAssignment_41639,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,49)
    <=> v6234(VarCurr,49) ) ).

tff(addAssignment_41638,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,49)
    <=> v67485(VarCurr,49) ) ).

tff(addAssignment_41637,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,49)
    <=> $false ) ).

tff(addAssignment_41636,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,49)
    <=> v67409(VarCurr,49) ) ).

tff(addAssignment_41635,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,49)
    <=> v67423(VarCurr,49) ) ).

tff(addAssignment_41634,axiom,
    ! [VarCurr: state_type] :
      ( v69310(VarCurr)
    <=> v69312(VarCurr) ) ).

tff(addAssignment_41633,axiom,
    ! [VarCurr: state_type] :
      ( v69312(VarCurr)
    <=> v67349(VarCurr,41) ) ).

tff(addAssignment_41632,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,41)
    <=> v67351(VarCurr,41) ) ).

tff(addAssignment_41631,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,41)
    <=> v67353(VarCurr,41) ) ).

tff(addAssignment_41630,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,41)
    <=> v67355(VarCurr,41) ) ).

tff(addAssignment_41629,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,41)
    <=> v67357(VarCurr,41) ) ).

tff(addAssignment_41628,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,41)
    <=> v67359(VarCurr,41) ) ).

tff(addAssignment_41627,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,41)
    <=> v67580(VarCurr,41) ) ).

tff(addAssignment_41626,axiom,
    ! [VarCurr: state_type] :
      ( v67602(VarCurr,1)
    <=> v67363(VarCurr,41) ) ).

tff(addAssignment_41625,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,41)
    <=> v67365(VarCurr,41) ) ).

tff(addAssignment_41624,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,41)
    <=> v69314(VarNext,41) ) ).

tff(addCaseBooleanConditionEqualRanges1_812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69315(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69314(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_812,axiom,
    ! [VarNext: state_type] :
      ( v69315(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69314(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69315(VarNext)
      <=> v69316(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69316(VarNext)
      <=> ( v69318(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69318(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41623,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,41)
    <=> v67389(VarCurr,41) ) ).

tff(addAssignment_41622,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,41)
    <=> v67391(VarCurr,41) ) ).

tff(addAssignment_41621,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,41)
    <=> v68026(VarCurr,1) ) ).

tff(addAssignment_41620,axiom,
    ! [VarCurr: state_type] :
      ( v68026(VarCurr,1)
    <=> v68028(VarCurr,1) ) ).

tff(addAssignment_41619,axiom,
    ! [VarCurr: state_type] :
      ( v68028(VarCurr,1)
    <=> v68045(VarCurr,1) ) ).

tff(addAssignment_41618,axiom,
    ! [VarCurr: state_type] :
      ( v68038(VarCurr,1)
    <=> v68040(VarCurr,1) ) ).

tff(addAssignment_41617,axiom,
    ! [VarCurr: state_type] :
      ( v68040(VarCurr,1)
    <=> v67401(VarCurr,41) ) ).

tff(addAssignment_41616,axiom,
    ! [VarCurr: state_type] :
      ( v68030(VarCurr,1)
    <=> v68032(VarCurr,1) ) ).

tff(addAssignment_41615,axiom,
    ! [VarCurr: state_type] :
      ( v68032(VarCurr,1)
    <=> v67401(VarCurr,45) ) ).

tff(addAssignment_41614,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,45)
    <=> v67403(VarCurr,45) ) ).

tff(addAssignment_41613,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,45)
    <=> v67405(VarCurr,45) ) ).

tff(addAssignment_41612,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,45)
    <=> v67514(VarCurr,45) ) ).

tff(addAssignment_41611,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,45)
    <=> v67428(VarCurr,45) ) ).

tff(addAssignment_41610,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,45)
    <=> v67430(VarCurr,45) ) ).

tff(addAssignment_41609,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,45)
    <=> v67432(VarCurr,45) ) ).

tff(addAssignment_41608,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,45)
    <=> v67434(VarCurr,45) ) ).

tff(addAssignment_41607,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,45)
    <=> v67436(VarCurr,45) ) ).

tff(addAssignment_41606,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,45)
    <=> v67438(VarCurr,45) ) ).

tff(addAssignment_41605,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,45)
    <=> v67497(VarCurr,45) ) ).

tff(addAssignment_41604,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,45)
    <=> v67493(VarCurr,45) ) ).

tff(addAssignment_41603,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,45)
    <=> v67495(VarCurr,45) ) ).

tff(addAssignment_41602,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,45)
    <=> v67496(VarCurr,45) ) ).

tff(addAssignment_41601,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,93)
    <=> v33839(VarCurr,93) ) ).

tff(addAssignment_41600,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,93)
    <=> v33841(VarCurr,93) ) ).

tff(addAssignment_41599,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,93)
    <=> v20355(VarCurr,9) ) ).

tff(addAssignment_41598,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,45)
    <=> v67489(VarCurr,45) ) ).

tff(addAssignment_41597,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,45)
    <=> v6234(VarCurr,45) ) ).

tff(addAssignment_41596,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,45)
    <=> v67485(VarCurr,45) ) ).

tff(addAssignment_41595,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,45)
    <=> $false ) ).

tff(addAssignment_41594,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,45)
    <=> v67409(VarCurr,45) ) ).

tff(addAssignment_41593,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,45)
    <=> v67423(VarCurr,45) ) ).

tff(addAssignment_41592,axiom,
    ! [VarCurr: state_type] :
      ( v69298(VarCurr)
    <=> v69300(VarCurr) ) ).

tff(addAssignment_41591,axiom,
    ! [VarCurr: state_type] :
      ( v69300(VarCurr)
    <=> v67349(VarCurr,37) ) ).

tff(addAssignment_41590,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,37)
    <=> v67351(VarCurr,37) ) ).

tff(addAssignment_41589,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,37)
    <=> v67353(VarCurr,37) ) ).

tff(addAssignment_41588,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,37)
    <=> v67355(VarCurr,37) ) ).

tff(addAssignment_41587,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,37)
    <=> v67357(VarCurr,37) ) ).

tff(addAssignment_41586,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,37)
    <=> v67359(VarCurr,37) ) ).

tff(addAssignment_41585,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,37)
    <=> v67580(VarCurr,37) ) ).

tff(addAssignment_41584,axiom,
    ! [VarCurr: state_type] :
      ( v67603(VarCurr,1)
    <=> v67363(VarCurr,37) ) ).

tff(addAssignment_41583,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,37)
    <=> v67365(VarCurr,37) ) ).

tff(addAssignment_41582,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,37)
    <=> v69302(VarNext,37) ) ).

tff(addCaseBooleanConditionEqualRanges1_811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69303(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69302(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_811,axiom,
    ! [VarNext: state_type] :
      ( v69303(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69302(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69303(VarNext)
      <=> v69304(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69304(VarNext)
      <=> ( v69306(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69306(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41581,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,37)
    <=> v67389(VarCurr,37) ) ).

tff(addAssignment_41580,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,37)
    <=> v67391(VarCurr,37) ) ).

tff(addAssignment_41579,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,37)
    <=> v67986(VarCurr,1) ) ).

tff(addAssignment_41578,axiom,
    ! [VarCurr: state_type] :
      ( v67986(VarCurr,1)
    <=> v67988(VarCurr,1) ) ).

tff(addAssignment_41577,axiom,
    ! [VarCurr: state_type] :
      ( v67988(VarCurr,1)
    <=> v68005(VarCurr,1) ) ).

tff(addAssignment_41576,axiom,
    ! [VarCurr: state_type] :
      ( v67998(VarCurr,1)
    <=> v68000(VarCurr,1) ) ).

tff(addAssignment_41575,axiom,
    ! [VarCurr: state_type] :
      ( v68000(VarCurr,1)
    <=> v67401(VarCurr,37) ) ).

tff(addAssignment_41574,axiom,
    ! [VarCurr: state_type] :
      ( v67990(VarCurr,1)
    <=> v67992(VarCurr,1) ) ).

tff(addAssignment_41573,axiom,
    ! [VarCurr: state_type] :
      ( v67992(VarCurr,1)
    <=> v67401(VarCurr,41) ) ).

tff(addAssignment_41572,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,41)
    <=> v67403(VarCurr,41) ) ).

tff(addAssignment_41571,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,41)
    <=> v67405(VarCurr,41) ) ).

tff(addAssignment_41570,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,41)
    <=> v67514(VarCurr,41) ) ).

tff(addAssignment_41569,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,41)
    <=> v67428(VarCurr,41) ) ).

tff(addAssignment_41568,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,41)
    <=> v67430(VarCurr,41) ) ).

tff(addAssignment_41567,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,41)
    <=> v67432(VarCurr,41) ) ).

tff(addAssignment_41566,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,41)
    <=> v67434(VarCurr,41) ) ).

tff(addAssignment_41565,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,41)
    <=> v67436(VarCurr,41) ) ).

tff(addAssignment_41564,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,41)
    <=> v67438(VarCurr,41) ) ).

tff(addAssignment_41563,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,41)
    <=> v67497(VarCurr,41) ) ).

tff(addAssignment_41562,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,41)
    <=> v67493(VarCurr,41) ) ).

tff(addAssignment_41561,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,41)
    <=> v67495(VarCurr,41) ) ).

tff(addAssignment_41560,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,41)
    <=> v67496(VarCurr,41) ) ).

tff(addAssignment_41559,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,83)
    <=> v33839(VarCurr,83) ) ).

tff(addAssignment_41558,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,83)
    <=> v33841(VarCurr,83) ) ).

tff(addAssignment_41557,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,83)
    <=> v18805(VarCurr,11) ) ).

tff(addAssignment_41556,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,41)
    <=> v67489(VarCurr,41) ) ).

tff(addAssignment_41555,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,41)
    <=> v6234(VarCurr,41) ) ).

tff(addAssignment_41554,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,41)
    <=> v67485(VarCurr,41) ) ).

tff(addAssignment_41553,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,41)
    <=> $false ) ).

tff(addAssignment_41552,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,41)
    <=> v67409(VarCurr,41) ) ).

tff(addAssignment_41551,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,41)
    <=> v67423(VarCurr,41) ) ).

tff(addAssignment_41550,axiom,
    ! [VarCurr: state_type] :
      ( v69122(VarCurr)
    <=> v69124(VarCurr) ) ).

tff(addAssignment_41549,axiom,
    ! [VarCurr: state_type] :
      ( v69124(VarCurr)
    <=> v69126(VarCurr) ) ).

tff(addAssignment_41548,axiom,
    ! [VarCurr: state_type] :
      ( v69126(VarCurr)
    <=> v69128(VarCurr) ) ).

tff(addAssignment_41547,axiom,
    ! [VarCurr: state_type] :
      ( v69128(VarCurr)
    <=> v69130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6378,axiom,
    ! [VarCurr: state_type] :
      ( v69130(VarCurr)
    <=> ( v69276(VarCurr)
      <~> v69228(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6377,axiom,
    ! [VarCurr: state_type] :
      ( v69276(VarCurr)
    <=> ( v69132(VarCurr)
      <~> v69180(VarCurr) ) ) ).

tff(addAssignment_41546,axiom,
    ! [VarCurr: state_type] :
      ( v69228(VarCurr)
    <=> v69230(VarCurr) ) ).

tff(addAssignment_41545,axiom,
    ! [VarCurr: state_type] :
      ( v69230(VarCurr)
    <=> v69232(VarCurr) ) ).

tff(addAssignment_41544,axiom,
    ! [VarCurr: state_type] :
      ( v69232(VarCurr)
    <=> v69234(VarCurr) ) ).

tff(addAssignment_41543,axiom,
    ! [VarCurr: state_type] :
      ( v69234(VarCurr)
    <=> v69236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6376,axiom,
    ! [VarCurr: state_type] :
      ( v69236(VarCurr)
    <=> ( v69274(VarCurr)
      <~> v69262(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6375,axiom,
    ! [VarCurr: state_type] :
      ( v69274(VarCurr)
    <=> ( v69238(VarCurr)
      <~> v69250(VarCurr) ) ) ).

tff(addAssignment_41542,axiom,
    ! [VarCurr: state_type] :
      ( v69262(VarCurr)
    <=> v69264(VarCurr) ) ).

tff(addAssignment_41541,axiom,
    ! [VarCurr: state_type] :
      ( v69264(VarCurr)
    <=> v67349(VarCurr,33) ) ).

tff(addAssignment_41540,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,33)
    <=> v67351(VarCurr,33) ) ).

tff(addAssignment_41539,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,33)
    <=> v67353(VarCurr,33) ) ).

tff(addAssignment_41538,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,33)
    <=> v67355(VarCurr,33) ) ).

tff(addAssignment_41537,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,33)
    <=> v67357(VarCurr,33) ) ).

tff(addAssignment_41536,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,33)
    <=> v67359(VarCurr,33) ) ).

tff(addAssignment_41535,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,33)
    <=> v67580(VarCurr,33) ) ).

tff(addAssignment_41534,axiom,
    ! [VarCurr: state_type] :
      ( v67604(VarCurr,1)
    <=> v67363(VarCurr,33) ) ).

tff(addAssignment_41533,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,33)
    <=> v67365(VarCurr,33) ) ).

tff(addAssignment_41532,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,33)
    <=> v69266(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69267(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69266(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_810,axiom,
    ! [VarNext: state_type] :
      ( v69267(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69266(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69267(VarNext)
      <=> v69268(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69268(VarNext)
      <=> ( v69270(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69270(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41531,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,33)
    <=> v67389(VarCurr,33) ) ).

tff(addAssignment_41530,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,33)
    <=> v67391(VarCurr,33) ) ).

tff(addAssignment_41529,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,33)
    <=> v67922(VarCurr,1) ) ).

tff(addAssignment_41528,axiom,
    ! [VarCurr: state_type] :
      ( v67922(VarCurr,1)
    <=> v67924(VarCurr,1) ) ).

tff(addAssignment_41527,axiom,
    ! [VarCurr: state_type] :
      ( v67924(VarCurr,1)
    <=> v67941(VarCurr,1) ) ).

tff(addAssignment_41526,axiom,
    ! [VarCurr: state_type] :
      ( v67934(VarCurr,1)
    <=> v67936(VarCurr,1) ) ).

tff(addAssignment_41525,axiom,
    ! [VarCurr: state_type] :
      ( v67936(VarCurr,1)
    <=> v67401(VarCurr,33) ) ).

tff(addAssignment_41524,axiom,
    ! [VarCurr: state_type] :
      ( v67926(VarCurr,1)
    <=> v67928(VarCurr,1) ) ).

tff(addAssignment_41523,axiom,
    ! [VarCurr: state_type] :
      ( v67928(VarCurr,1)
    <=> v67401(VarCurr,37) ) ).

tff(addAssignment_41522,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,37)
    <=> v67403(VarCurr,37) ) ).

tff(addAssignment_41521,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,37)
    <=> v67405(VarCurr,37) ) ).

tff(addAssignment_41520,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,37)
    <=> v67514(VarCurr,37) ) ).

tff(addAssignment_41519,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,37)
    <=> v67428(VarCurr,37) ) ).

tff(addAssignment_41518,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,37)
    <=> v67430(VarCurr,37) ) ).

tff(addAssignment_41517,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,37)
    <=> v67432(VarCurr,37) ) ).

tff(addAssignment_41516,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,37)
    <=> v67434(VarCurr,37) ) ).

tff(addAssignment_41515,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,37)
    <=> v67436(VarCurr,37) ) ).

tff(addAssignment_41514,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,37)
    <=> v67438(VarCurr,37) ) ).

tff(addAssignment_41513,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,37)
    <=> v67497(VarCurr,37) ) ).

tff(addAssignment_41512,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,37)
    <=> v67493(VarCurr,37) ) ).

tff(addAssignment_41511,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,37)
    <=> v67495(VarCurr,37) ) ).

tff(addAssignment_41510,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,37)
    <=> v67496(VarCurr,37) ) ).

tff(addAssignment_41509,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,79)
    <=> v33839(VarCurr,79) ) ).

tff(addAssignment_41508,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,79)
    <=> v33841(VarCurr,79) ) ).

tff(addAssignment_41507,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,79)
    <=> v18805(VarCurr,7) ) ).

tff(addAssignment_41506,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,37)
    <=> v67489(VarCurr,37) ) ).

tff(addAssignment_41505,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,37)
    <=> v6234(VarCurr,37) ) ).

tff(addAssignment_41504,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,37)
    <=> v67485(VarCurr,37) ) ).

tff(addAssignment_41503,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,37)
    <=> $false ) ).

tff(addAssignment_41502,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,37)
    <=> v67409(VarCurr,37) ) ).

tff(addAssignment_41501,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,37)
    <=> v67423(VarCurr,37) ) ).

tff(addAssignment_41500,axiom,
    ! [VarCurr: state_type] :
      ( v69250(VarCurr)
    <=> v69252(VarCurr) ) ).

tff(addAssignment_41499,axiom,
    ! [VarCurr: state_type] :
      ( v69252(VarCurr)
    <=> v67349(VarCurr,29) ) ).

tff(addAssignment_41498,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,29)
    <=> v67351(VarCurr,29) ) ).

tff(addAssignment_41497,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,29)
    <=> v67353(VarCurr,29) ) ).

tff(addAssignment_41496,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,29)
    <=> v67355(VarCurr,29) ) ).

tff(addAssignment_41495,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,29)
    <=> v67357(VarCurr,29) ) ).

tff(addAssignment_41494,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,29)
    <=> v67359(VarCurr,29) ) ).

tff(addAssignment_41493,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,29)
    <=> v67580(VarCurr,29) ) ).

tff(addAssignment_41492,axiom,
    ! [VarCurr: state_type] :
      ( v67605(VarCurr,1)
    <=> v67363(VarCurr,29) ) ).

tff(addAssignment_41491,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,29)
    <=> v67365(VarCurr,29) ) ).

tff(addAssignment_41490,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,29)
    <=> v69254(VarNext,29) ) ).

tff(addCaseBooleanConditionEqualRanges1_809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69254(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_809,axiom,
    ! [VarNext: state_type] :
      ( v69255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69254(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69255(VarNext)
      <=> v69256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69256(VarNext)
      <=> ( v69258(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69258(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41489,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,29)
    <=> v67389(VarCurr,29) ) ).

tff(addAssignment_41488,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,29)
    <=> v67391(VarCurr,29) ) ).

tff(addAssignment_41487,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,29)
    <=> v67882(VarCurr,1) ) ).

tff(addAssignment_41486,axiom,
    ! [VarCurr: state_type] :
      ( v67882(VarCurr,1)
    <=> v67884(VarCurr,1) ) ).

tff(addAssignment_41485,axiom,
    ! [VarCurr: state_type] :
      ( v67884(VarCurr,1)
    <=> v67901(VarCurr,1) ) ).

tff(addAssignment_41484,axiom,
    ! [VarCurr: state_type] :
      ( v67894(VarCurr,1)
    <=> v67896(VarCurr,1) ) ).

tff(addAssignment_41483,axiom,
    ! [VarCurr: state_type] :
      ( v67896(VarCurr,1)
    <=> v67401(VarCurr,29) ) ).

tff(addAssignment_41482,axiom,
    ! [VarCurr: state_type] :
      ( v67886(VarCurr,1)
    <=> v67888(VarCurr,1) ) ).

tff(addAssignment_41481,axiom,
    ! [VarCurr: state_type] :
      ( v67888(VarCurr,1)
    <=> v67401(VarCurr,33) ) ).

tff(addAssignment_41480,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,33)
    <=> v67403(VarCurr,33) ) ).

tff(addAssignment_41479,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,33)
    <=> v67405(VarCurr,33) ) ).

tff(addAssignment_41478,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,33)
    <=> v67514(VarCurr,33) ) ).

tff(addAssignment_41477,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,33)
    <=> v67428(VarCurr,33) ) ).

tff(addAssignment_41476,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,33)
    <=> v67430(VarCurr,33) ) ).

tff(addAssignment_41475,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,33)
    <=> v67432(VarCurr,33) ) ).

tff(addAssignment_41474,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,33)
    <=> v67434(VarCurr,33) ) ).

tff(addAssignment_41473,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,33)
    <=> v67436(VarCurr,33) ) ).

tff(addAssignment_41472,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,33)
    <=> v67438(VarCurr,33) ) ).

tff(addAssignment_41471,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,33)
    <=> v67497(VarCurr,33) ) ).

tff(addAssignment_41470,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,33)
    <=> v67493(VarCurr,33) ) ).

tff(addAssignment_41469,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,33)
    <=> v67495(VarCurr,33) ) ).

tff(addAssignment_41468,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,33)
    <=> v67496(VarCurr,33) ) ).

tff(addAssignment_41467,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,69)
    <=> v33839(VarCurr,69) ) ).

tff(addAssignment_41466,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,69)
    <=> v33841(VarCurr,69) ) ).

tff(addAssignment_41465,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,69)
    <=> v17255(VarCurr,9) ) ).

tff(addAssignment_41464,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,33)
    <=> v67489(VarCurr,33) ) ).

tff(addAssignment_41463,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,33)
    <=> v6234(VarCurr,33) ) ).

tff(addAssignment_41462,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,33)
    <=> v67485(VarCurr,33) ) ).

tff(addAssignment_41461,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,33)
    <=> $false ) ).

tff(addAssignment_41460,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,33)
    <=> v67409(VarCurr,33) ) ).

tff(addAssignment_41459,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,33)
    <=> v67423(VarCurr,33) ) ).

tff(addAssignment_41458,axiom,
    ! [VarCurr: state_type] :
      ( v69238(VarCurr)
    <=> v69240(VarCurr) ) ).

tff(addAssignment_41457,axiom,
    ! [VarCurr: state_type] :
      ( v69240(VarCurr)
    <=> v67349(VarCurr,25) ) ).

tff(addAssignment_41456,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,25)
    <=> v67351(VarCurr,25) ) ).

tff(addAssignment_41455,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,25)
    <=> v67353(VarCurr,25) ) ).

tff(addAssignment_41454,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,25)
    <=> v67355(VarCurr,25) ) ).

tff(addAssignment_41453,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,25)
    <=> v67357(VarCurr,25) ) ).

tff(addAssignment_41452,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,25)
    <=> v67359(VarCurr,25) ) ).

tff(addAssignment_41451,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,25)
    <=> v67580(VarCurr,25) ) ).

tff(addAssignment_41450,axiom,
    ! [VarCurr: state_type] :
      ( v67606(VarCurr,1)
    <=> v67363(VarCurr,25) ) ).

tff(addAssignment_41449,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,25)
    <=> v67365(VarCurr,25) ) ).

tff(addAssignment_41448,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,25)
    <=> v69242(VarNext,25) ) ).

tff(addCaseBooleanConditionEqualRanges1_808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69243(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69242(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_808,axiom,
    ! [VarNext: state_type] :
      ( v69243(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69242(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69243(VarNext)
      <=> v69244(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69244(VarNext)
      <=> ( v69246(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69246(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41447,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,25)
    <=> v67389(VarCurr,25) ) ).

tff(addAssignment_41446,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,25)
    <=> v67391(VarCurr,25) ) ).

tff(addAssignment_41445,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,25)
    <=> v67842(VarCurr,1) ) ).

tff(addAssignment_41444,axiom,
    ! [VarCurr: state_type] :
      ( v67842(VarCurr,1)
    <=> v67844(VarCurr,1) ) ).

tff(addAssignment_41443,axiom,
    ! [VarCurr: state_type] :
      ( v67844(VarCurr,1)
    <=> v67861(VarCurr,1) ) ).

tff(addAssignment_41442,axiom,
    ! [VarCurr: state_type] :
      ( v67854(VarCurr,1)
    <=> v67856(VarCurr,1) ) ).

tff(addAssignment_41441,axiom,
    ! [VarCurr: state_type] :
      ( v67856(VarCurr,1)
    <=> v67401(VarCurr,25) ) ).

tff(addAssignment_41440,axiom,
    ! [VarCurr: state_type] :
      ( v67846(VarCurr,1)
    <=> v67848(VarCurr,1) ) ).

tff(addAssignment_41439,axiom,
    ! [VarCurr: state_type] :
      ( v67848(VarCurr,1)
    <=> v67401(VarCurr,29) ) ).

tff(addAssignment_41438,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,29)
    <=> v67403(VarCurr,29) ) ).

tff(addAssignment_41437,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,29)
    <=> v67405(VarCurr,29) ) ).

tff(addAssignment_41436,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,29)
    <=> v67514(VarCurr,29) ) ).

tff(addAssignment_41435,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,29)
    <=> v67428(VarCurr,29) ) ).

tff(addAssignment_41434,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,29)
    <=> v67430(VarCurr,29) ) ).

tff(addAssignment_41433,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,29)
    <=> v67432(VarCurr,29) ) ).

tff(addAssignment_41432,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,29)
    <=> v67434(VarCurr,29) ) ).

tff(addAssignment_41431,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,29)
    <=> v67436(VarCurr,29) ) ).

tff(addAssignment_41430,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,29)
    <=> v67438(VarCurr,29) ) ).

tff(addAssignment_41429,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,29)
    <=> v67497(VarCurr,29) ) ).

tff(addAssignment_41428,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,29)
    <=> v67493(VarCurr,29) ) ).

tff(addAssignment_41427,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,29)
    <=> v67495(VarCurr,29) ) ).

tff(addAssignment_41426,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,29)
    <=> v67496(VarCurr,29) ) ).

tff(addAssignment_41425,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,59)
    <=> v33839(VarCurr,59) ) ).

tff(addAssignment_41424,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,59)
    <=> v33841(VarCurr,59) ) ).

tff(addAssignment_41423,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,59)
    <=> v15705(VarCurr,11) ) ).

tff(addAssignment_41422,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,29)
    <=> v67489(VarCurr,29) ) ).

tff(addAssignment_41421,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,29)
    <=> v6234(VarCurr,29) ) ).

tff(addAssignment_41420,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,29)
    <=> v67485(VarCurr,29) ) ).

tff(addAssignment_41419,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,29)
    <=> $false ) ).

tff(addAssignment_41418,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,29)
    <=> v67409(VarCurr,29) ) ).

tff(addAssignment_41417,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,29)
    <=> v67423(VarCurr,29) ) ).

tff(addAssignment_41416,axiom,
    ! [VarCurr: state_type] :
      ( v69180(VarCurr)
    <=> v69182(VarCurr) ) ).

tff(addAssignment_41415,axiom,
    ! [VarCurr: state_type] :
      ( v69182(VarCurr)
    <=> v69184(VarCurr) ) ).

tff(addAssignment_41414,axiom,
    ! [VarCurr: state_type] :
      ( v69184(VarCurr)
    <=> v69186(VarCurr) ) ).

tff(addAssignment_41413,axiom,
    ! [VarCurr: state_type] :
      ( v69186(VarCurr)
    <=> v69188(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6368,axiom,
    ! [VarCurr: state_type] :
      ( v69188(VarCurr)
    <=> ( v69226(VarCurr)
      <~> v69214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6367,axiom,
    ! [VarCurr: state_type] :
      ( v69226(VarCurr)
    <=> ( v69190(VarCurr)
      <~> v69202(VarCurr) ) ) ).

tff(addAssignment_41412,axiom,
    ! [VarCurr: state_type] :
      ( v69214(VarCurr)
    <=> v69216(VarCurr) ) ).

tff(addAssignment_41411,axiom,
    ! [VarCurr: state_type] :
      ( v69216(VarCurr)
    <=> v67349(VarCurr,21) ) ).

tff(addAssignment_41410,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,21)
    <=> v67351(VarCurr,21) ) ).

tff(addAssignment_41409,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,21)
    <=> v67353(VarCurr,21) ) ).

tff(addAssignment_41408,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,21)
    <=> v67355(VarCurr,21) ) ).

tff(addAssignment_41407,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,21)
    <=> v67357(VarCurr,21) ) ).

tff(addAssignment_41406,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,21)
    <=> v67359(VarCurr,21) ) ).

tff(addAssignment_41405,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,21)
    <=> v67580(VarCurr,21) ) ).

tff(addAssignment_41404,axiom,
    ! [VarCurr: state_type] :
      ( v67607(VarCurr,1)
    <=> v67363(VarCurr,21) ) ).

tff(addAssignment_41403,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,21)
    <=> v67365(VarCurr,21) ) ).

tff(addAssignment_41402,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,21)
    <=> v69218(VarNext,21) ) ).

tff(addCaseBooleanConditionEqualRanges1_807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69219(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69218(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_807,axiom,
    ! [VarNext: state_type] :
      ( v69219(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69218(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69219(VarNext)
      <=> v69220(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69220(VarNext)
      <=> ( v69222(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69222(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41401,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,21)
    <=> v67389(VarCurr,21) ) ).

tff(addAssignment_41400,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,21)
    <=> v67391(VarCurr,21) ) ).

tff(addAssignment_41399,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,21)
    <=> v67790(VarCurr,1) ) ).

tff(addAssignment_41398,axiom,
    ! [VarCurr: state_type] :
      ( v67790(VarCurr,1)
    <=> v67792(VarCurr,1) ) ).

tff(addAssignment_41397,axiom,
    ! [VarCurr: state_type] :
      ( v67792(VarCurr,1)
    <=> v67809(VarCurr,1) ) ).

tff(addAssignment_41396,axiom,
    ! [VarCurr: state_type] :
      ( v67802(VarCurr,1)
    <=> v67804(VarCurr,1) ) ).

tff(addAssignment_41395,axiom,
    ! [VarCurr: state_type] :
      ( v67804(VarCurr,1)
    <=> v67401(VarCurr,21) ) ).

tff(addAssignment_41394,axiom,
    ! [VarCurr: state_type] :
      ( v67794(VarCurr,1)
    <=> v67796(VarCurr,1) ) ).

tff(addAssignment_41393,axiom,
    ! [VarCurr: state_type] :
      ( v67796(VarCurr,1)
    <=> v67401(VarCurr,25) ) ).

tff(addAssignment_41392,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,25)
    <=> v67403(VarCurr,25) ) ).

tff(addAssignment_41391,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,25)
    <=> v67405(VarCurr,25) ) ).

tff(addAssignment_41390,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,25)
    <=> v67514(VarCurr,25) ) ).

tff(addAssignment_41389,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,25)
    <=> v67428(VarCurr,25) ) ).

tff(addAssignment_41388,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,25)
    <=> v67430(VarCurr,25) ) ).

tff(addAssignment_41387,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,25)
    <=> v67432(VarCurr,25) ) ).

tff(addAssignment_41386,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,25)
    <=> v67434(VarCurr,25) ) ).

tff(addAssignment_41385,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,25)
    <=> v67436(VarCurr,25) ) ).

tff(addAssignment_41384,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,25)
    <=> v67438(VarCurr,25) ) ).

tff(addAssignment_41383,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,25)
    <=> v67497(VarCurr,25) ) ).

tff(addAssignment_41382,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,25)
    <=> v67493(VarCurr,25) ) ).

tff(addAssignment_41381,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,25)
    <=> v67495(VarCurr,25) ) ).

tff(addAssignment_41380,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,25)
    <=> v67496(VarCurr,25) ) ).

tff(addAssignment_41379,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,55)
    <=> v33839(VarCurr,55) ) ).

tff(addAssignment_41378,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,55)
    <=> v33841(VarCurr,55) ) ).

tff(addAssignment_41377,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,55)
    <=> v15705(VarCurr,7) ) ).

tff(addAssignment_41376,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,25)
    <=> v67489(VarCurr,25) ) ).

tff(addAssignment_41375,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,25)
    <=> v6234(VarCurr,25) ) ).

tff(addAssignment_41374,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,25)
    <=> v67485(VarCurr,25) ) ).

tff(addAssignment_41373,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,25)
    <=> $false ) ).

tff(addAssignment_41372,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,25)
    <=> v67409(VarCurr,25) ) ).

tff(addAssignment_41371,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,25)
    <=> v67423(VarCurr,25) ) ).

tff(addAssignment_41370,axiom,
    ! [VarCurr: state_type] :
      ( v69202(VarCurr)
    <=> v69204(VarCurr) ) ).

tff(addAssignment_41369,axiom,
    ! [VarCurr: state_type] :
      ( v69204(VarCurr)
    <=> v67349(VarCurr,17) ) ).

tff(addAssignment_41368,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,17)
    <=> v67351(VarCurr,17) ) ).

tff(addAssignment_41367,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,17)
    <=> v67353(VarCurr,17) ) ).

tff(addAssignment_41366,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,17)
    <=> v67355(VarCurr,17) ) ).

tff(addAssignment_41365,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,17)
    <=> v67357(VarCurr,17) ) ).

tff(addAssignment_41364,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,17)
    <=> v67359(VarCurr,17) ) ).

tff(addAssignment_41363,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,17)
    <=> v67580(VarCurr,17) ) ).

tff(addAssignment_41362,axiom,
    ! [VarCurr: state_type] :
      ( v67608(VarCurr,1)
    <=> v67363(VarCurr,17) ) ).

tff(addAssignment_41361,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,17)
    <=> v67365(VarCurr,17) ) ).

tff(addAssignment_41360,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,17)
    <=> v69206(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69207(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69206(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_806,axiom,
    ! [VarNext: state_type] :
      ( v69207(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69206(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69207(VarNext)
      <=> v69208(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69208(VarNext)
      <=> ( v69210(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69210(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41359,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,17)
    <=> v67389(VarCurr,17) ) ).

tff(addAssignment_41358,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,17)
    <=> v67391(VarCurr,17) ) ).

tff(addAssignment_41357,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,17)
    <=> v67750(VarCurr,1) ) ).

tff(addAssignment_41356,axiom,
    ! [VarCurr: state_type] :
      ( v67750(VarCurr,1)
    <=> v67752(VarCurr,1) ) ).

tff(addAssignment_41355,axiom,
    ! [VarCurr: state_type] :
      ( v67752(VarCurr,1)
    <=> v67769(VarCurr,1) ) ).

tff(addAssignment_41354,axiom,
    ! [VarCurr: state_type] :
      ( v67762(VarCurr,1)
    <=> v67764(VarCurr,1) ) ).

tff(addAssignment_41353,axiom,
    ! [VarCurr: state_type] :
      ( v67764(VarCurr,1)
    <=> v67401(VarCurr,17) ) ).

tff(addAssignment_41352,axiom,
    ! [VarCurr: state_type] :
      ( v67754(VarCurr,1)
    <=> v67756(VarCurr,1) ) ).

tff(addAssignment_41351,axiom,
    ! [VarCurr: state_type] :
      ( v67756(VarCurr,1)
    <=> v67401(VarCurr,21) ) ).

tff(addAssignment_41350,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,21)
    <=> v67403(VarCurr,21) ) ).

tff(addAssignment_41349,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,21)
    <=> v67405(VarCurr,21) ) ).

tff(addAssignment_41348,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,21)
    <=> v67514(VarCurr,21) ) ).

tff(addAssignment_41347,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,21)
    <=> v67428(VarCurr,21) ) ).

tff(addAssignment_41346,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,21)
    <=> v67430(VarCurr,21) ) ).

tff(addAssignment_41345,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,21)
    <=> v67432(VarCurr,21) ) ).

tff(addAssignment_41344,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,21)
    <=> v67434(VarCurr,21) ) ).

tff(addAssignment_41343,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,21)
    <=> v67436(VarCurr,21) ) ).

tff(addAssignment_41342,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,21)
    <=> v67438(VarCurr,21) ) ).

tff(addAssignment_41341,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,21)
    <=> v67497(VarCurr,21) ) ).

tff(addAssignment_41340,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,21)
    <=> v67493(VarCurr,21) ) ).

tff(addAssignment_41339,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,21)
    <=> v67495(VarCurr,21) ) ).

tff(addAssignment_41338,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,21)
    <=> v67496(VarCurr,21) ) ).

tff(addAssignment_41337,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,45)
    <=> v33839(VarCurr,45) ) ).

tff(addAssignment_41336,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,45)
    <=> v33841(VarCurr,45) ) ).

tff(addAssignment_41335,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,45)
    <=> v14155(VarCurr,9) ) ).

tff(addAssignment_41334,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,21)
    <=> v67489(VarCurr,21) ) ).

tff(addAssignment_41333,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,21)
    <=> v6234(VarCurr,21) ) ).

tff(addAssignment_41332,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,21)
    <=> v67485(VarCurr,21) ) ).

tff(addAssignment_41331,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,21)
    <=> $false ) ).

tff(addAssignment_41330,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,21)
    <=> v67409(VarCurr,21) ) ).

tff(addAssignment_41329,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,21)
    <=> v67423(VarCurr,21) ) ).

tff(addAssignment_41328,axiom,
    ! [VarCurr: state_type] :
      ( v69190(VarCurr)
    <=> v69192(VarCurr) ) ).

tff(addAssignment_41327,axiom,
    ! [VarCurr: state_type] :
      ( v69192(VarCurr)
    <=> v67349(VarCurr,13) ) ).

tff(addAssignment_41326,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,13)
    <=> v67351(VarCurr,13) ) ).

tff(addAssignment_41325,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,13)
    <=> v67353(VarCurr,13) ) ).

tff(addAssignment_41324,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,13)
    <=> v67355(VarCurr,13) ) ).

tff(addAssignment_41323,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,13)
    <=> v67357(VarCurr,13) ) ).

tff(addAssignment_41322,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,13)
    <=> v67359(VarCurr,13) ) ).

tff(addAssignment_41321,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,13)
    <=> v67580(VarCurr,13) ) ).

tff(addAssignment_41320,axiom,
    ! [VarCurr: state_type] :
      ( v67609(VarCurr,1)
    <=> v67363(VarCurr,13) ) ).

tff(addAssignment_41319,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,13)
    <=> v67365(VarCurr,13) ) ).

tff(addAssignment_41318,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,13)
    <=> v69194(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69195(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69194(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_805,axiom,
    ! [VarNext: state_type] :
      ( v69195(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69194(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69195(VarNext)
      <=> v69196(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69196(VarNext)
      <=> ( v69198(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69198(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41317,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,13)
    <=> v67389(VarCurr,13) ) ).

tff(addAssignment_41316,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,13)
    <=> v67391(VarCurr,13) ) ).

tff(addAssignment_41315,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,13)
    <=> v67710(VarCurr,1) ) ).

tff(addAssignment_41314,axiom,
    ! [VarCurr: state_type] :
      ( v67710(VarCurr,1)
    <=> v67712(VarCurr,1) ) ).

tff(addAssignment_41313,axiom,
    ! [VarCurr: state_type] :
      ( v67712(VarCurr,1)
    <=> v67729(VarCurr,1) ) ).

tff(addAssignment_41312,axiom,
    ! [VarCurr: state_type] :
      ( v67722(VarCurr,1)
    <=> v67724(VarCurr,1) ) ).

tff(addAssignment_41311,axiom,
    ! [VarCurr: state_type] :
      ( v67724(VarCurr,1)
    <=> v67401(VarCurr,13) ) ).

tff(addAssignment_41310,axiom,
    ! [VarCurr: state_type] :
      ( v67714(VarCurr,1)
    <=> v67716(VarCurr,1) ) ).

tff(addAssignment_41309,axiom,
    ! [VarCurr: state_type] :
      ( v67716(VarCurr,1)
    <=> v67401(VarCurr,17) ) ).

tff(addAssignment_41308,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,17)
    <=> v67403(VarCurr,17) ) ).

tff(addAssignment_41307,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,17)
    <=> v67405(VarCurr,17) ) ).

tff(addAssignment_41306,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,17)
    <=> v67514(VarCurr,17) ) ).

tff(addAssignment_41305,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,17)
    <=> v67428(VarCurr,17) ) ).

tff(addAssignment_41304,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,17)
    <=> v67430(VarCurr,17) ) ).

tff(addAssignment_41303,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,17)
    <=> v67432(VarCurr,17) ) ).

tff(addAssignment_41302,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,17)
    <=> v67434(VarCurr,17) ) ).

tff(addAssignment_41301,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,17)
    <=> v67436(VarCurr,17) ) ).

tff(addAssignment_41300,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,17)
    <=> v67438(VarCurr,17) ) ).

tff(addAssignment_41299,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,17)
    <=> v67497(VarCurr,17) ) ).

tff(addAssignment_41298,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,17)
    <=> v67493(VarCurr,17) ) ).

tff(addAssignment_41297,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,17)
    <=> v67495(VarCurr,17) ) ).

tff(addAssignment_41296,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,17)
    <=> v67496(VarCurr,17) ) ).

tff(addAssignment_41295,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,35)
    <=> v33839(VarCurr,35) ) ).

tff(addAssignment_41294,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,17)
    <=> v67489(VarCurr,17) ) ).

tff(addAssignment_41293,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,17)
    <=> v6234(VarCurr,17) ) ).

tff(addAssignment_41292,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,17)
    <=> v67485(VarCurr,17) ) ).

tff(addAssignment_41291,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,17)
    <=> $false ) ).

tff(addAssignment_41290,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,17)
    <=> v67409(VarCurr,17) ) ).

tff(addAssignment_41289,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,17)
    <=> v67423(VarCurr,17) ) ).

tff(addAssignment_41288,axiom,
    ! [VarCurr: state_type] :
      ( v69132(VarCurr)
    <=> v69134(VarCurr) ) ).

tff(addAssignment_41287,axiom,
    ! [VarCurr: state_type] :
      ( v69134(VarCurr)
    <=> v69136(VarCurr) ) ).

tff(addAssignment_41286,axiom,
    ! [VarCurr: state_type] :
      ( v69136(VarCurr)
    <=> v69138(VarCurr) ) ).

tff(addAssignment_41285,axiom,
    ! [VarCurr: state_type] :
      ( v69138(VarCurr)
    <=> v69140(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6360,axiom,
    ! [VarCurr: state_type] :
      ( v69140(VarCurr)
    <=> ( v69178(VarCurr)
      <~> v69166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6359,axiom,
    ! [VarCurr: state_type] :
      ( v69178(VarCurr)
    <=> ( v69142(VarCurr)
      <~> v69154(VarCurr) ) ) ).

tff(addAssignment_41284,axiom,
    ! [VarCurr: state_type] :
      ( v69166(VarCurr)
    <=> v69168(VarCurr) ) ).

tff(addAssignment_41283,axiom,
    ! [VarCurr: state_type] :
      ( v69168(VarCurr)
    <=> v67349(VarCurr,9) ) ).

tff(addAssignment_41282,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,9)
    <=> v67351(VarCurr,9) ) ).

tff(addAssignment_41281,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,9)
    <=> v67353(VarCurr,9) ) ).

tff(addAssignment_41280,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,9)
    <=> v67355(VarCurr,9) ) ).

tff(addAssignment_41279,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,9)
    <=> v67357(VarCurr,9) ) ).

tff(addAssignment_41278,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,9)
    <=> v67359(VarCurr,9) ) ).

tff(addAssignment_41277,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,9)
    <=> v67580(VarCurr,9) ) ).

tff(addAssignment_41276,axiom,
    ! [VarCurr: state_type] :
      ( v67610(VarCurr,1)
    <=> v67363(VarCurr,9) ) ).

tff(addAssignment_41275,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,9)
    <=> v67365(VarCurr,9) ) ).

tff(addAssignment_41274,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,9)
    <=> v69170(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69171(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69170(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_804,axiom,
    ! [VarNext: state_type] :
      ( v69171(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69170(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69171(VarNext)
      <=> v69172(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69172(VarNext)
      <=> ( v69174(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69174(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41273,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,9)
    <=> v67389(VarCurr,9) ) ).

tff(addAssignment_41272,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,9)
    <=> v67391(VarCurr,9) ) ).

tff(addAssignment_41271,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,9)
    <=> v67658(VarCurr,1) ) ).

tff(addAssignment_41270,axiom,
    ! [VarCurr: state_type] :
      ( v67658(VarCurr,1)
    <=> v67660(VarCurr,1) ) ).

tff(addAssignment_41269,axiom,
    ! [VarCurr: state_type] :
      ( v67660(VarCurr,1)
    <=> v67677(VarCurr,1) ) ).

tff(addAssignment_41268,axiom,
    ! [VarCurr: state_type] :
      ( v67670(VarCurr,1)
    <=> v67672(VarCurr,1) ) ).

tff(addAssignment_41267,axiom,
    ! [VarCurr: state_type] :
      ( v67672(VarCurr,1)
    <=> v67401(VarCurr,9) ) ).

tff(addAssignment_41266,axiom,
    ! [VarCurr: state_type] :
      ( v67662(VarCurr,1)
    <=> v67664(VarCurr,1) ) ).

tff(addAssignment_41265,axiom,
    ! [VarCurr: state_type] :
      ( v67664(VarCurr,1)
    <=> v67401(VarCurr,13) ) ).

tff(addAssignment_41264,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,13)
    <=> v67403(VarCurr,13) ) ).

tff(addAssignment_41263,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,13)
    <=> v67405(VarCurr,13) ) ).

tff(addAssignment_41262,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,13)
    <=> v67514(VarCurr,13) ) ).

tff(addAssignment_41261,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,13)
    <=> v67428(VarCurr,13) ) ).

tff(addAssignment_41260,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,13)
    <=> v67430(VarCurr,13) ) ).

tff(addAssignment_41259,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,13)
    <=> v67432(VarCurr,13) ) ).

tff(addAssignment_41258,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,13)
    <=> v67434(VarCurr,13) ) ).

tff(addAssignment_41257,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,13)
    <=> v67436(VarCurr,13) ) ).

tff(addAssignment_41256,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,13)
    <=> v67438(VarCurr,13) ) ).

tff(addAssignment_41255,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,13)
    <=> v67497(VarCurr,13) ) ).

tff(addAssignment_41254,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,13)
    <=> v67493(VarCurr,13) ) ).

tff(addAssignment_41253,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,13)
    <=> v67495(VarCurr,13) ) ).

tff(addAssignment_41252,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,13)
    <=> v67496(VarCurr,13) ) ).

tff(addAssignment_41251,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,31)
    <=> v33839(VarCurr,31) ) ).

tff(addAssignment_41250,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,13)
    <=> v67489(VarCurr,13) ) ).

tff(addAssignment_41249,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,13)
    <=> v6234(VarCurr,13) ) ).

tff(addAssignment_41248,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,13)
    <=> v67485(VarCurr,13) ) ).

tff(addAssignment_41247,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_41246,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,13)
    <=> v67409(VarCurr,13) ) ).

tff(addAssignment_41245,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,13)
    <=> v67423(VarCurr,13) ) ).

tff(addAssignment_41244,axiom,
    ! [VarCurr: state_type] :
      ( v69154(VarCurr)
    <=> v69156(VarCurr) ) ).

tff(addAssignment_41243,axiom,
    ! [VarCurr: state_type] :
      ( v69156(VarCurr)
    <=> v67349(VarCurr,5) ) ).

tff(addAssignment_41242,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,5)
    <=> v67351(VarCurr,5) ) ).

tff(addAssignment_41241,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,5)
    <=> v67353(VarCurr,5) ) ).

tff(addAssignment_41240,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,5)
    <=> v67355(VarCurr,5) ) ).

tff(addAssignment_41239,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,5)
    <=> v67357(VarCurr,5) ) ).

tff(addAssignment_41238,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,5)
    <=> v67359(VarCurr,5) ) ).

tff(addAssignment_41237,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,5)
    <=> v67580(VarCurr,5) ) ).

tff(addAssignment_41236,axiom,
    ! [VarCurr: state_type] :
      ( v67611(VarCurr,1)
    <=> v67363(VarCurr,5) ) ).

tff(addAssignment_41235,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,5)
    <=> v67365(VarCurr,5) ) ).

tff(addAssignment_41234,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,5)
    <=> v69158(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69159(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69158(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_803,axiom,
    ! [VarNext: state_type] :
      ( v69159(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69158(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69159(VarNext)
      <=> v69160(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69160(VarNext)
      <=> ( v69162(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69162(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41233,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,5)
    <=> v67389(VarCurr,5) ) ).

tff(addAssignment_41232,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,5)
    <=> v67391(VarCurr,5) ) ).

tff(addAssignment_41231,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,5)
    <=> v67618(VarCurr,1) ) ).

tff(addAssignment_41230,axiom,
    ! [VarCurr: state_type] :
      ( v67618(VarCurr,1)
    <=> v67620(VarCurr,1) ) ).

tff(addAssignment_41229,axiom,
    ! [VarCurr: state_type] :
      ( v67620(VarCurr,1)
    <=> v67637(VarCurr,1) ) ).

tff(addAssignment_41228,axiom,
    ! [VarCurr: state_type] :
      ( v67630(VarCurr,1)
    <=> v67632(VarCurr,1) ) ).

tff(addAssignment_41227,axiom,
    ! [VarCurr: state_type] :
      ( v67632(VarCurr,1)
    <=> v67401(VarCurr,5) ) ).

tff(addAssignment_41226,axiom,
    ! [VarCurr: state_type] :
      ( v67622(VarCurr,1)
    <=> v67624(VarCurr,1) ) ).

tff(addAssignment_41225,axiom,
    ! [VarCurr: state_type] :
      ( v67624(VarCurr,1)
    <=> v67401(VarCurr,9) ) ).

tff(addAssignment_41224,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,9)
    <=> v67403(VarCurr,9) ) ).

tff(addAssignment_41223,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,9)
    <=> v67405(VarCurr,9) ) ).

tff(addAssignment_41222,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,9)
    <=> v67514(VarCurr,9) ) ).

tff(addAssignment_41221,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,9)
    <=> v67428(VarCurr,9) ) ).

tff(addAssignment_41220,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,9)
    <=> v67430(VarCurr,9) ) ).

tff(addAssignment_41219,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,9)
    <=> v67432(VarCurr,9) ) ).

tff(addAssignment_41218,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,9)
    <=> v67434(VarCurr,9) ) ).

tff(addAssignment_41217,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,9)
    <=> v67436(VarCurr,9) ) ).

tff(addAssignment_41216,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,9)
    <=> v67438(VarCurr,9) ) ).

tff(addAssignment_41215,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,9)
    <=> v67497(VarCurr,9) ) ).

tff(addAssignment_41214,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,9)
    <=> v67493(VarCurr,9) ) ).

tff(addAssignment_41213,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,9)
    <=> v67495(VarCurr,9) ) ).

tff(addAssignment_41212,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,9)
    <=> v67496(VarCurr,9) ) ).

tff(addAssignment_41211,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,21)
    <=> v33839(VarCurr,21) ) ).

tff(addAssignment_41210,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,9)
    <=> v67489(VarCurr,9) ) ).

tff(addAssignment_41209,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,9)
    <=> v6234(VarCurr,9) ) ).

tff(addAssignment_41208,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,9)
    <=> v67485(VarCurr,9) ) ).

tff(addAssignment_41207,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_41206,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,9)
    <=> v67409(VarCurr,9) ) ).

tff(addAssignment_41205,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,9)
    <=> v67423(VarCurr,9) ) ).

tff(addAssignment_41204,axiom,
    ! [VarCurr: state_type] :
      ( v69142(VarCurr)
    <=> v69144(VarCurr) ) ).

tff(addAssignment_41203,axiom,
    ! [VarCurr: state_type] :
      ( v69144(VarCurr)
    <=> v67349(VarCurr,1) ) ).

tff(addAssignment_41202,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,1)
    <=> v67351(VarCurr,1) ) ).

tff(addAssignment_41201,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,1)
    <=> v67353(VarCurr,1) ) ).

tff(addAssignment_41200,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,1)
    <=> v67355(VarCurr,1) ) ).

tff(addAssignment_41199,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,1)
    <=> v67357(VarCurr,1) ) ).

tff(addAssignment_41198,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,1)
    <=> v67359(VarCurr,1) ) ).

tff(addAssignment_41197,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,1)
    <=> v67580(VarCurr,1) ) ).

tff(addAssignment_41196,axiom,
    ! [VarCurr: state_type] :
      ( v67361(VarCurr,1)
    <=> v67363(VarCurr,1) ) ).

tff(addAssignment_41195,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,1)
    <=> v67365(VarCurr,1) ) ).

tff(addAssignment_41194,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,1)
    <=> v69146(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69147(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69146(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_802,axiom,
    ! [VarNext: state_type] :
      ( v69147(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69146(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69147(VarNext)
      <=> v69148(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69148(VarNext)
      <=> ( v69150(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69150(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_41193,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,1)
    <=> v67389(VarCurr,1) ) ).

tff(addAssignment_41192,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,1)
    <=> v67391(VarCurr,1) ) ).

tff(addAssignment_41191,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,1)
    <=> v67393(VarCurr,1) ) ).

tff(addAssignment_41190,axiom,
    ! [VarCurr: state_type] :
      ( v67393(VarCurr,1)
    <=> v67395(VarCurr,1) ) ).

tff(addAssignment_41189,axiom,
    ! [VarCurr: state_type] :
      ( v67395(VarCurr,1)
    <=> v67531(VarCurr,1) ) ).

tff(addAssignment_41188,axiom,
    ! [VarCurr: state_type] :
      ( v67522(VarCurr,1)
    <=> v67524(VarCurr,1) ) ).

tff(addAssignment_41187,axiom,
    ! [VarCurr: state_type] :
      ( v67524(VarCurr,1)
    <=> v67401(VarCurr,1) ) ).

tff(addAssignment_41186,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,1)
    <=> v67403(VarCurr,1) ) ).

tff(addAssignment_41185,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,1)
    <=> v67405(VarCurr,1) ) ).

tff(addAssignment_41184,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,1)
    <=> v67514(VarCurr,1) ) ).

tff(addAssignment_41183,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,1)
    <=> v67428(VarCurr,1) ) ).

tff(addAssignment_41182,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,1)
    <=> v67430(VarCurr,1) ) ).

tff(addAssignment_41181,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,1)
    <=> v67432(VarCurr,1) ) ).

tff(addAssignment_41180,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,1)
    <=> v67434(VarCurr,1) ) ).

tff(addAssignment_41179,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,1)
    <=> v67436(VarCurr,1) ) ).

tff(addAssignment_41178,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,1)
    <=> v67438(VarCurr,1) ) ).

tff(addAssignment_41177,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,1)
    <=> v67497(VarCurr,1) ) ).

tff(addAssignment_41176,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,1)
    <=> v67493(VarCurr,1) ) ).

tff(addAssignment_41175,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,1)
    <=> v67495(VarCurr,1) ) ).

tff(addAssignment_41174,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,1)
    <=> v67496(VarCurr,1) ) ).

tff(addAssignment_41173,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,7)
    <=> v33839(VarCurr,7) ) ).

tff(addAssignment_41172,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,1)
    <=> v67489(VarCurr,1) ) ).

tff(addAssignment_41171,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,1)
    <=> v6234(VarCurr,1) ) ).

tff(addAssignment_41170,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,1)
    <=> v67485(VarCurr,1) ) ).

tff(addAssignment_41169,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_41168,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,1)
    <=> v67409(VarCurr,1) ) ).

tff(addAssignment_41167,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,1)
    <=> v67423(VarCurr,1) ) ).

tff(addAssignment_41166,axiom,
    ! [VarCurr: state_type] :
      ( v67397(VarCurr,1)
    <=> v67399(VarCurr,1) ) ).

tff(addAssignment_41165,axiom,
    ! [VarCurr: state_type] :
      ( v67399(VarCurr,1)
    <=> v67401(VarCurr,5) ) ).

tff(addAssignment_41164,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,5)
    <=> v67403(VarCurr,5) ) ).

tff(addAssignment_41163,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,5)
    <=> v67405(VarCurr,5) ) ).

tff(addAssignment_41162,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,5)
    <=> v67514(VarCurr,5) ) ).

tff(addAssignment_41161,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,5)
    <=> v67428(VarCurr,5) ) ).

tff(addAssignment_41160,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,5)
    <=> v67430(VarCurr,5) ) ).

tff(addAssignment_41159,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,5)
    <=> v67432(VarCurr,5) ) ).

tff(addAssignment_41158,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,5)
    <=> v67434(VarCurr,5) ) ).

tff(addAssignment_41157,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,5)
    <=> v67436(VarCurr,5) ) ).

tff(addAssignment_41156,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,5)
    <=> v67438(VarCurr,5) ) ).

tff(addAssignment_41155,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,5)
    <=> v67497(VarCurr,5) ) ).

tff(addAssignment_41154,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,5)
    <=> v67493(VarCurr,5) ) ).

tff(addAssignment_41153,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,5)
    <=> v67495(VarCurr,5) ) ).

tff(addAssignment_41152,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,5)
    <=> v67496(VarCurr,5) ) ).

tff(addAssignment_41151,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,11)
    <=> v33839(VarCurr,11) ) ).

tff(addAssignment_41150,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,5)
    <=> v67489(VarCurr,5) ) ).

tff(addAssignment_41149,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,5)
    <=> v6234(VarCurr,5) ) ).

tff(addAssignment_41148,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,5)
    <=> v67485(VarCurr,5) ) ).

tff(addAssignment_41147,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_41146,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,5)
    <=> v67409(VarCurr,5) ) ).

tff(addAssignment_41145,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,5)
    <=> v67423(VarCurr,5) ) ).

tff(addAssignment_41144,axiom,
    ! [VarCurr: state_type] :
      ( v67293(VarCurr)
    <=> v67295(VarCurr) ) ).

tff(addAssignment_41143,axiom,
    ! [VarCurr: state_type] :
      ( v67295(VarCurr)
    <=> v67297(VarCurr) ) ).

tff(addAssignment_41142,axiom,
    ! [VarCurr: state_type] :
      ( v67297(VarCurr)
    <=> v67299(VarCurr) ) ).

tff(addAssignment_41141,axiom,
    ! [VarCurr: state_type] :
      ( v67299(VarCurr)
    <=> v67301(VarCurr) ) ).

tff(writeUnaryOperator_3330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67301(VarCurr)
    <=> v69102(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6352,axiom,
    ! [VarCurr: state_type] :
      ( v69102(VarCurr)
    <=> ( v67303(VarCurr)
        | v68776(VarCurr) ) ) ).

tff(addAssignment_41140,axiom,
    ! [VarCurr: state_type] :
      ( v68776(VarCurr)
    <=> v68778(VarCurr) ) ).

tff(addAssignment_41139,axiom,
    ! [VarCurr: state_type] :
      ( v68778(VarCurr)
    <=> v67307(VarCurr,2) ) ).

tff(addAssignment_41138,axiom,
    ! [VarCurr: state_type] :
      ( v67307(VarCurr,2)
    <=> v67309(VarCurr,10) ) ).

tff(addAssignment_41137,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,10)
    <=> v67311(VarCurr,10) ) ).

tff(addAssignment_41136,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,10)
    <=> v67313(VarCurr,10) ) ).

tff(addAssignment_41135,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,10)
    <=> v67315(VarCurr,10) ) ).

tff(addAssignment_41134,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,10)
    <=> v67317(VarCurr,10) ) ).

tff(addAssignment_41133,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,10)
    <=> v68771(VarCurr,10) ) ).

tff(addAssignment_41132,axiom,
    ! [VarCurr: state_type] :
      ( v67319(VarCurr,2)
    <=> v68780(VarCurr) ) ).

tff(addAssignment_41131,axiom,
    ! [VarCurr: state_type] :
      ( v68780(VarCurr)
    <=> v68782(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6351,axiom,
    ! [VarCurr: state_type] :
      ( v68782(VarCurr)
    <=> ( v69100(VarCurr)
      <~> v69088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6350,axiom,
    ! [VarCurr: state_type] :
      ( v69100(VarCurr)
    <=> ( v68784(VarCurr)
      <~> v68940(VarCurr) ) ) ).

tff(addAssignment_41130,axiom,
    ! [VarCurr: state_type] :
      ( v69088(VarCurr)
    <=> v69090(VarCurr) ) ).

tff(addAssignment_41129,axiom,
    ! [VarCurr: state_type] :
      ( v69090(VarCurr)
    <=> v68672(VarCurr,2) ) ).

tff(addAssignment_41128,axiom,
    ! [VarCurr: state_type] :
      ( v68672(VarCurr,2)
    <=> v68674(VarCurr,2) ) ).

tff(addAssignment_41127,axiom,
    ! [VarCurr: state_type] :
      ( v68674(VarCurr,2)
    <=> v68676(VarCurr,2) ) ).

tff(addAssignment_41126,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,2)
    <=> v68678(VarCurr,2) ) ).

tff(addAssignment_41125,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,2)
    <=> v69092(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69093(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v69092(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_801,axiom,
    ! [VarNext: state_type] :
      ( v69093(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v69092(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69093(VarNext)
      <=> v69094(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69094(VarNext)
      <=> ( v69096(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69096(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_41124,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,2)
    <=> v68702(VarCurr,2) ) ).

tff(addAssignment_41123,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,2)
    <=> v68731(VarCurr,2) ) ).

tff(addAssignment_41122,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,10)
    <=> v68705(VarCurr,2) ) ).

tff(addAssignment_41121,axiom,
    ! [VarCurr: state_type] :
      ( v68705(VarCurr,2)
    <=> v68707(VarCurr,2) ) ).

tff(addAssignment_41120,axiom,
    ! [VarCurr: state_type] :
      ( v68707(VarCurr,2)
    <=> v68724(VarCurr,2) ) ).

tff(addAssignment_41119,axiom,
    ! [VarCurr: state_type] :
      ( v68717(VarCurr,2)
    <=> v68719(VarCurr,2) ) ).

tff(addAssignment_41118,axiom,
    ! [VarCurr: state_type] :
      ( v68719(VarCurr,2)
    <=> v68455(VarCurr,10) ) ).

tff(addAssignment_41117,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,10)
    <=> v68457(VarCurr,10) ) ).

tff(addAssignment_41116,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,10)
    <=> v68459(VarCurr,10) ) ).

tff(addAssignment_41115,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,10)
    <=> v68548(VarCurr,10) ) ).

tff(addAssignment_41114,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,10)
    <=> v68469(VarCurr,10) ) ).

tff(addAssignment_41113,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,10)
    <=> v68471(VarCurr,10) ) ).

tff(addAssignment_41112,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,10)
    <=> v67432(VarCurr,138) ) ).

tff(addAssignment_41111,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,138)
    <=> v67434(VarCurr,138) ) ).

tff(addAssignment_41110,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,138)
    <=> v68473(VarCurr,10) ) ).

tff(addAssignment_41109,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,10)
    <=> v68475(VarCurr,10) ) ).

tff(addAssignment_41108,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,10)
    <=> v68531(VarCurr,10) ) ).

tff(addAssignment_41107,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,10)
    <=> v68530(VarCurr,10) ) ).

tff(addAssignment_41106,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,10)
    <=> v6234(VarCurr,66) ) ).

tff(addAssignment_41105,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,10)
    <=> v68526(VarCurr,10) ) ).

tff(addAssignment_41104,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,10)
    <=> v53217(VarCurr,66) ) ).

tff(addAssignment_41103,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,10)
    <=> v68522(VarCurr,10) ) ).

tff(addAssignment_41102,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_41101,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,10)
    <=> v68463(VarCurr,10) ) ).

tff(addAssignment_41100,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,10)
    <=> v68464(VarCurr,10) ) ).

tff(addAssignment_41099,axiom,
    ! [VarCurr: state_type] :
      ( v68709(VarCurr,2)
    <=> v68711(VarCurr,2) ) ).

tff(addAssignment_41098,axiom,
    ! [VarCurr: state_type] :
      ( v68711(VarCurr,2)
    <=> v68455(VarCurr,6) ) ).

tff(addAssignment_41097,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,6)
    <=> v68457(VarCurr,6) ) ).

tff(addAssignment_41096,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,6)
    <=> v68459(VarCurr,6) ) ).

tff(addAssignment_41095,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,6)
    <=> v68548(VarCurr,6) ) ).

tff(addAssignment_41094,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,6)
    <=> v68469(VarCurr,6) ) ).

tff(addAssignment_41093,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,6)
    <=> v68471(VarCurr,6) ) ).

tff(addAssignment_41092,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,6)
    <=> v67432(VarCurr,134) ) ).

tff(addAssignment_41091,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,134)
    <=> v67434(VarCurr,134) ) ).

tff(addAssignment_41090,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,134)
    <=> v68473(VarCurr,6) ) ).

tff(addAssignment_41089,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,6)
    <=> v68475(VarCurr,6) ) ).

tff(addAssignment_41088,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,6)
    <=> v68531(VarCurr,6) ) ).

tff(addAssignment_41087,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,6)
    <=> v68530(VarCurr,6) ) ).

tff(addAssignment_41086,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,6)
    <=> v6234(VarCurr,62) ) ).

tff(addAssignment_41085,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,6)
    <=> v68526(VarCurr,6) ) ).

tff(addAssignment_41084,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,6)
    <=> v53217(VarCurr,62) ) ).

tff(addAssignment_41083,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,6)
    <=> v68522(VarCurr,6) ) ).

tff(addAssignment_41082,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_41081,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,6)
    <=> v68463(VarCurr,6) ) ).

tff(addAssignment_41080,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,6)
    <=> v68464(VarCurr,6) ) ).

tff(addAssignment_41079,axiom,
    ! [VarCurr: state_type] :
      ( v68940(VarCurr)
    <=> v68942(VarCurr) ) ).

tff(addAssignment_41078,axiom,
    ! [VarCurr: state_type] :
      ( v68942(VarCurr)
    <=> v68944(VarCurr) ) ).

tff(addAssignment_41077,axiom,
    ! [VarCurr: state_type] :
      ( v68944(VarCurr)
    <=> v68946(VarCurr) ) ).

tff(addAssignment_41076,axiom,
    ! [VarCurr: state_type] :
      ( v68946(VarCurr)
    <=> v68948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6347,axiom,
    ! [VarCurr: state_type] :
      ( v68948(VarCurr)
    <=> ( v69086(VarCurr)
      <~> v69046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6346,axiom,
    ! [VarCurr: state_type] :
      ( v69086(VarCurr)
    <=> ( v68950(VarCurr)
      <~> v68998(VarCurr) ) ) ).

tff(addAssignment_41075,axiom,
    ! [VarCurr: state_type] :
      ( v69046(VarCurr)
    <=> v69048(VarCurr) ) ).

tff(addAssignment_41074,axiom,
    ! [VarCurr: state_type] :
      ( v69048(VarCurr)
    <=> v69050(VarCurr) ) ).

tff(addAssignment_41073,axiom,
    ! [VarCurr: state_type] :
      ( v69050(VarCurr)
    <=> v69052(VarCurr) ) ).

tff(addAssignment_41072,axiom,
    ! [VarCurr: state_type] :
      ( v69052(VarCurr)
    <=> v69054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6345,axiom,
    ! [VarCurr: state_type] :
      ( v69054(VarCurr)
    <=> ( v69084(VarCurr)
      <~> v69080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6344,axiom,
    ! [VarCurr: state_type] :
      ( v69084(VarCurr)
    <=> ( v69056(VarCurr)
      <~> v69068(VarCurr) ) ) ).

tff(addAssignment_41071,axiom,
    ! [VarCurr: state_type] :
      ( v69080(VarCurr)
    <=> v69082(VarCurr) ) ).

tff(addAssignment_41070,axiom,
    ! [VarCurr: state_type] :
      ( v69082(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_41069,axiom,
    ! [VarCurr: state_type] :
      ( v69068(VarCurr)
    <=> v69070(VarCurr) ) ).

tff(addAssignment_41068,axiom,
    ! [VarCurr: state_type] :
      ( v69070(VarCurr)
    <=> v67349(VarCurr,126) ) ).

tff(addAssignment_41067,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,126)
    <=> v68249(VarCurr,62) ) ).

tff(addAssignment_41066,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,62)
    <=> v68251(VarCurr,62) ) ).

tff(addAssignment_41065,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,62)
    <=> v68253(VarCurr,62) ) ).

tff(addAssignment_41064,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,62)
    <=> v68255(VarCurr,62) ) ).

tff(addAssignment_41063,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,62)
    <=> v67359(VarCurr,126) ) ).

tff(addAssignment_41062,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,126)
    <=> v67580(VarCurr,126) ) ).

tff(addAssignment_41061,axiom,
    ! [VarCurr: state_type] :
      ( v67581(VarCurr,2)
    <=> v68258(VarCurr,62) ) ).

tff(addAssignment_41060,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,62)
    <=> v68260(VarCurr,62) ) ).

tff(addAssignment_41059,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,62)
    <=> v69072(VarNext,62) ) ).

tff(addCaseBooleanConditionEqualRanges1_800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69073(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69072(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_800,axiom,
    ! [VarNext: state_type] :
      ( v69073(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69072(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69073(VarNext)
      <=> v69074(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69074(VarNext)
      <=> ( v69076(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69076(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_41058,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,62)
    <=> v68284(VarCurr,62) ) ).

tff(addAssignment_41057,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,62)
    <=> v67391(VarCurr,126) ) ).

tff(addAssignment_41056,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,126)
    <=> v68447(VarCurr,2) ) ).

tff(addAssignment_41055,axiom,
    ! [VarCurr: state_type] :
      ( v68447(VarCurr,2)
    <=> v68449(VarCurr,2) ) ).

tff(addAssignment_41054,axiom,
    ! [VarCurr: state_type] :
      ( v68449(VarCurr,2)
    <=> v68561(VarCurr,2) ) ).

tff(addAssignment_41053,axiom,
    ! [VarCurr: state_type] :
      ( v68554(VarCurr,2)
    <=> v68556(VarCurr,2) ) ).

tff(addAssignment_41052,axiom,
    ! [VarCurr: state_type] :
      ( v68556(VarCurr,2)
    <=> v67401(VarCurr,126) ) ).

tff(addAssignment_41051,axiom,
    ! [VarCurr: state_type] :
      ( v68451(VarCurr,2)
    <=> v68453(VarCurr,2) ) ).

tff(addAssignment_41050,axiom,
    ! [VarCurr: state_type] :
      ( v68453(VarCurr,2)
    <=> v68455(VarCurr,14) ) ).

tff(addAssignment_41049,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,14)
    <=> v68457(VarCurr,14) ) ).

tff(addAssignment_41048,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,14)
    <=> v68459(VarCurr,14) ) ).

tff(addAssignment_41047,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,14)
    <=> v68548(VarCurr,14) ) ).

tff(addAssignment_41046,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,14)
    <=> v68469(VarCurr,14) ) ).

tff(addAssignment_41045,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,14)
    <=> v68471(VarCurr,14) ) ).

tff(addAssignment_41044,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,14)
    <=> v67432(VarCurr,142) ) ).

tff(addAssignment_41043,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,142)
    <=> v67434(VarCurr,142) ) ).

tff(addAssignment_41042,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,142)
    <=> v68473(VarCurr,14) ) ).

tff(addAssignment_41041,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,14)
    <=> v68475(VarCurr,14) ) ).

tff(addAssignment_41040,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,14)
    <=> v68531(VarCurr,14) ) ).

tff(addAssignment_41039,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,14)
    <=> v68530(VarCurr,14) ) ).

tff(addAssignment_41038,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,14)
    <=> v6234(VarCurr,70) ) ).

tff(addAssignment_41037,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,14)
    <=> v68526(VarCurr,14) ) ).

tff(addAssignment_41036,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,14)
    <=> v53217(VarCurr,70) ) ).

tff(addAssignment_41035,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,14)
    <=> v68522(VarCurr,14) ) ).

tff(addAssignment_41034,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_41033,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,14)
    <=> v68463(VarCurr,14) ) ).

tff(addAssignment_41032,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,14)
    <=> v68464(VarCurr,14) ) ).

tff(addAssignment_41031,axiom,
    ! [VarCurr: state_type] :
      ( v69056(VarCurr)
    <=> v69058(VarCurr) ) ).

tff(addAssignment_41030,axiom,
    ! [VarCurr: state_type] :
      ( v69058(VarCurr)
    <=> v67349(VarCurr,122) ) ).

tff(addAssignment_41029,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,122)
    <=> v68249(VarCurr,58) ) ).

tff(addAssignment_41028,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,58)
    <=> v68251(VarCurr,58) ) ).

tff(addAssignment_41027,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,58)
    <=> v68253(VarCurr,58) ) ).

tff(addAssignment_41026,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,58)
    <=> v68255(VarCurr,58) ) ).

tff(addAssignment_41025,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,58)
    <=> v67359(VarCurr,122) ) ).

tff(addAssignment_41024,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,122)
    <=> v67580(VarCurr,122) ) ).

tff(addAssignment_41023,axiom,
    ! [VarCurr: state_type] :
      ( v67582(VarCurr,2)
    <=> v68258(VarCurr,58) ) ).

tff(addAssignment_41022,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,58)
    <=> v68260(VarCurr,58) ) ).

tff(addAssignment_41021,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,58)
    <=> v69060(VarNext,58) ) ).

tff(addCaseBooleanConditionEqualRanges1_799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69061(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69060(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_799,axiom,
    ! [VarNext: state_type] :
      ( v69061(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69060(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69061(VarNext)
      <=> v69062(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69062(VarNext)
      <=> ( v69064(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69064(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_41020,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,58)
    <=> v68284(VarCurr,58) ) ).

tff(addAssignment_41019,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,58)
    <=> v67391(VarCurr,122) ) ).

tff(addAssignment_41018,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,122)
    <=> v68286(VarCurr,2) ) ).

tff(addAssignment_41017,axiom,
    ! [VarCurr: state_type] :
      ( v68286(VarCurr,2)
    <=> v68288(VarCurr,2) ) ).

tff(addAssignment_41016,axiom,
    ! [VarCurr: state_type] :
      ( v68288(VarCurr,2)
    <=> v68398(VarCurr,2) ) ).

tff(addAssignment_41015,axiom,
    ! [VarCurr: state_type] :
      ( v68391(VarCurr,2)
    <=> v68393(VarCurr,2) ) ).

tff(addAssignment_41014,axiom,
    ! [VarCurr: state_type] :
      ( v68393(VarCurr,2)
    <=> v67401(VarCurr,122) ) ).

tff(addAssignment_41013,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,122)
    <=> v68294(VarCurr,58) ) ).

tff(addAssignment_41012,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,58)
    <=> v68296(VarCurr,58) ) ).

tff(addAssignment_41011,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,58)
    <=> v68385(VarCurr,58) ) ).

tff(addAssignment_41010,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,58)
    <=> v68306(VarCurr,58) ) ).

tff(addAssignment_41009,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,58)
    <=> v67430(VarCurr,122) ) ).

tff(addAssignment_41008,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,122)
    <=> v67432(VarCurr,122) ) ).

tff(addAssignment_41007,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,122)
    <=> v67434(VarCurr,122) ) ).

tff(addAssignment_41006,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,122)
    <=> v68308(VarCurr,58) ) ).

tff(addAssignment_41005,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,58)
    <=> v68310(VarCurr,58) ) ).

tff(addAssignment_41004,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,58)
    <=> v68368(VarCurr,58) ) ).

tff(addAssignment_41003,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,58)
    <=> v68366(VarCurr,58) ) ).

tff(addAssignment_41002,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,58)
    <=> v68367(VarCurr,58) ) ).

tff(addAssignment_41001,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,58)
    <=> v68361(VarCurr,58) ) ).

tff(addAssignment_41000,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,58)
    <=> v68362(VarCurr,58) ) ).

tff(addAssignment_40999,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,58)
    <=> v68357(VarCurr,58) ) ).

tff(addAssignment_40998,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,58)
    <=> $false ) ).

tff(addAssignment_40997,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,58)
    <=> v68300(VarCurr,58) ) ).

tff(addAssignment_40996,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,58)
    <=> v68301(VarCurr,58) ) ).

tff(addAssignment_40995,axiom,
    ! [VarCurr: state_type] :
      ( v68290(VarCurr,2)
    <=> v68292(VarCurr,2) ) ).

tff(addAssignment_40994,axiom,
    ! [VarCurr: state_type] :
      ( v68292(VarCurr,2)
    <=> v67401(VarCurr,126) ) ).

tff(addAssignment_40993,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,126)
    <=> v68294(VarCurr,62) ) ).

tff(addAssignment_40992,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,62)
    <=> v68296(VarCurr,62) ) ).

tff(addAssignment_40991,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,62)
    <=> v68385(VarCurr,62) ) ).

tff(addAssignment_40990,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,62)
    <=> v68306(VarCurr,62) ) ).

tff(addAssignment_40989,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,62)
    <=> v67430(VarCurr,126) ) ).

tff(addAssignment_40988,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,126)
    <=> v67432(VarCurr,126) ) ).

tff(addAssignment_40987,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,126)
    <=> v67434(VarCurr,126) ) ).

tff(addAssignment_40986,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,126)
    <=> v68308(VarCurr,62) ) ).

tff(addAssignment_40985,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,62)
    <=> v68310(VarCurr,62) ) ).

tff(addAssignment_40984,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,62)
    <=> v68368(VarCurr,62) ) ).

tff(addAssignment_40983,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,62)
    <=> v68366(VarCurr,62) ) ).

tff(addAssignment_40982,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,62)
    <=> v68367(VarCurr,62) ) ).

tff(addAssignment_40981,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,62)
    <=> v68361(VarCurr,62) ) ).

tff(addAssignment_40980,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,62)
    <=> v68362(VarCurr,62) ) ).

tff(addAssignment_40979,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,62)
    <=> v68357(VarCurr,62) ) ).

tff(addAssignment_40978,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,62)
    <=> $false ) ).

tff(addAssignment_40977,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,62)
    <=> v68300(VarCurr,62) ) ).

tff(addAssignment_40976,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,62)
    <=> v68301(VarCurr,62) ) ).

tff(addAssignment_40975,axiom,
    ! [VarCurr: state_type] :
      ( v68998(VarCurr)
    <=> v69000(VarCurr) ) ).

tff(addAssignment_40974,axiom,
    ! [VarCurr: state_type] :
      ( v69000(VarCurr)
    <=> v69002(VarCurr) ) ).

tff(addAssignment_40973,axiom,
    ! [VarCurr: state_type] :
      ( v69002(VarCurr)
    <=> v69004(VarCurr) ) ).

tff(addAssignment_40972,axiom,
    ! [VarCurr: state_type] :
      ( v69004(VarCurr)
    <=> v69006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6339,axiom,
    ! [VarCurr: state_type] :
      ( v69006(VarCurr)
    <=> ( v69044(VarCurr)
      <~> v69032(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6338,axiom,
    ! [VarCurr: state_type] :
      ( v69044(VarCurr)
    <=> ( v69008(VarCurr)
      <~> v69020(VarCurr) ) ) ).

tff(addAssignment_40971,axiom,
    ! [VarCurr: state_type] :
      ( v69032(VarCurr)
    <=> v69034(VarCurr) ) ).

tff(addAssignment_40970,axiom,
    ! [VarCurr: state_type] :
      ( v69034(VarCurr)
    <=> v67349(VarCurr,58) ) ).

tff(addAssignment_40969,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,58)
    <=> v67351(VarCurr,58) ) ).

tff(addAssignment_40968,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,58)
    <=> v67353(VarCurr,58) ) ).

tff(addAssignment_40967,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,58)
    <=> v67355(VarCurr,58) ) ).

tff(addAssignment_40966,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,58)
    <=> v67357(VarCurr,58) ) ).

tff(addAssignment_40965,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,58)
    <=> v67359(VarCurr,58) ) ).

tff(addAssignment_40964,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,58)
    <=> v67580(VarCurr,58) ) ).

tff(addAssignment_40963,axiom,
    ! [VarCurr: state_type] :
      ( v67598(VarCurr,2)
    <=> v67363(VarCurr,58) ) ).

tff(addAssignment_40962,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,58)
    <=> v67365(VarCurr,58) ) ).

tff(addAssignment_40961,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,58)
    <=> v69036(VarNext,58) ) ).

tff(addCaseBooleanConditionEqualRanges1_798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69037(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69036(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_798,axiom,
    ! [VarNext: state_type] :
      ( v69037(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69036(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69037(VarNext)
      <=> v69038(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69038(VarNext)
      <=> ( v69040(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69040(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40960,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,58)
    <=> v67389(VarCurr,58) ) ).

tff(addAssignment_40959,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,58)
    <=> v67391(VarCurr,58) ) ).

tff(addAssignment_40958,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,58)
    <=> v68198(VarCurr,2) ) ).

tff(addAssignment_40957,axiom,
    ! [VarCurr: state_type] :
      ( v68198(VarCurr,2)
    <=> v68200(VarCurr,2) ) ).

tff(addAssignment_40956,axiom,
    ! [VarCurr: state_type] :
      ( v68200(VarCurr,2)
    <=> v68217(VarCurr,2) ) ).

tff(addAssignment_40955,axiom,
    ! [VarCurr: state_type] :
      ( v68210(VarCurr,2)
    <=> v68212(VarCurr,2) ) ).

tff(addAssignment_40954,axiom,
    ! [VarCurr: state_type] :
      ( v68212(VarCurr,2)
    <=> v67401(VarCurr,58) ) ).

tff(addAssignment_40953,axiom,
    ! [VarCurr: state_type] :
      ( v68202(VarCurr,2)
    <=> v68204(VarCurr,2) ) ).

tff(addAssignment_40952,axiom,
    ! [VarCurr: state_type] :
      ( v68204(VarCurr,2)
    <=> v67401(VarCurr,62) ) ).

tff(addAssignment_40951,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,62)
    <=> v67403(VarCurr,62) ) ).

tff(addAssignment_40950,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,62)
    <=> v67405(VarCurr,62) ) ).

tff(addAssignment_40949,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,62)
    <=> v67514(VarCurr,62) ) ).

tff(addAssignment_40948,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,62)
    <=> v67428(VarCurr,62) ) ).

tff(addAssignment_40947,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,62)
    <=> v67430(VarCurr,62) ) ).

tff(addAssignment_40946,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,62)
    <=> v67432(VarCurr,62) ) ).

tff(addAssignment_40945,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,62)
    <=> v67434(VarCurr,62) ) ).

tff(addAssignment_40944,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,62)
    <=> v67436(VarCurr,62) ) ).

tff(addAssignment_40943,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,62)
    <=> v67438(VarCurr,62) ) ).

tff(addAssignment_40942,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,62)
    <=> v67497(VarCurr,62) ) ).

tff(addAssignment_40941,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,62)
    <=> v67493(VarCurr,62) ) ).

tff(addAssignment_40940,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,62)
    <=> v67495(VarCurr,62) ) ).

tff(addAssignment_40939,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,62)
    <=> v67496(VarCurr,62) ) ).

tff(addAssignment_40938,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,128)
    <=> v33839(VarCurr,128) ) ).

tff(addAssignment_40937,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,128)
    <=> v33841(VarCurr,128) ) ).

tff(addAssignment_40936,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,128)
    <=> v25005(VarCurr,8) ) ).

tff(addAssignment_40935,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,62)
    <=> v67489(VarCurr,62) ) ).

tff(addAssignment_40934,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,62)
    <=> v6234(VarCurr,62) ) ).

tff(addAssignment_40933,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,62)
    <=> v67485(VarCurr,62) ) ).

tff(addAssignment_40932,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,62)
    <=> $false ) ).

tff(addAssignment_40931,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,62)
    <=> v67409(VarCurr,62) ) ).

tff(addAssignment_40930,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,62)
    <=> v67423(VarCurr,62) ) ).

tff(addAssignment_40929,axiom,
    ! [VarCurr: state_type] :
      ( v69020(VarCurr)
    <=> v69022(VarCurr) ) ).

tff(addAssignment_40928,axiom,
    ! [VarCurr: state_type] :
      ( v69022(VarCurr)
    <=> v67349(VarCurr,54) ) ).

tff(addAssignment_40927,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,54)
    <=> v67351(VarCurr,54) ) ).

tff(addAssignment_40926,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,54)
    <=> v67353(VarCurr,54) ) ).

tff(addAssignment_40925,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,54)
    <=> v67355(VarCurr,54) ) ).

tff(addAssignment_40924,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,54)
    <=> v67357(VarCurr,54) ) ).

tff(addAssignment_40923,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,54)
    <=> v67359(VarCurr,54) ) ).

tff(addAssignment_40922,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,54)
    <=> v67580(VarCurr,54) ) ).

tff(addAssignment_40921,axiom,
    ! [VarCurr: state_type] :
      ( v67599(VarCurr,2)
    <=> v67363(VarCurr,54) ) ).

tff(addAssignment_40920,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,54)
    <=> v67365(VarCurr,54) ) ).

tff(addAssignment_40919,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,54)
    <=> v69024(VarNext,54) ) ).

tff(addCaseBooleanConditionEqualRanges1_797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69025(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69024(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_797,axiom,
    ! [VarNext: state_type] :
      ( v69025(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69024(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69025(VarNext)
      <=> v69026(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69026(VarNext)
      <=> ( v69028(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69028(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40918,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,54)
    <=> v67389(VarCurr,54) ) ).

tff(addAssignment_40917,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,54)
    <=> v67391(VarCurr,54) ) ).

tff(addAssignment_40916,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,54)
    <=> v68158(VarCurr,2) ) ).

tff(addAssignment_40915,axiom,
    ! [VarCurr: state_type] :
      ( v68158(VarCurr,2)
    <=> v68160(VarCurr,2) ) ).

tff(addAssignment_40914,axiom,
    ! [VarCurr: state_type] :
      ( v68160(VarCurr,2)
    <=> v68177(VarCurr,2) ) ).

tff(addAssignment_40913,axiom,
    ! [VarCurr: state_type] :
      ( v68170(VarCurr,2)
    <=> v68172(VarCurr,2) ) ).

tff(addAssignment_40912,axiom,
    ! [VarCurr: state_type] :
      ( v68172(VarCurr,2)
    <=> v67401(VarCurr,54) ) ).

tff(addAssignment_40911,axiom,
    ! [VarCurr: state_type] :
      ( v68162(VarCurr,2)
    <=> v68164(VarCurr,2) ) ).

tff(addAssignment_40910,axiom,
    ! [VarCurr: state_type] :
      ( v68164(VarCurr,2)
    <=> v67401(VarCurr,58) ) ).

tff(addAssignment_40909,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,58)
    <=> v67403(VarCurr,58) ) ).

tff(addAssignment_40908,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,58)
    <=> v67405(VarCurr,58) ) ).

tff(addAssignment_40907,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,58)
    <=> v67514(VarCurr,58) ) ).

tff(addAssignment_40906,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,58)
    <=> v67428(VarCurr,58) ) ).

tff(addAssignment_40905,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,58)
    <=> v67430(VarCurr,58) ) ).

tff(addAssignment_40904,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,58)
    <=> v67432(VarCurr,58) ) ).

tff(addAssignment_40903,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,58)
    <=> v67434(VarCurr,58) ) ).

tff(addAssignment_40902,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,58)
    <=> v67436(VarCurr,58) ) ).

tff(addAssignment_40901,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,58)
    <=> v67438(VarCurr,58) ) ).

tff(addAssignment_40900,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,58)
    <=> v67497(VarCurr,58) ) ).

tff(addAssignment_40899,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,58)
    <=> v67493(VarCurr,58) ) ).

tff(addAssignment_40898,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,58)
    <=> v67495(VarCurr,58) ) ).

tff(addAssignment_40897,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,58)
    <=> v67496(VarCurr,58) ) ).

tff(addAssignment_40896,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,118)
    <=> v33839(VarCurr,118) ) ).

tff(addAssignment_40895,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,118)
    <=> v33841(VarCurr,118) ) ).

tff(addAssignment_40894,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,118)
    <=> v23455(VarCurr,10) ) ).

tff(addAssignment_40893,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,58)
    <=> v67489(VarCurr,58) ) ).

tff(addAssignment_40892,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,58)
    <=> v6234(VarCurr,58) ) ).

tff(addAssignment_40891,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,58)
    <=> v67485(VarCurr,58) ) ).

tff(addAssignment_40890,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,58)
    <=> $false ) ).

tff(addAssignment_40889,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,58)
    <=> v67409(VarCurr,58) ) ).

tff(addAssignment_40888,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,58)
    <=> v67423(VarCurr,58) ) ).

tff(addAssignment_40887,axiom,
    ! [VarCurr: state_type] :
      ( v69008(VarCurr)
    <=> v69010(VarCurr) ) ).

tff(addAssignment_40886,axiom,
    ! [VarCurr: state_type] :
      ( v69010(VarCurr)
    <=> v67349(VarCurr,50) ) ).

tff(addAssignment_40885,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,50)
    <=> v67351(VarCurr,50) ) ).

tff(addAssignment_40884,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,50)
    <=> v67353(VarCurr,50) ) ).

tff(addAssignment_40883,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,50)
    <=> v67355(VarCurr,50) ) ).

tff(addAssignment_40882,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,50)
    <=> v67357(VarCurr,50) ) ).

tff(addAssignment_40881,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,50)
    <=> v67359(VarCurr,50) ) ).

tff(addAssignment_40880,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,50)
    <=> v67580(VarCurr,50) ) ).

tff(addAssignment_40879,axiom,
    ! [VarCurr: state_type] :
      ( v67600(VarCurr,2)
    <=> v67363(VarCurr,50) ) ).

tff(addAssignment_40878,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,50)
    <=> v67365(VarCurr,50) ) ).

tff(addAssignment_40877,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,50)
    <=> v69012(VarNext,50) ) ).

tff(addCaseBooleanConditionEqualRanges1_796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69013(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v69012(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_796,axiom,
    ! [VarNext: state_type] :
      ( v69013(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v69012(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69013(VarNext)
      <=> v69014(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v69014(VarNext)
      <=> ( v69016(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v69016(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40876,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,50)
    <=> v67389(VarCurr,50) ) ).

tff(addAssignment_40875,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,50)
    <=> v67391(VarCurr,50) ) ).

tff(addAssignment_40874,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,50)
    <=> v68118(VarCurr,2) ) ).

tff(addAssignment_40873,axiom,
    ! [VarCurr: state_type] :
      ( v68118(VarCurr,2)
    <=> v68120(VarCurr,2) ) ).

tff(addAssignment_40872,axiom,
    ! [VarCurr: state_type] :
      ( v68120(VarCurr,2)
    <=> v68137(VarCurr,2) ) ).

tff(addAssignment_40871,axiom,
    ! [VarCurr: state_type] :
      ( v68130(VarCurr,2)
    <=> v68132(VarCurr,2) ) ).

tff(addAssignment_40870,axiom,
    ! [VarCurr: state_type] :
      ( v68132(VarCurr,2)
    <=> v67401(VarCurr,50) ) ).

tff(addAssignment_40869,axiom,
    ! [VarCurr: state_type] :
      ( v68122(VarCurr,2)
    <=> v68124(VarCurr,2) ) ).

tff(addAssignment_40868,axiom,
    ! [VarCurr: state_type] :
      ( v68124(VarCurr,2)
    <=> v67401(VarCurr,54) ) ).

tff(addAssignment_40867,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,54)
    <=> v67403(VarCurr,54) ) ).

tff(addAssignment_40866,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,54)
    <=> v67405(VarCurr,54) ) ).

tff(addAssignment_40865,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,54)
    <=> v67514(VarCurr,54) ) ).

tff(addAssignment_40864,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,54)
    <=> v67428(VarCurr,54) ) ).

tff(addAssignment_40863,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,54)
    <=> v67430(VarCurr,54) ) ).

tff(addAssignment_40862,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,54)
    <=> v67432(VarCurr,54) ) ).

tff(addAssignment_40861,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,54)
    <=> v67434(VarCurr,54) ) ).

tff(addAssignment_40860,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,54)
    <=> v67436(VarCurr,54) ) ).

tff(addAssignment_40859,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,54)
    <=> v67438(VarCurr,54) ) ).

tff(addAssignment_40858,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,54)
    <=> v67497(VarCurr,54) ) ).

tff(addAssignment_40857,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,54)
    <=> v67493(VarCurr,54) ) ).

tff(addAssignment_40856,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,54)
    <=> v67495(VarCurr,54) ) ).

tff(addAssignment_40855,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,54)
    <=> v67496(VarCurr,54) ) ).

tff(addAssignment_40854,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,114)
    <=> v33839(VarCurr,114) ) ).

tff(addAssignment_40853,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,114)
    <=> v33841(VarCurr,114) ) ).

tff(addAssignment_40852,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,114)
    <=> v23455(VarCurr,6) ) ).

tff(addAssignment_40851,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,54)
    <=> v67489(VarCurr,54) ) ).

tff(addAssignment_40850,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,54)
    <=> v6234(VarCurr,54) ) ).

tff(addAssignment_40849,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,54)
    <=> v67485(VarCurr,54) ) ).

tff(addAssignment_40848,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,54)
    <=> $false ) ).

tff(addAssignment_40847,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,54)
    <=> v67409(VarCurr,54) ) ).

tff(addAssignment_40846,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,54)
    <=> v67423(VarCurr,54) ) ).

tff(addAssignment_40845,axiom,
    ! [VarCurr: state_type] :
      ( v68950(VarCurr)
    <=> v68952(VarCurr) ) ).

tff(addAssignment_40844,axiom,
    ! [VarCurr: state_type] :
      ( v68952(VarCurr)
    <=> v68954(VarCurr) ) ).

tff(addAssignment_40843,axiom,
    ! [VarCurr: state_type] :
      ( v68954(VarCurr)
    <=> v68956(VarCurr) ) ).

tff(addAssignment_40842,axiom,
    ! [VarCurr: state_type] :
      ( v68956(VarCurr)
    <=> v68958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6331,axiom,
    ! [VarCurr: state_type] :
      ( v68958(VarCurr)
    <=> ( v68996(VarCurr)
      <~> v68984(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6330,axiom,
    ! [VarCurr: state_type] :
      ( v68996(VarCurr)
    <=> ( v68960(VarCurr)
      <~> v68972(VarCurr) ) ) ).

tff(addAssignment_40841,axiom,
    ! [VarCurr: state_type] :
      ( v68984(VarCurr)
    <=> v68986(VarCurr) ) ).

tff(addAssignment_40840,axiom,
    ! [VarCurr: state_type] :
      ( v68986(VarCurr)
    <=> v67349(VarCurr,46) ) ).

tff(addAssignment_40839,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,46)
    <=> v67351(VarCurr,46) ) ).

tff(addAssignment_40838,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,46)
    <=> v67353(VarCurr,46) ) ).

tff(addAssignment_40837,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,46)
    <=> v67355(VarCurr,46) ) ).

tff(addAssignment_40836,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,46)
    <=> v67357(VarCurr,46) ) ).

tff(addAssignment_40835,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,46)
    <=> v67359(VarCurr,46) ) ).

tff(addAssignment_40834,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,46)
    <=> v67580(VarCurr,46) ) ).

tff(addAssignment_40833,axiom,
    ! [VarCurr: state_type] :
      ( v67601(VarCurr,2)
    <=> v67363(VarCurr,46) ) ).

tff(addAssignment_40832,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,46)
    <=> v67365(VarCurr,46) ) ).

tff(addAssignment_40831,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,46)
    <=> v68988(VarNext,46) ) ).

tff(addCaseBooleanConditionEqualRanges1_795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68989(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68988(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_795,axiom,
    ! [VarNext: state_type] :
      ( v68989(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68988(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68989(VarNext)
      <=> v68990(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68990(VarNext)
      <=> ( v68992(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68992(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40830,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,46)
    <=> v67389(VarCurr,46) ) ).

tff(addAssignment_40829,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,46)
    <=> v67391(VarCurr,46) ) ).

tff(addAssignment_40828,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,46)
    <=> v68066(VarCurr,2) ) ).

tff(addAssignment_40827,axiom,
    ! [VarCurr: state_type] :
      ( v68066(VarCurr,2)
    <=> v68068(VarCurr,2) ) ).

tff(addAssignment_40826,axiom,
    ! [VarCurr: state_type] :
      ( v68068(VarCurr,2)
    <=> v68085(VarCurr,2) ) ).

tff(addAssignment_40825,axiom,
    ! [VarCurr: state_type] :
      ( v68078(VarCurr,2)
    <=> v68080(VarCurr,2) ) ).

tff(addAssignment_40824,axiom,
    ! [VarCurr: state_type] :
      ( v68080(VarCurr,2)
    <=> v67401(VarCurr,46) ) ).

tff(addAssignment_40823,axiom,
    ! [VarCurr: state_type] :
      ( v68070(VarCurr,2)
    <=> v68072(VarCurr,2) ) ).

tff(addAssignment_40822,axiom,
    ! [VarCurr: state_type] :
      ( v68072(VarCurr,2)
    <=> v67401(VarCurr,50) ) ).

tff(addAssignment_40821,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,50)
    <=> v67403(VarCurr,50) ) ).

tff(addAssignment_40820,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,50)
    <=> v67405(VarCurr,50) ) ).

tff(addAssignment_40819,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,50)
    <=> v67514(VarCurr,50) ) ).

tff(addAssignment_40818,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,50)
    <=> v67428(VarCurr,50) ) ).

tff(addAssignment_40817,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,50)
    <=> v67430(VarCurr,50) ) ).

tff(addAssignment_40816,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,50)
    <=> v67432(VarCurr,50) ) ).

tff(addAssignment_40815,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,50)
    <=> v67434(VarCurr,50) ) ).

tff(addAssignment_40814,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,50)
    <=> v67436(VarCurr,50) ) ).

tff(addAssignment_40813,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,50)
    <=> v67438(VarCurr,50) ) ).

tff(addAssignment_40812,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,50)
    <=> v67497(VarCurr,50) ) ).

tff(addAssignment_40811,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,50)
    <=> v67493(VarCurr,50) ) ).

tff(addAssignment_40810,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,50)
    <=> v67495(VarCurr,50) ) ).

tff(addAssignment_40809,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,50)
    <=> v67496(VarCurr,50) ) ).

tff(addAssignment_40808,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,104)
    <=> v33839(VarCurr,104) ) ).

tff(addAssignment_40807,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,104)
    <=> v33841(VarCurr,104) ) ).

tff(addAssignment_40806,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,104)
    <=> v21905(VarCurr,8) ) ).

tff(addAssignment_40805,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,50)
    <=> v67489(VarCurr,50) ) ).

tff(addAssignment_40804,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,50)
    <=> v6234(VarCurr,50) ) ).

tff(addAssignment_40803,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,50)
    <=> v67485(VarCurr,50) ) ).

tff(addAssignment_40802,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,50)
    <=> $false ) ).

tff(addAssignment_40801,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,50)
    <=> v67409(VarCurr,50) ) ).

tff(addAssignment_40800,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,50)
    <=> v67423(VarCurr,50) ) ).

tff(addAssignment_40799,axiom,
    ! [VarCurr: state_type] :
      ( v68972(VarCurr)
    <=> v68974(VarCurr) ) ).

tff(addAssignment_40798,axiom,
    ! [VarCurr: state_type] :
      ( v68974(VarCurr)
    <=> v67349(VarCurr,42) ) ).

tff(addAssignment_40797,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,42)
    <=> v67351(VarCurr,42) ) ).

tff(addAssignment_40796,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,42)
    <=> v67353(VarCurr,42) ) ).

tff(addAssignment_40795,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,42)
    <=> v67355(VarCurr,42) ) ).

tff(addAssignment_40794,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,42)
    <=> v67357(VarCurr,42) ) ).

tff(addAssignment_40793,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,42)
    <=> v67359(VarCurr,42) ) ).

tff(addAssignment_40792,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,42)
    <=> v67580(VarCurr,42) ) ).

tff(addAssignment_40791,axiom,
    ! [VarCurr: state_type] :
      ( v67602(VarCurr,2)
    <=> v67363(VarCurr,42) ) ).

tff(addAssignment_40790,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,42)
    <=> v67365(VarCurr,42) ) ).

tff(addAssignment_40789,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,42)
    <=> v68976(VarNext,42) ) ).

tff(addCaseBooleanConditionEqualRanges1_794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68977(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68976(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_794,axiom,
    ! [VarNext: state_type] :
      ( v68977(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68976(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68977(VarNext)
      <=> v68978(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68978(VarNext)
      <=> ( v68980(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68980(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40788,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,42)
    <=> v67389(VarCurr,42) ) ).

tff(addAssignment_40787,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,42)
    <=> v67391(VarCurr,42) ) ).

tff(addAssignment_40786,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,42)
    <=> v68026(VarCurr,2) ) ).

tff(addAssignment_40785,axiom,
    ! [VarCurr: state_type] :
      ( v68026(VarCurr,2)
    <=> v68028(VarCurr,2) ) ).

tff(addAssignment_40784,axiom,
    ! [VarCurr: state_type] :
      ( v68028(VarCurr,2)
    <=> v68045(VarCurr,2) ) ).

tff(addAssignment_40783,axiom,
    ! [VarCurr: state_type] :
      ( v68038(VarCurr,2)
    <=> v68040(VarCurr,2) ) ).

tff(addAssignment_40782,axiom,
    ! [VarCurr: state_type] :
      ( v68040(VarCurr,2)
    <=> v67401(VarCurr,42) ) ).

tff(addAssignment_40781,axiom,
    ! [VarCurr: state_type] :
      ( v68030(VarCurr,2)
    <=> v68032(VarCurr,2) ) ).

tff(addAssignment_40780,axiom,
    ! [VarCurr: state_type] :
      ( v68032(VarCurr,2)
    <=> v67401(VarCurr,46) ) ).

tff(addAssignment_40779,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,46)
    <=> v67403(VarCurr,46) ) ).

tff(addAssignment_40778,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,46)
    <=> v67405(VarCurr,46) ) ).

tff(addAssignment_40777,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,46)
    <=> v67514(VarCurr,46) ) ).

tff(addAssignment_40776,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,46)
    <=> v67428(VarCurr,46) ) ).

tff(addAssignment_40775,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,46)
    <=> v67430(VarCurr,46) ) ).

tff(addAssignment_40774,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,46)
    <=> v67432(VarCurr,46) ) ).

tff(addAssignment_40773,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,46)
    <=> v67434(VarCurr,46) ) ).

tff(addAssignment_40772,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,46)
    <=> v67436(VarCurr,46) ) ).

tff(addAssignment_40771,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,46)
    <=> v67438(VarCurr,46) ) ).

tff(addAssignment_40770,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,46)
    <=> v67497(VarCurr,46) ) ).

tff(addAssignment_40769,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,46)
    <=> v67493(VarCurr,46) ) ).

tff(addAssignment_40768,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,46)
    <=> v67495(VarCurr,46) ) ).

tff(addAssignment_40767,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,46)
    <=> v67496(VarCurr,46) ) ).

tff(addAssignment_40766,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,94)
    <=> v33839(VarCurr,94) ) ).

tff(addAssignment_40765,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,94)
    <=> v33841(VarCurr,94) ) ).

tff(addAssignment_40764,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,94)
    <=> v20355(VarCurr,10) ) ).

tff(addAssignment_40763,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,46)
    <=> v67489(VarCurr,46) ) ).

tff(addAssignment_40762,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,46)
    <=> v6234(VarCurr,46) ) ).

tff(addAssignment_40761,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,46)
    <=> v67485(VarCurr,46) ) ).

tff(addAssignment_40760,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,46)
    <=> $false ) ).

tff(addAssignment_40759,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,46)
    <=> v67409(VarCurr,46) ) ).

tff(addAssignment_40758,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,46)
    <=> v67423(VarCurr,46) ) ).

tff(addAssignment_40757,axiom,
    ! [VarCurr: state_type] :
      ( v68960(VarCurr)
    <=> v68962(VarCurr) ) ).

tff(addAssignment_40756,axiom,
    ! [VarCurr: state_type] :
      ( v68962(VarCurr)
    <=> v67349(VarCurr,38) ) ).

tff(addAssignment_40755,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,38)
    <=> v67351(VarCurr,38) ) ).

tff(addAssignment_40754,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,38)
    <=> v67353(VarCurr,38) ) ).

tff(addAssignment_40753,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,38)
    <=> v67355(VarCurr,38) ) ).

tff(addAssignment_40752,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,38)
    <=> v67357(VarCurr,38) ) ).

tff(addAssignment_40751,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,38)
    <=> v67359(VarCurr,38) ) ).

tff(addAssignment_40750,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,38)
    <=> v67580(VarCurr,38) ) ).

tff(addAssignment_40749,axiom,
    ! [VarCurr: state_type] :
      ( v67603(VarCurr,2)
    <=> v67363(VarCurr,38) ) ).

tff(addAssignment_40748,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,38)
    <=> v67365(VarCurr,38) ) ).

tff(addAssignment_40747,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,38)
    <=> v68964(VarNext,38) ) ).

tff(addCaseBooleanConditionEqualRanges1_793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68965(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68964(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_793,axiom,
    ! [VarNext: state_type] :
      ( v68965(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68964(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68965(VarNext)
      <=> v68966(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68966(VarNext)
      <=> ( v68968(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68968(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40746,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,38)
    <=> v67389(VarCurr,38) ) ).

tff(addAssignment_40745,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,38)
    <=> v67391(VarCurr,38) ) ).

tff(addAssignment_40744,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,38)
    <=> v67986(VarCurr,2) ) ).

tff(addAssignment_40743,axiom,
    ! [VarCurr: state_type] :
      ( v67986(VarCurr,2)
    <=> v67988(VarCurr,2) ) ).

tff(addAssignment_40742,axiom,
    ! [VarCurr: state_type] :
      ( v67988(VarCurr,2)
    <=> v68005(VarCurr,2) ) ).

tff(addAssignment_40741,axiom,
    ! [VarCurr: state_type] :
      ( v67998(VarCurr,2)
    <=> v68000(VarCurr,2) ) ).

tff(addAssignment_40740,axiom,
    ! [VarCurr: state_type] :
      ( v68000(VarCurr,2)
    <=> v67401(VarCurr,38) ) ).

tff(addAssignment_40739,axiom,
    ! [VarCurr: state_type] :
      ( v67990(VarCurr,2)
    <=> v67992(VarCurr,2) ) ).

tff(addAssignment_40738,axiom,
    ! [VarCurr: state_type] :
      ( v67992(VarCurr,2)
    <=> v67401(VarCurr,42) ) ).

tff(addAssignment_40737,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,42)
    <=> v67403(VarCurr,42) ) ).

tff(addAssignment_40736,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,42)
    <=> v67405(VarCurr,42) ) ).

tff(addAssignment_40735,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,42)
    <=> v67514(VarCurr,42) ) ).

tff(addAssignment_40734,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,42)
    <=> v67428(VarCurr,42) ) ).

tff(addAssignment_40733,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,42)
    <=> v67430(VarCurr,42) ) ).

tff(addAssignment_40732,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,42)
    <=> v67432(VarCurr,42) ) ).

tff(addAssignment_40731,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,42)
    <=> v67434(VarCurr,42) ) ).

tff(addAssignment_40730,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,42)
    <=> v67436(VarCurr,42) ) ).

tff(addAssignment_40729,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,42)
    <=> v67438(VarCurr,42) ) ).

tff(addAssignment_40728,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,42)
    <=> v67497(VarCurr,42) ) ).

tff(addAssignment_40727,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,42)
    <=> v67493(VarCurr,42) ) ).

tff(addAssignment_40726,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,42)
    <=> v67495(VarCurr,42) ) ).

tff(addAssignment_40725,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,42)
    <=> v67496(VarCurr,42) ) ).

tff(addAssignment_40724,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,90)
    <=> v33839(VarCurr,90) ) ).

tff(addAssignment_40723,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,90)
    <=> v33841(VarCurr,90) ) ).

tff(addAssignment_40722,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,90)
    <=> v20355(VarCurr,6) ) ).

tff(addAssignment_40721,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,42)
    <=> v67489(VarCurr,42) ) ).

tff(addAssignment_40720,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,42)
    <=> v6234(VarCurr,42) ) ).

tff(addAssignment_40719,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,42)
    <=> v67485(VarCurr,42) ) ).

tff(addAssignment_40718,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,42)
    <=> $false ) ).

tff(addAssignment_40717,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,42)
    <=> v67409(VarCurr,42) ) ).

tff(addAssignment_40716,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,42)
    <=> v67423(VarCurr,42) ) ).

tff(addAssignment_40715,axiom,
    ! [VarCurr: state_type] :
      ( v68784(VarCurr)
    <=> v68786(VarCurr) ) ).

tff(addAssignment_40714,axiom,
    ! [VarCurr: state_type] :
      ( v68786(VarCurr)
    <=> v68788(VarCurr) ) ).

tff(addAssignment_40713,axiom,
    ! [VarCurr: state_type] :
      ( v68788(VarCurr)
    <=> v68790(VarCurr) ) ).

tff(addAssignment_40712,axiom,
    ! [VarCurr: state_type] :
      ( v68790(VarCurr)
    <=> v68792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6323,axiom,
    ! [VarCurr: state_type] :
      ( v68792(VarCurr)
    <=> ( v68938(VarCurr)
      <~> v68890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6322,axiom,
    ! [VarCurr: state_type] :
      ( v68938(VarCurr)
    <=> ( v68794(VarCurr)
      <~> v68842(VarCurr) ) ) ).

tff(addAssignment_40711,axiom,
    ! [VarCurr: state_type] :
      ( v68890(VarCurr)
    <=> v68892(VarCurr) ) ).

tff(addAssignment_40710,axiom,
    ! [VarCurr: state_type] :
      ( v68892(VarCurr)
    <=> v68894(VarCurr) ) ).

tff(addAssignment_40709,axiom,
    ! [VarCurr: state_type] :
      ( v68894(VarCurr)
    <=> v68896(VarCurr) ) ).

tff(addAssignment_40708,axiom,
    ! [VarCurr: state_type] :
      ( v68896(VarCurr)
    <=> v68898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6321,axiom,
    ! [VarCurr: state_type] :
      ( v68898(VarCurr)
    <=> ( v68936(VarCurr)
      <~> v68924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6320,axiom,
    ! [VarCurr: state_type] :
      ( v68936(VarCurr)
    <=> ( v68900(VarCurr)
      <~> v68912(VarCurr) ) ) ).

tff(addAssignment_40707,axiom,
    ! [VarCurr: state_type] :
      ( v68924(VarCurr)
    <=> v68926(VarCurr) ) ).

tff(addAssignment_40706,axiom,
    ! [VarCurr: state_type] :
      ( v68926(VarCurr)
    <=> v67349(VarCurr,34) ) ).

tff(addAssignment_40705,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,34)
    <=> v67351(VarCurr,34) ) ).

tff(addAssignment_40704,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,34)
    <=> v67353(VarCurr,34) ) ).

tff(addAssignment_40703,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,34)
    <=> v67355(VarCurr,34) ) ).

tff(addAssignment_40702,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,34)
    <=> v67357(VarCurr,34) ) ).

tff(addAssignment_40701,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,34)
    <=> v67359(VarCurr,34) ) ).

tff(addAssignment_40700,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,34)
    <=> v67580(VarCurr,34) ) ).

tff(addAssignment_40699,axiom,
    ! [VarCurr: state_type] :
      ( v67604(VarCurr,2)
    <=> v67363(VarCurr,34) ) ).

tff(addAssignment_40698,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,34)
    <=> v67365(VarCurr,34) ) ).

tff(addAssignment_40697,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,34)
    <=> v68928(VarNext,34) ) ).

tff(addCaseBooleanConditionEqualRanges1_792,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68929(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68928(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_792,axiom,
    ! [VarNext: state_type] :
      ( v68929(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68928(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68929(VarNext)
      <=> v68930(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68930(VarNext)
      <=> ( v68932(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68932(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40696,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,34)
    <=> v67389(VarCurr,34) ) ).

tff(addAssignment_40695,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,34)
    <=> v67391(VarCurr,34) ) ).

tff(addAssignment_40694,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,34)
    <=> v67922(VarCurr,2) ) ).

tff(addAssignment_40693,axiom,
    ! [VarCurr: state_type] :
      ( v67922(VarCurr,2)
    <=> v67924(VarCurr,2) ) ).

tff(addAssignment_40692,axiom,
    ! [VarCurr: state_type] :
      ( v67924(VarCurr,2)
    <=> v67941(VarCurr,2) ) ).

tff(addAssignment_40691,axiom,
    ! [VarCurr: state_type] :
      ( v67934(VarCurr,2)
    <=> v67936(VarCurr,2) ) ).

tff(addAssignment_40690,axiom,
    ! [VarCurr: state_type] :
      ( v67936(VarCurr,2)
    <=> v67401(VarCurr,34) ) ).

tff(addAssignment_40689,axiom,
    ! [VarCurr: state_type] :
      ( v67926(VarCurr,2)
    <=> v67928(VarCurr,2) ) ).

tff(addAssignment_40688,axiom,
    ! [VarCurr: state_type] :
      ( v67928(VarCurr,2)
    <=> v67401(VarCurr,38) ) ).

tff(addAssignment_40687,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,38)
    <=> v67403(VarCurr,38) ) ).

tff(addAssignment_40686,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,38)
    <=> v67405(VarCurr,38) ) ).

tff(addAssignment_40685,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,38)
    <=> v67514(VarCurr,38) ) ).

tff(addAssignment_40684,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,38)
    <=> v67428(VarCurr,38) ) ).

tff(addAssignment_40683,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,38)
    <=> v67430(VarCurr,38) ) ).

tff(addAssignment_40682,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,38)
    <=> v67432(VarCurr,38) ) ).

tff(addAssignment_40681,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,38)
    <=> v67434(VarCurr,38) ) ).

tff(addAssignment_40680,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,38)
    <=> v67436(VarCurr,38) ) ).

tff(addAssignment_40679,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,38)
    <=> v67438(VarCurr,38) ) ).

tff(addAssignment_40678,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,38)
    <=> v67497(VarCurr,38) ) ).

tff(addAssignment_40677,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,38)
    <=> v67493(VarCurr,38) ) ).

tff(addAssignment_40676,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,38)
    <=> v67495(VarCurr,38) ) ).

tff(addAssignment_40675,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,38)
    <=> v67496(VarCurr,38) ) ).

tff(addAssignment_40674,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,80)
    <=> v33839(VarCurr,80) ) ).

tff(addAssignment_40673,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,80)
    <=> v33841(VarCurr,80) ) ).

tff(addAssignment_40672,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,80)
    <=> v18805(VarCurr,8) ) ).

tff(addAssignment_40671,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,38)
    <=> v67489(VarCurr,38) ) ).

tff(addAssignment_40670,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,38)
    <=> v6234(VarCurr,38) ) ).

tff(addAssignment_40669,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,38)
    <=> v67485(VarCurr,38) ) ).

tff(addAssignment_40668,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,38)
    <=> $false ) ).

tff(addAssignment_40667,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,38)
    <=> v67409(VarCurr,38) ) ).

tff(addAssignment_40666,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,38)
    <=> v67423(VarCurr,38) ) ).

tff(addAssignment_40665,axiom,
    ! [VarCurr: state_type] :
      ( v68912(VarCurr)
    <=> v68914(VarCurr) ) ).

tff(addAssignment_40664,axiom,
    ! [VarCurr: state_type] :
      ( v68914(VarCurr)
    <=> v67349(VarCurr,30) ) ).

tff(addAssignment_40663,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,30)
    <=> v67351(VarCurr,30) ) ).

tff(addAssignment_40662,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,30)
    <=> v67353(VarCurr,30) ) ).

tff(addAssignment_40661,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,30)
    <=> v67355(VarCurr,30) ) ).

tff(addAssignment_40660,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,30)
    <=> v67357(VarCurr,30) ) ).

tff(addAssignment_40659,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,30)
    <=> v67359(VarCurr,30) ) ).

tff(addAssignment_40658,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,30)
    <=> v67580(VarCurr,30) ) ).

tff(addAssignment_40657,axiom,
    ! [VarCurr: state_type] :
      ( v67605(VarCurr,2)
    <=> v67363(VarCurr,30) ) ).

tff(addAssignment_40656,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,30)
    <=> v67365(VarCurr,30) ) ).

tff(addAssignment_40655,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,30)
    <=> v68916(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68917(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68916(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_791,axiom,
    ! [VarNext: state_type] :
      ( v68917(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68916(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68917(VarNext)
      <=> v68918(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68918(VarNext)
      <=> ( v68920(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68920(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40654,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,30)
    <=> v67389(VarCurr,30) ) ).

tff(addAssignment_40653,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,30)
    <=> v67391(VarCurr,30) ) ).

tff(addAssignment_40652,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,30)
    <=> v67882(VarCurr,2) ) ).

tff(addAssignment_40651,axiom,
    ! [VarCurr: state_type] :
      ( v67882(VarCurr,2)
    <=> v67884(VarCurr,2) ) ).

tff(addAssignment_40650,axiom,
    ! [VarCurr: state_type] :
      ( v67884(VarCurr,2)
    <=> v67901(VarCurr,2) ) ).

tff(addAssignment_40649,axiom,
    ! [VarCurr: state_type] :
      ( v67894(VarCurr,2)
    <=> v67896(VarCurr,2) ) ).

tff(addAssignment_40648,axiom,
    ! [VarCurr: state_type] :
      ( v67896(VarCurr,2)
    <=> v67401(VarCurr,30) ) ).

tff(addAssignment_40647,axiom,
    ! [VarCurr: state_type] :
      ( v67886(VarCurr,2)
    <=> v67888(VarCurr,2) ) ).

tff(addAssignment_40646,axiom,
    ! [VarCurr: state_type] :
      ( v67888(VarCurr,2)
    <=> v67401(VarCurr,34) ) ).

tff(addAssignment_40645,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,34)
    <=> v67403(VarCurr,34) ) ).

tff(addAssignment_40644,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,34)
    <=> v67405(VarCurr,34) ) ).

tff(addAssignment_40643,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,34)
    <=> v67514(VarCurr,34) ) ).

tff(addAssignment_40642,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,34)
    <=> v67428(VarCurr,34) ) ).

tff(addAssignment_40641,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,34)
    <=> v67430(VarCurr,34) ) ).

tff(addAssignment_40640,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,34)
    <=> v67432(VarCurr,34) ) ).

tff(addAssignment_40639,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,34)
    <=> v67434(VarCurr,34) ) ).

tff(addAssignment_40638,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,34)
    <=> v67436(VarCurr,34) ) ).

tff(addAssignment_40637,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,34)
    <=> v67438(VarCurr,34) ) ).

tff(addAssignment_40636,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,34)
    <=> v67497(VarCurr,34) ) ).

tff(addAssignment_40635,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,34)
    <=> v67493(VarCurr,34) ) ).

tff(addAssignment_40634,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,34)
    <=> v67495(VarCurr,34) ) ).

tff(addAssignment_40633,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,34)
    <=> v67496(VarCurr,34) ) ).

tff(addAssignment_40632,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,70)
    <=> v33839(VarCurr,70) ) ).

tff(addAssignment_40631,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,70)
    <=> v33841(VarCurr,70) ) ).

tff(addAssignment_40630,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,70)
    <=> v17255(VarCurr,10) ) ).

tff(addAssignment_40629,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,34)
    <=> v67489(VarCurr,34) ) ).

tff(addAssignment_40628,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,34)
    <=> v6234(VarCurr,34) ) ).

tff(addAssignment_40627,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,34)
    <=> v67485(VarCurr,34) ) ).

tff(addAssignment_40626,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,34)
    <=> $false ) ).

tff(addAssignment_40625,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,34)
    <=> v67409(VarCurr,34) ) ).

tff(addAssignment_40624,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,34)
    <=> v67423(VarCurr,34) ) ).

tff(addAssignment_40623,axiom,
    ! [VarCurr: state_type] :
      ( v68900(VarCurr)
    <=> v68902(VarCurr) ) ).

tff(addAssignment_40622,axiom,
    ! [VarCurr: state_type] :
      ( v68902(VarCurr)
    <=> v67349(VarCurr,26) ) ).

tff(addAssignment_40621,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,26)
    <=> v67351(VarCurr,26) ) ).

tff(addAssignment_40620,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,26)
    <=> v67353(VarCurr,26) ) ).

tff(addAssignment_40619,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,26)
    <=> v67355(VarCurr,26) ) ).

tff(addAssignment_40618,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,26)
    <=> v67357(VarCurr,26) ) ).

tff(addAssignment_40617,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,26)
    <=> v67359(VarCurr,26) ) ).

tff(addAssignment_40616,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,26)
    <=> v67580(VarCurr,26) ) ).

tff(addAssignment_40615,axiom,
    ! [VarCurr: state_type] :
      ( v67606(VarCurr,2)
    <=> v67363(VarCurr,26) ) ).

tff(addAssignment_40614,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,26)
    <=> v67365(VarCurr,26) ) ).

tff(addAssignment_40613,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,26)
    <=> v68904(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68905(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68904(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_790,axiom,
    ! [VarNext: state_type] :
      ( v68905(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68904(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68905(VarNext)
      <=> v68906(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68906(VarNext)
      <=> ( v68908(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68908(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40612,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,26)
    <=> v67389(VarCurr,26) ) ).

tff(addAssignment_40611,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,26)
    <=> v67391(VarCurr,26) ) ).

tff(addAssignment_40610,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,26)
    <=> v67842(VarCurr,2) ) ).

tff(addAssignment_40609,axiom,
    ! [VarCurr: state_type] :
      ( v67842(VarCurr,2)
    <=> v67844(VarCurr,2) ) ).

tff(addAssignment_40608,axiom,
    ! [VarCurr: state_type] :
      ( v67844(VarCurr,2)
    <=> v67861(VarCurr,2) ) ).

tff(addAssignment_40607,axiom,
    ! [VarCurr: state_type] :
      ( v67854(VarCurr,2)
    <=> v67856(VarCurr,2) ) ).

tff(addAssignment_40606,axiom,
    ! [VarCurr: state_type] :
      ( v67856(VarCurr,2)
    <=> v67401(VarCurr,26) ) ).

tff(addAssignment_40605,axiom,
    ! [VarCurr: state_type] :
      ( v67846(VarCurr,2)
    <=> v67848(VarCurr,2) ) ).

tff(addAssignment_40604,axiom,
    ! [VarCurr: state_type] :
      ( v67848(VarCurr,2)
    <=> v67401(VarCurr,30) ) ).

tff(addAssignment_40603,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,30)
    <=> v67403(VarCurr,30) ) ).

tff(addAssignment_40602,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,30)
    <=> v67405(VarCurr,30) ) ).

tff(addAssignment_40601,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,30)
    <=> v67514(VarCurr,30) ) ).

tff(addAssignment_40600,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,30)
    <=> v67428(VarCurr,30) ) ).

tff(addAssignment_40599,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,30)
    <=> v67430(VarCurr,30) ) ).

tff(addAssignment_40598,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,30)
    <=> v67432(VarCurr,30) ) ).

tff(addAssignment_40597,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,30)
    <=> v67434(VarCurr,30) ) ).

tff(addAssignment_40596,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,30)
    <=> v67436(VarCurr,30) ) ).

tff(addAssignment_40595,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,30)
    <=> v67438(VarCurr,30) ) ).

tff(addAssignment_40594,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,30)
    <=> v67497(VarCurr,30) ) ).

tff(addAssignment_40593,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,30)
    <=> v67493(VarCurr,30) ) ).

tff(addAssignment_40592,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,30)
    <=> v67495(VarCurr,30) ) ).

tff(addAssignment_40591,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,30)
    <=> v67496(VarCurr,30) ) ).

tff(addAssignment_40590,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,66)
    <=> v33839(VarCurr,66) ) ).

tff(addAssignment_40589,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,66)
    <=> v33841(VarCurr,66) ) ).

tff(addAssignment_40588,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,66)
    <=> v17255(VarCurr,6) ) ).

tff(addAssignment_40587,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,30)
    <=> v67489(VarCurr,30) ) ).

tff(addAssignment_40586,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,30)
    <=> v6234(VarCurr,30) ) ).

tff(addAssignment_40585,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,30)
    <=> v67485(VarCurr,30) ) ).

tff(addAssignment_40584,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_40583,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,30)
    <=> v67409(VarCurr,30) ) ).

tff(addAssignment_40582,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,30)
    <=> v67423(VarCurr,30) ) ).

tff(addAssignment_40581,axiom,
    ! [VarCurr: state_type] :
      ( v68842(VarCurr)
    <=> v68844(VarCurr) ) ).

tff(addAssignment_40580,axiom,
    ! [VarCurr: state_type] :
      ( v68844(VarCurr)
    <=> v68846(VarCurr) ) ).

tff(addAssignment_40579,axiom,
    ! [VarCurr: state_type] :
      ( v68846(VarCurr)
    <=> v68848(VarCurr) ) ).

tff(addAssignment_40578,axiom,
    ! [VarCurr: state_type] :
      ( v68848(VarCurr)
    <=> v68850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6313,axiom,
    ! [VarCurr: state_type] :
      ( v68850(VarCurr)
    <=> ( v68888(VarCurr)
      <~> v68876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6312,axiom,
    ! [VarCurr: state_type] :
      ( v68888(VarCurr)
    <=> ( v68852(VarCurr)
      <~> v68864(VarCurr) ) ) ).

tff(addAssignment_40577,axiom,
    ! [VarCurr: state_type] :
      ( v68876(VarCurr)
    <=> v68878(VarCurr) ) ).

tff(addAssignment_40576,axiom,
    ! [VarCurr: state_type] :
      ( v68878(VarCurr)
    <=> v67349(VarCurr,22) ) ).

tff(addAssignment_40575,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,22)
    <=> v67351(VarCurr,22) ) ).

tff(addAssignment_40574,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,22)
    <=> v67353(VarCurr,22) ) ).

tff(addAssignment_40573,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,22)
    <=> v67355(VarCurr,22) ) ).

tff(addAssignment_40572,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,22)
    <=> v67357(VarCurr,22) ) ).

tff(addAssignment_40571,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,22)
    <=> v67359(VarCurr,22) ) ).

tff(addAssignment_40570,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,22)
    <=> v67580(VarCurr,22) ) ).

tff(addAssignment_40569,axiom,
    ! [VarCurr: state_type] :
      ( v67607(VarCurr,2)
    <=> v67363(VarCurr,22) ) ).

tff(addAssignment_40568,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,22)
    <=> v67365(VarCurr,22) ) ).

tff(addAssignment_40567,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,22)
    <=> v68880(VarNext,22) ) ).

tff(addCaseBooleanConditionEqualRanges1_789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68881(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68880(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_789,axiom,
    ! [VarNext: state_type] :
      ( v68881(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68880(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68881(VarNext)
      <=> v68882(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68882(VarNext)
      <=> ( v68884(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68884(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40566,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,22)
    <=> v67389(VarCurr,22) ) ).

tff(addAssignment_40565,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,22)
    <=> v67391(VarCurr,22) ) ).

tff(addAssignment_40564,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,22)
    <=> v67790(VarCurr,2) ) ).

tff(addAssignment_40563,axiom,
    ! [VarCurr: state_type] :
      ( v67790(VarCurr,2)
    <=> v67792(VarCurr,2) ) ).

tff(addAssignment_40562,axiom,
    ! [VarCurr: state_type] :
      ( v67792(VarCurr,2)
    <=> v67809(VarCurr,2) ) ).

tff(addAssignment_40561,axiom,
    ! [VarCurr: state_type] :
      ( v67802(VarCurr,2)
    <=> v67804(VarCurr,2) ) ).

tff(addAssignment_40560,axiom,
    ! [VarCurr: state_type] :
      ( v67804(VarCurr,2)
    <=> v67401(VarCurr,22) ) ).

tff(addAssignment_40559,axiom,
    ! [VarCurr: state_type] :
      ( v67794(VarCurr,2)
    <=> v67796(VarCurr,2) ) ).

tff(addAssignment_40558,axiom,
    ! [VarCurr: state_type] :
      ( v67796(VarCurr,2)
    <=> v67401(VarCurr,26) ) ).

tff(addAssignment_40557,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,26)
    <=> v67403(VarCurr,26) ) ).

tff(addAssignment_40556,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,26)
    <=> v67405(VarCurr,26) ) ).

tff(addAssignment_40555,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,26)
    <=> v67514(VarCurr,26) ) ).

tff(addAssignment_40554,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,26)
    <=> v67428(VarCurr,26) ) ).

tff(addAssignment_40553,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,26)
    <=> v67430(VarCurr,26) ) ).

tff(addAssignment_40552,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,26)
    <=> v67432(VarCurr,26) ) ).

tff(addAssignment_40551,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,26)
    <=> v67434(VarCurr,26) ) ).

tff(addAssignment_40550,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,26)
    <=> v67436(VarCurr,26) ) ).

tff(addAssignment_40549,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,26)
    <=> v67438(VarCurr,26) ) ).

tff(addAssignment_40548,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,26)
    <=> v67497(VarCurr,26) ) ).

tff(addAssignment_40547,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,26)
    <=> v67493(VarCurr,26) ) ).

tff(addAssignment_40546,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,26)
    <=> v67495(VarCurr,26) ) ).

tff(addAssignment_40545,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,26)
    <=> v67496(VarCurr,26) ) ).

tff(addAssignment_40544,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,56)
    <=> v33839(VarCurr,56) ) ).

tff(addAssignment_40543,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,56)
    <=> v33841(VarCurr,56) ) ).

tff(addAssignment_40542,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,56)
    <=> v15705(VarCurr,8) ) ).

tff(addAssignment_40541,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,26)
    <=> v67489(VarCurr,26) ) ).

tff(addAssignment_40540,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,26)
    <=> v6234(VarCurr,26) ) ).

tff(addAssignment_40539,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,26)
    <=> v67485(VarCurr,26) ) ).

tff(addAssignment_40538,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,26)
    <=> $false ) ).

tff(addAssignment_40537,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,26)
    <=> v67409(VarCurr,26) ) ).

tff(addAssignment_40536,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,26)
    <=> v67423(VarCurr,26) ) ).

tff(addAssignment_40535,axiom,
    ! [VarCurr: state_type] :
      ( v68864(VarCurr)
    <=> v68866(VarCurr) ) ).

tff(addAssignment_40534,axiom,
    ! [VarCurr: state_type] :
      ( v68866(VarCurr)
    <=> v67349(VarCurr,18) ) ).

tff(addAssignment_40533,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,18)
    <=> v67351(VarCurr,18) ) ).

tff(addAssignment_40532,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,18)
    <=> v67353(VarCurr,18) ) ).

tff(addAssignment_40531,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,18)
    <=> v67355(VarCurr,18) ) ).

tff(addAssignment_40530,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,18)
    <=> v67357(VarCurr,18) ) ).

tff(addAssignment_40529,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,18)
    <=> v67359(VarCurr,18) ) ).

tff(addAssignment_40528,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,18)
    <=> v67580(VarCurr,18) ) ).

tff(addAssignment_40527,axiom,
    ! [VarCurr: state_type] :
      ( v67608(VarCurr,2)
    <=> v67363(VarCurr,18) ) ).

tff(addAssignment_40526,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,18)
    <=> v67365(VarCurr,18) ) ).

tff(addAssignment_40525,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,18)
    <=> v68868(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68869(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68868(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_788,axiom,
    ! [VarNext: state_type] :
      ( v68869(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68868(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68869(VarNext)
      <=> v68870(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68870(VarNext)
      <=> ( v68872(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68872(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40524,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,18)
    <=> v67389(VarCurr,18) ) ).

tff(addAssignment_40523,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,18)
    <=> v67391(VarCurr,18) ) ).

tff(addAssignment_40522,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,18)
    <=> v67750(VarCurr,2) ) ).

tff(addAssignment_40521,axiom,
    ! [VarCurr: state_type] :
      ( v67750(VarCurr,2)
    <=> v67752(VarCurr,2) ) ).

tff(addAssignment_40520,axiom,
    ! [VarCurr: state_type] :
      ( v67752(VarCurr,2)
    <=> v67769(VarCurr,2) ) ).

tff(addAssignment_40519,axiom,
    ! [VarCurr: state_type] :
      ( v67762(VarCurr,2)
    <=> v67764(VarCurr,2) ) ).

tff(addAssignment_40518,axiom,
    ! [VarCurr: state_type] :
      ( v67764(VarCurr,2)
    <=> v67401(VarCurr,18) ) ).

tff(addAssignment_40517,axiom,
    ! [VarCurr: state_type] :
      ( v67754(VarCurr,2)
    <=> v67756(VarCurr,2) ) ).

tff(addAssignment_40516,axiom,
    ! [VarCurr: state_type] :
      ( v67756(VarCurr,2)
    <=> v67401(VarCurr,22) ) ).

tff(addAssignment_40515,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,22)
    <=> v67403(VarCurr,22) ) ).

tff(addAssignment_40514,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,22)
    <=> v67405(VarCurr,22) ) ).

tff(addAssignment_40513,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,22)
    <=> v67514(VarCurr,22) ) ).

tff(addAssignment_40512,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,22)
    <=> v67428(VarCurr,22) ) ).

tff(addAssignment_40511,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,22)
    <=> v67430(VarCurr,22) ) ).

tff(addAssignment_40510,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,22)
    <=> v67432(VarCurr,22) ) ).

tff(addAssignment_40509,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,22)
    <=> v67434(VarCurr,22) ) ).

tff(addAssignment_40508,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,22)
    <=> v67436(VarCurr,22) ) ).

tff(addAssignment_40507,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,22)
    <=> v67438(VarCurr,22) ) ).

tff(addAssignment_40506,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,22)
    <=> v67497(VarCurr,22) ) ).

tff(addAssignment_40505,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,22)
    <=> v67493(VarCurr,22) ) ).

tff(addAssignment_40504,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,22)
    <=> v67495(VarCurr,22) ) ).

tff(addAssignment_40503,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,22)
    <=> v67496(VarCurr,22) ) ).

tff(addAssignment_40502,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,46)
    <=> v33839(VarCurr,46) ) ).

tff(addAssignment_40501,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,46)
    <=> v33841(VarCurr,46) ) ).

tff(addAssignment_40500,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,46)
    <=> v14155(VarCurr,10) ) ).

tff(addAssignment_40499,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,22)
    <=> v67489(VarCurr,22) ) ).

tff(addAssignment_40498,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,22)
    <=> v6234(VarCurr,22) ) ).

tff(addAssignment_40497,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,22)
    <=> v67485(VarCurr,22) ) ).

tff(addAssignment_40496,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,22)
    <=> $false ) ).

tff(addAssignment_40495,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,22)
    <=> v67409(VarCurr,22) ) ).

tff(addAssignment_40494,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,22)
    <=> v67423(VarCurr,22) ) ).

tff(addAssignment_40493,axiom,
    ! [VarCurr: state_type] :
      ( v68852(VarCurr)
    <=> v68854(VarCurr) ) ).

tff(addAssignment_40492,axiom,
    ! [VarCurr: state_type] :
      ( v68854(VarCurr)
    <=> v67349(VarCurr,14) ) ).

tff(addAssignment_40491,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,14)
    <=> v67351(VarCurr,14) ) ).

tff(addAssignment_40490,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,14)
    <=> v67353(VarCurr,14) ) ).

tff(addAssignment_40489,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,14)
    <=> v67355(VarCurr,14) ) ).

tff(addAssignment_40488,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,14)
    <=> v67357(VarCurr,14) ) ).

tff(addAssignment_40487,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,14)
    <=> v67359(VarCurr,14) ) ).

tff(addAssignment_40486,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,14)
    <=> v67580(VarCurr,14) ) ).

tff(addAssignment_40485,axiom,
    ! [VarCurr: state_type] :
      ( v67609(VarCurr,2)
    <=> v67363(VarCurr,14) ) ).

tff(addAssignment_40484,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,14)
    <=> v67365(VarCurr,14) ) ).

tff(addAssignment_40483,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,14)
    <=> v68856(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68857(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68856(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_787,axiom,
    ! [VarNext: state_type] :
      ( v68857(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68856(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68857(VarNext)
      <=> v68858(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68858(VarNext)
      <=> ( v68860(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68860(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40482,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,14)
    <=> v67389(VarCurr,14) ) ).

tff(addAssignment_40481,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,14)
    <=> v67391(VarCurr,14) ) ).

tff(addAssignment_40480,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,14)
    <=> v67710(VarCurr,2) ) ).

tff(addAssignment_40479,axiom,
    ! [VarCurr: state_type] :
      ( v67710(VarCurr,2)
    <=> v67712(VarCurr,2) ) ).

tff(addAssignment_40478,axiom,
    ! [VarCurr: state_type] :
      ( v67712(VarCurr,2)
    <=> v67729(VarCurr,2) ) ).

tff(addAssignment_40477,axiom,
    ! [VarCurr: state_type] :
      ( v67722(VarCurr,2)
    <=> v67724(VarCurr,2) ) ).

tff(addAssignment_40476,axiom,
    ! [VarCurr: state_type] :
      ( v67724(VarCurr,2)
    <=> v67401(VarCurr,14) ) ).

tff(addAssignment_40475,axiom,
    ! [VarCurr: state_type] :
      ( v67714(VarCurr,2)
    <=> v67716(VarCurr,2) ) ).

tff(addAssignment_40474,axiom,
    ! [VarCurr: state_type] :
      ( v67716(VarCurr,2)
    <=> v67401(VarCurr,18) ) ).

tff(addAssignment_40473,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,18)
    <=> v67403(VarCurr,18) ) ).

tff(addAssignment_40472,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,18)
    <=> v67405(VarCurr,18) ) ).

tff(addAssignment_40471,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,18)
    <=> v67514(VarCurr,18) ) ).

tff(addAssignment_40470,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,18)
    <=> v67428(VarCurr,18) ) ).

tff(addAssignment_40469,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,18)
    <=> v67430(VarCurr,18) ) ).

tff(addAssignment_40468,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,18)
    <=> v67432(VarCurr,18) ) ).

tff(addAssignment_40467,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,18)
    <=> v67434(VarCurr,18) ) ).

tff(addAssignment_40466,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,18)
    <=> v67436(VarCurr,18) ) ).

tff(addAssignment_40465,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,18)
    <=> v67438(VarCurr,18) ) ).

tff(addAssignment_40464,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,18)
    <=> v67497(VarCurr,18) ) ).

tff(addAssignment_40463,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,18)
    <=> v67493(VarCurr,18) ) ).

tff(addAssignment_40462,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,18)
    <=> v67495(VarCurr,18) ) ).

tff(addAssignment_40461,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,18)
    <=> v67496(VarCurr,18) ) ).

tff(addAssignment_40460,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,42)
    <=> v33839(VarCurr,42) ) ).

tff(addAssignment_40459,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,42)
    <=> v33841(VarCurr,42) ) ).

tff(addAssignment_40458,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,42)
    <=> v14155(VarCurr,6) ) ).

tff(addAssignment_40457,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,18)
    <=> v67489(VarCurr,18) ) ).

tff(addAssignment_40456,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,18)
    <=> v6234(VarCurr,18) ) ).

tff(addAssignment_40455,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,18)
    <=> v67485(VarCurr,18) ) ).

tff(addAssignment_40454,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,18)
    <=> $false ) ).

tff(addAssignment_40453,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,18)
    <=> v67409(VarCurr,18) ) ).

tff(addAssignment_40452,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,18)
    <=> v67423(VarCurr,18) ) ).

tff(addAssignment_40451,axiom,
    ! [VarCurr: state_type] :
      ( v68794(VarCurr)
    <=> v68796(VarCurr) ) ).

tff(addAssignment_40450,axiom,
    ! [VarCurr: state_type] :
      ( v68796(VarCurr)
    <=> v68798(VarCurr) ) ).

tff(addAssignment_40449,axiom,
    ! [VarCurr: state_type] :
      ( v68798(VarCurr)
    <=> v68800(VarCurr) ) ).

tff(addAssignment_40448,axiom,
    ! [VarCurr: state_type] :
      ( v68800(VarCurr)
    <=> v68802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6305,axiom,
    ! [VarCurr: state_type] :
      ( v68802(VarCurr)
    <=> ( v68840(VarCurr)
      <~> v68828(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6304,axiom,
    ! [VarCurr: state_type] :
      ( v68840(VarCurr)
    <=> ( v68804(VarCurr)
      <~> v68816(VarCurr) ) ) ).

tff(addAssignment_40447,axiom,
    ! [VarCurr: state_type] :
      ( v68828(VarCurr)
    <=> v68830(VarCurr) ) ).

tff(addAssignment_40446,axiom,
    ! [VarCurr: state_type] :
      ( v68830(VarCurr)
    <=> v67349(VarCurr,10) ) ).

tff(addAssignment_40445,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,10)
    <=> v67351(VarCurr,10) ) ).

tff(addAssignment_40444,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,10)
    <=> v67353(VarCurr,10) ) ).

tff(addAssignment_40443,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,10)
    <=> v67355(VarCurr,10) ) ).

tff(addAssignment_40442,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,10)
    <=> v67357(VarCurr,10) ) ).

tff(addAssignment_40441,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,10)
    <=> v67359(VarCurr,10) ) ).

tff(addAssignment_40440,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,10)
    <=> v67580(VarCurr,10) ) ).

tff(addAssignment_40439,axiom,
    ! [VarCurr: state_type] :
      ( v67610(VarCurr,2)
    <=> v67363(VarCurr,10) ) ).

tff(addAssignment_40438,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,10)
    <=> v67365(VarCurr,10) ) ).

tff(addAssignment_40437,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,10)
    <=> v68832(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68833(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68832(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_786,axiom,
    ! [VarNext: state_type] :
      ( v68833(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68832(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68833(VarNext)
      <=> v68834(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68834(VarNext)
      <=> ( v68836(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68836(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40436,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,10)
    <=> v67389(VarCurr,10) ) ).

tff(addAssignment_40435,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,10)
    <=> v67391(VarCurr,10) ) ).

tff(addAssignment_40434,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,10)
    <=> v67658(VarCurr,2) ) ).

tff(addAssignment_40433,axiom,
    ! [VarCurr: state_type] :
      ( v67658(VarCurr,2)
    <=> v67660(VarCurr,2) ) ).

tff(addAssignment_40432,axiom,
    ! [VarCurr: state_type] :
      ( v67660(VarCurr,2)
    <=> v67677(VarCurr,2) ) ).

tff(addAssignment_40431,axiom,
    ! [VarCurr: state_type] :
      ( v67670(VarCurr,2)
    <=> v67672(VarCurr,2) ) ).

tff(addAssignment_40430,axiom,
    ! [VarCurr: state_type] :
      ( v67672(VarCurr,2)
    <=> v67401(VarCurr,10) ) ).

tff(addAssignment_40429,axiom,
    ! [VarCurr: state_type] :
      ( v67662(VarCurr,2)
    <=> v67664(VarCurr,2) ) ).

tff(addAssignment_40428,axiom,
    ! [VarCurr: state_type] :
      ( v67664(VarCurr,2)
    <=> v67401(VarCurr,14) ) ).

tff(addAssignment_40427,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,14)
    <=> v67403(VarCurr,14) ) ).

tff(addAssignment_40426,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,14)
    <=> v67405(VarCurr,14) ) ).

tff(addAssignment_40425,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,14)
    <=> v67514(VarCurr,14) ) ).

tff(addAssignment_40424,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,14)
    <=> v67428(VarCurr,14) ) ).

tff(addAssignment_40423,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,14)
    <=> v67430(VarCurr,14) ) ).

tff(addAssignment_40422,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,14)
    <=> v67432(VarCurr,14) ) ).

tff(addAssignment_40421,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,14)
    <=> v67434(VarCurr,14) ) ).

tff(addAssignment_40420,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,14)
    <=> v67436(VarCurr,14) ) ).

tff(addAssignment_40419,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,14)
    <=> v67438(VarCurr,14) ) ).

tff(addAssignment_40418,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,14)
    <=> v67497(VarCurr,14) ) ).

tff(addAssignment_40417,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,14)
    <=> v67493(VarCurr,14) ) ).

tff(addAssignment_40416,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,14)
    <=> v67495(VarCurr,14) ) ).

tff(addAssignment_40415,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,14)
    <=> v67496(VarCurr,14) ) ).

tff(addAssignment_40414,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,32)
    <=> v33839(VarCurr,32) ) ).

tff(addAssignment_40413,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,14)
    <=> v67489(VarCurr,14) ) ).

tff(addAssignment_40412,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,14)
    <=> v6234(VarCurr,14) ) ).

tff(addAssignment_40411,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,14)
    <=> v67485(VarCurr,14) ) ).

tff(addAssignment_40410,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_40409,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,14)
    <=> v67409(VarCurr,14) ) ).

tff(addAssignment_40408,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,14)
    <=> v67423(VarCurr,14) ) ).

tff(addAssignment_40407,axiom,
    ! [VarCurr: state_type] :
      ( v68816(VarCurr)
    <=> v68818(VarCurr) ) ).

tff(addAssignment_40406,axiom,
    ! [VarCurr: state_type] :
      ( v68818(VarCurr)
    <=> v67349(VarCurr,6) ) ).

tff(addAssignment_40405,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,6)
    <=> v67351(VarCurr,6) ) ).

tff(addAssignment_40404,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,6)
    <=> v67353(VarCurr,6) ) ).

tff(addAssignment_40403,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,6)
    <=> v67355(VarCurr,6) ) ).

tff(addAssignment_40402,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,6)
    <=> v67357(VarCurr,6) ) ).

tff(addAssignment_40401,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,6)
    <=> v67359(VarCurr,6) ) ).

tff(addAssignment_40400,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,6)
    <=> v67580(VarCurr,6) ) ).

tff(addAssignment_40399,axiom,
    ! [VarCurr: state_type] :
      ( v67611(VarCurr,2)
    <=> v67363(VarCurr,6) ) ).

tff(addAssignment_40398,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,6)
    <=> v67365(VarCurr,6) ) ).

tff(addAssignment_40397,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,6)
    <=> v68820(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68821(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68820(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_785,axiom,
    ! [VarNext: state_type] :
      ( v68821(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68820(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68821(VarNext)
      <=> v68822(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68822(VarNext)
      <=> ( v68824(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68824(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40396,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,6)
    <=> v67389(VarCurr,6) ) ).

tff(addAssignment_40395,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,6)
    <=> v67391(VarCurr,6) ) ).

tff(addAssignment_40394,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,6)
    <=> v67618(VarCurr,2) ) ).

tff(addAssignment_40393,axiom,
    ! [VarCurr: state_type] :
      ( v67618(VarCurr,2)
    <=> v67620(VarCurr,2) ) ).

tff(addAssignment_40392,axiom,
    ! [VarCurr: state_type] :
      ( v67620(VarCurr,2)
    <=> v67637(VarCurr,2) ) ).

tff(addAssignment_40391,axiom,
    ! [VarCurr: state_type] :
      ( v67630(VarCurr,2)
    <=> v67632(VarCurr,2) ) ).

tff(addAssignment_40390,axiom,
    ! [VarCurr: state_type] :
      ( v67632(VarCurr,2)
    <=> v67401(VarCurr,6) ) ).

tff(addAssignment_40389,axiom,
    ! [VarCurr: state_type] :
      ( v67622(VarCurr,2)
    <=> v67624(VarCurr,2) ) ).

tff(addAssignment_40388,axiom,
    ! [VarCurr: state_type] :
      ( v67624(VarCurr,2)
    <=> v67401(VarCurr,10) ) ).

tff(addAssignment_40387,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,10)
    <=> v67403(VarCurr,10) ) ).

tff(addAssignment_40386,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,10)
    <=> v67405(VarCurr,10) ) ).

tff(addAssignment_40385,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,10)
    <=> v67514(VarCurr,10) ) ).

tff(addAssignment_40384,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,10)
    <=> v67428(VarCurr,10) ) ).

tff(addAssignment_40383,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,10)
    <=> v67430(VarCurr,10) ) ).

tff(addAssignment_40382,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,10)
    <=> v67432(VarCurr,10) ) ).

tff(addAssignment_40381,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,10)
    <=> v67434(VarCurr,10) ) ).

tff(addAssignment_40380,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,10)
    <=> v67436(VarCurr,10) ) ).

tff(addAssignment_40379,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,10)
    <=> v67438(VarCurr,10) ) ).

tff(addAssignment_40378,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,10)
    <=> v67497(VarCurr,10) ) ).

tff(addAssignment_40377,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,10)
    <=> v67493(VarCurr,10) ) ).

tff(addAssignment_40376,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,10)
    <=> v67495(VarCurr,10) ) ).

tff(addAssignment_40375,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,10)
    <=> v67496(VarCurr,10) ) ).

tff(addAssignment_40374,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,22)
    <=> v33839(VarCurr,22) ) ).

tff(addAssignment_40373,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,10)
    <=> v67489(VarCurr,10) ) ).

tff(addAssignment_40372,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,10)
    <=> v6234(VarCurr,10) ) ).

tff(addAssignment_40371,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,10)
    <=> v67485(VarCurr,10) ) ).

tff(addAssignment_40370,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_40369,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,10)
    <=> v67409(VarCurr,10) ) ).

tff(addAssignment_40368,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,10)
    <=> v67423(VarCurr,10) ) ).

tff(addAssignment_40367,axiom,
    ! [VarCurr: state_type] :
      ( v68804(VarCurr)
    <=> v68806(VarCurr) ) ).

tff(addAssignment_40366,axiom,
    ! [VarCurr: state_type] :
      ( v68806(VarCurr)
    <=> v67349(VarCurr,2) ) ).

tff(addAssignment_40365,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,2)
    <=> v67351(VarCurr,2) ) ).

tff(addAssignment_40364,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,2)
    <=> v67353(VarCurr,2) ) ).

tff(addAssignment_40363,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,2)
    <=> v67355(VarCurr,2) ) ).

tff(addAssignment_40362,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,2)
    <=> v67357(VarCurr,2) ) ).

tff(addAssignment_40361,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,2)
    <=> v67359(VarCurr,2) ) ).

tff(addAssignment_40360,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,2)
    <=> v67580(VarCurr,2) ) ).

tff(addAssignment_40359,axiom,
    ! [VarCurr: state_type] :
      ( v67361(VarCurr,2)
    <=> v67363(VarCurr,2) ) ).

tff(addAssignment_40358,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,2)
    <=> v67365(VarCurr,2) ) ).

tff(addAssignment_40357,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,2)
    <=> v68808(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68809(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68808(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_784,axiom,
    ! [VarNext: state_type] :
      ( v68809(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68808(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68809(VarNext)
      <=> v68810(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68810(VarNext)
      <=> ( v68812(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68812(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_40356,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,2)
    <=> v67389(VarCurr,2) ) ).

tff(addAssignment_40355,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,2)
    <=> v67391(VarCurr,2) ) ).

tff(addAssignment_40354,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,2)
    <=> v67393(VarCurr,2) ) ).

tff(addAssignment_40353,axiom,
    ! [VarCurr: state_type] :
      ( v67393(VarCurr,2)
    <=> v67395(VarCurr,2) ) ).

tff(addAssignment_40352,axiom,
    ! [VarCurr: state_type] :
      ( v67395(VarCurr,2)
    <=> v67531(VarCurr,2) ) ).

tff(addAssignment_40351,axiom,
    ! [VarCurr: state_type] :
      ( v67522(VarCurr,2)
    <=> v67524(VarCurr,2) ) ).

tff(addAssignment_40350,axiom,
    ! [VarCurr: state_type] :
      ( v67524(VarCurr,2)
    <=> v67401(VarCurr,2) ) ).

tff(addAssignment_40349,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,2)
    <=> v67403(VarCurr,2) ) ).

tff(addAssignment_40348,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,2)
    <=> v67405(VarCurr,2) ) ).

tff(addAssignment_40347,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,2)
    <=> v67514(VarCurr,2) ) ).

tff(addAssignment_40346,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,2)
    <=> v67428(VarCurr,2) ) ).

tff(addAssignment_40345,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,2)
    <=> v67430(VarCurr,2) ) ).

tff(addAssignment_40344,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,2)
    <=> v67432(VarCurr,2) ) ).

tff(addAssignment_40343,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,2)
    <=> v67434(VarCurr,2) ) ).

tff(addAssignment_40342,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,2)
    <=> v67436(VarCurr,2) ) ).

tff(addAssignment_40341,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,2)
    <=> v67438(VarCurr,2) ) ).

tff(addAssignment_40340,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,2)
    <=> v67497(VarCurr,2) ) ).

tff(addAssignment_40339,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,2)
    <=> v67493(VarCurr,2) ) ).

tff(addAssignment_40338,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,2)
    <=> v67495(VarCurr,2) ) ).

tff(addAssignment_40337,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,2)
    <=> v67496(VarCurr,2) ) ).

tff(addAssignment_40336,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,8)
    <=> v33839(VarCurr,8) ) ).

tff(addAssignment_40335,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,2)
    <=> v67489(VarCurr,2) ) ).

tff(addAssignment_40334,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,2)
    <=> v6234(VarCurr,2) ) ).

tff(addAssignment_40333,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,2)
    <=> v67485(VarCurr,2) ) ).

tff(addAssignment_40332,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_40331,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,2)
    <=> v67409(VarCurr,2) ) ).

tff(addAssignment_40330,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,2)
    <=> v67423(VarCurr,2) ) ).

tff(addAssignment_40329,axiom,
    ! [VarCurr: state_type] :
      ( v67397(VarCurr,2)
    <=> v67399(VarCurr,2) ) ).

tff(addAssignment_40328,axiom,
    ! [VarCurr: state_type] :
      ( v67399(VarCurr,2)
    <=> v67401(VarCurr,6) ) ).

tff(addAssignment_40327,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,6)
    <=> v67403(VarCurr,6) ) ).

tff(addAssignment_40326,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,6)
    <=> v67405(VarCurr,6) ) ).

tff(addAssignment_40325,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,6)
    <=> v67514(VarCurr,6) ) ).

tff(addAssignment_40324,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,6)
    <=> v67428(VarCurr,6) ) ).

tff(addAssignment_40323,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,6)
    <=> v67430(VarCurr,6) ) ).

tff(addAssignment_40322,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,6)
    <=> v67432(VarCurr,6) ) ).

tff(addAssignment_40321,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,6)
    <=> v67434(VarCurr,6) ) ).

tff(addAssignment_40320,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,6)
    <=> v67436(VarCurr,6) ) ).

tff(addAssignment_40319,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,6)
    <=> v67438(VarCurr,6) ) ).

tff(addAssignment_40318,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,6)
    <=> v67497(VarCurr,6) ) ).

tff(addAssignment_40317,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,6)
    <=> v67493(VarCurr,6) ) ).

tff(addAssignment_40316,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,6)
    <=> v67495(VarCurr,6) ) ).

tff(addAssignment_40315,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,6)
    <=> v67496(VarCurr,6) ) ).

tff(addAssignment_40314,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,18)
    <=> v33839(VarCurr,18) ) ).

tff(addAssignment_40313,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,6)
    <=> v67489(VarCurr,6) ) ).

tff(addAssignment_40312,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,6)
    <=> v6234(VarCurr,6) ) ).

tff(addAssignment_40311,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,6)
    <=> v67485(VarCurr,6) ) ).

tff(addAssignment_40310,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_40309,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,6)
    <=> v67409(VarCurr,6) ) ).

tff(addAssignment_40308,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,6)
    <=> v67423(VarCurr,6) ) ).

tff(addAssignment_40307,axiom,
    ! [VarCurr: state_type] :
      ( v67303(VarCurr)
    <=> v67305(VarCurr) ) ).

tff(addAssignment_40306,axiom,
    ! [VarCurr: state_type] :
      ( v67305(VarCurr)
    <=> v67307(VarCurr,3) ) ).

tff(addAssignment_40305,axiom,
    ! [VarCurr: state_type] :
      ( v67307(VarCurr,3)
    <=> v67309(VarCurr,11) ) ).

tff(addAssignment_40304,axiom,
    ! [VarCurr: state_type] :
      ( v67309(VarCurr,11)
    <=> v67311(VarCurr,11) ) ).

tff(addAssignment_40303,axiom,
    ! [VarCurr: state_type] :
      ( v67311(VarCurr,11)
    <=> v67313(VarCurr,11) ) ).

tff(addAssignment_40302,axiom,
    ! [VarCurr: state_type] :
      ( v67313(VarCurr,11)
    <=> v67315(VarCurr,11) ) ).

tff(addAssignment_40301,axiom,
    ! [VarCurr: state_type] :
      ( v67315(VarCurr,11)
    <=> v67317(VarCurr,11) ) ).

tff(addAssignment_40300,axiom,
    ! [VarCurr: state_type] :
      ( v67317(VarCurr,11)
    <=> v68771(VarCurr,11) ) ).

tff(addAssignment_40299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68771(VarCurr,B)
      <=> v68774(VarCurr,B) ) ) ).

tff(addAssignment_40298,axiom,
    ! [VarCurr: state_type] :
      ( ( v68771(VarCurr,7)
      <=> v68773(VarCurr,3) )
      & ( v68771(VarCurr,6)
      <=> v68773(VarCurr,2) )
      & ( v68771(VarCurr,5)
      <=> v68773(VarCurr,1) )
      & ( v68771(VarCurr,4)
      <=> v68773(VarCurr,0) ) ) ).

tff(addAssignment_40297,axiom,
    ! [VarCurr: state_type] :
      ( ( v68771(VarCurr,11)
      <=> v67319(VarCurr,3) )
      & ( v68771(VarCurr,10)
      <=> v67319(VarCurr,2) )
      & ( v68771(VarCurr,9)
      <=> v67319(VarCurr,1) )
      & ( v68771(VarCurr,8)
      <=> v67319(VarCurr,0) ) ) ).

tff(addAssignment_40296,axiom,
    ! [VarCurr: state_type] :
      ( ( v68771(VarCurr,15)
      <=> v68772(VarCurr,3) )
      & ( v68771(VarCurr,14)
      <=> v68772(VarCurr,2) )
      & ( v68771(VarCurr,13)
      <=> v68772(VarCurr,1) )
      & ( v68771(VarCurr,12)
      <=> v68772(VarCurr,0) ) ) ).

tff(addAssignment_40295,axiom,
    ! [VarCurr: state_type] :
      ( v67319(VarCurr,3)
    <=> v67321(VarCurr) ) ).

tff(addAssignment_40294,axiom,
    ! [VarCurr: state_type] :
      ( v67321(VarCurr)
    <=> v67323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6297,axiom,
    ! [VarCurr: state_type] :
      ( v67323(VarCurr)
    <=> ( v68770(VarCurr)
      <~> v68668(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6296,axiom,
    ! [VarCurr: state_type] :
      ( v68770(VarCurr)
    <=> ( v67325(VarCurr)
      <~> v67961(VarCurr) ) ) ).

tff(addAssignment_40293,axiom,
    ! [VarCurr: state_type] :
      ( v68668(VarCurr)
    <=> v68670(VarCurr) ) ).

tff(addAssignment_40292,axiom,
    ! [VarCurr: state_type] :
      ( v68670(VarCurr)
    <=> v68672(VarCurr,3) ) ).

tff(addAssignment_40291,axiom,
    ! [VarCurr: state_type] :
      ( v68672(VarCurr,3)
    <=> v68674(VarCurr,3) ) ).

tff(addAssignment_40290,axiom,
    ! [VarCurr: state_type] :
      ( v68674(VarCurr,3)
    <=> v68676(VarCurr,3) ) ).

tff(addAssignment_40289,axiom,
    ! [VarCurr: state_type] :
      ( v68676(VarCurr,3)
    <=> v68678(VarCurr,3) ) ).

tff(addAssignment_40288,axiom,
    ! [VarNext: state_type] :
      ( v68678(VarNext,3)
    <=> v68752(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68753(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v68752(VarNext,B)
            <=> v68678(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_783,axiom,
    ! [VarNext: state_type] :
      ( v68753(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v68752(VarNext,B)
          <=> v68763(VarNext,B) ) ) ) ).

tff(addAssignment_40287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v68763(VarNext,B)
          <=> v68761(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v68761(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_404,axiom,
    ! [VarCurr: state_type] :
      ( v68764(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v68761(VarCurr,B)
          <=> v68700(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6295,axiom,
    ! [VarCurr: state_type] :
      ( v68764(VarCurr)
    <=> ( v68765(VarCurr)
        & v68766(VarCurr) ) ) ).

tff(writeUnaryOperator_3311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68766(VarCurr)
    <=> v68690(VarCurr) ) ).

tff(writeUnaryOperator_3310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68765(VarCurr)
    <=> v68680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68753(VarNext)
      <=> v68754(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68754(VarNext)
      <=> ( v68755(VarNext)
          & v68734(VarNext) ) ) ) ).

tff(writeUnaryOperator_3309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68755(VarNext)
      <=> v68757(VarNext) ) ) ).

tff(addAssignment_40286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68757(VarNext)
      <=> v68734(VarCurr) ) ) ).

tff(addAssignment_40285,axiom,
    ! [VarCurr: state_type] :
      ( v68734(VarCurr)
    <=> v68736(VarCurr) ) ).

tff(addAssignment_40284,axiom,
    ! [VarCurr: state_type] :
      ( v68736(VarCurr)
    <=> v68738(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6292,axiom,
    ! [VarCurr: state_type] :
      ( v68738(VarCurr)
    <=> ( v68750(VarCurr)
        | v68746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6291,axiom,
    ! [VarCurr: state_type] :
      ( v68750(VarCurr)
    <=> ( v68740(VarCurr)
        & v68744(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_237,axiom,
    ( v68744(constB0)
  <=> $true ) ).

tff(addAssignment_40283,axiom,
    ! [VarCurr: state_type] :
      ( v68746(VarCurr)
    <=> v68748(VarCurr) ) ).

tff(addAssignment_40282,axiom,
    ! [VarCurr: state_type] :
      ( v68748(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addAssignment_40281,axiom,
    ! [VarCurr: state_type] :
      ( v68740(VarCurr)
    <=> v68742(VarCurr) ) ).

tff(addAssignment_40280,axiom,
    ! [VarCurr: state_type] :
      ( v68742(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_40279,axiom,
    ! [VarCurr: state_type] :
      ( v68700(VarCurr,3)
    <=> v68702(VarCurr,3) ) ).

tff(addAssignment_40278,axiom,
    ! [VarCurr: state_type] :
      ( v68702(VarCurr,3)
    <=> v68731(VarCurr,3) ) ).

tff(addAssignment_40277,axiom,
    ! [VarCurr: state_type] :
      ( ( v68731(VarCurr,6)
      <=> v68625(VarCurr,14) )
      & ( v68731(VarCurr,5)
      <=> v68625(VarCurr,13) )
      & ( v68731(VarCurr,4)
      <=> v68625(VarCurr,12) )
      & ( v68731(VarCurr,3)
      <=> v68625(VarCurr,11) )
      & ( v68731(VarCurr,2)
      <=> v68625(VarCurr,10) )
      & ( v68731(VarCurr,1)
      <=> v68625(VarCurr,9) )
      & ( v68731(VarCurr,0)
      <=> v68625(VarCurr,8) ) ) ).

tff(addAssignment_40276,axiom,
    ! [VarCurr: state_type] :
      ( v68731(VarCurr,7)
    <=> v68732(VarCurr) ) ).

tff(addAssignment_40275,axiom,
    ! [VarCurr: state_type] :
      ( v68625(VarCurr,11)
    <=> v68705(VarCurr,3) ) ).

tff(addAssignment_40274,axiom,
    ! [VarCurr: state_type] :
      ( v68705(VarCurr,3)
    <=> v68707(VarCurr,3) ) ).

tff(addAssignment_40273,axiom,
    ! [VarCurr: state_type] :
      ( v68707(VarCurr,3)
    <=> v68724(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68724(VarCurr,B)
      <=> ( v68725(VarCurr,B)
          | v68728(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68728(VarCurr,B)
      <=> ( v68717(VarCurr,B)
          & v68729(VarCurr,B) ) ) ) ).

tff(addAssignment_40272,axiom,
    ! [VarCurr: state_type] :
      ( v68729(VarCurr,0)
    <=> v68730(VarCurr) ) ).

tff(addAssignment_40271,axiom,
    ! [VarCurr: state_type] :
      ( v68729(VarCurr,1)
    <=> v68730(VarCurr) ) ).

tff(addAssignment_40270,axiom,
    ! [VarCurr: state_type] :
      ( v68729(VarCurr,2)
    <=> v68730(VarCurr) ) ).

tff(addAssignment_40269,axiom,
    ! [VarCurr: state_type] :
      ( v68729(VarCurr,3)
    <=> v68730(VarCurr) ) ).

tff(addAssignment_40268,axiom,
    ! [VarCurr: state_type] :
      ( v68730(VarCurr)
    <=> v68721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68725(VarCurr,B)
      <=> ( v68709(VarCurr,B)
          & v68726(VarCurr,B) ) ) ) ).

tff(addAssignment_40267,axiom,
    ! [VarCurr: state_type] :
      ( v68726(VarCurr,0)
    <=> v68727(VarCurr) ) ).

tff(addAssignment_40266,axiom,
    ! [VarCurr: state_type] :
      ( v68726(VarCurr,1)
    <=> v68727(VarCurr) ) ).

tff(addAssignment_40265,axiom,
    ! [VarCurr: state_type] :
      ( v68726(VarCurr,2)
    <=> v68727(VarCurr) ) ).

tff(addAssignment_40264,axiom,
    ! [VarCurr: state_type] :
      ( v68726(VarCurr,3)
    <=> v68727(VarCurr) ) ).

tff(addAssignment_40263,axiom,
    ! [VarCurr: state_type] :
      ( v68727(VarCurr)
    <=> v68713(VarCurr) ) ).

tff(addAssignment_40262,axiom,
    ! [VarCurr: state_type] :
      ( v68721(VarCurr)
    <=> v68723(VarCurr) ) ).

tff(addAssignment_40261,axiom,
    ! [VarCurr: state_type] :
      ( v68723(VarCurr)
    <=> v67530(VarCurr,33) ) ).

tff(addAssignment_40260,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,33)
    <=> v52381(VarCurr,33) ) ).

tff(addAssignment_40259,axiom,
    ! [VarCurr: state_type] :
      ( v68717(VarCurr,3)
    <=> v68719(VarCurr,3) ) ).

tff(addAssignment_40258,axiom,
    ! [VarCurr: state_type] :
      ( v68719(VarCurr,3)
    <=> v68455(VarCurr,11) ) ).

tff(addAssignment_40257,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,11)
    <=> v68457(VarCurr,11) ) ).

tff(addAssignment_40256,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,11)
    <=> v68459(VarCurr,11) ) ).

tff(addAssignment_40255,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,11)
    <=> v68548(VarCurr,11) ) ).

tff(addAssignment_40254,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,11)
    <=> v68469(VarCurr,11) ) ).

tff(addAssignment_40253,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,11)
    <=> v68471(VarCurr,11) ) ).

tff(addAssignment_40252,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,11)
    <=> v67432(VarCurr,139) ) ).

tff(addAssignment_40251,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,139)
    <=> v67434(VarCurr,139) ) ).

tff(addAssignment_40250,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,139)
    <=> v68473(VarCurr,11) ) ).

tff(addAssignment_40249,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,11)
    <=> v68475(VarCurr,11) ) ).

tff(addAssignment_40248,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,11)
    <=> v68531(VarCurr,11) ) ).

tff(addAssignment_40247,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,11)
    <=> v68530(VarCurr,11) ) ).

tff(addAssignment_40246,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,11)
    <=> v6234(VarCurr,67) ) ).

tff(addAssignment_40245,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,11)
    <=> v68526(VarCurr,11) ) ).

tff(addAssignment_40244,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,11)
    <=> v53217(VarCurr,67) ) ).

tff(addAssignment_40243,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,11)
    <=> v68522(VarCurr,11) ) ).

tff(addAssignment_40242,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_40241,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,11)
    <=> v68463(VarCurr,11) ) ).

tff(addAssignment_40240,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,11)
    <=> v68464(VarCurr,11) ) ).

tff(addAssignment_40239,axiom,
    ! [VarCurr: state_type] :
      ( v68713(VarCurr)
    <=> v68715(VarCurr) ) ).

tff(addAssignment_40238,axiom,
    ! [VarCurr: state_type] :
      ( v68715(VarCurr)
    <=> v67520(VarCurr,33) ) ).

tff(addAssignment_40237,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,33)
    <=> v52363(VarCurr,33) ) ).

tff(addAssignment_40236,axiom,
    ! [VarCurr: state_type] :
      ( v68709(VarCurr,3)
    <=> v68711(VarCurr,3) ) ).

tff(addAssignment_40235,axiom,
    ! [VarCurr: state_type] :
      ( v68711(VarCurr,3)
    <=> v68455(VarCurr,7) ) ).

tff(addAssignment_40234,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,7)
    <=> v68457(VarCurr,7) ) ).

tff(addAssignment_40233,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,7)
    <=> v68459(VarCurr,7) ) ).

tff(addAssignment_40232,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,7)
    <=> v68548(VarCurr,7) ) ).

tff(addAssignment_40231,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,7)
    <=> v68469(VarCurr,7) ) ).

tff(addAssignment_40230,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,7)
    <=> v68471(VarCurr,7) ) ).

tff(addAssignment_40229,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,7)
    <=> v67432(VarCurr,135) ) ).

tff(addAssignment_40228,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,135)
    <=> v67434(VarCurr,135) ) ).

tff(addAssignment_40227,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,135)
    <=> v68473(VarCurr,7) ) ).

tff(addAssignment_40226,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,7)
    <=> v68475(VarCurr,7) ) ).

tff(addAssignment_40225,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,7)
    <=> v68531(VarCurr,7) ) ).

tff(addAssignment_40224,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,7)
    <=> v68530(VarCurr,7) ) ).

tff(addAssignment_40223,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,7)
    <=> v6234(VarCurr,63) ) ).

tff(addAssignment_40222,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,7)
    <=> v68526(VarCurr,7) ) ).

tff(addAssignment_40221,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,7)
    <=> v53217(VarCurr,63) ) ).

tff(addAssignment_40220,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,7)
    <=> v68522(VarCurr,7) ) ).

tff(addAssignment_40219,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_40218,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,7)
    <=> v68463(VarCurr,7) ) ).

tff(addAssignment_40217,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,7)
    <=> v68464(VarCurr,7) ) ).

tff(addAssignment_40216,axiom,
    ! [VarCurr: state_type] :
      ( v68690(VarCurr)
    <=> v68692(VarCurr) ) ).

tff(addAssignment_40215,axiom,
    ! [VarCurr: state_type] :
      ( v68692(VarCurr)
    <=> v68694(VarCurr) ) ).

tff(addAssignment_40214,axiom,
    ! [VarCurr: state_type] :
      ( v68694(VarCurr)
    <=> v68696(VarCurr) ) ).

tff(addAssignment_40213,axiom,
    ! [VarCurr: state_type] :
      ( v68696(VarCurr)
    <=> v68698(VarCurr) ) ).

tff(addAssignment_40212,axiom,
    ! [VarCurr: state_type] :
      ( v68698(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_40211,axiom,
    ! [VarCurr: state_type] :
      ( v68680(VarCurr)
    <=> v68682(VarCurr) ) ).

tff(addAssignment_40210,axiom,
    ! [VarCurr: state_type] :
      ( v68682(VarCurr)
    <=> v68684(VarCurr) ) ).

tff(addAssignment_40209,axiom,
    ! [VarCurr: state_type] :
      ( v68684(VarCurr)
    <=> v68686(VarCurr) ) ).

tff(addAssignment_40208,axiom,
    ! [VarCurr: state_type] :
      ( v68686(VarCurr)
    <=> v68688(VarCurr) ) ).

tff(addAssignment_40207,axiom,
    ! [VarCurr: state_type] :
      ( v68688(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_40206,axiom,
    ! [VarCurr: state_type] :
      ( v67961(VarCurr)
    <=> v67963(VarCurr) ) ).

tff(addAssignment_40205,axiom,
    ! [VarCurr: state_type] :
      ( v67963(VarCurr)
    <=> v67965(VarCurr) ) ).

tff(addAssignment_40204,axiom,
    ! [VarCurr: state_type] :
      ( v67965(VarCurr)
    <=> v67967(VarCurr) ) ).

tff(addAssignment_40203,axiom,
    ! [VarCurr: state_type] :
      ( v67967(VarCurr)
    <=> v67969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6290,axiom,
    ! [VarCurr: state_type] :
      ( v67969(VarCurr)
    <=> ( v68666(VarCurr)
      <~> v68235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6289,axiom,
    ! [VarCurr: state_type] :
      ( v68666(VarCurr)
    <=> ( v67971(VarCurr)
      <~> v68103(VarCurr) ) ) ).

tff(addAssignment_40202,axiom,
    ! [VarCurr: state_type] :
      ( v68235(VarCurr)
    <=> v68237(VarCurr) ) ).

tff(addAssignment_40201,axiom,
    ! [VarCurr: state_type] :
      ( v68237(VarCurr)
    <=> v68239(VarCurr) ) ).

tff(addAssignment_40200,axiom,
    ! [VarCurr: state_type] :
      ( v68239(VarCurr)
    <=> v68241(VarCurr) ) ).

tff(addAssignment_40199,axiom,
    ! [VarCurr: state_type] :
      ( v68241(VarCurr)
    <=> v68243(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6288,axiom,
    ! [VarCurr: state_type] :
      ( v68243(VarCurr)
    <=> ( v68664(VarCurr)
      <~> v68577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6287,axiom,
    ! [VarCurr: state_type] :
      ( v68664(VarCurr)
    <=> ( v68245(VarCurr)
      <~> v68442(VarCurr) ) ) ).

tff(addAssignment_40198,axiom,
    ! [VarCurr: state_type] :
      ( v68577(VarCurr)
    <=> v68579(VarCurr) ) ).

tff(addAssignment_40197,axiom,
    ! [VarCurr: state_type] :
      ( v68579(VarCurr)
    <=> v68581(VarCurr) ) ).

tff(addAssignment_40196,axiom,
    ! [VarCurr: state_type] :
      ( v68581(VarCurr)
    <=> v68583(VarCurr,1) ) ).

tff(addAssignment_40195,axiom,
    ! [VarCurr: state_type] :
      ( v68583(VarCurr,1)
    <=> v68585(VarCurr,1) ) ).

tff(addAssignment_40194,axiom,
    ! [VarCurr: state_type] :
      ( v68585(VarCurr,1)
    <=> v68587(VarCurr,1) ) ).

tff(addAssignment_40193,axiom,
    ! [VarCurr: state_type] :
      ( v68587(VarCurr,1)
    <=> v68589(VarCurr,1) ) ).

tff(addAssignment_40192,axiom,
    ! [VarCurr: state_type] :
      ( v68589(VarCurr,1)
    <=> v68662(VarCurr,1) ) ).

tff(addAssignment_40191,axiom,
    ! [VarCurr: state_type] :
      ( v68662(VarCurr,0)
    <=> v68591(VarCurr) ) ).

tff(addAssignment_40190,axiom,
    ! [VarCurr: state_type] :
      ( v68662(VarCurr,1)
    <=> v68591(VarCurr) ) ).

tff(addAssignment_40189,axiom,
    ! [VarCurr: state_type] :
      ( v68591(VarCurr)
    <=> v68593(VarCurr) ) ).

tff(addAssignment_40188,axiom,
    ! [VarCurr: state_type] :
      ( v68593(VarCurr)
    <=> v68595(VarCurr,0) ) ).

tff(addAssignment_40187,axiom,
    ! [VarCurr: state_type] :
      ( v68595(VarCurr,0)
    <=> v68597(VarCurr,0) ) ).

tff(addAssignment_40186,axiom,
    ! [VarNext: state_type] :
      ( v68597(VarNext,0)
    <=> v68645(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68646(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v68645(VarNext,B)
            <=> v68597(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_782,axiom,
    ! [VarNext: state_type] :
      ( v68646(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v68645(VarNext,B)
          <=> v68656(VarNext,B) ) ) ) ).

tff(addAssignment_40185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v68656(VarNext,B)
          <=> v68654(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68657(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v68654(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_403,axiom,
    ! [VarCurr: state_type] :
      ( v68657(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v68654(VarCurr,B)
          <=> v68619(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6286,axiom,
    ! [VarCurr: state_type] :
      ( v68657(VarCurr)
    <=> ( v68658(VarCurr)
        & v68659(VarCurr) ) ) ).

tff(writeUnaryOperator_3308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68659(VarCurr)
    <=> v68609(VarCurr) ) ).

tff(writeUnaryOperator_3307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68658(VarCurr)
    <=> v68599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68646(VarNext)
      <=> v68647(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68647(VarNext)
      <=> ( v68648(VarNext)
          & v68627(VarNext) ) ) ) ).

tff(writeUnaryOperator_3306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68648(VarNext)
      <=> v68650(VarNext) ) ) ).

tff(addAssignment_40184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68650(VarNext)
      <=> v68627(VarCurr) ) ) ).

tff(addAssignment_40183,axiom,
    ! [VarCurr: state_type] :
      ( v68627(VarCurr)
    <=> v68629(VarCurr) ) ).

tff(addAssignment_40182,axiom,
    ! [VarCurr: state_type] :
      ( v68629(VarCurr)
    <=> v68631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6283,axiom,
    ! [VarCurr: state_type] :
      ( v68631(VarCurr)
    <=> ( v68643(VarCurr)
        | v68639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6282,axiom,
    ! [VarCurr: state_type] :
      ( v68643(VarCurr)
    <=> ( v68633(VarCurr)
        & v68637(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_236,axiom,
    ( v68637(constB0)
  <=> $true ) ).

tff(addAssignment_40181,axiom,
    ! [VarCurr: state_type] :
      ( v68639(VarCurr)
    <=> v68641(VarCurr) ) ).

tff(addAssignment_40180,axiom,
    ! [VarCurr: state_type] :
      ( v68641(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addAssignment_40179,axiom,
    ! [VarCurr: state_type] :
      ( v68633(VarCurr)
    <=> v68635(VarCurr) ) ).

tff(addAssignment_40178,axiom,
    ! [VarCurr: state_type] :
      ( v68635(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_40177,axiom,
    ! [VarCurr: state_type] :
      ( v68619(VarCurr,0)
    <=> v68621(VarCurr,0) ) ).

tff(addAssignment_40176,axiom,
    ! [VarCurr: state_type] :
      ( v68621(VarCurr,0)
    <=> v68624(VarCurr,0) ) ).

tff(addAssignment_40175,axiom,
    ! [VarCurr: state_type] :
      ( v68624(VarCurr,0)
    <=> v68623(VarCurr) ) ).

tff(addAssignment_40174,axiom,
    ! [VarCurr: state_type] :
      ( ( v68624(VarCurr,8)
      <=> v68625(VarCurr,7) )
      & ( v68624(VarCurr,7)
      <=> v68625(VarCurr,6) )
      & ( v68624(VarCurr,6)
      <=> v68625(VarCurr,5) )
      & ( v68624(VarCurr,5)
      <=> v68625(VarCurr,4) )
      & ( v68624(VarCurr,4)
      <=> v68625(VarCurr,3) )
      & ( v68624(VarCurr,3)
      <=> v68625(VarCurr,2) )
      & ( v68624(VarCurr,2)
      <=> v68625(VarCurr,1) )
      & ( v68624(VarCurr,1)
      <=> v68625(VarCurr,0) ) ) ).

tff(addAssignment_40173,axiom,
    ! [VarCurr: state_type] :
      ( v68623(VarCurr)
    <=> v53484(VarCurr) ) ).

tff(addAssignment_40172,axiom,
    ! [VarCurr: state_type] :
      ( v68609(VarCurr)
    <=> v68611(VarCurr) ) ).

tff(addAssignment_40171,axiom,
    ! [VarCurr: state_type] :
      ( v68611(VarCurr)
    <=> v68613(VarCurr) ) ).

tff(addAssignment_40170,axiom,
    ! [VarCurr: state_type] :
      ( v68613(VarCurr)
    <=> v68615(VarCurr) ) ).

tff(addAssignment_40169,axiom,
    ! [VarCurr: state_type] :
      ( v68615(VarCurr)
    <=> v68617(VarCurr) ) ).

tff(addAssignment_40168,axiom,
    ! [VarCurr: state_type] :
      ( v68617(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_40167,axiom,
    ! [VarCurr: state_type] :
      ( v68599(VarCurr)
    <=> v68601(VarCurr) ) ).

tff(addAssignment_40166,axiom,
    ! [VarCurr: state_type] :
      ( v68601(VarCurr)
    <=> v68603(VarCurr) ) ).

tff(addAssignment_40165,axiom,
    ! [VarCurr: state_type] :
      ( v68603(VarCurr)
    <=> v68605(VarCurr) ) ).

tff(addAssignment_40164,axiom,
    ! [VarCurr: state_type] :
      ( v68605(VarCurr)
    <=> v68607(VarCurr) ) ).

tff(addAssignment_40163,axiom,
    ! [VarCurr: state_type] :
      ( v68607(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_40162,axiom,
    ! [VarCurr: state_type] :
      ( v68442(VarCurr)
    <=> v68444(VarCurr) ) ).

tff(addAssignment_40161,axiom,
    ! [VarCurr: state_type] :
      ( v68444(VarCurr)
    <=> v67349(VarCurr,127) ) ).

tff(addAssignment_40160,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,127)
    <=> v68249(VarCurr,63) ) ).

tff(addAssignment_40159,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,63)
    <=> v68251(VarCurr,63) ) ).

tff(addAssignment_40158,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,63)
    <=> v68253(VarCurr,63) ) ).

tff(addAssignment_40157,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,63)
    <=> v68255(VarCurr,63) ) ).

tff(addAssignment_40156,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,63)
    <=> v67359(VarCurr,127) ) ).

tff(addAssignment_40155,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,127)
    <=> v67580(VarCurr,127) ) ).

tff(addAssignment_40154,axiom,
    ! [VarCurr: state_type] :
      ( v67581(VarCurr,3)
    <=> v68258(VarCurr,63) ) ).

tff(addAssignment_40153,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,63)
    <=> v68260(VarCurr,63) ) ).

tff(addAssignment_40152,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,63)
    <=> v68569(VarNext,63) ) ).

tff(addCaseBooleanConditionEqualRanges1_781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68570(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68569(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_781,axiom,
    ! [VarNext: state_type] :
      ( v68570(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68569(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68570(VarNext)
      <=> v68571(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68571(VarNext)
      <=> ( v68573(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68573(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_40151,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,63)
    <=> v68284(VarCurr,63) ) ).

tff(addAssignment_40150,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,63)
    <=> v67391(VarCurr,127) ) ).

tff(addAssignment_40149,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,127)
    <=> v68447(VarCurr,3) ) ).

tff(addAssignment_40148,axiom,
    ! [VarCurr: state_type] :
      ( v68447(VarCurr,3)
    <=> v68449(VarCurr,3) ) ).

tff(addAssignment_40147,axiom,
    ! [VarCurr: state_type] :
      ( v68449(VarCurr,3)
    <=> v68561(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68561(VarCurr,B)
      <=> ( v68562(VarCurr,B)
          | v68565(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68565(VarCurr,B)
      <=> ( v68554(VarCurr,B)
          & v68566(VarCurr,B) ) ) ) ).

tff(addAssignment_40146,axiom,
    ! [VarCurr: state_type] :
      ( v68566(VarCurr,0)
    <=> v68567(VarCurr) ) ).

tff(addAssignment_40145,axiom,
    ! [VarCurr: state_type] :
      ( v68566(VarCurr,1)
    <=> v68567(VarCurr) ) ).

tff(addAssignment_40144,axiom,
    ! [VarCurr: state_type] :
      ( v68566(VarCurr,2)
    <=> v68567(VarCurr) ) ).

tff(addAssignment_40143,axiom,
    ! [VarCurr: state_type] :
      ( v68566(VarCurr,3)
    <=> v68567(VarCurr) ) ).

tff(addAssignment_40142,axiom,
    ! [VarCurr: state_type] :
      ( v68567(VarCurr)
    <=> v68558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68562(VarCurr,B)
      <=> ( v68451(VarCurr,B)
          & v68563(VarCurr,B) ) ) ) ).

tff(addAssignment_40141,axiom,
    ! [VarCurr: state_type] :
      ( v68563(VarCurr,0)
    <=> v68564(VarCurr) ) ).

tff(addAssignment_40140,axiom,
    ! [VarCurr: state_type] :
      ( v68563(VarCurr,1)
    <=> v68564(VarCurr) ) ).

tff(addAssignment_40139,axiom,
    ! [VarCurr: state_type] :
      ( v68563(VarCurr,2)
    <=> v68564(VarCurr) ) ).

tff(addAssignment_40138,axiom,
    ! [VarCurr: state_type] :
      ( v68563(VarCurr,3)
    <=> v68564(VarCurr) ) ).

tff(addAssignment_40137,axiom,
    ! [VarCurr: state_type] :
      ( v68564(VarCurr)
    <=> v68550(VarCurr) ) ).

tff(addAssignment_40136,axiom,
    ! [VarCurr: state_type] :
      ( v68558(VarCurr)
    <=> v68560(VarCurr) ) ).

tff(addAssignment_40135,axiom,
    ! [VarCurr: state_type] :
      ( v68560(VarCurr)
    <=> v67530(VarCurr,31) ) ).

tff(addAssignment_40134,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,31)
    <=> v52381(VarCurr,31) ) ).

tff(addAssignment_40133,axiom,
    ! [VarCurr: state_type] :
      ( v68554(VarCurr,3)
    <=> v68556(VarCurr,3) ) ).

tff(addAssignment_40132,axiom,
    ! [VarCurr: state_type] :
      ( v68556(VarCurr,3)
    <=> v67401(VarCurr,127) ) ).

tff(addAssignment_40131,axiom,
    ! [VarCurr: state_type] :
      ( v68550(VarCurr)
    <=> v68552(VarCurr) ) ).

tff(addAssignment_40130,axiom,
    ! [VarCurr: state_type] :
      ( v68552(VarCurr)
    <=> v67520(VarCurr,31) ) ).

tff(addAssignment_40129,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,31)
    <=> v52363(VarCurr,31) ) ).

tff(addAssignment_40128,axiom,
    ! [VarCurr: state_type] :
      ( v68451(VarCurr,3)
    <=> v68453(VarCurr,3) ) ).

tff(addAssignment_40127,axiom,
    ! [VarCurr: state_type] :
      ( v68453(VarCurr,3)
    <=> v68455(VarCurr,15) ) ).

tff(addAssignment_40126,axiom,
    ! [VarCurr: state_type] :
      ( v68455(VarCurr,15)
    <=> v68457(VarCurr,15) ) ).

tff(addAssignment_40125,axiom,
    ! [VarCurr: state_type] :
      ( v68457(VarCurr,15)
    <=> v68459(VarCurr,15) ) ).

tff(addAssignment_40124,axiom,
    ! [VarCurr: state_type] :
      ( v68459(VarCurr,15)
    <=> v68548(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v68548(VarCurr,B)
      <=> ( v68461(VarCurr,B)
          & v68467(VarCurr,B) ) ) ) ).

tff(addAssignment_40123,axiom,
    ! [VarCurr: state_type] :
      ( v68467(VarCurr,15)
    <=> v68469(VarCurr,15) ) ).

tff(addAssignment_40122,axiom,
    ! [VarCurr: state_type] :
      ( v68469(VarCurr,15)
    <=> v68471(VarCurr,15) ) ).

tff(addAssignment_40121,axiom,
    ! [VarCurr: state_type] :
      ( v68471(VarCurr,15)
    <=> v67432(VarCurr,143) ) ).

tff(addAssignment_40120,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,143)
    <=> v67434(VarCurr,143) ) ).

tff(addAssignment_40119,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,143)
    <=> v68473(VarCurr,15) ) ).

tff(addAssignment_40118,axiom,
    ! [VarCurr: state_type] :
      ( v68473(VarCurr,15)
    <=> v68475(VarCurr,15) ) ).

tff(addAssignment_40117,axiom,
    ! [VarCurr: state_type] :
      ( v68475(VarCurr,15)
    <=> v68531(VarCurr,15) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_5,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v68532(VarCurr)
        & ~ v68537(VarCurr)
        & ~ v68541(VarCurr)
        & ~ v68544(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v68531(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_5,axiom,
    ! [VarCurr: state_type] :
      ( v68544(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v68531(VarCurr,B)
          <=> $true ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_6,axiom,
    ! [VarCurr: state_type] :
      ( v68541(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v68531(VarCurr,B)
          <=> v68528(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_13,axiom,
    ! [VarCurr: state_type] :
      ( v68537(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v68531(VarCurr,B)
          <=> v68524(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_13,axiom,
    ! [VarCurr: state_type] :
      ( v68532(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v68531(VarCurr,B)
          <=> v68520(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6279,axiom,
    ! [VarCurr: state_type] :
      ( v68544(VarCurr)
    <=> ( v68546(VarCurr)
        & v68547(VarCurr) ) ) ).

tff(writeUnaryOperator_3304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68547(VarCurr)
    <=> v68477(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6278,axiom,
    ! [VarCurr: state_type] :
      ( v68546(VarCurr)
    <=> ( v68543(VarCurr)
        & v68536(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_598,axiom,
    ! [VarCurr: state_type] :
      ( v68541(VarCurr)
    <=> ( v68543(VarCurr)
        & v68477(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6277,axiom,
    ! [VarCurr: state_type] :
      ( v68543(VarCurr)
    <=> ( v68540(VarCurr)
        & v68535(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6276,axiom,
    ! [VarCurr: state_type] :
      ( v68537(VarCurr)
    <=> ( v68539(VarCurr)
        & v68536(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_597,axiom,
    ! [VarCurr: state_type] :
      ( v68539(VarCurr)
    <=> ( v68540(VarCurr)
        & v68477(VarCurr,1) ) ) ).

tff(writeUnaryOperator_3303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68540(VarCurr)
    <=> v68477(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6275,axiom,
    ! [VarCurr: state_type] :
      ( v68532(VarCurr)
    <=> ( v68534(VarCurr)
        & v68536(VarCurr) ) ) ).

tff(writeUnaryOperator_3302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68536(VarCurr)
    <=> v68477(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6274,axiom,
    ! [VarCurr: state_type] :
      ( v68534(VarCurr)
    <=> ( v68477(VarCurr,0)
        & v68535(VarCurr) ) ) ).

tff(writeUnaryOperator_3301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68535(VarCurr)
    <=> v68477(VarCurr,1) ) ).

tff(addAssignment_40116,axiom,
    ! [VarCurr: state_type] :
      ( v68528(VarCurr,15)
    <=> v68530(VarCurr,15) ) ).

tff(addAssignment_40115,axiom,
    ! [VarCurr: state_type] :
      ( v68530(VarCurr,15)
    <=> v6234(VarCurr,71) ) ).

tff(addAssignment_40114,axiom,
    ! [VarCurr: state_type] :
      ( v68524(VarCurr,15)
    <=> v68526(VarCurr,15) ) ).

tff(addAssignment_40113,axiom,
    ! [VarCurr: state_type] :
      ( v68526(VarCurr,15)
    <=> v53217(VarCurr,71) ) ).

tff(addAssignment_40112,axiom,
    ! [VarCurr: state_type] :
      ( v68520(VarCurr,15)
    <=> v68522(VarCurr,15) ) ).

tff(addAssignment_40111,axiom,
    ! [VarCurr: state_type] :
      ( v68522(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_40110,axiom,
    ! [VarCurr: state_type] :
      ( v68477(VarCurr,0)
    <=> v68513(VarCurr) ) ).

tff(addAssignment_40109,axiom,
    ! [VarCurr: state_type] :
      ( v68477(VarCurr,1)
    <=> v68505(VarCurr) ) ).

tff(addAssignment_40108,axiom,
    ! [VarCurr: state_type] :
      ( v68477(VarCurr,2)
    <=> v68483(VarCurr) ) ).

tff(addAssignment_40107,axiom,
    ! [VarCurr: state_type] :
      ( v68477(VarCurr,3)
    <=> v68479(VarCurr) ) ).

tff(addAssignment_40106,axiom,
    ! [VarCurr: state_type] :
      ( v68513(VarCurr)
    <=> v68515(VarCurr) ) ).

tff(addAssignment_40105,axiom,
    ! [VarCurr: state_type] :
      ( v68515(VarCurr)
    <=> v68517(VarCurr) ) ).

tff(addAssignment_40104,axiom,
    ! [VarCurr: state_type] :
      ( v68517(VarCurr)
    <=> v68489(VarCurr) ) ).

tff(addAssignment_40103,axiom,
    ! [VarCurr: state_type] :
      ( v68505(VarCurr)
    <=> v68507(VarCurr) ) ).

tff(addAssignment_40102,axiom,
    ! [VarCurr: state_type] :
      ( v68507(VarCurr)
    <=> v68509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6273,axiom,
    ! [VarCurr: state_type] :
      ( v68509(VarCurr)
    <=> ( v68511(VarCurr)
        & v68493(VarCurr) ) ) ).

tff(writeUnaryOperator_3300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68511(VarCurr)
    <=> v68489(VarCurr) ) ).

tff(addAssignment_40101,axiom,
    ! [VarCurr: state_type] :
      ( v68483(VarCurr)
    <=> v68485(VarCurr) ) ).

tff(addAssignment_40100,axiom,
    ! [VarCurr: state_type] :
      ( v68485(VarCurr)
    <=> v68487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6272,axiom,
    ! [VarCurr: state_type] :
      ( v68487(VarCurr)
    <=> ( v68501(VarCurr)
        & v68497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6271,axiom,
    ! [VarCurr: state_type] :
      ( v68501(VarCurr)
    <=> ( v68502(VarCurr)
        & v68503(VarCurr) ) ) ).

tff(writeUnaryOperator_3299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68503(VarCurr)
    <=> v68493(VarCurr) ) ).

tff(writeUnaryOperator_3298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68502(VarCurr)
    <=> v68489(VarCurr) ) ).

tff(addAssignment_40099,axiom,
    ! [VarCurr: state_type] :
      ( v68497(VarCurr)
    <=> v68499(VarCurr) ) ).

tff(addAssignment_40098,axiom,
    ! [VarCurr: state_type] :
      ( v68499(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_40097,axiom,
    ! [VarCurr: state_type] :
      ( v68493(VarCurr)
    <=> v68495(VarCurr) ) ).

tff(addAssignment_40096,axiom,
    ! [VarCurr: state_type] :
      ( v68495(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_40095,axiom,
    ! [VarCurr: state_type] :
      ( v68489(VarCurr)
    <=> v68491(VarCurr) ) ).

tff(addAssignment_40094,axiom,
    ! [VarCurr: state_type] :
      ( v68491(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_40093,axiom,
    ! [VarCurr: state_type] :
      ( v68479(VarCurr)
    <=> v68481(VarCurr) ) ).

tff(addAssignment_40092,axiom,
    ! [VarCurr: state_type] :
      ( v68481(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_40091,axiom,
    ! [VarCurr: state_type] :
      ( v68461(VarCurr,15)
    <=> v68463(VarCurr,15) ) ).

tff(addAssignment_40090,axiom,
    ! [VarCurr: state_type] :
      ( v68463(VarCurr,15)
    <=> v68464(VarCurr,15) ) ).

tff(addAssignment_40089,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,0)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40088,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,1)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40087,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,2)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40086,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,3)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40085,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,4)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40084,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,5)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40083,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,6)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40082,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,7)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40081,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,8)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40080,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,9)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40079,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,10)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40078,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,11)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40077,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,12)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40076,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,13)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40075,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,14)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40074,axiom,
    ! [VarCurr: state_type] :
      ( v68464(VarCurr,15)
    <=> v68465(VarCurr) ) ).

tff(addAssignment_40073,axiom,
    ! [VarCurr: state_type] :
      ( v68465(VarCurr)
    <=> v67411(VarCurr) ) ).

tff(addAssignment_40072,axiom,
    ! [VarCurr: state_type] :
      ( v68245(VarCurr)
    <=> v68247(VarCurr) ) ).

tff(addAssignment_40071,axiom,
    ! [VarCurr: state_type] :
      ( v68247(VarCurr)
    <=> v67349(VarCurr,123) ) ).

tff(addAssignment_40070,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,123)
    <=> v68249(VarCurr,59) ) ).

tff(addAssignment_40069,axiom,
    ! [VarCurr: state_type] :
      ( v68249(VarCurr,59)
    <=> v68251(VarCurr,59) ) ).

tff(addAssignment_40068,axiom,
    ! [VarCurr: state_type] :
      ( v68251(VarCurr,59)
    <=> v68253(VarCurr,59) ) ).

tff(addAssignment_40067,axiom,
    ! [VarCurr: state_type] :
      ( v68253(VarCurr,59)
    <=> v68255(VarCurr,59) ) ).

tff(addAssignment_40066,axiom,
    ! [VarCurr: state_type] :
      ( v68255(VarCurr,59)
    <=> v67359(VarCurr,123) ) ).

tff(addAssignment_40065,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,123)
    <=> v67580(VarCurr,123) ) ).

tff(addAssignment_40064,axiom,
    ! [VarCurr: state_type] :
      ( v67582(VarCurr,3)
    <=> v68258(VarCurr,59) ) ).

tff(addAssignment_40063,axiom,
    ! [VarCurr: state_type] :
      ( v68258(VarCurr,59)
    <=> v68260(VarCurr,59) ) ).

tff(addAssignment_40062,axiom,
    ! [VarNext: state_type] :
      ( v68260(VarNext,59)
    <=> v68424(VarNext,59) ) ).

tff(addCaseBooleanConditionEqualRanges1_780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68425(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68424(VarNext,B)
            <=> v68260(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_780,axiom,
    ! [VarNext: state_type] :
      ( v68425(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68424(VarNext,B)
          <=> v68435(VarNext,B) ) ) ) ).

tff(addAssignment_40061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68435(VarNext,B)
          <=> v68433(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68436(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68433(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_402,axiom,
    ! [VarCurr: state_type] :
      ( v68436(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68433(VarCurr,B)
          <=> v68282(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6270,axiom,
    ! [VarCurr: state_type] :
      ( v68436(VarCurr)
    <=> ( v68437(VarCurr)
        & v68438(VarCurr) ) ) ).

tff(writeUnaryOperator_3297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68438(VarCurr)
    <=> v68272(VarCurr) ) ).

tff(writeUnaryOperator_3296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68437(VarCurr)
    <=> v68262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68425(VarNext)
      <=> v68426(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68426(VarNext)
      <=> ( v68427(VarNext)
          & v68406(VarNext) ) ) ) ).

tff(writeUnaryOperator_3295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68427(VarNext)
      <=> v68429(VarNext) ) ) ).

tff(addAssignment_40060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68429(VarNext)
      <=> v68406(VarCurr) ) ) ).

tff(addAssignment_40059,axiom,
    ! [VarCurr: state_type] :
      ( v68406(VarCurr)
    <=> v68408(VarCurr) ) ).

tff(addAssignment_40058,axiom,
    ! [VarCurr: state_type] :
      ( v68408(VarCurr)
    <=> v68410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6267,axiom,
    ! [VarCurr: state_type] :
      ( v68410(VarCurr)
    <=> ( v68422(VarCurr)
        | v68418(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6266,axiom,
    ! [VarCurr: state_type] :
      ( v68422(VarCurr)
    <=> ( v68412(VarCurr)
        & v68416(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_235,axiom,
    ( v68416(constB0)
  <=> $true ) ).

tff(addAssignment_40057,axiom,
    ! [VarCurr: state_type] :
      ( v68418(VarCurr)
    <=> v68420(VarCurr) ) ).

tff(addAssignment_40056,axiom,
    ! [VarCurr: state_type] :
      ( v68420(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addAssignment_40055,axiom,
    ! [VarCurr: state_type] :
      ( v68412(VarCurr)
    <=> v68414(VarCurr) ) ).

tff(addAssignment_40054,axiom,
    ! [VarCurr: state_type] :
      ( v68414(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_40053,axiom,
    ! [VarCurr: state_type] :
      ( v68282(VarCurr,59)
    <=> v68284(VarCurr,59) ) ).

tff(addAssignment_40052,axiom,
    ! [VarCurr: state_type] :
      ( v68284(VarCurr,59)
    <=> v67391(VarCurr,123) ) ).

tff(addAssignment_40051,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,123)
    <=> v68286(VarCurr,3) ) ).

tff(addAssignment_40050,axiom,
    ! [VarCurr: state_type] :
      ( v68286(VarCurr,3)
    <=> v68288(VarCurr,3) ) ).

tff(addAssignment_40049,axiom,
    ! [VarCurr: state_type] :
      ( v68288(VarCurr,3)
    <=> v68398(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68398(VarCurr,B)
      <=> ( v68399(VarCurr,B)
          | v68402(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68402(VarCurr,B)
      <=> ( v68391(VarCurr,B)
          & v68403(VarCurr,B) ) ) ) ).

tff(addAssignment_40048,axiom,
    ! [VarCurr: state_type] :
      ( v68403(VarCurr,0)
    <=> v68404(VarCurr) ) ).

tff(addAssignment_40047,axiom,
    ! [VarCurr: state_type] :
      ( v68403(VarCurr,1)
    <=> v68404(VarCurr) ) ).

tff(addAssignment_40046,axiom,
    ! [VarCurr: state_type] :
      ( v68403(VarCurr,2)
    <=> v68404(VarCurr) ) ).

tff(addAssignment_40045,axiom,
    ! [VarCurr: state_type] :
      ( v68403(VarCurr,3)
    <=> v68404(VarCurr) ) ).

tff(addAssignment_40044,axiom,
    ! [VarCurr: state_type] :
      ( v68404(VarCurr)
    <=> v68395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68399(VarCurr,B)
      <=> ( v68290(VarCurr,B)
          & v68400(VarCurr,B) ) ) ) ).

tff(addAssignment_40043,axiom,
    ! [VarCurr: state_type] :
      ( v68400(VarCurr,0)
    <=> v68401(VarCurr) ) ).

tff(addAssignment_40042,axiom,
    ! [VarCurr: state_type] :
      ( v68400(VarCurr,1)
    <=> v68401(VarCurr) ) ).

tff(addAssignment_40041,axiom,
    ! [VarCurr: state_type] :
      ( v68400(VarCurr,2)
    <=> v68401(VarCurr) ) ).

tff(addAssignment_40040,axiom,
    ! [VarCurr: state_type] :
      ( v68400(VarCurr,3)
    <=> v68401(VarCurr) ) ).

tff(addAssignment_40039,axiom,
    ! [VarCurr: state_type] :
      ( v68401(VarCurr)
    <=> v68387(VarCurr) ) ).

tff(addAssignment_40038,axiom,
    ! [VarCurr: state_type] :
      ( v68395(VarCurr)
    <=> v68397(VarCurr) ) ).

tff(addAssignment_40037,axiom,
    ! [VarCurr: state_type] :
      ( v68397(VarCurr)
    <=> v67530(VarCurr,30) ) ).

tff(addAssignment_40036,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,30)
    <=> v52381(VarCurr,30) ) ).

tff(addAssignment_40035,axiom,
    ! [VarCurr: state_type] :
      ( v68391(VarCurr,3)
    <=> v68393(VarCurr,3) ) ).

tff(addAssignment_40034,axiom,
    ! [VarCurr: state_type] :
      ( v68393(VarCurr,3)
    <=> v67401(VarCurr,123) ) ).

tff(addAssignment_40033,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,123)
    <=> v68294(VarCurr,59) ) ).

tff(addAssignment_40032,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,59)
    <=> v68296(VarCurr,59) ) ).

tff(addAssignment_40031,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,59)
    <=> v68385(VarCurr,59) ) ).

tff(addAssignment_40030,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,59)
    <=> v68306(VarCurr,59) ) ).

tff(addAssignment_40029,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,59)
    <=> v67430(VarCurr,123) ) ).

tff(addAssignment_40028,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,123)
    <=> v67432(VarCurr,123) ) ).

tff(addAssignment_40027,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,123)
    <=> v67434(VarCurr,123) ) ).

tff(addAssignment_40026,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,123)
    <=> v68308(VarCurr,59) ) ).

tff(addAssignment_40025,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,59)
    <=> v68310(VarCurr,59) ) ).

tff(addAssignment_40024,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,59)
    <=> v68368(VarCurr,59) ) ).

tff(addAssignment_40023,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,59)
    <=> v68366(VarCurr,59) ) ).

tff(addAssignment_40022,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,59)
    <=> v68367(VarCurr,59) ) ).

tff(addAssignment_40021,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,59)
    <=> v68361(VarCurr,59) ) ).

tff(addAssignment_40020,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,59)
    <=> v68362(VarCurr,59) ) ).

tff(addAssignment_40019,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,59)
    <=> v68357(VarCurr,59) ) ).

tff(addAssignment_40018,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,59)
    <=> $false ) ).

tff(addAssignment_40017,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,59)
    <=> v68300(VarCurr,59) ) ).

tff(addAssignment_40016,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,59)
    <=> v68301(VarCurr,59) ) ).

tff(addAssignment_40015,axiom,
    ! [VarCurr: state_type] :
      ( v68387(VarCurr)
    <=> v68389(VarCurr) ) ).

tff(addAssignment_40014,axiom,
    ! [VarCurr: state_type] :
      ( v68389(VarCurr)
    <=> v67520(VarCurr,30) ) ).

tff(addAssignment_40013,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,30)
    <=> v52363(VarCurr,30) ) ).

tff(addAssignment_40012,axiom,
    ! [VarCurr: state_type] :
      ( v68290(VarCurr,3)
    <=> v68292(VarCurr,3) ) ).

tff(addAssignment_40011,axiom,
    ! [VarCurr: state_type] :
      ( v68292(VarCurr,3)
    <=> v67401(VarCurr,127) ) ).

tff(addAssignment_40010,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,127)
    <=> v68294(VarCurr,63) ) ).

tff(addAssignment_40009,axiom,
    ! [VarCurr: state_type] :
      ( v68294(VarCurr,63)
    <=> v68296(VarCurr,63) ) ).

tff(addAssignment_40008,axiom,
    ! [VarCurr: state_type] :
      ( v68296(VarCurr,63)
    <=> v68385(VarCurr,63) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v68385(VarCurr,B)
      <=> ( v68298(VarCurr,B)
          & v68304(VarCurr,B) ) ) ) ).

tff(addAssignment_40007,axiom,
    ! [VarCurr: state_type] :
      ( v68304(VarCurr,63)
    <=> v68306(VarCurr,63) ) ).

tff(addAssignment_40006,axiom,
    ! [VarCurr: state_type] :
      ( v68306(VarCurr,63)
    <=> v67430(VarCurr,127) ) ).

tff(addAssignment_40005,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,127)
    <=> v67432(VarCurr,127) ) ).

tff(addAssignment_40004,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,127)
    <=> v67434(VarCurr,127) ) ).

tff(addAssignment_40003,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,127)
    <=> v68308(VarCurr,63) ) ).

tff(addAssignment_40002,axiom,
    ! [VarCurr: state_type] :
      ( v68308(VarCurr,63)
    <=> v68310(VarCurr,63) ) ).

tff(addAssignment_40001,axiom,
    ! [VarCurr: state_type] :
      ( v68310(VarCurr,63)
    <=> v68368(VarCurr,63) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v68369(VarCurr)
        & ~ v68374(VarCurr)
        & ~ v68378(VarCurr)
        & ~ v68381(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68368(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_4,axiom,
    ! [VarCurr: state_type] :
      ( v68381(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68368(VarCurr,B)
          <=> $true ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_5,axiom,
    ! [VarCurr: state_type] :
      ( v68378(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68368(VarCurr,B)
          <=> v68364(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_12,axiom,
    ! [VarCurr: state_type] :
      ( v68374(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68368(VarCurr,B)
          <=> v68359(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_12,axiom,
    ! [VarCurr: state_type] :
      ( v68369(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68368(VarCurr,B)
          <=> v68355(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6265,axiom,
    ! [VarCurr: state_type] :
      ( v68381(VarCurr)
    <=> ( v68383(VarCurr)
        & v68384(VarCurr) ) ) ).

tff(writeUnaryOperator_3294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68384(VarCurr)
    <=> v68312(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6264,axiom,
    ! [VarCurr: state_type] :
      ( v68383(VarCurr)
    <=> ( v68380(VarCurr)
        & v68373(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_596,axiom,
    ! [VarCurr: state_type] :
      ( v68378(VarCurr)
    <=> ( v68380(VarCurr)
        & v68312(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6263,axiom,
    ! [VarCurr: state_type] :
      ( v68380(VarCurr)
    <=> ( v68377(VarCurr)
        & v68372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6262,axiom,
    ! [VarCurr: state_type] :
      ( v68374(VarCurr)
    <=> ( v68376(VarCurr)
        & v68373(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_595,axiom,
    ! [VarCurr: state_type] :
      ( v68376(VarCurr)
    <=> ( v68377(VarCurr)
        & v68312(VarCurr,1) ) ) ).

tff(writeUnaryOperator_3293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68377(VarCurr)
    <=> v68312(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6261,axiom,
    ! [VarCurr: state_type] :
      ( v68369(VarCurr)
    <=> ( v68371(VarCurr)
        & v68373(VarCurr) ) ) ).

tff(writeUnaryOperator_3292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68373(VarCurr)
    <=> v68312(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6260,axiom,
    ! [VarCurr: state_type] :
      ( v68371(VarCurr)
    <=> ( v68312(VarCurr,0)
        & v68372(VarCurr) ) ) ).

tff(writeUnaryOperator_3291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68372(VarCurr)
    <=> v68312(VarCurr,1) ) ).

tff(addAssignment_40000,axiom,
    ! [VarCurr: state_type] :
      ( v68364(VarCurr,63)
    <=> v68366(VarCurr,63) ) ).

tff(addAssignment_39999,axiom,
    ! [VarCurr: state_type] :
      ( v68366(VarCurr,63)
    <=> v68367(VarCurr,63) ) ).

tff(addAssignment_39998,axiom,
    ! [VarCurr: state_type] :
      ( ( v68367(VarCurr,7)
      <=> v67495(VarCurr,71) )
      & ( v68367(VarCurr,6)
      <=> v67495(VarCurr,70) )
      & ( v68367(VarCurr,5)
      <=> v67495(VarCurr,69) )
      & ( v68367(VarCurr,4)
      <=> v67495(VarCurr,68) )
      & ( v68367(VarCurr,3)
      <=> v67495(VarCurr,67) )
      & ( v68367(VarCurr,2)
      <=> v67495(VarCurr,66) )
      & ( v68367(VarCurr,1)
      <=> v67495(VarCurr,65) )
      & ( v68367(VarCurr,0)
      <=> v67495(VarCurr,64) ) ) ).

tff(addAssignment_39997,axiom,
    ! [VarCurr: state_type] :
      ( ( v68367(VarCurr,63)
      <=> v6234(VarCurr,55) )
      & ( v68367(VarCurr,62)
      <=> v6234(VarCurr,54) )
      & ( v68367(VarCurr,61)
      <=> v6234(VarCurr,53) )
      & ( v68367(VarCurr,60)
      <=> v6234(VarCurr,52) )
      & ( v68367(VarCurr,59)
      <=> v6234(VarCurr,51) )
      & ( v68367(VarCurr,58)
      <=> v6234(VarCurr,50) )
      & ( v68367(VarCurr,57)
      <=> v6234(VarCurr,49) )
      & ( v68367(VarCurr,56)
      <=> v6234(VarCurr,48) )
      & ( v68367(VarCurr,55)
      <=> v6234(VarCurr,47) )
      & ( v68367(VarCurr,54)
      <=> v6234(VarCurr,46) )
      & ( v68367(VarCurr,53)
      <=> v6234(VarCurr,45) )
      & ( v68367(VarCurr,52)
      <=> v6234(VarCurr,44) )
      & ( v68367(VarCurr,51)
      <=> v6234(VarCurr,43) )
      & ( v68367(VarCurr,50)
      <=> v6234(VarCurr,42) )
      & ( v68367(VarCurr,49)
      <=> v6234(VarCurr,41) )
      & ( v68367(VarCurr,48)
      <=> v6234(VarCurr,40) )
      & ( v68367(VarCurr,47)
      <=> v6234(VarCurr,39) )
      & ( v68367(VarCurr,46)
      <=> v6234(VarCurr,38) )
      & ( v68367(VarCurr,45)
      <=> v6234(VarCurr,37) )
      & ( v68367(VarCurr,44)
      <=> v6234(VarCurr,36) )
      & ( v68367(VarCurr,43)
      <=> v6234(VarCurr,35) )
      & ( v68367(VarCurr,42)
      <=> v6234(VarCurr,34) )
      & ( v68367(VarCurr,41)
      <=> v6234(VarCurr,33) )
      & ( v68367(VarCurr,40)
      <=> v6234(VarCurr,32) )
      & ( v68367(VarCurr,39)
      <=> v6234(VarCurr,31) )
      & ( v68367(VarCurr,38)
      <=> v6234(VarCurr,30) )
      & ( v68367(VarCurr,37)
      <=> v6234(VarCurr,29) )
      & ( v68367(VarCurr,36)
      <=> v6234(VarCurr,28) )
      & ( v68367(VarCurr,35)
      <=> v6234(VarCurr,27) )
      & ( v68367(VarCurr,34)
      <=> v6234(VarCurr,26) )
      & ( v68367(VarCurr,33)
      <=> v6234(VarCurr,25) )
      & ( v68367(VarCurr,32)
      <=> v6234(VarCurr,24) )
      & ( v68367(VarCurr,31)
      <=> v6234(VarCurr,23) )
      & ( v68367(VarCurr,30)
      <=> v6234(VarCurr,22) )
      & ( v68367(VarCurr,29)
      <=> v6234(VarCurr,21) )
      & ( v68367(VarCurr,28)
      <=> v6234(VarCurr,20) )
      & ( v68367(VarCurr,27)
      <=> v6234(VarCurr,19) )
      & ( v68367(VarCurr,26)
      <=> v6234(VarCurr,18) )
      & ( v68367(VarCurr,25)
      <=> v6234(VarCurr,17) )
      & ( v68367(VarCurr,24)
      <=> v6234(VarCurr,16) )
      & ( v68367(VarCurr,23)
      <=> v6234(VarCurr,15) )
      & ( v68367(VarCurr,22)
      <=> v6234(VarCurr,14) )
      & ( v68367(VarCurr,21)
      <=> v6234(VarCurr,13) )
      & ( v68367(VarCurr,20)
      <=> v6234(VarCurr,12) )
      & ( v68367(VarCurr,19)
      <=> v6234(VarCurr,11) )
      & ( v68367(VarCurr,18)
      <=> v6234(VarCurr,10) )
      & ( v68367(VarCurr,17)
      <=> v6234(VarCurr,9) )
      & ( v68367(VarCurr,16)
      <=> v6234(VarCurr,8) )
      & ( v68367(VarCurr,15)
      <=> v6234(VarCurr,7) )
      & ( v68367(VarCurr,14)
      <=> v6234(VarCurr,6) )
      & ( v68367(VarCurr,13)
      <=> v6234(VarCurr,5) )
      & ( v68367(VarCurr,12)
      <=> v6234(VarCurr,4) )
      & ( v68367(VarCurr,11)
      <=> v6234(VarCurr,3) )
      & ( v68367(VarCurr,10)
      <=> v6234(VarCurr,2) )
      & ( v68367(VarCurr,9)
      <=> v6234(VarCurr,1) )
      & ( v68367(VarCurr,8)
      <=> v6234(VarCurr,0) ) ) ).

tff(addAssignment_39996,axiom,
    ! [VarCurr: state_type] :
      ( v68359(VarCurr,63)
    <=> v68361(VarCurr,63) ) ).

tff(addAssignment_39995,axiom,
    ! [VarCurr: state_type] :
      ( v68361(VarCurr,63)
    <=> v68362(VarCurr,63) ) ).

tff(addAssignment_39994,axiom,
    ! [VarCurr: state_type] :
      ( ( v68362(VarCurr,7)
      <=> v6234(VarCurr,71) )
      & ( v68362(VarCurr,6)
      <=> v6234(VarCurr,70) )
      & ( v68362(VarCurr,5)
      <=> v6234(VarCurr,69) )
      & ( v68362(VarCurr,4)
      <=> v6234(VarCurr,68) )
      & ( v68362(VarCurr,3)
      <=> v6234(VarCurr,67) )
      & ( v68362(VarCurr,2)
      <=> v6234(VarCurr,66) )
      & ( v68362(VarCurr,1)
      <=> v6234(VarCurr,65) )
      & ( v68362(VarCurr,0)
      <=> v6234(VarCurr,64) ) ) ).

tff(addAssignment_39993,axiom,
    ! [VarCurr: state_type] :
      ( ( v68362(VarCurr,63)
      <=> v53217(VarCurr,55) )
      & ( v68362(VarCurr,62)
      <=> v53217(VarCurr,54) )
      & ( v68362(VarCurr,61)
      <=> v53217(VarCurr,53) )
      & ( v68362(VarCurr,60)
      <=> v53217(VarCurr,52) )
      & ( v68362(VarCurr,59)
      <=> v53217(VarCurr,51) )
      & ( v68362(VarCurr,58)
      <=> v53217(VarCurr,50) )
      & ( v68362(VarCurr,57)
      <=> v53217(VarCurr,49) )
      & ( v68362(VarCurr,56)
      <=> v53217(VarCurr,48) )
      & ( v68362(VarCurr,55)
      <=> v53217(VarCurr,47) )
      & ( v68362(VarCurr,54)
      <=> v53217(VarCurr,46) )
      & ( v68362(VarCurr,53)
      <=> v53217(VarCurr,45) )
      & ( v68362(VarCurr,52)
      <=> v53217(VarCurr,44) )
      & ( v68362(VarCurr,51)
      <=> v53217(VarCurr,43) )
      & ( v68362(VarCurr,50)
      <=> v53217(VarCurr,42) )
      & ( v68362(VarCurr,49)
      <=> v53217(VarCurr,41) )
      & ( v68362(VarCurr,48)
      <=> v53217(VarCurr,40) )
      & ( v68362(VarCurr,47)
      <=> v53217(VarCurr,39) )
      & ( v68362(VarCurr,46)
      <=> v53217(VarCurr,38) )
      & ( v68362(VarCurr,45)
      <=> v53217(VarCurr,37) )
      & ( v68362(VarCurr,44)
      <=> v53217(VarCurr,36) )
      & ( v68362(VarCurr,43)
      <=> v53217(VarCurr,35) )
      & ( v68362(VarCurr,42)
      <=> v53217(VarCurr,34) )
      & ( v68362(VarCurr,41)
      <=> v53217(VarCurr,33) )
      & ( v68362(VarCurr,40)
      <=> v53217(VarCurr,32) )
      & ( v68362(VarCurr,39)
      <=> v53217(VarCurr,31) )
      & ( v68362(VarCurr,38)
      <=> v53217(VarCurr,30) )
      & ( v68362(VarCurr,37)
      <=> v53217(VarCurr,29) )
      & ( v68362(VarCurr,36)
      <=> v53217(VarCurr,28) )
      & ( v68362(VarCurr,35)
      <=> v53217(VarCurr,27) )
      & ( v68362(VarCurr,34)
      <=> v53217(VarCurr,26) )
      & ( v68362(VarCurr,33)
      <=> v53217(VarCurr,25) )
      & ( v68362(VarCurr,32)
      <=> v53217(VarCurr,24) )
      & ( v68362(VarCurr,31)
      <=> v53217(VarCurr,23) )
      & ( v68362(VarCurr,30)
      <=> v53217(VarCurr,22) )
      & ( v68362(VarCurr,29)
      <=> v53217(VarCurr,21) )
      & ( v68362(VarCurr,28)
      <=> v53217(VarCurr,20) )
      & ( v68362(VarCurr,27)
      <=> v53217(VarCurr,19) )
      & ( v68362(VarCurr,26)
      <=> v53217(VarCurr,18) )
      & ( v68362(VarCurr,25)
      <=> v53217(VarCurr,17) )
      & ( v68362(VarCurr,24)
      <=> v53217(VarCurr,16) )
      & ( v68362(VarCurr,23)
      <=> v53217(VarCurr,15) )
      & ( v68362(VarCurr,22)
      <=> v53217(VarCurr,14) )
      & ( v68362(VarCurr,21)
      <=> v53217(VarCurr,13) )
      & ( v68362(VarCurr,20)
      <=> v53217(VarCurr,12) )
      & ( v68362(VarCurr,19)
      <=> v53217(VarCurr,11) )
      & ( v68362(VarCurr,18)
      <=> v53217(VarCurr,10) )
      & ( v68362(VarCurr,17)
      <=> v53217(VarCurr,9) )
      & ( v68362(VarCurr,16)
      <=> v53217(VarCurr,8) )
      & ( v68362(VarCurr,15)
      <=> v53217(VarCurr,7) )
      & ( v68362(VarCurr,14)
      <=> v53217(VarCurr,6) )
      & ( v68362(VarCurr,13)
      <=> v53217(VarCurr,5) )
      & ( v68362(VarCurr,12)
      <=> v53217(VarCurr,4) )
      & ( v68362(VarCurr,11)
      <=> v53217(VarCurr,3) )
      & ( v68362(VarCurr,10)
      <=> v53217(VarCurr,2) )
      & ( v68362(VarCurr,9)
      <=> v53217(VarCurr,1) )
      & ( v68362(VarCurr,8)
      <=> v53217(VarCurr,0) ) ) ).

tff(addAssignment_39992,axiom,
    ! [VarCurr: state_type] :
      ( v68355(VarCurr,63)
    <=> v68357(VarCurr,63) ) ).

tff(addAssignment_39991,axiom,
    ! [VarCurr: state_type] :
      ( v68357(VarCurr,63)
    <=> $false ) ).

tff(addAssignment_39990,axiom,
    ! [VarCurr: state_type] :
      ( v68312(VarCurr,0)
    <=> v68348(VarCurr) ) ).

tff(addAssignment_39989,axiom,
    ! [VarCurr: state_type] :
      ( v68312(VarCurr,1)
    <=> v68340(VarCurr) ) ).

tff(addAssignment_39988,axiom,
    ! [VarCurr: state_type] :
      ( v68312(VarCurr,2)
    <=> v68318(VarCurr) ) ).

tff(addAssignment_39987,axiom,
    ! [VarCurr: state_type] :
      ( v68312(VarCurr,3)
    <=> v68314(VarCurr) ) ).

tff(addAssignment_39986,axiom,
    ! [VarCurr: state_type] :
      ( v68348(VarCurr)
    <=> v68350(VarCurr) ) ).

tff(addAssignment_39985,axiom,
    ! [VarCurr: state_type] :
      ( v68350(VarCurr)
    <=> v68352(VarCurr) ) ).

tff(addAssignment_39984,axiom,
    ! [VarCurr: state_type] :
      ( v68352(VarCurr)
    <=> v68324(VarCurr) ) ).

tff(addAssignment_39983,axiom,
    ! [VarCurr: state_type] :
      ( v68340(VarCurr)
    <=> v68342(VarCurr) ) ).

tff(addAssignment_39982,axiom,
    ! [VarCurr: state_type] :
      ( v68342(VarCurr)
    <=> v68344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6259,axiom,
    ! [VarCurr: state_type] :
      ( v68344(VarCurr)
    <=> ( v68346(VarCurr)
        & v68328(VarCurr) ) ) ).

tff(writeUnaryOperator_3290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68346(VarCurr)
    <=> v68324(VarCurr) ) ).

tff(addAssignment_39981,axiom,
    ! [VarCurr: state_type] :
      ( v68318(VarCurr)
    <=> v68320(VarCurr) ) ).

tff(addAssignment_39980,axiom,
    ! [VarCurr: state_type] :
      ( v68320(VarCurr)
    <=> v68322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6258,axiom,
    ! [VarCurr: state_type] :
      ( v68322(VarCurr)
    <=> ( v68336(VarCurr)
        & v68332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6257,axiom,
    ! [VarCurr: state_type] :
      ( v68336(VarCurr)
    <=> ( v68337(VarCurr)
        & v68338(VarCurr) ) ) ).

tff(writeUnaryOperator_3289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68338(VarCurr)
    <=> v68328(VarCurr) ) ).

tff(writeUnaryOperator_3288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v68337(VarCurr)
    <=> v68324(VarCurr) ) ).

tff(addAssignment_39979,axiom,
    ! [VarCurr: state_type] :
      ( v68332(VarCurr)
    <=> v68334(VarCurr) ) ).

tff(addAssignment_39978,axiom,
    ! [VarCurr: state_type] :
      ( v68334(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_39977,axiom,
    ! [VarCurr: state_type] :
      ( v68328(VarCurr)
    <=> v68330(VarCurr) ) ).

tff(addAssignment_39976,axiom,
    ! [VarCurr: state_type] :
      ( v68330(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_39975,axiom,
    ! [VarCurr: state_type] :
      ( v68324(VarCurr)
    <=> v68326(VarCurr) ) ).

tff(addAssignment_39974,axiom,
    ! [VarCurr: state_type] :
      ( v68326(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_39973,axiom,
    ! [VarCurr: state_type] :
      ( v68314(VarCurr)
    <=> v68316(VarCurr) ) ).

tff(addAssignment_39972,axiom,
    ! [VarCurr: state_type] :
      ( v68316(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_39971,axiom,
    ! [VarCurr: state_type] :
      ( v68298(VarCurr,63)
    <=> v68300(VarCurr,63) ) ).

tff(addAssignment_39970,axiom,
    ! [VarCurr: state_type] :
      ( v68300(VarCurr,63)
    <=> v68301(VarCurr,63) ) ).

tff(addAssignment_39969,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,0)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39968,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,1)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39967,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,2)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39966,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,3)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39965,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,4)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39964,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,5)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39963,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,6)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39962,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,7)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39961,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,8)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39960,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,9)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39959,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,10)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39958,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,11)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39957,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,12)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39956,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,13)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39955,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,14)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39954,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,15)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39953,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,16)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39952,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,17)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39951,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,18)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39950,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,19)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39949,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,20)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39948,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,21)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39947,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,22)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39946,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,23)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39945,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,24)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39944,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,25)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39943,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,26)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39942,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,27)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39941,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,28)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39940,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,29)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39939,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,30)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39938,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,31)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39937,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,32)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39936,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,33)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39935,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,34)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39934,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,35)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39933,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,36)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39932,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,37)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39931,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,38)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39930,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,39)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39929,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,40)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39928,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,41)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39927,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,42)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39926,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,43)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39925,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,44)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39924,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,45)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39923,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,46)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39922,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,47)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39921,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,48)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39920,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,49)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39919,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,50)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39918,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,51)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39917,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,52)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39916,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,53)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39915,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,54)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39914,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,55)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39913,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,56)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39912,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,57)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39911,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,58)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39910,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,59)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39909,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,60)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39908,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,61)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39907,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,62)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39906,axiom,
    ! [VarCurr: state_type] :
      ( v68301(VarCurr,63)
    <=> v68302(VarCurr) ) ).

tff(addAssignment_39905,axiom,
    ! [VarCurr: state_type] :
      ( v68302(VarCurr)
    <=> v67411(VarCurr) ) ).

tff(addAssignment_39904,axiom,
    ! [VarCurr: state_type] :
      ( v68272(VarCurr)
    <=> v68274(VarCurr) ) ).

tff(addAssignment_39903,axiom,
    ! [VarCurr: state_type] :
      ( v68274(VarCurr)
    <=> v68276(VarCurr) ) ).

tff(addAssignment_39902,axiom,
    ! [VarCurr: state_type] :
      ( v68276(VarCurr)
    <=> v68278(VarCurr) ) ).

tff(addAssignment_39901,axiom,
    ! [VarCurr: state_type] :
      ( v68278(VarCurr)
    <=> v68280(VarCurr) ) ).

tff(addAssignment_39900,axiom,
    ! [VarCurr: state_type] :
      ( v68280(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_39899,axiom,
    ! [VarCurr: state_type] :
      ( v68262(VarCurr)
    <=> v68264(VarCurr) ) ).

tff(addAssignment_39898,axiom,
    ! [VarCurr: state_type] :
      ( v68264(VarCurr)
    <=> v68266(VarCurr) ) ).

tff(addAssignment_39897,axiom,
    ! [VarCurr: state_type] :
      ( v68266(VarCurr)
    <=> v68268(VarCurr) ) ).

tff(addAssignment_39896,axiom,
    ! [VarCurr: state_type] :
      ( v68268(VarCurr)
    <=> v68270(VarCurr) ) ).

tff(addAssignment_39895,axiom,
    ! [VarCurr: state_type] :
      ( v68270(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_39894,axiom,
    ! [VarCurr: state_type] :
      ( v68103(VarCurr)
    <=> v68105(VarCurr) ) ).

tff(addAssignment_39893,axiom,
    ! [VarCurr: state_type] :
      ( v68105(VarCurr)
    <=> v68107(VarCurr) ) ).

tff(addAssignment_39892,axiom,
    ! [VarCurr: state_type] :
      ( v68107(VarCurr)
    <=> v68109(VarCurr) ) ).

tff(addAssignment_39891,axiom,
    ! [VarCurr: state_type] :
      ( v68109(VarCurr)
    <=> v68111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6256,axiom,
    ! [VarCurr: state_type] :
      ( v68111(VarCurr)
    <=> ( v68233(VarCurr)
      <~> v68193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6255,axiom,
    ! [VarCurr: state_type] :
      ( v68233(VarCurr)
    <=> ( v68113(VarCurr)
      <~> v68153(VarCurr) ) ) ).

tff(addAssignment_39890,axiom,
    ! [VarCurr: state_type] :
      ( v68193(VarCurr)
    <=> v68195(VarCurr) ) ).

tff(addAssignment_39889,axiom,
    ! [VarCurr: state_type] :
      ( v68195(VarCurr)
    <=> v67349(VarCurr,59) ) ).

tff(addAssignment_39888,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,59)
    <=> v67351(VarCurr,59) ) ).

tff(addAssignment_39887,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,59)
    <=> v67353(VarCurr,59) ) ).

tff(addAssignment_39886,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,59)
    <=> v67355(VarCurr,59) ) ).

tff(addAssignment_39885,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,59)
    <=> v67357(VarCurr,59) ) ).

tff(addAssignment_39884,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,59)
    <=> v67359(VarCurr,59) ) ).

tff(addAssignment_39883,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,59)
    <=> v67580(VarCurr,59) ) ).

tff(addAssignment_39882,axiom,
    ! [VarCurr: state_type] :
      ( v67598(VarCurr,3)
    <=> v67363(VarCurr,59) ) ).

tff(addAssignment_39881,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,59)
    <=> v67365(VarCurr,59) ) ).

tff(addAssignment_39880,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,59)
    <=> v68225(VarNext,59) ) ).

tff(addCaseBooleanConditionEqualRanges1_779,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68226(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68225(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_779,axiom,
    ! [VarNext: state_type] :
      ( v68226(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68225(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68226(VarNext)
      <=> v68227(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68227(VarNext)
      <=> ( v68229(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68229(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39879,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,59)
    <=> v67389(VarCurr,59) ) ).

tff(addAssignment_39878,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,59)
    <=> v67391(VarCurr,59) ) ).

tff(addAssignment_39877,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,59)
    <=> v68198(VarCurr,3) ) ).

tff(addAssignment_39876,axiom,
    ! [VarCurr: state_type] :
      ( v68198(VarCurr,3)
    <=> v68200(VarCurr,3) ) ).

tff(addAssignment_39875,axiom,
    ! [VarCurr: state_type] :
      ( v68200(VarCurr,3)
    <=> v68217(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68217(VarCurr,B)
      <=> ( v68218(VarCurr,B)
          | v68221(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68221(VarCurr,B)
      <=> ( v68210(VarCurr,B)
          & v68222(VarCurr,B) ) ) ) ).

tff(addAssignment_39874,axiom,
    ! [VarCurr: state_type] :
      ( v68222(VarCurr,0)
    <=> v68223(VarCurr) ) ).

tff(addAssignment_39873,axiom,
    ! [VarCurr: state_type] :
      ( v68222(VarCurr,1)
    <=> v68223(VarCurr) ) ).

tff(addAssignment_39872,axiom,
    ! [VarCurr: state_type] :
      ( v68222(VarCurr,2)
    <=> v68223(VarCurr) ) ).

tff(addAssignment_39871,axiom,
    ! [VarCurr: state_type] :
      ( v68222(VarCurr,3)
    <=> v68223(VarCurr) ) ).

tff(addAssignment_39870,axiom,
    ! [VarCurr: state_type] :
      ( v68223(VarCurr)
    <=> v68214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68218(VarCurr,B)
      <=> ( v68202(VarCurr,B)
          & v68219(VarCurr,B) ) ) ) ).

tff(addAssignment_39869,axiom,
    ! [VarCurr: state_type] :
      ( v68219(VarCurr,0)
    <=> v68220(VarCurr) ) ).

tff(addAssignment_39868,axiom,
    ! [VarCurr: state_type] :
      ( v68219(VarCurr,1)
    <=> v68220(VarCurr) ) ).

tff(addAssignment_39867,axiom,
    ! [VarCurr: state_type] :
      ( v68219(VarCurr,2)
    <=> v68220(VarCurr) ) ).

tff(addAssignment_39866,axiom,
    ! [VarCurr: state_type] :
      ( v68219(VarCurr,3)
    <=> v68220(VarCurr) ) ).

tff(addAssignment_39865,axiom,
    ! [VarCurr: state_type] :
      ( v68220(VarCurr)
    <=> v68206(VarCurr) ) ).

tff(addAssignment_39864,axiom,
    ! [VarCurr: state_type] :
      ( v68214(VarCurr)
    <=> v68216(VarCurr) ) ).

tff(addAssignment_39863,axiom,
    ! [VarCurr: state_type] :
      ( v68216(VarCurr)
    <=> v67530(VarCurr,14) ) ).

tff(addAssignment_39862,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,14)
    <=> v52381(VarCurr,14) ) ).

tff(addAssignment_39861,axiom,
    ! [VarCurr: state_type] :
      ( v68210(VarCurr,3)
    <=> v68212(VarCurr,3) ) ).

tff(addAssignment_39860,axiom,
    ! [VarCurr: state_type] :
      ( v68212(VarCurr,3)
    <=> v67401(VarCurr,59) ) ).

tff(addAssignment_39859,axiom,
    ! [VarCurr: state_type] :
      ( v68206(VarCurr)
    <=> v68208(VarCurr) ) ).

tff(addAssignment_39858,axiom,
    ! [VarCurr: state_type] :
      ( v68208(VarCurr)
    <=> v67520(VarCurr,14) ) ).

tff(addAssignment_39857,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,14)
    <=> v52363(VarCurr,14) ) ).

tff(addAssignment_39856,axiom,
    ! [VarCurr: state_type] :
      ( v68202(VarCurr,3)
    <=> v68204(VarCurr,3) ) ).

tff(addAssignment_39855,axiom,
    ! [VarCurr: state_type] :
      ( v68204(VarCurr,3)
    <=> v67401(VarCurr,63) ) ).

tff(addAssignment_39854,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,63)
    <=> v67403(VarCurr,63) ) ).

tff(addAssignment_39853,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,63)
    <=> v67405(VarCurr,63) ) ).

tff(addAssignment_39852,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,63)
    <=> v67514(VarCurr,63) ) ).

tff(addAssignment_39851,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,63)
    <=> v67428(VarCurr,63) ) ).

tff(addAssignment_39850,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,63)
    <=> v67430(VarCurr,63) ) ).

tff(addAssignment_39849,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,63)
    <=> v67432(VarCurr,63) ) ).

tff(addAssignment_39848,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,63)
    <=> v67434(VarCurr,63) ) ).

tff(addAssignment_39847,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,63)
    <=> v67436(VarCurr,63) ) ).

tff(addAssignment_39846,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,63)
    <=> v67438(VarCurr,63) ) ).

tff(addAssignment_39845,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,63)
    <=> v67497(VarCurr,63) ) ).

tff(addAssignment_39844,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,63)
    <=> v67493(VarCurr,63) ) ).

tff(addAssignment_39843,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,63)
    <=> v67495(VarCurr,63) ) ).

tff(addAssignment_39842,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,63)
    <=> v67496(VarCurr,63) ) ).

tff(addAssignment_39841,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,129)
    <=> v33839(VarCurr,129) ) ).

tff(addAssignment_39840,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,129)
    <=> v33841(VarCurr,129) ) ).

tff(addAssignment_39839,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,129)
    <=> v25005(VarCurr,9) ) ).

tff(addAssignment_39838,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,63)
    <=> v67489(VarCurr,63) ) ).

tff(addAssignment_39837,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,63)
    <=> v6234(VarCurr,63) ) ).

tff(addAssignment_39836,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,63)
    <=> v67485(VarCurr,63) ) ).

tff(addAssignment_39835,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,63)
    <=> $false ) ).

tff(addAssignment_39834,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,63)
    <=> v67409(VarCurr,63) ) ).

tff(addAssignment_39833,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,63)
    <=> v67423(VarCurr,63) ) ).

tff(addAssignment_39832,axiom,
    ! [VarCurr: state_type] :
      ( v68153(VarCurr)
    <=> v68155(VarCurr) ) ).

tff(addAssignment_39831,axiom,
    ! [VarCurr: state_type] :
      ( v68155(VarCurr)
    <=> v67349(VarCurr,55) ) ).

tff(addAssignment_39830,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,55)
    <=> v67351(VarCurr,55) ) ).

tff(addAssignment_39829,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,55)
    <=> v67353(VarCurr,55) ) ).

tff(addAssignment_39828,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,55)
    <=> v67355(VarCurr,55) ) ).

tff(addAssignment_39827,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,55)
    <=> v67357(VarCurr,55) ) ).

tff(addAssignment_39826,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,55)
    <=> v67359(VarCurr,55) ) ).

tff(addAssignment_39825,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,55)
    <=> v67580(VarCurr,55) ) ).

tff(addAssignment_39824,axiom,
    ! [VarCurr: state_type] :
      ( v67599(VarCurr,3)
    <=> v67363(VarCurr,55) ) ).

tff(addAssignment_39823,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,55)
    <=> v67365(VarCurr,55) ) ).

tff(addAssignment_39822,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,55)
    <=> v68185(VarNext,55) ) ).

tff(addCaseBooleanConditionEqualRanges1_778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68186(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68185(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_778,axiom,
    ! [VarNext: state_type] :
      ( v68186(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68185(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68186(VarNext)
      <=> v68187(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68187(VarNext)
      <=> ( v68189(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68189(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39821,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,55)
    <=> v67389(VarCurr,55) ) ).

tff(addAssignment_39820,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,55)
    <=> v67391(VarCurr,55) ) ).

tff(addAssignment_39819,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,55)
    <=> v68158(VarCurr,3) ) ).

tff(addAssignment_39818,axiom,
    ! [VarCurr: state_type] :
      ( v68158(VarCurr,3)
    <=> v68160(VarCurr,3) ) ).

tff(addAssignment_39817,axiom,
    ! [VarCurr: state_type] :
      ( v68160(VarCurr,3)
    <=> v68177(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68177(VarCurr,B)
      <=> ( v68178(VarCurr,B)
          | v68181(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68181(VarCurr,B)
      <=> ( v68170(VarCurr,B)
          & v68182(VarCurr,B) ) ) ) ).

tff(addAssignment_39816,axiom,
    ! [VarCurr: state_type] :
      ( v68182(VarCurr,0)
    <=> v68183(VarCurr) ) ).

tff(addAssignment_39815,axiom,
    ! [VarCurr: state_type] :
      ( v68182(VarCurr,1)
    <=> v68183(VarCurr) ) ).

tff(addAssignment_39814,axiom,
    ! [VarCurr: state_type] :
      ( v68182(VarCurr,2)
    <=> v68183(VarCurr) ) ).

tff(addAssignment_39813,axiom,
    ! [VarCurr: state_type] :
      ( v68182(VarCurr,3)
    <=> v68183(VarCurr) ) ).

tff(addAssignment_39812,axiom,
    ! [VarCurr: state_type] :
      ( v68183(VarCurr)
    <=> v68174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68178(VarCurr,B)
      <=> ( v68162(VarCurr,B)
          & v68179(VarCurr,B) ) ) ) ).

tff(addAssignment_39811,axiom,
    ! [VarCurr: state_type] :
      ( v68179(VarCurr,0)
    <=> v68180(VarCurr) ) ).

tff(addAssignment_39810,axiom,
    ! [VarCurr: state_type] :
      ( v68179(VarCurr,1)
    <=> v68180(VarCurr) ) ).

tff(addAssignment_39809,axiom,
    ! [VarCurr: state_type] :
      ( v68179(VarCurr,2)
    <=> v68180(VarCurr) ) ).

tff(addAssignment_39808,axiom,
    ! [VarCurr: state_type] :
      ( v68179(VarCurr,3)
    <=> v68180(VarCurr) ) ).

tff(addAssignment_39807,axiom,
    ! [VarCurr: state_type] :
      ( v68180(VarCurr)
    <=> v68166(VarCurr) ) ).

tff(addAssignment_39806,axiom,
    ! [VarCurr: state_type] :
      ( v68174(VarCurr)
    <=> v68176(VarCurr) ) ).

tff(addAssignment_39805,axiom,
    ! [VarCurr: state_type] :
      ( v68176(VarCurr)
    <=> v67530(VarCurr,13) ) ).

tff(addAssignment_39804,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,13)
    <=> v52381(VarCurr,13) ) ).

tff(addAssignment_39803,axiom,
    ! [VarCurr: state_type] :
      ( v68170(VarCurr,3)
    <=> v68172(VarCurr,3) ) ).

tff(addAssignment_39802,axiom,
    ! [VarCurr: state_type] :
      ( v68172(VarCurr,3)
    <=> v67401(VarCurr,55) ) ).

tff(addAssignment_39801,axiom,
    ! [VarCurr: state_type] :
      ( v68166(VarCurr)
    <=> v68168(VarCurr) ) ).

tff(addAssignment_39800,axiom,
    ! [VarCurr: state_type] :
      ( v68168(VarCurr)
    <=> v67520(VarCurr,13) ) ).

tff(addAssignment_39799,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,13)
    <=> v52363(VarCurr,13) ) ).

tff(addAssignment_39798,axiom,
    ! [VarCurr: state_type] :
      ( v68162(VarCurr,3)
    <=> v68164(VarCurr,3) ) ).

tff(addAssignment_39797,axiom,
    ! [VarCurr: state_type] :
      ( v68164(VarCurr,3)
    <=> v67401(VarCurr,59) ) ).

tff(addAssignment_39796,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,59)
    <=> v67403(VarCurr,59) ) ).

tff(addAssignment_39795,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,59)
    <=> v67405(VarCurr,59) ) ).

tff(addAssignment_39794,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,59)
    <=> v67514(VarCurr,59) ) ).

tff(addAssignment_39793,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,59)
    <=> v67428(VarCurr,59) ) ).

tff(addAssignment_39792,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,59)
    <=> v67430(VarCurr,59) ) ).

tff(addAssignment_39791,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,59)
    <=> v67432(VarCurr,59) ) ).

tff(addAssignment_39790,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,59)
    <=> v67434(VarCurr,59) ) ).

tff(addAssignment_39789,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,59)
    <=> v67436(VarCurr,59) ) ).

tff(addAssignment_39788,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,59)
    <=> v67438(VarCurr,59) ) ).

tff(addAssignment_39787,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,59)
    <=> v67497(VarCurr,59) ) ).

tff(addAssignment_39786,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,59)
    <=> v67493(VarCurr,59) ) ).

tff(addAssignment_39785,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,59)
    <=> v67495(VarCurr,59) ) ).

tff(addAssignment_39784,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,59)
    <=> v67496(VarCurr,59) ) ).

tff(addAssignment_39783,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,119)
    <=> v33839(VarCurr,119) ) ).

tff(addAssignment_39782,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,119)
    <=> v33841(VarCurr,119) ) ).

tff(addAssignment_39781,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,119)
    <=> v23455(VarCurr,11) ) ).

tff(addAssignment_39780,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,59)
    <=> v67489(VarCurr,59) ) ).

tff(addAssignment_39779,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,59)
    <=> v6234(VarCurr,59) ) ).

tff(addAssignment_39778,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,59)
    <=> v67485(VarCurr,59) ) ).

tff(addAssignment_39777,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,59)
    <=> $false ) ).

tff(addAssignment_39776,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,59)
    <=> v67409(VarCurr,59) ) ).

tff(addAssignment_39775,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,59)
    <=> v67423(VarCurr,59) ) ).

tff(addAssignment_39774,axiom,
    ! [VarCurr: state_type] :
      ( v68113(VarCurr)
    <=> v68115(VarCurr) ) ).

tff(addAssignment_39773,axiom,
    ! [VarCurr: state_type] :
      ( v68115(VarCurr)
    <=> v67349(VarCurr,51) ) ).

tff(addAssignment_39772,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,51)
    <=> v67351(VarCurr,51) ) ).

tff(addAssignment_39771,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,51)
    <=> v67353(VarCurr,51) ) ).

tff(addAssignment_39770,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,51)
    <=> v67355(VarCurr,51) ) ).

tff(addAssignment_39769,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,51)
    <=> v67357(VarCurr,51) ) ).

tff(addAssignment_39768,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,51)
    <=> v67359(VarCurr,51) ) ).

tff(addAssignment_39767,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,51)
    <=> v67580(VarCurr,51) ) ).

tff(addAssignment_39766,axiom,
    ! [VarCurr: state_type] :
      ( v67600(VarCurr,3)
    <=> v67363(VarCurr,51) ) ).

tff(addAssignment_39765,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,51)
    <=> v67365(VarCurr,51) ) ).

tff(addAssignment_39764,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,51)
    <=> v68145(VarNext,51) ) ).

tff(addCaseBooleanConditionEqualRanges1_777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68146(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68145(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_777,axiom,
    ! [VarNext: state_type] :
      ( v68146(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68145(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68146(VarNext)
      <=> v68147(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68147(VarNext)
      <=> ( v68149(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68149(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39763,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,51)
    <=> v67389(VarCurr,51) ) ).

tff(addAssignment_39762,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,51)
    <=> v67391(VarCurr,51) ) ).

tff(addAssignment_39761,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,51)
    <=> v68118(VarCurr,3) ) ).

tff(addAssignment_39760,axiom,
    ! [VarCurr: state_type] :
      ( v68118(VarCurr,3)
    <=> v68120(VarCurr,3) ) ).

tff(addAssignment_39759,axiom,
    ! [VarCurr: state_type] :
      ( v68120(VarCurr,3)
    <=> v68137(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68137(VarCurr,B)
      <=> ( v68138(VarCurr,B)
          | v68141(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68141(VarCurr,B)
      <=> ( v68130(VarCurr,B)
          & v68142(VarCurr,B) ) ) ) ).

tff(addAssignment_39758,axiom,
    ! [VarCurr: state_type] :
      ( v68142(VarCurr,0)
    <=> v68143(VarCurr) ) ).

tff(addAssignment_39757,axiom,
    ! [VarCurr: state_type] :
      ( v68142(VarCurr,1)
    <=> v68143(VarCurr) ) ).

tff(addAssignment_39756,axiom,
    ! [VarCurr: state_type] :
      ( v68142(VarCurr,2)
    <=> v68143(VarCurr) ) ).

tff(addAssignment_39755,axiom,
    ! [VarCurr: state_type] :
      ( v68142(VarCurr,3)
    <=> v68143(VarCurr) ) ).

tff(addAssignment_39754,axiom,
    ! [VarCurr: state_type] :
      ( v68143(VarCurr)
    <=> v68134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68138(VarCurr,B)
      <=> ( v68122(VarCurr,B)
          & v68139(VarCurr,B) ) ) ) ).

tff(addAssignment_39753,axiom,
    ! [VarCurr: state_type] :
      ( v68139(VarCurr,0)
    <=> v68140(VarCurr) ) ).

tff(addAssignment_39752,axiom,
    ! [VarCurr: state_type] :
      ( v68139(VarCurr,1)
    <=> v68140(VarCurr) ) ).

tff(addAssignment_39751,axiom,
    ! [VarCurr: state_type] :
      ( v68139(VarCurr,2)
    <=> v68140(VarCurr) ) ).

tff(addAssignment_39750,axiom,
    ! [VarCurr: state_type] :
      ( v68139(VarCurr,3)
    <=> v68140(VarCurr) ) ).

tff(addAssignment_39749,axiom,
    ! [VarCurr: state_type] :
      ( v68140(VarCurr)
    <=> v68126(VarCurr) ) ).

tff(addAssignment_39748,axiom,
    ! [VarCurr: state_type] :
      ( v68134(VarCurr)
    <=> v68136(VarCurr) ) ).

tff(addAssignment_39747,axiom,
    ! [VarCurr: state_type] :
      ( v68136(VarCurr)
    <=> v67530(VarCurr,12) ) ).

tff(addAssignment_39746,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,12)
    <=> v52381(VarCurr,12) ) ).

tff(addAssignment_39745,axiom,
    ! [VarCurr: state_type] :
      ( v68130(VarCurr,3)
    <=> v68132(VarCurr,3) ) ).

tff(addAssignment_39744,axiom,
    ! [VarCurr: state_type] :
      ( v68132(VarCurr,3)
    <=> v67401(VarCurr,51) ) ).

tff(addAssignment_39743,axiom,
    ! [VarCurr: state_type] :
      ( v68126(VarCurr)
    <=> v68128(VarCurr) ) ).

tff(addAssignment_39742,axiom,
    ! [VarCurr: state_type] :
      ( v68128(VarCurr)
    <=> v67520(VarCurr,12) ) ).

tff(addAssignment_39741,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,12)
    <=> v52363(VarCurr,12) ) ).

tff(addAssignment_39740,axiom,
    ! [VarCurr: state_type] :
      ( v68122(VarCurr,3)
    <=> v68124(VarCurr,3) ) ).

tff(addAssignment_39739,axiom,
    ! [VarCurr: state_type] :
      ( v68124(VarCurr,3)
    <=> v67401(VarCurr,55) ) ).

tff(addAssignment_39738,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,55)
    <=> v67403(VarCurr,55) ) ).

tff(addAssignment_39737,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,55)
    <=> v67405(VarCurr,55) ) ).

tff(addAssignment_39736,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,55)
    <=> v67514(VarCurr,55) ) ).

tff(addAssignment_39735,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,55)
    <=> v67428(VarCurr,55) ) ).

tff(addAssignment_39734,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,55)
    <=> v67430(VarCurr,55) ) ).

tff(addAssignment_39733,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,55)
    <=> v67432(VarCurr,55) ) ).

tff(addAssignment_39732,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,55)
    <=> v67434(VarCurr,55) ) ).

tff(addAssignment_39731,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,55)
    <=> v67436(VarCurr,55) ) ).

tff(addAssignment_39730,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,55)
    <=> v67438(VarCurr,55) ) ).

tff(addAssignment_39729,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,55)
    <=> v67497(VarCurr,55) ) ).

tff(addAssignment_39728,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,55)
    <=> v67493(VarCurr,55) ) ).

tff(addAssignment_39727,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,55)
    <=> v67495(VarCurr,55) ) ).

tff(addAssignment_39726,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,55)
    <=> v67496(VarCurr,55) ) ).

tff(addAssignment_39725,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,115)
    <=> v33839(VarCurr,115) ) ).

tff(addAssignment_39724,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,115)
    <=> v33841(VarCurr,115) ) ).

tff(addAssignment_39723,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,115)
    <=> v23455(VarCurr,7) ) ).

tff(addAssignment_39722,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,55)
    <=> v67489(VarCurr,55) ) ).

tff(addAssignment_39721,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,55)
    <=> v6234(VarCurr,55) ) ).

tff(addAssignment_39720,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,55)
    <=> v67485(VarCurr,55) ) ).

tff(addAssignment_39719,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,55)
    <=> $false ) ).

tff(addAssignment_39718,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,55)
    <=> v67409(VarCurr,55) ) ).

tff(addAssignment_39717,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,55)
    <=> v67423(VarCurr,55) ) ).

tff(addAssignment_39716,axiom,
    ! [VarCurr: state_type] :
      ( v67971(VarCurr)
    <=> v67973(VarCurr) ) ).

tff(addAssignment_39715,axiom,
    ! [VarCurr: state_type] :
      ( v67973(VarCurr)
    <=> v67975(VarCurr) ) ).

tff(addAssignment_39714,axiom,
    ! [VarCurr: state_type] :
      ( v67975(VarCurr)
    <=> v67977(VarCurr) ) ).

tff(addAssignment_39713,axiom,
    ! [VarCurr: state_type] :
      ( v67977(VarCurr)
    <=> v67979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6248,axiom,
    ! [VarCurr: state_type] :
      ( v67979(VarCurr)
    <=> ( v68101(VarCurr)
      <~> v68061(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6247,axiom,
    ! [VarCurr: state_type] :
      ( v68101(VarCurr)
    <=> ( v67981(VarCurr)
      <~> v68021(VarCurr) ) ) ).

tff(addAssignment_39712,axiom,
    ! [VarCurr: state_type] :
      ( v68061(VarCurr)
    <=> v68063(VarCurr) ) ).

tff(addAssignment_39711,axiom,
    ! [VarCurr: state_type] :
      ( v68063(VarCurr)
    <=> v67349(VarCurr,47) ) ).

tff(addAssignment_39710,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,47)
    <=> v67351(VarCurr,47) ) ).

tff(addAssignment_39709,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,47)
    <=> v67353(VarCurr,47) ) ).

tff(addAssignment_39708,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,47)
    <=> v67355(VarCurr,47) ) ).

tff(addAssignment_39707,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,47)
    <=> v67357(VarCurr,47) ) ).

tff(addAssignment_39706,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,47)
    <=> v67359(VarCurr,47) ) ).

tff(addAssignment_39705,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,47)
    <=> v67580(VarCurr,47) ) ).

tff(addAssignment_39704,axiom,
    ! [VarCurr: state_type] :
      ( v67601(VarCurr,3)
    <=> v67363(VarCurr,47) ) ).

tff(addAssignment_39703,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,47)
    <=> v67365(VarCurr,47) ) ).

tff(addAssignment_39702,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,47)
    <=> v68093(VarNext,47) ) ).

tff(addCaseBooleanConditionEqualRanges1_776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68094(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68093(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_776,axiom,
    ! [VarNext: state_type] :
      ( v68094(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68093(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68094(VarNext)
      <=> v68095(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68095(VarNext)
      <=> ( v68097(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68097(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39701,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,47)
    <=> v67389(VarCurr,47) ) ).

tff(addAssignment_39700,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,47)
    <=> v67391(VarCurr,47) ) ).

tff(addAssignment_39699,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,47)
    <=> v68066(VarCurr,3) ) ).

tff(addAssignment_39698,axiom,
    ! [VarCurr: state_type] :
      ( v68066(VarCurr,3)
    <=> v68068(VarCurr,3) ) ).

tff(addAssignment_39697,axiom,
    ! [VarCurr: state_type] :
      ( v68068(VarCurr,3)
    <=> v68085(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68085(VarCurr,B)
      <=> ( v68086(VarCurr,B)
          | v68089(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68089(VarCurr,B)
      <=> ( v68078(VarCurr,B)
          & v68090(VarCurr,B) ) ) ) ).

tff(addAssignment_39696,axiom,
    ! [VarCurr: state_type] :
      ( v68090(VarCurr,0)
    <=> v68091(VarCurr) ) ).

tff(addAssignment_39695,axiom,
    ! [VarCurr: state_type] :
      ( v68090(VarCurr,1)
    <=> v68091(VarCurr) ) ).

tff(addAssignment_39694,axiom,
    ! [VarCurr: state_type] :
      ( v68090(VarCurr,2)
    <=> v68091(VarCurr) ) ).

tff(addAssignment_39693,axiom,
    ! [VarCurr: state_type] :
      ( v68090(VarCurr,3)
    <=> v68091(VarCurr) ) ).

tff(addAssignment_39692,axiom,
    ! [VarCurr: state_type] :
      ( v68091(VarCurr)
    <=> v68082(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68086(VarCurr,B)
      <=> ( v68070(VarCurr,B)
          & v68087(VarCurr,B) ) ) ) ).

tff(addAssignment_39691,axiom,
    ! [VarCurr: state_type] :
      ( v68087(VarCurr,0)
    <=> v68088(VarCurr) ) ).

tff(addAssignment_39690,axiom,
    ! [VarCurr: state_type] :
      ( v68087(VarCurr,1)
    <=> v68088(VarCurr) ) ).

tff(addAssignment_39689,axiom,
    ! [VarCurr: state_type] :
      ( v68087(VarCurr,2)
    <=> v68088(VarCurr) ) ).

tff(addAssignment_39688,axiom,
    ! [VarCurr: state_type] :
      ( v68087(VarCurr,3)
    <=> v68088(VarCurr) ) ).

tff(addAssignment_39687,axiom,
    ! [VarCurr: state_type] :
      ( v68088(VarCurr)
    <=> v68074(VarCurr) ) ).

tff(addAssignment_39686,axiom,
    ! [VarCurr: state_type] :
      ( v68082(VarCurr)
    <=> v68084(VarCurr) ) ).

tff(addAssignment_39685,axiom,
    ! [VarCurr: state_type] :
      ( v68084(VarCurr)
    <=> v67530(VarCurr,11) ) ).

tff(addAssignment_39684,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,11)
    <=> v52381(VarCurr,11) ) ).

tff(addAssignment_39683,axiom,
    ! [VarCurr: state_type] :
      ( v68078(VarCurr,3)
    <=> v68080(VarCurr,3) ) ).

tff(addAssignment_39682,axiom,
    ! [VarCurr: state_type] :
      ( v68080(VarCurr,3)
    <=> v67401(VarCurr,47) ) ).

tff(addAssignment_39681,axiom,
    ! [VarCurr: state_type] :
      ( v68074(VarCurr)
    <=> v68076(VarCurr) ) ).

tff(addAssignment_39680,axiom,
    ! [VarCurr: state_type] :
      ( v68076(VarCurr)
    <=> v67520(VarCurr,11) ) ).

tff(addAssignment_39679,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,11)
    <=> v52363(VarCurr,11) ) ).

tff(addAssignment_39678,axiom,
    ! [VarCurr: state_type] :
      ( v68070(VarCurr,3)
    <=> v68072(VarCurr,3) ) ).

tff(addAssignment_39677,axiom,
    ! [VarCurr: state_type] :
      ( v68072(VarCurr,3)
    <=> v67401(VarCurr,51) ) ).

tff(addAssignment_39676,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,51)
    <=> v67403(VarCurr,51) ) ).

tff(addAssignment_39675,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,51)
    <=> v67405(VarCurr,51) ) ).

tff(addAssignment_39674,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,51)
    <=> v67514(VarCurr,51) ) ).

tff(addAssignment_39673,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,51)
    <=> v67428(VarCurr,51) ) ).

tff(addAssignment_39672,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,51)
    <=> v67430(VarCurr,51) ) ).

tff(addAssignment_39671,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,51)
    <=> v67432(VarCurr,51) ) ).

tff(addAssignment_39670,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,51)
    <=> v67434(VarCurr,51) ) ).

tff(addAssignment_39669,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,51)
    <=> v67436(VarCurr,51) ) ).

tff(addAssignment_39668,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,51)
    <=> v67438(VarCurr,51) ) ).

tff(addAssignment_39667,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,51)
    <=> v67497(VarCurr,51) ) ).

tff(addAssignment_39666,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,51)
    <=> v67493(VarCurr,51) ) ).

tff(addAssignment_39665,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,51)
    <=> v67495(VarCurr,51) ) ).

tff(addAssignment_39664,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,51)
    <=> v67496(VarCurr,51) ) ).

tff(addAssignment_39663,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,105)
    <=> v33839(VarCurr,105) ) ).

tff(addAssignment_39662,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,105)
    <=> v33841(VarCurr,105) ) ).

tff(addAssignment_39661,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,105)
    <=> v21905(VarCurr,9) ) ).

tff(addAssignment_39660,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,51)
    <=> v67489(VarCurr,51) ) ).

tff(addAssignment_39659,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,51)
    <=> v6234(VarCurr,51) ) ).

tff(addAssignment_39658,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,51)
    <=> v67485(VarCurr,51) ) ).

tff(addAssignment_39657,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,51)
    <=> $false ) ).

tff(addAssignment_39656,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,51)
    <=> v67409(VarCurr,51) ) ).

tff(addAssignment_39655,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,51)
    <=> v67423(VarCurr,51) ) ).

tff(addAssignment_39654,axiom,
    ! [VarCurr: state_type] :
      ( v68021(VarCurr)
    <=> v68023(VarCurr) ) ).

tff(addAssignment_39653,axiom,
    ! [VarCurr: state_type] :
      ( v68023(VarCurr)
    <=> v67349(VarCurr,43) ) ).

tff(addAssignment_39652,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,43)
    <=> v67351(VarCurr,43) ) ).

tff(addAssignment_39651,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,43)
    <=> v67353(VarCurr,43) ) ).

tff(addAssignment_39650,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,43)
    <=> v67355(VarCurr,43) ) ).

tff(addAssignment_39649,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,43)
    <=> v67357(VarCurr,43) ) ).

tff(addAssignment_39648,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,43)
    <=> v67359(VarCurr,43) ) ).

tff(addAssignment_39647,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,43)
    <=> v67580(VarCurr,43) ) ).

tff(addAssignment_39646,axiom,
    ! [VarCurr: state_type] :
      ( v67602(VarCurr,3)
    <=> v67363(VarCurr,43) ) ).

tff(addAssignment_39645,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,43)
    <=> v67365(VarCurr,43) ) ).

tff(addAssignment_39644,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,43)
    <=> v68053(VarNext,43) ) ).

tff(addCaseBooleanConditionEqualRanges1_775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68054(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68053(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_775,axiom,
    ! [VarNext: state_type] :
      ( v68054(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68053(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68054(VarNext)
      <=> v68055(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68055(VarNext)
      <=> ( v68057(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68057(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39643,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,43)
    <=> v67389(VarCurr,43) ) ).

tff(addAssignment_39642,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,43)
    <=> v67391(VarCurr,43) ) ).

tff(addAssignment_39641,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,43)
    <=> v68026(VarCurr,3) ) ).

tff(addAssignment_39640,axiom,
    ! [VarCurr: state_type] :
      ( v68026(VarCurr,3)
    <=> v68028(VarCurr,3) ) ).

tff(addAssignment_39639,axiom,
    ! [VarCurr: state_type] :
      ( v68028(VarCurr,3)
    <=> v68045(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68045(VarCurr,B)
      <=> ( v68046(VarCurr,B)
          | v68049(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_981,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68049(VarCurr,B)
      <=> ( v68038(VarCurr,B)
          & v68050(VarCurr,B) ) ) ) ).

tff(addAssignment_39638,axiom,
    ! [VarCurr: state_type] :
      ( v68050(VarCurr,0)
    <=> v68051(VarCurr) ) ).

tff(addAssignment_39637,axiom,
    ! [VarCurr: state_type] :
      ( v68050(VarCurr,1)
    <=> v68051(VarCurr) ) ).

tff(addAssignment_39636,axiom,
    ! [VarCurr: state_type] :
      ( v68050(VarCurr,2)
    <=> v68051(VarCurr) ) ).

tff(addAssignment_39635,axiom,
    ! [VarCurr: state_type] :
      ( v68050(VarCurr,3)
    <=> v68051(VarCurr) ) ).

tff(addAssignment_39634,axiom,
    ! [VarCurr: state_type] :
      ( v68051(VarCurr)
    <=> v68042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68046(VarCurr,B)
      <=> ( v68030(VarCurr,B)
          & v68047(VarCurr,B) ) ) ) ).

tff(addAssignment_39633,axiom,
    ! [VarCurr: state_type] :
      ( v68047(VarCurr,0)
    <=> v68048(VarCurr) ) ).

tff(addAssignment_39632,axiom,
    ! [VarCurr: state_type] :
      ( v68047(VarCurr,1)
    <=> v68048(VarCurr) ) ).

tff(addAssignment_39631,axiom,
    ! [VarCurr: state_type] :
      ( v68047(VarCurr,2)
    <=> v68048(VarCurr) ) ).

tff(addAssignment_39630,axiom,
    ! [VarCurr: state_type] :
      ( v68047(VarCurr,3)
    <=> v68048(VarCurr) ) ).

tff(addAssignment_39629,axiom,
    ! [VarCurr: state_type] :
      ( v68048(VarCurr)
    <=> v68034(VarCurr) ) ).

tff(addAssignment_39628,axiom,
    ! [VarCurr: state_type] :
      ( v68042(VarCurr)
    <=> v68044(VarCurr) ) ).

tff(addAssignment_39627,axiom,
    ! [VarCurr: state_type] :
      ( v68044(VarCurr)
    <=> v67530(VarCurr,10) ) ).

tff(addAssignment_39626,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,10)
    <=> v52381(VarCurr,10) ) ).

tff(addAssignment_39625,axiom,
    ! [VarCurr: state_type] :
      ( v68038(VarCurr,3)
    <=> v68040(VarCurr,3) ) ).

tff(addAssignment_39624,axiom,
    ! [VarCurr: state_type] :
      ( v68040(VarCurr,3)
    <=> v67401(VarCurr,43) ) ).

tff(addAssignment_39623,axiom,
    ! [VarCurr: state_type] :
      ( v68034(VarCurr)
    <=> v68036(VarCurr) ) ).

tff(addAssignment_39622,axiom,
    ! [VarCurr: state_type] :
      ( v68036(VarCurr)
    <=> v67520(VarCurr,10) ) ).

tff(addAssignment_39621,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,10)
    <=> v52363(VarCurr,10) ) ).

tff(addAssignment_39620,axiom,
    ! [VarCurr: state_type] :
      ( v68030(VarCurr,3)
    <=> v68032(VarCurr,3) ) ).

tff(addAssignment_39619,axiom,
    ! [VarCurr: state_type] :
      ( v68032(VarCurr,3)
    <=> v67401(VarCurr,47) ) ).

tff(addAssignment_39618,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,47)
    <=> v67403(VarCurr,47) ) ).

tff(addAssignment_39617,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,47)
    <=> v67405(VarCurr,47) ) ).

tff(addAssignment_39616,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,47)
    <=> v67514(VarCurr,47) ) ).

tff(addAssignment_39615,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,47)
    <=> v67428(VarCurr,47) ) ).

tff(addAssignment_39614,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,47)
    <=> v67430(VarCurr,47) ) ).

tff(addAssignment_39613,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,47)
    <=> v67432(VarCurr,47) ) ).

tff(addAssignment_39612,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,47)
    <=> v67434(VarCurr,47) ) ).

tff(addAssignment_39611,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,47)
    <=> v67436(VarCurr,47) ) ).

tff(addAssignment_39610,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,47)
    <=> v67438(VarCurr,47) ) ).

tff(addAssignment_39609,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,47)
    <=> v67497(VarCurr,47) ) ).

tff(addAssignment_39608,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,47)
    <=> v67493(VarCurr,47) ) ).

tff(addAssignment_39607,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,47)
    <=> v67495(VarCurr,47) ) ).

tff(addAssignment_39606,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,47)
    <=> v67496(VarCurr,47) ) ).

tff(addAssignment_39605,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,95)
    <=> v33839(VarCurr,95) ) ).

tff(addAssignment_39604,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,95)
    <=> v33841(VarCurr,95) ) ).

tff(addAssignment_39603,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,95)
    <=> v20355(VarCurr,11) ) ).

tff(addAssignment_39602,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,47)
    <=> v67489(VarCurr,47) ) ).

tff(addAssignment_39601,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,47)
    <=> v6234(VarCurr,47) ) ).

tff(addAssignment_39600,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,47)
    <=> v67485(VarCurr,47) ) ).

tff(addAssignment_39599,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,47)
    <=> $false ) ).

tff(addAssignment_39598,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,47)
    <=> v67409(VarCurr,47) ) ).

tff(addAssignment_39597,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,47)
    <=> v67423(VarCurr,47) ) ).

tff(addAssignment_39596,axiom,
    ! [VarCurr: state_type] :
      ( v67981(VarCurr)
    <=> v67983(VarCurr) ) ).

tff(addAssignment_39595,axiom,
    ! [VarCurr: state_type] :
      ( v67983(VarCurr)
    <=> v67349(VarCurr,39) ) ).

tff(addAssignment_39594,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,39)
    <=> v67351(VarCurr,39) ) ).

tff(addAssignment_39593,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,39)
    <=> v67353(VarCurr,39) ) ).

tff(addAssignment_39592,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,39)
    <=> v67355(VarCurr,39) ) ).

tff(addAssignment_39591,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,39)
    <=> v67357(VarCurr,39) ) ).

tff(addAssignment_39590,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,39)
    <=> v67359(VarCurr,39) ) ).

tff(addAssignment_39589,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,39)
    <=> v67580(VarCurr,39) ) ).

tff(addAssignment_39588,axiom,
    ! [VarCurr: state_type] :
      ( v67603(VarCurr,3)
    <=> v67363(VarCurr,39) ) ).

tff(addAssignment_39587,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,39)
    <=> v67365(VarCurr,39) ) ).

tff(addAssignment_39586,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,39)
    <=> v68013(VarNext,39) ) ).

tff(addCaseBooleanConditionEqualRanges1_774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68014(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v68013(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_774,axiom,
    ! [VarNext: state_type] :
      ( v68014(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v68013(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68014(VarNext)
      <=> v68015(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v68015(VarNext)
      <=> ( v68017(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v68017(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39585,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,39)
    <=> v67389(VarCurr,39) ) ).

tff(addAssignment_39584,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,39)
    <=> v67391(VarCurr,39) ) ).

tff(addAssignment_39583,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,39)
    <=> v67986(VarCurr,3) ) ).

tff(addAssignment_39582,axiom,
    ! [VarCurr: state_type] :
      ( v67986(VarCurr,3)
    <=> v67988(VarCurr,3) ) ).

tff(addAssignment_39581,axiom,
    ! [VarCurr: state_type] :
      ( v67988(VarCurr,3)
    <=> v68005(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68005(VarCurr,B)
      <=> ( v68006(VarCurr,B)
          | v68009(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68009(VarCurr,B)
      <=> ( v67998(VarCurr,B)
          & v68010(VarCurr,B) ) ) ) ).

tff(addAssignment_39580,axiom,
    ! [VarCurr: state_type] :
      ( v68010(VarCurr,0)
    <=> v68011(VarCurr) ) ).

tff(addAssignment_39579,axiom,
    ! [VarCurr: state_type] :
      ( v68010(VarCurr,1)
    <=> v68011(VarCurr) ) ).

tff(addAssignment_39578,axiom,
    ! [VarCurr: state_type] :
      ( v68010(VarCurr,2)
    <=> v68011(VarCurr) ) ).

tff(addAssignment_39577,axiom,
    ! [VarCurr: state_type] :
      ( v68010(VarCurr,3)
    <=> v68011(VarCurr) ) ).

tff(addAssignment_39576,axiom,
    ! [VarCurr: state_type] :
      ( v68011(VarCurr)
    <=> v68002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v68006(VarCurr,B)
      <=> ( v67990(VarCurr,B)
          & v68007(VarCurr,B) ) ) ) ).

tff(addAssignment_39575,axiom,
    ! [VarCurr: state_type] :
      ( v68007(VarCurr,0)
    <=> v68008(VarCurr) ) ).

tff(addAssignment_39574,axiom,
    ! [VarCurr: state_type] :
      ( v68007(VarCurr,1)
    <=> v68008(VarCurr) ) ).

tff(addAssignment_39573,axiom,
    ! [VarCurr: state_type] :
      ( v68007(VarCurr,2)
    <=> v68008(VarCurr) ) ).

tff(addAssignment_39572,axiom,
    ! [VarCurr: state_type] :
      ( v68007(VarCurr,3)
    <=> v68008(VarCurr) ) ).

tff(addAssignment_39571,axiom,
    ! [VarCurr: state_type] :
      ( v68008(VarCurr)
    <=> v67994(VarCurr) ) ).

tff(addAssignment_39570,axiom,
    ! [VarCurr: state_type] :
      ( v68002(VarCurr)
    <=> v68004(VarCurr) ) ).

tff(addAssignment_39569,axiom,
    ! [VarCurr: state_type] :
      ( v68004(VarCurr)
    <=> v67530(VarCurr,9) ) ).

tff(addAssignment_39568,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,9)
    <=> v52381(VarCurr,9) ) ).

tff(addAssignment_39567,axiom,
    ! [VarCurr: state_type] :
      ( v67998(VarCurr,3)
    <=> v68000(VarCurr,3) ) ).

tff(addAssignment_39566,axiom,
    ! [VarCurr: state_type] :
      ( v68000(VarCurr,3)
    <=> v67401(VarCurr,39) ) ).

tff(addAssignment_39565,axiom,
    ! [VarCurr: state_type] :
      ( v67994(VarCurr)
    <=> v67996(VarCurr) ) ).

tff(addAssignment_39564,axiom,
    ! [VarCurr: state_type] :
      ( v67996(VarCurr)
    <=> v67520(VarCurr,9) ) ).

tff(addAssignment_39563,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,9)
    <=> v52363(VarCurr,9) ) ).

tff(addAssignment_39562,axiom,
    ! [VarCurr: state_type] :
      ( v67990(VarCurr,3)
    <=> v67992(VarCurr,3) ) ).

tff(addAssignment_39561,axiom,
    ! [VarCurr: state_type] :
      ( v67992(VarCurr,3)
    <=> v67401(VarCurr,43) ) ).

tff(addAssignment_39560,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,43)
    <=> v67403(VarCurr,43) ) ).

tff(addAssignment_39559,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,43)
    <=> v67405(VarCurr,43) ) ).

tff(addAssignment_39558,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,43)
    <=> v67514(VarCurr,43) ) ).

tff(addAssignment_39557,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,43)
    <=> v67428(VarCurr,43) ) ).

tff(addAssignment_39556,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,43)
    <=> v67430(VarCurr,43) ) ).

tff(addAssignment_39555,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,43)
    <=> v67432(VarCurr,43) ) ).

tff(addAssignment_39554,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,43)
    <=> v67434(VarCurr,43) ) ).

tff(addAssignment_39553,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,43)
    <=> v67436(VarCurr,43) ) ).

tff(addAssignment_39552,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,43)
    <=> v67438(VarCurr,43) ) ).

tff(addAssignment_39551,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,43)
    <=> v67497(VarCurr,43) ) ).

tff(addAssignment_39550,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,43)
    <=> v67493(VarCurr,43) ) ).

tff(addAssignment_39549,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,43)
    <=> v67495(VarCurr,43) ) ).

tff(addAssignment_39548,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,43)
    <=> v67496(VarCurr,43) ) ).

tff(addAssignment_39547,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,91)
    <=> v33839(VarCurr,91) ) ).

tff(addAssignment_39546,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,91)
    <=> v33841(VarCurr,91) ) ).

tff(addAssignment_39545,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,91)
    <=> v20355(VarCurr,7) ) ).

tff(addAssignment_39544,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,43)
    <=> v67489(VarCurr,43) ) ).

tff(addAssignment_39543,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,43)
    <=> v6234(VarCurr,43) ) ).

tff(addAssignment_39542,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,43)
    <=> v67485(VarCurr,43) ) ).

tff(addAssignment_39541,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,43)
    <=> $false ) ).

tff(addAssignment_39540,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,43)
    <=> v67409(VarCurr,43) ) ).

tff(addAssignment_39539,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,43)
    <=> v67423(VarCurr,43) ) ).

tff(addAssignment_39538,axiom,
    ! [VarCurr: state_type] :
      ( v67325(VarCurr)
    <=> v67327(VarCurr) ) ).

tff(addAssignment_39537,axiom,
    ! [VarCurr: state_type] :
      ( v67327(VarCurr)
    <=> v67329(VarCurr) ) ).

tff(addAssignment_39536,axiom,
    ! [VarCurr: state_type] :
      ( v67329(VarCurr)
    <=> v67331(VarCurr) ) ).

tff(addAssignment_39535,axiom,
    ! [VarCurr: state_type] :
      ( v67331(VarCurr)
    <=> v67333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6240,axiom,
    ! [VarCurr: state_type] :
      ( v67333(VarCurr)
    <=> ( v67959(VarCurr)
      <~> v67827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6239,axiom,
    ! [VarCurr: state_type] :
      ( v67959(VarCurr)
    <=> ( v67335(VarCurr)
      <~> v67695(VarCurr) ) ) ).

tff(addAssignment_39534,axiom,
    ! [VarCurr: state_type] :
      ( v67827(VarCurr)
    <=> v67829(VarCurr) ) ).

tff(addAssignment_39533,axiom,
    ! [VarCurr: state_type] :
      ( v67829(VarCurr)
    <=> v67831(VarCurr) ) ).

tff(addAssignment_39532,axiom,
    ! [VarCurr: state_type] :
      ( v67831(VarCurr)
    <=> v67833(VarCurr) ) ).

tff(addAssignment_39531,axiom,
    ! [VarCurr: state_type] :
      ( v67833(VarCurr)
    <=> v67835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6238,axiom,
    ! [VarCurr: state_type] :
      ( v67835(VarCurr)
    <=> ( v67957(VarCurr)
      <~> v67917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6237,axiom,
    ! [VarCurr: state_type] :
      ( v67957(VarCurr)
    <=> ( v67837(VarCurr)
      <~> v67877(VarCurr) ) ) ).

tff(addAssignment_39530,axiom,
    ! [VarCurr: state_type] :
      ( v67917(VarCurr)
    <=> v67919(VarCurr) ) ).

tff(addAssignment_39529,axiom,
    ! [VarCurr: state_type] :
      ( v67919(VarCurr)
    <=> v67349(VarCurr,35) ) ).

tff(addAssignment_39528,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,35)
    <=> v67351(VarCurr,35) ) ).

tff(addAssignment_39527,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,35)
    <=> v67353(VarCurr,35) ) ).

tff(addAssignment_39526,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,35)
    <=> v67355(VarCurr,35) ) ).

tff(addAssignment_39525,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,35)
    <=> v67357(VarCurr,35) ) ).

tff(addAssignment_39524,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,35)
    <=> v67359(VarCurr,35) ) ).

tff(addAssignment_39523,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,35)
    <=> v67580(VarCurr,35) ) ).

tff(addAssignment_39522,axiom,
    ! [VarCurr: state_type] :
      ( v67604(VarCurr,3)
    <=> v67363(VarCurr,35) ) ).

tff(addAssignment_39521,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,35)
    <=> v67365(VarCurr,35) ) ).

tff(addAssignment_39520,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,35)
    <=> v67949(VarNext,35) ) ).

tff(addCaseBooleanConditionEqualRanges1_773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67950(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67949(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_773,axiom,
    ! [VarNext: state_type] :
      ( v67950(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67949(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67950(VarNext)
      <=> v67951(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67951(VarNext)
      <=> ( v67953(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67953(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39519,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,35)
    <=> v67389(VarCurr,35) ) ).

tff(addAssignment_39518,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,35)
    <=> v67391(VarCurr,35) ) ).

tff(addAssignment_39517,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,35)
    <=> v67922(VarCurr,3) ) ).

tff(addAssignment_39516,axiom,
    ! [VarCurr: state_type] :
      ( v67922(VarCurr,3)
    <=> v67924(VarCurr,3) ) ).

tff(addAssignment_39515,axiom,
    ! [VarCurr: state_type] :
      ( v67924(VarCurr,3)
    <=> v67941(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67941(VarCurr,B)
      <=> ( v67942(VarCurr,B)
          | v67945(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67945(VarCurr,B)
      <=> ( v67934(VarCurr,B)
          & v67946(VarCurr,B) ) ) ) ).

tff(addAssignment_39514,axiom,
    ! [VarCurr: state_type] :
      ( v67946(VarCurr,0)
    <=> v67947(VarCurr) ) ).

tff(addAssignment_39513,axiom,
    ! [VarCurr: state_type] :
      ( v67946(VarCurr,1)
    <=> v67947(VarCurr) ) ).

tff(addAssignment_39512,axiom,
    ! [VarCurr: state_type] :
      ( v67946(VarCurr,2)
    <=> v67947(VarCurr) ) ).

tff(addAssignment_39511,axiom,
    ! [VarCurr: state_type] :
      ( v67946(VarCurr,3)
    <=> v67947(VarCurr) ) ).

tff(addAssignment_39510,axiom,
    ! [VarCurr: state_type] :
      ( v67947(VarCurr)
    <=> v67938(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67942(VarCurr,B)
      <=> ( v67926(VarCurr,B)
          & v67943(VarCurr,B) ) ) ) ).

tff(addAssignment_39509,axiom,
    ! [VarCurr: state_type] :
      ( v67943(VarCurr,0)
    <=> v67944(VarCurr) ) ).

tff(addAssignment_39508,axiom,
    ! [VarCurr: state_type] :
      ( v67943(VarCurr,1)
    <=> v67944(VarCurr) ) ).

tff(addAssignment_39507,axiom,
    ! [VarCurr: state_type] :
      ( v67943(VarCurr,2)
    <=> v67944(VarCurr) ) ).

tff(addAssignment_39506,axiom,
    ! [VarCurr: state_type] :
      ( v67943(VarCurr,3)
    <=> v67944(VarCurr) ) ).

tff(addAssignment_39505,axiom,
    ! [VarCurr: state_type] :
      ( v67944(VarCurr)
    <=> v67930(VarCurr) ) ).

tff(addAssignment_39504,axiom,
    ! [VarCurr: state_type] :
      ( v67938(VarCurr)
    <=> v67940(VarCurr) ) ).

tff(addAssignment_39503,axiom,
    ! [VarCurr: state_type] :
      ( v67940(VarCurr)
    <=> v67530(VarCurr,8) ) ).

tff(addAssignment_39502,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,8)
    <=> v52381(VarCurr,8) ) ).

tff(addAssignment_39501,axiom,
    ! [VarCurr: state_type] :
      ( v67934(VarCurr,3)
    <=> v67936(VarCurr,3) ) ).

tff(addAssignment_39500,axiom,
    ! [VarCurr: state_type] :
      ( v67936(VarCurr,3)
    <=> v67401(VarCurr,35) ) ).

tff(addAssignment_39499,axiom,
    ! [VarCurr: state_type] :
      ( v67930(VarCurr)
    <=> v67932(VarCurr) ) ).

tff(addAssignment_39498,axiom,
    ! [VarCurr: state_type] :
      ( v67932(VarCurr)
    <=> v67520(VarCurr,8) ) ).

tff(addAssignment_39497,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,8)
    <=> v52363(VarCurr,8) ) ).

tff(addAssignment_39496,axiom,
    ! [VarCurr: state_type] :
      ( v67926(VarCurr,3)
    <=> v67928(VarCurr,3) ) ).

tff(addAssignment_39495,axiom,
    ! [VarCurr: state_type] :
      ( v67928(VarCurr,3)
    <=> v67401(VarCurr,39) ) ).

tff(addAssignment_39494,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,39)
    <=> v67403(VarCurr,39) ) ).

tff(addAssignment_39493,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,39)
    <=> v67405(VarCurr,39) ) ).

tff(addAssignment_39492,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,39)
    <=> v67514(VarCurr,39) ) ).

tff(addAssignment_39491,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,39)
    <=> v67428(VarCurr,39) ) ).

tff(addAssignment_39490,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,39)
    <=> v67430(VarCurr,39) ) ).

tff(addAssignment_39489,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,39)
    <=> v67432(VarCurr,39) ) ).

tff(addAssignment_39488,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,39)
    <=> v67434(VarCurr,39) ) ).

tff(addAssignment_39487,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,39)
    <=> v67436(VarCurr,39) ) ).

tff(addAssignment_39486,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,39)
    <=> v67438(VarCurr,39) ) ).

tff(addAssignment_39485,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,39)
    <=> v67497(VarCurr,39) ) ).

tff(addAssignment_39484,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,39)
    <=> v67493(VarCurr,39) ) ).

tff(addAssignment_39483,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,39)
    <=> v67495(VarCurr,39) ) ).

tff(addAssignment_39482,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,39)
    <=> v67496(VarCurr,39) ) ).

tff(addAssignment_39481,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,81)
    <=> v33839(VarCurr,81) ) ).

tff(addAssignment_39480,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,81)
    <=> v33841(VarCurr,81) ) ).

tff(addAssignment_39479,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,81)
    <=> v18805(VarCurr,9) ) ).

tff(addAssignment_39478,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,39)
    <=> v67489(VarCurr,39) ) ).

tff(addAssignment_39477,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,39)
    <=> v6234(VarCurr,39) ) ).

tff(addAssignment_39476,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,39)
    <=> v67485(VarCurr,39) ) ).

tff(addAssignment_39475,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,39)
    <=> $false ) ).

tff(addAssignment_39474,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,39)
    <=> v67409(VarCurr,39) ) ).

tff(addAssignment_39473,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,39)
    <=> v67423(VarCurr,39) ) ).

tff(addAssignment_39472,axiom,
    ! [VarCurr: state_type] :
      ( v67877(VarCurr)
    <=> v67879(VarCurr) ) ).

tff(addAssignment_39471,axiom,
    ! [VarCurr: state_type] :
      ( v67879(VarCurr)
    <=> v67349(VarCurr,31) ) ).

tff(addAssignment_39470,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,31)
    <=> v67351(VarCurr,31) ) ).

tff(addAssignment_39469,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,31)
    <=> v67353(VarCurr,31) ) ).

tff(addAssignment_39468,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,31)
    <=> v67355(VarCurr,31) ) ).

tff(addAssignment_39467,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,31)
    <=> v67357(VarCurr,31) ) ).

tff(addAssignment_39466,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,31)
    <=> v67359(VarCurr,31) ) ).

tff(addAssignment_39465,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,31)
    <=> v67580(VarCurr,31) ) ).

tff(addAssignment_39464,axiom,
    ! [VarCurr: state_type] :
      ( v67605(VarCurr,3)
    <=> v67363(VarCurr,31) ) ).

tff(addAssignment_39463,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,31)
    <=> v67365(VarCurr,31) ) ).

tff(addAssignment_39462,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,31)
    <=> v67909(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67910(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67909(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_772,axiom,
    ! [VarNext: state_type] :
      ( v67910(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67909(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67910(VarNext)
      <=> v67911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67911(VarNext)
      <=> ( v67913(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67913(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39461,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,31)
    <=> v67389(VarCurr,31) ) ).

tff(addAssignment_39460,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,31)
    <=> v67391(VarCurr,31) ) ).

tff(addAssignment_39459,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,31)
    <=> v67882(VarCurr,3) ) ).

tff(addAssignment_39458,axiom,
    ! [VarCurr: state_type] :
      ( v67882(VarCurr,3)
    <=> v67884(VarCurr,3) ) ).

tff(addAssignment_39457,axiom,
    ! [VarCurr: state_type] :
      ( v67884(VarCurr,3)
    <=> v67901(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67901(VarCurr,B)
      <=> ( v67902(VarCurr,B)
          | v67905(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67905(VarCurr,B)
      <=> ( v67894(VarCurr,B)
          & v67906(VarCurr,B) ) ) ) ).

tff(addAssignment_39456,axiom,
    ! [VarCurr: state_type] :
      ( v67906(VarCurr,0)
    <=> v67907(VarCurr) ) ).

tff(addAssignment_39455,axiom,
    ! [VarCurr: state_type] :
      ( v67906(VarCurr,1)
    <=> v67907(VarCurr) ) ).

tff(addAssignment_39454,axiom,
    ! [VarCurr: state_type] :
      ( v67906(VarCurr,2)
    <=> v67907(VarCurr) ) ).

tff(addAssignment_39453,axiom,
    ! [VarCurr: state_type] :
      ( v67906(VarCurr,3)
    <=> v67907(VarCurr) ) ).

tff(addAssignment_39452,axiom,
    ! [VarCurr: state_type] :
      ( v67907(VarCurr)
    <=> v67898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67902(VarCurr,B)
      <=> ( v67886(VarCurr,B)
          & v67903(VarCurr,B) ) ) ) ).

tff(addAssignment_39451,axiom,
    ! [VarCurr: state_type] :
      ( v67903(VarCurr,0)
    <=> v67904(VarCurr) ) ).

tff(addAssignment_39450,axiom,
    ! [VarCurr: state_type] :
      ( v67903(VarCurr,1)
    <=> v67904(VarCurr) ) ).

tff(addAssignment_39449,axiom,
    ! [VarCurr: state_type] :
      ( v67903(VarCurr,2)
    <=> v67904(VarCurr) ) ).

tff(addAssignment_39448,axiom,
    ! [VarCurr: state_type] :
      ( v67903(VarCurr,3)
    <=> v67904(VarCurr) ) ).

tff(addAssignment_39447,axiom,
    ! [VarCurr: state_type] :
      ( v67904(VarCurr)
    <=> v67890(VarCurr) ) ).

tff(addAssignment_39446,axiom,
    ! [VarCurr: state_type] :
      ( v67898(VarCurr)
    <=> v67900(VarCurr) ) ).

tff(addAssignment_39445,axiom,
    ! [VarCurr: state_type] :
      ( v67900(VarCurr)
    <=> v67530(VarCurr,7) ) ).

tff(addAssignment_39444,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,7)
    <=> v52381(VarCurr,7) ) ).

tff(addAssignment_39443,axiom,
    ! [VarCurr: state_type] :
      ( v67894(VarCurr,3)
    <=> v67896(VarCurr,3) ) ).

tff(addAssignment_39442,axiom,
    ! [VarCurr: state_type] :
      ( v67896(VarCurr,3)
    <=> v67401(VarCurr,31) ) ).

tff(addAssignment_39441,axiom,
    ! [VarCurr: state_type] :
      ( v67890(VarCurr)
    <=> v67892(VarCurr) ) ).

tff(addAssignment_39440,axiom,
    ! [VarCurr: state_type] :
      ( v67892(VarCurr)
    <=> v67520(VarCurr,7) ) ).

tff(addAssignment_39439,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,7)
    <=> v52363(VarCurr,7) ) ).

tff(addAssignment_39438,axiom,
    ! [VarCurr: state_type] :
      ( v67886(VarCurr,3)
    <=> v67888(VarCurr,3) ) ).

tff(addAssignment_39437,axiom,
    ! [VarCurr: state_type] :
      ( v67888(VarCurr,3)
    <=> v67401(VarCurr,35) ) ).

tff(addAssignment_39436,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,35)
    <=> v67403(VarCurr,35) ) ).

tff(addAssignment_39435,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,35)
    <=> v67405(VarCurr,35) ) ).

tff(addAssignment_39434,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,35)
    <=> v67514(VarCurr,35) ) ).

tff(addAssignment_39433,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,35)
    <=> v67428(VarCurr,35) ) ).

tff(addAssignment_39432,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,35)
    <=> v67430(VarCurr,35) ) ).

tff(addAssignment_39431,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,35)
    <=> v67432(VarCurr,35) ) ).

tff(addAssignment_39430,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,35)
    <=> v67434(VarCurr,35) ) ).

tff(addAssignment_39429,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,35)
    <=> v67436(VarCurr,35) ) ).

tff(addAssignment_39428,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,35)
    <=> v67438(VarCurr,35) ) ).

tff(addAssignment_39427,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,35)
    <=> v67497(VarCurr,35) ) ).

tff(addAssignment_39426,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,35)
    <=> v67493(VarCurr,35) ) ).

tff(addAssignment_39425,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,35)
    <=> v67495(VarCurr,35) ) ).

tff(addAssignment_39424,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,35)
    <=> v67496(VarCurr,35) ) ).

tff(addAssignment_39423,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,71)
    <=> v33839(VarCurr,71) ) ).

tff(addAssignment_39422,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,71)
    <=> v33841(VarCurr,71) ) ).

tff(addAssignment_39421,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,71)
    <=> v17255(VarCurr,11) ) ).

tff(addAssignment_39420,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,35)
    <=> v67489(VarCurr,35) ) ).

tff(addAssignment_39419,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,35)
    <=> v6234(VarCurr,35) ) ).

tff(addAssignment_39418,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,35)
    <=> v67485(VarCurr,35) ) ).

tff(addAssignment_39417,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,35)
    <=> $false ) ).

tff(addAssignment_39416,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,35)
    <=> v67409(VarCurr,35) ) ).

tff(addAssignment_39415,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,35)
    <=> v67423(VarCurr,35) ) ).

tff(addAssignment_39414,axiom,
    ! [VarCurr: state_type] :
      ( v67837(VarCurr)
    <=> v67839(VarCurr) ) ).

tff(addAssignment_39413,axiom,
    ! [VarCurr: state_type] :
      ( v67839(VarCurr)
    <=> v67349(VarCurr,27) ) ).

tff(addAssignment_39412,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,27)
    <=> v67351(VarCurr,27) ) ).

tff(addAssignment_39411,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,27)
    <=> v67353(VarCurr,27) ) ).

tff(addAssignment_39410,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,27)
    <=> v67355(VarCurr,27) ) ).

tff(addAssignment_39409,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,27)
    <=> v67357(VarCurr,27) ) ).

tff(addAssignment_39408,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,27)
    <=> v67359(VarCurr,27) ) ).

tff(addAssignment_39407,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,27)
    <=> v67580(VarCurr,27) ) ).

tff(addAssignment_39406,axiom,
    ! [VarCurr: state_type] :
      ( v67606(VarCurr,3)
    <=> v67363(VarCurr,27) ) ).

tff(addAssignment_39405,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,27)
    <=> v67365(VarCurr,27) ) ).

tff(addAssignment_39404,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,27)
    <=> v67869(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67870(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67869(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_771,axiom,
    ! [VarNext: state_type] :
      ( v67870(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67869(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67870(VarNext)
      <=> v67871(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67871(VarNext)
      <=> ( v67873(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67873(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39403,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,27)
    <=> v67389(VarCurr,27) ) ).

tff(addAssignment_39402,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,27)
    <=> v67391(VarCurr,27) ) ).

tff(addAssignment_39401,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,27)
    <=> v67842(VarCurr,3) ) ).

tff(addAssignment_39400,axiom,
    ! [VarCurr: state_type] :
      ( v67842(VarCurr,3)
    <=> v67844(VarCurr,3) ) ).

tff(addAssignment_39399,axiom,
    ! [VarCurr: state_type] :
      ( v67844(VarCurr,3)
    <=> v67861(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67861(VarCurr,B)
      <=> ( v67862(VarCurr,B)
          | v67865(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67865(VarCurr,B)
      <=> ( v67854(VarCurr,B)
          & v67866(VarCurr,B) ) ) ) ).

tff(addAssignment_39398,axiom,
    ! [VarCurr: state_type] :
      ( v67866(VarCurr,0)
    <=> v67867(VarCurr) ) ).

tff(addAssignment_39397,axiom,
    ! [VarCurr: state_type] :
      ( v67866(VarCurr,1)
    <=> v67867(VarCurr) ) ).

tff(addAssignment_39396,axiom,
    ! [VarCurr: state_type] :
      ( v67866(VarCurr,2)
    <=> v67867(VarCurr) ) ).

tff(addAssignment_39395,axiom,
    ! [VarCurr: state_type] :
      ( v67866(VarCurr,3)
    <=> v67867(VarCurr) ) ).

tff(addAssignment_39394,axiom,
    ! [VarCurr: state_type] :
      ( v67867(VarCurr)
    <=> v67858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67862(VarCurr,B)
      <=> ( v67846(VarCurr,B)
          & v67863(VarCurr,B) ) ) ) ).

tff(addAssignment_39393,axiom,
    ! [VarCurr: state_type] :
      ( v67863(VarCurr,0)
    <=> v67864(VarCurr) ) ).

tff(addAssignment_39392,axiom,
    ! [VarCurr: state_type] :
      ( v67863(VarCurr,1)
    <=> v67864(VarCurr) ) ).

tff(addAssignment_39391,axiom,
    ! [VarCurr: state_type] :
      ( v67863(VarCurr,2)
    <=> v67864(VarCurr) ) ).

tff(addAssignment_39390,axiom,
    ! [VarCurr: state_type] :
      ( v67863(VarCurr,3)
    <=> v67864(VarCurr) ) ).

tff(addAssignment_39389,axiom,
    ! [VarCurr: state_type] :
      ( v67864(VarCurr)
    <=> v67850(VarCurr) ) ).

tff(addAssignment_39388,axiom,
    ! [VarCurr: state_type] :
      ( v67858(VarCurr)
    <=> v67860(VarCurr) ) ).

tff(addAssignment_39387,axiom,
    ! [VarCurr: state_type] :
      ( v67860(VarCurr)
    <=> v67530(VarCurr,6) ) ).

tff(addAssignment_39386,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,6)
    <=> v52381(VarCurr,6) ) ).

tff(addAssignment_39385,axiom,
    ! [VarCurr: state_type] :
      ( v67854(VarCurr,3)
    <=> v67856(VarCurr,3) ) ).

tff(addAssignment_39384,axiom,
    ! [VarCurr: state_type] :
      ( v67856(VarCurr,3)
    <=> v67401(VarCurr,27) ) ).

tff(addAssignment_39383,axiom,
    ! [VarCurr: state_type] :
      ( v67850(VarCurr)
    <=> v67852(VarCurr) ) ).

tff(addAssignment_39382,axiom,
    ! [VarCurr: state_type] :
      ( v67852(VarCurr)
    <=> v67520(VarCurr,6) ) ).

tff(addAssignment_39381,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,6)
    <=> v52363(VarCurr,6) ) ).

tff(addAssignment_39380,axiom,
    ! [VarCurr: state_type] :
      ( v67846(VarCurr,3)
    <=> v67848(VarCurr,3) ) ).

tff(addAssignment_39379,axiom,
    ! [VarCurr: state_type] :
      ( v67848(VarCurr,3)
    <=> v67401(VarCurr,31) ) ).

tff(addAssignment_39378,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,31)
    <=> v67403(VarCurr,31) ) ).

tff(addAssignment_39377,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,31)
    <=> v67405(VarCurr,31) ) ).

tff(addAssignment_39376,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,31)
    <=> v67514(VarCurr,31) ) ).

tff(addAssignment_39375,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,31)
    <=> v67428(VarCurr,31) ) ).

tff(addAssignment_39374,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,31)
    <=> v67430(VarCurr,31) ) ).

tff(addAssignment_39373,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,31)
    <=> v67432(VarCurr,31) ) ).

tff(addAssignment_39372,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,31)
    <=> v67434(VarCurr,31) ) ).

tff(addAssignment_39371,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,31)
    <=> v67436(VarCurr,31) ) ).

tff(addAssignment_39370,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,31)
    <=> v67438(VarCurr,31) ) ).

tff(addAssignment_39369,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,31)
    <=> v67497(VarCurr,31) ) ).

tff(addAssignment_39368,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,31)
    <=> v67493(VarCurr,31) ) ).

tff(addAssignment_39367,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,31)
    <=> v67495(VarCurr,31) ) ).

tff(addAssignment_39366,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,31)
    <=> v67496(VarCurr,31) ) ).

tff(addAssignment_39365,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,67)
    <=> v33839(VarCurr,67) ) ).

tff(addAssignment_39364,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,67)
    <=> v33841(VarCurr,67) ) ).

tff(addAssignment_39363,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,67)
    <=> v17255(VarCurr,7) ) ).

tff(addAssignment_39362,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,31)
    <=> v67489(VarCurr,31) ) ).

tff(addAssignment_39361,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,31)
    <=> v6234(VarCurr,31) ) ).

tff(addAssignment_39360,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,31)
    <=> v67485(VarCurr,31) ) ).

tff(addAssignment_39359,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_39358,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,31)
    <=> v67409(VarCurr,31) ) ).

tff(addAssignment_39357,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,31)
    <=> v67423(VarCurr,31) ) ).

tff(addAssignment_39356,axiom,
    ! [VarCurr: state_type] :
      ( v67695(VarCurr)
    <=> v67697(VarCurr) ) ).

tff(addAssignment_39355,axiom,
    ! [VarCurr: state_type] :
      ( v67697(VarCurr)
    <=> v67699(VarCurr) ) ).

tff(addAssignment_39354,axiom,
    ! [VarCurr: state_type] :
      ( v67699(VarCurr)
    <=> v67701(VarCurr) ) ).

tff(addAssignment_39353,axiom,
    ! [VarCurr: state_type] :
      ( v67701(VarCurr)
    <=> v67703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6230,axiom,
    ! [VarCurr: state_type] :
      ( v67703(VarCurr)
    <=> ( v67825(VarCurr)
      <~> v67785(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6229,axiom,
    ! [VarCurr: state_type] :
      ( v67825(VarCurr)
    <=> ( v67705(VarCurr)
      <~> v67745(VarCurr) ) ) ).

tff(addAssignment_39352,axiom,
    ! [VarCurr: state_type] :
      ( v67785(VarCurr)
    <=> v67787(VarCurr) ) ).

tff(addAssignment_39351,axiom,
    ! [VarCurr: state_type] :
      ( v67787(VarCurr)
    <=> v67349(VarCurr,23) ) ).

tff(addAssignment_39350,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,23)
    <=> v67351(VarCurr,23) ) ).

tff(addAssignment_39349,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,23)
    <=> v67353(VarCurr,23) ) ).

tff(addAssignment_39348,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,23)
    <=> v67355(VarCurr,23) ) ).

tff(addAssignment_39347,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,23)
    <=> v67357(VarCurr,23) ) ).

tff(addAssignment_39346,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,23)
    <=> v67359(VarCurr,23) ) ).

tff(addAssignment_39345,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,23)
    <=> v67580(VarCurr,23) ) ).

tff(addAssignment_39344,axiom,
    ! [VarCurr: state_type] :
      ( v67607(VarCurr,3)
    <=> v67363(VarCurr,23) ) ).

tff(addAssignment_39343,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,23)
    <=> v67365(VarCurr,23) ) ).

tff(addAssignment_39342,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,23)
    <=> v67817(VarNext,23) ) ).

tff(addCaseBooleanConditionEqualRanges1_770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67818(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67817(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_770,axiom,
    ! [VarNext: state_type] :
      ( v67818(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67817(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67818(VarNext)
      <=> v67819(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67819(VarNext)
      <=> ( v67821(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67821(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39341,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,23)
    <=> v67389(VarCurr,23) ) ).

tff(addAssignment_39340,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,23)
    <=> v67391(VarCurr,23) ) ).

tff(addAssignment_39339,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,23)
    <=> v67790(VarCurr,3) ) ).

tff(addAssignment_39338,axiom,
    ! [VarCurr: state_type] :
      ( v67790(VarCurr,3)
    <=> v67792(VarCurr,3) ) ).

tff(addAssignment_39337,axiom,
    ! [VarCurr: state_type] :
      ( v67792(VarCurr,3)
    <=> v67809(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67809(VarCurr,B)
      <=> ( v67810(VarCurr,B)
          | v67813(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67813(VarCurr,B)
      <=> ( v67802(VarCurr,B)
          & v67814(VarCurr,B) ) ) ) ).

tff(addAssignment_39336,axiom,
    ! [VarCurr: state_type] :
      ( v67814(VarCurr,0)
    <=> v67815(VarCurr) ) ).

tff(addAssignment_39335,axiom,
    ! [VarCurr: state_type] :
      ( v67814(VarCurr,1)
    <=> v67815(VarCurr) ) ).

tff(addAssignment_39334,axiom,
    ! [VarCurr: state_type] :
      ( v67814(VarCurr,2)
    <=> v67815(VarCurr) ) ).

tff(addAssignment_39333,axiom,
    ! [VarCurr: state_type] :
      ( v67814(VarCurr,3)
    <=> v67815(VarCurr) ) ).

tff(addAssignment_39332,axiom,
    ! [VarCurr: state_type] :
      ( v67815(VarCurr)
    <=> v67806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_965,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67810(VarCurr,B)
      <=> ( v67794(VarCurr,B)
          & v67811(VarCurr,B) ) ) ) ).

tff(addAssignment_39331,axiom,
    ! [VarCurr: state_type] :
      ( v67811(VarCurr,0)
    <=> v67812(VarCurr) ) ).

tff(addAssignment_39330,axiom,
    ! [VarCurr: state_type] :
      ( v67811(VarCurr,1)
    <=> v67812(VarCurr) ) ).

tff(addAssignment_39329,axiom,
    ! [VarCurr: state_type] :
      ( v67811(VarCurr,2)
    <=> v67812(VarCurr) ) ).

tff(addAssignment_39328,axiom,
    ! [VarCurr: state_type] :
      ( v67811(VarCurr,3)
    <=> v67812(VarCurr) ) ).

tff(addAssignment_39327,axiom,
    ! [VarCurr: state_type] :
      ( v67812(VarCurr)
    <=> v67798(VarCurr) ) ).

tff(addAssignment_39326,axiom,
    ! [VarCurr: state_type] :
      ( v67806(VarCurr)
    <=> v67808(VarCurr) ) ).

tff(addAssignment_39325,axiom,
    ! [VarCurr: state_type] :
      ( v67808(VarCurr)
    <=> v67530(VarCurr,5) ) ).

tff(addAssignment_39324,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,5)
    <=> v52381(VarCurr,5) ) ).

tff(addAssignment_39323,axiom,
    ! [VarCurr: state_type] :
      ( v67802(VarCurr,3)
    <=> v67804(VarCurr,3) ) ).

tff(addAssignment_39322,axiom,
    ! [VarCurr: state_type] :
      ( v67804(VarCurr,3)
    <=> v67401(VarCurr,23) ) ).

tff(addAssignment_39321,axiom,
    ! [VarCurr: state_type] :
      ( v67798(VarCurr)
    <=> v67800(VarCurr) ) ).

tff(addAssignment_39320,axiom,
    ! [VarCurr: state_type] :
      ( v67800(VarCurr)
    <=> v67520(VarCurr,5) ) ).

tff(addAssignment_39319,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,5)
    <=> v52363(VarCurr,5) ) ).

tff(addAssignment_39318,axiom,
    ! [VarCurr: state_type] :
      ( v67794(VarCurr,3)
    <=> v67796(VarCurr,3) ) ).

tff(addAssignment_39317,axiom,
    ! [VarCurr: state_type] :
      ( v67796(VarCurr,3)
    <=> v67401(VarCurr,27) ) ).

tff(addAssignment_39316,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,27)
    <=> v67403(VarCurr,27) ) ).

tff(addAssignment_39315,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,27)
    <=> v67405(VarCurr,27) ) ).

tff(addAssignment_39314,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,27)
    <=> v67514(VarCurr,27) ) ).

tff(addAssignment_39313,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,27)
    <=> v67428(VarCurr,27) ) ).

tff(addAssignment_39312,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,27)
    <=> v67430(VarCurr,27) ) ).

tff(addAssignment_39311,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,27)
    <=> v67432(VarCurr,27) ) ).

tff(addAssignment_39310,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,27)
    <=> v67434(VarCurr,27) ) ).

tff(addAssignment_39309,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,27)
    <=> v67436(VarCurr,27) ) ).

tff(addAssignment_39308,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,27)
    <=> v67438(VarCurr,27) ) ).

tff(addAssignment_39307,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,27)
    <=> v67497(VarCurr,27) ) ).

tff(addAssignment_39306,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,27)
    <=> v67493(VarCurr,27) ) ).

tff(addAssignment_39305,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,27)
    <=> v67495(VarCurr,27) ) ).

tff(addAssignment_39304,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,27)
    <=> v67496(VarCurr,27) ) ).

tff(addAssignment_39303,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,57)
    <=> v33839(VarCurr,57) ) ).

tff(addAssignment_39302,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,57)
    <=> v33841(VarCurr,57) ) ).

tff(addAssignment_39301,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,57)
    <=> v15705(VarCurr,9) ) ).

tff(addAssignment_39300,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,27)
    <=> v67489(VarCurr,27) ) ).

tff(addAssignment_39299,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,27)
    <=> v6234(VarCurr,27) ) ).

tff(addAssignment_39298,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,27)
    <=> v67485(VarCurr,27) ) ).

tff(addAssignment_39297,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,27)
    <=> $false ) ).

tff(addAssignment_39296,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,27)
    <=> v67409(VarCurr,27) ) ).

tff(addAssignment_39295,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,27)
    <=> v67423(VarCurr,27) ) ).

tff(addAssignment_39294,axiom,
    ! [VarCurr: state_type] :
      ( v67745(VarCurr)
    <=> v67747(VarCurr) ) ).

tff(addAssignment_39293,axiom,
    ! [VarCurr: state_type] :
      ( v67747(VarCurr)
    <=> v67349(VarCurr,19) ) ).

tff(addAssignment_39292,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,19)
    <=> v67351(VarCurr,19) ) ).

tff(addAssignment_39291,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,19)
    <=> v67353(VarCurr,19) ) ).

tff(addAssignment_39290,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,19)
    <=> v67355(VarCurr,19) ) ).

tff(addAssignment_39289,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,19)
    <=> v67357(VarCurr,19) ) ).

tff(addAssignment_39288,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,19)
    <=> v67359(VarCurr,19) ) ).

tff(addAssignment_39287,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,19)
    <=> v67580(VarCurr,19) ) ).

tff(addAssignment_39286,axiom,
    ! [VarCurr: state_type] :
      ( v67608(VarCurr,3)
    <=> v67363(VarCurr,19) ) ).

tff(addAssignment_39285,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,19)
    <=> v67365(VarCurr,19) ) ).

tff(addAssignment_39284,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,19)
    <=> v67777(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67778(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67777(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_769,axiom,
    ! [VarNext: state_type] :
      ( v67778(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67777(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67778(VarNext)
      <=> v67779(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67779(VarNext)
      <=> ( v67781(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67781(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39283,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,19)
    <=> v67389(VarCurr,19) ) ).

tff(addAssignment_39282,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,19)
    <=> v67391(VarCurr,19) ) ).

tff(addAssignment_39281,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,19)
    <=> v67750(VarCurr,3) ) ).

tff(addAssignment_39280,axiom,
    ! [VarCurr: state_type] :
      ( v67750(VarCurr,3)
    <=> v67752(VarCurr,3) ) ).

tff(addAssignment_39279,axiom,
    ! [VarCurr: state_type] :
      ( v67752(VarCurr,3)
    <=> v67769(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67769(VarCurr,B)
      <=> ( v67770(VarCurr,B)
          | v67773(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_963,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67773(VarCurr,B)
      <=> ( v67762(VarCurr,B)
          & v67774(VarCurr,B) ) ) ) ).

tff(addAssignment_39278,axiom,
    ! [VarCurr: state_type] :
      ( v67774(VarCurr,0)
    <=> v67775(VarCurr) ) ).

tff(addAssignment_39277,axiom,
    ! [VarCurr: state_type] :
      ( v67774(VarCurr,1)
    <=> v67775(VarCurr) ) ).

tff(addAssignment_39276,axiom,
    ! [VarCurr: state_type] :
      ( v67774(VarCurr,2)
    <=> v67775(VarCurr) ) ).

tff(addAssignment_39275,axiom,
    ! [VarCurr: state_type] :
      ( v67774(VarCurr,3)
    <=> v67775(VarCurr) ) ).

tff(addAssignment_39274,axiom,
    ! [VarCurr: state_type] :
      ( v67775(VarCurr)
    <=> v67766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67770(VarCurr,B)
      <=> ( v67754(VarCurr,B)
          & v67771(VarCurr,B) ) ) ) ).

tff(addAssignment_39273,axiom,
    ! [VarCurr: state_type] :
      ( v67771(VarCurr,0)
    <=> v67772(VarCurr) ) ).

tff(addAssignment_39272,axiom,
    ! [VarCurr: state_type] :
      ( v67771(VarCurr,1)
    <=> v67772(VarCurr) ) ).

tff(addAssignment_39271,axiom,
    ! [VarCurr: state_type] :
      ( v67771(VarCurr,2)
    <=> v67772(VarCurr) ) ).

tff(addAssignment_39270,axiom,
    ! [VarCurr: state_type] :
      ( v67771(VarCurr,3)
    <=> v67772(VarCurr) ) ).

tff(addAssignment_39269,axiom,
    ! [VarCurr: state_type] :
      ( v67772(VarCurr)
    <=> v67758(VarCurr) ) ).

tff(addAssignment_39268,axiom,
    ! [VarCurr: state_type] :
      ( v67766(VarCurr)
    <=> v67768(VarCurr) ) ).

tff(addAssignment_39267,axiom,
    ! [VarCurr: state_type] :
      ( v67768(VarCurr)
    <=> v67530(VarCurr,4) ) ).

tff(addAssignment_39266,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,4)
    <=> v52381(VarCurr,4) ) ).

tff(addAssignment_39265,axiom,
    ! [VarCurr: state_type] :
      ( v67762(VarCurr,3)
    <=> v67764(VarCurr,3) ) ).

tff(addAssignment_39264,axiom,
    ! [VarCurr: state_type] :
      ( v67764(VarCurr,3)
    <=> v67401(VarCurr,19) ) ).

tff(addAssignment_39263,axiom,
    ! [VarCurr: state_type] :
      ( v67758(VarCurr)
    <=> v67760(VarCurr) ) ).

tff(addAssignment_39262,axiom,
    ! [VarCurr: state_type] :
      ( v67760(VarCurr)
    <=> v67520(VarCurr,4) ) ).

tff(addAssignment_39261,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,4)
    <=> v52363(VarCurr,4) ) ).

tff(addAssignment_39260,axiom,
    ! [VarCurr: state_type] :
      ( v67754(VarCurr,3)
    <=> v67756(VarCurr,3) ) ).

tff(addAssignment_39259,axiom,
    ! [VarCurr: state_type] :
      ( v67756(VarCurr,3)
    <=> v67401(VarCurr,23) ) ).

tff(addAssignment_39258,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,23)
    <=> v67403(VarCurr,23) ) ).

tff(addAssignment_39257,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,23)
    <=> v67405(VarCurr,23) ) ).

tff(addAssignment_39256,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,23)
    <=> v67514(VarCurr,23) ) ).

tff(addAssignment_39255,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,23)
    <=> v67428(VarCurr,23) ) ).

tff(addAssignment_39254,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,23)
    <=> v67430(VarCurr,23) ) ).

tff(addAssignment_39253,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,23)
    <=> v67432(VarCurr,23) ) ).

tff(addAssignment_39252,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,23)
    <=> v67434(VarCurr,23) ) ).

tff(addAssignment_39251,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,23)
    <=> v67436(VarCurr,23) ) ).

tff(addAssignment_39250,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,23)
    <=> v67438(VarCurr,23) ) ).

tff(addAssignment_39249,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,23)
    <=> v67497(VarCurr,23) ) ).

tff(addAssignment_39248,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,23)
    <=> v67493(VarCurr,23) ) ).

tff(addAssignment_39247,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,23)
    <=> v67495(VarCurr,23) ) ).

tff(addAssignment_39246,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,23)
    <=> v67496(VarCurr,23) ) ).

tff(addAssignment_39245,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,47)
    <=> v33839(VarCurr,47) ) ).

tff(addAssignment_39244,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,47)
    <=> v33841(VarCurr,47) ) ).

tff(addAssignment_39243,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,47)
    <=> v14155(VarCurr,11) ) ).

tff(addAssignment_39242,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,23)
    <=> v67489(VarCurr,23) ) ).

tff(addAssignment_39241,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,23)
    <=> v6234(VarCurr,23) ) ).

tff(addAssignment_39240,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,23)
    <=> v67485(VarCurr,23) ) ).

tff(addAssignment_39239,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,23)
    <=> $false ) ).

tff(addAssignment_39238,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,23)
    <=> v67409(VarCurr,23) ) ).

tff(addAssignment_39237,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,23)
    <=> v67423(VarCurr,23) ) ).

tff(addAssignment_39236,axiom,
    ! [VarCurr: state_type] :
      ( v67705(VarCurr)
    <=> v67707(VarCurr) ) ).

tff(addAssignment_39235,axiom,
    ! [VarCurr: state_type] :
      ( v67707(VarCurr)
    <=> v67349(VarCurr,15) ) ).

tff(addAssignment_39234,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,15)
    <=> v67351(VarCurr,15) ) ).

tff(addAssignment_39233,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,15)
    <=> v67353(VarCurr,15) ) ).

tff(addAssignment_39232,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,15)
    <=> v67355(VarCurr,15) ) ).

tff(addAssignment_39231,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,15)
    <=> v67357(VarCurr,15) ) ).

tff(addAssignment_39230,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,15)
    <=> v67359(VarCurr,15) ) ).

tff(addAssignment_39229,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,15)
    <=> v67580(VarCurr,15) ) ).

tff(addAssignment_39228,axiom,
    ! [VarCurr: state_type] :
      ( v67609(VarCurr,3)
    <=> v67363(VarCurr,15) ) ).

tff(addAssignment_39227,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,15)
    <=> v67365(VarCurr,15) ) ).

tff(addAssignment_39226,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,15)
    <=> v67737(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67738(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67737(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_768,axiom,
    ! [VarNext: state_type] :
      ( v67738(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67737(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67738(VarNext)
      <=> v67739(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67739(VarNext)
      <=> ( v67741(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67741(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39225,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,15)
    <=> v67389(VarCurr,15) ) ).

tff(addAssignment_39224,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,15)
    <=> v67391(VarCurr,15) ) ).

tff(addAssignment_39223,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,15)
    <=> v67710(VarCurr,3) ) ).

tff(addAssignment_39222,axiom,
    ! [VarCurr: state_type] :
      ( v67710(VarCurr,3)
    <=> v67712(VarCurr,3) ) ).

tff(addAssignment_39221,axiom,
    ! [VarCurr: state_type] :
      ( v67712(VarCurr,3)
    <=> v67729(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_961,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67729(VarCurr,B)
      <=> ( v67730(VarCurr,B)
          | v67733(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67733(VarCurr,B)
      <=> ( v67722(VarCurr,B)
          & v67734(VarCurr,B) ) ) ) ).

tff(addAssignment_39220,axiom,
    ! [VarCurr: state_type] :
      ( v67734(VarCurr,0)
    <=> v67735(VarCurr) ) ).

tff(addAssignment_39219,axiom,
    ! [VarCurr: state_type] :
      ( v67734(VarCurr,1)
    <=> v67735(VarCurr) ) ).

tff(addAssignment_39218,axiom,
    ! [VarCurr: state_type] :
      ( v67734(VarCurr,2)
    <=> v67735(VarCurr) ) ).

tff(addAssignment_39217,axiom,
    ! [VarCurr: state_type] :
      ( v67734(VarCurr,3)
    <=> v67735(VarCurr) ) ).

tff(addAssignment_39216,axiom,
    ! [VarCurr: state_type] :
      ( v67735(VarCurr)
    <=> v67726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67730(VarCurr,B)
      <=> ( v67714(VarCurr,B)
          & v67731(VarCurr,B) ) ) ) ).

tff(addAssignment_39215,axiom,
    ! [VarCurr: state_type] :
      ( v67731(VarCurr,0)
    <=> v67732(VarCurr) ) ).

tff(addAssignment_39214,axiom,
    ! [VarCurr: state_type] :
      ( v67731(VarCurr,1)
    <=> v67732(VarCurr) ) ).

tff(addAssignment_39213,axiom,
    ! [VarCurr: state_type] :
      ( v67731(VarCurr,2)
    <=> v67732(VarCurr) ) ).

tff(addAssignment_39212,axiom,
    ! [VarCurr: state_type] :
      ( v67731(VarCurr,3)
    <=> v67732(VarCurr) ) ).

tff(addAssignment_39211,axiom,
    ! [VarCurr: state_type] :
      ( v67732(VarCurr)
    <=> v67718(VarCurr) ) ).

tff(addAssignment_39210,axiom,
    ! [VarCurr: state_type] :
      ( v67726(VarCurr)
    <=> v67728(VarCurr) ) ).

tff(addAssignment_39209,axiom,
    ! [VarCurr: state_type] :
      ( v67728(VarCurr)
    <=> v67530(VarCurr,3) ) ).

tff(addAssignment_39208,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,3)
    <=> v52381(VarCurr,3) ) ).

tff(addAssignment_39207,axiom,
    ! [VarCurr: state_type] :
      ( v67722(VarCurr,3)
    <=> v67724(VarCurr,3) ) ).

tff(addAssignment_39206,axiom,
    ! [VarCurr: state_type] :
      ( v67724(VarCurr,3)
    <=> v67401(VarCurr,15) ) ).

tff(addAssignment_39205,axiom,
    ! [VarCurr: state_type] :
      ( v67718(VarCurr)
    <=> v67720(VarCurr) ) ).

tff(addAssignment_39204,axiom,
    ! [VarCurr: state_type] :
      ( v67720(VarCurr)
    <=> v67520(VarCurr,3) ) ).

tff(addAssignment_39203,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,3)
    <=> v52363(VarCurr,3) ) ).

tff(addAssignment_39202,axiom,
    ! [VarCurr: state_type] :
      ( v67714(VarCurr,3)
    <=> v67716(VarCurr,3) ) ).

tff(addAssignment_39201,axiom,
    ! [VarCurr: state_type] :
      ( v67716(VarCurr,3)
    <=> v67401(VarCurr,19) ) ).

tff(addAssignment_39200,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,19)
    <=> v67403(VarCurr,19) ) ).

tff(addAssignment_39199,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,19)
    <=> v67405(VarCurr,19) ) ).

tff(addAssignment_39198,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,19)
    <=> v67514(VarCurr,19) ) ).

tff(addAssignment_39197,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,19)
    <=> v67428(VarCurr,19) ) ).

tff(addAssignment_39196,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,19)
    <=> v67430(VarCurr,19) ) ).

tff(addAssignment_39195,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,19)
    <=> v67432(VarCurr,19) ) ).

tff(addAssignment_39194,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,19)
    <=> v67434(VarCurr,19) ) ).

tff(addAssignment_39193,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,19)
    <=> v67436(VarCurr,19) ) ).

tff(addAssignment_39192,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,19)
    <=> v67438(VarCurr,19) ) ).

tff(addAssignment_39191,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,19)
    <=> v67497(VarCurr,19) ) ).

tff(addAssignment_39190,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,19)
    <=> v67493(VarCurr,19) ) ).

tff(addAssignment_39189,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,19)
    <=> v67495(VarCurr,19) ) ).

tff(addAssignment_39188,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,19)
    <=> v67496(VarCurr,19) ) ).

tff(addAssignment_39187,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,43)
    <=> v33839(VarCurr,43) ) ).

tff(addAssignment_39186,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,43)
    <=> v33841(VarCurr,43) ) ).

tff(addAssignment_39185,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,43)
    <=> v14155(VarCurr,7) ) ).

tff(addAssignment_39184,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,19)
    <=> v67489(VarCurr,19) ) ).

tff(addAssignment_39183,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,19)
    <=> v6234(VarCurr,19) ) ).

tff(addAssignment_39182,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,19)
    <=> v67485(VarCurr,19) ) ).

tff(addAssignment_39181,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,19)
    <=> $false ) ).

tff(addAssignment_39180,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,19)
    <=> v67409(VarCurr,19) ) ).

tff(addAssignment_39179,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,19)
    <=> v67423(VarCurr,19) ) ).

tff(addAssignment_39178,axiom,
    ! [VarCurr: state_type] :
      ( v67335(VarCurr)
    <=> v67337(VarCurr) ) ).

tff(addAssignment_39177,axiom,
    ! [VarCurr: state_type] :
      ( v67337(VarCurr)
    <=> v67339(VarCurr) ) ).

tff(addAssignment_39176,axiom,
    ! [VarCurr: state_type] :
      ( v67339(VarCurr)
    <=> v67341(VarCurr) ) ).

tff(addAssignment_39175,axiom,
    ! [VarCurr: state_type] :
      ( v67341(VarCurr)
    <=> v67343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6222,axiom,
    ! [VarCurr: state_type] :
      ( v67343(VarCurr)
    <=> ( v67693(VarCurr)
      <~> v67653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6221,axiom,
    ! [VarCurr: state_type] :
      ( v67693(VarCurr)
    <=> ( v67345(VarCurr)
      <~> v67613(VarCurr) ) ) ).

tff(addAssignment_39174,axiom,
    ! [VarCurr: state_type] :
      ( v67653(VarCurr)
    <=> v67655(VarCurr) ) ).

tff(addAssignment_39173,axiom,
    ! [VarCurr: state_type] :
      ( v67655(VarCurr)
    <=> v67349(VarCurr,11) ) ).

tff(addAssignment_39172,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,11)
    <=> v67351(VarCurr,11) ) ).

tff(addAssignment_39171,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,11)
    <=> v67353(VarCurr,11) ) ).

tff(addAssignment_39170,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,11)
    <=> v67355(VarCurr,11) ) ).

tff(addAssignment_39169,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,11)
    <=> v67357(VarCurr,11) ) ).

tff(addAssignment_39168,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,11)
    <=> v67359(VarCurr,11) ) ).

tff(addAssignment_39167,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,11)
    <=> v67580(VarCurr,11) ) ).

tff(addAssignment_39166,axiom,
    ! [VarCurr: state_type] :
      ( v67610(VarCurr,3)
    <=> v67363(VarCurr,11) ) ).

tff(addAssignment_39165,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,11)
    <=> v67365(VarCurr,11) ) ).

tff(addAssignment_39164,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,11)
    <=> v67685(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67686(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67685(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_767,axiom,
    ! [VarNext: state_type] :
      ( v67686(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67685(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67686(VarNext)
      <=> v67687(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67687(VarNext)
      <=> ( v67689(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67689(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39163,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,11)
    <=> v67389(VarCurr,11) ) ).

tff(addAssignment_39162,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,11)
    <=> v67391(VarCurr,11) ) ).

tff(addAssignment_39161,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,11)
    <=> v67658(VarCurr,3) ) ).

tff(addAssignment_39160,axiom,
    ! [VarCurr: state_type] :
      ( v67658(VarCurr,3)
    <=> v67660(VarCurr,3) ) ).

tff(addAssignment_39159,axiom,
    ! [VarCurr: state_type] :
      ( v67660(VarCurr,3)
    <=> v67677(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67677(VarCurr,B)
      <=> ( v67678(VarCurr,B)
          | v67681(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67681(VarCurr,B)
      <=> ( v67670(VarCurr,B)
          & v67682(VarCurr,B) ) ) ) ).

tff(addAssignment_39158,axiom,
    ! [VarCurr: state_type] :
      ( v67682(VarCurr,0)
    <=> v67683(VarCurr) ) ).

tff(addAssignment_39157,axiom,
    ! [VarCurr: state_type] :
      ( v67682(VarCurr,1)
    <=> v67683(VarCurr) ) ).

tff(addAssignment_39156,axiom,
    ! [VarCurr: state_type] :
      ( v67682(VarCurr,2)
    <=> v67683(VarCurr) ) ).

tff(addAssignment_39155,axiom,
    ! [VarCurr: state_type] :
      ( v67682(VarCurr,3)
    <=> v67683(VarCurr) ) ).

tff(addAssignment_39154,axiom,
    ! [VarCurr: state_type] :
      ( v67683(VarCurr)
    <=> v67674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67678(VarCurr,B)
      <=> ( v67662(VarCurr,B)
          & v67679(VarCurr,B) ) ) ) ).

tff(addAssignment_39153,axiom,
    ! [VarCurr: state_type] :
      ( v67679(VarCurr,0)
    <=> v67680(VarCurr) ) ).

tff(addAssignment_39152,axiom,
    ! [VarCurr: state_type] :
      ( v67679(VarCurr,1)
    <=> v67680(VarCurr) ) ).

tff(addAssignment_39151,axiom,
    ! [VarCurr: state_type] :
      ( v67679(VarCurr,2)
    <=> v67680(VarCurr) ) ).

tff(addAssignment_39150,axiom,
    ! [VarCurr: state_type] :
      ( v67679(VarCurr,3)
    <=> v67680(VarCurr) ) ).

tff(addAssignment_39149,axiom,
    ! [VarCurr: state_type] :
      ( v67680(VarCurr)
    <=> v67666(VarCurr) ) ).

tff(addAssignment_39148,axiom,
    ! [VarCurr: state_type] :
      ( v67674(VarCurr)
    <=> v67676(VarCurr) ) ).

tff(addAssignment_39147,axiom,
    ! [VarCurr: state_type] :
      ( v67676(VarCurr)
    <=> v67530(VarCurr,2) ) ).

tff(addAssignment_39146,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,2)
    <=> v52381(VarCurr,2) ) ).

tff(addAssignment_39145,axiom,
    ! [VarCurr: state_type] :
      ( v67670(VarCurr,3)
    <=> v67672(VarCurr,3) ) ).

tff(addAssignment_39144,axiom,
    ! [VarCurr: state_type] :
      ( v67672(VarCurr,3)
    <=> v67401(VarCurr,11) ) ).

tff(addAssignment_39143,axiom,
    ! [VarCurr: state_type] :
      ( v67666(VarCurr)
    <=> v67668(VarCurr) ) ).

tff(addAssignment_39142,axiom,
    ! [VarCurr: state_type] :
      ( v67668(VarCurr)
    <=> v67520(VarCurr,2) ) ).

tff(addAssignment_39141,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,2)
    <=> v52363(VarCurr,2) ) ).

tff(addAssignment_39140,axiom,
    ! [VarCurr: state_type] :
      ( v67662(VarCurr,3)
    <=> v67664(VarCurr,3) ) ).

tff(addAssignment_39139,axiom,
    ! [VarCurr: state_type] :
      ( v67664(VarCurr,3)
    <=> v67401(VarCurr,15) ) ).

tff(addAssignment_39138,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,15)
    <=> v67403(VarCurr,15) ) ).

tff(addAssignment_39137,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,15)
    <=> v67405(VarCurr,15) ) ).

tff(addAssignment_39136,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,15)
    <=> v67514(VarCurr,15) ) ).

tff(addAssignment_39135,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,15)
    <=> v67428(VarCurr,15) ) ).

tff(addAssignment_39134,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,15)
    <=> v67430(VarCurr,15) ) ).

tff(addAssignment_39133,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,15)
    <=> v67432(VarCurr,15) ) ).

tff(addAssignment_39132,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,15)
    <=> v67434(VarCurr,15) ) ).

tff(addAssignment_39131,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,15)
    <=> v67436(VarCurr,15) ) ).

tff(addAssignment_39130,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,15)
    <=> v67438(VarCurr,15) ) ).

tff(addAssignment_39129,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,15)
    <=> v67497(VarCurr,15) ) ).

tff(addAssignment_39128,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,15)
    <=> v67493(VarCurr,15) ) ).

tff(addAssignment_39127,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,15)
    <=> v67495(VarCurr,15) ) ).

tff(addAssignment_39126,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,15)
    <=> v67496(VarCurr,15) ) ).

tff(addAssignment_39125,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,33)
    <=> v33839(VarCurr,33) ) ).

tff(addAssignment_39124,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,15)
    <=> v67489(VarCurr,15) ) ).

tff(addAssignment_39123,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,15)
    <=> v6234(VarCurr,15) ) ).

tff(addAssignment_39122,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,15)
    <=> v67485(VarCurr,15) ) ).

tff(addAssignment_39121,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_39120,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,15)
    <=> v67409(VarCurr,15) ) ).

tff(addAssignment_39119,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,15)
    <=> v67423(VarCurr,15) ) ).

tff(addAssignment_39118,axiom,
    ! [VarCurr: state_type] :
      ( v67613(VarCurr)
    <=> v67615(VarCurr) ) ).

tff(addAssignment_39117,axiom,
    ! [VarCurr: state_type] :
      ( v67615(VarCurr)
    <=> v67349(VarCurr,7) ) ).

tff(addAssignment_39116,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,7)
    <=> v67351(VarCurr,7) ) ).

tff(addAssignment_39115,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,7)
    <=> v67353(VarCurr,7) ) ).

tff(addAssignment_39114,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,7)
    <=> v67355(VarCurr,7) ) ).

tff(addAssignment_39113,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,7)
    <=> v67357(VarCurr,7) ) ).

tff(addAssignment_39112,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,7)
    <=> v67359(VarCurr,7) ) ).

tff(addAssignment_39111,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,7)
    <=> v67580(VarCurr,7) ) ).

tff(addAssignment_39110,axiom,
    ! [VarCurr: state_type] :
      ( v67611(VarCurr,3)
    <=> v67363(VarCurr,7) ) ).

tff(addAssignment_39109,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,7)
    <=> v67365(VarCurr,7) ) ).

tff(addAssignment_39108,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,7)
    <=> v67645(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67646(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67645(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_766,axiom,
    ! [VarNext: state_type] :
      ( v67646(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67645(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67646(VarNext)
      <=> v67647(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67647(VarNext)
      <=> ( v67649(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67649(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39107,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,7)
    <=> v67389(VarCurr,7) ) ).

tff(addAssignment_39106,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,7)
    <=> v67391(VarCurr,7) ) ).

tff(addAssignment_39105,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,7)
    <=> v67618(VarCurr,3) ) ).

tff(addAssignment_39104,axiom,
    ! [VarCurr: state_type] :
      ( v67618(VarCurr,3)
    <=> v67620(VarCurr,3) ) ).

tff(addAssignment_39103,axiom,
    ! [VarCurr: state_type] :
      ( v67620(VarCurr,3)
    <=> v67637(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67637(VarCurr,B)
      <=> ( v67638(VarCurr,B)
          | v67641(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67641(VarCurr,B)
      <=> ( v67630(VarCurr,B)
          & v67642(VarCurr,B) ) ) ) ).

tff(addAssignment_39102,axiom,
    ! [VarCurr: state_type] :
      ( v67642(VarCurr,0)
    <=> v67643(VarCurr) ) ).

tff(addAssignment_39101,axiom,
    ! [VarCurr: state_type] :
      ( v67642(VarCurr,1)
    <=> v67643(VarCurr) ) ).

tff(addAssignment_39100,axiom,
    ! [VarCurr: state_type] :
      ( v67642(VarCurr,2)
    <=> v67643(VarCurr) ) ).

tff(addAssignment_39099,axiom,
    ! [VarCurr: state_type] :
      ( v67642(VarCurr,3)
    <=> v67643(VarCurr) ) ).

tff(addAssignment_39098,axiom,
    ! [VarCurr: state_type] :
      ( v67643(VarCurr)
    <=> v67634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67638(VarCurr,B)
      <=> ( v67622(VarCurr,B)
          & v67639(VarCurr,B) ) ) ) ).

tff(addAssignment_39097,axiom,
    ! [VarCurr: state_type] :
      ( v67639(VarCurr,0)
    <=> v67640(VarCurr) ) ).

tff(addAssignment_39096,axiom,
    ! [VarCurr: state_type] :
      ( v67639(VarCurr,1)
    <=> v67640(VarCurr) ) ).

tff(addAssignment_39095,axiom,
    ! [VarCurr: state_type] :
      ( v67639(VarCurr,2)
    <=> v67640(VarCurr) ) ).

tff(addAssignment_39094,axiom,
    ! [VarCurr: state_type] :
      ( v67639(VarCurr,3)
    <=> v67640(VarCurr) ) ).

tff(addAssignment_39093,axiom,
    ! [VarCurr: state_type] :
      ( v67640(VarCurr)
    <=> v67626(VarCurr) ) ).

tff(addAssignment_39092,axiom,
    ! [VarCurr: state_type] :
      ( v67634(VarCurr)
    <=> v67636(VarCurr) ) ).

tff(addAssignment_39091,axiom,
    ! [VarCurr: state_type] :
      ( v67636(VarCurr)
    <=> v67530(VarCurr,1) ) ).

tff(addAssignment_39090,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,1)
    <=> v52381(VarCurr,1) ) ).

tff(addAssignment_39089,axiom,
    ! [VarCurr: state_type] :
      ( v67630(VarCurr,3)
    <=> v67632(VarCurr,3) ) ).

tff(addAssignment_39088,axiom,
    ! [VarCurr: state_type] :
      ( v67632(VarCurr,3)
    <=> v67401(VarCurr,7) ) ).

tff(addAssignment_39087,axiom,
    ! [VarCurr: state_type] :
      ( v67626(VarCurr)
    <=> v67628(VarCurr) ) ).

tff(addAssignment_39086,axiom,
    ! [VarCurr: state_type] :
      ( v67628(VarCurr)
    <=> v67520(VarCurr,1) ) ).

tff(addAssignment_39085,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,1)
    <=> v52363(VarCurr,1) ) ).

tff(addAssignment_39084,axiom,
    ! [VarCurr: state_type] :
      ( v67622(VarCurr,3)
    <=> v67624(VarCurr,3) ) ).

tff(addAssignment_39083,axiom,
    ! [VarCurr: state_type] :
      ( v67624(VarCurr,3)
    <=> v67401(VarCurr,11) ) ).

tff(addAssignment_39082,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,11)
    <=> v67403(VarCurr,11) ) ).

tff(addAssignment_39081,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,11)
    <=> v67405(VarCurr,11) ) ).

tff(addAssignment_39080,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,11)
    <=> v67514(VarCurr,11) ) ).

tff(addAssignment_39079,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,11)
    <=> v67428(VarCurr,11) ) ).

tff(addAssignment_39078,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,11)
    <=> v67430(VarCurr,11) ) ).

tff(addAssignment_39077,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,11)
    <=> v67432(VarCurr,11) ) ).

tff(addAssignment_39076,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,11)
    <=> v67434(VarCurr,11) ) ).

tff(addAssignment_39075,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,11)
    <=> v67436(VarCurr,11) ) ).

tff(addAssignment_39074,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,11)
    <=> v67438(VarCurr,11) ) ).

tff(addAssignment_39073,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,11)
    <=> v67497(VarCurr,11) ) ).

tff(addAssignment_39072,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,11)
    <=> v67493(VarCurr,11) ) ).

tff(addAssignment_39071,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,11)
    <=> v67495(VarCurr,11) ) ).

tff(addAssignment_39070,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,11)
    <=> v67496(VarCurr,11) ) ).

tff(addAssignment_39069,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,23)
    <=> v33839(VarCurr,23) ) ).

tff(addAssignment_39068,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,11)
    <=> v67489(VarCurr,11) ) ).

tff(addAssignment_39067,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,11)
    <=> v6234(VarCurr,11) ) ).

tff(addAssignment_39066,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,11)
    <=> v67485(VarCurr,11) ) ).

tff(addAssignment_39065,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_39064,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,11)
    <=> v67409(VarCurr,11) ) ).

tff(addAssignment_39063,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,11)
    <=> v67423(VarCurr,11) ) ).

tff(addAssignment_39062,axiom,
    ! [VarCurr: state_type] :
      ( v67345(VarCurr)
    <=> v67347(VarCurr) ) ).

tff(addAssignment_39061,axiom,
    ! [VarCurr: state_type] :
      ( v67347(VarCurr)
    <=> v67349(VarCurr,3) ) ).

tff(addAssignment_39060,axiom,
    ! [VarCurr: state_type] :
      ( v67349(VarCurr,3)
    <=> v67351(VarCurr,3) ) ).

tff(addAssignment_39059,axiom,
    ! [VarCurr: state_type] :
      ( v67351(VarCurr,3)
    <=> v67353(VarCurr,3) ) ).

tff(addAssignment_39058,axiom,
    ! [VarCurr: state_type] :
      ( v67353(VarCurr,3)
    <=> v67355(VarCurr,3) ) ).

tff(addAssignment_39057,axiom,
    ! [VarCurr: state_type] :
      ( v67355(VarCurr,3)
    <=> v67357(VarCurr,3) ) ).

tff(addAssignment_39056,axiom,
    ! [VarCurr: state_type] :
      ( v67357(VarCurr,3)
    <=> v67359(VarCurr,3) ) ).

tff(addAssignment_39055,axiom,
    ! [VarCurr: state_type] :
      ( v67359(VarCurr,3)
    <=> v67580(VarCurr,3) ) ).

tff(addAssignment_39054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67580(VarCurr,B)
      <=> v67361(VarCurr,B) ) ) ).

tff(addAssignment_39053,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,7)
      <=> v67611(VarCurr,3) )
      & ( v67580(VarCurr,6)
      <=> v67611(VarCurr,2) )
      & ( v67580(VarCurr,5)
      <=> v67611(VarCurr,1) )
      & ( v67580(VarCurr,4)
      <=> v67611(VarCurr,0) ) ) ).

tff(addAssignment_39052,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,11)
      <=> v67610(VarCurr,3) )
      & ( v67580(VarCurr,10)
      <=> v67610(VarCurr,2) )
      & ( v67580(VarCurr,9)
      <=> v67610(VarCurr,1) )
      & ( v67580(VarCurr,8)
      <=> v67610(VarCurr,0) ) ) ).

tff(addAssignment_39051,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,15)
      <=> v67609(VarCurr,3) )
      & ( v67580(VarCurr,14)
      <=> v67609(VarCurr,2) )
      & ( v67580(VarCurr,13)
      <=> v67609(VarCurr,1) )
      & ( v67580(VarCurr,12)
      <=> v67609(VarCurr,0) ) ) ).

tff(addAssignment_39050,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,19)
      <=> v67608(VarCurr,3) )
      & ( v67580(VarCurr,18)
      <=> v67608(VarCurr,2) )
      & ( v67580(VarCurr,17)
      <=> v67608(VarCurr,1) )
      & ( v67580(VarCurr,16)
      <=> v67608(VarCurr,0) ) ) ).

tff(addAssignment_39049,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,23)
      <=> v67607(VarCurr,3) )
      & ( v67580(VarCurr,22)
      <=> v67607(VarCurr,2) )
      & ( v67580(VarCurr,21)
      <=> v67607(VarCurr,1) )
      & ( v67580(VarCurr,20)
      <=> v67607(VarCurr,0) ) ) ).

tff(addAssignment_39048,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,27)
      <=> v67606(VarCurr,3) )
      & ( v67580(VarCurr,26)
      <=> v67606(VarCurr,2) )
      & ( v67580(VarCurr,25)
      <=> v67606(VarCurr,1) )
      & ( v67580(VarCurr,24)
      <=> v67606(VarCurr,0) ) ) ).

tff(addAssignment_39047,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,31)
      <=> v67605(VarCurr,3) )
      & ( v67580(VarCurr,30)
      <=> v67605(VarCurr,2) )
      & ( v67580(VarCurr,29)
      <=> v67605(VarCurr,1) )
      & ( v67580(VarCurr,28)
      <=> v67605(VarCurr,0) ) ) ).

tff(addAssignment_39046,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,35)
      <=> v67604(VarCurr,3) )
      & ( v67580(VarCurr,34)
      <=> v67604(VarCurr,2) )
      & ( v67580(VarCurr,33)
      <=> v67604(VarCurr,1) )
      & ( v67580(VarCurr,32)
      <=> v67604(VarCurr,0) ) ) ).

tff(addAssignment_39045,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,39)
      <=> v67603(VarCurr,3) )
      & ( v67580(VarCurr,38)
      <=> v67603(VarCurr,2) )
      & ( v67580(VarCurr,37)
      <=> v67603(VarCurr,1) )
      & ( v67580(VarCurr,36)
      <=> v67603(VarCurr,0) ) ) ).

tff(addAssignment_39044,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,43)
      <=> v67602(VarCurr,3) )
      & ( v67580(VarCurr,42)
      <=> v67602(VarCurr,2) )
      & ( v67580(VarCurr,41)
      <=> v67602(VarCurr,1) )
      & ( v67580(VarCurr,40)
      <=> v67602(VarCurr,0) ) ) ).

tff(addAssignment_39043,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,47)
      <=> v67601(VarCurr,3) )
      & ( v67580(VarCurr,46)
      <=> v67601(VarCurr,2) )
      & ( v67580(VarCurr,45)
      <=> v67601(VarCurr,1) )
      & ( v67580(VarCurr,44)
      <=> v67601(VarCurr,0) ) ) ).

tff(addAssignment_39042,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,51)
      <=> v67600(VarCurr,3) )
      & ( v67580(VarCurr,50)
      <=> v67600(VarCurr,2) )
      & ( v67580(VarCurr,49)
      <=> v67600(VarCurr,1) )
      & ( v67580(VarCurr,48)
      <=> v67600(VarCurr,0) ) ) ).

tff(addAssignment_39041,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,55)
      <=> v67599(VarCurr,3) )
      & ( v67580(VarCurr,54)
      <=> v67599(VarCurr,2) )
      & ( v67580(VarCurr,53)
      <=> v67599(VarCurr,1) )
      & ( v67580(VarCurr,52)
      <=> v67599(VarCurr,0) ) ) ).

tff(addAssignment_39040,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,59)
      <=> v67598(VarCurr,3) )
      & ( v67580(VarCurr,58)
      <=> v67598(VarCurr,2) )
      & ( v67580(VarCurr,57)
      <=> v67598(VarCurr,1) )
      & ( v67580(VarCurr,56)
      <=> v67598(VarCurr,0) ) ) ).

tff(addAssignment_39039,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,63)
      <=> v67597(VarCurr,3) )
      & ( v67580(VarCurr,62)
      <=> v67597(VarCurr,2) )
      & ( v67580(VarCurr,61)
      <=> v67597(VarCurr,1) )
      & ( v67580(VarCurr,60)
      <=> v67597(VarCurr,0) ) ) ).

tff(addAssignment_39038,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,67)
      <=> v67596(VarCurr,3) )
      & ( v67580(VarCurr,66)
      <=> v67596(VarCurr,2) )
      & ( v67580(VarCurr,65)
      <=> v67596(VarCurr,1) )
      & ( v67580(VarCurr,64)
      <=> v67596(VarCurr,0) ) ) ).

tff(addAssignment_39037,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,71)
      <=> v67595(VarCurr,3) )
      & ( v67580(VarCurr,70)
      <=> v67595(VarCurr,2) )
      & ( v67580(VarCurr,69)
      <=> v67595(VarCurr,1) )
      & ( v67580(VarCurr,68)
      <=> v67595(VarCurr,0) ) ) ).

tff(addAssignment_39036,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,75)
      <=> v67594(VarCurr,3) )
      & ( v67580(VarCurr,74)
      <=> v67594(VarCurr,2) )
      & ( v67580(VarCurr,73)
      <=> v67594(VarCurr,1) )
      & ( v67580(VarCurr,72)
      <=> v67594(VarCurr,0) ) ) ).

tff(addAssignment_39035,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,79)
      <=> v67593(VarCurr,3) )
      & ( v67580(VarCurr,78)
      <=> v67593(VarCurr,2) )
      & ( v67580(VarCurr,77)
      <=> v67593(VarCurr,1) )
      & ( v67580(VarCurr,76)
      <=> v67593(VarCurr,0) ) ) ).

tff(addAssignment_39034,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,83)
      <=> v67592(VarCurr,3) )
      & ( v67580(VarCurr,82)
      <=> v67592(VarCurr,2) )
      & ( v67580(VarCurr,81)
      <=> v67592(VarCurr,1) )
      & ( v67580(VarCurr,80)
      <=> v67592(VarCurr,0) ) ) ).

tff(addAssignment_39033,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,87)
      <=> v67591(VarCurr,3) )
      & ( v67580(VarCurr,86)
      <=> v67591(VarCurr,2) )
      & ( v67580(VarCurr,85)
      <=> v67591(VarCurr,1) )
      & ( v67580(VarCurr,84)
      <=> v67591(VarCurr,0) ) ) ).

tff(addAssignment_39032,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,91)
      <=> v67590(VarCurr,3) )
      & ( v67580(VarCurr,90)
      <=> v67590(VarCurr,2) )
      & ( v67580(VarCurr,89)
      <=> v67590(VarCurr,1) )
      & ( v67580(VarCurr,88)
      <=> v67590(VarCurr,0) ) ) ).

tff(addAssignment_39031,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,95)
      <=> v67589(VarCurr,3) )
      & ( v67580(VarCurr,94)
      <=> v67589(VarCurr,2) )
      & ( v67580(VarCurr,93)
      <=> v67589(VarCurr,1) )
      & ( v67580(VarCurr,92)
      <=> v67589(VarCurr,0) ) ) ).

tff(addAssignment_39030,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,99)
      <=> v67588(VarCurr,3) )
      & ( v67580(VarCurr,98)
      <=> v67588(VarCurr,2) )
      & ( v67580(VarCurr,97)
      <=> v67588(VarCurr,1) )
      & ( v67580(VarCurr,96)
      <=> v67588(VarCurr,0) ) ) ).

tff(addAssignment_39029,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,103)
      <=> v67587(VarCurr,3) )
      & ( v67580(VarCurr,102)
      <=> v67587(VarCurr,2) )
      & ( v67580(VarCurr,101)
      <=> v67587(VarCurr,1) )
      & ( v67580(VarCurr,100)
      <=> v67587(VarCurr,0) ) ) ).

tff(addAssignment_39028,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,107)
      <=> v67586(VarCurr,3) )
      & ( v67580(VarCurr,106)
      <=> v67586(VarCurr,2) )
      & ( v67580(VarCurr,105)
      <=> v67586(VarCurr,1) )
      & ( v67580(VarCurr,104)
      <=> v67586(VarCurr,0) ) ) ).

tff(addAssignment_39027,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,111)
      <=> v67585(VarCurr,3) )
      & ( v67580(VarCurr,110)
      <=> v67585(VarCurr,2) )
      & ( v67580(VarCurr,109)
      <=> v67585(VarCurr,1) )
      & ( v67580(VarCurr,108)
      <=> v67585(VarCurr,0) ) ) ).

tff(addAssignment_39026,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,115)
      <=> v67584(VarCurr,3) )
      & ( v67580(VarCurr,114)
      <=> v67584(VarCurr,2) )
      & ( v67580(VarCurr,113)
      <=> v67584(VarCurr,1) )
      & ( v67580(VarCurr,112)
      <=> v67584(VarCurr,0) ) ) ).

tff(addAssignment_39025,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,119)
      <=> v67583(VarCurr,3) )
      & ( v67580(VarCurr,118)
      <=> v67583(VarCurr,2) )
      & ( v67580(VarCurr,117)
      <=> v67583(VarCurr,1) )
      & ( v67580(VarCurr,116)
      <=> v67583(VarCurr,0) ) ) ).

tff(addAssignment_39024,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,123)
      <=> v67582(VarCurr,3) )
      & ( v67580(VarCurr,122)
      <=> v67582(VarCurr,2) )
      & ( v67580(VarCurr,121)
      <=> v67582(VarCurr,1) )
      & ( v67580(VarCurr,120)
      <=> v67582(VarCurr,0) ) ) ).

tff(addAssignment_39023,axiom,
    ! [VarCurr: state_type] :
      ( ( v67580(VarCurr,127)
      <=> v67581(VarCurr,3) )
      & ( v67580(VarCurr,126)
      <=> v67581(VarCurr,2) )
      & ( v67580(VarCurr,125)
      <=> v67581(VarCurr,1) )
      & ( v67580(VarCurr,124)
      <=> v67581(VarCurr,0) ) ) ).

tff(addAssignment_39022,axiom,
    ! [VarCurr: state_type] :
      ( v67361(VarCurr,3)
    <=> v67363(VarCurr,3) ) ).

tff(addAssignment_39021,axiom,
    ! [VarCurr: state_type] :
      ( v67363(VarCurr,3)
    <=> v67365(VarCurr,3) ) ).

tff(addAssignment_39020,axiom,
    ! [VarNext: state_type] :
      ( v67365(VarNext,3)
    <=> v67563(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67564(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v67563(VarNext,B)
            <=> v67365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_765,axiom,
    ! [VarNext: state_type] :
      ( v67564(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67563(VarNext,B)
          <=> v67574(VarNext,B) ) ) ) ).

tff(addAssignment_39019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67574(VarNext,B)
          <=> v67572(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67572(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_401,axiom,
    ! [VarCurr: state_type] :
      ( v67575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67572(VarCurr,B)
          <=> v67387(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6216,axiom,
    ! [VarCurr: state_type] :
      ( v67575(VarCurr)
    <=> ( v67576(VarCurr)
        & v67577(VarCurr) ) ) ).

tff(writeUnaryOperator_3273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67577(VarCurr)
    <=> v67377(VarCurr) ) ).

tff(writeUnaryOperator_3272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67576(VarCurr)
    <=> v67367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67564(VarNext)
      <=> v67565(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67565(VarNext)
      <=> ( v67566(VarNext)
          & v67539(VarNext) ) ) ) ).

tff(writeUnaryOperator_3271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67566(VarNext)
      <=> v67568(VarNext) ) ) ).

tff(addAssignment_39018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67568(VarNext)
      <=> v67539(VarCurr) ) ) ).

tff(addAssignment_39017,axiom,
    ! [VarCurr: state_type] :
      ( v67539(VarCurr)
    <=> v67541(VarCurr) ) ).

tff(addAssignment_39016,axiom,
    ! [VarCurr: state_type] :
      ( v67541(VarCurr)
    <=> v67543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6213,axiom,
    ! [VarCurr: state_type] :
      ( v67543(VarCurr)
    <=> ( v67561(VarCurr)
        | v67553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6212,axiom,
    ! [VarCurr: state_type] :
      ( v67561(VarCurr)
    <=> ( v67545(VarCurr)
        & v67551(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_234,axiom,
    ( v67551(constB0)
  <=> $true ) ).

tff(addAssignment_39015,axiom,
    ! [VarCurr: state_type] :
      ( v67553(VarCurr)
    <=> v67555(VarCurr) ) ).

tff(addAssignment_39014,axiom,
    ! [VarCurr: state_type] :
      ( v67555(VarCurr)
    <=> v67557(VarCurr) ) ).

tff(addAssignment_39013,axiom,
    ! [VarCurr: state_type] :
      ( v67557(VarCurr)
    <=> v67559(VarCurr) ) ).

tff(addAssignment_39012,axiom,
    ! [VarCurr: state_type] :
      ( v67559(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_39011,axiom,
    ! [VarCurr: state_type] :
      ( v67545(VarCurr)
    <=> v67547(VarCurr) ) ).

tff(addAssignment_39010,axiom,
    ! [VarCurr: state_type] :
      ( v67547(VarCurr)
    <=> v67549(VarCurr) ) ).

tff(addAssignment_39009,axiom,
    ! [VarCurr: state_type] :
      ( v67549(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_39008,axiom,
    ! [VarCurr: state_type] :
      ( v67387(VarCurr,3)
    <=> v67389(VarCurr,3) ) ).

tff(addAssignment_39007,axiom,
    ! [VarCurr: state_type] :
      ( v67389(VarCurr,3)
    <=> v67391(VarCurr,3) ) ).

tff(addAssignment_39006,axiom,
    ! [VarCurr: state_type] :
      ( v67391(VarCurr,3)
    <=> v67393(VarCurr,3) ) ).

tff(addAssignment_39005,axiom,
    ! [VarCurr: state_type] :
      ( v67393(VarCurr,3)
    <=> v67395(VarCurr,3) ) ).

tff(addAssignment_39004,axiom,
    ! [VarCurr: state_type] :
      ( v67395(VarCurr,3)
    <=> v67531(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67531(VarCurr,B)
      <=> ( v67532(VarCurr,B)
          | v67535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_951,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67535(VarCurr,B)
      <=> ( v67522(VarCurr,B)
          & v67536(VarCurr,B) ) ) ) ).

tff(addAssignment_39003,axiom,
    ! [VarCurr: state_type] :
      ( v67536(VarCurr,0)
    <=> v67537(VarCurr) ) ).

tff(addAssignment_39002,axiom,
    ! [VarCurr: state_type] :
      ( v67536(VarCurr,1)
    <=> v67537(VarCurr) ) ).

tff(addAssignment_39001,axiom,
    ! [VarCurr: state_type] :
      ( v67536(VarCurr,2)
    <=> v67537(VarCurr) ) ).

tff(addAssignment_39000,axiom,
    ! [VarCurr: state_type] :
      ( v67536(VarCurr,3)
    <=> v67537(VarCurr) ) ).

tff(addAssignment_38999,axiom,
    ! [VarCurr: state_type] :
      ( v67537(VarCurr)
    <=> v67526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v67532(VarCurr,B)
      <=> ( v67397(VarCurr,B)
          & v67533(VarCurr,B) ) ) ) ).

tff(addAssignment_38998,axiom,
    ! [VarCurr: state_type] :
      ( v67533(VarCurr,0)
    <=> v67534(VarCurr) ) ).

tff(addAssignment_38997,axiom,
    ! [VarCurr: state_type] :
      ( v67533(VarCurr,1)
    <=> v67534(VarCurr) ) ).

tff(addAssignment_38996,axiom,
    ! [VarCurr: state_type] :
      ( v67533(VarCurr,2)
    <=> v67534(VarCurr) ) ).

tff(addAssignment_38995,axiom,
    ! [VarCurr: state_type] :
      ( v67533(VarCurr,3)
    <=> v67534(VarCurr) ) ).

tff(addAssignment_38994,axiom,
    ! [VarCurr: state_type] :
      ( v67534(VarCurr)
    <=> v67516(VarCurr) ) ).

tff(addAssignment_38993,axiom,
    ! [VarCurr: state_type] :
      ( v67526(VarCurr)
    <=> v67528(VarCurr) ) ).

tff(addAssignment_38992,axiom,
    ! [VarCurr: state_type] :
      ( v67528(VarCurr)
    <=> v67530(VarCurr,0) ) ).

tff(addAssignment_38991,axiom,
    ! [VarCurr: state_type] :
      ( v67530(VarCurr,0)
    <=> v52381(VarCurr,0) ) ).

tff(addAssignment_38990,axiom,
    ! [VarCurr: state_type] :
      ( v67522(VarCurr,3)
    <=> v67524(VarCurr,3) ) ).

tff(addAssignment_38989,axiom,
    ! [VarCurr: state_type] :
      ( v67524(VarCurr,3)
    <=> v67401(VarCurr,3) ) ).

tff(addAssignment_38988,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,3)
    <=> v67403(VarCurr,3) ) ).

tff(addAssignment_38987,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,3)
    <=> v67405(VarCurr,3) ) ).

tff(addAssignment_38986,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,3)
    <=> v67514(VarCurr,3) ) ).

tff(addAssignment_38985,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,3)
    <=> v67428(VarCurr,3) ) ).

tff(addAssignment_38984,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,3)
    <=> v67430(VarCurr,3) ) ).

tff(addAssignment_38983,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,3)
    <=> v67432(VarCurr,3) ) ).

tff(addAssignment_38982,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,3)
    <=> v67434(VarCurr,3) ) ).

tff(addAssignment_38981,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,3)
    <=> v67436(VarCurr,3) ) ).

tff(addAssignment_38980,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,3)
    <=> v67438(VarCurr,3) ) ).

tff(addAssignment_38979,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,3)
    <=> v67497(VarCurr,3) ) ).

tff(addAssignment_38978,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,3)
    <=> v67493(VarCurr,3) ) ).

tff(addAssignment_38977,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,3)
    <=> v67495(VarCurr,3) ) ).

tff(addAssignment_38976,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,3)
    <=> v67496(VarCurr,3) ) ).

tff(addAssignment_38975,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,9)
    <=> v33839(VarCurr,9) ) ).

tff(addAssignment_38974,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,3)
    <=> v67489(VarCurr,3) ) ).

tff(addAssignment_38973,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,3)
    <=> v6234(VarCurr,3) ) ).

tff(addAssignment_38972,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,3)
    <=> v67485(VarCurr,3) ) ).

tff(addAssignment_38971,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_38970,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,3)
    <=> v67409(VarCurr,3) ) ).

tff(addAssignment_38969,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,3)
    <=> v67423(VarCurr,3) ) ).

tff(addAssignment_38968,axiom,
    ! [VarCurr: state_type] :
      ( v67516(VarCurr)
    <=> v67518(VarCurr) ) ).

tff(addAssignment_38967,axiom,
    ! [VarCurr: state_type] :
      ( v67518(VarCurr)
    <=> v67520(VarCurr,0) ) ).

tff(addAssignment_38966,axiom,
    ! [VarCurr: state_type] :
      ( v67520(VarCurr,0)
    <=> v52363(VarCurr,0) ) ).

tff(addAssignment_38965,axiom,
    ! [VarCurr: state_type] :
      ( v67397(VarCurr,3)
    <=> v67399(VarCurr,3) ) ).

tff(addAssignment_38964,axiom,
    ! [VarCurr: state_type] :
      ( v67399(VarCurr,3)
    <=> v67401(VarCurr,7) ) ).

tff(addAssignment_38963,axiom,
    ! [VarCurr: state_type] :
      ( v67401(VarCurr,7)
    <=> v67403(VarCurr,7) ) ).

tff(addAssignment_38962,axiom,
    ! [VarCurr: state_type] :
      ( v67403(VarCurr,7)
    <=> v67405(VarCurr,7) ) ).

tff(addAssignment_38961,axiom,
    ! [VarCurr: state_type] :
      ( v67405(VarCurr,7)
    <=> v67514(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v67514(VarCurr,B)
      <=> ( v67407(VarCurr,B)
          & v67426(VarCurr,B) ) ) ) ).

tff(addAssignment_38960,axiom,
    ! [VarCurr: state_type] :
      ( v67426(VarCurr,7)
    <=> v67428(VarCurr,7) ) ).

tff(addAssignment_38959,axiom,
    ! [VarCurr: state_type] :
      ( v67428(VarCurr,7)
    <=> v67430(VarCurr,7) ) ).

tff(addAssignment_38958,axiom,
    ! [VarCurr: state_type] :
      ( v67430(VarCurr,7)
    <=> v67432(VarCurr,7) ) ).

tff(addAssignment_38957,axiom,
    ! [VarCurr: state_type] :
      ( v67432(VarCurr,7)
    <=> v67434(VarCurr,7) ) ).

tff(addAssignment_38956,axiom,
    ! [VarCurr: state_type] :
      ( v67434(VarCurr,7)
    <=> v67436(VarCurr,7) ) ).

tff(addAssignment_38955,axiom,
    ! [VarCurr: state_type] :
      ( v67436(VarCurr,7)
    <=> v67438(VarCurr,7) ) ).

tff(addAssignment_38954,axiom,
    ! [VarCurr: state_type] :
      ( v67438(VarCurr,7)
    <=> v67497(VarCurr,7) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_3,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v67498(VarCurr)
        & ~ v67503(VarCurr)
        & ~ v67507(VarCurr)
        & ~ v67510(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67497(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_3,axiom,
    ! [VarCurr: state_type] :
      ( v67510(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67497(VarCurr,B)
          <=> $true ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_4,axiom,
    ! [VarCurr: state_type] :
      ( v67507(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67497(VarCurr,B)
          <=> v67491(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_11,axiom,
    ! [VarCurr: state_type] :
      ( v67503(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67497(VarCurr,B)
          <=> v67487(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_11,axiom,
    ! [VarCurr: state_type] :
      ( v67498(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v67497(VarCurr,B)
          <=> v67483(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6211,axiom,
    ! [VarCurr: state_type] :
      ( v67510(VarCurr)
    <=> ( v67512(VarCurr)
        & v67513(VarCurr) ) ) ).

tff(writeUnaryOperator_3270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67513(VarCurr)
    <=> v67440(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6210,axiom,
    ! [VarCurr: state_type] :
      ( v67512(VarCurr)
    <=> ( v67509(VarCurr)
        & v67502(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_594,axiom,
    ! [VarCurr: state_type] :
      ( v67507(VarCurr)
    <=> ( v67509(VarCurr)
        & v67440(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6209,axiom,
    ! [VarCurr: state_type] :
      ( v67509(VarCurr)
    <=> ( v67506(VarCurr)
        & v67501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6208,axiom,
    ! [VarCurr: state_type] :
      ( v67503(VarCurr)
    <=> ( v67505(VarCurr)
        & v67502(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_593,axiom,
    ! [VarCurr: state_type] :
      ( v67505(VarCurr)
    <=> ( v67506(VarCurr)
        & v67440(VarCurr,1) ) ) ).

tff(writeUnaryOperator_3269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67506(VarCurr)
    <=> v67440(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6207,axiom,
    ! [VarCurr: state_type] :
      ( v67498(VarCurr)
    <=> ( v67500(VarCurr)
        & v67502(VarCurr) ) ) ).

tff(writeUnaryOperator_3268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67502(VarCurr)
    <=> v67440(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6206,axiom,
    ! [VarCurr: state_type] :
      ( v67500(VarCurr)
    <=> ( v67440(VarCurr,0)
        & v67501(VarCurr) ) ) ).

tff(writeUnaryOperator_3267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67501(VarCurr)
    <=> v67440(VarCurr,1) ) ).

tff(addAssignment_38953,axiom,
    ! [VarCurr: state_type] :
      ( v67491(VarCurr,7)
    <=> v67493(VarCurr,7) ) ).

tff(addAssignment_38952,axiom,
    ! [VarCurr: state_type] :
      ( v67493(VarCurr,7)
    <=> v67495(VarCurr,7) ) ).

tff(addAssignment_38951,axiom,
    ! [VarCurr: state_type] :
      ( v67495(VarCurr,7)
    <=> v67496(VarCurr,7) ) ).

tff(addAssignment_38950,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,5)
      <=> v52334(VarCurr,11) )
      & ( v67496(VarCurr,4)
      <=> v52334(VarCurr,10) )
      & ( v67496(VarCurr,3)
      <=> v52334(VarCurr,9) )
      & ( v67496(VarCurr,2)
      <=> v52334(VarCurr,8) )
      & ( v67496(VarCurr,1)
      <=> v52334(VarCurr,7) )
      & ( v67496(VarCurr,0)
      <=> v52334(VarCurr,6) ) ) ).

tff(addAssignment_38949,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,11)
      <=> v52334(VarCurr,23) )
      & ( v67496(VarCurr,10)
      <=> v52334(VarCurr,22) )
      & ( v67496(VarCurr,9)
      <=> v52334(VarCurr,21) )
      & ( v67496(VarCurr,8)
      <=> v52334(VarCurr,20) )
      & ( v67496(VarCurr,7)
      <=> v52334(VarCurr,19) )
      & ( v67496(VarCurr,6)
      <=> v52334(VarCurr,18) ) ) ).

tff(addAssignment_38948,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,17)
      <=> v52334(VarCurr,35) )
      & ( v67496(VarCurr,16)
      <=> v52334(VarCurr,34) )
      & ( v67496(VarCurr,15)
      <=> v52334(VarCurr,33) )
      & ( v67496(VarCurr,14)
      <=> v52334(VarCurr,32) )
      & ( v67496(VarCurr,13)
      <=> v52334(VarCurr,31) )
      & ( v67496(VarCurr,12)
      <=> v52334(VarCurr,30) ) ) ).

tff(addAssignment_38947,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,23)
      <=> v52334(VarCurr,47) )
      & ( v67496(VarCurr,22)
      <=> v52334(VarCurr,46) )
      & ( v67496(VarCurr,21)
      <=> v52334(VarCurr,45) )
      & ( v67496(VarCurr,20)
      <=> v52334(VarCurr,44) )
      & ( v67496(VarCurr,19)
      <=> v52334(VarCurr,43) )
      & ( v67496(VarCurr,18)
      <=> v52334(VarCurr,42) ) ) ).

tff(addAssignment_38946,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,29)
      <=> v52334(VarCurr,59) )
      & ( v67496(VarCurr,28)
      <=> v52334(VarCurr,58) )
      & ( v67496(VarCurr,27)
      <=> v52334(VarCurr,57) )
      & ( v67496(VarCurr,26)
      <=> v52334(VarCurr,56) )
      & ( v67496(VarCurr,25)
      <=> v52334(VarCurr,55) )
      & ( v67496(VarCurr,24)
      <=> v52334(VarCurr,54) ) ) ).

tff(addAssignment_38945,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,35)
      <=> v52334(VarCurr,71) )
      & ( v67496(VarCurr,34)
      <=> v52334(VarCurr,70) )
      & ( v67496(VarCurr,33)
      <=> v52334(VarCurr,69) )
      & ( v67496(VarCurr,32)
      <=> v52334(VarCurr,68) )
      & ( v67496(VarCurr,31)
      <=> v52334(VarCurr,67) )
      & ( v67496(VarCurr,30)
      <=> v52334(VarCurr,66) ) ) ).

tff(addAssignment_38944,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,41)
      <=> v52334(VarCurr,83) )
      & ( v67496(VarCurr,40)
      <=> v52334(VarCurr,82) )
      & ( v67496(VarCurr,39)
      <=> v52334(VarCurr,81) )
      & ( v67496(VarCurr,38)
      <=> v52334(VarCurr,80) )
      & ( v67496(VarCurr,37)
      <=> v52334(VarCurr,79) )
      & ( v67496(VarCurr,36)
      <=> v52334(VarCurr,78) ) ) ).

tff(addAssignment_38943,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,47)
      <=> v52334(VarCurr,95) )
      & ( v67496(VarCurr,46)
      <=> v52334(VarCurr,94) )
      & ( v67496(VarCurr,45)
      <=> v52334(VarCurr,93) )
      & ( v67496(VarCurr,44)
      <=> v52334(VarCurr,92) )
      & ( v67496(VarCurr,43)
      <=> v52334(VarCurr,91) )
      & ( v67496(VarCurr,42)
      <=> v52334(VarCurr,90) ) ) ).

tff(addAssignment_38942,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,53)
      <=> v52334(VarCurr,107) )
      & ( v67496(VarCurr,52)
      <=> v52334(VarCurr,106) )
      & ( v67496(VarCurr,51)
      <=> v52334(VarCurr,105) )
      & ( v67496(VarCurr,50)
      <=> v52334(VarCurr,104) )
      & ( v67496(VarCurr,49)
      <=> v52334(VarCurr,103) )
      & ( v67496(VarCurr,48)
      <=> v52334(VarCurr,102) ) ) ).

tff(addAssignment_38941,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,59)
      <=> v52334(VarCurr,119) )
      & ( v67496(VarCurr,58)
      <=> v52334(VarCurr,118) )
      & ( v67496(VarCurr,57)
      <=> v52334(VarCurr,117) )
      & ( v67496(VarCurr,56)
      <=> v52334(VarCurr,116) )
      & ( v67496(VarCurr,55)
      <=> v52334(VarCurr,115) )
      & ( v67496(VarCurr,54)
      <=> v52334(VarCurr,114) ) ) ).

tff(addAssignment_38940,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,65)
      <=> v52334(VarCurr,131) )
      & ( v67496(VarCurr,64)
      <=> v52334(VarCurr,130) )
      & ( v67496(VarCurr,63)
      <=> v52334(VarCurr,129) )
      & ( v67496(VarCurr,62)
      <=> v52334(VarCurr,128) )
      & ( v67496(VarCurr,61)
      <=> v52334(VarCurr,127) )
      & ( v67496(VarCurr,60)
      <=> v52334(VarCurr,126) ) ) ).

tff(addAssignment_38939,axiom,
    ! [VarCurr: state_type] :
      ( ( v67496(VarCurr,71)
      <=> v52334(VarCurr,143) )
      & ( v67496(VarCurr,70)
      <=> v52334(VarCurr,142) )
      & ( v67496(VarCurr,69)
      <=> v52334(VarCurr,141) )
      & ( v67496(VarCurr,68)
      <=> v52334(VarCurr,140) )
      & ( v67496(VarCurr,67)
      <=> v52334(VarCurr,139) )
      & ( v67496(VarCurr,66)
      <=> v52334(VarCurr,138) ) ) ).

tff(addAssignment_38938,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,19)
    <=> v33839(VarCurr,19) ) ).

tff(addAssignment_38937,axiom,
    ! [VarCurr: state_type] :
      ( v67487(VarCurr,7)
    <=> v67489(VarCurr,7) ) ).

tff(addAssignment_38936,axiom,
    ! [VarCurr: state_type] :
      ( v67489(VarCurr,7)
    <=> v6234(VarCurr,7) ) ).

tff(addAssignment_38935,axiom,
    ! [VarCurr: state_type] :
      ( v67483(VarCurr,7)
    <=> v67485(VarCurr,7) ) ).

tff(addAssignment_38934,axiom,
    ! [VarCurr: state_type] :
      ( v67485(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_38933,axiom,
    ! [VarCurr: state_type] :
      ( v67440(VarCurr,0)
    <=> v67476(VarCurr) ) ).

tff(addAssignment_38932,axiom,
    ! [VarCurr: state_type] :
      ( v67440(VarCurr,1)
    <=> v67468(VarCurr) ) ).

tff(addAssignment_38931,axiom,
    ! [VarCurr: state_type] :
      ( v67440(VarCurr,2)
    <=> v67446(VarCurr) ) ).

tff(addAssignment_38930,axiom,
    ! [VarCurr: state_type] :
      ( v67440(VarCurr,3)
    <=> v67442(VarCurr) ) ).

tff(addAssignment_38929,axiom,
    ! [VarCurr: state_type] :
      ( v67476(VarCurr)
    <=> v67478(VarCurr) ) ).

tff(addAssignment_38928,axiom,
    ! [VarCurr: state_type] :
      ( v67478(VarCurr)
    <=> v67480(VarCurr) ) ).

tff(addAssignment_38927,axiom,
    ! [VarCurr: state_type] :
      ( v67480(VarCurr)
    <=> v67452(VarCurr) ) ).

tff(addAssignment_38926,axiom,
    ! [VarCurr: state_type] :
      ( v67468(VarCurr)
    <=> v67470(VarCurr) ) ).

tff(addAssignment_38925,axiom,
    ! [VarCurr: state_type] :
      ( v67470(VarCurr)
    <=> v67472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6205,axiom,
    ! [VarCurr: state_type] :
      ( v67472(VarCurr)
    <=> ( v67474(VarCurr)
        & v67456(VarCurr) ) ) ).

tff(writeUnaryOperator_3266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67474(VarCurr)
    <=> v67452(VarCurr) ) ).

tff(addAssignment_38924,axiom,
    ! [VarCurr: state_type] :
      ( v67446(VarCurr)
    <=> v67448(VarCurr) ) ).

tff(addAssignment_38923,axiom,
    ! [VarCurr: state_type] :
      ( v67448(VarCurr)
    <=> v67450(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6204,axiom,
    ! [VarCurr: state_type] :
      ( v67450(VarCurr)
    <=> ( v67464(VarCurr)
        & v67460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6203,axiom,
    ! [VarCurr: state_type] :
      ( v67464(VarCurr)
    <=> ( v67465(VarCurr)
        & v67466(VarCurr) ) ) ).

tff(writeUnaryOperator_3265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67466(VarCurr)
    <=> v67456(VarCurr) ) ).

tff(writeUnaryOperator_3264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67465(VarCurr)
    <=> v67452(VarCurr) ) ).

tff(addAssignment_38922,axiom,
    ! [VarCurr: state_type] :
      ( v67460(VarCurr)
    <=> v67462(VarCurr) ) ).

tff(addAssignment_38921,axiom,
    ! [VarCurr: state_type] :
      ( v67462(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_38920,axiom,
    ! [VarCurr: state_type] :
      ( v67456(VarCurr)
    <=> v67458(VarCurr) ) ).

tff(addAssignment_38919,axiom,
    ! [VarCurr: state_type] :
      ( v67458(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_38918,axiom,
    ! [VarCurr: state_type] :
      ( v67452(VarCurr)
    <=> v67454(VarCurr) ) ).

tff(addAssignment_38917,axiom,
    ! [VarCurr: state_type] :
      ( v67454(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_38916,axiom,
    ! [VarCurr: state_type] :
      ( v67442(VarCurr)
    <=> v67444(VarCurr) ) ).

tff(addAssignment_38915,axiom,
    ! [VarCurr: state_type] :
      ( v67444(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_38914,axiom,
    ! [VarCurr: state_type] :
      ( v67407(VarCurr,7)
    <=> v67409(VarCurr,7) ) ).

tff(addAssignment_38913,axiom,
    ! [VarCurr: state_type] :
      ( v67409(VarCurr,7)
    <=> v67423(VarCurr,7) ) ).

tff(addAssignment_38912,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,0)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38911,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,1)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38910,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,2)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38909,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,3)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38908,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,4)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38907,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,5)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38906,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,6)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38905,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,7)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38904,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,8)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38903,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,9)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38902,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,10)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38901,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,11)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38900,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,12)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38899,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,13)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38898,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,14)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38897,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,15)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38896,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,16)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38895,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,17)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38894,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,18)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38893,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,19)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38892,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,20)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38891,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,21)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38890,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,22)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38889,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,23)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38888,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,24)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38887,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,25)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38886,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,26)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38885,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,27)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38884,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,28)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38883,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,29)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38882,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,30)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38881,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,31)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38880,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,32)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38879,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,33)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38878,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,34)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38877,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,35)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38876,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,36)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38875,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,37)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38874,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,38)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38873,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,39)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38872,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,40)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38871,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,41)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38870,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,42)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38869,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,43)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38868,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,44)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38867,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,45)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38866,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,46)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38865,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,47)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38864,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,48)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38863,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,49)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38862,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,50)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38861,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,51)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38860,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,52)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38859,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,53)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38858,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,54)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38857,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,55)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38856,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,56)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38855,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,57)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38854,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,58)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38853,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,59)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38852,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,60)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38851,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,61)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38850,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,62)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38849,axiom,
    ! [VarCurr: state_type] :
      ( v67423(VarCurr,63)
    <=> v67424(VarCurr) ) ).

tff(addAssignment_38848,axiom,
    ! [VarCurr: state_type] :
      ( v67424(VarCurr)
    <=> v67411(VarCurr) ) ).

tff(addAssignment_38847,axiom,
    ! [VarCurr: state_type] :
      ( v67411(VarCurr)
    <=> v67413(VarCurr,1) ) ).

tff(addAssignment_38846,axiom,
    ! [VarCurr: state_type] :
      ( v67413(VarCurr,1)
    <=> v67415(VarCurr,1) ) ).

tff(addAssignment_38845,axiom,
    ! [VarCurr: state_type] :
      ( v67415(VarCurr,1)
    <=> v67417(VarCurr,1) ) ).

tff(addAssignment_38844,axiom,
    ! [VarCurr: state_type] :
      ( v67417(VarCurr,1)
    <=> v67419(VarCurr,1) ) ).

tff(addAssignment_38843,axiom,
    ! [VarCurr: state_type] :
      ( v67419(VarCurr,1)
    <=> v67422(VarCurr,1) ) ).

tff(addAssignment_38842,axiom,
    ! [VarCurr: state_type] :
      ( v67422(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_38841,axiom,
    ! [VarCurr: state_type] :
      ( v67422(VarCurr,1)
    <=> v67421(VarCurr) ) ).

tff(addAssignment_38840,axiom,
    ! [VarCurr: state_type] :
      ( v67421(VarCurr)
    <=> v2038(VarCurr) ) ).

tff(addAssignment_38839,axiom,
    ! [VarCurr: state_type] :
      ( v67377(VarCurr)
    <=> v67379(VarCurr) ) ).

tff(addAssignment_38838,axiom,
    ! [VarCurr: state_type] :
      ( v67379(VarCurr)
    <=> v67381(VarCurr) ) ).

tff(addAssignment_38837,axiom,
    ! [VarCurr: state_type] :
      ( v67381(VarCurr)
    <=> v67383(VarCurr) ) ).

tff(addAssignment_38836,axiom,
    ! [VarCurr: state_type] :
      ( v67383(VarCurr)
    <=> v67385(VarCurr) ) ).

tff(addAssignment_38835,axiom,
    ! [VarCurr: state_type] :
      ( v67385(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_38834,axiom,
    ! [VarCurr: state_type] :
      ( v67367(VarCurr)
    <=> v67369(VarCurr) ) ).

tff(addAssignment_38833,axiom,
    ! [VarCurr: state_type] :
      ( v67369(VarCurr)
    <=> v67371(VarCurr) ) ).

tff(addAssignment_38832,axiom,
    ! [VarCurr: state_type] :
      ( v67371(VarCurr)
    <=> v67373(VarCurr) ) ).

tff(addAssignment_38831,axiom,
    ! [VarCurr: state_type] :
      ( v67373(VarCurr)
    <=> v67375(VarCurr) ) ).

tff(addAssignment_38830,axiom,
    ! [VarCurr: state_type] :
      ( v67375(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_38829,axiom,
    ! [VarCurr: state_type] :
      ( v67159(VarCurr)
    <=> v67161(VarCurr) ) ).

tff(addAssignment_38828,axiom,
    ! [VarCurr: state_type] :
      ( v67161(VarCurr)
    <=> v67163(VarCurr) ) ).

tff(addAssignment_38827,axiom,
    ! [VarCurr: state_type] :
      ( v67163(VarCurr)
    <=> v67165(VarCurr) ) ).

tff(addAssignment_38826,axiom,
    ! [VarCurr: state_type] :
      ( v67165(VarCurr)
    <=> v67167(VarCurr) ) ).

tff(addAssignment_38825,axiom,
    ! [VarCurr: state_type] :
      ( v67167(VarCurr)
    <=> v67169(VarCurr) ) ).

tff(addAssignment_38824,axiom,
    ! [VarCurr: state_type] :
      ( v67169(VarCurr)
    <=> v67171(VarCurr) ) ).

tff(addAssignment_38823,axiom,
    ! [VarCurr: state_type] :
      ( v67171(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_38822,axiom,
    ! [VarCurr: state_type] :
      ( v67145(VarCurr)
    <=> v67147(VarCurr) ) ).

tff(addAssignment_38821,axiom,
    ! [VarCurr: state_type] :
      ( v67147(VarCurr)
    <=> v67149(VarCurr) ) ).

tff(addAssignment_38820,axiom,
    ! [VarCurr: state_type] :
      ( v67149(VarCurr)
    <=> v67151(VarCurr) ) ).

tff(addAssignment_38819,axiom,
    ! [VarCurr: state_type] :
      ( v67151(VarCurr)
    <=> v67153(VarCurr) ) ).

tff(addAssignment_38818,axiom,
    ! [VarCurr: state_type] :
      ( v67153(VarCurr)
    <=> v67155(VarCurr) ) ).

tff(addAssignment_38817,axiom,
    ! [VarCurr: state_type] :
      ( v67155(VarCurr)
    <=> v67157(VarCurr) ) ).

tff(addAssignment_38816,axiom,
    ! [VarCurr: state_type] :
      ( v67157(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_38815,axiom,
    ! [VarCurr: state_type] :
      ( v5807(VarCurr)
    <=> v5809(VarCurr,0) ) ).

tff(addAssignment_38814,axiom,
    ! [VarCurr: state_type] :
      ( v5809(VarCurr,0)
    <=> v5811(VarCurr,0) ) ).

tff(addAssignment_38813,axiom,
    ! [VarNext: state_type] :
      ( v5811(VarNext,0)
    <=> v67121(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67122(VarNext)
       => ! [B: $int] :
            ( ( $less(B,65)
              & ~ $less(B,0) )
           => ( v67121(VarNext,B)
            <=> v5811(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_764,axiom,
    ! [VarNext: state_type] :
      ( v67122(VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v67121(VarNext,B)
          <=> v67132(VarNext,B) ) ) ) ).

tff(addAssignment_38812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v67132(VarNext,B)
          <=> v67130(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67133(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v67130(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_400,axiom,
    ! [VarCurr: state_type] :
      ( v67133(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,65)
            & ~ $less(B,0) )
         => ( v67130(VarCurr,B)
          <=> v5841(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6202,axiom,
    ! [VarCurr: state_type] :
      ( v67133(VarCurr)
    <=> ( v67134(VarCurr)
        & v67135(VarCurr) ) ) ).

tff(writeUnaryOperator_3263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67135(VarCurr)
    <=> v5827(VarCurr) ) ).

tff(writeUnaryOperator_3262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67134(VarCurr)
    <=> v5813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67122(VarNext)
      <=> v67123(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67123(VarNext)
      <=> ( v67124(VarNext)
          & v67061(VarNext) ) ) ) ).

tff(writeUnaryOperator_3261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67124(VarNext)
      <=> v67126(VarNext) ) ) ).

tff(addAssignment_38811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67126(VarNext)
      <=> v67061(VarCurr) ) ) ).

tff(addAssignment_38810,axiom,
    ! [VarCurr: state_type] :
      ( v67061(VarCurr)
    <=> v67063(VarCurr) ) ).

tff(addAssignment_38809,axiom,
    ! [VarCurr: state_type] :
      ( v67063(VarCurr)
    <=> v67065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6199,axiom,
    ! [VarCurr: state_type] :
      ( v67065(VarCurr)
    <=> ( v67119(VarCurr)
        | v67115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6198,axiom,
    ! [VarCurr: state_type] :
      ( v67119(VarCurr)
    <=> ( v67067(VarCurr)
        & v67071(VarCurr) ) ) ).

tff(addAssignment_38808,axiom,
    ! [VarCurr: state_type] :
      ( v67115(VarCurr)
    <=> v67117(VarCurr) ) ).

tff(addAssignment_38807,axiom,
    ! [VarCurr: state_type] :
      ( v67117(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v67099(VarNext)
       => ( v67071(VarNext)
        <=> v67071(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_763,axiom,
    ! [VarNext: state_type] :
      ( v67099(VarNext)
     => ( v67071(VarNext)
      <=> v67109(VarNext) ) ) ).

tff(addAssignment_38806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67109(VarNext)
      <=> v67107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6197,axiom,
    ! [VarCurr: state_type] :
      ( v67107(VarCurr)
    <=> ( v67110(VarCurr)
        & v67111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6196,axiom,
    ! [VarCurr: state_type] :
      ( v67111(VarCurr)
    <=> ( v67077(VarCurr)
        | v67090(VarCurr) ) ) ).

tff(writeUnaryOperator_3260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67110(VarCurr)
    <=> v67073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67099(VarNext)
      <=> v67100(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67100(VarNext)
      <=> ( v67102(VarNext)
          & v67104(VarNext) ) ) ) ).

tff(writeUnaryOperator_3259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67104(VarCurr)
    <=> v67067(VarCurr) ) ).

tff(addAssignment_38805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v67102(VarNext)
      <=> v67067(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_233,axiom,
    ( v67071(constB0)
  <=> $true ) ).

tff(addAssignment_38804,axiom,
    ! [VarCurr: state_type] :
      ( v67090(VarCurr)
    <=> v67092(VarCurr) ) ).

tff(addAssignment_38803,axiom,
    ! [VarCurr: state_type] :
      ( v67092(VarCurr)
    <=> v67094(VarCurr) ) ).

tff(addAssignment_38802,axiom,
    ! [VarCurr: state_type] :
      ( v67094(VarCurr)
    <=> v67096(VarCurr) ) ).

tff(addAssignment_38801,axiom,
    ! [VarCurr: state_type] :
      ( v67096(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_38800,axiom,
    ! [VarCurr: state_type] :
      ( v67077(VarCurr)
    <=> v67079(VarCurr) ) ).

tff(addAssignment_38799,axiom,
    ! [VarCurr: state_type] :
      ( v67079(VarCurr)
    <=> v67081(VarCurr,1) ) ).

tff(addAssignment_38798,axiom,
    ! [VarCurr: state_type] :
      ( v67081(VarCurr,1)
    <=> v67088(VarCurr,1) ) ).

tff(addAssignment_38797,axiom,
    ! [VarCurr: state_type] :
      ( v67088(VarCurr,0)
    <=> v67083(VarCurr,0) ) ).

tff(addAssignment_38796,axiom,
    ! [VarCurr: state_type] :
      ( v67088(VarCurr,1)
    <=> v67083(VarCurr,2) ) ).

tff(addAssignment_38795,axiom,
    ! [VarCurr: state_type] :
      ( v67083(VarCurr,2)
    <=> v67085(VarCurr,2) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_4,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1047(VarCurr)
     => ( v67085(VarCurr,2)
      <=> $true ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_6,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
     => ( v67085(VarCurr,2)
      <=> v67087(VarCurr) ) ) ).

tff(writeUnaryOperator_3258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67087(VarCurr)
    <=> v59955(VarCurr,0) ) ).

tff(addAssignment_38794,axiom,
    ! [VarCurr: state_type] :
      ( v67073(VarCurr)
    <=> v67075(VarCurr) ) ).

tff(addAssignment_38793,axiom,
    ! [VarCurr: state_type] :
      ( v67075(VarCurr)
    <=> $false ) ).

tff(addAssignment_38792,axiom,
    ! [VarCurr: state_type] :
      ( v67067(VarCurr)
    <=> v67069(VarCurr) ) ).

tff(addAssignment_38791,axiom,
    ! [VarCurr: state_type] :
      ( v67069(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_38790,axiom,
    ! [VarCurr: state_type] :
      ( v5841(VarCurr,0)
    <=> v5843(VarCurr,0) ) ).

tff(addAssignment_38789,axiom,
    ! [VarCurr: state_type] :
      ( v5843(VarCurr,0)
    <=> v67057(VarCurr,0) ) ).

tff(addAssignment_38788,axiom,
    ! [VarCurr: state_type] :
      ( v67057(VarCurr,0)
    <=> v5845(VarCurr) ) ).

tff(addAssignment_38787,axiom,
    ! [VarCurr: state_type] :
      ( ( v67057(VarCurr,64)
      <=> v67058(VarCurr,63) )
      & ( v67057(VarCurr,63)
      <=> v67058(VarCurr,62) )
      & ( v67057(VarCurr,62)
      <=> v67058(VarCurr,61) )
      & ( v67057(VarCurr,61)
      <=> v67058(VarCurr,60) )
      & ( v67057(VarCurr,60)
      <=> v67058(VarCurr,59) )
      & ( v67057(VarCurr,59)
      <=> v67058(VarCurr,58) )
      & ( v67057(VarCurr,58)
      <=> v67058(VarCurr,57) )
      & ( v67057(VarCurr,57)
      <=> v67058(VarCurr,56) )
      & ( v67057(VarCurr,56)
      <=> v67058(VarCurr,55) )
      & ( v67057(VarCurr,55)
      <=> v67058(VarCurr,54) )
      & ( v67057(VarCurr,54)
      <=> v67058(VarCurr,53) )
      & ( v67057(VarCurr,53)
      <=> v67058(VarCurr,52) )
      & ( v67057(VarCurr,52)
      <=> v67058(VarCurr,51) )
      & ( v67057(VarCurr,51)
      <=> v67058(VarCurr,50) )
      & ( v67057(VarCurr,50)
      <=> v67058(VarCurr,49) )
      & ( v67057(VarCurr,49)
      <=> v67058(VarCurr,48) )
      & ( v67057(VarCurr,48)
      <=> v67058(VarCurr,47) )
      & ( v67057(VarCurr,47)
      <=> v67058(VarCurr,46) )
      & ( v67057(VarCurr,46)
      <=> v67058(VarCurr,45) )
      & ( v67057(VarCurr,45)
      <=> v67058(VarCurr,44) )
      & ( v67057(VarCurr,44)
      <=> v67058(VarCurr,43) )
      & ( v67057(VarCurr,43)
      <=> v67058(VarCurr,42) )
      & ( v67057(VarCurr,42)
      <=> v67058(VarCurr,41) )
      & ( v67057(VarCurr,41)
      <=> v67058(VarCurr,40) )
      & ( v67057(VarCurr,40)
      <=> v67058(VarCurr,39) )
      & ( v67057(VarCurr,39)
      <=> v67058(VarCurr,38) )
      & ( v67057(VarCurr,38)
      <=> v67058(VarCurr,37) )
      & ( v67057(VarCurr,37)
      <=> v67058(VarCurr,36) )
      & ( v67057(VarCurr,36)
      <=> v67058(VarCurr,35) )
      & ( v67057(VarCurr,35)
      <=> v67058(VarCurr,34) )
      & ( v67057(VarCurr,34)
      <=> v67058(VarCurr,33) )
      & ( v67057(VarCurr,33)
      <=> v67058(VarCurr,32) )
      & ( v67057(VarCurr,32)
      <=> v67058(VarCurr,31) )
      & ( v67057(VarCurr,31)
      <=> v67058(VarCurr,30) )
      & ( v67057(VarCurr,30)
      <=> v67058(VarCurr,29) )
      & ( v67057(VarCurr,29)
      <=> v67058(VarCurr,28) )
      & ( v67057(VarCurr,28)
      <=> v67058(VarCurr,27) )
      & ( v67057(VarCurr,27)
      <=> v67058(VarCurr,26) )
      & ( v67057(VarCurr,26)
      <=> v67058(VarCurr,25) )
      & ( v67057(VarCurr,25)
      <=> v67058(VarCurr,24) )
      & ( v67057(VarCurr,24)
      <=> v67058(VarCurr,23) )
      & ( v67057(VarCurr,23)
      <=> v67058(VarCurr,22) )
      & ( v67057(VarCurr,22)
      <=> v67058(VarCurr,21) )
      & ( v67057(VarCurr,21)
      <=> v67058(VarCurr,20) )
      & ( v67057(VarCurr,20)
      <=> v67058(VarCurr,19) )
      & ( v67057(VarCurr,19)
      <=> v67058(VarCurr,18) )
      & ( v67057(VarCurr,18)
      <=> v67058(VarCurr,17) )
      & ( v67057(VarCurr,17)
      <=> v67058(VarCurr,16) )
      & ( v67057(VarCurr,16)
      <=> v67058(VarCurr,15) )
      & ( v67057(VarCurr,15)
      <=> v67058(VarCurr,14) )
      & ( v67057(VarCurr,14)
      <=> v67058(VarCurr,13) )
      & ( v67057(VarCurr,13)
      <=> v67058(VarCurr,12) )
      & ( v67057(VarCurr,12)
      <=> v67058(VarCurr,11) )
      & ( v67057(VarCurr,11)
      <=> v67058(VarCurr,10) )
      & ( v67057(VarCurr,10)
      <=> v67058(VarCurr,9) )
      & ( v67057(VarCurr,9)
      <=> v67058(VarCurr,8) )
      & ( v67057(VarCurr,8)
      <=> v67058(VarCurr,7) )
      & ( v67057(VarCurr,7)
      <=> v67058(VarCurr,6) )
      & ( v67057(VarCurr,6)
      <=> v67058(VarCurr,5) )
      & ( v67057(VarCurr,5)
      <=> v67058(VarCurr,4) )
      & ( v67057(VarCurr,4)
      <=> v67058(VarCurr,3) )
      & ( v67057(VarCurr,3)
      <=> v67058(VarCurr,2) )
      & ( v67057(VarCurr,2)
      <=> v67058(VarCurr,1) )
      & ( v67057(VarCurr,1)
      <=> v67058(VarCurr,0) ) ) ).

tff(addAssignment_38786,axiom,
    ! [VarCurr: state_type] :
      ( v5845(VarCurr)
    <=> v5847(VarCurr) ) ).

tff(addAssignment_38785,axiom,
    ! [VarCurr: state_type] :
      ( v5847(VarCurr)
    <=> v5849(VarCurr) ) ).

tff(writeUnaryOperator_3257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5849(VarCurr)
    <=> v67054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6193,axiom,
    ! [VarCurr: state_type] :
      ( v67054(VarCurr)
    <=> ( v67055(VarCurr)
        & v66850(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6192,axiom,
    ! [VarCurr: state_type] :
      ( v67055(VarCurr)
    <=> ( v67056(VarCurr)
        & v62681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6191,axiom,
    ! [VarCurr: state_type] :
      ( v67056(VarCurr)
    <=> ( v5851(VarCurr)
        & v62542(VarCurr) ) ) ).

tff(addAssignment_38784,axiom,
    ! [VarCurr: state_type] :
      ( v66850(VarCurr)
    <=> v66852(VarCurr) ) ).

tff(addAssignment_38783,axiom,
    ! [VarCurr: state_type] :
      ( v66852(VarCurr)
    <=> v66854(VarCurr) ) ).

tff(addAssignment_38782,axiom,
    ! [VarCurr: state_type] :
      ( v66854(VarCurr)
    <=> v66856(VarCurr) ) ).

tff(addAssignment_38781,axiom,
    ! [VarCurr: state_type] :
      ( v66856(VarCurr)
    <=> v66858(VarCurr) ) ).

tff(writeUnaryOperator_3256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66858(VarCurr)
    <=> v67052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6190,axiom,
    ! [VarCurr: state_type] :
      ( v67052(VarCurr)
    <=> ( v66860(VarCurr)
        | v66969(VarCurr) ) ) ).

tff(addAssignment_38780,axiom,
    ! [VarCurr: state_type] :
      ( v66969(VarCurr)
    <=> v66971(VarCurr) ) ).

tff(addAssignment_38779,axiom,
    ! [VarCurr: state_type] :
      ( v66971(VarCurr)
    <=> v66973(VarCurr) ) ).

tff(addAssignment_38778,axiom,
    ! [VarCurr: state_type] :
      ( v66973(VarCurr)
    <=> v66975(VarCurr) ) ).

tff(addAssignment_38777,axiom,
    ! [VarCurr: state_type] :
      ( v66975(VarCurr)
    <=> v66977(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6189,axiom,
    ! [VarCurr: state_type] :
      ( v66977(VarCurr)
    <=> ( v66979(VarCurr)
        & v67021(VarCurr) ) ) ).

tff(addAssignment_38776,axiom,
    ! [VarCurr: state_type] :
      ( v67021(VarCurr)
    <=> v67023(VarCurr) ) ).

tff(addAssignment_38775,axiom,
    ! [VarCurr: state_type] :
      ( v67023(VarCurr)
    <=> v67025(VarCurr) ) ).

tff(addAssignment_38774,axiom,
    ! [VarCurr: state_type] :
      ( v67025(VarCurr)
    <=> v67027(VarCurr) ) ).

tff(addAssignment_38773,axiom,
    ! [VarCurr: state_type] :
      ( v67027(VarCurr)
    <=> v67029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6188,axiom,
    ! [VarCurr: state_type] :
      ( v67029(VarCurr)
    <=> ( v67031(VarCurr)
        | v67035(VarCurr) ) ) ).

tff(addAssignment_38772,axiom,
    ! [VarCurr: state_type] :
      ( v67035(VarCurr)
    <=> v67037(VarCurr) ) ).

tff(addAssignment_38771,axiom,
    ! [VarCurr: state_type] :
      ( v67037(VarCurr)
    <=> v67039(VarCurr) ) ).

tff(addAssignment_38770,axiom,
    ! [VarCurr: state_type] :
      ( v67039(VarCurr)
    <=> v67041(VarCurr) ) ).

tff(addAssignment_38769,axiom,
    ! [VarCurr: state_type] :
      ( v67041(VarCurr)
    <=> v67043(VarCurr) ) ).

tff(writeUnaryOperator_3255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v67043(VarCurr)
    <=> v67045(VarCurr) ) ).

tff(addAssignment_38768,axiom,
    ! [VarCurr: state_type] :
      ( v67045(VarCurr)
    <=> v67047(VarCurr) ) ).

tff(addAssignment_38767,axiom,
    ! [VarCurr: state_type] :
      ( v67047(VarCurr)
    <=> v66826(VarCurr) ) ).

tff(addAssignment_38766,axiom,
    ! [VarCurr: state_type] :
      ( v67031(VarCurr)
    <=> v67033(VarCurr) ) ).

tff(addAssignment_38765,axiom,
    ! [VarCurr: state_type] :
      ( v67033(VarCurr)
    <=> v66941(VarCurr) ) ).

tff(addAssignment_38764,axiom,
    ! [VarCurr: state_type] :
      ( v66979(VarCurr)
    <=> v66981(VarCurr) ) ).

tff(addAssignment_38763,axiom,
    ! [VarCurr: state_type] :
      ( v66981(VarCurr)
    <=> v5865(VarCurr,0) ) ).

tff(addAssignment_38762,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,0)
    <=> v66983(VarCurr) ) ).

tff(addAssignment_38761,axiom,
    ! [VarCurr: state_type] :
      ( v66983(VarCurr)
    <=> v66985(VarCurr) ) ).

tff(writeUnaryOperator_3254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66985(VarCurr)
    <=> v67019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6187,axiom,
    ! [VarCurr: state_type] :
      ( v67019(VarCurr)
    <=> ( v66987(VarCurr)
        | v67015(VarCurr) ) ) ).

tff(addAssignment_38760,axiom,
    ! [VarCurr: state_type] :
      ( v67015(VarCurr)
    <=> v67017(VarCurr) ) ).

tff(addAssignment_38759,axiom,
    ! [VarCurr: state_type] :
      ( v67017(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_38758,axiom,
    ! [VarCurr: state_type] :
      ( v66987(VarCurr)
    <=> v66989(VarCurr) ) ).

tff(addAssignment_38757,axiom,
    ! [VarCurr: state_type] :
      ( v66989(VarCurr)
    <=> v5875(VarCurr,0) ) ).

tff(addAssignment_38756,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,0)
    <=> v66991(VarCurr) ) ).

tff(addAssignment_38755,axiom,
    ! [VarCurr: state_type] :
      ( v66991(VarCurr)
    <=> v66993(VarCurr) ) ).

tff(writeUnaryOperator_3253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66993(VarCurr)
    <=> v67011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6186,axiom,
    ! [VarCurr: state_type] :
      ( v67011(VarCurr)
    <=> ( v67012(VarCurr)
        & v67007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6185,axiom,
    ! [VarCurr: state_type] :
      ( v67012(VarCurr)
    <=> ( v67013(VarCurr)
        & v67003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6184,axiom,
    ! [VarCurr: state_type] :
      ( v67013(VarCurr)
    <=> ( v66995(VarCurr)
        & v66999(VarCurr) ) ) ).

tff(addAssignment_38754,axiom,
    ! [VarCurr: state_type] :
      ( v67007(VarCurr)
    <=> v67009(VarCurr) ) ).

tff(addAssignment_38753,axiom,
    ! [VarCurr: state_type] :
      ( v67009(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_38752,axiom,
    ! [VarCurr: state_type] :
      ( v67003(VarCurr)
    <=> v67005(VarCurr) ) ).

tff(addAssignment_38751,axiom,
    ! [VarCurr: state_type] :
      ( v67005(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_38750,axiom,
    ! [VarCurr: state_type] :
      ( v66999(VarCurr)
    <=> v67001(VarCurr) ) ).

tff(addAssignment_38749,axiom,
    ! [VarCurr: state_type] :
      ( v67001(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_38748,axiom,
    ! [VarCurr: state_type] :
      ( v66995(VarCurr)
    <=> v66997(VarCurr) ) ).

tff(addAssignment_38747,axiom,
    ! [VarCurr: state_type] :
      ( v66997(VarCurr)
    <=> v5885(VarCurr) ) ).

tff(addAssignment_38746,axiom,
    ! [VarCurr: state_type] :
      ( v66860(VarCurr)
    <=> v66862(VarCurr) ) ).

tff(addAssignment_38745,axiom,
    ! [VarCurr: state_type] :
      ( v66862(VarCurr)
    <=> v66864(VarCurr) ) ).

tff(addAssignment_38744,axiom,
    ! [VarCurr: state_type] :
      ( v66864(VarCurr)
    <=> v66866(VarCurr) ) ).

tff(addAssignment_38743,axiom,
    ! [VarCurr: state_type] :
      ( v66866(VarCurr)
    <=> v66868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6183,axiom,
    ! [VarCurr: state_type] :
      ( v66868(VarCurr)
    <=> ( v66870(VarCurr)
        & v66912(VarCurr) ) ) ).

tff(addAssignment_38742,axiom,
    ! [VarCurr: state_type] :
      ( v66912(VarCurr)
    <=> v66914(VarCurr) ) ).

tff(addAssignment_38741,axiom,
    ! [VarCurr: state_type] :
      ( v66914(VarCurr)
    <=> v66916(VarCurr) ) ).

tff(addAssignment_38740,axiom,
    ! [VarCurr: state_type] :
      ( v66916(VarCurr)
    <=> v66918(VarCurr) ) ).

tff(addAssignment_38739,axiom,
    ! [VarCurr: state_type] :
      ( v66918(VarCurr)
    <=> v66920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6182,axiom,
    ! [VarCurr: state_type] :
      ( v66920(VarCurr)
    <=> ( v66922(VarCurr)
        | v66937(VarCurr) ) ) ).

tff(addAssignment_38738,axiom,
    ! [VarCurr: state_type] :
      ( v66937(VarCurr)
    <=> v66939(VarCurr) ) ).

tff(addAssignment_38737,axiom,
    ! [VarCurr: state_type] :
      ( v66939(VarCurr)
    <=> v66941(VarCurr) ) ).

tff(addAssignment_38736,axiom,
    ! [VarCurr: state_type] :
      ( v66941(VarCurr)
    <=> v66943(VarCurr) ) ).

tff(addAssignment_38735,axiom,
    ! [VarCurr: state_type] :
      ( v66943(VarCurr)
    <=> v66945(VarCurr) ) ).

tff(writeUnaryOperator_3252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66945(VarCurr)
    <=> v66947(VarCurr) ) ).

tff(addAssignment_38734,axiom,
    ! [VarCurr: state_type] :
      ( v66947(VarCurr)
    <=> v66949(VarCurr) ) ).

tff(addAssignment_38733,axiom,
    ! [VarCurr: state_type] :
      ( v66949(VarCurr)
    <=> v66951(VarCurr) ) ).

tff(addAssignment_38732,axiom,
    ! [VarCurr: state_type] :
      ( v66951(VarCurr)
    <=> v66953(VarCurr) ) ).

tff(addAssignment_38731,axiom,
    ! [VarCurr: state_type] :
      ( v66953(VarCurr)
    <=> v66955(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_282,axiom,
    ! [VarCurr: state_type] :
      ( v66955(VarCurr)
    <=> ( ( v66957(VarCurr,3)
        <=> v66961(VarCurr,3) )
        & ( v66957(VarCurr,2)
        <=> v66961(VarCurr,2) )
        & ( v66957(VarCurr,1)
        <=> v66961(VarCurr,1) )
        & ( v66957(VarCurr,0)
        <=> v66961(VarCurr,0) ) ) ) ).

tff(addAssignment_38730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66961(VarCurr,B)
      <=> v66963(VarCurr,B) ) ) ).

tff(addAssignment_38729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66963(VarCurr,B)
      <=> v62257(VarCurr,B) ) ) ).

tff(addAssignment_38728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66957(VarCurr,B)
      <=> v66959(VarCurr,B) ) ) ).

tff(addAssignment_38727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66959(VarCurr,B)
      <=> v62097(VarCurr,B) ) ) ).

tff(addAssignment_38726,axiom,
    ! [VarCurr: state_type] :
      ( v66922(VarCurr)
    <=> v66924(VarCurr) ) ).

tff(addAssignment_38725,axiom,
    ! [VarCurr: state_type] :
      ( v66924(VarCurr)
    <=> v66926(VarCurr) ) ).

tff(addAssignment_38724,axiom,
    ! [VarCurr: state_type] :
      ( v66926(VarCurr)
    <=> v66928(VarCurr) ) ).

tff(addAssignment_38723,axiom,
    ! [VarCurr: state_type] :
      ( v66928(VarCurr)
    <=> v66930(VarCurr) ) ).

tff(writeUnaryOperator_3251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66930(VarCurr)
    <=> v66932(VarCurr) ) ).

tff(addAssignment_38722,axiom,
    ! [VarCurr: state_type] :
      ( v66932(VarCurr)
    <=> v66934(VarCurr) ) ).

tff(addAssignment_38721,axiom,
    ! [VarCurr: state_type] :
      ( v66934(VarCurr)
    <=> v64445(VarCurr) ) ).

tff(addAssignment_38720,axiom,
    ! [VarCurr: state_type] :
      ( v66870(VarCurr)
    <=> v66872(VarCurr) ) ).

tff(addAssignment_38719,axiom,
    ! [VarCurr: state_type] :
      ( v66872(VarCurr)
    <=> v5865(VarCurr,1) ) ).

tff(addAssignment_38718,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,1)
    <=> v66874(VarCurr) ) ).

tff(addAssignment_38717,axiom,
    ! [VarCurr: state_type] :
      ( v66874(VarCurr)
    <=> v66876(VarCurr) ) ).

tff(writeUnaryOperator_3250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66876(VarCurr)
    <=> v66910(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6181,axiom,
    ! [VarCurr: state_type] :
      ( v66910(VarCurr)
    <=> ( v66878(VarCurr)
        | v66906(VarCurr) ) ) ).

tff(addAssignment_38716,axiom,
    ! [VarCurr: state_type] :
      ( v66906(VarCurr)
    <=> v66908(VarCurr) ) ).

tff(addAssignment_38715,axiom,
    ! [VarCurr: state_type] :
      ( v66908(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_38714,axiom,
    ! [VarCurr: state_type] :
      ( v66878(VarCurr)
    <=> v66880(VarCurr) ) ).

tff(addAssignment_38713,axiom,
    ! [VarCurr: state_type] :
      ( v66880(VarCurr)
    <=> v5875(VarCurr,1) ) ).

tff(addAssignment_38712,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,1)
    <=> v66882(VarCurr) ) ).

tff(addAssignment_38711,axiom,
    ! [VarCurr: state_type] :
      ( v66882(VarCurr)
    <=> v66884(VarCurr) ) ).

tff(writeUnaryOperator_3249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66884(VarCurr)
    <=> v66902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6180,axiom,
    ! [VarCurr: state_type] :
      ( v66902(VarCurr)
    <=> ( v66903(VarCurr)
        & v66898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6179,axiom,
    ! [VarCurr: state_type] :
      ( v66903(VarCurr)
    <=> ( v66904(VarCurr)
        & v66894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6178,axiom,
    ! [VarCurr: state_type] :
      ( v66904(VarCurr)
    <=> ( v66886(VarCurr)
        & v66890(VarCurr) ) ) ).

tff(addAssignment_38710,axiom,
    ! [VarCurr: state_type] :
      ( v66898(VarCurr)
    <=> v66900(VarCurr) ) ).

tff(addAssignment_38709,axiom,
    ! [VarCurr: state_type] :
      ( v66900(VarCurr)
    <=> v62476(VarCurr) ) ).

tff(addAssignment_38708,axiom,
    ! [VarCurr: state_type] :
      ( v66894(VarCurr)
    <=> v66896(VarCurr) ) ).

tff(addAssignment_38707,axiom,
    ! [VarCurr: state_type] :
      ( v66896(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_38706,axiom,
    ! [VarCurr: state_type] :
      ( v66890(VarCurr)
    <=> v66892(VarCurr) ) ).

tff(addAssignment_38705,axiom,
    ! [VarCurr: state_type] :
      ( v66892(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_38704,axiom,
    ! [VarCurr: state_type] :
      ( v66886(VarCurr)
    <=> v66888(VarCurr) ) ).

tff(addAssignment_38703,axiom,
    ! [VarCurr: state_type] :
      ( v66888(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_38702,axiom,
    ! [VarCurr: state_type] :
      ( v62681(VarCurr)
    <=> v62683(VarCurr) ) ).

tff(addAssignment_38701,axiom,
    ! [VarCurr: state_type] :
      ( v62683(VarCurr)
    <=> v62685(VarCurr) ) ).

tff(addAssignment_38700,axiom,
    ! [VarCurr: state_type] :
      ( v62685(VarCurr)
    <=> v62687(VarCurr) ) ).

tff(addAssignment_38699,axiom,
    ! [VarCurr: state_type] :
      ( v62687(VarCurr)
    <=> v62689(VarCurr) ) ).

tff(writeUnaryOperator_3248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62689(VarCurr)
    <=> v66847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6177,axiom,
    ! [VarCurr: state_type] :
      ( v66847(VarCurr)
    <=> ( v66848(VarCurr)
        | v64957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6176,axiom,
    ! [VarCurr: state_type] :
      ( v66848(VarCurr)
    <=> ( v62691(VarCurr)
        | v62733(VarCurr) ) ) ).

tff(addAssignment_38698,axiom,
    ! [VarCurr: state_type] :
      ( v64957(VarCurr)
    <=> v64959(VarCurr) ) ).

tff(addAssignment_38697,axiom,
    ! [VarCurr: state_type] :
      ( v64959(VarCurr)
    <=> v64961(VarCurr) ) ).

tff(addAssignment_38696,axiom,
    ! [VarCurr: state_type] :
      ( v64961(VarCurr)
    <=> v64963(VarCurr) ) ).

tff(addAssignment_38695,axiom,
    ! [VarCurr: state_type] :
      ( v64963(VarCurr)
    <=> v64965(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6175,axiom,
    ! [VarCurr: state_type] :
      ( v64965(VarCurr)
    <=> ( v64967(VarCurr)
        & v65009(VarCurr) ) ) ).

tff(addAssignment_38694,axiom,
    ! [VarCurr: state_type] :
      ( v65009(VarCurr)
    <=> v65011(VarCurr) ) ).

tff(addAssignment_38693,axiom,
    ! [VarCurr: state_type] :
      ( v65011(VarCurr)
    <=> v65013(VarCurr) ) ).

tff(addAssignment_38692,axiom,
    ! [VarCurr: state_type] :
      ( v65013(VarCurr)
    <=> v65015(VarCurr) ) ).

tff(addAssignment_38691,axiom,
    ! [VarCurr: state_type] :
      ( v65015(VarCurr)
    <=> v65017(VarCurr) ) ).

tff(writeUnaryOperator_3247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65017(VarCurr)
    <=> v65019(VarCurr) ) ).

tff(addAssignment_38690,axiom,
    ! [VarCurr: state_type] :
      ( v65019(VarCurr)
    <=> v65021(VarCurr) ) ).

tff(addAssignment_38689,axiom,
    ! [VarCurr: state_type] :
      ( v65021(VarCurr)
    <=> v65023(VarCurr) ) ).

tff(addAssignment_38688,axiom,
    ! [VarCurr: state_type] :
      ( v65023(VarCurr)
    <=> v65025(VarCurr) ) ).

tff(addAssignment_38687,axiom,
    ! [VarCurr: state_type] :
      ( v65025(VarCurr)
    <=> v65027(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_281,axiom,
    ! [VarCurr: state_type] :
      ( v65027(VarCurr)
    <=> ( ( v65029(VarCurr,15)
        <=> v66581(VarCurr,15) )
        & ( v65029(VarCurr,14)
        <=> v66581(VarCurr,14) )
        & ( v65029(VarCurr,13)
        <=> v66581(VarCurr,13) )
        & ( v65029(VarCurr,12)
        <=> v66581(VarCurr,12) )
        & ( v65029(VarCurr,11)
        <=> v66581(VarCurr,11) )
        & ( v65029(VarCurr,10)
        <=> v66581(VarCurr,10) )
        & ( v65029(VarCurr,9)
        <=> v66581(VarCurr,9) )
        & ( v65029(VarCurr,8)
        <=> v66581(VarCurr,8) )
        & ( v65029(VarCurr,7)
        <=> v66581(VarCurr,7) )
        & ( v65029(VarCurr,6)
        <=> v66581(VarCurr,6) )
        & ( v65029(VarCurr,5)
        <=> v66581(VarCurr,5) )
        & ( v65029(VarCurr,4)
        <=> v66581(VarCurr,4) )
        & ( v65029(VarCurr,3)
        <=> v66581(VarCurr,3) )
        & ( v65029(VarCurr,2)
        <=> v66581(VarCurr,2) )
        & ( v65029(VarCurr,1)
        <=> v66581(VarCurr,1) )
        & ( v65029(VarCurr,0)
        <=> v66581(VarCurr,0) ) ) ) ).

tff(addAssignment_38686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v66581(VarCurr,B)
      <=> v66583(VarCurr,B) ) ) ).

tff(addAssignment_38685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v66583(VarCurr,B)
      <=> v66585(VarCurr,B) ) ) ).

tff(addAssignment_38684,axiom,
    ! [VarCurr: state_type] :
      ( v66583(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_38683,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,0)
    <=> v66812(VarCurr) ) ).

tff(addAssignment_38682,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,1)
    <=> v66797(VarCurr) ) ).

tff(addAssignment_38681,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,2)
    <=> v66782(VarCurr) ) ).

tff(addAssignment_38680,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,3)
    <=> v66767(VarCurr) ) ).

tff(addAssignment_38679,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,4)
    <=> v66752(VarCurr) ) ).

tff(addAssignment_38678,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,5)
    <=> v66737(VarCurr) ) ).

tff(addAssignment_38677,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,6)
    <=> v66722(VarCurr) ) ).

tff(addAssignment_38676,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,7)
    <=> v66707(VarCurr) ) ).

tff(addAssignment_38675,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,8)
    <=> v66692(VarCurr) ) ).

tff(addAssignment_38674,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,9)
    <=> v66677(VarCurr) ) ).

tff(addAssignment_38673,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,10)
    <=> v66662(VarCurr) ) ).

tff(addAssignment_38672,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,11)
    <=> v66647(VarCurr) ) ).

tff(addAssignment_38671,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,12)
    <=> v66632(VarCurr) ) ).

tff(addAssignment_38670,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,13)
    <=> v66617(VarCurr) ) ).

tff(addAssignment_38669,axiom,
    ! [VarCurr: state_type] :
      ( v66585(VarCurr,14)
    <=> v66587(VarCurr) ) ).

tff(addAssignment_38668,axiom,
    ! [VarCurr: state_type] :
      ( v66812(VarCurr)
    <=> v66814(VarCurr) ) ).

tff(addAssignment_38667,axiom,
    ! [VarCurr: state_type] :
      ( v66814(VarCurr)
    <=> v66816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6174,axiom,
    ! [VarCurr: state_type] :
      ( v66816(VarCurr)
    <=> ( v66818(VarCurr)
        & v66822(VarCurr) ) ) ).

tff(addAssignment_38666,axiom,
    ! [VarCurr: state_type] :
      ( v66822(VarCurr)
    <=> v66824(VarCurr) ) ).

tff(addAssignment_38665,axiom,
    ! [VarCurr: state_type] :
      ( v66824(VarCurr)
    <=> v66826(VarCurr) ) ).

tff(addAssignment_38664,axiom,
    ! [VarCurr: state_type] :
      ( v66826(VarCurr)
    <=> v66828(VarCurr) ) ).

tff(addAssignment_38663,axiom,
    ! [VarCurr: state_type] :
      ( v66828(VarCurr)
    <=> v66830(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_280,axiom,
    ! [VarCurr: state_type] :
      ( v66830(VarCurr)
    <=> ( ( v66832(VarCurr,3)
        <=> v66836(VarCurr,3) )
        & ( v66832(VarCurr,2)
        <=> v66836(VarCurr,2) )
        & ( v66832(VarCurr,1)
        <=> v66836(VarCurr,1) )
        & ( v66832(VarCurr,0)
        <=> v66836(VarCurr,0) ) ) ) ).

tff(addAssignment_38662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66836(VarCurr,B)
      <=> v66838(VarCurr,B) ) ) ).

tff(addAssignment_38661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66838(VarCurr,B)
      <=> v62257(VarCurr,B) ) ) ).

tff(addAssignment_38660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66832(VarCurr,B)
      <=> v66834(VarCurr,B) ) ) ).

tff(addAssignment_38659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66834(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_38658,axiom,
    ! [VarCurr: state_type] :
      ( v66818(VarCurr)
    <=> v66820(VarCurr) ) ).

tff(addAssignment_38657,axiom,
    ! [VarCurr: state_type] :
      ( v66820(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38656,axiom,
    ! [VarCurr: state_type] :
      ( v66797(VarCurr)
    <=> v66799(VarCurr) ) ).

tff(addAssignment_38655,axiom,
    ! [VarCurr: state_type] :
      ( v66799(VarCurr)
    <=> v66801(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6173,axiom,
    ! [VarCurr: state_type] :
      ( v66801(VarCurr)
    <=> ( v66803(VarCurr)
        & v66807(VarCurr) ) ) ).

tff(addAssignment_38654,axiom,
    ! [VarCurr: state_type] :
      ( v66807(VarCurr)
    <=> v66809(VarCurr) ) ).

tff(addAssignment_38653,axiom,
    ! [VarCurr: state_type] :
      ( v66809(VarCurr)
    <=> v64906(VarCurr) ) ).

tff(addAssignment_38652,axiom,
    ! [VarCurr: state_type] :
      ( v66803(VarCurr)
    <=> v66805(VarCurr) ) ).

tff(addAssignment_38651,axiom,
    ! [VarCurr: state_type] :
      ( v66805(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38650,axiom,
    ! [VarCurr: state_type] :
      ( v66782(VarCurr)
    <=> v66784(VarCurr) ) ).

tff(addAssignment_38649,axiom,
    ! [VarCurr: state_type] :
      ( v66784(VarCurr)
    <=> v66786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6172,axiom,
    ! [VarCurr: state_type] :
      ( v66786(VarCurr)
    <=> ( v66788(VarCurr)
        & v66792(VarCurr) ) ) ).

tff(addAssignment_38648,axiom,
    ! [VarCurr: state_type] :
      ( v66792(VarCurr)
    <=> v66794(VarCurr) ) ).

tff(addAssignment_38647,axiom,
    ! [VarCurr: state_type] :
      ( v66794(VarCurr)
    <=> v64876(VarCurr) ) ).

tff(addAssignment_38646,axiom,
    ! [VarCurr: state_type] :
      ( v66788(VarCurr)
    <=> v66790(VarCurr) ) ).

tff(addAssignment_38645,axiom,
    ! [VarCurr: state_type] :
      ( v66790(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38644,axiom,
    ! [VarCurr: state_type] :
      ( v66767(VarCurr)
    <=> v66769(VarCurr) ) ).

tff(addAssignment_38643,axiom,
    ! [VarCurr: state_type] :
      ( v66769(VarCurr)
    <=> v66771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6171,axiom,
    ! [VarCurr: state_type] :
      ( v66771(VarCurr)
    <=> ( v66773(VarCurr)
        & v66777(VarCurr) ) ) ).

tff(addAssignment_38642,axiom,
    ! [VarCurr: state_type] :
      ( v66777(VarCurr)
    <=> v66779(VarCurr) ) ).

tff(addAssignment_38641,axiom,
    ! [VarCurr: state_type] :
      ( v66779(VarCurr)
    <=> v64846(VarCurr) ) ).

tff(addAssignment_38640,axiom,
    ! [VarCurr: state_type] :
      ( v66773(VarCurr)
    <=> v66775(VarCurr) ) ).

tff(addAssignment_38639,axiom,
    ! [VarCurr: state_type] :
      ( v66775(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38638,axiom,
    ! [VarCurr: state_type] :
      ( v66752(VarCurr)
    <=> v66754(VarCurr) ) ).

tff(addAssignment_38637,axiom,
    ! [VarCurr: state_type] :
      ( v66754(VarCurr)
    <=> v66756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6170,axiom,
    ! [VarCurr: state_type] :
      ( v66756(VarCurr)
    <=> ( v66758(VarCurr)
        & v66762(VarCurr) ) ) ).

tff(addAssignment_38636,axiom,
    ! [VarCurr: state_type] :
      ( v66762(VarCurr)
    <=> v66764(VarCurr) ) ).

tff(addAssignment_38635,axiom,
    ! [VarCurr: state_type] :
      ( v66764(VarCurr)
    <=> v64816(VarCurr) ) ).

tff(addAssignment_38634,axiom,
    ! [VarCurr: state_type] :
      ( v66758(VarCurr)
    <=> v66760(VarCurr) ) ).

tff(addAssignment_38633,axiom,
    ! [VarCurr: state_type] :
      ( v66760(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38632,axiom,
    ! [VarCurr: state_type] :
      ( v66737(VarCurr)
    <=> v66739(VarCurr) ) ).

tff(addAssignment_38631,axiom,
    ! [VarCurr: state_type] :
      ( v66739(VarCurr)
    <=> v66741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6169,axiom,
    ! [VarCurr: state_type] :
      ( v66741(VarCurr)
    <=> ( v66743(VarCurr)
        & v66747(VarCurr) ) ) ).

tff(addAssignment_38630,axiom,
    ! [VarCurr: state_type] :
      ( v66747(VarCurr)
    <=> v66749(VarCurr) ) ).

tff(addAssignment_38629,axiom,
    ! [VarCurr: state_type] :
      ( v66749(VarCurr)
    <=> v64786(VarCurr) ) ).

tff(addAssignment_38628,axiom,
    ! [VarCurr: state_type] :
      ( v66743(VarCurr)
    <=> v66745(VarCurr) ) ).

tff(addAssignment_38627,axiom,
    ! [VarCurr: state_type] :
      ( v66745(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38626,axiom,
    ! [VarCurr: state_type] :
      ( v66722(VarCurr)
    <=> v66724(VarCurr) ) ).

tff(addAssignment_38625,axiom,
    ! [VarCurr: state_type] :
      ( v66724(VarCurr)
    <=> v66726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6168,axiom,
    ! [VarCurr: state_type] :
      ( v66726(VarCurr)
    <=> ( v66728(VarCurr)
        & v66732(VarCurr) ) ) ).

tff(addAssignment_38624,axiom,
    ! [VarCurr: state_type] :
      ( v66732(VarCurr)
    <=> v66734(VarCurr) ) ).

tff(addAssignment_38623,axiom,
    ! [VarCurr: state_type] :
      ( v66734(VarCurr)
    <=> v64756(VarCurr) ) ).

tff(addAssignment_38622,axiom,
    ! [VarCurr: state_type] :
      ( v66728(VarCurr)
    <=> v66730(VarCurr) ) ).

tff(addAssignment_38621,axiom,
    ! [VarCurr: state_type] :
      ( v66730(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38620,axiom,
    ! [VarCurr: state_type] :
      ( v66707(VarCurr)
    <=> v66709(VarCurr) ) ).

tff(addAssignment_38619,axiom,
    ! [VarCurr: state_type] :
      ( v66709(VarCurr)
    <=> v66711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6167,axiom,
    ! [VarCurr: state_type] :
      ( v66711(VarCurr)
    <=> ( v66713(VarCurr)
        & v66717(VarCurr) ) ) ).

tff(addAssignment_38618,axiom,
    ! [VarCurr: state_type] :
      ( v66717(VarCurr)
    <=> v66719(VarCurr) ) ).

tff(addAssignment_38617,axiom,
    ! [VarCurr: state_type] :
      ( v66719(VarCurr)
    <=> v64726(VarCurr) ) ).

tff(addAssignment_38616,axiom,
    ! [VarCurr: state_type] :
      ( v66713(VarCurr)
    <=> v66715(VarCurr) ) ).

tff(addAssignment_38615,axiom,
    ! [VarCurr: state_type] :
      ( v66715(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38614,axiom,
    ! [VarCurr: state_type] :
      ( v66692(VarCurr)
    <=> v66694(VarCurr) ) ).

tff(addAssignment_38613,axiom,
    ! [VarCurr: state_type] :
      ( v66694(VarCurr)
    <=> v66696(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6166,axiom,
    ! [VarCurr: state_type] :
      ( v66696(VarCurr)
    <=> ( v66698(VarCurr)
        & v66702(VarCurr) ) ) ).

tff(addAssignment_38612,axiom,
    ! [VarCurr: state_type] :
      ( v66702(VarCurr)
    <=> v66704(VarCurr) ) ).

tff(addAssignment_38611,axiom,
    ! [VarCurr: state_type] :
      ( v66704(VarCurr)
    <=> v64696(VarCurr) ) ).

tff(addAssignment_38610,axiom,
    ! [VarCurr: state_type] :
      ( v66698(VarCurr)
    <=> v66700(VarCurr) ) ).

tff(addAssignment_38609,axiom,
    ! [VarCurr: state_type] :
      ( v66700(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38608,axiom,
    ! [VarCurr: state_type] :
      ( v66677(VarCurr)
    <=> v66679(VarCurr) ) ).

tff(addAssignment_38607,axiom,
    ! [VarCurr: state_type] :
      ( v66679(VarCurr)
    <=> v66681(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6165,axiom,
    ! [VarCurr: state_type] :
      ( v66681(VarCurr)
    <=> ( v66683(VarCurr)
        & v66687(VarCurr) ) ) ).

tff(addAssignment_38606,axiom,
    ! [VarCurr: state_type] :
      ( v66687(VarCurr)
    <=> v66689(VarCurr) ) ).

tff(addAssignment_38605,axiom,
    ! [VarCurr: state_type] :
      ( v66689(VarCurr)
    <=> v64666(VarCurr) ) ).

tff(addAssignment_38604,axiom,
    ! [VarCurr: state_type] :
      ( v66683(VarCurr)
    <=> v66685(VarCurr) ) ).

tff(addAssignment_38603,axiom,
    ! [VarCurr: state_type] :
      ( v66685(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38602,axiom,
    ! [VarCurr: state_type] :
      ( v66662(VarCurr)
    <=> v66664(VarCurr) ) ).

tff(addAssignment_38601,axiom,
    ! [VarCurr: state_type] :
      ( v66664(VarCurr)
    <=> v66666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6164,axiom,
    ! [VarCurr: state_type] :
      ( v66666(VarCurr)
    <=> ( v66668(VarCurr)
        & v66672(VarCurr) ) ) ).

tff(addAssignment_38600,axiom,
    ! [VarCurr: state_type] :
      ( v66672(VarCurr)
    <=> v66674(VarCurr) ) ).

tff(addAssignment_38599,axiom,
    ! [VarCurr: state_type] :
      ( v66674(VarCurr)
    <=> v64636(VarCurr) ) ).

tff(addAssignment_38598,axiom,
    ! [VarCurr: state_type] :
      ( v66668(VarCurr)
    <=> v66670(VarCurr) ) ).

tff(addAssignment_38597,axiom,
    ! [VarCurr: state_type] :
      ( v66670(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38596,axiom,
    ! [VarCurr: state_type] :
      ( v66647(VarCurr)
    <=> v66649(VarCurr) ) ).

tff(addAssignment_38595,axiom,
    ! [VarCurr: state_type] :
      ( v66649(VarCurr)
    <=> v66651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6163,axiom,
    ! [VarCurr: state_type] :
      ( v66651(VarCurr)
    <=> ( v66653(VarCurr)
        & v66657(VarCurr) ) ) ).

tff(addAssignment_38594,axiom,
    ! [VarCurr: state_type] :
      ( v66657(VarCurr)
    <=> v66659(VarCurr) ) ).

tff(addAssignment_38593,axiom,
    ! [VarCurr: state_type] :
      ( v66659(VarCurr)
    <=> v64606(VarCurr) ) ).

tff(addAssignment_38592,axiom,
    ! [VarCurr: state_type] :
      ( v66653(VarCurr)
    <=> v66655(VarCurr) ) ).

tff(addAssignment_38591,axiom,
    ! [VarCurr: state_type] :
      ( v66655(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38590,axiom,
    ! [VarCurr: state_type] :
      ( v66632(VarCurr)
    <=> v66634(VarCurr) ) ).

tff(addAssignment_38589,axiom,
    ! [VarCurr: state_type] :
      ( v66634(VarCurr)
    <=> v66636(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6162,axiom,
    ! [VarCurr: state_type] :
      ( v66636(VarCurr)
    <=> ( v66638(VarCurr)
        & v66642(VarCurr) ) ) ).

tff(addAssignment_38588,axiom,
    ! [VarCurr: state_type] :
      ( v66642(VarCurr)
    <=> v66644(VarCurr) ) ).

tff(addAssignment_38587,axiom,
    ! [VarCurr: state_type] :
      ( v66644(VarCurr)
    <=> v64576(VarCurr) ) ).

tff(addAssignment_38586,axiom,
    ! [VarCurr: state_type] :
      ( v66638(VarCurr)
    <=> v66640(VarCurr) ) ).

tff(addAssignment_38585,axiom,
    ! [VarCurr: state_type] :
      ( v66640(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38584,axiom,
    ! [VarCurr: state_type] :
      ( v66617(VarCurr)
    <=> v66619(VarCurr) ) ).

tff(addAssignment_38583,axiom,
    ! [VarCurr: state_type] :
      ( v66619(VarCurr)
    <=> v66621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6161,axiom,
    ! [VarCurr: state_type] :
      ( v66621(VarCurr)
    <=> ( v66623(VarCurr)
        & v66627(VarCurr) ) ) ).

tff(addAssignment_38582,axiom,
    ! [VarCurr: state_type] :
      ( v66627(VarCurr)
    <=> v66629(VarCurr) ) ).

tff(addAssignment_38581,axiom,
    ! [VarCurr: state_type] :
      ( v66629(VarCurr)
    <=> v64546(VarCurr) ) ).

tff(addAssignment_38580,axiom,
    ! [VarCurr: state_type] :
      ( v66623(VarCurr)
    <=> v66625(VarCurr) ) ).

tff(addAssignment_38579,axiom,
    ! [VarCurr: state_type] :
      ( v66625(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38578,axiom,
    ! [VarCurr: state_type] :
      ( v66587(VarCurr)
    <=> v66589(VarCurr) ) ).

tff(addAssignment_38577,axiom,
    ! [VarCurr: state_type] :
      ( v66589(VarCurr)
    <=> v66591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6160,axiom,
    ! [VarCurr: state_type] :
      ( v66591(VarCurr)
    <=> ( v66593(VarCurr)
        & v66612(VarCurr) ) ) ).

tff(addAssignment_38576,axiom,
    ! [VarCurr: state_type] :
      ( v66612(VarCurr)
    <=> v66614(VarCurr) ) ).

tff(addAssignment_38575,axiom,
    ! [VarCurr: state_type] :
      ( v66614(VarCurr)
    <=> v64516(VarCurr) ) ).

tff(addAssignment_38574,axiom,
    ! [VarCurr: state_type] :
      ( v66593(VarCurr)
    <=> v66595(VarCurr) ) ).

tff(addAssignment_38573,axiom,
    ! [VarCurr: state_type] :
      ( v66595(VarCurr)
    <=> v66597(VarCurr) ) ).

tff(addAssignment_38572,axiom,
    ! [VarCurr: state_type] :
      ( v66597(VarCurr)
    <=> v66599(VarCurr) ) ).

tff(addAssignment_38571,axiom,
    ! [VarCurr: state_type] :
      ( v66599(VarCurr)
    <=> v66601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6159,axiom,
    ! [VarCurr: state_type] :
      ( v66601(VarCurr)
    <=> ( v66603(VarCurr)
        & v66607(VarCurr) ) ) ).

tff(addAssignment_38570,axiom,
    ! [VarCurr: state_type] :
      ( v66607(VarCurr)
    <=> v66609(VarCurr) ) ).

tff(addAssignment_38569,axiom,
    ! [VarCurr: state_type] :
      ( v66609(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_38568,axiom,
    ! [VarCurr: state_type] :
      ( v66603(VarCurr)
    <=> v66605(VarCurr) ) ).

tff(addAssignment_38567,axiom,
    ! [VarCurr: state_type] :
      ( v66605(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_38566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v65029(VarCurr,B)
      <=> v65031(VarCurr,B) ) ) ).

tff(addAssignment_38565,axiom,
    ! [VarCurr: state_type] :
      ( ( v65031(VarCurr,14)
      <=> v62809(VarCurr,29) )
      & ( v65031(VarCurr,13)
      <=> v62809(VarCurr,28) )
      & ( v65031(VarCurr,12)
      <=> v62809(VarCurr,27) )
      & ( v65031(VarCurr,11)
      <=> v62809(VarCurr,26) )
      & ( v65031(VarCurr,10)
      <=> v62809(VarCurr,25) )
      & ( v65031(VarCurr,9)
      <=> v62809(VarCurr,24) )
      & ( v65031(VarCurr,8)
      <=> v62809(VarCurr,23) )
      & ( v65031(VarCurr,7)
      <=> v62809(VarCurr,22) )
      & ( v65031(VarCurr,6)
      <=> v62809(VarCurr,21) )
      & ( v65031(VarCurr,5)
      <=> v62809(VarCurr,20) )
      & ( v65031(VarCurr,4)
      <=> v62809(VarCurr,19) )
      & ( v65031(VarCurr,3)
      <=> v62809(VarCurr,18) )
      & ( v65031(VarCurr,2)
      <=> v62809(VarCurr,17) )
      & ( v65031(VarCurr,1)
      <=> v62809(VarCurr,16) )
      & ( v65031(VarCurr,0)
      <=> v62809(VarCurr,15) ) ) ).

tff(addAssignment_38564,axiom,
    ! [VarCurr: state_type] :
      ( v65031(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_38563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,30)
        & ~ $less(B,15) )
     => ( v62809(VarCurr,B)
      <=> v64460(VarCurr,B) ) ) ).

tff(addAssignment_38562,axiom,
    ! [VarCurr: state_type] :
      ( v64478(VarCurr)
    <=> v66552(VarCurr) ) ).

tff(addAssignment_38561,axiom,
    ! [VarCurr: state_type] :
      ( v66552(VarCurr)
    <=> v66554(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6158,axiom,
    ! [VarCurr: state_type] :
      ( v66554(VarCurr)
    <=> ( v66556(VarCurr)
        & v66560(VarCurr) ) ) ).

tff(addAssignment_38560,axiom,
    ! [VarCurr: state_type] :
      ( v66560(VarCurr)
    <=> v66562(VarCurr) ) ).

tff(addAssignment_38559,axiom,
    ! [VarCurr: state_type] :
      ( v66562(VarCurr)
    <=> v66564(VarCurr) ) ).

tff(addAssignment_38558,axiom,
    ! [VarCurr: state_type] :
      ( v66564(VarCurr)
    <=> v66566(VarCurr) ) ).

tff(addAssignment_38557,axiom,
    ! [VarCurr: state_type] :
      ( v66566(VarCurr)
    <=> v66568(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_279,axiom,
    ! [VarCurr: state_type] :
      ( v66568(VarCurr)
    <=> ( ( v66570(VarCurr,3)
        <=> v66574(VarCurr,3) )
        & ( v66570(VarCurr,2)
        <=> v66574(VarCurr,2) )
        & ( v66570(VarCurr,1)
        <=> v66574(VarCurr,1) )
        & ( v66570(VarCurr,0)
        <=> v66574(VarCurr,0) ) ) ) ).

tff(addAssignment_38556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66574(VarCurr,B)
      <=> v66576(VarCurr,B) ) ) ).

tff(addAssignment_38555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66576(VarCurr,B)
      <=> v62257(VarCurr,B) ) ) ).

tff(addAssignment_38554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66570(VarCurr,B)
      <=> v66572(VarCurr,B) ) ) ).

tff(addAssignment_38553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66572(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38552,axiom,
    ! [VarCurr: state_type] :
      ( v66556(VarCurr)
    <=> v66558(VarCurr) ) ).

tff(addAssignment_38551,axiom,
    ! [VarCurr: state_type] :
      ( v66558(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38550,axiom,
    ! [VarCurr: state_type] :
      ( v64477(VarCurr)
    <=> v66483(VarCurr) ) ).

tff(addAssignment_38549,axiom,
    ! [VarCurr: state_type] :
      ( v66483(VarCurr)
    <=> v66485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6157,axiom,
    ! [VarCurr: state_type] :
      ( v66485(VarCurr)
    <=> ( v66487(VarCurr)
        & v66491(VarCurr) ) ) ).

tff(addAssignment_38548,axiom,
    ! [VarCurr: state_type] :
      ( v66491(VarCurr)
    <=> v66493(VarCurr) ) ).

tff(addAssignment_38547,axiom,
    ! [VarCurr: state_type] :
      ( v66493(VarCurr)
    <=> v66495(VarCurr) ) ).

tff(addAssignment_38546,axiom,
    ! [VarCurr: state_type] :
      ( v66495(VarCurr)
    <=> v66497(VarCurr) ) ).

tff(addAssignment_38545,axiom,
    ! [VarCurr: state_type] :
      ( v66497(VarCurr)
    <=> v66499(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_278,axiom,
    ! [VarCurr: state_type] :
      ( v66499(VarCurr)
    <=> ( ( v66501(VarCurr,3)
        <=> v66505(VarCurr,3) )
        & ( v66501(VarCurr,2)
        <=> v66505(VarCurr,2) )
        & ( v66501(VarCurr,1)
        <=> v66505(VarCurr,1) )
        & ( v66501(VarCurr,0)
        <=> v66505(VarCurr,0) ) ) ) ).

tff(addAssignment_38544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66505(VarCurr,B)
      <=> v66507(VarCurr,B) ) ) ).

tff(addAssignment_38543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66507(VarCurr,B)
      <=> v66509(VarCurr,B) ) ) ).

tff(addAssignment_38542,axiom,
    ! [VarCurr: state_type] :
      ( ( v66509(VarCurr,3)
      <=> v62856(VarCurr,59) )
      & ( v66509(VarCurr,2)
      <=> v62856(VarCurr,58) )
      & ( v66509(VarCurr,1)
      <=> v62856(VarCurr,57) )
      & ( v66509(VarCurr,0)
      <=> v62856(VarCurr,56) ) ) ).

tff(addAssignment_38541,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,59)
      <=> v65077(VarCurr,3) )
      & ( v62856(VarCurr,58)
      <=> v65077(VarCurr,2) )
      & ( v62856(VarCurr,57)
      <=> v65077(VarCurr,1) )
      & ( v62856(VarCurr,56)
      <=> v65077(VarCurr,0) ) ) ).

tff(addAssignment_38540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38536,axiom,
    ! [VarCurr: state_type] :
      ( v65255(VarCurr,3)
    <=> v66512(VarCurr) ) ).

tff(addAssignment_38535,axiom,
    ! [VarCurr: state_type] :
      ( v65255(VarCurr,2)
    <=> v66520(VarCurr) ) ).

tff(addAssignment_38534,axiom,
    ! [VarCurr: state_type] :
      ( v65255(VarCurr,1)
    <=> v66528(VarCurr) ) ).

tff(addAssignment_38533,axiom,
    ! [VarCurr: state_type] :
      ( v65255(VarCurr,0)
    <=> v66541(VarCurr) ) ).

tff(addAssignment_38532,axiom,
    ! [VarCurr: state_type] :
      ( v66541(VarCurr)
    <=> v66543(VarCurr) ) ).

tff(addAssignment_38531,axiom,
    ! [VarCurr: state_type] :
      ( v66543(VarCurr)
    <=> v66545(VarCurr) ) ).

tff(addAssignment_38530,axiom,
    ! [VarCurr: state_type] :
      ( v66545(VarCurr)
    <=> v66547(VarCurr) ) ).

tff(addAssignment_38529,axiom,
    ! [VarCurr: state_type] :
      ( v66547(VarCurr)
    <=> v62876(VarCurr,67) ) ).

tff(addAssignment_38528,axiom,
    ! [VarCurr: state_type] :
      ( v66528(VarCurr)
    <=> v66530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6156,axiom,
    ! [VarCurr: state_type] :
      ( v66530(VarCurr)
    <=> ( v66532(VarCurr)
      <~> v66536(VarCurr) ) ) ).

tff(addAssignment_38527,axiom,
    ! [VarCurr: state_type] :
      ( v66536(VarCurr)
    <=> v66538(VarCurr) ) ).

tff(addAssignment_38526,axiom,
    ! [VarCurr: state_type] :
      ( v66538(VarCurr)
    <=> v62876(VarCurr,67) ) ).

tff(addAssignment_38525,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,67)
    <=> v62934(VarCurr,67) ) ).

tff(addAssignment_38524,axiom,
    ! [VarCurr: state_type] :
      ( v66532(VarCurr)
    <=> v66534(VarCurr) ) ).

tff(addAssignment_38523,axiom,
    ! [VarCurr: state_type] :
      ( v66534(VarCurr)
    <=> v62876(VarCurr,64) ) ).

tff(addAssignment_38522,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,64)
    <=> v62934(VarCurr,64) ) ).

tff(addAssignment_38521,axiom,
    ! [VarCurr: state_type] :
      ( v66520(VarCurr)
    <=> v66522(VarCurr) ) ).

tff(addAssignment_38520,axiom,
    ! [VarCurr: state_type] :
      ( v66522(VarCurr)
    <=> v66524(VarCurr) ) ).

tff(addAssignment_38519,axiom,
    ! [VarCurr: state_type] :
      ( v66524(VarCurr)
    <=> v66526(VarCurr) ) ).

tff(addAssignment_38518,axiom,
    ! [VarCurr: state_type] :
      ( v66526(VarCurr)
    <=> v62876(VarCurr,65) ) ).

tff(addAssignment_38517,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,65)
    <=> v62934(VarCurr,65) ) ).

tff(addAssignment_38516,axiom,
    ! [VarCurr: state_type] :
      ( v66512(VarCurr)
    <=> v66514(VarCurr) ) ).

tff(addAssignment_38515,axiom,
    ! [VarCurr: state_type] :
      ( v66514(VarCurr)
    <=> v66516(VarCurr) ) ).

tff(addAssignment_38514,axiom,
    ! [VarCurr: state_type] :
      ( v66516(VarCurr)
    <=> v66518(VarCurr) ) ).

tff(addAssignment_38513,axiom,
    ! [VarCurr: state_type] :
      ( v66518(VarCurr)
    <=> v62876(VarCurr,66) ) ).

tff(addAssignment_38512,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,66)
    <=> v62934(VarCurr,66) ) ).

tff(addAssignment_38511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66501(VarCurr,B)
      <=> v66503(VarCurr,B) ) ) ).

tff(addAssignment_38510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66503(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38509,axiom,
    ! [VarCurr: state_type] :
      ( v66487(VarCurr)
    <=> v66489(VarCurr) ) ).

tff(addAssignment_38508,axiom,
    ! [VarCurr: state_type] :
      ( v66489(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38507,axiom,
    ! [VarCurr: state_type] :
      ( v64476(VarCurr)
    <=> v66394(VarCurr) ) ).

tff(addAssignment_38506,axiom,
    ! [VarCurr: state_type] :
      ( v66394(VarCurr)
    <=> v66396(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6155,axiom,
    ! [VarCurr: state_type] :
      ( v66396(VarCurr)
    <=> ( v66398(VarCurr)
        & v66402(VarCurr) ) ) ).

tff(addAssignment_38505,axiom,
    ! [VarCurr: state_type] :
      ( v66402(VarCurr)
    <=> v66404(VarCurr) ) ).

tff(addAssignment_38504,axiom,
    ! [VarCurr: state_type] :
      ( v66404(VarCurr)
    <=> v66406(VarCurr) ) ).

tff(addAssignment_38503,axiom,
    ! [VarCurr: state_type] :
      ( v66406(VarCurr)
    <=> v66408(VarCurr) ) ).

tff(addAssignment_38502,axiom,
    ! [VarCurr: state_type] :
      ( v66408(VarCurr)
    <=> v66410(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_277,axiom,
    ! [VarCurr: state_type] :
      ( v66410(VarCurr)
    <=> ( ( v66412(VarCurr,3)
        <=> v66416(VarCurr,3) )
        & ( v66412(VarCurr,2)
        <=> v66416(VarCurr,2) )
        & ( v66412(VarCurr,1)
        <=> v66416(VarCurr,1) )
        & ( v66412(VarCurr,0)
        <=> v66416(VarCurr,0) ) ) ) ).

tff(addAssignment_38501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66416(VarCurr,B)
      <=> v66418(VarCurr,B) ) ) ).

tff(addAssignment_38500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66418(VarCurr,B)
      <=> v66420(VarCurr,B) ) ) ).

tff(addAssignment_38499,axiom,
    ! [VarCurr: state_type] :
      ( ( v66420(VarCurr,3)
      <=> v62856(VarCurr,63) )
      & ( v66420(VarCurr,2)
      <=> v62856(VarCurr,62) )
      & ( v66420(VarCurr,1)
      <=> v62856(VarCurr,61) )
      & ( v66420(VarCurr,0)
      <=> v62856(VarCurr,60) ) ) ).

tff(addAssignment_38498,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,63)
      <=> v65077(VarCurr,7) )
      & ( v62856(VarCurr,62)
      <=> v65077(VarCurr,6) )
      & ( v62856(VarCurr,61)
      <=> v65077(VarCurr,5) )
      & ( v62856(VarCurr,60)
      <=> v65077(VarCurr,4) ) ) ).

tff(addAssignment_38497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38493,axiom,
    ! [VarCurr: state_type] :
      ( v65254(VarCurr,3)
    <=> v66423(VarCurr) ) ).

tff(addAssignment_38492,axiom,
    ! [VarCurr: state_type] :
      ( v65254(VarCurr,2)
    <=> v66436(VarCurr) ) ).

tff(addAssignment_38491,axiom,
    ! [VarCurr: state_type] :
      ( v65254(VarCurr,1)
    <=> v66449(VarCurr) ) ).

tff(addAssignment_38490,axiom,
    ! [VarCurr: state_type] :
      ( v65254(VarCurr,0)
    <=> v66467(VarCurr) ) ).

tff(addAssignment_38489,axiom,
    ! [VarCurr: state_type] :
      ( v66467(VarCurr)
    <=> v66469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6154,axiom,
    ! [VarCurr: state_type] :
      ( v66469(VarCurr)
    <=> ( v66471(VarCurr)
      <~> v66475(VarCurr) ) ) ).

tff(addAssignment_38488,axiom,
    ! [VarCurr: state_type] :
      ( v66475(VarCurr)
    <=> v66477(VarCurr) ) ).

tff(addAssignment_38487,axiom,
    ! [VarCurr: state_type] :
      ( v66477(VarCurr)
    <=> v62876(VarCurr,71) ) ).

tff(addAssignment_38486,axiom,
    ! [VarCurr: state_type] :
      ( v66471(VarCurr)
    <=> v66473(VarCurr) ) ).

tff(addAssignment_38485,axiom,
    ! [VarCurr: state_type] :
      ( v66473(VarCurr)
    <=> v62876(VarCurr,68) ) ).

tff(addAssignment_38484,axiom,
    ! [VarCurr: state_type] :
      ( v66449(VarCurr)
    <=> v66451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6153,axiom,
    ! [VarCurr: state_type] :
      ( v66451(VarCurr)
    <=> ( v66465(VarCurr)
      <~> v66461(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6152,axiom,
    ! [VarCurr: state_type] :
      ( v66465(VarCurr)
    <=> ( v66453(VarCurr)
      <~> v66457(VarCurr) ) ) ).

tff(addAssignment_38483,axiom,
    ! [VarCurr: state_type] :
      ( v66461(VarCurr)
    <=> v66463(VarCurr) ) ).

tff(addAssignment_38482,axiom,
    ! [VarCurr: state_type] :
      ( v66463(VarCurr)
    <=> v62876(VarCurr,71) ) ).

tff(addAssignment_38481,axiom,
    ! [VarCurr: state_type] :
      ( v66457(VarCurr)
    <=> v66459(VarCurr) ) ).

tff(addAssignment_38480,axiom,
    ! [VarCurr: state_type] :
      ( v66459(VarCurr)
    <=> v62876(VarCurr,69) ) ).

tff(addAssignment_38479,axiom,
    ! [VarCurr: state_type] :
      ( v66453(VarCurr)
    <=> v66455(VarCurr) ) ).

tff(addAssignment_38478,axiom,
    ! [VarCurr: state_type] :
      ( v66455(VarCurr)
    <=> v62876(VarCurr,68) ) ).

tff(addAssignment_38477,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,68)
    <=> v62934(VarCurr,68) ) ).

tff(addAssignment_38476,axiom,
    ! [VarCurr: state_type] :
      ( v66436(VarCurr)
    <=> v66438(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6151,axiom,
    ! [VarCurr: state_type] :
      ( v66438(VarCurr)
    <=> ( v66440(VarCurr)
      <~> v66444(VarCurr) ) ) ).

tff(addAssignment_38475,axiom,
    ! [VarCurr: state_type] :
      ( v66444(VarCurr)
    <=> v66446(VarCurr) ) ).

tff(addAssignment_38474,axiom,
    ! [VarCurr: state_type] :
      ( v66446(VarCurr)
    <=> v62876(VarCurr,70) ) ).

tff(addAssignment_38473,axiom,
    ! [VarCurr: state_type] :
      ( v66440(VarCurr)
    <=> v66442(VarCurr) ) ).

tff(addAssignment_38472,axiom,
    ! [VarCurr: state_type] :
      ( v66442(VarCurr)
    <=> v62876(VarCurr,69) ) ).

tff(addAssignment_38471,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,69)
    <=> v62934(VarCurr,69) ) ).

tff(addAssignment_38470,axiom,
    ! [VarCurr: state_type] :
      ( v66423(VarCurr)
    <=> v66425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6150,axiom,
    ! [VarCurr: state_type] :
      ( v66425(VarCurr)
    <=> ( v66427(VarCurr)
      <~> v66431(VarCurr) ) ) ).

tff(addAssignment_38469,axiom,
    ! [VarCurr: state_type] :
      ( v66431(VarCurr)
    <=> v66433(VarCurr) ) ).

tff(addAssignment_38468,axiom,
    ! [VarCurr: state_type] :
      ( v66433(VarCurr)
    <=> v62876(VarCurr,71) ) ).

tff(addAssignment_38467,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,71)
    <=> v62934(VarCurr,71) ) ).

tff(addAssignment_38466,axiom,
    ! [VarCurr: state_type] :
      ( v66427(VarCurr)
    <=> v66429(VarCurr) ) ).

tff(addAssignment_38465,axiom,
    ! [VarCurr: state_type] :
      ( v66429(VarCurr)
    <=> v62876(VarCurr,70) ) ).

tff(addAssignment_38464,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,70)
    <=> v62934(VarCurr,70) ) ).

tff(addAssignment_38463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66412(VarCurr,B)
      <=> v66414(VarCurr,B) ) ) ).

tff(addAssignment_38462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66414(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38461,axiom,
    ! [VarCurr: state_type] :
      ( v66398(VarCurr)
    <=> v66400(VarCurr) ) ).

tff(addAssignment_38460,axiom,
    ! [VarCurr: state_type] :
      ( v66400(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38459,axiom,
    ! [VarCurr: state_type] :
      ( v64475(VarCurr)
    <=> v66320(VarCurr) ) ).

tff(addAssignment_38458,axiom,
    ! [VarCurr: state_type] :
      ( v66320(VarCurr)
    <=> v66322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6149,axiom,
    ! [VarCurr: state_type] :
      ( v66322(VarCurr)
    <=> ( v66324(VarCurr)
        & v66328(VarCurr) ) ) ).

tff(addAssignment_38457,axiom,
    ! [VarCurr: state_type] :
      ( v66328(VarCurr)
    <=> v66330(VarCurr) ) ).

tff(addAssignment_38456,axiom,
    ! [VarCurr: state_type] :
      ( v66330(VarCurr)
    <=> v66332(VarCurr) ) ).

tff(addAssignment_38455,axiom,
    ! [VarCurr: state_type] :
      ( v66332(VarCurr)
    <=> v66334(VarCurr) ) ).

tff(addAssignment_38454,axiom,
    ! [VarCurr: state_type] :
      ( v66334(VarCurr)
    <=> v66336(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_276,axiom,
    ! [VarCurr: state_type] :
      ( v66336(VarCurr)
    <=> ( ( v66338(VarCurr,3)
        <=> v66342(VarCurr,3) )
        & ( v66338(VarCurr,2)
        <=> v66342(VarCurr,2) )
        & ( v66338(VarCurr,1)
        <=> v66342(VarCurr,1) )
        & ( v66338(VarCurr,0)
        <=> v66342(VarCurr,0) ) ) ) ).

tff(addAssignment_38453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66342(VarCurr,B)
      <=> v66344(VarCurr,B) ) ) ).

tff(addAssignment_38452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66344(VarCurr,B)
      <=> v66346(VarCurr,B) ) ) ).

tff(addAssignment_38451,axiom,
    ! [VarCurr: state_type] :
      ( ( v66346(VarCurr,3)
      <=> v62856(VarCurr,67) )
      & ( v66346(VarCurr,2)
      <=> v62856(VarCurr,66) )
      & ( v66346(VarCurr,1)
      <=> v62856(VarCurr,65) )
      & ( v66346(VarCurr,0)
      <=> v62856(VarCurr,64) ) ) ).

tff(addAssignment_38450,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,67)
      <=> v65077(VarCurr,11) )
      & ( v62856(VarCurr,66)
      <=> v65077(VarCurr,10) )
      & ( v62856(VarCurr,65)
      <=> v65077(VarCurr,9) )
      & ( v62856(VarCurr,64)
      <=> v65077(VarCurr,8) ) ) ).

tff(addAssignment_38449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38445,axiom,
    ! [VarCurr: state_type] :
      ( v65253(VarCurr,3)
    <=> v66349(VarCurr) ) ).

tff(addAssignment_38444,axiom,
    ! [VarCurr: state_type] :
      ( v65253(VarCurr,2)
    <=> v66357(VarCurr) ) ).

tff(addAssignment_38443,axiom,
    ! [VarCurr: state_type] :
      ( v65253(VarCurr,1)
    <=> v66370(VarCurr) ) ).

tff(addAssignment_38442,axiom,
    ! [VarCurr: state_type] :
      ( v65253(VarCurr,0)
    <=> v66383(VarCurr) ) ).

tff(addAssignment_38441,axiom,
    ! [VarCurr: state_type] :
      ( v66383(VarCurr)
    <=> v66385(VarCurr) ) ).

tff(addAssignment_38440,axiom,
    ! [VarCurr: state_type] :
      ( v66385(VarCurr)
    <=> v66387(VarCurr) ) ).

tff(addAssignment_38439,axiom,
    ! [VarCurr: state_type] :
      ( v66387(VarCurr)
    <=> v66389(VarCurr) ) ).

tff(addAssignment_38438,axiom,
    ! [VarCurr: state_type] :
      ( v66389(VarCurr)
    <=> v62876(VarCurr,74) ) ).

tff(addAssignment_38437,axiom,
    ! [VarCurr: state_type] :
      ( v66370(VarCurr)
    <=> v66372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6148,axiom,
    ! [VarCurr: state_type] :
      ( v66372(VarCurr)
    <=> ( v66374(VarCurr)
      <~> v66378(VarCurr) ) ) ).

tff(addAssignment_38436,axiom,
    ! [VarCurr: state_type] :
      ( v66378(VarCurr)
    <=> v66380(VarCurr) ) ).

tff(addAssignment_38435,axiom,
    ! [VarCurr: state_type] :
      ( v66380(VarCurr)
    <=> v62876(VarCurr,75) ) ).

tff(addAssignment_38434,axiom,
    ! [VarCurr: state_type] :
      ( v66374(VarCurr)
    <=> v66376(VarCurr) ) ).

tff(addAssignment_38433,axiom,
    ! [VarCurr: state_type] :
      ( v66376(VarCurr)
    <=> v62876(VarCurr,74) ) ).

tff(addAssignment_38432,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,74)
    <=> v62934(VarCurr,74) ) ).

tff(addAssignment_38431,axiom,
    ! [VarCurr: state_type] :
      ( v66357(VarCurr)
    <=> v66359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6147,axiom,
    ! [VarCurr: state_type] :
      ( v66359(VarCurr)
    <=> ( v66361(VarCurr)
      <~> v66365(VarCurr) ) ) ).

tff(addAssignment_38430,axiom,
    ! [VarCurr: state_type] :
      ( v66365(VarCurr)
    <=> v66367(VarCurr) ) ).

tff(addAssignment_38429,axiom,
    ! [VarCurr: state_type] :
      ( v66367(VarCurr)
    <=> v62876(VarCurr,75) ) ).

tff(addAssignment_38428,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,75)
    <=> v62934(VarCurr,75) ) ).

tff(addAssignment_38427,axiom,
    ! [VarCurr: state_type] :
      ( v66361(VarCurr)
    <=> v66363(VarCurr) ) ).

tff(addAssignment_38426,axiom,
    ! [VarCurr: state_type] :
      ( v66363(VarCurr)
    <=> v62876(VarCurr,72) ) ).

tff(addAssignment_38425,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,72)
    <=> v62934(VarCurr,72) ) ).

tff(addAssignment_38424,axiom,
    ! [VarCurr: state_type] :
      ( v66349(VarCurr)
    <=> v66351(VarCurr) ) ).

tff(addAssignment_38423,axiom,
    ! [VarCurr: state_type] :
      ( v66351(VarCurr)
    <=> v66353(VarCurr) ) ).

tff(addAssignment_38422,axiom,
    ! [VarCurr: state_type] :
      ( v66353(VarCurr)
    <=> v66355(VarCurr) ) ).

tff(addAssignment_38421,axiom,
    ! [VarCurr: state_type] :
      ( v66355(VarCurr)
    <=> v62876(VarCurr,73) ) ).

tff(addAssignment_38420,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,73)
    <=> v62934(VarCurr,73) ) ).

tff(addAssignment_38419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66338(VarCurr,B)
      <=> v66340(VarCurr,B) ) ) ).

tff(addAssignment_38418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66340(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38417,axiom,
    ! [VarCurr: state_type] :
      ( v66324(VarCurr)
    <=> v66326(VarCurr) ) ).

tff(addAssignment_38416,axiom,
    ! [VarCurr: state_type] :
      ( v66326(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38415,axiom,
    ! [VarCurr: state_type] :
      ( v64474(VarCurr)
    <=> v66186(VarCurr) ) ).

tff(addAssignment_38414,axiom,
    ! [VarCurr: state_type] :
      ( v66186(VarCurr)
    <=> v66188(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6146,axiom,
    ! [VarCurr: state_type] :
      ( v66188(VarCurr)
    <=> ( v66190(VarCurr)
        & v66194(VarCurr) ) ) ).

tff(addAssignment_38413,axiom,
    ! [VarCurr: state_type] :
      ( v66194(VarCurr)
    <=> v66196(VarCurr) ) ).

tff(addAssignment_38412,axiom,
    ! [VarCurr: state_type] :
      ( v66196(VarCurr)
    <=> v66198(VarCurr) ) ).

tff(addAssignment_38411,axiom,
    ! [VarCurr: state_type] :
      ( v66198(VarCurr)
    <=> v66200(VarCurr) ) ).

tff(addAssignment_38410,axiom,
    ! [VarCurr: state_type] :
      ( v66200(VarCurr)
    <=> v66202(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_275,axiom,
    ! [VarCurr: state_type] :
      ( v66202(VarCurr)
    <=> ( ( v66204(VarCurr,3)
        <=> v66208(VarCurr,3) )
        & ( v66204(VarCurr,2)
        <=> v66208(VarCurr,2) )
        & ( v66204(VarCurr,1)
        <=> v66208(VarCurr,1) )
        & ( v66204(VarCurr,0)
        <=> v66208(VarCurr,0) ) ) ) ).

tff(addAssignment_38409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66208(VarCurr,B)
      <=> v66210(VarCurr,B) ) ) ).

tff(addAssignment_38408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66210(VarCurr,B)
      <=> v66212(VarCurr,B) ) ) ).

tff(addAssignment_38407,axiom,
    ! [VarCurr: state_type] :
      ( ( v66212(VarCurr,3)
      <=> v62856(VarCurr,71) )
      & ( v66212(VarCurr,2)
      <=> v62856(VarCurr,70) )
      & ( v66212(VarCurr,1)
      <=> v62856(VarCurr,69) )
      & ( v66212(VarCurr,0)
      <=> v62856(VarCurr,68) ) ) ).

tff(addAssignment_38406,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,71)
      <=> v65077(VarCurr,15) )
      & ( v62856(VarCurr,70)
      <=> v65077(VarCurr,14) )
      & ( v62856(VarCurr,69)
      <=> v65077(VarCurr,13) )
      & ( v62856(VarCurr,68)
      <=> v65077(VarCurr,12) ) ) ).

tff(addAssignment_38405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38401,axiom,
    ! [VarCurr: state_type] :
      ( v65252(VarCurr,3)
    <=> v66215(VarCurr) ) ).

tff(addAssignment_38400,axiom,
    ! [VarCurr: state_type] :
      ( v65252(VarCurr,2)
    <=> v66248(VarCurr) ) ).

tff(addAssignment_38399,axiom,
    ! [VarCurr: state_type] :
      ( v65252(VarCurr,1)
    <=> v66286(VarCurr) ) ).

tff(addAssignment_38398,axiom,
    ! [VarCurr: state_type] :
      ( v65252(VarCurr,0)
    <=> v66304(VarCurr) ) ).

tff(addAssignment_38397,axiom,
    ! [VarCurr: state_type] :
      ( v66304(VarCurr)
    <=> v66306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6145,axiom,
    ! [VarCurr: state_type] :
      ( v66306(VarCurr)
    <=> ( v66308(VarCurr)
      <~> v66312(VarCurr) ) ) ).

tff(addAssignment_38396,axiom,
    ! [VarCurr: state_type] :
      ( v66312(VarCurr)
    <=> v66314(VarCurr) ) ).

tff(addAssignment_38395,axiom,
    ! [VarCurr: state_type] :
      ( v66314(VarCurr)
    <=> v62876(VarCurr,78) ) ).

tff(addAssignment_38394,axiom,
    ! [VarCurr: state_type] :
      ( v66308(VarCurr)
    <=> v66310(VarCurr) ) ).

tff(addAssignment_38393,axiom,
    ! [VarCurr: state_type] :
      ( v66310(VarCurr)
    <=> v62876(VarCurr,76) ) ).

tff(addAssignment_38392,axiom,
    ! [VarCurr: state_type] :
      ( v66286(VarCurr)
    <=> v66288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6144,axiom,
    ! [VarCurr: state_type] :
      ( v66288(VarCurr)
    <=> ( v66302(VarCurr)
      <~> v66298(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6143,axiom,
    ! [VarCurr: state_type] :
      ( v66302(VarCurr)
    <=> ( v66290(VarCurr)
      <~> v66294(VarCurr) ) ) ).

tff(addAssignment_38391,axiom,
    ! [VarCurr: state_type] :
      ( v66298(VarCurr)
    <=> v66300(VarCurr) ) ).

tff(addAssignment_38390,axiom,
    ! [VarCurr: state_type] :
      ( v66300(VarCurr)
    <=> v62876(VarCurr,79) ) ).

tff(addAssignment_38389,axiom,
    ! [VarCurr: state_type] :
      ( v66294(VarCurr)
    <=> v66296(VarCurr) ) ).

tff(addAssignment_38388,axiom,
    ! [VarCurr: state_type] :
      ( v66296(VarCurr)
    <=> v62876(VarCurr,78) ) ).

tff(addAssignment_38387,axiom,
    ! [VarCurr: state_type] :
      ( v66290(VarCurr)
    <=> v66292(VarCurr) ) ).

tff(addAssignment_38386,axiom,
    ! [VarCurr: state_type] :
      ( v66292(VarCurr)
    <=> v62876(VarCurr,77) ) ).

tff(addAssignment_38385,axiom,
    ! [VarCurr: state_type] :
      ( v66248(VarCurr)
    <=> v66250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6142,axiom,
    ! [VarCurr: state_type] :
      ( v66250(VarCurr)
    <=> ( v66284(VarCurr)
      <~> v66280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6141,axiom,
    ! [VarCurr: state_type] :
      ( v66284(VarCurr)
    <=> ( v66252(VarCurr)
      <~> v66266(VarCurr) ) ) ).

tff(addAssignment_38384,axiom,
    ! [VarCurr: state_type] :
      ( v66280(VarCurr)
    <=> v66282(VarCurr) ) ).

tff(addAssignment_38383,axiom,
    ! [VarCurr: state_type] :
      ( v66282(VarCurr)
    <=> v62876(VarCurr,79) ) ).

tff(addAssignment_38382,axiom,
    ! [VarCurr: state_type] :
      ( v66266(VarCurr)
    <=> v66268(VarCurr) ) ).

tff(addAssignment_38381,axiom,
    ! [VarCurr: state_type] :
      ( v66268(VarCurr)
    <=> v62876(VarCurr,78) ) ).

tff(addAssignment_38380,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,78)
    <=> v62934(VarCurr,78) ) ).

tff(addAssignment_38379,axiom,
    ! [VarCurr: state_type] :
      ( v62956(VarCurr)
    <=> v66271(VarCurr) ) ).

tff(addAssignment_38378,axiom,
    ! [VarCurr: state_type] :
      ( v66271(VarCurr)
    <=> v66273(VarCurr) ) ).

tff(writeUnaryOperator_3246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66273(VarCurr)
    <=> v66275(VarCurr) ) ).

tff(addAssignment_38377,axiom,
    ! [VarCurr: state_type] :
      ( v66275(VarCurr)
    <=> v66277(VarCurr) ) ).

tff(addAssignment_38376,axiom,
    ! [VarCurr: state_type] :
      ( v66277(VarCurr)
    <=> v65154(VarCurr) ) ).

tff(addAssignment_38375,axiom,
    ! [VarCurr: state_type] :
      ( v66252(VarCurr)
    <=> v66254(VarCurr) ) ).

tff(addAssignment_38374,axiom,
    ! [VarCurr: state_type] :
      ( v66254(VarCurr)
    <=> v62876(VarCurr,76) ) ).

tff(addAssignment_38373,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,76)
    <=> v62934(VarCurr,76) ) ).

tff(addAssignment_38372,axiom,
    ! [VarCurr: state_type] :
      ( v62958(VarCurr)
    <=> v66257(VarCurr) ) ).

tff(addAssignment_38371,axiom,
    ! [VarCurr: state_type] :
      ( v66257(VarCurr)
    <=> v66259(VarCurr) ) ).

tff(writeUnaryOperator_3245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66259(VarCurr)
    <=> v66261(VarCurr) ) ).

tff(addAssignment_38370,axiom,
    ! [VarCurr: state_type] :
      ( v66261(VarCurr)
    <=> v66263(VarCurr) ) ).

tff(addAssignment_38369,axiom,
    ! [VarCurr: state_type] :
      ( v66263(VarCurr)
    <=> v65104(VarCurr) ) ).

tff(addAssignment_38368,axiom,
    ! [VarCurr: state_type] :
      ( v66215(VarCurr)
    <=> v66217(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6140,axiom,
    ! [VarCurr: state_type] :
      ( v66217(VarCurr)
    <=> ( v66219(VarCurr)
      <~> v66233(VarCurr) ) ) ).

tff(addAssignment_38367,axiom,
    ! [VarCurr: state_type] :
      ( v66233(VarCurr)
    <=> v66235(VarCurr) ) ).

tff(addAssignment_38366,axiom,
    ! [VarCurr: state_type] :
      ( v66235(VarCurr)
    <=> v62876(VarCurr,79) ) ).

tff(addAssignment_38365,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,79)
    <=> v62934(VarCurr,79) ) ).

tff(addAssignment_38364,axiom,
    ! [VarCurr: state_type] :
      ( v62955(VarCurr)
    <=> v66238(VarCurr) ) ).

tff(addAssignment_38363,axiom,
    ! [VarCurr: state_type] :
      ( v66238(VarCurr)
    <=> v66240(VarCurr) ) ).

tff(writeUnaryOperator_3244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66240(VarCurr)
    <=> v66242(VarCurr) ) ).

tff(addAssignment_38362,axiom,
    ! [VarCurr: state_type] :
      ( v66242(VarCurr)
    <=> v66244(VarCurr) ) ).

tff(addAssignment_38361,axiom,
    ! [VarCurr: state_type] :
      ( v66244(VarCurr)
    <=> v65230(VarCurr) ) ).

tff(addAssignment_38360,axiom,
    ! [VarCurr: state_type] :
      ( v66219(VarCurr)
    <=> v66221(VarCurr) ) ).

tff(addAssignment_38359,axiom,
    ! [VarCurr: state_type] :
      ( v66221(VarCurr)
    <=> v62876(VarCurr,77) ) ).

tff(addAssignment_38358,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,77)
    <=> v62934(VarCurr,77) ) ).

tff(addAssignment_38357,axiom,
    ! [VarCurr: state_type] :
      ( v62957(VarCurr)
    <=> v66224(VarCurr) ) ).

tff(addAssignment_38356,axiom,
    ! [VarCurr: state_type] :
      ( v66224(VarCurr)
    <=> v66226(VarCurr) ) ).

tff(writeUnaryOperator_3243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v66226(VarCurr)
    <=> v66228(VarCurr) ) ).

tff(addAssignment_38355,axiom,
    ! [VarCurr: state_type] :
      ( v66228(VarCurr)
    <=> v66230(VarCurr) ) ).

tff(addAssignment_38354,axiom,
    ! [VarCurr: state_type] :
      ( v66230(VarCurr)
    <=> v65129(VarCurr) ) ).

tff(addAssignment_38353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66204(VarCurr,B)
      <=> v66206(VarCurr,B) ) ) ).

tff(addAssignment_38352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66206(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38351,axiom,
    ! [VarCurr: state_type] :
      ( v66190(VarCurr)
    <=> v66192(VarCurr) ) ).

tff(addAssignment_38350,axiom,
    ! [VarCurr: state_type] :
      ( v66192(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38349,axiom,
    ! [VarCurr: state_type] :
      ( v64473(VarCurr)
    <=> v66097(VarCurr) ) ).

tff(addAssignment_38348,axiom,
    ! [VarCurr: state_type] :
      ( v66097(VarCurr)
    <=> v66099(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6139,axiom,
    ! [VarCurr: state_type] :
      ( v66099(VarCurr)
    <=> ( v66101(VarCurr)
        & v66105(VarCurr) ) ) ).

tff(addAssignment_38347,axiom,
    ! [VarCurr: state_type] :
      ( v66105(VarCurr)
    <=> v66107(VarCurr) ) ).

tff(addAssignment_38346,axiom,
    ! [VarCurr: state_type] :
      ( v66107(VarCurr)
    <=> v66109(VarCurr) ) ).

tff(addAssignment_38345,axiom,
    ! [VarCurr: state_type] :
      ( v66109(VarCurr)
    <=> v66111(VarCurr) ) ).

tff(addAssignment_38344,axiom,
    ! [VarCurr: state_type] :
      ( v66111(VarCurr)
    <=> v66113(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_274,axiom,
    ! [VarCurr: state_type] :
      ( v66113(VarCurr)
    <=> ( ( v66115(VarCurr,3)
        <=> v66119(VarCurr,3) )
        & ( v66115(VarCurr,2)
        <=> v66119(VarCurr,2) )
        & ( v66115(VarCurr,1)
        <=> v66119(VarCurr,1) )
        & ( v66115(VarCurr,0)
        <=> v66119(VarCurr,0) ) ) ) ).

tff(addAssignment_38343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66119(VarCurr,B)
      <=> v66121(VarCurr,B) ) ) ).

tff(addAssignment_38342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66121(VarCurr,B)
      <=> v66123(VarCurr,B) ) ) ).

tff(addAssignment_38341,axiom,
    ! [VarCurr: state_type] :
      ( ( v66123(VarCurr,3)
      <=> v62856(VarCurr,75) )
      & ( v66123(VarCurr,2)
      <=> v62856(VarCurr,74) )
      & ( v66123(VarCurr,1)
      <=> v62856(VarCurr,73) )
      & ( v66123(VarCurr,0)
      <=> v62856(VarCurr,72) ) ) ).

tff(addAssignment_38340,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,75)
      <=> v65077(VarCurr,19) )
      & ( v62856(VarCurr,74)
      <=> v65077(VarCurr,18) )
      & ( v62856(VarCurr,73)
      <=> v65077(VarCurr,17) )
      & ( v62856(VarCurr,72)
      <=> v65077(VarCurr,16) ) ) ).

tff(addAssignment_38339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38335,axiom,
    ! [VarCurr: state_type] :
      ( v65251(VarCurr,3)
    <=> v66126(VarCurr) ) ).

tff(addAssignment_38334,axiom,
    ! [VarCurr: state_type] :
      ( v65251(VarCurr,2)
    <=> v66139(VarCurr) ) ).

tff(addAssignment_38333,axiom,
    ! [VarCurr: state_type] :
      ( v65251(VarCurr,1)
    <=> v66157(VarCurr) ) ).

tff(addAssignment_38332,axiom,
    ! [VarCurr: state_type] :
      ( v65251(VarCurr,0)
    <=> v66170(VarCurr) ) ).

tff(addAssignment_38331,axiom,
    ! [VarCurr: state_type] :
      ( v66170(VarCurr)
    <=> v66172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6138,axiom,
    ! [VarCurr: state_type] :
      ( v66172(VarCurr)
    <=> ( v66174(VarCurr)
      <~> v66178(VarCurr) ) ) ).

tff(addAssignment_38330,axiom,
    ! [VarCurr: state_type] :
      ( v66178(VarCurr)
    <=> v66180(VarCurr) ) ).

tff(addAssignment_38329,axiom,
    ! [VarCurr: state_type] :
      ( v66180(VarCurr)
    <=> v62876(VarCurr,83) ) ).

tff(addAssignment_38328,axiom,
    ! [VarCurr: state_type] :
      ( v66174(VarCurr)
    <=> v66176(VarCurr) ) ).

tff(addAssignment_38327,axiom,
    ! [VarCurr: state_type] :
      ( v66176(VarCurr)
    <=> v62876(VarCurr,82) ) ).

tff(addAssignment_38326,axiom,
    ! [VarCurr: state_type] :
      ( v66157(VarCurr)
    <=> v66159(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6137,axiom,
    ! [VarCurr: state_type] :
      ( v66159(VarCurr)
    <=> ( v66161(VarCurr)
      <~> v66165(VarCurr) ) ) ).

tff(addAssignment_38325,axiom,
    ! [VarCurr: state_type] :
      ( v66165(VarCurr)
    <=> v66167(VarCurr) ) ).

tff(addAssignment_38324,axiom,
    ! [VarCurr: state_type] :
      ( v66167(VarCurr)
    <=> v62876(VarCurr,82) ) ).

tff(addAssignment_38323,axiom,
    ! [VarCurr: state_type] :
      ( v66161(VarCurr)
    <=> v66163(VarCurr) ) ).

tff(addAssignment_38322,axiom,
    ! [VarCurr: state_type] :
      ( v66163(VarCurr)
    <=> v62876(VarCurr,80) ) ).

tff(addAssignment_38321,axiom,
    ! [VarCurr: state_type] :
      ( v66139(VarCurr)
    <=> v66141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6136,axiom,
    ! [VarCurr: state_type] :
      ( v66141(VarCurr)
    <=> ( v66155(VarCurr)
      <~> v66151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6135,axiom,
    ! [VarCurr: state_type] :
      ( v66155(VarCurr)
    <=> ( v66143(VarCurr)
      <~> v66147(VarCurr) ) ) ).

tff(addAssignment_38320,axiom,
    ! [VarCurr: state_type] :
      ( v66151(VarCurr)
    <=> v66153(VarCurr) ) ).

tff(addAssignment_38319,axiom,
    ! [VarCurr: state_type] :
      ( v66153(VarCurr)
    <=> v62876(VarCurr,83) ) ).

tff(addAssignment_38318,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,83)
    <=> v62934(VarCurr,83) ) ).

tff(addAssignment_38317,axiom,
    ! [VarCurr: state_type] :
      ( v66147(VarCurr)
    <=> v66149(VarCurr) ) ).

tff(addAssignment_38316,axiom,
    ! [VarCurr: state_type] :
      ( v66149(VarCurr)
    <=> v62876(VarCurr,81) ) ).

tff(addAssignment_38315,axiom,
    ! [VarCurr: state_type] :
      ( v66143(VarCurr)
    <=> v66145(VarCurr) ) ).

tff(addAssignment_38314,axiom,
    ! [VarCurr: state_type] :
      ( v66145(VarCurr)
    <=> v62876(VarCurr,80) ) ).

tff(addAssignment_38313,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,80)
    <=> v62934(VarCurr,80) ) ).

tff(addAssignment_38312,axiom,
    ! [VarCurr: state_type] :
      ( v66126(VarCurr)
    <=> v66128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6134,axiom,
    ! [VarCurr: state_type] :
      ( v66128(VarCurr)
    <=> ( v66130(VarCurr)
      <~> v66134(VarCurr) ) ) ).

tff(addAssignment_38311,axiom,
    ! [VarCurr: state_type] :
      ( v66134(VarCurr)
    <=> v66136(VarCurr) ) ).

tff(addAssignment_38310,axiom,
    ! [VarCurr: state_type] :
      ( v66136(VarCurr)
    <=> v62876(VarCurr,82) ) ).

tff(addAssignment_38309,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,82)
    <=> v62934(VarCurr,82) ) ).

tff(addAssignment_38308,axiom,
    ! [VarCurr: state_type] :
      ( v66130(VarCurr)
    <=> v66132(VarCurr) ) ).

tff(addAssignment_38307,axiom,
    ! [VarCurr: state_type] :
      ( v66132(VarCurr)
    <=> v62876(VarCurr,81) ) ).

tff(addAssignment_38306,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,81)
    <=> v62934(VarCurr,81) ) ).

tff(addAssignment_38305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66115(VarCurr,B)
      <=> v66117(VarCurr,B) ) ) ).

tff(addAssignment_38304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66117(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38303,axiom,
    ! [VarCurr: state_type] :
      ( v66101(VarCurr)
    <=> v66103(VarCurr) ) ).

tff(addAssignment_38302,axiom,
    ! [VarCurr: state_type] :
      ( v66103(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38301,axiom,
    ! [VarCurr: state_type] :
      ( v64472(VarCurr)
    <=> v65978(VarCurr) ) ).

tff(addAssignment_38300,axiom,
    ! [VarCurr: state_type] :
      ( v65978(VarCurr)
    <=> v65980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6133,axiom,
    ! [VarCurr: state_type] :
      ( v65980(VarCurr)
    <=> ( v65982(VarCurr)
        & v65986(VarCurr) ) ) ).

tff(addAssignment_38299,axiom,
    ! [VarCurr: state_type] :
      ( v65986(VarCurr)
    <=> v65988(VarCurr) ) ).

tff(addAssignment_38298,axiom,
    ! [VarCurr: state_type] :
      ( v65988(VarCurr)
    <=> v65990(VarCurr) ) ).

tff(addAssignment_38297,axiom,
    ! [VarCurr: state_type] :
      ( v65990(VarCurr)
    <=> v65992(VarCurr) ) ).

tff(addAssignment_38296,axiom,
    ! [VarCurr: state_type] :
      ( v65992(VarCurr)
    <=> v65994(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_273,axiom,
    ! [VarCurr: state_type] :
      ( v65994(VarCurr)
    <=> ( ( v65996(VarCurr,3)
        <=> v66000(VarCurr,3) )
        & ( v65996(VarCurr,2)
        <=> v66000(VarCurr,2) )
        & ( v65996(VarCurr,1)
        <=> v66000(VarCurr,1) )
        & ( v65996(VarCurr,0)
        <=> v66000(VarCurr,0) ) ) ) ).

tff(addAssignment_38295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66000(VarCurr,B)
      <=> v66002(VarCurr,B) ) ) ).

tff(addAssignment_38294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v66002(VarCurr,B)
      <=> v66004(VarCurr,B) ) ) ).

tff(addAssignment_38293,axiom,
    ! [VarCurr: state_type] :
      ( ( v66004(VarCurr,3)
      <=> v62856(VarCurr,79) )
      & ( v66004(VarCurr,2)
      <=> v62856(VarCurr,78) )
      & ( v66004(VarCurr,1)
      <=> v62856(VarCurr,77) )
      & ( v66004(VarCurr,0)
      <=> v62856(VarCurr,76) ) ) ).

tff(addAssignment_38292,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,79)
      <=> v65077(VarCurr,23) )
      & ( v62856(VarCurr,78)
      <=> v65077(VarCurr,22) )
      & ( v62856(VarCurr,77)
      <=> v65077(VarCurr,21) )
      & ( v62856(VarCurr,76)
      <=> v65077(VarCurr,20) ) ) ).

tff(addAssignment_38291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38287,axiom,
    ! [VarCurr: state_type] :
      ( v65250(VarCurr,3)
    <=> v66007(VarCurr) ) ).

tff(addAssignment_38286,axiom,
    ! [VarCurr: state_type] :
      ( v65250(VarCurr,2)
    <=> v66025(VarCurr) ) ).

tff(addAssignment_38285,axiom,
    ! [VarCurr: state_type] :
      ( v65250(VarCurr,1)
    <=> v66058(VarCurr) ) ).

tff(addAssignment_38284,axiom,
    ! [VarCurr: state_type] :
      ( v65250(VarCurr,0)
    <=> v66076(VarCurr) ) ).

tff(addAssignment_38283,axiom,
    ! [VarCurr: state_type] :
      ( v66076(VarCurr)
    <=> v66078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6132,axiom,
    ! [VarCurr: state_type] :
      ( v66078(VarCurr)
    <=> ( v66092(VarCurr)
      <~> v66088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6131,axiom,
    ! [VarCurr: state_type] :
      ( v66092(VarCurr)
    <=> ( v66080(VarCurr)
      <~> v66084(VarCurr) ) ) ).

tff(addAssignment_38282,axiom,
    ! [VarCurr: state_type] :
      ( v66088(VarCurr)
    <=> v66090(VarCurr) ) ).

tff(addAssignment_38281,axiom,
    ! [VarCurr: state_type] :
      ( v66090(VarCurr)
    <=> v62876(VarCurr,87) ) ).

tff(addAssignment_38280,axiom,
    ! [VarCurr: state_type] :
      ( v66084(VarCurr)
    <=> v66086(VarCurr) ) ).

tff(addAssignment_38279,axiom,
    ! [VarCurr: state_type] :
      ( v66086(VarCurr)
    <=> v62876(VarCurr,86) ) ).

tff(addAssignment_38278,axiom,
    ! [VarCurr: state_type] :
      ( v66080(VarCurr)
    <=> v66082(VarCurr) ) ).

tff(addAssignment_38277,axiom,
    ! [VarCurr: state_type] :
      ( v66082(VarCurr)
    <=> v62876(VarCurr,84) ) ).

tff(addAssignment_38276,axiom,
    ! [VarCurr: state_type] :
      ( v66058(VarCurr)
    <=> v66060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6130,axiom,
    ! [VarCurr: state_type] :
      ( v66060(VarCurr)
    <=> ( v66074(VarCurr)
      <~> v66070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6129,axiom,
    ! [VarCurr: state_type] :
      ( v66074(VarCurr)
    <=> ( v66062(VarCurr)
      <~> v66066(VarCurr) ) ) ).

tff(addAssignment_38275,axiom,
    ! [VarCurr: state_type] :
      ( v66070(VarCurr)
    <=> v66072(VarCurr) ) ).

tff(addAssignment_38274,axiom,
    ! [VarCurr: state_type] :
      ( v66072(VarCurr)
    <=> v62876(VarCurr,86) ) ).

tff(addAssignment_38273,axiom,
    ! [VarCurr: state_type] :
      ( v66066(VarCurr)
    <=> v66068(VarCurr) ) ).

tff(addAssignment_38272,axiom,
    ! [VarCurr: state_type] :
      ( v66068(VarCurr)
    <=> v62876(VarCurr,85) ) ).

tff(addAssignment_38271,axiom,
    ! [VarCurr: state_type] :
      ( v66062(VarCurr)
    <=> v66064(VarCurr) ) ).

tff(addAssignment_38270,axiom,
    ! [VarCurr: state_type] :
      ( v66064(VarCurr)
    <=> v62876(VarCurr,84) ) ).

tff(addAssignment_38269,axiom,
    ! [VarCurr: state_type] :
      ( v66025(VarCurr)
    <=> v66027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6128,axiom,
    ! [VarCurr: state_type] :
      ( v66027(VarCurr)
    <=> ( v66029(VarCurr)
      <~> v66053(VarCurr) ) ) ).

tff(addAssignment_38268,axiom,
    ! [VarCurr: state_type] :
      ( v66053(VarCurr)
    <=> v66055(VarCurr) ) ).

tff(addAssignment_38267,axiom,
    ! [VarCurr: state_type] :
      ( v66055(VarCurr)
    <=> v62876(VarCurr,87) ) ).

tff(addAssignment_38266,axiom,
    ! [VarCurr: state_type] :
      ( v66029(VarCurr)
    <=> v66031(VarCurr) ) ).

tff(addAssignment_38265,axiom,
    ! [VarCurr: state_type] :
      ( v66031(VarCurr)
    <=> v66033(VarCurr) ) ).

tff(addAssignment_38264,axiom,
    ! [VarCurr: state_type] :
      ( v66033(VarCurr)
    <=> v66035(VarCurr) ) ).

tff(addAssignment_38263,axiom,
    ! [VarCurr: state_type] :
      ( v66035(VarCurr)
    <=> v66037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6127,axiom,
    ! [VarCurr: state_type] :
      ( v66037(VarCurr)
    <=> ( v66051(VarCurr)
      <~> v66047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6126,axiom,
    ! [VarCurr: state_type] :
      ( v66051(VarCurr)
    <=> ( v66039(VarCurr)
      <~> v66043(VarCurr) ) ) ).

tff(addAssignment_38262,axiom,
    ! [VarCurr: state_type] :
      ( v66047(VarCurr)
    <=> v66049(VarCurr) ) ).

tff(addAssignment_38261,axiom,
    ! [VarCurr: state_type] :
      ( v66049(VarCurr)
    <=> v62876(VarCurr,86) ) ).

tff(addAssignment_38260,axiom,
    ! [VarCurr: state_type] :
      ( v66043(VarCurr)
    <=> v66045(VarCurr) ) ).

tff(addAssignment_38259,axiom,
    ! [VarCurr: state_type] :
      ( v66045(VarCurr)
    <=> v62876(VarCurr,85) ) ).

tff(addAssignment_38258,axiom,
    ! [VarCurr: state_type] :
      ( v66039(VarCurr)
    <=> v66041(VarCurr) ) ).

tff(addAssignment_38257,axiom,
    ! [VarCurr: state_type] :
      ( v66041(VarCurr)
    <=> v62876(VarCurr,84) ) ).

tff(addAssignment_38256,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,84)
    <=> v62934(VarCurr,84) ) ).

tff(addAssignment_38255,axiom,
    ! [VarCurr: state_type] :
      ( v66007(VarCurr)
    <=> v66009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6125,axiom,
    ! [VarCurr: state_type] :
      ( v66009(VarCurr)
    <=> ( v66023(VarCurr)
      <~> v66019(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6124,axiom,
    ! [VarCurr: state_type] :
      ( v66023(VarCurr)
    <=> ( v66011(VarCurr)
      <~> v66015(VarCurr) ) ) ).

tff(addAssignment_38254,axiom,
    ! [VarCurr: state_type] :
      ( v66019(VarCurr)
    <=> v66021(VarCurr) ) ).

tff(addAssignment_38253,axiom,
    ! [VarCurr: state_type] :
      ( v66021(VarCurr)
    <=> v62876(VarCurr,87) ) ).

tff(addAssignment_38252,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,87)
    <=> v62934(VarCurr,87) ) ).

tff(addAssignment_38251,axiom,
    ! [VarCurr: state_type] :
      ( v66015(VarCurr)
    <=> v66017(VarCurr) ) ).

tff(addAssignment_38250,axiom,
    ! [VarCurr: state_type] :
      ( v66017(VarCurr)
    <=> v62876(VarCurr,86) ) ).

tff(addAssignment_38249,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,86)
    <=> v62934(VarCurr,86) ) ).

tff(addAssignment_38248,axiom,
    ! [VarCurr: state_type] :
      ( v66011(VarCurr)
    <=> v66013(VarCurr) ) ).

tff(addAssignment_38247,axiom,
    ! [VarCurr: state_type] :
      ( v66013(VarCurr)
    <=> v62876(VarCurr,85) ) ).

tff(addAssignment_38246,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,85)
    <=> v62934(VarCurr,85) ) ).

tff(addAssignment_38245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65996(VarCurr,B)
      <=> v65998(VarCurr,B) ) ) ).

tff(addAssignment_38244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65998(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38243,axiom,
    ! [VarCurr: state_type] :
      ( v65982(VarCurr)
    <=> v65984(VarCurr) ) ).

tff(addAssignment_38242,axiom,
    ! [VarCurr: state_type] :
      ( v65984(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38241,axiom,
    ! [VarCurr: state_type] :
      ( v64471(VarCurr)
    <=> v65899(VarCurr) ) ).

tff(addAssignment_38240,axiom,
    ! [VarCurr: state_type] :
      ( v65899(VarCurr)
    <=> v65901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6123,axiom,
    ! [VarCurr: state_type] :
      ( v65901(VarCurr)
    <=> ( v65903(VarCurr)
        & v65907(VarCurr) ) ) ).

tff(addAssignment_38239,axiom,
    ! [VarCurr: state_type] :
      ( v65907(VarCurr)
    <=> v65909(VarCurr) ) ).

tff(addAssignment_38238,axiom,
    ! [VarCurr: state_type] :
      ( v65909(VarCurr)
    <=> v65911(VarCurr) ) ).

tff(addAssignment_38237,axiom,
    ! [VarCurr: state_type] :
      ( v65911(VarCurr)
    <=> v65913(VarCurr) ) ).

tff(addAssignment_38236,axiom,
    ! [VarCurr: state_type] :
      ( v65913(VarCurr)
    <=> v65915(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_272,axiom,
    ! [VarCurr: state_type] :
      ( v65915(VarCurr)
    <=> ( ( v65917(VarCurr,3)
        <=> v65921(VarCurr,3) )
        & ( v65917(VarCurr,2)
        <=> v65921(VarCurr,2) )
        & ( v65917(VarCurr,1)
        <=> v65921(VarCurr,1) )
        & ( v65917(VarCurr,0)
        <=> v65921(VarCurr,0) ) ) ) ).

tff(addAssignment_38235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65921(VarCurr,B)
      <=> v65923(VarCurr,B) ) ) ).

tff(addAssignment_38234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65923(VarCurr,B)
      <=> v65925(VarCurr,B) ) ) ).

tff(addAssignment_38233,axiom,
    ! [VarCurr: state_type] :
      ( ( v65925(VarCurr,3)
      <=> v62856(VarCurr,83) )
      & ( v65925(VarCurr,2)
      <=> v62856(VarCurr,82) )
      & ( v65925(VarCurr,1)
      <=> v62856(VarCurr,81) )
      & ( v65925(VarCurr,0)
      <=> v62856(VarCurr,80) ) ) ).

tff(addAssignment_38232,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,83)
      <=> v65077(VarCurr,27) )
      & ( v62856(VarCurr,82)
      <=> v65077(VarCurr,26) )
      & ( v62856(VarCurr,81)
      <=> v65077(VarCurr,25) )
      & ( v62856(VarCurr,80)
      <=> v65077(VarCurr,24) ) ) ).

tff(addAssignment_38231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38227,axiom,
    ! [VarCurr: state_type] :
      ( v65249(VarCurr,3)
    <=> v65928(VarCurr) ) ).

tff(addAssignment_38226,axiom,
    ! [VarCurr: state_type] :
      ( v65249(VarCurr,2)
    <=> v65941(VarCurr) ) ).

tff(addAssignment_38225,axiom,
    ! [VarCurr: state_type] :
      ( v65249(VarCurr,1)
    <=> v65954(VarCurr) ) ).

tff(addAssignment_38224,axiom,
    ! [VarCurr: state_type] :
      ( v65249(VarCurr,0)
    <=> v65967(VarCurr) ) ).

tff(addAssignment_38223,axiom,
    ! [VarCurr: state_type] :
      ( v65967(VarCurr)
    <=> v65969(VarCurr) ) ).

tff(addAssignment_38222,axiom,
    ! [VarCurr: state_type] :
      ( v65969(VarCurr)
    <=> v65971(VarCurr) ) ).

tff(addAssignment_38221,axiom,
    ! [VarCurr: state_type] :
      ( v65971(VarCurr)
    <=> v65973(VarCurr) ) ).

tff(addAssignment_38220,axiom,
    ! [VarCurr: state_type] :
      ( v65973(VarCurr)
    <=> v62876(VarCurr,89) ) ).

tff(addAssignment_38219,axiom,
    ! [VarCurr: state_type] :
      ( v65954(VarCurr)
    <=> v65956(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6122,axiom,
    ! [VarCurr: state_type] :
      ( v65956(VarCurr)
    <=> ( v65958(VarCurr)
      <~> v65962(VarCurr) ) ) ).

tff(addAssignment_38218,axiom,
    ! [VarCurr: state_type] :
      ( v65962(VarCurr)
    <=> v65964(VarCurr) ) ).

tff(addAssignment_38217,axiom,
    ! [VarCurr: state_type] :
      ( v65964(VarCurr)
    <=> v62876(VarCurr,90) ) ).

tff(addAssignment_38216,axiom,
    ! [VarCurr: state_type] :
      ( v65958(VarCurr)
    <=> v65960(VarCurr) ) ).

tff(addAssignment_38215,axiom,
    ! [VarCurr: state_type] :
      ( v65960(VarCurr)
    <=> v62876(VarCurr,89) ) ).

tff(addAssignment_38214,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,89)
    <=> v62934(VarCurr,89) ) ).

tff(addAssignment_38213,axiom,
    ! [VarCurr: state_type] :
      ( v65941(VarCurr)
    <=> v65943(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6121,axiom,
    ! [VarCurr: state_type] :
      ( v65943(VarCurr)
    <=> ( v65945(VarCurr)
      <~> v65949(VarCurr) ) ) ).

tff(addAssignment_38212,axiom,
    ! [VarCurr: state_type] :
      ( v65949(VarCurr)
    <=> v65951(VarCurr) ) ).

tff(addAssignment_38211,axiom,
    ! [VarCurr: state_type] :
      ( v65951(VarCurr)
    <=> v62876(VarCurr,91) ) ).

tff(addAssignment_38210,axiom,
    ! [VarCurr: state_type] :
      ( v65945(VarCurr)
    <=> v65947(VarCurr) ) ).

tff(addAssignment_38209,axiom,
    ! [VarCurr: state_type] :
      ( v65947(VarCurr)
    <=> v62876(VarCurr,90) ) ).

tff(addAssignment_38208,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,90)
    <=> v62934(VarCurr,90) ) ).

tff(addAssignment_38207,axiom,
    ! [VarCurr: state_type] :
      ( v65928(VarCurr)
    <=> v65930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6120,axiom,
    ! [VarCurr: state_type] :
      ( v65930(VarCurr)
    <=> ( v65932(VarCurr)
      <~> v65936(VarCurr) ) ) ).

tff(addAssignment_38206,axiom,
    ! [VarCurr: state_type] :
      ( v65936(VarCurr)
    <=> v65938(VarCurr) ) ).

tff(addAssignment_38205,axiom,
    ! [VarCurr: state_type] :
      ( v65938(VarCurr)
    <=> v62876(VarCurr,91) ) ).

tff(addAssignment_38204,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,91)
    <=> v62934(VarCurr,91) ) ).

tff(addAssignment_38203,axiom,
    ! [VarCurr: state_type] :
      ( v65932(VarCurr)
    <=> v65934(VarCurr) ) ).

tff(addAssignment_38202,axiom,
    ! [VarCurr: state_type] :
      ( v65934(VarCurr)
    <=> v62876(VarCurr,88) ) ).

tff(addAssignment_38201,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,88)
    <=> v62934(VarCurr,88) ) ).

tff(addAssignment_38200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65917(VarCurr,B)
      <=> v65919(VarCurr,B) ) ) ).

tff(addAssignment_38199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65919(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38198,axiom,
    ! [VarCurr: state_type] :
      ( v65903(VarCurr)
    <=> v65905(VarCurr) ) ).

tff(addAssignment_38197,axiom,
    ! [VarCurr: state_type] :
      ( v65905(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38196,axiom,
    ! [VarCurr: state_type] :
      ( v64470(VarCurr)
    <=> v65790(VarCurr) ) ).

tff(addAssignment_38195,axiom,
    ! [VarCurr: state_type] :
      ( v65790(VarCurr)
    <=> v65792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6119,axiom,
    ! [VarCurr: state_type] :
      ( v65792(VarCurr)
    <=> ( v65794(VarCurr)
        & v65798(VarCurr) ) ) ).

tff(addAssignment_38194,axiom,
    ! [VarCurr: state_type] :
      ( v65798(VarCurr)
    <=> v65800(VarCurr) ) ).

tff(addAssignment_38193,axiom,
    ! [VarCurr: state_type] :
      ( v65800(VarCurr)
    <=> v65802(VarCurr) ) ).

tff(addAssignment_38192,axiom,
    ! [VarCurr: state_type] :
      ( v65802(VarCurr)
    <=> v65804(VarCurr) ) ).

tff(addAssignment_38191,axiom,
    ! [VarCurr: state_type] :
      ( v65804(VarCurr)
    <=> v65806(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_271,axiom,
    ! [VarCurr: state_type] :
      ( v65806(VarCurr)
    <=> ( ( v65808(VarCurr,3)
        <=> v65812(VarCurr,3) )
        & ( v65808(VarCurr,2)
        <=> v65812(VarCurr,2) )
        & ( v65808(VarCurr,1)
        <=> v65812(VarCurr,1) )
        & ( v65808(VarCurr,0)
        <=> v65812(VarCurr,0) ) ) ) ).

tff(addAssignment_38190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65812(VarCurr,B)
      <=> v65814(VarCurr,B) ) ) ).

tff(addAssignment_38189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65814(VarCurr,B)
      <=> v65816(VarCurr,B) ) ) ).

tff(addAssignment_38188,axiom,
    ! [VarCurr: state_type] :
      ( ( v65816(VarCurr,3)
      <=> v62856(VarCurr,87) )
      & ( v65816(VarCurr,2)
      <=> v62856(VarCurr,86) )
      & ( v65816(VarCurr,1)
      <=> v62856(VarCurr,85) )
      & ( v65816(VarCurr,0)
      <=> v62856(VarCurr,84) ) ) ).

tff(addAssignment_38187,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,87)
      <=> v65077(VarCurr,31) )
      & ( v62856(VarCurr,86)
      <=> v65077(VarCurr,30) )
      & ( v62856(VarCurr,85)
      <=> v65077(VarCurr,29) )
      & ( v62856(VarCurr,84)
      <=> v65077(VarCurr,28) ) ) ).

tff(addAssignment_38186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38182,axiom,
    ! [VarCurr: state_type] :
      ( v65248(VarCurr,3)
    <=> v65819(VarCurr) ) ).

tff(addAssignment_38181,axiom,
    ! [VarCurr: state_type] :
      ( v65248(VarCurr,2)
    <=> v65837(VarCurr) ) ).

tff(addAssignment_38180,axiom,
    ! [VarCurr: state_type] :
      ( v65248(VarCurr,1)
    <=> v65855(VarCurr) ) ).

tff(addAssignment_38179,axiom,
    ! [VarCurr: state_type] :
      ( v65248(VarCurr,0)
    <=> v65873(VarCurr) ) ).

tff(addAssignment_38178,axiom,
    ! [VarCurr: state_type] :
      ( v65873(VarCurr)
    <=> v65875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6118,axiom,
    ! [VarCurr: state_type] :
      ( v65875(VarCurr)
    <=> ( v65877(VarCurr)
      <~> v65881(VarCurr) ) ) ).

tff(addAssignment_38177,axiom,
    ! [VarCurr: state_type] :
      ( v65881(VarCurr)
    <=> v65883(VarCurr) ) ).

tff(addAssignment_38176,axiom,
    ! [VarCurr: state_type] :
      ( v65883(VarCurr)
    <=> v62876(VarCurr,93) ) ).

tff(addAssignment_38175,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,93)
    <=> v62934(VarCurr,93) ) ).

tff(addAssignment_38174,axiom,
    ! [VarCurr: state_type] :
      ( v62951(VarCurr)
    <=> v65886(VarCurr) ) ).

tff(addAssignment_38173,axiom,
    ! [VarCurr: state_type] :
      ( v65886(VarCurr)
    <=> v65888(VarCurr) ) ).

tff(writeUnaryOperator_3242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65888(VarCurr)
    <=> v65890(VarCurr) ) ).

tff(addAssignment_38172,axiom,
    ! [VarCurr: state_type] :
      ( v65890(VarCurr)
    <=> v65892(VarCurr) ) ).

tff(addAssignment_38171,axiom,
    ! [VarCurr: state_type] :
      ( v65892(VarCurr)
    <=> v65129(VarCurr) ) ).

tff(addAssignment_38170,axiom,
    ! [VarCurr: state_type] :
      ( v65877(VarCurr)
    <=> v65879(VarCurr) ) ).

tff(addAssignment_38169,axiom,
    ! [VarCurr: state_type] :
      ( v65879(VarCurr)
    <=> v62876(VarCurr,92) ) ).

tff(addAssignment_38168,axiom,
    ! [VarCurr: state_type] :
      ( v65855(VarCurr)
    <=> v65857(VarCurr) ) ).

tff(addAssignment_38167,axiom,
    ! [VarCurr: state_type] :
      ( v65857(VarCurr)
    <=> v65859(VarCurr) ) ).

tff(addAssignment_38166,axiom,
    ! [VarCurr: state_type] :
      ( v65859(VarCurr)
    <=> v65861(VarCurr) ) ).

tff(addAssignment_38165,axiom,
    ! [VarCurr: state_type] :
      ( v65861(VarCurr)
    <=> v62876(VarCurr,94) ) ).

tff(addAssignment_38164,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,94)
    <=> v62934(VarCurr,94) ) ).

tff(addAssignment_38163,axiom,
    ! [VarCurr: state_type] :
      ( v62950(VarCurr)
    <=> v65864(VarCurr) ) ).

tff(addAssignment_38162,axiom,
    ! [VarCurr: state_type] :
      ( v65864(VarCurr)
    <=> v65866(VarCurr) ) ).

tff(writeUnaryOperator_3241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65866(VarCurr)
    <=> v65868(VarCurr) ) ).

tff(addAssignment_38161,axiom,
    ! [VarCurr: state_type] :
      ( v65868(VarCurr)
    <=> v65870(VarCurr) ) ).

tff(addAssignment_38160,axiom,
    ! [VarCurr: state_type] :
      ( v65870(VarCurr)
    <=> v65154(VarCurr) ) ).

tff(addAssignment_38159,axiom,
    ! [VarCurr: state_type] :
      ( v65837(VarCurr)
    <=> v65839(VarCurr) ) ).

tff(addAssignment_38158,axiom,
    ! [VarCurr: state_type] :
      ( v65839(VarCurr)
    <=> v65841(VarCurr) ) ).

tff(addAssignment_38157,axiom,
    ! [VarCurr: state_type] :
      ( v65841(VarCurr)
    <=> v65843(VarCurr) ) ).

tff(addAssignment_38156,axiom,
    ! [VarCurr: state_type] :
      ( v65843(VarCurr)
    <=> v62876(VarCurr,95) ) ).

tff(addAssignment_38155,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,95)
    <=> v62934(VarCurr,95) ) ).

tff(addAssignment_38154,axiom,
    ! [VarCurr: state_type] :
      ( v62949(VarCurr)
    <=> v65846(VarCurr) ) ).

tff(addAssignment_38153,axiom,
    ! [VarCurr: state_type] :
      ( v65846(VarCurr)
    <=> v65848(VarCurr) ) ).

tff(writeUnaryOperator_3240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65848(VarCurr)
    <=> v65850(VarCurr) ) ).

tff(addAssignment_38152,axiom,
    ! [VarCurr: state_type] :
      ( v65850(VarCurr)
    <=> v65852(VarCurr) ) ).

tff(addAssignment_38151,axiom,
    ! [VarCurr: state_type] :
      ( v65852(VarCurr)
    <=> v65230(VarCurr) ) ).

tff(addAssignment_38150,axiom,
    ! [VarCurr: state_type] :
      ( v65819(VarCurr)
    <=> v65821(VarCurr) ) ).

tff(addAssignment_38149,axiom,
    ! [VarCurr: state_type] :
      ( v65821(VarCurr)
    <=> v65823(VarCurr) ) ).

tff(addAssignment_38148,axiom,
    ! [VarCurr: state_type] :
      ( v65823(VarCurr)
    <=> v65825(VarCurr) ) ).

tff(addAssignment_38147,axiom,
    ! [VarCurr: state_type] :
      ( v65825(VarCurr)
    <=> v62876(VarCurr,92) ) ).

tff(addAssignment_38146,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,92)
    <=> v62934(VarCurr,92) ) ).

tff(addAssignment_38145,axiom,
    ! [VarCurr: state_type] :
      ( v62952(VarCurr)
    <=> v65828(VarCurr) ) ).

tff(addAssignment_38144,axiom,
    ! [VarCurr: state_type] :
      ( v65828(VarCurr)
    <=> v65830(VarCurr) ) ).

tff(writeUnaryOperator_3239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65830(VarCurr)
    <=> v65832(VarCurr) ) ).

tff(addAssignment_38143,axiom,
    ! [VarCurr: state_type] :
      ( v65832(VarCurr)
    <=> v65834(VarCurr) ) ).

tff(addAssignment_38142,axiom,
    ! [VarCurr: state_type] :
      ( v65834(VarCurr)
    <=> v65104(VarCurr) ) ).

tff(addAssignment_38141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65808(VarCurr,B)
      <=> v65810(VarCurr,B) ) ) ).

tff(addAssignment_38140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65810(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38139,axiom,
    ! [VarCurr: state_type] :
      ( v65794(VarCurr)
    <=> v65796(VarCurr) ) ).

tff(addAssignment_38138,axiom,
    ! [VarCurr: state_type] :
      ( v65796(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38137,axiom,
    ! [VarCurr: state_type] :
      ( v64469(VarCurr)
    <=> v65676(VarCurr) ) ).

tff(addAssignment_38136,axiom,
    ! [VarCurr: state_type] :
      ( v65676(VarCurr)
    <=> v65678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6117,axiom,
    ! [VarCurr: state_type] :
      ( v65678(VarCurr)
    <=> ( v65680(VarCurr)
        & v65684(VarCurr) ) ) ).

tff(addAssignment_38135,axiom,
    ! [VarCurr: state_type] :
      ( v65684(VarCurr)
    <=> v65686(VarCurr) ) ).

tff(addAssignment_38134,axiom,
    ! [VarCurr: state_type] :
      ( v65686(VarCurr)
    <=> v65688(VarCurr) ) ).

tff(addAssignment_38133,axiom,
    ! [VarCurr: state_type] :
      ( v65688(VarCurr)
    <=> v65690(VarCurr) ) ).

tff(addAssignment_38132,axiom,
    ! [VarCurr: state_type] :
      ( v65690(VarCurr)
    <=> v65692(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_270,axiom,
    ! [VarCurr: state_type] :
      ( v65692(VarCurr)
    <=> ( ( v65694(VarCurr,3)
        <=> v65698(VarCurr,3) )
        & ( v65694(VarCurr,2)
        <=> v65698(VarCurr,2) )
        & ( v65694(VarCurr,1)
        <=> v65698(VarCurr,1) )
        & ( v65694(VarCurr,0)
        <=> v65698(VarCurr,0) ) ) ) ).

tff(addAssignment_38131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65698(VarCurr,B)
      <=> v65700(VarCurr,B) ) ) ).

tff(addAssignment_38130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65700(VarCurr,B)
      <=> v65702(VarCurr,B) ) ) ).

tff(addAssignment_38129,axiom,
    ! [VarCurr: state_type] :
      ( ( v65702(VarCurr,3)
      <=> v62856(VarCurr,91) )
      & ( v65702(VarCurr,2)
      <=> v62856(VarCurr,90) )
      & ( v65702(VarCurr,1)
      <=> v62856(VarCurr,89) )
      & ( v65702(VarCurr,0)
      <=> v62856(VarCurr,88) ) ) ).

tff(addAssignment_38128,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,91)
      <=> v65077(VarCurr,35) )
      & ( v62856(VarCurr,90)
      <=> v65077(VarCurr,34) )
      & ( v62856(VarCurr,89)
      <=> v65077(VarCurr,33) )
      & ( v62856(VarCurr,88)
      <=> v65077(VarCurr,32) ) ) ).

tff(addAssignment_38127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38123,axiom,
    ! [VarCurr: state_type] :
      ( v65247(VarCurr,3)
    <=> v65705(VarCurr) ) ).

tff(addAssignment_38122,axiom,
    ! [VarCurr: state_type] :
      ( v65247(VarCurr,2)
    <=> v65723(VarCurr) ) ).

tff(addAssignment_38121,axiom,
    ! [VarCurr: state_type] :
      ( v65247(VarCurr,1)
    <=> v65741(VarCurr) ) ).

tff(addAssignment_38120,axiom,
    ! [VarCurr: state_type] :
      ( v65247(VarCurr,0)
    <=> v65774(VarCurr) ) ).

tff(addAssignment_38119,axiom,
    ! [VarCurr: state_type] :
      ( v65774(VarCurr)
    <=> v65776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6116,axiom,
    ! [VarCurr: state_type] :
      ( v65776(VarCurr)
    <=> ( v65778(VarCurr)
      <~> v65782(VarCurr) ) ) ).

tff(addAssignment_38118,axiom,
    ! [VarCurr: state_type] :
      ( v65782(VarCurr)
    <=> v65784(VarCurr) ) ).

tff(addAssignment_38117,axiom,
    ! [VarCurr: state_type] :
      ( v65784(VarCurr)
    <=> v62876(VarCurr,99) ) ).

tff(addAssignment_38116,axiom,
    ! [VarCurr: state_type] :
      ( v65778(VarCurr)
    <=> v65780(VarCurr) ) ).

tff(addAssignment_38115,axiom,
    ! [VarCurr: state_type] :
      ( v65780(VarCurr)
    <=> v62876(VarCurr,97) ) ).

tff(addAssignment_38114,axiom,
    ! [VarCurr: state_type] :
      ( v65741(VarCurr)
    <=> v65743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6115,axiom,
    ! [VarCurr: state_type] :
      ( v65743(VarCurr)
    <=> ( v65745(VarCurr)
      <~> v65769(VarCurr) ) ) ).

tff(addAssignment_38113,axiom,
    ! [VarCurr: state_type] :
      ( v65769(VarCurr)
    <=> v65771(VarCurr) ) ).

tff(addAssignment_38112,axiom,
    ! [VarCurr: state_type] :
      ( v65771(VarCurr)
    <=> v62876(VarCurr,99) ) ).

tff(addAssignment_38111,axiom,
    ! [VarCurr: state_type] :
      ( v65745(VarCurr)
    <=> v65747(VarCurr) ) ).

tff(addAssignment_38110,axiom,
    ! [VarCurr: state_type] :
      ( v65747(VarCurr)
    <=> v65749(VarCurr) ) ).

tff(addAssignment_38109,axiom,
    ! [VarCurr: state_type] :
      ( v65749(VarCurr)
    <=> v65751(VarCurr) ) ).

tff(addAssignment_38108,axiom,
    ! [VarCurr: state_type] :
      ( v65751(VarCurr)
    <=> v65753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6114,axiom,
    ! [VarCurr: state_type] :
      ( v65753(VarCurr)
    <=> ( v65767(VarCurr)
      <~> v65763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6113,axiom,
    ! [VarCurr: state_type] :
      ( v65767(VarCurr)
    <=> ( v65755(VarCurr)
      <~> v65759(VarCurr) ) ) ).

tff(addAssignment_38107,axiom,
    ! [VarCurr: state_type] :
      ( v65763(VarCurr)
    <=> v65765(VarCurr) ) ).

tff(addAssignment_38106,axiom,
    ! [VarCurr: state_type] :
      ( v65765(VarCurr)
    <=> v62876(VarCurr,98) ) ).

tff(addAssignment_38105,axiom,
    ! [VarCurr: state_type] :
      ( v65759(VarCurr)
    <=> v65761(VarCurr) ) ).

tff(addAssignment_38104,axiom,
    ! [VarCurr: state_type] :
      ( v65761(VarCurr)
    <=> v62876(VarCurr,97) ) ).

tff(addAssignment_38103,axiom,
    ! [VarCurr: state_type] :
      ( v65755(VarCurr)
    <=> v65757(VarCurr) ) ).

tff(addAssignment_38102,axiom,
    ! [VarCurr: state_type] :
      ( v65757(VarCurr)
    <=> v62876(VarCurr,96) ) ).

tff(addAssignment_38101,axiom,
    ! [VarCurr: state_type] :
      ( v65723(VarCurr)
    <=> v65725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6112,axiom,
    ! [VarCurr: state_type] :
      ( v65725(VarCurr)
    <=> ( v65739(VarCurr)
      <~> v65735(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6111,axiom,
    ! [VarCurr: state_type] :
      ( v65739(VarCurr)
    <=> ( v65727(VarCurr)
      <~> v65731(VarCurr) ) ) ).

tff(addAssignment_38100,axiom,
    ! [VarCurr: state_type] :
      ( v65735(VarCurr)
    <=> v65737(VarCurr) ) ).

tff(addAssignment_38099,axiom,
    ! [VarCurr: state_type] :
      ( v65737(VarCurr)
    <=> v62876(VarCurr,97) ) ).

tff(addAssignment_38098,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,97)
    <=> v62934(VarCurr,97) ) ).

tff(addAssignment_38097,axiom,
    ! [VarCurr: state_type] :
      ( v65731(VarCurr)
    <=> v65733(VarCurr) ) ).

tff(addAssignment_38096,axiom,
    ! [VarCurr: state_type] :
      ( v65733(VarCurr)
    <=> v62876(VarCurr,98) ) ).

tff(addAssignment_38095,axiom,
    ! [VarCurr: state_type] :
      ( v65727(VarCurr)
    <=> v65729(VarCurr) ) ).

tff(addAssignment_38094,axiom,
    ! [VarCurr: state_type] :
      ( v65729(VarCurr)
    <=> v62876(VarCurr,99) ) ).

tff(addAssignment_38093,axiom,
    ! [VarCurr: state_type] :
      ( v65705(VarCurr)
    <=> v65707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6110,axiom,
    ! [VarCurr: state_type] :
      ( v65707(VarCurr)
    <=> ( v65721(VarCurr)
      <~> v65717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6109,axiom,
    ! [VarCurr: state_type] :
      ( v65721(VarCurr)
    <=> ( v65709(VarCurr)
      <~> v65713(VarCurr) ) ) ).

tff(addAssignment_38092,axiom,
    ! [VarCurr: state_type] :
      ( v65717(VarCurr)
    <=> v65719(VarCurr) ) ).

tff(addAssignment_38091,axiom,
    ! [VarCurr: state_type] :
      ( v65719(VarCurr)
    <=> v62876(VarCurr,98) ) ).

tff(addAssignment_38090,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,98)
    <=> v62934(VarCurr,98) ) ).

tff(addAssignment_38089,axiom,
    ! [VarCurr: state_type] :
      ( v65713(VarCurr)
    <=> v65715(VarCurr) ) ).

tff(addAssignment_38088,axiom,
    ! [VarCurr: state_type] :
      ( v65715(VarCurr)
    <=> v62876(VarCurr,99) ) ).

tff(addAssignment_38087,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,99)
    <=> v62934(VarCurr,99) ) ).

tff(addAssignment_38086,axiom,
    ! [VarCurr: state_type] :
      ( v65709(VarCurr)
    <=> v65711(VarCurr) ) ).

tff(addAssignment_38085,axiom,
    ! [VarCurr: state_type] :
      ( v65711(VarCurr)
    <=> v62876(VarCurr,96) ) ).

tff(addAssignment_38084,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,96)
    <=> v62934(VarCurr,96) ) ).

tff(addAssignment_38083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65694(VarCurr,B)
      <=> v65696(VarCurr,B) ) ) ).

tff(addAssignment_38082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65696(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38081,axiom,
    ! [VarCurr: state_type] :
      ( v65680(VarCurr)
    <=> v65682(VarCurr) ) ).

tff(addAssignment_38080,axiom,
    ! [VarCurr: state_type] :
      ( v65682(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38079,axiom,
    ! [VarCurr: state_type] :
      ( v64468(VarCurr)
    <=> v65582(VarCurr) ) ).

tff(addAssignment_38078,axiom,
    ! [VarCurr: state_type] :
      ( v65582(VarCurr)
    <=> v65584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6108,axiom,
    ! [VarCurr: state_type] :
      ( v65584(VarCurr)
    <=> ( v65586(VarCurr)
        & v65590(VarCurr) ) ) ).

tff(addAssignment_38077,axiom,
    ! [VarCurr: state_type] :
      ( v65590(VarCurr)
    <=> v65592(VarCurr) ) ).

tff(addAssignment_38076,axiom,
    ! [VarCurr: state_type] :
      ( v65592(VarCurr)
    <=> v65594(VarCurr) ) ).

tff(addAssignment_38075,axiom,
    ! [VarCurr: state_type] :
      ( v65594(VarCurr)
    <=> v65596(VarCurr) ) ).

tff(addAssignment_38074,axiom,
    ! [VarCurr: state_type] :
      ( v65596(VarCurr)
    <=> v65598(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_269,axiom,
    ! [VarCurr: state_type] :
      ( v65598(VarCurr)
    <=> ( ( v65600(VarCurr,3)
        <=> v65604(VarCurr,3) )
        & ( v65600(VarCurr,2)
        <=> v65604(VarCurr,2) )
        & ( v65600(VarCurr,1)
        <=> v65604(VarCurr,1) )
        & ( v65600(VarCurr,0)
        <=> v65604(VarCurr,0) ) ) ) ).

tff(addAssignment_38073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65604(VarCurr,B)
      <=> v65606(VarCurr,B) ) ) ).

tff(addAssignment_38072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65606(VarCurr,B)
      <=> v65608(VarCurr,B) ) ) ).

tff(addAssignment_38071,axiom,
    ! [VarCurr: state_type] :
      ( ( v65608(VarCurr,3)
      <=> v62856(VarCurr,95) )
      & ( v65608(VarCurr,2)
      <=> v62856(VarCurr,94) )
      & ( v65608(VarCurr,1)
      <=> v62856(VarCurr,93) )
      & ( v65608(VarCurr,0)
      <=> v62856(VarCurr,92) ) ) ).

tff(addAssignment_38070,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,95)
      <=> v65077(VarCurr,39) )
      & ( v62856(VarCurr,94)
      <=> v65077(VarCurr,38) )
      & ( v62856(VarCurr,93)
      <=> v65077(VarCurr,37) )
      & ( v62856(VarCurr,92)
      <=> v65077(VarCurr,36) ) ) ).

tff(addAssignment_38069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38065,axiom,
    ! [VarCurr: state_type] :
      ( v65246(VarCurr,3)
    <=> v65611(VarCurr) ) ).

tff(addAssignment_38064,axiom,
    ! [VarCurr: state_type] :
      ( v65246(VarCurr,2)
    <=> v65624(VarCurr) ) ).

tff(addAssignment_38063,axiom,
    ! [VarCurr: state_type] :
      ( v65246(VarCurr,1)
    <=> v65637(VarCurr) ) ).

tff(addAssignment_38062,axiom,
    ! [VarCurr: state_type] :
      ( v65246(VarCurr,0)
    <=> v65655(VarCurr) ) ).

tff(addAssignment_38061,axiom,
    ! [VarCurr: state_type] :
      ( v65655(VarCurr)
    <=> v65657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6107,axiom,
    ! [VarCurr: state_type] :
      ( v65657(VarCurr)
    <=> ( v65671(VarCurr)
      <~> v65667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6106,axiom,
    ! [VarCurr: state_type] :
      ( v65671(VarCurr)
    <=> ( v65659(VarCurr)
      <~> v65663(VarCurr) ) ) ).

tff(addAssignment_38060,axiom,
    ! [VarCurr: state_type] :
      ( v65667(VarCurr)
    <=> v65669(VarCurr) ) ).

tff(addAssignment_38059,axiom,
    ! [VarCurr: state_type] :
      ( v65669(VarCurr)
    <=> v62876(VarCurr,103) ) ).

tff(addAssignment_38058,axiom,
    ! [VarCurr: state_type] :
      ( v65663(VarCurr)
    <=> v65665(VarCurr) ) ).

tff(addAssignment_38057,axiom,
    ! [VarCurr: state_type] :
      ( v65665(VarCurr)
    <=> v62876(VarCurr,100) ) ).

tff(addAssignment_38056,axiom,
    ! [VarCurr: state_type] :
      ( v65659(VarCurr)
    <=> v65661(VarCurr) ) ).

tff(addAssignment_38055,axiom,
    ! [VarCurr: state_type] :
      ( v65661(VarCurr)
    <=> v62876(VarCurr,101) ) ).

tff(addAssignment_38054,axiom,
    ! [VarCurr: state_type] :
      ( v65637(VarCurr)
    <=> v65639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6105,axiom,
    ! [VarCurr: state_type] :
      ( v65639(VarCurr)
    <=> ( v65653(VarCurr)
      <~> v65649(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6104,axiom,
    ! [VarCurr: state_type] :
      ( v65653(VarCurr)
    <=> ( v65641(VarCurr)
      <~> v65645(VarCurr) ) ) ).

tff(addAssignment_38053,axiom,
    ! [VarCurr: state_type] :
      ( v65649(VarCurr)
    <=> v65651(VarCurr) ) ).

tff(addAssignment_38052,axiom,
    ! [VarCurr: state_type] :
      ( v65651(VarCurr)
    <=> v62876(VarCurr,103) ) ).

tff(addAssignment_38051,axiom,
    ! [VarCurr: state_type] :
      ( v65645(VarCurr)
    <=> v65647(VarCurr) ) ).

tff(addAssignment_38050,axiom,
    ! [VarCurr: state_type] :
      ( v65647(VarCurr)
    <=> v62876(VarCurr,102) ) ).

tff(addAssignment_38049,axiom,
    ! [VarCurr: state_type] :
      ( v65641(VarCurr)
    <=> v65643(VarCurr) ) ).

tff(addAssignment_38048,axiom,
    ! [VarCurr: state_type] :
      ( v65643(VarCurr)
    <=> v62876(VarCurr,100) ) ).

tff(addAssignment_38047,axiom,
    ! [VarCurr: state_type] :
      ( v65624(VarCurr)
    <=> v65626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6103,axiom,
    ! [VarCurr: state_type] :
      ( v65626(VarCurr)
    <=> ( v65628(VarCurr)
      <~> v65632(VarCurr) ) ) ).

tff(addAssignment_38046,axiom,
    ! [VarCurr: state_type] :
      ( v65632(VarCurr)
    <=> v65634(VarCurr) ) ).

tff(addAssignment_38045,axiom,
    ! [VarCurr: state_type] :
      ( v65634(VarCurr)
    <=> v62876(VarCurr,103) ) ).

tff(addAssignment_38044,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,103)
    <=> v62934(VarCurr,103) ) ).

tff(addAssignment_38043,axiom,
    ! [VarCurr: state_type] :
      ( v65628(VarCurr)
    <=> v65630(VarCurr) ) ).

tff(addAssignment_38042,axiom,
    ! [VarCurr: state_type] :
      ( v65630(VarCurr)
    <=> v62876(VarCurr,101) ) ).

tff(addAssignment_38041,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,101)
    <=> v62934(VarCurr,101) ) ).

tff(addAssignment_38040,axiom,
    ! [VarCurr: state_type] :
      ( v65611(VarCurr)
    <=> v65613(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6102,axiom,
    ! [VarCurr: state_type] :
      ( v65613(VarCurr)
    <=> ( v65615(VarCurr)
      <~> v65619(VarCurr) ) ) ).

tff(addAssignment_38039,axiom,
    ! [VarCurr: state_type] :
      ( v65619(VarCurr)
    <=> v65621(VarCurr) ) ).

tff(addAssignment_38038,axiom,
    ! [VarCurr: state_type] :
      ( v65621(VarCurr)
    <=> v62876(VarCurr,102) ) ).

tff(addAssignment_38037,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,102)
    <=> v62934(VarCurr,102) ) ).

tff(addAssignment_38036,axiom,
    ! [VarCurr: state_type] :
      ( v65615(VarCurr)
    <=> v65617(VarCurr) ) ).

tff(addAssignment_38035,axiom,
    ! [VarCurr: state_type] :
      ( v65617(VarCurr)
    <=> v62876(VarCurr,100) ) ).

tff(addAssignment_38034,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,100)
    <=> v62934(VarCurr,100) ) ).

tff(addAssignment_38033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65600(VarCurr,B)
      <=> v65602(VarCurr,B) ) ) ).

tff(addAssignment_38032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65602(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_38031,axiom,
    ! [VarCurr: state_type] :
      ( v65586(VarCurr)
    <=> v65588(VarCurr) ) ).

tff(addAssignment_38030,axiom,
    ! [VarCurr: state_type] :
      ( v65588(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_38029,axiom,
    ! [VarCurr: state_type] :
      ( v64467(VarCurr)
    <=> v65493(VarCurr) ) ).

tff(addAssignment_38028,axiom,
    ! [VarCurr: state_type] :
      ( v65493(VarCurr)
    <=> v65495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6101,axiom,
    ! [VarCurr: state_type] :
      ( v65495(VarCurr)
    <=> ( v65497(VarCurr)
        & v65501(VarCurr) ) ) ).

tff(addAssignment_38027,axiom,
    ! [VarCurr: state_type] :
      ( v65501(VarCurr)
    <=> v65503(VarCurr) ) ).

tff(addAssignment_38026,axiom,
    ! [VarCurr: state_type] :
      ( v65503(VarCurr)
    <=> v65505(VarCurr) ) ).

tff(addAssignment_38025,axiom,
    ! [VarCurr: state_type] :
      ( v65505(VarCurr)
    <=> v65507(VarCurr) ) ).

tff(addAssignment_38024,axiom,
    ! [VarCurr: state_type] :
      ( v65507(VarCurr)
    <=> v65509(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_268,axiom,
    ! [VarCurr: state_type] :
      ( v65509(VarCurr)
    <=> ( ( v65511(VarCurr,3)
        <=> v65515(VarCurr,3) )
        & ( v65511(VarCurr,2)
        <=> v65515(VarCurr,2) )
        & ( v65511(VarCurr,1)
        <=> v65515(VarCurr,1) )
        & ( v65511(VarCurr,0)
        <=> v65515(VarCurr,0) ) ) ) ).

tff(addAssignment_38023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65515(VarCurr,B)
      <=> v65517(VarCurr,B) ) ) ).

tff(addAssignment_38022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65517(VarCurr,B)
      <=> v65519(VarCurr,B) ) ) ).

tff(addAssignment_38021,axiom,
    ! [VarCurr: state_type] :
      ( ( v65519(VarCurr,3)
      <=> v62856(VarCurr,99) )
      & ( v65519(VarCurr,2)
      <=> v62856(VarCurr,98) )
      & ( v65519(VarCurr,1)
      <=> v62856(VarCurr,97) )
      & ( v65519(VarCurr,0)
      <=> v62856(VarCurr,96) ) ) ).

tff(addAssignment_38020,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,99)
      <=> v65077(VarCurr,43) )
      & ( v62856(VarCurr,98)
      <=> v65077(VarCurr,42) )
      & ( v62856(VarCurr,97)
      <=> v65077(VarCurr,41) )
      & ( v62856(VarCurr,96)
      <=> v65077(VarCurr,40) ) ) ).

tff(addAssignment_38019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_38018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_38017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_38016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_38015,axiom,
    ! [VarCurr: state_type] :
      ( v65245(VarCurr,3)
    <=> v65522(VarCurr) ) ).

tff(addAssignment_38014,axiom,
    ! [VarCurr: state_type] :
      ( v65245(VarCurr,2)
    <=> v65540(VarCurr) ) ).

tff(addAssignment_38013,axiom,
    ! [VarCurr: state_type] :
      ( v65245(VarCurr,1)
    <=> v65553(VarCurr) ) ).

tff(addAssignment_38012,axiom,
    ! [VarCurr: state_type] :
      ( v65245(VarCurr,0)
    <=> v65566(VarCurr) ) ).

tff(addAssignment_38011,axiom,
    ! [VarCurr: state_type] :
      ( v65566(VarCurr)
    <=> v65568(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6100,axiom,
    ! [VarCurr: state_type] :
      ( v65568(VarCurr)
    <=> ( v65570(VarCurr)
      <~> v65574(VarCurr) ) ) ).

tff(addAssignment_38010,axiom,
    ! [VarCurr: state_type] :
      ( v65574(VarCurr)
    <=> v65576(VarCurr) ) ).

tff(addAssignment_38009,axiom,
    ! [VarCurr: state_type] :
      ( v65576(VarCurr)
    <=> v62876(VarCurr,106) ) ).

tff(addAssignment_38008,axiom,
    ! [VarCurr: state_type] :
      ( v65570(VarCurr)
    <=> v65572(VarCurr) ) ).

tff(addAssignment_38007,axiom,
    ! [VarCurr: state_type] :
      ( v65572(VarCurr)
    <=> v62876(VarCurr,105) ) ).

tff(addAssignment_38006,axiom,
    ! [VarCurr: state_type] :
      ( v65553(VarCurr)
    <=> v65555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6099,axiom,
    ! [VarCurr: state_type] :
      ( v65555(VarCurr)
    <=> ( v65557(VarCurr)
      <~> v65561(VarCurr) ) ) ).

tff(addAssignment_38005,axiom,
    ! [VarCurr: state_type] :
      ( v65561(VarCurr)
    <=> v65563(VarCurr) ) ).

tff(addAssignment_38004,axiom,
    ! [VarCurr: state_type] :
      ( v65563(VarCurr)
    <=> v62876(VarCurr,107) ) ).

tff(addAssignment_38003,axiom,
    ! [VarCurr: state_type] :
      ( v65557(VarCurr)
    <=> v65559(VarCurr) ) ).

tff(addAssignment_38002,axiom,
    ! [VarCurr: state_type] :
      ( v65559(VarCurr)
    <=> v62876(VarCurr,105) ) ).

tff(addAssignment_38001,axiom,
    ! [VarCurr: state_type] :
      ( v65540(VarCurr)
    <=> v65542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6098,axiom,
    ! [VarCurr: state_type] :
      ( v65542(VarCurr)
    <=> ( v65544(VarCurr)
      <~> v65548(VarCurr) ) ) ).

tff(addAssignment_38000,axiom,
    ! [VarCurr: state_type] :
      ( v65548(VarCurr)
    <=> v65550(VarCurr) ) ).

tff(addAssignment_37999,axiom,
    ! [VarCurr: state_type] :
      ( v65550(VarCurr)
    <=> v62876(VarCurr,106) ) ).

tff(addAssignment_37998,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,106)
    <=> v62934(VarCurr,106) ) ).

tff(addAssignment_37997,axiom,
    ! [VarCurr: state_type] :
      ( v65544(VarCurr)
    <=> v65546(VarCurr) ) ).

tff(addAssignment_37996,axiom,
    ! [VarCurr: state_type] :
      ( v65546(VarCurr)
    <=> v62876(VarCurr,104) ) ).

tff(addAssignment_37995,axiom,
    ! [VarCurr: state_type] :
      ( v65522(VarCurr)
    <=> v65524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6097,axiom,
    ! [VarCurr: state_type] :
      ( v65524(VarCurr)
    <=> ( v65538(VarCurr)
      <~> v65534(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6096,axiom,
    ! [VarCurr: state_type] :
      ( v65538(VarCurr)
    <=> ( v65526(VarCurr)
      <~> v65530(VarCurr) ) ) ).

tff(addAssignment_37994,axiom,
    ! [VarCurr: state_type] :
      ( v65534(VarCurr)
    <=> v65536(VarCurr) ) ).

tff(addAssignment_37993,axiom,
    ! [VarCurr: state_type] :
      ( v65536(VarCurr)
    <=> v62876(VarCurr,107) ) ).

tff(addAssignment_37992,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,107)
    <=> v62934(VarCurr,107) ) ).

tff(addAssignment_37991,axiom,
    ! [VarCurr: state_type] :
      ( v65530(VarCurr)
    <=> v65532(VarCurr) ) ).

tff(addAssignment_37990,axiom,
    ! [VarCurr: state_type] :
      ( v65532(VarCurr)
    <=> v62876(VarCurr,105) ) ).

tff(addAssignment_37989,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,105)
    <=> v62934(VarCurr,105) ) ).

tff(addAssignment_37988,axiom,
    ! [VarCurr: state_type] :
      ( v65526(VarCurr)
    <=> v65528(VarCurr) ) ).

tff(addAssignment_37987,axiom,
    ! [VarCurr: state_type] :
      ( v65528(VarCurr)
    <=> v62876(VarCurr,104) ) ).

tff(addAssignment_37986,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,104)
    <=> v62934(VarCurr,104) ) ).

tff(addAssignment_37985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65511(VarCurr,B)
      <=> v65513(VarCurr,B) ) ) ).

tff(addAssignment_37984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65513(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37983,axiom,
    ! [VarCurr: state_type] :
      ( v65497(VarCurr)
    <=> v65499(VarCurr) ) ).

tff(addAssignment_37982,axiom,
    ! [VarCurr: state_type] :
      ( v65499(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_37981,axiom,
    ! [VarCurr: state_type] :
      ( v64466(VarCurr)
    <=> v65374(VarCurr) ) ).

tff(addAssignment_37980,axiom,
    ! [VarCurr: state_type] :
      ( v65374(VarCurr)
    <=> v65376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6095,axiom,
    ! [VarCurr: state_type] :
      ( v65376(VarCurr)
    <=> ( v65378(VarCurr)
        & v65382(VarCurr) ) ) ).

tff(addAssignment_37979,axiom,
    ! [VarCurr: state_type] :
      ( v65382(VarCurr)
    <=> v65384(VarCurr) ) ).

tff(addAssignment_37978,axiom,
    ! [VarCurr: state_type] :
      ( v65384(VarCurr)
    <=> v65386(VarCurr) ) ).

tff(addAssignment_37977,axiom,
    ! [VarCurr: state_type] :
      ( v65386(VarCurr)
    <=> v65388(VarCurr) ) ).

tff(addAssignment_37976,axiom,
    ! [VarCurr: state_type] :
      ( v65388(VarCurr)
    <=> v65390(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_267,axiom,
    ! [VarCurr: state_type] :
      ( v65390(VarCurr)
    <=> ( ( v65392(VarCurr,3)
        <=> v65396(VarCurr,3) )
        & ( v65392(VarCurr,2)
        <=> v65396(VarCurr,2) )
        & ( v65392(VarCurr,1)
        <=> v65396(VarCurr,1) )
        & ( v65392(VarCurr,0)
        <=> v65396(VarCurr,0) ) ) ) ).

tff(addAssignment_37975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65396(VarCurr,B)
      <=> v65398(VarCurr,B) ) ) ).

tff(addAssignment_37974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65398(VarCurr,B)
      <=> v65400(VarCurr,B) ) ) ).

tff(addAssignment_37973,axiom,
    ! [VarCurr: state_type] :
      ( ( v65400(VarCurr,3)
      <=> v62856(VarCurr,103) )
      & ( v65400(VarCurr,2)
      <=> v62856(VarCurr,102) )
      & ( v65400(VarCurr,1)
      <=> v62856(VarCurr,101) )
      & ( v65400(VarCurr,0)
      <=> v62856(VarCurr,100) ) ) ).

tff(addAssignment_37972,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,103)
      <=> v65077(VarCurr,47) )
      & ( v62856(VarCurr,102)
      <=> v65077(VarCurr,46) )
      & ( v62856(VarCurr,101)
      <=> v65077(VarCurr,45) )
      & ( v62856(VarCurr,100)
      <=> v65077(VarCurr,44) ) ) ).

tff(addAssignment_37971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_37970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_37969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_37968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_37967,axiom,
    ! [VarCurr: state_type] :
      ( v65244(VarCurr,3)
    <=> v65403(VarCurr) ) ).

tff(addAssignment_37966,axiom,
    ! [VarCurr: state_type] :
      ( v65244(VarCurr,2)
    <=> v65436(VarCurr) ) ).

tff(addAssignment_37965,axiom,
    ! [VarCurr: state_type] :
      ( v65244(VarCurr,1)
    <=> v65444(VarCurr) ) ).

tff(addAssignment_37964,axiom,
    ! [VarCurr: state_type] :
      ( v65244(VarCurr,0)
    <=> v65462(VarCurr) ) ).

tff(addAssignment_37963,axiom,
    ! [VarCurr: state_type] :
      ( v65462(VarCurr)
    <=> v65464(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6094,axiom,
    ! [VarCurr: state_type] :
      ( v65464(VarCurr)
    <=> ( v65488(VarCurr)
      <~> v65474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6093,axiom,
    ! [VarCurr: state_type] :
      ( v65488(VarCurr)
    <=> ( v65466(VarCurr)
      <~> v65470(VarCurr) ) ) ).

tff(addAssignment_37962,axiom,
    ! [VarCurr: state_type] :
      ( v65474(VarCurr)
    <=> v65476(VarCurr) ) ).

tff(addAssignment_37961,axiom,
    ! [VarCurr: state_type] :
      ( v65476(VarCurr)
    <=> v62876(VarCurr,110) ) ).

tff(addAssignment_37960,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,110)
    <=> v62934(VarCurr,110) ) ).

tff(addAssignment_37959,axiom,
    ! [VarCurr: state_type] :
      ( v62944(VarCurr)
    <=> v65479(VarCurr) ) ).

tff(addAssignment_37958,axiom,
    ! [VarCurr: state_type] :
      ( v65479(VarCurr)
    <=> v65481(VarCurr) ) ).

tff(writeUnaryOperator_3238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65481(VarCurr)
    <=> v65483(VarCurr) ) ).

tff(addAssignment_37957,axiom,
    ! [VarCurr: state_type] :
      ( v65483(VarCurr)
    <=> v65485(VarCurr) ) ).

tff(addAssignment_37956,axiom,
    ! [VarCurr: state_type] :
      ( v65485(VarCurr)
    <=> v65154(VarCurr) ) ).

tff(addAssignment_37955,axiom,
    ! [VarCurr: state_type] :
      ( v65470(VarCurr)
    <=> v65472(VarCurr) ) ).

tff(addAssignment_37954,axiom,
    ! [VarCurr: state_type] :
      ( v65472(VarCurr)
    <=> v62876(VarCurr,109) ) ).

tff(addAssignment_37953,axiom,
    ! [VarCurr: state_type] :
      ( v65466(VarCurr)
    <=> v65468(VarCurr) ) ).

tff(addAssignment_37952,axiom,
    ! [VarCurr: state_type] :
      ( v65468(VarCurr)
    <=> v62876(VarCurr,108) ) ).

tff(addAssignment_37951,axiom,
    ! [VarCurr: state_type] :
      ( v65444(VarCurr)
    <=> v65446(VarCurr) ) ).

tff(addAssignment_37950,axiom,
    ! [VarCurr: state_type] :
      ( v65446(VarCurr)
    <=> v65448(VarCurr) ) ).

tff(addAssignment_37949,axiom,
    ! [VarCurr: state_type] :
      ( v65448(VarCurr)
    <=> v65450(VarCurr) ) ).

tff(addAssignment_37948,axiom,
    ! [VarCurr: state_type] :
      ( v65450(VarCurr)
    <=> v62876(VarCurr,111) ) ).

tff(addAssignment_37947,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,111)
    <=> v62934(VarCurr,111) ) ).

tff(addAssignment_37946,axiom,
    ! [VarCurr: state_type] :
      ( v62943(VarCurr)
    <=> v65453(VarCurr) ) ).

tff(addAssignment_37945,axiom,
    ! [VarCurr: state_type] :
      ( v65453(VarCurr)
    <=> v65455(VarCurr) ) ).

tff(writeUnaryOperator_3237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65455(VarCurr)
    <=> v65457(VarCurr) ) ).

tff(addAssignment_37944,axiom,
    ! [VarCurr: state_type] :
      ( v65457(VarCurr)
    <=> v65459(VarCurr) ) ).

tff(addAssignment_37943,axiom,
    ! [VarCurr: state_type] :
      ( v65459(VarCurr)
    <=> v65230(VarCurr) ) ).

tff(addAssignment_37942,axiom,
    ! [VarCurr: state_type] :
      ( v65436(VarCurr)
    <=> v65438(VarCurr) ) ).

tff(addAssignment_37941,axiom,
    ! [VarCurr: state_type] :
      ( v65438(VarCurr)
    <=> v65440(VarCurr) ) ).

tff(addAssignment_37940,axiom,
    ! [VarCurr: state_type] :
      ( v65440(VarCurr)
    <=> v65442(VarCurr) ) ).

tff(addAssignment_37939,axiom,
    ! [VarCurr: state_type] :
      ( v65442(VarCurr)
    <=> v62876(VarCurr,108) ) ).

tff(addAssignment_37938,axiom,
    ! [VarCurr: state_type] :
      ( v65403(VarCurr)
    <=> v65405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6092,axiom,
    ! [VarCurr: state_type] :
      ( v65405(VarCurr)
    <=> ( v65407(VarCurr)
      <~> v65421(VarCurr) ) ) ).

tff(addAssignment_37937,axiom,
    ! [VarCurr: state_type] :
      ( v65421(VarCurr)
    <=> v65423(VarCurr) ) ).

tff(addAssignment_37936,axiom,
    ! [VarCurr: state_type] :
      ( v65423(VarCurr)
    <=> v62876(VarCurr,109) ) ).

tff(addAssignment_37935,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,109)
    <=> v62934(VarCurr,109) ) ).

tff(addAssignment_37934,axiom,
    ! [VarCurr: state_type] :
      ( v62945(VarCurr)
    <=> v65426(VarCurr) ) ).

tff(addAssignment_37933,axiom,
    ! [VarCurr: state_type] :
      ( v65426(VarCurr)
    <=> v65428(VarCurr) ) ).

tff(writeUnaryOperator_3236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65428(VarCurr)
    <=> v65430(VarCurr) ) ).

tff(addAssignment_37932,axiom,
    ! [VarCurr: state_type] :
      ( v65430(VarCurr)
    <=> v65432(VarCurr) ) ).

tff(addAssignment_37931,axiom,
    ! [VarCurr: state_type] :
      ( v65432(VarCurr)
    <=> v65129(VarCurr) ) ).

tff(addAssignment_37930,axiom,
    ! [VarCurr: state_type] :
      ( v65407(VarCurr)
    <=> v65409(VarCurr) ) ).

tff(addAssignment_37929,axiom,
    ! [VarCurr: state_type] :
      ( v65409(VarCurr)
    <=> v62876(VarCurr,108) ) ).

tff(addAssignment_37928,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,108)
    <=> v62934(VarCurr,108) ) ).

tff(addAssignment_37927,axiom,
    ! [VarCurr: state_type] :
      ( v62946(VarCurr)
    <=> v65412(VarCurr) ) ).

tff(addAssignment_37926,axiom,
    ! [VarCurr: state_type] :
      ( v65412(VarCurr)
    <=> v65414(VarCurr) ) ).

tff(writeUnaryOperator_3235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65414(VarCurr)
    <=> v65416(VarCurr) ) ).

tff(addAssignment_37925,axiom,
    ! [VarCurr: state_type] :
      ( v65416(VarCurr)
    <=> v65418(VarCurr) ) ).

tff(addAssignment_37924,axiom,
    ! [VarCurr: state_type] :
      ( v65418(VarCurr)
    <=> v65104(VarCurr) ) ).

tff(addAssignment_37923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65392(VarCurr,B)
      <=> v65394(VarCurr,B) ) ) ).

tff(addAssignment_37922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65394(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37921,axiom,
    ! [VarCurr: state_type] :
      ( v65378(VarCurr)
    <=> v65380(VarCurr) ) ).

tff(addAssignment_37920,axiom,
    ! [VarCurr: state_type] :
      ( v65380(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_37919,axiom,
    ! [VarCurr: state_type] :
      ( v64465(VarCurr)
    <=> v65260(VarCurr) ) ).

tff(addAssignment_37918,axiom,
    ! [VarCurr: state_type] :
      ( v65260(VarCurr)
    <=> v65262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6091,axiom,
    ! [VarCurr: state_type] :
      ( v65262(VarCurr)
    <=> ( v65264(VarCurr)
        & v65268(VarCurr) ) ) ).

tff(addAssignment_37917,axiom,
    ! [VarCurr: state_type] :
      ( v65268(VarCurr)
    <=> v65270(VarCurr) ) ).

tff(addAssignment_37916,axiom,
    ! [VarCurr: state_type] :
      ( v65270(VarCurr)
    <=> v65272(VarCurr) ) ).

tff(addAssignment_37915,axiom,
    ! [VarCurr: state_type] :
      ( v65272(VarCurr)
    <=> v65274(VarCurr) ) ).

tff(addAssignment_37914,axiom,
    ! [VarCurr: state_type] :
      ( v65274(VarCurr)
    <=> v65276(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_266,axiom,
    ! [VarCurr: state_type] :
      ( v65276(VarCurr)
    <=> ( ( v65278(VarCurr,3)
        <=> v65282(VarCurr,3) )
        & ( v65278(VarCurr,2)
        <=> v65282(VarCurr,2) )
        & ( v65278(VarCurr,1)
        <=> v65282(VarCurr,1) )
        & ( v65278(VarCurr,0)
        <=> v65282(VarCurr,0) ) ) ) ).

tff(addAssignment_37913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65282(VarCurr,B)
      <=> v65284(VarCurr,B) ) ) ).

tff(addAssignment_37912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65284(VarCurr,B)
      <=> v65286(VarCurr,B) ) ) ).

tff(addAssignment_37911,axiom,
    ! [VarCurr: state_type] :
      ( ( v65286(VarCurr,3)
      <=> v62856(VarCurr,107) )
      & ( v65286(VarCurr,2)
      <=> v62856(VarCurr,106) )
      & ( v65286(VarCurr,1)
      <=> v62856(VarCurr,105) )
      & ( v65286(VarCurr,0)
      <=> v62856(VarCurr,104) ) ) ).

tff(addAssignment_37910,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,107)
      <=> v65077(VarCurr,51) )
      & ( v62856(VarCurr,106)
      <=> v65077(VarCurr,50) )
      & ( v62856(VarCurr,105)
      <=> v65077(VarCurr,49) )
      & ( v62856(VarCurr,104)
      <=> v65077(VarCurr,48) ) ) ).

tff(addAssignment_37909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_37908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_37907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_37906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_37905,axiom,
    ! [VarCurr: state_type] :
      ( v65243(VarCurr,3)
    <=> v65289(VarCurr) ) ).

tff(addAssignment_37904,axiom,
    ! [VarCurr: state_type] :
      ( v65243(VarCurr,2)
    <=> v65322(VarCurr) ) ).

tff(addAssignment_37903,axiom,
    ! [VarCurr: state_type] :
      ( v65243(VarCurr,1)
    <=> v65340(VarCurr) ) ).

tff(addAssignment_37902,axiom,
    ! [VarCurr: state_type] :
      ( v65243(VarCurr,0)
    <=> v65353(VarCurr) ) ).

tff(addAssignment_37901,axiom,
    ! [VarCurr: state_type] :
      ( v65353(VarCurr)
    <=> v65355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6090,axiom,
    ! [VarCurr: state_type] :
      ( v65355(VarCurr)
    <=> ( v65369(VarCurr)
      <~> v65365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6089,axiom,
    ! [VarCurr: state_type] :
      ( v65369(VarCurr)
    <=> ( v65357(VarCurr)
      <~> v65361(VarCurr) ) ) ).

tff(addAssignment_37900,axiom,
    ! [VarCurr: state_type] :
      ( v65365(VarCurr)
    <=> v65367(VarCurr) ) ).

tff(addAssignment_37899,axiom,
    ! [VarCurr: state_type] :
      ( v65367(VarCurr)
    <=> v62876(VarCurr,115) ) ).

tff(addAssignment_37898,axiom,
    ! [VarCurr: state_type] :
      ( v65361(VarCurr)
    <=> v65363(VarCurr) ) ).

tff(addAssignment_37897,axiom,
    ! [VarCurr: state_type] :
      ( v65363(VarCurr)
    <=> v62876(VarCurr,114) ) ).

tff(addAssignment_37896,axiom,
    ! [VarCurr: state_type] :
      ( v65357(VarCurr)
    <=> v65359(VarCurr) ) ).

tff(addAssignment_37895,axiom,
    ! [VarCurr: state_type] :
      ( v65359(VarCurr)
    <=> v62876(VarCurr,113) ) ).

tff(addAssignment_37894,axiom,
    ! [VarCurr: state_type] :
      ( v65340(VarCurr)
    <=> v65342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6088,axiom,
    ! [VarCurr: state_type] :
      ( v65342(VarCurr)
    <=> ( v65344(VarCurr)
      <~> v65348(VarCurr) ) ) ).

tff(addAssignment_37893,axiom,
    ! [VarCurr: state_type] :
      ( v65348(VarCurr)
    <=> v65350(VarCurr) ) ).

tff(addAssignment_37892,axiom,
    ! [VarCurr: state_type] :
      ( v65350(VarCurr)
    <=> v62876(VarCurr,112) ) ).

tff(addAssignment_37891,axiom,
    ! [VarCurr: state_type] :
      ( v65344(VarCurr)
    <=> v65346(VarCurr) ) ).

tff(addAssignment_37890,axiom,
    ! [VarCurr: state_type] :
      ( v65346(VarCurr)
    <=> v62876(VarCurr,113) ) ).

tff(addAssignment_37889,axiom,
    ! [VarCurr: state_type] :
      ( v65322(VarCurr)
    <=> v65324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6087,axiom,
    ! [VarCurr: state_type] :
      ( v65324(VarCurr)
    <=> ( v65338(VarCurr)
      <~> v65334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6086,axiom,
    ! [VarCurr: state_type] :
      ( v65338(VarCurr)
    <=> ( v65326(VarCurr)
      <~> v65330(VarCurr) ) ) ).

tff(addAssignment_37888,axiom,
    ! [VarCurr: state_type] :
      ( v65334(VarCurr)
    <=> v65336(VarCurr) ) ).

tff(addAssignment_37887,axiom,
    ! [VarCurr: state_type] :
      ( v65336(VarCurr)
    <=> v62876(VarCurr,114) ) ).

tff(addAssignment_37886,axiom,
    ! [VarCurr: state_type] :
      ( v65330(VarCurr)
    <=> v65332(VarCurr) ) ).

tff(addAssignment_37885,axiom,
    ! [VarCurr: state_type] :
      ( v65332(VarCurr)
    <=> v62876(VarCurr,113) ) ).

tff(addAssignment_37884,axiom,
    ! [VarCurr: state_type] :
      ( v65326(VarCurr)
    <=> v65328(VarCurr) ) ).

tff(addAssignment_37883,axiom,
    ! [VarCurr: state_type] :
      ( v65328(VarCurr)
    <=> v62876(VarCurr,112) ) ).

tff(addAssignment_37882,axiom,
    ! [VarCurr: state_type] :
      ( v65289(VarCurr)
    <=> v65291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6085,axiom,
    ! [VarCurr: state_type] :
      ( v65291(VarCurr)
    <=> ( v65293(VarCurr)
      <~> v65317(VarCurr) ) ) ).

tff(addAssignment_37881,axiom,
    ! [VarCurr: state_type] :
      ( v65317(VarCurr)
    <=> v65319(VarCurr) ) ).

tff(addAssignment_37880,axiom,
    ! [VarCurr: state_type] :
      ( v65319(VarCurr)
    <=> v62876(VarCurr,115) ) ).

tff(addAssignment_37879,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,115)
    <=> v62934(VarCurr,115) ) ).

tff(addAssignment_37878,axiom,
    ! [VarCurr: state_type] :
      ( v65293(VarCurr)
    <=> v65295(VarCurr) ) ).

tff(addAssignment_37877,axiom,
    ! [VarCurr: state_type] :
      ( v65295(VarCurr)
    <=> v65297(VarCurr) ) ).

tff(addAssignment_37876,axiom,
    ! [VarCurr: state_type] :
      ( v65297(VarCurr)
    <=> v65299(VarCurr) ) ).

tff(addAssignment_37875,axiom,
    ! [VarCurr: state_type] :
      ( v65299(VarCurr)
    <=> v65301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6084,axiom,
    ! [VarCurr: state_type] :
      ( v65301(VarCurr)
    <=> ( v65315(VarCurr)
      <~> v65311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6083,axiom,
    ! [VarCurr: state_type] :
      ( v65315(VarCurr)
    <=> ( v65303(VarCurr)
      <~> v65307(VarCurr) ) ) ).

tff(addAssignment_37874,axiom,
    ! [VarCurr: state_type] :
      ( v65311(VarCurr)
    <=> v65313(VarCurr) ) ).

tff(addAssignment_37873,axiom,
    ! [VarCurr: state_type] :
      ( v65313(VarCurr)
    <=> v62876(VarCurr,114) ) ).

tff(addAssignment_37872,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,114)
    <=> v62934(VarCurr,114) ) ).

tff(addAssignment_37871,axiom,
    ! [VarCurr: state_type] :
      ( v65307(VarCurr)
    <=> v65309(VarCurr) ) ).

tff(addAssignment_37870,axiom,
    ! [VarCurr: state_type] :
      ( v65309(VarCurr)
    <=> v62876(VarCurr,113) ) ).

tff(addAssignment_37869,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,113)
    <=> v62934(VarCurr,113) ) ).

tff(addAssignment_37868,axiom,
    ! [VarCurr: state_type] :
      ( v65303(VarCurr)
    <=> v65305(VarCurr) ) ).

tff(addAssignment_37867,axiom,
    ! [VarCurr: state_type] :
      ( v65305(VarCurr)
    <=> v62876(VarCurr,112) ) ).

tff(addAssignment_37866,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,112)
    <=> v62934(VarCurr,112) ) ).

tff(addAssignment_37865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65278(VarCurr,B)
      <=> v65280(VarCurr,B) ) ) ).

tff(addAssignment_37864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65280(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37863,axiom,
    ! [VarCurr: state_type] :
      ( v65264(VarCurr)
    <=> v65266(VarCurr) ) ).

tff(addAssignment_37862,axiom,
    ! [VarCurr: state_type] :
      ( v65266(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_37861,axiom,
    ! [VarCurr: state_type] :
      ( v64464(VarCurr)
    <=> v65034(VarCurr) ) ).

tff(addAssignment_37860,axiom,
    ! [VarCurr: state_type] :
      ( v65034(VarCurr)
    <=> v65036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6082,axiom,
    ! [VarCurr: state_type] :
      ( v65036(VarCurr)
    <=> ( v65038(VarCurr)
        & v65057(VarCurr) ) ) ).

tff(addAssignment_37859,axiom,
    ! [VarCurr: state_type] :
      ( v65057(VarCurr)
    <=> v65059(VarCurr) ) ).

tff(addAssignment_37858,axiom,
    ! [VarCurr: state_type] :
      ( v65059(VarCurr)
    <=> v65061(VarCurr) ) ).

tff(addAssignment_37857,axiom,
    ! [VarCurr: state_type] :
      ( v65061(VarCurr)
    <=> v65063(VarCurr) ) ).

tff(addAssignment_37856,axiom,
    ! [VarCurr: state_type] :
      ( v65063(VarCurr)
    <=> v65065(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_265,axiom,
    ! [VarCurr: state_type] :
      ( v65065(VarCurr)
    <=> ( ( v65067(VarCurr,3)
        <=> v65071(VarCurr,3) )
        & ( v65067(VarCurr,2)
        <=> v65071(VarCurr,2) )
        & ( v65067(VarCurr,1)
        <=> v65071(VarCurr,1) )
        & ( v65067(VarCurr,0)
        <=> v65071(VarCurr,0) ) ) ) ).

tff(addAssignment_37855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65071(VarCurr,B)
      <=> v65073(VarCurr,B) ) ) ).

tff(addAssignment_37854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65073(VarCurr,B)
      <=> v65075(VarCurr,B) ) ) ).

tff(addAssignment_37853,axiom,
    ! [VarCurr: state_type] :
      ( ( v65075(VarCurr,3)
      <=> v62856(VarCurr,111) )
      & ( v65075(VarCurr,2)
      <=> v62856(VarCurr,110) )
      & ( v65075(VarCurr,1)
      <=> v62856(VarCurr,109) )
      & ( v65075(VarCurr,0)
      <=> v62856(VarCurr,108) ) ) ).

tff(addAssignment_37852,axiom,
    ! [VarCurr: state_type] :
      ( ( v62856(VarCurr,111)
      <=> v65077(VarCurr,55) )
      & ( v62856(VarCurr,110)
      <=> v65077(VarCurr,54) )
      & ( v62856(VarCurr,109)
      <=> v65077(VarCurr,53) )
      & ( v62856(VarCurr,108)
      <=> v65077(VarCurr,52) ) ) ).

tff(addAssignment_37851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v65077(VarCurr,B)
      <=> v65079(VarCurr,B) ) ) ).

tff(addAssignment_37850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v65079(VarCurr,B)
      <=> v65081(VarCurr,B) ) ) ).

tff(addAssignment_37849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v65081(VarCurr,B)
      <=> v65083(VarCurr,B) ) ) ).

tff(addAssignment_37848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v65083(VarCurr,B)
      <=> v65242(VarCurr,B) ) ) ).

tff(addAssignment_37847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65242(VarCurr,B)
      <=> v65255(VarCurr,B) ) ) ).

tff(addAssignment_37846,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,7)
      <=> v65254(VarCurr,3) )
      & ( v65242(VarCurr,6)
      <=> v65254(VarCurr,2) )
      & ( v65242(VarCurr,5)
      <=> v65254(VarCurr,1) )
      & ( v65242(VarCurr,4)
      <=> v65254(VarCurr,0) ) ) ).

tff(addAssignment_37845,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,11)
      <=> v65253(VarCurr,3) )
      & ( v65242(VarCurr,10)
      <=> v65253(VarCurr,2) )
      & ( v65242(VarCurr,9)
      <=> v65253(VarCurr,1) )
      & ( v65242(VarCurr,8)
      <=> v65253(VarCurr,0) ) ) ).

tff(addAssignment_37844,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,15)
      <=> v65252(VarCurr,3) )
      & ( v65242(VarCurr,14)
      <=> v65252(VarCurr,2) )
      & ( v65242(VarCurr,13)
      <=> v65252(VarCurr,1) )
      & ( v65242(VarCurr,12)
      <=> v65252(VarCurr,0) ) ) ).

tff(addAssignment_37843,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,19)
      <=> v65251(VarCurr,3) )
      & ( v65242(VarCurr,18)
      <=> v65251(VarCurr,2) )
      & ( v65242(VarCurr,17)
      <=> v65251(VarCurr,1) )
      & ( v65242(VarCurr,16)
      <=> v65251(VarCurr,0) ) ) ).

tff(addAssignment_37842,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,23)
      <=> v65250(VarCurr,3) )
      & ( v65242(VarCurr,22)
      <=> v65250(VarCurr,2) )
      & ( v65242(VarCurr,21)
      <=> v65250(VarCurr,1) )
      & ( v65242(VarCurr,20)
      <=> v65250(VarCurr,0) ) ) ).

tff(addAssignment_37841,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,27)
      <=> v65249(VarCurr,3) )
      & ( v65242(VarCurr,26)
      <=> v65249(VarCurr,2) )
      & ( v65242(VarCurr,25)
      <=> v65249(VarCurr,1) )
      & ( v65242(VarCurr,24)
      <=> v65249(VarCurr,0) ) ) ).

tff(addAssignment_37840,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,31)
      <=> v65248(VarCurr,3) )
      & ( v65242(VarCurr,30)
      <=> v65248(VarCurr,2) )
      & ( v65242(VarCurr,29)
      <=> v65248(VarCurr,1) )
      & ( v65242(VarCurr,28)
      <=> v65248(VarCurr,0) ) ) ).

tff(addAssignment_37839,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,35)
      <=> v65247(VarCurr,3) )
      & ( v65242(VarCurr,34)
      <=> v65247(VarCurr,2) )
      & ( v65242(VarCurr,33)
      <=> v65247(VarCurr,1) )
      & ( v65242(VarCurr,32)
      <=> v65247(VarCurr,0) ) ) ).

tff(addAssignment_37838,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,39)
      <=> v65246(VarCurr,3) )
      & ( v65242(VarCurr,38)
      <=> v65246(VarCurr,2) )
      & ( v65242(VarCurr,37)
      <=> v65246(VarCurr,1) )
      & ( v65242(VarCurr,36)
      <=> v65246(VarCurr,0) ) ) ).

tff(addAssignment_37837,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,43)
      <=> v65245(VarCurr,3) )
      & ( v65242(VarCurr,42)
      <=> v65245(VarCurr,2) )
      & ( v65242(VarCurr,41)
      <=> v65245(VarCurr,1) )
      & ( v65242(VarCurr,40)
      <=> v65245(VarCurr,0) ) ) ).

tff(addAssignment_37836,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,47)
      <=> v65244(VarCurr,3) )
      & ( v65242(VarCurr,46)
      <=> v65244(VarCurr,2) )
      & ( v65242(VarCurr,45)
      <=> v65244(VarCurr,1) )
      & ( v65242(VarCurr,44)
      <=> v65244(VarCurr,0) ) ) ).

tff(addAssignment_37835,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,51)
      <=> v65243(VarCurr,3) )
      & ( v65242(VarCurr,50)
      <=> v65243(VarCurr,2) )
      & ( v65242(VarCurr,49)
      <=> v65243(VarCurr,1) )
      & ( v65242(VarCurr,48)
      <=> v65243(VarCurr,0) ) ) ).

tff(addAssignment_37834,axiom,
    ! [VarCurr: state_type] :
      ( ( v65242(VarCurr,55)
      <=> v65085(VarCurr,3) )
      & ( v65242(VarCurr,54)
      <=> v65085(VarCurr,2) )
      & ( v65242(VarCurr,53)
      <=> v65085(VarCurr,1) )
      & ( v65242(VarCurr,52)
      <=> v65085(VarCurr,0) ) ) ).

tff(addAssignment_37833,axiom,
    ! [VarCurr: state_type] :
      ( v65085(VarCurr,3)
    <=> v65087(VarCurr) ) ).

tff(addAssignment_37832,axiom,
    ! [VarCurr: state_type] :
      ( v65085(VarCurr,2)
    <=> v65168(VarCurr) ) ).

tff(addAssignment_37831,axiom,
    ! [VarCurr: state_type] :
      ( v65085(VarCurr,1)
    <=> v65181(VarCurr) ) ).

tff(addAssignment_37830,axiom,
    ! [VarCurr: state_type] :
      ( v65085(VarCurr,0)
    <=> v65189(VarCurr) ) ).

tff(addAssignment_37829,axiom,
    ! [VarCurr: state_type] :
      ( v65189(VarCurr)
    <=> v65191(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6081,axiom,
    ! [VarCurr: state_type] :
      ( v65191(VarCurr)
    <=> ( v65193(VarCurr)
      <~> v65217(VarCurr) ) ) ).

tff(addAssignment_37828,axiom,
    ! [VarCurr: state_type] :
      ( v65217(VarCurr)
    <=> v65219(VarCurr) ) ).

tff(addAssignment_37827,axiom,
    ! [VarCurr: state_type] :
      ( v65219(VarCurr)
    <=> v62876(VarCurr,119) ) ).

tff(addAssignment_37826,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,119)
    <=> v62934(VarCurr,119) ) ).

tff(addAssignment_37825,axiom,
    ! [VarCurr: state_type] :
      ( v62937(VarCurr)
    <=> v65222(VarCurr) ) ).

tff(addAssignment_37824,axiom,
    ! [VarCurr: state_type] :
      ( v65222(VarCurr)
    <=> v65224(VarCurr) ) ).

tff(writeUnaryOperator_3234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65224(VarCurr)
    <=> v65226(VarCurr) ) ).

tff(addAssignment_37823,axiom,
    ! [VarCurr: state_type] :
      ( v65226(VarCurr)
    <=> v65228(VarCurr) ) ).

tff(addAssignment_37822,axiom,
    ! [VarCurr: state_type] :
      ( v65228(VarCurr)
    <=> v65230(VarCurr) ) ).

tff(addAssignment_37821,axiom,
    ! [VarCurr: state_type] :
      ( v65230(VarCurr)
    <=> v65232(VarCurr) ) ).

tff(addAssignment_37820,axiom,
    ! [VarCurr: state_type] :
      ( v65232(VarCurr)
    <=> v65234(VarCurr) ) ).

tff(writeUnaryOperator_3233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65234(VarCurr)
    <=> v65236(VarCurr) ) ).

tff(addAssignment_37819,axiom,
    ! [VarCurr: state_type] :
      ( v65236(VarCurr)
    <=> v65238(VarCurr) ) ).

tff(addAssignment_37818,axiom,
    ! [VarCurr: state_type] :
      ( v65238(VarCurr)
    <=> v62898(VarCurr,3) ) ).

tff(addAssignment_37817,axiom,
    ! [VarCurr: state_type] :
      ( v65193(VarCurr)
    <=> v65195(VarCurr) ) ).

tff(addAssignment_37816,axiom,
    ! [VarCurr: state_type] :
      ( v65195(VarCurr)
    <=> v65197(VarCurr) ) ).

tff(addAssignment_37815,axiom,
    ! [VarCurr: state_type] :
      ( v65197(VarCurr)
    <=> v65199(VarCurr) ) ).

tff(addAssignment_37814,axiom,
    ! [VarCurr: state_type] :
      ( v65199(VarCurr)
    <=> v65201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6080,axiom,
    ! [VarCurr: state_type] :
      ( v65201(VarCurr)
    <=> ( v65215(VarCurr)
      <~> v65211(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6079,axiom,
    ! [VarCurr: state_type] :
      ( v65215(VarCurr)
    <=> ( v65203(VarCurr)
      <~> v65207(VarCurr) ) ) ).

tff(addAssignment_37813,axiom,
    ! [VarCurr: state_type] :
      ( v65211(VarCurr)
    <=> v65213(VarCurr) ) ).

tff(addAssignment_37812,axiom,
    ! [VarCurr: state_type] :
      ( v65213(VarCurr)
    <=> v62876(VarCurr,118) ) ).

tff(addAssignment_37811,axiom,
    ! [VarCurr: state_type] :
      ( v65207(VarCurr)
    <=> v65209(VarCurr) ) ).

tff(addAssignment_37810,axiom,
    ! [VarCurr: state_type] :
      ( v65209(VarCurr)
    <=> v62876(VarCurr,117) ) ).

tff(addAssignment_37809,axiom,
    ! [VarCurr: state_type] :
      ( v65203(VarCurr)
    <=> v65205(VarCurr) ) ).

tff(addAssignment_37808,axiom,
    ! [VarCurr: state_type] :
      ( v65205(VarCurr)
    <=> v62876(VarCurr,116) ) ).

tff(addAssignment_37807,axiom,
    ! [VarCurr: state_type] :
      ( v65181(VarCurr)
    <=> v65183(VarCurr) ) ).

tff(addAssignment_37806,axiom,
    ! [VarCurr: state_type] :
      ( v65183(VarCurr)
    <=> v65185(VarCurr) ) ).

tff(addAssignment_37805,axiom,
    ! [VarCurr: state_type] :
      ( v65185(VarCurr)
    <=> v65187(VarCurr) ) ).

tff(addAssignment_37804,axiom,
    ! [VarCurr: state_type] :
      ( v65187(VarCurr)
    <=> v62876(VarCurr,116) ) ).

tff(addAssignment_37803,axiom,
    ! [VarCurr: state_type] :
      ( v65168(VarCurr)
    <=> v65170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6078,axiom,
    ! [VarCurr: state_type] :
      ( v65170(VarCurr)
    <=> ( v65172(VarCurr)
      <~> v65176(VarCurr) ) ) ).

tff(addAssignment_37802,axiom,
    ! [VarCurr: state_type] :
      ( v65176(VarCurr)
    <=> v65178(VarCurr) ) ).

tff(addAssignment_37801,axiom,
    ! [VarCurr: state_type] :
      ( v65178(VarCurr)
    <=> v62876(VarCurr,117) ) ).

tff(addAssignment_37800,axiom,
    ! [VarCurr: state_type] :
      ( v65172(VarCurr)
    <=> v65174(VarCurr) ) ).

tff(addAssignment_37799,axiom,
    ! [VarCurr: state_type] :
      ( v65174(VarCurr)
    <=> v62876(VarCurr,116) ) ).

tff(addAssignment_37798,axiom,
    ! [VarCurr: state_type] :
      ( v65087(VarCurr)
    <=> v65089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6077,axiom,
    ! [VarCurr: state_type] :
      ( v65089(VarCurr)
    <=> ( v65166(VarCurr)
      <~> v65141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6076,axiom,
    ! [VarCurr: state_type] :
      ( v65166(VarCurr)
    <=> ( v65091(VarCurr)
      <~> v65116(VarCurr) ) ) ).

tff(addAssignment_37797,axiom,
    ! [VarCurr: state_type] :
      ( v65141(VarCurr)
    <=> v65143(VarCurr) ) ).

tff(addAssignment_37796,axiom,
    ! [VarCurr: state_type] :
      ( v65143(VarCurr)
    <=> v62876(VarCurr,118) ) ).

tff(addAssignment_37795,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,118)
    <=> v62934(VarCurr,118) ) ).

tff(addAssignment_37794,axiom,
    ! [VarCurr: state_type] :
      ( v62938(VarCurr)
    <=> v65146(VarCurr) ) ).

tff(addAssignment_37793,axiom,
    ! [VarCurr: state_type] :
      ( v65146(VarCurr)
    <=> v65148(VarCurr) ) ).

tff(writeUnaryOperator_3232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65148(VarCurr)
    <=> v65150(VarCurr) ) ).

tff(addAssignment_37792,axiom,
    ! [VarCurr: state_type] :
      ( v65150(VarCurr)
    <=> v65152(VarCurr) ) ).

tff(addAssignment_37791,axiom,
    ! [VarCurr: state_type] :
      ( v65152(VarCurr)
    <=> v65154(VarCurr) ) ).

tff(addAssignment_37790,axiom,
    ! [VarCurr: state_type] :
      ( v65154(VarCurr)
    <=> v65156(VarCurr) ) ).

tff(addAssignment_37789,axiom,
    ! [VarCurr: state_type] :
      ( v65156(VarCurr)
    <=> v65158(VarCurr) ) ).

tff(writeUnaryOperator_3231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65158(VarCurr)
    <=> v65160(VarCurr) ) ).

tff(addAssignment_37788,axiom,
    ! [VarCurr: state_type] :
      ( v65160(VarCurr)
    <=> v65162(VarCurr) ) ).

tff(addAssignment_37787,axiom,
    ! [VarCurr: state_type] :
      ( v65162(VarCurr)
    <=> v62898(VarCurr,2) ) ).

tff(addAssignment_37786,axiom,
    ! [VarCurr: state_type] :
      ( v65116(VarCurr)
    <=> v65118(VarCurr) ) ).

tff(addAssignment_37785,axiom,
    ! [VarCurr: state_type] :
      ( v65118(VarCurr)
    <=> v62876(VarCurr,117) ) ).

tff(addAssignment_37784,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,117)
    <=> v62934(VarCurr,117) ) ).

tff(addAssignment_37783,axiom,
    ! [VarCurr: state_type] :
      ( v62939(VarCurr)
    <=> v65121(VarCurr) ) ).

tff(addAssignment_37782,axiom,
    ! [VarCurr: state_type] :
      ( v65121(VarCurr)
    <=> v65123(VarCurr) ) ).

tff(writeUnaryOperator_3230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65123(VarCurr)
    <=> v65125(VarCurr) ) ).

tff(addAssignment_37781,axiom,
    ! [VarCurr: state_type] :
      ( v65125(VarCurr)
    <=> v65127(VarCurr) ) ).

tff(addAssignment_37780,axiom,
    ! [VarCurr: state_type] :
      ( v65127(VarCurr)
    <=> v65129(VarCurr) ) ).

tff(addAssignment_37779,axiom,
    ! [VarCurr: state_type] :
      ( v65129(VarCurr)
    <=> v65131(VarCurr) ) ).

tff(addAssignment_37778,axiom,
    ! [VarCurr: state_type] :
      ( v65131(VarCurr)
    <=> v65133(VarCurr) ) ).

tff(writeUnaryOperator_3229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65133(VarCurr)
    <=> v65135(VarCurr) ) ).

tff(addAssignment_37777,axiom,
    ! [VarCurr: state_type] :
      ( v65135(VarCurr)
    <=> v65137(VarCurr) ) ).

tff(addAssignment_37776,axiom,
    ! [VarCurr: state_type] :
      ( v65137(VarCurr)
    <=> v62898(VarCurr,1) ) ).

tff(addAssignment_37775,axiom,
    ! [VarCurr: state_type] :
      ( v65091(VarCurr)
    <=> v65093(VarCurr) ) ).

tff(addAssignment_37774,axiom,
    ! [VarCurr: state_type] :
      ( v65093(VarCurr)
    <=> v62876(VarCurr,116) ) ).

tff(addAssignment_37773,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,116)
    <=> v62934(VarCurr,116) ) ).

tff(addAssignment_37772,axiom,
    ! [VarCurr: state_type] :
      ( v62940(VarCurr)
    <=> v65096(VarCurr) ) ).

tff(addAssignment_37771,axiom,
    ! [VarCurr: state_type] :
      ( v65096(VarCurr)
    <=> v65098(VarCurr) ) ).

tff(writeUnaryOperator_3228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65098(VarCurr)
    <=> v65100(VarCurr) ) ).

tff(addAssignment_37770,axiom,
    ! [VarCurr: state_type] :
      ( v65100(VarCurr)
    <=> v65102(VarCurr) ) ).

tff(addAssignment_37769,axiom,
    ! [VarCurr: state_type] :
      ( v65102(VarCurr)
    <=> v65104(VarCurr) ) ).

tff(addAssignment_37768,axiom,
    ! [VarCurr: state_type] :
      ( v65104(VarCurr)
    <=> v65106(VarCurr) ) ).

tff(addAssignment_37767,axiom,
    ! [VarCurr: state_type] :
      ( v65106(VarCurr)
    <=> v65108(VarCurr) ) ).

tff(writeUnaryOperator_3227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v65108(VarCurr)
    <=> v65110(VarCurr) ) ).

tff(addAssignment_37766,axiom,
    ! [VarCurr: state_type] :
      ( v65110(VarCurr)
    <=> v65112(VarCurr) ) ).

tff(addAssignment_37765,axiom,
    ! [VarCurr: state_type] :
      ( v65112(VarCurr)
    <=> v62898(VarCurr,0) ) ).

tff(addAssignment_37764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65067(VarCurr,B)
      <=> v65069(VarCurr,B) ) ) ).

tff(addAssignment_37763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v65069(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37762,axiom,
    ! [VarCurr: state_type] :
      ( v65038(VarCurr)
    <=> v65040(VarCurr) ) ).

tff(addAssignment_37761,axiom,
    ! [VarCurr: state_type] :
      ( v65040(VarCurr)
    <=> v65042(VarCurr) ) ).

tff(addAssignment_37760,axiom,
    ! [VarCurr: state_type] :
      ( v65042(VarCurr)
    <=> v65044(VarCurr) ) ).

tff(addAssignment_37759,axiom,
    ! [VarCurr: state_type] :
      ( v65044(VarCurr)
    <=> v65046(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6075,axiom,
    ! [VarCurr: state_type] :
      ( v65046(VarCurr)
    <=> ( v65048(VarCurr)
        & v65052(VarCurr) ) ) ).

tff(addAssignment_37758,axiom,
    ! [VarCurr: state_type] :
      ( v65052(VarCurr)
    <=> v65054(VarCurr) ) ).

tff(addAssignment_37757,axiom,
    ! [VarCurr: state_type] :
      ( v65054(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_37756,axiom,
    ! [VarCurr: state_type] :
      ( v65048(VarCurr)
    <=> v65050(VarCurr) ) ).

tff(addAssignment_37755,axiom,
    ! [VarCurr: state_type] :
      ( v65050(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_37754,axiom,
    ! [VarCurr: state_type] :
      ( v64967(VarCurr)
    <=> v64969(VarCurr) ) ).

tff(addAssignment_37753,axiom,
    ! [VarCurr: state_type] :
      ( v64969(VarCurr)
    <=> v5865(VarCurr,2) ) ).

tff(addAssignment_37752,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,2)
    <=> v64971(VarCurr) ) ).

tff(addAssignment_37751,axiom,
    ! [VarCurr: state_type] :
      ( v64971(VarCurr)
    <=> v64973(VarCurr) ) ).

tff(writeUnaryOperator_3226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64973(VarCurr)
    <=> v65007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6074,axiom,
    ! [VarCurr: state_type] :
      ( v65007(VarCurr)
    <=> ( v64975(VarCurr)
        | v65003(VarCurr) ) ) ).

tff(addAssignment_37750,axiom,
    ! [VarCurr: state_type] :
      ( v65003(VarCurr)
    <=> v65005(VarCurr) ) ).

tff(addAssignment_37749,axiom,
    ! [VarCurr: state_type] :
      ( v65005(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_37748,axiom,
    ! [VarCurr: state_type] :
      ( v64975(VarCurr)
    <=> v64977(VarCurr) ) ).

tff(addAssignment_37747,axiom,
    ! [VarCurr: state_type] :
      ( v64977(VarCurr)
    <=> v5875(VarCurr,2) ) ).

tff(addAssignment_37746,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,2)
    <=> v64979(VarCurr) ) ).

tff(addAssignment_37745,axiom,
    ! [VarCurr: state_type] :
      ( v64979(VarCurr)
    <=> v64981(VarCurr) ) ).

tff(writeUnaryOperator_3225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64981(VarCurr)
    <=> v64999(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6073,axiom,
    ! [VarCurr: state_type] :
      ( v64999(VarCurr)
    <=> ( v65000(VarCurr)
        & v64995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6072,axiom,
    ! [VarCurr: state_type] :
      ( v65000(VarCurr)
    <=> ( v65001(VarCurr)
        & v64991(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6071,axiom,
    ! [VarCurr: state_type] :
      ( v65001(VarCurr)
    <=> ( v64983(VarCurr)
        & v64987(VarCurr) ) ) ).

tff(addAssignment_37744,axiom,
    ! [VarCurr: state_type] :
      ( v64995(VarCurr)
    <=> v64997(VarCurr) ) ).

tff(addAssignment_37743,axiom,
    ! [VarCurr: state_type] :
      ( v64997(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_37742,axiom,
    ! [VarCurr: state_type] :
      ( v64991(VarCurr)
    <=> v64993(VarCurr) ) ).

tff(addAssignment_37741,axiom,
    ! [VarCurr: state_type] :
      ( v64993(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_37740,axiom,
    ! [VarCurr: state_type] :
      ( v64987(VarCurr)
    <=> v64989(VarCurr) ) ).

tff(addAssignment_37739,axiom,
    ! [VarCurr: state_type] :
      ( v64989(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_37738,axiom,
    ! [VarCurr: state_type] :
      ( v64983(VarCurr)
    <=> v64985(VarCurr) ) ).

tff(addAssignment_37737,axiom,
    ! [VarCurr: state_type] :
      ( v64985(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_37736,axiom,
    ! [VarCurr: state_type] :
      ( v62733(VarCurr)
    <=> v62735(VarCurr) ) ).

tff(addAssignment_37735,axiom,
    ! [VarCurr: state_type] :
      ( v62735(VarCurr)
    <=> v62737(VarCurr) ) ).

tff(addAssignment_37734,axiom,
    ! [VarCurr: state_type] :
      ( v62737(VarCurr)
    <=> v62739(VarCurr) ) ).

tff(addAssignment_37733,axiom,
    ! [VarCurr: state_type] :
      ( v62739(VarCurr)
    <=> v62741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6070,axiom,
    ! [VarCurr: state_type] :
      ( v62741(VarCurr)
    <=> ( v62743(VarCurr)
        & v62785(VarCurr) ) ) ).

tff(addAssignment_37732,axiom,
    ! [VarCurr: state_type] :
      ( v62785(VarCurr)
    <=> v62787(VarCurr) ) ).

tff(addAssignment_37731,axiom,
    ! [VarCurr: state_type] :
      ( v62787(VarCurr)
    <=> v62789(VarCurr) ) ).

tff(addAssignment_37730,axiom,
    ! [VarCurr: state_type] :
      ( v62789(VarCurr)
    <=> v62791(VarCurr) ) ).

tff(addAssignment_37729,axiom,
    ! [VarCurr: state_type] :
      ( v62791(VarCurr)
    <=> v62793(VarCurr) ) ).

tff(writeUnaryOperator_3224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62793(VarCurr)
    <=> v62795(VarCurr) ) ).

tff(addAssignment_37728,axiom,
    ! [VarCurr: state_type] :
      ( v62795(VarCurr)
    <=> v62797(VarCurr) ) ).

tff(addAssignment_37727,axiom,
    ! [VarCurr: state_type] :
      ( v62797(VarCurr)
    <=> v62799(VarCurr) ) ).

tff(addAssignment_37726,axiom,
    ! [VarCurr: state_type] :
      ( v62799(VarCurr)
    <=> v62801(VarCurr) ) ).

tff(addAssignment_37725,axiom,
    ! [VarCurr: state_type] :
      ( v62801(VarCurr)
    <=> v62803(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_264,axiom,
    ! [VarCurr: state_type] :
      ( v62803(VarCurr)
    <=> ( ( v62805(VarCurr,15)
        <=> v64481(VarCurr,15) )
        & ( v62805(VarCurr,14)
        <=> v64481(VarCurr,14) )
        & ( v62805(VarCurr,13)
        <=> v64481(VarCurr,13) )
        & ( v62805(VarCurr,12)
        <=> v64481(VarCurr,12) )
        & ( v62805(VarCurr,11)
        <=> v64481(VarCurr,11) )
        & ( v62805(VarCurr,10)
        <=> v64481(VarCurr,10) )
        & ( v62805(VarCurr,9)
        <=> v64481(VarCurr,9) )
        & ( v62805(VarCurr,8)
        <=> v64481(VarCurr,8) )
        & ( v62805(VarCurr,7)
        <=> v64481(VarCurr,7) )
        & ( v62805(VarCurr,6)
        <=> v64481(VarCurr,6) )
        & ( v62805(VarCurr,5)
        <=> v64481(VarCurr,5) )
        & ( v62805(VarCurr,4)
        <=> v64481(VarCurr,4) )
        & ( v62805(VarCurr,3)
        <=> v64481(VarCurr,3) )
        & ( v62805(VarCurr,2)
        <=> v64481(VarCurr,2) )
        & ( v62805(VarCurr,1)
        <=> v64481(VarCurr,1) )
        & ( v62805(VarCurr,0)
        <=> v64481(VarCurr,0) ) ) ) ).

tff(addAssignment_37724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v64481(VarCurr,B)
      <=> v64483(VarCurr,B) ) ) ).

tff(addAssignment_37723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v64483(VarCurr,B)
      <=> v64485(VarCurr,B) ) ) ).

tff(addAssignment_37722,axiom,
    ! [VarCurr: state_type] :
      ( v64483(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_37721,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,0)
    <=> v64922(VarCurr) ) ).

tff(addAssignment_37720,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,1)
    <=> v64892(VarCurr) ) ).

tff(addAssignment_37719,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,2)
    <=> v64862(VarCurr) ) ).

tff(addAssignment_37718,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,3)
    <=> v64832(VarCurr) ) ).

tff(addAssignment_37717,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,4)
    <=> v64802(VarCurr) ) ).

tff(addAssignment_37716,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,5)
    <=> v64772(VarCurr) ) ).

tff(addAssignment_37715,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,6)
    <=> v64742(VarCurr) ) ).

tff(addAssignment_37714,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,7)
    <=> v64712(VarCurr) ) ).

tff(addAssignment_37713,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,8)
    <=> v64682(VarCurr) ) ).

tff(addAssignment_37712,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,9)
    <=> v64652(VarCurr) ) ).

tff(addAssignment_37711,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,10)
    <=> v64622(VarCurr) ) ).

tff(addAssignment_37710,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,11)
    <=> v64592(VarCurr) ) ).

tff(addAssignment_37709,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,12)
    <=> v64562(VarCurr) ) ).

tff(addAssignment_37708,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,13)
    <=> v64532(VarCurr) ) ).

tff(addAssignment_37707,axiom,
    ! [VarCurr: state_type] :
      ( v64485(VarCurr,14)
    <=> v64487(VarCurr) ) ).

tff(addAssignment_37706,axiom,
    ! [VarCurr: state_type] :
      ( v64922(VarCurr)
    <=> v64924(VarCurr) ) ).

tff(addAssignment_37705,axiom,
    ! [VarCurr: state_type] :
      ( v64924(VarCurr)
    <=> v64926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6069,axiom,
    ! [VarCurr: state_type] :
      ( v64926(VarCurr)
    <=> ( v64928(VarCurr)
        & v64932(VarCurr) ) ) ).

tff(addAssignment_37704,axiom,
    ! [VarCurr: state_type] :
      ( v64932(VarCurr)
    <=> v64934(VarCurr) ) ).

tff(addAssignment_37703,axiom,
    ! [VarCurr: state_type] :
      ( v64934(VarCurr)
    <=> v64936(VarCurr) ) ).

tff(addAssignment_37702,axiom,
    ! [VarCurr: state_type] :
      ( v64936(VarCurr)
    <=> v64938(VarCurr) ) ).

tff(addAssignment_37701,axiom,
    ! [VarCurr: state_type] :
      ( v64938(VarCurr)
    <=> v64940(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_263,axiom,
    ! [VarCurr: state_type] :
      ( v64940(VarCurr)
    <=> ( ( v64942(VarCurr,3)
        <=> v64946(VarCurr,3) )
        & ( v64942(VarCurr,2)
        <=> v64946(VarCurr,2) )
        & ( v64942(VarCurr,1)
        <=> v64946(VarCurr,1) )
        & ( v64942(VarCurr,0)
        <=> v64946(VarCurr,0) ) ) ) ).

tff(addAssignment_37700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64946(VarCurr,B)
      <=> v64948(VarCurr,B) ) ) ).

tff(addAssignment_37699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64948(VarCurr,B)
      <=> v62097(VarCurr,B) ) ) ).

tff(addAssignment_37698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64942(VarCurr,B)
      <=> v64944(VarCurr,B) ) ) ).

tff(addAssignment_37697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64944(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37696,axiom,
    ! [VarCurr: state_type] :
      ( v64928(VarCurr)
    <=> v64930(VarCurr) ) ).

tff(addAssignment_37695,axiom,
    ! [VarCurr: state_type] :
      ( v64930(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37694,axiom,
    ! [VarCurr: state_type] :
      ( v64892(VarCurr)
    <=> v64894(VarCurr) ) ).

tff(addAssignment_37693,axiom,
    ! [VarCurr: state_type] :
      ( v64894(VarCurr)
    <=> v64896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6068,axiom,
    ! [VarCurr: state_type] :
      ( v64896(VarCurr)
    <=> ( v64898(VarCurr)
        & v64902(VarCurr) ) ) ).

tff(addAssignment_37692,axiom,
    ! [VarCurr: state_type] :
      ( v64902(VarCurr)
    <=> v64904(VarCurr) ) ).

tff(addAssignment_37691,axiom,
    ! [VarCurr: state_type] :
      ( v64904(VarCurr)
    <=> v64906(VarCurr) ) ).

tff(addAssignment_37690,axiom,
    ! [VarCurr: state_type] :
      ( v64906(VarCurr)
    <=> v64908(VarCurr) ) ).

tff(addAssignment_37689,axiom,
    ! [VarCurr: state_type] :
      ( v64908(VarCurr)
    <=> v64910(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_262,axiom,
    ! [VarCurr: state_type] :
      ( v64910(VarCurr)
    <=> ( ( v64912(VarCurr,3)
        <=> v64916(VarCurr,3) )
        & ( v64912(VarCurr,2)
        <=> v64916(VarCurr,2) )
        & ( v64912(VarCurr,1)
        <=> v64916(VarCurr,1) )
        & ( v64912(VarCurr,0)
        <=> v64916(VarCurr,0) ) ) ) ).

tff(addAssignment_37688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64916(VarCurr,B)
      <=> v64918(VarCurr,B) ) ) ).

tff(addAssignment_37687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64918(VarCurr,B)
      <=> v63689(VarCurr,B) ) ) ).

tff(addAssignment_37686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64912(VarCurr,B)
      <=> v64914(VarCurr,B) ) ) ).

tff(addAssignment_37685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64914(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37684,axiom,
    ! [VarCurr: state_type] :
      ( v64898(VarCurr)
    <=> v64900(VarCurr) ) ).

tff(addAssignment_37683,axiom,
    ! [VarCurr: state_type] :
      ( v64900(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37682,axiom,
    ! [VarCurr: state_type] :
      ( v64862(VarCurr)
    <=> v64864(VarCurr) ) ).

tff(addAssignment_37681,axiom,
    ! [VarCurr: state_type] :
      ( v64864(VarCurr)
    <=> v64866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6067,axiom,
    ! [VarCurr: state_type] :
      ( v64866(VarCurr)
    <=> ( v64868(VarCurr)
        & v64872(VarCurr) ) ) ).

tff(addAssignment_37680,axiom,
    ! [VarCurr: state_type] :
      ( v64872(VarCurr)
    <=> v64874(VarCurr) ) ).

tff(addAssignment_37679,axiom,
    ! [VarCurr: state_type] :
      ( v64874(VarCurr)
    <=> v64876(VarCurr) ) ).

tff(addAssignment_37678,axiom,
    ! [VarCurr: state_type] :
      ( v64876(VarCurr)
    <=> v64878(VarCurr) ) ).

tff(addAssignment_37677,axiom,
    ! [VarCurr: state_type] :
      ( v64878(VarCurr)
    <=> v64880(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_261,axiom,
    ! [VarCurr: state_type] :
      ( v64880(VarCurr)
    <=> ( ( v64882(VarCurr,3)
        <=> v64886(VarCurr,3) )
        & ( v64882(VarCurr,2)
        <=> v64886(VarCurr,2) )
        & ( v64882(VarCurr,1)
        <=> v64886(VarCurr,1) )
        & ( v64882(VarCurr,0)
        <=> v64886(VarCurr,0) ) ) ) ).

tff(addAssignment_37676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64886(VarCurr,B)
      <=> v64888(VarCurr,B) ) ) ).

tff(addAssignment_37675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64888(VarCurr,B)
      <=> v63154(VarCurr,B) ) ) ).

tff(addAssignment_37674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64882(VarCurr,B)
      <=> v64884(VarCurr,B) ) ) ).

tff(addAssignment_37673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64884(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37672,axiom,
    ! [VarCurr: state_type] :
      ( v64868(VarCurr)
    <=> v64870(VarCurr) ) ).

tff(addAssignment_37671,axiom,
    ! [VarCurr: state_type] :
      ( v64870(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37670,axiom,
    ! [VarCurr: state_type] :
      ( v64832(VarCurr)
    <=> v64834(VarCurr) ) ).

tff(addAssignment_37669,axiom,
    ! [VarCurr: state_type] :
      ( v64834(VarCurr)
    <=> v64836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6066,axiom,
    ! [VarCurr: state_type] :
      ( v64836(VarCurr)
    <=> ( v64838(VarCurr)
        & v64842(VarCurr) ) ) ).

tff(addAssignment_37668,axiom,
    ! [VarCurr: state_type] :
      ( v64842(VarCurr)
    <=> v64844(VarCurr) ) ).

tff(addAssignment_37667,axiom,
    ! [VarCurr: state_type] :
      ( v64844(VarCurr)
    <=> v64846(VarCurr) ) ).

tff(addAssignment_37666,axiom,
    ! [VarCurr: state_type] :
      ( v64846(VarCurr)
    <=> v64848(VarCurr) ) ).

tff(addAssignment_37665,axiom,
    ! [VarCurr: state_type] :
      ( v64848(VarCurr)
    <=> v64850(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_260,axiom,
    ! [VarCurr: state_type] :
      ( v64850(VarCurr)
    <=> ( ( v64852(VarCurr,3)
        <=> v64856(VarCurr,3) )
        & ( v64852(VarCurr,2)
        <=> v64856(VarCurr,2) )
        & ( v64852(VarCurr,1)
        <=> v64856(VarCurr,1) )
        & ( v64852(VarCurr,0)
        <=> v64856(VarCurr,0) ) ) ) ).

tff(addAssignment_37664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64856(VarCurr,B)
      <=> v64858(VarCurr,B) ) ) ).

tff(addAssignment_37663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64858(VarCurr,B)
      <=> v63269(VarCurr,B) ) ) ).

tff(addAssignment_37662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64852(VarCurr,B)
      <=> v64854(VarCurr,B) ) ) ).

tff(addAssignment_37661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64854(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37660,axiom,
    ! [VarCurr: state_type] :
      ( v64838(VarCurr)
    <=> v64840(VarCurr) ) ).

tff(addAssignment_37659,axiom,
    ! [VarCurr: state_type] :
      ( v64840(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37658,axiom,
    ! [VarCurr: state_type] :
      ( v64802(VarCurr)
    <=> v64804(VarCurr) ) ).

tff(addAssignment_37657,axiom,
    ! [VarCurr: state_type] :
      ( v64804(VarCurr)
    <=> v64806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6065,axiom,
    ! [VarCurr: state_type] :
      ( v64806(VarCurr)
    <=> ( v64808(VarCurr)
        & v64812(VarCurr) ) ) ).

tff(addAssignment_37656,axiom,
    ! [VarCurr: state_type] :
      ( v64812(VarCurr)
    <=> v64814(VarCurr) ) ).

tff(addAssignment_37655,axiom,
    ! [VarCurr: state_type] :
      ( v64814(VarCurr)
    <=> v64816(VarCurr) ) ).

tff(addAssignment_37654,axiom,
    ! [VarCurr: state_type] :
      ( v64816(VarCurr)
    <=> v64818(VarCurr) ) ).

tff(addAssignment_37653,axiom,
    ! [VarCurr: state_type] :
      ( v64818(VarCurr)
    <=> v64820(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_259,axiom,
    ! [VarCurr: state_type] :
      ( v64820(VarCurr)
    <=> ( ( v64822(VarCurr,3)
        <=> v64826(VarCurr,3) )
        & ( v64822(VarCurr,2)
        <=> v64826(VarCurr,2) )
        & ( v64822(VarCurr,1)
        <=> v64826(VarCurr,1) )
        & ( v64822(VarCurr,0)
        <=> v64826(VarCurr,0) ) ) ) ).

tff(addAssignment_37652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64826(VarCurr,B)
      <=> v64828(VarCurr,B) ) ) ).

tff(addAssignment_37651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64828(VarCurr,B)
      <=> v63479(VarCurr,B) ) ) ).

tff(addAssignment_37650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64822(VarCurr,B)
      <=> v64824(VarCurr,B) ) ) ).

tff(addAssignment_37649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64824(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37648,axiom,
    ! [VarCurr: state_type] :
      ( v64808(VarCurr)
    <=> v64810(VarCurr) ) ).

tff(addAssignment_37647,axiom,
    ! [VarCurr: state_type] :
      ( v64810(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37646,axiom,
    ! [VarCurr: state_type] :
      ( v64772(VarCurr)
    <=> v64774(VarCurr) ) ).

tff(addAssignment_37645,axiom,
    ! [VarCurr: state_type] :
      ( v64774(VarCurr)
    <=> v64776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6064,axiom,
    ! [VarCurr: state_type] :
      ( v64776(VarCurr)
    <=> ( v64778(VarCurr)
        & v64782(VarCurr) ) ) ).

tff(addAssignment_37644,axiom,
    ! [VarCurr: state_type] :
      ( v64782(VarCurr)
    <=> v64784(VarCurr) ) ).

tff(addAssignment_37643,axiom,
    ! [VarCurr: state_type] :
      ( v64784(VarCurr)
    <=> v64786(VarCurr) ) ).

tff(addAssignment_37642,axiom,
    ! [VarCurr: state_type] :
      ( v64786(VarCurr)
    <=> v64788(VarCurr) ) ).

tff(addAssignment_37641,axiom,
    ! [VarCurr: state_type] :
      ( v64788(VarCurr)
    <=> v64790(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_258,axiom,
    ! [VarCurr: state_type] :
      ( v64790(VarCurr)
    <=> ( ( v64792(VarCurr,3)
        <=> v64796(VarCurr,3) )
        & ( v64792(VarCurr,2)
        <=> v64796(VarCurr,2) )
        & ( v64792(VarCurr,1)
        <=> v64796(VarCurr,1) )
        & ( v64792(VarCurr,0)
        <=> v64796(VarCurr,0) ) ) ) ).

tff(addAssignment_37640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64796(VarCurr,B)
      <=> v64798(VarCurr,B) ) ) ).

tff(addAssignment_37639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64798(VarCurr,B)
      <=> v63879(VarCurr,B) ) ) ).

tff(addAssignment_37638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64792(VarCurr,B)
      <=> v64794(VarCurr,B) ) ) ).

tff(addAssignment_37637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64794(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37636,axiom,
    ! [VarCurr: state_type] :
      ( v64778(VarCurr)
    <=> v64780(VarCurr) ) ).

tff(addAssignment_37635,axiom,
    ! [VarCurr: state_type] :
      ( v64780(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37634,axiom,
    ! [VarCurr: state_type] :
      ( v64742(VarCurr)
    <=> v64744(VarCurr) ) ).

tff(addAssignment_37633,axiom,
    ! [VarCurr: state_type] :
      ( v64744(VarCurr)
    <=> v64746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6063,axiom,
    ! [VarCurr: state_type] :
      ( v64746(VarCurr)
    <=> ( v64748(VarCurr)
        & v64752(VarCurr) ) ) ).

tff(addAssignment_37632,axiom,
    ! [VarCurr: state_type] :
      ( v64752(VarCurr)
    <=> v64754(VarCurr) ) ).

tff(addAssignment_37631,axiom,
    ! [VarCurr: state_type] :
      ( v64754(VarCurr)
    <=> v64756(VarCurr) ) ).

tff(addAssignment_37630,axiom,
    ! [VarCurr: state_type] :
      ( v64756(VarCurr)
    <=> v64758(VarCurr) ) ).

tff(addAssignment_37629,axiom,
    ! [VarCurr: state_type] :
      ( v64758(VarCurr)
    <=> v64760(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_257,axiom,
    ! [VarCurr: state_type] :
      ( v64760(VarCurr)
    <=> ( ( v64762(VarCurr,3)
        <=> v64766(VarCurr,3) )
        & ( v64762(VarCurr,2)
        <=> v64766(VarCurr,2) )
        & ( v64762(VarCurr,1)
        <=> v64766(VarCurr,1) )
        & ( v64762(VarCurr,0)
        <=> v64766(VarCurr,0) ) ) ) ).

tff(addAssignment_37628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64766(VarCurr,B)
      <=> v64768(VarCurr,B) ) ) ).

tff(addAssignment_37627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64768(VarCurr,B)
      <=> v63999(VarCurr,B) ) ) ).

tff(addAssignment_37626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64762(VarCurr,B)
      <=> v64764(VarCurr,B) ) ) ).

tff(addAssignment_37625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64764(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37624,axiom,
    ! [VarCurr: state_type] :
      ( v64748(VarCurr)
    <=> v64750(VarCurr) ) ).

tff(addAssignment_37623,axiom,
    ! [VarCurr: state_type] :
      ( v64750(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37622,axiom,
    ! [VarCurr: state_type] :
      ( v64712(VarCurr)
    <=> v64714(VarCurr) ) ).

tff(addAssignment_37621,axiom,
    ! [VarCurr: state_type] :
      ( v64714(VarCurr)
    <=> v64716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6062,axiom,
    ! [VarCurr: state_type] :
      ( v64716(VarCurr)
    <=> ( v64718(VarCurr)
        & v64722(VarCurr) ) ) ).

tff(addAssignment_37620,axiom,
    ! [VarCurr: state_type] :
      ( v64722(VarCurr)
    <=> v64724(VarCurr) ) ).

tff(addAssignment_37619,axiom,
    ! [VarCurr: state_type] :
      ( v64724(VarCurr)
    <=> v64726(VarCurr) ) ).

tff(addAssignment_37618,axiom,
    ! [VarCurr: state_type] :
      ( v64726(VarCurr)
    <=> v64728(VarCurr) ) ).

tff(addAssignment_37617,axiom,
    ! [VarCurr: state_type] :
      ( v64728(VarCurr)
    <=> v64730(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_256,axiom,
    ! [VarCurr: state_type] :
      ( v64730(VarCurr)
    <=> ( ( v64732(VarCurr,3)
        <=> v64736(VarCurr,3) )
        & ( v64732(VarCurr,2)
        <=> v64736(VarCurr,2) )
        & ( v64732(VarCurr,1)
        <=> v64736(VarCurr,1) )
        & ( v64732(VarCurr,0)
        <=> v64736(VarCurr,0) ) ) ) ).

tff(addAssignment_37616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64736(VarCurr,B)
      <=> v64738(VarCurr,B) ) ) ).

tff(addAssignment_37615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64738(VarCurr,B)
      <=> v62854(VarCurr,B) ) ) ).

tff(addAssignment_37614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64732(VarCurr,B)
      <=> v64734(VarCurr,B) ) ) ).

tff(addAssignment_37613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64734(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37612,axiom,
    ! [VarCurr: state_type] :
      ( v64718(VarCurr)
    <=> v64720(VarCurr) ) ).

tff(addAssignment_37611,axiom,
    ! [VarCurr: state_type] :
      ( v64720(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37610,axiom,
    ! [VarCurr: state_type] :
      ( v64682(VarCurr)
    <=> v64684(VarCurr) ) ).

tff(addAssignment_37609,axiom,
    ! [VarCurr: state_type] :
      ( v64684(VarCurr)
    <=> v64686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6061,axiom,
    ! [VarCurr: state_type] :
      ( v64686(VarCurr)
    <=> ( v64688(VarCurr)
        & v64692(VarCurr) ) ) ).

tff(addAssignment_37608,axiom,
    ! [VarCurr: state_type] :
      ( v64692(VarCurr)
    <=> v64694(VarCurr) ) ).

tff(addAssignment_37607,axiom,
    ! [VarCurr: state_type] :
      ( v64694(VarCurr)
    <=> v64696(VarCurr) ) ).

tff(addAssignment_37606,axiom,
    ! [VarCurr: state_type] :
      ( v64696(VarCurr)
    <=> v64698(VarCurr) ) ).

tff(addAssignment_37605,axiom,
    ! [VarCurr: state_type] :
      ( v64698(VarCurr)
    <=> v64700(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_255,axiom,
    ! [VarCurr: state_type] :
      ( v64700(VarCurr)
    <=> ( ( v64702(VarCurr,3)
        <=> v64706(VarCurr,3) )
        & ( v64702(VarCurr,2)
        <=> v64706(VarCurr,2) )
        & ( v64702(VarCurr,1)
        <=> v64706(VarCurr,1) )
        & ( v64702(VarCurr,0)
        <=> v64706(VarCurr,0) ) ) ) ).

tff(addAssignment_37604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64706(VarCurr,B)
      <=> v64708(VarCurr,B) ) ) ).

tff(addAssignment_37603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64708(VarCurr,B)
      <=> v64389(VarCurr,B) ) ) ).

tff(addAssignment_37602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64702(VarCurr,B)
      <=> v64704(VarCurr,B) ) ) ).

tff(addAssignment_37601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64704(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37600,axiom,
    ! [VarCurr: state_type] :
      ( v64688(VarCurr)
    <=> v64690(VarCurr) ) ).

tff(addAssignment_37599,axiom,
    ! [VarCurr: state_type] :
      ( v64690(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37598,axiom,
    ! [VarCurr: state_type] :
      ( v64652(VarCurr)
    <=> v64654(VarCurr) ) ).

tff(addAssignment_37597,axiom,
    ! [VarCurr: state_type] :
      ( v64654(VarCurr)
    <=> v64656(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6060,axiom,
    ! [VarCurr: state_type] :
      ( v64656(VarCurr)
    <=> ( v64658(VarCurr)
        & v64662(VarCurr) ) ) ).

tff(addAssignment_37596,axiom,
    ! [VarCurr: state_type] :
      ( v64662(VarCurr)
    <=> v64664(VarCurr) ) ).

tff(addAssignment_37595,axiom,
    ! [VarCurr: state_type] :
      ( v64664(VarCurr)
    <=> v64666(VarCurr) ) ).

tff(addAssignment_37594,axiom,
    ! [VarCurr: state_type] :
      ( v64666(VarCurr)
    <=> v64668(VarCurr) ) ).

tff(addAssignment_37593,axiom,
    ! [VarCurr: state_type] :
      ( v64668(VarCurr)
    <=> v64670(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_254,axiom,
    ! [VarCurr: state_type] :
      ( v64670(VarCurr)
    <=> ( ( v64672(VarCurr,3)
        <=> v64676(VarCurr,3) )
        & ( v64672(VarCurr,2)
        <=> v64676(VarCurr,2) )
        & ( v64672(VarCurr,1)
        <=> v64676(VarCurr,1) )
        & ( v64672(VarCurr,0)
        <=> v64676(VarCurr,0) ) ) ) ).

tff(addAssignment_37592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64676(VarCurr,B)
      <=> v64678(VarCurr,B) ) ) ).

tff(addAssignment_37591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64678(VarCurr,B)
      <=> v63349(VarCurr,B) ) ) ).

tff(addAssignment_37590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64672(VarCurr,B)
      <=> v64674(VarCurr,B) ) ) ).

tff(addAssignment_37589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64674(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37588,axiom,
    ! [VarCurr: state_type] :
      ( v64658(VarCurr)
    <=> v64660(VarCurr) ) ).

tff(addAssignment_37587,axiom,
    ! [VarCurr: state_type] :
      ( v64660(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37586,axiom,
    ! [VarCurr: state_type] :
      ( v64622(VarCurr)
    <=> v64624(VarCurr) ) ).

tff(addAssignment_37585,axiom,
    ! [VarCurr: state_type] :
      ( v64624(VarCurr)
    <=> v64626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6059,axiom,
    ! [VarCurr: state_type] :
      ( v64626(VarCurr)
    <=> ( v64628(VarCurr)
        & v64632(VarCurr) ) ) ).

tff(addAssignment_37584,axiom,
    ! [VarCurr: state_type] :
      ( v64632(VarCurr)
    <=> v64634(VarCurr) ) ).

tff(addAssignment_37583,axiom,
    ! [VarCurr: state_type] :
      ( v64634(VarCurr)
    <=> v64636(VarCurr) ) ).

tff(addAssignment_37582,axiom,
    ! [VarCurr: state_type] :
      ( v64636(VarCurr)
    <=> v64638(VarCurr) ) ).

tff(addAssignment_37581,axiom,
    ! [VarCurr: state_type] :
      ( v64638(VarCurr)
    <=> v64640(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_253,axiom,
    ! [VarCurr: state_type] :
      ( v64640(VarCurr)
    <=> ( ( v64642(VarCurr,3)
        <=> v64646(VarCurr,3) )
        & ( v64642(VarCurr,2)
        <=> v64646(VarCurr,2) )
        & ( v64642(VarCurr,1)
        <=> v64646(VarCurr,1) )
        & ( v64642(VarCurr,0)
        <=> v64646(VarCurr,0) ) ) ) ).

tff(addAssignment_37580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64646(VarCurr,B)
      <=> v64648(VarCurr,B) ) ) ).

tff(addAssignment_37579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64648(VarCurr,B)
      <=> v64089(VarCurr,B) ) ) ).

tff(addAssignment_37578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64642(VarCurr,B)
      <=> v64644(VarCurr,B) ) ) ).

tff(addAssignment_37577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64644(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37576,axiom,
    ! [VarCurr: state_type] :
      ( v64628(VarCurr)
    <=> v64630(VarCurr) ) ).

tff(addAssignment_37575,axiom,
    ! [VarCurr: state_type] :
      ( v64630(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37574,axiom,
    ! [VarCurr: state_type] :
      ( v64592(VarCurr)
    <=> v64594(VarCurr) ) ).

tff(addAssignment_37573,axiom,
    ! [VarCurr: state_type] :
      ( v64594(VarCurr)
    <=> v64596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6058,axiom,
    ! [VarCurr: state_type] :
      ( v64596(VarCurr)
    <=> ( v64598(VarCurr)
        & v64602(VarCurr) ) ) ).

tff(addAssignment_37572,axiom,
    ! [VarCurr: state_type] :
      ( v64602(VarCurr)
    <=> v64604(VarCurr) ) ).

tff(addAssignment_37571,axiom,
    ! [VarCurr: state_type] :
      ( v64604(VarCurr)
    <=> v64606(VarCurr) ) ).

tff(addAssignment_37570,axiom,
    ! [VarCurr: state_type] :
      ( v64606(VarCurr)
    <=> v64608(VarCurr) ) ).

tff(addAssignment_37569,axiom,
    ! [VarCurr: state_type] :
      ( v64608(VarCurr)
    <=> v64610(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_252,axiom,
    ! [VarCurr: state_type] :
      ( v64610(VarCurr)
    <=> ( ( v64612(VarCurr,3)
        <=> v64616(VarCurr,3) )
        & ( v64612(VarCurr,2)
        <=> v64616(VarCurr,2) )
        & ( v64612(VarCurr,1)
        <=> v64616(VarCurr,1) )
        & ( v64612(VarCurr,0)
        <=> v64616(VarCurr,0) ) ) ) ).

tff(addAssignment_37568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64616(VarCurr,B)
      <=> v64618(VarCurr,B) ) ) ).

tff(addAssignment_37567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64618(VarCurr,B)
      <=> v63574(VarCurr,B) ) ) ).

tff(addAssignment_37566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64612(VarCurr,B)
      <=> v64614(VarCurr,B) ) ) ).

tff(addAssignment_37565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64614(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37564,axiom,
    ! [VarCurr: state_type] :
      ( v64598(VarCurr)
    <=> v64600(VarCurr) ) ).

tff(addAssignment_37563,axiom,
    ! [VarCurr: state_type] :
      ( v64600(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37562,axiom,
    ! [VarCurr: state_type] :
      ( v64562(VarCurr)
    <=> v64564(VarCurr) ) ).

tff(addAssignment_37561,axiom,
    ! [VarCurr: state_type] :
      ( v64564(VarCurr)
    <=> v64566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6057,axiom,
    ! [VarCurr: state_type] :
      ( v64566(VarCurr)
    <=> ( v64568(VarCurr)
        & v64572(VarCurr) ) ) ).

tff(addAssignment_37560,axiom,
    ! [VarCurr: state_type] :
      ( v64572(VarCurr)
    <=> v64574(VarCurr) ) ).

tff(addAssignment_37559,axiom,
    ! [VarCurr: state_type] :
      ( v64574(VarCurr)
    <=> v64576(VarCurr) ) ).

tff(addAssignment_37558,axiom,
    ! [VarCurr: state_type] :
      ( v64576(VarCurr)
    <=> v64578(VarCurr) ) ).

tff(addAssignment_37557,axiom,
    ! [VarCurr: state_type] :
      ( v64578(VarCurr)
    <=> v64580(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_251,axiom,
    ! [VarCurr: state_type] :
      ( v64580(VarCurr)
    <=> ( ( v64582(VarCurr,3)
        <=> v64586(VarCurr,3) )
        & ( v64582(VarCurr,2)
        <=> v64586(VarCurr,2) )
        & ( v64582(VarCurr,1)
        <=> v64586(VarCurr,1) )
        & ( v64582(VarCurr,0)
        <=> v64586(VarCurr,0) ) ) ) ).

tff(addAssignment_37556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64586(VarCurr,B)
      <=> v64588(VarCurr,B) ) ) ).

tff(addAssignment_37555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64588(VarCurr,B)
      <=> v64184(VarCurr,B) ) ) ).

tff(addAssignment_37554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64582(VarCurr,B)
      <=> v64584(VarCurr,B) ) ) ).

tff(addAssignment_37553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64584(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37552,axiom,
    ! [VarCurr: state_type] :
      ( v64568(VarCurr)
    <=> v64570(VarCurr) ) ).

tff(addAssignment_37551,axiom,
    ! [VarCurr: state_type] :
      ( v64570(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37550,axiom,
    ! [VarCurr: state_type] :
      ( v64532(VarCurr)
    <=> v64534(VarCurr) ) ).

tff(addAssignment_37549,axiom,
    ! [VarCurr: state_type] :
      ( v64534(VarCurr)
    <=> v64536(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6056,axiom,
    ! [VarCurr: state_type] :
      ( v64536(VarCurr)
    <=> ( v64538(VarCurr)
        & v64542(VarCurr) ) ) ).

tff(addAssignment_37548,axiom,
    ! [VarCurr: state_type] :
      ( v64542(VarCurr)
    <=> v64544(VarCurr) ) ).

tff(addAssignment_37547,axiom,
    ! [VarCurr: state_type] :
      ( v64544(VarCurr)
    <=> v64546(VarCurr) ) ).

tff(addAssignment_37546,axiom,
    ! [VarCurr: state_type] :
      ( v64546(VarCurr)
    <=> v64548(VarCurr) ) ).

tff(addAssignment_37545,axiom,
    ! [VarCurr: state_type] :
      ( v64548(VarCurr)
    <=> v64550(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_250,axiom,
    ! [VarCurr: state_type] :
      ( v64550(VarCurr)
    <=> ( ( v64552(VarCurr,3)
        <=> v64556(VarCurr,3) )
        & ( v64552(VarCurr,2)
        <=> v64556(VarCurr,2) )
        & ( v64552(VarCurr,1)
        <=> v64556(VarCurr,1) )
        & ( v64552(VarCurr,0)
        <=> v64556(VarCurr,0) ) ) ) ).

tff(addAssignment_37544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64556(VarCurr,B)
      <=> v64558(VarCurr,B) ) ) ).

tff(addAssignment_37543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64558(VarCurr,B)
      <=> v64299(VarCurr,B) ) ) ).

tff(addAssignment_37542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64552(VarCurr,B)
      <=> v64554(VarCurr,B) ) ) ).

tff(addAssignment_37541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64554(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37540,axiom,
    ! [VarCurr: state_type] :
      ( v64538(VarCurr)
    <=> v64540(VarCurr) ) ).

tff(addAssignment_37539,axiom,
    ! [VarCurr: state_type] :
      ( v64540(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37538,axiom,
    ! [VarCurr: state_type] :
      ( v64487(VarCurr)
    <=> v64489(VarCurr) ) ).

tff(addAssignment_37537,axiom,
    ! [VarCurr: state_type] :
      ( v64489(VarCurr)
    <=> v64491(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6055,axiom,
    ! [VarCurr: state_type] :
      ( v64491(VarCurr)
    <=> ( v64493(VarCurr)
        & v64512(VarCurr) ) ) ).

tff(addAssignment_37536,axiom,
    ! [VarCurr: state_type] :
      ( v64512(VarCurr)
    <=> v64514(VarCurr) ) ).

tff(addAssignment_37535,axiom,
    ! [VarCurr: state_type] :
      ( v64514(VarCurr)
    <=> v64516(VarCurr) ) ).

tff(addAssignment_37534,axiom,
    ! [VarCurr: state_type] :
      ( v64516(VarCurr)
    <=> v64518(VarCurr) ) ).

tff(addAssignment_37533,axiom,
    ! [VarCurr: state_type] :
      ( v64518(VarCurr)
    <=> v64520(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_249,axiom,
    ! [VarCurr: state_type] :
      ( v64520(VarCurr)
    <=> ( ( v64522(VarCurr,3)
        <=> v64526(VarCurr,3) )
        & ( v64522(VarCurr,2)
        <=> v64526(VarCurr,2) )
        & ( v64522(VarCurr,1)
        <=> v64526(VarCurr,1) )
        & ( v64522(VarCurr,0)
        <=> v64526(VarCurr,0) ) ) ) ).

tff(addAssignment_37532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64526(VarCurr,B)
      <=> v64528(VarCurr,B) ) ) ).

tff(addAssignment_37531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64528(VarCurr,B)
      <=> v63759(VarCurr,B) ) ) ).

tff(addAssignment_37530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64522(VarCurr,B)
      <=> v64524(VarCurr,B) ) ) ).

tff(addAssignment_37529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64524(VarCurr,B)
      <=> v62357(VarCurr,B) ) ) ).

tff(addAssignment_37528,axiom,
    ! [VarCurr: state_type] :
      ( v64493(VarCurr)
    <=> v64495(VarCurr) ) ).

tff(addAssignment_37527,axiom,
    ! [VarCurr: state_type] :
      ( v64495(VarCurr)
    <=> v64497(VarCurr) ) ).

tff(addAssignment_37526,axiom,
    ! [VarCurr: state_type] :
      ( v64497(VarCurr)
    <=> v64499(VarCurr) ) ).

tff(addAssignment_37525,axiom,
    ! [VarCurr: state_type] :
      ( v64499(VarCurr)
    <=> v64501(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6054,axiom,
    ! [VarCurr: state_type] :
      ( v64501(VarCurr)
    <=> ( v64503(VarCurr)
        & v64507(VarCurr) ) ) ).

tff(addAssignment_37524,axiom,
    ! [VarCurr: state_type] :
      ( v64507(VarCurr)
    <=> v64509(VarCurr) ) ).

tff(addAssignment_37523,axiom,
    ! [VarCurr: state_type] :
      ( v64509(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_37522,axiom,
    ! [VarCurr: state_type] :
      ( v64503(VarCurr)
    <=> v64505(VarCurr) ) ).

tff(addAssignment_37521,axiom,
    ! [VarCurr: state_type] :
      ( v64505(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_37520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v62805(VarCurr,B)
      <=> v62807(VarCurr,B) ) ) ).

tff(addAssignment_37519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v62807(VarCurr,B)
      <=> v62809(VarCurr,B) ) ) ).

tff(addAssignment_37518,axiom,
    ! [VarCurr: state_type] :
      ( v62807(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_37517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v62809(VarCurr,B)
      <=> v64460(VarCurr,B) ) ) ).

tff(addAssignment_37516,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,0)
    <=> v64431(VarCurr) ) ).

tff(addAssignment_37515,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,1)
    <=> v64361(VarCurr) ) ).

tff(addAssignment_37514,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,2)
    <=> v64271(VarCurr) ) ).

tff(addAssignment_37513,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,3)
    <=> v64156(VarCurr) ) ).

tff(addAssignment_37512,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,4)
    <=> v64061(VarCurr) ) ).

tff(addAssignment_37511,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,5)
    <=> v63971(VarCurr) ) ).

tff(addAssignment_37510,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,6)
    <=> v63851(VarCurr) ) ).

tff(addAssignment_37509,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,7)
    <=> v63731(VarCurr) ) ).

tff(addAssignment_37508,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,8)
    <=> v63661(VarCurr) ) ).

tff(addAssignment_37507,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,9)
    <=> v63546(VarCurr) ) ).

tff(addAssignment_37506,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,10)
    <=> v63451(VarCurr) ) ).

tff(addAssignment_37505,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,11)
    <=> v63321(VarCurr) ) ).

tff(addAssignment_37504,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,12)
    <=> v63241(VarCurr) ) ).

tff(addAssignment_37503,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,13)
    <=> v63126(VarCurr) ) ).

tff(addAssignment_37502,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,14)
    <=> v62811(VarCurr) ) ).

tff(addAssignment_37501,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,15)
    <=> v64478(VarCurr) ) ).

tff(addAssignment_37500,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,16)
    <=> v64477(VarCurr) ) ).

tff(addAssignment_37499,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,17)
    <=> v64476(VarCurr) ) ).

tff(addAssignment_37498,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,18)
    <=> v64475(VarCurr) ) ).

tff(addAssignment_37497,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,19)
    <=> v64474(VarCurr) ) ).

tff(addAssignment_37496,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,20)
    <=> v64473(VarCurr) ) ).

tff(addAssignment_37495,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,21)
    <=> v64472(VarCurr) ) ).

tff(addAssignment_37494,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,22)
    <=> v64471(VarCurr) ) ).

tff(addAssignment_37493,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,23)
    <=> v64470(VarCurr) ) ).

tff(addAssignment_37492,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,24)
    <=> v64469(VarCurr) ) ).

tff(addAssignment_37491,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,25)
    <=> v64468(VarCurr) ) ).

tff(addAssignment_37490,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,26)
    <=> v64467(VarCurr) ) ).

tff(addAssignment_37489,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,27)
    <=> v64466(VarCurr) ) ).

tff(addAssignment_37488,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,28)
    <=> v64465(VarCurr) ) ).

tff(addAssignment_37487,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,29)
    <=> v64464(VarCurr) ) ).

tff(addAssignment_37486,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,30)
    <=> v64463(VarCurr) ) ).

tff(addAssignment_37485,axiom,
    ! [VarCurr: state_type] :
      ( v64460(VarCurr,31)
    <=> v64462(VarCurr) ) ).

tff(addAssignment_37484,axiom,
    ! [VarCurr: state_type] :
      ( ( v64460(VarCurr,35)
      <=> v64461(VarCurr,3) )
      & ( v64460(VarCurr,34)
      <=> v64461(VarCurr,2) )
      & ( v64460(VarCurr,33)
      <=> v64461(VarCurr,1) )
      & ( v64460(VarCurr,32)
      <=> v64461(VarCurr,0) ) ) ).

tff(addAssignment_37483,axiom,
    ! [VarCurr: state_type] :
      ( v64431(VarCurr)
    <=> v64433(VarCurr) ) ).

tff(addAssignment_37482,axiom,
    ! [VarCurr: state_type] :
      ( v64433(VarCurr)
    <=> v64435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6053,axiom,
    ! [VarCurr: state_type] :
      ( v64435(VarCurr)
    <=> ( v64437(VarCurr)
        & v64441(VarCurr) ) ) ).

tff(addAssignment_37481,axiom,
    ! [VarCurr: state_type] :
      ( v64441(VarCurr)
    <=> v64443(VarCurr) ) ).

tff(addAssignment_37480,axiom,
    ! [VarCurr: state_type] :
      ( v64443(VarCurr)
    <=> v64445(VarCurr) ) ).

tff(addAssignment_37479,axiom,
    ! [VarCurr: state_type] :
      ( v64445(VarCurr)
    <=> v64447(VarCurr) ) ).

tff(addAssignment_37478,axiom,
    ! [VarCurr: state_type] :
      ( v64447(VarCurr)
    <=> v64449(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_248,axiom,
    ! [VarCurr: state_type] :
      ( v64449(VarCurr)
    <=> ( ( v64451(VarCurr,3)
        <=> v64455(VarCurr,3) )
        & ( v64451(VarCurr,2)
        <=> v64455(VarCurr,2) )
        & ( v64451(VarCurr,1)
        <=> v64455(VarCurr,1) )
        & ( v64451(VarCurr,0)
        <=> v64455(VarCurr,0) ) ) ) ).

tff(addAssignment_37477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64455(VarCurr,B)
      <=> v64457(VarCurr,B) ) ) ).

tff(addAssignment_37476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64457(VarCurr,B)
      <=> v62097(VarCurr,B) ) ) ).

tff(addAssignment_37475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64451(VarCurr,B)
      <=> v64453(VarCurr,B) ) ) ).

tff(addAssignment_37474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64453(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37473,axiom,
    ! [VarCurr: state_type] :
      ( v64437(VarCurr)
    <=> v64439(VarCurr) ) ).

tff(addAssignment_37472,axiom,
    ! [VarCurr: state_type] :
      ( v64439(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37471,axiom,
    ! [VarCurr: state_type] :
      ( v64361(VarCurr)
    <=> v64363(VarCurr) ) ).

tff(addAssignment_37470,axiom,
    ! [VarCurr: state_type] :
      ( v64363(VarCurr)
    <=> v64365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6052,axiom,
    ! [VarCurr: state_type] :
      ( v64365(VarCurr)
    <=> ( v64367(VarCurr)
        & v64371(VarCurr) ) ) ).

tff(addAssignment_37469,axiom,
    ! [VarCurr: state_type] :
      ( v64371(VarCurr)
    <=> v64373(VarCurr) ) ).

tff(addAssignment_37468,axiom,
    ! [VarCurr: state_type] :
      ( v64373(VarCurr)
    <=> v64375(VarCurr) ) ).

tff(addAssignment_37467,axiom,
    ! [VarCurr: state_type] :
      ( v64375(VarCurr)
    <=> v64377(VarCurr) ) ).

tff(addAssignment_37466,axiom,
    ! [VarCurr: state_type] :
      ( v64377(VarCurr)
    <=> v64379(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_247,axiom,
    ! [VarCurr: state_type] :
      ( v64379(VarCurr)
    <=> ( ( v64381(VarCurr,3)
        <=> v64385(VarCurr,3) )
        & ( v64381(VarCurr,2)
        <=> v64385(VarCurr,2) )
        & ( v64381(VarCurr,1)
        <=> v64385(VarCurr,1) )
        & ( v64381(VarCurr,0)
        <=> v64385(VarCurr,0) ) ) ) ).

tff(addAssignment_37465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64385(VarCurr,B)
      <=> v64387(VarCurr,B) ) ) ).

tff(addAssignment_37464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64387(VarCurr,B)
      <=> v64389(VarCurr,B) ) ) ).

tff(addAssignment_37463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64389(VarCurr,B)
      <=> v62856(VarCurr,B) ) ) ).

tff(addAssignment_37462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37457,axiom,
    ! [VarCurr: state_type] :
      ( v63122(VarCurr,3)
    <=> v64392(VarCurr) ) ).

tff(addAssignment_37456,axiom,
    ! [VarCurr: state_type] :
      ( v63122(VarCurr,2)
    <=> v64400(VarCurr) ) ).

tff(addAssignment_37455,axiom,
    ! [VarCurr: state_type] :
      ( v63122(VarCurr,1)
    <=> v64408(VarCurr) ) ).

tff(addAssignment_37454,axiom,
    ! [VarCurr: state_type] :
      ( v63122(VarCurr,0)
    <=> v64421(VarCurr) ) ).

tff(addAssignment_37453,axiom,
    ! [VarCurr: state_type] :
      ( v64421(VarCurr)
    <=> v64423(VarCurr) ) ).

tff(addAssignment_37452,axiom,
    ! [VarCurr: state_type] :
      ( v64423(VarCurr)
    <=> v64425(VarCurr) ) ).

tff(addAssignment_37451,axiom,
    ! [VarCurr: state_type] :
      ( v64425(VarCurr)
    <=> v64427(VarCurr) ) ).

tff(addAssignment_37450,axiom,
    ! [VarCurr: state_type] :
      ( v64427(VarCurr)
    <=> v62876(VarCurr,7) ) ).

tff(addAssignment_37449,axiom,
    ! [VarCurr: state_type] :
      ( v64408(VarCurr)
    <=> v64410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6051,axiom,
    ! [VarCurr: state_type] :
      ( v64410(VarCurr)
    <=> ( v64412(VarCurr)
      <~> v64416(VarCurr) ) ) ).

tff(addAssignment_37448,axiom,
    ! [VarCurr: state_type] :
      ( v64416(VarCurr)
    <=> v64418(VarCurr) ) ).

tff(addAssignment_37447,axiom,
    ! [VarCurr: state_type] :
      ( v64418(VarCurr)
    <=> v62876(VarCurr,7) ) ).

tff(addAssignment_37446,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,7)
    <=> v62934(VarCurr,7) ) ).

tff(addAssignment_37445,axiom,
    ! [VarCurr: state_type] :
      ( v64412(VarCurr)
    <=> v64414(VarCurr) ) ).

tff(addAssignment_37444,axiom,
    ! [VarCurr: state_type] :
      ( v64414(VarCurr)
    <=> v62876(VarCurr,4) ) ).

tff(addAssignment_37443,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,4)
    <=> v62934(VarCurr,4) ) ).

tff(addAssignment_37442,axiom,
    ! [VarCurr: state_type] :
      ( v64400(VarCurr)
    <=> v64402(VarCurr) ) ).

tff(addAssignment_37441,axiom,
    ! [VarCurr: state_type] :
      ( v64402(VarCurr)
    <=> v64404(VarCurr) ) ).

tff(addAssignment_37440,axiom,
    ! [VarCurr: state_type] :
      ( v64404(VarCurr)
    <=> v64406(VarCurr) ) ).

tff(addAssignment_37439,axiom,
    ! [VarCurr: state_type] :
      ( v64406(VarCurr)
    <=> v62876(VarCurr,5) ) ).

tff(addAssignment_37438,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,5)
    <=> v62934(VarCurr,5) ) ).

tff(addAssignment_37437,axiom,
    ! [VarCurr: state_type] :
      ( v64392(VarCurr)
    <=> v64394(VarCurr) ) ).

tff(addAssignment_37436,axiom,
    ! [VarCurr: state_type] :
      ( v64394(VarCurr)
    <=> v64396(VarCurr) ) ).

tff(addAssignment_37435,axiom,
    ! [VarCurr: state_type] :
      ( v64396(VarCurr)
    <=> v64398(VarCurr) ) ).

tff(addAssignment_37434,axiom,
    ! [VarCurr: state_type] :
      ( v64398(VarCurr)
    <=> v62876(VarCurr,6) ) ).

tff(addAssignment_37433,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,6)
    <=> v62934(VarCurr,6) ) ).

tff(addAssignment_37432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64381(VarCurr,B)
      <=> v64383(VarCurr,B) ) ) ).

tff(addAssignment_37431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64383(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37430,axiom,
    ! [VarCurr: state_type] :
      ( v64367(VarCurr)
    <=> v64369(VarCurr) ) ).

tff(addAssignment_37429,axiom,
    ! [VarCurr: state_type] :
      ( v64369(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37428,axiom,
    ! [VarCurr: state_type] :
      ( v64271(VarCurr)
    <=> v64273(VarCurr) ) ).

tff(addAssignment_37427,axiom,
    ! [VarCurr: state_type] :
      ( v64273(VarCurr)
    <=> v64275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6050,axiom,
    ! [VarCurr: state_type] :
      ( v64275(VarCurr)
    <=> ( v64277(VarCurr)
        & v64281(VarCurr) ) ) ).

tff(addAssignment_37426,axiom,
    ! [VarCurr: state_type] :
      ( v64281(VarCurr)
    <=> v64283(VarCurr) ) ).

tff(addAssignment_37425,axiom,
    ! [VarCurr: state_type] :
      ( v64283(VarCurr)
    <=> v64285(VarCurr) ) ).

tff(addAssignment_37424,axiom,
    ! [VarCurr: state_type] :
      ( v64285(VarCurr)
    <=> v64287(VarCurr) ) ).

tff(addAssignment_37423,axiom,
    ! [VarCurr: state_type] :
      ( v64287(VarCurr)
    <=> v64289(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_246,axiom,
    ! [VarCurr: state_type] :
      ( v64289(VarCurr)
    <=> ( ( v64291(VarCurr,3)
        <=> v64295(VarCurr,3) )
        & ( v64291(VarCurr,2)
        <=> v64295(VarCurr,2) )
        & ( v64291(VarCurr,1)
        <=> v64295(VarCurr,1) )
        & ( v64291(VarCurr,0)
        <=> v64295(VarCurr,0) ) ) ) ).

tff(addAssignment_37422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64295(VarCurr,B)
      <=> v64297(VarCurr,B) ) ) ).

tff(addAssignment_37421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64297(VarCurr,B)
      <=> v64299(VarCurr,B) ) ) ).

tff(addAssignment_37420,axiom,
    ! [VarCurr: state_type] :
      ( ( v64299(VarCurr,3)
      <=> v62856(VarCurr,7) )
      & ( v64299(VarCurr,2)
      <=> v62856(VarCurr,6) )
      & ( v64299(VarCurr,1)
      <=> v62856(VarCurr,5) )
      & ( v64299(VarCurr,0)
      <=> v62856(VarCurr,4) ) ) ).

tff(addAssignment_37419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,4) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37414,axiom,
    ! [VarCurr: state_type] :
      ( v63121(VarCurr,3)
    <=> v64302(VarCurr) ) ).

tff(addAssignment_37413,axiom,
    ! [VarCurr: state_type] :
      ( v63121(VarCurr,2)
    <=> v64315(VarCurr) ) ).

tff(addAssignment_37412,axiom,
    ! [VarCurr: state_type] :
      ( v63121(VarCurr,1)
    <=> v64328(VarCurr) ) ).

tff(addAssignment_37411,axiom,
    ! [VarCurr: state_type] :
      ( v63121(VarCurr,0)
    <=> v64346(VarCurr) ) ).

tff(addAssignment_37410,axiom,
    ! [VarCurr: state_type] :
      ( v64346(VarCurr)
    <=> v64348(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6049,axiom,
    ! [VarCurr: state_type] :
      ( v64348(VarCurr)
    <=> ( v64350(VarCurr)
      <~> v64354(VarCurr) ) ) ).

tff(addAssignment_37409,axiom,
    ! [VarCurr: state_type] :
      ( v64354(VarCurr)
    <=> v64356(VarCurr) ) ).

tff(addAssignment_37408,axiom,
    ! [VarCurr: state_type] :
      ( v64356(VarCurr)
    <=> v62876(VarCurr,11) ) ).

tff(addAssignment_37407,axiom,
    ! [VarCurr: state_type] :
      ( v64350(VarCurr)
    <=> v64352(VarCurr) ) ).

tff(addAssignment_37406,axiom,
    ! [VarCurr: state_type] :
      ( v64352(VarCurr)
    <=> v62876(VarCurr,8) ) ).

tff(addAssignment_37405,axiom,
    ! [VarCurr: state_type] :
      ( v64328(VarCurr)
    <=> v64330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6048,axiom,
    ! [VarCurr: state_type] :
      ( v64330(VarCurr)
    <=> ( v64344(VarCurr)
      <~> v64340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6047,axiom,
    ! [VarCurr: state_type] :
      ( v64344(VarCurr)
    <=> ( v64332(VarCurr)
      <~> v64336(VarCurr) ) ) ).

tff(addAssignment_37404,axiom,
    ! [VarCurr: state_type] :
      ( v64340(VarCurr)
    <=> v64342(VarCurr) ) ).

tff(addAssignment_37403,axiom,
    ! [VarCurr: state_type] :
      ( v64342(VarCurr)
    <=> v62876(VarCurr,9) ) ).

tff(addAssignment_37402,axiom,
    ! [VarCurr: state_type] :
      ( v64336(VarCurr)
    <=> v64338(VarCurr) ) ).

tff(addAssignment_37401,axiom,
    ! [VarCurr: state_type] :
      ( v64338(VarCurr)
    <=> v62876(VarCurr,11) ) ).

tff(addAssignment_37400,axiom,
    ! [VarCurr: state_type] :
      ( v64332(VarCurr)
    <=> v64334(VarCurr) ) ).

tff(addAssignment_37399,axiom,
    ! [VarCurr: state_type] :
      ( v64334(VarCurr)
    <=> v62876(VarCurr,8) ) ).

tff(addAssignment_37398,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,8)
    <=> v62934(VarCurr,8) ) ).

tff(addAssignment_37397,axiom,
    ! [VarCurr: state_type] :
      ( v64315(VarCurr)
    <=> v64317(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6046,axiom,
    ! [VarCurr: state_type] :
      ( v64317(VarCurr)
    <=> ( v64319(VarCurr)
      <~> v64323(VarCurr) ) ) ).

tff(addAssignment_37396,axiom,
    ! [VarCurr: state_type] :
      ( v64323(VarCurr)
    <=> v64325(VarCurr) ) ).

tff(addAssignment_37395,axiom,
    ! [VarCurr: state_type] :
      ( v64325(VarCurr)
    <=> v62876(VarCurr,10) ) ).

tff(addAssignment_37394,axiom,
    ! [VarCurr: state_type] :
      ( v64319(VarCurr)
    <=> v64321(VarCurr) ) ).

tff(addAssignment_37393,axiom,
    ! [VarCurr: state_type] :
      ( v64321(VarCurr)
    <=> v62876(VarCurr,9) ) ).

tff(addAssignment_37392,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,9)
    <=> v62934(VarCurr,9) ) ).

tff(addAssignment_37391,axiom,
    ! [VarCurr: state_type] :
      ( v64302(VarCurr)
    <=> v64304(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6045,axiom,
    ! [VarCurr: state_type] :
      ( v64304(VarCurr)
    <=> ( v64306(VarCurr)
      <~> v64310(VarCurr) ) ) ).

tff(addAssignment_37390,axiom,
    ! [VarCurr: state_type] :
      ( v64310(VarCurr)
    <=> v64312(VarCurr) ) ).

tff(addAssignment_37389,axiom,
    ! [VarCurr: state_type] :
      ( v64312(VarCurr)
    <=> v62876(VarCurr,11) ) ).

tff(addAssignment_37388,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,11)
    <=> v62934(VarCurr,11) ) ).

tff(addAssignment_37387,axiom,
    ! [VarCurr: state_type] :
      ( v64306(VarCurr)
    <=> v64308(VarCurr) ) ).

tff(addAssignment_37386,axiom,
    ! [VarCurr: state_type] :
      ( v64308(VarCurr)
    <=> v62876(VarCurr,10) ) ).

tff(addAssignment_37385,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,10)
    <=> v62934(VarCurr,10) ) ).

tff(addAssignment_37384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64291(VarCurr,B)
      <=> v64293(VarCurr,B) ) ) ).

tff(addAssignment_37383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64293(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37382,axiom,
    ! [VarCurr: state_type] :
      ( v64277(VarCurr)
    <=> v64279(VarCurr) ) ).

tff(addAssignment_37381,axiom,
    ! [VarCurr: state_type] :
      ( v64279(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37380,axiom,
    ! [VarCurr: state_type] :
      ( v64156(VarCurr)
    <=> v64158(VarCurr) ) ).

tff(addAssignment_37379,axiom,
    ! [VarCurr: state_type] :
      ( v64158(VarCurr)
    <=> v64160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6044,axiom,
    ! [VarCurr: state_type] :
      ( v64160(VarCurr)
    <=> ( v64162(VarCurr)
        & v64166(VarCurr) ) ) ).

tff(addAssignment_37378,axiom,
    ! [VarCurr: state_type] :
      ( v64166(VarCurr)
    <=> v64168(VarCurr) ) ).

tff(addAssignment_37377,axiom,
    ! [VarCurr: state_type] :
      ( v64168(VarCurr)
    <=> v64170(VarCurr) ) ).

tff(addAssignment_37376,axiom,
    ! [VarCurr: state_type] :
      ( v64170(VarCurr)
    <=> v64172(VarCurr) ) ).

tff(addAssignment_37375,axiom,
    ! [VarCurr: state_type] :
      ( v64172(VarCurr)
    <=> v64174(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_245,axiom,
    ! [VarCurr: state_type] :
      ( v64174(VarCurr)
    <=> ( ( v64176(VarCurr,3)
        <=> v64180(VarCurr,3) )
        & ( v64176(VarCurr,2)
        <=> v64180(VarCurr,2) )
        & ( v64176(VarCurr,1)
        <=> v64180(VarCurr,1) )
        & ( v64176(VarCurr,0)
        <=> v64180(VarCurr,0) ) ) ) ).

tff(addAssignment_37374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64180(VarCurr,B)
      <=> v64182(VarCurr,B) ) ) ).

tff(addAssignment_37373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64182(VarCurr,B)
      <=> v64184(VarCurr,B) ) ) ).

tff(addAssignment_37372,axiom,
    ! [VarCurr: state_type] :
      ( ( v64184(VarCurr,3)
      <=> v62856(VarCurr,11) )
      & ( v64184(VarCurr,2)
      <=> v62856(VarCurr,10) )
      & ( v64184(VarCurr,1)
      <=> v62856(VarCurr,9) )
      & ( v64184(VarCurr,0)
      <=> v62856(VarCurr,8) ) ) ).

tff(addAssignment_37371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37366,axiom,
    ! [VarCurr: state_type] :
      ( v63120(VarCurr,3)
    <=> v64187(VarCurr) ) ).

tff(addAssignment_37365,axiom,
    ! [VarCurr: state_type] :
      ( v63120(VarCurr,2)
    <=> v64205(VarCurr) ) ).

tff(addAssignment_37364,axiom,
    ! [VarCurr: state_type] :
      ( v63120(VarCurr,1)
    <=> v64238(VarCurr) ) ).

tff(addAssignment_37363,axiom,
    ! [VarCurr: state_type] :
      ( v63120(VarCurr,0)
    <=> v64261(VarCurr) ) ).

tff(addAssignment_37362,axiom,
    ! [VarCurr: state_type] :
      ( v64261(VarCurr)
    <=> v64263(VarCurr) ) ).

tff(addAssignment_37361,axiom,
    ! [VarCurr: state_type] :
      ( v64263(VarCurr)
    <=> v64265(VarCurr) ) ).

tff(addAssignment_37360,axiom,
    ! [VarCurr: state_type] :
      ( v64265(VarCurr)
    <=> v64267(VarCurr) ) ).

tff(addAssignment_37359,axiom,
    ! [VarCurr: state_type] :
      ( v64267(VarCurr)
    <=> v62876(VarCurr,14) ) ).

tff(addAssignment_37358,axiom,
    ! [VarCurr: state_type] :
      ( v64238(VarCurr)
    <=> v64240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6043,axiom,
    ! [VarCurr: state_type] :
      ( v64240(VarCurr)
    <=> ( v64242(VarCurr)
      <~> v64246(VarCurr) ) ) ).

tff(addAssignment_37357,axiom,
    ! [VarCurr: state_type] :
      ( v64246(VarCurr)
    <=> v64248(VarCurr) ) ).

tff(addAssignment_37356,axiom,
    ! [VarCurr: state_type] :
      ( v64248(VarCurr)
    <=> v62876(VarCurr,14) ) ).

tff(addAssignment_37355,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,14)
    <=> v62934(VarCurr,14) ) ).

tff(addAssignment_37354,axiom,
    ! [VarCurr: state_type] :
      ( v62979(VarCurr)
    <=> v64251(VarCurr) ) ).

tff(addAssignment_37353,axiom,
    ! [VarCurr: state_type] :
      ( v64251(VarCurr)
    <=> v64253(VarCurr) ) ).

tff(writeUnaryOperator_3223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64253(VarCurr)
    <=> v64255(VarCurr) ) ).

tff(addAssignment_37352,axiom,
    ! [VarCurr: state_type] :
      ( v64255(VarCurr)
    <=> v64257(VarCurr) ) ).

tff(addAssignment_37351,axiom,
    ! [VarCurr: state_type] :
      ( v64257(VarCurr)
    <=> v63021(VarCurr) ) ).

tff(addAssignment_37350,axiom,
    ! [VarCurr: state_type] :
      ( v64242(VarCurr)
    <=> v64244(VarCurr) ) ).

tff(addAssignment_37349,axiom,
    ! [VarCurr: state_type] :
      ( v64244(VarCurr)
    <=> v62876(VarCurr,15) ) ).

tff(addAssignment_37348,axiom,
    ! [VarCurr: state_type] :
      ( v64205(VarCurr)
    <=> v64207(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6042,axiom,
    ! [VarCurr: state_type] :
      ( v64207(VarCurr)
    <=> ( v64209(VarCurr)
      <~> v64223(VarCurr) ) ) ).

tff(addAssignment_37347,axiom,
    ! [VarCurr: state_type] :
      ( v64223(VarCurr)
    <=> v64225(VarCurr) ) ).

tff(addAssignment_37346,axiom,
    ! [VarCurr: state_type] :
      ( v64225(VarCurr)
    <=> v62876(VarCurr,15) ) ).

tff(addAssignment_37345,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,15)
    <=> v62934(VarCurr,15) ) ).

tff(addAssignment_37344,axiom,
    ! [VarCurr: state_type] :
      ( v62978(VarCurr)
    <=> v64228(VarCurr) ) ).

tff(addAssignment_37343,axiom,
    ! [VarCurr: state_type] :
      ( v64228(VarCurr)
    <=> v64230(VarCurr) ) ).

tff(writeUnaryOperator_3222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64230(VarCurr)
    <=> v64232(VarCurr) ) ).

tff(addAssignment_37342,axiom,
    ! [VarCurr: state_type] :
      ( v64232(VarCurr)
    <=> v64234(VarCurr) ) ).

tff(addAssignment_37341,axiom,
    ! [VarCurr: state_type] :
      ( v64234(VarCurr)
    <=> v63097(VarCurr) ) ).

tff(addAssignment_37340,axiom,
    ! [VarCurr: state_type] :
      ( v64209(VarCurr)
    <=> v64211(VarCurr) ) ).

tff(addAssignment_37339,axiom,
    ! [VarCurr: state_type] :
      ( v64211(VarCurr)
    <=> v62876(VarCurr,12) ) ).

tff(addAssignment_37338,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,12)
    <=> v62934(VarCurr,12) ) ).

tff(addAssignment_37337,axiom,
    ! [VarCurr: state_type] :
      ( v62981(VarCurr)
    <=> v64214(VarCurr) ) ).

tff(addAssignment_37336,axiom,
    ! [VarCurr: state_type] :
      ( v64214(VarCurr)
    <=> v64216(VarCurr) ) ).

tff(writeUnaryOperator_3221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64216(VarCurr)
    <=> v64218(VarCurr) ) ).

tff(addAssignment_37335,axiom,
    ! [VarCurr: state_type] :
      ( v64218(VarCurr)
    <=> v64220(VarCurr) ) ).

tff(addAssignment_37334,axiom,
    ! [VarCurr: state_type] :
      ( v64220(VarCurr)
    <=> v62888(VarCurr) ) ).

tff(addAssignment_37333,axiom,
    ! [VarCurr: state_type] :
      ( v64187(VarCurr)
    <=> v64189(VarCurr) ) ).

tff(addAssignment_37332,axiom,
    ! [VarCurr: state_type] :
      ( v64189(VarCurr)
    <=> v64191(VarCurr) ) ).

tff(addAssignment_37331,axiom,
    ! [VarCurr: state_type] :
      ( v64191(VarCurr)
    <=> v64193(VarCurr) ) ).

tff(addAssignment_37330,axiom,
    ! [VarCurr: state_type] :
      ( v64193(VarCurr)
    <=> v62876(VarCurr,13) ) ).

tff(addAssignment_37329,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,13)
    <=> v62934(VarCurr,13) ) ).

tff(addAssignment_37328,axiom,
    ! [VarCurr: state_type] :
      ( v62980(VarCurr)
    <=> v64196(VarCurr) ) ).

tff(addAssignment_37327,axiom,
    ! [VarCurr: state_type] :
      ( v64196(VarCurr)
    <=> v64198(VarCurr) ) ).

tff(writeUnaryOperator_3220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v64198(VarCurr)
    <=> v64200(VarCurr) ) ).

tff(addAssignment_37326,axiom,
    ! [VarCurr: state_type] :
      ( v64200(VarCurr)
    <=> v64202(VarCurr) ) ).

tff(addAssignment_37325,axiom,
    ! [VarCurr: state_type] :
      ( v64202(VarCurr)
    <=> v62996(VarCurr) ) ).

tff(addAssignment_37324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64176(VarCurr,B)
      <=> v64178(VarCurr,B) ) ) ).

tff(addAssignment_37323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64178(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37322,axiom,
    ! [VarCurr: state_type] :
      ( v64162(VarCurr)
    <=> v64164(VarCurr) ) ).

tff(addAssignment_37321,axiom,
    ! [VarCurr: state_type] :
      ( v64164(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37320,axiom,
    ! [VarCurr: state_type] :
      ( v64061(VarCurr)
    <=> v64063(VarCurr) ) ).

tff(addAssignment_37319,axiom,
    ! [VarCurr: state_type] :
      ( v64063(VarCurr)
    <=> v64065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6041,axiom,
    ! [VarCurr: state_type] :
      ( v64065(VarCurr)
    <=> ( v64067(VarCurr)
        & v64071(VarCurr) ) ) ).

tff(addAssignment_37318,axiom,
    ! [VarCurr: state_type] :
      ( v64071(VarCurr)
    <=> v64073(VarCurr) ) ).

tff(addAssignment_37317,axiom,
    ! [VarCurr: state_type] :
      ( v64073(VarCurr)
    <=> v64075(VarCurr) ) ).

tff(addAssignment_37316,axiom,
    ! [VarCurr: state_type] :
      ( v64075(VarCurr)
    <=> v64077(VarCurr) ) ).

tff(addAssignment_37315,axiom,
    ! [VarCurr: state_type] :
      ( v64077(VarCurr)
    <=> v64079(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_244,axiom,
    ! [VarCurr: state_type] :
      ( v64079(VarCurr)
    <=> ( ( v64081(VarCurr,3)
        <=> v64085(VarCurr,3) )
        & ( v64081(VarCurr,2)
        <=> v64085(VarCurr,2) )
        & ( v64081(VarCurr,1)
        <=> v64085(VarCurr,1) )
        & ( v64081(VarCurr,0)
        <=> v64085(VarCurr,0) ) ) ) ).

tff(addAssignment_37314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64085(VarCurr,B)
      <=> v64087(VarCurr,B) ) ) ).

tff(addAssignment_37313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64087(VarCurr,B)
      <=> v64089(VarCurr,B) ) ) ).

tff(addAssignment_37312,axiom,
    ! [VarCurr: state_type] :
      ( ( v64089(VarCurr,3)
      <=> v62856(VarCurr,15) )
      & ( v64089(VarCurr,2)
      <=> v62856(VarCurr,14) )
      & ( v64089(VarCurr,1)
      <=> v62856(VarCurr,13) )
      & ( v64089(VarCurr,0)
      <=> v62856(VarCurr,12) ) ) ).

tff(addAssignment_37311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37306,axiom,
    ! [VarCurr: state_type] :
      ( v63119(VarCurr,3)
    <=> v64092(VarCurr) ) ).

tff(addAssignment_37305,axiom,
    ! [VarCurr: state_type] :
      ( v63119(VarCurr,2)
    <=> v64105(VarCurr) ) ).

tff(addAssignment_37304,axiom,
    ! [VarCurr: state_type] :
      ( v63119(VarCurr,1)
    <=> v64123(VarCurr) ) ).

tff(addAssignment_37303,axiom,
    ! [VarCurr: state_type] :
      ( v63119(VarCurr,0)
    <=> v64141(VarCurr) ) ).

tff(addAssignment_37302,axiom,
    ! [VarCurr: state_type] :
      ( v64141(VarCurr)
    <=> v64143(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6040,axiom,
    ! [VarCurr: state_type] :
      ( v64143(VarCurr)
    <=> ( v64145(VarCurr)
      <~> v64149(VarCurr) ) ) ).

tff(addAssignment_37301,axiom,
    ! [VarCurr: state_type] :
      ( v64149(VarCurr)
    <=> v64151(VarCurr) ) ).

tff(addAssignment_37300,axiom,
    ! [VarCurr: state_type] :
      ( v64151(VarCurr)
    <=> v62876(VarCurr,18) ) ).

tff(addAssignment_37299,axiom,
    ! [VarCurr: state_type] :
      ( v64145(VarCurr)
    <=> v64147(VarCurr) ) ).

tff(addAssignment_37298,axiom,
    ! [VarCurr: state_type] :
      ( v64147(VarCurr)
    <=> v62876(VarCurr,16) ) ).

tff(addAssignment_37297,axiom,
    ! [VarCurr: state_type] :
      ( v64123(VarCurr)
    <=> v64125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6039,axiom,
    ! [VarCurr: state_type] :
      ( v64125(VarCurr)
    <=> ( v64139(VarCurr)
      <~> v64135(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6038,axiom,
    ! [VarCurr: state_type] :
      ( v64139(VarCurr)
    <=> ( v64127(VarCurr)
      <~> v64131(VarCurr) ) ) ).

tff(addAssignment_37296,axiom,
    ! [VarCurr: state_type] :
      ( v64135(VarCurr)
    <=> v64137(VarCurr) ) ).

tff(addAssignment_37295,axiom,
    ! [VarCurr: state_type] :
      ( v64137(VarCurr)
    <=> v62876(VarCurr,19) ) ).

tff(addAssignment_37294,axiom,
    ! [VarCurr: state_type] :
      ( v64131(VarCurr)
    <=> v64133(VarCurr) ) ).

tff(addAssignment_37293,axiom,
    ! [VarCurr: state_type] :
      ( v64133(VarCurr)
    <=> v62876(VarCurr,18) ) ).

tff(addAssignment_37292,axiom,
    ! [VarCurr: state_type] :
      ( v64127(VarCurr)
    <=> v64129(VarCurr) ) ).

tff(addAssignment_37291,axiom,
    ! [VarCurr: state_type] :
      ( v64129(VarCurr)
    <=> v62876(VarCurr,17) ) ).

tff(addAssignment_37290,axiom,
    ! [VarCurr: state_type] :
      ( v64105(VarCurr)
    <=> v64107(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6037,axiom,
    ! [VarCurr: state_type] :
      ( v64107(VarCurr)
    <=> ( v64121(VarCurr)
      <~> v64117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6036,axiom,
    ! [VarCurr: state_type] :
      ( v64121(VarCurr)
    <=> ( v64109(VarCurr)
      <~> v64113(VarCurr) ) ) ).

tff(addAssignment_37289,axiom,
    ! [VarCurr: state_type] :
      ( v64117(VarCurr)
    <=> v64119(VarCurr) ) ).

tff(addAssignment_37288,axiom,
    ! [VarCurr: state_type] :
      ( v64119(VarCurr)
    <=> v62876(VarCurr,19) ) ).

tff(addAssignment_37287,axiom,
    ! [VarCurr: state_type] :
      ( v64113(VarCurr)
    <=> v64115(VarCurr) ) ).

tff(addAssignment_37286,axiom,
    ! [VarCurr: state_type] :
      ( v64115(VarCurr)
    <=> v62876(VarCurr,18) ) ).

tff(addAssignment_37285,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,18)
    <=> v62934(VarCurr,18) ) ).

tff(addAssignment_37284,axiom,
    ! [VarCurr: state_type] :
      ( v64109(VarCurr)
    <=> v64111(VarCurr) ) ).

tff(addAssignment_37283,axiom,
    ! [VarCurr: state_type] :
      ( v64111(VarCurr)
    <=> v62876(VarCurr,16) ) ).

tff(addAssignment_37282,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,16)
    <=> v62934(VarCurr,16) ) ).

tff(addAssignment_37281,axiom,
    ! [VarCurr: state_type] :
      ( v64092(VarCurr)
    <=> v64094(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6035,axiom,
    ! [VarCurr: state_type] :
      ( v64094(VarCurr)
    <=> ( v64096(VarCurr)
      <~> v64100(VarCurr) ) ) ).

tff(addAssignment_37280,axiom,
    ! [VarCurr: state_type] :
      ( v64100(VarCurr)
    <=> v64102(VarCurr) ) ).

tff(addAssignment_37279,axiom,
    ! [VarCurr: state_type] :
      ( v64102(VarCurr)
    <=> v62876(VarCurr,19) ) ).

tff(addAssignment_37278,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,19)
    <=> v62934(VarCurr,19) ) ).

tff(addAssignment_37277,axiom,
    ! [VarCurr: state_type] :
      ( v64096(VarCurr)
    <=> v64098(VarCurr) ) ).

tff(addAssignment_37276,axiom,
    ! [VarCurr: state_type] :
      ( v64098(VarCurr)
    <=> v62876(VarCurr,17) ) ).

tff(addAssignment_37275,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,17)
    <=> v62934(VarCurr,17) ) ).

tff(addAssignment_37274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64081(VarCurr,B)
      <=> v64083(VarCurr,B) ) ) ).

tff(addAssignment_37273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v64083(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37272,axiom,
    ! [VarCurr: state_type] :
      ( v64067(VarCurr)
    <=> v64069(VarCurr) ) ).

tff(addAssignment_37271,axiom,
    ! [VarCurr: state_type] :
      ( v64069(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37270,axiom,
    ! [VarCurr: state_type] :
      ( v63971(VarCurr)
    <=> v63973(VarCurr) ) ).

tff(addAssignment_37269,axiom,
    ! [VarCurr: state_type] :
      ( v63973(VarCurr)
    <=> v63975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6034,axiom,
    ! [VarCurr: state_type] :
      ( v63975(VarCurr)
    <=> ( v63977(VarCurr)
        & v63981(VarCurr) ) ) ).

tff(addAssignment_37268,axiom,
    ! [VarCurr: state_type] :
      ( v63981(VarCurr)
    <=> v63983(VarCurr) ) ).

tff(addAssignment_37267,axiom,
    ! [VarCurr: state_type] :
      ( v63983(VarCurr)
    <=> v63985(VarCurr) ) ).

tff(addAssignment_37266,axiom,
    ! [VarCurr: state_type] :
      ( v63985(VarCurr)
    <=> v63987(VarCurr) ) ).

tff(addAssignment_37265,axiom,
    ! [VarCurr: state_type] :
      ( v63987(VarCurr)
    <=> v63989(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_243,axiom,
    ! [VarCurr: state_type] :
      ( v63989(VarCurr)
    <=> ( ( v63991(VarCurr,3)
        <=> v63995(VarCurr,3) )
        & ( v63991(VarCurr,2)
        <=> v63995(VarCurr,2) )
        & ( v63991(VarCurr,1)
        <=> v63995(VarCurr,1) )
        & ( v63991(VarCurr,0)
        <=> v63995(VarCurr,0) ) ) ) ).

tff(addAssignment_37264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63995(VarCurr,B)
      <=> v63997(VarCurr,B) ) ) ).

tff(addAssignment_37263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63997(VarCurr,B)
      <=> v63999(VarCurr,B) ) ) ).

tff(addAssignment_37262,axiom,
    ! [VarCurr: state_type] :
      ( ( v63999(VarCurr,3)
      <=> v62856(VarCurr,19) )
      & ( v63999(VarCurr,2)
      <=> v62856(VarCurr,18) )
      & ( v63999(VarCurr,1)
      <=> v62856(VarCurr,17) )
      & ( v63999(VarCurr,0)
      <=> v62856(VarCurr,16) ) ) ).

tff(addAssignment_37261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37256,axiom,
    ! [VarCurr: state_type] :
      ( v63118(VarCurr,3)
    <=> v64002(VarCurr) ) ).

tff(addAssignment_37255,axiom,
    ! [VarCurr: state_type] :
      ( v63118(VarCurr,2)
    <=> v64015(VarCurr) ) ).

tff(addAssignment_37254,axiom,
    ! [VarCurr: state_type] :
      ( v63118(VarCurr,1)
    <=> v64033(VarCurr) ) ).

tff(addAssignment_37253,axiom,
    ! [VarCurr: state_type] :
      ( v63118(VarCurr,0)
    <=> v64046(VarCurr) ) ).

tff(addAssignment_37252,axiom,
    ! [VarCurr: state_type] :
      ( v64046(VarCurr)
    <=> v64048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6033,axiom,
    ! [VarCurr: state_type] :
      ( v64048(VarCurr)
    <=> ( v64050(VarCurr)
      <~> v64054(VarCurr) ) ) ).

tff(addAssignment_37251,axiom,
    ! [VarCurr: state_type] :
      ( v64054(VarCurr)
    <=> v64056(VarCurr) ) ).

tff(addAssignment_37250,axiom,
    ! [VarCurr: state_type] :
      ( v64056(VarCurr)
    <=> v62876(VarCurr,23) ) ).

tff(addAssignment_37249,axiom,
    ! [VarCurr: state_type] :
      ( v64050(VarCurr)
    <=> v64052(VarCurr) ) ).

tff(addAssignment_37248,axiom,
    ! [VarCurr: state_type] :
      ( v64052(VarCurr)
    <=> v62876(VarCurr,22) ) ).

tff(addAssignment_37247,axiom,
    ! [VarCurr: state_type] :
      ( v64033(VarCurr)
    <=> v64035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6032,axiom,
    ! [VarCurr: state_type] :
      ( v64035(VarCurr)
    <=> ( v64037(VarCurr)
      <~> v64041(VarCurr) ) ) ).

tff(addAssignment_37246,axiom,
    ! [VarCurr: state_type] :
      ( v64041(VarCurr)
    <=> v64043(VarCurr) ) ).

tff(addAssignment_37245,axiom,
    ! [VarCurr: state_type] :
      ( v64043(VarCurr)
    <=> v62876(VarCurr,22) ) ).

tff(addAssignment_37244,axiom,
    ! [VarCurr: state_type] :
      ( v64037(VarCurr)
    <=> v64039(VarCurr) ) ).

tff(addAssignment_37243,axiom,
    ! [VarCurr: state_type] :
      ( v64039(VarCurr)
    <=> v62876(VarCurr,20) ) ).

tff(addAssignment_37242,axiom,
    ! [VarCurr: state_type] :
      ( v64015(VarCurr)
    <=> v64017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6031,axiom,
    ! [VarCurr: state_type] :
      ( v64017(VarCurr)
    <=> ( v64031(VarCurr)
      <~> v64027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6030,axiom,
    ! [VarCurr: state_type] :
      ( v64031(VarCurr)
    <=> ( v64019(VarCurr)
      <~> v64023(VarCurr) ) ) ).

tff(addAssignment_37241,axiom,
    ! [VarCurr: state_type] :
      ( v64027(VarCurr)
    <=> v64029(VarCurr) ) ).

tff(addAssignment_37240,axiom,
    ! [VarCurr: state_type] :
      ( v64029(VarCurr)
    <=> v62876(VarCurr,23) ) ).

tff(addAssignment_37239,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,23)
    <=> v62934(VarCurr,23) ) ).

tff(addAssignment_37238,axiom,
    ! [VarCurr: state_type] :
      ( v64023(VarCurr)
    <=> v64025(VarCurr) ) ).

tff(addAssignment_37237,axiom,
    ! [VarCurr: state_type] :
      ( v64025(VarCurr)
    <=> v62876(VarCurr,21) ) ).

tff(addAssignment_37236,axiom,
    ! [VarCurr: state_type] :
      ( v64019(VarCurr)
    <=> v64021(VarCurr) ) ).

tff(addAssignment_37235,axiom,
    ! [VarCurr: state_type] :
      ( v64021(VarCurr)
    <=> v62876(VarCurr,20) ) ).

tff(addAssignment_37234,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,20)
    <=> v62934(VarCurr,20) ) ).

tff(addAssignment_37233,axiom,
    ! [VarCurr: state_type] :
      ( v64002(VarCurr)
    <=> v64004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6029,axiom,
    ! [VarCurr: state_type] :
      ( v64004(VarCurr)
    <=> ( v64006(VarCurr)
      <~> v64010(VarCurr) ) ) ).

tff(addAssignment_37232,axiom,
    ! [VarCurr: state_type] :
      ( v64010(VarCurr)
    <=> v64012(VarCurr) ) ).

tff(addAssignment_37231,axiom,
    ! [VarCurr: state_type] :
      ( v64012(VarCurr)
    <=> v62876(VarCurr,22) ) ).

tff(addAssignment_37230,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,22)
    <=> v62934(VarCurr,22) ) ).

tff(addAssignment_37229,axiom,
    ! [VarCurr: state_type] :
      ( v64006(VarCurr)
    <=> v64008(VarCurr) ) ).

tff(addAssignment_37228,axiom,
    ! [VarCurr: state_type] :
      ( v64008(VarCurr)
    <=> v62876(VarCurr,21) ) ).

tff(addAssignment_37227,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,21)
    <=> v62934(VarCurr,21) ) ).

tff(addAssignment_37226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63991(VarCurr,B)
      <=> v63993(VarCurr,B) ) ) ).

tff(addAssignment_37225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63993(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37224,axiom,
    ! [VarCurr: state_type] :
      ( v63977(VarCurr)
    <=> v63979(VarCurr) ) ).

tff(addAssignment_37223,axiom,
    ! [VarCurr: state_type] :
      ( v63979(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37222,axiom,
    ! [VarCurr: state_type] :
      ( v63851(VarCurr)
    <=> v63853(VarCurr) ) ).

tff(addAssignment_37221,axiom,
    ! [VarCurr: state_type] :
      ( v63853(VarCurr)
    <=> v63855(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6028,axiom,
    ! [VarCurr: state_type] :
      ( v63855(VarCurr)
    <=> ( v63857(VarCurr)
        & v63861(VarCurr) ) ) ).

tff(addAssignment_37220,axiom,
    ! [VarCurr: state_type] :
      ( v63861(VarCurr)
    <=> v63863(VarCurr) ) ).

tff(addAssignment_37219,axiom,
    ! [VarCurr: state_type] :
      ( v63863(VarCurr)
    <=> v63865(VarCurr) ) ).

tff(addAssignment_37218,axiom,
    ! [VarCurr: state_type] :
      ( v63865(VarCurr)
    <=> v63867(VarCurr) ) ).

tff(addAssignment_37217,axiom,
    ! [VarCurr: state_type] :
      ( v63867(VarCurr)
    <=> v63869(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_242,axiom,
    ! [VarCurr: state_type] :
      ( v63869(VarCurr)
    <=> ( ( v63871(VarCurr,3)
        <=> v63875(VarCurr,3) )
        & ( v63871(VarCurr,2)
        <=> v63875(VarCurr,2) )
        & ( v63871(VarCurr,1)
        <=> v63875(VarCurr,1) )
        & ( v63871(VarCurr,0)
        <=> v63875(VarCurr,0) ) ) ) ).

tff(addAssignment_37216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63875(VarCurr,B)
      <=> v63877(VarCurr,B) ) ) ).

tff(addAssignment_37215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63877(VarCurr,B)
      <=> v63879(VarCurr,B) ) ) ).

tff(addAssignment_37214,axiom,
    ! [VarCurr: state_type] :
      ( ( v63879(VarCurr,3)
      <=> v62856(VarCurr,23) )
      & ( v63879(VarCurr,2)
      <=> v62856(VarCurr,22) )
      & ( v63879(VarCurr,1)
      <=> v62856(VarCurr,21) )
      & ( v63879(VarCurr,0)
      <=> v62856(VarCurr,20) ) ) ).

tff(addAssignment_37213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37208,axiom,
    ! [VarCurr: state_type] :
      ( v63117(VarCurr,3)
    <=> v63882(VarCurr) ) ).

tff(addAssignment_37207,axiom,
    ! [VarCurr: state_type] :
      ( v63117(VarCurr,2)
    <=> v63900(VarCurr) ) ).

tff(addAssignment_37206,axiom,
    ! [VarCurr: state_type] :
      ( v63117(VarCurr,1)
    <=> v63933(VarCurr) ) ).

tff(addAssignment_37205,axiom,
    ! [VarCurr: state_type] :
      ( v63117(VarCurr,0)
    <=> v63951(VarCurr) ) ).

tff(addAssignment_37204,axiom,
    ! [VarCurr: state_type] :
      ( v63951(VarCurr)
    <=> v63953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6027,axiom,
    ! [VarCurr: state_type] :
      ( v63953(VarCurr)
    <=> ( v63967(VarCurr)
      <~> v63963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6026,axiom,
    ! [VarCurr: state_type] :
      ( v63967(VarCurr)
    <=> ( v63955(VarCurr)
      <~> v63959(VarCurr) ) ) ).

tff(addAssignment_37203,axiom,
    ! [VarCurr: state_type] :
      ( v63963(VarCurr)
    <=> v63965(VarCurr) ) ).

tff(addAssignment_37202,axiom,
    ! [VarCurr: state_type] :
      ( v63965(VarCurr)
    <=> v62876(VarCurr,27) ) ).

tff(addAssignment_37201,axiom,
    ! [VarCurr: state_type] :
      ( v63959(VarCurr)
    <=> v63961(VarCurr) ) ).

tff(addAssignment_37200,axiom,
    ! [VarCurr: state_type] :
      ( v63961(VarCurr)
    <=> v62876(VarCurr,26) ) ).

tff(addAssignment_37199,axiom,
    ! [VarCurr: state_type] :
      ( v63955(VarCurr)
    <=> v63957(VarCurr) ) ).

tff(addAssignment_37198,axiom,
    ! [VarCurr: state_type] :
      ( v63957(VarCurr)
    <=> v62876(VarCurr,24) ) ).

tff(addAssignment_37197,axiom,
    ! [VarCurr: state_type] :
      ( v63933(VarCurr)
    <=> v63935(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6025,axiom,
    ! [VarCurr: state_type] :
      ( v63935(VarCurr)
    <=> ( v63949(VarCurr)
      <~> v63945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6024,axiom,
    ! [VarCurr: state_type] :
      ( v63949(VarCurr)
    <=> ( v63937(VarCurr)
      <~> v63941(VarCurr) ) ) ).

tff(addAssignment_37196,axiom,
    ! [VarCurr: state_type] :
      ( v63945(VarCurr)
    <=> v63947(VarCurr) ) ).

tff(addAssignment_37195,axiom,
    ! [VarCurr: state_type] :
      ( v63947(VarCurr)
    <=> v62876(VarCurr,26) ) ).

tff(addAssignment_37194,axiom,
    ! [VarCurr: state_type] :
      ( v63941(VarCurr)
    <=> v63943(VarCurr) ) ).

tff(addAssignment_37193,axiom,
    ! [VarCurr: state_type] :
      ( v63943(VarCurr)
    <=> v62876(VarCurr,25) ) ).

tff(addAssignment_37192,axiom,
    ! [VarCurr: state_type] :
      ( v63937(VarCurr)
    <=> v63939(VarCurr) ) ).

tff(addAssignment_37191,axiom,
    ! [VarCurr: state_type] :
      ( v63939(VarCurr)
    <=> v62876(VarCurr,24) ) ).

tff(addAssignment_37190,axiom,
    ! [VarCurr: state_type] :
      ( v63900(VarCurr)
    <=> v63902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6023,axiom,
    ! [VarCurr: state_type] :
      ( v63902(VarCurr)
    <=> ( v63904(VarCurr)
      <~> v63928(VarCurr) ) ) ).

tff(addAssignment_37189,axiom,
    ! [VarCurr: state_type] :
      ( v63928(VarCurr)
    <=> v63930(VarCurr) ) ).

tff(addAssignment_37188,axiom,
    ! [VarCurr: state_type] :
      ( v63930(VarCurr)
    <=> v62876(VarCurr,27) ) ).

tff(addAssignment_37187,axiom,
    ! [VarCurr: state_type] :
      ( v63904(VarCurr)
    <=> v63906(VarCurr) ) ).

tff(addAssignment_37186,axiom,
    ! [VarCurr: state_type] :
      ( v63906(VarCurr)
    <=> v63908(VarCurr) ) ).

tff(addAssignment_37185,axiom,
    ! [VarCurr: state_type] :
      ( v63908(VarCurr)
    <=> v63910(VarCurr) ) ).

tff(addAssignment_37184,axiom,
    ! [VarCurr: state_type] :
      ( v63910(VarCurr)
    <=> v63912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6022,axiom,
    ! [VarCurr: state_type] :
      ( v63912(VarCurr)
    <=> ( v63926(VarCurr)
      <~> v63922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6021,axiom,
    ! [VarCurr: state_type] :
      ( v63926(VarCurr)
    <=> ( v63914(VarCurr)
      <~> v63918(VarCurr) ) ) ).

tff(addAssignment_37183,axiom,
    ! [VarCurr: state_type] :
      ( v63922(VarCurr)
    <=> v63924(VarCurr) ) ).

tff(addAssignment_37182,axiom,
    ! [VarCurr: state_type] :
      ( v63924(VarCurr)
    <=> v62876(VarCurr,26) ) ).

tff(addAssignment_37181,axiom,
    ! [VarCurr: state_type] :
      ( v63918(VarCurr)
    <=> v63920(VarCurr) ) ).

tff(addAssignment_37180,axiom,
    ! [VarCurr: state_type] :
      ( v63920(VarCurr)
    <=> v62876(VarCurr,25) ) ).

tff(addAssignment_37179,axiom,
    ! [VarCurr: state_type] :
      ( v63914(VarCurr)
    <=> v63916(VarCurr) ) ).

tff(addAssignment_37178,axiom,
    ! [VarCurr: state_type] :
      ( v63916(VarCurr)
    <=> v62876(VarCurr,24) ) ).

tff(addAssignment_37177,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,24)
    <=> v62934(VarCurr,24) ) ).

tff(addAssignment_37176,axiom,
    ! [VarCurr: state_type] :
      ( v63882(VarCurr)
    <=> v63884(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6020,axiom,
    ! [VarCurr: state_type] :
      ( v63884(VarCurr)
    <=> ( v63898(VarCurr)
      <~> v63894(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6019,axiom,
    ! [VarCurr: state_type] :
      ( v63898(VarCurr)
    <=> ( v63886(VarCurr)
      <~> v63890(VarCurr) ) ) ).

tff(addAssignment_37175,axiom,
    ! [VarCurr: state_type] :
      ( v63894(VarCurr)
    <=> v63896(VarCurr) ) ).

tff(addAssignment_37174,axiom,
    ! [VarCurr: state_type] :
      ( v63896(VarCurr)
    <=> v62876(VarCurr,27) ) ).

tff(addAssignment_37173,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,27)
    <=> v62934(VarCurr,27) ) ).

tff(addAssignment_37172,axiom,
    ! [VarCurr: state_type] :
      ( v63890(VarCurr)
    <=> v63892(VarCurr) ) ).

tff(addAssignment_37171,axiom,
    ! [VarCurr: state_type] :
      ( v63892(VarCurr)
    <=> v62876(VarCurr,26) ) ).

tff(addAssignment_37170,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,26)
    <=> v62934(VarCurr,26) ) ).

tff(addAssignment_37169,axiom,
    ! [VarCurr: state_type] :
      ( v63886(VarCurr)
    <=> v63888(VarCurr) ) ).

tff(addAssignment_37168,axiom,
    ! [VarCurr: state_type] :
      ( v63888(VarCurr)
    <=> v62876(VarCurr,25) ) ).

tff(addAssignment_37167,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,25)
    <=> v62934(VarCurr,25) ) ).

tff(addAssignment_37166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63871(VarCurr,B)
      <=> v63873(VarCurr,B) ) ) ).

tff(addAssignment_37165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63873(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37164,axiom,
    ! [VarCurr: state_type] :
      ( v63857(VarCurr)
    <=> v63859(VarCurr) ) ).

tff(addAssignment_37163,axiom,
    ! [VarCurr: state_type] :
      ( v63859(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37162,axiom,
    ! [VarCurr: state_type] :
      ( v63731(VarCurr)
    <=> v63733(VarCurr) ) ).

tff(addAssignment_37161,axiom,
    ! [VarCurr: state_type] :
      ( v63733(VarCurr)
    <=> v63735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6018,axiom,
    ! [VarCurr: state_type] :
      ( v63735(VarCurr)
    <=> ( v63737(VarCurr)
        & v63741(VarCurr) ) ) ).

tff(addAssignment_37160,axiom,
    ! [VarCurr: state_type] :
      ( v63741(VarCurr)
    <=> v63743(VarCurr) ) ).

tff(addAssignment_37159,axiom,
    ! [VarCurr: state_type] :
      ( v63743(VarCurr)
    <=> v63745(VarCurr) ) ).

tff(addAssignment_37158,axiom,
    ! [VarCurr: state_type] :
      ( v63745(VarCurr)
    <=> v63747(VarCurr) ) ).

tff(addAssignment_37157,axiom,
    ! [VarCurr: state_type] :
      ( v63747(VarCurr)
    <=> v63749(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_241,axiom,
    ! [VarCurr: state_type] :
      ( v63749(VarCurr)
    <=> ( ( v63751(VarCurr,3)
        <=> v63755(VarCurr,3) )
        & ( v63751(VarCurr,2)
        <=> v63755(VarCurr,2) )
        & ( v63751(VarCurr,1)
        <=> v63755(VarCurr,1) )
        & ( v63751(VarCurr,0)
        <=> v63755(VarCurr,0) ) ) ) ).

tff(addAssignment_37156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63755(VarCurr,B)
      <=> v63757(VarCurr,B) ) ) ).

tff(addAssignment_37155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63757(VarCurr,B)
      <=> v63759(VarCurr,B) ) ) ).

tff(addAssignment_37154,axiom,
    ! [VarCurr: state_type] :
      ( ( v63759(VarCurr,3)
      <=> v62856(VarCurr,27) )
      & ( v63759(VarCurr,2)
      <=> v62856(VarCurr,26) )
      & ( v63759(VarCurr,1)
      <=> v62856(VarCurr,25) )
      & ( v63759(VarCurr,0)
      <=> v62856(VarCurr,24) ) ) ).

tff(addAssignment_37153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,28)
        & ~ $less(B,24) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37148,axiom,
    ! [VarCurr: state_type] :
      ( v63116(VarCurr,3)
    <=> v63762(VarCurr) ) ).

tff(addAssignment_37147,axiom,
    ! [VarCurr: state_type] :
      ( v63116(VarCurr,2)
    <=> v63795(VarCurr) ) ).

tff(addAssignment_37146,axiom,
    ! [VarCurr: state_type] :
      ( v63116(VarCurr,1)
    <=> v63818(VarCurr) ) ).

tff(addAssignment_37145,axiom,
    ! [VarCurr: state_type] :
      ( v63116(VarCurr,0)
    <=> v63841(VarCurr) ) ).

tff(addAssignment_37144,axiom,
    ! [VarCurr: state_type] :
      ( v63841(VarCurr)
    <=> v63843(VarCurr) ) ).

tff(addAssignment_37143,axiom,
    ! [VarCurr: state_type] :
      ( v63843(VarCurr)
    <=> v63845(VarCurr) ) ).

tff(addAssignment_37142,axiom,
    ! [VarCurr: state_type] :
      ( v63845(VarCurr)
    <=> v63847(VarCurr) ) ).

tff(addAssignment_37141,axiom,
    ! [VarCurr: state_type] :
      ( v63847(VarCurr)
    <=> v62876(VarCurr,29) ) ).

tff(addAssignment_37140,axiom,
    ! [VarCurr: state_type] :
      ( v63818(VarCurr)
    <=> v63820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6017,axiom,
    ! [VarCurr: state_type] :
      ( v63820(VarCurr)
    <=> ( v63822(VarCurr)
      <~> v63826(VarCurr) ) ) ).

tff(addAssignment_37139,axiom,
    ! [VarCurr: state_type] :
      ( v63826(VarCurr)
    <=> v63828(VarCurr) ) ).

tff(addAssignment_37138,axiom,
    ! [VarCurr: state_type] :
      ( v63828(VarCurr)
    <=> v62876(VarCurr,29) ) ).

tff(addAssignment_37137,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,29)
    <=> v62934(VarCurr,29) ) ).

tff(addAssignment_37136,axiom,
    ! [VarCurr: state_type] :
      ( v62974(VarCurr)
    <=> v63831(VarCurr) ) ).

tff(addAssignment_37135,axiom,
    ! [VarCurr: state_type] :
      ( v63831(VarCurr)
    <=> v63833(VarCurr) ) ).

tff(writeUnaryOperator_3219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63833(VarCurr)
    <=> v63835(VarCurr) ) ).

tff(addAssignment_37134,axiom,
    ! [VarCurr: state_type] :
      ( v63835(VarCurr)
    <=> v63837(VarCurr) ) ).

tff(addAssignment_37133,axiom,
    ! [VarCurr: state_type] :
      ( v63837(VarCurr)
    <=> v62996(VarCurr) ) ).

tff(addAssignment_37132,axiom,
    ! [VarCurr: state_type] :
      ( v63822(VarCurr)
    <=> v63824(VarCurr) ) ).

tff(addAssignment_37131,axiom,
    ! [VarCurr: state_type] :
      ( v63824(VarCurr)
    <=> v62876(VarCurr,30) ) ).

tff(addAssignment_37130,axiom,
    ! [VarCurr: state_type] :
      ( v63795(VarCurr)
    <=> v63797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6016,axiom,
    ! [VarCurr: state_type] :
      ( v63797(VarCurr)
    <=> ( v63799(VarCurr)
      <~> v63803(VarCurr) ) ) ).

tff(addAssignment_37129,axiom,
    ! [VarCurr: state_type] :
      ( v63803(VarCurr)
    <=> v63805(VarCurr) ) ).

tff(addAssignment_37128,axiom,
    ! [VarCurr: state_type] :
      ( v63805(VarCurr)
    <=> v62876(VarCurr,30) ) ).

tff(addAssignment_37127,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,30)
    <=> v62934(VarCurr,30) ) ).

tff(addAssignment_37126,axiom,
    ! [VarCurr: state_type] :
      ( v62973(VarCurr)
    <=> v63808(VarCurr) ) ).

tff(addAssignment_37125,axiom,
    ! [VarCurr: state_type] :
      ( v63808(VarCurr)
    <=> v63810(VarCurr) ) ).

tff(writeUnaryOperator_3218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63810(VarCurr)
    <=> v63812(VarCurr) ) ).

tff(addAssignment_37124,axiom,
    ! [VarCurr: state_type] :
      ( v63812(VarCurr)
    <=> v63814(VarCurr) ) ).

tff(addAssignment_37123,axiom,
    ! [VarCurr: state_type] :
      ( v63814(VarCurr)
    <=> v63021(VarCurr) ) ).

tff(addAssignment_37122,axiom,
    ! [VarCurr: state_type] :
      ( v63799(VarCurr)
    <=> v63801(VarCurr) ) ).

tff(addAssignment_37121,axiom,
    ! [VarCurr: state_type] :
      ( v63801(VarCurr)
    <=> v62876(VarCurr,31) ) ).

tff(addAssignment_37120,axiom,
    ! [VarCurr: state_type] :
      ( v63762(VarCurr)
    <=> v63764(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6015,axiom,
    ! [VarCurr: state_type] :
      ( v63764(VarCurr)
    <=> ( v63766(VarCurr)
      <~> v63780(VarCurr) ) ) ).

tff(addAssignment_37119,axiom,
    ! [VarCurr: state_type] :
      ( v63780(VarCurr)
    <=> v63782(VarCurr) ) ).

tff(addAssignment_37118,axiom,
    ! [VarCurr: state_type] :
      ( v63782(VarCurr)
    <=> v62876(VarCurr,31) ) ).

tff(addAssignment_37117,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,31)
    <=> v62934(VarCurr,31) ) ).

tff(addAssignment_37116,axiom,
    ! [VarCurr: state_type] :
      ( v62972(VarCurr)
    <=> v63785(VarCurr) ) ).

tff(addAssignment_37115,axiom,
    ! [VarCurr: state_type] :
      ( v63785(VarCurr)
    <=> v63787(VarCurr) ) ).

tff(writeUnaryOperator_3217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63787(VarCurr)
    <=> v63789(VarCurr) ) ).

tff(addAssignment_37114,axiom,
    ! [VarCurr: state_type] :
      ( v63789(VarCurr)
    <=> v63791(VarCurr) ) ).

tff(addAssignment_37113,axiom,
    ! [VarCurr: state_type] :
      ( v63791(VarCurr)
    <=> v63097(VarCurr) ) ).

tff(addAssignment_37112,axiom,
    ! [VarCurr: state_type] :
      ( v63766(VarCurr)
    <=> v63768(VarCurr) ) ).

tff(addAssignment_37111,axiom,
    ! [VarCurr: state_type] :
      ( v63768(VarCurr)
    <=> v62876(VarCurr,28) ) ).

tff(addAssignment_37110,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,28)
    <=> v62934(VarCurr,28) ) ).

tff(addAssignment_37109,axiom,
    ! [VarCurr: state_type] :
      ( v62975(VarCurr)
    <=> v63771(VarCurr) ) ).

tff(addAssignment_37108,axiom,
    ! [VarCurr: state_type] :
      ( v63771(VarCurr)
    <=> v63773(VarCurr) ) ).

tff(writeUnaryOperator_3216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63773(VarCurr)
    <=> v63775(VarCurr) ) ).

tff(addAssignment_37107,axiom,
    ! [VarCurr: state_type] :
      ( v63775(VarCurr)
    <=> v63777(VarCurr) ) ).

tff(addAssignment_37106,axiom,
    ! [VarCurr: state_type] :
      ( v63777(VarCurr)
    <=> v62888(VarCurr) ) ).

tff(addAssignment_37105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63751(VarCurr,B)
      <=> v63753(VarCurr,B) ) ) ).

tff(addAssignment_37104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63753(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37103,axiom,
    ! [VarCurr: state_type] :
      ( v63737(VarCurr)
    <=> v63739(VarCurr) ) ).

tff(addAssignment_37102,axiom,
    ! [VarCurr: state_type] :
      ( v63739(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37101,axiom,
    ! [VarCurr: state_type] :
      ( v63661(VarCurr)
    <=> v63663(VarCurr) ) ).

tff(addAssignment_37100,axiom,
    ! [VarCurr: state_type] :
      ( v63663(VarCurr)
    <=> v63665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6014,axiom,
    ! [VarCurr: state_type] :
      ( v63665(VarCurr)
    <=> ( v63667(VarCurr)
        & v63671(VarCurr) ) ) ).

tff(addAssignment_37099,axiom,
    ! [VarCurr: state_type] :
      ( v63671(VarCurr)
    <=> v63673(VarCurr) ) ).

tff(addAssignment_37098,axiom,
    ! [VarCurr: state_type] :
      ( v63673(VarCurr)
    <=> v63675(VarCurr) ) ).

tff(addAssignment_37097,axiom,
    ! [VarCurr: state_type] :
      ( v63675(VarCurr)
    <=> v63677(VarCurr) ) ).

tff(addAssignment_37096,axiom,
    ! [VarCurr: state_type] :
      ( v63677(VarCurr)
    <=> v63679(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_240,axiom,
    ! [VarCurr: state_type] :
      ( v63679(VarCurr)
    <=> ( ( v63681(VarCurr,3)
        <=> v63685(VarCurr,3) )
        & ( v63681(VarCurr,2)
        <=> v63685(VarCurr,2) )
        & ( v63681(VarCurr,1)
        <=> v63685(VarCurr,1) )
        & ( v63681(VarCurr,0)
        <=> v63685(VarCurr,0) ) ) ) ).

tff(addAssignment_37095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63685(VarCurr,B)
      <=> v63687(VarCurr,B) ) ) ).

tff(addAssignment_37094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63687(VarCurr,B)
      <=> v63689(VarCurr,B) ) ) ).

tff(addAssignment_37093,axiom,
    ! [VarCurr: state_type] :
      ( ( v63689(VarCurr,3)
      <=> v62856(VarCurr,31) )
      & ( v63689(VarCurr,2)
      <=> v62856(VarCurr,30) )
      & ( v63689(VarCurr,1)
      <=> v62856(VarCurr,29) )
      & ( v63689(VarCurr,0)
      <=> v62856(VarCurr,28) ) ) ).

tff(addAssignment_37092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,28) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37087,axiom,
    ! [VarCurr: state_type] :
      ( v63115(VarCurr,3)
    <=> v63692(VarCurr) ) ).

tff(addAssignment_37086,axiom,
    ! [VarCurr: state_type] :
      ( v63115(VarCurr,2)
    <=> v63700(VarCurr) ) ).

tff(addAssignment_37085,axiom,
    ! [VarCurr: state_type] :
      ( v63115(VarCurr,1)
    <=> v63708(VarCurr) ) ).

tff(addAssignment_37084,axiom,
    ! [VarCurr: state_type] :
      ( v63115(VarCurr,0)
    <=> v63716(VarCurr) ) ).

tff(addAssignment_37083,axiom,
    ! [VarCurr: state_type] :
      ( v63716(VarCurr)
    <=> v63718(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6013,axiom,
    ! [VarCurr: state_type] :
      ( v63718(VarCurr)
    <=> ( v63720(VarCurr)
      <~> v63724(VarCurr) ) ) ).

tff(addAssignment_37082,axiom,
    ! [VarCurr: state_type] :
      ( v63724(VarCurr)
    <=> v63726(VarCurr) ) ).

tff(addAssignment_37081,axiom,
    ! [VarCurr: state_type] :
      ( v63726(VarCurr)
    <=> v62876(VarCurr,32) ) ).

tff(addAssignment_37080,axiom,
    ! [VarCurr: state_type] :
      ( v63720(VarCurr)
    <=> v63722(VarCurr) ) ).

tff(addAssignment_37079,axiom,
    ! [VarCurr: state_type] :
      ( v63722(VarCurr)
    <=> v62876(VarCurr,33) ) ).

tff(addAssignment_37078,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,33)
    <=> v62934(VarCurr,33) ) ).

tff(addAssignment_37077,axiom,
    ! [VarCurr: state_type] :
      ( v63708(VarCurr)
    <=> v63710(VarCurr) ) ).

tff(addAssignment_37076,axiom,
    ! [VarCurr: state_type] :
      ( v63710(VarCurr)
    <=> v63712(VarCurr) ) ).

tff(addAssignment_37075,axiom,
    ! [VarCurr: state_type] :
      ( v63712(VarCurr)
    <=> v63714(VarCurr) ) ).

tff(addAssignment_37074,axiom,
    ! [VarCurr: state_type] :
      ( v63714(VarCurr)
    <=> v62876(VarCurr,34) ) ).

tff(addAssignment_37073,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,34)
    <=> v62934(VarCurr,34) ) ).

tff(addAssignment_37072,axiom,
    ! [VarCurr: state_type] :
      ( v63700(VarCurr)
    <=> v63702(VarCurr) ) ).

tff(addAssignment_37071,axiom,
    ! [VarCurr: state_type] :
      ( v63702(VarCurr)
    <=> v63704(VarCurr) ) ).

tff(addAssignment_37070,axiom,
    ! [VarCurr: state_type] :
      ( v63704(VarCurr)
    <=> v63706(VarCurr) ) ).

tff(addAssignment_37069,axiom,
    ! [VarCurr: state_type] :
      ( v63706(VarCurr)
    <=> v62876(VarCurr,35) ) ).

tff(addAssignment_37068,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,35)
    <=> v62934(VarCurr,35) ) ).

tff(addAssignment_37067,axiom,
    ! [VarCurr: state_type] :
      ( v63692(VarCurr)
    <=> v63694(VarCurr) ) ).

tff(addAssignment_37066,axiom,
    ! [VarCurr: state_type] :
      ( v63694(VarCurr)
    <=> v63696(VarCurr) ) ).

tff(addAssignment_37065,axiom,
    ! [VarCurr: state_type] :
      ( v63696(VarCurr)
    <=> v63698(VarCurr) ) ).

tff(addAssignment_37064,axiom,
    ! [VarCurr: state_type] :
      ( v63698(VarCurr)
    <=> v62876(VarCurr,32) ) ).

tff(addAssignment_37063,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,32)
    <=> v62934(VarCurr,32) ) ).

tff(addAssignment_37062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63681(VarCurr,B)
      <=> v63683(VarCurr,B) ) ) ).

tff(addAssignment_37061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63683(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37060,axiom,
    ! [VarCurr: state_type] :
      ( v63667(VarCurr)
    <=> v63669(VarCurr) ) ).

tff(addAssignment_37059,axiom,
    ! [VarCurr: state_type] :
      ( v63669(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37058,axiom,
    ! [VarCurr: state_type] :
      ( v63546(VarCurr)
    <=> v63548(VarCurr) ) ).

tff(addAssignment_37057,axiom,
    ! [VarCurr: state_type] :
      ( v63548(VarCurr)
    <=> v63550(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6012,axiom,
    ! [VarCurr: state_type] :
      ( v63550(VarCurr)
    <=> ( v63552(VarCurr)
        & v63556(VarCurr) ) ) ).

tff(addAssignment_37056,axiom,
    ! [VarCurr: state_type] :
      ( v63556(VarCurr)
    <=> v63558(VarCurr) ) ).

tff(addAssignment_37055,axiom,
    ! [VarCurr: state_type] :
      ( v63558(VarCurr)
    <=> v63560(VarCurr) ) ).

tff(addAssignment_37054,axiom,
    ! [VarCurr: state_type] :
      ( v63560(VarCurr)
    <=> v63562(VarCurr) ) ).

tff(addAssignment_37053,axiom,
    ! [VarCurr: state_type] :
      ( v63562(VarCurr)
    <=> v63564(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_239,axiom,
    ! [VarCurr: state_type] :
      ( v63564(VarCurr)
    <=> ( ( v63566(VarCurr,3)
        <=> v63570(VarCurr,3) )
        & ( v63566(VarCurr,2)
        <=> v63570(VarCurr,2) )
        & ( v63566(VarCurr,1)
        <=> v63570(VarCurr,1) )
        & ( v63566(VarCurr,0)
        <=> v63570(VarCurr,0) ) ) ) ).

tff(addAssignment_37052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63570(VarCurr,B)
      <=> v63572(VarCurr,B) ) ) ).

tff(addAssignment_37051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63572(VarCurr,B)
      <=> v63574(VarCurr,B) ) ) ).

tff(addAssignment_37050,axiom,
    ! [VarCurr: state_type] :
      ( ( v63574(VarCurr,3)
      <=> v62856(VarCurr,35) )
      & ( v63574(VarCurr,2)
      <=> v62856(VarCurr,34) )
      & ( v63574(VarCurr,1)
      <=> v62856(VarCurr,33) )
      & ( v63574(VarCurr,0)
      <=> v62856(VarCurr,32) ) ) ).

tff(addAssignment_37049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_37048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_37047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_37046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_37045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_37044,axiom,
    ! [VarCurr: state_type] :
      ( v63114(VarCurr,3)
    <=> v63577(VarCurr) ) ).

tff(addAssignment_37043,axiom,
    ! [VarCurr: state_type] :
      ( v63114(VarCurr,2)
    <=> v63595(VarCurr) ) ).

tff(addAssignment_37042,axiom,
    ! [VarCurr: state_type] :
      ( v63114(VarCurr,1)
    <=> v63613(VarCurr) ) ).

tff(addAssignment_37041,axiom,
    ! [VarCurr: state_type] :
      ( v63114(VarCurr,0)
    <=> v63646(VarCurr) ) ).

tff(addAssignment_37040,axiom,
    ! [VarCurr: state_type] :
      ( v63646(VarCurr)
    <=> v63648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6011,axiom,
    ! [VarCurr: state_type] :
      ( v63648(VarCurr)
    <=> ( v63650(VarCurr)
      <~> v63654(VarCurr) ) ) ).

tff(addAssignment_37039,axiom,
    ! [VarCurr: state_type] :
      ( v63654(VarCurr)
    <=> v63656(VarCurr) ) ).

tff(addAssignment_37038,axiom,
    ! [VarCurr: state_type] :
      ( v63656(VarCurr)
    <=> v62876(VarCurr,39) ) ).

tff(addAssignment_37037,axiom,
    ! [VarCurr: state_type] :
      ( v63650(VarCurr)
    <=> v63652(VarCurr) ) ).

tff(addAssignment_37036,axiom,
    ! [VarCurr: state_type] :
      ( v63652(VarCurr)
    <=> v62876(VarCurr,37) ) ).

tff(addAssignment_37035,axiom,
    ! [VarCurr: state_type] :
      ( v63613(VarCurr)
    <=> v63615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6010,axiom,
    ! [VarCurr: state_type] :
      ( v63615(VarCurr)
    <=> ( v63617(VarCurr)
      <~> v63641(VarCurr) ) ) ).

tff(addAssignment_37034,axiom,
    ! [VarCurr: state_type] :
      ( v63641(VarCurr)
    <=> v63643(VarCurr) ) ).

tff(addAssignment_37033,axiom,
    ! [VarCurr: state_type] :
      ( v63643(VarCurr)
    <=> v62876(VarCurr,39) ) ).

tff(addAssignment_37032,axiom,
    ! [VarCurr: state_type] :
      ( v63617(VarCurr)
    <=> v63619(VarCurr) ) ).

tff(addAssignment_37031,axiom,
    ! [VarCurr: state_type] :
      ( v63619(VarCurr)
    <=> v63621(VarCurr) ) ).

tff(addAssignment_37030,axiom,
    ! [VarCurr: state_type] :
      ( v63621(VarCurr)
    <=> v63623(VarCurr) ) ).

tff(addAssignment_37029,axiom,
    ! [VarCurr: state_type] :
      ( v63623(VarCurr)
    <=> v63625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6009,axiom,
    ! [VarCurr: state_type] :
      ( v63625(VarCurr)
    <=> ( v63639(VarCurr)
      <~> v63635(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6008,axiom,
    ! [VarCurr: state_type] :
      ( v63639(VarCurr)
    <=> ( v63627(VarCurr)
      <~> v63631(VarCurr) ) ) ).

tff(addAssignment_37028,axiom,
    ! [VarCurr: state_type] :
      ( v63635(VarCurr)
    <=> v63637(VarCurr) ) ).

tff(addAssignment_37027,axiom,
    ! [VarCurr: state_type] :
      ( v63637(VarCurr)
    <=> v62876(VarCurr,38) ) ).

tff(addAssignment_37026,axiom,
    ! [VarCurr: state_type] :
      ( v63631(VarCurr)
    <=> v63633(VarCurr) ) ).

tff(addAssignment_37025,axiom,
    ! [VarCurr: state_type] :
      ( v63633(VarCurr)
    <=> v62876(VarCurr,37) ) ).

tff(addAssignment_37024,axiom,
    ! [VarCurr: state_type] :
      ( v63627(VarCurr)
    <=> v63629(VarCurr) ) ).

tff(addAssignment_37023,axiom,
    ! [VarCurr: state_type] :
      ( v63629(VarCurr)
    <=> v62876(VarCurr,36) ) ).

tff(addAssignment_37022,axiom,
    ! [VarCurr: state_type] :
      ( v63595(VarCurr)
    <=> v63597(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6007,axiom,
    ! [VarCurr: state_type] :
      ( v63597(VarCurr)
    <=> ( v63611(VarCurr)
      <~> v63607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6006,axiom,
    ! [VarCurr: state_type] :
      ( v63611(VarCurr)
    <=> ( v63599(VarCurr)
      <~> v63603(VarCurr) ) ) ).

tff(addAssignment_37021,axiom,
    ! [VarCurr: state_type] :
      ( v63607(VarCurr)
    <=> v63609(VarCurr) ) ).

tff(addAssignment_37020,axiom,
    ! [VarCurr: state_type] :
      ( v63609(VarCurr)
    <=> v62876(VarCurr,39) ) ).

tff(addAssignment_37019,axiom,
    ! [VarCurr: state_type] :
      ( v63603(VarCurr)
    <=> v63605(VarCurr) ) ).

tff(addAssignment_37018,axiom,
    ! [VarCurr: state_type] :
      ( v63605(VarCurr)
    <=> v62876(VarCurr,38) ) ).

tff(addAssignment_37017,axiom,
    ! [VarCurr: state_type] :
      ( v63599(VarCurr)
    <=> v63601(VarCurr) ) ).

tff(addAssignment_37016,axiom,
    ! [VarCurr: state_type] :
      ( v63601(VarCurr)
    <=> v62876(VarCurr,37) ) ).

tff(addAssignment_37015,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,37)
    <=> v62934(VarCurr,37) ) ).

tff(addAssignment_37014,axiom,
    ! [VarCurr: state_type] :
      ( v63577(VarCurr)
    <=> v63579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6005,axiom,
    ! [VarCurr: state_type] :
      ( v63579(VarCurr)
    <=> ( v63593(VarCurr)
      <~> v63589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6004,axiom,
    ! [VarCurr: state_type] :
      ( v63593(VarCurr)
    <=> ( v63581(VarCurr)
      <~> v63585(VarCurr) ) ) ).

tff(addAssignment_37013,axiom,
    ! [VarCurr: state_type] :
      ( v63589(VarCurr)
    <=> v63591(VarCurr) ) ).

tff(addAssignment_37012,axiom,
    ! [VarCurr: state_type] :
      ( v63591(VarCurr)
    <=> v62876(VarCurr,39) ) ).

tff(addAssignment_37011,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,39)
    <=> v62934(VarCurr,39) ) ).

tff(addAssignment_37010,axiom,
    ! [VarCurr: state_type] :
      ( v63585(VarCurr)
    <=> v63587(VarCurr) ) ).

tff(addAssignment_37009,axiom,
    ! [VarCurr: state_type] :
      ( v63587(VarCurr)
    <=> v62876(VarCurr,38) ) ).

tff(addAssignment_37008,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,38)
    <=> v62934(VarCurr,38) ) ).

tff(addAssignment_37007,axiom,
    ! [VarCurr: state_type] :
      ( v63581(VarCurr)
    <=> v63583(VarCurr) ) ).

tff(addAssignment_37006,axiom,
    ! [VarCurr: state_type] :
      ( v63583(VarCurr)
    <=> v62876(VarCurr,36) ) ).

tff(addAssignment_37005,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,36)
    <=> v62934(VarCurr,36) ) ).

tff(addAssignment_37004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63566(VarCurr,B)
      <=> v63568(VarCurr,B) ) ) ).

tff(addAssignment_37003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63568(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_37002,axiom,
    ! [VarCurr: state_type] :
      ( v63552(VarCurr)
    <=> v63554(VarCurr) ) ).

tff(addAssignment_37001,axiom,
    ! [VarCurr: state_type] :
      ( v63554(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_37000,axiom,
    ! [VarCurr: state_type] :
      ( v63451(VarCurr)
    <=> v63453(VarCurr) ) ).

tff(addAssignment_36999,axiom,
    ! [VarCurr: state_type] :
      ( v63453(VarCurr)
    <=> v63455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6003,axiom,
    ! [VarCurr: state_type] :
      ( v63455(VarCurr)
    <=> ( v63457(VarCurr)
        & v63461(VarCurr) ) ) ).

tff(addAssignment_36998,axiom,
    ! [VarCurr: state_type] :
      ( v63461(VarCurr)
    <=> v63463(VarCurr) ) ).

tff(addAssignment_36997,axiom,
    ! [VarCurr: state_type] :
      ( v63463(VarCurr)
    <=> v63465(VarCurr) ) ).

tff(addAssignment_36996,axiom,
    ! [VarCurr: state_type] :
      ( v63465(VarCurr)
    <=> v63467(VarCurr) ) ).

tff(addAssignment_36995,axiom,
    ! [VarCurr: state_type] :
      ( v63467(VarCurr)
    <=> v63469(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_238,axiom,
    ! [VarCurr: state_type] :
      ( v63469(VarCurr)
    <=> ( ( v63471(VarCurr,3)
        <=> v63475(VarCurr,3) )
        & ( v63471(VarCurr,2)
        <=> v63475(VarCurr,2) )
        & ( v63471(VarCurr,1)
        <=> v63475(VarCurr,1) )
        & ( v63471(VarCurr,0)
        <=> v63475(VarCurr,0) ) ) ) ).

tff(addAssignment_36994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63475(VarCurr,B)
      <=> v63477(VarCurr,B) ) ) ).

tff(addAssignment_36993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63477(VarCurr,B)
      <=> v63479(VarCurr,B) ) ) ).

tff(addAssignment_36992,axiom,
    ! [VarCurr: state_type] :
      ( ( v63479(VarCurr,3)
      <=> v62856(VarCurr,39) )
      & ( v63479(VarCurr,2)
      <=> v62856(VarCurr,38) )
      & ( v63479(VarCurr,1)
      <=> v62856(VarCurr,37) )
      & ( v63479(VarCurr,0)
      <=> v62856(VarCurr,36) ) ) ).

tff(addAssignment_36991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_36990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_36989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_36988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_36987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,40)
        & ~ $less(B,36) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_36986,axiom,
    ! [VarCurr: state_type] :
      ( v63113(VarCurr,3)
    <=> v63482(VarCurr) ) ).

tff(addAssignment_36985,axiom,
    ! [VarCurr: state_type] :
      ( v63113(VarCurr,2)
    <=> v63495(VarCurr) ) ).

tff(addAssignment_36984,axiom,
    ! [VarCurr: state_type] :
      ( v63113(VarCurr,1)
    <=> v63508(VarCurr) ) ).

tff(addAssignment_36983,axiom,
    ! [VarCurr: state_type] :
      ( v63113(VarCurr,0)
    <=> v63526(VarCurr) ) ).

tff(addAssignment_36982,axiom,
    ! [VarCurr: state_type] :
      ( v63526(VarCurr)
    <=> v63528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6002,axiom,
    ! [VarCurr: state_type] :
      ( v63528(VarCurr)
    <=> ( v63542(VarCurr)
      <~> v63538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6001,axiom,
    ! [VarCurr: state_type] :
      ( v63542(VarCurr)
    <=> ( v63530(VarCurr)
      <~> v63534(VarCurr) ) ) ).

tff(addAssignment_36981,axiom,
    ! [VarCurr: state_type] :
      ( v63538(VarCurr)
    <=> v63540(VarCurr) ) ).

tff(addAssignment_36980,axiom,
    ! [VarCurr: state_type] :
      ( v63540(VarCurr)
    <=> v62876(VarCurr,43) ) ).

tff(addAssignment_36979,axiom,
    ! [VarCurr: state_type] :
      ( v63534(VarCurr)
    <=> v63536(VarCurr) ) ).

tff(addAssignment_36978,axiom,
    ! [VarCurr: state_type] :
      ( v63536(VarCurr)
    <=> v62876(VarCurr,41) ) ).

tff(addAssignment_36977,axiom,
    ! [VarCurr: state_type] :
      ( v63530(VarCurr)
    <=> v63532(VarCurr) ) ).

tff(addAssignment_36976,axiom,
    ! [VarCurr: state_type] :
      ( v63532(VarCurr)
    <=> v62876(VarCurr,40) ) ).

tff(addAssignment_36975,axiom,
    ! [VarCurr: state_type] :
      ( v63508(VarCurr)
    <=> v63510(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6000,axiom,
    ! [VarCurr: state_type] :
      ( v63510(VarCurr)
    <=> ( v63524(VarCurr)
      <~> v63520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5999,axiom,
    ! [VarCurr: state_type] :
      ( v63524(VarCurr)
    <=> ( v63512(VarCurr)
      <~> v63516(VarCurr) ) ) ).

tff(addAssignment_36974,axiom,
    ! [VarCurr: state_type] :
      ( v63520(VarCurr)
    <=> v63522(VarCurr) ) ).

tff(addAssignment_36973,axiom,
    ! [VarCurr: state_type] :
      ( v63522(VarCurr)
    <=> v62876(VarCurr,43) ) ).

tff(addAssignment_36972,axiom,
    ! [VarCurr: state_type] :
      ( v63516(VarCurr)
    <=> v63518(VarCurr) ) ).

tff(addAssignment_36971,axiom,
    ! [VarCurr: state_type] :
      ( v63518(VarCurr)
    <=> v62876(VarCurr,42) ) ).

tff(addAssignment_36970,axiom,
    ! [VarCurr: state_type] :
      ( v63512(VarCurr)
    <=> v63514(VarCurr) ) ).

tff(addAssignment_36969,axiom,
    ! [VarCurr: state_type] :
      ( v63514(VarCurr)
    <=> v62876(VarCurr,40) ) ).

tff(addAssignment_36968,axiom,
    ! [VarCurr: state_type] :
      ( v63495(VarCurr)
    <=> v63497(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5998,axiom,
    ! [VarCurr: state_type] :
      ( v63497(VarCurr)
    <=> ( v63499(VarCurr)
      <~> v63503(VarCurr) ) ) ).

tff(addAssignment_36967,axiom,
    ! [VarCurr: state_type] :
      ( v63503(VarCurr)
    <=> v63505(VarCurr) ) ).

tff(addAssignment_36966,axiom,
    ! [VarCurr: state_type] :
      ( v63505(VarCurr)
    <=> v62876(VarCurr,41) ) ).

tff(addAssignment_36965,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,41)
    <=> v62934(VarCurr,41) ) ).

tff(addAssignment_36964,axiom,
    ! [VarCurr: state_type] :
      ( v63499(VarCurr)
    <=> v63501(VarCurr) ) ).

tff(addAssignment_36963,axiom,
    ! [VarCurr: state_type] :
      ( v63501(VarCurr)
    <=> v62876(VarCurr,43) ) ).

tff(addAssignment_36962,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,43)
    <=> v62934(VarCurr,43) ) ).

tff(addAssignment_36961,axiom,
    ! [VarCurr: state_type] :
      ( v63482(VarCurr)
    <=> v63484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5997,axiom,
    ! [VarCurr: state_type] :
      ( v63484(VarCurr)
    <=> ( v63486(VarCurr)
      <~> v63490(VarCurr) ) ) ).

tff(addAssignment_36960,axiom,
    ! [VarCurr: state_type] :
      ( v63490(VarCurr)
    <=> v63492(VarCurr) ) ).

tff(addAssignment_36959,axiom,
    ! [VarCurr: state_type] :
      ( v63492(VarCurr)
    <=> v62876(VarCurr,42) ) ).

tff(addAssignment_36958,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,42)
    <=> v62934(VarCurr,42) ) ).

tff(addAssignment_36957,axiom,
    ! [VarCurr: state_type] :
      ( v63486(VarCurr)
    <=> v63488(VarCurr) ) ).

tff(addAssignment_36956,axiom,
    ! [VarCurr: state_type] :
      ( v63488(VarCurr)
    <=> v62876(VarCurr,40) ) ).

tff(addAssignment_36955,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,40)
    <=> v62934(VarCurr,40) ) ).

tff(addAssignment_36954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63471(VarCurr,B)
      <=> v63473(VarCurr,B) ) ) ).

tff(addAssignment_36953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63473(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_36952,axiom,
    ! [VarCurr: state_type] :
      ( v63457(VarCurr)
    <=> v63459(VarCurr) ) ).

tff(addAssignment_36951,axiom,
    ! [VarCurr: state_type] :
      ( v63459(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_36950,axiom,
    ! [VarCurr: state_type] :
      ( v63321(VarCurr)
    <=> v63323(VarCurr) ) ).

tff(addAssignment_36949,axiom,
    ! [VarCurr: state_type] :
      ( v63323(VarCurr)
    <=> v63325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5996,axiom,
    ! [VarCurr: state_type] :
      ( v63325(VarCurr)
    <=> ( v63327(VarCurr)
        & v63331(VarCurr) ) ) ).

tff(addAssignment_36948,axiom,
    ! [VarCurr: state_type] :
      ( v63331(VarCurr)
    <=> v63333(VarCurr) ) ).

tff(addAssignment_36947,axiom,
    ! [VarCurr: state_type] :
      ( v63333(VarCurr)
    <=> v63335(VarCurr) ) ).

tff(addAssignment_36946,axiom,
    ! [VarCurr: state_type] :
      ( v63335(VarCurr)
    <=> v63337(VarCurr) ) ).

tff(addAssignment_36945,axiom,
    ! [VarCurr: state_type] :
      ( v63337(VarCurr)
    <=> v63339(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_237,axiom,
    ! [VarCurr: state_type] :
      ( v63339(VarCurr)
    <=> ( ( v63341(VarCurr,3)
        <=> v63345(VarCurr,3) )
        & ( v63341(VarCurr,2)
        <=> v63345(VarCurr,2) )
        & ( v63341(VarCurr,1)
        <=> v63345(VarCurr,1) )
        & ( v63341(VarCurr,0)
        <=> v63345(VarCurr,0) ) ) ) ).

tff(addAssignment_36944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63345(VarCurr,B)
      <=> v63347(VarCurr,B) ) ) ).

tff(addAssignment_36943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63347(VarCurr,B)
      <=> v63349(VarCurr,B) ) ) ).

tff(addAssignment_36942,axiom,
    ! [VarCurr: state_type] :
      ( ( v63349(VarCurr,3)
      <=> v62856(VarCurr,43) )
      & ( v63349(VarCurr,2)
      <=> v62856(VarCurr,42) )
      & ( v63349(VarCurr,1)
      <=> v62856(VarCurr,41) )
      & ( v63349(VarCurr,0)
      <=> v62856(VarCurr,40) ) ) ).

tff(addAssignment_36941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_36940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_36939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_36938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_36937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,44)
        & ~ $less(B,40) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_36936,axiom,
    ! [VarCurr: state_type] :
      ( v63112(VarCurr,3)
    <=> v63352(VarCurr) ) ).

tff(addAssignment_36935,axiom,
    ! [VarCurr: state_type] :
      ( v63112(VarCurr,2)
    <=> v63400(VarCurr) ) ).

tff(addAssignment_36934,axiom,
    ! [VarCurr: state_type] :
      ( v63112(VarCurr,1)
    <=> v63423(VarCurr) ) ).

tff(addAssignment_36933,axiom,
    ! [VarCurr: state_type] :
      ( v63112(VarCurr,0)
    <=> v63436(VarCurr) ) ).

tff(addAssignment_36932,axiom,
    ! [VarCurr: state_type] :
      ( v63436(VarCurr)
    <=> v63438(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5995,axiom,
    ! [VarCurr: state_type] :
      ( v63438(VarCurr)
    <=> ( v63440(VarCurr)
      <~> v63444(VarCurr) ) ) ).

tff(addAssignment_36931,axiom,
    ! [VarCurr: state_type] :
      ( v63444(VarCurr)
    <=> v63446(VarCurr) ) ).

tff(addAssignment_36930,axiom,
    ! [VarCurr: state_type] :
      ( v63446(VarCurr)
    <=> v62876(VarCurr,46) ) ).

tff(addAssignment_36929,axiom,
    ! [VarCurr: state_type] :
      ( v63440(VarCurr)
    <=> v63442(VarCurr) ) ).

tff(addAssignment_36928,axiom,
    ! [VarCurr: state_type] :
      ( v63442(VarCurr)
    <=> v62876(VarCurr,45) ) ).

tff(addAssignment_36927,axiom,
    ! [VarCurr: state_type] :
      ( v63423(VarCurr)
    <=> v63425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5994,axiom,
    ! [VarCurr: state_type] :
      ( v63425(VarCurr)
    <=> ( v63427(VarCurr)
      <~> v63431(VarCurr) ) ) ).

tff(addAssignment_36926,axiom,
    ! [VarCurr: state_type] :
      ( v63431(VarCurr)
    <=> v63433(VarCurr) ) ).

tff(addAssignment_36925,axiom,
    ! [VarCurr: state_type] :
      ( v63433(VarCurr)
    <=> v62876(VarCurr,47) ) ).

tff(addAssignment_36924,axiom,
    ! [VarCurr: state_type] :
      ( v63427(VarCurr)
    <=> v63429(VarCurr) ) ).

tff(addAssignment_36923,axiom,
    ! [VarCurr: state_type] :
      ( v63429(VarCurr)
    <=> v62876(VarCurr,45) ) ).

tff(addAssignment_36922,axiom,
    ! [VarCurr: state_type] :
      ( v63400(VarCurr)
    <=> v63402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5993,axiom,
    ! [VarCurr: state_type] :
      ( v63402(VarCurr)
    <=> ( v63404(VarCurr)
      <~> v63408(VarCurr) ) ) ).

tff(addAssignment_36921,axiom,
    ! [VarCurr: state_type] :
      ( v63408(VarCurr)
    <=> v63410(VarCurr) ) ).

tff(addAssignment_36920,axiom,
    ! [VarCurr: state_type] :
      ( v63410(VarCurr)
    <=> v62876(VarCurr,46) ) ).

tff(addAssignment_36919,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,46)
    <=> v62934(VarCurr,46) ) ).

tff(addAssignment_36918,axiom,
    ! [VarCurr: state_type] :
      ( v62967(VarCurr)
    <=> v63413(VarCurr) ) ).

tff(addAssignment_36917,axiom,
    ! [VarCurr: state_type] :
      ( v63413(VarCurr)
    <=> v63415(VarCurr) ) ).

tff(writeUnaryOperator_3215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63415(VarCurr)
    <=> v63417(VarCurr) ) ).

tff(addAssignment_36916,axiom,
    ! [VarCurr: state_type] :
      ( v63417(VarCurr)
    <=> v63419(VarCurr) ) ).

tff(addAssignment_36915,axiom,
    ! [VarCurr: state_type] :
      ( v63419(VarCurr)
    <=> v63021(VarCurr) ) ).

tff(addAssignment_36914,axiom,
    ! [VarCurr: state_type] :
      ( v63404(VarCurr)
    <=> v63406(VarCurr) ) ).

tff(addAssignment_36913,axiom,
    ! [VarCurr: state_type] :
      ( v63406(VarCurr)
    <=> v62876(VarCurr,44) ) ).

tff(addAssignment_36912,axiom,
    ! [VarCurr: state_type] :
      ( v63352(VarCurr)
    <=> v63354(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5992,axiom,
    ! [VarCurr: state_type] :
      ( v63354(VarCurr)
    <=> ( v63398(VarCurr)
      <~> v63384(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5991,axiom,
    ! [VarCurr: state_type] :
      ( v63398(VarCurr)
    <=> ( v63356(VarCurr)
      <~> v63370(VarCurr) ) ) ).

tff(addAssignment_36911,axiom,
    ! [VarCurr: state_type] :
      ( v63384(VarCurr)
    <=> v63386(VarCurr) ) ).

tff(addAssignment_36910,axiom,
    ! [VarCurr: state_type] :
      ( v63386(VarCurr)
    <=> v62876(VarCurr,47) ) ).

tff(addAssignment_36909,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,47)
    <=> v62934(VarCurr,47) ) ).

tff(addAssignment_36908,axiom,
    ! [VarCurr: state_type] :
      ( v62966(VarCurr)
    <=> v63389(VarCurr) ) ).

tff(addAssignment_36907,axiom,
    ! [VarCurr: state_type] :
      ( v63389(VarCurr)
    <=> v63391(VarCurr) ) ).

tff(writeUnaryOperator_3214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63391(VarCurr)
    <=> v63393(VarCurr) ) ).

tff(addAssignment_36906,axiom,
    ! [VarCurr: state_type] :
      ( v63393(VarCurr)
    <=> v63395(VarCurr) ) ).

tff(addAssignment_36905,axiom,
    ! [VarCurr: state_type] :
      ( v63395(VarCurr)
    <=> v63097(VarCurr) ) ).

tff(addAssignment_36904,axiom,
    ! [VarCurr: state_type] :
      ( v63370(VarCurr)
    <=> v63372(VarCurr) ) ).

tff(addAssignment_36903,axiom,
    ! [VarCurr: state_type] :
      ( v63372(VarCurr)
    <=> v62876(VarCurr,45) ) ).

tff(addAssignment_36902,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,45)
    <=> v62934(VarCurr,45) ) ).

tff(addAssignment_36901,axiom,
    ! [VarCurr: state_type] :
      ( v62968(VarCurr)
    <=> v63375(VarCurr) ) ).

tff(addAssignment_36900,axiom,
    ! [VarCurr: state_type] :
      ( v63375(VarCurr)
    <=> v63377(VarCurr) ) ).

tff(writeUnaryOperator_3213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63377(VarCurr)
    <=> v63379(VarCurr) ) ).

tff(addAssignment_36899,axiom,
    ! [VarCurr: state_type] :
      ( v63379(VarCurr)
    <=> v63381(VarCurr) ) ).

tff(addAssignment_36898,axiom,
    ! [VarCurr: state_type] :
      ( v63381(VarCurr)
    <=> v62996(VarCurr) ) ).

tff(addAssignment_36897,axiom,
    ! [VarCurr: state_type] :
      ( v63356(VarCurr)
    <=> v63358(VarCurr) ) ).

tff(addAssignment_36896,axiom,
    ! [VarCurr: state_type] :
      ( v63358(VarCurr)
    <=> v62876(VarCurr,44) ) ).

tff(addAssignment_36895,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,44)
    <=> v62934(VarCurr,44) ) ).

tff(addAssignment_36894,axiom,
    ! [VarCurr: state_type] :
      ( v62969(VarCurr)
    <=> v63361(VarCurr) ) ).

tff(addAssignment_36893,axiom,
    ! [VarCurr: state_type] :
      ( v63361(VarCurr)
    <=> v63363(VarCurr) ) ).

tff(writeUnaryOperator_3212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63363(VarCurr)
    <=> v63365(VarCurr) ) ).

tff(addAssignment_36892,axiom,
    ! [VarCurr: state_type] :
      ( v63365(VarCurr)
    <=> v63367(VarCurr) ) ).

tff(addAssignment_36891,axiom,
    ! [VarCurr: state_type] :
      ( v63367(VarCurr)
    <=> v62888(VarCurr) ) ).

tff(addAssignment_36890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63341(VarCurr,B)
      <=> v63343(VarCurr,B) ) ) ).

tff(addAssignment_36889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63343(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_36888,axiom,
    ! [VarCurr: state_type] :
      ( v63327(VarCurr)
    <=> v63329(VarCurr) ) ).

tff(addAssignment_36887,axiom,
    ! [VarCurr: state_type] :
      ( v63329(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_36886,axiom,
    ! [VarCurr: state_type] :
      ( v63241(VarCurr)
    <=> v63243(VarCurr) ) ).

tff(addAssignment_36885,axiom,
    ! [VarCurr: state_type] :
      ( v63243(VarCurr)
    <=> v63245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5990,axiom,
    ! [VarCurr: state_type] :
      ( v63245(VarCurr)
    <=> ( v63247(VarCurr)
        & v63251(VarCurr) ) ) ).

tff(addAssignment_36884,axiom,
    ! [VarCurr: state_type] :
      ( v63251(VarCurr)
    <=> v63253(VarCurr) ) ).

tff(addAssignment_36883,axiom,
    ! [VarCurr: state_type] :
      ( v63253(VarCurr)
    <=> v63255(VarCurr) ) ).

tff(addAssignment_36882,axiom,
    ! [VarCurr: state_type] :
      ( v63255(VarCurr)
    <=> v63257(VarCurr) ) ).

tff(addAssignment_36881,axiom,
    ! [VarCurr: state_type] :
      ( v63257(VarCurr)
    <=> v63259(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_236,axiom,
    ! [VarCurr: state_type] :
      ( v63259(VarCurr)
    <=> ( ( v63261(VarCurr,3)
        <=> v63265(VarCurr,3) )
        & ( v63261(VarCurr,2)
        <=> v63265(VarCurr,2) )
        & ( v63261(VarCurr,1)
        <=> v63265(VarCurr,1) )
        & ( v63261(VarCurr,0)
        <=> v63265(VarCurr,0) ) ) ) ).

tff(addAssignment_36880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63265(VarCurr,B)
      <=> v63267(VarCurr,B) ) ) ).

tff(addAssignment_36879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63267(VarCurr,B)
      <=> v63269(VarCurr,B) ) ) ).

tff(addAssignment_36878,axiom,
    ! [VarCurr: state_type] :
      ( ( v63269(VarCurr,3)
      <=> v62856(VarCurr,47) )
      & ( v63269(VarCurr,2)
      <=> v62856(VarCurr,46) )
      & ( v63269(VarCurr,1)
      <=> v62856(VarCurr,45) )
      & ( v63269(VarCurr,0)
      <=> v62856(VarCurr,44) ) ) ).

tff(addAssignment_36877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_36876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_36875,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_36874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_36873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,44) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_36872,axiom,
    ! [VarCurr: state_type] :
      ( v63111(VarCurr,3)
    <=> v63272(VarCurr) ) ).

tff(addAssignment_36871,axiom,
    ! [VarCurr: state_type] :
      ( v63111(VarCurr,2)
    <=> v63285(VarCurr) ) ).

tff(addAssignment_36870,axiom,
    ! [VarCurr: state_type] :
      ( v63111(VarCurr,1)
    <=> v63293(VarCurr) ) ).

tff(addAssignment_36869,axiom,
    ! [VarCurr: state_type] :
      ( v63111(VarCurr,0)
    <=> v63301(VarCurr) ) ).

tff(addAssignment_36868,axiom,
    ! [VarCurr: state_type] :
      ( v63301(VarCurr)
    <=> v63303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5989,axiom,
    ! [VarCurr: state_type] :
      ( v63303(VarCurr)
    <=> ( v63317(VarCurr)
      <~> v63313(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5988,axiom,
    ! [VarCurr: state_type] :
      ( v63317(VarCurr)
    <=> ( v63305(VarCurr)
      <~> v63309(VarCurr) ) ) ).

tff(addAssignment_36867,axiom,
    ! [VarCurr: state_type] :
      ( v63313(VarCurr)
    <=> v63315(VarCurr) ) ).

tff(addAssignment_36866,axiom,
    ! [VarCurr: state_type] :
      ( v63315(VarCurr)
    <=> v62876(VarCurr,50) ) ).

tff(addAssignment_36865,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,50)
    <=> v62934(VarCurr,50) ) ).

tff(addAssignment_36864,axiom,
    ! [VarCurr: state_type] :
      ( v63309(VarCurr)
    <=> v63311(VarCurr) ) ).

tff(addAssignment_36863,axiom,
    ! [VarCurr: state_type] :
      ( v63311(VarCurr)
    <=> v62876(VarCurr,49) ) ).

tff(addAssignment_36862,axiom,
    ! [VarCurr: state_type] :
      ( v63305(VarCurr)
    <=> v63307(VarCurr) ) ).

tff(addAssignment_36861,axiom,
    ! [VarCurr: state_type] :
      ( v63307(VarCurr)
    <=> v62876(VarCurr,48) ) ).

tff(addAssignment_36860,axiom,
    ! [VarCurr: state_type] :
      ( v63293(VarCurr)
    <=> v63295(VarCurr) ) ).

tff(addAssignment_36859,axiom,
    ! [VarCurr: state_type] :
      ( v63295(VarCurr)
    <=> v63297(VarCurr) ) ).

tff(addAssignment_36858,axiom,
    ! [VarCurr: state_type] :
      ( v63297(VarCurr)
    <=> v63299(VarCurr) ) ).

tff(addAssignment_36857,axiom,
    ! [VarCurr: state_type] :
      ( v63299(VarCurr)
    <=> v62876(VarCurr,51) ) ).

tff(addAssignment_36856,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,51)
    <=> v62934(VarCurr,51) ) ).

tff(addAssignment_36855,axiom,
    ! [VarCurr: state_type] :
      ( v63285(VarCurr)
    <=> v63287(VarCurr) ) ).

tff(addAssignment_36854,axiom,
    ! [VarCurr: state_type] :
      ( v63287(VarCurr)
    <=> v63289(VarCurr) ) ).

tff(addAssignment_36853,axiom,
    ! [VarCurr: state_type] :
      ( v63289(VarCurr)
    <=> v63291(VarCurr) ) ).

tff(addAssignment_36852,axiom,
    ! [VarCurr: state_type] :
      ( v63291(VarCurr)
    <=> v62876(VarCurr,48) ) ).

tff(addAssignment_36851,axiom,
    ! [VarCurr: state_type] :
      ( v63272(VarCurr)
    <=> v63274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5987,axiom,
    ! [VarCurr: state_type] :
      ( v63274(VarCurr)
    <=> ( v63276(VarCurr)
      <~> v63280(VarCurr) ) ) ).

tff(addAssignment_36850,axiom,
    ! [VarCurr: state_type] :
      ( v63280(VarCurr)
    <=> v63282(VarCurr) ) ).

tff(addAssignment_36849,axiom,
    ! [VarCurr: state_type] :
      ( v63282(VarCurr)
    <=> v62876(VarCurr,49) ) ).

tff(addAssignment_36848,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,49)
    <=> v62934(VarCurr,49) ) ).

tff(addAssignment_36847,axiom,
    ! [VarCurr: state_type] :
      ( v63276(VarCurr)
    <=> v63278(VarCurr) ) ).

tff(addAssignment_36846,axiom,
    ! [VarCurr: state_type] :
      ( v63278(VarCurr)
    <=> v62876(VarCurr,48) ) ).

tff(addAssignment_36845,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,48)
    <=> v62934(VarCurr,48) ) ).

tff(addAssignment_36844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63261(VarCurr,B)
      <=> v63263(VarCurr,B) ) ) ).

tff(addAssignment_36843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63263(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_36842,axiom,
    ! [VarCurr: state_type] :
      ( v63247(VarCurr)
    <=> v63249(VarCurr) ) ).

tff(addAssignment_36841,axiom,
    ! [VarCurr: state_type] :
      ( v63249(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_36840,axiom,
    ! [VarCurr: state_type] :
      ( v63126(VarCurr)
    <=> v63128(VarCurr) ) ).

tff(addAssignment_36839,axiom,
    ! [VarCurr: state_type] :
      ( v63128(VarCurr)
    <=> v63130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5986,axiom,
    ! [VarCurr: state_type] :
      ( v63130(VarCurr)
    <=> ( v63132(VarCurr)
        & v63136(VarCurr) ) ) ).

tff(addAssignment_36838,axiom,
    ! [VarCurr: state_type] :
      ( v63136(VarCurr)
    <=> v63138(VarCurr) ) ).

tff(addAssignment_36837,axiom,
    ! [VarCurr: state_type] :
      ( v63138(VarCurr)
    <=> v63140(VarCurr) ) ).

tff(addAssignment_36836,axiom,
    ! [VarCurr: state_type] :
      ( v63140(VarCurr)
    <=> v63142(VarCurr) ) ).

tff(addAssignment_36835,axiom,
    ! [VarCurr: state_type] :
      ( v63142(VarCurr)
    <=> v63144(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_235,axiom,
    ! [VarCurr: state_type] :
      ( v63144(VarCurr)
    <=> ( ( v63146(VarCurr,3)
        <=> v63150(VarCurr,3) )
        & ( v63146(VarCurr,2)
        <=> v63150(VarCurr,2) )
        & ( v63146(VarCurr,1)
        <=> v63150(VarCurr,1) )
        & ( v63146(VarCurr,0)
        <=> v63150(VarCurr,0) ) ) ) ).

tff(addAssignment_36834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63150(VarCurr,B)
      <=> v63152(VarCurr,B) ) ) ).

tff(addAssignment_36833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63152(VarCurr,B)
      <=> v63154(VarCurr,B) ) ) ).

tff(addAssignment_36832,axiom,
    ! [VarCurr: state_type] :
      ( ( v63154(VarCurr,3)
      <=> v62856(VarCurr,51) )
      & ( v63154(VarCurr,2)
      <=> v62856(VarCurr,50) )
      & ( v63154(VarCurr,1)
      <=> v62856(VarCurr,49) )
      & ( v63154(VarCurr,0)
      <=> v62856(VarCurr,48) ) ) ).

tff(addAssignment_36831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_36830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_36829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_36828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_36827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,52)
        & ~ $less(B,48) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_36826,axiom,
    ! [VarCurr: state_type] :
      ( v63110(VarCurr,3)
    <=> v63157(VarCurr) ) ).

tff(addAssignment_36825,axiom,
    ! [VarCurr: state_type] :
      ( v63110(VarCurr,2)
    <=> v63190(VarCurr) ) ).

tff(addAssignment_36824,axiom,
    ! [VarCurr: state_type] :
      ( v63110(VarCurr,1)
    <=> v63208(VarCurr) ) ).

tff(addAssignment_36823,axiom,
    ! [VarCurr: state_type] :
      ( v63110(VarCurr,0)
    <=> v63221(VarCurr) ) ).

tff(addAssignment_36822,axiom,
    ! [VarCurr: state_type] :
      ( v63221(VarCurr)
    <=> v63223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5985,axiom,
    ! [VarCurr: state_type] :
      ( v63223(VarCurr)
    <=> ( v63237(VarCurr)
      <~> v63233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5984,axiom,
    ! [VarCurr: state_type] :
      ( v63237(VarCurr)
    <=> ( v63225(VarCurr)
      <~> v63229(VarCurr) ) ) ).

tff(addAssignment_36821,axiom,
    ! [VarCurr: state_type] :
      ( v63233(VarCurr)
    <=> v63235(VarCurr) ) ).

tff(addAssignment_36820,axiom,
    ! [VarCurr: state_type] :
      ( v63235(VarCurr)
    <=> v62876(VarCurr,55) ) ).

tff(addAssignment_36819,axiom,
    ! [VarCurr: state_type] :
      ( v63229(VarCurr)
    <=> v63231(VarCurr) ) ).

tff(addAssignment_36818,axiom,
    ! [VarCurr: state_type] :
      ( v63231(VarCurr)
    <=> v62876(VarCurr,54) ) ).

tff(addAssignment_36817,axiom,
    ! [VarCurr: state_type] :
      ( v63225(VarCurr)
    <=> v63227(VarCurr) ) ).

tff(addAssignment_36816,axiom,
    ! [VarCurr: state_type] :
      ( v63227(VarCurr)
    <=> v62876(VarCurr,53) ) ).

tff(addAssignment_36815,axiom,
    ! [VarCurr: state_type] :
      ( v63208(VarCurr)
    <=> v63210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5983,axiom,
    ! [VarCurr: state_type] :
      ( v63210(VarCurr)
    <=> ( v63212(VarCurr)
      <~> v63216(VarCurr) ) ) ).

tff(addAssignment_36814,axiom,
    ! [VarCurr: state_type] :
      ( v63216(VarCurr)
    <=> v63218(VarCurr) ) ).

tff(addAssignment_36813,axiom,
    ! [VarCurr: state_type] :
      ( v63218(VarCurr)
    <=> v62876(VarCurr,53) ) ).

tff(addAssignment_36812,axiom,
    ! [VarCurr: state_type] :
      ( v63212(VarCurr)
    <=> v63214(VarCurr) ) ).

tff(addAssignment_36811,axiom,
    ! [VarCurr: state_type] :
      ( v63214(VarCurr)
    <=> v62876(VarCurr,52) ) ).

tff(addAssignment_36810,axiom,
    ! [VarCurr: state_type] :
      ( v63190(VarCurr)
    <=> v63192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5982,axiom,
    ! [VarCurr: state_type] :
      ( v63192(VarCurr)
    <=> ( v63206(VarCurr)
      <~> v63202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5981,axiom,
    ! [VarCurr: state_type] :
      ( v63206(VarCurr)
    <=> ( v63194(VarCurr)
      <~> v63198(VarCurr) ) ) ).

tff(addAssignment_36809,axiom,
    ! [VarCurr: state_type] :
      ( v63202(VarCurr)
    <=> v63204(VarCurr) ) ).

tff(addAssignment_36808,axiom,
    ! [VarCurr: state_type] :
      ( v63204(VarCurr)
    <=> v62876(VarCurr,54) ) ).

tff(addAssignment_36807,axiom,
    ! [VarCurr: state_type] :
      ( v63198(VarCurr)
    <=> v63200(VarCurr) ) ).

tff(addAssignment_36806,axiom,
    ! [VarCurr: state_type] :
      ( v63200(VarCurr)
    <=> v62876(VarCurr,53) ) ).

tff(addAssignment_36805,axiom,
    ! [VarCurr: state_type] :
      ( v63194(VarCurr)
    <=> v63196(VarCurr) ) ).

tff(addAssignment_36804,axiom,
    ! [VarCurr: state_type] :
      ( v63196(VarCurr)
    <=> v62876(VarCurr,52) ) ).

tff(addAssignment_36803,axiom,
    ! [VarCurr: state_type] :
      ( v63157(VarCurr)
    <=> v63159(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5980,axiom,
    ! [VarCurr: state_type] :
      ( v63159(VarCurr)
    <=> ( v63161(VarCurr)
      <~> v63185(VarCurr) ) ) ).

tff(addAssignment_36802,axiom,
    ! [VarCurr: state_type] :
      ( v63185(VarCurr)
    <=> v63187(VarCurr) ) ).

tff(addAssignment_36801,axiom,
    ! [VarCurr: state_type] :
      ( v63187(VarCurr)
    <=> v62876(VarCurr,55) ) ).

tff(addAssignment_36800,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,55)
    <=> v62934(VarCurr,55) ) ).

tff(addAssignment_36799,axiom,
    ! [VarCurr: state_type] :
      ( v63161(VarCurr)
    <=> v63163(VarCurr) ) ).

tff(addAssignment_36798,axiom,
    ! [VarCurr: state_type] :
      ( v63163(VarCurr)
    <=> v63165(VarCurr) ) ).

tff(addAssignment_36797,axiom,
    ! [VarCurr: state_type] :
      ( v63165(VarCurr)
    <=> v63167(VarCurr) ) ).

tff(addAssignment_36796,axiom,
    ! [VarCurr: state_type] :
      ( v63167(VarCurr)
    <=> v63169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5979,axiom,
    ! [VarCurr: state_type] :
      ( v63169(VarCurr)
    <=> ( v63183(VarCurr)
      <~> v63179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5978,axiom,
    ! [VarCurr: state_type] :
      ( v63183(VarCurr)
    <=> ( v63171(VarCurr)
      <~> v63175(VarCurr) ) ) ).

tff(addAssignment_36795,axiom,
    ! [VarCurr: state_type] :
      ( v63179(VarCurr)
    <=> v63181(VarCurr) ) ).

tff(addAssignment_36794,axiom,
    ! [VarCurr: state_type] :
      ( v63181(VarCurr)
    <=> v62876(VarCurr,54) ) ).

tff(addAssignment_36793,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,54)
    <=> v62934(VarCurr,54) ) ).

tff(addAssignment_36792,axiom,
    ! [VarCurr: state_type] :
      ( v63175(VarCurr)
    <=> v63177(VarCurr) ) ).

tff(addAssignment_36791,axiom,
    ! [VarCurr: state_type] :
      ( v63177(VarCurr)
    <=> v62876(VarCurr,53) ) ).

tff(addAssignment_36790,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,53)
    <=> v62934(VarCurr,53) ) ).

tff(addAssignment_36789,axiom,
    ! [VarCurr: state_type] :
      ( v63171(VarCurr)
    <=> v63173(VarCurr) ) ).

tff(addAssignment_36788,axiom,
    ! [VarCurr: state_type] :
      ( v63173(VarCurr)
    <=> v62876(VarCurr,52) ) ).

tff(addAssignment_36787,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,52)
    <=> v62934(VarCurr,52) ) ).

tff(addAssignment_36786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63146(VarCurr,B)
      <=> v63148(VarCurr,B) ) ) ).

tff(addAssignment_36785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63148(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_36784,axiom,
    ! [VarCurr: state_type] :
      ( v63132(VarCurr)
    <=> v63134(VarCurr) ) ).

tff(addAssignment_36783,axiom,
    ! [VarCurr: state_type] :
      ( v63134(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_36782,axiom,
    ! [VarCurr: state_type] :
      ( v62811(VarCurr)
    <=> v62813(VarCurr) ) ).

tff(addAssignment_36781,axiom,
    ! [VarCurr: state_type] :
      ( v62813(VarCurr)
    <=> v62815(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5977,axiom,
    ! [VarCurr: state_type] :
      ( v62815(VarCurr)
    <=> ( v62817(VarCurr)
        & v62836(VarCurr) ) ) ).

tff(addAssignment_36780,axiom,
    ! [VarCurr: state_type] :
      ( v62836(VarCurr)
    <=> v62838(VarCurr) ) ).

tff(addAssignment_36779,axiom,
    ! [VarCurr: state_type] :
      ( v62838(VarCurr)
    <=> v62840(VarCurr) ) ).

tff(addAssignment_36778,axiom,
    ! [VarCurr: state_type] :
      ( v62840(VarCurr)
    <=> v62842(VarCurr) ) ).

tff(addAssignment_36777,axiom,
    ! [VarCurr: state_type] :
      ( v62842(VarCurr)
    <=> v62844(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_234,axiom,
    ! [VarCurr: state_type] :
      ( v62844(VarCurr)
    <=> ( ( v62846(VarCurr,3)
        <=> v62850(VarCurr,3) )
        & ( v62846(VarCurr,2)
        <=> v62850(VarCurr,2) )
        & ( v62846(VarCurr,1)
        <=> v62850(VarCurr,1) )
        & ( v62846(VarCurr,0)
        <=> v62850(VarCurr,0) ) ) ) ).

tff(addAssignment_36776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62850(VarCurr,B)
      <=> v62852(VarCurr,B) ) ) ).

tff(addAssignment_36775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62852(VarCurr,B)
      <=> v62854(VarCurr,B) ) ) ).

tff(addAssignment_36774,axiom,
    ! [VarCurr: state_type] :
      ( ( v62854(VarCurr,3)
      <=> v62856(VarCurr,55) )
      & ( v62854(VarCurr,2)
      <=> v62856(VarCurr,54) )
      & ( v62854(VarCurr,1)
      <=> v62856(VarCurr,53) )
      & ( v62854(VarCurr,0)
      <=> v62856(VarCurr,52) ) ) ).

tff(addAssignment_36773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v62856(VarCurr,B)
      <=> v62858(VarCurr,B) ) ) ).

tff(addAssignment_36772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v62858(VarCurr,B)
      <=> v62860(VarCurr,B) ) ) ).

tff(addAssignment_36771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v62860(VarCurr,B)
      <=> v62862(VarCurr,B) ) ) ).

tff(addAssignment_36770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v62862(VarCurr,B)
      <=> v62864(VarCurr,B) ) ) ).

tff(addAssignment_36769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,56)
        & ~ $less(B,52) )
     => ( v62864(VarCurr,B)
      <=> v63109(VarCurr,B) ) ) ).

tff(addAssignment_36768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v63109(VarCurr,B)
      <=> v63122(VarCurr,B) ) ) ).

tff(addAssignment_36767,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,7)
      <=> v63121(VarCurr,3) )
      & ( v63109(VarCurr,6)
      <=> v63121(VarCurr,2) )
      & ( v63109(VarCurr,5)
      <=> v63121(VarCurr,1) )
      & ( v63109(VarCurr,4)
      <=> v63121(VarCurr,0) ) ) ).

tff(addAssignment_36766,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,11)
      <=> v63120(VarCurr,3) )
      & ( v63109(VarCurr,10)
      <=> v63120(VarCurr,2) )
      & ( v63109(VarCurr,9)
      <=> v63120(VarCurr,1) )
      & ( v63109(VarCurr,8)
      <=> v63120(VarCurr,0) ) ) ).

tff(addAssignment_36765,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,15)
      <=> v63119(VarCurr,3) )
      & ( v63109(VarCurr,14)
      <=> v63119(VarCurr,2) )
      & ( v63109(VarCurr,13)
      <=> v63119(VarCurr,1) )
      & ( v63109(VarCurr,12)
      <=> v63119(VarCurr,0) ) ) ).

tff(addAssignment_36764,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,19)
      <=> v63118(VarCurr,3) )
      & ( v63109(VarCurr,18)
      <=> v63118(VarCurr,2) )
      & ( v63109(VarCurr,17)
      <=> v63118(VarCurr,1) )
      & ( v63109(VarCurr,16)
      <=> v63118(VarCurr,0) ) ) ).

tff(addAssignment_36763,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,23)
      <=> v63117(VarCurr,3) )
      & ( v63109(VarCurr,22)
      <=> v63117(VarCurr,2) )
      & ( v63109(VarCurr,21)
      <=> v63117(VarCurr,1) )
      & ( v63109(VarCurr,20)
      <=> v63117(VarCurr,0) ) ) ).

tff(addAssignment_36762,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,27)
      <=> v63116(VarCurr,3) )
      & ( v63109(VarCurr,26)
      <=> v63116(VarCurr,2) )
      & ( v63109(VarCurr,25)
      <=> v63116(VarCurr,1) )
      & ( v63109(VarCurr,24)
      <=> v63116(VarCurr,0) ) ) ).

tff(addAssignment_36761,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,31)
      <=> v63115(VarCurr,3) )
      & ( v63109(VarCurr,30)
      <=> v63115(VarCurr,2) )
      & ( v63109(VarCurr,29)
      <=> v63115(VarCurr,1) )
      & ( v63109(VarCurr,28)
      <=> v63115(VarCurr,0) ) ) ).

tff(addAssignment_36760,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,35)
      <=> v63114(VarCurr,3) )
      & ( v63109(VarCurr,34)
      <=> v63114(VarCurr,2) )
      & ( v63109(VarCurr,33)
      <=> v63114(VarCurr,1) )
      & ( v63109(VarCurr,32)
      <=> v63114(VarCurr,0) ) ) ).

tff(addAssignment_36759,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,39)
      <=> v63113(VarCurr,3) )
      & ( v63109(VarCurr,38)
      <=> v63113(VarCurr,2) )
      & ( v63109(VarCurr,37)
      <=> v63113(VarCurr,1) )
      & ( v63109(VarCurr,36)
      <=> v63113(VarCurr,0) ) ) ).

tff(addAssignment_36758,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,43)
      <=> v63112(VarCurr,3) )
      & ( v63109(VarCurr,42)
      <=> v63112(VarCurr,2) )
      & ( v63109(VarCurr,41)
      <=> v63112(VarCurr,1) )
      & ( v63109(VarCurr,40)
      <=> v63112(VarCurr,0) ) ) ).

tff(addAssignment_36757,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,47)
      <=> v63111(VarCurr,3) )
      & ( v63109(VarCurr,46)
      <=> v63111(VarCurr,2) )
      & ( v63109(VarCurr,45)
      <=> v63111(VarCurr,1) )
      & ( v63109(VarCurr,44)
      <=> v63111(VarCurr,0) ) ) ).

tff(addAssignment_36756,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,51)
      <=> v63110(VarCurr,3) )
      & ( v63109(VarCurr,50)
      <=> v63110(VarCurr,2) )
      & ( v63109(VarCurr,49)
      <=> v63110(VarCurr,1) )
      & ( v63109(VarCurr,48)
      <=> v63110(VarCurr,0) ) ) ).

tff(addAssignment_36755,axiom,
    ! [VarCurr: state_type] :
      ( ( v63109(VarCurr,55)
      <=> v62866(VarCurr,3) )
      & ( v63109(VarCurr,54)
      <=> v62866(VarCurr,2) )
      & ( v63109(VarCurr,53)
      <=> v62866(VarCurr,1) )
      & ( v63109(VarCurr,52)
      <=> v62866(VarCurr,0) ) ) ).

tff(addAssignment_36754,axiom,
    ! [VarCurr: state_type] :
      ( v62866(VarCurr,3)
    <=> v62868(VarCurr) ) ).

tff(addAssignment_36753,axiom,
    ! [VarCurr: state_type] :
      ( v62866(VarCurr,2)
    <=> v63035(VarCurr) ) ).

tff(addAssignment_36752,axiom,
    ! [VarCurr: state_type] :
      ( v62866(VarCurr,1)
    <=> v63048(VarCurr) ) ).

tff(addAssignment_36751,axiom,
    ! [VarCurr: state_type] :
      ( v62866(VarCurr,0)
    <=> v63056(VarCurr) ) ).

tff(addAssignment_36750,axiom,
    ! [VarCurr: state_type] :
      ( v63056(VarCurr)
    <=> v63058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5976,axiom,
    ! [VarCurr: state_type] :
      ( v63058(VarCurr)
    <=> ( v63060(VarCurr)
      <~> v63084(VarCurr) ) ) ).

tff(addAssignment_36749,axiom,
    ! [VarCurr: state_type] :
      ( v63084(VarCurr)
    <=> v63086(VarCurr) ) ).

tff(addAssignment_36748,axiom,
    ! [VarCurr: state_type] :
      ( v63086(VarCurr)
    <=> v62876(VarCurr,59) ) ).

tff(addAssignment_36747,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,59)
    <=> v62934(VarCurr,59) ) ).

tff(addAssignment_36746,axiom,
    ! [VarCurr: state_type] :
      ( v62961(VarCurr)
    <=> v63089(VarCurr) ) ).

tff(addAssignment_36745,axiom,
    ! [VarCurr: state_type] :
      ( v63089(VarCurr)
    <=> v63091(VarCurr) ) ).

tff(writeUnaryOperator_3211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63091(VarCurr)
    <=> v63093(VarCurr) ) ).

tff(addAssignment_36744,axiom,
    ! [VarCurr: state_type] :
      ( v63093(VarCurr)
    <=> v63095(VarCurr) ) ).

tff(addAssignment_36743,axiom,
    ! [VarCurr: state_type] :
      ( v63095(VarCurr)
    <=> v63097(VarCurr) ) ).

tff(addAssignment_36742,axiom,
    ! [VarCurr: state_type] :
      ( v63097(VarCurr)
    <=> v63099(VarCurr) ) ).

tff(addAssignment_36741,axiom,
    ! [VarCurr: state_type] :
      ( v63099(VarCurr)
    <=> v63101(VarCurr) ) ).

tff(writeUnaryOperator_3210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63101(VarCurr)
    <=> v63103(VarCurr) ) ).

tff(addAssignment_36740,axiom,
    ! [VarCurr: state_type] :
      ( v63103(VarCurr)
    <=> v63105(VarCurr) ) ).

tff(addAssignment_36739,axiom,
    ! [VarCurr: state_type] :
      ( v63105(VarCurr)
    <=> v62898(VarCurr,3) ) ).

tff(addAssignment_36738,axiom,
    ! [VarCurr: state_type] :
      ( v62898(VarCurr,3)
    <=> v62900(VarCurr,3) ) ).

tff(addAssignment_36737,axiom,
    ! [VarCurr: state_type] :
      ( v62900(VarCurr,3)
    <=> v62902(VarCurr,3) ) ).

tff(addAssignment_36736,axiom,
    ! [VarCurr: state_type] :
      ( v62902(VarCurr,3)
    <=> v62929(VarCurr,3) ) ).

tff(addAssignment_36735,axiom,
    ! [VarCurr: state_type] :
      ( v62923(VarCurr,3)
    <=> v62925(VarCurr,3) ) ).

tff(addAssignment_36734,axiom,
    ! [VarCurr: state_type] :
      ( v62925(VarCurr,3)
    <=> v62927(VarCurr,3) ) ).

tff(addAssignment_36733,axiom,
    ! [VarCurr: state_type] :
      ( v62927(VarCurr,3)
    <=> v5975(VarCurr,3) ) ).

tff(addAssignment_36732,axiom,
    ! [VarCurr: state_type] :
      ( v62917(VarCurr,3)
    <=> v62919(VarCurr,3) ) ).

tff(addAssignment_36731,axiom,
    ! [VarCurr: state_type] :
      ( v62919(VarCurr,3)
    <=> v62921(VarCurr,3) ) ).

tff(addAssignment_36730,axiom,
    ! [VarCurr: state_type] :
      ( v62921(VarCurr,3)
    <=> v54706(VarCurr,3) ) ).

tff(addAssignment_36729,axiom,
    ! [VarCurr: state_type] :
      ( v63060(VarCurr)
    <=> v63062(VarCurr) ) ).

tff(addAssignment_36728,axiom,
    ! [VarCurr: state_type] :
      ( v63062(VarCurr)
    <=> v63064(VarCurr) ) ).

tff(addAssignment_36727,axiom,
    ! [VarCurr: state_type] :
      ( v63064(VarCurr)
    <=> v63066(VarCurr) ) ).

tff(addAssignment_36726,axiom,
    ! [VarCurr: state_type] :
      ( v63066(VarCurr)
    <=> v63068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5975,axiom,
    ! [VarCurr: state_type] :
      ( v63068(VarCurr)
    <=> ( v63082(VarCurr)
      <~> v63078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5974,axiom,
    ! [VarCurr: state_type] :
      ( v63082(VarCurr)
    <=> ( v63070(VarCurr)
      <~> v63074(VarCurr) ) ) ).

tff(addAssignment_36725,axiom,
    ! [VarCurr: state_type] :
      ( v63078(VarCurr)
    <=> v63080(VarCurr) ) ).

tff(addAssignment_36724,axiom,
    ! [VarCurr: state_type] :
      ( v63080(VarCurr)
    <=> v62876(VarCurr,58) ) ).

tff(addAssignment_36723,axiom,
    ! [VarCurr: state_type] :
      ( v63074(VarCurr)
    <=> v63076(VarCurr) ) ).

tff(addAssignment_36722,axiom,
    ! [VarCurr: state_type] :
      ( v63076(VarCurr)
    <=> v62876(VarCurr,57) ) ).

tff(addAssignment_36721,axiom,
    ! [VarCurr: state_type] :
      ( v63070(VarCurr)
    <=> v63072(VarCurr) ) ).

tff(addAssignment_36720,axiom,
    ! [VarCurr: state_type] :
      ( v63072(VarCurr)
    <=> v62876(VarCurr,56) ) ).

tff(addAssignment_36719,axiom,
    ! [VarCurr: state_type] :
      ( v63048(VarCurr)
    <=> v63050(VarCurr) ) ).

tff(addAssignment_36718,axiom,
    ! [VarCurr: state_type] :
      ( v63050(VarCurr)
    <=> v63052(VarCurr) ) ).

tff(addAssignment_36717,axiom,
    ! [VarCurr: state_type] :
      ( v63052(VarCurr)
    <=> v63054(VarCurr) ) ).

tff(addAssignment_36716,axiom,
    ! [VarCurr: state_type] :
      ( v63054(VarCurr)
    <=> v62876(VarCurr,56) ) ).

tff(addAssignment_36715,axiom,
    ! [VarCurr: state_type] :
      ( v63035(VarCurr)
    <=> v63037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5973,axiom,
    ! [VarCurr: state_type] :
      ( v63037(VarCurr)
    <=> ( v63039(VarCurr)
      <~> v63043(VarCurr) ) ) ).

tff(addAssignment_36714,axiom,
    ! [VarCurr: state_type] :
      ( v63043(VarCurr)
    <=> v63045(VarCurr) ) ).

tff(addAssignment_36713,axiom,
    ! [VarCurr: state_type] :
      ( v63045(VarCurr)
    <=> v62876(VarCurr,57) ) ).

tff(addAssignment_36712,axiom,
    ! [VarCurr: state_type] :
      ( v63039(VarCurr)
    <=> v63041(VarCurr) ) ).

tff(addAssignment_36711,axiom,
    ! [VarCurr: state_type] :
      ( v63041(VarCurr)
    <=> v62876(VarCurr,56) ) ).

tff(addAssignment_36710,axiom,
    ! [VarCurr: state_type] :
      ( v62868(VarCurr)
    <=> v62870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5972,axiom,
    ! [VarCurr: state_type] :
      ( v62870(VarCurr)
    <=> ( v63033(VarCurr)
      <~> v63008(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5971,axiom,
    ! [VarCurr: state_type] :
      ( v63033(VarCurr)
    <=> ( v62872(VarCurr)
      <~> v62983(VarCurr) ) ) ).

tff(addAssignment_36709,axiom,
    ! [VarCurr: state_type] :
      ( v63008(VarCurr)
    <=> v63010(VarCurr) ) ).

tff(addAssignment_36708,axiom,
    ! [VarCurr: state_type] :
      ( v63010(VarCurr)
    <=> v62876(VarCurr,58) ) ).

tff(addAssignment_36707,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,58)
    <=> v62934(VarCurr,58) ) ).

tff(addAssignment_36706,axiom,
    ! [VarCurr: state_type] :
      ( v62962(VarCurr)
    <=> v63013(VarCurr) ) ).

tff(addAssignment_36705,axiom,
    ! [VarCurr: state_type] :
      ( v63013(VarCurr)
    <=> v63015(VarCurr) ) ).

tff(writeUnaryOperator_3209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63015(VarCurr)
    <=> v63017(VarCurr) ) ).

tff(addAssignment_36704,axiom,
    ! [VarCurr: state_type] :
      ( v63017(VarCurr)
    <=> v63019(VarCurr) ) ).

tff(addAssignment_36703,axiom,
    ! [VarCurr: state_type] :
      ( v63019(VarCurr)
    <=> v63021(VarCurr) ) ).

tff(addAssignment_36702,axiom,
    ! [VarCurr: state_type] :
      ( v63021(VarCurr)
    <=> v63023(VarCurr) ) ).

tff(addAssignment_36701,axiom,
    ! [VarCurr: state_type] :
      ( v63023(VarCurr)
    <=> v63025(VarCurr) ) ).

tff(writeUnaryOperator_3208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63025(VarCurr)
    <=> v63027(VarCurr) ) ).

tff(addAssignment_36700,axiom,
    ! [VarCurr: state_type] :
      ( v63027(VarCurr)
    <=> v63029(VarCurr) ) ).

tff(addAssignment_36699,axiom,
    ! [VarCurr: state_type] :
      ( v63029(VarCurr)
    <=> v62898(VarCurr,2) ) ).

tff(addAssignment_36698,axiom,
    ! [VarCurr: state_type] :
      ( v62898(VarCurr,2)
    <=> v62900(VarCurr,2) ) ).

tff(addAssignment_36697,axiom,
    ! [VarCurr: state_type] :
      ( v62900(VarCurr,2)
    <=> v62902(VarCurr,2) ) ).

tff(addAssignment_36696,axiom,
    ! [VarCurr: state_type] :
      ( v62902(VarCurr,2)
    <=> v62929(VarCurr,2) ) ).

tff(addAssignment_36695,axiom,
    ! [VarCurr: state_type] :
      ( v62923(VarCurr,2)
    <=> v62925(VarCurr,2) ) ).

tff(addAssignment_36694,axiom,
    ! [VarCurr: state_type] :
      ( v62925(VarCurr,2)
    <=> v62927(VarCurr,2) ) ).

tff(addAssignment_36693,axiom,
    ! [VarCurr: state_type] :
      ( v62927(VarCurr,2)
    <=> v5975(VarCurr,2) ) ).

tff(addAssignment_36692,axiom,
    ! [VarCurr: state_type] :
      ( v62917(VarCurr,2)
    <=> v62919(VarCurr,2) ) ).

tff(addAssignment_36691,axiom,
    ! [VarCurr: state_type] :
      ( v62919(VarCurr,2)
    <=> v62921(VarCurr,2) ) ).

tff(addAssignment_36690,axiom,
    ! [VarCurr: state_type] :
      ( v62921(VarCurr,2)
    <=> v54706(VarCurr,2) ) ).

tff(addAssignment_36689,axiom,
    ! [VarCurr: state_type] :
      ( v62983(VarCurr)
    <=> v62985(VarCurr) ) ).

tff(addAssignment_36688,axiom,
    ! [VarCurr: state_type] :
      ( v62985(VarCurr)
    <=> v62876(VarCurr,57) ) ).

tff(addAssignment_36687,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,57)
    <=> v62934(VarCurr,57) ) ).

tff(addAssignment_36686,axiom,
    ! [VarCurr: state_type] :
      ( v62963(VarCurr)
    <=> v62988(VarCurr) ) ).

tff(addAssignment_36685,axiom,
    ! [VarCurr: state_type] :
      ( v62988(VarCurr)
    <=> v62990(VarCurr) ) ).

tff(writeUnaryOperator_3207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62990(VarCurr)
    <=> v62992(VarCurr) ) ).

tff(addAssignment_36684,axiom,
    ! [VarCurr: state_type] :
      ( v62992(VarCurr)
    <=> v62994(VarCurr) ) ).

tff(addAssignment_36683,axiom,
    ! [VarCurr: state_type] :
      ( v62994(VarCurr)
    <=> v62996(VarCurr) ) ).

tff(addAssignment_36682,axiom,
    ! [VarCurr: state_type] :
      ( v62996(VarCurr)
    <=> v62998(VarCurr) ) ).

tff(addAssignment_36681,axiom,
    ! [VarCurr: state_type] :
      ( v62998(VarCurr)
    <=> v63000(VarCurr) ) ).

tff(writeUnaryOperator_3206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v63000(VarCurr)
    <=> v63002(VarCurr) ) ).

tff(addAssignment_36680,axiom,
    ! [VarCurr: state_type] :
      ( v63002(VarCurr)
    <=> v63004(VarCurr) ) ).

tff(addAssignment_36679,axiom,
    ! [VarCurr: state_type] :
      ( v63004(VarCurr)
    <=> v62898(VarCurr,1) ) ).

tff(addAssignment_36678,axiom,
    ! [VarCurr: state_type] :
      ( v62898(VarCurr,1)
    <=> v62900(VarCurr,1) ) ).

tff(addAssignment_36677,axiom,
    ! [VarCurr: state_type] :
      ( v62900(VarCurr,1)
    <=> v62902(VarCurr,1) ) ).

tff(addAssignment_36676,axiom,
    ! [VarCurr: state_type] :
      ( v62902(VarCurr,1)
    <=> v62929(VarCurr,1) ) ).

tff(addAssignment_36675,axiom,
    ! [VarCurr: state_type] :
      ( v62923(VarCurr,1)
    <=> v62925(VarCurr,1) ) ).

tff(addAssignment_36674,axiom,
    ! [VarCurr: state_type] :
      ( v62925(VarCurr,1)
    <=> v62927(VarCurr,1) ) ).

tff(addAssignment_36673,axiom,
    ! [VarCurr: state_type] :
      ( v62927(VarCurr,1)
    <=> v5975(VarCurr,1) ) ).

tff(addAssignment_36672,axiom,
    ! [VarCurr: state_type] :
      ( v62917(VarCurr,1)
    <=> v62919(VarCurr,1) ) ).

tff(addAssignment_36671,axiom,
    ! [VarCurr: state_type] :
      ( v62919(VarCurr,1)
    <=> v62921(VarCurr,1) ) ).

tff(addAssignment_36670,axiom,
    ! [VarCurr: state_type] :
      ( v62921(VarCurr,1)
    <=> v54706(VarCurr,1) ) ).

tff(addAssignment_36669,axiom,
    ! [VarCurr: state_type] :
      ( v62872(VarCurr)
    <=> v62874(VarCurr) ) ).

tff(addAssignment_36668,axiom,
    ! [VarCurr: state_type] :
      ( v62874(VarCurr)
    <=> v62876(VarCurr,56) ) ).

tff(addAssignment_36667,axiom,
    ! [VarCurr: state_type] :
      ( v62876(VarCurr,56)
    <=> v62934(VarCurr,56) ) ).

tff(addAssignment_36666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v62934(VarCurr,B)
      <=> v62976(VarCurr,B) ) ) ).

tff(addAssignment_36665,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,31)
      <=> v62970(VarCurr,15) )
      & ( v62934(VarCurr,30)
      <=> v62970(VarCurr,14) )
      & ( v62934(VarCurr,29)
      <=> v62970(VarCurr,13) )
      & ( v62934(VarCurr,28)
      <=> v62970(VarCurr,12) )
      & ( v62934(VarCurr,27)
      <=> v62970(VarCurr,11) )
      & ( v62934(VarCurr,26)
      <=> v62970(VarCurr,10) )
      & ( v62934(VarCurr,25)
      <=> v62970(VarCurr,9) )
      & ( v62934(VarCurr,24)
      <=> v62970(VarCurr,8) )
      & ( v62934(VarCurr,23)
      <=> v62970(VarCurr,7) )
      & ( v62934(VarCurr,22)
      <=> v62970(VarCurr,6) )
      & ( v62934(VarCurr,21)
      <=> v62970(VarCurr,5) )
      & ( v62934(VarCurr,20)
      <=> v62970(VarCurr,4) )
      & ( v62934(VarCurr,19)
      <=> v62970(VarCurr,3) )
      & ( v62934(VarCurr,18)
      <=> v62970(VarCurr,2) )
      & ( v62934(VarCurr,17)
      <=> v62970(VarCurr,1) )
      & ( v62934(VarCurr,16)
      <=> v62970(VarCurr,0) ) ) ).

tff(addAssignment_36664,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,47)
      <=> v62964(VarCurr,15) )
      & ( v62934(VarCurr,46)
      <=> v62964(VarCurr,14) )
      & ( v62934(VarCurr,45)
      <=> v62964(VarCurr,13) )
      & ( v62934(VarCurr,44)
      <=> v62964(VarCurr,12) )
      & ( v62934(VarCurr,43)
      <=> v62964(VarCurr,11) )
      & ( v62934(VarCurr,42)
      <=> v62964(VarCurr,10) )
      & ( v62934(VarCurr,41)
      <=> v62964(VarCurr,9) )
      & ( v62934(VarCurr,40)
      <=> v62964(VarCurr,8) )
      & ( v62934(VarCurr,39)
      <=> v62964(VarCurr,7) )
      & ( v62934(VarCurr,38)
      <=> v62964(VarCurr,6) )
      & ( v62934(VarCurr,37)
      <=> v62964(VarCurr,5) )
      & ( v62934(VarCurr,36)
      <=> v62964(VarCurr,4) )
      & ( v62934(VarCurr,35)
      <=> v62964(VarCurr,3) )
      & ( v62934(VarCurr,34)
      <=> v62964(VarCurr,2) )
      & ( v62934(VarCurr,33)
      <=> v62964(VarCurr,1) )
      & ( v62934(VarCurr,32)
      <=> v62964(VarCurr,0) ) ) ).

tff(addAssignment_36663,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,63)
      <=> v62959(VarCurr,15) )
      & ( v62934(VarCurr,62)
      <=> v62959(VarCurr,14) )
      & ( v62934(VarCurr,61)
      <=> v62959(VarCurr,13) )
      & ( v62934(VarCurr,60)
      <=> v62959(VarCurr,12) )
      & ( v62934(VarCurr,59)
      <=> v62959(VarCurr,11) )
      & ( v62934(VarCurr,58)
      <=> v62959(VarCurr,10) )
      & ( v62934(VarCurr,57)
      <=> v62959(VarCurr,9) )
      & ( v62934(VarCurr,56)
      <=> v62959(VarCurr,8) )
      & ( v62934(VarCurr,55)
      <=> v62959(VarCurr,7) )
      & ( v62934(VarCurr,54)
      <=> v62959(VarCurr,6) )
      & ( v62934(VarCurr,53)
      <=> v62959(VarCurr,5) )
      & ( v62934(VarCurr,52)
      <=> v62959(VarCurr,4) )
      & ( v62934(VarCurr,51)
      <=> v62959(VarCurr,3) )
      & ( v62934(VarCurr,50)
      <=> v62959(VarCurr,2) )
      & ( v62934(VarCurr,49)
      <=> v62959(VarCurr,1) )
      & ( v62934(VarCurr,48)
      <=> v62959(VarCurr,0) ) ) ).

tff(addAssignment_36662,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,79)
      <=> v62953(VarCurr,15) )
      & ( v62934(VarCurr,78)
      <=> v62953(VarCurr,14) )
      & ( v62934(VarCurr,77)
      <=> v62953(VarCurr,13) )
      & ( v62934(VarCurr,76)
      <=> v62953(VarCurr,12) )
      & ( v62934(VarCurr,75)
      <=> v62953(VarCurr,11) )
      & ( v62934(VarCurr,74)
      <=> v62953(VarCurr,10) )
      & ( v62934(VarCurr,73)
      <=> v62953(VarCurr,9) )
      & ( v62934(VarCurr,72)
      <=> v62953(VarCurr,8) )
      & ( v62934(VarCurr,71)
      <=> v62953(VarCurr,7) )
      & ( v62934(VarCurr,70)
      <=> v62953(VarCurr,6) )
      & ( v62934(VarCurr,69)
      <=> v62953(VarCurr,5) )
      & ( v62934(VarCurr,68)
      <=> v62953(VarCurr,4) )
      & ( v62934(VarCurr,67)
      <=> v62953(VarCurr,3) )
      & ( v62934(VarCurr,66)
      <=> v62953(VarCurr,2) )
      & ( v62934(VarCurr,65)
      <=> v62953(VarCurr,1) )
      & ( v62934(VarCurr,64)
      <=> v62953(VarCurr,0) ) ) ).

tff(addAssignment_36661,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,95)
      <=> v62947(VarCurr,15) )
      & ( v62934(VarCurr,94)
      <=> v62947(VarCurr,14) )
      & ( v62934(VarCurr,93)
      <=> v62947(VarCurr,13) )
      & ( v62934(VarCurr,92)
      <=> v62947(VarCurr,12) )
      & ( v62934(VarCurr,91)
      <=> v62947(VarCurr,11) )
      & ( v62934(VarCurr,90)
      <=> v62947(VarCurr,10) )
      & ( v62934(VarCurr,89)
      <=> v62947(VarCurr,9) )
      & ( v62934(VarCurr,88)
      <=> v62947(VarCurr,8) )
      & ( v62934(VarCurr,87)
      <=> v62947(VarCurr,7) )
      & ( v62934(VarCurr,86)
      <=> v62947(VarCurr,6) )
      & ( v62934(VarCurr,85)
      <=> v62947(VarCurr,5) )
      & ( v62934(VarCurr,84)
      <=> v62947(VarCurr,4) )
      & ( v62934(VarCurr,83)
      <=> v62947(VarCurr,3) )
      & ( v62934(VarCurr,82)
      <=> v62947(VarCurr,2) )
      & ( v62934(VarCurr,81)
      <=> v62947(VarCurr,1) )
      & ( v62934(VarCurr,80)
      <=> v62947(VarCurr,0) ) ) ).

tff(addAssignment_36660,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,111)
      <=> v62941(VarCurr,15) )
      & ( v62934(VarCurr,110)
      <=> v62941(VarCurr,14) )
      & ( v62934(VarCurr,109)
      <=> v62941(VarCurr,13) )
      & ( v62934(VarCurr,108)
      <=> v62941(VarCurr,12) )
      & ( v62934(VarCurr,107)
      <=> v62941(VarCurr,11) )
      & ( v62934(VarCurr,106)
      <=> v62941(VarCurr,10) )
      & ( v62934(VarCurr,105)
      <=> v62941(VarCurr,9) )
      & ( v62934(VarCurr,104)
      <=> v62941(VarCurr,8) )
      & ( v62934(VarCurr,103)
      <=> v62941(VarCurr,7) )
      & ( v62934(VarCurr,102)
      <=> v62941(VarCurr,6) )
      & ( v62934(VarCurr,101)
      <=> v62941(VarCurr,5) )
      & ( v62934(VarCurr,100)
      <=> v62941(VarCurr,4) )
      & ( v62934(VarCurr,99)
      <=> v62941(VarCurr,3) )
      & ( v62934(VarCurr,98)
      <=> v62941(VarCurr,2) )
      & ( v62934(VarCurr,97)
      <=> v62941(VarCurr,1) )
      & ( v62934(VarCurr,96)
      <=> v62941(VarCurr,0) ) ) ).

tff(addAssignment_36659,axiom,
    ! [VarCurr: state_type] :
      ( ( v62934(VarCurr,127)
      <=> v62935(VarCurr,15) )
      & ( v62934(VarCurr,126)
      <=> v62935(VarCurr,14) )
      & ( v62934(VarCurr,125)
      <=> v62935(VarCurr,13) )
      & ( v62934(VarCurr,124)
      <=> v62935(VarCurr,12) )
      & ( v62934(VarCurr,123)
      <=> v62935(VarCurr,11) )
      & ( v62934(VarCurr,122)
      <=> v62935(VarCurr,10) )
      & ( v62934(VarCurr,121)
      <=> v62935(VarCurr,9) )
      & ( v62934(VarCurr,120)
      <=> v62935(VarCurr,8) )
      & ( v62934(VarCurr,119)
      <=> v62935(VarCurr,7) )
      & ( v62934(VarCurr,118)
      <=> v62935(VarCurr,6) )
      & ( v62934(VarCurr,117)
      <=> v62935(VarCurr,5) )
      & ( v62934(VarCurr,116)
      <=> v62935(VarCurr,4) )
      & ( v62934(VarCurr,115)
      <=> v62935(VarCurr,3) )
      & ( v62934(VarCurr,114)
      <=> v62935(VarCurr,2) )
      & ( v62934(VarCurr,113)
      <=> v62935(VarCurr,1) )
      & ( v62934(VarCurr,112)
      <=> v62935(VarCurr,0) ) ) ).

tff(addAssignment_36658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62976(VarCurr,B)
      <=> v62977(VarCurr,B) ) ) ).

tff(addAssignment_36657,axiom,
    ! [VarCurr: state_type] :
      ( ( v62976(VarCurr,7)
      <=> v62977(VarCurr,3) )
      & ( v62976(VarCurr,6)
      <=> v62977(VarCurr,2) )
      & ( v62976(VarCurr,5)
      <=> v62977(VarCurr,1) )
      & ( v62976(VarCurr,4)
      <=> v62977(VarCurr,0) ) ) ).

tff(addAssignment_36656,axiom,
    ! [VarCurr: state_type] :
      ( ( v62976(VarCurr,11)
      <=> v62977(VarCurr,3) )
      & ( v62976(VarCurr,10)
      <=> v62977(VarCurr,2) )
      & ( v62976(VarCurr,9)
      <=> v62977(VarCurr,1) )
      & ( v62976(VarCurr,8)
      <=> v62977(VarCurr,0) ) ) ).

tff(addAssignment_36655,axiom,
    ! [VarCurr: state_type] :
      ( ( v62976(VarCurr,15)
      <=> v62977(VarCurr,3) )
      & ( v62976(VarCurr,14)
      <=> v62977(VarCurr,2) )
      & ( v62976(VarCurr,13)
      <=> v62977(VarCurr,1) )
      & ( v62976(VarCurr,12)
      <=> v62977(VarCurr,0) ) ) ).

tff(addAssignment_36654,axiom,
    ! [VarCurr: state_type] :
      ( v62977(VarCurr,0)
    <=> v62981(VarCurr) ) ).

tff(addAssignment_36653,axiom,
    ! [VarCurr: state_type] :
      ( v62977(VarCurr,1)
    <=> v62980(VarCurr) ) ).

tff(addAssignment_36652,axiom,
    ! [VarCurr: state_type] :
      ( v62977(VarCurr,2)
    <=> v62979(VarCurr) ) ).

tff(addAssignment_36651,axiom,
    ! [VarCurr: state_type] :
      ( v62977(VarCurr,3)
    <=> v62978(VarCurr) ) ).

tff(addAssignment_36650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62970(VarCurr,B)
      <=> v62971(VarCurr,B) ) ) ).

tff(addAssignment_36649,axiom,
    ! [VarCurr: state_type] :
      ( ( v62970(VarCurr,7)
      <=> v62971(VarCurr,3) )
      & ( v62970(VarCurr,6)
      <=> v62971(VarCurr,2) )
      & ( v62970(VarCurr,5)
      <=> v62971(VarCurr,1) )
      & ( v62970(VarCurr,4)
      <=> v62971(VarCurr,0) ) ) ).

tff(addAssignment_36648,axiom,
    ! [VarCurr: state_type] :
      ( ( v62970(VarCurr,11)
      <=> v62971(VarCurr,3) )
      & ( v62970(VarCurr,10)
      <=> v62971(VarCurr,2) )
      & ( v62970(VarCurr,9)
      <=> v62971(VarCurr,1) )
      & ( v62970(VarCurr,8)
      <=> v62971(VarCurr,0) ) ) ).

tff(addAssignment_36647,axiom,
    ! [VarCurr: state_type] :
      ( ( v62970(VarCurr,15)
      <=> v62971(VarCurr,3) )
      & ( v62970(VarCurr,14)
      <=> v62971(VarCurr,2) )
      & ( v62970(VarCurr,13)
      <=> v62971(VarCurr,1) )
      & ( v62970(VarCurr,12)
      <=> v62971(VarCurr,0) ) ) ).

tff(addAssignment_36646,axiom,
    ! [VarCurr: state_type] :
      ( v62971(VarCurr,0)
    <=> v62975(VarCurr) ) ).

tff(addAssignment_36645,axiom,
    ! [VarCurr: state_type] :
      ( v62971(VarCurr,1)
    <=> v62974(VarCurr) ) ).

tff(addAssignment_36644,axiom,
    ! [VarCurr: state_type] :
      ( v62971(VarCurr,2)
    <=> v62973(VarCurr) ) ).

tff(addAssignment_36643,axiom,
    ! [VarCurr: state_type] :
      ( v62971(VarCurr,3)
    <=> v62972(VarCurr) ) ).

tff(addAssignment_36642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62964(VarCurr,B)
      <=> v62965(VarCurr,B) ) ) ).

tff(addAssignment_36641,axiom,
    ! [VarCurr: state_type] :
      ( ( v62964(VarCurr,7)
      <=> v62965(VarCurr,3) )
      & ( v62964(VarCurr,6)
      <=> v62965(VarCurr,2) )
      & ( v62964(VarCurr,5)
      <=> v62965(VarCurr,1) )
      & ( v62964(VarCurr,4)
      <=> v62965(VarCurr,0) ) ) ).

tff(addAssignment_36640,axiom,
    ! [VarCurr: state_type] :
      ( ( v62964(VarCurr,11)
      <=> v62965(VarCurr,3) )
      & ( v62964(VarCurr,10)
      <=> v62965(VarCurr,2) )
      & ( v62964(VarCurr,9)
      <=> v62965(VarCurr,1) )
      & ( v62964(VarCurr,8)
      <=> v62965(VarCurr,0) ) ) ).

tff(addAssignment_36639,axiom,
    ! [VarCurr: state_type] :
      ( ( v62964(VarCurr,15)
      <=> v62965(VarCurr,3) )
      & ( v62964(VarCurr,14)
      <=> v62965(VarCurr,2) )
      & ( v62964(VarCurr,13)
      <=> v62965(VarCurr,1) )
      & ( v62964(VarCurr,12)
      <=> v62965(VarCurr,0) ) ) ).

tff(addAssignment_36638,axiom,
    ! [VarCurr: state_type] :
      ( v62965(VarCurr,0)
    <=> v62969(VarCurr) ) ).

tff(addAssignment_36637,axiom,
    ! [VarCurr: state_type] :
      ( v62965(VarCurr,1)
    <=> v62968(VarCurr) ) ).

tff(addAssignment_36636,axiom,
    ! [VarCurr: state_type] :
      ( v62965(VarCurr,2)
    <=> v62967(VarCurr) ) ).

tff(addAssignment_36635,axiom,
    ! [VarCurr: state_type] :
      ( v62965(VarCurr,3)
    <=> v62966(VarCurr) ) ).

tff(addAssignment_36634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62959(VarCurr,B)
      <=> v62960(VarCurr,B) ) ) ).

tff(addAssignment_36633,axiom,
    ! [VarCurr: state_type] :
      ( ( v62959(VarCurr,7)
      <=> v62960(VarCurr,3) )
      & ( v62959(VarCurr,6)
      <=> v62960(VarCurr,2) )
      & ( v62959(VarCurr,5)
      <=> v62960(VarCurr,1) )
      & ( v62959(VarCurr,4)
      <=> v62960(VarCurr,0) ) ) ).

tff(addAssignment_36632,axiom,
    ! [VarCurr: state_type] :
      ( ( v62959(VarCurr,11)
      <=> v62960(VarCurr,3) )
      & ( v62959(VarCurr,10)
      <=> v62960(VarCurr,2) )
      & ( v62959(VarCurr,9)
      <=> v62960(VarCurr,1) )
      & ( v62959(VarCurr,8)
      <=> v62960(VarCurr,0) ) ) ).

tff(addAssignment_36631,axiom,
    ! [VarCurr: state_type] :
      ( ( v62959(VarCurr,15)
      <=> v62960(VarCurr,3) )
      & ( v62959(VarCurr,14)
      <=> v62960(VarCurr,2) )
      & ( v62959(VarCurr,13)
      <=> v62960(VarCurr,1) )
      & ( v62959(VarCurr,12)
      <=> v62960(VarCurr,0) ) ) ).

tff(addAssignment_36630,axiom,
    ! [VarCurr: state_type] :
      ( v62960(VarCurr,0)
    <=> v62878(VarCurr) ) ).

tff(addAssignment_36629,axiom,
    ! [VarCurr: state_type] :
      ( v62960(VarCurr,1)
    <=> v62963(VarCurr) ) ).

tff(addAssignment_36628,axiom,
    ! [VarCurr: state_type] :
      ( v62960(VarCurr,2)
    <=> v62962(VarCurr) ) ).

tff(addAssignment_36627,axiom,
    ! [VarCurr: state_type] :
      ( v62960(VarCurr,3)
    <=> v62961(VarCurr) ) ).

tff(addAssignment_36626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62953(VarCurr,B)
      <=> v62954(VarCurr,B) ) ) ).

tff(addAssignment_36625,axiom,
    ! [VarCurr: state_type] :
      ( ( v62953(VarCurr,7)
      <=> v62954(VarCurr,3) )
      & ( v62953(VarCurr,6)
      <=> v62954(VarCurr,2) )
      & ( v62953(VarCurr,5)
      <=> v62954(VarCurr,1) )
      & ( v62953(VarCurr,4)
      <=> v62954(VarCurr,0) ) ) ).

tff(addAssignment_36624,axiom,
    ! [VarCurr: state_type] :
      ( ( v62953(VarCurr,11)
      <=> v62954(VarCurr,3) )
      & ( v62953(VarCurr,10)
      <=> v62954(VarCurr,2) )
      & ( v62953(VarCurr,9)
      <=> v62954(VarCurr,1) )
      & ( v62953(VarCurr,8)
      <=> v62954(VarCurr,0) ) ) ).

tff(addAssignment_36623,axiom,
    ! [VarCurr: state_type] :
      ( ( v62953(VarCurr,15)
      <=> v62954(VarCurr,3) )
      & ( v62953(VarCurr,14)
      <=> v62954(VarCurr,2) )
      & ( v62953(VarCurr,13)
      <=> v62954(VarCurr,1) )
      & ( v62953(VarCurr,12)
      <=> v62954(VarCurr,0) ) ) ).

tff(addAssignment_36622,axiom,
    ! [VarCurr: state_type] :
      ( v62954(VarCurr,0)
    <=> v62958(VarCurr) ) ).

tff(addAssignment_36621,axiom,
    ! [VarCurr: state_type] :
      ( v62954(VarCurr,1)
    <=> v62957(VarCurr) ) ).

tff(addAssignment_36620,axiom,
    ! [VarCurr: state_type] :
      ( v62954(VarCurr,2)
    <=> v62956(VarCurr) ) ).

tff(addAssignment_36619,axiom,
    ! [VarCurr: state_type] :
      ( v62954(VarCurr,3)
    <=> v62955(VarCurr) ) ).

tff(addAssignment_36618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62947(VarCurr,B)
      <=> v62948(VarCurr,B) ) ) ).

tff(addAssignment_36617,axiom,
    ! [VarCurr: state_type] :
      ( ( v62947(VarCurr,7)
      <=> v62948(VarCurr,3) )
      & ( v62947(VarCurr,6)
      <=> v62948(VarCurr,2) )
      & ( v62947(VarCurr,5)
      <=> v62948(VarCurr,1) )
      & ( v62947(VarCurr,4)
      <=> v62948(VarCurr,0) ) ) ).

tff(addAssignment_36616,axiom,
    ! [VarCurr: state_type] :
      ( ( v62947(VarCurr,11)
      <=> v62948(VarCurr,3) )
      & ( v62947(VarCurr,10)
      <=> v62948(VarCurr,2) )
      & ( v62947(VarCurr,9)
      <=> v62948(VarCurr,1) )
      & ( v62947(VarCurr,8)
      <=> v62948(VarCurr,0) ) ) ).

tff(addAssignment_36615,axiom,
    ! [VarCurr: state_type] :
      ( ( v62947(VarCurr,15)
      <=> v62948(VarCurr,3) )
      & ( v62947(VarCurr,14)
      <=> v62948(VarCurr,2) )
      & ( v62947(VarCurr,13)
      <=> v62948(VarCurr,1) )
      & ( v62947(VarCurr,12)
      <=> v62948(VarCurr,0) ) ) ).

tff(addAssignment_36614,axiom,
    ! [VarCurr: state_type] :
      ( v62948(VarCurr,0)
    <=> v62952(VarCurr) ) ).

tff(addAssignment_36613,axiom,
    ! [VarCurr: state_type] :
      ( v62948(VarCurr,1)
    <=> v62951(VarCurr) ) ).

tff(addAssignment_36612,axiom,
    ! [VarCurr: state_type] :
      ( v62948(VarCurr,2)
    <=> v62950(VarCurr) ) ).

tff(addAssignment_36611,axiom,
    ! [VarCurr: state_type] :
      ( v62948(VarCurr,3)
    <=> v62949(VarCurr) ) ).

tff(addAssignment_36610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62941(VarCurr,B)
      <=> v62942(VarCurr,B) ) ) ).

tff(addAssignment_36609,axiom,
    ! [VarCurr: state_type] :
      ( ( v62941(VarCurr,7)
      <=> v62942(VarCurr,3) )
      & ( v62941(VarCurr,6)
      <=> v62942(VarCurr,2) )
      & ( v62941(VarCurr,5)
      <=> v62942(VarCurr,1) )
      & ( v62941(VarCurr,4)
      <=> v62942(VarCurr,0) ) ) ).

tff(addAssignment_36608,axiom,
    ! [VarCurr: state_type] :
      ( ( v62941(VarCurr,11)
      <=> v62942(VarCurr,3) )
      & ( v62941(VarCurr,10)
      <=> v62942(VarCurr,2) )
      & ( v62941(VarCurr,9)
      <=> v62942(VarCurr,1) )
      & ( v62941(VarCurr,8)
      <=> v62942(VarCurr,0) ) ) ).

tff(addAssignment_36607,axiom,
    ! [VarCurr: state_type] :
      ( ( v62941(VarCurr,15)
      <=> v62942(VarCurr,3) )
      & ( v62941(VarCurr,14)
      <=> v62942(VarCurr,2) )
      & ( v62941(VarCurr,13)
      <=> v62942(VarCurr,1) )
      & ( v62941(VarCurr,12)
      <=> v62942(VarCurr,0) ) ) ).

tff(addAssignment_36606,axiom,
    ! [VarCurr: state_type] :
      ( v62942(VarCurr,0)
    <=> v62946(VarCurr) ) ).

tff(addAssignment_36605,axiom,
    ! [VarCurr: state_type] :
      ( v62942(VarCurr,1)
    <=> v62945(VarCurr) ) ).

tff(addAssignment_36604,axiom,
    ! [VarCurr: state_type] :
      ( v62942(VarCurr,2)
    <=> v62944(VarCurr) ) ).

tff(addAssignment_36603,axiom,
    ! [VarCurr: state_type] :
      ( v62942(VarCurr,3)
    <=> v62943(VarCurr) ) ).

tff(addAssignment_36602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62935(VarCurr,B)
      <=> v62936(VarCurr,B) ) ) ).

tff(addAssignment_36601,axiom,
    ! [VarCurr: state_type] :
      ( ( v62935(VarCurr,7)
      <=> v62936(VarCurr,3) )
      & ( v62935(VarCurr,6)
      <=> v62936(VarCurr,2) )
      & ( v62935(VarCurr,5)
      <=> v62936(VarCurr,1) )
      & ( v62935(VarCurr,4)
      <=> v62936(VarCurr,0) ) ) ).

tff(addAssignment_36600,axiom,
    ! [VarCurr: state_type] :
      ( ( v62935(VarCurr,11)
      <=> v62936(VarCurr,3) )
      & ( v62935(VarCurr,10)
      <=> v62936(VarCurr,2) )
      & ( v62935(VarCurr,9)
      <=> v62936(VarCurr,1) )
      & ( v62935(VarCurr,8)
      <=> v62936(VarCurr,0) ) ) ).

tff(addAssignment_36599,axiom,
    ! [VarCurr: state_type] :
      ( ( v62935(VarCurr,15)
      <=> v62936(VarCurr,3) )
      & ( v62935(VarCurr,14)
      <=> v62936(VarCurr,2) )
      & ( v62935(VarCurr,13)
      <=> v62936(VarCurr,1) )
      & ( v62935(VarCurr,12)
      <=> v62936(VarCurr,0) ) ) ).

tff(addAssignment_36598,axiom,
    ! [VarCurr: state_type] :
      ( v62936(VarCurr,0)
    <=> v62940(VarCurr) ) ).

tff(addAssignment_36597,axiom,
    ! [VarCurr: state_type] :
      ( v62936(VarCurr,1)
    <=> v62939(VarCurr) ) ).

tff(addAssignment_36596,axiom,
    ! [VarCurr: state_type] :
      ( v62936(VarCurr,2)
    <=> v62938(VarCurr) ) ).

tff(addAssignment_36595,axiom,
    ! [VarCurr: state_type] :
      ( v62936(VarCurr,3)
    <=> v62937(VarCurr) ) ).

tff(addAssignment_36594,axiom,
    ! [VarCurr: state_type] :
      ( v62878(VarCurr)
    <=> v62880(VarCurr) ) ).

tff(addAssignment_36593,axiom,
    ! [VarCurr: state_type] :
      ( v62880(VarCurr)
    <=> v62882(VarCurr) ) ).

tff(writeUnaryOperator_3205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62882(VarCurr)
    <=> v62884(VarCurr) ) ).

tff(addAssignment_36592,axiom,
    ! [VarCurr: state_type] :
      ( v62884(VarCurr)
    <=> v62886(VarCurr) ) ).

tff(addAssignment_36591,axiom,
    ! [VarCurr: state_type] :
      ( v62886(VarCurr)
    <=> v62888(VarCurr) ) ).

tff(addAssignment_36590,axiom,
    ! [VarCurr: state_type] :
      ( v62888(VarCurr)
    <=> v62890(VarCurr) ) ).

tff(addAssignment_36589,axiom,
    ! [VarCurr: state_type] :
      ( v62890(VarCurr)
    <=> v62892(VarCurr) ) ).

tff(writeUnaryOperator_3204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62892(VarCurr)
    <=> v62894(VarCurr) ) ).

tff(addAssignment_36588,axiom,
    ! [VarCurr: state_type] :
      ( v62894(VarCurr)
    <=> v62896(VarCurr) ) ).

tff(addAssignment_36587,axiom,
    ! [VarCurr: state_type] :
      ( v62896(VarCurr)
    <=> v62898(VarCurr,0) ) ).

tff(addAssignment_36586,axiom,
    ! [VarCurr: state_type] :
      ( v62898(VarCurr,0)
    <=> v62900(VarCurr,0) ) ).

tff(addAssignment_36585,axiom,
    ! [VarCurr: state_type] :
      ( v62900(VarCurr,0)
    <=> v62902(VarCurr,0) ) ).

tff(addAssignment_36584,axiom,
    ! [VarCurr: state_type] :
      ( v62902(VarCurr,0)
    <=> v62929(VarCurr,0) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_3,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v62930(VarCurr)
        & ~ v62931(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v62929(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_10,axiom,
    ! [VarCurr: state_type] :
      ( v62931(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v62929(VarCurr,B)
          <=> v62923(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_10,axiom,
    ! [VarCurr: state_type] :
      ( v62930(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v62929(VarCurr,B)
          <=> v62917(VarCurr,B) ) ) ) ).

tff(addBitVectorEqualityBitBlasted_233,axiom,
    ! [VarCurr: state_type] :
      ( v62931(VarCurr)
    <=> ( v62904(VarCurr)
      <=> $true ) ) ).

tff(addBitVectorEqualityBitBlasted_232,axiom,
    ! [VarCurr: state_type] :
      ( v62930(VarCurr)
    <=> ( v62904(VarCurr)
      <=> $false ) ) ).

tff(addAssignment_36583,axiom,
    ! [VarCurr: state_type] :
      ( v62923(VarCurr,0)
    <=> v62925(VarCurr,0) ) ).

tff(addAssignment_36582,axiom,
    ! [VarCurr: state_type] :
      ( v62925(VarCurr,0)
    <=> v62927(VarCurr,0) ) ).

tff(addAssignment_36581,axiom,
    ! [VarCurr: state_type] :
      ( v62927(VarCurr,0)
    <=> v5975(VarCurr,0) ) ).

tff(addAssignment_36580,axiom,
    ! [VarCurr: state_type] :
      ( v62917(VarCurr,0)
    <=> v62919(VarCurr,0) ) ).

tff(addAssignment_36579,axiom,
    ! [VarCurr: state_type] :
      ( v62919(VarCurr,0)
    <=> v62921(VarCurr,0) ) ).

tff(addAssignment_36578,axiom,
    ! [VarCurr: state_type] :
      ( v62921(VarCurr,0)
    <=> v54706(VarCurr,0) ) ).

tff(addAssignment_36577,axiom,
    ! [VarCurr: state_type] :
      ( v62904(VarCurr)
    <=> v62906(VarCurr) ) ).

tff(addAssignment_36576,axiom,
    ! [VarCurr: state_type] :
      ( v62906(VarCurr)
    <=> v62908(VarCurr) ) ).

tff(writeUnaryOperator_3203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62908(VarCurr)
    <=> v62910(VarCurr) ) ).

tff(addAssignment_36575,axiom,
    ! [VarCurr: state_type] :
      ( v62910(VarCurr)
    <=> v62912(VarCurr) ) ).

tff(addAssignment_36574,axiom,
    ! [VarCurr: state_type] :
      ( v62912(VarCurr)
    <=> v62914(VarCurr) ) ).

tff(addAssignment_36573,axiom,
    ! [VarCurr: state_type] :
      ( v62914(VarCurr)
    <=> v54686(VarCurr) ) ).

tff(addAssignment_36572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62846(VarCurr,B)
      <=> v62848(VarCurr,B) ) ) ).

tff(addAssignment_36571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62848(VarCurr,B)
      <=> v5915(VarCurr,B) ) ) ).

tff(addAssignment_36570,axiom,
    ! [VarCurr: state_type] :
      ( v62817(VarCurr)
    <=> v62819(VarCurr) ) ).

tff(addAssignment_36569,axiom,
    ! [VarCurr: state_type] :
      ( v62819(VarCurr)
    <=> v62821(VarCurr) ) ).

tff(addAssignment_36568,axiom,
    ! [VarCurr: state_type] :
      ( v62821(VarCurr)
    <=> v62823(VarCurr) ) ).

tff(addAssignment_36567,axiom,
    ! [VarCurr: state_type] :
      ( v62823(VarCurr)
    <=> v62825(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5970,axiom,
    ! [VarCurr: state_type] :
      ( v62825(VarCurr)
    <=> ( v62827(VarCurr)
        & v62831(VarCurr) ) ) ).

tff(addAssignment_36566,axiom,
    ! [VarCurr: state_type] :
      ( v62831(VarCurr)
    <=> v62833(VarCurr) ) ).

tff(addAssignment_36565,axiom,
    ! [VarCurr: state_type] :
      ( v62833(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_36564,axiom,
    ! [VarCurr: state_type] :
      ( v62827(VarCurr)
    <=> v62829(VarCurr) ) ).

tff(addAssignment_36563,axiom,
    ! [VarCurr: state_type] :
      ( v62829(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36562,axiom,
    ! [VarCurr: state_type] :
      ( v62743(VarCurr)
    <=> v62745(VarCurr) ) ).

tff(addAssignment_36561,axiom,
    ! [VarCurr: state_type] :
      ( v62745(VarCurr)
    <=> v5865(VarCurr,3) ) ).

tff(addAssignment_36560,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,3)
    <=> v62747(VarCurr) ) ).

tff(addAssignment_36559,axiom,
    ! [VarCurr: state_type] :
      ( v62747(VarCurr)
    <=> v62749(VarCurr) ) ).

tff(writeUnaryOperator_3202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62749(VarCurr)
    <=> v62783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5969,axiom,
    ! [VarCurr: state_type] :
      ( v62783(VarCurr)
    <=> ( v62751(VarCurr)
        | v62779(VarCurr) ) ) ).

tff(addAssignment_36558,axiom,
    ! [VarCurr: state_type] :
      ( v62779(VarCurr)
    <=> v62781(VarCurr) ) ).

tff(addAssignment_36557,axiom,
    ! [VarCurr: state_type] :
      ( v62781(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36556,axiom,
    ! [VarCurr: state_type] :
      ( v62751(VarCurr)
    <=> v62753(VarCurr) ) ).

tff(addAssignment_36555,axiom,
    ! [VarCurr: state_type] :
      ( v62753(VarCurr)
    <=> v5875(VarCurr,3) ) ).

tff(addAssignment_36554,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,3)
    <=> v62755(VarCurr) ) ).

tff(addAssignment_36553,axiom,
    ! [VarCurr: state_type] :
      ( v62755(VarCurr)
    <=> v62757(VarCurr) ) ).

tff(writeUnaryOperator_3201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62757(VarCurr)
    <=> v62775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5968,axiom,
    ! [VarCurr: state_type] :
      ( v62775(VarCurr)
    <=> ( v62776(VarCurr)
        & v62771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5967,axiom,
    ! [VarCurr: state_type] :
      ( v62776(VarCurr)
    <=> ( v62777(VarCurr)
        & v62767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5966,axiom,
    ! [VarCurr: state_type] :
      ( v62777(VarCurr)
    <=> ( v62759(VarCurr)
        & v62763(VarCurr) ) ) ).

tff(addAssignment_36552,axiom,
    ! [VarCurr: state_type] :
      ( v62771(VarCurr)
    <=> v62773(VarCurr) ) ).

tff(addAssignment_36551,axiom,
    ! [VarCurr: state_type] :
      ( v62773(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36550,axiom,
    ! [VarCurr: state_type] :
      ( v62767(VarCurr)
    <=> v62769(VarCurr) ) ).

tff(addAssignment_36549,axiom,
    ! [VarCurr: state_type] :
      ( v62769(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_36548,axiom,
    ! [VarCurr: state_type] :
      ( v62763(VarCurr)
    <=> v62765(VarCurr) ) ).

tff(addAssignment_36547,axiom,
    ! [VarCurr: state_type] :
      ( v62765(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36546,axiom,
    ! [VarCurr: state_type] :
      ( v62759(VarCurr)
    <=> v62761(VarCurr) ) ).

tff(addAssignment_36545,axiom,
    ! [VarCurr: state_type] :
      ( v62761(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36544,axiom,
    ! [VarCurr: state_type] :
      ( v62691(VarCurr)
    <=> v62693(VarCurr) ) ).

tff(addAssignment_36543,axiom,
    ! [VarCurr: state_type] :
      ( v62693(VarCurr)
    <=> v5865(VarCurr,4) ) ).

tff(addAssignment_36542,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,4)
    <=> v62695(VarCurr) ) ).

tff(addAssignment_36541,axiom,
    ! [VarCurr: state_type] :
      ( v62695(VarCurr)
    <=> v62697(VarCurr) ) ).

tff(writeUnaryOperator_3200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62697(VarCurr)
    <=> v62731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5965,axiom,
    ! [VarCurr: state_type] :
      ( v62731(VarCurr)
    <=> ( v62699(VarCurr)
        | v62727(VarCurr) ) ) ).

tff(addAssignment_36540,axiom,
    ! [VarCurr: state_type] :
      ( v62727(VarCurr)
    <=> v62729(VarCurr) ) ).

tff(addAssignment_36539,axiom,
    ! [VarCurr: state_type] :
      ( v62729(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36538,axiom,
    ! [VarCurr: state_type] :
      ( v62699(VarCurr)
    <=> v62701(VarCurr) ) ).

tff(addAssignment_36537,axiom,
    ! [VarCurr: state_type] :
      ( v62701(VarCurr)
    <=> v5875(VarCurr,4) ) ).

tff(addAssignment_36536,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,4)
    <=> v62703(VarCurr) ) ).

tff(addAssignment_36535,axiom,
    ! [VarCurr: state_type] :
      ( v62703(VarCurr)
    <=> v62705(VarCurr) ) ).

tff(writeUnaryOperator_3199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62705(VarCurr)
    <=> v62723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5964,axiom,
    ! [VarCurr: state_type] :
      ( v62723(VarCurr)
    <=> ( v62724(VarCurr)
        & v62719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5963,axiom,
    ! [VarCurr: state_type] :
      ( v62724(VarCurr)
    <=> ( v62725(VarCurr)
        & v62715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5962,axiom,
    ! [VarCurr: state_type] :
      ( v62725(VarCurr)
    <=> ( v62707(VarCurr)
        & v62711(VarCurr) ) ) ).

tff(addAssignment_36534,axiom,
    ! [VarCurr: state_type] :
      ( v62719(VarCurr)
    <=> v62721(VarCurr) ) ).

tff(addAssignment_36533,axiom,
    ! [VarCurr: state_type] :
      ( v62721(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36532,axiom,
    ! [VarCurr: state_type] :
      ( v62715(VarCurr)
    <=> v62717(VarCurr) ) ).

tff(addAssignment_36531,axiom,
    ! [VarCurr: state_type] :
      ( v62717(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_36530,axiom,
    ! [VarCurr: state_type] :
      ( v62711(VarCurr)
    <=> v62713(VarCurr) ) ).

tff(addAssignment_36529,axiom,
    ! [VarCurr: state_type] :
      ( v62713(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36528,axiom,
    ! [VarCurr: state_type] :
      ( v62707(VarCurr)
    <=> v62709(VarCurr) ) ).

tff(addAssignment_36527,axiom,
    ! [VarCurr: state_type] :
      ( v62709(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36526,axiom,
    ! [VarCurr: state_type] :
      ( v62542(VarCurr)
    <=> v62544(VarCurr) ) ).

tff(addAssignment_36525,axiom,
    ! [VarCurr: state_type] :
      ( v62544(VarCurr)
    <=> v62546(VarCurr) ) ).

tff(addAssignment_36524,axiom,
    ! [VarCurr: state_type] :
      ( v62546(VarCurr)
    <=> v62548(VarCurr) ) ).

tff(addAssignment_36523,axiom,
    ! [VarCurr: state_type] :
      ( v62548(VarCurr)
    <=> v62550(VarCurr) ) ).

tff(writeUnaryOperator_3198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62550(VarCurr)
    <=> v62678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5961,axiom,
    ! [VarCurr: state_type] :
      ( v62678(VarCurr)
    <=> ( v62679(VarCurr)
        | v62636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5960,axiom,
    ! [VarCurr: state_type] :
      ( v62679(VarCurr)
    <=> ( v62552(VarCurr)
        | v62594(VarCurr) ) ) ).

tff(addAssignment_36522,axiom,
    ! [VarCurr: state_type] :
      ( v62636(VarCurr)
    <=> v62638(VarCurr) ) ).

tff(addAssignment_36521,axiom,
    ! [VarCurr: state_type] :
      ( v62638(VarCurr)
    <=> v5865(VarCurr,5) ) ).

tff(addAssignment_36520,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,5)
    <=> v62640(VarCurr) ) ).

tff(addAssignment_36519,axiom,
    ! [VarCurr: state_type] :
      ( v62640(VarCurr)
    <=> v62642(VarCurr) ) ).

tff(writeUnaryOperator_3197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62642(VarCurr)
    <=> v62676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5959,axiom,
    ! [VarCurr: state_type] :
      ( v62676(VarCurr)
    <=> ( v62644(VarCurr)
        | v62672(VarCurr) ) ) ).

tff(addAssignment_36518,axiom,
    ! [VarCurr: state_type] :
      ( v62672(VarCurr)
    <=> v62674(VarCurr) ) ).

tff(addAssignment_36517,axiom,
    ! [VarCurr: state_type] :
      ( v62674(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36516,axiom,
    ! [VarCurr: state_type] :
      ( v62644(VarCurr)
    <=> v62646(VarCurr) ) ).

tff(addAssignment_36515,axiom,
    ! [VarCurr: state_type] :
      ( v62646(VarCurr)
    <=> v5875(VarCurr,5) ) ).

tff(addAssignment_36514,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,5)
    <=> v62648(VarCurr) ) ).

tff(addAssignment_36513,axiom,
    ! [VarCurr: state_type] :
      ( v62648(VarCurr)
    <=> v62650(VarCurr) ) ).

tff(writeUnaryOperator_3196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62650(VarCurr)
    <=> v62668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5958,axiom,
    ! [VarCurr: state_type] :
      ( v62668(VarCurr)
    <=> ( v62669(VarCurr)
        & v62664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5957,axiom,
    ! [VarCurr: state_type] :
      ( v62669(VarCurr)
    <=> ( v62670(VarCurr)
        & v62660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5956,axiom,
    ! [VarCurr: state_type] :
      ( v62670(VarCurr)
    <=> ( v62652(VarCurr)
        & v62656(VarCurr) ) ) ).

tff(addAssignment_36512,axiom,
    ! [VarCurr: state_type] :
      ( v62664(VarCurr)
    <=> v62666(VarCurr) ) ).

tff(addAssignment_36511,axiom,
    ! [VarCurr: state_type] :
      ( v62666(VarCurr)
    <=> v62476(VarCurr) ) ).

tff(addAssignment_36510,axiom,
    ! [VarCurr: state_type] :
      ( v62660(VarCurr)
    <=> v62662(VarCurr) ) ).

tff(addAssignment_36509,axiom,
    ! [VarCurr: state_type] :
      ( v62662(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_36508,axiom,
    ! [VarCurr: state_type] :
      ( v62656(VarCurr)
    <=> v62658(VarCurr) ) ).

tff(addAssignment_36507,axiom,
    ! [VarCurr: state_type] :
      ( v62658(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36506,axiom,
    ! [VarCurr: state_type] :
      ( v62652(VarCurr)
    <=> v62654(VarCurr) ) ).

tff(addAssignment_36505,axiom,
    ! [VarCurr: state_type] :
      ( v62654(VarCurr)
    <=> v5885(VarCurr) ) ).

tff(addAssignment_36504,axiom,
    ! [VarCurr: state_type] :
      ( v62594(VarCurr)
    <=> v62596(VarCurr) ) ).

tff(addAssignment_36503,axiom,
    ! [VarCurr: state_type] :
      ( v62596(VarCurr)
    <=> v5865(VarCurr,6) ) ).

tff(addAssignment_36502,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,6)
    <=> v62598(VarCurr) ) ).

tff(addAssignment_36501,axiom,
    ! [VarCurr: state_type] :
      ( v62598(VarCurr)
    <=> v62600(VarCurr) ) ).

tff(writeUnaryOperator_3195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62600(VarCurr)
    <=> v62634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5955,axiom,
    ! [VarCurr: state_type] :
      ( v62634(VarCurr)
    <=> ( v62602(VarCurr)
        | v62630(VarCurr) ) ) ).

tff(addAssignment_36500,axiom,
    ! [VarCurr: state_type] :
      ( v62630(VarCurr)
    <=> v62632(VarCurr) ) ).

tff(addAssignment_36499,axiom,
    ! [VarCurr: state_type] :
      ( v62632(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36498,axiom,
    ! [VarCurr: state_type] :
      ( v62602(VarCurr)
    <=> v62604(VarCurr) ) ).

tff(addAssignment_36497,axiom,
    ! [VarCurr: state_type] :
      ( v62604(VarCurr)
    <=> v5875(VarCurr,6) ) ).

tff(addAssignment_36496,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,6)
    <=> v62606(VarCurr) ) ).

tff(addAssignment_36495,axiom,
    ! [VarCurr: state_type] :
      ( v62606(VarCurr)
    <=> v62608(VarCurr) ) ).

tff(writeUnaryOperator_3194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62608(VarCurr)
    <=> v62626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5954,axiom,
    ! [VarCurr: state_type] :
      ( v62626(VarCurr)
    <=> ( v62627(VarCurr)
        & v62622(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5953,axiom,
    ! [VarCurr: state_type] :
      ( v62627(VarCurr)
    <=> ( v62628(VarCurr)
        & v62618(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5952,axiom,
    ! [VarCurr: state_type] :
      ( v62628(VarCurr)
    <=> ( v62610(VarCurr)
        & v62614(VarCurr) ) ) ).

tff(addAssignment_36494,axiom,
    ! [VarCurr: state_type] :
      ( v62622(VarCurr)
    <=> v62624(VarCurr) ) ).

tff(addAssignment_36493,axiom,
    ! [VarCurr: state_type] :
      ( v62624(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36492,axiom,
    ! [VarCurr: state_type] :
      ( v62618(VarCurr)
    <=> v62620(VarCurr) ) ).

tff(addAssignment_36491,axiom,
    ! [VarCurr: state_type] :
      ( v62620(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_36490,axiom,
    ! [VarCurr: state_type] :
      ( v62614(VarCurr)
    <=> v62616(VarCurr) ) ).

tff(addAssignment_36489,axiom,
    ! [VarCurr: state_type] :
      ( v62616(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36488,axiom,
    ! [VarCurr: state_type] :
      ( v62610(VarCurr)
    <=> v62612(VarCurr) ) ).

tff(addAssignment_36487,axiom,
    ! [VarCurr: state_type] :
      ( v62612(VarCurr)
    <=> v5885(VarCurr) ) ).

tff(addAssignment_36486,axiom,
    ! [VarCurr: state_type] :
      ( v62552(VarCurr)
    <=> v62554(VarCurr) ) ).

tff(addAssignment_36485,axiom,
    ! [VarCurr: state_type] :
      ( v62554(VarCurr)
    <=> v5865(VarCurr,7) ) ).

tff(addAssignment_36484,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,7)
    <=> v62556(VarCurr) ) ).

tff(addAssignment_36483,axiom,
    ! [VarCurr: state_type] :
      ( v62556(VarCurr)
    <=> v62558(VarCurr) ) ).

tff(writeUnaryOperator_3193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62558(VarCurr)
    <=> v62592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5951,axiom,
    ! [VarCurr: state_type] :
      ( v62592(VarCurr)
    <=> ( v62560(VarCurr)
        | v62588(VarCurr) ) ) ).

tff(addAssignment_36482,axiom,
    ! [VarCurr: state_type] :
      ( v62588(VarCurr)
    <=> v62590(VarCurr) ) ).

tff(addAssignment_36481,axiom,
    ! [VarCurr: state_type] :
      ( v62590(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36480,axiom,
    ! [VarCurr: state_type] :
      ( v62560(VarCurr)
    <=> v62562(VarCurr) ) ).

tff(addAssignment_36479,axiom,
    ! [VarCurr: state_type] :
      ( v62562(VarCurr)
    <=> v5875(VarCurr,7) ) ).

tff(addAssignment_36478,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,7)
    <=> v62564(VarCurr) ) ).

tff(addAssignment_36477,axiom,
    ! [VarCurr: state_type] :
      ( v62564(VarCurr)
    <=> v62566(VarCurr) ) ).

tff(writeUnaryOperator_3192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62566(VarCurr)
    <=> v62584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5950,axiom,
    ! [VarCurr: state_type] :
      ( v62584(VarCurr)
    <=> ( v62585(VarCurr)
        & v62580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5949,axiom,
    ! [VarCurr: state_type] :
      ( v62585(VarCurr)
    <=> ( v62586(VarCurr)
        & v62576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5948,axiom,
    ! [VarCurr: state_type] :
      ( v62586(VarCurr)
    <=> ( v62568(VarCurr)
        & v62572(VarCurr) ) ) ).

tff(addAssignment_36476,axiom,
    ! [VarCurr: state_type] :
      ( v62580(VarCurr)
    <=> v62582(VarCurr) ) ).

tff(addAssignment_36475,axiom,
    ! [VarCurr: state_type] :
      ( v62582(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36474,axiom,
    ! [VarCurr: state_type] :
      ( v62576(VarCurr)
    <=> v62578(VarCurr) ) ).

tff(addAssignment_36473,axiom,
    ! [VarCurr: state_type] :
      ( v62578(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_36472,axiom,
    ! [VarCurr: state_type] :
      ( v62572(VarCurr)
    <=> v62574(VarCurr) ) ).

tff(addAssignment_36471,axiom,
    ! [VarCurr: state_type] :
      ( v62574(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_36470,axiom,
    ! [VarCurr: state_type] :
      ( v62568(VarCurr)
    <=> v62570(VarCurr) ) ).

tff(addAssignment_36469,axiom,
    ! [VarCurr: state_type] :
      ( v62570(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36468,axiom,
    ! [VarCurr: state_type] :
      ( v5851(VarCurr)
    <=> v5853(VarCurr) ) ).

tff(addAssignment_36467,axiom,
    ! [VarCurr: state_type] :
      ( v5853(VarCurr)
    <=> v5855(VarCurr) ) ).

tff(addAssignment_36466,axiom,
    ! [VarCurr: state_type] :
      ( v5855(VarCurr)
    <=> v5857(VarCurr) ) ).

tff(addAssignment_36465,axiom,
    ! [VarCurr: state_type] :
      ( v5857(VarCurr)
    <=> v5859(VarCurr) ) ).

tff(writeUnaryOperator_3191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5859(VarCurr)
    <=> v62539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5947,axiom,
    ! [VarCurr: state_type] :
      ( v62539(VarCurr)
    <=> ( v62540(VarCurr)
        | v62497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5946,axiom,
    ! [VarCurr: state_type] :
      ( v62540(VarCurr)
    <=> ( v5861(VarCurr)
        | v62433(VarCurr) ) ) ).

tff(addAssignment_36464,axiom,
    ! [VarCurr: state_type] :
      ( v62497(VarCurr)
    <=> v62499(VarCurr) ) ).

tff(addAssignment_36463,axiom,
    ! [VarCurr: state_type] :
      ( v62499(VarCurr)
    <=> v5865(VarCurr,8) ) ).

tff(addAssignment_36462,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,8)
    <=> v62501(VarCurr) ) ).

tff(addAssignment_36461,axiom,
    ! [VarCurr: state_type] :
      ( v62501(VarCurr)
    <=> v62503(VarCurr) ) ).

tff(writeUnaryOperator_3190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62503(VarCurr)
    <=> v62537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5945,axiom,
    ! [VarCurr: state_type] :
      ( v62537(VarCurr)
    <=> ( v62505(VarCurr)
        | v62533(VarCurr) ) ) ).

tff(addAssignment_36460,axiom,
    ! [VarCurr: state_type] :
      ( v62533(VarCurr)
    <=> v62535(VarCurr) ) ).

tff(addAssignment_36459,axiom,
    ! [VarCurr: state_type] :
      ( v62535(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36458,axiom,
    ! [VarCurr: state_type] :
      ( v62505(VarCurr)
    <=> v62507(VarCurr) ) ).

tff(addAssignment_36457,axiom,
    ! [VarCurr: state_type] :
      ( v62507(VarCurr)
    <=> v5875(VarCurr,8) ) ).

tff(addAssignment_36456,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,8)
    <=> v62509(VarCurr) ) ).

tff(addAssignment_36455,axiom,
    ! [VarCurr: state_type] :
      ( v62509(VarCurr)
    <=> v62511(VarCurr) ) ).

tff(writeUnaryOperator_3189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62511(VarCurr)
    <=> v62529(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5944,axiom,
    ! [VarCurr: state_type] :
      ( v62529(VarCurr)
    <=> ( v62530(VarCurr)
        & v62525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5943,axiom,
    ! [VarCurr: state_type] :
      ( v62530(VarCurr)
    <=> ( v62531(VarCurr)
        & v62521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5942,axiom,
    ! [VarCurr: state_type] :
      ( v62531(VarCurr)
    <=> ( v62513(VarCurr)
        & v62517(VarCurr) ) ) ).

tff(addAssignment_36454,axiom,
    ! [VarCurr: state_type] :
      ( v62525(VarCurr)
    <=> v62527(VarCurr) ) ).

tff(addAssignment_36453,axiom,
    ! [VarCurr: state_type] :
      ( v62527(VarCurr)
    <=> v62476(VarCurr) ) ).

tff(addAssignment_36452,axiom,
    ! [VarCurr: state_type] :
      ( v62521(VarCurr)
    <=> v62523(VarCurr) ) ).

tff(addAssignment_36451,axiom,
    ! [VarCurr: state_type] :
      ( v62523(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_36450,axiom,
    ! [VarCurr: state_type] :
      ( v62517(VarCurr)
    <=> v62519(VarCurr) ) ).

tff(addAssignment_36449,axiom,
    ! [VarCurr: state_type] :
      ( v62519(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_36448,axiom,
    ! [VarCurr: state_type] :
      ( v62513(VarCurr)
    <=> v62515(VarCurr) ) ).

tff(addAssignment_36447,axiom,
    ! [VarCurr: state_type] :
      ( v62515(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36446,axiom,
    ! [VarCurr: state_type] :
      ( v62433(VarCurr)
    <=> v62435(VarCurr) ) ).

tff(addAssignment_36445,axiom,
    ! [VarCurr: state_type] :
      ( v62435(VarCurr)
    <=> v5865(VarCurr,9) ) ).

tff(addAssignment_36444,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,9)
    <=> v62437(VarCurr) ) ).

tff(addAssignment_36443,axiom,
    ! [VarCurr: state_type] :
      ( v62437(VarCurr)
    <=> v62439(VarCurr) ) ).

tff(writeUnaryOperator_3188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62439(VarCurr)
    <=> v62495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5941,axiom,
    ! [VarCurr: state_type] :
      ( v62495(VarCurr)
    <=> ( v62441(VarCurr)
        | v62491(VarCurr) ) ) ).

tff(addAssignment_36442,axiom,
    ! [VarCurr: state_type] :
      ( v62491(VarCurr)
    <=> v62493(VarCurr) ) ).

tff(addAssignment_36441,axiom,
    ! [VarCurr: state_type] :
      ( v62493(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36440,axiom,
    ! [VarCurr: state_type] :
      ( v62441(VarCurr)
    <=> v62443(VarCurr) ) ).

tff(addAssignment_36439,axiom,
    ! [VarCurr: state_type] :
      ( v62443(VarCurr)
    <=> v5875(VarCurr,9) ) ).

tff(addAssignment_36438,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,9)
    <=> v62445(VarCurr) ) ).

tff(addAssignment_36437,axiom,
    ! [VarCurr: state_type] :
      ( v62445(VarCurr)
    <=> v62447(VarCurr) ) ).

tff(writeUnaryOperator_3187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62447(VarCurr)
    <=> v62487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5940,axiom,
    ! [VarCurr: state_type] :
      ( v62487(VarCurr)
    <=> ( v62488(VarCurr)
        & v62472(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5939,axiom,
    ! [VarCurr: state_type] :
      ( v62488(VarCurr)
    <=> ( v62489(VarCurr)
        & v62457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5938,axiom,
    ! [VarCurr: state_type] :
      ( v62489(VarCurr)
    <=> ( v62449(VarCurr)
        & v62453(VarCurr) ) ) ).

tff(addAssignment_36436,axiom,
    ! [VarCurr: state_type] :
      ( v62472(VarCurr)
    <=> v62474(VarCurr) ) ).

tff(addAssignment_36435,axiom,
    ! [VarCurr: state_type] :
      ( v62474(VarCurr)
    <=> v62476(VarCurr) ) ).

tff(addAssignment_36434,axiom,
    ! [VarCurr: state_type] :
      ( v62476(VarCurr)
    <=> v62478(VarCurr) ) ).

tff(addAssignment_36433,axiom,
    ! [VarCurr: state_type] :
      ( v62478(VarCurr)
    <=> v62480(VarCurr) ) ).

tff(writeUnaryOperator_3186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62480(VarCurr)
    <=> v62482(VarCurr) ) ).

tff(addAssignment_36432,axiom,
    ! [VarCurr: state_type] :
      ( v62482(VarCurr)
    <=> v62484(VarCurr) ) ).

tff(addAssignment_36431,axiom,
    ! [VarCurr: state_type] :
      ( v62484(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36430,axiom,
    ! [VarCurr: state_type] :
      ( v62457(VarCurr)
    <=> v62459(VarCurr) ) ).

tff(addAssignment_36429,axiom,
    ! [VarCurr: state_type] :
      ( v62459(VarCurr)
    <=> v62461(VarCurr) ) ).

tff(addAssignment_36428,axiom,
    ! [VarCurr: state_type] :
      ( v62461(VarCurr)
    <=> v62463(VarCurr) ) ).

tff(addAssignment_36427,axiom,
    ! [VarCurr: state_type] :
      ( v62463(VarCurr)
    <=> v62465(VarCurr) ) ).

tff(writeUnaryOperator_3185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62465(VarCurr)
    <=> v62467(VarCurr) ) ).

tff(addAssignment_36426,axiom,
    ! [VarCurr: state_type] :
      ( v62467(VarCurr)
    <=> v62469(VarCurr) ) ).

tff(addAssignment_36425,axiom,
    ! [VarCurr: state_type] :
      ( v62469(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_36424,axiom,
    ! [VarCurr: state_type] :
      ( v62453(VarCurr)
    <=> v62455(VarCurr) ) ).

tff(addAssignment_36423,axiom,
    ! [VarCurr: state_type] :
      ( v62455(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36422,axiom,
    ! [VarCurr: state_type] :
      ( v62449(VarCurr)
    <=> v62451(VarCurr) ) ).

tff(addAssignment_36421,axiom,
    ! [VarCurr: state_type] :
      ( v62451(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36420,axiom,
    ! [VarCurr: state_type] :
      ( v5861(VarCurr)
    <=> v5863(VarCurr) ) ).

tff(addAssignment_36419,axiom,
    ! [VarCurr: state_type] :
      ( v5863(VarCurr)
    <=> v5865(VarCurr,10) ) ).

tff(addAssignment_36418,axiom,
    ! [VarCurr: state_type] :
      ( v5865(VarCurr,10)
    <=> v5867(VarCurr) ) ).

tff(addAssignment_36417,axiom,
    ! [VarCurr: state_type] :
      ( v5867(VarCurr)
    <=> v5869(VarCurr) ) ).

tff(writeUnaryOperator_3184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5869(VarCurr)
    <=> v62431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5937,axiom,
    ! [VarCurr: state_type] :
      ( v62431(VarCurr)
    <=> ( v5871(VarCurr)
        | v62427(VarCurr) ) ) ).

tff(addAssignment_36416,axiom,
    ! [VarCurr: state_type] :
      ( v62427(VarCurr)
    <=> v62429(VarCurr) ) ).

tff(addAssignment_36415,axiom,
    ! [VarCurr: state_type] :
      ( v62429(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_36414,axiom,
    ! [VarCurr: state_type] :
      ( v5871(VarCurr)
    <=> v5873(VarCurr) ) ).

tff(addAssignment_36413,axiom,
    ! [VarCurr: state_type] :
      ( v5873(VarCurr)
    <=> v5875(VarCurr,10) ) ).

tff(addAssignment_36412,axiom,
    ! [VarCurr: state_type] :
      ( v5875(VarCurr,10)
    <=> v5877(VarCurr) ) ).

tff(addAssignment_36411,axiom,
    ! [VarCurr: state_type] :
      ( v5877(VarCurr)
    <=> v5879(VarCurr) ) ).

tff(writeUnaryOperator_3183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5879(VarCurr)
    <=> v62423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5936,axiom,
    ! [VarCurr: state_type] :
      ( v62423(VarCurr)
    <=> ( v62424(VarCurr)
        & v62333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5935,axiom,
    ! [VarCurr: state_type] :
      ( v62424(VarCurr)
    <=> ( v62425(VarCurr)
        & v62233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5934,axiom,
    ! [VarCurr: state_type] :
      ( v62425(VarCurr)
    <=> ( v5881(VarCurr)
        & v62063(VarCurr) ) ) ).

tff(addAssignment_36410,axiom,
    ! [VarCurr: state_type] :
      ( v62333(VarCurr)
    <=> v62335(VarCurr) ) ).

tff(addAssignment_36409,axiom,
    ! [VarCurr: state_type] :
      ( v62335(VarCurr)
    <=> v62337(VarCurr) ) ).

tff(addAssignment_36408,axiom,
    ! [VarCurr: state_type] :
      ( v62337(VarCurr)
    <=> v62339(VarCurr) ) ).

tff(addAssignment_36407,axiom,
    ! [VarCurr: state_type] :
      ( v62339(VarCurr)
    <=> v62341(VarCurr) ) ).

tff(writeUnaryOperator_3182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62341(VarCurr)
    <=> v62421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5933,axiom,
    ! [VarCurr: state_type] :
      ( v62421(VarCurr)
    <=> ( v62343(VarCurr)
        & v62401(VarCurr) ) ) ).

tff(addAssignment_36406,axiom,
    ! [VarCurr: state_type] :
      ( v62401(VarCurr)
    <=> v62403(VarCurr) ) ).

tff(addAssignment_36405,axiom,
    ! [VarCurr: state_type] :
      ( v62403(VarCurr)
    <=> v62405(VarCurr) ) ).

tff(addAssignment_36404,axiom,
    ! [VarCurr: state_type] :
      ( v62405(VarCurr)
    <=> v62407(VarCurr) ) ).

tff(addAssignment_36403,axiom,
    ! [VarCurr: state_type] :
      ( v62407(VarCurr)
    <=> v62409(VarCurr) ) ).

tff(writeUnaryOperator_3181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62409(VarCurr)
    <=> v62419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5932,axiom,
    ! [VarCurr: state_type] :
      ( v62419(VarCurr)
    <=> ( v62411(VarCurr)
        | v62415(VarCurr) ) ) ).

tff(addAssignment_36402,axiom,
    ! [VarCurr: state_type] :
      ( v62415(VarCurr)
    <=> v62417(VarCurr) ) ).

tff(addAssignment_36401,axiom,
    ! [VarCurr: state_type] :
      ( v62417(VarCurr)
    <=> v62357(VarCurr,0) ) ).

tff(addAssignment_36400,axiom,
    ! [VarCurr: state_type] :
      ( v62357(VarCurr,0)
    <=> v62359(VarCurr,0) ) ).

tff(addAssignment_36399,axiom,
    ! [VarCurr: state_type] :
      ( v62359(VarCurr,0)
    <=> v62361(VarCurr,0) ) ).

tff(addAssignment_36398,axiom,
    ! [VarCurr: state_type] :
      ( v62361(VarCurr,0)
    <=> v62393(VarCurr,0) ) ).

tff(addAssignment_36397,axiom,
    ! [VarCurr: state_type] :
      ( v62390(VarCurr,0)
    <=> v62392(VarCurr,0) ) ).

tff(addAssignment_36396,axiom,
    ! [VarCurr: state_type] :
      ( v62392(VarCurr,0)
    <=> v56461(VarCurr,0) ) ).

tff(addAssignment_36395,axiom,
    ! [VarCurr: state_type] :
      ( v62363(VarCurr,0)
    <=> v62365(VarCurr,0) ) ).

tff(addAssignment_36394,axiom,
    ! [VarCurr: state_type] :
      ( v62365(VarCurr,0)
    <=> v62387(VarCurr,0) ) ).

tff(addAssignment_36393,axiom,
    ! [VarCurr: state_type] :
      ( v62411(VarCurr)
    <=> v62413(VarCurr) ) ).

tff(addAssignment_36392,axiom,
    ! [VarCurr: state_type] :
      ( v62413(VarCurr)
    <=> v62357(VarCurr,1) ) ).

tff(addAssignment_36391,axiom,
    ! [VarCurr: state_type] :
      ( v62357(VarCurr,1)
    <=> v62359(VarCurr,1) ) ).

tff(addAssignment_36390,axiom,
    ! [VarCurr: state_type] :
      ( v62359(VarCurr,1)
    <=> v62361(VarCurr,1) ) ).

tff(addAssignment_36389,axiom,
    ! [VarCurr: state_type] :
      ( v62361(VarCurr,1)
    <=> v62393(VarCurr,1) ) ).

tff(addAssignment_36388,axiom,
    ! [VarCurr: state_type] :
      ( v62390(VarCurr,1)
    <=> v62392(VarCurr,1) ) ).

tff(addAssignment_36387,axiom,
    ! [VarCurr: state_type] :
      ( v62392(VarCurr,1)
    <=> v56461(VarCurr,1) ) ).

tff(addAssignment_36386,axiom,
    ! [VarCurr: state_type] :
      ( v62363(VarCurr,1)
    <=> v62365(VarCurr,1) ) ).

tff(addAssignment_36385,axiom,
    ! [VarCurr: state_type] :
      ( v62365(VarCurr,1)
    <=> v62387(VarCurr,1) ) ).

tff(addAssignment_36384,axiom,
    ! [VarCurr: state_type] :
      ( v62343(VarCurr)
    <=> v62345(VarCurr) ) ).

tff(addAssignment_36383,axiom,
    ! [VarCurr: state_type] :
      ( v62345(VarCurr)
    <=> v62347(VarCurr) ) ).

tff(addAssignment_36382,axiom,
    ! [VarCurr: state_type] :
      ( v62347(VarCurr)
    <=> v62349(VarCurr) ) ).

tff(addAssignment_36381,axiom,
    ! [VarCurr: state_type] :
      ( v62349(VarCurr)
    <=> v62351(VarCurr) ) ).

tff(writeUnaryOperator_3180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62351(VarCurr)
    <=> v62399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5931,axiom,
    ! [VarCurr: state_type] :
      ( v62399(VarCurr)
    <=> ( v62353(VarCurr)
        | v62395(VarCurr) ) ) ).

tff(addAssignment_36380,axiom,
    ! [VarCurr: state_type] :
      ( v62395(VarCurr)
    <=> v62397(VarCurr) ) ).

tff(addAssignment_36379,axiom,
    ! [VarCurr: state_type] :
      ( v62397(VarCurr)
    <=> v62357(VarCurr,2) ) ).

tff(addAssignment_36378,axiom,
    ! [VarCurr: state_type] :
      ( v62357(VarCurr,2)
    <=> v62359(VarCurr,2) ) ).

tff(addAssignment_36377,axiom,
    ! [VarCurr: state_type] :
      ( v62359(VarCurr,2)
    <=> v62361(VarCurr,2) ) ).

tff(addAssignment_36376,axiom,
    ! [VarCurr: state_type] :
      ( v62361(VarCurr,2)
    <=> v62393(VarCurr,2) ) ).

tff(addAssignment_36375,axiom,
    ! [VarCurr: state_type] :
      ( v62390(VarCurr,2)
    <=> v62392(VarCurr,2) ) ).

tff(addAssignment_36374,axiom,
    ! [VarCurr: state_type] :
      ( v62392(VarCurr,2)
    <=> v56461(VarCurr,2) ) ).

tff(addAssignment_36373,axiom,
    ! [VarCurr: state_type] :
      ( v62363(VarCurr,2)
    <=> v62365(VarCurr,2) ) ).

tff(addAssignment_36372,axiom,
    ! [VarCurr: state_type] :
      ( v62365(VarCurr,2)
    <=> v62387(VarCurr,2) ) ).

tff(addAssignment_36371,axiom,
    ! [VarCurr: state_type] :
      ( v62353(VarCurr)
    <=> v62355(VarCurr) ) ).

tff(addAssignment_36370,axiom,
    ! [VarCurr: state_type] :
      ( v62355(VarCurr)
    <=> v62357(VarCurr,3) ) ).

tff(addAssignment_36369,axiom,
    ! [VarCurr: state_type] :
      ( v62357(VarCurr,3)
    <=> v62359(VarCurr,3) ) ).

tff(addAssignment_36368,axiom,
    ! [VarCurr: state_type] :
      ( v62359(VarCurr,3)
    <=> v62361(VarCurr,3) ) ).

tff(addAssignment_36367,axiom,
    ! [VarCurr: state_type] :
      ( v62361(VarCurr,3)
    <=> v62393(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62393(VarCurr,B)
      <=> ( v62363(VarCurr,B)
          & v62390(VarCurr,B) ) ) ) ).

tff(addAssignment_36366,axiom,
    ! [VarCurr: state_type] :
      ( v62390(VarCurr,3)
    <=> v62392(VarCurr,3) ) ).

tff(addAssignment_36365,axiom,
    ! [VarCurr: state_type] :
      ( v62392(VarCurr,3)
    <=> v56461(VarCurr,3) ) ).

tff(addAssignment_36364,axiom,
    ! [VarCurr: state_type] :
      ( v62363(VarCurr,3)
    <=> v62365(VarCurr,3) ) ).

tff(addAssignment_36363,axiom,
    ! [VarCurr: state_type] :
      ( v62365(VarCurr,3)
    <=> v62387(VarCurr,3) ) ).

tff(addAssignment_36362,axiom,
    ! [VarCurr: state_type] :
      ( v62387(VarCurr,0)
    <=> v62388(VarCurr) ) ).

tff(addAssignment_36361,axiom,
    ! [VarCurr: state_type] :
      ( v62387(VarCurr,1)
    <=> v62388(VarCurr) ) ).

tff(addAssignment_36360,axiom,
    ! [VarCurr: state_type] :
      ( v62387(VarCurr,2)
    <=> v62388(VarCurr) ) ).

tff(addAssignment_36359,axiom,
    ! [VarCurr: state_type] :
      ( v62387(VarCurr,3)
    <=> v62388(VarCurr) ) ).

tff(addAssignment_36358,axiom,
    ! [VarCurr: state_type] :
      ( v62388(VarCurr)
    <=> v62367(VarCurr) ) ).

tff(addAssignment_36357,axiom,
    ! [VarCurr: state_type] :
      ( v62367(VarCurr)
    <=> v62369(VarCurr) ) ).

tff(addAssignment_36356,axiom,
    ! [VarCurr: state_type] :
      ( v62369(VarCurr)
    <=> v62371(VarCurr) ) ).

tff(writeUnaryOperator_3179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62371(VarCurr)
    <=> v62385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5930,axiom,
    ! [VarCurr: state_type] :
      ( v62385(VarCurr)
    <=> ( v62386(VarCurr)
        & v62381(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5929,axiom,
    ! [VarCurr: state_type] :
      ( v62386(VarCurr)
    <=> ( v62373(VarCurr)
        & v62377(VarCurr) ) ) ).

tff(addAssignment_36355,axiom,
    ! [VarCurr: state_type] :
      ( v62381(VarCurr)
    <=> v62383(VarCurr) ) ).

tff(addAssignment_36354,axiom,
    ! [VarCurr: state_type] :
      ( v62383(VarCurr)
    <=> v54676(VarCurr) ) ).

tff(addAssignment_36353,axiom,
    ! [VarCurr: state_type] :
      ( v62377(VarCurr)
    <=> v62379(VarCurr) ) ).

tff(addAssignment_36352,axiom,
    ! [VarCurr: state_type] :
      ( v62379(VarCurr)
    <=> v5945(VarCurr) ) ).

tff(addAssignment_36351,axiom,
    ! [VarCurr: state_type] :
      ( v62373(VarCurr)
    <=> v62375(VarCurr) ) ).

tff(addAssignment_36350,axiom,
    ! [VarCurr: state_type] :
      ( v62375(VarCurr)
    <=> v62127(VarCurr) ) ).

tff(addAssignment_36349,axiom,
    ! [VarCurr: state_type] :
      ( v62233(VarCurr)
    <=> v62235(VarCurr) ) ).

tff(addAssignment_36348,axiom,
    ! [VarCurr: state_type] :
      ( v62235(VarCurr)
    <=> v62237(VarCurr) ) ).

tff(addAssignment_36347,axiom,
    ! [VarCurr: state_type] :
      ( v62237(VarCurr)
    <=> v62239(VarCurr) ) ).

tff(addAssignment_36346,axiom,
    ! [VarCurr: state_type] :
      ( v62239(VarCurr)
    <=> v62241(VarCurr) ) ).

tff(writeUnaryOperator_3178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62241(VarCurr)
    <=> v62331(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5928,axiom,
    ! [VarCurr: state_type] :
      ( v62331(VarCurr)
    <=> ( v62243(VarCurr)
        & v62311(VarCurr) ) ) ).

tff(addAssignment_36345,axiom,
    ! [VarCurr: state_type] :
      ( v62311(VarCurr)
    <=> v62313(VarCurr) ) ).

tff(addAssignment_36344,axiom,
    ! [VarCurr: state_type] :
      ( v62313(VarCurr)
    <=> v62315(VarCurr) ) ).

tff(addAssignment_36343,axiom,
    ! [VarCurr: state_type] :
      ( v62315(VarCurr)
    <=> v62317(VarCurr) ) ).

tff(addAssignment_36342,axiom,
    ! [VarCurr: state_type] :
      ( v62317(VarCurr)
    <=> v62319(VarCurr) ) ).

tff(writeUnaryOperator_3177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62319(VarCurr)
    <=> v62329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5927,axiom,
    ! [VarCurr: state_type] :
      ( v62329(VarCurr)
    <=> ( v62321(VarCurr)
        | v62325(VarCurr) ) ) ).

tff(addAssignment_36341,axiom,
    ! [VarCurr: state_type] :
      ( v62325(VarCurr)
    <=> v62327(VarCurr) ) ).

tff(addAssignment_36340,axiom,
    ! [VarCurr: state_type] :
      ( v62327(VarCurr)
    <=> v62257(VarCurr,0) ) ).

tff(addAssignment_36339,axiom,
    ! [VarCurr: state_type] :
      ( v62257(VarCurr,0)
    <=> v62259(VarCurr,0) ) ).

tff(addAssignment_36338,axiom,
    ! [VarCurr: state_type] :
      ( v62259(VarCurr,0)
    <=> v62261(VarCurr,0) ) ).

tff(addAssignment_36337,axiom,
    ! [VarCurr: state_type] :
      ( v62261(VarCurr,0)
    <=> v62303(VarCurr,0) ) ).

tff(addAssignment_36336,axiom,
    ! [VarCurr: state_type] :
      ( v62300(VarCurr,0)
    <=> v62302(VarCurr,0) ) ).

tff(addAssignment_36335,axiom,
    ! [VarCurr: state_type] :
      ( v62302(VarCurr,0)
    <=> v54706(VarCurr,0) ) ).

tff(addAssignment_36334,axiom,
    ! [VarCurr: state_type] :
      ( v62263(VarCurr,0)
    <=> v62265(VarCurr,0) ) ).

tff(addAssignment_36333,axiom,
    ! [VarCurr: state_type] :
      ( v62265(VarCurr,0)
    <=> v62297(VarCurr,0) ) ).

tff(addAssignment_36332,axiom,
    ! [VarCurr: state_type] :
      ( v62321(VarCurr)
    <=> v62323(VarCurr) ) ).

tff(addAssignment_36331,axiom,
    ! [VarCurr: state_type] :
      ( v62323(VarCurr)
    <=> v62257(VarCurr,1) ) ).

tff(addAssignment_36330,axiom,
    ! [VarCurr: state_type] :
      ( v62257(VarCurr,1)
    <=> v62259(VarCurr,1) ) ).

tff(addAssignment_36329,axiom,
    ! [VarCurr: state_type] :
      ( v62259(VarCurr,1)
    <=> v62261(VarCurr,1) ) ).

tff(addAssignment_36328,axiom,
    ! [VarCurr: state_type] :
      ( v62261(VarCurr,1)
    <=> v62303(VarCurr,1) ) ).

tff(addAssignment_36327,axiom,
    ! [VarCurr: state_type] :
      ( v62300(VarCurr,1)
    <=> v62302(VarCurr,1) ) ).

tff(addAssignment_36326,axiom,
    ! [VarCurr: state_type] :
      ( v62302(VarCurr,1)
    <=> v54706(VarCurr,1) ) ).

tff(addAssignment_36325,axiom,
    ! [VarCurr: state_type] :
      ( v62263(VarCurr,1)
    <=> v62265(VarCurr,1) ) ).

tff(addAssignment_36324,axiom,
    ! [VarCurr: state_type] :
      ( v62265(VarCurr,1)
    <=> v62297(VarCurr,1) ) ).

tff(addAssignment_36323,axiom,
    ! [VarCurr: state_type] :
      ( v62243(VarCurr)
    <=> v62245(VarCurr) ) ).

tff(addAssignment_36322,axiom,
    ! [VarCurr: state_type] :
      ( v62245(VarCurr)
    <=> v62247(VarCurr) ) ).

tff(addAssignment_36321,axiom,
    ! [VarCurr: state_type] :
      ( v62247(VarCurr)
    <=> v62249(VarCurr) ) ).

tff(addAssignment_36320,axiom,
    ! [VarCurr: state_type] :
      ( v62249(VarCurr)
    <=> v62251(VarCurr) ) ).

tff(writeUnaryOperator_3176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62251(VarCurr)
    <=> v62309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5926,axiom,
    ! [VarCurr: state_type] :
      ( v62309(VarCurr)
    <=> ( v62253(VarCurr)
        | v62305(VarCurr) ) ) ).

tff(addAssignment_36319,axiom,
    ! [VarCurr: state_type] :
      ( v62305(VarCurr)
    <=> v62307(VarCurr) ) ).

tff(addAssignment_36318,axiom,
    ! [VarCurr: state_type] :
      ( v62307(VarCurr)
    <=> v62257(VarCurr,2) ) ).

tff(addAssignment_36317,axiom,
    ! [VarCurr: state_type] :
      ( v62257(VarCurr,2)
    <=> v62259(VarCurr,2) ) ).

tff(addAssignment_36316,axiom,
    ! [VarCurr: state_type] :
      ( v62259(VarCurr,2)
    <=> v62261(VarCurr,2) ) ).

tff(addAssignment_36315,axiom,
    ! [VarCurr: state_type] :
      ( v62261(VarCurr,2)
    <=> v62303(VarCurr,2) ) ).

tff(addAssignment_36314,axiom,
    ! [VarCurr: state_type] :
      ( v62300(VarCurr,2)
    <=> v62302(VarCurr,2) ) ).

tff(addAssignment_36313,axiom,
    ! [VarCurr: state_type] :
      ( v62302(VarCurr,2)
    <=> v54706(VarCurr,2) ) ).

tff(addAssignment_36312,axiom,
    ! [VarCurr: state_type] :
      ( v62263(VarCurr,2)
    <=> v62265(VarCurr,2) ) ).

tff(addAssignment_36311,axiom,
    ! [VarCurr: state_type] :
      ( v62265(VarCurr,2)
    <=> v62297(VarCurr,2) ) ).

tff(addAssignment_36310,axiom,
    ! [VarCurr: state_type] :
      ( v62253(VarCurr)
    <=> v62255(VarCurr) ) ).

tff(addAssignment_36309,axiom,
    ! [VarCurr: state_type] :
      ( v62255(VarCurr)
    <=> v62257(VarCurr,3) ) ).

tff(addAssignment_36308,axiom,
    ! [VarCurr: state_type] :
      ( v62257(VarCurr,3)
    <=> v62259(VarCurr,3) ) ).

tff(addAssignment_36307,axiom,
    ! [VarCurr: state_type] :
      ( v62259(VarCurr,3)
    <=> v62261(VarCurr,3) ) ).

tff(addAssignment_36306,axiom,
    ! [VarCurr: state_type] :
      ( v62261(VarCurr,3)
    <=> v62303(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62303(VarCurr,B)
      <=> ( v62263(VarCurr,B)
          & v62300(VarCurr,B) ) ) ) ).

tff(addAssignment_36305,axiom,
    ! [VarCurr: state_type] :
      ( v62300(VarCurr,3)
    <=> v62302(VarCurr,3) ) ).

tff(addAssignment_36304,axiom,
    ! [VarCurr: state_type] :
      ( v62302(VarCurr,3)
    <=> v54706(VarCurr,3) ) ).

tff(addAssignment_36303,axiom,
    ! [VarCurr: state_type] :
      ( v62263(VarCurr,3)
    <=> v62265(VarCurr,3) ) ).

tff(addAssignment_36302,axiom,
    ! [VarCurr: state_type] :
      ( v62265(VarCurr,3)
    <=> v62297(VarCurr,3) ) ).

tff(addAssignment_36301,axiom,
    ! [VarCurr: state_type] :
      ( v62297(VarCurr,0)
    <=> v62298(VarCurr) ) ).

tff(addAssignment_36300,axiom,
    ! [VarCurr: state_type] :
      ( v62297(VarCurr,1)
    <=> v62298(VarCurr) ) ).

tff(addAssignment_36299,axiom,
    ! [VarCurr: state_type] :
      ( v62297(VarCurr,2)
    <=> v62298(VarCurr) ) ).

tff(addAssignment_36298,axiom,
    ! [VarCurr: state_type] :
      ( v62297(VarCurr,3)
    <=> v62298(VarCurr) ) ).

tff(addAssignment_36297,axiom,
    ! [VarCurr: state_type] :
      ( v62298(VarCurr)
    <=> v62267(VarCurr) ) ).

tff(addAssignment_36296,axiom,
    ! [VarCurr: state_type] :
      ( v62267(VarCurr)
    <=> v62269(VarCurr) ) ).

tff(addAssignment_36295,axiom,
    ! [VarCurr: state_type] :
      ( v62269(VarCurr)
    <=> v62271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5925,axiom,
    ! [VarCurr: state_type] :
      ( v62271(VarCurr)
    <=> ( v62273(VarCurr)
        | v62293(VarCurr) ) ) ).

tff(addAssignment_36294,axiom,
    ! [VarCurr: state_type] :
      ( v62293(VarCurr)
    <=> v62295(VarCurr) ) ).

tff(addAssignment_36293,axiom,
    ! [VarCurr: state_type] :
      ( v62295(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_36292,axiom,
    ! [VarCurr: state_type] :
      ( v62273(VarCurr)
    <=> v62275(VarCurr) ) ).

tff(addAssignment_36291,axiom,
    ! [VarCurr: state_type] :
      ( v62275(VarCurr)
    <=> v62277(VarCurr) ) ).

tff(addAssignment_36290,axiom,
    ! [VarCurr: state_type] :
      ( v62277(VarCurr)
    <=> v62279(VarCurr) ) ).

tff(addAssignment_36289,axiom,
    ! [VarCurr: state_type] :
      ( v62279(VarCurr)
    <=> v62281(VarCurr) ) ).

tff(writeUnaryOperator_3175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62281(VarCurr)
    <=> v62291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5924,axiom,
    ! [VarCurr: state_type] :
      ( v62291(VarCurr)
    <=> ( v62283(VarCurr)
        & v62287(VarCurr) ) ) ).

tff(addAssignment_36288,axiom,
    ! [VarCurr: state_type] :
      ( v62287(VarCurr)
    <=> v62289(VarCurr) ) ).

tff(addAssignment_36287,axiom,
    ! [VarCurr: state_type] :
      ( v62289(VarCurr)
    <=> v5945(VarCurr) ) ).

tff(addAssignment_36286,axiom,
    ! [VarCurr: state_type] :
      ( v62283(VarCurr)
    <=> v62285(VarCurr) ) ).

tff(addAssignment_36285,axiom,
    ! [VarCurr: state_type] :
      ( v62285(VarCurr)
    <=> v62127(VarCurr) ) ).

tff(addAssignment_36284,axiom,
    ! [VarCurr: state_type] :
      ( v62063(VarCurr)
    <=> v62065(VarCurr) ) ).

tff(addAssignment_36283,axiom,
    ! [VarCurr: state_type] :
      ( v62065(VarCurr)
    <=> v62067(VarCurr) ) ).

tff(addAssignment_36282,axiom,
    ! [VarCurr: state_type] :
      ( v62067(VarCurr)
    <=> v62069(VarCurr) ) ).

tff(addAssignment_36281,axiom,
    ! [VarCurr: state_type] :
      ( v62069(VarCurr)
    <=> v62071(VarCurr) ) ).

tff(writeUnaryOperator_3174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62071(VarCurr)
    <=> v62073(VarCurr) ) ).

tff(addAssignment_36280,axiom,
    ! [VarCurr: state_type] :
      ( v62073(VarCurr)
    <=> v62075(VarCurr) ) ).

tff(addAssignment_36279,axiom,
    ! [VarCurr: state_type] :
      ( v62075(VarCurr)
    <=> v62077(VarCurr) ) ).

tff(addAssignment_36278,axiom,
    ! [VarCurr: state_type] :
      ( v62077(VarCurr)
    <=> v62079(VarCurr) ) ).

tff(addAssignment_36277,axiom,
    ! [VarCurr: state_type] :
      ( v62079(VarCurr)
    <=> v62081(VarCurr) ) ).

tff(writeUnaryOperator_3173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62081(VarCurr)
    <=> v62230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5923,axiom,
    ! [VarCurr: state_type] :
      ( v62230(VarCurr)
    <=> ( v62083(VarCurr)
        & v62210(VarCurr) ) ) ).

tff(addAssignment_36276,axiom,
    ! [VarCurr: state_type] :
      ( v62210(VarCurr)
    <=> v62212(VarCurr) ) ).

tff(addAssignment_36275,axiom,
    ! [VarCurr: state_type] :
      ( v62212(VarCurr)
    <=> v62214(VarCurr) ) ).

tff(addAssignment_36274,axiom,
    ! [VarCurr: state_type] :
      ( v62214(VarCurr)
    <=> v62216(VarCurr) ) ).

tff(addAssignment_36273,axiom,
    ! [VarCurr: state_type] :
      ( v62216(VarCurr)
    <=> v62218(VarCurr) ) ).

tff(writeUnaryOperator_3172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62218(VarCurr)
    <=> v62228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5922,axiom,
    ! [VarCurr: state_type] :
      ( v62228(VarCurr)
    <=> ( v62220(VarCurr)
        | v62224(VarCurr) ) ) ).

tff(addAssignment_36272,axiom,
    ! [VarCurr: state_type] :
      ( v62224(VarCurr)
    <=> v62226(VarCurr) ) ).

tff(addAssignment_36271,axiom,
    ! [VarCurr: state_type] :
      ( v62226(VarCurr)
    <=> v62097(VarCurr,0) ) ).

tff(addAssignment_36270,axiom,
    ! [VarCurr: state_type] :
      ( v62097(VarCurr,0)
    <=> v62099(VarCurr,0) ) ).

tff(addAssignment_36269,axiom,
    ! [VarCurr: state_type] :
      ( v62099(VarCurr,0)
    <=> v62101(VarCurr,0) ) ).

tff(addAssignment_36268,axiom,
    ! [VarCurr: state_type] :
      ( v62101(VarCurr,0)
    <=> v62202(VarCurr,0) ) ).

tff(addAssignment_36267,axiom,
    ! [VarCurr: state_type] :
      ( v62199(VarCurr,0)
    <=> v62201(VarCurr,0) ) ).

tff(addAssignment_36266,axiom,
    ! [VarCurr: state_type] :
      ( v62201(VarCurr,0)
    <=> v5975(VarCurr,0) ) ).

tff(addAssignment_36265,axiom,
    ! [VarCurr: state_type] :
      ( v62103(VarCurr,0)
    <=> v62105(VarCurr,0) ) ).

tff(addAssignment_36264,axiom,
    ! [VarCurr: state_type] :
      ( v62105(VarCurr,0)
    <=> v62196(VarCurr,0) ) ).

tff(addAssignment_36263,axiom,
    ! [VarCurr: state_type] :
      ( v62220(VarCurr)
    <=> v62222(VarCurr) ) ).

tff(addAssignment_36262,axiom,
    ! [VarCurr: state_type] :
      ( v62222(VarCurr)
    <=> v62097(VarCurr,1) ) ).

tff(addAssignment_36261,axiom,
    ! [VarCurr: state_type] :
      ( v62097(VarCurr,1)
    <=> v62099(VarCurr,1) ) ).

tff(addAssignment_36260,axiom,
    ! [VarCurr: state_type] :
      ( v62099(VarCurr,1)
    <=> v62101(VarCurr,1) ) ).

tff(addAssignment_36259,axiom,
    ! [VarCurr: state_type] :
      ( v62101(VarCurr,1)
    <=> v62202(VarCurr,1) ) ).

tff(addAssignment_36258,axiom,
    ! [VarCurr: state_type] :
      ( v62199(VarCurr,1)
    <=> v62201(VarCurr,1) ) ).

tff(addAssignment_36257,axiom,
    ! [VarCurr: state_type] :
      ( v62201(VarCurr,1)
    <=> v5975(VarCurr,1) ) ).

tff(addAssignment_36256,axiom,
    ! [VarCurr: state_type] :
      ( v62103(VarCurr,1)
    <=> v62105(VarCurr,1) ) ).

tff(addAssignment_36255,axiom,
    ! [VarCurr: state_type] :
      ( v62105(VarCurr,1)
    <=> v62196(VarCurr,1) ) ).

tff(addAssignment_36254,axiom,
    ! [VarCurr: state_type] :
      ( v62083(VarCurr)
    <=> v62085(VarCurr) ) ).

tff(addAssignment_36253,axiom,
    ! [VarCurr: state_type] :
      ( v62085(VarCurr)
    <=> v62087(VarCurr) ) ).

tff(addAssignment_36252,axiom,
    ! [VarCurr: state_type] :
      ( v62087(VarCurr)
    <=> v62089(VarCurr) ) ).

tff(addAssignment_36251,axiom,
    ! [VarCurr: state_type] :
      ( v62089(VarCurr)
    <=> v62091(VarCurr) ) ).

tff(writeUnaryOperator_3171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62091(VarCurr)
    <=> v62208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5921,axiom,
    ! [VarCurr: state_type] :
      ( v62208(VarCurr)
    <=> ( v62093(VarCurr)
        | v62204(VarCurr) ) ) ).

tff(addAssignment_36250,axiom,
    ! [VarCurr: state_type] :
      ( v62204(VarCurr)
    <=> v62206(VarCurr) ) ).

tff(addAssignment_36249,axiom,
    ! [VarCurr: state_type] :
      ( v62206(VarCurr)
    <=> v62097(VarCurr,2) ) ).

tff(addAssignment_36248,axiom,
    ! [VarCurr: state_type] :
      ( v62097(VarCurr,2)
    <=> v62099(VarCurr,2) ) ).

tff(addAssignment_36247,axiom,
    ! [VarCurr: state_type] :
      ( v62099(VarCurr,2)
    <=> v62101(VarCurr,2) ) ).

tff(addAssignment_36246,axiom,
    ! [VarCurr: state_type] :
      ( v62101(VarCurr,2)
    <=> v62202(VarCurr,2) ) ).

tff(addAssignment_36245,axiom,
    ! [VarCurr: state_type] :
      ( v62199(VarCurr,2)
    <=> v62201(VarCurr,2) ) ).

tff(addAssignment_36244,axiom,
    ! [VarCurr: state_type] :
      ( v62201(VarCurr,2)
    <=> v5975(VarCurr,2) ) ).

tff(addAssignment_36243,axiom,
    ! [VarCurr: state_type] :
      ( v62103(VarCurr,2)
    <=> v62105(VarCurr,2) ) ).

tff(addAssignment_36242,axiom,
    ! [VarCurr: state_type] :
      ( v62105(VarCurr,2)
    <=> v62196(VarCurr,2) ) ).

tff(addAssignment_36241,axiom,
    ! [VarCurr: state_type] :
      ( v62093(VarCurr)
    <=> v62095(VarCurr) ) ).

tff(addAssignment_36240,axiom,
    ! [VarCurr: state_type] :
      ( v62095(VarCurr)
    <=> v62097(VarCurr,3) ) ).

tff(addAssignment_36239,axiom,
    ! [VarCurr: state_type] :
      ( v62097(VarCurr,3)
    <=> v62099(VarCurr,3) ) ).

tff(addAssignment_36238,axiom,
    ! [VarCurr: state_type] :
      ( v62099(VarCurr,3)
    <=> v62101(VarCurr,3) ) ).

tff(addAssignment_36237,axiom,
    ! [VarCurr: state_type] :
      ( v62101(VarCurr,3)
    <=> v62202(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v62202(VarCurr,B)
      <=> ( v62103(VarCurr,B)
          & v62199(VarCurr,B) ) ) ) ).

tff(addAssignment_36236,axiom,
    ! [VarCurr: state_type] :
      ( v62199(VarCurr,3)
    <=> v62201(VarCurr,3) ) ).

tff(addAssignment_36235,axiom,
    ! [VarCurr: state_type] :
      ( v62201(VarCurr,3)
    <=> v5975(VarCurr,3) ) ).

tff(addAssignment_36234,axiom,
    ! [VarCurr: state_type] :
      ( v62103(VarCurr,3)
    <=> v62105(VarCurr,3) ) ).

tff(addAssignment_36233,axiom,
    ! [VarCurr: state_type] :
      ( v62105(VarCurr,3)
    <=> v62196(VarCurr,3) ) ).

tff(addAssignment_36232,axiom,
    ! [VarCurr: state_type] :
      ( v62196(VarCurr,0)
    <=> v62197(VarCurr) ) ).

tff(addAssignment_36231,axiom,
    ! [VarCurr: state_type] :
      ( v62196(VarCurr,1)
    <=> v62197(VarCurr) ) ).

tff(addAssignment_36230,axiom,
    ! [VarCurr: state_type] :
      ( v62196(VarCurr,2)
    <=> v62197(VarCurr) ) ).

tff(addAssignment_36229,axiom,
    ! [VarCurr: state_type] :
      ( v62196(VarCurr,3)
    <=> v62197(VarCurr) ) ).

tff(addAssignment_36228,axiom,
    ! [VarCurr: state_type] :
      ( v62197(VarCurr)
    <=> v62107(VarCurr) ) ).

tff(addAssignment_36227,axiom,
    ! [VarCurr: state_type] :
      ( v62107(VarCurr)
    <=> v62109(VarCurr) ) ).

tff(addAssignment_36226,axiom,
    ! [VarCurr: state_type] :
      ( v62109(VarCurr)
    <=> v62111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5920,axiom,
    ! [VarCurr: state_type] :
      ( v62111(VarCurr)
    <=> ( v62113(VarCurr)
        | v62192(VarCurr) ) ) ).

tff(addAssignment_36225,axiom,
    ! [VarCurr: state_type] :
      ( v62192(VarCurr)
    <=> v62194(VarCurr) ) ).

tff(addAssignment_36224,axiom,
    ! [VarCurr: state_type] :
      ( v62194(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_36223,axiom,
    ! [VarCurr: state_type] :
      ( v62113(VarCurr)
    <=> v62115(VarCurr) ) ).

tff(addAssignment_36222,axiom,
    ! [VarCurr: state_type] :
      ( v62115(VarCurr)
    <=> v62117(VarCurr) ) ).

tff(addAssignment_36221,axiom,
    ! [VarCurr: state_type] :
      ( v62117(VarCurr)
    <=> v62119(VarCurr) ) ).

tff(addAssignment_36220,axiom,
    ! [VarCurr: state_type] :
      ( v62119(VarCurr)
    <=> v62121(VarCurr) ) ).

tff(writeUnaryOperator_3170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62121(VarCurr)
    <=> v62190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5919,axiom,
    ! [VarCurr: state_type] :
      ( v62190(VarCurr)
    <=> ( v62123(VarCurr)
        & v62186(VarCurr) ) ) ).

tff(addAssignment_36219,axiom,
    ! [VarCurr: state_type] :
      ( v62186(VarCurr)
    <=> v62188(VarCurr) ) ).

tff(addAssignment_36218,axiom,
    ! [VarCurr: state_type] :
      ( v62188(VarCurr)
    <=> v54676(VarCurr) ) ).

tff(addAssignment_36217,axiom,
    ! [VarCurr: state_type] :
      ( v62123(VarCurr)
    <=> v62125(VarCurr) ) ).

tff(addAssignment_36216,axiom,
    ! [VarCurr: state_type] :
      ( v62125(VarCurr)
    <=> v62127(VarCurr) ) ).

tff(addAssignment_36215,axiom,
    ! [VarCurr: state_type] :
      ( v62127(VarCurr)
    <=> v62129(VarCurr) ) ).

tff(addAssignment_36214,axiom,
    ! [VarCurr: state_type] :
      ( v62129(VarCurr)
    <=> v62131(VarCurr) ) ).

tff(writeUnaryOperator_3169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62131(VarCurr)
    <=> v62133(VarCurr) ) ).

tff(addAssignment_36213,axiom,
    ! [VarCurr: state_type] :
      ( v62133(VarCurr)
    <=> v62135(VarCurr) ) ).

tff(addAssignment_36212,axiom,
    ! [VarCurr: state_type] :
      ( v62135(VarCurr)
    <=> v62137(VarCurr) ) ).

tff(addAssignment_36211,axiom,
    ! [VarCurr: state_type] :
      ( v62137(VarCurr)
    <=> v62139(VarCurr) ) ).

tff(addAssignment_36210,axiom,
    ! [VarCurr: state_type] :
      ( v62139(VarCurr)
    <=> v62141(VarCurr) ) ).

tff(writeUnaryOperator_3168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62141(VarCurr)
    <=> v62183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5918,axiom,
    ! [VarCurr: state_type] :
      ( v62183(VarCurr)
    <=> ( v62143(VarCurr)
        & v62163(VarCurr) ) ) ).

tff(addAssignment_36209,axiom,
    ! [VarCurr: state_type] :
      ( v62163(VarCurr)
    <=> v62165(VarCurr) ) ).

tff(addAssignment_36208,axiom,
    ! [VarCurr: state_type] :
      ( v62165(VarCurr)
    <=> v62167(VarCurr) ) ).

tff(addAssignment_36207,axiom,
    ! [VarCurr: state_type] :
      ( v62167(VarCurr)
    <=> v62169(VarCurr) ) ).

tff(addAssignment_36206,axiom,
    ! [VarCurr: state_type] :
      ( v62169(VarCurr)
    <=> v62171(VarCurr) ) ).

tff(writeUnaryOperator_3167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62171(VarCurr)
    <=> v62181(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5917,axiom,
    ! [VarCurr: state_type] :
      ( v62181(VarCurr)
    <=> ( v62173(VarCurr)
        | v62177(VarCurr) ) ) ).

tff(addAssignment_36205,axiom,
    ! [VarCurr: state_type] :
      ( v62177(VarCurr)
    <=> v62179(VarCurr) ) ).

tff(addAssignment_36204,axiom,
    ! [VarCurr: state_type] :
      ( v62179(VarCurr)
    <=> v59242(VarCurr,0) ) ).

tff(addAssignment_36203,axiom,
    ! [VarCurr: state_type] :
      ( v62173(VarCurr)
    <=> v62175(VarCurr) ) ).

tff(addAssignment_36202,axiom,
    ! [VarCurr: state_type] :
      ( v62175(VarCurr)
    <=> v59242(VarCurr,1) ) ).

tff(addAssignment_36201,axiom,
    ! [VarCurr: state_type] :
      ( v62143(VarCurr)
    <=> v62145(VarCurr) ) ).

tff(addAssignment_36200,axiom,
    ! [VarCurr: state_type] :
      ( v62145(VarCurr)
    <=> v62147(VarCurr) ) ).

tff(addAssignment_36199,axiom,
    ! [VarCurr: state_type] :
      ( v62147(VarCurr)
    <=> v62149(VarCurr) ) ).

tff(addAssignment_36198,axiom,
    ! [VarCurr: state_type] :
      ( v62149(VarCurr)
    <=> v62151(VarCurr) ) ).

tff(writeUnaryOperator_3166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v62151(VarCurr)
    <=> v62161(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5916,axiom,
    ! [VarCurr: state_type] :
      ( v62161(VarCurr)
    <=> ( v62153(VarCurr)
        | v62157(VarCurr) ) ) ).

tff(addAssignment_36197,axiom,
    ! [VarCurr: state_type] :
      ( v62157(VarCurr)
    <=> v62159(VarCurr) ) ).

tff(addAssignment_36196,axiom,
    ! [VarCurr: state_type] :
      ( v62159(VarCurr)
    <=> v59242(VarCurr,2) ) ).

tff(addAssignment_36195,axiom,
    ! [VarCurr: state_type] :
      ( v62153(VarCurr)
    <=> v62155(VarCurr) ) ).

tff(addAssignment_36194,axiom,
    ! [VarCurr: state_type] :
      ( v62155(VarCurr)
    <=> v59242(VarCurr,3) ) ).

tff(addAssignment_36193,axiom,
    ! [VarCurr: state_type] :
      ( v5881(VarCurr)
    <=> v5883(VarCurr) ) ).

tff(addAssignment_36192,axiom,
    ! [VarCurr: state_type] :
      ( v5883(VarCurr)
    <=> v5885(VarCurr) ) ).

tff(addAssignment_36191,axiom,
    ! [VarCurr: state_type] :
      ( v5885(VarCurr)
    <=> v5887(VarCurr) ) ).

tff(addAssignment_36190,axiom,
    ! [VarCurr: state_type] :
      ( v5887(VarCurr)
    <=> v5889(VarCurr) ) ).

tff(writeUnaryOperator_3165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5889(VarCurr)
    <=> v5891(VarCurr) ) ).

tff(addAssignment_36189,axiom,
    ! [VarCurr: state_type] :
      ( v5891(VarCurr)
    <=> v5893(VarCurr) ) ).

tff(addAssignment_36188,axiom,
    ! [VarCurr: state_type] :
      ( v5893(VarCurr)
    <=> v5895(VarCurr) ) ).

tff(addAssignment_36187,axiom,
    ! [VarCurr: state_type] :
      ( v5895(VarCurr)
    <=> v5897(VarCurr) ) ).

tff(addAssignment_36186,axiom,
    ! [VarCurr: state_type] :
      ( v5897(VarCurr)
    <=> v5899(VarCurr) ) ).

tff(writeUnaryOperator_3164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5899(VarCurr)
    <=> v62060(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5915,axiom,
    ! [VarCurr: state_type] :
      ( v62060(VarCurr)
    <=> ( v5901(VarCurr)
        & v60708(VarCurr) ) ) ).

tff(addAssignment_36185,axiom,
    ! [VarCurr: state_type] :
      ( v60708(VarCurr)
    <=> v60710(VarCurr) ) ).

tff(addAssignment_36184,axiom,
    ! [VarCurr: state_type] :
      ( v60710(VarCurr)
    <=> v60712(VarCurr) ) ).

tff(addAssignment_36183,axiom,
    ! [VarCurr: state_type] :
      ( v60712(VarCurr)
    <=> v60714(VarCurr) ) ).

tff(addAssignment_36182,axiom,
    ! [VarCurr: state_type] :
      ( v60714(VarCurr)
    <=> v60716(VarCurr) ) ).

tff(writeUnaryOperator_3163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v60716(VarCurr)
    <=> v62058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5914,axiom,
    ! [VarCurr: state_type] :
      ( v62058(VarCurr)
    <=> ( v60718(VarCurr)
        | v61388(VarCurr) ) ) ).

tff(addAssignment_36181,axiom,
    ! [VarCurr: state_type] :
      ( v61388(VarCurr)
    <=> v61390(VarCurr) ) ).

tff(addAssignment_36180,axiom,
    ! [VarCurr: state_type] :
      ( v61390(VarCurr)
    <=> v5915(VarCurr,0) ) ).

tff(addAssignment_36179,axiom,
    ! [VarCurr: state_type] :
      ( v5915(VarCurr,0)
    <=> v5917(VarCurr,0) ) ).

tff(addAssignment_36178,axiom,
    ! [VarCurr: state_type] :
      ( v5917(VarCurr,0)
    <=> v5919(VarCurr,0) ) ).

tff(addAssignment_36177,axiom,
    ! [VarCurr: state_type] :
      ( v5919(VarCurr,0)
    <=> v60034(VarCurr,0) ) ).

tff(addAssignment_36176,axiom,
    ! [VarCurr: state_type] :
      ( v59238(VarCurr,0)
    <=> v59240(VarCurr,0) ) ).

tff(addAssignment_36175,axiom,
    ! [VarCurr: state_type] :
      ( v59240(VarCurr,0)
    <=> v59242(VarCurr,0) ) ).

tff(addAssignment_36174,axiom,
    ! [VarCurr: state_type] :
      ( v59242(VarCurr,0)
    <=> v5977(VarCurr,12) ) ).

tff(addAssignment_36173,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,12)
    <=> v5979(VarCurr,12) ) ).

tff(addAssignment_36172,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,12)
    <=> v5981(VarCurr,12) ) ).

tff(addAssignment_36171,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,12)
    <=> v5983(VarCurr,12) ) ).

tff(addAssignment_36170,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,12)
    <=> v5985(VarCurr,12) ) ).

tff(addAssignment_36169,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,12)
    <=> v53672(VarCurr,12) ) ).

tff(addAssignment_36168,axiom,
    ! [VarCurr: state_type] :
      ( v53673(VarCurr,0)
    <=> v61392(VarCurr) ) ).

tff(addAssignment_36167,axiom,
    ! [VarCurr: state_type] :
      ( v61392(VarCurr)
    <=> v61394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5913,axiom,
    ! [VarCurr: state_type] :
      ( v61394(VarCurr)
    <=> ( v62056(VarCurr)
      <~> v61924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5912,axiom,
    ! [VarCurr: state_type] :
      ( v62056(VarCurr)
    <=> ( v61396(VarCurr)
      <~> v61660(VarCurr) ) ) ).

tff(addAssignment_36166,axiom,
    ! [VarCurr: state_type] :
      ( v61924(VarCurr)
    <=> v61926(VarCurr) ) ).

tff(addAssignment_36165,axiom,
    ! [VarCurr: state_type] :
      ( v61926(VarCurr)
    <=> v61928(VarCurr) ) ).

tff(addAssignment_36164,axiom,
    ! [VarCurr: state_type] :
      ( v61928(VarCurr)
    <=> v61930(VarCurr) ) ).

tff(addAssignment_36163,axiom,
    ! [VarCurr: state_type] :
      ( v61930(VarCurr)
    <=> v61932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5911,axiom,
    ! [VarCurr: state_type] :
      ( v61932(VarCurr)
    <=> ( v62054(VarCurr)
      <~> v62042(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5910,axiom,
    ! [VarCurr: state_type] :
      ( v62054(VarCurr)
    <=> ( v61934(VarCurr)
      <~> v61958(VarCurr) ) ) ).

tff(addAssignment_36162,axiom,
    ! [VarCurr: state_type] :
      ( v62042(VarCurr)
    <=> v62044(VarCurr) ) ).

tff(addAssignment_36161,axiom,
    ! [VarCurr: state_type] :
      ( v62044(VarCurr)
    <=> v59899(VarCurr,0) ) ).

tff(addAssignment_36160,axiom,
    ! [VarCurr: state_type] :
      ( v59899(VarCurr,0)
    <=> v59901(VarCurr,0) ) ).

tff(addAssignment_36159,axiom,
    ! [VarCurr: state_type] :
      ( v59901(VarCurr,0)
    <=> v53577(VarCurr,4) ) ).

tff(addAssignment_36158,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,4)
    <=> v53579(VarCurr,4) ) ).

tff(addAssignment_36157,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,4)
    <=> v62046(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v62047(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v62046(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_762,axiom,
    ! [VarNext: state_type] :
      ( v62047(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v62046(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v62047(VarNext)
      <=> v62048(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v62048(VarNext)
      <=> ( v62050(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v62050(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_36156,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,4)
    <=> v53603(VarCurr,4) ) ).

tff(addAssignment_36155,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,4)
    <=> v53632(VarCurr,4) ) ).

tff(addAssignment_36154,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,12)
    <=> v59912(VarCurr,0) ) ).

tff(addAssignment_36153,axiom,
    ! [VarCurr: state_type] :
      ( v59912(VarCurr,0)
    <=> v59914(VarCurr,0) ) ).

tff(addAssignment_36152,axiom,
    ! [VarCurr: state_type] :
      ( v59914(VarCurr,0)
    <=> v59931(VarCurr,0) ) ).

tff(addAssignment_36151,axiom,
    ! [VarCurr: state_type] :
      ( v59924(VarCurr,0)
    <=> v59926(VarCurr,0) ) ).

tff(addAssignment_36150,axiom,
    ! [VarCurr: state_type] :
      ( v59926(VarCurr,0)
    <=> v53312(VarCurr,12) ) ).

tff(addAssignment_36149,axiom,
    ! [VarCurr: state_type] :
      ( v59916(VarCurr,0)
    <=> v59918(VarCurr,0) ) ).

tff(addAssignment_36148,axiom,
    ! [VarCurr: state_type] :
      ( v59918(VarCurr,0)
    <=> v53312(VarCurr,8) ) ).

tff(addAssignment_36147,axiom,
    ! [VarCurr: state_type] :
      ( v61958(VarCurr)
    <=> v61960(VarCurr) ) ).

tff(addAssignment_36146,axiom,
    ! [VarCurr: state_type] :
      ( v61960(VarCurr)
    <=> v61962(VarCurr) ) ).

tff(addAssignment_36145,axiom,
    ! [VarCurr: state_type] :
      ( v61962(VarCurr)
    <=> v61964(VarCurr) ) ).

tff(addAssignment_36144,axiom,
    ! [VarCurr: state_type] :
      ( v61964(VarCurr)
    <=> v61966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5907,axiom,
    ! [VarCurr: state_type] :
      ( v61966(VarCurr)
    <=> ( v62040(VarCurr)
      <~> v62016(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5906,axiom,
    ! [VarCurr: state_type] :
      ( v62040(VarCurr)
    <=> ( v61968(VarCurr)
      <~> v61992(VarCurr) ) ) ).

tff(addAssignment_36143,axiom,
    ! [VarCurr: state_type] :
      ( v62016(VarCurr)
    <=> v62018(VarCurr) ) ).

tff(addAssignment_36142,axiom,
    ! [VarCurr: state_type] :
      ( v62018(VarCurr)
    <=> v62020(VarCurr) ) ).

tff(addAssignment_36141,axiom,
    ! [VarCurr: state_type] :
      ( v62020(VarCurr)
    <=> v62022(VarCurr) ) ).

tff(addAssignment_36140,axiom,
    ! [VarCurr: state_type] :
      ( v62022(VarCurr)
    <=> v62024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5905,axiom,
    ! [VarCurr: state_type] :
      ( v62024(VarCurr)
    <=> ( v62038(VarCurr)
      <~> v62034(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5904,axiom,
    ! [VarCurr: state_type] :
      ( v62038(VarCurr)
    <=> ( v62026(VarCurr)
      <~> v62030(VarCurr) ) ) ).

tff(addAssignment_36139,axiom,
    ! [VarCurr: state_type] :
      ( v62034(VarCurr)
    <=> v62036(VarCurr) ) ).

tff(addAssignment_36138,axiom,
    ! [VarCurr: state_type] :
      ( v62036(VarCurr)
    <=> v6017(VarCurr,118) ) ).

tff(addAssignment_36137,axiom,
    ! [VarCurr: state_type] :
      ( v62030(VarCurr)
    <=> v62032(VarCurr) ) ).

tff(addAssignment_36136,axiom,
    ! [VarCurr: state_type] :
      ( v62032(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_36135,axiom,
    ! [VarCurr: state_type] :
      ( v62026(VarCurr)
    <=> v62028(VarCurr) ) ).

tff(addAssignment_36134,axiom,
    ! [VarCurr: state_type] :
      ( v62028(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_36133,axiom,
    ! [VarCurr: state_type] :
      ( v61992(VarCurr)
    <=> v61994(VarCurr) ) ).

tff(addAssignment_36132,axiom,
    ! [VarCurr: state_type] :
      ( v61994(VarCurr)
    <=> v61996(VarCurr) ) ).

tff(addAssignment_36131,axiom,
    ! [VarCurr: state_type] :
      ( v61996(VarCurr)
    <=> v61998(VarCurr) ) ).

tff(addAssignment_36130,axiom,
    ! [VarCurr: state_type] :
      ( v61998(VarCurr)
    <=> v62000(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5903,axiom,
    ! [VarCurr: state_type] :
      ( v62000(VarCurr)
    <=> ( v62014(VarCurr)
      <~> v62010(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5902,axiom,
    ! [VarCurr: state_type] :
      ( v62014(VarCurr)
    <=> ( v62002(VarCurr)
      <~> v62006(VarCurr) ) ) ).

tff(addAssignment_36129,axiom,
    ! [VarCurr: state_type] :
      ( v62010(VarCurr)
    <=> v62012(VarCurr) ) ).

tff(addAssignment_36128,axiom,
    ! [VarCurr: state_type] :
      ( v62012(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_36127,axiom,
    ! [VarCurr: state_type] :
      ( v62006(VarCurr)
    <=> v62008(VarCurr) ) ).

tff(addAssignment_36126,axiom,
    ! [VarCurr: state_type] :
      ( v62008(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_36125,axiom,
    ! [VarCurr: state_type] :
      ( v62002(VarCurr)
    <=> v62004(VarCurr) ) ).

tff(addAssignment_36124,axiom,
    ! [VarCurr: state_type] :
      ( v62004(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_36123,axiom,
    ! [VarCurr: state_type] :
      ( v61968(VarCurr)
    <=> v61970(VarCurr) ) ).

tff(addAssignment_36122,axiom,
    ! [VarCurr: state_type] :
      ( v61970(VarCurr)
    <=> v61972(VarCurr) ) ).

tff(addAssignment_36121,axiom,
    ! [VarCurr: state_type] :
      ( v61972(VarCurr)
    <=> v61974(VarCurr) ) ).

tff(addAssignment_36120,axiom,
    ! [VarCurr: state_type] :
      ( v61974(VarCurr)
    <=> v61976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5901,axiom,
    ! [VarCurr: state_type] :
      ( v61976(VarCurr)
    <=> ( v61990(VarCurr)
      <~> v61986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5900,axiom,
    ! [VarCurr: state_type] :
      ( v61990(VarCurr)
    <=> ( v61978(VarCurr)
      <~> v61982(VarCurr) ) ) ).

tff(addAssignment_36119,axiom,
    ! [VarCurr: state_type] :
      ( v61986(VarCurr)
    <=> v61988(VarCurr) ) ).

tff(addAssignment_36118,axiom,
    ! [VarCurr: state_type] :
      ( v61988(VarCurr)
    <=> v6017(VarCurr,110) ) ).

tff(addAssignment_36117,axiom,
    ! [VarCurr: state_type] :
      ( v61982(VarCurr)
    <=> v61984(VarCurr) ) ).

tff(addAssignment_36116,axiom,
    ! [VarCurr: state_type] :
      ( v61984(VarCurr)
    <=> v6017(VarCurr,109) ) ).

tff(addAssignment_36115,axiom,
    ! [VarCurr: state_type] :
      ( v61978(VarCurr)
    <=> v61980(VarCurr) ) ).

tff(addAssignment_36114,axiom,
    ! [VarCurr: state_type] :
      ( v61980(VarCurr)
    <=> v6017(VarCurr,108) ) ).

tff(addAssignment_36113,axiom,
    ! [VarCurr: state_type] :
      ( v61934(VarCurr)
    <=> v61936(VarCurr) ) ).

tff(addAssignment_36112,axiom,
    ! [VarCurr: state_type] :
      ( v61936(VarCurr)
    <=> v61938(VarCurr) ) ).

tff(addAssignment_36111,axiom,
    ! [VarCurr: state_type] :
      ( v61938(VarCurr)
    <=> v61940(VarCurr) ) ).

tff(addAssignment_36110,axiom,
    ! [VarCurr: state_type] :
      ( v61940(VarCurr)
    <=> v61942(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5899,axiom,
    ! [VarCurr: state_type] :
      ( v61942(VarCurr)
    <=> ( v61956(VarCurr)
      <~> v61952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5898,axiom,
    ! [VarCurr: state_type] :
      ( v61956(VarCurr)
    <=> ( v61944(VarCurr)
      <~> v61948(VarCurr) ) ) ).

tff(addAssignment_36109,axiom,
    ! [VarCurr: state_type] :
      ( v61952(VarCurr)
    <=> v61954(VarCurr) ) ).

tff(addAssignment_36108,axiom,
    ! [VarCurr: state_type] :
      ( v61954(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_36107,axiom,
    ! [VarCurr: state_type] :
      ( v61948(VarCurr)
    <=> v61950(VarCurr) ) ).

tff(addAssignment_36106,axiom,
    ! [VarCurr: state_type] :
      ( v61950(VarCurr)
    <=> v6017(VarCurr,124) ) ).

tff(addAssignment_36105,axiom,
    ! [VarCurr: state_type] :
      ( v61944(VarCurr)
    <=> v61946(VarCurr) ) ).

tff(addAssignment_36104,axiom,
    ! [VarCurr: state_type] :
      ( v61946(VarCurr)
    <=> v6017(VarCurr,119) ) ).

tff(addAssignment_36103,axiom,
    ! [VarCurr: state_type] :
      ( v61660(VarCurr)
    <=> v61662(VarCurr) ) ).

tff(addAssignment_36102,axiom,
    ! [VarCurr: state_type] :
      ( v61662(VarCurr)
    <=> v61664(VarCurr) ) ).

tff(addAssignment_36101,axiom,
    ! [VarCurr: state_type] :
      ( v61664(VarCurr)
    <=> v61666(VarCurr) ) ).

tff(addAssignment_36100,axiom,
    ! [VarCurr: state_type] :
      ( v61666(VarCurr)
    <=> v61668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5897,axiom,
    ! [VarCurr: state_type] :
      ( v61668(VarCurr)
    <=> ( v61922(VarCurr)
      <~> v61838(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5896,axiom,
    ! [VarCurr: state_type] :
      ( v61922(VarCurr)
    <=> ( v61670(VarCurr)
      <~> v61754(VarCurr) ) ) ).

tff(addAssignment_36099,axiom,
    ! [VarCurr: state_type] :
      ( v61838(VarCurr)
    <=> v61840(VarCurr) ) ).

tff(addAssignment_36098,axiom,
    ! [VarCurr: state_type] :
      ( v61840(VarCurr)
    <=> v61842(VarCurr) ) ).

tff(addAssignment_36097,axiom,
    ! [VarCurr: state_type] :
      ( v61842(VarCurr)
    <=> v61844(VarCurr) ) ).

tff(addAssignment_36096,axiom,
    ! [VarCurr: state_type] :
      ( v61844(VarCurr)
    <=> v61846(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5895,axiom,
    ! [VarCurr: state_type] :
      ( v61846(VarCurr)
    <=> ( v61920(VarCurr)
      <~> v61896(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5894,axiom,
    ! [VarCurr: state_type] :
      ( v61920(VarCurr)
    <=> ( v61848(VarCurr)
      <~> v61872(VarCurr) ) ) ).

tff(addAssignment_36095,axiom,
    ! [VarCurr: state_type] :
      ( v61896(VarCurr)
    <=> v61898(VarCurr) ) ).

tff(addAssignment_36094,axiom,
    ! [VarCurr: state_type] :
      ( v61898(VarCurr)
    <=> v61900(VarCurr) ) ).

tff(addAssignment_36093,axiom,
    ! [VarCurr: state_type] :
      ( v61900(VarCurr)
    <=> v61902(VarCurr) ) ).

tff(addAssignment_36092,axiom,
    ! [VarCurr: state_type] :
      ( v61902(VarCurr)
    <=> v61904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5893,axiom,
    ! [VarCurr: state_type] :
      ( v61904(VarCurr)
    <=> ( v61918(VarCurr)
      <~> v61914(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5892,axiom,
    ! [VarCurr: state_type] :
      ( v61918(VarCurr)
    <=> ( v61906(VarCurr)
      <~> v61910(VarCurr) ) ) ).

tff(addAssignment_36091,axiom,
    ! [VarCurr: state_type] :
      ( v61914(VarCurr)
    <=> v61916(VarCurr) ) ).

tff(addAssignment_36090,axiom,
    ! [VarCurr: state_type] :
      ( v61916(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_36089,axiom,
    ! [VarCurr: state_type] :
      ( v61910(VarCurr)
    <=> v61912(VarCurr) ) ).

tff(addAssignment_36088,axiom,
    ! [VarCurr: state_type] :
      ( v61912(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_36087,axiom,
    ! [VarCurr: state_type] :
      ( v61906(VarCurr)
    <=> v61908(VarCurr) ) ).

tff(addAssignment_36086,axiom,
    ! [VarCurr: state_type] :
      ( v61908(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_36085,axiom,
    ! [VarCurr: state_type] :
      ( v61872(VarCurr)
    <=> v61874(VarCurr) ) ).

tff(addAssignment_36084,axiom,
    ! [VarCurr: state_type] :
      ( v61874(VarCurr)
    <=> v61876(VarCurr) ) ).

tff(addAssignment_36083,axiom,
    ! [VarCurr: state_type] :
      ( v61876(VarCurr)
    <=> v61878(VarCurr) ) ).

tff(addAssignment_36082,axiom,
    ! [VarCurr: state_type] :
      ( v61878(VarCurr)
    <=> v61880(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5891,axiom,
    ! [VarCurr: state_type] :
      ( v61880(VarCurr)
    <=> ( v61894(VarCurr)
      <~> v61890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5890,axiom,
    ! [VarCurr: state_type] :
      ( v61894(VarCurr)
    <=> ( v61882(VarCurr)
      <~> v61886(VarCurr) ) ) ).

tff(addAssignment_36081,axiom,
    ! [VarCurr: state_type] :
      ( v61890(VarCurr)
    <=> v61892(VarCurr) ) ).

tff(addAssignment_36080,axiom,
    ! [VarCurr: state_type] :
      ( v61892(VarCurr)
    <=> v6017(VarCurr,101) ) ).

tff(addAssignment_36079,axiom,
    ! [VarCurr: state_type] :
      ( v61886(VarCurr)
    <=> v61888(VarCurr) ) ).

tff(addAssignment_36078,axiom,
    ! [VarCurr: state_type] :
      ( v61888(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_36077,axiom,
    ! [VarCurr: state_type] :
      ( v61882(VarCurr)
    <=> v61884(VarCurr) ) ).

tff(addAssignment_36076,axiom,
    ! [VarCurr: state_type] :
      ( v61884(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_36075,axiom,
    ! [VarCurr: state_type] :
      ( v61848(VarCurr)
    <=> v61850(VarCurr) ) ).

tff(addAssignment_36074,axiom,
    ! [VarCurr: state_type] :
      ( v61850(VarCurr)
    <=> v61852(VarCurr) ) ).

tff(addAssignment_36073,axiom,
    ! [VarCurr: state_type] :
      ( v61852(VarCurr)
    <=> v61854(VarCurr) ) ).

tff(addAssignment_36072,axiom,
    ! [VarCurr: state_type] :
      ( v61854(VarCurr)
    <=> v61856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5889,axiom,
    ! [VarCurr: state_type] :
      ( v61856(VarCurr)
    <=> ( v61870(VarCurr)
      <~> v61866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5888,axiom,
    ! [VarCurr: state_type] :
      ( v61870(VarCurr)
    <=> ( v61858(VarCurr)
      <~> v61862(VarCurr) ) ) ).

tff(addAssignment_36071,axiom,
    ! [VarCurr: state_type] :
      ( v61866(VarCurr)
    <=> v61868(VarCurr) ) ).

tff(addAssignment_36070,axiom,
    ! [VarCurr: state_type] :
      ( v61868(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_36069,axiom,
    ! [VarCurr: state_type] :
      ( v61862(VarCurr)
    <=> v61864(VarCurr) ) ).

tff(addAssignment_36068,axiom,
    ! [VarCurr: state_type] :
      ( v61864(VarCurr)
    <=> v6017(VarCurr,93) ) ).

tff(addAssignment_36067,axiom,
    ! [VarCurr: state_type] :
      ( v61858(VarCurr)
    <=> v61860(VarCurr) ) ).

tff(addAssignment_36066,axiom,
    ! [VarCurr: state_type] :
      ( v61860(VarCurr)
    <=> v6017(VarCurr,92) ) ).

tff(addAssignment_36065,axiom,
    ! [VarCurr: state_type] :
      ( v61754(VarCurr)
    <=> v61756(VarCurr) ) ).

tff(addAssignment_36064,axiom,
    ! [VarCurr: state_type] :
      ( v61756(VarCurr)
    <=> v61758(VarCurr) ) ).

tff(addAssignment_36063,axiom,
    ! [VarCurr: state_type] :
      ( v61758(VarCurr)
    <=> v61760(VarCurr) ) ).

tff(addAssignment_36062,axiom,
    ! [VarCurr: state_type] :
      ( v61760(VarCurr)
    <=> v61762(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5887,axiom,
    ! [VarCurr: state_type] :
      ( v61762(VarCurr)
    <=> ( v61836(VarCurr)
      <~> v61812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5886,axiom,
    ! [VarCurr: state_type] :
      ( v61836(VarCurr)
    <=> ( v61764(VarCurr)
      <~> v61788(VarCurr) ) ) ).

tff(addAssignment_36061,axiom,
    ! [VarCurr: state_type] :
      ( v61812(VarCurr)
    <=> v61814(VarCurr) ) ).

tff(addAssignment_36060,axiom,
    ! [VarCurr: state_type] :
      ( v61814(VarCurr)
    <=> v61816(VarCurr) ) ).

tff(addAssignment_36059,axiom,
    ! [VarCurr: state_type] :
      ( v61816(VarCurr)
    <=> v61818(VarCurr) ) ).

tff(addAssignment_36058,axiom,
    ! [VarCurr: state_type] :
      ( v61818(VarCurr)
    <=> v61820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5885,axiom,
    ! [VarCurr: state_type] :
      ( v61820(VarCurr)
    <=> ( v61834(VarCurr)
      <~> v61830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5884,axiom,
    ! [VarCurr: state_type] :
      ( v61834(VarCurr)
    <=> ( v61822(VarCurr)
      <~> v61826(VarCurr) ) ) ).

tff(addAssignment_36057,axiom,
    ! [VarCurr: state_type] :
      ( v61830(VarCurr)
    <=> v61832(VarCurr) ) ).

tff(addAssignment_36056,axiom,
    ! [VarCurr: state_type] :
      ( v61832(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_36055,axiom,
    ! [VarCurr: state_type] :
      ( v61826(VarCurr)
    <=> v61828(VarCurr) ) ).

tff(addAssignment_36054,axiom,
    ! [VarCurr: state_type] :
      ( v61828(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_36053,axiom,
    ! [VarCurr: state_type] :
      ( v61822(VarCurr)
    <=> v61824(VarCurr) ) ).

tff(addAssignment_36052,axiom,
    ! [VarCurr: state_type] :
      ( v61824(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_36051,axiom,
    ! [VarCurr: state_type] :
      ( v61788(VarCurr)
    <=> v61790(VarCurr) ) ).

tff(addAssignment_36050,axiom,
    ! [VarCurr: state_type] :
      ( v61790(VarCurr)
    <=> v61792(VarCurr) ) ).

tff(addAssignment_36049,axiom,
    ! [VarCurr: state_type] :
      ( v61792(VarCurr)
    <=> v61794(VarCurr) ) ).

tff(addAssignment_36048,axiom,
    ! [VarCurr: state_type] :
      ( v61794(VarCurr)
    <=> v61796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5883,axiom,
    ! [VarCurr: state_type] :
      ( v61796(VarCurr)
    <=> ( v61810(VarCurr)
      <~> v61806(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5882,axiom,
    ! [VarCurr: state_type] :
      ( v61810(VarCurr)
    <=> ( v61798(VarCurr)
      <~> v61802(VarCurr) ) ) ).

tff(addAssignment_36047,axiom,
    ! [VarCurr: state_type] :
      ( v61806(VarCurr)
    <=> v61808(VarCurr) ) ).

tff(addAssignment_36046,axiom,
    ! [VarCurr: state_type] :
      ( v61808(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_36045,axiom,
    ! [VarCurr: state_type] :
      ( v61802(VarCurr)
    <=> v61804(VarCurr) ) ).

tff(addAssignment_36044,axiom,
    ! [VarCurr: state_type] :
      ( v61804(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_36043,axiom,
    ! [VarCurr: state_type] :
      ( v61798(VarCurr)
    <=> v61800(VarCurr) ) ).

tff(addAssignment_36042,axiom,
    ! [VarCurr: state_type] :
      ( v61800(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_36041,axiom,
    ! [VarCurr: state_type] :
      ( v61764(VarCurr)
    <=> v61766(VarCurr) ) ).

tff(addAssignment_36040,axiom,
    ! [VarCurr: state_type] :
      ( v61766(VarCurr)
    <=> v61768(VarCurr) ) ).

tff(addAssignment_36039,axiom,
    ! [VarCurr: state_type] :
      ( v61768(VarCurr)
    <=> v61770(VarCurr) ) ).

tff(addAssignment_36038,axiom,
    ! [VarCurr: state_type] :
      ( v61770(VarCurr)
    <=> v61772(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5881,axiom,
    ! [VarCurr: state_type] :
      ( v61772(VarCurr)
    <=> ( v61786(VarCurr)
      <~> v61782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5880,axiom,
    ! [VarCurr: state_type] :
      ( v61786(VarCurr)
    <=> ( v61774(VarCurr)
      <~> v61778(VarCurr) ) ) ).

tff(addAssignment_36037,axiom,
    ! [VarCurr: state_type] :
      ( v61782(VarCurr)
    <=> v61784(VarCurr) ) ).

tff(addAssignment_36036,axiom,
    ! [VarCurr: state_type] :
      ( v61784(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_36035,axiom,
    ! [VarCurr: state_type] :
      ( v61778(VarCurr)
    <=> v61780(VarCurr) ) ).

tff(addAssignment_36034,axiom,
    ! [VarCurr: state_type] :
      ( v61780(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_36033,axiom,
    ! [VarCurr: state_type] :
      ( v61774(VarCurr)
    <=> v61776(VarCurr) ) ).

tff(addAssignment_36032,axiom,
    ! [VarCurr: state_type] :
      ( v61776(VarCurr)
    <=> v6017(VarCurr,74) ) ).

tff(addAssignment_36031,axiom,
    ! [VarCurr: state_type] :
      ( v61670(VarCurr)
    <=> v61672(VarCurr) ) ).

tff(addAssignment_36030,axiom,
    ! [VarCurr: state_type] :
      ( v61672(VarCurr)
    <=> v61674(VarCurr) ) ).

tff(addAssignment_36029,axiom,
    ! [VarCurr: state_type] :
      ( v61674(VarCurr)
    <=> v61676(VarCurr) ) ).

tff(addAssignment_36028,axiom,
    ! [VarCurr: state_type] :
      ( v61676(VarCurr)
    <=> v61678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5879,axiom,
    ! [VarCurr: state_type] :
      ( v61678(VarCurr)
    <=> ( v61752(VarCurr)
      <~> v61728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5878,axiom,
    ! [VarCurr: state_type] :
      ( v61752(VarCurr)
    <=> ( v61680(VarCurr)
      <~> v61704(VarCurr) ) ) ).

tff(addAssignment_36027,axiom,
    ! [VarCurr: state_type] :
      ( v61728(VarCurr)
    <=> v61730(VarCurr) ) ).

tff(addAssignment_36026,axiom,
    ! [VarCurr: state_type] :
      ( v61730(VarCurr)
    <=> v61732(VarCurr) ) ).

tff(addAssignment_36025,axiom,
    ! [VarCurr: state_type] :
      ( v61732(VarCurr)
    <=> v61734(VarCurr) ) ).

tff(addAssignment_36024,axiom,
    ! [VarCurr: state_type] :
      ( v61734(VarCurr)
    <=> v61736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5877,axiom,
    ! [VarCurr: state_type] :
      ( v61736(VarCurr)
    <=> ( v61750(VarCurr)
      <~> v61746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5876,axiom,
    ! [VarCurr: state_type] :
      ( v61750(VarCurr)
    <=> ( v61738(VarCurr)
      <~> v61742(VarCurr) ) ) ).

tff(addAssignment_36023,axiom,
    ! [VarCurr: state_type] :
      ( v61746(VarCurr)
    <=> v61748(VarCurr) ) ).

tff(addAssignment_36022,axiom,
    ! [VarCurr: state_type] :
      ( v61748(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_36021,axiom,
    ! [VarCurr: state_type] :
      ( v61742(VarCurr)
    <=> v61744(VarCurr) ) ).

tff(addAssignment_36020,axiom,
    ! [VarCurr: state_type] :
      ( v61744(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_36019,axiom,
    ! [VarCurr: state_type] :
      ( v61738(VarCurr)
    <=> v61740(VarCurr) ) ).

tff(addAssignment_36018,axiom,
    ! [VarCurr: state_type] :
      ( v61740(VarCurr)
    <=> v6017(VarCurr,67) ) ).

tff(addAssignment_36017,axiom,
    ! [VarCurr: state_type] :
      ( v61704(VarCurr)
    <=> v61706(VarCurr) ) ).

tff(addAssignment_36016,axiom,
    ! [VarCurr: state_type] :
      ( v61706(VarCurr)
    <=> v61708(VarCurr) ) ).

tff(addAssignment_36015,axiom,
    ! [VarCurr: state_type] :
      ( v61708(VarCurr)
    <=> v61710(VarCurr) ) ).

tff(addAssignment_36014,axiom,
    ! [VarCurr: state_type] :
      ( v61710(VarCurr)
    <=> v61712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5875,axiom,
    ! [VarCurr: state_type] :
      ( v61712(VarCurr)
    <=> ( v61726(VarCurr)
      <~> v61722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5874,axiom,
    ! [VarCurr: state_type] :
      ( v61726(VarCurr)
    <=> ( v61714(VarCurr)
      <~> v61718(VarCurr) ) ) ).

tff(addAssignment_36013,axiom,
    ! [VarCurr: state_type] :
      ( v61722(VarCurr)
    <=> v61724(VarCurr) ) ).

tff(addAssignment_36012,axiom,
    ! [VarCurr: state_type] :
      ( v61724(VarCurr)
    <=> v6017(VarCurr,60) ) ).

tff(addAssignment_36011,axiom,
    ! [VarCurr: state_type] :
      ( v61718(VarCurr)
    <=> v61720(VarCurr) ) ).

tff(addAssignment_36010,axiom,
    ! [VarCurr: state_type] :
      ( v61720(VarCurr)
    <=> v6017(VarCurr,59) ) ).

tff(addAssignment_36009,axiom,
    ! [VarCurr: state_type] :
      ( v61714(VarCurr)
    <=> v61716(VarCurr) ) ).

tff(addAssignment_36008,axiom,
    ! [VarCurr: state_type] :
      ( v61716(VarCurr)
    <=> v6017(VarCurr,58) ) ).

tff(addAssignment_36007,axiom,
    ! [VarCurr: state_type] :
      ( v61680(VarCurr)
    <=> v61682(VarCurr) ) ).

tff(addAssignment_36006,axiom,
    ! [VarCurr: state_type] :
      ( v61682(VarCurr)
    <=> v61684(VarCurr) ) ).

tff(addAssignment_36005,axiom,
    ! [VarCurr: state_type] :
      ( v61684(VarCurr)
    <=> v61686(VarCurr) ) ).

tff(addAssignment_36004,axiom,
    ! [VarCurr: state_type] :
      ( v61686(VarCurr)
    <=> v61688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5873,axiom,
    ! [VarCurr: state_type] :
      ( v61688(VarCurr)
    <=> ( v61702(VarCurr)
      <~> v61698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5872,axiom,
    ! [VarCurr: state_type] :
      ( v61702(VarCurr)
    <=> ( v61690(VarCurr)
      <~> v61694(VarCurr) ) ) ).

tff(addAssignment_36003,axiom,
    ! [VarCurr: state_type] :
      ( v61698(VarCurr)
    <=> v61700(VarCurr) ) ).

tff(addAssignment_36002,axiom,
    ! [VarCurr: state_type] :
      ( v61700(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_36001,axiom,
    ! [VarCurr: state_type] :
      ( v61694(VarCurr)
    <=> v61696(VarCurr) ) ).

tff(addAssignment_36000,axiom,
    ! [VarCurr: state_type] :
      ( v61696(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_35999,axiom,
    ! [VarCurr: state_type] :
      ( v61690(VarCurr)
    <=> v61692(VarCurr) ) ).

tff(addAssignment_35998,axiom,
    ! [VarCurr: state_type] :
      ( v61692(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_35997,axiom,
    ! [VarCurr: state_type] :
      ( v61396(VarCurr)
    <=> v61398(VarCurr) ) ).

tff(addAssignment_35996,axiom,
    ! [VarCurr: state_type] :
      ( v61398(VarCurr)
    <=> v61400(VarCurr) ) ).

tff(addAssignment_35995,axiom,
    ! [VarCurr: state_type] :
      ( v61400(VarCurr)
    <=> v61402(VarCurr) ) ).

tff(addAssignment_35994,axiom,
    ! [VarCurr: state_type] :
      ( v61402(VarCurr)
    <=> v61404(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5871,axiom,
    ! [VarCurr: state_type] :
      ( v61404(VarCurr)
    <=> ( v61658(VarCurr)
      <~> v61574(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5870,axiom,
    ! [VarCurr: state_type] :
      ( v61658(VarCurr)
    <=> ( v61406(VarCurr)
      <~> v61490(VarCurr) ) ) ).

tff(addAssignment_35993,axiom,
    ! [VarCurr: state_type] :
      ( v61574(VarCurr)
    <=> v61576(VarCurr) ) ).

tff(addAssignment_35992,axiom,
    ! [VarCurr: state_type] :
      ( v61576(VarCurr)
    <=> v61578(VarCurr) ) ).

tff(addAssignment_35991,axiom,
    ! [VarCurr: state_type] :
      ( v61578(VarCurr)
    <=> v61580(VarCurr) ) ).

tff(addAssignment_35990,axiom,
    ! [VarCurr: state_type] :
      ( v61580(VarCurr)
    <=> v61582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5869,axiom,
    ! [VarCurr: state_type] :
      ( v61582(VarCurr)
    <=> ( v61656(VarCurr)
      <~> v61632(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5868,axiom,
    ! [VarCurr: state_type] :
      ( v61656(VarCurr)
    <=> ( v61584(VarCurr)
      <~> v61608(VarCurr) ) ) ).

tff(addAssignment_35989,axiom,
    ! [VarCurr: state_type] :
      ( v61632(VarCurr)
    <=> v61634(VarCurr) ) ).

tff(addAssignment_35988,axiom,
    ! [VarCurr: state_type] :
      ( v61634(VarCurr)
    <=> v61636(VarCurr) ) ).

tff(addAssignment_35987,axiom,
    ! [VarCurr: state_type] :
      ( v61636(VarCurr)
    <=> v61638(VarCurr) ) ).

tff(addAssignment_35986,axiom,
    ! [VarCurr: state_type] :
      ( v61638(VarCurr)
    <=> v61640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5867,axiom,
    ! [VarCurr: state_type] :
      ( v61640(VarCurr)
    <=> ( v61654(VarCurr)
      <~> v61650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5866,axiom,
    ! [VarCurr: state_type] :
      ( v61654(VarCurr)
    <=> ( v61642(VarCurr)
      <~> v61646(VarCurr) ) ) ).

tff(addAssignment_35985,axiom,
    ! [VarCurr: state_type] :
      ( v61650(VarCurr)
    <=> v61652(VarCurr) ) ).

tff(addAssignment_35984,axiom,
    ! [VarCurr: state_type] :
      ( v61652(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_35983,axiom,
    ! [VarCurr: state_type] :
      ( v61646(VarCurr)
    <=> v61648(VarCurr) ) ).

tff(addAssignment_35982,axiom,
    ! [VarCurr: state_type] :
      ( v61648(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_35981,axiom,
    ! [VarCurr: state_type] :
      ( v61642(VarCurr)
    <=> v61644(VarCurr) ) ).

tff(addAssignment_35980,axiom,
    ! [VarCurr: state_type] :
      ( v61644(VarCurr)
    <=> v6017(VarCurr,50) ) ).

tff(addAssignment_35979,axiom,
    ! [VarCurr: state_type] :
      ( v61608(VarCurr)
    <=> v61610(VarCurr) ) ).

tff(addAssignment_35978,axiom,
    ! [VarCurr: state_type] :
      ( v61610(VarCurr)
    <=> v61612(VarCurr) ) ).

tff(addAssignment_35977,axiom,
    ! [VarCurr: state_type] :
      ( v61612(VarCurr)
    <=> v61614(VarCurr) ) ).

tff(addAssignment_35976,axiom,
    ! [VarCurr: state_type] :
      ( v61614(VarCurr)
    <=> v61616(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5865,axiom,
    ! [VarCurr: state_type] :
      ( v61616(VarCurr)
    <=> ( v61630(VarCurr)
      <~> v61626(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5864,axiom,
    ! [VarCurr: state_type] :
      ( v61630(VarCurr)
    <=> ( v61618(VarCurr)
      <~> v61622(VarCurr) ) ) ).

tff(addAssignment_35975,axiom,
    ! [VarCurr: state_type] :
      ( v61626(VarCurr)
    <=> v61628(VarCurr) ) ).

tff(addAssignment_35974,axiom,
    ! [VarCurr: state_type] :
      ( v61628(VarCurr)
    <=> v6017(VarCurr,49) ) ).

tff(addAssignment_35973,axiom,
    ! [VarCurr: state_type] :
      ( v61622(VarCurr)
    <=> v61624(VarCurr) ) ).

tff(addAssignment_35972,axiom,
    ! [VarCurr: state_type] :
      ( v61624(VarCurr)
    <=> v6017(VarCurr,48) ) ).

tff(addAssignment_35971,axiom,
    ! [VarCurr: state_type] :
      ( v61618(VarCurr)
    <=> v61620(VarCurr) ) ).

tff(addAssignment_35970,axiom,
    ! [VarCurr: state_type] :
      ( v61620(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_35969,axiom,
    ! [VarCurr: state_type] :
      ( v61584(VarCurr)
    <=> v61586(VarCurr) ) ).

tff(addAssignment_35968,axiom,
    ! [VarCurr: state_type] :
      ( v61586(VarCurr)
    <=> v61588(VarCurr) ) ).

tff(addAssignment_35967,axiom,
    ! [VarCurr: state_type] :
      ( v61588(VarCurr)
    <=> v61590(VarCurr) ) ).

tff(addAssignment_35966,axiom,
    ! [VarCurr: state_type] :
      ( v61590(VarCurr)
    <=> v61592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5863,axiom,
    ! [VarCurr: state_type] :
      ( v61592(VarCurr)
    <=> ( v61606(VarCurr)
      <~> v61602(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5862,axiom,
    ! [VarCurr: state_type] :
      ( v61606(VarCurr)
    <=> ( v61594(VarCurr)
      <~> v61598(VarCurr) ) ) ).

tff(addAssignment_35965,axiom,
    ! [VarCurr: state_type] :
      ( v61602(VarCurr)
    <=> v61604(VarCurr) ) ).

tff(addAssignment_35964,axiom,
    ! [VarCurr: state_type] :
      ( v61604(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_35963,axiom,
    ! [VarCurr: state_type] :
      ( v61598(VarCurr)
    <=> v61600(VarCurr) ) ).

tff(addAssignment_35962,axiom,
    ! [VarCurr: state_type] :
      ( v61600(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_35961,axiom,
    ! [VarCurr: state_type] :
      ( v61594(VarCurr)
    <=> v61596(VarCurr) ) ).

tff(addAssignment_35960,axiom,
    ! [VarCurr: state_type] :
      ( v61596(VarCurr)
    <=> v6017(VarCurr,41) ) ).

tff(addAssignment_35959,axiom,
    ! [VarCurr: state_type] :
      ( v61490(VarCurr)
    <=> v61492(VarCurr) ) ).

tff(addAssignment_35958,axiom,
    ! [VarCurr: state_type] :
      ( v61492(VarCurr)
    <=> v61494(VarCurr) ) ).

tff(addAssignment_35957,axiom,
    ! [VarCurr: state_type] :
      ( v61494(VarCurr)
    <=> v61496(VarCurr) ) ).

tff(addAssignment_35956,axiom,
    ! [VarCurr: state_type] :
      ( v61496(VarCurr)
    <=> v61498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5861,axiom,
    ! [VarCurr: state_type] :
      ( v61498(VarCurr)
    <=> ( v61572(VarCurr)
      <~> v61548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5860,axiom,
    ! [VarCurr: state_type] :
      ( v61572(VarCurr)
    <=> ( v61500(VarCurr)
      <~> v61524(VarCurr) ) ) ).

tff(addAssignment_35955,axiom,
    ! [VarCurr: state_type] :
      ( v61548(VarCurr)
    <=> v61550(VarCurr) ) ).

tff(addAssignment_35954,axiom,
    ! [VarCurr: state_type] :
      ( v61550(VarCurr)
    <=> v61552(VarCurr) ) ).

tff(addAssignment_35953,axiom,
    ! [VarCurr: state_type] :
      ( v61552(VarCurr)
    <=> v61554(VarCurr) ) ).

tff(addAssignment_35952,axiom,
    ! [VarCurr: state_type] :
      ( v61554(VarCurr)
    <=> v61556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5859,axiom,
    ! [VarCurr: state_type] :
      ( v61556(VarCurr)
    <=> ( v61570(VarCurr)
      <~> v61566(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5858,axiom,
    ! [VarCurr: state_type] :
      ( v61570(VarCurr)
    <=> ( v61558(VarCurr)
      <~> v61562(VarCurr) ) ) ).

tff(addAssignment_35951,axiom,
    ! [VarCurr: state_type] :
      ( v61566(VarCurr)
    <=> v61568(VarCurr) ) ).

tff(addAssignment_35950,axiom,
    ! [VarCurr: state_type] :
      ( v61568(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_35949,axiom,
    ! [VarCurr: state_type] :
      ( v61562(VarCurr)
    <=> v61564(VarCurr) ) ).

tff(addAssignment_35948,axiom,
    ! [VarCurr: state_type] :
      ( v61564(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_35947,axiom,
    ! [VarCurr: state_type] :
      ( v61558(VarCurr)
    <=> v61560(VarCurr) ) ).

tff(addAssignment_35946,axiom,
    ! [VarCurr: state_type] :
      ( v61560(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_35945,axiom,
    ! [VarCurr: state_type] :
      ( v61524(VarCurr)
    <=> v61526(VarCurr) ) ).

tff(addAssignment_35944,axiom,
    ! [VarCurr: state_type] :
      ( v61526(VarCurr)
    <=> v61528(VarCurr) ) ).

tff(addAssignment_35943,axiom,
    ! [VarCurr: state_type] :
      ( v61528(VarCurr)
    <=> v61530(VarCurr) ) ).

tff(addAssignment_35942,axiom,
    ! [VarCurr: state_type] :
      ( v61530(VarCurr)
    <=> v61532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5857,axiom,
    ! [VarCurr: state_type] :
      ( v61532(VarCurr)
    <=> ( v61546(VarCurr)
      <~> v61542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5856,axiom,
    ! [VarCurr: state_type] :
      ( v61546(VarCurr)
    <=> ( v61534(VarCurr)
      <~> v61538(VarCurr) ) ) ).

tff(addAssignment_35941,axiom,
    ! [VarCurr: state_type] :
      ( v61542(VarCurr)
    <=> v61544(VarCurr) ) ).

tff(addAssignment_35940,axiom,
    ! [VarCurr: state_type] :
      ( v61544(VarCurr)
    <=> v6017(VarCurr,33) ) ).

tff(addAssignment_35939,axiom,
    ! [VarCurr: state_type] :
      ( v61538(VarCurr)
    <=> v61540(VarCurr) ) ).

tff(addAssignment_35938,axiom,
    ! [VarCurr: state_type] :
      ( v61540(VarCurr)
    <=> v6017(VarCurr,32) ) ).

tff(addAssignment_35937,axiom,
    ! [VarCurr: state_type] :
      ( v61534(VarCurr)
    <=> v61536(VarCurr) ) ).

tff(addAssignment_35936,axiom,
    ! [VarCurr: state_type] :
      ( v61536(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_35935,axiom,
    ! [VarCurr: state_type] :
      ( v61500(VarCurr)
    <=> v61502(VarCurr) ) ).

tff(addAssignment_35934,axiom,
    ! [VarCurr: state_type] :
      ( v61502(VarCurr)
    <=> v61504(VarCurr) ) ).

tff(addAssignment_35933,axiom,
    ! [VarCurr: state_type] :
      ( v61504(VarCurr)
    <=> v61506(VarCurr) ) ).

tff(addAssignment_35932,axiom,
    ! [VarCurr: state_type] :
      ( v61506(VarCurr)
    <=> v61508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5855,axiom,
    ! [VarCurr: state_type] :
      ( v61508(VarCurr)
    <=> ( v61522(VarCurr)
      <~> v61518(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5854,axiom,
    ! [VarCurr: state_type] :
      ( v61522(VarCurr)
    <=> ( v61510(VarCurr)
      <~> v61514(VarCurr) ) ) ).

tff(addAssignment_35931,axiom,
    ! [VarCurr: state_type] :
      ( v61518(VarCurr)
    <=> v61520(VarCurr) ) ).

tff(addAssignment_35930,axiom,
    ! [VarCurr: state_type] :
      ( v61520(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_35929,axiom,
    ! [VarCurr: state_type] :
      ( v61514(VarCurr)
    <=> v61516(VarCurr) ) ).

tff(addAssignment_35928,axiom,
    ! [VarCurr: state_type] :
      ( v61516(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_35927,axiom,
    ! [VarCurr: state_type] :
      ( v61510(VarCurr)
    <=> v61512(VarCurr) ) ).

tff(addAssignment_35926,axiom,
    ! [VarCurr: state_type] :
      ( v61512(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_35925,axiom,
    ! [VarCurr: state_type] :
      ( v61406(VarCurr)
    <=> v61408(VarCurr) ) ).

tff(addAssignment_35924,axiom,
    ! [VarCurr: state_type] :
      ( v61408(VarCurr)
    <=> v61410(VarCurr) ) ).

tff(addAssignment_35923,axiom,
    ! [VarCurr: state_type] :
      ( v61410(VarCurr)
    <=> v61412(VarCurr) ) ).

tff(addAssignment_35922,axiom,
    ! [VarCurr: state_type] :
      ( v61412(VarCurr)
    <=> v61414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5853,axiom,
    ! [VarCurr: state_type] :
      ( v61414(VarCurr)
    <=> ( v61488(VarCurr)
      <~> v61464(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5852,axiom,
    ! [VarCurr: state_type] :
      ( v61488(VarCurr)
    <=> ( v61416(VarCurr)
      <~> v61440(VarCurr) ) ) ).

tff(addAssignment_35921,axiom,
    ! [VarCurr: state_type] :
      ( v61464(VarCurr)
    <=> v61466(VarCurr) ) ).

tff(addAssignment_35920,axiom,
    ! [VarCurr: state_type] :
      ( v61466(VarCurr)
    <=> v61468(VarCurr) ) ).

tff(addAssignment_35919,axiom,
    ! [VarCurr: state_type] :
      ( v61468(VarCurr)
    <=> v61470(VarCurr) ) ).

tff(addAssignment_35918,axiom,
    ! [VarCurr: state_type] :
      ( v61470(VarCurr)
    <=> v61472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5851,axiom,
    ! [VarCurr: state_type] :
      ( v61472(VarCurr)
    <=> ( v61486(VarCurr)
      <~> v61482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5850,axiom,
    ! [VarCurr: state_type] :
      ( v61486(VarCurr)
    <=> ( v61474(VarCurr)
      <~> v61478(VarCurr) ) ) ).

tff(addAssignment_35917,axiom,
    ! [VarCurr: state_type] :
      ( v61482(VarCurr)
    <=> v61484(VarCurr) ) ).

tff(addAssignment_35916,axiom,
    ! [VarCurr: state_type] :
      ( v61484(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_35915,axiom,
    ! [VarCurr: state_type] :
      ( v61478(VarCurr)
    <=> v61480(VarCurr) ) ).

tff(addAssignment_35914,axiom,
    ! [VarCurr: state_type] :
      ( v61480(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_35913,axiom,
    ! [VarCurr: state_type] :
      ( v61474(VarCurr)
    <=> v61476(VarCurr) ) ).

tff(addAssignment_35912,axiom,
    ! [VarCurr: state_type] :
      ( v61476(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_35911,axiom,
    ! [VarCurr: state_type] :
      ( v61440(VarCurr)
    <=> v61442(VarCurr) ) ).

tff(addAssignment_35910,axiom,
    ! [VarCurr: state_type] :
      ( v61442(VarCurr)
    <=> v61444(VarCurr) ) ).

tff(addAssignment_35909,axiom,
    ! [VarCurr: state_type] :
      ( v61444(VarCurr)
    <=> v61446(VarCurr) ) ).

tff(addAssignment_35908,axiom,
    ! [VarCurr: state_type] :
      ( v61446(VarCurr)
    <=> v61448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5849,axiom,
    ! [VarCurr: state_type] :
      ( v61448(VarCurr)
    <=> ( v61462(VarCurr)
      <~> v61458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5848,axiom,
    ! [VarCurr: state_type] :
      ( v61462(VarCurr)
    <=> ( v61450(VarCurr)
      <~> v61454(VarCurr) ) ) ).

tff(addAssignment_35907,axiom,
    ! [VarCurr: state_type] :
      ( v61458(VarCurr)
    <=> v61460(VarCurr) ) ).

tff(addAssignment_35906,axiom,
    ! [VarCurr: state_type] :
      ( v61460(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_35905,axiom,
    ! [VarCurr: state_type] :
      ( v61454(VarCurr)
    <=> v61456(VarCurr) ) ).

tff(addAssignment_35904,axiom,
    ! [VarCurr: state_type] :
      ( v61456(VarCurr)
    <=> v6017(VarCurr,14) ) ).

tff(addAssignment_35903,axiom,
    ! [VarCurr: state_type] :
      ( v61450(VarCurr)
    <=> v61452(VarCurr) ) ).

tff(addAssignment_35902,axiom,
    ! [VarCurr: state_type] :
      ( v61452(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_35901,axiom,
    ! [VarCurr: state_type] :
      ( v61416(VarCurr)
    <=> v61418(VarCurr) ) ).

tff(addAssignment_35900,axiom,
    ! [VarCurr: state_type] :
      ( v61418(VarCurr)
    <=> v61420(VarCurr) ) ).

tff(addAssignment_35899,axiom,
    ! [VarCurr: state_type] :
      ( v61420(VarCurr)
    <=> v61422(VarCurr) ) ).

tff(addAssignment_35898,axiom,
    ! [VarCurr: state_type] :
      ( v61422(VarCurr)
    <=> v61424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5847,axiom,
    ! [VarCurr: state_type] :
      ( v61424(VarCurr)
    <=> ( v61438(VarCurr)
      <~> v61434(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5846,axiom,
    ! [VarCurr: state_type] :
      ( v61438(VarCurr)
    <=> ( v61426(VarCurr)
      <~> v61430(VarCurr) ) ) ).

tff(addAssignment_35897,axiom,
    ! [VarCurr: state_type] :
      ( v61434(VarCurr)
    <=> v61436(VarCurr) ) ).

tff(addAssignment_35896,axiom,
    ! [VarCurr: state_type] :
      ( v61436(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_35895,axiom,
    ! [VarCurr: state_type] :
      ( v61430(VarCurr)
    <=> v61432(VarCurr) ) ).

tff(addAssignment_35894,axiom,
    ! [VarCurr: state_type] :
      ( v61432(VarCurr)
    <=> v6017(VarCurr,7) ) ).

tff(addAssignment_35893,axiom,
    ! [VarCurr: state_type] :
      ( v61426(VarCurr)
    <=> v61428(VarCurr) ) ).

tff(addAssignment_35892,axiom,
    ! [VarCurr: state_type] :
      ( v61428(VarCurr)
    <=> v6017(VarCurr,0) ) ).

tff(addAssignment_35891,axiom,
    ! [VarCurr: state_type] :
      ( v5921(VarCurr,0)
    <=> v5923(VarCurr,0) ) ).

tff(addAssignment_35890,axiom,
    ! [VarCurr: state_type] :
      ( v5923(VarCurr,0)
    <=> v59235(VarCurr,0) ) ).

tff(addAssignment_35889,axiom,
    ! [VarCurr: state_type] :
      ( v60718(VarCurr)
    <=> v60720(VarCurr) ) ).

tff(addAssignment_35888,axiom,
    ! [VarCurr: state_type] :
      ( v60720(VarCurr)
    <=> v5915(VarCurr,1) ) ).

tff(addAssignment_35887,axiom,
    ! [VarCurr: state_type] :
      ( v5915(VarCurr,1)
    <=> v5917(VarCurr,1) ) ).

tff(addAssignment_35886,axiom,
    ! [VarCurr: state_type] :
      ( v5917(VarCurr,1)
    <=> v5919(VarCurr,1) ) ).

tff(addAssignment_35885,axiom,
    ! [VarCurr: state_type] :
      ( v5919(VarCurr,1)
    <=> v60034(VarCurr,1) ) ).

tff(addAssignment_35884,axiom,
    ! [VarCurr: state_type] :
      ( v59238(VarCurr,1)
    <=> v59240(VarCurr,1) ) ).

tff(addAssignment_35883,axiom,
    ! [VarCurr: state_type] :
      ( v59240(VarCurr,1)
    <=> v59242(VarCurr,1) ) ).

tff(addAssignment_35882,axiom,
    ! [VarCurr: state_type] :
      ( v59242(VarCurr,1)
    <=> v5977(VarCurr,13) ) ).

tff(addAssignment_35881,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,13)
    <=> v5979(VarCurr,13) ) ).

tff(addAssignment_35880,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,13)
    <=> v5981(VarCurr,13) ) ).

tff(addAssignment_35879,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,13)
    <=> v5983(VarCurr,13) ) ).

tff(addAssignment_35878,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,13)
    <=> v5985(VarCurr,13) ) ).

tff(addAssignment_35877,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,13)
    <=> v53672(VarCurr,13) ) ).

tff(addAssignment_35876,axiom,
    ! [VarCurr: state_type] :
      ( v53673(VarCurr,1)
    <=> v60722(VarCurr) ) ).

tff(addAssignment_35875,axiom,
    ! [VarCurr: state_type] :
      ( v60722(VarCurr)
    <=> v60724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5845,axiom,
    ! [VarCurr: state_type] :
      ( v60724(VarCurr)
    <=> ( v61386(VarCurr)
      <~> v61254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5844,axiom,
    ! [VarCurr: state_type] :
      ( v61386(VarCurr)
    <=> ( v60726(VarCurr)
      <~> v60990(VarCurr) ) ) ).

tff(addAssignment_35874,axiom,
    ! [VarCurr: state_type] :
      ( v61254(VarCurr)
    <=> v61256(VarCurr) ) ).

tff(addAssignment_35873,axiom,
    ! [VarCurr: state_type] :
      ( v61256(VarCurr)
    <=> v61258(VarCurr) ) ).

tff(addAssignment_35872,axiom,
    ! [VarCurr: state_type] :
      ( v61258(VarCurr)
    <=> v61260(VarCurr) ) ).

tff(addAssignment_35871,axiom,
    ! [VarCurr: state_type] :
      ( v61260(VarCurr)
    <=> v61262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5843,axiom,
    ! [VarCurr: state_type] :
      ( v61262(VarCurr)
    <=> ( v61384(VarCurr)
      <~> v61372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5842,axiom,
    ! [VarCurr: state_type] :
      ( v61384(VarCurr)
    <=> ( v61264(VarCurr)
      <~> v61288(VarCurr) ) ) ).

tff(addAssignment_35870,axiom,
    ! [VarCurr: state_type] :
      ( v61372(VarCurr)
    <=> v61374(VarCurr) ) ).

tff(addAssignment_35869,axiom,
    ! [VarCurr: state_type] :
      ( v61374(VarCurr)
    <=> v59899(VarCurr,1) ) ).

tff(addAssignment_35868,axiom,
    ! [VarCurr: state_type] :
      ( v59899(VarCurr,1)
    <=> v59901(VarCurr,1) ) ).

tff(addAssignment_35867,axiom,
    ! [VarCurr: state_type] :
      ( v59901(VarCurr,1)
    <=> v53577(VarCurr,5) ) ).

tff(addAssignment_35866,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,5)
    <=> v53579(VarCurr,5) ) ).

tff(addAssignment_35865,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,5)
    <=> v61376(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v61377(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v61376(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_761,axiom,
    ! [VarNext: state_type] :
      ( v61377(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v61376(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5841,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v61377(VarNext)
      <=> v61378(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v61378(VarNext)
      <=> ( v61380(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v61380(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_35864,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,5)
    <=> v53603(VarCurr,5) ) ).

tff(addAssignment_35863,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,5)
    <=> v53632(VarCurr,5) ) ).

tff(addAssignment_35862,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,13)
    <=> v59912(VarCurr,1) ) ).

tff(addAssignment_35861,axiom,
    ! [VarCurr: state_type] :
      ( v59912(VarCurr,1)
    <=> v59914(VarCurr,1) ) ).

tff(addAssignment_35860,axiom,
    ! [VarCurr: state_type] :
      ( v59914(VarCurr,1)
    <=> v59931(VarCurr,1) ) ).

tff(addAssignment_35859,axiom,
    ! [VarCurr: state_type] :
      ( v59924(VarCurr,1)
    <=> v59926(VarCurr,1) ) ).

tff(addAssignment_35858,axiom,
    ! [VarCurr: state_type] :
      ( v59926(VarCurr,1)
    <=> v53312(VarCurr,13) ) ).

tff(addAssignment_35857,axiom,
    ! [VarCurr: state_type] :
      ( v59916(VarCurr,1)
    <=> v59918(VarCurr,1) ) ).

tff(addAssignment_35856,axiom,
    ! [VarCurr: state_type] :
      ( v59918(VarCurr,1)
    <=> v53312(VarCurr,9) ) ).

tff(addAssignment_35855,axiom,
    ! [VarCurr: state_type] :
      ( v61288(VarCurr)
    <=> v61290(VarCurr) ) ).

tff(addAssignment_35854,axiom,
    ! [VarCurr: state_type] :
      ( v61290(VarCurr)
    <=> v61292(VarCurr) ) ).

tff(addAssignment_35853,axiom,
    ! [VarCurr: state_type] :
      ( v61292(VarCurr)
    <=> v61294(VarCurr) ) ).

tff(addAssignment_35852,axiom,
    ! [VarCurr: state_type] :
      ( v61294(VarCurr)
    <=> v61296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5839,axiom,
    ! [VarCurr: state_type] :
      ( v61296(VarCurr)
    <=> ( v61370(VarCurr)
      <~> v61346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5838,axiom,
    ! [VarCurr: state_type] :
      ( v61370(VarCurr)
    <=> ( v61298(VarCurr)
      <~> v61322(VarCurr) ) ) ).

tff(addAssignment_35851,axiom,
    ! [VarCurr: state_type] :
      ( v61346(VarCurr)
    <=> v61348(VarCurr) ) ).

tff(addAssignment_35850,axiom,
    ! [VarCurr: state_type] :
      ( v61348(VarCurr)
    <=> v61350(VarCurr) ) ).

tff(addAssignment_35849,axiom,
    ! [VarCurr: state_type] :
      ( v61350(VarCurr)
    <=> v61352(VarCurr) ) ).

tff(addAssignment_35848,axiom,
    ! [VarCurr: state_type] :
      ( v61352(VarCurr)
    <=> v61354(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5837,axiom,
    ! [VarCurr: state_type] :
      ( v61354(VarCurr)
    <=> ( v61368(VarCurr)
      <~> v61364(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5836,axiom,
    ! [VarCurr: state_type] :
      ( v61368(VarCurr)
    <=> ( v61356(VarCurr)
      <~> v61360(VarCurr) ) ) ).

tff(addAssignment_35847,axiom,
    ! [VarCurr: state_type] :
      ( v61364(VarCurr)
    <=> v61366(VarCurr) ) ).

tff(addAssignment_35846,axiom,
    ! [VarCurr: state_type] :
      ( v61366(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_35845,axiom,
    ! [VarCurr: state_type] :
      ( v61360(VarCurr)
    <=> v61362(VarCurr) ) ).

tff(addAssignment_35844,axiom,
    ! [VarCurr: state_type] :
      ( v61362(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_35843,axiom,
    ! [VarCurr: state_type] :
      ( v61356(VarCurr)
    <=> v61358(VarCurr) ) ).

tff(addAssignment_35842,axiom,
    ! [VarCurr: state_type] :
      ( v61358(VarCurr)
    <=> v6017(VarCurr,111) ) ).

tff(addAssignment_35841,axiom,
    ! [VarCurr: state_type] :
      ( v61322(VarCurr)
    <=> v61324(VarCurr) ) ).

tff(addAssignment_35840,axiom,
    ! [VarCurr: state_type] :
      ( v61324(VarCurr)
    <=> v61326(VarCurr) ) ).

tff(addAssignment_35839,axiom,
    ! [VarCurr: state_type] :
      ( v61326(VarCurr)
    <=> v61328(VarCurr) ) ).

tff(addAssignment_35838,axiom,
    ! [VarCurr: state_type] :
      ( v61328(VarCurr)
    <=> v61330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5835,axiom,
    ! [VarCurr: state_type] :
      ( v61330(VarCurr)
    <=> ( v61344(VarCurr)
      <~> v61340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5834,axiom,
    ! [VarCurr: state_type] :
      ( v61344(VarCurr)
    <=> ( v61332(VarCurr)
      <~> v61336(VarCurr) ) ) ).

tff(addAssignment_35837,axiom,
    ! [VarCurr: state_type] :
      ( v61340(VarCurr)
    <=> v61342(VarCurr) ) ).

tff(addAssignment_35836,axiom,
    ! [VarCurr: state_type] :
      ( v61342(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_35835,axiom,
    ! [VarCurr: state_type] :
      ( v61336(VarCurr)
    <=> v61338(VarCurr) ) ).

tff(addAssignment_35834,axiom,
    ! [VarCurr: state_type] :
      ( v61338(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_35833,axiom,
    ! [VarCurr: state_type] :
      ( v61332(VarCurr)
    <=> v61334(VarCurr) ) ).

tff(addAssignment_35832,axiom,
    ! [VarCurr: state_type] :
      ( v61334(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_35831,axiom,
    ! [VarCurr: state_type] :
      ( v61298(VarCurr)
    <=> v61300(VarCurr) ) ).

tff(addAssignment_35830,axiom,
    ! [VarCurr: state_type] :
      ( v61300(VarCurr)
    <=> v61302(VarCurr) ) ).

tff(addAssignment_35829,axiom,
    ! [VarCurr: state_type] :
      ( v61302(VarCurr)
    <=> v61304(VarCurr) ) ).

tff(addAssignment_35828,axiom,
    ! [VarCurr: state_type] :
      ( v61304(VarCurr)
    <=> v61306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5833,axiom,
    ! [VarCurr: state_type] :
      ( v61306(VarCurr)
    <=> ( v61320(VarCurr)
      <~> v61316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5832,axiom,
    ! [VarCurr: state_type] :
      ( v61320(VarCurr)
    <=> ( v61308(VarCurr)
      <~> v61312(VarCurr) ) ) ).

tff(addAssignment_35827,axiom,
    ! [VarCurr: state_type] :
      ( v61316(VarCurr)
    <=> v61318(VarCurr) ) ).

tff(addAssignment_35826,axiom,
    ! [VarCurr: state_type] :
      ( v61318(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_35825,axiom,
    ! [VarCurr: state_type] :
      ( v61312(VarCurr)
    <=> v61314(VarCurr) ) ).

tff(addAssignment_35824,axiom,
    ! [VarCurr: state_type] :
      ( v61314(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_35823,axiom,
    ! [VarCurr: state_type] :
      ( v61308(VarCurr)
    <=> v61310(VarCurr) ) ).

tff(addAssignment_35822,axiom,
    ! [VarCurr: state_type] :
      ( v61310(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_35821,axiom,
    ! [VarCurr: state_type] :
      ( v61264(VarCurr)
    <=> v61266(VarCurr) ) ).

tff(addAssignment_35820,axiom,
    ! [VarCurr: state_type] :
      ( v61266(VarCurr)
    <=> v61268(VarCurr) ) ).

tff(addAssignment_35819,axiom,
    ! [VarCurr: state_type] :
      ( v61268(VarCurr)
    <=> v61270(VarCurr) ) ).

tff(addAssignment_35818,axiom,
    ! [VarCurr: state_type] :
      ( v61270(VarCurr)
    <=> v61272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5831,axiom,
    ! [VarCurr: state_type] :
      ( v61272(VarCurr)
    <=> ( v61286(VarCurr)
      <~> v61282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5830,axiom,
    ! [VarCurr: state_type] :
      ( v61286(VarCurr)
    <=> ( v61274(VarCurr)
      <~> v61278(VarCurr) ) ) ).

tff(addAssignment_35817,axiom,
    ! [VarCurr: state_type] :
      ( v61282(VarCurr)
    <=> v61284(VarCurr) ) ).

tff(addAssignment_35816,axiom,
    ! [VarCurr: state_type] :
      ( v61284(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_35815,axiom,
    ! [VarCurr: state_type] :
      ( v61278(VarCurr)
    <=> v61280(VarCurr) ) ).

tff(addAssignment_35814,axiom,
    ! [VarCurr: state_type] :
      ( v61280(VarCurr)
    <=> v6017(VarCurr,125) ) ).

tff(addAssignment_35813,axiom,
    ! [VarCurr: state_type] :
      ( v61274(VarCurr)
    <=> v61276(VarCurr) ) ).

tff(addAssignment_35812,axiom,
    ! [VarCurr: state_type] :
      ( v61276(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_35811,axiom,
    ! [VarCurr: state_type] :
      ( v60990(VarCurr)
    <=> v60992(VarCurr) ) ).

tff(addAssignment_35810,axiom,
    ! [VarCurr: state_type] :
      ( v60992(VarCurr)
    <=> v60994(VarCurr) ) ).

tff(addAssignment_35809,axiom,
    ! [VarCurr: state_type] :
      ( v60994(VarCurr)
    <=> v60996(VarCurr) ) ).

tff(addAssignment_35808,axiom,
    ! [VarCurr: state_type] :
      ( v60996(VarCurr)
    <=> v60998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5829,axiom,
    ! [VarCurr: state_type] :
      ( v60998(VarCurr)
    <=> ( v61252(VarCurr)
      <~> v61168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5828,axiom,
    ! [VarCurr: state_type] :
      ( v61252(VarCurr)
    <=> ( v61000(VarCurr)
      <~> v61084(VarCurr) ) ) ).

tff(addAssignment_35807,axiom,
    ! [VarCurr: state_type] :
      ( v61168(VarCurr)
    <=> v61170(VarCurr) ) ).

tff(addAssignment_35806,axiom,
    ! [VarCurr: state_type] :
      ( v61170(VarCurr)
    <=> v61172(VarCurr) ) ).

tff(addAssignment_35805,axiom,
    ! [VarCurr: state_type] :
      ( v61172(VarCurr)
    <=> v61174(VarCurr) ) ).

tff(addAssignment_35804,axiom,
    ! [VarCurr: state_type] :
      ( v61174(VarCurr)
    <=> v61176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5827,axiom,
    ! [VarCurr: state_type] :
      ( v61176(VarCurr)
    <=> ( v61250(VarCurr)
      <~> v61226(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5826,axiom,
    ! [VarCurr: state_type] :
      ( v61250(VarCurr)
    <=> ( v61178(VarCurr)
      <~> v61202(VarCurr) ) ) ).

tff(addAssignment_35803,axiom,
    ! [VarCurr: state_type] :
      ( v61226(VarCurr)
    <=> v61228(VarCurr) ) ).

tff(addAssignment_35802,axiom,
    ! [VarCurr: state_type] :
      ( v61228(VarCurr)
    <=> v61230(VarCurr) ) ).

tff(addAssignment_35801,axiom,
    ! [VarCurr: state_type] :
      ( v61230(VarCurr)
    <=> v61232(VarCurr) ) ).

tff(addAssignment_35800,axiom,
    ! [VarCurr: state_type] :
      ( v61232(VarCurr)
    <=> v61234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5825,axiom,
    ! [VarCurr: state_type] :
      ( v61234(VarCurr)
    <=> ( v61248(VarCurr)
      <~> v61244(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5824,axiom,
    ! [VarCurr: state_type] :
      ( v61248(VarCurr)
    <=> ( v61236(VarCurr)
      <~> v61240(VarCurr) ) ) ).

tff(addAssignment_35799,axiom,
    ! [VarCurr: state_type] :
      ( v61244(VarCurr)
    <=> v61246(VarCurr) ) ).

tff(addAssignment_35798,axiom,
    ! [VarCurr: state_type] :
      ( v61246(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_35797,axiom,
    ! [VarCurr: state_type] :
      ( v61240(VarCurr)
    <=> v61242(VarCurr) ) ).

tff(addAssignment_35796,axiom,
    ! [VarCurr: state_type] :
      ( v61242(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_35795,axiom,
    ! [VarCurr: state_type] :
      ( v61236(VarCurr)
    <=> v61238(VarCurr) ) ).

tff(addAssignment_35794,axiom,
    ! [VarCurr: state_type] :
      ( v61238(VarCurr)
    <=> v6017(VarCurr,96) ) ).

tff(addAssignment_35793,axiom,
    ! [VarCurr: state_type] :
      ( v61202(VarCurr)
    <=> v61204(VarCurr) ) ).

tff(addAssignment_35792,axiom,
    ! [VarCurr: state_type] :
      ( v61204(VarCurr)
    <=> v61206(VarCurr) ) ).

tff(addAssignment_35791,axiom,
    ! [VarCurr: state_type] :
      ( v61206(VarCurr)
    <=> v61208(VarCurr) ) ).

tff(addAssignment_35790,axiom,
    ! [VarCurr: state_type] :
      ( v61208(VarCurr)
    <=> v61210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5823,axiom,
    ! [VarCurr: state_type] :
      ( v61210(VarCurr)
    <=> ( v61224(VarCurr)
      <~> v61220(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5822,axiom,
    ! [VarCurr: state_type] :
      ( v61224(VarCurr)
    <=> ( v61212(VarCurr)
      <~> v61216(VarCurr) ) ) ).

tff(addAssignment_35789,axiom,
    ! [VarCurr: state_type] :
      ( v61220(VarCurr)
    <=> v61222(VarCurr) ) ).

tff(addAssignment_35788,axiom,
    ! [VarCurr: state_type] :
      ( v61222(VarCurr)
    <=> v6017(VarCurr,94) ) ).

tff(addAssignment_35787,axiom,
    ! [VarCurr: state_type] :
      ( v61216(VarCurr)
    <=> v61218(VarCurr) ) ).

tff(addAssignment_35786,axiom,
    ! [VarCurr: state_type] :
      ( v61218(VarCurr)
    <=> v6017(VarCurr,90) ) ).

tff(addAssignment_35785,axiom,
    ! [VarCurr: state_type] :
      ( v61212(VarCurr)
    <=> v61214(VarCurr) ) ).

tff(addAssignment_35784,axiom,
    ! [VarCurr: state_type] :
      ( v61214(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_35783,axiom,
    ! [VarCurr: state_type] :
      ( v61178(VarCurr)
    <=> v61180(VarCurr) ) ).

tff(addAssignment_35782,axiom,
    ! [VarCurr: state_type] :
      ( v61180(VarCurr)
    <=> v61182(VarCurr) ) ).

tff(addAssignment_35781,axiom,
    ! [VarCurr: state_type] :
      ( v61182(VarCurr)
    <=> v61184(VarCurr) ) ).

tff(addAssignment_35780,axiom,
    ! [VarCurr: state_type] :
      ( v61184(VarCurr)
    <=> v61186(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5821,axiom,
    ! [VarCurr: state_type] :
      ( v61186(VarCurr)
    <=> ( v61200(VarCurr)
      <~> v61196(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5820,axiom,
    ! [VarCurr: state_type] :
      ( v61200(VarCurr)
    <=> ( v61188(VarCurr)
      <~> v61192(VarCurr) ) ) ).

tff(addAssignment_35779,axiom,
    ! [VarCurr: state_type] :
      ( v61196(VarCurr)
    <=> v61198(VarCurr) ) ).

tff(addAssignment_35778,axiom,
    ! [VarCurr: state_type] :
      ( v61198(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_35777,axiom,
    ! [VarCurr: state_type] :
      ( v61192(VarCurr)
    <=> v61194(VarCurr) ) ).

tff(addAssignment_35776,axiom,
    ! [VarCurr: state_type] :
      ( v61194(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_35775,axiom,
    ! [VarCurr: state_type] :
      ( v61188(VarCurr)
    <=> v61190(VarCurr) ) ).

tff(addAssignment_35774,axiom,
    ! [VarCurr: state_type] :
      ( v61190(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_35773,axiom,
    ! [VarCurr: state_type] :
      ( v61084(VarCurr)
    <=> v61086(VarCurr) ) ).

tff(addAssignment_35772,axiom,
    ! [VarCurr: state_type] :
      ( v61086(VarCurr)
    <=> v61088(VarCurr) ) ).

tff(addAssignment_35771,axiom,
    ! [VarCurr: state_type] :
      ( v61088(VarCurr)
    <=> v61090(VarCurr) ) ).

tff(addAssignment_35770,axiom,
    ! [VarCurr: state_type] :
      ( v61090(VarCurr)
    <=> v61092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5819,axiom,
    ! [VarCurr: state_type] :
      ( v61092(VarCurr)
    <=> ( v61166(VarCurr)
      <~> v61142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5818,axiom,
    ! [VarCurr: state_type] :
      ( v61166(VarCurr)
    <=> ( v61094(VarCurr)
      <~> v61118(VarCurr) ) ) ).

tff(addAssignment_35769,axiom,
    ! [VarCurr: state_type] :
      ( v61142(VarCurr)
    <=> v61144(VarCurr) ) ).

tff(addAssignment_35768,axiom,
    ! [VarCurr: state_type] :
      ( v61144(VarCurr)
    <=> v61146(VarCurr) ) ).

tff(addAssignment_35767,axiom,
    ! [VarCurr: state_type] :
      ( v61146(VarCurr)
    <=> v61148(VarCurr) ) ).

tff(addAssignment_35766,axiom,
    ! [VarCurr: state_type] :
      ( v61148(VarCurr)
    <=> v61150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5817,axiom,
    ! [VarCurr: state_type] :
      ( v61150(VarCurr)
    <=> ( v61164(VarCurr)
      <~> v61160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5816,axiom,
    ! [VarCurr: state_type] :
      ( v61164(VarCurr)
    <=> ( v61152(VarCurr)
      <~> v61156(VarCurr) ) ) ).

tff(addAssignment_35765,axiom,
    ! [VarCurr: state_type] :
      ( v61160(VarCurr)
    <=> v61162(VarCurr) ) ).

tff(addAssignment_35764,axiom,
    ! [VarCurr: state_type] :
      ( v61162(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_35763,axiom,
    ! [VarCurr: state_type] :
      ( v61156(VarCurr)
    <=> v61158(VarCurr) ) ).

tff(addAssignment_35762,axiom,
    ! [VarCurr: state_type] :
      ( v61158(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_35761,axiom,
    ! [VarCurr: state_type] :
      ( v61152(VarCurr)
    <=> v61154(VarCurr) ) ).

tff(addAssignment_35760,axiom,
    ! [VarCurr: state_type] :
      ( v61154(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_35759,axiom,
    ! [VarCurr: state_type] :
      ( v61118(VarCurr)
    <=> v61120(VarCurr) ) ).

tff(addAssignment_35758,axiom,
    ! [VarCurr: state_type] :
      ( v61120(VarCurr)
    <=> v61122(VarCurr) ) ).

tff(addAssignment_35757,axiom,
    ! [VarCurr: state_type] :
      ( v61122(VarCurr)
    <=> v61124(VarCurr) ) ).

tff(addAssignment_35756,axiom,
    ! [VarCurr: state_type] :
      ( v61124(VarCurr)
    <=> v61126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5815,axiom,
    ! [VarCurr: state_type] :
      ( v61126(VarCurr)
    <=> ( v61140(VarCurr)
      <~> v61136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5814,axiom,
    ! [VarCurr: state_type] :
      ( v61140(VarCurr)
    <=> ( v61128(VarCurr)
      <~> v61132(VarCurr) ) ) ).

tff(addAssignment_35755,axiom,
    ! [VarCurr: state_type] :
      ( v61136(VarCurr)
    <=> v61138(VarCurr) ) ).

tff(addAssignment_35754,axiom,
    ! [VarCurr: state_type] :
      ( v61138(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_35753,axiom,
    ! [VarCurr: state_type] :
      ( v61132(VarCurr)
    <=> v61134(VarCurr) ) ).

tff(addAssignment_35752,axiom,
    ! [VarCurr: state_type] :
      ( v61134(VarCurr)
    <=> v6017(VarCurr,77) ) ).

tff(addAssignment_35751,axiom,
    ! [VarCurr: state_type] :
      ( v61128(VarCurr)
    <=> v61130(VarCurr) ) ).

tff(addAssignment_35750,axiom,
    ! [VarCurr: state_type] :
      ( v61130(VarCurr)
    <=> v6017(VarCurr,75) ) ).

tff(addAssignment_35749,axiom,
    ! [VarCurr: state_type] :
      ( v61094(VarCurr)
    <=> v61096(VarCurr) ) ).

tff(addAssignment_35748,axiom,
    ! [VarCurr: state_type] :
      ( v61096(VarCurr)
    <=> v61098(VarCurr) ) ).

tff(addAssignment_35747,axiom,
    ! [VarCurr: state_type] :
      ( v61098(VarCurr)
    <=> v61100(VarCurr) ) ).

tff(addAssignment_35746,axiom,
    ! [VarCurr: state_type] :
      ( v61100(VarCurr)
    <=> v61102(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5813,axiom,
    ! [VarCurr: state_type] :
      ( v61102(VarCurr)
    <=> ( v61116(VarCurr)
      <~> v61112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5812,axiom,
    ! [VarCurr: state_type] :
      ( v61116(VarCurr)
    <=> ( v61104(VarCurr)
      <~> v61108(VarCurr) ) ) ).

tff(addAssignment_35745,axiom,
    ! [VarCurr: state_type] :
      ( v61112(VarCurr)
    <=> v61114(VarCurr) ) ).

tff(addAssignment_35744,axiom,
    ! [VarCurr: state_type] :
      ( v61114(VarCurr)
    <=> v6017(VarCurr,74) ) ).

tff(addAssignment_35743,axiom,
    ! [VarCurr: state_type] :
      ( v61108(VarCurr)
    <=> v61110(VarCurr) ) ).

tff(addAssignment_35742,axiom,
    ! [VarCurr: state_type] :
      ( v61110(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_35741,axiom,
    ! [VarCurr: state_type] :
      ( v61104(VarCurr)
    <=> v61106(VarCurr) ) ).

tff(addAssignment_35740,axiom,
    ! [VarCurr: state_type] :
      ( v61106(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_35739,axiom,
    ! [VarCurr: state_type] :
      ( v61000(VarCurr)
    <=> v61002(VarCurr) ) ).

tff(addAssignment_35738,axiom,
    ! [VarCurr: state_type] :
      ( v61002(VarCurr)
    <=> v61004(VarCurr) ) ).

tff(addAssignment_35737,axiom,
    ! [VarCurr: state_type] :
      ( v61004(VarCurr)
    <=> v61006(VarCurr) ) ).

tff(addAssignment_35736,axiom,
    ! [VarCurr: state_type] :
      ( v61006(VarCurr)
    <=> v61008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5811,axiom,
    ! [VarCurr: state_type] :
      ( v61008(VarCurr)
    <=> ( v61082(VarCurr)
      <~> v61058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5810,axiom,
    ! [VarCurr: state_type] :
      ( v61082(VarCurr)
    <=> ( v61010(VarCurr)
      <~> v61034(VarCurr) ) ) ).

tff(addAssignment_35735,axiom,
    ! [VarCurr: state_type] :
      ( v61058(VarCurr)
    <=> v61060(VarCurr) ) ).

tff(addAssignment_35734,axiom,
    ! [VarCurr: state_type] :
      ( v61060(VarCurr)
    <=> v61062(VarCurr) ) ).

tff(addAssignment_35733,axiom,
    ! [VarCurr: state_type] :
      ( v61062(VarCurr)
    <=> v61064(VarCurr) ) ).

tff(addAssignment_35732,axiom,
    ! [VarCurr: state_type] :
      ( v61064(VarCurr)
    <=> v61066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5809,axiom,
    ! [VarCurr: state_type] :
      ( v61066(VarCurr)
    <=> ( v61080(VarCurr)
      <~> v61076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5808,axiom,
    ! [VarCurr: state_type] :
      ( v61080(VarCurr)
    <=> ( v61068(VarCurr)
      <~> v61072(VarCurr) ) ) ).

tff(addAssignment_35731,axiom,
    ! [VarCurr: state_type] :
      ( v61076(VarCurr)
    <=> v61078(VarCurr) ) ).

tff(addAssignment_35730,axiom,
    ! [VarCurr: state_type] :
      ( v61078(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_35729,axiom,
    ! [VarCurr: state_type] :
      ( v61072(VarCurr)
    <=> v61074(VarCurr) ) ).

tff(addAssignment_35728,axiom,
    ! [VarCurr: state_type] :
      ( v61074(VarCurr)
    <=> v6017(VarCurr,67) ) ).

tff(addAssignment_35727,axiom,
    ! [VarCurr: state_type] :
      ( v61068(VarCurr)
    <=> v61070(VarCurr) ) ).

tff(addAssignment_35726,axiom,
    ! [VarCurr: state_type] :
      ( v61070(VarCurr)
    <=> v6017(VarCurr,64) ) ).

tff(addAssignment_35725,axiom,
    ! [VarCurr: state_type] :
      ( v61034(VarCurr)
    <=> v61036(VarCurr) ) ).

tff(addAssignment_35724,axiom,
    ! [VarCurr: state_type] :
      ( v61036(VarCurr)
    <=> v61038(VarCurr) ) ).

tff(addAssignment_35723,axiom,
    ! [VarCurr: state_type] :
      ( v61038(VarCurr)
    <=> v61040(VarCurr) ) ).

tff(addAssignment_35722,axiom,
    ! [VarCurr: state_type] :
      ( v61040(VarCurr)
    <=> v61042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5807,axiom,
    ! [VarCurr: state_type] :
      ( v61042(VarCurr)
    <=> ( v61056(VarCurr)
      <~> v61052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5806,axiom,
    ! [VarCurr: state_type] :
      ( v61056(VarCurr)
    <=> ( v61044(VarCurr)
      <~> v61048(VarCurr) ) ) ).

tff(addAssignment_35721,axiom,
    ! [VarCurr: state_type] :
      ( v61052(VarCurr)
    <=> v61054(VarCurr) ) ).

tff(addAssignment_35720,axiom,
    ! [VarCurr: state_type] :
      ( v61054(VarCurr)
    <=> v6017(VarCurr,61) ) ).

tff(addAssignment_35719,axiom,
    ! [VarCurr: state_type] :
      ( v61048(VarCurr)
    <=> v61050(VarCurr) ) ).

tff(addAssignment_35718,axiom,
    ! [VarCurr: state_type] :
      ( v61050(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_35717,axiom,
    ! [VarCurr: state_type] :
      ( v61044(VarCurr)
    <=> v61046(VarCurr) ) ).

tff(addAssignment_35716,axiom,
    ! [VarCurr: state_type] :
      ( v61046(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_35715,axiom,
    ! [VarCurr: state_type] :
      ( v61010(VarCurr)
    <=> v61012(VarCurr) ) ).

tff(addAssignment_35714,axiom,
    ! [VarCurr: state_type] :
      ( v61012(VarCurr)
    <=> v61014(VarCurr) ) ).

tff(addAssignment_35713,axiom,
    ! [VarCurr: state_type] :
      ( v61014(VarCurr)
    <=> v61016(VarCurr) ) ).

tff(addAssignment_35712,axiom,
    ! [VarCurr: state_type] :
      ( v61016(VarCurr)
    <=> v61018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5805,axiom,
    ! [VarCurr: state_type] :
      ( v61018(VarCurr)
    <=> ( v61032(VarCurr)
      <~> v61028(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5804,axiom,
    ! [VarCurr: state_type] :
      ( v61032(VarCurr)
    <=> ( v61020(VarCurr)
      <~> v61024(VarCurr) ) ) ).

tff(addAssignment_35711,axiom,
    ! [VarCurr: state_type] :
      ( v61028(VarCurr)
    <=> v61030(VarCurr) ) ).

tff(addAssignment_35710,axiom,
    ! [VarCurr: state_type] :
      ( v61030(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_35709,axiom,
    ! [VarCurr: state_type] :
      ( v61024(VarCurr)
    <=> v61026(VarCurr) ) ).

tff(addAssignment_35708,axiom,
    ! [VarCurr: state_type] :
      ( v61026(VarCurr)
    <=> v6017(VarCurr,51) ) ).

tff(addAssignment_35707,axiom,
    ! [VarCurr: state_type] :
      ( v61020(VarCurr)
    <=> v61022(VarCurr) ) ).

tff(addAssignment_35706,axiom,
    ! [VarCurr: state_type] :
      ( v61022(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_35705,axiom,
    ! [VarCurr: state_type] :
      ( v60726(VarCurr)
    <=> v60728(VarCurr) ) ).

tff(addAssignment_35704,axiom,
    ! [VarCurr: state_type] :
      ( v60728(VarCurr)
    <=> v60730(VarCurr) ) ).

tff(addAssignment_35703,axiom,
    ! [VarCurr: state_type] :
      ( v60730(VarCurr)
    <=> v60732(VarCurr) ) ).

tff(addAssignment_35702,axiom,
    ! [VarCurr: state_type] :
      ( v60732(VarCurr)
    <=> v60734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5803,axiom,
    ! [VarCurr: state_type] :
      ( v60734(VarCurr)
    <=> ( v60988(VarCurr)
      <~> v60904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5802,axiom,
    ! [VarCurr: state_type] :
      ( v60988(VarCurr)
    <=> ( v60736(VarCurr)
      <~> v60820(VarCurr) ) ) ).

tff(addAssignment_35701,axiom,
    ! [VarCurr: state_type] :
      ( v60904(VarCurr)
    <=> v60906(VarCurr) ) ).

tff(addAssignment_35700,axiom,
    ! [VarCurr: state_type] :
      ( v60906(VarCurr)
    <=> v60908(VarCurr) ) ).

tff(addAssignment_35699,axiom,
    ! [VarCurr: state_type] :
      ( v60908(VarCurr)
    <=> v60910(VarCurr) ) ).

tff(addAssignment_35698,axiom,
    ! [VarCurr: state_type] :
      ( v60910(VarCurr)
    <=> v60912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5801,axiom,
    ! [VarCurr: state_type] :
      ( v60912(VarCurr)
    <=> ( v60986(VarCurr)
      <~> v60962(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5800,axiom,
    ! [VarCurr: state_type] :
      ( v60986(VarCurr)
    <=> ( v60914(VarCurr)
      <~> v60938(VarCurr) ) ) ).

tff(addAssignment_35697,axiom,
    ! [VarCurr: state_type] :
      ( v60962(VarCurr)
    <=> v60964(VarCurr) ) ).

tff(addAssignment_35696,axiom,
    ! [VarCurr: state_type] :
      ( v60964(VarCurr)
    <=> v60966(VarCurr) ) ).

tff(addAssignment_35695,axiom,
    ! [VarCurr: state_type] :
      ( v60966(VarCurr)
    <=> v60968(VarCurr) ) ).

tff(addAssignment_35694,axiom,
    ! [VarCurr: state_type] :
      ( v60968(VarCurr)
    <=> v60970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5799,axiom,
    ! [VarCurr: state_type] :
      ( v60970(VarCurr)
    <=> ( v60984(VarCurr)
      <~> v60980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5798,axiom,
    ! [VarCurr: state_type] :
      ( v60984(VarCurr)
    <=> ( v60972(VarCurr)
      <~> v60976(VarCurr) ) ) ).

tff(addAssignment_35693,axiom,
    ! [VarCurr: state_type] :
      ( v60980(VarCurr)
    <=> v60982(VarCurr) ) ).

tff(addAssignment_35692,axiom,
    ! [VarCurr: state_type] :
      ( v60982(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_35691,axiom,
    ! [VarCurr: state_type] :
      ( v60976(VarCurr)
    <=> v60978(VarCurr) ) ).

tff(addAssignment_35690,axiom,
    ! [VarCurr: state_type] :
      ( v60978(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_35689,axiom,
    ! [VarCurr: state_type] :
      ( v60972(VarCurr)
    <=> v60974(VarCurr) ) ).

tff(addAssignment_35688,axiom,
    ! [VarCurr: state_type] :
      ( v60974(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_35687,axiom,
    ! [VarCurr: state_type] :
      ( v60938(VarCurr)
    <=> v60940(VarCurr) ) ).

tff(addAssignment_35686,axiom,
    ! [VarCurr: state_type] :
      ( v60940(VarCurr)
    <=> v60942(VarCurr) ) ).

tff(addAssignment_35685,axiom,
    ! [VarCurr: state_type] :
      ( v60942(VarCurr)
    <=> v60944(VarCurr) ) ).

tff(addAssignment_35684,axiom,
    ! [VarCurr: state_type] :
      ( v60944(VarCurr)
    <=> v60946(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5797,axiom,
    ! [VarCurr: state_type] :
      ( v60946(VarCurr)
    <=> ( v60960(VarCurr)
      <~> v60956(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5796,axiom,
    ! [VarCurr: state_type] :
      ( v60960(VarCurr)
    <=> ( v60948(VarCurr)
      <~> v60952(VarCurr) ) ) ).

tff(addAssignment_35683,axiom,
    ! [VarCurr: state_type] :
      ( v60956(VarCurr)
    <=> v60958(VarCurr) ) ).

tff(addAssignment_35682,axiom,
    ! [VarCurr: state_type] :
      ( v60958(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_35681,axiom,
    ! [VarCurr: state_type] :
      ( v60952(VarCurr)
    <=> v60954(VarCurr) ) ).

tff(addAssignment_35680,axiom,
    ! [VarCurr: state_type] :
      ( v60954(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_35679,axiom,
    ! [VarCurr: state_type] :
      ( v60948(VarCurr)
    <=> v60950(VarCurr) ) ).

tff(addAssignment_35678,axiom,
    ! [VarCurr: state_type] :
      ( v60950(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_35677,axiom,
    ! [VarCurr: state_type] :
      ( v60914(VarCurr)
    <=> v60916(VarCurr) ) ).

tff(addAssignment_35676,axiom,
    ! [VarCurr: state_type] :
      ( v60916(VarCurr)
    <=> v60918(VarCurr) ) ).

tff(addAssignment_35675,axiom,
    ! [VarCurr: state_type] :
      ( v60918(VarCurr)
    <=> v60920(VarCurr) ) ).

tff(addAssignment_35674,axiom,
    ! [VarCurr: state_type] :
      ( v60920(VarCurr)
    <=> v60922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5795,axiom,
    ! [VarCurr: state_type] :
      ( v60922(VarCurr)
    <=> ( v60936(VarCurr)
      <~> v60932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5794,axiom,
    ! [VarCurr: state_type] :
      ( v60936(VarCurr)
    <=> ( v60924(VarCurr)
      <~> v60928(VarCurr) ) ) ).

tff(addAssignment_35673,axiom,
    ! [VarCurr: state_type] :
      ( v60932(VarCurr)
    <=> v60934(VarCurr) ) ).

tff(addAssignment_35672,axiom,
    ! [VarCurr: state_type] :
      ( v60934(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_35671,axiom,
    ! [VarCurr: state_type] :
      ( v60928(VarCurr)
    <=> v60930(VarCurr) ) ).

tff(addAssignment_35670,axiom,
    ! [VarCurr: state_type] :
      ( v60930(VarCurr)
    <=> v6017(VarCurr,36) ) ).

tff(addAssignment_35669,axiom,
    ! [VarCurr: state_type] :
      ( v60924(VarCurr)
    <=> v60926(VarCurr) ) ).

tff(addAssignment_35668,axiom,
    ! [VarCurr: state_type] :
      ( v60926(VarCurr)
    <=> v6017(VarCurr,34) ) ).

tff(addAssignment_35667,axiom,
    ! [VarCurr: state_type] :
      ( v60820(VarCurr)
    <=> v60822(VarCurr) ) ).

tff(addAssignment_35666,axiom,
    ! [VarCurr: state_type] :
      ( v60822(VarCurr)
    <=> v60824(VarCurr) ) ).

tff(addAssignment_35665,axiom,
    ! [VarCurr: state_type] :
      ( v60824(VarCurr)
    <=> v60826(VarCurr) ) ).

tff(addAssignment_35664,axiom,
    ! [VarCurr: state_type] :
      ( v60826(VarCurr)
    <=> v60828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5793,axiom,
    ! [VarCurr: state_type] :
      ( v60828(VarCurr)
    <=> ( v60902(VarCurr)
      <~> v60878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5792,axiom,
    ! [VarCurr: state_type] :
      ( v60902(VarCurr)
    <=> ( v60830(VarCurr)
      <~> v60854(VarCurr) ) ) ).

tff(addAssignment_35663,axiom,
    ! [VarCurr: state_type] :
      ( v60878(VarCurr)
    <=> v60880(VarCurr) ) ).

tff(addAssignment_35662,axiom,
    ! [VarCurr: state_type] :
      ( v60880(VarCurr)
    <=> v60882(VarCurr) ) ).

tff(addAssignment_35661,axiom,
    ! [VarCurr: state_type] :
      ( v60882(VarCurr)
    <=> v60884(VarCurr) ) ).

tff(addAssignment_35660,axiom,
    ! [VarCurr: state_type] :
      ( v60884(VarCurr)
    <=> v60886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5791,axiom,
    ! [VarCurr: state_type] :
      ( v60886(VarCurr)
    <=> ( v60900(VarCurr)
      <~> v60896(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5790,axiom,
    ! [VarCurr: state_type] :
      ( v60900(VarCurr)
    <=> ( v60888(VarCurr)
      <~> v60892(VarCurr) ) ) ).

tff(addAssignment_35659,axiom,
    ! [VarCurr: state_type] :
      ( v60896(VarCurr)
    <=> v60898(VarCurr) ) ).

tff(addAssignment_35658,axiom,
    ! [VarCurr: state_type] :
      ( v60898(VarCurr)
    <=> v6017(VarCurr,30) ) ).

tff(addAssignment_35657,axiom,
    ! [VarCurr: state_type] :
      ( v60892(VarCurr)
    <=> v60894(VarCurr) ) ).

tff(addAssignment_35656,axiom,
    ! [VarCurr: state_type] :
      ( v60894(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_35655,axiom,
    ! [VarCurr: state_type] :
      ( v60888(VarCurr)
    <=> v60890(VarCurr) ) ).

tff(addAssignment_35654,axiom,
    ! [VarCurr: state_type] :
      ( v60890(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_35653,axiom,
    ! [VarCurr: state_type] :
      ( v60854(VarCurr)
    <=> v60856(VarCurr) ) ).

tff(addAssignment_35652,axiom,
    ! [VarCurr: state_type] :
      ( v60856(VarCurr)
    <=> v60858(VarCurr) ) ).

tff(addAssignment_35651,axiom,
    ! [VarCurr: state_type] :
      ( v60858(VarCurr)
    <=> v60860(VarCurr) ) ).

tff(addAssignment_35650,axiom,
    ! [VarCurr: state_type] :
      ( v60860(VarCurr)
    <=> v60862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5789,axiom,
    ! [VarCurr: state_type] :
      ( v60862(VarCurr)
    <=> ( v60876(VarCurr)
      <~> v60872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5788,axiom,
    ! [VarCurr: state_type] :
      ( v60876(VarCurr)
    <=> ( v60864(VarCurr)
      <~> v60868(VarCurr) ) ) ).

tff(addAssignment_35649,axiom,
    ! [VarCurr: state_type] :
      ( v60872(VarCurr)
    <=> v60874(VarCurr) ) ).

tff(addAssignment_35648,axiom,
    ! [VarCurr: state_type] :
      ( v60874(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_35647,axiom,
    ! [VarCurr: state_type] :
      ( v60868(VarCurr)
    <=> v60870(VarCurr) ) ).

tff(addAssignment_35646,axiom,
    ! [VarCurr: state_type] :
      ( v60870(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_35645,axiom,
    ! [VarCurr: state_type] :
      ( v60864(VarCurr)
    <=> v60866(VarCurr) ) ).

tff(addAssignment_35644,axiom,
    ! [VarCurr: state_type] :
      ( v60866(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_35643,axiom,
    ! [VarCurr: state_type] :
      ( v60830(VarCurr)
    <=> v60832(VarCurr) ) ).

tff(addAssignment_35642,axiom,
    ! [VarCurr: state_type] :
      ( v60832(VarCurr)
    <=> v60834(VarCurr) ) ).

tff(addAssignment_35641,axiom,
    ! [VarCurr: state_type] :
      ( v60834(VarCurr)
    <=> v60836(VarCurr) ) ).

tff(addAssignment_35640,axiom,
    ! [VarCurr: state_type] :
      ( v60836(VarCurr)
    <=> v60838(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5787,axiom,
    ! [VarCurr: state_type] :
      ( v60838(VarCurr)
    <=> ( v60852(VarCurr)
      <~> v60848(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5786,axiom,
    ! [VarCurr: state_type] :
      ( v60852(VarCurr)
    <=> ( v60840(VarCurr)
      <~> v60844(VarCurr) ) ) ).

tff(addAssignment_35639,axiom,
    ! [VarCurr: state_type] :
      ( v60848(VarCurr)
    <=> v60850(VarCurr) ) ).

tff(addAssignment_35638,axiom,
    ! [VarCurr: state_type] :
      ( v60850(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_35637,axiom,
    ! [VarCurr: state_type] :
      ( v60844(VarCurr)
    <=> v60846(VarCurr) ) ).

tff(addAssignment_35636,axiom,
    ! [VarCurr: state_type] :
      ( v60846(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_35635,axiom,
    ! [VarCurr: state_type] :
      ( v60840(VarCurr)
    <=> v60842(VarCurr) ) ).

tff(addAssignment_35634,axiom,
    ! [VarCurr: state_type] :
      ( v60842(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_35633,axiom,
    ! [VarCurr: state_type] :
      ( v60736(VarCurr)
    <=> v60738(VarCurr) ) ).

tff(addAssignment_35632,axiom,
    ! [VarCurr: state_type] :
      ( v60738(VarCurr)
    <=> v60740(VarCurr) ) ).

tff(addAssignment_35631,axiom,
    ! [VarCurr: state_type] :
      ( v60740(VarCurr)
    <=> v60742(VarCurr) ) ).

tff(addAssignment_35630,axiom,
    ! [VarCurr: state_type] :
      ( v60742(VarCurr)
    <=> v60744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5785,axiom,
    ! [VarCurr: state_type] :
      ( v60744(VarCurr)
    <=> ( v60818(VarCurr)
      <~> v60794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5784,axiom,
    ! [VarCurr: state_type] :
      ( v60818(VarCurr)
    <=> ( v60746(VarCurr)
      <~> v60770(VarCurr) ) ) ).

tff(addAssignment_35629,axiom,
    ! [VarCurr: state_type] :
      ( v60794(VarCurr)
    <=> v60796(VarCurr) ) ).

tff(addAssignment_35628,axiom,
    ! [VarCurr: state_type] :
      ( v60796(VarCurr)
    <=> v60798(VarCurr) ) ).

tff(addAssignment_35627,axiom,
    ! [VarCurr: state_type] :
      ( v60798(VarCurr)
    <=> v60800(VarCurr) ) ).

tff(addAssignment_35626,axiom,
    ! [VarCurr: state_type] :
      ( v60800(VarCurr)
    <=> v60802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5783,axiom,
    ! [VarCurr: state_type] :
      ( v60802(VarCurr)
    <=> ( v60816(VarCurr)
      <~> v60812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5782,axiom,
    ! [VarCurr: state_type] :
      ( v60816(VarCurr)
    <=> ( v60804(VarCurr)
      <~> v60808(VarCurr) ) ) ).

tff(addAssignment_35625,axiom,
    ! [VarCurr: state_type] :
      ( v60812(VarCurr)
    <=> v60814(VarCurr) ) ).

tff(addAssignment_35624,axiom,
    ! [VarCurr: state_type] :
      ( v60814(VarCurr)
    <=> v6017(VarCurr,17) ) ).

tff(addAssignment_35623,axiom,
    ! [VarCurr: state_type] :
      ( v60808(VarCurr)
    <=> v60810(VarCurr) ) ).

tff(addAssignment_35622,axiom,
    ! [VarCurr: state_type] :
      ( v60810(VarCurr)
    <=> v6017(VarCurr,15) ) ).

tff(addAssignment_35621,axiom,
    ! [VarCurr: state_type] :
      ( v60804(VarCurr)
    <=> v60806(VarCurr) ) ).

tff(addAssignment_35620,axiom,
    ! [VarCurr: state_type] :
      ( v60806(VarCurr)
    <=> v6017(VarCurr,14) ) ).

tff(addAssignment_35619,axiom,
    ! [VarCurr: state_type] :
      ( v60770(VarCurr)
    <=> v60772(VarCurr) ) ).

tff(addAssignment_35618,axiom,
    ! [VarCurr: state_type] :
      ( v60772(VarCurr)
    <=> v60774(VarCurr) ) ).

tff(addAssignment_35617,axiom,
    ! [VarCurr: state_type] :
      ( v60774(VarCurr)
    <=> v60776(VarCurr) ) ).

tff(addAssignment_35616,axiom,
    ! [VarCurr: state_type] :
      ( v60776(VarCurr)
    <=> v60778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5781,axiom,
    ! [VarCurr: state_type] :
      ( v60778(VarCurr)
    <=> ( v60792(VarCurr)
      <~> v60788(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5780,axiom,
    ! [VarCurr: state_type] :
      ( v60792(VarCurr)
    <=> ( v60780(VarCurr)
      <~> v60784(VarCurr) ) ) ).

tff(addAssignment_35615,axiom,
    ! [VarCurr: state_type] :
      ( v60788(VarCurr)
    <=> v60790(VarCurr) ) ).

tff(addAssignment_35614,axiom,
    ! [VarCurr: state_type] :
      ( v60790(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_35613,axiom,
    ! [VarCurr: state_type] :
      ( v60784(VarCurr)
    <=> v60786(VarCurr) ) ).

tff(addAssignment_35612,axiom,
    ! [VarCurr: state_type] :
      ( v60786(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_35611,axiom,
    ! [VarCurr: state_type] :
      ( v60780(VarCurr)
    <=> v60782(VarCurr) ) ).

tff(addAssignment_35610,axiom,
    ! [VarCurr: state_type] :
      ( v60782(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_35609,axiom,
    ! [VarCurr: state_type] :
      ( v60746(VarCurr)
    <=> v60748(VarCurr) ) ).

tff(addAssignment_35608,axiom,
    ! [VarCurr: state_type] :
      ( v60748(VarCurr)
    <=> v60750(VarCurr) ) ).

tff(addAssignment_35607,axiom,
    ! [VarCurr: state_type] :
      ( v60750(VarCurr)
    <=> v60752(VarCurr) ) ).

tff(addAssignment_35606,axiom,
    ! [VarCurr: state_type] :
      ( v60752(VarCurr)
    <=> v60754(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5779,axiom,
    ! [VarCurr: state_type] :
      ( v60754(VarCurr)
    <=> ( v60768(VarCurr)
      <~> v60764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5778,axiom,
    ! [VarCurr: state_type] :
      ( v60768(VarCurr)
    <=> ( v60756(VarCurr)
      <~> v60760(VarCurr) ) ) ).

tff(addAssignment_35605,axiom,
    ! [VarCurr: state_type] :
      ( v60764(VarCurr)
    <=> v60766(VarCurr) ) ).

tff(addAssignment_35604,axiom,
    ! [VarCurr: state_type] :
      ( v60766(VarCurr)
    <=> v6017(VarCurr,7) ) ).

tff(addAssignment_35603,axiom,
    ! [VarCurr: state_type] :
      ( v60760(VarCurr)
    <=> v60762(VarCurr) ) ).

tff(addAssignment_35602,axiom,
    ! [VarCurr: state_type] :
      ( v60762(VarCurr)
    <=> v6017(VarCurr,4) ) ).

tff(addAssignment_35601,axiom,
    ! [VarCurr: state_type] :
      ( v60756(VarCurr)
    <=> v60758(VarCurr) ) ).

tff(addAssignment_35600,axiom,
    ! [VarCurr: state_type] :
      ( v60758(VarCurr)
    <=> v6017(VarCurr,1) ) ).

tff(addAssignment_35599,axiom,
    ! [VarCurr: state_type] :
      ( v5921(VarCurr,1)
    <=> v5923(VarCurr,1) ) ).

tff(addAssignment_35598,axiom,
    ! [VarCurr: state_type] :
      ( v5923(VarCurr,1)
    <=> v59235(VarCurr,1) ) ).

tff(addAssignment_35597,axiom,
    ! [VarCurr: state_type] :
      ( v5901(VarCurr)
    <=> v5903(VarCurr) ) ).

tff(addAssignment_35596,axiom,
    ! [VarCurr: state_type] :
      ( v5903(VarCurr)
    <=> v5905(VarCurr) ) ).

tff(addAssignment_35595,axiom,
    ! [VarCurr: state_type] :
      ( v5905(VarCurr)
    <=> v5907(VarCurr) ) ).

tff(addAssignment_35594,axiom,
    ! [VarCurr: state_type] :
      ( v5907(VarCurr)
    <=> v5909(VarCurr) ) ).

tff(writeUnaryOperator_3160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5909(VarCurr)
    <=> v60706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5777,axiom,
    ! [VarCurr: state_type] :
      ( v60706(VarCurr)
    <=> ( v5911(VarCurr)
        | v60036(VarCurr) ) ) ).

tff(addAssignment_35593,axiom,
    ! [VarCurr: state_type] :
      ( v60036(VarCurr)
    <=> v60038(VarCurr) ) ).

tff(addAssignment_35592,axiom,
    ! [VarCurr: state_type] :
      ( v60038(VarCurr)
    <=> v5915(VarCurr,2) ) ).

tff(addAssignment_35591,axiom,
    ! [VarCurr: state_type] :
      ( v5915(VarCurr,2)
    <=> v5917(VarCurr,2) ) ).

tff(addAssignment_35590,axiom,
    ! [VarCurr: state_type] :
      ( v5917(VarCurr,2)
    <=> v5919(VarCurr,2) ) ).

tff(addAssignment_35589,axiom,
    ! [VarCurr: state_type] :
      ( v5919(VarCurr,2)
    <=> v60034(VarCurr,2) ) ).

tff(addAssignment_35588,axiom,
    ! [VarCurr: state_type] :
      ( v59238(VarCurr,2)
    <=> v59240(VarCurr,2) ) ).

tff(addAssignment_35587,axiom,
    ! [VarCurr: state_type] :
      ( v59240(VarCurr,2)
    <=> v59242(VarCurr,2) ) ).

tff(addAssignment_35586,axiom,
    ! [VarCurr: state_type] :
      ( v59242(VarCurr,2)
    <=> v5977(VarCurr,14) ) ).

tff(addAssignment_35585,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,14)
    <=> v5979(VarCurr,14) ) ).

tff(addAssignment_35584,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,14)
    <=> v5981(VarCurr,14) ) ).

tff(addAssignment_35583,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,14)
    <=> v5983(VarCurr,14) ) ).

tff(addAssignment_35582,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,14)
    <=> v5985(VarCurr,14) ) ).

tff(addAssignment_35581,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,14)
    <=> v53672(VarCurr,14) ) ).

tff(addAssignment_35580,axiom,
    ! [VarCurr: state_type] :
      ( v53673(VarCurr,2)
    <=> v60040(VarCurr) ) ).

tff(addAssignment_35579,axiom,
    ! [VarCurr: state_type] :
      ( v60040(VarCurr)
    <=> v60042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5776,axiom,
    ! [VarCurr: state_type] :
      ( v60042(VarCurr)
    <=> ( v60704(VarCurr)
      <~> v60572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5775,axiom,
    ! [VarCurr: state_type] :
      ( v60704(VarCurr)
    <=> ( v60044(VarCurr)
      <~> v60308(VarCurr) ) ) ).

tff(addAssignment_35578,axiom,
    ! [VarCurr: state_type] :
      ( v60572(VarCurr)
    <=> v60574(VarCurr) ) ).

tff(addAssignment_35577,axiom,
    ! [VarCurr: state_type] :
      ( v60574(VarCurr)
    <=> v60576(VarCurr) ) ).

tff(addAssignment_35576,axiom,
    ! [VarCurr: state_type] :
      ( v60576(VarCurr)
    <=> v60578(VarCurr) ) ).

tff(addAssignment_35575,axiom,
    ! [VarCurr: state_type] :
      ( v60578(VarCurr)
    <=> v60580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5774,axiom,
    ! [VarCurr: state_type] :
      ( v60580(VarCurr)
    <=> ( v60702(VarCurr)
      <~> v60690(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5773,axiom,
    ! [VarCurr: state_type] :
      ( v60702(VarCurr)
    <=> ( v60582(VarCurr)
      <~> v60606(VarCurr) ) ) ).

tff(addAssignment_35574,axiom,
    ! [VarCurr: state_type] :
      ( v60690(VarCurr)
    <=> v60692(VarCurr) ) ).

tff(addAssignment_35573,axiom,
    ! [VarCurr: state_type] :
      ( v60692(VarCurr)
    <=> v59899(VarCurr,2) ) ).

tff(addAssignment_35572,axiom,
    ! [VarCurr: state_type] :
      ( v59899(VarCurr,2)
    <=> v59901(VarCurr,2) ) ).

tff(addAssignment_35571,axiom,
    ! [VarCurr: state_type] :
      ( v59901(VarCurr,2)
    <=> v53577(VarCurr,6) ) ).

tff(addAssignment_35570,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,6)
    <=> v53579(VarCurr,6) ) ).

tff(addAssignment_35569,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,6)
    <=> v60694(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60695(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v60694(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_760,axiom,
    ! [VarNext: state_type] :
      ( v60695(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v60694(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60695(VarNext)
      <=> v60696(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60696(VarNext)
      <=> ( v60698(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60698(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_35568,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,6)
    <=> v53603(VarCurr,6) ) ).

tff(addAssignment_35567,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,6)
    <=> v53632(VarCurr,6) ) ).

tff(addAssignment_35566,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,14)
    <=> v59912(VarCurr,2) ) ).

tff(addAssignment_35565,axiom,
    ! [VarCurr: state_type] :
      ( v59912(VarCurr,2)
    <=> v59914(VarCurr,2) ) ).

tff(addAssignment_35564,axiom,
    ! [VarCurr: state_type] :
      ( v59914(VarCurr,2)
    <=> v59931(VarCurr,2) ) ).

tff(addAssignment_35563,axiom,
    ! [VarCurr: state_type] :
      ( v59924(VarCurr,2)
    <=> v59926(VarCurr,2) ) ).

tff(addAssignment_35562,axiom,
    ! [VarCurr: state_type] :
      ( v59926(VarCurr,2)
    <=> v53312(VarCurr,14) ) ).

tff(addAssignment_35561,axiom,
    ! [VarCurr: state_type] :
      ( v59916(VarCurr,2)
    <=> v59918(VarCurr,2) ) ).

tff(addAssignment_35560,axiom,
    ! [VarCurr: state_type] :
      ( v59918(VarCurr,2)
    <=> v53312(VarCurr,10) ) ).

tff(addAssignment_35559,axiom,
    ! [VarCurr: state_type] :
      ( v60606(VarCurr)
    <=> v60608(VarCurr) ) ).

tff(addAssignment_35558,axiom,
    ! [VarCurr: state_type] :
      ( v60608(VarCurr)
    <=> v60610(VarCurr) ) ).

tff(addAssignment_35557,axiom,
    ! [VarCurr: state_type] :
      ( v60610(VarCurr)
    <=> v60612(VarCurr) ) ).

tff(addAssignment_35556,axiom,
    ! [VarCurr: state_type] :
      ( v60612(VarCurr)
    <=> v60614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5770,axiom,
    ! [VarCurr: state_type] :
      ( v60614(VarCurr)
    <=> ( v60688(VarCurr)
      <~> v60664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5769,axiom,
    ! [VarCurr: state_type] :
      ( v60688(VarCurr)
    <=> ( v60616(VarCurr)
      <~> v60640(VarCurr) ) ) ).

tff(addAssignment_35555,axiom,
    ! [VarCurr: state_type] :
      ( v60664(VarCurr)
    <=> v60666(VarCurr) ) ).

tff(addAssignment_35554,axiom,
    ! [VarCurr: state_type] :
      ( v60666(VarCurr)
    <=> v60668(VarCurr) ) ).

tff(addAssignment_35553,axiom,
    ! [VarCurr: state_type] :
      ( v60668(VarCurr)
    <=> v60670(VarCurr) ) ).

tff(addAssignment_35552,axiom,
    ! [VarCurr: state_type] :
      ( v60670(VarCurr)
    <=> v60672(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5768,axiom,
    ! [VarCurr: state_type] :
      ( v60672(VarCurr)
    <=> ( v60686(VarCurr)
      <~> v60682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5767,axiom,
    ! [VarCurr: state_type] :
      ( v60686(VarCurr)
    <=> ( v60674(VarCurr)
      <~> v60678(VarCurr) ) ) ).

tff(addAssignment_35551,axiom,
    ! [VarCurr: state_type] :
      ( v60682(VarCurr)
    <=> v60684(VarCurr) ) ).

tff(addAssignment_35550,axiom,
    ! [VarCurr: state_type] :
      ( v60684(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_35549,axiom,
    ! [VarCurr: state_type] :
      ( v60678(VarCurr)
    <=> v60680(VarCurr) ) ).

tff(addAssignment_35548,axiom,
    ! [VarCurr: state_type] :
      ( v60680(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_35547,axiom,
    ! [VarCurr: state_type] :
      ( v60674(VarCurr)
    <=> v60676(VarCurr) ) ).

tff(addAssignment_35546,axiom,
    ! [VarCurr: state_type] :
      ( v60676(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_35545,axiom,
    ! [VarCurr: state_type] :
      ( v60640(VarCurr)
    <=> v60642(VarCurr) ) ).

tff(addAssignment_35544,axiom,
    ! [VarCurr: state_type] :
      ( v60642(VarCurr)
    <=> v60644(VarCurr) ) ).

tff(addAssignment_35543,axiom,
    ! [VarCurr: state_type] :
      ( v60644(VarCurr)
    <=> v60646(VarCurr) ) ).

tff(addAssignment_35542,axiom,
    ! [VarCurr: state_type] :
      ( v60646(VarCurr)
    <=> v60648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5766,axiom,
    ! [VarCurr: state_type] :
      ( v60648(VarCurr)
    <=> ( v60662(VarCurr)
      <~> v60658(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5765,axiom,
    ! [VarCurr: state_type] :
      ( v60662(VarCurr)
    <=> ( v60650(VarCurr)
      <~> v60654(VarCurr) ) ) ).

tff(addAssignment_35541,axiom,
    ! [VarCurr: state_type] :
      ( v60658(VarCurr)
    <=> v60660(VarCurr) ) ).

tff(addAssignment_35540,axiom,
    ! [VarCurr: state_type] :
      ( v60660(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_35539,axiom,
    ! [VarCurr: state_type] :
      ( v60654(VarCurr)
    <=> v60656(VarCurr) ) ).

tff(addAssignment_35538,axiom,
    ! [VarCurr: state_type] :
      ( v60656(VarCurr)
    <=> v6017(VarCurr,108) ) ).

tff(addAssignment_35537,axiom,
    ! [VarCurr: state_type] :
      ( v60650(VarCurr)
    <=> v60652(VarCurr) ) ).

tff(addAssignment_35536,axiom,
    ! [VarCurr: state_type] :
      ( v60652(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_35535,axiom,
    ! [VarCurr: state_type] :
      ( v60616(VarCurr)
    <=> v60618(VarCurr) ) ).

tff(addAssignment_35534,axiom,
    ! [VarCurr: state_type] :
      ( v60618(VarCurr)
    <=> v60620(VarCurr) ) ).

tff(addAssignment_35533,axiom,
    ! [VarCurr: state_type] :
      ( v60620(VarCurr)
    <=> v60622(VarCurr) ) ).

tff(addAssignment_35532,axiom,
    ! [VarCurr: state_type] :
      ( v60622(VarCurr)
    <=> v60624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5764,axiom,
    ! [VarCurr: state_type] :
      ( v60624(VarCurr)
    <=> ( v60638(VarCurr)
      <~> v60634(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5763,axiom,
    ! [VarCurr: state_type] :
      ( v60638(VarCurr)
    <=> ( v60626(VarCurr)
      <~> v60630(VarCurr) ) ) ).

tff(addAssignment_35531,axiom,
    ! [VarCurr: state_type] :
      ( v60634(VarCurr)
    <=> v60636(VarCurr) ) ).

tff(addAssignment_35530,axiom,
    ! [VarCurr: state_type] :
      ( v60636(VarCurr)
    <=> v6017(VarCurr,104) ) ).

tff(addAssignment_35529,axiom,
    ! [VarCurr: state_type] :
      ( v60630(VarCurr)
    <=> v60632(VarCurr) ) ).

tff(addAssignment_35528,axiom,
    ! [VarCurr: state_type] :
      ( v60632(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_35527,axiom,
    ! [VarCurr: state_type] :
      ( v60626(VarCurr)
    <=> v60628(VarCurr) ) ).

tff(addAssignment_35526,axiom,
    ! [VarCurr: state_type] :
      ( v60628(VarCurr)
    <=> v6017(VarCurr,101) ) ).

tff(addAssignment_35525,axiom,
    ! [VarCurr: state_type] :
      ( v60582(VarCurr)
    <=> v60584(VarCurr) ) ).

tff(addAssignment_35524,axiom,
    ! [VarCurr: state_type] :
      ( v60584(VarCurr)
    <=> v60586(VarCurr) ) ).

tff(addAssignment_35523,axiom,
    ! [VarCurr: state_type] :
      ( v60586(VarCurr)
    <=> v60588(VarCurr) ) ).

tff(addAssignment_35522,axiom,
    ! [VarCurr: state_type] :
      ( v60588(VarCurr)
    <=> v60590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5762,axiom,
    ! [VarCurr: state_type] :
      ( v60590(VarCurr)
    <=> ( v60604(VarCurr)
      <~> v60600(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5761,axiom,
    ! [VarCurr: state_type] :
      ( v60604(VarCurr)
    <=> ( v60592(VarCurr)
      <~> v60596(VarCurr) ) ) ).

tff(addAssignment_35521,axiom,
    ! [VarCurr: state_type] :
      ( v60600(VarCurr)
    <=> v60602(VarCurr) ) ).

tff(addAssignment_35520,axiom,
    ! [VarCurr: state_type] :
      ( v60602(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_35519,axiom,
    ! [VarCurr: state_type] :
      ( v60596(VarCurr)
    <=> v60598(VarCurr) ) ).

tff(addAssignment_35518,axiom,
    ! [VarCurr: state_type] :
      ( v60598(VarCurr)
    <=> v6017(VarCurr,126) ) ).

tff(addAssignment_35517,axiom,
    ! [VarCurr: state_type] :
      ( v60592(VarCurr)
    <=> v60594(VarCurr) ) ).

tff(addAssignment_35516,axiom,
    ! [VarCurr: state_type] :
      ( v60594(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_35515,axiom,
    ! [VarCurr: state_type] :
      ( v60308(VarCurr)
    <=> v60310(VarCurr) ) ).

tff(addAssignment_35514,axiom,
    ! [VarCurr: state_type] :
      ( v60310(VarCurr)
    <=> v60312(VarCurr) ) ).

tff(addAssignment_35513,axiom,
    ! [VarCurr: state_type] :
      ( v60312(VarCurr)
    <=> v60314(VarCurr) ) ).

tff(addAssignment_35512,axiom,
    ! [VarCurr: state_type] :
      ( v60314(VarCurr)
    <=> v60316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5760,axiom,
    ! [VarCurr: state_type] :
      ( v60316(VarCurr)
    <=> ( v60570(VarCurr)
      <~> v60486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5759,axiom,
    ! [VarCurr: state_type] :
      ( v60570(VarCurr)
    <=> ( v60318(VarCurr)
      <~> v60402(VarCurr) ) ) ).

tff(addAssignment_35511,axiom,
    ! [VarCurr: state_type] :
      ( v60486(VarCurr)
    <=> v60488(VarCurr) ) ).

tff(addAssignment_35510,axiom,
    ! [VarCurr: state_type] :
      ( v60488(VarCurr)
    <=> v60490(VarCurr) ) ).

tff(addAssignment_35509,axiom,
    ! [VarCurr: state_type] :
      ( v60490(VarCurr)
    <=> v60492(VarCurr) ) ).

tff(addAssignment_35508,axiom,
    ! [VarCurr: state_type] :
      ( v60492(VarCurr)
    <=> v60494(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5758,axiom,
    ! [VarCurr: state_type] :
      ( v60494(VarCurr)
    <=> ( v60568(VarCurr)
      <~> v60544(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5757,axiom,
    ! [VarCurr: state_type] :
      ( v60568(VarCurr)
    <=> ( v60496(VarCurr)
      <~> v60520(VarCurr) ) ) ).

tff(addAssignment_35507,axiom,
    ! [VarCurr: state_type] :
      ( v60544(VarCurr)
    <=> v60546(VarCurr) ) ).

tff(addAssignment_35506,axiom,
    ! [VarCurr: state_type] :
      ( v60546(VarCurr)
    <=> v60548(VarCurr) ) ).

tff(addAssignment_35505,axiom,
    ! [VarCurr: state_type] :
      ( v60548(VarCurr)
    <=> v60550(VarCurr) ) ).

tff(addAssignment_35504,axiom,
    ! [VarCurr: state_type] :
      ( v60550(VarCurr)
    <=> v60552(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5756,axiom,
    ! [VarCurr: state_type] :
      ( v60552(VarCurr)
    <=> ( v60566(VarCurr)
      <~> v60562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5755,axiom,
    ! [VarCurr: state_type] :
      ( v60566(VarCurr)
    <=> ( v60554(VarCurr)
      <~> v60558(VarCurr) ) ) ).

tff(addAssignment_35503,axiom,
    ! [VarCurr: state_type] :
      ( v60562(VarCurr)
    <=> v60564(VarCurr) ) ).

tff(addAssignment_35502,axiom,
    ! [VarCurr: state_type] :
      ( v60564(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_35501,axiom,
    ! [VarCurr: state_type] :
      ( v60558(VarCurr)
    <=> v60560(VarCurr) ) ).

tff(addAssignment_35500,axiom,
    ! [VarCurr: state_type] :
      ( v60560(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_35499,axiom,
    ! [VarCurr: state_type] :
      ( v60554(VarCurr)
    <=> v60556(VarCurr) ) ).

tff(addAssignment_35498,axiom,
    ! [VarCurr: state_type] :
      ( v60556(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_35497,axiom,
    ! [VarCurr: state_type] :
      ( v60520(VarCurr)
    <=> v60522(VarCurr) ) ).

tff(addAssignment_35496,axiom,
    ! [VarCurr: state_type] :
      ( v60522(VarCurr)
    <=> v60524(VarCurr) ) ).

tff(addAssignment_35495,axiom,
    ! [VarCurr: state_type] :
      ( v60524(VarCurr)
    <=> v60526(VarCurr) ) ).

tff(addAssignment_35494,axiom,
    ! [VarCurr: state_type] :
      ( v60526(VarCurr)
    <=> v60528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5754,axiom,
    ! [VarCurr: state_type] :
      ( v60528(VarCurr)
    <=> ( v60542(VarCurr)
      <~> v60538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5753,axiom,
    ! [VarCurr: state_type] :
      ( v60542(VarCurr)
    <=> ( v60530(VarCurr)
      <~> v60534(VarCurr) ) ) ).

tff(addAssignment_35493,axiom,
    ! [VarCurr: state_type] :
      ( v60538(VarCurr)
    <=> v60540(VarCurr) ) ).

tff(addAssignment_35492,axiom,
    ! [VarCurr: state_type] :
      ( v60540(VarCurr)
    <=> v6017(VarCurr,95) ) ).

tff(addAssignment_35491,axiom,
    ! [VarCurr: state_type] :
      ( v60534(VarCurr)
    <=> v60536(VarCurr) ) ).

tff(addAssignment_35490,axiom,
    ! [VarCurr: state_type] :
      ( v60536(VarCurr)
    <=> v6017(VarCurr,90) ) ).

tff(addAssignment_35489,axiom,
    ! [VarCurr: state_type] :
      ( v60530(VarCurr)
    <=> v60532(VarCurr) ) ).

tff(addAssignment_35488,axiom,
    ! [VarCurr: state_type] :
      ( v60532(VarCurr)
    <=> v6017(VarCurr,91) ) ).

tff(addAssignment_35487,axiom,
    ! [VarCurr: state_type] :
      ( v60496(VarCurr)
    <=> v60498(VarCurr) ) ).

tff(addAssignment_35486,axiom,
    ! [VarCurr: state_type] :
      ( v60498(VarCurr)
    <=> v60500(VarCurr) ) ).

tff(addAssignment_35485,axiom,
    ! [VarCurr: state_type] :
      ( v60500(VarCurr)
    <=> v60502(VarCurr) ) ).

tff(addAssignment_35484,axiom,
    ! [VarCurr: state_type] :
      ( v60502(VarCurr)
    <=> v60504(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5752,axiom,
    ! [VarCurr: state_type] :
      ( v60504(VarCurr)
    <=> ( v60518(VarCurr)
      <~> v60514(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5751,axiom,
    ! [VarCurr: state_type] :
      ( v60518(VarCurr)
    <=> ( v60506(VarCurr)
      <~> v60510(VarCurr) ) ) ).

tff(addAssignment_35483,axiom,
    ! [VarCurr: state_type] :
      ( v60514(VarCurr)
    <=> v60516(VarCurr) ) ).

tff(addAssignment_35482,axiom,
    ! [VarCurr: state_type] :
      ( v60516(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_35481,axiom,
    ! [VarCurr: state_type] :
      ( v60510(VarCurr)
    <=> v60512(VarCurr) ) ).

tff(addAssignment_35480,axiom,
    ! [VarCurr: state_type] :
      ( v60512(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_35479,axiom,
    ! [VarCurr: state_type] :
      ( v60506(VarCurr)
    <=> v60508(VarCurr) ) ).

tff(addAssignment_35478,axiom,
    ! [VarCurr: state_type] :
      ( v60508(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_35477,axiom,
    ! [VarCurr: state_type] :
      ( v60402(VarCurr)
    <=> v60404(VarCurr) ) ).

tff(addAssignment_35476,axiom,
    ! [VarCurr: state_type] :
      ( v60404(VarCurr)
    <=> v60406(VarCurr) ) ).

tff(addAssignment_35475,axiom,
    ! [VarCurr: state_type] :
      ( v60406(VarCurr)
    <=> v60408(VarCurr) ) ).

tff(addAssignment_35474,axiom,
    ! [VarCurr: state_type] :
      ( v60408(VarCurr)
    <=> v60410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5750,axiom,
    ! [VarCurr: state_type] :
      ( v60410(VarCurr)
    <=> ( v60484(VarCurr)
      <~> v60460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5749,axiom,
    ! [VarCurr: state_type] :
      ( v60484(VarCurr)
    <=> ( v60412(VarCurr)
      <~> v60436(VarCurr) ) ) ).

tff(addAssignment_35473,axiom,
    ! [VarCurr: state_type] :
      ( v60460(VarCurr)
    <=> v60462(VarCurr) ) ).

tff(addAssignment_35472,axiom,
    ! [VarCurr: state_type] :
      ( v60462(VarCurr)
    <=> v60464(VarCurr) ) ).

tff(addAssignment_35471,axiom,
    ! [VarCurr: state_type] :
      ( v60464(VarCurr)
    <=> v60466(VarCurr) ) ).

tff(addAssignment_35470,axiom,
    ! [VarCurr: state_type] :
      ( v60466(VarCurr)
    <=> v60468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5748,axiom,
    ! [VarCurr: state_type] :
      ( v60468(VarCurr)
    <=> ( v60482(VarCurr)
      <~> v60478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5747,axiom,
    ! [VarCurr: state_type] :
      ( v60482(VarCurr)
    <=> ( v60470(VarCurr)
      <~> v60474(VarCurr) ) ) ).

tff(addAssignment_35469,axiom,
    ! [VarCurr: state_type] :
      ( v60478(VarCurr)
    <=> v60480(VarCurr) ) ).

tff(addAssignment_35468,axiom,
    ! [VarCurr: state_type] :
      ( v60480(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_35467,axiom,
    ! [VarCurr: state_type] :
      ( v60474(VarCurr)
    <=> v60476(VarCurr) ) ).

tff(addAssignment_35466,axiom,
    ! [VarCurr: state_type] :
      ( v60476(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_35465,axiom,
    ! [VarCurr: state_type] :
      ( v60470(VarCurr)
    <=> v60472(VarCurr) ) ).

tff(addAssignment_35464,axiom,
    ! [VarCurr: state_type] :
      ( v60472(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_35463,axiom,
    ! [VarCurr: state_type] :
      ( v60436(VarCurr)
    <=> v60438(VarCurr) ) ).

tff(addAssignment_35462,axiom,
    ! [VarCurr: state_type] :
      ( v60438(VarCurr)
    <=> v60440(VarCurr) ) ).

tff(addAssignment_35461,axiom,
    ! [VarCurr: state_type] :
      ( v60440(VarCurr)
    <=> v60442(VarCurr) ) ).

tff(addAssignment_35460,axiom,
    ! [VarCurr: state_type] :
      ( v60442(VarCurr)
    <=> v60444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5746,axiom,
    ! [VarCurr: state_type] :
      ( v60444(VarCurr)
    <=> ( v60458(VarCurr)
      <~> v60454(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5745,axiom,
    ! [VarCurr: state_type] :
      ( v60458(VarCurr)
    <=> ( v60446(VarCurr)
      <~> v60450(VarCurr) ) ) ).

tff(addAssignment_35459,axiom,
    ! [VarCurr: state_type] :
      ( v60454(VarCurr)
    <=> v60456(VarCurr) ) ).

tff(addAssignment_35458,axiom,
    ! [VarCurr: state_type] :
      ( v60456(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_35457,axiom,
    ! [VarCurr: state_type] :
      ( v60450(VarCurr)
    <=> v60452(VarCurr) ) ).

tff(addAssignment_35456,axiom,
    ! [VarCurr: state_type] :
      ( v60452(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_35455,axiom,
    ! [VarCurr: state_type] :
      ( v60446(VarCurr)
    <=> v60448(VarCurr) ) ).

tff(addAssignment_35454,axiom,
    ! [VarCurr: state_type] :
      ( v60448(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_35453,axiom,
    ! [VarCurr: state_type] :
      ( v60412(VarCurr)
    <=> v60414(VarCurr) ) ).

tff(addAssignment_35452,axiom,
    ! [VarCurr: state_type] :
      ( v60414(VarCurr)
    <=> v60416(VarCurr) ) ).

tff(addAssignment_35451,axiom,
    ! [VarCurr: state_type] :
      ( v60416(VarCurr)
    <=> v60418(VarCurr) ) ).

tff(addAssignment_35450,axiom,
    ! [VarCurr: state_type] :
      ( v60418(VarCurr)
    <=> v60420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5744,axiom,
    ! [VarCurr: state_type] :
      ( v60420(VarCurr)
    <=> ( v60434(VarCurr)
      <~> v60430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5743,axiom,
    ! [VarCurr: state_type] :
      ( v60434(VarCurr)
    <=> ( v60422(VarCurr)
      <~> v60426(VarCurr) ) ) ).

tff(addAssignment_35449,axiom,
    ! [VarCurr: state_type] :
      ( v60430(VarCurr)
    <=> v60432(VarCurr) ) ).

tff(addAssignment_35448,axiom,
    ! [VarCurr: state_type] :
      ( v60432(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_35447,axiom,
    ! [VarCurr: state_type] :
      ( v60426(VarCurr)
    <=> v60428(VarCurr) ) ).

tff(addAssignment_35446,axiom,
    ! [VarCurr: state_type] :
      ( v60428(VarCurr)
    <=> v6017(VarCurr,75) ) ).

tff(addAssignment_35445,axiom,
    ! [VarCurr: state_type] :
      ( v60422(VarCurr)
    <=> v60424(VarCurr) ) ).

tff(addAssignment_35444,axiom,
    ! [VarCurr: state_type] :
      ( v60424(VarCurr)
    <=> v6017(VarCurr,72) ) ).

tff(addAssignment_35443,axiom,
    ! [VarCurr: state_type] :
      ( v60318(VarCurr)
    <=> v60320(VarCurr) ) ).

tff(addAssignment_35442,axiom,
    ! [VarCurr: state_type] :
      ( v60320(VarCurr)
    <=> v60322(VarCurr) ) ).

tff(addAssignment_35441,axiom,
    ! [VarCurr: state_type] :
      ( v60322(VarCurr)
    <=> v60324(VarCurr) ) ).

tff(addAssignment_35440,axiom,
    ! [VarCurr: state_type] :
      ( v60324(VarCurr)
    <=> v60326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5742,axiom,
    ! [VarCurr: state_type] :
      ( v60326(VarCurr)
    <=> ( v60400(VarCurr)
      <~> v60376(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5741,axiom,
    ! [VarCurr: state_type] :
      ( v60400(VarCurr)
    <=> ( v60328(VarCurr)
      <~> v60352(VarCurr) ) ) ).

tff(addAssignment_35439,axiom,
    ! [VarCurr: state_type] :
      ( v60376(VarCurr)
    <=> v60378(VarCurr) ) ).

tff(addAssignment_35438,axiom,
    ! [VarCurr: state_type] :
      ( v60378(VarCurr)
    <=> v60380(VarCurr) ) ).

tff(addAssignment_35437,axiom,
    ! [VarCurr: state_type] :
      ( v60380(VarCurr)
    <=> v60382(VarCurr) ) ).

tff(addAssignment_35436,axiom,
    ! [VarCurr: state_type] :
      ( v60382(VarCurr)
    <=> v60384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5740,axiom,
    ! [VarCurr: state_type] :
      ( v60384(VarCurr)
    <=> ( v60398(VarCurr)
      <~> v60394(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5739,axiom,
    ! [VarCurr: state_type] :
      ( v60398(VarCurr)
    <=> ( v60386(VarCurr)
      <~> v60390(VarCurr) ) ) ).

tff(addAssignment_35435,axiom,
    ! [VarCurr: state_type] :
      ( v60394(VarCurr)
    <=> v60396(VarCurr) ) ).

tff(addAssignment_35434,axiom,
    ! [VarCurr: state_type] :
      ( v60396(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_35433,axiom,
    ! [VarCurr: state_type] :
      ( v60390(VarCurr)
    <=> v60392(VarCurr) ) ).

tff(addAssignment_35432,axiom,
    ! [VarCurr: state_type] :
      ( v60392(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_35431,axiom,
    ! [VarCurr: state_type] :
      ( v60386(VarCurr)
    <=> v60388(VarCurr) ) ).

tff(addAssignment_35430,axiom,
    ! [VarCurr: state_type] :
      ( v60388(VarCurr)
    <=> v6017(VarCurr,65) ) ).

tff(addAssignment_35429,axiom,
    ! [VarCurr: state_type] :
      ( v60352(VarCurr)
    <=> v60354(VarCurr) ) ).

tff(addAssignment_35428,axiom,
    ! [VarCurr: state_type] :
      ( v60354(VarCurr)
    <=> v60356(VarCurr) ) ).

tff(addAssignment_35427,axiom,
    ! [VarCurr: state_type] :
      ( v60356(VarCurr)
    <=> v60358(VarCurr) ) ).

tff(addAssignment_35426,axiom,
    ! [VarCurr: state_type] :
      ( v60358(VarCurr)
    <=> v60360(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5738,axiom,
    ! [VarCurr: state_type] :
      ( v60360(VarCurr)
    <=> ( v60374(VarCurr)
      <~> v60370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5737,axiom,
    ! [VarCurr: state_type] :
      ( v60374(VarCurr)
    <=> ( v60362(VarCurr)
      <~> v60366(VarCurr) ) ) ).

tff(addAssignment_35425,axiom,
    ! [VarCurr: state_type] :
      ( v60370(VarCurr)
    <=> v60372(VarCurr) ) ).

tff(addAssignment_35424,axiom,
    ! [VarCurr: state_type] :
      ( v60372(VarCurr)
    <=> v6017(VarCurr,62) ) ).

tff(addAssignment_35423,axiom,
    ! [VarCurr: state_type] :
      ( v60366(VarCurr)
    <=> v60368(VarCurr) ) ).

tff(addAssignment_35422,axiom,
    ! [VarCurr: state_type] :
      ( v60368(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_35421,axiom,
    ! [VarCurr: state_type] :
      ( v60362(VarCurr)
    <=> v60364(VarCurr) ) ).

tff(addAssignment_35420,axiom,
    ! [VarCurr: state_type] :
      ( v60364(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_35419,axiom,
    ! [VarCurr: state_type] :
      ( v60328(VarCurr)
    <=> v60330(VarCurr) ) ).

tff(addAssignment_35418,axiom,
    ! [VarCurr: state_type] :
      ( v60330(VarCurr)
    <=> v60332(VarCurr) ) ).

tff(addAssignment_35417,axiom,
    ! [VarCurr: state_type] :
      ( v60332(VarCurr)
    <=> v60334(VarCurr) ) ).

tff(addAssignment_35416,axiom,
    ! [VarCurr: state_type] :
      ( v60334(VarCurr)
    <=> v60336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5736,axiom,
    ! [VarCurr: state_type] :
      ( v60336(VarCurr)
    <=> ( v60350(VarCurr)
      <~> v60346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5735,axiom,
    ! [VarCurr: state_type] :
      ( v60350(VarCurr)
    <=> ( v60338(VarCurr)
      <~> v60342(VarCurr) ) ) ).

tff(addAssignment_35415,axiom,
    ! [VarCurr: state_type] :
      ( v60346(VarCurr)
    <=> v60348(VarCurr) ) ).

tff(addAssignment_35414,axiom,
    ! [VarCurr: state_type] :
      ( v60348(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_35413,axiom,
    ! [VarCurr: state_type] :
      ( v60342(VarCurr)
    <=> v60344(VarCurr) ) ).

tff(addAssignment_35412,axiom,
    ! [VarCurr: state_type] :
      ( v60344(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_35411,axiom,
    ! [VarCurr: state_type] :
      ( v60338(VarCurr)
    <=> v60340(VarCurr) ) ).

tff(addAssignment_35410,axiom,
    ! [VarCurr: state_type] :
      ( v60340(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_35409,axiom,
    ! [VarCurr: state_type] :
      ( v60044(VarCurr)
    <=> v60046(VarCurr) ) ).

tff(addAssignment_35408,axiom,
    ! [VarCurr: state_type] :
      ( v60046(VarCurr)
    <=> v60048(VarCurr) ) ).

tff(addAssignment_35407,axiom,
    ! [VarCurr: state_type] :
      ( v60048(VarCurr)
    <=> v60050(VarCurr) ) ).

tff(addAssignment_35406,axiom,
    ! [VarCurr: state_type] :
      ( v60050(VarCurr)
    <=> v60052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5734,axiom,
    ! [VarCurr: state_type] :
      ( v60052(VarCurr)
    <=> ( v60306(VarCurr)
      <~> v60222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5733,axiom,
    ! [VarCurr: state_type] :
      ( v60306(VarCurr)
    <=> ( v60054(VarCurr)
      <~> v60138(VarCurr) ) ) ).

tff(addAssignment_35405,axiom,
    ! [VarCurr: state_type] :
      ( v60222(VarCurr)
    <=> v60224(VarCurr) ) ).

tff(addAssignment_35404,axiom,
    ! [VarCurr: state_type] :
      ( v60224(VarCurr)
    <=> v60226(VarCurr) ) ).

tff(addAssignment_35403,axiom,
    ! [VarCurr: state_type] :
      ( v60226(VarCurr)
    <=> v60228(VarCurr) ) ).

tff(addAssignment_35402,axiom,
    ! [VarCurr: state_type] :
      ( v60228(VarCurr)
    <=> v60230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5732,axiom,
    ! [VarCurr: state_type] :
      ( v60230(VarCurr)
    <=> ( v60304(VarCurr)
      <~> v60280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5731,axiom,
    ! [VarCurr: state_type] :
      ( v60304(VarCurr)
    <=> ( v60232(VarCurr)
      <~> v60256(VarCurr) ) ) ).

tff(addAssignment_35401,axiom,
    ! [VarCurr: state_type] :
      ( v60280(VarCurr)
    <=> v60282(VarCurr) ) ).

tff(addAssignment_35400,axiom,
    ! [VarCurr: state_type] :
      ( v60282(VarCurr)
    <=> v60284(VarCurr) ) ).

tff(addAssignment_35399,axiom,
    ! [VarCurr: state_type] :
      ( v60284(VarCurr)
    <=> v60286(VarCurr) ) ).

tff(addAssignment_35398,axiom,
    ! [VarCurr: state_type] :
      ( v60286(VarCurr)
    <=> v60288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5730,axiom,
    ! [VarCurr: state_type] :
      ( v60288(VarCurr)
    <=> ( v60302(VarCurr)
      <~> v60298(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5729,axiom,
    ! [VarCurr: state_type] :
      ( v60302(VarCurr)
    <=> ( v60290(VarCurr)
      <~> v60294(VarCurr) ) ) ).

tff(addAssignment_35397,axiom,
    ! [VarCurr: state_type] :
      ( v60298(VarCurr)
    <=> v60300(VarCurr) ) ).

tff(addAssignment_35396,axiom,
    ! [VarCurr: state_type] :
      ( v60300(VarCurr)
    <=> v6017(VarCurr,48) ) ).

tff(addAssignment_35395,axiom,
    ! [VarCurr: state_type] :
      ( v60294(VarCurr)
    <=> v60296(VarCurr) ) ).

tff(addAssignment_35394,axiom,
    ! [VarCurr: state_type] :
      ( v60296(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_35393,axiom,
    ! [VarCurr: state_type] :
      ( v60290(VarCurr)
    <=> v60292(VarCurr) ) ).

tff(addAssignment_35392,axiom,
    ! [VarCurr: state_type] :
      ( v60292(VarCurr)
    <=> v6017(VarCurr,44) ) ).

tff(addAssignment_35391,axiom,
    ! [VarCurr: state_type] :
      ( v60256(VarCurr)
    <=> v60258(VarCurr) ) ).

tff(addAssignment_35390,axiom,
    ! [VarCurr: state_type] :
      ( v60258(VarCurr)
    <=> v60260(VarCurr) ) ).

tff(addAssignment_35389,axiom,
    ! [VarCurr: state_type] :
      ( v60260(VarCurr)
    <=> v60262(VarCurr) ) ).

tff(addAssignment_35388,axiom,
    ! [VarCurr: state_type] :
      ( v60262(VarCurr)
    <=> v60264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5728,axiom,
    ! [VarCurr: state_type] :
      ( v60264(VarCurr)
    <=> ( v60278(VarCurr)
      <~> v60274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5727,axiom,
    ! [VarCurr: state_type] :
      ( v60278(VarCurr)
    <=> ( v60266(VarCurr)
      <~> v60270(VarCurr) ) ) ).

tff(addAssignment_35387,axiom,
    ! [VarCurr: state_type] :
      ( v60274(VarCurr)
    <=> v60276(VarCurr) ) ).

tff(addAssignment_35386,axiom,
    ! [VarCurr: state_type] :
      ( v60276(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_35385,axiom,
    ! [VarCurr: state_type] :
      ( v60270(VarCurr)
    <=> v60272(VarCurr) ) ).

tff(addAssignment_35384,axiom,
    ! [VarCurr: state_type] :
      ( v60272(VarCurr)
    <=> v6017(VarCurr,41) ) ).

tff(addAssignment_35383,axiom,
    ! [VarCurr: state_type] :
      ( v60266(VarCurr)
    <=> v60268(VarCurr) ) ).

tff(addAssignment_35382,axiom,
    ! [VarCurr: state_type] :
      ( v60268(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_35381,axiom,
    ! [VarCurr: state_type] :
      ( v60232(VarCurr)
    <=> v60234(VarCurr) ) ).

tff(addAssignment_35380,axiom,
    ! [VarCurr: state_type] :
      ( v60234(VarCurr)
    <=> v60236(VarCurr) ) ).

tff(addAssignment_35379,axiom,
    ! [VarCurr: state_type] :
      ( v60236(VarCurr)
    <=> v60238(VarCurr) ) ).

tff(addAssignment_35378,axiom,
    ! [VarCurr: state_type] :
      ( v60238(VarCurr)
    <=> v60240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5726,axiom,
    ! [VarCurr: state_type] :
      ( v60240(VarCurr)
    <=> ( v60254(VarCurr)
      <~> v60250(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5725,axiom,
    ! [VarCurr: state_type] :
      ( v60254(VarCurr)
    <=> ( v60242(VarCurr)
      <~> v60246(VarCurr) ) ) ).

tff(addAssignment_35377,axiom,
    ! [VarCurr: state_type] :
      ( v60250(VarCurr)
    <=> v60252(VarCurr) ) ).

tff(addAssignment_35376,axiom,
    ! [VarCurr: state_type] :
      ( v60252(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_35375,axiom,
    ! [VarCurr: state_type] :
      ( v60246(VarCurr)
    <=> v60248(VarCurr) ) ).

tff(addAssignment_35374,axiom,
    ! [VarCurr: state_type] :
      ( v60248(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_35373,axiom,
    ! [VarCurr: state_type] :
      ( v60242(VarCurr)
    <=> v60244(VarCurr) ) ).

tff(addAssignment_35372,axiom,
    ! [VarCurr: state_type] :
      ( v60244(VarCurr)
    <=> v6017(VarCurr,35) ) ).

tff(addAssignment_35371,axiom,
    ! [VarCurr: state_type] :
      ( v60138(VarCurr)
    <=> v60140(VarCurr) ) ).

tff(addAssignment_35370,axiom,
    ! [VarCurr: state_type] :
      ( v60140(VarCurr)
    <=> v60142(VarCurr) ) ).

tff(addAssignment_35369,axiom,
    ! [VarCurr: state_type] :
      ( v60142(VarCurr)
    <=> v60144(VarCurr) ) ).

tff(addAssignment_35368,axiom,
    ! [VarCurr: state_type] :
      ( v60144(VarCurr)
    <=> v60146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5724,axiom,
    ! [VarCurr: state_type] :
      ( v60146(VarCurr)
    <=> ( v60220(VarCurr)
      <~> v60196(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5723,axiom,
    ! [VarCurr: state_type] :
      ( v60220(VarCurr)
    <=> ( v60148(VarCurr)
      <~> v60172(VarCurr) ) ) ).

tff(addAssignment_35367,axiom,
    ! [VarCurr: state_type] :
      ( v60196(VarCurr)
    <=> v60198(VarCurr) ) ).

tff(addAssignment_35366,axiom,
    ! [VarCurr: state_type] :
      ( v60198(VarCurr)
    <=> v60200(VarCurr) ) ).

tff(addAssignment_35365,axiom,
    ! [VarCurr: state_type] :
      ( v60200(VarCurr)
    <=> v60202(VarCurr) ) ).

tff(addAssignment_35364,axiom,
    ! [VarCurr: state_type] :
      ( v60202(VarCurr)
    <=> v60204(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5722,axiom,
    ! [VarCurr: state_type] :
      ( v60204(VarCurr)
    <=> ( v60218(VarCurr)
      <~> v60214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5721,axiom,
    ! [VarCurr: state_type] :
      ( v60218(VarCurr)
    <=> ( v60206(VarCurr)
      <~> v60210(VarCurr) ) ) ).

tff(addAssignment_35363,axiom,
    ! [VarCurr: state_type] :
      ( v60214(VarCurr)
    <=> v60216(VarCurr) ) ).

tff(addAssignment_35362,axiom,
    ! [VarCurr: state_type] :
      ( v60216(VarCurr)
    <=> v6017(VarCurr,31) ) ).

tff(addAssignment_35361,axiom,
    ! [VarCurr: state_type] :
      ( v60210(VarCurr)
    <=> v60212(VarCurr) ) ).

tff(addAssignment_35360,axiom,
    ! [VarCurr: state_type] :
      ( v60212(VarCurr)
    <=> v6017(VarCurr,30) ) ).

tff(addAssignment_35359,axiom,
    ! [VarCurr: state_type] :
      ( v60206(VarCurr)
    <=> v60208(VarCurr) ) ).

tff(addAssignment_35358,axiom,
    ! [VarCurr: state_type] :
      ( v60208(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_35357,axiom,
    ! [VarCurr: state_type] :
      ( v60172(VarCurr)
    <=> v60174(VarCurr) ) ).

tff(addAssignment_35356,axiom,
    ! [VarCurr: state_type] :
      ( v60174(VarCurr)
    <=> v60176(VarCurr) ) ).

tff(addAssignment_35355,axiom,
    ! [VarCurr: state_type] :
      ( v60176(VarCurr)
    <=> v60178(VarCurr) ) ).

tff(addAssignment_35354,axiom,
    ! [VarCurr: state_type] :
      ( v60178(VarCurr)
    <=> v60180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5720,axiom,
    ! [VarCurr: state_type] :
      ( v60180(VarCurr)
    <=> ( v60194(VarCurr)
      <~> v60190(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5719,axiom,
    ! [VarCurr: state_type] :
      ( v60194(VarCurr)
    <=> ( v60182(VarCurr)
      <~> v60186(VarCurr) ) ) ).

tff(addAssignment_35353,axiom,
    ! [VarCurr: state_type] :
      ( v60190(VarCurr)
    <=> v60192(VarCurr) ) ).

tff(addAssignment_35352,axiom,
    ! [VarCurr: state_type] :
      ( v60192(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_35351,axiom,
    ! [VarCurr: state_type] :
      ( v60186(VarCurr)
    <=> v60188(VarCurr) ) ).

tff(addAssignment_35350,axiom,
    ! [VarCurr: state_type] :
      ( v60188(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_35349,axiom,
    ! [VarCurr: state_type] :
      ( v60182(VarCurr)
    <=> v60184(VarCurr) ) ).

tff(addAssignment_35348,axiom,
    ! [VarCurr: state_type] :
      ( v60184(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_35347,axiom,
    ! [VarCurr: state_type] :
      ( v60148(VarCurr)
    <=> v60150(VarCurr) ) ).

tff(addAssignment_35346,axiom,
    ! [VarCurr: state_type] :
      ( v60150(VarCurr)
    <=> v60152(VarCurr) ) ).

tff(addAssignment_35345,axiom,
    ! [VarCurr: state_type] :
      ( v60152(VarCurr)
    <=> v60154(VarCurr) ) ).

tff(addAssignment_35344,axiom,
    ! [VarCurr: state_type] :
      ( v60154(VarCurr)
    <=> v60156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5718,axiom,
    ! [VarCurr: state_type] :
      ( v60156(VarCurr)
    <=> ( v60170(VarCurr)
      <~> v60166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5717,axiom,
    ! [VarCurr: state_type] :
      ( v60170(VarCurr)
    <=> ( v60158(VarCurr)
      <~> v60162(VarCurr) ) ) ).

tff(addAssignment_35343,axiom,
    ! [VarCurr: state_type] :
      ( v60166(VarCurr)
    <=> v60168(VarCurr) ) ).

tff(addAssignment_35342,axiom,
    ! [VarCurr: state_type] :
      ( v60168(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_35341,axiom,
    ! [VarCurr: state_type] :
      ( v60162(VarCurr)
    <=> v60164(VarCurr) ) ).

tff(addAssignment_35340,axiom,
    ! [VarCurr: state_type] :
      ( v60164(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_35339,axiom,
    ! [VarCurr: state_type] :
      ( v60158(VarCurr)
    <=> v60160(VarCurr) ) ).

tff(addAssignment_35338,axiom,
    ! [VarCurr: state_type] :
      ( v60160(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_35337,axiom,
    ! [VarCurr: state_type] :
      ( v60054(VarCurr)
    <=> v60056(VarCurr) ) ).

tff(addAssignment_35336,axiom,
    ! [VarCurr: state_type] :
      ( v60056(VarCurr)
    <=> v60058(VarCurr) ) ).

tff(addAssignment_35335,axiom,
    ! [VarCurr: state_type] :
      ( v60058(VarCurr)
    <=> v60060(VarCurr) ) ).

tff(addAssignment_35334,axiom,
    ! [VarCurr: state_type] :
      ( v60060(VarCurr)
    <=> v60062(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5716,axiom,
    ! [VarCurr: state_type] :
      ( v60062(VarCurr)
    <=> ( v60136(VarCurr)
      <~> v60112(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5715,axiom,
    ! [VarCurr: state_type] :
      ( v60136(VarCurr)
    <=> ( v60064(VarCurr)
      <~> v60088(VarCurr) ) ) ).

tff(addAssignment_35333,axiom,
    ! [VarCurr: state_type] :
      ( v60112(VarCurr)
    <=> v60114(VarCurr) ) ).

tff(addAssignment_35332,axiom,
    ! [VarCurr: state_type] :
      ( v60114(VarCurr)
    <=> v60116(VarCurr) ) ).

tff(addAssignment_35331,axiom,
    ! [VarCurr: state_type] :
      ( v60116(VarCurr)
    <=> v60118(VarCurr) ) ).

tff(addAssignment_35330,axiom,
    ! [VarCurr: state_type] :
      ( v60118(VarCurr)
    <=> v60120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5714,axiom,
    ! [VarCurr: state_type] :
      ( v60120(VarCurr)
    <=> ( v60134(VarCurr)
      <~> v60130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5713,axiom,
    ! [VarCurr: state_type] :
      ( v60134(VarCurr)
    <=> ( v60122(VarCurr)
      <~> v60126(VarCurr) ) ) ).

tff(addAssignment_35329,axiom,
    ! [VarCurr: state_type] :
      ( v60130(VarCurr)
    <=> v60132(VarCurr) ) ).

tff(addAssignment_35328,axiom,
    ! [VarCurr: state_type] :
      ( v60132(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_35327,axiom,
    ! [VarCurr: state_type] :
      ( v60126(VarCurr)
    <=> v60128(VarCurr) ) ).

tff(addAssignment_35326,axiom,
    ! [VarCurr: state_type] :
      ( v60128(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_35325,axiom,
    ! [VarCurr: state_type] :
      ( v60122(VarCurr)
    <=> v60124(VarCurr) ) ).

tff(addAssignment_35324,axiom,
    ! [VarCurr: state_type] :
      ( v60124(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_35323,axiom,
    ! [VarCurr: state_type] :
      ( v60088(VarCurr)
    <=> v60090(VarCurr) ) ).

tff(addAssignment_35322,axiom,
    ! [VarCurr: state_type] :
      ( v60090(VarCurr)
    <=> v60092(VarCurr) ) ).

tff(addAssignment_35321,axiom,
    ! [VarCurr: state_type] :
      ( v60092(VarCurr)
    <=> v60094(VarCurr) ) ).

tff(addAssignment_35320,axiom,
    ! [VarCurr: state_type] :
      ( v60094(VarCurr)
    <=> v60096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5712,axiom,
    ! [VarCurr: state_type] :
      ( v60096(VarCurr)
    <=> ( v60110(VarCurr)
      <~> v60106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5711,axiom,
    ! [VarCurr: state_type] :
      ( v60110(VarCurr)
    <=> ( v60098(VarCurr)
      <~> v60102(VarCurr) ) ) ).

tff(addAssignment_35319,axiom,
    ! [VarCurr: state_type] :
      ( v60106(VarCurr)
    <=> v60108(VarCurr) ) ).

tff(addAssignment_35318,axiom,
    ! [VarCurr: state_type] :
      ( v60108(VarCurr)
    <=> v6017(VarCurr,15) ) ).

tff(addAssignment_35317,axiom,
    ! [VarCurr: state_type] :
      ( v60102(VarCurr)
    <=> v60104(VarCurr) ) ).

tff(addAssignment_35316,axiom,
    ! [VarCurr: state_type] :
      ( v60104(VarCurr)
    <=> v6017(VarCurr,12) ) ).

tff(addAssignment_35315,axiom,
    ! [VarCurr: state_type] :
      ( v60098(VarCurr)
    <=> v60100(VarCurr) ) ).

tff(addAssignment_35314,axiom,
    ! [VarCurr: state_type] :
      ( v60100(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_35313,axiom,
    ! [VarCurr: state_type] :
      ( v60064(VarCurr)
    <=> v60066(VarCurr) ) ).

tff(addAssignment_35312,axiom,
    ! [VarCurr: state_type] :
      ( v60066(VarCurr)
    <=> v60068(VarCurr) ) ).

tff(addAssignment_35311,axiom,
    ! [VarCurr: state_type] :
      ( v60068(VarCurr)
    <=> v60070(VarCurr) ) ).

tff(addAssignment_35310,axiom,
    ! [VarCurr: state_type] :
      ( v60070(VarCurr)
    <=> v60072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5710,axiom,
    ! [VarCurr: state_type] :
      ( v60072(VarCurr)
    <=> ( v60086(VarCurr)
      <~> v60082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5709,axiom,
    ! [VarCurr: state_type] :
      ( v60086(VarCurr)
    <=> ( v60074(VarCurr)
      <~> v60078(VarCurr) ) ) ).

tff(addAssignment_35309,axiom,
    ! [VarCurr: state_type] :
      ( v60082(VarCurr)
    <=> v60084(VarCurr) ) ).

tff(addAssignment_35308,axiom,
    ! [VarCurr: state_type] :
      ( v60084(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_35307,axiom,
    ! [VarCurr: state_type] :
      ( v60078(VarCurr)
    <=> v60080(VarCurr) ) ).

tff(addAssignment_35306,axiom,
    ! [VarCurr: state_type] :
      ( v60080(VarCurr)
    <=> v6017(VarCurr,5) ) ).

tff(addAssignment_35305,axiom,
    ! [VarCurr: state_type] :
      ( v60074(VarCurr)
    <=> v60076(VarCurr) ) ).

tff(addAssignment_35304,axiom,
    ! [VarCurr: state_type] :
      ( v60076(VarCurr)
    <=> v6017(VarCurr,2) ) ).

tff(addAssignment_35303,axiom,
    ! [VarCurr: state_type] :
      ( v5921(VarCurr,2)
    <=> v5923(VarCurr,2) ) ).

tff(addAssignment_35302,axiom,
    ! [VarCurr: state_type] :
      ( v5923(VarCurr,2)
    <=> v59235(VarCurr,2) ) ).

tff(addAssignment_35301,axiom,
    ! [VarCurr: state_type] :
      ( v5911(VarCurr)
    <=> v5913(VarCurr) ) ).

tff(addAssignment_35300,axiom,
    ! [VarCurr: state_type] :
      ( v5913(VarCurr)
    <=> v5915(VarCurr,3) ) ).

tff(addAssignment_35299,axiom,
    ! [VarCurr: state_type] :
      ( v5915(VarCurr,3)
    <=> v5917(VarCurr,3) ) ).

tff(addAssignment_35298,axiom,
    ! [VarCurr: state_type] :
      ( v5917(VarCurr,3)
    <=> v5919(VarCurr,3) ) ).

tff(addAssignment_35297,axiom,
    ! [VarCurr: state_type] :
      ( v5919(VarCurr,3)
    <=> v60034(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v60034(VarCurr,B)
      <=> ( v5921(VarCurr,B)
          & v59238(VarCurr,B) ) ) ) ).

tff(addAssignment_35296,axiom,
    ! [VarCurr: state_type] :
      ( v59238(VarCurr,3)
    <=> v59240(VarCurr,3) ) ).

tff(addAssignment_35295,axiom,
    ! [VarCurr: state_type] :
      ( v59240(VarCurr,3)
    <=> v59242(VarCurr,3) ) ).

tff(addAssignment_35294,axiom,
    ! [VarCurr: state_type] :
      ( v59242(VarCurr,3)
    <=> v5977(VarCurr,15) ) ).

tff(addAssignment_35293,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,15)
    <=> v5979(VarCurr,15) ) ).

tff(addAssignment_35292,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,15)
    <=> v5981(VarCurr,15) ) ).

tff(addAssignment_35291,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,15)
    <=> v5983(VarCurr,15) ) ).

tff(addAssignment_35290,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,15)
    <=> v5985(VarCurr,15) ) ).

tff(addAssignment_35289,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,15)
    <=> v53672(VarCurr,15) ) ).

tff(addAssignment_35288,axiom,
    ! [VarCurr: state_type] :
      ( v53673(VarCurr,3)
    <=> v59245(VarCurr) ) ).

tff(addAssignment_35287,axiom,
    ! [VarCurr: state_type] :
      ( v59245(VarCurr)
    <=> v59247(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5708,axiom,
    ! [VarCurr: state_type] :
      ( v59247(VarCurr)
    <=> ( v60033(VarCurr)
      <~> v59777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5707,axiom,
    ! [VarCurr: state_type] :
      ( v60033(VarCurr)
    <=> ( v59249(VarCurr)
      <~> v59513(VarCurr) ) ) ).

tff(addAssignment_35286,axiom,
    ! [VarCurr: state_type] :
      ( v59777(VarCurr)
    <=> v59779(VarCurr) ) ).

tff(addAssignment_35285,axiom,
    ! [VarCurr: state_type] :
      ( v59779(VarCurr)
    <=> v59781(VarCurr) ) ).

tff(addAssignment_35284,axiom,
    ! [VarCurr: state_type] :
      ( v59781(VarCurr)
    <=> v59783(VarCurr) ) ).

tff(addAssignment_35283,axiom,
    ! [VarCurr: state_type] :
      ( v59783(VarCurr)
    <=> v59785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5706,axiom,
    ! [VarCurr: state_type] :
      ( v59785(VarCurr)
    <=> ( v60031(VarCurr)
      <~> v59895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5705,axiom,
    ! [VarCurr: state_type] :
      ( v60031(VarCurr)
    <=> ( v59787(VarCurr)
      <~> v59811(VarCurr) ) ) ).

tff(addAssignment_35282,axiom,
    ! [VarCurr: state_type] :
      ( v59895(VarCurr)
    <=> v59897(VarCurr) ) ).

tff(addAssignment_35281,axiom,
    ! [VarCurr: state_type] :
      ( v59897(VarCurr)
    <=> v59899(VarCurr,3) ) ).

tff(addAssignment_35280,axiom,
    ! [VarCurr: state_type] :
      ( v59899(VarCurr,3)
    <=> v59901(VarCurr,3) ) ).

tff(addAssignment_35279,axiom,
    ! [VarCurr: state_type] :
      ( v59901(VarCurr,3)
    <=> v53577(VarCurr,7) ) ).

tff(addAssignment_35278,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,7)
    <=> v53579(VarCurr,7) ) ).

tff(addAssignment_35277,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,7)
    <=> v60023(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60024(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v60023(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_759,axiom,
    ! [VarNext: state_type] :
      ( v60024(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v60023(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60024(VarNext)
      <=> v60025(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60025(VarNext)
      <=> ( v60027(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60027(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_35276,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,7)
    <=> v53603(VarCurr,7) ) ).

tff(addAssignment_35275,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,7)
    <=> v53632(VarCurr,7) ) ).

tff(addAssignment_35274,axiom,
    ! [VarCurr: state_type] :
      ( v53633(VarCurr)
    <=> v59904(VarCurr) ) ).

tff(addAssignment_35273,axiom,
    ! [VarCurr: state_type] :
      ( v59904(VarCurr)
    <=> v59906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5702,axiom,
    ! [VarCurr: state_type] :
      ( v59906(VarCurr)
    <=> ( v59908(VarCurr)
      <~> v59939(VarCurr) ) ) ).

tff(addAssignment_35272,axiom,
    ! [VarCurr: state_type] :
      ( v59939(VarCurr)
    <=> v59941(VarCurr) ) ).

tff(addAssignment_35271,axiom,
    ! [VarCurr: state_type] :
      ( v59941(VarCurr)
    <=> v59943(VarCurr) ) ).

tff(addAssignment_35270,axiom,
    ! [VarCurr: state_type] :
      ( v59943(VarCurr)
    <=> v59945(VarCurr) ) ).

tff(addAssignment_35269,axiom,
    ! [VarCurr: state_type] :
      ( v59945(VarCurr)
    <=> v59947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5701,axiom,
    ! [VarCurr: state_type] :
      ( v59947(VarCurr)
    <=> ( v60019(VarCurr)
        & v2036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5700,axiom,
    ! [VarCurr: state_type] :
      ( v60019(VarCurr)
    <=> ( v59949(VarCurr)
        & v60020(VarCurr) ) ) ).

tff(writeUnaryOperator_3157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v60020(VarCurr)
    <=> v59955(VarCurr,0) ) ).

tff(addAssignment_35268,axiom,
    ! [VarCurr: state_type] :
      ( v59955(VarCurr,0)
    <=> v59957(VarCurr,0) ) ).

tff(addAssignment_35267,axiom,
    ! [VarCurr: state_type] :
      ( v59957(VarCurr,0)
    <=> v59959(VarCurr,0) ) ).

tff(addAssignment_35266,axiom,
    ! [VarNext: state_type] :
      ( v59959(VarNext,0)
    <=> v60001(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60002(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v60001(VarNext,B)
            <=> v59959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_758,axiom,
    ! [VarNext: state_type] :
      ( v60002(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v60001(VarNext,B)
          <=> v60012(VarNext,B) ) ) ) ).

tff(addAssignment_35265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v60012(VarNext,B)
          <=> v60010(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v60013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v60010(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_399,axiom,
    ! [VarCurr: state_type] :
      ( v60013(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v60010(VarCurr,B)
          <=> v59969(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5699,axiom,
    ! [VarCurr: state_type] :
      ( v60013(VarCurr)
    <=> ( v60014(VarCurr)
        & v60015(VarCurr) ) ) ).

tff(writeUnaryOperator_3156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v60015(VarCurr)
    <=> v59965(VarCurr) ) ).

tff(writeUnaryOperator_3155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v60014(VarCurr)
    <=> v59961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60002(VarNext)
      <=> v60003(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60003(VarNext)
      <=> ( v60004(VarNext)
          & v59997(VarNext) ) ) ) ).

tff(writeUnaryOperator_3154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v60004(VarNext)
      <=> v60006(VarNext) ) ) ).

tff(addAssignment_35264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v60006(VarNext)
      <=> v59997(VarCurr) ) ) ).

tff(addAssignment_35263,axiom,
    ! [VarCurr: state_type] :
      ( v59997(VarCurr)
    <=> v59999(VarCurr) ) ).

tff(addAssignment_35262,axiom,
    ! [VarCurr: state_type] :
      ( v59999(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_35261,axiom,
    ! [VarCurr: state_type] :
      ( v59969(VarCurr,0)
    <=> v59971(VarCurr,0) ) ).

tff(addAssignment_35260,axiom,
    ! [VarCurr: state_type] :
      ( v59971(VarCurr,0)
    <=> v59988(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v59988(VarCurr,B)
      <=> ( v59989(VarCurr,B)
          | v59992(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v59992(VarCurr,B)
      <=> ( v59957(VarCurr,B)
          & v59993(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_3153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v59993(VarCurr,B)
      <=> ~ v59994(VarCurr,B) ) ) ).

tff(addAssignment_35259,axiom,
    ! [VarCurr: state_type] :
      ( v59994(VarCurr,0)
    <=> v59995(VarCurr) ) ).

tff(addAssignment_35258,axiom,
    ! [VarCurr: state_type] :
      ( v59994(VarCurr,1)
    <=> v59995(VarCurr) ) ).

tff(addAssignment_35257,axiom,
    ! [VarCurr: state_type] :
      ( v59995(VarCurr)
    <=> v59987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v59989(VarCurr,B)
      <=> ( v59973(VarCurr,B)
          & v59990(VarCurr,B) ) ) ) ).

tff(addAssignment_35256,axiom,
    ! [VarCurr: state_type] :
      ( v59990(VarCurr,0)
    <=> v59991(VarCurr) ) ).

tff(addAssignment_35255,axiom,
    ! [VarCurr: state_type] :
      ( v59990(VarCurr,1)
    <=> v59991(VarCurr) ) ).

tff(addAssignment_35254,axiom,
    ! [VarCurr: state_type] :
      ( v59991(VarCurr)
    <=> v59987(VarCurr) ) ).

tff(addAssignment_35253,axiom,
    ! [VarCurr: state_type] :
      ( v59987(VarCurr)
    <=> v2036(VarCurr) ) ).

tff(addAssignment_35252,axiom,
    ! [VarCurr: state_type] :
      ( v59973(VarCurr,0)
    <=> v59975(VarCurr,0) ) ).

tff(addAssignment_35251,axiom,
    ! [VarCurr: state_type] :
      ( v59975(VarCurr,0)
    <=> v59976(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v59976(VarCurr,B)
          <=> v59984(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_398,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v59976(VarCurr,B)
          <=> v59977(VarCurr,B) ) ) ) ).

tff(addAssignment_35250,axiom,
    ! [VarCurr: state_type] :
      ( v59984(VarCurr,0)
    <=> v59985(VarCurr) ) ).

tff(addAssignment_35249,axiom,
    ! [VarCurr: state_type] :
      ( v59984(VarCurr,1)
    <=> $false ) ).

tff(writeUnaryOperator_3152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59985(VarCurr)
    <=> v59955(VarCurr,0) ) ).

tff(addAssignment_35248,axiom,
    ! [VarCurr: state_type] :
      ( v59977(VarCurr,0)
    <=> v59981(VarCurr) ) ).

tff(addAssignment_35247,axiom,
    ! [VarCurr: state_type] :
      ( v59977(VarCurr,1)
    <=> v59979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5696,axiom,
    ! [VarCurr: state_type] :
      ( v59979(VarCurr)
    <=> ( v59980(VarCurr)
        & v59983(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_592,axiom,
    ! [VarCurr: state_type] :
      ( v59983(VarCurr)
    <=> ( v59955(VarCurr,0)
        | v59955(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5695,axiom,
    ! [VarCurr: state_type] :
      ( v59980(VarCurr)
    <=> ( v59981(VarCurr)
        | v59982(VarCurr) ) ) ).

tff(writeUnaryOperator_3151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59982(VarCurr)
    <=> v59955(VarCurr,1) ) ).

tff(writeUnaryOperator_3150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59981(VarCurr)
    <=> v59955(VarCurr,0) ) ).

tff(addAssignment_35246,axiom,
    ! [VarCurr: state_type] :
      ( v59965(VarCurr)
    <=> v59967(VarCurr) ) ).

tff(addAssignment_35245,axiom,
    ! [VarCurr: state_type] :
      ( v59967(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_35244,axiom,
    ! [VarCurr: state_type] :
      ( v59961(VarCurr)
    <=> v59963(VarCurr) ) ).

tff(addAssignment_35243,axiom,
    ! [VarCurr: state_type] :
      ( v59963(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_35242,axiom,
    ! [VarCurr: state_type] :
      ( v59949(VarCurr)
    <=> v59951(VarCurr) ) ).

tff(addAssignment_35241,axiom,
    ! [VarCurr: state_type] :
      ( v59951(VarCurr)
    <=> v59953(VarCurr) ) ).

tff(addAssignment_35240,axiom,
    ! [VarCurr: state_type] :
      ( v59908(VarCurr)
    <=> v59910(VarCurr) ) ).

tff(addAssignment_35239,axiom,
    ! [VarCurr: state_type] :
      ( v59910(VarCurr)
    <=> v53526(VarCurr,15) ) ).

tff(addAssignment_35238,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,15)
    <=> v59912(VarCurr,3) ) ).

tff(addAssignment_35237,axiom,
    ! [VarCurr: state_type] :
      ( v59912(VarCurr,3)
    <=> v59914(VarCurr,3) ) ).

tff(addAssignment_35236,axiom,
    ! [VarCurr: state_type] :
      ( v59914(VarCurr,3)
    <=> v59931(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v59931(VarCurr,B)
      <=> ( v59932(VarCurr,B)
          | v59935(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v59935(VarCurr,B)
      <=> ( v59924(VarCurr,B)
          & v59936(VarCurr,B) ) ) ) ).

tff(addAssignment_35235,axiom,
    ! [VarCurr: state_type] :
      ( v59936(VarCurr,0)
    <=> v59937(VarCurr) ) ).

tff(addAssignment_35234,axiom,
    ! [VarCurr: state_type] :
      ( v59936(VarCurr,1)
    <=> v59937(VarCurr) ) ).

tff(addAssignment_35233,axiom,
    ! [VarCurr: state_type] :
      ( v59936(VarCurr,2)
    <=> v59937(VarCurr) ) ).

tff(addAssignment_35232,axiom,
    ! [VarCurr: state_type] :
      ( v59936(VarCurr,3)
    <=> v59937(VarCurr) ) ).

tff(addAssignment_35231,axiom,
    ! [VarCurr: state_type] :
      ( v59937(VarCurr)
    <=> v59928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v59932(VarCurr,B)
      <=> ( v59916(VarCurr,B)
          & v59933(VarCurr,B) ) ) ) ).

tff(addAssignment_35230,axiom,
    ! [VarCurr: state_type] :
      ( v59933(VarCurr,0)
    <=> v59934(VarCurr) ) ).

tff(addAssignment_35229,axiom,
    ! [VarCurr: state_type] :
      ( v59933(VarCurr,1)
    <=> v59934(VarCurr) ) ).

tff(addAssignment_35228,axiom,
    ! [VarCurr: state_type] :
      ( v59933(VarCurr,2)
    <=> v59934(VarCurr) ) ).

tff(addAssignment_35227,axiom,
    ! [VarCurr: state_type] :
      ( v59933(VarCurr,3)
    <=> v59934(VarCurr) ) ).

tff(addAssignment_35226,axiom,
    ! [VarCurr: state_type] :
      ( v59934(VarCurr)
    <=> v59920(VarCurr) ) ).

tff(addAssignment_35225,axiom,
    ! [VarCurr: state_type] :
      ( v59928(VarCurr)
    <=> v59930(VarCurr) ) ).

tff(addAssignment_35224,axiom,
    ! [VarCurr: state_type] :
      ( v59930(VarCurr)
    <=> v52379(VarCurr,32) ) ).

tff(addAssignment_35223,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,32)
    <=> v52381(VarCurr,32) ) ).

tff(addAssignment_35222,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,32)
    <=> v52383(VarCurr,32) ) ).

tff(addAssignment_35221,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,32)
    <=> v52384(VarCurr,32) ) ).

tff(addAssignment_35220,axiom,
    ! [VarCurr: state_type] :
      ( v59924(VarCurr,3)
    <=> v59926(VarCurr,3) ) ).

tff(addAssignment_35219,axiom,
    ! [VarCurr: state_type] :
      ( v59926(VarCurr,3)
    <=> v53312(VarCurr,15) ) ).

tff(addAssignment_35218,axiom,
    ! [VarCurr: state_type] :
      ( v59920(VarCurr)
    <=> v59922(VarCurr) ) ).

tff(addAssignment_35217,axiom,
    ! [VarCurr: state_type] :
      ( v59922(VarCurr)
    <=> v52361(VarCurr,32) ) ).

tff(addAssignment_35216,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,32)
    <=> v52363(VarCurr,32) ) ).

tff(addAssignment_35215,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,32)
    <=> v52365(VarCurr,32) ) ).

tff(addAssignment_35214,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,32)
    <=> v52367(VarCurr,32) ) ).

tff(addAssignment_35213,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,32)
    <=> v52369(VarCurr,32) ) ).

tff(addAssignment_35212,axiom,
    ! [VarCurr: state_type] :
      ( v59916(VarCurr,3)
    <=> v59918(VarCurr,3) ) ).

tff(addAssignment_35211,axiom,
    ! [VarCurr: state_type] :
      ( v59918(VarCurr,3)
    <=> v53312(VarCurr,11) ) ).

tff(addAssignment_35210,axiom,
    ! [VarCurr: state_type] :
      ( v59811(VarCurr)
    <=> v59813(VarCurr) ) ).

tff(addAssignment_35209,axiom,
    ! [VarCurr: state_type] :
      ( v59813(VarCurr)
    <=> v59815(VarCurr) ) ).

tff(addAssignment_35208,axiom,
    ! [VarCurr: state_type] :
      ( v59815(VarCurr)
    <=> v59817(VarCurr) ) ).

tff(addAssignment_35207,axiom,
    ! [VarCurr: state_type] :
      ( v59817(VarCurr)
    <=> v59819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5694,axiom,
    ! [VarCurr: state_type] :
      ( v59819(VarCurr)
    <=> ( v59893(VarCurr)
      <~> v59869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5693,axiom,
    ! [VarCurr: state_type] :
      ( v59893(VarCurr)
    <=> ( v59821(VarCurr)
      <~> v59845(VarCurr) ) ) ).

tff(addAssignment_35206,axiom,
    ! [VarCurr: state_type] :
      ( v59869(VarCurr)
    <=> v59871(VarCurr) ) ).

tff(addAssignment_35205,axiom,
    ! [VarCurr: state_type] :
      ( v59871(VarCurr)
    <=> v59873(VarCurr) ) ).

tff(addAssignment_35204,axiom,
    ! [VarCurr: state_type] :
      ( v59873(VarCurr)
    <=> v59875(VarCurr) ) ).

tff(addAssignment_35203,axiom,
    ! [VarCurr: state_type] :
      ( v59875(VarCurr)
    <=> v59877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5692,axiom,
    ! [VarCurr: state_type] :
      ( v59877(VarCurr)
    <=> ( v59891(VarCurr)
      <~> v59887(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5691,axiom,
    ! [VarCurr: state_type] :
      ( v59891(VarCurr)
    <=> ( v59879(VarCurr)
      <~> v59883(VarCurr) ) ) ).

tff(addAssignment_35202,axiom,
    ! [VarCurr: state_type] :
      ( v59887(VarCurr)
    <=> v59889(VarCurr) ) ).

tff(addAssignment_35201,axiom,
    ! [VarCurr: state_type] :
      ( v59889(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_35200,axiom,
    ! [VarCurr: state_type] :
      ( v59883(VarCurr)
    <=> v59885(VarCurr) ) ).

tff(addAssignment_35199,axiom,
    ! [VarCurr: state_type] :
      ( v59885(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_35198,axiom,
    ! [VarCurr: state_type] :
      ( v59879(VarCurr)
    <=> v59881(VarCurr) ) ).

tff(addAssignment_35197,axiom,
    ! [VarCurr: state_type] :
      ( v59881(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_35196,axiom,
    ! [VarCurr: state_type] :
      ( v59845(VarCurr)
    <=> v59847(VarCurr) ) ).

tff(addAssignment_35195,axiom,
    ! [VarCurr: state_type] :
      ( v59847(VarCurr)
    <=> v59849(VarCurr) ) ).

tff(addAssignment_35194,axiom,
    ! [VarCurr: state_type] :
      ( v59849(VarCurr)
    <=> v59851(VarCurr) ) ).

tff(addAssignment_35193,axiom,
    ! [VarCurr: state_type] :
      ( v59851(VarCurr)
    <=> v59853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5690,axiom,
    ! [VarCurr: state_type] :
      ( v59853(VarCurr)
    <=> ( v59867(VarCurr)
      <~> v59863(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5689,axiom,
    ! [VarCurr: state_type] :
      ( v59867(VarCurr)
    <=> ( v59855(VarCurr)
      <~> v59859(VarCurr) ) ) ).

tff(addAssignment_35192,axiom,
    ! [VarCurr: state_type] :
      ( v59863(VarCurr)
    <=> v59865(VarCurr) ) ).

tff(addAssignment_35191,axiom,
    ! [VarCurr: state_type] :
      ( v59865(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_35190,axiom,
    ! [VarCurr: state_type] :
      ( v59859(VarCurr)
    <=> v59861(VarCurr) ) ).

tff(addAssignment_35189,axiom,
    ! [VarCurr: state_type] :
      ( v59861(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_35188,axiom,
    ! [VarCurr: state_type] :
      ( v59855(VarCurr)
    <=> v59857(VarCurr) ) ).

tff(addAssignment_35187,axiom,
    ! [VarCurr: state_type] :
      ( v59857(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_35186,axiom,
    ! [VarCurr: state_type] :
      ( v59821(VarCurr)
    <=> v59823(VarCurr) ) ).

tff(addAssignment_35185,axiom,
    ! [VarCurr: state_type] :
      ( v59823(VarCurr)
    <=> v59825(VarCurr) ) ).

tff(addAssignment_35184,axiom,
    ! [VarCurr: state_type] :
      ( v59825(VarCurr)
    <=> v59827(VarCurr) ) ).

tff(addAssignment_35183,axiom,
    ! [VarCurr: state_type] :
      ( v59827(VarCurr)
    <=> v59829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5688,axiom,
    ! [VarCurr: state_type] :
      ( v59829(VarCurr)
    <=> ( v59843(VarCurr)
      <~> v59839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5687,axiom,
    ! [VarCurr: state_type] :
      ( v59843(VarCurr)
    <=> ( v59831(VarCurr)
      <~> v59835(VarCurr) ) ) ).

tff(addAssignment_35182,axiom,
    ! [VarCurr: state_type] :
      ( v59839(VarCurr)
    <=> v59841(VarCurr) ) ).

tff(addAssignment_35181,axiom,
    ! [VarCurr: state_type] :
      ( v59841(VarCurr)
    <=> v6017(VarCurr,109) ) ).

tff(addAssignment_35180,axiom,
    ! [VarCurr: state_type] :
      ( v59835(VarCurr)
    <=> v59837(VarCurr) ) ).

tff(addAssignment_35179,axiom,
    ! [VarCurr: state_type] :
      ( v59837(VarCurr)
    <=> v6017(VarCurr,108) ) ).

tff(addAssignment_35178,axiom,
    ! [VarCurr: state_type] :
      ( v59831(VarCurr)
    <=> v59833(VarCurr) ) ).

tff(addAssignment_35177,axiom,
    ! [VarCurr: state_type] :
      ( v59833(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_35176,axiom,
    ! [VarCurr: state_type] :
      ( v59787(VarCurr)
    <=> v59789(VarCurr) ) ).

tff(addAssignment_35175,axiom,
    ! [VarCurr: state_type] :
      ( v59789(VarCurr)
    <=> v59791(VarCurr) ) ).

tff(addAssignment_35174,axiom,
    ! [VarCurr: state_type] :
      ( v59791(VarCurr)
    <=> v59793(VarCurr) ) ).

tff(addAssignment_35173,axiom,
    ! [VarCurr: state_type] :
      ( v59793(VarCurr)
    <=> v59795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5686,axiom,
    ! [VarCurr: state_type] :
      ( v59795(VarCurr)
    <=> ( v59809(VarCurr)
      <~> v59805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5685,axiom,
    ! [VarCurr: state_type] :
      ( v59809(VarCurr)
    <=> ( v59797(VarCurr)
      <~> v59801(VarCurr) ) ) ).

tff(addAssignment_35172,axiom,
    ! [VarCurr: state_type] :
      ( v59805(VarCurr)
    <=> v59807(VarCurr) ) ).

tff(addAssignment_35171,axiom,
    ! [VarCurr: state_type] :
      ( v59807(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_35170,axiom,
    ! [VarCurr: state_type] :
      ( v59801(VarCurr)
    <=> v59803(VarCurr) ) ).

tff(addAssignment_35169,axiom,
    ! [VarCurr: state_type] :
      ( v59803(VarCurr)
    <=> v6017(VarCurr,127) ) ).

tff(addAssignment_35168,axiom,
    ! [VarCurr: state_type] :
      ( v59797(VarCurr)
    <=> v59799(VarCurr) ) ).

tff(addAssignment_35167,axiom,
    ! [VarCurr: state_type] :
      ( v59799(VarCurr)
    <=> v6017(VarCurr,118) ) ).

tff(addAssignment_35166,axiom,
    ! [VarCurr: state_type] :
      ( v59513(VarCurr)
    <=> v59515(VarCurr) ) ).

tff(addAssignment_35165,axiom,
    ! [VarCurr: state_type] :
      ( v59515(VarCurr)
    <=> v59517(VarCurr) ) ).

tff(addAssignment_35164,axiom,
    ! [VarCurr: state_type] :
      ( v59517(VarCurr)
    <=> v59519(VarCurr) ) ).

tff(addAssignment_35163,axiom,
    ! [VarCurr: state_type] :
      ( v59519(VarCurr)
    <=> v59521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5684,axiom,
    ! [VarCurr: state_type] :
      ( v59521(VarCurr)
    <=> ( v59775(VarCurr)
      <~> v59691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5683,axiom,
    ! [VarCurr: state_type] :
      ( v59775(VarCurr)
    <=> ( v59523(VarCurr)
      <~> v59607(VarCurr) ) ) ).

tff(addAssignment_35162,axiom,
    ! [VarCurr: state_type] :
      ( v59691(VarCurr)
    <=> v59693(VarCurr) ) ).

tff(addAssignment_35161,axiom,
    ! [VarCurr: state_type] :
      ( v59693(VarCurr)
    <=> v59695(VarCurr) ) ).

tff(addAssignment_35160,axiom,
    ! [VarCurr: state_type] :
      ( v59695(VarCurr)
    <=> v59697(VarCurr) ) ).

tff(addAssignment_35159,axiom,
    ! [VarCurr: state_type] :
      ( v59697(VarCurr)
    <=> v59699(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5682,axiom,
    ! [VarCurr: state_type] :
      ( v59699(VarCurr)
    <=> ( v59773(VarCurr)
      <~> v59749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5681,axiom,
    ! [VarCurr: state_type] :
      ( v59773(VarCurr)
    <=> ( v59701(VarCurr)
      <~> v59725(VarCurr) ) ) ).

tff(addAssignment_35158,axiom,
    ! [VarCurr: state_type] :
      ( v59749(VarCurr)
    <=> v59751(VarCurr) ) ).

tff(addAssignment_35157,axiom,
    ! [VarCurr: state_type] :
      ( v59751(VarCurr)
    <=> v59753(VarCurr) ) ).

tff(addAssignment_35156,axiom,
    ! [VarCurr: state_type] :
      ( v59753(VarCurr)
    <=> v59755(VarCurr) ) ).

tff(addAssignment_35155,axiom,
    ! [VarCurr: state_type] :
      ( v59755(VarCurr)
    <=> v59757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5680,axiom,
    ! [VarCurr: state_type] :
      ( v59757(VarCurr)
    <=> ( v59771(VarCurr)
      <~> v59767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5679,axiom,
    ! [VarCurr: state_type] :
      ( v59771(VarCurr)
    <=> ( v59759(VarCurr)
      <~> v59763(VarCurr) ) ) ).

tff(addAssignment_35154,axiom,
    ! [VarCurr: state_type] :
      ( v59767(VarCurr)
    <=> v59769(VarCurr) ) ).

tff(addAssignment_35153,axiom,
    ! [VarCurr: state_type] :
      ( v59769(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_35152,axiom,
    ! [VarCurr: state_type] :
      ( v59763(VarCurr)
    <=> v59765(VarCurr) ) ).

tff(addAssignment_35151,axiom,
    ! [VarCurr: state_type] :
      ( v59765(VarCurr)
    <=> v6017(VarCurr,104) ) ).

tff(addAssignment_35150,axiom,
    ! [VarCurr: state_type] :
      ( v59759(VarCurr)
    <=> v59761(VarCurr) ) ).

tff(addAssignment_35149,axiom,
    ! [VarCurr: state_type] :
      ( v59761(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_35148,axiom,
    ! [VarCurr: state_type] :
      ( v59725(VarCurr)
    <=> v59727(VarCurr) ) ).

tff(addAssignment_35147,axiom,
    ! [VarCurr: state_type] :
      ( v59727(VarCurr)
    <=> v59729(VarCurr) ) ).

tff(addAssignment_35146,axiom,
    ! [VarCurr: state_type] :
      ( v59729(VarCurr)
    <=> v59731(VarCurr) ) ).

tff(addAssignment_35145,axiom,
    ! [VarCurr: state_type] :
      ( v59731(VarCurr)
    <=> v59733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5678,axiom,
    ! [VarCurr: state_type] :
      ( v59733(VarCurr)
    <=> ( v59747(VarCurr)
      <~> v59743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5677,axiom,
    ! [VarCurr: state_type] :
      ( v59747(VarCurr)
    <=> ( v59735(VarCurr)
      <~> v59739(VarCurr) ) ) ).

tff(addAssignment_35144,axiom,
    ! [VarCurr: state_type] :
      ( v59743(VarCurr)
    <=> v59745(VarCurr) ) ).

tff(addAssignment_35143,axiom,
    ! [VarCurr: state_type] :
      ( v59745(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_35142,axiom,
    ! [VarCurr: state_type] :
      ( v59739(VarCurr)
    <=> v59741(VarCurr) ) ).

tff(addAssignment_35141,axiom,
    ! [VarCurr: state_type] :
      ( v59741(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_35140,axiom,
    ! [VarCurr: state_type] :
      ( v59735(VarCurr)
    <=> v59737(VarCurr) ) ).

tff(addAssignment_35139,axiom,
    ! [VarCurr: state_type] :
      ( v59737(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_35138,axiom,
    ! [VarCurr: state_type] :
      ( v59701(VarCurr)
    <=> v59703(VarCurr) ) ).

tff(addAssignment_35137,axiom,
    ! [VarCurr: state_type] :
      ( v59703(VarCurr)
    <=> v59705(VarCurr) ) ).

tff(addAssignment_35136,axiom,
    ! [VarCurr: state_type] :
      ( v59705(VarCurr)
    <=> v59707(VarCurr) ) ).

tff(addAssignment_35135,axiom,
    ! [VarCurr: state_type] :
      ( v59707(VarCurr)
    <=> v59709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5676,axiom,
    ! [VarCurr: state_type] :
      ( v59709(VarCurr)
    <=> ( v59723(VarCurr)
      <~> v59719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5675,axiom,
    ! [VarCurr: state_type] :
      ( v59723(VarCurr)
    <=> ( v59711(VarCurr)
      <~> v59715(VarCurr) ) ) ).

tff(addAssignment_35134,axiom,
    ! [VarCurr: state_type] :
      ( v59719(VarCurr)
    <=> v59721(VarCurr) ) ).

tff(addAssignment_35133,axiom,
    ! [VarCurr: state_type] :
      ( v59721(VarCurr)
    <=> v6017(VarCurr,96) ) ).

tff(addAssignment_35132,axiom,
    ! [VarCurr: state_type] :
      ( v59715(VarCurr)
    <=> v59717(VarCurr) ) ).

tff(addAssignment_35131,axiom,
    ! [VarCurr: state_type] :
      ( v59717(VarCurr)
    <=> v6017(VarCurr,92) ) ).

tff(addAssignment_35130,axiom,
    ! [VarCurr: state_type] :
      ( v59711(VarCurr)
    <=> v59713(VarCurr) ) ).

tff(addAssignment_35129,axiom,
    ! [VarCurr: state_type] :
      ( v59713(VarCurr)
    <=> v6017(VarCurr,91) ) ).

tff(addAssignment_35128,axiom,
    ! [VarCurr: state_type] :
      ( v59607(VarCurr)
    <=> v59609(VarCurr) ) ).

tff(addAssignment_35127,axiom,
    ! [VarCurr: state_type] :
      ( v59609(VarCurr)
    <=> v59611(VarCurr) ) ).

tff(addAssignment_35126,axiom,
    ! [VarCurr: state_type] :
      ( v59611(VarCurr)
    <=> v59613(VarCurr) ) ).

tff(addAssignment_35125,axiom,
    ! [VarCurr: state_type] :
      ( v59613(VarCurr)
    <=> v59615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5674,axiom,
    ! [VarCurr: state_type] :
      ( v59615(VarCurr)
    <=> ( v59689(VarCurr)
      <~> v59665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5673,axiom,
    ! [VarCurr: state_type] :
      ( v59689(VarCurr)
    <=> ( v59617(VarCurr)
      <~> v59641(VarCurr) ) ) ).

tff(addAssignment_35124,axiom,
    ! [VarCurr: state_type] :
      ( v59665(VarCurr)
    <=> v59667(VarCurr) ) ).

tff(addAssignment_35123,axiom,
    ! [VarCurr: state_type] :
      ( v59667(VarCurr)
    <=> v59669(VarCurr) ) ).

tff(addAssignment_35122,axiom,
    ! [VarCurr: state_type] :
      ( v59669(VarCurr)
    <=> v59671(VarCurr) ) ).

tff(addAssignment_35121,axiom,
    ! [VarCurr: state_type] :
      ( v59671(VarCurr)
    <=> v59673(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5672,axiom,
    ! [VarCurr: state_type] :
      ( v59673(VarCurr)
    <=> ( v59687(VarCurr)
      <~> v59683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5671,axiom,
    ! [VarCurr: state_type] :
      ( v59687(VarCurr)
    <=> ( v59675(VarCurr)
      <~> v59679(VarCurr) ) ) ).

tff(addAssignment_35120,axiom,
    ! [VarCurr: state_type] :
      ( v59683(VarCurr)
    <=> v59685(VarCurr) ) ).

tff(addAssignment_35119,axiom,
    ! [VarCurr: state_type] :
      ( v59685(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_35118,axiom,
    ! [VarCurr: state_type] :
      ( v59679(VarCurr)
    <=> v59681(VarCurr) ) ).

tff(addAssignment_35117,axiom,
    ! [VarCurr: state_type] :
      ( v59681(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_35116,axiom,
    ! [VarCurr: state_type] :
      ( v59675(VarCurr)
    <=> v59677(VarCurr) ) ).

tff(addAssignment_35115,axiom,
    ! [VarCurr: state_type] :
      ( v59677(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_35114,axiom,
    ! [VarCurr: state_type] :
      ( v59641(VarCurr)
    <=> v59643(VarCurr) ) ).

tff(addAssignment_35113,axiom,
    ! [VarCurr: state_type] :
      ( v59643(VarCurr)
    <=> v59645(VarCurr) ) ).

tff(addAssignment_35112,axiom,
    ! [VarCurr: state_type] :
      ( v59645(VarCurr)
    <=> v59647(VarCurr) ) ).

tff(addAssignment_35111,axiom,
    ! [VarCurr: state_type] :
      ( v59647(VarCurr)
    <=> v59649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5670,axiom,
    ! [VarCurr: state_type] :
      ( v59649(VarCurr)
    <=> ( v59663(VarCurr)
      <~> v59659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5669,axiom,
    ! [VarCurr: state_type] :
      ( v59663(VarCurr)
    <=> ( v59651(VarCurr)
      <~> v59655(VarCurr) ) ) ).

tff(addAssignment_35110,axiom,
    ! [VarCurr: state_type] :
      ( v59659(VarCurr)
    <=> v59661(VarCurr) ) ).

tff(addAssignment_35109,axiom,
    ! [VarCurr: state_type] :
      ( v59661(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_35108,axiom,
    ! [VarCurr: state_type] :
      ( v59655(VarCurr)
    <=> v59657(VarCurr) ) ).

tff(addAssignment_35107,axiom,
    ! [VarCurr: state_type] :
      ( v59657(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_35106,axiom,
    ! [VarCurr: state_type] :
      ( v59651(VarCurr)
    <=> v59653(VarCurr) ) ).

tff(addAssignment_35105,axiom,
    ! [VarCurr: state_type] :
      ( v59653(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_35104,axiom,
    ! [VarCurr: state_type] :
      ( v59617(VarCurr)
    <=> v59619(VarCurr) ) ).

tff(addAssignment_35103,axiom,
    ! [VarCurr: state_type] :
      ( v59619(VarCurr)
    <=> v59621(VarCurr) ) ).

tff(addAssignment_35102,axiom,
    ! [VarCurr: state_type] :
      ( v59621(VarCurr)
    <=> v59623(VarCurr) ) ).

tff(addAssignment_35101,axiom,
    ! [VarCurr: state_type] :
      ( v59623(VarCurr)
    <=> v59625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5668,axiom,
    ! [VarCurr: state_type] :
      ( v59625(VarCurr)
    <=> ( v59639(VarCurr)
      <~> v59635(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5667,axiom,
    ! [VarCurr: state_type] :
      ( v59639(VarCurr)
    <=> ( v59627(VarCurr)
      <~> v59631(VarCurr) ) ) ).

tff(addAssignment_35100,axiom,
    ! [VarCurr: state_type] :
      ( v59635(VarCurr)
    <=> v59637(VarCurr) ) ).

tff(addAssignment_35099,axiom,
    ! [VarCurr: state_type] :
      ( v59637(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_35098,axiom,
    ! [VarCurr: state_type] :
      ( v59631(VarCurr)
    <=> v59633(VarCurr) ) ).

tff(addAssignment_35097,axiom,
    ! [VarCurr: state_type] :
      ( v59633(VarCurr)
    <=> v6017(VarCurr,77) ) ).

tff(addAssignment_35096,axiom,
    ! [VarCurr: state_type] :
      ( v59627(VarCurr)
    <=> v59629(VarCurr) ) ).

tff(addAssignment_35095,axiom,
    ! [VarCurr: state_type] :
      ( v59629(VarCurr)
    <=> v6017(VarCurr,73) ) ).

tff(addAssignment_35094,axiom,
    ! [VarCurr: state_type] :
      ( v59523(VarCurr)
    <=> v59525(VarCurr) ) ).

tff(addAssignment_35093,axiom,
    ! [VarCurr: state_type] :
      ( v59525(VarCurr)
    <=> v59527(VarCurr) ) ).

tff(addAssignment_35092,axiom,
    ! [VarCurr: state_type] :
      ( v59527(VarCurr)
    <=> v59529(VarCurr) ) ).

tff(addAssignment_35091,axiom,
    ! [VarCurr: state_type] :
      ( v59529(VarCurr)
    <=> v59531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5666,axiom,
    ! [VarCurr: state_type] :
      ( v59531(VarCurr)
    <=> ( v59605(VarCurr)
      <~> v59581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5665,axiom,
    ! [VarCurr: state_type] :
      ( v59605(VarCurr)
    <=> ( v59533(VarCurr)
      <~> v59557(VarCurr) ) ) ).

tff(addAssignment_35090,axiom,
    ! [VarCurr: state_type] :
      ( v59581(VarCurr)
    <=> v59583(VarCurr) ) ).

tff(addAssignment_35089,axiom,
    ! [VarCurr: state_type] :
      ( v59583(VarCurr)
    <=> v59585(VarCurr) ) ).

tff(addAssignment_35088,axiom,
    ! [VarCurr: state_type] :
      ( v59585(VarCurr)
    <=> v59587(VarCurr) ) ).

tff(addAssignment_35087,axiom,
    ! [VarCurr: state_type] :
      ( v59587(VarCurr)
    <=> v59589(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5664,axiom,
    ! [VarCurr: state_type] :
      ( v59589(VarCurr)
    <=> ( v59603(VarCurr)
      <~> v59599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5663,axiom,
    ! [VarCurr: state_type] :
      ( v59603(VarCurr)
    <=> ( v59591(VarCurr)
      <~> v59595(VarCurr) ) ) ).

tff(addAssignment_35086,axiom,
    ! [VarCurr: state_type] :
      ( v59599(VarCurr)
    <=> v59601(VarCurr) ) ).

tff(addAssignment_35085,axiom,
    ! [VarCurr: state_type] :
      ( v59601(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_35084,axiom,
    ! [VarCurr: state_type] :
      ( v59595(VarCurr)
    <=> v59597(VarCurr) ) ).

tff(addAssignment_35083,axiom,
    ! [VarCurr: state_type] :
      ( v59597(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_35082,axiom,
    ! [VarCurr: state_type] :
      ( v59591(VarCurr)
    <=> v59593(VarCurr) ) ).

tff(addAssignment_35081,axiom,
    ! [VarCurr: state_type] :
      ( v59593(VarCurr)
    <=> v6017(VarCurr,66) ) ).

tff(addAssignment_35080,axiom,
    ! [VarCurr: state_type] :
      ( v59557(VarCurr)
    <=> v59559(VarCurr) ) ).

tff(addAssignment_35079,axiom,
    ! [VarCurr: state_type] :
      ( v59559(VarCurr)
    <=> v59561(VarCurr) ) ).

tff(addAssignment_35078,axiom,
    ! [VarCurr: state_type] :
      ( v59561(VarCurr)
    <=> v59563(VarCurr) ) ).

tff(addAssignment_35077,axiom,
    ! [VarCurr: state_type] :
      ( v59563(VarCurr)
    <=> v59565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5662,axiom,
    ! [VarCurr: state_type] :
      ( v59565(VarCurr)
    <=> ( v59579(VarCurr)
      <~> v59575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5661,axiom,
    ! [VarCurr: state_type] :
      ( v59579(VarCurr)
    <=> ( v59567(VarCurr)
      <~> v59571(VarCurr) ) ) ).

tff(addAssignment_35076,axiom,
    ! [VarCurr: state_type] :
      ( v59575(VarCurr)
    <=> v59577(VarCurr) ) ).

tff(addAssignment_35075,axiom,
    ! [VarCurr: state_type] :
      ( v59577(VarCurr)
    <=> v6017(VarCurr,63) ) ).

tff(addAssignment_35074,axiom,
    ! [VarCurr: state_type] :
      ( v59571(VarCurr)
    <=> v59573(VarCurr) ) ).

tff(addAssignment_35073,axiom,
    ! [VarCurr: state_type] :
      ( v59573(VarCurr)
    <=> v6017(VarCurr,58) ) ).

tff(addAssignment_35072,axiom,
    ! [VarCurr: state_type] :
      ( v59567(VarCurr)
    <=> v59569(VarCurr) ) ).

tff(addAssignment_35071,axiom,
    ! [VarCurr: state_type] :
      ( v59569(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_35070,axiom,
    ! [VarCurr: state_type] :
      ( v59533(VarCurr)
    <=> v59535(VarCurr) ) ).

tff(addAssignment_35069,axiom,
    ! [VarCurr: state_type] :
      ( v59535(VarCurr)
    <=> v59537(VarCurr) ) ).

tff(addAssignment_35068,axiom,
    ! [VarCurr: state_type] :
      ( v59537(VarCurr)
    <=> v59539(VarCurr) ) ).

tff(addAssignment_35067,axiom,
    ! [VarCurr: state_type] :
      ( v59539(VarCurr)
    <=> v59541(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5660,axiom,
    ! [VarCurr: state_type] :
      ( v59541(VarCurr)
    <=> ( v59555(VarCurr)
      <~> v59551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5659,axiom,
    ! [VarCurr: state_type] :
      ( v59555(VarCurr)
    <=> ( v59543(VarCurr)
      <~> v59547(VarCurr) ) ) ).

tff(addAssignment_35066,axiom,
    ! [VarCurr: state_type] :
      ( v59551(VarCurr)
    <=> v59553(VarCurr) ) ).

tff(addAssignment_35065,axiom,
    ! [VarCurr: state_type] :
      ( v59553(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_35064,axiom,
    ! [VarCurr: state_type] :
      ( v59547(VarCurr)
    <=> v59549(VarCurr) ) ).

tff(addAssignment_35063,axiom,
    ! [VarCurr: state_type] :
      ( v59549(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_35062,axiom,
    ! [VarCurr: state_type] :
      ( v59543(VarCurr)
    <=> v59545(VarCurr) ) ).

tff(addAssignment_35061,axiom,
    ! [VarCurr: state_type] :
      ( v59545(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_35060,axiom,
    ! [VarCurr: state_type] :
      ( v59249(VarCurr)
    <=> v59251(VarCurr) ) ).

tff(addAssignment_35059,axiom,
    ! [VarCurr: state_type] :
      ( v59251(VarCurr)
    <=> v59253(VarCurr) ) ).

tff(addAssignment_35058,axiom,
    ! [VarCurr: state_type] :
      ( v59253(VarCurr)
    <=> v59255(VarCurr) ) ).

tff(addAssignment_35057,axiom,
    ! [VarCurr: state_type] :
      ( v59255(VarCurr)
    <=> v59257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5658,axiom,
    ! [VarCurr: state_type] :
      ( v59257(VarCurr)
    <=> ( v59511(VarCurr)
      <~> v59427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5657,axiom,
    ! [VarCurr: state_type] :
      ( v59511(VarCurr)
    <=> ( v59259(VarCurr)
      <~> v59343(VarCurr) ) ) ).

tff(addAssignment_35056,axiom,
    ! [VarCurr: state_type] :
      ( v59427(VarCurr)
    <=> v59429(VarCurr) ) ).

tff(addAssignment_35055,axiom,
    ! [VarCurr: state_type] :
      ( v59429(VarCurr)
    <=> v59431(VarCurr) ) ).

tff(addAssignment_35054,axiom,
    ! [VarCurr: state_type] :
      ( v59431(VarCurr)
    <=> v59433(VarCurr) ) ).

tff(addAssignment_35053,axiom,
    ! [VarCurr: state_type] :
      ( v59433(VarCurr)
    <=> v59435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5656,axiom,
    ! [VarCurr: state_type] :
      ( v59435(VarCurr)
    <=> ( v59509(VarCurr)
      <~> v59485(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5655,axiom,
    ! [VarCurr: state_type] :
      ( v59509(VarCurr)
    <=> ( v59437(VarCurr)
      <~> v59461(VarCurr) ) ) ).

tff(addAssignment_35052,axiom,
    ! [VarCurr: state_type] :
      ( v59485(VarCurr)
    <=> v59487(VarCurr) ) ).

tff(addAssignment_35051,axiom,
    ! [VarCurr: state_type] :
      ( v59487(VarCurr)
    <=> v59489(VarCurr) ) ).

tff(addAssignment_35050,axiom,
    ! [VarCurr: state_type] :
      ( v59489(VarCurr)
    <=> v59491(VarCurr) ) ).

tff(addAssignment_35049,axiom,
    ! [VarCurr: state_type] :
      ( v59491(VarCurr)
    <=> v59493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5654,axiom,
    ! [VarCurr: state_type] :
      ( v59493(VarCurr)
    <=> ( v59507(VarCurr)
      <~> v59503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5653,axiom,
    ! [VarCurr: state_type] :
      ( v59507(VarCurr)
    <=> ( v59495(VarCurr)
      <~> v59499(VarCurr) ) ) ).

tff(addAssignment_35048,axiom,
    ! [VarCurr: state_type] :
      ( v59503(VarCurr)
    <=> v59505(VarCurr) ) ).

tff(addAssignment_35047,axiom,
    ! [VarCurr: state_type] :
      ( v59505(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_35046,axiom,
    ! [VarCurr: state_type] :
      ( v59499(VarCurr)
    <=> v59501(VarCurr) ) ).

tff(addAssignment_35045,axiom,
    ! [VarCurr: state_type] :
      ( v59501(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_35044,axiom,
    ! [VarCurr: state_type] :
      ( v59495(VarCurr)
    <=> v59497(VarCurr) ) ).

tff(addAssignment_35043,axiom,
    ! [VarCurr: state_type] :
      ( v59497(VarCurr)
    <=> v6017(VarCurr,49) ) ).

tff(addAssignment_35042,axiom,
    ! [VarCurr: state_type] :
      ( v59461(VarCurr)
    <=> v59463(VarCurr) ) ).

tff(addAssignment_35041,axiom,
    ! [VarCurr: state_type] :
      ( v59463(VarCurr)
    <=> v59465(VarCurr) ) ).

tff(addAssignment_35040,axiom,
    ! [VarCurr: state_type] :
      ( v59465(VarCurr)
    <=> v59467(VarCurr) ) ).

tff(addAssignment_35039,axiom,
    ! [VarCurr: state_type] :
      ( v59467(VarCurr)
    <=> v59469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5652,axiom,
    ! [VarCurr: state_type] :
      ( v59469(VarCurr)
    <=> ( v59483(VarCurr)
      <~> v59479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5651,axiom,
    ! [VarCurr: state_type] :
      ( v59483(VarCurr)
    <=> ( v59471(VarCurr)
      <~> v59475(VarCurr) ) ) ).

tff(addAssignment_35038,axiom,
    ! [VarCurr: state_type] :
      ( v59479(VarCurr)
    <=> v59481(VarCurr) ) ).

tff(addAssignment_35037,axiom,
    ! [VarCurr: state_type] :
      ( v59481(VarCurr)
    <=> v6017(VarCurr,48) ) ).

tff(addAssignment_35036,axiom,
    ! [VarCurr: state_type] :
      ( v59475(VarCurr)
    <=> v59477(VarCurr) ) ).

tff(addAssignment_35035,axiom,
    ! [VarCurr: state_type] :
      ( v59477(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_35034,axiom,
    ! [VarCurr: state_type] :
      ( v59471(VarCurr)
    <=> v59473(VarCurr) ) ).

tff(addAssignment_35033,axiom,
    ! [VarCurr: state_type] :
      ( v59473(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_35032,axiom,
    ! [VarCurr: state_type] :
      ( v59437(VarCurr)
    <=> v59439(VarCurr) ) ).

tff(addAssignment_35031,axiom,
    ! [VarCurr: state_type] :
      ( v59439(VarCurr)
    <=> v59441(VarCurr) ) ).

tff(addAssignment_35030,axiom,
    ! [VarCurr: state_type] :
      ( v59441(VarCurr)
    <=> v59443(VarCurr) ) ).

tff(addAssignment_35029,axiom,
    ! [VarCurr: state_type] :
      ( v59443(VarCurr)
    <=> v59445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5650,axiom,
    ! [VarCurr: state_type] :
      ( v59445(VarCurr)
    <=> ( v59459(VarCurr)
      <~> v59455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5649,axiom,
    ! [VarCurr: state_type] :
      ( v59459(VarCurr)
    <=> ( v59447(VarCurr)
      <~> v59451(VarCurr) ) ) ).

tff(addAssignment_35028,axiom,
    ! [VarCurr: state_type] :
      ( v59455(VarCurr)
    <=> v59457(VarCurr) ) ).

tff(addAssignment_35027,axiom,
    ! [VarCurr: state_type] :
      ( v59457(VarCurr)
    <=> v6017(VarCurr,44) ) ).

tff(addAssignment_35026,axiom,
    ! [VarCurr: state_type] :
      ( v59451(VarCurr)
    <=> v59453(VarCurr) ) ).

tff(addAssignment_35025,axiom,
    ! [VarCurr: state_type] :
      ( v59453(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_35024,axiom,
    ! [VarCurr: state_type] :
      ( v59447(VarCurr)
    <=> v59449(VarCurr) ) ).

tff(addAssignment_35023,axiom,
    ! [VarCurr: state_type] :
      ( v59449(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_35022,axiom,
    ! [VarCurr: state_type] :
      ( v59343(VarCurr)
    <=> v59345(VarCurr) ) ).

tff(addAssignment_35021,axiom,
    ! [VarCurr: state_type] :
      ( v59345(VarCurr)
    <=> v59347(VarCurr) ) ).

tff(addAssignment_35020,axiom,
    ! [VarCurr: state_type] :
      ( v59347(VarCurr)
    <=> v59349(VarCurr) ) ).

tff(addAssignment_35019,axiom,
    ! [VarCurr: state_type] :
      ( v59349(VarCurr)
    <=> v59351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5648,axiom,
    ! [VarCurr: state_type] :
      ( v59351(VarCurr)
    <=> ( v59425(VarCurr)
      <~> v59401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5647,axiom,
    ! [VarCurr: state_type] :
      ( v59425(VarCurr)
    <=> ( v59353(VarCurr)
      <~> v59377(VarCurr) ) ) ).

tff(addAssignment_35018,axiom,
    ! [VarCurr: state_type] :
      ( v59401(VarCurr)
    <=> v59403(VarCurr) ) ).

tff(addAssignment_35017,axiom,
    ! [VarCurr: state_type] :
      ( v59403(VarCurr)
    <=> v59405(VarCurr) ) ).

tff(addAssignment_35016,axiom,
    ! [VarCurr: state_type] :
      ( v59405(VarCurr)
    <=> v59407(VarCurr) ) ).

tff(addAssignment_35015,axiom,
    ! [VarCurr: state_type] :
      ( v59407(VarCurr)
    <=> v59409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5646,axiom,
    ! [VarCurr: state_type] :
      ( v59409(VarCurr)
    <=> ( v59423(VarCurr)
      <~> v59419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5645,axiom,
    ! [VarCurr: state_type] :
      ( v59423(VarCurr)
    <=> ( v59411(VarCurr)
      <~> v59415(VarCurr) ) ) ).

tff(addAssignment_35014,axiom,
    ! [VarCurr: state_type] :
      ( v59419(VarCurr)
    <=> v59421(VarCurr) ) ).

tff(addAssignment_35013,axiom,
    ! [VarCurr: state_type] :
      ( v59421(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_35012,axiom,
    ! [VarCurr: state_type] :
      ( v59415(VarCurr)
    <=> v59417(VarCurr) ) ).

tff(addAssignment_35011,axiom,
    ! [VarCurr: state_type] :
      ( v59417(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_35010,axiom,
    ! [VarCurr: state_type] :
      ( v59411(VarCurr)
    <=> v59413(VarCurr) ) ).

tff(addAssignment_35009,axiom,
    ! [VarCurr: state_type] :
      ( v59413(VarCurr)
    <=> v6017(VarCurr,36) ) ).

tff(addAssignment_35008,axiom,
    ! [VarCurr: state_type] :
      ( v59377(VarCurr)
    <=> v59379(VarCurr) ) ).

tff(addAssignment_35007,axiom,
    ! [VarCurr: state_type] :
      ( v59379(VarCurr)
    <=> v59381(VarCurr) ) ).

tff(addAssignment_35006,axiom,
    ! [VarCurr: state_type] :
      ( v59381(VarCurr)
    <=> v59383(VarCurr) ) ).

tff(addAssignment_35005,axiom,
    ! [VarCurr: state_type] :
      ( v59383(VarCurr)
    <=> v59385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5644,axiom,
    ! [VarCurr: state_type] :
      ( v59385(VarCurr)
    <=> ( v59399(VarCurr)
      <~> v59395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5643,axiom,
    ! [VarCurr: state_type] :
      ( v59399(VarCurr)
    <=> ( v59387(VarCurr)
      <~> v59391(VarCurr) ) ) ).

tff(addAssignment_35004,axiom,
    ! [VarCurr: state_type] :
      ( v59395(VarCurr)
    <=> v59397(VarCurr) ) ).

tff(addAssignment_35003,axiom,
    ! [VarCurr: state_type] :
      ( v59397(VarCurr)
    <=> v6017(VarCurr,32) ) ).

tff(addAssignment_35002,axiom,
    ! [VarCurr: state_type] :
      ( v59391(VarCurr)
    <=> v59393(VarCurr) ) ).

tff(addAssignment_35001,axiom,
    ! [VarCurr: state_type] :
      ( v59393(VarCurr)
    <=> v6017(VarCurr,31) ) ).

tff(addAssignment_35000,axiom,
    ! [VarCurr: state_type] :
      ( v59387(VarCurr)
    <=> v59389(VarCurr) ) ).

tff(addAssignment_34999,axiom,
    ! [VarCurr: state_type] :
      ( v59389(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_34998,axiom,
    ! [VarCurr: state_type] :
      ( v59353(VarCurr)
    <=> v59355(VarCurr) ) ).

tff(addAssignment_34997,axiom,
    ! [VarCurr: state_type] :
      ( v59355(VarCurr)
    <=> v59357(VarCurr) ) ).

tff(addAssignment_34996,axiom,
    ! [VarCurr: state_type] :
      ( v59357(VarCurr)
    <=> v59359(VarCurr) ) ).

tff(addAssignment_34995,axiom,
    ! [VarCurr: state_type] :
      ( v59359(VarCurr)
    <=> v59361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5642,axiom,
    ! [VarCurr: state_type] :
      ( v59361(VarCurr)
    <=> ( v59375(VarCurr)
      <~> v59371(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5641,axiom,
    ! [VarCurr: state_type] :
      ( v59375(VarCurr)
    <=> ( v59363(VarCurr)
      <~> v59367(VarCurr) ) ) ).

tff(addAssignment_34994,axiom,
    ! [VarCurr: state_type] :
      ( v59371(VarCurr)
    <=> v59373(VarCurr) ) ).

tff(addAssignment_34993,axiom,
    ! [VarCurr: state_type] :
      ( v59373(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_34992,axiom,
    ! [VarCurr: state_type] :
      ( v59367(VarCurr)
    <=> v59369(VarCurr) ) ).

tff(addAssignment_34991,axiom,
    ! [VarCurr: state_type] :
      ( v59369(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_34990,axiom,
    ! [VarCurr: state_type] :
      ( v59363(VarCurr)
    <=> v59365(VarCurr) ) ).

tff(addAssignment_34989,axiom,
    ! [VarCurr: state_type] :
      ( v59365(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_34988,axiom,
    ! [VarCurr: state_type] :
      ( v59259(VarCurr)
    <=> v59261(VarCurr) ) ).

tff(addAssignment_34987,axiom,
    ! [VarCurr: state_type] :
      ( v59261(VarCurr)
    <=> v59263(VarCurr) ) ).

tff(addAssignment_34986,axiom,
    ! [VarCurr: state_type] :
      ( v59263(VarCurr)
    <=> v59265(VarCurr) ) ).

tff(addAssignment_34985,axiom,
    ! [VarCurr: state_type] :
      ( v59265(VarCurr)
    <=> v59267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5640,axiom,
    ! [VarCurr: state_type] :
      ( v59267(VarCurr)
    <=> ( v59341(VarCurr)
      <~> v59317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5639,axiom,
    ! [VarCurr: state_type] :
      ( v59341(VarCurr)
    <=> ( v59269(VarCurr)
      <~> v59293(VarCurr) ) ) ).

tff(addAssignment_34984,axiom,
    ! [VarCurr: state_type] :
      ( v59317(VarCurr)
    <=> v59319(VarCurr) ) ).

tff(addAssignment_34983,axiom,
    ! [VarCurr: state_type] :
      ( v59319(VarCurr)
    <=> v59321(VarCurr) ) ).

tff(addAssignment_34982,axiom,
    ! [VarCurr: state_type] :
      ( v59321(VarCurr)
    <=> v59323(VarCurr) ) ).

tff(addAssignment_34981,axiom,
    ! [VarCurr: state_type] :
      ( v59323(VarCurr)
    <=> v59325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5638,axiom,
    ! [VarCurr: state_type] :
      ( v59325(VarCurr)
    <=> ( v59339(VarCurr)
      <~> v59335(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5637,axiom,
    ! [VarCurr: state_type] :
      ( v59339(VarCurr)
    <=> ( v59327(VarCurr)
      <~> v59331(VarCurr) ) ) ).

tff(addAssignment_34980,axiom,
    ! [VarCurr: state_type] :
      ( v59335(VarCurr)
    <=> v59337(VarCurr) ) ).

tff(addAssignment_34979,axiom,
    ! [VarCurr: state_type] :
      ( v59337(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_34978,axiom,
    ! [VarCurr: state_type] :
      ( v59331(VarCurr)
    <=> v59333(VarCurr) ) ).

tff(addAssignment_34977,axiom,
    ! [VarCurr: state_type] :
      ( v59333(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_34976,axiom,
    ! [VarCurr: state_type] :
      ( v59327(VarCurr)
    <=> v59329(VarCurr) ) ).

tff(addAssignment_34975,axiom,
    ! [VarCurr: state_type] :
      ( v59329(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_34974,axiom,
    ! [VarCurr: state_type] :
      ( v59293(VarCurr)
    <=> v59295(VarCurr) ) ).

tff(addAssignment_34973,axiom,
    ! [VarCurr: state_type] :
      ( v59295(VarCurr)
    <=> v59297(VarCurr) ) ).

tff(addAssignment_34972,axiom,
    ! [VarCurr: state_type] :
      ( v59297(VarCurr)
    <=> v59299(VarCurr) ) ).

tff(addAssignment_34971,axiom,
    ! [VarCurr: state_type] :
      ( v59299(VarCurr)
    <=> v59301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5636,axiom,
    ! [VarCurr: state_type] :
      ( v59301(VarCurr)
    <=> ( v59315(VarCurr)
      <~> v59311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5635,axiom,
    ! [VarCurr: state_type] :
      ( v59315(VarCurr)
    <=> ( v59303(VarCurr)
      <~> v59307(VarCurr) ) ) ).

tff(addAssignment_34970,axiom,
    ! [VarCurr: state_type] :
      ( v59311(VarCurr)
    <=> v59313(VarCurr) ) ).

tff(addAssignment_34969,axiom,
    ! [VarCurr: state_type] :
      ( v59313(VarCurr)
    <=> v6017(VarCurr,17) ) ).

tff(addAssignment_34968,axiom,
    ! [VarCurr: state_type] :
      ( v59307(VarCurr)
    <=> v59309(VarCurr) ) ).

tff(addAssignment_34967,axiom,
    ! [VarCurr: state_type] :
      ( v59309(VarCurr)
    <=> v6017(VarCurr,13) ) ).

tff(addAssignment_34966,axiom,
    ! [VarCurr: state_type] :
      ( v59303(VarCurr)
    <=> v59305(VarCurr) ) ).

tff(addAssignment_34965,axiom,
    ! [VarCurr: state_type] :
      ( v59305(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_34964,axiom,
    ! [VarCurr: state_type] :
      ( v59269(VarCurr)
    <=> v59271(VarCurr) ) ).

tff(addAssignment_34963,axiom,
    ! [VarCurr: state_type] :
      ( v59271(VarCurr)
    <=> v59273(VarCurr) ) ).

tff(addAssignment_34962,axiom,
    ! [VarCurr: state_type] :
      ( v59273(VarCurr)
    <=> v59275(VarCurr) ) ).

tff(addAssignment_34961,axiom,
    ! [VarCurr: state_type] :
      ( v59275(VarCurr)
    <=> v59277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5634,axiom,
    ! [VarCurr: state_type] :
      ( v59277(VarCurr)
    <=> ( v59291(VarCurr)
      <~> v59287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5633,axiom,
    ! [VarCurr: state_type] :
      ( v59291(VarCurr)
    <=> ( v59279(VarCurr)
      <~> v59283(VarCurr) ) ) ).

tff(addAssignment_34960,axiom,
    ! [VarCurr: state_type] :
      ( v59287(VarCurr)
    <=> v59289(VarCurr) ) ).

tff(addAssignment_34959,axiom,
    ! [VarCurr: state_type] :
      ( v59289(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_34958,axiom,
    ! [VarCurr: state_type] :
      ( v59283(VarCurr)
    <=> v59285(VarCurr) ) ).

tff(addAssignment_34957,axiom,
    ! [VarCurr: state_type] :
      ( v59285(VarCurr)
    <=> v6017(VarCurr,6) ) ).

tff(addAssignment_34956,axiom,
    ! [VarCurr: state_type] :
      ( v59279(VarCurr)
    <=> v59281(VarCurr) ) ).

tff(addAssignment_34955,axiom,
    ! [VarCurr: state_type] :
      ( v59281(VarCurr)
    <=> v6017(VarCurr,3) ) ).

tff(addAssignment_34954,axiom,
    ! [VarCurr: state_type] :
      ( v5921(VarCurr,3)
    <=> v5923(VarCurr,3) ) ).

tff(addAssignment_34953,axiom,
    ! [VarCurr: state_type] :
      ( v5923(VarCurr,3)
    <=> v59235(VarCurr,3) ) ).

tff(addAssignment_34952,axiom,
    ! [VarCurr: state_type] :
      ( v59235(VarCurr,0)
    <=> v59236(VarCurr) ) ).

tff(addAssignment_34951,axiom,
    ! [VarCurr: state_type] :
      ( v59235(VarCurr,1)
    <=> v59236(VarCurr) ) ).

tff(addAssignment_34950,axiom,
    ! [VarCurr: state_type] :
      ( v59235(VarCurr,2)
    <=> v59236(VarCurr) ) ).

tff(addAssignment_34949,axiom,
    ! [VarCurr: state_type] :
      ( v59235(VarCurr,3)
    <=> v59236(VarCurr) ) ).

tff(addAssignment_34948,axiom,
    ! [VarCurr: state_type] :
      ( v59236(VarCurr)
    <=> v5925(VarCurr) ) ).

tff(addAssignment_34947,axiom,
    ! [VarCurr: state_type] :
      ( v5925(VarCurr)
    <=> v5927(VarCurr) ) ).

tff(addAssignment_34946,axiom,
    ! [VarCurr: state_type] :
      ( v5927(VarCurr)
    <=> v5929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5632,axiom,
    ! [VarCurr: state_type] :
      ( v5929(VarCurr)
    <=> ( v5931(VarCurr)
        | v56417(VarCurr) ) ) ).

tff(addAssignment_34945,axiom,
    ! [VarCurr: state_type] :
      ( v56417(VarCurr)
    <=> v56419(VarCurr) ) ).

tff(addAssignment_34944,axiom,
    ! [VarCurr: state_type] :
      ( v56419(VarCurr)
    <=> v56421(VarCurr) ) ).

tff(addAssignment_34943,axiom,
    ! [VarCurr: state_type] :
      ( v56421(VarCurr)
    <=> v56423(VarCurr) ) ).

tff(addAssignment_34942,axiom,
    ! [VarCurr: state_type] :
      ( v56423(VarCurr)
    <=> v56425(VarCurr) ) ).

tff(writeUnaryOperator_3149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v56425(VarCurr)
    <=> v59233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5631,axiom,
    ! [VarCurr: state_type] :
      ( v59233(VarCurr)
    <=> ( v56427(VarCurr)
        | v59229(VarCurr) ) ) ).

tff(addAssignment_34941,axiom,
    ! [VarCurr: state_type] :
      ( v59229(VarCurr)
    <=> v59231(VarCurr) ) ).

tff(addAssignment_34940,axiom,
    ! [VarCurr: state_type] :
      ( v59231(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_34939,axiom,
    ! [VarCurr: state_type] :
      ( v56427(VarCurr)
    <=> v56429(VarCurr) ) ).

tff(addAssignment_34938,axiom,
    ! [VarCurr: state_type] :
      ( v56429(VarCurr)
    <=> v56431(VarCurr) ) ).

tff(addAssignment_34937,axiom,
    ! [VarCurr: state_type] :
      ( v56431(VarCurr)
    <=> v56433(VarCurr) ) ).

tff(addAssignment_34936,axiom,
    ! [VarCurr: state_type] :
      ( v56433(VarCurr)
    <=> v56435(VarCurr) ) ).

tff(writeUnaryOperator_3148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v56435(VarCurr)
    <=> v59227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5630,axiom,
    ! [VarCurr: state_type] :
      ( v59227(VarCurr)
    <=> ( v56437(VarCurr)
        | v59160(VarCurr) ) ) ).

tff(addAssignment_34935,axiom,
    ! [VarCurr: state_type] :
      ( v59160(VarCurr)
    <=> v59162(VarCurr) ) ).

tff(addAssignment_34934,axiom,
    ! [VarCurr: state_type] :
      ( v59162(VarCurr)
    <=> v59164(VarCurr) ) ).

tff(addAssignment_34933,axiom,
    ! [VarCurr: state_type] :
      ( v59164(VarCurr)
    <=> v59166(VarCurr) ) ).

tff(addAssignment_34932,axiom,
    ! [VarCurr: state_type] :
      ( v59166(VarCurr)
    <=> v59168(VarCurr) ) ).

tff(addAssignment_34931,axiom,
    ! [VarCurr: state_type] :
      ( v59168(VarCurr)
    <=> v59170(VarCurr) ) ).

tff(addAssignment_34930,axiom,
    ! [VarCurr: state_type] :
      ( v59170(VarCurr)
    <=> v59172(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v59210(VarNext)
       => ( v59172(VarNext)
        <=> v59172(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_757,axiom,
    ! [VarNext: state_type] :
      ( v59210(VarNext)
     => ( v59172(VarNext)
      <=> v59220(VarNext) ) ) ).

tff(addAssignment_34929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59220(VarNext)
      <=> v59218(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59221(VarCurr)
     => ( v59218(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_397,axiom,
    ! [VarCurr: state_type] :
      ( v59221(VarCurr)
     => ( v59218(VarCurr)
      <=> v59182(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5629,axiom,
    ! [VarCurr: state_type] :
      ( v59221(VarCurr)
    <=> ( v59222(VarCurr)
        & v59223(VarCurr) ) ) ).

tff(writeUnaryOperator_3147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59223(VarCurr)
    <=> v59178(VarCurr) ) ).

tff(writeUnaryOperator_3146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59222(VarCurr)
    <=> v59174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59210(VarNext)
      <=> v59211(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59211(VarNext)
      <=> ( v59212(VarNext)
          & v59205(VarNext) ) ) ) ).

tff(writeUnaryOperator_3145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v59212(VarNext)
      <=> v59214(VarNext) ) ) ).

tff(addAssignment_34928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59214(VarNext)
      <=> v59205(VarCurr) ) ) ).

tff(addAssignment_34927,axiom,
    ! [VarCurr: state_type] :
      ( v59205(VarCurr)
    <=> v59207(VarCurr) ) ).

tff(addAssignment_34926,axiom,
    ! [VarCurr: state_type] :
      ( v59207(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_34925,axiom,
    ! [VarCurr: state_type] :
      ( v59182(VarCurr)
    <=> v59184(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5626,axiom,
    ! [VarCurr: state_type] :
      ( v59184(VarCurr)
    <=> ( v59197(VarCurr)
        | v59200(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5625,axiom,
    ! [VarCurr: state_type] :
      ( v59200(VarCurr)
    <=> ( v59170(VarCurr)
        & v59201(VarCurr) ) ) ).

tff(writeUnaryOperator_3144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v59201(VarCurr)
    <=> v59202(VarCurr) ) ).

tff(addAssignment_34924,axiom,
    ! [VarCurr: state_type] :
      ( v59202(VarCurr)
    <=> v59203(VarCurr) ) ).

tff(addAssignment_34923,axiom,
    ! [VarCurr: state_type] :
      ( v59203(VarCurr)
    <=> v59190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5624,axiom,
    ! [VarCurr: state_type] :
      ( v59197(VarCurr)
    <=> ( v59186(VarCurr)
        & v59198(VarCurr) ) ) ).

tff(addAssignment_34922,axiom,
    ! [VarCurr: state_type] :
      ( v59198(VarCurr)
    <=> v59199(VarCurr) ) ).

tff(addAssignment_34921,axiom,
    ! [VarCurr: state_type] :
      ( v59199(VarCurr)
    <=> v59190(VarCurr) ) ).

tff(addAssignment_34920,axiom,
    ! [VarCurr: state_type] :
      ( v59190(VarCurr)
    <=> v59192(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5623,axiom,
    ! [VarCurr: state_type] :
      ( v59192(VarCurr)
    <=> ( v1729(VarCurr)
        & v59195(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_231,axiom,
    ! [VarCurr: state_type] :
      ( v59195(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $true )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_1030,axiom,
    ~ b0001000100000(12) ).

tff(bitBlastConstant_1029,axiom,
    ~ b0001000100000(11) ).

tff(bitBlastConstant_1028,axiom,
    ~ b0001000100000(10) ).

tff(bitBlastConstant_1027,axiom,
    b0001000100000(9) ).

tff(bitBlastConstant_1026,axiom,
    ~ b0001000100000(8) ).

tff(bitBlastConstant_1025,axiom,
    ~ b0001000100000(7) ).

tff(bitBlastConstant_1024,axiom,
    ~ b0001000100000(6) ).

tff(bitBlastConstant_1023,axiom,
    b0001000100000(5) ).

tff(bitBlastConstant_1022,axiom,
    ~ b0001000100000(4) ).

tff(bitBlastConstant_1021,axiom,
    ~ b0001000100000(3) ).

tff(bitBlastConstant_1020,axiom,
    ~ b0001000100000(2) ).

tff(bitBlastConstant_1019,axiom,
    ~ b0001000100000(1) ).

tff(bitBlastConstant_1018,axiom,
    ~ b0001000100000(0) ).

tff(addAssignment_34919,axiom,
    ! [VarCurr: state_type] :
      ( v59186(VarCurr)
    <=> v59188(VarCurr) ) ).

tff(addAssignment_34918,axiom,
    ! [VarCurr: state_type] :
      ( v59188(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_34917,axiom,
    ! [VarCurr: state_type] :
      ( v59178(VarCurr)
    <=> v59180(VarCurr) ) ).

tff(addAssignment_34916,axiom,
    ! [VarCurr: state_type] :
      ( v59180(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_34915,axiom,
    ! [VarCurr: state_type] :
      ( v59174(VarCurr)
    <=> v59176(VarCurr) ) ).

tff(addAssignment_34914,axiom,
    ! [VarCurr: state_type] :
      ( v59176(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_34913,axiom,
    ! [VarCurr: state_type] :
      ( v56437(VarCurr)
    <=> v56439(VarCurr) ) ).

tff(addAssignment_34912,axiom,
    ! [VarCurr: state_type] :
      ( v56439(VarCurr)
    <=> v56441(VarCurr) ) ).

tff(addAssignment_34911,axiom,
    ! [VarCurr: state_type] :
      ( v56441(VarCurr)
    <=> v56443(VarCurr) ) ).

tff(addAssignment_34910,axiom,
    ! [VarCurr: state_type] :
      ( v56443(VarCurr)
    <=> v56445(VarCurr) ) ).

tff(writeUnaryOperator_3143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v56445(VarCurr)
    <=> v59158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5622,axiom,
    ! [VarCurr: state_type] :
      ( v59158(VarCurr)
    <=> ( v56447(VarCurr)
        & v57806(VarCurr) ) ) ).

tff(addAssignment_34909,axiom,
    ! [VarCurr: state_type] :
      ( v57806(VarCurr)
    <=> v57808(VarCurr) ) ).

tff(addAssignment_34908,axiom,
    ! [VarCurr: state_type] :
      ( v57808(VarCurr)
    <=> v57810(VarCurr) ) ).

tff(addAssignment_34907,axiom,
    ! [VarCurr: state_type] :
      ( v57810(VarCurr)
    <=> v57812(VarCurr) ) ).

tff(addAssignment_34906,axiom,
    ! [VarCurr: state_type] :
      ( v57812(VarCurr)
    <=> v57814(VarCurr) ) ).

tff(writeUnaryOperator_3142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v57814(VarCurr)
    <=> v59156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5621,axiom,
    ! [VarCurr: state_type] :
      ( v59156(VarCurr)
    <=> ( v57816(VarCurr)
        | v58486(VarCurr) ) ) ).

tff(addAssignment_34905,axiom,
    ! [VarCurr: state_type] :
      ( v58486(VarCurr)
    <=> v58488(VarCurr) ) ).

tff(addAssignment_34904,axiom,
    ! [VarCurr: state_type] :
      ( v58488(VarCurr)
    <=> v56461(VarCurr,0) ) ).

tff(addAssignment_34903,axiom,
    ! [VarCurr: state_type] :
      ( v56461(VarCurr,0)
    <=> v5977(VarCurr,0) ) ).

tff(addAssignment_34902,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,0)
    <=> v5979(VarCurr,0) ) ).

tff(addAssignment_34901,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,0)
    <=> v5981(VarCurr,0) ) ).

tff(addAssignment_34900,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,0)
    <=> v5983(VarCurr,0) ) ).

tff(addAssignment_34899,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,0)
    <=> v5985(VarCurr,0) ) ).

tff(addAssignment_34898,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,0)
    <=> v53672(VarCurr,0) ) ).

tff(addAssignment_34897,axiom,
    ! [VarCurr: state_type] :
      ( v53675(VarCurr,0)
    <=> v58490(VarCurr) ) ).

tff(addAssignment_34896,axiom,
    ! [VarCurr: state_type] :
      ( v58490(VarCurr)
    <=> v58492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5620,axiom,
    ! [VarCurr: state_type] :
      ( v58492(VarCurr)
    <=> ( v59154(VarCurr)
      <~> v59022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5619,axiom,
    ! [VarCurr: state_type] :
      ( v59154(VarCurr)
    <=> ( v58494(VarCurr)
      <~> v58758(VarCurr) ) ) ).

tff(addAssignment_34895,axiom,
    ! [VarCurr: state_type] :
      ( v59022(VarCurr)
    <=> v59024(VarCurr) ) ).

tff(addAssignment_34894,axiom,
    ! [VarCurr: state_type] :
      ( v59024(VarCurr)
    <=> v59026(VarCurr) ) ).

tff(addAssignment_34893,axiom,
    ! [VarCurr: state_type] :
      ( v59026(VarCurr)
    <=> v59028(VarCurr) ) ).

tff(addAssignment_34892,axiom,
    ! [VarCurr: state_type] :
      ( v59028(VarCurr)
    <=> v59030(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5618,axiom,
    ! [VarCurr: state_type] :
      ( v59030(VarCurr)
    <=> ( v59152(VarCurr)
      <~> v59140(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5617,axiom,
    ! [VarCurr: state_type] :
      ( v59152(VarCurr)
    <=> ( v59032(VarCurr)
      <~> v59056(VarCurr) ) ) ).

tff(addAssignment_34891,axiom,
    ! [VarCurr: state_type] :
      ( v59140(VarCurr)
    <=> v59142(VarCurr) ) ).

tff(addAssignment_34890,axiom,
    ! [VarCurr: state_type] :
      ( v59142(VarCurr)
    <=> v57118(VarCurr,0) ) ).

tff(addAssignment_34889,axiom,
    ! [VarCurr: state_type] :
      ( v57118(VarCurr,0)
    <=> v57120(VarCurr,0) ) ).

tff(addAssignment_34888,axiom,
    ! [VarCurr: state_type] :
      ( v57120(VarCurr,0)
    <=> v53454(VarCurr,1) ) ).

tff(addAssignment_34887,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,1)
    <=> v53456(VarCurr,1) ) ).

tff(addAssignment_34886,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,1)
    <=> v59144(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v59145(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v59144(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_756,axiom,
    ! [VarNext: state_type] :
      ( v59145(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v59144(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59145(VarNext)
      <=> v59146(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v59146(VarNext)
      <=> ( v59148(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v59148(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_34885,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,1)
    <=> v53480(VarCurr,1) ) ).

tff(addAssignment_34884,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,1)
    <=> v53525(VarCurr,1) ) ).

tff(addAssignment_34883,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,0)
    <=> v53312(VarCurr,0) ) ).

tff(addAssignment_34882,axiom,
    ! [VarCurr: state_type] :
      ( v59056(VarCurr)
    <=> v59058(VarCurr) ) ).

tff(addAssignment_34881,axiom,
    ! [VarCurr: state_type] :
      ( v59058(VarCurr)
    <=> v59060(VarCurr) ) ).

tff(addAssignment_34880,axiom,
    ! [VarCurr: state_type] :
      ( v59060(VarCurr)
    <=> v59062(VarCurr) ) ).

tff(addAssignment_34879,axiom,
    ! [VarCurr: state_type] :
      ( v59062(VarCurr)
    <=> v59064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5614,axiom,
    ! [VarCurr: state_type] :
      ( v59064(VarCurr)
    <=> ( v59138(VarCurr)
      <~> v59114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5613,axiom,
    ! [VarCurr: state_type] :
      ( v59138(VarCurr)
    <=> ( v59066(VarCurr)
      <~> v59090(VarCurr) ) ) ).

tff(addAssignment_34878,axiom,
    ! [VarCurr: state_type] :
      ( v59114(VarCurr)
    <=> v59116(VarCurr) ) ).

tff(addAssignment_34877,axiom,
    ! [VarCurr: state_type] :
      ( v59116(VarCurr)
    <=> v59118(VarCurr) ) ).

tff(addAssignment_34876,axiom,
    ! [VarCurr: state_type] :
      ( v59118(VarCurr)
    <=> v59120(VarCurr) ) ).

tff(addAssignment_34875,axiom,
    ! [VarCurr: state_type] :
      ( v59120(VarCurr)
    <=> v59122(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5612,axiom,
    ! [VarCurr: state_type] :
      ( v59122(VarCurr)
    <=> ( v59136(VarCurr)
      <~> v59132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5611,axiom,
    ! [VarCurr: state_type] :
      ( v59136(VarCurr)
    <=> ( v59124(VarCurr)
      <~> v59128(VarCurr) ) ) ).

tff(addAssignment_34874,axiom,
    ! [VarCurr: state_type] :
      ( v59132(VarCurr)
    <=> v59134(VarCurr) ) ).

tff(addAssignment_34873,axiom,
    ! [VarCurr: state_type] :
      ( v59134(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_34872,axiom,
    ! [VarCurr: state_type] :
      ( v59128(VarCurr)
    <=> v59130(VarCurr) ) ).

tff(addAssignment_34871,axiom,
    ! [VarCurr: state_type] :
      ( v59130(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_34870,axiom,
    ! [VarCurr: state_type] :
      ( v59124(VarCurr)
    <=> v59126(VarCurr) ) ).

tff(addAssignment_34869,axiom,
    ! [VarCurr: state_type] :
      ( v59126(VarCurr)
    <=> v6017(VarCurr,110) ) ).

tff(addAssignment_34868,axiom,
    ! [VarCurr: state_type] :
      ( v59090(VarCurr)
    <=> v59092(VarCurr) ) ).

tff(addAssignment_34867,axiom,
    ! [VarCurr: state_type] :
      ( v59092(VarCurr)
    <=> v59094(VarCurr) ) ).

tff(addAssignment_34866,axiom,
    ! [VarCurr: state_type] :
      ( v59094(VarCurr)
    <=> v59096(VarCurr) ) ).

tff(addAssignment_34865,axiom,
    ! [VarCurr: state_type] :
      ( v59096(VarCurr)
    <=> v59098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5610,axiom,
    ! [VarCurr: state_type] :
      ( v59098(VarCurr)
    <=> ( v59112(VarCurr)
      <~> v59108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5609,axiom,
    ! [VarCurr: state_type] :
      ( v59112(VarCurr)
    <=> ( v59100(VarCurr)
      <~> v59104(VarCurr) ) ) ).

tff(addAssignment_34864,axiom,
    ! [VarCurr: state_type] :
      ( v59108(VarCurr)
    <=> v59110(VarCurr) ) ).

tff(addAssignment_34863,axiom,
    ! [VarCurr: state_type] :
      ( v59110(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_34862,axiom,
    ! [VarCurr: state_type] :
      ( v59104(VarCurr)
    <=> v59106(VarCurr) ) ).

tff(addAssignment_34861,axiom,
    ! [VarCurr: state_type] :
      ( v59106(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_34860,axiom,
    ! [VarCurr: state_type] :
      ( v59100(VarCurr)
    <=> v59102(VarCurr) ) ).

tff(addAssignment_34859,axiom,
    ! [VarCurr: state_type] :
      ( v59102(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_34858,axiom,
    ! [VarCurr: state_type] :
      ( v59066(VarCurr)
    <=> v59068(VarCurr) ) ).

tff(addAssignment_34857,axiom,
    ! [VarCurr: state_type] :
      ( v59068(VarCurr)
    <=> v59070(VarCurr) ) ).

tff(addAssignment_34856,axiom,
    ! [VarCurr: state_type] :
      ( v59070(VarCurr)
    <=> v59072(VarCurr) ) ).

tff(addAssignment_34855,axiom,
    ! [VarCurr: state_type] :
      ( v59072(VarCurr)
    <=> v59074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5608,axiom,
    ! [VarCurr: state_type] :
      ( v59074(VarCurr)
    <=> ( v59088(VarCurr)
      <~> v59084(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5607,axiom,
    ! [VarCurr: state_type] :
      ( v59088(VarCurr)
    <=> ( v59076(VarCurr)
      <~> v59080(VarCurr) ) ) ).

tff(addAssignment_34854,axiom,
    ! [VarCurr: state_type] :
      ( v59084(VarCurr)
    <=> v59086(VarCurr) ) ).

tff(addAssignment_34853,axiom,
    ! [VarCurr: state_type] :
      ( v59086(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_34852,axiom,
    ! [VarCurr: state_type] :
      ( v59080(VarCurr)
    <=> v59082(VarCurr) ) ).

tff(addAssignment_34851,axiom,
    ! [VarCurr: state_type] :
      ( v59082(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_34850,axiom,
    ! [VarCurr: state_type] :
      ( v59076(VarCurr)
    <=> v59078(VarCurr) ) ).

tff(addAssignment_34849,axiom,
    ! [VarCurr: state_type] :
      ( v59078(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_34848,axiom,
    ! [VarCurr: state_type] :
      ( v59032(VarCurr)
    <=> v59034(VarCurr) ) ).

tff(addAssignment_34847,axiom,
    ! [VarCurr: state_type] :
      ( v59034(VarCurr)
    <=> v59036(VarCurr) ) ).

tff(addAssignment_34846,axiom,
    ! [VarCurr: state_type] :
      ( v59036(VarCurr)
    <=> v59038(VarCurr) ) ).

tff(addAssignment_34845,axiom,
    ! [VarCurr: state_type] :
      ( v59038(VarCurr)
    <=> v59040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5606,axiom,
    ! [VarCurr: state_type] :
      ( v59040(VarCurr)
    <=> ( v59054(VarCurr)
      <~> v59050(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5605,axiom,
    ! [VarCurr: state_type] :
      ( v59054(VarCurr)
    <=> ( v59042(VarCurr)
      <~> v59046(VarCurr) ) ) ).

tff(addAssignment_34844,axiom,
    ! [VarCurr: state_type] :
      ( v59050(VarCurr)
    <=> v59052(VarCurr) ) ).

tff(addAssignment_34843,axiom,
    ! [VarCurr: state_type] :
      ( v59052(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_34842,axiom,
    ! [VarCurr: state_type] :
      ( v59046(VarCurr)
    <=> v59048(VarCurr) ) ).

tff(addAssignment_34841,axiom,
    ! [VarCurr: state_type] :
      ( v59048(VarCurr)
    <=> v6017(VarCurr,120) ) ).

tff(addAssignment_34840,axiom,
    ! [VarCurr: state_type] :
      ( v59042(VarCurr)
    <=> v59044(VarCurr) ) ).

tff(addAssignment_34839,axiom,
    ! [VarCurr: state_type] :
      ( v59044(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_34838,axiom,
    ! [VarCurr: state_type] :
      ( v58758(VarCurr)
    <=> v58760(VarCurr) ) ).

tff(addAssignment_34837,axiom,
    ! [VarCurr: state_type] :
      ( v58760(VarCurr)
    <=> v58762(VarCurr) ) ).

tff(addAssignment_34836,axiom,
    ! [VarCurr: state_type] :
      ( v58762(VarCurr)
    <=> v58764(VarCurr) ) ).

tff(addAssignment_34835,axiom,
    ! [VarCurr: state_type] :
      ( v58764(VarCurr)
    <=> v58766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5604,axiom,
    ! [VarCurr: state_type] :
      ( v58766(VarCurr)
    <=> ( v59020(VarCurr)
      <~> v58936(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5603,axiom,
    ! [VarCurr: state_type] :
      ( v59020(VarCurr)
    <=> ( v58768(VarCurr)
      <~> v58852(VarCurr) ) ) ).

tff(addAssignment_34834,axiom,
    ! [VarCurr: state_type] :
      ( v58936(VarCurr)
    <=> v58938(VarCurr) ) ).

tff(addAssignment_34833,axiom,
    ! [VarCurr: state_type] :
      ( v58938(VarCurr)
    <=> v58940(VarCurr) ) ).

tff(addAssignment_34832,axiom,
    ! [VarCurr: state_type] :
      ( v58940(VarCurr)
    <=> v58942(VarCurr) ) ).

tff(addAssignment_34831,axiom,
    ! [VarCurr: state_type] :
      ( v58942(VarCurr)
    <=> v58944(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5602,axiom,
    ! [VarCurr: state_type] :
      ( v58944(VarCurr)
    <=> ( v59018(VarCurr)
      <~> v58994(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5601,axiom,
    ! [VarCurr: state_type] :
      ( v59018(VarCurr)
    <=> ( v58946(VarCurr)
      <~> v58970(VarCurr) ) ) ).

tff(addAssignment_34830,axiom,
    ! [VarCurr: state_type] :
      ( v58994(VarCurr)
    <=> v58996(VarCurr) ) ).

tff(addAssignment_34829,axiom,
    ! [VarCurr: state_type] :
      ( v58996(VarCurr)
    <=> v58998(VarCurr) ) ).

tff(addAssignment_34828,axiom,
    ! [VarCurr: state_type] :
      ( v58998(VarCurr)
    <=> v59000(VarCurr) ) ).

tff(addAssignment_34827,axiom,
    ! [VarCurr: state_type] :
      ( v59000(VarCurr)
    <=> v59002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5600,axiom,
    ! [VarCurr: state_type] :
      ( v59002(VarCurr)
    <=> ( v59016(VarCurr)
      <~> v59012(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5599,axiom,
    ! [VarCurr: state_type] :
      ( v59016(VarCurr)
    <=> ( v59004(VarCurr)
      <~> v59008(VarCurr) ) ) ).

tff(addAssignment_34826,axiom,
    ! [VarCurr: state_type] :
      ( v59012(VarCurr)
    <=> v59014(VarCurr) ) ).

tff(addAssignment_34825,axiom,
    ! [VarCurr: state_type] :
      ( v59014(VarCurr)
    <=> v6017(VarCurr,95) ) ).

tff(addAssignment_34824,axiom,
    ! [VarCurr: state_type] :
      ( v59008(VarCurr)
    <=> v59010(VarCurr) ) ).

tff(addAssignment_34823,axiom,
    ! [VarCurr: state_type] :
      ( v59010(VarCurr)
    <=> v6017(VarCurr,91) ) ).

tff(addAssignment_34822,axiom,
    ! [VarCurr: state_type] :
      ( v59004(VarCurr)
    <=> v59006(VarCurr) ) ).

tff(addAssignment_34821,axiom,
    ! [VarCurr: state_type] :
      ( v59006(VarCurr)
    <=> v6017(VarCurr,90) ) ).

tff(addAssignment_34820,axiom,
    ! [VarCurr: state_type] :
      ( v58970(VarCurr)
    <=> v58972(VarCurr) ) ).

tff(addAssignment_34819,axiom,
    ! [VarCurr: state_type] :
      ( v58972(VarCurr)
    <=> v58974(VarCurr) ) ).

tff(addAssignment_34818,axiom,
    ! [VarCurr: state_type] :
      ( v58974(VarCurr)
    <=> v58976(VarCurr) ) ).

tff(addAssignment_34817,axiom,
    ! [VarCurr: state_type] :
      ( v58976(VarCurr)
    <=> v58978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5598,axiom,
    ! [VarCurr: state_type] :
      ( v58978(VarCurr)
    <=> ( v58992(VarCurr)
      <~> v58988(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5597,axiom,
    ! [VarCurr: state_type] :
      ( v58992(VarCurr)
    <=> ( v58980(VarCurr)
      <~> v58984(VarCurr) ) ) ).

tff(addAssignment_34816,axiom,
    ! [VarCurr: state_type] :
      ( v58988(VarCurr)
    <=> v58990(VarCurr) ) ).

tff(addAssignment_34815,axiom,
    ! [VarCurr: state_type] :
      ( v58990(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_34814,axiom,
    ! [VarCurr: state_type] :
      ( v58984(VarCurr)
    <=> v58986(VarCurr) ) ).

tff(addAssignment_34813,axiom,
    ! [VarCurr: state_type] :
      ( v58986(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_34812,axiom,
    ! [VarCurr: state_type] :
      ( v58980(VarCurr)
    <=> v58982(VarCurr) ) ).

tff(addAssignment_34811,axiom,
    ! [VarCurr: state_type] :
      ( v58982(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_34810,axiom,
    ! [VarCurr: state_type] :
      ( v58946(VarCurr)
    <=> v58948(VarCurr) ) ).

tff(addAssignment_34809,axiom,
    ! [VarCurr: state_type] :
      ( v58948(VarCurr)
    <=> v58950(VarCurr) ) ).

tff(addAssignment_34808,axiom,
    ! [VarCurr: state_type] :
      ( v58950(VarCurr)
    <=> v58952(VarCurr) ) ).

tff(addAssignment_34807,axiom,
    ! [VarCurr: state_type] :
      ( v58952(VarCurr)
    <=> v58954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5596,axiom,
    ! [VarCurr: state_type] :
      ( v58954(VarCurr)
    <=> ( v58968(VarCurr)
      <~> v58964(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5595,axiom,
    ! [VarCurr: state_type] :
      ( v58968(VarCurr)
    <=> ( v58956(VarCurr)
      <~> v58960(VarCurr) ) ) ).

tff(addAssignment_34806,axiom,
    ! [VarCurr: state_type] :
      ( v58964(VarCurr)
    <=> v58966(VarCurr) ) ).

tff(addAssignment_34805,axiom,
    ! [VarCurr: state_type] :
      ( v58966(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_34804,axiom,
    ! [VarCurr: state_type] :
      ( v58960(VarCurr)
    <=> v58962(VarCurr) ) ).

tff(addAssignment_34803,axiom,
    ! [VarCurr: state_type] :
      ( v58962(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_34802,axiom,
    ! [VarCurr: state_type] :
      ( v58956(VarCurr)
    <=> v58958(VarCurr) ) ).

tff(addAssignment_34801,axiom,
    ! [VarCurr: state_type] :
      ( v58958(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_34800,axiom,
    ! [VarCurr: state_type] :
      ( v58852(VarCurr)
    <=> v58854(VarCurr) ) ).

tff(addAssignment_34799,axiom,
    ! [VarCurr: state_type] :
      ( v58854(VarCurr)
    <=> v58856(VarCurr) ) ).

tff(addAssignment_34798,axiom,
    ! [VarCurr: state_type] :
      ( v58856(VarCurr)
    <=> v58858(VarCurr) ) ).

tff(addAssignment_34797,axiom,
    ! [VarCurr: state_type] :
      ( v58858(VarCurr)
    <=> v58860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5594,axiom,
    ! [VarCurr: state_type] :
      ( v58860(VarCurr)
    <=> ( v58934(VarCurr)
      <~> v58910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5593,axiom,
    ! [VarCurr: state_type] :
      ( v58934(VarCurr)
    <=> ( v58862(VarCurr)
      <~> v58886(VarCurr) ) ) ).

tff(addAssignment_34796,axiom,
    ! [VarCurr: state_type] :
      ( v58910(VarCurr)
    <=> v58912(VarCurr) ) ).

tff(addAssignment_34795,axiom,
    ! [VarCurr: state_type] :
      ( v58912(VarCurr)
    <=> v58914(VarCurr) ) ).

tff(addAssignment_34794,axiom,
    ! [VarCurr: state_type] :
      ( v58914(VarCurr)
    <=> v58916(VarCurr) ) ).

tff(addAssignment_34793,axiom,
    ! [VarCurr: state_type] :
      ( v58916(VarCurr)
    <=> v58918(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5592,axiom,
    ! [VarCurr: state_type] :
      ( v58918(VarCurr)
    <=> ( v58932(VarCurr)
      <~> v58928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5591,axiom,
    ! [VarCurr: state_type] :
      ( v58932(VarCurr)
    <=> ( v58920(VarCurr)
      <~> v58924(VarCurr) ) ) ).

tff(addAssignment_34792,axiom,
    ! [VarCurr: state_type] :
      ( v58928(VarCurr)
    <=> v58930(VarCurr) ) ).

tff(addAssignment_34791,axiom,
    ! [VarCurr: state_type] :
      ( v58930(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_34790,axiom,
    ! [VarCurr: state_type] :
      ( v58924(VarCurr)
    <=> v58926(VarCurr) ) ).

tff(addAssignment_34789,axiom,
    ! [VarCurr: state_type] :
      ( v58926(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_34788,axiom,
    ! [VarCurr: state_type] :
      ( v58920(VarCurr)
    <=> v58922(VarCurr) ) ).

tff(addAssignment_34787,axiom,
    ! [VarCurr: state_type] :
      ( v58922(VarCurr)
    <=> v6017(VarCurr,77) ) ).

tff(addAssignment_34786,axiom,
    ! [VarCurr: state_type] :
      ( v58886(VarCurr)
    <=> v58888(VarCurr) ) ).

tff(addAssignment_34785,axiom,
    ! [VarCurr: state_type] :
      ( v58888(VarCurr)
    <=> v58890(VarCurr) ) ).

tff(addAssignment_34784,axiom,
    ! [VarCurr: state_type] :
      ( v58890(VarCurr)
    <=> v58892(VarCurr) ) ).

tff(addAssignment_34783,axiom,
    ! [VarCurr: state_type] :
      ( v58892(VarCurr)
    <=> v58894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5590,axiom,
    ! [VarCurr: state_type] :
      ( v58894(VarCurr)
    <=> ( v58908(VarCurr)
      <~> v58904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5589,axiom,
    ! [VarCurr: state_type] :
      ( v58908(VarCurr)
    <=> ( v58896(VarCurr)
      <~> v58900(VarCurr) ) ) ).

tff(addAssignment_34782,axiom,
    ! [VarCurr: state_type] :
      ( v58904(VarCurr)
    <=> v58906(VarCurr) ) ).

tff(addAssignment_34781,axiom,
    ! [VarCurr: state_type] :
      ( v58906(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_34780,axiom,
    ! [VarCurr: state_type] :
      ( v58900(VarCurr)
    <=> v58902(VarCurr) ) ).

tff(addAssignment_34779,axiom,
    ! [VarCurr: state_type] :
      ( v58902(VarCurr)
    <=> v6017(VarCurr,74) ) ).

tff(addAssignment_34778,axiom,
    ! [VarCurr: state_type] :
      ( v58896(VarCurr)
    <=> v58898(VarCurr) ) ).

tff(addAssignment_34777,axiom,
    ! [VarCurr: state_type] :
      ( v58898(VarCurr)
    <=> v6017(VarCurr,73) ) ).

tff(addAssignment_34776,axiom,
    ! [VarCurr: state_type] :
      ( v58862(VarCurr)
    <=> v58864(VarCurr) ) ).

tff(addAssignment_34775,axiom,
    ! [VarCurr: state_type] :
      ( v58864(VarCurr)
    <=> v58866(VarCurr) ) ).

tff(addAssignment_34774,axiom,
    ! [VarCurr: state_type] :
      ( v58866(VarCurr)
    <=> v58868(VarCurr) ) ).

tff(addAssignment_34773,axiom,
    ! [VarCurr: state_type] :
      ( v58868(VarCurr)
    <=> v58870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5588,axiom,
    ! [VarCurr: state_type] :
      ( v58870(VarCurr)
    <=> ( v58884(VarCurr)
      <~> v58880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5587,axiom,
    ! [VarCurr: state_type] :
      ( v58884(VarCurr)
    <=> ( v58872(VarCurr)
      <~> v58876(VarCurr) ) ) ).

tff(addAssignment_34772,axiom,
    ! [VarCurr: state_type] :
      ( v58880(VarCurr)
    <=> v58882(VarCurr) ) ).

tff(addAssignment_34771,axiom,
    ! [VarCurr: state_type] :
      ( v58882(VarCurr)
    <=> v6017(VarCurr,72) ) ).

tff(addAssignment_34770,axiom,
    ! [VarCurr: state_type] :
      ( v58876(VarCurr)
    <=> v58878(VarCurr) ) ).

tff(addAssignment_34769,axiom,
    ! [VarCurr: state_type] :
      ( v58878(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_34768,axiom,
    ! [VarCurr: state_type] :
      ( v58872(VarCurr)
    <=> v58874(VarCurr) ) ).

tff(addAssignment_34767,axiom,
    ! [VarCurr: state_type] :
      ( v58874(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_34766,axiom,
    ! [VarCurr: state_type] :
      ( v58768(VarCurr)
    <=> v58770(VarCurr) ) ).

tff(addAssignment_34765,axiom,
    ! [VarCurr: state_type] :
      ( v58770(VarCurr)
    <=> v58772(VarCurr) ) ).

tff(addAssignment_34764,axiom,
    ! [VarCurr: state_type] :
      ( v58772(VarCurr)
    <=> v58774(VarCurr) ) ).

tff(addAssignment_34763,axiom,
    ! [VarCurr: state_type] :
      ( v58774(VarCurr)
    <=> v58776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5586,axiom,
    ! [VarCurr: state_type] :
      ( v58776(VarCurr)
    <=> ( v58850(VarCurr)
      <~> v58826(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5585,axiom,
    ! [VarCurr: state_type] :
      ( v58850(VarCurr)
    <=> ( v58778(VarCurr)
      <~> v58802(VarCurr) ) ) ).

tff(addAssignment_34762,axiom,
    ! [VarCurr: state_type] :
      ( v58826(VarCurr)
    <=> v58828(VarCurr) ) ).

tff(addAssignment_34761,axiom,
    ! [VarCurr: state_type] :
      ( v58828(VarCurr)
    <=> v58830(VarCurr) ) ).

tff(addAssignment_34760,axiom,
    ! [VarCurr: state_type] :
      ( v58830(VarCurr)
    <=> v58832(VarCurr) ) ).

tff(addAssignment_34759,axiom,
    ! [VarCurr: state_type] :
      ( v58832(VarCurr)
    <=> v58834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5584,axiom,
    ! [VarCurr: state_type] :
      ( v58834(VarCurr)
    <=> ( v58848(VarCurr)
      <~> v58844(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5583,axiom,
    ! [VarCurr: state_type] :
      ( v58848(VarCurr)
    <=> ( v58836(VarCurr)
      <~> v58840(VarCurr) ) ) ).

tff(addAssignment_34758,axiom,
    ! [VarCurr: state_type] :
      ( v58844(VarCurr)
    <=> v58846(VarCurr) ) ).

tff(addAssignment_34757,axiom,
    ! [VarCurr: state_type] :
      ( v58846(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_34756,axiom,
    ! [VarCurr: state_type] :
      ( v58840(VarCurr)
    <=> v58842(VarCurr) ) ).

tff(addAssignment_34755,axiom,
    ! [VarCurr: state_type] :
      ( v58842(VarCurr)
    <=> v6017(VarCurr,65) ) ).

tff(addAssignment_34754,axiom,
    ! [VarCurr: state_type] :
      ( v58836(VarCurr)
    <=> v58838(VarCurr) ) ).

tff(addAssignment_34753,axiom,
    ! [VarCurr: state_type] :
      ( v58838(VarCurr)
    <=> v6017(VarCurr,64) ) ).

tff(addAssignment_34752,axiom,
    ! [VarCurr: state_type] :
      ( v58802(VarCurr)
    <=> v58804(VarCurr) ) ).

tff(addAssignment_34751,axiom,
    ! [VarCurr: state_type] :
      ( v58804(VarCurr)
    <=> v58806(VarCurr) ) ).

tff(addAssignment_34750,axiom,
    ! [VarCurr: state_type] :
      ( v58806(VarCurr)
    <=> v58808(VarCurr) ) ).

tff(addAssignment_34749,axiom,
    ! [VarCurr: state_type] :
      ( v58808(VarCurr)
    <=> v58810(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5582,axiom,
    ! [VarCurr: state_type] :
      ( v58810(VarCurr)
    <=> ( v58824(VarCurr)
      <~> v58820(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5581,axiom,
    ! [VarCurr: state_type] :
      ( v58824(VarCurr)
    <=> ( v58812(VarCurr)
      <~> v58816(VarCurr) ) ) ).

tff(addAssignment_34748,axiom,
    ! [VarCurr: state_type] :
      ( v58820(VarCurr)
    <=> v58822(VarCurr) ) ).

tff(addAssignment_34747,axiom,
    ! [VarCurr: state_type] :
      ( v58822(VarCurr)
    <=> v6017(VarCurr,60) ) ).

tff(addAssignment_34746,axiom,
    ! [VarCurr: state_type] :
      ( v58816(VarCurr)
    <=> v58818(VarCurr) ) ).

tff(addAssignment_34745,axiom,
    ! [VarCurr: state_type] :
      ( v58818(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_34744,axiom,
    ! [VarCurr: state_type] :
      ( v58812(VarCurr)
    <=> v58814(VarCurr) ) ).

tff(addAssignment_34743,axiom,
    ! [VarCurr: state_type] :
      ( v58814(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_34742,axiom,
    ! [VarCurr: state_type] :
      ( v58778(VarCurr)
    <=> v58780(VarCurr) ) ).

tff(addAssignment_34741,axiom,
    ! [VarCurr: state_type] :
      ( v58780(VarCurr)
    <=> v58782(VarCurr) ) ).

tff(addAssignment_34740,axiom,
    ! [VarCurr: state_type] :
      ( v58782(VarCurr)
    <=> v58784(VarCurr) ) ).

tff(addAssignment_34739,axiom,
    ! [VarCurr: state_type] :
      ( v58784(VarCurr)
    <=> v58786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5580,axiom,
    ! [VarCurr: state_type] :
      ( v58786(VarCurr)
    <=> ( v58800(VarCurr)
      <~> v58796(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5579,axiom,
    ! [VarCurr: state_type] :
      ( v58800(VarCurr)
    <=> ( v58788(VarCurr)
      <~> v58792(VarCurr) ) ) ).

tff(addAssignment_34738,axiom,
    ! [VarCurr: state_type] :
      ( v58796(VarCurr)
    <=> v58798(VarCurr) ) ).

tff(addAssignment_34737,axiom,
    ! [VarCurr: state_type] :
      ( v58798(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_34736,axiom,
    ! [VarCurr: state_type] :
      ( v58792(VarCurr)
    <=> v58794(VarCurr) ) ).

tff(addAssignment_34735,axiom,
    ! [VarCurr: state_type] :
      ( v58794(VarCurr)
    <=> v6017(VarCurr,50) ) ).

tff(addAssignment_34734,axiom,
    ! [VarCurr: state_type] :
      ( v58788(VarCurr)
    <=> v58790(VarCurr) ) ).

tff(addAssignment_34733,axiom,
    ! [VarCurr: state_type] :
      ( v58790(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_34732,axiom,
    ! [VarCurr: state_type] :
      ( v58494(VarCurr)
    <=> v58496(VarCurr) ) ).

tff(addAssignment_34731,axiom,
    ! [VarCurr: state_type] :
      ( v58496(VarCurr)
    <=> v58498(VarCurr) ) ).

tff(addAssignment_34730,axiom,
    ! [VarCurr: state_type] :
      ( v58498(VarCurr)
    <=> v58500(VarCurr) ) ).

tff(addAssignment_34729,axiom,
    ! [VarCurr: state_type] :
      ( v58500(VarCurr)
    <=> v58502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5578,axiom,
    ! [VarCurr: state_type] :
      ( v58502(VarCurr)
    <=> ( v58756(VarCurr)
      <~> v58672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5577,axiom,
    ! [VarCurr: state_type] :
      ( v58756(VarCurr)
    <=> ( v58504(VarCurr)
      <~> v58588(VarCurr) ) ) ).

tff(addAssignment_34728,axiom,
    ! [VarCurr: state_type] :
      ( v58672(VarCurr)
    <=> v58674(VarCurr) ) ).

tff(addAssignment_34727,axiom,
    ! [VarCurr: state_type] :
      ( v58674(VarCurr)
    <=> v58676(VarCurr) ) ).

tff(addAssignment_34726,axiom,
    ! [VarCurr: state_type] :
      ( v58676(VarCurr)
    <=> v58678(VarCurr) ) ).

tff(addAssignment_34725,axiom,
    ! [VarCurr: state_type] :
      ( v58678(VarCurr)
    <=> v58680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5576,axiom,
    ! [VarCurr: state_type] :
      ( v58680(VarCurr)
    <=> ( v58754(VarCurr)
      <~> v58730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5575,axiom,
    ! [VarCurr: state_type] :
      ( v58754(VarCurr)
    <=> ( v58682(VarCurr)
      <~> v58706(VarCurr) ) ) ).

tff(addAssignment_34724,axiom,
    ! [VarCurr: state_type] :
      ( v58730(VarCurr)
    <=> v58732(VarCurr) ) ).

tff(addAssignment_34723,axiom,
    ! [VarCurr: state_type] :
      ( v58732(VarCurr)
    <=> v58734(VarCurr) ) ).

tff(addAssignment_34722,axiom,
    ! [VarCurr: state_type] :
      ( v58734(VarCurr)
    <=> v58736(VarCurr) ) ).

tff(addAssignment_34721,axiom,
    ! [VarCurr: state_type] :
      ( v58736(VarCurr)
    <=> v58738(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5574,axiom,
    ! [VarCurr: state_type] :
      ( v58738(VarCurr)
    <=> ( v58752(VarCurr)
      <~> v58748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5573,axiom,
    ! [VarCurr: state_type] :
      ( v58752(VarCurr)
    <=> ( v58740(VarCurr)
      <~> v58744(VarCurr) ) ) ).

tff(addAssignment_34720,axiom,
    ! [VarCurr: state_type] :
      ( v58748(VarCurr)
    <=> v58750(VarCurr) ) ).

tff(addAssignment_34719,axiom,
    ! [VarCurr: state_type] :
      ( v58750(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_34718,axiom,
    ! [VarCurr: state_type] :
      ( v58744(VarCurr)
    <=> v58746(VarCurr) ) ).

tff(addAssignment_34717,axiom,
    ! [VarCurr: state_type] :
      ( v58746(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_34716,axiom,
    ! [VarCurr: state_type] :
      ( v58740(VarCurr)
    <=> v58742(VarCurr) ) ).

tff(addAssignment_34715,axiom,
    ! [VarCurr: state_type] :
      ( v58742(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_34714,axiom,
    ! [VarCurr: state_type] :
      ( v58706(VarCurr)
    <=> v58708(VarCurr) ) ).

tff(addAssignment_34713,axiom,
    ! [VarCurr: state_type] :
      ( v58708(VarCurr)
    <=> v58710(VarCurr) ) ).

tff(addAssignment_34712,axiom,
    ! [VarCurr: state_type] :
      ( v58710(VarCurr)
    <=> v58712(VarCurr) ) ).

tff(addAssignment_34711,axiom,
    ! [VarCurr: state_type] :
      ( v58712(VarCurr)
    <=> v58714(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5572,axiom,
    ! [VarCurr: state_type] :
      ( v58714(VarCurr)
    <=> ( v58728(VarCurr)
      <~> v58724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5571,axiom,
    ! [VarCurr: state_type] :
      ( v58728(VarCurr)
    <=> ( v58716(VarCurr)
      <~> v58720(VarCurr) ) ) ).

tff(addAssignment_34710,axiom,
    ! [VarCurr: state_type] :
      ( v58724(VarCurr)
    <=> v58726(VarCurr) ) ).

tff(addAssignment_34709,axiom,
    ! [VarCurr: state_type] :
      ( v58726(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_34708,axiom,
    ! [VarCurr: state_type] :
      ( v58720(VarCurr)
    <=> v58722(VarCurr) ) ).

tff(addAssignment_34707,axiom,
    ! [VarCurr: state_type] :
      ( v58722(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_34706,axiom,
    ! [VarCurr: state_type] :
      ( v58716(VarCurr)
    <=> v58718(VarCurr) ) ).

tff(addAssignment_34705,axiom,
    ! [VarCurr: state_type] :
      ( v58718(VarCurr)
    <=> v6017(VarCurr,35) ) ).

tff(addAssignment_34704,axiom,
    ! [VarCurr: state_type] :
      ( v58682(VarCurr)
    <=> v58684(VarCurr) ) ).

tff(addAssignment_34703,axiom,
    ! [VarCurr: state_type] :
      ( v58684(VarCurr)
    <=> v58686(VarCurr) ) ).

tff(addAssignment_34702,axiom,
    ! [VarCurr: state_type] :
      ( v58686(VarCurr)
    <=> v58688(VarCurr) ) ).

tff(addAssignment_34701,axiom,
    ! [VarCurr: state_type] :
      ( v58688(VarCurr)
    <=> v58690(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5570,axiom,
    ! [VarCurr: state_type] :
      ( v58690(VarCurr)
    <=> ( v58704(VarCurr)
      <~> v58700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5569,axiom,
    ! [VarCurr: state_type] :
      ( v58704(VarCurr)
    <=> ( v58692(VarCurr)
      <~> v58696(VarCurr) ) ) ).

tff(addAssignment_34700,axiom,
    ! [VarCurr: state_type] :
      ( v58700(VarCurr)
    <=> v58702(VarCurr) ) ).

tff(addAssignment_34699,axiom,
    ! [VarCurr: state_type] :
      ( v58702(VarCurr)
    <=> v6017(VarCurr,31) ) ).

tff(addAssignment_34698,axiom,
    ! [VarCurr: state_type] :
      ( v58696(VarCurr)
    <=> v58698(VarCurr) ) ).

tff(addAssignment_34697,axiom,
    ! [VarCurr: state_type] :
      ( v58698(VarCurr)
    <=> v6017(VarCurr,30) ) ).

tff(addAssignment_34696,axiom,
    ! [VarCurr: state_type] :
      ( v58692(VarCurr)
    <=> v58694(VarCurr) ) ).

tff(addAssignment_34695,axiom,
    ! [VarCurr: state_type] :
      ( v58694(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_34694,axiom,
    ! [VarCurr: state_type] :
      ( v58588(VarCurr)
    <=> v58590(VarCurr) ) ).

tff(addAssignment_34693,axiom,
    ! [VarCurr: state_type] :
      ( v58590(VarCurr)
    <=> v58592(VarCurr) ) ).

tff(addAssignment_34692,axiom,
    ! [VarCurr: state_type] :
      ( v58592(VarCurr)
    <=> v58594(VarCurr) ) ).

tff(addAssignment_34691,axiom,
    ! [VarCurr: state_type] :
      ( v58594(VarCurr)
    <=> v58596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5568,axiom,
    ! [VarCurr: state_type] :
      ( v58596(VarCurr)
    <=> ( v58670(VarCurr)
      <~> v58646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5567,axiom,
    ! [VarCurr: state_type] :
      ( v58670(VarCurr)
    <=> ( v58598(VarCurr)
      <~> v58622(VarCurr) ) ) ).

tff(addAssignment_34690,axiom,
    ! [VarCurr: state_type] :
      ( v58646(VarCurr)
    <=> v58648(VarCurr) ) ).

tff(addAssignment_34689,axiom,
    ! [VarCurr: state_type] :
      ( v58648(VarCurr)
    <=> v58650(VarCurr) ) ).

tff(addAssignment_34688,axiom,
    ! [VarCurr: state_type] :
      ( v58650(VarCurr)
    <=> v58652(VarCurr) ) ).

tff(addAssignment_34687,axiom,
    ! [VarCurr: state_type] :
      ( v58652(VarCurr)
    <=> v58654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5566,axiom,
    ! [VarCurr: state_type] :
      ( v58654(VarCurr)
    <=> ( v58668(VarCurr)
      <~> v58664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5565,axiom,
    ! [VarCurr: state_type] :
      ( v58668(VarCurr)
    <=> ( v58656(VarCurr)
      <~> v58660(VarCurr) ) ) ).

tff(addAssignment_34686,axiom,
    ! [VarCurr: state_type] :
      ( v58664(VarCurr)
    <=> v58666(VarCurr) ) ).

tff(addAssignment_34685,axiom,
    ! [VarCurr: state_type] :
      ( v58666(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_34684,axiom,
    ! [VarCurr: state_type] :
      ( v58660(VarCurr)
    <=> v58662(VarCurr) ) ).

tff(addAssignment_34683,axiom,
    ! [VarCurr: state_type] :
      ( v58662(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_34682,axiom,
    ! [VarCurr: state_type] :
      ( v58656(VarCurr)
    <=> v58658(VarCurr) ) ).

tff(addAssignment_34681,axiom,
    ! [VarCurr: state_type] :
      ( v58658(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_34680,axiom,
    ! [VarCurr: state_type] :
      ( v58622(VarCurr)
    <=> v58624(VarCurr) ) ).

tff(addAssignment_34679,axiom,
    ! [VarCurr: state_type] :
      ( v58624(VarCurr)
    <=> v58626(VarCurr) ) ).

tff(addAssignment_34678,axiom,
    ! [VarCurr: state_type] :
      ( v58626(VarCurr)
    <=> v58628(VarCurr) ) ).

tff(addAssignment_34677,axiom,
    ! [VarCurr: state_type] :
      ( v58628(VarCurr)
    <=> v58630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5564,axiom,
    ! [VarCurr: state_type] :
      ( v58630(VarCurr)
    <=> ( v58644(VarCurr)
      <~> v58640(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5563,axiom,
    ! [VarCurr: state_type] :
      ( v58644(VarCurr)
    <=> ( v58632(VarCurr)
      <~> v58636(VarCurr) ) ) ).

tff(addAssignment_34676,axiom,
    ! [VarCurr: state_type] :
      ( v58640(VarCurr)
    <=> v58642(VarCurr) ) ).

tff(addAssignment_34675,axiom,
    ! [VarCurr: state_type] :
      ( v58642(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_34674,axiom,
    ! [VarCurr: state_type] :
      ( v58636(VarCurr)
    <=> v58638(VarCurr) ) ).

tff(addAssignment_34673,axiom,
    ! [VarCurr: state_type] :
      ( v58638(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_34672,axiom,
    ! [VarCurr: state_type] :
      ( v58632(VarCurr)
    <=> v58634(VarCurr) ) ).

tff(addAssignment_34671,axiom,
    ! [VarCurr: state_type] :
      ( v58634(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_34670,axiom,
    ! [VarCurr: state_type] :
      ( v58598(VarCurr)
    <=> v58600(VarCurr) ) ).

tff(addAssignment_34669,axiom,
    ! [VarCurr: state_type] :
      ( v58600(VarCurr)
    <=> v58602(VarCurr) ) ).

tff(addAssignment_34668,axiom,
    ! [VarCurr: state_type] :
      ( v58602(VarCurr)
    <=> v58604(VarCurr) ) ).

tff(addAssignment_34667,axiom,
    ! [VarCurr: state_type] :
      ( v58604(VarCurr)
    <=> v58606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5562,axiom,
    ! [VarCurr: state_type] :
      ( v58606(VarCurr)
    <=> ( v58620(VarCurr)
      <~> v58616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5561,axiom,
    ! [VarCurr: state_type] :
      ( v58620(VarCurr)
    <=> ( v58608(VarCurr)
      <~> v58612(VarCurr) ) ) ).

tff(addAssignment_34666,axiom,
    ! [VarCurr: state_type] :
      ( v58616(VarCurr)
    <=> v58618(VarCurr) ) ).

tff(addAssignment_34665,axiom,
    ! [VarCurr: state_type] :
      ( v58618(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_34664,axiom,
    ! [VarCurr: state_type] :
      ( v58612(VarCurr)
    <=> v58614(VarCurr) ) ).

tff(addAssignment_34663,axiom,
    ! [VarCurr: state_type] :
      ( v58614(VarCurr)
    <=> v6017(VarCurr,17) ) ).

tff(addAssignment_34662,axiom,
    ! [VarCurr: state_type] :
      ( v58608(VarCurr)
    <=> v58610(VarCurr) ) ).

tff(addAssignment_34661,axiom,
    ! [VarCurr: state_type] :
      ( v58610(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_34660,axiom,
    ! [VarCurr: state_type] :
      ( v58504(VarCurr)
    <=> v58506(VarCurr) ) ).

tff(addAssignment_34659,axiom,
    ! [VarCurr: state_type] :
      ( v58506(VarCurr)
    <=> v58508(VarCurr) ) ).

tff(addAssignment_34658,axiom,
    ! [VarCurr: state_type] :
      ( v58508(VarCurr)
    <=> v58510(VarCurr) ) ).

tff(addAssignment_34657,axiom,
    ! [VarCurr: state_type] :
      ( v58510(VarCurr)
    <=> v58512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5560,axiom,
    ! [VarCurr: state_type] :
      ( v58512(VarCurr)
    <=> ( v58586(VarCurr)
      <~> v58562(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5559,axiom,
    ! [VarCurr: state_type] :
      ( v58586(VarCurr)
    <=> ( v58514(VarCurr)
      <~> v58538(VarCurr) ) ) ).

tff(addAssignment_34656,axiom,
    ! [VarCurr: state_type] :
      ( v58562(VarCurr)
    <=> v58564(VarCurr) ) ).

tff(addAssignment_34655,axiom,
    ! [VarCurr: state_type] :
      ( v58564(VarCurr)
    <=> v58566(VarCurr) ) ).

tff(addAssignment_34654,axiom,
    ! [VarCurr: state_type] :
      ( v58566(VarCurr)
    <=> v58568(VarCurr) ) ).

tff(addAssignment_34653,axiom,
    ! [VarCurr: state_type] :
      ( v58568(VarCurr)
    <=> v58570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5558,axiom,
    ! [VarCurr: state_type] :
      ( v58570(VarCurr)
    <=> ( v58584(VarCurr)
      <~> v58580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5557,axiom,
    ! [VarCurr: state_type] :
      ( v58584(VarCurr)
    <=> ( v58572(VarCurr)
      <~> v58576(VarCurr) ) ) ).

tff(addAssignment_34652,axiom,
    ! [VarCurr: state_type] :
      ( v58580(VarCurr)
    <=> v58582(VarCurr) ) ).

tff(addAssignment_34651,axiom,
    ! [VarCurr: state_type] :
      ( v58582(VarCurr)
    <=> v6017(VarCurr,14) ) ).

tff(addAssignment_34650,axiom,
    ! [VarCurr: state_type] :
      ( v58576(VarCurr)
    <=> v58578(VarCurr) ) ).

tff(addAssignment_34649,axiom,
    ! [VarCurr: state_type] :
      ( v58578(VarCurr)
    <=> v6017(VarCurr,13) ) ).

tff(addAssignment_34648,axiom,
    ! [VarCurr: state_type] :
      ( v58572(VarCurr)
    <=> v58574(VarCurr) ) ).

tff(addAssignment_34647,axiom,
    ! [VarCurr: state_type] :
      ( v58574(VarCurr)
    <=> v6017(VarCurr,12) ) ).

tff(addAssignment_34646,axiom,
    ! [VarCurr: state_type] :
      ( v58538(VarCurr)
    <=> v58540(VarCurr) ) ).

tff(addAssignment_34645,axiom,
    ! [VarCurr: state_type] :
      ( v58540(VarCurr)
    <=> v58542(VarCurr) ) ).

tff(addAssignment_34644,axiom,
    ! [VarCurr: state_type] :
      ( v58542(VarCurr)
    <=> v58544(VarCurr) ) ).

tff(addAssignment_34643,axiom,
    ! [VarCurr: state_type] :
      ( v58544(VarCurr)
    <=> v58546(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5556,axiom,
    ! [VarCurr: state_type] :
      ( v58546(VarCurr)
    <=> ( v58560(VarCurr)
      <~> v58556(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5555,axiom,
    ! [VarCurr: state_type] :
      ( v58560(VarCurr)
    <=> ( v58548(VarCurr)
      <~> v58552(VarCurr) ) ) ).

tff(addAssignment_34642,axiom,
    ! [VarCurr: state_type] :
      ( v58556(VarCurr)
    <=> v58558(VarCurr) ) ).

tff(addAssignment_34641,axiom,
    ! [VarCurr: state_type] :
      ( v58558(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_34640,axiom,
    ! [VarCurr: state_type] :
      ( v58552(VarCurr)
    <=> v58554(VarCurr) ) ).

tff(addAssignment_34639,axiom,
    ! [VarCurr: state_type] :
      ( v58554(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_34638,axiom,
    ! [VarCurr: state_type] :
      ( v58548(VarCurr)
    <=> v58550(VarCurr) ) ).

tff(addAssignment_34637,axiom,
    ! [VarCurr: state_type] :
      ( v58550(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_34636,axiom,
    ! [VarCurr: state_type] :
      ( v58514(VarCurr)
    <=> v58516(VarCurr) ) ).

tff(addAssignment_34635,axiom,
    ! [VarCurr: state_type] :
      ( v58516(VarCurr)
    <=> v58518(VarCurr) ) ).

tff(addAssignment_34634,axiom,
    ! [VarCurr: state_type] :
      ( v58518(VarCurr)
    <=> v58520(VarCurr) ) ).

tff(addAssignment_34633,axiom,
    ! [VarCurr: state_type] :
      ( v58520(VarCurr)
    <=> v58522(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5554,axiom,
    ! [VarCurr: state_type] :
      ( v58522(VarCurr)
    <=> ( v58536(VarCurr)
      <~> v58532(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5553,axiom,
    ! [VarCurr: state_type] :
      ( v58536(VarCurr)
    <=> ( v58524(VarCurr)
      <~> v58528(VarCurr) ) ) ).

tff(addAssignment_34632,axiom,
    ! [VarCurr: state_type] :
      ( v58532(VarCurr)
    <=> v58534(VarCurr) ) ).

tff(addAssignment_34631,axiom,
    ! [VarCurr: state_type] :
      ( v58534(VarCurr)
    <=> v6017(VarCurr,5) ) ).

tff(addAssignment_34630,axiom,
    ! [VarCurr: state_type] :
      ( v58528(VarCurr)
    <=> v58530(VarCurr) ) ).

tff(addAssignment_34629,axiom,
    ! [VarCurr: state_type] :
      ( v58530(VarCurr)
    <=> v6017(VarCurr,4) ) ).

tff(addAssignment_34628,axiom,
    ! [VarCurr: state_type] :
      ( v58524(VarCurr)
    <=> v58526(VarCurr) ) ).

tff(addAssignment_34627,axiom,
    ! [VarCurr: state_type] :
      ( v58526(VarCurr)
    <=> v6017(VarCurr,0) ) ).

tff(addAssignment_34626,axiom,
    ! [VarCurr: state_type] :
      ( v57816(VarCurr)
    <=> v57818(VarCurr) ) ).

tff(addAssignment_34625,axiom,
    ! [VarCurr: state_type] :
      ( v57818(VarCurr)
    <=> v56461(VarCurr,1) ) ).

tff(addAssignment_34624,axiom,
    ! [VarCurr: state_type] :
      ( v56461(VarCurr,1)
    <=> v5977(VarCurr,1) ) ).

tff(addAssignment_34623,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,1)
    <=> v5979(VarCurr,1) ) ).

tff(addAssignment_34622,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,1)
    <=> v5981(VarCurr,1) ) ).

tff(addAssignment_34621,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,1)
    <=> v5983(VarCurr,1) ) ).

tff(addAssignment_34620,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,1)
    <=> v5985(VarCurr,1) ) ).

tff(addAssignment_34619,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,1)
    <=> v53672(VarCurr,1) ) ).

tff(addAssignment_34618,axiom,
    ! [VarCurr: state_type] :
      ( v53675(VarCurr,1)
    <=> v57820(VarCurr) ) ).

tff(addAssignment_34617,axiom,
    ! [VarCurr: state_type] :
      ( v57820(VarCurr)
    <=> v57822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5552,axiom,
    ! [VarCurr: state_type] :
      ( v57822(VarCurr)
    <=> ( v58484(VarCurr)
      <~> v58352(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5551,axiom,
    ! [VarCurr: state_type] :
      ( v58484(VarCurr)
    <=> ( v57824(VarCurr)
      <~> v58088(VarCurr) ) ) ).

tff(addAssignment_34616,axiom,
    ! [VarCurr: state_type] :
      ( v58352(VarCurr)
    <=> v58354(VarCurr) ) ).

tff(addAssignment_34615,axiom,
    ! [VarCurr: state_type] :
      ( v58354(VarCurr)
    <=> v58356(VarCurr) ) ).

tff(addAssignment_34614,axiom,
    ! [VarCurr: state_type] :
      ( v58356(VarCurr)
    <=> v58358(VarCurr) ) ).

tff(addAssignment_34613,axiom,
    ! [VarCurr: state_type] :
      ( v58358(VarCurr)
    <=> v58360(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5550,axiom,
    ! [VarCurr: state_type] :
      ( v58360(VarCurr)
    <=> ( v58482(VarCurr)
      <~> v58470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5549,axiom,
    ! [VarCurr: state_type] :
      ( v58482(VarCurr)
    <=> ( v58362(VarCurr)
      <~> v58386(VarCurr) ) ) ).

tff(addAssignment_34612,axiom,
    ! [VarCurr: state_type] :
      ( v58470(VarCurr)
    <=> v58472(VarCurr) ) ).

tff(addAssignment_34611,axiom,
    ! [VarCurr: state_type] :
      ( v58472(VarCurr)
    <=> v57118(VarCurr,1) ) ).

tff(addAssignment_34610,axiom,
    ! [VarCurr: state_type] :
      ( v57118(VarCurr,1)
    <=> v57120(VarCurr,1) ) ).

tff(addAssignment_34609,axiom,
    ! [VarCurr: state_type] :
      ( v57120(VarCurr,1)
    <=> v53454(VarCurr,2) ) ).

tff(addAssignment_34608,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,2)
    <=> v53456(VarCurr,2) ) ).

tff(addAssignment_34607,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,2)
    <=> v58474(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v58475(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v58474(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_755,axiom,
    ! [VarNext: state_type] :
      ( v58475(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v58474(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v58475(VarNext)
      <=> v58476(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v58476(VarNext)
      <=> ( v58478(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v58478(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_34606,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,2)
    <=> v53480(VarCurr,2) ) ).

tff(addAssignment_34605,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,2)
    <=> v53525(VarCurr,2) ) ).

tff(addAssignment_34604,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,1)
    <=> v53312(VarCurr,1) ) ).

tff(addAssignment_34603,axiom,
    ! [VarCurr: state_type] :
      ( v58386(VarCurr)
    <=> v58388(VarCurr) ) ).

tff(addAssignment_34602,axiom,
    ! [VarCurr: state_type] :
      ( v58388(VarCurr)
    <=> v58390(VarCurr) ) ).

tff(addAssignment_34601,axiom,
    ! [VarCurr: state_type] :
      ( v58390(VarCurr)
    <=> v58392(VarCurr) ) ).

tff(addAssignment_34600,axiom,
    ! [VarCurr: state_type] :
      ( v58392(VarCurr)
    <=> v58394(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5546,axiom,
    ! [VarCurr: state_type] :
      ( v58394(VarCurr)
    <=> ( v58468(VarCurr)
      <~> v58444(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5545,axiom,
    ! [VarCurr: state_type] :
      ( v58468(VarCurr)
    <=> ( v58396(VarCurr)
      <~> v58420(VarCurr) ) ) ).

tff(addAssignment_34599,axiom,
    ! [VarCurr: state_type] :
      ( v58444(VarCurr)
    <=> v58446(VarCurr) ) ).

tff(addAssignment_34598,axiom,
    ! [VarCurr: state_type] :
      ( v58446(VarCurr)
    <=> v58448(VarCurr) ) ).

tff(addAssignment_34597,axiom,
    ! [VarCurr: state_type] :
      ( v58448(VarCurr)
    <=> v58450(VarCurr) ) ).

tff(addAssignment_34596,axiom,
    ! [VarCurr: state_type] :
      ( v58450(VarCurr)
    <=> v58452(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5544,axiom,
    ! [VarCurr: state_type] :
      ( v58452(VarCurr)
    <=> ( v58466(VarCurr)
      <~> v58462(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5543,axiom,
    ! [VarCurr: state_type] :
      ( v58466(VarCurr)
    <=> ( v58454(VarCurr)
      <~> v58458(VarCurr) ) ) ).

tff(addAssignment_34595,axiom,
    ! [VarCurr: state_type] :
      ( v58462(VarCurr)
    <=> v58464(VarCurr) ) ).

tff(addAssignment_34594,axiom,
    ! [VarCurr: state_type] :
      ( v58464(VarCurr)
    <=> v6017(VarCurr,118) ) ).

tff(addAssignment_34593,axiom,
    ! [VarCurr: state_type] :
      ( v58458(VarCurr)
    <=> v58460(VarCurr) ) ).

tff(addAssignment_34592,axiom,
    ! [VarCurr: state_type] :
      ( v58460(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_34591,axiom,
    ! [VarCurr: state_type] :
      ( v58454(VarCurr)
    <=> v58456(VarCurr) ) ).

tff(addAssignment_34590,axiom,
    ! [VarCurr: state_type] :
      ( v58456(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_34589,axiom,
    ! [VarCurr: state_type] :
      ( v58420(VarCurr)
    <=> v58422(VarCurr) ) ).

tff(addAssignment_34588,axiom,
    ! [VarCurr: state_type] :
      ( v58422(VarCurr)
    <=> v58424(VarCurr) ) ).

tff(addAssignment_34587,axiom,
    ! [VarCurr: state_type] :
      ( v58424(VarCurr)
    <=> v58426(VarCurr) ) ).

tff(addAssignment_34586,axiom,
    ! [VarCurr: state_type] :
      ( v58426(VarCurr)
    <=> v58428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5542,axiom,
    ! [VarCurr: state_type] :
      ( v58428(VarCurr)
    <=> ( v58442(VarCurr)
      <~> v58438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5541,axiom,
    ! [VarCurr: state_type] :
      ( v58442(VarCurr)
    <=> ( v58430(VarCurr)
      <~> v58434(VarCurr) ) ) ).

tff(addAssignment_34585,axiom,
    ! [VarCurr: state_type] :
      ( v58438(VarCurr)
    <=> v58440(VarCurr) ) ).

tff(addAssignment_34584,axiom,
    ! [VarCurr: state_type] :
      ( v58440(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_34583,axiom,
    ! [VarCurr: state_type] :
      ( v58434(VarCurr)
    <=> v58436(VarCurr) ) ).

tff(addAssignment_34582,axiom,
    ! [VarCurr: state_type] :
      ( v58436(VarCurr)
    <=> v6017(VarCurr,111) ) ).

tff(addAssignment_34581,axiom,
    ! [VarCurr: state_type] :
      ( v58430(VarCurr)
    <=> v58432(VarCurr) ) ).

tff(addAssignment_34580,axiom,
    ! [VarCurr: state_type] :
      ( v58432(VarCurr)
    <=> v6017(VarCurr,110) ) ).

tff(addAssignment_34579,axiom,
    ! [VarCurr: state_type] :
      ( v58396(VarCurr)
    <=> v58398(VarCurr) ) ).

tff(addAssignment_34578,axiom,
    ! [VarCurr: state_type] :
      ( v58398(VarCurr)
    <=> v58400(VarCurr) ) ).

tff(addAssignment_34577,axiom,
    ! [VarCurr: state_type] :
      ( v58400(VarCurr)
    <=> v58402(VarCurr) ) ).

tff(addAssignment_34576,axiom,
    ! [VarCurr: state_type] :
      ( v58402(VarCurr)
    <=> v58404(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5540,axiom,
    ! [VarCurr: state_type] :
      ( v58404(VarCurr)
    <=> ( v58418(VarCurr)
      <~> v58414(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5539,axiom,
    ! [VarCurr: state_type] :
      ( v58418(VarCurr)
    <=> ( v58406(VarCurr)
      <~> v58410(VarCurr) ) ) ).

tff(addAssignment_34575,axiom,
    ! [VarCurr: state_type] :
      ( v58414(VarCurr)
    <=> v58416(VarCurr) ) ).

tff(addAssignment_34574,axiom,
    ! [VarCurr: state_type] :
      ( v58416(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_34573,axiom,
    ! [VarCurr: state_type] :
      ( v58410(VarCurr)
    <=> v58412(VarCurr) ) ).

tff(addAssignment_34572,axiom,
    ! [VarCurr: state_type] :
      ( v58412(VarCurr)
    <=> v6017(VarCurr,104) ) ).

tff(addAssignment_34571,axiom,
    ! [VarCurr: state_type] :
      ( v58406(VarCurr)
    <=> v58408(VarCurr) ) ).

tff(addAssignment_34570,axiom,
    ! [VarCurr: state_type] :
      ( v58408(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_34569,axiom,
    ! [VarCurr: state_type] :
      ( v58362(VarCurr)
    <=> v58364(VarCurr) ) ).

tff(addAssignment_34568,axiom,
    ! [VarCurr: state_type] :
      ( v58364(VarCurr)
    <=> v58366(VarCurr) ) ).

tff(addAssignment_34567,axiom,
    ! [VarCurr: state_type] :
      ( v58366(VarCurr)
    <=> v58368(VarCurr) ) ).

tff(addAssignment_34566,axiom,
    ! [VarCurr: state_type] :
      ( v58368(VarCurr)
    <=> v58370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5538,axiom,
    ! [VarCurr: state_type] :
      ( v58370(VarCurr)
    <=> ( v58384(VarCurr)
      <~> v58380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5537,axiom,
    ! [VarCurr: state_type] :
      ( v58384(VarCurr)
    <=> ( v58372(VarCurr)
      <~> v58376(VarCurr) ) ) ).

tff(addAssignment_34565,axiom,
    ! [VarCurr: state_type] :
      ( v58380(VarCurr)
    <=> v58382(VarCurr) ) ).

tff(addAssignment_34564,axiom,
    ! [VarCurr: state_type] :
      ( v58382(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_34563,axiom,
    ! [VarCurr: state_type] :
      ( v58376(VarCurr)
    <=> v58378(VarCurr) ) ).

tff(addAssignment_34562,axiom,
    ! [VarCurr: state_type] :
      ( v58378(VarCurr)
    <=> v6017(VarCurr,121) ) ).

tff(addAssignment_34561,axiom,
    ! [VarCurr: state_type] :
      ( v58372(VarCurr)
    <=> v58374(VarCurr) ) ).

tff(addAssignment_34560,axiom,
    ! [VarCurr: state_type] :
      ( v58374(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_34559,axiom,
    ! [VarCurr: state_type] :
      ( v58088(VarCurr)
    <=> v58090(VarCurr) ) ).

tff(addAssignment_34558,axiom,
    ! [VarCurr: state_type] :
      ( v58090(VarCurr)
    <=> v58092(VarCurr) ) ).

tff(addAssignment_34557,axiom,
    ! [VarCurr: state_type] :
      ( v58092(VarCurr)
    <=> v58094(VarCurr) ) ).

tff(addAssignment_34556,axiom,
    ! [VarCurr: state_type] :
      ( v58094(VarCurr)
    <=> v58096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5536,axiom,
    ! [VarCurr: state_type] :
      ( v58096(VarCurr)
    <=> ( v58350(VarCurr)
      <~> v58266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5535,axiom,
    ! [VarCurr: state_type] :
      ( v58350(VarCurr)
    <=> ( v58098(VarCurr)
      <~> v58182(VarCurr) ) ) ).

tff(addAssignment_34555,axiom,
    ! [VarCurr: state_type] :
      ( v58266(VarCurr)
    <=> v58268(VarCurr) ) ).

tff(addAssignment_34554,axiom,
    ! [VarCurr: state_type] :
      ( v58268(VarCurr)
    <=> v58270(VarCurr) ) ).

tff(addAssignment_34553,axiom,
    ! [VarCurr: state_type] :
      ( v58270(VarCurr)
    <=> v58272(VarCurr) ) ).

tff(addAssignment_34552,axiom,
    ! [VarCurr: state_type] :
      ( v58272(VarCurr)
    <=> v58274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5534,axiom,
    ! [VarCurr: state_type] :
      ( v58274(VarCurr)
    <=> ( v58348(VarCurr)
      <~> v58324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5533,axiom,
    ! [VarCurr: state_type] :
      ( v58348(VarCurr)
    <=> ( v58276(VarCurr)
      <~> v58300(VarCurr) ) ) ).

tff(addAssignment_34551,axiom,
    ! [VarCurr: state_type] :
      ( v58324(VarCurr)
    <=> v58326(VarCurr) ) ).

tff(addAssignment_34550,axiom,
    ! [VarCurr: state_type] :
      ( v58326(VarCurr)
    <=> v58328(VarCurr) ) ).

tff(addAssignment_34549,axiom,
    ! [VarCurr: state_type] :
      ( v58328(VarCurr)
    <=> v58330(VarCurr) ) ).

tff(addAssignment_34548,axiom,
    ! [VarCurr: state_type] :
      ( v58330(VarCurr)
    <=> v58332(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5532,axiom,
    ! [VarCurr: state_type] :
      ( v58332(VarCurr)
    <=> ( v58346(VarCurr)
      <~> v58342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5531,axiom,
    ! [VarCurr: state_type] :
      ( v58346(VarCurr)
    <=> ( v58334(VarCurr)
      <~> v58338(VarCurr) ) ) ).

tff(addAssignment_34547,axiom,
    ! [VarCurr: state_type] :
      ( v58342(VarCurr)
    <=> v58344(VarCurr) ) ).

tff(addAssignment_34546,axiom,
    ! [VarCurr: state_type] :
      ( v58344(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_34545,axiom,
    ! [VarCurr: state_type] :
      ( v58338(VarCurr)
    <=> v58340(VarCurr) ) ).

tff(addAssignment_34544,axiom,
    ! [VarCurr: state_type] :
      ( v58340(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_34543,axiom,
    ! [VarCurr: state_type] :
      ( v58334(VarCurr)
    <=> v58336(VarCurr) ) ).

tff(addAssignment_34542,axiom,
    ! [VarCurr: state_type] :
      ( v58336(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_34541,axiom,
    ! [VarCurr: state_type] :
      ( v58300(VarCurr)
    <=> v58302(VarCurr) ) ).

tff(addAssignment_34540,axiom,
    ! [VarCurr: state_type] :
      ( v58302(VarCurr)
    <=> v58304(VarCurr) ) ).

tff(addAssignment_34539,axiom,
    ! [VarCurr: state_type] :
      ( v58304(VarCurr)
    <=> v58306(VarCurr) ) ).

tff(addAssignment_34538,axiom,
    ! [VarCurr: state_type] :
      ( v58306(VarCurr)
    <=> v58308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5530,axiom,
    ! [VarCurr: state_type] :
      ( v58308(VarCurr)
    <=> ( v58322(VarCurr)
      <~> v58318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5529,axiom,
    ! [VarCurr: state_type] :
      ( v58322(VarCurr)
    <=> ( v58310(VarCurr)
      <~> v58314(VarCurr) ) ) ).

tff(addAssignment_34537,axiom,
    ! [VarCurr: state_type] :
      ( v58318(VarCurr)
    <=> v58320(VarCurr) ) ).

tff(addAssignment_34536,axiom,
    ! [VarCurr: state_type] :
      ( v58320(VarCurr)
    <=> v6017(VarCurr,101) ) ).

tff(addAssignment_34535,axiom,
    ! [VarCurr: state_type] :
      ( v58314(VarCurr)
    <=> v58316(VarCurr) ) ).

tff(addAssignment_34534,axiom,
    ! [VarCurr: state_type] :
      ( v58316(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_34533,axiom,
    ! [VarCurr: state_type] :
      ( v58310(VarCurr)
    <=> v58312(VarCurr) ) ).

tff(addAssignment_34532,axiom,
    ! [VarCurr: state_type] :
      ( v58312(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_34531,axiom,
    ! [VarCurr: state_type] :
      ( v58276(VarCurr)
    <=> v58278(VarCurr) ) ).

tff(addAssignment_34530,axiom,
    ! [VarCurr: state_type] :
      ( v58278(VarCurr)
    <=> v58280(VarCurr) ) ).

tff(addAssignment_34529,axiom,
    ! [VarCurr: state_type] :
      ( v58280(VarCurr)
    <=> v58282(VarCurr) ) ).

tff(addAssignment_34528,axiom,
    ! [VarCurr: state_type] :
      ( v58282(VarCurr)
    <=> v58284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5528,axiom,
    ! [VarCurr: state_type] :
      ( v58284(VarCurr)
    <=> ( v58298(VarCurr)
      <~> v58294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5527,axiom,
    ! [VarCurr: state_type] :
      ( v58298(VarCurr)
    <=> ( v58286(VarCurr)
      <~> v58290(VarCurr) ) ) ).

tff(addAssignment_34527,axiom,
    ! [VarCurr: state_type] :
      ( v58294(VarCurr)
    <=> v58296(VarCurr) ) ).

tff(addAssignment_34526,axiom,
    ! [VarCurr: state_type] :
      ( v58296(VarCurr)
    <=> v6017(VarCurr,95) ) ).

tff(addAssignment_34525,axiom,
    ! [VarCurr: state_type] :
      ( v58290(VarCurr)
    <=> v58292(VarCurr) ) ).

tff(addAssignment_34524,axiom,
    ! [VarCurr: state_type] :
      ( v58292(VarCurr)
    <=> v6017(VarCurr,92) ) ).

tff(addAssignment_34523,axiom,
    ! [VarCurr: state_type] :
      ( v58286(VarCurr)
    <=> v58288(VarCurr) ) ).

tff(addAssignment_34522,axiom,
    ! [VarCurr: state_type] :
      ( v58288(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_34521,axiom,
    ! [VarCurr: state_type] :
      ( v58182(VarCurr)
    <=> v58184(VarCurr) ) ).

tff(addAssignment_34520,axiom,
    ! [VarCurr: state_type] :
      ( v58184(VarCurr)
    <=> v58186(VarCurr) ) ).

tff(addAssignment_34519,axiom,
    ! [VarCurr: state_type] :
      ( v58186(VarCurr)
    <=> v58188(VarCurr) ) ).

tff(addAssignment_34518,axiom,
    ! [VarCurr: state_type] :
      ( v58188(VarCurr)
    <=> v58190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5526,axiom,
    ! [VarCurr: state_type] :
      ( v58190(VarCurr)
    <=> ( v58264(VarCurr)
      <~> v58240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5525,axiom,
    ! [VarCurr: state_type] :
      ( v58264(VarCurr)
    <=> ( v58192(VarCurr)
      <~> v58216(VarCurr) ) ) ).

tff(addAssignment_34517,axiom,
    ! [VarCurr: state_type] :
      ( v58240(VarCurr)
    <=> v58242(VarCurr) ) ).

tff(addAssignment_34516,axiom,
    ! [VarCurr: state_type] :
      ( v58242(VarCurr)
    <=> v58244(VarCurr) ) ).

tff(addAssignment_34515,axiom,
    ! [VarCurr: state_type] :
      ( v58244(VarCurr)
    <=> v58246(VarCurr) ) ).

tff(addAssignment_34514,axiom,
    ! [VarCurr: state_type] :
      ( v58246(VarCurr)
    <=> v58248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5524,axiom,
    ! [VarCurr: state_type] :
      ( v58248(VarCurr)
    <=> ( v58262(VarCurr)
      <~> v58258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5523,axiom,
    ! [VarCurr: state_type] :
      ( v58262(VarCurr)
    <=> ( v58250(VarCurr)
      <~> v58254(VarCurr) ) ) ).

tff(addAssignment_34513,axiom,
    ! [VarCurr: state_type] :
      ( v58258(VarCurr)
    <=> v58260(VarCurr) ) ).

tff(addAssignment_34512,axiom,
    ! [VarCurr: state_type] :
      ( v58260(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_34511,axiom,
    ! [VarCurr: state_type] :
      ( v58254(VarCurr)
    <=> v58256(VarCurr) ) ).

tff(addAssignment_34510,axiom,
    ! [VarCurr: state_type] :
      ( v58256(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_34509,axiom,
    ! [VarCurr: state_type] :
      ( v58250(VarCurr)
    <=> v58252(VarCurr) ) ).

tff(addAssignment_34508,axiom,
    ! [VarCurr: state_type] :
      ( v58252(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_34507,axiom,
    ! [VarCurr: state_type] :
      ( v58216(VarCurr)
    <=> v58218(VarCurr) ) ).

tff(addAssignment_34506,axiom,
    ! [VarCurr: state_type] :
      ( v58218(VarCurr)
    <=> v58220(VarCurr) ) ).

tff(addAssignment_34505,axiom,
    ! [VarCurr: state_type] :
      ( v58220(VarCurr)
    <=> v58222(VarCurr) ) ).

tff(addAssignment_34504,axiom,
    ! [VarCurr: state_type] :
      ( v58222(VarCurr)
    <=> v58224(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5522,axiom,
    ! [VarCurr: state_type] :
      ( v58224(VarCurr)
    <=> ( v58238(VarCurr)
      <~> v58234(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5521,axiom,
    ! [VarCurr: state_type] :
      ( v58238(VarCurr)
    <=> ( v58226(VarCurr)
      <~> v58230(VarCurr) ) ) ).

tff(addAssignment_34503,axiom,
    ! [VarCurr: state_type] :
      ( v58234(VarCurr)
    <=> v58236(VarCurr) ) ).

tff(addAssignment_34502,axiom,
    ! [VarCurr: state_type] :
      ( v58236(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_34501,axiom,
    ! [VarCurr: state_type] :
      ( v58230(VarCurr)
    <=> v58232(VarCurr) ) ).

tff(addAssignment_34500,axiom,
    ! [VarCurr: state_type] :
      ( v58232(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_34499,axiom,
    ! [VarCurr: state_type] :
      ( v58226(VarCurr)
    <=> v58228(VarCurr) ) ).

tff(addAssignment_34498,axiom,
    ! [VarCurr: state_type] :
      ( v58228(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_34497,axiom,
    ! [VarCurr: state_type] :
      ( v58192(VarCurr)
    <=> v58194(VarCurr) ) ).

tff(addAssignment_34496,axiom,
    ! [VarCurr: state_type] :
      ( v58194(VarCurr)
    <=> v58196(VarCurr) ) ).

tff(addAssignment_34495,axiom,
    ! [VarCurr: state_type] :
      ( v58196(VarCurr)
    <=> v58198(VarCurr) ) ).

tff(addAssignment_34494,axiom,
    ! [VarCurr: state_type] :
      ( v58198(VarCurr)
    <=> v58200(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5520,axiom,
    ! [VarCurr: state_type] :
      ( v58200(VarCurr)
    <=> ( v58214(VarCurr)
      <~> v58210(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5519,axiom,
    ! [VarCurr: state_type] :
      ( v58214(VarCurr)
    <=> ( v58202(VarCurr)
      <~> v58206(VarCurr) ) ) ).

tff(addAssignment_34493,axiom,
    ! [VarCurr: state_type] :
      ( v58210(VarCurr)
    <=> v58212(VarCurr) ) ).

tff(addAssignment_34492,axiom,
    ! [VarCurr: state_type] :
      ( v58212(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_34491,axiom,
    ! [VarCurr: state_type] :
      ( v58206(VarCurr)
    <=> v58208(VarCurr) ) ).

tff(addAssignment_34490,axiom,
    ! [VarCurr: state_type] :
      ( v58208(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_34489,axiom,
    ! [VarCurr: state_type] :
      ( v58202(VarCurr)
    <=> v58204(VarCurr) ) ).

tff(addAssignment_34488,axiom,
    ! [VarCurr: state_type] :
      ( v58204(VarCurr)
    <=> v6017(VarCurr,75) ) ).

tff(addAssignment_34487,axiom,
    ! [VarCurr: state_type] :
      ( v58098(VarCurr)
    <=> v58100(VarCurr) ) ).

tff(addAssignment_34486,axiom,
    ! [VarCurr: state_type] :
      ( v58100(VarCurr)
    <=> v58102(VarCurr) ) ).

tff(addAssignment_34485,axiom,
    ! [VarCurr: state_type] :
      ( v58102(VarCurr)
    <=> v58104(VarCurr) ) ).

tff(addAssignment_34484,axiom,
    ! [VarCurr: state_type] :
      ( v58104(VarCurr)
    <=> v58106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5518,axiom,
    ! [VarCurr: state_type] :
      ( v58106(VarCurr)
    <=> ( v58180(VarCurr)
      <~> v58156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5517,axiom,
    ! [VarCurr: state_type] :
      ( v58180(VarCurr)
    <=> ( v58108(VarCurr)
      <~> v58132(VarCurr) ) ) ).

tff(addAssignment_34483,axiom,
    ! [VarCurr: state_type] :
      ( v58156(VarCurr)
    <=> v58158(VarCurr) ) ).

tff(addAssignment_34482,axiom,
    ! [VarCurr: state_type] :
      ( v58158(VarCurr)
    <=> v58160(VarCurr) ) ).

tff(addAssignment_34481,axiom,
    ! [VarCurr: state_type] :
      ( v58160(VarCurr)
    <=> v58162(VarCurr) ) ).

tff(addAssignment_34480,axiom,
    ! [VarCurr: state_type] :
      ( v58162(VarCurr)
    <=> v58164(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5516,axiom,
    ! [VarCurr: state_type] :
      ( v58164(VarCurr)
    <=> ( v58178(VarCurr)
      <~> v58174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5515,axiom,
    ! [VarCurr: state_type] :
      ( v58178(VarCurr)
    <=> ( v58166(VarCurr)
      <~> v58170(VarCurr) ) ) ).

tff(addAssignment_34479,axiom,
    ! [VarCurr: state_type] :
      ( v58174(VarCurr)
    <=> v58176(VarCurr) ) ).

tff(addAssignment_34478,axiom,
    ! [VarCurr: state_type] :
      ( v58176(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_34477,axiom,
    ! [VarCurr: state_type] :
      ( v58170(VarCurr)
    <=> v58172(VarCurr) ) ).

tff(addAssignment_34476,axiom,
    ! [VarCurr: state_type] :
      ( v58172(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_34475,axiom,
    ! [VarCurr: state_type] :
      ( v58166(VarCurr)
    <=> v58168(VarCurr) ) ).

tff(addAssignment_34474,axiom,
    ! [VarCurr: state_type] :
      ( v58168(VarCurr)
    <=> v6017(VarCurr,66) ) ).

tff(addAssignment_34473,axiom,
    ! [VarCurr: state_type] :
      ( v58132(VarCurr)
    <=> v58134(VarCurr) ) ).

tff(addAssignment_34472,axiom,
    ! [VarCurr: state_type] :
      ( v58134(VarCurr)
    <=> v58136(VarCurr) ) ).

tff(addAssignment_34471,axiom,
    ! [VarCurr: state_type] :
      ( v58136(VarCurr)
    <=> v58138(VarCurr) ) ).

tff(addAssignment_34470,axiom,
    ! [VarCurr: state_type] :
      ( v58138(VarCurr)
    <=> v58140(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5514,axiom,
    ! [VarCurr: state_type] :
      ( v58140(VarCurr)
    <=> ( v58154(VarCurr)
      <~> v58150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5513,axiom,
    ! [VarCurr: state_type] :
      ( v58154(VarCurr)
    <=> ( v58142(VarCurr)
      <~> v58146(VarCurr) ) ) ).

tff(addAssignment_34469,axiom,
    ! [VarCurr: state_type] :
      ( v58150(VarCurr)
    <=> v58152(VarCurr) ) ).

tff(addAssignment_34468,axiom,
    ! [VarCurr: state_type] :
      ( v58152(VarCurr)
    <=> v6017(VarCurr,61) ) ).

tff(addAssignment_34467,axiom,
    ! [VarCurr: state_type] :
      ( v58146(VarCurr)
    <=> v58148(VarCurr) ) ).

tff(addAssignment_34466,axiom,
    ! [VarCurr: state_type] :
      ( v58148(VarCurr)
    <=> v6017(VarCurr,58) ) ).

tff(addAssignment_34465,axiom,
    ! [VarCurr: state_type] :
      ( v58142(VarCurr)
    <=> v58144(VarCurr) ) ).

tff(addAssignment_34464,axiom,
    ! [VarCurr: state_type] :
      ( v58144(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_34463,axiom,
    ! [VarCurr: state_type] :
      ( v58108(VarCurr)
    <=> v58110(VarCurr) ) ).

tff(addAssignment_34462,axiom,
    ! [VarCurr: state_type] :
      ( v58110(VarCurr)
    <=> v58112(VarCurr) ) ).

tff(addAssignment_34461,axiom,
    ! [VarCurr: state_type] :
      ( v58112(VarCurr)
    <=> v58114(VarCurr) ) ).

tff(addAssignment_34460,axiom,
    ! [VarCurr: state_type] :
      ( v58114(VarCurr)
    <=> v58116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5512,axiom,
    ! [VarCurr: state_type] :
      ( v58116(VarCurr)
    <=> ( v58130(VarCurr)
      <~> v58126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5511,axiom,
    ! [VarCurr: state_type] :
      ( v58130(VarCurr)
    <=> ( v58118(VarCurr)
      <~> v58122(VarCurr) ) ) ).

tff(addAssignment_34459,axiom,
    ! [VarCurr: state_type] :
      ( v58126(VarCurr)
    <=> v58128(VarCurr) ) ).

tff(addAssignment_34458,axiom,
    ! [VarCurr: state_type] :
      ( v58128(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_34457,axiom,
    ! [VarCurr: state_type] :
      ( v58122(VarCurr)
    <=> v58124(VarCurr) ) ).

tff(addAssignment_34456,axiom,
    ! [VarCurr: state_type] :
      ( v58124(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_34455,axiom,
    ! [VarCurr: state_type] :
      ( v58118(VarCurr)
    <=> v58120(VarCurr) ) ).

tff(addAssignment_34454,axiom,
    ! [VarCurr: state_type] :
      ( v58120(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_34453,axiom,
    ! [VarCurr: state_type] :
      ( v57824(VarCurr)
    <=> v57826(VarCurr) ) ).

tff(addAssignment_34452,axiom,
    ! [VarCurr: state_type] :
      ( v57826(VarCurr)
    <=> v57828(VarCurr) ) ).

tff(addAssignment_34451,axiom,
    ! [VarCurr: state_type] :
      ( v57828(VarCurr)
    <=> v57830(VarCurr) ) ).

tff(addAssignment_34450,axiom,
    ! [VarCurr: state_type] :
      ( v57830(VarCurr)
    <=> v57832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5510,axiom,
    ! [VarCurr: state_type] :
      ( v57832(VarCurr)
    <=> ( v58086(VarCurr)
      <~> v58002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5509,axiom,
    ! [VarCurr: state_type] :
      ( v58086(VarCurr)
    <=> ( v57834(VarCurr)
      <~> v57918(VarCurr) ) ) ).

tff(addAssignment_34449,axiom,
    ! [VarCurr: state_type] :
      ( v58002(VarCurr)
    <=> v58004(VarCurr) ) ).

tff(addAssignment_34448,axiom,
    ! [VarCurr: state_type] :
      ( v58004(VarCurr)
    <=> v58006(VarCurr) ) ).

tff(addAssignment_34447,axiom,
    ! [VarCurr: state_type] :
      ( v58006(VarCurr)
    <=> v58008(VarCurr) ) ).

tff(addAssignment_34446,axiom,
    ! [VarCurr: state_type] :
      ( v58008(VarCurr)
    <=> v58010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5508,axiom,
    ! [VarCurr: state_type] :
      ( v58010(VarCurr)
    <=> ( v58084(VarCurr)
      <~> v58060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5507,axiom,
    ! [VarCurr: state_type] :
      ( v58084(VarCurr)
    <=> ( v58012(VarCurr)
      <~> v58036(VarCurr) ) ) ).

tff(addAssignment_34445,axiom,
    ! [VarCurr: state_type] :
      ( v58060(VarCurr)
    <=> v58062(VarCurr) ) ).

tff(addAssignment_34444,axiom,
    ! [VarCurr: state_type] :
      ( v58062(VarCurr)
    <=> v58064(VarCurr) ) ).

tff(addAssignment_34443,axiom,
    ! [VarCurr: state_type] :
      ( v58064(VarCurr)
    <=> v58066(VarCurr) ) ).

tff(addAssignment_34442,axiom,
    ! [VarCurr: state_type] :
      ( v58066(VarCurr)
    <=> v58068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5506,axiom,
    ! [VarCurr: state_type] :
      ( v58068(VarCurr)
    <=> ( v58082(VarCurr)
      <~> v58078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5505,axiom,
    ! [VarCurr: state_type] :
      ( v58082(VarCurr)
    <=> ( v58070(VarCurr)
      <~> v58074(VarCurr) ) ) ).

tff(addAssignment_34441,axiom,
    ! [VarCurr: state_type] :
      ( v58078(VarCurr)
    <=> v58080(VarCurr) ) ).

tff(addAssignment_34440,axiom,
    ! [VarCurr: state_type] :
      ( v58080(VarCurr)
    <=> v6017(VarCurr,51) ) ).

tff(addAssignment_34439,axiom,
    ! [VarCurr: state_type] :
      ( v58074(VarCurr)
    <=> v58076(VarCurr) ) ).

tff(addAssignment_34438,axiom,
    ! [VarCurr: state_type] :
      ( v58076(VarCurr)
    <=> v6017(VarCurr,50) ) ).

tff(addAssignment_34437,axiom,
    ! [VarCurr: state_type] :
      ( v58070(VarCurr)
    <=> v58072(VarCurr) ) ).

tff(addAssignment_34436,axiom,
    ! [VarCurr: state_type] :
      ( v58072(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_34435,axiom,
    ! [VarCurr: state_type] :
      ( v58036(VarCurr)
    <=> v58038(VarCurr) ) ).

tff(addAssignment_34434,axiom,
    ! [VarCurr: state_type] :
      ( v58038(VarCurr)
    <=> v58040(VarCurr) ) ).

tff(addAssignment_34433,axiom,
    ! [VarCurr: state_type] :
      ( v58040(VarCurr)
    <=> v58042(VarCurr) ) ).

tff(addAssignment_34432,axiom,
    ! [VarCurr: state_type] :
      ( v58042(VarCurr)
    <=> v58044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5504,axiom,
    ! [VarCurr: state_type] :
      ( v58044(VarCurr)
    <=> ( v58058(VarCurr)
      <~> v58054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5503,axiom,
    ! [VarCurr: state_type] :
      ( v58058(VarCurr)
    <=> ( v58046(VarCurr)
      <~> v58050(VarCurr) ) ) ).

tff(addAssignment_34431,axiom,
    ! [VarCurr: state_type] :
      ( v58054(VarCurr)
    <=> v58056(VarCurr) ) ).

tff(addAssignment_34430,axiom,
    ! [VarCurr: state_type] :
      ( v58056(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_34429,axiom,
    ! [VarCurr: state_type] :
      ( v58050(VarCurr)
    <=> v58052(VarCurr) ) ).

tff(addAssignment_34428,axiom,
    ! [VarCurr: state_type] :
      ( v58052(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_34427,axiom,
    ! [VarCurr: state_type] :
      ( v58046(VarCurr)
    <=> v58048(VarCurr) ) ).

tff(addAssignment_34426,axiom,
    ! [VarCurr: state_type] :
      ( v58048(VarCurr)
    <=> v6017(VarCurr,44) ) ).

tff(addAssignment_34425,axiom,
    ! [VarCurr: state_type] :
      ( v58012(VarCurr)
    <=> v58014(VarCurr) ) ).

tff(addAssignment_34424,axiom,
    ! [VarCurr: state_type] :
      ( v58014(VarCurr)
    <=> v58016(VarCurr) ) ).

tff(addAssignment_34423,axiom,
    ! [VarCurr: state_type] :
      ( v58016(VarCurr)
    <=> v58018(VarCurr) ) ).

tff(addAssignment_34422,axiom,
    ! [VarCurr: state_type] :
      ( v58018(VarCurr)
    <=> v58020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5502,axiom,
    ! [VarCurr: state_type] :
      ( v58020(VarCurr)
    <=> ( v58034(VarCurr)
      <~> v58030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5501,axiom,
    ! [VarCurr: state_type] :
      ( v58034(VarCurr)
    <=> ( v58022(VarCurr)
      <~> v58026(VarCurr) ) ) ).

tff(addAssignment_34421,axiom,
    ! [VarCurr: state_type] :
      ( v58030(VarCurr)
    <=> v58032(VarCurr) ) ).

tff(addAssignment_34420,axiom,
    ! [VarCurr: state_type] :
      ( v58032(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_34419,axiom,
    ! [VarCurr: state_type] :
      ( v58026(VarCurr)
    <=> v58028(VarCurr) ) ).

tff(addAssignment_34418,axiom,
    ! [VarCurr: state_type] :
      ( v58028(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_34417,axiom,
    ! [VarCurr: state_type] :
      ( v58022(VarCurr)
    <=> v58024(VarCurr) ) ).

tff(addAssignment_34416,axiom,
    ! [VarCurr: state_type] :
      ( v58024(VarCurr)
    <=> v6017(VarCurr,41) ) ).

tff(addAssignment_34415,axiom,
    ! [VarCurr: state_type] :
      ( v57918(VarCurr)
    <=> v57920(VarCurr) ) ).

tff(addAssignment_34414,axiom,
    ! [VarCurr: state_type] :
      ( v57920(VarCurr)
    <=> v57922(VarCurr) ) ).

tff(addAssignment_34413,axiom,
    ! [VarCurr: state_type] :
      ( v57922(VarCurr)
    <=> v57924(VarCurr) ) ).

tff(addAssignment_34412,axiom,
    ! [VarCurr: state_type] :
      ( v57924(VarCurr)
    <=> v57926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5500,axiom,
    ! [VarCurr: state_type] :
      ( v57926(VarCurr)
    <=> ( v58000(VarCurr)
      <~> v57976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5499,axiom,
    ! [VarCurr: state_type] :
      ( v58000(VarCurr)
    <=> ( v57928(VarCurr)
      <~> v57952(VarCurr) ) ) ).

tff(addAssignment_34411,axiom,
    ! [VarCurr: state_type] :
      ( v57976(VarCurr)
    <=> v57978(VarCurr) ) ).

tff(addAssignment_34410,axiom,
    ! [VarCurr: state_type] :
      ( v57978(VarCurr)
    <=> v57980(VarCurr) ) ).

tff(addAssignment_34409,axiom,
    ! [VarCurr: state_type] :
      ( v57980(VarCurr)
    <=> v57982(VarCurr) ) ).

tff(addAssignment_34408,axiom,
    ! [VarCurr: state_type] :
      ( v57982(VarCurr)
    <=> v57984(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5498,axiom,
    ! [VarCurr: state_type] :
      ( v57984(VarCurr)
    <=> ( v57998(VarCurr)
      <~> v57994(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5497,axiom,
    ! [VarCurr: state_type] :
      ( v57998(VarCurr)
    <=> ( v57986(VarCurr)
      <~> v57990(VarCurr) ) ) ).

tff(addAssignment_34407,axiom,
    ! [VarCurr: state_type] :
      ( v57994(VarCurr)
    <=> v57996(VarCurr) ) ).

tff(addAssignment_34406,axiom,
    ! [VarCurr: state_type] :
      ( v57996(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_34405,axiom,
    ! [VarCurr: state_type] :
      ( v57990(VarCurr)
    <=> v57992(VarCurr) ) ).

tff(addAssignment_34404,axiom,
    ! [VarCurr: state_type] :
      ( v57992(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_34403,axiom,
    ! [VarCurr: state_type] :
      ( v57986(VarCurr)
    <=> v57988(VarCurr) ) ).

tff(addAssignment_34402,axiom,
    ! [VarCurr: state_type] :
      ( v57988(VarCurr)
    <=> v6017(VarCurr,35) ) ).

tff(addAssignment_34401,axiom,
    ! [VarCurr: state_type] :
      ( v57952(VarCurr)
    <=> v57954(VarCurr) ) ).

tff(addAssignment_34400,axiom,
    ! [VarCurr: state_type] :
      ( v57954(VarCurr)
    <=> v57956(VarCurr) ) ).

tff(addAssignment_34399,axiom,
    ! [VarCurr: state_type] :
      ( v57956(VarCurr)
    <=> v57958(VarCurr) ) ).

tff(addAssignment_34398,axiom,
    ! [VarCurr: state_type] :
      ( v57958(VarCurr)
    <=> v57960(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5496,axiom,
    ! [VarCurr: state_type] :
      ( v57960(VarCurr)
    <=> ( v57974(VarCurr)
      <~> v57970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5495,axiom,
    ! [VarCurr: state_type] :
      ( v57974(VarCurr)
    <=> ( v57962(VarCurr)
      <~> v57966(VarCurr) ) ) ).

tff(addAssignment_34397,axiom,
    ! [VarCurr: state_type] :
      ( v57970(VarCurr)
    <=> v57972(VarCurr) ) ).

tff(addAssignment_34396,axiom,
    ! [VarCurr: state_type] :
      ( v57972(VarCurr)
    <=> v6017(VarCurr,32) ) ).

tff(addAssignment_34395,axiom,
    ! [VarCurr: state_type] :
      ( v57966(VarCurr)
    <=> v57968(VarCurr) ) ).

tff(addAssignment_34394,axiom,
    ! [VarCurr: state_type] :
      ( v57968(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_34393,axiom,
    ! [VarCurr: state_type] :
      ( v57962(VarCurr)
    <=> v57964(VarCurr) ) ).

tff(addAssignment_34392,axiom,
    ! [VarCurr: state_type] :
      ( v57964(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_34391,axiom,
    ! [VarCurr: state_type] :
      ( v57928(VarCurr)
    <=> v57930(VarCurr) ) ).

tff(addAssignment_34390,axiom,
    ! [VarCurr: state_type] :
      ( v57930(VarCurr)
    <=> v57932(VarCurr) ) ).

tff(addAssignment_34389,axiom,
    ! [VarCurr: state_type] :
      ( v57932(VarCurr)
    <=> v57934(VarCurr) ) ).

tff(addAssignment_34388,axiom,
    ! [VarCurr: state_type] :
      ( v57934(VarCurr)
    <=> v57936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5494,axiom,
    ! [VarCurr: state_type] :
      ( v57936(VarCurr)
    <=> ( v57950(VarCurr)
      <~> v57946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5493,axiom,
    ! [VarCurr: state_type] :
      ( v57950(VarCurr)
    <=> ( v57938(VarCurr)
      <~> v57942(VarCurr) ) ) ).

tff(addAssignment_34387,axiom,
    ! [VarCurr: state_type] :
      ( v57946(VarCurr)
    <=> v57948(VarCurr) ) ).

tff(addAssignment_34386,axiom,
    ! [VarCurr: state_type] :
      ( v57948(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_34385,axiom,
    ! [VarCurr: state_type] :
      ( v57942(VarCurr)
    <=> v57944(VarCurr) ) ).

tff(addAssignment_34384,axiom,
    ! [VarCurr: state_type] :
      ( v57944(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_34383,axiom,
    ! [VarCurr: state_type] :
      ( v57938(VarCurr)
    <=> v57940(VarCurr) ) ).

tff(addAssignment_34382,axiom,
    ! [VarCurr: state_type] :
      ( v57940(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_34381,axiom,
    ! [VarCurr: state_type] :
      ( v57834(VarCurr)
    <=> v57836(VarCurr) ) ).

tff(addAssignment_34380,axiom,
    ! [VarCurr: state_type] :
      ( v57836(VarCurr)
    <=> v57838(VarCurr) ) ).

tff(addAssignment_34379,axiom,
    ! [VarCurr: state_type] :
      ( v57838(VarCurr)
    <=> v57840(VarCurr) ) ).

tff(addAssignment_34378,axiom,
    ! [VarCurr: state_type] :
      ( v57840(VarCurr)
    <=> v57842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5492,axiom,
    ! [VarCurr: state_type] :
      ( v57842(VarCurr)
    <=> ( v57916(VarCurr)
      <~> v57892(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5491,axiom,
    ! [VarCurr: state_type] :
      ( v57916(VarCurr)
    <=> ( v57844(VarCurr)
      <~> v57868(VarCurr) ) ) ).

tff(addAssignment_34377,axiom,
    ! [VarCurr: state_type] :
      ( v57892(VarCurr)
    <=> v57894(VarCurr) ) ).

tff(addAssignment_34376,axiom,
    ! [VarCurr: state_type] :
      ( v57894(VarCurr)
    <=> v57896(VarCurr) ) ).

tff(addAssignment_34375,axiom,
    ! [VarCurr: state_type] :
      ( v57896(VarCurr)
    <=> v57898(VarCurr) ) ).

tff(addAssignment_34374,axiom,
    ! [VarCurr: state_type] :
      ( v57898(VarCurr)
    <=> v57900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5490,axiom,
    ! [VarCurr: state_type] :
      ( v57900(VarCurr)
    <=> ( v57914(VarCurr)
      <~> v57910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5489,axiom,
    ! [VarCurr: state_type] :
      ( v57914(VarCurr)
    <=> ( v57902(VarCurr)
      <~> v57906(VarCurr) ) ) ).

tff(addAssignment_34373,axiom,
    ! [VarCurr: state_type] :
      ( v57910(VarCurr)
    <=> v57912(VarCurr) ) ).

tff(addAssignment_34372,axiom,
    ! [VarCurr: state_type] :
      ( v57912(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_34371,axiom,
    ! [VarCurr: state_type] :
      ( v57906(VarCurr)
    <=> v57908(VarCurr) ) ).

tff(addAssignment_34370,axiom,
    ! [VarCurr: state_type] :
      ( v57908(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_34369,axiom,
    ! [VarCurr: state_type] :
      ( v57902(VarCurr)
    <=> v57904(VarCurr) ) ).

tff(addAssignment_34368,axiom,
    ! [VarCurr: state_type] :
      ( v57904(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_34367,axiom,
    ! [VarCurr: state_type] :
      ( v57868(VarCurr)
    <=> v57870(VarCurr) ) ).

tff(addAssignment_34366,axiom,
    ! [VarCurr: state_type] :
      ( v57870(VarCurr)
    <=> v57872(VarCurr) ) ).

tff(addAssignment_34365,axiom,
    ! [VarCurr: state_type] :
      ( v57872(VarCurr)
    <=> v57874(VarCurr) ) ).

tff(addAssignment_34364,axiom,
    ! [VarCurr: state_type] :
      ( v57874(VarCurr)
    <=> v57876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5488,axiom,
    ! [VarCurr: state_type] :
      ( v57876(VarCurr)
    <=> ( v57890(VarCurr)
      <~> v57886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5487,axiom,
    ! [VarCurr: state_type] :
      ( v57890(VarCurr)
    <=> ( v57878(VarCurr)
      <~> v57882(VarCurr) ) ) ).

tff(addAssignment_34363,axiom,
    ! [VarCurr: state_type] :
      ( v57886(VarCurr)
    <=> v57888(VarCurr) ) ).

tff(addAssignment_34362,axiom,
    ! [VarCurr: state_type] :
      ( v57888(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_34361,axiom,
    ! [VarCurr: state_type] :
      ( v57882(VarCurr)
    <=> v57884(VarCurr) ) ).

tff(addAssignment_34360,axiom,
    ! [VarCurr: state_type] :
      ( v57884(VarCurr)
    <=> v6017(VarCurr,15) ) ).

tff(addAssignment_34359,axiom,
    ! [VarCurr: state_type] :
      ( v57878(VarCurr)
    <=> v57880(VarCurr) ) ).

tff(addAssignment_34358,axiom,
    ! [VarCurr: state_type] :
      ( v57880(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_34357,axiom,
    ! [VarCurr: state_type] :
      ( v57844(VarCurr)
    <=> v57846(VarCurr) ) ).

tff(addAssignment_34356,axiom,
    ! [VarCurr: state_type] :
      ( v57846(VarCurr)
    <=> v57848(VarCurr) ) ).

tff(addAssignment_34355,axiom,
    ! [VarCurr: state_type] :
      ( v57848(VarCurr)
    <=> v57850(VarCurr) ) ).

tff(addAssignment_34354,axiom,
    ! [VarCurr: state_type] :
      ( v57850(VarCurr)
    <=> v57852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5486,axiom,
    ! [VarCurr: state_type] :
      ( v57852(VarCurr)
    <=> ( v57866(VarCurr)
      <~> v57862(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5485,axiom,
    ! [VarCurr: state_type] :
      ( v57866(VarCurr)
    <=> ( v57854(VarCurr)
      <~> v57858(VarCurr) ) ) ).

tff(addAssignment_34353,axiom,
    ! [VarCurr: state_type] :
      ( v57862(VarCurr)
    <=> v57864(VarCurr) ) ).

tff(addAssignment_34352,axiom,
    ! [VarCurr: state_type] :
      ( v57864(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_34351,axiom,
    ! [VarCurr: state_type] :
      ( v57858(VarCurr)
    <=> v57860(VarCurr) ) ).

tff(addAssignment_34350,axiom,
    ! [VarCurr: state_type] :
      ( v57860(VarCurr)
    <=> v6017(VarCurr,6) ) ).

tff(addAssignment_34349,axiom,
    ! [VarCurr: state_type] :
      ( v57854(VarCurr)
    <=> v57856(VarCurr) ) ).

tff(addAssignment_34348,axiom,
    ! [VarCurr: state_type] :
      ( v57856(VarCurr)
    <=> v6017(VarCurr,1) ) ).

tff(addAssignment_34347,axiom,
    ! [VarCurr: state_type] :
      ( v56447(VarCurr)
    <=> v56449(VarCurr) ) ).

tff(addAssignment_34346,axiom,
    ! [VarCurr: state_type] :
      ( v56449(VarCurr)
    <=> v56451(VarCurr) ) ).

tff(addAssignment_34345,axiom,
    ! [VarCurr: state_type] :
      ( v56451(VarCurr)
    <=> v56453(VarCurr) ) ).

tff(addAssignment_34344,axiom,
    ! [VarCurr: state_type] :
      ( v56453(VarCurr)
    <=> v56455(VarCurr) ) ).

tff(writeUnaryOperator_3139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v56455(VarCurr)
    <=> v57804(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5484,axiom,
    ! [VarCurr: state_type] :
      ( v57804(VarCurr)
    <=> ( v56457(VarCurr)
        | v57134(VarCurr) ) ) ).

tff(addAssignment_34343,axiom,
    ! [VarCurr: state_type] :
      ( v57134(VarCurr)
    <=> v57136(VarCurr) ) ).

tff(addAssignment_34342,axiom,
    ! [VarCurr: state_type] :
      ( v57136(VarCurr)
    <=> v56461(VarCurr,2) ) ).

tff(addAssignment_34341,axiom,
    ! [VarCurr: state_type] :
      ( v56461(VarCurr,2)
    <=> v5977(VarCurr,2) ) ).

tff(addAssignment_34340,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,2)
    <=> v5979(VarCurr,2) ) ).

tff(addAssignment_34339,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,2)
    <=> v5981(VarCurr,2) ) ).

tff(addAssignment_34338,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,2)
    <=> v5983(VarCurr,2) ) ).

tff(addAssignment_34337,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,2)
    <=> v5985(VarCurr,2) ) ).

tff(addAssignment_34336,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,2)
    <=> v53672(VarCurr,2) ) ).

tff(addAssignment_34335,axiom,
    ! [VarCurr: state_type] :
      ( v53675(VarCurr,2)
    <=> v57138(VarCurr) ) ).

tff(addAssignment_34334,axiom,
    ! [VarCurr: state_type] :
      ( v57138(VarCurr)
    <=> v57140(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5483,axiom,
    ! [VarCurr: state_type] :
      ( v57140(VarCurr)
    <=> ( v57802(VarCurr)
      <~> v57670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5482,axiom,
    ! [VarCurr: state_type] :
      ( v57802(VarCurr)
    <=> ( v57142(VarCurr)
      <~> v57406(VarCurr) ) ) ).

tff(addAssignment_34333,axiom,
    ! [VarCurr: state_type] :
      ( v57670(VarCurr)
    <=> v57672(VarCurr) ) ).

tff(addAssignment_34332,axiom,
    ! [VarCurr: state_type] :
      ( v57672(VarCurr)
    <=> v57674(VarCurr) ) ).

tff(addAssignment_34331,axiom,
    ! [VarCurr: state_type] :
      ( v57674(VarCurr)
    <=> v57676(VarCurr) ) ).

tff(addAssignment_34330,axiom,
    ! [VarCurr: state_type] :
      ( v57676(VarCurr)
    <=> v57678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5481,axiom,
    ! [VarCurr: state_type] :
      ( v57678(VarCurr)
    <=> ( v57800(VarCurr)
      <~> v57788(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5480,axiom,
    ! [VarCurr: state_type] :
      ( v57800(VarCurr)
    <=> ( v57680(VarCurr)
      <~> v57704(VarCurr) ) ) ).

tff(addAssignment_34329,axiom,
    ! [VarCurr: state_type] :
      ( v57788(VarCurr)
    <=> v57790(VarCurr) ) ).

tff(addAssignment_34328,axiom,
    ! [VarCurr: state_type] :
      ( v57790(VarCurr)
    <=> v57118(VarCurr,2) ) ).

tff(addAssignment_34327,axiom,
    ! [VarCurr: state_type] :
      ( v57118(VarCurr,2)
    <=> v57120(VarCurr,2) ) ).

tff(addAssignment_34326,axiom,
    ! [VarCurr: state_type] :
      ( v57120(VarCurr,2)
    <=> v53454(VarCurr,3) ) ).

tff(addAssignment_34325,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,3)
    <=> v53456(VarCurr,3) ) ).

tff(addAssignment_34324,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,3)
    <=> v57792(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v57793(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v57792(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_754,axiom,
    ! [VarNext: state_type] :
      ( v57793(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v57792(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v57793(VarNext)
      <=> v57794(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v57794(VarNext)
      <=> ( v57796(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v57796(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_34323,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,3)
    <=> v53480(VarCurr,3) ) ).

tff(addAssignment_34322,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,3)
    <=> v53525(VarCurr,3) ) ).

tff(addAssignment_34321,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,2)
    <=> v53312(VarCurr,2) ) ).

tff(addAssignment_34320,axiom,
    ! [VarCurr: state_type] :
      ( v57704(VarCurr)
    <=> v57706(VarCurr) ) ).

tff(addAssignment_34319,axiom,
    ! [VarCurr: state_type] :
      ( v57706(VarCurr)
    <=> v57708(VarCurr) ) ).

tff(addAssignment_34318,axiom,
    ! [VarCurr: state_type] :
      ( v57708(VarCurr)
    <=> v57710(VarCurr) ) ).

tff(addAssignment_34317,axiom,
    ! [VarCurr: state_type] :
      ( v57710(VarCurr)
    <=> v57712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5477,axiom,
    ! [VarCurr: state_type] :
      ( v57712(VarCurr)
    <=> ( v57786(VarCurr)
      <~> v57762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5476,axiom,
    ! [VarCurr: state_type] :
      ( v57786(VarCurr)
    <=> ( v57714(VarCurr)
      <~> v57738(VarCurr) ) ) ).

tff(addAssignment_34316,axiom,
    ! [VarCurr: state_type] :
      ( v57762(VarCurr)
    <=> v57764(VarCurr) ) ).

tff(addAssignment_34315,axiom,
    ! [VarCurr: state_type] :
      ( v57764(VarCurr)
    <=> v57766(VarCurr) ) ).

tff(addAssignment_34314,axiom,
    ! [VarCurr: state_type] :
      ( v57766(VarCurr)
    <=> v57768(VarCurr) ) ).

tff(addAssignment_34313,axiom,
    ! [VarCurr: state_type] :
      ( v57768(VarCurr)
    <=> v57770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5475,axiom,
    ! [VarCurr: state_type] :
      ( v57770(VarCurr)
    <=> ( v57784(VarCurr)
      <~> v57780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5474,axiom,
    ! [VarCurr: state_type] :
      ( v57784(VarCurr)
    <=> ( v57772(VarCurr)
      <~> v57776(VarCurr) ) ) ).

tff(addAssignment_34312,axiom,
    ! [VarCurr: state_type] :
      ( v57780(VarCurr)
    <=> v57782(VarCurr) ) ).

tff(addAssignment_34311,axiom,
    ! [VarCurr: state_type] :
      ( v57782(VarCurr)
    <=> v6017(VarCurr,118) ) ).

tff(addAssignment_34310,axiom,
    ! [VarCurr: state_type] :
      ( v57776(VarCurr)
    <=> v57778(VarCurr) ) ).

tff(addAssignment_34309,axiom,
    ! [VarCurr: state_type] :
      ( v57778(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_34308,axiom,
    ! [VarCurr: state_type] :
      ( v57772(VarCurr)
    <=> v57774(VarCurr) ) ).

tff(addAssignment_34307,axiom,
    ! [VarCurr: state_type] :
      ( v57774(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_34306,axiom,
    ! [VarCurr: state_type] :
      ( v57738(VarCurr)
    <=> v57740(VarCurr) ) ).

tff(addAssignment_34305,axiom,
    ! [VarCurr: state_type] :
      ( v57740(VarCurr)
    <=> v57742(VarCurr) ) ).

tff(addAssignment_34304,axiom,
    ! [VarCurr: state_type] :
      ( v57742(VarCurr)
    <=> v57744(VarCurr) ) ).

tff(addAssignment_34303,axiom,
    ! [VarCurr: state_type] :
      ( v57744(VarCurr)
    <=> v57746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5473,axiom,
    ! [VarCurr: state_type] :
      ( v57746(VarCurr)
    <=> ( v57760(VarCurr)
      <~> v57756(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5472,axiom,
    ! [VarCurr: state_type] :
      ( v57760(VarCurr)
    <=> ( v57748(VarCurr)
      <~> v57752(VarCurr) ) ) ).

tff(addAssignment_34302,axiom,
    ! [VarCurr: state_type] :
      ( v57756(VarCurr)
    <=> v57758(VarCurr) ) ).

tff(addAssignment_34301,axiom,
    ! [VarCurr: state_type] :
      ( v57758(VarCurr)
    <=> v6017(VarCurr,111) ) ).

tff(addAssignment_34300,axiom,
    ! [VarCurr: state_type] :
      ( v57752(VarCurr)
    <=> v57754(VarCurr) ) ).

tff(addAssignment_34299,axiom,
    ! [VarCurr: state_type] :
      ( v57754(VarCurr)
    <=> v6017(VarCurr,108) ) ).

tff(addAssignment_34298,axiom,
    ! [VarCurr: state_type] :
      ( v57748(VarCurr)
    <=> v57750(VarCurr) ) ).

tff(addAssignment_34297,axiom,
    ! [VarCurr: state_type] :
      ( v57750(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_34296,axiom,
    ! [VarCurr: state_type] :
      ( v57714(VarCurr)
    <=> v57716(VarCurr) ) ).

tff(addAssignment_34295,axiom,
    ! [VarCurr: state_type] :
      ( v57716(VarCurr)
    <=> v57718(VarCurr) ) ).

tff(addAssignment_34294,axiom,
    ! [VarCurr: state_type] :
      ( v57718(VarCurr)
    <=> v57720(VarCurr) ) ).

tff(addAssignment_34293,axiom,
    ! [VarCurr: state_type] :
      ( v57720(VarCurr)
    <=> v57722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5471,axiom,
    ! [VarCurr: state_type] :
      ( v57722(VarCurr)
    <=> ( v57736(VarCurr)
      <~> v57732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5470,axiom,
    ! [VarCurr: state_type] :
      ( v57736(VarCurr)
    <=> ( v57724(VarCurr)
      <~> v57728(VarCurr) ) ) ).

tff(addAssignment_34292,axiom,
    ! [VarCurr: state_type] :
      ( v57732(VarCurr)
    <=> v57734(VarCurr) ) ).

tff(addAssignment_34291,axiom,
    ! [VarCurr: state_type] :
      ( v57734(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_34290,axiom,
    ! [VarCurr: state_type] :
      ( v57728(VarCurr)
    <=> v57730(VarCurr) ) ).

tff(addAssignment_34289,axiom,
    ! [VarCurr: state_type] :
      ( v57730(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_34288,axiom,
    ! [VarCurr: state_type] :
      ( v57724(VarCurr)
    <=> v57726(VarCurr) ) ).

tff(addAssignment_34287,axiom,
    ! [VarCurr: state_type] :
      ( v57726(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_34286,axiom,
    ! [VarCurr: state_type] :
      ( v57680(VarCurr)
    <=> v57682(VarCurr) ) ).

tff(addAssignment_34285,axiom,
    ! [VarCurr: state_type] :
      ( v57682(VarCurr)
    <=> v57684(VarCurr) ) ).

tff(addAssignment_34284,axiom,
    ! [VarCurr: state_type] :
      ( v57684(VarCurr)
    <=> v57686(VarCurr) ) ).

tff(addAssignment_34283,axiom,
    ! [VarCurr: state_type] :
      ( v57686(VarCurr)
    <=> v57688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5469,axiom,
    ! [VarCurr: state_type] :
      ( v57688(VarCurr)
    <=> ( v57702(VarCurr)
      <~> v57698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5468,axiom,
    ! [VarCurr: state_type] :
      ( v57702(VarCurr)
    <=> ( v57690(VarCurr)
      <~> v57694(VarCurr) ) ) ).

tff(addAssignment_34282,axiom,
    ! [VarCurr: state_type] :
      ( v57698(VarCurr)
    <=> v57700(VarCurr) ) ).

tff(addAssignment_34281,axiom,
    ! [VarCurr: state_type] :
      ( v57700(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_34280,axiom,
    ! [VarCurr: state_type] :
      ( v57694(VarCurr)
    <=> v57696(VarCurr) ) ).

tff(addAssignment_34279,axiom,
    ! [VarCurr: state_type] :
      ( v57696(VarCurr)
    <=> v6017(VarCurr,122) ) ).

tff(addAssignment_34278,axiom,
    ! [VarCurr: state_type] :
      ( v57690(VarCurr)
    <=> v57692(VarCurr) ) ).

tff(addAssignment_34277,axiom,
    ! [VarCurr: state_type] :
      ( v57692(VarCurr)
    <=> v6017(VarCurr,119) ) ).

tff(addAssignment_34276,axiom,
    ! [VarCurr: state_type] :
      ( v57406(VarCurr)
    <=> v57408(VarCurr) ) ).

tff(addAssignment_34275,axiom,
    ! [VarCurr: state_type] :
      ( v57408(VarCurr)
    <=> v57410(VarCurr) ) ).

tff(addAssignment_34274,axiom,
    ! [VarCurr: state_type] :
      ( v57410(VarCurr)
    <=> v57412(VarCurr) ) ).

tff(addAssignment_34273,axiom,
    ! [VarCurr: state_type] :
      ( v57412(VarCurr)
    <=> v57414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5467,axiom,
    ! [VarCurr: state_type] :
      ( v57414(VarCurr)
    <=> ( v57668(VarCurr)
      <~> v57584(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5466,axiom,
    ! [VarCurr: state_type] :
      ( v57668(VarCurr)
    <=> ( v57416(VarCurr)
      <~> v57500(VarCurr) ) ) ).

tff(addAssignment_34272,axiom,
    ! [VarCurr: state_type] :
      ( v57584(VarCurr)
    <=> v57586(VarCurr) ) ).

tff(addAssignment_34271,axiom,
    ! [VarCurr: state_type] :
      ( v57586(VarCurr)
    <=> v57588(VarCurr) ) ).

tff(addAssignment_34270,axiom,
    ! [VarCurr: state_type] :
      ( v57588(VarCurr)
    <=> v57590(VarCurr) ) ).

tff(addAssignment_34269,axiom,
    ! [VarCurr: state_type] :
      ( v57590(VarCurr)
    <=> v57592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5465,axiom,
    ! [VarCurr: state_type] :
      ( v57592(VarCurr)
    <=> ( v57666(VarCurr)
      <~> v57642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5464,axiom,
    ! [VarCurr: state_type] :
      ( v57666(VarCurr)
    <=> ( v57594(VarCurr)
      <~> v57618(VarCurr) ) ) ).

tff(addAssignment_34268,axiom,
    ! [VarCurr: state_type] :
      ( v57642(VarCurr)
    <=> v57644(VarCurr) ) ).

tff(addAssignment_34267,axiom,
    ! [VarCurr: state_type] :
      ( v57644(VarCurr)
    <=> v57646(VarCurr) ) ).

tff(addAssignment_34266,axiom,
    ! [VarCurr: state_type] :
      ( v57646(VarCurr)
    <=> v57648(VarCurr) ) ).

tff(addAssignment_34265,axiom,
    ! [VarCurr: state_type] :
      ( v57648(VarCurr)
    <=> v57650(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5463,axiom,
    ! [VarCurr: state_type] :
      ( v57650(VarCurr)
    <=> ( v57664(VarCurr)
      <~> v57660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5462,axiom,
    ! [VarCurr: state_type] :
      ( v57664(VarCurr)
    <=> ( v57652(VarCurr)
      <~> v57656(VarCurr) ) ) ).

tff(addAssignment_34264,axiom,
    ! [VarCurr: state_type] :
      ( v57660(VarCurr)
    <=> v57662(VarCurr) ) ).

tff(addAssignment_34263,axiom,
    ! [VarCurr: state_type] :
      ( v57662(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_34262,axiom,
    ! [VarCurr: state_type] :
      ( v57656(VarCurr)
    <=> v57658(VarCurr) ) ).

tff(addAssignment_34261,axiom,
    ! [VarCurr: state_type] :
      ( v57658(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_34260,axiom,
    ! [VarCurr: state_type] :
      ( v57652(VarCurr)
    <=> v57654(VarCurr) ) ).

tff(addAssignment_34259,axiom,
    ! [VarCurr: state_type] :
      ( v57654(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_34258,axiom,
    ! [VarCurr: state_type] :
      ( v57618(VarCurr)
    <=> v57620(VarCurr) ) ).

tff(addAssignment_34257,axiom,
    ! [VarCurr: state_type] :
      ( v57620(VarCurr)
    <=> v57622(VarCurr) ) ).

tff(addAssignment_34256,axiom,
    ! [VarCurr: state_type] :
      ( v57622(VarCurr)
    <=> v57624(VarCurr) ) ).

tff(addAssignment_34255,axiom,
    ! [VarCurr: state_type] :
      ( v57624(VarCurr)
    <=> v57626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5461,axiom,
    ! [VarCurr: state_type] :
      ( v57626(VarCurr)
    <=> ( v57640(VarCurr)
      <~> v57636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5460,axiom,
    ! [VarCurr: state_type] :
      ( v57640(VarCurr)
    <=> ( v57628(VarCurr)
      <~> v57632(VarCurr) ) ) ).

tff(addAssignment_34254,axiom,
    ! [VarCurr: state_type] :
      ( v57636(VarCurr)
    <=> v57638(VarCurr) ) ).

tff(addAssignment_34253,axiom,
    ! [VarCurr: state_type] :
      ( v57638(VarCurr)
    <=> v6017(VarCurr,96) ) ).

tff(addAssignment_34252,axiom,
    ! [VarCurr: state_type] :
      ( v57632(VarCurr)
    <=> v57634(VarCurr) ) ).

tff(addAssignment_34251,axiom,
    ! [VarCurr: state_type] :
      ( v57634(VarCurr)
    <=> v6017(VarCurr,93) ) ).

tff(addAssignment_34250,axiom,
    ! [VarCurr: state_type] :
      ( v57628(VarCurr)
    <=> v57630(VarCurr) ) ).

tff(addAssignment_34249,axiom,
    ! [VarCurr: state_type] :
      ( v57630(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_34248,axiom,
    ! [VarCurr: state_type] :
      ( v57594(VarCurr)
    <=> v57596(VarCurr) ) ).

tff(addAssignment_34247,axiom,
    ! [VarCurr: state_type] :
      ( v57596(VarCurr)
    <=> v57598(VarCurr) ) ).

tff(addAssignment_34246,axiom,
    ! [VarCurr: state_type] :
      ( v57598(VarCurr)
    <=> v57600(VarCurr) ) ).

tff(addAssignment_34245,axiom,
    ! [VarCurr: state_type] :
      ( v57600(VarCurr)
    <=> v57602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5459,axiom,
    ! [VarCurr: state_type] :
      ( v57602(VarCurr)
    <=> ( v57616(VarCurr)
      <~> v57612(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5458,axiom,
    ! [VarCurr: state_type] :
      ( v57616(VarCurr)
    <=> ( v57604(VarCurr)
      <~> v57608(VarCurr) ) ) ).

tff(addAssignment_34244,axiom,
    ! [VarCurr: state_type] :
      ( v57612(VarCurr)
    <=> v57614(VarCurr) ) ).

tff(addAssignment_34243,axiom,
    ! [VarCurr: state_type] :
      ( v57614(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_34242,axiom,
    ! [VarCurr: state_type] :
      ( v57608(VarCurr)
    <=> v57610(VarCurr) ) ).

tff(addAssignment_34241,axiom,
    ! [VarCurr: state_type] :
      ( v57610(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_34240,axiom,
    ! [VarCurr: state_type] :
      ( v57604(VarCurr)
    <=> v57606(VarCurr) ) ).

tff(addAssignment_34239,axiom,
    ! [VarCurr: state_type] :
      ( v57606(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_34238,axiom,
    ! [VarCurr: state_type] :
      ( v57500(VarCurr)
    <=> v57502(VarCurr) ) ).

tff(addAssignment_34237,axiom,
    ! [VarCurr: state_type] :
      ( v57502(VarCurr)
    <=> v57504(VarCurr) ) ).

tff(addAssignment_34236,axiom,
    ! [VarCurr: state_type] :
      ( v57504(VarCurr)
    <=> v57506(VarCurr) ) ).

tff(addAssignment_34235,axiom,
    ! [VarCurr: state_type] :
      ( v57506(VarCurr)
    <=> v57508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5457,axiom,
    ! [VarCurr: state_type] :
      ( v57508(VarCurr)
    <=> ( v57582(VarCurr)
      <~> v57558(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5456,axiom,
    ! [VarCurr: state_type] :
      ( v57582(VarCurr)
    <=> ( v57510(VarCurr)
      <~> v57534(VarCurr) ) ) ).

tff(addAssignment_34234,axiom,
    ! [VarCurr: state_type] :
      ( v57558(VarCurr)
    <=> v57560(VarCurr) ) ).

tff(addAssignment_34233,axiom,
    ! [VarCurr: state_type] :
      ( v57560(VarCurr)
    <=> v57562(VarCurr) ) ).

tff(addAssignment_34232,axiom,
    ! [VarCurr: state_type] :
      ( v57562(VarCurr)
    <=> v57564(VarCurr) ) ).

tff(addAssignment_34231,axiom,
    ! [VarCurr: state_type] :
      ( v57564(VarCurr)
    <=> v57566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5455,axiom,
    ! [VarCurr: state_type] :
      ( v57566(VarCurr)
    <=> ( v57580(VarCurr)
      <~> v57576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5454,axiom,
    ! [VarCurr: state_type] :
      ( v57580(VarCurr)
    <=> ( v57568(VarCurr)
      <~> v57572(VarCurr) ) ) ).

tff(addAssignment_34230,axiom,
    ! [VarCurr: state_type] :
      ( v57576(VarCurr)
    <=> v57578(VarCurr) ) ).

tff(addAssignment_34229,axiom,
    ! [VarCurr: state_type] :
      ( v57578(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_34228,axiom,
    ! [VarCurr: state_type] :
      ( v57572(VarCurr)
    <=> v57574(VarCurr) ) ).

tff(addAssignment_34227,axiom,
    ! [VarCurr: state_type] :
      ( v57574(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_34226,axiom,
    ! [VarCurr: state_type] :
      ( v57568(VarCurr)
    <=> v57570(VarCurr) ) ).

tff(addAssignment_34225,axiom,
    ! [VarCurr: state_type] :
      ( v57570(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_34224,axiom,
    ! [VarCurr: state_type] :
      ( v57534(VarCurr)
    <=> v57536(VarCurr) ) ).

tff(addAssignment_34223,axiom,
    ! [VarCurr: state_type] :
      ( v57536(VarCurr)
    <=> v57538(VarCurr) ) ).

tff(addAssignment_34222,axiom,
    ! [VarCurr: state_type] :
      ( v57538(VarCurr)
    <=> v57540(VarCurr) ) ).

tff(addAssignment_34221,axiom,
    ! [VarCurr: state_type] :
      ( v57540(VarCurr)
    <=> v57542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5453,axiom,
    ! [VarCurr: state_type] :
      ( v57542(VarCurr)
    <=> ( v57556(VarCurr)
      <~> v57552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5452,axiom,
    ! [VarCurr: state_type] :
      ( v57556(VarCurr)
    <=> ( v57544(VarCurr)
      <~> v57548(VarCurr) ) ) ).

tff(addAssignment_34220,axiom,
    ! [VarCurr: state_type] :
      ( v57552(VarCurr)
    <=> v57554(VarCurr) ) ).

tff(addAssignment_34219,axiom,
    ! [VarCurr: state_type] :
      ( v57554(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_34218,axiom,
    ! [VarCurr: state_type] :
      ( v57548(VarCurr)
    <=> v57550(VarCurr) ) ).

tff(addAssignment_34217,axiom,
    ! [VarCurr: state_type] :
      ( v57550(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_34216,axiom,
    ! [VarCurr: state_type] :
      ( v57544(VarCurr)
    <=> v57546(VarCurr) ) ).

tff(addAssignment_34215,axiom,
    ! [VarCurr: state_type] :
      ( v57546(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_34214,axiom,
    ! [VarCurr: state_type] :
      ( v57510(VarCurr)
    <=> v57512(VarCurr) ) ).

tff(addAssignment_34213,axiom,
    ! [VarCurr: state_type] :
      ( v57512(VarCurr)
    <=> v57514(VarCurr) ) ).

tff(addAssignment_34212,axiom,
    ! [VarCurr: state_type] :
      ( v57514(VarCurr)
    <=> v57516(VarCurr) ) ).

tff(addAssignment_34211,axiom,
    ! [VarCurr: state_type] :
      ( v57516(VarCurr)
    <=> v57518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5451,axiom,
    ! [VarCurr: state_type] :
      ( v57518(VarCurr)
    <=> ( v57532(VarCurr)
      <~> v57528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5450,axiom,
    ! [VarCurr: state_type] :
      ( v57532(VarCurr)
    <=> ( v57520(VarCurr)
      <~> v57524(VarCurr) ) ) ).

tff(addAssignment_34210,axiom,
    ! [VarCurr: state_type] :
      ( v57528(VarCurr)
    <=> v57530(VarCurr) ) ).

tff(addAssignment_34209,axiom,
    ! [VarCurr: state_type] :
      ( v57530(VarCurr)
    <=> v6017(VarCurr,77) ) ).

tff(addAssignment_34208,axiom,
    ! [VarCurr: state_type] :
      ( v57524(VarCurr)
    <=> v57526(VarCurr) ) ).

tff(addAssignment_34207,axiom,
    ! [VarCurr: state_type] :
      ( v57526(VarCurr)
    <=> v6017(VarCurr,72) ) ).

tff(addAssignment_34206,axiom,
    ! [VarCurr: state_type] :
      ( v57520(VarCurr)
    <=> v57522(VarCurr) ) ).

tff(addAssignment_34205,axiom,
    ! [VarCurr: state_type] :
      ( v57522(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_34204,axiom,
    ! [VarCurr: state_type] :
      ( v57416(VarCurr)
    <=> v57418(VarCurr) ) ).

tff(addAssignment_34203,axiom,
    ! [VarCurr: state_type] :
      ( v57418(VarCurr)
    <=> v57420(VarCurr) ) ).

tff(addAssignment_34202,axiom,
    ! [VarCurr: state_type] :
      ( v57420(VarCurr)
    <=> v57422(VarCurr) ) ).

tff(addAssignment_34201,axiom,
    ! [VarCurr: state_type] :
      ( v57422(VarCurr)
    <=> v57424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5449,axiom,
    ! [VarCurr: state_type] :
      ( v57424(VarCurr)
    <=> ( v57498(VarCurr)
      <~> v57474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5448,axiom,
    ! [VarCurr: state_type] :
      ( v57498(VarCurr)
    <=> ( v57426(VarCurr)
      <~> v57450(VarCurr) ) ) ).

tff(addAssignment_34200,axiom,
    ! [VarCurr: state_type] :
      ( v57474(VarCurr)
    <=> v57476(VarCurr) ) ).

tff(addAssignment_34199,axiom,
    ! [VarCurr: state_type] :
      ( v57476(VarCurr)
    <=> v57478(VarCurr) ) ).

tff(addAssignment_34198,axiom,
    ! [VarCurr: state_type] :
      ( v57478(VarCurr)
    <=> v57480(VarCurr) ) ).

tff(addAssignment_34197,axiom,
    ! [VarCurr: state_type] :
      ( v57480(VarCurr)
    <=> v57482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5447,axiom,
    ! [VarCurr: state_type] :
      ( v57482(VarCurr)
    <=> ( v57496(VarCurr)
      <~> v57492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5446,axiom,
    ! [VarCurr: state_type] :
      ( v57496(VarCurr)
    <=> ( v57484(VarCurr)
      <~> v57488(VarCurr) ) ) ).

tff(addAssignment_34196,axiom,
    ! [VarCurr: state_type] :
      ( v57492(VarCurr)
    <=> v57494(VarCurr) ) ).

tff(addAssignment_34195,axiom,
    ! [VarCurr: state_type] :
      ( v57494(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_34194,axiom,
    ! [VarCurr: state_type] :
      ( v57488(VarCurr)
    <=> v57490(VarCurr) ) ).

tff(addAssignment_34193,axiom,
    ! [VarCurr: state_type] :
      ( v57490(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_34192,axiom,
    ! [VarCurr: state_type] :
      ( v57484(VarCurr)
    <=> v57486(VarCurr) ) ).

tff(addAssignment_34191,axiom,
    ! [VarCurr: state_type] :
      ( v57486(VarCurr)
    <=> v6017(VarCurr,67) ) ).

tff(addAssignment_34190,axiom,
    ! [VarCurr: state_type] :
      ( v57450(VarCurr)
    <=> v57452(VarCurr) ) ).

tff(addAssignment_34189,axiom,
    ! [VarCurr: state_type] :
      ( v57452(VarCurr)
    <=> v57454(VarCurr) ) ).

tff(addAssignment_34188,axiom,
    ! [VarCurr: state_type] :
      ( v57454(VarCurr)
    <=> v57456(VarCurr) ) ).

tff(addAssignment_34187,axiom,
    ! [VarCurr: state_type] :
      ( v57456(VarCurr)
    <=> v57458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5445,axiom,
    ! [VarCurr: state_type] :
      ( v57458(VarCurr)
    <=> ( v57472(VarCurr)
      <~> v57468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5444,axiom,
    ! [VarCurr: state_type] :
      ( v57472(VarCurr)
    <=> ( v57460(VarCurr)
      <~> v57464(VarCurr) ) ) ).

tff(addAssignment_34186,axiom,
    ! [VarCurr: state_type] :
      ( v57468(VarCurr)
    <=> v57470(VarCurr) ) ).

tff(addAssignment_34185,axiom,
    ! [VarCurr: state_type] :
      ( v57470(VarCurr)
    <=> v6017(VarCurr,62) ) ).

tff(addAssignment_34184,axiom,
    ! [VarCurr: state_type] :
      ( v57464(VarCurr)
    <=> v57466(VarCurr) ) ).

tff(addAssignment_34183,axiom,
    ! [VarCurr: state_type] :
      ( v57466(VarCurr)
    <=> v6017(VarCurr,59) ) ).

tff(addAssignment_34182,axiom,
    ! [VarCurr: state_type] :
      ( v57460(VarCurr)
    <=> v57462(VarCurr) ) ).

tff(addAssignment_34181,axiom,
    ! [VarCurr: state_type] :
      ( v57462(VarCurr)
    <=> v6017(VarCurr,58) ) ).

tff(addAssignment_34180,axiom,
    ! [VarCurr: state_type] :
      ( v57426(VarCurr)
    <=> v57428(VarCurr) ) ).

tff(addAssignment_34179,axiom,
    ! [VarCurr: state_type] :
      ( v57428(VarCurr)
    <=> v57430(VarCurr) ) ).

tff(addAssignment_34178,axiom,
    ! [VarCurr: state_type] :
      ( v57430(VarCurr)
    <=> v57432(VarCurr) ) ).

tff(addAssignment_34177,axiom,
    ! [VarCurr: state_type] :
      ( v57432(VarCurr)
    <=> v57434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5443,axiom,
    ! [VarCurr: state_type] :
      ( v57434(VarCurr)
    <=> ( v57448(VarCurr)
      <~> v57444(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5442,axiom,
    ! [VarCurr: state_type] :
      ( v57448(VarCurr)
    <=> ( v57436(VarCurr)
      <~> v57440(VarCurr) ) ) ).

tff(addAssignment_34176,axiom,
    ! [VarCurr: state_type] :
      ( v57444(VarCurr)
    <=> v57446(VarCurr) ) ).

tff(addAssignment_34175,axiom,
    ! [VarCurr: state_type] :
      ( v57446(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_34174,axiom,
    ! [VarCurr: state_type] :
      ( v57440(VarCurr)
    <=> v57442(VarCurr) ) ).

tff(addAssignment_34173,axiom,
    ! [VarCurr: state_type] :
      ( v57442(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_34172,axiom,
    ! [VarCurr: state_type] :
      ( v57436(VarCurr)
    <=> v57438(VarCurr) ) ).

tff(addAssignment_34171,axiom,
    ! [VarCurr: state_type] :
      ( v57438(VarCurr)
    <=> v6017(VarCurr,51) ) ).

tff(addAssignment_34170,axiom,
    ! [VarCurr: state_type] :
      ( v57142(VarCurr)
    <=> v57144(VarCurr) ) ).

tff(addAssignment_34169,axiom,
    ! [VarCurr: state_type] :
      ( v57144(VarCurr)
    <=> v57146(VarCurr) ) ).

tff(addAssignment_34168,axiom,
    ! [VarCurr: state_type] :
      ( v57146(VarCurr)
    <=> v57148(VarCurr) ) ).

tff(addAssignment_34167,axiom,
    ! [VarCurr: state_type] :
      ( v57148(VarCurr)
    <=> v57150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5441,axiom,
    ! [VarCurr: state_type] :
      ( v57150(VarCurr)
    <=> ( v57404(VarCurr)
      <~> v57320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5440,axiom,
    ! [VarCurr: state_type] :
      ( v57404(VarCurr)
    <=> ( v57152(VarCurr)
      <~> v57236(VarCurr) ) ) ).

tff(addAssignment_34166,axiom,
    ! [VarCurr: state_type] :
      ( v57320(VarCurr)
    <=> v57322(VarCurr) ) ).

tff(addAssignment_34165,axiom,
    ! [VarCurr: state_type] :
      ( v57322(VarCurr)
    <=> v57324(VarCurr) ) ).

tff(addAssignment_34164,axiom,
    ! [VarCurr: state_type] :
      ( v57324(VarCurr)
    <=> v57326(VarCurr) ) ).

tff(addAssignment_34163,axiom,
    ! [VarCurr: state_type] :
      ( v57326(VarCurr)
    <=> v57328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5439,axiom,
    ! [VarCurr: state_type] :
      ( v57328(VarCurr)
    <=> ( v57402(VarCurr)
      <~> v57378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5438,axiom,
    ! [VarCurr: state_type] :
      ( v57402(VarCurr)
    <=> ( v57330(VarCurr)
      <~> v57354(VarCurr) ) ) ).

tff(addAssignment_34162,axiom,
    ! [VarCurr: state_type] :
      ( v57378(VarCurr)
    <=> v57380(VarCurr) ) ).

tff(addAssignment_34161,axiom,
    ! [VarCurr: state_type] :
      ( v57380(VarCurr)
    <=> v57382(VarCurr) ) ).

tff(addAssignment_34160,axiom,
    ! [VarCurr: state_type] :
      ( v57382(VarCurr)
    <=> v57384(VarCurr) ) ).

tff(addAssignment_34159,axiom,
    ! [VarCurr: state_type] :
      ( v57384(VarCurr)
    <=> v57386(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5437,axiom,
    ! [VarCurr: state_type] :
      ( v57386(VarCurr)
    <=> ( v57400(VarCurr)
      <~> v57396(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5436,axiom,
    ! [VarCurr: state_type] :
      ( v57400(VarCurr)
    <=> ( v57388(VarCurr)
      <~> v57392(VarCurr) ) ) ).

tff(addAssignment_34158,axiom,
    ! [VarCurr: state_type] :
      ( v57396(VarCurr)
    <=> v57398(VarCurr) ) ).

tff(addAssignment_34157,axiom,
    ! [VarCurr: state_type] :
      ( v57398(VarCurr)
    <=> v6017(VarCurr,48) ) ).

tff(addAssignment_34156,axiom,
    ! [VarCurr: state_type] :
      ( v57392(VarCurr)
    <=> v57394(VarCurr) ) ).

tff(addAssignment_34155,axiom,
    ! [VarCurr: state_type] :
      ( v57394(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_34154,axiom,
    ! [VarCurr: state_type] :
      ( v57388(VarCurr)
    <=> v57390(VarCurr) ) ).

tff(addAssignment_34153,axiom,
    ! [VarCurr: state_type] :
      ( v57390(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_34152,axiom,
    ! [VarCurr: state_type] :
      ( v57354(VarCurr)
    <=> v57356(VarCurr) ) ).

tff(addAssignment_34151,axiom,
    ! [VarCurr: state_type] :
      ( v57356(VarCurr)
    <=> v57358(VarCurr) ) ).

tff(addAssignment_34150,axiom,
    ! [VarCurr: state_type] :
      ( v57358(VarCurr)
    <=> v57360(VarCurr) ) ).

tff(addAssignment_34149,axiom,
    ! [VarCurr: state_type] :
      ( v57360(VarCurr)
    <=> v57362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5435,axiom,
    ! [VarCurr: state_type] :
      ( v57362(VarCurr)
    <=> ( v57376(VarCurr)
      <~> v57372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5434,axiom,
    ! [VarCurr: state_type] :
      ( v57376(VarCurr)
    <=> ( v57364(VarCurr)
      <~> v57368(VarCurr) ) ) ).

tff(addAssignment_34148,axiom,
    ! [VarCurr: state_type] :
      ( v57372(VarCurr)
    <=> v57374(VarCurr) ) ).

tff(addAssignment_34147,axiom,
    ! [VarCurr: state_type] :
      ( v57374(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_34146,axiom,
    ! [VarCurr: state_type] :
      ( v57368(VarCurr)
    <=> v57370(VarCurr) ) ).

tff(addAssignment_34145,axiom,
    ! [VarCurr: state_type] :
      ( v57370(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_34144,axiom,
    ! [VarCurr: state_type] :
      ( v57364(VarCurr)
    <=> v57366(VarCurr) ) ).

tff(addAssignment_34143,axiom,
    ! [VarCurr: state_type] :
      ( v57366(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_34142,axiom,
    ! [VarCurr: state_type] :
      ( v57330(VarCurr)
    <=> v57332(VarCurr) ) ).

tff(addAssignment_34141,axiom,
    ! [VarCurr: state_type] :
      ( v57332(VarCurr)
    <=> v57334(VarCurr) ) ).

tff(addAssignment_34140,axiom,
    ! [VarCurr: state_type] :
      ( v57334(VarCurr)
    <=> v57336(VarCurr) ) ).

tff(addAssignment_34139,axiom,
    ! [VarCurr: state_type] :
      ( v57336(VarCurr)
    <=> v57338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5433,axiom,
    ! [VarCurr: state_type] :
      ( v57338(VarCurr)
    <=> ( v57352(VarCurr)
      <~> v57348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5432,axiom,
    ! [VarCurr: state_type] :
      ( v57352(VarCurr)
    <=> ( v57340(VarCurr)
      <~> v57344(VarCurr) ) ) ).

tff(addAssignment_34138,axiom,
    ! [VarCurr: state_type] :
      ( v57348(VarCurr)
    <=> v57350(VarCurr) ) ).

tff(addAssignment_34137,axiom,
    ! [VarCurr: state_type] :
      ( v57350(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_34136,axiom,
    ! [VarCurr: state_type] :
      ( v57344(VarCurr)
    <=> v57346(VarCurr) ) ).

tff(addAssignment_34135,axiom,
    ! [VarCurr: state_type] :
      ( v57346(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_34134,axiom,
    ! [VarCurr: state_type] :
      ( v57340(VarCurr)
    <=> v57342(VarCurr) ) ).

tff(addAssignment_34133,axiom,
    ! [VarCurr: state_type] :
      ( v57342(VarCurr)
    <=> v6017(VarCurr,36) ) ).

tff(addAssignment_34132,axiom,
    ! [VarCurr: state_type] :
      ( v57236(VarCurr)
    <=> v57238(VarCurr) ) ).

tff(addAssignment_34131,axiom,
    ! [VarCurr: state_type] :
      ( v57238(VarCurr)
    <=> v57240(VarCurr) ) ).

tff(addAssignment_34130,axiom,
    ! [VarCurr: state_type] :
      ( v57240(VarCurr)
    <=> v57242(VarCurr) ) ).

tff(addAssignment_34129,axiom,
    ! [VarCurr: state_type] :
      ( v57242(VarCurr)
    <=> v57244(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5431,axiom,
    ! [VarCurr: state_type] :
      ( v57244(VarCurr)
    <=> ( v57318(VarCurr)
      <~> v57294(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5430,axiom,
    ! [VarCurr: state_type] :
      ( v57318(VarCurr)
    <=> ( v57246(VarCurr)
      <~> v57270(VarCurr) ) ) ).

tff(addAssignment_34128,axiom,
    ! [VarCurr: state_type] :
      ( v57294(VarCurr)
    <=> v57296(VarCurr) ) ).

tff(addAssignment_34127,axiom,
    ! [VarCurr: state_type] :
      ( v57296(VarCurr)
    <=> v57298(VarCurr) ) ).

tff(addAssignment_34126,axiom,
    ! [VarCurr: state_type] :
      ( v57298(VarCurr)
    <=> v57300(VarCurr) ) ).

tff(addAssignment_34125,axiom,
    ! [VarCurr: state_type] :
      ( v57300(VarCurr)
    <=> v57302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5429,axiom,
    ! [VarCurr: state_type] :
      ( v57302(VarCurr)
    <=> ( v57316(VarCurr)
      <~> v57312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5428,axiom,
    ! [VarCurr: state_type] :
      ( v57316(VarCurr)
    <=> ( v57304(VarCurr)
      <~> v57308(VarCurr) ) ) ).

tff(addAssignment_34124,axiom,
    ! [VarCurr: state_type] :
      ( v57312(VarCurr)
    <=> v57314(VarCurr) ) ).

tff(addAssignment_34123,axiom,
    ! [VarCurr: state_type] :
      ( v57314(VarCurr)
    <=> v6017(VarCurr,33) ) ).

tff(addAssignment_34122,axiom,
    ! [VarCurr: state_type] :
      ( v57308(VarCurr)
    <=> v57310(VarCurr) ) ).

tff(addAssignment_34121,axiom,
    ! [VarCurr: state_type] :
      ( v57310(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_34120,axiom,
    ! [VarCurr: state_type] :
      ( v57304(VarCurr)
    <=> v57306(VarCurr) ) ).

tff(addAssignment_34119,axiom,
    ! [VarCurr: state_type] :
      ( v57306(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_34118,axiom,
    ! [VarCurr: state_type] :
      ( v57270(VarCurr)
    <=> v57272(VarCurr) ) ).

tff(addAssignment_34117,axiom,
    ! [VarCurr: state_type] :
      ( v57272(VarCurr)
    <=> v57274(VarCurr) ) ).

tff(addAssignment_34116,axiom,
    ! [VarCurr: state_type] :
      ( v57274(VarCurr)
    <=> v57276(VarCurr) ) ).

tff(addAssignment_34115,axiom,
    ! [VarCurr: state_type] :
      ( v57276(VarCurr)
    <=> v57278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5427,axiom,
    ! [VarCurr: state_type] :
      ( v57278(VarCurr)
    <=> ( v57292(VarCurr)
      <~> v57288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5426,axiom,
    ! [VarCurr: state_type] :
      ( v57292(VarCurr)
    <=> ( v57280(VarCurr)
      <~> v57284(VarCurr) ) ) ).

tff(addAssignment_34114,axiom,
    ! [VarCurr: state_type] :
      ( v57288(VarCurr)
    <=> v57290(VarCurr) ) ).

tff(addAssignment_34113,axiom,
    ! [VarCurr: state_type] :
      ( v57290(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_34112,axiom,
    ! [VarCurr: state_type] :
      ( v57284(VarCurr)
    <=> v57286(VarCurr) ) ).

tff(addAssignment_34111,axiom,
    ! [VarCurr: state_type] :
      ( v57286(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_34110,axiom,
    ! [VarCurr: state_type] :
      ( v57280(VarCurr)
    <=> v57282(VarCurr) ) ).

tff(addAssignment_34109,axiom,
    ! [VarCurr: state_type] :
      ( v57282(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_34108,axiom,
    ! [VarCurr: state_type] :
      ( v57246(VarCurr)
    <=> v57248(VarCurr) ) ).

tff(addAssignment_34107,axiom,
    ! [VarCurr: state_type] :
      ( v57248(VarCurr)
    <=> v57250(VarCurr) ) ).

tff(addAssignment_34106,axiom,
    ! [VarCurr: state_type] :
      ( v57250(VarCurr)
    <=> v57252(VarCurr) ) ).

tff(addAssignment_34105,axiom,
    ! [VarCurr: state_type] :
      ( v57252(VarCurr)
    <=> v57254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5425,axiom,
    ! [VarCurr: state_type] :
      ( v57254(VarCurr)
    <=> ( v57268(VarCurr)
      <~> v57264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5424,axiom,
    ! [VarCurr: state_type] :
      ( v57268(VarCurr)
    <=> ( v57256(VarCurr)
      <~> v57260(VarCurr) ) ) ).

tff(addAssignment_34104,axiom,
    ! [VarCurr: state_type] :
      ( v57264(VarCurr)
    <=> v57266(VarCurr) ) ).

tff(addAssignment_34103,axiom,
    ! [VarCurr: state_type] :
      ( v57266(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_34102,axiom,
    ! [VarCurr: state_type] :
      ( v57260(VarCurr)
    <=> v57262(VarCurr) ) ).

tff(addAssignment_34101,axiom,
    ! [VarCurr: state_type] :
      ( v57262(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_34100,axiom,
    ! [VarCurr: state_type] :
      ( v57256(VarCurr)
    <=> v57258(VarCurr) ) ).

tff(addAssignment_34099,axiom,
    ! [VarCurr: state_type] :
      ( v57258(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_34098,axiom,
    ! [VarCurr: state_type] :
      ( v57152(VarCurr)
    <=> v57154(VarCurr) ) ).

tff(addAssignment_34097,axiom,
    ! [VarCurr: state_type] :
      ( v57154(VarCurr)
    <=> v57156(VarCurr) ) ).

tff(addAssignment_34096,axiom,
    ! [VarCurr: state_type] :
      ( v57156(VarCurr)
    <=> v57158(VarCurr) ) ).

tff(addAssignment_34095,axiom,
    ! [VarCurr: state_type] :
      ( v57158(VarCurr)
    <=> v57160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5423,axiom,
    ! [VarCurr: state_type] :
      ( v57160(VarCurr)
    <=> ( v57234(VarCurr)
      <~> v57210(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5422,axiom,
    ! [VarCurr: state_type] :
      ( v57234(VarCurr)
    <=> ( v57162(VarCurr)
      <~> v57186(VarCurr) ) ) ).

tff(addAssignment_34094,axiom,
    ! [VarCurr: state_type] :
      ( v57210(VarCurr)
    <=> v57212(VarCurr) ) ).

tff(addAssignment_34093,axiom,
    ! [VarCurr: state_type] :
      ( v57212(VarCurr)
    <=> v57214(VarCurr) ) ).

tff(addAssignment_34092,axiom,
    ! [VarCurr: state_type] :
      ( v57214(VarCurr)
    <=> v57216(VarCurr) ) ).

tff(addAssignment_34091,axiom,
    ! [VarCurr: state_type] :
      ( v57216(VarCurr)
    <=> v57218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5421,axiom,
    ! [VarCurr: state_type] :
      ( v57218(VarCurr)
    <=> ( v57232(VarCurr)
      <~> v57228(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5420,axiom,
    ! [VarCurr: state_type] :
      ( v57232(VarCurr)
    <=> ( v57220(VarCurr)
      <~> v57224(VarCurr) ) ) ).

tff(addAssignment_34090,axiom,
    ! [VarCurr: state_type] :
      ( v57228(VarCurr)
    <=> v57230(VarCurr) ) ).

tff(addAssignment_34089,axiom,
    ! [VarCurr: state_type] :
      ( v57230(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_34088,axiom,
    ! [VarCurr: state_type] :
      ( v57224(VarCurr)
    <=> v57226(VarCurr) ) ).

tff(addAssignment_34087,axiom,
    ! [VarCurr: state_type] :
      ( v57226(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_34086,axiom,
    ! [VarCurr: state_type] :
      ( v57220(VarCurr)
    <=> v57222(VarCurr) ) ).

tff(addAssignment_34085,axiom,
    ! [VarCurr: state_type] :
      ( v57222(VarCurr)
    <=> v6017(VarCurr,17) ) ).

tff(addAssignment_34084,axiom,
    ! [VarCurr: state_type] :
      ( v57186(VarCurr)
    <=> v57188(VarCurr) ) ).

tff(addAssignment_34083,axiom,
    ! [VarCurr: state_type] :
      ( v57188(VarCurr)
    <=> v57190(VarCurr) ) ).

tff(addAssignment_34082,axiom,
    ! [VarCurr: state_type] :
      ( v57190(VarCurr)
    <=> v57192(VarCurr) ) ).

tff(addAssignment_34081,axiom,
    ! [VarCurr: state_type] :
      ( v57192(VarCurr)
    <=> v57194(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5419,axiom,
    ! [VarCurr: state_type] :
      ( v57194(VarCurr)
    <=> ( v57208(VarCurr)
      <~> v57204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5418,axiom,
    ! [VarCurr: state_type] :
      ( v57208(VarCurr)
    <=> ( v57196(VarCurr)
      <~> v57200(VarCurr) ) ) ).

tff(addAssignment_34080,axiom,
    ! [VarCurr: state_type] :
      ( v57204(VarCurr)
    <=> v57206(VarCurr) ) ).

tff(addAssignment_34079,axiom,
    ! [VarCurr: state_type] :
      ( v57206(VarCurr)
    <=> v6017(VarCurr,12) ) ).

tff(addAssignment_34078,axiom,
    ! [VarCurr: state_type] :
      ( v57200(VarCurr)
    <=> v57202(VarCurr) ) ).

tff(addAssignment_34077,axiom,
    ! [VarCurr: state_type] :
      ( v57202(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_34076,axiom,
    ! [VarCurr: state_type] :
      ( v57196(VarCurr)
    <=> v57198(VarCurr) ) ).

tff(addAssignment_34075,axiom,
    ! [VarCurr: state_type] :
      ( v57198(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_34074,axiom,
    ! [VarCurr: state_type] :
      ( v57162(VarCurr)
    <=> v57164(VarCurr) ) ).

tff(addAssignment_34073,axiom,
    ! [VarCurr: state_type] :
      ( v57164(VarCurr)
    <=> v57166(VarCurr) ) ).

tff(addAssignment_34072,axiom,
    ! [VarCurr: state_type] :
      ( v57166(VarCurr)
    <=> v57168(VarCurr) ) ).

tff(addAssignment_34071,axiom,
    ! [VarCurr: state_type] :
      ( v57168(VarCurr)
    <=> v57170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5417,axiom,
    ! [VarCurr: state_type] :
      ( v57170(VarCurr)
    <=> ( v57184(VarCurr)
      <~> v57180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5416,axiom,
    ! [VarCurr: state_type] :
      ( v57184(VarCurr)
    <=> ( v57172(VarCurr)
      <~> v57176(VarCurr) ) ) ).

tff(addAssignment_34070,axiom,
    ! [VarCurr: state_type] :
      ( v57180(VarCurr)
    <=> v57182(VarCurr) ) ).

tff(addAssignment_34069,axiom,
    ! [VarCurr: state_type] :
      ( v57182(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_34068,axiom,
    ! [VarCurr: state_type] :
      ( v57176(VarCurr)
    <=> v57178(VarCurr) ) ).

tff(addAssignment_34067,axiom,
    ! [VarCurr: state_type] :
      ( v57178(VarCurr)
    <=> v6017(VarCurr,7) ) ).

tff(addAssignment_34066,axiom,
    ! [VarCurr: state_type] :
      ( v57172(VarCurr)
    <=> v57174(VarCurr) ) ).

tff(addAssignment_34065,axiom,
    ! [VarCurr: state_type] :
      ( v57174(VarCurr)
    <=> v6017(VarCurr,2) ) ).

tff(addAssignment_34064,axiom,
    ! [VarCurr: state_type] :
      ( v56457(VarCurr)
    <=> v56459(VarCurr) ) ).

tff(addAssignment_34063,axiom,
    ! [VarCurr: state_type] :
      ( v56459(VarCurr)
    <=> v56461(VarCurr,3) ) ).

tff(addAssignment_34062,axiom,
    ! [VarCurr: state_type] :
      ( v56461(VarCurr,3)
    <=> v5977(VarCurr,3) ) ).

tff(addAssignment_34061,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,3)
    <=> v5979(VarCurr,3) ) ).

tff(addAssignment_34060,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,3)
    <=> v5981(VarCurr,3) ) ).

tff(addAssignment_34059,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,3)
    <=> v5983(VarCurr,3) ) ).

tff(addAssignment_34058,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,3)
    <=> v5985(VarCurr,3) ) ).

tff(addAssignment_34057,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,3)
    <=> v53672(VarCurr,3) ) ).

tff(addAssignment_34056,axiom,
    ! [VarCurr: state_type] :
      ( v53675(VarCurr,3)
    <=> v56464(VarCurr) ) ).

tff(addAssignment_34055,axiom,
    ! [VarCurr: state_type] :
      ( v56464(VarCurr)
    <=> v56466(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5415,axiom,
    ! [VarCurr: state_type] :
      ( v56466(VarCurr)
    <=> ( v57132(VarCurr)
      <~> v56996(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5414,axiom,
    ! [VarCurr: state_type] :
      ( v57132(VarCurr)
    <=> ( v56468(VarCurr)
      <~> v56732(VarCurr) ) ) ).

tff(addAssignment_34054,axiom,
    ! [VarCurr: state_type] :
      ( v56996(VarCurr)
    <=> v56998(VarCurr) ) ).

tff(addAssignment_34053,axiom,
    ! [VarCurr: state_type] :
      ( v56998(VarCurr)
    <=> v57000(VarCurr) ) ).

tff(addAssignment_34052,axiom,
    ! [VarCurr: state_type] :
      ( v57000(VarCurr)
    <=> v57002(VarCurr) ) ).

tff(addAssignment_34051,axiom,
    ! [VarCurr: state_type] :
      ( v57002(VarCurr)
    <=> v57004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5413,axiom,
    ! [VarCurr: state_type] :
      ( v57004(VarCurr)
    <=> ( v57130(VarCurr)
      <~> v57114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5412,axiom,
    ! [VarCurr: state_type] :
      ( v57130(VarCurr)
    <=> ( v57006(VarCurr)
      <~> v57030(VarCurr) ) ) ).

tff(addAssignment_34050,axiom,
    ! [VarCurr: state_type] :
      ( v57114(VarCurr)
    <=> v57116(VarCurr) ) ).

tff(addAssignment_34049,axiom,
    ! [VarCurr: state_type] :
      ( v57116(VarCurr)
    <=> v57118(VarCurr,3) ) ).

tff(addAssignment_34048,axiom,
    ! [VarCurr: state_type] :
      ( v57118(VarCurr,3)
    <=> v57120(VarCurr,3) ) ).

tff(addAssignment_34047,axiom,
    ! [VarCurr: state_type] :
      ( v57120(VarCurr,3)
    <=> v53454(VarCurr,4) ) ).

tff(addAssignment_34046,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,4)
    <=> v53456(VarCurr,4) ) ).

tff(addAssignment_34045,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,4)
    <=> v57122(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v57123(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v57122(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_753,axiom,
    ! [VarNext: state_type] :
      ( v57123(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v57122(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v57123(VarNext)
      <=> v57124(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v57124(VarNext)
      <=> ( v57126(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v57126(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_34044,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,4)
    <=> v53480(VarCurr,4) ) ).

tff(addAssignment_34043,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,4)
    <=> v53525(VarCurr,4) ) ).

tff(addAssignment_34042,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,3)
    <=> v53312(VarCurr,3) ) ).

tff(addAssignment_34041,axiom,
    ! [VarCurr: state_type] :
      ( v57030(VarCurr)
    <=> v57032(VarCurr) ) ).

tff(addAssignment_34040,axiom,
    ! [VarCurr: state_type] :
      ( v57032(VarCurr)
    <=> v57034(VarCurr) ) ).

tff(addAssignment_34039,axiom,
    ! [VarCurr: state_type] :
      ( v57034(VarCurr)
    <=> v57036(VarCurr) ) ).

tff(addAssignment_34038,axiom,
    ! [VarCurr: state_type] :
      ( v57036(VarCurr)
    <=> v57038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5409,axiom,
    ! [VarCurr: state_type] :
      ( v57038(VarCurr)
    <=> ( v57112(VarCurr)
      <~> v57088(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5408,axiom,
    ! [VarCurr: state_type] :
      ( v57112(VarCurr)
    <=> ( v57040(VarCurr)
      <~> v57064(VarCurr) ) ) ).

tff(addAssignment_34037,axiom,
    ! [VarCurr: state_type] :
      ( v57088(VarCurr)
    <=> v57090(VarCurr) ) ).

tff(addAssignment_34036,axiom,
    ! [VarCurr: state_type] :
      ( v57090(VarCurr)
    <=> v57092(VarCurr) ) ).

tff(addAssignment_34035,axiom,
    ! [VarCurr: state_type] :
      ( v57092(VarCurr)
    <=> v57094(VarCurr) ) ).

tff(addAssignment_34034,axiom,
    ! [VarCurr: state_type] :
      ( v57094(VarCurr)
    <=> v57096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5407,axiom,
    ! [VarCurr: state_type] :
      ( v57096(VarCurr)
    <=> ( v57110(VarCurr)
      <~> v57106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5406,axiom,
    ! [VarCurr: state_type] :
      ( v57110(VarCurr)
    <=> ( v57098(VarCurr)
      <~> v57102(VarCurr) ) ) ).

tff(addAssignment_34033,axiom,
    ! [VarCurr: state_type] :
      ( v57106(VarCurr)
    <=> v57108(VarCurr) ) ).

tff(addAssignment_34032,axiom,
    ! [VarCurr: state_type] :
      ( v57108(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_34031,axiom,
    ! [VarCurr: state_type] :
      ( v57102(VarCurr)
    <=> v57104(VarCurr) ) ).

tff(addAssignment_34030,axiom,
    ! [VarCurr: state_type] :
      ( v57104(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_34029,axiom,
    ! [VarCurr: state_type] :
      ( v57098(VarCurr)
    <=> v57100(VarCurr) ) ).

tff(addAssignment_34028,axiom,
    ! [VarCurr: state_type] :
      ( v57100(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_34027,axiom,
    ! [VarCurr: state_type] :
      ( v57064(VarCurr)
    <=> v57066(VarCurr) ) ).

tff(addAssignment_34026,axiom,
    ! [VarCurr: state_type] :
      ( v57066(VarCurr)
    <=> v57068(VarCurr) ) ).

tff(addAssignment_34025,axiom,
    ! [VarCurr: state_type] :
      ( v57068(VarCurr)
    <=> v57070(VarCurr) ) ).

tff(addAssignment_34024,axiom,
    ! [VarCurr: state_type] :
      ( v57070(VarCurr)
    <=> v57072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5405,axiom,
    ! [VarCurr: state_type] :
      ( v57072(VarCurr)
    <=> ( v57086(VarCurr)
      <~> v57082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5404,axiom,
    ! [VarCurr: state_type] :
      ( v57086(VarCurr)
    <=> ( v57074(VarCurr)
      <~> v57078(VarCurr) ) ) ).

tff(addAssignment_34023,axiom,
    ! [VarCurr: state_type] :
      ( v57082(VarCurr)
    <=> v57084(VarCurr) ) ).

tff(addAssignment_34022,axiom,
    ! [VarCurr: state_type] :
      ( v57084(VarCurr)
    <=> v6017(VarCurr,109) ) ).

tff(addAssignment_34021,axiom,
    ! [VarCurr: state_type] :
      ( v57078(VarCurr)
    <=> v57080(VarCurr) ) ).

tff(addAssignment_34020,axiom,
    ! [VarCurr: state_type] :
      ( v57080(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_34019,axiom,
    ! [VarCurr: state_type] :
      ( v57074(VarCurr)
    <=> v57076(VarCurr) ) ).

tff(addAssignment_34018,axiom,
    ! [VarCurr: state_type] :
      ( v57076(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_34017,axiom,
    ! [VarCurr: state_type] :
      ( v57040(VarCurr)
    <=> v57042(VarCurr) ) ).

tff(addAssignment_34016,axiom,
    ! [VarCurr: state_type] :
      ( v57042(VarCurr)
    <=> v57044(VarCurr) ) ).

tff(addAssignment_34015,axiom,
    ! [VarCurr: state_type] :
      ( v57044(VarCurr)
    <=> v57046(VarCurr) ) ).

tff(addAssignment_34014,axiom,
    ! [VarCurr: state_type] :
      ( v57046(VarCurr)
    <=> v57048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5403,axiom,
    ! [VarCurr: state_type] :
      ( v57048(VarCurr)
    <=> ( v57062(VarCurr)
      <~> v57058(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5402,axiom,
    ! [VarCurr: state_type] :
      ( v57062(VarCurr)
    <=> ( v57050(VarCurr)
      <~> v57054(VarCurr) ) ) ).

tff(addAssignment_34013,axiom,
    ! [VarCurr: state_type] :
      ( v57058(VarCurr)
    <=> v57060(VarCurr) ) ).

tff(addAssignment_34012,axiom,
    ! [VarCurr: state_type] :
      ( v57060(VarCurr)
    <=> v6017(VarCurr,104) ) ).

tff(addAssignment_34011,axiom,
    ! [VarCurr: state_type] :
      ( v57054(VarCurr)
    <=> v57056(VarCurr) ) ).

tff(addAssignment_34010,axiom,
    ! [VarCurr: state_type] :
      ( v57056(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_34009,axiom,
    ! [VarCurr: state_type] :
      ( v57050(VarCurr)
    <=> v57052(VarCurr) ) ).

tff(addAssignment_34008,axiom,
    ! [VarCurr: state_type] :
      ( v57052(VarCurr)
    <=> v6017(VarCurr,101) ) ).

tff(addAssignment_34007,axiom,
    ! [VarCurr: state_type] :
      ( v57006(VarCurr)
    <=> v57008(VarCurr) ) ).

tff(addAssignment_34006,axiom,
    ! [VarCurr: state_type] :
      ( v57008(VarCurr)
    <=> v57010(VarCurr) ) ).

tff(addAssignment_34005,axiom,
    ! [VarCurr: state_type] :
      ( v57010(VarCurr)
    <=> v57012(VarCurr) ) ).

tff(addAssignment_34004,axiom,
    ! [VarCurr: state_type] :
      ( v57012(VarCurr)
    <=> v57014(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5401,axiom,
    ! [VarCurr: state_type] :
      ( v57014(VarCurr)
    <=> ( v57028(VarCurr)
      <~> v57024(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5400,axiom,
    ! [VarCurr: state_type] :
      ( v57028(VarCurr)
    <=> ( v57016(VarCurr)
      <~> v57020(VarCurr) ) ) ).

tff(addAssignment_34003,axiom,
    ! [VarCurr: state_type] :
      ( v57024(VarCurr)
    <=> v57026(VarCurr) ) ).

tff(addAssignment_34002,axiom,
    ! [VarCurr: state_type] :
      ( v57026(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_34001,axiom,
    ! [VarCurr: state_type] :
      ( v57020(VarCurr)
    <=> v57022(VarCurr) ) ).

tff(addAssignment_34000,axiom,
    ! [VarCurr: state_type] :
      ( v57022(VarCurr)
    <=> v6017(VarCurr,123) ) ).

tff(addAssignment_33999,axiom,
    ! [VarCurr: state_type] :
      ( v57016(VarCurr)
    <=> v57018(VarCurr) ) ).

tff(addAssignment_33998,axiom,
    ! [VarCurr: state_type] :
      ( v57018(VarCurr)
    <=> v6017(VarCurr,119) ) ).

tff(addAssignment_33997,axiom,
    ! [VarCurr: state_type] :
      ( v56732(VarCurr)
    <=> v56734(VarCurr) ) ).

tff(addAssignment_33996,axiom,
    ! [VarCurr: state_type] :
      ( v56734(VarCurr)
    <=> v56736(VarCurr) ) ).

tff(addAssignment_33995,axiom,
    ! [VarCurr: state_type] :
      ( v56736(VarCurr)
    <=> v56738(VarCurr) ) ).

tff(addAssignment_33994,axiom,
    ! [VarCurr: state_type] :
      ( v56738(VarCurr)
    <=> v56740(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5399,axiom,
    ! [VarCurr: state_type] :
      ( v56740(VarCurr)
    <=> ( v56994(VarCurr)
      <~> v56910(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5398,axiom,
    ! [VarCurr: state_type] :
      ( v56994(VarCurr)
    <=> ( v56742(VarCurr)
      <~> v56826(VarCurr) ) ) ).

tff(addAssignment_33993,axiom,
    ! [VarCurr: state_type] :
      ( v56910(VarCurr)
    <=> v56912(VarCurr) ) ).

tff(addAssignment_33992,axiom,
    ! [VarCurr: state_type] :
      ( v56912(VarCurr)
    <=> v56914(VarCurr) ) ).

tff(addAssignment_33991,axiom,
    ! [VarCurr: state_type] :
      ( v56914(VarCurr)
    <=> v56916(VarCurr) ) ).

tff(addAssignment_33990,axiom,
    ! [VarCurr: state_type] :
      ( v56916(VarCurr)
    <=> v56918(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5397,axiom,
    ! [VarCurr: state_type] :
      ( v56918(VarCurr)
    <=> ( v56992(VarCurr)
      <~> v56968(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5396,axiom,
    ! [VarCurr: state_type] :
      ( v56992(VarCurr)
    <=> ( v56920(VarCurr)
      <~> v56944(VarCurr) ) ) ).

tff(addAssignment_33989,axiom,
    ! [VarCurr: state_type] :
      ( v56968(VarCurr)
    <=> v56970(VarCurr) ) ).

tff(addAssignment_33988,axiom,
    ! [VarCurr: state_type] :
      ( v56970(VarCurr)
    <=> v56972(VarCurr) ) ).

tff(addAssignment_33987,axiom,
    ! [VarCurr: state_type] :
      ( v56972(VarCurr)
    <=> v56974(VarCurr) ) ).

tff(addAssignment_33986,axiom,
    ! [VarCurr: state_type] :
      ( v56974(VarCurr)
    <=> v56976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5395,axiom,
    ! [VarCurr: state_type] :
      ( v56976(VarCurr)
    <=> ( v56990(VarCurr)
      <~> v56986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5394,axiom,
    ! [VarCurr: state_type] :
      ( v56990(VarCurr)
    <=> ( v56978(VarCurr)
      <~> v56982(VarCurr) ) ) ).

tff(addAssignment_33985,axiom,
    ! [VarCurr: state_type] :
      ( v56986(VarCurr)
    <=> v56988(VarCurr) ) ).

tff(addAssignment_33984,axiom,
    ! [VarCurr: state_type] :
      ( v56988(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_33983,axiom,
    ! [VarCurr: state_type] :
      ( v56982(VarCurr)
    <=> v56984(VarCurr) ) ).

tff(addAssignment_33982,axiom,
    ! [VarCurr: state_type] :
      ( v56984(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_33981,axiom,
    ! [VarCurr: state_type] :
      ( v56978(VarCurr)
    <=> v56980(VarCurr) ) ).

tff(addAssignment_33980,axiom,
    ! [VarCurr: state_type] :
      ( v56980(VarCurr)
    <=> v6017(VarCurr,96) ) ).

tff(addAssignment_33979,axiom,
    ! [VarCurr: state_type] :
      ( v56944(VarCurr)
    <=> v56946(VarCurr) ) ).

tff(addAssignment_33978,axiom,
    ! [VarCurr: state_type] :
      ( v56946(VarCurr)
    <=> v56948(VarCurr) ) ).

tff(addAssignment_33977,axiom,
    ! [VarCurr: state_type] :
      ( v56948(VarCurr)
    <=> v56950(VarCurr) ) ).

tff(addAssignment_33976,axiom,
    ! [VarCurr: state_type] :
      ( v56950(VarCurr)
    <=> v56952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5393,axiom,
    ! [VarCurr: state_type] :
      ( v56952(VarCurr)
    <=> ( v56966(VarCurr)
      <~> v56962(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5392,axiom,
    ! [VarCurr: state_type] :
      ( v56966(VarCurr)
    <=> ( v56954(VarCurr)
      <~> v56958(VarCurr) ) ) ).

tff(addAssignment_33975,axiom,
    ! [VarCurr: state_type] :
      ( v56962(VarCurr)
    <=> v56964(VarCurr) ) ).

tff(addAssignment_33974,axiom,
    ! [VarCurr: state_type] :
      ( v56964(VarCurr)
    <=> v6017(VarCurr,94) ) ).

tff(addAssignment_33973,axiom,
    ! [VarCurr: state_type] :
      ( v56958(VarCurr)
    <=> v56960(VarCurr) ) ).

tff(addAssignment_33972,axiom,
    ! [VarCurr: state_type] :
      ( v56960(VarCurr)
    <=> v6017(VarCurr,90) ) ).

tff(addAssignment_33971,axiom,
    ! [VarCurr: state_type] :
      ( v56954(VarCurr)
    <=> v56956(VarCurr) ) ).

tff(addAssignment_33970,axiom,
    ! [VarCurr: state_type] :
      ( v56956(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_33969,axiom,
    ! [VarCurr: state_type] :
      ( v56920(VarCurr)
    <=> v56922(VarCurr) ) ).

tff(addAssignment_33968,axiom,
    ! [VarCurr: state_type] :
      ( v56922(VarCurr)
    <=> v56924(VarCurr) ) ).

tff(addAssignment_33967,axiom,
    ! [VarCurr: state_type] :
      ( v56924(VarCurr)
    <=> v56926(VarCurr) ) ).

tff(addAssignment_33966,axiom,
    ! [VarCurr: state_type] :
      ( v56926(VarCurr)
    <=> v56928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5391,axiom,
    ! [VarCurr: state_type] :
      ( v56928(VarCurr)
    <=> ( v56942(VarCurr)
      <~> v56938(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5390,axiom,
    ! [VarCurr: state_type] :
      ( v56942(VarCurr)
    <=> ( v56930(VarCurr)
      <~> v56934(VarCurr) ) ) ).

tff(addAssignment_33965,axiom,
    ! [VarCurr: state_type] :
      ( v56938(VarCurr)
    <=> v56940(VarCurr) ) ).

tff(addAssignment_33964,axiom,
    ! [VarCurr: state_type] :
      ( v56940(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_33963,axiom,
    ! [VarCurr: state_type] :
      ( v56934(VarCurr)
    <=> v56936(VarCurr) ) ).

tff(addAssignment_33962,axiom,
    ! [VarCurr: state_type] :
      ( v56936(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_33961,axiom,
    ! [VarCurr: state_type] :
      ( v56930(VarCurr)
    <=> v56932(VarCurr) ) ).

tff(addAssignment_33960,axiom,
    ! [VarCurr: state_type] :
      ( v56932(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_33959,axiom,
    ! [VarCurr: state_type] :
      ( v56826(VarCurr)
    <=> v56828(VarCurr) ) ).

tff(addAssignment_33958,axiom,
    ! [VarCurr: state_type] :
      ( v56828(VarCurr)
    <=> v56830(VarCurr) ) ).

tff(addAssignment_33957,axiom,
    ! [VarCurr: state_type] :
      ( v56830(VarCurr)
    <=> v56832(VarCurr) ) ).

tff(addAssignment_33956,axiom,
    ! [VarCurr: state_type] :
      ( v56832(VarCurr)
    <=> v56834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5389,axiom,
    ! [VarCurr: state_type] :
      ( v56834(VarCurr)
    <=> ( v56908(VarCurr)
      <~> v56884(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5388,axiom,
    ! [VarCurr: state_type] :
      ( v56908(VarCurr)
    <=> ( v56836(VarCurr)
      <~> v56860(VarCurr) ) ) ).

tff(addAssignment_33955,axiom,
    ! [VarCurr: state_type] :
      ( v56884(VarCurr)
    <=> v56886(VarCurr) ) ).

tff(addAssignment_33954,axiom,
    ! [VarCurr: state_type] :
      ( v56886(VarCurr)
    <=> v56888(VarCurr) ) ).

tff(addAssignment_33953,axiom,
    ! [VarCurr: state_type] :
      ( v56888(VarCurr)
    <=> v56890(VarCurr) ) ).

tff(addAssignment_33952,axiom,
    ! [VarCurr: state_type] :
      ( v56890(VarCurr)
    <=> v56892(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5387,axiom,
    ! [VarCurr: state_type] :
      ( v56892(VarCurr)
    <=> ( v56906(VarCurr)
      <~> v56902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5386,axiom,
    ! [VarCurr: state_type] :
      ( v56906(VarCurr)
    <=> ( v56894(VarCurr)
      <~> v56898(VarCurr) ) ) ).

tff(addAssignment_33951,axiom,
    ! [VarCurr: state_type] :
      ( v56902(VarCurr)
    <=> v56904(VarCurr) ) ).

tff(addAssignment_33950,axiom,
    ! [VarCurr: state_type] :
      ( v56904(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_33949,axiom,
    ! [VarCurr: state_type] :
      ( v56898(VarCurr)
    <=> v56900(VarCurr) ) ).

tff(addAssignment_33948,axiom,
    ! [VarCurr: state_type] :
      ( v56900(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_33947,axiom,
    ! [VarCurr: state_type] :
      ( v56894(VarCurr)
    <=> v56896(VarCurr) ) ).

tff(addAssignment_33946,axiom,
    ! [VarCurr: state_type] :
      ( v56896(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_33945,axiom,
    ! [VarCurr: state_type] :
      ( v56860(VarCurr)
    <=> v56862(VarCurr) ) ).

tff(addAssignment_33944,axiom,
    ! [VarCurr: state_type] :
      ( v56862(VarCurr)
    <=> v56864(VarCurr) ) ).

tff(addAssignment_33943,axiom,
    ! [VarCurr: state_type] :
      ( v56864(VarCurr)
    <=> v56866(VarCurr) ) ).

tff(addAssignment_33942,axiom,
    ! [VarCurr: state_type] :
      ( v56866(VarCurr)
    <=> v56868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5385,axiom,
    ! [VarCurr: state_type] :
      ( v56868(VarCurr)
    <=> ( v56882(VarCurr)
      <~> v56878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5384,axiom,
    ! [VarCurr: state_type] :
      ( v56882(VarCurr)
    <=> ( v56870(VarCurr)
      <~> v56874(VarCurr) ) ) ).

tff(addAssignment_33941,axiom,
    ! [VarCurr: state_type] :
      ( v56878(VarCurr)
    <=> v56880(VarCurr) ) ).

tff(addAssignment_33940,axiom,
    ! [VarCurr: state_type] :
      ( v56880(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_33939,axiom,
    ! [VarCurr: state_type] :
      ( v56874(VarCurr)
    <=> v56876(VarCurr) ) ).

tff(addAssignment_33938,axiom,
    ! [VarCurr: state_type] :
      ( v56876(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_33937,axiom,
    ! [VarCurr: state_type] :
      ( v56870(VarCurr)
    <=> v56872(VarCurr) ) ).

tff(addAssignment_33936,axiom,
    ! [VarCurr: state_type] :
      ( v56872(VarCurr)
    <=> v6017(VarCurr,73) ) ).

tff(addAssignment_33935,axiom,
    ! [VarCurr: state_type] :
      ( v56836(VarCurr)
    <=> v56838(VarCurr) ) ).

tff(addAssignment_33934,axiom,
    ! [VarCurr: state_type] :
      ( v56838(VarCurr)
    <=> v56840(VarCurr) ) ).

tff(addAssignment_33933,axiom,
    ! [VarCurr: state_type] :
      ( v56840(VarCurr)
    <=> v56842(VarCurr) ) ).

tff(addAssignment_33932,axiom,
    ! [VarCurr: state_type] :
      ( v56842(VarCurr)
    <=> v56844(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5383,axiom,
    ! [VarCurr: state_type] :
      ( v56844(VarCurr)
    <=> ( v56858(VarCurr)
      <~> v56854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5382,axiom,
    ! [VarCurr: state_type] :
      ( v56858(VarCurr)
    <=> ( v56846(VarCurr)
      <~> v56850(VarCurr) ) ) ).

tff(addAssignment_33931,axiom,
    ! [VarCurr: state_type] :
      ( v56854(VarCurr)
    <=> v56856(VarCurr) ) ).

tff(addAssignment_33930,axiom,
    ! [VarCurr: state_type] :
      ( v56856(VarCurr)
    <=> v6017(VarCurr,72) ) ).

tff(addAssignment_33929,axiom,
    ! [VarCurr: state_type] :
      ( v56850(VarCurr)
    <=> v56852(VarCurr) ) ).

tff(addAssignment_33928,axiom,
    ! [VarCurr: state_type] :
      ( v56852(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_33927,axiom,
    ! [VarCurr: state_type] :
      ( v56846(VarCurr)
    <=> v56848(VarCurr) ) ).

tff(addAssignment_33926,axiom,
    ! [VarCurr: state_type] :
      ( v56848(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_33925,axiom,
    ! [VarCurr: state_type] :
      ( v56742(VarCurr)
    <=> v56744(VarCurr) ) ).

tff(addAssignment_33924,axiom,
    ! [VarCurr: state_type] :
      ( v56744(VarCurr)
    <=> v56746(VarCurr) ) ).

tff(addAssignment_33923,axiom,
    ! [VarCurr: state_type] :
      ( v56746(VarCurr)
    <=> v56748(VarCurr) ) ).

tff(addAssignment_33922,axiom,
    ! [VarCurr: state_type] :
      ( v56748(VarCurr)
    <=> v56750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5381,axiom,
    ! [VarCurr: state_type] :
      ( v56750(VarCurr)
    <=> ( v56824(VarCurr)
      <~> v56800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5380,axiom,
    ! [VarCurr: state_type] :
      ( v56824(VarCurr)
    <=> ( v56752(VarCurr)
      <~> v56776(VarCurr) ) ) ).

tff(addAssignment_33921,axiom,
    ! [VarCurr: state_type] :
      ( v56800(VarCurr)
    <=> v56802(VarCurr) ) ).

tff(addAssignment_33920,axiom,
    ! [VarCurr: state_type] :
      ( v56802(VarCurr)
    <=> v56804(VarCurr) ) ).

tff(addAssignment_33919,axiom,
    ! [VarCurr: state_type] :
      ( v56804(VarCurr)
    <=> v56806(VarCurr) ) ).

tff(addAssignment_33918,axiom,
    ! [VarCurr: state_type] :
      ( v56806(VarCurr)
    <=> v56808(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5379,axiom,
    ! [VarCurr: state_type] :
      ( v56808(VarCurr)
    <=> ( v56822(VarCurr)
      <~> v56818(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5378,axiom,
    ! [VarCurr: state_type] :
      ( v56822(VarCurr)
    <=> ( v56810(VarCurr)
      <~> v56814(VarCurr) ) ) ).

tff(addAssignment_33917,axiom,
    ! [VarCurr: state_type] :
      ( v56818(VarCurr)
    <=> v56820(VarCurr) ) ).

tff(addAssignment_33916,axiom,
    ! [VarCurr: state_type] :
      ( v56820(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_33915,axiom,
    ! [VarCurr: state_type] :
      ( v56814(VarCurr)
    <=> v56816(VarCurr) ) ).

tff(addAssignment_33914,axiom,
    ! [VarCurr: state_type] :
      ( v56816(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_33913,axiom,
    ! [VarCurr: state_type] :
      ( v56810(VarCurr)
    <=> v56812(VarCurr) ) ).

tff(addAssignment_33912,axiom,
    ! [VarCurr: state_type] :
      ( v56812(VarCurr)
    <=> v6017(VarCurr,64) ) ).

tff(addAssignment_33911,axiom,
    ! [VarCurr: state_type] :
      ( v56776(VarCurr)
    <=> v56778(VarCurr) ) ).

tff(addAssignment_33910,axiom,
    ! [VarCurr: state_type] :
      ( v56778(VarCurr)
    <=> v56780(VarCurr) ) ).

tff(addAssignment_33909,axiom,
    ! [VarCurr: state_type] :
      ( v56780(VarCurr)
    <=> v56782(VarCurr) ) ).

tff(addAssignment_33908,axiom,
    ! [VarCurr: state_type] :
      ( v56782(VarCurr)
    <=> v56784(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5377,axiom,
    ! [VarCurr: state_type] :
      ( v56784(VarCurr)
    <=> ( v56798(VarCurr)
      <~> v56794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5376,axiom,
    ! [VarCurr: state_type] :
      ( v56798(VarCurr)
    <=> ( v56786(VarCurr)
      <~> v56790(VarCurr) ) ) ).

tff(addAssignment_33907,axiom,
    ! [VarCurr: state_type] :
      ( v56794(VarCurr)
    <=> v56796(VarCurr) ) ).

tff(addAssignment_33906,axiom,
    ! [VarCurr: state_type] :
      ( v56796(VarCurr)
    <=> v6017(VarCurr,63) ) ).

tff(addAssignment_33905,axiom,
    ! [VarCurr: state_type] :
      ( v56790(VarCurr)
    <=> v56792(VarCurr) ) ).

tff(addAssignment_33904,axiom,
    ! [VarCurr: state_type] :
      ( v56792(VarCurr)
    <=> v6017(VarCurr,59) ) ).

tff(addAssignment_33903,axiom,
    ! [VarCurr: state_type] :
      ( v56786(VarCurr)
    <=> v56788(VarCurr) ) ).

tff(addAssignment_33902,axiom,
    ! [VarCurr: state_type] :
      ( v56788(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_33901,axiom,
    ! [VarCurr: state_type] :
      ( v56752(VarCurr)
    <=> v56754(VarCurr) ) ).

tff(addAssignment_33900,axiom,
    ! [VarCurr: state_type] :
      ( v56754(VarCurr)
    <=> v56756(VarCurr) ) ).

tff(addAssignment_33899,axiom,
    ! [VarCurr: state_type] :
      ( v56756(VarCurr)
    <=> v56758(VarCurr) ) ).

tff(addAssignment_33898,axiom,
    ! [VarCurr: state_type] :
      ( v56758(VarCurr)
    <=> v56760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5375,axiom,
    ! [VarCurr: state_type] :
      ( v56760(VarCurr)
    <=> ( v56774(VarCurr)
      <~> v56770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5374,axiom,
    ! [VarCurr: state_type] :
      ( v56774(VarCurr)
    <=> ( v56762(VarCurr)
      <~> v56766(VarCurr) ) ) ).

tff(addAssignment_33897,axiom,
    ! [VarCurr: state_type] :
      ( v56770(VarCurr)
    <=> v56772(VarCurr) ) ).

tff(addAssignment_33896,axiom,
    ! [VarCurr: state_type] :
      ( v56772(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_33895,axiom,
    ! [VarCurr: state_type] :
      ( v56766(VarCurr)
    <=> v56768(VarCurr) ) ).

tff(addAssignment_33894,axiom,
    ! [VarCurr: state_type] :
      ( v56768(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_33893,axiom,
    ! [VarCurr: state_type] :
      ( v56762(VarCurr)
    <=> v56764(VarCurr) ) ).

tff(addAssignment_33892,axiom,
    ! [VarCurr: state_type] :
      ( v56764(VarCurr)
    <=> v6017(VarCurr,49) ) ).

tff(addAssignment_33891,axiom,
    ! [VarCurr: state_type] :
      ( v56468(VarCurr)
    <=> v56470(VarCurr) ) ).

tff(addAssignment_33890,axiom,
    ! [VarCurr: state_type] :
      ( v56470(VarCurr)
    <=> v56472(VarCurr) ) ).

tff(addAssignment_33889,axiom,
    ! [VarCurr: state_type] :
      ( v56472(VarCurr)
    <=> v56474(VarCurr) ) ).

tff(addAssignment_33888,axiom,
    ! [VarCurr: state_type] :
      ( v56474(VarCurr)
    <=> v56476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5373,axiom,
    ! [VarCurr: state_type] :
      ( v56476(VarCurr)
    <=> ( v56730(VarCurr)
      <~> v56646(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5372,axiom,
    ! [VarCurr: state_type] :
      ( v56730(VarCurr)
    <=> ( v56478(VarCurr)
      <~> v56562(VarCurr) ) ) ).

tff(addAssignment_33887,axiom,
    ! [VarCurr: state_type] :
      ( v56646(VarCurr)
    <=> v56648(VarCurr) ) ).

tff(addAssignment_33886,axiom,
    ! [VarCurr: state_type] :
      ( v56648(VarCurr)
    <=> v56650(VarCurr) ) ).

tff(addAssignment_33885,axiom,
    ! [VarCurr: state_type] :
      ( v56650(VarCurr)
    <=> v56652(VarCurr) ) ).

tff(addAssignment_33884,axiom,
    ! [VarCurr: state_type] :
      ( v56652(VarCurr)
    <=> v56654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5371,axiom,
    ! [VarCurr: state_type] :
      ( v56654(VarCurr)
    <=> ( v56728(VarCurr)
      <~> v56704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5370,axiom,
    ! [VarCurr: state_type] :
      ( v56728(VarCurr)
    <=> ( v56656(VarCurr)
      <~> v56680(VarCurr) ) ) ).

tff(addAssignment_33883,axiom,
    ! [VarCurr: state_type] :
      ( v56704(VarCurr)
    <=> v56706(VarCurr) ) ).

tff(addAssignment_33882,axiom,
    ! [VarCurr: state_type] :
      ( v56706(VarCurr)
    <=> v56708(VarCurr) ) ).

tff(addAssignment_33881,axiom,
    ! [VarCurr: state_type] :
      ( v56708(VarCurr)
    <=> v56710(VarCurr) ) ).

tff(addAssignment_33880,axiom,
    ! [VarCurr: state_type] :
      ( v56710(VarCurr)
    <=> v56712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5369,axiom,
    ! [VarCurr: state_type] :
      ( v56712(VarCurr)
    <=> ( v56726(VarCurr)
      <~> v56722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5368,axiom,
    ! [VarCurr: state_type] :
      ( v56726(VarCurr)
    <=> ( v56714(VarCurr)
      <~> v56718(VarCurr) ) ) ).

tff(addAssignment_33879,axiom,
    ! [VarCurr: state_type] :
      ( v56722(VarCurr)
    <=> v56724(VarCurr) ) ).

tff(addAssignment_33878,axiom,
    ! [VarCurr: state_type] :
      ( v56724(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_33877,axiom,
    ! [VarCurr: state_type] :
      ( v56718(VarCurr)
    <=> v56720(VarCurr) ) ).

tff(addAssignment_33876,axiom,
    ! [VarCurr: state_type] :
      ( v56720(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_33875,axiom,
    ! [VarCurr: state_type] :
      ( v56714(VarCurr)
    <=> v56716(VarCurr) ) ).

tff(addAssignment_33874,axiom,
    ! [VarCurr: state_type] :
      ( v56716(VarCurr)
    <=> v6017(VarCurr,44) ) ).

tff(addAssignment_33873,axiom,
    ! [VarCurr: state_type] :
      ( v56680(VarCurr)
    <=> v56682(VarCurr) ) ).

tff(addAssignment_33872,axiom,
    ! [VarCurr: state_type] :
      ( v56682(VarCurr)
    <=> v56684(VarCurr) ) ).

tff(addAssignment_33871,axiom,
    ! [VarCurr: state_type] :
      ( v56684(VarCurr)
    <=> v56686(VarCurr) ) ).

tff(addAssignment_33870,axiom,
    ! [VarCurr: state_type] :
      ( v56686(VarCurr)
    <=> v56688(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5367,axiom,
    ! [VarCurr: state_type] :
      ( v56688(VarCurr)
    <=> ( v56702(VarCurr)
      <~> v56698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5366,axiom,
    ! [VarCurr: state_type] :
      ( v56702(VarCurr)
    <=> ( v56690(VarCurr)
      <~> v56694(VarCurr) ) ) ).

tff(addAssignment_33869,axiom,
    ! [VarCurr: state_type] :
      ( v56698(VarCurr)
    <=> v56700(VarCurr) ) ).

tff(addAssignment_33868,axiom,
    ! [VarCurr: state_type] :
      ( v56700(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_33867,axiom,
    ! [VarCurr: state_type] :
      ( v56694(VarCurr)
    <=> v56696(VarCurr) ) ).

tff(addAssignment_33866,axiom,
    ! [VarCurr: state_type] :
      ( v56696(VarCurr)
    <=> v6017(VarCurr,41) ) ).

tff(addAssignment_33865,axiom,
    ! [VarCurr: state_type] :
      ( v56690(VarCurr)
    <=> v56692(VarCurr) ) ).

tff(addAssignment_33864,axiom,
    ! [VarCurr: state_type] :
      ( v56692(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_33863,axiom,
    ! [VarCurr: state_type] :
      ( v56656(VarCurr)
    <=> v56658(VarCurr) ) ).

tff(addAssignment_33862,axiom,
    ! [VarCurr: state_type] :
      ( v56658(VarCurr)
    <=> v56660(VarCurr) ) ).

tff(addAssignment_33861,axiom,
    ! [VarCurr: state_type] :
      ( v56660(VarCurr)
    <=> v56662(VarCurr) ) ).

tff(addAssignment_33860,axiom,
    ! [VarCurr: state_type] :
      ( v56662(VarCurr)
    <=> v56664(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5365,axiom,
    ! [VarCurr: state_type] :
      ( v56664(VarCurr)
    <=> ( v56678(VarCurr)
      <~> v56674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5364,axiom,
    ! [VarCurr: state_type] :
      ( v56678(VarCurr)
    <=> ( v56666(VarCurr)
      <~> v56670(VarCurr) ) ) ).

tff(addAssignment_33859,axiom,
    ! [VarCurr: state_type] :
      ( v56674(VarCurr)
    <=> v56676(VarCurr) ) ).

tff(addAssignment_33858,axiom,
    ! [VarCurr: state_type] :
      ( v56676(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_33857,axiom,
    ! [VarCurr: state_type] :
      ( v56670(VarCurr)
    <=> v56672(VarCurr) ) ).

tff(addAssignment_33856,axiom,
    ! [VarCurr: state_type] :
      ( v56672(VarCurr)
    <=> v6017(VarCurr,36) ) ).

tff(addAssignment_33855,axiom,
    ! [VarCurr: state_type] :
      ( v56666(VarCurr)
    <=> v56668(VarCurr) ) ).

tff(addAssignment_33854,axiom,
    ! [VarCurr: state_type] :
      ( v56668(VarCurr)
    <=> v6017(VarCurr,34) ) ).

tff(addAssignment_33853,axiom,
    ! [VarCurr: state_type] :
      ( v56562(VarCurr)
    <=> v56564(VarCurr) ) ).

tff(addAssignment_33852,axiom,
    ! [VarCurr: state_type] :
      ( v56564(VarCurr)
    <=> v56566(VarCurr) ) ).

tff(addAssignment_33851,axiom,
    ! [VarCurr: state_type] :
      ( v56566(VarCurr)
    <=> v56568(VarCurr) ) ).

tff(addAssignment_33850,axiom,
    ! [VarCurr: state_type] :
      ( v56568(VarCurr)
    <=> v56570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5363,axiom,
    ! [VarCurr: state_type] :
      ( v56570(VarCurr)
    <=> ( v56644(VarCurr)
      <~> v56620(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5362,axiom,
    ! [VarCurr: state_type] :
      ( v56644(VarCurr)
    <=> ( v56572(VarCurr)
      <~> v56596(VarCurr) ) ) ).

tff(addAssignment_33849,axiom,
    ! [VarCurr: state_type] :
      ( v56620(VarCurr)
    <=> v56622(VarCurr) ) ).

tff(addAssignment_33848,axiom,
    ! [VarCurr: state_type] :
      ( v56622(VarCurr)
    <=> v56624(VarCurr) ) ).

tff(addAssignment_33847,axiom,
    ! [VarCurr: state_type] :
      ( v56624(VarCurr)
    <=> v56626(VarCurr) ) ).

tff(addAssignment_33846,axiom,
    ! [VarCurr: state_type] :
      ( v56626(VarCurr)
    <=> v56628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5361,axiom,
    ! [VarCurr: state_type] :
      ( v56628(VarCurr)
    <=> ( v56642(VarCurr)
      <~> v56638(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5360,axiom,
    ! [VarCurr: state_type] :
      ( v56642(VarCurr)
    <=> ( v56630(VarCurr)
      <~> v56634(VarCurr) ) ) ).

tff(addAssignment_33845,axiom,
    ! [VarCurr: state_type] :
      ( v56638(VarCurr)
    <=> v56640(VarCurr) ) ).

tff(addAssignment_33844,axiom,
    ! [VarCurr: state_type] :
      ( v56640(VarCurr)
    <=> v6017(VarCurr,30) ) ).

tff(addAssignment_33843,axiom,
    ! [VarCurr: state_type] :
      ( v56634(VarCurr)
    <=> v56636(VarCurr) ) ).

tff(addAssignment_33842,axiom,
    ! [VarCurr: state_type] :
      ( v56636(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_33841,axiom,
    ! [VarCurr: state_type] :
      ( v56630(VarCurr)
    <=> v56632(VarCurr) ) ).

tff(addAssignment_33840,axiom,
    ! [VarCurr: state_type] :
      ( v56632(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_33839,axiom,
    ! [VarCurr: state_type] :
      ( v56596(VarCurr)
    <=> v56598(VarCurr) ) ).

tff(addAssignment_33838,axiom,
    ! [VarCurr: state_type] :
      ( v56598(VarCurr)
    <=> v56600(VarCurr) ) ).

tff(addAssignment_33837,axiom,
    ! [VarCurr: state_type] :
      ( v56600(VarCurr)
    <=> v56602(VarCurr) ) ).

tff(addAssignment_33836,axiom,
    ! [VarCurr: state_type] :
      ( v56602(VarCurr)
    <=> v56604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5359,axiom,
    ! [VarCurr: state_type] :
      ( v56604(VarCurr)
    <=> ( v56618(VarCurr)
      <~> v56614(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5358,axiom,
    ! [VarCurr: state_type] :
      ( v56618(VarCurr)
    <=> ( v56606(VarCurr)
      <~> v56610(VarCurr) ) ) ).

tff(addAssignment_33835,axiom,
    ! [VarCurr: state_type] :
      ( v56614(VarCurr)
    <=> v56616(VarCurr) ) ).

tff(addAssignment_33834,axiom,
    ! [VarCurr: state_type] :
      ( v56616(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_33833,axiom,
    ! [VarCurr: state_type] :
      ( v56610(VarCurr)
    <=> v56612(VarCurr) ) ).

tff(addAssignment_33832,axiom,
    ! [VarCurr: state_type] :
      ( v56612(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_33831,axiom,
    ! [VarCurr: state_type] :
      ( v56606(VarCurr)
    <=> v56608(VarCurr) ) ).

tff(addAssignment_33830,axiom,
    ! [VarCurr: state_type] :
      ( v56608(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_33829,axiom,
    ! [VarCurr: state_type] :
      ( v56572(VarCurr)
    <=> v56574(VarCurr) ) ).

tff(addAssignment_33828,axiom,
    ! [VarCurr: state_type] :
      ( v56574(VarCurr)
    <=> v56576(VarCurr) ) ).

tff(addAssignment_33827,axiom,
    ! [VarCurr: state_type] :
      ( v56576(VarCurr)
    <=> v56578(VarCurr) ) ).

tff(addAssignment_33826,axiom,
    ! [VarCurr: state_type] :
      ( v56578(VarCurr)
    <=> v56580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5357,axiom,
    ! [VarCurr: state_type] :
      ( v56580(VarCurr)
    <=> ( v56594(VarCurr)
      <~> v56590(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5356,axiom,
    ! [VarCurr: state_type] :
      ( v56594(VarCurr)
    <=> ( v56582(VarCurr)
      <~> v56586(VarCurr) ) ) ).

tff(addAssignment_33825,axiom,
    ! [VarCurr: state_type] :
      ( v56590(VarCurr)
    <=> v56592(VarCurr) ) ).

tff(addAssignment_33824,axiom,
    ! [VarCurr: state_type] :
      ( v56592(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_33823,axiom,
    ! [VarCurr: state_type] :
      ( v56586(VarCurr)
    <=> v56588(VarCurr) ) ).

tff(addAssignment_33822,axiom,
    ! [VarCurr: state_type] :
      ( v56588(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_33821,axiom,
    ! [VarCurr: state_type] :
      ( v56582(VarCurr)
    <=> v56584(VarCurr) ) ).

tff(addAssignment_33820,axiom,
    ! [VarCurr: state_type] :
      ( v56584(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_33819,axiom,
    ! [VarCurr: state_type] :
      ( v56478(VarCurr)
    <=> v56480(VarCurr) ) ).

tff(addAssignment_33818,axiom,
    ! [VarCurr: state_type] :
      ( v56480(VarCurr)
    <=> v56482(VarCurr) ) ).

tff(addAssignment_33817,axiom,
    ! [VarCurr: state_type] :
      ( v56482(VarCurr)
    <=> v56484(VarCurr) ) ).

tff(addAssignment_33816,axiom,
    ! [VarCurr: state_type] :
      ( v56484(VarCurr)
    <=> v56486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5355,axiom,
    ! [VarCurr: state_type] :
      ( v56486(VarCurr)
    <=> ( v56560(VarCurr)
      <~> v56536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5354,axiom,
    ! [VarCurr: state_type] :
      ( v56560(VarCurr)
    <=> ( v56488(VarCurr)
      <~> v56512(VarCurr) ) ) ).

tff(addAssignment_33815,axiom,
    ! [VarCurr: state_type] :
      ( v56536(VarCurr)
    <=> v56538(VarCurr) ) ).

tff(addAssignment_33814,axiom,
    ! [VarCurr: state_type] :
      ( v56538(VarCurr)
    <=> v56540(VarCurr) ) ).

tff(addAssignment_33813,axiom,
    ! [VarCurr: state_type] :
      ( v56540(VarCurr)
    <=> v56542(VarCurr) ) ).

tff(addAssignment_33812,axiom,
    ! [VarCurr: state_type] :
      ( v56542(VarCurr)
    <=> v56544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5353,axiom,
    ! [VarCurr: state_type] :
      ( v56544(VarCurr)
    <=> ( v56558(VarCurr)
      <~> v56554(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5352,axiom,
    ! [VarCurr: state_type] :
      ( v56558(VarCurr)
    <=> ( v56546(VarCurr)
      <~> v56550(VarCurr) ) ) ).

tff(addAssignment_33811,axiom,
    ! [VarCurr: state_type] :
      ( v56554(VarCurr)
    <=> v56556(VarCurr) ) ).

tff(addAssignment_33810,axiom,
    ! [VarCurr: state_type] :
      ( v56556(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_33809,axiom,
    ! [VarCurr: state_type] :
      ( v56550(VarCurr)
    <=> v56552(VarCurr) ) ).

tff(addAssignment_33808,axiom,
    ! [VarCurr: state_type] :
      ( v56552(VarCurr)
    <=> v6017(VarCurr,13) ) ).

tff(addAssignment_33807,axiom,
    ! [VarCurr: state_type] :
      ( v56546(VarCurr)
    <=> v56548(VarCurr) ) ).

tff(addAssignment_33806,axiom,
    ! [VarCurr: state_type] :
      ( v56548(VarCurr)
    <=> v6017(VarCurr,12) ) ).

tff(addAssignment_33805,axiom,
    ! [VarCurr: state_type] :
      ( v56512(VarCurr)
    <=> v56514(VarCurr) ) ).

tff(addAssignment_33804,axiom,
    ! [VarCurr: state_type] :
      ( v56514(VarCurr)
    <=> v56516(VarCurr) ) ).

tff(addAssignment_33803,axiom,
    ! [VarCurr: state_type] :
      ( v56516(VarCurr)
    <=> v56518(VarCurr) ) ).

tff(addAssignment_33802,axiom,
    ! [VarCurr: state_type] :
      ( v56518(VarCurr)
    <=> v56520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5351,axiom,
    ! [VarCurr: state_type] :
      ( v56520(VarCurr)
    <=> ( v56534(VarCurr)
      <~> v56530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5350,axiom,
    ! [VarCurr: state_type] :
      ( v56534(VarCurr)
    <=> ( v56522(VarCurr)
      <~> v56526(VarCurr) ) ) ).

tff(addAssignment_33801,axiom,
    ! [VarCurr: state_type] :
      ( v56530(VarCurr)
    <=> v56532(VarCurr) ) ).

tff(addAssignment_33800,axiom,
    ! [VarCurr: state_type] :
      ( v56532(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_33799,axiom,
    ! [VarCurr: state_type] :
      ( v56526(VarCurr)
    <=> v56528(VarCurr) ) ).

tff(addAssignment_33798,axiom,
    ! [VarCurr: state_type] :
      ( v56528(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_33797,axiom,
    ! [VarCurr: state_type] :
      ( v56522(VarCurr)
    <=> v56524(VarCurr) ) ).

tff(addAssignment_33796,axiom,
    ! [VarCurr: state_type] :
      ( v56524(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_33795,axiom,
    ! [VarCurr: state_type] :
      ( v56488(VarCurr)
    <=> v56490(VarCurr) ) ).

tff(addAssignment_33794,axiom,
    ! [VarCurr: state_type] :
      ( v56490(VarCurr)
    <=> v56492(VarCurr) ) ).

tff(addAssignment_33793,axiom,
    ! [VarCurr: state_type] :
      ( v56492(VarCurr)
    <=> v56494(VarCurr) ) ).

tff(addAssignment_33792,axiom,
    ! [VarCurr: state_type] :
      ( v56494(VarCurr)
    <=> v56496(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5349,axiom,
    ! [VarCurr: state_type] :
      ( v56496(VarCurr)
    <=> ( v56510(VarCurr)
      <~> v56506(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5348,axiom,
    ! [VarCurr: state_type] :
      ( v56510(VarCurr)
    <=> ( v56498(VarCurr)
      <~> v56502(VarCurr) ) ) ).

tff(addAssignment_33791,axiom,
    ! [VarCurr: state_type] :
      ( v56506(VarCurr)
    <=> v56508(VarCurr) ) ).

tff(addAssignment_33790,axiom,
    ! [VarCurr: state_type] :
      ( v56508(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_33789,axiom,
    ! [VarCurr: state_type] :
      ( v56502(VarCurr)
    <=> v56504(VarCurr) ) ).

tff(addAssignment_33788,axiom,
    ! [VarCurr: state_type] :
      ( v56504(VarCurr)
    <=> v6017(VarCurr,4) ) ).

tff(addAssignment_33787,axiom,
    ! [VarCurr: state_type] :
      ( v56498(VarCurr)
    <=> v56500(VarCurr) ) ).

tff(addAssignment_33786,axiom,
    ! [VarCurr: state_type] :
      ( v56500(VarCurr)
    <=> v6017(VarCurr,3) ) ).

tff(addAssignment_33785,axiom,
    ! [VarCurr: state_type] :
      ( v5931(VarCurr)
    <=> v5933(VarCurr) ) ).

tff(addAssignment_33784,axiom,
    ! [VarCurr: state_type] :
      ( v5933(VarCurr)
    <=> v5935(VarCurr) ) ).

tff(addAssignment_33783,axiom,
    ! [VarCurr: state_type] :
      ( v5935(VarCurr)
    <=> v5937(VarCurr) ) ).

tff(addAssignment_33782,axiom,
    ! [VarCurr: state_type] :
      ( v5937(VarCurr)
    <=> v5939(VarCurr) ) ).

tff(writeUnaryOperator_3136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5939(VarCurr)
    <=> v56415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5347,axiom,
    ! [VarCurr: state_type] :
      ( v56415(VarCurr)
    <=> ( v5941(VarCurr)
        & v54672(VarCurr) ) ) ).

tff(addAssignment_33781,axiom,
    ! [VarCurr: state_type] :
      ( v54672(VarCurr)
    <=> v54674(VarCurr) ) ).

tff(addAssignment_33780,axiom,
    ! [VarCurr: state_type] :
      ( v54674(VarCurr)
    <=> v54676(VarCurr) ) ).

tff(addAssignment_33779,axiom,
    ! [VarCurr: state_type] :
      ( v54676(VarCurr)
    <=> v54678(VarCurr) ) ).

tff(addAssignment_33778,axiom,
    ! [VarCurr: state_type] :
      ( v54678(VarCurr)
    <=> v54680(VarCurr) ) ).

tff(writeUnaryOperator_3135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v54680(VarCurr)
    <=> v54682(VarCurr) ) ).

tff(addAssignment_33777,axiom,
    ! [VarCurr: state_type] :
      ( v54682(VarCurr)
    <=> v54684(VarCurr) ) ).

tff(addAssignment_33776,axiom,
    ! [VarCurr: state_type] :
      ( v54684(VarCurr)
    <=> v54686(VarCurr) ) ).

tff(addAssignment_33775,axiom,
    ! [VarCurr: state_type] :
      ( v54686(VarCurr)
    <=> v54688(VarCurr) ) ).

tff(addAssignment_33774,axiom,
    ! [VarCurr: state_type] :
      ( v54688(VarCurr)
    <=> v54690(VarCurr) ) ).

tff(writeUnaryOperator_3134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v54690(VarCurr)
    <=> v56412(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5346,axiom,
    ! [VarCurr: state_type] :
      ( v56412(VarCurr)
    <=> ( v54692(VarCurr)
        & v55780(VarCurr) ) ) ).

tff(addAssignment_33773,axiom,
    ! [VarCurr: state_type] :
      ( v55780(VarCurr)
    <=> v55782(VarCurr) ) ).

tff(addAssignment_33772,axiom,
    ! [VarCurr: state_type] :
      ( v55782(VarCurr)
    <=> v55784(VarCurr) ) ).

tff(addAssignment_33771,axiom,
    ! [VarCurr: state_type] :
      ( v55784(VarCurr)
    <=> v55786(VarCurr) ) ).

tff(addAssignment_33770,axiom,
    ! [VarCurr: state_type] :
      ( v55786(VarCurr)
    <=> v55788(VarCurr) ) ).

tff(writeUnaryOperator_3133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v55788(VarCurr)
    <=> v56410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5345,axiom,
    ! [VarCurr: state_type] :
      ( v56410(VarCurr)
    <=> ( v55790(VarCurr)
        | v56100(VarCurr) ) ) ).

tff(addAssignment_33769,axiom,
    ! [VarCurr: state_type] :
      ( v56100(VarCurr)
    <=> v56102(VarCurr) ) ).

tff(addAssignment_33768,axiom,
    ! [VarCurr: state_type] :
      ( v56102(VarCurr)
    <=> v54706(VarCurr,0) ) ).

tff(addAssignment_33767,axiom,
    ! [VarCurr: state_type] :
      ( v54706(VarCurr,0)
    <=> v5977(VarCurr,4) ) ).

tff(addAssignment_33766,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,4)
    <=> v5979(VarCurr,4) ) ).

tff(addAssignment_33765,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,4)
    <=> v5981(VarCurr,4) ) ).

tff(addAssignment_33764,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,4)
    <=> v5983(VarCurr,4) ) ).

tff(addAssignment_33763,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,4)
    <=> v5985(VarCurr,4) ) ).

tff(addAssignment_33762,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,4)
    <=> v53672(VarCurr,4) ) ).

tff(addAssignment_33761,axiom,
    ! [VarCurr: state_type] :
      ( v53674(VarCurr,0)
    <=> v56104(VarCurr) ) ).

tff(addAssignment_33760,axiom,
    ! [VarCurr: state_type] :
      ( v56104(VarCurr)
    <=> v56106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5344,axiom,
    ! [VarCurr: state_type] :
      ( v56106(VarCurr)
    <=> ( v56408(VarCurr)
      <~> v56396(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5343,axiom,
    ! [VarCurr: state_type] :
      ( v56408(VarCurr)
    <=> ( v56108(VarCurr)
      <~> v56264(VarCurr) ) ) ).

tff(addAssignment_33759,axiom,
    ! [VarCurr: state_type] :
      ( v56396(VarCurr)
    <=> v56398(VarCurr) ) ).

tff(addAssignment_33758,axiom,
    ! [VarCurr: state_type] :
      ( v56398(VarCurr)
    <=> v55427(VarCurr,0) ) ).

tff(addAssignment_33757,axiom,
    ! [VarCurr: state_type] :
      ( v55427(VarCurr,0)
    <=> v55429(VarCurr,0) ) ).

tff(addAssignment_33756,axiom,
    ! [VarCurr: state_type] :
      ( v55429(VarCurr,0)
    <=> v53454(VarCurr,5) ) ).

tff(addAssignment_33755,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,5)
    <=> v53456(VarCurr,5) ) ).

tff(addAssignment_33754,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,5)
    <=> v56400(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56401(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v56400(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_752,axiom,
    ! [VarNext: state_type] :
      ( v56401(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v56400(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56401(VarNext)
      <=> v56402(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56402(VarNext)
      <=> ( v56404(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56404(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_33753,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,5)
    <=> v53480(VarCurr,5) ) ).

tff(addAssignment_33752,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,5)
    <=> v53525(VarCurr,5) ) ).

tff(addAssignment_33751,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,4)
    <=> v55431(VarCurr,0) ) ).

tff(addAssignment_33750,axiom,
    ! [VarCurr: state_type] :
      ( v55431(VarCurr,0)
    <=> v55433(VarCurr,0) ) ).

tff(addAssignment_33749,axiom,
    ! [VarCurr: state_type] :
      ( v55433(VarCurr,0)
    <=> v55450(VarCurr,0) ) ).

tff(addAssignment_33748,axiom,
    ! [VarCurr: state_type] :
      ( v55443(VarCurr,0)
    <=> v55445(VarCurr,0) ) ).

tff(addAssignment_33747,axiom,
    ! [VarCurr: state_type] :
      ( v55445(VarCurr,0)
    <=> v53312(VarCurr,4) ) ).

tff(addAssignment_33746,axiom,
    ! [VarCurr: state_type] :
      ( v55435(VarCurr,0)
    <=> v55437(VarCurr,0) ) ).

tff(addAssignment_33745,axiom,
    ! [VarCurr: state_type] :
      ( v55437(VarCurr,0)
    <=> v53312(VarCurr,0) ) ).

tff(addAssignment_33744,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,0)
    <=> v53314(VarCurr,0) ) ).

tff(addAssignment_33743,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,0)
    <=> v53316(VarCurr,0) ) ).

tff(addAssignment_33742,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,0)
    <=> v53407(VarCurr,0) ) ).

tff(addAssignment_33741,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,0)
    <=> v53326(VarCurr,0) ) ).

tff(addAssignment_33740,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,0)
    <=> v53328(VarCurr,0) ) ).

tff(addAssignment_33739,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,0)
    <=> v6100(VarCurr,128) ) ).

tff(addAssignment_33738,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,128)
    <=> v6102(VarCurr,128) ) ).

tff(addAssignment_33737,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,128)
    <=> v53330(VarCurr,0) ) ).

tff(addAssignment_33736,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,0)
    <=> v53332(VarCurr,0) ) ).

tff(addAssignment_33735,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,0)
    <=> v53390(VarCurr,0) ) ).

tff(addAssignment_33734,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,0)
    <=> v53387(VarCurr,0) ) ).

tff(addAssignment_33733,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,0)
    <=> v53217(VarCurr,56) ) ).

tff(addAssignment_33732,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,0)
    <=> v53383(VarCurr,0) ) ).

tff(addAssignment_33731,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,0)
    <=> v53217(VarCurr,56) ) ).

tff(addAssignment_33730,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,56)
    <=> v53218(VarCurr,56) ) ).

tff(addAssignment_33729,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,110)
    <=> v6238(VarCurr,110) ) ).

tff(addAssignment_33728,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,110)
    <=> v6240(VarCurr,110) ) ).

tff(addAssignment_33727,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,110)
    <=> v44749(VarCurr,2) ) ).

tff(addAssignment_33726,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,0)
    <=> v53379(VarCurr,0) ) ).

tff(addAssignment_33725,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_33724,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,0)
    <=> v53320(VarCurr,0) ) ).

tff(addAssignment_33723,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,0)
    <=> v53321(VarCurr,0) ) ).

tff(addAssignment_33722,axiom,
    ! [VarCurr: state_type] :
      ( v56264(VarCurr)
    <=> v56266(VarCurr) ) ).

tff(addAssignment_33721,axiom,
    ! [VarCurr: state_type] :
      ( v56266(VarCurr)
    <=> v56268(VarCurr) ) ).

tff(addAssignment_33720,axiom,
    ! [VarCurr: state_type] :
      ( v56268(VarCurr)
    <=> v56270(VarCurr) ) ).

tff(addAssignment_33719,axiom,
    ! [VarCurr: state_type] :
      ( v56270(VarCurr)
    <=> v56272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5340,axiom,
    ! [VarCurr: state_type] :
      ( v56272(VarCurr)
    <=> ( v56394(VarCurr)
      <~> v56370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5339,axiom,
    ! [VarCurr: state_type] :
      ( v56394(VarCurr)
    <=> ( v56274(VarCurr)
      <~> v56322(VarCurr) ) ) ).

tff(addAssignment_33718,axiom,
    ! [VarCurr: state_type] :
      ( v56370(VarCurr)
    <=> v56372(VarCurr) ) ).

tff(addAssignment_33717,axiom,
    ! [VarCurr: state_type] :
      ( v56372(VarCurr)
    <=> v56374(VarCurr) ) ).

tff(addAssignment_33716,axiom,
    ! [VarCurr: state_type] :
      ( v56374(VarCurr)
    <=> v56376(VarCurr) ) ).

tff(addAssignment_33715,axiom,
    ! [VarCurr: state_type] :
      ( v56376(VarCurr)
    <=> v56378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5338,axiom,
    ! [VarCurr: state_type] :
      ( v56378(VarCurr)
    <=> ( v56392(VarCurr)
      <~> v56388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5337,axiom,
    ! [VarCurr: state_type] :
      ( v56392(VarCurr)
    <=> ( v56380(VarCurr)
      <~> v56384(VarCurr) ) ) ).

tff(addAssignment_33714,axiom,
    ! [VarCurr: state_type] :
      ( v56388(VarCurr)
    <=> v56390(VarCurr) ) ).

tff(addAssignment_33713,axiom,
    ! [VarCurr: state_type] :
      ( v56390(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_33712,axiom,
    ! [VarCurr: state_type] :
      ( v56384(VarCurr)
    <=> v56386(VarCurr) ) ).

tff(addAssignment_33711,axiom,
    ! [VarCurr: state_type] :
      ( v56386(VarCurr)
    <=> v6017(VarCurr,124) ) ).

tff(addAssignment_33710,axiom,
    ! [VarCurr: state_type] :
      ( v56380(VarCurr)
    <=> v56382(VarCurr) ) ).

tff(addAssignment_33709,axiom,
    ! [VarCurr: state_type] :
      ( v56382(VarCurr)
    <=> v6017(VarCurr,120) ) ).

tff(addAssignment_33708,axiom,
    ! [VarCurr: state_type] :
      ( v56322(VarCurr)
    <=> v56324(VarCurr) ) ).

tff(addAssignment_33707,axiom,
    ! [VarCurr: state_type] :
      ( v56324(VarCurr)
    <=> v56326(VarCurr) ) ).

tff(addAssignment_33706,axiom,
    ! [VarCurr: state_type] :
      ( v56326(VarCurr)
    <=> v56328(VarCurr) ) ).

tff(addAssignment_33705,axiom,
    ! [VarCurr: state_type] :
      ( v56328(VarCurr)
    <=> v56330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5336,axiom,
    ! [VarCurr: state_type] :
      ( v56330(VarCurr)
    <=> ( v56368(VarCurr)
      <~> v56356(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5335,axiom,
    ! [VarCurr: state_type] :
      ( v56368(VarCurr)
    <=> ( v56332(VarCurr)
      <~> v56344(VarCurr) ) ) ).

tff(addAssignment_33704,axiom,
    ! [VarCurr: state_type] :
      ( v56356(VarCurr)
    <=> v56358(VarCurr) ) ).

tff(addAssignment_33703,axiom,
    ! [VarCurr: state_type] :
      ( v56358(VarCurr)
    <=> v6017(VarCurr,116) ) ).

tff(addAssignment_33702,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,116)
    <=> v53103(VarCurr,52) ) ).

tff(addAssignment_33701,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,52)
    <=> v53105(VarCurr,52) ) ).

tff(addAssignment_33700,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,52)
    <=> v53107(VarCurr,52) ) ).

tff(addAssignment_33699,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,52)
    <=> v53109(VarCurr,52) ) ).

tff(addAssignment_33698,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,52)
    <=> v6027(VarCurr,116) ) ).

tff(addAssignment_33697,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,116)
    <=> v52434(VarCurr,116) ) ).

tff(addAssignment_33696,axiom,
    ! [VarCurr: state_type] :
      ( v52437(VarCurr,0)
    <=> v53112(VarCurr,52) ) ).

tff(addAssignment_33695,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,52)
    <=> v53114(VarCurr,52) ) ).

tff(addAssignment_33694,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,52)
    <=> v56360(VarNext,52) ) ).

tff(addCaseBooleanConditionEqualRanges1_751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56361(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56360(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_751,axiom,
    ! [VarNext: state_type] :
      ( v56361(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56360(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56361(VarNext)
      <=> v56362(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56362(VarNext)
      <=> ( v56364(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56364(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33693,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,52)
    <=> v53138(VarCurr,52) ) ).

tff(addAssignment_33692,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,52)
    <=> v6059(VarCurr,116) ) ).

tff(addAssignment_33691,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,116)
    <=> v55358(VarCurr,0) ) ).

tff(addAssignment_33690,axiom,
    ! [VarCurr: state_type] :
      ( v55358(VarCurr,0)
    <=> v55360(VarCurr,0) ) ).

tff(addAssignment_33689,axiom,
    ! [VarCurr: state_type] :
      ( v55360(VarCurr,0)
    <=> v55377(VarCurr,0) ) ).

tff(addAssignment_33688,axiom,
    ! [VarCurr: state_type] :
      ( v55370(VarCurr,0)
    <=> v55372(VarCurr,0) ) ).

tff(addAssignment_33687,axiom,
    ! [VarCurr: state_type] :
      ( v55372(VarCurr,0)
    <=> v6069(VarCurr,116) ) ).

tff(addAssignment_33686,axiom,
    ! [VarCurr: state_type] :
      ( v55362(VarCurr,0)
    <=> v55364(VarCurr,0) ) ).

tff(addAssignment_33685,axiom,
    ! [VarCurr: state_type] :
      ( v55364(VarCurr,0)
    <=> v6069(VarCurr,120) ) ).

tff(addAssignment_33684,axiom,
    ! [VarCurr: state_type] :
      ( v56344(VarCurr)
    <=> v56346(VarCurr) ) ).

tff(addAssignment_33683,axiom,
    ! [VarCurr: state_type] :
      ( v56346(VarCurr)
    <=> v6017(VarCurr,112) ) ).

tff(addAssignment_33682,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,112)
    <=> v53103(VarCurr,48) ) ).

tff(addAssignment_33681,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,48)
    <=> v53105(VarCurr,48) ) ).

tff(addAssignment_33680,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,48)
    <=> v53107(VarCurr,48) ) ).

tff(addAssignment_33679,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,48)
    <=> v53109(VarCurr,48) ) ).

tff(addAssignment_33678,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,48)
    <=> v6027(VarCurr,112) ) ).

tff(addAssignment_33677,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,112)
    <=> v52434(VarCurr,112) ) ).

tff(addAssignment_33676,axiom,
    ! [VarCurr: state_type] :
      ( v52438(VarCurr,0)
    <=> v53112(VarCurr,48) ) ).

tff(addAssignment_33675,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,48)
    <=> v53114(VarCurr,48) ) ).

tff(addAssignment_33674,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,48)
    <=> v56348(VarNext,48) ) ).

tff(addCaseBooleanConditionEqualRanges1_750,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56349(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56348(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_750,axiom,
    ! [VarNext: state_type] :
      ( v56349(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56348(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56349(VarNext)
      <=> v56350(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56350(VarNext)
      <=> ( v56352(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56352(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33673,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,48)
    <=> v53138(VarCurr,48) ) ).

tff(addAssignment_33672,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,48)
    <=> v6059(VarCurr,112) ) ).

tff(addAssignment_33671,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,112)
    <=> v55318(VarCurr,0) ) ).

tff(addAssignment_33670,axiom,
    ! [VarCurr: state_type] :
      ( v55318(VarCurr,0)
    <=> v55320(VarCurr,0) ) ).

tff(addAssignment_33669,axiom,
    ! [VarCurr: state_type] :
      ( v55320(VarCurr,0)
    <=> v55337(VarCurr,0) ) ).

tff(addAssignment_33668,axiom,
    ! [VarCurr: state_type] :
      ( v55330(VarCurr,0)
    <=> v55332(VarCurr,0) ) ).

tff(addAssignment_33667,axiom,
    ! [VarCurr: state_type] :
      ( v55332(VarCurr,0)
    <=> v6069(VarCurr,112) ) ).

tff(addAssignment_33666,axiom,
    ! [VarCurr: state_type] :
      ( v55322(VarCurr,0)
    <=> v55324(VarCurr,0) ) ).

tff(addAssignment_33665,axiom,
    ! [VarCurr: state_type] :
      ( v55324(VarCurr,0)
    <=> v6069(VarCurr,116) ) ).

tff(addAssignment_33664,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,116)
    <=> v53148(VarCurr,52) ) ).

tff(addAssignment_33663,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,52)
    <=> v53150(VarCurr,52) ) ).

tff(addAssignment_33662,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,52)
    <=> v53242(VarCurr,52) ) ).

tff(addAssignment_33661,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,52)
    <=> v53160(VarCurr,52) ) ).

tff(addAssignment_33660,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,52)
    <=> v6098(VarCurr,116) ) ).

tff(addAssignment_33659,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,116)
    <=> v6100(VarCurr,116) ) ).

tff(addAssignment_33658,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,116)
    <=> v6102(VarCurr,116) ) ).

tff(addAssignment_33657,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,116)
    <=> v53162(VarCurr,52) ) ).

tff(addAssignment_33656,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,52)
    <=> v53164(VarCurr,52) ) ).

tff(addAssignment_33655,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,52)
    <=> v53225(VarCurr,52) ) ).

tff(addAssignment_33654,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,52)
    <=> v53223(VarCurr,52) ) ).

tff(addAssignment_33653,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,52)
    <=> v53224(VarCurr,52) ) ).

tff(addAssignment_33652,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,52)
    <=> v53215(VarCurr,52) ) ).

tff(addAssignment_33651,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,52)
    <=> v53219(VarCurr,52) ) ).

tff(addAssignment_33650,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,44)
    <=> v53218(VarCurr,44) ) ).

tff(addAssignment_33649,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,86)
    <=> v6238(VarCurr,86) ) ).

tff(addAssignment_33648,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,86)
    <=> v6240(VarCurr,86) ) ).

tff(addAssignment_33647,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,86)
    <=> v41649(VarCurr,2) ) ).

tff(addAssignment_33646,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,52)
    <=> v53211(VarCurr,52) ) ).

tff(addAssignment_33645,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,52)
    <=> $false ) ).

tff(addAssignment_33644,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,52)
    <=> v53154(VarCurr,52) ) ).

tff(addAssignment_33643,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,52)
    <=> v53155(VarCurr,52) ) ).

tff(addAssignment_33642,axiom,
    ! [VarCurr: state_type] :
      ( v56332(VarCurr)
    <=> v56334(VarCurr) ) ).

tff(addAssignment_33641,axiom,
    ! [VarCurr: state_type] :
      ( v56334(VarCurr)
    <=> v6017(VarCurr,108) ) ).

tff(addAssignment_33640,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,108)
    <=> v53103(VarCurr,44) ) ).

tff(addAssignment_33639,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,44)
    <=> v53105(VarCurr,44) ) ).

tff(addAssignment_33638,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,44)
    <=> v53107(VarCurr,44) ) ).

tff(addAssignment_33637,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,44)
    <=> v53109(VarCurr,44) ) ).

tff(addAssignment_33636,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,44)
    <=> v6027(VarCurr,108) ) ).

tff(addAssignment_33635,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,108)
    <=> v52434(VarCurr,108) ) ).

tff(addAssignment_33634,axiom,
    ! [VarCurr: state_type] :
      ( v52439(VarCurr,0)
    <=> v53112(VarCurr,44) ) ).

tff(addAssignment_33633,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,44)
    <=> v53114(VarCurr,44) ) ).

tff(addAssignment_33632,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,44)
    <=> v56336(VarNext,44) ) ).

tff(addCaseBooleanConditionEqualRanges1_749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56337(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56336(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_749,axiom,
    ! [VarNext: state_type] :
      ( v56337(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56336(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56337(VarNext)
      <=> v56338(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56338(VarNext)
      <=> ( v56340(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56340(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33631,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,44)
    <=> v53138(VarCurr,44) ) ).

tff(addAssignment_33630,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,44)
    <=> v6059(VarCurr,108) ) ).

tff(addAssignment_33629,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,108)
    <=> v55278(VarCurr,0) ) ).

tff(addAssignment_33628,axiom,
    ! [VarCurr: state_type] :
      ( v55278(VarCurr,0)
    <=> v55280(VarCurr,0) ) ).

tff(addAssignment_33627,axiom,
    ! [VarCurr: state_type] :
      ( v55280(VarCurr,0)
    <=> v55297(VarCurr,0) ) ).

tff(addAssignment_33626,axiom,
    ! [VarCurr: state_type] :
      ( v55290(VarCurr,0)
    <=> v55292(VarCurr,0) ) ).

tff(addAssignment_33625,axiom,
    ! [VarCurr: state_type] :
      ( v55292(VarCurr,0)
    <=> v6069(VarCurr,108) ) ).

tff(addAssignment_33624,axiom,
    ! [VarCurr: state_type] :
      ( v55282(VarCurr,0)
    <=> v55284(VarCurr,0) ) ).

tff(addAssignment_33623,axiom,
    ! [VarCurr: state_type] :
      ( v55284(VarCurr,0)
    <=> v6069(VarCurr,112) ) ).

tff(addAssignment_33622,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,112)
    <=> v53148(VarCurr,48) ) ).

tff(addAssignment_33621,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,48)
    <=> v53150(VarCurr,48) ) ).

tff(addAssignment_33620,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,48)
    <=> v53242(VarCurr,48) ) ).

tff(addAssignment_33619,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,48)
    <=> v53160(VarCurr,48) ) ).

tff(addAssignment_33618,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,48)
    <=> v6098(VarCurr,112) ) ).

tff(addAssignment_33617,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,112)
    <=> v6100(VarCurr,112) ) ).

tff(addAssignment_33616,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,112)
    <=> v6102(VarCurr,112) ) ).

tff(addAssignment_33615,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,112)
    <=> v53162(VarCurr,48) ) ).

tff(addAssignment_33614,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,48)
    <=> v53164(VarCurr,48) ) ).

tff(addAssignment_33613,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,48)
    <=> v53225(VarCurr,48) ) ).

tff(addAssignment_33612,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,48)
    <=> v53223(VarCurr,48) ) ).

tff(addAssignment_33611,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,48)
    <=> v53224(VarCurr,48) ) ).

tff(addAssignment_33610,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,48)
    <=> v53215(VarCurr,48) ) ).

tff(addAssignment_33609,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,48)
    <=> v53219(VarCurr,48) ) ).

tff(addAssignment_33608,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,40)
    <=> v53218(VarCurr,40) ) ).

tff(addAssignment_33607,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,76)
    <=> v6238(VarCurr,76) ) ).

tff(addAssignment_33606,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,76)
    <=> v6240(VarCurr,76) ) ).

tff(addAssignment_33605,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,76)
    <=> v40099(VarCurr,4) ) ).

tff(addAssignment_33604,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,48)
    <=> v53211(VarCurr,48) ) ).

tff(addAssignment_33603,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,48)
    <=> $false ) ).

tff(addAssignment_33602,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,48)
    <=> v53154(VarCurr,48) ) ).

tff(addAssignment_33601,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,48)
    <=> v53155(VarCurr,48) ) ).

tff(addAssignment_33600,axiom,
    ! [VarCurr: state_type] :
      ( v56274(VarCurr)
    <=> v56276(VarCurr) ) ).

tff(addAssignment_33599,axiom,
    ! [VarCurr: state_type] :
      ( v56276(VarCurr)
    <=> v56278(VarCurr) ) ).

tff(addAssignment_33598,axiom,
    ! [VarCurr: state_type] :
      ( v56278(VarCurr)
    <=> v56280(VarCurr) ) ).

tff(addAssignment_33597,axiom,
    ! [VarCurr: state_type] :
      ( v56280(VarCurr)
    <=> v56282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5328,axiom,
    ! [VarCurr: state_type] :
      ( v56282(VarCurr)
    <=> ( v56320(VarCurr)
      <~> v56308(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5327,axiom,
    ! [VarCurr: state_type] :
      ( v56320(VarCurr)
    <=> ( v56284(VarCurr)
      <~> v56296(VarCurr) ) ) ).

tff(addAssignment_33596,axiom,
    ! [VarCurr: state_type] :
      ( v56308(VarCurr)
    <=> v56310(VarCurr) ) ).

tff(addAssignment_33595,axiom,
    ! [VarCurr: state_type] :
      ( v56310(VarCurr)
    <=> v6017(VarCurr,104) ) ).

tff(addAssignment_33594,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,104)
    <=> v53103(VarCurr,40) ) ).

tff(addAssignment_33593,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,40)
    <=> v53105(VarCurr,40) ) ).

tff(addAssignment_33592,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,40)
    <=> v53107(VarCurr,40) ) ).

tff(addAssignment_33591,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,40)
    <=> v53109(VarCurr,40) ) ).

tff(addAssignment_33590,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,40)
    <=> v6027(VarCurr,104) ) ).

tff(addAssignment_33589,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,104)
    <=> v52434(VarCurr,104) ) ).

tff(addAssignment_33588,axiom,
    ! [VarCurr: state_type] :
      ( v52440(VarCurr,0)
    <=> v53112(VarCurr,40) ) ).

tff(addAssignment_33587,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,40)
    <=> v53114(VarCurr,40) ) ).

tff(addAssignment_33586,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,40)
    <=> v56312(VarNext,40) ) ).

tff(addCaseBooleanConditionEqualRanges1_748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56313(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56312(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_748,axiom,
    ! [VarNext: state_type] :
      ( v56313(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56312(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56313(VarNext)
      <=> v56314(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56314(VarNext)
      <=> ( v56316(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56316(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33585,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,40)
    <=> v53138(VarCurr,40) ) ).

tff(addAssignment_33584,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,40)
    <=> v6059(VarCurr,104) ) ).

tff(addAssignment_33583,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,104)
    <=> v55226(VarCurr,0) ) ).

tff(addAssignment_33582,axiom,
    ! [VarCurr: state_type] :
      ( v55226(VarCurr,0)
    <=> v55228(VarCurr,0) ) ).

tff(addAssignment_33581,axiom,
    ! [VarCurr: state_type] :
      ( v55228(VarCurr,0)
    <=> v55245(VarCurr,0) ) ).

tff(addAssignment_33580,axiom,
    ! [VarCurr: state_type] :
      ( v55238(VarCurr,0)
    <=> v55240(VarCurr,0) ) ).

tff(addAssignment_33579,axiom,
    ! [VarCurr: state_type] :
      ( v55240(VarCurr,0)
    <=> v6069(VarCurr,104) ) ).

tff(addAssignment_33578,axiom,
    ! [VarCurr: state_type] :
      ( v55230(VarCurr,0)
    <=> v55232(VarCurr,0) ) ).

tff(addAssignment_33577,axiom,
    ! [VarCurr: state_type] :
      ( v55232(VarCurr,0)
    <=> v6069(VarCurr,108) ) ).

tff(addAssignment_33576,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,108)
    <=> v53148(VarCurr,44) ) ).

tff(addAssignment_33575,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,44)
    <=> v53150(VarCurr,44) ) ).

tff(addAssignment_33574,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,44)
    <=> v53242(VarCurr,44) ) ).

tff(addAssignment_33573,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,44)
    <=> v53160(VarCurr,44) ) ).

tff(addAssignment_33572,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,44)
    <=> v6098(VarCurr,108) ) ).

tff(addAssignment_33571,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,108)
    <=> v6100(VarCurr,108) ) ).

tff(addAssignment_33570,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,108)
    <=> v6102(VarCurr,108) ) ).

tff(addAssignment_33569,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,108)
    <=> v53162(VarCurr,44) ) ).

tff(addAssignment_33568,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,44)
    <=> v53164(VarCurr,44) ) ).

tff(addAssignment_33567,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,44)
    <=> v53225(VarCurr,44) ) ).

tff(addAssignment_33566,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,44)
    <=> v53223(VarCurr,44) ) ).

tff(addAssignment_33565,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,44)
    <=> v53224(VarCurr,44) ) ).

tff(addAssignment_33564,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,44)
    <=> v53215(VarCurr,44) ) ).

tff(addAssignment_33563,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,44)
    <=> v53219(VarCurr,44) ) ).

tff(addAssignment_33562,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,36)
    <=> v53218(VarCurr,36) ) ).

tff(addAssignment_33561,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,72)
    <=> v6238(VarCurr,72) ) ).

tff(addAssignment_33560,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,72)
    <=> v6240(VarCurr,72) ) ).

tff(addAssignment_33559,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,72)
    <=> v40099(VarCurr,0) ) ).

tff(addAssignment_33558,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,44)
    <=> v53211(VarCurr,44) ) ).

tff(addAssignment_33557,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,44)
    <=> $false ) ).

tff(addAssignment_33556,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,44)
    <=> v53154(VarCurr,44) ) ).

tff(addAssignment_33555,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,44)
    <=> v53155(VarCurr,44) ) ).

tff(addAssignment_33554,axiom,
    ! [VarCurr: state_type] :
      ( v56296(VarCurr)
    <=> v56298(VarCurr) ) ).

tff(addAssignment_33553,axiom,
    ! [VarCurr: state_type] :
      ( v56298(VarCurr)
    <=> v6017(VarCurr,100) ) ).

tff(addAssignment_33552,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,100)
    <=> v53103(VarCurr,36) ) ).

tff(addAssignment_33551,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,36)
    <=> v53105(VarCurr,36) ) ).

tff(addAssignment_33550,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,36)
    <=> v53107(VarCurr,36) ) ).

tff(addAssignment_33549,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,36)
    <=> v53109(VarCurr,36) ) ).

tff(addAssignment_33548,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,36)
    <=> v6027(VarCurr,100) ) ).

tff(addAssignment_33547,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,100)
    <=> v52434(VarCurr,100) ) ).

tff(addAssignment_33546,axiom,
    ! [VarCurr: state_type] :
      ( v52441(VarCurr,0)
    <=> v53112(VarCurr,36) ) ).

tff(addAssignment_33545,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,36)
    <=> v53114(VarCurr,36) ) ).

tff(addAssignment_33544,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,36)
    <=> v56300(VarNext,36) ) ).

tff(addCaseBooleanConditionEqualRanges1_747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56301(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56300(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_747,axiom,
    ! [VarNext: state_type] :
      ( v56301(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56300(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56301(VarNext)
      <=> v56302(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56302(VarNext)
      <=> ( v56304(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56304(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33543,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,36)
    <=> v53138(VarCurr,36) ) ).

tff(addAssignment_33542,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,36)
    <=> v6059(VarCurr,100) ) ).

tff(addAssignment_33541,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,100)
    <=> v55186(VarCurr,0) ) ).

tff(addAssignment_33540,axiom,
    ! [VarCurr: state_type] :
      ( v55186(VarCurr,0)
    <=> v55188(VarCurr,0) ) ).

tff(addAssignment_33539,axiom,
    ! [VarCurr: state_type] :
      ( v55188(VarCurr,0)
    <=> v55205(VarCurr,0) ) ).

tff(addAssignment_33538,axiom,
    ! [VarCurr: state_type] :
      ( v55198(VarCurr,0)
    <=> v55200(VarCurr,0) ) ).

tff(addAssignment_33537,axiom,
    ! [VarCurr: state_type] :
      ( v55200(VarCurr,0)
    <=> v6069(VarCurr,100) ) ).

tff(addAssignment_33536,axiom,
    ! [VarCurr: state_type] :
      ( v55190(VarCurr,0)
    <=> v55192(VarCurr,0) ) ).

tff(addAssignment_33535,axiom,
    ! [VarCurr: state_type] :
      ( v55192(VarCurr,0)
    <=> v6069(VarCurr,104) ) ).

tff(addAssignment_33534,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,104)
    <=> v53148(VarCurr,40) ) ).

tff(addAssignment_33533,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,40)
    <=> v53150(VarCurr,40) ) ).

tff(addAssignment_33532,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,40)
    <=> v53242(VarCurr,40) ) ).

tff(addAssignment_33531,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,40)
    <=> v53160(VarCurr,40) ) ).

tff(addAssignment_33530,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,40)
    <=> v6098(VarCurr,104) ) ).

tff(addAssignment_33529,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,104)
    <=> v6100(VarCurr,104) ) ).

tff(addAssignment_33528,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,104)
    <=> v6102(VarCurr,104) ) ).

tff(addAssignment_33527,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,104)
    <=> v53162(VarCurr,40) ) ).

tff(addAssignment_33526,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,40)
    <=> v53164(VarCurr,40) ) ).

tff(addAssignment_33525,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,40)
    <=> v53225(VarCurr,40) ) ).

tff(addAssignment_33524,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,40)
    <=> v53223(VarCurr,40) ) ).

tff(addAssignment_33523,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,40)
    <=> v53224(VarCurr,40) ) ).

tff(addAssignment_33522,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,40)
    <=> v53215(VarCurr,40) ) ).

tff(addAssignment_33521,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,40)
    <=> v53219(VarCurr,40) ) ).

tff(addAssignment_33520,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,32)
    <=> v53218(VarCurr,32) ) ).

tff(addAssignment_33519,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,62)
    <=> v6238(VarCurr,62) ) ).

tff(addAssignment_33518,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,62)
    <=> v6240(VarCurr,62) ) ).

tff(addAssignment_33517,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,62)
    <=> v38549(VarCurr,2) ) ).

tff(addAssignment_33516,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,40)
    <=> v53211(VarCurr,40) ) ).

tff(addAssignment_33515,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,40)
    <=> $false ) ).

tff(addAssignment_33514,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,40)
    <=> v53154(VarCurr,40) ) ).

tff(addAssignment_33513,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,40)
    <=> v53155(VarCurr,40) ) ).

tff(addAssignment_33512,axiom,
    ! [VarCurr: state_type] :
      ( v56284(VarCurr)
    <=> v56286(VarCurr) ) ).

tff(addAssignment_33511,axiom,
    ! [VarCurr: state_type] :
      ( v56286(VarCurr)
    <=> v6017(VarCurr,96) ) ).

tff(addAssignment_33510,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,96)
    <=> v53103(VarCurr,32) ) ).

tff(addAssignment_33509,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,32)
    <=> v53105(VarCurr,32) ) ).

tff(addAssignment_33508,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,32)
    <=> v53107(VarCurr,32) ) ).

tff(addAssignment_33507,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,32)
    <=> v53109(VarCurr,32) ) ).

tff(addAssignment_33506,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,32)
    <=> v6027(VarCurr,96) ) ).

tff(addAssignment_33505,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,96)
    <=> v52434(VarCurr,96) ) ).

tff(addAssignment_33504,axiom,
    ! [VarCurr: state_type] :
      ( v52442(VarCurr,0)
    <=> v53112(VarCurr,32) ) ).

tff(addAssignment_33503,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,32)
    <=> v53114(VarCurr,32) ) ).

tff(addAssignment_33502,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,32)
    <=> v56288(VarNext,32) ) ).

tff(addCaseBooleanConditionEqualRanges1_746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56289(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56288(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_746,axiom,
    ! [VarNext: state_type] :
      ( v56289(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56288(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56289(VarNext)
      <=> v56290(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56290(VarNext)
      <=> ( v56292(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56292(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33501,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,32)
    <=> v53138(VarCurr,32) ) ).

tff(addAssignment_33500,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,32)
    <=> v6059(VarCurr,96) ) ).

tff(addAssignment_33499,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,96)
    <=> v55146(VarCurr,0) ) ).

tff(addAssignment_33498,axiom,
    ! [VarCurr: state_type] :
      ( v55146(VarCurr,0)
    <=> v55148(VarCurr,0) ) ).

tff(addAssignment_33497,axiom,
    ! [VarCurr: state_type] :
      ( v55148(VarCurr,0)
    <=> v55165(VarCurr,0) ) ).

tff(addAssignment_33496,axiom,
    ! [VarCurr: state_type] :
      ( v55158(VarCurr,0)
    <=> v55160(VarCurr,0) ) ).

tff(addAssignment_33495,axiom,
    ! [VarCurr: state_type] :
      ( v55160(VarCurr,0)
    <=> v6069(VarCurr,96) ) ).

tff(addAssignment_33494,axiom,
    ! [VarCurr: state_type] :
      ( v55150(VarCurr,0)
    <=> v55152(VarCurr,0) ) ).

tff(addAssignment_33493,axiom,
    ! [VarCurr: state_type] :
      ( v55152(VarCurr,0)
    <=> v6069(VarCurr,100) ) ).

tff(addAssignment_33492,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,100)
    <=> v53148(VarCurr,36) ) ).

tff(addAssignment_33491,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,36)
    <=> v53150(VarCurr,36) ) ).

tff(addAssignment_33490,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,36)
    <=> v53242(VarCurr,36) ) ).

tff(addAssignment_33489,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,36)
    <=> v53160(VarCurr,36) ) ).

tff(addAssignment_33488,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,36)
    <=> v6098(VarCurr,100) ) ).

tff(addAssignment_33487,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,100)
    <=> v6100(VarCurr,100) ) ).

tff(addAssignment_33486,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,100)
    <=> v6102(VarCurr,100) ) ).

tff(addAssignment_33485,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,100)
    <=> v53162(VarCurr,36) ) ).

tff(addAssignment_33484,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,36)
    <=> v53164(VarCurr,36) ) ).

tff(addAssignment_33483,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,36)
    <=> v53225(VarCurr,36) ) ).

tff(addAssignment_33482,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,36)
    <=> v53223(VarCurr,36) ) ).

tff(addAssignment_33481,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,36)
    <=> v53224(VarCurr,36) ) ).

tff(addAssignment_33480,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,36)
    <=> v53215(VarCurr,36) ) ).

tff(addAssignment_33479,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,36)
    <=> v53219(VarCurr,36) ) ).

tff(addAssignment_33478,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,28)
    <=> v53218(VarCurr,28) ) ).

tff(addAssignment_33477,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,52)
    <=> v6238(VarCurr,52) ) ).

tff(addAssignment_33476,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,52)
    <=> v6240(VarCurr,52) ) ).

tff(addAssignment_33475,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,52)
    <=> v36999(VarCurr,4) ) ).

tff(addAssignment_33474,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,36)
    <=> v53211(VarCurr,36) ) ).

tff(addAssignment_33473,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,36)
    <=> $false ) ).

tff(addAssignment_33472,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,36)
    <=> v53154(VarCurr,36) ) ).

tff(addAssignment_33471,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,36)
    <=> v53155(VarCurr,36) ) ).

tff(addAssignment_33470,axiom,
    ! [VarCurr: state_type] :
      ( v56108(VarCurr)
    <=> v56110(VarCurr) ) ).

tff(addAssignment_33469,axiom,
    ! [VarCurr: state_type] :
      ( v56110(VarCurr)
    <=> v56112(VarCurr) ) ).

tff(addAssignment_33468,axiom,
    ! [VarCurr: state_type] :
      ( v56112(VarCurr)
    <=> v56114(VarCurr) ) ).

tff(addAssignment_33467,axiom,
    ! [VarCurr: state_type] :
      ( v56114(VarCurr)
    <=> v56116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5320,axiom,
    ! [VarCurr: state_type] :
      ( v56116(VarCurr)
    <=> ( v56262(VarCurr)
      <~> v56214(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5319,axiom,
    ! [VarCurr: state_type] :
      ( v56262(VarCurr)
    <=> ( v56118(VarCurr)
      <~> v56166(VarCurr) ) ) ).

tff(addAssignment_33466,axiom,
    ! [VarCurr: state_type] :
      ( v56214(VarCurr)
    <=> v56216(VarCurr) ) ).

tff(addAssignment_33465,axiom,
    ! [VarCurr: state_type] :
      ( v56216(VarCurr)
    <=> v56218(VarCurr) ) ).

tff(addAssignment_33464,axiom,
    ! [VarCurr: state_type] :
      ( v56218(VarCurr)
    <=> v56220(VarCurr) ) ).

tff(addAssignment_33463,axiom,
    ! [VarCurr: state_type] :
      ( v56220(VarCurr)
    <=> v56222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5318,axiom,
    ! [VarCurr: state_type] :
      ( v56222(VarCurr)
    <=> ( v56260(VarCurr)
      <~> v56248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5317,axiom,
    ! [VarCurr: state_type] :
      ( v56260(VarCurr)
    <=> ( v56224(VarCurr)
      <~> v56236(VarCurr) ) ) ).

tff(addAssignment_33462,axiom,
    ! [VarCurr: state_type] :
      ( v56248(VarCurr)
    <=> v56250(VarCurr) ) ).

tff(addAssignment_33461,axiom,
    ! [VarCurr: state_type] :
      ( v56250(VarCurr)
    <=> v6017(VarCurr,92) ) ).

tff(addAssignment_33460,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,92)
    <=> v53103(VarCurr,28) ) ).

tff(addAssignment_33459,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,28)
    <=> v53105(VarCurr,28) ) ).

tff(addAssignment_33458,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,28)
    <=> v53107(VarCurr,28) ) ).

tff(addAssignment_33457,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,28)
    <=> v53109(VarCurr,28) ) ).

tff(addAssignment_33456,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,28)
    <=> v6027(VarCurr,92) ) ).

tff(addAssignment_33455,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,92)
    <=> v52434(VarCurr,92) ) ).

tff(addAssignment_33454,axiom,
    ! [VarCurr: state_type] :
      ( v52443(VarCurr,0)
    <=> v53112(VarCurr,28) ) ).

tff(addAssignment_33453,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,28)
    <=> v53114(VarCurr,28) ) ).

tff(addAssignment_33452,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,28)
    <=> v56252(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56253(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56252(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_745,axiom,
    ! [VarNext: state_type] :
      ( v56253(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56252(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56253(VarNext)
      <=> v56254(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56254(VarNext)
      <=> ( v56256(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56256(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33451,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,28)
    <=> v53138(VarCurr,28) ) ).

tff(addAssignment_33450,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,28)
    <=> v6059(VarCurr,92) ) ).

tff(addAssignment_33449,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,92)
    <=> v55082(VarCurr,0) ) ).

tff(addAssignment_33448,axiom,
    ! [VarCurr: state_type] :
      ( v55082(VarCurr,0)
    <=> v55084(VarCurr,0) ) ).

tff(addAssignment_33447,axiom,
    ! [VarCurr: state_type] :
      ( v55084(VarCurr,0)
    <=> v55101(VarCurr,0) ) ).

tff(addAssignment_33446,axiom,
    ! [VarCurr: state_type] :
      ( v55094(VarCurr,0)
    <=> v55096(VarCurr,0) ) ).

tff(addAssignment_33445,axiom,
    ! [VarCurr: state_type] :
      ( v55096(VarCurr,0)
    <=> v6069(VarCurr,92) ) ).

tff(addAssignment_33444,axiom,
    ! [VarCurr: state_type] :
      ( v55086(VarCurr,0)
    <=> v55088(VarCurr,0) ) ).

tff(addAssignment_33443,axiom,
    ! [VarCurr: state_type] :
      ( v55088(VarCurr,0)
    <=> v6069(VarCurr,96) ) ).

tff(addAssignment_33442,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,96)
    <=> v53148(VarCurr,32) ) ).

tff(addAssignment_33441,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,32)
    <=> v53150(VarCurr,32) ) ).

tff(addAssignment_33440,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,32)
    <=> v53242(VarCurr,32) ) ).

tff(addAssignment_33439,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,32)
    <=> v53160(VarCurr,32) ) ).

tff(addAssignment_33438,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,32)
    <=> v6098(VarCurr,96) ) ).

tff(addAssignment_33437,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,96)
    <=> v6100(VarCurr,96) ) ).

tff(addAssignment_33436,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,96)
    <=> v6102(VarCurr,96) ) ).

tff(addAssignment_33435,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,96)
    <=> v53162(VarCurr,32) ) ).

tff(addAssignment_33434,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,32)
    <=> v53164(VarCurr,32) ) ).

tff(addAssignment_33433,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,32)
    <=> v53225(VarCurr,32) ) ).

tff(addAssignment_33432,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,32)
    <=> v53223(VarCurr,32) ) ).

tff(addAssignment_33431,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,32)
    <=> v53224(VarCurr,32) ) ).

tff(addAssignment_33430,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,32)
    <=> v53215(VarCurr,32) ) ).

tff(addAssignment_33429,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,32)
    <=> v53219(VarCurr,32) ) ).

tff(addAssignment_33428,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,24)
    <=> v53218(VarCurr,24) ) ).

tff(addAssignment_33427,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,48)
    <=> v6238(VarCurr,48) ) ).

tff(addAssignment_33426,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,48)
    <=> v6240(VarCurr,48) ) ).

tff(addAssignment_33425,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,48)
    <=> v36999(VarCurr,0) ) ).

tff(addAssignment_33424,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,32)
    <=> v53211(VarCurr,32) ) ).

tff(addAssignment_33423,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,32)
    <=> $false ) ).

tff(addAssignment_33422,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,32)
    <=> v53154(VarCurr,32) ) ).

tff(addAssignment_33421,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,32)
    <=> v53155(VarCurr,32) ) ).

tff(addAssignment_33420,axiom,
    ! [VarCurr: state_type] :
      ( v56236(VarCurr)
    <=> v56238(VarCurr) ) ).

tff(addAssignment_33419,axiom,
    ! [VarCurr: state_type] :
      ( v56238(VarCurr)
    <=> v6017(VarCurr,88) ) ).

tff(addAssignment_33418,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,88)
    <=> v53103(VarCurr,24) ) ).

tff(addAssignment_33417,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,24)
    <=> v53105(VarCurr,24) ) ).

tff(addAssignment_33416,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,24)
    <=> v53107(VarCurr,24) ) ).

tff(addAssignment_33415,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,24)
    <=> v53109(VarCurr,24) ) ).

tff(addAssignment_33414,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,24)
    <=> v6027(VarCurr,88) ) ).

tff(addAssignment_33413,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,88)
    <=> v52434(VarCurr,88) ) ).

tff(addAssignment_33412,axiom,
    ! [VarCurr: state_type] :
      ( v52444(VarCurr,0)
    <=> v53112(VarCurr,24) ) ).

tff(addAssignment_33411,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,24)
    <=> v53114(VarCurr,24) ) ).

tff(addAssignment_33410,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,24)
    <=> v56240(VarNext,24) ) ).

tff(addCaseBooleanConditionEqualRanges1_744,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56241(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56240(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_744,axiom,
    ! [VarNext: state_type] :
      ( v56241(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56240(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56241(VarNext)
      <=> v56242(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56242(VarNext)
      <=> ( v56244(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56244(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33409,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,24)
    <=> v53138(VarCurr,24) ) ).

tff(addAssignment_33408,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,24)
    <=> v6059(VarCurr,88) ) ).

tff(addAssignment_33407,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,88)
    <=> v55042(VarCurr,0) ) ).

tff(addAssignment_33406,axiom,
    ! [VarCurr: state_type] :
      ( v55042(VarCurr,0)
    <=> v55044(VarCurr,0) ) ).

tff(addAssignment_33405,axiom,
    ! [VarCurr: state_type] :
      ( v55044(VarCurr,0)
    <=> v55061(VarCurr,0) ) ).

tff(addAssignment_33404,axiom,
    ! [VarCurr: state_type] :
      ( v55054(VarCurr,0)
    <=> v55056(VarCurr,0) ) ).

tff(addAssignment_33403,axiom,
    ! [VarCurr: state_type] :
      ( v55056(VarCurr,0)
    <=> v6069(VarCurr,88) ) ).

tff(addAssignment_33402,axiom,
    ! [VarCurr: state_type] :
      ( v55046(VarCurr,0)
    <=> v55048(VarCurr,0) ) ).

tff(addAssignment_33401,axiom,
    ! [VarCurr: state_type] :
      ( v55048(VarCurr,0)
    <=> v6069(VarCurr,92) ) ).

tff(addAssignment_33400,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,92)
    <=> v53148(VarCurr,28) ) ).

tff(addAssignment_33399,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,28)
    <=> v53150(VarCurr,28) ) ).

tff(addAssignment_33398,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,28)
    <=> v53242(VarCurr,28) ) ).

tff(addAssignment_33397,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,28)
    <=> v53160(VarCurr,28) ) ).

tff(addAssignment_33396,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,28)
    <=> v6098(VarCurr,92) ) ).

tff(addAssignment_33395,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,92)
    <=> v6100(VarCurr,92) ) ).

tff(addAssignment_33394,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,92)
    <=> v6102(VarCurr,92) ) ).

tff(addAssignment_33393,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,92)
    <=> v53162(VarCurr,28) ) ).

tff(addAssignment_33392,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,28)
    <=> v53164(VarCurr,28) ) ).

tff(addAssignment_33391,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,28)
    <=> v53225(VarCurr,28) ) ).

tff(addAssignment_33390,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,28)
    <=> v53223(VarCurr,28) ) ).

tff(addAssignment_33389,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,28)
    <=> v53224(VarCurr,28) ) ).

tff(addAssignment_33388,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,28)
    <=> v53215(VarCurr,28) ) ).

tff(addAssignment_33387,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,28)
    <=> v53219(VarCurr,28) ) ).

tff(addAssignment_33386,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,20)
    <=> v53218(VarCurr,20) ) ).

tff(addAssignment_33385,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,38)
    <=> v6238(VarCurr,38) ) ).

tff(addAssignment_33384,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,38)
    <=> v6240(VarCurr,38) ) ).

tff(addAssignment_33383,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,38)
    <=> v35449(VarCurr,2) ) ).

tff(addAssignment_33382,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,28)
    <=> v53211(VarCurr,28) ) ).

tff(addAssignment_33381,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,28)
    <=> $false ) ).

tff(addAssignment_33380,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,28)
    <=> v53154(VarCurr,28) ) ).

tff(addAssignment_33379,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,28)
    <=> v53155(VarCurr,28) ) ).

tff(addAssignment_33378,axiom,
    ! [VarCurr: state_type] :
      ( v56224(VarCurr)
    <=> v56226(VarCurr) ) ).

tff(addAssignment_33377,axiom,
    ! [VarCurr: state_type] :
      ( v56226(VarCurr)
    <=> v6017(VarCurr,84) ) ).

tff(addAssignment_33376,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,84)
    <=> v53103(VarCurr,20) ) ).

tff(addAssignment_33375,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,20)
    <=> v53105(VarCurr,20) ) ).

tff(addAssignment_33374,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,20)
    <=> v53107(VarCurr,20) ) ).

tff(addAssignment_33373,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,20)
    <=> v53109(VarCurr,20) ) ).

tff(addAssignment_33372,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,20)
    <=> v6027(VarCurr,84) ) ).

tff(addAssignment_33371,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,84)
    <=> v52434(VarCurr,84) ) ).

tff(addAssignment_33370,axiom,
    ! [VarCurr: state_type] :
      ( v52445(VarCurr,0)
    <=> v53112(VarCurr,20) ) ).

tff(addAssignment_33369,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,20)
    <=> v53114(VarCurr,20) ) ).

tff(addAssignment_33368,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,20)
    <=> v56228(VarNext,20) ) ).

tff(addCaseBooleanConditionEqualRanges1_743,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56229(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56228(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_743,axiom,
    ! [VarNext: state_type] :
      ( v56229(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56228(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56229(VarNext)
      <=> v56230(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56230(VarNext)
      <=> ( v56232(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56232(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33367,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,20)
    <=> v53138(VarCurr,20) ) ).

tff(addAssignment_33366,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,20)
    <=> v6059(VarCurr,84) ) ).

tff(addAssignment_33365,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,84)
    <=> v55002(VarCurr,0) ) ).

tff(addAssignment_33364,axiom,
    ! [VarCurr: state_type] :
      ( v55002(VarCurr,0)
    <=> v55004(VarCurr,0) ) ).

tff(addAssignment_33363,axiom,
    ! [VarCurr: state_type] :
      ( v55004(VarCurr,0)
    <=> v55021(VarCurr,0) ) ).

tff(addAssignment_33362,axiom,
    ! [VarCurr: state_type] :
      ( v55014(VarCurr,0)
    <=> v55016(VarCurr,0) ) ).

tff(addAssignment_33361,axiom,
    ! [VarCurr: state_type] :
      ( v55016(VarCurr,0)
    <=> v6069(VarCurr,84) ) ).

tff(addAssignment_33360,axiom,
    ! [VarCurr: state_type] :
      ( v55006(VarCurr,0)
    <=> v55008(VarCurr,0) ) ).

tff(addAssignment_33359,axiom,
    ! [VarCurr: state_type] :
      ( v55008(VarCurr,0)
    <=> v6069(VarCurr,88) ) ).

tff(addAssignment_33358,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,88)
    <=> v53148(VarCurr,24) ) ).

tff(addAssignment_33357,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,24)
    <=> v53150(VarCurr,24) ) ).

tff(addAssignment_33356,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,24)
    <=> v53242(VarCurr,24) ) ).

tff(addAssignment_33355,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,24)
    <=> v53160(VarCurr,24) ) ).

tff(addAssignment_33354,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,24)
    <=> v6098(VarCurr,88) ) ).

tff(addAssignment_33353,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,88)
    <=> v6100(VarCurr,88) ) ).

tff(addAssignment_33352,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,88)
    <=> v6102(VarCurr,88) ) ).

tff(addAssignment_33351,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,88)
    <=> v53162(VarCurr,24) ) ).

tff(addAssignment_33350,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,24)
    <=> v53164(VarCurr,24) ) ).

tff(addAssignment_33349,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,24)
    <=> v53225(VarCurr,24) ) ).

tff(addAssignment_33348,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,24)
    <=> v53223(VarCurr,24) ) ).

tff(addAssignment_33347,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,24)
    <=> v53224(VarCurr,24) ) ).

tff(addAssignment_33346,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,24)
    <=> v53215(VarCurr,24) ) ).

tff(addAssignment_33345,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,24)
    <=> v53219(VarCurr,24) ) ).

tff(addAssignment_33344,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,16)
    <=> v53218(VarCurr,16) ) ).

tff(addAssignment_33343,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,28)
    <=> v6238(VarCurr,28) ) ).

tff(addAssignment_33342,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,24)
    <=> v53211(VarCurr,24) ) ).

tff(addAssignment_33341,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,24)
    <=> $false ) ).

tff(addAssignment_33340,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,24)
    <=> v53154(VarCurr,24) ) ).

tff(addAssignment_33339,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,24)
    <=> v53155(VarCurr,24) ) ).

tff(addAssignment_33338,axiom,
    ! [VarCurr: state_type] :
      ( v56166(VarCurr)
    <=> v56168(VarCurr) ) ).

tff(addAssignment_33337,axiom,
    ! [VarCurr: state_type] :
      ( v56168(VarCurr)
    <=> v56170(VarCurr) ) ).

tff(addAssignment_33336,axiom,
    ! [VarCurr: state_type] :
      ( v56170(VarCurr)
    <=> v56172(VarCurr) ) ).

tff(addAssignment_33335,axiom,
    ! [VarCurr: state_type] :
      ( v56172(VarCurr)
    <=> v56174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5310,axiom,
    ! [VarCurr: state_type] :
      ( v56174(VarCurr)
    <=> ( v56212(VarCurr)
      <~> v56200(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5309,axiom,
    ! [VarCurr: state_type] :
      ( v56212(VarCurr)
    <=> ( v56176(VarCurr)
      <~> v56188(VarCurr) ) ) ).

tff(addAssignment_33334,axiom,
    ! [VarCurr: state_type] :
      ( v56200(VarCurr)
    <=> v56202(VarCurr) ) ).

tff(addAssignment_33333,axiom,
    ! [VarCurr: state_type] :
      ( v56202(VarCurr)
    <=> v6017(VarCurr,80) ) ).

tff(addAssignment_33332,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,80)
    <=> v53103(VarCurr,16) ) ).

tff(addAssignment_33331,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,16)
    <=> v53105(VarCurr,16) ) ).

tff(addAssignment_33330,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,16)
    <=> v53107(VarCurr,16) ) ).

tff(addAssignment_33329,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,16)
    <=> v53109(VarCurr,16) ) ).

tff(addAssignment_33328,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,16)
    <=> v6027(VarCurr,80) ) ).

tff(addAssignment_33327,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,80)
    <=> v52434(VarCurr,80) ) ).

tff(addAssignment_33326,axiom,
    ! [VarCurr: state_type] :
      ( v52446(VarCurr,0)
    <=> v53112(VarCurr,16) ) ).

tff(addAssignment_33325,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,16)
    <=> v53114(VarCurr,16) ) ).

tff(addAssignment_33324,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,16)
    <=> v56204(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56205(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56204(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_742,axiom,
    ! [VarNext: state_type] :
      ( v56205(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56204(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56205(VarNext)
      <=> v56206(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56206(VarNext)
      <=> ( v56208(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56208(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33323,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,16)
    <=> v53138(VarCurr,16) ) ).

tff(addAssignment_33322,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,16)
    <=> v6059(VarCurr,80) ) ).

tff(addAssignment_33321,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,80)
    <=> v54950(VarCurr,0) ) ).

tff(addAssignment_33320,axiom,
    ! [VarCurr: state_type] :
      ( v54950(VarCurr,0)
    <=> v54952(VarCurr,0) ) ).

tff(addAssignment_33319,axiom,
    ! [VarCurr: state_type] :
      ( v54952(VarCurr,0)
    <=> v54969(VarCurr,0) ) ).

tff(addAssignment_33318,axiom,
    ! [VarCurr: state_type] :
      ( v54962(VarCurr,0)
    <=> v54964(VarCurr,0) ) ).

tff(addAssignment_33317,axiom,
    ! [VarCurr: state_type] :
      ( v54964(VarCurr,0)
    <=> v6069(VarCurr,80) ) ).

tff(addAssignment_33316,axiom,
    ! [VarCurr: state_type] :
      ( v54954(VarCurr,0)
    <=> v54956(VarCurr,0) ) ).

tff(addAssignment_33315,axiom,
    ! [VarCurr: state_type] :
      ( v54956(VarCurr,0)
    <=> v6069(VarCurr,84) ) ).

tff(addAssignment_33314,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,84)
    <=> v53148(VarCurr,20) ) ).

tff(addAssignment_33313,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,20)
    <=> v53150(VarCurr,20) ) ).

tff(addAssignment_33312,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,20)
    <=> v53242(VarCurr,20) ) ).

tff(addAssignment_33311,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,20)
    <=> v53160(VarCurr,20) ) ).

tff(addAssignment_33310,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,20)
    <=> v6098(VarCurr,84) ) ).

tff(addAssignment_33309,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,84)
    <=> v6100(VarCurr,84) ) ).

tff(addAssignment_33308,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,84)
    <=> v6102(VarCurr,84) ) ).

tff(addAssignment_33307,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,84)
    <=> v53162(VarCurr,20) ) ).

tff(addAssignment_33306,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,20)
    <=> v53164(VarCurr,20) ) ).

tff(addAssignment_33305,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,20)
    <=> v53225(VarCurr,20) ) ).

tff(addAssignment_33304,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,20)
    <=> v53223(VarCurr,20) ) ).

tff(addAssignment_33303,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,20)
    <=> v53224(VarCurr,20) ) ).

tff(addAssignment_33302,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,20)
    <=> v53215(VarCurr,20) ) ).

tff(addAssignment_33301,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,20)
    <=> v53219(VarCurr,20) ) ).

tff(addAssignment_33300,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,12)
    <=> v53218(VarCurr,12) ) ).

tff(addAssignment_33299,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,24)
    <=> v6238(VarCurr,24) ) ).

tff(addAssignment_33298,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,20)
    <=> v53211(VarCurr,20) ) ).

tff(addAssignment_33297,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,20)
    <=> $false ) ).

tff(addAssignment_33296,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,20)
    <=> v53154(VarCurr,20) ) ).

tff(addAssignment_33295,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,20)
    <=> v53155(VarCurr,20) ) ).

tff(addAssignment_33294,axiom,
    ! [VarCurr: state_type] :
      ( v56188(VarCurr)
    <=> v56190(VarCurr) ) ).

tff(addAssignment_33293,axiom,
    ! [VarCurr: state_type] :
      ( v56190(VarCurr)
    <=> v6017(VarCurr,76) ) ).

tff(addAssignment_33292,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,76)
    <=> v53103(VarCurr,12) ) ).

tff(addAssignment_33291,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,12)
    <=> v53105(VarCurr,12) ) ).

tff(addAssignment_33290,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,12)
    <=> v53107(VarCurr,12) ) ).

tff(addAssignment_33289,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,12)
    <=> v53109(VarCurr,12) ) ).

tff(addAssignment_33288,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,12)
    <=> v6027(VarCurr,76) ) ).

tff(addAssignment_33287,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,76)
    <=> v52434(VarCurr,76) ) ).

tff(addAssignment_33286,axiom,
    ! [VarCurr: state_type] :
      ( v52447(VarCurr,0)
    <=> v53112(VarCurr,12) ) ).

tff(addAssignment_33285,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,12)
    <=> v53114(VarCurr,12) ) ).

tff(addAssignment_33284,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,12)
    <=> v56192(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56193(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56192(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_741,axiom,
    ! [VarNext: state_type] :
      ( v56193(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56192(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56193(VarNext)
      <=> v56194(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56194(VarNext)
      <=> ( v56196(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56196(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33283,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,12)
    <=> v53138(VarCurr,12) ) ).

tff(addAssignment_33282,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,12)
    <=> v6059(VarCurr,76) ) ).

tff(addAssignment_33281,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,76)
    <=> v54910(VarCurr,0) ) ).

tff(addAssignment_33280,axiom,
    ! [VarCurr: state_type] :
      ( v54910(VarCurr,0)
    <=> v54912(VarCurr,0) ) ).

tff(addAssignment_33279,axiom,
    ! [VarCurr: state_type] :
      ( v54912(VarCurr,0)
    <=> v54929(VarCurr,0) ) ).

tff(addAssignment_33278,axiom,
    ! [VarCurr: state_type] :
      ( v54922(VarCurr,0)
    <=> v54924(VarCurr,0) ) ).

tff(addAssignment_33277,axiom,
    ! [VarCurr: state_type] :
      ( v54924(VarCurr,0)
    <=> v6069(VarCurr,76) ) ).

tff(addAssignment_33276,axiom,
    ! [VarCurr: state_type] :
      ( v54914(VarCurr,0)
    <=> v54916(VarCurr,0) ) ).

tff(addAssignment_33275,axiom,
    ! [VarCurr: state_type] :
      ( v54916(VarCurr,0)
    <=> v6069(VarCurr,80) ) ).

tff(addAssignment_33274,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,80)
    <=> v53148(VarCurr,16) ) ).

tff(addAssignment_33273,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,16)
    <=> v53150(VarCurr,16) ) ).

tff(addAssignment_33272,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,16)
    <=> v53242(VarCurr,16) ) ).

tff(addAssignment_33271,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,16)
    <=> v53160(VarCurr,16) ) ).

tff(addAssignment_33270,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,16)
    <=> v6098(VarCurr,80) ) ).

tff(addAssignment_33269,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,80)
    <=> v6100(VarCurr,80) ) ).

tff(addAssignment_33268,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,80)
    <=> v6102(VarCurr,80) ) ).

tff(addAssignment_33267,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,80)
    <=> v53162(VarCurr,16) ) ).

tff(addAssignment_33266,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,16)
    <=> v53164(VarCurr,16) ) ).

tff(addAssignment_33265,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,16)
    <=> v53225(VarCurr,16) ) ).

tff(addAssignment_33264,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,16)
    <=> v53223(VarCurr,16) ) ).

tff(addAssignment_33263,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,16)
    <=> v53224(VarCurr,16) ) ).

tff(addAssignment_33262,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,16)
    <=> v53215(VarCurr,16) ) ).

tff(addAssignment_33261,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,16)
    <=> v53219(VarCurr,16) ) ).

tff(addAssignment_33260,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,8)
    <=> v53218(VarCurr,8) ) ).

tff(addAssignment_33259,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,14)
    <=> v6238(VarCurr,14) ) ).

tff(addAssignment_33258,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,16)
    <=> v53211(VarCurr,16) ) ).

tff(addAssignment_33257,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,16)
    <=> $false ) ).

tff(addAssignment_33256,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,16)
    <=> v53154(VarCurr,16) ) ).

tff(addAssignment_33255,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,16)
    <=> v53155(VarCurr,16) ) ).

tff(addAssignment_33254,axiom,
    ! [VarCurr: state_type] :
      ( v56176(VarCurr)
    <=> v56178(VarCurr) ) ).

tff(addAssignment_33253,axiom,
    ! [VarCurr: state_type] :
      ( v56178(VarCurr)
    <=> v6017(VarCurr,72) ) ).

tff(addAssignment_33252,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,72)
    <=> v53103(VarCurr,8) ) ).

tff(addAssignment_33251,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,8)
    <=> v53105(VarCurr,8) ) ).

tff(addAssignment_33250,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,8)
    <=> v53107(VarCurr,8) ) ).

tff(addAssignment_33249,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,8)
    <=> v53109(VarCurr,8) ) ).

tff(addAssignment_33248,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,8)
    <=> v6027(VarCurr,72) ) ).

tff(addAssignment_33247,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,72)
    <=> v52434(VarCurr,72) ) ).

tff(addAssignment_33246,axiom,
    ! [VarCurr: state_type] :
      ( v52448(VarCurr,0)
    <=> v53112(VarCurr,8) ) ).

tff(addAssignment_33245,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,8)
    <=> v53114(VarCurr,8) ) ).

tff(addAssignment_33244,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,8)
    <=> v56180(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56181(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56180(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_740,axiom,
    ! [VarNext: state_type] :
      ( v56181(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56180(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56181(VarNext)
      <=> v56182(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56182(VarNext)
      <=> ( v56184(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56184(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33243,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,8)
    <=> v53138(VarCurr,8) ) ).

tff(addAssignment_33242,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,8)
    <=> v6059(VarCurr,72) ) ).

tff(addAssignment_33241,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,72)
    <=> v54870(VarCurr,0) ) ).

tff(addAssignment_33240,axiom,
    ! [VarCurr: state_type] :
      ( v54870(VarCurr,0)
    <=> v54872(VarCurr,0) ) ).

tff(addAssignment_33239,axiom,
    ! [VarCurr: state_type] :
      ( v54872(VarCurr,0)
    <=> v54889(VarCurr,0) ) ).

tff(addAssignment_33238,axiom,
    ! [VarCurr: state_type] :
      ( v54882(VarCurr,0)
    <=> v54884(VarCurr,0) ) ).

tff(addAssignment_33237,axiom,
    ! [VarCurr: state_type] :
      ( v54884(VarCurr,0)
    <=> v6069(VarCurr,72) ) ).

tff(addAssignment_33236,axiom,
    ! [VarCurr: state_type] :
      ( v54874(VarCurr,0)
    <=> v54876(VarCurr,0) ) ).

tff(addAssignment_33235,axiom,
    ! [VarCurr: state_type] :
      ( v54876(VarCurr,0)
    <=> v6069(VarCurr,76) ) ).

tff(addAssignment_33234,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,76)
    <=> v53148(VarCurr,12) ) ).

tff(addAssignment_33233,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,12)
    <=> v53150(VarCurr,12) ) ).

tff(addAssignment_33232,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,12)
    <=> v53242(VarCurr,12) ) ).

tff(addAssignment_33231,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,12)
    <=> v53160(VarCurr,12) ) ).

tff(addAssignment_33230,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,12)
    <=> v6098(VarCurr,76) ) ).

tff(addAssignment_33229,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,76)
    <=> v6100(VarCurr,76) ) ).

tff(addAssignment_33228,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,76)
    <=> v6102(VarCurr,76) ) ).

tff(addAssignment_33227,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,76)
    <=> v53162(VarCurr,12) ) ).

tff(addAssignment_33226,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,12)
    <=> v53164(VarCurr,12) ) ).

tff(addAssignment_33225,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,12)
    <=> v53225(VarCurr,12) ) ).

tff(addAssignment_33224,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,12)
    <=> v53223(VarCurr,12) ) ).

tff(addAssignment_33223,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,12)
    <=> v53224(VarCurr,12) ) ).

tff(addAssignment_33222,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,12)
    <=> v53215(VarCurr,12) ) ).

tff(addAssignment_33221,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,12)
    <=> v53219(VarCurr,12) ) ).

tff(addAssignment_33220,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,4)
    <=> v53218(VarCurr,4) ) ).

tff(addAssignment_33219,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,4)
    <=> v6238(VarCurr,4) ) ).

tff(addAssignment_33218,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,12)
    <=> v53211(VarCurr,12) ) ).

tff(addAssignment_33217,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_33216,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,12)
    <=> v53154(VarCurr,12) ) ).

tff(addAssignment_33215,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,12)
    <=> v53155(VarCurr,12) ) ).

tff(addAssignment_33214,axiom,
    ! [VarCurr: state_type] :
      ( v56118(VarCurr)
    <=> v56120(VarCurr) ) ).

tff(addAssignment_33213,axiom,
    ! [VarCurr: state_type] :
      ( v56120(VarCurr)
    <=> v56122(VarCurr) ) ).

tff(addAssignment_33212,axiom,
    ! [VarCurr: state_type] :
      ( v56122(VarCurr)
    <=> v56124(VarCurr) ) ).

tff(addAssignment_33211,axiom,
    ! [VarCurr: state_type] :
      ( v56124(VarCurr)
    <=> v56126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5302,axiom,
    ! [VarCurr: state_type] :
      ( v56126(VarCurr)
    <=> ( v56164(VarCurr)
      <~> v56152(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5301,axiom,
    ! [VarCurr: state_type] :
      ( v56164(VarCurr)
    <=> ( v56128(VarCurr)
      <~> v56140(VarCurr) ) ) ).

tff(addAssignment_33210,axiom,
    ! [VarCurr: state_type] :
      ( v56152(VarCurr)
    <=> v56154(VarCurr) ) ).

tff(addAssignment_33209,axiom,
    ! [VarCurr: state_type] :
      ( v56154(VarCurr)
    <=> v6017(VarCurr,68) ) ).

tff(addAssignment_33208,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,68)
    <=> v53103(VarCurr,4) ) ).

tff(addAssignment_33207,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,4)
    <=> v53105(VarCurr,4) ) ).

tff(addAssignment_33206,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,4)
    <=> v53107(VarCurr,4) ) ).

tff(addAssignment_33205,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,4)
    <=> v53109(VarCurr,4) ) ).

tff(addAssignment_33204,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,4)
    <=> v6027(VarCurr,68) ) ).

tff(addAssignment_33203,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,68)
    <=> v52434(VarCurr,68) ) ).

tff(addAssignment_33202,axiom,
    ! [VarCurr: state_type] :
      ( v52449(VarCurr,0)
    <=> v53112(VarCurr,4) ) ).

tff(addAssignment_33201,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,4)
    <=> v53114(VarCurr,4) ) ).

tff(addAssignment_33200,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,4)
    <=> v56156(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56157(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56156(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_739,axiom,
    ! [VarNext: state_type] :
      ( v56157(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56156(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56157(VarNext)
      <=> v56158(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56158(VarNext)
      <=> ( v56160(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56160(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33199,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,4)
    <=> v53138(VarCurr,4) ) ).

tff(addAssignment_33198,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,4)
    <=> v6059(VarCurr,68) ) ).

tff(addAssignment_33197,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,68)
    <=> v54818(VarCurr,0) ) ).

tff(addAssignment_33196,axiom,
    ! [VarCurr: state_type] :
      ( v54818(VarCurr,0)
    <=> v54820(VarCurr,0) ) ).

tff(addAssignment_33195,axiom,
    ! [VarCurr: state_type] :
      ( v54820(VarCurr,0)
    <=> v54837(VarCurr,0) ) ).

tff(addAssignment_33194,axiom,
    ! [VarCurr: state_type] :
      ( v54830(VarCurr,0)
    <=> v54832(VarCurr,0) ) ).

tff(addAssignment_33193,axiom,
    ! [VarCurr: state_type] :
      ( v54832(VarCurr,0)
    <=> v6069(VarCurr,68) ) ).

tff(addAssignment_33192,axiom,
    ! [VarCurr: state_type] :
      ( v54822(VarCurr,0)
    <=> v54824(VarCurr,0) ) ).

tff(addAssignment_33191,axiom,
    ! [VarCurr: state_type] :
      ( v54824(VarCurr,0)
    <=> v6069(VarCurr,72) ) ).

tff(addAssignment_33190,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,72)
    <=> v53148(VarCurr,8) ) ).

tff(addAssignment_33189,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,8)
    <=> v53150(VarCurr,8) ) ).

tff(addAssignment_33188,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,8)
    <=> v53242(VarCurr,8) ) ).

tff(addAssignment_33187,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,8)
    <=> v53160(VarCurr,8) ) ).

tff(addAssignment_33186,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,8)
    <=> v6098(VarCurr,72) ) ).

tff(addAssignment_33185,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,72)
    <=> v6100(VarCurr,72) ) ).

tff(addAssignment_33184,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,72)
    <=> v6102(VarCurr,72) ) ).

tff(addAssignment_33183,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,72)
    <=> v53162(VarCurr,8) ) ).

tff(addAssignment_33182,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,8)
    <=> v53164(VarCurr,8) ) ).

tff(addAssignment_33181,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,8)
    <=> v53225(VarCurr,8) ) ).

tff(addAssignment_33180,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,8)
    <=> v53223(VarCurr,8) ) ).

tff(addAssignment_33179,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,8)
    <=> v53224(VarCurr,8) ) ).

tff(addAssignment_33178,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,8)
    <=> v53215(VarCurr,8) ) ).

tff(addAssignment_33177,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,8)
    <=> v53219(VarCurr,8) ) ).

tff(addAssignment_33176,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,0)
    <=> v53218(VarCurr,0) ) ).

tff(addAssignment_33175,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,0)
    <=> v6238(VarCurr,0) ) ).

tff(addAssignment_33174,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,8)
    <=> v53211(VarCurr,8) ) ).

tff(addAssignment_33173,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_33172,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,8)
    <=> v53154(VarCurr,8) ) ).

tff(addAssignment_33171,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,8)
    <=> v53155(VarCurr,8) ) ).

tff(addAssignment_33170,axiom,
    ! [VarCurr: state_type] :
      ( v56140(VarCurr)
    <=> v56142(VarCurr) ) ).

tff(addAssignment_33169,axiom,
    ! [VarCurr: state_type] :
      ( v56142(VarCurr)
    <=> v6017(VarCurr,64) ) ).

tff(addAssignment_33168,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,64)
    <=> v53103(VarCurr,0) ) ).

tff(addAssignment_33167,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,0)
    <=> v53105(VarCurr,0) ) ).

tff(addAssignment_33166,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,0)
    <=> v53107(VarCurr,0) ) ).

tff(addAssignment_33165,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,0)
    <=> v53109(VarCurr,0) ) ).

tff(addAssignment_33164,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,0)
    <=> v6027(VarCurr,64) ) ).

tff(addAssignment_33163,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,64)
    <=> v52434(VarCurr,64) ) ).

tff(addAssignment_33162,axiom,
    ! [VarCurr: state_type] :
      ( v52450(VarCurr,0)
    <=> v53112(VarCurr,0) ) ).

tff(addAssignment_33161,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,0)
    <=> v53114(VarCurr,0) ) ).

tff(addAssignment_33160,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,0)
    <=> v56144(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56145(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56144(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_738,axiom,
    ! [VarNext: state_type] :
      ( v56145(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56144(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56145(VarNext)
      <=> v56146(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56146(VarNext)
      <=> ( v56148(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56148(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33159,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,0)
    <=> v53138(VarCurr,0) ) ).

tff(addAssignment_33158,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,0)
    <=> v6059(VarCurr,64) ) ).

tff(addAssignment_33157,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,64)
    <=> v54778(VarCurr,0) ) ).

tff(addAssignment_33156,axiom,
    ! [VarCurr: state_type] :
      ( v54778(VarCurr,0)
    <=> v54780(VarCurr,0) ) ).

tff(addAssignment_33155,axiom,
    ! [VarCurr: state_type] :
      ( v54780(VarCurr,0)
    <=> v54797(VarCurr,0) ) ).

tff(addAssignment_33154,axiom,
    ! [VarCurr: state_type] :
      ( v54790(VarCurr,0)
    <=> v54792(VarCurr,0) ) ).

tff(addAssignment_33153,axiom,
    ! [VarCurr: state_type] :
      ( v54792(VarCurr,0)
    <=> v6069(VarCurr,64) ) ).

tff(addAssignment_33152,axiom,
    ! [VarCurr: state_type] :
      ( v54782(VarCurr,0)
    <=> v54784(VarCurr,0) ) ).

tff(addAssignment_33151,axiom,
    ! [VarCurr: state_type] :
      ( v54784(VarCurr,0)
    <=> v6069(VarCurr,68) ) ).

tff(addAssignment_33150,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,68)
    <=> v53148(VarCurr,4) ) ).

tff(addAssignment_33149,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,4)
    <=> v53150(VarCurr,4) ) ).

tff(addAssignment_33148,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,4)
    <=> v53242(VarCurr,4) ) ).

tff(addAssignment_33147,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,4)
    <=> v53160(VarCurr,4) ) ).

tff(addAssignment_33146,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,4)
    <=> v6098(VarCurr,68) ) ).

tff(addAssignment_33145,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,68)
    <=> v6100(VarCurr,68) ) ).

tff(addAssignment_33144,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,68)
    <=> v6102(VarCurr,68) ) ).

tff(addAssignment_33143,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,68)
    <=> v53162(VarCurr,4) ) ).

tff(addAssignment_33142,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,4)
    <=> v53164(VarCurr,4) ) ).

tff(addAssignment_33141,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,4)
    <=> v53225(VarCurr,4) ) ).

tff(addAssignment_33140,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,4)
    <=> v53223(VarCurr,4) ) ).

tff(addAssignment_33139,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,4)
    <=> v53224(VarCurr,4) ) ).

tff(addAssignment_33138,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,68)
    <=> v52335(VarCurr,68) ) ).

tff(addAssignment_33137,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,134)
    <=> v33839(VarCurr,134) ) ).

tff(addAssignment_33136,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,134)
    <=> v33841(VarCurr,134) ) ).

tff(addAssignment_33135,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,134)
    <=> v26555(VarCurr,2) ) ).

tff(addAssignment_33134,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,4)
    <=> v53215(VarCurr,4) ) ).

tff(addAssignment_33133,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,4)
    <=> v53219(VarCurr,4) ) ).

tff(addAssignment_33132,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,68)
    <=> v52325(VarCurr,68) ) ).

tff(addAssignment_33131,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,140)
    <=> v6238(VarCurr,140) ) ).

tff(addAssignment_33130,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,140)
    <=> v6240(VarCurr,140) ) ).

tff(addAssignment_33129,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,140)
    <=> v47849(VarCurr,8) ) ).

tff(addAssignment_33128,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,4)
    <=> v53211(VarCurr,4) ) ).

tff(addAssignment_33127,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_33126,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,4)
    <=> v53154(VarCurr,4) ) ).

tff(addAssignment_33125,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,4)
    <=> v53155(VarCurr,4) ) ).

tff(addAssignment_33124,axiom,
    ! [VarCurr: state_type] :
      ( v56128(VarCurr)
    <=> v56130(VarCurr) ) ).

tff(addAssignment_33123,axiom,
    ! [VarCurr: state_type] :
      ( v56130(VarCurr)
    <=> v6017(VarCurr,60) ) ).

tff(addAssignment_33122,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,60)
    <=> v6019(VarCurr,60) ) ).

tff(addAssignment_33121,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,60)
    <=> v6021(VarCurr,60) ) ).

tff(addAssignment_33120,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,60)
    <=> v6023(VarCurr,60) ) ).

tff(addAssignment_33119,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,60)
    <=> v6025(VarCurr,60) ) ).

tff(addAssignment_33118,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,60)
    <=> v6027(VarCurr,60) ) ).

tff(addAssignment_33117,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,60)
    <=> v52434(VarCurr,60) ) ).

tff(addAssignment_33116,axiom,
    ! [VarCurr: state_type] :
      ( v52451(VarCurr,0)
    <=> v6031(VarCurr,60) ) ).

tff(addAssignment_33115,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,60)
    <=> v6033(VarCurr,60) ) ).

tff(addAssignment_33114,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,60)
    <=> v56132(VarNext,60) ) ).

tff(addCaseBooleanConditionEqualRanges1_737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56133(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56132(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_737,axiom,
    ! [VarNext: state_type] :
      ( v56133(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56132(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56133(VarNext)
      <=> v56134(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56134(VarNext)
      <=> ( v56136(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56136(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_33113,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,60)
    <=> v6057(VarCurr,60) ) ).

tff(addAssignment_33112,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,60)
    <=> v6059(VarCurr,60) ) ).

tff(addAssignment_33111,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,60)
    <=> v54738(VarCurr,0) ) ).

tff(addAssignment_33110,axiom,
    ! [VarCurr: state_type] :
      ( v54738(VarCurr,0)
    <=> v54740(VarCurr,0) ) ).

tff(addAssignment_33109,axiom,
    ! [VarCurr: state_type] :
      ( v54740(VarCurr,0)
    <=> v54757(VarCurr,0) ) ).

tff(addAssignment_33108,axiom,
    ! [VarCurr: state_type] :
      ( v54750(VarCurr,0)
    <=> v54752(VarCurr,0) ) ).

tff(addAssignment_33107,axiom,
    ! [VarCurr: state_type] :
      ( v54752(VarCurr,0)
    <=> v6069(VarCurr,60) ) ).

tff(addAssignment_33106,axiom,
    ! [VarCurr: state_type] :
      ( v54742(VarCurr,0)
    <=> v54744(VarCurr,0) ) ).

tff(addAssignment_33105,axiom,
    ! [VarCurr: state_type] :
      ( v54744(VarCurr,0)
    <=> v6069(VarCurr,64) ) ).

tff(addAssignment_33104,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,64)
    <=> v53148(VarCurr,0) ) ).

tff(addAssignment_33103,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,0)
    <=> v53150(VarCurr,0) ) ).

tff(addAssignment_33102,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,0)
    <=> v53242(VarCurr,0) ) ).

tff(addAssignment_33101,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,0)
    <=> v53160(VarCurr,0) ) ).

tff(addAssignment_33100,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,0)
    <=> v6098(VarCurr,64) ) ).

tff(addAssignment_33099,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,64)
    <=> v6100(VarCurr,64) ) ).

tff(addAssignment_33098,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,64)
    <=> v6102(VarCurr,64) ) ).

tff(addAssignment_33097,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,64)
    <=> v53162(VarCurr,0) ) ).

tff(addAssignment_33096,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,0)
    <=> v53164(VarCurr,0) ) ).

tff(addAssignment_33095,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,0)
    <=> v53225(VarCurr,0) ) ).

tff(addAssignment_33094,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,0)
    <=> v53223(VarCurr,0) ) ).

tff(addAssignment_33093,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,0)
    <=> v53224(VarCurr,0) ) ).

tff(addAssignment_33092,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,64)
    <=> v52335(VarCurr,64) ) ).

tff(addAssignment_33091,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,124)
    <=> v33839(VarCurr,124) ) ).

tff(addAssignment_33090,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,124)
    <=> v33841(VarCurr,124) ) ).

tff(addAssignment_33089,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,124)
    <=> v25005(VarCurr,4) ) ).

tff(addAssignment_33088,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,0)
    <=> v53215(VarCurr,0) ) ).

tff(addAssignment_33087,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,0)
    <=> v53219(VarCurr,0) ) ).

tff(addAssignment_33086,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,64)
    <=> v52325(VarCurr,64) ) ).

tff(addAssignment_33085,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,130)
    <=> v6238(VarCurr,130) ) ).

tff(addAssignment_33084,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,130)
    <=> v6240(VarCurr,130) ) ).

tff(addAssignment_33083,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,130)
    <=> v46299(VarCurr,10) ) ).

tff(addAssignment_33082,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,0)
    <=> v53211(VarCurr,0) ) ).

tff(addAssignment_33081,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_33080,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,0)
    <=> v53154(VarCurr,0) ) ).

tff(addAssignment_33079,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,0)
    <=> v53155(VarCurr,0) ) ).

tff(addAssignment_33078,axiom,
    ! [VarCurr: state_type] :
      ( v55790(VarCurr)
    <=> v55792(VarCurr) ) ).

tff(addAssignment_33077,axiom,
    ! [VarCurr: state_type] :
      ( v55792(VarCurr)
    <=> v54706(VarCurr,1) ) ).

tff(addAssignment_33076,axiom,
    ! [VarCurr: state_type] :
      ( v54706(VarCurr,1)
    <=> v5977(VarCurr,5) ) ).

tff(addAssignment_33075,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,5)
    <=> v5979(VarCurr,5) ) ).

tff(addAssignment_33074,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,5)
    <=> v5981(VarCurr,5) ) ).

tff(addAssignment_33073,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,5)
    <=> v5983(VarCurr,5) ) ).

tff(addAssignment_33072,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,5)
    <=> v5985(VarCurr,5) ) ).

tff(addAssignment_33071,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,5)
    <=> v53672(VarCurr,5) ) ).

tff(addAssignment_33070,axiom,
    ! [VarCurr: state_type] :
      ( v53674(VarCurr,1)
    <=> v55794(VarCurr) ) ).

tff(addAssignment_33069,axiom,
    ! [VarCurr: state_type] :
      ( v55794(VarCurr)
    <=> v55796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5294,axiom,
    ! [VarCurr: state_type] :
      ( v55796(VarCurr)
    <=> ( v56098(VarCurr)
      <~> v56086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5293,axiom,
    ! [VarCurr: state_type] :
      ( v56098(VarCurr)
    <=> ( v55798(VarCurr)
      <~> v55954(VarCurr) ) ) ).

tff(addAssignment_33068,axiom,
    ! [VarCurr: state_type] :
      ( v56086(VarCurr)
    <=> v56088(VarCurr) ) ).

tff(addAssignment_33067,axiom,
    ! [VarCurr: state_type] :
      ( v56088(VarCurr)
    <=> v55427(VarCurr,1) ) ).

tff(addAssignment_33066,axiom,
    ! [VarCurr: state_type] :
      ( v55427(VarCurr,1)
    <=> v55429(VarCurr,1) ) ).

tff(addAssignment_33065,axiom,
    ! [VarCurr: state_type] :
      ( v55429(VarCurr,1)
    <=> v53454(VarCurr,6) ) ).

tff(addAssignment_33064,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,6)
    <=> v53456(VarCurr,6) ) ).

tff(addAssignment_33063,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,6)
    <=> v56090(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_736,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56091(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v56090(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_736,axiom,
    ! [VarNext: state_type] :
      ( v56091(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v56090(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56091(VarNext)
      <=> v56092(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56092(VarNext)
      <=> ( v56094(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56094(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_33062,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,6)
    <=> v53480(VarCurr,6) ) ).

tff(addAssignment_33061,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,6)
    <=> v53525(VarCurr,6) ) ).

tff(addAssignment_33060,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,5)
    <=> v55431(VarCurr,1) ) ).

tff(addAssignment_33059,axiom,
    ! [VarCurr: state_type] :
      ( v55431(VarCurr,1)
    <=> v55433(VarCurr,1) ) ).

tff(addAssignment_33058,axiom,
    ! [VarCurr: state_type] :
      ( v55433(VarCurr,1)
    <=> v55450(VarCurr,1) ) ).

tff(addAssignment_33057,axiom,
    ! [VarCurr: state_type] :
      ( v55443(VarCurr,1)
    <=> v55445(VarCurr,1) ) ).

tff(addAssignment_33056,axiom,
    ! [VarCurr: state_type] :
      ( v55445(VarCurr,1)
    <=> v53312(VarCurr,5) ) ).

tff(addAssignment_33055,axiom,
    ! [VarCurr: state_type] :
      ( v55435(VarCurr,1)
    <=> v55437(VarCurr,1) ) ).

tff(addAssignment_33054,axiom,
    ! [VarCurr: state_type] :
      ( v55437(VarCurr,1)
    <=> v53312(VarCurr,1) ) ).

tff(addAssignment_33053,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,1)
    <=> v53314(VarCurr,1) ) ).

tff(addAssignment_33052,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,1)
    <=> v53316(VarCurr,1) ) ).

tff(addAssignment_33051,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,1)
    <=> v53407(VarCurr,1) ) ).

tff(addAssignment_33050,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,1)
    <=> v53326(VarCurr,1) ) ).

tff(addAssignment_33049,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,1)
    <=> v53328(VarCurr,1) ) ).

tff(addAssignment_33048,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,1)
    <=> v6100(VarCurr,129) ) ).

tff(addAssignment_33047,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,129)
    <=> v6102(VarCurr,129) ) ).

tff(addAssignment_33046,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,129)
    <=> v53330(VarCurr,1) ) ).

tff(addAssignment_33045,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,1)
    <=> v53332(VarCurr,1) ) ).

tff(addAssignment_33044,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,1)
    <=> v53390(VarCurr,1) ) ).

tff(addAssignment_33043,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,1)
    <=> v53387(VarCurr,1) ) ).

tff(addAssignment_33042,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,1)
    <=> v53217(VarCurr,57) ) ).

tff(addAssignment_33041,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,1)
    <=> v53383(VarCurr,1) ) ).

tff(addAssignment_33040,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,1)
    <=> v53217(VarCurr,57) ) ).

tff(addAssignment_33039,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,57)
    <=> v53218(VarCurr,57) ) ).

tff(addAssignment_33038,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,111)
    <=> v6238(VarCurr,111) ) ).

tff(addAssignment_33037,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,111)
    <=> v6240(VarCurr,111) ) ).

tff(addAssignment_33036,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,111)
    <=> v44749(VarCurr,3) ) ).

tff(addAssignment_33035,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,1)
    <=> v53379(VarCurr,1) ) ).

tff(addAssignment_33034,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_33033,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,1)
    <=> v53320(VarCurr,1) ) ).

tff(addAssignment_33032,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,1)
    <=> v53321(VarCurr,1) ) ).

tff(addAssignment_33031,axiom,
    ! [VarCurr: state_type] :
      ( v55954(VarCurr)
    <=> v55956(VarCurr) ) ).

tff(addAssignment_33030,axiom,
    ! [VarCurr: state_type] :
      ( v55956(VarCurr)
    <=> v55958(VarCurr) ) ).

tff(addAssignment_33029,axiom,
    ! [VarCurr: state_type] :
      ( v55958(VarCurr)
    <=> v55960(VarCurr) ) ).

tff(addAssignment_33028,axiom,
    ! [VarCurr: state_type] :
      ( v55960(VarCurr)
    <=> v55962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5290,axiom,
    ! [VarCurr: state_type] :
      ( v55962(VarCurr)
    <=> ( v56084(VarCurr)
      <~> v56060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5289,axiom,
    ! [VarCurr: state_type] :
      ( v56084(VarCurr)
    <=> ( v55964(VarCurr)
      <~> v56012(VarCurr) ) ) ).

tff(addAssignment_33027,axiom,
    ! [VarCurr: state_type] :
      ( v56060(VarCurr)
    <=> v56062(VarCurr) ) ).

tff(addAssignment_33026,axiom,
    ! [VarCurr: state_type] :
      ( v56062(VarCurr)
    <=> v56064(VarCurr) ) ).

tff(addAssignment_33025,axiom,
    ! [VarCurr: state_type] :
      ( v56064(VarCurr)
    <=> v56066(VarCurr) ) ).

tff(addAssignment_33024,axiom,
    ! [VarCurr: state_type] :
      ( v56066(VarCurr)
    <=> v56068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5288,axiom,
    ! [VarCurr: state_type] :
      ( v56068(VarCurr)
    <=> ( v56082(VarCurr)
      <~> v56078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5287,axiom,
    ! [VarCurr: state_type] :
      ( v56082(VarCurr)
    <=> ( v56070(VarCurr)
      <~> v56074(VarCurr) ) ) ).

tff(addAssignment_33023,axiom,
    ! [VarCurr: state_type] :
      ( v56078(VarCurr)
    <=> v56080(VarCurr) ) ).

tff(addAssignment_33022,axiom,
    ! [VarCurr: state_type] :
      ( v56080(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_33021,axiom,
    ! [VarCurr: state_type] :
      ( v56074(VarCurr)
    <=> v56076(VarCurr) ) ).

tff(addAssignment_33020,axiom,
    ! [VarCurr: state_type] :
      ( v56076(VarCurr)
    <=> v6017(VarCurr,125) ) ).

tff(addAssignment_33019,axiom,
    ! [VarCurr: state_type] :
      ( v56070(VarCurr)
    <=> v56072(VarCurr) ) ).

tff(addAssignment_33018,axiom,
    ! [VarCurr: state_type] :
      ( v56072(VarCurr)
    <=> v6017(VarCurr,121) ) ).

tff(addAssignment_33017,axiom,
    ! [VarCurr: state_type] :
      ( v56012(VarCurr)
    <=> v56014(VarCurr) ) ).

tff(addAssignment_33016,axiom,
    ! [VarCurr: state_type] :
      ( v56014(VarCurr)
    <=> v56016(VarCurr) ) ).

tff(addAssignment_33015,axiom,
    ! [VarCurr: state_type] :
      ( v56016(VarCurr)
    <=> v56018(VarCurr) ) ).

tff(addAssignment_33014,axiom,
    ! [VarCurr: state_type] :
      ( v56018(VarCurr)
    <=> v56020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5286,axiom,
    ! [VarCurr: state_type] :
      ( v56020(VarCurr)
    <=> ( v56058(VarCurr)
      <~> v56046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5285,axiom,
    ! [VarCurr: state_type] :
      ( v56058(VarCurr)
    <=> ( v56022(VarCurr)
      <~> v56034(VarCurr) ) ) ).

tff(addAssignment_33013,axiom,
    ! [VarCurr: state_type] :
      ( v56046(VarCurr)
    <=> v56048(VarCurr) ) ).

tff(addAssignment_33012,axiom,
    ! [VarCurr: state_type] :
      ( v56048(VarCurr)
    <=> v6017(VarCurr,117) ) ).

tff(addAssignment_33011,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,117)
    <=> v53103(VarCurr,53) ) ).

tff(addAssignment_33010,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,53)
    <=> v53105(VarCurr,53) ) ).

tff(addAssignment_33009,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,53)
    <=> v53107(VarCurr,53) ) ).

tff(addAssignment_33008,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,53)
    <=> v53109(VarCurr,53) ) ).

tff(addAssignment_33007,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,53)
    <=> v6027(VarCurr,117) ) ).

tff(addAssignment_33006,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,117)
    <=> v52434(VarCurr,117) ) ).

tff(addAssignment_33005,axiom,
    ! [VarCurr: state_type] :
      ( v52437(VarCurr,1)
    <=> v53112(VarCurr,53) ) ).

tff(addAssignment_33004,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,53)
    <=> v53114(VarCurr,53) ) ).

tff(addAssignment_33003,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,53)
    <=> v56050(VarNext,53) ) ).

tff(addCaseBooleanConditionEqualRanges1_735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56051(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56050(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_735,axiom,
    ! [VarNext: state_type] :
      ( v56051(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56050(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56051(VarNext)
      <=> v56052(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56052(VarNext)
      <=> ( v56054(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56054(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_33002,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,53)
    <=> v53138(VarCurr,53) ) ).

tff(addAssignment_33001,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,53)
    <=> v6059(VarCurr,117) ) ).

tff(addAssignment_33000,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,117)
    <=> v55358(VarCurr,1) ) ).

tff(addAssignment_32999,axiom,
    ! [VarCurr: state_type] :
      ( v55358(VarCurr,1)
    <=> v55360(VarCurr,1) ) ).

tff(addAssignment_32998,axiom,
    ! [VarCurr: state_type] :
      ( v55360(VarCurr,1)
    <=> v55377(VarCurr,1) ) ).

tff(addAssignment_32997,axiom,
    ! [VarCurr: state_type] :
      ( v55370(VarCurr,1)
    <=> v55372(VarCurr,1) ) ).

tff(addAssignment_32996,axiom,
    ! [VarCurr: state_type] :
      ( v55372(VarCurr,1)
    <=> v6069(VarCurr,117) ) ).

tff(addAssignment_32995,axiom,
    ! [VarCurr: state_type] :
      ( v55362(VarCurr,1)
    <=> v55364(VarCurr,1) ) ).

tff(addAssignment_32994,axiom,
    ! [VarCurr: state_type] :
      ( v55364(VarCurr,1)
    <=> v6069(VarCurr,121) ) ).

tff(addAssignment_32993,axiom,
    ! [VarCurr: state_type] :
      ( v56034(VarCurr)
    <=> v56036(VarCurr) ) ).

tff(addAssignment_32992,axiom,
    ! [VarCurr: state_type] :
      ( v56036(VarCurr)
    <=> v6017(VarCurr,113) ) ).

tff(addAssignment_32991,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,113)
    <=> v53103(VarCurr,49) ) ).

tff(addAssignment_32990,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,49)
    <=> v53105(VarCurr,49) ) ).

tff(addAssignment_32989,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,49)
    <=> v53107(VarCurr,49) ) ).

tff(addAssignment_32988,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,49)
    <=> v53109(VarCurr,49) ) ).

tff(addAssignment_32987,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,49)
    <=> v6027(VarCurr,113) ) ).

tff(addAssignment_32986,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,113)
    <=> v52434(VarCurr,113) ) ).

tff(addAssignment_32985,axiom,
    ! [VarCurr: state_type] :
      ( v52438(VarCurr,1)
    <=> v53112(VarCurr,49) ) ).

tff(addAssignment_32984,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,49)
    <=> v53114(VarCurr,49) ) ).

tff(addAssignment_32983,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,49)
    <=> v56038(VarNext,49) ) ).

tff(addCaseBooleanConditionEqualRanges1_734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56039(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56038(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_734,axiom,
    ! [VarNext: state_type] :
      ( v56039(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56038(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56039(VarNext)
      <=> v56040(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56040(VarNext)
      <=> ( v56042(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56042(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32982,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,49)
    <=> v53138(VarCurr,49) ) ).

tff(addAssignment_32981,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,49)
    <=> v6059(VarCurr,113) ) ).

tff(addAssignment_32980,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,113)
    <=> v55318(VarCurr,1) ) ).

tff(addAssignment_32979,axiom,
    ! [VarCurr: state_type] :
      ( v55318(VarCurr,1)
    <=> v55320(VarCurr,1) ) ).

tff(addAssignment_32978,axiom,
    ! [VarCurr: state_type] :
      ( v55320(VarCurr,1)
    <=> v55337(VarCurr,1) ) ).

tff(addAssignment_32977,axiom,
    ! [VarCurr: state_type] :
      ( v55330(VarCurr,1)
    <=> v55332(VarCurr,1) ) ).

tff(addAssignment_32976,axiom,
    ! [VarCurr: state_type] :
      ( v55332(VarCurr,1)
    <=> v6069(VarCurr,113) ) ).

tff(addAssignment_32975,axiom,
    ! [VarCurr: state_type] :
      ( v55322(VarCurr,1)
    <=> v55324(VarCurr,1) ) ).

tff(addAssignment_32974,axiom,
    ! [VarCurr: state_type] :
      ( v55324(VarCurr,1)
    <=> v6069(VarCurr,117) ) ).

tff(addAssignment_32973,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,117)
    <=> v53148(VarCurr,53) ) ).

tff(addAssignment_32972,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,53)
    <=> v53150(VarCurr,53) ) ).

tff(addAssignment_32971,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,53)
    <=> v53242(VarCurr,53) ) ).

tff(addAssignment_32970,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,53)
    <=> v53160(VarCurr,53) ) ).

tff(addAssignment_32969,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,53)
    <=> v6098(VarCurr,117) ) ).

tff(addAssignment_32968,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,117)
    <=> v6100(VarCurr,117) ) ).

tff(addAssignment_32967,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,117)
    <=> v6102(VarCurr,117) ) ).

tff(addAssignment_32966,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,117)
    <=> v53162(VarCurr,53) ) ).

tff(addAssignment_32965,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,53)
    <=> v53164(VarCurr,53) ) ).

tff(addAssignment_32964,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,53)
    <=> v53225(VarCurr,53) ) ).

tff(addAssignment_32963,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,53)
    <=> v53223(VarCurr,53) ) ).

tff(addAssignment_32962,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,53)
    <=> v53224(VarCurr,53) ) ).

tff(addAssignment_32961,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,53)
    <=> v53215(VarCurr,53) ) ).

tff(addAssignment_32960,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,53)
    <=> v53219(VarCurr,53) ) ).

tff(addAssignment_32959,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,45)
    <=> v53218(VarCurr,45) ) ).

tff(addAssignment_32958,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,87)
    <=> v6238(VarCurr,87) ) ).

tff(addAssignment_32957,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,87)
    <=> v6240(VarCurr,87) ) ).

tff(addAssignment_32956,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,87)
    <=> v41649(VarCurr,3) ) ).

tff(addAssignment_32955,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,53)
    <=> v53211(VarCurr,53) ) ).

tff(addAssignment_32954,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,53)
    <=> $false ) ).

tff(addAssignment_32953,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,53)
    <=> v53154(VarCurr,53) ) ).

tff(addAssignment_32952,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,53)
    <=> v53155(VarCurr,53) ) ).

tff(addAssignment_32951,axiom,
    ! [VarCurr: state_type] :
      ( v56022(VarCurr)
    <=> v56024(VarCurr) ) ).

tff(addAssignment_32950,axiom,
    ! [VarCurr: state_type] :
      ( v56024(VarCurr)
    <=> v6017(VarCurr,109) ) ).

tff(addAssignment_32949,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,109)
    <=> v53103(VarCurr,45) ) ).

tff(addAssignment_32948,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,45)
    <=> v53105(VarCurr,45) ) ).

tff(addAssignment_32947,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,45)
    <=> v53107(VarCurr,45) ) ).

tff(addAssignment_32946,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,45)
    <=> v53109(VarCurr,45) ) ).

tff(addAssignment_32945,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,45)
    <=> v6027(VarCurr,109) ) ).

tff(addAssignment_32944,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,109)
    <=> v52434(VarCurr,109) ) ).

tff(addAssignment_32943,axiom,
    ! [VarCurr: state_type] :
      ( v52439(VarCurr,1)
    <=> v53112(VarCurr,45) ) ).

tff(addAssignment_32942,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,45)
    <=> v53114(VarCurr,45) ) ).

tff(addAssignment_32941,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,45)
    <=> v56026(VarNext,45) ) ).

tff(addCaseBooleanConditionEqualRanges1_733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56027(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56026(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_733,axiom,
    ! [VarNext: state_type] :
      ( v56027(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56026(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56027(VarNext)
      <=> v56028(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56028(VarNext)
      <=> ( v56030(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56030(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32940,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,45)
    <=> v53138(VarCurr,45) ) ).

tff(addAssignment_32939,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,45)
    <=> v6059(VarCurr,109) ) ).

tff(addAssignment_32938,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,109)
    <=> v55278(VarCurr,1) ) ).

tff(addAssignment_32937,axiom,
    ! [VarCurr: state_type] :
      ( v55278(VarCurr,1)
    <=> v55280(VarCurr,1) ) ).

tff(addAssignment_32936,axiom,
    ! [VarCurr: state_type] :
      ( v55280(VarCurr,1)
    <=> v55297(VarCurr,1) ) ).

tff(addAssignment_32935,axiom,
    ! [VarCurr: state_type] :
      ( v55290(VarCurr,1)
    <=> v55292(VarCurr,1) ) ).

tff(addAssignment_32934,axiom,
    ! [VarCurr: state_type] :
      ( v55292(VarCurr,1)
    <=> v6069(VarCurr,109) ) ).

tff(addAssignment_32933,axiom,
    ! [VarCurr: state_type] :
      ( v55282(VarCurr,1)
    <=> v55284(VarCurr,1) ) ).

tff(addAssignment_32932,axiom,
    ! [VarCurr: state_type] :
      ( v55284(VarCurr,1)
    <=> v6069(VarCurr,113) ) ).

tff(addAssignment_32931,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,113)
    <=> v53148(VarCurr,49) ) ).

tff(addAssignment_32930,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,49)
    <=> v53150(VarCurr,49) ) ).

tff(addAssignment_32929,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,49)
    <=> v53242(VarCurr,49) ) ).

tff(addAssignment_32928,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,49)
    <=> v53160(VarCurr,49) ) ).

tff(addAssignment_32927,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,49)
    <=> v6098(VarCurr,113) ) ).

tff(addAssignment_32926,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,113)
    <=> v6100(VarCurr,113) ) ).

tff(addAssignment_32925,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,113)
    <=> v6102(VarCurr,113) ) ).

tff(addAssignment_32924,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,113)
    <=> v53162(VarCurr,49) ) ).

tff(addAssignment_32923,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,49)
    <=> v53164(VarCurr,49) ) ).

tff(addAssignment_32922,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,49)
    <=> v53225(VarCurr,49) ) ).

tff(addAssignment_32921,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,49)
    <=> v53223(VarCurr,49) ) ).

tff(addAssignment_32920,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,49)
    <=> v53224(VarCurr,49) ) ).

tff(addAssignment_32919,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,49)
    <=> v53215(VarCurr,49) ) ).

tff(addAssignment_32918,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,49)
    <=> v53219(VarCurr,49) ) ).

tff(addAssignment_32917,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,41)
    <=> v53218(VarCurr,41) ) ).

tff(addAssignment_32916,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,77)
    <=> v6238(VarCurr,77) ) ).

tff(addAssignment_32915,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,77)
    <=> v6240(VarCurr,77) ) ).

tff(addAssignment_32914,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,77)
    <=> v40099(VarCurr,5) ) ).

tff(addAssignment_32913,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,49)
    <=> v53211(VarCurr,49) ) ).

tff(addAssignment_32912,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,49)
    <=> $false ) ).

tff(addAssignment_32911,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,49)
    <=> v53154(VarCurr,49) ) ).

tff(addAssignment_32910,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,49)
    <=> v53155(VarCurr,49) ) ).

tff(addAssignment_32909,axiom,
    ! [VarCurr: state_type] :
      ( v55964(VarCurr)
    <=> v55966(VarCurr) ) ).

tff(addAssignment_32908,axiom,
    ! [VarCurr: state_type] :
      ( v55966(VarCurr)
    <=> v55968(VarCurr) ) ).

tff(addAssignment_32907,axiom,
    ! [VarCurr: state_type] :
      ( v55968(VarCurr)
    <=> v55970(VarCurr) ) ).

tff(addAssignment_32906,axiom,
    ! [VarCurr: state_type] :
      ( v55970(VarCurr)
    <=> v55972(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5278,axiom,
    ! [VarCurr: state_type] :
      ( v55972(VarCurr)
    <=> ( v56010(VarCurr)
      <~> v55998(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5277,axiom,
    ! [VarCurr: state_type] :
      ( v56010(VarCurr)
    <=> ( v55974(VarCurr)
      <~> v55986(VarCurr) ) ) ).

tff(addAssignment_32905,axiom,
    ! [VarCurr: state_type] :
      ( v55998(VarCurr)
    <=> v56000(VarCurr) ) ).

tff(addAssignment_32904,axiom,
    ! [VarCurr: state_type] :
      ( v56000(VarCurr)
    <=> v6017(VarCurr,105) ) ).

tff(addAssignment_32903,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,105)
    <=> v53103(VarCurr,41) ) ).

tff(addAssignment_32902,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,41)
    <=> v53105(VarCurr,41) ) ).

tff(addAssignment_32901,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,41)
    <=> v53107(VarCurr,41) ) ).

tff(addAssignment_32900,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,41)
    <=> v53109(VarCurr,41) ) ).

tff(addAssignment_32899,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,41)
    <=> v6027(VarCurr,105) ) ).

tff(addAssignment_32898,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,105)
    <=> v52434(VarCurr,105) ) ).

tff(addAssignment_32897,axiom,
    ! [VarCurr: state_type] :
      ( v52440(VarCurr,1)
    <=> v53112(VarCurr,41) ) ).

tff(addAssignment_32896,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,41)
    <=> v53114(VarCurr,41) ) ).

tff(addAssignment_32895,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,41)
    <=> v56002(VarNext,41) ) ).

tff(addCaseBooleanConditionEqualRanges1_732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56003(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v56002(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_732,axiom,
    ! [VarNext: state_type] :
      ( v56003(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v56002(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56003(VarNext)
      <=> v56004(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v56004(VarNext)
      <=> ( v56006(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v56006(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32894,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,41)
    <=> v53138(VarCurr,41) ) ).

tff(addAssignment_32893,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,41)
    <=> v6059(VarCurr,105) ) ).

tff(addAssignment_32892,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,105)
    <=> v55226(VarCurr,1) ) ).

tff(addAssignment_32891,axiom,
    ! [VarCurr: state_type] :
      ( v55226(VarCurr,1)
    <=> v55228(VarCurr,1) ) ).

tff(addAssignment_32890,axiom,
    ! [VarCurr: state_type] :
      ( v55228(VarCurr,1)
    <=> v55245(VarCurr,1) ) ).

tff(addAssignment_32889,axiom,
    ! [VarCurr: state_type] :
      ( v55238(VarCurr,1)
    <=> v55240(VarCurr,1) ) ).

tff(addAssignment_32888,axiom,
    ! [VarCurr: state_type] :
      ( v55240(VarCurr,1)
    <=> v6069(VarCurr,105) ) ).

tff(addAssignment_32887,axiom,
    ! [VarCurr: state_type] :
      ( v55230(VarCurr,1)
    <=> v55232(VarCurr,1) ) ).

tff(addAssignment_32886,axiom,
    ! [VarCurr: state_type] :
      ( v55232(VarCurr,1)
    <=> v6069(VarCurr,109) ) ).

tff(addAssignment_32885,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,109)
    <=> v53148(VarCurr,45) ) ).

tff(addAssignment_32884,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,45)
    <=> v53150(VarCurr,45) ) ).

tff(addAssignment_32883,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,45)
    <=> v53242(VarCurr,45) ) ).

tff(addAssignment_32882,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,45)
    <=> v53160(VarCurr,45) ) ).

tff(addAssignment_32881,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,45)
    <=> v6098(VarCurr,109) ) ).

tff(addAssignment_32880,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,109)
    <=> v6100(VarCurr,109) ) ).

tff(addAssignment_32879,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,109)
    <=> v6102(VarCurr,109) ) ).

tff(addAssignment_32878,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,109)
    <=> v53162(VarCurr,45) ) ).

tff(addAssignment_32877,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,45)
    <=> v53164(VarCurr,45) ) ).

tff(addAssignment_32876,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,45)
    <=> v53225(VarCurr,45) ) ).

tff(addAssignment_32875,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,45)
    <=> v53223(VarCurr,45) ) ).

tff(addAssignment_32874,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,45)
    <=> v53224(VarCurr,45) ) ).

tff(addAssignment_32873,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,45)
    <=> v53215(VarCurr,45) ) ).

tff(addAssignment_32872,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,45)
    <=> v53219(VarCurr,45) ) ).

tff(addAssignment_32871,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,37)
    <=> v53218(VarCurr,37) ) ).

tff(addAssignment_32870,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,73)
    <=> v6238(VarCurr,73) ) ).

tff(addAssignment_32869,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,73)
    <=> v6240(VarCurr,73) ) ).

tff(addAssignment_32868,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,73)
    <=> v40099(VarCurr,1) ) ).

tff(addAssignment_32867,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,45)
    <=> v53211(VarCurr,45) ) ).

tff(addAssignment_32866,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,45)
    <=> $false ) ).

tff(addAssignment_32865,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,45)
    <=> v53154(VarCurr,45) ) ).

tff(addAssignment_32864,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,45)
    <=> v53155(VarCurr,45) ) ).

tff(addAssignment_32863,axiom,
    ! [VarCurr: state_type] :
      ( v55986(VarCurr)
    <=> v55988(VarCurr) ) ).

tff(addAssignment_32862,axiom,
    ! [VarCurr: state_type] :
      ( v55988(VarCurr)
    <=> v6017(VarCurr,101) ) ).

tff(addAssignment_32861,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,101)
    <=> v53103(VarCurr,37) ) ).

tff(addAssignment_32860,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,37)
    <=> v53105(VarCurr,37) ) ).

tff(addAssignment_32859,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,37)
    <=> v53107(VarCurr,37) ) ).

tff(addAssignment_32858,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,37)
    <=> v53109(VarCurr,37) ) ).

tff(addAssignment_32857,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,37)
    <=> v6027(VarCurr,101) ) ).

tff(addAssignment_32856,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,101)
    <=> v52434(VarCurr,101) ) ).

tff(addAssignment_32855,axiom,
    ! [VarCurr: state_type] :
      ( v52441(VarCurr,1)
    <=> v53112(VarCurr,37) ) ).

tff(addAssignment_32854,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,37)
    <=> v53114(VarCurr,37) ) ).

tff(addAssignment_32853,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,37)
    <=> v55990(VarNext,37) ) ).

tff(addCaseBooleanConditionEqualRanges1_731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55991(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55990(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_731,axiom,
    ! [VarNext: state_type] :
      ( v55991(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55990(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55991(VarNext)
      <=> v55992(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55992(VarNext)
      <=> ( v55994(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55994(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32852,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,37)
    <=> v53138(VarCurr,37) ) ).

tff(addAssignment_32851,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,37)
    <=> v6059(VarCurr,101) ) ).

tff(addAssignment_32850,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,101)
    <=> v55186(VarCurr,1) ) ).

tff(addAssignment_32849,axiom,
    ! [VarCurr: state_type] :
      ( v55186(VarCurr,1)
    <=> v55188(VarCurr,1) ) ).

tff(addAssignment_32848,axiom,
    ! [VarCurr: state_type] :
      ( v55188(VarCurr,1)
    <=> v55205(VarCurr,1) ) ).

tff(addAssignment_32847,axiom,
    ! [VarCurr: state_type] :
      ( v55198(VarCurr,1)
    <=> v55200(VarCurr,1) ) ).

tff(addAssignment_32846,axiom,
    ! [VarCurr: state_type] :
      ( v55200(VarCurr,1)
    <=> v6069(VarCurr,101) ) ).

tff(addAssignment_32845,axiom,
    ! [VarCurr: state_type] :
      ( v55190(VarCurr,1)
    <=> v55192(VarCurr,1) ) ).

tff(addAssignment_32844,axiom,
    ! [VarCurr: state_type] :
      ( v55192(VarCurr,1)
    <=> v6069(VarCurr,105) ) ).

tff(addAssignment_32843,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,105)
    <=> v53148(VarCurr,41) ) ).

tff(addAssignment_32842,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,41)
    <=> v53150(VarCurr,41) ) ).

tff(addAssignment_32841,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,41)
    <=> v53242(VarCurr,41) ) ).

tff(addAssignment_32840,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,41)
    <=> v53160(VarCurr,41) ) ).

tff(addAssignment_32839,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,41)
    <=> v6098(VarCurr,105) ) ).

tff(addAssignment_32838,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,105)
    <=> v6100(VarCurr,105) ) ).

tff(addAssignment_32837,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,105)
    <=> v6102(VarCurr,105) ) ).

tff(addAssignment_32836,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,105)
    <=> v53162(VarCurr,41) ) ).

tff(addAssignment_32835,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,41)
    <=> v53164(VarCurr,41) ) ).

tff(addAssignment_32834,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,41)
    <=> v53225(VarCurr,41) ) ).

tff(addAssignment_32833,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,41)
    <=> v53223(VarCurr,41) ) ).

tff(addAssignment_32832,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,41)
    <=> v53224(VarCurr,41) ) ).

tff(addAssignment_32831,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,41)
    <=> v53215(VarCurr,41) ) ).

tff(addAssignment_32830,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,41)
    <=> v53219(VarCurr,41) ) ).

tff(addAssignment_32829,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,33)
    <=> v53218(VarCurr,33) ) ).

tff(addAssignment_32828,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,63)
    <=> v6238(VarCurr,63) ) ).

tff(addAssignment_32827,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,63)
    <=> v6240(VarCurr,63) ) ).

tff(addAssignment_32826,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,63)
    <=> v38549(VarCurr,3) ) ).

tff(addAssignment_32825,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,41)
    <=> v53211(VarCurr,41) ) ).

tff(addAssignment_32824,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,41)
    <=> $false ) ).

tff(addAssignment_32823,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,41)
    <=> v53154(VarCurr,41) ) ).

tff(addAssignment_32822,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,41)
    <=> v53155(VarCurr,41) ) ).

tff(addAssignment_32821,axiom,
    ! [VarCurr: state_type] :
      ( v55974(VarCurr)
    <=> v55976(VarCurr) ) ).

tff(addAssignment_32820,axiom,
    ! [VarCurr: state_type] :
      ( v55976(VarCurr)
    <=> v6017(VarCurr,97) ) ).

tff(addAssignment_32819,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,97)
    <=> v53103(VarCurr,33) ) ).

tff(addAssignment_32818,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,33)
    <=> v53105(VarCurr,33) ) ).

tff(addAssignment_32817,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,33)
    <=> v53107(VarCurr,33) ) ).

tff(addAssignment_32816,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,33)
    <=> v53109(VarCurr,33) ) ).

tff(addAssignment_32815,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,33)
    <=> v6027(VarCurr,97) ) ).

tff(addAssignment_32814,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,97)
    <=> v52434(VarCurr,97) ) ).

tff(addAssignment_32813,axiom,
    ! [VarCurr: state_type] :
      ( v52442(VarCurr,1)
    <=> v53112(VarCurr,33) ) ).

tff(addAssignment_32812,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,33)
    <=> v53114(VarCurr,33) ) ).

tff(addAssignment_32811,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,33)
    <=> v55978(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55979(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55978(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_730,axiom,
    ! [VarNext: state_type] :
      ( v55979(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55978(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55979(VarNext)
      <=> v55980(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55980(VarNext)
      <=> ( v55982(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55982(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32810,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,33)
    <=> v53138(VarCurr,33) ) ).

tff(addAssignment_32809,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,33)
    <=> v6059(VarCurr,97) ) ).

tff(addAssignment_32808,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,97)
    <=> v55146(VarCurr,1) ) ).

tff(addAssignment_32807,axiom,
    ! [VarCurr: state_type] :
      ( v55146(VarCurr,1)
    <=> v55148(VarCurr,1) ) ).

tff(addAssignment_32806,axiom,
    ! [VarCurr: state_type] :
      ( v55148(VarCurr,1)
    <=> v55165(VarCurr,1) ) ).

tff(addAssignment_32805,axiom,
    ! [VarCurr: state_type] :
      ( v55158(VarCurr,1)
    <=> v55160(VarCurr,1) ) ).

tff(addAssignment_32804,axiom,
    ! [VarCurr: state_type] :
      ( v55160(VarCurr,1)
    <=> v6069(VarCurr,97) ) ).

tff(addAssignment_32803,axiom,
    ! [VarCurr: state_type] :
      ( v55150(VarCurr,1)
    <=> v55152(VarCurr,1) ) ).

tff(addAssignment_32802,axiom,
    ! [VarCurr: state_type] :
      ( v55152(VarCurr,1)
    <=> v6069(VarCurr,101) ) ).

tff(addAssignment_32801,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,101)
    <=> v53148(VarCurr,37) ) ).

tff(addAssignment_32800,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,37)
    <=> v53150(VarCurr,37) ) ).

tff(addAssignment_32799,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,37)
    <=> v53242(VarCurr,37) ) ).

tff(addAssignment_32798,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,37)
    <=> v53160(VarCurr,37) ) ).

tff(addAssignment_32797,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,37)
    <=> v6098(VarCurr,101) ) ).

tff(addAssignment_32796,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,101)
    <=> v6100(VarCurr,101) ) ).

tff(addAssignment_32795,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,101)
    <=> v6102(VarCurr,101) ) ).

tff(addAssignment_32794,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,101)
    <=> v53162(VarCurr,37) ) ).

tff(addAssignment_32793,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,37)
    <=> v53164(VarCurr,37) ) ).

tff(addAssignment_32792,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,37)
    <=> v53225(VarCurr,37) ) ).

tff(addAssignment_32791,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,37)
    <=> v53223(VarCurr,37) ) ).

tff(addAssignment_32790,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,37)
    <=> v53224(VarCurr,37) ) ).

tff(addAssignment_32789,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,37)
    <=> v53215(VarCurr,37) ) ).

tff(addAssignment_32788,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,37)
    <=> v53219(VarCurr,37) ) ).

tff(addAssignment_32787,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,29)
    <=> v53218(VarCurr,29) ) ).

tff(addAssignment_32786,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,53)
    <=> v6238(VarCurr,53) ) ).

tff(addAssignment_32785,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,53)
    <=> v6240(VarCurr,53) ) ).

tff(addAssignment_32784,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,53)
    <=> v36999(VarCurr,5) ) ).

tff(addAssignment_32783,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,37)
    <=> v53211(VarCurr,37) ) ).

tff(addAssignment_32782,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,37)
    <=> $false ) ).

tff(addAssignment_32781,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,37)
    <=> v53154(VarCurr,37) ) ).

tff(addAssignment_32780,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,37)
    <=> v53155(VarCurr,37) ) ).

tff(addAssignment_32779,axiom,
    ! [VarCurr: state_type] :
      ( v55798(VarCurr)
    <=> v55800(VarCurr) ) ).

tff(addAssignment_32778,axiom,
    ! [VarCurr: state_type] :
      ( v55800(VarCurr)
    <=> v55802(VarCurr) ) ).

tff(addAssignment_32777,axiom,
    ! [VarCurr: state_type] :
      ( v55802(VarCurr)
    <=> v55804(VarCurr) ) ).

tff(addAssignment_32776,axiom,
    ! [VarCurr: state_type] :
      ( v55804(VarCurr)
    <=> v55806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5270,axiom,
    ! [VarCurr: state_type] :
      ( v55806(VarCurr)
    <=> ( v55952(VarCurr)
      <~> v55904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5269,axiom,
    ! [VarCurr: state_type] :
      ( v55952(VarCurr)
    <=> ( v55808(VarCurr)
      <~> v55856(VarCurr) ) ) ).

tff(addAssignment_32775,axiom,
    ! [VarCurr: state_type] :
      ( v55904(VarCurr)
    <=> v55906(VarCurr) ) ).

tff(addAssignment_32774,axiom,
    ! [VarCurr: state_type] :
      ( v55906(VarCurr)
    <=> v55908(VarCurr) ) ).

tff(addAssignment_32773,axiom,
    ! [VarCurr: state_type] :
      ( v55908(VarCurr)
    <=> v55910(VarCurr) ) ).

tff(addAssignment_32772,axiom,
    ! [VarCurr: state_type] :
      ( v55910(VarCurr)
    <=> v55912(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5268,axiom,
    ! [VarCurr: state_type] :
      ( v55912(VarCurr)
    <=> ( v55950(VarCurr)
      <~> v55938(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5267,axiom,
    ! [VarCurr: state_type] :
      ( v55950(VarCurr)
    <=> ( v55914(VarCurr)
      <~> v55926(VarCurr) ) ) ).

tff(addAssignment_32771,axiom,
    ! [VarCurr: state_type] :
      ( v55938(VarCurr)
    <=> v55940(VarCurr) ) ).

tff(addAssignment_32770,axiom,
    ! [VarCurr: state_type] :
      ( v55940(VarCurr)
    <=> v6017(VarCurr,93) ) ).

tff(addAssignment_32769,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,93)
    <=> v53103(VarCurr,29) ) ).

tff(addAssignment_32768,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,29)
    <=> v53105(VarCurr,29) ) ).

tff(addAssignment_32767,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,29)
    <=> v53107(VarCurr,29) ) ).

tff(addAssignment_32766,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,29)
    <=> v53109(VarCurr,29) ) ).

tff(addAssignment_32765,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,29)
    <=> v6027(VarCurr,93) ) ).

tff(addAssignment_32764,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,93)
    <=> v52434(VarCurr,93) ) ).

tff(addAssignment_32763,axiom,
    ! [VarCurr: state_type] :
      ( v52443(VarCurr,1)
    <=> v53112(VarCurr,29) ) ).

tff(addAssignment_32762,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,29)
    <=> v53114(VarCurr,29) ) ).

tff(addAssignment_32761,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,29)
    <=> v55942(VarNext,29) ) ).

tff(addCaseBooleanConditionEqualRanges1_729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55943(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55942(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_729,axiom,
    ! [VarNext: state_type] :
      ( v55943(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55942(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55943(VarNext)
      <=> v55944(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55944(VarNext)
      <=> ( v55946(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55946(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32760,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,29)
    <=> v53138(VarCurr,29) ) ).

tff(addAssignment_32759,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,29)
    <=> v6059(VarCurr,93) ) ).

tff(addAssignment_32758,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,93)
    <=> v55082(VarCurr,1) ) ).

tff(addAssignment_32757,axiom,
    ! [VarCurr: state_type] :
      ( v55082(VarCurr,1)
    <=> v55084(VarCurr,1) ) ).

tff(addAssignment_32756,axiom,
    ! [VarCurr: state_type] :
      ( v55084(VarCurr,1)
    <=> v55101(VarCurr,1) ) ).

tff(addAssignment_32755,axiom,
    ! [VarCurr: state_type] :
      ( v55094(VarCurr,1)
    <=> v55096(VarCurr,1) ) ).

tff(addAssignment_32754,axiom,
    ! [VarCurr: state_type] :
      ( v55096(VarCurr,1)
    <=> v6069(VarCurr,93) ) ).

tff(addAssignment_32753,axiom,
    ! [VarCurr: state_type] :
      ( v55086(VarCurr,1)
    <=> v55088(VarCurr,1) ) ).

tff(addAssignment_32752,axiom,
    ! [VarCurr: state_type] :
      ( v55088(VarCurr,1)
    <=> v6069(VarCurr,97) ) ).

tff(addAssignment_32751,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,97)
    <=> v53148(VarCurr,33) ) ).

tff(addAssignment_32750,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,33)
    <=> v53150(VarCurr,33) ) ).

tff(addAssignment_32749,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,33)
    <=> v53242(VarCurr,33) ) ).

tff(addAssignment_32748,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,33)
    <=> v53160(VarCurr,33) ) ).

tff(addAssignment_32747,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,33)
    <=> v6098(VarCurr,97) ) ).

tff(addAssignment_32746,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,97)
    <=> v6100(VarCurr,97) ) ).

tff(addAssignment_32745,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,97)
    <=> v6102(VarCurr,97) ) ).

tff(addAssignment_32744,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,97)
    <=> v53162(VarCurr,33) ) ).

tff(addAssignment_32743,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,33)
    <=> v53164(VarCurr,33) ) ).

tff(addAssignment_32742,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,33)
    <=> v53225(VarCurr,33) ) ).

tff(addAssignment_32741,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,33)
    <=> v53223(VarCurr,33) ) ).

tff(addAssignment_32740,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,33)
    <=> v53224(VarCurr,33) ) ).

tff(addAssignment_32739,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,33)
    <=> v53215(VarCurr,33) ) ).

tff(addAssignment_32738,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,33)
    <=> v53219(VarCurr,33) ) ).

tff(addAssignment_32737,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,25)
    <=> v53218(VarCurr,25) ) ).

tff(addAssignment_32736,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,49)
    <=> v6238(VarCurr,49) ) ).

tff(addAssignment_32735,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,49)
    <=> v6240(VarCurr,49) ) ).

tff(addAssignment_32734,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,49)
    <=> v36999(VarCurr,1) ) ).

tff(addAssignment_32733,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,33)
    <=> v53211(VarCurr,33) ) ).

tff(addAssignment_32732,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,33)
    <=> $false ) ).

tff(addAssignment_32731,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,33)
    <=> v53154(VarCurr,33) ) ).

tff(addAssignment_32730,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,33)
    <=> v53155(VarCurr,33) ) ).

tff(addAssignment_32729,axiom,
    ! [VarCurr: state_type] :
      ( v55926(VarCurr)
    <=> v55928(VarCurr) ) ).

tff(addAssignment_32728,axiom,
    ! [VarCurr: state_type] :
      ( v55928(VarCurr)
    <=> v6017(VarCurr,89) ) ).

tff(addAssignment_32727,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,89)
    <=> v53103(VarCurr,25) ) ).

tff(addAssignment_32726,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,25)
    <=> v53105(VarCurr,25) ) ).

tff(addAssignment_32725,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,25)
    <=> v53107(VarCurr,25) ) ).

tff(addAssignment_32724,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,25)
    <=> v53109(VarCurr,25) ) ).

tff(addAssignment_32723,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,25)
    <=> v6027(VarCurr,89) ) ).

tff(addAssignment_32722,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,89)
    <=> v52434(VarCurr,89) ) ).

tff(addAssignment_32721,axiom,
    ! [VarCurr: state_type] :
      ( v52444(VarCurr,1)
    <=> v53112(VarCurr,25) ) ).

tff(addAssignment_32720,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,25)
    <=> v53114(VarCurr,25) ) ).

tff(addAssignment_32719,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,25)
    <=> v55930(VarNext,25) ) ).

tff(addCaseBooleanConditionEqualRanges1_728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55931(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55930(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_728,axiom,
    ! [VarNext: state_type] :
      ( v55931(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55930(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55931(VarNext)
      <=> v55932(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55932(VarNext)
      <=> ( v55934(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55934(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32718,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,25)
    <=> v53138(VarCurr,25) ) ).

tff(addAssignment_32717,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,25)
    <=> v6059(VarCurr,89) ) ).

tff(addAssignment_32716,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,89)
    <=> v55042(VarCurr,1) ) ).

tff(addAssignment_32715,axiom,
    ! [VarCurr: state_type] :
      ( v55042(VarCurr,1)
    <=> v55044(VarCurr,1) ) ).

tff(addAssignment_32714,axiom,
    ! [VarCurr: state_type] :
      ( v55044(VarCurr,1)
    <=> v55061(VarCurr,1) ) ).

tff(addAssignment_32713,axiom,
    ! [VarCurr: state_type] :
      ( v55054(VarCurr,1)
    <=> v55056(VarCurr,1) ) ).

tff(addAssignment_32712,axiom,
    ! [VarCurr: state_type] :
      ( v55056(VarCurr,1)
    <=> v6069(VarCurr,89) ) ).

tff(addAssignment_32711,axiom,
    ! [VarCurr: state_type] :
      ( v55046(VarCurr,1)
    <=> v55048(VarCurr,1) ) ).

tff(addAssignment_32710,axiom,
    ! [VarCurr: state_type] :
      ( v55048(VarCurr,1)
    <=> v6069(VarCurr,93) ) ).

tff(addAssignment_32709,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,93)
    <=> v53148(VarCurr,29) ) ).

tff(addAssignment_32708,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,29)
    <=> v53150(VarCurr,29) ) ).

tff(addAssignment_32707,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,29)
    <=> v53242(VarCurr,29) ) ).

tff(addAssignment_32706,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,29)
    <=> v53160(VarCurr,29) ) ).

tff(addAssignment_32705,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,29)
    <=> v6098(VarCurr,93) ) ).

tff(addAssignment_32704,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,93)
    <=> v6100(VarCurr,93) ) ).

tff(addAssignment_32703,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,93)
    <=> v6102(VarCurr,93) ) ).

tff(addAssignment_32702,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,93)
    <=> v53162(VarCurr,29) ) ).

tff(addAssignment_32701,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,29)
    <=> v53164(VarCurr,29) ) ).

tff(addAssignment_32700,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,29)
    <=> v53225(VarCurr,29) ) ).

tff(addAssignment_32699,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,29)
    <=> v53223(VarCurr,29) ) ).

tff(addAssignment_32698,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,29)
    <=> v53224(VarCurr,29) ) ).

tff(addAssignment_32697,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,29)
    <=> v53215(VarCurr,29) ) ).

tff(addAssignment_32696,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,29)
    <=> v53219(VarCurr,29) ) ).

tff(addAssignment_32695,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,21)
    <=> v53218(VarCurr,21) ) ).

tff(addAssignment_32694,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,39)
    <=> v6238(VarCurr,39) ) ).

tff(addAssignment_32693,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,39)
    <=> v6240(VarCurr,39) ) ).

tff(addAssignment_32692,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,39)
    <=> v35449(VarCurr,3) ) ).

tff(addAssignment_32691,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,29)
    <=> v53211(VarCurr,29) ) ).

tff(addAssignment_32690,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,29)
    <=> $false ) ).

tff(addAssignment_32689,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,29)
    <=> v53154(VarCurr,29) ) ).

tff(addAssignment_32688,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,29)
    <=> v53155(VarCurr,29) ) ).

tff(addAssignment_32687,axiom,
    ! [VarCurr: state_type] :
      ( v55914(VarCurr)
    <=> v55916(VarCurr) ) ).

tff(addAssignment_32686,axiom,
    ! [VarCurr: state_type] :
      ( v55916(VarCurr)
    <=> v6017(VarCurr,85) ) ).

tff(addAssignment_32685,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,85)
    <=> v53103(VarCurr,21) ) ).

tff(addAssignment_32684,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,21)
    <=> v53105(VarCurr,21) ) ).

tff(addAssignment_32683,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,21)
    <=> v53107(VarCurr,21) ) ).

tff(addAssignment_32682,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,21)
    <=> v53109(VarCurr,21) ) ).

tff(addAssignment_32681,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,21)
    <=> v6027(VarCurr,85) ) ).

tff(addAssignment_32680,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,85)
    <=> v52434(VarCurr,85) ) ).

tff(addAssignment_32679,axiom,
    ! [VarCurr: state_type] :
      ( v52445(VarCurr,1)
    <=> v53112(VarCurr,21) ) ).

tff(addAssignment_32678,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,21)
    <=> v53114(VarCurr,21) ) ).

tff(addAssignment_32677,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,21)
    <=> v55918(VarNext,21) ) ).

tff(addCaseBooleanConditionEqualRanges1_727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55919(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55918(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_727,axiom,
    ! [VarNext: state_type] :
      ( v55919(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55918(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55919(VarNext)
      <=> v55920(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55920(VarNext)
      <=> ( v55922(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55922(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32676,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,21)
    <=> v53138(VarCurr,21) ) ).

tff(addAssignment_32675,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,21)
    <=> v6059(VarCurr,85) ) ).

tff(addAssignment_32674,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,85)
    <=> v55002(VarCurr,1) ) ).

tff(addAssignment_32673,axiom,
    ! [VarCurr: state_type] :
      ( v55002(VarCurr,1)
    <=> v55004(VarCurr,1) ) ).

tff(addAssignment_32672,axiom,
    ! [VarCurr: state_type] :
      ( v55004(VarCurr,1)
    <=> v55021(VarCurr,1) ) ).

tff(addAssignment_32671,axiom,
    ! [VarCurr: state_type] :
      ( v55014(VarCurr,1)
    <=> v55016(VarCurr,1) ) ).

tff(addAssignment_32670,axiom,
    ! [VarCurr: state_type] :
      ( v55016(VarCurr,1)
    <=> v6069(VarCurr,85) ) ).

tff(addAssignment_32669,axiom,
    ! [VarCurr: state_type] :
      ( v55006(VarCurr,1)
    <=> v55008(VarCurr,1) ) ).

tff(addAssignment_32668,axiom,
    ! [VarCurr: state_type] :
      ( v55008(VarCurr,1)
    <=> v6069(VarCurr,89) ) ).

tff(addAssignment_32667,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,89)
    <=> v53148(VarCurr,25) ) ).

tff(addAssignment_32666,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,25)
    <=> v53150(VarCurr,25) ) ).

tff(addAssignment_32665,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,25)
    <=> v53242(VarCurr,25) ) ).

tff(addAssignment_32664,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,25)
    <=> v53160(VarCurr,25) ) ).

tff(addAssignment_32663,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,25)
    <=> v6098(VarCurr,89) ) ).

tff(addAssignment_32662,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,89)
    <=> v6100(VarCurr,89) ) ).

tff(addAssignment_32661,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,89)
    <=> v6102(VarCurr,89) ) ).

tff(addAssignment_32660,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,89)
    <=> v53162(VarCurr,25) ) ).

tff(addAssignment_32659,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,25)
    <=> v53164(VarCurr,25) ) ).

tff(addAssignment_32658,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,25)
    <=> v53225(VarCurr,25) ) ).

tff(addAssignment_32657,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,25)
    <=> v53223(VarCurr,25) ) ).

tff(addAssignment_32656,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,25)
    <=> v53224(VarCurr,25) ) ).

tff(addAssignment_32655,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,25)
    <=> v53215(VarCurr,25) ) ).

tff(addAssignment_32654,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,25)
    <=> v53219(VarCurr,25) ) ).

tff(addAssignment_32653,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,17)
    <=> v53218(VarCurr,17) ) ).

tff(addAssignment_32652,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,29)
    <=> v6238(VarCurr,29) ) ).

tff(addAssignment_32651,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,25)
    <=> v53211(VarCurr,25) ) ).

tff(addAssignment_32650,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,25)
    <=> $false ) ).

tff(addAssignment_32649,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,25)
    <=> v53154(VarCurr,25) ) ).

tff(addAssignment_32648,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,25)
    <=> v53155(VarCurr,25) ) ).

tff(addAssignment_32647,axiom,
    ! [VarCurr: state_type] :
      ( v55856(VarCurr)
    <=> v55858(VarCurr) ) ).

tff(addAssignment_32646,axiom,
    ! [VarCurr: state_type] :
      ( v55858(VarCurr)
    <=> v55860(VarCurr) ) ).

tff(addAssignment_32645,axiom,
    ! [VarCurr: state_type] :
      ( v55860(VarCurr)
    <=> v55862(VarCurr) ) ).

tff(addAssignment_32644,axiom,
    ! [VarCurr: state_type] :
      ( v55862(VarCurr)
    <=> v55864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5260,axiom,
    ! [VarCurr: state_type] :
      ( v55864(VarCurr)
    <=> ( v55902(VarCurr)
      <~> v55890(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5259,axiom,
    ! [VarCurr: state_type] :
      ( v55902(VarCurr)
    <=> ( v55866(VarCurr)
      <~> v55878(VarCurr) ) ) ).

tff(addAssignment_32643,axiom,
    ! [VarCurr: state_type] :
      ( v55890(VarCurr)
    <=> v55892(VarCurr) ) ).

tff(addAssignment_32642,axiom,
    ! [VarCurr: state_type] :
      ( v55892(VarCurr)
    <=> v6017(VarCurr,81) ) ).

tff(addAssignment_32641,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,81)
    <=> v53103(VarCurr,17) ) ).

tff(addAssignment_32640,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,17)
    <=> v53105(VarCurr,17) ) ).

tff(addAssignment_32639,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,17)
    <=> v53107(VarCurr,17) ) ).

tff(addAssignment_32638,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,17)
    <=> v53109(VarCurr,17) ) ).

tff(addAssignment_32637,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,17)
    <=> v6027(VarCurr,81) ) ).

tff(addAssignment_32636,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,81)
    <=> v52434(VarCurr,81) ) ).

tff(addAssignment_32635,axiom,
    ! [VarCurr: state_type] :
      ( v52446(VarCurr,1)
    <=> v53112(VarCurr,17) ) ).

tff(addAssignment_32634,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,17)
    <=> v53114(VarCurr,17) ) ).

tff(addAssignment_32633,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,17)
    <=> v55894(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55895(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55894(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_726,axiom,
    ! [VarNext: state_type] :
      ( v55895(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55894(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55895(VarNext)
      <=> v55896(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55896(VarNext)
      <=> ( v55898(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55898(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32632,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,17)
    <=> v53138(VarCurr,17) ) ).

tff(addAssignment_32631,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,17)
    <=> v6059(VarCurr,81) ) ).

tff(addAssignment_32630,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,81)
    <=> v54950(VarCurr,1) ) ).

tff(addAssignment_32629,axiom,
    ! [VarCurr: state_type] :
      ( v54950(VarCurr,1)
    <=> v54952(VarCurr,1) ) ).

tff(addAssignment_32628,axiom,
    ! [VarCurr: state_type] :
      ( v54952(VarCurr,1)
    <=> v54969(VarCurr,1) ) ).

tff(addAssignment_32627,axiom,
    ! [VarCurr: state_type] :
      ( v54962(VarCurr,1)
    <=> v54964(VarCurr,1) ) ).

tff(addAssignment_32626,axiom,
    ! [VarCurr: state_type] :
      ( v54964(VarCurr,1)
    <=> v6069(VarCurr,81) ) ).

tff(addAssignment_32625,axiom,
    ! [VarCurr: state_type] :
      ( v54954(VarCurr,1)
    <=> v54956(VarCurr,1) ) ).

tff(addAssignment_32624,axiom,
    ! [VarCurr: state_type] :
      ( v54956(VarCurr,1)
    <=> v6069(VarCurr,85) ) ).

tff(addAssignment_32623,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,85)
    <=> v53148(VarCurr,21) ) ).

tff(addAssignment_32622,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,21)
    <=> v53150(VarCurr,21) ) ).

tff(addAssignment_32621,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,21)
    <=> v53242(VarCurr,21) ) ).

tff(addAssignment_32620,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,21)
    <=> v53160(VarCurr,21) ) ).

tff(addAssignment_32619,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,21)
    <=> v6098(VarCurr,85) ) ).

tff(addAssignment_32618,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,85)
    <=> v6100(VarCurr,85) ) ).

tff(addAssignment_32617,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,85)
    <=> v6102(VarCurr,85) ) ).

tff(addAssignment_32616,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,85)
    <=> v53162(VarCurr,21) ) ).

tff(addAssignment_32615,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,21)
    <=> v53164(VarCurr,21) ) ).

tff(addAssignment_32614,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,21)
    <=> v53225(VarCurr,21) ) ).

tff(addAssignment_32613,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,21)
    <=> v53223(VarCurr,21) ) ).

tff(addAssignment_32612,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,21)
    <=> v53224(VarCurr,21) ) ).

tff(addAssignment_32611,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,21)
    <=> v53215(VarCurr,21) ) ).

tff(addAssignment_32610,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,21)
    <=> v53219(VarCurr,21) ) ).

tff(addAssignment_32609,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,13)
    <=> v53218(VarCurr,13) ) ).

tff(addAssignment_32608,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,25)
    <=> v6238(VarCurr,25) ) ).

tff(addAssignment_32607,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,21)
    <=> v53211(VarCurr,21) ) ).

tff(addAssignment_32606,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,21)
    <=> $false ) ).

tff(addAssignment_32605,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,21)
    <=> v53154(VarCurr,21) ) ).

tff(addAssignment_32604,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,21)
    <=> v53155(VarCurr,21) ) ).

tff(addAssignment_32603,axiom,
    ! [VarCurr: state_type] :
      ( v55878(VarCurr)
    <=> v55880(VarCurr) ) ).

tff(addAssignment_32602,axiom,
    ! [VarCurr: state_type] :
      ( v55880(VarCurr)
    <=> v6017(VarCurr,77) ) ).

tff(addAssignment_32601,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,77)
    <=> v53103(VarCurr,13) ) ).

tff(addAssignment_32600,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,13)
    <=> v53105(VarCurr,13) ) ).

tff(addAssignment_32599,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,13)
    <=> v53107(VarCurr,13) ) ).

tff(addAssignment_32598,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,13)
    <=> v53109(VarCurr,13) ) ).

tff(addAssignment_32597,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,13)
    <=> v6027(VarCurr,77) ) ).

tff(addAssignment_32596,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,77)
    <=> v52434(VarCurr,77) ) ).

tff(addAssignment_32595,axiom,
    ! [VarCurr: state_type] :
      ( v52447(VarCurr,1)
    <=> v53112(VarCurr,13) ) ).

tff(addAssignment_32594,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,13)
    <=> v53114(VarCurr,13) ) ).

tff(addAssignment_32593,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,13)
    <=> v55882(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55883(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55882(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_725,axiom,
    ! [VarNext: state_type] :
      ( v55883(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55882(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55883(VarNext)
      <=> v55884(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55884(VarNext)
      <=> ( v55886(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55886(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32592,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,13)
    <=> v53138(VarCurr,13) ) ).

tff(addAssignment_32591,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,13)
    <=> v6059(VarCurr,77) ) ).

tff(addAssignment_32590,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,77)
    <=> v54910(VarCurr,1) ) ).

tff(addAssignment_32589,axiom,
    ! [VarCurr: state_type] :
      ( v54910(VarCurr,1)
    <=> v54912(VarCurr,1) ) ).

tff(addAssignment_32588,axiom,
    ! [VarCurr: state_type] :
      ( v54912(VarCurr,1)
    <=> v54929(VarCurr,1) ) ).

tff(addAssignment_32587,axiom,
    ! [VarCurr: state_type] :
      ( v54922(VarCurr,1)
    <=> v54924(VarCurr,1) ) ).

tff(addAssignment_32586,axiom,
    ! [VarCurr: state_type] :
      ( v54924(VarCurr,1)
    <=> v6069(VarCurr,77) ) ).

tff(addAssignment_32585,axiom,
    ! [VarCurr: state_type] :
      ( v54914(VarCurr,1)
    <=> v54916(VarCurr,1) ) ).

tff(addAssignment_32584,axiom,
    ! [VarCurr: state_type] :
      ( v54916(VarCurr,1)
    <=> v6069(VarCurr,81) ) ).

tff(addAssignment_32583,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,81)
    <=> v53148(VarCurr,17) ) ).

tff(addAssignment_32582,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,17)
    <=> v53150(VarCurr,17) ) ).

tff(addAssignment_32581,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,17)
    <=> v53242(VarCurr,17) ) ).

tff(addAssignment_32580,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,17)
    <=> v53160(VarCurr,17) ) ).

tff(addAssignment_32579,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,17)
    <=> v6098(VarCurr,81) ) ).

tff(addAssignment_32578,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,81)
    <=> v6100(VarCurr,81) ) ).

tff(addAssignment_32577,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,81)
    <=> v6102(VarCurr,81) ) ).

tff(addAssignment_32576,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,81)
    <=> v53162(VarCurr,17) ) ).

tff(addAssignment_32575,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,17)
    <=> v53164(VarCurr,17) ) ).

tff(addAssignment_32574,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,17)
    <=> v53225(VarCurr,17) ) ).

tff(addAssignment_32573,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,17)
    <=> v53223(VarCurr,17) ) ).

tff(addAssignment_32572,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,17)
    <=> v53224(VarCurr,17) ) ).

tff(addAssignment_32571,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,17)
    <=> v53215(VarCurr,17) ) ).

tff(addAssignment_32570,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,17)
    <=> v53219(VarCurr,17) ) ).

tff(addAssignment_32569,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,9)
    <=> v53218(VarCurr,9) ) ).

tff(addAssignment_32568,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,15)
    <=> v6238(VarCurr,15) ) ).

tff(addAssignment_32567,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,17)
    <=> v53211(VarCurr,17) ) ).

tff(addAssignment_32566,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,17)
    <=> $false ) ).

tff(addAssignment_32565,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,17)
    <=> v53154(VarCurr,17) ) ).

tff(addAssignment_32564,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,17)
    <=> v53155(VarCurr,17) ) ).

tff(addAssignment_32563,axiom,
    ! [VarCurr: state_type] :
      ( v55866(VarCurr)
    <=> v55868(VarCurr) ) ).

tff(addAssignment_32562,axiom,
    ! [VarCurr: state_type] :
      ( v55868(VarCurr)
    <=> v6017(VarCurr,73) ) ).

tff(addAssignment_32561,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,73)
    <=> v53103(VarCurr,9) ) ).

tff(addAssignment_32560,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,9)
    <=> v53105(VarCurr,9) ) ).

tff(addAssignment_32559,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,9)
    <=> v53107(VarCurr,9) ) ).

tff(addAssignment_32558,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,9)
    <=> v53109(VarCurr,9) ) ).

tff(addAssignment_32557,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,9)
    <=> v6027(VarCurr,73) ) ).

tff(addAssignment_32556,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,73)
    <=> v52434(VarCurr,73) ) ).

tff(addAssignment_32555,axiom,
    ! [VarCurr: state_type] :
      ( v52448(VarCurr,1)
    <=> v53112(VarCurr,9) ) ).

tff(addAssignment_32554,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,9)
    <=> v53114(VarCurr,9) ) ).

tff(addAssignment_32553,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,9)
    <=> v55870(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55871(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55870(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_724,axiom,
    ! [VarNext: state_type] :
      ( v55871(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55870(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55871(VarNext)
      <=> v55872(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55872(VarNext)
      <=> ( v55874(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55874(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32552,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,9)
    <=> v53138(VarCurr,9) ) ).

tff(addAssignment_32551,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,9)
    <=> v6059(VarCurr,73) ) ).

tff(addAssignment_32550,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,73)
    <=> v54870(VarCurr,1) ) ).

tff(addAssignment_32549,axiom,
    ! [VarCurr: state_type] :
      ( v54870(VarCurr,1)
    <=> v54872(VarCurr,1) ) ).

tff(addAssignment_32548,axiom,
    ! [VarCurr: state_type] :
      ( v54872(VarCurr,1)
    <=> v54889(VarCurr,1) ) ).

tff(addAssignment_32547,axiom,
    ! [VarCurr: state_type] :
      ( v54882(VarCurr,1)
    <=> v54884(VarCurr,1) ) ).

tff(addAssignment_32546,axiom,
    ! [VarCurr: state_type] :
      ( v54884(VarCurr,1)
    <=> v6069(VarCurr,73) ) ).

tff(addAssignment_32545,axiom,
    ! [VarCurr: state_type] :
      ( v54874(VarCurr,1)
    <=> v54876(VarCurr,1) ) ).

tff(addAssignment_32544,axiom,
    ! [VarCurr: state_type] :
      ( v54876(VarCurr,1)
    <=> v6069(VarCurr,77) ) ).

tff(addAssignment_32543,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,77)
    <=> v53148(VarCurr,13) ) ).

tff(addAssignment_32542,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,13)
    <=> v53150(VarCurr,13) ) ).

tff(addAssignment_32541,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,13)
    <=> v53242(VarCurr,13) ) ).

tff(addAssignment_32540,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,13)
    <=> v53160(VarCurr,13) ) ).

tff(addAssignment_32539,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,13)
    <=> v6098(VarCurr,77) ) ).

tff(addAssignment_32538,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,77)
    <=> v6100(VarCurr,77) ) ).

tff(addAssignment_32537,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,77)
    <=> v6102(VarCurr,77) ) ).

tff(addAssignment_32536,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,77)
    <=> v53162(VarCurr,13) ) ).

tff(addAssignment_32535,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,13)
    <=> v53164(VarCurr,13) ) ).

tff(addAssignment_32534,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,13)
    <=> v53225(VarCurr,13) ) ).

tff(addAssignment_32533,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,13)
    <=> v53223(VarCurr,13) ) ).

tff(addAssignment_32532,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,13)
    <=> v53224(VarCurr,13) ) ).

tff(addAssignment_32531,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,13)
    <=> v53215(VarCurr,13) ) ).

tff(addAssignment_32530,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,13)
    <=> v53219(VarCurr,13) ) ).

tff(addAssignment_32529,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,5)
    <=> v53218(VarCurr,5) ) ).

tff(addAssignment_32528,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,5)
    <=> v6238(VarCurr,5) ) ).

tff(addAssignment_32527,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,13)
    <=> v53211(VarCurr,13) ) ).

tff(addAssignment_32526,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_32525,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,13)
    <=> v53154(VarCurr,13) ) ).

tff(addAssignment_32524,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,13)
    <=> v53155(VarCurr,13) ) ).

tff(addAssignment_32523,axiom,
    ! [VarCurr: state_type] :
      ( v55808(VarCurr)
    <=> v55810(VarCurr) ) ).

tff(addAssignment_32522,axiom,
    ! [VarCurr: state_type] :
      ( v55810(VarCurr)
    <=> v55812(VarCurr) ) ).

tff(addAssignment_32521,axiom,
    ! [VarCurr: state_type] :
      ( v55812(VarCurr)
    <=> v55814(VarCurr) ) ).

tff(addAssignment_32520,axiom,
    ! [VarCurr: state_type] :
      ( v55814(VarCurr)
    <=> v55816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5252,axiom,
    ! [VarCurr: state_type] :
      ( v55816(VarCurr)
    <=> ( v55854(VarCurr)
      <~> v55842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5251,axiom,
    ! [VarCurr: state_type] :
      ( v55854(VarCurr)
    <=> ( v55818(VarCurr)
      <~> v55830(VarCurr) ) ) ).

tff(addAssignment_32519,axiom,
    ! [VarCurr: state_type] :
      ( v55842(VarCurr)
    <=> v55844(VarCurr) ) ).

tff(addAssignment_32518,axiom,
    ! [VarCurr: state_type] :
      ( v55844(VarCurr)
    <=> v6017(VarCurr,69) ) ).

tff(addAssignment_32517,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,69)
    <=> v53103(VarCurr,5) ) ).

tff(addAssignment_32516,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,5)
    <=> v53105(VarCurr,5) ) ).

tff(addAssignment_32515,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,5)
    <=> v53107(VarCurr,5) ) ).

tff(addAssignment_32514,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,5)
    <=> v53109(VarCurr,5) ) ).

tff(addAssignment_32513,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,5)
    <=> v6027(VarCurr,69) ) ).

tff(addAssignment_32512,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,69)
    <=> v52434(VarCurr,69) ) ).

tff(addAssignment_32511,axiom,
    ! [VarCurr: state_type] :
      ( v52449(VarCurr,1)
    <=> v53112(VarCurr,5) ) ).

tff(addAssignment_32510,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,5)
    <=> v53114(VarCurr,5) ) ).

tff(addAssignment_32509,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,5)
    <=> v55846(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55847(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55846(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_723,axiom,
    ! [VarNext: state_type] :
      ( v55847(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55846(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55847(VarNext)
      <=> v55848(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55848(VarNext)
      <=> ( v55850(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55850(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32508,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,5)
    <=> v53138(VarCurr,5) ) ).

tff(addAssignment_32507,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,5)
    <=> v6059(VarCurr,69) ) ).

tff(addAssignment_32506,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,69)
    <=> v54818(VarCurr,1) ) ).

tff(addAssignment_32505,axiom,
    ! [VarCurr: state_type] :
      ( v54818(VarCurr,1)
    <=> v54820(VarCurr,1) ) ).

tff(addAssignment_32504,axiom,
    ! [VarCurr: state_type] :
      ( v54820(VarCurr,1)
    <=> v54837(VarCurr,1) ) ).

tff(addAssignment_32503,axiom,
    ! [VarCurr: state_type] :
      ( v54830(VarCurr,1)
    <=> v54832(VarCurr,1) ) ).

tff(addAssignment_32502,axiom,
    ! [VarCurr: state_type] :
      ( v54832(VarCurr,1)
    <=> v6069(VarCurr,69) ) ).

tff(addAssignment_32501,axiom,
    ! [VarCurr: state_type] :
      ( v54822(VarCurr,1)
    <=> v54824(VarCurr,1) ) ).

tff(addAssignment_32500,axiom,
    ! [VarCurr: state_type] :
      ( v54824(VarCurr,1)
    <=> v6069(VarCurr,73) ) ).

tff(addAssignment_32499,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,73)
    <=> v53148(VarCurr,9) ) ).

tff(addAssignment_32498,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,9)
    <=> v53150(VarCurr,9) ) ).

tff(addAssignment_32497,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,9)
    <=> v53242(VarCurr,9) ) ).

tff(addAssignment_32496,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,9)
    <=> v53160(VarCurr,9) ) ).

tff(addAssignment_32495,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,9)
    <=> v6098(VarCurr,73) ) ).

tff(addAssignment_32494,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,73)
    <=> v6100(VarCurr,73) ) ).

tff(addAssignment_32493,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,73)
    <=> v6102(VarCurr,73) ) ).

tff(addAssignment_32492,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,73)
    <=> v53162(VarCurr,9) ) ).

tff(addAssignment_32491,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,9)
    <=> v53164(VarCurr,9) ) ).

tff(addAssignment_32490,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,9)
    <=> v53225(VarCurr,9) ) ).

tff(addAssignment_32489,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,9)
    <=> v53223(VarCurr,9) ) ).

tff(addAssignment_32488,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,9)
    <=> v53224(VarCurr,9) ) ).

tff(addAssignment_32487,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,9)
    <=> v53215(VarCurr,9) ) ).

tff(addAssignment_32486,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,9)
    <=> v53219(VarCurr,9) ) ).

tff(addAssignment_32485,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,1)
    <=> v53218(VarCurr,1) ) ).

tff(addAssignment_32484,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,1)
    <=> v6238(VarCurr,1) ) ).

tff(addAssignment_32483,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,9)
    <=> v53211(VarCurr,9) ) ).

tff(addAssignment_32482,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_32481,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,9)
    <=> v53154(VarCurr,9) ) ).

tff(addAssignment_32480,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,9)
    <=> v53155(VarCurr,9) ) ).

tff(addAssignment_32479,axiom,
    ! [VarCurr: state_type] :
      ( v55830(VarCurr)
    <=> v55832(VarCurr) ) ).

tff(addAssignment_32478,axiom,
    ! [VarCurr: state_type] :
      ( v55832(VarCurr)
    <=> v6017(VarCurr,65) ) ).

tff(addAssignment_32477,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,65)
    <=> v53103(VarCurr,1) ) ).

tff(addAssignment_32476,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,1)
    <=> v53105(VarCurr,1) ) ).

tff(addAssignment_32475,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,1)
    <=> v53107(VarCurr,1) ) ).

tff(addAssignment_32474,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,1)
    <=> v53109(VarCurr,1) ) ).

tff(addAssignment_32473,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,1)
    <=> v6027(VarCurr,65) ) ).

tff(addAssignment_32472,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,65)
    <=> v52434(VarCurr,65) ) ).

tff(addAssignment_32471,axiom,
    ! [VarCurr: state_type] :
      ( v52450(VarCurr,1)
    <=> v53112(VarCurr,1) ) ).

tff(addAssignment_32470,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,1)
    <=> v53114(VarCurr,1) ) ).

tff(addAssignment_32469,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,1)
    <=> v55834(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55835(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55834(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_722,axiom,
    ! [VarNext: state_type] :
      ( v55835(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55834(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55835(VarNext)
      <=> v55836(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55836(VarNext)
      <=> ( v55838(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55838(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32468,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,1)
    <=> v53138(VarCurr,1) ) ).

tff(addAssignment_32467,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,1)
    <=> v6059(VarCurr,65) ) ).

tff(addAssignment_32466,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,65)
    <=> v54778(VarCurr,1) ) ).

tff(addAssignment_32465,axiom,
    ! [VarCurr: state_type] :
      ( v54778(VarCurr,1)
    <=> v54780(VarCurr,1) ) ).

tff(addAssignment_32464,axiom,
    ! [VarCurr: state_type] :
      ( v54780(VarCurr,1)
    <=> v54797(VarCurr,1) ) ).

tff(addAssignment_32463,axiom,
    ! [VarCurr: state_type] :
      ( v54790(VarCurr,1)
    <=> v54792(VarCurr,1) ) ).

tff(addAssignment_32462,axiom,
    ! [VarCurr: state_type] :
      ( v54792(VarCurr,1)
    <=> v6069(VarCurr,65) ) ).

tff(addAssignment_32461,axiom,
    ! [VarCurr: state_type] :
      ( v54782(VarCurr,1)
    <=> v54784(VarCurr,1) ) ).

tff(addAssignment_32460,axiom,
    ! [VarCurr: state_type] :
      ( v54784(VarCurr,1)
    <=> v6069(VarCurr,69) ) ).

tff(addAssignment_32459,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,69)
    <=> v53148(VarCurr,5) ) ).

tff(addAssignment_32458,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,5)
    <=> v53150(VarCurr,5) ) ).

tff(addAssignment_32457,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,5)
    <=> v53242(VarCurr,5) ) ).

tff(addAssignment_32456,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,5)
    <=> v53160(VarCurr,5) ) ).

tff(addAssignment_32455,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,5)
    <=> v6098(VarCurr,69) ) ).

tff(addAssignment_32454,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,69)
    <=> v6100(VarCurr,69) ) ).

tff(addAssignment_32453,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,69)
    <=> v6102(VarCurr,69) ) ).

tff(addAssignment_32452,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,69)
    <=> v53162(VarCurr,5) ) ).

tff(addAssignment_32451,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,5)
    <=> v53164(VarCurr,5) ) ).

tff(addAssignment_32450,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,5)
    <=> v53225(VarCurr,5) ) ).

tff(addAssignment_32449,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,5)
    <=> v53223(VarCurr,5) ) ).

tff(addAssignment_32448,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,5)
    <=> v53224(VarCurr,5) ) ).

tff(addAssignment_32447,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,69)
    <=> v52335(VarCurr,69) ) ).

tff(addAssignment_32446,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,135)
    <=> v33839(VarCurr,135) ) ).

tff(addAssignment_32445,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,135)
    <=> v33841(VarCurr,135) ) ).

tff(addAssignment_32444,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,135)
    <=> v26555(VarCurr,3) ) ).

tff(addAssignment_32443,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,5)
    <=> v53215(VarCurr,5) ) ).

tff(addAssignment_32442,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,5)
    <=> v53219(VarCurr,5) ) ).

tff(addAssignment_32441,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,69)
    <=> v52325(VarCurr,69) ) ).

tff(addAssignment_32440,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,141)
    <=> v6238(VarCurr,141) ) ).

tff(addAssignment_32439,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,141)
    <=> v6240(VarCurr,141) ) ).

tff(addAssignment_32438,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,141)
    <=> v47849(VarCurr,9) ) ).

tff(addAssignment_32437,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,5)
    <=> v53211(VarCurr,5) ) ).

tff(addAssignment_32436,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_32435,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,5)
    <=> v53154(VarCurr,5) ) ).

tff(addAssignment_32434,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,5)
    <=> v53155(VarCurr,5) ) ).

tff(addAssignment_32433,axiom,
    ! [VarCurr: state_type] :
      ( v55818(VarCurr)
    <=> v55820(VarCurr) ) ).

tff(addAssignment_32432,axiom,
    ! [VarCurr: state_type] :
      ( v55820(VarCurr)
    <=> v6017(VarCurr,61) ) ).

tff(addAssignment_32431,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,61)
    <=> v6019(VarCurr,61) ) ).

tff(addAssignment_32430,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,61)
    <=> v6021(VarCurr,61) ) ).

tff(addAssignment_32429,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,61)
    <=> v6023(VarCurr,61) ) ).

tff(addAssignment_32428,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,61)
    <=> v6025(VarCurr,61) ) ).

tff(addAssignment_32427,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,61)
    <=> v6027(VarCurr,61) ) ).

tff(addAssignment_32426,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,61)
    <=> v52434(VarCurr,61) ) ).

tff(addAssignment_32425,axiom,
    ! [VarCurr: state_type] :
      ( v52451(VarCurr,1)
    <=> v6031(VarCurr,61) ) ).

tff(addAssignment_32424,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,61)
    <=> v6033(VarCurr,61) ) ).

tff(addAssignment_32423,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,61)
    <=> v55822(VarNext,61) ) ).

tff(addCaseBooleanConditionEqualRanges1_721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55823(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55822(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_721,axiom,
    ! [VarNext: state_type] :
      ( v55823(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55822(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55823(VarNext)
      <=> v55824(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55824(VarNext)
      <=> ( v55826(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55826(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_32422,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,61)
    <=> v6057(VarCurr,61) ) ).

tff(addAssignment_32421,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,61)
    <=> v6059(VarCurr,61) ) ).

tff(addAssignment_32420,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,61)
    <=> v54738(VarCurr,1) ) ).

tff(addAssignment_32419,axiom,
    ! [VarCurr: state_type] :
      ( v54738(VarCurr,1)
    <=> v54740(VarCurr,1) ) ).

tff(addAssignment_32418,axiom,
    ! [VarCurr: state_type] :
      ( v54740(VarCurr,1)
    <=> v54757(VarCurr,1) ) ).

tff(addAssignment_32417,axiom,
    ! [VarCurr: state_type] :
      ( v54750(VarCurr,1)
    <=> v54752(VarCurr,1) ) ).

tff(addAssignment_32416,axiom,
    ! [VarCurr: state_type] :
      ( v54752(VarCurr,1)
    <=> v6069(VarCurr,61) ) ).

tff(addAssignment_32415,axiom,
    ! [VarCurr: state_type] :
      ( v54742(VarCurr,1)
    <=> v54744(VarCurr,1) ) ).

tff(addAssignment_32414,axiom,
    ! [VarCurr: state_type] :
      ( v54744(VarCurr,1)
    <=> v6069(VarCurr,65) ) ).

tff(addAssignment_32413,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,65)
    <=> v53148(VarCurr,1) ) ).

tff(addAssignment_32412,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,1)
    <=> v53150(VarCurr,1) ) ).

tff(addAssignment_32411,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,1)
    <=> v53242(VarCurr,1) ) ).

tff(addAssignment_32410,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,1)
    <=> v53160(VarCurr,1) ) ).

tff(addAssignment_32409,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,1)
    <=> v6098(VarCurr,65) ) ).

tff(addAssignment_32408,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,65)
    <=> v6100(VarCurr,65) ) ).

tff(addAssignment_32407,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,65)
    <=> v6102(VarCurr,65) ) ).

tff(addAssignment_32406,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,65)
    <=> v53162(VarCurr,1) ) ).

tff(addAssignment_32405,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,1)
    <=> v53164(VarCurr,1) ) ).

tff(addAssignment_32404,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,1)
    <=> v53225(VarCurr,1) ) ).

tff(addAssignment_32403,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,1)
    <=> v53223(VarCurr,1) ) ).

tff(addAssignment_32402,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,1)
    <=> v53224(VarCurr,1) ) ).

tff(addAssignment_32401,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,65)
    <=> v52335(VarCurr,65) ) ).

tff(addAssignment_32400,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,125)
    <=> v33839(VarCurr,125) ) ).

tff(addAssignment_32399,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,125)
    <=> v33841(VarCurr,125) ) ).

tff(addAssignment_32398,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,125)
    <=> v25005(VarCurr,5) ) ).

tff(addAssignment_32397,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,1)
    <=> v53215(VarCurr,1) ) ).

tff(addAssignment_32396,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,1)
    <=> v53219(VarCurr,1) ) ).

tff(addAssignment_32395,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,65)
    <=> v52325(VarCurr,65) ) ).

tff(addAssignment_32394,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,131)
    <=> v6238(VarCurr,131) ) ).

tff(addAssignment_32393,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,131)
    <=> v6240(VarCurr,131) ) ).

tff(addAssignment_32392,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,131)
    <=> v46299(VarCurr,11) ) ).

tff(addAssignment_32391,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,1)
    <=> v53211(VarCurr,1) ) ).

tff(addAssignment_32390,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_32389,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,1)
    <=> v53154(VarCurr,1) ) ).

tff(addAssignment_32388,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,1)
    <=> v53155(VarCurr,1) ) ).

tff(addAssignment_32387,axiom,
    ! [VarCurr: state_type] :
      ( v54692(VarCurr)
    <=> v54694(VarCurr) ) ).

tff(addAssignment_32386,axiom,
    ! [VarCurr: state_type] :
      ( v54694(VarCurr)
    <=> v54696(VarCurr) ) ).

tff(addAssignment_32385,axiom,
    ! [VarCurr: state_type] :
      ( v54696(VarCurr)
    <=> v54698(VarCurr) ) ).

tff(addAssignment_32384,axiom,
    ! [VarCurr: state_type] :
      ( v54698(VarCurr)
    <=> v54700(VarCurr) ) ).

tff(writeUnaryOperator_3100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v54700(VarCurr)
    <=> v55778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5244,axiom,
    ! [VarCurr: state_type] :
      ( v55778(VarCurr)
    <=> ( v54702(VarCurr)
        | v55468(VarCurr) ) ) ).

tff(addAssignment_32383,axiom,
    ! [VarCurr: state_type] :
      ( v55468(VarCurr)
    <=> v55470(VarCurr) ) ).

tff(addAssignment_32382,axiom,
    ! [VarCurr: state_type] :
      ( v55470(VarCurr)
    <=> v54706(VarCurr,2) ) ).

tff(addAssignment_32381,axiom,
    ! [VarCurr: state_type] :
      ( v54706(VarCurr,2)
    <=> v5977(VarCurr,6) ) ).

tff(addAssignment_32380,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,6)
    <=> v5979(VarCurr,6) ) ).

tff(addAssignment_32379,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,6)
    <=> v5981(VarCurr,6) ) ).

tff(addAssignment_32378,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,6)
    <=> v5983(VarCurr,6) ) ).

tff(addAssignment_32377,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,6)
    <=> v5985(VarCurr,6) ) ).

tff(addAssignment_32376,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,6)
    <=> v53672(VarCurr,6) ) ).

tff(addAssignment_32375,axiom,
    ! [VarCurr: state_type] :
      ( v53674(VarCurr,2)
    <=> v55472(VarCurr) ) ).

tff(addAssignment_32374,axiom,
    ! [VarCurr: state_type] :
      ( v55472(VarCurr)
    <=> v55474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5243,axiom,
    ! [VarCurr: state_type] :
      ( v55474(VarCurr)
    <=> ( v55776(VarCurr)
      <~> v55764(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5242,axiom,
    ! [VarCurr: state_type] :
      ( v55776(VarCurr)
    <=> ( v55476(VarCurr)
      <~> v55632(VarCurr) ) ) ).

tff(addAssignment_32373,axiom,
    ! [VarCurr: state_type] :
      ( v55764(VarCurr)
    <=> v55766(VarCurr) ) ).

tff(addAssignment_32372,axiom,
    ! [VarCurr: state_type] :
      ( v55766(VarCurr)
    <=> v55427(VarCurr,2) ) ).

tff(addAssignment_32371,axiom,
    ! [VarCurr: state_type] :
      ( v55427(VarCurr,2)
    <=> v55429(VarCurr,2) ) ).

tff(addAssignment_32370,axiom,
    ! [VarCurr: state_type] :
      ( v55429(VarCurr,2)
    <=> v53454(VarCurr,7) ) ).

tff(addAssignment_32369,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,7)
    <=> v53456(VarCurr,7) ) ).

tff(addAssignment_32368,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,7)
    <=> v55768(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55769(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v55768(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_720,axiom,
    ! [VarNext: state_type] :
      ( v55769(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v55768(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55769(VarNext)
      <=> v55770(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55770(VarNext)
      <=> ( v55772(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55772(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_32367,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,7)
    <=> v53480(VarCurr,7) ) ).

tff(addAssignment_32366,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,7)
    <=> v53525(VarCurr,7) ) ).

tff(addAssignment_32365,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,6)
    <=> v55431(VarCurr,2) ) ).

tff(addAssignment_32364,axiom,
    ! [VarCurr: state_type] :
      ( v55431(VarCurr,2)
    <=> v55433(VarCurr,2) ) ).

tff(addAssignment_32363,axiom,
    ! [VarCurr: state_type] :
      ( v55433(VarCurr,2)
    <=> v55450(VarCurr,2) ) ).

tff(addAssignment_32362,axiom,
    ! [VarCurr: state_type] :
      ( v55443(VarCurr,2)
    <=> v55445(VarCurr,2) ) ).

tff(addAssignment_32361,axiom,
    ! [VarCurr: state_type] :
      ( v55445(VarCurr,2)
    <=> v53312(VarCurr,6) ) ).

tff(addAssignment_32360,axiom,
    ! [VarCurr: state_type] :
      ( v55435(VarCurr,2)
    <=> v55437(VarCurr,2) ) ).

tff(addAssignment_32359,axiom,
    ! [VarCurr: state_type] :
      ( v55437(VarCurr,2)
    <=> v53312(VarCurr,2) ) ).

tff(addAssignment_32358,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,2)
    <=> v53314(VarCurr,2) ) ).

tff(addAssignment_32357,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,2)
    <=> v53316(VarCurr,2) ) ).

tff(addAssignment_32356,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,2)
    <=> v53407(VarCurr,2) ) ).

tff(addAssignment_32355,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,2)
    <=> v53326(VarCurr,2) ) ).

tff(addAssignment_32354,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,2)
    <=> v53328(VarCurr,2) ) ).

tff(addAssignment_32353,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,2)
    <=> v6100(VarCurr,130) ) ).

tff(addAssignment_32352,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,130)
    <=> v6102(VarCurr,130) ) ).

tff(addAssignment_32351,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,130)
    <=> v53330(VarCurr,2) ) ).

tff(addAssignment_32350,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,2)
    <=> v53332(VarCurr,2) ) ).

tff(addAssignment_32349,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,2)
    <=> v53390(VarCurr,2) ) ).

tff(addAssignment_32348,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,2)
    <=> v53387(VarCurr,2) ) ).

tff(addAssignment_32347,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,2)
    <=> v53217(VarCurr,58) ) ).

tff(addAssignment_32346,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,2)
    <=> v53383(VarCurr,2) ) ).

tff(addAssignment_32345,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,2)
    <=> v53217(VarCurr,58) ) ).

tff(addAssignment_32344,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,58)
    <=> v53218(VarCurr,58) ) ).

tff(addAssignment_32343,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,112)
    <=> v6238(VarCurr,112) ) ).

tff(addAssignment_32342,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,112)
    <=> v6240(VarCurr,112) ) ).

tff(addAssignment_32341,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,112)
    <=> v44749(VarCurr,4) ) ).

tff(addAssignment_32340,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,2)
    <=> v53379(VarCurr,2) ) ).

tff(addAssignment_32339,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_32338,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,2)
    <=> v53320(VarCurr,2) ) ).

tff(addAssignment_32337,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,2)
    <=> v53321(VarCurr,2) ) ).

tff(addAssignment_32336,axiom,
    ! [VarCurr: state_type] :
      ( v55632(VarCurr)
    <=> v55634(VarCurr) ) ).

tff(addAssignment_32335,axiom,
    ! [VarCurr: state_type] :
      ( v55634(VarCurr)
    <=> v55636(VarCurr) ) ).

tff(addAssignment_32334,axiom,
    ! [VarCurr: state_type] :
      ( v55636(VarCurr)
    <=> v55638(VarCurr) ) ).

tff(addAssignment_32333,axiom,
    ! [VarCurr: state_type] :
      ( v55638(VarCurr)
    <=> v55640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5239,axiom,
    ! [VarCurr: state_type] :
      ( v55640(VarCurr)
    <=> ( v55762(VarCurr)
      <~> v55738(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5238,axiom,
    ! [VarCurr: state_type] :
      ( v55762(VarCurr)
    <=> ( v55642(VarCurr)
      <~> v55690(VarCurr) ) ) ).

tff(addAssignment_32332,axiom,
    ! [VarCurr: state_type] :
      ( v55738(VarCurr)
    <=> v55740(VarCurr) ) ).

tff(addAssignment_32331,axiom,
    ! [VarCurr: state_type] :
      ( v55740(VarCurr)
    <=> v55742(VarCurr) ) ).

tff(addAssignment_32330,axiom,
    ! [VarCurr: state_type] :
      ( v55742(VarCurr)
    <=> v55744(VarCurr) ) ).

tff(addAssignment_32329,axiom,
    ! [VarCurr: state_type] :
      ( v55744(VarCurr)
    <=> v55746(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5237,axiom,
    ! [VarCurr: state_type] :
      ( v55746(VarCurr)
    <=> ( v55760(VarCurr)
      <~> v55756(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5236,axiom,
    ! [VarCurr: state_type] :
      ( v55760(VarCurr)
    <=> ( v55748(VarCurr)
      <~> v55752(VarCurr) ) ) ).

tff(addAssignment_32328,axiom,
    ! [VarCurr: state_type] :
      ( v55756(VarCurr)
    <=> v55758(VarCurr) ) ).

tff(addAssignment_32327,axiom,
    ! [VarCurr: state_type] :
      ( v55758(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_32326,axiom,
    ! [VarCurr: state_type] :
      ( v55752(VarCurr)
    <=> v55754(VarCurr) ) ).

tff(addAssignment_32325,axiom,
    ! [VarCurr: state_type] :
      ( v55754(VarCurr)
    <=> v6017(VarCurr,126) ) ).

tff(addAssignment_32324,axiom,
    ! [VarCurr: state_type] :
      ( v55748(VarCurr)
    <=> v55750(VarCurr) ) ).

tff(addAssignment_32323,axiom,
    ! [VarCurr: state_type] :
      ( v55750(VarCurr)
    <=> v6017(VarCurr,122) ) ).

tff(addAssignment_32322,axiom,
    ! [VarCurr: state_type] :
      ( v55690(VarCurr)
    <=> v55692(VarCurr) ) ).

tff(addAssignment_32321,axiom,
    ! [VarCurr: state_type] :
      ( v55692(VarCurr)
    <=> v55694(VarCurr) ) ).

tff(addAssignment_32320,axiom,
    ! [VarCurr: state_type] :
      ( v55694(VarCurr)
    <=> v55696(VarCurr) ) ).

tff(addAssignment_32319,axiom,
    ! [VarCurr: state_type] :
      ( v55696(VarCurr)
    <=> v55698(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5235,axiom,
    ! [VarCurr: state_type] :
      ( v55698(VarCurr)
    <=> ( v55736(VarCurr)
      <~> v55724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5234,axiom,
    ! [VarCurr: state_type] :
      ( v55736(VarCurr)
    <=> ( v55700(VarCurr)
      <~> v55712(VarCurr) ) ) ).

tff(addAssignment_32318,axiom,
    ! [VarCurr: state_type] :
      ( v55724(VarCurr)
    <=> v55726(VarCurr) ) ).

tff(addAssignment_32317,axiom,
    ! [VarCurr: state_type] :
      ( v55726(VarCurr)
    <=> v6017(VarCurr,118) ) ).

tff(addAssignment_32316,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,118)
    <=> v53103(VarCurr,54) ) ).

tff(addAssignment_32315,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,54)
    <=> v53105(VarCurr,54) ) ).

tff(addAssignment_32314,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,54)
    <=> v53107(VarCurr,54) ) ).

tff(addAssignment_32313,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,54)
    <=> v53109(VarCurr,54) ) ).

tff(addAssignment_32312,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,54)
    <=> v6027(VarCurr,118) ) ).

tff(addAssignment_32311,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,118)
    <=> v52434(VarCurr,118) ) ).

tff(addAssignment_32310,axiom,
    ! [VarCurr: state_type] :
      ( v52437(VarCurr,2)
    <=> v53112(VarCurr,54) ) ).

tff(addAssignment_32309,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,54)
    <=> v53114(VarCurr,54) ) ).

tff(addAssignment_32308,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,54)
    <=> v55728(VarNext,54) ) ).

tff(addCaseBooleanConditionEqualRanges1_719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55729(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55728(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_719,axiom,
    ! [VarNext: state_type] :
      ( v55729(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55728(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55729(VarNext)
      <=> v55730(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55730(VarNext)
      <=> ( v55732(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55732(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32307,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,54)
    <=> v53138(VarCurr,54) ) ).

tff(addAssignment_32306,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,54)
    <=> v6059(VarCurr,118) ) ).

tff(addAssignment_32305,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,118)
    <=> v55358(VarCurr,2) ) ).

tff(addAssignment_32304,axiom,
    ! [VarCurr: state_type] :
      ( v55358(VarCurr,2)
    <=> v55360(VarCurr,2) ) ).

tff(addAssignment_32303,axiom,
    ! [VarCurr: state_type] :
      ( v55360(VarCurr,2)
    <=> v55377(VarCurr,2) ) ).

tff(addAssignment_32302,axiom,
    ! [VarCurr: state_type] :
      ( v55370(VarCurr,2)
    <=> v55372(VarCurr,2) ) ).

tff(addAssignment_32301,axiom,
    ! [VarCurr: state_type] :
      ( v55372(VarCurr,2)
    <=> v6069(VarCurr,118) ) ).

tff(addAssignment_32300,axiom,
    ! [VarCurr: state_type] :
      ( v55362(VarCurr,2)
    <=> v55364(VarCurr,2) ) ).

tff(addAssignment_32299,axiom,
    ! [VarCurr: state_type] :
      ( v55364(VarCurr,2)
    <=> v6069(VarCurr,122) ) ).

tff(addAssignment_32298,axiom,
    ! [VarCurr: state_type] :
      ( v55712(VarCurr)
    <=> v55714(VarCurr) ) ).

tff(addAssignment_32297,axiom,
    ! [VarCurr: state_type] :
      ( v55714(VarCurr)
    <=> v6017(VarCurr,114) ) ).

tff(addAssignment_32296,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,114)
    <=> v53103(VarCurr,50) ) ).

tff(addAssignment_32295,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,50)
    <=> v53105(VarCurr,50) ) ).

tff(addAssignment_32294,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,50)
    <=> v53107(VarCurr,50) ) ).

tff(addAssignment_32293,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,50)
    <=> v53109(VarCurr,50) ) ).

tff(addAssignment_32292,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,50)
    <=> v6027(VarCurr,114) ) ).

tff(addAssignment_32291,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,114)
    <=> v52434(VarCurr,114) ) ).

tff(addAssignment_32290,axiom,
    ! [VarCurr: state_type] :
      ( v52438(VarCurr,2)
    <=> v53112(VarCurr,50) ) ).

tff(addAssignment_32289,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,50)
    <=> v53114(VarCurr,50) ) ).

tff(addAssignment_32288,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,50)
    <=> v55716(VarNext,50) ) ).

tff(addCaseBooleanConditionEqualRanges1_718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55717(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55716(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_718,axiom,
    ! [VarNext: state_type] :
      ( v55717(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55716(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55717(VarNext)
      <=> v55718(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55718(VarNext)
      <=> ( v55720(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55720(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32287,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,50)
    <=> v53138(VarCurr,50) ) ).

tff(addAssignment_32286,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,50)
    <=> v6059(VarCurr,114) ) ).

tff(addAssignment_32285,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,114)
    <=> v55318(VarCurr,2) ) ).

tff(addAssignment_32284,axiom,
    ! [VarCurr: state_type] :
      ( v55318(VarCurr,2)
    <=> v55320(VarCurr,2) ) ).

tff(addAssignment_32283,axiom,
    ! [VarCurr: state_type] :
      ( v55320(VarCurr,2)
    <=> v55337(VarCurr,2) ) ).

tff(addAssignment_32282,axiom,
    ! [VarCurr: state_type] :
      ( v55330(VarCurr,2)
    <=> v55332(VarCurr,2) ) ).

tff(addAssignment_32281,axiom,
    ! [VarCurr: state_type] :
      ( v55332(VarCurr,2)
    <=> v6069(VarCurr,114) ) ).

tff(addAssignment_32280,axiom,
    ! [VarCurr: state_type] :
      ( v55322(VarCurr,2)
    <=> v55324(VarCurr,2) ) ).

tff(addAssignment_32279,axiom,
    ! [VarCurr: state_type] :
      ( v55324(VarCurr,2)
    <=> v6069(VarCurr,118) ) ).

tff(addAssignment_32278,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,118)
    <=> v53148(VarCurr,54) ) ).

tff(addAssignment_32277,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,54)
    <=> v53150(VarCurr,54) ) ).

tff(addAssignment_32276,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,54)
    <=> v53242(VarCurr,54) ) ).

tff(addAssignment_32275,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,54)
    <=> v53160(VarCurr,54) ) ).

tff(addAssignment_32274,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,54)
    <=> v6098(VarCurr,118) ) ).

tff(addAssignment_32273,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,118)
    <=> v6100(VarCurr,118) ) ).

tff(addAssignment_32272,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,118)
    <=> v6102(VarCurr,118) ) ).

tff(addAssignment_32271,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,118)
    <=> v53162(VarCurr,54) ) ).

tff(addAssignment_32270,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,54)
    <=> v53164(VarCurr,54) ) ).

tff(addAssignment_32269,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,54)
    <=> v53225(VarCurr,54) ) ).

tff(addAssignment_32268,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,54)
    <=> v53223(VarCurr,54) ) ).

tff(addAssignment_32267,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,54)
    <=> v53224(VarCurr,54) ) ).

tff(addAssignment_32266,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,54)
    <=> v53215(VarCurr,54) ) ).

tff(addAssignment_32265,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,54)
    <=> v53219(VarCurr,54) ) ).

tff(addAssignment_32264,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,46)
    <=> v53218(VarCurr,46) ) ).

tff(addAssignment_32263,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,88)
    <=> v6238(VarCurr,88) ) ).

tff(addAssignment_32262,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,88)
    <=> v6240(VarCurr,88) ) ).

tff(addAssignment_32261,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,88)
    <=> v41649(VarCurr,4) ) ).

tff(addAssignment_32260,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,54)
    <=> v53211(VarCurr,54) ) ).

tff(addAssignment_32259,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,54)
    <=> $false ) ).

tff(addAssignment_32258,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,54)
    <=> v53154(VarCurr,54) ) ).

tff(addAssignment_32257,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,54)
    <=> v53155(VarCurr,54) ) ).

tff(addAssignment_32256,axiom,
    ! [VarCurr: state_type] :
      ( v55700(VarCurr)
    <=> v55702(VarCurr) ) ).

tff(addAssignment_32255,axiom,
    ! [VarCurr: state_type] :
      ( v55702(VarCurr)
    <=> v6017(VarCurr,110) ) ).

tff(addAssignment_32254,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,110)
    <=> v53103(VarCurr,46) ) ).

tff(addAssignment_32253,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,46)
    <=> v53105(VarCurr,46) ) ).

tff(addAssignment_32252,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,46)
    <=> v53107(VarCurr,46) ) ).

tff(addAssignment_32251,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,46)
    <=> v53109(VarCurr,46) ) ).

tff(addAssignment_32250,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,46)
    <=> v6027(VarCurr,110) ) ).

tff(addAssignment_32249,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,110)
    <=> v52434(VarCurr,110) ) ).

tff(addAssignment_32248,axiom,
    ! [VarCurr: state_type] :
      ( v52439(VarCurr,2)
    <=> v53112(VarCurr,46) ) ).

tff(addAssignment_32247,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,46)
    <=> v53114(VarCurr,46) ) ).

tff(addAssignment_32246,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,46)
    <=> v55704(VarNext,46) ) ).

tff(addCaseBooleanConditionEqualRanges1_717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55705(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55704(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_717,axiom,
    ! [VarNext: state_type] :
      ( v55705(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55704(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55705(VarNext)
      <=> v55706(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55706(VarNext)
      <=> ( v55708(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55708(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32245,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,46)
    <=> v53138(VarCurr,46) ) ).

tff(addAssignment_32244,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,46)
    <=> v6059(VarCurr,110) ) ).

tff(addAssignment_32243,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,110)
    <=> v55278(VarCurr,2) ) ).

tff(addAssignment_32242,axiom,
    ! [VarCurr: state_type] :
      ( v55278(VarCurr,2)
    <=> v55280(VarCurr,2) ) ).

tff(addAssignment_32241,axiom,
    ! [VarCurr: state_type] :
      ( v55280(VarCurr,2)
    <=> v55297(VarCurr,2) ) ).

tff(addAssignment_32240,axiom,
    ! [VarCurr: state_type] :
      ( v55290(VarCurr,2)
    <=> v55292(VarCurr,2) ) ).

tff(addAssignment_32239,axiom,
    ! [VarCurr: state_type] :
      ( v55292(VarCurr,2)
    <=> v6069(VarCurr,110) ) ).

tff(addAssignment_32238,axiom,
    ! [VarCurr: state_type] :
      ( v55282(VarCurr,2)
    <=> v55284(VarCurr,2) ) ).

tff(addAssignment_32237,axiom,
    ! [VarCurr: state_type] :
      ( v55284(VarCurr,2)
    <=> v6069(VarCurr,114) ) ).

tff(addAssignment_32236,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,114)
    <=> v53148(VarCurr,50) ) ).

tff(addAssignment_32235,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,50)
    <=> v53150(VarCurr,50) ) ).

tff(addAssignment_32234,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,50)
    <=> v53242(VarCurr,50) ) ).

tff(addAssignment_32233,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,50)
    <=> v53160(VarCurr,50) ) ).

tff(addAssignment_32232,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,50)
    <=> v6098(VarCurr,114) ) ).

tff(addAssignment_32231,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,114)
    <=> v6100(VarCurr,114) ) ).

tff(addAssignment_32230,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,114)
    <=> v6102(VarCurr,114) ) ).

tff(addAssignment_32229,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,114)
    <=> v53162(VarCurr,50) ) ).

tff(addAssignment_32228,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,50)
    <=> v53164(VarCurr,50) ) ).

tff(addAssignment_32227,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,50)
    <=> v53225(VarCurr,50) ) ).

tff(addAssignment_32226,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,50)
    <=> v53223(VarCurr,50) ) ).

tff(addAssignment_32225,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,50)
    <=> v53224(VarCurr,50) ) ).

tff(addAssignment_32224,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,50)
    <=> v53215(VarCurr,50) ) ).

tff(addAssignment_32223,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,50)
    <=> v53219(VarCurr,50) ) ).

tff(addAssignment_32222,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,42)
    <=> v53218(VarCurr,42) ) ).

tff(addAssignment_32221,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,84)
    <=> v6238(VarCurr,84) ) ).

tff(addAssignment_32220,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,84)
    <=> v6240(VarCurr,84) ) ).

tff(addAssignment_32219,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,84)
    <=> v41649(VarCurr,0) ) ).

tff(addAssignment_32218,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,50)
    <=> v53211(VarCurr,50) ) ).

tff(addAssignment_32217,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,50)
    <=> $false ) ).

tff(addAssignment_32216,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,50)
    <=> v53154(VarCurr,50) ) ).

tff(addAssignment_32215,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,50)
    <=> v53155(VarCurr,50) ) ).

tff(addAssignment_32214,axiom,
    ! [VarCurr: state_type] :
      ( v55642(VarCurr)
    <=> v55644(VarCurr) ) ).

tff(addAssignment_32213,axiom,
    ! [VarCurr: state_type] :
      ( v55644(VarCurr)
    <=> v55646(VarCurr) ) ).

tff(addAssignment_32212,axiom,
    ! [VarCurr: state_type] :
      ( v55646(VarCurr)
    <=> v55648(VarCurr) ) ).

tff(addAssignment_32211,axiom,
    ! [VarCurr: state_type] :
      ( v55648(VarCurr)
    <=> v55650(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5227,axiom,
    ! [VarCurr: state_type] :
      ( v55650(VarCurr)
    <=> ( v55688(VarCurr)
      <~> v55676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5226,axiom,
    ! [VarCurr: state_type] :
      ( v55688(VarCurr)
    <=> ( v55652(VarCurr)
      <~> v55664(VarCurr) ) ) ).

tff(addAssignment_32210,axiom,
    ! [VarCurr: state_type] :
      ( v55676(VarCurr)
    <=> v55678(VarCurr) ) ).

tff(addAssignment_32209,axiom,
    ! [VarCurr: state_type] :
      ( v55678(VarCurr)
    <=> v6017(VarCurr,106) ) ).

tff(addAssignment_32208,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,106)
    <=> v53103(VarCurr,42) ) ).

tff(addAssignment_32207,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,42)
    <=> v53105(VarCurr,42) ) ).

tff(addAssignment_32206,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,42)
    <=> v53107(VarCurr,42) ) ).

tff(addAssignment_32205,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,42)
    <=> v53109(VarCurr,42) ) ).

tff(addAssignment_32204,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,42)
    <=> v6027(VarCurr,106) ) ).

tff(addAssignment_32203,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,106)
    <=> v52434(VarCurr,106) ) ).

tff(addAssignment_32202,axiom,
    ! [VarCurr: state_type] :
      ( v52440(VarCurr,2)
    <=> v53112(VarCurr,42) ) ).

tff(addAssignment_32201,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,42)
    <=> v53114(VarCurr,42) ) ).

tff(addAssignment_32200,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,42)
    <=> v55680(VarNext,42) ) ).

tff(addCaseBooleanConditionEqualRanges1_716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55681(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55680(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_716,axiom,
    ! [VarNext: state_type] :
      ( v55681(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55680(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55681(VarNext)
      <=> v55682(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55682(VarNext)
      <=> ( v55684(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55684(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32199,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,42)
    <=> v53138(VarCurr,42) ) ).

tff(addAssignment_32198,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,42)
    <=> v6059(VarCurr,106) ) ).

tff(addAssignment_32197,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,106)
    <=> v55226(VarCurr,2) ) ).

tff(addAssignment_32196,axiom,
    ! [VarCurr: state_type] :
      ( v55226(VarCurr,2)
    <=> v55228(VarCurr,2) ) ).

tff(addAssignment_32195,axiom,
    ! [VarCurr: state_type] :
      ( v55228(VarCurr,2)
    <=> v55245(VarCurr,2) ) ).

tff(addAssignment_32194,axiom,
    ! [VarCurr: state_type] :
      ( v55238(VarCurr,2)
    <=> v55240(VarCurr,2) ) ).

tff(addAssignment_32193,axiom,
    ! [VarCurr: state_type] :
      ( v55240(VarCurr,2)
    <=> v6069(VarCurr,106) ) ).

tff(addAssignment_32192,axiom,
    ! [VarCurr: state_type] :
      ( v55230(VarCurr,2)
    <=> v55232(VarCurr,2) ) ).

tff(addAssignment_32191,axiom,
    ! [VarCurr: state_type] :
      ( v55232(VarCurr,2)
    <=> v6069(VarCurr,110) ) ).

tff(addAssignment_32190,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,110)
    <=> v53148(VarCurr,46) ) ).

tff(addAssignment_32189,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,46)
    <=> v53150(VarCurr,46) ) ).

tff(addAssignment_32188,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,46)
    <=> v53242(VarCurr,46) ) ).

tff(addAssignment_32187,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,46)
    <=> v53160(VarCurr,46) ) ).

tff(addAssignment_32186,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,46)
    <=> v6098(VarCurr,110) ) ).

tff(addAssignment_32185,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,110)
    <=> v6100(VarCurr,110) ) ).

tff(addAssignment_32184,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,110)
    <=> v6102(VarCurr,110) ) ).

tff(addAssignment_32183,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,110)
    <=> v53162(VarCurr,46) ) ).

tff(addAssignment_32182,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,46)
    <=> v53164(VarCurr,46) ) ).

tff(addAssignment_32181,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,46)
    <=> v53225(VarCurr,46) ) ).

tff(addAssignment_32180,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,46)
    <=> v53223(VarCurr,46) ) ).

tff(addAssignment_32179,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,46)
    <=> v53224(VarCurr,46) ) ).

tff(addAssignment_32178,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,46)
    <=> v53215(VarCurr,46) ) ).

tff(addAssignment_32177,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,46)
    <=> v53219(VarCurr,46) ) ).

tff(addAssignment_32176,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,38)
    <=> v53218(VarCurr,38) ) ).

tff(addAssignment_32175,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,74)
    <=> v6238(VarCurr,74) ) ).

tff(addAssignment_32174,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,74)
    <=> v6240(VarCurr,74) ) ).

tff(addAssignment_32173,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,74)
    <=> v40099(VarCurr,2) ) ).

tff(addAssignment_32172,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,46)
    <=> v53211(VarCurr,46) ) ).

tff(addAssignment_32171,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,46)
    <=> $false ) ).

tff(addAssignment_32170,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,46)
    <=> v53154(VarCurr,46) ) ).

tff(addAssignment_32169,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,46)
    <=> v53155(VarCurr,46) ) ).

tff(addAssignment_32168,axiom,
    ! [VarCurr: state_type] :
      ( v55664(VarCurr)
    <=> v55666(VarCurr) ) ).

tff(addAssignment_32167,axiom,
    ! [VarCurr: state_type] :
      ( v55666(VarCurr)
    <=> v6017(VarCurr,102) ) ).

tff(addAssignment_32166,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,102)
    <=> v53103(VarCurr,38) ) ).

tff(addAssignment_32165,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,38)
    <=> v53105(VarCurr,38) ) ).

tff(addAssignment_32164,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,38)
    <=> v53107(VarCurr,38) ) ).

tff(addAssignment_32163,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,38)
    <=> v53109(VarCurr,38) ) ).

tff(addAssignment_32162,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,38)
    <=> v6027(VarCurr,102) ) ).

tff(addAssignment_32161,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,102)
    <=> v52434(VarCurr,102) ) ).

tff(addAssignment_32160,axiom,
    ! [VarCurr: state_type] :
      ( v52441(VarCurr,2)
    <=> v53112(VarCurr,38) ) ).

tff(addAssignment_32159,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,38)
    <=> v53114(VarCurr,38) ) ).

tff(addAssignment_32158,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,38)
    <=> v55668(VarNext,38) ) ).

tff(addCaseBooleanConditionEqualRanges1_715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55669(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55668(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_715,axiom,
    ! [VarNext: state_type] :
      ( v55669(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55668(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55669(VarNext)
      <=> v55670(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55670(VarNext)
      <=> ( v55672(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55672(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32157,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,38)
    <=> v53138(VarCurr,38) ) ).

tff(addAssignment_32156,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,38)
    <=> v6059(VarCurr,102) ) ).

tff(addAssignment_32155,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,102)
    <=> v55186(VarCurr,2) ) ).

tff(addAssignment_32154,axiom,
    ! [VarCurr: state_type] :
      ( v55186(VarCurr,2)
    <=> v55188(VarCurr,2) ) ).

tff(addAssignment_32153,axiom,
    ! [VarCurr: state_type] :
      ( v55188(VarCurr,2)
    <=> v55205(VarCurr,2) ) ).

tff(addAssignment_32152,axiom,
    ! [VarCurr: state_type] :
      ( v55198(VarCurr,2)
    <=> v55200(VarCurr,2) ) ).

tff(addAssignment_32151,axiom,
    ! [VarCurr: state_type] :
      ( v55200(VarCurr,2)
    <=> v6069(VarCurr,102) ) ).

tff(addAssignment_32150,axiom,
    ! [VarCurr: state_type] :
      ( v55190(VarCurr,2)
    <=> v55192(VarCurr,2) ) ).

tff(addAssignment_32149,axiom,
    ! [VarCurr: state_type] :
      ( v55192(VarCurr,2)
    <=> v6069(VarCurr,106) ) ).

tff(addAssignment_32148,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,106)
    <=> v53148(VarCurr,42) ) ).

tff(addAssignment_32147,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,42)
    <=> v53150(VarCurr,42) ) ).

tff(addAssignment_32146,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,42)
    <=> v53242(VarCurr,42) ) ).

tff(addAssignment_32145,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,42)
    <=> v53160(VarCurr,42) ) ).

tff(addAssignment_32144,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,42)
    <=> v6098(VarCurr,106) ) ).

tff(addAssignment_32143,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,106)
    <=> v6100(VarCurr,106) ) ).

tff(addAssignment_32142,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,106)
    <=> v6102(VarCurr,106) ) ).

tff(addAssignment_32141,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,106)
    <=> v53162(VarCurr,42) ) ).

tff(addAssignment_32140,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,42)
    <=> v53164(VarCurr,42) ) ).

tff(addAssignment_32139,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,42)
    <=> v53225(VarCurr,42) ) ).

tff(addAssignment_32138,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,42)
    <=> v53223(VarCurr,42) ) ).

tff(addAssignment_32137,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,42)
    <=> v53224(VarCurr,42) ) ).

tff(addAssignment_32136,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,42)
    <=> v53215(VarCurr,42) ) ).

tff(addAssignment_32135,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,42)
    <=> v53219(VarCurr,42) ) ).

tff(addAssignment_32134,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,34)
    <=> v53218(VarCurr,34) ) ).

tff(addAssignment_32133,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,64)
    <=> v6238(VarCurr,64) ) ).

tff(addAssignment_32132,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,64)
    <=> v6240(VarCurr,64) ) ).

tff(addAssignment_32131,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,64)
    <=> v38549(VarCurr,4) ) ).

tff(addAssignment_32130,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,42)
    <=> v53211(VarCurr,42) ) ).

tff(addAssignment_32129,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,42)
    <=> $false ) ).

tff(addAssignment_32128,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,42)
    <=> v53154(VarCurr,42) ) ).

tff(addAssignment_32127,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,42)
    <=> v53155(VarCurr,42) ) ).

tff(addAssignment_32126,axiom,
    ! [VarCurr: state_type] :
      ( v55652(VarCurr)
    <=> v55654(VarCurr) ) ).

tff(addAssignment_32125,axiom,
    ! [VarCurr: state_type] :
      ( v55654(VarCurr)
    <=> v6017(VarCurr,98) ) ).

tff(addAssignment_32124,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,98)
    <=> v53103(VarCurr,34) ) ).

tff(addAssignment_32123,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,34)
    <=> v53105(VarCurr,34) ) ).

tff(addAssignment_32122,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,34)
    <=> v53107(VarCurr,34) ) ).

tff(addAssignment_32121,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,34)
    <=> v53109(VarCurr,34) ) ).

tff(addAssignment_32120,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,34)
    <=> v6027(VarCurr,98) ) ).

tff(addAssignment_32119,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,98)
    <=> v52434(VarCurr,98) ) ).

tff(addAssignment_32118,axiom,
    ! [VarCurr: state_type] :
      ( v52442(VarCurr,2)
    <=> v53112(VarCurr,34) ) ).

tff(addAssignment_32117,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,34)
    <=> v53114(VarCurr,34) ) ).

tff(addAssignment_32116,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,34)
    <=> v55656(VarNext,34) ) ).

tff(addCaseBooleanConditionEqualRanges1_714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55657(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55656(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_714,axiom,
    ! [VarNext: state_type] :
      ( v55657(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55656(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55657(VarNext)
      <=> v55658(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55658(VarNext)
      <=> ( v55660(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55660(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32115,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,34)
    <=> v53138(VarCurr,34) ) ).

tff(addAssignment_32114,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,34)
    <=> v6059(VarCurr,98) ) ).

tff(addAssignment_32113,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,98)
    <=> v55146(VarCurr,2) ) ).

tff(addAssignment_32112,axiom,
    ! [VarCurr: state_type] :
      ( v55146(VarCurr,2)
    <=> v55148(VarCurr,2) ) ).

tff(addAssignment_32111,axiom,
    ! [VarCurr: state_type] :
      ( v55148(VarCurr,2)
    <=> v55165(VarCurr,2) ) ).

tff(addAssignment_32110,axiom,
    ! [VarCurr: state_type] :
      ( v55158(VarCurr,2)
    <=> v55160(VarCurr,2) ) ).

tff(addAssignment_32109,axiom,
    ! [VarCurr: state_type] :
      ( v55160(VarCurr,2)
    <=> v6069(VarCurr,98) ) ).

tff(addAssignment_32108,axiom,
    ! [VarCurr: state_type] :
      ( v55150(VarCurr,2)
    <=> v55152(VarCurr,2) ) ).

tff(addAssignment_32107,axiom,
    ! [VarCurr: state_type] :
      ( v55152(VarCurr,2)
    <=> v6069(VarCurr,102) ) ).

tff(addAssignment_32106,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,102)
    <=> v53148(VarCurr,38) ) ).

tff(addAssignment_32105,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,38)
    <=> v53150(VarCurr,38) ) ).

tff(addAssignment_32104,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,38)
    <=> v53242(VarCurr,38) ) ).

tff(addAssignment_32103,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,38)
    <=> v53160(VarCurr,38) ) ).

tff(addAssignment_32102,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,38)
    <=> v6098(VarCurr,102) ) ).

tff(addAssignment_32101,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,102)
    <=> v6100(VarCurr,102) ) ).

tff(addAssignment_32100,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,102)
    <=> v6102(VarCurr,102) ) ).

tff(addAssignment_32099,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,102)
    <=> v53162(VarCurr,38) ) ).

tff(addAssignment_32098,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,38)
    <=> v53164(VarCurr,38) ) ).

tff(addAssignment_32097,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,38)
    <=> v53225(VarCurr,38) ) ).

tff(addAssignment_32096,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,38)
    <=> v53223(VarCurr,38) ) ).

tff(addAssignment_32095,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,38)
    <=> v53224(VarCurr,38) ) ).

tff(addAssignment_32094,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,38)
    <=> v53215(VarCurr,38) ) ).

tff(addAssignment_32093,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,38)
    <=> v53219(VarCurr,38) ) ).

tff(addAssignment_32092,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,30)
    <=> v53218(VarCurr,30) ) ).

tff(addAssignment_32091,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,60)
    <=> v6238(VarCurr,60) ) ).

tff(addAssignment_32090,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,60)
    <=> v6240(VarCurr,60) ) ).

tff(addAssignment_32089,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,60)
    <=> v38549(VarCurr,0) ) ).

tff(addAssignment_32088,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,38)
    <=> v53211(VarCurr,38) ) ).

tff(addAssignment_32087,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,38)
    <=> $false ) ).

tff(addAssignment_32086,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,38)
    <=> v53154(VarCurr,38) ) ).

tff(addAssignment_32085,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,38)
    <=> v53155(VarCurr,38) ) ).

tff(addAssignment_32084,axiom,
    ! [VarCurr: state_type] :
      ( v55476(VarCurr)
    <=> v55478(VarCurr) ) ).

tff(addAssignment_32083,axiom,
    ! [VarCurr: state_type] :
      ( v55478(VarCurr)
    <=> v55480(VarCurr) ) ).

tff(addAssignment_32082,axiom,
    ! [VarCurr: state_type] :
      ( v55480(VarCurr)
    <=> v55482(VarCurr) ) ).

tff(addAssignment_32081,axiom,
    ! [VarCurr: state_type] :
      ( v55482(VarCurr)
    <=> v55484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5219,axiom,
    ! [VarCurr: state_type] :
      ( v55484(VarCurr)
    <=> ( v55630(VarCurr)
      <~> v55582(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5218,axiom,
    ! [VarCurr: state_type] :
      ( v55630(VarCurr)
    <=> ( v55486(VarCurr)
      <~> v55534(VarCurr) ) ) ).

tff(addAssignment_32080,axiom,
    ! [VarCurr: state_type] :
      ( v55582(VarCurr)
    <=> v55584(VarCurr) ) ).

tff(addAssignment_32079,axiom,
    ! [VarCurr: state_type] :
      ( v55584(VarCurr)
    <=> v55586(VarCurr) ) ).

tff(addAssignment_32078,axiom,
    ! [VarCurr: state_type] :
      ( v55586(VarCurr)
    <=> v55588(VarCurr) ) ).

tff(addAssignment_32077,axiom,
    ! [VarCurr: state_type] :
      ( v55588(VarCurr)
    <=> v55590(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5217,axiom,
    ! [VarCurr: state_type] :
      ( v55590(VarCurr)
    <=> ( v55628(VarCurr)
      <~> v55616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5216,axiom,
    ! [VarCurr: state_type] :
      ( v55628(VarCurr)
    <=> ( v55592(VarCurr)
      <~> v55604(VarCurr) ) ) ).

tff(addAssignment_32076,axiom,
    ! [VarCurr: state_type] :
      ( v55616(VarCurr)
    <=> v55618(VarCurr) ) ).

tff(addAssignment_32075,axiom,
    ! [VarCurr: state_type] :
      ( v55618(VarCurr)
    <=> v6017(VarCurr,94) ) ).

tff(addAssignment_32074,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,94)
    <=> v53103(VarCurr,30) ) ).

tff(addAssignment_32073,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,30)
    <=> v53105(VarCurr,30) ) ).

tff(addAssignment_32072,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,30)
    <=> v53107(VarCurr,30) ) ).

tff(addAssignment_32071,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,30)
    <=> v53109(VarCurr,30) ) ).

tff(addAssignment_32070,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,30)
    <=> v6027(VarCurr,94) ) ).

tff(addAssignment_32069,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,94)
    <=> v52434(VarCurr,94) ) ).

tff(addAssignment_32068,axiom,
    ! [VarCurr: state_type] :
      ( v52443(VarCurr,2)
    <=> v53112(VarCurr,30) ) ).

tff(addAssignment_32067,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,30)
    <=> v53114(VarCurr,30) ) ).

tff(addAssignment_32066,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,30)
    <=> v55620(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55621(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55620(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_713,axiom,
    ! [VarNext: state_type] :
      ( v55621(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55620(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55621(VarNext)
      <=> v55622(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55622(VarNext)
      <=> ( v55624(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55624(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32065,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,30)
    <=> v53138(VarCurr,30) ) ).

tff(addAssignment_32064,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,30)
    <=> v6059(VarCurr,94) ) ).

tff(addAssignment_32063,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,94)
    <=> v55082(VarCurr,2) ) ).

tff(addAssignment_32062,axiom,
    ! [VarCurr: state_type] :
      ( v55082(VarCurr,2)
    <=> v55084(VarCurr,2) ) ).

tff(addAssignment_32061,axiom,
    ! [VarCurr: state_type] :
      ( v55084(VarCurr,2)
    <=> v55101(VarCurr,2) ) ).

tff(addAssignment_32060,axiom,
    ! [VarCurr: state_type] :
      ( v55094(VarCurr,2)
    <=> v55096(VarCurr,2) ) ).

tff(addAssignment_32059,axiom,
    ! [VarCurr: state_type] :
      ( v55096(VarCurr,2)
    <=> v6069(VarCurr,94) ) ).

tff(addAssignment_32058,axiom,
    ! [VarCurr: state_type] :
      ( v55086(VarCurr,2)
    <=> v55088(VarCurr,2) ) ).

tff(addAssignment_32057,axiom,
    ! [VarCurr: state_type] :
      ( v55088(VarCurr,2)
    <=> v6069(VarCurr,98) ) ).

tff(addAssignment_32056,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,98)
    <=> v53148(VarCurr,34) ) ).

tff(addAssignment_32055,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,34)
    <=> v53150(VarCurr,34) ) ).

tff(addAssignment_32054,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,34)
    <=> v53242(VarCurr,34) ) ).

tff(addAssignment_32053,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,34)
    <=> v53160(VarCurr,34) ) ).

tff(addAssignment_32052,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,34)
    <=> v6098(VarCurr,98) ) ).

tff(addAssignment_32051,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,98)
    <=> v6100(VarCurr,98) ) ).

tff(addAssignment_32050,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,98)
    <=> v6102(VarCurr,98) ) ).

tff(addAssignment_32049,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,98)
    <=> v53162(VarCurr,34) ) ).

tff(addAssignment_32048,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,34)
    <=> v53164(VarCurr,34) ) ).

tff(addAssignment_32047,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,34)
    <=> v53225(VarCurr,34) ) ).

tff(addAssignment_32046,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,34)
    <=> v53223(VarCurr,34) ) ).

tff(addAssignment_32045,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,34)
    <=> v53224(VarCurr,34) ) ).

tff(addAssignment_32044,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,34)
    <=> v53215(VarCurr,34) ) ).

tff(addAssignment_32043,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,34)
    <=> v53219(VarCurr,34) ) ).

tff(addAssignment_32042,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,26)
    <=> v53218(VarCurr,26) ) ).

tff(addAssignment_32041,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,50)
    <=> v6238(VarCurr,50) ) ).

tff(addAssignment_32040,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,50)
    <=> v6240(VarCurr,50) ) ).

tff(addAssignment_32039,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,50)
    <=> v36999(VarCurr,2) ) ).

tff(addAssignment_32038,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,34)
    <=> v53211(VarCurr,34) ) ).

tff(addAssignment_32037,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,34)
    <=> $false ) ).

tff(addAssignment_32036,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,34)
    <=> v53154(VarCurr,34) ) ).

tff(addAssignment_32035,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,34)
    <=> v53155(VarCurr,34) ) ).

tff(addAssignment_32034,axiom,
    ! [VarCurr: state_type] :
      ( v55604(VarCurr)
    <=> v55606(VarCurr) ) ).

tff(addAssignment_32033,axiom,
    ! [VarCurr: state_type] :
      ( v55606(VarCurr)
    <=> v6017(VarCurr,90) ) ).

tff(addAssignment_32032,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,90)
    <=> v53103(VarCurr,26) ) ).

tff(addAssignment_32031,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,26)
    <=> v53105(VarCurr,26) ) ).

tff(addAssignment_32030,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,26)
    <=> v53107(VarCurr,26) ) ).

tff(addAssignment_32029,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,26)
    <=> v53109(VarCurr,26) ) ).

tff(addAssignment_32028,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,26)
    <=> v6027(VarCurr,90) ) ).

tff(addAssignment_32027,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,90)
    <=> v52434(VarCurr,90) ) ).

tff(addAssignment_32026,axiom,
    ! [VarCurr: state_type] :
      ( v52444(VarCurr,2)
    <=> v53112(VarCurr,26) ) ).

tff(addAssignment_32025,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,26)
    <=> v53114(VarCurr,26) ) ).

tff(addAssignment_32024,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,26)
    <=> v55608(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55609(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55608(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_712,axiom,
    ! [VarNext: state_type] :
      ( v55609(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55608(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55609(VarNext)
      <=> v55610(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55610(VarNext)
      <=> ( v55612(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55612(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_32023,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,26)
    <=> v53138(VarCurr,26) ) ).

tff(addAssignment_32022,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,26)
    <=> v6059(VarCurr,90) ) ).

tff(addAssignment_32021,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,90)
    <=> v55042(VarCurr,2) ) ).

tff(addAssignment_32020,axiom,
    ! [VarCurr: state_type] :
      ( v55042(VarCurr,2)
    <=> v55044(VarCurr,2) ) ).

tff(addAssignment_32019,axiom,
    ! [VarCurr: state_type] :
      ( v55044(VarCurr,2)
    <=> v55061(VarCurr,2) ) ).

tff(addAssignment_32018,axiom,
    ! [VarCurr: state_type] :
      ( v55054(VarCurr,2)
    <=> v55056(VarCurr,2) ) ).

tff(addAssignment_32017,axiom,
    ! [VarCurr: state_type] :
      ( v55056(VarCurr,2)
    <=> v6069(VarCurr,90) ) ).

tff(addAssignment_32016,axiom,
    ! [VarCurr: state_type] :
      ( v55046(VarCurr,2)
    <=> v55048(VarCurr,2) ) ).

tff(addAssignment_32015,axiom,
    ! [VarCurr: state_type] :
      ( v55048(VarCurr,2)
    <=> v6069(VarCurr,94) ) ).

tff(addAssignment_32014,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,94)
    <=> v53148(VarCurr,30) ) ).

tff(addAssignment_32013,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,30)
    <=> v53150(VarCurr,30) ) ).

tff(addAssignment_32012,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,30)
    <=> v53242(VarCurr,30) ) ).

tff(addAssignment_32011,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,30)
    <=> v53160(VarCurr,30) ) ).

tff(addAssignment_32010,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,30)
    <=> v6098(VarCurr,94) ) ).

tff(addAssignment_32009,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,94)
    <=> v6100(VarCurr,94) ) ).

tff(addAssignment_32008,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,94)
    <=> v6102(VarCurr,94) ) ).

tff(addAssignment_32007,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,94)
    <=> v53162(VarCurr,30) ) ).

tff(addAssignment_32006,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,30)
    <=> v53164(VarCurr,30) ) ).

tff(addAssignment_32005,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,30)
    <=> v53225(VarCurr,30) ) ).

tff(addAssignment_32004,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,30)
    <=> v53223(VarCurr,30) ) ).

tff(addAssignment_32003,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,30)
    <=> v53224(VarCurr,30) ) ).

tff(addAssignment_32002,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,30)
    <=> v53215(VarCurr,30) ) ).

tff(addAssignment_32001,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,30)
    <=> v53219(VarCurr,30) ) ).

tff(addAssignment_32000,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,22)
    <=> v53218(VarCurr,22) ) ).

tff(addAssignment_31999,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,40)
    <=> v6238(VarCurr,40) ) ).

tff(addAssignment_31998,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,40)
    <=> v6240(VarCurr,40) ) ).

tff(addAssignment_31997,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,40)
    <=> v35449(VarCurr,4) ) ).

tff(addAssignment_31996,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,30)
    <=> v53211(VarCurr,30) ) ).

tff(addAssignment_31995,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_31994,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,30)
    <=> v53154(VarCurr,30) ) ).

tff(addAssignment_31993,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,30)
    <=> v53155(VarCurr,30) ) ).

tff(addAssignment_31992,axiom,
    ! [VarCurr: state_type] :
      ( v55592(VarCurr)
    <=> v55594(VarCurr) ) ).

tff(addAssignment_31991,axiom,
    ! [VarCurr: state_type] :
      ( v55594(VarCurr)
    <=> v6017(VarCurr,86) ) ).

tff(addAssignment_31990,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,86)
    <=> v53103(VarCurr,22) ) ).

tff(addAssignment_31989,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,22)
    <=> v53105(VarCurr,22) ) ).

tff(addAssignment_31988,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,22)
    <=> v53107(VarCurr,22) ) ).

tff(addAssignment_31987,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,22)
    <=> v53109(VarCurr,22) ) ).

tff(addAssignment_31986,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,22)
    <=> v6027(VarCurr,86) ) ).

tff(addAssignment_31985,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,86)
    <=> v52434(VarCurr,86) ) ).

tff(addAssignment_31984,axiom,
    ! [VarCurr: state_type] :
      ( v52445(VarCurr,2)
    <=> v53112(VarCurr,22) ) ).

tff(addAssignment_31983,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,22)
    <=> v53114(VarCurr,22) ) ).

tff(addAssignment_31982,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,22)
    <=> v55596(VarNext,22) ) ).

tff(addCaseBooleanConditionEqualRanges1_711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55597(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55596(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_711,axiom,
    ! [VarNext: state_type] :
      ( v55597(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55596(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55597(VarNext)
      <=> v55598(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55598(VarNext)
      <=> ( v55600(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55600(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31981,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,22)
    <=> v53138(VarCurr,22) ) ).

tff(addAssignment_31980,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,22)
    <=> v6059(VarCurr,86) ) ).

tff(addAssignment_31979,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,86)
    <=> v55002(VarCurr,2) ) ).

tff(addAssignment_31978,axiom,
    ! [VarCurr: state_type] :
      ( v55002(VarCurr,2)
    <=> v55004(VarCurr,2) ) ).

tff(addAssignment_31977,axiom,
    ! [VarCurr: state_type] :
      ( v55004(VarCurr,2)
    <=> v55021(VarCurr,2) ) ).

tff(addAssignment_31976,axiom,
    ! [VarCurr: state_type] :
      ( v55014(VarCurr,2)
    <=> v55016(VarCurr,2) ) ).

tff(addAssignment_31975,axiom,
    ! [VarCurr: state_type] :
      ( v55016(VarCurr,2)
    <=> v6069(VarCurr,86) ) ).

tff(addAssignment_31974,axiom,
    ! [VarCurr: state_type] :
      ( v55006(VarCurr,2)
    <=> v55008(VarCurr,2) ) ).

tff(addAssignment_31973,axiom,
    ! [VarCurr: state_type] :
      ( v55008(VarCurr,2)
    <=> v6069(VarCurr,90) ) ).

tff(addAssignment_31972,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,90)
    <=> v53148(VarCurr,26) ) ).

tff(addAssignment_31971,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,26)
    <=> v53150(VarCurr,26) ) ).

tff(addAssignment_31970,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,26)
    <=> v53242(VarCurr,26) ) ).

tff(addAssignment_31969,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,26)
    <=> v53160(VarCurr,26) ) ).

tff(addAssignment_31968,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,26)
    <=> v6098(VarCurr,90) ) ).

tff(addAssignment_31967,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,90)
    <=> v6100(VarCurr,90) ) ).

tff(addAssignment_31966,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,90)
    <=> v6102(VarCurr,90) ) ).

tff(addAssignment_31965,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,90)
    <=> v53162(VarCurr,26) ) ).

tff(addAssignment_31964,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,26)
    <=> v53164(VarCurr,26) ) ).

tff(addAssignment_31963,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,26)
    <=> v53225(VarCurr,26) ) ).

tff(addAssignment_31962,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,26)
    <=> v53223(VarCurr,26) ) ).

tff(addAssignment_31961,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,26)
    <=> v53224(VarCurr,26) ) ).

tff(addAssignment_31960,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,26)
    <=> v53215(VarCurr,26) ) ).

tff(addAssignment_31959,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,26)
    <=> v53219(VarCurr,26) ) ).

tff(addAssignment_31958,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,18)
    <=> v53218(VarCurr,18) ) ).

tff(addAssignment_31957,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,36)
    <=> v6238(VarCurr,36) ) ).

tff(addAssignment_31956,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,36)
    <=> v6240(VarCurr,36) ) ).

tff(addAssignment_31955,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,36)
    <=> v35449(VarCurr,0) ) ).

tff(addAssignment_31954,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,26)
    <=> v53211(VarCurr,26) ) ).

tff(addAssignment_31953,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,26)
    <=> $false ) ).

tff(addAssignment_31952,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,26)
    <=> v53154(VarCurr,26) ) ).

tff(addAssignment_31951,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,26)
    <=> v53155(VarCurr,26) ) ).

tff(addAssignment_31950,axiom,
    ! [VarCurr: state_type] :
      ( v55534(VarCurr)
    <=> v55536(VarCurr) ) ).

tff(addAssignment_31949,axiom,
    ! [VarCurr: state_type] :
      ( v55536(VarCurr)
    <=> v55538(VarCurr) ) ).

tff(addAssignment_31948,axiom,
    ! [VarCurr: state_type] :
      ( v55538(VarCurr)
    <=> v55540(VarCurr) ) ).

tff(addAssignment_31947,axiom,
    ! [VarCurr: state_type] :
      ( v55540(VarCurr)
    <=> v55542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5209,axiom,
    ! [VarCurr: state_type] :
      ( v55542(VarCurr)
    <=> ( v55580(VarCurr)
      <~> v55568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5208,axiom,
    ! [VarCurr: state_type] :
      ( v55580(VarCurr)
    <=> ( v55544(VarCurr)
      <~> v55556(VarCurr) ) ) ).

tff(addAssignment_31946,axiom,
    ! [VarCurr: state_type] :
      ( v55568(VarCurr)
    <=> v55570(VarCurr) ) ).

tff(addAssignment_31945,axiom,
    ! [VarCurr: state_type] :
      ( v55570(VarCurr)
    <=> v6017(VarCurr,82) ) ).

tff(addAssignment_31944,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,82)
    <=> v53103(VarCurr,18) ) ).

tff(addAssignment_31943,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,18)
    <=> v53105(VarCurr,18) ) ).

tff(addAssignment_31942,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,18)
    <=> v53107(VarCurr,18) ) ).

tff(addAssignment_31941,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,18)
    <=> v53109(VarCurr,18) ) ).

tff(addAssignment_31940,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,18)
    <=> v6027(VarCurr,82) ) ).

tff(addAssignment_31939,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,82)
    <=> v52434(VarCurr,82) ) ).

tff(addAssignment_31938,axiom,
    ! [VarCurr: state_type] :
      ( v52446(VarCurr,2)
    <=> v53112(VarCurr,18) ) ).

tff(addAssignment_31937,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,18)
    <=> v53114(VarCurr,18) ) ).

tff(addAssignment_31936,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,18)
    <=> v55572(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55573(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55572(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_710,axiom,
    ! [VarNext: state_type] :
      ( v55573(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55572(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55573(VarNext)
      <=> v55574(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55574(VarNext)
      <=> ( v55576(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55576(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31935,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,18)
    <=> v53138(VarCurr,18) ) ).

tff(addAssignment_31934,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,18)
    <=> v6059(VarCurr,82) ) ).

tff(addAssignment_31933,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,82)
    <=> v54950(VarCurr,2) ) ).

tff(addAssignment_31932,axiom,
    ! [VarCurr: state_type] :
      ( v54950(VarCurr,2)
    <=> v54952(VarCurr,2) ) ).

tff(addAssignment_31931,axiom,
    ! [VarCurr: state_type] :
      ( v54952(VarCurr,2)
    <=> v54969(VarCurr,2) ) ).

tff(addAssignment_31930,axiom,
    ! [VarCurr: state_type] :
      ( v54962(VarCurr,2)
    <=> v54964(VarCurr,2) ) ).

tff(addAssignment_31929,axiom,
    ! [VarCurr: state_type] :
      ( v54964(VarCurr,2)
    <=> v6069(VarCurr,82) ) ).

tff(addAssignment_31928,axiom,
    ! [VarCurr: state_type] :
      ( v54954(VarCurr,2)
    <=> v54956(VarCurr,2) ) ).

tff(addAssignment_31927,axiom,
    ! [VarCurr: state_type] :
      ( v54956(VarCurr,2)
    <=> v6069(VarCurr,86) ) ).

tff(addAssignment_31926,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,86)
    <=> v53148(VarCurr,22) ) ).

tff(addAssignment_31925,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,22)
    <=> v53150(VarCurr,22) ) ).

tff(addAssignment_31924,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,22)
    <=> v53242(VarCurr,22) ) ).

tff(addAssignment_31923,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,22)
    <=> v53160(VarCurr,22) ) ).

tff(addAssignment_31922,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,22)
    <=> v6098(VarCurr,86) ) ).

tff(addAssignment_31921,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,86)
    <=> v6100(VarCurr,86) ) ).

tff(addAssignment_31920,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,86)
    <=> v6102(VarCurr,86) ) ).

tff(addAssignment_31919,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,86)
    <=> v53162(VarCurr,22) ) ).

tff(addAssignment_31918,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,22)
    <=> v53164(VarCurr,22) ) ).

tff(addAssignment_31917,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,22)
    <=> v53225(VarCurr,22) ) ).

tff(addAssignment_31916,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,22)
    <=> v53223(VarCurr,22) ) ).

tff(addAssignment_31915,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,22)
    <=> v53224(VarCurr,22) ) ).

tff(addAssignment_31914,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,22)
    <=> v53215(VarCurr,22) ) ).

tff(addAssignment_31913,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,22)
    <=> v53219(VarCurr,22) ) ).

tff(addAssignment_31912,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,14)
    <=> v53218(VarCurr,14) ) ).

tff(addAssignment_31911,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,26)
    <=> v6238(VarCurr,26) ) ).

tff(addAssignment_31910,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,22)
    <=> v53211(VarCurr,22) ) ).

tff(addAssignment_31909,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,22)
    <=> $false ) ).

tff(addAssignment_31908,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,22)
    <=> v53154(VarCurr,22) ) ).

tff(addAssignment_31907,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,22)
    <=> v53155(VarCurr,22) ) ).

tff(addAssignment_31906,axiom,
    ! [VarCurr: state_type] :
      ( v55556(VarCurr)
    <=> v55558(VarCurr) ) ).

tff(addAssignment_31905,axiom,
    ! [VarCurr: state_type] :
      ( v55558(VarCurr)
    <=> v6017(VarCurr,78) ) ).

tff(addAssignment_31904,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,78)
    <=> v53103(VarCurr,14) ) ).

tff(addAssignment_31903,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,14)
    <=> v53105(VarCurr,14) ) ).

tff(addAssignment_31902,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,14)
    <=> v53107(VarCurr,14) ) ).

tff(addAssignment_31901,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,14)
    <=> v53109(VarCurr,14) ) ).

tff(addAssignment_31900,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,14)
    <=> v6027(VarCurr,78) ) ).

tff(addAssignment_31899,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,78)
    <=> v52434(VarCurr,78) ) ).

tff(addAssignment_31898,axiom,
    ! [VarCurr: state_type] :
      ( v52447(VarCurr,2)
    <=> v53112(VarCurr,14) ) ).

tff(addAssignment_31897,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,14)
    <=> v53114(VarCurr,14) ) ).

tff(addAssignment_31896,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,14)
    <=> v55560(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55561(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55560(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_709,axiom,
    ! [VarNext: state_type] :
      ( v55561(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55560(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55561(VarNext)
      <=> v55562(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55562(VarNext)
      <=> ( v55564(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55564(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31895,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,14)
    <=> v53138(VarCurr,14) ) ).

tff(addAssignment_31894,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,14)
    <=> v6059(VarCurr,78) ) ).

tff(addAssignment_31893,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,78)
    <=> v54910(VarCurr,2) ) ).

tff(addAssignment_31892,axiom,
    ! [VarCurr: state_type] :
      ( v54910(VarCurr,2)
    <=> v54912(VarCurr,2) ) ).

tff(addAssignment_31891,axiom,
    ! [VarCurr: state_type] :
      ( v54912(VarCurr,2)
    <=> v54929(VarCurr,2) ) ).

tff(addAssignment_31890,axiom,
    ! [VarCurr: state_type] :
      ( v54922(VarCurr,2)
    <=> v54924(VarCurr,2) ) ).

tff(addAssignment_31889,axiom,
    ! [VarCurr: state_type] :
      ( v54924(VarCurr,2)
    <=> v6069(VarCurr,78) ) ).

tff(addAssignment_31888,axiom,
    ! [VarCurr: state_type] :
      ( v54914(VarCurr,2)
    <=> v54916(VarCurr,2) ) ).

tff(addAssignment_31887,axiom,
    ! [VarCurr: state_type] :
      ( v54916(VarCurr,2)
    <=> v6069(VarCurr,82) ) ).

tff(addAssignment_31886,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,82)
    <=> v53148(VarCurr,18) ) ).

tff(addAssignment_31885,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,18)
    <=> v53150(VarCurr,18) ) ).

tff(addAssignment_31884,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,18)
    <=> v53242(VarCurr,18) ) ).

tff(addAssignment_31883,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,18)
    <=> v53160(VarCurr,18) ) ).

tff(addAssignment_31882,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,18)
    <=> v6098(VarCurr,82) ) ).

tff(addAssignment_31881,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,82)
    <=> v6100(VarCurr,82) ) ).

tff(addAssignment_31880,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,82)
    <=> v6102(VarCurr,82) ) ).

tff(addAssignment_31879,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,82)
    <=> v53162(VarCurr,18) ) ).

tff(addAssignment_31878,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,18)
    <=> v53164(VarCurr,18) ) ).

tff(addAssignment_31877,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,18)
    <=> v53225(VarCurr,18) ) ).

tff(addAssignment_31876,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,18)
    <=> v53223(VarCurr,18) ) ).

tff(addAssignment_31875,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,18)
    <=> v53224(VarCurr,18) ) ).

tff(addAssignment_31874,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,18)
    <=> v53215(VarCurr,18) ) ).

tff(addAssignment_31873,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,18)
    <=> v53219(VarCurr,18) ) ).

tff(addAssignment_31872,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,10)
    <=> v53218(VarCurr,10) ) ).

tff(addAssignment_31871,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,16)
    <=> v6238(VarCurr,16) ) ).

tff(addAssignment_31870,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,18)
    <=> v53211(VarCurr,18) ) ).

tff(addAssignment_31869,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,18)
    <=> $false ) ).

tff(addAssignment_31868,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,18)
    <=> v53154(VarCurr,18) ) ).

tff(addAssignment_31867,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,18)
    <=> v53155(VarCurr,18) ) ).

tff(addAssignment_31866,axiom,
    ! [VarCurr: state_type] :
      ( v55544(VarCurr)
    <=> v55546(VarCurr) ) ).

tff(addAssignment_31865,axiom,
    ! [VarCurr: state_type] :
      ( v55546(VarCurr)
    <=> v6017(VarCurr,74) ) ).

tff(addAssignment_31864,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,74)
    <=> v53103(VarCurr,10) ) ).

tff(addAssignment_31863,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,10)
    <=> v53105(VarCurr,10) ) ).

tff(addAssignment_31862,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,10)
    <=> v53107(VarCurr,10) ) ).

tff(addAssignment_31861,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,10)
    <=> v53109(VarCurr,10) ) ).

tff(addAssignment_31860,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,10)
    <=> v6027(VarCurr,74) ) ).

tff(addAssignment_31859,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,74)
    <=> v52434(VarCurr,74) ) ).

tff(addAssignment_31858,axiom,
    ! [VarCurr: state_type] :
      ( v52448(VarCurr,2)
    <=> v53112(VarCurr,10) ) ).

tff(addAssignment_31857,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,10)
    <=> v53114(VarCurr,10) ) ).

tff(addAssignment_31856,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,10)
    <=> v55548(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55549(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55548(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_708,axiom,
    ! [VarNext: state_type] :
      ( v55549(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55548(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55549(VarNext)
      <=> v55550(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55550(VarNext)
      <=> ( v55552(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3087,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55552(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31855,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,10)
    <=> v53138(VarCurr,10) ) ).

tff(addAssignment_31854,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,10)
    <=> v6059(VarCurr,74) ) ).

tff(addAssignment_31853,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,74)
    <=> v54870(VarCurr,2) ) ).

tff(addAssignment_31852,axiom,
    ! [VarCurr: state_type] :
      ( v54870(VarCurr,2)
    <=> v54872(VarCurr,2) ) ).

tff(addAssignment_31851,axiom,
    ! [VarCurr: state_type] :
      ( v54872(VarCurr,2)
    <=> v54889(VarCurr,2) ) ).

tff(addAssignment_31850,axiom,
    ! [VarCurr: state_type] :
      ( v54882(VarCurr,2)
    <=> v54884(VarCurr,2) ) ).

tff(addAssignment_31849,axiom,
    ! [VarCurr: state_type] :
      ( v54884(VarCurr,2)
    <=> v6069(VarCurr,74) ) ).

tff(addAssignment_31848,axiom,
    ! [VarCurr: state_type] :
      ( v54874(VarCurr,2)
    <=> v54876(VarCurr,2) ) ).

tff(addAssignment_31847,axiom,
    ! [VarCurr: state_type] :
      ( v54876(VarCurr,2)
    <=> v6069(VarCurr,78) ) ).

tff(addAssignment_31846,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,78)
    <=> v53148(VarCurr,14) ) ).

tff(addAssignment_31845,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,14)
    <=> v53150(VarCurr,14) ) ).

tff(addAssignment_31844,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,14)
    <=> v53242(VarCurr,14) ) ).

tff(addAssignment_31843,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,14)
    <=> v53160(VarCurr,14) ) ).

tff(addAssignment_31842,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,14)
    <=> v6098(VarCurr,78) ) ).

tff(addAssignment_31841,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,78)
    <=> v6100(VarCurr,78) ) ).

tff(addAssignment_31840,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,78)
    <=> v6102(VarCurr,78) ) ).

tff(addAssignment_31839,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,78)
    <=> v53162(VarCurr,14) ) ).

tff(addAssignment_31838,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,14)
    <=> v53164(VarCurr,14) ) ).

tff(addAssignment_31837,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,14)
    <=> v53225(VarCurr,14) ) ).

tff(addAssignment_31836,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,14)
    <=> v53223(VarCurr,14) ) ).

tff(addAssignment_31835,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,14)
    <=> v53224(VarCurr,14) ) ).

tff(addAssignment_31834,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,14)
    <=> v53215(VarCurr,14) ) ).

tff(addAssignment_31833,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,14)
    <=> v53219(VarCurr,14) ) ).

tff(addAssignment_31832,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,6)
    <=> v53218(VarCurr,6) ) ).

tff(addAssignment_31831,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,12)
    <=> v6238(VarCurr,12) ) ).

tff(addAssignment_31830,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,14)
    <=> v53211(VarCurr,14) ) ).

tff(addAssignment_31829,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_31828,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,14)
    <=> v53154(VarCurr,14) ) ).

tff(addAssignment_31827,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,14)
    <=> v53155(VarCurr,14) ) ).

tff(addAssignment_31826,axiom,
    ! [VarCurr: state_type] :
      ( v55486(VarCurr)
    <=> v55488(VarCurr) ) ).

tff(addAssignment_31825,axiom,
    ! [VarCurr: state_type] :
      ( v55488(VarCurr)
    <=> v55490(VarCurr) ) ).

tff(addAssignment_31824,axiom,
    ! [VarCurr: state_type] :
      ( v55490(VarCurr)
    <=> v55492(VarCurr) ) ).

tff(addAssignment_31823,axiom,
    ! [VarCurr: state_type] :
      ( v55492(VarCurr)
    <=> v55494(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5201,axiom,
    ! [VarCurr: state_type] :
      ( v55494(VarCurr)
    <=> ( v55532(VarCurr)
      <~> v55520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5200,axiom,
    ! [VarCurr: state_type] :
      ( v55532(VarCurr)
    <=> ( v55496(VarCurr)
      <~> v55508(VarCurr) ) ) ).

tff(addAssignment_31822,axiom,
    ! [VarCurr: state_type] :
      ( v55520(VarCurr)
    <=> v55522(VarCurr) ) ).

tff(addAssignment_31821,axiom,
    ! [VarCurr: state_type] :
      ( v55522(VarCurr)
    <=> v6017(VarCurr,70) ) ).

tff(addAssignment_31820,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,70)
    <=> v53103(VarCurr,6) ) ).

tff(addAssignment_31819,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,6)
    <=> v53105(VarCurr,6) ) ).

tff(addAssignment_31818,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,6)
    <=> v53107(VarCurr,6) ) ).

tff(addAssignment_31817,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,6)
    <=> v53109(VarCurr,6) ) ).

tff(addAssignment_31816,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,6)
    <=> v6027(VarCurr,70) ) ).

tff(addAssignment_31815,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,70)
    <=> v52434(VarCurr,70) ) ).

tff(addAssignment_31814,axiom,
    ! [VarCurr: state_type] :
      ( v52449(VarCurr,2)
    <=> v53112(VarCurr,6) ) ).

tff(addAssignment_31813,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,6)
    <=> v53114(VarCurr,6) ) ).

tff(addAssignment_31812,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,6)
    <=> v55524(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55525(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55524(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_707,axiom,
    ! [VarNext: state_type] :
      ( v55525(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55524(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55525(VarNext)
      <=> v55526(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55526(VarNext)
      <=> ( v55528(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55528(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31811,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,6)
    <=> v53138(VarCurr,6) ) ).

tff(addAssignment_31810,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,6)
    <=> v6059(VarCurr,70) ) ).

tff(addAssignment_31809,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,70)
    <=> v54818(VarCurr,2) ) ).

tff(addAssignment_31808,axiom,
    ! [VarCurr: state_type] :
      ( v54818(VarCurr,2)
    <=> v54820(VarCurr,2) ) ).

tff(addAssignment_31807,axiom,
    ! [VarCurr: state_type] :
      ( v54820(VarCurr,2)
    <=> v54837(VarCurr,2) ) ).

tff(addAssignment_31806,axiom,
    ! [VarCurr: state_type] :
      ( v54830(VarCurr,2)
    <=> v54832(VarCurr,2) ) ).

tff(addAssignment_31805,axiom,
    ! [VarCurr: state_type] :
      ( v54832(VarCurr,2)
    <=> v6069(VarCurr,70) ) ).

tff(addAssignment_31804,axiom,
    ! [VarCurr: state_type] :
      ( v54822(VarCurr,2)
    <=> v54824(VarCurr,2) ) ).

tff(addAssignment_31803,axiom,
    ! [VarCurr: state_type] :
      ( v54824(VarCurr,2)
    <=> v6069(VarCurr,74) ) ).

tff(addAssignment_31802,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,74)
    <=> v53148(VarCurr,10) ) ).

tff(addAssignment_31801,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,10)
    <=> v53150(VarCurr,10) ) ).

tff(addAssignment_31800,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,10)
    <=> v53242(VarCurr,10) ) ).

tff(addAssignment_31799,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,10)
    <=> v53160(VarCurr,10) ) ).

tff(addAssignment_31798,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,10)
    <=> v6098(VarCurr,74) ) ).

tff(addAssignment_31797,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,74)
    <=> v6100(VarCurr,74) ) ).

tff(addAssignment_31796,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,74)
    <=> v6102(VarCurr,74) ) ).

tff(addAssignment_31795,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,74)
    <=> v53162(VarCurr,10) ) ).

tff(addAssignment_31794,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,10)
    <=> v53164(VarCurr,10) ) ).

tff(addAssignment_31793,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,10)
    <=> v53225(VarCurr,10) ) ).

tff(addAssignment_31792,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,10)
    <=> v53223(VarCurr,10) ) ).

tff(addAssignment_31791,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,10)
    <=> v53224(VarCurr,10) ) ).

tff(addAssignment_31790,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,10)
    <=> v53215(VarCurr,10) ) ).

tff(addAssignment_31789,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,10)
    <=> v53219(VarCurr,10) ) ).

tff(addAssignment_31788,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,2)
    <=> v53218(VarCurr,2) ) ).

tff(addAssignment_31787,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,2)
    <=> v6238(VarCurr,2) ) ).

tff(addAssignment_31786,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,10)
    <=> v53211(VarCurr,10) ) ).

tff(addAssignment_31785,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_31784,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,10)
    <=> v53154(VarCurr,10) ) ).

tff(addAssignment_31783,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,10)
    <=> v53155(VarCurr,10) ) ).

tff(addAssignment_31782,axiom,
    ! [VarCurr: state_type] :
      ( v55508(VarCurr)
    <=> v55510(VarCurr) ) ).

tff(addAssignment_31781,axiom,
    ! [VarCurr: state_type] :
      ( v55510(VarCurr)
    <=> v6017(VarCurr,66) ) ).

tff(addAssignment_31780,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,66)
    <=> v53103(VarCurr,2) ) ).

tff(addAssignment_31779,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,2)
    <=> v53105(VarCurr,2) ) ).

tff(addAssignment_31778,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,2)
    <=> v53107(VarCurr,2) ) ).

tff(addAssignment_31777,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,2)
    <=> v53109(VarCurr,2) ) ).

tff(addAssignment_31776,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,2)
    <=> v6027(VarCurr,66) ) ).

tff(addAssignment_31775,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,66)
    <=> v52434(VarCurr,66) ) ).

tff(addAssignment_31774,axiom,
    ! [VarCurr: state_type] :
      ( v52450(VarCurr,2)
    <=> v53112(VarCurr,2) ) ).

tff(addAssignment_31773,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,2)
    <=> v53114(VarCurr,2) ) ).

tff(addAssignment_31772,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,2)
    <=> v55512(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55513(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55512(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_706,axiom,
    ! [VarNext: state_type] :
      ( v55513(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55512(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55513(VarNext)
      <=> v55514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55514(VarNext)
      <=> ( v55516(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55516(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31771,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,2)
    <=> v53138(VarCurr,2) ) ).

tff(addAssignment_31770,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,2)
    <=> v6059(VarCurr,66) ) ).

tff(addAssignment_31769,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,66)
    <=> v54778(VarCurr,2) ) ).

tff(addAssignment_31768,axiom,
    ! [VarCurr: state_type] :
      ( v54778(VarCurr,2)
    <=> v54780(VarCurr,2) ) ).

tff(addAssignment_31767,axiom,
    ! [VarCurr: state_type] :
      ( v54780(VarCurr,2)
    <=> v54797(VarCurr,2) ) ).

tff(addAssignment_31766,axiom,
    ! [VarCurr: state_type] :
      ( v54790(VarCurr,2)
    <=> v54792(VarCurr,2) ) ).

tff(addAssignment_31765,axiom,
    ! [VarCurr: state_type] :
      ( v54792(VarCurr,2)
    <=> v6069(VarCurr,66) ) ).

tff(addAssignment_31764,axiom,
    ! [VarCurr: state_type] :
      ( v54782(VarCurr,2)
    <=> v54784(VarCurr,2) ) ).

tff(addAssignment_31763,axiom,
    ! [VarCurr: state_type] :
      ( v54784(VarCurr,2)
    <=> v6069(VarCurr,70) ) ).

tff(addAssignment_31762,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,70)
    <=> v53148(VarCurr,6) ) ).

tff(addAssignment_31761,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,6)
    <=> v53150(VarCurr,6) ) ).

tff(addAssignment_31760,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,6)
    <=> v53242(VarCurr,6) ) ).

tff(addAssignment_31759,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,6)
    <=> v53160(VarCurr,6) ) ).

tff(addAssignment_31758,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,6)
    <=> v6098(VarCurr,70) ) ).

tff(addAssignment_31757,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,70)
    <=> v6100(VarCurr,70) ) ).

tff(addAssignment_31756,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,70)
    <=> v6102(VarCurr,70) ) ).

tff(addAssignment_31755,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,70)
    <=> v53162(VarCurr,6) ) ).

tff(addAssignment_31754,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,6)
    <=> v53164(VarCurr,6) ) ).

tff(addAssignment_31753,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,6)
    <=> v53225(VarCurr,6) ) ).

tff(addAssignment_31752,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,6)
    <=> v53223(VarCurr,6) ) ).

tff(addAssignment_31751,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,6)
    <=> v53224(VarCurr,6) ) ).

tff(addAssignment_31750,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,70)
    <=> v52335(VarCurr,70) ) ).

tff(addAssignment_31749,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,136)
    <=> v33839(VarCurr,136) ) ).

tff(addAssignment_31748,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,136)
    <=> v33841(VarCurr,136) ) ).

tff(addAssignment_31747,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,136)
    <=> v26555(VarCurr,4) ) ).

tff(addAssignment_31746,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,6)
    <=> v53215(VarCurr,6) ) ).

tff(addAssignment_31745,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,6)
    <=> v53219(VarCurr,6) ) ).

tff(addAssignment_31744,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,70)
    <=> v52325(VarCurr,70) ) ).

tff(addAssignment_31743,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,142)
    <=> v6238(VarCurr,142) ) ).

tff(addAssignment_31742,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,142)
    <=> v6240(VarCurr,142) ) ).

tff(addAssignment_31741,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,142)
    <=> v47849(VarCurr,10) ) ).

tff(addAssignment_31740,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,6)
    <=> v53211(VarCurr,6) ) ).

tff(addAssignment_31739,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_31738,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,6)
    <=> v53154(VarCurr,6) ) ).

tff(addAssignment_31737,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,6)
    <=> v53155(VarCurr,6) ) ).

tff(addAssignment_31736,axiom,
    ! [VarCurr: state_type] :
      ( v55496(VarCurr)
    <=> v55498(VarCurr) ) ).

tff(addAssignment_31735,axiom,
    ! [VarCurr: state_type] :
      ( v55498(VarCurr)
    <=> v6017(VarCurr,62) ) ).

tff(addAssignment_31734,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,62)
    <=> v6019(VarCurr,62) ) ).

tff(addAssignment_31733,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,62)
    <=> v6021(VarCurr,62) ) ).

tff(addAssignment_31732,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,62)
    <=> v6023(VarCurr,62) ) ).

tff(addAssignment_31731,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,62)
    <=> v6025(VarCurr,62) ) ).

tff(addAssignment_31730,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,62)
    <=> v6027(VarCurr,62) ) ).

tff(addAssignment_31729,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,62)
    <=> v52434(VarCurr,62) ) ).

tff(addAssignment_31728,axiom,
    ! [VarCurr: state_type] :
      ( v52451(VarCurr,2)
    <=> v6031(VarCurr,62) ) ).

tff(addAssignment_31727,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,62)
    <=> v6033(VarCurr,62) ) ).

tff(addAssignment_31726,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,62)
    <=> v55500(VarNext,62) ) ).

tff(addCaseBooleanConditionEqualRanges1_705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55501(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55500(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_705,axiom,
    ! [VarNext: state_type] :
      ( v55501(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55500(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55501(VarNext)
      <=> v55502(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55502(VarNext)
      <=> ( v55504(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55504(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_31725,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,62)
    <=> v6057(VarCurr,62) ) ).

tff(addAssignment_31724,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,62)
    <=> v6059(VarCurr,62) ) ).

tff(addAssignment_31723,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,62)
    <=> v54738(VarCurr,2) ) ).

tff(addAssignment_31722,axiom,
    ! [VarCurr: state_type] :
      ( v54738(VarCurr,2)
    <=> v54740(VarCurr,2) ) ).

tff(addAssignment_31721,axiom,
    ! [VarCurr: state_type] :
      ( v54740(VarCurr,2)
    <=> v54757(VarCurr,2) ) ).

tff(addAssignment_31720,axiom,
    ! [VarCurr: state_type] :
      ( v54750(VarCurr,2)
    <=> v54752(VarCurr,2) ) ).

tff(addAssignment_31719,axiom,
    ! [VarCurr: state_type] :
      ( v54752(VarCurr,2)
    <=> v6069(VarCurr,62) ) ).

tff(addAssignment_31718,axiom,
    ! [VarCurr: state_type] :
      ( v54742(VarCurr,2)
    <=> v54744(VarCurr,2) ) ).

tff(addAssignment_31717,axiom,
    ! [VarCurr: state_type] :
      ( v54744(VarCurr,2)
    <=> v6069(VarCurr,66) ) ).

tff(addAssignment_31716,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,66)
    <=> v53148(VarCurr,2) ) ).

tff(addAssignment_31715,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,2)
    <=> v53150(VarCurr,2) ) ).

tff(addAssignment_31714,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,2)
    <=> v53242(VarCurr,2) ) ).

tff(addAssignment_31713,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,2)
    <=> v53160(VarCurr,2) ) ).

tff(addAssignment_31712,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,2)
    <=> v6098(VarCurr,66) ) ).

tff(addAssignment_31711,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,66)
    <=> v6100(VarCurr,66) ) ).

tff(addAssignment_31710,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,66)
    <=> v6102(VarCurr,66) ) ).

tff(addAssignment_31709,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,66)
    <=> v53162(VarCurr,2) ) ).

tff(addAssignment_31708,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,2)
    <=> v53164(VarCurr,2) ) ).

tff(addAssignment_31707,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,2)
    <=> v53225(VarCurr,2) ) ).

tff(addAssignment_31706,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,2)
    <=> v53223(VarCurr,2) ) ).

tff(addAssignment_31705,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,2)
    <=> v53224(VarCurr,2) ) ).

tff(addAssignment_31704,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,66)
    <=> v52335(VarCurr,66) ) ).

tff(addAssignment_31703,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,132)
    <=> v33839(VarCurr,132) ) ).

tff(addAssignment_31702,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,132)
    <=> v33841(VarCurr,132) ) ).

tff(addAssignment_31701,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,132)
    <=> v26555(VarCurr,0) ) ).

tff(addAssignment_31700,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,2)
    <=> v53215(VarCurr,2) ) ).

tff(addAssignment_31699,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,2)
    <=> v53219(VarCurr,2) ) ).

tff(addAssignment_31698,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,66)
    <=> v52325(VarCurr,66) ) ).

tff(addAssignment_31697,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,138)
    <=> v6238(VarCurr,138) ) ).

tff(addAssignment_31696,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,138)
    <=> v6240(VarCurr,138) ) ).

tff(addAssignment_31695,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,138)
    <=> v47849(VarCurr,6) ) ).

tff(addAssignment_31694,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,2)
    <=> v53211(VarCurr,2) ) ).

tff(addAssignment_31693,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_31692,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,2)
    <=> v53154(VarCurr,2) ) ).

tff(addAssignment_31691,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,2)
    <=> v53155(VarCurr,2) ) ).

tff(addAssignment_31690,axiom,
    ! [VarCurr: state_type] :
      ( v54702(VarCurr)
    <=> v54704(VarCurr) ) ).

tff(addAssignment_31689,axiom,
    ! [VarCurr: state_type] :
      ( v54704(VarCurr)
    <=> v54706(VarCurr,3) ) ).

tff(addAssignment_31688,axiom,
    ! [VarCurr: state_type] :
      ( v54706(VarCurr,3)
    <=> v5977(VarCurr,7) ) ).

tff(addAssignment_31687,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,7)
    <=> v5979(VarCurr,7) ) ).

tff(addAssignment_31686,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,7)
    <=> v5981(VarCurr,7) ) ).

tff(addAssignment_31685,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,7)
    <=> v5983(VarCurr,7) ) ).

tff(addAssignment_31684,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,7)
    <=> v5985(VarCurr,7) ) ).

tff(addAssignment_31683,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,7)
    <=> v53672(VarCurr,7) ) ).

tff(addAssignment_31682,axiom,
    ! [VarCurr: state_type] :
      ( v53674(VarCurr,3)
    <=> v54709(VarCurr) ) ).

tff(addAssignment_31681,axiom,
    ! [VarCurr: state_type] :
      ( v54709(VarCurr)
    <=> v54711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5193,axiom,
    ! [VarCurr: state_type] :
      ( v54711(VarCurr)
    <=> ( v55466(VarCurr)
      <~> v55423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5192,axiom,
    ! [VarCurr: state_type] :
      ( v55466(VarCurr)
    <=> ( v54713(VarCurr)
      <~> v55121(VarCurr) ) ) ).

tff(addAssignment_31680,axiom,
    ! [VarCurr: state_type] :
      ( v55423(VarCurr)
    <=> v55425(VarCurr) ) ).

tff(addAssignment_31679,axiom,
    ! [VarCurr: state_type] :
      ( v55425(VarCurr)
    <=> v55427(VarCurr,3) ) ).

tff(addAssignment_31678,axiom,
    ! [VarCurr: state_type] :
      ( v55427(VarCurr,3)
    <=> v55429(VarCurr,3) ) ).

tff(addAssignment_31677,axiom,
    ! [VarCurr: state_type] :
      ( v55429(VarCurr,3)
    <=> v53454(VarCurr,8) ) ).

tff(addAssignment_31676,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,8)
    <=> v53456(VarCurr,8) ) ).

tff(addAssignment_31675,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,8)
    <=> v55458(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55459(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v55458(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_704,axiom,
    ! [VarNext: state_type] :
      ( v55459(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v55458(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55459(VarNext)
      <=> v55460(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55460(VarNext)
      <=> ( v55462(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55462(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_31674,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,8)
    <=> v53480(VarCurr,8) ) ).

tff(addAssignment_31673,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,8)
    <=> v53525(VarCurr,8) ) ).

tff(addAssignment_31672,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,7)
    <=> v55431(VarCurr,3) ) ).

tff(addAssignment_31671,axiom,
    ! [VarCurr: state_type] :
      ( v55431(VarCurr,3)
    <=> v55433(VarCurr,3) ) ).

tff(addAssignment_31670,axiom,
    ! [VarCurr: state_type] :
      ( v55433(VarCurr,3)
    <=> v55450(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55450(VarCurr,B)
      <=> ( v55451(VarCurr,B)
          | v55454(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55454(VarCurr,B)
      <=> ( v55443(VarCurr,B)
          & v55455(VarCurr,B) ) ) ) ).

tff(addAssignment_31669,axiom,
    ! [VarCurr: state_type] :
      ( v55455(VarCurr,0)
    <=> v55456(VarCurr) ) ).

tff(addAssignment_31668,axiom,
    ! [VarCurr: state_type] :
      ( v55455(VarCurr,1)
    <=> v55456(VarCurr) ) ).

tff(addAssignment_31667,axiom,
    ! [VarCurr: state_type] :
      ( v55455(VarCurr,2)
    <=> v55456(VarCurr) ) ).

tff(addAssignment_31666,axiom,
    ! [VarCurr: state_type] :
      ( v55455(VarCurr,3)
    <=> v55456(VarCurr) ) ).

tff(addAssignment_31665,axiom,
    ! [VarCurr: state_type] :
      ( v55456(VarCurr)
    <=> v55447(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55451(VarCurr,B)
      <=> ( v55435(VarCurr,B)
          & v55452(VarCurr,B) ) ) ) ).

tff(addAssignment_31664,axiom,
    ! [VarCurr: state_type] :
      ( v55452(VarCurr,0)
    <=> v55453(VarCurr) ) ).

tff(addAssignment_31663,axiom,
    ! [VarCurr: state_type] :
      ( v55452(VarCurr,1)
    <=> v55453(VarCurr) ) ).

tff(addAssignment_31662,axiom,
    ! [VarCurr: state_type] :
      ( v55452(VarCurr,2)
    <=> v55453(VarCurr) ) ).

tff(addAssignment_31661,axiom,
    ! [VarCurr: state_type] :
      ( v55452(VarCurr,3)
    <=> v55453(VarCurr) ) ).

tff(addAssignment_31660,axiom,
    ! [VarCurr: state_type] :
      ( v55453(VarCurr)
    <=> v55439(VarCurr) ) ).

tff(addAssignment_31659,axiom,
    ! [VarCurr: state_type] :
      ( v55447(VarCurr)
    <=> v55449(VarCurr) ) ).

tff(addAssignment_31658,axiom,
    ! [VarCurr: state_type] :
      ( v55449(VarCurr)
    <=> v52379(VarCurr,34) ) ).

tff(addAssignment_31657,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,34)
    <=> v52381(VarCurr,34) ) ).

tff(addAssignment_31656,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,34)
    <=> v52383(VarCurr,34) ) ).

tff(addAssignment_31655,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,34)
    <=> v52384(VarCurr,34) ) ).

tff(addAssignment_31654,axiom,
    ! [VarCurr: state_type] :
      ( v55443(VarCurr,3)
    <=> v55445(VarCurr,3) ) ).

tff(addAssignment_31653,axiom,
    ! [VarCurr: state_type] :
      ( v55445(VarCurr,3)
    <=> v53312(VarCurr,7) ) ).

tff(addAssignment_31652,axiom,
    ! [VarCurr: state_type] :
      ( v55439(VarCurr)
    <=> v55441(VarCurr) ) ).

tff(addAssignment_31651,axiom,
    ! [VarCurr: state_type] :
      ( v55441(VarCurr)
    <=> v52361(VarCurr,34) ) ).

tff(addAssignment_31650,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,34)
    <=> v52363(VarCurr,34) ) ).

tff(addAssignment_31649,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,34)
    <=> v52365(VarCurr,34) ) ).

tff(addAssignment_31648,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,34)
    <=> v52367(VarCurr,34) ) ).

tff(addAssignment_31647,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,34)
    <=> v52369(VarCurr,34) ) ).

tff(addAssignment_31646,axiom,
    ! [VarCurr: state_type] :
      ( v55435(VarCurr,3)
    <=> v55437(VarCurr,3) ) ).

tff(addAssignment_31645,axiom,
    ! [VarCurr: state_type] :
      ( v55437(VarCurr,3)
    <=> v53312(VarCurr,3) ) ).

tff(addAssignment_31644,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,3)
    <=> v53314(VarCurr,3) ) ).

tff(addAssignment_31643,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,3)
    <=> v53316(VarCurr,3) ) ).

tff(addAssignment_31642,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,3)
    <=> v53407(VarCurr,3) ) ).

tff(addAssignment_31641,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,3)
    <=> v53326(VarCurr,3) ) ).

tff(addAssignment_31640,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,3)
    <=> v53328(VarCurr,3) ) ).

tff(addAssignment_31639,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,3)
    <=> v6100(VarCurr,131) ) ).

tff(addAssignment_31638,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,131)
    <=> v6102(VarCurr,131) ) ).

tff(addAssignment_31637,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,131)
    <=> v53330(VarCurr,3) ) ).

tff(addAssignment_31636,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,3)
    <=> v53332(VarCurr,3) ) ).

tff(addAssignment_31635,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,3)
    <=> v53390(VarCurr,3) ) ).

tff(addAssignment_31634,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,3)
    <=> v53387(VarCurr,3) ) ).

tff(addAssignment_31633,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,3)
    <=> v53217(VarCurr,59) ) ).

tff(addAssignment_31632,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,3)
    <=> v53383(VarCurr,3) ) ).

tff(addAssignment_31631,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,3)
    <=> v53217(VarCurr,59) ) ).

tff(addAssignment_31630,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,59)
    <=> v53218(VarCurr,59) ) ).

tff(addAssignment_31629,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,113)
    <=> v6238(VarCurr,113) ) ).

tff(addAssignment_31628,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,113)
    <=> v6240(VarCurr,113) ) ).

tff(addAssignment_31627,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,113)
    <=> v44749(VarCurr,5) ) ).

tff(addAssignment_31626,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,3)
    <=> v53379(VarCurr,3) ) ).

tff(addAssignment_31625,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_31624,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,3)
    <=> v53320(VarCurr,3) ) ).

tff(addAssignment_31623,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,3)
    <=> v53321(VarCurr,3) ) ).

tff(addAssignment_31622,axiom,
    ! [VarCurr: state_type] :
      ( v55121(VarCurr)
    <=> v55123(VarCurr) ) ).

tff(addAssignment_31621,axiom,
    ! [VarCurr: state_type] :
      ( v55123(VarCurr)
    <=> v55125(VarCurr) ) ).

tff(addAssignment_31620,axiom,
    ! [VarCurr: state_type] :
      ( v55125(VarCurr)
    <=> v55127(VarCurr) ) ).

tff(addAssignment_31619,axiom,
    ! [VarCurr: state_type] :
      ( v55127(VarCurr)
    <=> v55129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5189,axiom,
    ! [VarCurr: state_type] :
      ( v55129(VarCurr)
    <=> ( v55421(VarCurr)
      <~> v55395(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5188,axiom,
    ! [VarCurr: state_type] :
      ( v55421(VarCurr)
    <=> ( v55131(VarCurr)
      <~> v55263(VarCurr) ) ) ).

tff(addAssignment_31618,axiom,
    ! [VarCurr: state_type] :
      ( v55395(VarCurr)
    <=> v55397(VarCurr) ) ).

tff(addAssignment_31617,axiom,
    ! [VarCurr: state_type] :
      ( v55397(VarCurr)
    <=> v55399(VarCurr) ) ).

tff(addAssignment_31616,axiom,
    ! [VarCurr: state_type] :
      ( v55399(VarCurr)
    <=> v55401(VarCurr) ) ).

tff(addAssignment_31615,axiom,
    ! [VarCurr: state_type] :
      ( v55401(VarCurr)
    <=> v55403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5187,axiom,
    ! [VarCurr: state_type] :
      ( v55403(VarCurr)
    <=> ( v55419(VarCurr)
      <~> v55413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5186,axiom,
    ! [VarCurr: state_type] :
      ( v55419(VarCurr)
    <=> ( v55405(VarCurr)
      <~> v55409(VarCurr) ) ) ).

tff(addAssignment_31614,axiom,
    ! [VarCurr: state_type] :
      ( v55413(VarCurr)
    <=> v55415(VarCurr) ) ).

tff(addAssignment_31613,axiom,
    ! [VarCurr: state_type] :
      ( v55415(VarCurr)
    <=> v55417(VarCurr) ) ).

tff(addAssignment_31612,axiom,
    ! [VarCurr: state_type] :
      ( v55417(VarCurr)
    <=> v53442(VarCurr,0) ) ).

tff(addAssignment_31611,axiom,
    ! [VarCurr: state_type] :
      ( v53442(VarCurr,0)
    <=> v53444(VarCurr,0) ) ).

tff(addAssignment_31610,axiom,
    ! [VarCurr: state_type] :
      ( v53444(VarCurr,0)
    <=> v53446(VarCurr,0) ) ).

tff(addAssignment_31609,axiom,
    ! [VarCurr: state_type] :
      ( v53446(VarCurr,0)
    <=> v53448(VarCurr,0) ) ).

tff(addAssignment_31608,axiom,
    ! [VarCurr: state_type] :
      ( v53448(VarCurr,0)
    <=> v53563(VarCurr,0) ) ).

tff(addAssignment_31607,axiom,
    ! [VarCurr: state_type] :
      ( v55409(VarCurr)
    <=> v55411(VarCurr) ) ).

tff(addAssignment_31606,axiom,
    ! [VarCurr: state_type] :
      ( v55411(VarCurr)
    <=> v6017(VarCurr,127) ) ).

tff(addAssignment_31605,axiom,
    ! [VarCurr: state_type] :
      ( v55405(VarCurr)
    <=> v55407(VarCurr) ) ).

tff(addAssignment_31604,axiom,
    ! [VarCurr: state_type] :
      ( v55407(VarCurr)
    <=> v6017(VarCurr,123) ) ).

tff(addAssignment_31603,axiom,
    ! [VarCurr: state_type] :
      ( v55263(VarCurr)
    <=> v55265(VarCurr) ) ).

tff(addAssignment_31602,axiom,
    ! [VarCurr: state_type] :
      ( v55265(VarCurr)
    <=> v55267(VarCurr) ) ).

tff(addAssignment_31601,axiom,
    ! [VarCurr: state_type] :
      ( v55267(VarCurr)
    <=> v55269(VarCurr) ) ).

tff(addAssignment_31600,axiom,
    ! [VarCurr: state_type] :
      ( v55269(VarCurr)
    <=> v55271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5185,axiom,
    ! [VarCurr: state_type] :
      ( v55271(VarCurr)
    <=> ( v55393(VarCurr)
      <~> v55353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5184,axiom,
    ! [VarCurr: state_type] :
      ( v55393(VarCurr)
    <=> ( v55273(VarCurr)
      <~> v55313(VarCurr) ) ) ).

tff(addAssignment_31599,axiom,
    ! [VarCurr: state_type] :
      ( v55353(VarCurr)
    <=> v55355(VarCurr) ) ).

tff(addAssignment_31598,axiom,
    ! [VarCurr: state_type] :
      ( v55355(VarCurr)
    <=> v6017(VarCurr,119) ) ).

tff(addAssignment_31597,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,119)
    <=> v53103(VarCurr,55) ) ).

tff(addAssignment_31596,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,55)
    <=> v53105(VarCurr,55) ) ).

tff(addAssignment_31595,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,55)
    <=> v53107(VarCurr,55) ) ).

tff(addAssignment_31594,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,55)
    <=> v53109(VarCurr,55) ) ).

tff(addAssignment_31593,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,55)
    <=> v6027(VarCurr,119) ) ).

tff(addAssignment_31592,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,119)
    <=> v52434(VarCurr,119) ) ).

tff(addAssignment_31591,axiom,
    ! [VarCurr: state_type] :
      ( v52437(VarCurr,3)
    <=> v53112(VarCurr,55) ) ).

tff(addAssignment_31590,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,55)
    <=> v53114(VarCurr,55) ) ).

tff(addAssignment_31589,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,55)
    <=> v55385(VarNext,55) ) ).

tff(addCaseBooleanConditionEqualRanges1_703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55386(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55385(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_703,axiom,
    ! [VarNext: state_type] :
      ( v55386(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55385(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55386(VarNext)
      <=> v55387(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55387(VarNext)
      <=> ( v55389(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55389(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31588,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,55)
    <=> v53138(VarCurr,55) ) ).

tff(addAssignment_31587,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,55)
    <=> v6059(VarCurr,119) ) ).

tff(addAssignment_31586,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,119)
    <=> v55358(VarCurr,3) ) ).

tff(addAssignment_31585,axiom,
    ! [VarCurr: state_type] :
      ( v55358(VarCurr,3)
    <=> v55360(VarCurr,3) ) ).

tff(addAssignment_31584,axiom,
    ! [VarCurr: state_type] :
      ( v55360(VarCurr,3)
    <=> v55377(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55377(VarCurr,B)
      <=> ( v55378(VarCurr,B)
          | v55381(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55381(VarCurr,B)
      <=> ( v55370(VarCurr,B)
          & v55382(VarCurr,B) ) ) ) ).

tff(addAssignment_31583,axiom,
    ! [VarCurr: state_type] :
      ( v55382(VarCurr,0)
    <=> v55383(VarCurr) ) ).

tff(addAssignment_31582,axiom,
    ! [VarCurr: state_type] :
      ( v55382(VarCurr,1)
    <=> v55383(VarCurr) ) ).

tff(addAssignment_31581,axiom,
    ! [VarCurr: state_type] :
      ( v55382(VarCurr,2)
    <=> v55383(VarCurr) ) ).

tff(addAssignment_31580,axiom,
    ! [VarCurr: state_type] :
      ( v55382(VarCurr,3)
    <=> v55383(VarCurr) ) ).

tff(addAssignment_31579,axiom,
    ! [VarCurr: state_type] :
      ( v55383(VarCurr)
    <=> v55374(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55378(VarCurr,B)
      <=> ( v55362(VarCurr,B)
          & v55379(VarCurr,B) ) ) ) ).

tff(addAssignment_31578,axiom,
    ! [VarCurr: state_type] :
      ( v55379(VarCurr,0)
    <=> v55380(VarCurr) ) ).

tff(addAssignment_31577,axiom,
    ! [VarCurr: state_type] :
      ( v55379(VarCurr,1)
    <=> v55380(VarCurr) ) ).

tff(addAssignment_31576,axiom,
    ! [VarCurr: state_type] :
      ( v55379(VarCurr,2)
    <=> v55380(VarCurr) ) ).

tff(addAssignment_31575,axiom,
    ! [VarCurr: state_type] :
      ( v55379(VarCurr,3)
    <=> v55380(VarCurr) ) ).

tff(addAssignment_31574,axiom,
    ! [VarCurr: state_type] :
      ( v55380(VarCurr)
    <=> v55366(VarCurr) ) ).

tff(addAssignment_31573,axiom,
    ! [VarCurr: state_type] :
      ( v55374(VarCurr)
    <=> v55376(VarCurr) ) ).

tff(addAssignment_31572,axiom,
    ! [VarCurr: state_type] :
      ( v55376(VarCurr)
    <=> v52379(VarCurr,29) ) ).

tff(addAssignment_31571,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,29)
    <=> v52381(VarCurr,29) ) ).

tff(addAssignment_31570,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,29)
    <=> v52383(VarCurr,29) ) ).

tff(addAssignment_31569,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,29)
    <=> v52384(VarCurr,29) ) ).

tff(addAssignment_31568,axiom,
    ! [VarCurr: state_type] :
      ( v55370(VarCurr,3)
    <=> v55372(VarCurr,3) ) ).

tff(addAssignment_31567,axiom,
    ! [VarCurr: state_type] :
      ( v55372(VarCurr,3)
    <=> v6069(VarCurr,119) ) ).

tff(addAssignment_31566,axiom,
    ! [VarCurr: state_type] :
      ( v55366(VarCurr)
    <=> v55368(VarCurr) ) ).

tff(addAssignment_31565,axiom,
    ! [VarCurr: state_type] :
      ( v55368(VarCurr)
    <=> v52361(VarCurr,29) ) ).

tff(addAssignment_31564,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,29)
    <=> v52363(VarCurr,29) ) ).

tff(addAssignment_31563,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,29)
    <=> v52365(VarCurr,29) ) ).

tff(addAssignment_31562,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,29)
    <=> v52367(VarCurr,29) ) ).

tff(addAssignment_31561,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,29)
    <=> v52369(VarCurr,29) ) ).

tff(addAssignment_31560,axiom,
    ! [VarCurr: state_type] :
      ( v55362(VarCurr,3)
    <=> v55364(VarCurr,3) ) ).

tff(addAssignment_31559,axiom,
    ! [VarCurr: state_type] :
      ( v55364(VarCurr,3)
    <=> v6069(VarCurr,123) ) ).

tff(addAssignment_31558,axiom,
    ! [VarCurr: state_type] :
      ( v55313(VarCurr)
    <=> v55315(VarCurr) ) ).

tff(addAssignment_31557,axiom,
    ! [VarCurr: state_type] :
      ( v55315(VarCurr)
    <=> v6017(VarCurr,115) ) ).

tff(addAssignment_31556,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,115)
    <=> v53103(VarCurr,51) ) ).

tff(addAssignment_31555,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,51)
    <=> v53105(VarCurr,51) ) ).

tff(addAssignment_31554,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,51)
    <=> v53107(VarCurr,51) ) ).

tff(addAssignment_31553,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,51)
    <=> v53109(VarCurr,51) ) ).

tff(addAssignment_31552,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,51)
    <=> v6027(VarCurr,115) ) ).

tff(addAssignment_31551,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,115)
    <=> v52434(VarCurr,115) ) ).

tff(addAssignment_31550,axiom,
    ! [VarCurr: state_type] :
      ( v52438(VarCurr,3)
    <=> v53112(VarCurr,51) ) ).

tff(addAssignment_31549,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,51)
    <=> v53114(VarCurr,51) ) ).

tff(addAssignment_31548,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,51)
    <=> v55345(VarNext,51) ) ).

tff(addCaseBooleanConditionEqualRanges1_702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55346(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55345(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_702,axiom,
    ! [VarNext: state_type] :
      ( v55346(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55345(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55346(VarNext)
      <=> v55347(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55347(VarNext)
      <=> ( v55349(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55349(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31547,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,51)
    <=> v53138(VarCurr,51) ) ).

tff(addAssignment_31546,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,51)
    <=> v6059(VarCurr,115) ) ).

tff(addAssignment_31545,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,115)
    <=> v55318(VarCurr,3) ) ).

tff(addAssignment_31544,axiom,
    ! [VarCurr: state_type] :
      ( v55318(VarCurr,3)
    <=> v55320(VarCurr,3) ) ).

tff(addAssignment_31543,axiom,
    ! [VarCurr: state_type] :
      ( v55320(VarCurr,3)
    <=> v55337(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55337(VarCurr,B)
      <=> ( v55338(VarCurr,B)
          | v55341(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_931,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55341(VarCurr,B)
      <=> ( v55330(VarCurr,B)
          & v55342(VarCurr,B) ) ) ) ).

tff(addAssignment_31542,axiom,
    ! [VarCurr: state_type] :
      ( v55342(VarCurr,0)
    <=> v55343(VarCurr) ) ).

tff(addAssignment_31541,axiom,
    ! [VarCurr: state_type] :
      ( v55342(VarCurr,1)
    <=> v55343(VarCurr) ) ).

tff(addAssignment_31540,axiom,
    ! [VarCurr: state_type] :
      ( v55342(VarCurr,2)
    <=> v55343(VarCurr) ) ).

tff(addAssignment_31539,axiom,
    ! [VarCurr: state_type] :
      ( v55342(VarCurr,3)
    <=> v55343(VarCurr) ) ).

tff(addAssignment_31538,axiom,
    ! [VarCurr: state_type] :
      ( v55343(VarCurr)
    <=> v55334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_930,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55338(VarCurr,B)
      <=> ( v55322(VarCurr,B)
          & v55339(VarCurr,B) ) ) ) ).

tff(addAssignment_31537,axiom,
    ! [VarCurr: state_type] :
      ( v55339(VarCurr,0)
    <=> v55340(VarCurr) ) ).

tff(addAssignment_31536,axiom,
    ! [VarCurr: state_type] :
      ( v55339(VarCurr,1)
    <=> v55340(VarCurr) ) ).

tff(addAssignment_31535,axiom,
    ! [VarCurr: state_type] :
      ( v55339(VarCurr,2)
    <=> v55340(VarCurr) ) ).

tff(addAssignment_31534,axiom,
    ! [VarCurr: state_type] :
      ( v55339(VarCurr,3)
    <=> v55340(VarCurr) ) ).

tff(addAssignment_31533,axiom,
    ! [VarCurr: state_type] :
      ( v55340(VarCurr)
    <=> v55326(VarCurr) ) ).

tff(addAssignment_31532,axiom,
    ! [VarCurr: state_type] :
      ( v55334(VarCurr)
    <=> v55336(VarCurr) ) ).

tff(addAssignment_31531,axiom,
    ! [VarCurr: state_type] :
      ( v55336(VarCurr)
    <=> v52379(VarCurr,28) ) ).

tff(addAssignment_31530,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,28)
    <=> v52381(VarCurr,28) ) ).

tff(addAssignment_31529,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,28)
    <=> v52383(VarCurr,28) ) ).

tff(addAssignment_31528,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,28)
    <=> v52384(VarCurr,28) ) ).

tff(addAssignment_31527,axiom,
    ! [VarCurr: state_type] :
      ( v55330(VarCurr,3)
    <=> v55332(VarCurr,3) ) ).

tff(addAssignment_31526,axiom,
    ! [VarCurr: state_type] :
      ( v55332(VarCurr,3)
    <=> v6069(VarCurr,115) ) ).

tff(addAssignment_31525,axiom,
    ! [VarCurr: state_type] :
      ( v55326(VarCurr)
    <=> v55328(VarCurr) ) ).

tff(addAssignment_31524,axiom,
    ! [VarCurr: state_type] :
      ( v55328(VarCurr)
    <=> v52361(VarCurr,28) ) ).

tff(addAssignment_31523,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,28)
    <=> v52363(VarCurr,28) ) ).

tff(addAssignment_31522,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,28)
    <=> v52365(VarCurr,28) ) ).

tff(addAssignment_31521,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,28)
    <=> v52367(VarCurr,28) ) ).

tff(addAssignment_31520,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,28)
    <=> v52369(VarCurr,28) ) ).

tff(addAssignment_31519,axiom,
    ! [VarCurr: state_type] :
      ( v55322(VarCurr,3)
    <=> v55324(VarCurr,3) ) ).

tff(addAssignment_31518,axiom,
    ! [VarCurr: state_type] :
      ( v55324(VarCurr,3)
    <=> v6069(VarCurr,119) ) ).

tff(addAssignment_31517,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,119)
    <=> v53148(VarCurr,55) ) ).

tff(addAssignment_31516,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,55)
    <=> v53150(VarCurr,55) ) ).

tff(addAssignment_31515,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,55)
    <=> v53242(VarCurr,55) ) ).

tff(addAssignment_31514,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,55)
    <=> v53160(VarCurr,55) ) ).

tff(addAssignment_31513,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,55)
    <=> v6098(VarCurr,119) ) ).

tff(addAssignment_31512,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,119)
    <=> v6100(VarCurr,119) ) ).

tff(addAssignment_31511,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,119)
    <=> v6102(VarCurr,119) ) ).

tff(addAssignment_31510,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,119)
    <=> v53162(VarCurr,55) ) ).

tff(addAssignment_31509,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,55)
    <=> v53164(VarCurr,55) ) ).

tff(addAssignment_31508,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,55)
    <=> v53225(VarCurr,55) ) ).

tff(addAssignment_31507,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,55)
    <=> v53223(VarCurr,55) ) ).

tff(addAssignment_31506,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,55)
    <=> v53224(VarCurr,55) ) ).

tff(addAssignment_31505,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,55)
    <=> v53215(VarCurr,55) ) ).

tff(addAssignment_31504,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,55)
    <=> v53219(VarCurr,55) ) ).

tff(addAssignment_31503,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,47)
    <=> v53218(VarCurr,47) ) ).

tff(addAssignment_31502,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,89)
    <=> v6238(VarCurr,89) ) ).

tff(addAssignment_31501,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,89)
    <=> v6240(VarCurr,89) ) ).

tff(addAssignment_31500,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,89)
    <=> v41649(VarCurr,5) ) ).

tff(addAssignment_31499,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,55)
    <=> v53211(VarCurr,55) ) ).

tff(addAssignment_31498,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,55)
    <=> $false ) ).

tff(addAssignment_31497,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,55)
    <=> v53154(VarCurr,55) ) ).

tff(addAssignment_31496,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,55)
    <=> v53155(VarCurr,55) ) ).

tff(addAssignment_31495,axiom,
    ! [VarCurr: state_type] :
      ( v55273(VarCurr)
    <=> v55275(VarCurr) ) ).

tff(addAssignment_31494,axiom,
    ! [VarCurr: state_type] :
      ( v55275(VarCurr)
    <=> v6017(VarCurr,111) ) ).

tff(addAssignment_31493,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,111)
    <=> v53103(VarCurr,47) ) ).

tff(addAssignment_31492,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,47)
    <=> v53105(VarCurr,47) ) ).

tff(addAssignment_31491,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,47)
    <=> v53107(VarCurr,47) ) ).

tff(addAssignment_31490,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,47)
    <=> v53109(VarCurr,47) ) ).

tff(addAssignment_31489,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,47)
    <=> v6027(VarCurr,111) ) ).

tff(addAssignment_31488,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,111)
    <=> v52434(VarCurr,111) ) ).

tff(addAssignment_31487,axiom,
    ! [VarCurr: state_type] :
      ( v52439(VarCurr,3)
    <=> v53112(VarCurr,47) ) ).

tff(addAssignment_31486,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,47)
    <=> v53114(VarCurr,47) ) ).

tff(addAssignment_31485,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,47)
    <=> v55305(VarNext,47) ) ).

tff(addCaseBooleanConditionEqualRanges1_701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55306(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55305(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_701,axiom,
    ! [VarNext: state_type] :
      ( v55306(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55305(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55306(VarNext)
      <=> v55307(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55307(VarNext)
      <=> ( v55309(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55309(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31484,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,47)
    <=> v53138(VarCurr,47) ) ).

tff(addAssignment_31483,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,47)
    <=> v6059(VarCurr,111) ) ).

tff(addAssignment_31482,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,111)
    <=> v55278(VarCurr,3) ) ).

tff(addAssignment_31481,axiom,
    ! [VarCurr: state_type] :
      ( v55278(VarCurr,3)
    <=> v55280(VarCurr,3) ) ).

tff(addAssignment_31480,axiom,
    ! [VarCurr: state_type] :
      ( v55280(VarCurr,3)
    <=> v55297(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55297(VarCurr,B)
      <=> ( v55298(VarCurr,B)
          | v55301(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55301(VarCurr,B)
      <=> ( v55290(VarCurr,B)
          & v55302(VarCurr,B) ) ) ) ).

tff(addAssignment_31479,axiom,
    ! [VarCurr: state_type] :
      ( v55302(VarCurr,0)
    <=> v55303(VarCurr) ) ).

tff(addAssignment_31478,axiom,
    ! [VarCurr: state_type] :
      ( v55302(VarCurr,1)
    <=> v55303(VarCurr) ) ).

tff(addAssignment_31477,axiom,
    ! [VarCurr: state_type] :
      ( v55302(VarCurr,2)
    <=> v55303(VarCurr) ) ).

tff(addAssignment_31476,axiom,
    ! [VarCurr: state_type] :
      ( v55302(VarCurr,3)
    <=> v55303(VarCurr) ) ).

tff(addAssignment_31475,axiom,
    ! [VarCurr: state_type] :
      ( v55303(VarCurr)
    <=> v55294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55298(VarCurr,B)
      <=> ( v55282(VarCurr,B)
          & v55299(VarCurr,B) ) ) ) ).

tff(addAssignment_31474,axiom,
    ! [VarCurr: state_type] :
      ( v55299(VarCurr,0)
    <=> v55300(VarCurr) ) ).

tff(addAssignment_31473,axiom,
    ! [VarCurr: state_type] :
      ( v55299(VarCurr,1)
    <=> v55300(VarCurr) ) ).

tff(addAssignment_31472,axiom,
    ! [VarCurr: state_type] :
      ( v55299(VarCurr,2)
    <=> v55300(VarCurr) ) ).

tff(addAssignment_31471,axiom,
    ! [VarCurr: state_type] :
      ( v55299(VarCurr,3)
    <=> v55300(VarCurr) ) ).

tff(addAssignment_31470,axiom,
    ! [VarCurr: state_type] :
      ( v55300(VarCurr)
    <=> v55286(VarCurr) ) ).

tff(addAssignment_31469,axiom,
    ! [VarCurr: state_type] :
      ( v55294(VarCurr)
    <=> v55296(VarCurr) ) ).

tff(addAssignment_31468,axiom,
    ! [VarCurr: state_type] :
      ( v55296(VarCurr)
    <=> v52379(VarCurr,27) ) ).

tff(addAssignment_31467,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,27)
    <=> v52381(VarCurr,27) ) ).

tff(addAssignment_31466,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,27)
    <=> v52383(VarCurr,27) ) ).

tff(addAssignment_31465,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,27)
    <=> v52384(VarCurr,27) ) ).

tff(addAssignment_31464,axiom,
    ! [VarCurr: state_type] :
      ( v55290(VarCurr,3)
    <=> v55292(VarCurr,3) ) ).

tff(addAssignment_31463,axiom,
    ! [VarCurr: state_type] :
      ( v55292(VarCurr,3)
    <=> v6069(VarCurr,111) ) ).

tff(addAssignment_31462,axiom,
    ! [VarCurr: state_type] :
      ( v55286(VarCurr)
    <=> v55288(VarCurr) ) ).

tff(addAssignment_31461,axiom,
    ! [VarCurr: state_type] :
      ( v55288(VarCurr)
    <=> v52361(VarCurr,27) ) ).

tff(addAssignment_31460,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,27)
    <=> v52363(VarCurr,27) ) ).

tff(addAssignment_31459,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,27)
    <=> v52365(VarCurr,27) ) ).

tff(addAssignment_31458,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,27)
    <=> v52367(VarCurr,27) ) ).

tff(addAssignment_31457,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,27)
    <=> v52369(VarCurr,27) ) ).

tff(addAssignment_31456,axiom,
    ! [VarCurr: state_type] :
      ( v55282(VarCurr,3)
    <=> v55284(VarCurr,3) ) ).

tff(addAssignment_31455,axiom,
    ! [VarCurr: state_type] :
      ( v55284(VarCurr,3)
    <=> v6069(VarCurr,115) ) ).

tff(addAssignment_31454,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,115)
    <=> v53148(VarCurr,51) ) ).

tff(addAssignment_31453,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,51)
    <=> v53150(VarCurr,51) ) ).

tff(addAssignment_31452,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,51)
    <=> v53242(VarCurr,51) ) ).

tff(addAssignment_31451,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,51)
    <=> v53160(VarCurr,51) ) ).

tff(addAssignment_31450,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,51)
    <=> v6098(VarCurr,115) ) ).

tff(addAssignment_31449,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,115)
    <=> v6100(VarCurr,115) ) ).

tff(addAssignment_31448,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,115)
    <=> v6102(VarCurr,115) ) ).

tff(addAssignment_31447,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,115)
    <=> v53162(VarCurr,51) ) ).

tff(addAssignment_31446,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,51)
    <=> v53164(VarCurr,51) ) ).

tff(addAssignment_31445,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,51)
    <=> v53225(VarCurr,51) ) ).

tff(addAssignment_31444,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,51)
    <=> v53223(VarCurr,51) ) ).

tff(addAssignment_31443,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,51)
    <=> v53224(VarCurr,51) ) ).

tff(addAssignment_31442,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,51)
    <=> v53215(VarCurr,51) ) ).

tff(addAssignment_31441,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,51)
    <=> v53219(VarCurr,51) ) ).

tff(addAssignment_31440,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,43)
    <=> v53218(VarCurr,43) ) ).

tff(addAssignment_31439,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,85)
    <=> v6238(VarCurr,85) ) ).

tff(addAssignment_31438,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,85)
    <=> v6240(VarCurr,85) ) ).

tff(addAssignment_31437,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,85)
    <=> v41649(VarCurr,1) ) ).

tff(addAssignment_31436,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,51)
    <=> v53211(VarCurr,51) ) ).

tff(addAssignment_31435,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,51)
    <=> $false ) ).

tff(addAssignment_31434,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,51)
    <=> v53154(VarCurr,51) ) ).

tff(addAssignment_31433,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,51)
    <=> v53155(VarCurr,51) ) ).

tff(addAssignment_31432,axiom,
    ! [VarCurr: state_type] :
      ( v55131(VarCurr)
    <=> v55133(VarCurr) ) ).

tff(addAssignment_31431,axiom,
    ! [VarCurr: state_type] :
      ( v55133(VarCurr)
    <=> v55135(VarCurr) ) ).

tff(addAssignment_31430,axiom,
    ! [VarCurr: state_type] :
      ( v55135(VarCurr)
    <=> v55137(VarCurr) ) ).

tff(addAssignment_31429,axiom,
    ! [VarCurr: state_type] :
      ( v55137(VarCurr)
    <=> v55139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5177,axiom,
    ! [VarCurr: state_type] :
      ( v55139(VarCurr)
    <=> ( v55261(VarCurr)
      <~> v55221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5176,axiom,
    ! [VarCurr: state_type] :
      ( v55261(VarCurr)
    <=> ( v55141(VarCurr)
      <~> v55181(VarCurr) ) ) ).

tff(addAssignment_31428,axiom,
    ! [VarCurr: state_type] :
      ( v55221(VarCurr)
    <=> v55223(VarCurr) ) ).

tff(addAssignment_31427,axiom,
    ! [VarCurr: state_type] :
      ( v55223(VarCurr)
    <=> v6017(VarCurr,107) ) ).

tff(addAssignment_31426,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,107)
    <=> v53103(VarCurr,43) ) ).

tff(addAssignment_31425,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,43)
    <=> v53105(VarCurr,43) ) ).

tff(addAssignment_31424,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,43)
    <=> v53107(VarCurr,43) ) ).

tff(addAssignment_31423,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,43)
    <=> v53109(VarCurr,43) ) ).

tff(addAssignment_31422,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,43)
    <=> v6027(VarCurr,107) ) ).

tff(addAssignment_31421,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,107)
    <=> v52434(VarCurr,107) ) ).

tff(addAssignment_31420,axiom,
    ! [VarCurr: state_type] :
      ( v52440(VarCurr,3)
    <=> v53112(VarCurr,43) ) ).

tff(addAssignment_31419,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,43)
    <=> v53114(VarCurr,43) ) ).

tff(addAssignment_31418,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,43)
    <=> v55253(VarNext,43) ) ).

tff(addCaseBooleanConditionEqualRanges1_700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55254(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55253(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_700,axiom,
    ! [VarNext: state_type] :
      ( v55254(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55253(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55254(VarNext)
      <=> v55255(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55255(VarNext)
      <=> ( v55257(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55257(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31417,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,43)
    <=> v53138(VarCurr,43) ) ).

tff(addAssignment_31416,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,43)
    <=> v6059(VarCurr,107) ) ).

tff(addAssignment_31415,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,107)
    <=> v55226(VarCurr,3) ) ).

tff(addAssignment_31414,axiom,
    ! [VarCurr: state_type] :
      ( v55226(VarCurr,3)
    <=> v55228(VarCurr,3) ) ).

tff(addAssignment_31413,axiom,
    ! [VarCurr: state_type] :
      ( v55228(VarCurr,3)
    <=> v55245(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55245(VarCurr,B)
      <=> ( v55246(VarCurr,B)
          | v55249(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55249(VarCurr,B)
      <=> ( v55238(VarCurr,B)
          & v55250(VarCurr,B) ) ) ) ).

tff(addAssignment_31412,axiom,
    ! [VarCurr: state_type] :
      ( v55250(VarCurr,0)
    <=> v55251(VarCurr) ) ).

tff(addAssignment_31411,axiom,
    ! [VarCurr: state_type] :
      ( v55250(VarCurr,1)
    <=> v55251(VarCurr) ) ).

tff(addAssignment_31410,axiom,
    ! [VarCurr: state_type] :
      ( v55250(VarCurr,2)
    <=> v55251(VarCurr) ) ).

tff(addAssignment_31409,axiom,
    ! [VarCurr: state_type] :
      ( v55250(VarCurr,3)
    <=> v55251(VarCurr) ) ).

tff(addAssignment_31408,axiom,
    ! [VarCurr: state_type] :
      ( v55251(VarCurr)
    <=> v55242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55246(VarCurr,B)
      <=> ( v55230(VarCurr,B)
          & v55247(VarCurr,B) ) ) ) ).

tff(addAssignment_31407,axiom,
    ! [VarCurr: state_type] :
      ( v55247(VarCurr,0)
    <=> v55248(VarCurr) ) ).

tff(addAssignment_31406,axiom,
    ! [VarCurr: state_type] :
      ( v55247(VarCurr,1)
    <=> v55248(VarCurr) ) ).

tff(addAssignment_31405,axiom,
    ! [VarCurr: state_type] :
      ( v55247(VarCurr,2)
    <=> v55248(VarCurr) ) ).

tff(addAssignment_31404,axiom,
    ! [VarCurr: state_type] :
      ( v55247(VarCurr,3)
    <=> v55248(VarCurr) ) ).

tff(addAssignment_31403,axiom,
    ! [VarCurr: state_type] :
      ( v55248(VarCurr)
    <=> v55234(VarCurr) ) ).

tff(addAssignment_31402,axiom,
    ! [VarCurr: state_type] :
      ( v55242(VarCurr)
    <=> v55244(VarCurr) ) ).

tff(addAssignment_31401,axiom,
    ! [VarCurr: state_type] :
      ( v55244(VarCurr)
    <=> v52379(VarCurr,26) ) ).

tff(addAssignment_31400,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,26)
    <=> v52381(VarCurr,26) ) ).

tff(addAssignment_31399,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,26)
    <=> v52383(VarCurr,26) ) ).

tff(addAssignment_31398,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,26)
    <=> v52384(VarCurr,26) ) ).

tff(addAssignment_31397,axiom,
    ! [VarCurr: state_type] :
      ( v55238(VarCurr,3)
    <=> v55240(VarCurr,3) ) ).

tff(addAssignment_31396,axiom,
    ! [VarCurr: state_type] :
      ( v55240(VarCurr,3)
    <=> v6069(VarCurr,107) ) ).

tff(addAssignment_31395,axiom,
    ! [VarCurr: state_type] :
      ( v55234(VarCurr)
    <=> v55236(VarCurr) ) ).

tff(addAssignment_31394,axiom,
    ! [VarCurr: state_type] :
      ( v55236(VarCurr)
    <=> v52361(VarCurr,26) ) ).

tff(addAssignment_31393,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,26)
    <=> v52363(VarCurr,26) ) ).

tff(addAssignment_31392,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,26)
    <=> v52365(VarCurr,26) ) ).

tff(addAssignment_31391,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,26)
    <=> v52367(VarCurr,26) ) ).

tff(addAssignment_31390,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,26)
    <=> v52369(VarCurr,26) ) ).

tff(addAssignment_31389,axiom,
    ! [VarCurr: state_type] :
      ( v55230(VarCurr,3)
    <=> v55232(VarCurr,3) ) ).

tff(addAssignment_31388,axiom,
    ! [VarCurr: state_type] :
      ( v55232(VarCurr,3)
    <=> v6069(VarCurr,111) ) ).

tff(addAssignment_31387,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,111)
    <=> v53148(VarCurr,47) ) ).

tff(addAssignment_31386,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,47)
    <=> v53150(VarCurr,47) ) ).

tff(addAssignment_31385,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,47)
    <=> v53242(VarCurr,47) ) ).

tff(addAssignment_31384,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,47)
    <=> v53160(VarCurr,47) ) ).

tff(addAssignment_31383,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,47)
    <=> v6098(VarCurr,111) ) ).

tff(addAssignment_31382,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,111)
    <=> v6100(VarCurr,111) ) ).

tff(addAssignment_31381,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,111)
    <=> v6102(VarCurr,111) ) ).

tff(addAssignment_31380,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,111)
    <=> v53162(VarCurr,47) ) ).

tff(addAssignment_31379,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,47)
    <=> v53164(VarCurr,47) ) ).

tff(addAssignment_31378,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,47)
    <=> v53225(VarCurr,47) ) ).

tff(addAssignment_31377,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,47)
    <=> v53223(VarCurr,47) ) ).

tff(addAssignment_31376,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,47)
    <=> v53224(VarCurr,47) ) ).

tff(addAssignment_31375,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,47)
    <=> v53215(VarCurr,47) ) ).

tff(addAssignment_31374,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,47)
    <=> v53219(VarCurr,47) ) ).

tff(addAssignment_31373,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,39)
    <=> v53218(VarCurr,39) ) ).

tff(addAssignment_31372,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,75)
    <=> v6238(VarCurr,75) ) ).

tff(addAssignment_31371,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,75)
    <=> v6240(VarCurr,75) ) ).

tff(addAssignment_31370,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,75)
    <=> v40099(VarCurr,3) ) ).

tff(addAssignment_31369,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,47)
    <=> v53211(VarCurr,47) ) ).

tff(addAssignment_31368,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,47)
    <=> $false ) ).

tff(addAssignment_31367,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,47)
    <=> v53154(VarCurr,47) ) ).

tff(addAssignment_31366,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,47)
    <=> v53155(VarCurr,47) ) ).

tff(addAssignment_31365,axiom,
    ! [VarCurr: state_type] :
      ( v55181(VarCurr)
    <=> v55183(VarCurr) ) ).

tff(addAssignment_31364,axiom,
    ! [VarCurr: state_type] :
      ( v55183(VarCurr)
    <=> v6017(VarCurr,103) ) ).

tff(addAssignment_31363,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,103)
    <=> v53103(VarCurr,39) ) ).

tff(addAssignment_31362,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,39)
    <=> v53105(VarCurr,39) ) ).

tff(addAssignment_31361,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,39)
    <=> v53107(VarCurr,39) ) ).

tff(addAssignment_31360,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,39)
    <=> v53109(VarCurr,39) ) ).

tff(addAssignment_31359,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,39)
    <=> v6027(VarCurr,103) ) ).

tff(addAssignment_31358,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,103)
    <=> v52434(VarCurr,103) ) ).

tff(addAssignment_31357,axiom,
    ! [VarCurr: state_type] :
      ( v52441(VarCurr,3)
    <=> v53112(VarCurr,39) ) ).

tff(addAssignment_31356,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,39)
    <=> v53114(VarCurr,39) ) ).

tff(addAssignment_31355,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,39)
    <=> v55213(VarNext,39) ) ).

tff(addCaseBooleanConditionEqualRanges1_699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55214(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55213(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_699,axiom,
    ! [VarNext: state_type] :
      ( v55214(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55213(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55214(VarNext)
      <=> v55215(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55215(VarNext)
      <=> ( v55217(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55217(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31354,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,39)
    <=> v53138(VarCurr,39) ) ).

tff(addAssignment_31353,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,39)
    <=> v6059(VarCurr,103) ) ).

tff(addAssignment_31352,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,103)
    <=> v55186(VarCurr,3) ) ).

tff(addAssignment_31351,axiom,
    ! [VarCurr: state_type] :
      ( v55186(VarCurr,3)
    <=> v55188(VarCurr,3) ) ).

tff(addAssignment_31350,axiom,
    ! [VarCurr: state_type] :
      ( v55188(VarCurr,3)
    <=> v55205(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55205(VarCurr,B)
      <=> ( v55206(VarCurr,B)
          | v55209(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55209(VarCurr,B)
      <=> ( v55198(VarCurr,B)
          & v55210(VarCurr,B) ) ) ) ).

tff(addAssignment_31349,axiom,
    ! [VarCurr: state_type] :
      ( v55210(VarCurr,0)
    <=> v55211(VarCurr) ) ).

tff(addAssignment_31348,axiom,
    ! [VarCurr: state_type] :
      ( v55210(VarCurr,1)
    <=> v55211(VarCurr) ) ).

tff(addAssignment_31347,axiom,
    ! [VarCurr: state_type] :
      ( v55210(VarCurr,2)
    <=> v55211(VarCurr) ) ).

tff(addAssignment_31346,axiom,
    ! [VarCurr: state_type] :
      ( v55210(VarCurr,3)
    <=> v55211(VarCurr) ) ).

tff(addAssignment_31345,axiom,
    ! [VarCurr: state_type] :
      ( v55211(VarCurr)
    <=> v55202(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55206(VarCurr,B)
      <=> ( v55190(VarCurr,B)
          & v55207(VarCurr,B) ) ) ) ).

tff(addAssignment_31344,axiom,
    ! [VarCurr: state_type] :
      ( v55207(VarCurr,0)
    <=> v55208(VarCurr) ) ).

tff(addAssignment_31343,axiom,
    ! [VarCurr: state_type] :
      ( v55207(VarCurr,1)
    <=> v55208(VarCurr) ) ).

tff(addAssignment_31342,axiom,
    ! [VarCurr: state_type] :
      ( v55207(VarCurr,2)
    <=> v55208(VarCurr) ) ).

tff(addAssignment_31341,axiom,
    ! [VarCurr: state_type] :
      ( v55207(VarCurr,3)
    <=> v55208(VarCurr) ) ).

tff(addAssignment_31340,axiom,
    ! [VarCurr: state_type] :
      ( v55208(VarCurr)
    <=> v55194(VarCurr) ) ).

tff(addAssignment_31339,axiom,
    ! [VarCurr: state_type] :
      ( v55202(VarCurr)
    <=> v55204(VarCurr) ) ).

tff(addAssignment_31338,axiom,
    ! [VarCurr: state_type] :
      ( v55204(VarCurr)
    <=> v52379(VarCurr,25) ) ).

tff(addAssignment_31337,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,25)
    <=> v52381(VarCurr,25) ) ).

tff(addAssignment_31336,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,25)
    <=> v52383(VarCurr,25) ) ).

tff(addAssignment_31335,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,25)
    <=> v52384(VarCurr,25) ) ).

tff(addAssignment_31334,axiom,
    ! [VarCurr: state_type] :
      ( v55198(VarCurr,3)
    <=> v55200(VarCurr,3) ) ).

tff(addAssignment_31333,axiom,
    ! [VarCurr: state_type] :
      ( v55200(VarCurr,3)
    <=> v6069(VarCurr,103) ) ).

tff(addAssignment_31332,axiom,
    ! [VarCurr: state_type] :
      ( v55194(VarCurr)
    <=> v55196(VarCurr) ) ).

tff(addAssignment_31331,axiom,
    ! [VarCurr: state_type] :
      ( v55196(VarCurr)
    <=> v52361(VarCurr,25) ) ).

tff(addAssignment_31330,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,25)
    <=> v52363(VarCurr,25) ) ).

tff(addAssignment_31329,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,25)
    <=> v52365(VarCurr,25) ) ).

tff(addAssignment_31328,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,25)
    <=> v52367(VarCurr,25) ) ).

tff(addAssignment_31327,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,25)
    <=> v52369(VarCurr,25) ) ).

tff(addAssignment_31326,axiom,
    ! [VarCurr: state_type] :
      ( v55190(VarCurr,3)
    <=> v55192(VarCurr,3) ) ).

tff(addAssignment_31325,axiom,
    ! [VarCurr: state_type] :
      ( v55192(VarCurr,3)
    <=> v6069(VarCurr,107) ) ).

tff(addAssignment_31324,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,107)
    <=> v53148(VarCurr,43) ) ).

tff(addAssignment_31323,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,43)
    <=> v53150(VarCurr,43) ) ).

tff(addAssignment_31322,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,43)
    <=> v53242(VarCurr,43) ) ).

tff(addAssignment_31321,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,43)
    <=> v53160(VarCurr,43) ) ).

tff(addAssignment_31320,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,43)
    <=> v6098(VarCurr,107) ) ).

tff(addAssignment_31319,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,107)
    <=> v6100(VarCurr,107) ) ).

tff(addAssignment_31318,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,107)
    <=> v6102(VarCurr,107) ) ).

tff(addAssignment_31317,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,107)
    <=> v53162(VarCurr,43) ) ).

tff(addAssignment_31316,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,43)
    <=> v53164(VarCurr,43) ) ).

tff(addAssignment_31315,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,43)
    <=> v53225(VarCurr,43) ) ).

tff(addAssignment_31314,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,43)
    <=> v53223(VarCurr,43) ) ).

tff(addAssignment_31313,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,43)
    <=> v53224(VarCurr,43) ) ).

tff(addAssignment_31312,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,43)
    <=> v53215(VarCurr,43) ) ).

tff(addAssignment_31311,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,43)
    <=> v53219(VarCurr,43) ) ).

tff(addAssignment_31310,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,35)
    <=> v53218(VarCurr,35) ) ).

tff(addAssignment_31309,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,65)
    <=> v6238(VarCurr,65) ) ).

tff(addAssignment_31308,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,65)
    <=> v6240(VarCurr,65) ) ).

tff(addAssignment_31307,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,65)
    <=> v38549(VarCurr,5) ) ).

tff(addAssignment_31306,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,43)
    <=> v53211(VarCurr,43) ) ).

tff(addAssignment_31305,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,43)
    <=> $false ) ).

tff(addAssignment_31304,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,43)
    <=> v53154(VarCurr,43) ) ).

tff(addAssignment_31303,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,43)
    <=> v53155(VarCurr,43) ) ).

tff(addAssignment_31302,axiom,
    ! [VarCurr: state_type] :
      ( v55141(VarCurr)
    <=> v55143(VarCurr) ) ).

tff(addAssignment_31301,axiom,
    ! [VarCurr: state_type] :
      ( v55143(VarCurr)
    <=> v6017(VarCurr,99) ) ).

tff(addAssignment_31300,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,99)
    <=> v53103(VarCurr,35) ) ).

tff(addAssignment_31299,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,35)
    <=> v53105(VarCurr,35) ) ).

tff(addAssignment_31298,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,35)
    <=> v53107(VarCurr,35) ) ).

tff(addAssignment_31297,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,35)
    <=> v53109(VarCurr,35) ) ).

tff(addAssignment_31296,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,35)
    <=> v6027(VarCurr,99) ) ).

tff(addAssignment_31295,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,99)
    <=> v52434(VarCurr,99) ) ).

tff(addAssignment_31294,axiom,
    ! [VarCurr: state_type] :
      ( v52442(VarCurr,3)
    <=> v53112(VarCurr,35) ) ).

tff(addAssignment_31293,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,35)
    <=> v53114(VarCurr,35) ) ).

tff(addAssignment_31292,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,35)
    <=> v55173(VarNext,35) ) ).

tff(addCaseBooleanConditionEqualRanges1_698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55174(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55173(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_698,axiom,
    ! [VarNext: state_type] :
      ( v55174(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55173(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55174(VarNext)
      <=> v55175(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55175(VarNext)
      <=> ( v55177(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55177(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31291,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,35)
    <=> v53138(VarCurr,35) ) ).

tff(addAssignment_31290,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,35)
    <=> v6059(VarCurr,99) ) ).

tff(addAssignment_31289,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,99)
    <=> v55146(VarCurr,3) ) ).

tff(addAssignment_31288,axiom,
    ! [VarCurr: state_type] :
      ( v55146(VarCurr,3)
    <=> v55148(VarCurr,3) ) ).

tff(addAssignment_31287,axiom,
    ! [VarCurr: state_type] :
      ( v55148(VarCurr,3)
    <=> v55165(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55165(VarCurr,B)
      <=> ( v55166(VarCurr,B)
          | v55169(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55169(VarCurr,B)
      <=> ( v55158(VarCurr,B)
          & v55170(VarCurr,B) ) ) ) ).

tff(addAssignment_31286,axiom,
    ! [VarCurr: state_type] :
      ( v55170(VarCurr,0)
    <=> v55171(VarCurr) ) ).

tff(addAssignment_31285,axiom,
    ! [VarCurr: state_type] :
      ( v55170(VarCurr,1)
    <=> v55171(VarCurr) ) ).

tff(addAssignment_31284,axiom,
    ! [VarCurr: state_type] :
      ( v55170(VarCurr,2)
    <=> v55171(VarCurr) ) ).

tff(addAssignment_31283,axiom,
    ! [VarCurr: state_type] :
      ( v55170(VarCurr,3)
    <=> v55171(VarCurr) ) ).

tff(addAssignment_31282,axiom,
    ! [VarCurr: state_type] :
      ( v55171(VarCurr)
    <=> v55162(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55166(VarCurr,B)
      <=> ( v55150(VarCurr,B)
          & v55167(VarCurr,B) ) ) ) ).

tff(addAssignment_31281,axiom,
    ! [VarCurr: state_type] :
      ( v55167(VarCurr,0)
    <=> v55168(VarCurr) ) ).

tff(addAssignment_31280,axiom,
    ! [VarCurr: state_type] :
      ( v55167(VarCurr,1)
    <=> v55168(VarCurr) ) ).

tff(addAssignment_31279,axiom,
    ! [VarCurr: state_type] :
      ( v55167(VarCurr,2)
    <=> v55168(VarCurr) ) ).

tff(addAssignment_31278,axiom,
    ! [VarCurr: state_type] :
      ( v55167(VarCurr,3)
    <=> v55168(VarCurr) ) ).

tff(addAssignment_31277,axiom,
    ! [VarCurr: state_type] :
      ( v55168(VarCurr)
    <=> v55154(VarCurr) ) ).

tff(addAssignment_31276,axiom,
    ! [VarCurr: state_type] :
      ( v55162(VarCurr)
    <=> v55164(VarCurr) ) ).

tff(addAssignment_31275,axiom,
    ! [VarCurr: state_type] :
      ( v55164(VarCurr)
    <=> v52379(VarCurr,24) ) ).

tff(addAssignment_31274,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,24)
    <=> v52381(VarCurr,24) ) ).

tff(addAssignment_31273,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,24)
    <=> v52383(VarCurr,24) ) ).

tff(addAssignment_31272,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,24)
    <=> v52384(VarCurr,24) ) ).

tff(addAssignment_31271,axiom,
    ! [VarCurr: state_type] :
      ( v55158(VarCurr,3)
    <=> v55160(VarCurr,3) ) ).

tff(addAssignment_31270,axiom,
    ! [VarCurr: state_type] :
      ( v55160(VarCurr,3)
    <=> v6069(VarCurr,99) ) ).

tff(addAssignment_31269,axiom,
    ! [VarCurr: state_type] :
      ( v55154(VarCurr)
    <=> v55156(VarCurr) ) ).

tff(addAssignment_31268,axiom,
    ! [VarCurr: state_type] :
      ( v55156(VarCurr)
    <=> v52361(VarCurr,24) ) ).

tff(addAssignment_31267,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,24)
    <=> v52363(VarCurr,24) ) ).

tff(addAssignment_31266,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,24)
    <=> v52365(VarCurr,24) ) ).

tff(addAssignment_31265,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,24)
    <=> v52367(VarCurr,24) ) ).

tff(addAssignment_31264,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,24)
    <=> v52369(VarCurr,24) ) ).

tff(addAssignment_31263,axiom,
    ! [VarCurr: state_type] :
      ( v55150(VarCurr,3)
    <=> v55152(VarCurr,3) ) ).

tff(addAssignment_31262,axiom,
    ! [VarCurr: state_type] :
      ( v55152(VarCurr,3)
    <=> v6069(VarCurr,103) ) ).

tff(addAssignment_31261,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,103)
    <=> v53148(VarCurr,39) ) ).

tff(addAssignment_31260,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,39)
    <=> v53150(VarCurr,39) ) ).

tff(addAssignment_31259,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,39)
    <=> v53242(VarCurr,39) ) ).

tff(addAssignment_31258,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,39)
    <=> v53160(VarCurr,39) ) ).

tff(addAssignment_31257,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,39)
    <=> v6098(VarCurr,103) ) ).

tff(addAssignment_31256,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,103)
    <=> v6100(VarCurr,103) ) ).

tff(addAssignment_31255,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,103)
    <=> v6102(VarCurr,103) ) ).

tff(addAssignment_31254,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,103)
    <=> v53162(VarCurr,39) ) ).

tff(addAssignment_31253,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,39)
    <=> v53164(VarCurr,39) ) ).

tff(addAssignment_31252,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,39)
    <=> v53225(VarCurr,39) ) ).

tff(addAssignment_31251,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,39)
    <=> v53223(VarCurr,39) ) ).

tff(addAssignment_31250,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,39)
    <=> v53224(VarCurr,39) ) ).

tff(addAssignment_31249,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,39)
    <=> v53215(VarCurr,39) ) ).

tff(addAssignment_31248,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,39)
    <=> v53219(VarCurr,39) ) ).

tff(addAssignment_31247,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,31)
    <=> v53218(VarCurr,31) ) ).

tff(addAssignment_31246,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,61)
    <=> v6238(VarCurr,61) ) ).

tff(addAssignment_31245,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,61)
    <=> v6240(VarCurr,61) ) ).

tff(addAssignment_31244,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,61)
    <=> v38549(VarCurr,1) ) ).

tff(addAssignment_31243,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,39)
    <=> v53211(VarCurr,39) ) ).

tff(addAssignment_31242,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,39)
    <=> $false ) ).

tff(addAssignment_31241,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,39)
    <=> v53154(VarCurr,39) ) ).

tff(addAssignment_31240,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,39)
    <=> v53155(VarCurr,39) ) ).

tff(addAssignment_31239,axiom,
    ! [VarCurr: state_type] :
      ( v54713(VarCurr)
    <=> v54715(VarCurr) ) ).

tff(addAssignment_31238,axiom,
    ! [VarCurr: state_type] :
      ( v54715(VarCurr)
    <=> v54717(VarCurr) ) ).

tff(addAssignment_31237,axiom,
    ! [VarCurr: state_type] :
      ( v54717(VarCurr)
    <=> v54719(VarCurr) ) ).

tff(addAssignment_31236,axiom,
    ! [VarCurr: state_type] :
      ( v54719(VarCurr)
    <=> v54721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5169,axiom,
    ! [VarCurr: state_type] :
      ( v54721(VarCurr)
    <=> ( v55119(VarCurr)
      <~> v54987(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5168,axiom,
    ! [VarCurr: state_type] :
      ( v55119(VarCurr)
    <=> ( v54723(VarCurr)
      <~> v54855(VarCurr) ) ) ).

tff(addAssignment_31235,axiom,
    ! [VarCurr: state_type] :
      ( v54987(VarCurr)
    <=> v54989(VarCurr) ) ).

tff(addAssignment_31234,axiom,
    ! [VarCurr: state_type] :
      ( v54989(VarCurr)
    <=> v54991(VarCurr) ) ).

tff(addAssignment_31233,axiom,
    ! [VarCurr: state_type] :
      ( v54991(VarCurr)
    <=> v54993(VarCurr) ) ).

tff(addAssignment_31232,axiom,
    ! [VarCurr: state_type] :
      ( v54993(VarCurr)
    <=> v54995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5167,axiom,
    ! [VarCurr: state_type] :
      ( v54995(VarCurr)
    <=> ( v55117(VarCurr)
      <~> v55077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5166,axiom,
    ! [VarCurr: state_type] :
      ( v55117(VarCurr)
    <=> ( v54997(VarCurr)
      <~> v55037(VarCurr) ) ) ).

tff(addAssignment_31231,axiom,
    ! [VarCurr: state_type] :
      ( v55077(VarCurr)
    <=> v55079(VarCurr) ) ).

tff(addAssignment_31230,axiom,
    ! [VarCurr: state_type] :
      ( v55079(VarCurr)
    <=> v6017(VarCurr,95) ) ).

tff(addAssignment_31229,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,95)
    <=> v53103(VarCurr,31) ) ).

tff(addAssignment_31228,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,31)
    <=> v53105(VarCurr,31) ) ).

tff(addAssignment_31227,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,31)
    <=> v53107(VarCurr,31) ) ).

tff(addAssignment_31226,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,31)
    <=> v53109(VarCurr,31) ) ).

tff(addAssignment_31225,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,31)
    <=> v6027(VarCurr,95) ) ).

tff(addAssignment_31224,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,95)
    <=> v52434(VarCurr,95) ) ).

tff(addAssignment_31223,axiom,
    ! [VarCurr: state_type] :
      ( v52443(VarCurr,3)
    <=> v53112(VarCurr,31) ) ).

tff(addAssignment_31222,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,31)
    <=> v53114(VarCurr,31) ) ).

tff(addAssignment_31221,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,31)
    <=> v55109(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55110(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55109(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_697,axiom,
    ! [VarNext: state_type] :
      ( v55110(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55109(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55110(VarNext)
      <=> v55111(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55111(VarNext)
      <=> ( v55113(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55113(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31220,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,31)
    <=> v53138(VarCurr,31) ) ).

tff(addAssignment_31219,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,31)
    <=> v6059(VarCurr,95) ) ).

tff(addAssignment_31218,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,95)
    <=> v55082(VarCurr,3) ) ).

tff(addAssignment_31217,axiom,
    ! [VarCurr: state_type] :
      ( v55082(VarCurr,3)
    <=> v55084(VarCurr,3) ) ).

tff(addAssignment_31216,axiom,
    ! [VarCurr: state_type] :
      ( v55084(VarCurr,3)
    <=> v55101(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55101(VarCurr,B)
      <=> ( v55102(VarCurr,B)
          | v55105(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55105(VarCurr,B)
      <=> ( v55094(VarCurr,B)
          & v55106(VarCurr,B) ) ) ) ).

tff(addAssignment_31215,axiom,
    ! [VarCurr: state_type] :
      ( v55106(VarCurr,0)
    <=> v55107(VarCurr) ) ).

tff(addAssignment_31214,axiom,
    ! [VarCurr: state_type] :
      ( v55106(VarCurr,1)
    <=> v55107(VarCurr) ) ).

tff(addAssignment_31213,axiom,
    ! [VarCurr: state_type] :
      ( v55106(VarCurr,2)
    <=> v55107(VarCurr) ) ).

tff(addAssignment_31212,axiom,
    ! [VarCurr: state_type] :
      ( v55106(VarCurr,3)
    <=> v55107(VarCurr) ) ).

tff(addAssignment_31211,axiom,
    ! [VarCurr: state_type] :
      ( v55107(VarCurr)
    <=> v55098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_915,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55102(VarCurr,B)
      <=> ( v55086(VarCurr,B)
          & v55103(VarCurr,B) ) ) ) ).

tff(addAssignment_31210,axiom,
    ! [VarCurr: state_type] :
      ( v55103(VarCurr,0)
    <=> v55104(VarCurr) ) ).

tff(addAssignment_31209,axiom,
    ! [VarCurr: state_type] :
      ( v55103(VarCurr,1)
    <=> v55104(VarCurr) ) ).

tff(addAssignment_31208,axiom,
    ! [VarCurr: state_type] :
      ( v55103(VarCurr,2)
    <=> v55104(VarCurr) ) ).

tff(addAssignment_31207,axiom,
    ! [VarCurr: state_type] :
      ( v55103(VarCurr,3)
    <=> v55104(VarCurr) ) ).

tff(addAssignment_31206,axiom,
    ! [VarCurr: state_type] :
      ( v55104(VarCurr)
    <=> v55090(VarCurr) ) ).

tff(addAssignment_31205,axiom,
    ! [VarCurr: state_type] :
      ( v55098(VarCurr)
    <=> v55100(VarCurr) ) ).

tff(addAssignment_31204,axiom,
    ! [VarCurr: state_type] :
      ( v55100(VarCurr)
    <=> v52379(VarCurr,23) ) ).

tff(addAssignment_31203,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,23)
    <=> v52381(VarCurr,23) ) ).

tff(addAssignment_31202,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,23)
    <=> v52383(VarCurr,23) ) ).

tff(addAssignment_31201,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,23)
    <=> v52384(VarCurr,23) ) ).

tff(addAssignment_31200,axiom,
    ! [VarCurr: state_type] :
      ( v55094(VarCurr,3)
    <=> v55096(VarCurr,3) ) ).

tff(addAssignment_31199,axiom,
    ! [VarCurr: state_type] :
      ( v55096(VarCurr,3)
    <=> v6069(VarCurr,95) ) ).

tff(addAssignment_31198,axiom,
    ! [VarCurr: state_type] :
      ( v55090(VarCurr)
    <=> v55092(VarCurr) ) ).

tff(addAssignment_31197,axiom,
    ! [VarCurr: state_type] :
      ( v55092(VarCurr)
    <=> v52361(VarCurr,23) ) ).

tff(addAssignment_31196,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,23)
    <=> v52363(VarCurr,23) ) ).

tff(addAssignment_31195,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,23)
    <=> v52365(VarCurr,23) ) ).

tff(addAssignment_31194,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,23)
    <=> v52367(VarCurr,23) ) ).

tff(addAssignment_31193,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,23)
    <=> v52369(VarCurr,23) ) ).

tff(addAssignment_31192,axiom,
    ! [VarCurr: state_type] :
      ( v55086(VarCurr,3)
    <=> v55088(VarCurr,3) ) ).

tff(addAssignment_31191,axiom,
    ! [VarCurr: state_type] :
      ( v55088(VarCurr,3)
    <=> v6069(VarCurr,99) ) ).

tff(addAssignment_31190,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,99)
    <=> v53148(VarCurr,35) ) ).

tff(addAssignment_31189,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,35)
    <=> v53150(VarCurr,35) ) ).

tff(addAssignment_31188,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,35)
    <=> v53242(VarCurr,35) ) ).

tff(addAssignment_31187,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,35)
    <=> v53160(VarCurr,35) ) ).

tff(addAssignment_31186,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,35)
    <=> v6098(VarCurr,99) ) ).

tff(addAssignment_31185,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,99)
    <=> v6100(VarCurr,99) ) ).

tff(addAssignment_31184,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,99)
    <=> v6102(VarCurr,99) ) ).

tff(addAssignment_31183,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,99)
    <=> v53162(VarCurr,35) ) ).

tff(addAssignment_31182,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,35)
    <=> v53164(VarCurr,35) ) ).

tff(addAssignment_31181,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,35)
    <=> v53225(VarCurr,35) ) ).

tff(addAssignment_31180,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,35)
    <=> v53223(VarCurr,35) ) ).

tff(addAssignment_31179,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,35)
    <=> v53224(VarCurr,35) ) ).

tff(addAssignment_31178,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,35)
    <=> v53215(VarCurr,35) ) ).

tff(addAssignment_31177,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,35)
    <=> v53219(VarCurr,35) ) ).

tff(addAssignment_31176,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,27)
    <=> v53218(VarCurr,27) ) ).

tff(addAssignment_31175,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,51)
    <=> v6238(VarCurr,51) ) ).

tff(addAssignment_31174,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,51)
    <=> v6240(VarCurr,51) ) ).

tff(addAssignment_31173,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,51)
    <=> v36999(VarCurr,3) ) ).

tff(addAssignment_31172,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,35)
    <=> v53211(VarCurr,35) ) ).

tff(addAssignment_31171,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,35)
    <=> $false ) ).

tff(addAssignment_31170,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,35)
    <=> v53154(VarCurr,35) ) ).

tff(addAssignment_31169,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,35)
    <=> v53155(VarCurr,35) ) ).

tff(addAssignment_31168,axiom,
    ! [VarCurr: state_type] :
      ( v55037(VarCurr)
    <=> v55039(VarCurr) ) ).

tff(addAssignment_31167,axiom,
    ! [VarCurr: state_type] :
      ( v55039(VarCurr)
    <=> v6017(VarCurr,91) ) ).

tff(addAssignment_31166,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,91)
    <=> v53103(VarCurr,27) ) ).

tff(addAssignment_31165,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,27)
    <=> v53105(VarCurr,27) ) ).

tff(addAssignment_31164,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,27)
    <=> v53107(VarCurr,27) ) ).

tff(addAssignment_31163,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,27)
    <=> v53109(VarCurr,27) ) ).

tff(addAssignment_31162,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,27)
    <=> v6027(VarCurr,91) ) ).

tff(addAssignment_31161,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,91)
    <=> v52434(VarCurr,91) ) ).

tff(addAssignment_31160,axiom,
    ! [VarCurr: state_type] :
      ( v52444(VarCurr,3)
    <=> v53112(VarCurr,27) ) ).

tff(addAssignment_31159,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,27)
    <=> v53114(VarCurr,27) ) ).

tff(addAssignment_31158,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,27)
    <=> v55069(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55070(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55069(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_696,axiom,
    ! [VarNext: state_type] :
      ( v55070(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55069(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55070(VarNext)
      <=> v55071(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55071(VarNext)
      <=> ( v55073(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55073(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31157,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,27)
    <=> v53138(VarCurr,27) ) ).

tff(addAssignment_31156,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,27)
    <=> v6059(VarCurr,91) ) ).

tff(addAssignment_31155,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,91)
    <=> v55042(VarCurr,3) ) ).

tff(addAssignment_31154,axiom,
    ! [VarCurr: state_type] :
      ( v55042(VarCurr,3)
    <=> v55044(VarCurr,3) ) ).

tff(addAssignment_31153,axiom,
    ! [VarCurr: state_type] :
      ( v55044(VarCurr,3)
    <=> v55061(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55061(VarCurr,B)
      <=> ( v55062(VarCurr,B)
          | v55065(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55065(VarCurr,B)
      <=> ( v55054(VarCurr,B)
          & v55066(VarCurr,B) ) ) ) ).

tff(addAssignment_31152,axiom,
    ! [VarCurr: state_type] :
      ( v55066(VarCurr,0)
    <=> v55067(VarCurr) ) ).

tff(addAssignment_31151,axiom,
    ! [VarCurr: state_type] :
      ( v55066(VarCurr,1)
    <=> v55067(VarCurr) ) ).

tff(addAssignment_31150,axiom,
    ! [VarCurr: state_type] :
      ( v55066(VarCurr,2)
    <=> v55067(VarCurr) ) ).

tff(addAssignment_31149,axiom,
    ! [VarCurr: state_type] :
      ( v55066(VarCurr,3)
    <=> v55067(VarCurr) ) ).

tff(addAssignment_31148,axiom,
    ! [VarCurr: state_type] :
      ( v55067(VarCurr)
    <=> v55058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55062(VarCurr,B)
      <=> ( v55046(VarCurr,B)
          & v55063(VarCurr,B) ) ) ) ).

tff(addAssignment_31147,axiom,
    ! [VarCurr: state_type] :
      ( v55063(VarCurr,0)
    <=> v55064(VarCurr) ) ).

tff(addAssignment_31146,axiom,
    ! [VarCurr: state_type] :
      ( v55063(VarCurr,1)
    <=> v55064(VarCurr) ) ).

tff(addAssignment_31145,axiom,
    ! [VarCurr: state_type] :
      ( v55063(VarCurr,2)
    <=> v55064(VarCurr) ) ).

tff(addAssignment_31144,axiom,
    ! [VarCurr: state_type] :
      ( v55063(VarCurr,3)
    <=> v55064(VarCurr) ) ).

tff(addAssignment_31143,axiom,
    ! [VarCurr: state_type] :
      ( v55064(VarCurr)
    <=> v55050(VarCurr) ) ).

tff(addAssignment_31142,axiom,
    ! [VarCurr: state_type] :
      ( v55058(VarCurr)
    <=> v55060(VarCurr) ) ).

tff(addAssignment_31141,axiom,
    ! [VarCurr: state_type] :
      ( v55060(VarCurr)
    <=> v52379(VarCurr,22) ) ).

tff(addAssignment_31140,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,22)
    <=> v52381(VarCurr,22) ) ).

tff(addAssignment_31139,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,22)
    <=> v52383(VarCurr,22) ) ).

tff(addAssignment_31138,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,22)
    <=> v52384(VarCurr,22) ) ).

tff(addAssignment_31137,axiom,
    ! [VarCurr: state_type] :
      ( v55054(VarCurr,3)
    <=> v55056(VarCurr,3) ) ).

tff(addAssignment_31136,axiom,
    ! [VarCurr: state_type] :
      ( v55056(VarCurr,3)
    <=> v6069(VarCurr,91) ) ).

tff(addAssignment_31135,axiom,
    ! [VarCurr: state_type] :
      ( v55050(VarCurr)
    <=> v55052(VarCurr) ) ).

tff(addAssignment_31134,axiom,
    ! [VarCurr: state_type] :
      ( v55052(VarCurr)
    <=> v52361(VarCurr,22) ) ).

tff(addAssignment_31133,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,22)
    <=> v52363(VarCurr,22) ) ).

tff(addAssignment_31132,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,22)
    <=> v52365(VarCurr,22) ) ).

tff(addAssignment_31131,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,22)
    <=> v52367(VarCurr,22) ) ).

tff(addAssignment_31130,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,22)
    <=> v52369(VarCurr,22) ) ).

tff(addAssignment_31129,axiom,
    ! [VarCurr: state_type] :
      ( v55046(VarCurr,3)
    <=> v55048(VarCurr,3) ) ).

tff(addAssignment_31128,axiom,
    ! [VarCurr: state_type] :
      ( v55048(VarCurr,3)
    <=> v6069(VarCurr,95) ) ).

tff(addAssignment_31127,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,95)
    <=> v53148(VarCurr,31) ) ).

tff(addAssignment_31126,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,31)
    <=> v53150(VarCurr,31) ) ).

tff(addAssignment_31125,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,31)
    <=> v53242(VarCurr,31) ) ).

tff(addAssignment_31124,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,31)
    <=> v53160(VarCurr,31) ) ).

tff(addAssignment_31123,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,31)
    <=> v6098(VarCurr,95) ) ).

tff(addAssignment_31122,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,95)
    <=> v6100(VarCurr,95) ) ).

tff(addAssignment_31121,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,95)
    <=> v6102(VarCurr,95) ) ).

tff(addAssignment_31120,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,95)
    <=> v53162(VarCurr,31) ) ).

tff(addAssignment_31119,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,31)
    <=> v53164(VarCurr,31) ) ).

tff(addAssignment_31118,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,31)
    <=> v53225(VarCurr,31) ) ).

tff(addAssignment_31117,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,31)
    <=> v53223(VarCurr,31) ) ).

tff(addAssignment_31116,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,31)
    <=> v53224(VarCurr,31) ) ).

tff(addAssignment_31115,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,31)
    <=> v53215(VarCurr,31) ) ).

tff(addAssignment_31114,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,31)
    <=> v53219(VarCurr,31) ) ).

tff(addAssignment_31113,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,23)
    <=> v53218(VarCurr,23) ) ).

tff(addAssignment_31112,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,41)
    <=> v6238(VarCurr,41) ) ).

tff(addAssignment_31111,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,41)
    <=> v6240(VarCurr,41) ) ).

tff(addAssignment_31110,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,41)
    <=> v35449(VarCurr,5) ) ).

tff(addAssignment_31109,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,31)
    <=> v53211(VarCurr,31) ) ).

tff(addAssignment_31108,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_31107,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,31)
    <=> v53154(VarCurr,31) ) ).

tff(addAssignment_31106,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,31)
    <=> v53155(VarCurr,31) ) ).

tff(addAssignment_31105,axiom,
    ! [VarCurr: state_type] :
      ( v54997(VarCurr)
    <=> v54999(VarCurr) ) ).

tff(addAssignment_31104,axiom,
    ! [VarCurr: state_type] :
      ( v54999(VarCurr)
    <=> v6017(VarCurr,87) ) ).

tff(addAssignment_31103,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,87)
    <=> v53103(VarCurr,23) ) ).

tff(addAssignment_31102,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,23)
    <=> v53105(VarCurr,23) ) ).

tff(addAssignment_31101,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,23)
    <=> v53107(VarCurr,23) ) ).

tff(addAssignment_31100,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,23)
    <=> v53109(VarCurr,23) ) ).

tff(addAssignment_31099,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,23)
    <=> v6027(VarCurr,87) ) ).

tff(addAssignment_31098,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,87)
    <=> v52434(VarCurr,87) ) ).

tff(addAssignment_31097,axiom,
    ! [VarCurr: state_type] :
      ( v52445(VarCurr,3)
    <=> v53112(VarCurr,23) ) ).

tff(addAssignment_31096,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,23)
    <=> v53114(VarCurr,23) ) ).

tff(addAssignment_31095,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,23)
    <=> v55029(VarNext,23) ) ).

tff(addCaseBooleanConditionEqualRanges1_695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55030(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v55029(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_695,axiom,
    ! [VarNext: state_type] :
      ( v55030(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v55029(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55030(VarNext)
      <=> v55031(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v55031(VarNext)
      <=> ( v55033(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v55033(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31094,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,23)
    <=> v53138(VarCurr,23) ) ).

tff(addAssignment_31093,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,23)
    <=> v6059(VarCurr,87) ) ).

tff(addAssignment_31092,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,87)
    <=> v55002(VarCurr,3) ) ).

tff(addAssignment_31091,axiom,
    ! [VarCurr: state_type] :
      ( v55002(VarCurr,3)
    <=> v55004(VarCurr,3) ) ).

tff(addAssignment_31090,axiom,
    ! [VarCurr: state_type] :
      ( v55004(VarCurr,3)
    <=> v55021(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55021(VarCurr,B)
      <=> ( v55022(VarCurr,B)
          | v55025(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55025(VarCurr,B)
      <=> ( v55014(VarCurr,B)
          & v55026(VarCurr,B) ) ) ) ).

tff(addAssignment_31089,axiom,
    ! [VarCurr: state_type] :
      ( v55026(VarCurr,0)
    <=> v55027(VarCurr) ) ).

tff(addAssignment_31088,axiom,
    ! [VarCurr: state_type] :
      ( v55026(VarCurr,1)
    <=> v55027(VarCurr) ) ).

tff(addAssignment_31087,axiom,
    ! [VarCurr: state_type] :
      ( v55026(VarCurr,2)
    <=> v55027(VarCurr) ) ).

tff(addAssignment_31086,axiom,
    ! [VarCurr: state_type] :
      ( v55026(VarCurr,3)
    <=> v55027(VarCurr) ) ).

tff(addAssignment_31085,axiom,
    ! [VarCurr: state_type] :
      ( v55027(VarCurr)
    <=> v55018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v55022(VarCurr,B)
      <=> ( v55006(VarCurr,B)
          & v55023(VarCurr,B) ) ) ) ).

tff(addAssignment_31084,axiom,
    ! [VarCurr: state_type] :
      ( v55023(VarCurr,0)
    <=> v55024(VarCurr) ) ).

tff(addAssignment_31083,axiom,
    ! [VarCurr: state_type] :
      ( v55023(VarCurr,1)
    <=> v55024(VarCurr) ) ).

tff(addAssignment_31082,axiom,
    ! [VarCurr: state_type] :
      ( v55023(VarCurr,2)
    <=> v55024(VarCurr) ) ).

tff(addAssignment_31081,axiom,
    ! [VarCurr: state_type] :
      ( v55023(VarCurr,3)
    <=> v55024(VarCurr) ) ).

tff(addAssignment_31080,axiom,
    ! [VarCurr: state_type] :
      ( v55024(VarCurr)
    <=> v55010(VarCurr) ) ).

tff(addAssignment_31079,axiom,
    ! [VarCurr: state_type] :
      ( v55018(VarCurr)
    <=> v55020(VarCurr) ) ).

tff(addAssignment_31078,axiom,
    ! [VarCurr: state_type] :
      ( v55020(VarCurr)
    <=> v52379(VarCurr,21) ) ).

tff(addAssignment_31077,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,21)
    <=> v52381(VarCurr,21) ) ).

tff(addAssignment_31076,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,21)
    <=> v52383(VarCurr,21) ) ).

tff(addAssignment_31075,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,21)
    <=> v52384(VarCurr,21) ) ).

tff(addAssignment_31074,axiom,
    ! [VarCurr: state_type] :
      ( v55014(VarCurr,3)
    <=> v55016(VarCurr,3) ) ).

tff(addAssignment_31073,axiom,
    ! [VarCurr: state_type] :
      ( v55016(VarCurr,3)
    <=> v6069(VarCurr,87) ) ).

tff(addAssignment_31072,axiom,
    ! [VarCurr: state_type] :
      ( v55010(VarCurr)
    <=> v55012(VarCurr) ) ).

tff(addAssignment_31071,axiom,
    ! [VarCurr: state_type] :
      ( v55012(VarCurr)
    <=> v52361(VarCurr,21) ) ).

tff(addAssignment_31070,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,21)
    <=> v52363(VarCurr,21) ) ).

tff(addAssignment_31069,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,21)
    <=> v52365(VarCurr,21) ) ).

tff(addAssignment_31068,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,21)
    <=> v52367(VarCurr,21) ) ).

tff(addAssignment_31067,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,21)
    <=> v52369(VarCurr,21) ) ).

tff(addAssignment_31066,axiom,
    ! [VarCurr: state_type] :
      ( v55006(VarCurr,3)
    <=> v55008(VarCurr,3) ) ).

tff(addAssignment_31065,axiom,
    ! [VarCurr: state_type] :
      ( v55008(VarCurr,3)
    <=> v6069(VarCurr,91) ) ).

tff(addAssignment_31064,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,91)
    <=> v53148(VarCurr,27) ) ).

tff(addAssignment_31063,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,27)
    <=> v53150(VarCurr,27) ) ).

tff(addAssignment_31062,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,27)
    <=> v53242(VarCurr,27) ) ).

tff(addAssignment_31061,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,27)
    <=> v53160(VarCurr,27) ) ).

tff(addAssignment_31060,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,27)
    <=> v6098(VarCurr,91) ) ).

tff(addAssignment_31059,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,91)
    <=> v6100(VarCurr,91) ) ).

tff(addAssignment_31058,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,91)
    <=> v6102(VarCurr,91) ) ).

tff(addAssignment_31057,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,91)
    <=> v53162(VarCurr,27) ) ).

tff(addAssignment_31056,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,27)
    <=> v53164(VarCurr,27) ) ).

tff(addAssignment_31055,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,27)
    <=> v53225(VarCurr,27) ) ).

tff(addAssignment_31054,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,27)
    <=> v53223(VarCurr,27) ) ).

tff(addAssignment_31053,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,27)
    <=> v53224(VarCurr,27) ) ).

tff(addAssignment_31052,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,27)
    <=> v53215(VarCurr,27) ) ).

tff(addAssignment_31051,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,27)
    <=> v53219(VarCurr,27) ) ).

tff(addAssignment_31050,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,19)
    <=> v53218(VarCurr,19) ) ).

tff(addAssignment_31049,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,37)
    <=> v6238(VarCurr,37) ) ).

tff(addAssignment_31048,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,37)
    <=> v6240(VarCurr,37) ) ).

tff(addAssignment_31047,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,37)
    <=> v35449(VarCurr,1) ) ).

tff(addAssignment_31046,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,27)
    <=> v53211(VarCurr,27) ) ).

tff(addAssignment_31045,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,27)
    <=> $false ) ).

tff(addAssignment_31044,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,27)
    <=> v53154(VarCurr,27) ) ).

tff(addAssignment_31043,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,27)
    <=> v53155(VarCurr,27) ) ).

tff(addAssignment_31042,axiom,
    ! [VarCurr: state_type] :
      ( v54855(VarCurr)
    <=> v54857(VarCurr) ) ).

tff(addAssignment_31041,axiom,
    ! [VarCurr: state_type] :
      ( v54857(VarCurr)
    <=> v54859(VarCurr) ) ).

tff(addAssignment_31040,axiom,
    ! [VarCurr: state_type] :
      ( v54859(VarCurr)
    <=> v54861(VarCurr) ) ).

tff(addAssignment_31039,axiom,
    ! [VarCurr: state_type] :
      ( v54861(VarCurr)
    <=> v54863(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5159,axiom,
    ! [VarCurr: state_type] :
      ( v54863(VarCurr)
    <=> ( v54985(VarCurr)
      <~> v54945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5158,axiom,
    ! [VarCurr: state_type] :
      ( v54985(VarCurr)
    <=> ( v54865(VarCurr)
      <~> v54905(VarCurr) ) ) ).

tff(addAssignment_31038,axiom,
    ! [VarCurr: state_type] :
      ( v54945(VarCurr)
    <=> v54947(VarCurr) ) ).

tff(addAssignment_31037,axiom,
    ! [VarCurr: state_type] :
      ( v54947(VarCurr)
    <=> v6017(VarCurr,83) ) ).

tff(addAssignment_31036,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,83)
    <=> v53103(VarCurr,19) ) ).

tff(addAssignment_31035,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,19)
    <=> v53105(VarCurr,19) ) ).

tff(addAssignment_31034,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,19)
    <=> v53107(VarCurr,19) ) ).

tff(addAssignment_31033,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,19)
    <=> v53109(VarCurr,19) ) ).

tff(addAssignment_31032,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,19)
    <=> v6027(VarCurr,83) ) ).

tff(addAssignment_31031,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,83)
    <=> v52434(VarCurr,83) ) ).

tff(addAssignment_31030,axiom,
    ! [VarCurr: state_type] :
      ( v52446(VarCurr,3)
    <=> v53112(VarCurr,19) ) ).

tff(addAssignment_31029,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,19)
    <=> v53114(VarCurr,19) ) ).

tff(addAssignment_31028,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,19)
    <=> v54977(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54978(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54977(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_694,axiom,
    ! [VarNext: state_type] :
      ( v54978(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54977(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54978(VarNext)
      <=> v54979(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54979(VarNext)
      <=> ( v54981(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54981(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_31027,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,19)
    <=> v53138(VarCurr,19) ) ).

tff(addAssignment_31026,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,19)
    <=> v6059(VarCurr,83) ) ).

tff(addAssignment_31025,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,83)
    <=> v54950(VarCurr,3) ) ).

tff(addAssignment_31024,axiom,
    ! [VarCurr: state_type] :
      ( v54950(VarCurr,3)
    <=> v54952(VarCurr,3) ) ).

tff(addAssignment_31023,axiom,
    ! [VarCurr: state_type] :
      ( v54952(VarCurr,3)
    <=> v54969(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54969(VarCurr,B)
      <=> ( v54970(VarCurr,B)
          | v54973(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54973(VarCurr,B)
      <=> ( v54962(VarCurr,B)
          & v54974(VarCurr,B) ) ) ) ).

tff(addAssignment_31022,axiom,
    ! [VarCurr: state_type] :
      ( v54974(VarCurr,0)
    <=> v54975(VarCurr) ) ).

tff(addAssignment_31021,axiom,
    ! [VarCurr: state_type] :
      ( v54974(VarCurr,1)
    <=> v54975(VarCurr) ) ).

tff(addAssignment_31020,axiom,
    ! [VarCurr: state_type] :
      ( v54974(VarCurr,2)
    <=> v54975(VarCurr) ) ).

tff(addAssignment_31019,axiom,
    ! [VarCurr: state_type] :
      ( v54974(VarCurr,3)
    <=> v54975(VarCurr) ) ).

tff(addAssignment_31018,axiom,
    ! [VarCurr: state_type] :
      ( v54975(VarCurr)
    <=> v54966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54970(VarCurr,B)
      <=> ( v54954(VarCurr,B)
          & v54971(VarCurr,B) ) ) ) ).

tff(addAssignment_31017,axiom,
    ! [VarCurr: state_type] :
      ( v54971(VarCurr,0)
    <=> v54972(VarCurr) ) ).

tff(addAssignment_31016,axiom,
    ! [VarCurr: state_type] :
      ( v54971(VarCurr,1)
    <=> v54972(VarCurr) ) ).

tff(addAssignment_31015,axiom,
    ! [VarCurr: state_type] :
      ( v54971(VarCurr,2)
    <=> v54972(VarCurr) ) ).

tff(addAssignment_31014,axiom,
    ! [VarCurr: state_type] :
      ( v54971(VarCurr,3)
    <=> v54972(VarCurr) ) ).

tff(addAssignment_31013,axiom,
    ! [VarCurr: state_type] :
      ( v54972(VarCurr)
    <=> v54958(VarCurr) ) ).

tff(addAssignment_31012,axiom,
    ! [VarCurr: state_type] :
      ( v54966(VarCurr)
    <=> v54968(VarCurr) ) ).

tff(addAssignment_31011,axiom,
    ! [VarCurr: state_type] :
      ( v54968(VarCurr)
    <=> v52379(VarCurr,20) ) ).

tff(addAssignment_31010,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,20)
    <=> v52381(VarCurr,20) ) ).

tff(addAssignment_31009,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,20)
    <=> v52383(VarCurr,20) ) ).

tff(addAssignment_31008,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,20)
    <=> v52384(VarCurr,20) ) ).

tff(addAssignment_31007,axiom,
    ! [VarCurr: state_type] :
      ( v54962(VarCurr,3)
    <=> v54964(VarCurr,3) ) ).

tff(addAssignment_31006,axiom,
    ! [VarCurr: state_type] :
      ( v54964(VarCurr,3)
    <=> v6069(VarCurr,83) ) ).

tff(addAssignment_31005,axiom,
    ! [VarCurr: state_type] :
      ( v54958(VarCurr)
    <=> v54960(VarCurr) ) ).

tff(addAssignment_31004,axiom,
    ! [VarCurr: state_type] :
      ( v54960(VarCurr)
    <=> v52361(VarCurr,20) ) ).

tff(addAssignment_31003,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,20)
    <=> v52363(VarCurr,20) ) ).

tff(addAssignment_31002,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,20)
    <=> v52365(VarCurr,20) ) ).

tff(addAssignment_31001,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,20)
    <=> v52367(VarCurr,20) ) ).

tff(addAssignment_31000,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,20)
    <=> v52369(VarCurr,20) ) ).

tff(addAssignment_30999,axiom,
    ! [VarCurr: state_type] :
      ( v54954(VarCurr,3)
    <=> v54956(VarCurr,3) ) ).

tff(addAssignment_30998,axiom,
    ! [VarCurr: state_type] :
      ( v54956(VarCurr,3)
    <=> v6069(VarCurr,87) ) ).

tff(addAssignment_30997,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,87)
    <=> v53148(VarCurr,23) ) ).

tff(addAssignment_30996,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,23)
    <=> v53150(VarCurr,23) ) ).

tff(addAssignment_30995,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,23)
    <=> v53242(VarCurr,23) ) ).

tff(addAssignment_30994,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,23)
    <=> v53160(VarCurr,23) ) ).

tff(addAssignment_30993,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,23)
    <=> v6098(VarCurr,87) ) ).

tff(addAssignment_30992,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,87)
    <=> v6100(VarCurr,87) ) ).

tff(addAssignment_30991,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,87)
    <=> v6102(VarCurr,87) ) ).

tff(addAssignment_30990,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,87)
    <=> v53162(VarCurr,23) ) ).

tff(addAssignment_30989,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,23)
    <=> v53164(VarCurr,23) ) ).

tff(addAssignment_30988,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,23)
    <=> v53225(VarCurr,23) ) ).

tff(addAssignment_30987,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,23)
    <=> v53223(VarCurr,23) ) ).

tff(addAssignment_30986,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,23)
    <=> v53224(VarCurr,23) ) ).

tff(addAssignment_30985,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,23)
    <=> v53215(VarCurr,23) ) ).

tff(addAssignment_30984,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,23)
    <=> v53219(VarCurr,23) ) ).

tff(addAssignment_30983,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,15)
    <=> v53218(VarCurr,15) ) ).

tff(addAssignment_30982,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,27)
    <=> v6238(VarCurr,27) ) ).

tff(addAssignment_30981,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,23)
    <=> v53211(VarCurr,23) ) ).

tff(addAssignment_30980,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,23)
    <=> $false ) ).

tff(addAssignment_30979,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,23)
    <=> v53154(VarCurr,23) ) ).

tff(addAssignment_30978,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,23)
    <=> v53155(VarCurr,23) ) ).

tff(addAssignment_30977,axiom,
    ! [VarCurr: state_type] :
      ( v54905(VarCurr)
    <=> v54907(VarCurr) ) ).

tff(addAssignment_30976,axiom,
    ! [VarCurr: state_type] :
      ( v54907(VarCurr)
    <=> v6017(VarCurr,79) ) ).

tff(addAssignment_30975,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,79)
    <=> v53103(VarCurr,15) ) ).

tff(addAssignment_30974,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,15)
    <=> v53105(VarCurr,15) ) ).

tff(addAssignment_30973,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,15)
    <=> v53107(VarCurr,15) ) ).

tff(addAssignment_30972,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,15)
    <=> v53109(VarCurr,15) ) ).

tff(addAssignment_30971,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,15)
    <=> v6027(VarCurr,79) ) ).

tff(addAssignment_30970,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,79)
    <=> v52434(VarCurr,79) ) ).

tff(addAssignment_30969,axiom,
    ! [VarCurr: state_type] :
      ( v52447(VarCurr,3)
    <=> v53112(VarCurr,15) ) ).

tff(addAssignment_30968,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,15)
    <=> v53114(VarCurr,15) ) ).

tff(addAssignment_30967,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,15)
    <=> v54937(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54938(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54937(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_693,axiom,
    ! [VarNext: state_type] :
      ( v54938(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54937(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54938(VarNext)
      <=> v54939(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54939(VarNext)
      <=> ( v54941(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54941(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30966,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,15)
    <=> v53138(VarCurr,15) ) ).

tff(addAssignment_30965,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,15)
    <=> v6059(VarCurr,79) ) ).

tff(addAssignment_30964,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,79)
    <=> v54910(VarCurr,3) ) ).

tff(addAssignment_30963,axiom,
    ! [VarCurr: state_type] :
      ( v54910(VarCurr,3)
    <=> v54912(VarCurr,3) ) ).

tff(addAssignment_30962,axiom,
    ! [VarCurr: state_type] :
      ( v54912(VarCurr,3)
    <=> v54929(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54929(VarCurr,B)
      <=> ( v54930(VarCurr,B)
          | v54933(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54933(VarCurr,B)
      <=> ( v54922(VarCurr,B)
          & v54934(VarCurr,B) ) ) ) ).

tff(addAssignment_30961,axiom,
    ! [VarCurr: state_type] :
      ( v54934(VarCurr,0)
    <=> v54935(VarCurr) ) ).

tff(addAssignment_30960,axiom,
    ! [VarCurr: state_type] :
      ( v54934(VarCurr,1)
    <=> v54935(VarCurr) ) ).

tff(addAssignment_30959,axiom,
    ! [VarCurr: state_type] :
      ( v54934(VarCurr,2)
    <=> v54935(VarCurr) ) ).

tff(addAssignment_30958,axiom,
    ! [VarCurr: state_type] :
      ( v54934(VarCurr,3)
    <=> v54935(VarCurr) ) ).

tff(addAssignment_30957,axiom,
    ! [VarCurr: state_type] :
      ( v54935(VarCurr)
    <=> v54926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54930(VarCurr,B)
      <=> ( v54914(VarCurr,B)
          & v54931(VarCurr,B) ) ) ) ).

tff(addAssignment_30956,axiom,
    ! [VarCurr: state_type] :
      ( v54931(VarCurr,0)
    <=> v54932(VarCurr) ) ).

tff(addAssignment_30955,axiom,
    ! [VarCurr: state_type] :
      ( v54931(VarCurr,1)
    <=> v54932(VarCurr) ) ).

tff(addAssignment_30954,axiom,
    ! [VarCurr: state_type] :
      ( v54931(VarCurr,2)
    <=> v54932(VarCurr) ) ).

tff(addAssignment_30953,axiom,
    ! [VarCurr: state_type] :
      ( v54931(VarCurr,3)
    <=> v54932(VarCurr) ) ).

tff(addAssignment_30952,axiom,
    ! [VarCurr: state_type] :
      ( v54932(VarCurr)
    <=> v54918(VarCurr) ) ).

tff(addAssignment_30951,axiom,
    ! [VarCurr: state_type] :
      ( v54926(VarCurr)
    <=> v54928(VarCurr) ) ).

tff(addAssignment_30950,axiom,
    ! [VarCurr: state_type] :
      ( v54928(VarCurr)
    <=> v52379(VarCurr,19) ) ).

tff(addAssignment_30949,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,19)
    <=> v52381(VarCurr,19) ) ).

tff(addAssignment_30948,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,19)
    <=> v52383(VarCurr,19) ) ).

tff(addAssignment_30947,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,19)
    <=> v52384(VarCurr,19) ) ).

tff(addAssignment_30946,axiom,
    ! [VarCurr: state_type] :
      ( v54922(VarCurr,3)
    <=> v54924(VarCurr,3) ) ).

tff(addAssignment_30945,axiom,
    ! [VarCurr: state_type] :
      ( v54924(VarCurr,3)
    <=> v6069(VarCurr,79) ) ).

tff(addAssignment_30944,axiom,
    ! [VarCurr: state_type] :
      ( v54918(VarCurr)
    <=> v54920(VarCurr) ) ).

tff(addAssignment_30943,axiom,
    ! [VarCurr: state_type] :
      ( v54920(VarCurr)
    <=> v52361(VarCurr,19) ) ).

tff(addAssignment_30942,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,19)
    <=> v52363(VarCurr,19) ) ).

tff(addAssignment_30941,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,19)
    <=> v52365(VarCurr,19) ) ).

tff(addAssignment_30940,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,19)
    <=> v52367(VarCurr,19) ) ).

tff(addAssignment_30939,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,19)
    <=> v52369(VarCurr,19) ) ).

tff(addAssignment_30938,axiom,
    ! [VarCurr: state_type] :
      ( v54914(VarCurr,3)
    <=> v54916(VarCurr,3) ) ).

tff(addAssignment_30937,axiom,
    ! [VarCurr: state_type] :
      ( v54916(VarCurr,3)
    <=> v6069(VarCurr,83) ) ).

tff(addAssignment_30936,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,83)
    <=> v53148(VarCurr,19) ) ).

tff(addAssignment_30935,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,19)
    <=> v53150(VarCurr,19) ) ).

tff(addAssignment_30934,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,19)
    <=> v53242(VarCurr,19) ) ).

tff(addAssignment_30933,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,19)
    <=> v53160(VarCurr,19) ) ).

tff(addAssignment_30932,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,19)
    <=> v6098(VarCurr,83) ) ).

tff(addAssignment_30931,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,83)
    <=> v6100(VarCurr,83) ) ).

tff(addAssignment_30930,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,83)
    <=> v6102(VarCurr,83) ) ).

tff(addAssignment_30929,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,83)
    <=> v53162(VarCurr,19) ) ).

tff(addAssignment_30928,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,19)
    <=> v53164(VarCurr,19) ) ).

tff(addAssignment_30927,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,19)
    <=> v53225(VarCurr,19) ) ).

tff(addAssignment_30926,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,19)
    <=> v53223(VarCurr,19) ) ).

tff(addAssignment_30925,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,19)
    <=> v53224(VarCurr,19) ) ).

tff(addAssignment_30924,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,19)
    <=> v53215(VarCurr,19) ) ).

tff(addAssignment_30923,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,19)
    <=> v53219(VarCurr,19) ) ).

tff(addAssignment_30922,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,11)
    <=> v53218(VarCurr,11) ) ).

tff(addAssignment_30921,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,17)
    <=> v6238(VarCurr,17) ) ).

tff(addAssignment_30920,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,19)
    <=> v53211(VarCurr,19) ) ).

tff(addAssignment_30919,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,19)
    <=> $false ) ).

tff(addAssignment_30918,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,19)
    <=> v53154(VarCurr,19) ) ).

tff(addAssignment_30917,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,19)
    <=> v53155(VarCurr,19) ) ).

tff(addAssignment_30916,axiom,
    ! [VarCurr: state_type] :
      ( v54865(VarCurr)
    <=> v54867(VarCurr) ) ).

tff(addAssignment_30915,axiom,
    ! [VarCurr: state_type] :
      ( v54867(VarCurr)
    <=> v6017(VarCurr,75) ) ).

tff(addAssignment_30914,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,75)
    <=> v53103(VarCurr,11) ) ).

tff(addAssignment_30913,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,11)
    <=> v53105(VarCurr,11) ) ).

tff(addAssignment_30912,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,11)
    <=> v53107(VarCurr,11) ) ).

tff(addAssignment_30911,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,11)
    <=> v53109(VarCurr,11) ) ).

tff(addAssignment_30910,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,11)
    <=> v6027(VarCurr,75) ) ).

tff(addAssignment_30909,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,75)
    <=> v52434(VarCurr,75) ) ).

tff(addAssignment_30908,axiom,
    ! [VarCurr: state_type] :
      ( v52448(VarCurr,3)
    <=> v53112(VarCurr,11) ) ).

tff(addAssignment_30907,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,11)
    <=> v53114(VarCurr,11) ) ).

tff(addAssignment_30906,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,11)
    <=> v54897(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54898(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54897(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_692,axiom,
    ! [VarNext: state_type] :
      ( v54898(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54897(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54898(VarNext)
      <=> v54899(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54899(VarNext)
      <=> ( v54901(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54901(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30905,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,11)
    <=> v53138(VarCurr,11) ) ).

tff(addAssignment_30904,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,11)
    <=> v6059(VarCurr,75) ) ).

tff(addAssignment_30903,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,75)
    <=> v54870(VarCurr,3) ) ).

tff(addAssignment_30902,axiom,
    ! [VarCurr: state_type] :
      ( v54870(VarCurr,3)
    <=> v54872(VarCurr,3) ) ).

tff(addAssignment_30901,axiom,
    ! [VarCurr: state_type] :
      ( v54872(VarCurr,3)
    <=> v54889(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54889(VarCurr,B)
      <=> ( v54890(VarCurr,B)
          | v54893(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54893(VarCurr,B)
      <=> ( v54882(VarCurr,B)
          & v54894(VarCurr,B) ) ) ) ).

tff(addAssignment_30900,axiom,
    ! [VarCurr: state_type] :
      ( v54894(VarCurr,0)
    <=> v54895(VarCurr) ) ).

tff(addAssignment_30899,axiom,
    ! [VarCurr: state_type] :
      ( v54894(VarCurr,1)
    <=> v54895(VarCurr) ) ).

tff(addAssignment_30898,axiom,
    ! [VarCurr: state_type] :
      ( v54894(VarCurr,2)
    <=> v54895(VarCurr) ) ).

tff(addAssignment_30897,axiom,
    ! [VarCurr: state_type] :
      ( v54894(VarCurr,3)
    <=> v54895(VarCurr) ) ).

tff(addAssignment_30896,axiom,
    ! [VarCurr: state_type] :
      ( v54895(VarCurr)
    <=> v54886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_900,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54890(VarCurr,B)
      <=> ( v54874(VarCurr,B)
          & v54891(VarCurr,B) ) ) ) ).

tff(addAssignment_30895,axiom,
    ! [VarCurr: state_type] :
      ( v54891(VarCurr,0)
    <=> v54892(VarCurr) ) ).

tff(addAssignment_30894,axiom,
    ! [VarCurr: state_type] :
      ( v54891(VarCurr,1)
    <=> v54892(VarCurr) ) ).

tff(addAssignment_30893,axiom,
    ! [VarCurr: state_type] :
      ( v54891(VarCurr,2)
    <=> v54892(VarCurr) ) ).

tff(addAssignment_30892,axiom,
    ! [VarCurr: state_type] :
      ( v54891(VarCurr,3)
    <=> v54892(VarCurr) ) ).

tff(addAssignment_30891,axiom,
    ! [VarCurr: state_type] :
      ( v54892(VarCurr)
    <=> v54878(VarCurr) ) ).

tff(addAssignment_30890,axiom,
    ! [VarCurr: state_type] :
      ( v54886(VarCurr)
    <=> v54888(VarCurr) ) ).

tff(addAssignment_30889,axiom,
    ! [VarCurr: state_type] :
      ( v54888(VarCurr)
    <=> v52379(VarCurr,18) ) ).

tff(addAssignment_30888,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,18)
    <=> v52381(VarCurr,18) ) ).

tff(addAssignment_30887,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,18)
    <=> v52383(VarCurr,18) ) ).

tff(addAssignment_30886,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,18)
    <=> v52384(VarCurr,18) ) ).

tff(addAssignment_30885,axiom,
    ! [VarCurr: state_type] :
      ( v54882(VarCurr,3)
    <=> v54884(VarCurr,3) ) ).

tff(addAssignment_30884,axiom,
    ! [VarCurr: state_type] :
      ( v54884(VarCurr,3)
    <=> v6069(VarCurr,75) ) ).

tff(addAssignment_30883,axiom,
    ! [VarCurr: state_type] :
      ( v54878(VarCurr)
    <=> v54880(VarCurr) ) ).

tff(addAssignment_30882,axiom,
    ! [VarCurr: state_type] :
      ( v54880(VarCurr)
    <=> v52361(VarCurr,18) ) ).

tff(addAssignment_30881,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,18)
    <=> v52363(VarCurr,18) ) ).

tff(addAssignment_30880,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,18)
    <=> v52365(VarCurr,18) ) ).

tff(addAssignment_30879,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,18)
    <=> v52367(VarCurr,18) ) ).

tff(addAssignment_30878,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,18)
    <=> v52369(VarCurr,18) ) ).

tff(addAssignment_30877,axiom,
    ! [VarCurr: state_type] :
      ( v54874(VarCurr,3)
    <=> v54876(VarCurr,3) ) ).

tff(addAssignment_30876,axiom,
    ! [VarCurr: state_type] :
      ( v54876(VarCurr,3)
    <=> v6069(VarCurr,79) ) ).

tff(addAssignment_30875,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,79)
    <=> v53148(VarCurr,15) ) ).

tff(addAssignment_30874,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,15)
    <=> v53150(VarCurr,15) ) ).

tff(addAssignment_30873,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,15)
    <=> v53242(VarCurr,15) ) ).

tff(addAssignment_30872,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,15)
    <=> v53160(VarCurr,15) ) ).

tff(addAssignment_30871,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,15)
    <=> v6098(VarCurr,79) ) ).

tff(addAssignment_30870,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,79)
    <=> v6100(VarCurr,79) ) ).

tff(addAssignment_30869,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,79)
    <=> v6102(VarCurr,79) ) ).

tff(addAssignment_30868,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,79)
    <=> v53162(VarCurr,15) ) ).

tff(addAssignment_30867,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,15)
    <=> v53164(VarCurr,15) ) ).

tff(addAssignment_30866,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,15)
    <=> v53225(VarCurr,15) ) ).

tff(addAssignment_30865,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,15)
    <=> v53223(VarCurr,15) ) ).

tff(addAssignment_30864,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,15)
    <=> v53224(VarCurr,15) ) ).

tff(addAssignment_30863,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,15)
    <=> v53215(VarCurr,15) ) ).

tff(addAssignment_30862,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,15)
    <=> v53219(VarCurr,15) ) ).

tff(addAssignment_30861,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,7)
    <=> v53218(VarCurr,7) ) ).

tff(addAssignment_30860,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,13)
    <=> v6238(VarCurr,13) ) ).

tff(addAssignment_30859,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,15)
    <=> v53211(VarCurr,15) ) ).

tff(addAssignment_30858,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_30857,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,15)
    <=> v53154(VarCurr,15) ) ).

tff(addAssignment_30856,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,15)
    <=> v53155(VarCurr,15) ) ).

tff(addAssignment_30855,axiom,
    ! [VarCurr: state_type] :
      ( v54723(VarCurr)
    <=> v54725(VarCurr) ) ).

tff(addAssignment_30854,axiom,
    ! [VarCurr: state_type] :
      ( v54725(VarCurr)
    <=> v54727(VarCurr) ) ).

tff(addAssignment_30853,axiom,
    ! [VarCurr: state_type] :
      ( v54727(VarCurr)
    <=> v54729(VarCurr) ) ).

tff(addAssignment_30852,axiom,
    ! [VarCurr: state_type] :
      ( v54729(VarCurr)
    <=> v54731(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5151,axiom,
    ! [VarCurr: state_type] :
      ( v54731(VarCurr)
    <=> ( v54853(VarCurr)
      <~> v54813(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5150,axiom,
    ! [VarCurr: state_type] :
      ( v54853(VarCurr)
    <=> ( v54733(VarCurr)
      <~> v54773(VarCurr) ) ) ).

tff(addAssignment_30851,axiom,
    ! [VarCurr: state_type] :
      ( v54813(VarCurr)
    <=> v54815(VarCurr) ) ).

tff(addAssignment_30850,axiom,
    ! [VarCurr: state_type] :
      ( v54815(VarCurr)
    <=> v6017(VarCurr,71) ) ).

tff(addAssignment_30849,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,71)
    <=> v53103(VarCurr,7) ) ).

tff(addAssignment_30848,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,7)
    <=> v53105(VarCurr,7) ) ).

tff(addAssignment_30847,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,7)
    <=> v53107(VarCurr,7) ) ).

tff(addAssignment_30846,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,7)
    <=> v53109(VarCurr,7) ) ).

tff(addAssignment_30845,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,7)
    <=> v6027(VarCurr,71) ) ).

tff(addAssignment_30844,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,71)
    <=> v52434(VarCurr,71) ) ).

tff(addAssignment_30843,axiom,
    ! [VarCurr: state_type] :
      ( v52449(VarCurr,3)
    <=> v53112(VarCurr,7) ) ).

tff(addAssignment_30842,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,7)
    <=> v53114(VarCurr,7) ) ).

tff(addAssignment_30841,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,7)
    <=> v54845(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54846(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54845(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_691,axiom,
    ! [VarNext: state_type] :
      ( v54846(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54845(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54846(VarNext)
      <=> v54847(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54847(VarNext)
      <=> ( v54849(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54849(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30840,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,7)
    <=> v53138(VarCurr,7) ) ).

tff(addAssignment_30839,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,7)
    <=> v6059(VarCurr,71) ) ).

tff(addAssignment_30838,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,71)
    <=> v54818(VarCurr,3) ) ).

tff(addAssignment_30837,axiom,
    ! [VarCurr: state_type] :
      ( v54818(VarCurr,3)
    <=> v54820(VarCurr,3) ) ).

tff(addAssignment_30836,axiom,
    ! [VarCurr: state_type] :
      ( v54820(VarCurr,3)
    <=> v54837(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_899,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54837(VarCurr,B)
      <=> ( v54838(VarCurr,B)
          | v54841(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_898,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54841(VarCurr,B)
      <=> ( v54830(VarCurr,B)
          & v54842(VarCurr,B) ) ) ) ).

tff(addAssignment_30835,axiom,
    ! [VarCurr: state_type] :
      ( v54842(VarCurr,0)
    <=> v54843(VarCurr) ) ).

tff(addAssignment_30834,axiom,
    ! [VarCurr: state_type] :
      ( v54842(VarCurr,1)
    <=> v54843(VarCurr) ) ).

tff(addAssignment_30833,axiom,
    ! [VarCurr: state_type] :
      ( v54842(VarCurr,2)
    <=> v54843(VarCurr) ) ).

tff(addAssignment_30832,axiom,
    ! [VarCurr: state_type] :
      ( v54842(VarCurr,3)
    <=> v54843(VarCurr) ) ).

tff(addAssignment_30831,axiom,
    ! [VarCurr: state_type] :
      ( v54843(VarCurr)
    <=> v54834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54838(VarCurr,B)
      <=> ( v54822(VarCurr,B)
          & v54839(VarCurr,B) ) ) ) ).

tff(addAssignment_30830,axiom,
    ! [VarCurr: state_type] :
      ( v54839(VarCurr,0)
    <=> v54840(VarCurr) ) ).

tff(addAssignment_30829,axiom,
    ! [VarCurr: state_type] :
      ( v54839(VarCurr,1)
    <=> v54840(VarCurr) ) ).

tff(addAssignment_30828,axiom,
    ! [VarCurr: state_type] :
      ( v54839(VarCurr,2)
    <=> v54840(VarCurr) ) ).

tff(addAssignment_30827,axiom,
    ! [VarCurr: state_type] :
      ( v54839(VarCurr,3)
    <=> v54840(VarCurr) ) ).

tff(addAssignment_30826,axiom,
    ! [VarCurr: state_type] :
      ( v54840(VarCurr)
    <=> v54826(VarCurr) ) ).

tff(addAssignment_30825,axiom,
    ! [VarCurr: state_type] :
      ( v54834(VarCurr)
    <=> v54836(VarCurr) ) ).

tff(addAssignment_30824,axiom,
    ! [VarCurr: state_type] :
      ( v54836(VarCurr)
    <=> v52379(VarCurr,17) ) ).

tff(addAssignment_30823,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,17)
    <=> v52381(VarCurr,17) ) ).

tff(addAssignment_30822,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,17)
    <=> v52383(VarCurr,17) ) ).

tff(addAssignment_30821,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,17)
    <=> v52384(VarCurr,17) ) ).

tff(addAssignment_30820,axiom,
    ! [VarCurr: state_type] :
      ( v54830(VarCurr,3)
    <=> v54832(VarCurr,3) ) ).

tff(addAssignment_30819,axiom,
    ! [VarCurr: state_type] :
      ( v54832(VarCurr,3)
    <=> v6069(VarCurr,71) ) ).

tff(addAssignment_30818,axiom,
    ! [VarCurr: state_type] :
      ( v54826(VarCurr)
    <=> v54828(VarCurr) ) ).

tff(addAssignment_30817,axiom,
    ! [VarCurr: state_type] :
      ( v54828(VarCurr)
    <=> v52361(VarCurr,17) ) ).

tff(addAssignment_30816,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,17)
    <=> v52363(VarCurr,17) ) ).

tff(addAssignment_30815,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,17)
    <=> v52365(VarCurr,17) ) ).

tff(addAssignment_30814,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,17)
    <=> v52367(VarCurr,17) ) ).

tff(addAssignment_30813,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,17)
    <=> v52369(VarCurr,17) ) ).

tff(addAssignment_30812,axiom,
    ! [VarCurr: state_type] :
      ( v54822(VarCurr,3)
    <=> v54824(VarCurr,3) ) ).

tff(addAssignment_30811,axiom,
    ! [VarCurr: state_type] :
      ( v54824(VarCurr,3)
    <=> v6069(VarCurr,75) ) ).

tff(addAssignment_30810,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,75)
    <=> v53148(VarCurr,11) ) ).

tff(addAssignment_30809,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,11)
    <=> v53150(VarCurr,11) ) ).

tff(addAssignment_30808,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,11)
    <=> v53242(VarCurr,11) ) ).

tff(addAssignment_30807,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,11)
    <=> v53160(VarCurr,11) ) ).

tff(addAssignment_30806,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,11)
    <=> v6098(VarCurr,75) ) ).

tff(addAssignment_30805,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,75)
    <=> v6100(VarCurr,75) ) ).

tff(addAssignment_30804,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,75)
    <=> v6102(VarCurr,75) ) ).

tff(addAssignment_30803,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,75)
    <=> v53162(VarCurr,11) ) ).

tff(addAssignment_30802,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,11)
    <=> v53164(VarCurr,11) ) ).

tff(addAssignment_30801,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,11)
    <=> v53225(VarCurr,11) ) ).

tff(addAssignment_30800,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,11)
    <=> v53223(VarCurr,11) ) ).

tff(addAssignment_30799,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,11)
    <=> v53224(VarCurr,11) ) ).

tff(addAssignment_30798,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,11)
    <=> v53215(VarCurr,11) ) ).

tff(addAssignment_30797,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,11)
    <=> v53219(VarCurr,11) ) ).

tff(addAssignment_30796,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,3)
    <=> v53218(VarCurr,3) ) ).

tff(addAssignment_30795,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,3)
    <=> v6238(VarCurr,3) ) ).

tff(addAssignment_30794,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,11)
    <=> v53211(VarCurr,11) ) ).

tff(addAssignment_30793,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_30792,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,11)
    <=> v53154(VarCurr,11) ) ).

tff(addAssignment_30791,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,11)
    <=> v53155(VarCurr,11) ) ).

tff(addAssignment_30790,axiom,
    ! [VarCurr: state_type] :
      ( v54773(VarCurr)
    <=> v54775(VarCurr) ) ).

tff(addAssignment_30789,axiom,
    ! [VarCurr: state_type] :
      ( v54775(VarCurr)
    <=> v6017(VarCurr,67) ) ).

tff(addAssignment_30788,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,67)
    <=> v53103(VarCurr,3) ) ).

tff(addAssignment_30787,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,3)
    <=> v53105(VarCurr,3) ) ).

tff(addAssignment_30786,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,3)
    <=> v53107(VarCurr,3) ) ).

tff(addAssignment_30785,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,3)
    <=> v53109(VarCurr,3) ) ).

tff(addAssignment_30784,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,3)
    <=> v6027(VarCurr,67) ) ).

tff(addAssignment_30783,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,67)
    <=> v52434(VarCurr,67) ) ).

tff(addAssignment_30782,axiom,
    ! [VarCurr: state_type] :
      ( v52450(VarCurr,3)
    <=> v53112(VarCurr,3) ) ).

tff(addAssignment_30781,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,3)
    <=> v53114(VarCurr,3) ) ).

tff(addAssignment_30780,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,3)
    <=> v54805(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54806(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54805(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_690,axiom,
    ! [VarNext: state_type] :
      ( v54806(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54805(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54806(VarNext)
      <=> v54807(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54807(VarNext)
      <=> ( v54809(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54809(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30779,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,3)
    <=> v53138(VarCurr,3) ) ).

tff(addAssignment_30778,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,3)
    <=> v6059(VarCurr,67) ) ).

tff(addAssignment_30777,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,67)
    <=> v54778(VarCurr,3) ) ).

tff(addAssignment_30776,axiom,
    ! [VarCurr: state_type] :
      ( v54778(VarCurr,3)
    <=> v54780(VarCurr,3) ) ).

tff(addAssignment_30775,axiom,
    ! [VarCurr: state_type] :
      ( v54780(VarCurr,3)
    <=> v54797(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54797(VarCurr,B)
      <=> ( v54798(VarCurr,B)
          | v54801(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54801(VarCurr,B)
      <=> ( v54790(VarCurr,B)
          & v54802(VarCurr,B) ) ) ) ).

tff(addAssignment_30774,axiom,
    ! [VarCurr: state_type] :
      ( v54802(VarCurr,0)
    <=> v54803(VarCurr) ) ).

tff(addAssignment_30773,axiom,
    ! [VarCurr: state_type] :
      ( v54802(VarCurr,1)
    <=> v54803(VarCurr) ) ).

tff(addAssignment_30772,axiom,
    ! [VarCurr: state_type] :
      ( v54802(VarCurr,2)
    <=> v54803(VarCurr) ) ).

tff(addAssignment_30771,axiom,
    ! [VarCurr: state_type] :
      ( v54802(VarCurr,3)
    <=> v54803(VarCurr) ) ).

tff(addAssignment_30770,axiom,
    ! [VarCurr: state_type] :
      ( v54803(VarCurr)
    <=> v54794(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54798(VarCurr,B)
      <=> ( v54782(VarCurr,B)
          & v54799(VarCurr,B) ) ) ) ).

tff(addAssignment_30769,axiom,
    ! [VarCurr: state_type] :
      ( v54799(VarCurr,0)
    <=> v54800(VarCurr) ) ).

tff(addAssignment_30768,axiom,
    ! [VarCurr: state_type] :
      ( v54799(VarCurr,1)
    <=> v54800(VarCurr) ) ).

tff(addAssignment_30767,axiom,
    ! [VarCurr: state_type] :
      ( v54799(VarCurr,2)
    <=> v54800(VarCurr) ) ).

tff(addAssignment_30766,axiom,
    ! [VarCurr: state_type] :
      ( v54799(VarCurr,3)
    <=> v54800(VarCurr) ) ).

tff(addAssignment_30765,axiom,
    ! [VarCurr: state_type] :
      ( v54800(VarCurr)
    <=> v54786(VarCurr) ) ).

tff(addAssignment_30764,axiom,
    ! [VarCurr: state_type] :
      ( v54794(VarCurr)
    <=> v54796(VarCurr) ) ).

tff(addAssignment_30763,axiom,
    ! [VarCurr: state_type] :
      ( v54796(VarCurr)
    <=> v52379(VarCurr,16) ) ).

tff(addAssignment_30762,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,16)
    <=> v52381(VarCurr,16) ) ).

tff(addAssignment_30761,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,16)
    <=> v52383(VarCurr,16) ) ).

tff(addAssignment_30760,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,16)
    <=> v52384(VarCurr,16) ) ).

tff(addAssignment_30759,axiom,
    ! [VarCurr: state_type] :
      ( v54790(VarCurr,3)
    <=> v54792(VarCurr,3) ) ).

tff(addAssignment_30758,axiom,
    ! [VarCurr: state_type] :
      ( v54792(VarCurr,3)
    <=> v6069(VarCurr,67) ) ).

tff(addAssignment_30757,axiom,
    ! [VarCurr: state_type] :
      ( v54786(VarCurr)
    <=> v54788(VarCurr) ) ).

tff(addAssignment_30756,axiom,
    ! [VarCurr: state_type] :
      ( v54788(VarCurr)
    <=> v52361(VarCurr,16) ) ).

tff(addAssignment_30755,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,16)
    <=> v52363(VarCurr,16) ) ).

tff(addAssignment_30754,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,16)
    <=> v52365(VarCurr,16) ) ).

tff(addAssignment_30753,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,16)
    <=> v52367(VarCurr,16) ) ).

tff(addAssignment_30752,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,16)
    <=> v52369(VarCurr,16) ) ).

tff(addAssignment_30751,axiom,
    ! [VarCurr: state_type] :
      ( v54782(VarCurr,3)
    <=> v54784(VarCurr,3) ) ).

tff(addAssignment_30750,axiom,
    ! [VarCurr: state_type] :
      ( v54784(VarCurr,3)
    <=> v6069(VarCurr,71) ) ).

tff(addAssignment_30749,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,71)
    <=> v53148(VarCurr,7) ) ).

tff(addAssignment_30748,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,7)
    <=> v53150(VarCurr,7) ) ).

tff(addAssignment_30747,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,7)
    <=> v53242(VarCurr,7) ) ).

tff(addAssignment_30746,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,7)
    <=> v53160(VarCurr,7) ) ).

tff(addAssignment_30745,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,7)
    <=> v6098(VarCurr,71) ) ).

tff(addAssignment_30744,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,71)
    <=> v6100(VarCurr,71) ) ).

tff(addAssignment_30743,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,71)
    <=> v6102(VarCurr,71) ) ).

tff(addAssignment_30742,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,71)
    <=> v53162(VarCurr,7) ) ).

tff(addAssignment_30741,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,7)
    <=> v53164(VarCurr,7) ) ).

tff(addAssignment_30740,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,7)
    <=> v53225(VarCurr,7) ) ).

tff(addAssignment_30739,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,7)
    <=> v53223(VarCurr,7) ) ).

tff(addAssignment_30738,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,7)
    <=> v53224(VarCurr,7) ) ).

tff(addAssignment_30737,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,71)
    <=> v52335(VarCurr,71) ) ).

tff(addAssignment_30736,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,137)
    <=> v33839(VarCurr,137) ) ).

tff(addAssignment_30735,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,137)
    <=> v33841(VarCurr,137) ) ).

tff(addAssignment_30734,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,137)
    <=> v26555(VarCurr,5) ) ).

tff(addAssignment_30733,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,7)
    <=> v53215(VarCurr,7) ) ).

tff(addAssignment_30732,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,7)
    <=> v53219(VarCurr,7) ) ).

tff(addAssignment_30731,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,71)
    <=> v52325(VarCurr,71) ) ).

tff(addAssignment_30730,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,143)
    <=> v6238(VarCurr,143) ) ).

tff(addAssignment_30729,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,143)
    <=> v6240(VarCurr,143) ) ).

tff(addAssignment_30728,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,143)
    <=> v47849(VarCurr,11) ) ).

tff(addAssignment_30727,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,7)
    <=> v53211(VarCurr,7) ) ).

tff(addAssignment_30726,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_30725,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,7)
    <=> v53154(VarCurr,7) ) ).

tff(addAssignment_30724,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,7)
    <=> v53155(VarCurr,7) ) ).

tff(addAssignment_30723,axiom,
    ! [VarCurr: state_type] :
      ( v54733(VarCurr)
    <=> v54735(VarCurr) ) ).

tff(addAssignment_30722,axiom,
    ! [VarCurr: state_type] :
      ( v54735(VarCurr)
    <=> v6017(VarCurr,63) ) ).

tff(addAssignment_30721,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,63)
    <=> v6019(VarCurr,63) ) ).

tff(addAssignment_30720,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,63)
    <=> v6021(VarCurr,63) ) ).

tff(addAssignment_30719,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,63)
    <=> v6023(VarCurr,63) ) ).

tff(addAssignment_30718,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,63)
    <=> v6025(VarCurr,63) ) ).

tff(addAssignment_30717,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,63)
    <=> v6027(VarCurr,63) ) ).

tff(addAssignment_30716,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,63)
    <=> v52434(VarCurr,63) ) ).

tff(addAssignment_30715,axiom,
    ! [VarCurr: state_type] :
      ( v52451(VarCurr,3)
    <=> v6031(VarCurr,63) ) ).

tff(addAssignment_30714,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,63)
    <=> v6033(VarCurr,63) ) ).

tff(addAssignment_30713,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,63)
    <=> v54765(VarNext,63) ) ).

tff(addCaseBooleanConditionEqualRanges1_689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54766(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54765(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_689,axiom,
    ! [VarNext: state_type] :
      ( v54766(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54765(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54766(VarNext)
      <=> v54767(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54767(VarNext)
      <=> ( v54769(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54769(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30712,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,63)
    <=> v6057(VarCurr,63) ) ).

tff(addAssignment_30711,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,63)
    <=> v6059(VarCurr,63) ) ).

tff(addAssignment_30710,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,63)
    <=> v54738(VarCurr,3) ) ).

tff(addAssignment_30709,axiom,
    ! [VarCurr: state_type] :
      ( v54738(VarCurr,3)
    <=> v54740(VarCurr,3) ) ).

tff(addAssignment_30708,axiom,
    ! [VarCurr: state_type] :
      ( v54740(VarCurr,3)
    <=> v54757(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54757(VarCurr,B)
      <=> ( v54758(VarCurr,B)
          | v54761(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54761(VarCurr,B)
      <=> ( v54750(VarCurr,B)
          & v54762(VarCurr,B) ) ) ) ).

tff(addAssignment_30707,axiom,
    ! [VarCurr: state_type] :
      ( v54762(VarCurr,0)
    <=> v54763(VarCurr) ) ).

tff(addAssignment_30706,axiom,
    ! [VarCurr: state_type] :
      ( v54762(VarCurr,1)
    <=> v54763(VarCurr) ) ).

tff(addAssignment_30705,axiom,
    ! [VarCurr: state_type] :
      ( v54762(VarCurr,2)
    <=> v54763(VarCurr) ) ).

tff(addAssignment_30704,axiom,
    ! [VarCurr: state_type] :
      ( v54762(VarCurr,3)
    <=> v54763(VarCurr) ) ).

tff(addAssignment_30703,axiom,
    ! [VarCurr: state_type] :
      ( v54763(VarCurr)
    <=> v54754(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v54758(VarCurr,B)
      <=> ( v54742(VarCurr,B)
          & v54759(VarCurr,B) ) ) ) ).

tff(addAssignment_30702,axiom,
    ! [VarCurr: state_type] :
      ( v54759(VarCurr,0)
    <=> v54760(VarCurr) ) ).

tff(addAssignment_30701,axiom,
    ! [VarCurr: state_type] :
      ( v54759(VarCurr,1)
    <=> v54760(VarCurr) ) ).

tff(addAssignment_30700,axiom,
    ! [VarCurr: state_type] :
      ( v54759(VarCurr,2)
    <=> v54760(VarCurr) ) ).

tff(addAssignment_30699,axiom,
    ! [VarCurr: state_type] :
      ( v54759(VarCurr,3)
    <=> v54760(VarCurr) ) ).

tff(addAssignment_30698,axiom,
    ! [VarCurr: state_type] :
      ( v54760(VarCurr)
    <=> v54746(VarCurr) ) ).

tff(addAssignment_30697,axiom,
    ! [VarCurr: state_type] :
      ( v54754(VarCurr)
    <=> v54756(VarCurr) ) ).

tff(addAssignment_30696,axiom,
    ! [VarCurr: state_type] :
      ( v54756(VarCurr)
    <=> v52379(VarCurr,15) ) ).

tff(addAssignment_30695,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,15)
    <=> v52381(VarCurr,15) ) ).

tff(addAssignment_30694,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,15)
    <=> v52383(VarCurr,15) ) ).

tff(addAssignment_30693,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,15)
    <=> v52384(VarCurr,15) ) ).

tff(addAssignment_30692,axiom,
    ! [VarCurr: state_type] :
      ( v54750(VarCurr,3)
    <=> v54752(VarCurr,3) ) ).

tff(addAssignment_30691,axiom,
    ! [VarCurr: state_type] :
      ( v54752(VarCurr,3)
    <=> v6069(VarCurr,63) ) ).

tff(addAssignment_30690,axiom,
    ! [VarCurr: state_type] :
      ( v54746(VarCurr)
    <=> v54748(VarCurr) ) ).

tff(addAssignment_30689,axiom,
    ! [VarCurr: state_type] :
      ( v54748(VarCurr)
    <=> v52361(VarCurr,15) ) ).

tff(addAssignment_30688,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,15)
    <=> v52363(VarCurr,15) ) ).

tff(addAssignment_30687,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,15)
    <=> v52365(VarCurr,15) ) ).

tff(addAssignment_30686,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,15)
    <=> v52367(VarCurr,15) ) ).

tff(addAssignment_30685,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,15)
    <=> v52369(VarCurr,15) ) ).

tff(addAssignment_30684,axiom,
    ! [VarCurr: state_type] :
      ( v54742(VarCurr,3)
    <=> v54744(VarCurr,3) ) ).

tff(addAssignment_30683,axiom,
    ! [VarCurr: state_type] :
      ( v54744(VarCurr,3)
    <=> v6069(VarCurr,67) ) ).

tff(addAssignment_30682,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,67)
    <=> v53148(VarCurr,3) ) ).

tff(addAssignment_30681,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,3)
    <=> v53150(VarCurr,3) ) ).

tff(addAssignment_30680,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,3)
    <=> v53242(VarCurr,3) ) ).

tff(addAssignment_30679,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,3)
    <=> v53160(VarCurr,3) ) ).

tff(addAssignment_30678,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,3)
    <=> v6098(VarCurr,67) ) ).

tff(addAssignment_30677,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,67)
    <=> v6100(VarCurr,67) ) ).

tff(addAssignment_30676,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,67)
    <=> v6102(VarCurr,67) ) ).

tff(addAssignment_30675,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,67)
    <=> v53162(VarCurr,3) ) ).

tff(addAssignment_30674,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,3)
    <=> v53164(VarCurr,3) ) ).

tff(addAssignment_30673,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,3)
    <=> v53225(VarCurr,3) ) ).

tff(addAssignment_30672,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,3)
    <=> v53223(VarCurr,3) ) ).

tff(addAssignment_30671,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,3)
    <=> v53224(VarCurr,3) ) ).

tff(addAssignment_30670,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,67)
    <=> v52335(VarCurr,67) ) ).

tff(addAssignment_30669,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,133)
    <=> v33839(VarCurr,133) ) ).

tff(addAssignment_30668,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,133)
    <=> v33841(VarCurr,133) ) ).

tff(addAssignment_30667,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,133)
    <=> v26555(VarCurr,1) ) ).

tff(addAssignment_30666,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,3)
    <=> v53215(VarCurr,3) ) ).

tff(addAssignment_30665,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,3)
    <=> v53219(VarCurr,3) ) ).

tff(addAssignment_30664,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,67)
    <=> v52325(VarCurr,67) ) ).

tff(addAssignment_30663,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,139)
    <=> v6238(VarCurr,139) ) ).

tff(addAssignment_30662,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,139)
    <=> v6240(VarCurr,139) ) ).

tff(addAssignment_30661,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,139)
    <=> v47849(VarCurr,7) ) ).

tff(addAssignment_30660,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,3)
    <=> v53211(VarCurr,3) ) ).

tff(addAssignment_30659,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_30658,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,3)
    <=> v53154(VarCurr,3) ) ).

tff(addAssignment_30657,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,3)
    <=> v53155(VarCurr,3) ) ).

tff(addAssignment_30656,axiom,
    ! [VarCurr: state_type] :
      ( v5941(VarCurr)
    <=> v5943(VarCurr) ) ).

tff(addAssignment_30655,axiom,
    ! [VarCurr: state_type] :
      ( v5943(VarCurr)
    <=> v5945(VarCurr) ) ).

tff(addAssignment_30654,axiom,
    ! [VarCurr: state_type] :
      ( v5945(VarCurr)
    <=> v5947(VarCurr) ) ).

tff(addAssignment_30653,axiom,
    ! [VarCurr: state_type] :
      ( v5947(VarCurr)
    <=> v5949(VarCurr) ) ).

tff(writeUnaryOperator_3067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5949(VarCurr)
    <=> v5951(VarCurr) ) ).

tff(addAssignment_30652,axiom,
    ! [VarCurr: state_type] :
      ( v5951(VarCurr)
    <=> v5953(VarCurr) ) ).

tff(addAssignment_30651,axiom,
    ! [VarCurr: state_type] :
      ( v5953(VarCurr)
    <=> v5955(VarCurr) ) ).

tff(addAssignment_30650,axiom,
    ! [VarCurr: state_type] :
      ( v5955(VarCurr)
    <=> v5957(VarCurr) ) ).

tff(addAssignment_30649,axiom,
    ! [VarCurr: state_type] :
      ( v5957(VarCurr)
    <=> v5959(VarCurr) ) ).

tff(writeUnaryOperator_3066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5959(VarCurr)
    <=> v54669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5143,axiom,
    ! [VarCurr: state_type] :
      ( v54669(VarCurr)
    <=> ( v5961(VarCurr)
        & v54005(VarCurr) ) ) ).

tff(addAssignment_30648,axiom,
    ! [VarCurr: state_type] :
      ( v54005(VarCurr)
    <=> v54007(VarCurr) ) ).

tff(addAssignment_30647,axiom,
    ! [VarCurr: state_type] :
      ( v54007(VarCurr)
    <=> v54009(VarCurr) ) ).

tff(addAssignment_30646,axiom,
    ! [VarCurr: state_type] :
      ( v54009(VarCurr)
    <=> v54011(VarCurr) ) ).

tff(addAssignment_30645,axiom,
    ! [VarCurr: state_type] :
      ( v54011(VarCurr)
    <=> v54013(VarCurr) ) ).

tff(writeUnaryOperator_3065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v54013(VarCurr)
    <=> v54667(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5142,axiom,
    ! [VarCurr: state_type] :
      ( v54667(VarCurr)
    <=> ( v54015(VarCurr)
        | v54341(VarCurr) ) ) ).

tff(addAssignment_30644,axiom,
    ! [VarCurr: state_type] :
      ( v54341(VarCurr)
    <=> v54343(VarCurr) ) ).

tff(addAssignment_30643,axiom,
    ! [VarCurr: state_type] :
      ( v54343(VarCurr)
    <=> v5975(VarCurr,0) ) ).

tff(addAssignment_30642,axiom,
    ! [VarCurr: state_type] :
      ( v5975(VarCurr,0)
    <=> v5977(VarCurr,8) ) ).

tff(addAssignment_30641,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,8)
    <=> v5979(VarCurr,8) ) ).

tff(addAssignment_30640,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,8)
    <=> v5981(VarCurr,8) ) ).

tff(addAssignment_30639,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,8)
    <=> v5983(VarCurr,8) ) ).

tff(addAssignment_30638,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,8)
    <=> v5985(VarCurr,8) ) ).

tff(addAssignment_30637,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,8)
    <=> v53672(VarCurr,8) ) ).

tff(addAssignment_30636,axiom,
    ! [VarCurr: state_type] :
      ( v5987(VarCurr,0)
    <=> v54345(VarCurr) ) ).

tff(addAssignment_30635,axiom,
    ! [VarCurr: state_type] :
      ( v54345(VarCurr)
    <=> v54347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5141,axiom,
    ! [VarCurr: state_type] :
      ( v54347(VarCurr)
    <=> ( v54665(VarCurr)
      <~> v54653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5140,axiom,
    ! [VarCurr: state_type] :
      ( v54665(VarCurr)
    <=> ( v54349(VarCurr)
      <~> v54505(VarCurr) ) ) ).

tff(addAssignment_30634,axiom,
    ! [VarCurr: state_type] :
      ( v54653(VarCurr)
    <=> v54655(VarCurr) ) ).

tff(addAssignment_30633,axiom,
    ! [VarCurr: state_type] :
      ( v54655(VarCurr)
    <=> v53573(VarCurr,0) ) ).

tff(addAssignment_30632,axiom,
    ! [VarCurr: state_type] :
      ( v53573(VarCurr,0)
    <=> v53575(VarCurr,0) ) ).

tff(addAssignment_30631,axiom,
    ! [VarCurr: state_type] :
      ( v53575(VarCurr,0)
    <=> v53577(VarCurr,0) ) ).

tff(addAssignment_30630,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,0)
    <=> v53579(VarCurr,0) ) ).

tff(addAssignment_30629,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,0)
    <=> v54657(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54658(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v54657(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_688,axiom,
    ! [VarNext: state_type] :
      ( v54658(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v54657(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54658(VarNext)
      <=> v54659(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54659(VarNext)
      <=> ( v54661(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54661(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_30628,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,0)
    <=> v53603(VarCurr,0) ) ).

tff(addAssignment_30627,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,0)
    <=> v53632(VarCurr,0) ) ).

tff(addAssignment_30626,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,8)
    <=> v53606(VarCurr,0) ) ).

tff(addAssignment_30625,axiom,
    ! [VarCurr: state_type] :
      ( v53606(VarCurr,0)
    <=> v53608(VarCurr,0) ) ).

tff(addAssignment_30624,axiom,
    ! [VarCurr: state_type] :
      ( v53608(VarCurr,0)
    <=> v53625(VarCurr,0) ) ).

tff(addAssignment_30623,axiom,
    ! [VarCurr: state_type] :
      ( v53618(VarCurr,0)
    <=> v53620(VarCurr,0) ) ).

tff(addAssignment_30622,axiom,
    ! [VarCurr: state_type] :
      ( v53620(VarCurr,0)
    <=> v53312(VarCurr,8) ) ).

tff(addAssignment_30621,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,8)
    <=> v53314(VarCurr,8) ) ).

tff(addAssignment_30620,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,8)
    <=> v53316(VarCurr,8) ) ).

tff(addAssignment_30619,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,8)
    <=> v53407(VarCurr,8) ) ).

tff(addAssignment_30618,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,8)
    <=> v53326(VarCurr,8) ) ).

tff(addAssignment_30617,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,8)
    <=> v53328(VarCurr,8) ) ).

tff(addAssignment_30616,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,8)
    <=> v6100(VarCurr,136) ) ).

tff(addAssignment_30615,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,136)
    <=> v6102(VarCurr,136) ) ).

tff(addAssignment_30614,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,136)
    <=> v53330(VarCurr,8) ) ).

tff(addAssignment_30613,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,8)
    <=> v53332(VarCurr,8) ) ).

tff(addAssignment_30612,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,8)
    <=> v53390(VarCurr,8) ) ).

tff(addAssignment_30611,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,8)
    <=> v53387(VarCurr,8) ) ).

tff(addAssignment_30610,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,8)
    <=> v53217(VarCurr,64) ) ).

tff(addAssignment_30609,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,8)
    <=> v53383(VarCurr,8) ) ).

tff(addAssignment_30608,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,8)
    <=> v53217(VarCurr,64) ) ).

tff(addAssignment_30607,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,64)
    <=> v53218(VarCurr,64) ) ).

tff(addAssignment_30606,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,124)
    <=> v6238(VarCurr,124) ) ).

tff(addAssignment_30605,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,124)
    <=> v6240(VarCurr,124) ) ).

tff(addAssignment_30604,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,124)
    <=> v46299(VarCurr,4) ) ).

tff(addAssignment_30603,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,8)
    <=> v53379(VarCurr,8) ) ).

tff(addAssignment_30602,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_30601,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,8)
    <=> v53320(VarCurr,8) ) ).

tff(addAssignment_30600,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,8)
    <=> v53321(VarCurr,8) ) ).

tff(addAssignment_30599,axiom,
    ! [VarCurr: state_type] :
      ( v53610(VarCurr,0)
    <=> v53612(VarCurr,0) ) ).

tff(addAssignment_30598,axiom,
    ! [VarCurr: state_type] :
      ( v53612(VarCurr,0)
    <=> v53312(VarCurr,4) ) ).

tff(addAssignment_30597,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,4)
    <=> v53314(VarCurr,4) ) ).

tff(addAssignment_30596,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,4)
    <=> v53316(VarCurr,4) ) ).

tff(addAssignment_30595,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,4)
    <=> v53407(VarCurr,4) ) ).

tff(addAssignment_30594,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,4)
    <=> v53326(VarCurr,4) ) ).

tff(addAssignment_30593,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,4)
    <=> v53328(VarCurr,4) ) ).

tff(addAssignment_30592,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,4)
    <=> v6100(VarCurr,132) ) ).

tff(addAssignment_30591,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,132)
    <=> v6102(VarCurr,132) ) ).

tff(addAssignment_30590,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,132)
    <=> v53330(VarCurr,4) ) ).

tff(addAssignment_30589,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,4)
    <=> v53332(VarCurr,4) ) ).

tff(addAssignment_30588,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,4)
    <=> v53390(VarCurr,4) ) ).

tff(addAssignment_30587,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,4)
    <=> v53387(VarCurr,4) ) ).

tff(addAssignment_30586,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,4)
    <=> v53217(VarCurr,60) ) ).

tff(addAssignment_30585,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,4)
    <=> v53383(VarCurr,4) ) ).

tff(addAssignment_30584,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,4)
    <=> v53217(VarCurr,60) ) ).

tff(addAssignment_30583,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,60)
    <=> v53218(VarCurr,60) ) ).

tff(addAssignment_30582,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,120)
    <=> v6238(VarCurr,120) ) ).

tff(addAssignment_30581,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,120)
    <=> v6240(VarCurr,120) ) ).

tff(addAssignment_30580,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,120)
    <=> v46299(VarCurr,0) ) ).

tff(addAssignment_30579,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,4)
    <=> v53379(VarCurr,4) ) ).

tff(addAssignment_30578,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_30577,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,4)
    <=> v53320(VarCurr,4) ) ).

tff(addAssignment_30576,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,4)
    <=> v53321(VarCurr,4) ) ).

tff(addAssignment_30575,axiom,
    ! [VarCurr: state_type] :
      ( v54505(VarCurr)
    <=> v54507(VarCurr) ) ).

tff(addAssignment_30574,axiom,
    ! [VarCurr: state_type] :
      ( v54507(VarCurr)
    <=> v54509(VarCurr) ) ).

tff(addAssignment_30573,axiom,
    ! [VarCurr: state_type] :
      ( v54509(VarCurr)
    <=> v54511(VarCurr) ) ).

tff(addAssignment_30572,axiom,
    ! [VarCurr: state_type] :
      ( v54511(VarCurr)
    <=> v54513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5137,axiom,
    ! [VarCurr: state_type] :
      ( v54513(VarCurr)
    <=> ( v54651(VarCurr)
      <~> v54611(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5136,axiom,
    ! [VarCurr: state_type] :
      ( v54651(VarCurr)
    <=> ( v54515(VarCurr)
      <~> v54563(VarCurr) ) ) ).

tff(addAssignment_30571,axiom,
    ! [VarCurr: state_type] :
      ( v54611(VarCurr)
    <=> v54613(VarCurr) ) ).

tff(addAssignment_30570,axiom,
    ! [VarCurr: state_type] :
      ( v54613(VarCurr)
    <=> v54615(VarCurr) ) ).

tff(addAssignment_30569,axiom,
    ! [VarCurr: state_type] :
      ( v54615(VarCurr)
    <=> v54617(VarCurr) ) ).

tff(addAssignment_30568,axiom,
    ! [VarCurr: state_type] :
      ( v54617(VarCurr)
    <=> v54619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5135,axiom,
    ! [VarCurr: state_type] :
      ( v54619(VarCurr)
    <=> ( v54649(VarCurr)
      <~> v54645(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5134,axiom,
    ! [VarCurr: state_type] :
      ( v54649(VarCurr)
    <=> ( v54621(VarCurr)
      <~> v54633(VarCurr) ) ) ).

tff(addAssignment_30567,axiom,
    ! [VarCurr: state_type] :
      ( v54645(VarCurr)
    <=> v54647(VarCurr) ) ).

tff(addAssignment_30566,axiom,
    ! [VarCurr: state_type] :
      ( v54647(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_30565,axiom,
    ! [VarCurr: state_type] :
      ( v54633(VarCurr)
    <=> v54635(VarCurr) ) ).

tff(addAssignment_30564,axiom,
    ! [VarCurr: state_type] :
      ( v54635(VarCurr)
    <=> v6017(VarCurr,124) ) ).

tff(addAssignment_30563,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,124)
    <=> v53103(VarCurr,60) ) ).

tff(addAssignment_30562,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,60)
    <=> v53105(VarCurr,60) ) ).

tff(addAssignment_30561,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,60)
    <=> v53107(VarCurr,60) ) ).

tff(addAssignment_30560,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,60)
    <=> v53109(VarCurr,60) ) ).

tff(addAssignment_30559,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,60)
    <=> v6027(VarCurr,124) ) ).

tff(addAssignment_30558,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,124)
    <=> v52434(VarCurr,124) ) ).

tff(addAssignment_30557,axiom,
    ! [VarCurr: state_type] :
      ( v52435(VarCurr,0)
    <=> v53112(VarCurr,60) ) ).

tff(addAssignment_30556,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,60)
    <=> v53114(VarCurr,60) ) ).

tff(addAssignment_30555,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,60)
    <=> v54637(VarNext,60) ) ).

tff(addCaseBooleanConditionEqualRanges1_687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54638(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54637(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_687,axiom,
    ! [VarNext: state_type] :
      ( v54638(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54637(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54638(VarNext)
      <=> v54639(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54639(VarNext)
      <=> ( v54641(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54641(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30554,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,60)
    <=> v53138(VarCurr,60) ) ).

tff(addAssignment_30553,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,60)
    <=> v6059(VarCurr,124) ) ).

tff(addAssignment_30552,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,124)
    <=> v53304(VarCurr,0) ) ).

tff(addAssignment_30551,axiom,
    ! [VarCurr: state_type] :
      ( v53304(VarCurr,0)
    <=> v53306(VarCurr,0) ) ).

tff(addAssignment_30550,axiom,
    ! [VarCurr: state_type] :
      ( v53306(VarCurr,0)
    <=> v53420(VarCurr,0) ) ).

tff(addAssignment_30549,axiom,
    ! [VarCurr: state_type] :
      ( v53413(VarCurr,0)
    <=> v53415(VarCurr,0) ) ).

tff(addAssignment_30548,axiom,
    ! [VarCurr: state_type] :
      ( v53415(VarCurr,0)
    <=> v6069(VarCurr,124) ) ).

tff(addAssignment_30547,axiom,
    ! [VarCurr: state_type] :
      ( v53308(VarCurr,0)
    <=> v53310(VarCurr,0) ) ).

tff(addAssignment_30546,axiom,
    ! [VarCurr: state_type] :
      ( v53310(VarCurr,0)
    <=> v53312(VarCurr,12) ) ).

tff(addAssignment_30545,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,12)
    <=> v53314(VarCurr,12) ) ).

tff(addAssignment_30544,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,12)
    <=> v53316(VarCurr,12) ) ).

tff(addAssignment_30543,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,12)
    <=> v53407(VarCurr,12) ) ).

tff(addAssignment_30542,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,12)
    <=> v53326(VarCurr,12) ) ).

tff(addAssignment_30541,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,12)
    <=> v53328(VarCurr,12) ) ).

tff(addAssignment_30540,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,12)
    <=> v6100(VarCurr,140) ) ).

tff(addAssignment_30539,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,140)
    <=> v6102(VarCurr,140) ) ).

tff(addAssignment_30538,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,140)
    <=> v53330(VarCurr,12) ) ).

tff(addAssignment_30537,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,12)
    <=> v53332(VarCurr,12) ) ).

tff(addAssignment_30536,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,12)
    <=> v53390(VarCurr,12) ) ).

tff(addAssignment_30535,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,12)
    <=> v53387(VarCurr,12) ) ).

tff(addAssignment_30534,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,12)
    <=> v53217(VarCurr,68) ) ).

tff(addAssignment_30533,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,12)
    <=> v53383(VarCurr,12) ) ).

tff(addAssignment_30532,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,12)
    <=> v53217(VarCurr,68) ) ).

tff(addAssignment_30531,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,68)
    <=> v53218(VarCurr,68) ) ).

tff(addAssignment_30530,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,134)
    <=> v6238(VarCurr,134) ) ).

tff(addAssignment_30529,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,134)
    <=> v6240(VarCurr,134) ) ).

tff(addAssignment_30528,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,134)
    <=> v47849(VarCurr,2) ) ).

tff(addAssignment_30527,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,12)
    <=> v53379(VarCurr,12) ) ).

tff(addAssignment_30526,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_30525,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,12)
    <=> v53320(VarCurr,12) ) ).

tff(addAssignment_30524,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,12)
    <=> v53321(VarCurr,12) ) ).

tff(addAssignment_30523,axiom,
    ! [VarCurr: state_type] :
      ( v54621(VarCurr)
    <=> v54623(VarCurr) ) ).

tff(addAssignment_30522,axiom,
    ! [VarCurr: state_type] :
      ( v54623(VarCurr)
    <=> v6017(VarCurr,120) ) ).

tff(addAssignment_30521,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,120)
    <=> v53103(VarCurr,56) ) ).

tff(addAssignment_30520,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,56)
    <=> v53105(VarCurr,56) ) ).

tff(addAssignment_30519,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,56)
    <=> v53107(VarCurr,56) ) ).

tff(addAssignment_30518,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,56)
    <=> v53109(VarCurr,56) ) ).

tff(addAssignment_30517,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,56)
    <=> v6027(VarCurr,120) ) ).

tff(addAssignment_30516,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,120)
    <=> v52434(VarCurr,120) ) ).

tff(addAssignment_30515,axiom,
    ! [VarCurr: state_type] :
      ( v52436(VarCurr,0)
    <=> v53112(VarCurr,56) ) ).

tff(addAssignment_30514,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,56)
    <=> v53114(VarCurr,56) ) ).

tff(addAssignment_30513,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,56)
    <=> v54625(VarNext,56) ) ).

tff(addCaseBooleanConditionEqualRanges1_686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54626(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54625(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_686,axiom,
    ! [VarNext: state_type] :
      ( v54626(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54625(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54626(VarNext)
      <=> v54627(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54627(VarNext)
      <=> ( v54629(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54629(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_30512,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,56)
    <=> v53138(VarCurr,56) ) ).

tff(addAssignment_30511,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,56)
    <=> v6059(VarCurr,120) ) ).

tff(addAssignment_30510,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,120)
    <=> v53140(VarCurr,0) ) ).

tff(addAssignment_30509,axiom,
    ! [VarCurr: state_type] :
      ( v53140(VarCurr,0)
    <=> v53142(VarCurr,0) ) ).

tff(addAssignment_30508,axiom,
    ! [VarCurr: state_type] :
      ( v53142(VarCurr,0)
    <=> v53255(VarCurr,0) ) ).

tff(addAssignment_30507,axiom,
    ! [VarCurr: state_type] :
      ( v53248(VarCurr,0)
    <=> v53250(VarCurr,0) ) ).

tff(addAssignment_30506,axiom,
    ! [VarCurr: state_type] :
      ( v53250(VarCurr,0)
    <=> v6069(VarCurr,120) ) ).

tff(addAssignment_30505,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,120)
    <=> v53148(VarCurr,56) ) ).

tff(addAssignment_30504,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,56)
    <=> v53150(VarCurr,56) ) ).

tff(addAssignment_30503,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,56)
    <=> v53242(VarCurr,56) ) ).

tff(addAssignment_30502,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,56)
    <=> v53160(VarCurr,56) ) ).

tff(addAssignment_30501,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,56)
    <=> v6098(VarCurr,120) ) ).

tff(addAssignment_30500,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,120)
    <=> v6100(VarCurr,120) ) ).

tff(addAssignment_30499,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,120)
    <=> v6102(VarCurr,120) ) ).

tff(addAssignment_30498,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,120)
    <=> v53162(VarCurr,56) ) ).

tff(addAssignment_30497,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,56)
    <=> v53164(VarCurr,56) ) ).

tff(addAssignment_30496,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,56)
    <=> v53225(VarCurr,56) ) ).

tff(addAssignment_30495,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,56)
    <=> v53223(VarCurr,56) ) ).

tff(addAssignment_30494,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,56)
    <=> v53224(VarCurr,56) ) ).

tff(addAssignment_30493,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,56)
    <=> v53215(VarCurr,56) ) ).

tff(addAssignment_30492,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,56)
    <=> v53219(VarCurr,56) ) ).

tff(addAssignment_30491,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,48)
    <=> v53218(VarCurr,48) ) ).

tff(addAssignment_30490,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,96)
    <=> v6238(VarCurr,96) ) ).

tff(addAssignment_30489,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,96)
    <=> v6240(VarCurr,96) ) ).

tff(addAssignment_30488,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,96)
    <=> v43199(VarCurr,0) ) ).

tff(addAssignment_30487,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,56)
    <=> v53211(VarCurr,56) ) ).

tff(addAssignment_30486,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,56)
    <=> $false ) ).

tff(addAssignment_30485,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,56)
    <=> v53154(VarCurr,56) ) ).

tff(addAssignment_30484,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,56)
    <=> v53155(VarCurr,56) ) ).

tff(addAssignment_30483,axiom,
    ! [VarCurr: state_type] :
      ( v53144(VarCurr,0)
    <=> v53146(VarCurr,0) ) ).

tff(addAssignment_30482,axiom,
    ! [VarCurr: state_type] :
      ( v53146(VarCurr,0)
    <=> v6069(VarCurr,124) ) ).

tff(addAssignment_30481,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,124)
    <=> v53148(VarCurr,60) ) ).

tff(addAssignment_30480,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,60)
    <=> v53150(VarCurr,60) ) ).

tff(addAssignment_30479,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,60)
    <=> v53242(VarCurr,60) ) ).

tff(addAssignment_30478,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,60)
    <=> v53160(VarCurr,60) ) ).

tff(addAssignment_30477,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,60)
    <=> v6098(VarCurr,124) ) ).

tff(addAssignment_30476,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,124)
    <=> v6100(VarCurr,124) ) ).

tff(addAssignment_30475,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,124)
    <=> v6102(VarCurr,124) ) ).

tff(addAssignment_30474,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,124)
    <=> v53162(VarCurr,60) ) ).

tff(addAssignment_30473,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,60)
    <=> v53164(VarCurr,60) ) ).

tff(addAssignment_30472,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,60)
    <=> v53225(VarCurr,60) ) ).

tff(addAssignment_30471,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,60)
    <=> v53223(VarCurr,60) ) ).

tff(addAssignment_30470,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,60)
    <=> v53224(VarCurr,60) ) ).

tff(addAssignment_30469,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,60)
    <=> v53215(VarCurr,60) ) ).

tff(addAssignment_30468,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,60)
    <=> v53219(VarCurr,60) ) ).

tff(addAssignment_30467,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,52)
    <=> v53218(VarCurr,52) ) ).

tff(addAssignment_30466,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,100)
    <=> v6238(VarCurr,100) ) ).

tff(addAssignment_30465,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,100)
    <=> v6240(VarCurr,100) ) ).

tff(addAssignment_30464,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,100)
    <=> v43199(VarCurr,4) ) ).

tff(addAssignment_30463,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,60)
    <=> v53211(VarCurr,60) ) ).

tff(addAssignment_30462,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,60)
    <=> $false ) ).

tff(addAssignment_30461,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,60)
    <=> v53154(VarCurr,60) ) ).

tff(addAssignment_30460,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,60)
    <=> v53155(VarCurr,60) ) ).

tff(addAssignment_30459,axiom,
    ! [VarCurr: state_type] :
      ( v54563(VarCurr)
    <=> v54565(VarCurr) ) ).

tff(addAssignment_30458,axiom,
    ! [VarCurr: state_type] :
      ( v54565(VarCurr)
    <=> v54567(VarCurr) ) ).

tff(addAssignment_30457,axiom,
    ! [VarCurr: state_type] :
      ( v54567(VarCurr)
    <=> v54569(VarCurr) ) ).

tff(addAssignment_30456,axiom,
    ! [VarCurr: state_type] :
      ( v54569(VarCurr)
    <=> v54571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5129,axiom,
    ! [VarCurr: state_type] :
      ( v54571(VarCurr)
    <=> ( v54609(VarCurr)
      <~> v54597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5128,axiom,
    ! [VarCurr: state_type] :
      ( v54609(VarCurr)
    <=> ( v54573(VarCurr)
      <~> v54585(VarCurr) ) ) ).

tff(addAssignment_30455,axiom,
    ! [VarCurr: state_type] :
      ( v54597(VarCurr)
    <=> v54599(VarCurr) ) ).

tff(addAssignment_30454,axiom,
    ! [VarCurr: state_type] :
      ( v54599(VarCurr)
    <=> v6017(VarCurr,56) ) ).

tff(addAssignment_30453,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,56)
    <=> v6019(VarCurr,56) ) ).

tff(addAssignment_30452,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,56)
    <=> v6021(VarCurr,56) ) ).

tff(addAssignment_30451,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,56)
    <=> v6023(VarCurr,56) ) ).

tff(addAssignment_30450,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,56)
    <=> v6025(VarCurr,56) ) ).

tff(addAssignment_30449,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,56)
    <=> v6027(VarCurr,56) ) ).

tff(addAssignment_30448,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,56)
    <=> v52434(VarCurr,56) ) ).

tff(addAssignment_30447,axiom,
    ! [VarCurr: state_type] :
      ( v52452(VarCurr,0)
    <=> v6031(VarCurr,56) ) ).

tff(addAssignment_30446,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,56)
    <=> v6033(VarCurr,56) ) ).

tff(addAssignment_30445,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,56)
    <=> v54601(VarNext,56) ) ).

tff(addCaseBooleanConditionEqualRanges1_685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54602(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54601(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_685,axiom,
    ! [VarNext: state_type] :
      ( v54602(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54601(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54602(VarNext)
      <=> v54603(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54603(VarNext)
      <=> ( v54605(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54605(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30444,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,56)
    <=> v6057(VarCurr,56) ) ).

tff(addAssignment_30443,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,56)
    <=> v6059(VarCurr,56) ) ).

tff(addAssignment_30442,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,56)
    <=> v53052(VarCurr,0) ) ).

tff(addAssignment_30441,axiom,
    ! [VarCurr: state_type] :
      ( v53052(VarCurr,0)
    <=> v53054(VarCurr,0) ) ).

tff(addAssignment_30440,axiom,
    ! [VarCurr: state_type] :
      ( v53054(VarCurr,0)
    <=> v53071(VarCurr,0) ) ).

tff(addAssignment_30439,axiom,
    ! [VarCurr: state_type] :
      ( v53064(VarCurr,0)
    <=> v53066(VarCurr,0) ) ).

tff(addAssignment_30438,axiom,
    ! [VarCurr: state_type] :
      ( v53066(VarCurr,0)
    <=> v6069(VarCurr,56) ) ).

tff(addAssignment_30437,axiom,
    ! [VarCurr: state_type] :
      ( v53056(VarCurr,0)
    <=> v53058(VarCurr,0) ) ).

tff(addAssignment_30436,axiom,
    ! [VarCurr: state_type] :
      ( v53058(VarCurr,0)
    <=> v6069(VarCurr,60) ) ).

tff(addAssignment_30435,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,60)
    <=> v6071(VarCurr,60) ) ).

tff(addAssignment_30434,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,60)
    <=> v6073(VarCurr,60) ) ).

tff(addAssignment_30433,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,60)
    <=> v52355(VarCurr,60) ) ).

tff(addAssignment_30432,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,60)
    <=> v6096(VarCurr,60) ) ).

tff(addAssignment_30431,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,60)
    <=> v6098(VarCurr,60) ) ).

tff(addAssignment_30430,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,60)
    <=> v6100(VarCurr,60) ) ).

tff(addAssignment_30429,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,60)
    <=> v6102(VarCurr,60) ) ).

tff(addAssignment_30428,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,60)
    <=> v6104(VarCurr,60) ) ).

tff(addAssignment_30427,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,60)
    <=> v6106(VarCurr,60) ) ).

tff(addAssignment_30426,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,60)
    <=> v52338(VarCurr,60) ) ).

tff(addAssignment_30425,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,60)
    <=> v52330(VarCurr,60) ) ).

tff(addAssignment_30424,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,60)
    <=> v52332(VarCurr,60) ) ).

tff(addAssignment_30423,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,60)
    <=> v52335(VarCurr,60) ) ).

tff(addAssignment_30422,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,120)
    <=> v33839(VarCurr,120) ) ).

tff(addAssignment_30421,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,120)
    <=> v33841(VarCurr,120) ) ).

tff(addAssignment_30420,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,120)
    <=> v25005(VarCurr,0) ) ).

tff(addAssignment_30419,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,60)
    <=> v6232(VarCurr,60) ) ).

tff(addAssignment_30418,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,60)
    <=> v6234(VarCurr,60) ) ).

tff(addAssignment_30417,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,60)
    <=> v52325(VarCurr,60) ) ).

tff(addAssignment_30416,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,126)
    <=> v6238(VarCurr,126) ) ).

tff(addAssignment_30415,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,126)
    <=> v6240(VarCurr,126) ) ).

tff(addAssignment_30414,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,126)
    <=> v46299(VarCurr,6) ) ).

tff(addAssignment_30413,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,60)
    <=> v6226(VarCurr,60) ) ).

tff(addAssignment_30412,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,60)
    <=> $false ) ).

tff(addAssignment_30411,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,60)
    <=> v6077(VarCurr,60) ) ).

tff(addAssignment_30410,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,60)
    <=> v6091(VarCurr,60) ) ).

tff(addAssignment_30409,axiom,
    ! [VarCurr: state_type] :
      ( v54585(VarCurr)
    <=> v54587(VarCurr) ) ).

tff(addAssignment_30408,axiom,
    ! [VarCurr: state_type] :
      ( v54587(VarCurr)
    <=> v6017(VarCurr,52) ) ).

tff(addAssignment_30407,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,52)
    <=> v6019(VarCurr,52) ) ).

tff(addAssignment_30406,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,52)
    <=> v6021(VarCurr,52) ) ).

tff(addAssignment_30405,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,52)
    <=> v6023(VarCurr,52) ) ).

tff(addAssignment_30404,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,52)
    <=> v6025(VarCurr,52) ) ).

tff(addAssignment_30403,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,52)
    <=> v6027(VarCurr,52) ) ).

tff(addAssignment_30402,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,52)
    <=> v52434(VarCurr,52) ) ).

tff(addAssignment_30401,axiom,
    ! [VarCurr: state_type] :
      ( v52453(VarCurr,0)
    <=> v6031(VarCurr,52) ) ).

tff(addAssignment_30400,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,52)
    <=> v6033(VarCurr,52) ) ).

tff(addAssignment_30399,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,52)
    <=> v54589(VarNext,52) ) ).

tff(addCaseBooleanConditionEqualRanges1_684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54590(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54589(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_684,axiom,
    ! [VarNext: state_type] :
      ( v54590(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54589(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54590(VarNext)
      <=> v54591(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54591(VarNext)
      <=> ( v54593(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54593(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30398,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,52)
    <=> v6057(VarCurr,52) ) ).

tff(addAssignment_30397,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,52)
    <=> v6059(VarCurr,52) ) ).

tff(addAssignment_30396,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,52)
    <=> v53012(VarCurr,0) ) ).

tff(addAssignment_30395,axiom,
    ! [VarCurr: state_type] :
      ( v53012(VarCurr,0)
    <=> v53014(VarCurr,0) ) ).

tff(addAssignment_30394,axiom,
    ! [VarCurr: state_type] :
      ( v53014(VarCurr,0)
    <=> v53031(VarCurr,0) ) ).

tff(addAssignment_30393,axiom,
    ! [VarCurr: state_type] :
      ( v53024(VarCurr,0)
    <=> v53026(VarCurr,0) ) ).

tff(addAssignment_30392,axiom,
    ! [VarCurr: state_type] :
      ( v53026(VarCurr,0)
    <=> v6069(VarCurr,52) ) ).

tff(addAssignment_30391,axiom,
    ! [VarCurr: state_type] :
      ( v53016(VarCurr,0)
    <=> v53018(VarCurr,0) ) ).

tff(addAssignment_30390,axiom,
    ! [VarCurr: state_type] :
      ( v53018(VarCurr,0)
    <=> v6069(VarCurr,56) ) ).

tff(addAssignment_30389,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,56)
    <=> v6071(VarCurr,56) ) ).

tff(addAssignment_30388,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,56)
    <=> v6073(VarCurr,56) ) ).

tff(addAssignment_30387,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,56)
    <=> v52355(VarCurr,56) ) ).

tff(addAssignment_30386,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,56)
    <=> v6096(VarCurr,56) ) ).

tff(addAssignment_30385,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,56)
    <=> v6098(VarCurr,56) ) ).

tff(addAssignment_30384,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,56)
    <=> v6100(VarCurr,56) ) ).

tff(addAssignment_30383,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,56)
    <=> v6102(VarCurr,56) ) ).

tff(addAssignment_30382,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,56)
    <=> v6104(VarCurr,56) ) ).

tff(addAssignment_30381,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,56)
    <=> v6106(VarCurr,56) ) ).

tff(addAssignment_30380,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,56)
    <=> v52338(VarCurr,56) ) ).

tff(addAssignment_30379,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,56)
    <=> v52330(VarCurr,56) ) ).

tff(addAssignment_30378,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,56)
    <=> v52332(VarCurr,56) ) ).

tff(addAssignment_30377,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,56)
    <=> v52335(VarCurr,56) ) ).

tff(addAssignment_30376,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,110)
    <=> v33839(VarCurr,110) ) ).

tff(addAssignment_30375,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,110)
    <=> v33841(VarCurr,110) ) ).

tff(addAssignment_30374,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,110)
    <=> v23455(VarCurr,2) ) ).

tff(addAssignment_30373,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,56)
    <=> v6232(VarCurr,56) ) ).

tff(addAssignment_30372,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,56)
    <=> v6234(VarCurr,56) ) ).

tff(addAssignment_30371,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,56)
    <=> v52325(VarCurr,56) ) ).

tff(addAssignment_30370,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,116)
    <=> v6238(VarCurr,116) ) ).

tff(addAssignment_30369,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,116)
    <=> v6240(VarCurr,116) ) ).

tff(addAssignment_30368,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,116)
    <=> v44749(VarCurr,8) ) ).

tff(addAssignment_30367,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,56)
    <=> v6226(VarCurr,56) ) ).

tff(addAssignment_30366,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,56)
    <=> $false ) ).

tff(addAssignment_30365,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,56)
    <=> v6077(VarCurr,56) ) ).

tff(addAssignment_30364,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,56)
    <=> v6091(VarCurr,56) ) ).

tff(addAssignment_30363,axiom,
    ! [VarCurr: state_type] :
      ( v54573(VarCurr)
    <=> v54575(VarCurr) ) ).

tff(addAssignment_30362,axiom,
    ! [VarCurr: state_type] :
      ( v54575(VarCurr)
    <=> v6017(VarCurr,48) ) ).

tff(addAssignment_30361,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,48)
    <=> v6019(VarCurr,48) ) ).

tff(addAssignment_30360,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,48)
    <=> v6021(VarCurr,48) ) ).

tff(addAssignment_30359,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,48)
    <=> v6023(VarCurr,48) ) ).

tff(addAssignment_30358,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,48)
    <=> v6025(VarCurr,48) ) ).

tff(addAssignment_30357,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,48)
    <=> v6027(VarCurr,48) ) ).

tff(addAssignment_30356,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,48)
    <=> v52434(VarCurr,48) ) ).

tff(addAssignment_30355,axiom,
    ! [VarCurr: state_type] :
      ( v52454(VarCurr,0)
    <=> v6031(VarCurr,48) ) ).

tff(addAssignment_30354,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,48)
    <=> v6033(VarCurr,48) ) ).

tff(addAssignment_30353,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,48)
    <=> v54577(VarNext,48) ) ).

tff(addCaseBooleanConditionEqualRanges1_683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54578(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54577(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_683,axiom,
    ! [VarNext: state_type] :
      ( v54578(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54577(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54578(VarNext)
      <=> v54579(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54579(VarNext)
      <=> ( v54581(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54581(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30352,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,48)
    <=> v6057(VarCurr,48) ) ).

tff(addAssignment_30351,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,48)
    <=> v6059(VarCurr,48) ) ).

tff(addAssignment_30350,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,48)
    <=> v52972(VarCurr,0) ) ).

tff(addAssignment_30349,axiom,
    ! [VarCurr: state_type] :
      ( v52972(VarCurr,0)
    <=> v52974(VarCurr,0) ) ).

tff(addAssignment_30348,axiom,
    ! [VarCurr: state_type] :
      ( v52974(VarCurr,0)
    <=> v52991(VarCurr,0) ) ).

tff(addAssignment_30347,axiom,
    ! [VarCurr: state_type] :
      ( v52984(VarCurr,0)
    <=> v52986(VarCurr,0) ) ).

tff(addAssignment_30346,axiom,
    ! [VarCurr: state_type] :
      ( v52986(VarCurr,0)
    <=> v6069(VarCurr,48) ) ).

tff(addAssignment_30345,axiom,
    ! [VarCurr: state_type] :
      ( v52976(VarCurr,0)
    <=> v52978(VarCurr,0) ) ).

tff(addAssignment_30344,axiom,
    ! [VarCurr: state_type] :
      ( v52978(VarCurr,0)
    <=> v6069(VarCurr,52) ) ).

tff(addAssignment_30343,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,52)
    <=> v6071(VarCurr,52) ) ).

tff(addAssignment_30342,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,52)
    <=> v6073(VarCurr,52) ) ).

tff(addAssignment_30341,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,52)
    <=> v52355(VarCurr,52) ) ).

tff(addAssignment_30340,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,52)
    <=> v6096(VarCurr,52) ) ).

tff(addAssignment_30339,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,52)
    <=> v6098(VarCurr,52) ) ).

tff(addAssignment_30338,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,52)
    <=> v6100(VarCurr,52) ) ).

tff(addAssignment_30337,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,52)
    <=> v6102(VarCurr,52) ) ).

tff(addAssignment_30336,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,52)
    <=> v6104(VarCurr,52) ) ).

tff(addAssignment_30335,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,52)
    <=> v6106(VarCurr,52) ) ).

tff(addAssignment_30334,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,52)
    <=> v52338(VarCurr,52) ) ).

tff(addAssignment_30333,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,52)
    <=> v52330(VarCurr,52) ) ).

tff(addAssignment_30332,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,52)
    <=> v52332(VarCurr,52) ) ).

tff(addAssignment_30331,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,52)
    <=> v52335(VarCurr,52) ) ).

tff(addAssignment_30330,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,100)
    <=> v33839(VarCurr,100) ) ).

tff(addAssignment_30329,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,100)
    <=> v33841(VarCurr,100) ) ).

tff(addAssignment_30328,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,100)
    <=> v21905(VarCurr,4) ) ).

tff(addAssignment_30327,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,52)
    <=> v6232(VarCurr,52) ) ).

tff(addAssignment_30326,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,52)
    <=> v6234(VarCurr,52) ) ).

tff(addAssignment_30325,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,52)
    <=> v52325(VarCurr,52) ) ).

tff(addAssignment_30324,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,106)
    <=> v6238(VarCurr,106) ) ).

tff(addAssignment_30323,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,106)
    <=> v6240(VarCurr,106) ) ).

tff(addAssignment_30322,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,106)
    <=> v43199(VarCurr,10) ) ).

tff(addAssignment_30321,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,52)
    <=> v6226(VarCurr,52) ) ).

tff(addAssignment_30320,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,52)
    <=> $false ) ).

tff(addAssignment_30319,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,52)
    <=> v6077(VarCurr,52) ) ).

tff(addAssignment_30318,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,52)
    <=> v6091(VarCurr,52) ) ).

tff(addAssignment_30317,axiom,
    ! [VarCurr: state_type] :
      ( v54515(VarCurr)
    <=> v54517(VarCurr) ) ).

tff(addAssignment_30316,axiom,
    ! [VarCurr: state_type] :
      ( v54517(VarCurr)
    <=> v54519(VarCurr) ) ).

tff(addAssignment_30315,axiom,
    ! [VarCurr: state_type] :
      ( v54519(VarCurr)
    <=> v54521(VarCurr) ) ).

tff(addAssignment_30314,axiom,
    ! [VarCurr: state_type] :
      ( v54521(VarCurr)
    <=> v54523(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5121,axiom,
    ! [VarCurr: state_type] :
      ( v54523(VarCurr)
    <=> ( v54561(VarCurr)
      <~> v54549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5120,axiom,
    ! [VarCurr: state_type] :
      ( v54561(VarCurr)
    <=> ( v54525(VarCurr)
      <~> v54537(VarCurr) ) ) ).

tff(addAssignment_30313,axiom,
    ! [VarCurr: state_type] :
      ( v54549(VarCurr)
    <=> v54551(VarCurr) ) ).

tff(addAssignment_30312,axiom,
    ! [VarCurr: state_type] :
      ( v54551(VarCurr)
    <=> v6017(VarCurr,44) ) ).

tff(addAssignment_30311,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,44)
    <=> v6019(VarCurr,44) ) ).

tff(addAssignment_30310,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,44)
    <=> v6021(VarCurr,44) ) ).

tff(addAssignment_30309,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,44)
    <=> v6023(VarCurr,44) ) ).

tff(addAssignment_30308,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,44)
    <=> v6025(VarCurr,44) ) ).

tff(addAssignment_30307,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,44)
    <=> v6027(VarCurr,44) ) ).

tff(addAssignment_30306,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,44)
    <=> v52434(VarCurr,44) ) ).

tff(addAssignment_30305,axiom,
    ! [VarCurr: state_type] :
      ( v52455(VarCurr,0)
    <=> v6031(VarCurr,44) ) ).

tff(addAssignment_30304,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,44)
    <=> v6033(VarCurr,44) ) ).

tff(addAssignment_30303,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,44)
    <=> v54553(VarNext,44) ) ).

tff(addCaseBooleanConditionEqualRanges1_682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54554(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54553(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_682,axiom,
    ! [VarNext: state_type] :
      ( v54554(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54553(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54554(VarNext)
      <=> v54555(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54555(VarNext)
      <=> ( v54557(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54557(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30302,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,44)
    <=> v6057(VarCurr,44) ) ).

tff(addAssignment_30301,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,44)
    <=> v6059(VarCurr,44) ) ).

tff(addAssignment_30300,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,44)
    <=> v52920(VarCurr,0) ) ).

tff(addAssignment_30299,axiom,
    ! [VarCurr: state_type] :
      ( v52920(VarCurr,0)
    <=> v52922(VarCurr,0) ) ).

tff(addAssignment_30298,axiom,
    ! [VarCurr: state_type] :
      ( v52922(VarCurr,0)
    <=> v52939(VarCurr,0) ) ).

tff(addAssignment_30297,axiom,
    ! [VarCurr: state_type] :
      ( v52932(VarCurr,0)
    <=> v52934(VarCurr,0) ) ).

tff(addAssignment_30296,axiom,
    ! [VarCurr: state_type] :
      ( v52934(VarCurr,0)
    <=> v6069(VarCurr,44) ) ).

tff(addAssignment_30295,axiom,
    ! [VarCurr: state_type] :
      ( v52924(VarCurr,0)
    <=> v52926(VarCurr,0) ) ).

tff(addAssignment_30294,axiom,
    ! [VarCurr: state_type] :
      ( v52926(VarCurr,0)
    <=> v6069(VarCurr,48) ) ).

tff(addAssignment_30293,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,48)
    <=> v6071(VarCurr,48) ) ).

tff(addAssignment_30292,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,48)
    <=> v6073(VarCurr,48) ) ).

tff(addAssignment_30291,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,48)
    <=> v52355(VarCurr,48) ) ).

tff(addAssignment_30290,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,48)
    <=> v6096(VarCurr,48) ) ).

tff(addAssignment_30289,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,48)
    <=> v6098(VarCurr,48) ) ).

tff(addAssignment_30288,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,48)
    <=> v6100(VarCurr,48) ) ).

tff(addAssignment_30287,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,48)
    <=> v6102(VarCurr,48) ) ).

tff(addAssignment_30286,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,48)
    <=> v6104(VarCurr,48) ) ).

tff(addAssignment_30285,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,48)
    <=> v6106(VarCurr,48) ) ).

tff(addAssignment_30284,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,48)
    <=> v52338(VarCurr,48) ) ).

tff(addAssignment_30283,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,48)
    <=> v52330(VarCurr,48) ) ).

tff(addAssignment_30282,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,48)
    <=> v52332(VarCurr,48) ) ).

tff(addAssignment_30281,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,48)
    <=> v52335(VarCurr,48) ) ).

tff(addAssignment_30280,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,96)
    <=> v33839(VarCurr,96) ) ).

tff(addAssignment_30279,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,96)
    <=> v33841(VarCurr,96) ) ).

tff(addAssignment_30278,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,96)
    <=> v21905(VarCurr,0) ) ).

tff(addAssignment_30277,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,48)
    <=> v6232(VarCurr,48) ) ).

tff(addAssignment_30276,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,48)
    <=> v6234(VarCurr,48) ) ).

tff(addAssignment_30275,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,48)
    <=> v52325(VarCurr,48) ) ).

tff(addAssignment_30274,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,102)
    <=> v6238(VarCurr,102) ) ).

tff(addAssignment_30273,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,102)
    <=> v6240(VarCurr,102) ) ).

tff(addAssignment_30272,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,102)
    <=> v43199(VarCurr,6) ) ).

tff(addAssignment_30271,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,48)
    <=> v6226(VarCurr,48) ) ).

tff(addAssignment_30270,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,48)
    <=> $false ) ).

tff(addAssignment_30269,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,48)
    <=> v6077(VarCurr,48) ) ).

tff(addAssignment_30268,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,48)
    <=> v6091(VarCurr,48) ) ).

tff(addAssignment_30267,axiom,
    ! [VarCurr: state_type] :
      ( v54537(VarCurr)
    <=> v54539(VarCurr) ) ).

tff(addAssignment_30266,axiom,
    ! [VarCurr: state_type] :
      ( v54539(VarCurr)
    <=> v6017(VarCurr,40) ) ).

tff(addAssignment_30265,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,40)
    <=> v6019(VarCurr,40) ) ).

tff(addAssignment_30264,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,40)
    <=> v6021(VarCurr,40) ) ).

tff(addAssignment_30263,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,40)
    <=> v6023(VarCurr,40) ) ).

tff(addAssignment_30262,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,40)
    <=> v6025(VarCurr,40) ) ).

tff(addAssignment_30261,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,40)
    <=> v6027(VarCurr,40) ) ).

tff(addAssignment_30260,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,40)
    <=> v52434(VarCurr,40) ) ).

tff(addAssignment_30259,axiom,
    ! [VarCurr: state_type] :
      ( v52456(VarCurr,0)
    <=> v6031(VarCurr,40) ) ).

tff(addAssignment_30258,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,40)
    <=> v6033(VarCurr,40) ) ).

tff(addAssignment_30257,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,40)
    <=> v54541(VarNext,40) ) ).

tff(addCaseBooleanConditionEqualRanges1_681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54542(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54541(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_681,axiom,
    ! [VarNext: state_type] :
      ( v54542(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54541(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54542(VarNext)
      <=> v54543(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54543(VarNext)
      <=> ( v54545(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54545(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30256,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,40)
    <=> v6057(VarCurr,40) ) ).

tff(addAssignment_30255,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,40)
    <=> v6059(VarCurr,40) ) ).

tff(addAssignment_30254,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,40)
    <=> v52880(VarCurr,0) ) ).

tff(addAssignment_30253,axiom,
    ! [VarCurr: state_type] :
      ( v52880(VarCurr,0)
    <=> v52882(VarCurr,0) ) ).

tff(addAssignment_30252,axiom,
    ! [VarCurr: state_type] :
      ( v52882(VarCurr,0)
    <=> v52899(VarCurr,0) ) ).

tff(addAssignment_30251,axiom,
    ! [VarCurr: state_type] :
      ( v52892(VarCurr,0)
    <=> v52894(VarCurr,0) ) ).

tff(addAssignment_30250,axiom,
    ! [VarCurr: state_type] :
      ( v52894(VarCurr,0)
    <=> v6069(VarCurr,40) ) ).

tff(addAssignment_30249,axiom,
    ! [VarCurr: state_type] :
      ( v52884(VarCurr,0)
    <=> v52886(VarCurr,0) ) ).

tff(addAssignment_30248,axiom,
    ! [VarCurr: state_type] :
      ( v52886(VarCurr,0)
    <=> v6069(VarCurr,44) ) ).

tff(addAssignment_30247,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,44)
    <=> v6071(VarCurr,44) ) ).

tff(addAssignment_30246,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,44)
    <=> v6073(VarCurr,44) ) ).

tff(addAssignment_30245,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,44)
    <=> v52355(VarCurr,44) ) ).

tff(addAssignment_30244,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,44)
    <=> v6096(VarCurr,44) ) ).

tff(addAssignment_30243,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,44)
    <=> v6098(VarCurr,44) ) ).

tff(addAssignment_30242,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,44)
    <=> v6100(VarCurr,44) ) ).

tff(addAssignment_30241,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,44)
    <=> v6102(VarCurr,44) ) ).

tff(addAssignment_30240,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,44)
    <=> v6104(VarCurr,44) ) ).

tff(addAssignment_30239,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,44)
    <=> v6106(VarCurr,44) ) ).

tff(addAssignment_30238,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,44)
    <=> v52338(VarCurr,44) ) ).

tff(addAssignment_30237,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,44)
    <=> v52330(VarCurr,44) ) ).

tff(addAssignment_30236,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,44)
    <=> v52332(VarCurr,44) ) ).

tff(addAssignment_30235,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,44)
    <=> v52335(VarCurr,44) ) ).

tff(addAssignment_30234,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,86)
    <=> v33839(VarCurr,86) ) ).

tff(addAssignment_30233,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,86)
    <=> v33841(VarCurr,86) ) ).

tff(addAssignment_30232,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,86)
    <=> v20355(VarCurr,2) ) ).

tff(addAssignment_30231,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,44)
    <=> v6232(VarCurr,44) ) ).

tff(addAssignment_30230,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,44)
    <=> v6234(VarCurr,44) ) ).

tff(addAssignment_30229,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,44)
    <=> v52325(VarCurr,44) ) ).

tff(addAssignment_30228,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,92)
    <=> v6238(VarCurr,92) ) ).

tff(addAssignment_30227,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,92)
    <=> v6240(VarCurr,92) ) ).

tff(addAssignment_30226,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,92)
    <=> v41649(VarCurr,8) ) ).

tff(addAssignment_30225,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,44)
    <=> v6226(VarCurr,44) ) ).

tff(addAssignment_30224,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,44)
    <=> $false ) ).

tff(addAssignment_30223,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,44)
    <=> v6077(VarCurr,44) ) ).

tff(addAssignment_30222,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,44)
    <=> v6091(VarCurr,44) ) ).

tff(addAssignment_30221,axiom,
    ! [VarCurr: state_type] :
      ( v54525(VarCurr)
    <=> v54527(VarCurr) ) ).

tff(addAssignment_30220,axiom,
    ! [VarCurr: state_type] :
      ( v54527(VarCurr)
    <=> v6017(VarCurr,36) ) ).

tff(addAssignment_30219,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,36)
    <=> v6019(VarCurr,36) ) ).

tff(addAssignment_30218,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,36)
    <=> v6021(VarCurr,36) ) ).

tff(addAssignment_30217,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,36)
    <=> v6023(VarCurr,36) ) ).

tff(addAssignment_30216,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,36)
    <=> v6025(VarCurr,36) ) ).

tff(addAssignment_30215,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,36)
    <=> v6027(VarCurr,36) ) ).

tff(addAssignment_30214,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,36)
    <=> v52434(VarCurr,36) ) ).

tff(addAssignment_30213,axiom,
    ! [VarCurr: state_type] :
      ( v52457(VarCurr,0)
    <=> v6031(VarCurr,36) ) ).

tff(addAssignment_30212,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,36)
    <=> v6033(VarCurr,36) ) ).

tff(addAssignment_30211,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,36)
    <=> v54529(VarNext,36) ) ).

tff(addCaseBooleanConditionEqualRanges1_680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54530(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54529(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_680,axiom,
    ! [VarNext: state_type] :
      ( v54530(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54529(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54530(VarNext)
      <=> v54531(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54531(VarNext)
      <=> ( v54533(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54533(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30210,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,36)
    <=> v6057(VarCurr,36) ) ).

tff(addAssignment_30209,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,36)
    <=> v6059(VarCurr,36) ) ).

tff(addAssignment_30208,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,36)
    <=> v52840(VarCurr,0) ) ).

tff(addAssignment_30207,axiom,
    ! [VarCurr: state_type] :
      ( v52840(VarCurr,0)
    <=> v52842(VarCurr,0) ) ).

tff(addAssignment_30206,axiom,
    ! [VarCurr: state_type] :
      ( v52842(VarCurr,0)
    <=> v52859(VarCurr,0) ) ).

tff(addAssignment_30205,axiom,
    ! [VarCurr: state_type] :
      ( v52852(VarCurr,0)
    <=> v52854(VarCurr,0) ) ).

tff(addAssignment_30204,axiom,
    ! [VarCurr: state_type] :
      ( v52854(VarCurr,0)
    <=> v6069(VarCurr,36) ) ).

tff(addAssignment_30203,axiom,
    ! [VarCurr: state_type] :
      ( v52844(VarCurr,0)
    <=> v52846(VarCurr,0) ) ).

tff(addAssignment_30202,axiom,
    ! [VarCurr: state_type] :
      ( v52846(VarCurr,0)
    <=> v6069(VarCurr,40) ) ).

tff(addAssignment_30201,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,40)
    <=> v6071(VarCurr,40) ) ).

tff(addAssignment_30200,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,40)
    <=> v6073(VarCurr,40) ) ).

tff(addAssignment_30199,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,40)
    <=> v52355(VarCurr,40) ) ).

tff(addAssignment_30198,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,40)
    <=> v6096(VarCurr,40) ) ).

tff(addAssignment_30197,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,40)
    <=> v6098(VarCurr,40) ) ).

tff(addAssignment_30196,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,40)
    <=> v6100(VarCurr,40) ) ).

tff(addAssignment_30195,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,40)
    <=> v6102(VarCurr,40) ) ).

tff(addAssignment_30194,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,40)
    <=> v6104(VarCurr,40) ) ).

tff(addAssignment_30193,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,40)
    <=> v6106(VarCurr,40) ) ).

tff(addAssignment_30192,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,40)
    <=> v52338(VarCurr,40) ) ).

tff(addAssignment_30191,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,40)
    <=> v52330(VarCurr,40) ) ).

tff(addAssignment_30190,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,40)
    <=> v52332(VarCurr,40) ) ).

tff(addAssignment_30189,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,40)
    <=> v52335(VarCurr,40) ) ).

tff(addAssignment_30188,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,76)
    <=> v33839(VarCurr,76) ) ).

tff(addAssignment_30187,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,76)
    <=> v33841(VarCurr,76) ) ).

tff(addAssignment_30186,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,76)
    <=> v18805(VarCurr,4) ) ).

tff(addAssignment_30185,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,40)
    <=> v6232(VarCurr,40) ) ).

tff(addAssignment_30184,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,40)
    <=> v6234(VarCurr,40) ) ).

tff(addAssignment_30183,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,40)
    <=> v52325(VarCurr,40) ) ).

tff(addAssignment_30182,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,82)
    <=> v6238(VarCurr,82) ) ).

tff(addAssignment_30181,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,82)
    <=> v6240(VarCurr,82) ) ).

tff(addAssignment_30180,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,82)
    <=> v40099(VarCurr,10) ) ).

tff(addAssignment_30179,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,40)
    <=> v6226(VarCurr,40) ) ).

tff(addAssignment_30178,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,40)
    <=> $false ) ).

tff(addAssignment_30177,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,40)
    <=> v6077(VarCurr,40) ) ).

tff(addAssignment_30176,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,40)
    <=> v6091(VarCurr,40) ) ).

tff(addAssignment_30175,axiom,
    ! [VarCurr: state_type] :
      ( v54349(VarCurr)
    <=> v54351(VarCurr) ) ).

tff(addAssignment_30174,axiom,
    ! [VarCurr: state_type] :
      ( v54351(VarCurr)
    <=> v54353(VarCurr) ) ).

tff(addAssignment_30173,axiom,
    ! [VarCurr: state_type] :
      ( v54353(VarCurr)
    <=> v54355(VarCurr) ) ).

tff(addAssignment_30172,axiom,
    ! [VarCurr: state_type] :
      ( v54355(VarCurr)
    <=> v54357(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5113,axiom,
    ! [VarCurr: state_type] :
      ( v54357(VarCurr)
    <=> ( v54503(VarCurr)
      <~> v54455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5112,axiom,
    ! [VarCurr: state_type] :
      ( v54503(VarCurr)
    <=> ( v54359(VarCurr)
      <~> v54407(VarCurr) ) ) ).

tff(addAssignment_30171,axiom,
    ! [VarCurr: state_type] :
      ( v54455(VarCurr)
    <=> v54457(VarCurr) ) ).

tff(addAssignment_30170,axiom,
    ! [VarCurr: state_type] :
      ( v54457(VarCurr)
    <=> v54459(VarCurr) ) ).

tff(addAssignment_30169,axiom,
    ! [VarCurr: state_type] :
      ( v54459(VarCurr)
    <=> v54461(VarCurr) ) ).

tff(addAssignment_30168,axiom,
    ! [VarCurr: state_type] :
      ( v54461(VarCurr)
    <=> v54463(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5111,axiom,
    ! [VarCurr: state_type] :
      ( v54463(VarCurr)
    <=> ( v54501(VarCurr)
      <~> v54489(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5110,axiom,
    ! [VarCurr: state_type] :
      ( v54501(VarCurr)
    <=> ( v54465(VarCurr)
      <~> v54477(VarCurr) ) ) ).

tff(addAssignment_30167,axiom,
    ! [VarCurr: state_type] :
      ( v54489(VarCurr)
    <=> v54491(VarCurr) ) ).

tff(addAssignment_30166,axiom,
    ! [VarCurr: state_type] :
      ( v54491(VarCurr)
    <=> v6017(VarCurr,32) ) ).

tff(addAssignment_30165,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,32)
    <=> v6019(VarCurr,32) ) ).

tff(addAssignment_30164,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,32)
    <=> v6021(VarCurr,32) ) ).

tff(addAssignment_30163,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,32)
    <=> v6023(VarCurr,32) ) ).

tff(addAssignment_30162,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,32)
    <=> v6025(VarCurr,32) ) ).

tff(addAssignment_30161,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,32)
    <=> v6027(VarCurr,32) ) ).

tff(addAssignment_30160,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,32)
    <=> v52434(VarCurr,32) ) ).

tff(addAssignment_30159,axiom,
    ! [VarCurr: state_type] :
      ( v52458(VarCurr,0)
    <=> v6031(VarCurr,32) ) ).

tff(addAssignment_30158,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,32)
    <=> v6033(VarCurr,32) ) ).

tff(addAssignment_30157,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,32)
    <=> v54493(VarNext,32) ) ).

tff(addCaseBooleanConditionEqualRanges1_679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54494(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54493(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_679,axiom,
    ! [VarNext: state_type] :
      ( v54494(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54493(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54494(VarNext)
      <=> v54495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54495(VarNext)
      <=> ( v54497(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54497(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30156,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,32)
    <=> v6057(VarCurr,32) ) ).

tff(addAssignment_30155,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,32)
    <=> v6059(VarCurr,32) ) ).

tff(addAssignment_30154,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,32)
    <=> v52776(VarCurr,0) ) ).

tff(addAssignment_30153,axiom,
    ! [VarCurr: state_type] :
      ( v52776(VarCurr,0)
    <=> v52778(VarCurr,0) ) ).

tff(addAssignment_30152,axiom,
    ! [VarCurr: state_type] :
      ( v52778(VarCurr,0)
    <=> v52795(VarCurr,0) ) ).

tff(addAssignment_30151,axiom,
    ! [VarCurr: state_type] :
      ( v52788(VarCurr,0)
    <=> v52790(VarCurr,0) ) ).

tff(addAssignment_30150,axiom,
    ! [VarCurr: state_type] :
      ( v52790(VarCurr,0)
    <=> v6069(VarCurr,32) ) ).

tff(addAssignment_30149,axiom,
    ! [VarCurr: state_type] :
      ( v52780(VarCurr,0)
    <=> v52782(VarCurr,0) ) ).

tff(addAssignment_30148,axiom,
    ! [VarCurr: state_type] :
      ( v52782(VarCurr,0)
    <=> v6069(VarCurr,36) ) ).

tff(addAssignment_30147,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,36)
    <=> v6071(VarCurr,36) ) ).

tff(addAssignment_30146,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,36)
    <=> v6073(VarCurr,36) ) ).

tff(addAssignment_30145,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,36)
    <=> v52355(VarCurr,36) ) ).

tff(addAssignment_30144,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,36)
    <=> v6096(VarCurr,36) ) ).

tff(addAssignment_30143,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,36)
    <=> v6098(VarCurr,36) ) ).

tff(addAssignment_30142,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,36)
    <=> v6100(VarCurr,36) ) ).

tff(addAssignment_30141,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,36)
    <=> v6102(VarCurr,36) ) ).

tff(addAssignment_30140,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,36)
    <=> v6104(VarCurr,36) ) ).

tff(addAssignment_30139,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,36)
    <=> v6106(VarCurr,36) ) ).

tff(addAssignment_30138,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,36)
    <=> v52338(VarCurr,36) ) ).

tff(addAssignment_30137,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,36)
    <=> v52330(VarCurr,36) ) ).

tff(addAssignment_30136,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,36)
    <=> v52332(VarCurr,36) ) ).

tff(addAssignment_30135,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,36)
    <=> v52335(VarCurr,36) ) ).

tff(addAssignment_30134,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,72)
    <=> v33839(VarCurr,72) ) ).

tff(addAssignment_30133,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,72)
    <=> v33841(VarCurr,72) ) ).

tff(addAssignment_30132,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,72)
    <=> v18805(VarCurr,0) ) ).

tff(addAssignment_30131,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,36)
    <=> v6232(VarCurr,36) ) ).

tff(addAssignment_30130,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,36)
    <=> v6234(VarCurr,36) ) ).

tff(addAssignment_30129,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,36)
    <=> v52325(VarCurr,36) ) ).

tff(addAssignment_30128,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,78)
    <=> v6238(VarCurr,78) ) ).

tff(addAssignment_30127,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,78)
    <=> v6240(VarCurr,78) ) ).

tff(addAssignment_30126,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,78)
    <=> v40099(VarCurr,6) ) ).

tff(addAssignment_30125,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,36)
    <=> v6226(VarCurr,36) ) ).

tff(addAssignment_30124,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,36)
    <=> $false ) ).

tff(addAssignment_30123,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,36)
    <=> v6077(VarCurr,36) ) ).

tff(addAssignment_30122,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,36)
    <=> v6091(VarCurr,36) ) ).

tff(addAssignment_30121,axiom,
    ! [VarCurr: state_type] :
      ( v54477(VarCurr)
    <=> v54479(VarCurr) ) ).

tff(addAssignment_30120,axiom,
    ! [VarCurr: state_type] :
      ( v54479(VarCurr)
    <=> v6017(VarCurr,28) ) ).

tff(addAssignment_30119,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,28)
    <=> v6019(VarCurr,28) ) ).

tff(addAssignment_30118,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,28)
    <=> v6021(VarCurr,28) ) ).

tff(addAssignment_30117,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,28)
    <=> v6023(VarCurr,28) ) ).

tff(addAssignment_30116,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,28)
    <=> v6025(VarCurr,28) ) ).

tff(addAssignment_30115,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,28)
    <=> v6027(VarCurr,28) ) ).

tff(addAssignment_30114,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,28)
    <=> v52434(VarCurr,28) ) ).

tff(addAssignment_30113,axiom,
    ! [VarCurr: state_type] :
      ( v52459(VarCurr,0)
    <=> v6031(VarCurr,28) ) ).

tff(addAssignment_30112,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,28)
    <=> v6033(VarCurr,28) ) ).

tff(addAssignment_30111,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,28)
    <=> v54481(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54482(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54481(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_678,axiom,
    ! [VarNext: state_type] :
      ( v54482(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54481(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54482(VarNext)
      <=> v54483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54483(VarNext)
      <=> ( v54485(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54485(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30110,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,28)
    <=> v6057(VarCurr,28) ) ).

tff(addAssignment_30109,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,28)
    <=> v6059(VarCurr,28) ) ).

tff(addAssignment_30108,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,28)
    <=> v52736(VarCurr,0) ) ).

tff(addAssignment_30107,axiom,
    ! [VarCurr: state_type] :
      ( v52736(VarCurr,0)
    <=> v52738(VarCurr,0) ) ).

tff(addAssignment_30106,axiom,
    ! [VarCurr: state_type] :
      ( v52738(VarCurr,0)
    <=> v52755(VarCurr,0) ) ).

tff(addAssignment_30105,axiom,
    ! [VarCurr: state_type] :
      ( v52748(VarCurr,0)
    <=> v52750(VarCurr,0) ) ).

tff(addAssignment_30104,axiom,
    ! [VarCurr: state_type] :
      ( v52750(VarCurr,0)
    <=> v6069(VarCurr,28) ) ).

tff(addAssignment_30103,axiom,
    ! [VarCurr: state_type] :
      ( v52740(VarCurr,0)
    <=> v52742(VarCurr,0) ) ).

tff(addAssignment_30102,axiom,
    ! [VarCurr: state_type] :
      ( v52742(VarCurr,0)
    <=> v6069(VarCurr,32) ) ).

tff(addAssignment_30101,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,32)
    <=> v6071(VarCurr,32) ) ).

tff(addAssignment_30100,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,32)
    <=> v6073(VarCurr,32) ) ).

tff(addAssignment_30099,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,32)
    <=> v52355(VarCurr,32) ) ).

tff(addAssignment_30098,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,32)
    <=> v6096(VarCurr,32) ) ).

tff(addAssignment_30097,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,32)
    <=> v6098(VarCurr,32) ) ).

tff(addAssignment_30096,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,32)
    <=> v6100(VarCurr,32) ) ).

tff(addAssignment_30095,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,32)
    <=> v6102(VarCurr,32) ) ).

tff(addAssignment_30094,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,32)
    <=> v6104(VarCurr,32) ) ).

tff(addAssignment_30093,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,32)
    <=> v6106(VarCurr,32) ) ).

tff(addAssignment_30092,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,32)
    <=> v52338(VarCurr,32) ) ).

tff(addAssignment_30091,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,32)
    <=> v52330(VarCurr,32) ) ).

tff(addAssignment_30090,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,32)
    <=> v52332(VarCurr,32) ) ).

tff(addAssignment_30089,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,32)
    <=> v52335(VarCurr,32) ) ).

tff(addAssignment_30088,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,62)
    <=> v33839(VarCurr,62) ) ).

tff(addAssignment_30087,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,62)
    <=> v33841(VarCurr,62) ) ).

tff(addAssignment_30086,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,62)
    <=> v17255(VarCurr,2) ) ).

tff(addAssignment_30085,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,32)
    <=> v6232(VarCurr,32) ) ).

tff(addAssignment_30084,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,32)
    <=> v6234(VarCurr,32) ) ).

tff(addAssignment_30083,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,32)
    <=> v52325(VarCurr,32) ) ).

tff(addAssignment_30082,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,68)
    <=> v6238(VarCurr,68) ) ).

tff(addAssignment_30081,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,68)
    <=> v6240(VarCurr,68) ) ).

tff(addAssignment_30080,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,68)
    <=> v38549(VarCurr,8) ) ).

tff(addAssignment_30079,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,32)
    <=> v6226(VarCurr,32) ) ).

tff(addAssignment_30078,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,32)
    <=> $false ) ).

tff(addAssignment_30077,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,32)
    <=> v6077(VarCurr,32) ) ).

tff(addAssignment_30076,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,32)
    <=> v6091(VarCurr,32) ) ).

tff(addAssignment_30075,axiom,
    ! [VarCurr: state_type] :
      ( v54465(VarCurr)
    <=> v54467(VarCurr) ) ).

tff(addAssignment_30074,axiom,
    ! [VarCurr: state_type] :
      ( v54467(VarCurr)
    <=> v6017(VarCurr,24) ) ).

tff(addAssignment_30073,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,24)
    <=> v6019(VarCurr,24) ) ).

tff(addAssignment_30072,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,24)
    <=> v6021(VarCurr,24) ) ).

tff(addAssignment_30071,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,24)
    <=> v6023(VarCurr,24) ) ).

tff(addAssignment_30070,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,24)
    <=> v6025(VarCurr,24) ) ).

tff(addAssignment_30069,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,24)
    <=> v6027(VarCurr,24) ) ).

tff(addAssignment_30068,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,24)
    <=> v52434(VarCurr,24) ) ).

tff(addAssignment_30067,axiom,
    ! [VarCurr: state_type] :
      ( v52460(VarCurr,0)
    <=> v6031(VarCurr,24) ) ).

tff(addAssignment_30066,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,24)
    <=> v6033(VarCurr,24) ) ).

tff(addAssignment_30065,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,24)
    <=> v54469(VarNext,24) ) ).

tff(addCaseBooleanConditionEqualRanges1_677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54470(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54469(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_677,axiom,
    ! [VarNext: state_type] :
      ( v54470(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54469(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54470(VarNext)
      <=> v54471(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54471(VarNext)
      <=> ( v54473(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54473(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30064,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,24)
    <=> v6057(VarCurr,24) ) ).

tff(addAssignment_30063,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,24)
    <=> v6059(VarCurr,24) ) ).

tff(addAssignment_30062,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,24)
    <=> v52696(VarCurr,0) ) ).

tff(addAssignment_30061,axiom,
    ! [VarCurr: state_type] :
      ( v52696(VarCurr,0)
    <=> v52698(VarCurr,0) ) ).

tff(addAssignment_30060,axiom,
    ! [VarCurr: state_type] :
      ( v52698(VarCurr,0)
    <=> v52715(VarCurr,0) ) ).

tff(addAssignment_30059,axiom,
    ! [VarCurr: state_type] :
      ( v52708(VarCurr,0)
    <=> v52710(VarCurr,0) ) ).

tff(addAssignment_30058,axiom,
    ! [VarCurr: state_type] :
      ( v52710(VarCurr,0)
    <=> v6069(VarCurr,24) ) ).

tff(addAssignment_30057,axiom,
    ! [VarCurr: state_type] :
      ( v52700(VarCurr,0)
    <=> v52702(VarCurr,0) ) ).

tff(addAssignment_30056,axiom,
    ! [VarCurr: state_type] :
      ( v52702(VarCurr,0)
    <=> v6069(VarCurr,28) ) ).

tff(addAssignment_30055,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,28)
    <=> v6071(VarCurr,28) ) ).

tff(addAssignment_30054,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,28)
    <=> v6073(VarCurr,28) ) ).

tff(addAssignment_30053,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,28)
    <=> v52355(VarCurr,28) ) ).

tff(addAssignment_30052,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,28)
    <=> v6096(VarCurr,28) ) ).

tff(addAssignment_30051,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,28)
    <=> v6098(VarCurr,28) ) ).

tff(addAssignment_30050,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,28)
    <=> v6100(VarCurr,28) ) ).

tff(addAssignment_30049,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,28)
    <=> v6102(VarCurr,28) ) ).

tff(addAssignment_30048,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,28)
    <=> v6104(VarCurr,28) ) ).

tff(addAssignment_30047,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,28)
    <=> v6106(VarCurr,28) ) ).

tff(addAssignment_30046,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,28)
    <=> v52338(VarCurr,28) ) ).

tff(addAssignment_30045,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,28)
    <=> v52330(VarCurr,28) ) ).

tff(addAssignment_30044,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,28)
    <=> v52332(VarCurr,28) ) ).

tff(addAssignment_30043,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,28)
    <=> v52335(VarCurr,28) ) ).

tff(addAssignment_30042,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,52)
    <=> v33839(VarCurr,52) ) ).

tff(addAssignment_30041,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,52)
    <=> v33841(VarCurr,52) ) ).

tff(addAssignment_30040,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,52)
    <=> v15705(VarCurr,4) ) ).

tff(addAssignment_30039,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,28)
    <=> v6232(VarCurr,28) ) ).

tff(addAssignment_30038,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,28)
    <=> v6234(VarCurr,28) ) ).

tff(addAssignment_30037,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,28)
    <=> v52325(VarCurr,28) ) ).

tff(addAssignment_30036,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,58)
    <=> v6238(VarCurr,58) ) ).

tff(addAssignment_30035,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,58)
    <=> v6240(VarCurr,58) ) ).

tff(addAssignment_30034,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,58)
    <=> v36999(VarCurr,10) ) ).

tff(addAssignment_30033,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,28)
    <=> v6226(VarCurr,28) ) ).

tff(addAssignment_30032,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,28)
    <=> $false ) ).

tff(addAssignment_30031,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,28)
    <=> v6077(VarCurr,28) ) ).

tff(addAssignment_30030,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,28)
    <=> v6091(VarCurr,28) ) ).

tff(addAssignment_30029,axiom,
    ! [VarCurr: state_type] :
      ( v54407(VarCurr)
    <=> v54409(VarCurr) ) ).

tff(addAssignment_30028,axiom,
    ! [VarCurr: state_type] :
      ( v54409(VarCurr)
    <=> v54411(VarCurr) ) ).

tff(addAssignment_30027,axiom,
    ! [VarCurr: state_type] :
      ( v54411(VarCurr)
    <=> v54413(VarCurr) ) ).

tff(addAssignment_30026,axiom,
    ! [VarCurr: state_type] :
      ( v54413(VarCurr)
    <=> v54415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5103,axiom,
    ! [VarCurr: state_type] :
      ( v54415(VarCurr)
    <=> ( v54453(VarCurr)
      <~> v54441(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5102,axiom,
    ! [VarCurr: state_type] :
      ( v54453(VarCurr)
    <=> ( v54417(VarCurr)
      <~> v54429(VarCurr) ) ) ).

tff(addAssignment_30025,axiom,
    ! [VarCurr: state_type] :
      ( v54441(VarCurr)
    <=> v54443(VarCurr) ) ).

tff(addAssignment_30024,axiom,
    ! [VarCurr: state_type] :
      ( v54443(VarCurr)
    <=> v6017(VarCurr,20) ) ).

tff(addAssignment_30023,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,20)
    <=> v6019(VarCurr,20) ) ).

tff(addAssignment_30022,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,20)
    <=> v6021(VarCurr,20) ) ).

tff(addAssignment_30021,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,20)
    <=> v6023(VarCurr,20) ) ).

tff(addAssignment_30020,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,20)
    <=> v6025(VarCurr,20) ) ).

tff(addAssignment_30019,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,20)
    <=> v6027(VarCurr,20) ) ).

tff(addAssignment_30018,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,20)
    <=> v52434(VarCurr,20) ) ).

tff(addAssignment_30017,axiom,
    ! [VarCurr: state_type] :
      ( v52461(VarCurr,0)
    <=> v6031(VarCurr,20) ) ).

tff(addAssignment_30016,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,20)
    <=> v6033(VarCurr,20) ) ).

tff(addAssignment_30015,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,20)
    <=> v54445(VarNext,20) ) ).

tff(addCaseBooleanConditionEqualRanges1_676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54446(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54445(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_676,axiom,
    ! [VarNext: state_type] :
      ( v54446(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54445(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54446(VarNext)
      <=> v54447(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54447(VarNext)
      <=> ( v54449(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54449(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_30014,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,20)
    <=> v6057(VarCurr,20) ) ).

tff(addAssignment_30013,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,20)
    <=> v6059(VarCurr,20) ) ).

tff(addAssignment_30012,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,20)
    <=> v52644(VarCurr,0) ) ).

tff(addAssignment_30011,axiom,
    ! [VarCurr: state_type] :
      ( v52644(VarCurr,0)
    <=> v52646(VarCurr,0) ) ).

tff(addAssignment_30010,axiom,
    ! [VarCurr: state_type] :
      ( v52646(VarCurr,0)
    <=> v52663(VarCurr,0) ) ).

tff(addAssignment_30009,axiom,
    ! [VarCurr: state_type] :
      ( v52656(VarCurr,0)
    <=> v52658(VarCurr,0) ) ).

tff(addAssignment_30008,axiom,
    ! [VarCurr: state_type] :
      ( v52658(VarCurr,0)
    <=> v6069(VarCurr,20) ) ).

tff(addAssignment_30007,axiom,
    ! [VarCurr: state_type] :
      ( v52648(VarCurr,0)
    <=> v52650(VarCurr,0) ) ).

tff(addAssignment_30006,axiom,
    ! [VarCurr: state_type] :
      ( v52650(VarCurr,0)
    <=> v6069(VarCurr,24) ) ).

tff(addAssignment_30005,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,24)
    <=> v6071(VarCurr,24) ) ).

tff(addAssignment_30004,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,24)
    <=> v6073(VarCurr,24) ) ).

tff(addAssignment_30003,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,24)
    <=> v52355(VarCurr,24) ) ).

tff(addAssignment_30002,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,24)
    <=> v6096(VarCurr,24) ) ).

tff(addAssignment_30001,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,24)
    <=> v6098(VarCurr,24) ) ).

tff(addAssignment_30000,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,24)
    <=> v6100(VarCurr,24) ) ).

tff(addAssignment_29999,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,24)
    <=> v6102(VarCurr,24) ) ).

tff(addAssignment_29998,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,24)
    <=> v6104(VarCurr,24) ) ).

tff(addAssignment_29997,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,24)
    <=> v6106(VarCurr,24) ) ).

tff(addAssignment_29996,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,24)
    <=> v52338(VarCurr,24) ) ).

tff(addAssignment_29995,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,24)
    <=> v52330(VarCurr,24) ) ).

tff(addAssignment_29994,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,24)
    <=> v52332(VarCurr,24) ) ).

tff(addAssignment_29993,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,24)
    <=> v52335(VarCurr,24) ) ).

tff(addAssignment_29992,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,48)
    <=> v33839(VarCurr,48) ) ).

tff(addAssignment_29991,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,48)
    <=> v33841(VarCurr,48) ) ).

tff(addAssignment_29990,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,48)
    <=> v15705(VarCurr,0) ) ).

tff(addAssignment_29989,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,24)
    <=> v6232(VarCurr,24) ) ).

tff(addAssignment_29988,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,24)
    <=> v6234(VarCurr,24) ) ).

tff(addAssignment_29987,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,24)
    <=> v52325(VarCurr,24) ) ).

tff(addAssignment_29986,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,54)
    <=> v6238(VarCurr,54) ) ).

tff(addAssignment_29985,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,54)
    <=> v6240(VarCurr,54) ) ).

tff(addAssignment_29984,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,54)
    <=> v36999(VarCurr,6) ) ).

tff(addAssignment_29983,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,24)
    <=> v6226(VarCurr,24) ) ).

tff(addAssignment_29982,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,24)
    <=> $false ) ).

tff(addAssignment_29981,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,24)
    <=> v6077(VarCurr,24) ) ).

tff(addAssignment_29980,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,24)
    <=> v6091(VarCurr,24) ) ).

tff(addAssignment_29979,axiom,
    ! [VarCurr: state_type] :
      ( v54429(VarCurr)
    <=> v54431(VarCurr) ) ).

tff(addAssignment_29978,axiom,
    ! [VarCurr: state_type] :
      ( v54431(VarCurr)
    <=> v6017(VarCurr,16) ) ).

tff(addAssignment_29977,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,16)
    <=> v6019(VarCurr,16) ) ).

tff(addAssignment_29976,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,16)
    <=> v6021(VarCurr,16) ) ).

tff(addAssignment_29975,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,16)
    <=> v6023(VarCurr,16) ) ).

tff(addAssignment_29974,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,16)
    <=> v6025(VarCurr,16) ) ).

tff(addAssignment_29973,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,16)
    <=> v6027(VarCurr,16) ) ).

tff(addAssignment_29972,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,16)
    <=> v52434(VarCurr,16) ) ).

tff(addAssignment_29971,axiom,
    ! [VarCurr: state_type] :
      ( v52462(VarCurr,0)
    <=> v6031(VarCurr,16) ) ).

tff(addAssignment_29970,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,16)
    <=> v6033(VarCurr,16) ) ).

tff(addAssignment_29969,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,16)
    <=> v54433(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54434(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54433(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_675,axiom,
    ! [VarNext: state_type] :
      ( v54434(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54433(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54434(VarNext)
      <=> v54435(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54435(VarNext)
      <=> ( v54437(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54437(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29968,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,16)
    <=> v6057(VarCurr,16) ) ).

tff(addAssignment_29967,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,16)
    <=> v6059(VarCurr,16) ) ).

tff(addAssignment_29966,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,16)
    <=> v52604(VarCurr,0) ) ).

tff(addAssignment_29965,axiom,
    ! [VarCurr: state_type] :
      ( v52604(VarCurr,0)
    <=> v52606(VarCurr,0) ) ).

tff(addAssignment_29964,axiom,
    ! [VarCurr: state_type] :
      ( v52606(VarCurr,0)
    <=> v52623(VarCurr,0) ) ).

tff(addAssignment_29963,axiom,
    ! [VarCurr: state_type] :
      ( v52616(VarCurr,0)
    <=> v52618(VarCurr,0) ) ).

tff(addAssignment_29962,axiom,
    ! [VarCurr: state_type] :
      ( v52618(VarCurr,0)
    <=> v6069(VarCurr,16) ) ).

tff(addAssignment_29961,axiom,
    ! [VarCurr: state_type] :
      ( v52608(VarCurr,0)
    <=> v52610(VarCurr,0) ) ).

tff(addAssignment_29960,axiom,
    ! [VarCurr: state_type] :
      ( v52610(VarCurr,0)
    <=> v6069(VarCurr,20) ) ).

tff(addAssignment_29959,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,20)
    <=> v6071(VarCurr,20) ) ).

tff(addAssignment_29958,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,20)
    <=> v6073(VarCurr,20) ) ).

tff(addAssignment_29957,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,20)
    <=> v52355(VarCurr,20) ) ).

tff(addAssignment_29956,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,20)
    <=> v6096(VarCurr,20) ) ).

tff(addAssignment_29955,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,20)
    <=> v6098(VarCurr,20) ) ).

tff(addAssignment_29954,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,20)
    <=> v6100(VarCurr,20) ) ).

tff(addAssignment_29953,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,20)
    <=> v6102(VarCurr,20) ) ).

tff(addAssignment_29952,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,20)
    <=> v6104(VarCurr,20) ) ).

tff(addAssignment_29951,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,20)
    <=> v6106(VarCurr,20) ) ).

tff(addAssignment_29950,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,20)
    <=> v52338(VarCurr,20) ) ).

tff(addAssignment_29949,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,20)
    <=> v52330(VarCurr,20) ) ).

tff(addAssignment_29948,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,20)
    <=> v52332(VarCurr,20) ) ).

tff(addAssignment_29947,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,20)
    <=> v52335(VarCurr,20) ) ).

tff(addAssignment_29946,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,38)
    <=> v33839(VarCurr,38) ) ).

tff(addAssignment_29945,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,38)
    <=> v33841(VarCurr,38) ) ).

tff(addAssignment_29944,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,38)
    <=> v14155(VarCurr,2) ) ).

tff(addAssignment_29943,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,20)
    <=> v6232(VarCurr,20) ) ).

tff(addAssignment_29942,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,20)
    <=> v6234(VarCurr,20) ) ).

tff(addAssignment_29941,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,20)
    <=> v52325(VarCurr,20) ) ).

tff(addAssignment_29940,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,44)
    <=> v6238(VarCurr,44) ) ).

tff(addAssignment_29939,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,44)
    <=> v6240(VarCurr,44) ) ).

tff(addAssignment_29938,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,44)
    <=> v35449(VarCurr,8) ) ).

tff(addAssignment_29937,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,20)
    <=> v6226(VarCurr,20) ) ).

tff(addAssignment_29936,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,20)
    <=> $false ) ).

tff(addAssignment_29935,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,20)
    <=> v6077(VarCurr,20) ) ).

tff(addAssignment_29934,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,20)
    <=> v6091(VarCurr,20) ) ).

tff(addAssignment_29933,axiom,
    ! [VarCurr: state_type] :
      ( v54417(VarCurr)
    <=> v54419(VarCurr) ) ).

tff(addAssignment_29932,axiom,
    ! [VarCurr: state_type] :
      ( v54419(VarCurr)
    <=> v6017(VarCurr,12) ) ).

tff(addAssignment_29931,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,12)
    <=> v6019(VarCurr,12) ) ).

tff(addAssignment_29930,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,12)
    <=> v6021(VarCurr,12) ) ).

tff(addAssignment_29929,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,12)
    <=> v6023(VarCurr,12) ) ).

tff(addAssignment_29928,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,12)
    <=> v6025(VarCurr,12) ) ).

tff(addAssignment_29927,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,12)
    <=> v6027(VarCurr,12) ) ).

tff(addAssignment_29926,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,12)
    <=> v52434(VarCurr,12) ) ).

tff(addAssignment_29925,axiom,
    ! [VarCurr: state_type] :
      ( v52463(VarCurr,0)
    <=> v6031(VarCurr,12) ) ).

tff(addAssignment_29924,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,12)
    <=> v6033(VarCurr,12) ) ).

tff(addAssignment_29923,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,12)
    <=> v54421(VarNext,12) ) ).

tff(addCaseBooleanConditionEqualRanges1_674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54422(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54421(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_674,axiom,
    ! [VarNext: state_type] :
      ( v54422(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54421(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54422(VarNext)
      <=> v54423(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54423(VarNext)
      <=> ( v54425(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54425(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29922,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,12)
    <=> v6057(VarCurr,12) ) ).

tff(addAssignment_29921,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,12)
    <=> v6059(VarCurr,12) ) ).

tff(addAssignment_29920,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,12)
    <=> v52564(VarCurr,0) ) ).

tff(addAssignment_29919,axiom,
    ! [VarCurr: state_type] :
      ( v52564(VarCurr,0)
    <=> v52566(VarCurr,0) ) ).

tff(addAssignment_29918,axiom,
    ! [VarCurr: state_type] :
      ( v52566(VarCurr,0)
    <=> v52583(VarCurr,0) ) ).

tff(addAssignment_29917,axiom,
    ! [VarCurr: state_type] :
      ( v52576(VarCurr,0)
    <=> v52578(VarCurr,0) ) ).

tff(addAssignment_29916,axiom,
    ! [VarCurr: state_type] :
      ( v52578(VarCurr,0)
    <=> v6069(VarCurr,12) ) ).

tff(addAssignment_29915,axiom,
    ! [VarCurr: state_type] :
      ( v52568(VarCurr,0)
    <=> v52570(VarCurr,0) ) ).

tff(addAssignment_29914,axiom,
    ! [VarCurr: state_type] :
      ( v52570(VarCurr,0)
    <=> v6069(VarCurr,16) ) ).

tff(addAssignment_29913,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,16)
    <=> v6071(VarCurr,16) ) ).

tff(addAssignment_29912,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,16)
    <=> v6073(VarCurr,16) ) ).

tff(addAssignment_29911,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,16)
    <=> v52355(VarCurr,16) ) ).

tff(addAssignment_29910,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,16)
    <=> v6096(VarCurr,16) ) ).

tff(addAssignment_29909,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,16)
    <=> v6098(VarCurr,16) ) ).

tff(addAssignment_29908,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,16)
    <=> v6100(VarCurr,16) ) ).

tff(addAssignment_29907,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,16)
    <=> v6102(VarCurr,16) ) ).

tff(addAssignment_29906,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,16)
    <=> v6104(VarCurr,16) ) ).

tff(addAssignment_29905,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,16)
    <=> v6106(VarCurr,16) ) ).

tff(addAssignment_29904,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,16)
    <=> v52338(VarCurr,16) ) ).

tff(addAssignment_29903,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,16)
    <=> v52330(VarCurr,16) ) ).

tff(addAssignment_29902,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,16)
    <=> v52332(VarCurr,16) ) ).

tff(addAssignment_29901,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,16)
    <=> v52335(VarCurr,16) ) ).

tff(addAssignment_29900,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,28)
    <=> v33839(VarCurr,28) ) ).

tff(addAssignment_29899,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,16)
    <=> v6232(VarCurr,16) ) ).

tff(addAssignment_29898,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,16)
    <=> v6234(VarCurr,16) ) ).

tff(addAssignment_29897,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,16)
    <=> v52325(VarCurr,16) ) ).

tff(addAssignment_29896,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,34)
    <=> v6238(VarCurr,34) ) ).

tff(addAssignment_29895,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,16)
    <=> v6226(VarCurr,16) ) ).

tff(addAssignment_29894,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,16)
    <=> $false ) ).

tff(addAssignment_29893,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,16)
    <=> v6077(VarCurr,16) ) ).

tff(addAssignment_29892,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,16)
    <=> v6091(VarCurr,16) ) ).

tff(addAssignment_29891,axiom,
    ! [VarCurr: state_type] :
      ( v54359(VarCurr)
    <=> v54361(VarCurr) ) ).

tff(addAssignment_29890,axiom,
    ! [VarCurr: state_type] :
      ( v54361(VarCurr)
    <=> v54363(VarCurr) ) ).

tff(addAssignment_29889,axiom,
    ! [VarCurr: state_type] :
      ( v54363(VarCurr)
    <=> v54365(VarCurr) ) ).

tff(addAssignment_29888,axiom,
    ! [VarCurr: state_type] :
      ( v54365(VarCurr)
    <=> v54367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5095,axiom,
    ! [VarCurr: state_type] :
      ( v54367(VarCurr)
    <=> ( v54405(VarCurr)
      <~> v54393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5094,axiom,
    ! [VarCurr: state_type] :
      ( v54405(VarCurr)
    <=> ( v54369(VarCurr)
      <~> v54381(VarCurr) ) ) ).

tff(addAssignment_29887,axiom,
    ! [VarCurr: state_type] :
      ( v54393(VarCurr)
    <=> v54395(VarCurr) ) ).

tff(addAssignment_29886,axiom,
    ! [VarCurr: state_type] :
      ( v54395(VarCurr)
    <=> v6017(VarCurr,8) ) ).

tff(addAssignment_29885,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,8)
    <=> v6019(VarCurr,8) ) ).

tff(addAssignment_29884,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,8)
    <=> v6021(VarCurr,8) ) ).

tff(addAssignment_29883,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,8)
    <=> v6023(VarCurr,8) ) ).

tff(addAssignment_29882,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,8)
    <=> v6025(VarCurr,8) ) ).

tff(addAssignment_29881,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,8)
    <=> v6027(VarCurr,8) ) ).

tff(addAssignment_29880,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,8)
    <=> v52434(VarCurr,8) ) ).

tff(addAssignment_29879,axiom,
    ! [VarCurr: state_type] :
      ( v52464(VarCurr,0)
    <=> v6031(VarCurr,8) ) ).

tff(addAssignment_29878,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,8)
    <=> v6033(VarCurr,8) ) ).

tff(addAssignment_29877,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,8)
    <=> v54397(VarNext,8) ) ).

tff(addCaseBooleanConditionEqualRanges1_673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54398(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54397(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_673,axiom,
    ! [VarNext: state_type] :
      ( v54398(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54397(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5093,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54398(VarNext)
      <=> v54399(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54399(VarNext)
      <=> ( v54401(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54401(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29876,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,8)
    <=> v6057(VarCurr,8) ) ).

tff(addAssignment_29875,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,8)
    <=> v6059(VarCurr,8) ) ).

tff(addAssignment_29874,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,8)
    <=> v52512(VarCurr,0) ) ).

tff(addAssignment_29873,axiom,
    ! [VarCurr: state_type] :
      ( v52512(VarCurr,0)
    <=> v52514(VarCurr,0) ) ).

tff(addAssignment_29872,axiom,
    ! [VarCurr: state_type] :
      ( v52514(VarCurr,0)
    <=> v52531(VarCurr,0) ) ).

tff(addAssignment_29871,axiom,
    ! [VarCurr: state_type] :
      ( v52524(VarCurr,0)
    <=> v52526(VarCurr,0) ) ).

tff(addAssignment_29870,axiom,
    ! [VarCurr: state_type] :
      ( v52526(VarCurr,0)
    <=> v6069(VarCurr,8) ) ).

tff(addAssignment_29869,axiom,
    ! [VarCurr: state_type] :
      ( v52516(VarCurr,0)
    <=> v52518(VarCurr,0) ) ).

tff(addAssignment_29868,axiom,
    ! [VarCurr: state_type] :
      ( v52518(VarCurr,0)
    <=> v6069(VarCurr,12) ) ).

tff(addAssignment_29867,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,12)
    <=> v6071(VarCurr,12) ) ).

tff(addAssignment_29866,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,12)
    <=> v6073(VarCurr,12) ) ).

tff(addAssignment_29865,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,12)
    <=> v52355(VarCurr,12) ) ).

tff(addAssignment_29864,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,12)
    <=> v6096(VarCurr,12) ) ).

tff(addAssignment_29863,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,12)
    <=> v6098(VarCurr,12) ) ).

tff(addAssignment_29862,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,12)
    <=> v6100(VarCurr,12) ) ).

tff(addAssignment_29861,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,12)
    <=> v6102(VarCurr,12) ) ).

tff(addAssignment_29860,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,12)
    <=> v6104(VarCurr,12) ) ).

tff(addAssignment_29859,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,12)
    <=> v6106(VarCurr,12) ) ).

tff(addAssignment_29858,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,12)
    <=> v52338(VarCurr,12) ) ).

tff(addAssignment_29857,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,12)
    <=> v52330(VarCurr,12) ) ).

tff(addAssignment_29856,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,12)
    <=> v52332(VarCurr,12) ) ).

tff(addAssignment_29855,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,12)
    <=> v52335(VarCurr,12) ) ).

tff(addAssignment_29854,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,24)
    <=> v33839(VarCurr,24) ) ).

tff(addAssignment_29853,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,12)
    <=> v6232(VarCurr,12) ) ).

tff(addAssignment_29852,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,12)
    <=> v6234(VarCurr,12) ) ).

tff(addAssignment_29851,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,12)
    <=> v52325(VarCurr,12) ) ).

tff(addAssignment_29850,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,30)
    <=> v6238(VarCurr,30) ) ).

tff(addAssignment_29849,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,12)
    <=> v6226(VarCurr,12) ) ).

tff(addAssignment_29848,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,12)
    <=> $false ) ).

tff(addAssignment_29847,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,12)
    <=> v6077(VarCurr,12) ) ).

tff(addAssignment_29846,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,12)
    <=> v6091(VarCurr,12) ) ).

tff(addAssignment_29845,axiom,
    ! [VarCurr: state_type] :
      ( v54381(VarCurr)
    <=> v54383(VarCurr) ) ).

tff(addAssignment_29844,axiom,
    ! [VarCurr: state_type] :
      ( v54383(VarCurr)
    <=> v6017(VarCurr,4) ) ).

tff(addAssignment_29843,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,4)
    <=> v6019(VarCurr,4) ) ).

tff(addAssignment_29842,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,4)
    <=> v6021(VarCurr,4) ) ).

tff(addAssignment_29841,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,4)
    <=> v6023(VarCurr,4) ) ).

tff(addAssignment_29840,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,4)
    <=> v6025(VarCurr,4) ) ).

tff(addAssignment_29839,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,4)
    <=> v6027(VarCurr,4) ) ).

tff(addAssignment_29838,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,4)
    <=> v52434(VarCurr,4) ) ).

tff(addAssignment_29837,axiom,
    ! [VarCurr: state_type] :
      ( v52465(VarCurr,0)
    <=> v6031(VarCurr,4) ) ).

tff(addAssignment_29836,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,4)
    <=> v6033(VarCurr,4) ) ).

tff(addAssignment_29835,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,4)
    <=> v54385(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54386(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54385(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_672,axiom,
    ! [VarNext: state_type] :
      ( v54386(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54385(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54386(VarNext)
      <=> v54387(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54387(VarNext)
      <=> ( v54389(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54389(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29834,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,4)
    <=> v6057(VarCurr,4) ) ).

tff(addAssignment_29833,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,4)
    <=> v6059(VarCurr,4) ) ).

tff(addAssignment_29832,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,4)
    <=> v52472(VarCurr,0) ) ).

tff(addAssignment_29831,axiom,
    ! [VarCurr: state_type] :
      ( v52472(VarCurr,0)
    <=> v52474(VarCurr,0) ) ).

tff(addAssignment_29830,axiom,
    ! [VarCurr: state_type] :
      ( v52474(VarCurr,0)
    <=> v52491(VarCurr,0) ) ).

tff(addAssignment_29829,axiom,
    ! [VarCurr: state_type] :
      ( v52484(VarCurr,0)
    <=> v52486(VarCurr,0) ) ).

tff(addAssignment_29828,axiom,
    ! [VarCurr: state_type] :
      ( v52486(VarCurr,0)
    <=> v6069(VarCurr,4) ) ).

tff(addAssignment_29827,axiom,
    ! [VarCurr: state_type] :
      ( v52476(VarCurr,0)
    <=> v52478(VarCurr,0) ) ).

tff(addAssignment_29826,axiom,
    ! [VarCurr: state_type] :
      ( v52478(VarCurr,0)
    <=> v6069(VarCurr,8) ) ).

tff(addAssignment_29825,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,8)
    <=> v6071(VarCurr,8) ) ).

tff(addAssignment_29824,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,8)
    <=> v6073(VarCurr,8) ) ).

tff(addAssignment_29823,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,8)
    <=> v52355(VarCurr,8) ) ).

tff(addAssignment_29822,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,8)
    <=> v6096(VarCurr,8) ) ).

tff(addAssignment_29821,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,8)
    <=> v6098(VarCurr,8) ) ).

tff(addAssignment_29820,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,8)
    <=> v6100(VarCurr,8) ) ).

tff(addAssignment_29819,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,8)
    <=> v6102(VarCurr,8) ) ).

tff(addAssignment_29818,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,8)
    <=> v6104(VarCurr,8) ) ).

tff(addAssignment_29817,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,8)
    <=> v6106(VarCurr,8) ) ).

tff(addAssignment_29816,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,8)
    <=> v52338(VarCurr,8) ) ).

tff(addAssignment_29815,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,8)
    <=> v52330(VarCurr,8) ) ).

tff(addAssignment_29814,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,8)
    <=> v52332(VarCurr,8) ) ).

tff(addAssignment_29813,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,8)
    <=> v52335(VarCurr,8) ) ).

tff(addAssignment_29812,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,14)
    <=> v33839(VarCurr,14) ) ).

tff(addAssignment_29811,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,8)
    <=> v6232(VarCurr,8) ) ).

tff(addAssignment_29810,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,8)
    <=> v6234(VarCurr,8) ) ).

tff(addAssignment_29809,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,8)
    <=> v52325(VarCurr,8) ) ).

tff(addAssignment_29808,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,20)
    <=> v6238(VarCurr,20) ) ).

tff(addAssignment_29807,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,8)
    <=> v6226(VarCurr,8) ) ).

tff(addAssignment_29806,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,8)
    <=> $false ) ).

tff(addAssignment_29805,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,8)
    <=> v6077(VarCurr,8) ) ).

tff(addAssignment_29804,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,8)
    <=> v6091(VarCurr,8) ) ).

tff(addAssignment_29803,axiom,
    ! [VarCurr: state_type] :
      ( v54369(VarCurr)
    <=> v54371(VarCurr) ) ).

tff(addAssignment_29802,axiom,
    ! [VarCurr: state_type] :
      ( v54371(VarCurr)
    <=> v6017(VarCurr,0) ) ).

tff(addAssignment_29801,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,0)
    <=> v6019(VarCurr,0) ) ).

tff(addAssignment_29800,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,0)
    <=> v6021(VarCurr,0) ) ).

tff(addAssignment_29799,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,0)
    <=> v6023(VarCurr,0) ) ).

tff(addAssignment_29798,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,0)
    <=> v6025(VarCurr,0) ) ).

tff(addAssignment_29797,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,0)
    <=> v6027(VarCurr,0) ) ).

tff(addAssignment_29796,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,0)
    <=> v52434(VarCurr,0) ) ).

tff(addAssignment_29795,axiom,
    ! [VarCurr: state_type] :
      ( v6029(VarCurr,0)
    <=> v6031(VarCurr,0) ) ).

tff(addAssignment_29794,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,0)
    <=> v6033(VarCurr,0) ) ).

tff(addAssignment_29793,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,0)
    <=> v54373(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54374(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54373(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_671,axiom,
    ! [VarNext: state_type] :
      ( v54374(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54373(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5089,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54374(VarNext)
      <=> v54375(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5088,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54375(VarNext)
      <=> ( v54377(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54377(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29792,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,0)
    <=> v6057(VarCurr,0) ) ).

tff(addAssignment_29791,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,0)
    <=> v6059(VarCurr,0) ) ).

tff(addAssignment_29790,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,0)
    <=> v6061(VarCurr,0) ) ).

tff(addAssignment_29789,axiom,
    ! [VarCurr: state_type] :
      ( v6061(VarCurr,0)
    <=> v6063(VarCurr,0) ) ).

tff(addAssignment_29788,axiom,
    ! [VarCurr: state_type] :
      ( v6063(VarCurr,0)
    <=> v52385(VarCurr,0) ) ).

tff(addAssignment_29787,axiom,
    ! [VarCurr: state_type] :
      ( v52371(VarCurr,0)
    <=> v52373(VarCurr,0) ) ).

tff(addAssignment_29786,axiom,
    ! [VarCurr: state_type] :
      ( v52373(VarCurr,0)
    <=> v6069(VarCurr,0) ) ).

tff(addAssignment_29785,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,0)
    <=> v6071(VarCurr,0) ) ).

tff(addAssignment_29784,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,0)
    <=> v6073(VarCurr,0) ) ).

tff(addAssignment_29783,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,0)
    <=> v52355(VarCurr,0) ) ).

tff(addAssignment_29782,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,0)
    <=> v6096(VarCurr,0) ) ).

tff(addAssignment_29781,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,0)
    <=> v6098(VarCurr,0) ) ).

tff(addAssignment_29780,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,0)
    <=> v6100(VarCurr,0) ) ).

tff(addAssignment_29779,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,0)
    <=> v6102(VarCurr,0) ) ).

tff(addAssignment_29778,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,0)
    <=> v6104(VarCurr,0) ) ).

tff(addAssignment_29777,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,0)
    <=> v6106(VarCurr,0) ) ).

tff(addAssignment_29776,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,0)
    <=> v52338(VarCurr,0) ) ).

tff(addAssignment_29775,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,0)
    <=> v52330(VarCurr,0) ) ).

tff(addAssignment_29774,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,0)
    <=> v52332(VarCurr,0) ) ).

tff(addAssignment_29773,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,0)
    <=> v52335(VarCurr,0) ) ).

tff(addAssignment_29772,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,0)
    <=> v33839(VarCurr,0) ) ).

tff(addAssignment_29771,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,0)
    <=> v6232(VarCurr,0) ) ).

tff(addAssignment_29770,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,0)
    <=> v6234(VarCurr,0) ) ).

tff(addAssignment_29769,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,0)
    <=> v52325(VarCurr,0) ) ).

tff(addAssignment_29768,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,6)
    <=> v6238(VarCurr,6) ) ).

tff(addAssignment_29767,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,0)
    <=> v6226(VarCurr,0) ) ).

tff(addAssignment_29766,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_29765,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,0)
    <=> v6077(VarCurr,0) ) ).

tff(addAssignment_29764,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,0)
    <=> v6091(VarCurr,0) ) ).

tff(addAssignment_29763,axiom,
    ! [VarCurr: state_type] :
      ( v6065(VarCurr,0)
    <=> v6067(VarCurr,0) ) ).

tff(addAssignment_29762,axiom,
    ! [VarCurr: state_type] :
      ( v6067(VarCurr,0)
    <=> v6069(VarCurr,4) ) ).

tff(addAssignment_29761,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,4)
    <=> v6071(VarCurr,4) ) ).

tff(addAssignment_29760,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,4)
    <=> v6073(VarCurr,4) ) ).

tff(addAssignment_29759,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,4)
    <=> v52355(VarCurr,4) ) ).

tff(addAssignment_29758,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,4)
    <=> v6096(VarCurr,4) ) ).

tff(addAssignment_29757,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,4)
    <=> v6098(VarCurr,4) ) ).

tff(addAssignment_29756,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,4)
    <=> v6100(VarCurr,4) ) ).

tff(addAssignment_29755,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,4)
    <=> v6102(VarCurr,4) ) ).

tff(addAssignment_29754,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,4)
    <=> v6104(VarCurr,4) ) ).

tff(addAssignment_29753,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,4)
    <=> v6106(VarCurr,4) ) ).

tff(addAssignment_29752,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,4)
    <=> v52338(VarCurr,4) ) ).

tff(addAssignment_29751,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,4)
    <=> v52330(VarCurr,4) ) ).

tff(addAssignment_29750,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,4)
    <=> v52332(VarCurr,4) ) ).

tff(addAssignment_29749,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,4)
    <=> v52335(VarCurr,4) ) ).

tff(addAssignment_29748,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,4)
    <=> v33839(VarCurr,4) ) ).

tff(addAssignment_29747,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,4)
    <=> v6232(VarCurr,4) ) ).

tff(addAssignment_29746,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,4)
    <=> v6234(VarCurr,4) ) ).

tff(addAssignment_29745,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,4)
    <=> v52325(VarCurr,4) ) ).

tff(addAssignment_29744,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,10)
    <=> v6238(VarCurr,10) ) ).

tff(addAssignment_29743,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,4)
    <=> v6226(VarCurr,4) ) ).

tff(addAssignment_29742,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,4)
    <=> $false ) ).

tff(addAssignment_29741,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,4)
    <=> v6077(VarCurr,4) ) ).

tff(addAssignment_29740,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,4)
    <=> v6091(VarCurr,4) ) ).

tff(addAssignment_29739,axiom,
    ! [VarCurr: state_type] :
      ( v54015(VarCurr)
    <=> v54017(VarCurr) ) ).

tff(addAssignment_29738,axiom,
    ! [VarCurr: state_type] :
      ( v54017(VarCurr)
    <=> v5975(VarCurr,1) ) ).

tff(addAssignment_29737,axiom,
    ! [VarCurr: state_type] :
      ( v5975(VarCurr,1)
    <=> v5977(VarCurr,9) ) ).

tff(addAssignment_29736,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,9)
    <=> v5979(VarCurr,9) ) ).

tff(addAssignment_29735,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,9)
    <=> v5981(VarCurr,9) ) ).

tff(addAssignment_29734,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,9)
    <=> v5983(VarCurr,9) ) ).

tff(addAssignment_29733,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,9)
    <=> v5985(VarCurr,9) ) ).

tff(addAssignment_29732,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,9)
    <=> v53672(VarCurr,9) ) ).

tff(addAssignment_29731,axiom,
    ! [VarCurr: state_type] :
      ( v5987(VarCurr,1)
    <=> v54019(VarCurr) ) ).

tff(addAssignment_29730,axiom,
    ! [VarCurr: state_type] :
      ( v54019(VarCurr)
    <=> v54021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5087,axiom,
    ! [VarCurr: state_type] :
      ( v54021(VarCurr)
    <=> ( v54339(VarCurr)
      <~> v54327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5086,axiom,
    ! [VarCurr: state_type] :
      ( v54339(VarCurr)
    <=> ( v54023(VarCurr)
      <~> v54179(VarCurr) ) ) ).

tff(addAssignment_29729,axiom,
    ! [VarCurr: state_type] :
      ( v54327(VarCurr)
    <=> v54329(VarCurr) ) ).

tff(addAssignment_29728,axiom,
    ! [VarCurr: state_type] :
      ( v54329(VarCurr)
    <=> v53573(VarCurr,1) ) ).

tff(addAssignment_29727,axiom,
    ! [VarCurr: state_type] :
      ( v53573(VarCurr,1)
    <=> v53575(VarCurr,1) ) ).

tff(addAssignment_29726,axiom,
    ! [VarCurr: state_type] :
      ( v53575(VarCurr,1)
    <=> v53577(VarCurr,1) ) ).

tff(addAssignment_29725,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,1)
    <=> v53579(VarCurr,1) ) ).

tff(addAssignment_29724,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,1)
    <=> v54331(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54332(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v54331(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_670,axiom,
    ! [VarNext: state_type] :
      ( v54332(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v54331(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54332(VarNext)
      <=> v54333(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54333(VarNext)
      <=> ( v54335(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54335(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_29723,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,1)
    <=> v53603(VarCurr,1) ) ).

tff(addAssignment_29722,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,1)
    <=> v53632(VarCurr,1) ) ).

tff(addAssignment_29721,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,9)
    <=> v53606(VarCurr,1) ) ).

tff(addAssignment_29720,axiom,
    ! [VarCurr: state_type] :
      ( v53606(VarCurr,1)
    <=> v53608(VarCurr,1) ) ).

tff(addAssignment_29719,axiom,
    ! [VarCurr: state_type] :
      ( v53608(VarCurr,1)
    <=> v53625(VarCurr,1) ) ).

tff(addAssignment_29718,axiom,
    ! [VarCurr: state_type] :
      ( v53618(VarCurr,1)
    <=> v53620(VarCurr,1) ) ).

tff(addAssignment_29717,axiom,
    ! [VarCurr: state_type] :
      ( v53620(VarCurr,1)
    <=> v53312(VarCurr,9) ) ).

tff(addAssignment_29716,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,9)
    <=> v53314(VarCurr,9) ) ).

tff(addAssignment_29715,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,9)
    <=> v53316(VarCurr,9) ) ).

tff(addAssignment_29714,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,9)
    <=> v53407(VarCurr,9) ) ).

tff(addAssignment_29713,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,9)
    <=> v53326(VarCurr,9) ) ).

tff(addAssignment_29712,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,9)
    <=> v53328(VarCurr,9) ) ).

tff(addAssignment_29711,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,9)
    <=> v6100(VarCurr,137) ) ).

tff(addAssignment_29710,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,137)
    <=> v6102(VarCurr,137) ) ).

tff(addAssignment_29709,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,137)
    <=> v53330(VarCurr,9) ) ).

tff(addAssignment_29708,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,9)
    <=> v53332(VarCurr,9) ) ).

tff(addAssignment_29707,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,9)
    <=> v53390(VarCurr,9) ) ).

tff(addAssignment_29706,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,9)
    <=> v53387(VarCurr,9) ) ).

tff(addAssignment_29705,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,9)
    <=> v53217(VarCurr,65) ) ).

tff(addAssignment_29704,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,9)
    <=> v53383(VarCurr,9) ) ).

tff(addAssignment_29703,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,9)
    <=> v53217(VarCurr,65) ) ).

tff(addAssignment_29702,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,65)
    <=> v53218(VarCurr,65) ) ).

tff(addAssignment_29701,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,125)
    <=> v6238(VarCurr,125) ) ).

tff(addAssignment_29700,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,125)
    <=> v6240(VarCurr,125) ) ).

tff(addAssignment_29699,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,125)
    <=> v46299(VarCurr,5) ) ).

tff(addAssignment_29698,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,9)
    <=> v53379(VarCurr,9) ) ).

tff(addAssignment_29697,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_29696,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,9)
    <=> v53320(VarCurr,9) ) ).

tff(addAssignment_29695,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,9)
    <=> v53321(VarCurr,9) ) ).

tff(addAssignment_29694,axiom,
    ! [VarCurr: state_type] :
      ( v53610(VarCurr,1)
    <=> v53612(VarCurr,1) ) ).

tff(addAssignment_29693,axiom,
    ! [VarCurr: state_type] :
      ( v53612(VarCurr,1)
    <=> v53312(VarCurr,5) ) ).

tff(addAssignment_29692,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,5)
    <=> v53314(VarCurr,5) ) ).

tff(addAssignment_29691,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,5)
    <=> v53316(VarCurr,5) ) ).

tff(addAssignment_29690,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,5)
    <=> v53407(VarCurr,5) ) ).

tff(addAssignment_29689,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,5)
    <=> v53326(VarCurr,5) ) ).

tff(addAssignment_29688,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,5)
    <=> v53328(VarCurr,5) ) ).

tff(addAssignment_29687,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,5)
    <=> v6100(VarCurr,133) ) ).

tff(addAssignment_29686,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,133)
    <=> v6102(VarCurr,133) ) ).

tff(addAssignment_29685,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,133)
    <=> v53330(VarCurr,5) ) ).

tff(addAssignment_29684,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,5)
    <=> v53332(VarCurr,5) ) ).

tff(addAssignment_29683,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,5)
    <=> v53390(VarCurr,5) ) ).

tff(addAssignment_29682,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,5)
    <=> v53387(VarCurr,5) ) ).

tff(addAssignment_29681,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,5)
    <=> v53217(VarCurr,61) ) ).

tff(addAssignment_29680,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,5)
    <=> v53383(VarCurr,5) ) ).

tff(addAssignment_29679,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,5)
    <=> v53217(VarCurr,61) ) ).

tff(addAssignment_29678,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,61)
    <=> v53218(VarCurr,61) ) ).

tff(addAssignment_29677,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,121)
    <=> v6238(VarCurr,121) ) ).

tff(addAssignment_29676,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,121)
    <=> v6240(VarCurr,121) ) ).

tff(addAssignment_29675,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,121)
    <=> v46299(VarCurr,1) ) ).

tff(addAssignment_29674,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,5)
    <=> v53379(VarCurr,5) ) ).

tff(addAssignment_29673,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_29672,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,5)
    <=> v53320(VarCurr,5) ) ).

tff(addAssignment_29671,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,5)
    <=> v53321(VarCurr,5) ) ).

tff(addAssignment_29670,axiom,
    ! [VarCurr: state_type] :
      ( v54179(VarCurr)
    <=> v54181(VarCurr) ) ).

tff(addAssignment_29669,axiom,
    ! [VarCurr: state_type] :
      ( v54181(VarCurr)
    <=> v54183(VarCurr) ) ).

tff(addAssignment_29668,axiom,
    ! [VarCurr: state_type] :
      ( v54183(VarCurr)
    <=> v54185(VarCurr) ) ).

tff(addAssignment_29667,axiom,
    ! [VarCurr: state_type] :
      ( v54185(VarCurr)
    <=> v54187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5083,axiom,
    ! [VarCurr: state_type] :
      ( v54187(VarCurr)
    <=> ( v54325(VarCurr)
      <~> v54285(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5082,axiom,
    ! [VarCurr: state_type] :
      ( v54325(VarCurr)
    <=> ( v54189(VarCurr)
      <~> v54237(VarCurr) ) ) ).

tff(addAssignment_29666,axiom,
    ! [VarCurr: state_type] :
      ( v54285(VarCurr)
    <=> v54287(VarCurr) ) ).

tff(addAssignment_29665,axiom,
    ! [VarCurr: state_type] :
      ( v54287(VarCurr)
    <=> v54289(VarCurr) ) ).

tff(addAssignment_29664,axiom,
    ! [VarCurr: state_type] :
      ( v54289(VarCurr)
    <=> v54291(VarCurr) ) ).

tff(addAssignment_29663,axiom,
    ! [VarCurr: state_type] :
      ( v54291(VarCurr)
    <=> v54293(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5081,axiom,
    ! [VarCurr: state_type] :
      ( v54293(VarCurr)
    <=> ( v54323(VarCurr)
      <~> v54319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5080,axiom,
    ! [VarCurr: state_type] :
      ( v54323(VarCurr)
    <=> ( v54295(VarCurr)
      <~> v54307(VarCurr) ) ) ).

tff(addAssignment_29662,axiom,
    ! [VarCurr: state_type] :
      ( v54319(VarCurr)
    <=> v54321(VarCurr) ) ).

tff(addAssignment_29661,axiom,
    ! [VarCurr: state_type] :
      ( v54321(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_29660,axiom,
    ! [VarCurr: state_type] :
      ( v54307(VarCurr)
    <=> v54309(VarCurr) ) ).

tff(addAssignment_29659,axiom,
    ! [VarCurr: state_type] :
      ( v54309(VarCurr)
    <=> v6017(VarCurr,125) ) ).

tff(addAssignment_29658,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,125)
    <=> v53103(VarCurr,61) ) ).

tff(addAssignment_29657,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,61)
    <=> v53105(VarCurr,61) ) ).

tff(addAssignment_29656,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,61)
    <=> v53107(VarCurr,61) ) ).

tff(addAssignment_29655,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,61)
    <=> v53109(VarCurr,61) ) ).

tff(addAssignment_29654,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,61)
    <=> v6027(VarCurr,125) ) ).

tff(addAssignment_29653,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,125)
    <=> v52434(VarCurr,125) ) ).

tff(addAssignment_29652,axiom,
    ! [VarCurr: state_type] :
      ( v52435(VarCurr,1)
    <=> v53112(VarCurr,61) ) ).

tff(addAssignment_29651,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,61)
    <=> v53114(VarCurr,61) ) ).

tff(addAssignment_29650,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,61)
    <=> v54311(VarNext,61) ) ).

tff(addCaseBooleanConditionEqualRanges1_669,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54312(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54311(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_669,axiom,
    ! [VarNext: state_type] :
      ( v54312(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54311(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54312(VarNext)
      <=> v54313(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54313(VarNext)
      <=> ( v54315(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54315(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_29649,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,61)
    <=> v53138(VarCurr,61) ) ).

tff(addAssignment_29648,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,61)
    <=> v6059(VarCurr,125) ) ).

tff(addAssignment_29647,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,125)
    <=> v53304(VarCurr,1) ) ).

tff(addAssignment_29646,axiom,
    ! [VarCurr: state_type] :
      ( v53304(VarCurr,1)
    <=> v53306(VarCurr,1) ) ).

tff(addAssignment_29645,axiom,
    ! [VarCurr: state_type] :
      ( v53306(VarCurr,1)
    <=> v53420(VarCurr,1) ) ).

tff(addAssignment_29644,axiom,
    ! [VarCurr: state_type] :
      ( v53413(VarCurr,1)
    <=> v53415(VarCurr,1) ) ).

tff(addAssignment_29643,axiom,
    ! [VarCurr: state_type] :
      ( v53415(VarCurr,1)
    <=> v6069(VarCurr,125) ) ).

tff(addAssignment_29642,axiom,
    ! [VarCurr: state_type] :
      ( v53308(VarCurr,1)
    <=> v53310(VarCurr,1) ) ).

tff(addAssignment_29641,axiom,
    ! [VarCurr: state_type] :
      ( v53310(VarCurr,1)
    <=> v53312(VarCurr,13) ) ).

tff(addAssignment_29640,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,13)
    <=> v53314(VarCurr,13) ) ).

tff(addAssignment_29639,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,13)
    <=> v53316(VarCurr,13) ) ).

tff(addAssignment_29638,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,13)
    <=> v53407(VarCurr,13) ) ).

tff(addAssignment_29637,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,13)
    <=> v53326(VarCurr,13) ) ).

tff(addAssignment_29636,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,13)
    <=> v53328(VarCurr,13) ) ).

tff(addAssignment_29635,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,13)
    <=> v6100(VarCurr,141) ) ).

tff(addAssignment_29634,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,141)
    <=> v6102(VarCurr,141) ) ).

tff(addAssignment_29633,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,141)
    <=> v53330(VarCurr,13) ) ).

tff(addAssignment_29632,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,13)
    <=> v53332(VarCurr,13) ) ).

tff(addAssignment_29631,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,13)
    <=> v53390(VarCurr,13) ) ).

tff(addAssignment_29630,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,13)
    <=> v53387(VarCurr,13) ) ).

tff(addAssignment_29629,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,13)
    <=> v53217(VarCurr,69) ) ).

tff(addAssignment_29628,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,13)
    <=> v53383(VarCurr,13) ) ).

tff(addAssignment_29627,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,13)
    <=> v53217(VarCurr,69) ) ).

tff(addAssignment_29626,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,69)
    <=> v53218(VarCurr,69) ) ).

tff(addAssignment_29625,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,135)
    <=> v6238(VarCurr,135) ) ).

tff(addAssignment_29624,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,135)
    <=> v6240(VarCurr,135) ) ).

tff(addAssignment_29623,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,135)
    <=> v47849(VarCurr,3) ) ).

tff(addAssignment_29622,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,13)
    <=> v53379(VarCurr,13) ) ).

tff(addAssignment_29621,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_29620,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,13)
    <=> v53320(VarCurr,13) ) ).

tff(addAssignment_29619,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,13)
    <=> v53321(VarCurr,13) ) ).

tff(addAssignment_29618,axiom,
    ! [VarCurr: state_type] :
      ( v54295(VarCurr)
    <=> v54297(VarCurr) ) ).

tff(addAssignment_29617,axiom,
    ! [VarCurr: state_type] :
      ( v54297(VarCurr)
    <=> v6017(VarCurr,121) ) ).

tff(addAssignment_29616,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,121)
    <=> v53103(VarCurr,57) ) ).

tff(addAssignment_29615,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,57)
    <=> v53105(VarCurr,57) ) ).

tff(addAssignment_29614,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,57)
    <=> v53107(VarCurr,57) ) ).

tff(addAssignment_29613,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,57)
    <=> v53109(VarCurr,57) ) ).

tff(addAssignment_29612,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,57)
    <=> v6027(VarCurr,121) ) ).

tff(addAssignment_29611,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,121)
    <=> v52434(VarCurr,121) ) ).

tff(addAssignment_29610,axiom,
    ! [VarCurr: state_type] :
      ( v52436(VarCurr,1)
    <=> v53112(VarCurr,57) ) ).

tff(addAssignment_29609,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,57)
    <=> v53114(VarCurr,57) ) ).

tff(addAssignment_29608,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,57)
    <=> v54299(VarNext,57) ) ).

tff(addCaseBooleanConditionEqualRanges1_668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54300(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54299(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_668,axiom,
    ! [VarNext: state_type] :
      ( v54300(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54299(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54300(VarNext)
      <=> v54301(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54301(VarNext)
      <=> ( v54303(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54303(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_29607,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,57)
    <=> v53138(VarCurr,57) ) ).

tff(addAssignment_29606,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,57)
    <=> v6059(VarCurr,121) ) ).

tff(addAssignment_29605,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,121)
    <=> v53140(VarCurr,1) ) ).

tff(addAssignment_29604,axiom,
    ! [VarCurr: state_type] :
      ( v53140(VarCurr,1)
    <=> v53142(VarCurr,1) ) ).

tff(addAssignment_29603,axiom,
    ! [VarCurr: state_type] :
      ( v53142(VarCurr,1)
    <=> v53255(VarCurr,1) ) ).

tff(addAssignment_29602,axiom,
    ! [VarCurr: state_type] :
      ( v53248(VarCurr,1)
    <=> v53250(VarCurr,1) ) ).

tff(addAssignment_29601,axiom,
    ! [VarCurr: state_type] :
      ( v53250(VarCurr,1)
    <=> v6069(VarCurr,121) ) ).

tff(addAssignment_29600,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,121)
    <=> v53148(VarCurr,57) ) ).

tff(addAssignment_29599,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,57)
    <=> v53150(VarCurr,57) ) ).

tff(addAssignment_29598,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,57)
    <=> v53242(VarCurr,57) ) ).

tff(addAssignment_29597,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,57)
    <=> v53160(VarCurr,57) ) ).

tff(addAssignment_29596,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,57)
    <=> v6098(VarCurr,121) ) ).

tff(addAssignment_29595,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,121)
    <=> v6100(VarCurr,121) ) ).

tff(addAssignment_29594,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,121)
    <=> v6102(VarCurr,121) ) ).

tff(addAssignment_29593,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,121)
    <=> v53162(VarCurr,57) ) ).

tff(addAssignment_29592,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,57)
    <=> v53164(VarCurr,57) ) ).

tff(addAssignment_29591,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,57)
    <=> v53225(VarCurr,57) ) ).

tff(addAssignment_29590,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,57)
    <=> v53223(VarCurr,57) ) ).

tff(addAssignment_29589,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,57)
    <=> v53224(VarCurr,57) ) ).

tff(addAssignment_29588,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,57)
    <=> v53215(VarCurr,57) ) ).

tff(addAssignment_29587,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,57)
    <=> v53219(VarCurr,57) ) ).

tff(addAssignment_29586,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,49)
    <=> v53218(VarCurr,49) ) ).

tff(addAssignment_29585,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,97)
    <=> v6238(VarCurr,97) ) ).

tff(addAssignment_29584,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,97)
    <=> v6240(VarCurr,97) ) ).

tff(addAssignment_29583,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,97)
    <=> v43199(VarCurr,1) ) ).

tff(addAssignment_29582,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,57)
    <=> v53211(VarCurr,57) ) ).

tff(addAssignment_29581,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,57)
    <=> $false ) ).

tff(addAssignment_29580,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,57)
    <=> v53154(VarCurr,57) ) ).

tff(addAssignment_29579,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,57)
    <=> v53155(VarCurr,57) ) ).

tff(addAssignment_29578,axiom,
    ! [VarCurr: state_type] :
      ( v53144(VarCurr,1)
    <=> v53146(VarCurr,1) ) ).

tff(addAssignment_29577,axiom,
    ! [VarCurr: state_type] :
      ( v53146(VarCurr,1)
    <=> v6069(VarCurr,125) ) ).

tff(addAssignment_29576,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,125)
    <=> v53148(VarCurr,61) ) ).

tff(addAssignment_29575,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,61)
    <=> v53150(VarCurr,61) ) ).

tff(addAssignment_29574,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,61)
    <=> v53242(VarCurr,61) ) ).

tff(addAssignment_29573,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,61)
    <=> v53160(VarCurr,61) ) ).

tff(addAssignment_29572,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,61)
    <=> v6098(VarCurr,125) ) ).

tff(addAssignment_29571,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,125)
    <=> v6100(VarCurr,125) ) ).

tff(addAssignment_29570,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,125)
    <=> v6102(VarCurr,125) ) ).

tff(addAssignment_29569,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,125)
    <=> v53162(VarCurr,61) ) ).

tff(addAssignment_29568,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,61)
    <=> v53164(VarCurr,61) ) ).

tff(addAssignment_29567,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,61)
    <=> v53225(VarCurr,61) ) ).

tff(addAssignment_29566,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,61)
    <=> v53223(VarCurr,61) ) ).

tff(addAssignment_29565,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,61)
    <=> v53224(VarCurr,61) ) ).

tff(addAssignment_29564,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,61)
    <=> v53215(VarCurr,61) ) ).

tff(addAssignment_29563,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,61)
    <=> v53219(VarCurr,61) ) ).

tff(addAssignment_29562,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,53)
    <=> v53218(VarCurr,53) ) ).

tff(addAssignment_29561,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,101)
    <=> v6238(VarCurr,101) ) ).

tff(addAssignment_29560,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,101)
    <=> v6240(VarCurr,101) ) ).

tff(addAssignment_29559,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,101)
    <=> v43199(VarCurr,5) ) ).

tff(addAssignment_29558,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,61)
    <=> v53211(VarCurr,61) ) ).

tff(addAssignment_29557,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,61)
    <=> $false ) ).

tff(addAssignment_29556,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,61)
    <=> v53154(VarCurr,61) ) ).

tff(addAssignment_29555,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,61)
    <=> v53155(VarCurr,61) ) ).

tff(addAssignment_29554,axiom,
    ! [VarCurr: state_type] :
      ( v54237(VarCurr)
    <=> v54239(VarCurr) ) ).

tff(addAssignment_29553,axiom,
    ! [VarCurr: state_type] :
      ( v54239(VarCurr)
    <=> v54241(VarCurr) ) ).

tff(addAssignment_29552,axiom,
    ! [VarCurr: state_type] :
      ( v54241(VarCurr)
    <=> v54243(VarCurr) ) ).

tff(addAssignment_29551,axiom,
    ! [VarCurr: state_type] :
      ( v54243(VarCurr)
    <=> v54245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5075,axiom,
    ! [VarCurr: state_type] :
      ( v54245(VarCurr)
    <=> ( v54283(VarCurr)
      <~> v54271(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5074,axiom,
    ! [VarCurr: state_type] :
      ( v54283(VarCurr)
    <=> ( v54247(VarCurr)
      <~> v54259(VarCurr) ) ) ).

tff(addAssignment_29550,axiom,
    ! [VarCurr: state_type] :
      ( v54271(VarCurr)
    <=> v54273(VarCurr) ) ).

tff(addAssignment_29549,axiom,
    ! [VarCurr: state_type] :
      ( v54273(VarCurr)
    <=> v6017(VarCurr,57) ) ).

tff(addAssignment_29548,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,57)
    <=> v6019(VarCurr,57) ) ).

tff(addAssignment_29547,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,57)
    <=> v6021(VarCurr,57) ) ).

tff(addAssignment_29546,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,57)
    <=> v6023(VarCurr,57) ) ).

tff(addAssignment_29545,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,57)
    <=> v6025(VarCurr,57) ) ).

tff(addAssignment_29544,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,57)
    <=> v6027(VarCurr,57) ) ).

tff(addAssignment_29543,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,57)
    <=> v52434(VarCurr,57) ) ).

tff(addAssignment_29542,axiom,
    ! [VarCurr: state_type] :
      ( v52452(VarCurr,1)
    <=> v6031(VarCurr,57) ) ).

tff(addAssignment_29541,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,57)
    <=> v6033(VarCurr,57) ) ).

tff(addAssignment_29540,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,57)
    <=> v54275(VarNext,57) ) ).

tff(addCaseBooleanConditionEqualRanges1_667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54276(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54275(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_667,axiom,
    ! [VarNext: state_type] :
      ( v54276(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54275(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5073,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54276(VarNext)
      <=> v54277(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54277(VarNext)
      <=> ( v54279(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54279(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29539,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,57)
    <=> v6057(VarCurr,57) ) ).

tff(addAssignment_29538,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,57)
    <=> v6059(VarCurr,57) ) ).

tff(addAssignment_29537,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,57)
    <=> v53052(VarCurr,1) ) ).

tff(addAssignment_29536,axiom,
    ! [VarCurr: state_type] :
      ( v53052(VarCurr,1)
    <=> v53054(VarCurr,1) ) ).

tff(addAssignment_29535,axiom,
    ! [VarCurr: state_type] :
      ( v53054(VarCurr,1)
    <=> v53071(VarCurr,1) ) ).

tff(addAssignment_29534,axiom,
    ! [VarCurr: state_type] :
      ( v53064(VarCurr,1)
    <=> v53066(VarCurr,1) ) ).

tff(addAssignment_29533,axiom,
    ! [VarCurr: state_type] :
      ( v53066(VarCurr,1)
    <=> v6069(VarCurr,57) ) ).

tff(addAssignment_29532,axiom,
    ! [VarCurr: state_type] :
      ( v53056(VarCurr,1)
    <=> v53058(VarCurr,1) ) ).

tff(addAssignment_29531,axiom,
    ! [VarCurr: state_type] :
      ( v53058(VarCurr,1)
    <=> v6069(VarCurr,61) ) ).

tff(addAssignment_29530,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,61)
    <=> v6071(VarCurr,61) ) ).

tff(addAssignment_29529,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,61)
    <=> v6073(VarCurr,61) ) ).

tff(addAssignment_29528,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,61)
    <=> v52355(VarCurr,61) ) ).

tff(addAssignment_29527,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,61)
    <=> v6096(VarCurr,61) ) ).

tff(addAssignment_29526,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,61)
    <=> v6098(VarCurr,61) ) ).

tff(addAssignment_29525,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,61)
    <=> v6100(VarCurr,61) ) ).

tff(addAssignment_29524,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,61)
    <=> v6102(VarCurr,61) ) ).

tff(addAssignment_29523,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,61)
    <=> v6104(VarCurr,61) ) ).

tff(addAssignment_29522,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,61)
    <=> v6106(VarCurr,61) ) ).

tff(addAssignment_29521,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,61)
    <=> v52338(VarCurr,61) ) ).

tff(addAssignment_29520,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,61)
    <=> v52330(VarCurr,61) ) ).

tff(addAssignment_29519,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,61)
    <=> v52332(VarCurr,61) ) ).

tff(addAssignment_29518,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,61)
    <=> v52335(VarCurr,61) ) ).

tff(addAssignment_29517,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,121)
    <=> v33839(VarCurr,121) ) ).

tff(addAssignment_29516,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,121)
    <=> v33841(VarCurr,121) ) ).

tff(addAssignment_29515,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,121)
    <=> v25005(VarCurr,1) ) ).

tff(addAssignment_29514,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,61)
    <=> v6232(VarCurr,61) ) ).

tff(addAssignment_29513,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,61)
    <=> v6234(VarCurr,61) ) ).

tff(addAssignment_29512,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,61)
    <=> v52325(VarCurr,61) ) ).

tff(addAssignment_29511,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,127)
    <=> v6238(VarCurr,127) ) ).

tff(addAssignment_29510,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,127)
    <=> v6240(VarCurr,127) ) ).

tff(addAssignment_29509,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,127)
    <=> v46299(VarCurr,7) ) ).

tff(addAssignment_29508,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,61)
    <=> v6226(VarCurr,61) ) ).

tff(addAssignment_29507,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,61)
    <=> $false ) ).

tff(addAssignment_29506,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,61)
    <=> v6077(VarCurr,61) ) ).

tff(addAssignment_29505,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,61)
    <=> v6091(VarCurr,61) ) ).

tff(addAssignment_29504,axiom,
    ! [VarCurr: state_type] :
      ( v54259(VarCurr)
    <=> v54261(VarCurr) ) ).

tff(addAssignment_29503,axiom,
    ! [VarCurr: state_type] :
      ( v54261(VarCurr)
    <=> v6017(VarCurr,53) ) ).

tff(addAssignment_29502,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,53)
    <=> v6019(VarCurr,53) ) ).

tff(addAssignment_29501,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,53)
    <=> v6021(VarCurr,53) ) ).

tff(addAssignment_29500,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,53)
    <=> v6023(VarCurr,53) ) ).

tff(addAssignment_29499,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,53)
    <=> v6025(VarCurr,53) ) ).

tff(addAssignment_29498,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,53)
    <=> v6027(VarCurr,53) ) ).

tff(addAssignment_29497,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,53)
    <=> v52434(VarCurr,53) ) ).

tff(addAssignment_29496,axiom,
    ! [VarCurr: state_type] :
      ( v52453(VarCurr,1)
    <=> v6031(VarCurr,53) ) ).

tff(addAssignment_29495,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,53)
    <=> v6033(VarCurr,53) ) ).

tff(addAssignment_29494,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,53)
    <=> v54263(VarNext,53) ) ).

tff(addCaseBooleanConditionEqualRanges1_666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54264(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54263(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_666,axiom,
    ! [VarNext: state_type] :
      ( v54264(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54263(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54264(VarNext)
      <=> v54265(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54265(VarNext)
      <=> ( v54267(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54267(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29493,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,53)
    <=> v6057(VarCurr,53) ) ).

tff(addAssignment_29492,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,53)
    <=> v6059(VarCurr,53) ) ).

tff(addAssignment_29491,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,53)
    <=> v53012(VarCurr,1) ) ).

tff(addAssignment_29490,axiom,
    ! [VarCurr: state_type] :
      ( v53012(VarCurr,1)
    <=> v53014(VarCurr,1) ) ).

tff(addAssignment_29489,axiom,
    ! [VarCurr: state_type] :
      ( v53014(VarCurr,1)
    <=> v53031(VarCurr,1) ) ).

tff(addAssignment_29488,axiom,
    ! [VarCurr: state_type] :
      ( v53024(VarCurr,1)
    <=> v53026(VarCurr,1) ) ).

tff(addAssignment_29487,axiom,
    ! [VarCurr: state_type] :
      ( v53026(VarCurr,1)
    <=> v6069(VarCurr,53) ) ).

tff(addAssignment_29486,axiom,
    ! [VarCurr: state_type] :
      ( v53016(VarCurr,1)
    <=> v53018(VarCurr,1) ) ).

tff(addAssignment_29485,axiom,
    ! [VarCurr: state_type] :
      ( v53018(VarCurr,1)
    <=> v6069(VarCurr,57) ) ).

tff(addAssignment_29484,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,57)
    <=> v6071(VarCurr,57) ) ).

tff(addAssignment_29483,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,57)
    <=> v6073(VarCurr,57) ) ).

tff(addAssignment_29482,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,57)
    <=> v52355(VarCurr,57) ) ).

tff(addAssignment_29481,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,57)
    <=> v6096(VarCurr,57) ) ).

tff(addAssignment_29480,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,57)
    <=> v6098(VarCurr,57) ) ).

tff(addAssignment_29479,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,57)
    <=> v6100(VarCurr,57) ) ).

tff(addAssignment_29478,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,57)
    <=> v6102(VarCurr,57) ) ).

tff(addAssignment_29477,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,57)
    <=> v6104(VarCurr,57) ) ).

tff(addAssignment_29476,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,57)
    <=> v6106(VarCurr,57) ) ).

tff(addAssignment_29475,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,57)
    <=> v52338(VarCurr,57) ) ).

tff(addAssignment_29474,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,57)
    <=> v52330(VarCurr,57) ) ).

tff(addAssignment_29473,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,57)
    <=> v52332(VarCurr,57) ) ).

tff(addAssignment_29472,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,57)
    <=> v52335(VarCurr,57) ) ).

tff(addAssignment_29471,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,111)
    <=> v33839(VarCurr,111) ) ).

tff(addAssignment_29470,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,111)
    <=> v33841(VarCurr,111) ) ).

tff(addAssignment_29469,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,111)
    <=> v23455(VarCurr,3) ) ).

tff(addAssignment_29468,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,57)
    <=> v6232(VarCurr,57) ) ).

tff(addAssignment_29467,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,57)
    <=> v6234(VarCurr,57) ) ).

tff(addAssignment_29466,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,57)
    <=> v52325(VarCurr,57) ) ).

tff(addAssignment_29465,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,117)
    <=> v6238(VarCurr,117) ) ).

tff(addAssignment_29464,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,117)
    <=> v6240(VarCurr,117) ) ).

tff(addAssignment_29463,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,117)
    <=> v44749(VarCurr,9) ) ).

tff(addAssignment_29462,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,57)
    <=> v6226(VarCurr,57) ) ).

tff(addAssignment_29461,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,57)
    <=> $false ) ).

tff(addAssignment_29460,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,57)
    <=> v6077(VarCurr,57) ) ).

tff(addAssignment_29459,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,57)
    <=> v6091(VarCurr,57) ) ).

tff(addAssignment_29458,axiom,
    ! [VarCurr: state_type] :
      ( v54247(VarCurr)
    <=> v54249(VarCurr) ) ).

tff(addAssignment_29457,axiom,
    ! [VarCurr: state_type] :
      ( v54249(VarCurr)
    <=> v6017(VarCurr,49) ) ).

tff(addAssignment_29456,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,49)
    <=> v6019(VarCurr,49) ) ).

tff(addAssignment_29455,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,49)
    <=> v6021(VarCurr,49) ) ).

tff(addAssignment_29454,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,49)
    <=> v6023(VarCurr,49) ) ).

tff(addAssignment_29453,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,49)
    <=> v6025(VarCurr,49) ) ).

tff(addAssignment_29452,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,49)
    <=> v6027(VarCurr,49) ) ).

tff(addAssignment_29451,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,49)
    <=> v52434(VarCurr,49) ) ).

tff(addAssignment_29450,axiom,
    ! [VarCurr: state_type] :
      ( v52454(VarCurr,1)
    <=> v6031(VarCurr,49) ) ).

tff(addAssignment_29449,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,49)
    <=> v6033(VarCurr,49) ) ).

tff(addAssignment_29448,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,49)
    <=> v54251(VarNext,49) ) ).

tff(addCaseBooleanConditionEqualRanges1_665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54252(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54251(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_665,axiom,
    ! [VarNext: state_type] :
      ( v54252(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54251(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54252(VarNext)
      <=> v54253(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5068,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54253(VarNext)
      <=> ( v54255(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54255(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29447,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,49)
    <=> v6057(VarCurr,49) ) ).

tff(addAssignment_29446,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,49)
    <=> v6059(VarCurr,49) ) ).

tff(addAssignment_29445,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,49)
    <=> v52972(VarCurr,1) ) ).

tff(addAssignment_29444,axiom,
    ! [VarCurr: state_type] :
      ( v52972(VarCurr,1)
    <=> v52974(VarCurr,1) ) ).

tff(addAssignment_29443,axiom,
    ! [VarCurr: state_type] :
      ( v52974(VarCurr,1)
    <=> v52991(VarCurr,1) ) ).

tff(addAssignment_29442,axiom,
    ! [VarCurr: state_type] :
      ( v52984(VarCurr,1)
    <=> v52986(VarCurr,1) ) ).

tff(addAssignment_29441,axiom,
    ! [VarCurr: state_type] :
      ( v52986(VarCurr,1)
    <=> v6069(VarCurr,49) ) ).

tff(addAssignment_29440,axiom,
    ! [VarCurr: state_type] :
      ( v52976(VarCurr,1)
    <=> v52978(VarCurr,1) ) ).

tff(addAssignment_29439,axiom,
    ! [VarCurr: state_type] :
      ( v52978(VarCurr,1)
    <=> v6069(VarCurr,53) ) ).

tff(addAssignment_29438,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,53)
    <=> v6071(VarCurr,53) ) ).

tff(addAssignment_29437,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,53)
    <=> v6073(VarCurr,53) ) ).

tff(addAssignment_29436,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,53)
    <=> v52355(VarCurr,53) ) ).

tff(addAssignment_29435,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,53)
    <=> v6096(VarCurr,53) ) ).

tff(addAssignment_29434,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,53)
    <=> v6098(VarCurr,53) ) ).

tff(addAssignment_29433,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,53)
    <=> v6100(VarCurr,53) ) ).

tff(addAssignment_29432,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,53)
    <=> v6102(VarCurr,53) ) ).

tff(addAssignment_29431,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,53)
    <=> v6104(VarCurr,53) ) ).

tff(addAssignment_29430,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,53)
    <=> v6106(VarCurr,53) ) ).

tff(addAssignment_29429,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,53)
    <=> v52338(VarCurr,53) ) ).

tff(addAssignment_29428,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,53)
    <=> v52330(VarCurr,53) ) ).

tff(addAssignment_29427,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,53)
    <=> v52332(VarCurr,53) ) ).

tff(addAssignment_29426,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,53)
    <=> v52335(VarCurr,53) ) ).

tff(addAssignment_29425,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,101)
    <=> v33839(VarCurr,101) ) ).

tff(addAssignment_29424,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,101)
    <=> v33841(VarCurr,101) ) ).

tff(addAssignment_29423,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,101)
    <=> v21905(VarCurr,5) ) ).

tff(addAssignment_29422,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,53)
    <=> v6232(VarCurr,53) ) ).

tff(addAssignment_29421,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,53)
    <=> v6234(VarCurr,53) ) ).

tff(addAssignment_29420,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,53)
    <=> v52325(VarCurr,53) ) ).

tff(addAssignment_29419,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,107)
    <=> v6238(VarCurr,107) ) ).

tff(addAssignment_29418,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,107)
    <=> v6240(VarCurr,107) ) ).

tff(addAssignment_29417,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,107)
    <=> v43199(VarCurr,11) ) ).

tff(addAssignment_29416,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,53)
    <=> v6226(VarCurr,53) ) ).

tff(addAssignment_29415,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,53)
    <=> $false ) ).

tff(addAssignment_29414,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,53)
    <=> v6077(VarCurr,53) ) ).

tff(addAssignment_29413,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,53)
    <=> v6091(VarCurr,53) ) ).

tff(addAssignment_29412,axiom,
    ! [VarCurr: state_type] :
      ( v54189(VarCurr)
    <=> v54191(VarCurr) ) ).

tff(addAssignment_29411,axiom,
    ! [VarCurr: state_type] :
      ( v54191(VarCurr)
    <=> v54193(VarCurr) ) ).

tff(addAssignment_29410,axiom,
    ! [VarCurr: state_type] :
      ( v54193(VarCurr)
    <=> v54195(VarCurr) ) ).

tff(addAssignment_29409,axiom,
    ! [VarCurr: state_type] :
      ( v54195(VarCurr)
    <=> v54197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5067,axiom,
    ! [VarCurr: state_type] :
      ( v54197(VarCurr)
    <=> ( v54235(VarCurr)
      <~> v54223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5066,axiom,
    ! [VarCurr: state_type] :
      ( v54235(VarCurr)
    <=> ( v54199(VarCurr)
      <~> v54211(VarCurr) ) ) ).

tff(addAssignment_29408,axiom,
    ! [VarCurr: state_type] :
      ( v54223(VarCurr)
    <=> v54225(VarCurr) ) ).

tff(addAssignment_29407,axiom,
    ! [VarCurr: state_type] :
      ( v54225(VarCurr)
    <=> v6017(VarCurr,45) ) ).

tff(addAssignment_29406,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,45)
    <=> v6019(VarCurr,45) ) ).

tff(addAssignment_29405,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,45)
    <=> v6021(VarCurr,45) ) ).

tff(addAssignment_29404,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,45)
    <=> v6023(VarCurr,45) ) ).

tff(addAssignment_29403,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,45)
    <=> v6025(VarCurr,45) ) ).

tff(addAssignment_29402,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,45)
    <=> v6027(VarCurr,45) ) ).

tff(addAssignment_29401,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,45)
    <=> v52434(VarCurr,45) ) ).

tff(addAssignment_29400,axiom,
    ! [VarCurr: state_type] :
      ( v52455(VarCurr,1)
    <=> v6031(VarCurr,45) ) ).

tff(addAssignment_29399,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,45)
    <=> v6033(VarCurr,45) ) ).

tff(addAssignment_29398,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,45)
    <=> v54227(VarNext,45) ) ).

tff(addCaseBooleanConditionEqualRanges1_664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54228(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54227(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_664,axiom,
    ! [VarNext: state_type] :
      ( v54228(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54227(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54228(VarNext)
      <=> v54229(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54229(VarNext)
      <=> ( v54231(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54231(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29397,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,45)
    <=> v6057(VarCurr,45) ) ).

tff(addAssignment_29396,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,45)
    <=> v6059(VarCurr,45) ) ).

tff(addAssignment_29395,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,45)
    <=> v52920(VarCurr,1) ) ).

tff(addAssignment_29394,axiom,
    ! [VarCurr: state_type] :
      ( v52920(VarCurr,1)
    <=> v52922(VarCurr,1) ) ).

tff(addAssignment_29393,axiom,
    ! [VarCurr: state_type] :
      ( v52922(VarCurr,1)
    <=> v52939(VarCurr,1) ) ).

tff(addAssignment_29392,axiom,
    ! [VarCurr: state_type] :
      ( v52932(VarCurr,1)
    <=> v52934(VarCurr,1) ) ).

tff(addAssignment_29391,axiom,
    ! [VarCurr: state_type] :
      ( v52934(VarCurr,1)
    <=> v6069(VarCurr,45) ) ).

tff(addAssignment_29390,axiom,
    ! [VarCurr: state_type] :
      ( v52924(VarCurr,1)
    <=> v52926(VarCurr,1) ) ).

tff(addAssignment_29389,axiom,
    ! [VarCurr: state_type] :
      ( v52926(VarCurr,1)
    <=> v6069(VarCurr,49) ) ).

tff(addAssignment_29388,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,49)
    <=> v6071(VarCurr,49) ) ).

tff(addAssignment_29387,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,49)
    <=> v6073(VarCurr,49) ) ).

tff(addAssignment_29386,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,49)
    <=> v52355(VarCurr,49) ) ).

tff(addAssignment_29385,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,49)
    <=> v6096(VarCurr,49) ) ).

tff(addAssignment_29384,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,49)
    <=> v6098(VarCurr,49) ) ).

tff(addAssignment_29383,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,49)
    <=> v6100(VarCurr,49) ) ).

tff(addAssignment_29382,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,49)
    <=> v6102(VarCurr,49) ) ).

tff(addAssignment_29381,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,49)
    <=> v6104(VarCurr,49) ) ).

tff(addAssignment_29380,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,49)
    <=> v6106(VarCurr,49) ) ).

tff(addAssignment_29379,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,49)
    <=> v52338(VarCurr,49) ) ).

tff(addAssignment_29378,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,49)
    <=> v52330(VarCurr,49) ) ).

tff(addAssignment_29377,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,49)
    <=> v52332(VarCurr,49) ) ).

tff(addAssignment_29376,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,49)
    <=> v52335(VarCurr,49) ) ).

tff(addAssignment_29375,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,97)
    <=> v33839(VarCurr,97) ) ).

tff(addAssignment_29374,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,97)
    <=> v33841(VarCurr,97) ) ).

tff(addAssignment_29373,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,97)
    <=> v21905(VarCurr,1) ) ).

tff(addAssignment_29372,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,49)
    <=> v6232(VarCurr,49) ) ).

tff(addAssignment_29371,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,49)
    <=> v6234(VarCurr,49) ) ).

tff(addAssignment_29370,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,49)
    <=> v52325(VarCurr,49) ) ).

tff(addAssignment_29369,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,103)
    <=> v6238(VarCurr,103) ) ).

tff(addAssignment_29368,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,103)
    <=> v6240(VarCurr,103) ) ).

tff(addAssignment_29367,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,103)
    <=> v43199(VarCurr,7) ) ).

tff(addAssignment_29366,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,49)
    <=> v6226(VarCurr,49) ) ).

tff(addAssignment_29365,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,49)
    <=> $false ) ).

tff(addAssignment_29364,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,49)
    <=> v6077(VarCurr,49) ) ).

tff(addAssignment_29363,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,49)
    <=> v6091(VarCurr,49) ) ).

tff(addAssignment_29362,axiom,
    ! [VarCurr: state_type] :
      ( v54211(VarCurr)
    <=> v54213(VarCurr) ) ).

tff(addAssignment_29361,axiom,
    ! [VarCurr: state_type] :
      ( v54213(VarCurr)
    <=> v6017(VarCurr,41) ) ).

tff(addAssignment_29360,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,41)
    <=> v6019(VarCurr,41) ) ).

tff(addAssignment_29359,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,41)
    <=> v6021(VarCurr,41) ) ).

tff(addAssignment_29358,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,41)
    <=> v6023(VarCurr,41) ) ).

tff(addAssignment_29357,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,41)
    <=> v6025(VarCurr,41) ) ).

tff(addAssignment_29356,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,41)
    <=> v6027(VarCurr,41) ) ).

tff(addAssignment_29355,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,41)
    <=> v52434(VarCurr,41) ) ).

tff(addAssignment_29354,axiom,
    ! [VarCurr: state_type] :
      ( v52456(VarCurr,1)
    <=> v6031(VarCurr,41) ) ).

tff(addAssignment_29353,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,41)
    <=> v6033(VarCurr,41) ) ).

tff(addAssignment_29352,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,41)
    <=> v54215(VarNext,41) ) ).

tff(addCaseBooleanConditionEqualRanges1_663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54216(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54215(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_663,axiom,
    ! [VarNext: state_type] :
      ( v54216(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54215(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54216(VarNext)
      <=> v54217(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54217(VarNext)
      <=> ( v54219(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54219(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29351,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,41)
    <=> v6057(VarCurr,41) ) ).

tff(addAssignment_29350,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,41)
    <=> v6059(VarCurr,41) ) ).

tff(addAssignment_29349,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,41)
    <=> v52880(VarCurr,1) ) ).

tff(addAssignment_29348,axiom,
    ! [VarCurr: state_type] :
      ( v52880(VarCurr,1)
    <=> v52882(VarCurr,1) ) ).

tff(addAssignment_29347,axiom,
    ! [VarCurr: state_type] :
      ( v52882(VarCurr,1)
    <=> v52899(VarCurr,1) ) ).

tff(addAssignment_29346,axiom,
    ! [VarCurr: state_type] :
      ( v52892(VarCurr,1)
    <=> v52894(VarCurr,1) ) ).

tff(addAssignment_29345,axiom,
    ! [VarCurr: state_type] :
      ( v52894(VarCurr,1)
    <=> v6069(VarCurr,41) ) ).

tff(addAssignment_29344,axiom,
    ! [VarCurr: state_type] :
      ( v52884(VarCurr,1)
    <=> v52886(VarCurr,1) ) ).

tff(addAssignment_29343,axiom,
    ! [VarCurr: state_type] :
      ( v52886(VarCurr,1)
    <=> v6069(VarCurr,45) ) ).

tff(addAssignment_29342,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,45)
    <=> v6071(VarCurr,45) ) ).

tff(addAssignment_29341,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,45)
    <=> v6073(VarCurr,45) ) ).

tff(addAssignment_29340,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,45)
    <=> v52355(VarCurr,45) ) ).

tff(addAssignment_29339,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,45)
    <=> v6096(VarCurr,45) ) ).

tff(addAssignment_29338,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,45)
    <=> v6098(VarCurr,45) ) ).

tff(addAssignment_29337,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,45)
    <=> v6100(VarCurr,45) ) ).

tff(addAssignment_29336,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,45)
    <=> v6102(VarCurr,45) ) ).

tff(addAssignment_29335,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,45)
    <=> v6104(VarCurr,45) ) ).

tff(addAssignment_29334,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,45)
    <=> v6106(VarCurr,45) ) ).

tff(addAssignment_29333,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,45)
    <=> v52338(VarCurr,45) ) ).

tff(addAssignment_29332,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,45)
    <=> v52330(VarCurr,45) ) ).

tff(addAssignment_29331,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,45)
    <=> v52332(VarCurr,45) ) ).

tff(addAssignment_29330,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,45)
    <=> v52335(VarCurr,45) ) ).

tff(addAssignment_29329,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,87)
    <=> v33839(VarCurr,87) ) ).

tff(addAssignment_29328,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,87)
    <=> v33841(VarCurr,87) ) ).

tff(addAssignment_29327,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,87)
    <=> v20355(VarCurr,3) ) ).

tff(addAssignment_29326,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,45)
    <=> v6232(VarCurr,45) ) ).

tff(addAssignment_29325,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,45)
    <=> v6234(VarCurr,45) ) ).

tff(addAssignment_29324,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,45)
    <=> v52325(VarCurr,45) ) ).

tff(addAssignment_29323,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,93)
    <=> v6238(VarCurr,93) ) ).

tff(addAssignment_29322,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,93)
    <=> v6240(VarCurr,93) ) ).

tff(addAssignment_29321,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,93)
    <=> v41649(VarCurr,9) ) ).

tff(addAssignment_29320,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,45)
    <=> v6226(VarCurr,45) ) ).

tff(addAssignment_29319,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,45)
    <=> $false ) ).

tff(addAssignment_29318,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,45)
    <=> v6077(VarCurr,45) ) ).

tff(addAssignment_29317,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,45)
    <=> v6091(VarCurr,45) ) ).

tff(addAssignment_29316,axiom,
    ! [VarCurr: state_type] :
      ( v54199(VarCurr)
    <=> v54201(VarCurr) ) ).

tff(addAssignment_29315,axiom,
    ! [VarCurr: state_type] :
      ( v54201(VarCurr)
    <=> v6017(VarCurr,37) ) ).

tff(addAssignment_29314,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,37)
    <=> v6019(VarCurr,37) ) ).

tff(addAssignment_29313,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,37)
    <=> v6021(VarCurr,37) ) ).

tff(addAssignment_29312,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,37)
    <=> v6023(VarCurr,37) ) ).

tff(addAssignment_29311,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,37)
    <=> v6025(VarCurr,37) ) ).

tff(addAssignment_29310,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,37)
    <=> v6027(VarCurr,37) ) ).

tff(addAssignment_29309,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,37)
    <=> v52434(VarCurr,37) ) ).

tff(addAssignment_29308,axiom,
    ! [VarCurr: state_type] :
      ( v52457(VarCurr,1)
    <=> v6031(VarCurr,37) ) ).

tff(addAssignment_29307,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,37)
    <=> v6033(VarCurr,37) ) ).

tff(addAssignment_29306,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,37)
    <=> v54203(VarNext,37) ) ).

tff(addCaseBooleanConditionEqualRanges1_662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54204(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54203(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_662,axiom,
    ! [VarNext: state_type] :
      ( v54204(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54203(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54204(VarNext)
      <=> v54205(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54205(VarNext)
      <=> ( v54207(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54207(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29305,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,37)
    <=> v6057(VarCurr,37) ) ).

tff(addAssignment_29304,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,37)
    <=> v6059(VarCurr,37) ) ).

tff(addAssignment_29303,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,37)
    <=> v52840(VarCurr,1) ) ).

tff(addAssignment_29302,axiom,
    ! [VarCurr: state_type] :
      ( v52840(VarCurr,1)
    <=> v52842(VarCurr,1) ) ).

tff(addAssignment_29301,axiom,
    ! [VarCurr: state_type] :
      ( v52842(VarCurr,1)
    <=> v52859(VarCurr,1) ) ).

tff(addAssignment_29300,axiom,
    ! [VarCurr: state_type] :
      ( v52852(VarCurr,1)
    <=> v52854(VarCurr,1) ) ).

tff(addAssignment_29299,axiom,
    ! [VarCurr: state_type] :
      ( v52854(VarCurr,1)
    <=> v6069(VarCurr,37) ) ).

tff(addAssignment_29298,axiom,
    ! [VarCurr: state_type] :
      ( v52844(VarCurr,1)
    <=> v52846(VarCurr,1) ) ).

tff(addAssignment_29297,axiom,
    ! [VarCurr: state_type] :
      ( v52846(VarCurr,1)
    <=> v6069(VarCurr,41) ) ).

tff(addAssignment_29296,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,41)
    <=> v6071(VarCurr,41) ) ).

tff(addAssignment_29295,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,41)
    <=> v6073(VarCurr,41) ) ).

tff(addAssignment_29294,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,41)
    <=> v52355(VarCurr,41) ) ).

tff(addAssignment_29293,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,41)
    <=> v6096(VarCurr,41) ) ).

tff(addAssignment_29292,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,41)
    <=> v6098(VarCurr,41) ) ).

tff(addAssignment_29291,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,41)
    <=> v6100(VarCurr,41) ) ).

tff(addAssignment_29290,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,41)
    <=> v6102(VarCurr,41) ) ).

tff(addAssignment_29289,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,41)
    <=> v6104(VarCurr,41) ) ).

tff(addAssignment_29288,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,41)
    <=> v6106(VarCurr,41) ) ).

tff(addAssignment_29287,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,41)
    <=> v52338(VarCurr,41) ) ).

tff(addAssignment_29286,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,41)
    <=> v52330(VarCurr,41) ) ).

tff(addAssignment_29285,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,41)
    <=> v52332(VarCurr,41) ) ).

tff(addAssignment_29284,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,41)
    <=> v52335(VarCurr,41) ) ).

tff(addAssignment_29283,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,77)
    <=> v33839(VarCurr,77) ) ).

tff(addAssignment_29282,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,77)
    <=> v33841(VarCurr,77) ) ).

tff(addAssignment_29281,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,77)
    <=> v18805(VarCurr,5) ) ).

tff(addAssignment_29280,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,41)
    <=> v6232(VarCurr,41) ) ).

tff(addAssignment_29279,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,41)
    <=> v6234(VarCurr,41) ) ).

tff(addAssignment_29278,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,41)
    <=> v52325(VarCurr,41) ) ).

tff(addAssignment_29277,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,83)
    <=> v6238(VarCurr,83) ) ).

tff(addAssignment_29276,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,83)
    <=> v6240(VarCurr,83) ) ).

tff(addAssignment_29275,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,83)
    <=> v40099(VarCurr,11) ) ).

tff(addAssignment_29274,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,41)
    <=> v6226(VarCurr,41) ) ).

tff(addAssignment_29273,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,41)
    <=> $false ) ).

tff(addAssignment_29272,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,41)
    <=> v6077(VarCurr,41) ) ).

tff(addAssignment_29271,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,41)
    <=> v6091(VarCurr,41) ) ).

tff(addAssignment_29270,axiom,
    ! [VarCurr: state_type] :
      ( v54023(VarCurr)
    <=> v54025(VarCurr) ) ).

tff(addAssignment_29269,axiom,
    ! [VarCurr: state_type] :
      ( v54025(VarCurr)
    <=> v54027(VarCurr) ) ).

tff(addAssignment_29268,axiom,
    ! [VarCurr: state_type] :
      ( v54027(VarCurr)
    <=> v54029(VarCurr) ) ).

tff(addAssignment_29267,axiom,
    ! [VarCurr: state_type] :
      ( v54029(VarCurr)
    <=> v54031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5059,axiom,
    ! [VarCurr: state_type] :
      ( v54031(VarCurr)
    <=> ( v54177(VarCurr)
      <~> v54129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5058,axiom,
    ! [VarCurr: state_type] :
      ( v54177(VarCurr)
    <=> ( v54033(VarCurr)
      <~> v54081(VarCurr) ) ) ).

tff(addAssignment_29266,axiom,
    ! [VarCurr: state_type] :
      ( v54129(VarCurr)
    <=> v54131(VarCurr) ) ).

tff(addAssignment_29265,axiom,
    ! [VarCurr: state_type] :
      ( v54131(VarCurr)
    <=> v54133(VarCurr) ) ).

tff(addAssignment_29264,axiom,
    ! [VarCurr: state_type] :
      ( v54133(VarCurr)
    <=> v54135(VarCurr) ) ).

tff(addAssignment_29263,axiom,
    ! [VarCurr: state_type] :
      ( v54135(VarCurr)
    <=> v54137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5057,axiom,
    ! [VarCurr: state_type] :
      ( v54137(VarCurr)
    <=> ( v54175(VarCurr)
      <~> v54163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5056,axiom,
    ! [VarCurr: state_type] :
      ( v54175(VarCurr)
    <=> ( v54139(VarCurr)
      <~> v54151(VarCurr) ) ) ).

tff(addAssignment_29262,axiom,
    ! [VarCurr: state_type] :
      ( v54163(VarCurr)
    <=> v54165(VarCurr) ) ).

tff(addAssignment_29261,axiom,
    ! [VarCurr: state_type] :
      ( v54165(VarCurr)
    <=> v6017(VarCurr,33) ) ).

tff(addAssignment_29260,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,33)
    <=> v6019(VarCurr,33) ) ).

tff(addAssignment_29259,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,33)
    <=> v6021(VarCurr,33) ) ).

tff(addAssignment_29258,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,33)
    <=> v6023(VarCurr,33) ) ).

tff(addAssignment_29257,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,33)
    <=> v6025(VarCurr,33) ) ).

tff(addAssignment_29256,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,33)
    <=> v6027(VarCurr,33) ) ).

tff(addAssignment_29255,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,33)
    <=> v52434(VarCurr,33) ) ).

tff(addAssignment_29254,axiom,
    ! [VarCurr: state_type] :
      ( v52458(VarCurr,1)
    <=> v6031(VarCurr,33) ) ).

tff(addAssignment_29253,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,33)
    <=> v6033(VarCurr,33) ) ).

tff(addAssignment_29252,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,33)
    <=> v54167(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54168(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54167(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_661,axiom,
    ! [VarNext: state_type] :
      ( v54168(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54167(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54168(VarNext)
      <=> v54169(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5054,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54169(VarNext)
      <=> ( v54171(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54171(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29251,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,33)
    <=> v6057(VarCurr,33) ) ).

tff(addAssignment_29250,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,33)
    <=> v6059(VarCurr,33) ) ).

tff(addAssignment_29249,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,33)
    <=> v52776(VarCurr,1) ) ).

tff(addAssignment_29248,axiom,
    ! [VarCurr: state_type] :
      ( v52776(VarCurr,1)
    <=> v52778(VarCurr,1) ) ).

tff(addAssignment_29247,axiom,
    ! [VarCurr: state_type] :
      ( v52778(VarCurr,1)
    <=> v52795(VarCurr,1) ) ).

tff(addAssignment_29246,axiom,
    ! [VarCurr: state_type] :
      ( v52788(VarCurr,1)
    <=> v52790(VarCurr,1) ) ).

tff(addAssignment_29245,axiom,
    ! [VarCurr: state_type] :
      ( v52790(VarCurr,1)
    <=> v6069(VarCurr,33) ) ).

tff(addAssignment_29244,axiom,
    ! [VarCurr: state_type] :
      ( v52780(VarCurr,1)
    <=> v52782(VarCurr,1) ) ).

tff(addAssignment_29243,axiom,
    ! [VarCurr: state_type] :
      ( v52782(VarCurr,1)
    <=> v6069(VarCurr,37) ) ).

tff(addAssignment_29242,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,37)
    <=> v6071(VarCurr,37) ) ).

tff(addAssignment_29241,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,37)
    <=> v6073(VarCurr,37) ) ).

tff(addAssignment_29240,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,37)
    <=> v52355(VarCurr,37) ) ).

tff(addAssignment_29239,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,37)
    <=> v6096(VarCurr,37) ) ).

tff(addAssignment_29238,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,37)
    <=> v6098(VarCurr,37) ) ).

tff(addAssignment_29237,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,37)
    <=> v6100(VarCurr,37) ) ).

tff(addAssignment_29236,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,37)
    <=> v6102(VarCurr,37) ) ).

tff(addAssignment_29235,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,37)
    <=> v6104(VarCurr,37) ) ).

tff(addAssignment_29234,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,37)
    <=> v6106(VarCurr,37) ) ).

tff(addAssignment_29233,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,37)
    <=> v52338(VarCurr,37) ) ).

tff(addAssignment_29232,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,37)
    <=> v52330(VarCurr,37) ) ).

tff(addAssignment_29231,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,37)
    <=> v52332(VarCurr,37) ) ).

tff(addAssignment_29230,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,37)
    <=> v52335(VarCurr,37) ) ).

tff(addAssignment_29229,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,73)
    <=> v33839(VarCurr,73) ) ).

tff(addAssignment_29228,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,73)
    <=> v33841(VarCurr,73) ) ).

tff(addAssignment_29227,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,73)
    <=> v18805(VarCurr,1) ) ).

tff(addAssignment_29226,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,37)
    <=> v6232(VarCurr,37) ) ).

tff(addAssignment_29225,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,37)
    <=> v6234(VarCurr,37) ) ).

tff(addAssignment_29224,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,37)
    <=> v52325(VarCurr,37) ) ).

tff(addAssignment_29223,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,79)
    <=> v6238(VarCurr,79) ) ).

tff(addAssignment_29222,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,79)
    <=> v6240(VarCurr,79) ) ).

tff(addAssignment_29221,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,79)
    <=> v40099(VarCurr,7) ) ).

tff(addAssignment_29220,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,37)
    <=> v6226(VarCurr,37) ) ).

tff(addAssignment_29219,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,37)
    <=> $false ) ).

tff(addAssignment_29218,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,37)
    <=> v6077(VarCurr,37) ) ).

tff(addAssignment_29217,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,37)
    <=> v6091(VarCurr,37) ) ).

tff(addAssignment_29216,axiom,
    ! [VarCurr: state_type] :
      ( v54151(VarCurr)
    <=> v54153(VarCurr) ) ).

tff(addAssignment_29215,axiom,
    ! [VarCurr: state_type] :
      ( v54153(VarCurr)
    <=> v6017(VarCurr,29) ) ).

tff(addAssignment_29214,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,29)
    <=> v6019(VarCurr,29) ) ).

tff(addAssignment_29213,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,29)
    <=> v6021(VarCurr,29) ) ).

tff(addAssignment_29212,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,29)
    <=> v6023(VarCurr,29) ) ).

tff(addAssignment_29211,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,29)
    <=> v6025(VarCurr,29) ) ).

tff(addAssignment_29210,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,29)
    <=> v6027(VarCurr,29) ) ).

tff(addAssignment_29209,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,29)
    <=> v52434(VarCurr,29) ) ).

tff(addAssignment_29208,axiom,
    ! [VarCurr: state_type] :
      ( v52459(VarCurr,1)
    <=> v6031(VarCurr,29) ) ).

tff(addAssignment_29207,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,29)
    <=> v6033(VarCurr,29) ) ).

tff(addAssignment_29206,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,29)
    <=> v54155(VarNext,29) ) ).

tff(addCaseBooleanConditionEqualRanges1_660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54156(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54155(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_660,axiom,
    ! [VarNext: state_type] :
      ( v54156(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54155(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54156(VarNext)
      <=> v54157(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54157(VarNext)
      <=> ( v54159(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54159(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29205,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,29)
    <=> v6057(VarCurr,29) ) ).

tff(addAssignment_29204,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,29)
    <=> v6059(VarCurr,29) ) ).

tff(addAssignment_29203,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,29)
    <=> v52736(VarCurr,1) ) ).

tff(addAssignment_29202,axiom,
    ! [VarCurr: state_type] :
      ( v52736(VarCurr,1)
    <=> v52738(VarCurr,1) ) ).

tff(addAssignment_29201,axiom,
    ! [VarCurr: state_type] :
      ( v52738(VarCurr,1)
    <=> v52755(VarCurr,1) ) ).

tff(addAssignment_29200,axiom,
    ! [VarCurr: state_type] :
      ( v52748(VarCurr,1)
    <=> v52750(VarCurr,1) ) ).

tff(addAssignment_29199,axiom,
    ! [VarCurr: state_type] :
      ( v52750(VarCurr,1)
    <=> v6069(VarCurr,29) ) ).

tff(addAssignment_29198,axiom,
    ! [VarCurr: state_type] :
      ( v52740(VarCurr,1)
    <=> v52742(VarCurr,1) ) ).

tff(addAssignment_29197,axiom,
    ! [VarCurr: state_type] :
      ( v52742(VarCurr,1)
    <=> v6069(VarCurr,33) ) ).

tff(addAssignment_29196,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,33)
    <=> v6071(VarCurr,33) ) ).

tff(addAssignment_29195,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,33)
    <=> v6073(VarCurr,33) ) ).

tff(addAssignment_29194,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,33)
    <=> v52355(VarCurr,33) ) ).

tff(addAssignment_29193,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,33)
    <=> v6096(VarCurr,33) ) ).

tff(addAssignment_29192,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,33)
    <=> v6098(VarCurr,33) ) ).

tff(addAssignment_29191,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,33)
    <=> v6100(VarCurr,33) ) ).

tff(addAssignment_29190,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,33)
    <=> v6102(VarCurr,33) ) ).

tff(addAssignment_29189,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,33)
    <=> v6104(VarCurr,33) ) ).

tff(addAssignment_29188,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,33)
    <=> v6106(VarCurr,33) ) ).

tff(addAssignment_29187,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,33)
    <=> v52338(VarCurr,33) ) ).

tff(addAssignment_29186,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,33)
    <=> v52330(VarCurr,33) ) ).

tff(addAssignment_29185,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,33)
    <=> v52332(VarCurr,33) ) ).

tff(addAssignment_29184,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,33)
    <=> v52335(VarCurr,33) ) ).

tff(addAssignment_29183,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,63)
    <=> v33839(VarCurr,63) ) ).

tff(addAssignment_29182,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,63)
    <=> v33841(VarCurr,63) ) ).

tff(addAssignment_29181,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,63)
    <=> v17255(VarCurr,3) ) ).

tff(addAssignment_29180,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,33)
    <=> v6232(VarCurr,33) ) ).

tff(addAssignment_29179,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,33)
    <=> v6234(VarCurr,33) ) ).

tff(addAssignment_29178,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,33)
    <=> v52325(VarCurr,33) ) ).

tff(addAssignment_29177,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,69)
    <=> v6238(VarCurr,69) ) ).

tff(addAssignment_29176,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,69)
    <=> v6240(VarCurr,69) ) ).

tff(addAssignment_29175,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,69)
    <=> v38549(VarCurr,9) ) ).

tff(addAssignment_29174,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,33)
    <=> v6226(VarCurr,33) ) ).

tff(addAssignment_29173,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,33)
    <=> $false ) ).

tff(addAssignment_29172,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,33)
    <=> v6077(VarCurr,33) ) ).

tff(addAssignment_29171,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,33)
    <=> v6091(VarCurr,33) ) ).

tff(addAssignment_29170,axiom,
    ! [VarCurr: state_type] :
      ( v54139(VarCurr)
    <=> v54141(VarCurr) ) ).

tff(addAssignment_29169,axiom,
    ! [VarCurr: state_type] :
      ( v54141(VarCurr)
    <=> v6017(VarCurr,25) ) ).

tff(addAssignment_29168,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,25)
    <=> v6019(VarCurr,25) ) ).

tff(addAssignment_29167,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,25)
    <=> v6021(VarCurr,25) ) ).

tff(addAssignment_29166,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,25)
    <=> v6023(VarCurr,25) ) ).

tff(addAssignment_29165,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,25)
    <=> v6025(VarCurr,25) ) ).

tff(addAssignment_29164,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,25)
    <=> v6027(VarCurr,25) ) ).

tff(addAssignment_29163,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,25)
    <=> v52434(VarCurr,25) ) ).

tff(addAssignment_29162,axiom,
    ! [VarCurr: state_type] :
      ( v52460(VarCurr,1)
    <=> v6031(VarCurr,25) ) ).

tff(addAssignment_29161,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,25)
    <=> v6033(VarCurr,25) ) ).

tff(addAssignment_29160,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,25)
    <=> v54143(VarNext,25) ) ).

tff(addCaseBooleanConditionEqualRanges1_659,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54144(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54143(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_659,axiom,
    ! [VarNext: state_type] :
      ( v54144(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54143(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54144(VarNext)
      <=> v54145(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54145(VarNext)
      <=> ( v54147(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54147(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29159,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,25)
    <=> v6057(VarCurr,25) ) ).

tff(addAssignment_29158,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,25)
    <=> v6059(VarCurr,25) ) ).

tff(addAssignment_29157,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,25)
    <=> v52696(VarCurr,1) ) ).

tff(addAssignment_29156,axiom,
    ! [VarCurr: state_type] :
      ( v52696(VarCurr,1)
    <=> v52698(VarCurr,1) ) ).

tff(addAssignment_29155,axiom,
    ! [VarCurr: state_type] :
      ( v52698(VarCurr,1)
    <=> v52715(VarCurr,1) ) ).

tff(addAssignment_29154,axiom,
    ! [VarCurr: state_type] :
      ( v52708(VarCurr,1)
    <=> v52710(VarCurr,1) ) ).

tff(addAssignment_29153,axiom,
    ! [VarCurr: state_type] :
      ( v52710(VarCurr,1)
    <=> v6069(VarCurr,25) ) ).

tff(addAssignment_29152,axiom,
    ! [VarCurr: state_type] :
      ( v52700(VarCurr,1)
    <=> v52702(VarCurr,1) ) ).

tff(addAssignment_29151,axiom,
    ! [VarCurr: state_type] :
      ( v52702(VarCurr,1)
    <=> v6069(VarCurr,29) ) ).

tff(addAssignment_29150,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,29)
    <=> v6071(VarCurr,29) ) ).

tff(addAssignment_29149,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,29)
    <=> v6073(VarCurr,29) ) ).

tff(addAssignment_29148,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,29)
    <=> v52355(VarCurr,29) ) ).

tff(addAssignment_29147,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,29)
    <=> v6096(VarCurr,29) ) ).

tff(addAssignment_29146,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,29)
    <=> v6098(VarCurr,29) ) ).

tff(addAssignment_29145,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,29)
    <=> v6100(VarCurr,29) ) ).

tff(addAssignment_29144,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,29)
    <=> v6102(VarCurr,29) ) ).

tff(addAssignment_29143,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,29)
    <=> v6104(VarCurr,29) ) ).

tff(addAssignment_29142,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,29)
    <=> v6106(VarCurr,29) ) ).

tff(addAssignment_29141,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,29)
    <=> v52338(VarCurr,29) ) ).

tff(addAssignment_29140,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,29)
    <=> v52330(VarCurr,29) ) ).

tff(addAssignment_29139,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,29)
    <=> v52332(VarCurr,29) ) ).

tff(addAssignment_29138,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,29)
    <=> v52335(VarCurr,29) ) ).

tff(addAssignment_29137,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,53)
    <=> v33839(VarCurr,53) ) ).

tff(addAssignment_29136,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,53)
    <=> v33841(VarCurr,53) ) ).

tff(addAssignment_29135,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,53)
    <=> v15705(VarCurr,5) ) ).

tff(addAssignment_29134,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,29)
    <=> v6232(VarCurr,29) ) ).

tff(addAssignment_29133,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,29)
    <=> v6234(VarCurr,29) ) ).

tff(addAssignment_29132,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,29)
    <=> v52325(VarCurr,29) ) ).

tff(addAssignment_29131,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,59)
    <=> v6238(VarCurr,59) ) ).

tff(addAssignment_29130,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,59)
    <=> v6240(VarCurr,59) ) ).

tff(addAssignment_29129,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,59)
    <=> v36999(VarCurr,11) ) ).

tff(addAssignment_29128,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,29)
    <=> v6226(VarCurr,29) ) ).

tff(addAssignment_29127,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,29)
    <=> $false ) ).

tff(addAssignment_29126,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,29)
    <=> v6077(VarCurr,29) ) ).

tff(addAssignment_29125,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,29)
    <=> v6091(VarCurr,29) ) ).

tff(addAssignment_29124,axiom,
    ! [VarCurr: state_type] :
      ( v54081(VarCurr)
    <=> v54083(VarCurr) ) ).

tff(addAssignment_29123,axiom,
    ! [VarCurr: state_type] :
      ( v54083(VarCurr)
    <=> v54085(VarCurr) ) ).

tff(addAssignment_29122,axiom,
    ! [VarCurr: state_type] :
      ( v54085(VarCurr)
    <=> v54087(VarCurr) ) ).

tff(addAssignment_29121,axiom,
    ! [VarCurr: state_type] :
      ( v54087(VarCurr)
    <=> v54089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5049,axiom,
    ! [VarCurr: state_type] :
      ( v54089(VarCurr)
    <=> ( v54127(VarCurr)
      <~> v54115(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5048,axiom,
    ! [VarCurr: state_type] :
      ( v54127(VarCurr)
    <=> ( v54091(VarCurr)
      <~> v54103(VarCurr) ) ) ).

tff(addAssignment_29120,axiom,
    ! [VarCurr: state_type] :
      ( v54115(VarCurr)
    <=> v54117(VarCurr) ) ).

tff(addAssignment_29119,axiom,
    ! [VarCurr: state_type] :
      ( v54117(VarCurr)
    <=> v6017(VarCurr,21) ) ).

tff(addAssignment_29118,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,21)
    <=> v6019(VarCurr,21) ) ).

tff(addAssignment_29117,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,21)
    <=> v6021(VarCurr,21) ) ).

tff(addAssignment_29116,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,21)
    <=> v6023(VarCurr,21) ) ).

tff(addAssignment_29115,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,21)
    <=> v6025(VarCurr,21) ) ).

tff(addAssignment_29114,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,21)
    <=> v6027(VarCurr,21) ) ).

tff(addAssignment_29113,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,21)
    <=> v52434(VarCurr,21) ) ).

tff(addAssignment_29112,axiom,
    ! [VarCurr: state_type] :
      ( v52461(VarCurr,1)
    <=> v6031(VarCurr,21) ) ).

tff(addAssignment_29111,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,21)
    <=> v6033(VarCurr,21) ) ).

tff(addAssignment_29110,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,21)
    <=> v54119(VarNext,21) ) ).

tff(addCaseBooleanConditionEqualRanges1_658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54120(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54119(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_658,axiom,
    ! [VarNext: state_type] :
      ( v54120(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54119(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54120(VarNext)
      <=> v54121(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54121(VarNext)
      <=> ( v54123(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54123(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29109,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,21)
    <=> v6057(VarCurr,21) ) ).

tff(addAssignment_29108,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,21)
    <=> v6059(VarCurr,21) ) ).

tff(addAssignment_29107,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,21)
    <=> v52644(VarCurr,1) ) ).

tff(addAssignment_29106,axiom,
    ! [VarCurr: state_type] :
      ( v52644(VarCurr,1)
    <=> v52646(VarCurr,1) ) ).

tff(addAssignment_29105,axiom,
    ! [VarCurr: state_type] :
      ( v52646(VarCurr,1)
    <=> v52663(VarCurr,1) ) ).

tff(addAssignment_29104,axiom,
    ! [VarCurr: state_type] :
      ( v52656(VarCurr,1)
    <=> v52658(VarCurr,1) ) ).

tff(addAssignment_29103,axiom,
    ! [VarCurr: state_type] :
      ( v52658(VarCurr,1)
    <=> v6069(VarCurr,21) ) ).

tff(addAssignment_29102,axiom,
    ! [VarCurr: state_type] :
      ( v52648(VarCurr,1)
    <=> v52650(VarCurr,1) ) ).

tff(addAssignment_29101,axiom,
    ! [VarCurr: state_type] :
      ( v52650(VarCurr,1)
    <=> v6069(VarCurr,25) ) ).

tff(addAssignment_29100,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,25)
    <=> v6071(VarCurr,25) ) ).

tff(addAssignment_29099,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,25)
    <=> v6073(VarCurr,25) ) ).

tff(addAssignment_29098,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,25)
    <=> v52355(VarCurr,25) ) ).

tff(addAssignment_29097,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,25)
    <=> v6096(VarCurr,25) ) ).

tff(addAssignment_29096,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,25)
    <=> v6098(VarCurr,25) ) ).

tff(addAssignment_29095,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,25)
    <=> v6100(VarCurr,25) ) ).

tff(addAssignment_29094,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,25)
    <=> v6102(VarCurr,25) ) ).

tff(addAssignment_29093,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,25)
    <=> v6104(VarCurr,25) ) ).

tff(addAssignment_29092,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,25)
    <=> v6106(VarCurr,25) ) ).

tff(addAssignment_29091,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,25)
    <=> v52338(VarCurr,25) ) ).

tff(addAssignment_29090,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,25)
    <=> v52330(VarCurr,25) ) ).

tff(addAssignment_29089,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,25)
    <=> v52332(VarCurr,25) ) ).

tff(addAssignment_29088,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,25)
    <=> v52335(VarCurr,25) ) ).

tff(addAssignment_29087,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,49)
    <=> v33839(VarCurr,49) ) ).

tff(addAssignment_29086,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,49)
    <=> v33841(VarCurr,49) ) ).

tff(addAssignment_29085,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,49)
    <=> v15705(VarCurr,1) ) ).

tff(addAssignment_29084,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,25)
    <=> v6232(VarCurr,25) ) ).

tff(addAssignment_29083,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,25)
    <=> v6234(VarCurr,25) ) ).

tff(addAssignment_29082,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,25)
    <=> v52325(VarCurr,25) ) ).

tff(addAssignment_29081,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,55)
    <=> v6238(VarCurr,55) ) ).

tff(addAssignment_29080,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,55)
    <=> v6240(VarCurr,55) ) ).

tff(addAssignment_29079,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,55)
    <=> v36999(VarCurr,7) ) ).

tff(addAssignment_29078,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,25)
    <=> v6226(VarCurr,25) ) ).

tff(addAssignment_29077,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,25)
    <=> $false ) ).

tff(addAssignment_29076,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,25)
    <=> v6077(VarCurr,25) ) ).

tff(addAssignment_29075,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,25)
    <=> v6091(VarCurr,25) ) ).

tff(addAssignment_29074,axiom,
    ! [VarCurr: state_type] :
      ( v54103(VarCurr)
    <=> v54105(VarCurr) ) ).

tff(addAssignment_29073,axiom,
    ! [VarCurr: state_type] :
      ( v54105(VarCurr)
    <=> v6017(VarCurr,17) ) ).

tff(addAssignment_29072,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,17)
    <=> v6019(VarCurr,17) ) ).

tff(addAssignment_29071,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,17)
    <=> v6021(VarCurr,17) ) ).

tff(addAssignment_29070,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,17)
    <=> v6023(VarCurr,17) ) ).

tff(addAssignment_29069,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,17)
    <=> v6025(VarCurr,17) ) ).

tff(addAssignment_29068,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,17)
    <=> v6027(VarCurr,17) ) ).

tff(addAssignment_29067,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,17)
    <=> v52434(VarCurr,17) ) ).

tff(addAssignment_29066,axiom,
    ! [VarCurr: state_type] :
      ( v52462(VarCurr,1)
    <=> v6031(VarCurr,17) ) ).

tff(addAssignment_29065,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,17)
    <=> v6033(VarCurr,17) ) ).

tff(addAssignment_29064,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,17)
    <=> v54107(VarNext,17) ) ).

tff(addCaseBooleanConditionEqualRanges1_657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54108(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54107(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_657,axiom,
    ! [VarNext: state_type] :
      ( v54108(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54107(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54108(VarNext)
      <=> v54109(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54109(VarNext)
      <=> ( v54111(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54111(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29063,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,17)
    <=> v6057(VarCurr,17) ) ).

tff(addAssignment_29062,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,17)
    <=> v6059(VarCurr,17) ) ).

tff(addAssignment_29061,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,17)
    <=> v52604(VarCurr,1) ) ).

tff(addAssignment_29060,axiom,
    ! [VarCurr: state_type] :
      ( v52604(VarCurr,1)
    <=> v52606(VarCurr,1) ) ).

tff(addAssignment_29059,axiom,
    ! [VarCurr: state_type] :
      ( v52606(VarCurr,1)
    <=> v52623(VarCurr,1) ) ).

tff(addAssignment_29058,axiom,
    ! [VarCurr: state_type] :
      ( v52616(VarCurr,1)
    <=> v52618(VarCurr,1) ) ).

tff(addAssignment_29057,axiom,
    ! [VarCurr: state_type] :
      ( v52618(VarCurr,1)
    <=> v6069(VarCurr,17) ) ).

tff(addAssignment_29056,axiom,
    ! [VarCurr: state_type] :
      ( v52608(VarCurr,1)
    <=> v52610(VarCurr,1) ) ).

tff(addAssignment_29055,axiom,
    ! [VarCurr: state_type] :
      ( v52610(VarCurr,1)
    <=> v6069(VarCurr,21) ) ).

tff(addAssignment_29054,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,21)
    <=> v6071(VarCurr,21) ) ).

tff(addAssignment_29053,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,21)
    <=> v6073(VarCurr,21) ) ).

tff(addAssignment_29052,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,21)
    <=> v52355(VarCurr,21) ) ).

tff(addAssignment_29051,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,21)
    <=> v6096(VarCurr,21) ) ).

tff(addAssignment_29050,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,21)
    <=> v6098(VarCurr,21) ) ).

tff(addAssignment_29049,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,21)
    <=> v6100(VarCurr,21) ) ).

tff(addAssignment_29048,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,21)
    <=> v6102(VarCurr,21) ) ).

tff(addAssignment_29047,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,21)
    <=> v6104(VarCurr,21) ) ).

tff(addAssignment_29046,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,21)
    <=> v6106(VarCurr,21) ) ).

tff(addAssignment_29045,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,21)
    <=> v52338(VarCurr,21) ) ).

tff(addAssignment_29044,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,21)
    <=> v52330(VarCurr,21) ) ).

tff(addAssignment_29043,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,21)
    <=> v52332(VarCurr,21) ) ).

tff(addAssignment_29042,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,21)
    <=> v52335(VarCurr,21) ) ).

tff(addAssignment_29041,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,39)
    <=> v33839(VarCurr,39) ) ).

tff(addAssignment_29040,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,39)
    <=> v33841(VarCurr,39) ) ).

tff(addAssignment_29039,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,39)
    <=> v14155(VarCurr,3) ) ).

tff(addAssignment_29038,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,21)
    <=> v6232(VarCurr,21) ) ).

tff(addAssignment_29037,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,21)
    <=> v6234(VarCurr,21) ) ).

tff(addAssignment_29036,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,21)
    <=> v52325(VarCurr,21) ) ).

tff(addAssignment_29035,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,45)
    <=> v6238(VarCurr,45) ) ).

tff(addAssignment_29034,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,45)
    <=> v6240(VarCurr,45) ) ).

tff(addAssignment_29033,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,45)
    <=> v35449(VarCurr,9) ) ).

tff(addAssignment_29032,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,21)
    <=> v6226(VarCurr,21) ) ).

tff(addAssignment_29031,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,21)
    <=> $false ) ).

tff(addAssignment_29030,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,21)
    <=> v6077(VarCurr,21) ) ).

tff(addAssignment_29029,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,21)
    <=> v6091(VarCurr,21) ) ).

tff(addAssignment_29028,axiom,
    ! [VarCurr: state_type] :
      ( v54091(VarCurr)
    <=> v54093(VarCurr) ) ).

tff(addAssignment_29027,axiom,
    ! [VarCurr: state_type] :
      ( v54093(VarCurr)
    <=> v6017(VarCurr,13) ) ).

tff(addAssignment_29026,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,13)
    <=> v6019(VarCurr,13) ) ).

tff(addAssignment_29025,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,13)
    <=> v6021(VarCurr,13) ) ).

tff(addAssignment_29024,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,13)
    <=> v6023(VarCurr,13) ) ).

tff(addAssignment_29023,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,13)
    <=> v6025(VarCurr,13) ) ).

tff(addAssignment_29022,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,13)
    <=> v6027(VarCurr,13) ) ).

tff(addAssignment_29021,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,13)
    <=> v52434(VarCurr,13) ) ).

tff(addAssignment_29020,axiom,
    ! [VarCurr: state_type] :
      ( v52463(VarCurr,1)
    <=> v6031(VarCurr,13) ) ).

tff(addAssignment_29019,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,13)
    <=> v6033(VarCurr,13) ) ).

tff(addAssignment_29018,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,13)
    <=> v54095(VarNext,13) ) ).

tff(addCaseBooleanConditionEqualRanges1_656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54096(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54095(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_656,axiom,
    ! [VarNext: state_type] :
      ( v54096(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54095(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54096(VarNext)
      <=> v54097(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54097(VarNext)
      <=> ( v54099(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54099(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_29017,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,13)
    <=> v6057(VarCurr,13) ) ).

tff(addAssignment_29016,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,13)
    <=> v6059(VarCurr,13) ) ).

tff(addAssignment_29015,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,13)
    <=> v52564(VarCurr,1) ) ).

tff(addAssignment_29014,axiom,
    ! [VarCurr: state_type] :
      ( v52564(VarCurr,1)
    <=> v52566(VarCurr,1) ) ).

tff(addAssignment_29013,axiom,
    ! [VarCurr: state_type] :
      ( v52566(VarCurr,1)
    <=> v52583(VarCurr,1) ) ).

tff(addAssignment_29012,axiom,
    ! [VarCurr: state_type] :
      ( v52576(VarCurr,1)
    <=> v52578(VarCurr,1) ) ).

tff(addAssignment_29011,axiom,
    ! [VarCurr: state_type] :
      ( v52578(VarCurr,1)
    <=> v6069(VarCurr,13) ) ).

tff(addAssignment_29010,axiom,
    ! [VarCurr: state_type] :
      ( v52568(VarCurr,1)
    <=> v52570(VarCurr,1) ) ).

tff(addAssignment_29009,axiom,
    ! [VarCurr: state_type] :
      ( v52570(VarCurr,1)
    <=> v6069(VarCurr,17) ) ).

tff(addAssignment_29008,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,17)
    <=> v6071(VarCurr,17) ) ).

tff(addAssignment_29007,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,17)
    <=> v6073(VarCurr,17) ) ).

tff(addAssignment_29006,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,17)
    <=> v52355(VarCurr,17) ) ).

tff(addAssignment_29005,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,17)
    <=> v6096(VarCurr,17) ) ).

tff(addAssignment_29004,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,17)
    <=> v6098(VarCurr,17) ) ).

tff(addAssignment_29003,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,17)
    <=> v6100(VarCurr,17) ) ).

tff(addAssignment_29002,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,17)
    <=> v6102(VarCurr,17) ) ).

tff(addAssignment_29001,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,17)
    <=> v6104(VarCurr,17) ) ).

tff(addAssignment_29000,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,17)
    <=> v6106(VarCurr,17) ) ).

tff(addAssignment_28999,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,17)
    <=> v52338(VarCurr,17) ) ).

tff(addAssignment_28998,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,17)
    <=> v52330(VarCurr,17) ) ).

tff(addAssignment_28997,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,17)
    <=> v52332(VarCurr,17) ) ).

tff(addAssignment_28996,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,17)
    <=> v52335(VarCurr,17) ) ).

tff(addAssignment_28995,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,29)
    <=> v33839(VarCurr,29) ) ).

tff(addAssignment_28994,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,17)
    <=> v6232(VarCurr,17) ) ).

tff(addAssignment_28993,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,17)
    <=> v6234(VarCurr,17) ) ).

tff(addAssignment_28992,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,17)
    <=> v52325(VarCurr,17) ) ).

tff(addAssignment_28991,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,35)
    <=> v6238(VarCurr,35) ) ).

tff(addAssignment_28990,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,17)
    <=> v6226(VarCurr,17) ) ).

tff(addAssignment_28989,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,17)
    <=> $false ) ).

tff(addAssignment_28988,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,17)
    <=> v6077(VarCurr,17) ) ).

tff(addAssignment_28987,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,17)
    <=> v6091(VarCurr,17) ) ).

tff(addAssignment_28986,axiom,
    ! [VarCurr: state_type] :
      ( v54033(VarCurr)
    <=> v54035(VarCurr) ) ).

tff(addAssignment_28985,axiom,
    ! [VarCurr: state_type] :
      ( v54035(VarCurr)
    <=> v54037(VarCurr) ) ).

tff(addAssignment_28984,axiom,
    ! [VarCurr: state_type] :
      ( v54037(VarCurr)
    <=> v54039(VarCurr) ) ).

tff(addAssignment_28983,axiom,
    ! [VarCurr: state_type] :
      ( v54039(VarCurr)
    <=> v54041(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5041,axiom,
    ! [VarCurr: state_type] :
      ( v54041(VarCurr)
    <=> ( v54079(VarCurr)
      <~> v54067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5040,axiom,
    ! [VarCurr: state_type] :
      ( v54079(VarCurr)
    <=> ( v54043(VarCurr)
      <~> v54055(VarCurr) ) ) ).

tff(addAssignment_28982,axiom,
    ! [VarCurr: state_type] :
      ( v54067(VarCurr)
    <=> v54069(VarCurr) ) ).

tff(addAssignment_28981,axiom,
    ! [VarCurr: state_type] :
      ( v54069(VarCurr)
    <=> v6017(VarCurr,9) ) ).

tff(addAssignment_28980,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,9)
    <=> v6019(VarCurr,9) ) ).

tff(addAssignment_28979,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,9)
    <=> v6021(VarCurr,9) ) ).

tff(addAssignment_28978,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,9)
    <=> v6023(VarCurr,9) ) ).

tff(addAssignment_28977,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,9)
    <=> v6025(VarCurr,9) ) ).

tff(addAssignment_28976,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,9)
    <=> v6027(VarCurr,9) ) ).

tff(addAssignment_28975,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,9)
    <=> v52434(VarCurr,9) ) ).

tff(addAssignment_28974,axiom,
    ! [VarCurr: state_type] :
      ( v52464(VarCurr,1)
    <=> v6031(VarCurr,9) ) ).

tff(addAssignment_28973,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,9)
    <=> v6033(VarCurr,9) ) ).

tff(addAssignment_28972,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,9)
    <=> v54071(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54072(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54071(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_655,axiom,
    ! [VarNext: state_type] :
      ( v54072(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54071(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54072(VarNext)
      <=> v54073(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54073(VarNext)
      <=> ( v54075(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3031,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54075(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28971,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,9)
    <=> v6057(VarCurr,9) ) ).

tff(addAssignment_28970,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,9)
    <=> v6059(VarCurr,9) ) ).

tff(addAssignment_28969,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,9)
    <=> v52512(VarCurr,1) ) ).

tff(addAssignment_28968,axiom,
    ! [VarCurr: state_type] :
      ( v52512(VarCurr,1)
    <=> v52514(VarCurr,1) ) ).

tff(addAssignment_28967,axiom,
    ! [VarCurr: state_type] :
      ( v52514(VarCurr,1)
    <=> v52531(VarCurr,1) ) ).

tff(addAssignment_28966,axiom,
    ! [VarCurr: state_type] :
      ( v52524(VarCurr,1)
    <=> v52526(VarCurr,1) ) ).

tff(addAssignment_28965,axiom,
    ! [VarCurr: state_type] :
      ( v52526(VarCurr,1)
    <=> v6069(VarCurr,9) ) ).

tff(addAssignment_28964,axiom,
    ! [VarCurr: state_type] :
      ( v52516(VarCurr,1)
    <=> v52518(VarCurr,1) ) ).

tff(addAssignment_28963,axiom,
    ! [VarCurr: state_type] :
      ( v52518(VarCurr,1)
    <=> v6069(VarCurr,13) ) ).

tff(addAssignment_28962,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,13)
    <=> v6071(VarCurr,13) ) ).

tff(addAssignment_28961,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,13)
    <=> v6073(VarCurr,13) ) ).

tff(addAssignment_28960,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,13)
    <=> v52355(VarCurr,13) ) ).

tff(addAssignment_28959,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,13)
    <=> v6096(VarCurr,13) ) ).

tff(addAssignment_28958,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,13)
    <=> v6098(VarCurr,13) ) ).

tff(addAssignment_28957,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,13)
    <=> v6100(VarCurr,13) ) ).

tff(addAssignment_28956,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,13)
    <=> v6102(VarCurr,13) ) ).

tff(addAssignment_28955,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,13)
    <=> v6104(VarCurr,13) ) ).

tff(addAssignment_28954,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,13)
    <=> v6106(VarCurr,13) ) ).

tff(addAssignment_28953,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,13)
    <=> v52338(VarCurr,13) ) ).

tff(addAssignment_28952,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,13)
    <=> v52330(VarCurr,13) ) ).

tff(addAssignment_28951,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,13)
    <=> v52332(VarCurr,13) ) ).

tff(addAssignment_28950,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,13)
    <=> v52335(VarCurr,13) ) ).

tff(addAssignment_28949,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,25)
    <=> v33839(VarCurr,25) ) ).

tff(addAssignment_28948,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,13)
    <=> v6232(VarCurr,13) ) ).

tff(addAssignment_28947,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,13)
    <=> v6234(VarCurr,13) ) ).

tff(addAssignment_28946,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,13)
    <=> v52325(VarCurr,13) ) ).

tff(addAssignment_28945,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,31)
    <=> v6238(VarCurr,31) ) ).

tff(addAssignment_28944,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,13)
    <=> v6226(VarCurr,13) ) ).

tff(addAssignment_28943,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,13)
    <=> $false ) ).

tff(addAssignment_28942,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,13)
    <=> v6077(VarCurr,13) ) ).

tff(addAssignment_28941,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,13)
    <=> v6091(VarCurr,13) ) ).

tff(addAssignment_28940,axiom,
    ! [VarCurr: state_type] :
      ( v54055(VarCurr)
    <=> v54057(VarCurr) ) ).

tff(addAssignment_28939,axiom,
    ! [VarCurr: state_type] :
      ( v54057(VarCurr)
    <=> v6017(VarCurr,5) ) ).

tff(addAssignment_28938,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,5)
    <=> v6019(VarCurr,5) ) ).

tff(addAssignment_28937,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,5)
    <=> v6021(VarCurr,5) ) ).

tff(addAssignment_28936,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,5)
    <=> v6023(VarCurr,5) ) ).

tff(addAssignment_28935,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,5)
    <=> v6025(VarCurr,5) ) ).

tff(addAssignment_28934,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,5)
    <=> v6027(VarCurr,5) ) ).

tff(addAssignment_28933,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,5)
    <=> v52434(VarCurr,5) ) ).

tff(addAssignment_28932,axiom,
    ! [VarCurr: state_type] :
      ( v52465(VarCurr,1)
    <=> v6031(VarCurr,5) ) ).

tff(addAssignment_28931,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,5)
    <=> v6033(VarCurr,5) ) ).

tff(addAssignment_28930,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,5)
    <=> v54059(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54060(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54059(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_654,axiom,
    ! [VarNext: state_type] :
      ( v54060(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54059(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54060(VarNext)
      <=> v54061(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54061(VarNext)
      <=> ( v54063(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54063(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28929,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,5)
    <=> v6057(VarCurr,5) ) ).

tff(addAssignment_28928,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,5)
    <=> v6059(VarCurr,5) ) ).

tff(addAssignment_28927,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,5)
    <=> v52472(VarCurr,1) ) ).

tff(addAssignment_28926,axiom,
    ! [VarCurr: state_type] :
      ( v52472(VarCurr,1)
    <=> v52474(VarCurr,1) ) ).

tff(addAssignment_28925,axiom,
    ! [VarCurr: state_type] :
      ( v52474(VarCurr,1)
    <=> v52491(VarCurr,1) ) ).

tff(addAssignment_28924,axiom,
    ! [VarCurr: state_type] :
      ( v52484(VarCurr,1)
    <=> v52486(VarCurr,1) ) ).

tff(addAssignment_28923,axiom,
    ! [VarCurr: state_type] :
      ( v52486(VarCurr,1)
    <=> v6069(VarCurr,5) ) ).

tff(addAssignment_28922,axiom,
    ! [VarCurr: state_type] :
      ( v52476(VarCurr,1)
    <=> v52478(VarCurr,1) ) ).

tff(addAssignment_28921,axiom,
    ! [VarCurr: state_type] :
      ( v52478(VarCurr,1)
    <=> v6069(VarCurr,9) ) ).

tff(addAssignment_28920,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,9)
    <=> v6071(VarCurr,9) ) ).

tff(addAssignment_28919,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,9)
    <=> v6073(VarCurr,9) ) ).

tff(addAssignment_28918,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,9)
    <=> v52355(VarCurr,9) ) ).

tff(addAssignment_28917,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,9)
    <=> v6096(VarCurr,9) ) ).

tff(addAssignment_28916,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,9)
    <=> v6098(VarCurr,9) ) ).

tff(addAssignment_28915,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,9)
    <=> v6100(VarCurr,9) ) ).

tff(addAssignment_28914,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,9)
    <=> v6102(VarCurr,9) ) ).

tff(addAssignment_28913,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,9)
    <=> v6104(VarCurr,9) ) ).

tff(addAssignment_28912,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,9)
    <=> v6106(VarCurr,9) ) ).

tff(addAssignment_28911,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,9)
    <=> v52338(VarCurr,9) ) ).

tff(addAssignment_28910,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,9)
    <=> v52330(VarCurr,9) ) ).

tff(addAssignment_28909,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,9)
    <=> v52332(VarCurr,9) ) ).

tff(addAssignment_28908,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,9)
    <=> v52335(VarCurr,9) ) ).

tff(addAssignment_28907,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,15)
    <=> v33839(VarCurr,15) ) ).

tff(addAssignment_28906,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,9)
    <=> v6232(VarCurr,9) ) ).

tff(addAssignment_28905,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,9)
    <=> v6234(VarCurr,9) ) ).

tff(addAssignment_28904,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,9)
    <=> v52325(VarCurr,9) ) ).

tff(addAssignment_28903,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,21)
    <=> v6238(VarCurr,21) ) ).

tff(addAssignment_28902,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,9)
    <=> v6226(VarCurr,9) ) ).

tff(addAssignment_28901,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,9)
    <=> $false ) ).

tff(addAssignment_28900,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,9)
    <=> v6077(VarCurr,9) ) ).

tff(addAssignment_28899,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,9)
    <=> v6091(VarCurr,9) ) ).

tff(addAssignment_28898,axiom,
    ! [VarCurr: state_type] :
      ( v54043(VarCurr)
    <=> v54045(VarCurr) ) ).

tff(addAssignment_28897,axiom,
    ! [VarCurr: state_type] :
      ( v54045(VarCurr)
    <=> v6017(VarCurr,1) ) ).

tff(addAssignment_28896,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,1)
    <=> v6019(VarCurr,1) ) ).

tff(addAssignment_28895,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,1)
    <=> v6021(VarCurr,1) ) ).

tff(addAssignment_28894,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,1)
    <=> v6023(VarCurr,1) ) ).

tff(addAssignment_28893,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,1)
    <=> v6025(VarCurr,1) ) ).

tff(addAssignment_28892,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,1)
    <=> v6027(VarCurr,1) ) ).

tff(addAssignment_28891,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,1)
    <=> v52434(VarCurr,1) ) ).

tff(addAssignment_28890,axiom,
    ! [VarCurr: state_type] :
      ( v6029(VarCurr,1)
    <=> v6031(VarCurr,1) ) ).

tff(addAssignment_28889,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,1)
    <=> v6033(VarCurr,1) ) ).

tff(addAssignment_28888,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,1)
    <=> v54047(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54048(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v54047(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_653,axiom,
    ! [VarNext: state_type] :
      ( v54048(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v54047(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54048(VarNext)
      <=> v54049(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v54049(VarNext)
      <=> ( v54051(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v54051(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28887,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,1)
    <=> v6057(VarCurr,1) ) ).

tff(addAssignment_28886,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,1)
    <=> v6059(VarCurr,1) ) ).

tff(addAssignment_28885,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,1)
    <=> v6061(VarCurr,1) ) ).

tff(addAssignment_28884,axiom,
    ! [VarCurr: state_type] :
      ( v6061(VarCurr,1)
    <=> v6063(VarCurr,1) ) ).

tff(addAssignment_28883,axiom,
    ! [VarCurr: state_type] :
      ( v6063(VarCurr,1)
    <=> v52385(VarCurr,1) ) ).

tff(addAssignment_28882,axiom,
    ! [VarCurr: state_type] :
      ( v52371(VarCurr,1)
    <=> v52373(VarCurr,1) ) ).

tff(addAssignment_28881,axiom,
    ! [VarCurr: state_type] :
      ( v52373(VarCurr,1)
    <=> v6069(VarCurr,1) ) ).

tff(addAssignment_28880,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,1)
    <=> v6071(VarCurr,1) ) ).

tff(addAssignment_28879,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,1)
    <=> v6073(VarCurr,1) ) ).

tff(addAssignment_28878,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,1)
    <=> v52355(VarCurr,1) ) ).

tff(addAssignment_28877,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,1)
    <=> v6096(VarCurr,1) ) ).

tff(addAssignment_28876,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,1)
    <=> v6098(VarCurr,1) ) ).

tff(addAssignment_28875,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,1)
    <=> v6100(VarCurr,1) ) ).

tff(addAssignment_28874,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,1)
    <=> v6102(VarCurr,1) ) ).

tff(addAssignment_28873,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,1)
    <=> v6104(VarCurr,1) ) ).

tff(addAssignment_28872,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,1)
    <=> v6106(VarCurr,1) ) ).

tff(addAssignment_28871,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,1)
    <=> v52338(VarCurr,1) ) ).

tff(addAssignment_28870,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,1)
    <=> v52330(VarCurr,1) ) ).

tff(addAssignment_28869,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,1)
    <=> v52332(VarCurr,1) ) ).

tff(addAssignment_28868,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,1)
    <=> v52335(VarCurr,1) ) ).

tff(addAssignment_28867,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,1)
    <=> v33839(VarCurr,1) ) ).

tff(addAssignment_28866,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,1)
    <=> v6232(VarCurr,1) ) ).

tff(addAssignment_28865,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,1)
    <=> v6234(VarCurr,1) ) ).

tff(addAssignment_28864,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,1)
    <=> v52325(VarCurr,1) ) ).

tff(addAssignment_28863,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,7)
    <=> v6238(VarCurr,7) ) ).

tff(addAssignment_28862,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,1)
    <=> v6226(VarCurr,1) ) ).

tff(addAssignment_28861,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,1)
    <=> $false ) ).

tff(addAssignment_28860,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,1)
    <=> v6077(VarCurr,1) ) ).

tff(addAssignment_28859,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,1)
    <=> v6091(VarCurr,1) ) ).

tff(addAssignment_28858,axiom,
    ! [VarCurr: state_type] :
      ( v6065(VarCurr,1)
    <=> v6067(VarCurr,1) ) ).

tff(addAssignment_28857,axiom,
    ! [VarCurr: state_type] :
      ( v6067(VarCurr,1)
    <=> v6069(VarCurr,5) ) ).

tff(addAssignment_28856,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,5)
    <=> v6071(VarCurr,5) ) ).

tff(addAssignment_28855,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,5)
    <=> v6073(VarCurr,5) ) ).

tff(addAssignment_28854,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,5)
    <=> v52355(VarCurr,5) ) ).

tff(addAssignment_28853,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,5)
    <=> v6096(VarCurr,5) ) ).

tff(addAssignment_28852,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,5)
    <=> v6098(VarCurr,5) ) ).

tff(addAssignment_28851,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,5)
    <=> v6100(VarCurr,5) ) ).

tff(addAssignment_28850,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,5)
    <=> v6102(VarCurr,5) ) ).

tff(addAssignment_28849,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,5)
    <=> v6104(VarCurr,5) ) ).

tff(addAssignment_28848,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,5)
    <=> v6106(VarCurr,5) ) ).

tff(addAssignment_28847,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,5)
    <=> v52338(VarCurr,5) ) ).

tff(addAssignment_28846,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,5)
    <=> v52330(VarCurr,5) ) ).

tff(addAssignment_28845,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,5)
    <=> v52332(VarCurr,5) ) ).

tff(addAssignment_28844,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,5)
    <=> v52335(VarCurr,5) ) ).

tff(addAssignment_28843,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,5)
    <=> v33839(VarCurr,5) ) ).

tff(addAssignment_28842,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,5)
    <=> v6232(VarCurr,5) ) ).

tff(addAssignment_28841,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,5)
    <=> v6234(VarCurr,5) ) ).

tff(addAssignment_28840,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,5)
    <=> v52325(VarCurr,5) ) ).

tff(addAssignment_28839,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,11)
    <=> v6238(VarCurr,11) ) ).

tff(addAssignment_28838,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,5)
    <=> v6226(VarCurr,5) ) ).

tff(addAssignment_28837,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,5)
    <=> $false ) ).

tff(addAssignment_28836,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,5)
    <=> v6077(VarCurr,5) ) ).

tff(addAssignment_28835,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,5)
    <=> v6091(VarCurr,5) ) ).

tff(addAssignment_28834,axiom,
    ! [VarCurr: state_type] :
      ( v5961(VarCurr)
    <=> v5963(VarCurr) ) ).

tff(addAssignment_28833,axiom,
    ! [VarCurr: state_type] :
      ( v5963(VarCurr)
    <=> v5965(VarCurr) ) ).

tff(addAssignment_28832,axiom,
    ! [VarCurr: state_type] :
      ( v5965(VarCurr)
    <=> v5967(VarCurr) ) ).

tff(addAssignment_28831,axiom,
    ! [VarCurr: state_type] :
      ( v5967(VarCurr)
    <=> v5969(VarCurr) ) ).

tff(writeUnaryOperator_3028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5969(VarCurr)
    <=> v54003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5033,axiom,
    ! [VarCurr: state_type] :
      ( v54003(VarCurr)
    <=> ( v5971(VarCurr)
        | v53677(VarCurr) ) ) ).

tff(addAssignment_28830,axiom,
    ! [VarCurr: state_type] :
      ( v53677(VarCurr)
    <=> v53679(VarCurr) ) ).

tff(addAssignment_28829,axiom,
    ! [VarCurr: state_type] :
      ( v53679(VarCurr)
    <=> v5975(VarCurr,2) ) ).

tff(addAssignment_28828,axiom,
    ! [VarCurr: state_type] :
      ( v5975(VarCurr,2)
    <=> v5977(VarCurr,10) ) ).

tff(addAssignment_28827,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,10)
    <=> v5979(VarCurr,10) ) ).

tff(addAssignment_28826,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,10)
    <=> v5981(VarCurr,10) ) ).

tff(addAssignment_28825,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,10)
    <=> v5983(VarCurr,10) ) ).

tff(addAssignment_28824,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,10)
    <=> v5985(VarCurr,10) ) ).

tff(addAssignment_28823,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,10)
    <=> v53672(VarCurr,10) ) ).

tff(addAssignment_28822,axiom,
    ! [VarCurr: state_type] :
      ( v5987(VarCurr,2)
    <=> v53681(VarCurr) ) ).

tff(addAssignment_28821,axiom,
    ! [VarCurr: state_type] :
      ( v53681(VarCurr)
    <=> v53683(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5032,axiom,
    ! [VarCurr: state_type] :
      ( v53683(VarCurr)
    <=> ( v54001(VarCurr)
      <~> v53989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5031,axiom,
    ! [VarCurr: state_type] :
      ( v54001(VarCurr)
    <=> ( v53685(VarCurr)
      <~> v53841(VarCurr) ) ) ).

tff(addAssignment_28820,axiom,
    ! [VarCurr: state_type] :
      ( v53989(VarCurr)
    <=> v53991(VarCurr) ) ).

tff(addAssignment_28819,axiom,
    ! [VarCurr: state_type] :
      ( v53991(VarCurr)
    <=> v53573(VarCurr,2) ) ).

tff(addAssignment_28818,axiom,
    ! [VarCurr: state_type] :
      ( v53573(VarCurr,2)
    <=> v53575(VarCurr,2) ) ).

tff(addAssignment_28817,axiom,
    ! [VarCurr: state_type] :
      ( v53575(VarCurr,2)
    <=> v53577(VarCurr,2) ) ).

tff(addAssignment_28816,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,2)
    <=> v53579(VarCurr,2) ) ).

tff(addAssignment_28815,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,2)
    <=> v53993(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53994(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v53993(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_652,axiom,
    ! [VarNext: state_type] :
      ( v53994(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v53993(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53994(VarNext)
      <=> v53995(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5029,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53995(VarNext)
      <=> ( v53997(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53997(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_28814,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,2)
    <=> v53603(VarCurr,2) ) ).

tff(addAssignment_28813,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,2)
    <=> v53632(VarCurr,2) ) ).

tff(addAssignment_28812,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,10)
    <=> v53606(VarCurr,2) ) ).

tff(addAssignment_28811,axiom,
    ! [VarCurr: state_type] :
      ( v53606(VarCurr,2)
    <=> v53608(VarCurr,2) ) ).

tff(addAssignment_28810,axiom,
    ! [VarCurr: state_type] :
      ( v53608(VarCurr,2)
    <=> v53625(VarCurr,2) ) ).

tff(addAssignment_28809,axiom,
    ! [VarCurr: state_type] :
      ( v53618(VarCurr,2)
    <=> v53620(VarCurr,2) ) ).

tff(addAssignment_28808,axiom,
    ! [VarCurr: state_type] :
      ( v53620(VarCurr,2)
    <=> v53312(VarCurr,10) ) ).

tff(addAssignment_28807,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,10)
    <=> v53314(VarCurr,10) ) ).

tff(addAssignment_28806,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,10)
    <=> v53316(VarCurr,10) ) ).

tff(addAssignment_28805,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,10)
    <=> v53407(VarCurr,10) ) ).

tff(addAssignment_28804,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,10)
    <=> v53326(VarCurr,10) ) ).

tff(addAssignment_28803,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,10)
    <=> v53328(VarCurr,10) ) ).

tff(addAssignment_28802,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,10)
    <=> v6100(VarCurr,138) ) ).

tff(addAssignment_28801,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,138)
    <=> v6102(VarCurr,138) ) ).

tff(addAssignment_28800,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,138)
    <=> v53330(VarCurr,10) ) ).

tff(addAssignment_28799,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,10)
    <=> v53332(VarCurr,10) ) ).

tff(addAssignment_28798,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,10)
    <=> v53390(VarCurr,10) ) ).

tff(addAssignment_28797,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,10)
    <=> v53387(VarCurr,10) ) ).

tff(addAssignment_28796,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,10)
    <=> v53217(VarCurr,66) ) ).

tff(addAssignment_28795,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,10)
    <=> v53383(VarCurr,10) ) ).

tff(addAssignment_28794,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,10)
    <=> v53217(VarCurr,66) ) ).

tff(addAssignment_28793,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,66)
    <=> v53218(VarCurr,66) ) ).

tff(addAssignment_28792,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,132)
    <=> v6238(VarCurr,132) ) ).

tff(addAssignment_28791,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,132)
    <=> v6240(VarCurr,132) ) ).

tff(addAssignment_28790,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,132)
    <=> v47849(VarCurr,0) ) ).

tff(addAssignment_28789,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,10)
    <=> v53379(VarCurr,10) ) ).

tff(addAssignment_28788,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_28787,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,10)
    <=> v53320(VarCurr,10) ) ).

tff(addAssignment_28786,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,10)
    <=> v53321(VarCurr,10) ) ).

tff(addAssignment_28785,axiom,
    ! [VarCurr: state_type] :
      ( v53610(VarCurr,2)
    <=> v53612(VarCurr,2) ) ).

tff(addAssignment_28784,axiom,
    ! [VarCurr: state_type] :
      ( v53612(VarCurr,2)
    <=> v53312(VarCurr,6) ) ).

tff(addAssignment_28783,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,6)
    <=> v53314(VarCurr,6) ) ).

tff(addAssignment_28782,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,6)
    <=> v53316(VarCurr,6) ) ).

tff(addAssignment_28781,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,6)
    <=> v53407(VarCurr,6) ) ).

tff(addAssignment_28780,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,6)
    <=> v53326(VarCurr,6) ) ).

tff(addAssignment_28779,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,6)
    <=> v53328(VarCurr,6) ) ).

tff(addAssignment_28778,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,6)
    <=> v6100(VarCurr,134) ) ).

tff(addAssignment_28777,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,134)
    <=> v6102(VarCurr,134) ) ).

tff(addAssignment_28776,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,134)
    <=> v53330(VarCurr,6) ) ).

tff(addAssignment_28775,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,6)
    <=> v53332(VarCurr,6) ) ).

tff(addAssignment_28774,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,6)
    <=> v53390(VarCurr,6) ) ).

tff(addAssignment_28773,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,6)
    <=> v53387(VarCurr,6) ) ).

tff(addAssignment_28772,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,6)
    <=> v53217(VarCurr,62) ) ).

tff(addAssignment_28771,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,6)
    <=> v53383(VarCurr,6) ) ).

tff(addAssignment_28770,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,6)
    <=> v53217(VarCurr,62) ) ).

tff(addAssignment_28769,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,62)
    <=> v53218(VarCurr,62) ) ).

tff(addAssignment_28768,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,122)
    <=> v6238(VarCurr,122) ) ).

tff(addAssignment_28767,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,122)
    <=> v6240(VarCurr,122) ) ).

tff(addAssignment_28766,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,122)
    <=> v46299(VarCurr,2) ) ).

tff(addAssignment_28765,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,6)
    <=> v53379(VarCurr,6) ) ).

tff(addAssignment_28764,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_28763,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,6)
    <=> v53320(VarCurr,6) ) ).

tff(addAssignment_28762,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,6)
    <=> v53321(VarCurr,6) ) ).

tff(addAssignment_28761,axiom,
    ! [VarCurr: state_type] :
      ( v53841(VarCurr)
    <=> v53843(VarCurr) ) ).

tff(addAssignment_28760,axiom,
    ! [VarCurr: state_type] :
      ( v53843(VarCurr)
    <=> v53845(VarCurr) ) ).

tff(addAssignment_28759,axiom,
    ! [VarCurr: state_type] :
      ( v53845(VarCurr)
    <=> v53847(VarCurr) ) ).

tff(addAssignment_28758,axiom,
    ! [VarCurr: state_type] :
      ( v53847(VarCurr)
    <=> v53849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5028,axiom,
    ! [VarCurr: state_type] :
      ( v53849(VarCurr)
    <=> ( v53987(VarCurr)
      <~> v53947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5027,axiom,
    ! [VarCurr: state_type] :
      ( v53987(VarCurr)
    <=> ( v53851(VarCurr)
      <~> v53899(VarCurr) ) ) ).

tff(addAssignment_28757,axiom,
    ! [VarCurr: state_type] :
      ( v53947(VarCurr)
    <=> v53949(VarCurr) ) ).

tff(addAssignment_28756,axiom,
    ! [VarCurr: state_type] :
      ( v53949(VarCurr)
    <=> v53951(VarCurr) ) ).

tff(addAssignment_28755,axiom,
    ! [VarCurr: state_type] :
      ( v53951(VarCurr)
    <=> v53953(VarCurr) ) ).

tff(addAssignment_28754,axiom,
    ! [VarCurr: state_type] :
      ( v53953(VarCurr)
    <=> v53955(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5026,axiom,
    ! [VarCurr: state_type] :
      ( v53955(VarCurr)
    <=> ( v53985(VarCurr)
      <~> v53981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5025,axiom,
    ! [VarCurr: state_type] :
      ( v53985(VarCurr)
    <=> ( v53957(VarCurr)
      <~> v53969(VarCurr) ) ) ).

tff(addAssignment_28753,axiom,
    ! [VarCurr: state_type] :
      ( v53981(VarCurr)
    <=> v53983(VarCurr) ) ).

tff(addAssignment_28752,axiom,
    ! [VarCurr: state_type] :
      ( v53983(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_28751,axiom,
    ! [VarCurr: state_type] :
      ( v53969(VarCurr)
    <=> v53971(VarCurr) ) ).

tff(addAssignment_28750,axiom,
    ! [VarCurr: state_type] :
      ( v53971(VarCurr)
    <=> v6017(VarCurr,126) ) ).

tff(addAssignment_28749,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,126)
    <=> v53103(VarCurr,62) ) ).

tff(addAssignment_28748,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,62)
    <=> v53105(VarCurr,62) ) ).

tff(addAssignment_28747,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,62)
    <=> v53107(VarCurr,62) ) ).

tff(addAssignment_28746,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,62)
    <=> v53109(VarCurr,62) ) ).

tff(addAssignment_28745,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,62)
    <=> v6027(VarCurr,126) ) ).

tff(addAssignment_28744,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,126)
    <=> v52434(VarCurr,126) ) ).

tff(addAssignment_28743,axiom,
    ! [VarCurr: state_type] :
      ( v52435(VarCurr,2)
    <=> v53112(VarCurr,62) ) ).

tff(addAssignment_28742,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,62)
    <=> v53114(VarCurr,62) ) ).

tff(addAssignment_28741,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,62)
    <=> v53973(VarNext,62) ) ).

tff(addCaseBooleanConditionEqualRanges1_651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53974(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53973(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_651,axiom,
    ! [VarNext: state_type] :
      ( v53974(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53973(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53974(VarNext)
      <=> v53975(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53975(VarNext)
      <=> ( v53977(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53977(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_28740,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,62)
    <=> v53138(VarCurr,62) ) ).

tff(addAssignment_28739,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,62)
    <=> v6059(VarCurr,126) ) ).

tff(addAssignment_28738,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,126)
    <=> v53304(VarCurr,2) ) ).

tff(addAssignment_28737,axiom,
    ! [VarCurr: state_type] :
      ( v53304(VarCurr,2)
    <=> v53306(VarCurr,2) ) ).

tff(addAssignment_28736,axiom,
    ! [VarCurr: state_type] :
      ( v53306(VarCurr,2)
    <=> v53420(VarCurr,2) ) ).

tff(addAssignment_28735,axiom,
    ! [VarCurr: state_type] :
      ( v53413(VarCurr,2)
    <=> v53415(VarCurr,2) ) ).

tff(addAssignment_28734,axiom,
    ! [VarCurr: state_type] :
      ( v53415(VarCurr,2)
    <=> v6069(VarCurr,126) ) ).

tff(addAssignment_28733,axiom,
    ! [VarCurr: state_type] :
      ( v53308(VarCurr,2)
    <=> v53310(VarCurr,2) ) ).

tff(addAssignment_28732,axiom,
    ! [VarCurr: state_type] :
      ( v53310(VarCurr,2)
    <=> v53312(VarCurr,14) ) ).

tff(addAssignment_28731,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,14)
    <=> v53314(VarCurr,14) ) ).

tff(addAssignment_28730,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,14)
    <=> v53316(VarCurr,14) ) ).

tff(addAssignment_28729,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,14)
    <=> v53407(VarCurr,14) ) ).

tff(addAssignment_28728,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,14)
    <=> v53326(VarCurr,14) ) ).

tff(addAssignment_28727,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,14)
    <=> v53328(VarCurr,14) ) ).

tff(addAssignment_28726,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,14)
    <=> v6100(VarCurr,142) ) ).

tff(addAssignment_28725,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,142)
    <=> v6102(VarCurr,142) ) ).

tff(addAssignment_28724,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,142)
    <=> v53330(VarCurr,14) ) ).

tff(addAssignment_28723,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,14)
    <=> v53332(VarCurr,14) ) ).

tff(addAssignment_28722,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,14)
    <=> v53390(VarCurr,14) ) ).

tff(addAssignment_28721,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,14)
    <=> v53387(VarCurr,14) ) ).

tff(addAssignment_28720,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,14)
    <=> v53217(VarCurr,70) ) ).

tff(addAssignment_28719,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,14)
    <=> v53383(VarCurr,14) ) ).

tff(addAssignment_28718,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,14)
    <=> v53217(VarCurr,70) ) ).

tff(addAssignment_28717,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,70)
    <=> v53218(VarCurr,70) ) ).

tff(addAssignment_28716,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,136)
    <=> v6238(VarCurr,136) ) ).

tff(addAssignment_28715,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,136)
    <=> v6240(VarCurr,136) ) ).

tff(addAssignment_28714,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,136)
    <=> v47849(VarCurr,4) ) ).

tff(addAssignment_28713,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,14)
    <=> v53379(VarCurr,14) ) ).

tff(addAssignment_28712,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_28711,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,14)
    <=> v53320(VarCurr,14) ) ).

tff(addAssignment_28710,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,14)
    <=> v53321(VarCurr,14) ) ).

tff(addAssignment_28709,axiom,
    ! [VarCurr: state_type] :
      ( v53957(VarCurr)
    <=> v53959(VarCurr) ) ).

tff(addAssignment_28708,axiom,
    ! [VarCurr: state_type] :
      ( v53959(VarCurr)
    <=> v6017(VarCurr,122) ) ).

tff(addAssignment_28707,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,122)
    <=> v53103(VarCurr,58) ) ).

tff(addAssignment_28706,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,58)
    <=> v53105(VarCurr,58) ) ).

tff(addAssignment_28705,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,58)
    <=> v53107(VarCurr,58) ) ).

tff(addAssignment_28704,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,58)
    <=> v53109(VarCurr,58) ) ).

tff(addAssignment_28703,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,58)
    <=> v6027(VarCurr,122) ) ).

tff(addAssignment_28702,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,122)
    <=> v52434(VarCurr,122) ) ).

tff(addAssignment_28701,axiom,
    ! [VarCurr: state_type] :
      ( v52436(VarCurr,2)
    <=> v53112(VarCurr,58) ) ).

tff(addAssignment_28700,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,58)
    <=> v53114(VarCurr,58) ) ).

tff(addAssignment_28699,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,58)
    <=> v53961(VarNext,58) ) ).

tff(addCaseBooleanConditionEqualRanges1_650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53962(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53961(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_650,axiom,
    ! [VarNext: state_type] :
      ( v53962(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53961(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53962(VarNext)
      <=> v53963(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53963(VarNext)
      <=> ( v53965(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3025,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53965(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_28698,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,58)
    <=> v53138(VarCurr,58) ) ).

tff(addAssignment_28697,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,58)
    <=> v6059(VarCurr,122) ) ).

tff(addAssignment_28696,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,122)
    <=> v53140(VarCurr,2) ) ).

tff(addAssignment_28695,axiom,
    ! [VarCurr: state_type] :
      ( v53140(VarCurr,2)
    <=> v53142(VarCurr,2) ) ).

tff(addAssignment_28694,axiom,
    ! [VarCurr: state_type] :
      ( v53142(VarCurr,2)
    <=> v53255(VarCurr,2) ) ).

tff(addAssignment_28693,axiom,
    ! [VarCurr: state_type] :
      ( v53248(VarCurr,2)
    <=> v53250(VarCurr,2) ) ).

tff(addAssignment_28692,axiom,
    ! [VarCurr: state_type] :
      ( v53250(VarCurr,2)
    <=> v6069(VarCurr,122) ) ).

tff(addAssignment_28691,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,122)
    <=> v53148(VarCurr,58) ) ).

tff(addAssignment_28690,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,58)
    <=> v53150(VarCurr,58) ) ).

tff(addAssignment_28689,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,58)
    <=> v53242(VarCurr,58) ) ).

tff(addAssignment_28688,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,58)
    <=> v53160(VarCurr,58) ) ).

tff(addAssignment_28687,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,58)
    <=> v6098(VarCurr,122) ) ).

tff(addAssignment_28686,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,122)
    <=> v6100(VarCurr,122) ) ).

tff(addAssignment_28685,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,122)
    <=> v6102(VarCurr,122) ) ).

tff(addAssignment_28684,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,122)
    <=> v53162(VarCurr,58) ) ).

tff(addAssignment_28683,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,58)
    <=> v53164(VarCurr,58) ) ).

tff(addAssignment_28682,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,58)
    <=> v53225(VarCurr,58) ) ).

tff(addAssignment_28681,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,58)
    <=> v53223(VarCurr,58) ) ).

tff(addAssignment_28680,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,58)
    <=> v53224(VarCurr,58) ) ).

tff(addAssignment_28679,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,58)
    <=> v53215(VarCurr,58) ) ).

tff(addAssignment_28678,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,58)
    <=> v53219(VarCurr,58) ) ).

tff(addAssignment_28677,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,50)
    <=> v53218(VarCurr,50) ) ).

tff(addAssignment_28676,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,98)
    <=> v6238(VarCurr,98) ) ).

tff(addAssignment_28675,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,98)
    <=> v6240(VarCurr,98) ) ).

tff(addAssignment_28674,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,98)
    <=> v43199(VarCurr,2) ) ).

tff(addAssignment_28673,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,58)
    <=> v53211(VarCurr,58) ) ).

tff(addAssignment_28672,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,58)
    <=> $false ) ).

tff(addAssignment_28671,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,58)
    <=> v53154(VarCurr,58) ) ).

tff(addAssignment_28670,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,58)
    <=> v53155(VarCurr,58) ) ).

tff(addAssignment_28669,axiom,
    ! [VarCurr: state_type] :
      ( v53144(VarCurr,2)
    <=> v53146(VarCurr,2) ) ).

tff(addAssignment_28668,axiom,
    ! [VarCurr: state_type] :
      ( v53146(VarCurr,2)
    <=> v6069(VarCurr,126) ) ).

tff(addAssignment_28667,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,126)
    <=> v53148(VarCurr,62) ) ).

tff(addAssignment_28666,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,62)
    <=> v53150(VarCurr,62) ) ).

tff(addAssignment_28665,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,62)
    <=> v53242(VarCurr,62) ) ).

tff(addAssignment_28664,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,62)
    <=> v53160(VarCurr,62) ) ).

tff(addAssignment_28663,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,62)
    <=> v6098(VarCurr,126) ) ).

tff(addAssignment_28662,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,126)
    <=> v6100(VarCurr,126) ) ).

tff(addAssignment_28661,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,126)
    <=> v6102(VarCurr,126) ) ).

tff(addAssignment_28660,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,126)
    <=> v53162(VarCurr,62) ) ).

tff(addAssignment_28659,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,62)
    <=> v53164(VarCurr,62) ) ).

tff(addAssignment_28658,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,62)
    <=> v53225(VarCurr,62) ) ).

tff(addAssignment_28657,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,62)
    <=> v53223(VarCurr,62) ) ).

tff(addAssignment_28656,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,62)
    <=> v53224(VarCurr,62) ) ).

tff(addAssignment_28655,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,62)
    <=> v53215(VarCurr,62) ) ).

tff(addAssignment_28654,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,62)
    <=> v53219(VarCurr,62) ) ).

tff(addAssignment_28653,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,54)
    <=> v53218(VarCurr,54) ) ).

tff(addAssignment_28652,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,108)
    <=> v6238(VarCurr,108) ) ).

tff(addAssignment_28651,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,108)
    <=> v6240(VarCurr,108) ) ).

tff(addAssignment_28650,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,108)
    <=> v44749(VarCurr,0) ) ).

tff(addAssignment_28649,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,62)
    <=> v53211(VarCurr,62) ) ).

tff(addAssignment_28648,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,62)
    <=> $false ) ).

tff(addAssignment_28647,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,62)
    <=> v53154(VarCurr,62) ) ).

tff(addAssignment_28646,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,62)
    <=> v53155(VarCurr,62) ) ).

tff(addAssignment_28645,axiom,
    ! [VarCurr: state_type] :
      ( v53899(VarCurr)
    <=> v53901(VarCurr) ) ).

tff(addAssignment_28644,axiom,
    ! [VarCurr: state_type] :
      ( v53901(VarCurr)
    <=> v53903(VarCurr) ) ).

tff(addAssignment_28643,axiom,
    ! [VarCurr: state_type] :
      ( v53903(VarCurr)
    <=> v53905(VarCurr) ) ).

tff(addAssignment_28642,axiom,
    ! [VarCurr: state_type] :
      ( v53905(VarCurr)
    <=> v53907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5020,axiom,
    ! [VarCurr: state_type] :
      ( v53907(VarCurr)
    <=> ( v53945(VarCurr)
      <~> v53933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5019,axiom,
    ! [VarCurr: state_type] :
      ( v53945(VarCurr)
    <=> ( v53909(VarCurr)
      <~> v53921(VarCurr) ) ) ).

tff(addAssignment_28641,axiom,
    ! [VarCurr: state_type] :
      ( v53933(VarCurr)
    <=> v53935(VarCurr) ) ).

tff(addAssignment_28640,axiom,
    ! [VarCurr: state_type] :
      ( v53935(VarCurr)
    <=> v6017(VarCurr,58) ) ).

tff(addAssignment_28639,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,58)
    <=> v6019(VarCurr,58) ) ).

tff(addAssignment_28638,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,58)
    <=> v6021(VarCurr,58) ) ).

tff(addAssignment_28637,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,58)
    <=> v6023(VarCurr,58) ) ).

tff(addAssignment_28636,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,58)
    <=> v6025(VarCurr,58) ) ).

tff(addAssignment_28635,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,58)
    <=> v6027(VarCurr,58) ) ).

tff(addAssignment_28634,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,58)
    <=> v52434(VarCurr,58) ) ).

tff(addAssignment_28633,axiom,
    ! [VarCurr: state_type] :
      ( v52452(VarCurr,2)
    <=> v6031(VarCurr,58) ) ).

tff(addAssignment_28632,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,58)
    <=> v6033(VarCurr,58) ) ).

tff(addAssignment_28631,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,58)
    <=> v53937(VarNext,58) ) ).

tff(addCaseBooleanConditionEqualRanges1_649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53938(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53937(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_649,axiom,
    ! [VarNext: state_type] :
      ( v53938(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53937(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53938(VarNext)
      <=> v53939(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53939(VarNext)
      <=> ( v53941(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53941(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28630,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,58)
    <=> v6057(VarCurr,58) ) ).

tff(addAssignment_28629,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,58)
    <=> v6059(VarCurr,58) ) ).

tff(addAssignment_28628,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,58)
    <=> v53052(VarCurr,2) ) ).

tff(addAssignment_28627,axiom,
    ! [VarCurr: state_type] :
      ( v53052(VarCurr,2)
    <=> v53054(VarCurr,2) ) ).

tff(addAssignment_28626,axiom,
    ! [VarCurr: state_type] :
      ( v53054(VarCurr,2)
    <=> v53071(VarCurr,2) ) ).

tff(addAssignment_28625,axiom,
    ! [VarCurr: state_type] :
      ( v53064(VarCurr,2)
    <=> v53066(VarCurr,2) ) ).

tff(addAssignment_28624,axiom,
    ! [VarCurr: state_type] :
      ( v53066(VarCurr,2)
    <=> v6069(VarCurr,58) ) ).

tff(addAssignment_28623,axiom,
    ! [VarCurr: state_type] :
      ( v53056(VarCurr,2)
    <=> v53058(VarCurr,2) ) ).

tff(addAssignment_28622,axiom,
    ! [VarCurr: state_type] :
      ( v53058(VarCurr,2)
    <=> v6069(VarCurr,62) ) ).

tff(addAssignment_28621,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,62)
    <=> v6071(VarCurr,62) ) ).

tff(addAssignment_28620,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,62)
    <=> v6073(VarCurr,62) ) ).

tff(addAssignment_28619,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,62)
    <=> v52355(VarCurr,62) ) ).

tff(addAssignment_28618,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,62)
    <=> v6096(VarCurr,62) ) ).

tff(addAssignment_28617,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,62)
    <=> v6098(VarCurr,62) ) ).

tff(addAssignment_28616,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,62)
    <=> v6100(VarCurr,62) ) ).

tff(addAssignment_28615,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,62)
    <=> v6102(VarCurr,62) ) ).

tff(addAssignment_28614,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,62)
    <=> v6104(VarCurr,62) ) ).

tff(addAssignment_28613,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,62)
    <=> v6106(VarCurr,62) ) ).

tff(addAssignment_28612,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,62)
    <=> v52338(VarCurr,62) ) ).

tff(addAssignment_28611,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,62)
    <=> v52330(VarCurr,62) ) ).

tff(addAssignment_28610,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,62)
    <=> v52332(VarCurr,62) ) ).

tff(addAssignment_28609,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,62)
    <=> v52335(VarCurr,62) ) ).

tff(addAssignment_28608,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,122)
    <=> v33839(VarCurr,122) ) ).

tff(addAssignment_28607,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,122)
    <=> v33841(VarCurr,122) ) ).

tff(addAssignment_28606,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,122)
    <=> v25005(VarCurr,2) ) ).

tff(addAssignment_28605,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,62)
    <=> v6232(VarCurr,62) ) ).

tff(addAssignment_28604,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,62)
    <=> v6234(VarCurr,62) ) ).

tff(addAssignment_28603,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,62)
    <=> v52325(VarCurr,62) ) ).

tff(addAssignment_28602,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,128)
    <=> v6238(VarCurr,128) ) ).

tff(addAssignment_28601,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,128)
    <=> v6240(VarCurr,128) ) ).

tff(addAssignment_28600,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,128)
    <=> v46299(VarCurr,8) ) ).

tff(addAssignment_28599,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,62)
    <=> v6226(VarCurr,62) ) ).

tff(addAssignment_28598,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,62)
    <=> $false ) ).

tff(addAssignment_28597,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,62)
    <=> v6077(VarCurr,62) ) ).

tff(addAssignment_28596,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,62)
    <=> v6091(VarCurr,62) ) ).

tff(addAssignment_28595,axiom,
    ! [VarCurr: state_type] :
      ( v53921(VarCurr)
    <=> v53923(VarCurr) ) ).

tff(addAssignment_28594,axiom,
    ! [VarCurr: state_type] :
      ( v53923(VarCurr)
    <=> v6017(VarCurr,54) ) ).

tff(addAssignment_28593,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,54)
    <=> v6019(VarCurr,54) ) ).

tff(addAssignment_28592,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,54)
    <=> v6021(VarCurr,54) ) ).

tff(addAssignment_28591,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,54)
    <=> v6023(VarCurr,54) ) ).

tff(addAssignment_28590,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,54)
    <=> v6025(VarCurr,54) ) ).

tff(addAssignment_28589,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,54)
    <=> v6027(VarCurr,54) ) ).

tff(addAssignment_28588,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,54)
    <=> v52434(VarCurr,54) ) ).

tff(addAssignment_28587,axiom,
    ! [VarCurr: state_type] :
      ( v52453(VarCurr,2)
    <=> v6031(VarCurr,54) ) ).

tff(addAssignment_28586,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,54)
    <=> v6033(VarCurr,54) ) ).

tff(addAssignment_28585,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,54)
    <=> v53925(VarNext,54) ) ).

tff(addCaseBooleanConditionEqualRanges1_648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53926(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53925(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_648,axiom,
    ! [VarNext: state_type] :
      ( v53926(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53925(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53926(VarNext)
      <=> v53927(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53927(VarNext)
      <=> ( v53929(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53929(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28584,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,54)
    <=> v6057(VarCurr,54) ) ).

tff(addAssignment_28583,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,54)
    <=> v6059(VarCurr,54) ) ).

tff(addAssignment_28582,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,54)
    <=> v53012(VarCurr,2) ) ).

tff(addAssignment_28581,axiom,
    ! [VarCurr: state_type] :
      ( v53012(VarCurr,2)
    <=> v53014(VarCurr,2) ) ).

tff(addAssignment_28580,axiom,
    ! [VarCurr: state_type] :
      ( v53014(VarCurr,2)
    <=> v53031(VarCurr,2) ) ).

tff(addAssignment_28579,axiom,
    ! [VarCurr: state_type] :
      ( v53024(VarCurr,2)
    <=> v53026(VarCurr,2) ) ).

tff(addAssignment_28578,axiom,
    ! [VarCurr: state_type] :
      ( v53026(VarCurr,2)
    <=> v6069(VarCurr,54) ) ).

tff(addAssignment_28577,axiom,
    ! [VarCurr: state_type] :
      ( v53016(VarCurr,2)
    <=> v53018(VarCurr,2) ) ).

tff(addAssignment_28576,axiom,
    ! [VarCurr: state_type] :
      ( v53018(VarCurr,2)
    <=> v6069(VarCurr,58) ) ).

tff(addAssignment_28575,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,58)
    <=> v6071(VarCurr,58) ) ).

tff(addAssignment_28574,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,58)
    <=> v6073(VarCurr,58) ) ).

tff(addAssignment_28573,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,58)
    <=> v52355(VarCurr,58) ) ).

tff(addAssignment_28572,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,58)
    <=> v6096(VarCurr,58) ) ).

tff(addAssignment_28571,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,58)
    <=> v6098(VarCurr,58) ) ).

tff(addAssignment_28570,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,58)
    <=> v6100(VarCurr,58) ) ).

tff(addAssignment_28569,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,58)
    <=> v6102(VarCurr,58) ) ).

tff(addAssignment_28568,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,58)
    <=> v6104(VarCurr,58) ) ).

tff(addAssignment_28567,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,58)
    <=> v6106(VarCurr,58) ) ).

tff(addAssignment_28566,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,58)
    <=> v52338(VarCurr,58) ) ).

tff(addAssignment_28565,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,58)
    <=> v52330(VarCurr,58) ) ).

tff(addAssignment_28564,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,58)
    <=> v52332(VarCurr,58) ) ).

tff(addAssignment_28563,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,58)
    <=> v52335(VarCurr,58) ) ).

tff(addAssignment_28562,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,112)
    <=> v33839(VarCurr,112) ) ).

tff(addAssignment_28561,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,112)
    <=> v33841(VarCurr,112) ) ).

tff(addAssignment_28560,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,112)
    <=> v23455(VarCurr,4) ) ).

tff(addAssignment_28559,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,58)
    <=> v6232(VarCurr,58) ) ).

tff(addAssignment_28558,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,58)
    <=> v6234(VarCurr,58) ) ).

tff(addAssignment_28557,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,58)
    <=> v52325(VarCurr,58) ) ).

tff(addAssignment_28556,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,118)
    <=> v6238(VarCurr,118) ) ).

tff(addAssignment_28555,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,118)
    <=> v6240(VarCurr,118) ) ).

tff(addAssignment_28554,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,118)
    <=> v44749(VarCurr,10) ) ).

tff(addAssignment_28553,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,58)
    <=> v6226(VarCurr,58) ) ).

tff(addAssignment_28552,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,58)
    <=> $false ) ).

tff(addAssignment_28551,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,58)
    <=> v6077(VarCurr,58) ) ).

tff(addAssignment_28550,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,58)
    <=> v6091(VarCurr,58) ) ).

tff(addAssignment_28549,axiom,
    ! [VarCurr: state_type] :
      ( v53909(VarCurr)
    <=> v53911(VarCurr) ) ).

tff(addAssignment_28548,axiom,
    ! [VarCurr: state_type] :
      ( v53911(VarCurr)
    <=> v6017(VarCurr,50) ) ).

tff(addAssignment_28547,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,50)
    <=> v6019(VarCurr,50) ) ).

tff(addAssignment_28546,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,50)
    <=> v6021(VarCurr,50) ) ).

tff(addAssignment_28545,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,50)
    <=> v6023(VarCurr,50) ) ).

tff(addAssignment_28544,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,50)
    <=> v6025(VarCurr,50) ) ).

tff(addAssignment_28543,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,50)
    <=> v6027(VarCurr,50) ) ).

tff(addAssignment_28542,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,50)
    <=> v52434(VarCurr,50) ) ).

tff(addAssignment_28541,axiom,
    ! [VarCurr: state_type] :
      ( v52454(VarCurr,2)
    <=> v6031(VarCurr,50) ) ).

tff(addAssignment_28540,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,50)
    <=> v6033(VarCurr,50) ) ).

tff(addAssignment_28539,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,50)
    <=> v53913(VarNext,50) ) ).

tff(addCaseBooleanConditionEqualRanges1_647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53914(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53913(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_647,axiom,
    ! [VarNext: state_type] :
      ( v53914(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53913(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53914(VarNext)
      <=> v53915(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53915(VarNext)
      <=> ( v53917(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53917(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28538,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,50)
    <=> v6057(VarCurr,50) ) ).

tff(addAssignment_28537,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,50)
    <=> v6059(VarCurr,50) ) ).

tff(addAssignment_28536,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,50)
    <=> v52972(VarCurr,2) ) ).

tff(addAssignment_28535,axiom,
    ! [VarCurr: state_type] :
      ( v52972(VarCurr,2)
    <=> v52974(VarCurr,2) ) ).

tff(addAssignment_28534,axiom,
    ! [VarCurr: state_type] :
      ( v52974(VarCurr,2)
    <=> v52991(VarCurr,2) ) ).

tff(addAssignment_28533,axiom,
    ! [VarCurr: state_type] :
      ( v52984(VarCurr,2)
    <=> v52986(VarCurr,2) ) ).

tff(addAssignment_28532,axiom,
    ! [VarCurr: state_type] :
      ( v52986(VarCurr,2)
    <=> v6069(VarCurr,50) ) ).

tff(addAssignment_28531,axiom,
    ! [VarCurr: state_type] :
      ( v52976(VarCurr,2)
    <=> v52978(VarCurr,2) ) ).

tff(addAssignment_28530,axiom,
    ! [VarCurr: state_type] :
      ( v52978(VarCurr,2)
    <=> v6069(VarCurr,54) ) ).

tff(addAssignment_28529,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,54)
    <=> v6071(VarCurr,54) ) ).

tff(addAssignment_28528,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,54)
    <=> v6073(VarCurr,54) ) ).

tff(addAssignment_28527,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,54)
    <=> v52355(VarCurr,54) ) ).

tff(addAssignment_28526,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,54)
    <=> v6096(VarCurr,54) ) ).

tff(addAssignment_28525,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,54)
    <=> v6098(VarCurr,54) ) ).

tff(addAssignment_28524,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,54)
    <=> v6100(VarCurr,54) ) ).

tff(addAssignment_28523,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,54)
    <=> v6102(VarCurr,54) ) ).

tff(addAssignment_28522,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,54)
    <=> v6104(VarCurr,54) ) ).

tff(addAssignment_28521,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,54)
    <=> v6106(VarCurr,54) ) ).

tff(addAssignment_28520,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,54)
    <=> v52338(VarCurr,54) ) ).

tff(addAssignment_28519,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,54)
    <=> v52330(VarCurr,54) ) ).

tff(addAssignment_28518,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,54)
    <=> v52332(VarCurr,54) ) ).

tff(addAssignment_28517,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,54)
    <=> v52335(VarCurr,54) ) ).

tff(addAssignment_28516,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,108)
    <=> v33839(VarCurr,108) ) ).

tff(addAssignment_28515,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,108)
    <=> v33841(VarCurr,108) ) ).

tff(addAssignment_28514,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,108)
    <=> v23455(VarCurr,0) ) ).

tff(addAssignment_28513,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,54)
    <=> v6232(VarCurr,54) ) ).

tff(addAssignment_28512,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,54)
    <=> v6234(VarCurr,54) ) ).

tff(addAssignment_28511,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,54)
    <=> v52325(VarCurr,54) ) ).

tff(addAssignment_28510,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,114)
    <=> v6238(VarCurr,114) ) ).

tff(addAssignment_28509,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,114)
    <=> v6240(VarCurr,114) ) ).

tff(addAssignment_28508,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,114)
    <=> v44749(VarCurr,6) ) ).

tff(addAssignment_28507,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,54)
    <=> v6226(VarCurr,54) ) ).

tff(addAssignment_28506,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,54)
    <=> $false ) ).

tff(addAssignment_28505,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,54)
    <=> v6077(VarCurr,54) ) ).

tff(addAssignment_28504,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,54)
    <=> v6091(VarCurr,54) ) ).

tff(addAssignment_28503,axiom,
    ! [VarCurr: state_type] :
      ( v53851(VarCurr)
    <=> v53853(VarCurr) ) ).

tff(addAssignment_28502,axiom,
    ! [VarCurr: state_type] :
      ( v53853(VarCurr)
    <=> v53855(VarCurr) ) ).

tff(addAssignment_28501,axiom,
    ! [VarCurr: state_type] :
      ( v53855(VarCurr)
    <=> v53857(VarCurr) ) ).

tff(addAssignment_28500,axiom,
    ! [VarCurr: state_type] :
      ( v53857(VarCurr)
    <=> v53859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5012,axiom,
    ! [VarCurr: state_type] :
      ( v53859(VarCurr)
    <=> ( v53897(VarCurr)
      <~> v53885(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5011,axiom,
    ! [VarCurr: state_type] :
      ( v53897(VarCurr)
    <=> ( v53861(VarCurr)
      <~> v53873(VarCurr) ) ) ).

tff(addAssignment_28499,axiom,
    ! [VarCurr: state_type] :
      ( v53885(VarCurr)
    <=> v53887(VarCurr) ) ).

tff(addAssignment_28498,axiom,
    ! [VarCurr: state_type] :
      ( v53887(VarCurr)
    <=> v6017(VarCurr,46) ) ).

tff(addAssignment_28497,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,46)
    <=> v6019(VarCurr,46) ) ).

tff(addAssignment_28496,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,46)
    <=> v6021(VarCurr,46) ) ).

tff(addAssignment_28495,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,46)
    <=> v6023(VarCurr,46) ) ).

tff(addAssignment_28494,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,46)
    <=> v6025(VarCurr,46) ) ).

tff(addAssignment_28493,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,46)
    <=> v6027(VarCurr,46) ) ).

tff(addAssignment_28492,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,46)
    <=> v52434(VarCurr,46) ) ).

tff(addAssignment_28491,axiom,
    ! [VarCurr: state_type] :
      ( v52455(VarCurr,2)
    <=> v6031(VarCurr,46) ) ).

tff(addAssignment_28490,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,46)
    <=> v6033(VarCurr,46) ) ).

tff(addAssignment_28489,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,46)
    <=> v53889(VarNext,46) ) ).

tff(addCaseBooleanConditionEqualRanges1_646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53890(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53889(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_646,axiom,
    ! [VarNext: state_type] :
      ( v53890(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53889(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53890(VarNext)
      <=> v53891(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53891(VarNext)
      <=> ( v53893(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53893(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28488,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,46)
    <=> v6057(VarCurr,46) ) ).

tff(addAssignment_28487,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,46)
    <=> v6059(VarCurr,46) ) ).

tff(addAssignment_28486,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,46)
    <=> v52920(VarCurr,2) ) ).

tff(addAssignment_28485,axiom,
    ! [VarCurr: state_type] :
      ( v52920(VarCurr,2)
    <=> v52922(VarCurr,2) ) ).

tff(addAssignment_28484,axiom,
    ! [VarCurr: state_type] :
      ( v52922(VarCurr,2)
    <=> v52939(VarCurr,2) ) ).

tff(addAssignment_28483,axiom,
    ! [VarCurr: state_type] :
      ( v52932(VarCurr,2)
    <=> v52934(VarCurr,2) ) ).

tff(addAssignment_28482,axiom,
    ! [VarCurr: state_type] :
      ( v52934(VarCurr,2)
    <=> v6069(VarCurr,46) ) ).

tff(addAssignment_28481,axiom,
    ! [VarCurr: state_type] :
      ( v52924(VarCurr,2)
    <=> v52926(VarCurr,2) ) ).

tff(addAssignment_28480,axiom,
    ! [VarCurr: state_type] :
      ( v52926(VarCurr,2)
    <=> v6069(VarCurr,50) ) ).

tff(addAssignment_28479,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,50)
    <=> v6071(VarCurr,50) ) ).

tff(addAssignment_28478,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,50)
    <=> v6073(VarCurr,50) ) ).

tff(addAssignment_28477,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,50)
    <=> v52355(VarCurr,50) ) ).

tff(addAssignment_28476,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,50)
    <=> v6096(VarCurr,50) ) ).

tff(addAssignment_28475,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,50)
    <=> v6098(VarCurr,50) ) ).

tff(addAssignment_28474,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,50)
    <=> v6100(VarCurr,50) ) ).

tff(addAssignment_28473,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,50)
    <=> v6102(VarCurr,50) ) ).

tff(addAssignment_28472,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,50)
    <=> v6104(VarCurr,50) ) ).

tff(addAssignment_28471,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,50)
    <=> v6106(VarCurr,50) ) ).

tff(addAssignment_28470,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,50)
    <=> v52338(VarCurr,50) ) ).

tff(addAssignment_28469,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,50)
    <=> v52330(VarCurr,50) ) ).

tff(addAssignment_28468,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,50)
    <=> v52332(VarCurr,50) ) ).

tff(addAssignment_28467,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,50)
    <=> v52335(VarCurr,50) ) ).

tff(addAssignment_28466,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,98)
    <=> v33839(VarCurr,98) ) ).

tff(addAssignment_28465,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,98)
    <=> v33841(VarCurr,98) ) ).

tff(addAssignment_28464,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,98)
    <=> v21905(VarCurr,2) ) ).

tff(addAssignment_28463,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,50)
    <=> v6232(VarCurr,50) ) ).

tff(addAssignment_28462,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,50)
    <=> v6234(VarCurr,50) ) ).

tff(addAssignment_28461,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,50)
    <=> v52325(VarCurr,50) ) ).

tff(addAssignment_28460,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,104)
    <=> v6238(VarCurr,104) ) ).

tff(addAssignment_28459,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,104)
    <=> v6240(VarCurr,104) ) ).

tff(addAssignment_28458,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,104)
    <=> v43199(VarCurr,8) ) ).

tff(addAssignment_28457,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,50)
    <=> v6226(VarCurr,50) ) ).

tff(addAssignment_28456,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,50)
    <=> $false ) ).

tff(addAssignment_28455,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,50)
    <=> v6077(VarCurr,50) ) ).

tff(addAssignment_28454,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,50)
    <=> v6091(VarCurr,50) ) ).

tff(addAssignment_28453,axiom,
    ! [VarCurr: state_type] :
      ( v53873(VarCurr)
    <=> v53875(VarCurr) ) ).

tff(addAssignment_28452,axiom,
    ! [VarCurr: state_type] :
      ( v53875(VarCurr)
    <=> v6017(VarCurr,42) ) ).

tff(addAssignment_28451,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,42)
    <=> v6019(VarCurr,42) ) ).

tff(addAssignment_28450,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,42)
    <=> v6021(VarCurr,42) ) ).

tff(addAssignment_28449,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,42)
    <=> v6023(VarCurr,42) ) ).

tff(addAssignment_28448,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,42)
    <=> v6025(VarCurr,42) ) ).

tff(addAssignment_28447,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,42)
    <=> v6027(VarCurr,42) ) ).

tff(addAssignment_28446,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,42)
    <=> v52434(VarCurr,42) ) ).

tff(addAssignment_28445,axiom,
    ! [VarCurr: state_type] :
      ( v52456(VarCurr,2)
    <=> v6031(VarCurr,42) ) ).

tff(addAssignment_28444,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,42)
    <=> v6033(VarCurr,42) ) ).

tff(addAssignment_28443,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,42)
    <=> v53877(VarNext,42) ) ).

tff(addCaseBooleanConditionEqualRanges1_645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53878(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53877(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_645,axiom,
    ! [VarNext: state_type] :
      ( v53878(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53877(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53878(VarNext)
      <=> v53879(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53879(VarNext)
      <=> ( v53881(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3020,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53881(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28442,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,42)
    <=> v6057(VarCurr,42) ) ).

tff(addAssignment_28441,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,42)
    <=> v6059(VarCurr,42) ) ).

tff(addAssignment_28440,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,42)
    <=> v52880(VarCurr,2) ) ).

tff(addAssignment_28439,axiom,
    ! [VarCurr: state_type] :
      ( v52880(VarCurr,2)
    <=> v52882(VarCurr,2) ) ).

tff(addAssignment_28438,axiom,
    ! [VarCurr: state_type] :
      ( v52882(VarCurr,2)
    <=> v52899(VarCurr,2) ) ).

tff(addAssignment_28437,axiom,
    ! [VarCurr: state_type] :
      ( v52892(VarCurr,2)
    <=> v52894(VarCurr,2) ) ).

tff(addAssignment_28436,axiom,
    ! [VarCurr: state_type] :
      ( v52894(VarCurr,2)
    <=> v6069(VarCurr,42) ) ).

tff(addAssignment_28435,axiom,
    ! [VarCurr: state_type] :
      ( v52884(VarCurr,2)
    <=> v52886(VarCurr,2) ) ).

tff(addAssignment_28434,axiom,
    ! [VarCurr: state_type] :
      ( v52886(VarCurr,2)
    <=> v6069(VarCurr,46) ) ).

tff(addAssignment_28433,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,46)
    <=> v6071(VarCurr,46) ) ).

tff(addAssignment_28432,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,46)
    <=> v6073(VarCurr,46) ) ).

tff(addAssignment_28431,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,46)
    <=> v52355(VarCurr,46) ) ).

tff(addAssignment_28430,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,46)
    <=> v6096(VarCurr,46) ) ).

tff(addAssignment_28429,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,46)
    <=> v6098(VarCurr,46) ) ).

tff(addAssignment_28428,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,46)
    <=> v6100(VarCurr,46) ) ).

tff(addAssignment_28427,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,46)
    <=> v6102(VarCurr,46) ) ).

tff(addAssignment_28426,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,46)
    <=> v6104(VarCurr,46) ) ).

tff(addAssignment_28425,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,46)
    <=> v6106(VarCurr,46) ) ).

tff(addAssignment_28424,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,46)
    <=> v52338(VarCurr,46) ) ).

tff(addAssignment_28423,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,46)
    <=> v52330(VarCurr,46) ) ).

tff(addAssignment_28422,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,46)
    <=> v52332(VarCurr,46) ) ).

tff(addAssignment_28421,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,46)
    <=> v52335(VarCurr,46) ) ).

tff(addAssignment_28420,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,88)
    <=> v33839(VarCurr,88) ) ).

tff(addAssignment_28419,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,88)
    <=> v33841(VarCurr,88) ) ).

tff(addAssignment_28418,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,88)
    <=> v20355(VarCurr,4) ) ).

tff(addAssignment_28417,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,46)
    <=> v6232(VarCurr,46) ) ).

tff(addAssignment_28416,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,46)
    <=> v6234(VarCurr,46) ) ).

tff(addAssignment_28415,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,46)
    <=> v52325(VarCurr,46) ) ).

tff(addAssignment_28414,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,94)
    <=> v6238(VarCurr,94) ) ).

tff(addAssignment_28413,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,94)
    <=> v6240(VarCurr,94) ) ).

tff(addAssignment_28412,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,94)
    <=> v41649(VarCurr,10) ) ).

tff(addAssignment_28411,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,46)
    <=> v6226(VarCurr,46) ) ).

tff(addAssignment_28410,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,46)
    <=> $false ) ).

tff(addAssignment_28409,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,46)
    <=> v6077(VarCurr,46) ) ).

tff(addAssignment_28408,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,46)
    <=> v6091(VarCurr,46) ) ).

tff(addAssignment_28407,axiom,
    ! [VarCurr: state_type] :
      ( v53861(VarCurr)
    <=> v53863(VarCurr) ) ).

tff(addAssignment_28406,axiom,
    ! [VarCurr: state_type] :
      ( v53863(VarCurr)
    <=> v6017(VarCurr,38) ) ).

tff(addAssignment_28405,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,38)
    <=> v6019(VarCurr,38) ) ).

tff(addAssignment_28404,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,38)
    <=> v6021(VarCurr,38) ) ).

tff(addAssignment_28403,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,38)
    <=> v6023(VarCurr,38) ) ).

tff(addAssignment_28402,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,38)
    <=> v6025(VarCurr,38) ) ).

tff(addAssignment_28401,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,38)
    <=> v6027(VarCurr,38) ) ).

tff(addAssignment_28400,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,38)
    <=> v52434(VarCurr,38) ) ).

tff(addAssignment_28399,axiom,
    ! [VarCurr: state_type] :
      ( v52457(VarCurr,2)
    <=> v6031(VarCurr,38) ) ).

tff(addAssignment_28398,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,38)
    <=> v6033(VarCurr,38) ) ).

tff(addAssignment_28397,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,38)
    <=> v53865(VarNext,38) ) ).

tff(addCaseBooleanConditionEqualRanges1_644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53866(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53865(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_644,axiom,
    ! [VarNext: state_type] :
      ( v53866(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53865(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53866(VarNext)
      <=> v53867(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53867(VarNext)
      <=> ( v53869(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3019,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53869(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28396,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,38)
    <=> v6057(VarCurr,38) ) ).

tff(addAssignment_28395,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,38)
    <=> v6059(VarCurr,38) ) ).

tff(addAssignment_28394,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,38)
    <=> v52840(VarCurr,2) ) ).

tff(addAssignment_28393,axiom,
    ! [VarCurr: state_type] :
      ( v52840(VarCurr,2)
    <=> v52842(VarCurr,2) ) ).

tff(addAssignment_28392,axiom,
    ! [VarCurr: state_type] :
      ( v52842(VarCurr,2)
    <=> v52859(VarCurr,2) ) ).

tff(addAssignment_28391,axiom,
    ! [VarCurr: state_type] :
      ( v52852(VarCurr,2)
    <=> v52854(VarCurr,2) ) ).

tff(addAssignment_28390,axiom,
    ! [VarCurr: state_type] :
      ( v52854(VarCurr,2)
    <=> v6069(VarCurr,38) ) ).

tff(addAssignment_28389,axiom,
    ! [VarCurr: state_type] :
      ( v52844(VarCurr,2)
    <=> v52846(VarCurr,2) ) ).

tff(addAssignment_28388,axiom,
    ! [VarCurr: state_type] :
      ( v52846(VarCurr,2)
    <=> v6069(VarCurr,42) ) ).

tff(addAssignment_28387,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,42)
    <=> v6071(VarCurr,42) ) ).

tff(addAssignment_28386,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,42)
    <=> v6073(VarCurr,42) ) ).

tff(addAssignment_28385,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,42)
    <=> v52355(VarCurr,42) ) ).

tff(addAssignment_28384,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,42)
    <=> v6096(VarCurr,42) ) ).

tff(addAssignment_28383,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,42)
    <=> v6098(VarCurr,42) ) ).

tff(addAssignment_28382,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,42)
    <=> v6100(VarCurr,42) ) ).

tff(addAssignment_28381,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,42)
    <=> v6102(VarCurr,42) ) ).

tff(addAssignment_28380,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,42)
    <=> v6104(VarCurr,42) ) ).

tff(addAssignment_28379,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,42)
    <=> v6106(VarCurr,42) ) ).

tff(addAssignment_28378,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,42)
    <=> v52338(VarCurr,42) ) ).

tff(addAssignment_28377,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,42)
    <=> v52330(VarCurr,42) ) ).

tff(addAssignment_28376,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,42)
    <=> v52332(VarCurr,42) ) ).

tff(addAssignment_28375,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,42)
    <=> v52335(VarCurr,42) ) ).

tff(addAssignment_28374,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,84)
    <=> v33839(VarCurr,84) ) ).

tff(addAssignment_28373,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,84)
    <=> v33841(VarCurr,84) ) ).

tff(addAssignment_28372,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,84)
    <=> v20355(VarCurr,0) ) ).

tff(addAssignment_28371,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,42)
    <=> v6232(VarCurr,42) ) ).

tff(addAssignment_28370,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,42)
    <=> v6234(VarCurr,42) ) ).

tff(addAssignment_28369,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,42)
    <=> v52325(VarCurr,42) ) ).

tff(addAssignment_28368,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,90)
    <=> v6238(VarCurr,90) ) ).

tff(addAssignment_28367,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,90)
    <=> v6240(VarCurr,90) ) ).

tff(addAssignment_28366,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,90)
    <=> v41649(VarCurr,6) ) ).

tff(addAssignment_28365,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,42)
    <=> v6226(VarCurr,42) ) ).

tff(addAssignment_28364,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,42)
    <=> $false ) ).

tff(addAssignment_28363,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,42)
    <=> v6077(VarCurr,42) ) ).

tff(addAssignment_28362,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,42)
    <=> v6091(VarCurr,42) ) ).

tff(addAssignment_28361,axiom,
    ! [VarCurr: state_type] :
      ( v53685(VarCurr)
    <=> v53687(VarCurr) ) ).

tff(addAssignment_28360,axiom,
    ! [VarCurr: state_type] :
      ( v53687(VarCurr)
    <=> v53689(VarCurr) ) ).

tff(addAssignment_28359,axiom,
    ! [VarCurr: state_type] :
      ( v53689(VarCurr)
    <=> v53691(VarCurr) ) ).

tff(addAssignment_28358,axiom,
    ! [VarCurr: state_type] :
      ( v53691(VarCurr)
    <=> v53693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5004,axiom,
    ! [VarCurr: state_type] :
      ( v53693(VarCurr)
    <=> ( v53839(VarCurr)
      <~> v53791(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5003,axiom,
    ! [VarCurr: state_type] :
      ( v53839(VarCurr)
    <=> ( v53695(VarCurr)
      <~> v53743(VarCurr) ) ) ).

tff(addAssignment_28357,axiom,
    ! [VarCurr: state_type] :
      ( v53791(VarCurr)
    <=> v53793(VarCurr) ) ).

tff(addAssignment_28356,axiom,
    ! [VarCurr: state_type] :
      ( v53793(VarCurr)
    <=> v53795(VarCurr) ) ).

tff(addAssignment_28355,axiom,
    ! [VarCurr: state_type] :
      ( v53795(VarCurr)
    <=> v53797(VarCurr) ) ).

tff(addAssignment_28354,axiom,
    ! [VarCurr: state_type] :
      ( v53797(VarCurr)
    <=> v53799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5002,axiom,
    ! [VarCurr: state_type] :
      ( v53799(VarCurr)
    <=> ( v53837(VarCurr)
      <~> v53825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5001,axiom,
    ! [VarCurr: state_type] :
      ( v53837(VarCurr)
    <=> ( v53801(VarCurr)
      <~> v53813(VarCurr) ) ) ).

tff(addAssignment_28353,axiom,
    ! [VarCurr: state_type] :
      ( v53825(VarCurr)
    <=> v53827(VarCurr) ) ).

tff(addAssignment_28352,axiom,
    ! [VarCurr: state_type] :
      ( v53827(VarCurr)
    <=> v6017(VarCurr,34) ) ).

tff(addAssignment_28351,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,34)
    <=> v6019(VarCurr,34) ) ).

tff(addAssignment_28350,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,34)
    <=> v6021(VarCurr,34) ) ).

tff(addAssignment_28349,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,34)
    <=> v6023(VarCurr,34) ) ).

tff(addAssignment_28348,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,34)
    <=> v6025(VarCurr,34) ) ).

tff(addAssignment_28347,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,34)
    <=> v6027(VarCurr,34) ) ).

tff(addAssignment_28346,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,34)
    <=> v52434(VarCurr,34) ) ).

tff(addAssignment_28345,axiom,
    ! [VarCurr: state_type] :
      ( v52458(VarCurr,2)
    <=> v6031(VarCurr,34) ) ).

tff(addAssignment_28344,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,34)
    <=> v6033(VarCurr,34) ) ).

tff(addAssignment_28343,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,34)
    <=> v53829(VarNext,34) ) ).

tff(addCaseBooleanConditionEqualRanges1_643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53830(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53829(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_643,axiom,
    ! [VarNext: state_type] :
      ( v53830(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53829(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53830(VarNext)
      <=> v53831(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4999,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53831(VarNext)
      <=> ( v53833(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53833(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28342,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,34)
    <=> v6057(VarCurr,34) ) ).

tff(addAssignment_28341,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,34)
    <=> v6059(VarCurr,34) ) ).

tff(addAssignment_28340,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,34)
    <=> v52776(VarCurr,2) ) ).

tff(addAssignment_28339,axiom,
    ! [VarCurr: state_type] :
      ( v52776(VarCurr,2)
    <=> v52778(VarCurr,2) ) ).

tff(addAssignment_28338,axiom,
    ! [VarCurr: state_type] :
      ( v52778(VarCurr,2)
    <=> v52795(VarCurr,2) ) ).

tff(addAssignment_28337,axiom,
    ! [VarCurr: state_type] :
      ( v52788(VarCurr,2)
    <=> v52790(VarCurr,2) ) ).

tff(addAssignment_28336,axiom,
    ! [VarCurr: state_type] :
      ( v52790(VarCurr,2)
    <=> v6069(VarCurr,34) ) ).

tff(addAssignment_28335,axiom,
    ! [VarCurr: state_type] :
      ( v52780(VarCurr,2)
    <=> v52782(VarCurr,2) ) ).

tff(addAssignment_28334,axiom,
    ! [VarCurr: state_type] :
      ( v52782(VarCurr,2)
    <=> v6069(VarCurr,38) ) ).

tff(addAssignment_28333,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,38)
    <=> v6071(VarCurr,38) ) ).

tff(addAssignment_28332,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,38)
    <=> v6073(VarCurr,38) ) ).

tff(addAssignment_28331,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,38)
    <=> v52355(VarCurr,38) ) ).

tff(addAssignment_28330,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,38)
    <=> v6096(VarCurr,38) ) ).

tff(addAssignment_28329,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,38)
    <=> v6098(VarCurr,38) ) ).

tff(addAssignment_28328,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,38)
    <=> v6100(VarCurr,38) ) ).

tff(addAssignment_28327,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,38)
    <=> v6102(VarCurr,38) ) ).

tff(addAssignment_28326,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,38)
    <=> v6104(VarCurr,38) ) ).

tff(addAssignment_28325,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,38)
    <=> v6106(VarCurr,38) ) ).

tff(addAssignment_28324,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,38)
    <=> v52338(VarCurr,38) ) ).

tff(addAssignment_28323,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,38)
    <=> v52330(VarCurr,38) ) ).

tff(addAssignment_28322,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,38)
    <=> v52332(VarCurr,38) ) ).

tff(addAssignment_28321,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,38)
    <=> v52335(VarCurr,38) ) ).

tff(addAssignment_28320,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,74)
    <=> v33839(VarCurr,74) ) ).

tff(addAssignment_28319,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,74)
    <=> v33841(VarCurr,74) ) ).

tff(addAssignment_28318,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,74)
    <=> v18805(VarCurr,2) ) ).

tff(addAssignment_28317,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,38)
    <=> v6232(VarCurr,38) ) ).

tff(addAssignment_28316,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,38)
    <=> v6234(VarCurr,38) ) ).

tff(addAssignment_28315,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,38)
    <=> v52325(VarCurr,38) ) ).

tff(addAssignment_28314,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,80)
    <=> v6238(VarCurr,80) ) ).

tff(addAssignment_28313,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,80)
    <=> v6240(VarCurr,80) ) ).

tff(addAssignment_28312,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,80)
    <=> v40099(VarCurr,8) ) ).

tff(addAssignment_28311,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,38)
    <=> v6226(VarCurr,38) ) ).

tff(addAssignment_28310,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,38)
    <=> $false ) ).

tff(addAssignment_28309,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,38)
    <=> v6077(VarCurr,38) ) ).

tff(addAssignment_28308,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,38)
    <=> v6091(VarCurr,38) ) ).

tff(addAssignment_28307,axiom,
    ! [VarCurr: state_type] :
      ( v53813(VarCurr)
    <=> v53815(VarCurr) ) ).

tff(addAssignment_28306,axiom,
    ! [VarCurr: state_type] :
      ( v53815(VarCurr)
    <=> v6017(VarCurr,30) ) ).

tff(addAssignment_28305,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,30)
    <=> v6019(VarCurr,30) ) ).

tff(addAssignment_28304,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,30)
    <=> v6021(VarCurr,30) ) ).

tff(addAssignment_28303,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,30)
    <=> v6023(VarCurr,30) ) ).

tff(addAssignment_28302,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,30)
    <=> v6025(VarCurr,30) ) ).

tff(addAssignment_28301,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,30)
    <=> v6027(VarCurr,30) ) ).

tff(addAssignment_28300,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,30)
    <=> v52434(VarCurr,30) ) ).

tff(addAssignment_28299,axiom,
    ! [VarCurr: state_type] :
      ( v52459(VarCurr,2)
    <=> v6031(VarCurr,30) ) ).

tff(addAssignment_28298,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,30)
    <=> v6033(VarCurr,30) ) ).

tff(addAssignment_28297,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,30)
    <=> v53817(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53818(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53817(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_642,axiom,
    ! [VarNext: state_type] :
      ( v53818(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53817(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53818(VarNext)
      <=> v53819(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53819(VarNext)
      <=> ( v53821(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53821(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28296,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,30)
    <=> v6057(VarCurr,30) ) ).

tff(addAssignment_28295,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,30)
    <=> v6059(VarCurr,30) ) ).

tff(addAssignment_28294,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,30)
    <=> v52736(VarCurr,2) ) ).

tff(addAssignment_28293,axiom,
    ! [VarCurr: state_type] :
      ( v52736(VarCurr,2)
    <=> v52738(VarCurr,2) ) ).

tff(addAssignment_28292,axiom,
    ! [VarCurr: state_type] :
      ( v52738(VarCurr,2)
    <=> v52755(VarCurr,2) ) ).

tff(addAssignment_28291,axiom,
    ! [VarCurr: state_type] :
      ( v52748(VarCurr,2)
    <=> v52750(VarCurr,2) ) ).

tff(addAssignment_28290,axiom,
    ! [VarCurr: state_type] :
      ( v52750(VarCurr,2)
    <=> v6069(VarCurr,30) ) ).

tff(addAssignment_28289,axiom,
    ! [VarCurr: state_type] :
      ( v52740(VarCurr,2)
    <=> v52742(VarCurr,2) ) ).

tff(addAssignment_28288,axiom,
    ! [VarCurr: state_type] :
      ( v52742(VarCurr,2)
    <=> v6069(VarCurr,34) ) ).

tff(addAssignment_28287,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,34)
    <=> v6071(VarCurr,34) ) ).

tff(addAssignment_28286,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,34)
    <=> v6073(VarCurr,34) ) ).

tff(addAssignment_28285,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,34)
    <=> v52355(VarCurr,34) ) ).

tff(addAssignment_28284,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,34)
    <=> v6096(VarCurr,34) ) ).

tff(addAssignment_28283,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,34)
    <=> v6098(VarCurr,34) ) ).

tff(addAssignment_28282,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,34)
    <=> v6100(VarCurr,34) ) ).

tff(addAssignment_28281,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,34)
    <=> v6102(VarCurr,34) ) ).

tff(addAssignment_28280,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,34)
    <=> v6104(VarCurr,34) ) ).

tff(addAssignment_28279,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,34)
    <=> v6106(VarCurr,34) ) ).

tff(addAssignment_28278,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,34)
    <=> v52338(VarCurr,34) ) ).

tff(addAssignment_28277,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,34)
    <=> v52330(VarCurr,34) ) ).

tff(addAssignment_28276,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,34)
    <=> v52332(VarCurr,34) ) ).

tff(addAssignment_28275,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,34)
    <=> v52335(VarCurr,34) ) ).

tff(addAssignment_28274,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,64)
    <=> v33839(VarCurr,64) ) ).

tff(addAssignment_28273,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,64)
    <=> v33841(VarCurr,64) ) ).

tff(addAssignment_28272,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,64)
    <=> v17255(VarCurr,4) ) ).

tff(addAssignment_28271,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,34)
    <=> v6232(VarCurr,34) ) ).

tff(addAssignment_28270,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,34)
    <=> v6234(VarCurr,34) ) ).

tff(addAssignment_28269,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,34)
    <=> v52325(VarCurr,34) ) ).

tff(addAssignment_28268,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,70)
    <=> v6238(VarCurr,70) ) ).

tff(addAssignment_28267,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,70)
    <=> v6240(VarCurr,70) ) ).

tff(addAssignment_28266,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,70)
    <=> v38549(VarCurr,10) ) ).

tff(addAssignment_28265,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,34)
    <=> v6226(VarCurr,34) ) ).

tff(addAssignment_28264,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,34)
    <=> $false ) ).

tff(addAssignment_28263,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,34)
    <=> v6077(VarCurr,34) ) ).

tff(addAssignment_28262,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,34)
    <=> v6091(VarCurr,34) ) ).

tff(addAssignment_28261,axiom,
    ! [VarCurr: state_type] :
      ( v53801(VarCurr)
    <=> v53803(VarCurr) ) ).

tff(addAssignment_28260,axiom,
    ! [VarCurr: state_type] :
      ( v53803(VarCurr)
    <=> v6017(VarCurr,26) ) ).

tff(addAssignment_28259,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,26)
    <=> v6019(VarCurr,26) ) ).

tff(addAssignment_28258,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,26)
    <=> v6021(VarCurr,26) ) ).

tff(addAssignment_28257,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,26)
    <=> v6023(VarCurr,26) ) ).

tff(addAssignment_28256,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,26)
    <=> v6025(VarCurr,26) ) ).

tff(addAssignment_28255,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,26)
    <=> v6027(VarCurr,26) ) ).

tff(addAssignment_28254,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,26)
    <=> v52434(VarCurr,26) ) ).

tff(addAssignment_28253,axiom,
    ! [VarCurr: state_type] :
      ( v52460(VarCurr,2)
    <=> v6031(VarCurr,26) ) ).

tff(addAssignment_28252,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,26)
    <=> v6033(VarCurr,26) ) ).

tff(addAssignment_28251,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,26)
    <=> v53805(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53806(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53805(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_641,axiom,
    ! [VarNext: state_type] :
      ( v53806(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53805(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4996,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53806(VarNext)
      <=> v53807(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53807(VarNext)
      <=> ( v53809(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53809(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28250,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,26)
    <=> v6057(VarCurr,26) ) ).

tff(addAssignment_28249,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,26)
    <=> v6059(VarCurr,26) ) ).

tff(addAssignment_28248,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,26)
    <=> v52696(VarCurr,2) ) ).

tff(addAssignment_28247,axiom,
    ! [VarCurr: state_type] :
      ( v52696(VarCurr,2)
    <=> v52698(VarCurr,2) ) ).

tff(addAssignment_28246,axiom,
    ! [VarCurr: state_type] :
      ( v52698(VarCurr,2)
    <=> v52715(VarCurr,2) ) ).

tff(addAssignment_28245,axiom,
    ! [VarCurr: state_type] :
      ( v52708(VarCurr,2)
    <=> v52710(VarCurr,2) ) ).

tff(addAssignment_28244,axiom,
    ! [VarCurr: state_type] :
      ( v52710(VarCurr,2)
    <=> v6069(VarCurr,26) ) ).

tff(addAssignment_28243,axiom,
    ! [VarCurr: state_type] :
      ( v52700(VarCurr,2)
    <=> v52702(VarCurr,2) ) ).

tff(addAssignment_28242,axiom,
    ! [VarCurr: state_type] :
      ( v52702(VarCurr,2)
    <=> v6069(VarCurr,30) ) ).

tff(addAssignment_28241,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,30)
    <=> v6071(VarCurr,30) ) ).

tff(addAssignment_28240,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,30)
    <=> v6073(VarCurr,30) ) ).

tff(addAssignment_28239,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,30)
    <=> v52355(VarCurr,30) ) ).

tff(addAssignment_28238,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,30)
    <=> v6096(VarCurr,30) ) ).

tff(addAssignment_28237,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,30)
    <=> v6098(VarCurr,30) ) ).

tff(addAssignment_28236,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,30)
    <=> v6100(VarCurr,30) ) ).

tff(addAssignment_28235,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,30)
    <=> v6102(VarCurr,30) ) ).

tff(addAssignment_28234,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,30)
    <=> v6104(VarCurr,30) ) ).

tff(addAssignment_28233,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,30)
    <=> v6106(VarCurr,30) ) ).

tff(addAssignment_28232,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,30)
    <=> v52338(VarCurr,30) ) ).

tff(addAssignment_28231,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,30)
    <=> v52330(VarCurr,30) ) ).

tff(addAssignment_28230,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,30)
    <=> v52332(VarCurr,30) ) ).

tff(addAssignment_28229,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,30)
    <=> v52335(VarCurr,30) ) ).

tff(addAssignment_28228,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,60)
    <=> v33839(VarCurr,60) ) ).

tff(addAssignment_28227,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,60)
    <=> v33841(VarCurr,60) ) ).

tff(addAssignment_28226,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,60)
    <=> v17255(VarCurr,0) ) ).

tff(addAssignment_28225,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,30)
    <=> v6232(VarCurr,30) ) ).

tff(addAssignment_28224,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,30)
    <=> v6234(VarCurr,30) ) ).

tff(addAssignment_28223,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,30)
    <=> v52325(VarCurr,30) ) ).

tff(addAssignment_28222,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,66)
    <=> v6238(VarCurr,66) ) ).

tff(addAssignment_28221,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,66)
    <=> v6240(VarCurr,66) ) ).

tff(addAssignment_28220,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,66)
    <=> v38549(VarCurr,6) ) ).

tff(addAssignment_28219,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,30)
    <=> v6226(VarCurr,30) ) ).

tff(addAssignment_28218,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_28217,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,30)
    <=> v6077(VarCurr,30) ) ).

tff(addAssignment_28216,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,30)
    <=> v6091(VarCurr,30) ) ).

tff(addAssignment_28215,axiom,
    ! [VarCurr: state_type] :
      ( v53743(VarCurr)
    <=> v53745(VarCurr) ) ).

tff(addAssignment_28214,axiom,
    ! [VarCurr: state_type] :
      ( v53745(VarCurr)
    <=> v53747(VarCurr) ) ).

tff(addAssignment_28213,axiom,
    ! [VarCurr: state_type] :
      ( v53747(VarCurr)
    <=> v53749(VarCurr) ) ).

tff(addAssignment_28212,axiom,
    ! [VarCurr: state_type] :
      ( v53749(VarCurr)
    <=> v53751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4994,axiom,
    ! [VarCurr: state_type] :
      ( v53751(VarCurr)
    <=> ( v53789(VarCurr)
      <~> v53777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4993,axiom,
    ! [VarCurr: state_type] :
      ( v53789(VarCurr)
    <=> ( v53753(VarCurr)
      <~> v53765(VarCurr) ) ) ).

tff(addAssignment_28211,axiom,
    ! [VarCurr: state_type] :
      ( v53777(VarCurr)
    <=> v53779(VarCurr) ) ).

tff(addAssignment_28210,axiom,
    ! [VarCurr: state_type] :
      ( v53779(VarCurr)
    <=> v6017(VarCurr,22) ) ).

tff(addAssignment_28209,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,22)
    <=> v6019(VarCurr,22) ) ).

tff(addAssignment_28208,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,22)
    <=> v6021(VarCurr,22) ) ).

tff(addAssignment_28207,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,22)
    <=> v6023(VarCurr,22) ) ).

tff(addAssignment_28206,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,22)
    <=> v6025(VarCurr,22) ) ).

tff(addAssignment_28205,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,22)
    <=> v6027(VarCurr,22) ) ).

tff(addAssignment_28204,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,22)
    <=> v52434(VarCurr,22) ) ).

tff(addAssignment_28203,axiom,
    ! [VarCurr: state_type] :
      ( v52461(VarCurr,2)
    <=> v6031(VarCurr,22) ) ).

tff(addAssignment_28202,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,22)
    <=> v6033(VarCurr,22) ) ).

tff(addAssignment_28201,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,22)
    <=> v53781(VarNext,22) ) ).

tff(addCaseBooleanConditionEqualRanges1_640,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53782(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53781(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_640,axiom,
    ! [VarNext: state_type] :
      ( v53782(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53781(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53782(VarNext)
      <=> v53783(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53783(VarNext)
      <=> ( v53785(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3015,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53785(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28200,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,22)
    <=> v6057(VarCurr,22) ) ).

tff(addAssignment_28199,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,22)
    <=> v6059(VarCurr,22) ) ).

tff(addAssignment_28198,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,22)
    <=> v52644(VarCurr,2) ) ).

tff(addAssignment_28197,axiom,
    ! [VarCurr: state_type] :
      ( v52644(VarCurr,2)
    <=> v52646(VarCurr,2) ) ).

tff(addAssignment_28196,axiom,
    ! [VarCurr: state_type] :
      ( v52646(VarCurr,2)
    <=> v52663(VarCurr,2) ) ).

tff(addAssignment_28195,axiom,
    ! [VarCurr: state_type] :
      ( v52656(VarCurr,2)
    <=> v52658(VarCurr,2) ) ).

tff(addAssignment_28194,axiom,
    ! [VarCurr: state_type] :
      ( v52658(VarCurr,2)
    <=> v6069(VarCurr,22) ) ).

tff(addAssignment_28193,axiom,
    ! [VarCurr: state_type] :
      ( v52648(VarCurr,2)
    <=> v52650(VarCurr,2) ) ).

tff(addAssignment_28192,axiom,
    ! [VarCurr: state_type] :
      ( v52650(VarCurr,2)
    <=> v6069(VarCurr,26) ) ).

tff(addAssignment_28191,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,26)
    <=> v6071(VarCurr,26) ) ).

tff(addAssignment_28190,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,26)
    <=> v6073(VarCurr,26) ) ).

tff(addAssignment_28189,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,26)
    <=> v52355(VarCurr,26) ) ).

tff(addAssignment_28188,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,26)
    <=> v6096(VarCurr,26) ) ).

tff(addAssignment_28187,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,26)
    <=> v6098(VarCurr,26) ) ).

tff(addAssignment_28186,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,26)
    <=> v6100(VarCurr,26) ) ).

tff(addAssignment_28185,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,26)
    <=> v6102(VarCurr,26) ) ).

tff(addAssignment_28184,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,26)
    <=> v6104(VarCurr,26) ) ).

tff(addAssignment_28183,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,26)
    <=> v6106(VarCurr,26) ) ).

tff(addAssignment_28182,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,26)
    <=> v52338(VarCurr,26) ) ).

tff(addAssignment_28181,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,26)
    <=> v52330(VarCurr,26) ) ).

tff(addAssignment_28180,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,26)
    <=> v52332(VarCurr,26) ) ).

tff(addAssignment_28179,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,26)
    <=> v52335(VarCurr,26) ) ).

tff(addAssignment_28178,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,50)
    <=> v33839(VarCurr,50) ) ).

tff(addAssignment_28177,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,50)
    <=> v33841(VarCurr,50) ) ).

tff(addAssignment_28176,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,50)
    <=> v15705(VarCurr,2) ) ).

tff(addAssignment_28175,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,26)
    <=> v6232(VarCurr,26) ) ).

tff(addAssignment_28174,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,26)
    <=> v6234(VarCurr,26) ) ).

tff(addAssignment_28173,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,26)
    <=> v52325(VarCurr,26) ) ).

tff(addAssignment_28172,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,56)
    <=> v6238(VarCurr,56) ) ).

tff(addAssignment_28171,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,56)
    <=> v6240(VarCurr,56) ) ).

tff(addAssignment_28170,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,56)
    <=> v36999(VarCurr,8) ) ).

tff(addAssignment_28169,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,26)
    <=> v6226(VarCurr,26) ) ).

tff(addAssignment_28168,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,26)
    <=> $false ) ).

tff(addAssignment_28167,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,26)
    <=> v6077(VarCurr,26) ) ).

tff(addAssignment_28166,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,26)
    <=> v6091(VarCurr,26) ) ).

tff(addAssignment_28165,axiom,
    ! [VarCurr: state_type] :
      ( v53765(VarCurr)
    <=> v53767(VarCurr) ) ).

tff(addAssignment_28164,axiom,
    ! [VarCurr: state_type] :
      ( v53767(VarCurr)
    <=> v6017(VarCurr,18) ) ).

tff(addAssignment_28163,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,18)
    <=> v6019(VarCurr,18) ) ).

tff(addAssignment_28162,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,18)
    <=> v6021(VarCurr,18) ) ).

tff(addAssignment_28161,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,18)
    <=> v6023(VarCurr,18) ) ).

tff(addAssignment_28160,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,18)
    <=> v6025(VarCurr,18) ) ).

tff(addAssignment_28159,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,18)
    <=> v6027(VarCurr,18) ) ).

tff(addAssignment_28158,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,18)
    <=> v52434(VarCurr,18) ) ).

tff(addAssignment_28157,axiom,
    ! [VarCurr: state_type] :
      ( v52462(VarCurr,2)
    <=> v6031(VarCurr,18) ) ).

tff(addAssignment_28156,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,18)
    <=> v6033(VarCurr,18) ) ).

tff(addAssignment_28155,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,18)
    <=> v53769(VarNext,18) ) ).

tff(addCaseBooleanConditionEqualRanges1_639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53770(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53769(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_639,axiom,
    ! [VarNext: state_type] :
      ( v53770(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53769(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53770(VarNext)
      <=> v53771(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53771(VarNext)
      <=> ( v53773(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53773(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28154,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,18)
    <=> v6057(VarCurr,18) ) ).

tff(addAssignment_28153,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,18)
    <=> v6059(VarCurr,18) ) ).

tff(addAssignment_28152,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,18)
    <=> v52604(VarCurr,2) ) ).

tff(addAssignment_28151,axiom,
    ! [VarCurr: state_type] :
      ( v52604(VarCurr,2)
    <=> v52606(VarCurr,2) ) ).

tff(addAssignment_28150,axiom,
    ! [VarCurr: state_type] :
      ( v52606(VarCurr,2)
    <=> v52623(VarCurr,2) ) ).

tff(addAssignment_28149,axiom,
    ! [VarCurr: state_type] :
      ( v52616(VarCurr,2)
    <=> v52618(VarCurr,2) ) ).

tff(addAssignment_28148,axiom,
    ! [VarCurr: state_type] :
      ( v52618(VarCurr,2)
    <=> v6069(VarCurr,18) ) ).

tff(addAssignment_28147,axiom,
    ! [VarCurr: state_type] :
      ( v52608(VarCurr,2)
    <=> v52610(VarCurr,2) ) ).

tff(addAssignment_28146,axiom,
    ! [VarCurr: state_type] :
      ( v52610(VarCurr,2)
    <=> v6069(VarCurr,22) ) ).

tff(addAssignment_28145,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,22)
    <=> v6071(VarCurr,22) ) ).

tff(addAssignment_28144,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,22)
    <=> v6073(VarCurr,22) ) ).

tff(addAssignment_28143,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,22)
    <=> v52355(VarCurr,22) ) ).

tff(addAssignment_28142,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,22)
    <=> v6096(VarCurr,22) ) ).

tff(addAssignment_28141,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,22)
    <=> v6098(VarCurr,22) ) ).

tff(addAssignment_28140,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,22)
    <=> v6100(VarCurr,22) ) ).

tff(addAssignment_28139,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,22)
    <=> v6102(VarCurr,22) ) ).

tff(addAssignment_28138,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,22)
    <=> v6104(VarCurr,22) ) ).

tff(addAssignment_28137,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,22)
    <=> v6106(VarCurr,22) ) ).

tff(addAssignment_28136,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,22)
    <=> v52338(VarCurr,22) ) ).

tff(addAssignment_28135,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,22)
    <=> v52330(VarCurr,22) ) ).

tff(addAssignment_28134,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,22)
    <=> v52332(VarCurr,22) ) ).

tff(addAssignment_28133,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,22)
    <=> v52335(VarCurr,22) ) ).

tff(addAssignment_28132,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,40)
    <=> v33839(VarCurr,40) ) ).

tff(addAssignment_28131,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,40)
    <=> v33841(VarCurr,40) ) ).

tff(addAssignment_28130,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,40)
    <=> v14155(VarCurr,4) ) ).

tff(addAssignment_28129,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,22)
    <=> v6232(VarCurr,22) ) ).

tff(addAssignment_28128,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,22)
    <=> v6234(VarCurr,22) ) ).

tff(addAssignment_28127,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,22)
    <=> v52325(VarCurr,22) ) ).

tff(addAssignment_28126,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,46)
    <=> v6238(VarCurr,46) ) ).

tff(addAssignment_28125,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,46)
    <=> v6240(VarCurr,46) ) ).

tff(addAssignment_28124,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,46)
    <=> v35449(VarCurr,10) ) ).

tff(addAssignment_28123,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,22)
    <=> v6226(VarCurr,22) ) ).

tff(addAssignment_28122,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,22)
    <=> $false ) ).

tff(addAssignment_28121,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,22)
    <=> v6077(VarCurr,22) ) ).

tff(addAssignment_28120,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,22)
    <=> v6091(VarCurr,22) ) ).

tff(addAssignment_28119,axiom,
    ! [VarCurr: state_type] :
      ( v53753(VarCurr)
    <=> v53755(VarCurr) ) ).

tff(addAssignment_28118,axiom,
    ! [VarCurr: state_type] :
      ( v53755(VarCurr)
    <=> v6017(VarCurr,14) ) ).

tff(addAssignment_28117,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,14)
    <=> v6019(VarCurr,14) ) ).

tff(addAssignment_28116,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,14)
    <=> v6021(VarCurr,14) ) ).

tff(addAssignment_28115,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,14)
    <=> v6023(VarCurr,14) ) ).

tff(addAssignment_28114,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,14)
    <=> v6025(VarCurr,14) ) ).

tff(addAssignment_28113,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,14)
    <=> v6027(VarCurr,14) ) ).

tff(addAssignment_28112,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,14)
    <=> v52434(VarCurr,14) ) ).

tff(addAssignment_28111,axiom,
    ! [VarCurr: state_type] :
      ( v52463(VarCurr,2)
    <=> v6031(VarCurr,14) ) ).

tff(addAssignment_28110,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,14)
    <=> v6033(VarCurr,14) ) ).

tff(addAssignment_28109,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,14)
    <=> v53757(VarNext,14) ) ).

tff(addCaseBooleanConditionEqualRanges1_638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53758(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53757(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_638,axiom,
    ! [VarNext: state_type] :
      ( v53758(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53757(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53758(VarNext)
      <=> v53759(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4987,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53759(VarNext)
      <=> ( v53761(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53761(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28108,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,14)
    <=> v6057(VarCurr,14) ) ).

tff(addAssignment_28107,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,14)
    <=> v6059(VarCurr,14) ) ).

tff(addAssignment_28106,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,14)
    <=> v52564(VarCurr,2) ) ).

tff(addAssignment_28105,axiom,
    ! [VarCurr: state_type] :
      ( v52564(VarCurr,2)
    <=> v52566(VarCurr,2) ) ).

tff(addAssignment_28104,axiom,
    ! [VarCurr: state_type] :
      ( v52566(VarCurr,2)
    <=> v52583(VarCurr,2) ) ).

tff(addAssignment_28103,axiom,
    ! [VarCurr: state_type] :
      ( v52576(VarCurr,2)
    <=> v52578(VarCurr,2) ) ).

tff(addAssignment_28102,axiom,
    ! [VarCurr: state_type] :
      ( v52578(VarCurr,2)
    <=> v6069(VarCurr,14) ) ).

tff(addAssignment_28101,axiom,
    ! [VarCurr: state_type] :
      ( v52568(VarCurr,2)
    <=> v52570(VarCurr,2) ) ).

tff(addAssignment_28100,axiom,
    ! [VarCurr: state_type] :
      ( v52570(VarCurr,2)
    <=> v6069(VarCurr,18) ) ).

tff(addAssignment_28099,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,18)
    <=> v6071(VarCurr,18) ) ).

tff(addAssignment_28098,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,18)
    <=> v6073(VarCurr,18) ) ).

tff(addAssignment_28097,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,18)
    <=> v52355(VarCurr,18) ) ).

tff(addAssignment_28096,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,18)
    <=> v6096(VarCurr,18) ) ).

tff(addAssignment_28095,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,18)
    <=> v6098(VarCurr,18) ) ).

tff(addAssignment_28094,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,18)
    <=> v6100(VarCurr,18) ) ).

tff(addAssignment_28093,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,18)
    <=> v6102(VarCurr,18) ) ).

tff(addAssignment_28092,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,18)
    <=> v6104(VarCurr,18) ) ).

tff(addAssignment_28091,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,18)
    <=> v6106(VarCurr,18) ) ).

tff(addAssignment_28090,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,18)
    <=> v52338(VarCurr,18) ) ).

tff(addAssignment_28089,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,18)
    <=> v52330(VarCurr,18) ) ).

tff(addAssignment_28088,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,18)
    <=> v52332(VarCurr,18) ) ).

tff(addAssignment_28087,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,18)
    <=> v52335(VarCurr,18) ) ).

tff(addAssignment_28086,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,36)
    <=> v33839(VarCurr,36) ) ).

tff(addAssignment_28085,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,36)
    <=> v33841(VarCurr,36) ) ).

tff(addAssignment_28084,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,36)
    <=> v14155(VarCurr,0) ) ).

tff(addAssignment_28083,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,18)
    <=> v6232(VarCurr,18) ) ).

tff(addAssignment_28082,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,18)
    <=> v6234(VarCurr,18) ) ).

tff(addAssignment_28081,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,18)
    <=> v52325(VarCurr,18) ) ).

tff(addAssignment_28080,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,42)
    <=> v6238(VarCurr,42) ) ).

tff(addAssignment_28079,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,42)
    <=> v6240(VarCurr,42) ) ).

tff(addAssignment_28078,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,42)
    <=> v35449(VarCurr,6) ) ).

tff(addAssignment_28077,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,18)
    <=> v6226(VarCurr,18) ) ).

tff(addAssignment_28076,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,18)
    <=> $false ) ).

tff(addAssignment_28075,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,18)
    <=> v6077(VarCurr,18) ) ).

tff(addAssignment_28074,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,18)
    <=> v6091(VarCurr,18) ) ).

tff(addAssignment_28073,axiom,
    ! [VarCurr: state_type] :
      ( v53695(VarCurr)
    <=> v53697(VarCurr) ) ).

tff(addAssignment_28072,axiom,
    ! [VarCurr: state_type] :
      ( v53697(VarCurr)
    <=> v53699(VarCurr) ) ).

tff(addAssignment_28071,axiom,
    ! [VarCurr: state_type] :
      ( v53699(VarCurr)
    <=> v53701(VarCurr) ) ).

tff(addAssignment_28070,axiom,
    ! [VarCurr: state_type] :
      ( v53701(VarCurr)
    <=> v53703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4986,axiom,
    ! [VarCurr: state_type] :
      ( v53703(VarCurr)
    <=> ( v53741(VarCurr)
      <~> v53729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4985,axiom,
    ! [VarCurr: state_type] :
      ( v53741(VarCurr)
    <=> ( v53705(VarCurr)
      <~> v53717(VarCurr) ) ) ).

tff(addAssignment_28069,axiom,
    ! [VarCurr: state_type] :
      ( v53729(VarCurr)
    <=> v53731(VarCurr) ) ).

tff(addAssignment_28068,axiom,
    ! [VarCurr: state_type] :
      ( v53731(VarCurr)
    <=> v6017(VarCurr,10) ) ).

tff(addAssignment_28067,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,10)
    <=> v6019(VarCurr,10) ) ).

tff(addAssignment_28066,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,10)
    <=> v6021(VarCurr,10) ) ).

tff(addAssignment_28065,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,10)
    <=> v6023(VarCurr,10) ) ).

tff(addAssignment_28064,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,10)
    <=> v6025(VarCurr,10) ) ).

tff(addAssignment_28063,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,10)
    <=> v6027(VarCurr,10) ) ).

tff(addAssignment_28062,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,10)
    <=> v52434(VarCurr,10) ) ).

tff(addAssignment_28061,axiom,
    ! [VarCurr: state_type] :
      ( v52464(VarCurr,2)
    <=> v6031(VarCurr,10) ) ).

tff(addAssignment_28060,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,10)
    <=> v6033(VarCurr,10) ) ).

tff(addAssignment_28059,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,10)
    <=> v53733(VarNext,10) ) ).

tff(addCaseBooleanConditionEqualRanges1_637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53734(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53733(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_637,axiom,
    ! [VarNext: state_type] :
      ( v53734(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53733(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53734(VarNext)
      <=> v53735(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53735(VarNext)
      <=> ( v53737(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3012,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53737(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28058,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,10)
    <=> v6057(VarCurr,10) ) ).

tff(addAssignment_28057,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,10)
    <=> v6059(VarCurr,10) ) ).

tff(addAssignment_28056,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,10)
    <=> v52512(VarCurr,2) ) ).

tff(addAssignment_28055,axiom,
    ! [VarCurr: state_type] :
      ( v52512(VarCurr,2)
    <=> v52514(VarCurr,2) ) ).

tff(addAssignment_28054,axiom,
    ! [VarCurr: state_type] :
      ( v52514(VarCurr,2)
    <=> v52531(VarCurr,2) ) ).

tff(addAssignment_28053,axiom,
    ! [VarCurr: state_type] :
      ( v52524(VarCurr,2)
    <=> v52526(VarCurr,2) ) ).

tff(addAssignment_28052,axiom,
    ! [VarCurr: state_type] :
      ( v52526(VarCurr,2)
    <=> v6069(VarCurr,10) ) ).

tff(addAssignment_28051,axiom,
    ! [VarCurr: state_type] :
      ( v52516(VarCurr,2)
    <=> v52518(VarCurr,2) ) ).

tff(addAssignment_28050,axiom,
    ! [VarCurr: state_type] :
      ( v52518(VarCurr,2)
    <=> v6069(VarCurr,14) ) ).

tff(addAssignment_28049,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,14)
    <=> v6071(VarCurr,14) ) ).

tff(addAssignment_28048,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,14)
    <=> v6073(VarCurr,14) ) ).

tff(addAssignment_28047,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,14)
    <=> v52355(VarCurr,14) ) ).

tff(addAssignment_28046,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,14)
    <=> v6096(VarCurr,14) ) ).

tff(addAssignment_28045,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,14)
    <=> v6098(VarCurr,14) ) ).

tff(addAssignment_28044,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,14)
    <=> v6100(VarCurr,14) ) ).

tff(addAssignment_28043,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,14)
    <=> v6102(VarCurr,14) ) ).

tff(addAssignment_28042,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,14)
    <=> v6104(VarCurr,14) ) ).

tff(addAssignment_28041,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,14)
    <=> v6106(VarCurr,14) ) ).

tff(addAssignment_28040,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,14)
    <=> v52338(VarCurr,14) ) ).

tff(addAssignment_28039,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,14)
    <=> v52330(VarCurr,14) ) ).

tff(addAssignment_28038,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,14)
    <=> v52332(VarCurr,14) ) ).

tff(addAssignment_28037,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,14)
    <=> v52335(VarCurr,14) ) ).

tff(addAssignment_28036,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,26)
    <=> v33839(VarCurr,26) ) ).

tff(addAssignment_28035,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,14)
    <=> v6232(VarCurr,14) ) ).

tff(addAssignment_28034,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,14)
    <=> v6234(VarCurr,14) ) ).

tff(addAssignment_28033,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,14)
    <=> v52325(VarCurr,14) ) ).

tff(addAssignment_28032,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,32)
    <=> v6238(VarCurr,32) ) ).

tff(addAssignment_28031,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,14)
    <=> v6226(VarCurr,14) ) ).

tff(addAssignment_28030,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_28029,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,14)
    <=> v6077(VarCurr,14) ) ).

tff(addAssignment_28028,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,14)
    <=> v6091(VarCurr,14) ) ).

tff(addAssignment_28027,axiom,
    ! [VarCurr: state_type] :
      ( v53717(VarCurr)
    <=> v53719(VarCurr) ) ).

tff(addAssignment_28026,axiom,
    ! [VarCurr: state_type] :
      ( v53719(VarCurr)
    <=> v6017(VarCurr,6) ) ).

tff(addAssignment_28025,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,6)
    <=> v6019(VarCurr,6) ) ).

tff(addAssignment_28024,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,6)
    <=> v6021(VarCurr,6) ) ).

tff(addAssignment_28023,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,6)
    <=> v6023(VarCurr,6) ) ).

tff(addAssignment_28022,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,6)
    <=> v6025(VarCurr,6) ) ).

tff(addAssignment_28021,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,6)
    <=> v6027(VarCurr,6) ) ).

tff(addAssignment_28020,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,6)
    <=> v52434(VarCurr,6) ) ).

tff(addAssignment_28019,axiom,
    ! [VarCurr: state_type] :
      ( v52465(VarCurr,2)
    <=> v6031(VarCurr,6) ) ).

tff(addAssignment_28018,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,6)
    <=> v6033(VarCurr,6) ) ).

tff(addAssignment_28017,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,6)
    <=> v53721(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53722(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53721(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_636,axiom,
    ! [VarNext: state_type] :
      ( v53722(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53721(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53722(VarNext)
      <=> v53723(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53723(VarNext)
      <=> ( v53725(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53725(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_28016,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,6)
    <=> v6057(VarCurr,6) ) ).

tff(addAssignment_28015,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,6)
    <=> v6059(VarCurr,6) ) ).

tff(addAssignment_28014,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,6)
    <=> v52472(VarCurr,2) ) ).

tff(addAssignment_28013,axiom,
    ! [VarCurr: state_type] :
      ( v52472(VarCurr,2)
    <=> v52474(VarCurr,2) ) ).

tff(addAssignment_28012,axiom,
    ! [VarCurr: state_type] :
      ( v52474(VarCurr,2)
    <=> v52491(VarCurr,2) ) ).

tff(addAssignment_28011,axiom,
    ! [VarCurr: state_type] :
      ( v52484(VarCurr,2)
    <=> v52486(VarCurr,2) ) ).

tff(addAssignment_28010,axiom,
    ! [VarCurr: state_type] :
      ( v52486(VarCurr,2)
    <=> v6069(VarCurr,6) ) ).

tff(addAssignment_28009,axiom,
    ! [VarCurr: state_type] :
      ( v52476(VarCurr,2)
    <=> v52478(VarCurr,2) ) ).

tff(addAssignment_28008,axiom,
    ! [VarCurr: state_type] :
      ( v52478(VarCurr,2)
    <=> v6069(VarCurr,10) ) ).

tff(addAssignment_28007,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,10)
    <=> v6071(VarCurr,10) ) ).

tff(addAssignment_28006,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,10)
    <=> v6073(VarCurr,10) ) ).

tff(addAssignment_28005,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,10)
    <=> v52355(VarCurr,10) ) ).

tff(addAssignment_28004,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,10)
    <=> v6096(VarCurr,10) ) ).

tff(addAssignment_28003,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,10)
    <=> v6098(VarCurr,10) ) ).

tff(addAssignment_28002,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,10)
    <=> v6100(VarCurr,10) ) ).

tff(addAssignment_28001,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,10)
    <=> v6102(VarCurr,10) ) ).

tff(addAssignment_28000,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,10)
    <=> v6104(VarCurr,10) ) ).

tff(addAssignment_27999,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,10)
    <=> v6106(VarCurr,10) ) ).

tff(addAssignment_27998,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,10)
    <=> v52338(VarCurr,10) ) ).

tff(addAssignment_27997,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,10)
    <=> v52330(VarCurr,10) ) ).

tff(addAssignment_27996,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,10)
    <=> v52332(VarCurr,10) ) ).

tff(addAssignment_27995,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,10)
    <=> v52335(VarCurr,10) ) ).

tff(addAssignment_27994,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,16)
    <=> v33839(VarCurr,16) ) ).

tff(addAssignment_27993,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,10)
    <=> v6232(VarCurr,10) ) ).

tff(addAssignment_27992,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,10)
    <=> v6234(VarCurr,10) ) ).

tff(addAssignment_27991,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,10)
    <=> v52325(VarCurr,10) ) ).

tff(addAssignment_27990,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,22)
    <=> v6238(VarCurr,22) ) ).

tff(addAssignment_27989,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,10)
    <=> v6226(VarCurr,10) ) ).

tff(addAssignment_27988,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,10)
    <=> $false ) ).

tff(addAssignment_27987,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,10)
    <=> v6077(VarCurr,10) ) ).

tff(addAssignment_27986,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,10)
    <=> v6091(VarCurr,10) ) ).

tff(addAssignment_27985,axiom,
    ! [VarCurr: state_type] :
      ( v53705(VarCurr)
    <=> v53707(VarCurr) ) ).

tff(addAssignment_27984,axiom,
    ! [VarCurr: state_type] :
      ( v53707(VarCurr)
    <=> v6017(VarCurr,2) ) ).

tff(addAssignment_27983,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,2)
    <=> v6019(VarCurr,2) ) ).

tff(addAssignment_27982,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,2)
    <=> v6021(VarCurr,2) ) ).

tff(addAssignment_27981,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,2)
    <=> v6023(VarCurr,2) ) ).

tff(addAssignment_27980,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,2)
    <=> v6025(VarCurr,2) ) ).

tff(addAssignment_27979,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,2)
    <=> v6027(VarCurr,2) ) ).

tff(addAssignment_27978,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,2)
    <=> v52434(VarCurr,2) ) ).

tff(addAssignment_27977,axiom,
    ! [VarCurr: state_type] :
      ( v6029(VarCurr,2)
    <=> v6031(VarCurr,2) ) ).

tff(addAssignment_27976,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,2)
    <=> v6033(VarCurr,2) ) ).

tff(addAssignment_27975,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,2)
    <=> v53709(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53710(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53709(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_635,axiom,
    ! [VarNext: state_type] :
      ( v53710(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53709(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53710(VarNext)
      <=> v53711(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53711(VarNext)
      <=> ( v53713(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_3010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53713(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27974,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,2)
    <=> v6057(VarCurr,2) ) ).

tff(addAssignment_27973,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,2)
    <=> v6059(VarCurr,2) ) ).

tff(addAssignment_27972,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,2)
    <=> v6061(VarCurr,2) ) ).

tff(addAssignment_27971,axiom,
    ! [VarCurr: state_type] :
      ( v6061(VarCurr,2)
    <=> v6063(VarCurr,2) ) ).

tff(addAssignment_27970,axiom,
    ! [VarCurr: state_type] :
      ( v6063(VarCurr,2)
    <=> v52385(VarCurr,2) ) ).

tff(addAssignment_27969,axiom,
    ! [VarCurr: state_type] :
      ( v52371(VarCurr,2)
    <=> v52373(VarCurr,2) ) ).

tff(addAssignment_27968,axiom,
    ! [VarCurr: state_type] :
      ( v52373(VarCurr,2)
    <=> v6069(VarCurr,2) ) ).

tff(addAssignment_27967,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,2)
    <=> v6071(VarCurr,2) ) ).

tff(addAssignment_27966,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,2)
    <=> v6073(VarCurr,2) ) ).

tff(addAssignment_27965,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,2)
    <=> v52355(VarCurr,2) ) ).

tff(addAssignment_27964,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,2)
    <=> v6096(VarCurr,2) ) ).

tff(addAssignment_27963,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,2)
    <=> v6098(VarCurr,2) ) ).

tff(addAssignment_27962,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,2)
    <=> v6100(VarCurr,2) ) ).

tff(addAssignment_27961,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,2)
    <=> v6102(VarCurr,2) ) ).

tff(addAssignment_27960,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,2)
    <=> v6104(VarCurr,2) ) ).

tff(addAssignment_27959,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,2)
    <=> v6106(VarCurr,2) ) ).

tff(addAssignment_27958,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,2)
    <=> v52338(VarCurr,2) ) ).

tff(addAssignment_27957,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,2)
    <=> v52330(VarCurr,2) ) ).

tff(addAssignment_27956,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,2)
    <=> v52332(VarCurr,2) ) ).

tff(addAssignment_27955,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,2)
    <=> v52335(VarCurr,2) ) ).

tff(addAssignment_27954,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,2)
    <=> v33839(VarCurr,2) ) ).

tff(addAssignment_27953,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,2)
    <=> v6232(VarCurr,2) ) ).

tff(addAssignment_27952,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,2)
    <=> v6234(VarCurr,2) ) ).

tff(addAssignment_27951,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,2)
    <=> v52325(VarCurr,2) ) ).

tff(addAssignment_27950,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,8)
    <=> v6238(VarCurr,8) ) ).

tff(addAssignment_27949,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,2)
    <=> v6226(VarCurr,2) ) ).

tff(addAssignment_27948,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,2)
    <=> $false ) ).

tff(addAssignment_27947,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,2)
    <=> v6077(VarCurr,2) ) ).

tff(addAssignment_27946,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,2)
    <=> v6091(VarCurr,2) ) ).

tff(addAssignment_27945,axiom,
    ! [VarCurr: state_type] :
      ( v6065(VarCurr,2)
    <=> v6067(VarCurr,2) ) ).

tff(addAssignment_27944,axiom,
    ! [VarCurr: state_type] :
      ( v6067(VarCurr,2)
    <=> v6069(VarCurr,6) ) ).

tff(addAssignment_27943,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,6)
    <=> v6071(VarCurr,6) ) ).

tff(addAssignment_27942,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,6)
    <=> v6073(VarCurr,6) ) ).

tff(addAssignment_27941,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,6)
    <=> v52355(VarCurr,6) ) ).

tff(addAssignment_27940,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,6)
    <=> v6096(VarCurr,6) ) ).

tff(addAssignment_27939,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,6)
    <=> v6098(VarCurr,6) ) ).

tff(addAssignment_27938,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,6)
    <=> v6100(VarCurr,6) ) ).

tff(addAssignment_27937,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,6)
    <=> v6102(VarCurr,6) ) ).

tff(addAssignment_27936,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,6)
    <=> v6104(VarCurr,6) ) ).

tff(addAssignment_27935,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,6)
    <=> v6106(VarCurr,6) ) ).

tff(addAssignment_27934,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,6)
    <=> v52338(VarCurr,6) ) ).

tff(addAssignment_27933,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,6)
    <=> v52330(VarCurr,6) ) ).

tff(addAssignment_27932,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,6)
    <=> v52332(VarCurr,6) ) ).

tff(addAssignment_27931,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,6)
    <=> v52335(VarCurr,6) ) ).

tff(addAssignment_27930,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,12)
    <=> v33839(VarCurr,12) ) ).

tff(addAssignment_27929,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,6)
    <=> v6232(VarCurr,6) ) ).

tff(addAssignment_27928,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,6)
    <=> v6234(VarCurr,6) ) ).

tff(addAssignment_27927,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,6)
    <=> v52325(VarCurr,6) ) ).

tff(addAssignment_27926,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,18)
    <=> v6238(VarCurr,18) ) ).

tff(addAssignment_27925,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,6)
    <=> v6226(VarCurr,6) ) ).

tff(addAssignment_27924,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,6)
    <=> $false ) ).

tff(addAssignment_27923,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,6)
    <=> v6077(VarCurr,6) ) ).

tff(addAssignment_27922,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,6)
    <=> v6091(VarCurr,6) ) ).

tff(addAssignment_27921,axiom,
    ! [VarCurr: state_type] :
      ( v5971(VarCurr)
    <=> v5973(VarCurr) ) ).

tff(addAssignment_27920,axiom,
    ! [VarCurr: state_type] :
      ( v5973(VarCurr)
    <=> v5975(VarCurr,3) ) ).

tff(addAssignment_27919,axiom,
    ! [VarCurr: state_type] :
      ( v5975(VarCurr,3)
    <=> v5977(VarCurr,11) ) ).

tff(addAssignment_27918,axiom,
    ! [VarCurr: state_type] :
      ( v5977(VarCurr,11)
    <=> v5979(VarCurr,11) ) ).

tff(addAssignment_27917,axiom,
    ! [VarCurr: state_type] :
      ( v5979(VarCurr,11)
    <=> v5981(VarCurr,11) ) ).

tff(addAssignment_27916,axiom,
    ! [VarCurr: state_type] :
      ( v5981(VarCurr,11)
    <=> v5983(VarCurr,11) ) ).

tff(addAssignment_27915,axiom,
    ! [VarCurr: state_type] :
      ( v5983(VarCurr,11)
    <=> v5985(VarCurr,11) ) ).

tff(addAssignment_27914,axiom,
    ! [VarCurr: state_type] :
      ( v5985(VarCurr,11)
    <=> v53672(VarCurr,11) ) ).

tff(addAssignment_27913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53672(VarCurr,B)
      <=> v53675(VarCurr,B) ) ) ).

tff(addAssignment_27912,axiom,
    ! [VarCurr: state_type] :
      ( ( v53672(VarCurr,7)
      <=> v53674(VarCurr,3) )
      & ( v53672(VarCurr,6)
      <=> v53674(VarCurr,2) )
      & ( v53672(VarCurr,5)
      <=> v53674(VarCurr,1) )
      & ( v53672(VarCurr,4)
      <=> v53674(VarCurr,0) ) ) ).

tff(addAssignment_27911,axiom,
    ! [VarCurr: state_type] :
      ( ( v53672(VarCurr,11)
      <=> v5987(VarCurr,3) )
      & ( v53672(VarCurr,10)
      <=> v5987(VarCurr,2) )
      & ( v53672(VarCurr,9)
      <=> v5987(VarCurr,1) )
      & ( v53672(VarCurr,8)
      <=> v5987(VarCurr,0) ) ) ).

tff(addAssignment_27910,axiom,
    ! [VarCurr: state_type] :
      ( ( v53672(VarCurr,15)
      <=> v53673(VarCurr,3) )
      & ( v53672(VarCurr,14)
      <=> v53673(VarCurr,2) )
      & ( v53672(VarCurr,13)
      <=> v53673(VarCurr,1) )
      & ( v53672(VarCurr,12)
      <=> v53673(VarCurr,0) ) ) ).

tff(addAssignment_27909,axiom,
    ! [VarCurr: state_type] :
      ( v5987(VarCurr,3)
    <=> v5989(VarCurr) ) ).

tff(addAssignment_27908,axiom,
    ! [VarCurr: state_type] :
      ( v5989(VarCurr)
    <=> v5991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4978,axiom,
    ! [VarCurr: state_type] :
      ( v5991(VarCurr)
    <=> ( v53671(VarCurr)
      <~> v53569(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4977,axiom,
    ! [VarCurr: state_type] :
      ( v53671(VarCurr)
    <=> ( v5993(VarCurr)
      <~> v52815(VarCurr) ) ) ).

tff(addAssignment_27907,axiom,
    ! [VarCurr: state_type] :
      ( v53569(VarCurr)
    <=> v53571(VarCurr) ) ).

tff(addAssignment_27906,axiom,
    ! [VarCurr: state_type] :
      ( v53571(VarCurr)
    <=> v53573(VarCurr,3) ) ).

tff(addAssignment_27905,axiom,
    ! [VarCurr: state_type] :
      ( v53573(VarCurr,3)
    <=> v53575(VarCurr,3) ) ).

tff(addAssignment_27904,axiom,
    ! [VarCurr: state_type] :
      ( v53575(VarCurr,3)
    <=> v53577(VarCurr,3) ) ).

tff(addAssignment_27903,axiom,
    ! [VarCurr: state_type] :
      ( v53577(VarCurr,3)
    <=> v53579(VarCurr,3) ) ).

tff(addAssignment_27902,axiom,
    ! [VarNext: state_type] :
      ( v53579(VarNext,3)
    <=> v53653(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_634,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53654(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v53653(VarNext,B)
            <=> v53579(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_634,axiom,
    ! [VarNext: state_type] :
      ( v53654(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v53653(VarNext,B)
          <=> v53664(VarNext,B) ) ) ) ).

tff(addAssignment_27901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v53664(VarNext,B)
          <=> v53662(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v53662(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_396,axiom,
    ! [VarCurr: state_type] :
      ( v53665(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v53662(VarCurr,B)
          <=> v53601(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4976,axiom,
    ! [VarCurr: state_type] :
      ( v53665(VarCurr)
    <=> ( v53666(VarCurr)
        & v53667(VarCurr) ) ) ).

tff(writeUnaryOperator_3009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53667(VarCurr)
    <=> v53591(VarCurr) ) ).

tff(writeUnaryOperator_3008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53666(VarCurr)
    <=> v53581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53654(VarNext)
      <=> v53655(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53655(VarNext)
      <=> ( v53656(VarNext)
          & v53635(VarNext) ) ) ) ).

tff(writeUnaryOperator_3007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53656(VarNext)
      <=> v53658(VarNext) ) ) ).

tff(addAssignment_27900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53658(VarNext)
      <=> v53635(VarCurr) ) ) ).

tff(addAssignment_27899,axiom,
    ! [VarCurr: state_type] :
      ( v53635(VarCurr)
    <=> v53637(VarCurr) ) ).

tff(addAssignment_27898,axiom,
    ! [VarCurr: state_type] :
      ( v53637(VarCurr)
    <=> v53639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4973,axiom,
    ! [VarCurr: state_type] :
      ( v53639(VarCurr)
    <=> ( v53651(VarCurr)
        | v53647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4972,axiom,
    ! [VarCurr: state_type] :
      ( v53651(VarCurr)
    <=> ( v53641(VarCurr)
        & v53645(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_232,axiom,
    ( v53645(constB0)
  <=> $true ) ).

tff(addAssignment_27897,axiom,
    ! [VarCurr: state_type] :
      ( v53647(VarCurr)
    <=> v53649(VarCurr) ) ).

tff(addAssignment_27896,axiom,
    ! [VarCurr: state_type] :
      ( v53649(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addAssignment_27895,axiom,
    ! [VarCurr: state_type] :
      ( v53641(VarCurr)
    <=> v53643(VarCurr) ) ).

tff(addAssignment_27894,axiom,
    ! [VarCurr: state_type] :
      ( v53643(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_27893,axiom,
    ! [VarCurr: state_type] :
      ( v53601(VarCurr,3)
    <=> v53603(VarCurr,3) ) ).

tff(addAssignment_27892,axiom,
    ! [VarCurr: state_type] :
      ( v53603(VarCurr,3)
    <=> v53632(VarCurr,3) ) ).

tff(addAssignment_27891,axiom,
    ! [VarCurr: state_type] :
      ( ( v53632(VarCurr,6)
      <=> v53526(VarCurr,14) )
      & ( v53632(VarCurr,5)
      <=> v53526(VarCurr,13) )
      & ( v53632(VarCurr,4)
      <=> v53526(VarCurr,12) )
      & ( v53632(VarCurr,3)
      <=> v53526(VarCurr,11) )
      & ( v53632(VarCurr,2)
      <=> v53526(VarCurr,10) )
      & ( v53632(VarCurr,1)
      <=> v53526(VarCurr,9) )
      & ( v53632(VarCurr,0)
      <=> v53526(VarCurr,8) ) ) ).

tff(addAssignment_27890,axiom,
    ! [VarCurr: state_type] :
      ( v53632(VarCurr,7)
    <=> v53633(VarCurr) ) ).

tff(addAssignment_27889,axiom,
    ! [VarCurr: state_type] :
      ( v53526(VarCurr,11)
    <=> v53606(VarCurr,3) ) ).

tff(addAssignment_27888,axiom,
    ! [VarCurr: state_type] :
      ( v53606(VarCurr,3)
    <=> v53608(VarCurr,3) ) ).

tff(addAssignment_27887,axiom,
    ! [VarCurr: state_type] :
      ( v53608(VarCurr,3)
    <=> v53625(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53625(VarCurr,B)
      <=> ( v53626(VarCurr,B)
          | v53629(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53629(VarCurr,B)
      <=> ( v53618(VarCurr,B)
          & v53630(VarCurr,B) ) ) ) ).

tff(addAssignment_27886,axiom,
    ! [VarCurr: state_type] :
      ( v53630(VarCurr,0)
    <=> v53631(VarCurr) ) ).

tff(addAssignment_27885,axiom,
    ! [VarCurr: state_type] :
      ( v53630(VarCurr,1)
    <=> v53631(VarCurr) ) ).

tff(addAssignment_27884,axiom,
    ! [VarCurr: state_type] :
      ( v53630(VarCurr,2)
    <=> v53631(VarCurr) ) ).

tff(addAssignment_27883,axiom,
    ! [VarCurr: state_type] :
      ( v53630(VarCurr,3)
    <=> v53631(VarCurr) ) ).

tff(addAssignment_27882,axiom,
    ! [VarCurr: state_type] :
      ( v53631(VarCurr)
    <=> v53622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53626(VarCurr,B)
      <=> ( v53610(VarCurr,B)
          & v53627(VarCurr,B) ) ) ) ).

tff(addAssignment_27881,axiom,
    ! [VarCurr: state_type] :
      ( v53627(VarCurr,0)
    <=> v53628(VarCurr) ) ).

tff(addAssignment_27880,axiom,
    ! [VarCurr: state_type] :
      ( v53627(VarCurr,1)
    <=> v53628(VarCurr) ) ).

tff(addAssignment_27879,axiom,
    ! [VarCurr: state_type] :
      ( v53627(VarCurr,2)
    <=> v53628(VarCurr) ) ).

tff(addAssignment_27878,axiom,
    ! [VarCurr: state_type] :
      ( v53627(VarCurr,3)
    <=> v53628(VarCurr) ) ).

tff(addAssignment_27877,axiom,
    ! [VarCurr: state_type] :
      ( v53628(VarCurr)
    <=> v53614(VarCurr) ) ).

tff(addAssignment_27876,axiom,
    ! [VarCurr: state_type] :
      ( v53622(VarCurr)
    <=> v53624(VarCurr) ) ).

tff(addAssignment_27875,axiom,
    ! [VarCurr: state_type] :
      ( v53624(VarCurr)
    <=> v52379(VarCurr,33) ) ).

tff(addAssignment_27874,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,33)
    <=> v52381(VarCurr,33) ) ).

tff(addAssignment_27873,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,33)
    <=> v52383(VarCurr,33) ) ).

tff(addAssignment_27872,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,33)
    <=> v52384(VarCurr,33) ) ).

tff(addAssignment_27871,axiom,
    ! [VarCurr: state_type] :
      ( v53618(VarCurr,3)
    <=> v53620(VarCurr,3) ) ).

tff(addAssignment_27870,axiom,
    ! [VarCurr: state_type] :
      ( v53620(VarCurr,3)
    <=> v53312(VarCurr,11) ) ).

tff(addAssignment_27869,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,11)
    <=> v53314(VarCurr,11) ) ).

tff(addAssignment_27868,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,11)
    <=> v53316(VarCurr,11) ) ).

tff(addAssignment_27867,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,11)
    <=> v53407(VarCurr,11) ) ).

tff(addAssignment_27866,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,11)
    <=> v53326(VarCurr,11) ) ).

tff(addAssignment_27865,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,11)
    <=> v53328(VarCurr,11) ) ).

tff(addAssignment_27864,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,11)
    <=> v6100(VarCurr,139) ) ).

tff(addAssignment_27863,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,139)
    <=> v6102(VarCurr,139) ) ).

tff(addAssignment_27862,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,139)
    <=> v53330(VarCurr,11) ) ).

tff(addAssignment_27861,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,11)
    <=> v53332(VarCurr,11) ) ).

tff(addAssignment_27860,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,11)
    <=> v53390(VarCurr,11) ) ).

tff(addAssignment_27859,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,11)
    <=> v53387(VarCurr,11) ) ).

tff(addAssignment_27858,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,11)
    <=> v53217(VarCurr,67) ) ).

tff(addAssignment_27857,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,11)
    <=> v53383(VarCurr,11) ) ).

tff(addAssignment_27856,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,11)
    <=> v53217(VarCurr,67) ) ).

tff(addAssignment_27855,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,67)
    <=> v53218(VarCurr,67) ) ).

tff(addAssignment_27854,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,133)
    <=> v6238(VarCurr,133) ) ).

tff(addAssignment_27853,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,133)
    <=> v6240(VarCurr,133) ) ).

tff(addAssignment_27852,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,133)
    <=> v47849(VarCurr,1) ) ).

tff(addAssignment_27851,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,11)
    <=> v53379(VarCurr,11) ) ).

tff(addAssignment_27850,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_27849,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,11)
    <=> v53320(VarCurr,11) ) ).

tff(addAssignment_27848,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,11)
    <=> v53321(VarCurr,11) ) ).

tff(addAssignment_27847,axiom,
    ! [VarCurr: state_type] :
      ( v53614(VarCurr)
    <=> v53616(VarCurr) ) ).

tff(addAssignment_27846,axiom,
    ! [VarCurr: state_type] :
      ( v53616(VarCurr)
    <=> v52361(VarCurr,33) ) ).

tff(addAssignment_27845,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,33)
    <=> v52363(VarCurr,33) ) ).

tff(addAssignment_27844,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,33)
    <=> v52365(VarCurr,33) ) ).

tff(addAssignment_27843,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,33)
    <=> v52367(VarCurr,33) ) ).

tff(addAssignment_27842,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,33)
    <=> v52369(VarCurr,33) ) ).

tff(addAssignment_27841,axiom,
    ! [VarCurr: state_type] :
      ( v53610(VarCurr,3)
    <=> v53612(VarCurr,3) ) ).

tff(addAssignment_27840,axiom,
    ! [VarCurr: state_type] :
      ( v53612(VarCurr,3)
    <=> v53312(VarCurr,7) ) ).

tff(addAssignment_27839,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,7)
    <=> v53314(VarCurr,7) ) ).

tff(addAssignment_27838,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,7)
    <=> v53316(VarCurr,7) ) ).

tff(addAssignment_27837,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,7)
    <=> v53407(VarCurr,7) ) ).

tff(addAssignment_27836,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,7)
    <=> v53326(VarCurr,7) ) ).

tff(addAssignment_27835,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,7)
    <=> v53328(VarCurr,7) ) ).

tff(addAssignment_27834,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,7)
    <=> v6100(VarCurr,135) ) ).

tff(addAssignment_27833,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,135)
    <=> v6102(VarCurr,135) ) ).

tff(addAssignment_27832,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,135)
    <=> v53330(VarCurr,7) ) ).

tff(addAssignment_27831,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,7)
    <=> v53332(VarCurr,7) ) ).

tff(addAssignment_27830,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,7)
    <=> v53390(VarCurr,7) ) ).

tff(addAssignment_27829,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,7)
    <=> v53387(VarCurr,7) ) ).

tff(addAssignment_27828,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,7)
    <=> v53217(VarCurr,63) ) ).

tff(addAssignment_27827,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,7)
    <=> v53383(VarCurr,7) ) ).

tff(addAssignment_27826,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,7)
    <=> v53217(VarCurr,63) ) ).

tff(addAssignment_27825,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,63)
    <=> v53218(VarCurr,63) ) ).

tff(addAssignment_27824,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,123)
    <=> v6238(VarCurr,123) ) ).

tff(addAssignment_27823,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,123)
    <=> v6240(VarCurr,123) ) ).

tff(addAssignment_27822,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,123)
    <=> v46299(VarCurr,3) ) ).

tff(addAssignment_27821,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,7)
    <=> v53379(VarCurr,7) ) ).

tff(addAssignment_27820,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,7)
    <=> $false ) ).

tff(addAssignment_27819,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,7)
    <=> v53320(VarCurr,7) ) ).

tff(addAssignment_27818,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,7)
    <=> v53321(VarCurr,7) ) ).

tff(addAssignment_27817,axiom,
    ! [VarCurr: state_type] :
      ( v53591(VarCurr)
    <=> v53593(VarCurr) ) ).

tff(addAssignment_27816,axiom,
    ! [VarCurr: state_type] :
      ( v53593(VarCurr)
    <=> v53595(VarCurr) ) ).

tff(addAssignment_27815,axiom,
    ! [VarCurr: state_type] :
      ( v53595(VarCurr)
    <=> v53597(VarCurr) ) ).

tff(addAssignment_27814,axiom,
    ! [VarCurr: state_type] :
      ( v53597(VarCurr)
    <=> v53599(VarCurr) ) ).

tff(addAssignment_27813,axiom,
    ! [VarCurr: state_type] :
      ( v53599(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_27812,axiom,
    ! [VarCurr: state_type] :
      ( v53581(VarCurr)
    <=> v53583(VarCurr) ) ).

tff(addAssignment_27811,axiom,
    ! [VarCurr: state_type] :
      ( v53583(VarCurr)
    <=> v53585(VarCurr) ) ).

tff(addAssignment_27810,axiom,
    ! [VarCurr: state_type] :
      ( v53585(VarCurr)
    <=> v53587(VarCurr) ) ).

tff(addAssignment_27809,axiom,
    ! [VarCurr: state_type] :
      ( v53587(VarCurr)
    <=> v53589(VarCurr) ) ).

tff(addAssignment_27808,axiom,
    ! [VarCurr: state_type] :
      ( v53589(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(addAssignment_27807,axiom,
    ! [VarCurr: state_type] :
      ( v52815(VarCurr)
    <=> v52817(VarCurr) ) ).

tff(addAssignment_27806,axiom,
    ! [VarCurr: state_type] :
      ( v52817(VarCurr)
    <=> v52819(VarCurr) ) ).

tff(addAssignment_27805,axiom,
    ! [VarCurr: state_type] :
      ( v52819(VarCurr)
    <=> v52821(VarCurr) ) ).

tff(addAssignment_27804,axiom,
    ! [VarCurr: state_type] :
      ( v52821(VarCurr)
    <=> v52823(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4971,axiom,
    ! [VarCurr: state_type] :
      ( v52823(VarCurr)
    <=> ( v53567(VarCurr)
      <~> v53089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4970,axiom,
    ! [VarCurr: state_type] :
      ( v53567(VarCurr)
    <=> ( v52825(VarCurr)
      <~> v52957(VarCurr) ) ) ).

tff(addAssignment_27803,axiom,
    ! [VarCurr: state_type] :
      ( v53089(VarCurr)
    <=> v53091(VarCurr) ) ).

tff(addAssignment_27802,axiom,
    ! [VarCurr: state_type] :
      ( v53091(VarCurr)
    <=> v53093(VarCurr) ) ).

tff(addAssignment_27801,axiom,
    ! [VarCurr: state_type] :
      ( v53093(VarCurr)
    <=> v53095(VarCurr) ) ).

tff(addAssignment_27800,axiom,
    ! [VarCurr: state_type] :
      ( v53095(VarCurr)
    <=> v53097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4969,axiom,
    ! [VarCurr: state_type] :
      ( v53097(VarCurr)
    <=> ( v53565(VarCurr)
      <~> v53436(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4968,axiom,
    ! [VarCurr: state_type] :
      ( v53565(VarCurr)
    <=> ( v53099(VarCurr)
      <~> v53299(VarCurr) ) ) ).

tff(addAssignment_27799,axiom,
    ! [VarCurr: state_type] :
      ( v53436(VarCurr)
    <=> v53438(VarCurr) ) ).

tff(addAssignment_27798,axiom,
    ! [VarCurr: state_type] :
      ( v53438(VarCurr)
    <=> v53440(VarCurr) ) ).

tff(addAssignment_27797,axiom,
    ! [VarCurr: state_type] :
      ( v53440(VarCurr)
    <=> v53442(VarCurr,1) ) ).

tff(addAssignment_27796,axiom,
    ! [VarCurr: state_type] :
      ( v53442(VarCurr,1)
    <=> v53444(VarCurr,1) ) ).

tff(addAssignment_27795,axiom,
    ! [VarCurr: state_type] :
      ( v53444(VarCurr,1)
    <=> v53446(VarCurr,1) ) ).

tff(addAssignment_27794,axiom,
    ! [VarCurr: state_type] :
      ( v53446(VarCurr,1)
    <=> v53448(VarCurr,1) ) ).

tff(addAssignment_27793,axiom,
    ! [VarCurr: state_type] :
      ( v53448(VarCurr,1)
    <=> v53563(VarCurr,1) ) ).

tff(addAssignment_27792,axiom,
    ! [VarCurr: state_type] :
      ( v53563(VarCurr,0)
    <=> v53450(VarCurr) ) ).

tff(addAssignment_27791,axiom,
    ! [VarCurr: state_type] :
      ( v53563(VarCurr,1)
    <=> v53450(VarCurr) ) ).

tff(addAssignment_27790,axiom,
    ! [VarCurr: state_type] :
      ( v53450(VarCurr)
    <=> v53452(VarCurr) ) ).

tff(addAssignment_27789,axiom,
    ! [VarCurr: state_type] :
      ( v53452(VarCurr)
    <=> v53454(VarCurr,0) ) ).

tff(addAssignment_27788,axiom,
    ! [VarCurr: state_type] :
      ( v53454(VarCurr,0)
    <=> v53456(VarCurr,0) ) ).

tff(addAssignment_27787,axiom,
    ! [VarNext: state_type] :
      ( v53456(VarNext,0)
    <=> v53546(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53547(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v53546(VarNext,B)
            <=> v53456(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_633,axiom,
    ! [VarNext: state_type] :
      ( v53547(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v53546(VarNext,B)
          <=> v53557(VarNext,B) ) ) ) ).

tff(addAssignment_27786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v53557(VarNext,B)
          <=> v53555(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v53555(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_395,axiom,
    ! [VarCurr: state_type] :
      ( v53558(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v53555(VarCurr,B)
          <=> v53478(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4967,axiom,
    ! [VarCurr: state_type] :
      ( v53558(VarCurr)
    <=> ( v53559(VarCurr)
        & v53560(VarCurr) ) ) ).

tff(writeUnaryOperator_3006,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53560(VarCurr)
    <=> v53468(VarCurr) ) ).

tff(writeUnaryOperator_3005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53559(VarCurr)
    <=> v53458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53547(VarNext)
      <=> v53548(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53548(VarNext)
      <=> ( v53549(VarNext)
          & v53528(VarNext) ) ) ) ).

tff(writeUnaryOperator_3004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53549(VarNext)
      <=> v53551(VarNext) ) ) ).

tff(addAssignment_27785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53551(VarNext)
      <=> v53528(VarCurr) ) ) ).

tff(addAssignment_27784,axiom,
    ! [VarCurr: state_type] :
      ( v53528(VarCurr)
    <=> v53530(VarCurr) ) ).

tff(addAssignment_27783,axiom,
    ! [VarCurr: state_type] :
      ( v53530(VarCurr)
    <=> v53532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4964,axiom,
    ! [VarCurr: state_type] :
      ( v53532(VarCurr)
    <=> ( v53544(VarCurr)
        | v53540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4963,axiom,
    ! [VarCurr: state_type] :
      ( v53544(VarCurr)
    <=> ( v53534(VarCurr)
        & v53538(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_231,axiom,
    ( v53538(constB0)
  <=> $true ) ).

tff(addAssignment_27782,axiom,
    ! [VarCurr: state_type] :
      ( v53540(VarCurr)
    <=> v53542(VarCurr) ) ).

tff(addAssignment_27781,axiom,
    ! [VarCurr: state_type] :
      ( v53542(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addAssignment_27780,axiom,
    ! [VarCurr: state_type] :
      ( v53534(VarCurr)
    <=> v53536(VarCurr) ) ).

tff(addAssignment_27779,axiom,
    ! [VarCurr: state_type] :
      ( v53536(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_27778,axiom,
    ! [VarCurr: state_type] :
      ( v53478(VarCurr,0)
    <=> v53480(VarCurr,0) ) ).

tff(addAssignment_27777,axiom,
    ! [VarCurr: state_type] :
      ( v53480(VarCurr,0)
    <=> v53525(VarCurr,0) ) ).

tff(addAssignment_27776,axiom,
    ! [VarCurr: state_type] :
      ( v53525(VarCurr,0)
    <=> v53482(VarCurr) ) ).

tff(addAssignment_27775,axiom,
    ! [VarCurr: state_type] :
      ( ( v53525(VarCurr,8)
      <=> v53526(VarCurr,7) )
      & ( v53525(VarCurr,7)
      <=> v53526(VarCurr,6) )
      & ( v53525(VarCurr,6)
      <=> v53526(VarCurr,5) )
      & ( v53525(VarCurr,5)
      <=> v53526(VarCurr,4) )
      & ( v53525(VarCurr,4)
      <=> v53526(VarCurr,3) )
      & ( v53525(VarCurr,3)
      <=> v53526(VarCurr,2) )
      & ( v53525(VarCurr,2)
      <=> v53526(VarCurr,1) )
      & ( v53525(VarCurr,1)
      <=> v53526(VarCurr,0) ) ) ).

tff(addAssignment_27774,axiom,
    ! [VarCurr: state_type] :
      ( v53482(VarCurr)
    <=> v53484(VarCurr) ) ).

tff(addAssignment_27773,axiom,
    ! [VarCurr: state_type] :
      ( v53484(VarCurr)
    <=> v53486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4962,axiom,
    ! [VarCurr: state_type] :
      ( v53486(VarCurr)
    <=> ( v2036(VarCurr)
        & v53524(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1001(VarCurr)
     => ( v53524(VarCurr)
      <=> v5593(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_394,axiom,
    ! [VarCurr: state_type] :
      ( v1001(VarCurr)
     => ( v53524(VarCurr)
      <=> v53488(VarCurr) ) ) ).

tff(addAssignment_27772,axiom,
    ! [VarCurr: state_type] :
      ( v5593(VarCurr)
    <=> v964(VarCurr,9) ) ).

tff(addAssignment_27771,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,9)
    <=> v966(VarCurr,9) ) ).

tff(addAssignment_27770,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,9)
    <=> v5526(VarCurr,9) ) ).

tff(addAssignment_27769,axiom,
    ! [VarCurr: state_type] :
      ( v53488(VarCurr)
    <=> v53490(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4961,axiom,
    ! [VarCurr: state_type] :
      ( v53490(VarCurr)
    <=> ( v53492(VarCurr)
        | v53521(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_591,axiom,
    ! [VarCurr: state_type] :
      ( v53521(VarCurr)
    <=> ( v5588(VarCurr)
        & v5418(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4960,axiom,
    ! [VarCurr: state_type] :
      ( v53492(VarCurr)
    <=> ( v53493(VarCurr)
        | v53520(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_590,axiom,
    ! [VarCurr: state_type] :
      ( v53520(VarCurr)
    <=> ( v5585(VarCurr)
        & v5521(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4959,axiom,
    ! [VarCurr: state_type] :
      ( v53493(VarCurr)
    <=> ( v53494(VarCurr)
        | v53519(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_589,axiom,
    ! [VarCurr: state_type] :
      ( v53519(VarCurr)
    <=> ( v5582(VarCurr)
        & v5514(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4958,axiom,
    ! [VarCurr: state_type] :
      ( v53494(VarCurr)
    <=> ( v53495(VarCurr)
        | v53518(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_588,axiom,
    ! [VarCurr: state_type] :
      ( v53518(VarCurr)
    <=> ( v5579(VarCurr)
        & v5507(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4957,axiom,
    ! [VarCurr: state_type] :
      ( v53495(VarCurr)
    <=> ( v53496(VarCurr)
        | v53517(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_587,axiom,
    ! [VarCurr: state_type] :
      ( v53517(VarCurr)
    <=> ( v5576(VarCurr)
        & v5500(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4956,axiom,
    ! [VarCurr: state_type] :
      ( v53496(VarCurr)
    <=> ( v53497(VarCurr)
        | v53516(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_586,axiom,
    ! [VarCurr: state_type] :
      ( v53516(VarCurr)
    <=> ( v5573(VarCurr)
        & v5493(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4955,axiom,
    ! [VarCurr: state_type] :
      ( v53497(VarCurr)
    <=> ( v53498(VarCurr)
        | v53515(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_585,axiom,
    ! [VarCurr: state_type] :
      ( v53515(VarCurr)
    <=> ( v5570(VarCurr)
        & v5487(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4954,axiom,
    ! [VarCurr: state_type] :
      ( v53498(VarCurr)
    <=> ( v53499(VarCurr)
        | v53514(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_584,axiom,
    ! [VarCurr: state_type] :
      ( v53514(VarCurr)
    <=> ( v5567(VarCurr)
        & v5480(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4953,axiom,
    ! [VarCurr: state_type] :
      ( v53499(VarCurr)
    <=> ( v53500(VarCurr)
        | v53513(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_583,axiom,
    ! [VarCurr: state_type] :
      ( v53513(VarCurr)
    <=> ( v5564(VarCurr)
        & v5473(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4952,axiom,
    ! [VarCurr: state_type] :
      ( v53500(VarCurr)
    <=> ( v53501(VarCurr)
        | v53512(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_582,axiom,
    ! [VarCurr: state_type] :
      ( v53512(VarCurr)
    <=> ( v5561(VarCurr)
        & v5466(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4951,axiom,
    ! [VarCurr: state_type] :
      ( v53501(VarCurr)
    <=> ( v53502(VarCurr)
        | v53511(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_581,axiom,
    ! [VarCurr: state_type] :
      ( v53511(VarCurr)
    <=> ( v5558(VarCurr)
        & v5459(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4950,axiom,
    ! [VarCurr: state_type] :
      ( v53502(VarCurr)
    <=> ( v53503(VarCurr)
        | v53510(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_580,axiom,
    ! [VarCurr: state_type] :
      ( v53510(VarCurr)
    <=> ( v5555(VarCurr)
        & v5452(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4949,axiom,
    ! [VarCurr: state_type] :
      ( v53503(VarCurr)
    <=> ( v53504(VarCurr)
        | v53509(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_579,axiom,
    ! [VarCurr: state_type] :
      ( v53509(VarCurr)
    <=> ( v5552(VarCurr)
        & v5445(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4948,axiom,
    ! [VarCurr: state_type] :
      ( v53504(VarCurr)
    <=> ( v53505(VarCurr)
        | v53508(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_578,axiom,
    ! [VarCurr: state_type] :
      ( v53508(VarCurr)
    <=> ( v5549(VarCurr)
        & v5438(VarCurr,9) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4947,axiom,
    ! [VarCurr: state_type] :
      ( v53505(VarCurr)
    <=> ( v53506(VarCurr)
        | v53507(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_577,axiom,
    ! [VarCurr: state_type] :
      ( v53507(VarCurr)
    <=> ( v5546(VarCurr)
        & v5431(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_576,axiom,
    ! [VarCurr: state_type] :
      ( v53506(VarCurr)
    <=> ( v5543(VarCurr)
        & v5424(VarCurr,9) ) ) ).

tff(addAssignment_27768,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,9)
    <=> v5420(VarCurr,9) ) ).

tff(addAssignment_27767,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,9)
    <=> v5422(VarCurr,9) ) ).

tff(addAssignment_27766,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,9)
    <=> v5523(VarCurr,9) ) ).

tff(addAssignment_27765,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,9)
    <=> v5525(VarCurr,9) ) ).

tff(addAssignment_27764,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,9)
    <=> v5516(VarCurr,9) ) ).

tff(addAssignment_27763,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,9)
    <=> v5518(VarCurr,9) ) ).

tff(addAssignment_27762,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,9)
    <=> v5509(VarCurr,9) ) ).

tff(addAssignment_27761,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,9)
    <=> v5511(VarCurr,9) ) ).

tff(addAssignment_27760,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,9)
    <=> v5502(VarCurr,9) ) ).

tff(addAssignment_27759,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,9)
    <=> v5504(VarCurr,9) ) ).

tff(addAssignment_27758,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,9)
    <=> v5495(VarCurr,9) ) ).

tff(addAssignment_27757,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,9)
    <=> v5497(VarCurr,9) ) ).

tff(addAssignment_27756,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,9)
    <=> v5489(VarCurr,9) ) ).

tff(addAssignment_27755,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,9)
    <=> v5491(VarCurr,9) ) ).

tff(addAssignment_27754,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,9)
    <=> v5482(VarCurr,9) ) ).

tff(addAssignment_27753,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,9)
    <=> v5484(VarCurr,9) ) ).

tff(addAssignment_27752,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,9)
    <=> v5475(VarCurr,9) ) ).

tff(addAssignment_27751,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,9)
    <=> v5477(VarCurr,9) ) ).

tff(addAssignment_27750,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,9)
    <=> v5468(VarCurr,9) ) ).

tff(addAssignment_27749,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,9)
    <=> v5470(VarCurr,9) ) ).

tff(addAssignment_27748,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,9)
    <=> v5461(VarCurr,9) ) ).

tff(addAssignment_27747,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,9)
    <=> v5463(VarCurr,9) ) ).

tff(addAssignment_27746,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,9)
    <=> v5454(VarCurr,9) ) ).

tff(addAssignment_27745,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,9)
    <=> v5456(VarCurr,9) ) ).

tff(addAssignment_27744,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,9)
    <=> v5447(VarCurr,9) ) ).

tff(addAssignment_27743,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,9)
    <=> v5449(VarCurr,9) ) ).

tff(addAssignment_27742,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,9)
    <=> v5440(VarCurr,9) ) ).

tff(addAssignment_27741,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,9)
    <=> v5442(VarCurr,9) ) ).

tff(addAssignment_27740,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,9)
    <=> v5433(VarCurr,9) ) ).

tff(addAssignment_27739,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,9)
    <=> v5435(VarCurr,9) ) ).

tff(addAssignment_27738,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,9)
    <=> v5426(VarCurr,9) ) ).

tff(addAssignment_27737,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,9)
    <=> v5428(VarCurr,9) ) ).

tff(addAssignment_27736,axiom,
    ! [VarCurr: state_type] :
      ( v53468(VarCurr)
    <=> v53470(VarCurr) ) ).

tff(addAssignment_27735,axiom,
    ! [VarCurr: state_type] :
      ( v53470(VarCurr)
    <=> v53472(VarCurr) ) ).

tff(addAssignment_27734,axiom,
    ! [VarCurr: state_type] :
      ( v53472(VarCurr)
    <=> v53474(VarCurr) ) ).

tff(addAssignment_27733,axiom,
    ! [VarCurr: state_type] :
      ( v53474(VarCurr)
    <=> v53476(VarCurr) ) ).

tff(addAssignment_27732,axiom,
    ! [VarCurr: state_type] :
      ( v53476(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_27731,axiom,
    ! [VarCurr: state_type] :
      ( v53458(VarCurr)
    <=> v53460(VarCurr) ) ).

tff(addAssignment_27730,axiom,
    ! [VarCurr: state_type] :
      ( v53460(VarCurr)
    <=> v53462(VarCurr) ) ).

tff(addAssignment_27729,axiom,
    ! [VarCurr: state_type] :
      ( v53462(VarCurr)
    <=> v53464(VarCurr) ) ).

tff(addAssignment_27728,axiom,
    ! [VarCurr: state_type] :
      ( v53464(VarCurr)
    <=> v53466(VarCurr) ) ).

tff(addAssignment_27727,axiom,
    ! [VarCurr: state_type] :
      ( v53466(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(addAssignment_27726,axiom,
    ! [VarCurr: state_type] :
      ( v53299(VarCurr)
    <=> v53301(VarCurr) ) ).

tff(addAssignment_27725,axiom,
    ! [VarCurr: state_type] :
      ( v53301(VarCurr)
    <=> v6017(VarCurr,127) ) ).

tff(addAssignment_27724,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,127)
    <=> v53103(VarCurr,63) ) ).

tff(addAssignment_27723,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,63)
    <=> v53105(VarCurr,63) ) ).

tff(addAssignment_27722,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,63)
    <=> v53107(VarCurr,63) ) ).

tff(addAssignment_27721,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,63)
    <=> v53109(VarCurr,63) ) ).

tff(addAssignment_27720,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,63)
    <=> v6027(VarCurr,127) ) ).

tff(addAssignment_27719,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,127)
    <=> v52434(VarCurr,127) ) ).

tff(addAssignment_27718,axiom,
    ! [VarCurr: state_type] :
      ( v52435(VarCurr,3)
    <=> v53112(VarCurr,63) ) ).

tff(addAssignment_27717,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,63)
    <=> v53114(VarCurr,63) ) ).

tff(addAssignment_27716,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,63)
    <=> v53428(VarNext,63) ) ).

tff(addCaseBooleanConditionEqualRanges1_632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53429(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53428(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_632,axiom,
    ! [VarNext: state_type] :
      ( v53429(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53428(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53429(VarNext)
      <=> v53430(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53430(VarNext)
      <=> ( v53432(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_3003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53432(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_27715,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,63)
    <=> v53138(VarCurr,63) ) ).

tff(addAssignment_27714,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,63)
    <=> v6059(VarCurr,127) ) ).

tff(addAssignment_27713,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,127)
    <=> v53304(VarCurr,3) ) ).

tff(addAssignment_27712,axiom,
    ! [VarCurr: state_type] :
      ( v53304(VarCurr,3)
    <=> v53306(VarCurr,3) ) ).

tff(addAssignment_27711,axiom,
    ! [VarCurr: state_type] :
      ( v53306(VarCurr,3)
    <=> v53420(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53420(VarCurr,B)
      <=> ( v53421(VarCurr,B)
          | v53424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53424(VarCurr,B)
      <=> ( v53413(VarCurr,B)
          & v53425(VarCurr,B) ) ) ) ).

tff(addAssignment_27710,axiom,
    ! [VarCurr: state_type] :
      ( v53425(VarCurr,0)
    <=> v53426(VarCurr) ) ).

tff(addAssignment_27709,axiom,
    ! [VarCurr: state_type] :
      ( v53425(VarCurr,1)
    <=> v53426(VarCurr) ) ).

tff(addAssignment_27708,axiom,
    ! [VarCurr: state_type] :
      ( v53425(VarCurr,2)
    <=> v53426(VarCurr) ) ).

tff(addAssignment_27707,axiom,
    ! [VarCurr: state_type] :
      ( v53425(VarCurr,3)
    <=> v53426(VarCurr) ) ).

tff(addAssignment_27706,axiom,
    ! [VarCurr: state_type] :
      ( v53426(VarCurr)
    <=> v53417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53421(VarCurr,B)
      <=> ( v53308(VarCurr,B)
          & v53422(VarCurr,B) ) ) ) ).

tff(addAssignment_27705,axiom,
    ! [VarCurr: state_type] :
      ( v53422(VarCurr,0)
    <=> v53423(VarCurr) ) ).

tff(addAssignment_27704,axiom,
    ! [VarCurr: state_type] :
      ( v53422(VarCurr,1)
    <=> v53423(VarCurr) ) ).

tff(addAssignment_27703,axiom,
    ! [VarCurr: state_type] :
      ( v53422(VarCurr,2)
    <=> v53423(VarCurr) ) ).

tff(addAssignment_27702,axiom,
    ! [VarCurr: state_type] :
      ( v53422(VarCurr,3)
    <=> v53423(VarCurr) ) ).

tff(addAssignment_27701,axiom,
    ! [VarCurr: state_type] :
      ( v53423(VarCurr)
    <=> v53409(VarCurr) ) ).

tff(addAssignment_27700,axiom,
    ! [VarCurr: state_type] :
      ( v53417(VarCurr)
    <=> v53419(VarCurr) ) ).

tff(addAssignment_27699,axiom,
    ! [VarCurr: state_type] :
      ( v53419(VarCurr)
    <=> v52379(VarCurr,31) ) ).

tff(addAssignment_27698,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,31)
    <=> v52381(VarCurr,31) ) ).

tff(addAssignment_27697,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,31)
    <=> v52383(VarCurr,31) ) ).

tff(addAssignment_27696,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,31)
    <=> v52384(VarCurr,31) ) ).

tff(addAssignment_27695,axiom,
    ! [VarCurr: state_type] :
      ( v53413(VarCurr,3)
    <=> v53415(VarCurr,3) ) ).

tff(addAssignment_27694,axiom,
    ! [VarCurr: state_type] :
      ( v53415(VarCurr,3)
    <=> v6069(VarCurr,127) ) ).

tff(addAssignment_27693,axiom,
    ! [VarCurr: state_type] :
      ( v53409(VarCurr)
    <=> v53411(VarCurr) ) ).

tff(addAssignment_27692,axiom,
    ! [VarCurr: state_type] :
      ( v53411(VarCurr)
    <=> v52361(VarCurr,31) ) ).

tff(addAssignment_27691,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,31)
    <=> v52363(VarCurr,31) ) ).

tff(addAssignment_27690,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,31)
    <=> v52365(VarCurr,31) ) ).

tff(addAssignment_27689,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,31)
    <=> v52367(VarCurr,31) ) ).

tff(addAssignment_27688,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,31)
    <=> v52369(VarCurr,31) ) ).

tff(addAssignment_27687,axiom,
    ! [VarCurr: state_type] :
      ( v53308(VarCurr,3)
    <=> v53310(VarCurr,3) ) ).

tff(addAssignment_27686,axiom,
    ! [VarCurr: state_type] :
      ( v53310(VarCurr,3)
    <=> v53312(VarCurr,15) ) ).

tff(addAssignment_27685,axiom,
    ! [VarCurr: state_type] :
      ( v53312(VarCurr,15)
    <=> v53314(VarCurr,15) ) ).

tff(addAssignment_27684,axiom,
    ! [VarCurr: state_type] :
      ( v53314(VarCurr,15)
    <=> v53316(VarCurr,15) ) ).

tff(addAssignment_27683,axiom,
    ! [VarCurr: state_type] :
      ( v53316(VarCurr,15)
    <=> v53407(VarCurr,15) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_884,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v53407(VarCurr,B)
      <=> ( v53318(VarCurr,B)
          & v53324(VarCurr,B) ) ) ) ).

tff(addAssignment_27682,axiom,
    ! [VarCurr: state_type] :
      ( v53324(VarCurr,15)
    <=> v53326(VarCurr,15) ) ).

tff(addAssignment_27681,axiom,
    ! [VarCurr: state_type] :
      ( v53326(VarCurr,15)
    <=> v53328(VarCurr,15) ) ).

tff(addAssignment_27680,axiom,
    ! [VarCurr: state_type] :
      ( v53328(VarCurr,15)
    <=> v6100(VarCurr,143) ) ).

tff(addAssignment_27679,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,143)
    <=> v6102(VarCurr,143) ) ).

tff(addAssignment_27678,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,143)
    <=> v53330(VarCurr,15) ) ).

tff(addAssignment_27677,axiom,
    ! [VarCurr: state_type] :
      ( v53330(VarCurr,15)
    <=> v53332(VarCurr,15) ) ).

tff(addAssignment_27676,axiom,
    ! [VarCurr: state_type] :
      ( v53332(VarCurr,15)
    <=> v53390(VarCurr,15) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_2,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v53391(VarCurr)
        & ~ v53396(VarCurr)
        & ~ v53400(VarCurr)
        & ~ v53403(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v53390(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_2,axiom,
    ! [VarCurr: state_type] :
      ( v53403(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v53390(VarCurr,B)
          <=> $true ) ) ) ).

tff(bitBlastConstant_1017,axiom,
    b1111111111111111(15) ).

tff(bitBlastConstant_1016,axiom,
    b1111111111111111(14) ).

tff(bitBlastConstant_1015,axiom,
    b1111111111111111(13) ).

tff(bitBlastConstant_1014,axiom,
    b1111111111111111(12) ).

tff(bitBlastConstant_1013,axiom,
    b1111111111111111(11) ).

tff(bitBlastConstant_1012,axiom,
    b1111111111111111(10) ).

tff(bitBlastConstant_1011,axiom,
    b1111111111111111(9) ).

tff(bitBlastConstant_1010,axiom,
    b1111111111111111(8) ).

tff(bitBlastConstant_1009,axiom,
    b1111111111111111(7) ).

tff(bitBlastConstant_1008,axiom,
    b1111111111111111(6) ).

tff(bitBlastConstant_1007,axiom,
    b1111111111111111(5) ).

tff(bitBlastConstant_1006,axiom,
    b1111111111111111(4) ).

tff(bitBlastConstant_1005,axiom,
    b1111111111111111(3) ).

tff(bitBlastConstant_1004,axiom,
    b1111111111111111(2) ).

tff(bitBlastConstant_1003,axiom,
    b1111111111111111(1) ).

tff(bitBlastConstant_1002,axiom,
    b1111111111111111(0) ).

tff(addParallelCaseBooleanConditionEqualRanges2_2,axiom,
    ! [VarCurr: state_type] :
      ( v53400(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v53390(VarCurr,B)
          <=> v53385(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_9,axiom,
    ! [VarCurr: state_type] :
      ( v53396(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v53390(VarCurr,B)
          <=> v53381(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_9,axiom,
    ! [VarCurr: state_type] :
      ( v53391(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v53390(VarCurr,B)
          <=> v53377(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4944,axiom,
    ! [VarCurr: state_type] :
      ( v53403(VarCurr)
    <=> ( v53405(VarCurr)
        & v53406(VarCurr) ) ) ).

tff(writeUnaryOperator_3002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53406(VarCurr)
    <=> v53334(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4943,axiom,
    ! [VarCurr: state_type] :
      ( v53405(VarCurr)
    <=> ( v53402(VarCurr)
        & v53395(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_575,axiom,
    ! [VarCurr: state_type] :
      ( v53400(VarCurr)
    <=> ( v53402(VarCurr)
        & v53334(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4942,axiom,
    ! [VarCurr: state_type] :
      ( v53402(VarCurr)
    <=> ( v53399(VarCurr)
        & v53394(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4941,axiom,
    ! [VarCurr: state_type] :
      ( v53396(VarCurr)
    <=> ( v53398(VarCurr)
        & v53395(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_574,axiom,
    ! [VarCurr: state_type] :
      ( v53398(VarCurr)
    <=> ( v53399(VarCurr)
        & v53334(VarCurr,1) ) ) ).

tff(writeUnaryOperator_3001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53399(VarCurr)
    <=> v53334(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4940,axiom,
    ! [VarCurr: state_type] :
      ( v53391(VarCurr)
    <=> ( v53393(VarCurr)
        & v53395(VarCurr) ) ) ).

tff(writeUnaryOperator_3000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53395(VarCurr)
    <=> v53334(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4939,axiom,
    ! [VarCurr: state_type] :
      ( v53393(VarCurr)
    <=> ( v53334(VarCurr,0)
        & v53394(VarCurr) ) ) ).

tff(writeUnaryOperator_2999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53394(VarCurr)
    <=> v53334(VarCurr,1) ) ).

tff(addAssignment_27675,axiom,
    ! [VarCurr: state_type] :
      ( v53385(VarCurr,15)
    <=> v53387(VarCurr,15) ) ).

tff(addAssignment_27674,axiom,
    ! [VarCurr: state_type] :
      ( v53387(VarCurr,15)
    <=> v53217(VarCurr,71) ) ).

tff(addAssignment_27673,axiom,
    ! [VarCurr: state_type] :
      ( v53381(VarCurr,15)
    <=> v53383(VarCurr,15) ) ).

tff(addAssignment_27672,axiom,
    ! [VarCurr: state_type] :
      ( v53383(VarCurr,15)
    <=> v53217(VarCurr,71) ) ).

tff(addAssignment_27671,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,71)
    <=> v53218(VarCurr,71) ) ).

tff(addAssignment_27670,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,137)
    <=> v6238(VarCurr,137) ) ).

tff(addAssignment_27669,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,137)
    <=> v6240(VarCurr,137) ) ).

tff(addAssignment_27668,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,137)
    <=> v47849(VarCurr,5) ) ).

tff(addAssignment_27667,axiom,
    ! [VarCurr: state_type] :
      ( v53377(VarCurr,15)
    <=> v53379(VarCurr,15) ) ).

tff(addAssignment_27666,axiom,
    ! [VarCurr: state_type] :
      ( v53379(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_27665,axiom,
    ! [VarCurr: state_type] :
      ( v53334(VarCurr,0)
    <=> v53370(VarCurr) ) ).

tff(addAssignment_27664,axiom,
    ! [VarCurr: state_type] :
      ( v53334(VarCurr,1)
    <=> v53362(VarCurr) ) ).

tff(addAssignment_27663,axiom,
    ! [VarCurr: state_type] :
      ( v53334(VarCurr,2)
    <=> v53340(VarCurr) ) ).

tff(addAssignment_27662,axiom,
    ! [VarCurr: state_type] :
      ( v53334(VarCurr,3)
    <=> v53336(VarCurr) ) ).

tff(addAssignment_27661,axiom,
    ! [VarCurr: state_type] :
      ( v53370(VarCurr)
    <=> v53372(VarCurr) ) ).

tff(addAssignment_27660,axiom,
    ! [VarCurr: state_type] :
      ( v53372(VarCurr)
    <=> v53374(VarCurr) ) ).

tff(addAssignment_27659,axiom,
    ! [VarCurr: state_type] :
      ( v53374(VarCurr)
    <=> v53346(VarCurr) ) ).

tff(addAssignment_27658,axiom,
    ! [VarCurr: state_type] :
      ( v53362(VarCurr)
    <=> v53364(VarCurr) ) ).

tff(addAssignment_27657,axiom,
    ! [VarCurr: state_type] :
      ( v53364(VarCurr)
    <=> v53366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4938,axiom,
    ! [VarCurr: state_type] :
      ( v53366(VarCurr)
    <=> ( v53368(VarCurr)
        & v53350(VarCurr) ) ) ).

tff(writeUnaryOperator_2998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53368(VarCurr)
    <=> v53346(VarCurr) ) ).

tff(addAssignment_27656,axiom,
    ! [VarCurr: state_type] :
      ( v53340(VarCurr)
    <=> v53342(VarCurr) ) ).

tff(addAssignment_27655,axiom,
    ! [VarCurr: state_type] :
      ( v53342(VarCurr)
    <=> v53344(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4937,axiom,
    ! [VarCurr: state_type] :
      ( v53344(VarCurr)
    <=> ( v53358(VarCurr)
        & v53354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4936,axiom,
    ! [VarCurr: state_type] :
      ( v53358(VarCurr)
    <=> ( v53359(VarCurr)
        & v53360(VarCurr) ) ) ).

tff(writeUnaryOperator_2997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53360(VarCurr)
    <=> v53350(VarCurr) ) ).

tff(writeUnaryOperator_2996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53359(VarCurr)
    <=> v53346(VarCurr) ) ).

tff(addAssignment_27654,axiom,
    ! [VarCurr: state_type] :
      ( v53354(VarCurr)
    <=> v53356(VarCurr) ) ).

tff(addAssignment_27653,axiom,
    ! [VarCurr: state_type] :
      ( v53356(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_27652,axiom,
    ! [VarCurr: state_type] :
      ( v53350(VarCurr)
    <=> v53352(VarCurr) ) ).

tff(addAssignment_27651,axiom,
    ! [VarCurr: state_type] :
      ( v53352(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_27650,axiom,
    ! [VarCurr: state_type] :
      ( v53346(VarCurr)
    <=> v53348(VarCurr) ) ).

tff(addAssignment_27649,axiom,
    ! [VarCurr: state_type] :
      ( v53348(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_27648,axiom,
    ! [VarCurr: state_type] :
      ( v53336(VarCurr)
    <=> v53338(VarCurr) ) ).

tff(addAssignment_27647,axiom,
    ! [VarCurr: state_type] :
      ( v53338(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_27646,axiom,
    ! [VarCurr: state_type] :
      ( v53318(VarCurr,15)
    <=> v53320(VarCurr,15) ) ).

tff(addAssignment_27645,axiom,
    ! [VarCurr: state_type] :
      ( v53320(VarCurr,15)
    <=> v53321(VarCurr,15) ) ).

tff(addAssignment_27644,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,0)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27643,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,1)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27642,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,2)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27641,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,3)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27640,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,4)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27639,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,5)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27638,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,6)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27637,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,7)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27636,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,8)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27635,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,9)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27634,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,10)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27633,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,11)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27632,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,12)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27631,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,13)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27630,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,14)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27629,axiom,
    ! [VarCurr: state_type] :
      ( v53321(VarCurr,15)
    <=> v53322(VarCurr) ) ).

tff(addAssignment_27628,axiom,
    ! [VarCurr: state_type] :
      ( v53322(VarCurr)
    <=> v6079(VarCurr) ) ).

tff(addAssignment_27627,axiom,
    ! [VarCurr: state_type] :
      ( v53099(VarCurr)
    <=> v53101(VarCurr) ) ).

tff(addAssignment_27626,axiom,
    ! [VarCurr: state_type] :
      ( v53101(VarCurr)
    <=> v6017(VarCurr,123) ) ).

tff(addAssignment_27625,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,123)
    <=> v53103(VarCurr,59) ) ).

tff(addAssignment_27624,axiom,
    ! [VarCurr: state_type] :
      ( v53103(VarCurr,59)
    <=> v53105(VarCurr,59) ) ).

tff(addAssignment_27623,axiom,
    ! [VarCurr: state_type] :
      ( v53105(VarCurr,59)
    <=> v53107(VarCurr,59) ) ).

tff(addAssignment_27622,axiom,
    ! [VarCurr: state_type] :
      ( v53107(VarCurr,59)
    <=> v53109(VarCurr,59) ) ).

tff(addAssignment_27621,axiom,
    ! [VarCurr: state_type] :
      ( v53109(VarCurr,59)
    <=> v6027(VarCurr,123) ) ).

tff(addAssignment_27620,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,123)
    <=> v52434(VarCurr,123) ) ).

tff(addAssignment_27619,axiom,
    ! [VarCurr: state_type] :
      ( v52436(VarCurr,3)
    <=> v53112(VarCurr,59) ) ).

tff(addAssignment_27618,axiom,
    ! [VarCurr: state_type] :
      ( v53112(VarCurr,59)
    <=> v53114(VarCurr,59) ) ).

tff(addAssignment_27617,axiom,
    ! [VarNext: state_type] :
      ( v53114(VarNext,59)
    <=> v53281(VarNext,59) ) ).

tff(addCaseBooleanConditionEqualRanges1_631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53281(VarNext,B)
            <=> v53114(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_631,axiom,
    ! [VarNext: state_type] :
      ( v53282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53281(VarNext,B)
          <=> v53292(VarNext,B) ) ) ) ).

tff(addAssignment_27616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53292(VarNext,B)
          <=> v53290(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53290(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_393,axiom,
    ! [VarCurr: state_type] :
      ( v53293(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53290(VarCurr,B)
          <=> v53136(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4935,axiom,
    ! [VarCurr: state_type] :
      ( v53293(VarCurr)
    <=> ( v53294(VarCurr)
        & v53295(VarCurr) ) ) ).

tff(writeUnaryOperator_2995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53295(VarCurr)
    <=> v53126(VarCurr) ) ).

tff(writeUnaryOperator_2994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53294(VarCurr)
    <=> v53116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53282(VarNext)
      <=> v53283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53283(VarNext)
      <=> ( v53284(VarNext)
          & v53263(VarNext) ) ) ) ).

tff(writeUnaryOperator_2993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53284(VarNext)
      <=> v53286(VarNext) ) ) ).

tff(addAssignment_27615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53286(VarNext)
      <=> v53263(VarCurr) ) ) ).

tff(addAssignment_27614,axiom,
    ! [VarCurr: state_type] :
      ( v53263(VarCurr)
    <=> v53265(VarCurr) ) ).

tff(addAssignment_27613,axiom,
    ! [VarCurr: state_type] :
      ( v53265(VarCurr)
    <=> v53267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4932,axiom,
    ! [VarCurr: state_type] :
      ( v53267(VarCurr)
    <=> ( v53279(VarCurr)
        | v53275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4931,axiom,
    ! [VarCurr: state_type] :
      ( v53279(VarCurr)
    <=> ( v53269(VarCurr)
        & v53273(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_230,axiom,
    ( v53273(constB0)
  <=> $true ) ).

tff(addAssignment_27612,axiom,
    ! [VarCurr: state_type] :
      ( v53275(VarCurr)
    <=> v53277(VarCurr) ) ).

tff(addAssignment_27611,axiom,
    ! [VarCurr: state_type] :
      ( v53277(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addAssignment_27610,axiom,
    ! [VarCurr: state_type] :
      ( v53269(VarCurr)
    <=> v53271(VarCurr) ) ).

tff(addAssignment_27609,axiom,
    ! [VarCurr: state_type] :
      ( v53271(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_27608,axiom,
    ! [VarCurr: state_type] :
      ( v53136(VarCurr,59)
    <=> v53138(VarCurr,59) ) ).

tff(addAssignment_27607,axiom,
    ! [VarCurr: state_type] :
      ( v53138(VarCurr,59)
    <=> v6059(VarCurr,123) ) ).

tff(addAssignment_27606,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,123)
    <=> v53140(VarCurr,3) ) ).

tff(addAssignment_27605,axiom,
    ! [VarCurr: state_type] :
      ( v53140(VarCurr,3)
    <=> v53142(VarCurr,3) ) ).

tff(addAssignment_27604,axiom,
    ! [VarCurr: state_type] :
      ( v53142(VarCurr,3)
    <=> v53255(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_883,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53255(VarCurr,B)
      <=> ( v53256(VarCurr,B)
          | v53259(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53259(VarCurr,B)
      <=> ( v53248(VarCurr,B)
          & v53260(VarCurr,B) ) ) ) ).

tff(addAssignment_27603,axiom,
    ! [VarCurr: state_type] :
      ( v53260(VarCurr,0)
    <=> v53261(VarCurr) ) ).

tff(addAssignment_27602,axiom,
    ! [VarCurr: state_type] :
      ( v53260(VarCurr,1)
    <=> v53261(VarCurr) ) ).

tff(addAssignment_27601,axiom,
    ! [VarCurr: state_type] :
      ( v53260(VarCurr,2)
    <=> v53261(VarCurr) ) ).

tff(addAssignment_27600,axiom,
    ! [VarCurr: state_type] :
      ( v53260(VarCurr,3)
    <=> v53261(VarCurr) ) ).

tff(addAssignment_27599,axiom,
    ! [VarCurr: state_type] :
      ( v53261(VarCurr)
    <=> v53252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53256(VarCurr,B)
      <=> ( v53144(VarCurr,B)
          & v53257(VarCurr,B) ) ) ) ).

tff(addAssignment_27598,axiom,
    ! [VarCurr: state_type] :
      ( v53257(VarCurr,0)
    <=> v53258(VarCurr) ) ).

tff(addAssignment_27597,axiom,
    ! [VarCurr: state_type] :
      ( v53257(VarCurr,1)
    <=> v53258(VarCurr) ) ).

tff(addAssignment_27596,axiom,
    ! [VarCurr: state_type] :
      ( v53257(VarCurr,2)
    <=> v53258(VarCurr) ) ).

tff(addAssignment_27595,axiom,
    ! [VarCurr: state_type] :
      ( v53257(VarCurr,3)
    <=> v53258(VarCurr) ) ).

tff(addAssignment_27594,axiom,
    ! [VarCurr: state_type] :
      ( v53258(VarCurr)
    <=> v53244(VarCurr) ) ).

tff(addAssignment_27593,axiom,
    ! [VarCurr: state_type] :
      ( v53252(VarCurr)
    <=> v53254(VarCurr) ) ).

tff(addAssignment_27592,axiom,
    ! [VarCurr: state_type] :
      ( v53254(VarCurr)
    <=> v52379(VarCurr,30) ) ).

tff(addAssignment_27591,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,30)
    <=> v52381(VarCurr,30) ) ).

tff(addAssignment_27590,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,30)
    <=> v52383(VarCurr,30) ) ).

tff(addAssignment_27589,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,30)
    <=> v52384(VarCurr,30) ) ).

tff(addAssignment_27588,axiom,
    ! [VarCurr: state_type] :
      ( v53248(VarCurr,3)
    <=> v53250(VarCurr,3) ) ).

tff(addAssignment_27587,axiom,
    ! [VarCurr: state_type] :
      ( v53250(VarCurr,3)
    <=> v6069(VarCurr,123) ) ).

tff(addAssignment_27586,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,123)
    <=> v53148(VarCurr,59) ) ).

tff(addAssignment_27585,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,59)
    <=> v53150(VarCurr,59) ) ).

tff(addAssignment_27584,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,59)
    <=> v53242(VarCurr,59) ) ).

tff(addAssignment_27583,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,59)
    <=> v53160(VarCurr,59) ) ).

tff(addAssignment_27582,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,59)
    <=> v6098(VarCurr,123) ) ).

tff(addAssignment_27581,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,123)
    <=> v6100(VarCurr,123) ) ).

tff(addAssignment_27580,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,123)
    <=> v6102(VarCurr,123) ) ).

tff(addAssignment_27579,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,123)
    <=> v53162(VarCurr,59) ) ).

tff(addAssignment_27578,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,59)
    <=> v53164(VarCurr,59) ) ).

tff(addAssignment_27577,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,59)
    <=> v53225(VarCurr,59) ) ).

tff(addAssignment_27576,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,59)
    <=> v53223(VarCurr,59) ) ).

tff(addAssignment_27575,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,59)
    <=> v53224(VarCurr,59) ) ).

tff(addAssignment_27574,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,59)
    <=> v53215(VarCurr,59) ) ).

tff(addAssignment_27573,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,59)
    <=> v53219(VarCurr,59) ) ).

tff(addAssignment_27572,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,51)
    <=> v53218(VarCurr,51) ) ).

tff(addAssignment_27571,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,99)
    <=> v6238(VarCurr,99) ) ).

tff(addAssignment_27570,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,99)
    <=> v6240(VarCurr,99) ) ).

tff(addAssignment_27569,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,99)
    <=> v43199(VarCurr,3) ) ).

tff(addAssignment_27568,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,59)
    <=> v53211(VarCurr,59) ) ).

tff(addAssignment_27567,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,59)
    <=> $false ) ).

tff(addAssignment_27566,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,59)
    <=> v53154(VarCurr,59) ) ).

tff(addAssignment_27565,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,59)
    <=> v53155(VarCurr,59) ) ).

tff(addAssignment_27564,axiom,
    ! [VarCurr: state_type] :
      ( v53244(VarCurr)
    <=> v53246(VarCurr) ) ).

tff(addAssignment_27563,axiom,
    ! [VarCurr: state_type] :
      ( v53246(VarCurr)
    <=> v52361(VarCurr,30) ) ).

tff(addAssignment_27562,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,30)
    <=> v52363(VarCurr,30) ) ).

tff(addAssignment_27561,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,30)
    <=> v52365(VarCurr,30) ) ).

tff(addAssignment_27560,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,30)
    <=> v52367(VarCurr,30) ) ).

tff(addAssignment_27559,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,30)
    <=> v52369(VarCurr,30) ) ).

tff(addAssignment_27558,axiom,
    ! [VarCurr: state_type] :
      ( v53144(VarCurr,3)
    <=> v53146(VarCurr,3) ) ).

tff(addAssignment_27557,axiom,
    ! [VarCurr: state_type] :
      ( v53146(VarCurr,3)
    <=> v6069(VarCurr,127) ) ).

tff(addAssignment_27556,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,127)
    <=> v53148(VarCurr,63) ) ).

tff(addAssignment_27555,axiom,
    ! [VarCurr: state_type] :
      ( v53148(VarCurr,63)
    <=> v53150(VarCurr,63) ) ).

tff(addAssignment_27554,axiom,
    ! [VarCurr: state_type] :
      ( v53150(VarCurr,63)
    <=> v53242(VarCurr,63) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v53242(VarCurr,B)
      <=> ( v53152(VarCurr,B)
          & v53158(VarCurr,B) ) ) ) ).

tff(addAssignment_27553,axiom,
    ! [VarCurr: state_type] :
      ( v53158(VarCurr,63)
    <=> v53160(VarCurr,63) ) ).

tff(addAssignment_27552,axiom,
    ! [VarCurr: state_type] :
      ( v53160(VarCurr,63)
    <=> v6098(VarCurr,127) ) ).

tff(addAssignment_27551,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,127)
    <=> v6100(VarCurr,127) ) ).

tff(addAssignment_27550,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,127)
    <=> v6102(VarCurr,127) ) ).

tff(addAssignment_27549,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,127)
    <=> v53162(VarCurr,63) ) ).

tff(addAssignment_27548,axiom,
    ! [VarCurr: state_type] :
      ( v53162(VarCurr,63)
    <=> v53164(VarCurr,63) ) ).

tff(addAssignment_27547,axiom,
    ! [VarCurr: state_type] :
      ( v53164(VarCurr,63)
    <=> v53225(VarCurr,63) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4_1,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v53226(VarCurr)
        & ~ v53231(VarCurr)
        & ~ v53235(VarCurr)
        & ~ v53238(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53225(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3_1,axiom,
    ! [VarCurr: state_type] :
      ( v53238(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53225(VarCurr,B)
          <=> $true ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges2_1,axiom,
    ! [VarCurr: state_type] :
      ( v53235(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53225(VarCurr,B)
          <=> v53221(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_8,axiom,
    ! [VarCurr: state_type] :
      ( v53231(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53225(VarCurr,B)
          <=> v53213(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_8,axiom,
    ! [VarCurr: state_type] :
      ( v53226(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53225(VarCurr,B)
          <=> v53209(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4930,axiom,
    ! [VarCurr: state_type] :
      ( v53238(VarCurr)
    <=> ( v53240(VarCurr)
        & v53241(VarCurr) ) ) ).

tff(writeUnaryOperator_2992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53241(VarCurr)
    <=> v53166(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4929,axiom,
    ! [VarCurr: state_type] :
      ( v53240(VarCurr)
    <=> ( v53237(VarCurr)
        & v53230(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_573,axiom,
    ! [VarCurr: state_type] :
      ( v53235(VarCurr)
    <=> ( v53237(VarCurr)
        & v53166(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4928,axiom,
    ! [VarCurr: state_type] :
      ( v53237(VarCurr)
    <=> ( v53234(VarCurr)
        & v53229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4927,axiom,
    ! [VarCurr: state_type] :
      ( v53231(VarCurr)
    <=> ( v53233(VarCurr)
        & v53230(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_572,axiom,
    ! [VarCurr: state_type] :
      ( v53233(VarCurr)
    <=> ( v53234(VarCurr)
        & v53166(VarCurr,1) ) ) ).

tff(writeUnaryOperator_2991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53234(VarCurr)
    <=> v53166(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4926,axiom,
    ! [VarCurr: state_type] :
      ( v53226(VarCurr)
    <=> ( v53228(VarCurr)
        & v53230(VarCurr) ) ) ).

tff(writeUnaryOperator_2990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53230(VarCurr)
    <=> v53166(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4925,axiom,
    ! [VarCurr: state_type] :
      ( v53228(VarCurr)
    <=> ( v53166(VarCurr,0)
        & v53229(VarCurr) ) ) ).

tff(writeUnaryOperator_2989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53229(VarCurr)
    <=> v53166(VarCurr,1) ) ).

tff(addAssignment_27546,axiom,
    ! [VarCurr: state_type] :
      ( v53221(VarCurr,63)
    <=> v53223(VarCurr,63) ) ).

tff(addAssignment_27545,axiom,
    ! [VarCurr: state_type] :
      ( v53223(VarCurr,63)
    <=> v53224(VarCurr,63) ) ).

tff(addAssignment_27544,axiom,
    ! [VarCurr: state_type] :
      ( ( v53224(VarCurr,7)
      <=> v52332(VarCurr,71) )
      & ( v53224(VarCurr,6)
      <=> v52332(VarCurr,70) )
      & ( v53224(VarCurr,5)
      <=> v52332(VarCurr,69) )
      & ( v53224(VarCurr,4)
      <=> v52332(VarCurr,68) )
      & ( v53224(VarCurr,3)
      <=> v52332(VarCurr,67) )
      & ( v53224(VarCurr,2)
      <=> v52332(VarCurr,66) )
      & ( v53224(VarCurr,1)
      <=> v52332(VarCurr,65) )
      & ( v53224(VarCurr,0)
      <=> v52332(VarCurr,64) ) ) ).

tff(addAssignment_27543,axiom,
    ! [VarCurr: state_type] :
      ( ( v53224(VarCurr,63)
      <=> v53217(VarCurr,55) )
      & ( v53224(VarCurr,62)
      <=> v53217(VarCurr,54) )
      & ( v53224(VarCurr,61)
      <=> v53217(VarCurr,53) )
      & ( v53224(VarCurr,60)
      <=> v53217(VarCurr,52) )
      & ( v53224(VarCurr,59)
      <=> v53217(VarCurr,51) )
      & ( v53224(VarCurr,58)
      <=> v53217(VarCurr,50) )
      & ( v53224(VarCurr,57)
      <=> v53217(VarCurr,49) )
      & ( v53224(VarCurr,56)
      <=> v53217(VarCurr,48) )
      & ( v53224(VarCurr,55)
      <=> v53217(VarCurr,47) )
      & ( v53224(VarCurr,54)
      <=> v53217(VarCurr,46) )
      & ( v53224(VarCurr,53)
      <=> v53217(VarCurr,45) )
      & ( v53224(VarCurr,52)
      <=> v53217(VarCurr,44) )
      & ( v53224(VarCurr,51)
      <=> v53217(VarCurr,43) )
      & ( v53224(VarCurr,50)
      <=> v53217(VarCurr,42) )
      & ( v53224(VarCurr,49)
      <=> v53217(VarCurr,41) )
      & ( v53224(VarCurr,48)
      <=> v53217(VarCurr,40) )
      & ( v53224(VarCurr,47)
      <=> v53217(VarCurr,39) )
      & ( v53224(VarCurr,46)
      <=> v53217(VarCurr,38) )
      & ( v53224(VarCurr,45)
      <=> v53217(VarCurr,37) )
      & ( v53224(VarCurr,44)
      <=> v53217(VarCurr,36) )
      & ( v53224(VarCurr,43)
      <=> v53217(VarCurr,35) )
      & ( v53224(VarCurr,42)
      <=> v53217(VarCurr,34) )
      & ( v53224(VarCurr,41)
      <=> v53217(VarCurr,33) )
      & ( v53224(VarCurr,40)
      <=> v53217(VarCurr,32) )
      & ( v53224(VarCurr,39)
      <=> v53217(VarCurr,31) )
      & ( v53224(VarCurr,38)
      <=> v53217(VarCurr,30) )
      & ( v53224(VarCurr,37)
      <=> v53217(VarCurr,29) )
      & ( v53224(VarCurr,36)
      <=> v53217(VarCurr,28) )
      & ( v53224(VarCurr,35)
      <=> v53217(VarCurr,27) )
      & ( v53224(VarCurr,34)
      <=> v53217(VarCurr,26) )
      & ( v53224(VarCurr,33)
      <=> v53217(VarCurr,25) )
      & ( v53224(VarCurr,32)
      <=> v53217(VarCurr,24) )
      & ( v53224(VarCurr,31)
      <=> v53217(VarCurr,23) )
      & ( v53224(VarCurr,30)
      <=> v53217(VarCurr,22) )
      & ( v53224(VarCurr,29)
      <=> v53217(VarCurr,21) )
      & ( v53224(VarCurr,28)
      <=> v53217(VarCurr,20) )
      & ( v53224(VarCurr,27)
      <=> v53217(VarCurr,19) )
      & ( v53224(VarCurr,26)
      <=> v53217(VarCurr,18) )
      & ( v53224(VarCurr,25)
      <=> v53217(VarCurr,17) )
      & ( v53224(VarCurr,24)
      <=> v53217(VarCurr,16) )
      & ( v53224(VarCurr,23)
      <=> v53217(VarCurr,15) )
      & ( v53224(VarCurr,22)
      <=> v53217(VarCurr,14) )
      & ( v53224(VarCurr,21)
      <=> v53217(VarCurr,13) )
      & ( v53224(VarCurr,20)
      <=> v53217(VarCurr,12) )
      & ( v53224(VarCurr,19)
      <=> v53217(VarCurr,11) )
      & ( v53224(VarCurr,18)
      <=> v53217(VarCurr,10) )
      & ( v53224(VarCurr,17)
      <=> v53217(VarCurr,9) )
      & ( v53224(VarCurr,16)
      <=> v53217(VarCurr,8) )
      & ( v53224(VarCurr,15)
      <=> v53217(VarCurr,7) )
      & ( v53224(VarCurr,14)
      <=> v53217(VarCurr,6) )
      & ( v53224(VarCurr,13)
      <=> v53217(VarCurr,5) )
      & ( v53224(VarCurr,12)
      <=> v53217(VarCurr,4) )
      & ( v53224(VarCurr,11)
      <=> v53217(VarCurr,3) )
      & ( v53224(VarCurr,10)
      <=> v53217(VarCurr,2) )
      & ( v53224(VarCurr,9)
      <=> v53217(VarCurr,1) )
      & ( v53224(VarCurr,8)
      <=> v53217(VarCurr,0) ) ) ).

tff(addAssignment_27542,axiom,
    ! [VarCurr: state_type] :
      ( v53213(VarCurr,63)
    <=> v53215(VarCurr,63) ) ).

tff(addAssignment_27541,axiom,
    ! [VarCurr: state_type] :
      ( v53215(VarCurr,63)
    <=> v53219(VarCurr,63) ) ).

tff(addAssignment_27540,axiom,
    ! [VarCurr: state_type] :
      ( ( v53219(VarCurr,7)
      <=> v6234(VarCurr,71) )
      & ( v53219(VarCurr,6)
      <=> v6234(VarCurr,70) )
      & ( v53219(VarCurr,5)
      <=> v6234(VarCurr,69) )
      & ( v53219(VarCurr,4)
      <=> v6234(VarCurr,68) )
      & ( v53219(VarCurr,3)
      <=> v6234(VarCurr,67) )
      & ( v53219(VarCurr,2)
      <=> v6234(VarCurr,66) )
      & ( v53219(VarCurr,1)
      <=> v6234(VarCurr,65) )
      & ( v53219(VarCurr,0)
      <=> v6234(VarCurr,64) ) ) ).

tff(addAssignment_27539,axiom,
    ! [VarCurr: state_type] :
      ( ( v53219(VarCurr,63)
      <=> v53217(VarCurr,55) )
      & ( v53219(VarCurr,62)
      <=> v53217(VarCurr,54) )
      & ( v53219(VarCurr,61)
      <=> v53217(VarCurr,53) )
      & ( v53219(VarCurr,60)
      <=> v53217(VarCurr,52) )
      & ( v53219(VarCurr,59)
      <=> v53217(VarCurr,51) )
      & ( v53219(VarCurr,58)
      <=> v53217(VarCurr,50) )
      & ( v53219(VarCurr,57)
      <=> v53217(VarCurr,49) )
      & ( v53219(VarCurr,56)
      <=> v53217(VarCurr,48) )
      & ( v53219(VarCurr,55)
      <=> v53217(VarCurr,47) )
      & ( v53219(VarCurr,54)
      <=> v53217(VarCurr,46) )
      & ( v53219(VarCurr,53)
      <=> v53217(VarCurr,45) )
      & ( v53219(VarCurr,52)
      <=> v53217(VarCurr,44) )
      & ( v53219(VarCurr,51)
      <=> v53217(VarCurr,43) )
      & ( v53219(VarCurr,50)
      <=> v53217(VarCurr,42) )
      & ( v53219(VarCurr,49)
      <=> v53217(VarCurr,41) )
      & ( v53219(VarCurr,48)
      <=> v53217(VarCurr,40) )
      & ( v53219(VarCurr,47)
      <=> v53217(VarCurr,39) )
      & ( v53219(VarCurr,46)
      <=> v53217(VarCurr,38) )
      & ( v53219(VarCurr,45)
      <=> v53217(VarCurr,37) )
      & ( v53219(VarCurr,44)
      <=> v53217(VarCurr,36) )
      & ( v53219(VarCurr,43)
      <=> v53217(VarCurr,35) )
      & ( v53219(VarCurr,42)
      <=> v53217(VarCurr,34) )
      & ( v53219(VarCurr,41)
      <=> v53217(VarCurr,33) )
      & ( v53219(VarCurr,40)
      <=> v53217(VarCurr,32) )
      & ( v53219(VarCurr,39)
      <=> v53217(VarCurr,31) )
      & ( v53219(VarCurr,38)
      <=> v53217(VarCurr,30) )
      & ( v53219(VarCurr,37)
      <=> v53217(VarCurr,29) )
      & ( v53219(VarCurr,36)
      <=> v53217(VarCurr,28) )
      & ( v53219(VarCurr,35)
      <=> v53217(VarCurr,27) )
      & ( v53219(VarCurr,34)
      <=> v53217(VarCurr,26) )
      & ( v53219(VarCurr,33)
      <=> v53217(VarCurr,25) )
      & ( v53219(VarCurr,32)
      <=> v53217(VarCurr,24) )
      & ( v53219(VarCurr,31)
      <=> v53217(VarCurr,23) )
      & ( v53219(VarCurr,30)
      <=> v53217(VarCurr,22) )
      & ( v53219(VarCurr,29)
      <=> v53217(VarCurr,21) )
      & ( v53219(VarCurr,28)
      <=> v53217(VarCurr,20) )
      & ( v53219(VarCurr,27)
      <=> v53217(VarCurr,19) )
      & ( v53219(VarCurr,26)
      <=> v53217(VarCurr,18) )
      & ( v53219(VarCurr,25)
      <=> v53217(VarCurr,17) )
      & ( v53219(VarCurr,24)
      <=> v53217(VarCurr,16) )
      & ( v53219(VarCurr,23)
      <=> v53217(VarCurr,15) )
      & ( v53219(VarCurr,22)
      <=> v53217(VarCurr,14) )
      & ( v53219(VarCurr,21)
      <=> v53217(VarCurr,13) )
      & ( v53219(VarCurr,20)
      <=> v53217(VarCurr,12) )
      & ( v53219(VarCurr,19)
      <=> v53217(VarCurr,11) )
      & ( v53219(VarCurr,18)
      <=> v53217(VarCurr,10) )
      & ( v53219(VarCurr,17)
      <=> v53217(VarCurr,9) )
      & ( v53219(VarCurr,16)
      <=> v53217(VarCurr,8) )
      & ( v53219(VarCurr,15)
      <=> v53217(VarCurr,7) )
      & ( v53219(VarCurr,14)
      <=> v53217(VarCurr,6) )
      & ( v53219(VarCurr,13)
      <=> v53217(VarCurr,5) )
      & ( v53219(VarCurr,12)
      <=> v53217(VarCurr,4) )
      & ( v53219(VarCurr,11)
      <=> v53217(VarCurr,3) )
      & ( v53219(VarCurr,10)
      <=> v53217(VarCurr,2) )
      & ( v53219(VarCurr,9)
      <=> v53217(VarCurr,1) )
      & ( v53219(VarCurr,8)
      <=> v53217(VarCurr,0) ) ) ).

tff(addAssignment_27538,axiom,
    ! [VarCurr: state_type] :
      ( v53217(VarCurr,55)
    <=> v53218(VarCurr,55) ) ).

tff(addAssignment_27537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v53218(VarCurr,B)
      <=> v6236(VarCurr,B) ) ) ).

tff(addAssignment_27536,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,11)
      <=> v6236(VarCurr,17) )
      & ( v53218(VarCurr,10)
      <=> v6236(VarCurr,16) )
      & ( v53218(VarCurr,9)
      <=> v6236(VarCurr,15) )
      & ( v53218(VarCurr,8)
      <=> v6236(VarCurr,14) )
      & ( v53218(VarCurr,7)
      <=> v6236(VarCurr,13) )
      & ( v53218(VarCurr,6)
      <=> v6236(VarCurr,12) ) ) ).

tff(addAssignment_27535,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,17)
      <=> v6236(VarCurr,29) )
      & ( v53218(VarCurr,16)
      <=> v6236(VarCurr,28) )
      & ( v53218(VarCurr,15)
      <=> v6236(VarCurr,27) )
      & ( v53218(VarCurr,14)
      <=> v6236(VarCurr,26) )
      & ( v53218(VarCurr,13)
      <=> v6236(VarCurr,25) )
      & ( v53218(VarCurr,12)
      <=> v6236(VarCurr,24) ) ) ).

tff(addAssignment_27534,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,23)
      <=> v6236(VarCurr,41) )
      & ( v53218(VarCurr,22)
      <=> v6236(VarCurr,40) )
      & ( v53218(VarCurr,21)
      <=> v6236(VarCurr,39) )
      & ( v53218(VarCurr,20)
      <=> v6236(VarCurr,38) )
      & ( v53218(VarCurr,19)
      <=> v6236(VarCurr,37) )
      & ( v53218(VarCurr,18)
      <=> v6236(VarCurr,36) ) ) ).

tff(addAssignment_27533,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,29)
      <=> v6236(VarCurr,53) )
      & ( v53218(VarCurr,28)
      <=> v6236(VarCurr,52) )
      & ( v53218(VarCurr,27)
      <=> v6236(VarCurr,51) )
      & ( v53218(VarCurr,26)
      <=> v6236(VarCurr,50) )
      & ( v53218(VarCurr,25)
      <=> v6236(VarCurr,49) )
      & ( v53218(VarCurr,24)
      <=> v6236(VarCurr,48) ) ) ).

tff(addAssignment_27532,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,35)
      <=> v6236(VarCurr,65) )
      & ( v53218(VarCurr,34)
      <=> v6236(VarCurr,64) )
      & ( v53218(VarCurr,33)
      <=> v6236(VarCurr,63) )
      & ( v53218(VarCurr,32)
      <=> v6236(VarCurr,62) )
      & ( v53218(VarCurr,31)
      <=> v6236(VarCurr,61) )
      & ( v53218(VarCurr,30)
      <=> v6236(VarCurr,60) ) ) ).

tff(addAssignment_27531,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,41)
      <=> v6236(VarCurr,77) )
      & ( v53218(VarCurr,40)
      <=> v6236(VarCurr,76) )
      & ( v53218(VarCurr,39)
      <=> v6236(VarCurr,75) )
      & ( v53218(VarCurr,38)
      <=> v6236(VarCurr,74) )
      & ( v53218(VarCurr,37)
      <=> v6236(VarCurr,73) )
      & ( v53218(VarCurr,36)
      <=> v6236(VarCurr,72) ) ) ).

tff(addAssignment_27530,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,47)
      <=> v6236(VarCurr,89) )
      & ( v53218(VarCurr,46)
      <=> v6236(VarCurr,88) )
      & ( v53218(VarCurr,45)
      <=> v6236(VarCurr,87) )
      & ( v53218(VarCurr,44)
      <=> v6236(VarCurr,86) )
      & ( v53218(VarCurr,43)
      <=> v6236(VarCurr,85) )
      & ( v53218(VarCurr,42)
      <=> v6236(VarCurr,84) ) ) ).

tff(addAssignment_27529,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,53)
      <=> v6236(VarCurr,101) )
      & ( v53218(VarCurr,52)
      <=> v6236(VarCurr,100) )
      & ( v53218(VarCurr,51)
      <=> v6236(VarCurr,99) )
      & ( v53218(VarCurr,50)
      <=> v6236(VarCurr,98) )
      & ( v53218(VarCurr,49)
      <=> v6236(VarCurr,97) )
      & ( v53218(VarCurr,48)
      <=> v6236(VarCurr,96) ) ) ).

tff(addAssignment_27528,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,59)
      <=> v6236(VarCurr,113) )
      & ( v53218(VarCurr,58)
      <=> v6236(VarCurr,112) )
      & ( v53218(VarCurr,57)
      <=> v6236(VarCurr,111) )
      & ( v53218(VarCurr,56)
      <=> v6236(VarCurr,110) )
      & ( v53218(VarCurr,55)
      <=> v6236(VarCurr,109) )
      & ( v53218(VarCurr,54)
      <=> v6236(VarCurr,108) ) ) ).

tff(addAssignment_27527,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,65)
      <=> v6236(VarCurr,125) )
      & ( v53218(VarCurr,64)
      <=> v6236(VarCurr,124) )
      & ( v53218(VarCurr,63)
      <=> v6236(VarCurr,123) )
      & ( v53218(VarCurr,62)
      <=> v6236(VarCurr,122) )
      & ( v53218(VarCurr,61)
      <=> v6236(VarCurr,121) )
      & ( v53218(VarCurr,60)
      <=> v6236(VarCurr,120) ) ) ).

tff(addAssignment_27526,axiom,
    ! [VarCurr: state_type] :
      ( ( v53218(VarCurr,71)
      <=> v6236(VarCurr,137) )
      & ( v53218(VarCurr,70)
      <=> v6236(VarCurr,136) )
      & ( v53218(VarCurr,69)
      <=> v6236(VarCurr,135) )
      & ( v53218(VarCurr,68)
      <=> v6236(VarCurr,134) )
      & ( v53218(VarCurr,67)
      <=> v6236(VarCurr,133) )
      & ( v53218(VarCurr,66)
      <=> v6236(VarCurr,132) ) ) ).

tff(addAssignment_27525,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,109)
    <=> v6238(VarCurr,109) ) ).

tff(addAssignment_27524,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,109)
    <=> v6240(VarCurr,109) ) ).

tff(addAssignment_27523,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,109)
    <=> v44749(VarCurr,1) ) ).

tff(addAssignment_27522,axiom,
    ! [VarCurr: state_type] :
      ( v53209(VarCurr,63)
    <=> v53211(VarCurr,63) ) ).

tff(addAssignment_27521,axiom,
    ! [VarCurr: state_type] :
      ( v53211(VarCurr,63)
    <=> $false ) ).

tff(addAssignment_27520,axiom,
    ! [VarCurr: state_type] :
      ( v53166(VarCurr,0)
    <=> v53202(VarCurr) ) ).

tff(addAssignment_27519,axiom,
    ! [VarCurr: state_type] :
      ( v53166(VarCurr,1)
    <=> v53194(VarCurr) ) ).

tff(addAssignment_27518,axiom,
    ! [VarCurr: state_type] :
      ( v53166(VarCurr,2)
    <=> v53172(VarCurr) ) ).

tff(addAssignment_27517,axiom,
    ! [VarCurr: state_type] :
      ( v53166(VarCurr,3)
    <=> v53168(VarCurr) ) ).

tff(addAssignment_27516,axiom,
    ! [VarCurr: state_type] :
      ( v53202(VarCurr)
    <=> v53204(VarCurr) ) ).

tff(addAssignment_27515,axiom,
    ! [VarCurr: state_type] :
      ( v53204(VarCurr)
    <=> v53206(VarCurr) ) ).

tff(addAssignment_27514,axiom,
    ! [VarCurr: state_type] :
      ( v53206(VarCurr)
    <=> v53178(VarCurr) ) ).

tff(addAssignment_27513,axiom,
    ! [VarCurr: state_type] :
      ( v53194(VarCurr)
    <=> v53196(VarCurr) ) ).

tff(addAssignment_27512,axiom,
    ! [VarCurr: state_type] :
      ( v53196(VarCurr)
    <=> v53198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4924,axiom,
    ! [VarCurr: state_type] :
      ( v53198(VarCurr)
    <=> ( v53200(VarCurr)
        & v53182(VarCurr) ) ) ).

tff(writeUnaryOperator_2988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53200(VarCurr)
    <=> v53178(VarCurr) ) ).

tff(addAssignment_27511,axiom,
    ! [VarCurr: state_type] :
      ( v53172(VarCurr)
    <=> v53174(VarCurr) ) ).

tff(addAssignment_27510,axiom,
    ! [VarCurr: state_type] :
      ( v53174(VarCurr)
    <=> v53176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4923,axiom,
    ! [VarCurr: state_type] :
      ( v53176(VarCurr)
    <=> ( v53190(VarCurr)
        & v53186(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4922,axiom,
    ! [VarCurr: state_type] :
      ( v53190(VarCurr)
    <=> ( v53191(VarCurr)
        & v53192(VarCurr) ) ) ).

tff(writeUnaryOperator_2987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53192(VarCurr)
    <=> v53182(VarCurr) ) ).

tff(writeUnaryOperator_2986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v53191(VarCurr)
    <=> v53178(VarCurr) ) ).

tff(addAssignment_27509,axiom,
    ! [VarCurr: state_type] :
      ( v53186(VarCurr)
    <=> v53188(VarCurr) ) ).

tff(addAssignment_27508,axiom,
    ! [VarCurr: state_type] :
      ( v53188(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_27507,axiom,
    ! [VarCurr: state_type] :
      ( v53182(VarCurr)
    <=> v53184(VarCurr) ) ).

tff(addAssignment_27506,axiom,
    ! [VarCurr: state_type] :
      ( v53184(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_27505,axiom,
    ! [VarCurr: state_type] :
      ( v53178(VarCurr)
    <=> v53180(VarCurr) ) ).

tff(addAssignment_27504,axiom,
    ! [VarCurr: state_type] :
      ( v53180(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_27503,axiom,
    ! [VarCurr: state_type] :
      ( v53168(VarCurr)
    <=> v53170(VarCurr) ) ).

tff(addAssignment_27502,axiom,
    ! [VarCurr: state_type] :
      ( v53170(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_27501,axiom,
    ! [VarCurr: state_type] :
      ( v53152(VarCurr,63)
    <=> v53154(VarCurr,63) ) ).

tff(addAssignment_27500,axiom,
    ! [VarCurr: state_type] :
      ( v53154(VarCurr,63)
    <=> v53155(VarCurr,63) ) ).

tff(addAssignment_27499,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,0)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27498,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,1)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27497,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,2)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27496,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,3)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27495,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,4)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27494,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,5)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27493,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,6)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27492,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,7)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27491,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,8)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27490,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,9)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27489,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,10)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27488,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,11)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27487,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,12)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27486,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,13)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27485,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,14)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27484,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,15)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27483,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,16)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27482,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,17)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27481,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,18)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27480,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,19)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27479,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,20)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27478,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,21)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27477,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,22)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27476,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,23)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27475,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,24)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27474,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,25)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27473,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,26)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27472,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,27)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27471,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,28)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27470,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,29)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27469,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,30)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27468,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,31)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27467,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,32)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27466,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,33)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27465,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,34)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27464,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,35)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27463,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,36)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27462,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,37)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27461,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,38)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27460,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,39)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27459,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,40)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27458,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,41)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27457,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,42)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27456,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,43)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27455,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,44)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27454,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,45)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27453,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,46)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27452,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,47)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27451,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,48)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27450,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,49)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27449,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,50)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27448,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,51)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27447,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,52)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27446,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,53)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27445,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,54)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27444,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,55)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27443,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,56)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27442,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,57)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27441,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,58)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27440,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,59)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27439,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,60)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27438,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,61)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27437,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,62)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27436,axiom,
    ! [VarCurr: state_type] :
      ( v53155(VarCurr,63)
    <=> v53156(VarCurr) ) ).

tff(addAssignment_27435,axiom,
    ! [VarCurr: state_type] :
      ( v53156(VarCurr)
    <=> v6079(VarCurr) ) ).

tff(addAssignment_27434,axiom,
    ! [VarCurr: state_type] :
      ( v53126(VarCurr)
    <=> v53128(VarCurr) ) ).

tff(addAssignment_27433,axiom,
    ! [VarCurr: state_type] :
      ( v53128(VarCurr)
    <=> v53130(VarCurr) ) ).

tff(addAssignment_27432,axiom,
    ! [VarCurr: state_type] :
      ( v53130(VarCurr)
    <=> v53132(VarCurr) ) ).

tff(addAssignment_27431,axiom,
    ! [VarCurr: state_type] :
      ( v53132(VarCurr)
    <=> v53134(VarCurr) ) ).

tff(addAssignment_27430,axiom,
    ! [VarCurr: state_type] :
      ( v53134(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_27429,axiom,
    ! [VarCurr: state_type] :
      ( v53116(VarCurr)
    <=> v53118(VarCurr) ) ).

tff(addAssignment_27428,axiom,
    ! [VarCurr: state_type] :
      ( v53118(VarCurr)
    <=> v53120(VarCurr) ) ).

tff(addAssignment_27427,axiom,
    ! [VarCurr: state_type] :
      ( v53120(VarCurr)
    <=> v53122(VarCurr) ) ).

tff(addAssignment_27426,axiom,
    ! [VarCurr: state_type] :
      ( v53122(VarCurr)
    <=> v53124(VarCurr) ) ).

tff(addAssignment_27425,axiom,
    ! [VarCurr: state_type] :
      ( v53124(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(addAssignment_27424,axiom,
    ! [VarCurr: state_type] :
      ( v52957(VarCurr)
    <=> v52959(VarCurr) ) ).

tff(addAssignment_27423,axiom,
    ! [VarCurr: state_type] :
      ( v52959(VarCurr)
    <=> v52961(VarCurr) ) ).

tff(addAssignment_27422,axiom,
    ! [VarCurr: state_type] :
      ( v52961(VarCurr)
    <=> v52963(VarCurr) ) ).

tff(addAssignment_27421,axiom,
    ! [VarCurr: state_type] :
      ( v52963(VarCurr)
    <=> v52965(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4921,axiom,
    ! [VarCurr: state_type] :
      ( v52965(VarCurr)
    <=> ( v53087(VarCurr)
      <~> v53047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4920,axiom,
    ! [VarCurr: state_type] :
      ( v53087(VarCurr)
    <=> ( v52967(VarCurr)
      <~> v53007(VarCurr) ) ) ).

tff(addAssignment_27420,axiom,
    ! [VarCurr: state_type] :
      ( v53047(VarCurr)
    <=> v53049(VarCurr) ) ).

tff(addAssignment_27419,axiom,
    ! [VarCurr: state_type] :
      ( v53049(VarCurr)
    <=> v6017(VarCurr,59) ) ).

tff(addAssignment_27418,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,59)
    <=> v6019(VarCurr,59) ) ).

tff(addAssignment_27417,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,59)
    <=> v6021(VarCurr,59) ) ).

tff(addAssignment_27416,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,59)
    <=> v6023(VarCurr,59) ) ).

tff(addAssignment_27415,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,59)
    <=> v6025(VarCurr,59) ) ).

tff(addAssignment_27414,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,59)
    <=> v6027(VarCurr,59) ) ).

tff(addAssignment_27413,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,59)
    <=> v52434(VarCurr,59) ) ).

tff(addAssignment_27412,axiom,
    ! [VarCurr: state_type] :
      ( v52452(VarCurr,3)
    <=> v6031(VarCurr,59) ) ).

tff(addAssignment_27411,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,59)
    <=> v6033(VarCurr,59) ) ).

tff(addAssignment_27410,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,59)
    <=> v53079(VarNext,59) ) ).

tff(addCaseBooleanConditionEqualRanges1_630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53080(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53079(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_630,axiom,
    ! [VarNext: state_type] :
      ( v53080(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53079(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53080(VarNext)
      <=> v53081(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53081(VarNext)
      <=> ( v53083(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2985,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53083(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27409,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,59)
    <=> v6057(VarCurr,59) ) ).

tff(addAssignment_27408,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,59)
    <=> v6059(VarCurr,59) ) ).

tff(addAssignment_27407,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,59)
    <=> v53052(VarCurr,3) ) ).

tff(addAssignment_27406,axiom,
    ! [VarCurr: state_type] :
      ( v53052(VarCurr,3)
    <=> v53054(VarCurr,3) ) ).

tff(addAssignment_27405,axiom,
    ! [VarCurr: state_type] :
      ( v53054(VarCurr,3)
    <=> v53071(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53071(VarCurr,B)
      <=> ( v53072(VarCurr,B)
          | v53075(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53075(VarCurr,B)
      <=> ( v53064(VarCurr,B)
          & v53076(VarCurr,B) ) ) ) ).

tff(addAssignment_27404,axiom,
    ! [VarCurr: state_type] :
      ( v53076(VarCurr,0)
    <=> v53077(VarCurr) ) ).

tff(addAssignment_27403,axiom,
    ! [VarCurr: state_type] :
      ( v53076(VarCurr,1)
    <=> v53077(VarCurr) ) ).

tff(addAssignment_27402,axiom,
    ! [VarCurr: state_type] :
      ( v53076(VarCurr,2)
    <=> v53077(VarCurr) ) ).

tff(addAssignment_27401,axiom,
    ! [VarCurr: state_type] :
      ( v53076(VarCurr,3)
    <=> v53077(VarCurr) ) ).

tff(addAssignment_27400,axiom,
    ! [VarCurr: state_type] :
      ( v53077(VarCurr)
    <=> v53068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53072(VarCurr,B)
      <=> ( v53056(VarCurr,B)
          & v53073(VarCurr,B) ) ) ) ).

tff(addAssignment_27399,axiom,
    ! [VarCurr: state_type] :
      ( v53073(VarCurr,0)
    <=> v53074(VarCurr) ) ).

tff(addAssignment_27398,axiom,
    ! [VarCurr: state_type] :
      ( v53073(VarCurr,1)
    <=> v53074(VarCurr) ) ).

tff(addAssignment_27397,axiom,
    ! [VarCurr: state_type] :
      ( v53073(VarCurr,2)
    <=> v53074(VarCurr) ) ).

tff(addAssignment_27396,axiom,
    ! [VarCurr: state_type] :
      ( v53073(VarCurr,3)
    <=> v53074(VarCurr) ) ).

tff(addAssignment_27395,axiom,
    ! [VarCurr: state_type] :
      ( v53074(VarCurr)
    <=> v53060(VarCurr) ) ).

tff(addAssignment_27394,axiom,
    ! [VarCurr: state_type] :
      ( v53068(VarCurr)
    <=> v53070(VarCurr) ) ).

tff(addAssignment_27393,axiom,
    ! [VarCurr: state_type] :
      ( v53070(VarCurr)
    <=> v52379(VarCurr,14) ) ).

tff(addAssignment_27392,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,14)
    <=> v52381(VarCurr,14) ) ).

tff(addAssignment_27391,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,14)
    <=> v52383(VarCurr,14) ) ).

tff(addAssignment_27390,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,14)
    <=> v52384(VarCurr,14) ) ).

tff(addAssignment_27389,axiom,
    ! [VarCurr: state_type] :
      ( v53064(VarCurr,3)
    <=> v53066(VarCurr,3) ) ).

tff(addAssignment_27388,axiom,
    ! [VarCurr: state_type] :
      ( v53066(VarCurr,3)
    <=> v6069(VarCurr,59) ) ).

tff(addAssignment_27387,axiom,
    ! [VarCurr: state_type] :
      ( v53060(VarCurr)
    <=> v53062(VarCurr) ) ).

tff(addAssignment_27386,axiom,
    ! [VarCurr: state_type] :
      ( v53062(VarCurr)
    <=> v52361(VarCurr,14) ) ).

tff(addAssignment_27385,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,14)
    <=> v52363(VarCurr,14) ) ).

tff(addAssignment_27384,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,14)
    <=> v52365(VarCurr,14) ) ).

tff(addAssignment_27383,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,14)
    <=> v52367(VarCurr,14) ) ).

tff(addAssignment_27382,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,14)
    <=> v52369(VarCurr,14) ) ).

tff(addAssignment_27381,axiom,
    ! [VarCurr: state_type] :
      ( v53056(VarCurr,3)
    <=> v53058(VarCurr,3) ) ).

tff(addAssignment_27380,axiom,
    ! [VarCurr: state_type] :
      ( v53058(VarCurr,3)
    <=> v6069(VarCurr,63) ) ).

tff(addAssignment_27379,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,63)
    <=> v6071(VarCurr,63) ) ).

tff(addAssignment_27378,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,63)
    <=> v6073(VarCurr,63) ) ).

tff(addAssignment_27377,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,63)
    <=> v52355(VarCurr,63) ) ).

tff(addAssignment_27376,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,63)
    <=> v6096(VarCurr,63) ) ).

tff(addAssignment_27375,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,63)
    <=> v6098(VarCurr,63) ) ).

tff(addAssignment_27374,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,63)
    <=> v6100(VarCurr,63) ) ).

tff(addAssignment_27373,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,63)
    <=> v6102(VarCurr,63) ) ).

tff(addAssignment_27372,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,63)
    <=> v6104(VarCurr,63) ) ).

tff(addAssignment_27371,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,63)
    <=> v6106(VarCurr,63) ) ).

tff(addAssignment_27370,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,63)
    <=> v52338(VarCurr,63) ) ).

tff(addAssignment_27369,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,63)
    <=> v52330(VarCurr,63) ) ).

tff(addAssignment_27368,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,63)
    <=> v52332(VarCurr,63) ) ).

tff(addAssignment_27367,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,63)
    <=> v52335(VarCurr,63) ) ).

tff(addAssignment_27366,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,123)
    <=> v33839(VarCurr,123) ) ).

tff(addAssignment_27365,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,123)
    <=> v33841(VarCurr,123) ) ).

tff(addAssignment_27364,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,123)
    <=> v25005(VarCurr,3) ) ).

tff(addAssignment_27363,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,63)
    <=> v6232(VarCurr,63) ) ).

tff(addAssignment_27362,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,63)
    <=> v6234(VarCurr,63) ) ).

tff(addAssignment_27361,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,63)
    <=> v52325(VarCurr,63) ) ).

tff(addAssignment_27360,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,129)
    <=> v6238(VarCurr,129) ) ).

tff(addAssignment_27359,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,129)
    <=> v6240(VarCurr,129) ) ).

tff(addAssignment_27358,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,129)
    <=> v46299(VarCurr,9) ) ).

tff(addAssignment_27357,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,63)
    <=> v6226(VarCurr,63) ) ).

tff(addAssignment_27356,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,63)
    <=> $false ) ).

tff(addAssignment_27355,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,63)
    <=> v6077(VarCurr,63) ) ).

tff(addAssignment_27354,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,63)
    <=> v6091(VarCurr,63) ) ).

tff(addAssignment_27353,axiom,
    ! [VarCurr: state_type] :
      ( v53007(VarCurr)
    <=> v53009(VarCurr) ) ).

tff(addAssignment_27352,axiom,
    ! [VarCurr: state_type] :
      ( v53009(VarCurr)
    <=> v6017(VarCurr,55) ) ).

tff(addAssignment_27351,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,55)
    <=> v6019(VarCurr,55) ) ).

tff(addAssignment_27350,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,55)
    <=> v6021(VarCurr,55) ) ).

tff(addAssignment_27349,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,55)
    <=> v6023(VarCurr,55) ) ).

tff(addAssignment_27348,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,55)
    <=> v6025(VarCurr,55) ) ).

tff(addAssignment_27347,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,55)
    <=> v6027(VarCurr,55) ) ).

tff(addAssignment_27346,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,55)
    <=> v52434(VarCurr,55) ) ).

tff(addAssignment_27345,axiom,
    ! [VarCurr: state_type] :
      ( v52453(VarCurr,3)
    <=> v6031(VarCurr,55) ) ).

tff(addAssignment_27344,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,55)
    <=> v6033(VarCurr,55) ) ).

tff(addAssignment_27343,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,55)
    <=> v53039(VarNext,55) ) ).

tff(addCaseBooleanConditionEqualRanges1_629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53040(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v53039(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_629,axiom,
    ! [VarNext: state_type] :
      ( v53040(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v53039(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53040(VarNext)
      <=> v53041(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53041(VarNext)
      <=> ( v53043(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53043(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27342,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,55)
    <=> v6057(VarCurr,55) ) ).

tff(addAssignment_27341,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,55)
    <=> v6059(VarCurr,55) ) ).

tff(addAssignment_27340,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,55)
    <=> v53012(VarCurr,3) ) ).

tff(addAssignment_27339,axiom,
    ! [VarCurr: state_type] :
      ( v53012(VarCurr,3)
    <=> v53014(VarCurr,3) ) ).

tff(addAssignment_27338,axiom,
    ! [VarCurr: state_type] :
      ( v53014(VarCurr,3)
    <=> v53031(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53031(VarCurr,B)
      <=> ( v53032(VarCurr,B)
          | v53035(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_875,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53035(VarCurr,B)
      <=> ( v53024(VarCurr,B)
          & v53036(VarCurr,B) ) ) ) ).

tff(addAssignment_27337,axiom,
    ! [VarCurr: state_type] :
      ( v53036(VarCurr,0)
    <=> v53037(VarCurr) ) ).

tff(addAssignment_27336,axiom,
    ! [VarCurr: state_type] :
      ( v53036(VarCurr,1)
    <=> v53037(VarCurr) ) ).

tff(addAssignment_27335,axiom,
    ! [VarCurr: state_type] :
      ( v53036(VarCurr,2)
    <=> v53037(VarCurr) ) ).

tff(addAssignment_27334,axiom,
    ! [VarCurr: state_type] :
      ( v53036(VarCurr,3)
    <=> v53037(VarCurr) ) ).

tff(addAssignment_27333,axiom,
    ! [VarCurr: state_type] :
      ( v53037(VarCurr)
    <=> v53028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v53032(VarCurr,B)
      <=> ( v53016(VarCurr,B)
          & v53033(VarCurr,B) ) ) ) ).

tff(addAssignment_27332,axiom,
    ! [VarCurr: state_type] :
      ( v53033(VarCurr,0)
    <=> v53034(VarCurr) ) ).

tff(addAssignment_27331,axiom,
    ! [VarCurr: state_type] :
      ( v53033(VarCurr,1)
    <=> v53034(VarCurr) ) ).

tff(addAssignment_27330,axiom,
    ! [VarCurr: state_type] :
      ( v53033(VarCurr,2)
    <=> v53034(VarCurr) ) ).

tff(addAssignment_27329,axiom,
    ! [VarCurr: state_type] :
      ( v53033(VarCurr,3)
    <=> v53034(VarCurr) ) ).

tff(addAssignment_27328,axiom,
    ! [VarCurr: state_type] :
      ( v53034(VarCurr)
    <=> v53020(VarCurr) ) ).

tff(addAssignment_27327,axiom,
    ! [VarCurr: state_type] :
      ( v53028(VarCurr)
    <=> v53030(VarCurr) ) ).

tff(addAssignment_27326,axiom,
    ! [VarCurr: state_type] :
      ( v53030(VarCurr)
    <=> v52379(VarCurr,13) ) ).

tff(addAssignment_27325,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,13)
    <=> v52381(VarCurr,13) ) ).

tff(addAssignment_27324,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,13)
    <=> v52383(VarCurr,13) ) ).

tff(addAssignment_27323,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,13)
    <=> v52384(VarCurr,13) ) ).

tff(addAssignment_27322,axiom,
    ! [VarCurr: state_type] :
      ( v53024(VarCurr,3)
    <=> v53026(VarCurr,3) ) ).

tff(addAssignment_27321,axiom,
    ! [VarCurr: state_type] :
      ( v53026(VarCurr,3)
    <=> v6069(VarCurr,55) ) ).

tff(addAssignment_27320,axiom,
    ! [VarCurr: state_type] :
      ( v53020(VarCurr)
    <=> v53022(VarCurr) ) ).

tff(addAssignment_27319,axiom,
    ! [VarCurr: state_type] :
      ( v53022(VarCurr)
    <=> v52361(VarCurr,13) ) ).

tff(addAssignment_27318,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,13)
    <=> v52363(VarCurr,13) ) ).

tff(addAssignment_27317,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,13)
    <=> v52365(VarCurr,13) ) ).

tff(addAssignment_27316,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,13)
    <=> v52367(VarCurr,13) ) ).

tff(addAssignment_27315,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,13)
    <=> v52369(VarCurr,13) ) ).

tff(addAssignment_27314,axiom,
    ! [VarCurr: state_type] :
      ( v53016(VarCurr,3)
    <=> v53018(VarCurr,3) ) ).

tff(addAssignment_27313,axiom,
    ! [VarCurr: state_type] :
      ( v53018(VarCurr,3)
    <=> v6069(VarCurr,59) ) ).

tff(addAssignment_27312,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,59)
    <=> v6071(VarCurr,59) ) ).

tff(addAssignment_27311,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,59)
    <=> v6073(VarCurr,59) ) ).

tff(addAssignment_27310,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,59)
    <=> v52355(VarCurr,59) ) ).

tff(addAssignment_27309,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,59)
    <=> v6096(VarCurr,59) ) ).

tff(addAssignment_27308,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,59)
    <=> v6098(VarCurr,59) ) ).

tff(addAssignment_27307,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,59)
    <=> v6100(VarCurr,59) ) ).

tff(addAssignment_27306,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,59)
    <=> v6102(VarCurr,59) ) ).

tff(addAssignment_27305,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,59)
    <=> v6104(VarCurr,59) ) ).

tff(addAssignment_27304,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,59)
    <=> v6106(VarCurr,59) ) ).

tff(addAssignment_27303,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,59)
    <=> v52338(VarCurr,59) ) ).

tff(addAssignment_27302,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,59)
    <=> v52330(VarCurr,59) ) ).

tff(addAssignment_27301,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,59)
    <=> v52332(VarCurr,59) ) ).

tff(addAssignment_27300,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,59)
    <=> v52335(VarCurr,59) ) ).

tff(addAssignment_27299,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,113)
    <=> v33839(VarCurr,113) ) ).

tff(addAssignment_27298,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,113)
    <=> v33841(VarCurr,113) ) ).

tff(addAssignment_27297,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,113)
    <=> v23455(VarCurr,5) ) ).

tff(addAssignment_27296,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,59)
    <=> v6232(VarCurr,59) ) ).

tff(addAssignment_27295,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,59)
    <=> v6234(VarCurr,59) ) ).

tff(addAssignment_27294,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,59)
    <=> v52325(VarCurr,59) ) ).

tff(addAssignment_27293,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,119)
    <=> v6238(VarCurr,119) ) ).

tff(addAssignment_27292,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,119)
    <=> v6240(VarCurr,119) ) ).

tff(addAssignment_27291,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,119)
    <=> v44749(VarCurr,11) ) ).

tff(addAssignment_27290,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,59)
    <=> v6226(VarCurr,59) ) ).

tff(addAssignment_27289,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,59)
    <=> $false ) ).

tff(addAssignment_27288,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,59)
    <=> v6077(VarCurr,59) ) ).

tff(addAssignment_27287,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,59)
    <=> v6091(VarCurr,59) ) ).

tff(addAssignment_27286,axiom,
    ! [VarCurr: state_type] :
      ( v52967(VarCurr)
    <=> v52969(VarCurr) ) ).

tff(addAssignment_27285,axiom,
    ! [VarCurr: state_type] :
      ( v52969(VarCurr)
    <=> v6017(VarCurr,51) ) ).

tff(addAssignment_27284,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,51)
    <=> v6019(VarCurr,51) ) ).

tff(addAssignment_27283,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,51)
    <=> v6021(VarCurr,51) ) ).

tff(addAssignment_27282,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,51)
    <=> v6023(VarCurr,51) ) ).

tff(addAssignment_27281,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,51)
    <=> v6025(VarCurr,51) ) ).

tff(addAssignment_27280,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,51)
    <=> v6027(VarCurr,51) ) ).

tff(addAssignment_27279,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,51)
    <=> v52434(VarCurr,51) ) ).

tff(addAssignment_27278,axiom,
    ! [VarCurr: state_type] :
      ( v52454(VarCurr,3)
    <=> v6031(VarCurr,51) ) ).

tff(addAssignment_27277,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,51)
    <=> v6033(VarCurr,51) ) ).

tff(addAssignment_27276,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,51)
    <=> v52999(VarNext,51) ) ).

tff(addCaseBooleanConditionEqualRanges1_628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53000(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52999(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_628,axiom,
    ! [VarNext: state_type] :
      ( v53000(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52999(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53000(VarNext)
      <=> v53001(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v53001(VarNext)
      <=> ( v53003(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v53003(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27275,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,51)
    <=> v6057(VarCurr,51) ) ).

tff(addAssignment_27274,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,51)
    <=> v6059(VarCurr,51) ) ).

tff(addAssignment_27273,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,51)
    <=> v52972(VarCurr,3) ) ).

tff(addAssignment_27272,axiom,
    ! [VarCurr: state_type] :
      ( v52972(VarCurr,3)
    <=> v52974(VarCurr,3) ) ).

tff(addAssignment_27271,axiom,
    ! [VarCurr: state_type] :
      ( v52974(VarCurr,3)
    <=> v52991(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52991(VarCurr,B)
      <=> ( v52992(VarCurr,B)
          | v52995(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52995(VarCurr,B)
      <=> ( v52984(VarCurr,B)
          & v52996(VarCurr,B) ) ) ) ).

tff(addAssignment_27270,axiom,
    ! [VarCurr: state_type] :
      ( v52996(VarCurr,0)
    <=> v52997(VarCurr) ) ).

tff(addAssignment_27269,axiom,
    ! [VarCurr: state_type] :
      ( v52996(VarCurr,1)
    <=> v52997(VarCurr) ) ).

tff(addAssignment_27268,axiom,
    ! [VarCurr: state_type] :
      ( v52996(VarCurr,2)
    <=> v52997(VarCurr) ) ).

tff(addAssignment_27267,axiom,
    ! [VarCurr: state_type] :
      ( v52996(VarCurr,3)
    <=> v52997(VarCurr) ) ).

tff(addAssignment_27266,axiom,
    ! [VarCurr: state_type] :
      ( v52997(VarCurr)
    <=> v52988(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52992(VarCurr,B)
      <=> ( v52976(VarCurr,B)
          & v52993(VarCurr,B) ) ) ) ).

tff(addAssignment_27265,axiom,
    ! [VarCurr: state_type] :
      ( v52993(VarCurr,0)
    <=> v52994(VarCurr) ) ).

tff(addAssignment_27264,axiom,
    ! [VarCurr: state_type] :
      ( v52993(VarCurr,1)
    <=> v52994(VarCurr) ) ).

tff(addAssignment_27263,axiom,
    ! [VarCurr: state_type] :
      ( v52993(VarCurr,2)
    <=> v52994(VarCurr) ) ).

tff(addAssignment_27262,axiom,
    ! [VarCurr: state_type] :
      ( v52993(VarCurr,3)
    <=> v52994(VarCurr) ) ).

tff(addAssignment_27261,axiom,
    ! [VarCurr: state_type] :
      ( v52994(VarCurr)
    <=> v52980(VarCurr) ) ).

tff(addAssignment_27260,axiom,
    ! [VarCurr: state_type] :
      ( v52988(VarCurr)
    <=> v52990(VarCurr) ) ).

tff(addAssignment_27259,axiom,
    ! [VarCurr: state_type] :
      ( v52990(VarCurr)
    <=> v52379(VarCurr,12) ) ).

tff(addAssignment_27258,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,12)
    <=> v52381(VarCurr,12) ) ).

tff(addAssignment_27257,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,12)
    <=> v52383(VarCurr,12) ) ).

tff(addAssignment_27256,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,12)
    <=> v52384(VarCurr,12) ) ).

tff(addAssignment_27255,axiom,
    ! [VarCurr: state_type] :
      ( v52984(VarCurr,3)
    <=> v52986(VarCurr,3) ) ).

tff(addAssignment_27254,axiom,
    ! [VarCurr: state_type] :
      ( v52986(VarCurr,3)
    <=> v6069(VarCurr,51) ) ).

tff(addAssignment_27253,axiom,
    ! [VarCurr: state_type] :
      ( v52980(VarCurr)
    <=> v52982(VarCurr) ) ).

tff(addAssignment_27252,axiom,
    ! [VarCurr: state_type] :
      ( v52982(VarCurr)
    <=> v52361(VarCurr,12) ) ).

tff(addAssignment_27251,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,12)
    <=> v52363(VarCurr,12) ) ).

tff(addAssignment_27250,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,12)
    <=> v52365(VarCurr,12) ) ).

tff(addAssignment_27249,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,12)
    <=> v52367(VarCurr,12) ) ).

tff(addAssignment_27248,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,12)
    <=> v52369(VarCurr,12) ) ).

tff(addAssignment_27247,axiom,
    ! [VarCurr: state_type] :
      ( v52976(VarCurr,3)
    <=> v52978(VarCurr,3) ) ).

tff(addAssignment_27246,axiom,
    ! [VarCurr: state_type] :
      ( v52978(VarCurr,3)
    <=> v6069(VarCurr,55) ) ).

tff(addAssignment_27245,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,55)
    <=> v6071(VarCurr,55) ) ).

tff(addAssignment_27244,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,55)
    <=> v6073(VarCurr,55) ) ).

tff(addAssignment_27243,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,55)
    <=> v52355(VarCurr,55) ) ).

tff(addAssignment_27242,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,55)
    <=> v6096(VarCurr,55) ) ).

tff(addAssignment_27241,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,55)
    <=> v6098(VarCurr,55) ) ).

tff(addAssignment_27240,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,55)
    <=> v6100(VarCurr,55) ) ).

tff(addAssignment_27239,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,55)
    <=> v6102(VarCurr,55) ) ).

tff(addAssignment_27238,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,55)
    <=> v6104(VarCurr,55) ) ).

tff(addAssignment_27237,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,55)
    <=> v6106(VarCurr,55) ) ).

tff(addAssignment_27236,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,55)
    <=> v52338(VarCurr,55) ) ).

tff(addAssignment_27235,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,55)
    <=> v52330(VarCurr,55) ) ).

tff(addAssignment_27234,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,55)
    <=> v52332(VarCurr,55) ) ).

tff(addAssignment_27233,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,55)
    <=> v52335(VarCurr,55) ) ).

tff(addAssignment_27232,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,109)
    <=> v33839(VarCurr,109) ) ).

tff(addAssignment_27231,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,109)
    <=> v33841(VarCurr,109) ) ).

tff(addAssignment_27230,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,109)
    <=> v23455(VarCurr,1) ) ).

tff(addAssignment_27229,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,55)
    <=> v6232(VarCurr,55) ) ).

tff(addAssignment_27228,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,55)
    <=> v6234(VarCurr,55) ) ).

tff(addAssignment_27227,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,55)
    <=> v52325(VarCurr,55) ) ).

tff(addAssignment_27226,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,115)
    <=> v6238(VarCurr,115) ) ).

tff(addAssignment_27225,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,115)
    <=> v6240(VarCurr,115) ) ).

tff(addAssignment_27224,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,115)
    <=> v44749(VarCurr,7) ) ).

tff(addAssignment_27223,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,55)
    <=> v6226(VarCurr,55) ) ).

tff(addAssignment_27222,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,55)
    <=> $false ) ).

tff(addAssignment_27221,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,55)
    <=> v6077(VarCurr,55) ) ).

tff(addAssignment_27220,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,55)
    <=> v6091(VarCurr,55) ) ).

tff(addAssignment_27219,axiom,
    ! [VarCurr: state_type] :
      ( v52825(VarCurr)
    <=> v52827(VarCurr) ) ).

tff(addAssignment_27218,axiom,
    ! [VarCurr: state_type] :
      ( v52827(VarCurr)
    <=> v52829(VarCurr) ) ).

tff(addAssignment_27217,axiom,
    ! [VarCurr: state_type] :
      ( v52829(VarCurr)
    <=> v52831(VarCurr) ) ).

tff(addAssignment_27216,axiom,
    ! [VarCurr: state_type] :
      ( v52831(VarCurr)
    <=> v52833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4913,axiom,
    ! [VarCurr: state_type] :
      ( v52833(VarCurr)
    <=> ( v52955(VarCurr)
      <~> v52915(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4912,axiom,
    ! [VarCurr: state_type] :
      ( v52955(VarCurr)
    <=> ( v52835(VarCurr)
      <~> v52875(VarCurr) ) ) ).

tff(addAssignment_27215,axiom,
    ! [VarCurr: state_type] :
      ( v52915(VarCurr)
    <=> v52917(VarCurr) ) ).

tff(addAssignment_27214,axiom,
    ! [VarCurr: state_type] :
      ( v52917(VarCurr)
    <=> v6017(VarCurr,47) ) ).

tff(addAssignment_27213,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,47)
    <=> v6019(VarCurr,47) ) ).

tff(addAssignment_27212,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,47)
    <=> v6021(VarCurr,47) ) ).

tff(addAssignment_27211,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,47)
    <=> v6023(VarCurr,47) ) ).

tff(addAssignment_27210,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,47)
    <=> v6025(VarCurr,47) ) ).

tff(addAssignment_27209,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,47)
    <=> v6027(VarCurr,47) ) ).

tff(addAssignment_27208,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,47)
    <=> v52434(VarCurr,47) ) ).

tff(addAssignment_27207,axiom,
    ! [VarCurr: state_type] :
      ( v52455(VarCurr,3)
    <=> v6031(VarCurr,47) ) ).

tff(addAssignment_27206,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,47)
    <=> v6033(VarCurr,47) ) ).

tff(addAssignment_27205,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,47)
    <=> v52947(VarNext,47) ) ).

tff(addCaseBooleanConditionEqualRanges1_627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52948(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52947(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_627,axiom,
    ! [VarNext: state_type] :
      ( v52948(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52947(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52948(VarNext)
      <=> v52949(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52949(VarNext)
      <=> ( v52951(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52951(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27204,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,47)
    <=> v6057(VarCurr,47) ) ).

tff(addAssignment_27203,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,47)
    <=> v6059(VarCurr,47) ) ).

tff(addAssignment_27202,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,47)
    <=> v52920(VarCurr,3) ) ).

tff(addAssignment_27201,axiom,
    ! [VarCurr: state_type] :
      ( v52920(VarCurr,3)
    <=> v52922(VarCurr,3) ) ).

tff(addAssignment_27200,axiom,
    ! [VarCurr: state_type] :
      ( v52922(VarCurr,3)
    <=> v52939(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_870,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52939(VarCurr,B)
      <=> ( v52940(VarCurr,B)
          | v52943(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52943(VarCurr,B)
      <=> ( v52932(VarCurr,B)
          & v52944(VarCurr,B) ) ) ) ).

tff(addAssignment_27199,axiom,
    ! [VarCurr: state_type] :
      ( v52944(VarCurr,0)
    <=> v52945(VarCurr) ) ).

tff(addAssignment_27198,axiom,
    ! [VarCurr: state_type] :
      ( v52944(VarCurr,1)
    <=> v52945(VarCurr) ) ).

tff(addAssignment_27197,axiom,
    ! [VarCurr: state_type] :
      ( v52944(VarCurr,2)
    <=> v52945(VarCurr) ) ).

tff(addAssignment_27196,axiom,
    ! [VarCurr: state_type] :
      ( v52944(VarCurr,3)
    <=> v52945(VarCurr) ) ).

tff(addAssignment_27195,axiom,
    ! [VarCurr: state_type] :
      ( v52945(VarCurr)
    <=> v52936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52940(VarCurr,B)
      <=> ( v52924(VarCurr,B)
          & v52941(VarCurr,B) ) ) ) ).

tff(addAssignment_27194,axiom,
    ! [VarCurr: state_type] :
      ( v52941(VarCurr,0)
    <=> v52942(VarCurr) ) ).

tff(addAssignment_27193,axiom,
    ! [VarCurr: state_type] :
      ( v52941(VarCurr,1)
    <=> v52942(VarCurr) ) ).

tff(addAssignment_27192,axiom,
    ! [VarCurr: state_type] :
      ( v52941(VarCurr,2)
    <=> v52942(VarCurr) ) ).

tff(addAssignment_27191,axiom,
    ! [VarCurr: state_type] :
      ( v52941(VarCurr,3)
    <=> v52942(VarCurr) ) ).

tff(addAssignment_27190,axiom,
    ! [VarCurr: state_type] :
      ( v52942(VarCurr)
    <=> v52928(VarCurr) ) ).

tff(addAssignment_27189,axiom,
    ! [VarCurr: state_type] :
      ( v52936(VarCurr)
    <=> v52938(VarCurr) ) ).

tff(addAssignment_27188,axiom,
    ! [VarCurr: state_type] :
      ( v52938(VarCurr)
    <=> v52379(VarCurr,11) ) ).

tff(addAssignment_27187,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,11)
    <=> v52381(VarCurr,11) ) ).

tff(addAssignment_27186,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,11)
    <=> v52383(VarCurr,11) ) ).

tff(addAssignment_27185,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,11)
    <=> v52384(VarCurr,11) ) ).

tff(addAssignment_27184,axiom,
    ! [VarCurr: state_type] :
      ( v52932(VarCurr,3)
    <=> v52934(VarCurr,3) ) ).

tff(addAssignment_27183,axiom,
    ! [VarCurr: state_type] :
      ( v52934(VarCurr,3)
    <=> v6069(VarCurr,47) ) ).

tff(addAssignment_27182,axiom,
    ! [VarCurr: state_type] :
      ( v52928(VarCurr)
    <=> v52930(VarCurr) ) ).

tff(addAssignment_27181,axiom,
    ! [VarCurr: state_type] :
      ( v52930(VarCurr)
    <=> v52361(VarCurr,11) ) ).

tff(addAssignment_27180,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,11)
    <=> v52363(VarCurr,11) ) ).

tff(addAssignment_27179,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,11)
    <=> v52365(VarCurr,11) ) ).

tff(addAssignment_27178,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,11)
    <=> v52367(VarCurr,11) ) ).

tff(addAssignment_27177,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,11)
    <=> v52369(VarCurr,11) ) ).

tff(addAssignment_27176,axiom,
    ! [VarCurr: state_type] :
      ( v52924(VarCurr,3)
    <=> v52926(VarCurr,3) ) ).

tff(addAssignment_27175,axiom,
    ! [VarCurr: state_type] :
      ( v52926(VarCurr,3)
    <=> v6069(VarCurr,51) ) ).

tff(addAssignment_27174,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,51)
    <=> v6071(VarCurr,51) ) ).

tff(addAssignment_27173,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,51)
    <=> v6073(VarCurr,51) ) ).

tff(addAssignment_27172,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,51)
    <=> v52355(VarCurr,51) ) ).

tff(addAssignment_27171,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,51)
    <=> v6096(VarCurr,51) ) ).

tff(addAssignment_27170,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,51)
    <=> v6098(VarCurr,51) ) ).

tff(addAssignment_27169,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,51)
    <=> v6100(VarCurr,51) ) ).

tff(addAssignment_27168,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,51)
    <=> v6102(VarCurr,51) ) ).

tff(addAssignment_27167,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,51)
    <=> v6104(VarCurr,51) ) ).

tff(addAssignment_27166,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,51)
    <=> v6106(VarCurr,51) ) ).

tff(addAssignment_27165,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,51)
    <=> v52338(VarCurr,51) ) ).

tff(addAssignment_27164,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,51)
    <=> v52330(VarCurr,51) ) ).

tff(addAssignment_27163,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,51)
    <=> v52332(VarCurr,51) ) ).

tff(addAssignment_27162,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,51)
    <=> v52335(VarCurr,51) ) ).

tff(addAssignment_27161,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,99)
    <=> v33839(VarCurr,99) ) ).

tff(addAssignment_27160,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,99)
    <=> v33841(VarCurr,99) ) ).

tff(addAssignment_27159,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,99)
    <=> v21905(VarCurr,3) ) ).

tff(addAssignment_27158,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,51)
    <=> v6232(VarCurr,51) ) ).

tff(addAssignment_27157,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,51)
    <=> v6234(VarCurr,51) ) ).

tff(addAssignment_27156,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,51)
    <=> v52325(VarCurr,51) ) ).

tff(addAssignment_27155,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,105)
    <=> v6238(VarCurr,105) ) ).

tff(addAssignment_27154,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,105)
    <=> v6240(VarCurr,105) ) ).

tff(addAssignment_27153,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,105)
    <=> v43199(VarCurr,9) ) ).

tff(addAssignment_27152,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,51)
    <=> v6226(VarCurr,51) ) ).

tff(addAssignment_27151,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,51)
    <=> $false ) ).

tff(addAssignment_27150,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,51)
    <=> v6077(VarCurr,51) ) ).

tff(addAssignment_27149,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,51)
    <=> v6091(VarCurr,51) ) ).

tff(addAssignment_27148,axiom,
    ! [VarCurr: state_type] :
      ( v52875(VarCurr)
    <=> v52877(VarCurr) ) ).

tff(addAssignment_27147,axiom,
    ! [VarCurr: state_type] :
      ( v52877(VarCurr)
    <=> v6017(VarCurr,43) ) ).

tff(addAssignment_27146,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,43)
    <=> v6019(VarCurr,43) ) ).

tff(addAssignment_27145,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,43)
    <=> v6021(VarCurr,43) ) ).

tff(addAssignment_27144,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,43)
    <=> v6023(VarCurr,43) ) ).

tff(addAssignment_27143,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,43)
    <=> v6025(VarCurr,43) ) ).

tff(addAssignment_27142,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,43)
    <=> v6027(VarCurr,43) ) ).

tff(addAssignment_27141,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,43)
    <=> v52434(VarCurr,43) ) ).

tff(addAssignment_27140,axiom,
    ! [VarCurr: state_type] :
      ( v52456(VarCurr,3)
    <=> v6031(VarCurr,43) ) ).

tff(addAssignment_27139,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,43)
    <=> v6033(VarCurr,43) ) ).

tff(addAssignment_27138,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,43)
    <=> v52907(VarNext,43) ) ).

tff(addCaseBooleanConditionEqualRanges1_626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52908(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52907(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_626,axiom,
    ! [VarNext: state_type] :
      ( v52908(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52907(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52908(VarNext)
      <=> v52909(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52909(VarNext)
      <=> ( v52911(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52911(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27137,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,43)
    <=> v6057(VarCurr,43) ) ).

tff(addAssignment_27136,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,43)
    <=> v6059(VarCurr,43) ) ).

tff(addAssignment_27135,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,43)
    <=> v52880(VarCurr,3) ) ).

tff(addAssignment_27134,axiom,
    ! [VarCurr: state_type] :
      ( v52880(VarCurr,3)
    <=> v52882(VarCurr,3) ) ).

tff(addAssignment_27133,axiom,
    ! [VarCurr: state_type] :
      ( v52882(VarCurr,3)
    <=> v52899(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52899(VarCurr,B)
      <=> ( v52900(VarCurr,B)
          | v52903(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52903(VarCurr,B)
      <=> ( v52892(VarCurr,B)
          & v52904(VarCurr,B) ) ) ) ).

tff(addAssignment_27132,axiom,
    ! [VarCurr: state_type] :
      ( v52904(VarCurr,0)
    <=> v52905(VarCurr) ) ).

tff(addAssignment_27131,axiom,
    ! [VarCurr: state_type] :
      ( v52904(VarCurr,1)
    <=> v52905(VarCurr) ) ).

tff(addAssignment_27130,axiom,
    ! [VarCurr: state_type] :
      ( v52904(VarCurr,2)
    <=> v52905(VarCurr) ) ).

tff(addAssignment_27129,axiom,
    ! [VarCurr: state_type] :
      ( v52904(VarCurr,3)
    <=> v52905(VarCurr) ) ).

tff(addAssignment_27128,axiom,
    ! [VarCurr: state_type] :
      ( v52905(VarCurr)
    <=> v52896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52900(VarCurr,B)
      <=> ( v52884(VarCurr,B)
          & v52901(VarCurr,B) ) ) ) ).

tff(addAssignment_27127,axiom,
    ! [VarCurr: state_type] :
      ( v52901(VarCurr,0)
    <=> v52902(VarCurr) ) ).

tff(addAssignment_27126,axiom,
    ! [VarCurr: state_type] :
      ( v52901(VarCurr,1)
    <=> v52902(VarCurr) ) ).

tff(addAssignment_27125,axiom,
    ! [VarCurr: state_type] :
      ( v52901(VarCurr,2)
    <=> v52902(VarCurr) ) ).

tff(addAssignment_27124,axiom,
    ! [VarCurr: state_type] :
      ( v52901(VarCurr,3)
    <=> v52902(VarCurr) ) ).

tff(addAssignment_27123,axiom,
    ! [VarCurr: state_type] :
      ( v52902(VarCurr)
    <=> v52888(VarCurr) ) ).

tff(addAssignment_27122,axiom,
    ! [VarCurr: state_type] :
      ( v52896(VarCurr)
    <=> v52898(VarCurr) ) ).

tff(addAssignment_27121,axiom,
    ! [VarCurr: state_type] :
      ( v52898(VarCurr)
    <=> v52379(VarCurr,10) ) ).

tff(addAssignment_27120,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,10)
    <=> v52381(VarCurr,10) ) ).

tff(addAssignment_27119,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,10)
    <=> v52383(VarCurr,10) ) ).

tff(addAssignment_27118,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,10)
    <=> v52384(VarCurr,10) ) ).

tff(addAssignment_27117,axiom,
    ! [VarCurr: state_type] :
      ( v52892(VarCurr,3)
    <=> v52894(VarCurr,3) ) ).

tff(addAssignment_27116,axiom,
    ! [VarCurr: state_type] :
      ( v52894(VarCurr,3)
    <=> v6069(VarCurr,43) ) ).

tff(addAssignment_27115,axiom,
    ! [VarCurr: state_type] :
      ( v52888(VarCurr)
    <=> v52890(VarCurr) ) ).

tff(addAssignment_27114,axiom,
    ! [VarCurr: state_type] :
      ( v52890(VarCurr)
    <=> v52361(VarCurr,10) ) ).

tff(addAssignment_27113,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,10)
    <=> v52363(VarCurr,10) ) ).

tff(addAssignment_27112,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,10)
    <=> v52365(VarCurr,10) ) ).

tff(addAssignment_27111,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,10)
    <=> v52367(VarCurr,10) ) ).

tff(addAssignment_27110,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,10)
    <=> v52369(VarCurr,10) ) ).

tff(addAssignment_27109,axiom,
    ! [VarCurr: state_type] :
      ( v52884(VarCurr,3)
    <=> v52886(VarCurr,3) ) ).

tff(addAssignment_27108,axiom,
    ! [VarCurr: state_type] :
      ( v52886(VarCurr,3)
    <=> v6069(VarCurr,47) ) ).

tff(addAssignment_27107,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,47)
    <=> v6071(VarCurr,47) ) ).

tff(addAssignment_27106,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,47)
    <=> v6073(VarCurr,47) ) ).

tff(addAssignment_27105,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,47)
    <=> v52355(VarCurr,47) ) ).

tff(addAssignment_27104,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,47)
    <=> v6096(VarCurr,47) ) ).

tff(addAssignment_27103,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,47)
    <=> v6098(VarCurr,47) ) ).

tff(addAssignment_27102,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,47)
    <=> v6100(VarCurr,47) ) ).

tff(addAssignment_27101,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,47)
    <=> v6102(VarCurr,47) ) ).

tff(addAssignment_27100,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,47)
    <=> v6104(VarCurr,47) ) ).

tff(addAssignment_27099,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,47)
    <=> v6106(VarCurr,47) ) ).

tff(addAssignment_27098,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,47)
    <=> v52338(VarCurr,47) ) ).

tff(addAssignment_27097,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,47)
    <=> v52330(VarCurr,47) ) ).

tff(addAssignment_27096,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,47)
    <=> v52332(VarCurr,47) ) ).

tff(addAssignment_27095,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,47)
    <=> v52335(VarCurr,47) ) ).

tff(addAssignment_27094,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,89)
    <=> v33839(VarCurr,89) ) ).

tff(addAssignment_27093,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,89)
    <=> v33841(VarCurr,89) ) ).

tff(addAssignment_27092,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,89)
    <=> v20355(VarCurr,5) ) ).

tff(addAssignment_27091,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,47)
    <=> v6232(VarCurr,47) ) ).

tff(addAssignment_27090,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,47)
    <=> v6234(VarCurr,47) ) ).

tff(addAssignment_27089,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,47)
    <=> v52325(VarCurr,47) ) ).

tff(addAssignment_27088,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,95)
    <=> v6238(VarCurr,95) ) ).

tff(addAssignment_27087,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,95)
    <=> v6240(VarCurr,95) ) ).

tff(addAssignment_27086,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,95)
    <=> v41649(VarCurr,11) ) ).

tff(addAssignment_27085,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,47)
    <=> v6226(VarCurr,47) ) ).

tff(addAssignment_27084,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,47)
    <=> $false ) ).

tff(addAssignment_27083,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,47)
    <=> v6077(VarCurr,47) ) ).

tff(addAssignment_27082,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,47)
    <=> v6091(VarCurr,47) ) ).

tff(addAssignment_27081,axiom,
    ! [VarCurr: state_type] :
      ( v52835(VarCurr)
    <=> v52837(VarCurr) ) ).

tff(addAssignment_27080,axiom,
    ! [VarCurr: state_type] :
      ( v52837(VarCurr)
    <=> v6017(VarCurr,39) ) ).

tff(addAssignment_27079,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,39)
    <=> v6019(VarCurr,39) ) ).

tff(addAssignment_27078,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,39)
    <=> v6021(VarCurr,39) ) ).

tff(addAssignment_27077,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,39)
    <=> v6023(VarCurr,39) ) ).

tff(addAssignment_27076,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,39)
    <=> v6025(VarCurr,39) ) ).

tff(addAssignment_27075,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,39)
    <=> v6027(VarCurr,39) ) ).

tff(addAssignment_27074,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,39)
    <=> v52434(VarCurr,39) ) ).

tff(addAssignment_27073,axiom,
    ! [VarCurr: state_type] :
      ( v52457(VarCurr,3)
    <=> v6031(VarCurr,39) ) ).

tff(addAssignment_27072,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,39)
    <=> v6033(VarCurr,39) ) ).

tff(addAssignment_27071,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,39)
    <=> v52867(VarNext,39) ) ).

tff(addCaseBooleanConditionEqualRanges1_625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52868(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52867(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_625,axiom,
    ! [VarNext: state_type] :
      ( v52868(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52867(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52868(VarNext)
      <=> v52869(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4906,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52869(VarNext)
      <=> ( v52871(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52871(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_27070,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,39)
    <=> v6057(VarCurr,39) ) ).

tff(addAssignment_27069,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,39)
    <=> v6059(VarCurr,39) ) ).

tff(addAssignment_27068,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,39)
    <=> v52840(VarCurr,3) ) ).

tff(addAssignment_27067,axiom,
    ! [VarCurr: state_type] :
      ( v52840(VarCurr,3)
    <=> v52842(VarCurr,3) ) ).

tff(addAssignment_27066,axiom,
    ! [VarCurr: state_type] :
      ( v52842(VarCurr,3)
    <=> v52859(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52859(VarCurr,B)
      <=> ( v52860(VarCurr,B)
          | v52863(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52863(VarCurr,B)
      <=> ( v52852(VarCurr,B)
          & v52864(VarCurr,B) ) ) ) ).

tff(addAssignment_27065,axiom,
    ! [VarCurr: state_type] :
      ( v52864(VarCurr,0)
    <=> v52865(VarCurr) ) ).

tff(addAssignment_27064,axiom,
    ! [VarCurr: state_type] :
      ( v52864(VarCurr,1)
    <=> v52865(VarCurr) ) ).

tff(addAssignment_27063,axiom,
    ! [VarCurr: state_type] :
      ( v52864(VarCurr,2)
    <=> v52865(VarCurr) ) ).

tff(addAssignment_27062,axiom,
    ! [VarCurr: state_type] :
      ( v52864(VarCurr,3)
    <=> v52865(VarCurr) ) ).

tff(addAssignment_27061,axiom,
    ! [VarCurr: state_type] :
      ( v52865(VarCurr)
    <=> v52856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52860(VarCurr,B)
      <=> ( v52844(VarCurr,B)
          & v52861(VarCurr,B) ) ) ) ).

tff(addAssignment_27060,axiom,
    ! [VarCurr: state_type] :
      ( v52861(VarCurr,0)
    <=> v52862(VarCurr) ) ).

tff(addAssignment_27059,axiom,
    ! [VarCurr: state_type] :
      ( v52861(VarCurr,1)
    <=> v52862(VarCurr) ) ).

tff(addAssignment_27058,axiom,
    ! [VarCurr: state_type] :
      ( v52861(VarCurr,2)
    <=> v52862(VarCurr) ) ).

tff(addAssignment_27057,axiom,
    ! [VarCurr: state_type] :
      ( v52861(VarCurr,3)
    <=> v52862(VarCurr) ) ).

tff(addAssignment_27056,axiom,
    ! [VarCurr: state_type] :
      ( v52862(VarCurr)
    <=> v52848(VarCurr) ) ).

tff(addAssignment_27055,axiom,
    ! [VarCurr: state_type] :
      ( v52856(VarCurr)
    <=> v52858(VarCurr) ) ).

tff(addAssignment_27054,axiom,
    ! [VarCurr: state_type] :
      ( v52858(VarCurr)
    <=> v52379(VarCurr,9) ) ).

tff(addAssignment_27053,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,9)
    <=> v52381(VarCurr,9) ) ).

tff(addAssignment_27052,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,9)
    <=> v52383(VarCurr,9) ) ).

tff(addAssignment_27051,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,9)
    <=> v52384(VarCurr,9) ) ).

tff(addAssignment_27050,axiom,
    ! [VarCurr: state_type] :
      ( v52852(VarCurr,3)
    <=> v52854(VarCurr,3) ) ).

tff(addAssignment_27049,axiom,
    ! [VarCurr: state_type] :
      ( v52854(VarCurr,3)
    <=> v6069(VarCurr,39) ) ).

tff(addAssignment_27048,axiom,
    ! [VarCurr: state_type] :
      ( v52848(VarCurr)
    <=> v52850(VarCurr) ) ).

tff(addAssignment_27047,axiom,
    ! [VarCurr: state_type] :
      ( v52850(VarCurr)
    <=> v52361(VarCurr,9) ) ).

tff(addAssignment_27046,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,9)
    <=> v52363(VarCurr,9) ) ).

tff(addAssignment_27045,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,9)
    <=> v52365(VarCurr,9) ) ).

tff(addAssignment_27044,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,9)
    <=> v52367(VarCurr,9) ) ).

tff(addAssignment_27043,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,9)
    <=> v52369(VarCurr,9) ) ).

tff(addAssignment_27042,axiom,
    ! [VarCurr: state_type] :
      ( v52844(VarCurr,3)
    <=> v52846(VarCurr,3) ) ).

tff(addAssignment_27041,axiom,
    ! [VarCurr: state_type] :
      ( v52846(VarCurr,3)
    <=> v6069(VarCurr,43) ) ).

tff(addAssignment_27040,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,43)
    <=> v6071(VarCurr,43) ) ).

tff(addAssignment_27039,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,43)
    <=> v6073(VarCurr,43) ) ).

tff(addAssignment_27038,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,43)
    <=> v52355(VarCurr,43) ) ).

tff(addAssignment_27037,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,43)
    <=> v6096(VarCurr,43) ) ).

tff(addAssignment_27036,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,43)
    <=> v6098(VarCurr,43) ) ).

tff(addAssignment_27035,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,43)
    <=> v6100(VarCurr,43) ) ).

tff(addAssignment_27034,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,43)
    <=> v6102(VarCurr,43) ) ).

tff(addAssignment_27033,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,43)
    <=> v6104(VarCurr,43) ) ).

tff(addAssignment_27032,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,43)
    <=> v6106(VarCurr,43) ) ).

tff(addAssignment_27031,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,43)
    <=> v52338(VarCurr,43) ) ).

tff(addAssignment_27030,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,43)
    <=> v52330(VarCurr,43) ) ).

tff(addAssignment_27029,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,43)
    <=> v52332(VarCurr,43) ) ).

tff(addAssignment_27028,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,43)
    <=> v52335(VarCurr,43) ) ).

tff(addAssignment_27027,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,85)
    <=> v33839(VarCurr,85) ) ).

tff(addAssignment_27026,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,85)
    <=> v33841(VarCurr,85) ) ).

tff(addAssignment_27025,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,85)
    <=> v20355(VarCurr,1) ) ).

tff(addAssignment_27024,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,43)
    <=> v6232(VarCurr,43) ) ).

tff(addAssignment_27023,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,43)
    <=> v6234(VarCurr,43) ) ).

tff(addAssignment_27022,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,43)
    <=> v52325(VarCurr,43) ) ).

tff(addAssignment_27021,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,91)
    <=> v6238(VarCurr,91) ) ).

tff(addAssignment_27020,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,91)
    <=> v6240(VarCurr,91) ) ).

tff(addAssignment_27019,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,91)
    <=> v41649(VarCurr,7) ) ).

tff(addAssignment_27018,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,43)
    <=> v6226(VarCurr,43) ) ).

tff(addAssignment_27017,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,43)
    <=> $false ) ).

tff(addAssignment_27016,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,43)
    <=> v6077(VarCurr,43) ) ).

tff(addAssignment_27015,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,43)
    <=> v6091(VarCurr,43) ) ).

tff(addAssignment_27014,axiom,
    ! [VarCurr: state_type] :
      ( v5993(VarCurr)
    <=> v5995(VarCurr) ) ).

tff(addAssignment_27013,axiom,
    ! [VarCurr: state_type] :
      ( v5995(VarCurr)
    <=> v5997(VarCurr) ) ).

tff(addAssignment_27012,axiom,
    ! [VarCurr: state_type] :
      ( v5997(VarCurr)
    <=> v5999(VarCurr) ) ).

tff(addAssignment_27011,axiom,
    ! [VarCurr: state_type] :
      ( v5999(VarCurr)
    <=> v6001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4905,axiom,
    ! [VarCurr: state_type] :
      ( v6001(VarCurr)
    <=> ( v52813(VarCurr)
      <~> v52681(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4904,axiom,
    ! [VarCurr: state_type] :
      ( v52813(VarCurr)
    <=> ( v6003(VarCurr)
      <~> v52549(VarCurr) ) ) ).

tff(addAssignment_27010,axiom,
    ! [VarCurr: state_type] :
      ( v52681(VarCurr)
    <=> v52683(VarCurr) ) ).

tff(addAssignment_27009,axiom,
    ! [VarCurr: state_type] :
      ( v52683(VarCurr)
    <=> v52685(VarCurr) ) ).

tff(addAssignment_27008,axiom,
    ! [VarCurr: state_type] :
      ( v52685(VarCurr)
    <=> v52687(VarCurr) ) ).

tff(addAssignment_27007,axiom,
    ! [VarCurr: state_type] :
      ( v52687(VarCurr)
    <=> v52689(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4903,axiom,
    ! [VarCurr: state_type] :
      ( v52689(VarCurr)
    <=> ( v52811(VarCurr)
      <~> v52771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4902,axiom,
    ! [VarCurr: state_type] :
      ( v52811(VarCurr)
    <=> ( v52691(VarCurr)
      <~> v52731(VarCurr) ) ) ).

tff(addAssignment_27006,axiom,
    ! [VarCurr: state_type] :
      ( v52771(VarCurr)
    <=> v52773(VarCurr) ) ).

tff(addAssignment_27005,axiom,
    ! [VarCurr: state_type] :
      ( v52773(VarCurr)
    <=> v6017(VarCurr,35) ) ).

tff(addAssignment_27004,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,35)
    <=> v6019(VarCurr,35) ) ).

tff(addAssignment_27003,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,35)
    <=> v6021(VarCurr,35) ) ).

tff(addAssignment_27002,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,35)
    <=> v6023(VarCurr,35) ) ).

tff(addAssignment_27001,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,35)
    <=> v6025(VarCurr,35) ) ).

tff(addAssignment_27000,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,35)
    <=> v6027(VarCurr,35) ) ).

tff(addAssignment_26999,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,35)
    <=> v52434(VarCurr,35) ) ).

tff(addAssignment_26998,axiom,
    ! [VarCurr: state_type] :
      ( v52458(VarCurr,3)
    <=> v6031(VarCurr,35) ) ).

tff(addAssignment_26997,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,35)
    <=> v6033(VarCurr,35) ) ).

tff(addAssignment_26996,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,35)
    <=> v52803(VarNext,35) ) ).

tff(addCaseBooleanConditionEqualRanges1_624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52804(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52803(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_624,axiom,
    ! [VarNext: state_type] :
      ( v52804(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52803(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52804(VarNext)
      <=> v52805(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52805(VarNext)
      <=> ( v52807(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52807(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26995,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,35)
    <=> v6057(VarCurr,35) ) ).

tff(addAssignment_26994,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,35)
    <=> v6059(VarCurr,35) ) ).

tff(addAssignment_26993,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,35)
    <=> v52776(VarCurr,3) ) ).

tff(addAssignment_26992,axiom,
    ! [VarCurr: state_type] :
      ( v52776(VarCurr,3)
    <=> v52778(VarCurr,3) ) ).

tff(addAssignment_26991,axiom,
    ! [VarCurr: state_type] :
      ( v52778(VarCurr,3)
    <=> v52795(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52795(VarCurr,B)
      <=> ( v52796(VarCurr,B)
          | v52799(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52799(VarCurr,B)
      <=> ( v52788(VarCurr,B)
          & v52800(VarCurr,B) ) ) ) ).

tff(addAssignment_26990,axiom,
    ! [VarCurr: state_type] :
      ( v52800(VarCurr,0)
    <=> v52801(VarCurr) ) ).

tff(addAssignment_26989,axiom,
    ! [VarCurr: state_type] :
      ( v52800(VarCurr,1)
    <=> v52801(VarCurr) ) ).

tff(addAssignment_26988,axiom,
    ! [VarCurr: state_type] :
      ( v52800(VarCurr,2)
    <=> v52801(VarCurr) ) ).

tff(addAssignment_26987,axiom,
    ! [VarCurr: state_type] :
      ( v52800(VarCurr,3)
    <=> v52801(VarCurr) ) ).

tff(addAssignment_26986,axiom,
    ! [VarCurr: state_type] :
      ( v52801(VarCurr)
    <=> v52792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52796(VarCurr,B)
      <=> ( v52780(VarCurr,B)
          & v52797(VarCurr,B) ) ) ) ).

tff(addAssignment_26985,axiom,
    ! [VarCurr: state_type] :
      ( v52797(VarCurr,0)
    <=> v52798(VarCurr) ) ).

tff(addAssignment_26984,axiom,
    ! [VarCurr: state_type] :
      ( v52797(VarCurr,1)
    <=> v52798(VarCurr) ) ).

tff(addAssignment_26983,axiom,
    ! [VarCurr: state_type] :
      ( v52797(VarCurr,2)
    <=> v52798(VarCurr) ) ).

tff(addAssignment_26982,axiom,
    ! [VarCurr: state_type] :
      ( v52797(VarCurr,3)
    <=> v52798(VarCurr) ) ).

tff(addAssignment_26981,axiom,
    ! [VarCurr: state_type] :
      ( v52798(VarCurr)
    <=> v52784(VarCurr) ) ).

tff(addAssignment_26980,axiom,
    ! [VarCurr: state_type] :
      ( v52792(VarCurr)
    <=> v52794(VarCurr) ) ).

tff(addAssignment_26979,axiom,
    ! [VarCurr: state_type] :
      ( v52794(VarCurr)
    <=> v52379(VarCurr,8) ) ).

tff(addAssignment_26978,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,8)
    <=> v52381(VarCurr,8) ) ).

tff(addAssignment_26977,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,8)
    <=> v52383(VarCurr,8) ) ).

tff(addAssignment_26976,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,8)
    <=> v52384(VarCurr,8) ) ).

tff(addAssignment_26975,axiom,
    ! [VarCurr: state_type] :
      ( v52788(VarCurr,3)
    <=> v52790(VarCurr,3) ) ).

tff(addAssignment_26974,axiom,
    ! [VarCurr: state_type] :
      ( v52790(VarCurr,3)
    <=> v6069(VarCurr,35) ) ).

tff(addAssignment_26973,axiom,
    ! [VarCurr: state_type] :
      ( v52784(VarCurr)
    <=> v52786(VarCurr) ) ).

tff(addAssignment_26972,axiom,
    ! [VarCurr: state_type] :
      ( v52786(VarCurr)
    <=> v52361(VarCurr,8) ) ).

tff(addAssignment_26971,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,8)
    <=> v52363(VarCurr,8) ) ).

tff(addAssignment_26970,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,8)
    <=> v52365(VarCurr,8) ) ).

tff(addAssignment_26969,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,8)
    <=> v52367(VarCurr,8) ) ).

tff(addAssignment_26968,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,8)
    <=> v52369(VarCurr,8) ) ).

tff(addAssignment_26967,axiom,
    ! [VarCurr: state_type] :
      ( v52780(VarCurr,3)
    <=> v52782(VarCurr,3) ) ).

tff(addAssignment_26966,axiom,
    ! [VarCurr: state_type] :
      ( v52782(VarCurr,3)
    <=> v6069(VarCurr,39) ) ).

tff(addAssignment_26965,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,39)
    <=> v6071(VarCurr,39) ) ).

tff(addAssignment_26964,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,39)
    <=> v6073(VarCurr,39) ) ).

tff(addAssignment_26963,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,39)
    <=> v52355(VarCurr,39) ) ).

tff(addAssignment_26962,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,39)
    <=> v6096(VarCurr,39) ) ).

tff(addAssignment_26961,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,39)
    <=> v6098(VarCurr,39) ) ).

tff(addAssignment_26960,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,39)
    <=> v6100(VarCurr,39) ) ).

tff(addAssignment_26959,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,39)
    <=> v6102(VarCurr,39) ) ).

tff(addAssignment_26958,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,39)
    <=> v6104(VarCurr,39) ) ).

tff(addAssignment_26957,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,39)
    <=> v6106(VarCurr,39) ) ).

tff(addAssignment_26956,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,39)
    <=> v52338(VarCurr,39) ) ).

tff(addAssignment_26955,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,39)
    <=> v52330(VarCurr,39) ) ).

tff(addAssignment_26954,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,39)
    <=> v52332(VarCurr,39) ) ).

tff(addAssignment_26953,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,39)
    <=> v52335(VarCurr,39) ) ).

tff(addAssignment_26952,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,75)
    <=> v33839(VarCurr,75) ) ).

tff(addAssignment_26951,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,75)
    <=> v33841(VarCurr,75) ) ).

tff(addAssignment_26950,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,75)
    <=> v18805(VarCurr,3) ) ).

tff(addAssignment_26949,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,39)
    <=> v6232(VarCurr,39) ) ).

tff(addAssignment_26948,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,39)
    <=> v6234(VarCurr,39) ) ).

tff(addAssignment_26947,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,39)
    <=> v52325(VarCurr,39) ) ).

tff(addAssignment_26946,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,81)
    <=> v6238(VarCurr,81) ) ).

tff(addAssignment_26945,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,81)
    <=> v6240(VarCurr,81) ) ).

tff(addAssignment_26944,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,81)
    <=> v40099(VarCurr,9) ) ).

tff(addAssignment_26943,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,39)
    <=> v6226(VarCurr,39) ) ).

tff(addAssignment_26942,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,39)
    <=> $false ) ).

tff(addAssignment_26941,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,39)
    <=> v6077(VarCurr,39) ) ).

tff(addAssignment_26940,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,39)
    <=> v6091(VarCurr,39) ) ).

tff(addAssignment_26939,axiom,
    ! [VarCurr: state_type] :
      ( v52731(VarCurr)
    <=> v52733(VarCurr) ) ).

tff(addAssignment_26938,axiom,
    ! [VarCurr: state_type] :
      ( v52733(VarCurr)
    <=> v6017(VarCurr,31) ) ).

tff(addAssignment_26937,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,31)
    <=> v6019(VarCurr,31) ) ).

tff(addAssignment_26936,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,31)
    <=> v6021(VarCurr,31) ) ).

tff(addAssignment_26935,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,31)
    <=> v6023(VarCurr,31) ) ).

tff(addAssignment_26934,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,31)
    <=> v6025(VarCurr,31) ) ).

tff(addAssignment_26933,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,31)
    <=> v6027(VarCurr,31) ) ).

tff(addAssignment_26932,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,31)
    <=> v52434(VarCurr,31) ) ).

tff(addAssignment_26931,axiom,
    ! [VarCurr: state_type] :
      ( v52459(VarCurr,3)
    <=> v6031(VarCurr,31) ) ).

tff(addAssignment_26930,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,31)
    <=> v6033(VarCurr,31) ) ).

tff(addAssignment_26929,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,31)
    <=> v52763(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52764(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52763(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_623,axiom,
    ! [VarNext: state_type] :
      ( v52764(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52763(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52764(VarNext)
      <=> v52765(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52765(VarNext)
      <=> ( v52767(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52767(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26928,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,31)
    <=> v6057(VarCurr,31) ) ).

tff(addAssignment_26927,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,31)
    <=> v6059(VarCurr,31) ) ).

tff(addAssignment_26926,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,31)
    <=> v52736(VarCurr,3) ) ).

tff(addAssignment_26925,axiom,
    ! [VarCurr: state_type] :
      ( v52736(VarCurr,3)
    <=> v52738(VarCurr,3) ) ).

tff(addAssignment_26924,axiom,
    ! [VarCurr: state_type] :
      ( v52738(VarCurr,3)
    <=> v52755(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52755(VarCurr,B)
      <=> ( v52756(VarCurr,B)
          | v52759(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52759(VarCurr,B)
      <=> ( v52748(VarCurr,B)
          & v52760(VarCurr,B) ) ) ) ).

tff(addAssignment_26923,axiom,
    ! [VarCurr: state_type] :
      ( v52760(VarCurr,0)
    <=> v52761(VarCurr) ) ).

tff(addAssignment_26922,axiom,
    ! [VarCurr: state_type] :
      ( v52760(VarCurr,1)
    <=> v52761(VarCurr) ) ).

tff(addAssignment_26921,axiom,
    ! [VarCurr: state_type] :
      ( v52760(VarCurr,2)
    <=> v52761(VarCurr) ) ).

tff(addAssignment_26920,axiom,
    ! [VarCurr: state_type] :
      ( v52760(VarCurr,3)
    <=> v52761(VarCurr) ) ).

tff(addAssignment_26919,axiom,
    ! [VarCurr: state_type] :
      ( v52761(VarCurr)
    <=> v52752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52756(VarCurr,B)
      <=> ( v52740(VarCurr,B)
          & v52757(VarCurr,B) ) ) ) ).

tff(addAssignment_26918,axiom,
    ! [VarCurr: state_type] :
      ( v52757(VarCurr,0)
    <=> v52758(VarCurr) ) ).

tff(addAssignment_26917,axiom,
    ! [VarCurr: state_type] :
      ( v52757(VarCurr,1)
    <=> v52758(VarCurr) ) ).

tff(addAssignment_26916,axiom,
    ! [VarCurr: state_type] :
      ( v52757(VarCurr,2)
    <=> v52758(VarCurr) ) ).

tff(addAssignment_26915,axiom,
    ! [VarCurr: state_type] :
      ( v52757(VarCurr,3)
    <=> v52758(VarCurr) ) ).

tff(addAssignment_26914,axiom,
    ! [VarCurr: state_type] :
      ( v52758(VarCurr)
    <=> v52744(VarCurr) ) ).

tff(addAssignment_26913,axiom,
    ! [VarCurr: state_type] :
      ( v52752(VarCurr)
    <=> v52754(VarCurr) ) ).

tff(addAssignment_26912,axiom,
    ! [VarCurr: state_type] :
      ( v52754(VarCurr)
    <=> v52379(VarCurr,7) ) ).

tff(addAssignment_26911,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,7)
    <=> v52381(VarCurr,7) ) ).

tff(addAssignment_26910,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,7)
    <=> v52383(VarCurr,7) ) ).

tff(addAssignment_26909,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,7)
    <=> v52384(VarCurr,7) ) ).

tff(addAssignment_26908,axiom,
    ! [VarCurr: state_type] :
      ( v52748(VarCurr,3)
    <=> v52750(VarCurr,3) ) ).

tff(addAssignment_26907,axiom,
    ! [VarCurr: state_type] :
      ( v52750(VarCurr,3)
    <=> v6069(VarCurr,31) ) ).

tff(addAssignment_26906,axiom,
    ! [VarCurr: state_type] :
      ( v52744(VarCurr)
    <=> v52746(VarCurr) ) ).

tff(addAssignment_26905,axiom,
    ! [VarCurr: state_type] :
      ( v52746(VarCurr)
    <=> v52361(VarCurr,7) ) ).

tff(addAssignment_26904,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,7)
    <=> v52363(VarCurr,7) ) ).

tff(addAssignment_26903,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,7)
    <=> v52365(VarCurr,7) ) ).

tff(addAssignment_26902,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,7)
    <=> v52367(VarCurr,7) ) ).

tff(addAssignment_26901,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,7)
    <=> v52369(VarCurr,7) ) ).

tff(addAssignment_26900,axiom,
    ! [VarCurr: state_type] :
      ( v52740(VarCurr,3)
    <=> v52742(VarCurr,3) ) ).

tff(addAssignment_26899,axiom,
    ! [VarCurr: state_type] :
      ( v52742(VarCurr,3)
    <=> v6069(VarCurr,35) ) ).

tff(addAssignment_26898,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,35)
    <=> v6071(VarCurr,35) ) ).

tff(addAssignment_26897,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,35)
    <=> v6073(VarCurr,35) ) ).

tff(addAssignment_26896,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,35)
    <=> v52355(VarCurr,35) ) ).

tff(addAssignment_26895,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,35)
    <=> v6096(VarCurr,35) ) ).

tff(addAssignment_26894,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,35)
    <=> v6098(VarCurr,35) ) ).

tff(addAssignment_26893,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,35)
    <=> v6100(VarCurr,35) ) ).

tff(addAssignment_26892,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,35)
    <=> v6102(VarCurr,35) ) ).

tff(addAssignment_26891,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,35)
    <=> v6104(VarCurr,35) ) ).

tff(addAssignment_26890,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,35)
    <=> v6106(VarCurr,35) ) ).

tff(addAssignment_26889,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,35)
    <=> v52338(VarCurr,35) ) ).

tff(addAssignment_26888,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,35)
    <=> v52330(VarCurr,35) ) ).

tff(addAssignment_26887,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,35)
    <=> v52332(VarCurr,35) ) ).

tff(addAssignment_26886,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,35)
    <=> v52335(VarCurr,35) ) ).

tff(addAssignment_26885,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,65)
    <=> v33839(VarCurr,65) ) ).

tff(addAssignment_26884,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,65)
    <=> v33841(VarCurr,65) ) ).

tff(addAssignment_26883,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,65)
    <=> v17255(VarCurr,5) ) ).

tff(addAssignment_26882,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,35)
    <=> v6232(VarCurr,35) ) ).

tff(addAssignment_26881,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,35)
    <=> v6234(VarCurr,35) ) ).

tff(addAssignment_26880,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,35)
    <=> v52325(VarCurr,35) ) ).

tff(addAssignment_26879,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,71)
    <=> v6238(VarCurr,71) ) ).

tff(addAssignment_26878,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,71)
    <=> v6240(VarCurr,71) ) ).

tff(addAssignment_26877,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,71)
    <=> v38549(VarCurr,11) ) ).

tff(addAssignment_26876,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,35)
    <=> v6226(VarCurr,35) ) ).

tff(addAssignment_26875,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,35)
    <=> $false ) ).

tff(addAssignment_26874,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,35)
    <=> v6077(VarCurr,35) ) ).

tff(addAssignment_26873,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,35)
    <=> v6091(VarCurr,35) ) ).

tff(addAssignment_26872,axiom,
    ! [VarCurr: state_type] :
      ( v52691(VarCurr)
    <=> v52693(VarCurr) ) ).

tff(addAssignment_26871,axiom,
    ! [VarCurr: state_type] :
      ( v52693(VarCurr)
    <=> v6017(VarCurr,27) ) ).

tff(addAssignment_26870,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,27)
    <=> v6019(VarCurr,27) ) ).

tff(addAssignment_26869,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,27)
    <=> v6021(VarCurr,27) ) ).

tff(addAssignment_26868,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,27)
    <=> v6023(VarCurr,27) ) ).

tff(addAssignment_26867,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,27)
    <=> v6025(VarCurr,27) ) ).

tff(addAssignment_26866,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,27)
    <=> v6027(VarCurr,27) ) ).

tff(addAssignment_26865,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,27)
    <=> v52434(VarCurr,27) ) ).

tff(addAssignment_26864,axiom,
    ! [VarCurr: state_type] :
      ( v52460(VarCurr,3)
    <=> v6031(VarCurr,27) ) ).

tff(addAssignment_26863,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,27)
    <=> v6033(VarCurr,27) ) ).

tff(addAssignment_26862,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,27)
    <=> v52723(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52724(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52723(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_622,axiom,
    ! [VarNext: state_type] :
      ( v52724(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52723(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52724(VarNext)
      <=> v52725(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52725(VarNext)
      <=> ( v52727(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2977,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52727(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26861,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,27)
    <=> v6057(VarCurr,27) ) ).

tff(addAssignment_26860,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,27)
    <=> v6059(VarCurr,27) ) ).

tff(addAssignment_26859,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,27)
    <=> v52696(VarCurr,3) ) ).

tff(addAssignment_26858,axiom,
    ! [VarCurr: state_type] :
      ( v52696(VarCurr,3)
    <=> v52698(VarCurr,3) ) ).

tff(addAssignment_26857,axiom,
    ! [VarCurr: state_type] :
      ( v52698(VarCurr,3)
    <=> v52715(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52715(VarCurr,B)
      <=> ( v52716(VarCurr,B)
          | v52719(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52719(VarCurr,B)
      <=> ( v52708(VarCurr,B)
          & v52720(VarCurr,B) ) ) ) ).

tff(addAssignment_26856,axiom,
    ! [VarCurr: state_type] :
      ( v52720(VarCurr,0)
    <=> v52721(VarCurr) ) ).

tff(addAssignment_26855,axiom,
    ! [VarCurr: state_type] :
      ( v52720(VarCurr,1)
    <=> v52721(VarCurr) ) ).

tff(addAssignment_26854,axiom,
    ! [VarCurr: state_type] :
      ( v52720(VarCurr,2)
    <=> v52721(VarCurr) ) ).

tff(addAssignment_26853,axiom,
    ! [VarCurr: state_type] :
      ( v52720(VarCurr,3)
    <=> v52721(VarCurr) ) ).

tff(addAssignment_26852,axiom,
    ! [VarCurr: state_type] :
      ( v52721(VarCurr)
    <=> v52712(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52716(VarCurr,B)
      <=> ( v52700(VarCurr,B)
          & v52717(VarCurr,B) ) ) ) ).

tff(addAssignment_26851,axiom,
    ! [VarCurr: state_type] :
      ( v52717(VarCurr,0)
    <=> v52718(VarCurr) ) ).

tff(addAssignment_26850,axiom,
    ! [VarCurr: state_type] :
      ( v52717(VarCurr,1)
    <=> v52718(VarCurr) ) ).

tff(addAssignment_26849,axiom,
    ! [VarCurr: state_type] :
      ( v52717(VarCurr,2)
    <=> v52718(VarCurr) ) ).

tff(addAssignment_26848,axiom,
    ! [VarCurr: state_type] :
      ( v52717(VarCurr,3)
    <=> v52718(VarCurr) ) ).

tff(addAssignment_26847,axiom,
    ! [VarCurr: state_type] :
      ( v52718(VarCurr)
    <=> v52704(VarCurr) ) ).

tff(addAssignment_26846,axiom,
    ! [VarCurr: state_type] :
      ( v52712(VarCurr)
    <=> v52714(VarCurr) ) ).

tff(addAssignment_26845,axiom,
    ! [VarCurr: state_type] :
      ( v52714(VarCurr)
    <=> v52379(VarCurr,6) ) ).

tff(addAssignment_26844,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,6)
    <=> v52381(VarCurr,6) ) ).

tff(addAssignment_26843,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,6)
    <=> v52383(VarCurr,6) ) ).

tff(addAssignment_26842,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,6)
    <=> v52384(VarCurr,6) ) ).

tff(addAssignment_26841,axiom,
    ! [VarCurr: state_type] :
      ( v52708(VarCurr,3)
    <=> v52710(VarCurr,3) ) ).

tff(addAssignment_26840,axiom,
    ! [VarCurr: state_type] :
      ( v52710(VarCurr,3)
    <=> v6069(VarCurr,27) ) ).

tff(addAssignment_26839,axiom,
    ! [VarCurr: state_type] :
      ( v52704(VarCurr)
    <=> v52706(VarCurr) ) ).

tff(addAssignment_26838,axiom,
    ! [VarCurr: state_type] :
      ( v52706(VarCurr)
    <=> v52361(VarCurr,6) ) ).

tff(addAssignment_26837,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,6)
    <=> v52363(VarCurr,6) ) ).

tff(addAssignment_26836,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,6)
    <=> v52365(VarCurr,6) ) ).

tff(addAssignment_26835,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,6)
    <=> v52367(VarCurr,6) ) ).

tff(addAssignment_26834,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,6)
    <=> v52369(VarCurr,6) ) ).

tff(addAssignment_26833,axiom,
    ! [VarCurr: state_type] :
      ( v52700(VarCurr,3)
    <=> v52702(VarCurr,3) ) ).

tff(addAssignment_26832,axiom,
    ! [VarCurr: state_type] :
      ( v52702(VarCurr,3)
    <=> v6069(VarCurr,31) ) ).

tff(addAssignment_26831,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,31)
    <=> v6071(VarCurr,31) ) ).

tff(addAssignment_26830,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,31)
    <=> v6073(VarCurr,31) ) ).

tff(addAssignment_26829,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,31)
    <=> v52355(VarCurr,31) ) ).

tff(addAssignment_26828,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,31)
    <=> v6096(VarCurr,31) ) ).

tff(addAssignment_26827,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,31)
    <=> v6098(VarCurr,31) ) ).

tff(addAssignment_26826,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,31)
    <=> v6100(VarCurr,31) ) ).

tff(addAssignment_26825,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,31)
    <=> v6102(VarCurr,31) ) ).

tff(addAssignment_26824,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,31)
    <=> v6104(VarCurr,31) ) ).

tff(addAssignment_26823,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,31)
    <=> v6106(VarCurr,31) ) ).

tff(addAssignment_26822,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,31)
    <=> v52338(VarCurr,31) ) ).

tff(addAssignment_26821,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,31)
    <=> v52330(VarCurr,31) ) ).

tff(addAssignment_26820,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,31)
    <=> v52332(VarCurr,31) ) ).

tff(addAssignment_26819,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,31)
    <=> v52335(VarCurr,31) ) ).

tff(addAssignment_26818,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,61)
    <=> v33839(VarCurr,61) ) ).

tff(addAssignment_26817,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,61)
    <=> v33841(VarCurr,61) ) ).

tff(addAssignment_26816,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,61)
    <=> v17255(VarCurr,1) ) ).

tff(addAssignment_26815,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,31)
    <=> v6232(VarCurr,31) ) ).

tff(addAssignment_26814,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,31)
    <=> v6234(VarCurr,31) ) ).

tff(addAssignment_26813,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,31)
    <=> v52325(VarCurr,31) ) ).

tff(addAssignment_26812,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,67)
    <=> v6238(VarCurr,67) ) ).

tff(addAssignment_26811,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,67)
    <=> v6240(VarCurr,67) ) ).

tff(addAssignment_26810,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,67)
    <=> v38549(VarCurr,7) ) ).

tff(addAssignment_26809,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,31)
    <=> v6226(VarCurr,31) ) ).

tff(addAssignment_26808,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_26807,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,31)
    <=> v6077(VarCurr,31) ) ).

tff(addAssignment_26806,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,31)
    <=> v6091(VarCurr,31) ) ).

tff(addAssignment_26805,axiom,
    ! [VarCurr: state_type] :
      ( v52549(VarCurr)
    <=> v52551(VarCurr) ) ).

tff(addAssignment_26804,axiom,
    ! [VarCurr: state_type] :
      ( v52551(VarCurr)
    <=> v52553(VarCurr) ) ).

tff(addAssignment_26803,axiom,
    ! [VarCurr: state_type] :
      ( v52553(VarCurr)
    <=> v52555(VarCurr) ) ).

tff(addAssignment_26802,axiom,
    ! [VarCurr: state_type] :
      ( v52555(VarCurr)
    <=> v52557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4895,axiom,
    ! [VarCurr: state_type] :
      ( v52557(VarCurr)
    <=> ( v52679(VarCurr)
      <~> v52639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4894,axiom,
    ! [VarCurr: state_type] :
      ( v52679(VarCurr)
    <=> ( v52559(VarCurr)
      <~> v52599(VarCurr) ) ) ).

tff(addAssignment_26801,axiom,
    ! [VarCurr: state_type] :
      ( v52639(VarCurr)
    <=> v52641(VarCurr) ) ).

tff(addAssignment_26800,axiom,
    ! [VarCurr: state_type] :
      ( v52641(VarCurr)
    <=> v6017(VarCurr,23) ) ).

tff(addAssignment_26799,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,23)
    <=> v6019(VarCurr,23) ) ).

tff(addAssignment_26798,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,23)
    <=> v6021(VarCurr,23) ) ).

tff(addAssignment_26797,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,23)
    <=> v6023(VarCurr,23) ) ).

tff(addAssignment_26796,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,23)
    <=> v6025(VarCurr,23) ) ).

tff(addAssignment_26795,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,23)
    <=> v6027(VarCurr,23) ) ).

tff(addAssignment_26794,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,23)
    <=> v52434(VarCurr,23) ) ).

tff(addAssignment_26793,axiom,
    ! [VarCurr: state_type] :
      ( v52461(VarCurr,3)
    <=> v6031(VarCurr,23) ) ).

tff(addAssignment_26792,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,23)
    <=> v6033(VarCurr,23) ) ).

tff(addAssignment_26791,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,23)
    <=> v52671(VarNext,23) ) ).

tff(addCaseBooleanConditionEqualRanges1_621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52672(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52671(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_621,axiom,
    ! [VarNext: state_type] :
      ( v52672(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52671(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52672(VarNext)
      <=> v52673(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52673(VarNext)
      <=> ( v52675(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52675(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26790,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,23)
    <=> v6057(VarCurr,23) ) ).

tff(addAssignment_26789,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,23)
    <=> v6059(VarCurr,23) ) ).

tff(addAssignment_26788,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,23)
    <=> v52644(VarCurr,3) ) ).

tff(addAssignment_26787,axiom,
    ! [VarCurr: state_type] :
      ( v52644(VarCurr,3)
    <=> v52646(VarCurr,3) ) ).

tff(addAssignment_26786,axiom,
    ! [VarCurr: state_type] :
      ( v52646(VarCurr,3)
    <=> v52663(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52663(VarCurr,B)
      <=> ( v52664(VarCurr,B)
          | v52667(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52667(VarCurr,B)
      <=> ( v52656(VarCurr,B)
          & v52668(VarCurr,B) ) ) ) ).

tff(addAssignment_26785,axiom,
    ! [VarCurr: state_type] :
      ( v52668(VarCurr,0)
    <=> v52669(VarCurr) ) ).

tff(addAssignment_26784,axiom,
    ! [VarCurr: state_type] :
      ( v52668(VarCurr,1)
    <=> v52669(VarCurr) ) ).

tff(addAssignment_26783,axiom,
    ! [VarCurr: state_type] :
      ( v52668(VarCurr,2)
    <=> v52669(VarCurr) ) ).

tff(addAssignment_26782,axiom,
    ! [VarCurr: state_type] :
      ( v52668(VarCurr,3)
    <=> v52669(VarCurr) ) ).

tff(addAssignment_26781,axiom,
    ! [VarCurr: state_type] :
      ( v52669(VarCurr)
    <=> v52660(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52664(VarCurr,B)
      <=> ( v52648(VarCurr,B)
          & v52665(VarCurr,B) ) ) ) ).

tff(addAssignment_26780,axiom,
    ! [VarCurr: state_type] :
      ( v52665(VarCurr,0)
    <=> v52666(VarCurr) ) ).

tff(addAssignment_26779,axiom,
    ! [VarCurr: state_type] :
      ( v52665(VarCurr,1)
    <=> v52666(VarCurr) ) ).

tff(addAssignment_26778,axiom,
    ! [VarCurr: state_type] :
      ( v52665(VarCurr,2)
    <=> v52666(VarCurr) ) ).

tff(addAssignment_26777,axiom,
    ! [VarCurr: state_type] :
      ( v52665(VarCurr,3)
    <=> v52666(VarCurr) ) ).

tff(addAssignment_26776,axiom,
    ! [VarCurr: state_type] :
      ( v52666(VarCurr)
    <=> v52652(VarCurr) ) ).

tff(addAssignment_26775,axiom,
    ! [VarCurr: state_type] :
      ( v52660(VarCurr)
    <=> v52662(VarCurr) ) ).

tff(addAssignment_26774,axiom,
    ! [VarCurr: state_type] :
      ( v52662(VarCurr)
    <=> v52379(VarCurr,5) ) ).

tff(addAssignment_26773,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,5)
    <=> v52381(VarCurr,5) ) ).

tff(addAssignment_26772,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,5)
    <=> v52383(VarCurr,5) ) ).

tff(addAssignment_26771,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,5)
    <=> v52384(VarCurr,5) ) ).

tff(addAssignment_26770,axiom,
    ! [VarCurr: state_type] :
      ( v52656(VarCurr,3)
    <=> v52658(VarCurr,3) ) ).

tff(addAssignment_26769,axiom,
    ! [VarCurr: state_type] :
      ( v52658(VarCurr,3)
    <=> v6069(VarCurr,23) ) ).

tff(addAssignment_26768,axiom,
    ! [VarCurr: state_type] :
      ( v52652(VarCurr)
    <=> v52654(VarCurr) ) ).

tff(addAssignment_26767,axiom,
    ! [VarCurr: state_type] :
      ( v52654(VarCurr)
    <=> v52361(VarCurr,5) ) ).

tff(addAssignment_26766,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,5)
    <=> v52363(VarCurr,5) ) ).

tff(addAssignment_26765,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,5)
    <=> v52365(VarCurr,5) ) ).

tff(addAssignment_26764,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,5)
    <=> v52367(VarCurr,5) ) ).

tff(addAssignment_26763,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,5)
    <=> v52369(VarCurr,5) ) ).

tff(addAssignment_26762,axiom,
    ! [VarCurr: state_type] :
      ( v52648(VarCurr,3)
    <=> v52650(VarCurr,3) ) ).

tff(addAssignment_26761,axiom,
    ! [VarCurr: state_type] :
      ( v52650(VarCurr,3)
    <=> v6069(VarCurr,27) ) ).

tff(addAssignment_26760,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,27)
    <=> v6071(VarCurr,27) ) ).

tff(addAssignment_26759,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,27)
    <=> v6073(VarCurr,27) ) ).

tff(addAssignment_26758,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,27)
    <=> v52355(VarCurr,27) ) ).

tff(addAssignment_26757,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,27)
    <=> v6096(VarCurr,27) ) ).

tff(addAssignment_26756,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,27)
    <=> v6098(VarCurr,27) ) ).

tff(addAssignment_26755,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,27)
    <=> v6100(VarCurr,27) ) ).

tff(addAssignment_26754,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,27)
    <=> v6102(VarCurr,27) ) ).

tff(addAssignment_26753,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,27)
    <=> v6104(VarCurr,27) ) ).

tff(addAssignment_26752,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,27)
    <=> v6106(VarCurr,27) ) ).

tff(addAssignment_26751,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,27)
    <=> v52338(VarCurr,27) ) ).

tff(addAssignment_26750,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,27)
    <=> v52330(VarCurr,27) ) ).

tff(addAssignment_26749,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,27)
    <=> v52332(VarCurr,27) ) ).

tff(addAssignment_26748,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,27)
    <=> v52335(VarCurr,27) ) ).

tff(addAssignment_26747,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,51)
    <=> v33839(VarCurr,51) ) ).

tff(addAssignment_26746,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,51)
    <=> v33841(VarCurr,51) ) ).

tff(addAssignment_26745,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,51)
    <=> v15705(VarCurr,3) ) ).

tff(addAssignment_26744,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,27)
    <=> v6232(VarCurr,27) ) ).

tff(addAssignment_26743,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,27)
    <=> v6234(VarCurr,27) ) ).

tff(addAssignment_26742,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,27)
    <=> v52325(VarCurr,27) ) ).

tff(addAssignment_26741,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,57)
    <=> v6238(VarCurr,57) ) ).

tff(addAssignment_26740,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,57)
    <=> v6240(VarCurr,57) ) ).

tff(addAssignment_26739,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,57)
    <=> v36999(VarCurr,9) ) ).

tff(addAssignment_26738,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,27)
    <=> v6226(VarCurr,27) ) ).

tff(addAssignment_26737,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,27)
    <=> $false ) ).

tff(addAssignment_26736,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,27)
    <=> v6077(VarCurr,27) ) ).

tff(addAssignment_26735,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,27)
    <=> v6091(VarCurr,27) ) ).

tff(addAssignment_26734,axiom,
    ! [VarCurr: state_type] :
      ( v52599(VarCurr)
    <=> v52601(VarCurr) ) ).

tff(addAssignment_26733,axiom,
    ! [VarCurr: state_type] :
      ( v52601(VarCurr)
    <=> v6017(VarCurr,19) ) ).

tff(addAssignment_26732,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,19)
    <=> v6019(VarCurr,19) ) ).

tff(addAssignment_26731,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,19)
    <=> v6021(VarCurr,19) ) ).

tff(addAssignment_26730,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,19)
    <=> v6023(VarCurr,19) ) ).

tff(addAssignment_26729,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,19)
    <=> v6025(VarCurr,19) ) ).

tff(addAssignment_26728,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,19)
    <=> v6027(VarCurr,19) ) ).

tff(addAssignment_26727,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,19)
    <=> v52434(VarCurr,19) ) ).

tff(addAssignment_26726,axiom,
    ! [VarCurr: state_type] :
      ( v52462(VarCurr,3)
    <=> v6031(VarCurr,19) ) ).

tff(addAssignment_26725,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,19)
    <=> v6033(VarCurr,19) ) ).

tff(addAssignment_26724,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,19)
    <=> v52631(VarNext,19) ) ).

tff(addCaseBooleanConditionEqualRanges1_620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52632(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52631(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_620,axiom,
    ! [VarNext: state_type] :
      ( v52632(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52631(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52632(VarNext)
      <=> v52633(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52633(VarNext)
      <=> ( v52635(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52635(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26723,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,19)
    <=> v6057(VarCurr,19) ) ).

tff(addAssignment_26722,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,19)
    <=> v6059(VarCurr,19) ) ).

tff(addAssignment_26721,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,19)
    <=> v52604(VarCurr,3) ) ).

tff(addAssignment_26720,axiom,
    ! [VarCurr: state_type] :
      ( v52604(VarCurr,3)
    <=> v52606(VarCurr,3) ) ).

tff(addAssignment_26719,axiom,
    ! [VarCurr: state_type] :
      ( v52606(VarCurr,3)
    <=> v52623(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52623(VarCurr,B)
      <=> ( v52624(VarCurr,B)
          | v52627(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52627(VarCurr,B)
      <=> ( v52616(VarCurr,B)
          & v52628(VarCurr,B) ) ) ) ).

tff(addAssignment_26718,axiom,
    ! [VarCurr: state_type] :
      ( v52628(VarCurr,0)
    <=> v52629(VarCurr) ) ).

tff(addAssignment_26717,axiom,
    ! [VarCurr: state_type] :
      ( v52628(VarCurr,1)
    <=> v52629(VarCurr) ) ).

tff(addAssignment_26716,axiom,
    ! [VarCurr: state_type] :
      ( v52628(VarCurr,2)
    <=> v52629(VarCurr) ) ).

tff(addAssignment_26715,axiom,
    ! [VarCurr: state_type] :
      ( v52628(VarCurr,3)
    <=> v52629(VarCurr) ) ).

tff(addAssignment_26714,axiom,
    ! [VarCurr: state_type] :
      ( v52629(VarCurr)
    <=> v52620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52624(VarCurr,B)
      <=> ( v52608(VarCurr,B)
          & v52625(VarCurr,B) ) ) ) ).

tff(addAssignment_26713,axiom,
    ! [VarCurr: state_type] :
      ( v52625(VarCurr,0)
    <=> v52626(VarCurr) ) ).

tff(addAssignment_26712,axiom,
    ! [VarCurr: state_type] :
      ( v52625(VarCurr,1)
    <=> v52626(VarCurr) ) ).

tff(addAssignment_26711,axiom,
    ! [VarCurr: state_type] :
      ( v52625(VarCurr,2)
    <=> v52626(VarCurr) ) ).

tff(addAssignment_26710,axiom,
    ! [VarCurr: state_type] :
      ( v52625(VarCurr,3)
    <=> v52626(VarCurr) ) ).

tff(addAssignment_26709,axiom,
    ! [VarCurr: state_type] :
      ( v52626(VarCurr)
    <=> v52612(VarCurr) ) ).

tff(addAssignment_26708,axiom,
    ! [VarCurr: state_type] :
      ( v52620(VarCurr)
    <=> v52622(VarCurr) ) ).

tff(addAssignment_26707,axiom,
    ! [VarCurr: state_type] :
      ( v52622(VarCurr)
    <=> v52379(VarCurr,4) ) ).

tff(addAssignment_26706,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,4)
    <=> v52381(VarCurr,4) ) ).

tff(addAssignment_26705,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,4)
    <=> v52383(VarCurr,4) ) ).

tff(addAssignment_26704,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,4)
    <=> v52384(VarCurr,4) ) ).

tff(addAssignment_26703,axiom,
    ! [VarCurr: state_type] :
      ( v52616(VarCurr,3)
    <=> v52618(VarCurr,3) ) ).

tff(addAssignment_26702,axiom,
    ! [VarCurr: state_type] :
      ( v52618(VarCurr,3)
    <=> v6069(VarCurr,19) ) ).

tff(addAssignment_26701,axiom,
    ! [VarCurr: state_type] :
      ( v52612(VarCurr)
    <=> v52614(VarCurr) ) ).

tff(addAssignment_26700,axiom,
    ! [VarCurr: state_type] :
      ( v52614(VarCurr)
    <=> v52361(VarCurr,4) ) ).

tff(addAssignment_26699,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,4)
    <=> v52363(VarCurr,4) ) ).

tff(addAssignment_26698,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,4)
    <=> v52365(VarCurr,4) ) ).

tff(addAssignment_26697,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,4)
    <=> v52367(VarCurr,4) ) ).

tff(addAssignment_26696,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,4)
    <=> v52369(VarCurr,4) ) ).

tff(addAssignment_26695,axiom,
    ! [VarCurr: state_type] :
      ( v52608(VarCurr,3)
    <=> v52610(VarCurr,3) ) ).

tff(addAssignment_26694,axiom,
    ! [VarCurr: state_type] :
      ( v52610(VarCurr,3)
    <=> v6069(VarCurr,23) ) ).

tff(addAssignment_26693,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,23)
    <=> v6071(VarCurr,23) ) ).

tff(addAssignment_26692,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,23)
    <=> v6073(VarCurr,23) ) ).

tff(addAssignment_26691,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,23)
    <=> v52355(VarCurr,23) ) ).

tff(addAssignment_26690,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,23)
    <=> v6096(VarCurr,23) ) ).

tff(addAssignment_26689,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,23)
    <=> v6098(VarCurr,23) ) ).

tff(addAssignment_26688,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,23)
    <=> v6100(VarCurr,23) ) ).

tff(addAssignment_26687,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,23)
    <=> v6102(VarCurr,23) ) ).

tff(addAssignment_26686,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,23)
    <=> v6104(VarCurr,23) ) ).

tff(addAssignment_26685,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,23)
    <=> v6106(VarCurr,23) ) ).

tff(addAssignment_26684,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,23)
    <=> v52338(VarCurr,23) ) ).

tff(addAssignment_26683,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,23)
    <=> v52330(VarCurr,23) ) ).

tff(addAssignment_26682,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,23)
    <=> v52332(VarCurr,23) ) ).

tff(addAssignment_26681,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,23)
    <=> v52335(VarCurr,23) ) ).

tff(addAssignment_26680,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,41)
    <=> v33839(VarCurr,41) ) ).

tff(addAssignment_26679,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,41)
    <=> v33841(VarCurr,41) ) ).

tff(addAssignment_26678,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,41)
    <=> v14155(VarCurr,5) ) ).

tff(addAssignment_26677,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,23)
    <=> v6232(VarCurr,23) ) ).

tff(addAssignment_26676,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,23)
    <=> v6234(VarCurr,23) ) ).

tff(addAssignment_26675,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,23)
    <=> v52325(VarCurr,23) ) ).

tff(addAssignment_26674,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,47)
    <=> v6238(VarCurr,47) ) ).

tff(addAssignment_26673,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,47)
    <=> v6240(VarCurr,47) ) ).

tff(addAssignment_26672,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,47)
    <=> v35449(VarCurr,11) ) ).

tff(addAssignment_26671,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,23)
    <=> v6226(VarCurr,23) ) ).

tff(addAssignment_26670,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,23)
    <=> $false ) ).

tff(addAssignment_26669,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,23)
    <=> v6077(VarCurr,23) ) ).

tff(addAssignment_26668,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,23)
    <=> v6091(VarCurr,23) ) ).

tff(addAssignment_26667,axiom,
    ! [VarCurr: state_type] :
      ( v52559(VarCurr)
    <=> v52561(VarCurr) ) ).

tff(addAssignment_26666,axiom,
    ! [VarCurr: state_type] :
      ( v52561(VarCurr)
    <=> v6017(VarCurr,15) ) ).

tff(addAssignment_26665,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,15)
    <=> v6019(VarCurr,15) ) ).

tff(addAssignment_26664,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,15)
    <=> v6021(VarCurr,15) ) ).

tff(addAssignment_26663,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,15)
    <=> v6023(VarCurr,15) ) ).

tff(addAssignment_26662,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,15)
    <=> v6025(VarCurr,15) ) ).

tff(addAssignment_26661,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,15)
    <=> v6027(VarCurr,15) ) ).

tff(addAssignment_26660,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,15)
    <=> v52434(VarCurr,15) ) ).

tff(addAssignment_26659,axiom,
    ! [VarCurr: state_type] :
      ( v52463(VarCurr,3)
    <=> v6031(VarCurr,15) ) ).

tff(addAssignment_26658,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,15)
    <=> v6033(VarCurr,15) ) ).

tff(addAssignment_26657,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,15)
    <=> v52591(VarNext,15) ) ).

tff(addCaseBooleanConditionEqualRanges1_619,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52592(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52591(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_619,axiom,
    ! [VarNext: state_type] :
      ( v52592(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52591(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52592(VarNext)
      <=> v52593(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52593(VarNext)
      <=> ( v52595(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52595(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26656,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,15)
    <=> v6057(VarCurr,15) ) ).

tff(addAssignment_26655,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,15)
    <=> v6059(VarCurr,15) ) ).

tff(addAssignment_26654,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,15)
    <=> v52564(VarCurr,3) ) ).

tff(addAssignment_26653,axiom,
    ! [VarCurr: state_type] :
      ( v52564(VarCurr,3)
    <=> v52566(VarCurr,3) ) ).

tff(addAssignment_26652,axiom,
    ! [VarCurr: state_type] :
      ( v52566(VarCurr,3)
    <=> v52583(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52583(VarCurr,B)
      <=> ( v52584(VarCurr,B)
          | v52587(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52587(VarCurr,B)
      <=> ( v52576(VarCurr,B)
          & v52588(VarCurr,B) ) ) ) ).

tff(addAssignment_26651,axiom,
    ! [VarCurr: state_type] :
      ( v52588(VarCurr,0)
    <=> v52589(VarCurr) ) ).

tff(addAssignment_26650,axiom,
    ! [VarCurr: state_type] :
      ( v52588(VarCurr,1)
    <=> v52589(VarCurr) ) ).

tff(addAssignment_26649,axiom,
    ! [VarCurr: state_type] :
      ( v52588(VarCurr,2)
    <=> v52589(VarCurr) ) ).

tff(addAssignment_26648,axiom,
    ! [VarCurr: state_type] :
      ( v52588(VarCurr,3)
    <=> v52589(VarCurr) ) ).

tff(addAssignment_26647,axiom,
    ! [VarCurr: state_type] :
      ( v52589(VarCurr)
    <=> v52580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52584(VarCurr,B)
      <=> ( v52568(VarCurr,B)
          & v52585(VarCurr,B) ) ) ) ).

tff(addAssignment_26646,axiom,
    ! [VarCurr: state_type] :
      ( v52585(VarCurr,0)
    <=> v52586(VarCurr) ) ).

tff(addAssignment_26645,axiom,
    ! [VarCurr: state_type] :
      ( v52585(VarCurr,1)
    <=> v52586(VarCurr) ) ).

tff(addAssignment_26644,axiom,
    ! [VarCurr: state_type] :
      ( v52585(VarCurr,2)
    <=> v52586(VarCurr) ) ).

tff(addAssignment_26643,axiom,
    ! [VarCurr: state_type] :
      ( v52585(VarCurr,3)
    <=> v52586(VarCurr) ) ).

tff(addAssignment_26642,axiom,
    ! [VarCurr: state_type] :
      ( v52586(VarCurr)
    <=> v52572(VarCurr) ) ).

tff(addAssignment_26641,axiom,
    ! [VarCurr: state_type] :
      ( v52580(VarCurr)
    <=> v52582(VarCurr) ) ).

tff(addAssignment_26640,axiom,
    ! [VarCurr: state_type] :
      ( v52582(VarCurr)
    <=> v52379(VarCurr,3) ) ).

tff(addAssignment_26639,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,3)
    <=> v52381(VarCurr,3) ) ).

tff(addAssignment_26638,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,3)
    <=> v52383(VarCurr,3) ) ).

tff(addAssignment_26637,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,3)
    <=> v52384(VarCurr,3) ) ).

tff(addAssignment_26636,axiom,
    ! [VarCurr: state_type] :
      ( v52576(VarCurr,3)
    <=> v52578(VarCurr,3) ) ).

tff(addAssignment_26635,axiom,
    ! [VarCurr: state_type] :
      ( v52578(VarCurr,3)
    <=> v6069(VarCurr,15) ) ).

tff(addAssignment_26634,axiom,
    ! [VarCurr: state_type] :
      ( v52572(VarCurr)
    <=> v52574(VarCurr) ) ).

tff(addAssignment_26633,axiom,
    ! [VarCurr: state_type] :
      ( v52574(VarCurr)
    <=> v52361(VarCurr,3) ) ).

tff(addAssignment_26632,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,3)
    <=> v52363(VarCurr,3) ) ).

tff(addAssignment_26631,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,3)
    <=> v52365(VarCurr,3) ) ).

tff(addAssignment_26630,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,3)
    <=> v52367(VarCurr,3) ) ).

tff(addAssignment_26629,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,3)
    <=> v52369(VarCurr,3) ) ).

tff(addAssignment_26628,axiom,
    ! [VarCurr: state_type] :
      ( v52568(VarCurr,3)
    <=> v52570(VarCurr,3) ) ).

tff(addAssignment_26627,axiom,
    ! [VarCurr: state_type] :
      ( v52570(VarCurr,3)
    <=> v6069(VarCurr,19) ) ).

tff(addAssignment_26626,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,19)
    <=> v6071(VarCurr,19) ) ).

tff(addAssignment_26625,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,19)
    <=> v6073(VarCurr,19) ) ).

tff(addAssignment_26624,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,19)
    <=> v52355(VarCurr,19) ) ).

tff(addAssignment_26623,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,19)
    <=> v6096(VarCurr,19) ) ).

tff(addAssignment_26622,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,19)
    <=> v6098(VarCurr,19) ) ).

tff(addAssignment_26621,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,19)
    <=> v6100(VarCurr,19) ) ).

tff(addAssignment_26620,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,19)
    <=> v6102(VarCurr,19) ) ).

tff(addAssignment_26619,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,19)
    <=> v6104(VarCurr,19) ) ).

tff(addAssignment_26618,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,19)
    <=> v6106(VarCurr,19) ) ).

tff(addAssignment_26617,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,19)
    <=> v52338(VarCurr,19) ) ).

tff(addAssignment_26616,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,19)
    <=> v52330(VarCurr,19) ) ).

tff(addAssignment_26615,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,19)
    <=> v52332(VarCurr,19) ) ).

tff(addAssignment_26614,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,19)
    <=> v52335(VarCurr,19) ) ).

tff(addAssignment_26613,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,37)
    <=> v33839(VarCurr,37) ) ).

tff(addAssignment_26612,axiom,
    ! [VarCurr: state_type] :
      ( v33839(VarCurr,37)
    <=> v33841(VarCurr,37) ) ).

tff(addAssignment_26611,axiom,
    ! [VarCurr: state_type] :
      ( v33841(VarCurr,37)
    <=> v14155(VarCurr,1) ) ).

tff(addAssignment_26610,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,19)
    <=> v6232(VarCurr,19) ) ).

tff(addAssignment_26609,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,19)
    <=> v6234(VarCurr,19) ) ).

tff(addAssignment_26608,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,19)
    <=> v52325(VarCurr,19) ) ).

tff(addAssignment_26607,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,43)
    <=> v6238(VarCurr,43) ) ).

tff(addAssignment_26606,axiom,
    ! [VarCurr: state_type] :
      ( v6238(VarCurr,43)
    <=> v6240(VarCurr,43) ) ).

tff(addAssignment_26605,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,43)
    <=> v35449(VarCurr,7) ) ).

tff(addAssignment_26604,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,19)
    <=> v6226(VarCurr,19) ) ).

tff(addAssignment_26603,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,19)
    <=> $false ) ).

tff(addAssignment_26602,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,19)
    <=> v6077(VarCurr,19) ) ).

tff(addAssignment_26601,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,19)
    <=> v6091(VarCurr,19) ) ).

tff(addAssignment_26600,axiom,
    ! [VarCurr: state_type] :
      ( v6003(VarCurr)
    <=> v6005(VarCurr) ) ).

tff(addAssignment_26599,axiom,
    ! [VarCurr: state_type] :
      ( v6005(VarCurr)
    <=> v6007(VarCurr) ) ).

tff(addAssignment_26598,axiom,
    ! [VarCurr: state_type] :
      ( v6007(VarCurr)
    <=> v6009(VarCurr) ) ).

tff(addAssignment_26597,axiom,
    ! [VarCurr: state_type] :
      ( v6009(VarCurr)
    <=> v6011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4887,axiom,
    ! [VarCurr: state_type] :
      ( v6011(VarCurr)
    <=> ( v52547(VarCurr)
      <~> v52507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4886,axiom,
    ! [VarCurr: state_type] :
      ( v52547(VarCurr)
    <=> ( v6013(VarCurr)
      <~> v52467(VarCurr) ) ) ).

tff(addAssignment_26596,axiom,
    ! [VarCurr: state_type] :
      ( v52507(VarCurr)
    <=> v52509(VarCurr) ) ).

tff(addAssignment_26595,axiom,
    ! [VarCurr: state_type] :
      ( v52509(VarCurr)
    <=> v6017(VarCurr,11) ) ).

tff(addAssignment_26594,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,11)
    <=> v6019(VarCurr,11) ) ).

tff(addAssignment_26593,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,11)
    <=> v6021(VarCurr,11) ) ).

tff(addAssignment_26592,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,11)
    <=> v6023(VarCurr,11) ) ).

tff(addAssignment_26591,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,11)
    <=> v6025(VarCurr,11) ) ).

tff(addAssignment_26590,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,11)
    <=> v6027(VarCurr,11) ) ).

tff(addAssignment_26589,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,11)
    <=> v52434(VarCurr,11) ) ).

tff(addAssignment_26588,axiom,
    ! [VarCurr: state_type] :
      ( v52464(VarCurr,3)
    <=> v6031(VarCurr,11) ) ).

tff(addAssignment_26587,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,11)
    <=> v6033(VarCurr,11) ) ).

tff(addAssignment_26586,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,11)
    <=> v52539(VarNext,11) ) ).

tff(addCaseBooleanConditionEqualRanges1_618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52540(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52539(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_618,axiom,
    ! [VarNext: state_type] :
      ( v52540(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52539(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52540(VarNext)
      <=> v52541(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52541(VarNext)
      <=> ( v52543(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52543(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26585,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,11)
    <=> v6057(VarCurr,11) ) ).

tff(addAssignment_26584,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,11)
    <=> v6059(VarCurr,11) ) ).

tff(addAssignment_26583,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,11)
    <=> v52512(VarCurr,3) ) ).

tff(addAssignment_26582,axiom,
    ! [VarCurr: state_type] :
      ( v52512(VarCurr,3)
    <=> v52514(VarCurr,3) ) ).

tff(addAssignment_26581,axiom,
    ! [VarCurr: state_type] :
      ( v52514(VarCurr,3)
    <=> v52531(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52531(VarCurr,B)
      <=> ( v52532(VarCurr,B)
          | v52535(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52535(VarCurr,B)
      <=> ( v52524(VarCurr,B)
          & v52536(VarCurr,B) ) ) ) ).

tff(addAssignment_26580,axiom,
    ! [VarCurr: state_type] :
      ( v52536(VarCurr,0)
    <=> v52537(VarCurr) ) ).

tff(addAssignment_26579,axiom,
    ! [VarCurr: state_type] :
      ( v52536(VarCurr,1)
    <=> v52537(VarCurr) ) ).

tff(addAssignment_26578,axiom,
    ! [VarCurr: state_type] :
      ( v52536(VarCurr,2)
    <=> v52537(VarCurr) ) ).

tff(addAssignment_26577,axiom,
    ! [VarCurr: state_type] :
      ( v52536(VarCurr,3)
    <=> v52537(VarCurr) ) ).

tff(addAssignment_26576,axiom,
    ! [VarCurr: state_type] :
      ( v52537(VarCurr)
    <=> v52528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52532(VarCurr,B)
      <=> ( v52516(VarCurr,B)
          & v52533(VarCurr,B) ) ) ) ).

tff(addAssignment_26575,axiom,
    ! [VarCurr: state_type] :
      ( v52533(VarCurr,0)
    <=> v52534(VarCurr) ) ).

tff(addAssignment_26574,axiom,
    ! [VarCurr: state_type] :
      ( v52533(VarCurr,1)
    <=> v52534(VarCurr) ) ).

tff(addAssignment_26573,axiom,
    ! [VarCurr: state_type] :
      ( v52533(VarCurr,2)
    <=> v52534(VarCurr) ) ).

tff(addAssignment_26572,axiom,
    ! [VarCurr: state_type] :
      ( v52533(VarCurr,3)
    <=> v52534(VarCurr) ) ).

tff(addAssignment_26571,axiom,
    ! [VarCurr: state_type] :
      ( v52534(VarCurr)
    <=> v52520(VarCurr) ) ).

tff(addAssignment_26570,axiom,
    ! [VarCurr: state_type] :
      ( v52528(VarCurr)
    <=> v52530(VarCurr) ) ).

tff(addAssignment_26569,axiom,
    ! [VarCurr: state_type] :
      ( v52530(VarCurr)
    <=> v52379(VarCurr,2) ) ).

tff(addAssignment_26568,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,2)
    <=> v52381(VarCurr,2) ) ).

tff(addAssignment_26567,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,2)
    <=> v52383(VarCurr,2) ) ).

tff(addAssignment_26566,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,2)
    <=> v52384(VarCurr,2) ) ).

tff(addAssignment_26565,axiom,
    ! [VarCurr: state_type] :
      ( v52524(VarCurr,3)
    <=> v52526(VarCurr,3) ) ).

tff(addAssignment_26564,axiom,
    ! [VarCurr: state_type] :
      ( v52526(VarCurr,3)
    <=> v6069(VarCurr,11) ) ).

tff(addAssignment_26563,axiom,
    ! [VarCurr: state_type] :
      ( v52520(VarCurr)
    <=> v52522(VarCurr) ) ).

tff(addAssignment_26562,axiom,
    ! [VarCurr: state_type] :
      ( v52522(VarCurr)
    <=> v52361(VarCurr,2) ) ).

tff(addAssignment_26561,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,2)
    <=> v52363(VarCurr,2) ) ).

tff(addAssignment_26560,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,2)
    <=> v52365(VarCurr,2) ) ).

tff(addAssignment_26559,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,2)
    <=> v52367(VarCurr,2) ) ).

tff(addAssignment_26558,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,2)
    <=> v52369(VarCurr,2) ) ).

tff(addAssignment_26557,axiom,
    ! [VarCurr: state_type] :
      ( v52516(VarCurr,3)
    <=> v52518(VarCurr,3) ) ).

tff(addAssignment_26556,axiom,
    ! [VarCurr: state_type] :
      ( v52518(VarCurr,3)
    <=> v6069(VarCurr,15) ) ).

tff(addAssignment_26555,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,15)
    <=> v6071(VarCurr,15) ) ).

tff(addAssignment_26554,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,15)
    <=> v6073(VarCurr,15) ) ).

tff(addAssignment_26553,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,15)
    <=> v52355(VarCurr,15) ) ).

tff(addAssignment_26552,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,15)
    <=> v6096(VarCurr,15) ) ).

tff(addAssignment_26551,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,15)
    <=> v6098(VarCurr,15) ) ).

tff(addAssignment_26550,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,15)
    <=> v6100(VarCurr,15) ) ).

tff(addAssignment_26549,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,15)
    <=> v6102(VarCurr,15) ) ).

tff(addAssignment_26548,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,15)
    <=> v6104(VarCurr,15) ) ).

tff(addAssignment_26547,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,15)
    <=> v6106(VarCurr,15) ) ).

tff(addAssignment_26546,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,15)
    <=> v52338(VarCurr,15) ) ).

tff(addAssignment_26545,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,15)
    <=> v52330(VarCurr,15) ) ).

tff(addAssignment_26544,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,15)
    <=> v52332(VarCurr,15) ) ).

tff(addAssignment_26543,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,15)
    <=> v52335(VarCurr,15) ) ).

tff(addAssignment_26542,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,27)
    <=> v33839(VarCurr,27) ) ).

tff(addAssignment_26541,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,15)
    <=> v6232(VarCurr,15) ) ).

tff(addAssignment_26540,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,15)
    <=> v6234(VarCurr,15) ) ).

tff(addAssignment_26539,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,15)
    <=> v52325(VarCurr,15) ) ).

tff(addAssignment_26538,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,33)
    <=> v6238(VarCurr,33) ) ).

tff(addAssignment_26537,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,15)
    <=> v6226(VarCurr,15) ) ).

tff(addAssignment_26536,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_26535,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,15)
    <=> v6077(VarCurr,15) ) ).

tff(addAssignment_26534,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,15)
    <=> v6091(VarCurr,15) ) ).

tff(addAssignment_26533,axiom,
    ! [VarCurr: state_type] :
      ( v52467(VarCurr)
    <=> v52469(VarCurr) ) ).

tff(addAssignment_26532,axiom,
    ! [VarCurr: state_type] :
      ( v52469(VarCurr)
    <=> v6017(VarCurr,7) ) ).

tff(addAssignment_26531,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,7)
    <=> v6019(VarCurr,7) ) ).

tff(addAssignment_26530,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,7)
    <=> v6021(VarCurr,7) ) ).

tff(addAssignment_26529,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,7)
    <=> v6023(VarCurr,7) ) ).

tff(addAssignment_26528,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,7)
    <=> v6025(VarCurr,7) ) ).

tff(addAssignment_26527,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,7)
    <=> v6027(VarCurr,7) ) ).

tff(addAssignment_26526,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,7)
    <=> v52434(VarCurr,7) ) ).

tff(addAssignment_26525,axiom,
    ! [VarCurr: state_type] :
      ( v52465(VarCurr,3)
    <=> v6031(VarCurr,7) ) ).

tff(addAssignment_26524,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,7)
    <=> v6033(VarCurr,7) ) ).

tff(addAssignment_26523,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,7)
    <=> v52499(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52500(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52499(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_617,axiom,
    ! [VarNext: state_type] :
      ( v52500(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52499(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52500(VarNext)
      <=> v52501(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52501(VarNext)
      <=> ( v52503(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52503(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26522,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,7)
    <=> v6057(VarCurr,7) ) ).

tff(addAssignment_26521,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,7)
    <=> v6059(VarCurr,7) ) ).

tff(addAssignment_26520,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,7)
    <=> v52472(VarCurr,3) ) ).

tff(addAssignment_26519,axiom,
    ! [VarCurr: state_type] :
      ( v52472(VarCurr,3)
    <=> v52474(VarCurr,3) ) ).

tff(addAssignment_26518,axiom,
    ! [VarCurr: state_type] :
      ( v52474(VarCurr,3)
    <=> v52491(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52491(VarCurr,B)
      <=> ( v52492(VarCurr,B)
          | v52495(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52495(VarCurr,B)
      <=> ( v52484(VarCurr,B)
          & v52496(VarCurr,B) ) ) ) ).

tff(addAssignment_26517,axiom,
    ! [VarCurr: state_type] :
      ( v52496(VarCurr,0)
    <=> v52497(VarCurr) ) ).

tff(addAssignment_26516,axiom,
    ! [VarCurr: state_type] :
      ( v52496(VarCurr,1)
    <=> v52497(VarCurr) ) ).

tff(addAssignment_26515,axiom,
    ! [VarCurr: state_type] :
      ( v52496(VarCurr,2)
    <=> v52497(VarCurr) ) ).

tff(addAssignment_26514,axiom,
    ! [VarCurr: state_type] :
      ( v52496(VarCurr,3)
    <=> v52497(VarCurr) ) ).

tff(addAssignment_26513,axiom,
    ! [VarCurr: state_type] :
      ( v52497(VarCurr)
    <=> v52488(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52492(VarCurr,B)
      <=> ( v52476(VarCurr,B)
          & v52493(VarCurr,B) ) ) ) ).

tff(addAssignment_26512,axiom,
    ! [VarCurr: state_type] :
      ( v52493(VarCurr,0)
    <=> v52494(VarCurr) ) ).

tff(addAssignment_26511,axiom,
    ! [VarCurr: state_type] :
      ( v52493(VarCurr,1)
    <=> v52494(VarCurr) ) ).

tff(addAssignment_26510,axiom,
    ! [VarCurr: state_type] :
      ( v52493(VarCurr,2)
    <=> v52494(VarCurr) ) ).

tff(addAssignment_26509,axiom,
    ! [VarCurr: state_type] :
      ( v52493(VarCurr,3)
    <=> v52494(VarCurr) ) ).

tff(addAssignment_26508,axiom,
    ! [VarCurr: state_type] :
      ( v52494(VarCurr)
    <=> v52480(VarCurr) ) ).

tff(addAssignment_26507,axiom,
    ! [VarCurr: state_type] :
      ( v52488(VarCurr)
    <=> v52490(VarCurr) ) ).

tff(addAssignment_26506,axiom,
    ! [VarCurr: state_type] :
      ( v52490(VarCurr)
    <=> v52379(VarCurr,1) ) ).

tff(addAssignment_26505,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,1)
    <=> v52381(VarCurr,1) ) ).

tff(addAssignment_26504,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,1)
    <=> v52383(VarCurr,1) ) ).

tff(addAssignment_26503,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,1)
    <=> v52384(VarCurr,1) ) ).

tff(addAssignment_26502,axiom,
    ! [VarCurr: state_type] :
      ( v52484(VarCurr,3)
    <=> v52486(VarCurr,3) ) ).

tff(addAssignment_26501,axiom,
    ! [VarCurr: state_type] :
      ( v52486(VarCurr,3)
    <=> v6069(VarCurr,7) ) ).

tff(addAssignment_26500,axiom,
    ! [VarCurr: state_type] :
      ( v52480(VarCurr)
    <=> v52482(VarCurr) ) ).

tff(addAssignment_26499,axiom,
    ! [VarCurr: state_type] :
      ( v52482(VarCurr)
    <=> v52361(VarCurr,1) ) ).

tff(addAssignment_26498,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,1)
    <=> v52363(VarCurr,1) ) ).

tff(addAssignment_26497,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,1)
    <=> v52365(VarCurr,1) ) ).

tff(addAssignment_26496,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,1)
    <=> v52367(VarCurr,1) ) ).

tff(addAssignment_26495,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,1)
    <=> v52369(VarCurr,1) ) ).

tff(addAssignment_26494,axiom,
    ! [VarCurr: state_type] :
      ( v52476(VarCurr,3)
    <=> v52478(VarCurr,3) ) ).

tff(addAssignment_26493,axiom,
    ! [VarCurr: state_type] :
      ( v52478(VarCurr,3)
    <=> v6069(VarCurr,11) ) ).

tff(addAssignment_26492,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,11)
    <=> v6071(VarCurr,11) ) ).

tff(addAssignment_26491,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,11)
    <=> v6073(VarCurr,11) ) ).

tff(addAssignment_26490,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,11)
    <=> v52355(VarCurr,11) ) ).

tff(addAssignment_26489,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,11)
    <=> v6096(VarCurr,11) ) ).

tff(addAssignment_26488,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,11)
    <=> v6098(VarCurr,11) ) ).

tff(addAssignment_26487,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,11)
    <=> v6100(VarCurr,11) ) ).

tff(addAssignment_26486,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,11)
    <=> v6102(VarCurr,11) ) ).

tff(addAssignment_26485,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,11)
    <=> v6104(VarCurr,11) ) ).

tff(addAssignment_26484,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,11)
    <=> v6106(VarCurr,11) ) ).

tff(addAssignment_26483,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,11)
    <=> v52338(VarCurr,11) ) ).

tff(addAssignment_26482,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,11)
    <=> v52330(VarCurr,11) ) ).

tff(addAssignment_26481,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,11)
    <=> v52332(VarCurr,11) ) ).

tff(addAssignment_26480,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,11)
    <=> v52335(VarCurr,11) ) ).

tff(addAssignment_26479,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,17)
    <=> v33839(VarCurr,17) ) ).

tff(addAssignment_26478,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,11)
    <=> v6232(VarCurr,11) ) ).

tff(addAssignment_26477,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,11)
    <=> v6234(VarCurr,11) ) ).

tff(addAssignment_26476,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,11)
    <=> v52325(VarCurr,11) ) ).

tff(addAssignment_26475,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,23)
    <=> v6238(VarCurr,23) ) ).

tff(addAssignment_26474,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,11)
    <=> v6226(VarCurr,11) ) ).

tff(addAssignment_26473,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,11)
    <=> $false ) ).

tff(addAssignment_26472,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,11)
    <=> v6077(VarCurr,11) ) ).

tff(addAssignment_26471,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,11)
    <=> v6091(VarCurr,11) ) ).

tff(addAssignment_26470,axiom,
    ! [VarCurr: state_type] :
      ( v6013(VarCurr)
    <=> v6015(VarCurr) ) ).

tff(addAssignment_26469,axiom,
    ! [VarCurr: state_type] :
      ( v6015(VarCurr)
    <=> v6017(VarCurr,3) ) ).

tff(addAssignment_26468,axiom,
    ! [VarCurr: state_type] :
      ( v6017(VarCurr,3)
    <=> v6019(VarCurr,3) ) ).

tff(addAssignment_26467,axiom,
    ! [VarCurr: state_type] :
      ( v6019(VarCurr,3)
    <=> v6021(VarCurr,3) ) ).

tff(addAssignment_26466,axiom,
    ! [VarCurr: state_type] :
      ( v6021(VarCurr,3)
    <=> v6023(VarCurr,3) ) ).

tff(addAssignment_26465,axiom,
    ! [VarCurr: state_type] :
      ( v6023(VarCurr,3)
    <=> v6025(VarCurr,3) ) ).

tff(addAssignment_26464,axiom,
    ! [VarCurr: state_type] :
      ( v6025(VarCurr,3)
    <=> v6027(VarCurr,3) ) ).

tff(addAssignment_26463,axiom,
    ! [VarCurr: state_type] :
      ( v6027(VarCurr,3)
    <=> v52434(VarCurr,3) ) ).

tff(addAssignment_26462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52434(VarCurr,B)
      <=> v6029(VarCurr,B) ) ) ).

tff(addAssignment_26461,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,7)
      <=> v52465(VarCurr,3) )
      & ( v52434(VarCurr,6)
      <=> v52465(VarCurr,2) )
      & ( v52434(VarCurr,5)
      <=> v52465(VarCurr,1) )
      & ( v52434(VarCurr,4)
      <=> v52465(VarCurr,0) ) ) ).

tff(addAssignment_26460,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,11)
      <=> v52464(VarCurr,3) )
      & ( v52434(VarCurr,10)
      <=> v52464(VarCurr,2) )
      & ( v52434(VarCurr,9)
      <=> v52464(VarCurr,1) )
      & ( v52434(VarCurr,8)
      <=> v52464(VarCurr,0) ) ) ).

tff(addAssignment_26459,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,15)
      <=> v52463(VarCurr,3) )
      & ( v52434(VarCurr,14)
      <=> v52463(VarCurr,2) )
      & ( v52434(VarCurr,13)
      <=> v52463(VarCurr,1) )
      & ( v52434(VarCurr,12)
      <=> v52463(VarCurr,0) ) ) ).

tff(addAssignment_26458,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,19)
      <=> v52462(VarCurr,3) )
      & ( v52434(VarCurr,18)
      <=> v52462(VarCurr,2) )
      & ( v52434(VarCurr,17)
      <=> v52462(VarCurr,1) )
      & ( v52434(VarCurr,16)
      <=> v52462(VarCurr,0) ) ) ).

tff(addAssignment_26457,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,23)
      <=> v52461(VarCurr,3) )
      & ( v52434(VarCurr,22)
      <=> v52461(VarCurr,2) )
      & ( v52434(VarCurr,21)
      <=> v52461(VarCurr,1) )
      & ( v52434(VarCurr,20)
      <=> v52461(VarCurr,0) ) ) ).

tff(addAssignment_26456,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,27)
      <=> v52460(VarCurr,3) )
      & ( v52434(VarCurr,26)
      <=> v52460(VarCurr,2) )
      & ( v52434(VarCurr,25)
      <=> v52460(VarCurr,1) )
      & ( v52434(VarCurr,24)
      <=> v52460(VarCurr,0) ) ) ).

tff(addAssignment_26455,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,31)
      <=> v52459(VarCurr,3) )
      & ( v52434(VarCurr,30)
      <=> v52459(VarCurr,2) )
      & ( v52434(VarCurr,29)
      <=> v52459(VarCurr,1) )
      & ( v52434(VarCurr,28)
      <=> v52459(VarCurr,0) ) ) ).

tff(addAssignment_26454,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,35)
      <=> v52458(VarCurr,3) )
      & ( v52434(VarCurr,34)
      <=> v52458(VarCurr,2) )
      & ( v52434(VarCurr,33)
      <=> v52458(VarCurr,1) )
      & ( v52434(VarCurr,32)
      <=> v52458(VarCurr,0) ) ) ).

tff(addAssignment_26453,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,39)
      <=> v52457(VarCurr,3) )
      & ( v52434(VarCurr,38)
      <=> v52457(VarCurr,2) )
      & ( v52434(VarCurr,37)
      <=> v52457(VarCurr,1) )
      & ( v52434(VarCurr,36)
      <=> v52457(VarCurr,0) ) ) ).

tff(addAssignment_26452,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,43)
      <=> v52456(VarCurr,3) )
      & ( v52434(VarCurr,42)
      <=> v52456(VarCurr,2) )
      & ( v52434(VarCurr,41)
      <=> v52456(VarCurr,1) )
      & ( v52434(VarCurr,40)
      <=> v52456(VarCurr,0) ) ) ).

tff(addAssignment_26451,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,47)
      <=> v52455(VarCurr,3) )
      & ( v52434(VarCurr,46)
      <=> v52455(VarCurr,2) )
      & ( v52434(VarCurr,45)
      <=> v52455(VarCurr,1) )
      & ( v52434(VarCurr,44)
      <=> v52455(VarCurr,0) ) ) ).

tff(addAssignment_26450,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,51)
      <=> v52454(VarCurr,3) )
      & ( v52434(VarCurr,50)
      <=> v52454(VarCurr,2) )
      & ( v52434(VarCurr,49)
      <=> v52454(VarCurr,1) )
      & ( v52434(VarCurr,48)
      <=> v52454(VarCurr,0) ) ) ).

tff(addAssignment_26449,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,55)
      <=> v52453(VarCurr,3) )
      & ( v52434(VarCurr,54)
      <=> v52453(VarCurr,2) )
      & ( v52434(VarCurr,53)
      <=> v52453(VarCurr,1) )
      & ( v52434(VarCurr,52)
      <=> v52453(VarCurr,0) ) ) ).

tff(addAssignment_26448,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,59)
      <=> v52452(VarCurr,3) )
      & ( v52434(VarCurr,58)
      <=> v52452(VarCurr,2) )
      & ( v52434(VarCurr,57)
      <=> v52452(VarCurr,1) )
      & ( v52434(VarCurr,56)
      <=> v52452(VarCurr,0) ) ) ).

tff(addAssignment_26447,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,63)
      <=> v52451(VarCurr,3) )
      & ( v52434(VarCurr,62)
      <=> v52451(VarCurr,2) )
      & ( v52434(VarCurr,61)
      <=> v52451(VarCurr,1) )
      & ( v52434(VarCurr,60)
      <=> v52451(VarCurr,0) ) ) ).

tff(addAssignment_26446,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,67)
      <=> v52450(VarCurr,3) )
      & ( v52434(VarCurr,66)
      <=> v52450(VarCurr,2) )
      & ( v52434(VarCurr,65)
      <=> v52450(VarCurr,1) )
      & ( v52434(VarCurr,64)
      <=> v52450(VarCurr,0) ) ) ).

tff(addAssignment_26445,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,71)
      <=> v52449(VarCurr,3) )
      & ( v52434(VarCurr,70)
      <=> v52449(VarCurr,2) )
      & ( v52434(VarCurr,69)
      <=> v52449(VarCurr,1) )
      & ( v52434(VarCurr,68)
      <=> v52449(VarCurr,0) ) ) ).

tff(addAssignment_26444,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,75)
      <=> v52448(VarCurr,3) )
      & ( v52434(VarCurr,74)
      <=> v52448(VarCurr,2) )
      & ( v52434(VarCurr,73)
      <=> v52448(VarCurr,1) )
      & ( v52434(VarCurr,72)
      <=> v52448(VarCurr,0) ) ) ).

tff(addAssignment_26443,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,79)
      <=> v52447(VarCurr,3) )
      & ( v52434(VarCurr,78)
      <=> v52447(VarCurr,2) )
      & ( v52434(VarCurr,77)
      <=> v52447(VarCurr,1) )
      & ( v52434(VarCurr,76)
      <=> v52447(VarCurr,0) ) ) ).

tff(addAssignment_26442,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,83)
      <=> v52446(VarCurr,3) )
      & ( v52434(VarCurr,82)
      <=> v52446(VarCurr,2) )
      & ( v52434(VarCurr,81)
      <=> v52446(VarCurr,1) )
      & ( v52434(VarCurr,80)
      <=> v52446(VarCurr,0) ) ) ).

tff(addAssignment_26441,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,87)
      <=> v52445(VarCurr,3) )
      & ( v52434(VarCurr,86)
      <=> v52445(VarCurr,2) )
      & ( v52434(VarCurr,85)
      <=> v52445(VarCurr,1) )
      & ( v52434(VarCurr,84)
      <=> v52445(VarCurr,0) ) ) ).

tff(addAssignment_26440,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,91)
      <=> v52444(VarCurr,3) )
      & ( v52434(VarCurr,90)
      <=> v52444(VarCurr,2) )
      & ( v52434(VarCurr,89)
      <=> v52444(VarCurr,1) )
      & ( v52434(VarCurr,88)
      <=> v52444(VarCurr,0) ) ) ).

tff(addAssignment_26439,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,95)
      <=> v52443(VarCurr,3) )
      & ( v52434(VarCurr,94)
      <=> v52443(VarCurr,2) )
      & ( v52434(VarCurr,93)
      <=> v52443(VarCurr,1) )
      & ( v52434(VarCurr,92)
      <=> v52443(VarCurr,0) ) ) ).

tff(addAssignment_26438,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,99)
      <=> v52442(VarCurr,3) )
      & ( v52434(VarCurr,98)
      <=> v52442(VarCurr,2) )
      & ( v52434(VarCurr,97)
      <=> v52442(VarCurr,1) )
      & ( v52434(VarCurr,96)
      <=> v52442(VarCurr,0) ) ) ).

tff(addAssignment_26437,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,103)
      <=> v52441(VarCurr,3) )
      & ( v52434(VarCurr,102)
      <=> v52441(VarCurr,2) )
      & ( v52434(VarCurr,101)
      <=> v52441(VarCurr,1) )
      & ( v52434(VarCurr,100)
      <=> v52441(VarCurr,0) ) ) ).

tff(addAssignment_26436,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,107)
      <=> v52440(VarCurr,3) )
      & ( v52434(VarCurr,106)
      <=> v52440(VarCurr,2) )
      & ( v52434(VarCurr,105)
      <=> v52440(VarCurr,1) )
      & ( v52434(VarCurr,104)
      <=> v52440(VarCurr,0) ) ) ).

tff(addAssignment_26435,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,111)
      <=> v52439(VarCurr,3) )
      & ( v52434(VarCurr,110)
      <=> v52439(VarCurr,2) )
      & ( v52434(VarCurr,109)
      <=> v52439(VarCurr,1) )
      & ( v52434(VarCurr,108)
      <=> v52439(VarCurr,0) ) ) ).

tff(addAssignment_26434,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,115)
      <=> v52438(VarCurr,3) )
      & ( v52434(VarCurr,114)
      <=> v52438(VarCurr,2) )
      & ( v52434(VarCurr,113)
      <=> v52438(VarCurr,1) )
      & ( v52434(VarCurr,112)
      <=> v52438(VarCurr,0) ) ) ).

tff(addAssignment_26433,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,119)
      <=> v52437(VarCurr,3) )
      & ( v52434(VarCurr,118)
      <=> v52437(VarCurr,2) )
      & ( v52434(VarCurr,117)
      <=> v52437(VarCurr,1) )
      & ( v52434(VarCurr,116)
      <=> v52437(VarCurr,0) ) ) ).

tff(addAssignment_26432,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,123)
      <=> v52436(VarCurr,3) )
      & ( v52434(VarCurr,122)
      <=> v52436(VarCurr,2) )
      & ( v52434(VarCurr,121)
      <=> v52436(VarCurr,1) )
      & ( v52434(VarCurr,120)
      <=> v52436(VarCurr,0) ) ) ).

tff(addAssignment_26431,axiom,
    ! [VarCurr: state_type] :
      ( ( v52434(VarCurr,127)
      <=> v52435(VarCurr,3) )
      & ( v52434(VarCurr,126)
      <=> v52435(VarCurr,2) )
      & ( v52434(VarCurr,125)
      <=> v52435(VarCurr,1) )
      & ( v52434(VarCurr,124)
      <=> v52435(VarCurr,0) ) ) ).

tff(addAssignment_26430,axiom,
    ! [VarCurr: state_type] :
      ( v6029(VarCurr,3)
    <=> v6031(VarCurr,3) ) ).

tff(addAssignment_26429,axiom,
    ! [VarCurr: state_type] :
      ( v6031(VarCurr,3)
    <=> v6033(VarCurr,3) ) ).

tff(addAssignment_26428,axiom,
    ! [VarNext: state_type] :
      ( v6033(VarNext,3)
    <=> v52417(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52418(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v52417(VarNext,B)
            <=> v6033(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_616,axiom,
    ! [VarNext: state_type] :
      ( v52418(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52417(VarNext,B)
          <=> v52428(VarNext,B) ) ) ) ).

tff(addAssignment_26427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52428(VarNext,B)
          <=> v52426(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52429(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52426(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_392,axiom,
    ! [VarCurr: state_type] :
      ( v52429(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52426(VarCurr,B)
          <=> v6055(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4881,axiom,
    ! [VarCurr: state_type] :
      ( v52429(VarCurr)
    <=> ( v52430(VarCurr)
        & v52431(VarCurr) ) ) ).

tff(writeUnaryOperator_2971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52431(VarCurr)
    <=> v6045(VarCurr) ) ).

tff(writeUnaryOperator_2970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52430(VarCurr)
    <=> v6035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52418(VarNext)
      <=> v52419(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52419(VarNext)
      <=> ( v52420(VarNext)
          & v52393(VarNext) ) ) ) ).

tff(writeUnaryOperator_2969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52420(VarNext)
      <=> v52422(VarNext) ) ) ).

tff(addAssignment_26426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52422(VarNext)
      <=> v52393(VarCurr) ) ) ).

tff(addAssignment_26425,axiom,
    ! [VarCurr: state_type] :
      ( v52393(VarCurr)
    <=> v52395(VarCurr) ) ).

tff(addAssignment_26424,axiom,
    ! [VarCurr: state_type] :
      ( v52395(VarCurr)
    <=> v52397(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4878,axiom,
    ! [VarCurr: state_type] :
      ( v52397(VarCurr)
    <=> ( v52415(VarCurr)
        | v52407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4877,axiom,
    ! [VarCurr: state_type] :
      ( v52415(VarCurr)
    <=> ( v52399(VarCurr)
        & v52405(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_229,axiom,
    ( v52405(constB0)
  <=> $true ) ).

tff(addAssignment_26423,axiom,
    ! [VarCurr: state_type] :
      ( v52407(VarCurr)
    <=> v52409(VarCurr) ) ).

tff(addAssignment_26422,axiom,
    ! [VarCurr: state_type] :
      ( v52409(VarCurr)
    <=> v52411(VarCurr) ) ).

tff(addAssignment_26421,axiom,
    ! [VarCurr: state_type] :
      ( v52411(VarCurr)
    <=> v52413(VarCurr) ) ).

tff(addAssignment_26420,axiom,
    ! [VarCurr: state_type] :
      ( v52413(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_26419,axiom,
    ! [VarCurr: state_type] :
      ( v52399(VarCurr)
    <=> v52401(VarCurr) ) ).

tff(addAssignment_26418,axiom,
    ! [VarCurr: state_type] :
      ( v52401(VarCurr)
    <=> v52403(VarCurr) ) ).

tff(addAssignment_26417,axiom,
    ! [VarCurr: state_type] :
      ( v52403(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_26416,axiom,
    ! [VarCurr: state_type] :
      ( v6055(VarCurr,3)
    <=> v6057(VarCurr,3) ) ).

tff(addAssignment_26415,axiom,
    ! [VarCurr: state_type] :
      ( v6057(VarCurr,3)
    <=> v6059(VarCurr,3) ) ).

tff(addAssignment_26414,axiom,
    ! [VarCurr: state_type] :
      ( v6059(VarCurr,3)
    <=> v6061(VarCurr,3) ) ).

tff(addAssignment_26413,axiom,
    ! [VarCurr: state_type] :
      ( v6061(VarCurr,3)
    <=> v6063(VarCurr,3) ) ).

tff(addAssignment_26412,axiom,
    ! [VarCurr: state_type] :
      ( v6063(VarCurr,3)
    <=> v52385(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52385(VarCurr,B)
      <=> ( v52386(VarCurr,B)
          | v52389(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52389(VarCurr,B)
      <=> ( v52371(VarCurr,B)
          & v52390(VarCurr,B) ) ) ) ).

tff(addAssignment_26411,axiom,
    ! [VarCurr: state_type] :
      ( v52390(VarCurr,0)
    <=> v52391(VarCurr) ) ).

tff(addAssignment_26410,axiom,
    ! [VarCurr: state_type] :
      ( v52390(VarCurr,1)
    <=> v52391(VarCurr) ) ).

tff(addAssignment_26409,axiom,
    ! [VarCurr: state_type] :
      ( v52390(VarCurr,2)
    <=> v52391(VarCurr) ) ).

tff(addAssignment_26408,axiom,
    ! [VarCurr: state_type] :
      ( v52390(VarCurr,3)
    <=> v52391(VarCurr) ) ).

tff(addAssignment_26407,axiom,
    ! [VarCurr: state_type] :
      ( v52391(VarCurr)
    <=> v52375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v52386(VarCurr,B)
      <=> ( v6065(VarCurr,B)
          & v52387(VarCurr,B) ) ) ) ).

tff(addAssignment_26406,axiom,
    ! [VarCurr: state_type] :
      ( v52387(VarCurr,0)
    <=> v52388(VarCurr) ) ).

tff(addAssignment_26405,axiom,
    ! [VarCurr: state_type] :
      ( v52387(VarCurr,1)
    <=> v52388(VarCurr) ) ).

tff(addAssignment_26404,axiom,
    ! [VarCurr: state_type] :
      ( v52387(VarCurr,2)
    <=> v52388(VarCurr) ) ).

tff(addAssignment_26403,axiom,
    ! [VarCurr: state_type] :
      ( v52387(VarCurr,3)
    <=> v52388(VarCurr) ) ).

tff(addAssignment_26402,axiom,
    ! [VarCurr: state_type] :
      ( v52388(VarCurr)
    <=> v52357(VarCurr) ) ).

tff(addAssignment_26401,axiom,
    ! [VarCurr: state_type] :
      ( v52375(VarCurr)
    <=> v52377(VarCurr) ) ).

tff(addAssignment_26400,axiom,
    ! [VarCurr: state_type] :
      ( v52377(VarCurr)
    <=> v52379(VarCurr,0) ) ).

tff(addAssignment_26399,axiom,
    ! [VarCurr: state_type] :
      ( v52379(VarCurr,0)
    <=> v52381(VarCurr,0) ) ).

tff(addAssignment_26398,axiom,
    ! [VarCurr: state_type] :
      ( v52381(VarCurr,0)
    <=> v52383(VarCurr,0) ) ).

tff(addAssignment_26397,axiom,
    ! [VarCurr: state_type] :
      ( v52383(VarCurr,0)
    <=> v52384(VarCurr,0) ) ).

tff(writeUnaryOperator_2968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,35)
        & ~ $less(B,0) )
     => ( v52384(VarCurr,B)
      <=> ~ v52365(VarCurr,B) ) ) ).

tff(addAssignment_26396,axiom,
    ! [VarCurr: state_type] :
      ( v52371(VarCurr,3)
    <=> v52373(VarCurr,3) ) ).

tff(addAssignment_26395,axiom,
    ! [VarCurr: state_type] :
      ( v52373(VarCurr,3)
    <=> v6069(VarCurr,3) ) ).

tff(addAssignment_26394,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,3)
    <=> v6071(VarCurr,3) ) ).

tff(addAssignment_26393,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,3)
    <=> v6073(VarCurr,3) ) ).

tff(addAssignment_26392,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,3)
    <=> v52355(VarCurr,3) ) ).

tff(addAssignment_26391,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,3)
    <=> v6096(VarCurr,3) ) ).

tff(addAssignment_26390,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,3)
    <=> v6098(VarCurr,3) ) ).

tff(addAssignment_26389,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,3)
    <=> v6100(VarCurr,3) ) ).

tff(addAssignment_26388,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,3)
    <=> v6102(VarCurr,3) ) ).

tff(addAssignment_26387,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,3)
    <=> v6104(VarCurr,3) ) ).

tff(addAssignment_26386,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,3)
    <=> v6106(VarCurr,3) ) ).

tff(addAssignment_26385,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,3)
    <=> v52338(VarCurr,3) ) ).

tff(addAssignment_26384,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,3)
    <=> v52330(VarCurr,3) ) ).

tff(addAssignment_26383,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,3)
    <=> v52332(VarCurr,3) ) ).

tff(addAssignment_26382,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,3)
    <=> v52335(VarCurr,3) ) ).

tff(addAssignment_26381,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,3)
    <=> v33839(VarCurr,3) ) ).

tff(addAssignment_26380,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,3)
    <=> v6232(VarCurr,3) ) ).

tff(addAssignment_26379,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,3)
    <=> v6234(VarCurr,3) ) ).

tff(addAssignment_26378,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,3)
    <=> v52325(VarCurr,3) ) ).

tff(addAssignment_26377,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,9)
    <=> v6238(VarCurr,9) ) ).

tff(addAssignment_26376,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,3)
    <=> v6226(VarCurr,3) ) ).

tff(addAssignment_26375,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_26374,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,3)
    <=> v6077(VarCurr,3) ) ).

tff(addAssignment_26373,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,3)
    <=> v6091(VarCurr,3) ) ).

tff(addAssignment_26372,axiom,
    ! [VarCurr: state_type] :
      ( v52357(VarCurr)
    <=> v52359(VarCurr) ) ).

tff(addAssignment_26371,axiom,
    ! [VarCurr: state_type] :
      ( v52359(VarCurr)
    <=> v52361(VarCurr,0) ) ).

tff(addAssignment_26370,axiom,
    ! [VarCurr: state_type] :
      ( v52361(VarCurr,0)
    <=> v52363(VarCurr,0) ) ).

tff(addAssignment_26369,axiom,
    ! [VarCurr: state_type] :
      ( v52363(VarCurr,0)
    <=> v52365(VarCurr,0) ) ).

tff(addAssignment_26368,axiom,
    ! [VarCurr: state_type] :
      ( v52365(VarCurr,0)
    <=> v52367(VarCurr,0) ) ).

tff(addAssignment_26367,axiom,
    ! [VarCurr: state_type] :
      ( v52367(VarCurr,0)
    <=> v52369(VarCurr,0) ) ).

tff(addAssignment_26366,axiom,
    ! [VarCurr: state_type] :
      ( v6065(VarCurr,3)
    <=> v6067(VarCurr,3) ) ).

tff(addAssignment_26365,axiom,
    ! [VarCurr: state_type] :
      ( v6067(VarCurr,3)
    <=> v6069(VarCurr,7) ) ).

tff(addAssignment_26364,axiom,
    ! [VarCurr: state_type] :
      ( v6069(VarCurr,7)
    <=> v6071(VarCurr,7) ) ).

tff(addAssignment_26363,axiom,
    ! [VarCurr: state_type] :
      ( v6071(VarCurr,7)
    <=> v6073(VarCurr,7) ) ).

tff(addAssignment_26362,axiom,
    ! [VarCurr: state_type] :
      ( v6073(VarCurr,7)
    <=> v52355(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v52355(VarCurr,B)
      <=> ( v6075(VarCurr,B)
          & v6094(VarCurr,B) ) ) ) ).

tff(addAssignment_26361,axiom,
    ! [VarCurr: state_type] :
      ( v6094(VarCurr,7)
    <=> v6096(VarCurr,7) ) ).

tff(addAssignment_26360,axiom,
    ! [VarCurr: state_type] :
      ( v6096(VarCurr,7)
    <=> v6098(VarCurr,7) ) ).

tff(addAssignment_26359,axiom,
    ! [VarCurr: state_type] :
      ( v6098(VarCurr,7)
    <=> v6100(VarCurr,7) ) ).

tff(addAssignment_26358,axiom,
    ! [VarCurr: state_type] :
      ( v6100(VarCurr,7)
    <=> v6102(VarCurr,7) ) ).

tff(addAssignment_26357,axiom,
    ! [VarCurr: state_type] :
      ( v6102(VarCurr,7)
    <=> v6104(VarCurr,7) ) ).

tff(addAssignment_26356,axiom,
    ! [VarCurr: state_type] :
      ( v6104(VarCurr,7)
    <=> v6106(VarCurr,7) ) ).

tff(addAssignment_26355,axiom,
    ! [VarCurr: state_type] :
      ( v6106(VarCurr,7)
    <=> v52338(VarCurr,7) ) ).

tff(addParallelCaseBooleanConditionEqualRanges4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v52339(VarCurr)
        & ~ v52344(VarCurr)
        & ~ v52348(VarCurr)
        & ~ v52351(VarCurr) )
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52338(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges3,axiom,
    ! [VarCurr: state_type] :
      ( v52351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52338(VarCurr,B)
          <=> $true ) ) ) ).

tff(bitBlastConstant_1001,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(63) ).

tff(bitBlastConstant_1000,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(62) ).

tff(bitBlastConstant_999,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(61) ).

tff(bitBlastConstant_998,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(60) ).

tff(bitBlastConstant_997,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(59) ).

tff(bitBlastConstant_996,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(58) ).

tff(bitBlastConstant_995,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(57) ).

tff(bitBlastConstant_994,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(56) ).

tff(bitBlastConstant_993,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(55) ).

tff(bitBlastConstant_992,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(54) ).

tff(bitBlastConstant_991,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(53) ).

tff(bitBlastConstant_990,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(52) ).

tff(bitBlastConstant_989,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(51) ).

tff(bitBlastConstant_988,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(50) ).

tff(bitBlastConstant_987,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(49) ).

tff(bitBlastConstant_986,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(48) ).

tff(bitBlastConstant_985,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(47) ).

tff(bitBlastConstant_984,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(46) ).

tff(bitBlastConstant_983,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(45) ).

tff(bitBlastConstant_982,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(44) ).

tff(bitBlastConstant_981,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(43) ).

tff(bitBlastConstant_980,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(42) ).

tff(bitBlastConstant_979,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(41) ).

tff(bitBlastConstant_978,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(40) ).

tff(bitBlastConstant_977,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(39) ).

tff(bitBlastConstant_976,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(38) ).

tff(bitBlastConstant_975,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(37) ).

tff(bitBlastConstant_974,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(36) ).

tff(bitBlastConstant_973,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(35) ).

tff(bitBlastConstant_972,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(34) ).

tff(bitBlastConstant_971,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(33) ).

tff(bitBlastConstant_970,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(32) ).

tff(bitBlastConstant_969,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(31) ).

tff(bitBlastConstant_968,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(30) ).

tff(bitBlastConstant_967,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(29) ).

tff(bitBlastConstant_966,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(28) ).

tff(bitBlastConstant_965,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(27) ).

tff(bitBlastConstant_964,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(26) ).

tff(bitBlastConstant_963,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(25) ).

tff(bitBlastConstant_962,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(24) ).

tff(bitBlastConstant_961,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(23) ).

tff(bitBlastConstant_960,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(22) ).

tff(bitBlastConstant_959,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(21) ).

tff(bitBlastConstant_958,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(20) ).

tff(bitBlastConstant_957,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(19) ).

tff(bitBlastConstant_956,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(18) ).

tff(bitBlastConstant_955,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(17) ).

tff(bitBlastConstant_954,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(16) ).

tff(bitBlastConstant_953,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(15) ).

tff(bitBlastConstant_952,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(14) ).

tff(bitBlastConstant_951,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(13) ).

tff(bitBlastConstant_950,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(12) ).

tff(bitBlastConstant_949,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(11) ).

tff(bitBlastConstant_948,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(10) ).

tff(bitBlastConstant_947,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(9) ).

tff(bitBlastConstant_946,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(8) ).

tff(bitBlastConstant_945,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(7) ).

tff(bitBlastConstant_944,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(6) ).

tff(bitBlastConstant_943,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(5) ).

tff(bitBlastConstant_942,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(4) ).

tff(bitBlastConstant_941,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(3) ).

tff(bitBlastConstant_940,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(2) ).

tff(bitBlastConstant_939,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(1) ).

tff(bitBlastConstant_938,axiom,
    b1111111111111111111111111111111111111111111111111111111111111111(0) ).

tff(addParallelCaseBooleanConditionEqualRanges2,axiom,
    ! [VarCurr: state_type] :
      ( v52348(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52338(VarCurr,B)
          <=> v52328(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_7,axiom,
    ! [VarCurr: state_type] :
      ( v52344(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52338(VarCurr,B)
          <=> v6230(VarCurr,B) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_7,axiom,
    ! [VarCurr: state_type] :
      ( v52339(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v52338(VarCurr,B)
          <=> v6224(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4876,axiom,
    ! [VarCurr: state_type] :
      ( v52351(VarCurr)
    <=> ( v52353(VarCurr)
        & v52354(VarCurr) ) ) ).

tff(writeUnaryOperator_2967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52354(VarCurr)
    <=> v6108(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4875,axiom,
    ! [VarCurr: state_type] :
      ( v52353(VarCurr)
    <=> ( v52350(VarCurr)
        & v52343(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_571,axiom,
    ! [VarCurr: state_type] :
      ( v52348(VarCurr)
    <=> ( v52350(VarCurr)
        & v6108(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4874,axiom,
    ! [VarCurr: state_type] :
      ( v52350(VarCurr)
    <=> ( v52347(VarCurr)
        & v52342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4873,axiom,
    ! [VarCurr: state_type] :
      ( v52344(VarCurr)
    <=> ( v52346(VarCurr)
        & v52343(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_570,axiom,
    ! [VarCurr: state_type] :
      ( v52346(VarCurr)
    <=> ( v52347(VarCurr)
        & v6108(VarCurr,1) ) ) ).

tff(writeUnaryOperator_2966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52347(VarCurr)
    <=> v6108(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4872,axiom,
    ! [VarCurr: state_type] :
      ( v52339(VarCurr)
    <=> ( v52341(VarCurr)
        & v52343(VarCurr) ) ) ).

tff(writeUnaryOperator_2965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52343(VarCurr)
    <=> v6108(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4871,axiom,
    ! [VarCurr: state_type] :
      ( v52341(VarCurr)
    <=> ( v6108(VarCurr,0)
        & v52342(VarCurr) ) ) ).

tff(writeUnaryOperator_2964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52342(VarCurr)
    <=> v6108(VarCurr,1) ) ).

tff(addAssignment_26354,axiom,
    ! [VarCurr: state_type] :
      ( v52328(VarCurr,7)
    <=> v52330(VarCurr,7) ) ).

tff(addAssignment_26353,axiom,
    ! [VarCurr: state_type] :
      ( v52330(VarCurr,7)
    <=> v52332(VarCurr,7) ) ).

tff(addAssignment_26352,axiom,
    ! [VarCurr: state_type] :
      ( v52332(VarCurr,7)
    <=> v52335(VarCurr,7) ) ).

tff(addAssignment_26351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v52335(VarCurr,B)
      <=> v52334(VarCurr,B) ) ) ).

tff(addAssignment_26350,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,11)
      <=> v52334(VarCurr,17) )
      & ( v52335(VarCurr,10)
      <=> v52334(VarCurr,16) )
      & ( v52335(VarCurr,9)
      <=> v52334(VarCurr,15) )
      & ( v52335(VarCurr,8)
      <=> v52334(VarCurr,14) )
      & ( v52335(VarCurr,7)
      <=> v52334(VarCurr,13) )
      & ( v52335(VarCurr,6)
      <=> v52334(VarCurr,12) ) ) ).

tff(addAssignment_26349,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,17)
      <=> v52334(VarCurr,29) )
      & ( v52335(VarCurr,16)
      <=> v52334(VarCurr,28) )
      & ( v52335(VarCurr,15)
      <=> v52334(VarCurr,27) )
      & ( v52335(VarCurr,14)
      <=> v52334(VarCurr,26) )
      & ( v52335(VarCurr,13)
      <=> v52334(VarCurr,25) )
      & ( v52335(VarCurr,12)
      <=> v52334(VarCurr,24) ) ) ).

tff(addAssignment_26348,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,23)
      <=> v52334(VarCurr,41) )
      & ( v52335(VarCurr,22)
      <=> v52334(VarCurr,40) )
      & ( v52335(VarCurr,21)
      <=> v52334(VarCurr,39) )
      & ( v52335(VarCurr,20)
      <=> v52334(VarCurr,38) )
      & ( v52335(VarCurr,19)
      <=> v52334(VarCurr,37) )
      & ( v52335(VarCurr,18)
      <=> v52334(VarCurr,36) ) ) ).

tff(addAssignment_26347,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,29)
      <=> v52334(VarCurr,53) )
      & ( v52335(VarCurr,28)
      <=> v52334(VarCurr,52) )
      & ( v52335(VarCurr,27)
      <=> v52334(VarCurr,51) )
      & ( v52335(VarCurr,26)
      <=> v52334(VarCurr,50) )
      & ( v52335(VarCurr,25)
      <=> v52334(VarCurr,49) )
      & ( v52335(VarCurr,24)
      <=> v52334(VarCurr,48) ) ) ).

tff(addAssignment_26346,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,35)
      <=> v52334(VarCurr,65) )
      & ( v52335(VarCurr,34)
      <=> v52334(VarCurr,64) )
      & ( v52335(VarCurr,33)
      <=> v52334(VarCurr,63) )
      & ( v52335(VarCurr,32)
      <=> v52334(VarCurr,62) )
      & ( v52335(VarCurr,31)
      <=> v52334(VarCurr,61) )
      & ( v52335(VarCurr,30)
      <=> v52334(VarCurr,60) ) ) ).

tff(addAssignment_26345,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,41)
      <=> v52334(VarCurr,77) )
      & ( v52335(VarCurr,40)
      <=> v52334(VarCurr,76) )
      & ( v52335(VarCurr,39)
      <=> v52334(VarCurr,75) )
      & ( v52335(VarCurr,38)
      <=> v52334(VarCurr,74) )
      & ( v52335(VarCurr,37)
      <=> v52334(VarCurr,73) )
      & ( v52335(VarCurr,36)
      <=> v52334(VarCurr,72) ) ) ).

tff(addAssignment_26344,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,47)
      <=> v52334(VarCurr,89) )
      & ( v52335(VarCurr,46)
      <=> v52334(VarCurr,88) )
      & ( v52335(VarCurr,45)
      <=> v52334(VarCurr,87) )
      & ( v52335(VarCurr,44)
      <=> v52334(VarCurr,86) )
      & ( v52335(VarCurr,43)
      <=> v52334(VarCurr,85) )
      & ( v52335(VarCurr,42)
      <=> v52334(VarCurr,84) ) ) ).

tff(addAssignment_26343,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,53)
      <=> v52334(VarCurr,101) )
      & ( v52335(VarCurr,52)
      <=> v52334(VarCurr,100) )
      & ( v52335(VarCurr,51)
      <=> v52334(VarCurr,99) )
      & ( v52335(VarCurr,50)
      <=> v52334(VarCurr,98) )
      & ( v52335(VarCurr,49)
      <=> v52334(VarCurr,97) )
      & ( v52335(VarCurr,48)
      <=> v52334(VarCurr,96) ) ) ).

tff(addAssignment_26342,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,59)
      <=> v52334(VarCurr,113) )
      & ( v52335(VarCurr,58)
      <=> v52334(VarCurr,112) )
      & ( v52335(VarCurr,57)
      <=> v52334(VarCurr,111) )
      & ( v52335(VarCurr,56)
      <=> v52334(VarCurr,110) )
      & ( v52335(VarCurr,55)
      <=> v52334(VarCurr,109) )
      & ( v52335(VarCurr,54)
      <=> v52334(VarCurr,108) ) ) ).

tff(addAssignment_26341,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,65)
      <=> v52334(VarCurr,125) )
      & ( v52335(VarCurr,64)
      <=> v52334(VarCurr,124) )
      & ( v52335(VarCurr,63)
      <=> v52334(VarCurr,123) )
      & ( v52335(VarCurr,62)
      <=> v52334(VarCurr,122) )
      & ( v52335(VarCurr,61)
      <=> v52334(VarCurr,121) )
      & ( v52335(VarCurr,60)
      <=> v52334(VarCurr,120) ) ) ).

tff(addAssignment_26340,axiom,
    ! [VarCurr: state_type] :
      ( ( v52335(VarCurr,71)
      <=> v52334(VarCurr,137) )
      & ( v52335(VarCurr,70)
      <=> v52334(VarCurr,136) )
      & ( v52335(VarCurr,69)
      <=> v52334(VarCurr,135) )
      & ( v52335(VarCurr,68)
      <=> v52334(VarCurr,134) )
      & ( v52335(VarCurr,67)
      <=> v52334(VarCurr,133) )
      & ( v52335(VarCurr,66)
      <=> v52334(VarCurr,132) ) ) ).

tff(addAssignment_26339,axiom,
    ! [VarCurr: state_type] :
      ( v52334(VarCurr,13)
    <=> v33839(VarCurr,13) ) ).

tff(addAssignment_26338,axiom,
    ! [VarCurr: state_type] :
      ( v6230(VarCurr,7)
    <=> v6232(VarCurr,7) ) ).

tff(addAssignment_26337,axiom,
    ! [VarCurr: state_type] :
      ( v6232(VarCurr,7)
    <=> v6234(VarCurr,7) ) ).

tff(addAssignment_26336,axiom,
    ! [VarCurr: state_type] :
      ( v6234(VarCurr,7)
    <=> v52325(VarCurr,7) ) ).

tff(addAssignment_26335,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,5)
      <=> v6236(VarCurr,11) )
      & ( v52325(VarCurr,4)
      <=> v6236(VarCurr,10) )
      & ( v52325(VarCurr,3)
      <=> v6236(VarCurr,9) )
      & ( v52325(VarCurr,2)
      <=> v6236(VarCurr,8) )
      & ( v52325(VarCurr,1)
      <=> v6236(VarCurr,7) )
      & ( v52325(VarCurr,0)
      <=> v6236(VarCurr,6) ) ) ).

tff(addAssignment_26334,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,11)
      <=> v6236(VarCurr,23) )
      & ( v52325(VarCurr,10)
      <=> v6236(VarCurr,22) )
      & ( v52325(VarCurr,9)
      <=> v6236(VarCurr,21) )
      & ( v52325(VarCurr,8)
      <=> v6236(VarCurr,20) )
      & ( v52325(VarCurr,7)
      <=> v6236(VarCurr,19) )
      & ( v52325(VarCurr,6)
      <=> v6236(VarCurr,18) ) ) ).

tff(addAssignment_26333,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,17)
      <=> v6236(VarCurr,35) )
      & ( v52325(VarCurr,16)
      <=> v6236(VarCurr,34) )
      & ( v52325(VarCurr,15)
      <=> v6236(VarCurr,33) )
      & ( v52325(VarCurr,14)
      <=> v6236(VarCurr,32) )
      & ( v52325(VarCurr,13)
      <=> v6236(VarCurr,31) )
      & ( v52325(VarCurr,12)
      <=> v6236(VarCurr,30) ) ) ).

tff(addAssignment_26332,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,23)
      <=> v6236(VarCurr,47) )
      & ( v52325(VarCurr,22)
      <=> v6236(VarCurr,46) )
      & ( v52325(VarCurr,21)
      <=> v6236(VarCurr,45) )
      & ( v52325(VarCurr,20)
      <=> v6236(VarCurr,44) )
      & ( v52325(VarCurr,19)
      <=> v6236(VarCurr,43) )
      & ( v52325(VarCurr,18)
      <=> v6236(VarCurr,42) ) ) ).

tff(addAssignment_26331,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,29)
      <=> v6236(VarCurr,59) )
      & ( v52325(VarCurr,28)
      <=> v6236(VarCurr,58) )
      & ( v52325(VarCurr,27)
      <=> v6236(VarCurr,57) )
      & ( v52325(VarCurr,26)
      <=> v6236(VarCurr,56) )
      & ( v52325(VarCurr,25)
      <=> v6236(VarCurr,55) )
      & ( v52325(VarCurr,24)
      <=> v6236(VarCurr,54) ) ) ).

tff(addAssignment_26330,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,35)
      <=> v6236(VarCurr,71) )
      & ( v52325(VarCurr,34)
      <=> v6236(VarCurr,70) )
      & ( v52325(VarCurr,33)
      <=> v6236(VarCurr,69) )
      & ( v52325(VarCurr,32)
      <=> v6236(VarCurr,68) )
      & ( v52325(VarCurr,31)
      <=> v6236(VarCurr,67) )
      & ( v52325(VarCurr,30)
      <=> v6236(VarCurr,66) ) ) ).

tff(addAssignment_26329,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,41)
      <=> v6236(VarCurr,83) )
      & ( v52325(VarCurr,40)
      <=> v6236(VarCurr,82) )
      & ( v52325(VarCurr,39)
      <=> v6236(VarCurr,81) )
      & ( v52325(VarCurr,38)
      <=> v6236(VarCurr,80) )
      & ( v52325(VarCurr,37)
      <=> v6236(VarCurr,79) )
      & ( v52325(VarCurr,36)
      <=> v6236(VarCurr,78) ) ) ).

tff(addAssignment_26328,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,47)
      <=> v6236(VarCurr,95) )
      & ( v52325(VarCurr,46)
      <=> v6236(VarCurr,94) )
      & ( v52325(VarCurr,45)
      <=> v6236(VarCurr,93) )
      & ( v52325(VarCurr,44)
      <=> v6236(VarCurr,92) )
      & ( v52325(VarCurr,43)
      <=> v6236(VarCurr,91) )
      & ( v52325(VarCurr,42)
      <=> v6236(VarCurr,90) ) ) ).

tff(addAssignment_26327,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,53)
      <=> v6236(VarCurr,107) )
      & ( v52325(VarCurr,52)
      <=> v6236(VarCurr,106) )
      & ( v52325(VarCurr,51)
      <=> v6236(VarCurr,105) )
      & ( v52325(VarCurr,50)
      <=> v6236(VarCurr,104) )
      & ( v52325(VarCurr,49)
      <=> v6236(VarCurr,103) )
      & ( v52325(VarCurr,48)
      <=> v6236(VarCurr,102) ) ) ).

tff(addAssignment_26326,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,59)
      <=> v6236(VarCurr,119) )
      & ( v52325(VarCurr,58)
      <=> v6236(VarCurr,118) )
      & ( v52325(VarCurr,57)
      <=> v6236(VarCurr,117) )
      & ( v52325(VarCurr,56)
      <=> v6236(VarCurr,116) )
      & ( v52325(VarCurr,55)
      <=> v6236(VarCurr,115) )
      & ( v52325(VarCurr,54)
      <=> v6236(VarCurr,114) ) ) ).

tff(addAssignment_26325,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,65)
      <=> v6236(VarCurr,131) )
      & ( v52325(VarCurr,64)
      <=> v6236(VarCurr,130) )
      & ( v52325(VarCurr,63)
      <=> v6236(VarCurr,129) )
      & ( v52325(VarCurr,62)
      <=> v6236(VarCurr,128) )
      & ( v52325(VarCurr,61)
      <=> v6236(VarCurr,127) )
      & ( v52325(VarCurr,60)
      <=> v6236(VarCurr,126) ) ) ).

tff(addAssignment_26324,axiom,
    ! [VarCurr: state_type] :
      ( ( v52325(VarCurr,71)
      <=> v6236(VarCurr,143) )
      & ( v52325(VarCurr,70)
      <=> v6236(VarCurr,142) )
      & ( v52325(VarCurr,69)
      <=> v6236(VarCurr,141) )
      & ( v52325(VarCurr,68)
      <=> v6236(VarCurr,140) )
      & ( v52325(VarCurr,67)
      <=> v6236(VarCurr,139) )
      & ( v52325(VarCurr,66)
      <=> v6236(VarCurr,138) ) ) ).

tff(addAssignment_26323,axiom,
    ! [VarCurr: state_type] :
      ( v6236(VarCurr,19)
    <=> v6238(VarCurr,19) ) ).

tff(addAssignment_26322,axiom,
    ! [VarCurr: state_type] :
      ( v6240(VarCurr,19)
    <=> v6242(VarCurr,7) ) ).

tff(addAssignment_26321,axiom,
    ! [VarCurr: state_type] :
      ( v6244(VarCurr,7)
    <=> v6246(VarCurr,7) ) ).

tff(addAssignment_26320,axiom,
    ! [VarCurr: state_type] :
      ( v6246(VarCurr,7)
    <=> v8199(VarCurr,7) ) ).

tff(addAssignment_26319,axiom,
    ! [VarCurr: state_type] :
      ( v8049(VarCurr,7)
    <=> v8051(VarCurr,7) ) ).

tff(addAssignment_26318,axiom,
    ! [VarCurr: state_type] :
      ( v8051(VarCurr,7)
    <=> v8053(VarCurr,7) ) ).

tff(addAssignment_26317,axiom,
    ! [VarCurr: state_type] :
      ( v8053(VarCurr,7)
    <=> v8055(VarCurr,7) ) ).

tff(addAssignment_26316,axiom,
    ! [VarCurr: state_type] :
      ( v8055(VarCurr,7)
    <=> v8057(VarCurr,7) ) ).

tff(addAssignment_26315,axiom,
    ! [VarNext: state_type] :
      ( v8057(VarNext,7)
    <=> v52318(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52319(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52318(VarNext,B)
            <=> v8057(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_615,axiom,
    ! [VarNext: state_type] :
      ( v52319(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52318(VarNext,B)
          <=> v8162(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52319(VarNext)
      <=> v52320(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52320(VarNext)
      <=> ( v52322(VarNext)
          & v8083(VarNext) ) ) ) ).

tff(writeUnaryOperator_2963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52322(VarNext)
      <=> v8156(VarNext) ) ) ).

tff(addAssignment_26314,axiom,
    ! [VarCurr: state_type] :
      ( v8079(VarCurr,7)
    <=> v8081(VarCurr,7) ) ).

tff(addAssignment_26313,axiom,
    ! [VarCurr: state_type] :
      ( v8081(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_26312,axiom,
    ! [VarCurr: state_type] :
      ( v7898(VarCurr,7)
    <=> v7900(VarCurr,7) ) ).

tff(addAssignment_26311,axiom,
    ! [VarCurr: state_type] :
      ( v7900(VarCurr,7)
    <=> v7902(VarCurr,7) ) ).

tff(addAssignment_26310,axiom,
    ! [VarCurr: state_type] :
      ( v7902(VarCurr,7)
    <=> v7904(VarCurr,7) ) ).

tff(addAssignment_26309,axiom,
    ! [VarCurr: state_type] :
      ( v7904(VarCurr,7)
    <=> v7906(VarCurr,7) ) ).

tff(addAssignment_26308,axiom,
    ! [VarNext: state_type] :
      ( v7906(VarNext,7)
    <=> v52310(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52311(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52310(VarNext,B)
            <=> v7906(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_614,axiom,
    ! [VarNext: state_type] :
      ( v52311(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52310(VarNext,B)
          <=> v8011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52311(VarNext)
      <=> v52312(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52312(VarNext)
      <=> ( v52314(VarNext)
          & v7932(VarNext) ) ) ) ).

tff(writeUnaryOperator_2962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52314(VarNext)
      <=> v8005(VarNext) ) ) ).

tff(addAssignment_26307,axiom,
    ! [VarCurr: state_type] :
      ( v7928(VarCurr,7)
    <=> v7930(VarCurr,7) ) ).

tff(addAssignment_26306,axiom,
    ! [VarCurr: state_type] :
      ( v7930(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_26305,axiom,
    ! [VarCurr: state_type] :
      ( v7747(VarCurr,7)
    <=> v7749(VarCurr,7) ) ).

tff(addAssignment_26304,axiom,
    ! [VarCurr: state_type] :
      ( v7749(VarCurr,7)
    <=> v7751(VarCurr,7) ) ).

tff(addAssignment_26303,axiom,
    ! [VarCurr: state_type] :
      ( v7751(VarCurr,7)
    <=> v7753(VarCurr,7) ) ).

tff(addAssignment_26302,axiom,
    ! [VarCurr: state_type] :
      ( v7753(VarCurr,7)
    <=> v7755(VarCurr,7) ) ).

tff(addAssignment_26301,axiom,
    ! [VarNext: state_type] :
      ( v7755(VarNext,7)
    <=> v52302(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52303(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52302(VarNext,B)
            <=> v7755(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_613,axiom,
    ! [VarNext: state_type] :
      ( v52303(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52302(VarNext,B)
          <=> v7860(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52303(VarNext)
      <=> v52304(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52304(VarNext)
      <=> ( v52306(VarNext)
          & v7781(VarNext) ) ) ) ).

tff(writeUnaryOperator_2961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52306(VarNext)
      <=> v7854(VarNext) ) ) ).

tff(addAssignment_26300,axiom,
    ! [VarCurr: state_type] :
      ( v7777(VarCurr,7)
    <=> v7779(VarCurr,7) ) ).

tff(addAssignment_26299,axiom,
    ! [VarCurr: state_type] :
      ( v7779(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_26298,axiom,
    ! [VarCurr: state_type] :
      ( v7596(VarCurr,7)
    <=> v7598(VarCurr,7) ) ).

tff(addAssignment_26297,axiom,
    ! [VarCurr: state_type] :
      ( v7598(VarCurr,7)
    <=> v7600(VarCurr,7) ) ).

tff(addAssignment_26296,axiom,
    ! [VarCurr: state_type] :
      ( v7600(VarCurr,7)
    <=> v7602(VarCurr,7) ) ).

tff(addAssignment_26295,axiom,
    ! [VarCurr: state_type] :
      ( v7602(VarCurr,7)
    <=> v7604(VarCurr,7) ) ).

tff(addAssignment_26294,axiom,
    ! [VarNext: state_type] :
      ( v7604(VarNext,7)
    <=> v52294(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52295(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52294(VarNext,B)
            <=> v7604(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_612,axiom,
    ! [VarNext: state_type] :
      ( v52295(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52294(VarNext,B)
          <=> v7709(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52295(VarNext)
      <=> v52296(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52296(VarNext)
      <=> ( v52298(VarNext)
          & v7630(VarNext) ) ) ) ).

tff(writeUnaryOperator_2960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52298(VarNext)
      <=> v7703(VarNext) ) ) ).

tff(addAssignment_26293,axiom,
    ! [VarCurr: state_type] :
      ( v7626(VarCurr,7)
    <=> v7628(VarCurr,7) ) ).

tff(addAssignment_26292,axiom,
    ! [VarCurr: state_type] :
      ( v7628(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_26291,axiom,
    ! [VarCurr: state_type] :
      ( v7281(VarCurr,7)
    <=> v7283(VarCurr,7) ) ).

tff(addAssignment_26290,axiom,
    ! [VarCurr: state_type] :
      ( v7283(VarCurr,7)
    <=> v7285(VarCurr,7) ) ).

tff(addAssignment_26289,axiom,
    ! [VarCurr: state_type] :
      ( v7285(VarCurr,7)
    <=> v7287(VarCurr,7) ) ).

tff(addAssignment_26288,axiom,
    ! [VarCurr: state_type] :
      ( v7287(VarCurr,7)
    <=> v7289(VarCurr,7) ) ).

tff(addAssignment_26287,axiom,
    ! [VarNext: state_type] :
      ( v7289(VarNext,7)
    <=> v52286(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52287(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52286(VarNext,B)
            <=> v7289(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_611,axiom,
    ! [VarNext: state_type] :
      ( v52287(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52286(VarNext,B)
          <=> v7405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52287(VarNext)
      <=> v52288(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52288(VarNext)
      <=> ( v52290(VarNext)
          & v7315(VarNext) ) ) ) ).

tff(writeUnaryOperator_2959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52290(VarNext)
      <=> v7399(VarNext) ) ) ).

tff(addAssignment_26286,axiom,
    ! [VarCurr: state_type] :
      ( v7311(VarCurr,7)
    <=> v7313(VarCurr,7) ) ).

tff(addAssignment_26285,axiom,
    ! [VarCurr: state_type] :
      ( v7313(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_26284,axiom,
    ! [VarCurr: state_type] :
      ( v7141(VarCurr)
    <=> v7143(VarCurr) ) ).

tff(addAssignment_26283,axiom,
    ! [VarCurr: state_type] :
      ( v7143(VarCurr)
    <=> v7145(VarCurr) ) ).

tff(addAssignment_26282,axiom,
    ! [VarCurr: state_type] :
      ( v7145(VarCurr)
    <=> v7147(VarCurr) ) ).

tff(addAssignment_26281,axiom,
    ! [VarCurr: state_type] :
      ( v7147(VarCurr)
    <=> v7149(VarCurr) ) ).

tff(addAssignment_26280,axiom,
    ! [VarCurr: state_type] :
      ( v7149(VarCurr)
    <=> v7151(VarCurr) ) ).

tff(addAssignment_26279,axiom,
    ! [VarCurr: state_type] :
      ( v7151(VarCurr)
    <=> v7153(VarCurr) ) ).

tff(addAssignment_26278,axiom,
    ! [VarCurr: state_type] :
      ( v7153(VarCurr)
    <=> v7155(VarCurr) ) ).

tff(writeUnaryOperator_2958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7155(VarCurr)
    <=> v52283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4860,axiom,
    ! [VarCurr: state_type] :
      ( v52283(VarCurr)
    <=> ( v52284(VarCurr)
        | v52279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4859,axiom,
    ! [VarCurr: state_type] :
      ( v52284(VarCurr)
    <=> ( v7157(VarCurr)
        | v52275(VarCurr) ) ) ).

tff(addAssignment_26277,axiom,
    ! [VarCurr: state_type] :
      ( v52279(VarCurr)
    <=> v52281(VarCurr) ) ).

tff(addAssignment_26276,axiom,
    ! [VarCurr: state_type] :
      ( v52281(VarCurr)
    <=> v7161(VarCurr,2) ) ).

tff(addAssignment_26275,axiom,
    ! [VarCurr: state_type] :
      ( v52275(VarCurr)
    <=> v52277(VarCurr) ) ).

tff(addAssignment_26274,axiom,
    ! [VarCurr: state_type] :
      ( v52277(VarCurr)
    <=> v7161(VarCurr,1) ) ).

tff(addAssignment_26273,axiom,
    ! [VarCurr: state_type] :
      ( v7157(VarCurr)
    <=> v7159(VarCurr) ) ).

tff(addAssignment_26272,axiom,
    ! [VarCurr: state_type] :
      ( v7159(VarCurr)
    <=> v7161(VarCurr,0) ) ).

tff(addAssignment_26271,axiom,
    ! [VarCurr: state_type] :
      ( v7161(VarCurr,0)
    <=> v7069(VarCurr,3) ) ).

tff(addAssignment_26270,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,3)
    <=> v7071(VarCurr,3) ) ).

tff(addAssignment_26269,axiom,
    ! [VarNext: state_type] :
      ( v7071(VarNext,3)
    <=> v52267(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52268(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v52267(VarNext,B)
            <=> v7071(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_610,axiom,
    ! [VarNext: state_type] :
      ( v52268(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v52267(VarNext,B)
          <=> v7574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52268(VarNext)
      <=> v52269(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52269(VarNext)
      <=> ( v52271(VarNext)
          & v7516(VarNext) ) ) ) ).

tff(writeUnaryOperator_2957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52271(VarNext)
      <=> v7568(VarNext) ) ) ).

tff(addAssignment_26268,axiom,
    ! [VarCurr: state_type] :
      ( v7187(VarCurr,3)
    <=> v7189(VarCurr,3) ) ).

tff(addAssignment_26267,axiom,
    ! [VarCurr: state_type] :
      ( v7189(VarCurr,3)
    <=> v7513(VarCurr,3) ) ).

tff(addAssignment_26266,axiom,
    ! [VarCurr: state_type] :
      ( v7191(VarCurr,0)
    <=> v7193(VarCurr,0) ) ).

tff(addAssignment_26265,axiom,
    ! [VarCurr: state_type] :
      ( v7193(VarCurr,0)
    <=> v7195(VarCurr,0) ) ).

tff(addAssignment_26264,axiom,
    ! [VarCurr: state_type] :
      ( v7195(VarCurr,0)
    <=> v7512(VarCurr,0) ) ).

tff(addAssignment_26263,axiom,
    ! [VarCurr: state_type] :
      ( v7449(VarCurr,0)
    <=> v7451(VarCurr,0) ) ).

tff(addAssignment_26262,axiom,
    ! [VarCurr: state_type] :
      ( v7451(VarCurr,0)
    <=> v7453(VarCurr,0) ) ).

tff(addAssignment_26261,axiom,
    ! [VarCurr: state_type] :
      ( v7453(VarCurr,0)
    <=> v7455(VarCurr,0) ) ).

tff(addAssignment_26260,axiom,
    ! [VarCurr: state_type] :
      ( v7455(VarCurr,0)
    <=> v7457(VarCurr,0) ) ).

tff(addAssignment_26259,axiom,
    ! [VarCurr: state_type] :
      ( v7457(VarCurr,0)
    <=> v7467(VarCurr,0) ) ).

tff(addAssignment_26258,axiom,
    ! [VarCurr: state_type] :
      ( v7197(VarCurr,0)
    <=> v7199(VarCurr,0) ) ).

tff(addAssignment_26257,axiom,
    ! [VarCurr: state_type] :
      ( v7199(VarCurr,0)
    <=> v7446(VarCurr,0) ) ).

tff(addAssignment_26256,axiom,
    ! [VarCurr: state_type] :
      ( v7201(VarCurr)
    <=> v6302(VarCurr,2) ) ).

tff(addAssignment_26255,axiom,
    ! [VarCurr: state_type] :
      ( v6302(VarCurr,2)
    <=> v6304(VarCurr,2) ) ).

tff(addAssignment_26254,axiom,
    ! [VarCurr: state_type] :
      ( v6304(VarCurr,2)
    <=> v6314(VarCurr,2) ) ).

tff(addAssignment_26253,axiom,
    ! [VarCurr: state_type] :
      ( v6306(VarCurr,2)
    <=> v6308(VarCurr,2) ) ).

tff(addAssignment_26252,axiom,
    ! [VarCurr: state_type] :
      ( v6308(VarCurr,2)
    <=> v6311(VarCurr,2) ) ).

tff(addAssignment_26251,axiom,
    ! [VarCurr: state_type] :
      ( v6312(VarCurr)
    <=> v7204(VarCurr,1) ) ).

tff(addAssignment_26250,axiom,
    ! [VarCurr: state_type] :
      ( v7204(VarCurr,1)
    <=> v7206(VarCurr,1) ) ).

tff(addAssignment_26249,axiom,
    ! [VarCurr: state_type] :
      ( v7206(VarCurr,1)
    <=> v52265(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v52265(VarCurr,B)
      <=> ( v7208(VarCurr,B)
          | v7214(VarCurr,B) ) ) ) ).

tff(addAssignment_26248,axiom,
    ! [VarCurr: state_type] :
      ( v7214(VarCurr,1)
    <=> v7216(VarCurr,1) ) ).

tff(addAssignment_26247,axiom,
    ! [VarCurr: state_type] :
      ( v7216(VarCurr,1)
    <=> v52263(VarCurr,1) ) ).

tff(addAssignment_26246,axiom,
    ! [VarCurr: state_type] :
      ( v52263(VarCurr,0)
    <=> v52264(VarCurr) ) ).

tff(addAssignment_26245,axiom,
    ! [VarCurr: state_type] :
      ( v52263(VarCurr,1)
    <=> v7218(VarCurr) ) ).

tff(addAssignment_26244,axiom,
    ! [VarCurr: state_type] :
      ( v7218(VarCurr)
    <=> v7220(VarCurr,1) ) ).

tff(addAssignment_26243,axiom,
    ! [VarCurr: state_type] :
      ( v7220(VarCurr,1)
    <=> v7222(VarCurr,1) ) ).

tff(addAssignment_26242,axiom,
    ! [VarCurr: state_type] :
      ( v7222(VarCurr,1)
    <=> v52262(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v52262(VarCurr,B)
      <=> ( v7224(VarCurr,B)
          & v52258(VarCurr,B) ) ) ) ).

tff(addAssignment_26241,axiom,
    ! [VarCurr: state_type] :
      ( v52258(VarCurr,1)
    <=> v52260(VarCurr,1) ) ).

tff(addAssignment_26240,axiom,
    ! [VarCurr: state_type] :
      ( v52260(VarCurr,1)
    <=> v52261(VarCurr,1) ) ).

tff(addAssignment_26239,axiom,
    ! [VarCurr: state_type] :
      ( v52261(VarCurr,0)
    <=> v8103(VarCurr) ) ).

tff(addAssignment_26238,axiom,
    ! [VarCurr: state_type] :
      ( v52261(VarCurr,1)
    <=> v8179(VarCurr) ) ).

tff(addAssignment_26237,axiom,
    ! [VarCurr: state_type] :
      ( v7224(VarCurr,1)
    <=> v7226(VarCurr,1) ) ).

tff(addAssignment_26236,axiom,
    ! [VarCurr: state_type] :
      ( v7226(VarCurr,1)
    <=> v52255(VarCurr,1) ) ).

tff(addAssignment_26235,axiom,
    ! [VarCurr: state_type] :
      ( v52255(VarCurr,0)
    <=> v52256(VarCurr) ) ).

tff(addAssignment_26234,axiom,
    ! [VarCurr: state_type] :
      ( v52255(VarCurr,1)
    <=> v7228(VarCurr) ) ).

tff(addAssignment_26233,axiom,
    ! [VarCurr: state_type] :
      ( v7228(VarCurr)
    <=> v7230(VarCurr,1) ) ).

tff(addAssignment_26232,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,1)
    <=> v7232(VarCurr,1) ) ).

tff(addAssignment_26231,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,1)
    <=> v7234(VarCurr,1) ) ).

tff(addAssignment_26230,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,1)
    <=> v34455(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4856,axiom,
    ! [VarCurr: state_type] :
      ( v8288(VarCurr)
    <=> ( v8290(VarCurr)
        | v8310(VarCurr) ) ) ).

tff(addAssignment_26229,axiom,
    ! [VarCurr: state_type] :
      ( v8290(VarCurr)
    <=> v8292(VarCurr,1) ) ).

tff(addAssignment_26228,axiom,
    ! [VarCurr: state_type] :
      ( v8292(VarCurr,1)
    <=> v8294(VarCurr,1) ) ).

tff(addAssignment_26227,axiom,
    ! [VarNext: state_type] :
      ( v8294(VarNext,1)
    <=> v52247(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52248(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v52247(VarNext,B)
            <=> v8294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_609,axiom,
    ! [VarNext: state_type] :
      ( v52248(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v52247(VarNext,B)
          <=> v34448(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52248(VarNext)
      <=> v52249(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52249(VarNext)
      <=> ( v52251(VarNext)
          & v34433(VarNext) ) ) ) ).

tff(writeUnaryOperator_2956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52251(VarNext)
      <=> v34442(VarNext) ) ) ).

tff(addAssignment_26226,axiom,
    ! [VarCurr: state_type] :
      ( v8304(VarCurr,1)
    <=> v8306(VarCurr,1) ) ).

tff(addAssignment_26225,axiom,
    ! [VarCurr: state_type] :
      ( v8306(VarCurr,1)
    <=> v8308(VarCurr,1) ) ).

tff(addAssignment_26224,axiom,
    ! [VarCurr: state_type] :
      ( v8308(VarCurr,1)
    <=> v34431(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4853,axiom,
    ! [VarCurr: state_type] :
      ( v8310(VarCurr)
    <=> ( v52223(VarCurr)
        & v52227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4852,axiom,
    ! [VarCurr: state_type] :
      ( v52227(VarCurr)
    <=> ( v52228(VarCurr)
        | v8290(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4851,axiom,
    ! [VarCurr: state_type] :
      ( v52228(VarCurr)
    <=> ( v52229(VarCurr)
        | v52243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4850,axiom,
    ! [VarCurr: state_type] :
      ( v52243(VarCurr)
    <=> ( v52194(VarCurr)
        & v52244(VarCurr) ) ) ).

tff(writeUnaryOperator_2955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52244(VarCurr)
    <=> v52245(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_569,axiom,
    ! [VarCurr: state_type] :
      ( v52245(VarCurr)
    <=> ( v34427(VarCurr)
        | v30943(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_568,axiom,
    ! [VarCurr: state_type] :
      ( v52229(VarCurr)
    <=> ( v52231(VarCurr)
        & v7236(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_567,axiom,
    ! [VarCurr: state_type] :
      ( v52231(VarCurr)
    <=> ( v52232(VarCurr)
        & v7236(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_566,axiom,
    ! [VarCurr: state_type] :
      ( v52232(VarCurr)
    <=> ( v52233(VarCurr)
        & v7236(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_565,axiom,
    ! [VarCurr: state_type] :
      ( v52233(VarCurr)
    <=> ( v52234(VarCurr)
        & v7236(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_564,axiom,
    ! [VarCurr: state_type] :
      ( v52234(VarCurr)
    <=> ( v52235(VarCurr)
        & v7236(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_563,axiom,
    ! [VarCurr: state_type] :
      ( v52235(VarCurr)
    <=> ( v52236(VarCurr)
        & v7236(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_562,axiom,
    ! [VarCurr: state_type] :
      ( v52236(VarCurr)
    <=> ( v52237(VarCurr)
        & v7236(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_561,axiom,
    ! [VarCurr: state_type] :
      ( v52237(VarCurr)
    <=> ( v52238(VarCurr)
        & v7236(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_560,axiom,
    ! [VarCurr: state_type] :
      ( v52238(VarCurr)
    <=> ( v52239(VarCurr)
        & v7236(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_559,axiom,
    ! [VarCurr: state_type] :
      ( v52239(VarCurr)
    <=> ( v52240(VarCurr)
        & v7236(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_558,axiom,
    ! [VarCurr: state_type] :
      ( v52240(VarCurr)
    <=> ( v52241(VarCurr)
        & v7236(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_557,axiom,
    ! [VarCurr: state_type] :
      ( v52241(VarCurr)
    <=> ( v52242(VarCurr)
        & v7236(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_556,axiom,
    ! [VarCurr: state_type] :
      ( v52242(VarCurr)
    <=> ( v7236(VarCurr,0)
        & v7236(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_555,axiom,
    ! [VarCurr: state_type] :
      ( v52223(VarCurr)
    <=> ( v52224(VarCurr)
        | v8422(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4849,axiom,
    ! [VarCurr: state_type] :
      ( v52224(VarCurr)
    <=> ( v52225(VarCurr)
        | v8312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4848,axiom,
    ! [VarCurr: state_type] :
      ( v52225(VarCurr)
    <=> ( v52226(VarCurr)
        | v5037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_554,axiom,
    ! [VarCurr: state_type] :
      ( v52226(VarCurr)
    <=> ( v34406(VarCurr)
        | v4201(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4847,axiom,
    ! [VarCurr: state_type] :
      ( v52194(VarCurr)
    <=> ( v52196(VarCurr)
        | v52221(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_230,axiom,
    ! [VarCurr: state_type] :
      ( v52221(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $false )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4846,axiom,
    ! [VarCurr: state_type] :
      ( v52196(VarCurr)
    <=> ( v52197(VarCurr)
        | v52220(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_229,axiom,
    ! [VarCurr: state_type] :
      ( v52220(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $false )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4845,axiom,
    ! [VarCurr: state_type] :
      ( v52197(VarCurr)
    <=> ( v52198(VarCurr)
        | v52219(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_228,axiom,
    ! [VarCurr: state_type] :
      ( v52219(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $false )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4844,axiom,
    ! [VarCurr: state_type] :
      ( v52198(VarCurr)
    <=> ( v52199(VarCurr)
        | v52218(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_227,axiom,
    ! [VarCurr: state_type] :
      ( v52218(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $false )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4843,axiom,
    ! [VarCurr: state_type] :
      ( v52199(VarCurr)
    <=> ( v52200(VarCurr)
        | v52217(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_226,axiom,
    ! [VarCurr: state_type] :
      ( v52217(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $false )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4842,axiom,
    ! [VarCurr: state_type] :
      ( v52200(VarCurr)
    <=> ( v52201(VarCurr)
        | v52216(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_225,axiom,
    ! [VarCurr: state_type] :
      ( v52216(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $false )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4841,axiom,
    ! [VarCurr: state_type] :
      ( v52201(VarCurr)
    <=> ( v52202(VarCurr)
        | v52215(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_224,axiom,
    ! [VarCurr: state_type] :
      ( v52215(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $false )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4840,axiom,
    ! [VarCurr: state_type] :
      ( v52202(VarCurr)
    <=> ( v52203(VarCurr)
        | v52214(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_223,axiom,
    ! [VarCurr: state_type] :
      ( v52214(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $false )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4839,axiom,
    ! [VarCurr: state_type] :
      ( v52203(VarCurr)
    <=> ( v52204(VarCurr)
        | v52213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_222,axiom,
    ! [VarCurr: state_type] :
      ( v52213(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $false )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4838,axiom,
    ! [VarCurr: state_type] :
      ( v52204(VarCurr)
    <=> ( v52205(VarCurr)
        | v52212(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_221,axiom,
    ! [VarCurr: state_type] :
      ( v52212(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $false )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4837,axiom,
    ! [VarCurr: state_type] :
      ( v52205(VarCurr)
    <=> ( v52206(VarCurr)
        | v52211(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_220,axiom,
    ! [VarCurr: state_type] :
      ( v52211(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $false )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4836,axiom,
    ! [VarCurr: state_type] :
      ( v52206(VarCurr)
    <=> ( v52207(VarCurr)
        | v52210(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_219,axiom,
    ! [VarCurr: state_type] :
      ( v52210(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $false )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4835,axiom,
    ! [VarCurr: state_type] :
      ( v52207(VarCurr)
    <=> ( v52208(VarCurr)
        | v52209(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_218,axiom,
    ! [VarCurr: state_type] :
      ( v52209(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $false )
        & ( v7236(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_217,axiom,
    ! [VarCurr: state_type] :
      ( v52208(VarCurr)
    <=> ( ( v7236(VarCurr,13)
        <=> $true )
        & ( v7236(VarCurr,12)
        <=> $true )
        & ( v7236(VarCurr,11)
        <=> $true )
        & ( v7236(VarCurr,10)
        <=> $true )
        & ( v7236(VarCurr,9)
        <=> $true )
        & ( v7236(VarCurr,8)
        <=> $true )
        & ( v7236(VarCurr,7)
        <=> $true )
        & ( v7236(VarCurr,6)
        <=> $true )
        & ( v7236(VarCurr,5)
        <=> $true )
        & ( v7236(VarCurr,4)
        <=> $true )
        & ( v7236(VarCurr,3)
        <=> $true )
        & ( v7236(VarCurr,2)
        <=> $true )
        & ( v7236(VarCurr,1)
        <=> $true )
        & ( v7236(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_26223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,2) )
     => ( v7236(VarCurr,B)
      <=> v7238(VarCurr,B) ) ) ).

tff(addAssignment_26222,axiom,
    ! [VarCurr: state_type] :
      ( v7236(VarCurr,0)
    <=> v7238(VarCurr,0) ) ).

tff(addAssignment_26221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,2) )
     => ( v7238(VarCurr,B)
      <=> v7240(VarCurr,B) ) ) ).

tff(addAssignment_26220,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,13)
    <=> v50935(VarCurr) ) ).

tff(addAssignment_26219,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,12)
    <=> v49385(VarCurr) ) ).

tff(addAssignment_26218,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,11)
    <=> v47835(VarCurr) ) ).

tff(addAssignment_26217,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,10)
    <=> v46285(VarCurr) ) ).

tff(addAssignment_26216,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,9)
    <=> v44735(VarCurr) ) ).

tff(addAssignment_26215,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,8)
    <=> v43185(VarCurr) ) ).

tff(addAssignment_26214,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,7)
    <=> v41635(VarCurr) ) ).

tff(addAssignment_26213,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,6)
    <=> v40085(VarCurr) ) ).

tff(addAssignment_26212,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,5)
    <=> v38535(VarCurr) ) ).

tff(addAssignment_26211,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,4)
    <=> v36985(VarCurr) ) ).

tff(addAssignment_26210,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,3)
    <=> v35435(VarCurr) ) ).

tff(addAssignment_26209,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,2)
    <=> v8496(VarCurr) ) ).

tff(addAssignment_26208,axiom,
    ! [VarCurr: state_type] :
      ( v50935(VarCurr)
    <=> v50937(VarCurr) ) ).

tff(addAssignment_26207,axiom,
    ! [VarCurr: state_type] :
      ( v50937(VarCurr)
    <=> v50939(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_216,axiom,
    ! [VarCurr: state_type] :
      ( v50939(VarCurr)
    <=> ( ( v50941(VarCurr,11)
        <=> v50945(VarCurr,11) )
        & ( v50941(VarCurr,10)
        <=> v50945(VarCurr,10) )
        & ( v50941(VarCurr,9)
        <=> v50945(VarCurr,9) )
        & ( v50941(VarCurr,8)
        <=> v50945(VarCurr,8) )
        & ( v50941(VarCurr,7)
        <=> v50945(VarCurr,7) )
        & ( v50941(VarCurr,6)
        <=> v50945(VarCurr,6) )
        & ( v50941(VarCurr,5)
        <=> v50945(VarCurr,5) )
        & ( v50941(VarCurr,4)
        <=> v50945(VarCurr,4) )
        & ( v50941(VarCurr,3)
        <=> v50945(VarCurr,3) )
        & ( v50941(VarCurr,2)
        <=> v50945(VarCurr,2) )
        & ( v50941(VarCurr,1)
        <=> v50945(VarCurr,1) )
        & ( v50941(VarCurr,0)
        <=> v50945(VarCurr,0) ) ) ) ).

tff(addAssignment_26206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50945(VarCurr,B)
      <=> v50947(VarCurr,B) ) ) ).

tff(addAssignment_26205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50947(VarCurr,B)
      <=> v50949(VarCurr,B) ) ) ).

tff(addAssignment_26204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50949(VarCurr,B)
      <=> v50951(VarCurr,B) ) ) ).

tff(addAssignment_26203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50951(VarCurr,B)
      <=> v50953(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50953(VarCurr,B)
      <=> ( v52170(VarCurr,B)
          | v52189(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52189(VarCurr,B)
      <=> ( v52041(VarCurr,B)
          & v52190(VarCurr,B) ) ) ) ).

tff(addAssignment_26202,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,0)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26201,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,1)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26200,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,2)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26199,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,3)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26198,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,4)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26197,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,5)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26196,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,6)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26195,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,7)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26194,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,8)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26193,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,9)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26192,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,10)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26191,axiom,
    ! [VarCurr: state_type] :
      ( v52190(VarCurr,11)
    <=> v52191(VarCurr) ) ).

tff(addAssignment_26190,axiom,
    ! [VarCurr: state_type] :
      ( v52191(VarCurr)
    <=> v52160(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52170(VarCurr,B)
      <=> ( v52171(VarCurr,B)
          | v52186(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52186(VarCurr,B)
      <=> ( v51890(VarCurr,B)
          & v52187(VarCurr,B) ) ) ) ).

tff(addAssignment_26189,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,0)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26188,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,1)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26187,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,2)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26186,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,3)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26185,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,4)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26184,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,5)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26183,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,6)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26182,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,7)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26181,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,8)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26180,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,9)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26179,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,10)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26178,axiom,
    ! [VarCurr: state_type] :
      ( v52187(VarCurr,11)
    <=> v52188(VarCurr) ) ).

tff(addAssignment_26177,axiom,
    ! [VarCurr: state_type] :
      ( v52188(VarCurr)
    <=> v52010(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52171(VarCurr,B)
      <=> ( v52172(VarCurr,B)
          | v52183(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52183(VarCurr,B)
      <=> ( v51739(VarCurr,B)
          & v52184(VarCurr,B) ) ) ) ).

tff(addAssignment_26176,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,0)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26175,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,1)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26174,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,2)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26173,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,3)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26172,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,4)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26171,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,5)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26170,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,6)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26169,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,7)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26168,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,8)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26167,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,9)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26166,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,10)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26165,axiom,
    ! [VarCurr: state_type] :
      ( v52184(VarCurr,11)
    <=> v52185(VarCurr) ) ).

tff(addAssignment_26164,axiom,
    ! [VarCurr: state_type] :
      ( v52185(VarCurr)
    <=> v51859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52172(VarCurr,B)
      <=> ( v52173(VarCurr,B)
          | v52180(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52180(VarCurr,B)
      <=> ( v51588(VarCurr,B)
          & v52181(VarCurr,B) ) ) ) ).

tff(addAssignment_26163,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,0)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26162,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,1)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26161,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,2)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26160,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,3)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26159,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,4)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26158,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,5)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26157,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,6)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26156,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,7)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26155,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,8)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26154,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,9)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26153,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,10)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26152,axiom,
    ! [VarCurr: state_type] :
      ( v52181(VarCurr,11)
    <=> v52182(VarCurr) ) ).

tff(addAssignment_26151,axiom,
    ! [VarCurr: state_type] :
      ( v52182(VarCurr)
    <=> v51708(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52173(VarCurr,B)
      <=> ( v52174(VarCurr,B)
          | v52177(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52177(VarCurr,B)
      <=> ( v51426(VarCurr,B)
          & v52178(VarCurr,B) ) ) ) ).

tff(addAssignment_26150,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,0)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26149,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,1)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26148,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,2)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26147,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,3)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26146,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,4)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26145,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,5)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26144,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,6)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26143,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,7)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26142,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,8)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26141,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,9)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26140,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,10)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26139,axiom,
    ! [VarCurr: state_type] :
      ( v52178(VarCurr,11)
    <=> v52179(VarCurr) ) ).

tff(addAssignment_26138,axiom,
    ! [VarCurr: state_type] :
      ( v52179(VarCurr)
    <=> v51557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52174(VarCurr,B)
      <=> ( v50955(VarCurr,B)
          & v52175(VarCurr,B) ) ) ) ).

tff(addAssignment_26137,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,0)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26136,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,1)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26135,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,2)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26134,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,3)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26133,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,4)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26132,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,5)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26131,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,6)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26130,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,7)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26129,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,8)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26128,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,9)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26127,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,10)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26126,axiom,
    ! [VarCurr: state_type] :
      ( v52175(VarCurr,11)
    <=> v52176(VarCurr) ) ).

tff(addAssignment_26125,axiom,
    ! [VarCurr: state_type] :
      ( v52176(VarCurr)
    <=> v51134(VarCurr) ) ).

tff(addAssignment_26124,axiom,
    ! [VarCurr: state_type] :
      ( v52160(VarCurr)
    <=> v52162(VarCurr) ) ).

tff(addAssignment_26123,axiom,
    ! [VarCurr: state_type] :
      ( v52162(VarCurr)
    <=> v52164(VarCurr) ) ).

tff(addAssignment_26122,axiom,
    ! [VarCurr: state_type] :
      ( v52164(VarCurr)
    <=> v52166(VarCurr) ) ).

tff(addAssignment_26121,axiom,
    ! [VarCurr: state_type] :
      ( v52166(VarCurr)
    <=> v52168(VarCurr) ) ).

tff(addAssignment_26120,axiom,
    ! [VarCurr: state_type] :
      ( v52168(VarCurr)
    <=> v51227(VarCurr) ) ).

tff(addAssignment_26119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52041(VarCurr,B)
      <=> v52043(VarCurr,B) ) ) ).

tff(addAssignment_26118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52043(VarCurr,B)
      <=> v52045(VarCurr,B) ) ) ).

tff(addAssignment_26117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52045(VarCurr,B)
      <=> v52047(VarCurr,B) ) ) ).

tff(addAssignment_26116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52047(VarCurr,B)
      <=> v52049(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52143(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v52049(VarNext,B)
            <=> v52049(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_608,axiom,
    ! [VarNext: state_type] :
      ( v52143(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52049(VarNext,B)
          <=> v52153(VarNext,B) ) ) ) ).

tff(addAssignment_26115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52153(VarNext,B)
          <=> v52151(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52151(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_391,axiom,
    ! [VarCurr: state_type] :
      ( v52154(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52151(VarCurr,B)
          <=> v52071(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4834,axiom,
    ! [VarCurr: state_type] :
      ( v52154(VarCurr)
    <=> ( v52155(VarCurr)
        & v52156(VarCurr) ) ) ).

tff(writeUnaryOperator_2954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52156(VarCurr)
    <=> v52061(VarCurr) ) ).

tff(writeUnaryOperator_2953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52155(VarCurr)
    <=> v52051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52143(VarNext)
      <=> v52144(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52144(VarNext)
      <=> ( v52145(VarNext)
          & v52075(VarNext) ) ) ) ).

tff(writeUnaryOperator_2952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52145(VarNext)
      <=> v52147(VarNext) ) ) ).

tff(addAssignment_26114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52147(VarNext)
      <=> v52075(VarCurr) ) ) ).

tff(addAssignment_26113,axiom,
    ! [VarCurr: state_type] :
      ( v52075(VarCurr)
    <=> v52077(VarCurr) ) ).

tff(addAssignment_26112,axiom,
    ! [VarCurr: state_type] :
      ( v52077(VarCurr)
    <=> v52079(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4831,axiom,
    ! [VarCurr: state_type] :
      ( v52079(VarCurr)
    <=> ( v52140(VarCurr)
        | v52136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4830,axiom,
    ! [VarCurr: state_type] :
      ( v52140(VarCurr)
    <=> ( v52081(VarCurr)
        & v52085(VarCurr) ) ) ).

tff(addAssignment_26111,axiom,
    ! [VarCurr: state_type] :
      ( v52136(VarCurr)
    <=> v52138(VarCurr) ) ).

tff(addAssignment_26110,axiom,
    ! [VarCurr: state_type] :
      ( v52138(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v52120(VarNext)
       => ( v52085(VarNext)
        <=> v52085(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_607,axiom,
    ! [VarNext: state_type] :
      ( v52120(VarNext)
     => ( v52085(VarNext)
      <=> v52130(VarNext) ) ) ).

tff(addAssignment_26109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52130(VarNext)
      <=> v52128(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4829,axiom,
    ! [VarCurr: state_type] :
      ( v52128(VarCurr)
    <=> ( v52131(VarCurr)
        & v52132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4828,axiom,
    ! [VarCurr: state_type] :
      ( v52132(VarCurr)
    <=> ( v52091(VarCurr)
        | v52115(VarCurr) ) ) ).

tff(writeUnaryOperator_2951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52131(VarCurr)
    <=> v52087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52120(VarNext)
      <=> v52121(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52121(VarNext)
      <=> ( v52123(VarNext)
          & v52125(VarNext) ) ) ) ).

tff(writeUnaryOperator_2950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52125(VarCurr)
    <=> v52081(VarCurr) ) ).

tff(addAssignment_26108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v52123(VarNext)
      <=> v52081(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_228,axiom,
    ( v52085(constB0)
  <=> $true ) ).

tff(addAssignment_26107,axiom,
    ! [VarCurr: state_type] :
      ( v52115(VarCurr)
    <=> v52117(VarCurr) ) ).

tff(addAssignment_26106,axiom,
    ! [VarCurr: state_type] :
      ( v52117(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_26105,axiom,
    ! [VarCurr: state_type] :
      ( v52091(VarCurr)
    <=> v52093(VarCurr) ) ).

tff(addAssignment_26104,axiom,
    ! [VarCurr: state_type] :
      ( v52093(VarCurr)
    <=> v51401(VarCurr) ) ).

tff(addAssignment_26103,axiom,
    ! [VarCurr: state_type] :
      ( v51401(VarCurr)
    <=> v52096(VarCurr) ) ).

tff(addAssignment_26102,axiom,
    ! [VarCurr: state_type] :
      ( v52096(VarCurr)
    <=> v52098(VarCurr) ) ).

tff(writeUnaryOperator_2949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52098(VarCurr)
    <=> v52112(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4825,axiom,
    ! [VarCurr: state_type] :
      ( v52112(VarCurr)
    <=> ( v52113(VarCurr)
        | v52108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4824,axiom,
    ! [VarCurr: state_type] :
      ( v52113(VarCurr)
    <=> ( v52100(VarCurr)
        | v52104(VarCurr) ) ) ).

tff(addAssignment_26101,axiom,
    ! [VarCurr: state_type] :
      ( v52108(VarCurr)
    <=> v52110(VarCurr) ) ).

tff(addAssignment_26100,axiom,
    ! [VarCurr: state_type] :
      ( v52110(VarCurr)
    <=> v51490(VarCurr,2) ) ).

tff(addAssignment_26099,axiom,
    ! [VarCurr: state_type] :
      ( v52104(VarCurr)
    <=> v52106(VarCurr) ) ).

tff(addAssignment_26098,axiom,
    ! [VarCurr: state_type] :
      ( v52106(VarCurr)
    <=> v51064(VarCurr,1) ) ).

tff(addAssignment_26097,axiom,
    ! [VarCurr: state_type] :
      ( v52100(VarCurr)
    <=> v52102(VarCurr) ) ).

tff(addAssignment_26096,axiom,
    ! [VarCurr: state_type] :
      ( v52102(VarCurr)
    <=> v51490(VarCurr,0) ) ).

tff(addAssignment_26095,axiom,
    ! [VarCurr: state_type] :
      ( v52087(VarCurr)
    <=> v52089(VarCurr) ) ).

tff(addAssignment_26094,axiom,
    ! [VarCurr: state_type] :
      ( v52089(VarCurr)
    <=> $false ) ).

tff(addAssignment_26093,axiom,
    ! [VarCurr: state_type] :
      ( v52081(VarCurr)
    <=> v52083(VarCurr) ) ).

tff(addAssignment_26092,axiom,
    ! [VarCurr: state_type] :
      ( v52083(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_26091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52071(VarCurr,B)
      <=> v52073(VarCurr,B) ) ) ).

tff(addAssignment_26090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v52073(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_26089,axiom,
    ! [VarCurr: state_type] :
      ( v52061(VarCurr)
    <=> v52063(VarCurr) ) ).

tff(addAssignment_26088,axiom,
    ! [VarCurr: state_type] :
      ( v52063(VarCurr)
    <=> v52065(VarCurr) ) ).

tff(addAssignment_26087,axiom,
    ! [VarCurr: state_type] :
      ( v52065(VarCurr)
    <=> v52067(VarCurr) ) ).

tff(addAssignment_26086,axiom,
    ! [VarCurr: state_type] :
      ( v52067(VarCurr)
    <=> v52069(VarCurr) ) ).

tff(addAssignment_26085,axiom,
    ! [VarCurr: state_type] :
      ( v52069(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_26084,axiom,
    ! [VarCurr: state_type] :
      ( v52051(VarCurr)
    <=> v52053(VarCurr) ) ).

tff(addAssignment_26083,axiom,
    ! [VarCurr: state_type] :
      ( v52053(VarCurr)
    <=> v52055(VarCurr) ) ).

tff(addAssignment_26082,axiom,
    ! [VarCurr: state_type] :
      ( v52055(VarCurr)
    <=> v52057(VarCurr) ) ).

tff(addAssignment_26081,axiom,
    ! [VarCurr: state_type] :
      ( v52057(VarCurr)
    <=> v52059(VarCurr) ) ).

tff(addAssignment_26080,axiom,
    ! [VarCurr: state_type] :
      ( v52059(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_26079,axiom,
    ! [VarCurr: state_type] :
      ( v52010(VarCurr)
    <=> v52012(VarCurr) ) ).

tff(addAssignment_26078,axiom,
    ! [VarCurr: state_type] :
      ( v52012(VarCurr)
    <=> v52014(VarCurr) ) ).

tff(addAssignment_26077,axiom,
    ! [VarCurr: state_type] :
      ( v52014(VarCurr)
    <=> v52016(VarCurr) ) ).

tff(addAssignment_26076,axiom,
    ! [VarCurr: state_type] :
      ( v52016(VarCurr)
    <=> v52018(VarCurr) ) ).

tff(addAssignment_26075,axiom,
    ! [VarCurr: state_type] :
      ( v52018(VarCurr)
    <=> v52020(VarCurr) ) ).

tff(addAssignment_26074,axiom,
    ! [VarCurr: state_type] :
      ( v52020(VarCurr)
    <=> v52022(VarCurr) ) ).

tff(addAssignment_26073,axiom,
    ! [VarCurr: state_type] :
      ( v52022(VarCurr)
    <=> v52024(VarCurr) ) ).

tff(writeUnaryOperator_2948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52024(VarCurr)
    <=> v52038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4823,axiom,
    ! [VarCurr: state_type] :
      ( v52038(VarCurr)
    <=> ( v52039(VarCurr)
        | v52034(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4822,axiom,
    ! [VarCurr: state_type] :
      ( v52039(VarCurr)
    <=> ( v52026(VarCurr)
        | v52030(VarCurr) ) ) ).

tff(addAssignment_26072,axiom,
    ! [VarCurr: state_type] :
      ( v52034(VarCurr)
    <=> v52036(VarCurr) ) ).

tff(addAssignment_26071,axiom,
    ! [VarCurr: state_type] :
      ( v52036(VarCurr)
    <=> v51237(VarCurr,2) ) ).

tff(addAssignment_26070,axiom,
    ! [VarCurr: state_type] :
      ( v52030(VarCurr)
    <=> v52032(VarCurr) ) ).

tff(addAssignment_26069,axiom,
    ! [VarCurr: state_type] :
      ( v52032(VarCurr)
    <=> v51154(VarCurr,1) ) ).

tff(addAssignment_26068,axiom,
    ! [VarCurr: state_type] :
      ( v52026(VarCurr)
    <=> v52028(VarCurr) ) ).

tff(addAssignment_26067,axiom,
    ! [VarCurr: state_type] :
      ( v52028(VarCurr)
    <=> v51154(VarCurr,0) ) ).

tff(addAssignment_26066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51890(VarCurr,B)
      <=> v51892(VarCurr,B) ) ) ).

tff(addAssignment_26065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51892(VarCurr,B)
      <=> v51894(VarCurr,B) ) ) ).

tff(addAssignment_26064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51894(VarCurr,B)
      <=> v51896(VarCurr,B) ) ) ).

tff(addAssignment_26063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51896(VarCurr,B)
      <=> v51898(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51993(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v51898(VarNext,B)
            <=> v51898(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_606,axiom,
    ! [VarNext: state_type] :
      ( v51993(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51898(VarNext,B)
          <=> v52003(VarNext,B) ) ) ) ).

tff(addAssignment_26062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52003(VarNext,B)
          <=> v52001(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52001(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_390,axiom,
    ! [VarCurr: state_type] :
      ( v52004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v52001(VarCurr,B)
          <=> v51920(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4821,axiom,
    ! [VarCurr: state_type] :
      ( v52004(VarCurr)
    <=> ( v52005(VarCurr)
        & v52006(VarCurr) ) ) ).

tff(writeUnaryOperator_2947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52006(VarCurr)
    <=> v51910(VarCurr) ) ).

tff(writeUnaryOperator_2946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v52005(VarCurr)
    <=> v51900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51993(VarNext)
      <=> v51994(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51994(VarNext)
      <=> ( v51995(VarNext)
          & v51924(VarNext) ) ) ) ).

tff(writeUnaryOperator_2945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51995(VarNext)
      <=> v51997(VarNext) ) ) ).

tff(addAssignment_26061,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51997(VarNext)
      <=> v51924(VarCurr) ) ) ).

tff(addAssignment_26060,axiom,
    ! [VarCurr: state_type] :
      ( v51924(VarCurr)
    <=> v51926(VarCurr) ) ).

tff(addAssignment_26059,axiom,
    ! [VarCurr: state_type] :
      ( v51926(VarCurr)
    <=> v51928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4818,axiom,
    ! [VarCurr: state_type] :
      ( v51928(VarCurr)
    <=> ( v51990(VarCurr)
        | v51986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4817,axiom,
    ! [VarCurr: state_type] :
      ( v51990(VarCurr)
    <=> ( v51930(VarCurr)
        & v51934(VarCurr) ) ) ).

tff(addAssignment_26058,axiom,
    ! [VarCurr: state_type] :
      ( v51986(VarCurr)
    <=> v51988(VarCurr) ) ).

tff(addAssignment_26057,axiom,
    ! [VarCurr: state_type] :
      ( v51988(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51970(VarNext)
       => ( v51934(VarNext)
        <=> v51934(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_605,axiom,
    ! [VarNext: state_type] :
      ( v51970(VarNext)
     => ( v51934(VarNext)
      <=> v51980(VarNext) ) ) ).

tff(addAssignment_26056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51980(VarNext)
      <=> v51978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4816,axiom,
    ! [VarCurr: state_type] :
      ( v51978(VarCurr)
    <=> ( v51981(VarCurr)
        & v51982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4815,axiom,
    ! [VarCurr: state_type] :
      ( v51982(VarCurr)
    <=> ( v51940(VarCurr)
        | v51965(VarCurr) ) ) ).

tff(writeUnaryOperator_2944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51981(VarCurr)
    <=> v51936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51970(VarNext)
      <=> v51971(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51971(VarNext)
      <=> ( v51973(VarNext)
          & v51975(VarNext) ) ) ) ).

tff(writeUnaryOperator_2943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51975(VarCurr)
    <=> v51930(VarCurr) ) ).

tff(addAssignment_26055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51973(VarNext)
      <=> v51930(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_227,axiom,
    ( v51934(constB0)
  <=> $true ) ).

tff(addAssignment_26054,axiom,
    ! [VarCurr: state_type] :
      ( v51965(VarCurr)
    <=> v51967(VarCurr) ) ).

tff(addAssignment_26053,axiom,
    ! [VarCurr: state_type] :
      ( v51967(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_26052,axiom,
    ! [VarCurr: state_type] :
      ( v51940(VarCurr)
    <=> v51942(VarCurr) ) ).

tff(addAssignment_26051,axiom,
    ! [VarCurr: state_type] :
      ( v51942(VarCurr)
    <=> v51944(VarCurr) ) ).

tff(addAssignment_26050,axiom,
    ! [VarCurr: state_type] :
      ( v51944(VarCurr)
    <=> v51946(VarCurr) ) ).

tff(addAssignment_26049,axiom,
    ! [VarCurr: state_type] :
      ( v51946(VarCurr)
    <=> v51948(VarCurr) ) ).

tff(writeUnaryOperator_2942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51948(VarCurr)
    <=> v51962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4812,axiom,
    ! [VarCurr: state_type] :
      ( v51962(VarCurr)
    <=> ( v51963(VarCurr)
        | v51958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4811,axiom,
    ! [VarCurr: state_type] :
      ( v51963(VarCurr)
    <=> ( v51950(VarCurr)
        | v51954(VarCurr) ) ) ).

tff(addAssignment_26048,axiom,
    ! [VarCurr: state_type] :
      ( v51958(VarCurr)
    <=> v51960(VarCurr) ) ).

tff(addAssignment_26047,axiom,
    ! [VarCurr: state_type] :
      ( v51960(VarCurr)
    <=> v51490(VarCurr,2) ) ).

tff(addAssignment_26046,axiom,
    ! [VarCurr: state_type] :
      ( v51490(VarCurr,2)
    <=> v51492(VarCurr,2) ) ).

tff(addAssignment_26045,axiom,
    ! [VarCurr: state_type] :
      ( v51492(VarCurr,2)
    <=> v51494(VarCurr,2) ) ).

tff(addAssignment_26044,axiom,
    ! [VarCurr: state_type] :
      ( v51494(VarCurr,2)
    <=> v51499(VarCurr,2) ) ).

tff(addAssignment_26043,axiom,
    ! [VarCurr: state_type] :
      ( v51496(VarCurr,2)
    <=> v51498(VarCurr,2) ) ).

tff(addAssignment_26042,axiom,
    ! [VarCurr: state_type] :
      ( v51498(VarCurr,2)
    <=> v51064(VarCurr,2) ) ).

tff(addAssignment_26041,axiom,
    ! [VarCurr: state_type] :
      ( v51954(VarCurr)
    <=> v51956(VarCurr) ) ).

tff(addAssignment_26040,axiom,
    ! [VarCurr: state_type] :
      ( v51956(VarCurr)
    <=> v51064(VarCurr,1) ) ).

tff(addAssignment_26039,axiom,
    ! [VarCurr: state_type] :
      ( v51950(VarCurr)
    <=> v51952(VarCurr) ) ).

tff(addAssignment_26038,axiom,
    ! [VarCurr: state_type] :
      ( v51952(VarCurr)
    <=> v51064(VarCurr,0) ) ).

tff(addAssignment_26037,axiom,
    ! [VarCurr: state_type] :
      ( v51936(VarCurr)
    <=> v51938(VarCurr) ) ).

tff(addAssignment_26036,axiom,
    ! [VarCurr: state_type] :
      ( v51938(VarCurr)
    <=> $false ) ).

tff(addAssignment_26035,axiom,
    ! [VarCurr: state_type] :
      ( v51930(VarCurr)
    <=> v51932(VarCurr) ) ).

tff(addAssignment_26034,axiom,
    ! [VarCurr: state_type] :
      ( v51932(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_26033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51920(VarCurr,B)
      <=> v51922(VarCurr,B) ) ) ).

tff(addAssignment_26032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51922(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_26031,axiom,
    ! [VarCurr: state_type] :
      ( v51910(VarCurr)
    <=> v51912(VarCurr) ) ).

tff(addAssignment_26030,axiom,
    ! [VarCurr: state_type] :
      ( v51912(VarCurr)
    <=> v51914(VarCurr) ) ).

tff(addAssignment_26029,axiom,
    ! [VarCurr: state_type] :
      ( v51914(VarCurr)
    <=> v51916(VarCurr) ) ).

tff(addAssignment_26028,axiom,
    ! [VarCurr: state_type] :
      ( v51916(VarCurr)
    <=> v51918(VarCurr) ) ).

tff(addAssignment_26027,axiom,
    ! [VarCurr: state_type] :
      ( v51918(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_26026,axiom,
    ! [VarCurr: state_type] :
      ( v51900(VarCurr)
    <=> v51902(VarCurr) ) ).

tff(addAssignment_26025,axiom,
    ! [VarCurr: state_type] :
      ( v51902(VarCurr)
    <=> v51904(VarCurr) ) ).

tff(addAssignment_26024,axiom,
    ! [VarCurr: state_type] :
      ( v51904(VarCurr)
    <=> v51906(VarCurr) ) ).

tff(addAssignment_26023,axiom,
    ! [VarCurr: state_type] :
      ( v51906(VarCurr)
    <=> v51908(VarCurr) ) ).

tff(addAssignment_26022,axiom,
    ! [VarCurr: state_type] :
      ( v51908(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_26021,axiom,
    ! [VarCurr: state_type] :
      ( v51859(VarCurr)
    <=> v51861(VarCurr) ) ).

tff(addAssignment_26020,axiom,
    ! [VarCurr: state_type] :
      ( v51861(VarCurr)
    <=> v51863(VarCurr) ) ).

tff(addAssignment_26019,axiom,
    ! [VarCurr: state_type] :
      ( v51863(VarCurr)
    <=> v51865(VarCurr) ) ).

tff(addAssignment_26018,axiom,
    ! [VarCurr: state_type] :
      ( v51865(VarCurr)
    <=> v51867(VarCurr) ) ).

tff(addAssignment_26017,axiom,
    ! [VarCurr: state_type] :
      ( v51867(VarCurr)
    <=> v51869(VarCurr) ) ).

tff(addAssignment_26016,axiom,
    ! [VarCurr: state_type] :
      ( v51869(VarCurr)
    <=> v51871(VarCurr) ) ).

tff(addAssignment_26015,axiom,
    ! [VarCurr: state_type] :
      ( v51871(VarCurr)
    <=> v51873(VarCurr) ) ).

tff(writeUnaryOperator_2941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51873(VarCurr)
    <=> v51887(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4810,axiom,
    ! [VarCurr: state_type] :
      ( v51887(VarCurr)
    <=> ( v51888(VarCurr)
        | v51883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4809,axiom,
    ! [VarCurr: state_type] :
      ( v51888(VarCurr)
    <=> ( v51875(VarCurr)
        | v51879(VarCurr) ) ) ).

tff(addAssignment_26014,axiom,
    ! [VarCurr: state_type] :
      ( v51883(VarCurr)
    <=> v51885(VarCurr) ) ).

tff(addAssignment_26013,axiom,
    ! [VarCurr: state_type] :
      ( v51885(VarCurr)
    <=> v51154(VarCurr,2) ) ).

tff(addAssignment_26012,axiom,
    ! [VarCurr: state_type] :
      ( v51879(VarCurr)
    <=> v51881(VarCurr) ) ).

tff(addAssignment_26011,axiom,
    ! [VarCurr: state_type] :
      ( v51881(VarCurr)
    <=> v51237(VarCurr,1) ) ).

tff(addAssignment_26010,axiom,
    ! [VarCurr: state_type] :
      ( v51875(VarCurr)
    <=> v51877(VarCurr) ) ).

tff(addAssignment_26009,axiom,
    ! [VarCurr: state_type] :
      ( v51877(VarCurr)
    <=> v51237(VarCurr,0) ) ).

tff(addAssignment_26008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51739(VarCurr,B)
      <=> v51741(VarCurr,B) ) ) ).

tff(addAssignment_26007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51741(VarCurr,B)
      <=> v51743(VarCurr,B) ) ) ).

tff(addAssignment_26006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51743(VarCurr,B)
      <=> v51745(VarCurr,B) ) ) ).

tff(addAssignment_26005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51745(VarCurr,B)
      <=> v51747(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51842(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v51747(VarNext,B)
            <=> v51747(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_604,axiom,
    ! [VarNext: state_type] :
      ( v51842(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51747(VarNext,B)
          <=> v51852(VarNext,B) ) ) ) ).

tff(addAssignment_26004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51852(VarNext,B)
          <=> v51850(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51850(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_389,axiom,
    ! [VarCurr: state_type] :
      ( v51853(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51850(VarCurr,B)
          <=> v51769(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4808,axiom,
    ! [VarCurr: state_type] :
      ( v51853(VarCurr)
    <=> ( v51854(VarCurr)
        & v51855(VarCurr) ) ) ).

tff(writeUnaryOperator_2940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51855(VarCurr)
    <=> v51759(VarCurr) ) ).

tff(writeUnaryOperator_2939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51854(VarCurr)
    <=> v51749(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51842(VarNext)
      <=> v51843(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51843(VarNext)
      <=> ( v51844(VarNext)
          & v51773(VarNext) ) ) ) ).

tff(writeUnaryOperator_2938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51844(VarNext)
      <=> v51846(VarNext) ) ) ).

tff(addAssignment_26003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51846(VarNext)
      <=> v51773(VarCurr) ) ) ).

tff(addAssignment_26002,axiom,
    ! [VarCurr: state_type] :
      ( v51773(VarCurr)
    <=> v51775(VarCurr) ) ).

tff(addAssignment_26001,axiom,
    ! [VarCurr: state_type] :
      ( v51775(VarCurr)
    <=> v51777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4805,axiom,
    ! [VarCurr: state_type] :
      ( v51777(VarCurr)
    <=> ( v51839(VarCurr)
        | v51835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4804,axiom,
    ! [VarCurr: state_type] :
      ( v51839(VarCurr)
    <=> ( v51779(VarCurr)
        & v51783(VarCurr) ) ) ).

tff(addAssignment_26000,axiom,
    ! [VarCurr: state_type] :
      ( v51835(VarCurr)
    <=> v51837(VarCurr) ) ).

tff(addAssignment_25999,axiom,
    ! [VarCurr: state_type] :
      ( v51837(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51819(VarNext)
       => ( v51783(VarNext)
        <=> v51783(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_603,axiom,
    ! [VarNext: state_type] :
      ( v51819(VarNext)
     => ( v51783(VarNext)
      <=> v51829(VarNext) ) ) ).

tff(addAssignment_25998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51829(VarNext)
      <=> v51827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4803,axiom,
    ! [VarCurr: state_type] :
      ( v51827(VarCurr)
    <=> ( v51830(VarCurr)
        & v51831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4802,axiom,
    ! [VarCurr: state_type] :
      ( v51831(VarCurr)
    <=> ( v51789(VarCurr)
        | v51814(VarCurr) ) ) ).

tff(writeUnaryOperator_2937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51830(VarCurr)
    <=> v51785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51819(VarNext)
      <=> v51820(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51820(VarNext)
      <=> ( v51822(VarNext)
          & v51824(VarNext) ) ) ) ).

tff(writeUnaryOperator_2936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51824(VarCurr)
    <=> v51779(VarCurr) ) ).

tff(addAssignment_25997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51822(VarNext)
      <=> v51779(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_226,axiom,
    ( v51783(constB0)
  <=> $true ) ).

tff(addAssignment_25996,axiom,
    ! [VarCurr: state_type] :
      ( v51814(VarCurr)
    <=> v51816(VarCurr) ) ).

tff(addAssignment_25995,axiom,
    ! [VarCurr: state_type] :
      ( v51816(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_25994,axiom,
    ! [VarCurr: state_type] :
      ( v51789(VarCurr)
    <=> v51791(VarCurr) ) ).

tff(addAssignment_25993,axiom,
    ! [VarCurr: state_type] :
      ( v51791(VarCurr)
    <=> v51793(VarCurr) ) ).

tff(addAssignment_25992,axiom,
    ! [VarCurr: state_type] :
      ( v51793(VarCurr)
    <=> v51795(VarCurr) ) ).

tff(addAssignment_25991,axiom,
    ! [VarCurr: state_type] :
      ( v51795(VarCurr)
    <=> v51797(VarCurr) ) ).

tff(writeUnaryOperator_2935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51797(VarCurr)
    <=> v51811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4799,axiom,
    ! [VarCurr: state_type] :
      ( v51811(VarCurr)
    <=> ( v51812(VarCurr)
        | v51807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4798,axiom,
    ! [VarCurr: state_type] :
      ( v51812(VarCurr)
    <=> ( v51799(VarCurr)
        | v51803(VarCurr) ) ) ).

tff(addAssignment_25990,axiom,
    ! [VarCurr: state_type] :
      ( v51807(VarCurr)
    <=> v51809(VarCurr) ) ).

tff(addAssignment_25989,axiom,
    ! [VarCurr: state_type] :
      ( v51809(VarCurr)
    <=> v51064(VarCurr,2) ) ).

tff(addAssignment_25988,axiom,
    ! [VarCurr: state_type] :
      ( v51803(VarCurr)
    <=> v51805(VarCurr) ) ).

tff(addAssignment_25987,axiom,
    ! [VarCurr: state_type] :
      ( v51805(VarCurr)
    <=> v51490(VarCurr,1) ) ).

tff(addAssignment_25986,axiom,
    ! [VarCurr: state_type] :
      ( v51799(VarCurr)
    <=> v51801(VarCurr) ) ).

tff(addAssignment_25985,axiom,
    ! [VarCurr: state_type] :
      ( v51801(VarCurr)
    <=> v51490(VarCurr,0) ) ).

tff(addAssignment_25984,axiom,
    ! [VarCurr: state_type] :
      ( v51785(VarCurr)
    <=> v51787(VarCurr) ) ).

tff(addAssignment_25983,axiom,
    ! [VarCurr: state_type] :
      ( v51787(VarCurr)
    <=> $false ) ).

tff(addAssignment_25982,axiom,
    ! [VarCurr: state_type] :
      ( v51779(VarCurr)
    <=> v51781(VarCurr) ) ).

tff(addAssignment_25981,axiom,
    ! [VarCurr: state_type] :
      ( v51781(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_25980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51769(VarCurr,B)
      <=> v51771(VarCurr,B) ) ) ).

tff(addAssignment_25979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51771(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_25978,axiom,
    ! [VarCurr: state_type] :
      ( v51759(VarCurr)
    <=> v51761(VarCurr) ) ).

tff(addAssignment_25977,axiom,
    ! [VarCurr: state_type] :
      ( v51761(VarCurr)
    <=> v51763(VarCurr) ) ).

tff(addAssignment_25976,axiom,
    ! [VarCurr: state_type] :
      ( v51763(VarCurr)
    <=> v51765(VarCurr) ) ).

tff(addAssignment_25975,axiom,
    ! [VarCurr: state_type] :
      ( v51765(VarCurr)
    <=> v51767(VarCurr) ) ).

tff(addAssignment_25974,axiom,
    ! [VarCurr: state_type] :
      ( v51767(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_25973,axiom,
    ! [VarCurr: state_type] :
      ( v51749(VarCurr)
    <=> v51751(VarCurr) ) ).

tff(addAssignment_25972,axiom,
    ! [VarCurr: state_type] :
      ( v51751(VarCurr)
    <=> v51753(VarCurr) ) ).

tff(addAssignment_25971,axiom,
    ! [VarCurr: state_type] :
      ( v51753(VarCurr)
    <=> v51755(VarCurr) ) ).

tff(addAssignment_25970,axiom,
    ! [VarCurr: state_type] :
      ( v51755(VarCurr)
    <=> v51757(VarCurr) ) ).

tff(addAssignment_25969,axiom,
    ! [VarCurr: state_type] :
      ( v51757(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_25968,axiom,
    ! [VarCurr: state_type] :
      ( v51708(VarCurr)
    <=> v51710(VarCurr) ) ).

tff(addAssignment_25967,axiom,
    ! [VarCurr: state_type] :
      ( v51710(VarCurr)
    <=> v51712(VarCurr) ) ).

tff(addAssignment_25966,axiom,
    ! [VarCurr: state_type] :
      ( v51712(VarCurr)
    <=> v51714(VarCurr) ) ).

tff(addAssignment_25965,axiom,
    ! [VarCurr: state_type] :
      ( v51714(VarCurr)
    <=> v51716(VarCurr) ) ).

tff(addAssignment_25964,axiom,
    ! [VarCurr: state_type] :
      ( v51716(VarCurr)
    <=> v51718(VarCurr) ) ).

tff(addAssignment_25963,axiom,
    ! [VarCurr: state_type] :
      ( v51718(VarCurr)
    <=> v51720(VarCurr) ) ).

tff(addAssignment_25962,axiom,
    ! [VarCurr: state_type] :
      ( v51720(VarCurr)
    <=> v51722(VarCurr) ) ).

tff(writeUnaryOperator_2934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51722(VarCurr)
    <=> v51736(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4797,axiom,
    ! [VarCurr: state_type] :
      ( v51736(VarCurr)
    <=> ( v51737(VarCurr)
        | v51732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4796,axiom,
    ! [VarCurr: state_type] :
      ( v51737(VarCurr)
    <=> ( v51724(VarCurr)
        | v51728(VarCurr) ) ) ).

tff(addAssignment_25961,axiom,
    ! [VarCurr: state_type] :
      ( v51732(VarCurr)
    <=> v51734(VarCurr) ) ).

tff(addAssignment_25960,axiom,
    ! [VarCurr: state_type] :
      ( v51734(VarCurr)
    <=> v51154(VarCurr,2) ) ).

tff(addAssignment_25959,axiom,
    ! [VarCurr: state_type] :
      ( v51728(VarCurr)
    <=> v51730(VarCurr) ) ).

tff(addAssignment_25958,axiom,
    ! [VarCurr: state_type] :
      ( v51730(VarCurr)
    <=> v51237(VarCurr,1) ) ).

tff(addAssignment_25957,axiom,
    ! [VarCurr: state_type] :
      ( v51237(VarCurr,1)
    <=> v51239(VarCurr,1) ) ).

tff(addAssignment_25956,axiom,
    ! [VarCurr: state_type] :
      ( v51239(VarCurr,1)
    <=> v51241(VarCurr,1) ) ).

tff(addAssignment_25955,axiom,
    ! [VarCurr: state_type] :
      ( v51241(VarCurr,1)
    <=> v51246(VarCurr,1) ) ).

tff(addAssignment_25954,axiom,
    ! [VarCurr: state_type] :
      ( v51243(VarCurr,1)
    <=> v51245(VarCurr,1) ) ).

tff(addAssignment_25953,axiom,
    ! [VarCurr: state_type] :
      ( v51245(VarCurr,1)
    <=> v51154(VarCurr,1) ) ).

tff(addAssignment_25952,axiom,
    ! [VarCurr: state_type] :
      ( v51724(VarCurr)
    <=> v51726(VarCurr) ) ).

tff(addAssignment_25951,axiom,
    ! [VarCurr: state_type] :
      ( v51726(VarCurr)
    <=> v51154(VarCurr,0) ) ).

tff(addAssignment_25950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51588(VarCurr,B)
      <=> v51590(VarCurr,B) ) ) ).

tff(addAssignment_25949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51590(VarCurr,B)
      <=> v51592(VarCurr,B) ) ) ).

tff(addAssignment_25948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51592(VarCurr,B)
      <=> v51594(VarCurr,B) ) ) ).

tff(addAssignment_25947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51594(VarCurr,B)
      <=> v51596(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51691(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v51596(VarNext,B)
            <=> v51596(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_602,axiom,
    ! [VarNext: state_type] :
      ( v51691(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51596(VarNext,B)
          <=> v51701(VarNext,B) ) ) ) ).

tff(addAssignment_25946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51701(VarNext,B)
          <=> v51699(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51702(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51699(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_388,axiom,
    ! [VarCurr: state_type] :
      ( v51702(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51699(VarCurr,B)
          <=> v51618(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4795,axiom,
    ! [VarCurr: state_type] :
      ( v51702(VarCurr)
    <=> ( v51703(VarCurr)
        & v51704(VarCurr) ) ) ).

tff(writeUnaryOperator_2933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51704(VarCurr)
    <=> v51608(VarCurr) ) ).

tff(writeUnaryOperator_2932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51703(VarCurr)
    <=> v51598(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51691(VarNext)
      <=> v51692(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51692(VarNext)
      <=> ( v51693(VarNext)
          & v51622(VarNext) ) ) ) ).

tff(writeUnaryOperator_2931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51693(VarNext)
      <=> v51695(VarNext) ) ) ).

tff(addAssignment_25945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51695(VarNext)
      <=> v51622(VarCurr) ) ) ).

tff(addAssignment_25944,axiom,
    ! [VarCurr: state_type] :
      ( v51622(VarCurr)
    <=> v51624(VarCurr) ) ).

tff(addAssignment_25943,axiom,
    ! [VarCurr: state_type] :
      ( v51624(VarCurr)
    <=> v51626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4792,axiom,
    ! [VarCurr: state_type] :
      ( v51626(VarCurr)
    <=> ( v51688(VarCurr)
        | v51684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4791,axiom,
    ! [VarCurr: state_type] :
      ( v51688(VarCurr)
    <=> ( v51628(VarCurr)
        & v51632(VarCurr) ) ) ).

tff(addAssignment_25942,axiom,
    ! [VarCurr: state_type] :
      ( v51684(VarCurr)
    <=> v51686(VarCurr) ) ).

tff(addAssignment_25941,axiom,
    ! [VarCurr: state_type] :
      ( v51686(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51668(VarNext)
       => ( v51632(VarNext)
        <=> v51632(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_601,axiom,
    ! [VarNext: state_type] :
      ( v51668(VarNext)
     => ( v51632(VarNext)
      <=> v51678(VarNext) ) ) ).

tff(addAssignment_25940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51678(VarNext)
      <=> v51676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4790,axiom,
    ! [VarCurr: state_type] :
      ( v51676(VarCurr)
    <=> ( v51679(VarCurr)
        & v51680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4789,axiom,
    ! [VarCurr: state_type] :
      ( v51680(VarCurr)
    <=> ( v51638(VarCurr)
        | v51663(VarCurr) ) ) ).

tff(writeUnaryOperator_2930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51679(VarCurr)
    <=> v51634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51668(VarNext)
      <=> v51669(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51669(VarNext)
      <=> ( v51671(VarNext)
          & v51673(VarNext) ) ) ) ).

tff(writeUnaryOperator_2929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51673(VarCurr)
    <=> v51628(VarCurr) ) ).

tff(addAssignment_25939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51671(VarNext)
      <=> v51628(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_225,axiom,
    ( v51632(constB0)
  <=> $true ) ).

tff(addAssignment_25938,axiom,
    ! [VarCurr: state_type] :
      ( v51663(VarCurr)
    <=> v51665(VarCurr) ) ).

tff(addAssignment_25937,axiom,
    ! [VarCurr: state_type] :
      ( v51665(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_25936,axiom,
    ! [VarCurr: state_type] :
      ( v51638(VarCurr)
    <=> v51640(VarCurr) ) ).

tff(addAssignment_25935,axiom,
    ! [VarCurr: state_type] :
      ( v51640(VarCurr)
    <=> v51642(VarCurr) ) ).

tff(addAssignment_25934,axiom,
    ! [VarCurr: state_type] :
      ( v51642(VarCurr)
    <=> v51644(VarCurr) ) ).

tff(addAssignment_25933,axiom,
    ! [VarCurr: state_type] :
      ( v51644(VarCurr)
    <=> v51646(VarCurr) ) ).

tff(writeUnaryOperator_2928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51646(VarCurr)
    <=> v51660(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4786,axiom,
    ! [VarCurr: state_type] :
      ( v51660(VarCurr)
    <=> ( v51661(VarCurr)
        | v51656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4785,axiom,
    ! [VarCurr: state_type] :
      ( v51661(VarCurr)
    <=> ( v51648(VarCurr)
        | v51652(VarCurr) ) ) ).

tff(addAssignment_25932,axiom,
    ! [VarCurr: state_type] :
      ( v51656(VarCurr)
    <=> v51658(VarCurr) ) ).

tff(addAssignment_25931,axiom,
    ! [VarCurr: state_type] :
      ( v51658(VarCurr)
    <=> v51064(VarCurr,2) ) ).

tff(addAssignment_25930,axiom,
    ! [VarCurr: state_type] :
      ( v51652(VarCurr)
    <=> v51654(VarCurr) ) ).

tff(addAssignment_25929,axiom,
    ! [VarCurr: state_type] :
      ( v51654(VarCurr)
    <=> v51490(VarCurr,1) ) ).

tff(addAssignment_25928,axiom,
    ! [VarCurr: state_type] :
      ( v51490(VarCurr,1)
    <=> v51492(VarCurr,1) ) ).

tff(addAssignment_25927,axiom,
    ! [VarCurr: state_type] :
      ( v51492(VarCurr,1)
    <=> v51494(VarCurr,1) ) ).

tff(addAssignment_25926,axiom,
    ! [VarCurr: state_type] :
      ( v51494(VarCurr,1)
    <=> v51499(VarCurr,1) ) ).

tff(addAssignment_25925,axiom,
    ! [VarCurr: state_type] :
      ( v51496(VarCurr,1)
    <=> v51498(VarCurr,1) ) ).

tff(addAssignment_25924,axiom,
    ! [VarCurr: state_type] :
      ( v51498(VarCurr,1)
    <=> v51064(VarCurr,1) ) ).

tff(addAssignment_25923,axiom,
    ! [VarCurr: state_type] :
      ( v51648(VarCurr)
    <=> v51650(VarCurr) ) ).

tff(addAssignment_25922,axiom,
    ! [VarCurr: state_type] :
      ( v51650(VarCurr)
    <=> v51064(VarCurr,0) ) ).

tff(addAssignment_25921,axiom,
    ! [VarCurr: state_type] :
      ( v51634(VarCurr)
    <=> v51636(VarCurr) ) ).

tff(addAssignment_25920,axiom,
    ! [VarCurr: state_type] :
      ( v51636(VarCurr)
    <=> $false ) ).

tff(addAssignment_25919,axiom,
    ! [VarCurr: state_type] :
      ( v51628(VarCurr)
    <=> v51630(VarCurr) ) ).

tff(addAssignment_25918,axiom,
    ! [VarCurr: state_type] :
      ( v51630(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_25917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51618(VarCurr,B)
      <=> v51620(VarCurr,B) ) ) ).

tff(addAssignment_25916,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51620(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_25915,axiom,
    ! [VarCurr: state_type] :
      ( v51608(VarCurr)
    <=> v51610(VarCurr) ) ).

tff(addAssignment_25914,axiom,
    ! [VarCurr: state_type] :
      ( v51610(VarCurr)
    <=> v51612(VarCurr) ) ).

tff(addAssignment_25913,axiom,
    ! [VarCurr: state_type] :
      ( v51612(VarCurr)
    <=> v51614(VarCurr) ) ).

tff(addAssignment_25912,axiom,
    ! [VarCurr: state_type] :
      ( v51614(VarCurr)
    <=> v51616(VarCurr) ) ).

tff(addAssignment_25911,axiom,
    ! [VarCurr: state_type] :
      ( v51616(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_25910,axiom,
    ! [VarCurr: state_type] :
      ( v51598(VarCurr)
    <=> v51600(VarCurr) ) ).

tff(addAssignment_25909,axiom,
    ! [VarCurr: state_type] :
      ( v51600(VarCurr)
    <=> v51602(VarCurr) ) ).

tff(addAssignment_25908,axiom,
    ! [VarCurr: state_type] :
      ( v51602(VarCurr)
    <=> v51604(VarCurr) ) ).

tff(addAssignment_25907,axiom,
    ! [VarCurr: state_type] :
      ( v51604(VarCurr)
    <=> v51606(VarCurr) ) ).

tff(addAssignment_25906,axiom,
    ! [VarCurr: state_type] :
      ( v51606(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_25905,axiom,
    ! [VarCurr: state_type] :
      ( v51557(VarCurr)
    <=> v51559(VarCurr) ) ).

tff(addAssignment_25904,axiom,
    ! [VarCurr: state_type] :
      ( v51559(VarCurr)
    <=> v51561(VarCurr) ) ).

tff(addAssignment_25903,axiom,
    ! [VarCurr: state_type] :
      ( v51561(VarCurr)
    <=> v51563(VarCurr) ) ).

tff(addAssignment_25902,axiom,
    ! [VarCurr: state_type] :
      ( v51563(VarCurr)
    <=> v51565(VarCurr) ) ).

tff(addAssignment_25901,axiom,
    ! [VarCurr: state_type] :
      ( v51565(VarCurr)
    <=> v51567(VarCurr) ) ).

tff(addAssignment_25900,axiom,
    ! [VarCurr: state_type] :
      ( v51567(VarCurr)
    <=> v51569(VarCurr) ) ).

tff(addAssignment_25899,axiom,
    ! [VarCurr: state_type] :
      ( v51569(VarCurr)
    <=> v51571(VarCurr) ) ).

tff(writeUnaryOperator_2927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51571(VarCurr)
    <=> v51585(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4784,axiom,
    ! [VarCurr: state_type] :
      ( v51585(VarCurr)
    <=> ( v51586(VarCurr)
        | v51581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4783,axiom,
    ! [VarCurr: state_type] :
      ( v51586(VarCurr)
    <=> ( v51573(VarCurr)
        | v51577(VarCurr) ) ) ).

tff(addAssignment_25898,axiom,
    ! [VarCurr: state_type] :
      ( v51581(VarCurr)
    <=> v51583(VarCurr) ) ).

tff(addAssignment_25897,axiom,
    ! [VarCurr: state_type] :
      ( v51583(VarCurr)
    <=> v51154(VarCurr,2) ) ).

tff(addAssignment_25896,axiom,
    ! [VarCurr: state_type] :
      ( v51577(VarCurr)
    <=> v51579(VarCurr) ) ).

tff(addAssignment_25895,axiom,
    ! [VarCurr: state_type] :
      ( v51579(VarCurr)
    <=> v51154(VarCurr,1) ) ).

tff(addAssignment_25894,axiom,
    ! [VarCurr: state_type] :
      ( v51573(VarCurr)
    <=> v51575(VarCurr) ) ).

tff(addAssignment_25893,axiom,
    ! [VarCurr: state_type] :
      ( v51575(VarCurr)
    <=> v51237(VarCurr,0) ) ).

tff(addAssignment_25892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51426(VarCurr,B)
      <=> v51428(VarCurr,B) ) ) ).

tff(addAssignment_25891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51428(VarCurr,B)
      <=> v51430(VarCurr,B) ) ) ).

tff(addAssignment_25890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51430(VarCurr,B)
      <=> v51432(VarCurr,B) ) ) ).

tff(addAssignment_25889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51432(VarCurr,B)
      <=> v51434(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51540(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v51434(VarNext,B)
            <=> v51434(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_600,axiom,
    ! [VarNext: state_type] :
      ( v51540(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51434(VarNext,B)
          <=> v51550(VarNext,B) ) ) ) ).

tff(addAssignment_25888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51550(VarNext,B)
          <=> v51548(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51548(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_387,axiom,
    ! [VarCurr: state_type] :
      ( v51551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51548(VarCurr,B)
          <=> v51456(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4782,axiom,
    ! [VarCurr: state_type] :
      ( v51551(VarCurr)
    <=> ( v51552(VarCurr)
        & v51553(VarCurr) ) ) ).

tff(writeUnaryOperator_2926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51553(VarCurr)
    <=> v51446(VarCurr) ) ).

tff(writeUnaryOperator_2925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51552(VarCurr)
    <=> v51436(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51540(VarNext)
      <=> v51541(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51541(VarNext)
      <=> ( v51542(VarNext)
          & v51460(VarNext) ) ) ) ).

tff(writeUnaryOperator_2924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51542(VarNext)
      <=> v51544(VarNext) ) ) ).

tff(addAssignment_25887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51544(VarNext)
      <=> v51460(VarCurr) ) ) ).

tff(addAssignment_25886,axiom,
    ! [VarCurr: state_type] :
      ( v51460(VarCurr)
    <=> v51462(VarCurr) ) ).

tff(addAssignment_25885,axiom,
    ! [VarCurr: state_type] :
      ( v51462(VarCurr)
    <=> v51464(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4779,axiom,
    ! [VarCurr: state_type] :
      ( v51464(VarCurr)
    <=> ( v51537(VarCurr)
        | v51533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4778,axiom,
    ! [VarCurr: state_type] :
      ( v51537(VarCurr)
    <=> ( v51466(VarCurr)
        & v51470(VarCurr) ) ) ).

tff(addAssignment_25884,axiom,
    ! [VarCurr: state_type] :
      ( v51533(VarCurr)
    <=> v51535(VarCurr) ) ).

tff(addAssignment_25883,axiom,
    ! [VarCurr: state_type] :
      ( v51535(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51517(VarNext)
       => ( v51470(VarNext)
        <=> v51470(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_599,axiom,
    ! [VarNext: state_type] :
      ( v51517(VarNext)
     => ( v51470(VarNext)
      <=> v51527(VarNext) ) ) ).

tff(addAssignment_25882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51527(VarNext)
      <=> v51525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4777,axiom,
    ! [VarCurr: state_type] :
      ( v51525(VarCurr)
    <=> ( v51528(VarCurr)
        & v51529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4776,axiom,
    ! [VarCurr: state_type] :
      ( v51529(VarCurr)
    <=> ( v51476(VarCurr)
        | v51512(VarCurr) ) ) ).

tff(writeUnaryOperator_2923,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51528(VarCurr)
    <=> v51472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51517(VarNext)
      <=> v51518(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51518(VarNext)
      <=> ( v51520(VarNext)
          & v51522(VarNext) ) ) ) ).

tff(writeUnaryOperator_2922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51522(VarCurr)
    <=> v51466(VarCurr) ) ).

tff(addAssignment_25881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51520(VarNext)
      <=> v51466(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_224,axiom,
    ( v51470(constB0)
  <=> $true ) ).

tff(addAssignment_25880,axiom,
    ! [VarCurr: state_type] :
      ( v51512(VarCurr)
    <=> v51514(VarCurr) ) ).

tff(addAssignment_25879,axiom,
    ! [VarCurr: state_type] :
      ( v51514(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_25878,axiom,
    ! [VarCurr: state_type] :
      ( v51476(VarCurr)
    <=> v51478(VarCurr) ) ).

tff(addAssignment_25877,axiom,
    ! [VarCurr: state_type] :
      ( v51478(VarCurr)
    <=> v51480(VarCurr) ) ).

tff(addAssignment_25876,axiom,
    ! [VarCurr: state_type] :
      ( v51480(VarCurr)
    <=> v51482(VarCurr) ) ).

tff(addAssignment_25875,axiom,
    ! [VarCurr: state_type] :
      ( v51482(VarCurr)
    <=> v51484(VarCurr) ) ).

tff(writeUnaryOperator_2921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51484(VarCurr)
    <=> v51509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4773,axiom,
    ! [VarCurr: state_type] :
      ( v51509(VarCurr)
    <=> ( v51510(VarCurr)
        | v51505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4772,axiom,
    ! [VarCurr: state_type] :
      ( v51510(VarCurr)
    <=> ( v51486(VarCurr)
        | v51501(VarCurr) ) ) ).

tff(addAssignment_25874,axiom,
    ! [VarCurr: state_type] :
      ( v51505(VarCurr)
    <=> v51507(VarCurr) ) ).

tff(addAssignment_25873,axiom,
    ! [VarCurr: state_type] :
      ( v51507(VarCurr)
    <=> v51064(VarCurr,2) ) ).

tff(addAssignment_25872,axiom,
    ! [VarCurr: state_type] :
      ( v51501(VarCurr)
    <=> v51503(VarCurr) ) ).

tff(addAssignment_25871,axiom,
    ! [VarCurr: state_type] :
      ( v51503(VarCurr)
    <=> v51064(VarCurr,1) ) ).

tff(addAssignment_25870,axiom,
    ! [VarCurr: state_type] :
      ( v51486(VarCurr)
    <=> v51488(VarCurr) ) ).

tff(addAssignment_25869,axiom,
    ! [VarCurr: state_type] :
      ( v51488(VarCurr)
    <=> v51490(VarCurr,0) ) ).

tff(addAssignment_25868,axiom,
    ! [VarCurr: state_type] :
      ( v51490(VarCurr,0)
    <=> v51492(VarCurr,0) ) ).

tff(addAssignment_25867,axiom,
    ! [VarCurr: state_type] :
      ( v51492(VarCurr,0)
    <=> v51494(VarCurr,0) ) ).

tff(addAssignment_25866,axiom,
    ! [VarCurr: state_type] :
      ( v51494(VarCurr,0)
    <=> v51499(VarCurr,0) ) ).

tff(writeUnaryOperator_2920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51499(VarCurr,B)
      <=> ~ v51496(VarCurr,B) ) ) ).

tff(addAssignment_25865,axiom,
    ! [VarCurr: state_type] :
      ( v51496(VarCurr,0)
    <=> v51498(VarCurr,0) ) ).

tff(addAssignment_25864,axiom,
    ! [VarCurr: state_type] :
      ( v51498(VarCurr,0)
    <=> v51064(VarCurr,0) ) ).

tff(addAssignment_25863,axiom,
    ! [VarCurr: state_type] :
      ( v51472(VarCurr)
    <=> v51474(VarCurr) ) ).

tff(addAssignment_25862,axiom,
    ! [VarCurr: state_type] :
      ( v51474(VarCurr)
    <=> $false ) ).

tff(addAssignment_25861,axiom,
    ! [VarCurr: state_type] :
      ( v51466(VarCurr)
    <=> v51468(VarCurr) ) ).

tff(addAssignment_25860,axiom,
    ! [VarCurr: state_type] :
      ( v51468(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_25859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51456(VarCurr,B)
      <=> v51458(VarCurr,B) ) ) ).

tff(addAssignment_25858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51458(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_25857,axiom,
    ! [VarCurr: state_type] :
      ( v51446(VarCurr)
    <=> v51448(VarCurr) ) ).

tff(addAssignment_25856,axiom,
    ! [VarCurr: state_type] :
      ( v51448(VarCurr)
    <=> v51450(VarCurr) ) ).

tff(addAssignment_25855,axiom,
    ! [VarCurr: state_type] :
      ( v51450(VarCurr)
    <=> v51452(VarCurr) ) ).

tff(addAssignment_25854,axiom,
    ! [VarCurr: state_type] :
      ( v51452(VarCurr)
    <=> v51454(VarCurr) ) ).

tff(addAssignment_25853,axiom,
    ! [VarCurr: state_type] :
      ( v51454(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_25852,axiom,
    ! [VarCurr: state_type] :
      ( v51436(VarCurr)
    <=> v51438(VarCurr) ) ).

tff(addAssignment_25851,axiom,
    ! [VarCurr: state_type] :
      ( v51438(VarCurr)
    <=> v51440(VarCurr) ) ).

tff(addAssignment_25850,axiom,
    ! [VarCurr: state_type] :
      ( v51440(VarCurr)
    <=> v51442(VarCurr) ) ).

tff(addAssignment_25849,axiom,
    ! [VarCurr: state_type] :
      ( v51442(VarCurr)
    <=> v51444(VarCurr) ) ).

tff(addAssignment_25848,axiom,
    ! [VarCurr: state_type] :
      ( v51444(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_25847,axiom,
    ! [VarCurr: state_type] :
      ( v51134(VarCurr)
    <=> v51136(VarCurr) ) ).

tff(addAssignment_25846,axiom,
    ! [VarCurr: state_type] :
      ( v51136(VarCurr)
    <=> v51138(VarCurr) ) ).

tff(addAssignment_25845,axiom,
    ! [VarCurr: state_type] :
      ( v51138(VarCurr)
    <=> v51140(VarCurr) ) ).

tff(addAssignment_25844,axiom,
    ! [VarCurr: state_type] :
      ( v51140(VarCurr)
    <=> v51142(VarCurr) ) ).

tff(addAssignment_25843,axiom,
    ! [VarCurr: state_type] :
      ( v51142(VarCurr)
    <=> v51144(VarCurr) ) ).

tff(addAssignment_25842,axiom,
    ! [VarCurr: state_type] :
      ( v51144(VarCurr)
    <=> v51146(VarCurr) ) ).

tff(addAssignment_25841,axiom,
    ! [VarCurr: state_type] :
      ( v51146(VarCurr)
    <=> v51148(VarCurr) ) ).

tff(writeUnaryOperator_2919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51148(VarCurr)
    <=> v51423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4771,axiom,
    ! [VarCurr: state_type] :
      ( v51423(VarCurr)
    <=> ( v51424(VarCurr)
        | v51419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4770,axiom,
    ! [VarCurr: state_type] :
      ( v51424(VarCurr)
    <=> ( v51150(VarCurr)
        | v51415(VarCurr) ) ) ).

tff(addAssignment_25840,axiom,
    ! [VarCurr: state_type] :
      ( v51419(VarCurr)
    <=> v51421(VarCurr) ) ).

tff(addAssignment_25839,axiom,
    ! [VarCurr: state_type] :
      ( v51421(VarCurr)
    <=> v51154(VarCurr,2) ) ).

tff(addAssignment_25838,axiom,
    ! [VarCurr: state_type] :
      ( v51415(VarCurr)
    <=> v51417(VarCurr) ) ).

tff(addAssignment_25837,axiom,
    ! [VarCurr: state_type] :
      ( v51417(VarCurr)
    <=> v51154(VarCurr,1) ) ).

tff(addAssignment_25836,axiom,
    ! [VarCurr: state_type] :
      ( v51150(VarCurr)
    <=> v51152(VarCurr) ) ).

tff(addAssignment_25835,axiom,
    ! [VarCurr: state_type] :
      ( v51152(VarCurr)
    <=> v51154(VarCurr,0) ) ).

tff(addAssignment_25834,axiom,
    ! [VarCurr: state_type] :
      ( v51154(VarCurr,0)
    <=> v51066(VarCurr,3) ) ).

tff(addAssignment_25833,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,3)
    <=> v51068(VarCurr,3) ) ).

tff(addAssignment_25832,axiom,
    ! [VarNext: state_type] :
      ( v51068(VarNext,3)
    <=> v51407(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51408(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v51407(VarNext,B)
            <=> v51068(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_598,axiom,
    ! [VarNext: state_type] :
      ( v51408(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51407(VarNext,B)
          <=> v51379(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51408(VarNext)
      <=> v51409(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51409(VarNext)
      <=> ( v51411(VarNext)
          & v51321(VarNext) ) ) ) ).

tff(writeUnaryOperator_2918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51411(VarNext)
      <=> v51373(VarNext) ) ) ).

tff(addAssignment_25831,axiom,
    ! [VarCurr: state_type] :
      ( v51178(VarCurr,3)
    <=> v51180(VarCurr,3) ) ).

tff(addAssignment_25830,axiom,
    ! [VarCurr: state_type] :
      ( v51180(VarCurr,3)
    <=> v51318(VarCurr,3) ) ).

tff(addAssignment_25829,axiom,
    ! [VarCurr: state_type] :
      ( v51182(VarCurr,0)
    <=> v51184(VarCurr,0) ) ).

tff(addAssignment_25828,axiom,
    ! [VarCurr: state_type] :
      ( v51184(VarCurr,0)
    <=> v51186(VarCurr,0) ) ).

tff(addAssignment_25827,axiom,
    ! [VarCurr: state_type] :
      ( v51186(VarCurr,0)
    <=> v51317(VarCurr,0) ) ).

tff(addAssignment_25826,axiom,
    ! [VarCurr: state_type] :
      ( v51254(VarCurr,0)
    <=> v51256(VarCurr,0) ) ).

tff(addAssignment_25825,axiom,
    ! [VarCurr: state_type] :
      ( v51256(VarCurr,0)
    <=> v51258(VarCurr,0) ) ).

tff(addAssignment_25824,axiom,
    ! [VarCurr: state_type] :
      ( v51258(VarCurr,0)
    <=> v51260(VarCurr,0) ) ).

tff(addAssignment_25823,axiom,
    ! [VarCurr: state_type] :
      ( v51260(VarCurr,0)
    <=> v51262(VarCurr,0) ) ).

tff(addAssignment_25822,axiom,
    ! [VarCurr: state_type] :
      ( v51262(VarCurr,0)
    <=> v51272(VarCurr,0) ) ).

tff(addAssignment_25821,axiom,
    ! [VarCurr: state_type] :
      ( v51188(VarCurr,0)
    <=> v51190(VarCurr,0) ) ).

tff(addAssignment_25820,axiom,
    ! [VarCurr: state_type] :
      ( v51190(VarCurr,0)
    <=> v51251(VarCurr,0) ) ).

tff(addAssignment_25819,axiom,
    ! [VarCurr: state_type] :
      ( v51192(VarCurr)
    <=> v51009(VarCurr,2) ) ).

tff(addAssignment_25818,axiom,
    ! [VarCurr: state_type] :
      ( v51009(VarCurr,2)
    <=> v51011(VarCurr,2) ) ).

tff(addAssignment_25817,axiom,
    ! [VarCurr: state_type] :
      ( v51011(VarCurr,2)
    <=> v51021(VarCurr,2) ) ).

tff(addAssignment_25816,axiom,
    ! [VarCurr: state_type] :
      ( v51013(VarCurr,2)
    <=> v51015(VarCurr,2) ) ).

tff(addAssignment_25815,axiom,
    ! [VarCurr: state_type] :
      ( v51015(VarCurr,2)
    <=> v51018(VarCurr,2) ) ).

tff(addAssignment_25814,axiom,
    ! [VarCurr: state_type] :
      ( v51019(VarCurr)
    <=> v51195(VarCurr,1) ) ).

tff(addAssignment_25813,axiom,
    ! [VarCurr: state_type] :
      ( v51195(VarCurr,1)
    <=> v51197(VarCurr,1) ) ).

tff(addAssignment_25812,axiom,
    ! [VarCurr: state_type] :
      ( v51197(VarCurr,1)
    <=> v51405(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v51405(VarCurr,B)
      <=> ( v51199(VarCurr,B)
          | v51205(VarCurr,B) ) ) ) ).

tff(addAssignment_25811,axiom,
    ! [VarCurr: state_type] :
      ( v51205(VarCurr,1)
    <=> v51207(VarCurr,1) ) ).

tff(addAssignment_25810,axiom,
    ! [VarCurr: state_type] :
      ( v51207(VarCurr,1)
    <=> v51403(VarCurr,1) ) ).

tff(addAssignment_25809,axiom,
    ! [VarCurr: state_type] :
      ( v51403(VarCurr,0)
    <=> v51404(VarCurr) ) ).

tff(addAssignment_25808,axiom,
    ! [VarCurr: state_type] :
      ( v51403(VarCurr,1)
    <=> v51209(VarCurr) ) ).

tff(addAssignment_25807,axiom,
    ! [VarCurr: state_type] :
      ( v51209(VarCurr)
    <=> v51211(VarCurr,1) ) ).

tff(addAssignment_25806,axiom,
    ! [VarCurr: state_type] :
      ( v51211(VarCurr,1)
    <=> v51213(VarCurr,1) ) ).

tff(addAssignment_25805,axiom,
    ! [VarCurr: state_type] :
      ( v51213(VarCurr,1)
    <=> v51402(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v51402(VarCurr,B)
      <=> ( v51215(VarCurr,B)
          & v51223(VarCurr,B) ) ) ) ).

tff(addAssignment_25804,axiom,
    ! [VarCurr: state_type] :
      ( v51223(VarCurr,1)
    <=> v51225(VarCurr,1) ) ).

tff(addAssignment_25803,axiom,
    ! [VarCurr: state_type] :
      ( v51225(VarCurr,1)
    <=> v51400(VarCurr,1) ) ).

tff(addAssignment_25802,axiom,
    ! [VarCurr: state_type] :
      ( v51400(VarCurr,0)
    <=> v51401(VarCurr) ) ).

tff(addAssignment_25801,axiom,
    ! [VarCurr: state_type] :
      ( v51400(VarCurr,1)
    <=> v51227(VarCurr) ) ).

tff(addAssignment_25800,axiom,
    ! [VarCurr: state_type] :
      ( v51227(VarCurr)
    <=> v51229(VarCurr) ) ).

tff(addAssignment_25799,axiom,
    ! [VarCurr: state_type] :
      ( v51229(VarCurr)
    <=> v51231(VarCurr) ) ).

tff(writeUnaryOperator_2917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51231(VarCurr)
    <=> v51398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4767,axiom,
    ! [VarCurr: state_type] :
      ( v51398(VarCurr)
    <=> ( v51399(VarCurr)
        | v51386(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4766,axiom,
    ! [VarCurr: state_type] :
      ( v51399(VarCurr)
    <=> ( v51233(VarCurr)
        | v51248(VarCurr) ) ) ).

tff(addAssignment_25798,axiom,
    ! [VarCurr: state_type] :
      ( v51386(VarCurr)
    <=> v51388(VarCurr) ) ).

tff(addAssignment_25797,axiom,
    ! [VarCurr: state_type] :
      ( v51388(VarCurr)
    <=> v51237(VarCurr,2) ) ).

tff(addAssignment_25796,axiom,
    ! [VarCurr: state_type] :
      ( v51237(VarCurr,2)
    <=> v51239(VarCurr,2) ) ).

tff(addAssignment_25795,axiom,
    ! [VarCurr: state_type] :
      ( v51239(VarCurr,2)
    <=> v51241(VarCurr,2) ) ).

tff(addAssignment_25794,axiom,
    ! [VarCurr: state_type] :
      ( v51241(VarCurr,2)
    <=> v51246(VarCurr,2) ) ).

tff(addAssignment_25793,axiom,
    ! [VarCurr: state_type] :
      ( v51243(VarCurr,2)
    <=> v51245(VarCurr,2) ) ).

tff(addAssignment_25792,axiom,
    ! [VarCurr: state_type] :
      ( v51245(VarCurr,2)
    <=> v51154(VarCurr,2) ) ).

tff(addAssignment_25791,axiom,
    ! [VarCurr: state_type] :
      ( v51154(VarCurr,2)
    <=> v51066(VarCurr,5) ) ).

tff(addAssignment_25790,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,5)
    <=> v51068(VarCurr,5) ) ).

tff(addAssignment_25789,axiom,
    ! [VarNext: state_type] :
      ( v51068(VarNext,5)
    <=> v51390(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51391(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v51390(VarNext,B)
            <=> v51068(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_597,axiom,
    ! [VarNext: state_type] :
      ( v51391(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51390(VarNext,B)
          <=> v51379(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51391(VarNext)
      <=> v51392(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51392(VarNext)
      <=> ( v51394(VarNext)
          & v51321(VarNext) ) ) ) ).

tff(writeUnaryOperator_2916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51394(VarNext)
      <=> v51373(VarNext) ) ) ).

tff(addAssignment_25788,axiom,
    ! [VarCurr: state_type] :
      ( v51178(VarCurr,5)
    <=> v51180(VarCurr,5) ) ).

tff(addAssignment_25787,axiom,
    ! [VarCurr: state_type] :
      ( v51180(VarCurr,5)
    <=> v51318(VarCurr,5) ) ).

tff(addAssignment_25786,axiom,
    ! [VarCurr: state_type] :
      ( v51182(VarCurr,2)
    <=> v51184(VarCurr,2) ) ).

tff(addAssignment_25785,axiom,
    ! [VarCurr: state_type] :
      ( v51184(VarCurr,2)
    <=> v51186(VarCurr,2) ) ).

tff(addAssignment_25784,axiom,
    ! [VarCurr: state_type] :
      ( v51186(VarCurr,2)
    <=> v51317(VarCurr,2) ) ).

tff(addAssignment_25783,axiom,
    ! [VarCurr: state_type] :
      ( v51254(VarCurr,2)
    <=> v51256(VarCurr,2) ) ).

tff(addAssignment_25782,axiom,
    ! [VarCurr: state_type] :
      ( v51256(VarCurr,2)
    <=> v51258(VarCurr,2) ) ).

tff(addAssignment_25781,axiom,
    ! [VarCurr: state_type] :
      ( v51258(VarCurr,2)
    <=> v51260(VarCurr,2) ) ).

tff(addAssignment_25780,axiom,
    ! [VarCurr: state_type] :
      ( v51260(VarCurr,2)
    <=> v51262(VarCurr,2) ) ).

tff(addAssignment_25779,axiom,
    ! [VarCurr: state_type] :
      ( v51262(VarCurr,2)
    <=> v51272(VarCurr,2) ) ).

tff(addAssignment_25778,axiom,
    ! [VarCurr: state_type] :
      ( v51264(VarCurr,2)
    <=> v51266(VarCurr,2) ) ).

tff(addAssignment_25777,axiom,
    ! [VarCurr: state_type] :
      ( v51266(VarCurr,2)
    <=> v51267(VarCurr,2) ) ).

tff(addAssignment_25776,axiom,
    ! [VarCurr: state_type] :
      ( v51188(VarCurr,2)
    <=> v51190(VarCurr,2) ) ).

tff(addAssignment_25775,axiom,
    ! [VarCurr: state_type] :
      ( v51190(VarCurr,2)
    <=> v51251(VarCurr,2) ) ).

tff(addAssignment_25774,axiom,
    ! [VarCurr: state_type] :
      ( v51248(VarCurr)
    <=> v51250(VarCurr) ) ).

tff(addAssignment_25773,axiom,
    ! [VarCurr: state_type] :
      ( v51250(VarCurr)
    <=> v51154(VarCurr,1) ) ).

tff(addAssignment_25772,axiom,
    ! [VarCurr: state_type] :
      ( v51154(VarCurr,1)
    <=> v51066(VarCurr,4) ) ).

tff(addAssignment_25771,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,4)
    <=> v51068(VarCurr,4) ) ).

tff(addAssignment_25770,axiom,
    ! [VarNext: state_type] :
      ( v51068(VarNext,4)
    <=> v51368(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51369(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v51368(VarNext,B)
            <=> v51068(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_596,axiom,
    ! [VarNext: state_type] :
      ( v51369(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51368(VarNext,B)
          <=> v51379(VarNext,B) ) ) ) ).

tff(addAssignment_25769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51379(VarNext,B)
          <=> v51377(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51377(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_386,axiom,
    ! [VarCurr: state_type] :
      ( v51380(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v51377(VarCurr,B)
          <=> v51178(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4763,axiom,
    ! [VarCurr: state_type] :
      ( v51380(VarCurr)
    <=> ( v51381(VarCurr)
        & v51382(VarCurr) ) ) ).

tff(writeUnaryOperator_2915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51382(VarCurr)
    <=> v51168(VarCurr) ) ).

tff(writeUnaryOperator_2914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51381(VarCurr)
    <=> v51156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51369(VarNext)
      <=> v51370(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51370(VarNext)
      <=> ( v51371(VarNext)
          & v51321(VarNext) ) ) ) ).

tff(writeUnaryOperator_2913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51371(VarNext)
      <=> v51373(VarNext) ) ) ).

tff(addAssignment_25768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51373(VarNext)
      <=> v51321(VarCurr) ) ) ).

tff(addAssignment_25767,axiom,
    ! [VarCurr: state_type] :
      ( v51321(VarCurr)
    <=> v51323(VarCurr) ) ).

tff(addAssignment_25766,axiom,
    ! [VarCurr: state_type] :
      ( v51323(VarCurr)
    <=> v51325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4760,axiom,
    ! [VarCurr: state_type] :
      ( v51325(VarCurr)
    <=> ( v51366(VarCurr)
        | v51362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4759,axiom,
    ! [VarCurr: state_type] :
      ( v51366(VarCurr)
    <=> ( v51327(VarCurr)
        & v51331(VarCurr) ) ) ).

tff(addAssignment_25765,axiom,
    ! [VarCurr: state_type] :
      ( v51362(VarCurr)
    <=> v51364(VarCurr) ) ).

tff(addAssignment_25764,axiom,
    ! [VarCurr: state_type] :
      ( v51364(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51346(VarNext)
       => ( v51331(VarNext)
        <=> v51331(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_595,axiom,
    ! [VarNext: state_type] :
      ( v51346(VarNext)
     => ( v51331(VarNext)
      <=> v51356(VarNext) ) ) ).

tff(addAssignment_25763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51356(VarNext)
      <=> v51354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4758,axiom,
    ! [VarCurr: state_type] :
      ( v51354(VarCurr)
    <=> ( v51357(VarCurr)
        & v51358(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4757,axiom,
    ! [VarCurr: state_type] :
      ( v51358(VarCurr)
    <=> ( v51337(VarCurr)
        | v51341(VarCurr) ) ) ).

tff(writeUnaryOperator_2912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51357(VarCurr)
    <=> v51333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51346(VarNext)
      <=> v51347(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51347(VarNext)
      <=> ( v51349(VarNext)
          & v51351(VarNext) ) ) ) ).

tff(writeUnaryOperator_2911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51351(VarCurr)
    <=> v51327(VarCurr) ) ).

tff(addAssignment_25762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51349(VarNext)
      <=> v51327(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_223,axiom,
    ( v51331(constB0)
  <=> $true ) ).

tff(addAssignment_25761,axiom,
    ! [VarCurr: state_type] :
      ( v51341(VarCurr)
    <=> v51343(VarCurr) ) ).

tff(addAssignment_25760,axiom,
    ! [VarCurr: state_type] :
      ( v51343(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_25759,axiom,
    ! [VarCurr: state_type] :
      ( v51337(VarCurr)
    <=> v51339(VarCurr) ) ).

tff(addAssignment_25758,axiom,
    ! [VarCurr: state_type] :
      ( v51339(VarCurr)
    <=> $true ) ).

tff(addAssignment_25757,axiom,
    ! [VarCurr: state_type] :
      ( v51333(VarCurr)
    <=> v51335(VarCurr) ) ).

tff(addAssignment_25756,axiom,
    ! [VarCurr: state_type] :
      ( v51335(VarCurr)
    <=> $false ) ).

tff(addAssignment_25755,axiom,
    ! [VarCurr: state_type] :
      ( v51327(VarCurr)
    <=> v51329(VarCurr) ) ).

tff(addAssignment_25754,axiom,
    ! [VarCurr: state_type] :
      ( v51329(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_25753,axiom,
    ! [VarCurr: state_type] :
      ( v51178(VarCurr,4)
    <=> v51180(VarCurr,4) ) ).

tff(addAssignment_25752,axiom,
    ! [VarCurr: state_type] :
      ( v51180(VarCurr,4)
    <=> v51318(VarCurr,4) ) ).

tff(addAssignment_25751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51318(VarCurr,B)
      <=> v51319(VarCurr,B) ) ) ).

tff(addAssignment_25750,axiom,
    ! [VarCurr: state_type] :
      ( ( v51318(VarCurr,5)
      <=> v51182(VarCurr,2) )
      & ( v51318(VarCurr,4)
      <=> v51182(VarCurr,1) )
      & ( v51318(VarCurr,3)
      <=> v51182(VarCurr,0) ) ) ).

tff(addAssignment_25749,axiom,
    ! [VarCurr: state_type] :
      ( v51182(VarCurr,1)
    <=> v51184(VarCurr,1) ) ).

tff(addAssignment_25748,axiom,
    ! [VarCurr: state_type] :
      ( v51184(VarCurr,1)
    <=> v51186(VarCurr,1) ) ).

tff(addAssignment_25747,axiom,
    ! [VarCurr: state_type] :
      ( v51186(VarCurr,1)
    <=> v51317(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51317(VarCurr,B)
      <=> ( v51188(VarCurr,B)
          & v51254(VarCurr,B) ) ) ) ).

tff(addAssignment_25746,axiom,
    ! [VarCurr: state_type] :
      ( v51254(VarCurr,1)
    <=> v51256(VarCurr,1) ) ).

tff(addAssignment_25745,axiom,
    ! [VarCurr: state_type] :
      ( v51256(VarCurr,1)
    <=> v51258(VarCurr,1) ) ).

tff(addAssignment_25744,axiom,
    ! [VarCurr: state_type] :
      ( v51258(VarCurr,1)
    <=> v51260(VarCurr,1) ) ).

tff(addAssignment_25743,axiom,
    ! [VarCurr: state_type] :
      ( v51260(VarCurr,1)
    <=> v51262(VarCurr,1) ) ).

tff(addAssignment_25742,axiom,
    ! [VarCurr: state_type] :
      ( v51262(VarCurr,1)
    <=> v51272(VarCurr,1) ) ).

tff(addAssignment_25741,axiom,
    ! [VarCurr: state_type] :
      ( v51272(VarCurr,0)
    <=> v51312(VarCurr) ) ).

tff(addAssignment_25740,axiom,
    ! [VarCurr: state_type] :
      ( v51272(VarCurr,1)
    <=> v51307(VarCurr) ) ).

tff(addAssignment_25739,axiom,
    ! [VarCurr: state_type] :
      ( v51272(VarCurr,2)
    <=> v51302(VarCurr) ) ).

tff(addAssignment_25738,axiom,
    ! [VarCurr: state_type] :
      ( v51272(VarCurr,3)
    <=> v51274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4754,axiom,
    ! [VarCurr: state_type] :
      ( v51312(VarCurr)
    <=> ( v51313(VarCurr)
        & v51316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4753,axiom,
    ! [VarCurr: state_type] :
      ( v51316(VarCurr)
    <=> ( v51264(VarCurr,0)
        | v51282(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4752,axiom,
    ! [VarCurr: state_type] :
      ( v51313(VarCurr)
    <=> ( v51314(VarCurr)
        | v51315(VarCurr) ) ) ).

tff(writeUnaryOperator_2910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51315(VarCurr)
    <=> v51282(VarCurr,0) ) ).

tff(writeUnaryOperator_2909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51314(VarCurr)
    <=> v51264(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4751,axiom,
    ! [VarCurr: state_type] :
      ( v51307(VarCurr)
    <=> ( v51308(VarCurr)
        & v51311(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4750,axiom,
    ! [VarCurr: state_type] :
      ( v51311(VarCurr)
    <=> ( v51281(VarCurr)
        | v51283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4749,axiom,
    ! [VarCurr: state_type] :
      ( v51308(VarCurr)
    <=> ( v51309(VarCurr)
        | v51310(VarCurr) ) ) ).

tff(writeUnaryOperator_2908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51310(VarCurr)
    <=> v51283(VarCurr) ) ).

tff(writeUnaryOperator_2907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51309(VarCurr)
    <=> v51281(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4748,axiom,
    ! [VarCurr: state_type] :
      ( v51302(VarCurr)
    <=> ( v51303(VarCurr)
        & v51306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4747,axiom,
    ! [VarCurr: state_type] :
      ( v51306(VarCurr)
    <=> ( v51279(VarCurr)
        | v51289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4746,axiom,
    ! [VarCurr: state_type] :
      ( v51303(VarCurr)
    <=> ( v51304(VarCurr)
        | v51305(VarCurr) ) ) ).

tff(writeUnaryOperator_2906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51305(VarCurr)
    <=> v51289(VarCurr) ) ).

tff(writeUnaryOperator_2905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51304(VarCurr)
    <=> v51279(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4745,axiom,
    ! [VarCurr: state_type] :
      ( v51274(VarCurr)
    <=> ( v51275(VarCurr)
        & v51301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4744,axiom,
    ! [VarCurr: state_type] :
      ( v51301(VarCurr)
    <=> ( v51277(VarCurr)
        | v51296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4743,axiom,
    ! [VarCurr: state_type] :
      ( v51275(VarCurr)
    <=> ( v51276(VarCurr)
        | v51295(VarCurr) ) ) ).

tff(writeUnaryOperator_2904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51295(VarCurr)
    <=> v51296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4742,axiom,
    ! [VarCurr: state_type] :
      ( v51296(VarCurr)
    <=> ( v51297(VarCurr)
        & v51300(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_553,axiom,
    ! [VarCurr: state_type] :
      ( v51300(VarCurr)
    <=> ( v51264(VarCurr,3)
        | v51282(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4741,axiom,
    ! [VarCurr: state_type] :
      ( v51297(VarCurr)
    <=> ( v51298(VarCurr)
        | v51299(VarCurr) ) ) ).

tff(writeUnaryOperator_2903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51299(VarCurr)
    <=> v51282(VarCurr,3) ) ).

tff(writeUnaryOperator_2902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51298(VarCurr)
    <=> v51264(VarCurr,3) ) ).

tff(writeUnaryOperator_2901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51276(VarCurr)
    <=> v51277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4740,axiom,
    ! [VarCurr: state_type] :
      ( v51277(VarCurr)
    <=> ( v51278(VarCurr)
        | v51294(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_552,axiom,
    ! [VarCurr: state_type] :
      ( v51294(VarCurr)
    <=> ( v51264(VarCurr,2)
        & v51282(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4739,axiom,
    ! [VarCurr: state_type] :
      ( v51278(VarCurr)
    <=> ( v51279(VarCurr)
        & v51289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4738,axiom,
    ! [VarCurr: state_type] :
      ( v51289(VarCurr)
    <=> ( v51290(VarCurr)
        & v51293(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_551,axiom,
    ! [VarCurr: state_type] :
      ( v51293(VarCurr)
    <=> ( v51264(VarCurr,2)
        | v51282(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4737,axiom,
    ! [VarCurr: state_type] :
      ( v51290(VarCurr)
    <=> ( v51291(VarCurr)
        | v51292(VarCurr) ) ) ).

tff(writeUnaryOperator_2900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51292(VarCurr)
    <=> v51282(VarCurr,2) ) ).

tff(writeUnaryOperator_2899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51291(VarCurr)
    <=> v51264(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4736,axiom,
    ! [VarCurr: state_type] :
      ( v51279(VarCurr)
    <=> ( v51280(VarCurr)
        | v51288(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_550,axiom,
    ! [VarCurr: state_type] :
      ( v51288(VarCurr)
    <=> ( v51264(VarCurr,1)
        & v51282(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4735,axiom,
    ! [VarCurr: state_type] :
      ( v51280(VarCurr)
    <=> ( v51281(VarCurr)
        & v51283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4734,axiom,
    ! [VarCurr: state_type] :
      ( v51283(VarCurr)
    <=> ( v51284(VarCurr)
        & v51287(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_549,axiom,
    ! [VarCurr: state_type] :
      ( v51287(VarCurr)
    <=> ( v51264(VarCurr,1)
        | v51282(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4733,axiom,
    ! [VarCurr: state_type] :
      ( v51284(VarCurr)
    <=> ( v51285(VarCurr)
        | v51286(VarCurr) ) ) ).

tff(writeUnaryOperator_2898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51286(VarCurr)
    <=> v51282(VarCurr,1) ) ).

tff(writeUnaryOperator_2897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51285(VarCurr)
    <=> v51264(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4732,axiom,
    ! [VarCurr: state_type] :
      ( v51281(VarCurr)
    <=> ( v51264(VarCurr,0)
        & v51282(VarCurr,0) ) ) ).

tff(addAssignment_25737,axiom,
    ! [VarCurr: state_type] :
      ( v51282(VarCurr,0)
    <=> v51269(VarCurr) ) ).

tff(addAssignment_25736,axiom,
    ! [VarCurr: state_type] :
      ( ( v51282(VarCurr,3)
      <=> $false )
      & ( v51282(VarCurr,2)
      <=> $false )
      & ( v51282(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_25735,axiom,
    ! [VarCurr: state_type] :
      ( v51269(VarCurr)
    <=> v51271(VarCurr) ) ).

tff(addAssignment_25734,axiom,
    ! [VarCurr: state_type] :
      ( v51271(VarCurr)
    <=> v51219(VarCurr) ) ).

tff(addAssignment_25733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v51264(VarCurr,B)
      <=> v51266(VarCurr,B) ) ) ).

tff(addAssignment_25732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v51266(VarCurr,B)
      <=> v51267(VarCurr,B) ) ) ).

tff(addAssignment_25731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51267(VarCurr,B)
      <=> v51154(VarCurr,B) ) ) ).

tff(addAssignment_25730,axiom,
    ! [VarCurr: state_type] :
      ( v51267(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_25729,axiom,
    ! [VarCurr: state_type] :
      ( v51188(VarCurr,1)
    <=> v51190(VarCurr,1) ) ).

tff(addAssignment_25728,axiom,
    ! [VarCurr: state_type] :
      ( v51190(VarCurr,1)
    <=> v51251(VarCurr,1) ) ).

tff(addAssignment_25727,axiom,
    ! [VarCurr: state_type] :
      ( v51251(VarCurr,0)
    <=> v51252(VarCurr) ) ).

tff(addAssignment_25726,axiom,
    ! [VarCurr: state_type] :
      ( v51251(VarCurr,1)
    <=> v51252(VarCurr) ) ).

tff(addAssignment_25725,axiom,
    ! [VarCurr: state_type] :
      ( v51251(VarCurr,2)
    <=> v51252(VarCurr) ) ).

tff(addAssignment_25724,axiom,
    ! [VarCurr: state_type] :
      ( v51252(VarCurr)
    <=> v51192(VarCurr) ) ).

tff(addAssignment_25723,axiom,
    ! [VarCurr: state_type] :
      ( v51233(VarCurr)
    <=> v51235(VarCurr) ) ).

tff(addAssignment_25722,axiom,
    ! [VarCurr: state_type] :
      ( v51235(VarCurr)
    <=> v51237(VarCurr,0) ) ).

tff(addAssignment_25721,axiom,
    ! [VarCurr: state_type] :
      ( v51237(VarCurr,0)
    <=> v51239(VarCurr,0) ) ).

tff(addAssignment_25720,axiom,
    ! [VarCurr: state_type] :
      ( v51239(VarCurr,0)
    <=> v51241(VarCurr,0) ) ).

tff(addAssignment_25719,axiom,
    ! [VarCurr: state_type] :
      ( v51241(VarCurr,0)
    <=> v51246(VarCurr,0) ) ).

tff(writeUnaryOperator_2896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51246(VarCurr,B)
      <=> ~ v51243(VarCurr,B) ) ) ).

tff(addAssignment_25718,axiom,
    ! [VarCurr: state_type] :
      ( v51243(VarCurr,0)
    <=> v51245(VarCurr,0) ) ).

tff(addAssignment_25717,axiom,
    ! [VarCurr: state_type] :
      ( v51245(VarCurr,0)
    <=> v51154(VarCurr,0) ) ).

tff(addAssignment_25716,axiom,
    ! [VarCurr: state_type] :
      ( v51215(VarCurr,1)
    <=> v51217(VarCurr,1) ) ).

tff(addAssignment_25715,axiom,
    ! [VarCurr: state_type] :
      ( v51217(VarCurr,1)
    <=> v51220(VarCurr,1) ) ).

tff(addAssignment_25714,axiom,
    ! [VarCurr: state_type] :
      ( v51220(VarCurr,0)
    <=> v51221(VarCurr) ) ).

tff(addAssignment_25713,axiom,
    ! [VarCurr: state_type] :
      ( v51220(VarCurr,1)
    <=> v51219(VarCurr) ) ).

tff(addAssignment_25712,axiom,
    ! [VarCurr: state_type] :
      ( v51219(VarCurr)
    <=> v7230(VarCurr,13) ) ).

tff(addAssignment_25711,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,13)
    <=> v7232(VarCurr,13) ) ).

tff(addAssignment_25710,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,13)
    <=> v7234(VarCurr,13) ) ).

tff(addAssignment_25709,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,13)
    <=> v34455(VarCurr,13) ) ).

tff(addAssignment_25708,axiom,
    ! [VarCurr: state_type] :
      ( v51199(VarCurr,1)
    <=> v51201(VarCurr,1) ) ).

tff(addAssignment_25707,axiom,
    ! [VarCurr: state_type] :
      ( v51201(VarCurr,1)
    <=> v51202(VarCurr,1) ) ).

tff(addAssignment_25706,axiom,
    ! [VarCurr: state_type] :
      ( v51202(VarCurr,0)
    <=> v51203(VarCurr) ) ).

tff(addAssignment_25705,axiom,
    ! [VarCurr: state_type] :
      ( v51202(VarCurr,1)
    <=> v51203(VarCurr) ) ).

tff(addAssignment_25704,axiom,
    ! [VarCurr: state_type] :
      ( v51203(VarCurr)
    <=> v51017(VarCurr) ) ).

tff(addAssignment_25703,axiom,
    ! [VarCurr: state_type] :
      ( v51168(VarCurr)
    <=> v51170(VarCurr) ) ).

tff(addAssignment_25702,axiom,
    ! [VarCurr: state_type] :
      ( v51170(VarCurr)
    <=> v51172(VarCurr) ) ).

tff(addAssignment_25701,axiom,
    ! [VarCurr: state_type] :
      ( v51172(VarCurr)
    <=> v51174(VarCurr) ) ).

tff(addAssignment_25700,axiom,
    ! [VarCurr: state_type] :
      ( v51174(VarCurr)
    <=> v51176(VarCurr) ) ).

tff(addAssignment_25699,axiom,
    ! [VarCurr: state_type] :
      ( v51176(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_25698,axiom,
    ! [VarCurr: state_type] :
      ( v51156(VarCurr)
    <=> v51158(VarCurr) ) ).

tff(addAssignment_25697,axiom,
    ! [VarCurr: state_type] :
      ( v51158(VarCurr)
    <=> v51160(VarCurr) ) ).

tff(addAssignment_25696,axiom,
    ! [VarCurr: state_type] :
      ( v51160(VarCurr)
    <=> v51162(VarCurr) ) ).

tff(addAssignment_25695,axiom,
    ! [VarCurr: state_type] :
      ( v51162(VarCurr)
    <=> v51164(VarCurr) ) ).

tff(addAssignment_25694,axiom,
    ! [VarCurr: state_type] :
      ( v51164(VarCurr)
    <=> v51166(VarCurr) ) ).

tff(addAssignment_25693,axiom,
    ! [VarCurr: state_type] :
      ( v51166(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_25692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50955(VarCurr,B)
      <=> v50957(VarCurr,B) ) ) ).

tff(addAssignment_25691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50957(VarCurr,B)
      <=> v50959(VarCurr,B) ) ) ).

tff(addAssignment_25690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50959(VarCurr,B)
      <=> v50961(VarCurr,B) ) ) ).

tff(addAssignment_25689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50961(VarCurr,B)
      <=> v50963(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51117(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50963(VarNext,B)
            <=> v50963(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_594,axiom,
    ! [VarNext: state_type] :
      ( v51117(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50963(VarNext,B)
          <=> v51127(VarNext,B) ) ) ) ).

tff(addAssignment_25688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51127(VarNext,B)
          <=> v51125(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51128(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51125(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_385,axiom,
    ! [VarCurr: state_type] :
      ( v51128(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v51125(VarCurr,B)
          <=> v50993(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4731,axiom,
    ! [VarCurr: state_type] :
      ( v51128(VarCurr)
    <=> ( v51129(VarCurr)
        & v51130(VarCurr) ) ) ).

tff(writeUnaryOperator_2895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51130(VarCurr)
    <=> v50979(VarCurr) ) ).

tff(writeUnaryOperator_2894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51129(VarCurr)
    <=> v50965(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51117(VarNext)
      <=> v51118(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51118(VarNext)
      <=> ( v51119(VarNext)
          & v51032(VarNext) ) ) ) ).

tff(writeUnaryOperator_2893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51119(VarNext)
      <=> v51121(VarNext) ) ) ).

tff(addAssignment_25687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51121(VarNext)
      <=> v51032(VarCurr) ) ) ).

tff(addAssignment_25686,axiom,
    ! [VarCurr: state_type] :
      ( v51032(VarCurr)
    <=> v51034(VarCurr) ) ).

tff(addAssignment_25685,axiom,
    ! [VarCurr: state_type] :
      ( v51034(VarCurr)
    <=> v51036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4728,axiom,
    ! [VarCurr: state_type] :
      ( v51036(VarCurr)
    <=> ( v51114(VarCurr)
        | v51106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4727,axiom,
    ! [VarCurr: state_type] :
      ( v51114(VarCurr)
    <=> ( v51038(VarCurr)
        & v51044(VarCurr) ) ) ).

tff(addAssignment_25684,axiom,
    ! [VarCurr: state_type] :
      ( v51106(VarCurr)
    <=> v51108(VarCurr) ) ).

tff(addAssignment_25683,axiom,
    ! [VarCurr: state_type] :
      ( v51108(VarCurr)
    <=> v51110(VarCurr) ) ).

tff(addAssignment_25682,axiom,
    ! [VarCurr: state_type] :
      ( v51110(VarCurr)
    <=> v51112(VarCurr) ) ).

tff(addAssignment_25681,axiom,
    ! [VarCurr: state_type] :
      ( v51112(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v51090(VarNext)
       => ( v51044(VarNext)
        <=> v51044(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_593,axiom,
    ! [VarNext: state_type] :
      ( v51090(VarNext)
     => ( v51044(VarNext)
      <=> v51100(VarNext) ) ) ).

tff(addAssignment_25680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51100(VarNext)
      <=> v51098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4726,axiom,
    ! [VarCurr: state_type] :
      ( v51098(VarCurr)
    <=> ( v51101(VarCurr)
        & v51102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4725,axiom,
    ! [VarCurr: state_type] :
      ( v51102(VarCurr)
    <=> ( v51050(VarCurr)
        | v51081(VarCurr) ) ) ).

tff(writeUnaryOperator_2892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51101(VarCurr)
    <=> v51046(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51090(VarNext)
      <=> v51091(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51091(VarNext)
      <=> ( v51093(VarNext)
          & v51095(VarNext) ) ) ) ).

tff(writeUnaryOperator_2891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51095(VarCurr)
    <=> v51038(VarCurr) ) ).

tff(addAssignment_25679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v51093(VarNext)
      <=> v51038(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_222,axiom,
    ( v51044(constB0)
  <=> $true ) ).

tff(addAssignment_25678,axiom,
    ! [VarCurr: state_type] :
      ( v51081(VarCurr)
    <=> v51083(VarCurr) ) ).

tff(addAssignment_25677,axiom,
    ! [VarCurr: state_type] :
      ( v51083(VarCurr)
    <=> v51085(VarCurr) ) ).

tff(addAssignment_25676,axiom,
    ! [VarCurr: state_type] :
      ( v51085(VarCurr)
    <=> v51087(VarCurr) ) ).

tff(addAssignment_25675,axiom,
    ! [VarCurr: state_type] :
      ( v51087(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_25674,axiom,
    ! [VarCurr: state_type] :
      ( v51050(VarCurr)
    <=> v51052(VarCurr) ) ).

tff(addAssignment_25673,axiom,
    ! [VarCurr: state_type] :
      ( v51052(VarCurr)
    <=> v51054(VarCurr) ) ).

tff(addAssignment_25672,axiom,
    ! [VarCurr: state_type] :
      ( v51054(VarCurr)
    <=> v51056(VarCurr) ) ).

tff(addAssignment_25671,axiom,
    ! [VarCurr: state_type] :
      ( v51056(VarCurr)
    <=> v51058(VarCurr) ) ).

tff(writeUnaryOperator_2890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v51058(VarCurr)
    <=> v51078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4722,axiom,
    ! [VarCurr: state_type] :
      ( v51078(VarCurr)
    <=> ( v51079(VarCurr)
        | v51074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4721,axiom,
    ! [VarCurr: state_type] :
      ( v51079(VarCurr)
    <=> ( v51060(VarCurr)
        | v51070(VarCurr) ) ) ).

tff(addAssignment_25670,axiom,
    ! [VarCurr: state_type] :
      ( v51074(VarCurr)
    <=> v51076(VarCurr) ) ).

tff(addAssignment_25669,axiom,
    ! [VarCurr: state_type] :
      ( v51076(VarCurr)
    <=> v51064(VarCurr,2) ) ).

tff(addAssignment_25668,axiom,
    ! [VarCurr: state_type] :
      ( v51064(VarCurr,2)
    <=> v51066(VarCurr,2) ) ).

tff(addAssignment_25667,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,2)
    <=> v51068(VarCurr,2) ) ).

tff(addAssignment_25666,axiom,
    ! [VarCurr: state_type] :
      ( v51070(VarCurr)
    <=> v51072(VarCurr) ) ).

tff(addAssignment_25665,axiom,
    ! [VarCurr: state_type] :
      ( v51072(VarCurr)
    <=> v51064(VarCurr,1) ) ).

tff(addAssignment_25664,axiom,
    ! [VarCurr: state_type] :
      ( v51064(VarCurr,1)
    <=> v51066(VarCurr,1) ) ).

tff(addAssignment_25663,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,1)
    <=> v51068(VarCurr,1) ) ).

tff(addAssignment_25662,axiom,
    ! [VarCurr: state_type] :
      ( v51060(VarCurr)
    <=> v51062(VarCurr) ) ).

tff(addAssignment_25661,axiom,
    ! [VarCurr: state_type] :
      ( v51062(VarCurr)
    <=> v51064(VarCurr,0) ) ).

tff(addAssignment_25660,axiom,
    ! [VarCurr: state_type] :
      ( v51064(VarCurr,0)
    <=> v51066(VarCurr,0) ) ).

tff(addAssignment_25659,axiom,
    ! [VarCurr: state_type] :
      ( v51066(VarCurr,0)
    <=> v51068(VarCurr,0) ) ).

tff(addAssignment_25658,axiom,
    ! [VarCurr: state_type] :
      ( v51046(VarCurr)
    <=> v51048(VarCurr) ) ).

tff(addAssignment_25657,axiom,
    ! [VarCurr: state_type] :
      ( v51048(VarCurr)
    <=> $false ) ).

tff(addAssignment_25656,axiom,
    ! [VarCurr: state_type] :
      ( v51038(VarCurr)
    <=> v51040(VarCurr) ) ).

tff(addAssignment_25655,axiom,
    ! [VarCurr: state_type] :
      ( v51040(VarCurr)
    <=> v51042(VarCurr) ) ).

tff(addAssignment_25654,axiom,
    ! [VarCurr: state_type] :
      ( v51042(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_25653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50993(VarCurr,B)
      <=> v50995(VarCurr,B) ) ) ).

tff(addAssignment_25652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50995(VarCurr,B)
      <=> v50997(VarCurr,B) ) ) ).

tff(addAssignment_25651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50997(VarCurr,B)
      <=> v50999(VarCurr,B) ) ) ).

tff(addAssignment_25650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50999(VarCurr,B)
      <=> v51001(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51001(VarCurr,B)
      <=> ( v51003(VarCurr,B)
          & v51025(VarCurr,B) ) ) ) ).

tff(addAssignment_25649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51025(VarCurr,B)
      <=> v51027(VarCurr,B) ) ) ).

tff(addAssignment_25648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51027(VarCurr,B)
      <=> v51029(VarCurr,B) ) ) ).

tff(addAssignment_25647,axiom,
    ! [VarCurr: state_type] :
      ( ( v51029(VarCurr,11)
      <=> v6324(VarCurr,167) )
      & ( v51029(VarCurr,10)
      <=> v6324(VarCurr,166) )
      & ( v51029(VarCurr,9)
      <=> v6324(VarCurr,165) )
      & ( v51029(VarCurr,8)
      <=> v6324(VarCurr,164) )
      & ( v51029(VarCurr,7)
      <=> v6324(VarCurr,163) )
      & ( v51029(VarCurr,6)
      <=> v6324(VarCurr,162) )
      & ( v51029(VarCurr,5)
      <=> v6324(VarCurr,161) )
      & ( v51029(VarCurr,4)
      <=> v6324(VarCurr,160) )
      & ( v51029(VarCurr,3)
      <=> v6324(VarCurr,159) )
      & ( v51029(VarCurr,2)
      <=> v6324(VarCurr,158) )
      & ( v51029(VarCurr,1)
      <=> v6324(VarCurr,157) )
      & ( v51029(VarCurr,0)
      <=> v6324(VarCurr,156) ) ) ).

tff(addAssignment_25646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v6324(VarCurr,B)
      <=> v6334(VarCurr,B) ) ) ).

tff(addAssignment_25645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v51003(VarCurr,B)
      <=> v51005(VarCurr,B) ) ) ).

tff(addAssignment_25644,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,0)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25643,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,1)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25642,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,2)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25641,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,3)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25640,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,4)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25639,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,5)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25638,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,6)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25637,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,7)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25636,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,8)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25635,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,9)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25634,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,10)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25633,axiom,
    ! [VarCurr: state_type] :
      ( v51005(VarCurr,11)
    <=> v51023(VarCurr) ) ).

tff(addAssignment_25632,axiom,
    ! [VarCurr: state_type] :
      ( v51023(VarCurr)
    <=> v51007(VarCurr) ) ).

tff(addAssignment_25631,axiom,
    ! [VarCurr: state_type] :
      ( v51007(VarCurr)
    <=> v51009(VarCurr,0) ) ).

tff(addAssignment_25630,axiom,
    ! [VarCurr: state_type] :
      ( v51009(VarCurr,0)
    <=> v51011(VarCurr,0) ) ).

tff(addAssignment_25629,axiom,
    ! [VarCurr: state_type] :
      ( v51011(VarCurr,0)
    <=> v51021(VarCurr,0) ) ).

tff(writeUnaryOperator_2889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v51021(VarCurr,B)
      <=> ~ v51013(VarCurr,B) ) ) ).

tff(addAssignment_25628,axiom,
    ! [VarCurr: state_type] :
      ( v51013(VarCurr,0)
    <=> v51015(VarCurr,0) ) ).

tff(addAssignment_25627,axiom,
    ! [VarCurr: state_type] :
      ( v51015(VarCurr,0)
    <=> v51018(VarCurr,0) ) ).

tff(addAssignment_25626,axiom,
    ! [VarCurr: state_type] :
      ( v51018(VarCurr,0)
    <=> v51017(VarCurr) ) ).

tff(addAssignment_25625,axiom,
    ! [VarCurr: state_type] :
      ( v51018(VarCurr,1)
    <=> v51020(VarCurr) ) ).

tff(addAssignment_25624,axiom,
    ! [VarCurr: state_type] :
      ( v51018(VarCurr,2)
    <=> v51019(VarCurr) ) ).

tff(addAssignment_25623,axiom,
    ! [VarCurr: state_type] :
      ( v51017(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_25622,axiom,
    ! [VarCurr: state_type] :
      ( v50979(VarCurr)
    <=> v50981(VarCurr) ) ).

tff(addAssignment_25621,axiom,
    ! [VarCurr: state_type] :
      ( v50981(VarCurr)
    <=> v50983(VarCurr) ) ).

tff(addAssignment_25620,axiom,
    ! [VarCurr: state_type] :
      ( v50983(VarCurr)
    <=> v50985(VarCurr) ) ).

tff(addAssignment_25619,axiom,
    ! [VarCurr: state_type] :
      ( v50985(VarCurr)
    <=> v50987(VarCurr) ) ).

tff(addAssignment_25618,axiom,
    ! [VarCurr: state_type] :
      ( v50987(VarCurr)
    <=> v50989(VarCurr) ) ).

tff(addAssignment_25617,axiom,
    ! [VarCurr: state_type] :
      ( v50989(VarCurr)
    <=> v50991(VarCurr) ) ).

tff(addAssignment_25616,axiom,
    ! [VarCurr: state_type] :
      ( v50991(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_25615,axiom,
    ! [VarCurr: state_type] :
      ( v50965(VarCurr)
    <=> v50967(VarCurr) ) ).

tff(addAssignment_25614,axiom,
    ! [VarCurr: state_type] :
      ( v50967(VarCurr)
    <=> v50969(VarCurr) ) ).

tff(addAssignment_25613,axiom,
    ! [VarCurr: state_type] :
      ( v50969(VarCurr)
    <=> v50971(VarCurr) ) ).

tff(addAssignment_25612,axiom,
    ! [VarCurr: state_type] :
      ( v50971(VarCurr)
    <=> v50973(VarCurr) ) ).

tff(addAssignment_25611,axiom,
    ! [VarCurr: state_type] :
      ( v50973(VarCurr)
    <=> v50975(VarCurr) ) ).

tff(addAssignment_25610,axiom,
    ! [VarCurr: state_type] :
      ( v50975(VarCurr)
    <=> v50977(VarCurr) ) ).

tff(addAssignment_25609,axiom,
    ! [VarCurr: state_type] :
      ( v50977(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_25608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50941(VarCurr,B)
      <=> v50943(VarCurr,B) ) ) ).

tff(addAssignment_25607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50943(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_25606,axiom,
    ! [VarCurr: state_type] :
      ( v49385(VarCurr)
    <=> v49387(VarCurr) ) ).

tff(addAssignment_25605,axiom,
    ! [VarCurr: state_type] :
      ( v49387(VarCurr)
    <=> v49389(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_215,axiom,
    ! [VarCurr: state_type] :
      ( v49389(VarCurr)
    <=> ( ( v49391(VarCurr,11)
        <=> v49395(VarCurr,11) )
        & ( v49391(VarCurr,10)
        <=> v49395(VarCurr,10) )
        & ( v49391(VarCurr,9)
        <=> v49395(VarCurr,9) )
        & ( v49391(VarCurr,8)
        <=> v49395(VarCurr,8) )
        & ( v49391(VarCurr,7)
        <=> v49395(VarCurr,7) )
        & ( v49391(VarCurr,6)
        <=> v49395(VarCurr,6) )
        & ( v49391(VarCurr,5)
        <=> v49395(VarCurr,5) )
        & ( v49391(VarCurr,4)
        <=> v49395(VarCurr,4) )
        & ( v49391(VarCurr,3)
        <=> v49395(VarCurr,3) )
        & ( v49391(VarCurr,2)
        <=> v49395(VarCurr,2) )
        & ( v49391(VarCurr,1)
        <=> v49395(VarCurr,1) )
        & ( v49391(VarCurr,0)
        <=> v49395(VarCurr,0) ) ) ) ).

tff(addAssignment_25604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49395(VarCurr,B)
      <=> v49397(VarCurr,B) ) ) ).

tff(addAssignment_25603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49397(VarCurr,B)
      <=> v49399(VarCurr,B) ) ) ).

tff(addAssignment_25602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49399(VarCurr,B)
      <=> v49401(VarCurr,B) ) ) ).

tff(addAssignment_25601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49401(VarCurr,B)
      <=> v49403(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49403(VarCurr,B)
      <=> ( v50911(VarCurr,B)
          | v50930(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50930(VarCurr,B)
      <=> ( v50782(VarCurr,B)
          & v50931(VarCurr,B) ) ) ) ).

tff(addAssignment_25600,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,0)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25599,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,1)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25598,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,2)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25597,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,3)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25596,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,4)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25595,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,5)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25594,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,6)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25593,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,7)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25592,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,8)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25591,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,9)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25590,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,10)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25589,axiom,
    ! [VarCurr: state_type] :
      ( v50931(VarCurr,11)
    <=> v50932(VarCurr) ) ).

tff(addAssignment_25588,axiom,
    ! [VarCurr: state_type] :
      ( v50932(VarCurr)
    <=> v50901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50911(VarCurr,B)
      <=> ( v50912(VarCurr,B)
          | v50927(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50927(VarCurr,B)
      <=> ( v50631(VarCurr,B)
          & v50928(VarCurr,B) ) ) ) ).

tff(addAssignment_25587,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,0)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25586,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,1)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25585,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,2)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25584,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,3)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25583,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,4)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25582,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,5)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25581,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,6)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25580,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,7)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25579,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,8)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25578,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,9)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25577,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,10)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25576,axiom,
    ! [VarCurr: state_type] :
      ( v50928(VarCurr,11)
    <=> v50929(VarCurr) ) ).

tff(addAssignment_25575,axiom,
    ! [VarCurr: state_type] :
      ( v50929(VarCurr)
    <=> v50751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50912(VarCurr,B)
      <=> ( v50913(VarCurr,B)
          | v50924(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50924(VarCurr,B)
      <=> ( v50480(VarCurr,B)
          & v50925(VarCurr,B) ) ) ) ).

tff(addAssignment_25574,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,0)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25573,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,1)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25572,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,2)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25571,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,3)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25570,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,4)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25569,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,5)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25568,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,6)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25567,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,7)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25566,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,8)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25565,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,9)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25564,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,10)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25563,axiom,
    ! [VarCurr: state_type] :
      ( v50925(VarCurr,11)
    <=> v50926(VarCurr) ) ).

tff(addAssignment_25562,axiom,
    ! [VarCurr: state_type] :
      ( v50926(VarCurr)
    <=> v50600(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50913(VarCurr,B)
      <=> ( v50914(VarCurr,B)
          | v50921(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50921(VarCurr,B)
      <=> ( v50329(VarCurr,B)
          & v50922(VarCurr,B) ) ) ) ).

tff(addAssignment_25561,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,0)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25560,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,1)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25559,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,2)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25558,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,3)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25557,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,4)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25556,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,5)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25555,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,6)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25554,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,7)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25553,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,8)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25552,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,9)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25551,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,10)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25550,axiom,
    ! [VarCurr: state_type] :
      ( v50922(VarCurr,11)
    <=> v50923(VarCurr) ) ).

tff(addAssignment_25549,axiom,
    ! [VarCurr: state_type] :
      ( v50923(VarCurr)
    <=> v50449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50914(VarCurr,B)
      <=> ( v50915(VarCurr,B)
          | v50918(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_807,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50918(VarCurr,B)
      <=> ( v50167(VarCurr,B)
          & v50919(VarCurr,B) ) ) ) ).

tff(addAssignment_25548,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,0)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25547,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,1)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25546,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,2)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25545,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,3)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25544,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,4)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25543,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,5)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25542,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,6)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25541,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,7)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25540,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,8)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25539,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,9)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25538,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,10)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25537,axiom,
    ! [VarCurr: state_type] :
      ( v50919(VarCurr,11)
    <=> v50920(VarCurr) ) ).

tff(addAssignment_25536,axiom,
    ! [VarCurr: state_type] :
      ( v50920(VarCurr)
    <=> v50298(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50915(VarCurr,B)
      <=> ( v49405(VarCurr,B)
          & v50916(VarCurr,B) ) ) ) ).

tff(addAssignment_25535,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,0)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25534,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,1)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25533,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,2)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25532,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,3)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25531,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,4)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25530,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,5)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25529,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,6)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25528,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,7)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25527,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,8)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25526,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,9)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25525,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,10)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25524,axiom,
    ! [VarCurr: state_type] :
      ( v50916(VarCurr,11)
    <=> v50917(VarCurr) ) ).

tff(addAssignment_25523,axiom,
    ! [VarCurr: state_type] :
      ( v50917(VarCurr)
    <=> v49875(VarCurr) ) ).

tff(addAssignment_25522,axiom,
    ! [VarCurr: state_type] :
      ( v50901(VarCurr)
    <=> v50903(VarCurr) ) ).

tff(addAssignment_25521,axiom,
    ! [VarCurr: state_type] :
      ( v50903(VarCurr)
    <=> v50905(VarCurr) ) ).

tff(addAssignment_25520,axiom,
    ! [VarCurr: state_type] :
      ( v50905(VarCurr)
    <=> v50907(VarCurr) ) ).

tff(addAssignment_25519,axiom,
    ! [VarCurr: state_type] :
      ( v50907(VarCurr)
    <=> v50909(VarCurr) ) ).

tff(addAssignment_25518,axiom,
    ! [VarCurr: state_type] :
      ( v50909(VarCurr)
    <=> v49968(VarCurr) ) ).

tff(addAssignment_25517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50782(VarCurr,B)
      <=> v50784(VarCurr,B) ) ) ).

tff(addAssignment_25516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50784(VarCurr,B)
      <=> v50786(VarCurr,B) ) ) ).

tff(addAssignment_25515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50786(VarCurr,B)
      <=> v50788(VarCurr,B) ) ) ).

tff(addAssignment_25514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50788(VarCurr,B)
      <=> v50790(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50884(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50790(VarNext,B)
            <=> v50790(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_592,axiom,
    ! [VarNext: state_type] :
      ( v50884(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50790(VarNext,B)
          <=> v50894(VarNext,B) ) ) ) ).

tff(addAssignment_25513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50894(VarNext,B)
          <=> v50892(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50895(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50892(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_384,axiom,
    ! [VarCurr: state_type] :
      ( v50895(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50892(VarCurr,B)
          <=> v50812(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4720,axiom,
    ! [VarCurr: state_type] :
      ( v50895(VarCurr)
    <=> ( v50896(VarCurr)
        & v50897(VarCurr) ) ) ).

tff(writeUnaryOperator_2888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50897(VarCurr)
    <=> v50802(VarCurr) ) ).

tff(writeUnaryOperator_2887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50896(VarCurr)
    <=> v50792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50884(VarNext)
      <=> v50885(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4718,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50885(VarNext)
      <=> ( v50886(VarNext)
          & v50816(VarNext) ) ) ) ).

tff(writeUnaryOperator_2886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50886(VarNext)
      <=> v50888(VarNext) ) ) ).

tff(addAssignment_25512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50888(VarNext)
      <=> v50816(VarCurr) ) ) ).

tff(addAssignment_25511,axiom,
    ! [VarCurr: state_type] :
      ( v50816(VarCurr)
    <=> v50818(VarCurr) ) ).

tff(addAssignment_25510,axiom,
    ! [VarCurr: state_type] :
      ( v50818(VarCurr)
    <=> v50820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4717,axiom,
    ! [VarCurr: state_type] :
      ( v50820(VarCurr)
    <=> ( v50881(VarCurr)
        | v50877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4716,axiom,
    ! [VarCurr: state_type] :
      ( v50881(VarCurr)
    <=> ( v50822(VarCurr)
        & v50826(VarCurr) ) ) ).

tff(addAssignment_25509,axiom,
    ! [VarCurr: state_type] :
      ( v50877(VarCurr)
    <=> v50879(VarCurr) ) ).

tff(addAssignment_25508,axiom,
    ! [VarCurr: state_type] :
      ( v50879(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_591,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50861(VarNext)
       => ( v50826(VarNext)
        <=> v50826(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_591,axiom,
    ! [VarNext: state_type] :
      ( v50861(VarNext)
     => ( v50826(VarNext)
      <=> v50871(VarNext) ) ) ).

tff(addAssignment_25507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50871(VarNext)
      <=> v50869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4715,axiom,
    ! [VarCurr: state_type] :
      ( v50869(VarCurr)
    <=> ( v50872(VarCurr)
        & v50873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4714,axiom,
    ! [VarCurr: state_type] :
      ( v50873(VarCurr)
    <=> ( v50832(VarCurr)
        | v50856(VarCurr) ) ) ).

tff(writeUnaryOperator_2885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50872(VarCurr)
    <=> v50828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50861(VarNext)
      <=> v50862(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50862(VarNext)
      <=> ( v50864(VarNext)
          & v50866(VarNext) ) ) ) ).

tff(writeUnaryOperator_2884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50866(VarCurr)
    <=> v50822(VarCurr) ) ).

tff(addAssignment_25506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50864(VarNext)
      <=> v50822(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_221,axiom,
    ( v50826(constB0)
  <=> $true ) ).

tff(addAssignment_25505,axiom,
    ! [VarCurr: state_type] :
      ( v50856(VarCurr)
    <=> v50858(VarCurr) ) ).

tff(addAssignment_25504,axiom,
    ! [VarCurr: state_type] :
      ( v50858(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25503,axiom,
    ! [VarCurr: state_type] :
      ( v50832(VarCurr)
    <=> v50834(VarCurr) ) ).

tff(addAssignment_25502,axiom,
    ! [VarCurr: state_type] :
      ( v50834(VarCurr)
    <=> v50142(VarCurr) ) ).

tff(addAssignment_25501,axiom,
    ! [VarCurr: state_type] :
      ( v50142(VarCurr)
    <=> v50837(VarCurr) ) ).

tff(addAssignment_25500,axiom,
    ! [VarCurr: state_type] :
      ( v50837(VarCurr)
    <=> v50839(VarCurr) ) ).

tff(writeUnaryOperator_2883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50839(VarCurr)
    <=> v50853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4711,axiom,
    ! [VarCurr: state_type] :
      ( v50853(VarCurr)
    <=> ( v50854(VarCurr)
        | v50849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4710,axiom,
    ! [VarCurr: state_type] :
      ( v50854(VarCurr)
    <=> ( v50841(VarCurr)
        | v50845(VarCurr) ) ) ).

tff(addAssignment_25499,axiom,
    ! [VarCurr: state_type] :
      ( v50849(VarCurr)
    <=> v50851(VarCurr) ) ).

tff(addAssignment_25498,axiom,
    ! [VarCurr: state_type] :
      ( v50851(VarCurr)
    <=> v50231(VarCurr,2) ) ).

tff(addAssignment_25497,axiom,
    ! [VarCurr: state_type] :
      ( v50845(VarCurr)
    <=> v50847(VarCurr) ) ).

tff(addAssignment_25496,axiom,
    ! [VarCurr: state_type] :
      ( v50847(VarCurr)
    <=> v49805(VarCurr,1) ) ).

tff(addAssignment_25495,axiom,
    ! [VarCurr: state_type] :
      ( v50841(VarCurr)
    <=> v50843(VarCurr) ) ).

tff(addAssignment_25494,axiom,
    ! [VarCurr: state_type] :
      ( v50843(VarCurr)
    <=> v50231(VarCurr,0) ) ).

tff(addAssignment_25493,axiom,
    ! [VarCurr: state_type] :
      ( v50828(VarCurr)
    <=> v50830(VarCurr) ) ).

tff(addAssignment_25492,axiom,
    ! [VarCurr: state_type] :
      ( v50830(VarCurr)
    <=> $false ) ).

tff(addAssignment_25491,axiom,
    ! [VarCurr: state_type] :
      ( v50822(VarCurr)
    <=> v50824(VarCurr) ) ).

tff(addAssignment_25490,axiom,
    ! [VarCurr: state_type] :
      ( v50824(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50812(VarCurr,B)
      <=> v50814(VarCurr,B) ) ) ).

tff(addAssignment_25488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50814(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25487,axiom,
    ! [VarCurr: state_type] :
      ( v50802(VarCurr)
    <=> v50804(VarCurr) ) ).

tff(addAssignment_25486,axiom,
    ! [VarCurr: state_type] :
      ( v50804(VarCurr)
    <=> v50806(VarCurr) ) ).

tff(addAssignment_25485,axiom,
    ! [VarCurr: state_type] :
      ( v50806(VarCurr)
    <=> v50808(VarCurr) ) ).

tff(addAssignment_25484,axiom,
    ! [VarCurr: state_type] :
      ( v50808(VarCurr)
    <=> v50810(VarCurr) ) ).

tff(addAssignment_25483,axiom,
    ! [VarCurr: state_type] :
      ( v50810(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25482,axiom,
    ! [VarCurr: state_type] :
      ( v50792(VarCurr)
    <=> v50794(VarCurr) ) ).

tff(addAssignment_25481,axiom,
    ! [VarCurr: state_type] :
      ( v50794(VarCurr)
    <=> v50796(VarCurr) ) ).

tff(addAssignment_25480,axiom,
    ! [VarCurr: state_type] :
      ( v50796(VarCurr)
    <=> v50798(VarCurr) ) ).

tff(addAssignment_25479,axiom,
    ! [VarCurr: state_type] :
      ( v50798(VarCurr)
    <=> v50800(VarCurr) ) ).

tff(addAssignment_25478,axiom,
    ! [VarCurr: state_type] :
      ( v50800(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_25477,axiom,
    ! [VarCurr: state_type] :
      ( v50751(VarCurr)
    <=> v50753(VarCurr) ) ).

tff(addAssignment_25476,axiom,
    ! [VarCurr: state_type] :
      ( v50753(VarCurr)
    <=> v50755(VarCurr) ) ).

tff(addAssignment_25475,axiom,
    ! [VarCurr: state_type] :
      ( v50755(VarCurr)
    <=> v50757(VarCurr) ) ).

tff(addAssignment_25474,axiom,
    ! [VarCurr: state_type] :
      ( v50757(VarCurr)
    <=> v50759(VarCurr) ) ).

tff(addAssignment_25473,axiom,
    ! [VarCurr: state_type] :
      ( v50759(VarCurr)
    <=> v50761(VarCurr) ) ).

tff(addAssignment_25472,axiom,
    ! [VarCurr: state_type] :
      ( v50761(VarCurr)
    <=> v50763(VarCurr) ) ).

tff(addAssignment_25471,axiom,
    ! [VarCurr: state_type] :
      ( v50763(VarCurr)
    <=> v50765(VarCurr) ) ).

tff(writeUnaryOperator_2882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50765(VarCurr)
    <=> v50779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4709,axiom,
    ! [VarCurr: state_type] :
      ( v50779(VarCurr)
    <=> ( v50780(VarCurr)
        | v50775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4708,axiom,
    ! [VarCurr: state_type] :
      ( v50780(VarCurr)
    <=> ( v50767(VarCurr)
        | v50771(VarCurr) ) ) ).

tff(addAssignment_25470,axiom,
    ! [VarCurr: state_type] :
      ( v50775(VarCurr)
    <=> v50777(VarCurr) ) ).

tff(addAssignment_25469,axiom,
    ! [VarCurr: state_type] :
      ( v50777(VarCurr)
    <=> v49978(VarCurr,2) ) ).

tff(addAssignment_25468,axiom,
    ! [VarCurr: state_type] :
      ( v50771(VarCurr)
    <=> v50773(VarCurr) ) ).

tff(addAssignment_25467,axiom,
    ! [VarCurr: state_type] :
      ( v50773(VarCurr)
    <=> v49895(VarCurr,1) ) ).

tff(addAssignment_25466,axiom,
    ! [VarCurr: state_type] :
      ( v50767(VarCurr)
    <=> v50769(VarCurr) ) ).

tff(addAssignment_25465,axiom,
    ! [VarCurr: state_type] :
      ( v50769(VarCurr)
    <=> v49895(VarCurr,0) ) ).

tff(addAssignment_25464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50631(VarCurr,B)
      <=> v50633(VarCurr,B) ) ) ).

tff(addAssignment_25463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50633(VarCurr,B)
      <=> v50635(VarCurr,B) ) ) ).

tff(addAssignment_25462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50635(VarCurr,B)
      <=> v50637(VarCurr,B) ) ) ).

tff(addAssignment_25461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50637(VarCurr,B)
      <=> v50639(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50734(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50639(VarNext,B)
            <=> v50639(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_590,axiom,
    ! [VarNext: state_type] :
      ( v50734(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50639(VarNext,B)
          <=> v50744(VarNext,B) ) ) ) ).

tff(addAssignment_25460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50744(VarNext,B)
          <=> v50742(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50742(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_383,axiom,
    ! [VarCurr: state_type] :
      ( v50745(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50742(VarCurr,B)
          <=> v50661(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4707,axiom,
    ! [VarCurr: state_type] :
      ( v50745(VarCurr)
    <=> ( v50746(VarCurr)
        & v50747(VarCurr) ) ) ).

tff(writeUnaryOperator_2881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50747(VarCurr)
    <=> v50651(VarCurr) ) ).

tff(writeUnaryOperator_2880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50746(VarCurr)
    <=> v50641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50734(VarNext)
      <=> v50735(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50735(VarNext)
      <=> ( v50736(VarNext)
          & v50665(VarNext) ) ) ) ).

tff(writeUnaryOperator_2879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50736(VarNext)
      <=> v50738(VarNext) ) ) ).

tff(addAssignment_25459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50738(VarNext)
      <=> v50665(VarCurr) ) ) ).

tff(addAssignment_25458,axiom,
    ! [VarCurr: state_type] :
      ( v50665(VarCurr)
    <=> v50667(VarCurr) ) ).

tff(addAssignment_25457,axiom,
    ! [VarCurr: state_type] :
      ( v50667(VarCurr)
    <=> v50669(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4704,axiom,
    ! [VarCurr: state_type] :
      ( v50669(VarCurr)
    <=> ( v50731(VarCurr)
        | v50727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4703,axiom,
    ! [VarCurr: state_type] :
      ( v50731(VarCurr)
    <=> ( v50671(VarCurr)
        & v50675(VarCurr) ) ) ).

tff(addAssignment_25456,axiom,
    ! [VarCurr: state_type] :
      ( v50727(VarCurr)
    <=> v50729(VarCurr) ) ).

tff(addAssignment_25455,axiom,
    ! [VarCurr: state_type] :
      ( v50729(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50711(VarNext)
       => ( v50675(VarNext)
        <=> v50675(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_589,axiom,
    ! [VarNext: state_type] :
      ( v50711(VarNext)
     => ( v50675(VarNext)
      <=> v50721(VarNext) ) ) ).

tff(addAssignment_25454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50721(VarNext)
      <=> v50719(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4702,axiom,
    ! [VarCurr: state_type] :
      ( v50719(VarCurr)
    <=> ( v50722(VarCurr)
        & v50723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4701,axiom,
    ! [VarCurr: state_type] :
      ( v50723(VarCurr)
    <=> ( v50681(VarCurr)
        | v50706(VarCurr) ) ) ).

tff(writeUnaryOperator_2878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50722(VarCurr)
    <=> v50677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50711(VarNext)
      <=> v50712(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50712(VarNext)
      <=> ( v50714(VarNext)
          & v50716(VarNext) ) ) ) ).

tff(writeUnaryOperator_2877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50716(VarCurr)
    <=> v50671(VarCurr) ) ).

tff(addAssignment_25453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50714(VarNext)
      <=> v50671(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_220,axiom,
    ( v50675(constB0)
  <=> $true ) ).

tff(addAssignment_25452,axiom,
    ! [VarCurr: state_type] :
      ( v50706(VarCurr)
    <=> v50708(VarCurr) ) ).

tff(addAssignment_25451,axiom,
    ! [VarCurr: state_type] :
      ( v50708(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25450,axiom,
    ! [VarCurr: state_type] :
      ( v50681(VarCurr)
    <=> v50683(VarCurr) ) ).

tff(addAssignment_25449,axiom,
    ! [VarCurr: state_type] :
      ( v50683(VarCurr)
    <=> v50685(VarCurr) ) ).

tff(addAssignment_25448,axiom,
    ! [VarCurr: state_type] :
      ( v50685(VarCurr)
    <=> v50687(VarCurr) ) ).

tff(addAssignment_25447,axiom,
    ! [VarCurr: state_type] :
      ( v50687(VarCurr)
    <=> v50689(VarCurr) ) ).

tff(writeUnaryOperator_2876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50689(VarCurr)
    <=> v50703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4698,axiom,
    ! [VarCurr: state_type] :
      ( v50703(VarCurr)
    <=> ( v50704(VarCurr)
        | v50699(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4697,axiom,
    ! [VarCurr: state_type] :
      ( v50704(VarCurr)
    <=> ( v50691(VarCurr)
        | v50695(VarCurr) ) ) ).

tff(addAssignment_25446,axiom,
    ! [VarCurr: state_type] :
      ( v50699(VarCurr)
    <=> v50701(VarCurr) ) ).

tff(addAssignment_25445,axiom,
    ! [VarCurr: state_type] :
      ( v50701(VarCurr)
    <=> v50231(VarCurr,2) ) ).

tff(addAssignment_25444,axiom,
    ! [VarCurr: state_type] :
      ( v50231(VarCurr,2)
    <=> v50233(VarCurr,2) ) ).

tff(addAssignment_25443,axiom,
    ! [VarCurr: state_type] :
      ( v50233(VarCurr,2)
    <=> v50235(VarCurr,2) ) ).

tff(addAssignment_25442,axiom,
    ! [VarCurr: state_type] :
      ( v50235(VarCurr,2)
    <=> v50240(VarCurr,2) ) ).

tff(addAssignment_25441,axiom,
    ! [VarCurr: state_type] :
      ( v50237(VarCurr,2)
    <=> v50239(VarCurr,2) ) ).

tff(addAssignment_25440,axiom,
    ! [VarCurr: state_type] :
      ( v50239(VarCurr,2)
    <=> v49805(VarCurr,2) ) ).

tff(addAssignment_25439,axiom,
    ! [VarCurr: state_type] :
      ( v50695(VarCurr)
    <=> v50697(VarCurr) ) ).

tff(addAssignment_25438,axiom,
    ! [VarCurr: state_type] :
      ( v50697(VarCurr)
    <=> v49805(VarCurr,1) ) ).

tff(addAssignment_25437,axiom,
    ! [VarCurr: state_type] :
      ( v50691(VarCurr)
    <=> v50693(VarCurr) ) ).

tff(addAssignment_25436,axiom,
    ! [VarCurr: state_type] :
      ( v50693(VarCurr)
    <=> v49805(VarCurr,0) ) ).

tff(addAssignment_25435,axiom,
    ! [VarCurr: state_type] :
      ( v50677(VarCurr)
    <=> v50679(VarCurr) ) ).

tff(addAssignment_25434,axiom,
    ! [VarCurr: state_type] :
      ( v50679(VarCurr)
    <=> $false ) ).

tff(addAssignment_25433,axiom,
    ! [VarCurr: state_type] :
      ( v50671(VarCurr)
    <=> v50673(VarCurr) ) ).

tff(addAssignment_25432,axiom,
    ! [VarCurr: state_type] :
      ( v50673(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50661(VarCurr,B)
      <=> v50663(VarCurr,B) ) ) ).

tff(addAssignment_25430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50663(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25429,axiom,
    ! [VarCurr: state_type] :
      ( v50651(VarCurr)
    <=> v50653(VarCurr) ) ).

tff(addAssignment_25428,axiom,
    ! [VarCurr: state_type] :
      ( v50653(VarCurr)
    <=> v50655(VarCurr) ) ).

tff(addAssignment_25427,axiom,
    ! [VarCurr: state_type] :
      ( v50655(VarCurr)
    <=> v50657(VarCurr) ) ).

tff(addAssignment_25426,axiom,
    ! [VarCurr: state_type] :
      ( v50657(VarCurr)
    <=> v50659(VarCurr) ) ).

tff(addAssignment_25425,axiom,
    ! [VarCurr: state_type] :
      ( v50659(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25424,axiom,
    ! [VarCurr: state_type] :
      ( v50641(VarCurr)
    <=> v50643(VarCurr) ) ).

tff(addAssignment_25423,axiom,
    ! [VarCurr: state_type] :
      ( v50643(VarCurr)
    <=> v50645(VarCurr) ) ).

tff(addAssignment_25422,axiom,
    ! [VarCurr: state_type] :
      ( v50645(VarCurr)
    <=> v50647(VarCurr) ) ).

tff(addAssignment_25421,axiom,
    ! [VarCurr: state_type] :
      ( v50647(VarCurr)
    <=> v50649(VarCurr) ) ).

tff(addAssignment_25420,axiom,
    ! [VarCurr: state_type] :
      ( v50649(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_25419,axiom,
    ! [VarCurr: state_type] :
      ( v50600(VarCurr)
    <=> v50602(VarCurr) ) ).

tff(addAssignment_25418,axiom,
    ! [VarCurr: state_type] :
      ( v50602(VarCurr)
    <=> v50604(VarCurr) ) ).

tff(addAssignment_25417,axiom,
    ! [VarCurr: state_type] :
      ( v50604(VarCurr)
    <=> v50606(VarCurr) ) ).

tff(addAssignment_25416,axiom,
    ! [VarCurr: state_type] :
      ( v50606(VarCurr)
    <=> v50608(VarCurr) ) ).

tff(addAssignment_25415,axiom,
    ! [VarCurr: state_type] :
      ( v50608(VarCurr)
    <=> v50610(VarCurr) ) ).

tff(addAssignment_25414,axiom,
    ! [VarCurr: state_type] :
      ( v50610(VarCurr)
    <=> v50612(VarCurr) ) ).

tff(addAssignment_25413,axiom,
    ! [VarCurr: state_type] :
      ( v50612(VarCurr)
    <=> v50614(VarCurr) ) ).

tff(writeUnaryOperator_2875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50614(VarCurr)
    <=> v50628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4696,axiom,
    ! [VarCurr: state_type] :
      ( v50628(VarCurr)
    <=> ( v50629(VarCurr)
        | v50624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4695,axiom,
    ! [VarCurr: state_type] :
      ( v50629(VarCurr)
    <=> ( v50616(VarCurr)
        | v50620(VarCurr) ) ) ).

tff(addAssignment_25412,axiom,
    ! [VarCurr: state_type] :
      ( v50624(VarCurr)
    <=> v50626(VarCurr) ) ).

tff(addAssignment_25411,axiom,
    ! [VarCurr: state_type] :
      ( v50626(VarCurr)
    <=> v49895(VarCurr,2) ) ).

tff(addAssignment_25410,axiom,
    ! [VarCurr: state_type] :
      ( v50620(VarCurr)
    <=> v50622(VarCurr) ) ).

tff(addAssignment_25409,axiom,
    ! [VarCurr: state_type] :
      ( v50622(VarCurr)
    <=> v49978(VarCurr,1) ) ).

tff(addAssignment_25408,axiom,
    ! [VarCurr: state_type] :
      ( v50616(VarCurr)
    <=> v50618(VarCurr) ) ).

tff(addAssignment_25407,axiom,
    ! [VarCurr: state_type] :
      ( v50618(VarCurr)
    <=> v49978(VarCurr,0) ) ).

tff(addAssignment_25406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50480(VarCurr,B)
      <=> v50482(VarCurr,B) ) ) ).

tff(addAssignment_25405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50482(VarCurr,B)
      <=> v50484(VarCurr,B) ) ) ).

tff(addAssignment_25404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50484(VarCurr,B)
      <=> v50486(VarCurr,B) ) ) ).

tff(addAssignment_25403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50486(VarCurr,B)
      <=> v50488(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50583(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50488(VarNext,B)
            <=> v50488(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_588,axiom,
    ! [VarNext: state_type] :
      ( v50583(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50488(VarNext,B)
          <=> v50593(VarNext,B) ) ) ) ).

tff(addAssignment_25402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50593(VarNext,B)
          <=> v50591(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50594(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50591(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_382,axiom,
    ! [VarCurr: state_type] :
      ( v50594(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50591(VarCurr,B)
          <=> v50510(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4694,axiom,
    ! [VarCurr: state_type] :
      ( v50594(VarCurr)
    <=> ( v50595(VarCurr)
        & v50596(VarCurr) ) ) ).

tff(writeUnaryOperator_2874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50596(VarCurr)
    <=> v50500(VarCurr) ) ).

tff(writeUnaryOperator_2873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50595(VarCurr)
    <=> v50490(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50583(VarNext)
      <=> v50584(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50584(VarNext)
      <=> ( v50585(VarNext)
          & v50514(VarNext) ) ) ) ).

tff(writeUnaryOperator_2872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50585(VarNext)
      <=> v50587(VarNext) ) ) ).

tff(addAssignment_25401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50587(VarNext)
      <=> v50514(VarCurr) ) ) ).

tff(addAssignment_25400,axiom,
    ! [VarCurr: state_type] :
      ( v50514(VarCurr)
    <=> v50516(VarCurr) ) ).

tff(addAssignment_25399,axiom,
    ! [VarCurr: state_type] :
      ( v50516(VarCurr)
    <=> v50518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4691,axiom,
    ! [VarCurr: state_type] :
      ( v50518(VarCurr)
    <=> ( v50580(VarCurr)
        | v50576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4690,axiom,
    ! [VarCurr: state_type] :
      ( v50580(VarCurr)
    <=> ( v50520(VarCurr)
        & v50524(VarCurr) ) ) ).

tff(addAssignment_25398,axiom,
    ! [VarCurr: state_type] :
      ( v50576(VarCurr)
    <=> v50578(VarCurr) ) ).

tff(addAssignment_25397,axiom,
    ! [VarCurr: state_type] :
      ( v50578(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50560(VarNext)
       => ( v50524(VarNext)
        <=> v50524(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_587,axiom,
    ! [VarNext: state_type] :
      ( v50560(VarNext)
     => ( v50524(VarNext)
      <=> v50570(VarNext) ) ) ).

tff(addAssignment_25396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50570(VarNext)
      <=> v50568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4689,axiom,
    ! [VarCurr: state_type] :
      ( v50568(VarCurr)
    <=> ( v50571(VarCurr)
        & v50572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4688,axiom,
    ! [VarCurr: state_type] :
      ( v50572(VarCurr)
    <=> ( v50530(VarCurr)
        | v50555(VarCurr) ) ) ).

tff(writeUnaryOperator_2871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50571(VarCurr)
    <=> v50526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50560(VarNext)
      <=> v50561(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50561(VarNext)
      <=> ( v50563(VarNext)
          & v50565(VarNext) ) ) ) ).

tff(writeUnaryOperator_2870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50565(VarCurr)
    <=> v50520(VarCurr) ) ).

tff(addAssignment_25395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50563(VarNext)
      <=> v50520(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_219,axiom,
    ( v50524(constB0)
  <=> $true ) ).

tff(addAssignment_25394,axiom,
    ! [VarCurr: state_type] :
      ( v50555(VarCurr)
    <=> v50557(VarCurr) ) ).

tff(addAssignment_25393,axiom,
    ! [VarCurr: state_type] :
      ( v50557(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25392,axiom,
    ! [VarCurr: state_type] :
      ( v50530(VarCurr)
    <=> v50532(VarCurr) ) ).

tff(addAssignment_25391,axiom,
    ! [VarCurr: state_type] :
      ( v50532(VarCurr)
    <=> v50534(VarCurr) ) ).

tff(addAssignment_25390,axiom,
    ! [VarCurr: state_type] :
      ( v50534(VarCurr)
    <=> v50536(VarCurr) ) ).

tff(addAssignment_25389,axiom,
    ! [VarCurr: state_type] :
      ( v50536(VarCurr)
    <=> v50538(VarCurr) ) ).

tff(writeUnaryOperator_2869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50538(VarCurr)
    <=> v50552(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4685,axiom,
    ! [VarCurr: state_type] :
      ( v50552(VarCurr)
    <=> ( v50553(VarCurr)
        | v50548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4684,axiom,
    ! [VarCurr: state_type] :
      ( v50553(VarCurr)
    <=> ( v50540(VarCurr)
        | v50544(VarCurr) ) ) ).

tff(addAssignment_25388,axiom,
    ! [VarCurr: state_type] :
      ( v50548(VarCurr)
    <=> v50550(VarCurr) ) ).

tff(addAssignment_25387,axiom,
    ! [VarCurr: state_type] :
      ( v50550(VarCurr)
    <=> v49805(VarCurr,2) ) ).

tff(addAssignment_25386,axiom,
    ! [VarCurr: state_type] :
      ( v50544(VarCurr)
    <=> v50546(VarCurr) ) ).

tff(addAssignment_25385,axiom,
    ! [VarCurr: state_type] :
      ( v50546(VarCurr)
    <=> v50231(VarCurr,1) ) ).

tff(addAssignment_25384,axiom,
    ! [VarCurr: state_type] :
      ( v50540(VarCurr)
    <=> v50542(VarCurr) ) ).

tff(addAssignment_25383,axiom,
    ! [VarCurr: state_type] :
      ( v50542(VarCurr)
    <=> v50231(VarCurr,0) ) ).

tff(addAssignment_25382,axiom,
    ! [VarCurr: state_type] :
      ( v50526(VarCurr)
    <=> v50528(VarCurr) ) ).

tff(addAssignment_25381,axiom,
    ! [VarCurr: state_type] :
      ( v50528(VarCurr)
    <=> $false ) ).

tff(addAssignment_25380,axiom,
    ! [VarCurr: state_type] :
      ( v50520(VarCurr)
    <=> v50522(VarCurr) ) ).

tff(addAssignment_25379,axiom,
    ! [VarCurr: state_type] :
      ( v50522(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50510(VarCurr,B)
      <=> v50512(VarCurr,B) ) ) ).

tff(addAssignment_25377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50512(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25376,axiom,
    ! [VarCurr: state_type] :
      ( v50500(VarCurr)
    <=> v50502(VarCurr) ) ).

tff(addAssignment_25375,axiom,
    ! [VarCurr: state_type] :
      ( v50502(VarCurr)
    <=> v50504(VarCurr) ) ).

tff(addAssignment_25374,axiom,
    ! [VarCurr: state_type] :
      ( v50504(VarCurr)
    <=> v50506(VarCurr) ) ).

tff(addAssignment_25373,axiom,
    ! [VarCurr: state_type] :
      ( v50506(VarCurr)
    <=> v50508(VarCurr) ) ).

tff(addAssignment_25372,axiom,
    ! [VarCurr: state_type] :
      ( v50508(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25371,axiom,
    ! [VarCurr: state_type] :
      ( v50490(VarCurr)
    <=> v50492(VarCurr) ) ).

tff(addAssignment_25370,axiom,
    ! [VarCurr: state_type] :
      ( v50492(VarCurr)
    <=> v50494(VarCurr) ) ).

tff(addAssignment_25369,axiom,
    ! [VarCurr: state_type] :
      ( v50494(VarCurr)
    <=> v50496(VarCurr) ) ).

tff(addAssignment_25368,axiom,
    ! [VarCurr: state_type] :
      ( v50496(VarCurr)
    <=> v50498(VarCurr) ) ).

tff(addAssignment_25367,axiom,
    ! [VarCurr: state_type] :
      ( v50498(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_25366,axiom,
    ! [VarCurr: state_type] :
      ( v50449(VarCurr)
    <=> v50451(VarCurr) ) ).

tff(addAssignment_25365,axiom,
    ! [VarCurr: state_type] :
      ( v50451(VarCurr)
    <=> v50453(VarCurr) ) ).

tff(addAssignment_25364,axiom,
    ! [VarCurr: state_type] :
      ( v50453(VarCurr)
    <=> v50455(VarCurr) ) ).

tff(addAssignment_25363,axiom,
    ! [VarCurr: state_type] :
      ( v50455(VarCurr)
    <=> v50457(VarCurr) ) ).

tff(addAssignment_25362,axiom,
    ! [VarCurr: state_type] :
      ( v50457(VarCurr)
    <=> v50459(VarCurr) ) ).

tff(addAssignment_25361,axiom,
    ! [VarCurr: state_type] :
      ( v50459(VarCurr)
    <=> v50461(VarCurr) ) ).

tff(addAssignment_25360,axiom,
    ! [VarCurr: state_type] :
      ( v50461(VarCurr)
    <=> v50463(VarCurr) ) ).

tff(writeUnaryOperator_2868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50463(VarCurr)
    <=> v50477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4683,axiom,
    ! [VarCurr: state_type] :
      ( v50477(VarCurr)
    <=> ( v50478(VarCurr)
        | v50473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4682,axiom,
    ! [VarCurr: state_type] :
      ( v50478(VarCurr)
    <=> ( v50465(VarCurr)
        | v50469(VarCurr) ) ) ).

tff(addAssignment_25359,axiom,
    ! [VarCurr: state_type] :
      ( v50473(VarCurr)
    <=> v50475(VarCurr) ) ).

tff(addAssignment_25358,axiom,
    ! [VarCurr: state_type] :
      ( v50475(VarCurr)
    <=> v49895(VarCurr,2) ) ).

tff(addAssignment_25357,axiom,
    ! [VarCurr: state_type] :
      ( v50469(VarCurr)
    <=> v50471(VarCurr) ) ).

tff(addAssignment_25356,axiom,
    ! [VarCurr: state_type] :
      ( v50471(VarCurr)
    <=> v49978(VarCurr,1) ) ).

tff(addAssignment_25355,axiom,
    ! [VarCurr: state_type] :
      ( v49978(VarCurr,1)
    <=> v49980(VarCurr,1) ) ).

tff(addAssignment_25354,axiom,
    ! [VarCurr: state_type] :
      ( v49980(VarCurr,1)
    <=> v49982(VarCurr,1) ) ).

tff(addAssignment_25353,axiom,
    ! [VarCurr: state_type] :
      ( v49982(VarCurr,1)
    <=> v49987(VarCurr,1) ) ).

tff(addAssignment_25352,axiom,
    ! [VarCurr: state_type] :
      ( v49984(VarCurr,1)
    <=> v49986(VarCurr,1) ) ).

tff(addAssignment_25351,axiom,
    ! [VarCurr: state_type] :
      ( v49986(VarCurr,1)
    <=> v49895(VarCurr,1) ) ).

tff(addAssignment_25350,axiom,
    ! [VarCurr: state_type] :
      ( v50465(VarCurr)
    <=> v50467(VarCurr) ) ).

tff(addAssignment_25349,axiom,
    ! [VarCurr: state_type] :
      ( v50467(VarCurr)
    <=> v49895(VarCurr,0) ) ).

tff(addAssignment_25348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50329(VarCurr,B)
      <=> v50331(VarCurr,B) ) ) ).

tff(addAssignment_25347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50331(VarCurr,B)
      <=> v50333(VarCurr,B) ) ) ).

tff(addAssignment_25346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50333(VarCurr,B)
      <=> v50335(VarCurr,B) ) ) ).

tff(addAssignment_25345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50335(VarCurr,B)
      <=> v50337(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50432(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50337(VarNext,B)
            <=> v50337(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_586,axiom,
    ! [VarNext: state_type] :
      ( v50432(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50337(VarNext,B)
          <=> v50442(VarNext,B) ) ) ) ).

tff(addAssignment_25344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50442(VarNext,B)
          <=> v50440(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50443(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50440(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_381,axiom,
    ! [VarCurr: state_type] :
      ( v50443(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50440(VarCurr,B)
          <=> v50359(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4681,axiom,
    ! [VarCurr: state_type] :
      ( v50443(VarCurr)
    <=> ( v50444(VarCurr)
        & v50445(VarCurr) ) ) ).

tff(writeUnaryOperator_2867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50445(VarCurr)
    <=> v50349(VarCurr) ) ).

tff(writeUnaryOperator_2866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50444(VarCurr)
    <=> v50339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50432(VarNext)
      <=> v50433(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50433(VarNext)
      <=> ( v50434(VarNext)
          & v50363(VarNext) ) ) ) ).

tff(writeUnaryOperator_2865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50434(VarNext)
      <=> v50436(VarNext) ) ) ).

tff(addAssignment_25343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50436(VarNext)
      <=> v50363(VarCurr) ) ) ).

tff(addAssignment_25342,axiom,
    ! [VarCurr: state_type] :
      ( v50363(VarCurr)
    <=> v50365(VarCurr) ) ).

tff(addAssignment_25341,axiom,
    ! [VarCurr: state_type] :
      ( v50365(VarCurr)
    <=> v50367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4678,axiom,
    ! [VarCurr: state_type] :
      ( v50367(VarCurr)
    <=> ( v50429(VarCurr)
        | v50425(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4677,axiom,
    ! [VarCurr: state_type] :
      ( v50429(VarCurr)
    <=> ( v50369(VarCurr)
        & v50373(VarCurr) ) ) ).

tff(addAssignment_25340,axiom,
    ! [VarCurr: state_type] :
      ( v50425(VarCurr)
    <=> v50427(VarCurr) ) ).

tff(addAssignment_25339,axiom,
    ! [VarCurr: state_type] :
      ( v50427(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50409(VarNext)
       => ( v50373(VarNext)
        <=> v50373(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_585,axiom,
    ! [VarNext: state_type] :
      ( v50409(VarNext)
     => ( v50373(VarNext)
      <=> v50419(VarNext) ) ) ).

tff(addAssignment_25338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50419(VarNext)
      <=> v50417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4676,axiom,
    ! [VarCurr: state_type] :
      ( v50417(VarCurr)
    <=> ( v50420(VarCurr)
        & v50421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4675,axiom,
    ! [VarCurr: state_type] :
      ( v50421(VarCurr)
    <=> ( v50379(VarCurr)
        | v50404(VarCurr) ) ) ).

tff(writeUnaryOperator_2864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50420(VarCurr)
    <=> v50375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50409(VarNext)
      <=> v50410(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50410(VarNext)
      <=> ( v50412(VarNext)
          & v50414(VarNext) ) ) ) ).

tff(writeUnaryOperator_2863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50414(VarCurr)
    <=> v50369(VarCurr) ) ).

tff(addAssignment_25337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50412(VarNext)
      <=> v50369(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_218,axiom,
    ( v50373(constB0)
  <=> $true ) ).

tff(addAssignment_25336,axiom,
    ! [VarCurr: state_type] :
      ( v50404(VarCurr)
    <=> v50406(VarCurr) ) ).

tff(addAssignment_25335,axiom,
    ! [VarCurr: state_type] :
      ( v50406(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25334,axiom,
    ! [VarCurr: state_type] :
      ( v50379(VarCurr)
    <=> v50381(VarCurr) ) ).

tff(addAssignment_25333,axiom,
    ! [VarCurr: state_type] :
      ( v50381(VarCurr)
    <=> v50383(VarCurr) ) ).

tff(addAssignment_25332,axiom,
    ! [VarCurr: state_type] :
      ( v50383(VarCurr)
    <=> v50385(VarCurr) ) ).

tff(addAssignment_25331,axiom,
    ! [VarCurr: state_type] :
      ( v50385(VarCurr)
    <=> v50387(VarCurr) ) ).

tff(writeUnaryOperator_2862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50387(VarCurr)
    <=> v50401(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4672,axiom,
    ! [VarCurr: state_type] :
      ( v50401(VarCurr)
    <=> ( v50402(VarCurr)
        | v50397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4671,axiom,
    ! [VarCurr: state_type] :
      ( v50402(VarCurr)
    <=> ( v50389(VarCurr)
        | v50393(VarCurr) ) ) ).

tff(addAssignment_25330,axiom,
    ! [VarCurr: state_type] :
      ( v50397(VarCurr)
    <=> v50399(VarCurr) ) ).

tff(addAssignment_25329,axiom,
    ! [VarCurr: state_type] :
      ( v50399(VarCurr)
    <=> v49805(VarCurr,2) ) ).

tff(addAssignment_25328,axiom,
    ! [VarCurr: state_type] :
      ( v50393(VarCurr)
    <=> v50395(VarCurr) ) ).

tff(addAssignment_25327,axiom,
    ! [VarCurr: state_type] :
      ( v50395(VarCurr)
    <=> v50231(VarCurr,1) ) ).

tff(addAssignment_25326,axiom,
    ! [VarCurr: state_type] :
      ( v50231(VarCurr,1)
    <=> v50233(VarCurr,1) ) ).

tff(addAssignment_25325,axiom,
    ! [VarCurr: state_type] :
      ( v50233(VarCurr,1)
    <=> v50235(VarCurr,1) ) ).

tff(addAssignment_25324,axiom,
    ! [VarCurr: state_type] :
      ( v50235(VarCurr,1)
    <=> v50240(VarCurr,1) ) ).

tff(addAssignment_25323,axiom,
    ! [VarCurr: state_type] :
      ( v50237(VarCurr,1)
    <=> v50239(VarCurr,1) ) ).

tff(addAssignment_25322,axiom,
    ! [VarCurr: state_type] :
      ( v50239(VarCurr,1)
    <=> v49805(VarCurr,1) ) ).

tff(addAssignment_25321,axiom,
    ! [VarCurr: state_type] :
      ( v50389(VarCurr)
    <=> v50391(VarCurr) ) ).

tff(addAssignment_25320,axiom,
    ! [VarCurr: state_type] :
      ( v50391(VarCurr)
    <=> v49805(VarCurr,0) ) ).

tff(addAssignment_25319,axiom,
    ! [VarCurr: state_type] :
      ( v50375(VarCurr)
    <=> v50377(VarCurr) ) ).

tff(addAssignment_25318,axiom,
    ! [VarCurr: state_type] :
      ( v50377(VarCurr)
    <=> $false ) ).

tff(addAssignment_25317,axiom,
    ! [VarCurr: state_type] :
      ( v50369(VarCurr)
    <=> v50371(VarCurr) ) ).

tff(addAssignment_25316,axiom,
    ! [VarCurr: state_type] :
      ( v50371(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25315,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50359(VarCurr,B)
      <=> v50361(VarCurr,B) ) ) ).

tff(addAssignment_25314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50361(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25313,axiom,
    ! [VarCurr: state_type] :
      ( v50349(VarCurr)
    <=> v50351(VarCurr) ) ).

tff(addAssignment_25312,axiom,
    ! [VarCurr: state_type] :
      ( v50351(VarCurr)
    <=> v50353(VarCurr) ) ).

tff(addAssignment_25311,axiom,
    ! [VarCurr: state_type] :
      ( v50353(VarCurr)
    <=> v50355(VarCurr) ) ).

tff(addAssignment_25310,axiom,
    ! [VarCurr: state_type] :
      ( v50355(VarCurr)
    <=> v50357(VarCurr) ) ).

tff(addAssignment_25309,axiom,
    ! [VarCurr: state_type] :
      ( v50357(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25308,axiom,
    ! [VarCurr: state_type] :
      ( v50339(VarCurr)
    <=> v50341(VarCurr) ) ).

tff(addAssignment_25307,axiom,
    ! [VarCurr: state_type] :
      ( v50341(VarCurr)
    <=> v50343(VarCurr) ) ).

tff(addAssignment_25306,axiom,
    ! [VarCurr: state_type] :
      ( v50343(VarCurr)
    <=> v50345(VarCurr) ) ).

tff(addAssignment_25305,axiom,
    ! [VarCurr: state_type] :
      ( v50345(VarCurr)
    <=> v50347(VarCurr) ) ).

tff(addAssignment_25304,axiom,
    ! [VarCurr: state_type] :
      ( v50347(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_25303,axiom,
    ! [VarCurr: state_type] :
      ( v50298(VarCurr)
    <=> v50300(VarCurr) ) ).

tff(addAssignment_25302,axiom,
    ! [VarCurr: state_type] :
      ( v50300(VarCurr)
    <=> v50302(VarCurr) ) ).

tff(addAssignment_25301,axiom,
    ! [VarCurr: state_type] :
      ( v50302(VarCurr)
    <=> v50304(VarCurr) ) ).

tff(addAssignment_25300,axiom,
    ! [VarCurr: state_type] :
      ( v50304(VarCurr)
    <=> v50306(VarCurr) ) ).

tff(addAssignment_25299,axiom,
    ! [VarCurr: state_type] :
      ( v50306(VarCurr)
    <=> v50308(VarCurr) ) ).

tff(addAssignment_25298,axiom,
    ! [VarCurr: state_type] :
      ( v50308(VarCurr)
    <=> v50310(VarCurr) ) ).

tff(addAssignment_25297,axiom,
    ! [VarCurr: state_type] :
      ( v50310(VarCurr)
    <=> v50312(VarCurr) ) ).

tff(writeUnaryOperator_2861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50312(VarCurr)
    <=> v50326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4670,axiom,
    ! [VarCurr: state_type] :
      ( v50326(VarCurr)
    <=> ( v50327(VarCurr)
        | v50322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4669,axiom,
    ! [VarCurr: state_type] :
      ( v50327(VarCurr)
    <=> ( v50314(VarCurr)
        | v50318(VarCurr) ) ) ).

tff(addAssignment_25296,axiom,
    ! [VarCurr: state_type] :
      ( v50322(VarCurr)
    <=> v50324(VarCurr) ) ).

tff(addAssignment_25295,axiom,
    ! [VarCurr: state_type] :
      ( v50324(VarCurr)
    <=> v49895(VarCurr,2) ) ).

tff(addAssignment_25294,axiom,
    ! [VarCurr: state_type] :
      ( v50318(VarCurr)
    <=> v50320(VarCurr) ) ).

tff(addAssignment_25293,axiom,
    ! [VarCurr: state_type] :
      ( v50320(VarCurr)
    <=> v49895(VarCurr,1) ) ).

tff(addAssignment_25292,axiom,
    ! [VarCurr: state_type] :
      ( v50314(VarCurr)
    <=> v50316(VarCurr) ) ).

tff(addAssignment_25291,axiom,
    ! [VarCurr: state_type] :
      ( v50316(VarCurr)
    <=> v49978(VarCurr,0) ) ).

tff(addAssignment_25290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50167(VarCurr,B)
      <=> v50169(VarCurr,B) ) ) ).

tff(addAssignment_25289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50169(VarCurr,B)
      <=> v50171(VarCurr,B) ) ) ).

tff(addAssignment_25288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50171(VarCurr,B)
      <=> v50173(VarCurr,B) ) ) ).

tff(addAssignment_25287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50173(VarCurr,B)
      <=> v50175(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50281(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v50175(VarNext,B)
            <=> v50175(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_584,axiom,
    ! [VarNext: state_type] :
      ( v50281(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50175(VarNext,B)
          <=> v50291(VarNext,B) ) ) ) ).

tff(addAssignment_25286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50291(VarNext,B)
          <=> v50289(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50292(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50289(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_380,axiom,
    ! [VarCurr: state_type] :
      ( v50292(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v50289(VarCurr,B)
          <=> v50197(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4668,axiom,
    ! [VarCurr: state_type] :
      ( v50292(VarCurr)
    <=> ( v50293(VarCurr)
        & v50294(VarCurr) ) ) ).

tff(writeUnaryOperator_2860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50294(VarCurr)
    <=> v50187(VarCurr) ) ).

tff(writeUnaryOperator_2859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50293(VarCurr)
    <=> v50177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50281(VarNext)
      <=> v50282(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50282(VarNext)
      <=> ( v50283(VarNext)
          & v50201(VarNext) ) ) ) ).

tff(writeUnaryOperator_2858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50283(VarNext)
      <=> v50285(VarNext) ) ) ).

tff(addAssignment_25285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50285(VarNext)
      <=> v50201(VarCurr) ) ) ).

tff(addAssignment_25284,axiom,
    ! [VarCurr: state_type] :
      ( v50201(VarCurr)
    <=> v50203(VarCurr) ) ).

tff(addAssignment_25283,axiom,
    ! [VarCurr: state_type] :
      ( v50203(VarCurr)
    <=> v50205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4665,axiom,
    ! [VarCurr: state_type] :
      ( v50205(VarCurr)
    <=> ( v50278(VarCurr)
        | v50274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4664,axiom,
    ! [VarCurr: state_type] :
      ( v50278(VarCurr)
    <=> ( v50207(VarCurr)
        & v50211(VarCurr) ) ) ).

tff(addAssignment_25282,axiom,
    ! [VarCurr: state_type] :
      ( v50274(VarCurr)
    <=> v50276(VarCurr) ) ).

tff(addAssignment_25281,axiom,
    ! [VarCurr: state_type] :
      ( v50276(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50258(VarNext)
       => ( v50211(VarNext)
        <=> v50211(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_583,axiom,
    ! [VarNext: state_type] :
      ( v50258(VarNext)
     => ( v50211(VarNext)
      <=> v50268(VarNext) ) ) ).

tff(addAssignment_25280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50268(VarNext)
      <=> v50266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4663,axiom,
    ! [VarCurr: state_type] :
      ( v50266(VarCurr)
    <=> ( v50269(VarCurr)
        & v50270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4662,axiom,
    ! [VarCurr: state_type] :
      ( v50270(VarCurr)
    <=> ( v50217(VarCurr)
        | v50253(VarCurr) ) ) ).

tff(writeUnaryOperator_2857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50269(VarCurr)
    <=> v50213(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50258(VarNext)
      <=> v50259(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50259(VarNext)
      <=> ( v50261(VarNext)
          & v50263(VarNext) ) ) ) ).

tff(writeUnaryOperator_2856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50263(VarCurr)
    <=> v50207(VarCurr) ) ).

tff(addAssignment_25279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50261(VarNext)
      <=> v50207(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_217,axiom,
    ( v50211(constB0)
  <=> $true ) ).

tff(addAssignment_25278,axiom,
    ! [VarCurr: state_type] :
      ( v50253(VarCurr)
    <=> v50255(VarCurr) ) ).

tff(addAssignment_25277,axiom,
    ! [VarCurr: state_type] :
      ( v50255(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25276,axiom,
    ! [VarCurr: state_type] :
      ( v50217(VarCurr)
    <=> v50219(VarCurr) ) ).

tff(addAssignment_25275,axiom,
    ! [VarCurr: state_type] :
      ( v50219(VarCurr)
    <=> v50221(VarCurr) ) ).

tff(addAssignment_25274,axiom,
    ! [VarCurr: state_type] :
      ( v50221(VarCurr)
    <=> v50223(VarCurr) ) ).

tff(addAssignment_25273,axiom,
    ! [VarCurr: state_type] :
      ( v50223(VarCurr)
    <=> v50225(VarCurr) ) ).

tff(writeUnaryOperator_2855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50225(VarCurr)
    <=> v50250(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4659,axiom,
    ! [VarCurr: state_type] :
      ( v50250(VarCurr)
    <=> ( v50251(VarCurr)
        | v50246(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4658,axiom,
    ! [VarCurr: state_type] :
      ( v50251(VarCurr)
    <=> ( v50227(VarCurr)
        | v50242(VarCurr) ) ) ).

tff(addAssignment_25272,axiom,
    ! [VarCurr: state_type] :
      ( v50246(VarCurr)
    <=> v50248(VarCurr) ) ).

tff(addAssignment_25271,axiom,
    ! [VarCurr: state_type] :
      ( v50248(VarCurr)
    <=> v49805(VarCurr,2) ) ).

tff(addAssignment_25270,axiom,
    ! [VarCurr: state_type] :
      ( v50242(VarCurr)
    <=> v50244(VarCurr) ) ).

tff(addAssignment_25269,axiom,
    ! [VarCurr: state_type] :
      ( v50244(VarCurr)
    <=> v49805(VarCurr,1) ) ).

tff(addAssignment_25268,axiom,
    ! [VarCurr: state_type] :
      ( v50227(VarCurr)
    <=> v50229(VarCurr) ) ).

tff(addAssignment_25267,axiom,
    ! [VarCurr: state_type] :
      ( v50229(VarCurr)
    <=> v50231(VarCurr,0) ) ).

tff(addAssignment_25266,axiom,
    ! [VarCurr: state_type] :
      ( v50231(VarCurr,0)
    <=> v50233(VarCurr,0) ) ).

tff(addAssignment_25265,axiom,
    ! [VarCurr: state_type] :
      ( v50233(VarCurr,0)
    <=> v50235(VarCurr,0) ) ).

tff(addAssignment_25264,axiom,
    ! [VarCurr: state_type] :
      ( v50235(VarCurr,0)
    <=> v50240(VarCurr,0) ) ).

tff(writeUnaryOperator_2854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v50240(VarCurr,B)
      <=> ~ v50237(VarCurr,B) ) ) ).

tff(addAssignment_25263,axiom,
    ! [VarCurr: state_type] :
      ( v50237(VarCurr,0)
    <=> v50239(VarCurr,0) ) ).

tff(addAssignment_25262,axiom,
    ! [VarCurr: state_type] :
      ( v50239(VarCurr,0)
    <=> v49805(VarCurr,0) ) ).

tff(addAssignment_25261,axiom,
    ! [VarCurr: state_type] :
      ( v50213(VarCurr)
    <=> v50215(VarCurr) ) ).

tff(addAssignment_25260,axiom,
    ! [VarCurr: state_type] :
      ( v50215(VarCurr)
    <=> $false ) ).

tff(addAssignment_25259,axiom,
    ! [VarCurr: state_type] :
      ( v50207(VarCurr)
    <=> v50209(VarCurr) ) ).

tff(addAssignment_25258,axiom,
    ! [VarCurr: state_type] :
      ( v50209(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50197(VarCurr,B)
      <=> v50199(VarCurr,B) ) ) ).

tff(addAssignment_25256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v50199(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25255,axiom,
    ! [VarCurr: state_type] :
      ( v50187(VarCurr)
    <=> v50189(VarCurr) ) ).

tff(addAssignment_25254,axiom,
    ! [VarCurr: state_type] :
      ( v50189(VarCurr)
    <=> v50191(VarCurr) ) ).

tff(addAssignment_25253,axiom,
    ! [VarCurr: state_type] :
      ( v50191(VarCurr)
    <=> v50193(VarCurr) ) ).

tff(addAssignment_25252,axiom,
    ! [VarCurr: state_type] :
      ( v50193(VarCurr)
    <=> v50195(VarCurr) ) ).

tff(addAssignment_25251,axiom,
    ! [VarCurr: state_type] :
      ( v50195(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25250,axiom,
    ! [VarCurr: state_type] :
      ( v50177(VarCurr)
    <=> v50179(VarCurr) ) ).

tff(addAssignment_25249,axiom,
    ! [VarCurr: state_type] :
      ( v50179(VarCurr)
    <=> v50181(VarCurr) ) ).

tff(addAssignment_25248,axiom,
    ! [VarCurr: state_type] :
      ( v50181(VarCurr)
    <=> v50183(VarCurr) ) ).

tff(addAssignment_25247,axiom,
    ! [VarCurr: state_type] :
      ( v50183(VarCurr)
    <=> v50185(VarCurr) ) ).

tff(addAssignment_25246,axiom,
    ! [VarCurr: state_type] :
      ( v50185(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_25245,axiom,
    ! [VarCurr: state_type] :
      ( v49875(VarCurr)
    <=> v49877(VarCurr) ) ).

tff(addAssignment_25244,axiom,
    ! [VarCurr: state_type] :
      ( v49877(VarCurr)
    <=> v49879(VarCurr) ) ).

tff(addAssignment_25243,axiom,
    ! [VarCurr: state_type] :
      ( v49879(VarCurr)
    <=> v49881(VarCurr) ) ).

tff(addAssignment_25242,axiom,
    ! [VarCurr: state_type] :
      ( v49881(VarCurr)
    <=> v49883(VarCurr) ) ).

tff(addAssignment_25241,axiom,
    ! [VarCurr: state_type] :
      ( v49883(VarCurr)
    <=> v49885(VarCurr) ) ).

tff(addAssignment_25240,axiom,
    ! [VarCurr: state_type] :
      ( v49885(VarCurr)
    <=> v49887(VarCurr) ) ).

tff(addAssignment_25239,axiom,
    ! [VarCurr: state_type] :
      ( v49887(VarCurr)
    <=> v49889(VarCurr) ) ).

tff(writeUnaryOperator_2853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49889(VarCurr)
    <=> v50164(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4657,axiom,
    ! [VarCurr: state_type] :
      ( v50164(VarCurr)
    <=> ( v50165(VarCurr)
        | v50160(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4656,axiom,
    ! [VarCurr: state_type] :
      ( v50165(VarCurr)
    <=> ( v49891(VarCurr)
        | v50156(VarCurr) ) ) ).

tff(addAssignment_25238,axiom,
    ! [VarCurr: state_type] :
      ( v50160(VarCurr)
    <=> v50162(VarCurr) ) ).

tff(addAssignment_25237,axiom,
    ! [VarCurr: state_type] :
      ( v50162(VarCurr)
    <=> v49895(VarCurr,2) ) ).

tff(addAssignment_25236,axiom,
    ! [VarCurr: state_type] :
      ( v50156(VarCurr)
    <=> v50158(VarCurr) ) ).

tff(addAssignment_25235,axiom,
    ! [VarCurr: state_type] :
      ( v50158(VarCurr)
    <=> v49895(VarCurr,1) ) ).

tff(addAssignment_25234,axiom,
    ! [VarCurr: state_type] :
      ( v49891(VarCurr)
    <=> v49893(VarCurr) ) ).

tff(addAssignment_25233,axiom,
    ! [VarCurr: state_type] :
      ( v49893(VarCurr)
    <=> v49895(VarCurr,0) ) ).

tff(addAssignment_25232,axiom,
    ! [VarCurr: state_type] :
      ( v49895(VarCurr,0)
    <=> v49807(VarCurr,3) ) ).

tff(addAssignment_25231,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,3)
    <=> v49809(VarCurr,3) ) ).

tff(addAssignment_25230,axiom,
    ! [VarNext: state_type] :
      ( v49809(VarNext,3)
    <=> v50148(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50149(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v50148(VarNext,B)
            <=> v49809(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_582,axiom,
    ! [VarNext: state_type] :
      ( v50149(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50148(VarNext,B)
          <=> v50120(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50149(VarNext)
      <=> v50150(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50150(VarNext)
      <=> ( v50152(VarNext)
          & v50062(VarNext) ) ) ) ).

tff(writeUnaryOperator_2852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50152(VarNext)
      <=> v50114(VarNext) ) ) ).

tff(addAssignment_25229,axiom,
    ! [VarCurr: state_type] :
      ( v49919(VarCurr,3)
    <=> v49921(VarCurr,3) ) ).

tff(addAssignment_25228,axiom,
    ! [VarCurr: state_type] :
      ( v49921(VarCurr,3)
    <=> v50059(VarCurr,3) ) ).

tff(addAssignment_25227,axiom,
    ! [VarCurr: state_type] :
      ( v49923(VarCurr,0)
    <=> v49925(VarCurr,0) ) ).

tff(addAssignment_25226,axiom,
    ! [VarCurr: state_type] :
      ( v49925(VarCurr,0)
    <=> v49927(VarCurr,0) ) ).

tff(addAssignment_25225,axiom,
    ! [VarCurr: state_type] :
      ( v49927(VarCurr,0)
    <=> v50058(VarCurr,0) ) ).

tff(addAssignment_25224,axiom,
    ! [VarCurr: state_type] :
      ( v49995(VarCurr,0)
    <=> v49997(VarCurr,0) ) ).

tff(addAssignment_25223,axiom,
    ! [VarCurr: state_type] :
      ( v49997(VarCurr,0)
    <=> v49999(VarCurr,0) ) ).

tff(addAssignment_25222,axiom,
    ! [VarCurr: state_type] :
      ( v49999(VarCurr,0)
    <=> v50001(VarCurr,0) ) ).

tff(addAssignment_25221,axiom,
    ! [VarCurr: state_type] :
      ( v50001(VarCurr,0)
    <=> v50003(VarCurr,0) ) ).

tff(addAssignment_25220,axiom,
    ! [VarCurr: state_type] :
      ( v50003(VarCurr,0)
    <=> v50013(VarCurr,0) ) ).

tff(addAssignment_25219,axiom,
    ! [VarCurr: state_type] :
      ( v49929(VarCurr,0)
    <=> v49931(VarCurr,0) ) ).

tff(addAssignment_25218,axiom,
    ! [VarCurr: state_type] :
      ( v49931(VarCurr,0)
    <=> v49992(VarCurr,0) ) ).

tff(addAssignment_25217,axiom,
    ! [VarCurr: state_type] :
      ( v49933(VarCurr)
    <=> v49459(VarCurr,2) ) ).

tff(addAssignment_25216,axiom,
    ! [VarCurr: state_type] :
      ( v49459(VarCurr,2)
    <=> v49461(VarCurr,2) ) ).

tff(addAssignment_25215,axiom,
    ! [VarCurr: state_type] :
      ( v49461(VarCurr,2)
    <=> v49471(VarCurr,2) ) ).

tff(addAssignment_25214,axiom,
    ! [VarCurr: state_type] :
      ( v49463(VarCurr,2)
    <=> v49465(VarCurr,2) ) ).

tff(addAssignment_25213,axiom,
    ! [VarCurr: state_type] :
      ( v49465(VarCurr,2)
    <=> v49468(VarCurr,2) ) ).

tff(addAssignment_25212,axiom,
    ! [VarCurr: state_type] :
      ( v49469(VarCurr)
    <=> v49936(VarCurr,1) ) ).

tff(addAssignment_25211,axiom,
    ! [VarCurr: state_type] :
      ( v49936(VarCurr,1)
    <=> v49938(VarCurr,1) ) ).

tff(addAssignment_25210,axiom,
    ! [VarCurr: state_type] :
      ( v49938(VarCurr,1)
    <=> v50146(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v50146(VarCurr,B)
      <=> ( v49940(VarCurr,B)
          | v49946(VarCurr,B) ) ) ) ).

tff(addAssignment_25209,axiom,
    ! [VarCurr: state_type] :
      ( v49946(VarCurr,1)
    <=> v49948(VarCurr,1) ) ).

tff(addAssignment_25208,axiom,
    ! [VarCurr: state_type] :
      ( v49948(VarCurr,1)
    <=> v50144(VarCurr,1) ) ).

tff(addAssignment_25207,axiom,
    ! [VarCurr: state_type] :
      ( v50144(VarCurr,0)
    <=> v50145(VarCurr) ) ).

tff(addAssignment_25206,axiom,
    ! [VarCurr: state_type] :
      ( v50144(VarCurr,1)
    <=> v49950(VarCurr) ) ).

tff(addAssignment_25205,axiom,
    ! [VarCurr: state_type] :
      ( v49950(VarCurr)
    <=> v49952(VarCurr,1) ) ).

tff(addAssignment_25204,axiom,
    ! [VarCurr: state_type] :
      ( v49952(VarCurr,1)
    <=> v49954(VarCurr,1) ) ).

tff(addAssignment_25203,axiom,
    ! [VarCurr: state_type] :
      ( v49954(VarCurr,1)
    <=> v50143(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v50143(VarCurr,B)
      <=> ( v49956(VarCurr,B)
          & v49964(VarCurr,B) ) ) ) ).

tff(addAssignment_25202,axiom,
    ! [VarCurr: state_type] :
      ( v49964(VarCurr,1)
    <=> v49966(VarCurr,1) ) ).

tff(addAssignment_25201,axiom,
    ! [VarCurr: state_type] :
      ( v49966(VarCurr,1)
    <=> v50141(VarCurr,1) ) ).

tff(addAssignment_25200,axiom,
    ! [VarCurr: state_type] :
      ( v50141(VarCurr,0)
    <=> v50142(VarCurr) ) ).

tff(addAssignment_25199,axiom,
    ! [VarCurr: state_type] :
      ( v50141(VarCurr,1)
    <=> v49968(VarCurr) ) ).

tff(addAssignment_25198,axiom,
    ! [VarCurr: state_type] :
      ( v49968(VarCurr)
    <=> v49970(VarCurr) ) ).

tff(addAssignment_25197,axiom,
    ! [VarCurr: state_type] :
      ( v49970(VarCurr)
    <=> v49972(VarCurr) ) ).

tff(writeUnaryOperator_2851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49972(VarCurr)
    <=> v50139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4653,axiom,
    ! [VarCurr: state_type] :
      ( v50139(VarCurr)
    <=> ( v50140(VarCurr)
        | v50127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4652,axiom,
    ! [VarCurr: state_type] :
      ( v50140(VarCurr)
    <=> ( v49974(VarCurr)
        | v49989(VarCurr) ) ) ).

tff(addAssignment_25196,axiom,
    ! [VarCurr: state_type] :
      ( v50127(VarCurr)
    <=> v50129(VarCurr) ) ).

tff(addAssignment_25195,axiom,
    ! [VarCurr: state_type] :
      ( v50129(VarCurr)
    <=> v49978(VarCurr,2) ) ).

tff(addAssignment_25194,axiom,
    ! [VarCurr: state_type] :
      ( v49978(VarCurr,2)
    <=> v49980(VarCurr,2) ) ).

tff(addAssignment_25193,axiom,
    ! [VarCurr: state_type] :
      ( v49980(VarCurr,2)
    <=> v49982(VarCurr,2) ) ).

tff(addAssignment_25192,axiom,
    ! [VarCurr: state_type] :
      ( v49982(VarCurr,2)
    <=> v49987(VarCurr,2) ) ).

tff(addAssignment_25191,axiom,
    ! [VarCurr: state_type] :
      ( v49984(VarCurr,2)
    <=> v49986(VarCurr,2) ) ).

tff(addAssignment_25190,axiom,
    ! [VarCurr: state_type] :
      ( v49986(VarCurr,2)
    <=> v49895(VarCurr,2) ) ).

tff(addAssignment_25189,axiom,
    ! [VarCurr: state_type] :
      ( v49895(VarCurr,2)
    <=> v49807(VarCurr,5) ) ).

tff(addAssignment_25188,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,5)
    <=> v49809(VarCurr,5) ) ).

tff(addAssignment_25187,axiom,
    ! [VarNext: state_type] :
      ( v49809(VarNext,5)
    <=> v50131(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_581,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50132(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v50131(VarNext,B)
            <=> v49809(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_581,axiom,
    ! [VarNext: state_type] :
      ( v50132(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50131(VarNext,B)
          <=> v50120(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50132(VarNext)
      <=> v50133(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50133(VarNext)
      <=> ( v50135(VarNext)
          & v50062(VarNext) ) ) ) ).

tff(writeUnaryOperator_2850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50135(VarNext)
      <=> v50114(VarNext) ) ) ).

tff(addAssignment_25186,axiom,
    ! [VarCurr: state_type] :
      ( v49919(VarCurr,5)
    <=> v49921(VarCurr,5) ) ).

tff(addAssignment_25185,axiom,
    ! [VarCurr: state_type] :
      ( v49921(VarCurr,5)
    <=> v50059(VarCurr,5) ) ).

tff(addAssignment_25184,axiom,
    ! [VarCurr: state_type] :
      ( v49923(VarCurr,2)
    <=> v49925(VarCurr,2) ) ).

tff(addAssignment_25183,axiom,
    ! [VarCurr: state_type] :
      ( v49925(VarCurr,2)
    <=> v49927(VarCurr,2) ) ).

tff(addAssignment_25182,axiom,
    ! [VarCurr: state_type] :
      ( v49927(VarCurr,2)
    <=> v50058(VarCurr,2) ) ).

tff(addAssignment_25181,axiom,
    ! [VarCurr: state_type] :
      ( v49995(VarCurr,2)
    <=> v49997(VarCurr,2) ) ).

tff(addAssignment_25180,axiom,
    ! [VarCurr: state_type] :
      ( v49997(VarCurr,2)
    <=> v49999(VarCurr,2) ) ).

tff(addAssignment_25179,axiom,
    ! [VarCurr: state_type] :
      ( v49999(VarCurr,2)
    <=> v50001(VarCurr,2) ) ).

tff(addAssignment_25178,axiom,
    ! [VarCurr: state_type] :
      ( v50001(VarCurr,2)
    <=> v50003(VarCurr,2) ) ).

tff(addAssignment_25177,axiom,
    ! [VarCurr: state_type] :
      ( v50003(VarCurr,2)
    <=> v50013(VarCurr,2) ) ).

tff(addAssignment_25176,axiom,
    ! [VarCurr: state_type] :
      ( v50005(VarCurr,2)
    <=> v50007(VarCurr,2) ) ).

tff(addAssignment_25175,axiom,
    ! [VarCurr: state_type] :
      ( v50007(VarCurr,2)
    <=> v50008(VarCurr,2) ) ).

tff(addAssignment_25174,axiom,
    ! [VarCurr: state_type] :
      ( v49929(VarCurr,2)
    <=> v49931(VarCurr,2) ) ).

tff(addAssignment_25173,axiom,
    ! [VarCurr: state_type] :
      ( v49931(VarCurr,2)
    <=> v49992(VarCurr,2) ) ).

tff(addAssignment_25172,axiom,
    ! [VarCurr: state_type] :
      ( v49989(VarCurr)
    <=> v49991(VarCurr) ) ).

tff(addAssignment_25171,axiom,
    ! [VarCurr: state_type] :
      ( v49991(VarCurr)
    <=> v49895(VarCurr,1) ) ).

tff(addAssignment_25170,axiom,
    ! [VarCurr: state_type] :
      ( v49895(VarCurr,1)
    <=> v49807(VarCurr,4) ) ).

tff(addAssignment_25169,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,4)
    <=> v49809(VarCurr,4) ) ).

tff(addAssignment_25168,axiom,
    ! [VarNext: state_type] :
      ( v49809(VarNext,4)
    <=> v50109(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50110(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v50109(VarNext,B)
            <=> v49809(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_580,axiom,
    ! [VarNext: state_type] :
      ( v50110(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50109(VarNext,B)
          <=> v50120(VarNext,B) ) ) ) ).

tff(addAssignment_25167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50120(VarNext,B)
          <=> v50118(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50121(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50118(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_379,axiom,
    ! [VarCurr: state_type] :
      ( v50121(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v50118(VarCurr,B)
          <=> v49919(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4649,axiom,
    ! [VarCurr: state_type] :
      ( v50121(VarCurr)
    <=> ( v50122(VarCurr)
        & v50123(VarCurr) ) ) ).

tff(writeUnaryOperator_2849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50123(VarCurr)
    <=> v49909(VarCurr) ) ).

tff(writeUnaryOperator_2848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50122(VarCurr)
    <=> v49897(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50110(VarNext)
      <=> v50111(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50111(VarNext)
      <=> ( v50112(VarNext)
          & v50062(VarNext) ) ) ) ).

tff(writeUnaryOperator_2847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50112(VarNext)
      <=> v50114(VarNext) ) ) ).

tff(addAssignment_25166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50114(VarNext)
      <=> v50062(VarCurr) ) ) ).

tff(addAssignment_25165,axiom,
    ! [VarCurr: state_type] :
      ( v50062(VarCurr)
    <=> v50064(VarCurr) ) ).

tff(addAssignment_25164,axiom,
    ! [VarCurr: state_type] :
      ( v50064(VarCurr)
    <=> v50066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4646,axiom,
    ! [VarCurr: state_type] :
      ( v50066(VarCurr)
    <=> ( v50107(VarCurr)
        | v50103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4645,axiom,
    ! [VarCurr: state_type] :
      ( v50107(VarCurr)
    <=> ( v50068(VarCurr)
        & v50072(VarCurr) ) ) ).

tff(addAssignment_25163,axiom,
    ! [VarCurr: state_type] :
      ( v50103(VarCurr)
    <=> v50105(VarCurr) ) ).

tff(addAssignment_25162,axiom,
    ! [VarCurr: state_type] :
      ( v50105(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v50087(VarNext)
       => ( v50072(VarNext)
        <=> v50072(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_579,axiom,
    ! [VarNext: state_type] :
      ( v50087(VarNext)
     => ( v50072(VarNext)
      <=> v50097(VarNext) ) ) ).

tff(addAssignment_25161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50097(VarNext)
      <=> v50095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4644,axiom,
    ! [VarCurr: state_type] :
      ( v50095(VarCurr)
    <=> ( v50098(VarCurr)
        & v50099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4643,axiom,
    ! [VarCurr: state_type] :
      ( v50099(VarCurr)
    <=> ( v50078(VarCurr)
        | v50082(VarCurr) ) ) ).

tff(writeUnaryOperator_2846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50098(VarCurr)
    <=> v50074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50087(VarNext)
      <=> v50088(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50088(VarNext)
      <=> ( v50090(VarNext)
          & v50092(VarNext) ) ) ) ).

tff(writeUnaryOperator_2845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50092(VarCurr)
    <=> v50068(VarCurr) ) ).

tff(addAssignment_25160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v50090(VarNext)
      <=> v50068(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_216,axiom,
    ( v50072(constB0)
  <=> $true ) ).

tff(addAssignment_25159,axiom,
    ! [VarCurr: state_type] :
      ( v50082(VarCurr)
    <=> v50084(VarCurr) ) ).

tff(addAssignment_25158,axiom,
    ! [VarCurr: state_type] :
      ( v50084(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25157,axiom,
    ! [VarCurr: state_type] :
      ( v50078(VarCurr)
    <=> v50080(VarCurr) ) ).

tff(addAssignment_25156,axiom,
    ! [VarCurr: state_type] :
      ( v50080(VarCurr)
    <=> $true ) ).

tff(addAssignment_25155,axiom,
    ! [VarCurr: state_type] :
      ( v50074(VarCurr)
    <=> v50076(VarCurr) ) ).

tff(addAssignment_25154,axiom,
    ! [VarCurr: state_type] :
      ( v50076(VarCurr)
    <=> $false ) ).

tff(addAssignment_25153,axiom,
    ! [VarCurr: state_type] :
      ( v50068(VarCurr)
    <=> v50070(VarCurr) ) ).

tff(addAssignment_25152,axiom,
    ! [VarCurr: state_type] :
      ( v50070(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25151,axiom,
    ! [VarCurr: state_type] :
      ( v49919(VarCurr,4)
    <=> v49921(VarCurr,4) ) ).

tff(addAssignment_25150,axiom,
    ! [VarCurr: state_type] :
      ( v49921(VarCurr,4)
    <=> v50059(VarCurr,4) ) ).

tff(addAssignment_25149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v50059(VarCurr,B)
      <=> v50060(VarCurr,B) ) ) ).

tff(addAssignment_25148,axiom,
    ! [VarCurr: state_type] :
      ( ( v50059(VarCurr,5)
      <=> v49923(VarCurr,2) )
      & ( v50059(VarCurr,4)
      <=> v49923(VarCurr,1) )
      & ( v50059(VarCurr,3)
      <=> v49923(VarCurr,0) ) ) ).

tff(addAssignment_25147,axiom,
    ! [VarCurr: state_type] :
      ( v49923(VarCurr,1)
    <=> v49925(VarCurr,1) ) ).

tff(addAssignment_25146,axiom,
    ! [VarCurr: state_type] :
      ( v49925(VarCurr,1)
    <=> v49927(VarCurr,1) ) ).

tff(addAssignment_25145,axiom,
    ! [VarCurr: state_type] :
      ( v49927(VarCurr,1)
    <=> v50058(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v50058(VarCurr,B)
      <=> ( v49929(VarCurr,B)
          & v49995(VarCurr,B) ) ) ) ).

tff(addAssignment_25144,axiom,
    ! [VarCurr: state_type] :
      ( v49995(VarCurr,1)
    <=> v49997(VarCurr,1) ) ).

tff(addAssignment_25143,axiom,
    ! [VarCurr: state_type] :
      ( v49997(VarCurr,1)
    <=> v49999(VarCurr,1) ) ).

tff(addAssignment_25142,axiom,
    ! [VarCurr: state_type] :
      ( v49999(VarCurr,1)
    <=> v50001(VarCurr,1) ) ).

tff(addAssignment_25141,axiom,
    ! [VarCurr: state_type] :
      ( v50001(VarCurr,1)
    <=> v50003(VarCurr,1) ) ).

tff(addAssignment_25140,axiom,
    ! [VarCurr: state_type] :
      ( v50003(VarCurr,1)
    <=> v50013(VarCurr,1) ) ).

tff(addAssignment_25139,axiom,
    ! [VarCurr: state_type] :
      ( v50013(VarCurr,0)
    <=> v50053(VarCurr) ) ).

tff(addAssignment_25138,axiom,
    ! [VarCurr: state_type] :
      ( v50013(VarCurr,1)
    <=> v50048(VarCurr) ) ).

tff(addAssignment_25137,axiom,
    ! [VarCurr: state_type] :
      ( v50013(VarCurr,2)
    <=> v50043(VarCurr) ) ).

tff(addAssignment_25136,axiom,
    ! [VarCurr: state_type] :
      ( v50013(VarCurr,3)
    <=> v50015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4640,axiom,
    ! [VarCurr: state_type] :
      ( v50053(VarCurr)
    <=> ( v50054(VarCurr)
        & v50057(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4639,axiom,
    ! [VarCurr: state_type] :
      ( v50057(VarCurr)
    <=> ( v50005(VarCurr,0)
        | v50023(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4638,axiom,
    ! [VarCurr: state_type] :
      ( v50054(VarCurr)
    <=> ( v50055(VarCurr)
        | v50056(VarCurr) ) ) ).

tff(writeUnaryOperator_2844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50056(VarCurr)
    <=> v50023(VarCurr,0) ) ).

tff(writeUnaryOperator_2843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50055(VarCurr)
    <=> v50005(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4637,axiom,
    ! [VarCurr: state_type] :
      ( v50048(VarCurr)
    <=> ( v50049(VarCurr)
        & v50052(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4636,axiom,
    ! [VarCurr: state_type] :
      ( v50052(VarCurr)
    <=> ( v50022(VarCurr)
        | v50024(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4635,axiom,
    ! [VarCurr: state_type] :
      ( v50049(VarCurr)
    <=> ( v50050(VarCurr)
        | v50051(VarCurr) ) ) ).

tff(writeUnaryOperator_2842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50051(VarCurr)
    <=> v50024(VarCurr) ) ).

tff(writeUnaryOperator_2841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50050(VarCurr)
    <=> v50022(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4634,axiom,
    ! [VarCurr: state_type] :
      ( v50043(VarCurr)
    <=> ( v50044(VarCurr)
        & v50047(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4633,axiom,
    ! [VarCurr: state_type] :
      ( v50047(VarCurr)
    <=> ( v50020(VarCurr)
        | v50030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4632,axiom,
    ! [VarCurr: state_type] :
      ( v50044(VarCurr)
    <=> ( v50045(VarCurr)
        | v50046(VarCurr) ) ) ).

tff(writeUnaryOperator_2840,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50046(VarCurr)
    <=> v50030(VarCurr) ) ).

tff(writeUnaryOperator_2839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50045(VarCurr)
    <=> v50020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4631,axiom,
    ! [VarCurr: state_type] :
      ( v50015(VarCurr)
    <=> ( v50016(VarCurr)
        & v50042(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4630,axiom,
    ! [VarCurr: state_type] :
      ( v50042(VarCurr)
    <=> ( v50018(VarCurr)
        | v50037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4629,axiom,
    ! [VarCurr: state_type] :
      ( v50016(VarCurr)
    <=> ( v50017(VarCurr)
        | v50036(VarCurr) ) ) ).

tff(writeUnaryOperator_2838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50036(VarCurr)
    <=> v50037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4628,axiom,
    ! [VarCurr: state_type] :
      ( v50037(VarCurr)
    <=> ( v50038(VarCurr)
        & v50041(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_548,axiom,
    ! [VarCurr: state_type] :
      ( v50041(VarCurr)
    <=> ( v50005(VarCurr,3)
        | v50023(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4627,axiom,
    ! [VarCurr: state_type] :
      ( v50038(VarCurr)
    <=> ( v50039(VarCurr)
        | v50040(VarCurr) ) ) ).

tff(writeUnaryOperator_2837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50040(VarCurr)
    <=> v50023(VarCurr,3) ) ).

tff(writeUnaryOperator_2836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50039(VarCurr)
    <=> v50005(VarCurr,3) ) ).

tff(writeUnaryOperator_2835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50017(VarCurr)
    <=> v50018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4626,axiom,
    ! [VarCurr: state_type] :
      ( v50018(VarCurr)
    <=> ( v50019(VarCurr)
        | v50035(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_547,axiom,
    ! [VarCurr: state_type] :
      ( v50035(VarCurr)
    <=> ( v50005(VarCurr,2)
        & v50023(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4625,axiom,
    ! [VarCurr: state_type] :
      ( v50019(VarCurr)
    <=> ( v50020(VarCurr)
        & v50030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4624,axiom,
    ! [VarCurr: state_type] :
      ( v50030(VarCurr)
    <=> ( v50031(VarCurr)
        & v50034(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_546,axiom,
    ! [VarCurr: state_type] :
      ( v50034(VarCurr)
    <=> ( v50005(VarCurr,2)
        | v50023(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4623,axiom,
    ! [VarCurr: state_type] :
      ( v50031(VarCurr)
    <=> ( v50032(VarCurr)
        | v50033(VarCurr) ) ) ).

tff(writeUnaryOperator_2834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50033(VarCurr)
    <=> v50023(VarCurr,2) ) ).

tff(writeUnaryOperator_2833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50032(VarCurr)
    <=> v50005(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4622,axiom,
    ! [VarCurr: state_type] :
      ( v50020(VarCurr)
    <=> ( v50021(VarCurr)
        | v50029(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_545,axiom,
    ! [VarCurr: state_type] :
      ( v50029(VarCurr)
    <=> ( v50005(VarCurr,1)
        & v50023(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4621,axiom,
    ! [VarCurr: state_type] :
      ( v50021(VarCurr)
    <=> ( v50022(VarCurr)
        & v50024(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4620,axiom,
    ! [VarCurr: state_type] :
      ( v50024(VarCurr)
    <=> ( v50025(VarCurr)
        & v50028(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_544,axiom,
    ! [VarCurr: state_type] :
      ( v50028(VarCurr)
    <=> ( v50005(VarCurr,1)
        | v50023(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4619,axiom,
    ! [VarCurr: state_type] :
      ( v50025(VarCurr)
    <=> ( v50026(VarCurr)
        | v50027(VarCurr) ) ) ).

tff(writeUnaryOperator_2832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50027(VarCurr)
    <=> v50023(VarCurr,1) ) ).

tff(writeUnaryOperator_2831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v50026(VarCurr)
    <=> v50005(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4618,axiom,
    ! [VarCurr: state_type] :
      ( v50022(VarCurr)
    <=> ( v50005(VarCurr,0)
        & v50023(VarCurr,0) ) ) ).

tff(addAssignment_25135,axiom,
    ! [VarCurr: state_type] :
      ( v50023(VarCurr,0)
    <=> v50010(VarCurr) ) ).

tff(addAssignment_25134,axiom,
    ! [VarCurr: state_type] :
      ( ( v50023(VarCurr,3)
      <=> $false )
      & ( v50023(VarCurr,2)
      <=> $false )
      & ( v50023(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_25133,axiom,
    ! [VarCurr: state_type] :
      ( v50010(VarCurr)
    <=> v50012(VarCurr) ) ).

tff(addAssignment_25132,axiom,
    ! [VarCurr: state_type] :
      ( v50012(VarCurr)
    <=> v49960(VarCurr) ) ).

tff(addAssignment_25131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v50005(VarCurr,B)
      <=> v50007(VarCurr,B) ) ) ).

tff(addAssignment_25130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v50007(VarCurr,B)
      <=> v50008(VarCurr,B) ) ) ).

tff(addAssignment_25129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v50008(VarCurr,B)
      <=> v49895(VarCurr,B) ) ) ).

tff(addAssignment_25128,axiom,
    ! [VarCurr: state_type] :
      ( v50008(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_25127,axiom,
    ! [VarCurr: state_type] :
      ( v49929(VarCurr,1)
    <=> v49931(VarCurr,1) ) ).

tff(addAssignment_25126,axiom,
    ! [VarCurr: state_type] :
      ( v49931(VarCurr,1)
    <=> v49992(VarCurr,1) ) ).

tff(addAssignment_25125,axiom,
    ! [VarCurr: state_type] :
      ( v49992(VarCurr,0)
    <=> v49993(VarCurr) ) ).

tff(addAssignment_25124,axiom,
    ! [VarCurr: state_type] :
      ( v49992(VarCurr,1)
    <=> v49993(VarCurr) ) ).

tff(addAssignment_25123,axiom,
    ! [VarCurr: state_type] :
      ( v49992(VarCurr,2)
    <=> v49993(VarCurr) ) ).

tff(addAssignment_25122,axiom,
    ! [VarCurr: state_type] :
      ( v49993(VarCurr)
    <=> v49933(VarCurr) ) ).

tff(addAssignment_25121,axiom,
    ! [VarCurr: state_type] :
      ( v49974(VarCurr)
    <=> v49976(VarCurr) ) ).

tff(addAssignment_25120,axiom,
    ! [VarCurr: state_type] :
      ( v49976(VarCurr)
    <=> v49978(VarCurr,0) ) ).

tff(addAssignment_25119,axiom,
    ! [VarCurr: state_type] :
      ( v49978(VarCurr,0)
    <=> v49980(VarCurr,0) ) ).

tff(addAssignment_25118,axiom,
    ! [VarCurr: state_type] :
      ( v49980(VarCurr,0)
    <=> v49982(VarCurr,0) ) ).

tff(addAssignment_25117,axiom,
    ! [VarCurr: state_type] :
      ( v49982(VarCurr,0)
    <=> v49987(VarCurr,0) ) ).

tff(writeUnaryOperator_2830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v49987(VarCurr,B)
      <=> ~ v49984(VarCurr,B) ) ) ).

tff(addAssignment_25116,axiom,
    ! [VarCurr: state_type] :
      ( v49984(VarCurr,0)
    <=> v49986(VarCurr,0) ) ).

tff(addAssignment_25115,axiom,
    ! [VarCurr: state_type] :
      ( v49986(VarCurr,0)
    <=> v49895(VarCurr,0) ) ).

tff(addAssignment_25114,axiom,
    ! [VarCurr: state_type] :
      ( v49956(VarCurr,1)
    <=> v49958(VarCurr,1) ) ).

tff(addAssignment_25113,axiom,
    ! [VarCurr: state_type] :
      ( v49958(VarCurr,1)
    <=> v49961(VarCurr,1) ) ).

tff(addAssignment_25112,axiom,
    ! [VarCurr: state_type] :
      ( v49961(VarCurr,0)
    <=> v49962(VarCurr) ) ).

tff(addAssignment_25111,axiom,
    ! [VarCurr: state_type] :
      ( v49961(VarCurr,1)
    <=> v49960(VarCurr) ) ).

tff(addAssignment_25110,axiom,
    ! [VarCurr: state_type] :
      ( v49960(VarCurr)
    <=> v7230(VarCurr,12) ) ).

tff(addAssignment_25109,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,12)
    <=> v7232(VarCurr,12) ) ).

tff(addAssignment_25108,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,12)
    <=> v7234(VarCurr,12) ) ).

tff(addAssignment_25107,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,12)
    <=> v34455(VarCurr,12) ) ).

tff(addAssignment_25106,axiom,
    ! [VarCurr: state_type] :
      ( v49940(VarCurr,1)
    <=> v49942(VarCurr,1) ) ).

tff(addAssignment_25105,axiom,
    ! [VarCurr: state_type] :
      ( v49942(VarCurr,1)
    <=> v49943(VarCurr,1) ) ).

tff(addAssignment_25104,axiom,
    ! [VarCurr: state_type] :
      ( v49943(VarCurr,0)
    <=> v49944(VarCurr) ) ).

tff(addAssignment_25103,axiom,
    ! [VarCurr: state_type] :
      ( v49943(VarCurr,1)
    <=> v49944(VarCurr) ) ).

tff(addAssignment_25102,axiom,
    ! [VarCurr: state_type] :
      ( v49944(VarCurr)
    <=> v49467(VarCurr) ) ).

tff(addAssignment_25101,axiom,
    ! [VarCurr: state_type] :
      ( v49909(VarCurr)
    <=> v49911(VarCurr) ) ).

tff(addAssignment_25100,axiom,
    ! [VarCurr: state_type] :
      ( v49911(VarCurr)
    <=> v49913(VarCurr) ) ).

tff(addAssignment_25099,axiom,
    ! [VarCurr: state_type] :
      ( v49913(VarCurr)
    <=> v49915(VarCurr) ) ).

tff(addAssignment_25098,axiom,
    ! [VarCurr: state_type] :
      ( v49915(VarCurr)
    <=> v49917(VarCurr) ) ).

tff(addAssignment_25097,axiom,
    ! [VarCurr: state_type] :
      ( v49917(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_25096,axiom,
    ! [VarCurr: state_type] :
      ( v49897(VarCurr)
    <=> v49899(VarCurr) ) ).

tff(addAssignment_25095,axiom,
    ! [VarCurr: state_type] :
      ( v49899(VarCurr)
    <=> v49901(VarCurr) ) ).

tff(addAssignment_25094,axiom,
    ! [VarCurr: state_type] :
      ( v49901(VarCurr)
    <=> v49903(VarCurr) ) ).

tff(addAssignment_25093,axiom,
    ! [VarCurr: state_type] :
      ( v49903(VarCurr)
    <=> v49905(VarCurr) ) ).

tff(addAssignment_25092,axiom,
    ! [VarCurr: state_type] :
      ( v49905(VarCurr)
    <=> v49907(VarCurr) ) ).

tff(addAssignment_25091,axiom,
    ! [VarCurr: state_type] :
      ( v49907(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_25090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49405(VarCurr,B)
      <=> v49407(VarCurr,B) ) ) ).

tff(addAssignment_25089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49407(VarCurr,B)
      <=> v49409(VarCurr,B) ) ) ).

tff(addAssignment_25088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49409(VarCurr,B)
      <=> v49411(VarCurr,B) ) ) ).

tff(addAssignment_25087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49411(VarCurr,B)
      <=> v49413(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49858(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v49413(VarNext,B)
            <=> v49413(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_578,axiom,
    ! [VarNext: state_type] :
      ( v49858(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49413(VarNext,B)
          <=> v49868(VarNext,B) ) ) ) ).

tff(addAssignment_25086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49868(VarNext,B)
          <=> v49866(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49866(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_378,axiom,
    ! [VarCurr: state_type] :
      ( v49869(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49866(VarCurr,B)
          <=> v49443(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4617,axiom,
    ! [VarCurr: state_type] :
      ( v49869(VarCurr)
    <=> ( v49870(VarCurr)
        & v49871(VarCurr) ) ) ).

tff(writeUnaryOperator_2829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49871(VarCurr)
    <=> v49429(VarCurr) ) ).

tff(writeUnaryOperator_2828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49870(VarCurr)
    <=> v49415(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49858(VarNext)
      <=> v49859(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49859(VarNext)
      <=> ( v49860(VarNext)
          & v49773(VarNext) ) ) ) ).

tff(writeUnaryOperator_2827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49860(VarNext)
      <=> v49862(VarNext) ) ) ).

tff(addAssignment_25085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49862(VarNext)
      <=> v49773(VarCurr) ) ) ).

tff(addAssignment_25084,axiom,
    ! [VarCurr: state_type] :
      ( v49773(VarCurr)
    <=> v49775(VarCurr) ) ).

tff(addAssignment_25083,axiom,
    ! [VarCurr: state_type] :
      ( v49775(VarCurr)
    <=> v49777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4614,axiom,
    ! [VarCurr: state_type] :
      ( v49777(VarCurr)
    <=> ( v49855(VarCurr)
        | v49847(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4613,axiom,
    ! [VarCurr: state_type] :
      ( v49855(VarCurr)
    <=> ( v49779(VarCurr)
        & v49785(VarCurr) ) ) ).

tff(addAssignment_25082,axiom,
    ! [VarCurr: state_type] :
      ( v49847(VarCurr)
    <=> v49849(VarCurr) ) ).

tff(addAssignment_25081,axiom,
    ! [VarCurr: state_type] :
      ( v49849(VarCurr)
    <=> v49851(VarCurr) ) ).

tff(addAssignment_25080,axiom,
    ! [VarCurr: state_type] :
      ( v49851(VarCurr)
    <=> v49853(VarCurr) ) ).

tff(addAssignment_25079,axiom,
    ! [VarCurr: state_type] :
      ( v49853(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49831(VarNext)
       => ( v49785(VarNext)
        <=> v49785(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_577,axiom,
    ! [VarNext: state_type] :
      ( v49831(VarNext)
     => ( v49785(VarNext)
      <=> v49841(VarNext) ) ) ).

tff(addAssignment_25078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49841(VarNext)
      <=> v49839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4612,axiom,
    ! [VarCurr: state_type] :
      ( v49839(VarCurr)
    <=> ( v49842(VarCurr)
        & v49843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4611,axiom,
    ! [VarCurr: state_type] :
      ( v49843(VarCurr)
    <=> ( v49791(VarCurr)
        | v49822(VarCurr) ) ) ).

tff(writeUnaryOperator_2826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49842(VarCurr)
    <=> v49787(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49831(VarNext)
      <=> v49832(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49832(VarNext)
      <=> ( v49834(VarNext)
          & v49836(VarNext) ) ) ) ).

tff(writeUnaryOperator_2825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49836(VarCurr)
    <=> v49779(VarCurr) ) ).

tff(addAssignment_25077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49834(VarNext)
      <=> v49779(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_215,axiom,
    ( v49785(constB0)
  <=> $true ) ).

tff(addAssignment_25076,axiom,
    ! [VarCurr: state_type] :
      ( v49822(VarCurr)
    <=> v49824(VarCurr) ) ).

tff(addAssignment_25075,axiom,
    ! [VarCurr: state_type] :
      ( v49824(VarCurr)
    <=> v49826(VarCurr) ) ).

tff(addAssignment_25074,axiom,
    ! [VarCurr: state_type] :
      ( v49826(VarCurr)
    <=> v49828(VarCurr) ) ).

tff(addAssignment_25073,axiom,
    ! [VarCurr: state_type] :
      ( v49828(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_25072,axiom,
    ! [VarCurr: state_type] :
      ( v49791(VarCurr)
    <=> v49793(VarCurr) ) ).

tff(addAssignment_25071,axiom,
    ! [VarCurr: state_type] :
      ( v49793(VarCurr)
    <=> v49795(VarCurr) ) ).

tff(addAssignment_25070,axiom,
    ! [VarCurr: state_type] :
      ( v49795(VarCurr)
    <=> v49797(VarCurr) ) ).

tff(addAssignment_25069,axiom,
    ! [VarCurr: state_type] :
      ( v49797(VarCurr)
    <=> v49799(VarCurr) ) ).

tff(writeUnaryOperator_2824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49799(VarCurr)
    <=> v49819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4608,axiom,
    ! [VarCurr: state_type] :
      ( v49819(VarCurr)
    <=> ( v49820(VarCurr)
        | v49815(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4607,axiom,
    ! [VarCurr: state_type] :
      ( v49820(VarCurr)
    <=> ( v49801(VarCurr)
        | v49811(VarCurr) ) ) ).

tff(addAssignment_25068,axiom,
    ! [VarCurr: state_type] :
      ( v49815(VarCurr)
    <=> v49817(VarCurr) ) ).

tff(addAssignment_25067,axiom,
    ! [VarCurr: state_type] :
      ( v49817(VarCurr)
    <=> v49805(VarCurr,2) ) ).

tff(addAssignment_25066,axiom,
    ! [VarCurr: state_type] :
      ( v49805(VarCurr,2)
    <=> v49807(VarCurr,2) ) ).

tff(addAssignment_25065,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,2)
    <=> v49809(VarCurr,2) ) ).

tff(addAssignment_25064,axiom,
    ! [VarCurr: state_type] :
      ( v49811(VarCurr)
    <=> v49813(VarCurr) ) ).

tff(addAssignment_25063,axiom,
    ! [VarCurr: state_type] :
      ( v49813(VarCurr)
    <=> v49805(VarCurr,1) ) ).

tff(addAssignment_25062,axiom,
    ! [VarCurr: state_type] :
      ( v49805(VarCurr,1)
    <=> v49807(VarCurr,1) ) ).

tff(addAssignment_25061,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,1)
    <=> v49809(VarCurr,1) ) ).

tff(addAssignment_25060,axiom,
    ! [VarCurr: state_type] :
      ( v49801(VarCurr)
    <=> v49803(VarCurr) ) ).

tff(addAssignment_25059,axiom,
    ! [VarCurr: state_type] :
      ( v49803(VarCurr)
    <=> v49805(VarCurr,0) ) ).

tff(addAssignment_25058,axiom,
    ! [VarCurr: state_type] :
      ( v49805(VarCurr,0)
    <=> v49807(VarCurr,0) ) ).

tff(addAssignment_25057,axiom,
    ! [VarCurr: state_type] :
      ( v49807(VarCurr,0)
    <=> v49809(VarCurr,0) ) ).

tff(addAssignment_25056,axiom,
    ! [VarCurr: state_type] :
      ( v49787(VarCurr)
    <=> v49789(VarCurr) ) ).

tff(addAssignment_25055,axiom,
    ! [VarCurr: state_type] :
      ( v49789(VarCurr)
    <=> $false ) ).

tff(addAssignment_25054,axiom,
    ! [VarCurr: state_type] :
      ( v49779(VarCurr)
    <=> v49781(VarCurr) ) ).

tff(addAssignment_25053,axiom,
    ! [VarCurr: state_type] :
      ( v49781(VarCurr)
    <=> v49783(VarCurr) ) ).

tff(addAssignment_25052,axiom,
    ! [VarCurr: state_type] :
      ( v49783(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_25051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49443(VarCurr,B)
      <=> v49445(VarCurr,B) ) ) ).

tff(addAssignment_25050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49445(VarCurr,B)
      <=> v49447(VarCurr,B) ) ) ).

tff(addAssignment_25049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49447(VarCurr,B)
      <=> v49449(VarCurr,B) ) ) ).

tff(addAssignment_25048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49449(VarCurr,B)
      <=> v49451(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49451(VarCurr,B)
      <=> ( v49453(VarCurr,B)
          & v49475(VarCurr,B) ) ) ) ).

tff(addAssignment_25047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49475(VarCurr,B)
      <=> v49477(VarCurr,B) ) ) ).

tff(addAssignment_25046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49477(VarCurr,B)
      <=> v49479(VarCurr,B) ) ) ).

tff(addAssignment_25045,axiom,
    ! [VarCurr: state_type] :
      ( ( v49479(VarCurr,11)
      <=> v6324(VarCurr,155) )
      & ( v49479(VarCurr,10)
      <=> v6324(VarCurr,154) )
      & ( v49479(VarCurr,9)
      <=> v6324(VarCurr,153) )
      & ( v49479(VarCurr,8)
      <=> v6324(VarCurr,152) )
      & ( v49479(VarCurr,7)
      <=> v6324(VarCurr,151) )
      & ( v49479(VarCurr,6)
      <=> v6324(VarCurr,150) )
      & ( v49479(VarCurr,5)
      <=> v6324(VarCurr,149) )
      & ( v49479(VarCurr,4)
      <=> v6324(VarCurr,148) )
      & ( v49479(VarCurr,3)
      <=> v6324(VarCurr,147) )
      & ( v49479(VarCurr,2)
      <=> v6324(VarCurr,146) )
      & ( v49479(VarCurr,1)
      <=> v6324(VarCurr,145) )
      & ( v49479(VarCurr,0)
      <=> v6324(VarCurr,144) ) ) ).

tff(addAssignment_25044,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,155)
      <=> v49481(VarCurr,11) )
      & ( v6324(VarCurr,154)
      <=> v49481(VarCurr,10) )
      & ( v6324(VarCurr,153)
      <=> v49481(VarCurr,9) )
      & ( v6324(VarCurr,152)
      <=> v49481(VarCurr,8) )
      & ( v6324(VarCurr,151)
      <=> v49481(VarCurr,7) )
      & ( v6324(VarCurr,150)
      <=> v49481(VarCurr,6) )
      & ( v6324(VarCurr,149)
      <=> v49481(VarCurr,5) )
      & ( v6324(VarCurr,148)
      <=> v49481(VarCurr,4) )
      & ( v6324(VarCurr,147)
      <=> v49481(VarCurr,3) )
      & ( v6324(VarCurr,146)
      <=> v49481(VarCurr,2) )
      & ( v6324(VarCurr,145)
      <=> v49481(VarCurr,1) )
      & ( v6324(VarCurr,144)
      <=> v49481(VarCurr,0) ) ) ).

tff(addAssignment_25043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49481(VarCurr,B)
      <=> v49483(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49483(VarCurr,B)
      <=> ( v49765(VarCurr,B)
          | v49768(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49768(VarCurr,B)
      <=> ( v49493(VarCurr,B)
          & v49769(VarCurr,B) ) ) ) ).

tff(addAssignment_25042,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,0)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25041,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,1)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25040,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,2)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25039,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,3)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25038,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,4)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25037,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,5)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25036,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,6)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25035,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,7)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25034,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,8)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25033,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,9)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25032,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,10)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25031,axiom,
    ! [VarCurr: state_type] :
      ( v49769(VarCurr,11)
    <=> v49770(VarCurr) ) ).

tff(addAssignment_25030,axiom,
    ! [VarCurr: state_type] :
      ( v49770(VarCurr)
    <=> v49761(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49765(VarCurr,B)
      <=> ( v49485(VarCurr,B)
          & v49766(VarCurr,B) ) ) ) ).

tff(addAssignment_25029,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,0)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25028,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,1)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25027,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,2)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25026,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,3)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25025,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,4)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25024,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,5)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25023,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,6)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25022,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,7)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25021,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,8)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25020,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,9)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25019,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,10)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25018,axiom,
    ! [VarCurr: state_type] :
      ( v49766(VarCurr,11)
    <=> v49767(VarCurr) ) ).

tff(addAssignment_25017,axiom,
    ! [VarCurr: state_type] :
      ( v49767(VarCurr)
    <=> v49489(VarCurr) ) ).

tff(addAssignment_25016,axiom,
    ! [VarCurr: state_type] :
      ( v49761(VarCurr)
    <=> v49763(VarCurr) ) ).

tff(addAssignment_25015,axiom,
    ! [VarCurr: state_type] :
      ( v49763(VarCurr)
    <=> v7021(VarCurr,12) ) ).

tff(addAssignment_25014,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,12)
    <=> v7023(VarCurr,12) ) ).

tff(addAssignment_25013,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,12)
    <=> v6623(VarCurr,12) ) ).

tff(addAssignment_25012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49493(VarCurr,B)
      <=> v49495(VarCurr,B) ) ) ).

tff(addAssignment_25011,axiom,
    ! [VarCurr: state_type] :
      ( ( v49495(VarCurr,11)
      <=> v6334(VarCurr,167) )
      & ( v49495(VarCurr,10)
      <=> v6334(VarCurr,166) )
      & ( v49495(VarCurr,9)
      <=> v6334(VarCurr,165) )
      & ( v49495(VarCurr,8)
      <=> v6334(VarCurr,164) )
      & ( v49495(VarCurr,7)
      <=> v6334(VarCurr,163) )
      & ( v49495(VarCurr,6)
      <=> v6334(VarCurr,162) )
      & ( v49495(VarCurr,5)
      <=> v6334(VarCurr,161) )
      & ( v49495(VarCurr,4)
      <=> v6334(VarCurr,160) )
      & ( v49495(VarCurr,3)
      <=> v6334(VarCurr,159) )
      & ( v49495(VarCurr,2)
      <=> v6334(VarCurr,158) )
      & ( v49495(VarCurr,1)
      <=> v6334(VarCurr,157) )
      & ( v49495(VarCurr,0)
      <=> v6334(VarCurr,156) ) ) ).

tff(addAssignment_25010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_25009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_25008,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,167)
      <=> v49497(VarCurr,11) )
      & ( v6338(VarCurr,166)
      <=> v49497(VarCurr,10) )
      & ( v6338(VarCurr,165)
      <=> v49497(VarCurr,9) )
      & ( v6338(VarCurr,164)
      <=> v49497(VarCurr,8) )
      & ( v6338(VarCurr,163)
      <=> v49497(VarCurr,7) )
      & ( v6338(VarCurr,162)
      <=> v49497(VarCurr,6) )
      & ( v6338(VarCurr,161)
      <=> v49497(VarCurr,5) )
      & ( v6338(VarCurr,160)
      <=> v49497(VarCurr,4) )
      & ( v6338(VarCurr,159)
      <=> v49497(VarCurr,3) )
      & ( v6338(VarCurr,158)
      <=> v49497(VarCurr,2) )
      & ( v6338(VarCurr,157)
      <=> v49497(VarCurr,1) )
      & ( v6338(VarCurr,156)
      <=> v49497(VarCurr,0) ) ) ).

tff(addAssignment_25007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49497(VarCurr,B)
      <=> v49499(VarCurr,B) ) ) ).

tff(addAssignment_25006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49499(VarCurr,B)
      <=> v49501(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49744(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v49501(VarNext,B)
            <=> v49501(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_576,axiom,
    ! [VarNext: state_type] :
      ( v49744(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49501(VarNext,B)
          <=> v49754(VarNext,B) ) ) ) ).

tff(addAssignment_25005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49754(VarNext,B)
          <=> v49752(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49755(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49752(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_377,axiom,
    ! [VarCurr: state_type] :
      ( v49755(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49752(VarCurr,B)
          <=> v49531(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4606,axiom,
    ! [VarCurr: state_type] :
      ( v49755(VarCurr)
    <=> ( v49756(VarCurr)
        & v49757(VarCurr) ) ) ).

tff(writeUnaryOperator_2823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49757(VarCurr)
    <=> v49517(VarCurr) ) ).

tff(writeUnaryOperator_2822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49756(VarCurr)
    <=> v49503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49744(VarNext)
      <=> v49745(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49745(VarNext)
      <=> ( v49746(VarNext)
          & v49719(VarNext) ) ) ) ).

tff(writeUnaryOperator_2821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49746(VarNext)
      <=> v49748(VarNext) ) ) ).

tff(addAssignment_25004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49748(VarNext)
      <=> v49719(VarCurr) ) ) ).

tff(addAssignment_25003,axiom,
    ! [VarCurr: state_type] :
      ( v49719(VarCurr)
    <=> v49721(VarCurr) ) ).

tff(addAssignment_25002,axiom,
    ! [VarCurr: state_type] :
      ( v49721(VarCurr)
    <=> v49723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4603,axiom,
    ! [VarCurr: state_type] :
      ( v49723(VarCurr)
    <=> ( v49741(VarCurr)
        | v49733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4602,axiom,
    ! [VarCurr: state_type] :
      ( v49741(VarCurr)
    <=> ( v49725(VarCurr)
        & v49731(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_214,axiom,
    ( v49731(constB0)
  <=> $true ) ).

tff(addAssignment_25001,axiom,
    ! [VarCurr: state_type] :
      ( v49733(VarCurr)
    <=> v49735(VarCurr) ) ).

tff(addAssignment_25000,axiom,
    ! [VarCurr: state_type] :
      ( v49735(VarCurr)
    <=> v49737(VarCurr) ) ).

tff(addAssignment_24999,axiom,
    ! [VarCurr: state_type] :
      ( v49737(VarCurr)
    <=> v49739(VarCurr) ) ).

tff(addAssignment_24998,axiom,
    ! [VarCurr: state_type] :
      ( v49739(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_24997,axiom,
    ! [VarCurr: state_type] :
      ( v49725(VarCurr)
    <=> v49727(VarCurr) ) ).

tff(addAssignment_24996,axiom,
    ! [VarCurr: state_type] :
      ( v49727(VarCurr)
    <=> v49729(VarCurr) ) ).

tff(addAssignment_24995,axiom,
    ! [VarCurr: state_type] :
      ( v49729(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_24994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49531(VarCurr,B)
      <=> v49533(VarCurr,B) ) ) ).

tff(addAssignment_24993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49533(VarCurr,B)
      <=> v49535(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49535(VarCurr,B)
      <=> ( v49704(VarCurr,B)
          | v49715(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49715(VarCurr,B)
      <=> ( v49668(VarCurr,B)
          & v49716(VarCurr,B) ) ) ) ).

tff(addAssignment_24992,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,0)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24991,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,1)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24990,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,2)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24989,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,3)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24988,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,4)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24987,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,5)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24986,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,6)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24985,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,7)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24984,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,8)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24983,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,9)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24982,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,10)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24981,axiom,
    ! [VarCurr: state_type] :
      ( v49716(VarCurr,11)
    <=> v49717(VarCurr) ) ).

tff(addAssignment_24980,axiom,
    ! [VarCurr: state_type] :
      ( v49717(VarCurr)
    <=> v49678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49704(VarCurr,B)
      <=> ( v49705(VarCurr,B)
          | v49712(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49712(VarCurr,B)
      <=> ( v49632(VarCurr,B)
          & v49713(VarCurr,B) ) ) ) ).

tff(addAssignment_24979,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,0)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24978,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,1)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24977,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,2)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24976,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,3)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24975,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,4)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24974,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,5)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24973,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,6)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24972,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,7)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24971,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,8)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24970,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,9)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24969,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,10)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24968,axiom,
    ! [VarCurr: state_type] :
      ( v49713(VarCurr,11)
    <=> v49714(VarCurr) ) ).

tff(addAssignment_24967,axiom,
    ! [VarCurr: state_type] :
      ( v49714(VarCurr)
    <=> v49642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49705(VarCurr,B)
      <=> ( v49706(VarCurr,B)
          | v49709(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_793,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49709(VarCurr,B)
      <=> ( v49585(VarCurr,B)
          & v49710(VarCurr,B) ) ) ) ).

tff(addAssignment_24966,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,0)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24965,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,1)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24964,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,2)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24963,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,3)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24962,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,4)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24961,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,5)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24960,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,6)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24959,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,7)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24958,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,8)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24957,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,9)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24956,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,10)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24955,axiom,
    ! [VarCurr: state_type] :
      ( v49710(VarCurr,11)
    <=> v49711(VarCurr) ) ).

tff(addAssignment_24954,axiom,
    ! [VarCurr: state_type] :
      ( v49711(VarCurr)
    <=> v49595(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49706(VarCurr,B)
      <=> ( v49537(VarCurr,B)
          & v49707(VarCurr,B) ) ) ) ).

tff(addAssignment_24953,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,0)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24952,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,1)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24951,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,2)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24950,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,3)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24949,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,4)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24948,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,5)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24947,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,6)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24946,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,7)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24945,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,8)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24944,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,9)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24943,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,10)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24942,axiom,
    ! [VarCurr: state_type] :
      ( v49707(VarCurr,11)
    <=> v49708(VarCurr) ) ).

tff(addAssignment_24941,axiom,
    ! [VarCurr: state_type] :
      ( v49708(VarCurr)
    <=> v49547(VarCurr) ) ).

tff(addAssignment_24940,axiom,
    ! [VarCurr: state_type] :
      ( v49678(VarCurr)
    <=> v49680(VarCurr) ) ).

tff(addAssignment_24939,axiom,
    ! [VarCurr: state_type] :
      ( v49680(VarCurr)
    <=> v49682(VarCurr) ) ).

tff(addAssignment_24938,axiom,
    ! [VarCurr: state_type] :
      ( v49682(VarCurr)
    <=> v49684(VarCurr) ) ).

tff(addAssignment_24937,axiom,
    ! [VarCurr: state_type] :
      ( v49684(VarCurr)
    <=> v49686(VarCurr) ) ).

tff(addAssignment_24936,axiom,
    ! [VarCurr: state_type] :
      ( v49686(VarCurr)
    <=> v49688(VarCurr) ) ).

tff(addAssignment_24935,axiom,
    ! [VarCurr: state_type] :
      ( v49688(VarCurr)
    <=> v49690(VarCurr) ) ).

tff(addAssignment_24934,axiom,
    ! [VarCurr: state_type] :
      ( v49690(VarCurr)
    <=> v49692(VarCurr) ) ).

tff(writeUnaryOperator_2820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49692(VarCurr)
    <=> v49702(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4601,axiom,
    ! [VarCurr: state_type] :
      ( v49702(VarCurr)
    <=> ( v49694(VarCurr)
        | v49698(VarCurr) ) ) ).

tff(addAssignment_24933,axiom,
    ! [VarCurr: state_type] :
      ( v49698(VarCurr)
    <=> v49700(VarCurr) ) ).

tff(addAssignment_24932,axiom,
    ! [VarCurr: state_type] :
      ( v49700(VarCurr)
    <=> v49615(VarCurr,1) ) ).

tff(addAssignment_24931,axiom,
    ! [VarCurr: state_type] :
      ( v49694(VarCurr)
    <=> v49696(VarCurr) ) ).

tff(addAssignment_24930,axiom,
    ! [VarCurr: state_type] :
      ( v49696(VarCurr)
    <=> v49615(VarCurr,0) ) ).

tff(addAssignment_24929,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49668(VarCurr,B)
      <=> v49670(VarCurr,B) ) ) ).

tff(addAssignment_24928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49670(VarCurr,B)
      <=> v49672(VarCurr,B) ) ) ).

tff(addAssignment_24927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49672(VarCurr,B)
      <=> v49674(VarCurr,B) ) ) ).

tff(addAssignment_24926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49674(VarCurr,B)
      <=> v49676(VarCurr,B) ) ) ).

tff(addAssignment_24925,axiom,
    ! [VarCurr: state_type] :
      ( v49642(VarCurr)
    <=> v49644(VarCurr) ) ).

tff(addAssignment_24924,axiom,
    ! [VarCurr: state_type] :
      ( v49644(VarCurr)
    <=> v49646(VarCurr) ) ).

tff(addAssignment_24923,axiom,
    ! [VarCurr: state_type] :
      ( v49646(VarCurr)
    <=> v49648(VarCurr) ) ).

tff(addAssignment_24922,axiom,
    ! [VarCurr: state_type] :
      ( v49648(VarCurr)
    <=> v49650(VarCurr) ) ).

tff(addAssignment_24921,axiom,
    ! [VarCurr: state_type] :
      ( v49650(VarCurr)
    <=> v49652(VarCurr) ) ).

tff(addAssignment_24920,axiom,
    ! [VarCurr: state_type] :
      ( v49652(VarCurr)
    <=> v49654(VarCurr) ) ).

tff(addAssignment_24919,axiom,
    ! [VarCurr: state_type] :
      ( v49654(VarCurr)
    <=> v49656(VarCurr) ) ).

tff(writeUnaryOperator_2819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49656(VarCurr)
    <=> v49666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4600,axiom,
    ! [VarCurr: state_type] :
      ( v49666(VarCurr)
    <=> ( v49658(VarCurr)
        | v49662(VarCurr) ) ) ).

tff(addAssignment_24918,axiom,
    ! [VarCurr: state_type] :
      ( v49662(VarCurr)
    <=> v49664(VarCurr) ) ).

tff(addAssignment_24917,axiom,
    ! [VarCurr: state_type] :
      ( v49664(VarCurr)
    <=> v49615(VarCurr,1) ) ).

tff(addAssignment_24916,axiom,
    ! [VarCurr: state_type] :
      ( v49615(VarCurr,1)
    <=> v49617(VarCurr,1) ) ).

tff(addAssignment_24915,axiom,
    ! [VarCurr: state_type] :
      ( v49617(VarCurr,1)
    <=> v49619(VarCurr,1) ) ).

tff(addAssignment_24914,axiom,
    ! [VarCurr: state_type] :
      ( v49619(VarCurr,1)
    <=> v49624(VarCurr,1) ) ).

tff(addAssignment_24913,axiom,
    ! [VarCurr: state_type] :
      ( v49621(VarCurr,1)
    <=> v49623(VarCurr,1) ) ).

tff(addAssignment_24912,axiom,
    ! [VarCurr: state_type] :
      ( v49623(VarCurr,1)
    <=> v49567(VarCurr,1) ) ).

tff(addAssignment_24911,axiom,
    ! [VarCurr: state_type] :
      ( v49658(VarCurr)
    <=> v49660(VarCurr) ) ).

tff(addAssignment_24910,axiom,
    ! [VarCurr: state_type] :
      ( v49660(VarCurr)
    <=> v49567(VarCurr,0) ) ).

tff(addAssignment_24909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49632(VarCurr,B)
      <=> v49634(VarCurr,B) ) ) ).

tff(addAssignment_24908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49634(VarCurr,B)
      <=> v49636(VarCurr,B) ) ) ).

tff(addAssignment_24907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49636(VarCurr,B)
      <=> v49638(VarCurr,B) ) ) ).

tff(addAssignment_24906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49638(VarCurr,B)
      <=> v49640(VarCurr,B) ) ) ).

tff(addAssignment_24905,axiom,
    ! [VarCurr: state_type] :
      ( v49595(VarCurr)
    <=> v49597(VarCurr) ) ).

tff(addAssignment_24904,axiom,
    ! [VarCurr: state_type] :
      ( v49597(VarCurr)
    <=> v49599(VarCurr) ) ).

tff(addAssignment_24903,axiom,
    ! [VarCurr: state_type] :
      ( v49599(VarCurr)
    <=> v49601(VarCurr) ) ).

tff(addAssignment_24902,axiom,
    ! [VarCurr: state_type] :
      ( v49601(VarCurr)
    <=> v49603(VarCurr) ) ).

tff(addAssignment_24901,axiom,
    ! [VarCurr: state_type] :
      ( v49603(VarCurr)
    <=> v49605(VarCurr) ) ).

tff(addAssignment_24900,axiom,
    ! [VarCurr: state_type] :
      ( v49605(VarCurr)
    <=> v49607(VarCurr) ) ).

tff(addAssignment_24899,axiom,
    ! [VarCurr: state_type] :
      ( v49607(VarCurr)
    <=> v49609(VarCurr) ) ).

tff(writeUnaryOperator_2818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49609(VarCurr)
    <=> v49630(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4599,axiom,
    ! [VarCurr: state_type] :
      ( v49630(VarCurr)
    <=> ( v49611(VarCurr)
        | v49626(VarCurr) ) ) ).

tff(addAssignment_24898,axiom,
    ! [VarCurr: state_type] :
      ( v49626(VarCurr)
    <=> v49628(VarCurr) ) ).

tff(addAssignment_24897,axiom,
    ! [VarCurr: state_type] :
      ( v49628(VarCurr)
    <=> v49567(VarCurr,1) ) ).

tff(addAssignment_24896,axiom,
    ! [VarCurr: state_type] :
      ( v49611(VarCurr)
    <=> v49613(VarCurr) ) ).

tff(addAssignment_24895,axiom,
    ! [VarCurr: state_type] :
      ( v49613(VarCurr)
    <=> v49615(VarCurr,0) ) ).

tff(addAssignment_24894,axiom,
    ! [VarCurr: state_type] :
      ( v49615(VarCurr,0)
    <=> v49617(VarCurr,0) ) ).

tff(addAssignment_24893,axiom,
    ! [VarCurr: state_type] :
      ( v49617(VarCurr,0)
    <=> v49619(VarCurr,0) ) ).

tff(addAssignment_24892,axiom,
    ! [VarCurr: state_type] :
      ( v49619(VarCurr,0)
    <=> v49624(VarCurr,0) ) ).

tff(writeUnaryOperator_2817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v49624(VarCurr,B)
      <=> ~ v49621(VarCurr,B) ) ) ).

tff(addAssignment_24891,axiom,
    ! [VarCurr: state_type] :
      ( v49621(VarCurr,0)
    <=> v49623(VarCurr,0) ) ).

tff(addAssignment_24890,axiom,
    ! [VarCurr: state_type] :
      ( v49623(VarCurr,0)
    <=> v49567(VarCurr,0) ) ).

tff(addAssignment_24889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49585(VarCurr,B)
      <=> v49587(VarCurr,B) ) ) ).

tff(addAssignment_24888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49587(VarCurr,B)
      <=> v49589(VarCurr,B) ) ) ).

tff(addAssignment_24887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49589(VarCurr,B)
      <=> v49591(VarCurr,B) ) ) ).

tff(addAssignment_24886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49591(VarCurr,B)
      <=> v49593(VarCurr,B) ) ) ).

tff(addAssignment_24885,axiom,
    ! [VarCurr: state_type] :
      ( v49547(VarCurr)
    <=> v49549(VarCurr) ) ).

tff(addAssignment_24884,axiom,
    ! [VarCurr: state_type] :
      ( v49549(VarCurr)
    <=> v49551(VarCurr) ) ).

tff(addAssignment_24883,axiom,
    ! [VarCurr: state_type] :
      ( v49551(VarCurr)
    <=> v49553(VarCurr) ) ).

tff(addAssignment_24882,axiom,
    ! [VarCurr: state_type] :
      ( v49553(VarCurr)
    <=> v49555(VarCurr) ) ).

tff(addAssignment_24881,axiom,
    ! [VarCurr: state_type] :
      ( v49555(VarCurr)
    <=> v49557(VarCurr) ) ).

tff(addAssignment_24880,axiom,
    ! [VarCurr: state_type] :
      ( v49557(VarCurr)
    <=> v49559(VarCurr) ) ).

tff(addAssignment_24879,axiom,
    ! [VarCurr: state_type] :
      ( v49559(VarCurr)
    <=> v49561(VarCurr) ) ).

tff(writeUnaryOperator_2816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49561(VarCurr)
    <=> v49583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4598,axiom,
    ! [VarCurr: state_type] :
      ( v49583(VarCurr)
    <=> ( v49563(VarCurr)
        | v49579(VarCurr) ) ) ).

tff(addAssignment_24878,axiom,
    ! [VarCurr: state_type] :
      ( v49579(VarCurr)
    <=> v49581(VarCurr) ) ).

tff(addAssignment_24877,axiom,
    ! [VarCurr: state_type] :
      ( v49581(VarCurr)
    <=> v49567(VarCurr,1) ) ).

tff(addAssignment_24876,axiom,
    ! [VarCurr: state_type] :
      ( v49567(VarCurr,1)
    <=> v49569(VarCurr,1) ) ).

tff(addAssignment_24875,axiom,
    ! [VarCurr: state_type] :
      ( v49569(VarCurr,1)
    <=> v49571(VarCurr,1) ) ).

tff(addAssignment_24874,axiom,
    ! [VarCurr: state_type] :
      ( v49571(VarCurr,1)
    <=> v49573(VarCurr,1) ) ).

tff(addAssignment_24873,axiom,
    ! [VarCurr: state_type] :
      ( v49573(VarCurr,1)
    <=> v49575(VarCurr,1) ) ).

tff(addAssignment_24872,axiom,
    ! [VarCurr: state_type] :
      ( v49575(VarCurr,1)
    <=> v49577(VarCurr,1) ) ).

tff(addAssignment_24871,axiom,
    ! [VarCurr: state_type] :
      ( v49563(VarCurr)
    <=> v49565(VarCurr) ) ).

tff(addAssignment_24870,axiom,
    ! [VarCurr: state_type] :
      ( v49565(VarCurr)
    <=> v49567(VarCurr,0) ) ).

tff(addAssignment_24869,axiom,
    ! [VarCurr: state_type] :
      ( v49567(VarCurr,0)
    <=> v49569(VarCurr,0) ) ).

tff(addAssignment_24868,axiom,
    ! [VarCurr: state_type] :
      ( v49569(VarCurr,0)
    <=> v49571(VarCurr,0) ) ).

tff(addAssignment_24867,axiom,
    ! [VarCurr: state_type] :
      ( v49571(VarCurr,0)
    <=> v49573(VarCurr,0) ) ).

tff(addAssignment_24866,axiom,
    ! [VarCurr: state_type] :
      ( v49573(VarCurr,0)
    <=> v49575(VarCurr,0) ) ).

tff(addAssignment_24865,axiom,
    ! [VarCurr: state_type] :
      ( v49575(VarCurr,0)
    <=> v49577(VarCurr,0) ) ).

tff(addAssignment_24864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49537(VarCurr,B)
      <=> v49539(VarCurr,B) ) ) ).

tff(addAssignment_24863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49539(VarCurr,B)
      <=> v49541(VarCurr,B) ) ) ).

tff(addAssignment_24862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49541(VarCurr,B)
      <=> v49543(VarCurr,B) ) ) ).

tff(addAssignment_24861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49543(VarCurr,B)
      <=> v49545(VarCurr,B) ) ) ).

tff(addAssignment_24860,axiom,
    ! [VarCurr: state_type] :
      ( v49517(VarCurr)
    <=> v49519(VarCurr) ) ).

tff(addAssignment_24859,axiom,
    ! [VarCurr: state_type] :
      ( v49519(VarCurr)
    <=> v49521(VarCurr) ) ).

tff(addAssignment_24858,axiom,
    ! [VarCurr: state_type] :
      ( v49521(VarCurr)
    <=> v49523(VarCurr) ) ).

tff(addAssignment_24857,axiom,
    ! [VarCurr: state_type] :
      ( v49523(VarCurr)
    <=> v49525(VarCurr) ) ).

tff(addAssignment_24856,axiom,
    ! [VarCurr: state_type] :
      ( v49525(VarCurr)
    <=> v49527(VarCurr) ) ).

tff(addAssignment_24855,axiom,
    ! [VarCurr: state_type] :
      ( v49527(VarCurr)
    <=> v49529(VarCurr) ) ).

tff(addAssignment_24854,axiom,
    ! [VarCurr: state_type] :
      ( v49529(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_24853,axiom,
    ! [VarCurr: state_type] :
      ( v49503(VarCurr)
    <=> v49505(VarCurr) ) ).

tff(addAssignment_24852,axiom,
    ! [VarCurr: state_type] :
      ( v49505(VarCurr)
    <=> v49507(VarCurr) ) ).

tff(addAssignment_24851,axiom,
    ! [VarCurr: state_type] :
      ( v49507(VarCurr)
    <=> v49509(VarCurr) ) ).

tff(addAssignment_24850,axiom,
    ! [VarCurr: state_type] :
      ( v49509(VarCurr)
    <=> v49511(VarCurr) ) ).

tff(addAssignment_24849,axiom,
    ! [VarCurr: state_type] :
      ( v49511(VarCurr)
    <=> v49513(VarCurr) ) ).

tff(addAssignment_24848,axiom,
    ! [VarCurr: state_type] :
      ( v49513(VarCurr)
    <=> v49515(VarCurr) ) ).

tff(addAssignment_24847,axiom,
    ! [VarCurr: state_type] :
      ( v49515(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_24846,axiom,
    ! [VarCurr: state_type] :
      ( v49489(VarCurr)
    <=> v49491(VarCurr) ) ).

tff(addAssignment_24845,axiom,
    ! [VarCurr: state_type] :
      ( v49491(VarCurr)
    <=> v6617(VarCurr,12) ) ).

tff(addAssignment_24844,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,12)
    <=> v6619(VarCurr,12) ) ).

tff(addAssignment_24843,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,12)
    <=> v6621(VarCurr,12) ) ).

tff(addAssignment_24842,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,12)
    <=> v6747(VarCurr,12) ) ).

tff(addAssignment_24841,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,12)
    <=> v6690(VarCurr,12) ) ).

tff(addAssignment_24840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49485(VarCurr,B)
      <=> v49487(VarCurr,B) ) ) ).

tff(addAssignment_24839,axiom,
    ! [VarCurr: state_type] :
      ( ( v49487(VarCurr,11)
      <=> v6334(VarCurr,155) )
      & ( v49487(VarCurr,10)
      <=> v6334(VarCurr,154) )
      & ( v49487(VarCurr,9)
      <=> v6334(VarCurr,153) )
      & ( v49487(VarCurr,8)
      <=> v6334(VarCurr,152) )
      & ( v49487(VarCurr,7)
      <=> v6334(VarCurr,151) )
      & ( v49487(VarCurr,6)
      <=> v6334(VarCurr,150) )
      & ( v49487(VarCurr,5)
      <=> v6334(VarCurr,149) )
      & ( v49487(VarCurr,4)
      <=> v6334(VarCurr,148) )
      & ( v49487(VarCurr,3)
      <=> v6334(VarCurr,147) )
      & ( v49487(VarCurr,2)
      <=> v6334(VarCurr,146) )
      & ( v49487(VarCurr,1)
      <=> v6334(VarCurr,145) )
      & ( v49487(VarCurr,0)
      <=> v6334(VarCurr,144) ) ) ).

tff(addAssignment_24838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49453(VarCurr,B)
      <=> v49455(VarCurr,B) ) ) ).

tff(addAssignment_24837,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,0)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24836,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,1)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24835,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,2)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24834,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,3)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24833,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,4)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24832,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,5)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24831,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,6)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24830,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,7)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24829,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,8)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24828,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,9)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24827,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,10)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24826,axiom,
    ! [VarCurr: state_type] :
      ( v49455(VarCurr,11)
    <=> v49473(VarCurr) ) ).

tff(addAssignment_24825,axiom,
    ! [VarCurr: state_type] :
      ( v49473(VarCurr)
    <=> v49457(VarCurr) ) ).

tff(addAssignment_24824,axiom,
    ! [VarCurr: state_type] :
      ( v49457(VarCurr)
    <=> v49459(VarCurr,0) ) ).

tff(addAssignment_24823,axiom,
    ! [VarCurr: state_type] :
      ( v49459(VarCurr,0)
    <=> v49461(VarCurr,0) ) ).

tff(addAssignment_24822,axiom,
    ! [VarCurr: state_type] :
      ( v49461(VarCurr,0)
    <=> v49471(VarCurr,0) ) ).

tff(writeUnaryOperator_2815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v49471(VarCurr,B)
      <=> ~ v49463(VarCurr,B) ) ) ).

tff(addAssignment_24821,axiom,
    ! [VarCurr: state_type] :
      ( v49463(VarCurr,0)
    <=> v49465(VarCurr,0) ) ).

tff(addAssignment_24820,axiom,
    ! [VarCurr: state_type] :
      ( v49465(VarCurr,0)
    <=> v49468(VarCurr,0) ) ).

tff(addAssignment_24819,axiom,
    ! [VarCurr: state_type] :
      ( v49468(VarCurr,0)
    <=> v49467(VarCurr) ) ).

tff(addAssignment_24818,axiom,
    ! [VarCurr: state_type] :
      ( v49468(VarCurr,1)
    <=> v49470(VarCurr) ) ).

tff(addAssignment_24817,axiom,
    ! [VarCurr: state_type] :
      ( v49468(VarCurr,2)
    <=> v49469(VarCurr) ) ).

tff(addAssignment_24816,axiom,
    ! [VarCurr: state_type] :
      ( v49467(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_24815,axiom,
    ! [VarCurr: state_type] :
      ( v49429(VarCurr)
    <=> v49431(VarCurr) ) ).

tff(addAssignment_24814,axiom,
    ! [VarCurr: state_type] :
      ( v49431(VarCurr)
    <=> v49433(VarCurr) ) ).

tff(addAssignment_24813,axiom,
    ! [VarCurr: state_type] :
      ( v49433(VarCurr)
    <=> v49435(VarCurr) ) ).

tff(addAssignment_24812,axiom,
    ! [VarCurr: state_type] :
      ( v49435(VarCurr)
    <=> v49437(VarCurr) ) ).

tff(addAssignment_24811,axiom,
    ! [VarCurr: state_type] :
      ( v49437(VarCurr)
    <=> v49439(VarCurr) ) ).

tff(addAssignment_24810,axiom,
    ! [VarCurr: state_type] :
      ( v49439(VarCurr)
    <=> v49441(VarCurr) ) ).

tff(addAssignment_24809,axiom,
    ! [VarCurr: state_type] :
      ( v49441(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_24808,axiom,
    ! [VarCurr: state_type] :
      ( v49415(VarCurr)
    <=> v49417(VarCurr) ) ).

tff(addAssignment_24807,axiom,
    ! [VarCurr: state_type] :
      ( v49417(VarCurr)
    <=> v49419(VarCurr) ) ).

tff(addAssignment_24806,axiom,
    ! [VarCurr: state_type] :
      ( v49419(VarCurr)
    <=> v49421(VarCurr) ) ).

tff(addAssignment_24805,axiom,
    ! [VarCurr: state_type] :
      ( v49421(VarCurr)
    <=> v49423(VarCurr) ) ).

tff(addAssignment_24804,axiom,
    ! [VarCurr: state_type] :
      ( v49423(VarCurr)
    <=> v49425(VarCurr) ) ).

tff(addAssignment_24803,axiom,
    ! [VarCurr: state_type] :
      ( v49425(VarCurr)
    <=> v49427(VarCurr) ) ).

tff(addAssignment_24802,axiom,
    ! [VarCurr: state_type] :
      ( v49427(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_24801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49391(VarCurr,B)
      <=> v49393(VarCurr,B) ) ) ).

tff(addAssignment_24800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49393(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_24799,axiom,
    ! [VarCurr: state_type] :
      ( v47835(VarCurr)
    <=> v47837(VarCurr) ) ).

tff(addAssignment_24798,axiom,
    ! [VarCurr: state_type] :
      ( v47837(VarCurr)
    <=> v47839(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_214,axiom,
    ! [VarCurr: state_type] :
      ( v47839(VarCurr)
    <=> ( ( v47841(VarCurr,11)
        <=> v47845(VarCurr,11) )
        & ( v47841(VarCurr,10)
        <=> v47845(VarCurr,10) )
        & ( v47841(VarCurr,9)
        <=> v47845(VarCurr,9) )
        & ( v47841(VarCurr,8)
        <=> v47845(VarCurr,8) )
        & ( v47841(VarCurr,7)
        <=> v47845(VarCurr,7) )
        & ( v47841(VarCurr,6)
        <=> v47845(VarCurr,6) )
        & ( v47841(VarCurr,5)
        <=> v47845(VarCurr,5) )
        & ( v47841(VarCurr,4)
        <=> v47845(VarCurr,4) )
        & ( v47841(VarCurr,3)
        <=> v47845(VarCurr,3) )
        & ( v47841(VarCurr,2)
        <=> v47845(VarCurr,2) )
        & ( v47841(VarCurr,1)
        <=> v47845(VarCurr,1) )
        & ( v47841(VarCurr,0)
        <=> v47845(VarCurr,0) ) ) ) ).

tff(addAssignment_24797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47845(VarCurr,B)
      <=> v47847(VarCurr,B) ) ) ).

tff(addAssignment_24796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47847(VarCurr,B)
      <=> v47849(VarCurr,B) ) ) ).

tff(addAssignment_24795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47849(VarCurr,B)
      <=> v47851(VarCurr,B) ) ) ).

tff(addAssignment_24794,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47851(VarCurr,B)
      <=> v47853(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47853(VarCurr,B)
      <=> ( v49361(VarCurr,B)
          | v49380(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49380(VarCurr,B)
      <=> ( v49232(VarCurr,B)
          & v49381(VarCurr,B) ) ) ) ).

tff(addAssignment_24793,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,0)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24792,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,1)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24791,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,2)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24790,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,3)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24789,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,4)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24788,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,5)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24787,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,6)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24786,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,7)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24785,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,8)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24784,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,9)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24783,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,10)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24782,axiom,
    ! [VarCurr: state_type] :
      ( v49381(VarCurr,11)
    <=> v49382(VarCurr) ) ).

tff(addAssignment_24781,axiom,
    ! [VarCurr: state_type] :
      ( v49382(VarCurr)
    <=> v49351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49361(VarCurr,B)
      <=> ( v49362(VarCurr,B)
          | v49377(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49377(VarCurr,B)
      <=> ( v49081(VarCurr,B)
          & v49378(VarCurr,B) ) ) ) ).

tff(addAssignment_24780,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,0)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24779,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,1)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24778,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,2)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24777,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,3)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24776,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,4)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24775,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,5)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24774,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,6)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24773,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,7)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24772,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,8)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24771,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,9)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24770,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,10)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24769,axiom,
    ! [VarCurr: state_type] :
      ( v49378(VarCurr,11)
    <=> v49379(VarCurr) ) ).

tff(addAssignment_24768,axiom,
    ! [VarCurr: state_type] :
      ( v49379(VarCurr)
    <=> v49201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49362(VarCurr,B)
      <=> ( v49363(VarCurr,B)
          | v49374(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49374(VarCurr,B)
      <=> ( v48930(VarCurr,B)
          & v49375(VarCurr,B) ) ) ) ).

tff(addAssignment_24767,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,0)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24766,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,1)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24765,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,2)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24764,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,3)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24763,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,4)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24762,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,5)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24761,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,6)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24760,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,7)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24759,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,8)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24758,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,9)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24757,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,10)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24756,axiom,
    ! [VarCurr: state_type] :
      ( v49375(VarCurr,11)
    <=> v49376(VarCurr) ) ).

tff(addAssignment_24755,axiom,
    ! [VarCurr: state_type] :
      ( v49376(VarCurr)
    <=> v49050(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49363(VarCurr,B)
      <=> ( v49364(VarCurr,B)
          | v49371(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49371(VarCurr,B)
      <=> ( v48779(VarCurr,B)
          & v49372(VarCurr,B) ) ) ) ).

tff(addAssignment_24754,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,0)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24753,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,1)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24752,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,2)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24751,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,3)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24750,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,4)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24749,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,5)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24748,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,6)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24747,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,7)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24746,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,8)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24745,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,9)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24744,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,10)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24743,axiom,
    ! [VarCurr: state_type] :
      ( v49372(VarCurr,11)
    <=> v49373(VarCurr) ) ).

tff(addAssignment_24742,axiom,
    ! [VarCurr: state_type] :
      ( v49373(VarCurr)
    <=> v48899(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49364(VarCurr,B)
      <=> ( v49365(VarCurr,B)
          | v49368(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49368(VarCurr,B)
      <=> ( v48617(VarCurr,B)
          & v49369(VarCurr,B) ) ) ) ).

tff(addAssignment_24741,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,0)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24740,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,1)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24739,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,2)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24738,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,3)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24737,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,4)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24736,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,5)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24735,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,6)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24734,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,7)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24733,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,8)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24732,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,9)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24731,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,10)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24730,axiom,
    ! [VarCurr: state_type] :
      ( v49369(VarCurr,11)
    <=> v49370(VarCurr) ) ).

tff(addAssignment_24729,axiom,
    ! [VarCurr: state_type] :
      ( v49370(VarCurr)
    <=> v48748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49365(VarCurr,B)
      <=> ( v47855(VarCurr,B)
          & v49366(VarCurr,B) ) ) ) ).

tff(addAssignment_24728,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,0)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24727,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,1)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24726,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,2)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24725,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,3)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24724,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,4)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24723,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,5)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24722,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,6)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24721,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,7)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24720,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,8)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24719,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,9)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24718,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,10)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24717,axiom,
    ! [VarCurr: state_type] :
      ( v49366(VarCurr,11)
    <=> v49367(VarCurr) ) ).

tff(addAssignment_24716,axiom,
    ! [VarCurr: state_type] :
      ( v49367(VarCurr)
    <=> v48325(VarCurr) ) ).

tff(addAssignment_24715,axiom,
    ! [VarCurr: state_type] :
      ( v49351(VarCurr)
    <=> v49353(VarCurr) ) ).

tff(addAssignment_24714,axiom,
    ! [VarCurr: state_type] :
      ( v49353(VarCurr)
    <=> v49355(VarCurr) ) ).

tff(addAssignment_24713,axiom,
    ! [VarCurr: state_type] :
      ( v49355(VarCurr)
    <=> v49357(VarCurr) ) ).

tff(addAssignment_24712,axiom,
    ! [VarCurr: state_type] :
      ( v49357(VarCurr)
    <=> v49359(VarCurr) ) ).

tff(addAssignment_24711,axiom,
    ! [VarCurr: state_type] :
      ( v49359(VarCurr)
    <=> v48418(VarCurr) ) ).

tff(addAssignment_24710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49232(VarCurr,B)
      <=> v49234(VarCurr,B) ) ) ).

tff(addAssignment_24709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49234(VarCurr,B)
      <=> v49236(VarCurr,B) ) ) ).

tff(addAssignment_24708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49236(VarCurr,B)
      <=> v49238(VarCurr,B) ) ) ).

tff(addAssignment_24707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49238(VarCurr,B)
      <=> v49240(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49334(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v49240(VarNext,B)
            <=> v49240(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_575,axiom,
    ! [VarNext: state_type] :
      ( v49334(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49240(VarNext,B)
          <=> v49344(VarNext,B) ) ) ) ).

tff(addAssignment_24706,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49344(VarNext,B)
          <=> v49342(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49342(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_376,axiom,
    ! [VarCurr: state_type] :
      ( v49345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49342(VarCurr,B)
          <=> v49262(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4597,axiom,
    ! [VarCurr: state_type] :
      ( v49345(VarCurr)
    <=> ( v49346(VarCurr)
        & v49347(VarCurr) ) ) ).

tff(writeUnaryOperator_2814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49347(VarCurr)
    <=> v49252(VarCurr) ) ).

tff(writeUnaryOperator_2813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49346(VarCurr)
    <=> v49242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49334(VarNext)
      <=> v49335(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49335(VarNext)
      <=> ( v49336(VarNext)
          & v49266(VarNext) ) ) ) ).

tff(writeUnaryOperator_2812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49336(VarNext)
      <=> v49338(VarNext) ) ) ).

tff(addAssignment_24705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49338(VarNext)
      <=> v49266(VarCurr) ) ) ).

tff(addAssignment_24704,axiom,
    ! [VarCurr: state_type] :
      ( v49266(VarCurr)
    <=> v49268(VarCurr) ) ).

tff(addAssignment_24703,axiom,
    ! [VarCurr: state_type] :
      ( v49268(VarCurr)
    <=> v49270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4594,axiom,
    ! [VarCurr: state_type] :
      ( v49270(VarCurr)
    <=> ( v49331(VarCurr)
        | v49327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4593,axiom,
    ! [VarCurr: state_type] :
      ( v49331(VarCurr)
    <=> ( v49272(VarCurr)
        & v49276(VarCurr) ) ) ).

tff(addAssignment_24702,axiom,
    ! [VarCurr: state_type] :
      ( v49327(VarCurr)
    <=> v49329(VarCurr) ) ).

tff(addAssignment_24701,axiom,
    ! [VarCurr: state_type] :
      ( v49329(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49311(VarNext)
       => ( v49276(VarNext)
        <=> v49276(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_574,axiom,
    ! [VarNext: state_type] :
      ( v49311(VarNext)
     => ( v49276(VarNext)
      <=> v49321(VarNext) ) ) ).

tff(addAssignment_24700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49321(VarNext)
      <=> v49319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4592,axiom,
    ! [VarCurr: state_type] :
      ( v49319(VarCurr)
    <=> ( v49322(VarCurr)
        & v49323(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4591,axiom,
    ! [VarCurr: state_type] :
      ( v49323(VarCurr)
    <=> ( v49282(VarCurr)
        | v49306(VarCurr) ) ) ).

tff(writeUnaryOperator_2811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49322(VarCurr)
    <=> v49278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49311(VarNext)
      <=> v49312(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49312(VarNext)
      <=> ( v49314(VarNext)
          & v49316(VarNext) ) ) ) ).

tff(writeUnaryOperator_2810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49316(VarCurr)
    <=> v49272(VarCurr) ) ).

tff(addAssignment_24699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49314(VarNext)
      <=> v49272(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_213,axiom,
    ( v49276(constB0)
  <=> $true ) ).

tff(addAssignment_24698,axiom,
    ! [VarCurr: state_type] :
      ( v49306(VarCurr)
    <=> v49308(VarCurr) ) ).

tff(addAssignment_24697,axiom,
    ! [VarCurr: state_type] :
      ( v49308(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24696,axiom,
    ! [VarCurr: state_type] :
      ( v49282(VarCurr)
    <=> v49284(VarCurr) ) ).

tff(addAssignment_24695,axiom,
    ! [VarCurr: state_type] :
      ( v49284(VarCurr)
    <=> v48592(VarCurr) ) ).

tff(addAssignment_24694,axiom,
    ! [VarCurr: state_type] :
      ( v48592(VarCurr)
    <=> v49287(VarCurr) ) ).

tff(addAssignment_24693,axiom,
    ! [VarCurr: state_type] :
      ( v49287(VarCurr)
    <=> v49289(VarCurr) ) ).

tff(writeUnaryOperator_2809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49289(VarCurr)
    <=> v49303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4588,axiom,
    ! [VarCurr: state_type] :
      ( v49303(VarCurr)
    <=> ( v49304(VarCurr)
        | v49299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4587,axiom,
    ! [VarCurr: state_type] :
      ( v49304(VarCurr)
    <=> ( v49291(VarCurr)
        | v49295(VarCurr) ) ) ).

tff(addAssignment_24692,axiom,
    ! [VarCurr: state_type] :
      ( v49299(VarCurr)
    <=> v49301(VarCurr) ) ).

tff(addAssignment_24691,axiom,
    ! [VarCurr: state_type] :
      ( v49301(VarCurr)
    <=> v48681(VarCurr,2) ) ).

tff(addAssignment_24690,axiom,
    ! [VarCurr: state_type] :
      ( v49295(VarCurr)
    <=> v49297(VarCurr) ) ).

tff(addAssignment_24689,axiom,
    ! [VarCurr: state_type] :
      ( v49297(VarCurr)
    <=> v48255(VarCurr,1) ) ).

tff(addAssignment_24688,axiom,
    ! [VarCurr: state_type] :
      ( v49291(VarCurr)
    <=> v49293(VarCurr) ) ).

tff(addAssignment_24687,axiom,
    ! [VarCurr: state_type] :
      ( v49293(VarCurr)
    <=> v48681(VarCurr,0) ) ).

tff(addAssignment_24686,axiom,
    ! [VarCurr: state_type] :
      ( v49278(VarCurr)
    <=> v49280(VarCurr) ) ).

tff(addAssignment_24685,axiom,
    ! [VarCurr: state_type] :
      ( v49280(VarCurr)
    <=> $false ) ).

tff(addAssignment_24684,axiom,
    ! [VarCurr: state_type] :
      ( v49272(VarCurr)
    <=> v49274(VarCurr) ) ).

tff(addAssignment_24683,axiom,
    ! [VarCurr: state_type] :
      ( v49274(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49262(VarCurr,B)
      <=> v49264(VarCurr,B) ) ) ).

tff(addAssignment_24681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49264(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24680,axiom,
    ! [VarCurr: state_type] :
      ( v49252(VarCurr)
    <=> v49254(VarCurr) ) ).

tff(addAssignment_24679,axiom,
    ! [VarCurr: state_type] :
      ( v49254(VarCurr)
    <=> v49256(VarCurr) ) ).

tff(addAssignment_24678,axiom,
    ! [VarCurr: state_type] :
      ( v49256(VarCurr)
    <=> v49258(VarCurr) ) ).

tff(addAssignment_24677,axiom,
    ! [VarCurr: state_type] :
      ( v49258(VarCurr)
    <=> v49260(VarCurr) ) ).

tff(addAssignment_24676,axiom,
    ! [VarCurr: state_type] :
      ( v49260(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24675,axiom,
    ! [VarCurr: state_type] :
      ( v49242(VarCurr)
    <=> v49244(VarCurr) ) ).

tff(addAssignment_24674,axiom,
    ! [VarCurr: state_type] :
      ( v49244(VarCurr)
    <=> v49246(VarCurr) ) ).

tff(addAssignment_24673,axiom,
    ! [VarCurr: state_type] :
      ( v49246(VarCurr)
    <=> v49248(VarCurr) ) ).

tff(addAssignment_24672,axiom,
    ! [VarCurr: state_type] :
      ( v49248(VarCurr)
    <=> v49250(VarCurr) ) ).

tff(addAssignment_24671,axiom,
    ! [VarCurr: state_type] :
      ( v49250(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_24670,axiom,
    ! [VarCurr: state_type] :
      ( v49201(VarCurr)
    <=> v49203(VarCurr) ) ).

tff(addAssignment_24669,axiom,
    ! [VarCurr: state_type] :
      ( v49203(VarCurr)
    <=> v49205(VarCurr) ) ).

tff(addAssignment_24668,axiom,
    ! [VarCurr: state_type] :
      ( v49205(VarCurr)
    <=> v49207(VarCurr) ) ).

tff(addAssignment_24667,axiom,
    ! [VarCurr: state_type] :
      ( v49207(VarCurr)
    <=> v49209(VarCurr) ) ).

tff(addAssignment_24666,axiom,
    ! [VarCurr: state_type] :
      ( v49209(VarCurr)
    <=> v49211(VarCurr) ) ).

tff(addAssignment_24665,axiom,
    ! [VarCurr: state_type] :
      ( v49211(VarCurr)
    <=> v49213(VarCurr) ) ).

tff(addAssignment_24664,axiom,
    ! [VarCurr: state_type] :
      ( v49213(VarCurr)
    <=> v49215(VarCurr) ) ).

tff(writeUnaryOperator_2808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49215(VarCurr)
    <=> v49229(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4586,axiom,
    ! [VarCurr: state_type] :
      ( v49229(VarCurr)
    <=> ( v49230(VarCurr)
        | v49225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4585,axiom,
    ! [VarCurr: state_type] :
      ( v49230(VarCurr)
    <=> ( v49217(VarCurr)
        | v49221(VarCurr) ) ) ).

tff(addAssignment_24663,axiom,
    ! [VarCurr: state_type] :
      ( v49225(VarCurr)
    <=> v49227(VarCurr) ) ).

tff(addAssignment_24662,axiom,
    ! [VarCurr: state_type] :
      ( v49227(VarCurr)
    <=> v48428(VarCurr,2) ) ).

tff(addAssignment_24661,axiom,
    ! [VarCurr: state_type] :
      ( v49221(VarCurr)
    <=> v49223(VarCurr) ) ).

tff(addAssignment_24660,axiom,
    ! [VarCurr: state_type] :
      ( v49223(VarCurr)
    <=> v48345(VarCurr,1) ) ).

tff(addAssignment_24659,axiom,
    ! [VarCurr: state_type] :
      ( v49217(VarCurr)
    <=> v49219(VarCurr) ) ).

tff(addAssignment_24658,axiom,
    ! [VarCurr: state_type] :
      ( v49219(VarCurr)
    <=> v48345(VarCurr,0) ) ).

tff(addAssignment_24657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49081(VarCurr,B)
      <=> v49083(VarCurr,B) ) ) ).

tff(addAssignment_24656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49083(VarCurr,B)
      <=> v49085(VarCurr,B) ) ) ).

tff(addAssignment_24655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49085(VarCurr,B)
      <=> v49087(VarCurr,B) ) ) ).

tff(addAssignment_24654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49087(VarCurr,B)
      <=> v49089(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49184(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v49089(VarNext,B)
            <=> v49089(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_573,axiom,
    ! [VarNext: state_type] :
      ( v49184(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49089(VarNext,B)
          <=> v49194(VarNext,B) ) ) ) ).

tff(addAssignment_24653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49194(VarNext,B)
          <=> v49192(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49195(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49192(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_375,axiom,
    ! [VarCurr: state_type] :
      ( v49195(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49192(VarCurr,B)
          <=> v49111(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4584,axiom,
    ! [VarCurr: state_type] :
      ( v49195(VarCurr)
    <=> ( v49196(VarCurr)
        & v49197(VarCurr) ) ) ).

tff(writeUnaryOperator_2807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49197(VarCurr)
    <=> v49101(VarCurr) ) ).

tff(writeUnaryOperator_2806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49196(VarCurr)
    <=> v49091(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49184(VarNext)
      <=> v49185(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49185(VarNext)
      <=> ( v49186(VarNext)
          & v49115(VarNext) ) ) ) ).

tff(writeUnaryOperator_2805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49186(VarNext)
      <=> v49188(VarNext) ) ) ).

tff(addAssignment_24652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49188(VarNext)
      <=> v49115(VarCurr) ) ) ).

tff(addAssignment_24651,axiom,
    ! [VarCurr: state_type] :
      ( v49115(VarCurr)
    <=> v49117(VarCurr) ) ).

tff(addAssignment_24650,axiom,
    ! [VarCurr: state_type] :
      ( v49117(VarCurr)
    <=> v49119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4581,axiom,
    ! [VarCurr: state_type] :
      ( v49119(VarCurr)
    <=> ( v49181(VarCurr)
        | v49177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4580,axiom,
    ! [VarCurr: state_type] :
      ( v49181(VarCurr)
    <=> ( v49121(VarCurr)
        & v49125(VarCurr) ) ) ).

tff(addAssignment_24649,axiom,
    ! [VarCurr: state_type] :
      ( v49177(VarCurr)
    <=> v49179(VarCurr) ) ).

tff(addAssignment_24648,axiom,
    ! [VarCurr: state_type] :
      ( v49179(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49161(VarNext)
       => ( v49125(VarNext)
        <=> v49125(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_572,axiom,
    ! [VarNext: state_type] :
      ( v49161(VarNext)
     => ( v49125(VarNext)
      <=> v49171(VarNext) ) ) ).

tff(addAssignment_24647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49171(VarNext)
      <=> v49169(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4579,axiom,
    ! [VarCurr: state_type] :
      ( v49169(VarCurr)
    <=> ( v49172(VarCurr)
        & v49173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4578,axiom,
    ! [VarCurr: state_type] :
      ( v49173(VarCurr)
    <=> ( v49131(VarCurr)
        | v49156(VarCurr) ) ) ).

tff(writeUnaryOperator_2804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49172(VarCurr)
    <=> v49127(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49161(VarNext)
      <=> v49162(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49162(VarNext)
      <=> ( v49164(VarNext)
          & v49166(VarNext) ) ) ) ).

tff(writeUnaryOperator_2803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49166(VarCurr)
    <=> v49121(VarCurr) ) ).

tff(addAssignment_24646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49164(VarNext)
      <=> v49121(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_212,axiom,
    ( v49125(constB0)
  <=> $true ) ).

tff(addAssignment_24645,axiom,
    ! [VarCurr: state_type] :
      ( v49156(VarCurr)
    <=> v49158(VarCurr) ) ).

tff(addAssignment_24644,axiom,
    ! [VarCurr: state_type] :
      ( v49158(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24643,axiom,
    ! [VarCurr: state_type] :
      ( v49131(VarCurr)
    <=> v49133(VarCurr) ) ).

tff(addAssignment_24642,axiom,
    ! [VarCurr: state_type] :
      ( v49133(VarCurr)
    <=> v49135(VarCurr) ) ).

tff(addAssignment_24641,axiom,
    ! [VarCurr: state_type] :
      ( v49135(VarCurr)
    <=> v49137(VarCurr) ) ).

tff(addAssignment_24640,axiom,
    ! [VarCurr: state_type] :
      ( v49137(VarCurr)
    <=> v49139(VarCurr) ) ).

tff(writeUnaryOperator_2802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49139(VarCurr)
    <=> v49153(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4575,axiom,
    ! [VarCurr: state_type] :
      ( v49153(VarCurr)
    <=> ( v49154(VarCurr)
        | v49149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4574,axiom,
    ! [VarCurr: state_type] :
      ( v49154(VarCurr)
    <=> ( v49141(VarCurr)
        | v49145(VarCurr) ) ) ).

tff(addAssignment_24639,axiom,
    ! [VarCurr: state_type] :
      ( v49149(VarCurr)
    <=> v49151(VarCurr) ) ).

tff(addAssignment_24638,axiom,
    ! [VarCurr: state_type] :
      ( v49151(VarCurr)
    <=> v48681(VarCurr,2) ) ).

tff(addAssignment_24637,axiom,
    ! [VarCurr: state_type] :
      ( v48681(VarCurr,2)
    <=> v48683(VarCurr,2) ) ).

tff(addAssignment_24636,axiom,
    ! [VarCurr: state_type] :
      ( v48683(VarCurr,2)
    <=> v48685(VarCurr,2) ) ).

tff(addAssignment_24635,axiom,
    ! [VarCurr: state_type] :
      ( v48685(VarCurr,2)
    <=> v48690(VarCurr,2) ) ).

tff(addAssignment_24634,axiom,
    ! [VarCurr: state_type] :
      ( v48687(VarCurr,2)
    <=> v48689(VarCurr,2) ) ).

tff(addAssignment_24633,axiom,
    ! [VarCurr: state_type] :
      ( v48689(VarCurr,2)
    <=> v48255(VarCurr,2) ) ).

tff(addAssignment_24632,axiom,
    ! [VarCurr: state_type] :
      ( v49145(VarCurr)
    <=> v49147(VarCurr) ) ).

tff(addAssignment_24631,axiom,
    ! [VarCurr: state_type] :
      ( v49147(VarCurr)
    <=> v48255(VarCurr,1) ) ).

tff(addAssignment_24630,axiom,
    ! [VarCurr: state_type] :
      ( v49141(VarCurr)
    <=> v49143(VarCurr) ) ).

tff(addAssignment_24629,axiom,
    ! [VarCurr: state_type] :
      ( v49143(VarCurr)
    <=> v48255(VarCurr,0) ) ).

tff(addAssignment_24628,axiom,
    ! [VarCurr: state_type] :
      ( v49127(VarCurr)
    <=> v49129(VarCurr) ) ).

tff(addAssignment_24627,axiom,
    ! [VarCurr: state_type] :
      ( v49129(VarCurr)
    <=> $false ) ).

tff(addAssignment_24626,axiom,
    ! [VarCurr: state_type] :
      ( v49121(VarCurr)
    <=> v49123(VarCurr) ) ).

tff(addAssignment_24625,axiom,
    ! [VarCurr: state_type] :
      ( v49123(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49111(VarCurr,B)
      <=> v49113(VarCurr,B) ) ) ).

tff(addAssignment_24623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v49113(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24622,axiom,
    ! [VarCurr: state_type] :
      ( v49101(VarCurr)
    <=> v49103(VarCurr) ) ).

tff(addAssignment_24621,axiom,
    ! [VarCurr: state_type] :
      ( v49103(VarCurr)
    <=> v49105(VarCurr) ) ).

tff(addAssignment_24620,axiom,
    ! [VarCurr: state_type] :
      ( v49105(VarCurr)
    <=> v49107(VarCurr) ) ).

tff(addAssignment_24619,axiom,
    ! [VarCurr: state_type] :
      ( v49107(VarCurr)
    <=> v49109(VarCurr) ) ).

tff(addAssignment_24618,axiom,
    ! [VarCurr: state_type] :
      ( v49109(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24617,axiom,
    ! [VarCurr: state_type] :
      ( v49091(VarCurr)
    <=> v49093(VarCurr) ) ).

tff(addAssignment_24616,axiom,
    ! [VarCurr: state_type] :
      ( v49093(VarCurr)
    <=> v49095(VarCurr) ) ).

tff(addAssignment_24615,axiom,
    ! [VarCurr: state_type] :
      ( v49095(VarCurr)
    <=> v49097(VarCurr) ) ).

tff(addAssignment_24614,axiom,
    ! [VarCurr: state_type] :
      ( v49097(VarCurr)
    <=> v49099(VarCurr) ) ).

tff(addAssignment_24613,axiom,
    ! [VarCurr: state_type] :
      ( v49099(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_24612,axiom,
    ! [VarCurr: state_type] :
      ( v49050(VarCurr)
    <=> v49052(VarCurr) ) ).

tff(addAssignment_24611,axiom,
    ! [VarCurr: state_type] :
      ( v49052(VarCurr)
    <=> v49054(VarCurr) ) ).

tff(addAssignment_24610,axiom,
    ! [VarCurr: state_type] :
      ( v49054(VarCurr)
    <=> v49056(VarCurr) ) ).

tff(addAssignment_24609,axiom,
    ! [VarCurr: state_type] :
      ( v49056(VarCurr)
    <=> v49058(VarCurr) ) ).

tff(addAssignment_24608,axiom,
    ! [VarCurr: state_type] :
      ( v49058(VarCurr)
    <=> v49060(VarCurr) ) ).

tff(addAssignment_24607,axiom,
    ! [VarCurr: state_type] :
      ( v49060(VarCurr)
    <=> v49062(VarCurr) ) ).

tff(addAssignment_24606,axiom,
    ! [VarCurr: state_type] :
      ( v49062(VarCurr)
    <=> v49064(VarCurr) ) ).

tff(writeUnaryOperator_2801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49064(VarCurr)
    <=> v49078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4573,axiom,
    ! [VarCurr: state_type] :
      ( v49078(VarCurr)
    <=> ( v49079(VarCurr)
        | v49074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4572,axiom,
    ! [VarCurr: state_type] :
      ( v49079(VarCurr)
    <=> ( v49066(VarCurr)
        | v49070(VarCurr) ) ) ).

tff(addAssignment_24605,axiom,
    ! [VarCurr: state_type] :
      ( v49074(VarCurr)
    <=> v49076(VarCurr) ) ).

tff(addAssignment_24604,axiom,
    ! [VarCurr: state_type] :
      ( v49076(VarCurr)
    <=> v48345(VarCurr,2) ) ).

tff(addAssignment_24603,axiom,
    ! [VarCurr: state_type] :
      ( v49070(VarCurr)
    <=> v49072(VarCurr) ) ).

tff(addAssignment_24602,axiom,
    ! [VarCurr: state_type] :
      ( v49072(VarCurr)
    <=> v48428(VarCurr,1) ) ).

tff(addAssignment_24601,axiom,
    ! [VarCurr: state_type] :
      ( v49066(VarCurr)
    <=> v49068(VarCurr) ) ).

tff(addAssignment_24600,axiom,
    ! [VarCurr: state_type] :
      ( v49068(VarCurr)
    <=> v48428(VarCurr,0) ) ).

tff(addAssignment_24599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48930(VarCurr,B)
      <=> v48932(VarCurr,B) ) ) ).

tff(addAssignment_24598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48932(VarCurr,B)
      <=> v48934(VarCurr,B) ) ) ).

tff(addAssignment_24597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48934(VarCurr,B)
      <=> v48936(VarCurr,B) ) ) ).

tff(addAssignment_24596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48936(VarCurr,B)
      <=> v48938(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49033(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v48938(VarNext,B)
            <=> v48938(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_571,axiom,
    ! [VarNext: state_type] :
      ( v49033(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48938(VarNext,B)
          <=> v49043(VarNext,B) ) ) ) ).

tff(addAssignment_24595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49043(VarNext,B)
          <=> v49041(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49041(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_374,axiom,
    ! [VarCurr: state_type] :
      ( v49044(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v49041(VarCurr,B)
          <=> v48960(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4571,axiom,
    ! [VarCurr: state_type] :
      ( v49044(VarCurr)
    <=> ( v49045(VarCurr)
        & v49046(VarCurr) ) ) ).

tff(writeUnaryOperator_2800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49046(VarCurr)
    <=> v48950(VarCurr) ) ).

tff(writeUnaryOperator_2799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49045(VarCurr)
    <=> v48940(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49033(VarNext)
      <=> v49034(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49034(VarNext)
      <=> ( v49035(VarNext)
          & v48964(VarNext) ) ) ) ).

tff(writeUnaryOperator_2798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49035(VarNext)
      <=> v49037(VarNext) ) ) ).

tff(addAssignment_24594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49037(VarNext)
      <=> v48964(VarCurr) ) ) ).

tff(addAssignment_24593,axiom,
    ! [VarCurr: state_type] :
      ( v48964(VarCurr)
    <=> v48966(VarCurr) ) ).

tff(addAssignment_24592,axiom,
    ! [VarCurr: state_type] :
      ( v48966(VarCurr)
    <=> v48968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4568,axiom,
    ! [VarCurr: state_type] :
      ( v48968(VarCurr)
    <=> ( v49030(VarCurr)
        | v49026(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4567,axiom,
    ! [VarCurr: state_type] :
      ( v49030(VarCurr)
    <=> ( v48970(VarCurr)
        & v48974(VarCurr) ) ) ).

tff(addAssignment_24591,axiom,
    ! [VarCurr: state_type] :
      ( v49026(VarCurr)
    <=> v49028(VarCurr) ) ).

tff(addAssignment_24590,axiom,
    ! [VarCurr: state_type] :
      ( v49028(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_570,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v49010(VarNext)
       => ( v48974(VarNext)
        <=> v48974(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_570,axiom,
    ! [VarNext: state_type] :
      ( v49010(VarNext)
     => ( v48974(VarNext)
      <=> v49020(VarNext) ) ) ).

tff(addAssignment_24589,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49020(VarNext)
      <=> v49018(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4566,axiom,
    ! [VarCurr: state_type] :
      ( v49018(VarCurr)
    <=> ( v49021(VarCurr)
        & v49022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4565,axiom,
    ! [VarCurr: state_type] :
      ( v49022(VarCurr)
    <=> ( v48980(VarCurr)
        | v49005(VarCurr) ) ) ).

tff(writeUnaryOperator_2797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49021(VarCurr)
    <=> v48976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49010(VarNext)
      <=> v49011(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49011(VarNext)
      <=> ( v49013(VarNext)
          & v49015(VarNext) ) ) ) ).

tff(writeUnaryOperator_2796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v49015(VarCurr)
    <=> v48970(VarCurr) ) ).

tff(addAssignment_24588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v49013(VarNext)
      <=> v48970(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_211,axiom,
    ( v48974(constB0)
  <=> $true ) ).

tff(addAssignment_24587,axiom,
    ! [VarCurr: state_type] :
      ( v49005(VarCurr)
    <=> v49007(VarCurr) ) ).

tff(addAssignment_24586,axiom,
    ! [VarCurr: state_type] :
      ( v49007(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24585,axiom,
    ! [VarCurr: state_type] :
      ( v48980(VarCurr)
    <=> v48982(VarCurr) ) ).

tff(addAssignment_24584,axiom,
    ! [VarCurr: state_type] :
      ( v48982(VarCurr)
    <=> v48984(VarCurr) ) ).

tff(addAssignment_24583,axiom,
    ! [VarCurr: state_type] :
      ( v48984(VarCurr)
    <=> v48986(VarCurr) ) ).

tff(addAssignment_24582,axiom,
    ! [VarCurr: state_type] :
      ( v48986(VarCurr)
    <=> v48988(VarCurr) ) ).

tff(writeUnaryOperator_2795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48988(VarCurr)
    <=> v49002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4562,axiom,
    ! [VarCurr: state_type] :
      ( v49002(VarCurr)
    <=> ( v49003(VarCurr)
        | v48998(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4561,axiom,
    ! [VarCurr: state_type] :
      ( v49003(VarCurr)
    <=> ( v48990(VarCurr)
        | v48994(VarCurr) ) ) ).

tff(addAssignment_24581,axiom,
    ! [VarCurr: state_type] :
      ( v48998(VarCurr)
    <=> v49000(VarCurr) ) ).

tff(addAssignment_24580,axiom,
    ! [VarCurr: state_type] :
      ( v49000(VarCurr)
    <=> v48255(VarCurr,2) ) ).

tff(addAssignment_24579,axiom,
    ! [VarCurr: state_type] :
      ( v48994(VarCurr)
    <=> v48996(VarCurr) ) ).

tff(addAssignment_24578,axiom,
    ! [VarCurr: state_type] :
      ( v48996(VarCurr)
    <=> v48681(VarCurr,1) ) ).

tff(addAssignment_24577,axiom,
    ! [VarCurr: state_type] :
      ( v48990(VarCurr)
    <=> v48992(VarCurr) ) ).

tff(addAssignment_24576,axiom,
    ! [VarCurr: state_type] :
      ( v48992(VarCurr)
    <=> v48681(VarCurr,0) ) ).

tff(addAssignment_24575,axiom,
    ! [VarCurr: state_type] :
      ( v48976(VarCurr)
    <=> v48978(VarCurr) ) ).

tff(addAssignment_24574,axiom,
    ! [VarCurr: state_type] :
      ( v48978(VarCurr)
    <=> $false ) ).

tff(addAssignment_24573,axiom,
    ! [VarCurr: state_type] :
      ( v48970(VarCurr)
    <=> v48972(VarCurr) ) ).

tff(addAssignment_24572,axiom,
    ! [VarCurr: state_type] :
      ( v48972(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48960(VarCurr,B)
      <=> v48962(VarCurr,B) ) ) ).

tff(addAssignment_24570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48962(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24569,axiom,
    ! [VarCurr: state_type] :
      ( v48950(VarCurr)
    <=> v48952(VarCurr) ) ).

tff(addAssignment_24568,axiom,
    ! [VarCurr: state_type] :
      ( v48952(VarCurr)
    <=> v48954(VarCurr) ) ).

tff(addAssignment_24567,axiom,
    ! [VarCurr: state_type] :
      ( v48954(VarCurr)
    <=> v48956(VarCurr) ) ).

tff(addAssignment_24566,axiom,
    ! [VarCurr: state_type] :
      ( v48956(VarCurr)
    <=> v48958(VarCurr) ) ).

tff(addAssignment_24565,axiom,
    ! [VarCurr: state_type] :
      ( v48958(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24564,axiom,
    ! [VarCurr: state_type] :
      ( v48940(VarCurr)
    <=> v48942(VarCurr) ) ).

tff(addAssignment_24563,axiom,
    ! [VarCurr: state_type] :
      ( v48942(VarCurr)
    <=> v48944(VarCurr) ) ).

tff(addAssignment_24562,axiom,
    ! [VarCurr: state_type] :
      ( v48944(VarCurr)
    <=> v48946(VarCurr) ) ).

tff(addAssignment_24561,axiom,
    ! [VarCurr: state_type] :
      ( v48946(VarCurr)
    <=> v48948(VarCurr) ) ).

tff(addAssignment_24560,axiom,
    ! [VarCurr: state_type] :
      ( v48948(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_24559,axiom,
    ! [VarCurr: state_type] :
      ( v48899(VarCurr)
    <=> v48901(VarCurr) ) ).

tff(addAssignment_24558,axiom,
    ! [VarCurr: state_type] :
      ( v48901(VarCurr)
    <=> v48903(VarCurr) ) ).

tff(addAssignment_24557,axiom,
    ! [VarCurr: state_type] :
      ( v48903(VarCurr)
    <=> v48905(VarCurr) ) ).

tff(addAssignment_24556,axiom,
    ! [VarCurr: state_type] :
      ( v48905(VarCurr)
    <=> v48907(VarCurr) ) ).

tff(addAssignment_24555,axiom,
    ! [VarCurr: state_type] :
      ( v48907(VarCurr)
    <=> v48909(VarCurr) ) ).

tff(addAssignment_24554,axiom,
    ! [VarCurr: state_type] :
      ( v48909(VarCurr)
    <=> v48911(VarCurr) ) ).

tff(addAssignment_24553,axiom,
    ! [VarCurr: state_type] :
      ( v48911(VarCurr)
    <=> v48913(VarCurr) ) ).

tff(writeUnaryOperator_2794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48913(VarCurr)
    <=> v48927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4560,axiom,
    ! [VarCurr: state_type] :
      ( v48927(VarCurr)
    <=> ( v48928(VarCurr)
        | v48923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4559,axiom,
    ! [VarCurr: state_type] :
      ( v48928(VarCurr)
    <=> ( v48915(VarCurr)
        | v48919(VarCurr) ) ) ).

tff(addAssignment_24552,axiom,
    ! [VarCurr: state_type] :
      ( v48923(VarCurr)
    <=> v48925(VarCurr) ) ).

tff(addAssignment_24551,axiom,
    ! [VarCurr: state_type] :
      ( v48925(VarCurr)
    <=> v48345(VarCurr,2) ) ).

tff(addAssignment_24550,axiom,
    ! [VarCurr: state_type] :
      ( v48919(VarCurr)
    <=> v48921(VarCurr) ) ).

tff(addAssignment_24549,axiom,
    ! [VarCurr: state_type] :
      ( v48921(VarCurr)
    <=> v48428(VarCurr,1) ) ).

tff(addAssignment_24548,axiom,
    ! [VarCurr: state_type] :
      ( v48428(VarCurr,1)
    <=> v48430(VarCurr,1) ) ).

tff(addAssignment_24547,axiom,
    ! [VarCurr: state_type] :
      ( v48430(VarCurr,1)
    <=> v48432(VarCurr,1) ) ).

tff(addAssignment_24546,axiom,
    ! [VarCurr: state_type] :
      ( v48432(VarCurr,1)
    <=> v48437(VarCurr,1) ) ).

tff(addAssignment_24545,axiom,
    ! [VarCurr: state_type] :
      ( v48434(VarCurr,1)
    <=> v48436(VarCurr,1) ) ).

tff(addAssignment_24544,axiom,
    ! [VarCurr: state_type] :
      ( v48436(VarCurr,1)
    <=> v48345(VarCurr,1) ) ).

tff(addAssignment_24543,axiom,
    ! [VarCurr: state_type] :
      ( v48915(VarCurr)
    <=> v48917(VarCurr) ) ).

tff(addAssignment_24542,axiom,
    ! [VarCurr: state_type] :
      ( v48917(VarCurr)
    <=> v48345(VarCurr,0) ) ).

tff(addAssignment_24541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48779(VarCurr,B)
      <=> v48781(VarCurr,B) ) ) ).

tff(addAssignment_24540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48781(VarCurr,B)
      <=> v48783(VarCurr,B) ) ) ).

tff(addAssignment_24539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48783(VarCurr,B)
      <=> v48785(VarCurr,B) ) ) ).

tff(addAssignment_24538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48785(VarCurr,B)
      <=> v48787(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48882(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v48787(VarNext,B)
            <=> v48787(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_569,axiom,
    ! [VarNext: state_type] :
      ( v48882(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48787(VarNext,B)
          <=> v48892(VarNext,B) ) ) ) ).

tff(addAssignment_24537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48892(VarNext,B)
          <=> v48890(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48893(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48890(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_373,axiom,
    ! [VarCurr: state_type] :
      ( v48893(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48890(VarCurr,B)
          <=> v48809(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4558,axiom,
    ! [VarCurr: state_type] :
      ( v48893(VarCurr)
    <=> ( v48894(VarCurr)
        & v48895(VarCurr) ) ) ).

tff(writeUnaryOperator_2793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48895(VarCurr)
    <=> v48799(VarCurr) ) ).

tff(writeUnaryOperator_2792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48894(VarCurr)
    <=> v48789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48882(VarNext)
      <=> v48883(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48883(VarNext)
      <=> ( v48884(VarNext)
          & v48813(VarNext) ) ) ) ).

tff(writeUnaryOperator_2791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48884(VarNext)
      <=> v48886(VarNext) ) ) ).

tff(addAssignment_24536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48886(VarNext)
      <=> v48813(VarCurr) ) ) ).

tff(addAssignment_24535,axiom,
    ! [VarCurr: state_type] :
      ( v48813(VarCurr)
    <=> v48815(VarCurr) ) ).

tff(addAssignment_24534,axiom,
    ! [VarCurr: state_type] :
      ( v48815(VarCurr)
    <=> v48817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4555,axiom,
    ! [VarCurr: state_type] :
      ( v48817(VarCurr)
    <=> ( v48879(VarCurr)
        | v48875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4554,axiom,
    ! [VarCurr: state_type] :
      ( v48879(VarCurr)
    <=> ( v48819(VarCurr)
        & v48823(VarCurr) ) ) ).

tff(addAssignment_24533,axiom,
    ! [VarCurr: state_type] :
      ( v48875(VarCurr)
    <=> v48877(VarCurr) ) ).

tff(addAssignment_24532,axiom,
    ! [VarCurr: state_type] :
      ( v48877(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48859(VarNext)
       => ( v48823(VarNext)
        <=> v48823(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_568,axiom,
    ! [VarNext: state_type] :
      ( v48859(VarNext)
     => ( v48823(VarNext)
      <=> v48869(VarNext) ) ) ).

tff(addAssignment_24531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48869(VarNext)
      <=> v48867(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4553,axiom,
    ! [VarCurr: state_type] :
      ( v48867(VarCurr)
    <=> ( v48870(VarCurr)
        & v48871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4552,axiom,
    ! [VarCurr: state_type] :
      ( v48871(VarCurr)
    <=> ( v48829(VarCurr)
        | v48854(VarCurr) ) ) ).

tff(writeUnaryOperator_2790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48870(VarCurr)
    <=> v48825(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48859(VarNext)
      <=> v48860(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48860(VarNext)
      <=> ( v48862(VarNext)
          & v48864(VarNext) ) ) ) ).

tff(writeUnaryOperator_2789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48864(VarCurr)
    <=> v48819(VarCurr) ) ).

tff(addAssignment_24530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48862(VarNext)
      <=> v48819(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_210,axiom,
    ( v48823(constB0)
  <=> $true ) ).

tff(addAssignment_24529,axiom,
    ! [VarCurr: state_type] :
      ( v48854(VarCurr)
    <=> v48856(VarCurr) ) ).

tff(addAssignment_24528,axiom,
    ! [VarCurr: state_type] :
      ( v48856(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24527,axiom,
    ! [VarCurr: state_type] :
      ( v48829(VarCurr)
    <=> v48831(VarCurr) ) ).

tff(addAssignment_24526,axiom,
    ! [VarCurr: state_type] :
      ( v48831(VarCurr)
    <=> v48833(VarCurr) ) ).

tff(addAssignment_24525,axiom,
    ! [VarCurr: state_type] :
      ( v48833(VarCurr)
    <=> v48835(VarCurr) ) ).

tff(addAssignment_24524,axiom,
    ! [VarCurr: state_type] :
      ( v48835(VarCurr)
    <=> v48837(VarCurr) ) ).

tff(writeUnaryOperator_2788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48837(VarCurr)
    <=> v48851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4549,axiom,
    ! [VarCurr: state_type] :
      ( v48851(VarCurr)
    <=> ( v48852(VarCurr)
        | v48847(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4548,axiom,
    ! [VarCurr: state_type] :
      ( v48852(VarCurr)
    <=> ( v48839(VarCurr)
        | v48843(VarCurr) ) ) ).

tff(addAssignment_24523,axiom,
    ! [VarCurr: state_type] :
      ( v48847(VarCurr)
    <=> v48849(VarCurr) ) ).

tff(addAssignment_24522,axiom,
    ! [VarCurr: state_type] :
      ( v48849(VarCurr)
    <=> v48255(VarCurr,2) ) ).

tff(addAssignment_24521,axiom,
    ! [VarCurr: state_type] :
      ( v48843(VarCurr)
    <=> v48845(VarCurr) ) ).

tff(addAssignment_24520,axiom,
    ! [VarCurr: state_type] :
      ( v48845(VarCurr)
    <=> v48681(VarCurr,1) ) ).

tff(addAssignment_24519,axiom,
    ! [VarCurr: state_type] :
      ( v48681(VarCurr,1)
    <=> v48683(VarCurr,1) ) ).

tff(addAssignment_24518,axiom,
    ! [VarCurr: state_type] :
      ( v48683(VarCurr,1)
    <=> v48685(VarCurr,1) ) ).

tff(addAssignment_24517,axiom,
    ! [VarCurr: state_type] :
      ( v48685(VarCurr,1)
    <=> v48690(VarCurr,1) ) ).

tff(addAssignment_24516,axiom,
    ! [VarCurr: state_type] :
      ( v48687(VarCurr,1)
    <=> v48689(VarCurr,1) ) ).

tff(addAssignment_24515,axiom,
    ! [VarCurr: state_type] :
      ( v48689(VarCurr,1)
    <=> v48255(VarCurr,1) ) ).

tff(addAssignment_24514,axiom,
    ! [VarCurr: state_type] :
      ( v48839(VarCurr)
    <=> v48841(VarCurr) ) ).

tff(addAssignment_24513,axiom,
    ! [VarCurr: state_type] :
      ( v48841(VarCurr)
    <=> v48255(VarCurr,0) ) ).

tff(addAssignment_24512,axiom,
    ! [VarCurr: state_type] :
      ( v48825(VarCurr)
    <=> v48827(VarCurr) ) ).

tff(addAssignment_24511,axiom,
    ! [VarCurr: state_type] :
      ( v48827(VarCurr)
    <=> $false ) ).

tff(addAssignment_24510,axiom,
    ! [VarCurr: state_type] :
      ( v48819(VarCurr)
    <=> v48821(VarCurr) ) ).

tff(addAssignment_24509,axiom,
    ! [VarCurr: state_type] :
      ( v48821(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48809(VarCurr,B)
      <=> v48811(VarCurr,B) ) ) ).

tff(addAssignment_24507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48811(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24506,axiom,
    ! [VarCurr: state_type] :
      ( v48799(VarCurr)
    <=> v48801(VarCurr) ) ).

tff(addAssignment_24505,axiom,
    ! [VarCurr: state_type] :
      ( v48801(VarCurr)
    <=> v48803(VarCurr) ) ).

tff(addAssignment_24504,axiom,
    ! [VarCurr: state_type] :
      ( v48803(VarCurr)
    <=> v48805(VarCurr) ) ).

tff(addAssignment_24503,axiom,
    ! [VarCurr: state_type] :
      ( v48805(VarCurr)
    <=> v48807(VarCurr) ) ).

tff(addAssignment_24502,axiom,
    ! [VarCurr: state_type] :
      ( v48807(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24501,axiom,
    ! [VarCurr: state_type] :
      ( v48789(VarCurr)
    <=> v48791(VarCurr) ) ).

tff(addAssignment_24500,axiom,
    ! [VarCurr: state_type] :
      ( v48791(VarCurr)
    <=> v48793(VarCurr) ) ).

tff(addAssignment_24499,axiom,
    ! [VarCurr: state_type] :
      ( v48793(VarCurr)
    <=> v48795(VarCurr) ) ).

tff(addAssignment_24498,axiom,
    ! [VarCurr: state_type] :
      ( v48795(VarCurr)
    <=> v48797(VarCurr) ) ).

tff(addAssignment_24497,axiom,
    ! [VarCurr: state_type] :
      ( v48797(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_24496,axiom,
    ! [VarCurr: state_type] :
      ( v48748(VarCurr)
    <=> v48750(VarCurr) ) ).

tff(addAssignment_24495,axiom,
    ! [VarCurr: state_type] :
      ( v48750(VarCurr)
    <=> v48752(VarCurr) ) ).

tff(addAssignment_24494,axiom,
    ! [VarCurr: state_type] :
      ( v48752(VarCurr)
    <=> v48754(VarCurr) ) ).

tff(addAssignment_24493,axiom,
    ! [VarCurr: state_type] :
      ( v48754(VarCurr)
    <=> v48756(VarCurr) ) ).

tff(addAssignment_24492,axiom,
    ! [VarCurr: state_type] :
      ( v48756(VarCurr)
    <=> v48758(VarCurr) ) ).

tff(addAssignment_24491,axiom,
    ! [VarCurr: state_type] :
      ( v48758(VarCurr)
    <=> v48760(VarCurr) ) ).

tff(addAssignment_24490,axiom,
    ! [VarCurr: state_type] :
      ( v48760(VarCurr)
    <=> v48762(VarCurr) ) ).

tff(writeUnaryOperator_2787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48762(VarCurr)
    <=> v48776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4547,axiom,
    ! [VarCurr: state_type] :
      ( v48776(VarCurr)
    <=> ( v48777(VarCurr)
        | v48772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4546,axiom,
    ! [VarCurr: state_type] :
      ( v48777(VarCurr)
    <=> ( v48764(VarCurr)
        | v48768(VarCurr) ) ) ).

tff(addAssignment_24489,axiom,
    ! [VarCurr: state_type] :
      ( v48772(VarCurr)
    <=> v48774(VarCurr) ) ).

tff(addAssignment_24488,axiom,
    ! [VarCurr: state_type] :
      ( v48774(VarCurr)
    <=> v48345(VarCurr,2) ) ).

tff(addAssignment_24487,axiom,
    ! [VarCurr: state_type] :
      ( v48768(VarCurr)
    <=> v48770(VarCurr) ) ).

tff(addAssignment_24486,axiom,
    ! [VarCurr: state_type] :
      ( v48770(VarCurr)
    <=> v48345(VarCurr,1) ) ).

tff(addAssignment_24485,axiom,
    ! [VarCurr: state_type] :
      ( v48764(VarCurr)
    <=> v48766(VarCurr) ) ).

tff(addAssignment_24484,axiom,
    ! [VarCurr: state_type] :
      ( v48766(VarCurr)
    <=> v48428(VarCurr,0) ) ).

tff(addAssignment_24483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48617(VarCurr,B)
      <=> v48619(VarCurr,B) ) ) ).

tff(addAssignment_24482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48619(VarCurr,B)
      <=> v48621(VarCurr,B) ) ) ).

tff(addAssignment_24481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48621(VarCurr,B)
      <=> v48623(VarCurr,B) ) ) ).

tff(addAssignment_24480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48623(VarCurr,B)
      <=> v48625(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48731(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v48625(VarNext,B)
            <=> v48625(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_567,axiom,
    ! [VarNext: state_type] :
      ( v48731(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48625(VarNext,B)
          <=> v48741(VarNext,B) ) ) ) ).

tff(addAssignment_24479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48741(VarNext,B)
          <=> v48739(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48742(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48739(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_372,axiom,
    ! [VarCurr: state_type] :
      ( v48742(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48739(VarCurr,B)
          <=> v48647(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4545,axiom,
    ! [VarCurr: state_type] :
      ( v48742(VarCurr)
    <=> ( v48743(VarCurr)
        & v48744(VarCurr) ) ) ).

tff(writeUnaryOperator_2786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48744(VarCurr)
    <=> v48637(VarCurr) ) ).

tff(writeUnaryOperator_2785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48743(VarCurr)
    <=> v48627(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48731(VarNext)
      <=> v48732(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48732(VarNext)
      <=> ( v48733(VarNext)
          & v48651(VarNext) ) ) ) ).

tff(writeUnaryOperator_2784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48733(VarNext)
      <=> v48735(VarNext) ) ) ).

tff(addAssignment_24478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48735(VarNext)
      <=> v48651(VarCurr) ) ) ).

tff(addAssignment_24477,axiom,
    ! [VarCurr: state_type] :
      ( v48651(VarCurr)
    <=> v48653(VarCurr) ) ).

tff(addAssignment_24476,axiom,
    ! [VarCurr: state_type] :
      ( v48653(VarCurr)
    <=> v48655(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4542,axiom,
    ! [VarCurr: state_type] :
      ( v48655(VarCurr)
    <=> ( v48728(VarCurr)
        | v48724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4541,axiom,
    ! [VarCurr: state_type] :
      ( v48728(VarCurr)
    <=> ( v48657(VarCurr)
        & v48661(VarCurr) ) ) ).

tff(addAssignment_24475,axiom,
    ! [VarCurr: state_type] :
      ( v48724(VarCurr)
    <=> v48726(VarCurr) ) ).

tff(addAssignment_24474,axiom,
    ! [VarCurr: state_type] :
      ( v48726(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48708(VarNext)
       => ( v48661(VarNext)
        <=> v48661(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_566,axiom,
    ! [VarNext: state_type] :
      ( v48708(VarNext)
     => ( v48661(VarNext)
      <=> v48718(VarNext) ) ) ).

tff(addAssignment_24473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48718(VarNext)
      <=> v48716(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4540,axiom,
    ! [VarCurr: state_type] :
      ( v48716(VarCurr)
    <=> ( v48719(VarCurr)
        & v48720(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4539,axiom,
    ! [VarCurr: state_type] :
      ( v48720(VarCurr)
    <=> ( v48667(VarCurr)
        | v48703(VarCurr) ) ) ).

tff(writeUnaryOperator_2783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48719(VarCurr)
    <=> v48663(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48708(VarNext)
      <=> v48709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48709(VarNext)
      <=> ( v48711(VarNext)
          & v48713(VarNext) ) ) ) ).

tff(writeUnaryOperator_2782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48713(VarCurr)
    <=> v48657(VarCurr) ) ).

tff(addAssignment_24472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48711(VarNext)
      <=> v48657(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_209,axiom,
    ( v48661(constB0)
  <=> $true ) ).

tff(addAssignment_24471,axiom,
    ! [VarCurr: state_type] :
      ( v48703(VarCurr)
    <=> v48705(VarCurr) ) ).

tff(addAssignment_24470,axiom,
    ! [VarCurr: state_type] :
      ( v48705(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24469,axiom,
    ! [VarCurr: state_type] :
      ( v48667(VarCurr)
    <=> v48669(VarCurr) ) ).

tff(addAssignment_24468,axiom,
    ! [VarCurr: state_type] :
      ( v48669(VarCurr)
    <=> v48671(VarCurr) ) ).

tff(addAssignment_24467,axiom,
    ! [VarCurr: state_type] :
      ( v48671(VarCurr)
    <=> v48673(VarCurr) ) ).

tff(addAssignment_24466,axiom,
    ! [VarCurr: state_type] :
      ( v48673(VarCurr)
    <=> v48675(VarCurr) ) ).

tff(writeUnaryOperator_2781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48675(VarCurr)
    <=> v48700(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4536,axiom,
    ! [VarCurr: state_type] :
      ( v48700(VarCurr)
    <=> ( v48701(VarCurr)
        | v48696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4535,axiom,
    ! [VarCurr: state_type] :
      ( v48701(VarCurr)
    <=> ( v48677(VarCurr)
        | v48692(VarCurr) ) ) ).

tff(addAssignment_24465,axiom,
    ! [VarCurr: state_type] :
      ( v48696(VarCurr)
    <=> v48698(VarCurr) ) ).

tff(addAssignment_24464,axiom,
    ! [VarCurr: state_type] :
      ( v48698(VarCurr)
    <=> v48255(VarCurr,2) ) ).

tff(addAssignment_24463,axiom,
    ! [VarCurr: state_type] :
      ( v48692(VarCurr)
    <=> v48694(VarCurr) ) ).

tff(addAssignment_24462,axiom,
    ! [VarCurr: state_type] :
      ( v48694(VarCurr)
    <=> v48255(VarCurr,1) ) ).

tff(addAssignment_24461,axiom,
    ! [VarCurr: state_type] :
      ( v48677(VarCurr)
    <=> v48679(VarCurr) ) ).

tff(addAssignment_24460,axiom,
    ! [VarCurr: state_type] :
      ( v48679(VarCurr)
    <=> v48681(VarCurr,0) ) ).

tff(addAssignment_24459,axiom,
    ! [VarCurr: state_type] :
      ( v48681(VarCurr,0)
    <=> v48683(VarCurr,0) ) ).

tff(addAssignment_24458,axiom,
    ! [VarCurr: state_type] :
      ( v48683(VarCurr,0)
    <=> v48685(VarCurr,0) ) ).

tff(addAssignment_24457,axiom,
    ! [VarCurr: state_type] :
      ( v48685(VarCurr,0)
    <=> v48690(VarCurr,0) ) ).

tff(writeUnaryOperator_2780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v48690(VarCurr,B)
      <=> ~ v48687(VarCurr,B) ) ) ).

tff(addAssignment_24456,axiom,
    ! [VarCurr: state_type] :
      ( v48687(VarCurr,0)
    <=> v48689(VarCurr,0) ) ).

tff(addAssignment_24455,axiom,
    ! [VarCurr: state_type] :
      ( v48689(VarCurr,0)
    <=> v48255(VarCurr,0) ) ).

tff(addAssignment_24454,axiom,
    ! [VarCurr: state_type] :
      ( v48663(VarCurr)
    <=> v48665(VarCurr) ) ).

tff(addAssignment_24453,axiom,
    ! [VarCurr: state_type] :
      ( v48665(VarCurr)
    <=> $false ) ).

tff(addAssignment_24452,axiom,
    ! [VarCurr: state_type] :
      ( v48657(VarCurr)
    <=> v48659(VarCurr) ) ).

tff(addAssignment_24451,axiom,
    ! [VarCurr: state_type] :
      ( v48659(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48647(VarCurr,B)
      <=> v48649(VarCurr,B) ) ) ).

tff(addAssignment_24449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48649(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24448,axiom,
    ! [VarCurr: state_type] :
      ( v48637(VarCurr)
    <=> v48639(VarCurr) ) ).

tff(addAssignment_24447,axiom,
    ! [VarCurr: state_type] :
      ( v48639(VarCurr)
    <=> v48641(VarCurr) ) ).

tff(addAssignment_24446,axiom,
    ! [VarCurr: state_type] :
      ( v48641(VarCurr)
    <=> v48643(VarCurr) ) ).

tff(addAssignment_24445,axiom,
    ! [VarCurr: state_type] :
      ( v48643(VarCurr)
    <=> v48645(VarCurr) ) ).

tff(addAssignment_24444,axiom,
    ! [VarCurr: state_type] :
      ( v48645(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24443,axiom,
    ! [VarCurr: state_type] :
      ( v48627(VarCurr)
    <=> v48629(VarCurr) ) ).

tff(addAssignment_24442,axiom,
    ! [VarCurr: state_type] :
      ( v48629(VarCurr)
    <=> v48631(VarCurr) ) ).

tff(addAssignment_24441,axiom,
    ! [VarCurr: state_type] :
      ( v48631(VarCurr)
    <=> v48633(VarCurr) ) ).

tff(addAssignment_24440,axiom,
    ! [VarCurr: state_type] :
      ( v48633(VarCurr)
    <=> v48635(VarCurr) ) ).

tff(addAssignment_24439,axiom,
    ! [VarCurr: state_type] :
      ( v48635(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_24438,axiom,
    ! [VarCurr: state_type] :
      ( v48325(VarCurr)
    <=> v48327(VarCurr) ) ).

tff(addAssignment_24437,axiom,
    ! [VarCurr: state_type] :
      ( v48327(VarCurr)
    <=> v48329(VarCurr) ) ).

tff(addAssignment_24436,axiom,
    ! [VarCurr: state_type] :
      ( v48329(VarCurr)
    <=> v48331(VarCurr) ) ).

tff(addAssignment_24435,axiom,
    ! [VarCurr: state_type] :
      ( v48331(VarCurr)
    <=> v48333(VarCurr) ) ).

tff(addAssignment_24434,axiom,
    ! [VarCurr: state_type] :
      ( v48333(VarCurr)
    <=> v48335(VarCurr) ) ).

tff(addAssignment_24433,axiom,
    ! [VarCurr: state_type] :
      ( v48335(VarCurr)
    <=> v48337(VarCurr) ) ).

tff(addAssignment_24432,axiom,
    ! [VarCurr: state_type] :
      ( v48337(VarCurr)
    <=> v48339(VarCurr) ) ).

tff(writeUnaryOperator_2779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48339(VarCurr)
    <=> v48614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4534,axiom,
    ! [VarCurr: state_type] :
      ( v48614(VarCurr)
    <=> ( v48615(VarCurr)
        | v48610(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4533,axiom,
    ! [VarCurr: state_type] :
      ( v48615(VarCurr)
    <=> ( v48341(VarCurr)
        | v48606(VarCurr) ) ) ).

tff(addAssignment_24431,axiom,
    ! [VarCurr: state_type] :
      ( v48610(VarCurr)
    <=> v48612(VarCurr) ) ).

tff(addAssignment_24430,axiom,
    ! [VarCurr: state_type] :
      ( v48612(VarCurr)
    <=> v48345(VarCurr,2) ) ).

tff(addAssignment_24429,axiom,
    ! [VarCurr: state_type] :
      ( v48606(VarCurr)
    <=> v48608(VarCurr) ) ).

tff(addAssignment_24428,axiom,
    ! [VarCurr: state_type] :
      ( v48608(VarCurr)
    <=> v48345(VarCurr,1) ) ).

tff(addAssignment_24427,axiom,
    ! [VarCurr: state_type] :
      ( v48341(VarCurr)
    <=> v48343(VarCurr) ) ).

tff(addAssignment_24426,axiom,
    ! [VarCurr: state_type] :
      ( v48343(VarCurr)
    <=> v48345(VarCurr,0) ) ).

tff(addAssignment_24425,axiom,
    ! [VarCurr: state_type] :
      ( v48345(VarCurr,0)
    <=> v48257(VarCurr,3) ) ).

tff(addAssignment_24424,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,3)
    <=> v48259(VarCurr,3) ) ).

tff(addAssignment_24423,axiom,
    ! [VarNext: state_type] :
      ( v48259(VarNext,3)
    <=> v48598(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48599(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v48598(VarNext,B)
            <=> v48259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_565,axiom,
    ! [VarNext: state_type] :
      ( v48599(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48598(VarNext,B)
          <=> v48570(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48599(VarNext)
      <=> v48600(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48600(VarNext)
      <=> ( v48602(VarNext)
          & v48512(VarNext) ) ) ) ).

tff(writeUnaryOperator_2778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48602(VarNext)
      <=> v48564(VarNext) ) ) ).

tff(addAssignment_24422,axiom,
    ! [VarCurr: state_type] :
      ( v48369(VarCurr,3)
    <=> v48371(VarCurr,3) ) ).

tff(addAssignment_24421,axiom,
    ! [VarCurr: state_type] :
      ( v48371(VarCurr,3)
    <=> v48509(VarCurr,3) ) ).

tff(addAssignment_24420,axiom,
    ! [VarCurr: state_type] :
      ( v48373(VarCurr,0)
    <=> v48375(VarCurr,0) ) ).

tff(addAssignment_24419,axiom,
    ! [VarCurr: state_type] :
      ( v48375(VarCurr,0)
    <=> v48377(VarCurr,0) ) ).

tff(addAssignment_24418,axiom,
    ! [VarCurr: state_type] :
      ( v48377(VarCurr,0)
    <=> v48508(VarCurr,0) ) ).

tff(addAssignment_24417,axiom,
    ! [VarCurr: state_type] :
      ( v48445(VarCurr,0)
    <=> v48447(VarCurr,0) ) ).

tff(addAssignment_24416,axiom,
    ! [VarCurr: state_type] :
      ( v48447(VarCurr,0)
    <=> v48449(VarCurr,0) ) ).

tff(addAssignment_24415,axiom,
    ! [VarCurr: state_type] :
      ( v48449(VarCurr,0)
    <=> v48451(VarCurr,0) ) ).

tff(addAssignment_24414,axiom,
    ! [VarCurr: state_type] :
      ( v48451(VarCurr,0)
    <=> v48453(VarCurr,0) ) ).

tff(addAssignment_24413,axiom,
    ! [VarCurr: state_type] :
      ( v48453(VarCurr,0)
    <=> v48463(VarCurr,0) ) ).

tff(addAssignment_24412,axiom,
    ! [VarCurr: state_type] :
      ( v48379(VarCurr,0)
    <=> v48381(VarCurr,0) ) ).

tff(addAssignment_24411,axiom,
    ! [VarCurr: state_type] :
      ( v48381(VarCurr,0)
    <=> v48442(VarCurr,0) ) ).

tff(addAssignment_24410,axiom,
    ! [VarCurr: state_type] :
      ( v48383(VarCurr)
    <=> v47909(VarCurr,2) ) ).

tff(addAssignment_24409,axiom,
    ! [VarCurr: state_type] :
      ( v47909(VarCurr,2)
    <=> v47911(VarCurr,2) ) ).

tff(addAssignment_24408,axiom,
    ! [VarCurr: state_type] :
      ( v47911(VarCurr,2)
    <=> v47921(VarCurr,2) ) ).

tff(addAssignment_24407,axiom,
    ! [VarCurr: state_type] :
      ( v47913(VarCurr,2)
    <=> v47915(VarCurr,2) ) ).

tff(addAssignment_24406,axiom,
    ! [VarCurr: state_type] :
      ( v47915(VarCurr,2)
    <=> v47918(VarCurr,2) ) ).

tff(addAssignment_24405,axiom,
    ! [VarCurr: state_type] :
      ( v47919(VarCurr)
    <=> v48386(VarCurr,1) ) ).

tff(addAssignment_24404,axiom,
    ! [VarCurr: state_type] :
      ( v48386(VarCurr,1)
    <=> v48388(VarCurr,1) ) ).

tff(addAssignment_24403,axiom,
    ! [VarCurr: state_type] :
      ( v48388(VarCurr,1)
    <=> v48596(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v48596(VarCurr,B)
      <=> ( v48390(VarCurr,B)
          | v48396(VarCurr,B) ) ) ) ).

tff(addAssignment_24402,axiom,
    ! [VarCurr: state_type] :
      ( v48396(VarCurr,1)
    <=> v48398(VarCurr,1) ) ).

tff(addAssignment_24401,axiom,
    ! [VarCurr: state_type] :
      ( v48398(VarCurr,1)
    <=> v48594(VarCurr,1) ) ).

tff(addAssignment_24400,axiom,
    ! [VarCurr: state_type] :
      ( v48594(VarCurr,0)
    <=> v48595(VarCurr) ) ).

tff(addAssignment_24399,axiom,
    ! [VarCurr: state_type] :
      ( v48594(VarCurr,1)
    <=> v48400(VarCurr) ) ).

tff(addAssignment_24398,axiom,
    ! [VarCurr: state_type] :
      ( v48400(VarCurr)
    <=> v48402(VarCurr,1) ) ).

tff(addAssignment_24397,axiom,
    ! [VarCurr: state_type] :
      ( v48402(VarCurr,1)
    <=> v48404(VarCurr,1) ) ).

tff(addAssignment_24396,axiom,
    ! [VarCurr: state_type] :
      ( v48404(VarCurr,1)
    <=> v48593(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v48593(VarCurr,B)
      <=> ( v48406(VarCurr,B)
          & v48414(VarCurr,B) ) ) ) ).

tff(addAssignment_24395,axiom,
    ! [VarCurr: state_type] :
      ( v48414(VarCurr,1)
    <=> v48416(VarCurr,1) ) ).

tff(addAssignment_24394,axiom,
    ! [VarCurr: state_type] :
      ( v48416(VarCurr,1)
    <=> v48591(VarCurr,1) ) ).

tff(addAssignment_24393,axiom,
    ! [VarCurr: state_type] :
      ( v48591(VarCurr,0)
    <=> v48592(VarCurr) ) ).

tff(addAssignment_24392,axiom,
    ! [VarCurr: state_type] :
      ( v48591(VarCurr,1)
    <=> v48418(VarCurr) ) ).

tff(addAssignment_24391,axiom,
    ! [VarCurr: state_type] :
      ( v48418(VarCurr)
    <=> v48420(VarCurr) ) ).

tff(addAssignment_24390,axiom,
    ! [VarCurr: state_type] :
      ( v48420(VarCurr)
    <=> v48422(VarCurr) ) ).

tff(writeUnaryOperator_2777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48422(VarCurr)
    <=> v48589(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4530,axiom,
    ! [VarCurr: state_type] :
      ( v48589(VarCurr)
    <=> ( v48590(VarCurr)
        | v48577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4529,axiom,
    ! [VarCurr: state_type] :
      ( v48590(VarCurr)
    <=> ( v48424(VarCurr)
        | v48439(VarCurr) ) ) ).

tff(addAssignment_24389,axiom,
    ! [VarCurr: state_type] :
      ( v48577(VarCurr)
    <=> v48579(VarCurr) ) ).

tff(addAssignment_24388,axiom,
    ! [VarCurr: state_type] :
      ( v48579(VarCurr)
    <=> v48428(VarCurr,2) ) ).

tff(addAssignment_24387,axiom,
    ! [VarCurr: state_type] :
      ( v48428(VarCurr,2)
    <=> v48430(VarCurr,2) ) ).

tff(addAssignment_24386,axiom,
    ! [VarCurr: state_type] :
      ( v48430(VarCurr,2)
    <=> v48432(VarCurr,2) ) ).

tff(addAssignment_24385,axiom,
    ! [VarCurr: state_type] :
      ( v48432(VarCurr,2)
    <=> v48437(VarCurr,2) ) ).

tff(addAssignment_24384,axiom,
    ! [VarCurr: state_type] :
      ( v48434(VarCurr,2)
    <=> v48436(VarCurr,2) ) ).

tff(addAssignment_24383,axiom,
    ! [VarCurr: state_type] :
      ( v48436(VarCurr,2)
    <=> v48345(VarCurr,2) ) ).

tff(addAssignment_24382,axiom,
    ! [VarCurr: state_type] :
      ( v48345(VarCurr,2)
    <=> v48257(VarCurr,5) ) ).

tff(addAssignment_24381,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,5)
    <=> v48259(VarCurr,5) ) ).

tff(addAssignment_24380,axiom,
    ! [VarNext: state_type] :
      ( v48259(VarNext,5)
    <=> v48581(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48582(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v48581(VarNext,B)
            <=> v48259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_564,axiom,
    ! [VarNext: state_type] :
      ( v48582(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48581(VarNext,B)
          <=> v48570(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48582(VarNext)
      <=> v48583(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48583(VarNext)
      <=> ( v48585(VarNext)
          & v48512(VarNext) ) ) ) ).

tff(writeUnaryOperator_2776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48585(VarNext)
      <=> v48564(VarNext) ) ) ).

tff(addAssignment_24379,axiom,
    ! [VarCurr: state_type] :
      ( v48369(VarCurr,5)
    <=> v48371(VarCurr,5) ) ).

tff(addAssignment_24378,axiom,
    ! [VarCurr: state_type] :
      ( v48371(VarCurr,5)
    <=> v48509(VarCurr,5) ) ).

tff(addAssignment_24377,axiom,
    ! [VarCurr: state_type] :
      ( v48373(VarCurr,2)
    <=> v48375(VarCurr,2) ) ).

tff(addAssignment_24376,axiom,
    ! [VarCurr: state_type] :
      ( v48375(VarCurr,2)
    <=> v48377(VarCurr,2) ) ).

tff(addAssignment_24375,axiom,
    ! [VarCurr: state_type] :
      ( v48377(VarCurr,2)
    <=> v48508(VarCurr,2) ) ).

tff(addAssignment_24374,axiom,
    ! [VarCurr: state_type] :
      ( v48445(VarCurr,2)
    <=> v48447(VarCurr,2) ) ).

tff(addAssignment_24373,axiom,
    ! [VarCurr: state_type] :
      ( v48447(VarCurr,2)
    <=> v48449(VarCurr,2) ) ).

tff(addAssignment_24372,axiom,
    ! [VarCurr: state_type] :
      ( v48449(VarCurr,2)
    <=> v48451(VarCurr,2) ) ).

tff(addAssignment_24371,axiom,
    ! [VarCurr: state_type] :
      ( v48451(VarCurr,2)
    <=> v48453(VarCurr,2) ) ).

tff(addAssignment_24370,axiom,
    ! [VarCurr: state_type] :
      ( v48453(VarCurr,2)
    <=> v48463(VarCurr,2) ) ).

tff(addAssignment_24369,axiom,
    ! [VarCurr: state_type] :
      ( v48455(VarCurr,2)
    <=> v48457(VarCurr,2) ) ).

tff(addAssignment_24368,axiom,
    ! [VarCurr: state_type] :
      ( v48457(VarCurr,2)
    <=> v48458(VarCurr,2) ) ).

tff(addAssignment_24367,axiom,
    ! [VarCurr: state_type] :
      ( v48379(VarCurr,2)
    <=> v48381(VarCurr,2) ) ).

tff(addAssignment_24366,axiom,
    ! [VarCurr: state_type] :
      ( v48381(VarCurr,2)
    <=> v48442(VarCurr,2) ) ).

tff(addAssignment_24365,axiom,
    ! [VarCurr: state_type] :
      ( v48439(VarCurr)
    <=> v48441(VarCurr) ) ).

tff(addAssignment_24364,axiom,
    ! [VarCurr: state_type] :
      ( v48441(VarCurr)
    <=> v48345(VarCurr,1) ) ).

tff(addAssignment_24363,axiom,
    ! [VarCurr: state_type] :
      ( v48345(VarCurr,1)
    <=> v48257(VarCurr,4) ) ).

tff(addAssignment_24362,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,4)
    <=> v48259(VarCurr,4) ) ).

tff(addAssignment_24361,axiom,
    ! [VarNext: state_type] :
      ( v48259(VarNext,4)
    <=> v48559(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48560(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v48559(VarNext,B)
            <=> v48259(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_563,axiom,
    ! [VarNext: state_type] :
      ( v48560(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48559(VarNext,B)
          <=> v48570(VarNext,B) ) ) ) ).

tff(addAssignment_24360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48570(VarNext,B)
          <=> v48568(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48571(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48568(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_371,axiom,
    ! [VarCurr: state_type] :
      ( v48571(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v48568(VarCurr,B)
          <=> v48369(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4526,axiom,
    ! [VarCurr: state_type] :
      ( v48571(VarCurr)
    <=> ( v48572(VarCurr)
        & v48573(VarCurr) ) ) ).

tff(writeUnaryOperator_2775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48573(VarCurr)
    <=> v48359(VarCurr) ) ).

tff(writeUnaryOperator_2774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48572(VarCurr)
    <=> v48347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48560(VarNext)
      <=> v48561(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48561(VarNext)
      <=> ( v48562(VarNext)
          & v48512(VarNext) ) ) ) ).

tff(writeUnaryOperator_2773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48562(VarNext)
      <=> v48564(VarNext) ) ) ).

tff(addAssignment_24359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48564(VarNext)
      <=> v48512(VarCurr) ) ) ).

tff(addAssignment_24358,axiom,
    ! [VarCurr: state_type] :
      ( v48512(VarCurr)
    <=> v48514(VarCurr) ) ).

tff(addAssignment_24357,axiom,
    ! [VarCurr: state_type] :
      ( v48514(VarCurr)
    <=> v48516(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4523,axiom,
    ! [VarCurr: state_type] :
      ( v48516(VarCurr)
    <=> ( v48557(VarCurr)
        | v48553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4522,axiom,
    ! [VarCurr: state_type] :
      ( v48557(VarCurr)
    <=> ( v48518(VarCurr)
        & v48522(VarCurr) ) ) ).

tff(addAssignment_24356,axiom,
    ! [VarCurr: state_type] :
      ( v48553(VarCurr)
    <=> v48555(VarCurr) ) ).

tff(addAssignment_24355,axiom,
    ! [VarCurr: state_type] :
      ( v48555(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48537(VarNext)
       => ( v48522(VarNext)
        <=> v48522(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_562,axiom,
    ! [VarNext: state_type] :
      ( v48537(VarNext)
     => ( v48522(VarNext)
      <=> v48547(VarNext) ) ) ).

tff(addAssignment_24354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48547(VarNext)
      <=> v48545(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4521,axiom,
    ! [VarCurr: state_type] :
      ( v48545(VarCurr)
    <=> ( v48548(VarCurr)
        & v48549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4520,axiom,
    ! [VarCurr: state_type] :
      ( v48549(VarCurr)
    <=> ( v48528(VarCurr)
        | v48532(VarCurr) ) ) ).

tff(writeUnaryOperator_2772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48548(VarCurr)
    <=> v48524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48537(VarNext)
      <=> v48538(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48538(VarNext)
      <=> ( v48540(VarNext)
          & v48542(VarNext) ) ) ) ).

tff(writeUnaryOperator_2771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48542(VarCurr)
    <=> v48518(VarCurr) ) ).

tff(addAssignment_24353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48540(VarNext)
      <=> v48518(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_208,axiom,
    ( v48522(constB0)
  <=> $true ) ).

tff(addAssignment_24352,axiom,
    ! [VarCurr: state_type] :
      ( v48532(VarCurr)
    <=> v48534(VarCurr) ) ).

tff(addAssignment_24351,axiom,
    ! [VarCurr: state_type] :
      ( v48534(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24350,axiom,
    ! [VarCurr: state_type] :
      ( v48528(VarCurr)
    <=> v48530(VarCurr) ) ).

tff(addAssignment_24349,axiom,
    ! [VarCurr: state_type] :
      ( v48530(VarCurr)
    <=> $true ) ).

tff(addAssignment_24348,axiom,
    ! [VarCurr: state_type] :
      ( v48524(VarCurr)
    <=> v48526(VarCurr) ) ).

tff(addAssignment_24347,axiom,
    ! [VarCurr: state_type] :
      ( v48526(VarCurr)
    <=> $false ) ).

tff(addAssignment_24346,axiom,
    ! [VarCurr: state_type] :
      ( v48518(VarCurr)
    <=> v48520(VarCurr) ) ).

tff(addAssignment_24345,axiom,
    ! [VarCurr: state_type] :
      ( v48520(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24344,axiom,
    ! [VarCurr: state_type] :
      ( v48369(VarCurr,4)
    <=> v48371(VarCurr,4) ) ).

tff(addAssignment_24343,axiom,
    ! [VarCurr: state_type] :
      ( v48371(VarCurr,4)
    <=> v48509(VarCurr,4) ) ).

tff(addAssignment_24342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v48509(VarCurr,B)
      <=> v48510(VarCurr,B) ) ) ).

tff(addAssignment_24341,axiom,
    ! [VarCurr: state_type] :
      ( ( v48509(VarCurr,5)
      <=> v48373(VarCurr,2) )
      & ( v48509(VarCurr,4)
      <=> v48373(VarCurr,1) )
      & ( v48509(VarCurr,3)
      <=> v48373(VarCurr,0) ) ) ).

tff(addAssignment_24340,axiom,
    ! [VarCurr: state_type] :
      ( v48373(VarCurr,1)
    <=> v48375(VarCurr,1) ) ).

tff(addAssignment_24339,axiom,
    ! [VarCurr: state_type] :
      ( v48375(VarCurr,1)
    <=> v48377(VarCurr,1) ) ).

tff(addAssignment_24338,axiom,
    ! [VarCurr: state_type] :
      ( v48377(VarCurr,1)
    <=> v48508(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v48508(VarCurr,B)
      <=> ( v48379(VarCurr,B)
          & v48445(VarCurr,B) ) ) ) ).

tff(addAssignment_24337,axiom,
    ! [VarCurr: state_type] :
      ( v48445(VarCurr,1)
    <=> v48447(VarCurr,1) ) ).

tff(addAssignment_24336,axiom,
    ! [VarCurr: state_type] :
      ( v48447(VarCurr,1)
    <=> v48449(VarCurr,1) ) ).

tff(addAssignment_24335,axiom,
    ! [VarCurr: state_type] :
      ( v48449(VarCurr,1)
    <=> v48451(VarCurr,1) ) ).

tff(addAssignment_24334,axiom,
    ! [VarCurr: state_type] :
      ( v48451(VarCurr,1)
    <=> v48453(VarCurr,1) ) ).

tff(addAssignment_24333,axiom,
    ! [VarCurr: state_type] :
      ( v48453(VarCurr,1)
    <=> v48463(VarCurr,1) ) ).

tff(addAssignment_24332,axiom,
    ! [VarCurr: state_type] :
      ( v48463(VarCurr,0)
    <=> v48503(VarCurr) ) ).

tff(addAssignment_24331,axiom,
    ! [VarCurr: state_type] :
      ( v48463(VarCurr,1)
    <=> v48498(VarCurr) ) ).

tff(addAssignment_24330,axiom,
    ! [VarCurr: state_type] :
      ( v48463(VarCurr,2)
    <=> v48493(VarCurr) ) ).

tff(addAssignment_24329,axiom,
    ! [VarCurr: state_type] :
      ( v48463(VarCurr,3)
    <=> v48465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4517,axiom,
    ! [VarCurr: state_type] :
      ( v48503(VarCurr)
    <=> ( v48504(VarCurr)
        & v48507(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4516,axiom,
    ! [VarCurr: state_type] :
      ( v48507(VarCurr)
    <=> ( v48455(VarCurr,0)
        | v48473(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4515,axiom,
    ! [VarCurr: state_type] :
      ( v48504(VarCurr)
    <=> ( v48505(VarCurr)
        | v48506(VarCurr) ) ) ).

tff(writeUnaryOperator_2770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48506(VarCurr)
    <=> v48473(VarCurr,0) ) ).

tff(writeUnaryOperator_2769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48505(VarCurr)
    <=> v48455(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4514,axiom,
    ! [VarCurr: state_type] :
      ( v48498(VarCurr)
    <=> ( v48499(VarCurr)
        & v48502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4513,axiom,
    ! [VarCurr: state_type] :
      ( v48502(VarCurr)
    <=> ( v48472(VarCurr)
        | v48474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4512,axiom,
    ! [VarCurr: state_type] :
      ( v48499(VarCurr)
    <=> ( v48500(VarCurr)
        | v48501(VarCurr) ) ) ).

tff(writeUnaryOperator_2768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48501(VarCurr)
    <=> v48474(VarCurr) ) ).

tff(writeUnaryOperator_2767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48500(VarCurr)
    <=> v48472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4511,axiom,
    ! [VarCurr: state_type] :
      ( v48493(VarCurr)
    <=> ( v48494(VarCurr)
        & v48497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4510,axiom,
    ! [VarCurr: state_type] :
      ( v48497(VarCurr)
    <=> ( v48470(VarCurr)
        | v48480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4509,axiom,
    ! [VarCurr: state_type] :
      ( v48494(VarCurr)
    <=> ( v48495(VarCurr)
        | v48496(VarCurr) ) ) ).

tff(writeUnaryOperator_2766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48496(VarCurr)
    <=> v48480(VarCurr) ) ).

tff(writeUnaryOperator_2765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48495(VarCurr)
    <=> v48470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4508,axiom,
    ! [VarCurr: state_type] :
      ( v48465(VarCurr)
    <=> ( v48466(VarCurr)
        & v48492(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4507,axiom,
    ! [VarCurr: state_type] :
      ( v48492(VarCurr)
    <=> ( v48468(VarCurr)
        | v48487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4506,axiom,
    ! [VarCurr: state_type] :
      ( v48466(VarCurr)
    <=> ( v48467(VarCurr)
        | v48486(VarCurr) ) ) ).

tff(writeUnaryOperator_2764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48486(VarCurr)
    <=> v48487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4505,axiom,
    ! [VarCurr: state_type] :
      ( v48487(VarCurr)
    <=> ( v48488(VarCurr)
        & v48491(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_543,axiom,
    ! [VarCurr: state_type] :
      ( v48491(VarCurr)
    <=> ( v48455(VarCurr,3)
        | v48473(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4504,axiom,
    ! [VarCurr: state_type] :
      ( v48488(VarCurr)
    <=> ( v48489(VarCurr)
        | v48490(VarCurr) ) ) ).

tff(writeUnaryOperator_2763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48490(VarCurr)
    <=> v48473(VarCurr,3) ) ).

tff(writeUnaryOperator_2762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48489(VarCurr)
    <=> v48455(VarCurr,3) ) ).

tff(writeUnaryOperator_2761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48467(VarCurr)
    <=> v48468(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4503,axiom,
    ! [VarCurr: state_type] :
      ( v48468(VarCurr)
    <=> ( v48469(VarCurr)
        | v48485(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_542,axiom,
    ! [VarCurr: state_type] :
      ( v48485(VarCurr)
    <=> ( v48455(VarCurr,2)
        & v48473(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4502,axiom,
    ! [VarCurr: state_type] :
      ( v48469(VarCurr)
    <=> ( v48470(VarCurr)
        & v48480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4501,axiom,
    ! [VarCurr: state_type] :
      ( v48480(VarCurr)
    <=> ( v48481(VarCurr)
        & v48484(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_541,axiom,
    ! [VarCurr: state_type] :
      ( v48484(VarCurr)
    <=> ( v48455(VarCurr,2)
        | v48473(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4500,axiom,
    ! [VarCurr: state_type] :
      ( v48481(VarCurr)
    <=> ( v48482(VarCurr)
        | v48483(VarCurr) ) ) ).

tff(writeUnaryOperator_2760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48483(VarCurr)
    <=> v48473(VarCurr,2) ) ).

tff(writeUnaryOperator_2759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48482(VarCurr)
    <=> v48455(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4499,axiom,
    ! [VarCurr: state_type] :
      ( v48470(VarCurr)
    <=> ( v48471(VarCurr)
        | v48479(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_540,axiom,
    ! [VarCurr: state_type] :
      ( v48479(VarCurr)
    <=> ( v48455(VarCurr,1)
        & v48473(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4498,axiom,
    ! [VarCurr: state_type] :
      ( v48471(VarCurr)
    <=> ( v48472(VarCurr)
        & v48474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4497,axiom,
    ! [VarCurr: state_type] :
      ( v48474(VarCurr)
    <=> ( v48475(VarCurr)
        & v48478(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_539,axiom,
    ! [VarCurr: state_type] :
      ( v48478(VarCurr)
    <=> ( v48455(VarCurr,1)
        | v48473(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4496,axiom,
    ! [VarCurr: state_type] :
      ( v48475(VarCurr)
    <=> ( v48476(VarCurr)
        | v48477(VarCurr) ) ) ).

tff(writeUnaryOperator_2758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48477(VarCurr)
    <=> v48473(VarCurr,1) ) ).

tff(writeUnaryOperator_2757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48476(VarCurr)
    <=> v48455(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4495,axiom,
    ! [VarCurr: state_type] :
      ( v48472(VarCurr)
    <=> ( v48455(VarCurr,0)
        & v48473(VarCurr,0) ) ) ).

tff(addAssignment_24328,axiom,
    ! [VarCurr: state_type] :
      ( v48473(VarCurr,0)
    <=> v48460(VarCurr) ) ).

tff(addAssignment_24327,axiom,
    ! [VarCurr: state_type] :
      ( ( v48473(VarCurr,3)
      <=> $false )
      & ( v48473(VarCurr,2)
      <=> $false )
      & ( v48473(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_24326,axiom,
    ! [VarCurr: state_type] :
      ( v48460(VarCurr)
    <=> v48462(VarCurr) ) ).

tff(addAssignment_24325,axiom,
    ! [VarCurr: state_type] :
      ( v48462(VarCurr)
    <=> v48410(VarCurr) ) ).

tff(addAssignment_24324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v48455(VarCurr,B)
      <=> v48457(VarCurr,B) ) ) ).

tff(addAssignment_24323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v48457(VarCurr,B)
      <=> v48458(VarCurr,B) ) ) ).

tff(addAssignment_24322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v48458(VarCurr,B)
      <=> v48345(VarCurr,B) ) ) ).

tff(addAssignment_24321,axiom,
    ! [VarCurr: state_type] :
      ( v48458(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_24320,axiom,
    ! [VarCurr: state_type] :
      ( v48379(VarCurr,1)
    <=> v48381(VarCurr,1) ) ).

tff(addAssignment_24319,axiom,
    ! [VarCurr: state_type] :
      ( v48381(VarCurr,1)
    <=> v48442(VarCurr,1) ) ).

tff(addAssignment_24318,axiom,
    ! [VarCurr: state_type] :
      ( v48442(VarCurr,0)
    <=> v48443(VarCurr) ) ).

tff(addAssignment_24317,axiom,
    ! [VarCurr: state_type] :
      ( v48442(VarCurr,1)
    <=> v48443(VarCurr) ) ).

tff(addAssignment_24316,axiom,
    ! [VarCurr: state_type] :
      ( v48442(VarCurr,2)
    <=> v48443(VarCurr) ) ).

tff(addAssignment_24315,axiom,
    ! [VarCurr: state_type] :
      ( v48443(VarCurr)
    <=> v48383(VarCurr) ) ).

tff(addAssignment_24314,axiom,
    ! [VarCurr: state_type] :
      ( v48424(VarCurr)
    <=> v48426(VarCurr) ) ).

tff(addAssignment_24313,axiom,
    ! [VarCurr: state_type] :
      ( v48426(VarCurr)
    <=> v48428(VarCurr,0) ) ).

tff(addAssignment_24312,axiom,
    ! [VarCurr: state_type] :
      ( v48428(VarCurr,0)
    <=> v48430(VarCurr,0) ) ).

tff(addAssignment_24311,axiom,
    ! [VarCurr: state_type] :
      ( v48430(VarCurr,0)
    <=> v48432(VarCurr,0) ) ).

tff(addAssignment_24310,axiom,
    ! [VarCurr: state_type] :
      ( v48432(VarCurr,0)
    <=> v48437(VarCurr,0) ) ).

tff(writeUnaryOperator_2756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v48437(VarCurr,B)
      <=> ~ v48434(VarCurr,B) ) ) ).

tff(addAssignment_24309,axiom,
    ! [VarCurr: state_type] :
      ( v48434(VarCurr,0)
    <=> v48436(VarCurr,0) ) ).

tff(addAssignment_24308,axiom,
    ! [VarCurr: state_type] :
      ( v48436(VarCurr,0)
    <=> v48345(VarCurr,0) ) ).

tff(addAssignment_24307,axiom,
    ! [VarCurr: state_type] :
      ( v48406(VarCurr,1)
    <=> v48408(VarCurr,1) ) ).

tff(addAssignment_24306,axiom,
    ! [VarCurr: state_type] :
      ( v48408(VarCurr,1)
    <=> v48411(VarCurr,1) ) ).

tff(addAssignment_24305,axiom,
    ! [VarCurr: state_type] :
      ( v48411(VarCurr,0)
    <=> v48412(VarCurr) ) ).

tff(addAssignment_24304,axiom,
    ! [VarCurr: state_type] :
      ( v48411(VarCurr,1)
    <=> v48410(VarCurr) ) ).

tff(addAssignment_24303,axiom,
    ! [VarCurr: state_type] :
      ( v48410(VarCurr)
    <=> v7230(VarCurr,11) ) ).

tff(addAssignment_24302,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,11)
    <=> v7232(VarCurr,11) ) ).

tff(addAssignment_24301,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,11)
    <=> v7234(VarCurr,11) ) ).

tff(addAssignment_24300,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,11)
    <=> v34455(VarCurr,11) ) ).

tff(addAssignment_24299,axiom,
    ! [VarCurr: state_type] :
      ( v48390(VarCurr,1)
    <=> v48392(VarCurr,1) ) ).

tff(addAssignment_24298,axiom,
    ! [VarCurr: state_type] :
      ( v48392(VarCurr,1)
    <=> v48393(VarCurr,1) ) ).

tff(addAssignment_24297,axiom,
    ! [VarCurr: state_type] :
      ( v48393(VarCurr,0)
    <=> v48394(VarCurr) ) ).

tff(addAssignment_24296,axiom,
    ! [VarCurr: state_type] :
      ( v48393(VarCurr,1)
    <=> v48394(VarCurr) ) ).

tff(addAssignment_24295,axiom,
    ! [VarCurr: state_type] :
      ( v48394(VarCurr)
    <=> v47917(VarCurr) ) ).

tff(addAssignment_24294,axiom,
    ! [VarCurr: state_type] :
      ( v48359(VarCurr)
    <=> v48361(VarCurr) ) ).

tff(addAssignment_24293,axiom,
    ! [VarCurr: state_type] :
      ( v48361(VarCurr)
    <=> v48363(VarCurr) ) ).

tff(addAssignment_24292,axiom,
    ! [VarCurr: state_type] :
      ( v48363(VarCurr)
    <=> v48365(VarCurr) ) ).

tff(addAssignment_24291,axiom,
    ! [VarCurr: state_type] :
      ( v48365(VarCurr)
    <=> v48367(VarCurr) ) ).

tff(addAssignment_24290,axiom,
    ! [VarCurr: state_type] :
      ( v48367(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24289,axiom,
    ! [VarCurr: state_type] :
      ( v48347(VarCurr)
    <=> v48349(VarCurr) ) ).

tff(addAssignment_24288,axiom,
    ! [VarCurr: state_type] :
      ( v48349(VarCurr)
    <=> v48351(VarCurr) ) ).

tff(addAssignment_24287,axiom,
    ! [VarCurr: state_type] :
      ( v48351(VarCurr)
    <=> v48353(VarCurr) ) ).

tff(addAssignment_24286,axiom,
    ! [VarCurr: state_type] :
      ( v48353(VarCurr)
    <=> v48355(VarCurr) ) ).

tff(addAssignment_24285,axiom,
    ! [VarCurr: state_type] :
      ( v48355(VarCurr)
    <=> v48357(VarCurr) ) ).

tff(addAssignment_24284,axiom,
    ! [VarCurr: state_type] :
      ( v48357(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_24283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47855(VarCurr,B)
      <=> v47857(VarCurr,B) ) ) ).

tff(addAssignment_24282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47857(VarCurr,B)
      <=> v47859(VarCurr,B) ) ) ).

tff(addAssignment_24281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47859(VarCurr,B)
      <=> v47861(VarCurr,B) ) ) ).

tff(addAssignment_24280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47861(VarCurr,B)
      <=> v47863(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48308(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47863(VarNext,B)
            <=> v47863(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_561,axiom,
    ! [VarNext: state_type] :
      ( v48308(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47863(VarNext,B)
          <=> v48318(VarNext,B) ) ) ) ).

tff(addAssignment_24279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48318(VarNext,B)
          <=> v48316(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48319(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48316(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_370,axiom,
    ! [VarCurr: state_type] :
      ( v48319(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48316(VarCurr,B)
          <=> v47893(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4494,axiom,
    ! [VarCurr: state_type] :
      ( v48319(VarCurr)
    <=> ( v48320(VarCurr)
        & v48321(VarCurr) ) ) ).

tff(writeUnaryOperator_2755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48321(VarCurr)
    <=> v47879(VarCurr) ) ).

tff(writeUnaryOperator_2754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48320(VarCurr)
    <=> v47865(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48308(VarNext)
      <=> v48309(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48309(VarNext)
      <=> ( v48310(VarNext)
          & v48223(VarNext) ) ) ) ).

tff(writeUnaryOperator_2753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48310(VarNext)
      <=> v48312(VarNext) ) ) ).

tff(addAssignment_24278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48312(VarNext)
      <=> v48223(VarCurr) ) ) ).

tff(addAssignment_24277,axiom,
    ! [VarCurr: state_type] :
      ( v48223(VarCurr)
    <=> v48225(VarCurr) ) ).

tff(addAssignment_24276,axiom,
    ! [VarCurr: state_type] :
      ( v48225(VarCurr)
    <=> v48227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4491,axiom,
    ! [VarCurr: state_type] :
      ( v48227(VarCurr)
    <=> ( v48305(VarCurr)
        | v48297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4490,axiom,
    ! [VarCurr: state_type] :
      ( v48305(VarCurr)
    <=> ( v48229(VarCurr)
        & v48235(VarCurr) ) ) ).

tff(addAssignment_24275,axiom,
    ! [VarCurr: state_type] :
      ( v48297(VarCurr)
    <=> v48299(VarCurr) ) ).

tff(addAssignment_24274,axiom,
    ! [VarCurr: state_type] :
      ( v48299(VarCurr)
    <=> v48301(VarCurr) ) ).

tff(addAssignment_24273,axiom,
    ! [VarCurr: state_type] :
      ( v48301(VarCurr)
    <=> v48303(VarCurr) ) ).

tff(addAssignment_24272,axiom,
    ! [VarCurr: state_type] :
      ( v48303(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48281(VarNext)
       => ( v48235(VarNext)
        <=> v48235(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_560,axiom,
    ! [VarNext: state_type] :
      ( v48281(VarNext)
     => ( v48235(VarNext)
      <=> v48291(VarNext) ) ) ).

tff(addAssignment_24271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48291(VarNext)
      <=> v48289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4489,axiom,
    ! [VarCurr: state_type] :
      ( v48289(VarCurr)
    <=> ( v48292(VarCurr)
        & v48293(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4488,axiom,
    ! [VarCurr: state_type] :
      ( v48293(VarCurr)
    <=> ( v48241(VarCurr)
        | v48272(VarCurr) ) ) ).

tff(writeUnaryOperator_2752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48292(VarCurr)
    <=> v48237(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48281(VarNext)
      <=> v48282(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48282(VarNext)
      <=> ( v48284(VarNext)
          & v48286(VarNext) ) ) ) ).

tff(writeUnaryOperator_2751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48286(VarCurr)
    <=> v48229(VarCurr) ) ).

tff(addAssignment_24270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48284(VarNext)
      <=> v48229(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_207,axiom,
    ( v48235(constB0)
  <=> $true ) ).

tff(addAssignment_24269,axiom,
    ! [VarCurr: state_type] :
      ( v48272(VarCurr)
    <=> v48274(VarCurr) ) ).

tff(addAssignment_24268,axiom,
    ! [VarCurr: state_type] :
      ( v48274(VarCurr)
    <=> v48276(VarCurr) ) ).

tff(addAssignment_24267,axiom,
    ! [VarCurr: state_type] :
      ( v48276(VarCurr)
    <=> v48278(VarCurr) ) ).

tff(addAssignment_24266,axiom,
    ! [VarCurr: state_type] :
      ( v48278(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_24265,axiom,
    ! [VarCurr: state_type] :
      ( v48241(VarCurr)
    <=> v48243(VarCurr) ) ).

tff(addAssignment_24264,axiom,
    ! [VarCurr: state_type] :
      ( v48243(VarCurr)
    <=> v48245(VarCurr) ) ).

tff(addAssignment_24263,axiom,
    ! [VarCurr: state_type] :
      ( v48245(VarCurr)
    <=> v48247(VarCurr) ) ).

tff(addAssignment_24262,axiom,
    ! [VarCurr: state_type] :
      ( v48247(VarCurr)
    <=> v48249(VarCurr) ) ).

tff(writeUnaryOperator_2750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48249(VarCurr)
    <=> v48269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4485,axiom,
    ! [VarCurr: state_type] :
      ( v48269(VarCurr)
    <=> ( v48270(VarCurr)
        | v48265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4484,axiom,
    ! [VarCurr: state_type] :
      ( v48270(VarCurr)
    <=> ( v48251(VarCurr)
        | v48261(VarCurr) ) ) ).

tff(addAssignment_24261,axiom,
    ! [VarCurr: state_type] :
      ( v48265(VarCurr)
    <=> v48267(VarCurr) ) ).

tff(addAssignment_24260,axiom,
    ! [VarCurr: state_type] :
      ( v48267(VarCurr)
    <=> v48255(VarCurr,2) ) ).

tff(addAssignment_24259,axiom,
    ! [VarCurr: state_type] :
      ( v48255(VarCurr,2)
    <=> v48257(VarCurr,2) ) ).

tff(addAssignment_24258,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,2)
    <=> v48259(VarCurr,2) ) ).

tff(addAssignment_24257,axiom,
    ! [VarCurr: state_type] :
      ( v48261(VarCurr)
    <=> v48263(VarCurr) ) ).

tff(addAssignment_24256,axiom,
    ! [VarCurr: state_type] :
      ( v48263(VarCurr)
    <=> v48255(VarCurr,1) ) ).

tff(addAssignment_24255,axiom,
    ! [VarCurr: state_type] :
      ( v48255(VarCurr,1)
    <=> v48257(VarCurr,1) ) ).

tff(addAssignment_24254,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,1)
    <=> v48259(VarCurr,1) ) ).

tff(addAssignment_24253,axiom,
    ! [VarCurr: state_type] :
      ( v48251(VarCurr)
    <=> v48253(VarCurr) ) ).

tff(addAssignment_24252,axiom,
    ! [VarCurr: state_type] :
      ( v48253(VarCurr)
    <=> v48255(VarCurr,0) ) ).

tff(addAssignment_24251,axiom,
    ! [VarCurr: state_type] :
      ( v48255(VarCurr,0)
    <=> v48257(VarCurr,0) ) ).

tff(addAssignment_24250,axiom,
    ! [VarCurr: state_type] :
      ( v48257(VarCurr,0)
    <=> v48259(VarCurr,0) ) ).

tff(addAssignment_24249,axiom,
    ! [VarCurr: state_type] :
      ( v48237(VarCurr)
    <=> v48239(VarCurr) ) ).

tff(addAssignment_24248,axiom,
    ! [VarCurr: state_type] :
      ( v48239(VarCurr)
    <=> $false ) ).

tff(addAssignment_24247,axiom,
    ! [VarCurr: state_type] :
      ( v48229(VarCurr)
    <=> v48231(VarCurr) ) ).

tff(addAssignment_24246,axiom,
    ! [VarCurr: state_type] :
      ( v48231(VarCurr)
    <=> v48233(VarCurr) ) ).

tff(addAssignment_24245,axiom,
    ! [VarCurr: state_type] :
      ( v48233(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_24244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47893(VarCurr,B)
      <=> v47895(VarCurr,B) ) ) ).

tff(addAssignment_24243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47895(VarCurr,B)
      <=> v47897(VarCurr,B) ) ) ).

tff(addAssignment_24242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47897(VarCurr,B)
      <=> v47899(VarCurr,B) ) ) ).

tff(addAssignment_24241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47899(VarCurr,B)
      <=> v47901(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47901(VarCurr,B)
      <=> ( v47903(VarCurr,B)
          & v47925(VarCurr,B) ) ) ) ).

tff(addAssignment_24240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47925(VarCurr,B)
      <=> v47927(VarCurr,B) ) ) ).

tff(addAssignment_24239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47927(VarCurr,B)
      <=> v47929(VarCurr,B) ) ) ).

tff(addAssignment_24238,axiom,
    ! [VarCurr: state_type] :
      ( ( v47929(VarCurr,11)
      <=> v6324(VarCurr,143) )
      & ( v47929(VarCurr,10)
      <=> v6324(VarCurr,142) )
      & ( v47929(VarCurr,9)
      <=> v6324(VarCurr,141) )
      & ( v47929(VarCurr,8)
      <=> v6324(VarCurr,140) )
      & ( v47929(VarCurr,7)
      <=> v6324(VarCurr,139) )
      & ( v47929(VarCurr,6)
      <=> v6324(VarCurr,138) )
      & ( v47929(VarCurr,5)
      <=> v6324(VarCurr,137) )
      & ( v47929(VarCurr,4)
      <=> v6324(VarCurr,136) )
      & ( v47929(VarCurr,3)
      <=> v6324(VarCurr,135) )
      & ( v47929(VarCurr,2)
      <=> v6324(VarCurr,134) )
      & ( v47929(VarCurr,1)
      <=> v6324(VarCurr,133) )
      & ( v47929(VarCurr,0)
      <=> v6324(VarCurr,132) ) ) ).

tff(addAssignment_24237,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,143)
      <=> v47931(VarCurr,11) )
      & ( v6324(VarCurr,142)
      <=> v47931(VarCurr,10) )
      & ( v6324(VarCurr,141)
      <=> v47931(VarCurr,9) )
      & ( v6324(VarCurr,140)
      <=> v47931(VarCurr,8) )
      & ( v6324(VarCurr,139)
      <=> v47931(VarCurr,7) )
      & ( v6324(VarCurr,138)
      <=> v47931(VarCurr,6) )
      & ( v6324(VarCurr,137)
      <=> v47931(VarCurr,5) )
      & ( v6324(VarCurr,136)
      <=> v47931(VarCurr,4) )
      & ( v6324(VarCurr,135)
      <=> v47931(VarCurr,3) )
      & ( v6324(VarCurr,134)
      <=> v47931(VarCurr,2) )
      & ( v6324(VarCurr,133)
      <=> v47931(VarCurr,1) )
      & ( v6324(VarCurr,132)
      <=> v47931(VarCurr,0) ) ) ).

tff(addAssignment_24236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47931(VarCurr,B)
      <=> v47933(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47933(VarCurr,B)
      <=> ( v48215(VarCurr,B)
          | v48218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48218(VarCurr,B)
      <=> ( v47943(VarCurr,B)
          & v48219(VarCurr,B) ) ) ) ).

tff(addAssignment_24235,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,0)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24234,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,1)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24233,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,2)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24232,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,3)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24231,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,4)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24230,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,5)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24229,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,6)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24228,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,7)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24227,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,8)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24226,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,9)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24225,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,10)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24224,axiom,
    ! [VarCurr: state_type] :
      ( v48219(VarCurr,11)
    <=> v48220(VarCurr) ) ).

tff(addAssignment_24223,axiom,
    ! [VarCurr: state_type] :
      ( v48220(VarCurr)
    <=> v48211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48215(VarCurr,B)
      <=> ( v47935(VarCurr,B)
          & v48216(VarCurr,B) ) ) ) ).

tff(addAssignment_24222,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,0)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24221,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,1)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24220,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,2)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24219,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,3)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24218,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,4)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24217,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,5)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24216,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,6)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24215,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,7)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24214,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,8)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24213,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,9)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24212,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,10)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24211,axiom,
    ! [VarCurr: state_type] :
      ( v48216(VarCurr,11)
    <=> v48217(VarCurr) ) ).

tff(addAssignment_24210,axiom,
    ! [VarCurr: state_type] :
      ( v48217(VarCurr)
    <=> v47939(VarCurr) ) ).

tff(addAssignment_24209,axiom,
    ! [VarCurr: state_type] :
      ( v48211(VarCurr)
    <=> v48213(VarCurr) ) ).

tff(addAssignment_24208,axiom,
    ! [VarCurr: state_type] :
      ( v48213(VarCurr)
    <=> v7021(VarCurr,11) ) ).

tff(addAssignment_24207,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,11)
    <=> v7023(VarCurr,11) ) ).

tff(addAssignment_24206,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,11)
    <=> v6623(VarCurr,11) ) ).

tff(addAssignment_24205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47943(VarCurr,B)
      <=> v47945(VarCurr,B) ) ) ).

tff(addAssignment_24204,axiom,
    ! [VarCurr: state_type] :
      ( ( v47945(VarCurr,11)
      <=> v6334(VarCurr,155) )
      & ( v47945(VarCurr,10)
      <=> v6334(VarCurr,154) )
      & ( v47945(VarCurr,9)
      <=> v6334(VarCurr,153) )
      & ( v47945(VarCurr,8)
      <=> v6334(VarCurr,152) )
      & ( v47945(VarCurr,7)
      <=> v6334(VarCurr,151) )
      & ( v47945(VarCurr,6)
      <=> v6334(VarCurr,150) )
      & ( v47945(VarCurr,5)
      <=> v6334(VarCurr,149) )
      & ( v47945(VarCurr,4)
      <=> v6334(VarCurr,148) )
      & ( v47945(VarCurr,3)
      <=> v6334(VarCurr,147) )
      & ( v47945(VarCurr,2)
      <=> v6334(VarCurr,146) )
      & ( v47945(VarCurr,1)
      <=> v6334(VarCurr,145) )
      & ( v47945(VarCurr,0)
      <=> v6334(VarCurr,144) ) ) ).

tff(addAssignment_24203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,156)
        & ~ $less(B,144) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_24202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,156)
        & ~ $less(B,144) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_24201,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,155)
      <=> v47947(VarCurr,11) )
      & ( v6338(VarCurr,154)
      <=> v47947(VarCurr,10) )
      & ( v6338(VarCurr,153)
      <=> v47947(VarCurr,9) )
      & ( v6338(VarCurr,152)
      <=> v47947(VarCurr,8) )
      & ( v6338(VarCurr,151)
      <=> v47947(VarCurr,7) )
      & ( v6338(VarCurr,150)
      <=> v47947(VarCurr,6) )
      & ( v6338(VarCurr,149)
      <=> v47947(VarCurr,5) )
      & ( v6338(VarCurr,148)
      <=> v47947(VarCurr,4) )
      & ( v6338(VarCurr,147)
      <=> v47947(VarCurr,3) )
      & ( v6338(VarCurr,146)
      <=> v47947(VarCurr,2) )
      & ( v6338(VarCurr,145)
      <=> v47947(VarCurr,1) )
      & ( v6338(VarCurr,144)
      <=> v47947(VarCurr,0) ) ) ).

tff(addAssignment_24200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47947(VarCurr,B)
      <=> v47949(VarCurr,B) ) ) ).

tff(addAssignment_24199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47949(VarCurr,B)
      <=> v47951(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48194(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47951(VarNext,B)
            <=> v47951(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_559,axiom,
    ! [VarNext: state_type] :
      ( v48194(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47951(VarNext,B)
          <=> v48204(VarNext,B) ) ) ) ).

tff(addAssignment_24198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48204(VarNext,B)
          <=> v48202(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48205(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48202(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_369,axiom,
    ! [VarCurr: state_type] :
      ( v48205(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v48202(VarCurr,B)
          <=> v47981(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4483,axiom,
    ! [VarCurr: state_type] :
      ( v48205(VarCurr)
    <=> ( v48206(VarCurr)
        & v48207(VarCurr) ) ) ).

tff(writeUnaryOperator_2749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48207(VarCurr)
    <=> v47967(VarCurr) ) ).

tff(writeUnaryOperator_2748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48206(VarCurr)
    <=> v47953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48194(VarNext)
      <=> v48195(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48195(VarNext)
      <=> ( v48196(VarNext)
          & v48169(VarNext) ) ) ) ).

tff(writeUnaryOperator_2747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v48196(VarNext)
      <=> v48198(VarNext) ) ) ).

tff(addAssignment_24197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v48198(VarNext)
      <=> v48169(VarCurr) ) ) ).

tff(addAssignment_24196,axiom,
    ! [VarCurr: state_type] :
      ( v48169(VarCurr)
    <=> v48171(VarCurr) ) ).

tff(addAssignment_24195,axiom,
    ! [VarCurr: state_type] :
      ( v48171(VarCurr)
    <=> v48173(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4480,axiom,
    ! [VarCurr: state_type] :
      ( v48173(VarCurr)
    <=> ( v48191(VarCurr)
        | v48183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4479,axiom,
    ! [VarCurr: state_type] :
      ( v48191(VarCurr)
    <=> ( v48175(VarCurr)
        & v48181(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_206,axiom,
    ( v48181(constB0)
  <=> $true ) ).

tff(addAssignment_24194,axiom,
    ! [VarCurr: state_type] :
      ( v48183(VarCurr)
    <=> v48185(VarCurr) ) ).

tff(addAssignment_24193,axiom,
    ! [VarCurr: state_type] :
      ( v48185(VarCurr)
    <=> v48187(VarCurr) ) ).

tff(addAssignment_24192,axiom,
    ! [VarCurr: state_type] :
      ( v48187(VarCurr)
    <=> v48189(VarCurr) ) ).

tff(addAssignment_24191,axiom,
    ! [VarCurr: state_type] :
      ( v48189(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_24190,axiom,
    ! [VarCurr: state_type] :
      ( v48175(VarCurr)
    <=> v48177(VarCurr) ) ).

tff(addAssignment_24189,axiom,
    ! [VarCurr: state_type] :
      ( v48177(VarCurr)
    <=> v48179(VarCurr) ) ).

tff(addAssignment_24188,axiom,
    ! [VarCurr: state_type] :
      ( v48179(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_24187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47981(VarCurr,B)
      <=> v47983(VarCurr,B) ) ) ).

tff(addAssignment_24186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47983(VarCurr,B)
      <=> v47985(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47985(VarCurr,B)
      <=> ( v48154(VarCurr,B)
          | v48165(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48165(VarCurr,B)
      <=> ( v48118(VarCurr,B)
          & v48166(VarCurr,B) ) ) ) ).

tff(addAssignment_24185,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,0)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24184,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,1)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24183,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,2)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24182,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,3)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24181,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,4)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24180,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,5)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24179,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,6)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24178,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,7)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24177,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,8)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24176,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,9)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24175,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,10)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24174,axiom,
    ! [VarCurr: state_type] :
      ( v48166(VarCurr,11)
    <=> v48167(VarCurr) ) ).

tff(addAssignment_24173,axiom,
    ! [VarCurr: state_type] :
      ( v48167(VarCurr)
    <=> v48128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48154(VarCurr,B)
      <=> ( v48155(VarCurr,B)
          | v48162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48162(VarCurr,B)
      <=> ( v48082(VarCurr,B)
          & v48163(VarCurr,B) ) ) ) ).

tff(addAssignment_24172,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,0)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24171,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,1)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24170,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,2)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24169,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,3)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24168,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,4)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24167,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,5)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24166,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,6)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24165,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,7)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24164,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,8)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24163,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,9)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24162,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,10)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24161,axiom,
    ! [VarCurr: state_type] :
      ( v48163(VarCurr,11)
    <=> v48164(VarCurr) ) ).

tff(addAssignment_24160,axiom,
    ! [VarCurr: state_type] :
      ( v48164(VarCurr)
    <=> v48092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48155(VarCurr,B)
      <=> ( v48156(VarCurr,B)
          | v48159(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48159(VarCurr,B)
      <=> ( v48035(VarCurr,B)
          & v48160(VarCurr,B) ) ) ) ).

tff(addAssignment_24159,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,0)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24158,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,1)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24157,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,2)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24156,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,3)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24155,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,4)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24154,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,5)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24153,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,6)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24152,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,7)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24151,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,8)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24150,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,9)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24149,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,10)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24148,axiom,
    ! [VarCurr: state_type] :
      ( v48160(VarCurr,11)
    <=> v48161(VarCurr) ) ).

tff(addAssignment_24147,axiom,
    ! [VarCurr: state_type] :
      ( v48161(VarCurr)
    <=> v48045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48156(VarCurr,B)
      <=> ( v47987(VarCurr,B)
          & v48157(VarCurr,B) ) ) ) ).

tff(addAssignment_24146,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,0)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24145,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,1)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24144,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,2)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24143,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,3)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24142,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,4)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24141,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,5)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24140,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,6)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24139,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,7)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24138,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,8)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24137,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,9)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24136,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,10)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24135,axiom,
    ! [VarCurr: state_type] :
      ( v48157(VarCurr,11)
    <=> v48158(VarCurr) ) ).

tff(addAssignment_24134,axiom,
    ! [VarCurr: state_type] :
      ( v48158(VarCurr)
    <=> v47997(VarCurr) ) ).

tff(addAssignment_24133,axiom,
    ! [VarCurr: state_type] :
      ( v48128(VarCurr)
    <=> v48130(VarCurr) ) ).

tff(addAssignment_24132,axiom,
    ! [VarCurr: state_type] :
      ( v48130(VarCurr)
    <=> v48132(VarCurr) ) ).

tff(addAssignment_24131,axiom,
    ! [VarCurr: state_type] :
      ( v48132(VarCurr)
    <=> v48134(VarCurr) ) ).

tff(addAssignment_24130,axiom,
    ! [VarCurr: state_type] :
      ( v48134(VarCurr)
    <=> v48136(VarCurr) ) ).

tff(addAssignment_24129,axiom,
    ! [VarCurr: state_type] :
      ( v48136(VarCurr)
    <=> v48138(VarCurr) ) ).

tff(addAssignment_24128,axiom,
    ! [VarCurr: state_type] :
      ( v48138(VarCurr)
    <=> v48140(VarCurr) ) ).

tff(addAssignment_24127,axiom,
    ! [VarCurr: state_type] :
      ( v48140(VarCurr)
    <=> v48142(VarCurr) ) ).

tff(writeUnaryOperator_2746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48142(VarCurr)
    <=> v48152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4478,axiom,
    ! [VarCurr: state_type] :
      ( v48152(VarCurr)
    <=> ( v48144(VarCurr)
        | v48148(VarCurr) ) ) ).

tff(addAssignment_24126,axiom,
    ! [VarCurr: state_type] :
      ( v48148(VarCurr)
    <=> v48150(VarCurr) ) ).

tff(addAssignment_24125,axiom,
    ! [VarCurr: state_type] :
      ( v48150(VarCurr)
    <=> v48065(VarCurr,1) ) ).

tff(addAssignment_24124,axiom,
    ! [VarCurr: state_type] :
      ( v48144(VarCurr)
    <=> v48146(VarCurr) ) ).

tff(addAssignment_24123,axiom,
    ! [VarCurr: state_type] :
      ( v48146(VarCurr)
    <=> v48065(VarCurr,0) ) ).

tff(addAssignment_24122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48118(VarCurr,B)
      <=> v48120(VarCurr,B) ) ) ).

tff(addAssignment_24121,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48120(VarCurr,B)
      <=> v48122(VarCurr,B) ) ) ).

tff(addAssignment_24120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48122(VarCurr,B)
      <=> v48124(VarCurr,B) ) ) ).

tff(addAssignment_24119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48124(VarCurr,B)
      <=> v48126(VarCurr,B) ) ) ).

tff(addAssignment_24118,axiom,
    ! [VarCurr: state_type] :
      ( v48092(VarCurr)
    <=> v48094(VarCurr) ) ).

tff(addAssignment_24117,axiom,
    ! [VarCurr: state_type] :
      ( v48094(VarCurr)
    <=> v48096(VarCurr) ) ).

tff(addAssignment_24116,axiom,
    ! [VarCurr: state_type] :
      ( v48096(VarCurr)
    <=> v48098(VarCurr) ) ).

tff(addAssignment_24115,axiom,
    ! [VarCurr: state_type] :
      ( v48098(VarCurr)
    <=> v48100(VarCurr) ) ).

tff(addAssignment_24114,axiom,
    ! [VarCurr: state_type] :
      ( v48100(VarCurr)
    <=> v48102(VarCurr) ) ).

tff(addAssignment_24113,axiom,
    ! [VarCurr: state_type] :
      ( v48102(VarCurr)
    <=> v48104(VarCurr) ) ).

tff(addAssignment_24112,axiom,
    ! [VarCurr: state_type] :
      ( v48104(VarCurr)
    <=> v48106(VarCurr) ) ).

tff(writeUnaryOperator_2745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48106(VarCurr)
    <=> v48116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4477,axiom,
    ! [VarCurr: state_type] :
      ( v48116(VarCurr)
    <=> ( v48108(VarCurr)
        | v48112(VarCurr) ) ) ).

tff(addAssignment_24111,axiom,
    ! [VarCurr: state_type] :
      ( v48112(VarCurr)
    <=> v48114(VarCurr) ) ).

tff(addAssignment_24110,axiom,
    ! [VarCurr: state_type] :
      ( v48114(VarCurr)
    <=> v48065(VarCurr,1) ) ).

tff(addAssignment_24109,axiom,
    ! [VarCurr: state_type] :
      ( v48065(VarCurr,1)
    <=> v48067(VarCurr,1) ) ).

tff(addAssignment_24108,axiom,
    ! [VarCurr: state_type] :
      ( v48067(VarCurr,1)
    <=> v48069(VarCurr,1) ) ).

tff(addAssignment_24107,axiom,
    ! [VarCurr: state_type] :
      ( v48069(VarCurr,1)
    <=> v48074(VarCurr,1) ) ).

tff(addAssignment_24106,axiom,
    ! [VarCurr: state_type] :
      ( v48071(VarCurr,1)
    <=> v48073(VarCurr,1) ) ).

tff(addAssignment_24105,axiom,
    ! [VarCurr: state_type] :
      ( v48073(VarCurr,1)
    <=> v48017(VarCurr,1) ) ).

tff(addAssignment_24104,axiom,
    ! [VarCurr: state_type] :
      ( v48108(VarCurr)
    <=> v48110(VarCurr) ) ).

tff(addAssignment_24103,axiom,
    ! [VarCurr: state_type] :
      ( v48110(VarCurr)
    <=> v48017(VarCurr,0) ) ).

tff(addAssignment_24102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48082(VarCurr,B)
      <=> v48084(VarCurr,B) ) ) ).

tff(addAssignment_24101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48084(VarCurr,B)
      <=> v48086(VarCurr,B) ) ) ).

tff(addAssignment_24100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48086(VarCurr,B)
      <=> v48088(VarCurr,B) ) ) ).

tff(addAssignment_24099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48088(VarCurr,B)
      <=> v48090(VarCurr,B) ) ) ).

tff(addAssignment_24098,axiom,
    ! [VarCurr: state_type] :
      ( v48045(VarCurr)
    <=> v48047(VarCurr) ) ).

tff(addAssignment_24097,axiom,
    ! [VarCurr: state_type] :
      ( v48047(VarCurr)
    <=> v48049(VarCurr) ) ).

tff(addAssignment_24096,axiom,
    ! [VarCurr: state_type] :
      ( v48049(VarCurr)
    <=> v48051(VarCurr) ) ).

tff(addAssignment_24095,axiom,
    ! [VarCurr: state_type] :
      ( v48051(VarCurr)
    <=> v48053(VarCurr) ) ).

tff(addAssignment_24094,axiom,
    ! [VarCurr: state_type] :
      ( v48053(VarCurr)
    <=> v48055(VarCurr) ) ).

tff(addAssignment_24093,axiom,
    ! [VarCurr: state_type] :
      ( v48055(VarCurr)
    <=> v48057(VarCurr) ) ).

tff(addAssignment_24092,axiom,
    ! [VarCurr: state_type] :
      ( v48057(VarCurr)
    <=> v48059(VarCurr) ) ).

tff(writeUnaryOperator_2744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48059(VarCurr)
    <=> v48080(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4476,axiom,
    ! [VarCurr: state_type] :
      ( v48080(VarCurr)
    <=> ( v48061(VarCurr)
        | v48076(VarCurr) ) ) ).

tff(addAssignment_24091,axiom,
    ! [VarCurr: state_type] :
      ( v48076(VarCurr)
    <=> v48078(VarCurr) ) ).

tff(addAssignment_24090,axiom,
    ! [VarCurr: state_type] :
      ( v48078(VarCurr)
    <=> v48017(VarCurr,1) ) ).

tff(addAssignment_24089,axiom,
    ! [VarCurr: state_type] :
      ( v48061(VarCurr)
    <=> v48063(VarCurr) ) ).

tff(addAssignment_24088,axiom,
    ! [VarCurr: state_type] :
      ( v48063(VarCurr)
    <=> v48065(VarCurr,0) ) ).

tff(addAssignment_24087,axiom,
    ! [VarCurr: state_type] :
      ( v48065(VarCurr,0)
    <=> v48067(VarCurr,0) ) ).

tff(addAssignment_24086,axiom,
    ! [VarCurr: state_type] :
      ( v48067(VarCurr,0)
    <=> v48069(VarCurr,0) ) ).

tff(addAssignment_24085,axiom,
    ! [VarCurr: state_type] :
      ( v48069(VarCurr,0)
    <=> v48074(VarCurr,0) ) ).

tff(writeUnaryOperator_2743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v48074(VarCurr,B)
      <=> ~ v48071(VarCurr,B) ) ) ).

tff(addAssignment_24084,axiom,
    ! [VarCurr: state_type] :
      ( v48071(VarCurr,0)
    <=> v48073(VarCurr,0) ) ).

tff(addAssignment_24083,axiom,
    ! [VarCurr: state_type] :
      ( v48073(VarCurr,0)
    <=> v48017(VarCurr,0) ) ).

tff(addAssignment_24082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48035(VarCurr,B)
      <=> v48037(VarCurr,B) ) ) ).

tff(addAssignment_24081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48037(VarCurr,B)
      <=> v48039(VarCurr,B) ) ) ).

tff(addAssignment_24080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48039(VarCurr,B)
      <=> v48041(VarCurr,B) ) ) ).

tff(addAssignment_24079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v48041(VarCurr,B)
      <=> v48043(VarCurr,B) ) ) ).

tff(addAssignment_24078,axiom,
    ! [VarCurr: state_type] :
      ( v47997(VarCurr)
    <=> v47999(VarCurr) ) ).

tff(addAssignment_24077,axiom,
    ! [VarCurr: state_type] :
      ( v47999(VarCurr)
    <=> v48001(VarCurr) ) ).

tff(addAssignment_24076,axiom,
    ! [VarCurr: state_type] :
      ( v48001(VarCurr)
    <=> v48003(VarCurr) ) ).

tff(addAssignment_24075,axiom,
    ! [VarCurr: state_type] :
      ( v48003(VarCurr)
    <=> v48005(VarCurr) ) ).

tff(addAssignment_24074,axiom,
    ! [VarCurr: state_type] :
      ( v48005(VarCurr)
    <=> v48007(VarCurr) ) ).

tff(addAssignment_24073,axiom,
    ! [VarCurr: state_type] :
      ( v48007(VarCurr)
    <=> v48009(VarCurr) ) ).

tff(addAssignment_24072,axiom,
    ! [VarCurr: state_type] :
      ( v48009(VarCurr)
    <=> v48011(VarCurr) ) ).

tff(writeUnaryOperator_2742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v48011(VarCurr)
    <=> v48033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4475,axiom,
    ! [VarCurr: state_type] :
      ( v48033(VarCurr)
    <=> ( v48013(VarCurr)
        | v48029(VarCurr) ) ) ).

tff(addAssignment_24071,axiom,
    ! [VarCurr: state_type] :
      ( v48029(VarCurr)
    <=> v48031(VarCurr) ) ).

tff(addAssignment_24070,axiom,
    ! [VarCurr: state_type] :
      ( v48031(VarCurr)
    <=> v48017(VarCurr,1) ) ).

tff(addAssignment_24069,axiom,
    ! [VarCurr: state_type] :
      ( v48017(VarCurr,1)
    <=> v48019(VarCurr,1) ) ).

tff(addAssignment_24068,axiom,
    ! [VarCurr: state_type] :
      ( v48019(VarCurr,1)
    <=> v48021(VarCurr,1) ) ).

tff(addAssignment_24067,axiom,
    ! [VarCurr: state_type] :
      ( v48021(VarCurr,1)
    <=> v48023(VarCurr,1) ) ).

tff(addAssignment_24066,axiom,
    ! [VarCurr: state_type] :
      ( v48023(VarCurr,1)
    <=> v48025(VarCurr,1) ) ).

tff(addAssignment_24065,axiom,
    ! [VarCurr: state_type] :
      ( v48025(VarCurr,1)
    <=> v48027(VarCurr,1) ) ).

tff(addAssignment_24064,axiom,
    ! [VarCurr: state_type] :
      ( v48013(VarCurr)
    <=> v48015(VarCurr) ) ).

tff(addAssignment_24063,axiom,
    ! [VarCurr: state_type] :
      ( v48015(VarCurr)
    <=> v48017(VarCurr,0) ) ).

tff(addAssignment_24062,axiom,
    ! [VarCurr: state_type] :
      ( v48017(VarCurr,0)
    <=> v48019(VarCurr,0) ) ).

tff(addAssignment_24061,axiom,
    ! [VarCurr: state_type] :
      ( v48019(VarCurr,0)
    <=> v48021(VarCurr,0) ) ).

tff(addAssignment_24060,axiom,
    ! [VarCurr: state_type] :
      ( v48021(VarCurr,0)
    <=> v48023(VarCurr,0) ) ).

tff(addAssignment_24059,axiom,
    ! [VarCurr: state_type] :
      ( v48023(VarCurr,0)
    <=> v48025(VarCurr,0) ) ).

tff(addAssignment_24058,axiom,
    ! [VarCurr: state_type] :
      ( v48025(VarCurr,0)
    <=> v48027(VarCurr,0) ) ).

tff(addAssignment_24057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47987(VarCurr,B)
      <=> v47989(VarCurr,B) ) ) ).

tff(addAssignment_24056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47989(VarCurr,B)
      <=> v47991(VarCurr,B) ) ) ).

tff(addAssignment_24055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47991(VarCurr,B)
      <=> v47993(VarCurr,B) ) ) ).

tff(addAssignment_24054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47993(VarCurr,B)
      <=> v47995(VarCurr,B) ) ) ).

tff(addAssignment_24053,axiom,
    ! [VarCurr: state_type] :
      ( v47967(VarCurr)
    <=> v47969(VarCurr) ) ).

tff(addAssignment_24052,axiom,
    ! [VarCurr: state_type] :
      ( v47969(VarCurr)
    <=> v47971(VarCurr) ) ).

tff(addAssignment_24051,axiom,
    ! [VarCurr: state_type] :
      ( v47971(VarCurr)
    <=> v47973(VarCurr) ) ).

tff(addAssignment_24050,axiom,
    ! [VarCurr: state_type] :
      ( v47973(VarCurr)
    <=> v47975(VarCurr) ) ).

tff(addAssignment_24049,axiom,
    ! [VarCurr: state_type] :
      ( v47975(VarCurr)
    <=> v47977(VarCurr) ) ).

tff(addAssignment_24048,axiom,
    ! [VarCurr: state_type] :
      ( v47977(VarCurr)
    <=> v47979(VarCurr) ) ).

tff(addAssignment_24047,axiom,
    ! [VarCurr: state_type] :
      ( v47979(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_24046,axiom,
    ! [VarCurr: state_type] :
      ( v47953(VarCurr)
    <=> v47955(VarCurr) ) ).

tff(addAssignment_24045,axiom,
    ! [VarCurr: state_type] :
      ( v47955(VarCurr)
    <=> v47957(VarCurr) ) ).

tff(addAssignment_24044,axiom,
    ! [VarCurr: state_type] :
      ( v47957(VarCurr)
    <=> v47959(VarCurr) ) ).

tff(addAssignment_24043,axiom,
    ! [VarCurr: state_type] :
      ( v47959(VarCurr)
    <=> v47961(VarCurr) ) ).

tff(addAssignment_24042,axiom,
    ! [VarCurr: state_type] :
      ( v47961(VarCurr)
    <=> v47963(VarCurr) ) ).

tff(addAssignment_24041,axiom,
    ! [VarCurr: state_type] :
      ( v47963(VarCurr)
    <=> v47965(VarCurr) ) ).

tff(addAssignment_24040,axiom,
    ! [VarCurr: state_type] :
      ( v47965(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_24039,axiom,
    ! [VarCurr: state_type] :
      ( v47939(VarCurr)
    <=> v47941(VarCurr) ) ).

tff(addAssignment_24038,axiom,
    ! [VarCurr: state_type] :
      ( v47941(VarCurr)
    <=> v6617(VarCurr,11) ) ).

tff(addAssignment_24037,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,11)
    <=> v6619(VarCurr,11) ) ).

tff(addAssignment_24036,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,11)
    <=> v6621(VarCurr,11) ) ).

tff(addAssignment_24035,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,11)
    <=> v6747(VarCurr,11) ) ).

tff(addAssignment_24034,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,11)
    <=> v6690(VarCurr,11) ) ).

tff(addAssignment_24033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47935(VarCurr,B)
      <=> v47937(VarCurr,B) ) ) ).

tff(addAssignment_24032,axiom,
    ! [VarCurr: state_type] :
      ( ( v47937(VarCurr,11)
      <=> v6334(VarCurr,143) )
      & ( v47937(VarCurr,10)
      <=> v6334(VarCurr,142) )
      & ( v47937(VarCurr,9)
      <=> v6334(VarCurr,141) )
      & ( v47937(VarCurr,8)
      <=> v6334(VarCurr,140) )
      & ( v47937(VarCurr,7)
      <=> v6334(VarCurr,139) )
      & ( v47937(VarCurr,6)
      <=> v6334(VarCurr,138) )
      & ( v47937(VarCurr,5)
      <=> v6334(VarCurr,137) )
      & ( v47937(VarCurr,4)
      <=> v6334(VarCurr,136) )
      & ( v47937(VarCurr,3)
      <=> v6334(VarCurr,135) )
      & ( v47937(VarCurr,2)
      <=> v6334(VarCurr,134) )
      & ( v47937(VarCurr,1)
      <=> v6334(VarCurr,133) )
      & ( v47937(VarCurr,0)
      <=> v6334(VarCurr,132) ) ) ).

tff(addAssignment_24031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47903(VarCurr,B)
      <=> v47905(VarCurr,B) ) ) ).

tff(addAssignment_24030,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,0)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24029,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,1)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24028,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,2)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24027,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,3)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24026,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,4)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24025,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,5)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24024,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,6)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24023,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,7)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24022,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,8)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24021,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,9)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24020,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,10)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24019,axiom,
    ! [VarCurr: state_type] :
      ( v47905(VarCurr,11)
    <=> v47923(VarCurr) ) ).

tff(addAssignment_24018,axiom,
    ! [VarCurr: state_type] :
      ( v47923(VarCurr)
    <=> v47907(VarCurr) ) ).

tff(addAssignment_24017,axiom,
    ! [VarCurr: state_type] :
      ( v47907(VarCurr)
    <=> v47909(VarCurr,0) ) ).

tff(addAssignment_24016,axiom,
    ! [VarCurr: state_type] :
      ( v47909(VarCurr,0)
    <=> v47911(VarCurr,0) ) ).

tff(addAssignment_24015,axiom,
    ! [VarCurr: state_type] :
      ( v47911(VarCurr,0)
    <=> v47921(VarCurr,0) ) ).

tff(writeUnaryOperator_2741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v47921(VarCurr,B)
      <=> ~ v47913(VarCurr,B) ) ) ).

tff(addAssignment_24014,axiom,
    ! [VarCurr: state_type] :
      ( v47913(VarCurr,0)
    <=> v47915(VarCurr,0) ) ).

tff(addAssignment_24013,axiom,
    ! [VarCurr: state_type] :
      ( v47915(VarCurr,0)
    <=> v47918(VarCurr,0) ) ).

tff(addAssignment_24012,axiom,
    ! [VarCurr: state_type] :
      ( v47918(VarCurr,0)
    <=> v47917(VarCurr) ) ).

tff(addAssignment_24011,axiom,
    ! [VarCurr: state_type] :
      ( v47918(VarCurr,1)
    <=> v47920(VarCurr) ) ).

tff(addAssignment_24010,axiom,
    ! [VarCurr: state_type] :
      ( v47918(VarCurr,2)
    <=> v47919(VarCurr) ) ).

tff(addAssignment_24009,axiom,
    ! [VarCurr: state_type] :
      ( v47917(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_24008,axiom,
    ! [VarCurr: state_type] :
      ( v47879(VarCurr)
    <=> v47881(VarCurr) ) ).

tff(addAssignment_24007,axiom,
    ! [VarCurr: state_type] :
      ( v47881(VarCurr)
    <=> v47883(VarCurr) ) ).

tff(addAssignment_24006,axiom,
    ! [VarCurr: state_type] :
      ( v47883(VarCurr)
    <=> v47885(VarCurr) ) ).

tff(addAssignment_24005,axiom,
    ! [VarCurr: state_type] :
      ( v47885(VarCurr)
    <=> v47887(VarCurr) ) ).

tff(addAssignment_24004,axiom,
    ! [VarCurr: state_type] :
      ( v47887(VarCurr)
    <=> v47889(VarCurr) ) ).

tff(addAssignment_24003,axiom,
    ! [VarCurr: state_type] :
      ( v47889(VarCurr)
    <=> v47891(VarCurr) ) ).

tff(addAssignment_24002,axiom,
    ! [VarCurr: state_type] :
      ( v47891(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_24001,axiom,
    ! [VarCurr: state_type] :
      ( v47865(VarCurr)
    <=> v47867(VarCurr) ) ).

tff(addAssignment_24000,axiom,
    ! [VarCurr: state_type] :
      ( v47867(VarCurr)
    <=> v47869(VarCurr) ) ).

tff(addAssignment_23999,axiom,
    ! [VarCurr: state_type] :
      ( v47869(VarCurr)
    <=> v47871(VarCurr) ) ).

tff(addAssignment_23998,axiom,
    ! [VarCurr: state_type] :
      ( v47871(VarCurr)
    <=> v47873(VarCurr) ) ).

tff(addAssignment_23997,axiom,
    ! [VarCurr: state_type] :
      ( v47873(VarCurr)
    <=> v47875(VarCurr) ) ).

tff(addAssignment_23996,axiom,
    ! [VarCurr: state_type] :
      ( v47875(VarCurr)
    <=> v47877(VarCurr) ) ).

tff(addAssignment_23995,axiom,
    ! [VarCurr: state_type] :
      ( v47877(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_23994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47841(VarCurr,B)
      <=> v47843(VarCurr,B) ) ) ).

tff(addAssignment_23993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47843(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_23992,axiom,
    ! [VarCurr: state_type] :
      ( v46285(VarCurr)
    <=> v46287(VarCurr) ) ).

tff(addAssignment_23991,axiom,
    ! [VarCurr: state_type] :
      ( v46287(VarCurr)
    <=> v46289(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_213,axiom,
    ! [VarCurr: state_type] :
      ( v46289(VarCurr)
    <=> ( ( v46291(VarCurr,11)
        <=> v46295(VarCurr,11) )
        & ( v46291(VarCurr,10)
        <=> v46295(VarCurr,10) )
        & ( v46291(VarCurr,9)
        <=> v46295(VarCurr,9) )
        & ( v46291(VarCurr,8)
        <=> v46295(VarCurr,8) )
        & ( v46291(VarCurr,7)
        <=> v46295(VarCurr,7) )
        & ( v46291(VarCurr,6)
        <=> v46295(VarCurr,6) )
        & ( v46291(VarCurr,5)
        <=> v46295(VarCurr,5) )
        & ( v46291(VarCurr,4)
        <=> v46295(VarCurr,4) )
        & ( v46291(VarCurr,3)
        <=> v46295(VarCurr,3) )
        & ( v46291(VarCurr,2)
        <=> v46295(VarCurr,2) )
        & ( v46291(VarCurr,1)
        <=> v46295(VarCurr,1) )
        & ( v46291(VarCurr,0)
        <=> v46295(VarCurr,0) ) ) ) ).

tff(addAssignment_23990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46295(VarCurr,B)
      <=> v46297(VarCurr,B) ) ) ).

tff(addAssignment_23989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46297(VarCurr,B)
      <=> v46299(VarCurr,B) ) ) ).

tff(addAssignment_23988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46299(VarCurr,B)
      <=> v46301(VarCurr,B) ) ) ).

tff(addAssignment_23987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46301(VarCurr,B)
      <=> v46303(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46303(VarCurr,B)
      <=> ( v47811(VarCurr,B)
          | v47830(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47830(VarCurr,B)
      <=> ( v47682(VarCurr,B)
          & v47831(VarCurr,B) ) ) ) ).

tff(addAssignment_23986,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,0)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23985,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,1)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23984,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,2)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23983,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,3)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23982,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,4)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23981,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,5)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23980,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,6)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23979,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,7)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23978,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,8)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23977,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,9)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23976,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,10)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23975,axiom,
    ! [VarCurr: state_type] :
      ( v47831(VarCurr,11)
    <=> v47832(VarCurr) ) ).

tff(addAssignment_23974,axiom,
    ! [VarCurr: state_type] :
      ( v47832(VarCurr)
    <=> v47801(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47811(VarCurr,B)
      <=> ( v47812(VarCurr,B)
          | v47827(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47827(VarCurr,B)
      <=> ( v47531(VarCurr,B)
          & v47828(VarCurr,B) ) ) ) ).

tff(addAssignment_23973,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,0)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23972,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,1)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23971,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,2)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23970,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,3)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23969,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,4)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23968,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,5)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23967,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,6)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23966,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,7)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23965,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,8)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23964,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,9)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23963,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,10)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23962,axiom,
    ! [VarCurr: state_type] :
      ( v47828(VarCurr,11)
    <=> v47829(VarCurr) ) ).

tff(addAssignment_23961,axiom,
    ! [VarCurr: state_type] :
      ( v47829(VarCurr)
    <=> v47651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_762,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47812(VarCurr,B)
      <=> ( v47813(VarCurr,B)
          | v47824(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47824(VarCurr,B)
      <=> ( v47380(VarCurr,B)
          & v47825(VarCurr,B) ) ) ) ).

tff(addAssignment_23960,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,0)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23959,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,1)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23958,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,2)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23957,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,3)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23956,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,4)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23955,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,5)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23954,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,6)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23953,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,7)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23952,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,8)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23951,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,9)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23950,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,10)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23949,axiom,
    ! [VarCurr: state_type] :
      ( v47825(VarCurr,11)
    <=> v47826(VarCurr) ) ).

tff(addAssignment_23948,axiom,
    ! [VarCurr: state_type] :
      ( v47826(VarCurr)
    <=> v47500(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47813(VarCurr,B)
      <=> ( v47814(VarCurr,B)
          | v47821(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47821(VarCurr,B)
      <=> ( v47229(VarCurr,B)
          & v47822(VarCurr,B) ) ) ) ).

tff(addAssignment_23947,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,0)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23946,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,1)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23945,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,2)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23944,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,3)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23943,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,4)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23942,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,5)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23941,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,6)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23940,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,7)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23939,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,8)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23938,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,9)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23937,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,10)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23936,axiom,
    ! [VarCurr: state_type] :
      ( v47822(VarCurr,11)
    <=> v47823(VarCurr) ) ).

tff(addAssignment_23935,axiom,
    ! [VarCurr: state_type] :
      ( v47823(VarCurr)
    <=> v47349(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47814(VarCurr,B)
      <=> ( v47815(VarCurr,B)
          | v47818(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47818(VarCurr,B)
      <=> ( v47067(VarCurr,B)
          & v47819(VarCurr,B) ) ) ) ).

tff(addAssignment_23934,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,0)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23933,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,1)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23932,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,2)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23931,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,3)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23930,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,4)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23929,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,5)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23928,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,6)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23927,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,7)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23926,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,8)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23925,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,9)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23924,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,10)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23923,axiom,
    ! [VarCurr: state_type] :
      ( v47819(VarCurr,11)
    <=> v47820(VarCurr) ) ).

tff(addAssignment_23922,axiom,
    ! [VarCurr: state_type] :
      ( v47820(VarCurr)
    <=> v47198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47815(VarCurr,B)
      <=> ( v46305(VarCurr,B)
          & v47816(VarCurr,B) ) ) ) ).

tff(addAssignment_23921,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,0)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23920,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,1)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23919,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,2)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23918,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,3)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23917,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,4)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23916,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,5)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23915,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,6)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23914,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,7)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23913,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,8)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23912,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,9)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23911,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,10)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23910,axiom,
    ! [VarCurr: state_type] :
      ( v47816(VarCurr,11)
    <=> v47817(VarCurr) ) ).

tff(addAssignment_23909,axiom,
    ! [VarCurr: state_type] :
      ( v47817(VarCurr)
    <=> v46775(VarCurr) ) ).

tff(addAssignment_23908,axiom,
    ! [VarCurr: state_type] :
      ( v47801(VarCurr)
    <=> v47803(VarCurr) ) ).

tff(addAssignment_23907,axiom,
    ! [VarCurr: state_type] :
      ( v47803(VarCurr)
    <=> v47805(VarCurr) ) ).

tff(addAssignment_23906,axiom,
    ! [VarCurr: state_type] :
      ( v47805(VarCurr)
    <=> v47807(VarCurr) ) ).

tff(addAssignment_23905,axiom,
    ! [VarCurr: state_type] :
      ( v47807(VarCurr)
    <=> v47809(VarCurr) ) ).

tff(addAssignment_23904,axiom,
    ! [VarCurr: state_type] :
      ( v47809(VarCurr)
    <=> v46868(VarCurr) ) ).

tff(addAssignment_23903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47682(VarCurr,B)
      <=> v47684(VarCurr,B) ) ) ).

tff(addAssignment_23902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47684(VarCurr,B)
      <=> v47686(VarCurr,B) ) ) ).

tff(addAssignment_23901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47686(VarCurr,B)
      <=> v47688(VarCurr,B) ) ) ).

tff(addAssignment_23900,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47688(VarCurr,B)
      <=> v47690(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47784(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47690(VarNext,B)
            <=> v47690(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_558,axiom,
    ! [VarNext: state_type] :
      ( v47784(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47690(VarNext,B)
          <=> v47794(VarNext,B) ) ) ) ).

tff(addAssignment_23899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47794(VarNext,B)
          <=> v47792(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47792(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_368,axiom,
    ! [VarCurr: state_type] :
      ( v47795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47792(VarCurr,B)
          <=> v47712(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4474,axiom,
    ! [VarCurr: state_type] :
      ( v47795(VarCurr)
    <=> ( v47796(VarCurr)
        & v47797(VarCurr) ) ) ).

tff(writeUnaryOperator_2740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47797(VarCurr)
    <=> v47702(VarCurr) ) ).

tff(writeUnaryOperator_2739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47796(VarCurr)
    <=> v47692(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47784(VarNext)
      <=> v47785(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47785(VarNext)
      <=> ( v47786(VarNext)
          & v47716(VarNext) ) ) ) ).

tff(writeUnaryOperator_2738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47786(VarNext)
      <=> v47788(VarNext) ) ) ).

tff(addAssignment_23898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47788(VarNext)
      <=> v47716(VarCurr) ) ) ).

tff(addAssignment_23897,axiom,
    ! [VarCurr: state_type] :
      ( v47716(VarCurr)
    <=> v47718(VarCurr) ) ).

tff(addAssignment_23896,axiom,
    ! [VarCurr: state_type] :
      ( v47718(VarCurr)
    <=> v47720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4471,axiom,
    ! [VarCurr: state_type] :
      ( v47720(VarCurr)
    <=> ( v47781(VarCurr)
        | v47777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4470,axiom,
    ! [VarCurr: state_type] :
      ( v47781(VarCurr)
    <=> ( v47722(VarCurr)
        & v47726(VarCurr) ) ) ).

tff(addAssignment_23895,axiom,
    ! [VarCurr: state_type] :
      ( v47777(VarCurr)
    <=> v47779(VarCurr) ) ).

tff(addAssignment_23894,axiom,
    ! [VarCurr: state_type] :
      ( v47779(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47761(VarNext)
       => ( v47726(VarNext)
        <=> v47726(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_557,axiom,
    ! [VarNext: state_type] :
      ( v47761(VarNext)
     => ( v47726(VarNext)
      <=> v47771(VarNext) ) ) ).

tff(addAssignment_23893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47771(VarNext)
      <=> v47769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4469,axiom,
    ! [VarCurr: state_type] :
      ( v47769(VarCurr)
    <=> ( v47772(VarCurr)
        & v47773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4468,axiom,
    ! [VarCurr: state_type] :
      ( v47773(VarCurr)
    <=> ( v47732(VarCurr)
        | v47756(VarCurr) ) ) ).

tff(writeUnaryOperator_2737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47772(VarCurr)
    <=> v47728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47761(VarNext)
      <=> v47762(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47762(VarNext)
      <=> ( v47764(VarNext)
          & v47766(VarNext) ) ) ) ).

tff(writeUnaryOperator_2736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47766(VarCurr)
    <=> v47722(VarCurr) ) ).

tff(addAssignment_23892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47764(VarNext)
      <=> v47722(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_205,axiom,
    ( v47726(constB0)
  <=> $true ) ).

tff(addAssignment_23891,axiom,
    ! [VarCurr: state_type] :
      ( v47756(VarCurr)
    <=> v47758(VarCurr) ) ).

tff(addAssignment_23890,axiom,
    ! [VarCurr: state_type] :
      ( v47758(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23889,axiom,
    ! [VarCurr: state_type] :
      ( v47732(VarCurr)
    <=> v47734(VarCurr) ) ).

tff(addAssignment_23888,axiom,
    ! [VarCurr: state_type] :
      ( v47734(VarCurr)
    <=> v47042(VarCurr) ) ).

tff(addAssignment_23887,axiom,
    ! [VarCurr: state_type] :
      ( v47042(VarCurr)
    <=> v47737(VarCurr) ) ).

tff(addAssignment_23886,axiom,
    ! [VarCurr: state_type] :
      ( v47737(VarCurr)
    <=> v47739(VarCurr) ) ).

tff(writeUnaryOperator_2735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47739(VarCurr)
    <=> v47753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4465,axiom,
    ! [VarCurr: state_type] :
      ( v47753(VarCurr)
    <=> ( v47754(VarCurr)
        | v47749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4464,axiom,
    ! [VarCurr: state_type] :
      ( v47754(VarCurr)
    <=> ( v47741(VarCurr)
        | v47745(VarCurr) ) ) ).

tff(addAssignment_23885,axiom,
    ! [VarCurr: state_type] :
      ( v47749(VarCurr)
    <=> v47751(VarCurr) ) ).

tff(addAssignment_23884,axiom,
    ! [VarCurr: state_type] :
      ( v47751(VarCurr)
    <=> v47131(VarCurr,2) ) ).

tff(addAssignment_23883,axiom,
    ! [VarCurr: state_type] :
      ( v47745(VarCurr)
    <=> v47747(VarCurr) ) ).

tff(addAssignment_23882,axiom,
    ! [VarCurr: state_type] :
      ( v47747(VarCurr)
    <=> v46705(VarCurr,1) ) ).

tff(addAssignment_23881,axiom,
    ! [VarCurr: state_type] :
      ( v47741(VarCurr)
    <=> v47743(VarCurr) ) ).

tff(addAssignment_23880,axiom,
    ! [VarCurr: state_type] :
      ( v47743(VarCurr)
    <=> v47131(VarCurr,0) ) ).

tff(addAssignment_23879,axiom,
    ! [VarCurr: state_type] :
      ( v47728(VarCurr)
    <=> v47730(VarCurr) ) ).

tff(addAssignment_23878,axiom,
    ! [VarCurr: state_type] :
      ( v47730(VarCurr)
    <=> $false ) ).

tff(addAssignment_23877,axiom,
    ! [VarCurr: state_type] :
      ( v47722(VarCurr)
    <=> v47724(VarCurr) ) ).

tff(addAssignment_23876,axiom,
    ! [VarCurr: state_type] :
      ( v47724(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23875,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47712(VarCurr,B)
      <=> v47714(VarCurr,B) ) ) ).

tff(addAssignment_23874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47714(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23873,axiom,
    ! [VarCurr: state_type] :
      ( v47702(VarCurr)
    <=> v47704(VarCurr) ) ).

tff(addAssignment_23872,axiom,
    ! [VarCurr: state_type] :
      ( v47704(VarCurr)
    <=> v47706(VarCurr) ) ).

tff(addAssignment_23871,axiom,
    ! [VarCurr: state_type] :
      ( v47706(VarCurr)
    <=> v47708(VarCurr) ) ).

tff(addAssignment_23870,axiom,
    ! [VarCurr: state_type] :
      ( v47708(VarCurr)
    <=> v47710(VarCurr) ) ).

tff(addAssignment_23869,axiom,
    ! [VarCurr: state_type] :
      ( v47710(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23868,axiom,
    ! [VarCurr: state_type] :
      ( v47692(VarCurr)
    <=> v47694(VarCurr) ) ).

tff(addAssignment_23867,axiom,
    ! [VarCurr: state_type] :
      ( v47694(VarCurr)
    <=> v47696(VarCurr) ) ).

tff(addAssignment_23866,axiom,
    ! [VarCurr: state_type] :
      ( v47696(VarCurr)
    <=> v47698(VarCurr) ) ).

tff(addAssignment_23865,axiom,
    ! [VarCurr: state_type] :
      ( v47698(VarCurr)
    <=> v47700(VarCurr) ) ).

tff(addAssignment_23864,axiom,
    ! [VarCurr: state_type] :
      ( v47700(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23863,axiom,
    ! [VarCurr: state_type] :
      ( v47651(VarCurr)
    <=> v47653(VarCurr) ) ).

tff(addAssignment_23862,axiom,
    ! [VarCurr: state_type] :
      ( v47653(VarCurr)
    <=> v47655(VarCurr) ) ).

tff(addAssignment_23861,axiom,
    ! [VarCurr: state_type] :
      ( v47655(VarCurr)
    <=> v47657(VarCurr) ) ).

tff(addAssignment_23860,axiom,
    ! [VarCurr: state_type] :
      ( v47657(VarCurr)
    <=> v47659(VarCurr) ) ).

tff(addAssignment_23859,axiom,
    ! [VarCurr: state_type] :
      ( v47659(VarCurr)
    <=> v47661(VarCurr) ) ).

tff(addAssignment_23858,axiom,
    ! [VarCurr: state_type] :
      ( v47661(VarCurr)
    <=> v47663(VarCurr) ) ).

tff(addAssignment_23857,axiom,
    ! [VarCurr: state_type] :
      ( v47663(VarCurr)
    <=> v47665(VarCurr) ) ).

tff(writeUnaryOperator_2734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47665(VarCurr)
    <=> v47679(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4463,axiom,
    ! [VarCurr: state_type] :
      ( v47679(VarCurr)
    <=> ( v47680(VarCurr)
        | v47675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4462,axiom,
    ! [VarCurr: state_type] :
      ( v47680(VarCurr)
    <=> ( v47667(VarCurr)
        | v47671(VarCurr) ) ) ).

tff(addAssignment_23856,axiom,
    ! [VarCurr: state_type] :
      ( v47675(VarCurr)
    <=> v47677(VarCurr) ) ).

tff(addAssignment_23855,axiom,
    ! [VarCurr: state_type] :
      ( v47677(VarCurr)
    <=> v46878(VarCurr,2) ) ).

tff(addAssignment_23854,axiom,
    ! [VarCurr: state_type] :
      ( v47671(VarCurr)
    <=> v47673(VarCurr) ) ).

tff(addAssignment_23853,axiom,
    ! [VarCurr: state_type] :
      ( v47673(VarCurr)
    <=> v46795(VarCurr,1) ) ).

tff(addAssignment_23852,axiom,
    ! [VarCurr: state_type] :
      ( v47667(VarCurr)
    <=> v47669(VarCurr) ) ).

tff(addAssignment_23851,axiom,
    ! [VarCurr: state_type] :
      ( v47669(VarCurr)
    <=> v46795(VarCurr,0) ) ).

tff(addAssignment_23850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47531(VarCurr,B)
      <=> v47533(VarCurr,B) ) ) ).

tff(addAssignment_23849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47533(VarCurr,B)
      <=> v47535(VarCurr,B) ) ) ).

tff(addAssignment_23848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47535(VarCurr,B)
      <=> v47537(VarCurr,B) ) ) ).

tff(addAssignment_23847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47537(VarCurr,B)
      <=> v47539(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47634(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47539(VarNext,B)
            <=> v47539(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_556,axiom,
    ! [VarNext: state_type] :
      ( v47634(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47539(VarNext,B)
          <=> v47644(VarNext,B) ) ) ) ).

tff(addAssignment_23846,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47644(VarNext,B)
          <=> v47642(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47642(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_367,axiom,
    ! [VarCurr: state_type] :
      ( v47645(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47642(VarCurr,B)
          <=> v47561(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4461,axiom,
    ! [VarCurr: state_type] :
      ( v47645(VarCurr)
    <=> ( v47646(VarCurr)
        & v47647(VarCurr) ) ) ).

tff(writeUnaryOperator_2733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47647(VarCurr)
    <=> v47551(VarCurr) ) ).

tff(writeUnaryOperator_2732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47646(VarCurr)
    <=> v47541(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47634(VarNext)
      <=> v47635(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47635(VarNext)
      <=> ( v47636(VarNext)
          & v47565(VarNext) ) ) ) ).

tff(writeUnaryOperator_2731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47636(VarNext)
      <=> v47638(VarNext) ) ) ).

tff(addAssignment_23845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47638(VarNext)
      <=> v47565(VarCurr) ) ) ).

tff(addAssignment_23844,axiom,
    ! [VarCurr: state_type] :
      ( v47565(VarCurr)
    <=> v47567(VarCurr) ) ).

tff(addAssignment_23843,axiom,
    ! [VarCurr: state_type] :
      ( v47567(VarCurr)
    <=> v47569(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4458,axiom,
    ! [VarCurr: state_type] :
      ( v47569(VarCurr)
    <=> ( v47631(VarCurr)
        | v47627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4457,axiom,
    ! [VarCurr: state_type] :
      ( v47631(VarCurr)
    <=> ( v47571(VarCurr)
        & v47575(VarCurr) ) ) ).

tff(addAssignment_23842,axiom,
    ! [VarCurr: state_type] :
      ( v47627(VarCurr)
    <=> v47629(VarCurr) ) ).

tff(addAssignment_23841,axiom,
    ! [VarCurr: state_type] :
      ( v47629(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_555,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47611(VarNext)
       => ( v47575(VarNext)
        <=> v47575(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_555,axiom,
    ! [VarNext: state_type] :
      ( v47611(VarNext)
     => ( v47575(VarNext)
      <=> v47621(VarNext) ) ) ).

tff(addAssignment_23840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47621(VarNext)
      <=> v47619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4456,axiom,
    ! [VarCurr: state_type] :
      ( v47619(VarCurr)
    <=> ( v47622(VarCurr)
        & v47623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4455,axiom,
    ! [VarCurr: state_type] :
      ( v47623(VarCurr)
    <=> ( v47581(VarCurr)
        | v47606(VarCurr) ) ) ).

tff(writeUnaryOperator_2730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47622(VarCurr)
    <=> v47577(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47611(VarNext)
      <=> v47612(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47612(VarNext)
      <=> ( v47614(VarNext)
          & v47616(VarNext) ) ) ) ).

tff(writeUnaryOperator_2729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47616(VarCurr)
    <=> v47571(VarCurr) ) ).

tff(addAssignment_23839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47614(VarNext)
      <=> v47571(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_204,axiom,
    ( v47575(constB0)
  <=> $true ) ).

tff(addAssignment_23838,axiom,
    ! [VarCurr: state_type] :
      ( v47606(VarCurr)
    <=> v47608(VarCurr) ) ).

tff(addAssignment_23837,axiom,
    ! [VarCurr: state_type] :
      ( v47608(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23836,axiom,
    ! [VarCurr: state_type] :
      ( v47581(VarCurr)
    <=> v47583(VarCurr) ) ).

tff(addAssignment_23835,axiom,
    ! [VarCurr: state_type] :
      ( v47583(VarCurr)
    <=> v47585(VarCurr) ) ).

tff(addAssignment_23834,axiom,
    ! [VarCurr: state_type] :
      ( v47585(VarCurr)
    <=> v47587(VarCurr) ) ).

tff(addAssignment_23833,axiom,
    ! [VarCurr: state_type] :
      ( v47587(VarCurr)
    <=> v47589(VarCurr) ) ).

tff(writeUnaryOperator_2728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47589(VarCurr)
    <=> v47603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4452,axiom,
    ! [VarCurr: state_type] :
      ( v47603(VarCurr)
    <=> ( v47604(VarCurr)
        | v47599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4451,axiom,
    ! [VarCurr: state_type] :
      ( v47604(VarCurr)
    <=> ( v47591(VarCurr)
        | v47595(VarCurr) ) ) ).

tff(addAssignment_23832,axiom,
    ! [VarCurr: state_type] :
      ( v47599(VarCurr)
    <=> v47601(VarCurr) ) ).

tff(addAssignment_23831,axiom,
    ! [VarCurr: state_type] :
      ( v47601(VarCurr)
    <=> v47131(VarCurr,2) ) ).

tff(addAssignment_23830,axiom,
    ! [VarCurr: state_type] :
      ( v47131(VarCurr,2)
    <=> v47133(VarCurr,2) ) ).

tff(addAssignment_23829,axiom,
    ! [VarCurr: state_type] :
      ( v47133(VarCurr,2)
    <=> v47135(VarCurr,2) ) ).

tff(addAssignment_23828,axiom,
    ! [VarCurr: state_type] :
      ( v47135(VarCurr,2)
    <=> v47140(VarCurr,2) ) ).

tff(addAssignment_23827,axiom,
    ! [VarCurr: state_type] :
      ( v47137(VarCurr,2)
    <=> v47139(VarCurr,2) ) ).

tff(addAssignment_23826,axiom,
    ! [VarCurr: state_type] :
      ( v47139(VarCurr,2)
    <=> v46705(VarCurr,2) ) ).

tff(addAssignment_23825,axiom,
    ! [VarCurr: state_type] :
      ( v47595(VarCurr)
    <=> v47597(VarCurr) ) ).

tff(addAssignment_23824,axiom,
    ! [VarCurr: state_type] :
      ( v47597(VarCurr)
    <=> v46705(VarCurr,1) ) ).

tff(addAssignment_23823,axiom,
    ! [VarCurr: state_type] :
      ( v47591(VarCurr)
    <=> v47593(VarCurr) ) ).

tff(addAssignment_23822,axiom,
    ! [VarCurr: state_type] :
      ( v47593(VarCurr)
    <=> v46705(VarCurr,0) ) ).

tff(addAssignment_23821,axiom,
    ! [VarCurr: state_type] :
      ( v47577(VarCurr)
    <=> v47579(VarCurr) ) ).

tff(addAssignment_23820,axiom,
    ! [VarCurr: state_type] :
      ( v47579(VarCurr)
    <=> $false ) ).

tff(addAssignment_23819,axiom,
    ! [VarCurr: state_type] :
      ( v47571(VarCurr)
    <=> v47573(VarCurr) ) ).

tff(addAssignment_23818,axiom,
    ! [VarCurr: state_type] :
      ( v47573(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47561(VarCurr,B)
      <=> v47563(VarCurr,B) ) ) ).

tff(addAssignment_23816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47563(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23815,axiom,
    ! [VarCurr: state_type] :
      ( v47551(VarCurr)
    <=> v47553(VarCurr) ) ).

tff(addAssignment_23814,axiom,
    ! [VarCurr: state_type] :
      ( v47553(VarCurr)
    <=> v47555(VarCurr) ) ).

tff(addAssignment_23813,axiom,
    ! [VarCurr: state_type] :
      ( v47555(VarCurr)
    <=> v47557(VarCurr) ) ).

tff(addAssignment_23812,axiom,
    ! [VarCurr: state_type] :
      ( v47557(VarCurr)
    <=> v47559(VarCurr) ) ).

tff(addAssignment_23811,axiom,
    ! [VarCurr: state_type] :
      ( v47559(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23810,axiom,
    ! [VarCurr: state_type] :
      ( v47541(VarCurr)
    <=> v47543(VarCurr) ) ).

tff(addAssignment_23809,axiom,
    ! [VarCurr: state_type] :
      ( v47543(VarCurr)
    <=> v47545(VarCurr) ) ).

tff(addAssignment_23808,axiom,
    ! [VarCurr: state_type] :
      ( v47545(VarCurr)
    <=> v47547(VarCurr) ) ).

tff(addAssignment_23807,axiom,
    ! [VarCurr: state_type] :
      ( v47547(VarCurr)
    <=> v47549(VarCurr) ) ).

tff(addAssignment_23806,axiom,
    ! [VarCurr: state_type] :
      ( v47549(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23805,axiom,
    ! [VarCurr: state_type] :
      ( v47500(VarCurr)
    <=> v47502(VarCurr) ) ).

tff(addAssignment_23804,axiom,
    ! [VarCurr: state_type] :
      ( v47502(VarCurr)
    <=> v47504(VarCurr) ) ).

tff(addAssignment_23803,axiom,
    ! [VarCurr: state_type] :
      ( v47504(VarCurr)
    <=> v47506(VarCurr) ) ).

tff(addAssignment_23802,axiom,
    ! [VarCurr: state_type] :
      ( v47506(VarCurr)
    <=> v47508(VarCurr) ) ).

tff(addAssignment_23801,axiom,
    ! [VarCurr: state_type] :
      ( v47508(VarCurr)
    <=> v47510(VarCurr) ) ).

tff(addAssignment_23800,axiom,
    ! [VarCurr: state_type] :
      ( v47510(VarCurr)
    <=> v47512(VarCurr) ) ).

tff(addAssignment_23799,axiom,
    ! [VarCurr: state_type] :
      ( v47512(VarCurr)
    <=> v47514(VarCurr) ) ).

tff(writeUnaryOperator_2727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47514(VarCurr)
    <=> v47528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4450,axiom,
    ! [VarCurr: state_type] :
      ( v47528(VarCurr)
    <=> ( v47529(VarCurr)
        | v47524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4449,axiom,
    ! [VarCurr: state_type] :
      ( v47529(VarCurr)
    <=> ( v47516(VarCurr)
        | v47520(VarCurr) ) ) ).

tff(addAssignment_23798,axiom,
    ! [VarCurr: state_type] :
      ( v47524(VarCurr)
    <=> v47526(VarCurr) ) ).

tff(addAssignment_23797,axiom,
    ! [VarCurr: state_type] :
      ( v47526(VarCurr)
    <=> v46795(VarCurr,2) ) ).

tff(addAssignment_23796,axiom,
    ! [VarCurr: state_type] :
      ( v47520(VarCurr)
    <=> v47522(VarCurr) ) ).

tff(addAssignment_23795,axiom,
    ! [VarCurr: state_type] :
      ( v47522(VarCurr)
    <=> v46878(VarCurr,1) ) ).

tff(addAssignment_23794,axiom,
    ! [VarCurr: state_type] :
      ( v47516(VarCurr)
    <=> v47518(VarCurr) ) ).

tff(addAssignment_23793,axiom,
    ! [VarCurr: state_type] :
      ( v47518(VarCurr)
    <=> v46878(VarCurr,0) ) ).

tff(addAssignment_23792,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47380(VarCurr,B)
      <=> v47382(VarCurr,B) ) ) ).

tff(addAssignment_23791,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47382(VarCurr,B)
      <=> v47384(VarCurr,B) ) ) ).

tff(addAssignment_23790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47384(VarCurr,B)
      <=> v47386(VarCurr,B) ) ) ).

tff(addAssignment_23789,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47386(VarCurr,B)
      <=> v47388(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47483(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47388(VarNext,B)
            <=> v47388(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_554,axiom,
    ! [VarNext: state_type] :
      ( v47483(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47388(VarNext,B)
          <=> v47493(VarNext,B) ) ) ) ).

tff(addAssignment_23788,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47493(VarNext,B)
          <=> v47491(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47494(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47491(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_366,axiom,
    ! [VarCurr: state_type] :
      ( v47494(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47491(VarCurr,B)
          <=> v47410(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4448,axiom,
    ! [VarCurr: state_type] :
      ( v47494(VarCurr)
    <=> ( v47495(VarCurr)
        & v47496(VarCurr) ) ) ).

tff(writeUnaryOperator_2726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47496(VarCurr)
    <=> v47400(VarCurr) ) ).

tff(writeUnaryOperator_2725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47495(VarCurr)
    <=> v47390(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47483(VarNext)
      <=> v47484(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47484(VarNext)
      <=> ( v47485(VarNext)
          & v47414(VarNext) ) ) ) ).

tff(writeUnaryOperator_2724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47485(VarNext)
      <=> v47487(VarNext) ) ) ).

tff(addAssignment_23787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47487(VarNext)
      <=> v47414(VarCurr) ) ) ).

tff(addAssignment_23786,axiom,
    ! [VarCurr: state_type] :
      ( v47414(VarCurr)
    <=> v47416(VarCurr) ) ).

tff(addAssignment_23785,axiom,
    ! [VarCurr: state_type] :
      ( v47416(VarCurr)
    <=> v47418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4445,axiom,
    ! [VarCurr: state_type] :
      ( v47418(VarCurr)
    <=> ( v47480(VarCurr)
        | v47476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4444,axiom,
    ! [VarCurr: state_type] :
      ( v47480(VarCurr)
    <=> ( v47420(VarCurr)
        & v47424(VarCurr) ) ) ).

tff(addAssignment_23784,axiom,
    ! [VarCurr: state_type] :
      ( v47476(VarCurr)
    <=> v47478(VarCurr) ) ).

tff(addAssignment_23783,axiom,
    ! [VarCurr: state_type] :
      ( v47478(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47460(VarNext)
       => ( v47424(VarNext)
        <=> v47424(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_553,axiom,
    ! [VarNext: state_type] :
      ( v47460(VarNext)
     => ( v47424(VarNext)
      <=> v47470(VarNext) ) ) ).

tff(addAssignment_23782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47470(VarNext)
      <=> v47468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4443,axiom,
    ! [VarCurr: state_type] :
      ( v47468(VarCurr)
    <=> ( v47471(VarCurr)
        & v47472(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4442,axiom,
    ! [VarCurr: state_type] :
      ( v47472(VarCurr)
    <=> ( v47430(VarCurr)
        | v47455(VarCurr) ) ) ).

tff(writeUnaryOperator_2723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47471(VarCurr)
    <=> v47426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47460(VarNext)
      <=> v47461(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47461(VarNext)
      <=> ( v47463(VarNext)
          & v47465(VarNext) ) ) ) ).

tff(writeUnaryOperator_2722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47465(VarCurr)
    <=> v47420(VarCurr) ) ).

tff(addAssignment_23781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47463(VarNext)
      <=> v47420(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_203,axiom,
    ( v47424(constB0)
  <=> $true ) ).

tff(addAssignment_23780,axiom,
    ! [VarCurr: state_type] :
      ( v47455(VarCurr)
    <=> v47457(VarCurr) ) ).

tff(addAssignment_23779,axiom,
    ! [VarCurr: state_type] :
      ( v47457(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23778,axiom,
    ! [VarCurr: state_type] :
      ( v47430(VarCurr)
    <=> v47432(VarCurr) ) ).

tff(addAssignment_23777,axiom,
    ! [VarCurr: state_type] :
      ( v47432(VarCurr)
    <=> v47434(VarCurr) ) ).

tff(addAssignment_23776,axiom,
    ! [VarCurr: state_type] :
      ( v47434(VarCurr)
    <=> v47436(VarCurr) ) ).

tff(addAssignment_23775,axiom,
    ! [VarCurr: state_type] :
      ( v47436(VarCurr)
    <=> v47438(VarCurr) ) ).

tff(writeUnaryOperator_2721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47438(VarCurr)
    <=> v47452(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4439,axiom,
    ! [VarCurr: state_type] :
      ( v47452(VarCurr)
    <=> ( v47453(VarCurr)
        | v47448(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4438,axiom,
    ! [VarCurr: state_type] :
      ( v47453(VarCurr)
    <=> ( v47440(VarCurr)
        | v47444(VarCurr) ) ) ).

tff(addAssignment_23774,axiom,
    ! [VarCurr: state_type] :
      ( v47448(VarCurr)
    <=> v47450(VarCurr) ) ).

tff(addAssignment_23773,axiom,
    ! [VarCurr: state_type] :
      ( v47450(VarCurr)
    <=> v46705(VarCurr,2) ) ).

tff(addAssignment_23772,axiom,
    ! [VarCurr: state_type] :
      ( v47444(VarCurr)
    <=> v47446(VarCurr) ) ).

tff(addAssignment_23771,axiom,
    ! [VarCurr: state_type] :
      ( v47446(VarCurr)
    <=> v47131(VarCurr,1) ) ).

tff(addAssignment_23770,axiom,
    ! [VarCurr: state_type] :
      ( v47440(VarCurr)
    <=> v47442(VarCurr) ) ).

tff(addAssignment_23769,axiom,
    ! [VarCurr: state_type] :
      ( v47442(VarCurr)
    <=> v47131(VarCurr,0) ) ).

tff(addAssignment_23768,axiom,
    ! [VarCurr: state_type] :
      ( v47426(VarCurr)
    <=> v47428(VarCurr) ) ).

tff(addAssignment_23767,axiom,
    ! [VarCurr: state_type] :
      ( v47428(VarCurr)
    <=> $false ) ).

tff(addAssignment_23766,axiom,
    ! [VarCurr: state_type] :
      ( v47420(VarCurr)
    <=> v47422(VarCurr) ) ).

tff(addAssignment_23765,axiom,
    ! [VarCurr: state_type] :
      ( v47422(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47410(VarCurr,B)
      <=> v47412(VarCurr,B) ) ) ).

tff(addAssignment_23763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47412(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23762,axiom,
    ! [VarCurr: state_type] :
      ( v47400(VarCurr)
    <=> v47402(VarCurr) ) ).

tff(addAssignment_23761,axiom,
    ! [VarCurr: state_type] :
      ( v47402(VarCurr)
    <=> v47404(VarCurr) ) ).

tff(addAssignment_23760,axiom,
    ! [VarCurr: state_type] :
      ( v47404(VarCurr)
    <=> v47406(VarCurr) ) ).

tff(addAssignment_23759,axiom,
    ! [VarCurr: state_type] :
      ( v47406(VarCurr)
    <=> v47408(VarCurr) ) ).

tff(addAssignment_23758,axiom,
    ! [VarCurr: state_type] :
      ( v47408(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23757,axiom,
    ! [VarCurr: state_type] :
      ( v47390(VarCurr)
    <=> v47392(VarCurr) ) ).

tff(addAssignment_23756,axiom,
    ! [VarCurr: state_type] :
      ( v47392(VarCurr)
    <=> v47394(VarCurr) ) ).

tff(addAssignment_23755,axiom,
    ! [VarCurr: state_type] :
      ( v47394(VarCurr)
    <=> v47396(VarCurr) ) ).

tff(addAssignment_23754,axiom,
    ! [VarCurr: state_type] :
      ( v47396(VarCurr)
    <=> v47398(VarCurr) ) ).

tff(addAssignment_23753,axiom,
    ! [VarCurr: state_type] :
      ( v47398(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23752,axiom,
    ! [VarCurr: state_type] :
      ( v47349(VarCurr)
    <=> v47351(VarCurr) ) ).

tff(addAssignment_23751,axiom,
    ! [VarCurr: state_type] :
      ( v47351(VarCurr)
    <=> v47353(VarCurr) ) ).

tff(addAssignment_23750,axiom,
    ! [VarCurr: state_type] :
      ( v47353(VarCurr)
    <=> v47355(VarCurr) ) ).

tff(addAssignment_23749,axiom,
    ! [VarCurr: state_type] :
      ( v47355(VarCurr)
    <=> v47357(VarCurr) ) ).

tff(addAssignment_23748,axiom,
    ! [VarCurr: state_type] :
      ( v47357(VarCurr)
    <=> v47359(VarCurr) ) ).

tff(addAssignment_23747,axiom,
    ! [VarCurr: state_type] :
      ( v47359(VarCurr)
    <=> v47361(VarCurr) ) ).

tff(addAssignment_23746,axiom,
    ! [VarCurr: state_type] :
      ( v47361(VarCurr)
    <=> v47363(VarCurr) ) ).

tff(writeUnaryOperator_2720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47363(VarCurr)
    <=> v47377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4437,axiom,
    ! [VarCurr: state_type] :
      ( v47377(VarCurr)
    <=> ( v47378(VarCurr)
        | v47373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4436,axiom,
    ! [VarCurr: state_type] :
      ( v47378(VarCurr)
    <=> ( v47365(VarCurr)
        | v47369(VarCurr) ) ) ).

tff(addAssignment_23745,axiom,
    ! [VarCurr: state_type] :
      ( v47373(VarCurr)
    <=> v47375(VarCurr) ) ).

tff(addAssignment_23744,axiom,
    ! [VarCurr: state_type] :
      ( v47375(VarCurr)
    <=> v46795(VarCurr,2) ) ).

tff(addAssignment_23743,axiom,
    ! [VarCurr: state_type] :
      ( v47369(VarCurr)
    <=> v47371(VarCurr) ) ).

tff(addAssignment_23742,axiom,
    ! [VarCurr: state_type] :
      ( v47371(VarCurr)
    <=> v46878(VarCurr,1) ) ).

tff(addAssignment_23741,axiom,
    ! [VarCurr: state_type] :
      ( v46878(VarCurr,1)
    <=> v46880(VarCurr,1) ) ).

tff(addAssignment_23740,axiom,
    ! [VarCurr: state_type] :
      ( v46880(VarCurr,1)
    <=> v46882(VarCurr,1) ) ).

tff(addAssignment_23739,axiom,
    ! [VarCurr: state_type] :
      ( v46882(VarCurr,1)
    <=> v46887(VarCurr,1) ) ).

tff(addAssignment_23738,axiom,
    ! [VarCurr: state_type] :
      ( v46884(VarCurr,1)
    <=> v46886(VarCurr,1) ) ).

tff(addAssignment_23737,axiom,
    ! [VarCurr: state_type] :
      ( v46886(VarCurr,1)
    <=> v46795(VarCurr,1) ) ).

tff(addAssignment_23736,axiom,
    ! [VarCurr: state_type] :
      ( v47365(VarCurr)
    <=> v47367(VarCurr) ) ).

tff(addAssignment_23735,axiom,
    ! [VarCurr: state_type] :
      ( v47367(VarCurr)
    <=> v46795(VarCurr,0) ) ).

tff(addAssignment_23734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47229(VarCurr,B)
      <=> v47231(VarCurr,B) ) ) ).

tff(addAssignment_23733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47231(VarCurr,B)
      <=> v47233(VarCurr,B) ) ) ).

tff(addAssignment_23732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47233(VarCurr,B)
      <=> v47235(VarCurr,B) ) ) ).

tff(addAssignment_23731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47235(VarCurr,B)
      <=> v47237(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47332(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47237(VarNext,B)
            <=> v47237(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_552,axiom,
    ! [VarNext: state_type] :
      ( v47332(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47237(VarNext,B)
          <=> v47342(VarNext,B) ) ) ) ).

tff(addAssignment_23730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47342(VarNext,B)
          <=> v47340(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47343(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47340(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_365,axiom,
    ! [VarCurr: state_type] :
      ( v47343(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47340(VarCurr,B)
          <=> v47259(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4435,axiom,
    ! [VarCurr: state_type] :
      ( v47343(VarCurr)
    <=> ( v47344(VarCurr)
        & v47345(VarCurr) ) ) ).

tff(writeUnaryOperator_2719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47345(VarCurr)
    <=> v47249(VarCurr) ) ).

tff(writeUnaryOperator_2718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47344(VarCurr)
    <=> v47239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47332(VarNext)
      <=> v47333(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47333(VarNext)
      <=> ( v47334(VarNext)
          & v47263(VarNext) ) ) ) ).

tff(writeUnaryOperator_2717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47334(VarNext)
      <=> v47336(VarNext) ) ) ).

tff(addAssignment_23729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47336(VarNext)
      <=> v47263(VarCurr) ) ) ).

tff(addAssignment_23728,axiom,
    ! [VarCurr: state_type] :
      ( v47263(VarCurr)
    <=> v47265(VarCurr) ) ).

tff(addAssignment_23727,axiom,
    ! [VarCurr: state_type] :
      ( v47265(VarCurr)
    <=> v47267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4432,axiom,
    ! [VarCurr: state_type] :
      ( v47267(VarCurr)
    <=> ( v47329(VarCurr)
        | v47325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4431,axiom,
    ! [VarCurr: state_type] :
      ( v47329(VarCurr)
    <=> ( v47269(VarCurr)
        & v47273(VarCurr) ) ) ).

tff(addAssignment_23726,axiom,
    ! [VarCurr: state_type] :
      ( v47325(VarCurr)
    <=> v47327(VarCurr) ) ).

tff(addAssignment_23725,axiom,
    ! [VarCurr: state_type] :
      ( v47327(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47309(VarNext)
       => ( v47273(VarNext)
        <=> v47273(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_551,axiom,
    ! [VarNext: state_type] :
      ( v47309(VarNext)
     => ( v47273(VarNext)
      <=> v47319(VarNext) ) ) ).

tff(addAssignment_23724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47319(VarNext)
      <=> v47317(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4430,axiom,
    ! [VarCurr: state_type] :
      ( v47317(VarCurr)
    <=> ( v47320(VarCurr)
        & v47321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4429,axiom,
    ! [VarCurr: state_type] :
      ( v47321(VarCurr)
    <=> ( v47279(VarCurr)
        | v47304(VarCurr) ) ) ).

tff(writeUnaryOperator_2716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47320(VarCurr)
    <=> v47275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47309(VarNext)
      <=> v47310(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47310(VarNext)
      <=> ( v47312(VarNext)
          & v47314(VarNext) ) ) ) ).

tff(writeUnaryOperator_2715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47314(VarCurr)
    <=> v47269(VarCurr) ) ).

tff(addAssignment_23723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47312(VarNext)
      <=> v47269(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_202,axiom,
    ( v47273(constB0)
  <=> $true ) ).

tff(addAssignment_23722,axiom,
    ! [VarCurr: state_type] :
      ( v47304(VarCurr)
    <=> v47306(VarCurr) ) ).

tff(addAssignment_23721,axiom,
    ! [VarCurr: state_type] :
      ( v47306(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23720,axiom,
    ! [VarCurr: state_type] :
      ( v47279(VarCurr)
    <=> v47281(VarCurr) ) ).

tff(addAssignment_23719,axiom,
    ! [VarCurr: state_type] :
      ( v47281(VarCurr)
    <=> v47283(VarCurr) ) ).

tff(addAssignment_23718,axiom,
    ! [VarCurr: state_type] :
      ( v47283(VarCurr)
    <=> v47285(VarCurr) ) ).

tff(addAssignment_23717,axiom,
    ! [VarCurr: state_type] :
      ( v47285(VarCurr)
    <=> v47287(VarCurr) ) ).

tff(writeUnaryOperator_2714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47287(VarCurr)
    <=> v47301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4426,axiom,
    ! [VarCurr: state_type] :
      ( v47301(VarCurr)
    <=> ( v47302(VarCurr)
        | v47297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4425,axiom,
    ! [VarCurr: state_type] :
      ( v47302(VarCurr)
    <=> ( v47289(VarCurr)
        | v47293(VarCurr) ) ) ).

tff(addAssignment_23716,axiom,
    ! [VarCurr: state_type] :
      ( v47297(VarCurr)
    <=> v47299(VarCurr) ) ).

tff(addAssignment_23715,axiom,
    ! [VarCurr: state_type] :
      ( v47299(VarCurr)
    <=> v46705(VarCurr,2) ) ).

tff(addAssignment_23714,axiom,
    ! [VarCurr: state_type] :
      ( v47293(VarCurr)
    <=> v47295(VarCurr) ) ).

tff(addAssignment_23713,axiom,
    ! [VarCurr: state_type] :
      ( v47295(VarCurr)
    <=> v47131(VarCurr,1) ) ).

tff(addAssignment_23712,axiom,
    ! [VarCurr: state_type] :
      ( v47131(VarCurr,1)
    <=> v47133(VarCurr,1) ) ).

tff(addAssignment_23711,axiom,
    ! [VarCurr: state_type] :
      ( v47133(VarCurr,1)
    <=> v47135(VarCurr,1) ) ).

tff(addAssignment_23710,axiom,
    ! [VarCurr: state_type] :
      ( v47135(VarCurr,1)
    <=> v47140(VarCurr,1) ) ).

tff(addAssignment_23709,axiom,
    ! [VarCurr: state_type] :
      ( v47137(VarCurr,1)
    <=> v47139(VarCurr,1) ) ).

tff(addAssignment_23708,axiom,
    ! [VarCurr: state_type] :
      ( v47139(VarCurr,1)
    <=> v46705(VarCurr,1) ) ).

tff(addAssignment_23707,axiom,
    ! [VarCurr: state_type] :
      ( v47289(VarCurr)
    <=> v47291(VarCurr) ) ).

tff(addAssignment_23706,axiom,
    ! [VarCurr: state_type] :
      ( v47291(VarCurr)
    <=> v46705(VarCurr,0) ) ).

tff(addAssignment_23705,axiom,
    ! [VarCurr: state_type] :
      ( v47275(VarCurr)
    <=> v47277(VarCurr) ) ).

tff(addAssignment_23704,axiom,
    ! [VarCurr: state_type] :
      ( v47277(VarCurr)
    <=> $false ) ).

tff(addAssignment_23703,axiom,
    ! [VarCurr: state_type] :
      ( v47269(VarCurr)
    <=> v47271(VarCurr) ) ).

tff(addAssignment_23702,axiom,
    ! [VarCurr: state_type] :
      ( v47271(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47259(VarCurr,B)
      <=> v47261(VarCurr,B) ) ) ).

tff(addAssignment_23700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47261(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23699,axiom,
    ! [VarCurr: state_type] :
      ( v47249(VarCurr)
    <=> v47251(VarCurr) ) ).

tff(addAssignment_23698,axiom,
    ! [VarCurr: state_type] :
      ( v47251(VarCurr)
    <=> v47253(VarCurr) ) ).

tff(addAssignment_23697,axiom,
    ! [VarCurr: state_type] :
      ( v47253(VarCurr)
    <=> v47255(VarCurr) ) ).

tff(addAssignment_23696,axiom,
    ! [VarCurr: state_type] :
      ( v47255(VarCurr)
    <=> v47257(VarCurr) ) ).

tff(addAssignment_23695,axiom,
    ! [VarCurr: state_type] :
      ( v47257(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23694,axiom,
    ! [VarCurr: state_type] :
      ( v47239(VarCurr)
    <=> v47241(VarCurr) ) ).

tff(addAssignment_23693,axiom,
    ! [VarCurr: state_type] :
      ( v47241(VarCurr)
    <=> v47243(VarCurr) ) ).

tff(addAssignment_23692,axiom,
    ! [VarCurr: state_type] :
      ( v47243(VarCurr)
    <=> v47245(VarCurr) ) ).

tff(addAssignment_23691,axiom,
    ! [VarCurr: state_type] :
      ( v47245(VarCurr)
    <=> v47247(VarCurr) ) ).

tff(addAssignment_23690,axiom,
    ! [VarCurr: state_type] :
      ( v47247(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23689,axiom,
    ! [VarCurr: state_type] :
      ( v47198(VarCurr)
    <=> v47200(VarCurr) ) ).

tff(addAssignment_23688,axiom,
    ! [VarCurr: state_type] :
      ( v47200(VarCurr)
    <=> v47202(VarCurr) ) ).

tff(addAssignment_23687,axiom,
    ! [VarCurr: state_type] :
      ( v47202(VarCurr)
    <=> v47204(VarCurr) ) ).

tff(addAssignment_23686,axiom,
    ! [VarCurr: state_type] :
      ( v47204(VarCurr)
    <=> v47206(VarCurr) ) ).

tff(addAssignment_23685,axiom,
    ! [VarCurr: state_type] :
      ( v47206(VarCurr)
    <=> v47208(VarCurr) ) ).

tff(addAssignment_23684,axiom,
    ! [VarCurr: state_type] :
      ( v47208(VarCurr)
    <=> v47210(VarCurr) ) ).

tff(addAssignment_23683,axiom,
    ! [VarCurr: state_type] :
      ( v47210(VarCurr)
    <=> v47212(VarCurr) ) ).

tff(writeUnaryOperator_2713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47212(VarCurr)
    <=> v47226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4424,axiom,
    ! [VarCurr: state_type] :
      ( v47226(VarCurr)
    <=> ( v47227(VarCurr)
        | v47222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4423,axiom,
    ! [VarCurr: state_type] :
      ( v47227(VarCurr)
    <=> ( v47214(VarCurr)
        | v47218(VarCurr) ) ) ).

tff(addAssignment_23682,axiom,
    ! [VarCurr: state_type] :
      ( v47222(VarCurr)
    <=> v47224(VarCurr) ) ).

tff(addAssignment_23681,axiom,
    ! [VarCurr: state_type] :
      ( v47224(VarCurr)
    <=> v46795(VarCurr,2) ) ).

tff(addAssignment_23680,axiom,
    ! [VarCurr: state_type] :
      ( v47218(VarCurr)
    <=> v47220(VarCurr) ) ).

tff(addAssignment_23679,axiom,
    ! [VarCurr: state_type] :
      ( v47220(VarCurr)
    <=> v46795(VarCurr,1) ) ).

tff(addAssignment_23678,axiom,
    ! [VarCurr: state_type] :
      ( v47214(VarCurr)
    <=> v47216(VarCurr) ) ).

tff(addAssignment_23677,axiom,
    ! [VarCurr: state_type] :
      ( v47216(VarCurr)
    <=> v46878(VarCurr,0) ) ).

tff(addAssignment_23676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47067(VarCurr,B)
      <=> v47069(VarCurr,B) ) ) ).

tff(addAssignment_23675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47069(VarCurr,B)
      <=> v47071(VarCurr,B) ) ) ).

tff(addAssignment_23674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47071(VarCurr,B)
      <=> v47073(VarCurr,B) ) ) ).

tff(addAssignment_23673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47073(VarCurr,B)
      <=> v47075(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_550,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47181(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v47075(VarNext,B)
            <=> v47075(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_550,axiom,
    ! [VarNext: state_type] :
      ( v47181(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47075(VarNext,B)
          <=> v47191(VarNext,B) ) ) ) ).

tff(addAssignment_23672,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47191(VarNext,B)
          <=> v47189(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47192(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47189(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_364,axiom,
    ! [VarCurr: state_type] :
      ( v47192(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v47189(VarCurr,B)
          <=> v47097(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4422,axiom,
    ! [VarCurr: state_type] :
      ( v47192(VarCurr)
    <=> ( v47193(VarCurr)
        & v47194(VarCurr) ) ) ).

tff(writeUnaryOperator_2712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47194(VarCurr)
    <=> v47087(VarCurr) ) ).

tff(writeUnaryOperator_2711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47193(VarCurr)
    <=> v47077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47181(VarNext)
      <=> v47182(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47182(VarNext)
      <=> ( v47183(VarNext)
          & v47101(VarNext) ) ) ) ).

tff(writeUnaryOperator_2710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47183(VarNext)
      <=> v47185(VarNext) ) ) ).

tff(addAssignment_23671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47185(VarNext)
      <=> v47101(VarCurr) ) ) ).

tff(addAssignment_23670,axiom,
    ! [VarCurr: state_type] :
      ( v47101(VarCurr)
    <=> v47103(VarCurr) ) ).

tff(addAssignment_23669,axiom,
    ! [VarCurr: state_type] :
      ( v47103(VarCurr)
    <=> v47105(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4419,axiom,
    ! [VarCurr: state_type] :
      ( v47105(VarCurr)
    <=> ( v47178(VarCurr)
        | v47174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4418,axiom,
    ! [VarCurr: state_type] :
      ( v47178(VarCurr)
    <=> ( v47107(VarCurr)
        & v47111(VarCurr) ) ) ).

tff(addAssignment_23668,axiom,
    ! [VarCurr: state_type] :
      ( v47174(VarCurr)
    <=> v47176(VarCurr) ) ).

tff(addAssignment_23667,axiom,
    ! [VarCurr: state_type] :
      ( v47176(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47158(VarNext)
       => ( v47111(VarNext)
        <=> v47111(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_549,axiom,
    ! [VarNext: state_type] :
      ( v47158(VarNext)
     => ( v47111(VarNext)
      <=> v47168(VarNext) ) ) ).

tff(addAssignment_23666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47168(VarNext)
      <=> v47166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4417,axiom,
    ! [VarCurr: state_type] :
      ( v47166(VarCurr)
    <=> ( v47169(VarCurr)
        & v47170(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4416,axiom,
    ! [VarCurr: state_type] :
      ( v47170(VarCurr)
    <=> ( v47117(VarCurr)
        | v47153(VarCurr) ) ) ).

tff(writeUnaryOperator_2709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47169(VarCurr)
    <=> v47113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47158(VarNext)
      <=> v47159(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47159(VarNext)
      <=> ( v47161(VarNext)
          & v47163(VarNext) ) ) ) ).

tff(writeUnaryOperator_2708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47163(VarCurr)
    <=> v47107(VarCurr) ) ).

tff(addAssignment_23665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47161(VarNext)
      <=> v47107(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_201,axiom,
    ( v47111(constB0)
  <=> $true ) ).

tff(addAssignment_23664,axiom,
    ! [VarCurr: state_type] :
      ( v47153(VarCurr)
    <=> v47155(VarCurr) ) ).

tff(addAssignment_23663,axiom,
    ! [VarCurr: state_type] :
      ( v47155(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23662,axiom,
    ! [VarCurr: state_type] :
      ( v47117(VarCurr)
    <=> v47119(VarCurr) ) ).

tff(addAssignment_23661,axiom,
    ! [VarCurr: state_type] :
      ( v47119(VarCurr)
    <=> v47121(VarCurr) ) ).

tff(addAssignment_23660,axiom,
    ! [VarCurr: state_type] :
      ( v47121(VarCurr)
    <=> v47123(VarCurr) ) ).

tff(addAssignment_23659,axiom,
    ! [VarCurr: state_type] :
      ( v47123(VarCurr)
    <=> v47125(VarCurr) ) ).

tff(writeUnaryOperator_2707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47125(VarCurr)
    <=> v47150(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4413,axiom,
    ! [VarCurr: state_type] :
      ( v47150(VarCurr)
    <=> ( v47151(VarCurr)
        | v47146(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4412,axiom,
    ! [VarCurr: state_type] :
      ( v47151(VarCurr)
    <=> ( v47127(VarCurr)
        | v47142(VarCurr) ) ) ).

tff(addAssignment_23658,axiom,
    ! [VarCurr: state_type] :
      ( v47146(VarCurr)
    <=> v47148(VarCurr) ) ).

tff(addAssignment_23657,axiom,
    ! [VarCurr: state_type] :
      ( v47148(VarCurr)
    <=> v46705(VarCurr,2) ) ).

tff(addAssignment_23656,axiom,
    ! [VarCurr: state_type] :
      ( v47142(VarCurr)
    <=> v47144(VarCurr) ) ).

tff(addAssignment_23655,axiom,
    ! [VarCurr: state_type] :
      ( v47144(VarCurr)
    <=> v46705(VarCurr,1) ) ).

tff(addAssignment_23654,axiom,
    ! [VarCurr: state_type] :
      ( v47127(VarCurr)
    <=> v47129(VarCurr) ) ).

tff(addAssignment_23653,axiom,
    ! [VarCurr: state_type] :
      ( v47129(VarCurr)
    <=> v47131(VarCurr,0) ) ).

tff(addAssignment_23652,axiom,
    ! [VarCurr: state_type] :
      ( v47131(VarCurr,0)
    <=> v47133(VarCurr,0) ) ).

tff(addAssignment_23651,axiom,
    ! [VarCurr: state_type] :
      ( v47133(VarCurr,0)
    <=> v47135(VarCurr,0) ) ).

tff(addAssignment_23650,axiom,
    ! [VarCurr: state_type] :
      ( v47135(VarCurr,0)
    <=> v47140(VarCurr,0) ) ).

tff(writeUnaryOperator_2706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v47140(VarCurr,B)
      <=> ~ v47137(VarCurr,B) ) ) ).

tff(addAssignment_23649,axiom,
    ! [VarCurr: state_type] :
      ( v47137(VarCurr,0)
    <=> v47139(VarCurr,0) ) ).

tff(addAssignment_23648,axiom,
    ! [VarCurr: state_type] :
      ( v47139(VarCurr,0)
    <=> v46705(VarCurr,0) ) ).

tff(addAssignment_23647,axiom,
    ! [VarCurr: state_type] :
      ( v47113(VarCurr)
    <=> v47115(VarCurr) ) ).

tff(addAssignment_23646,axiom,
    ! [VarCurr: state_type] :
      ( v47115(VarCurr)
    <=> $false ) ).

tff(addAssignment_23645,axiom,
    ! [VarCurr: state_type] :
      ( v47107(VarCurr)
    <=> v47109(VarCurr) ) ).

tff(addAssignment_23644,axiom,
    ! [VarCurr: state_type] :
      ( v47109(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47097(VarCurr,B)
      <=> v47099(VarCurr,B) ) ) ).

tff(addAssignment_23642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v47099(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23641,axiom,
    ! [VarCurr: state_type] :
      ( v47087(VarCurr)
    <=> v47089(VarCurr) ) ).

tff(addAssignment_23640,axiom,
    ! [VarCurr: state_type] :
      ( v47089(VarCurr)
    <=> v47091(VarCurr) ) ).

tff(addAssignment_23639,axiom,
    ! [VarCurr: state_type] :
      ( v47091(VarCurr)
    <=> v47093(VarCurr) ) ).

tff(addAssignment_23638,axiom,
    ! [VarCurr: state_type] :
      ( v47093(VarCurr)
    <=> v47095(VarCurr) ) ).

tff(addAssignment_23637,axiom,
    ! [VarCurr: state_type] :
      ( v47095(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23636,axiom,
    ! [VarCurr: state_type] :
      ( v47077(VarCurr)
    <=> v47079(VarCurr) ) ).

tff(addAssignment_23635,axiom,
    ! [VarCurr: state_type] :
      ( v47079(VarCurr)
    <=> v47081(VarCurr) ) ).

tff(addAssignment_23634,axiom,
    ! [VarCurr: state_type] :
      ( v47081(VarCurr)
    <=> v47083(VarCurr) ) ).

tff(addAssignment_23633,axiom,
    ! [VarCurr: state_type] :
      ( v47083(VarCurr)
    <=> v47085(VarCurr) ) ).

tff(addAssignment_23632,axiom,
    ! [VarCurr: state_type] :
      ( v47085(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23631,axiom,
    ! [VarCurr: state_type] :
      ( v46775(VarCurr)
    <=> v46777(VarCurr) ) ).

tff(addAssignment_23630,axiom,
    ! [VarCurr: state_type] :
      ( v46777(VarCurr)
    <=> v46779(VarCurr) ) ).

tff(addAssignment_23629,axiom,
    ! [VarCurr: state_type] :
      ( v46779(VarCurr)
    <=> v46781(VarCurr) ) ).

tff(addAssignment_23628,axiom,
    ! [VarCurr: state_type] :
      ( v46781(VarCurr)
    <=> v46783(VarCurr) ) ).

tff(addAssignment_23627,axiom,
    ! [VarCurr: state_type] :
      ( v46783(VarCurr)
    <=> v46785(VarCurr) ) ).

tff(addAssignment_23626,axiom,
    ! [VarCurr: state_type] :
      ( v46785(VarCurr)
    <=> v46787(VarCurr) ) ).

tff(addAssignment_23625,axiom,
    ! [VarCurr: state_type] :
      ( v46787(VarCurr)
    <=> v46789(VarCurr) ) ).

tff(writeUnaryOperator_2705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46789(VarCurr)
    <=> v47064(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4411,axiom,
    ! [VarCurr: state_type] :
      ( v47064(VarCurr)
    <=> ( v47065(VarCurr)
        | v47060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4410,axiom,
    ! [VarCurr: state_type] :
      ( v47065(VarCurr)
    <=> ( v46791(VarCurr)
        | v47056(VarCurr) ) ) ).

tff(addAssignment_23624,axiom,
    ! [VarCurr: state_type] :
      ( v47060(VarCurr)
    <=> v47062(VarCurr) ) ).

tff(addAssignment_23623,axiom,
    ! [VarCurr: state_type] :
      ( v47062(VarCurr)
    <=> v46795(VarCurr,2) ) ).

tff(addAssignment_23622,axiom,
    ! [VarCurr: state_type] :
      ( v47056(VarCurr)
    <=> v47058(VarCurr) ) ).

tff(addAssignment_23621,axiom,
    ! [VarCurr: state_type] :
      ( v47058(VarCurr)
    <=> v46795(VarCurr,1) ) ).

tff(addAssignment_23620,axiom,
    ! [VarCurr: state_type] :
      ( v46791(VarCurr)
    <=> v46793(VarCurr) ) ).

tff(addAssignment_23619,axiom,
    ! [VarCurr: state_type] :
      ( v46793(VarCurr)
    <=> v46795(VarCurr,0) ) ).

tff(addAssignment_23618,axiom,
    ! [VarCurr: state_type] :
      ( v46795(VarCurr,0)
    <=> v46707(VarCurr,3) ) ).

tff(addAssignment_23617,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,3)
    <=> v46709(VarCurr,3) ) ).

tff(addAssignment_23616,axiom,
    ! [VarNext: state_type] :
      ( v46709(VarNext,3)
    <=> v47048(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47049(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v47048(VarNext,B)
            <=> v46709(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_548,axiom,
    ! [VarNext: state_type] :
      ( v47049(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47048(VarNext,B)
          <=> v47020(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47049(VarNext)
      <=> v47050(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47050(VarNext)
      <=> ( v47052(VarNext)
          & v46962(VarNext) ) ) ) ).

tff(writeUnaryOperator_2704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47052(VarNext)
      <=> v47014(VarNext) ) ) ).

tff(addAssignment_23615,axiom,
    ! [VarCurr: state_type] :
      ( v46819(VarCurr,3)
    <=> v46821(VarCurr,3) ) ).

tff(addAssignment_23614,axiom,
    ! [VarCurr: state_type] :
      ( v46821(VarCurr,3)
    <=> v46959(VarCurr,3) ) ).

tff(addAssignment_23613,axiom,
    ! [VarCurr: state_type] :
      ( v46823(VarCurr,0)
    <=> v46825(VarCurr,0) ) ).

tff(addAssignment_23612,axiom,
    ! [VarCurr: state_type] :
      ( v46825(VarCurr,0)
    <=> v46827(VarCurr,0) ) ).

tff(addAssignment_23611,axiom,
    ! [VarCurr: state_type] :
      ( v46827(VarCurr,0)
    <=> v46958(VarCurr,0) ) ).

tff(addAssignment_23610,axiom,
    ! [VarCurr: state_type] :
      ( v46895(VarCurr,0)
    <=> v46897(VarCurr,0) ) ).

tff(addAssignment_23609,axiom,
    ! [VarCurr: state_type] :
      ( v46897(VarCurr,0)
    <=> v46899(VarCurr,0) ) ).

tff(addAssignment_23608,axiom,
    ! [VarCurr: state_type] :
      ( v46899(VarCurr,0)
    <=> v46901(VarCurr,0) ) ).

tff(addAssignment_23607,axiom,
    ! [VarCurr: state_type] :
      ( v46901(VarCurr,0)
    <=> v46903(VarCurr,0) ) ).

tff(addAssignment_23606,axiom,
    ! [VarCurr: state_type] :
      ( v46903(VarCurr,0)
    <=> v46913(VarCurr,0) ) ).

tff(addAssignment_23605,axiom,
    ! [VarCurr: state_type] :
      ( v46829(VarCurr,0)
    <=> v46831(VarCurr,0) ) ).

tff(addAssignment_23604,axiom,
    ! [VarCurr: state_type] :
      ( v46831(VarCurr,0)
    <=> v46892(VarCurr,0) ) ).

tff(addAssignment_23603,axiom,
    ! [VarCurr: state_type] :
      ( v46833(VarCurr)
    <=> v46359(VarCurr,2) ) ).

tff(addAssignment_23602,axiom,
    ! [VarCurr: state_type] :
      ( v46359(VarCurr,2)
    <=> v46361(VarCurr,2) ) ).

tff(addAssignment_23601,axiom,
    ! [VarCurr: state_type] :
      ( v46361(VarCurr,2)
    <=> v46371(VarCurr,2) ) ).

tff(addAssignment_23600,axiom,
    ! [VarCurr: state_type] :
      ( v46363(VarCurr,2)
    <=> v46365(VarCurr,2) ) ).

tff(addAssignment_23599,axiom,
    ! [VarCurr: state_type] :
      ( v46365(VarCurr,2)
    <=> v46368(VarCurr,2) ) ).

tff(addAssignment_23598,axiom,
    ! [VarCurr: state_type] :
      ( v46369(VarCurr)
    <=> v46836(VarCurr,1) ) ).

tff(addAssignment_23597,axiom,
    ! [VarCurr: state_type] :
      ( v46836(VarCurr,1)
    <=> v46838(VarCurr,1) ) ).

tff(addAssignment_23596,axiom,
    ! [VarCurr: state_type] :
      ( v46838(VarCurr,1)
    <=> v47046(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v47046(VarCurr,B)
      <=> ( v46840(VarCurr,B)
          | v46846(VarCurr,B) ) ) ) ).

tff(addAssignment_23595,axiom,
    ! [VarCurr: state_type] :
      ( v46846(VarCurr,1)
    <=> v46848(VarCurr,1) ) ).

tff(addAssignment_23594,axiom,
    ! [VarCurr: state_type] :
      ( v46848(VarCurr,1)
    <=> v47044(VarCurr,1) ) ).

tff(addAssignment_23593,axiom,
    ! [VarCurr: state_type] :
      ( v47044(VarCurr,0)
    <=> v47045(VarCurr) ) ).

tff(addAssignment_23592,axiom,
    ! [VarCurr: state_type] :
      ( v47044(VarCurr,1)
    <=> v46850(VarCurr) ) ).

tff(addAssignment_23591,axiom,
    ! [VarCurr: state_type] :
      ( v46850(VarCurr)
    <=> v46852(VarCurr,1) ) ).

tff(addAssignment_23590,axiom,
    ! [VarCurr: state_type] :
      ( v46852(VarCurr,1)
    <=> v46854(VarCurr,1) ) ).

tff(addAssignment_23589,axiom,
    ! [VarCurr: state_type] :
      ( v46854(VarCurr,1)
    <=> v47043(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v47043(VarCurr,B)
      <=> ( v46856(VarCurr,B)
          & v46864(VarCurr,B) ) ) ) ).

tff(addAssignment_23588,axiom,
    ! [VarCurr: state_type] :
      ( v46864(VarCurr,1)
    <=> v46866(VarCurr,1) ) ).

tff(addAssignment_23587,axiom,
    ! [VarCurr: state_type] :
      ( v46866(VarCurr,1)
    <=> v47041(VarCurr,1) ) ).

tff(addAssignment_23586,axiom,
    ! [VarCurr: state_type] :
      ( v47041(VarCurr,0)
    <=> v47042(VarCurr) ) ).

tff(addAssignment_23585,axiom,
    ! [VarCurr: state_type] :
      ( v47041(VarCurr,1)
    <=> v46868(VarCurr) ) ).

tff(addAssignment_23584,axiom,
    ! [VarCurr: state_type] :
      ( v46868(VarCurr)
    <=> v46870(VarCurr) ) ).

tff(addAssignment_23583,axiom,
    ! [VarCurr: state_type] :
      ( v46870(VarCurr)
    <=> v46872(VarCurr) ) ).

tff(writeUnaryOperator_2703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46872(VarCurr)
    <=> v47039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4407,axiom,
    ! [VarCurr: state_type] :
      ( v47039(VarCurr)
    <=> ( v47040(VarCurr)
        | v47027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4406,axiom,
    ! [VarCurr: state_type] :
      ( v47040(VarCurr)
    <=> ( v46874(VarCurr)
        | v46889(VarCurr) ) ) ).

tff(addAssignment_23582,axiom,
    ! [VarCurr: state_type] :
      ( v47027(VarCurr)
    <=> v47029(VarCurr) ) ).

tff(addAssignment_23581,axiom,
    ! [VarCurr: state_type] :
      ( v47029(VarCurr)
    <=> v46878(VarCurr,2) ) ).

tff(addAssignment_23580,axiom,
    ! [VarCurr: state_type] :
      ( v46878(VarCurr,2)
    <=> v46880(VarCurr,2) ) ).

tff(addAssignment_23579,axiom,
    ! [VarCurr: state_type] :
      ( v46880(VarCurr,2)
    <=> v46882(VarCurr,2) ) ).

tff(addAssignment_23578,axiom,
    ! [VarCurr: state_type] :
      ( v46882(VarCurr,2)
    <=> v46887(VarCurr,2) ) ).

tff(addAssignment_23577,axiom,
    ! [VarCurr: state_type] :
      ( v46884(VarCurr,2)
    <=> v46886(VarCurr,2) ) ).

tff(addAssignment_23576,axiom,
    ! [VarCurr: state_type] :
      ( v46886(VarCurr,2)
    <=> v46795(VarCurr,2) ) ).

tff(addAssignment_23575,axiom,
    ! [VarCurr: state_type] :
      ( v46795(VarCurr,2)
    <=> v46707(VarCurr,5) ) ).

tff(addAssignment_23574,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,5)
    <=> v46709(VarCurr,5) ) ).

tff(addAssignment_23573,axiom,
    ! [VarNext: state_type] :
      ( v46709(VarNext,5)
    <=> v47031(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47032(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v47031(VarNext,B)
            <=> v46709(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_547,axiom,
    ! [VarNext: state_type] :
      ( v47032(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47031(VarNext,B)
          <=> v47020(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47032(VarNext)
      <=> v47033(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47033(VarNext)
      <=> ( v47035(VarNext)
          & v46962(VarNext) ) ) ) ).

tff(writeUnaryOperator_2702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47035(VarNext)
      <=> v47014(VarNext) ) ) ).

tff(addAssignment_23572,axiom,
    ! [VarCurr: state_type] :
      ( v46819(VarCurr,5)
    <=> v46821(VarCurr,5) ) ).

tff(addAssignment_23571,axiom,
    ! [VarCurr: state_type] :
      ( v46821(VarCurr,5)
    <=> v46959(VarCurr,5) ) ).

tff(addAssignment_23570,axiom,
    ! [VarCurr: state_type] :
      ( v46823(VarCurr,2)
    <=> v46825(VarCurr,2) ) ).

tff(addAssignment_23569,axiom,
    ! [VarCurr: state_type] :
      ( v46825(VarCurr,2)
    <=> v46827(VarCurr,2) ) ).

tff(addAssignment_23568,axiom,
    ! [VarCurr: state_type] :
      ( v46827(VarCurr,2)
    <=> v46958(VarCurr,2) ) ).

tff(addAssignment_23567,axiom,
    ! [VarCurr: state_type] :
      ( v46895(VarCurr,2)
    <=> v46897(VarCurr,2) ) ).

tff(addAssignment_23566,axiom,
    ! [VarCurr: state_type] :
      ( v46897(VarCurr,2)
    <=> v46899(VarCurr,2) ) ).

tff(addAssignment_23565,axiom,
    ! [VarCurr: state_type] :
      ( v46899(VarCurr,2)
    <=> v46901(VarCurr,2) ) ).

tff(addAssignment_23564,axiom,
    ! [VarCurr: state_type] :
      ( v46901(VarCurr,2)
    <=> v46903(VarCurr,2) ) ).

tff(addAssignment_23563,axiom,
    ! [VarCurr: state_type] :
      ( v46903(VarCurr,2)
    <=> v46913(VarCurr,2) ) ).

tff(addAssignment_23562,axiom,
    ! [VarCurr: state_type] :
      ( v46905(VarCurr,2)
    <=> v46907(VarCurr,2) ) ).

tff(addAssignment_23561,axiom,
    ! [VarCurr: state_type] :
      ( v46907(VarCurr,2)
    <=> v46908(VarCurr,2) ) ).

tff(addAssignment_23560,axiom,
    ! [VarCurr: state_type] :
      ( v46829(VarCurr,2)
    <=> v46831(VarCurr,2) ) ).

tff(addAssignment_23559,axiom,
    ! [VarCurr: state_type] :
      ( v46831(VarCurr,2)
    <=> v46892(VarCurr,2) ) ).

tff(addAssignment_23558,axiom,
    ! [VarCurr: state_type] :
      ( v46889(VarCurr)
    <=> v46891(VarCurr) ) ).

tff(addAssignment_23557,axiom,
    ! [VarCurr: state_type] :
      ( v46891(VarCurr)
    <=> v46795(VarCurr,1) ) ).

tff(addAssignment_23556,axiom,
    ! [VarCurr: state_type] :
      ( v46795(VarCurr,1)
    <=> v46707(VarCurr,4) ) ).

tff(addAssignment_23555,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,4)
    <=> v46709(VarCurr,4) ) ).

tff(addAssignment_23554,axiom,
    ! [VarNext: state_type] :
      ( v46709(VarNext,4)
    <=> v47009(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47010(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v47009(VarNext,B)
            <=> v46709(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_546,axiom,
    ! [VarNext: state_type] :
      ( v47010(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47009(VarNext,B)
          <=> v47020(VarNext,B) ) ) ) ).

tff(addAssignment_23553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47020(VarNext,B)
          <=> v47018(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47018(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_363,axiom,
    ! [VarCurr: state_type] :
      ( v47021(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v47018(VarCurr,B)
          <=> v46819(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4403,axiom,
    ! [VarCurr: state_type] :
      ( v47021(VarCurr)
    <=> ( v47022(VarCurr)
        & v47023(VarCurr) ) ) ).

tff(writeUnaryOperator_2701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47023(VarCurr)
    <=> v46809(VarCurr) ) ).

tff(writeUnaryOperator_2700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v47022(VarCurr)
    <=> v46797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47010(VarNext)
      <=> v47011(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47011(VarNext)
      <=> ( v47012(VarNext)
          & v46962(VarNext) ) ) ) ).

tff(writeUnaryOperator_2699,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v47012(VarNext)
      <=> v47014(VarNext) ) ) ).

tff(addAssignment_23552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v47014(VarNext)
      <=> v46962(VarCurr) ) ) ).

tff(addAssignment_23551,axiom,
    ! [VarCurr: state_type] :
      ( v46962(VarCurr)
    <=> v46964(VarCurr) ) ).

tff(addAssignment_23550,axiom,
    ! [VarCurr: state_type] :
      ( v46964(VarCurr)
    <=> v46966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4400,axiom,
    ! [VarCurr: state_type] :
      ( v46966(VarCurr)
    <=> ( v47007(VarCurr)
        | v47003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4399,axiom,
    ! [VarCurr: state_type] :
      ( v47007(VarCurr)
    <=> ( v46968(VarCurr)
        & v46972(VarCurr) ) ) ).

tff(addAssignment_23549,axiom,
    ! [VarCurr: state_type] :
      ( v47003(VarCurr)
    <=> v47005(VarCurr) ) ).

tff(addAssignment_23548,axiom,
    ! [VarCurr: state_type] :
      ( v47005(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46987(VarNext)
       => ( v46972(VarNext)
        <=> v46972(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_545,axiom,
    ! [VarNext: state_type] :
      ( v46987(VarNext)
     => ( v46972(VarNext)
      <=> v46997(VarNext) ) ) ).

tff(addAssignment_23547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46997(VarNext)
      <=> v46995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4398,axiom,
    ! [VarCurr: state_type] :
      ( v46995(VarCurr)
    <=> ( v46998(VarCurr)
        & v46999(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4397,axiom,
    ! [VarCurr: state_type] :
      ( v46999(VarCurr)
    <=> ( v46978(VarCurr)
        | v46982(VarCurr) ) ) ).

tff(writeUnaryOperator_2698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46998(VarCurr)
    <=> v46974(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46987(VarNext)
      <=> v46988(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46988(VarNext)
      <=> ( v46990(VarNext)
          & v46992(VarNext) ) ) ) ).

tff(writeUnaryOperator_2697,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46992(VarCurr)
    <=> v46968(VarCurr) ) ).

tff(addAssignment_23546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46990(VarNext)
      <=> v46968(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_200,axiom,
    ( v46972(constB0)
  <=> $true ) ).

tff(addAssignment_23545,axiom,
    ! [VarCurr: state_type] :
      ( v46982(VarCurr)
    <=> v46984(VarCurr) ) ).

tff(addAssignment_23544,axiom,
    ! [VarCurr: state_type] :
      ( v46984(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23543,axiom,
    ! [VarCurr: state_type] :
      ( v46978(VarCurr)
    <=> v46980(VarCurr) ) ).

tff(addAssignment_23542,axiom,
    ! [VarCurr: state_type] :
      ( v46980(VarCurr)
    <=> $true ) ).

tff(addAssignment_23541,axiom,
    ! [VarCurr: state_type] :
      ( v46974(VarCurr)
    <=> v46976(VarCurr) ) ).

tff(addAssignment_23540,axiom,
    ! [VarCurr: state_type] :
      ( v46976(VarCurr)
    <=> $false ) ).

tff(addAssignment_23539,axiom,
    ! [VarCurr: state_type] :
      ( v46968(VarCurr)
    <=> v46970(VarCurr) ) ).

tff(addAssignment_23538,axiom,
    ! [VarCurr: state_type] :
      ( v46970(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23537,axiom,
    ! [VarCurr: state_type] :
      ( v46819(VarCurr,4)
    <=> v46821(VarCurr,4) ) ).

tff(addAssignment_23536,axiom,
    ! [VarCurr: state_type] :
      ( v46821(VarCurr,4)
    <=> v46959(VarCurr,4) ) ).

tff(addAssignment_23535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v46959(VarCurr,B)
      <=> v46960(VarCurr,B) ) ) ).

tff(addAssignment_23534,axiom,
    ! [VarCurr: state_type] :
      ( ( v46959(VarCurr,5)
      <=> v46823(VarCurr,2) )
      & ( v46959(VarCurr,4)
      <=> v46823(VarCurr,1) )
      & ( v46959(VarCurr,3)
      <=> v46823(VarCurr,0) ) ) ).

tff(addAssignment_23533,axiom,
    ! [VarCurr: state_type] :
      ( v46823(VarCurr,1)
    <=> v46825(VarCurr,1) ) ).

tff(addAssignment_23532,axiom,
    ! [VarCurr: state_type] :
      ( v46825(VarCurr,1)
    <=> v46827(VarCurr,1) ) ).

tff(addAssignment_23531,axiom,
    ! [VarCurr: state_type] :
      ( v46827(VarCurr,1)
    <=> v46958(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_753,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v46958(VarCurr,B)
      <=> ( v46829(VarCurr,B)
          & v46895(VarCurr,B) ) ) ) ).

tff(addAssignment_23530,axiom,
    ! [VarCurr: state_type] :
      ( v46895(VarCurr,1)
    <=> v46897(VarCurr,1) ) ).

tff(addAssignment_23529,axiom,
    ! [VarCurr: state_type] :
      ( v46897(VarCurr,1)
    <=> v46899(VarCurr,1) ) ).

tff(addAssignment_23528,axiom,
    ! [VarCurr: state_type] :
      ( v46899(VarCurr,1)
    <=> v46901(VarCurr,1) ) ).

tff(addAssignment_23527,axiom,
    ! [VarCurr: state_type] :
      ( v46901(VarCurr,1)
    <=> v46903(VarCurr,1) ) ).

tff(addAssignment_23526,axiom,
    ! [VarCurr: state_type] :
      ( v46903(VarCurr,1)
    <=> v46913(VarCurr,1) ) ).

tff(addAssignment_23525,axiom,
    ! [VarCurr: state_type] :
      ( v46913(VarCurr,0)
    <=> v46953(VarCurr) ) ).

tff(addAssignment_23524,axiom,
    ! [VarCurr: state_type] :
      ( v46913(VarCurr,1)
    <=> v46948(VarCurr) ) ).

tff(addAssignment_23523,axiom,
    ! [VarCurr: state_type] :
      ( v46913(VarCurr,2)
    <=> v46943(VarCurr) ) ).

tff(addAssignment_23522,axiom,
    ! [VarCurr: state_type] :
      ( v46913(VarCurr,3)
    <=> v46915(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4394,axiom,
    ! [VarCurr: state_type] :
      ( v46953(VarCurr)
    <=> ( v46954(VarCurr)
        & v46957(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4393,axiom,
    ! [VarCurr: state_type] :
      ( v46957(VarCurr)
    <=> ( v46905(VarCurr,0)
        | v46923(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4392,axiom,
    ! [VarCurr: state_type] :
      ( v46954(VarCurr)
    <=> ( v46955(VarCurr)
        | v46956(VarCurr) ) ) ).

tff(writeUnaryOperator_2696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46956(VarCurr)
    <=> v46923(VarCurr,0) ) ).

tff(writeUnaryOperator_2695,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46955(VarCurr)
    <=> v46905(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4391,axiom,
    ! [VarCurr: state_type] :
      ( v46948(VarCurr)
    <=> ( v46949(VarCurr)
        & v46952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4390,axiom,
    ! [VarCurr: state_type] :
      ( v46952(VarCurr)
    <=> ( v46922(VarCurr)
        | v46924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4389,axiom,
    ! [VarCurr: state_type] :
      ( v46949(VarCurr)
    <=> ( v46950(VarCurr)
        | v46951(VarCurr) ) ) ).

tff(writeUnaryOperator_2694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46951(VarCurr)
    <=> v46924(VarCurr) ) ).

tff(writeUnaryOperator_2693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46950(VarCurr)
    <=> v46922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4388,axiom,
    ! [VarCurr: state_type] :
      ( v46943(VarCurr)
    <=> ( v46944(VarCurr)
        & v46947(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4387,axiom,
    ! [VarCurr: state_type] :
      ( v46947(VarCurr)
    <=> ( v46920(VarCurr)
        | v46930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4386,axiom,
    ! [VarCurr: state_type] :
      ( v46944(VarCurr)
    <=> ( v46945(VarCurr)
        | v46946(VarCurr) ) ) ).

tff(writeUnaryOperator_2692,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46946(VarCurr)
    <=> v46930(VarCurr) ) ).

tff(writeUnaryOperator_2691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46945(VarCurr)
    <=> v46920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4385,axiom,
    ! [VarCurr: state_type] :
      ( v46915(VarCurr)
    <=> ( v46916(VarCurr)
        & v46942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4384,axiom,
    ! [VarCurr: state_type] :
      ( v46942(VarCurr)
    <=> ( v46918(VarCurr)
        | v46937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4383,axiom,
    ! [VarCurr: state_type] :
      ( v46916(VarCurr)
    <=> ( v46917(VarCurr)
        | v46936(VarCurr) ) ) ).

tff(writeUnaryOperator_2690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46936(VarCurr)
    <=> v46937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4382,axiom,
    ! [VarCurr: state_type] :
      ( v46937(VarCurr)
    <=> ( v46938(VarCurr)
        & v46941(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_538,axiom,
    ! [VarCurr: state_type] :
      ( v46941(VarCurr)
    <=> ( v46905(VarCurr,3)
        | v46923(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4381,axiom,
    ! [VarCurr: state_type] :
      ( v46938(VarCurr)
    <=> ( v46939(VarCurr)
        | v46940(VarCurr) ) ) ).

tff(writeUnaryOperator_2689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46940(VarCurr)
    <=> v46923(VarCurr,3) ) ).

tff(writeUnaryOperator_2688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46939(VarCurr)
    <=> v46905(VarCurr,3) ) ).

tff(writeUnaryOperator_2687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46917(VarCurr)
    <=> v46918(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4380,axiom,
    ! [VarCurr: state_type] :
      ( v46918(VarCurr)
    <=> ( v46919(VarCurr)
        | v46935(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_537,axiom,
    ! [VarCurr: state_type] :
      ( v46935(VarCurr)
    <=> ( v46905(VarCurr,2)
        & v46923(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4379,axiom,
    ! [VarCurr: state_type] :
      ( v46919(VarCurr)
    <=> ( v46920(VarCurr)
        & v46930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4378,axiom,
    ! [VarCurr: state_type] :
      ( v46930(VarCurr)
    <=> ( v46931(VarCurr)
        & v46934(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_536,axiom,
    ! [VarCurr: state_type] :
      ( v46934(VarCurr)
    <=> ( v46905(VarCurr,2)
        | v46923(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4377,axiom,
    ! [VarCurr: state_type] :
      ( v46931(VarCurr)
    <=> ( v46932(VarCurr)
        | v46933(VarCurr) ) ) ).

tff(writeUnaryOperator_2686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46933(VarCurr)
    <=> v46923(VarCurr,2) ) ).

tff(writeUnaryOperator_2685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46932(VarCurr)
    <=> v46905(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4376,axiom,
    ! [VarCurr: state_type] :
      ( v46920(VarCurr)
    <=> ( v46921(VarCurr)
        | v46929(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_535,axiom,
    ! [VarCurr: state_type] :
      ( v46929(VarCurr)
    <=> ( v46905(VarCurr,1)
        & v46923(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4375,axiom,
    ! [VarCurr: state_type] :
      ( v46921(VarCurr)
    <=> ( v46922(VarCurr)
        & v46924(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4374,axiom,
    ! [VarCurr: state_type] :
      ( v46924(VarCurr)
    <=> ( v46925(VarCurr)
        & v46928(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_534,axiom,
    ! [VarCurr: state_type] :
      ( v46928(VarCurr)
    <=> ( v46905(VarCurr,1)
        | v46923(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4373,axiom,
    ! [VarCurr: state_type] :
      ( v46925(VarCurr)
    <=> ( v46926(VarCurr)
        | v46927(VarCurr) ) ) ).

tff(writeUnaryOperator_2684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46927(VarCurr)
    <=> v46923(VarCurr,1) ) ).

tff(writeUnaryOperator_2683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46926(VarCurr)
    <=> v46905(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4372,axiom,
    ! [VarCurr: state_type] :
      ( v46922(VarCurr)
    <=> ( v46905(VarCurr,0)
        & v46923(VarCurr,0) ) ) ).

tff(addAssignment_23521,axiom,
    ! [VarCurr: state_type] :
      ( v46923(VarCurr,0)
    <=> v46910(VarCurr) ) ).

tff(addAssignment_23520,axiom,
    ! [VarCurr: state_type] :
      ( ( v46923(VarCurr,3)
      <=> $false )
      & ( v46923(VarCurr,2)
      <=> $false )
      & ( v46923(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_23519,axiom,
    ! [VarCurr: state_type] :
      ( v46910(VarCurr)
    <=> v46912(VarCurr) ) ).

tff(addAssignment_23518,axiom,
    ! [VarCurr: state_type] :
      ( v46912(VarCurr)
    <=> v46860(VarCurr) ) ).

tff(addAssignment_23517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v46905(VarCurr,B)
      <=> v46907(VarCurr,B) ) ) ).

tff(addAssignment_23516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v46907(VarCurr,B)
      <=> v46908(VarCurr,B) ) ) ).

tff(addAssignment_23515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v46908(VarCurr,B)
      <=> v46795(VarCurr,B) ) ) ).

tff(addAssignment_23514,axiom,
    ! [VarCurr: state_type] :
      ( v46908(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_23513,axiom,
    ! [VarCurr: state_type] :
      ( v46829(VarCurr,1)
    <=> v46831(VarCurr,1) ) ).

tff(addAssignment_23512,axiom,
    ! [VarCurr: state_type] :
      ( v46831(VarCurr,1)
    <=> v46892(VarCurr,1) ) ).

tff(addAssignment_23511,axiom,
    ! [VarCurr: state_type] :
      ( v46892(VarCurr,0)
    <=> v46893(VarCurr) ) ).

tff(addAssignment_23510,axiom,
    ! [VarCurr: state_type] :
      ( v46892(VarCurr,1)
    <=> v46893(VarCurr) ) ).

tff(addAssignment_23509,axiom,
    ! [VarCurr: state_type] :
      ( v46892(VarCurr,2)
    <=> v46893(VarCurr) ) ).

tff(addAssignment_23508,axiom,
    ! [VarCurr: state_type] :
      ( v46893(VarCurr)
    <=> v46833(VarCurr) ) ).

tff(addAssignment_23507,axiom,
    ! [VarCurr: state_type] :
      ( v46874(VarCurr)
    <=> v46876(VarCurr) ) ).

tff(addAssignment_23506,axiom,
    ! [VarCurr: state_type] :
      ( v46876(VarCurr)
    <=> v46878(VarCurr,0) ) ).

tff(addAssignment_23505,axiom,
    ! [VarCurr: state_type] :
      ( v46878(VarCurr,0)
    <=> v46880(VarCurr,0) ) ).

tff(addAssignment_23504,axiom,
    ! [VarCurr: state_type] :
      ( v46880(VarCurr,0)
    <=> v46882(VarCurr,0) ) ).

tff(addAssignment_23503,axiom,
    ! [VarCurr: state_type] :
      ( v46882(VarCurr,0)
    <=> v46887(VarCurr,0) ) ).

tff(writeUnaryOperator_2682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v46887(VarCurr,B)
      <=> ~ v46884(VarCurr,B) ) ) ).

tff(addAssignment_23502,axiom,
    ! [VarCurr: state_type] :
      ( v46884(VarCurr,0)
    <=> v46886(VarCurr,0) ) ).

tff(addAssignment_23501,axiom,
    ! [VarCurr: state_type] :
      ( v46886(VarCurr,0)
    <=> v46795(VarCurr,0) ) ).

tff(addAssignment_23500,axiom,
    ! [VarCurr: state_type] :
      ( v46856(VarCurr,1)
    <=> v46858(VarCurr,1) ) ).

tff(addAssignment_23499,axiom,
    ! [VarCurr: state_type] :
      ( v46858(VarCurr,1)
    <=> v46861(VarCurr,1) ) ).

tff(addAssignment_23498,axiom,
    ! [VarCurr: state_type] :
      ( v46861(VarCurr,0)
    <=> v46862(VarCurr) ) ).

tff(addAssignment_23497,axiom,
    ! [VarCurr: state_type] :
      ( v46861(VarCurr,1)
    <=> v46860(VarCurr) ) ).

tff(addAssignment_23496,axiom,
    ! [VarCurr: state_type] :
      ( v46860(VarCurr)
    <=> v7230(VarCurr,10) ) ).

tff(addAssignment_23495,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,10)
    <=> v7232(VarCurr,10) ) ).

tff(addAssignment_23494,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,10)
    <=> v7234(VarCurr,10) ) ).

tff(addAssignment_23493,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,10)
    <=> v34455(VarCurr,10) ) ).

tff(addAssignment_23492,axiom,
    ! [VarCurr: state_type] :
      ( v46840(VarCurr,1)
    <=> v46842(VarCurr,1) ) ).

tff(addAssignment_23491,axiom,
    ! [VarCurr: state_type] :
      ( v46842(VarCurr,1)
    <=> v46843(VarCurr,1) ) ).

tff(addAssignment_23490,axiom,
    ! [VarCurr: state_type] :
      ( v46843(VarCurr,0)
    <=> v46844(VarCurr) ) ).

tff(addAssignment_23489,axiom,
    ! [VarCurr: state_type] :
      ( v46843(VarCurr,1)
    <=> v46844(VarCurr) ) ).

tff(addAssignment_23488,axiom,
    ! [VarCurr: state_type] :
      ( v46844(VarCurr)
    <=> v46367(VarCurr) ) ).

tff(addAssignment_23487,axiom,
    ! [VarCurr: state_type] :
      ( v46809(VarCurr)
    <=> v46811(VarCurr) ) ).

tff(addAssignment_23486,axiom,
    ! [VarCurr: state_type] :
      ( v46811(VarCurr)
    <=> v46813(VarCurr) ) ).

tff(addAssignment_23485,axiom,
    ! [VarCurr: state_type] :
      ( v46813(VarCurr)
    <=> v46815(VarCurr) ) ).

tff(addAssignment_23484,axiom,
    ! [VarCurr: state_type] :
      ( v46815(VarCurr)
    <=> v46817(VarCurr) ) ).

tff(addAssignment_23483,axiom,
    ! [VarCurr: state_type] :
      ( v46817(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23482,axiom,
    ! [VarCurr: state_type] :
      ( v46797(VarCurr)
    <=> v46799(VarCurr) ) ).

tff(addAssignment_23481,axiom,
    ! [VarCurr: state_type] :
      ( v46799(VarCurr)
    <=> v46801(VarCurr) ) ).

tff(addAssignment_23480,axiom,
    ! [VarCurr: state_type] :
      ( v46801(VarCurr)
    <=> v46803(VarCurr) ) ).

tff(addAssignment_23479,axiom,
    ! [VarCurr: state_type] :
      ( v46803(VarCurr)
    <=> v46805(VarCurr) ) ).

tff(addAssignment_23478,axiom,
    ! [VarCurr: state_type] :
      ( v46805(VarCurr)
    <=> v46807(VarCurr) ) ).

tff(addAssignment_23477,axiom,
    ! [VarCurr: state_type] :
      ( v46807(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_23476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46305(VarCurr,B)
      <=> v46307(VarCurr,B) ) ) ).

tff(addAssignment_23475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46307(VarCurr,B)
      <=> v46309(VarCurr,B) ) ) ).

tff(addAssignment_23474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46309(VarCurr,B)
      <=> v46311(VarCurr,B) ) ) ).

tff(addAssignment_23473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46311(VarCurr,B)
      <=> v46313(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46758(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v46313(VarNext,B)
            <=> v46313(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_544,axiom,
    ! [VarNext: state_type] :
      ( v46758(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46313(VarNext,B)
          <=> v46768(VarNext,B) ) ) ) ).

tff(addAssignment_23472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46768(VarNext,B)
          <=> v46766(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46766(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_362,axiom,
    ! [VarCurr: state_type] :
      ( v46769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46766(VarCurr,B)
          <=> v46343(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4371,axiom,
    ! [VarCurr: state_type] :
      ( v46769(VarCurr)
    <=> ( v46770(VarCurr)
        & v46771(VarCurr) ) ) ).

tff(writeUnaryOperator_2681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46771(VarCurr)
    <=> v46329(VarCurr) ) ).

tff(writeUnaryOperator_2680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46770(VarCurr)
    <=> v46315(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46758(VarNext)
      <=> v46759(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46759(VarNext)
      <=> ( v46760(VarNext)
          & v46673(VarNext) ) ) ) ).

tff(writeUnaryOperator_2679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46760(VarNext)
      <=> v46762(VarNext) ) ) ).

tff(addAssignment_23471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46762(VarNext)
      <=> v46673(VarCurr) ) ) ).

tff(addAssignment_23470,axiom,
    ! [VarCurr: state_type] :
      ( v46673(VarCurr)
    <=> v46675(VarCurr) ) ).

tff(addAssignment_23469,axiom,
    ! [VarCurr: state_type] :
      ( v46675(VarCurr)
    <=> v46677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4368,axiom,
    ! [VarCurr: state_type] :
      ( v46677(VarCurr)
    <=> ( v46755(VarCurr)
        | v46747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4367,axiom,
    ! [VarCurr: state_type] :
      ( v46755(VarCurr)
    <=> ( v46679(VarCurr)
        & v46685(VarCurr) ) ) ).

tff(addAssignment_23468,axiom,
    ! [VarCurr: state_type] :
      ( v46747(VarCurr)
    <=> v46749(VarCurr) ) ).

tff(addAssignment_23467,axiom,
    ! [VarCurr: state_type] :
      ( v46749(VarCurr)
    <=> v46751(VarCurr) ) ).

tff(addAssignment_23466,axiom,
    ! [VarCurr: state_type] :
      ( v46751(VarCurr)
    <=> v46753(VarCurr) ) ).

tff(addAssignment_23465,axiom,
    ! [VarCurr: state_type] :
      ( v46753(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46731(VarNext)
       => ( v46685(VarNext)
        <=> v46685(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_543,axiom,
    ! [VarNext: state_type] :
      ( v46731(VarNext)
     => ( v46685(VarNext)
      <=> v46741(VarNext) ) ) ).

tff(addAssignment_23464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46741(VarNext)
      <=> v46739(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4366,axiom,
    ! [VarCurr: state_type] :
      ( v46739(VarCurr)
    <=> ( v46742(VarCurr)
        & v46743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4365,axiom,
    ! [VarCurr: state_type] :
      ( v46743(VarCurr)
    <=> ( v46691(VarCurr)
        | v46722(VarCurr) ) ) ).

tff(writeUnaryOperator_2678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46742(VarCurr)
    <=> v46687(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46731(VarNext)
      <=> v46732(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46732(VarNext)
      <=> ( v46734(VarNext)
          & v46736(VarNext) ) ) ) ).

tff(writeUnaryOperator_2677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46736(VarCurr)
    <=> v46679(VarCurr) ) ).

tff(addAssignment_23463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46734(VarNext)
      <=> v46679(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_199,axiom,
    ( v46685(constB0)
  <=> $true ) ).

tff(addAssignment_23462,axiom,
    ! [VarCurr: state_type] :
      ( v46722(VarCurr)
    <=> v46724(VarCurr) ) ).

tff(addAssignment_23461,axiom,
    ! [VarCurr: state_type] :
      ( v46724(VarCurr)
    <=> v46726(VarCurr) ) ).

tff(addAssignment_23460,axiom,
    ! [VarCurr: state_type] :
      ( v46726(VarCurr)
    <=> v46728(VarCurr) ) ).

tff(addAssignment_23459,axiom,
    ! [VarCurr: state_type] :
      ( v46728(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_23458,axiom,
    ! [VarCurr: state_type] :
      ( v46691(VarCurr)
    <=> v46693(VarCurr) ) ).

tff(addAssignment_23457,axiom,
    ! [VarCurr: state_type] :
      ( v46693(VarCurr)
    <=> v46695(VarCurr) ) ).

tff(addAssignment_23456,axiom,
    ! [VarCurr: state_type] :
      ( v46695(VarCurr)
    <=> v46697(VarCurr) ) ).

tff(addAssignment_23455,axiom,
    ! [VarCurr: state_type] :
      ( v46697(VarCurr)
    <=> v46699(VarCurr) ) ).

tff(writeUnaryOperator_2676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46699(VarCurr)
    <=> v46719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4362,axiom,
    ! [VarCurr: state_type] :
      ( v46719(VarCurr)
    <=> ( v46720(VarCurr)
        | v46715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4361,axiom,
    ! [VarCurr: state_type] :
      ( v46720(VarCurr)
    <=> ( v46701(VarCurr)
        | v46711(VarCurr) ) ) ).

tff(addAssignment_23454,axiom,
    ! [VarCurr: state_type] :
      ( v46715(VarCurr)
    <=> v46717(VarCurr) ) ).

tff(addAssignment_23453,axiom,
    ! [VarCurr: state_type] :
      ( v46717(VarCurr)
    <=> v46705(VarCurr,2) ) ).

tff(addAssignment_23452,axiom,
    ! [VarCurr: state_type] :
      ( v46705(VarCurr,2)
    <=> v46707(VarCurr,2) ) ).

tff(addAssignment_23451,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,2)
    <=> v46709(VarCurr,2) ) ).

tff(addAssignment_23450,axiom,
    ! [VarCurr: state_type] :
      ( v46711(VarCurr)
    <=> v46713(VarCurr) ) ).

tff(addAssignment_23449,axiom,
    ! [VarCurr: state_type] :
      ( v46713(VarCurr)
    <=> v46705(VarCurr,1) ) ).

tff(addAssignment_23448,axiom,
    ! [VarCurr: state_type] :
      ( v46705(VarCurr,1)
    <=> v46707(VarCurr,1) ) ).

tff(addAssignment_23447,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,1)
    <=> v46709(VarCurr,1) ) ).

tff(addAssignment_23446,axiom,
    ! [VarCurr: state_type] :
      ( v46701(VarCurr)
    <=> v46703(VarCurr) ) ).

tff(addAssignment_23445,axiom,
    ! [VarCurr: state_type] :
      ( v46703(VarCurr)
    <=> v46705(VarCurr,0) ) ).

tff(addAssignment_23444,axiom,
    ! [VarCurr: state_type] :
      ( v46705(VarCurr,0)
    <=> v46707(VarCurr,0) ) ).

tff(addAssignment_23443,axiom,
    ! [VarCurr: state_type] :
      ( v46707(VarCurr,0)
    <=> v46709(VarCurr,0) ) ).

tff(addAssignment_23442,axiom,
    ! [VarCurr: state_type] :
      ( v46687(VarCurr)
    <=> v46689(VarCurr) ) ).

tff(addAssignment_23441,axiom,
    ! [VarCurr: state_type] :
      ( v46689(VarCurr)
    <=> $false ) ).

tff(addAssignment_23440,axiom,
    ! [VarCurr: state_type] :
      ( v46679(VarCurr)
    <=> v46681(VarCurr) ) ).

tff(addAssignment_23439,axiom,
    ! [VarCurr: state_type] :
      ( v46681(VarCurr)
    <=> v46683(VarCurr) ) ).

tff(addAssignment_23438,axiom,
    ! [VarCurr: state_type] :
      ( v46683(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_23437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46343(VarCurr,B)
      <=> v46345(VarCurr,B) ) ) ).

tff(addAssignment_23436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46345(VarCurr,B)
      <=> v46347(VarCurr,B) ) ) ).

tff(addAssignment_23435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46347(VarCurr,B)
      <=> v46349(VarCurr,B) ) ) ).

tff(addAssignment_23434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46349(VarCurr,B)
      <=> v46351(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_752,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46351(VarCurr,B)
      <=> ( v46353(VarCurr,B)
          & v46375(VarCurr,B) ) ) ) ).

tff(addAssignment_23433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46375(VarCurr,B)
      <=> v46377(VarCurr,B) ) ) ).

tff(addAssignment_23432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46377(VarCurr,B)
      <=> v46379(VarCurr,B) ) ) ).

tff(addAssignment_23431,axiom,
    ! [VarCurr: state_type] :
      ( ( v46379(VarCurr,11)
      <=> v6324(VarCurr,131) )
      & ( v46379(VarCurr,10)
      <=> v6324(VarCurr,130) )
      & ( v46379(VarCurr,9)
      <=> v6324(VarCurr,129) )
      & ( v46379(VarCurr,8)
      <=> v6324(VarCurr,128) )
      & ( v46379(VarCurr,7)
      <=> v6324(VarCurr,127) )
      & ( v46379(VarCurr,6)
      <=> v6324(VarCurr,126) )
      & ( v46379(VarCurr,5)
      <=> v6324(VarCurr,125) )
      & ( v46379(VarCurr,4)
      <=> v6324(VarCurr,124) )
      & ( v46379(VarCurr,3)
      <=> v6324(VarCurr,123) )
      & ( v46379(VarCurr,2)
      <=> v6324(VarCurr,122) )
      & ( v46379(VarCurr,1)
      <=> v6324(VarCurr,121) )
      & ( v46379(VarCurr,0)
      <=> v6324(VarCurr,120) ) ) ).

tff(addAssignment_23430,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,131)
      <=> v46381(VarCurr,11) )
      & ( v6324(VarCurr,130)
      <=> v46381(VarCurr,10) )
      & ( v6324(VarCurr,129)
      <=> v46381(VarCurr,9) )
      & ( v6324(VarCurr,128)
      <=> v46381(VarCurr,8) )
      & ( v6324(VarCurr,127)
      <=> v46381(VarCurr,7) )
      & ( v6324(VarCurr,126)
      <=> v46381(VarCurr,6) )
      & ( v6324(VarCurr,125)
      <=> v46381(VarCurr,5) )
      & ( v6324(VarCurr,124)
      <=> v46381(VarCurr,4) )
      & ( v6324(VarCurr,123)
      <=> v46381(VarCurr,3) )
      & ( v6324(VarCurr,122)
      <=> v46381(VarCurr,2) )
      & ( v6324(VarCurr,121)
      <=> v46381(VarCurr,1) )
      & ( v6324(VarCurr,120)
      <=> v46381(VarCurr,0) ) ) ).

tff(addAssignment_23429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46381(VarCurr,B)
      <=> v46383(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46383(VarCurr,B)
      <=> ( v46665(VarCurr,B)
          | v46668(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46668(VarCurr,B)
      <=> ( v46393(VarCurr,B)
          & v46669(VarCurr,B) ) ) ) ).

tff(addAssignment_23428,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,0)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23427,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,1)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23426,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,2)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23425,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,3)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23424,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,4)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23423,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,5)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23422,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,6)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23421,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,7)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23420,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,8)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23419,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,9)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23418,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,10)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23417,axiom,
    ! [VarCurr: state_type] :
      ( v46669(VarCurr,11)
    <=> v46670(VarCurr) ) ).

tff(addAssignment_23416,axiom,
    ! [VarCurr: state_type] :
      ( v46670(VarCurr)
    <=> v46661(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46665(VarCurr,B)
      <=> ( v46385(VarCurr,B)
          & v46666(VarCurr,B) ) ) ) ).

tff(addAssignment_23415,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,0)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23414,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,1)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23413,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,2)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23412,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,3)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23411,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,4)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23410,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,5)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23409,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,6)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23408,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,7)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23407,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,8)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23406,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,9)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23405,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,10)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23404,axiom,
    ! [VarCurr: state_type] :
      ( v46666(VarCurr,11)
    <=> v46667(VarCurr) ) ).

tff(addAssignment_23403,axiom,
    ! [VarCurr: state_type] :
      ( v46667(VarCurr)
    <=> v46389(VarCurr) ) ).

tff(addAssignment_23402,axiom,
    ! [VarCurr: state_type] :
      ( v46661(VarCurr)
    <=> v46663(VarCurr) ) ).

tff(addAssignment_23401,axiom,
    ! [VarCurr: state_type] :
      ( v46663(VarCurr)
    <=> v7021(VarCurr,10) ) ).

tff(addAssignment_23400,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,10)
    <=> v7023(VarCurr,10) ) ).

tff(addAssignment_23399,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,10)
    <=> v6623(VarCurr,10) ) ).

tff(addAssignment_23398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46393(VarCurr,B)
      <=> v46395(VarCurr,B) ) ) ).

tff(addAssignment_23397,axiom,
    ! [VarCurr: state_type] :
      ( ( v46395(VarCurr,11)
      <=> v6334(VarCurr,143) )
      & ( v46395(VarCurr,10)
      <=> v6334(VarCurr,142) )
      & ( v46395(VarCurr,9)
      <=> v6334(VarCurr,141) )
      & ( v46395(VarCurr,8)
      <=> v6334(VarCurr,140) )
      & ( v46395(VarCurr,7)
      <=> v6334(VarCurr,139) )
      & ( v46395(VarCurr,6)
      <=> v6334(VarCurr,138) )
      & ( v46395(VarCurr,5)
      <=> v6334(VarCurr,137) )
      & ( v46395(VarCurr,4)
      <=> v6334(VarCurr,136) )
      & ( v46395(VarCurr,3)
      <=> v6334(VarCurr,135) )
      & ( v46395(VarCurr,2)
      <=> v6334(VarCurr,134) )
      & ( v46395(VarCurr,1)
      <=> v6334(VarCurr,133) )
      & ( v46395(VarCurr,0)
      <=> v6334(VarCurr,132) ) ) ).

tff(addAssignment_23396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,144)
        & ~ $less(B,132) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_23395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,144)
        & ~ $less(B,132) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_23394,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,143)
      <=> v46397(VarCurr,11) )
      & ( v6338(VarCurr,142)
      <=> v46397(VarCurr,10) )
      & ( v6338(VarCurr,141)
      <=> v46397(VarCurr,9) )
      & ( v6338(VarCurr,140)
      <=> v46397(VarCurr,8) )
      & ( v6338(VarCurr,139)
      <=> v46397(VarCurr,7) )
      & ( v6338(VarCurr,138)
      <=> v46397(VarCurr,6) )
      & ( v6338(VarCurr,137)
      <=> v46397(VarCurr,5) )
      & ( v6338(VarCurr,136)
      <=> v46397(VarCurr,4) )
      & ( v6338(VarCurr,135)
      <=> v46397(VarCurr,3) )
      & ( v6338(VarCurr,134)
      <=> v46397(VarCurr,2) )
      & ( v6338(VarCurr,133)
      <=> v46397(VarCurr,1) )
      & ( v6338(VarCurr,132)
      <=> v46397(VarCurr,0) ) ) ).

tff(addAssignment_23393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46397(VarCurr,B)
      <=> v46399(VarCurr,B) ) ) ).

tff(addAssignment_23392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46399(VarCurr,B)
      <=> v46401(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_542,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46644(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v46401(VarNext,B)
            <=> v46401(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_542,axiom,
    ! [VarNext: state_type] :
      ( v46644(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46401(VarNext,B)
          <=> v46654(VarNext,B) ) ) ) ).

tff(addAssignment_23391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46654(VarNext,B)
          <=> v46652(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46655(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46652(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_361,axiom,
    ! [VarCurr: state_type] :
      ( v46655(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46652(VarCurr,B)
          <=> v46431(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4360,axiom,
    ! [VarCurr: state_type] :
      ( v46655(VarCurr)
    <=> ( v46656(VarCurr)
        & v46657(VarCurr) ) ) ).

tff(writeUnaryOperator_2675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46657(VarCurr)
    <=> v46417(VarCurr) ) ).

tff(writeUnaryOperator_2674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46656(VarCurr)
    <=> v46403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46644(VarNext)
      <=> v46645(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46645(VarNext)
      <=> ( v46646(VarNext)
          & v46619(VarNext) ) ) ) ).

tff(writeUnaryOperator_2673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46646(VarNext)
      <=> v46648(VarNext) ) ) ).

tff(addAssignment_23390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46648(VarNext)
      <=> v46619(VarCurr) ) ) ).

tff(addAssignment_23389,axiom,
    ! [VarCurr: state_type] :
      ( v46619(VarCurr)
    <=> v46621(VarCurr) ) ).

tff(addAssignment_23388,axiom,
    ! [VarCurr: state_type] :
      ( v46621(VarCurr)
    <=> v46623(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4357,axiom,
    ! [VarCurr: state_type] :
      ( v46623(VarCurr)
    <=> ( v46641(VarCurr)
        | v46633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4356,axiom,
    ! [VarCurr: state_type] :
      ( v46641(VarCurr)
    <=> ( v46625(VarCurr)
        & v46631(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_198,axiom,
    ( v46631(constB0)
  <=> $true ) ).

tff(addAssignment_23387,axiom,
    ! [VarCurr: state_type] :
      ( v46633(VarCurr)
    <=> v46635(VarCurr) ) ).

tff(addAssignment_23386,axiom,
    ! [VarCurr: state_type] :
      ( v46635(VarCurr)
    <=> v46637(VarCurr) ) ).

tff(addAssignment_23385,axiom,
    ! [VarCurr: state_type] :
      ( v46637(VarCurr)
    <=> v46639(VarCurr) ) ).

tff(addAssignment_23384,axiom,
    ! [VarCurr: state_type] :
      ( v46639(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_23383,axiom,
    ! [VarCurr: state_type] :
      ( v46625(VarCurr)
    <=> v46627(VarCurr) ) ).

tff(addAssignment_23382,axiom,
    ! [VarCurr: state_type] :
      ( v46627(VarCurr)
    <=> v46629(VarCurr) ) ).

tff(addAssignment_23381,axiom,
    ! [VarCurr: state_type] :
      ( v46629(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_23380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46431(VarCurr,B)
      <=> v46433(VarCurr,B) ) ) ).

tff(addAssignment_23379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46433(VarCurr,B)
      <=> v46435(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46435(VarCurr,B)
      <=> ( v46604(VarCurr,B)
          | v46615(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46615(VarCurr,B)
      <=> ( v46568(VarCurr,B)
          & v46616(VarCurr,B) ) ) ) ).

tff(addAssignment_23378,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,0)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23377,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,1)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23376,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,2)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23375,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,3)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23374,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,4)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23373,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,5)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23372,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,6)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23371,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,7)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23370,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,8)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23369,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,9)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23368,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,10)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23367,axiom,
    ! [VarCurr: state_type] :
      ( v46616(VarCurr,11)
    <=> v46617(VarCurr) ) ).

tff(addAssignment_23366,axiom,
    ! [VarCurr: state_type] :
      ( v46617(VarCurr)
    <=> v46578(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46604(VarCurr,B)
      <=> ( v46605(VarCurr,B)
          | v46612(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46612(VarCurr,B)
      <=> ( v46532(VarCurr,B)
          & v46613(VarCurr,B) ) ) ) ).

tff(addAssignment_23365,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,0)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23364,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,1)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23363,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,2)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23362,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,3)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23361,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,4)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23360,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,5)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23359,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,6)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23358,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,7)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23357,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,8)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23356,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,9)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23355,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,10)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23354,axiom,
    ! [VarCurr: state_type] :
      ( v46613(VarCurr,11)
    <=> v46614(VarCurr) ) ).

tff(addAssignment_23353,axiom,
    ! [VarCurr: state_type] :
      ( v46614(VarCurr)
    <=> v46542(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46605(VarCurr,B)
      <=> ( v46606(VarCurr,B)
          | v46609(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46609(VarCurr,B)
      <=> ( v46485(VarCurr,B)
          & v46610(VarCurr,B) ) ) ) ).

tff(addAssignment_23352,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,0)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23351,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,1)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23350,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,2)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23349,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,3)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23348,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,4)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23347,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,5)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23346,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,6)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23345,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,7)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23344,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,8)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23343,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,9)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23342,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,10)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23341,axiom,
    ! [VarCurr: state_type] :
      ( v46610(VarCurr,11)
    <=> v46611(VarCurr) ) ).

tff(addAssignment_23340,axiom,
    ! [VarCurr: state_type] :
      ( v46611(VarCurr)
    <=> v46495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46606(VarCurr,B)
      <=> ( v46437(VarCurr,B)
          & v46607(VarCurr,B) ) ) ) ).

tff(addAssignment_23339,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,0)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23338,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,1)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23337,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,2)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23336,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,3)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23335,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,4)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23334,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,5)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23333,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,6)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23332,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,7)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23331,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,8)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23330,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,9)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23329,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,10)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23328,axiom,
    ! [VarCurr: state_type] :
      ( v46607(VarCurr,11)
    <=> v46608(VarCurr) ) ).

tff(addAssignment_23327,axiom,
    ! [VarCurr: state_type] :
      ( v46608(VarCurr)
    <=> v46447(VarCurr) ) ).

tff(addAssignment_23326,axiom,
    ! [VarCurr: state_type] :
      ( v46578(VarCurr)
    <=> v46580(VarCurr) ) ).

tff(addAssignment_23325,axiom,
    ! [VarCurr: state_type] :
      ( v46580(VarCurr)
    <=> v46582(VarCurr) ) ).

tff(addAssignment_23324,axiom,
    ! [VarCurr: state_type] :
      ( v46582(VarCurr)
    <=> v46584(VarCurr) ) ).

tff(addAssignment_23323,axiom,
    ! [VarCurr: state_type] :
      ( v46584(VarCurr)
    <=> v46586(VarCurr) ) ).

tff(addAssignment_23322,axiom,
    ! [VarCurr: state_type] :
      ( v46586(VarCurr)
    <=> v46588(VarCurr) ) ).

tff(addAssignment_23321,axiom,
    ! [VarCurr: state_type] :
      ( v46588(VarCurr)
    <=> v46590(VarCurr) ) ).

tff(addAssignment_23320,axiom,
    ! [VarCurr: state_type] :
      ( v46590(VarCurr)
    <=> v46592(VarCurr) ) ).

tff(writeUnaryOperator_2672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46592(VarCurr)
    <=> v46602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4355,axiom,
    ! [VarCurr: state_type] :
      ( v46602(VarCurr)
    <=> ( v46594(VarCurr)
        | v46598(VarCurr) ) ) ).

tff(addAssignment_23319,axiom,
    ! [VarCurr: state_type] :
      ( v46598(VarCurr)
    <=> v46600(VarCurr) ) ).

tff(addAssignment_23318,axiom,
    ! [VarCurr: state_type] :
      ( v46600(VarCurr)
    <=> v46515(VarCurr,1) ) ).

tff(addAssignment_23317,axiom,
    ! [VarCurr: state_type] :
      ( v46594(VarCurr)
    <=> v46596(VarCurr) ) ).

tff(addAssignment_23316,axiom,
    ! [VarCurr: state_type] :
      ( v46596(VarCurr)
    <=> v46515(VarCurr,0) ) ).

tff(addAssignment_23315,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46568(VarCurr,B)
      <=> v46570(VarCurr,B) ) ) ).

tff(addAssignment_23314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46570(VarCurr,B)
      <=> v46572(VarCurr,B) ) ) ).

tff(addAssignment_23313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46572(VarCurr,B)
      <=> v46574(VarCurr,B) ) ) ).

tff(addAssignment_23312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46574(VarCurr,B)
      <=> v46576(VarCurr,B) ) ) ).

tff(addAssignment_23311,axiom,
    ! [VarCurr: state_type] :
      ( v46542(VarCurr)
    <=> v46544(VarCurr) ) ).

tff(addAssignment_23310,axiom,
    ! [VarCurr: state_type] :
      ( v46544(VarCurr)
    <=> v46546(VarCurr) ) ).

tff(addAssignment_23309,axiom,
    ! [VarCurr: state_type] :
      ( v46546(VarCurr)
    <=> v46548(VarCurr) ) ).

tff(addAssignment_23308,axiom,
    ! [VarCurr: state_type] :
      ( v46548(VarCurr)
    <=> v46550(VarCurr) ) ).

tff(addAssignment_23307,axiom,
    ! [VarCurr: state_type] :
      ( v46550(VarCurr)
    <=> v46552(VarCurr) ) ).

tff(addAssignment_23306,axiom,
    ! [VarCurr: state_type] :
      ( v46552(VarCurr)
    <=> v46554(VarCurr) ) ).

tff(addAssignment_23305,axiom,
    ! [VarCurr: state_type] :
      ( v46554(VarCurr)
    <=> v46556(VarCurr) ) ).

tff(writeUnaryOperator_2671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46556(VarCurr)
    <=> v46566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4354,axiom,
    ! [VarCurr: state_type] :
      ( v46566(VarCurr)
    <=> ( v46558(VarCurr)
        | v46562(VarCurr) ) ) ).

tff(addAssignment_23304,axiom,
    ! [VarCurr: state_type] :
      ( v46562(VarCurr)
    <=> v46564(VarCurr) ) ).

tff(addAssignment_23303,axiom,
    ! [VarCurr: state_type] :
      ( v46564(VarCurr)
    <=> v46515(VarCurr,1) ) ).

tff(addAssignment_23302,axiom,
    ! [VarCurr: state_type] :
      ( v46515(VarCurr,1)
    <=> v46517(VarCurr,1) ) ).

tff(addAssignment_23301,axiom,
    ! [VarCurr: state_type] :
      ( v46517(VarCurr,1)
    <=> v46519(VarCurr,1) ) ).

tff(addAssignment_23300,axiom,
    ! [VarCurr: state_type] :
      ( v46519(VarCurr,1)
    <=> v46524(VarCurr,1) ) ).

tff(addAssignment_23299,axiom,
    ! [VarCurr: state_type] :
      ( v46521(VarCurr,1)
    <=> v46523(VarCurr,1) ) ).

tff(addAssignment_23298,axiom,
    ! [VarCurr: state_type] :
      ( v46523(VarCurr,1)
    <=> v46467(VarCurr,1) ) ).

tff(addAssignment_23297,axiom,
    ! [VarCurr: state_type] :
      ( v46558(VarCurr)
    <=> v46560(VarCurr) ) ).

tff(addAssignment_23296,axiom,
    ! [VarCurr: state_type] :
      ( v46560(VarCurr)
    <=> v46467(VarCurr,0) ) ).

tff(addAssignment_23295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46532(VarCurr,B)
      <=> v46534(VarCurr,B) ) ) ).

tff(addAssignment_23294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46534(VarCurr,B)
      <=> v46536(VarCurr,B) ) ) ).

tff(addAssignment_23293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46536(VarCurr,B)
      <=> v46538(VarCurr,B) ) ) ).

tff(addAssignment_23292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46538(VarCurr,B)
      <=> v46540(VarCurr,B) ) ) ).

tff(addAssignment_23291,axiom,
    ! [VarCurr: state_type] :
      ( v46495(VarCurr)
    <=> v46497(VarCurr) ) ).

tff(addAssignment_23290,axiom,
    ! [VarCurr: state_type] :
      ( v46497(VarCurr)
    <=> v46499(VarCurr) ) ).

tff(addAssignment_23289,axiom,
    ! [VarCurr: state_type] :
      ( v46499(VarCurr)
    <=> v46501(VarCurr) ) ).

tff(addAssignment_23288,axiom,
    ! [VarCurr: state_type] :
      ( v46501(VarCurr)
    <=> v46503(VarCurr) ) ).

tff(addAssignment_23287,axiom,
    ! [VarCurr: state_type] :
      ( v46503(VarCurr)
    <=> v46505(VarCurr) ) ).

tff(addAssignment_23286,axiom,
    ! [VarCurr: state_type] :
      ( v46505(VarCurr)
    <=> v46507(VarCurr) ) ).

tff(addAssignment_23285,axiom,
    ! [VarCurr: state_type] :
      ( v46507(VarCurr)
    <=> v46509(VarCurr) ) ).

tff(writeUnaryOperator_2670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46509(VarCurr)
    <=> v46530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4353,axiom,
    ! [VarCurr: state_type] :
      ( v46530(VarCurr)
    <=> ( v46511(VarCurr)
        | v46526(VarCurr) ) ) ).

tff(addAssignment_23284,axiom,
    ! [VarCurr: state_type] :
      ( v46526(VarCurr)
    <=> v46528(VarCurr) ) ).

tff(addAssignment_23283,axiom,
    ! [VarCurr: state_type] :
      ( v46528(VarCurr)
    <=> v46467(VarCurr,1) ) ).

tff(addAssignment_23282,axiom,
    ! [VarCurr: state_type] :
      ( v46511(VarCurr)
    <=> v46513(VarCurr) ) ).

tff(addAssignment_23281,axiom,
    ! [VarCurr: state_type] :
      ( v46513(VarCurr)
    <=> v46515(VarCurr,0) ) ).

tff(addAssignment_23280,axiom,
    ! [VarCurr: state_type] :
      ( v46515(VarCurr,0)
    <=> v46517(VarCurr,0) ) ).

tff(addAssignment_23279,axiom,
    ! [VarCurr: state_type] :
      ( v46517(VarCurr,0)
    <=> v46519(VarCurr,0) ) ).

tff(addAssignment_23278,axiom,
    ! [VarCurr: state_type] :
      ( v46519(VarCurr,0)
    <=> v46524(VarCurr,0) ) ).

tff(writeUnaryOperator_2669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v46524(VarCurr,B)
      <=> ~ v46521(VarCurr,B) ) ) ).

tff(addAssignment_23277,axiom,
    ! [VarCurr: state_type] :
      ( v46521(VarCurr,0)
    <=> v46523(VarCurr,0) ) ).

tff(addAssignment_23276,axiom,
    ! [VarCurr: state_type] :
      ( v46523(VarCurr,0)
    <=> v46467(VarCurr,0) ) ).

tff(addAssignment_23275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46485(VarCurr,B)
      <=> v46487(VarCurr,B) ) ) ).

tff(addAssignment_23274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46487(VarCurr,B)
      <=> v46489(VarCurr,B) ) ) ).

tff(addAssignment_23273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46489(VarCurr,B)
      <=> v46491(VarCurr,B) ) ) ).

tff(addAssignment_23272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46491(VarCurr,B)
      <=> v46493(VarCurr,B) ) ) ).

tff(addAssignment_23271,axiom,
    ! [VarCurr: state_type] :
      ( v46447(VarCurr)
    <=> v46449(VarCurr) ) ).

tff(addAssignment_23270,axiom,
    ! [VarCurr: state_type] :
      ( v46449(VarCurr)
    <=> v46451(VarCurr) ) ).

tff(addAssignment_23269,axiom,
    ! [VarCurr: state_type] :
      ( v46451(VarCurr)
    <=> v46453(VarCurr) ) ).

tff(addAssignment_23268,axiom,
    ! [VarCurr: state_type] :
      ( v46453(VarCurr)
    <=> v46455(VarCurr) ) ).

tff(addAssignment_23267,axiom,
    ! [VarCurr: state_type] :
      ( v46455(VarCurr)
    <=> v46457(VarCurr) ) ).

tff(addAssignment_23266,axiom,
    ! [VarCurr: state_type] :
      ( v46457(VarCurr)
    <=> v46459(VarCurr) ) ).

tff(addAssignment_23265,axiom,
    ! [VarCurr: state_type] :
      ( v46459(VarCurr)
    <=> v46461(VarCurr) ) ).

tff(writeUnaryOperator_2668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46461(VarCurr)
    <=> v46483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4352,axiom,
    ! [VarCurr: state_type] :
      ( v46483(VarCurr)
    <=> ( v46463(VarCurr)
        | v46479(VarCurr) ) ) ).

tff(addAssignment_23264,axiom,
    ! [VarCurr: state_type] :
      ( v46479(VarCurr)
    <=> v46481(VarCurr) ) ).

tff(addAssignment_23263,axiom,
    ! [VarCurr: state_type] :
      ( v46481(VarCurr)
    <=> v46467(VarCurr,1) ) ).

tff(addAssignment_23262,axiom,
    ! [VarCurr: state_type] :
      ( v46467(VarCurr,1)
    <=> v46469(VarCurr,1) ) ).

tff(addAssignment_23261,axiom,
    ! [VarCurr: state_type] :
      ( v46469(VarCurr,1)
    <=> v46471(VarCurr,1) ) ).

tff(addAssignment_23260,axiom,
    ! [VarCurr: state_type] :
      ( v46471(VarCurr,1)
    <=> v46473(VarCurr,1) ) ).

tff(addAssignment_23259,axiom,
    ! [VarCurr: state_type] :
      ( v46473(VarCurr,1)
    <=> v46475(VarCurr,1) ) ).

tff(addAssignment_23258,axiom,
    ! [VarCurr: state_type] :
      ( v46475(VarCurr,1)
    <=> v46477(VarCurr,1) ) ).

tff(addAssignment_23257,axiom,
    ! [VarCurr: state_type] :
      ( v46463(VarCurr)
    <=> v46465(VarCurr) ) ).

tff(addAssignment_23256,axiom,
    ! [VarCurr: state_type] :
      ( v46465(VarCurr)
    <=> v46467(VarCurr,0) ) ).

tff(addAssignment_23255,axiom,
    ! [VarCurr: state_type] :
      ( v46467(VarCurr,0)
    <=> v46469(VarCurr,0) ) ).

tff(addAssignment_23254,axiom,
    ! [VarCurr: state_type] :
      ( v46469(VarCurr,0)
    <=> v46471(VarCurr,0) ) ).

tff(addAssignment_23253,axiom,
    ! [VarCurr: state_type] :
      ( v46471(VarCurr,0)
    <=> v46473(VarCurr,0) ) ).

tff(addAssignment_23252,axiom,
    ! [VarCurr: state_type] :
      ( v46473(VarCurr,0)
    <=> v46475(VarCurr,0) ) ).

tff(addAssignment_23251,axiom,
    ! [VarCurr: state_type] :
      ( v46475(VarCurr,0)
    <=> v46477(VarCurr,0) ) ).

tff(addAssignment_23250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46437(VarCurr,B)
      <=> v46439(VarCurr,B) ) ) ).

tff(addAssignment_23249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46439(VarCurr,B)
      <=> v46441(VarCurr,B) ) ) ).

tff(addAssignment_23248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46441(VarCurr,B)
      <=> v46443(VarCurr,B) ) ) ).

tff(addAssignment_23247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46443(VarCurr,B)
      <=> v46445(VarCurr,B) ) ) ).

tff(addAssignment_23246,axiom,
    ! [VarCurr: state_type] :
      ( v46417(VarCurr)
    <=> v46419(VarCurr) ) ).

tff(addAssignment_23245,axiom,
    ! [VarCurr: state_type] :
      ( v46419(VarCurr)
    <=> v46421(VarCurr) ) ).

tff(addAssignment_23244,axiom,
    ! [VarCurr: state_type] :
      ( v46421(VarCurr)
    <=> v46423(VarCurr) ) ).

tff(addAssignment_23243,axiom,
    ! [VarCurr: state_type] :
      ( v46423(VarCurr)
    <=> v46425(VarCurr) ) ).

tff(addAssignment_23242,axiom,
    ! [VarCurr: state_type] :
      ( v46425(VarCurr)
    <=> v46427(VarCurr) ) ).

tff(addAssignment_23241,axiom,
    ! [VarCurr: state_type] :
      ( v46427(VarCurr)
    <=> v46429(VarCurr) ) ).

tff(addAssignment_23240,axiom,
    ! [VarCurr: state_type] :
      ( v46429(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_23239,axiom,
    ! [VarCurr: state_type] :
      ( v46403(VarCurr)
    <=> v46405(VarCurr) ) ).

tff(addAssignment_23238,axiom,
    ! [VarCurr: state_type] :
      ( v46405(VarCurr)
    <=> v46407(VarCurr) ) ).

tff(addAssignment_23237,axiom,
    ! [VarCurr: state_type] :
      ( v46407(VarCurr)
    <=> v46409(VarCurr) ) ).

tff(addAssignment_23236,axiom,
    ! [VarCurr: state_type] :
      ( v46409(VarCurr)
    <=> v46411(VarCurr) ) ).

tff(addAssignment_23235,axiom,
    ! [VarCurr: state_type] :
      ( v46411(VarCurr)
    <=> v46413(VarCurr) ) ).

tff(addAssignment_23234,axiom,
    ! [VarCurr: state_type] :
      ( v46413(VarCurr)
    <=> v46415(VarCurr) ) ).

tff(addAssignment_23233,axiom,
    ! [VarCurr: state_type] :
      ( v46415(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_23232,axiom,
    ! [VarCurr: state_type] :
      ( v46389(VarCurr)
    <=> v46391(VarCurr) ) ).

tff(addAssignment_23231,axiom,
    ! [VarCurr: state_type] :
      ( v46391(VarCurr)
    <=> v6617(VarCurr,10) ) ).

tff(addAssignment_23230,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,10)
    <=> v6619(VarCurr,10) ) ).

tff(addAssignment_23229,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,10)
    <=> v6621(VarCurr,10) ) ).

tff(addAssignment_23228,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,10)
    <=> v6747(VarCurr,10) ) ).

tff(addAssignment_23227,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,10)
    <=> v6690(VarCurr,10) ) ).

tff(addAssignment_23226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46385(VarCurr,B)
      <=> v46387(VarCurr,B) ) ) ).

tff(addAssignment_23225,axiom,
    ! [VarCurr: state_type] :
      ( ( v46387(VarCurr,11)
      <=> v6334(VarCurr,131) )
      & ( v46387(VarCurr,10)
      <=> v6334(VarCurr,130) )
      & ( v46387(VarCurr,9)
      <=> v6334(VarCurr,129) )
      & ( v46387(VarCurr,8)
      <=> v6334(VarCurr,128) )
      & ( v46387(VarCurr,7)
      <=> v6334(VarCurr,127) )
      & ( v46387(VarCurr,6)
      <=> v6334(VarCurr,126) )
      & ( v46387(VarCurr,5)
      <=> v6334(VarCurr,125) )
      & ( v46387(VarCurr,4)
      <=> v6334(VarCurr,124) )
      & ( v46387(VarCurr,3)
      <=> v6334(VarCurr,123) )
      & ( v46387(VarCurr,2)
      <=> v6334(VarCurr,122) )
      & ( v46387(VarCurr,1)
      <=> v6334(VarCurr,121) )
      & ( v46387(VarCurr,0)
      <=> v6334(VarCurr,120) ) ) ).

tff(addAssignment_23224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46353(VarCurr,B)
      <=> v46355(VarCurr,B) ) ) ).

tff(addAssignment_23223,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,0)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23222,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,1)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23221,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,2)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23220,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,3)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23219,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,4)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23218,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,5)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23217,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,6)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23216,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,7)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23215,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,8)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23214,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,9)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23213,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,10)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23212,axiom,
    ! [VarCurr: state_type] :
      ( v46355(VarCurr,11)
    <=> v46373(VarCurr) ) ).

tff(addAssignment_23211,axiom,
    ! [VarCurr: state_type] :
      ( v46373(VarCurr)
    <=> v46357(VarCurr) ) ).

tff(addAssignment_23210,axiom,
    ! [VarCurr: state_type] :
      ( v46357(VarCurr)
    <=> v46359(VarCurr,0) ) ).

tff(addAssignment_23209,axiom,
    ! [VarCurr: state_type] :
      ( v46359(VarCurr,0)
    <=> v46361(VarCurr,0) ) ).

tff(addAssignment_23208,axiom,
    ! [VarCurr: state_type] :
      ( v46361(VarCurr,0)
    <=> v46371(VarCurr,0) ) ).

tff(writeUnaryOperator_2667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v46371(VarCurr,B)
      <=> ~ v46363(VarCurr,B) ) ) ).

tff(addAssignment_23207,axiom,
    ! [VarCurr: state_type] :
      ( v46363(VarCurr,0)
    <=> v46365(VarCurr,0) ) ).

tff(addAssignment_23206,axiom,
    ! [VarCurr: state_type] :
      ( v46365(VarCurr,0)
    <=> v46368(VarCurr,0) ) ).

tff(addAssignment_23205,axiom,
    ! [VarCurr: state_type] :
      ( v46368(VarCurr,0)
    <=> v46367(VarCurr) ) ).

tff(addAssignment_23204,axiom,
    ! [VarCurr: state_type] :
      ( v46368(VarCurr,1)
    <=> v46370(VarCurr) ) ).

tff(addAssignment_23203,axiom,
    ! [VarCurr: state_type] :
      ( v46368(VarCurr,2)
    <=> v46369(VarCurr) ) ).

tff(addAssignment_23202,axiom,
    ! [VarCurr: state_type] :
      ( v46367(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_23201,axiom,
    ! [VarCurr: state_type] :
      ( v46329(VarCurr)
    <=> v46331(VarCurr) ) ).

tff(addAssignment_23200,axiom,
    ! [VarCurr: state_type] :
      ( v46331(VarCurr)
    <=> v46333(VarCurr) ) ).

tff(addAssignment_23199,axiom,
    ! [VarCurr: state_type] :
      ( v46333(VarCurr)
    <=> v46335(VarCurr) ) ).

tff(addAssignment_23198,axiom,
    ! [VarCurr: state_type] :
      ( v46335(VarCurr)
    <=> v46337(VarCurr) ) ).

tff(addAssignment_23197,axiom,
    ! [VarCurr: state_type] :
      ( v46337(VarCurr)
    <=> v46339(VarCurr) ) ).

tff(addAssignment_23196,axiom,
    ! [VarCurr: state_type] :
      ( v46339(VarCurr)
    <=> v46341(VarCurr) ) ).

tff(addAssignment_23195,axiom,
    ! [VarCurr: state_type] :
      ( v46341(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_23194,axiom,
    ! [VarCurr: state_type] :
      ( v46315(VarCurr)
    <=> v46317(VarCurr) ) ).

tff(addAssignment_23193,axiom,
    ! [VarCurr: state_type] :
      ( v46317(VarCurr)
    <=> v46319(VarCurr) ) ).

tff(addAssignment_23192,axiom,
    ! [VarCurr: state_type] :
      ( v46319(VarCurr)
    <=> v46321(VarCurr) ) ).

tff(addAssignment_23191,axiom,
    ! [VarCurr: state_type] :
      ( v46321(VarCurr)
    <=> v46323(VarCurr) ) ).

tff(addAssignment_23190,axiom,
    ! [VarCurr: state_type] :
      ( v46323(VarCurr)
    <=> v46325(VarCurr) ) ).

tff(addAssignment_23189,axiom,
    ! [VarCurr: state_type] :
      ( v46325(VarCurr)
    <=> v46327(VarCurr) ) ).

tff(addAssignment_23188,axiom,
    ! [VarCurr: state_type] :
      ( v46327(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_23187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46291(VarCurr,B)
      <=> v46293(VarCurr,B) ) ) ).

tff(addAssignment_23186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46293(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_23185,axiom,
    ! [VarCurr: state_type] :
      ( v44735(VarCurr)
    <=> v44737(VarCurr) ) ).

tff(addAssignment_23184,axiom,
    ! [VarCurr: state_type] :
      ( v44737(VarCurr)
    <=> v44739(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_212,axiom,
    ! [VarCurr: state_type] :
      ( v44739(VarCurr)
    <=> ( ( v44741(VarCurr,11)
        <=> v44745(VarCurr,11) )
        & ( v44741(VarCurr,10)
        <=> v44745(VarCurr,10) )
        & ( v44741(VarCurr,9)
        <=> v44745(VarCurr,9) )
        & ( v44741(VarCurr,8)
        <=> v44745(VarCurr,8) )
        & ( v44741(VarCurr,7)
        <=> v44745(VarCurr,7) )
        & ( v44741(VarCurr,6)
        <=> v44745(VarCurr,6) )
        & ( v44741(VarCurr,5)
        <=> v44745(VarCurr,5) )
        & ( v44741(VarCurr,4)
        <=> v44745(VarCurr,4) )
        & ( v44741(VarCurr,3)
        <=> v44745(VarCurr,3) )
        & ( v44741(VarCurr,2)
        <=> v44745(VarCurr,2) )
        & ( v44741(VarCurr,1)
        <=> v44745(VarCurr,1) )
        & ( v44741(VarCurr,0)
        <=> v44745(VarCurr,0) ) ) ) ).

tff(addAssignment_23183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44745(VarCurr,B)
      <=> v44747(VarCurr,B) ) ) ).

tff(addAssignment_23182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44747(VarCurr,B)
      <=> v44749(VarCurr,B) ) ) ).

tff(addAssignment_23181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44749(VarCurr,B)
      <=> v44751(VarCurr,B) ) ) ).

tff(addAssignment_23180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44751(VarCurr,B)
      <=> v44753(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44753(VarCurr,B)
      <=> ( v46261(VarCurr,B)
          | v46280(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46280(VarCurr,B)
      <=> ( v46132(VarCurr,B)
          & v46281(VarCurr,B) ) ) ) ).

tff(addAssignment_23179,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,0)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23178,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,1)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23177,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,2)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23176,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,3)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23175,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,4)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23174,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,5)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23173,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,6)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23172,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,7)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23171,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,8)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23170,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,9)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23169,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,10)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23168,axiom,
    ! [VarCurr: state_type] :
      ( v46281(VarCurr,11)
    <=> v46282(VarCurr) ) ).

tff(addAssignment_23167,axiom,
    ! [VarCurr: state_type] :
      ( v46282(VarCurr)
    <=> v46251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46261(VarCurr,B)
      <=> ( v46262(VarCurr,B)
          | v46277(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_738,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46277(VarCurr,B)
      <=> ( v45981(VarCurr,B)
          & v46278(VarCurr,B) ) ) ) ).

tff(addAssignment_23166,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,0)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23165,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,1)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23164,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,2)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23163,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,3)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23162,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,4)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23161,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,5)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23160,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,6)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23159,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,7)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23158,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,8)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23157,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,9)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23156,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,10)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23155,axiom,
    ! [VarCurr: state_type] :
      ( v46278(VarCurr,11)
    <=> v46279(VarCurr) ) ).

tff(addAssignment_23154,axiom,
    ! [VarCurr: state_type] :
      ( v46279(VarCurr)
    <=> v46101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_737,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46262(VarCurr,B)
      <=> ( v46263(VarCurr,B)
          | v46274(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_736,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46274(VarCurr,B)
      <=> ( v45830(VarCurr,B)
          & v46275(VarCurr,B) ) ) ) ).

tff(addAssignment_23153,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,0)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23152,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,1)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23151,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,2)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23150,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,3)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23149,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,4)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23148,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,5)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23147,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,6)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23146,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,7)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23145,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,8)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23144,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,9)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23143,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,10)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23142,axiom,
    ! [VarCurr: state_type] :
      ( v46275(VarCurr,11)
    <=> v46276(VarCurr) ) ).

tff(addAssignment_23141,axiom,
    ! [VarCurr: state_type] :
      ( v46276(VarCurr)
    <=> v45950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_735,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46263(VarCurr,B)
      <=> ( v46264(VarCurr,B)
          | v46271(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46271(VarCurr,B)
      <=> ( v45679(VarCurr,B)
          & v46272(VarCurr,B) ) ) ) ).

tff(addAssignment_23140,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,0)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23139,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,1)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23138,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,2)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23137,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,3)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23136,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,4)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23135,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,5)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23134,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,6)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23133,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,7)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23132,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,8)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23131,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,9)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23130,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,10)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23129,axiom,
    ! [VarCurr: state_type] :
      ( v46272(VarCurr,11)
    <=> v46273(VarCurr) ) ).

tff(addAssignment_23128,axiom,
    ! [VarCurr: state_type] :
      ( v46273(VarCurr)
    <=> v45799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_733,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46264(VarCurr,B)
      <=> ( v46265(VarCurr,B)
          | v46268(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46268(VarCurr,B)
      <=> ( v45517(VarCurr,B)
          & v46269(VarCurr,B) ) ) ) ).

tff(addAssignment_23127,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,0)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23126,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,1)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23125,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,2)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23124,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,3)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23123,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,4)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23122,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,5)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23121,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,6)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23120,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,7)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23119,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,8)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23118,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,9)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23117,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,10)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23116,axiom,
    ! [VarCurr: state_type] :
      ( v46269(VarCurr,11)
    <=> v46270(VarCurr) ) ).

tff(addAssignment_23115,axiom,
    ! [VarCurr: state_type] :
      ( v46270(VarCurr)
    <=> v45648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46265(VarCurr,B)
      <=> ( v44755(VarCurr,B)
          & v46266(VarCurr,B) ) ) ) ).

tff(addAssignment_23114,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,0)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23113,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,1)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23112,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,2)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23111,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,3)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23110,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,4)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23109,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,5)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23108,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,6)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23107,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,7)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23106,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,8)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23105,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,9)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23104,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,10)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23103,axiom,
    ! [VarCurr: state_type] :
      ( v46266(VarCurr,11)
    <=> v46267(VarCurr) ) ).

tff(addAssignment_23102,axiom,
    ! [VarCurr: state_type] :
      ( v46267(VarCurr)
    <=> v45225(VarCurr) ) ).

tff(addAssignment_23101,axiom,
    ! [VarCurr: state_type] :
      ( v46251(VarCurr)
    <=> v46253(VarCurr) ) ).

tff(addAssignment_23100,axiom,
    ! [VarCurr: state_type] :
      ( v46253(VarCurr)
    <=> v46255(VarCurr) ) ).

tff(addAssignment_23099,axiom,
    ! [VarCurr: state_type] :
      ( v46255(VarCurr)
    <=> v46257(VarCurr) ) ).

tff(addAssignment_23098,axiom,
    ! [VarCurr: state_type] :
      ( v46257(VarCurr)
    <=> v46259(VarCurr) ) ).

tff(addAssignment_23097,axiom,
    ! [VarCurr: state_type] :
      ( v46259(VarCurr)
    <=> v45318(VarCurr) ) ).

tff(addAssignment_23096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46132(VarCurr,B)
      <=> v46134(VarCurr,B) ) ) ).

tff(addAssignment_23095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46134(VarCurr,B)
      <=> v46136(VarCurr,B) ) ) ).

tff(addAssignment_23094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46136(VarCurr,B)
      <=> v46138(VarCurr,B) ) ) ).

tff(addAssignment_23093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46138(VarCurr,B)
      <=> v46140(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46234(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v46140(VarNext,B)
            <=> v46140(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_541,axiom,
    ! [VarNext: state_type] :
      ( v46234(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46140(VarNext,B)
          <=> v46244(VarNext,B) ) ) ) ).

tff(addAssignment_23092,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46244(VarNext,B)
          <=> v46242(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46245(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46242(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_360,axiom,
    ! [VarCurr: state_type] :
      ( v46245(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46242(VarCurr,B)
          <=> v46162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4351,axiom,
    ! [VarCurr: state_type] :
      ( v46245(VarCurr)
    <=> ( v46246(VarCurr)
        & v46247(VarCurr) ) ) ).

tff(writeUnaryOperator_2666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46247(VarCurr)
    <=> v46152(VarCurr) ) ).

tff(writeUnaryOperator_2665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46246(VarCurr)
    <=> v46142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46234(VarNext)
      <=> v46235(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46235(VarNext)
      <=> ( v46236(VarNext)
          & v46166(VarNext) ) ) ) ).

tff(writeUnaryOperator_2664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46236(VarNext)
      <=> v46238(VarNext) ) ) ).

tff(addAssignment_23091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46238(VarNext)
      <=> v46166(VarCurr) ) ) ).

tff(addAssignment_23090,axiom,
    ! [VarCurr: state_type] :
      ( v46166(VarCurr)
    <=> v46168(VarCurr) ) ).

tff(addAssignment_23089,axiom,
    ! [VarCurr: state_type] :
      ( v46168(VarCurr)
    <=> v46170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4348,axiom,
    ! [VarCurr: state_type] :
      ( v46170(VarCurr)
    <=> ( v46231(VarCurr)
        | v46227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4347,axiom,
    ! [VarCurr: state_type] :
      ( v46231(VarCurr)
    <=> ( v46172(VarCurr)
        & v46176(VarCurr) ) ) ).

tff(addAssignment_23088,axiom,
    ! [VarCurr: state_type] :
      ( v46227(VarCurr)
    <=> v46229(VarCurr) ) ).

tff(addAssignment_23087,axiom,
    ! [VarCurr: state_type] :
      ( v46229(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46211(VarNext)
       => ( v46176(VarNext)
        <=> v46176(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_540,axiom,
    ! [VarNext: state_type] :
      ( v46211(VarNext)
     => ( v46176(VarNext)
      <=> v46221(VarNext) ) ) ).

tff(addAssignment_23086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46221(VarNext)
      <=> v46219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4346,axiom,
    ! [VarCurr: state_type] :
      ( v46219(VarCurr)
    <=> ( v46222(VarCurr)
        & v46223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4345,axiom,
    ! [VarCurr: state_type] :
      ( v46223(VarCurr)
    <=> ( v46182(VarCurr)
        | v46206(VarCurr) ) ) ).

tff(writeUnaryOperator_2663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46222(VarCurr)
    <=> v46178(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46211(VarNext)
      <=> v46212(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46212(VarNext)
      <=> ( v46214(VarNext)
          & v46216(VarNext) ) ) ) ).

tff(writeUnaryOperator_2662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46216(VarCurr)
    <=> v46172(VarCurr) ) ).

tff(addAssignment_23085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46214(VarNext)
      <=> v46172(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_197,axiom,
    ( v46176(constB0)
  <=> $true ) ).

tff(addAssignment_23084,axiom,
    ! [VarCurr: state_type] :
      ( v46206(VarCurr)
    <=> v46208(VarCurr) ) ).

tff(addAssignment_23083,axiom,
    ! [VarCurr: state_type] :
      ( v46208(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_23082,axiom,
    ! [VarCurr: state_type] :
      ( v46182(VarCurr)
    <=> v46184(VarCurr) ) ).

tff(addAssignment_23081,axiom,
    ! [VarCurr: state_type] :
      ( v46184(VarCurr)
    <=> v45492(VarCurr) ) ).

tff(addAssignment_23080,axiom,
    ! [VarCurr: state_type] :
      ( v45492(VarCurr)
    <=> v46187(VarCurr) ) ).

tff(addAssignment_23079,axiom,
    ! [VarCurr: state_type] :
      ( v46187(VarCurr)
    <=> v46189(VarCurr) ) ).

tff(writeUnaryOperator_2661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46189(VarCurr)
    <=> v46203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4342,axiom,
    ! [VarCurr: state_type] :
      ( v46203(VarCurr)
    <=> ( v46204(VarCurr)
        | v46199(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4341,axiom,
    ! [VarCurr: state_type] :
      ( v46204(VarCurr)
    <=> ( v46191(VarCurr)
        | v46195(VarCurr) ) ) ).

tff(addAssignment_23078,axiom,
    ! [VarCurr: state_type] :
      ( v46199(VarCurr)
    <=> v46201(VarCurr) ) ).

tff(addAssignment_23077,axiom,
    ! [VarCurr: state_type] :
      ( v46201(VarCurr)
    <=> v45581(VarCurr,2) ) ).

tff(addAssignment_23076,axiom,
    ! [VarCurr: state_type] :
      ( v46195(VarCurr)
    <=> v46197(VarCurr) ) ).

tff(addAssignment_23075,axiom,
    ! [VarCurr: state_type] :
      ( v46197(VarCurr)
    <=> v45155(VarCurr,1) ) ).

tff(addAssignment_23074,axiom,
    ! [VarCurr: state_type] :
      ( v46191(VarCurr)
    <=> v46193(VarCurr) ) ).

tff(addAssignment_23073,axiom,
    ! [VarCurr: state_type] :
      ( v46193(VarCurr)
    <=> v45581(VarCurr,0) ) ).

tff(addAssignment_23072,axiom,
    ! [VarCurr: state_type] :
      ( v46178(VarCurr)
    <=> v46180(VarCurr) ) ).

tff(addAssignment_23071,axiom,
    ! [VarCurr: state_type] :
      ( v46180(VarCurr)
    <=> $false ) ).

tff(addAssignment_23070,axiom,
    ! [VarCurr: state_type] :
      ( v46172(VarCurr)
    <=> v46174(VarCurr) ) ).

tff(addAssignment_23069,axiom,
    ! [VarCurr: state_type] :
      ( v46174(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_23068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46162(VarCurr,B)
      <=> v46164(VarCurr,B) ) ) ).

tff(addAssignment_23067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46164(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_23066,axiom,
    ! [VarCurr: state_type] :
      ( v46152(VarCurr)
    <=> v46154(VarCurr) ) ).

tff(addAssignment_23065,axiom,
    ! [VarCurr: state_type] :
      ( v46154(VarCurr)
    <=> v46156(VarCurr) ) ).

tff(addAssignment_23064,axiom,
    ! [VarCurr: state_type] :
      ( v46156(VarCurr)
    <=> v46158(VarCurr) ) ).

tff(addAssignment_23063,axiom,
    ! [VarCurr: state_type] :
      ( v46158(VarCurr)
    <=> v46160(VarCurr) ) ).

tff(addAssignment_23062,axiom,
    ! [VarCurr: state_type] :
      ( v46160(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_23061,axiom,
    ! [VarCurr: state_type] :
      ( v46142(VarCurr)
    <=> v46144(VarCurr) ) ).

tff(addAssignment_23060,axiom,
    ! [VarCurr: state_type] :
      ( v46144(VarCurr)
    <=> v46146(VarCurr) ) ).

tff(addAssignment_23059,axiom,
    ! [VarCurr: state_type] :
      ( v46146(VarCurr)
    <=> v46148(VarCurr) ) ).

tff(addAssignment_23058,axiom,
    ! [VarCurr: state_type] :
      ( v46148(VarCurr)
    <=> v46150(VarCurr) ) ).

tff(addAssignment_23057,axiom,
    ! [VarCurr: state_type] :
      ( v46150(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_23056,axiom,
    ! [VarCurr: state_type] :
      ( v46101(VarCurr)
    <=> v46103(VarCurr) ) ).

tff(addAssignment_23055,axiom,
    ! [VarCurr: state_type] :
      ( v46103(VarCurr)
    <=> v46105(VarCurr) ) ).

tff(addAssignment_23054,axiom,
    ! [VarCurr: state_type] :
      ( v46105(VarCurr)
    <=> v46107(VarCurr) ) ).

tff(addAssignment_23053,axiom,
    ! [VarCurr: state_type] :
      ( v46107(VarCurr)
    <=> v46109(VarCurr) ) ).

tff(addAssignment_23052,axiom,
    ! [VarCurr: state_type] :
      ( v46109(VarCurr)
    <=> v46111(VarCurr) ) ).

tff(addAssignment_23051,axiom,
    ! [VarCurr: state_type] :
      ( v46111(VarCurr)
    <=> v46113(VarCurr) ) ).

tff(addAssignment_23050,axiom,
    ! [VarCurr: state_type] :
      ( v46113(VarCurr)
    <=> v46115(VarCurr) ) ).

tff(writeUnaryOperator_2660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46115(VarCurr)
    <=> v46129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4340,axiom,
    ! [VarCurr: state_type] :
      ( v46129(VarCurr)
    <=> ( v46130(VarCurr)
        | v46125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4339,axiom,
    ! [VarCurr: state_type] :
      ( v46130(VarCurr)
    <=> ( v46117(VarCurr)
        | v46121(VarCurr) ) ) ).

tff(addAssignment_23049,axiom,
    ! [VarCurr: state_type] :
      ( v46125(VarCurr)
    <=> v46127(VarCurr) ) ).

tff(addAssignment_23048,axiom,
    ! [VarCurr: state_type] :
      ( v46127(VarCurr)
    <=> v45328(VarCurr,2) ) ).

tff(addAssignment_23047,axiom,
    ! [VarCurr: state_type] :
      ( v46121(VarCurr)
    <=> v46123(VarCurr) ) ).

tff(addAssignment_23046,axiom,
    ! [VarCurr: state_type] :
      ( v46123(VarCurr)
    <=> v45245(VarCurr,1) ) ).

tff(addAssignment_23045,axiom,
    ! [VarCurr: state_type] :
      ( v46117(VarCurr)
    <=> v46119(VarCurr) ) ).

tff(addAssignment_23044,axiom,
    ! [VarCurr: state_type] :
      ( v46119(VarCurr)
    <=> v45245(VarCurr,0) ) ).

tff(addAssignment_23043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45981(VarCurr,B)
      <=> v45983(VarCurr,B) ) ) ).

tff(addAssignment_23042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45983(VarCurr,B)
      <=> v45985(VarCurr,B) ) ) ).

tff(addAssignment_23041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45985(VarCurr,B)
      <=> v45987(VarCurr,B) ) ) ).

tff(addAssignment_23040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45987(VarCurr,B)
      <=> v45989(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46084(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v45989(VarNext,B)
            <=> v45989(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_539,axiom,
    ! [VarNext: state_type] :
      ( v46084(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45989(VarNext,B)
          <=> v46094(VarNext,B) ) ) ) ).

tff(addAssignment_23039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46094(VarNext,B)
          <=> v46092(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_361,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46095(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46092(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_359,axiom,
    ! [VarCurr: state_type] :
      ( v46095(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v46092(VarCurr,B)
          <=> v46011(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4338,axiom,
    ! [VarCurr: state_type] :
      ( v46095(VarCurr)
    <=> ( v46096(VarCurr)
        & v46097(VarCurr) ) ) ).

tff(writeUnaryOperator_2659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46097(VarCurr)
    <=> v46001(VarCurr) ) ).

tff(writeUnaryOperator_2658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46096(VarCurr)
    <=> v45991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46084(VarNext)
      <=> v46085(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46085(VarNext)
      <=> ( v46086(VarNext)
          & v46015(VarNext) ) ) ) ).

tff(writeUnaryOperator_2657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46086(VarNext)
      <=> v46088(VarNext) ) ) ).

tff(addAssignment_23038,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46088(VarNext)
      <=> v46015(VarCurr) ) ) ).

tff(addAssignment_23037,axiom,
    ! [VarCurr: state_type] :
      ( v46015(VarCurr)
    <=> v46017(VarCurr) ) ).

tff(addAssignment_23036,axiom,
    ! [VarCurr: state_type] :
      ( v46017(VarCurr)
    <=> v46019(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4335,axiom,
    ! [VarCurr: state_type] :
      ( v46019(VarCurr)
    <=> ( v46081(VarCurr)
        | v46077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4334,axiom,
    ! [VarCurr: state_type] :
      ( v46081(VarCurr)
    <=> ( v46021(VarCurr)
        & v46025(VarCurr) ) ) ).

tff(addAssignment_23035,axiom,
    ! [VarCurr: state_type] :
      ( v46077(VarCurr)
    <=> v46079(VarCurr) ) ).

tff(addAssignment_23034,axiom,
    ! [VarCurr: state_type] :
      ( v46079(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v46061(VarNext)
       => ( v46025(VarNext)
        <=> v46025(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_538,axiom,
    ! [VarNext: state_type] :
      ( v46061(VarNext)
     => ( v46025(VarNext)
      <=> v46071(VarNext) ) ) ).

tff(addAssignment_23033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46071(VarNext)
      <=> v46069(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4333,axiom,
    ! [VarCurr: state_type] :
      ( v46069(VarCurr)
    <=> ( v46072(VarCurr)
        & v46073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4332,axiom,
    ! [VarCurr: state_type] :
      ( v46073(VarCurr)
    <=> ( v46031(VarCurr)
        | v46056(VarCurr) ) ) ).

tff(writeUnaryOperator_2656,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46072(VarCurr)
    <=> v46027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46061(VarNext)
      <=> v46062(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46062(VarNext)
      <=> ( v46064(VarNext)
          & v46066(VarNext) ) ) ) ).

tff(writeUnaryOperator_2655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46066(VarCurr)
    <=> v46021(VarCurr) ) ).

tff(addAssignment_23032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v46064(VarNext)
      <=> v46021(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_196,axiom,
    ( v46025(constB0)
  <=> $true ) ).

tff(addAssignment_23031,axiom,
    ! [VarCurr: state_type] :
      ( v46056(VarCurr)
    <=> v46058(VarCurr) ) ).

tff(addAssignment_23030,axiom,
    ! [VarCurr: state_type] :
      ( v46058(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_23029,axiom,
    ! [VarCurr: state_type] :
      ( v46031(VarCurr)
    <=> v46033(VarCurr) ) ).

tff(addAssignment_23028,axiom,
    ! [VarCurr: state_type] :
      ( v46033(VarCurr)
    <=> v46035(VarCurr) ) ).

tff(addAssignment_23027,axiom,
    ! [VarCurr: state_type] :
      ( v46035(VarCurr)
    <=> v46037(VarCurr) ) ).

tff(addAssignment_23026,axiom,
    ! [VarCurr: state_type] :
      ( v46037(VarCurr)
    <=> v46039(VarCurr) ) ).

tff(writeUnaryOperator_2654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v46039(VarCurr)
    <=> v46053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4329,axiom,
    ! [VarCurr: state_type] :
      ( v46053(VarCurr)
    <=> ( v46054(VarCurr)
        | v46049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4328,axiom,
    ! [VarCurr: state_type] :
      ( v46054(VarCurr)
    <=> ( v46041(VarCurr)
        | v46045(VarCurr) ) ) ).

tff(addAssignment_23025,axiom,
    ! [VarCurr: state_type] :
      ( v46049(VarCurr)
    <=> v46051(VarCurr) ) ).

tff(addAssignment_23024,axiom,
    ! [VarCurr: state_type] :
      ( v46051(VarCurr)
    <=> v45581(VarCurr,2) ) ).

tff(addAssignment_23023,axiom,
    ! [VarCurr: state_type] :
      ( v45581(VarCurr,2)
    <=> v45583(VarCurr,2) ) ).

tff(addAssignment_23022,axiom,
    ! [VarCurr: state_type] :
      ( v45583(VarCurr,2)
    <=> v45585(VarCurr,2) ) ).

tff(addAssignment_23021,axiom,
    ! [VarCurr: state_type] :
      ( v45585(VarCurr,2)
    <=> v45590(VarCurr,2) ) ).

tff(addAssignment_23020,axiom,
    ! [VarCurr: state_type] :
      ( v45587(VarCurr,2)
    <=> v45589(VarCurr,2) ) ).

tff(addAssignment_23019,axiom,
    ! [VarCurr: state_type] :
      ( v45589(VarCurr,2)
    <=> v45155(VarCurr,2) ) ).

tff(addAssignment_23018,axiom,
    ! [VarCurr: state_type] :
      ( v46045(VarCurr)
    <=> v46047(VarCurr) ) ).

tff(addAssignment_23017,axiom,
    ! [VarCurr: state_type] :
      ( v46047(VarCurr)
    <=> v45155(VarCurr,1) ) ).

tff(addAssignment_23016,axiom,
    ! [VarCurr: state_type] :
      ( v46041(VarCurr)
    <=> v46043(VarCurr) ) ).

tff(addAssignment_23015,axiom,
    ! [VarCurr: state_type] :
      ( v46043(VarCurr)
    <=> v45155(VarCurr,0) ) ).

tff(addAssignment_23014,axiom,
    ! [VarCurr: state_type] :
      ( v46027(VarCurr)
    <=> v46029(VarCurr) ) ).

tff(addAssignment_23013,axiom,
    ! [VarCurr: state_type] :
      ( v46029(VarCurr)
    <=> $false ) ).

tff(addAssignment_23012,axiom,
    ! [VarCurr: state_type] :
      ( v46021(VarCurr)
    <=> v46023(VarCurr) ) ).

tff(addAssignment_23011,axiom,
    ! [VarCurr: state_type] :
      ( v46023(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_23010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46011(VarCurr,B)
      <=> v46013(VarCurr,B) ) ) ).

tff(addAssignment_23009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v46013(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_23008,axiom,
    ! [VarCurr: state_type] :
      ( v46001(VarCurr)
    <=> v46003(VarCurr) ) ).

tff(addAssignment_23007,axiom,
    ! [VarCurr: state_type] :
      ( v46003(VarCurr)
    <=> v46005(VarCurr) ) ).

tff(addAssignment_23006,axiom,
    ! [VarCurr: state_type] :
      ( v46005(VarCurr)
    <=> v46007(VarCurr) ) ).

tff(addAssignment_23005,axiom,
    ! [VarCurr: state_type] :
      ( v46007(VarCurr)
    <=> v46009(VarCurr) ) ).

tff(addAssignment_23004,axiom,
    ! [VarCurr: state_type] :
      ( v46009(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_23003,axiom,
    ! [VarCurr: state_type] :
      ( v45991(VarCurr)
    <=> v45993(VarCurr) ) ).

tff(addAssignment_23002,axiom,
    ! [VarCurr: state_type] :
      ( v45993(VarCurr)
    <=> v45995(VarCurr) ) ).

tff(addAssignment_23001,axiom,
    ! [VarCurr: state_type] :
      ( v45995(VarCurr)
    <=> v45997(VarCurr) ) ).

tff(addAssignment_23000,axiom,
    ! [VarCurr: state_type] :
      ( v45997(VarCurr)
    <=> v45999(VarCurr) ) ).

tff(addAssignment_22999,axiom,
    ! [VarCurr: state_type] :
      ( v45999(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_22998,axiom,
    ! [VarCurr: state_type] :
      ( v45950(VarCurr)
    <=> v45952(VarCurr) ) ).

tff(addAssignment_22997,axiom,
    ! [VarCurr: state_type] :
      ( v45952(VarCurr)
    <=> v45954(VarCurr) ) ).

tff(addAssignment_22996,axiom,
    ! [VarCurr: state_type] :
      ( v45954(VarCurr)
    <=> v45956(VarCurr) ) ).

tff(addAssignment_22995,axiom,
    ! [VarCurr: state_type] :
      ( v45956(VarCurr)
    <=> v45958(VarCurr) ) ).

tff(addAssignment_22994,axiom,
    ! [VarCurr: state_type] :
      ( v45958(VarCurr)
    <=> v45960(VarCurr) ) ).

tff(addAssignment_22993,axiom,
    ! [VarCurr: state_type] :
      ( v45960(VarCurr)
    <=> v45962(VarCurr) ) ).

tff(addAssignment_22992,axiom,
    ! [VarCurr: state_type] :
      ( v45962(VarCurr)
    <=> v45964(VarCurr) ) ).

tff(writeUnaryOperator_2653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45964(VarCurr)
    <=> v45978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4327,axiom,
    ! [VarCurr: state_type] :
      ( v45978(VarCurr)
    <=> ( v45979(VarCurr)
        | v45974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4326,axiom,
    ! [VarCurr: state_type] :
      ( v45979(VarCurr)
    <=> ( v45966(VarCurr)
        | v45970(VarCurr) ) ) ).

tff(addAssignment_22991,axiom,
    ! [VarCurr: state_type] :
      ( v45974(VarCurr)
    <=> v45976(VarCurr) ) ).

tff(addAssignment_22990,axiom,
    ! [VarCurr: state_type] :
      ( v45976(VarCurr)
    <=> v45245(VarCurr,2) ) ).

tff(addAssignment_22989,axiom,
    ! [VarCurr: state_type] :
      ( v45970(VarCurr)
    <=> v45972(VarCurr) ) ).

tff(addAssignment_22988,axiom,
    ! [VarCurr: state_type] :
      ( v45972(VarCurr)
    <=> v45328(VarCurr,1) ) ).

tff(addAssignment_22987,axiom,
    ! [VarCurr: state_type] :
      ( v45966(VarCurr)
    <=> v45968(VarCurr) ) ).

tff(addAssignment_22986,axiom,
    ! [VarCurr: state_type] :
      ( v45968(VarCurr)
    <=> v45328(VarCurr,0) ) ).

tff(addAssignment_22985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45830(VarCurr,B)
      <=> v45832(VarCurr,B) ) ) ).

tff(addAssignment_22984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45832(VarCurr,B)
      <=> v45834(VarCurr,B) ) ) ).

tff(addAssignment_22983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45834(VarCurr,B)
      <=> v45836(VarCurr,B) ) ) ).

tff(addAssignment_22982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45836(VarCurr,B)
      <=> v45838(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45933(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v45838(VarNext,B)
            <=> v45838(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_537,axiom,
    ! [VarNext: state_type] :
      ( v45933(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45838(VarNext,B)
          <=> v45943(VarNext,B) ) ) ) ).

tff(addAssignment_22981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45943(VarNext,B)
          <=> v45941(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45944(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45941(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_358,axiom,
    ! [VarCurr: state_type] :
      ( v45944(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45941(VarCurr,B)
          <=> v45860(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4325,axiom,
    ! [VarCurr: state_type] :
      ( v45944(VarCurr)
    <=> ( v45945(VarCurr)
        & v45946(VarCurr) ) ) ).

tff(writeUnaryOperator_2652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45946(VarCurr)
    <=> v45850(VarCurr) ) ).

tff(writeUnaryOperator_2651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45945(VarCurr)
    <=> v45840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45933(VarNext)
      <=> v45934(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45934(VarNext)
      <=> ( v45935(VarNext)
          & v45864(VarNext) ) ) ) ).

tff(writeUnaryOperator_2650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45935(VarNext)
      <=> v45937(VarNext) ) ) ).

tff(addAssignment_22980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45937(VarNext)
      <=> v45864(VarCurr) ) ) ).

tff(addAssignment_22979,axiom,
    ! [VarCurr: state_type] :
      ( v45864(VarCurr)
    <=> v45866(VarCurr) ) ).

tff(addAssignment_22978,axiom,
    ! [VarCurr: state_type] :
      ( v45866(VarCurr)
    <=> v45868(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4322,axiom,
    ! [VarCurr: state_type] :
      ( v45868(VarCurr)
    <=> ( v45930(VarCurr)
        | v45926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4321,axiom,
    ! [VarCurr: state_type] :
      ( v45930(VarCurr)
    <=> ( v45870(VarCurr)
        & v45874(VarCurr) ) ) ).

tff(addAssignment_22977,axiom,
    ! [VarCurr: state_type] :
      ( v45926(VarCurr)
    <=> v45928(VarCurr) ) ).

tff(addAssignment_22976,axiom,
    ! [VarCurr: state_type] :
      ( v45928(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_536,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45910(VarNext)
       => ( v45874(VarNext)
        <=> v45874(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_536,axiom,
    ! [VarNext: state_type] :
      ( v45910(VarNext)
     => ( v45874(VarNext)
      <=> v45920(VarNext) ) ) ).

tff(addAssignment_22975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45920(VarNext)
      <=> v45918(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4320,axiom,
    ! [VarCurr: state_type] :
      ( v45918(VarCurr)
    <=> ( v45921(VarCurr)
        & v45922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4319,axiom,
    ! [VarCurr: state_type] :
      ( v45922(VarCurr)
    <=> ( v45880(VarCurr)
        | v45905(VarCurr) ) ) ).

tff(writeUnaryOperator_2649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45921(VarCurr)
    <=> v45876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45910(VarNext)
      <=> v45911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45911(VarNext)
      <=> ( v45913(VarNext)
          & v45915(VarNext) ) ) ) ).

tff(writeUnaryOperator_2648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45915(VarCurr)
    <=> v45870(VarCurr) ) ).

tff(addAssignment_22974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45913(VarNext)
      <=> v45870(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_195,axiom,
    ( v45874(constB0)
  <=> $true ) ).

tff(addAssignment_22973,axiom,
    ! [VarCurr: state_type] :
      ( v45905(VarCurr)
    <=> v45907(VarCurr) ) ).

tff(addAssignment_22972,axiom,
    ! [VarCurr: state_type] :
      ( v45907(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_22971,axiom,
    ! [VarCurr: state_type] :
      ( v45880(VarCurr)
    <=> v45882(VarCurr) ) ).

tff(addAssignment_22970,axiom,
    ! [VarCurr: state_type] :
      ( v45882(VarCurr)
    <=> v45884(VarCurr) ) ).

tff(addAssignment_22969,axiom,
    ! [VarCurr: state_type] :
      ( v45884(VarCurr)
    <=> v45886(VarCurr) ) ).

tff(addAssignment_22968,axiom,
    ! [VarCurr: state_type] :
      ( v45886(VarCurr)
    <=> v45888(VarCurr) ) ).

tff(writeUnaryOperator_2647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45888(VarCurr)
    <=> v45902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4316,axiom,
    ! [VarCurr: state_type] :
      ( v45902(VarCurr)
    <=> ( v45903(VarCurr)
        | v45898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4315,axiom,
    ! [VarCurr: state_type] :
      ( v45903(VarCurr)
    <=> ( v45890(VarCurr)
        | v45894(VarCurr) ) ) ).

tff(addAssignment_22967,axiom,
    ! [VarCurr: state_type] :
      ( v45898(VarCurr)
    <=> v45900(VarCurr) ) ).

tff(addAssignment_22966,axiom,
    ! [VarCurr: state_type] :
      ( v45900(VarCurr)
    <=> v45155(VarCurr,2) ) ).

tff(addAssignment_22965,axiom,
    ! [VarCurr: state_type] :
      ( v45894(VarCurr)
    <=> v45896(VarCurr) ) ).

tff(addAssignment_22964,axiom,
    ! [VarCurr: state_type] :
      ( v45896(VarCurr)
    <=> v45581(VarCurr,1) ) ).

tff(addAssignment_22963,axiom,
    ! [VarCurr: state_type] :
      ( v45890(VarCurr)
    <=> v45892(VarCurr) ) ).

tff(addAssignment_22962,axiom,
    ! [VarCurr: state_type] :
      ( v45892(VarCurr)
    <=> v45581(VarCurr,0) ) ).

tff(addAssignment_22961,axiom,
    ! [VarCurr: state_type] :
      ( v45876(VarCurr)
    <=> v45878(VarCurr) ) ).

tff(addAssignment_22960,axiom,
    ! [VarCurr: state_type] :
      ( v45878(VarCurr)
    <=> $false ) ).

tff(addAssignment_22959,axiom,
    ! [VarCurr: state_type] :
      ( v45870(VarCurr)
    <=> v45872(VarCurr) ) ).

tff(addAssignment_22958,axiom,
    ! [VarCurr: state_type] :
      ( v45872(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_22957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45860(VarCurr,B)
      <=> v45862(VarCurr,B) ) ) ).

tff(addAssignment_22956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45862(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_22955,axiom,
    ! [VarCurr: state_type] :
      ( v45850(VarCurr)
    <=> v45852(VarCurr) ) ).

tff(addAssignment_22954,axiom,
    ! [VarCurr: state_type] :
      ( v45852(VarCurr)
    <=> v45854(VarCurr) ) ).

tff(addAssignment_22953,axiom,
    ! [VarCurr: state_type] :
      ( v45854(VarCurr)
    <=> v45856(VarCurr) ) ).

tff(addAssignment_22952,axiom,
    ! [VarCurr: state_type] :
      ( v45856(VarCurr)
    <=> v45858(VarCurr) ) ).

tff(addAssignment_22951,axiom,
    ! [VarCurr: state_type] :
      ( v45858(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_22950,axiom,
    ! [VarCurr: state_type] :
      ( v45840(VarCurr)
    <=> v45842(VarCurr) ) ).

tff(addAssignment_22949,axiom,
    ! [VarCurr: state_type] :
      ( v45842(VarCurr)
    <=> v45844(VarCurr) ) ).

tff(addAssignment_22948,axiom,
    ! [VarCurr: state_type] :
      ( v45844(VarCurr)
    <=> v45846(VarCurr) ) ).

tff(addAssignment_22947,axiom,
    ! [VarCurr: state_type] :
      ( v45846(VarCurr)
    <=> v45848(VarCurr) ) ).

tff(addAssignment_22946,axiom,
    ! [VarCurr: state_type] :
      ( v45848(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_22945,axiom,
    ! [VarCurr: state_type] :
      ( v45799(VarCurr)
    <=> v45801(VarCurr) ) ).

tff(addAssignment_22944,axiom,
    ! [VarCurr: state_type] :
      ( v45801(VarCurr)
    <=> v45803(VarCurr) ) ).

tff(addAssignment_22943,axiom,
    ! [VarCurr: state_type] :
      ( v45803(VarCurr)
    <=> v45805(VarCurr) ) ).

tff(addAssignment_22942,axiom,
    ! [VarCurr: state_type] :
      ( v45805(VarCurr)
    <=> v45807(VarCurr) ) ).

tff(addAssignment_22941,axiom,
    ! [VarCurr: state_type] :
      ( v45807(VarCurr)
    <=> v45809(VarCurr) ) ).

tff(addAssignment_22940,axiom,
    ! [VarCurr: state_type] :
      ( v45809(VarCurr)
    <=> v45811(VarCurr) ) ).

tff(addAssignment_22939,axiom,
    ! [VarCurr: state_type] :
      ( v45811(VarCurr)
    <=> v45813(VarCurr) ) ).

tff(writeUnaryOperator_2646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45813(VarCurr)
    <=> v45827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4314,axiom,
    ! [VarCurr: state_type] :
      ( v45827(VarCurr)
    <=> ( v45828(VarCurr)
        | v45823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4313,axiom,
    ! [VarCurr: state_type] :
      ( v45828(VarCurr)
    <=> ( v45815(VarCurr)
        | v45819(VarCurr) ) ) ).

tff(addAssignment_22938,axiom,
    ! [VarCurr: state_type] :
      ( v45823(VarCurr)
    <=> v45825(VarCurr) ) ).

tff(addAssignment_22937,axiom,
    ! [VarCurr: state_type] :
      ( v45825(VarCurr)
    <=> v45245(VarCurr,2) ) ).

tff(addAssignment_22936,axiom,
    ! [VarCurr: state_type] :
      ( v45819(VarCurr)
    <=> v45821(VarCurr) ) ).

tff(addAssignment_22935,axiom,
    ! [VarCurr: state_type] :
      ( v45821(VarCurr)
    <=> v45328(VarCurr,1) ) ).

tff(addAssignment_22934,axiom,
    ! [VarCurr: state_type] :
      ( v45328(VarCurr,1)
    <=> v45330(VarCurr,1) ) ).

tff(addAssignment_22933,axiom,
    ! [VarCurr: state_type] :
      ( v45330(VarCurr,1)
    <=> v45332(VarCurr,1) ) ).

tff(addAssignment_22932,axiom,
    ! [VarCurr: state_type] :
      ( v45332(VarCurr,1)
    <=> v45337(VarCurr,1) ) ).

tff(addAssignment_22931,axiom,
    ! [VarCurr: state_type] :
      ( v45334(VarCurr,1)
    <=> v45336(VarCurr,1) ) ).

tff(addAssignment_22930,axiom,
    ! [VarCurr: state_type] :
      ( v45336(VarCurr,1)
    <=> v45245(VarCurr,1) ) ).

tff(addAssignment_22929,axiom,
    ! [VarCurr: state_type] :
      ( v45815(VarCurr)
    <=> v45817(VarCurr) ) ).

tff(addAssignment_22928,axiom,
    ! [VarCurr: state_type] :
      ( v45817(VarCurr)
    <=> v45245(VarCurr,0) ) ).

tff(addAssignment_22927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45679(VarCurr,B)
      <=> v45681(VarCurr,B) ) ) ).

tff(addAssignment_22926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45681(VarCurr,B)
      <=> v45683(VarCurr,B) ) ) ).

tff(addAssignment_22925,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45683(VarCurr,B)
      <=> v45685(VarCurr,B) ) ) ).

tff(addAssignment_22924,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45685(VarCurr,B)
      <=> v45687(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45782(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v45687(VarNext,B)
            <=> v45687(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_535,axiom,
    ! [VarNext: state_type] :
      ( v45782(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45687(VarNext,B)
          <=> v45792(VarNext,B) ) ) ) ).

tff(addAssignment_22923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45792(VarNext,B)
          <=> v45790(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45793(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45790(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_357,axiom,
    ! [VarCurr: state_type] :
      ( v45793(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45790(VarCurr,B)
          <=> v45709(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4312,axiom,
    ! [VarCurr: state_type] :
      ( v45793(VarCurr)
    <=> ( v45794(VarCurr)
        & v45795(VarCurr) ) ) ).

tff(writeUnaryOperator_2645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45795(VarCurr)
    <=> v45699(VarCurr) ) ).

tff(writeUnaryOperator_2644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45794(VarCurr)
    <=> v45689(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45782(VarNext)
      <=> v45783(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45783(VarNext)
      <=> ( v45784(VarNext)
          & v45713(VarNext) ) ) ) ).

tff(writeUnaryOperator_2643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45784(VarNext)
      <=> v45786(VarNext) ) ) ).

tff(addAssignment_22922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45786(VarNext)
      <=> v45713(VarCurr) ) ) ).

tff(addAssignment_22921,axiom,
    ! [VarCurr: state_type] :
      ( v45713(VarCurr)
    <=> v45715(VarCurr) ) ).

tff(addAssignment_22920,axiom,
    ! [VarCurr: state_type] :
      ( v45715(VarCurr)
    <=> v45717(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4309,axiom,
    ! [VarCurr: state_type] :
      ( v45717(VarCurr)
    <=> ( v45779(VarCurr)
        | v45775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4308,axiom,
    ! [VarCurr: state_type] :
      ( v45779(VarCurr)
    <=> ( v45719(VarCurr)
        & v45723(VarCurr) ) ) ).

tff(addAssignment_22919,axiom,
    ! [VarCurr: state_type] :
      ( v45775(VarCurr)
    <=> v45777(VarCurr) ) ).

tff(addAssignment_22918,axiom,
    ! [VarCurr: state_type] :
      ( v45777(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45759(VarNext)
       => ( v45723(VarNext)
        <=> v45723(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_534,axiom,
    ! [VarNext: state_type] :
      ( v45759(VarNext)
     => ( v45723(VarNext)
      <=> v45769(VarNext) ) ) ).

tff(addAssignment_22917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45769(VarNext)
      <=> v45767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4307,axiom,
    ! [VarCurr: state_type] :
      ( v45767(VarCurr)
    <=> ( v45770(VarCurr)
        & v45771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4306,axiom,
    ! [VarCurr: state_type] :
      ( v45771(VarCurr)
    <=> ( v45729(VarCurr)
        | v45754(VarCurr) ) ) ).

tff(writeUnaryOperator_2642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45770(VarCurr)
    <=> v45725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45759(VarNext)
      <=> v45760(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45760(VarNext)
      <=> ( v45762(VarNext)
          & v45764(VarNext) ) ) ) ).

tff(writeUnaryOperator_2641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45764(VarCurr)
    <=> v45719(VarCurr) ) ).

tff(addAssignment_22916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45762(VarNext)
      <=> v45719(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_194,axiom,
    ( v45723(constB0)
  <=> $true ) ).

tff(addAssignment_22915,axiom,
    ! [VarCurr: state_type] :
      ( v45754(VarCurr)
    <=> v45756(VarCurr) ) ).

tff(addAssignment_22914,axiom,
    ! [VarCurr: state_type] :
      ( v45756(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_22913,axiom,
    ! [VarCurr: state_type] :
      ( v45729(VarCurr)
    <=> v45731(VarCurr) ) ).

tff(addAssignment_22912,axiom,
    ! [VarCurr: state_type] :
      ( v45731(VarCurr)
    <=> v45733(VarCurr) ) ).

tff(addAssignment_22911,axiom,
    ! [VarCurr: state_type] :
      ( v45733(VarCurr)
    <=> v45735(VarCurr) ) ).

tff(addAssignment_22910,axiom,
    ! [VarCurr: state_type] :
      ( v45735(VarCurr)
    <=> v45737(VarCurr) ) ).

tff(writeUnaryOperator_2640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45737(VarCurr)
    <=> v45751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4303,axiom,
    ! [VarCurr: state_type] :
      ( v45751(VarCurr)
    <=> ( v45752(VarCurr)
        | v45747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4302,axiom,
    ! [VarCurr: state_type] :
      ( v45752(VarCurr)
    <=> ( v45739(VarCurr)
        | v45743(VarCurr) ) ) ).

tff(addAssignment_22909,axiom,
    ! [VarCurr: state_type] :
      ( v45747(VarCurr)
    <=> v45749(VarCurr) ) ).

tff(addAssignment_22908,axiom,
    ! [VarCurr: state_type] :
      ( v45749(VarCurr)
    <=> v45155(VarCurr,2) ) ).

tff(addAssignment_22907,axiom,
    ! [VarCurr: state_type] :
      ( v45743(VarCurr)
    <=> v45745(VarCurr) ) ).

tff(addAssignment_22906,axiom,
    ! [VarCurr: state_type] :
      ( v45745(VarCurr)
    <=> v45581(VarCurr,1) ) ).

tff(addAssignment_22905,axiom,
    ! [VarCurr: state_type] :
      ( v45581(VarCurr,1)
    <=> v45583(VarCurr,1) ) ).

tff(addAssignment_22904,axiom,
    ! [VarCurr: state_type] :
      ( v45583(VarCurr,1)
    <=> v45585(VarCurr,1) ) ).

tff(addAssignment_22903,axiom,
    ! [VarCurr: state_type] :
      ( v45585(VarCurr,1)
    <=> v45590(VarCurr,1) ) ).

tff(addAssignment_22902,axiom,
    ! [VarCurr: state_type] :
      ( v45587(VarCurr,1)
    <=> v45589(VarCurr,1) ) ).

tff(addAssignment_22901,axiom,
    ! [VarCurr: state_type] :
      ( v45589(VarCurr,1)
    <=> v45155(VarCurr,1) ) ).

tff(addAssignment_22900,axiom,
    ! [VarCurr: state_type] :
      ( v45739(VarCurr)
    <=> v45741(VarCurr) ) ).

tff(addAssignment_22899,axiom,
    ! [VarCurr: state_type] :
      ( v45741(VarCurr)
    <=> v45155(VarCurr,0) ) ).

tff(addAssignment_22898,axiom,
    ! [VarCurr: state_type] :
      ( v45725(VarCurr)
    <=> v45727(VarCurr) ) ).

tff(addAssignment_22897,axiom,
    ! [VarCurr: state_type] :
      ( v45727(VarCurr)
    <=> $false ) ).

tff(addAssignment_22896,axiom,
    ! [VarCurr: state_type] :
      ( v45719(VarCurr)
    <=> v45721(VarCurr) ) ).

tff(addAssignment_22895,axiom,
    ! [VarCurr: state_type] :
      ( v45721(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_22894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45709(VarCurr,B)
      <=> v45711(VarCurr,B) ) ) ).

tff(addAssignment_22893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45711(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_22892,axiom,
    ! [VarCurr: state_type] :
      ( v45699(VarCurr)
    <=> v45701(VarCurr) ) ).

tff(addAssignment_22891,axiom,
    ! [VarCurr: state_type] :
      ( v45701(VarCurr)
    <=> v45703(VarCurr) ) ).

tff(addAssignment_22890,axiom,
    ! [VarCurr: state_type] :
      ( v45703(VarCurr)
    <=> v45705(VarCurr) ) ).

tff(addAssignment_22889,axiom,
    ! [VarCurr: state_type] :
      ( v45705(VarCurr)
    <=> v45707(VarCurr) ) ).

tff(addAssignment_22888,axiom,
    ! [VarCurr: state_type] :
      ( v45707(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_22887,axiom,
    ! [VarCurr: state_type] :
      ( v45689(VarCurr)
    <=> v45691(VarCurr) ) ).

tff(addAssignment_22886,axiom,
    ! [VarCurr: state_type] :
      ( v45691(VarCurr)
    <=> v45693(VarCurr) ) ).

tff(addAssignment_22885,axiom,
    ! [VarCurr: state_type] :
      ( v45693(VarCurr)
    <=> v45695(VarCurr) ) ).

tff(addAssignment_22884,axiom,
    ! [VarCurr: state_type] :
      ( v45695(VarCurr)
    <=> v45697(VarCurr) ) ).

tff(addAssignment_22883,axiom,
    ! [VarCurr: state_type] :
      ( v45697(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_22882,axiom,
    ! [VarCurr: state_type] :
      ( v45648(VarCurr)
    <=> v45650(VarCurr) ) ).

tff(addAssignment_22881,axiom,
    ! [VarCurr: state_type] :
      ( v45650(VarCurr)
    <=> v45652(VarCurr) ) ).

tff(addAssignment_22880,axiom,
    ! [VarCurr: state_type] :
      ( v45652(VarCurr)
    <=> v45654(VarCurr) ) ).

tff(addAssignment_22879,axiom,
    ! [VarCurr: state_type] :
      ( v45654(VarCurr)
    <=> v45656(VarCurr) ) ).

tff(addAssignment_22878,axiom,
    ! [VarCurr: state_type] :
      ( v45656(VarCurr)
    <=> v45658(VarCurr) ) ).

tff(addAssignment_22877,axiom,
    ! [VarCurr: state_type] :
      ( v45658(VarCurr)
    <=> v45660(VarCurr) ) ).

tff(addAssignment_22876,axiom,
    ! [VarCurr: state_type] :
      ( v45660(VarCurr)
    <=> v45662(VarCurr) ) ).

tff(writeUnaryOperator_2639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45662(VarCurr)
    <=> v45676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4301,axiom,
    ! [VarCurr: state_type] :
      ( v45676(VarCurr)
    <=> ( v45677(VarCurr)
        | v45672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4300,axiom,
    ! [VarCurr: state_type] :
      ( v45677(VarCurr)
    <=> ( v45664(VarCurr)
        | v45668(VarCurr) ) ) ).

tff(addAssignment_22875,axiom,
    ! [VarCurr: state_type] :
      ( v45672(VarCurr)
    <=> v45674(VarCurr) ) ).

tff(addAssignment_22874,axiom,
    ! [VarCurr: state_type] :
      ( v45674(VarCurr)
    <=> v45245(VarCurr,2) ) ).

tff(addAssignment_22873,axiom,
    ! [VarCurr: state_type] :
      ( v45668(VarCurr)
    <=> v45670(VarCurr) ) ).

tff(addAssignment_22872,axiom,
    ! [VarCurr: state_type] :
      ( v45670(VarCurr)
    <=> v45245(VarCurr,1) ) ).

tff(addAssignment_22871,axiom,
    ! [VarCurr: state_type] :
      ( v45664(VarCurr)
    <=> v45666(VarCurr) ) ).

tff(addAssignment_22870,axiom,
    ! [VarCurr: state_type] :
      ( v45666(VarCurr)
    <=> v45328(VarCurr,0) ) ).

tff(addAssignment_22869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45517(VarCurr,B)
      <=> v45519(VarCurr,B) ) ) ).

tff(addAssignment_22868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45519(VarCurr,B)
      <=> v45521(VarCurr,B) ) ) ).

tff(addAssignment_22867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45521(VarCurr,B)
      <=> v45523(VarCurr,B) ) ) ).

tff(addAssignment_22866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45523(VarCurr,B)
      <=> v45525(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45631(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v45525(VarNext,B)
            <=> v45525(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_533,axiom,
    ! [VarNext: state_type] :
      ( v45631(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45525(VarNext,B)
          <=> v45641(VarNext,B) ) ) ) ).

tff(addAssignment_22865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45641(VarNext,B)
          <=> v45639(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45642(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45639(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_356,axiom,
    ! [VarCurr: state_type] :
      ( v45642(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45639(VarCurr,B)
          <=> v45547(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4299,axiom,
    ! [VarCurr: state_type] :
      ( v45642(VarCurr)
    <=> ( v45643(VarCurr)
        & v45644(VarCurr) ) ) ).

tff(writeUnaryOperator_2638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45644(VarCurr)
    <=> v45537(VarCurr) ) ).

tff(writeUnaryOperator_2637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45643(VarCurr)
    <=> v45527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45631(VarNext)
      <=> v45632(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45632(VarNext)
      <=> ( v45633(VarNext)
          & v45551(VarNext) ) ) ) ).

tff(writeUnaryOperator_2636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45633(VarNext)
      <=> v45635(VarNext) ) ) ).

tff(addAssignment_22864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45635(VarNext)
      <=> v45551(VarCurr) ) ) ).

tff(addAssignment_22863,axiom,
    ! [VarCurr: state_type] :
      ( v45551(VarCurr)
    <=> v45553(VarCurr) ) ).

tff(addAssignment_22862,axiom,
    ! [VarCurr: state_type] :
      ( v45553(VarCurr)
    <=> v45555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4296,axiom,
    ! [VarCurr: state_type] :
      ( v45555(VarCurr)
    <=> ( v45628(VarCurr)
        | v45624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4295,axiom,
    ! [VarCurr: state_type] :
      ( v45628(VarCurr)
    <=> ( v45557(VarCurr)
        & v45561(VarCurr) ) ) ).

tff(addAssignment_22861,axiom,
    ! [VarCurr: state_type] :
      ( v45624(VarCurr)
    <=> v45626(VarCurr) ) ).

tff(addAssignment_22860,axiom,
    ! [VarCurr: state_type] :
      ( v45626(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45608(VarNext)
       => ( v45561(VarNext)
        <=> v45561(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_532,axiom,
    ! [VarNext: state_type] :
      ( v45608(VarNext)
     => ( v45561(VarNext)
      <=> v45618(VarNext) ) ) ).

tff(addAssignment_22859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45618(VarNext)
      <=> v45616(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4294,axiom,
    ! [VarCurr: state_type] :
      ( v45616(VarCurr)
    <=> ( v45619(VarCurr)
        & v45620(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4293,axiom,
    ! [VarCurr: state_type] :
      ( v45620(VarCurr)
    <=> ( v45567(VarCurr)
        | v45603(VarCurr) ) ) ).

tff(writeUnaryOperator_2635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45619(VarCurr)
    <=> v45563(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45608(VarNext)
      <=> v45609(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45609(VarNext)
      <=> ( v45611(VarNext)
          & v45613(VarNext) ) ) ) ).

tff(writeUnaryOperator_2634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45613(VarCurr)
    <=> v45557(VarCurr) ) ).

tff(addAssignment_22858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45611(VarNext)
      <=> v45557(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_193,axiom,
    ( v45561(constB0)
  <=> $true ) ).

tff(addAssignment_22857,axiom,
    ! [VarCurr: state_type] :
      ( v45603(VarCurr)
    <=> v45605(VarCurr) ) ).

tff(addAssignment_22856,axiom,
    ! [VarCurr: state_type] :
      ( v45605(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_22855,axiom,
    ! [VarCurr: state_type] :
      ( v45567(VarCurr)
    <=> v45569(VarCurr) ) ).

tff(addAssignment_22854,axiom,
    ! [VarCurr: state_type] :
      ( v45569(VarCurr)
    <=> v45571(VarCurr) ) ).

tff(addAssignment_22853,axiom,
    ! [VarCurr: state_type] :
      ( v45571(VarCurr)
    <=> v45573(VarCurr) ) ).

tff(addAssignment_22852,axiom,
    ! [VarCurr: state_type] :
      ( v45573(VarCurr)
    <=> v45575(VarCurr) ) ).

tff(writeUnaryOperator_2633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45575(VarCurr)
    <=> v45600(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4290,axiom,
    ! [VarCurr: state_type] :
      ( v45600(VarCurr)
    <=> ( v45601(VarCurr)
        | v45596(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4289,axiom,
    ! [VarCurr: state_type] :
      ( v45601(VarCurr)
    <=> ( v45577(VarCurr)
        | v45592(VarCurr) ) ) ).

tff(addAssignment_22851,axiom,
    ! [VarCurr: state_type] :
      ( v45596(VarCurr)
    <=> v45598(VarCurr) ) ).

tff(addAssignment_22850,axiom,
    ! [VarCurr: state_type] :
      ( v45598(VarCurr)
    <=> v45155(VarCurr,2) ) ).

tff(addAssignment_22849,axiom,
    ! [VarCurr: state_type] :
      ( v45592(VarCurr)
    <=> v45594(VarCurr) ) ).

tff(addAssignment_22848,axiom,
    ! [VarCurr: state_type] :
      ( v45594(VarCurr)
    <=> v45155(VarCurr,1) ) ).

tff(addAssignment_22847,axiom,
    ! [VarCurr: state_type] :
      ( v45577(VarCurr)
    <=> v45579(VarCurr) ) ).

tff(addAssignment_22846,axiom,
    ! [VarCurr: state_type] :
      ( v45579(VarCurr)
    <=> v45581(VarCurr,0) ) ).

tff(addAssignment_22845,axiom,
    ! [VarCurr: state_type] :
      ( v45581(VarCurr,0)
    <=> v45583(VarCurr,0) ) ).

tff(addAssignment_22844,axiom,
    ! [VarCurr: state_type] :
      ( v45583(VarCurr,0)
    <=> v45585(VarCurr,0) ) ).

tff(addAssignment_22843,axiom,
    ! [VarCurr: state_type] :
      ( v45585(VarCurr,0)
    <=> v45590(VarCurr,0) ) ).

tff(writeUnaryOperator_2632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v45590(VarCurr,B)
      <=> ~ v45587(VarCurr,B) ) ) ).

tff(addAssignment_22842,axiom,
    ! [VarCurr: state_type] :
      ( v45587(VarCurr,0)
    <=> v45589(VarCurr,0) ) ).

tff(addAssignment_22841,axiom,
    ! [VarCurr: state_type] :
      ( v45589(VarCurr,0)
    <=> v45155(VarCurr,0) ) ).

tff(addAssignment_22840,axiom,
    ! [VarCurr: state_type] :
      ( v45563(VarCurr)
    <=> v45565(VarCurr) ) ).

tff(addAssignment_22839,axiom,
    ! [VarCurr: state_type] :
      ( v45565(VarCurr)
    <=> $false ) ).

tff(addAssignment_22838,axiom,
    ! [VarCurr: state_type] :
      ( v45557(VarCurr)
    <=> v45559(VarCurr) ) ).

tff(addAssignment_22837,axiom,
    ! [VarCurr: state_type] :
      ( v45559(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_22836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45547(VarCurr,B)
      <=> v45549(VarCurr,B) ) ) ).

tff(addAssignment_22835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45549(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_22834,axiom,
    ! [VarCurr: state_type] :
      ( v45537(VarCurr)
    <=> v45539(VarCurr) ) ).

tff(addAssignment_22833,axiom,
    ! [VarCurr: state_type] :
      ( v45539(VarCurr)
    <=> v45541(VarCurr) ) ).

tff(addAssignment_22832,axiom,
    ! [VarCurr: state_type] :
      ( v45541(VarCurr)
    <=> v45543(VarCurr) ) ).

tff(addAssignment_22831,axiom,
    ! [VarCurr: state_type] :
      ( v45543(VarCurr)
    <=> v45545(VarCurr) ) ).

tff(addAssignment_22830,axiom,
    ! [VarCurr: state_type] :
      ( v45545(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_22829,axiom,
    ! [VarCurr: state_type] :
      ( v45527(VarCurr)
    <=> v45529(VarCurr) ) ).

tff(addAssignment_22828,axiom,
    ! [VarCurr: state_type] :
      ( v45529(VarCurr)
    <=> v45531(VarCurr) ) ).

tff(addAssignment_22827,axiom,
    ! [VarCurr: state_type] :
      ( v45531(VarCurr)
    <=> v45533(VarCurr) ) ).

tff(addAssignment_22826,axiom,
    ! [VarCurr: state_type] :
      ( v45533(VarCurr)
    <=> v45535(VarCurr) ) ).

tff(addAssignment_22825,axiom,
    ! [VarCurr: state_type] :
      ( v45535(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_22824,axiom,
    ! [VarCurr: state_type] :
      ( v45225(VarCurr)
    <=> v45227(VarCurr) ) ).

tff(addAssignment_22823,axiom,
    ! [VarCurr: state_type] :
      ( v45227(VarCurr)
    <=> v45229(VarCurr) ) ).

tff(addAssignment_22822,axiom,
    ! [VarCurr: state_type] :
      ( v45229(VarCurr)
    <=> v45231(VarCurr) ) ).

tff(addAssignment_22821,axiom,
    ! [VarCurr: state_type] :
      ( v45231(VarCurr)
    <=> v45233(VarCurr) ) ).

tff(addAssignment_22820,axiom,
    ! [VarCurr: state_type] :
      ( v45233(VarCurr)
    <=> v45235(VarCurr) ) ).

tff(addAssignment_22819,axiom,
    ! [VarCurr: state_type] :
      ( v45235(VarCurr)
    <=> v45237(VarCurr) ) ).

tff(addAssignment_22818,axiom,
    ! [VarCurr: state_type] :
      ( v45237(VarCurr)
    <=> v45239(VarCurr) ) ).

tff(writeUnaryOperator_2631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45239(VarCurr)
    <=> v45514(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4288,axiom,
    ! [VarCurr: state_type] :
      ( v45514(VarCurr)
    <=> ( v45515(VarCurr)
        | v45510(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4287,axiom,
    ! [VarCurr: state_type] :
      ( v45515(VarCurr)
    <=> ( v45241(VarCurr)
        | v45506(VarCurr) ) ) ).

tff(addAssignment_22817,axiom,
    ! [VarCurr: state_type] :
      ( v45510(VarCurr)
    <=> v45512(VarCurr) ) ).

tff(addAssignment_22816,axiom,
    ! [VarCurr: state_type] :
      ( v45512(VarCurr)
    <=> v45245(VarCurr,2) ) ).

tff(addAssignment_22815,axiom,
    ! [VarCurr: state_type] :
      ( v45506(VarCurr)
    <=> v45508(VarCurr) ) ).

tff(addAssignment_22814,axiom,
    ! [VarCurr: state_type] :
      ( v45508(VarCurr)
    <=> v45245(VarCurr,1) ) ).

tff(addAssignment_22813,axiom,
    ! [VarCurr: state_type] :
      ( v45241(VarCurr)
    <=> v45243(VarCurr) ) ).

tff(addAssignment_22812,axiom,
    ! [VarCurr: state_type] :
      ( v45243(VarCurr)
    <=> v45245(VarCurr,0) ) ).

tff(addAssignment_22811,axiom,
    ! [VarCurr: state_type] :
      ( v45245(VarCurr,0)
    <=> v45157(VarCurr,3) ) ).

tff(addAssignment_22810,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,3)
    <=> v45159(VarCurr,3) ) ).

tff(addAssignment_22809,axiom,
    ! [VarNext: state_type] :
      ( v45159(VarNext,3)
    <=> v45498(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45499(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v45498(VarNext,B)
            <=> v45159(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_531,axiom,
    ! [VarNext: state_type] :
      ( v45499(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45498(VarNext,B)
          <=> v45470(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45499(VarNext)
      <=> v45500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45500(VarNext)
      <=> ( v45502(VarNext)
          & v45412(VarNext) ) ) ) ).

tff(writeUnaryOperator_2630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45502(VarNext)
      <=> v45464(VarNext) ) ) ).

tff(addAssignment_22808,axiom,
    ! [VarCurr: state_type] :
      ( v45269(VarCurr,3)
    <=> v45271(VarCurr,3) ) ).

tff(addAssignment_22807,axiom,
    ! [VarCurr: state_type] :
      ( v45271(VarCurr,3)
    <=> v45409(VarCurr,3) ) ).

tff(addAssignment_22806,axiom,
    ! [VarCurr: state_type] :
      ( v45273(VarCurr,0)
    <=> v45275(VarCurr,0) ) ).

tff(addAssignment_22805,axiom,
    ! [VarCurr: state_type] :
      ( v45275(VarCurr,0)
    <=> v45277(VarCurr,0) ) ).

tff(addAssignment_22804,axiom,
    ! [VarCurr: state_type] :
      ( v45277(VarCurr,0)
    <=> v45408(VarCurr,0) ) ).

tff(addAssignment_22803,axiom,
    ! [VarCurr: state_type] :
      ( v45345(VarCurr,0)
    <=> v45347(VarCurr,0) ) ).

tff(addAssignment_22802,axiom,
    ! [VarCurr: state_type] :
      ( v45347(VarCurr,0)
    <=> v45349(VarCurr,0) ) ).

tff(addAssignment_22801,axiom,
    ! [VarCurr: state_type] :
      ( v45349(VarCurr,0)
    <=> v45351(VarCurr,0) ) ).

tff(addAssignment_22800,axiom,
    ! [VarCurr: state_type] :
      ( v45351(VarCurr,0)
    <=> v45353(VarCurr,0) ) ).

tff(addAssignment_22799,axiom,
    ! [VarCurr: state_type] :
      ( v45353(VarCurr,0)
    <=> v45363(VarCurr,0) ) ).

tff(addAssignment_22798,axiom,
    ! [VarCurr: state_type] :
      ( v45279(VarCurr,0)
    <=> v45281(VarCurr,0) ) ).

tff(addAssignment_22797,axiom,
    ! [VarCurr: state_type] :
      ( v45281(VarCurr,0)
    <=> v45342(VarCurr,0) ) ).

tff(addAssignment_22796,axiom,
    ! [VarCurr: state_type] :
      ( v45283(VarCurr)
    <=> v44809(VarCurr,2) ) ).

tff(addAssignment_22795,axiom,
    ! [VarCurr: state_type] :
      ( v44809(VarCurr,2)
    <=> v44811(VarCurr,2) ) ).

tff(addAssignment_22794,axiom,
    ! [VarCurr: state_type] :
      ( v44811(VarCurr,2)
    <=> v44821(VarCurr,2) ) ).

tff(addAssignment_22793,axiom,
    ! [VarCurr: state_type] :
      ( v44813(VarCurr,2)
    <=> v44815(VarCurr,2) ) ).

tff(addAssignment_22792,axiom,
    ! [VarCurr: state_type] :
      ( v44815(VarCurr,2)
    <=> v44818(VarCurr,2) ) ).

tff(addAssignment_22791,axiom,
    ! [VarCurr: state_type] :
      ( v44819(VarCurr)
    <=> v45286(VarCurr,1) ) ).

tff(addAssignment_22790,axiom,
    ! [VarCurr: state_type] :
      ( v45286(VarCurr,1)
    <=> v45288(VarCurr,1) ) ).

tff(addAssignment_22789,axiom,
    ! [VarCurr: state_type] :
      ( v45288(VarCurr,1)
    <=> v45496(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v45496(VarCurr,B)
      <=> ( v45290(VarCurr,B)
          | v45296(VarCurr,B) ) ) ) ).

tff(addAssignment_22788,axiom,
    ! [VarCurr: state_type] :
      ( v45296(VarCurr,1)
    <=> v45298(VarCurr,1) ) ).

tff(addAssignment_22787,axiom,
    ! [VarCurr: state_type] :
      ( v45298(VarCurr,1)
    <=> v45494(VarCurr,1) ) ).

tff(addAssignment_22786,axiom,
    ! [VarCurr: state_type] :
      ( v45494(VarCurr,0)
    <=> v45495(VarCurr) ) ).

tff(addAssignment_22785,axiom,
    ! [VarCurr: state_type] :
      ( v45494(VarCurr,1)
    <=> v45300(VarCurr) ) ).

tff(addAssignment_22784,axiom,
    ! [VarCurr: state_type] :
      ( v45300(VarCurr)
    <=> v45302(VarCurr,1) ) ).

tff(addAssignment_22783,axiom,
    ! [VarCurr: state_type] :
      ( v45302(VarCurr,1)
    <=> v45304(VarCurr,1) ) ).

tff(addAssignment_22782,axiom,
    ! [VarCurr: state_type] :
      ( v45304(VarCurr,1)
    <=> v45493(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v45493(VarCurr,B)
      <=> ( v45306(VarCurr,B)
          & v45314(VarCurr,B) ) ) ) ).

tff(addAssignment_22781,axiom,
    ! [VarCurr: state_type] :
      ( v45314(VarCurr,1)
    <=> v45316(VarCurr,1) ) ).

tff(addAssignment_22780,axiom,
    ! [VarCurr: state_type] :
      ( v45316(VarCurr,1)
    <=> v45491(VarCurr,1) ) ).

tff(addAssignment_22779,axiom,
    ! [VarCurr: state_type] :
      ( v45491(VarCurr,0)
    <=> v45492(VarCurr) ) ).

tff(addAssignment_22778,axiom,
    ! [VarCurr: state_type] :
      ( v45491(VarCurr,1)
    <=> v45318(VarCurr) ) ).

tff(addAssignment_22777,axiom,
    ! [VarCurr: state_type] :
      ( v45318(VarCurr)
    <=> v45320(VarCurr) ) ).

tff(addAssignment_22776,axiom,
    ! [VarCurr: state_type] :
      ( v45320(VarCurr)
    <=> v45322(VarCurr) ) ).

tff(writeUnaryOperator_2629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45322(VarCurr)
    <=> v45489(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4284,axiom,
    ! [VarCurr: state_type] :
      ( v45489(VarCurr)
    <=> ( v45490(VarCurr)
        | v45477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4283,axiom,
    ! [VarCurr: state_type] :
      ( v45490(VarCurr)
    <=> ( v45324(VarCurr)
        | v45339(VarCurr) ) ) ).

tff(addAssignment_22775,axiom,
    ! [VarCurr: state_type] :
      ( v45477(VarCurr)
    <=> v45479(VarCurr) ) ).

tff(addAssignment_22774,axiom,
    ! [VarCurr: state_type] :
      ( v45479(VarCurr)
    <=> v45328(VarCurr,2) ) ).

tff(addAssignment_22773,axiom,
    ! [VarCurr: state_type] :
      ( v45328(VarCurr,2)
    <=> v45330(VarCurr,2) ) ).

tff(addAssignment_22772,axiom,
    ! [VarCurr: state_type] :
      ( v45330(VarCurr,2)
    <=> v45332(VarCurr,2) ) ).

tff(addAssignment_22771,axiom,
    ! [VarCurr: state_type] :
      ( v45332(VarCurr,2)
    <=> v45337(VarCurr,2) ) ).

tff(addAssignment_22770,axiom,
    ! [VarCurr: state_type] :
      ( v45334(VarCurr,2)
    <=> v45336(VarCurr,2) ) ).

tff(addAssignment_22769,axiom,
    ! [VarCurr: state_type] :
      ( v45336(VarCurr,2)
    <=> v45245(VarCurr,2) ) ).

tff(addAssignment_22768,axiom,
    ! [VarCurr: state_type] :
      ( v45245(VarCurr,2)
    <=> v45157(VarCurr,5) ) ).

tff(addAssignment_22767,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,5)
    <=> v45159(VarCurr,5) ) ).

tff(addAssignment_22766,axiom,
    ! [VarNext: state_type] :
      ( v45159(VarNext,5)
    <=> v45481(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45482(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v45481(VarNext,B)
            <=> v45159(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_530,axiom,
    ! [VarNext: state_type] :
      ( v45482(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45481(VarNext,B)
          <=> v45470(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45482(VarNext)
      <=> v45483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45483(VarNext)
      <=> ( v45485(VarNext)
          & v45412(VarNext) ) ) ) ).

tff(writeUnaryOperator_2628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45485(VarNext)
      <=> v45464(VarNext) ) ) ).

tff(addAssignment_22765,axiom,
    ! [VarCurr: state_type] :
      ( v45269(VarCurr,5)
    <=> v45271(VarCurr,5) ) ).

tff(addAssignment_22764,axiom,
    ! [VarCurr: state_type] :
      ( v45271(VarCurr,5)
    <=> v45409(VarCurr,5) ) ).

tff(addAssignment_22763,axiom,
    ! [VarCurr: state_type] :
      ( v45273(VarCurr,2)
    <=> v45275(VarCurr,2) ) ).

tff(addAssignment_22762,axiom,
    ! [VarCurr: state_type] :
      ( v45275(VarCurr,2)
    <=> v45277(VarCurr,2) ) ).

tff(addAssignment_22761,axiom,
    ! [VarCurr: state_type] :
      ( v45277(VarCurr,2)
    <=> v45408(VarCurr,2) ) ).

tff(addAssignment_22760,axiom,
    ! [VarCurr: state_type] :
      ( v45345(VarCurr,2)
    <=> v45347(VarCurr,2) ) ).

tff(addAssignment_22759,axiom,
    ! [VarCurr: state_type] :
      ( v45347(VarCurr,2)
    <=> v45349(VarCurr,2) ) ).

tff(addAssignment_22758,axiom,
    ! [VarCurr: state_type] :
      ( v45349(VarCurr,2)
    <=> v45351(VarCurr,2) ) ).

tff(addAssignment_22757,axiom,
    ! [VarCurr: state_type] :
      ( v45351(VarCurr,2)
    <=> v45353(VarCurr,2) ) ).

tff(addAssignment_22756,axiom,
    ! [VarCurr: state_type] :
      ( v45353(VarCurr,2)
    <=> v45363(VarCurr,2) ) ).

tff(addAssignment_22755,axiom,
    ! [VarCurr: state_type] :
      ( v45355(VarCurr,2)
    <=> v45357(VarCurr,2) ) ).

tff(addAssignment_22754,axiom,
    ! [VarCurr: state_type] :
      ( v45357(VarCurr,2)
    <=> v45358(VarCurr,2) ) ).

tff(addAssignment_22753,axiom,
    ! [VarCurr: state_type] :
      ( v45279(VarCurr,2)
    <=> v45281(VarCurr,2) ) ).

tff(addAssignment_22752,axiom,
    ! [VarCurr: state_type] :
      ( v45281(VarCurr,2)
    <=> v45342(VarCurr,2) ) ).

tff(addAssignment_22751,axiom,
    ! [VarCurr: state_type] :
      ( v45339(VarCurr)
    <=> v45341(VarCurr) ) ).

tff(addAssignment_22750,axiom,
    ! [VarCurr: state_type] :
      ( v45341(VarCurr)
    <=> v45245(VarCurr,1) ) ).

tff(addAssignment_22749,axiom,
    ! [VarCurr: state_type] :
      ( v45245(VarCurr,1)
    <=> v45157(VarCurr,4) ) ).

tff(addAssignment_22748,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,4)
    <=> v45159(VarCurr,4) ) ).

tff(addAssignment_22747,axiom,
    ! [VarNext: state_type] :
      ( v45159(VarNext,4)
    <=> v45459(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_529,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45460(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v45459(VarNext,B)
            <=> v45159(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_529,axiom,
    ! [VarNext: state_type] :
      ( v45460(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45459(VarNext,B)
          <=> v45470(VarNext,B) ) ) ) ).

tff(addAssignment_22746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45470(VarNext,B)
          <=> v45468(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45471(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45468(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_355,axiom,
    ! [VarCurr: state_type] :
      ( v45471(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v45468(VarCurr,B)
          <=> v45269(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4280,axiom,
    ! [VarCurr: state_type] :
      ( v45471(VarCurr)
    <=> ( v45472(VarCurr)
        & v45473(VarCurr) ) ) ).

tff(writeUnaryOperator_2627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45473(VarCurr)
    <=> v45259(VarCurr) ) ).

tff(writeUnaryOperator_2626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45472(VarCurr)
    <=> v45247(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45460(VarNext)
      <=> v45461(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45461(VarNext)
      <=> ( v45462(VarNext)
          & v45412(VarNext) ) ) ) ).

tff(writeUnaryOperator_2625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45462(VarNext)
      <=> v45464(VarNext) ) ) ).

tff(addAssignment_22745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45464(VarNext)
      <=> v45412(VarCurr) ) ) ).

tff(addAssignment_22744,axiom,
    ! [VarCurr: state_type] :
      ( v45412(VarCurr)
    <=> v45414(VarCurr) ) ).

tff(addAssignment_22743,axiom,
    ! [VarCurr: state_type] :
      ( v45414(VarCurr)
    <=> v45416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4277,axiom,
    ! [VarCurr: state_type] :
      ( v45416(VarCurr)
    <=> ( v45457(VarCurr)
        | v45453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4276,axiom,
    ! [VarCurr: state_type] :
      ( v45457(VarCurr)
    <=> ( v45418(VarCurr)
        & v45422(VarCurr) ) ) ).

tff(addAssignment_22742,axiom,
    ! [VarCurr: state_type] :
      ( v45453(VarCurr)
    <=> v45455(VarCurr) ) ).

tff(addAssignment_22741,axiom,
    ! [VarCurr: state_type] :
      ( v45455(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_528,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45437(VarNext)
       => ( v45422(VarNext)
        <=> v45422(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_528,axiom,
    ! [VarNext: state_type] :
      ( v45437(VarNext)
     => ( v45422(VarNext)
      <=> v45447(VarNext) ) ) ).

tff(addAssignment_22740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45447(VarNext)
      <=> v45445(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4275,axiom,
    ! [VarCurr: state_type] :
      ( v45445(VarCurr)
    <=> ( v45448(VarCurr)
        & v45449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4274,axiom,
    ! [VarCurr: state_type] :
      ( v45449(VarCurr)
    <=> ( v45428(VarCurr)
        | v45432(VarCurr) ) ) ).

tff(writeUnaryOperator_2624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45448(VarCurr)
    <=> v45424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45437(VarNext)
      <=> v45438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45438(VarNext)
      <=> ( v45440(VarNext)
          & v45442(VarNext) ) ) ) ).

tff(writeUnaryOperator_2623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45442(VarCurr)
    <=> v45418(VarCurr) ) ).

tff(addAssignment_22739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45440(VarNext)
      <=> v45418(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_192,axiom,
    ( v45422(constB0)
  <=> $true ) ).

tff(addAssignment_22738,axiom,
    ! [VarCurr: state_type] :
      ( v45432(VarCurr)
    <=> v45434(VarCurr) ) ).

tff(addAssignment_22737,axiom,
    ! [VarCurr: state_type] :
      ( v45434(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_22736,axiom,
    ! [VarCurr: state_type] :
      ( v45428(VarCurr)
    <=> v45430(VarCurr) ) ).

tff(addAssignment_22735,axiom,
    ! [VarCurr: state_type] :
      ( v45430(VarCurr)
    <=> $true ) ).

tff(addAssignment_22734,axiom,
    ! [VarCurr: state_type] :
      ( v45424(VarCurr)
    <=> v45426(VarCurr) ) ).

tff(addAssignment_22733,axiom,
    ! [VarCurr: state_type] :
      ( v45426(VarCurr)
    <=> $false ) ).

tff(addAssignment_22732,axiom,
    ! [VarCurr: state_type] :
      ( v45418(VarCurr)
    <=> v45420(VarCurr) ) ).

tff(addAssignment_22731,axiom,
    ! [VarCurr: state_type] :
      ( v45420(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_22730,axiom,
    ! [VarCurr: state_type] :
      ( v45269(VarCurr,4)
    <=> v45271(VarCurr,4) ) ).

tff(addAssignment_22729,axiom,
    ! [VarCurr: state_type] :
      ( v45271(VarCurr,4)
    <=> v45409(VarCurr,4) ) ).

tff(addAssignment_22728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v45409(VarCurr,B)
      <=> v45410(VarCurr,B) ) ) ).

tff(addAssignment_22727,axiom,
    ! [VarCurr: state_type] :
      ( ( v45409(VarCurr,5)
      <=> v45273(VarCurr,2) )
      & ( v45409(VarCurr,4)
      <=> v45273(VarCurr,1) )
      & ( v45409(VarCurr,3)
      <=> v45273(VarCurr,0) ) ) ).

tff(addAssignment_22726,axiom,
    ! [VarCurr: state_type] :
      ( v45273(VarCurr,1)
    <=> v45275(VarCurr,1) ) ).

tff(addAssignment_22725,axiom,
    ! [VarCurr: state_type] :
      ( v45275(VarCurr,1)
    <=> v45277(VarCurr,1) ) ).

tff(addAssignment_22724,axiom,
    ! [VarCurr: state_type] :
      ( v45277(VarCurr,1)
    <=> v45408(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v45408(VarCurr,B)
      <=> ( v45279(VarCurr,B)
          & v45345(VarCurr,B) ) ) ) ).

tff(addAssignment_22723,axiom,
    ! [VarCurr: state_type] :
      ( v45345(VarCurr,1)
    <=> v45347(VarCurr,1) ) ).

tff(addAssignment_22722,axiom,
    ! [VarCurr: state_type] :
      ( v45347(VarCurr,1)
    <=> v45349(VarCurr,1) ) ).

tff(addAssignment_22721,axiom,
    ! [VarCurr: state_type] :
      ( v45349(VarCurr,1)
    <=> v45351(VarCurr,1) ) ).

tff(addAssignment_22720,axiom,
    ! [VarCurr: state_type] :
      ( v45351(VarCurr,1)
    <=> v45353(VarCurr,1) ) ).

tff(addAssignment_22719,axiom,
    ! [VarCurr: state_type] :
      ( v45353(VarCurr,1)
    <=> v45363(VarCurr,1) ) ).

tff(addAssignment_22718,axiom,
    ! [VarCurr: state_type] :
      ( v45363(VarCurr,0)
    <=> v45403(VarCurr) ) ).

tff(addAssignment_22717,axiom,
    ! [VarCurr: state_type] :
      ( v45363(VarCurr,1)
    <=> v45398(VarCurr) ) ).

tff(addAssignment_22716,axiom,
    ! [VarCurr: state_type] :
      ( v45363(VarCurr,2)
    <=> v45393(VarCurr) ) ).

tff(addAssignment_22715,axiom,
    ! [VarCurr: state_type] :
      ( v45363(VarCurr,3)
    <=> v45365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4271,axiom,
    ! [VarCurr: state_type] :
      ( v45403(VarCurr)
    <=> ( v45404(VarCurr)
        & v45407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4270,axiom,
    ! [VarCurr: state_type] :
      ( v45407(VarCurr)
    <=> ( v45355(VarCurr,0)
        | v45373(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4269,axiom,
    ! [VarCurr: state_type] :
      ( v45404(VarCurr)
    <=> ( v45405(VarCurr)
        | v45406(VarCurr) ) ) ).

tff(writeUnaryOperator_2622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45406(VarCurr)
    <=> v45373(VarCurr,0) ) ).

tff(writeUnaryOperator_2621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45405(VarCurr)
    <=> v45355(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4268,axiom,
    ! [VarCurr: state_type] :
      ( v45398(VarCurr)
    <=> ( v45399(VarCurr)
        & v45402(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4267,axiom,
    ! [VarCurr: state_type] :
      ( v45402(VarCurr)
    <=> ( v45372(VarCurr)
        | v45374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4266,axiom,
    ! [VarCurr: state_type] :
      ( v45399(VarCurr)
    <=> ( v45400(VarCurr)
        | v45401(VarCurr) ) ) ).

tff(writeUnaryOperator_2620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45401(VarCurr)
    <=> v45374(VarCurr) ) ).

tff(writeUnaryOperator_2619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45400(VarCurr)
    <=> v45372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4265,axiom,
    ! [VarCurr: state_type] :
      ( v45393(VarCurr)
    <=> ( v45394(VarCurr)
        & v45397(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4264,axiom,
    ! [VarCurr: state_type] :
      ( v45397(VarCurr)
    <=> ( v45370(VarCurr)
        | v45380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4263,axiom,
    ! [VarCurr: state_type] :
      ( v45394(VarCurr)
    <=> ( v45395(VarCurr)
        | v45396(VarCurr) ) ) ).

tff(writeUnaryOperator_2618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45396(VarCurr)
    <=> v45380(VarCurr) ) ).

tff(writeUnaryOperator_2617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45395(VarCurr)
    <=> v45370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4262,axiom,
    ! [VarCurr: state_type] :
      ( v45365(VarCurr)
    <=> ( v45366(VarCurr)
        & v45392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4261,axiom,
    ! [VarCurr: state_type] :
      ( v45392(VarCurr)
    <=> ( v45368(VarCurr)
        | v45387(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4260,axiom,
    ! [VarCurr: state_type] :
      ( v45366(VarCurr)
    <=> ( v45367(VarCurr)
        | v45386(VarCurr) ) ) ).

tff(writeUnaryOperator_2616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45386(VarCurr)
    <=> v45387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4259,axiom,
    ! [VarCurr: state_type] :
      ( v45387(VarCurr)
    <=> ( v45388(VarCurr)
        & v45391(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_533,axiom,
    ! [VarCurr: state_type] :
      ( v45391(VarCurr)
    <=> ( v45355(VarCurr,3)
        | v45373(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4258,axiom,
    ! [VarCurr: state_type] :
      ( v45388(VarCurr)
    <=> ( v45389(VarCurr)
        | v45390(VarCurr) ) ) ).

tff(writeUnaryOperator_2615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45390(VarCurr)
    <=> v45373(VarCurr,3) ) ).

tff(writeUnaryOperator_2614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45389(VarCurr)
    <=> v45355(VarCurr,3) ) ).

tff(writeUnaryOperator_2613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45367(VarCurr)
    <=> v45368(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4257,axiom,
    ! [VarCurr: state_type] :
      ( v45368(VarCurr)
    <=> ( v45369(VarCurr)
        | v45385(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_532,axiom,
    ! [VarCurr: state_type] :
      ( v45385(VarCurr)
    <=> ( v45355(VarCurr,2)
        & v45373(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4256,axiom,
    ! [VarCurr: state_type] :
      ( v45369(VarCurr)
    <=> ( v45370(VarCurr)
        & v45380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4255,axiom,
    ! [VarCurr: state_type] :
      ( v45380(VarCurr)
    <=> ( v45381(VarCurr)
        & v45384(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_531,axiom,
    ! [VarCurr: state_type] :
      ( v45384(VarCurr)
    <=> ( v45355(VarCurr,2)
        | v45373(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4254,axiom,
    ! [VarCurr: state_type] :
      ( v45381(VarCurr)
    <=> ( v45382(VarCurr)
        | v45383(VarCurr) ) ) ).

tff(writeUnaryOperator_2612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45383(VarCurr)
    <=> v45373(VarCurr,2) ) ).

tff(writeUnaryOperator_2611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45382(VarCurr)
    <=> v45355(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4253,axiom,
    ! [VarCurr: state_type] :
      ( v45370(VarCurr)
    <=> ( v45371(VarCurr)
        | v45379(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_530,axiom,
    ! [VarCurr: state_type] :
      ( v45379(VarCurr)
    <=> ( v45355(VarCurr,1)
        & v45373(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4252,axiom,
    ! [VarCurr: state_type] :
      ( v45371(VarCurr)
    <=> ( v45372(VarCurr)
        & v45374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4251,axiom,
    ! [VarCurr: state_type] :
      ( v45374(VarCurr)
    <=> ( v45375(VarCurr)
        & v45378(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_529,axiom,
    ! [VarCurr: state_type] :
      ( v45378(VarCurr)
    <=> ( v45355(VarCurr,1)
        | v45373(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4250,axiom,
    ! [VarCurr: state_type] :
      ( v45375(VarCurr)
    <=> ( v45376(VarCurr)
        | v45377(VarCurr) ) ) ).

tff(writeUnaryOperator_2610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45377(VarCurr)
    <=> v45373(VarCurr,1) ) ).

tff(writeUnaryOperator_2609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45376(VarCurr)
    <=> v45355(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4249,axiom,
    ! [VarCurr: state_type] :
      ( v45372(VarCurr)
    <=> ( v45355(VarCurr,0)
        & v45373(VarCurr,0) ) ) ).

tff(addAssignment_22714,axiom,
    ! [VarCurr: state_type] :
      ( v45373(VarCurr,0)
    <=> v45360(VarCurr) ) ).

tff(addAssignment_22713,axiom,
    ! [VarCurr: state_type] :
      ( ( v45373(VarCurr,3)
      <=> $false )
      & ( v45373(VarCurr,2)
      <=> $false )
      & ( v45373(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_22712,axiom,
    ! [VarCurr: state_type] :
      ( v45360(VarCurr)
    <=> v45362(VarCurr) ) ).

tff(addAssignment_22711,axiom,
    ! [VarCurr: state_type] :
      ( v45362(VarCurr)
    <=> v45310(VarCurr) ) ).

tff(addAssignment_22710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v45355(VarCurr,B)
      <=> v45357(VarCurr,B) ) ) ).

tff(addAssignment_22709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v45357(VarCurr,B)
      <=> v45358(VarCurr,B) ) ) ).

tff(addAssignment_22708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v45358(VarCurr,B)
      <=> v45245(VarCurr,B) ) ) ).

tff(addAssignment_22707,axiom,
    ! [VarCurr: state_type] :
      ( v45358(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_22706,axiom,
    ! [VarCurr: state_type] :
      ( v45279(VarCurr,1)
    <=> v45281(VarCurr,1) ) ).

tff(addAssignment_22705,axiom,
    ! [VarCurr: state_type] :
      ( v45281(VarCurr,1)
    <=> v45342(VarCurr,1) ) ).

tff(addAssignment_22704,axiom,
    ! [VarCurr: state_type] :
      ( v45342(VarCurr,0)
    <=> v45343(VarCurr) ) ).

tff(addAssignment_22703,axiom,
    ! [VarCurr: state_type] :
      ( v45342(VarCurr,1)
    <=> v45343(VarCurr) ) ).

tff(addAssignment_22702,axiom,
    ! [VarCurr: state_type] :
      ( v45342(VarCurr,2)
    <=> v45343(VarCurr) ) ).

tff(addAssignment_22701,axiom,
    ! [VarCurr: state_type] :
      ( v45343(VarCurr)
    <=> v45283(VarCurr) ) ).

tff(addAssignment_22700,axiom,
    ! [VarCurr: state_type] :
      ( v45324(VarCurr)
    <=> v45326(VarCurr) ) ).

tff(addAssignment_22699,axiom,
    ! [VarCurr: state_type] :
      ( v45326(VarCurr)
    <=> v45328(VarCurr,0) ) ).

tff(addAssignment_22698,axiom,
    ! [VarCurr: state_type] :
      ( v45328(VarCurr,0)
    <=> v45330(VarCurr,0) ) ).

tff(addAssignment_22697,axiom,
    ! [VarCurr: state_type] :
      ( v45330(VarCurr,0)
    <=> v45332(VarCurr,0) ) ).

tff(addAssignment_22696,axiom,
    ! [VarCurr: state_type] :
      ( v45332(VarCurr,0)
    <=> v45337(VarCurr,0) ) ).

tff(writeUnaryOperator_2608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v45337(VarCurr,B)
      <=> ~ v45334(VarCurr,B) ) ) ).

tff(addAssignment_22695,axiom,
    ! [VarCurr: state_type] :
      ( v45334(VarCurr,0)
    <=> v45336(VarCurr,0) ) ).

tff(addAssignment_22694,axiom,
    ! [VarCurr: state_type] :
      ( v45336(VarCurr,0)
    <=> v45245(VarCurr,0) ) ).

tff(addAssignment_22693,axiom,
    ! [VarCurr: state_type] :
      ( v45306(VarCurr,1)
    <=> v45308(VarCurr,1) ) ).

tff(addAssignment_22692,axiom,
    ! [VarCurr: state_type] :
      ( v45308(VarCurr,1)
    <=> v45311(VarCurr,1) ) ).

tff(addAssignment_22691,axiom,
    ! [VarCurr: state_type] :
      ( v45311(VarCurr,0)
    <=> v45312(VarCurr) ) ).

tff(addAssignment_22690,axiom,
    ! [VarCurr: state_type] :
      ( v45311(VarCurr,1)
    <=> v45310(VarCurr) ) ).

tff(addAssignment_22689,axiom,
    ! [VarCurr: state_type] :
      ( v45310(VarCurr)
    <=> v7230(VarCurr,9) ) ).

tff(addAssignment_22688,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,9)
    <=> v7232(VarCurr,9) ) ).

tff(addAssignment_22687,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,9)
    <=> v7234(VarCurr,9) ) ).

tff(addAssignment_22686,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,9)
    <=> v34455(VarCurr,9) ) ).

tff(addAssignment_22685,axiom,
    ! [VarCurr: state_type] :
      ( v45290(VarCurr,1)
    <=> v45292(VarCurr,1) ) ).

tff(addAssignment_22684,axiom,
    ! [VarCurr: state_type] :
      ( v45292(VarCurr,1)
    <=> v45293(VarCurr,1) ) ).

tff(addAssignment_22683,axiom,
    ! [VarCurr: state_type] :
      ( v45293(VarCurr,0)
    <=> v45294(VarCurr) ) ).

tff(addAssignment_22682,axiom,
    ! [VarCurr: state_type] :
      ( v45293(VarCurr,1)
    <=> v45294(VarCurr) ) ).

tff(addAssignment_22681,axiom,
    ! [VarCurr: state_type] :
      ( v45294(VarCurr)
    <=> v44817(VarCurr) ) ).

tff(addAssignment_22680,axiom,
    ! [VarCurr: state_type] :
      ( v45259(VarCurr)
    <=> v45261(VarCurr) ) ).

tff(addAssignment_22679,axiom,
    ! [VarCurr: state_type] :
      ( v45261(VarCurr)
    <=> v45263(VarCurr) ) ).

tff(addAssignment_22678,axiom,
    ! [VarCurr: state_type] :
      ( v45263(VarCurr)
    <=> v45265(VarCurr) ) ).

tff(addAssignment_22677,axiom,
    ! [VarCurr: state_type] :
      ( v45265(VarCurr)
    <=> v45267(VarCurr) ) ).

tff(addAssignment_22676,axiom,
    ! [VarCurr: state_type] :
      ( v45267(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_22675,axiom,
    ! [VarCurr: state_type] :
      ( v45247(VarCurr)
    <=> v45249(VarCurr) ) ).

tff(addAssignment_22674,axiom,
    ! [VarCurr: state_type] :
      ( v45249(VarCurr)
    <=> v45251(VarCurr) ) ).

tff(addAssignment_22673,axiom,
    ! [VarCurr: state_type] :
      ( v45251(VarCurr)
    <=> v45253(VarCurr) ) ).

tff(addAssignment_22672,axiom,
    ! [VarCurr: state_type] :
      ( v45253(VarCurr)
    <=> v45255(VarCurr) ) ).

tff(addAssignment_22671,axiom,
    ! [VarCurr: state_type] :
      ( v45255(VarCurr)
    <=> v45257(VarCurr) ) ).

tff(addAssignment_22670,axiom,
    ! [VarCurr: state_type] :
      ( v45257(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_22669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44755(VarCurr,B)
      <=> v44757(VarCurr,B) ) ) ).

tff(addAssignment_22668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44757(VarCurr,B)
      <=> v44759(VarCurr,B) ) ) ).

tff(addAssignment_22667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44759(VarCurr,B)
      <=> v44761(VarCurr,B) ) ) ).

tff(addAssignment_22666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44761(VarCurr,B)
      <=> v44763(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45208(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44763(VarNext,B)
            <=> v44763(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_527,axiom,
    ! [VarNext: state_type] :
      ( v45208(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44763(VarNext,B)
          <=> v45218(VarNext,B) ) ) ) ).

tff(addAssignment_22665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45218(VarNext,B)
          <=> v45216(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45219(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45216(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_354,axiom,
    ! [VarCurr: state_type] :
      ( v45219(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45216(VarCurr,B)
          <=> v44793(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4248,axiom,
    ! [VarCurr: state_type] :
      ( v45219(VarCurr)
    <=> ( v45220(VarCurr)
        & v45221(VarCurr) ) ) ).

tff(writeUnaryOperator_2607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45221(VarCurr)
    <=> v44779(VarCurr) ) ).

tff(writeUnaryOperator_2606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45220(VarCurr)
    <=> v44765(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45208(VarNext)
      <=> v45209(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45209(VarNext)
      <=> ( v45210(VarNext)
          & v45123(VarNext) ) ) ) ).

tff(writeUnaryOperator_2605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45210(VarNext)
      <=> v45212(VarNext) ) ) ).

tff(addAssignment_22664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45212(VarNext)
      <=> v45123(VarCurr) ) ) ).

tff(addAssignment_22663,axiom,
    ! [VarCurr: state_type] :
      ( v45123(VarCurr)
    <=> v45125(VarCurr) ) ).

tff(addAssignment_22662,axiom,
    ! [VarCurr: state_type] :
      ( v45125(VarCurr)
    <=> v45127(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4245,axiom,
    ! [VarCurr: state_type] :
      ( v45127(VarCurr)
    <=> ( v45205(VarCurr)
        | v45197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4244,axiom,
    ! [VarCurr: state_type] :
      ( v45205(VarCurr)
    <=> ( v45129(VarCurr)
        & v45135(VarCurr) ) ) ).

tff(addAssignment_22661,axiom,
    ! [VarCurr: state_type] :
      ( v45197(VarCurr)
    <=> v45199(VarCurr) ) ).

tff(addAssignment_22660,axiom,
    ! [VarCurr: state_type] :
      ( v45199(VarCurr)
    <=> v45201(VarCurr) ) ).

tff(addAssignment_22659,axiom,
    ! [VarCurr: state_type] :
      ( v45201(VarCurr)
    <=> v45203(VarCurr) ) ).

tff(addAssignment_22658,axiom,
    ! [VarCurr: state_type] :
      ( v45203(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45181(VarNext)
       => ( v45135(VarNext)
        <=> v45135(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_526,axiom,
    ! [VarNext: state_type] :
      ( v45181(VarNext)
     => ( v45135(VarNext)
      <=> v45191(VarNext) ) ) ).

tff(addAssignment_22657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45191(VarNext)
      <=> v45189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4243,axiom,
    ! [VarCurr: state_type] :
      ( v45189(VarCurr)
    <=> ( v45192(VarCurr)
        & v45193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4242,axiom,
    ! [VarCurr: state_type] :
      ( v45193(VarCurr)
    <=> ( v45141(VarCurr)
        | v45172(VarCurr) ) ) ).

tff(writeUnaryOperator_2604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45192(VarCurr)
    <=> v45137(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45181(VarNext)
      <=> v45182(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45182(VarNext)
      <=> ( v45184(VarNext)
          & v45186(VarNext) ) ) ) ).

tff(writeUnaryOperator_2603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45186(VarCurr)
    <=> v45129(VarCurr) ) ).

tff(addAssignment_22656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45184(VarNext)
      <=> v45129(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_191,axiom,
    ( v45135(constB0)
  <=> $true ) ).

tff(addAssignment_22655,axiom,
    ! [VarCurr: state_type] :
      ( v45172(VarCurr)
    <=> v45174(VarCurr) ) ).

tff(addAssignment_22654,axiom,
    ! [VarCurr: state_type] :
      ( v45174(VarCurr)
    <=> v45176(VarCurr) ) ).

tff(addAssignment_22653,axiom,
    ! [VarCurr: state_type] :
      ( v45176(VarCurr)
    <=> v45178(VarCurr) ) ).

tff(addAssignment_22652,axiom,
    ! [VarCurr: state_type] :
      ( v45178(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_22651,axiom,
    ! [VarCurr: state_type] :
      ( v45141(VarCurr)
    <=> v45143(VarCurr) ) ).

tff(addAssignment_22650,axiom,
    ! [VarCurr: state_type] :
      ( v45143(VarCurr)
    <=> v45145(VarCurr) ) ).

tff(addAssignment_22649,axiom,
    ! [VarCurr: state_type] :
      ( v45145(VarCurr)
    <=> v45147(VarCurr) ) ).

tff(addAssignment_22648,axiom,
    ! [VarCurr: state_type] :
      ( v45147(VarCurr)
    <=> v45149(VarCurr) ) ).

tff(writeUnaryOperator_2602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45149(VarCurr)
    <=> v45169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4239,axiom,
    ! [VarCurr: state_type] :
      ( v45169(VarCurr)
    <=> ( v45170(VarCurr)
        | v45165(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4238,axiom,
    ! [VarCurr: state_type] :
      ( v45170(VarCurr)
    <=> ( v45151(VarCurr)
        | v45161(VarCurr) ) ) ).

tff(addAssignment_22647,axiom,
    ! [VarCurr: state_type] :
      ( v45165(VarCurr)
    <=> v45167(VarCurr) ) ).

tff(addAssignment_22646,axiom,
    ! [VarCurr: state_type] :
      ( v45167(VarCurr)
    <=> v45155(VarCurr,2) ) ).

tff(addAssignment_22645,axiom,
    ! [VarCurr: state_type] :
      ( v45155(VarCurr,2)
    <=> v45157(VarCurr,2) ) ).

tff(addAssignment_22644,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,2)
    <=> v45159(VarCurr,2) ) ).

tff(addAssignment_22643,axiom,
    ! [VarCurr: state_type] :
      ( v45161(VarCurr)
    <=> v45163(VarCurr) ) ).

tff(addAssignment_22642,axiom,
    ! [VarCurr: state_type] :
      ( v45163(VarCurr)
    <=> v45155(VarCurr,1) ) ).

tff(addAssignment_22641,axiom,
    ! [VarCurr: state_type] :
      ( v45155(VarCurr,1)
    <=> v45157(VarCurr,1) ) ).

tff(addAssignment_22640,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,1)
    <=> v45159(VarCurr,1) ) ).

tff(addAssignment_22639,axiom,
    ! [VarCurr: state_type] :
      ( v45151(VarCurr)
    <=> v45153(VarCurr) ) ).

tff(addAssignment_22638,axiom,
    ! [VarCurr: state_type] :
      ( v45153(VarCurr)
    <=> v45155(VarCurr,0) ) ).

tff(addAssignment_22637,axiom,
    ! [VarCurr: state_type] :
      ( v45155(VarCurr,0)
    <=> v45157(VarCurr,0) ) ).

tff(addAssignment_22636,axiom,
    ! [VarCurr: state_type] :
      ( v45157(VarCurr,0)
    <=> v45159(VarCurr,0) ) ).

tff(addAssignment_22635,axiom,
    ! [VarCurr: state_type] :
      ( v45137(VarCurr)
    <=> v45139(VarCurr) ) ).

tff(addAssignment_22634,axiom,
    ! [VarCurr: state_type] :
      ( v45139(VarCurr)
    <=> $false ) ).

tff(addAssignment_22633,axiom,
    ! [VarCurr: state_type] :
      ( v45129(VarCurr)
    <=> v45131(VarCurr) ) ).

tff(addAssignment_22632,axiom,
    ! [VarCurr: state_type] :
      ( v45131(VarCurr)
    <=> v45133(VarCurr) ) ).

tff(addAssignment_22631,axiom,
    ! [VarCurr: state_type] :
      ( v45133(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_22630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44793(VarCurr,B)
      <=> v44795(VarCurr,B) ) ) ).

tff(addAssignment_22629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44795(VarCurr,B)
      <=> v44797(VarCurr,B) ) ) ).

tff(addAssignment_22628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44797(VarCurr,B)
      <=> v44799(VarCurr,B) ) ) ).

tff(addAssignment_22627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44799(VarCurr,B)
      <=> v44801(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_727,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44801(VarCurr,B)
      <=> ( v44803(VarCurr,B)
          & v44825(VarCurr,B) ) ) ) ).

tff(addAssignment_22626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44825(VarCurr,B)
      <=> v44827(VarCurr,B) ) ) ).

tff(addAssignment_22625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44827(VarCurr,B)
      <=> v44829(VarCurr,B) ) ) ).

tff(addAssignment_22624,axiom,
    ! [VarCurr: state_type] :
      ( ( v44829(VarCurr,11)
      <=> v6324(VarCurr,119) )
      & ( v44829(VarCurr,10)
      <=> v6324(VarCurr,118) )
      & ( v44829(VarCurr,9)
      <=> v6324(VarCurr,117) )
      & ( v44829(VarCurr,8)
      <=> v6324(VarCurr,116) )
      & ( v44829(VarCurr,7)
      <=> v6324(VarCurr,115) )
      & ( v44829(VarCurr,6)
      <=> v6324(VarCurr,114) )
      & ( v44829(VarCurr,5)
      <=> v6324(VarCurr,113) )
      & ( v44829(VarCurr,4)
      <=> v6324(VarCurr,112) )
      & ( v44829(VarCurr,3)
      <=> v6324(VarCurr,111) )
      & ( v44829(VarCurr,2)
      <=> v6324(VarCurr,110) )
      & ( v44829(VarCurr,1)
      <=> v6324(VarCurr,109) )
      & ( v44829(VarCurr,0)
      <=> v6324(VarCurr,108) ) ) ).

tff(addAssignment_22623,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,119)
      <=> v44831(VarCurr,11) )
      & ( v6324(VarCurr,118)
      <=> v44831(VarCurr,10) )
      & ( v6324(VarCurr,117)
      <=> v44831(VarCurr,9) )
      & ( v6324(VarCurr,116)
      <=> v44831(VarCurr,8) )
      & ( v6324(VarCurr,115)
      <=> v44831(VarCurr,7) )
      & ( v6324(VarCurr,114)
      <=> v44831(VarCurr,6) )
      & ( v6324(VarCurr,113)
      <=> v44831(VarCurr,5) )
      & ( v6324(VarCurr,112)
      <=> v44831(VarCurr,4) )
      & ( v6324(VarCurr,111)
      <=> v44831(VarCurr,3) )
      & ( v6324(VarCurr,110)
      <=> v44831(VarCurr,2) )
      & ( v6324(VarCurr,109)
      <=> v44831(VarCurr,1) )
      & ( v6324(VarCurr,108)
      <=> v44831(VarCurr,0) ) ) ).

tff(addAssignment_22622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44831(VarCurr,B)
      <=> v44833(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_726,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44833(VarCurr,B)
      <=> ( v45115(VarCurr,B)
          | v45118(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_725,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45118(VarCurr,B)
      <=> ( v44843(VarCurr,B)
          & v45119(VarCurr,B) ) ) ) ).

tff(addAssignment_22621,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,0)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22620,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,1)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22619,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,2)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22618,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,3)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22617,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,4)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22616,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,5)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22615,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,6)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22614,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,7)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22613,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,8)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22612,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,9)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22611,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,10)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22610,axiom,
    ! [VarCurr: state_type] :
      ( v45119(VarCurr,11)
    <=> v45120(VarCurr) ) ).

tff(addAssignment_22609,axiom,
    ! [VarCurr: state_type] :
      ( v45120(VarCurr)
    <=> v45111(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_724,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45115(VarCurr,B)
      <=> ( v44835(VarCurr,B)
          & v45116(VarCurr,B) ) ) ) ).

tff(addAssignment_22608,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,0)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22607,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,1)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22606,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,2)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22605,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,3)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22604,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,4)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22603,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,5)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22602,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,6)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22601,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,7)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22600,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,8)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22599,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,9)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22598,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,10)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22597,axiom,
    ! [VarCurr: state_type] :
      ( v45116(VarCurr,11)
    <=> v45117(VarCurr) ) ).

tff(addAssignment_22596,axiom,
    ! [VarCurr: state_type] :
      ( v45117(VarCurr)
    <=> v44839(VarCurr) ) ).

tff(addAssignment_22595,axiom,
    ! [VarCurr: state_type] :
      ( v45111(VarCurr)
    <=> v45113(VarCurr) ) ).

tff(addAssignment_22594,axiom,
    ! [VarCurr: state_type] :
      ( v45113(VarCurr)
    <=> v7021(VarCurr,9) ) ).

tff(addAssignment_22593,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,9)
    <=> v7023(VarCurr,9) ) ).

tff(addAssignment_22592,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,9)
    <=> v6623(VarCurr,9) ) ).

tff(addAssignment_22591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44843(VarCurr,B)
      <=> v44845(VarCurr,B) ) ) ).

tff(addAssignment_22590,axiom,
    ! [VarCurr: state_type] :
      ( ( v44845(VarCurr,11)
      <=> v6334(VarCurr,131) )
      & ( v44845(VarCurr,10)
      <=> v6334(VarCurr,130) )
      & ( v44845(VarCurr,9)
      <=> v6334(VarCurr,129) )
      & ( v44845(VarCurr,8)
      <=> v6334(VarCurr,128) )
      & ( v44845(VarCurr,7)
      <=> v6334(VarCurr,127) )
      & ( v44845(VarCurr,6)
      <=> v6334(VarCurr,126) )
      & ( v44845(VarCurr,5)
      <=> v6334(VarCurr,125) )
      & ( v44845(VarCurr,4)
      <=> v6334(VarCurr,124) )
      & ( v44845(VarCurr,3)
      <=> v6334(VarCurr,123) )
      & ( v44845(VarCurr,2)
      <=> v6334(VarCurr,122) )
      & ( v44845(VarCurr,1)
      <=> v6334(VarCurr,121) )
      & ( v44845(VarCurr,0)
      <=> v6334(VarCurr,120) ) ) ).

tff(addAssignment_22589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,132)
        & ~ $less(B,120) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_22588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,132)
        & ~ $less(B,120) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_22587,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,131)
      <=> v44847(VarCurr,11) )
      & ( v6338(VarCurr,130)
      <=> v44847(VarCurr,10) )
      & ( v6338(VarCurr,129)
      <=> v44847(VarCurr,9) )
      & ( v6338(VarCurr,128)
      <=> v44847(VarCurr,8) )
      & ( v6338(VarCurr,127)
      <=> v44847(VarCurr,7) )
      & ( v6338(VarCurr,126)
      <=> v44847(VarCurr,6) )
      & ( v6338(VarCurr,125)
      <=> v44847(VarCurr,5) )
      & ( v6338(VarCurr,124)
      <=> v44847(VarCurr,4) )
      & ( v6338(VarCurr,123)
      <=> v44847(VarCurr,3) )
      & ( v6338(VarCurr,122)
      <=> v44847(VarCurr,2) )
      & ( v6338(VarCurr,121)
      <=> v44847(VarCurr,1) )
      & ( v6338(VarCurr,120)
      <=> v44847(VarCurr,0) ) ) ).

tff(addAssignment_22586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44847(VarCurr,B)
      <=> v44849(VarCurr,B) ) ) ).

tff(addAssignment_22585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44849(VarCurr,B)
      <=> v44851(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45094(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44851(VarNext,B)
            <=> v44851(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_525,axiom,
    ! [VarNext: state_type] :
      ( v45094(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44851(VarNext,B)
          <=> v45104(VarNext,B) ) ) ) ).

tff(addAssignment_22584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45104(VarNext,B)
          <=> v45102(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45102(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_353,axiom,
    ! [VarCurr: state_type] :
      ( v45105(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v45102(VarCurr,B)
          <=> v44881(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4237,axiom,
    ! [VarCurr: state_type] :
      ( v45105(VarCurr)
    <=> ( v45106(VarCurr)
        & v45107(VarCurr) ) ) ).

tff(writeUnaryOperator_2601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45107(VarCurr)
    <=> v44867(VarCurr) ) ).

tff(writeUnaryOperator_2600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45106(VarCurr)
    <=> v44853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45094(VarNext)
      <=> v45095(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45095(VarNext)
      <=> ( v45096(VarNext)
          & v45069(VarNext) ) ) ) ).

tff(writeUnaryOperator_2599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v45096(VarNext)
      <=> v45098(VarNext) ) ) ).

tff(addAssignment_22583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v45098(VarNext)
      <=> v45069(VarCurr) ) ) ).

tff(addAssignment_22582,axiom,
    ! [VarCurr: state_type] :
      ( v45069(VarCurr)
    <=> v45071(VarCurr) ) ).

tff(addAssignment_22581,axiom,
    ! [VarCurr: state_type] :
      ( v45071(VarCurr)
    <=> v45073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4234,axiom,
    ! [VarCurr: state_type] :
      ( v45073(VarCurr)
    <=> ( v45091(VarCurr)
        | v45083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4233,axiom,
    ! [VarCurr: state_type] :
      ( v45091(VarCurr)
    <=> ( v45075(VarCurr)
        & v45081(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_190,axiom,
    ( v45081(constB0)
  <=> $true ) ).

tff(addAssignment_22580,axiom,
    ! [VarCurr: state_type] :
      ( v45083(VarCurr)
    <=> v45085(VarCurr) ) ).

tff(addAssignment_22579,axiom,
    ! [VarCurr: state_type] :
      ( v45085(VarCurr)
    <=> v45087(VarCurr) ) ).

tff(addAssignment_22578,axiom,
    ! [VarCurr: state_type] :
      ( v45087(VarCurr)
    <=> v45089(VarCurr) ) ).

tff(addAssignment_22577,axiom,
    ! [VarCurr: state_type] :
      ( v45089(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_22576,axiom,
    ! [VarCurr: state_type] :
      ( v45075(VarCurr)
    <=> v45077(VarCurr) ) ).

tff(addAssignment_22575,axiom,
    ! [VarCurr: state_type] :
      ( v45077(VarCurr)
    <=> v45079(VarCurr) ) ).

tff(addAssignment_22574,axiom,
    ! [VarCurr: state_type] :
      ( v45079(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_22573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44881(VarCurr,B)
      <=> v44883(VarCurr,B) ) ) ).

tff(addAssignment_22572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44883(VarCurr,B)
      <=> v44885(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_723,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44885(VarCurr,B)
      <=> ( v45054(VarCurr,B)
          | v45065(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45065(VarCurr,B)
      <=> ( v45018(VarCurr,B)
          & v45066(VarCurr,B) ) ) ) ).

tff(addAssignment_22571,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,0)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22570,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,1)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22569,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,2)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22568,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,3)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22567,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,4)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22566,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,5)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22565,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,6)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22564,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,7)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22563,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,8)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22562,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,9)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22561,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,10)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22560,axiom,
    ! [VarCurr: state_type] :
      ( v45066(VarCurr,11)
    <=> v45067(VarCurr) ) ).

tff(addAssignment_22559,axiom,
    ! [VarCurr: state_type] :
      ( v45067(VarCurr)
    <=> v45028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45054(VarCurr,B)
      <=> ( v45055(VarCurr,B)
          | v45062(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_720,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45062(VarCurr,B)
      <=> ( v44982(VarCurr,B)
          & v45063(VarCurr,B) ) ) ) ).

tff(addAssignment_22558,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,0)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22557,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,1)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22556,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,2)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22555,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,3)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22554,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,4)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22553,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,5)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22552,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,6)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22551,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,7)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22550,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,8)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22549,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,9)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22548,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,10)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22547,axiom,
    ! [VarCurr: state_type] :
      ( v45063(VarCurr,11)
    <=> v45064(VarCurr) ) ).

tff(addAssignment_22546,axiom,
    ! [VarCurr: state_type] :
      ( v45064(VarCurr)
    <=> v44992(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45055(VarCurr,B)
      <=> ( v45056(VarCurr,B)
          | v45059(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45059(VarCurr,B)
      <=> ( v44935(VarCurr,B)
          & v45060(VarCurr,B) ) ) ) ).

tff(addAssignment_22545,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,0)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22544,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,1)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22543,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,2)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22542,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,3)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22541,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,4)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22540,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,5)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22539,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,6)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22538,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,7)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22537,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,8)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22536,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,9)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22535,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,10)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22534,axiom,
    ! [VarCurr: state_type] :
      ( v45060(VarCurr,11)
    <=> v45061(VarCurr) ) ).

tff(addAssignment_22533,axiom,
    ! [VarCurr: state_type] :
      ( v45061(VarCurr)
    <=> v44945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45056(VarCurr,B)
      <=> ( v44887(VarCurr,B)
          & v45057(VarCurr,B) ) ) ) ).

tff(addAssignment_22532,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,0)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22531,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,1)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22530,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,2)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22529,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,3)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22528,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,4)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22527,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,5)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22526,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,6)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22525,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,7)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22524,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,8)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22523,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,9)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22522,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,10)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22521,axiom,
    ! [VarCurr: state_type] :
      ( v45057(VarCurr,11)
    <=> v45058(VarCurr) ) ).

tff(addAssignment_22520,axiom,
    ! [VarCurr: state_type] :
      ( v45058(VarCurr)
    <=> v44897(VarCurr) ) ).

tff(addAssignment_22519,axiom,
    ! [VarCurr: state_type] :
      ( v45028(VarCurr)
    <=> v45030(VarCurr) ) ).

tff(addAssignment_22518,axiom,
    ! [VarCurr: state_type] :
      ( v45030(VarCurr)
    <=> v45032(VarCurr) ) ).

tff(addAssignment_22517,axiom,
    ! [VarCurr: state_type] :
      ( v45032(VarCurr)
    <=> v45034(VarCurr) ) ).

tff(addAssignment_22516,axiom,
    ! [VarCurr: state_type] :
      ( v45034(VarCurr)
    <=> v45036(VarCurr) ) ).

tff(addAssignment_22515,axiom,
    ! [VarCurr: state_type] :
      ( v45036(VarCurr)
    <=> v45038(VarCurr) ) ).

tff(addAssignment_22514,axiom,
    ! [VarCurr: state_type] :
      ( v45038(VarCurr)
    <=> v45040(VarCurr) ) ).

tff(addAssignment_22513,axiom,
    ! [VarCurr: state_type] :
      ( v45040(VarCurr)
    <=> v45042(VarCurr) ) ).

tff(writeUnaryOperator_2598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45042(VarCurr)
    <=> v45052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4232,axiom,
    ! [VarCurr: state_type] :
      ( v45052(VarCurr)
    <=> ( v45044(VarCurr)
        | v45048(VarCurr) ) ) ).

tff(addAssignment_22512,axiom,
    ! [VarCurr: state_type] :
      ( v45048(VarCurr)
    <=> v45050(VarCurr) ) ).

tff(addAssignment_22511,axiom,
    ! [VarCurr: state_type] :
      ( v45050(VarCurr)
    <=> v44965(VarCurr,1) ) ).

tff(addAssignment_22510,axiom,
    ! [VarCurr: state_type] :
      ( v45044(VarCurr)
    <=> v45046(VarCurr) ) ).

tff(addAssignment_22509,axiom,
    ! [VarCurr: state_type] :
      ( v45046(VarCurr)
    <=> v44965(VarCurr,0) ) ).

tff(addAssignment_22508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45018(VarCurr,B)
      <=> v45020(VarCurr,B) ) ) ).

tff(addAssignment_22507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45020(VarCurr,B)
      <=> v45022(VarCurr,B) ) ) ).

tff(addAssignment_22506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45022(VarCurr,B)
      <=> v45024(VarCurr,B) ) ) ).

tff(addAssignment_22505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v45024(VarCurr,B)
      <=> v45026(VarCurr,B) ) ) ).

tff(addAssignment_22504,axiom,
    ! [VarCurr: state_type] :
      ( v44992(VarCurr)
    <=> v44994(VarCurr) ) ).

tff(addAssignment_22503,axiom,
    ! [VarCurr: state_type] :
      ( v44994(VarCurr)
    <=> v44996(VarCurr) ) ).

tff(addAssignment_22502,axiom,
    ! [VarCurr: state_type] :
      ( v44996(VarCurr)
    <=> v44998(VarCurr) ) ).

tff(addAssignment_22501,axiom,
    ! [VarCurr: state_type] :
      ( v44998(VarCurr)
    <=> v45000(VarCurr) ) ).

tff(addAssignment_22500,axiom,
    ! [VarCurr: state_type] :
      ( v45000(VarCurr)
    <=> v45002(VarCurr) ) ).

tff(addAssignment_22499,axiom,
    ! [VarCurr: state_type] :
      ( v45002(VarCurr)
    <=> v45004(VarCurr) ) ).

tff(addAssignment_22498,axiom,
    ! [VarCurr: state_type] :
      ( v45004(VarCurr)
    <=> v45006(VarCurr) ) ).

tff(writeUnaryOperator_2597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v45006(VarCurr)
    <=> v45016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4231,axiom,
    ! [VarCurr: state_type] :
      ( v45016(VarCurr)
    <=> ( v45008(VarCurr)
        | v45012(VarCurr) ) ) ).

tff(addAssignment_22497,axiom,
    ! [VarCurr: state_type] :
      ( v45012(VarCurr)
    <=> v45014(VarCurr) ) ).

tff(addAssignment_22496,axiom,
    ! [VarCurr: state_type] :
      ( v45014(VarCurr)
    <=> v44965(VarCurr,1) ) ).

tff(addAssignment_22495,axiom,
    ! [VarCurr: state_type] :
      ( v44965(VarCurr,1)
    <=> v44967(VarCurr,1) ) ).

tff(addAssignment_22494,axiom,
    ! [VarCurr: state_type] :
      ( v44967(VarCurr,1)
    <=> v44969(VarCurr,1) ) ).

tff(addAssignment_22493,axiom,
    ! [VarCurr: state_type] :
      ( v44969(VarCurr,1)
    <=> v44974(VarCurr,1) ) ).

tff(addAssignment_22492,axiom,
    ! [VarCurr: state_type] :
      ( v44971(VarCurr,1)
    <=> v44973(VarCurr,1) ) ).

tff(addAssignment_22491,axiom,
    ! [VarCurr: state_type] :
      ( v44973(VarCurr,1)
    <=> v44917(VarCurr,1) ) ).

tff(addAssignment_22490,axiom,
    ! [VarCurr: state_type] :
      ( v45008(VarCurr)
    <=> v45010(VarCurr) ) ).

tff(addAssignment_22489,axiom,
    ! [VarCurr: state_type] :
      ( v45010(VarCurr)
    <=> v44917(VarCurr,0) ) ).

tff(addAssignment_22488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44982(VarCurr,B)
      <=> v44984(VarCurr,B) ) ) ).

tff(addAssignment_22487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44984(VarCurr,B)
      <=> v44986(VarCurr,B) ) ) ).

tff(addAssignment_22486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44986(VarCurr,B)
      <=> v44988(VarCurr,B) ) ) ).

tff(addAssignment_22485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44988(VarCurr,B)
      <=> v44990(VarCurr,B) ) ) ).

tff(addAssignment_22484,axiom,
    ! [VarCurr: state_type] :
      ( v44945(VarCurr)
    <=> v44947(VarCurr) ) ).

tff(addAssignment_22483,axiom,
    ! [VarCurr: state_type] :
      ( v44947(VarCurr)
    <=> v44949(VarCurr) ) ).

tff(addAssignment_22482,axiom,
    ! [VarCurr: state_type] :
      ( v44949(VarCurr)
    <=> v44951(VarCurr) ) ).

tff(addAssignment_22481,axiom,
    ! [VarCurr: state_type] :
      ( v44951(VarCurr)
    <=> v44953(VarCurr) ) ).

tff(addAssignment_22480,axiom,
    ! [VarCurr: state_type] :
      ( v44953(VarCurr)
    <=> v44955(VarCurr) ) ).

tff(addAssignment_22479,axiom,
    ! [VarCurr: state_type] :
      ( v44955(VarCurr)
    <=> v44957(VarCurr) ) ).

tff(addAssignment_22478,axiom,
    ! [VarCurr: state_type] :
      ( v44957(VarCurr)
    <=> v44959(VarCurr) ) ).

tff(writeUnaryOperator_2596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44959(VarCurr)
    <=> v44980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4230,axiom,
    ! [VarCurr: state_type] :
      ( v44980(VarCurr)
    <=> ( v44961(VarCurr)
        | v44976(VarCurr) ) ) ).

tff(addAssignment_22477,axiom,
    ! [VarCurr: state_type] :
      ( v44976(VarCurr)
    <=> v44978(VarCurr) ) ).

tff(addAssignment_22476,axiom,
    ! [VarCurr: state_type] :
      ( v44978(VarCurr)
    <=> v44917(VarCurr,1) ) ).

tff(addAssignment_22475,axiom,
    ! [VarCurr: state_type] :
      ( v44961(VarCurr)
    <=> v44963(VarCurr) ) ).

tff(addAssignment_22474,axiom,
    ! [VarCurr: state_type] :
      ( v44963(VarCurr)
    <=> v44965(VarCurr,0) ) ).

tff(addAssignment_22473,axiom,
    ! [VarCurr: state_type] :
      ( v44965(VarCurr,0)
    <=> v44967(VarCurr,0) ) ).

tff(addAssignment_22472,axiom,
    ! [VarCurr: state_type] :
      ( v44967(VarCurr,0)
    <=> v44969(VarCurr,0) ) ).

tff(addAssignment_22471,axiom,
    ! [VarCurr: state_type] :
      ( v44969(VarCurr,0)
    <=> v44974(VarCurr,0) ) ).

tff(writeUnaryOperator_2595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v44974(VarCurr,B)
      <=> ~ v44971(VarCurr,B) ) ) ).

tff(addAssignment_22470,axiom,
    ! [VarCurr: state_type] :
      ( v44971(VarCurr,0)
    <=> v44973(VarCurr,0) ) ).

tff(addAssignment_22469,axiom,
    ! [VarCurr: state_type] :
      ( v44973(VarCurr,0)
    <=> v44917(VarCurr,0) ) ).

tff(addAssignment_22468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44935(VarCurr,B)
      <=> v44937(VarCurr,B) ) ) ).

tff(addAssignment_22467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44937(VarCurr,B)
      <=> v44939(VarCurr,B) ) ) ).

tff(addAssignment_22466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44939(VarCurr,B)
      <=> v44941(VarCurr,B) ) ) ).

tff(addAssignment_22465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44941(VarCurr,B)
      <=> v44943(VarCurr,B) ) ) ).

tff(addAssignment_22464,axiom,
    ! [VarCurr: state_type] :
      ( v44897(VarCurr)
    <=> v44899(VarCurr) ) ).

tff(addAssignment_22463,axiom,
    ! [VarCurr: state_type] :
      ( v44899(VarCurr)
    <=> v44901(VarCurr) ) ).

tff(addAssignment_22462,axiom,
    ! [VarCurr: state_type] :
      ( v44901(VarCurr)
    <=> v44903(VarCurr) ) ).

tff(addAssignment_22461,axiom,
    ! [VarCurr: state_type] :
      ( v44903(VarCurr)
    <=> v44905(VarCurr) ) ).

tff(addAssignment_22460,axiom,
    ! [VarCurr: state_type] :
      ( v44905(VarCurr)
    <=> v44907(VarCurr) ) ).

tff(addAssignment_22459,axiom,
    ! [VarCurr: state_type] :
      ( v44907(VarCurr)
    <=> v44909(VarCurr) ) ).

tff(addAssignment_22458,axiom,
    ! [VarCurr: state_type] :
      ( v44909(VarCurr)
    <=> v44911(VarCurr) ) ).

tff(writeUnaryOperator_2594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44911(VarCurr)
    <=> v44933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4229,axiom,
    ! [VarCurr: state_type] :
      ( v44933(VarCurr)
    <=> ( v44913(VarCurr)
        | v44929(VarCurr) ) ) ).

tff(addAssignment_22457,axiom,
    ! [VarCurr: state_type] :
      ( v44929(VarCurr)
    <=> v44931(VarCurr) ) ).

tff(addAssignment_22456,axiom,
    ! [VarCurr: state_type] :
      ( v44931(VarCurr)
    <=> v44917(VarCurr,1) ) ).

tff(addAssignment_22455,axiom,
    ! [VarCurr: state_type] :
      ( v44917(VarCurr,1)
    <=> v44919(VarCurr,1) ) ).

tff(addAssignment_22454,axiom,
    ! [VarCurr: state_type] :
      ( v44919(VarCurr,1)
    <=> v44921(VarCurr,1) ) ).

tff(addAssignment_22453,axiom,
    ! [VarCurr: state_type] :
      ( v44921(VarCurr,1)
    <=> v44923(VarCurr,1) ) ).

tff(addAssignment_22452,axiom,
    ! [VarCurr: state_type] :
      ( v44923(VarCurr,1)
    <=> v44925(VarCurr,1) ) ).

tff(addAssignment_22451,axiom,
    ! [VarCurr: state_type] :
      ( v44925(VarCurr,1)
    <=> v44927(VarCurr,1) ) ).

tff(addAssignment_22450,axiom,
    ! [VarCurr: state_type] :
      ( v44913(VarCurr)
    <=> v44915(VarCurr) ) ).

tff(addAssignment_22449,axiom,
    ! [VarCurr: state_type] :
      ( v44915(VarCurr)
    <=> v44917(VarCurr,0) ) ).

tff(addAssignment_22448,axiom,
    ! [VarCurr: state_type] :
      ( v44917(VarCurr,0)
    <=> v44919(VarCurr,0) ) ).

tff(addAssignment_22447,axiom,
    ! [VarCurr: state_type] :
      ( v44919(VarCurr,0)
    <=> v44921(VarCurr,0) ) ).

tff(addAssignment_22446,axiom,
    ! [VarCurr: state_type] :
      ( v44921(VarCurr,0)
    <=> v44923(VarCurr,0) ) ).

tff(addAssignment_22445,axiom,
    ! [VarCurr: state_type] :
      ( v44923(VarCurr,0)
    <=> v44925(VarCurr,0) ) ).

tff(addAssignment_22444,axiom,
    ! [VarCurr: state_type] :
      ( v44925(VarCurr,0)
    <=> v44927(VarCurr,0) ) ).

tff(addAssignment_22443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44887(VarCurr,B)
      <=> v44889(VarCurr,B) ) ) ).

tff(addAssignment_22442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44889(VarCurr,B)
      <=> v44891(VarCurr,B) ) ) ).

tff(addAssignment_22441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44891(VarCurr,B)
      <=> v44893(VarCurr,B) ) ) ).

tff(addAssignment_22440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44893(VarCurr,B)
      <=> v44895(VarCurr,B) ) ) ).

tff(addAssignment_22439,axiom,
    ! [VarCurr: state_type] :
      ( v44867(VarCurr)
    <=> v44869(VarCurr) ) ).

tff(addAssignment_22438,axiom,
    ! [VarCurr: state_type] :
      ( v44869(VarCurr)
    <=> v44871(VarCurr) ) ).

tff(addAssignment_22437,axiom,
    ! [VarCurr: state_type] :
      ( v44871(VarCurr)
    <=> v44873(VarCurr) ) ).

tff(addAssignment_22436,axiom,
    ! [VarCurr: state_type] :
      ( v44873(VarCurr)
    <=> v44875(VarCurr) ) ).

tff(addAssignment_22435,axiom,
    ! [VarCurr: state_type] :
      ( v44875(VarCurr)
    <=> v44877(VarCurr) ) ).

tff(addAssignment_22434,axiom,
    ! [VarCurr: state_type] :
      ( v44877(VarCurr)
    <=> v44879(VarCurr) ) ).

tff(addAssignment_22433,axiom,
    ! [VarCurr: state_type] :
      ( v44879(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_22432,axiom,
    ! [VarCurr: state_type] :
      ( v44853(VarCurr)
    <=> v44855(VarCurr) ) ).

tff(addAssignment_22431,axiom,
    ! [VarCurr: state_type] :
      ( v44855(VarCurr)
    <=> v44857(VarCurr) ) ).

tff(addAssignment_22430,axiom,
    ! [VarCurr: state_type] :
      ( v44857(VarCurr)
    <=> v44859(VarCurr) ) ).

tff(addAssignment_22429,axiom,
    ! [VarCurr: state_type] :
      ( v44859(VarCurr)
    <=> v44861(VarCurr) ) ).

tff(addAssignment_22428,axiom,
    ! [VarCurr: state_type] :
      ( v44861(VarCurr)
    <=> v44863(VarCurr) ) ).

tff(addAssignment_22427,axiom,
    ! [VarCurr: state_type] :
      ( v44863(VarCurr)
    <=> v44865(VarCurr) ) ).

tff(addAssignment_22426,axiom,
    ! [VarCurr: state_type] :
      ( v44865(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_22425,axiom,
    ! [VarCurr: state_type] :
      ( v44839(VarCurr)
    <=> v44841(VarCurr) ) ).

tff(addAssignment_22424,axiom,
    ! [VarCurr: state_type] :
      ( v44841(VarCurr)
    <=> v6617(VarCurr,9) ) ).

tff(addAssignment_22423,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,9)
    <=> v6619(VarCurr,9) ) ).

tff(addAssignment_22422,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,9)
    <=> v6621(VarCurr,9) ) ).

tff(addAssignment_22421,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,9)
    <=> v6747(VarCurr,9) ) ).

tff(addAssignment_22420,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,9)
    <=> v6690(VarCurr,9) ) ).

tff(addAssignment_22419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44835(VarCurr,B)
      <=> v44837(VarCurr,B) ) ) ).

tff(addAssignment_22418,axiom,
    ! [VarCurr: state_type] :
      ( ( v44837(VarCurr,11)
      <=> v6334(VarCurr,119) )
      & ( v44837(VarCurr,10)
      <=> v6334(VarCurr,118) )
      & ( v44837(VarCurr,9)
      <=> v6334(VarCurr,117) )
      & ( v44837(VarCurr,8)
      <=> v6334(VarCurr,116) )
      & ( v44837(VarCurr,7)
      <=> v6334(VarCurr,115) )
      & ( v44837(VarCurr,6)
      <=> v6334(VarCurr,114) )
      & ( v44837(VarCurr,5)
      <=> v6334(VarCurr,113) )
      & ( v44837(VarCurr,4)
      <=> v6334(VarCurr,112) )
      & ( v44837(VarCurr,3)
      <=> v6334(VarCurr,111) )
      & ( v44837(VarCurr,2)
      <=> v6334(VarCurr,110) )
      & ( v44837(VarCurr,1)
      <=> v6334(VarCurr,109) )
      & ( v44837(VarCurr,0)
      <=> v6334(VarCurr,108) ) ) ).

tff(addAssignment_22417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44803(VarCurr,B)
      <=> v44805(VarCurr,B) ) ) ).

tff(addAssignment_22416,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,0)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22415,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,1)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22414,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,2)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22413,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,3)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22412,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,4)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22411,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,5)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22410,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,6)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22409,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,7)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22408,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,8)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22407,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,9)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22406,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,10)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22405,axiom,
    ! [VarCurr: state_type] :
      ( v44805(VarCurr,11)
    <=> v44823(VarCurr) ) ).

tff(addAssignment_22404,axiom,
    ! [VarCurr: state_type] :
      ( v44823(VarCurr)
    <=> v44807(VarCurr) ) ).

tff(addAssignment_22403,axiom,
    ! [VarCurr: state_type] :
      ( v44807(VarCurr)
    <=> v44809(VarCurr,0) ) ).

tff(addAssignment_22402,axiom,
    ! [VarCurr: state_type] :
      ( v44809(VarCurr,0)
    <=> v44811(VarCurr,0) ) ).

tff(addAssignment_22401,axiom,
    ! [VarCurr: state_type] :
      ( v44811(VarCurr,0)
    <=> v44821(VarCurr,0) ) ).

tff(writeUnaryOperator_2593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v44821(VarCurr,B)
      <=> ~ v44813(VarCurr,B) ) ) ).

tff(addAssignment_22400,axiom,
    ! [VarCurr: state_type] :
      ( v44813(VarCurr,0)
    <=> v44815(VarCurr,0) ) ).

tff(addAssignment_22399,axiom,
    ! [VarCurr: state_type] :
      ( v44815(VarCurr,0)
    <=> v44818(VarCurr,0) ) ).

tff(addAssignment_22398,axiom,
    ! [VarCurr: state_type] :
      ( v44818(VarCurr,0)
    <=> v44817(VarCurr) ) ).

tff(addAssignment_22397,axiom,
    ! [VarCurr: state_type] :
      ( v44818(VarCurr,1)
    <=> v44820(VarCurr) ) ).

tff(addAssignment_22396,axiom,
    ! [VarCurr: state_type] :
      ( v44818(VarCurr,2)
    <=> v44819(VarCurr) ) ).

tff(addAssignment_22395,axiom,
    ! [VarCurr: state_type] :
      ( v44817(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_22394,axiom,
    ! [VarCurr: state_type] :
      ( v44779(VarCurr)
    <=> v44781(VarCurr) ) ).

tff(addAssignment_22393,axiom,
    ! [VarCurr: state_type] :
      ( v44781(VarCurr)
    <=> v44783(VarCurr) ) ).

tff(addAssignment_22392,axiom,
    ! [VarCurr: state_type] :
      ( v44783(VarCurr)
    <=> v44785(VarCurr) ) ).

tff(addAssignment_22391,axiom,
    ! [VarCurr: state_type] :
      ( v44785(VarCurr)
    <=> v44787(VarCurr) ) ).

tff(addAssignment_22390,axiom,
    ! [VarCurr: state_type] :
      ( v44787(VarCurr)
    <=> v44789(VarCurr) ) ).

tff(addAssignment_22389,axiom,
    ! [VarCurr: state_type] :
      ( v44789(VarCurr)
    <=> v44791(VarCurr) ) ).

tff(addAssignment_22388,axiom,
    ! [VarCurr: state_type] :
      ( v44791(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_22387,axiom,
    ! [VarCurr: state_type] :
      ( v44765(VarCurr)
    <=> v44767(VarCurr) ) ).

tff(addAssignment_22386,axiom,
    ! [VarCurr: state_type] :
      ( v44767(VarCurr)
    <=> v44769(VarCurr) ) ).

tff(addAssignment_22385,axiom,
    ! [VarCurr: state_type] :
      ( v44769(VarCurr)
    <=> v44771(VarCurr) ) ).

tff(addAssignment_22384,axiom,
    ! [VarCurr: state_type] :
      ( v44771(VarCurr)
    <=> v44773(VarCurr) ) ).

tff(addAssignment_22383,axiom,
    ! [VarCurr: state_type] :
      ( v44773(VarCurr)
    <=> v44775(VarCurr) ) ).

tff(addAssignment_22382,axiom,
    ! [VarCurr: state_type] :
      ( v44775(VarCurr)
    <=> v44777(VarCurr) ) ).

tff(addAssignment_22381,axiom,
    ! [VarCurr: state_type] :
      ( v44777(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_22380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44741(VarCurr,B)
      <=> v44743(VarCurr,B) ) ) ).

tff(addAssignment_22379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44743(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_22378,axiom,
    ! [VarCurr: state_type] :
      ( v43185(VarCurr)
    <=> v43187(VarCurr) ) ).

tff(addAssignment_22377,axiom,
    ! [VarCurr: state_type] :
      ( v43187(VarCurr)
    <=> v43189(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_211,axiom,
    ! [VarCurr: state_type] :
      ( v43189(VarCurr)
    <=> ( ( v43191(VarCurr,11)
        <=> v43195(VarCurr,11) )
        & ( v43191(VarCurr,10)
        <=> v43195(VarCurr,10) )
        & ( v43191(VarCurr,9)
        <=> v43195(VarCurr,9) )
        & ( v43191(VarCurr,8)
        <=> v43195(VarCurr,8) )
        & ( v43191(VarCurr,7)
        <=> v43195(VarCurr,7) )
        & ( v43191(VarCurr,6)
        <=> v43195(VarCurr,6) )
        & ( v43191(VarCurr,5)
        <=> v43195(VarCurr,5) )
        & ( v43191(VarCurr,4)
        <=> v43195(VarCurr,4) )
        & ( v43191(VarCurr,3)
        <=> v43195(VarCurr,3) )
        & ( v43191(VarCurr,2)
        <=> v43195(VarCurr,2) )
        & ( v43191(VarCurr,1)
        <=> v43195(VarCurr,1) )
        & ( v43191(VarCurr,0)
        <=> v43195(VarCurr,0) ) ) ) ).

tff(addAssignment_22376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43195(VarCurr,B)
      <=> v43197(VarCurr,B) ) ) ).

tff(addAssignment_22375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43197(VarCurr,B)
      <=> v43199(VarCurr,B) ) ) ).

tff(addAssignment_22374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43199(VarCurr,B)
      <=> v43201(VarCurr,B) ) ) ).

tff(addAssignment_22373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43201(VarCurr,B)
      <=> v43203(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43203(VarCurr,B)
      <=> ( v44711(VarCurr,B)
          | v44730(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44730(VarCurr,B)
      <=> ( v44582(VarCurr,B)
          & v44731(VarCurr,B) ) ) ) ).

tff(addAssignment_22372,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,0)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22371,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,1)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22370,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,2)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22369,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,3)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22368,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,4)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22367,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,5)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22366,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,6)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22365,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,7)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22364,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,8)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22363,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,9)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22362,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,10)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22361,axiom,
    ! [VarCurr: state_type] :
      ( v44731(VarCurr,11)
    <=> v44732(VarCurr) ) ).

tff(addAssignment_22360,axiom,
    ! [VarCurr: state_type] :
      ( v44732(VarCurr)
    <=> v44701(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44711(VarCurr,B)
      <=> ( v44712(VarCurr,B)
          | v44727(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44727(VarCurr,B)
      <=> ( v44431(VarCurr,B)
          & v44728(VarCurr,B) ) ) ) ).

tff(addAssignment_22359,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,0)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22358,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,1)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22357,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,2)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22356,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,3)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22355,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,4)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22354,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,5)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22353,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,6)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22352,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,7)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22351,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,8)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22350,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,9)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22349,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,10)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22348,axiom,
    ! [VarCurr: state_type] :
      ( v44728(VarCurr,11)
    <=> v44729(VarCurr) ) ).

tff(addAssignment_22347,axiom,
    ! [VarCurr: state_type] :
      ( v44729(VarCurr)
    <=> v44551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44712(VarCurr,B)
      <=> ( v44713(VarCurr,B)
          | v44724(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44724(VarCurr,B)
      <=> ( v44280(VarCurr,B)
          & v44725(VarCurr,B) ) ) ) ).

tff(addAssignment_22346,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,0)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22345,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,1)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22344,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,2)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22343,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,3)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22342,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,4)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22341,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,5)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22340,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,6)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22339,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,7)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22338,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,8)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22337,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,9)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22336,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,10)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22335,axiom,
    ! [VarCurr: state_type] :
      ( v44725(VarCurr,11)
    <=> v44726(VarCurr) ) ).

tff(addAssignment_22334,axiom,
    ! [VarCurr: state_type] :
      ( v44726(VarCurr)
    <=> v44400(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44713(VarCurr,B)
      <=> ( v44714(VarCurr,B)
          | v44721(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_709,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44721(VarCurr,B)
      <=> ( v44129(VarCurr,B)
          & v44722(VarCurr,B) ) ) ) ).

tff(addAssignment_22333,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,0)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22332,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,1)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22331,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,2)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22330,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,3)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22329,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,4)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22328,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,5)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22327,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,6)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22326,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,7)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22325,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,8)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22324,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,9)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22323,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,10)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22322,axiom,
    ! [VarCurr: state_type] :
      ( v44722(VarCurr,11)
    <=> v44723(VarCurr) ) ).

tff(addAssignment_22321,axiom,
    ! [VarCurr: state_type] :
      ( v44723(VarCurr)
    <=> v44249(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44714(VarCurr,B)
      <=> ( v44715(VarCurr,B)
          | v44718(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44718(VarCurr,B)
      <=> ( v43967(VarCurr,B)
          & v44719(VarCurr,B) ) ) ) ).

tff(addAssignment_22320,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,0)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22319,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,1)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22318,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,2)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22317,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,3)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22316,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,4)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22315,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,5)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22314,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,6)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22313,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,7)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22312,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,8)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22311,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,9)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22310,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,10)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22309,axiom,
    ! [VarCurr: state_type] :
      ( v44719(VarCurr,11)
    <=> v44720(VarCurr) ) ).

tff(addAssignment_22308,axiom,
    ! [VarCurr: state_type] :
      ( v44720(VarCurr)
    <=> v44098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44715(VarCurr,B)
      <=> ( v43205(VarCurr,B)
          & v44716(VarCurr,B) ) ) ) ).

tff(addAssignment_22307,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,0)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22306,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,1)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22305,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,2)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22304,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,3)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22303,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,4)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22302,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,5)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22301,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,6)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22300,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,7)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22299,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,8)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22298,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,9)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22297,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,10)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22296,axiom,
    ! [VarCurr: state_type] :
      ( v44716(VarCurr,11)
    <=> v44717(VarCurr) ) ).

tff(addAssignment_22295,axiom,
    ! [VarCurr: state_type] :
      ( v44717(VarCurr)
    <=> v43675(VarCurr) ) ).

tff(addAssignment_22294,axiom,
    ! [VarCurr: state_type] :
      ( v44701(VarCurr)
    <=> v44703(VarCurr) ) ).

tff(addAssignment_22293,axiom,
    ! [VarCurr: state_type] :
      ( v44703(VarCurr)
    <=> v44705(VarCurr) ) ).

tff(addAssignment_22292,axiom,
    ! [VarCurr: state_type] :
      ( v44705(VarCurr)
    <=> v44707(VarCurr) ) ).

tff(addAssignment_22291,axiom,
    ! [VarCurr: state_type] :
      ( v44707(VarCurr)
    <=> v44709(VarCurr) ) ).

tff(addAssignment_22290,axiom,
    ! [VarCurr: state_type] :
      ( v44709(VarCurr)
    <=> v43768(VarCurr) ) ).

tff(addAssignment_22289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44582(VarCurr,B)
      <=> v44584(VarCurr,B) ) ) ).

tff(addAssignment_22288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44584(VarCurr,B)
      <=> v44586(VarCurr,B) ) ) ).

tff(addAssignment_22287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44586(VarCurr,B)
      <=> v44588(VarCurr,B) ) ) ).

tff(addAssignment_22286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44588(VarCurr,B)
      <=> v44590(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44684(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44590(VarNext,B)
            <=> v44590(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_524,axiom,
    ! [VarNext: state_type] :
      ( v44684(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44590(VarNext,B)
          <=> v44694(VarNext,B) ) ) ) ).

tff(addAssignment_22285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44694(VarNext,B)
          <=> v44692(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44692(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_352,axiom,
    ! [VarCurr: state_type] :
      ( v44695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44692(VarCurr,B)
          <=> v44612(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4228,axiom,
    ! [VarCurr: state_type] :
      ( v44695(VarCurr)
    <=> ( v44696(VarCurr)
        & v44697(VarCurr) ) ) ).

tff(writeUnaryOperator_2592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44697(VarCurr)
    <=> v44602(VarCurr) ) ).

tff(writeUnaryOperator_2591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44696(VarCurr)
    <=> v44592(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44684(VarNext)
      <=> v44685(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44685(VarNext)
      <=> ( v44686(VarNext)
          & v44616(VarNext) ) ) ) ).

tff(writeUnaryOperator_2590,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44686(VarNext)
      <=> v44688(VarNext) ) ) ).

tff(addAssignment_22284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44688(VarNext)
      <=> v44616(VarCurr) ) ) ).

tff(addAssignment_22283,axiom,
    ! [VarCurr: state_type] :
      ( v44616(VarCurr)
    <=> v44618(VarCurr) ) ).

tff(addAssignment_22282,axiom,
    ! [VarCurr: state_type] :
      ( v44618(VarCurr)
    <=> v44620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4225,axiom,
    ! [VarCurr: state_type] :
      ( v44620(VarCurr)
    <=> ( v44681(VarCurr)
        | v44677(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4224,axiom,
    ! [VarCurr: state_type] :
      ( v44681(VarCurr)
    <=> ( v44622(VarCurr)
        & v44626(VarCurr) ) ) ).

tff(addAssignment_22281,axiom,
    ! [VarCurr: state_type] :
      ( v44677(VarCurr)
    <=> v44679(VarCurr) ) ).

tff(addAssignment_22280,axiom,
    ! [VarCurr: state_type] :
      ( v44679(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_523,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44661(VarNext)
       => ( v44626(VarNext)
        <=> v44626(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_523,axiom,
    ! [VarNext: state_type] :
      ( v44661(VarNext)
     => ( v44626(VarNext)
      <=> v44671(VarNext) ) ) ).

tff(addAssignment_22279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44671(VarNext)
      <=> v44669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4223,axiom,
    ! [VarCurr: state_type] :
      ( v44669(VarCurr)
    <=> ( v44672(VarCurr)
        & v44673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4222,axiom,
    ! [VarCurr: state_type] :
      ( v44673(VarCurr)
    <=> ( v44632(VarCurr)
        | v44656(VarCurr) ) ) ).

tff(writeUnaryOperator_2589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44672(VarCurr)
    <=> v44628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44661(VarNext)
      <=> v44662(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44662(VarNext)
      <=> ( v44664(VarNext)
          & v44666(VarNext) ) ) ) ).

tff(writeUnaryOperator_2588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44666(VarCurr)
    <=> v44622(VarCurr) ) ).

tff(addAssignment_22278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44664(VarNext)
      <=> v44622(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_189,axiom,
    ( v44626(constB0)
  <=> $true ) ).

tff(addAssignment_22277,axiom,
    ! [VarCurr: state_type] :
      ( v44656(VarCurr)
    <=> v44658(VarCurr) ) ).

tff(addAssignment_22276,axiom,
    ! [VarCurr: state_type] :
      ( v44658(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_22275,axiom,
    ! [VarCurr: state_type] :
      ( v44632(VarCurr)
    <=> v44634(VarCurr) ) ).

tff(addAssignment_22274,axiom,
    ! [VarCurr: state_type] :
      ( v44634(VarCurr)
    <=> v43942(VarCurr) ) ).

tff(addAssignment_22273,axiom,
    ! [VarCurr: state_type] :
      ( v43942(VarCurr)
    <=> v44637(VarCurr) ) ).

tff(addAssignment_22272,axiom,
    ! [VarCurr: state_type] :
      ( v44637(VarCurr)
    <=> v44639(VarCurr) ) ).

tff(writeUnaryOperator_2587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44639(VarCurr)
    <=> v44653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4219,axiom,
    ! [VarCurr: state_type] :
      ( v44653(VarCurr)
    <=> ( v44654(VarCurr)
        | v44649(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4218,axiom,
    ! [VarCurr: state_type] :
      ( v44654(VarCurr)
    <=> ( v44641(VarCurr)
        | v44645(VarCurr) ) ) ).

tff(addAssignment_22271,axiom,
    ! [VarCurr: state_type] :
      ( v44649(VarCurr)
    <=> v44651(VarCurr) ) ).

tff(addAssignment_22270,axiom,
    ! [VarCurr: state_type] :
      ( v44651(VarCurr)
    <=> v44031(VarCurr,2) ) ).

tff(addAssignment_22269,axiom,
    ! [VarCurr: state_type] :
      ( v44645(VarCurr)
    <=> v44647(VarCurr) ) ).

tff(addAssignment_22268,axiom,
    ! [VarCurr: state_type] :
      ( v44647(VarCurr)
    <=> v43605(VarCurr,1) ) ).

tff(addAssignment_22267,axiom,
    ! [VarCurr: state_type] :
      ( v44641(VarCurr)
    <=> v44643(VarCurr) ) ).

tff(addAssignment_22266,axiom,
    ! [VarCurr: state_type] :
      ( v44643(VarCurr)
    <=> v44031(VarCurr,0) ) ).

tff(addAssignment_22265,axiom,
    ! [VarCurr: state_type] :
      ( v44628(VarCurr)
    <=> v44630(VarCurr) ) ).

tff(addAssignment_22264,axiom,
    ! [VarCurr: state_type] :
      ( v44630(VarCurr)
    <=> $false ) ).

tff(addAssignment_22263,axiom,
    ! [VarCurr: state_type] :
      ( v44622(VarCurr)
    <=> v44624(VarCurr) ) ).

tff(addAssignment_22262,axiom,
    ! [VarCurr: state_type] :
      ( v44624(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_22261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44612(VarCurr,B)
      <=> v44614(VarCurr,B) ) ) ).

tff(addAssignment_22260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44614(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_22259,axiom,
    ! [VarCurr: state_type] :
      ( v44602(VarCurr)
    <=> v44604(VarCurr) ) ).

tff(addAssignment_22258,axiom,
    ! [VarCurr: state_type] :
      ( v44604(VarCurr)
    <=> v44606(VarCurr) ) ).

tff(addAssignment_22257,axiom,
    ! [VarCurr: state_type] :
      ( v44606(VarCurr)
    <=> v44608(VarCurr) ) ).

tff(addAssignment_22256,axiom,
    ! [VarCurr: state_type] :
      ( v44608(VarCurr)
    <=> v44610(VarCurr) ) ).

tff(addAssignment_22255,axiom,
    ! [VarCurr: state_type] :
      ( v44610(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_22254,axiom,
    ! [VarCurr: state_type] :
      ( v44592(VarCurr)
    <=> v44594(VarCurr) ) ).

tff(addAssignment_22253,axiom,
    ! [VarCurr: state_type] :
      ( v44594(VarCurr)
    <=> v44596(VarCurr) ) ).

tff(addAssignment_22252,axiom,
    ! [VarCurr: state_type] :
      ( v44596(VarCurr)
    <=> v44598(VarCurr) ) ).

tff(addAssignment_22251,axiom,
    ! [VarCurr: state_type] :
      ( v44598(VarCurr)
    <=> v44600(VarCurr) ) ).

tff(addAssignment_22250,axiom,
    ! [VarCurr: state_type] :
      ( v44600(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_22249,axiom,
    ! [VarCurr: state_type] :
      ( v44551(VarCurr)
    <=> v44553(VarCurr) ) ).

tff(addAssignment_22248,axiom,
    ! [VarCurr: state_type] :
      ( v44553(VarCurr)
    <=> v44555(VarCurr) ) ).

tff(addAssignment_22247,axiom,
    ! [VarCurr: state_type] :
      ( v44555(VarCurr)
    <=> v44557(VarCurr) ) ).

tff(addAssignment_22246,axiom,
    ! [VarCurr: state_type] :
      ( v44557(VarCurr)
    <=> v44559(VarCurr) ) ).

tff(addAssignment_22245,axiom,
    ! [VarCurr: state_type] :
      ( v44559(VarCurr)
    <=> v44561(VarCurr) ) ).

tff(addAssignment_22244,axiom,
    ! [VarCurr: state_type] :
      ( v44561(VarCurr)
    <=> v44563(VarCurr) ) ).

tff(addAssignment_22243,axiom,
    ! [VarCurr: state_type] :
      ( v44563(VarCurr)
    <=> v44565(VarCurr) ) ).

tff(writeUnaryOperator_2586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44565(VarCurr)
    <=> v44579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4217,axiom,
    ! [VarCurr: state_type] :
      ( v44579(VarCurr)
    <=> ( v44580(VarCurr)
        | v44575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4216,axiom,
    ! [VarCurr: state_type] :
      ( v44580(VarCurr)
    <=> ( v44567(VarCurr)
        | v44571(VarCurr) ) ) ).

tff(addAssignment_22242,axiom,
    ! [VarCurr: state_type] :
      ( v44575(VarCurr)
    <=> v44577(VarCurr) ) ).

tff(addAssignment_22241,axiom,
    ! [VarCurr: state_type] :
      ( v44577(VarCurr)
    <=> v43778(VarCurr,2) ) ).

tff(addAssignment_22240,axiom,
    ! [VarCurr: state_type] :
      ( v44571(VarCurr)
    <=> v44573(VarCurr) ) ).

tff(addAssignment_22239,axiom,
    ! [VarCurr: state_type] :
      ( v44573(VarCurr)
    <=> v43695(VarCurr,1) ) ).

tff(addAssignment_22238,axiom,
    ! [VarCurr: state_type] :
      ( v44567(VarCurr)
    <=> v44569(VarCurr) ) ).

tff(addAssignment_22237,axiom,
    ! [VarCurr: state_type] :
      ( v44569(VarCurr)
    <=> v43695(VarCurr,0) ) ).

tff(addAssignment_22236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44431(VarCurr,B)
      <=> v44433(VarCurr,B) ) ) ).

tff(addAssignment_22235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44433(VarCurr,B)
      <=> v44435(VarCurr,B) ) ) ).

tff(addAssignment_22234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44435(VarCurr,B)
      <=> v44437(VarCurr,B) ) ) ).

tff(addAssignment_22233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44437(VarCurr,B)
      <=> v44439(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44534(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44439(VarNext,B)
            <=> v44439(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_522,axiom,
    ! [VarNext: state_type] :
      ( v44534(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44439(VarNext,B)
          <=> v44544(VarNext,B) ) ) ) ).

tff(addAssignment_22232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44544(VarNext,B)
          <=> v44542(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44545(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44542(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_351,axiom,
    ! [VarCurr: state_type] :
      ( v44545(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44542(VarCurr,B)
          <=> v44461(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4215,axiom,
    ! [VarCurr: state_type] :
      ( v44545(VarCurr)
    <=> ( v44546(VarCurr)
        & v44547(VarCurr) ) ) ).

tff(writeUnaryOperator_2585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44547(VarCurr)
    <=> v44451(VarCurr) ) ).

tff(writeUnaryOperator_2584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44546(VarCurr)
    <=> v44441(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44534(VarNext)
      <=> v44535(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44535(VarNext)
      <=> ( v44536(VarNext)
          & v44465(VarNext) ) ) ) ).

tff(writeUnaryOperator_2583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44536(VarNext)
      <=> v44538(VarNext) ) ) ).

tff(addAssignment_22231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44538(VarNext)
      <=> v44465(VarCurr) ) ) ).

tff(addAssignment_22230,axiom,
    ! [VarCurr: state_type] :
      ( v44465(VarCurr)
    <=> v44467(VarCurr) ) ).

tff(addAssignment_22229,axiom,
    ! [VarCurr: state_type] :
      ( v44467(VarCurr)
    <=> v44469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4212,axiom,
    ! [VarCurr: state_type] :
      ( v44469(VarCurr)
    <=> ( v44531(VarCurr)
        | v44527(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4211,axiom,
    ! [VarCurr: state_type] :
      ( v44531(VarCurr)
    <=> ( v44471(VarCurr)
        & v44475(VarCurr) ) ) ).

tff(addAssignment_22228,axiom,
    ! [VarCurr: state_type] :
      ( v44527(VarCurr)
    <=> v44529(VarCurr) ) ).

tff(addAssignment_22227,axiom,
    ! [VarCurr: state_type] :
      ( v44529(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44511(VarNext)
       => ( v44475(VarNext)
        <=> v44475(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_521,axiom,
    ! [VarNext: state_type] :
      ( v44511(VarNext)
     => ( v44475(VarNext)
      <=> v44521(VarNext) ) ) ).

tff(addAssignment_22226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44521(VarNext)
      <=> v44519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4210,axiom,
    ! [VarCurr: state_type] :
      ( v44519(VarCurr)
    <=> ( v44522(VarCurr)
        & v44523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4209,axiom,
    ! [VarCurr: state_type] :
      ( v44523(VarCurr)
    <=> ( v44481(VarCurr)
        | v44506(VarCurr) ) ) ).

tff(writeUnaryOperator_2582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44522(VarCurr)
    <=> v44477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44511(VarNext)
      <=> v44512(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44512(VarNext)
      <=> ( v44514(VarNext)
          & v44516(VarNext) ) ) ) ).

tff(writeUnaryOperator_2581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44516(VarCurr)
    <=> v44471(VarCurr) ) ).

tff(addAssignment_22225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44514(VarNext)
      <=> v44471(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_188,axiom,
    ( v44475(constB0)
  <=> $true ) ).

tff(addAssignment_22224,axiom,
    ! [VarCurr: state_type] :
      ( v44506(VarCurr)
    <=> v44508(VarCurr) ) ).

tff(addAssignment_22223,axiom,
    ! [VarCurr: state_type] :
      ( v44508(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_22222,axiom,
    ! [VarCurr: state_type] :
      ( v44481(VarCurr)
    <=> v44483(VarCurr) ) ).

tff(addAssignment_22221,axiom,
    ! [VarCurr: state_type] :
      ( v44483(VarCurr)
    <=> v44485(VarCurr) ) ).

tff(addAssignment_22220,axiom,
    ! [VarCurr: state_type] :
      ( v44485(VarCurr)
    <=> v44487(VarCurr) ) ).

tff(addAssignment_22219,axiom,
    ! [VarCurr: state_type] :
      ( v44487(VarCurr)
    <=> v44489(VarCurr) ) ).

tff(writeUnaryOperator_2580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44489(VarCurr)
    <=> v44503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4206,axiom,
    ! [VarCurr: state_type] :
      ( v44503(VarCurr)
    <=> ( v44504(VarCurr)
        | v44499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4205,axiom,
    ! [VarCurr: state_type] :
      ( v44504(VarCurr)
    <=> ( v44491(VarCurr)
        | v44495(VarCurr) ) ) ).

tff(addAssignment_22218,axiom,
    ! [VarCurr: state_type] :
      ( v44499(VarCurr)
    <=> v44501(VarCurr) ) ).

tff(addAssignment_22217,axiom,
    ! [VarCurr: state_type] :
      ( v44501(VarCurr)
    <=> v44031(VarCurr,2) ) ).

tff(addAssignment_22216,axiom,
    ! [VarCurr: state_type] :
      ( v44031(VarCurr,2)
    <=> v44033(VarCurr,2) ) ).

tff(addAssignment_22215,axiom,
    ! [VarCurr: state_type] :
      ( v44033(VarCurr,2)
    <=> v44035(VarCurr,2) ) ).

tff(addAssignment_22214,axiom,
    ! [VarCurr: state_type] :
      ( v44035(VarCurr,2)
    <=> v44040(VarCurr,2) ) ).

tff(addAssignment_22213,axiom,
    ! [VarCurr: state_type] :
      ( v44037(VarCurr,2)
    <=> v44039(VarCurr,2) ) ).

tff(addAssignment_22212,axiom,
    ! [VarCurr: state_type] :
      ( v44039(VarCurr,2)
    <=> v43605(VarCurr,2) ) ).

tff(addAssignment_22211,axiom,
    ! [VarCurr: state_type] :
      ( v44495(VarCurr)
    <=> v44497(VarCurr) ) ).

tff(addAssignment_22210,axiom,
    ! [VarCurr: state_type] :
      ( v44497(VarCurr)
    <=> v43605(VarCurr,1) ) ).

tff(addAssignment_22209,axiom,
    ! [VarCurr: state_type] :
      ( v44491(VarCurr)
    <=> v44493(VarCurr) ) ).

tff(addAssignment_22208,axiom,
    ! [VarCurr: state_type] :
      ( v44493(VarCurr)
    <=> v43605(VarCurr,0) ) ).

tff(addAssignment_22207,axiom,
    ! [VarCurr: state_type] :
      ( v44477(VarCurr)
    <=> v44479(VarCurr) ) ).

tff(addAssignment_22206,axiom,
    ! [VarCurr: state_type] :
      ( v44479(VarCurr)
    <=> $false ) ).

tff(addAssignment_22205,axiom,
    ! [VarCurr: state_type] :
      ( v44471(VarCurr)
    <=> v44473(VarCurr) ) ).

tff(addAssignment_22204,axiom,
    ! [VarCurr: state_type] :
      ( v44473(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_22203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44461(VarCurr,B)
      <=> v44463(VarCurr,B) ) ) ).

tff(addAssignment_22202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44463(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_22201,axiom,
    ! [VarCurr: state_type] :
      ( v44451(VarCurr)
    <=> v44453(VarCurr) ) ).

tff(addAssignment_22200,axiom,
    ! [VarCurr: state_type] :
      ( v44453(VarCurr)
    <=> v44455(VarCurr) ) ).

tff(addAssignment_22199,axiom,
    ! [VarCurr: state_type] :
      ( v44455(VarCurr)
    <=> v44457(VarCurr) ) ).

tff(addAssignment_22198,axiom,
    ! [VarCurr: state_type] :
      ( v44457(VarCurr)
    <=> v44459(VarCurr) ) ).

tff(addAssignment_22197,axiom,
    ! [VarCurr: state_type] :
      ( v44459(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_22196,axiom,
    ! [VarCurr: state_type] :
      ( v44441(VarCurr)
    <=> v44443(VarCurr) ) ).

tff(addAssignment_22195,axiom,
    ! [VarCurr: state_type] :
      ( v44443(VarCurr)
    <=> v44445(VarCurr) ) ).

tff(addAssignment_22194,axiom,
    ! [VarCurr: state_type] :
      ( v44445(VarCurr)
    <=> v44447(VarCurr) ) ).

tff(addAssignment_22193,axiom,
    ! [VarCurr: state_type] :
      ( v44447(VarCurr)
    <=> v44449(VarCurr) ) ).

tff(addAssignment_22192,axiom,
    ! [VarCurr: state_type] :
      ( v44449(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_22191,axiom,
    ! [VarCurr: state_type] :
      ( v44400(VarCurr)
    <=> v44402(VarCurr) ) ).

tff(addAssignment_22190,axiom,
    ! [VarCurr: state_type] :
      ( v44402(VarCurr)
    <=> v44404(VarCurr) ) ).

tff(addAssignment_22189,axiom,
    ! [VarCurr: state_type] :
      ( v44404(VarCurr)
    <=> v44406(VarCurr) ) ).

tff(addAssignment_22188,axiom,
    ! [VarCurr: state_type] :
      ( v44406(VarCurr)
    <=> v44408(VarCurr) ) ).

tff(addAssignment_22187,axiom,
    ! [VarCurr: state_type] :
      ( v44408(VarCurr)
    <=> v44410(VarCurr) ) ).

tff(addAssignment_22186,axiom,
    ! [VarCurr: state_type] :
      ( v44410(VarCurr)
    <=> v44412(VarCurr) ) ).

tff(addAssignment_22185,axiom,
    ! [VarCurr: state_type] :
      ( v44412(VarCurr)
    <=> v44414(VarCurr) ) ).

tff(writeUnaryOperator_2579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44414(VarCurr)
    <=> v44428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4204,axiom,
    ! [VarCurr: state_type] :
      ( v44428(VarCurr)
    <=> ( v44429(VarCurr)
        | v44424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4203,axiom,
    ! [VarCurr: state_type] :
      ( v44429(VarCurr)
    <=> ( v44416(VarCurr)
        | v44420(VarCurr) ) ) ).

tff(addAssignment_22184,axiom,
    ! [VarCurr: state_type] :
      ( v44424(VarCurr)
    <=> v44426(VarCurr) ) ).

tff(addAssignment_22183,axiom,
    ! [VarCurr: state_type] :
      ( v44426(VarCurr)
    <=> v43695(VarCurr,2) ) ).

tff(addAssignment_22182,axiom,
    ! [VarCurr: state_type] :
      ( v44420(VarCurr)
    <=> v44422(VarCurr) ) ).

tff(addAssignment_22181,axiom,
    ! [VarCurr: state_type] :
      ( v44422(VarCurr)
    <=> v43778(VarCurr,1) ) ).

tff(addAssignment_22180,axiom,
    ! [VarCurr: state_type] :
      ( v44416(VarCurr)
    <=> v44418(VarCurr) ) ).

tff(addAssignment_22179,axiom,
    ! [VarCurr: state_type] :
      ( v44418(VarCurr)
    <=> v43778(VarCurr,0) ) ).

tff(addAssignment_22178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44280(VarCurr,B)
      <=> v44282(VarCurr,B) ) ) ).

tff(addAssignment_22177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44282(VarCurr,B)
      <=> v44284(VarCurr,B) ) ) ).

tff(addAssignment_22176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44284(VarCurr,B)
      <=> v44286(VarCurr,B) ) ) ).

tff(addAssignment_22175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44286(VarCurr,B)
      <=> v44288(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44383(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44288(VarNext,B)
            <=> v44288(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_520,axiom,
    ! [VarNext: state_type] :
      ( v44383(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44288(VarNext,B)
          <=> v44393(VarNext,B) ) ) ) ).

tff(addAssignment_22174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44393(VarNext,B)
          <=> v44391(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44394(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44391(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_350,axiom,
    ! [VarCurr: state_type] :
      ( v44394(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44391(VarCurr,B)
          <=> v44310(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4202,axiom,
    ! [VarCurr: state_type] :
      ( v44394(VarCurr)
    <=> ( v44395(VarCurr)
        & v44396(VarCurr) ) ) ).

tff(writeUnaryOperator_2578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44396(VarCurr)
    <=> v44300(VarCurr) ) ).

tff(writeUnaryOperator_2577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44395(VarCurr)
    <=> v44290(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44383(VarNext)
      <=> v44384(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44384(VarNext)
      <=> ( v44385(VarNext)
          & v44314(VarNext) ) ) ) ).

tff(writeUnaryOperator_2576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44385(VarNext)
      <=> v44387(VarNext) ) ) ).

tff(addAssignment_22173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44387(VarNext)
      <=> v44314(VarCurr) ) ) ).

tff(addAssignment_22172,axiom,
    ! [VarCurr: state_type] :
      ( v44314(VarCurr)
    <=> v44316(VarCurr) ) ).

tff(addAssignment_22171,axiom,
    ! [VarCurr: state_type] :
      ( v44316(VarCurr)
    <=> v44318(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4199,axiom,
    ! [VarCurr: state_type] :
      ( v44318(VarCurr)
    <=> ( v44380(VarCurr)
        | v44376(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4198,axiom,
    ! [VarCurr: state_type] :
      ( v44380(VarCurr)
    <=> ( v44320(VarCurr)
        & v44324(VarCurr) ) ) ).

tff(addAssignment_22170,axiom,
    ! [VarCurr: state_type] :
      ( v44376(VarCurr)
    <=> v44378(VarCurr) ) ).

tff(addAssignment_22169,axiom,
    ! [VarCurr: state_type] :
      ( v44378(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44360(VarNext)
       => ( v44324(VarNext)
        <=> v44324(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_519,axiom,
    ! [VarNext: state_type] :
      ( v44360(VarNext)
     => ( v44324(VarNext)
      <=> v44370(VarNext) ) ) ).

tff(addAssignment_22168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44370(VarNext)
      <=> v44368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4197,axiom,
    ! [VarCurr: state_type] :
      ( v44368(VarCurr)
    <=> ( v44371(VarCurr)
        & v44372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4196,axiom,
    ! [VarCurr: state_type] :
      ( v44372(VarCurr)
    <=> ( v44330(VarCurr)
        | v44355(VarCurr) ) ) ).

tff(writeUnaryOperator_2575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44371(VarCurr)
    <=> v44326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44360(VarNext)
      <=> v44361(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44361(VarNext)
      <=> ( v44363(VarNext)
          & v44365(VarNext) ) ) ) ).

tff(writeUnaryOperator_2574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44365(VarCurr)
    <=> v44320(VarCurr) ) ).

tff(addAssignment_22167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44363(VarNext)
      <=> v44320(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_187,axiom,
    ( v44324(constB0)
  <=> $true ) ).

tff(addAssignment_22166,axiom,
    ! [VarCurr: state_type] :
      ( v44355(VarCurr)
    <=> v44357(VarCurr) ) ).

tff(addAssignment_22165,axiom,
    ! [VarCurr: state_type] :
      ( v44357(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_22164,axiom,
    ! [VarCurr: state_type] :
      ( v44330(VarCurr)
    <=> v44332(VarCurr) ) ).

tff(addAssignment_22163,axiom,
    ! [VarCurr: state_type] :
      ( v44332(VarCurr)
    <=> v44334(VarCurr) ) ).

tff(addAssignment_22162,axiom,
    ! [VarCurr: state_type] :
      ( v44334(VarCurr)
    <=> v44336(VarCurr) ) ).

tff(addAssignment_22161,axiom,
    ! [VarCurr: state_type] :
      ( v44336(VarCurr)
    <=> v44338(VarCurr) ) ).

tff(writeUnaryOperator_2573,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44338(VarCurr)
    <=> v44352(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4193,axiom,
    ! [VarCurr: state_type] :
      ( v44352(VarCurr)
    <=> ( v44353(VarCurr)
        | v44348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4192,axiom,
    ! [VarCurr: state_type] :
      ( v44353(VarCurr)
    <=> ( v44340(VarCurr)
        | v44344(VarCurr) ) ) ).

tff(addAssignment_22160,axiom,
    ! [VarCurr: state_type] :
      ( v44348(VarCurr)
    <=> v44350(VarCurr) ) ).

tff(addAssignment_22159,axiom,
    ! [VarCurr: state_type] :
      ( v44350(VarCurr)
    <=> v43605(VarCurr,2) ) ).

tff(addAssignment_22158,axiom,
    ! [VarCurr: state_type] :
      ( v44344(VarCurr)
    <=> v44346(VarCurr) ) ).

tff(addAssignment_22157,axiom,
    ! [VarCurr: state_type] :
      ( v44346(VarCurr)
    <=> v44031(VarCurr,1) ) ).

tff(addAssignment_22156,axiom,
    ! [VarCurr: state_type] :
      ( v44340(VarCurr)
    <=> v44342(VarCurr) ) ).

tff(addAssignment_22155,axiom,
    ! [VarCurr: state_type] :
      ( v44342(VarCurr)
    <=> v44031(VarCurr,0) ) ).

tff(addAssignment_22154,axiom,
    ! [VarCurr: state_type] :
      ( v44326(VarCurr)
    <=> v44328(VarCurr) ) ).

tff(addAssignment_22153,axiom,
    ! [VarCurr: state_type] :
      ( v44328(VarCurr)
    <=> $false ) ).

tff(addAssignment_22152,axiom,
    ! [VarCurr: state_type] :
      ( v44320(VarCurr)
    <=> v44322(VarCurr) ) ).

tff(addAssignment_22151,axiom,
    ! [VarCurr: state_type] :
      ( v44322(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_22150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44310(VarCurr,B)
      <=> v44312(VarCurr,B) ) ) ).

tff(addAssignment_22149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44312(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_22148,axiom,
    ! [VarCurr: state_type] :
      ( v44300(VarCurr)
    <=> v44302(VarCurr) ) ).

tff(addAssignment_22147,axiom,
    ! [VarCurr: state_type] :
      ( v44302(VarCurr)
    <=> v44304(VarCurr) ) ).

tff(addAssignment_22146,axiom,
    ! [VarCurr: state_type] :
      ( v44304(VarCurr)
    <=> v44306(VarCurr) ) ).

tff(addAssignment_22145,axiom,
    ! [VarCurr: state_type] :
      ( v44306(VarCurr)
    <=> v44308(VarCurr) ) ).

tff(addAssignment_22144,axiom,
    ! [VarCurr: state_type] :
      ( v44308(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_22143,axiom,
    ! [VarCurr: state_type] :
      ( v44290(VarCurr)
    <=> v44292(VarCurr) ) ).

tff(addAssignment_22142,axiom,
    ! [VarCurr: state_type] :
      ( v44292(VarCurr)
    <=> v44294(VarCurr) ) ).

tff(addAssignment_22141,axiom,
    ! [VarCurr: state_type] :
      ( v44294(VarCurr)
    <=> v44296(VarCurr) ) ).

tff(addAssignment_22140,axiom,
    ! [VarCurr: state_type] :
      ( v44296(VarCurr)
    <=> v44298(VarCurr) ) ).

tff(addAssignment_22139,axiom,
    ! [VarCurr: state_type] :
      ( v44298(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_22138,axiom,
    ! [VarCurr: state_type] :
      ( v44249(VarCurr)
    <=> v44251(VarCurr) ) ).

tff(addAssignment_22137,axiom,
    ! [VarCurr: state_type] :
      ( v44251(VarCurr)
    <=> v44253(VarCurr) ) ).

tff(addAssignment_22136,axiom,
    ! [VarCurr: state_type] :
      ( v44253(VarCurr)
    <=> v44255(VarCurr) ) ).

tff(addAssignment_22135,axiom,
    ! [VarCurr: state_type] :
      ( v44255(VarCurr)
    <=> v44257(VarCurr) ) ).

tff(addAssignment_22134,axiom,
    ! [VarCurr: state_type] :
      ( v44257(VarCurr)
    <=> v44259(VarCurr) ) ).

tff(addAssignment_22133,axiom,
    ! [VarCurr: state_type] :
      ( v44259(VarCurr)
    <=> v44261(VarCurr) ) ).

tff(addAssignment_22132,axiom,
    ! [VarCurr: state_type] :
      ( v44261(VarCurr)
    <=> v44263(VarCurr) ) ).

tff(writeUnaryOperator_2572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44263(VarCurr)
    <=> v44277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4191,axiom,
    ! [VarCurr: state_type] :
      ( v44277(VarCurr)
    <=> ( v44278(VarCurr)
        | v44273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4190,axiom,
    ! [VarCurr: state_type] :
      ( v44278(VarCurr)
    <=> ( v44265(VarCurr)
        | v44269(VarCurr) ) ) ).

tff(addAssignment_22131,axiom,
    ! [VarCurr: state_type] :
      ( v44273(VarCurr)
    <=> v44275(VarCurr) ) ).

tff(addAssignment_22130,axiom,
    ! [VarCurr: state_type] :
      ( v44275(VarCurr)
    <=> v43695(VarCurr,2) ) ).

tff(addAssignment_22129,axiom,
    ! [VarCurr: state_type] :
      ( v44269(VarCurr)
    <=> v44271(VarCurr) ) ).

tff(addAssignment_22128,axiom,
    ! [VarCurr: state_type] :
      ( v44271(VarCurr)
    <=> v43778(VarCurr,1) ) ).

tff(addAssignment_22127,axiom,
    ! [VarCurr: state_type] :
      ( v43778(VarCurr,1)
    <=> v43780(VarCurr,1) ) ).

tff(addAssignment_22126,axiom,
    ! [VarCurr: state_type] :
      ( v43780(VarCurr,1)
    <=> v43782(VarCurr,1) ) ).

tff(addAssignment_22125,axiom,
    ! [VarCurr: state_type] :
      ( v43782(VarCurr,1)
    <=> v43787(VarCurr,1) ) ).

tff(addAssignment_22124,axiom,
    ! [VarCurr: state_type] :
      ( v43784(VarCurr,1)
    <=> v43786(VarCurr,1) ) ).

tff(addAssignment_22123,axiom,
    ! [VarCurr: state_type] :
      ( v43786(VarCurr,1)
    <=> v43695(VarCurr,1) ) ).

tff(addAssignment_22122,axiom,
    ! [VarCurr: state_type] :
      ( v44265(VarCurr)
    <=> v44267(VarCurr) ) ).

tff(addAssignment_22121,axiom,
    ! [VarCurr: state_type] :
      ( v44267(VarCurr)
    <=> v43695(VarCurr,0) ) ).

tff(addAssignment_22120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44129(VarCurr,B)
      <=> v44131(VarCurr,B) ) ) ).

tff(addAssignment_22119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44131(VarCurr,B)
      <=> v44133(VarCurr,B) ) ) ).

tff(addAssignment_22118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44133(VarCurr,B)
      <=> v44135(VarCurr,B) ) ) ).

tff(addAssignment_22117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44135(VarCurr,B)
      <=> v44137(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44232(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v44137(VarNext,B)
            <=> v44137(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_518,axiom,
    ! [VarNext: state_type] :
      ( v44232(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44137(VarNext,B)
          <=> v44242(VarNext,B) ) ) ) ).

tff(addAssignment_22116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44242(VarNext,B)
          <=> v44240(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44243(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44240(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_349,axiom,
    ! [VarCurr: state_type] :
      ( v44243(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44240(VarCurr,B)
          <=> v44159(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4189,axiom,
    ! [VarCurr: state_type] :
      ( v44243(VarCurr)
    <=> ( v44244(VarCurr)
        & v44245(VarCurr) ) ) ).

tff(writeUnaryOperator_2571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44245(VarCurr)
    <=> v44149(VarCurr) ) ).

tff(writeUnaryOperator_2570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44244(VarCurr)
    <=> v44139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44232(VarNext)
      <=> v44233(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44233(VarNext)
      <=> ( v44234(VarNext)
          & v44163(VarNext) ) ) ) ).

tff(writeUnaryOperator_2569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44234(VarNext)
      <=> v44236(VarNext) ) ) ).

tff(addAssignment_22115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44236(VarNext)
      <=> v44163(VarCurr) ) ) ).

tff(addAssignment_22114,axiom,
    ! [VarCurr: state_type] :
      ( v44163(VarCurr)
    <=> v44165(VarCurr) ) ).

tff(addAssignment_22113,axiom,
    ! [VarCurr: state_type] :
      ( v44165(VarCurr)
    <=> v44167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4186,axiom,
    ! [VarCurr: state_type] :
      ( v44167(VarCurr)
    <=> ( v44229(VarCurr)
        | v44225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4185,axiom,
    ! [VarCurr: state_type] :
      ( v44229(VarCurr)
    <=> ( v44169(VarCurr)
        & v44173(VarCurr) ) ) ).

tff(addAssignment_22112,axiom,
    ! [VarCurr: state_type] :
      ( v44225(VarCurr)
    <=> v44227(VarCurr) ) ).

tff(addAssignment_22111,axiom,
    ! [VarCurr: state_type] :
      ( v44227(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44209(VarNext)
       => ( v44173(VarNext)
        <=> v44173(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_517,axiom,
    ! [VarNext: state_type] :
      ( v44209(VarNext)
     => ( v44173(VarNext)
      <=> v44219(VarNext) ) ) ).

tff(addAssignment_22110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44219(VarNext)
      <=> v44217(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4184,axiom,
    ! [VarCurr: state_type] :
      ( v44217(VarCurr)
    <=> ( v44220(VarCurr)
        & v44221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4183,axiom,
    ! [VarCurr: state_type] :
      ( v44221(VarCurr)
    <=> ( v44179(VarCurr)
        | v44204(VarCurr) ) ) ).

tff(writeUnaryOperator_2568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44220(VarCurr)
    <=> v44175(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44209(VarNext)
      <=> v44210(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44210(VarNext)
      <=> ( v44212(VarNext)
          & v44214(VarNext) ) ) ) ).

tff(writeUnaryOperator_2567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44214(VarCurr)
    <=> v44169(VarCurr) ) ).

tff(addAssignment_22109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44212(VarNext)
      <=> v44169(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_186,axiom,
    ( v44173(constB0)
  <=> $true ) ).

tff(addAssignment_22108,axiom,
    ! [VarCurr: state_type] :
      ( v44204(VarCurr)
    <=> v44206(VarCurr) ) ).

tff(addAssignment_22107,axiom,
    ! [VarCurr: state_type] :
      ( v44206(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_22106,axiom,
    ! [VarCurr: state_type] :
      ( v44179(VarCurr)
    <=> v44181(VarCurr) ) ).

tff(addAssignment_22105,axiom,
    ! [VarCurr: state_type] :
      ( v44181(VarCurr)
    <=> v44183(VarCurr) ) ).

tff(addAssignment_22104,axiom,
    ! [VarCurr: state_type] :
      ( v44183(VarCurr)
    <=> v44185(VarCurr) ) ).

tff(addAssignment_22103,axiom,
    ! [VarCurr: state_type] :
      ( v44185(VarCurr)
    <=> v44187(VarCurr) ) ).

tff(writeUnaryOperator_2566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44187(VarCurr)
    <=> v44201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4180,axiom,
    ! [VarCurr: state_type] :
      ( v44201(VarCurr)
    <=> ( v44202(VarCurr)
        | v44197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4179,axiom,
    ! [VarCurr: state_type] :
      ( v44202(VarCurr)
    <=> ( v44189(VarCurr)
        | v44193(VarCurr) ) ) ).

tff(addAssignment_22102,axiom,
    ! [VarCurr: state_type] :
      ( v44197(VarCurr)
    <=> v44199(VarCurr) ) ).

tff(addAssignment_22101,axiom,
    ! [VarCurr: state_type] :
      ( v44199(VarCurr)
    <=> v43605(VarCurr,2) ) ).

tff(addAssignment_22100,axiom,
    ! [VarCurr: state_type] :
      ( v44193(VarCurr)
    <=> v44195(VarCurr) ) ).

tff(addAssignment_22099,axiom,
    ! [VarCurr: state_type] :
      ( v44195(VarCurr)
    <=> v44031(VarCurr,1) ) ).

tff(addAssignment_22098,axiom,
    ! [VarCurr: state_type] :
      ( v44031(VarCurr,1)
    <=> v44033(VarCurr,1) ) ).

tff(addAssignment_22097,axiom,
    ! [VarCurr: state_type] :
      ( v44033(VarCurr,1)
    <=> v44035(VarCurr,1) ) ).

tff(addAssignment_22096,axiom,
    ! [VarCurr: state_type] :
      ( v44035(VarCurr,1)
    <=> v44040(VarCurr,1) ) ).

tff(addAssignment_22095,axiom,
    ! [VarCurr: state_type] :
      ( v44037(VarCurr,1)
    <=> v44039(VarCurr,1) ) ).

tff(addAssignment_22094,axiom,
    ! [VarCurr: state_type] :
      ( v44039(VarCurr,1)
    <=> v43605(VarCurr,1) ) ).

tff(addAssignment_22093,axiom,
    ! [VarCurr: state_type] :
      ( v44189(VarCurr)
    <=> v44191(VarCurr) ) ).

tff(addAssignment_22092,axiom,
    ! [VarCurr: state_type] :
      ( v44191(VarCurr)
    <=> v43605(VarCurr,0) ) ).

tff(addAssignment_22091,axiom,
    ! [VarCurr: state_type] :
      ( v44175(VarCurr)
    <=> v44177(VarCurr) ) ).

tff(addAssignment_22090,axiom,
    ! [VarCurr: state_type] :
      ( v44177(VarCurr)
    <=> $false ) ).

tff(addAssignment_22089,axiom,
    ! [VarCurr: state_type] :
      ( v44169(VarCurr)
    <=> v44171(VarCurr) ) ).

tff(addAssignment_22088,axiom,
    ! [VarCurr: state_type] :
      ( v44171(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_22087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44159(VarCurr,B)
      <=> v44161(VarCurr,B) ) ) ).

tff(addAssignment_22086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v44161(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_22085,axiom,
    ! [VarCurr: state_type] :
      ( v44149(VarCurr)
    <=> v44151(VarCurr) ) ).

tff(addAssignment_22084,axiom,
    ! [VarCurr: state_type] :
      ( v44151(VarCurr)
    <=> v44153(VarCurr) ) ).

tff(addAssignment_22083,axiom,
    ! [VarCurr: state_type] :
      ( v44153(VarCurr)
    <=> v44155(VarCurr) ) ).

tff(addAssignment_22082,axiom,
    ! [VarCurr: state_type] :
      ( v44155(VarCurr)
    <=> v44157(VarCurr) ) ).

tff(addAssignment_22081,axiom,
    ! [VarCurr: state_type] :
      ( v44157(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_22080,axiom,
    ! [VarCurr: state_type] :
      ( v44139(VarCurr)
    <=> v44141(VarCurr) ) ).

tff(addAssignment_22079,axiom,
    ! [VarCurr: state_type] :
      ( v44141(VarCurr)
    <=> v44143(VarCurr) ) ).

tff(addAssignment_22078,axiom,
    ! [VarCurr: state_type] :
      ( v44143(VarCurr)
    <=> v44145(VarCurr) ) ).

tff(addAssignment_22077,axiom,
    ! [VarCurr: state_type] :
      ( v44145(VarCurr)
    <=> v44147(VarCurr) ) ).

tff(addAssignment_22076,axiom,
    ! [VarCurr: state_type] :
      ( v44147(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_22075,axiom,
    ! [VarCurr: state_type] :
      ( v44098(VarCurr)
    <=> v44100(VarCurr) ) ).

tff(addAssignment_22074,axiom,
    ! [VarCurr: state_type] :
      ( v44100(VarCurr)
    <=> v44102(VarCurr) ) ).

tff(addAssignment_22073,axiom,
    ! [VarCurr: state_type] :
      ( v44102(VarCurr)
    <=> v44104(VarCurr) ) ).

tff(addAssignment_22072,axiom,
    ! [VarCurr: state_type] :
      ( v44104(VarCurr)
    <=> v44106(VarCurr) ) ).

tff(addAssignment_22071,axiom,
    ! [VarCurr: state_type] :
      ( v44106(VarCurr)
    <=> v44108(VarCurr) ) ).

tff(addAssignment_22070,axiom,
    ! [VarCurr: state_type] :
      ( v44108(VarCurr)
    <=> v44110(VarCurr) ) ).

tff(addAssignment_22069,axiom,
    ! [VarCurr: state_type] :
      ( v44110(VarCurr)
    <=> v44112(VarCurr) ) ).

tff(writeUnaryOperator_2565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44112(VarCurr)
    <=> v44126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4178,axiom,
    ! [VarCurr: state_type] :
      ( v44126(VarCurr)
    <=> ( v44127(VarCurr)
        | v44122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4177,axiom,
    ! [VarCurr: state_type] :
      ( v44127(VarCurr)
    <=> ( v44114(VarCurr)
        | v44118(VarCurr) ) ) ).

tff(addAssignment_22068,axiom,
    ! [VarCurr: state_type] :
      ( v44122(VarCurr)
    <=> v44124(VarCurr) ) ).

tff(addAssignment_22067,axiom,
    ! [VarCurr: state_type] :
      ( v44124(VarCurr)
    <=> v43695(VarCurr,2) ) ).

tff(addAssignment_22066,axiom,
    ! [VarCurr: state_type] :
      ( v44118(VarCurr)
    <=> v44120(VarCurr) ) ).

tff(addAssignment_22065,axiom,
    ! [VarCurr: state_type] :
      ( v44120(VarCurr)
    <=> v43695(VarCurr,1) ) ).

tff(addAssignment_22064,axiom,
    ! [VarCurr: state_type] :
      ( v44114(VarCurr)
    <=> v44116(VarCurr) ) ).

tff(addAssignment_22063,axiom,
    ! [VarCurr: state_type] :
      ( v44116(VarCurr)
    <=> v43778(VarCurr,0) ) ).

tff(addAssignment_22062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43967(VarCurr,B)
      <=> v43969(VarCurr,B) ) ) ).

tff(addAssignment_22061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43969(VarCurr,B)
      <=> v43971(VarCurr,B) ) ) ).

tff(addAssignment_22060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43971(VarCurr,B)
      <=> v43973(VarCurr,B) ) ) ).

tff(addAssignment_22059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43973(VarCurr,B)
      <=> v43975(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44081(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v43975(VarNext,B)
            <=> v43975(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_516,axiom,
    ! [VarNext: state_type] :
      ( v44081(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43975(VarNext,B)
          <=> v44091(VarNext,B) ) ) ) ).

tff(addAssignment_22058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44091(VarNext,B)
          <=> v44089(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44092(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44089(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_348,axiom,
    ! [VarCurr: state_type] :
      ( v44092(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v44089(VarCurr,B)
          <=> v43997(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4176,axiom,
    ! [VarCurr: state_type] :
      ( v44092(VarCurr)
    <=> ( v44093(VarCurr)
        & v44094(VarCurr) ) ) ).

tff(writeUnaryOperator_2564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44094(VarCurr)
    <=> v43987(VarCurr) ) ).

tff(writeUnaryOperator_2563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44093(VarCurr)
    <=> v43977(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44081(VarNext)
      <=> v44082(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44082(VarNext)
      <=> ( v44083(VarNext)
          & v44001(VarNext) ) ) ) ).

tff(writeUnaryOperator_2562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44083(VarNext)
      <=> v44085(VarNext) ) ) ).

tff(addAssignment_22057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44085(VarNext)
      <=> v44001(VarCurr) ) ) ).

tff(addAssignment_22056,axiom,
    ! [VarCurr: state_type] :
      ( v44001(VarCurr)
    <=> v44003(VarCurr) ) ).

tff(addAssignment_22055,axiom,
    ! [VarCurr: state_type] :
      ( v44003(VarCurr)
    <=> v44005(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4173,axiom,
    ! [VarCurr: state_type] :
      ( v44005(VarCurr)
    <=> ( v44078(VarCurr)
        | v44074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4172,axiom,
    ! [VarCurr: state_type] :
      ( v44078(VarCurr)
    <=> ( v44007(VarCurr)
        & v44011(VarCurr) ) ) ).

tff(addAssignment_22054,axiom,
    ! [VarCurr: state_type] :
      ( v44074(VarCurr)
    <=> v44076(VarCurr) ) ).

tff(addAssignment_22053,axiom,
    ! [VarCurr: state_type] :
      ( v44076(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v44058(VarNext)
       => ( v44011(VarNext)
        <=> v44011(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_515,axiom,
    ! [VarNext: state_type] :
      ( v44058(VarNext)
     => ( v44011(VarNext)
      <=> v44068(VarNext) ) ) ).

tff(addAssignment_22052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44068(VarNext)
      <=> v44066(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4171,axiom,
    ! [VarCurr: state_type] :
      ( v44066(VarCurr)
    <=> ( v44069(VarCurr)
        & v44070(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4170,axiom,
    ! [VarCurr: state_type] :
      ( v44070(VarCurr)
    <=> ( v44017(VarCurr)
        | v44053(VarCurr) ) ) ).

tff(writeUnaryOperator_2561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44069(VarCurr)
    <=> v44013(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44058(VarNext)
      <=> v44059(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44059(VarNext)
      <=> ( v44061(VarNext)
          & v44063(VarNext) ) ) ) ).

tff(writeUnaryOperator_2560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44063(VarCurr)
    <=> v44007(VarCurr) ) ).

tff(addAssignment_22051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v44061(VarNext)
      <=> v44007(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_185,axiom,
    ( v44011(constB0)
  <=> $true ) ).

tff(addAssignment_22050,axiom,
    ! [VarCurr: state_type] :
      ( v44053(VarCurr)
    <=> v44055(VarCurr) ) ).

tff(addAssignment_22049,axiom,
    ! [VarCurr: state_type] :
      ( v44055(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_22048,axiom,
    ! [VarCurr: state_type] :
      ( v44017(VarCurr)
    <=> v44019(VarCurr) ) ).

tff(addAssignment_22047,axiom,
    ! [VarCurr: state_type] :
      ( v44019(VarCurr)
    <=> v44021(VarCurr) ) ).

tff(addAssignment_22046,axiom,
    ! [VarCurr: state_type] :
      ( v44021(VarCurr)
    <=> v44023(VarCurr) ) ).

tff(addAssignment_22045,axiom,
    ! [VarCurr: state_type] :
      ( v44023(VarCurr)
    <=> v44025(VarCurr) ) ).

tff(writeUnaryOperator_2559,axiom,
    ! [VarCurr: state_type] :
      ( ~ v44025(VarCurr)
    <=> v44050(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4167,axiom,
    ! [VarCurr: state_type] :
      ( v44050(VarCurr)
    <=> ( v44051(VarCurr)
        | v44046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4166,axiom,
    ! [VarCurr: state_type] :
      ( v44051(VarCurr)
    <=> ( v44027(VarCurr)
        | v44042(VarCurr) ) ) ).

tff(addAssignment_22044,axiom,
    ! [VarCurr: state_type] :
      ( v44046(VarCurr)
    <=> v44048(VarCurr) ) ).

tff(addAssignment_22043,axiom,
    ! [VarCurr: state_type] :
      ( v44048(VarCurr)
    <=> v43605(VarCurr,2) ) ).

tff(addAssignment_22042,axiom,
    ! [VarCurr: state_type] :
      ( v44042(VarCurr)
    <=> v44044(VarCurr) ) ).

tff(addAssignment_22041,axiom,
    ! [VarCurr: state_type] :
      ( v44044(VarCurr)
    <=> v43605(VarCurr,1) ) ).

tff(addAssignment_22040,axiom,
    ! [VarCurr: state_type] :
      ( v44027(VarCurr)
    <=> v44029(VarCurr) ) ).

tff(addAssignment_22039,axiom,
    ! [VarCurr: state_type] :
      ( v44029(VarCurr)
    <=> v44031(VarCurr,0) ) ).

tff(addAssignment_22038,axiom,
    ! [VarCurr: state_type] :
      ( v44031(VarCurr,0)
    <=> v44033(VarCurr,0) ) ).

tff(addAssignment_22037,axiom,
    ! [VarCurr: state_type] :
      ( v44033(VarCurr,0)
    <=> v44035(VarCurr,0) ) ).

tff(addAssignment_22036,axiom,
    ! [VarCurr: state_type] :
      ( v44035(VarCurr,0)
    <=> v44040(VarCurr,0) ) ).

tff(writeUnaryOperator_2558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v44040(VarCurr,B)
      <=> ~ v44037(VarCurr,B) ) ) ).

tff(addAssignment_22035,axiom,
    ! [VarCurr: state_type] :
      ( v44037(VarCurr,0)
    <=> v44039(VarCurr,0) ) ).

tff(addAssignment_22034,axiom,
    ! [VarCurr: state_type] :
      ( v44039(VarCurr,0)
    <=> v43605(VarCurr,0) ) ).

tff(addAssignment_22033,axiom,
    ! [VarCurr: state_type] :
      ( v44013(VarCurr)
    <=> v44015(VarCurr) ) ).

tff(addAssignment_22032,axiom,
    ! [VarCurr: state_type] :
      ( v44015(VarCurr)
    <=> $false ) ).

tff(addAssignment_22031,axiom,
    ! [VarCurr: state_type] :
      ( v44007(VarCurr)
    <=> v44009(VarCurr) ) ).

tff(addAssignment_22030,axiom,
    ! [VarCurr: state_type] :
      ( v44009(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_22029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43997(VarCurr,B)
      <=> v43999(VarCurr,B) ) ) ).

tff(addAssignment_22028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43999(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_22027,axiom,
    ! [VarCurr: state_type] :
      ( v43987(VarCurr)
    <=> v43989(VarCurr) ) ).

tff(addAssignment_22026,axiom,
    ! [VarCurr: state_type] :
      ( v43989(VarCurr)
    <=> v43991(VarCurr) ) ).

tff(addAssignment_22025,axiom,
    ! [VarCurr: state_type] :
      ( v43991(VarCurr)
    <=> v43993(VarCurr) ) ).

tff(addAssignment_22024,axiom,
    ! [VarCurr: state_type] :
      ( v43993(VarCurr)
    <=> v43995(VarCurr) ) ).

tff(addAssignment_22023,axiom,
    ! [VarCurr: state_type] :
      ( v43995(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_22022,axiom,
    ! [VarCurr: state_type] :
      ( v43977(VarCurr)
    <=> v43979(VarCurr) ) ).

tff(addAssignment_22021,axiom,
    ! [VarCurr: state_type] :
      ( v43979(VarCurr)
    <=> v43981(VarCurr) ) ).

tff(addAssignment_22020,axiom,
    ! [VarCurr: state_type] :
      ( v43981(VarCurr)
    <=> v43983(VarCurr) ) ).

tff(addAssignment_22019,axiom,
    ! [VarCurr: state_type] :
      ( v43983(VarCurr)
    <=> v43985(VarCurr) ) ).

tff(addAssignment_22018,axiom,
    ! [VarCurr: state_type] :
      ( v43985(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_22017,axiom,
    ! [VarCurr: state_type] :
      ( v43675(VarCurr)
    <=> v43677(VarCurr) ) ).

tff(addAssignment_22016,axiom,
    ! [VarCurr: state_type] :
      ( v43677(VarCurr)
    <=> v43679(VarCurr) ) ).

tff(addAssignment_22015,axiom,
    ! [VarCurr: state_type] :
      ( v43679(VarCurr)
    <=> v43681(VarCurr) ) ).

tff(addAssignment_22014,axiom,
    ! [VarCurr: state_type] :
      ( v43681(VarCurr)
    <=> v43683(VarCurr) ) ).

tff(addAssignment_22013,axiom,
    ! [VarCurr: state_type] :
      ( v43683(VarCurr)
    <=> v43685(VarCurr) ) ).

tff(addAssignment_22012,axiom,
    ! [VarCurr: state_type] :
      ( v43685(VarCurr)
    <=> v43687(VarCurr) ) ).

tff(addAssignment_22011,axiom,
    ! [VarCurr: state_type] :
      ( v43687(VarCurr)
    <=> v43689(VarCurr) ) ).

tff(writeUnaryOperator_2557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43689(VarCurr)
    <=> v43964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4165,axiom,
    ! [VarCurr: state_type] :
      ( v43964(VarCurr)
    <=> ( v43965(VarCurr)
        | v43960(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4164,axiom,
    ! [VarCurr: state_type] :
      ( v43965(VarCurr)
    <=> ( v43691(VarCurr)
        | v43956(VarCurr) ) ) ).

tff(addAssignment_22010,axiom,
    ! [VarCurr: state_type] :
      ( v43960(VarCurr)
    <=> v43962(VarCurr) ) ).

tff(addAssignment_22009,axiom,
    ! [VarCurr: state_type] :
      ( v43962(VarCurr)
    <=> v43695(VarCurr,2) ) ).

tff(addAssignment_22008,axiom,
    ! [VarCurr: state_type] :
      ( v43956(VarCurr)
    <=> v43958(VarCurr) ) ).

tff(addAssignment_22007,axiom,
    ! [VarCurr: state_type] :
      ( v43958(VarCurr)
    <=> v43695(VarCurr,1) ) ).

tff(addAssignment_22006,axiom,
    ! [VarCurr: state_type] :
      ( v43691(VarCurr)
    <=> v43693(VarCurr) ) ).

tff(addAssignment_22005,axiom,
    ! [VarCurr: state_type] :
      ( v43693(VarCurr)
    <=> v43695(VarCurr,0) ) ).

tff(addAssignment_22004,axiom,
    ! [VarCurr: state_type] :
      ( v43695(VarCurr,0)
    <=> v43607(VarCurr,3) ) ).

tff(addAssignment_22003,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,3)
    <=> v43609(VarCurr,3) ) ).

tff(addAssignment_22002,axiom,
    ! [VarNext: state_type] :
      ( v43609(VarNext,3)
    <=> v43948(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43949(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v43948(VarNext,B)
            <=> v43609(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_514,axiom,
    ! [VarNext: state_type] :
      ( v43949(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43948(VarNext,B)
          <=> v43920(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43949(VarNext)
      <=> v43950(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43950(VarNext)
      <=> ( v43952(VarNext)
          & v43862(VarNext) ) ) ) ).

tff(writeUnaryOperator_2556,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43952(VarNext)
      <=> v43914(VarNext) ) ) ).

tff(addAssignment_22001,axiom,
    ! [VarCurr: state_type] :
      ( v43719(VarCurr,3)
    <=> v43721(VarCurr,3) ) ).

tff(addAssignment_22000,axiom,
    ! [VarCurr: state_type] :
      ( v43721(VarCurr,3)
    <=> v43859(VarCurr,3) ) ).

tff(addAssignment_21999,axiom,
    ! [VarCurr: state_type] :
      ( v43723(VarCurr,0)
    <=> v43725(VarCurr,0) ) ).

tff(addAssignment_21998,axiom,
    ! [VarCurr: state_type] :
      ( v43725(VarCurr,0)
    <=> v43727(VarCurr,0) ) ).

tff(addAssignment_21997,axiom,
    ! [VarCurr: state_type] :
      ( v43727(VarCurr,0)
    <=> v43858(VarCurr,0) ) ).

tff(addAssignment_21996,axiom,
    ! [VarCurr: state_type] :
      ( v43795(VarCurr,0)
    <=> v43797(VarCurr,0) ) ).

tff(addAssignment_21995,axiom,
    ! [VarCurr: state_type] :
      ( v43797(VarCurr,0)
    <=> v43799(VarCurr,0) ) ).

tff(addAssignment_21994,axiom,
    ! [VarCurr: state_type] :
      ( v43799(VarCurr,0)
    <=> v43801(VarCurr,0) ) ).

tff(addAssignment_21993,axiom,
    ! [VarCurr: state_type] :
      ( v43801(VarCurr,0)
    <=> v43803(VarCurr,0) ) ).

tff(addAssignment_21992,axiom,
    ! [VarCurr: state_type] :
      ( v43803(VarCurr,0)
    <=> v43813(VarCurr,0) ) ).

tff(addAssignment_21991,axiom,
    ! [VarCurr: state_type] :
      ( v43729(VarCurr,0)
    <=> v43731(VarCurr,0) ) ).

tff(addAssignment_21990,axiom,
    ! [VarCurr: state_type] :
      ( v43731(VarCurr,0)
    <=> v43792(VarCurr,0) ) ).

tff(addAssignment_21989,axiom,
    ! [VarCurr: state_type] :
      ( v43733(VarCurr)
    <=> v43259(VarCurr,2) ) ).

tff(addAssignment_21988,axiom,
    ! [VarCurr: state_type] :
      ( v43259(VarCurr,2)
    <=> v43261(VarCurr,2) ) ).

tff(addAssignment_21987,axiom,
    ! [VarCurr: state_type] :
      ( v43261(VarCurr,2)
    <=> v43271(VarCurr,2) ) ).

tff(addAssignment_21986,axiom,
    ! [VarCurr: state_type] :
      ( v43263(VarCurr,2)
    <=> v43265(VarCurr,2) ) ).

tff(addAssignment_21985,axiom,
    ! [VarCurr: state_type] :
      ( v43265(VarCurr,2)
    <=> v43268(VarCurr,2) ) ).

tff(addAssignment_21984,axiom,
    ! [VarCurr: state_type] :
      ( v43269(VarCurr)
    <=> v43736(VarCurr,1) ) ).

tff(addAssignment_21983,axiom,
    ! [VarCurr: state_type] :
      ( v43736(VarCurr,1)
    <=> v43738(VarCurr,1) ) ).

tff(addAssignment_21982,axiom,
    ! [VarCurr: state_type] :
      ( v43738(VarCurr,1)
    <=> v43946(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v43946(VarCurr,B)
      <=> ( v43740(VarCurr,B)
          | v43746(VarCurr,B) ) ) ) ).

tff(addAssignment_21981,axiom,
    ! [VarCurr: state_type] :
      ( v43746(VarCurr,1)
    <=> v43748(VarCurr,1) ) ).

tff(addAssignment_21980,axiom,
    ! [VarCurr: state_type] :
      ( v43748(VarCurr,1)
    <=> v43944(VarCurr,1) ) ).

tff(addAssignment_21979,axiom,
    ! [VarCurr: state_type] :
      ( v43944(VarCurr,0)
    <=> v43945(VarCurr) ) ).

tff(addAssignment_21978,axiom,
    ! [VarCurr: state_type] :
      ( v43944(VarCurr,1)
    <=> v43750(VarCurr) ) ).

tff(addAssignment_21977,axiom,
    ! [VarCurr: state_type] :
      ( v43750(VarCurr)
    <=> v43752(VarCurr,1) ) ).

tff(addAssignment_21976,axiom,
    ! [VarCurr: state_type] :
      ( v43752(VarCurr,1)
    <=> v43754(VarCurr,1) ) ).

tff(addAssignment_21975,axiom,
    ! [VarCurr: state_type] :
      ( v43754(VarCurr,1)
    <=> v43943(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v43943(VarCurr,B)
      <=> ( v43756(VarCurr,B)
          & v43764(VarCurr,B) ) ) ) ).

tff(addAssignment_21974,axiom,
    ! [VarCurr: state_type] :
      ( v43764(VarCurr,1)
    <=> v43766(VarCurr,1) ) ).

tff(addAssignment_21973,axiom,
    ! [VarCurr: state_type] :
      ( v43766(VarCurr,1)
    <=> v43941(VarCurr,1) ) ).

tff(addAssignment_21972,axiom,
    ! [VarCurr: state_type] :
      ( v43941(VarCurr,0)
    <=> v43942(VarCurr) ) ).

tff(addAssignment_21971,axiom,
    ! [VarCurr: state_type] :
      ( v43941(VarCurr,1)
    <=> v43768(VarCurr) ) ).

tff(addAssignment_21970,axiom,
    ! [VarCurr: state_type] :
      ( v43768(VarCurr)
    <=> v43770(VarCurr) ) ).

tff(addAssignment_21969,axiom,
    ! [VarCurr: state_type] :
      ( v43770(VarCurr)
    <=> v43772(VarCurr) ) ).

tff(writeUnaryOperator_2555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43772(VarCurr)
    <=> v43939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4161,axiom,
    ! [VarCurr: state_type] :
      ( v43939(VarCurr)
    <=> ( v43940(VarCurr)
        | v43927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4160,axiom,
    ! [VarCurr: state_type] :
      ( v43940(VarCurr)
    <=> ( v43774(VarCurr)
        | v43789(VarCurr) ) ) ).

tff(addAssignment_21968,axiom,
    ! [VarCurr: state_type] :
      ( v43927(VarCurr)
    <=> v43929(VarCurr) ) ).

tff(addAssignment_21967,axiom,
    ! [VarCurr: state_type] :
      ( v43929(VarCurr)
    <=> v43778(VarCurr,2) ) ).

tff(addAssignment_21966,axiom,
    ! [VarCurr: state_type] :
      ( v43778(VarCurr,2)
    <=> v43780(VarCurr,2) ) ).

tff(addAssignment_21965,axiom,
    ! [VarCurr: state_type] :
      ( v43780(VarCurr,2)
    <=> v43782(VarCurr,2) ) ).

tff(addAssignment_21964,axiom,
    ! [VarCurr: state_type] :
      ( v43782(VarCurr,2)
    <=> v43787(VarCurr,2) ) ).

tff(addAssignment_21963,axiom,
    ! [VarCurr: state_type] :
      ( v43784(VarCurr,2)
    <=> v43786(VarCurr,2) ) ).

tff(addAssignment_21962,axiom,
    ! [VarCurr: state_type] :
      ( v43786(VarCurr,2)
    <=> v43695(VarCurr,2) ) ).

tff(addAssignment_21961,axiom,
    ! [VarCurr: state_type] :
      ( v43695(VarCurr,2)
    <=> v43607(VarCurr,5) ) ).

tff(addAssignment_21960,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,5)
    <=> v43609(VarCurr,5) ) ).

tff(addAssignment_21959,axiom,
    ! [VarNext: state_type] :
      ( v43609(VarNext,5)
    <=> v43931(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43932(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v43931(VarNext,B)
            <=> v43609(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_513,axiom,
    ! [VarNext: state_type] :
      ( v43932(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43931(VarNext,B)
          <=> v43920(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43932(VarNext)
      <=> v43933(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43933(VarNext)
      <=> ( v43935(VarNext)
          & v43862(VarNext) ) ) ) ).

tff(writeUnaryOperator_2554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43935(VarNext)
      <=> v43914(VarNext) ) ) ).

tff(addAssignment_21958,axiom,
    ! [VarCurr: state_type] :
      ( v43719(VarCurr,5)
    <=> v43721(VarCurr,5) ) ).

tff(addAssignment_21957,axiom,
    ! [VarCurr: state_type] :
      ( v43721(VarCurr,5)
    <=> v43859(VarCurr,5) ) ).

tff(addAssignment_21956,axiom,
    ! [VarCurr: state_type] :
      ( v43723(VarCurr,2)
    <=> v43725(VarCurr,2) ) ).

tff(addAssignment_21955,axiom,
    ! [VarCurr: state_type] :
      ( v43725(VarCurr,2)
    <=> v43727(VarCurr,2) ) ).

tff(addAssignment_21954,axiom,
    ! [VarCurr: state_type] :
      ( v43727(VarCurr,2)
    <=> v43858(VarCurr,2) ) ).

tff(addAssignment_21953,axiom,
    ! [VarCurr: state_type] :
      ( v43795(VarCurr,2)
    <=> v43797(VarCurr,2) ) ).

tff(addAssignment_21952,axiom,
    ! [VarCurr: state_type] :
      ( v43797(VarCurr,2)
    <=> v43799(VarCurr,2) ) ).

tff(addAssignment_21951,axiom,
    ! [VarCurr: state_type] :
      ( v43799(VarCurr,2)
    <=> v43801(VarCurr,2) ) ).

tff(addAssignment_21950,axiom,
    ! [VarCurr: state_type] :
      ( v43801(VarCurr,2)
    <=> v43803(VarCurr,2) ) ).

tff(addAssignment_21949,axiom,
    ! [VarCurr: state_type] :
      ( v43803(VarCurr,2)
    <=> v43813(VarCurr,2) ) ).

tff(addAssignment_21948,axiom,
    ! [VarCurr: state_type] :
      ( v43805(VarCurr,2)
    <=> v43807(VarCurr,2) ) ).

tff(addAssignment_21947,axiom,
    ! [VarCurr: state_type] :
      ( v43807(VarCurr,2)
    <=> v43808(VarCurr,2) ) ).

tff(addAssignment_21946,axiom,
    ! [VarCurr: state_type] :
      ( v43729(VarCurr,2)
    <=> v43731(VarCurr,2) ) ).

tff(addAssignment_21945,axiom,
    ! [VarCurr: state_type] :
      ( v43731(VarCurr,2)
    <=> v43792(VarCurr,2) ) ).

tff(addAssignment_21944,axiom,
    ! [VarCurr: state_type] :
      ( v43789(VarCurr)
    <=> v43791(VarCurr) ) ).

tff(addAssignment_21943,axiom,
    ! [VarCurr: state_type] :
      ( v43791(VarCurr)
    <=> v43695(VarCurr,1) ) ).

tff(addAssignment_21942,axiom,
    ! [VarCurr: state_type] :
      ( v43695(VarCurr,1)
    <=> v43607(VarCurr,4) ) ).

tff(addAssignment_21941,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,4)
    <=> v43609(VarCurr,4) ) ).

tff(addAssignment_21940,axiom,
    ! [VarNext: state_type] :
      ( v43609(VarNext,4)
    <=> v43909(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43910(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v43909(VarNext,B)
            <=> v43609(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_512,axiom,
    ! [VarNext: state_type] :
      ( v43910(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43909(VarNext,B)
          <=> v43920(VarNext,B) ) ) ) ).

tff(addAssignment_21939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43920(VarNext,B)
          <=> v43918(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43918(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_347,axiom,
    ! [VarCurr: state_type] :
      ( v43921(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v43918(VarCurr,B)
          <=> v43719(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4157,axiom,
    ! [VarCurr: state_type] :
      ( v43921(VarCurr)
    <=> ( v43922(VarCurr)
        & v43923(VarCurr) ) ) ).

tff(writeUnaryOperator_2553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43923(VarCurr)
    <=> v43709(VarCurr) ) ).

tff(writeUnaryOperator_2552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43922(VarCurr)
    <=> v43697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43910(VarNext)
      <=> v43911(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43911(VarNext)
      <=> ( v43912(VarNext)
          & v43862(VarNext) ) ) ) ).

tff(writeUnaryOperator_2551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43912(VarNext)
      <=> v43914(VarNext) ) ) ).

tff(addAssignment_21938,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43914(VarNext)
      <=> v43862(VarCurr) ) ) ).

tff(addAssignment_21937,axiom,
    ! [VarCurr: state_type] :
      ( v43862(VarCurr)
    <=> v43864(VarCurr) ) ).

tff(addAssignment_21936,axiom,
    ! [VarCurr: state_type] :
      ( v43864(VarCurr)
    <=> v43866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4154,axiom,
    ! [VarCurr: state_type] :
      ( v43866(VarCurr)
    <=> ( v43907(VarCurr)
        | v43903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4153,axiom,
    ! [VarCurr: state_type] :
      ( v43907(VarCurr)
    <=> ( v43868(VarCurr)
        & v43872(VarCurr) ) ) ).

tff(addAssignment_21935,axiom,
    ! [VarCurr: state_type] :
      ( v43903(VarCurr)
    <=> v43905(VarCurr) ) ).

tff(addAssignment_21934,axiom,
    ! [VarCurr: state_type] :
      ( v43905(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43887(VarNext)
       => ( v43872(VarNext)
        <=> v43872(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_511,axiom,
    ! [VarNext: state_type] :
      ( v43887(VarNext)
     => ( v43872(VarNext)
      <=> v43897(VarNext) ) ) ).

tff(addAssignment_21933,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43897(VarNext)
      <=> v43895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4152,axiom,
    ! [VarCurr: state_type] :
      ( v43895(VarCurr)
    <=> ( v43898(VarCurr)
        & v43899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4151,axiom,
    ! [VarCurr: state_type] :
      ( v43899(VarCurr)
    <=> ( v43878(VarCurr)
        | v43882(VarCurr) ) ) ).

tff(writeUnaryOperator_2550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43898(VarCurr)
    <=> v43874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43887(VarNext)
      <=> v43888(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43888(VarNext)
      <=> ( v43890(VarNext)
          & v43892(VarNext) ) ) ) ).

tff(writeUnaryOperator_2549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43892(VarCurr)
    <=> v43868(VarCurr) ) ).

tff(addAssignment_21932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43890(VarNext)
      <=> v43868(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_184,axiom,
    ( v43872(constB0)
  <=> $true ) ).

tff(addAssignment_21931,axiom,
    ! [VarCurr: state_type] :
      ( v43882(VarCurr)
    <=> v43884(VarCurr) ) ).

tff(addAssignment_21930,axiom,
    ! [VarCurr: state_type] :
      ( v43884(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_21929,axiom,
    ! [VarCurr: state_type] :
      ( v43878(VarCurr)
    <=> v43880(VarCurr) ) ).

tff(addAssignment_21928,axiom,
    ! [VarCurr: state_type] :
      ( v43880(VarCurr)
    <=> $true ) ).

tff(addAssignment_21927,axiom,
    ! [VarCurr: state_type] :
      ( v43874(VarCurr)
    <=> v43876(VarCurr) ) ).

tff(addAssignment_21926,axiom,
    ! [VarCurr: state_type] :
      ( v43876(VarCurr)
    <=> $false ) ).

tff(addAssignment_21925,axiom,
    ! [VarCurr: state_type] :
      ( v43868(VarCurr)
    <=> v43870(VarCurr) ) ).

tff(addAssignment_21924,axiom,
    ! [VarCurr: state_type] :
      ( v43870(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_21923,axiom,
    ! [VarCurr: state_type] :
      ( v43719(VarCurr,4)
    <=> v43721(VarCurr,4) ) ).

tff(addAssignment_21922,axiom,
    ! [VarCurr: state_type] :
      ( v43721(VarCurr,4)
    <=> v43859(VarCurr,4) ) ).

tff(addAssignment_21921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v43859(VarCurr,B)
      <=> v43860(VarCurr,B) ) ) ).

tff(addAssignment_21920,axiom,
    ! [VarCurr: state_type] :
      ( ( v43859(VarCurr,5)
      <=> v43723(VarCurr,2) )
      & ( v43859(VarCurr,4)
      <=> v43723(VarCurr,1) )
      & ( v43859(VarCurr,3)
      <=> v43723(VarCurr,0) ) ) ).

tff(addAssignment_21919,axiom,
    ! [VarCurr: state_type] :
      ( v43723(VarCurr,1)
    <=> v43725(VarCurr,1) ) ).

tff(addAssignment_21918,axiom,
    ! [VarCurr: state_type] :
      ( v43725(VarCurr,1)
    <=> v43727(VarCurr,1) ) ).

tff(addAssignment_21917,axiom,
    ! [VarCurr: state_type] :
      ( v43727(VarCurr,1)
    <=> v43858(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v43858(VarCurr,B)
      <=> ( v43729(VarCurr,B)
          & v43795(VarCurr,B) ) ) ) ).

tff(addAssignment_21916,axiom,
    ! [VarCurr: state_type] :
      ( v43795(VarCurr,1)
    <=> v43797(VarCurr,1) ) ).

tff(addAssignment_21915,axiom,
    ! [VarCurr: state_type] :
      ( v43797(VarCurr,1)
    <=> v43799(VarCurr,1) ) ).

tff(addAssignment_21914,axiom,
    ! [VarCurr: state_type] :
      ( v43799(VarCurr,1)
    <=> v43801(VarCurr,1) ) ).

tff(addAssignment_21913,axiom,
    ! [VarCurr: state_type] :
      ( v43801(VarCurr,1)
    <=> v43803(VarCurr,1) ) ).

tff(addAssignment_21912,axiom,
    ! [VarCurr: state_type] :
      ( v43803(VarCurr,1)
    <=> v43813(VarCurr,1) ) ).

tff(addAssignment_21911,axiom,
    ! [VarCurr: state_type] :
      ( v43813(VarCurr,0)
    <=> v43853(VarCurr) ) ).

tff(addAssignment_21910,axiom,
    ! [VarCurr: state_type] :
      ( v43813(VarCurr,1)
    <=> v43848(VarCurr) ) ).

tff(addAssignment_21909,axiom,
    ! [VarCurr: state_type] :
      ( v43813(VarCurr,2)
    <=> v43843(VarCurr) ) ).

tff(addAssignment_21908,axiom,
    ! [VarCurr: state_type] :
      ( v43813(VarCurr,3)
    <=> v43815(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4148,axiom,
    ! [VarCurr: state_type] :
      ( v43853(VarCurr)
    <=> ( v43854(VarCurr)
        & v43857(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4147,axiom,
    ! [VarCurr: state_type] :
      ( v43857(VarCurr)
    <=> ( v43805(VarCurr,0)
        | v43823(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4146,axiom,
    ! [VarCurr: state_type] :
      ( v43854(VarCurr)
    <=> ( v43855(VarCurr)
        | v43856(VarCurr) ) ) ).

tff(writeUnaryOperator_2548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43856(VarCurr)
    <=> v43823(VarCurr,0) ) ).

tff(writeUnaryOperator_2547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43855(VarCurr)
    <=> v43805(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4145,axiom,
    ! [VarCurr: state_type] :
      ( v43848(VarCurr)
    <=> ( v43849(VarCurr)
        & v43852(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4144,axiom,
    ! [VarCurr: state_type] :
      ( v43852(VarCurr)
    <=> ( v43822(VarCurr)
        | v43824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4143,axiom,
    ! [VarCurr: state_type] :
      ( v43849(VarCurr)
    <=> ( v43850(VarCurr)
        | v43851(VarCurr) ) ) ).

tff(writeUnaryOperator_2546,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43851(VarCurr)
    <=> v43824(VarCurr) ) ).

tff(writeUnaryOperator_2545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43850(VarCurr)
    <=> v43822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4142,axiom,
    ! [VarCurr: state_type] :
      ( v43843(VarCurr)
    <=> ( v43844(VarCurr)
        & v43847(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4141,axiom,
    ! [VarCurr: state_type] :
      ( v43847(VarCurr)
    <=> ( v43820(VarCurr)
        | v43830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4140,axiom,
    ! [VarCurr: state_type] :
      ( v43844(VarCurr)
    <=> ( v43845(VarCurr)
        | v43846(VarCurr) ) ) ).

tff(writeUnaryOperator_2544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43846(VarCurr)
    <=> v43830(VarCurr) ) ).

tff(writeUnaryOperator_2543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43845(VarCurr)
    <=> v43820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4139,axiom,
    ! [VarCurr: state_type] :
      ( v43815(VarCurr)
    <=> ( v43816(VarCurr)
        & v43842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4138,axiom,
    ! [VarCurr: state_type] :
      ( v43842(VarCurr)
    <=> ( v43818(VarCurr)
        | v43837(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4137,axiom,
    ! [VarCurr: state_type] :
      ( v43816(VarCurr)
    <=> ( v43817(VarCurr)
        | v43836(VarCurr) ) ) ).

tff(writeUnaryOperator_2542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43836(VarCurr)
    <=> v43837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4136,axiom,
    ! [VarCurr: state_type] :
      ( v43837(VarCurr)
    <=> ( v43838(VarCurr)
        & v43841(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_528,axiom,
    ! [VarCurr: state_type] :
      ( v43841(VarCurr)
    <=> ( v43805(VarCurr,3)
        | v43823(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4135,axiom,
    ! [VarCurr: state_type] :
      ( v43838(VarCurr)
    <=> ( v43839(VarCurr)
        | v43840(VarCurr) ) ) ).

tff(writeUnaryOperator_2541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43840(VarCurr)
    <=> v43823(VarCurr,3) ) ).

tff(writeUnaryOperator_2540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43839(VarCurr)
    <=> v43805(VarCurr,3) ) ).

tff(writeUnaryOperator_2539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43817(VarCurr)
    <=> v43818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4134,axiom,
    ! [VarCurr: state_type] :
      ( v43818(VarCurr)
    <=> ( v43819(VarCurr)
        | v43835(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_527,axiom,
    ! [VarCurr: state_type] :
      ( v43835(VarCurr)
    <=> ( v43805(VarCurr,2)
        & v43823(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4133,axiom,
    ! [VarCurr: state_type] :
      ( v43819(VarCurr)
    <=> ( v43820(VarCurr)
        & v43830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4132,axiom,
    ! [VarCurr: state_type] :
      ( v43830(VarCurr)
    <=> ( v43831(VarCurr)
        & v43834(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_526,axiom,
    ! [VarCurr: state_type] :
      ( v43834(VarCurr)
    <=> ( v43805(VarCurr,2)
        | v43823(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4131,axiom,
    ! [VarCurr: state_type] :
      ( v43831(VarCurr)
    <=> ( v43832(VarCurr)
        | v43833(VarCurr) ) ) ).

tff(writeUnaryOperator_2538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43833(VarCurr)
    <=> v43823(VarCurr,2) ) ).

tff(writeUnaryOperator_2537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43832(VarCurr)
    <=> v43805(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4130,axiom,
    ! [VarCurr: state_type] :
      ( v43820(VarCurr)
    <=> ( v43821(VarCurr)
        | v43829(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_525,axiom,
    ! [VarCurr: state_type] :
      ( v43829(VarCurr)
    <=> ( v43805(VarCurr,1)
        & v43823(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4129,axiom,
    ! [VarCurr: state_type] :
      ( v43821(VarCurr)
    <=> ( v43822(VarCurr)
        & v43824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4128,axiom,
    ! [VarCurr: state_type] :
      ( v43824(VarCurr)
    <=> ( v43825(VarCurr)
        & v43828(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_524,axiom,
    ! [VarCurr: state_type] :
      ( v43828(VarCurr)
    <=> ( v43805(VarCurr,1)
        | v43823(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4127,axiom,
    ! [VarCurr: state_type] :
      ( v43825(VarCurr)
    <=> ( v43826(VarCurr)
        | v43827(VarCurr) ) ) ).

tff(writeUnaryOperator_2536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43827(VarCurr)
    <=> v43823(VarCurr,1) ) ).

tff(writeUnaryOperator_2535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43826(VarCurr)
    <=> v43805(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4126,axiom,
    ! [VarCurr: state_type] :
      ( v43822(VarCurr)
    <=> ( v43805(VarCurr,0)
        & v43823(VarCurr,0) ) ) ).

tff(addAssignment_21907,axiom,
    ! [VarCurr: state_type] :
      ( v43823(VarCurr,0)
    <=> v43810(VarCurr) ) ).

tff(addAssignment_21906,axiom,
    ! [VarCurr: state_type] :
      ( ( v43823(VarCurr,3)
      <=> $false )
      & ( v43823(VarCurr,2)
      <=> $false )
      & ( v43823(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_21905,axiom,
    ! [VarCurr: state_type] :
      ( v43810(VarCurr)
    <=> v43812(VarCurr) ) ).

tff(addAssignment_21904,axiom,
    ! [VarCurr: state_type] :
      ( v43812(VarCurr)
    <=> v43760(VarCurr) ) ).

tff(addAssignment_21903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v43805(VarCurr,B)
      <=> v43807(VarCurr,B) ) ) ).

tff(addAssignment_21902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v43807(VarCurr,B)
      <=> v43808(VarCurr,B) ) ) ).

tff(addAssignment_21901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v43808(VarCurr,B)
      <=> v43695(VarCurr,B) ) ) ).

tff(addAssignment_21900,axiom,
    ! [VarCurr: state_type] :
      ( v43808(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_21899,axiom,
    ! [VarCurr: state_type] :
      ( v43729(VarCurr,1)
    <=> v43731(VarCurr,1) ) ).

tff(addAssignment_21898,axiom,
    ! [VarCurr: state_type] :
      ( v43731(VarCurr,1)
    <=> v43792(VarCurr,1) ) ).

tff(addAssignment_21897,axiom,
    ! [VarCurr: state_type] :
      ( v43792(VarCurr,0)
    <=> v43793(VarCurr) ) ).

tff(addAssignment_21896,axiom,
    ! [VarCurr: state_type] :
      ( v43792(VarCurr,1)
    <=> v43793(VarCurr) ) ).

tff(addAssignment_21895,axiom,
    ! [VarCurr: state_type] :
      ( v43792(VarCurr,2)
    <=> v43793(VarCurr) ) ).

tff(addAssignment_21894,axiom,
    ! [VarCurr: state_type] :
      ( v43793(VarCurr)
    <=> v43733(VarCurr) ) ).

tff(addAssignment_21893,axiom,
    ! [VarCurr: state_type] :
      ( v43774(VarCurr)
    <=> v43776(VarCurr) ) ).

tff(addAssignment_21892,axiom,
    ! [VarCurr: state_type] :
      ( v43776(VarCurr)
    <=> v43778(VarCurr,0) ) ).

tff(addAssignment_21891,axiom,
    ! [VarCurr: state_type] :
      ( v43778(VarCurr,0)
    <=> v43780(VarCurr,0) ) ).

tff(addAssignment_21890,axiom,
    ! [VarCurr: state_type] :
      ( v43780(VarCurr,0)
    <=> v43782(VarCurr,0) ) ).

tff(addAssignment_21889,axiom,
    ! [VarCurr: state_type] :
      ( v43782(VarCurr,0)
    <=> v43787(VarCurr,0) ) ).

tff(writeUnaryOperator_2534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v43787(VarCurr,B)
      <=> ~ v43784(VarCurr,B) ) ) ).

tff(addAssignment_21888,axiom,
    ! [VarCurr: state_type] :
      ( v43784(VarCurr,0)
    <=> v43786(VarCurr,0) ) ).

tff(addAssignment_21887,axiom,
    ! [VarCurr: state_type] :
      ( v43786(VarCurr,0)
    <=> v43695(VarCurr,0) ) ).

tff(addAssignment_21886,axiom,
    ! [VarCurr: state_type] :
      ( v43756(VarCurr,1)
    <=> v43758(VarCurr,1) ) ).

tff(addAssignment_21885,axiom,
    ! [VarCurr: state_type] :
      ( v43758(VarCurr,1)
    <=> v43761(VarCurr,1) ) ).

tff(addAssignment_21884,axiom,
    ! [VarCurr: state_type] :
      ( v43761(VarCurr,0)
    <=> v43762(VarCurr) ) ).

tff(addAssignment_21883,axiom,
    ! [VarCurr: state_type] :
      ( v43761(VarCurr,1)
    <=> v43760(VarCurr) ) ).

tff(addAssignment_21882,axiom,
    ! [VarCurr: state_type] :
      ( v43760(VarCurr)
    <=> v7230(VarCurr,8) ) ).

tff(addAssignment_21881,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,8)
    <=> v7232(VarCurr,8) ) ).

tff(addAssignment_21880,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,8)
    <=> v7234(VarCurr,8) ) ).

tff(addAssignment_21879,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,8)
    <=> v34455(VarCurr,8) ) ).

tff(addAssignment_21878,axiom,
    ! [VarCurr: state_type] :
      ( v43740(VarCurr,1)
    <=> v43742(VarCurr,1) ) ).

tff(addAssignment_21877,axiom,
    ! [VarCurr: state_type] :
      ( v43742(VarCurr,1)
    <=> v43743(VarCurr,1) ) ).

tff(addAssignment_21876,axiom,
    ! [VarCurr: state_type] :
      ( v43743(VarCurr,0)
    <=> v43744(VarCurr) ) ).

tff(addAssignment_21875,axiom,
    ! [VarCurr: state_type] :
      ( v43743(VarCurr,1)
    <=> v43744(VarCurr) ) ).

tff(addAssignment_21874,axiom,
    ! [VarCurr: state_type] :
      ( v43744(VarCurr)
    <=> v43267(VarCurr) ) ).

tff(addAssignment_21873,axiom,
    ! [VarCurr: state_type] :
      ( v43709(VarCurr)
    <=> v43711(VarCurr) ) ).

tff(addAssignment_21872,axiom,
    ! [VarCurr: state_type] :
      ( v43711(VarCurr)
    <=> v43713(VarCurr) ) ).

tff(addAssignment_21871,axiom,
    ! [VarCurr: state_type] :
      ( v43713(VarCurr)
    <=> v43715(VarCurr) ) ).

tff(addAssignment_21870,axiom,
    ! [VarCurr: state_type] :
      ( v43715(VarCurr)
    <=> v43717(VarCurr) ) ).

tff(addAssignment_21869,axiom,
    ! [VarCurr: state_type] :
      ( v43717(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_21868,axiom,
    ! [VarCurr: state_type] :
      ( v43697(VarCurr)
    <=> v43699(VarCurr) ) ).

tff(addAssignment_21867,axiom,
    ! [VarCurr: state_type] :
      ( v43699(VarCurr)
    <=> v43701(VarCurr) ) ).

tff(addAssignment_21866,axiom,
    ! [VarCurr: state_type] :
      ( v43701(VarCurr)
    <=> v43703(VarCurr) ) ).

tff(addAssignment_21865,axiom,
    ! [VarCurr: state_type] :
      ( v43703(VarCurr)
    <=> v43705(VarCurr) ) ).

tff(addAssignment_21864,axiom,
    ! [VarCurr: state_type] :
      ( v43705(VarCurr)
    <=> v43707(VarCurr) ) ).

tff(addAssignment_21863,axiom,
    ! [VarCurr: state_type] :
      ( v43707(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_21862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43205(VarCurr,B)
      <=> v43207(VarCurr,B) ) ) ).

tff(addAssignment_21861,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43207(VarCurr,B)
      <=> v43209(VarCurr,B) ) ) ).

tff(addAssignment_21860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43209(VarCurr,B)
      <=> v43211(VarCurr,B) ) ) ).

tff(addAssignment_21859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43211(VarCurr,B)
      <=> v43213(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_510,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43658(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v43213(VarNext,B)
            <=> v43213(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_510,axiom,
    ! [VarNext: state_type] :
      ( v43658(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43213(VarNext,B)
          <=> v43668(VarNext,B) ) ) ) ).

tff(addAssignment_21858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43668(VarNext,B)
          <=> v43666(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43669(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43666(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_346,axiom,
    ! [VarCurr: state_type] :
      ( v43669(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43666(VarCurr,B)
          <=> v43243(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4125,axiom,
    ! [VarCurr: state_type] :
      ( v43669(VarCurr)
    <=> ( v43670(VarCurr)
        & v43671(VarCurr) ) ) ).

tff(writeUnaryOperator_2533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43671(VarCurr)
    <=> v43229(VarCurr) ) ).

tff(writeUnaryOperator_2532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43670(VarCurr)
    <=> v43215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43658(VarNext)
      <=> v43659(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43659(VarNext)
      <=> ( v43660(VarNext)
          & v43573(VarNext) ) ) ) ).

tff(writeUnaryOperator_2531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43660(VarNext)
      <=> v43662(VarNext) ) ) ).

tff(addAssignment_21857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43662(VarNext)
      <=> v43573(VarCurr) ) ) ).

tff(addAssignment_21856,axiom,
    ! [VarCurr: state_type] :
      ( v43573(VarCurr)
    <=> v43575(VarCurr) ) ).

tff(addAssignment_21855,axiom,
    ! [VarCurr: state_type] :
      ( v43575(VarCurr)
    <=> v43577(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4122,axiom,
    ! [VarCurr: state_type] :
      ( v43577(VarCurr)
    <=> ( v43655(VarCurr)
        | v43647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4121,axiom,
    ! [VarCurr: state_type] :
      ( v43655(VarCurr)
    <=> ( v43579(VarCurr)
        & v43585(VarCurr) ) ) ).

tff(addAssignment_21854,axiom,
    ! [VarCurr: state_type] :
      ( v43647(VarCurr)
    <=> v43649(VarCurr) ) ).

tff(addAssignment_21853,axiom,
    ! [VarCurr: state_type] :
      ( v43649(VarCurr)
    <=> v43651(VarCurr) ) ).

tff(addAssignment_21852,axiom,
    ! [VarCurr: state_type] :
      ( v43651(VarCurr)
    <=> v43653(VarCurr) ) ).

tff(addAssignment_21851,axiom,
    ! [VarCurr: state_type] :
      ( v43653(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43631(VarNext)
       => ( v43585(VarNext)
        <=> v43585(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_509,axiom,
    ! [VarNext: state_type] :
      ( v43631(VarNext)
     => ( v43585(VarNext)
      <=> v43641(VarNext) ) ) ).

tff(addAssignment_21850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43641(VarNext)
      <=> v43639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4120,axiom,
    ! [VarCurr: state_type] :
      ( v43639(VarCurr)
    <=> ( v43642(VarCurr)
        & v43643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4119,axiom,
    ! [VarCurr: state_type] :
      ( v43643(VarCurr)
    <=> ( v43591(VarCurr)
        | v43622(VarCurr) ) ) ).

tff(writeUnaryOperator_2530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43642(VarCurr)
    <=> v43587(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43631(VarNext)
      <=> v43632(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43632(VarNext)
      <=> ( v43634(VarNext)
          & v43636(VarNext) ) ) ) ).

tff(writeUnaryOperator_2529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43636(VarCurr)
    <=> v43579(VarCurr) ) ).

tff(addAssignment_21849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43634(VarNext)
      <=> v43579(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_183,axiom,
    ( v43585(constB0)
  <=> $true ) ).

tff(addAssignment_21848,axiom,
    ! [VarCurr: state_type] :
      ( v43622(VarCurr)
    <=> v43624(VarCurr) ) ).

tff(addAssignment_21847,axiom,
    ! [VarCurr: state_type] :
      ( v43624(VarCurr)
    <=> v43626(VarCurr) ) ).

tff(addAssignment_21846,axiom,
    ! [VarCurr: state_type] :
      ( v43626(VarCurr)
    <=> v43628(VarCurr) ) ).

tff(addAssignment_21845,axiom,
    ! [VarCurr: state_type] :
      ( v43628(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_21844,axiom,
    ! [VarCurr: state_type] :
      ( v43591(VarCurr)
    <=> v43593(VarCurr) ) ).

tff(addAssignment_21843,axiom,
    ! [VarCurr: state_type] :
      ( v43593(VarCurr)
    <=> v43595(VarCurr) ) ).

tff(addAssignment_21842,axiom,
    ! [VarCurr: state_type] :
      ( v43595(VarCurr)
    <=> v43597(VarCurr) ) ).

tff(addAssignment_21841,axiom,
    ! [VarCurr: state_type] :
      ( v43597(VarCurr)
    <=> v43599(VarCurr) ) ).

tff(writeUnaryOperator_2528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43599(VarCurr)
    <=> v43619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4116,axiom,
    ! [VarCurr: state_type] :
      ( v43619(VarCurr)
    <=> ( v43620(VarCurr)
        | v43615(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4115,axiom,
    ! [VarCurr: state_type] :
      ( v43620(VarCurr)
    <=> ( v43601(VarCurr)
        | v43611(VarCurr) ) ) ).

tff(addAssignment_21840,axiom,
    ! [VarCurr: state_type] :
      ( v43615(VarCurr)
    <=> v43617(VarCurr) ) ).

tff(addAssignment_21839,axiom,
    ! [VarCurr: state_type] :
      ( v43617(VarCurr)
    <=> v43605(VarCurr,2) ) ).

tff(addAssignment_21838,axiom,
    ! [VarCurr: state_type] :
      ( v43605(VarCurr,2)
    <=> v43607(VarCurr,2) ) ).

tff(addAssignment_21837,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,2)
    <=> v43609(VarCurr,2) ) ).

tff(addAssignment_21836,axiom,
    ! [VarCurr: state_type] :
      ( v43611(VarCurr)
    <=> v43613(VarCurr) ) ).

tff(addAssignment_21835,axiom,
    ! [VarCurr: state_type] :
      ( v43613(VarCurr)
    <=> v43605(VarCurr,1) ) ).

tff(addAssignment_21834,axiom,
    ! [VarCurr: state_type] :
      ( v43605(VarCurr,1)
    <=> v43607(VarCurr,1) ) ).

tff(addAssignment_21833,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,1)
    <=> v43609(VarCurr,1) ) ).

tff(addAssignment_21832,axiom,
    ! [VarCurr: state_type] :
      ( v43601(VarCurr)
    <=> v43603(VarCurr) ) ).

tff(addAssignment_21831,axiom,
    ! [VarCurr: state_type] :
      ( v43603(VarCurr)
    <=> v43605(VarCurr,0) ) ).

tff(addAssignment_21830,axiom,
    ! [VarCurr: state_type] :
      ( v43605(VarCurr,0)
    <=> v43607(VarCurr,0) ) ).

tff(addAssignment_21829,axiom,
    ! [VarCurr: state_type] :
      ( v43607(VarCurr,0)
    <=> v43609(VarCurr,0) ) ).

tff(addAssignment_21828,axiom,
    ! [VarCurr: state_type] :
      ( v43587(VarCurr)
    <=> v43589(VarCurr) ) ).

tff(addAssignment_21827,axiom,
    ! [VarCurr: state_type] :
      ( v43589(VarCurr)
    <=> $false ) ).

tff(addAssignment_21826,axiom,
    ! [VarCurr: state_type] :
      ( v43579(VarCurr)
    <=> v43581(VarCurr) ) ).

tff(addAssignment_21825,axiom,
    ! [VarCurr: state_type] :
      ( v43581(VarCurr)
    <=> v43583(VarCurr) ) ).

tff(addAssignment_21824,axiom,
    ! [VarCurr: state_type] :
      ( v43583(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_21823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43243(VarCurr,B)
      <=> v43245(VarCurr,B) ) ) ).

tff(addAssignment_21822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43245(VarCurr,B)
      <=> v43247(VarCurr,B) ) ) ).

tff(addAssignment_21821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43247(VarCurr,B)
      <=> v43249(VarCurr,B) ) ) ).

tff(addAssignment_21820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43249(VarCurr,B)
      <=> v43251(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43251(VarCurr,B)
      <=> ( v43253(VarCurr,B)
          & v43275(VarCurr,B) ) ) ) ).

tff(addAssignment_21819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43275(VarCurr,B)
      <=> v43277(VarCurr,B) ) ) ).

tff(addAssignment_21818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43277(VarCurr,B)
      <=> v43279(VarCurr,B) ) ) ).

tff(addAssignment_21817,axiom,
    ! [VarCurr: state_type] :
      ( ( v43279(VarCurr,11)
      <=> v6324(VarCurr,107) )
      & ( v43279(VarCurr,10)
      <=> v6324(VarCurr,106) )
      & ( v43279(VarCurr,9)
      <=> v6324(VarCurr,105) )
      & ( v43279(VarCurr,8)
      <=> v6324(VarCurr,104) )
      & ( v43279(VarCurr,7)
      <=> v6324(VarCurr,103) )
      & ( v43279(VarCurr,6)
      <=> v6324(VarCurr,102) )
      & ( v43279(VarCurr,5)
      <=> v6324(VarCurr,101) )
      & ( v43279(VarCurr,4)
      <=> v6324(VarCurr,100) )
      & ( v43279(VarCurr,3)
      <=> v6324(VarCurr,99) )
      & ( v43279(VarCurr,2)
      <=> v6324(VarCurr,98) )
      & ( v43279(VarCurr,1)
      <=> v6324(VarCurr,97) )
      & ( v43279(VarCurr,0)
      <=> v6324(VarCurr,96) ) ) ).

tff(addAssignment_21816,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,107)
      <=> v43281(VarCurr,11) )
      & ( v6324(VarCurr,106)
      <=> v43281(VarCurr,10) )
      & ( v6324(VarCurr,105)
      <=> v43281(VarCurr,9) )
      & ( v6324(VarCurr,104)
      <=> v43281(VarCurr,8) )
      & ( v6324(VarCurr,103)
      <=> v43281(VarCurr,7) )
      & ( v6324(VarCurr,102)
      <=> v43281(VarCurr,6) )
      & ( v6324(VarCurr,101)
      <=> v43281(VarCurr,5) )
      & ( v6324(VarCurr,100)
      <=> v43281(VarCurr,4) )
      & ( v6324(VarCurr,99)
      <=> v43281(VarCurr,3) )
      & ( v6324(VarCurr,98)
      <=> v43281(VarCurr,2) )
      & ( v6324(VarCurr,97)
      <=> v43281(VarCurr,1) )
      & ( v6324(VarCurr,96)
      <=> v43281(VarCurr,0) ) ) ).

tff(addAssignment_21815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43281(VarCurr,B)
      <=> v43283(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43283(VarCurr,B)
      <=> ( v43565(VarCurr,B)
          | v43568(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43568(VarCurr,B)
      <=> ( v43293(VarCurr,B)
          & v43569(VarCurr,B) ) ) ) ).

tff(addAssignment_21814,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,0)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21813,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,1)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21812,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,2)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21811,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,3)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21810,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,4)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21809,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,5)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21808,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,6)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21807,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,7)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21806,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,8)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21805,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,9)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21804,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,10)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21803,axiom,
    ! [VarCurr: state_type] :
      ( v43569(VarCurr,11)
    <=> v43570(VarCurr) ) ).

tff(addAssignment_21802,axiom,
    ! [VarCurr: state_type] :
      ( v43570(VarCurr)
    <=> v43561(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43565(VarCurr,B)
      <=> ( v43285(VarCurr,B)
          & v43566(VarCurr,B) ) ) ) ).

tff(addAssignment_21801,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,0)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21800,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,1)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21799,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,2)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21798,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,3)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21797,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,4)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21796,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,5)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21795,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,6)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21794,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,7)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21793,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,8)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21792,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,9)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21791,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,10)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21790,axiom,
    ! [VarCurr: state_type] :
      ( v43566(VarCurr,11)
    <=> v43567(VarCurr) ) ).

tff(addAssignment_21789,axiom,
    ! [VarCurr: state_type] :
      ( v43567(VarCurr)
    <=> v43289(VarCurr) ) ).

tff(addAssignment_21788,axiom,
    ! [VarCurr: state_type] :
      ( v43561(VarCurr)
    <=> v43563(VarCurr) ) ).

tff(addAssignment_21787,axiom,
    ! [VarCurr: state_type] :
      ( v43563(VarCurr)
    <=> v7021(VarCurr,8) ) ).

tff(addAssignment_21786,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,8)
    <=> v7023(VarCurr,8) ) ).

tff(addAssignment_21785,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,8)
    <=> v6623(VarCurr,8) ) ).

tff(addAssignment_21784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43293(VarCurr,B)
      <=> v43295(VarCurr,B) ) ) ).

tff(addAssignment_21783,axiom,
    ! [VarCurr: state_type] :
      ( ( v43295(VarCurr,11)
      <=> v6334(VarCurr,119) )
      & ( v43295(VarCurr,10)
      <=> v6334(VarCurr,118) )
      & ( v43295(VarCurr,9)
      <=> v6334(VarCurr,117) )
      & ( v43295(VarCurr,8)
      <=> v6334(VarCurr,116) )
      & ( v43295(VarCurr,7)
      <=> v6334(VarCurr,115) )
      & ( v43295(VarCurr,6)
      <=> v6334(VarCurr,114) )
      & ( v43295(VarCurr,5)
      <=> v6334(VarCurr,113) )
      & ( v43295(VarCurr,4)
      <=> v6334(VarCurr,112) )
      & ( v43295(VarCurr,3)
      <=> v6334(VarCurr,111) )
      & ( v43295(VarCurr,2)
      <=> v6334(VarCurr,110) )
      & ( v43295(VarCurr,1)
      <=> v6334(VarCurr,109) )
      & ( v43295(VarCurr,0)
      <=> v6334(VarCurr,108) ) ) ).

tff(addAssignment_21782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,120)
        & ~ $less(B,108) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_21781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,120)
        & ~ $less(B,108) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_21780,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,119)
      <=> v43297(VarCurr,11) )
      & ( v6338(VarCurr,118)
      <=> v43297(VarCurr,10) )
      & ( v6338(VarCurr,117)
      <=> v43297(VarCurr,9) )
      & ( v6338(VarCurr,116)
      <=> v43297(VarCurr,8) )
      & ( v6338(VarCurr,115)
      <=> v43297(VarCurr,7) )
      & ( v6338(VarCurr,114)
      <=> v43297(VarCurr,6) )
      & ( v6338(VarCurr,113)
      <=> v43297(VarCurr,5) )
      & ( v6338(VarCurr,112)
      <=> v43297(VarCurr,4) )
      & ( v6338(VarCurr,111)
      <=> v43297(VarCurr,3) )
      & ( v6338(VarCurr,110)
      <=> v43297(VarCurr,2) )
      & ( v6338(VarCurr,109)
      <=> v43297(VarCurr,1) )
      & ( v6338(VarCurr,108)
      <=> v43297(VarCurr,0) ) ) ).

tff(addAssignment_21779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43297(VarCurr,B)
      <=> v43299(VarCurr,B) ) ) ).

tff(addAssignment_21778,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43299(VarCurr,B)
      <=> v43301(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43544(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v43301(VarNext,B)
            <=> v43301(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_508,axiom,
    ! [VarNext: state_type] :
      ( v43544(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43301(VarNext,B)
          <=> v43554(VarNext,B) ) ) ) ).

tff(addAssignment_21777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43554(VarNext,B)
          <=> v43552(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43555(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43552(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_345,axiom,
    ! [VarCurr: state_type] :
      ( v43555(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43552(VarCurr,B)
          <=> v43331(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4114,axiom,
    ! [VarCurr: state_type] :
      ( v43555(VarCurr)
    <=> ( v43556(VarCurr)
        & v43557(VarCurr) ) ) ).

tff(writeUnaryOperator_2527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43557(VarCurr)
    <=> v43317(VarCurr) ) ).

tff(writeUnaryOperator_2526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43556(VarCurr)
    <=> v43303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43544(VarNext)
      <=> v43545(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43545(VarNext)
      <=> ( v43546(VarNext)
          & v43519(VarNext) ) ) ) ).

tff(writeUnaryOperator_2525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43546(VarNext)
      <=> v43548(VarNext) ) ) ).

tff(addAssignment_21776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43548(VarNext)
      <=> v43519(VarCurr) ) ) ).

tff(addAssignment_21775,axiom,
    ! [VarCurr: state_type] :
      ( v43519(VarCurr)
    <=> v43521(VarCurr) ) ).

tff(addAssignment_21774,axiom,
    ! [VarCurr: state_type] :
      ( v43521(VarCurr)
    <=> v43523(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4111,axiom,
    ! [VarCurr: state_type] :
      ( v43523(VarCurr)
    <=> ( v43541(VarCurr)
        | v43533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4110,axiom,
    ! [VarCurr: state_type] :
      ( v43541(VarCurr)
    <=> ( v43525(VarCurr)
        & v43531(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_182,axiom,
    ( v43531(constB0)
  <=> $true ) ).

tff(addAssignment_21773,axiom,
    ! [VarCurr: state_type] :
      ( v43533(VarCurr)
    <=> v43535(VarCurr) ) ).

tff(addAssignment_21772,axiom,
    ! [VarCurr: state_type] :
      ( v43535(VarCurr)
    <=> v43537(VarCurr) ) ).

tff(addAssignment_21771,axiom,
    ! [VarCurr: state_type] :
      ( v43537(VarCurr)
    <=> v43539(VarCurr) ) ).

tff(addAssignment_21770,axiom,
    ! [VarCurr: state_type] :
      ( v43539(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_21769,axiom,
    ! [VarCurr: state_type] :
      ( v43525(VarCurr)
    <=> v43527(VarCurr) ) ).

tff(addAssignment_21768,axiom,
    ! [VarCurr: state_type] :
      ( v43527(VarCurr)
    <=> v43529(VarCurr) ) ).

tff(addAssignment_21767,axiom,
    ! [VarCurr: state_type] :
      ( v43529(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_21766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43331(VarCurr,B)
      <=> v43333(VarCurr,B) ) ) ).

tff(addAssignment_21765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43333(VarCurr,B)
      <=> v43335(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43335(VarCurr,B)
      <=> ( v43504(VarCurr,B)
          | v43515(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43515(VarCurr,B)
      <=> ( v43468(VarCurr,B)
          & v43516(VarCurr,B) ) ) ) ).

tff(addAssignment_21764,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,0)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21763,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,1)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21762,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,2)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21761,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,3)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21760,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,4)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21759,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,5)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21758,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,6)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21757,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,7)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21756,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,8)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21755,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,9)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21754,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,10)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21753,axiom,
    ! [VarCurr: state_type] :
      ( v43516(VarCurr,11)
    <=> v43517(VarCurr) ) ).

tff(addAssignment_21752,axiom,
    ! [VarCurr: state_type] :
      ( v43517(VarCurr)
    <=> v43478(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43504(VarCurr,B)
      <=> ( v43505(VarCurr,B)
          | v43512(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43512(VarCurr,B)
      <=> ( v43432(VarCurr,B)
          & v43513(VarCurr,B) ) ) ) ).

tff(addAssignment_21751,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,0)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21750,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,1)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21749,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,2)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21748,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,3)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21747,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,4)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21746,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,5)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21745,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,6)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21744,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,7)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21743,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,8)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21742,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,9)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21741,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,10)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21740,axiom,
    ! [VarCurr: state_type] :
      ( v43513(VarCurr,11)
    <=> v43514(VarCurr) ) ).

tff(addAssignment_21739,axiom,
    ! [VarCurr: state_type] :
      ( v43514(VarCurr)
    <=> v43442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43505(VarCurr,B)
      <=> ( v43506(VarCurr,B)
          | v43509(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43509(VarCurr,B)
      <=> ( v43385(VarCurr,B)
          & v43510(VarCurr,B) ) ) ) ).

tff(addAssignment_21738,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,0)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21737,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,1)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21736,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,2)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21735,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,3)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21734,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,4)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21733,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,5)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21732,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,6)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21731,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,7)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21730,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,8)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21729,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,9)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21728,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,10)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21727,axiom,
    ! [VarCurr: state_type] :
      ( v43510(VarCurr,11)
    <=> v43511(VarCurr) ) ).

tff(addAssignment_21726,axiom,
    ! [VarCurr: state_type] :
      ( v43511(VarCurr)
    <=> v43395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43506(VarCurr,B)
      <=> ( v43337(VarCurr,B)
          & v43507(VarCurr,B) ) ) ) ).

tff(addAssignment_21725,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,0)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21724,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,1)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21723,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,2)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21722,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,3)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21721,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,4)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21720,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,5)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21719,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,6)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21718,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,7)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21717,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,8)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21716,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,9)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21715,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,10)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21714,axiom,
    ! [VarCurr: state_type] :
      ( v43507(VarCurr,11)
    <=> v43508(VarCurr) ) ).

tff(addAssignment_21713,axiom,
    ! [VarCurr: state_type] :
      ( v43508(VarCurr)
    <=> v43347(VarCurr) ) ).

tff(addAssignment_21712,axiom,
    ! [VarCurr: state_type] :
      ( v43478(VarCurr)
    <=> v43480(VarCurr) ) ).

tff(addAssignment_21711,axiom,
    ! [VarCurr: state_type] :
      ( v43480(VarCurr)
    <=> v43482(VarCurr) ) ).

tff(addAssignment_21710,axiom,
    ! [VarCurr: state_type] :
      ( v43482(VarCurr)
    <=> v43484(VarCurr) ) ).

tff(addAssignment_21709,axiom,
    ! [VarCurr: state_type] :
      ( v43484(VarCurr)
    <=> v43486(VarCurr) ) ).

tff(addAssignment_21708,axiom,
    ! [VarCurr: state_type] :
      ( v43486(VarCurr)
    <=> v43488(VarCurr) ) ).

tff(addAssignment_21707,axiom,
    ! [VarCurr: state_type] :
      ( v43488(VarCurr)
    <=> v43490(VarCurr) ) ).

tff(addAssignment_21706,axiom,
    ! [VarCurr: state_type] :
      ( v43490(VarCurr)
    <=> v43492(VarCurr) ) ).

tff(writeUnaryOperator_2524,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43492(VarCurr)
    <=> v43502(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4109,axiom,
    ! [VarCurr: state_type] :
      ( v43502(VarCurr)
    <=> ( v43494(VarCurr)
        | v43498(VarCurr) ) ) ).

tff(addAssignment_21705,axiom,
    ! [VarCurr: state_type] :
      ( v43498(VarCurr)
    <=> v43500(VarCurr) ) ).

tff(addAssignment_21704,axiom,
    ! [VarCurr: state_type] :
      ( v43500(VarCurr)
    <=> v43415(VarCurr,1) ) ).

tff(addAssignment_21703,axiom,
    ! [VarCurr: state_type] :
      ( v43494(VarCurr)
    <=> v43496(VarCurr) ) ).

tff(addAssignment_21702,axiom,
    ! [VarCurr: state_type] :
      ( v43496(VarCurr)
    <=> v43415(VarCurr,0) ) ).

tff(addAssignment_21701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43468(VarCurr,B)
      <=> v43470(VarCurr,B) ) ) ).

tff(addAssignment_21700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43470(VarCurr,B)
      <=> v43472(VarCurr,B) ) ) ).

tff(addAssignment_21699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43472(VarCurr,B)
      <=> v43474(VarCurr,B) ) ) ).

tff(addAssignment_21698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43474(VarCurr,B)
      <=> v43476(VarCurr,B) ) ) ).

tff(addAssignment_21697,axiom,
    ! [VarCurr: state_type] :
      ( v43442(VarCurr)
    <=> v43444(VarCurr) ) ).

tff(addAssignment_21696,axiom,
    ! [VarCurr: state_type] :
      ( v43444(VarCurr)
    <=> v43446(VarCurr) ) ).

tff(addAssignment_21695,axiom,
    ! [VarCurr: state_type] :
      ( v43446(VarCurr)
    <=> v43448(VarCurr) ) ).

tff(addAssignment_21694,axiom,
    ! [VarCurr: state_type] :
      ( v43448(VarCurr)
    <=> v43450(VarCurr) ) ).

tff(addAssignment_21693,axiom,
    ! [VarCurr: state_type] :
      ( v43450(VarCurr)
    <=> v43452(VarCurr) ) ).

tff(addAssignment_21692,axiom,
    ! [VarCurr: state_type] :
      ( v43452(VarCurr)
    <=> v43454(VarCurr) ) ).

tff(addAssignment_21691,axiom,
    ! [VarCurr: state_type] :
      ( v43454(VarCurr)
    <=> v43456(VarCurr) ) ).

tff(writeUnaryOperator_2523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43456(VarCurr)
    <=> v43466(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4108,axiom,
    ! [VarCurr: state_type] :
      ( v43466(VarCurr)
    <=> ( v43458(VarCurr)
        | v43462(VarCurr) ) ) ).

tff(addAssignment_21690,axiom,
    ! [VarCurr: state_type] :
      ( v43462(VarCurr)
    <=> v43464(VarCurr) ) ).

tff(addAssignment_21689,axiom,
    ! [VarCurr: state_type] :
      ( v43464(VarCurr)
    <=> v43415(VarCurr,1) ) ).

tff(addAssignment_21688,axiom,
    ! [VarCurr: state_type] :
      ( v43415(VarCurr,1)
    <=> v43417(VarCurr,1) ) ).

tff(addAssignment_21687,axiom,
    ! [VarCurr: state_type] :
      ( v43417(VarCurr,1)
    <=> v43419(VarCurr,1) ) ).

tff(addAssignment_21686,axiom,
    ! [VarCurr: state_type] :
      ( v43419(VarCurr,1)
    <=> v43424(VarCurr,1) ) ).

tff(addAssignment_21685,axiom,
    ! [VarCurr: state_type] :
      ( v43421(VarCurr,1)
    <=> v43423(VarCurr,1) ) ).

tff(addAssignment_21684,axiom,
    ! [VarCurr: state_type] :
      ( v43423(VarCurr,1)
    <=> v43367(VarCurr,1) ) ).

tff(addAssignment_21683,axiom,
    ! [VarCurr: state_type] :
      ( v43458(VarCurr)
    <=> v43460(VarCurr) ) ).

tff(addAssignment_21682,axiom,
    ! [VarCurr: state_type] :
      ( v43460(VarCurr)
    <=> v43367(VarCurr,0) ) ).

tff(addAssignment_21681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43432(VarCurr,B)
      <=> v43434(VarCurr,B) ) ) ).

tff(addAssignment_21680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43434(VarCurr,B)
      <=> v43436(VarCurr,B) ) ) ).

tff(addAssignment_21679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43436(VarCurr,B)
      <=> v43438(VarCurr,B) ) ) ).

tff(addAssignment_21678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43438(VarCurr,B)
      <=> v43440(VarCurr,B) ) ) ).

tff(addAssignment_21677,axiom,
    ! [VarCurr: state_type] :
      ( v43395(VarCurr)
    <=> v43397(VarCurr) ) ).

tff(addAssignment_21676,axiom,
    ! [VarCurr: state_type] :
      ( v43397(VarCurr)
    <=> v43399(VarCurr) ) ).

tff(addAssignment_21675,axiom,
    ! [VarCurr: state_type] :
      ( v43399(VarCurr)
    <=> v43401(VarCurr) ) ).

tff(addAssignment_21674,axiom,
    ! [VarCurr: state_type] :
      ( v43401(VarCurr)
    <=> v43403(VarCurr) ) ).

tff(addAssignment_21673,axiom,
    ! [VarCurr: state_type] :
      ( v43403(VarCurr)
    <=> v43405(VarCurr) ) ).

tff(addAssignment_21672,axiom,
    ! [VarCurr: state_type] :
      ( v43405(VarCurr)
    <=> v43407(VarCurr) ) ).

tff(addAssignment_21671,axiom,
    ! [VarCurr: state_type] :
      ( v43407(VarCurr)
    <=> v43409(VarCurr) ) ).

tff(writeUnaryOperator_2522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43409(VarCurr)
    <=> v43430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4107,axiom,
    ! [VarCurr: state_type] :
      ( v43430(VarCurr)
    <=> ( v43411(VarCurr)
        | v43426(VarCurr) ) ) ).

tff(addAssignment_21670,axiom,
    ! [VarCurr: state_type] :
      ( v43426(VarCurr)
    <=> v43428(VarCurr) ) ).

tff(addAssignment_21669,axiom,
    ! [VarCurr: state_type] :
      ( v43428(VarCurr)
    <=> v43367(VarCurr,1) ) ).

tff(addAssignment_21668,axiom,
    ! [VarCurr: state_type] :
      ( v43411(VarCurr)
    <=> v43413(VarCurr) ) ).

tff(addAssignment_21667,axiom,
    ! [VarCurr: state_type] :
      ( v43413(VarCurr)
    <=> v43415(VarCurr,0) ) ).

tff(addAssignment_21666,axiom,
    ! [VarCurr: state_type] :
      ( v43415(VarCurr,0)
    <=> v43417(VarCurr,0) ) ).

tff(addAssignment_21665,axiom,
    ! [VarCurr: state_type] :
      ( v43417(VarCurr,0)
    <=> v43419(VarCurr,0) ) ).

tff(addAssignment_21664,axiom,
    ! [VarCurr: state_type] :
      ( v43419(VarCurr,0)
    <=> v43424(VarCurr,0) ) ).

tff(writeUnaryOperator_2521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v43424(VarCurr,B)
      <=> ~ v43421(VarCurr,B) ) ) ).

tff(addAssignment_21663,axiom,
    ! [VarCurr: state_type] :
      ( v43421(VarCurr,0)
    <=> v43423(VarCurr,0) ) ).

tff(addAssignment_21662,axiom,
    ! [VarCurr: state_type] :
      ( v43423(VarCurr,0)
    <=> v43367(VarCurr,0) ) ).

tff(addAssignment_21661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43385(VarCurr,B)
      <=> v43387(VarCurr,B) ) ) ).

tff(addAssignment_21660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43387(VarCurr,B)
      <=> v43389(VarCurr,B) ) ) ).

tff(addAssignment_21659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43389(VarCurr,B)
      <=> v43391(VarCurr,B) ) ) ).

tff(addAssignment_21658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43391(VarCurr,B)
      <=> v43393(VarCurr,B) ) ) ).

tff(addAssignment_21657,axiom,
    ! [VarCurr: state_type] :
      ( v43347(VarCurr)
    <=> v43349(VarCurr) ) ).

tff(addAssignment_21656,axiom,
    ! [VarCurr: state_type] :
      ( v43349(VarCurr)
    <=> v43351(VarCurr) ) ).

tff(addAssignment_21655,axiom,
    ! [VarCurr: state_type] :
      ( v43351(VarCurr)
    <=> v43353(VarCurr) ) ).

tff(addAssignment_21654,axiom,
    ! [VarCurr: state_type] :
      ( v43353(VarCurr)
    <=> v43355(VarCurr) ) ).

tff(addAssignment_21653,axiom,
    ! [VarCurr: state_type] :
      ( v43355(VarCurr)
    <=> v43357(VarCurr) ) ).

tff(addAssignment_21652,axiom,
    ! [VarCurr: state_type] :
      ( v43357(VarCurr)
    <=> v43359(VarCurr) ) ).

tff(addAssignment_21651,axiom,
    ! [VarCurr: state_type] :
      ( v43359(VarCurr)
    <=> v43361(VarCurr) ) ).

tff(writeUnaryOperator_2520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43361(VarCurr)
    <=> v43383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4106,axiom,
    ! [VarCurr: state_type] :
      ( v43383(VarCurr)
    <=> ( v43363(VarCurr)
        | v43379(VarCurr) ) ) ).

tff(addAssignment_21650,axiom,
    ! [VarCurr: state_type] :
      ( v43379(VarCurr)
    <=> v43381(VarCurr) ) ).

tff(addAssignment_21649,axiom,
    ! [VarCurr: state_type] :
      ( v43381(VarCurr)
    <=> v43367(VarCurr,1) ) ).

tff(addAssignment_21648,axiom,
    ! [VarCurr: state_type] :
      ( v43367(VarCurr,1)
    <=> v43369(VarCurr,1) ) ).

tff(addAssignment_21647,axiom,
    ! [VarCurr: state_type] :
      ( v43369(VarCurr,1)
    <=> v43371(VarCurr,1) ) ).

tff(addAssignment_21646,axiom,
    ! [VarCurr: state_type] :
      ( v43371(VarCurr,1)
    <=> v43373(VarCurr,1) ) ).

tff(addAssignment_21645,axiom,
    ! [VarCurr: state_type] :
      ( v43373(VarCurr,1)
    <=> v43375(VarCurr,1) ) ).

tff(addAssignment_21644,axiom,
    ! [VarCurr: state_type] :
      ( v43375(VarCurr,1)
    <=> v43377(VarCurr,1) ) ).

tff(addAssignment_21643,axiom,
    ! [VarCurr: state_type] :
      ( v43363(VarCurr)
    <=> v43365(VarCurr) ) ).

tff(addAssignment_21642,axiom,
    ! [VarCurr: state_type] :
      ( v43365(VarCurr)
    <=> v43367(VarCurr,0) ) ).

tff(addAssignment_21641,axiom,
    ! [VarCurr: state_type] :
      ( v43367(VarCurr,0)
    <=> v43369(VarCurr,0) ) ).

tff(addAssignment_21640,axiom,
    ! [VarCurr: state_type] :
      ( v43369(VarCurr,0)
    <=> v43371(VarCurr,0) ) ).

tff(addAssignment_21639,axiom,
    ! [VarCurr: state_type] :
      ( v43371(VarCurr,0)
    <=> v43373(VarCurr,0) ) ).

tff(addAssignment_21638,axiom,
    ! [VarCurr: state_type] :
      ( v43373(VarCurr,0)
    <=> v43375(VarCurr,0) ) ).

tff(addAssignment_21637,axiom,
    ! [VarCurr: state_type] :
      ( v43375(VarCurr,0)
    <=> v43377(VarCurr,0) ) ).

tff(addAssignment_21636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43337(VarCurr,B)
      <=> v43339(VarCurr,B) ) ) ).

tff(addAssignment_21635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43339(VarCurr,B)
      <=> v43341(VarCurr,B) ) ) ).

tff(addAssignment_21634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43341(VarCurr,B)
      <=> v43343(VarCurr,B) ) ) ).

tff(addAssignment_21633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43343(VarCurr,B)
      <=> v43345(VarCurr,B) ) ) ).

tff(addAssignment_21632,axiom,
    ! [VarCurr: state_type] :
      ( v43317(VarCurr)
    <=> v43319(VarCurr) ) ).

tff(addAssignment_21631,axiom,
    ! [VarCurr: state_type] :
      ( v43319(VarCurr)
    <=> v43321(VarCurr) ) ).

tff(addAssignment_21630,axiom,
    ! [VarCurr: state_type] :
      ( v43321(VarCurr)
    <=> v43323(VarCurr) ) ).

tff(addAssignment_21629,axiom,
    ! [VarCurr: state_type] :
      ( v43323(VarCurr)
    <=> v43325(VarCurr) ) ).

tff(addAssignment_21628,axiom,
    ! [VarCurr: state_type] :
      ( v43325(VarCurr)
    <=> v43327(VarCurr) ) ).

tff(addAssignment_21627,axiom,
    ! [VarCurr: state_type] :
      ( v43327(VarCurr)
    <=> v43329(VarCurr) ) ).

tff(addAssignment_21626,axiom,
    ! [VarCurr: state_type] :
      ( v43329(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_21625,axiom,
    ! [VarCurr: state_type] :
      ( v43303(VarCurr)
    <=> v43305(VarCurr) ) ).

tff(addAssignment_21624,axiom,
    ! [VarCurr: state_type] :
      ( v43305(VarCurr)
    <=> v43307(VarCurr) ) ).

tff(addAssignment_21623,axiom,
    ! [VarCurr: state_type] :
      ( v43307(VarCurr)
    <=> v43309(VarCurr) ) ).

tff(addAssignment_21622,axiom,
    ! [VarCurr: state_type] :
      ( v43309(VarCurr)
    <=> v43311(VarCurr) ) ).

tff(addAssignment_21621,axiom,
    ! [VarCurr: state_type] :
      ( v43311(VarCurr)
    <=> v43313(VarCurr) ) ).

tff(addAssignment_21620,axiom,
    ! [VarCurr: state_type] :
      ( v43313(VarCurr)
    <=> v43315(VarCurr) ) ).

tff(addAssignment_21619,axiom,
    ! [VarCurr: state_type] :
      ( v43315(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_21618,axiom,
    ! [VarCurr: state_type] :
      ( v43289(VarCurr)
    <=> v43291(VarCurr) ) ).

tff(addAssignment_21617,axiom,
    ! [VarCurr: state_type] :
      ( v43291(VarCurr)
    <=> v6617(VarCurr,8) ) ).

tff(addAssignment_21616,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,8)
    <=> v6619(VarCurr,8) ) ).

tff(addAssignment_21615,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,8)
    <=> v6621(VarCurr,8) ) ).

tff(addAssignment_21614,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,8)
    <=> v6747(VarCurr,8) ) ).

tff(addAssignment_21613,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,8)
    <=> v6690(VarCurr,8) ) ).

tff(addAssignment_21612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43285(VarCurr,B)
      <=> v43287(VarCurr,B) ) ) ).

tff(addAssignment_21611,axiom,
    ! [VarCurr: state_type] :
      ( ( v43287(VarCurr,11)
      <=> v6334(VarCurr,107) )
      & ( v43287(VarCurr,10)
      <=> v6334(VarCurr,106) )
      & ( v43287(VarCurr,9)
      <=> v6334(VarCurr,105) )
      & ( v43287(VarCurr,8)
      <=> v6334(VarCurr,104) )
      & ( v43287(VarCurr,7)
      <=> v6334(VarCurr,103) )
      & ( v43287(VarCurr,6)
      <=> v6334(VarCurr,102) )
      & ( v43287(VarCurr,5)
      <=> v6334(VarCurr,101) )
      & ( v43287(VarCurr,4)
      <=> v6334(VarCurr,100) )
      & ( v43287(VarCurr,3)
      <=> v6334(VarCurr,99) )
      & ( v43287(VarCurr,2)
      <=> v6334(VarCurr,98) )
      & ( v43287(VarCurr,1)
      <=> v6334(VarCurr,97) )
      & ( v43287(VarCurr,0)
      <=> v6334(VarCurr,96) ) ) ).

tff(addAssignment_21610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43253(VarCurr,B)
      <=> v43255(VarCurr,B) ) ) ).

tff(addAssignment_21609,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,0)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21608,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,1)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21607,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,2)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21606,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,3)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21605,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,4)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21604,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,5)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21603,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,6)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21602,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,7)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21601,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,8)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21600,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,9)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21599,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,10)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21598,axiom,
    ! [VarCurr: state_type] :
      ( v43255(VarCurr,11)
    <=> v43273(VarCurr) ) ).

tff(addAssignment_21597,axiom,
    ! [VarCurr: state_type] :
      ( v43273(VarCurr)
    <=> v43257(VarCurr) ) ).

tff(addAssignment_21596,axiom,
    ! [VarCurr: state_type] :
      ( v43257(VarCurr)
    <=> v43259(VarCurr,0) ) ).

tff(addAssignment_21595,axiom,
    ! [VarCurr: state_type] :
      ( v43259(VarCurr,0)
    <=> v43261(VarCurr,0) ) ).

tff(addAssignment_21594,axiom,
    ! [VarCurr: state_type] :
      ( v43261(VarCurr,0)
    <=> v43271(VarCurr,0) ) ).

tff(writeUnaryOperator_2519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v43271(VarCurr,B)
      <=> ~ v43263(VarCurr,B) ) ) ).

tff(addAssignment_21593,axiom,
    ! [VarCurr: state_type] :
      ( v43263(VarCurr,0)
    <=> v43265(VarCurr,0) ) ).

tff(addAssignment_21592,axiom,
    ! [VarCurr: state_type] :
      ( v43265(VarCurr,0)
    <=> v43268(VarCurr,0) ) ).

tff(addAssignment_21591,axiom,
    ! [VarCurr: state_type] :
      ( v43268(VarCurr,0)
    <=> v43267(VarCurr) ) ).

tff(addAssignment_21590,axiom,
    ! [VarCurr: state_type] :
      ( v43268(VarCurr,1)
    <=> v43270(VarCurr) ) ).

tff(addAssignment_21589,axiom,
    ! [VarCurr: state_type] :
      ( v43268(VarCurr,2)
    <=> v43269(VarCurr) ) ).

tff(addAssignment_21588,axiom,
    ! [VarCurr: state_type] :
      ( v43267(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_21587,axiom,
    ! [VarCurr: state_type] :
      ( v43229(VarCurr)
    <=> v43231(VarCurr) ) ).

tff(addAssignment_21586,axiom,
    ! [VarCurr: state_type] :
      ( v43231(VarCurr)
    <=> v43233(VarCurr) ) ).

tff(addAssignment_21585,axiom,
    ! [VarCurr: state_type] :
      ( v43233(VarCurr)
    <=> v43235(VarCurr) ) ).

tff(addAssignment_21584,axiom,
    ! [VarCurr: state_type] :
      ( v43235(VarCurr)
    <=> v43237(VarCurr) ) ).

tff(addAssignment_21583,axiom,
    ! [VarCurr: state_type] :
      ( v43237(VarCurr)
    <=> v43239(VarCurr) ) ).

tff(addAssignment_21582,axiom,
    ! [VarCurr: state_type] :
      ( v43239(VarCurr)
    <=> v43241(VarCurr) ) ).

tff(addAssignment_21581,axiom,
    ! [VarCurr: state_type] :
      ( v43241(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_21580,axiom,
    ! [VarCurr: state_type] :
      ( v43215(VarCurr)
    <=> v43217(VarCurr) ) ).

tff(addAssignment_21579,axiom,
    ! [VarCurr: state_type] :
      ( v43217(VarCurr)
    <=> v43219(VarCurr) ) ).

tff(addAssignment_21578,axiom,
    ! [VarCurr: state_type] :
      ( v43219(VarCurr)
    <=> v43221(VarCurr) ) ).

tff(addAssignment_21577,axiom,
    ! [VarCurr: state_type] :
      ( v43221(VarCurr)
    <=> v43223(VarCurr) ) ).

tff(addAssignment_21576,axiom,
    ! [VarCurr: state_type] :
      ( v43223(VarCurr)
    <=> v43225(VarCurr) ) ).

tff(addAssignment_21575,axiom,
    ! [VarCurr: state_type] :
      ( v43225(VarCurr)
    <=> v43227(VarCurr) ) ).

tff(addAssignment_21574,axiom,
    ! [VarCurr: state_type] :
      ( v43227(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_21573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43191(VarCurr,B)
      <=> v43193(VarCurr,B) ) ) ).

tff(addAssignment_21572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43193(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_21571,axiom,
    ! [VarCurr: state_type] :
      ( v41635(VarCurr)
    <=> v41637(VarCurr) ) ).

tff(addAssignment_21570,axiom,
    ! [VarCurr: state_type] :
      ( v41637(VarCurr)
    <=> v41639(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_210,axiom,
    ! [VarCurr: state_type] :
      ( v41639(VarCurr)
    <=> ( ( v41641(VarCurr,11)
        <=> v41645(VarCurr,11) )
        & ( v41641(VarCurr,10)
        <=> v41645(VarCurr,10) )
        & ( v41641(VarCurr,9)
        <=> v41645(VarCurr,9) )
        & ( v41641(VarCurr,8)
        <=> v41645(VarCurr,8) )
        & ( v41641(VarCurr,7)
        <=> v41645(VarCurr,7) )
        & ( v41641(VarCurr,6)
        <=> v41645(VarCurr,6) )
        & ( v41641(VarCurr,5)
        <=> v41645(VarCurr,5) )
        & ( v41641(VarCurr,4)
        <=> v41645(VarCurr,4) )
        & ( v41641(VarCurr,3)
        <=> v41645(VarCurr,3) )
        & ( v41641(VarCurr,2)
        <=> v41645(VarCurr,2) )
        & ( v41641(VarCurr,1)
        <=> v41645(VarCurr,1) )
        & ( v41641(VarCurr,0)
        <=> v41645(VarCurr,0) ) ) ) ).

tff(addAssignment_21569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41645(VarCurr,B)
      <=> v41647(VarCurr,B) ) ) ).

tff(addAssignment_21568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41647(VarCurr,B)
      <=> v41649(VarCurr,B) ) ) ).

tff(addAssignment_21567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41649(VarCurr,B)
      <=> v41651(VarCurr,B) ) ) ).

tff(addAssignment_21566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41651(VarCurr,B)
      <=> v41653(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41653(VarCurr,B)
      <=> ( v43161(VarCurr,B)
          | v43180(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43180(VarCurr,B)
      <=> ( v43032(VarCurr,B)
          & v43181(VarCurr,B) ) ) ) ).

tff(addAssignment_21565,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,0)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21564,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,1)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21563,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,2)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21562,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,3)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21561,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,4)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21560,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,5)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21559,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,6)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21558,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,7)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21557,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,8)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21556,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,9)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21555,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,10)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21554,axiom,
    ! [VarCurr: state_type] :
      ( v43181(VarCurr,11)
    <=> v43182(VarCurr) ) ).

tff(addAssignment_21553,axiom,
    ! [VarCurr: state_type] :
      ( v43182(VarCurr)
    <=> v43151(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43161(VarCurr,B)
      <=> ( v43162(VarCurr,B)
          | v43177(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43177(VarCurr,B)
      <=> ( v42881(VarCurr,B)
          & v43178(VarCurr,B) ) ) ) ).

tff(addAssignment_21552,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,0)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21551,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,1)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21550,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,2)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21549,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,3)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21548,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,4)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21547,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,5)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21546,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,6)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21545,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,7)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21544,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,8)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21543,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,9)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21542,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,10)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21541,axiom,
    ! [VarCurr: state_type] :
      ( v43178(VarCurr,11)
    <=> v43179(VarCurr) ) ).

tff(addAssignment_21540,axiom,
    ! [VarCurr: state_type] :
      ( v43179(VarCurr)
    <=> v43001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43162(VarCurr,B)
      <=> ( v43163(VarCurr,B)
          | v43174(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43174(VarCurr,B)
      <=> ( v42730(VarCurr,B)
          & v43175(VarCurr,B) ) ) ) ).

tff(addAssignment_21539,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,0)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21538,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,1)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21537,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,2)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21536,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,3)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21535,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,4)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21534,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,5)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21533,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,6)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21532,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,7)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21531,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,8)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21530,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,9)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21529,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,10)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21528,axiom,
    ! [VarCurr: state_type] :
      ( v43175(VarCurr,11)
    <=> v43176(VarCurr) ) ).

tff(addAssignment_21527,axiom,
    ! [VarCurr: state_type] :
      ( v43176(VarCurr)
    <=> v42850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43163(VarCurr,B)
      <=> ( v43164(VarCurr,B)
          | v43171(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43171(VarCurr,B)
      <=> ( v42579(VarCurr,B)
          & v43172(VarCurr,B) ) ) ) ).

tff(addAssignment_21526,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,0)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21525,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,1)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21524,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,2)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21523,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,3)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21522,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,4)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21521,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,5)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21520,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,6)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21519,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,7)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21518,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,8)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21517,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,9)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21516,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,10)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21515,axiom,
    ! [VarCurr: state_type] :
      ( v43172(VarCurr,11)
    <=> v43173(VarCurr) ) ).

tff(addAssignment_21514,axiom,
    ! [VarCurr: state_type] :
      ( v43173(VarCurr)
    <=> v42699(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43164(VarCurr,B)
      <=> ( v43165(VarCurr,B)
          | v43168(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43168(VarCurr,B)
      <=> ( v42417(VarCurr,B)
          & v43169(VarCurr,B) ) ) ) ).

tff(addAssignment_21513,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,0)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21512,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,1)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21511,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,2)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21510,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,3)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21509,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,4)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21508,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,5)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21507,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,6)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21506,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,7)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21505,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,8)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21504,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,9)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21503,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,10)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21502,axiom,
    ! [VarCurr: state_type] :
      ( v43169(VarCurr,11)
    <=> v43170(VarCurr) ) ).

tff(addAssignment_21501,axiom,
    ! [VarCurr: state_type] :
      ( v43170(VarCurr)
    <=> v42548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43165(VarCurr,B)
      <=> ( v41655(VarCurr,B)
          & v43166(VarCurr,B) ) ) ) ).

tff(addAssignment_21500,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,0)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21499,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,1)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21498,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,2)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21497,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,3)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21496,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,4)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21495,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,5)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21494,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,6)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21493,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,7)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21492,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,8)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21491,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,9)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21490,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,10)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21489,axiom,
    ! [VarCurr: state_type] :
      ( v43166(VarCurr,11)
    <=> v43167(VarCurr) ) ).

tff(addAssignment_21488,axiom,
    ! [VarCurr: state_type] :
      ( v43167(VarCurr)
    <=> v42125(VarCurr) ) ).

tff(addAssignment_21487,axiom,
    ! [VarCurr: state_type] :
      ( v43151(VarCurr)
    <=> v43153(VarCurr) ) ).

tff(addAssignment_21486,axiom,
    ! [VarCurr: state_type] :
      ( v43153(VarCurr)
    <=> v43155(VarCurr) ) ).

tff(addAssignment_21485,axiom,
    ! [VarCurr: state_type] :
      ( v43155(VarCurr)
    <=> v43157(VarCurr) ) ).

tff(addAssignment_21484,axiom,
    ! [VarCurr: state_type] :
      ( v43157(VarCurr)
    <=> v43159(VarCurr) ) ).

tff(addAssignment_21483,axiom,
    ! [VarCurr: state_type] :
      ( v43159(VarCurr)
    <=> v42218(VarCurr) ) ).

tff(addAssignment_21482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43032(VarCurr,B)
      <=> v43034(VarCurr,B) ) ) ).

tff(addAssignment_21481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43034(VarCurr,B)
      <=> v43036(VarCurr,B) ) ) ).

tff(addAssignment_21480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43036(VarCurr,B)
      <=> v43038(VarCurr,B) ) ) ).

tff(addAssignment_21479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43038(VarCurr,B)
      <=> v43040(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43134(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v43040(VarNext,B)
            <=> v43040(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_507,axiom,
    ! [VarNext: state_type] :
      ( v43134(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43040(VarNext,B)
          <=> v43144(VarNext,B) ) ) ) ).

tff(addAssignment_21478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43144(VarNext,B)
          <=> v43142(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43145(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43142(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_344,axiom,
    ! [VarCurr: state_type] :
      ( v43145(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v43142(VarCurr,B)
          <=> v43062(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4105,axiom,
    ! [VarCurr: state_type] :
      ( v43145(VarCurr)
    <=> ( v43146(VarCurr)
        & v43147(VarCurr) ) ) ).

tff(writeUnaryOperator_2518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43147(VarCurr)
    <=> v43052(VarCurr) ) ).

tff(writeUnaryOperator_2517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43146(VarCurr)
    <=> v43042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43134(VarNext)
      <=> v43135(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43135(VarNext)
      <=> ( v43136(VarNext)
          & v43066(VarNext) ) ) ) ).

tff(writeUnaryOperator_2516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43136(VarNext)
      <=> v43138(VarNext) ) ) ).

tff(addAssignment_21477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43138(VarNext)
      <=> v43066(VarCurr) ) ) ).

tff(addAssignment_21476,axiom,
    ! [VarCurr: state_type] :
      ( v43066(VarCurr)
    <=> v43068(VarCurr) ) ).

tff(addAssignment_21475,axiom,
    ! [VarCurr: state_type] :
      ( v43068(VarCurr)
    <=> v43070(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4102,axiom,
    ! [VarCurr: state_type] :
      ( v43070(VarCurr)
    <=> ( v43131(VarCurr)
        | v43127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4101,axiom,
    ! [VarCurr: state_type] :
      ( v43131(VarCurr)
    <=> ( v43072(VarCurr)
        & v43076(VarCurr) ) ) ).

tff(addAssignment_21474,axiom,
    ! [VarCurr: state_type] :
      ( v43127(VarCurr)
    <=> v43129(VarCurr) ) ).

tff(addAssignment_21473,axiom,
    ! [VarCurr: state_type] :
      ( v43129(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v43111(VarNext)
       => ( v43076(VarNext)
        <=> v43076(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_506,axiom,
    ! [VarNext: state_type] :
      ( v43111(VarNext)
     => ( v43076(VarNext)
      <=> v43121(VarNext) ) ) ).

tff(addAssignment_21472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43121(VarNext)
      <=> v43119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4100,axiom,
    ! [VarCurr: state_type] :
      ( v43119(VarCurr)
    <=> ( v43122(VarCurr)
        & v43123(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4099,axiom,
    ! [VarCurr: state_type] :
      ( v43123(VarCurr)
    <=> ( v43082(VarCurr)
        | v43106(VarCurr) ) ) ).

tff(writeUnaryOperator_2515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43122(VarCurr)
    <=> v43078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4098,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43111(VarNext)
      <=> v43112(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43112(VarNext)
      <=> ( v43114(VarNext)
          & v43116(VarNext) ) ) ) ).

tff(writeUnaryOperator_2514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43116(VarCurr)
    <=> v43072(VarCurr) ) ).

tff(addAssignment_21471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v43114(VarNext)
      <=> v43072(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_181,axiom,
    ( v43076(constB0)
  <=> $true ) ).

tff(addAssignment_21470,axiom,
    ! [VarCurr: state_type] :
      ( v43106(VarCurr)
    <=> v43108(VarCurr) ) ).

tff(addAssignment_21469,axiom,
    ! [VarCurr: state_type] :
      ( v43108(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21468,axiom,
    ! [VarCurr: state_type] :
      ( v43082(VarCurr)
    <=> v43084(VarCurr) ) ).

tff(addAssignment_21467,axiom,
    ! [VarCurr: state_type] :
      ( v43084(VarCurr)
    <=> v42392(VarCurr) ) ).

tff(addAssignment_21466,axiom,
    ! [VarCurr: state_type] :
      ( v42392(VarCurr)
    <=> v43087(VarCurr) ) ).

tff(addAssignment_21465,axiom,
    ! [VarCurr: state_type] :
      ( v43087(VarCurr)
    <=> v43089(VarCurr) ) ).

tff(writeUnaryOperator_2513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43089(VarCurr)
    <=> v43103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4096,axiom,
    ! [VarCurr: state_type] :
      ( v43103(VarCurr)
    <=> ( v43104(VarCurr)
        | v43099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4095,axiom,
    ! [VarCurr: state_type] :
      ( v43104(VarCurr)
    <=> ( v43091(VarCurr)
        | v43095(VarCurr) ) ) ).

tff(addAssignment_21464,axiom,
    ! [VarCurr: state_type] :
      ( v43099(VarCurr)
    <=> v43101(VarCurr) ) ).

tff(addAssignment_21463,axiom,
    ! [VarCurr: state_type] :
      ( v43101(VarCurr)
    <=> v42481(VarCurr,2) ) ).

tff(addAssignment_21462,axiom,
    ! [VarCurr: state_type] :
      ( v43095(VarCurr)
    <=> v43097(VarCurr) ) ).

tff(addAssignment_21461,axiom,
    ! [VarCurr: state_type] :
      ( v43097(VarCurr)
    <=> v42055(VarCurr,1) ) ).

tff(addAssignment_21460,axiom,
    ! [VarCurr: state_type] :
      ( v43091(VarCurr)
    <=> v43093(VarCurr) ) ).

tff(addAssignment_21459,axiom,
    ! [VarCurr: state_type] :
      ( v43093(VarCurr)
    <=> v42481(VarCurr,0) ) ).

tff(addAssignment_21458,axiom,
    ! [VarCurr: state_type] :
      ( v43078(VarCurr)
    <=> v43080(VarCurr) ) ).

tff(addAssignment_21457,axiom,
    ! [VarCurr: state_type] :
      ( v43080(VarCurr)
    <=> $false ) ).

tff(addAssignment_21456,axiom,
    ! [VarCurr: state_type] :
      ( v43072(VarCurr)
    <=> v43074(VarCurr) ) ).

tff(addAssignment_21455,axiom,
    ! [VarCurr: state_type] :
      ( v43074(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43062(VarCurr,B)
      <=> v43064(VarCurr,B) ) ) ).

tff(addAssignment_21453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v43064(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21452,axiom,
    ! [VarCurr: state_type] :
      ( v43052(VarCurr)
    <=> v43054(VarCurr) ) ).

tff(addAssignment_21451,axiom,
    ! [VarCurr: state_type] :
      ( v43054(VarCurr)
    <=> v43056(VarCurr) ) ).

tff(addAssignment_21450,axiom,
    ! [VarCurr: state_type] :
      ( v43056(VarCurr)
    <=> v43058(VarCurr) ) ).

tff(addAssignment_21449,axiom,
    ! [VarCurr: state_type] :
      ( v43058(VarCurr)
    <=> v43060(VarCurr) ) ).

tff(addAssignment_21448,axiom,
    ! [VarCurr: state_type] :
      ( v43060(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21447,axiom,
    ! [VarCurr: state_type] :
      ( v43042(VarCurr)
    <=> v43044(VarCurr) ) ).

tff(addAssignment_21446,axiom,
    ! [VarCurr: state_type] :
      ( v43044(VarCurr)
    <=> v43046(VarCurr) ) ).

tff(addAssignment_21445,axiom,
    ! [VarCurr: state_type] :
      ( v43046(VarCurr)
    <=> v43048(VarCurr) ) ).

tff(addAssignment_21444,axiom,
    ! [VarCurr: state_type] :
      ( v43048(VarCurr)
    <=> v43050(VarCurr) ) ).

tff(addAssignment_21443,axiom,
    ! [VarCurr: state_type] :
      ( v43050(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_21442,axiom,
    ! [VarCurr: state_type] :
      ( v43001(VarCurr)
    <=> v43003(VarCurr) ) ).

tff(addAssignment_21441,axiom,
    ! [VarCurr: state_type] :
      ( v43003(VarCurr)
    <=> v43005(VarCurr) ) ).

tff(addAssignment_21440,axiom,
    ! [VarCurr: state_type] :
      ( v43005(VarCurr)
    <=> v43007(VarCurr) ) ).

tff(addAssignment_21439,axiom,
    ! [VarCurr: state_type] :
      ( v43007(VarCurr)
    <=> v43009(VarCurr) ) ).

tff(addAssignment_21438,axiom,
    ! [VarCurr: state_type] :
      ( v43009(VarCurr)
    <=> v43011(VarCurr) ) ).

tff(addAssignment_21437,axiom,
    ! [VarCurr: state_type] :
      ( v43011(VarCurr)
    <=> v43013(VarCurr) ) ).

tff(addAssignment_21436,axiom,
    ! [VarCurr: state_type] :
      ( v43013(VarCurr)
    <=> v43015(VarCurr) ) ).

tff(writeUnaryOperator_2512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v43015(VarCurr)
    <=> v43029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4094,axiom,
    ! [VarCurr: state_type] :
      ( v43029(VarCurr)
    <=> ( v43030(VarCurr)
        | v43025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4093,axiom,
    ! [VarCurr: state_type] :
      ( v43030(VarCurr)
    <=> ( v43017(VarCurr)
        | v43021(VarCurr) ) ) ).

tff(addAssignment_21435,axiom,
    ! [VarCurr: state_type] :
      ( v43025(VarCurr)
    <=> v43027(VarCurr) ) ).

tff(addAssignment_21434,axiom,
    ! [VarCurr: state_type] :
      ( v43027(VarCurr)
    <=> v42228(VarCurr,2) ) ).

tff(addAssignment_21433,axiom,
    ! [VarCurr: state_type] :
      ( v43021(VarCurr)
    <=> v43023(VarCurr) ) ).

tff(addAssignment_21432,axiom,
    ! [VarCurr: state_type] :
      ( v43023(VarCurr)
    <=> v42145(VarCurr,1) ) ).

tff(addAssignment_21431,axiom,
    ! [VarCurr: state_type] :
      ( v43017(VarCurr)
    <=> v43019(VarCurr) ) ).

tff(addAssignment_21430,axiom,
    ! [VarCurr: state_type] :
      ( v43019(VarCurr)
    <=> v42145(VarCurr,0) ) ).

tff(addAssignment_21429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42881(VarCurr,B)
      <=> v42883(VarCurr,B) ) ) ).

tff(addAssignment_21428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42883(VarCurr,B)
      <=> v42885(VarCurr,B) ) ) ).

tff(addAssignment_21427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42885(VarCurr,B)
      <=> v42887(VarCurr,B) ) ) ).

tff(addAssignment_21426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42887(VarCurr,B)
      <=> v42889(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42984(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v42889(VarNext,B)
            <=> v42889(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_505,axiom,
    ! [VarNext: state_type] :
      ( v42984(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42889(VarNext,B)
          <=> v42994(VarNext,B) ) ) ) ).

tff(addAssignment_21425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42994(VarNext,B)
          <=> v42992(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42992(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_343,axiom,
    ! [VarCurr: state_type] :
      ( v42995(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42992(VarCurr,B)
          <=> v42911(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4092,axiom,
    ! [VarCurr: state_type] :
      ( v42995(VarCurr)
    <=> ( v42996(VarCurr)
        & v42997(VarCurr) ) ) ).

tff(writeUnaryOperator_2511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42997(VarCurr)
    <=> v42901(VarCurr) ) ).

tff(writeUnaryOperator_2510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42996(VarCurr)
    <=> v42891(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42984(VarNext)
      <=> v42985(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42985(VarNext)
      <=> ( v42986(VarNext)
          & v42915(VarNext) ) ) ) ).

tff(writeUnaryOperator_2509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42986(VarNext)
      <=> v42988(VarNext) ) ) ).

tff(addAssignment_21424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42988(VarNext)
      <=> v42915(VarCurr) ) ) ).

tff(addAssignment_21423,axiom,
    ! [VarCurr: state_type] :
      ( v42915(VarCurr)
    <=> v42917(VarCurr) ) ).

tff(addAssignment_21422,axiom,
    ! [VarCurr: state_type] :
      ( v42917(VarCurr)
    <=> v42919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4089,axiom,
    ! [VarCurr: state_type] :
      ( v42919(VarCurr)
    <=> ( v42981(VarCurr)
        | v42977(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4088,axiom,
    ! [VarCurr: state_type] :
      ( v42981(VarCurr)
    <=> ( v42921(VarCurr)
        & v42925(VarCurr) ) ) ).

tff(addAssignment_21421,axiom,
    ! [VarCurr: state_type] :
      ( v42977(VarCurr)
    <=> v42979(VarCurr) ) ).

tff(addAssignment_21420,axiom,
    ! [VarCurr: state_type] :
      ( v42979(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42961(VarNext)
       => ( v42925(VarNext)
        <=> v42925(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_504,axiom,
    ! [VarNext: state_type] :
      ( v42961(VarNext)
     => ( v42925(VarNext)
      <=> v42971(VarNext) ) ) ).

tff(addAssignment_21419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42971(VarNext)
      <=> v42969(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4087,axiom,
    ! [VarCurr: state_type] :
      ( v42969(VarCurr)
    <=> ( v42972(VarCurr)
        & v42973(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4086,axiom,
    ! [VarCurr: state_type] :
      ( v42973(VarCurr)
    <=> ( v42931(VarCurr)
        | v42956(VarCurr) ) ) ).

tff(writeUnaryOperator_2508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42972(VarCurr)
    <=> v42927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42961(VarNext)
      <=> v42962(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42962(VarNext)
      <=> ( v42964(VarNext)
          & v42966(VarNext) ) ) ) ).

tff(writeUnaryOperator_2507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42966(VarCurr)
    <=> v42921(VarCurr) ) ).

tff(addAssignment_21418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42964(VarNext)
      <=> v42921(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_180,axiom,
    ( v42925(constB0)
  <=> $true ) ).

tff(addAssignment_21417,axiom,
    ! [VarCurr: state_type] :
      ( v42956(VarCurr)
    <=> v42958(VarCurr) ) ).

tff(addAssignment_21416,axiom,
    ! [VarCurr: state_type] :
      ( v42958(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21415,axiom,
    ! [VarCurr: state_type] :
      ( v42931(VarCurr)
    <=> v42933(VarCurr) ) ).

tff(addAssignment_21414,axiom,
    ! [VarCurr: state_type] :
      ( v42933(VarCurr)
    <=> v42935(VarCurr) ) ).

tff(addAssignment_21413,axiom,
    ! [VarCurr: state_type] :
      ( v42935(VarCurr)
    <=> v42937(VarCurr) ) ).

tff(addAssignment_21412,axiom,
    ! [VarCurr: state_type] :
      ( v42937(VarCurr)
    <=> v42939(VarCurr) ) ).

tff(writeUnaryOperator_2506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42939(VarCurr)
    <=> v42953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4083,axiom,
    ! [VarCurr: state_type] :
      ( v42953(VarCurr)
    <=> ( v42954(VarCurr)
        | v42949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4082,axiom,
    ! [VarCurr: state_type] :
      ( v42954(VarCurr)
    <=> ( v42941(VarCurr)
        | v42945(VarCurr) ) ) ).

tff(addAssignment_21411,axiom,
    ! [VarCurr: state_type] :
      ( v42949(VarCurr)
    <=> v42951(VarCurr) ) ).

tff(addAssignment_21410,axiom,
    ! [VarCurr: state_type] :
      ( v42951(VarCurr)
    <=> v42481(VarCurr,2) ) ).

tff(addAssignment_21409,axiom,
    ! [VarCurr: state_type] :
      ( v42481(VarCurr,2)
    <=> v42483(VarCurr,2) ) ).

tff(addAssignment_21408,axiom,
    ! [VarCurr: state_type] :
      ( v42483(VarCurr,2)
    <=> v42485(VarCurr,2) ) ).

tff(addAssignment_21407,axiom,
    ! [VarCurr: state_type] :
      ( v42485(VarCurr,2)
    <=> v42490(VarCurr,2) ) ).

tff(addAssignment_21406,axiom,
    ! [VarCurr: state_type] :
      ( v42487(VarCurr,2)
    <=> v42489(VarCurr,2) ) ).

tff(addAssignment_21405,axiom,
    ! [VarCurr: state_type] :
      ( v42489(VarCurr,2)
    <=> v42055(VarCurr,2) ) ).

tff(addAssignment_21404,axiom,
    ! [VarCurr: state_type] :
      ( v42945(VarCurr)
    <=> v42947(VarCurr) ) ).

tff(addAssignment_21403,axiom,
    ! [VarCurr: state_type] :
      ( v42947(VarCurr)
    <=> v42055(VarCurr,1) ) ).

tff(addAssignment_21402,axiom,
    ! [VarCurr: state_type] :
      ( v42941(VarCurr)
    <=> v42943(VarCurr) ) ).

tff(addAssignment_21401,axiom,
    ! [VarCurr: state_type] :
      ( v42943(VarCurr)
    <=> v42055(VarCurr,0) ) ).

tff(addAssignment_21400,axiom,
    ! [VarCurr: state_type] :
      ( v42927(VarCurr)
    <=> v42929(VarCurr) ) ).

tff(addAssignment_21399,axiom,
    ! [VarCurr: state_type] :
      ( v42929(VarCurr)
    <=> $false ) ).

tff(addAssignment_21398,axiom,
    ! [VarCurr: state_type] :
      ( v42921(VarCurr)
    <=> v42923(VarCurr) ) ).

tff(addAssignment_21397,axiom,
    ! [VarCurr: state_type] :
      ( v42923(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42911(VarCurr,B)
      <=> v42913(VarCurr,B) ) ) ).

tff(addAssignment_21395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42913(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21394,axiom,
    ! [VarCurr: state_type] :
      ( v42901(VarCurr)
    <=> v42903(VarCurr) ) ).

tff(addAssignment_21393,axiom,
    ! [VarCurr: state_type] :
      ( v42903(VarCurr)
    <=> v42905(VarCurr) ) ).

tff(addAssignment_21392,axiom,
    ! [VarCurr: state_type] :
      ( v42905(VarCurr)
    <=> v42907(VarCurr) ) ).

tff(addAssignment_21391,axiom,
    ! [VarCurr: state_type] :
      ( v42907(VarCurr)
    <=> v42909(VarCurr) ) ).

tff(addAssignment_21390,axiom,
    ! [VarCurr: state_type] :
      ( v42909(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21389,axiom,
    ! [VarCurr: state_type] :
      ( v42891(VarCurr)
    <=> v42893(VarCurr) ) ).

tff(addAssignment_21388,axiom,
    ! [VarCurr: state_type] :
      ( v42893(VarCurr)
    <=> v42895(VarCurr) ) ).

tff(addAssignment_21387,axiom,
    ! [VarCurr: state_type] :
      ( v42895(VarCurr)
    <=> v42897(VarCurr) ) ).

tff(addAssignment_21386,axiom,
    ! [VarCurr: state_type] :
      ( v42897(VarCurr)
    <=> v42899(VarCurr) ) ).

tff(addAssignment_21385,axiom,
    ! [VarCurr: state_type] :
      ( v42899(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_21384,axiom,
    ! [VarCurr: state_type] :
      ( v42850(VarCurr)
    <=> v42852(VarCurr) ) ).

tff(addAssignment_21383,axiom,
    ! [VarCurr: state_type] :
      ( v42852(VarCurr)
    <=> v42854(VarCurr) ) ).

tff(addAssignment_21382,axiom,
    ! [VarCurr: state_type] :
      ( v42854(VarCurr)
    <=> v42856(VarCurr) ) ).

tff(addAssignment_21381,axiom,
    ! [VarCurr: state_type] :
      ( v42856(VarCurr)
    <=> v42858(VarCurr) ) ).

tff(addAssignment_21380,axiom,
    ! [VarCurr: state_type] :
      ( v42858(VarCurr)
    <=> v42860(VarCurr) ) ).

tff(addAssignment_21379,axiom,
    ! [VarCurr: state_type] :
      ( v42860(VarCurr)
    <=> v42862(VarCurr) ) ).

tff(addAssignment_21378,axiom,
    ! [VarCurr: state_type] :
      ( v42862(VarCurr)
    <=> v42864(VarCurr) ) ).

tff(writeUnaryOperator_2505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42864(VarCurr)
    <=> v42878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4081,axiom,
    ! [VarCurr: state_type] :
      ( v42878(VarCurr)
    <=> ( v42879(VarCurr)
        | v42874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4080,axiom,
    ! [VarCurr: state_type] :
      ( v42879(VarCurr)
    <=> ( v42866(VarCurr)
        | v42870(VarCurr) ) ) ).

tff(addAssignment_21377,axiom,
    ! [VarCurr: state_type] :
      ( v42874(VarCurr)
    <=> v42876(VarCurr) ) ).

tff(addAssignment_21376,axiom,
    ! [VarCurr: state_type] :
      ( v42876(VarCurr)
    <=> v42145(VarCurr,2) ) ).

tff(addAssignment_21375,axiom,
    ! [VarCurr: state_type] :
      ( v42870(VarCurr)
    <=> v42872(VarCurr) ) ).

tff(addAssignment_21374,axiom,
    ! [VarCurr: state_type] :
      ( v42872(VarCurr)
    <=> v42228(VarCurr,1) ) ).

tff(addAssignment_21373,axiom,
    ! [VarCurr: state_type] :
      ( v42866(VarCurr)
    <=> v42868(VarCurr) ) ).

tff(addAssignment_21372,axiom,
    ! [VarCurr: state_type] :
      ( v42868(VarCurr)
    <=> v42228(VarCurr,0) ) ).

tff(addAssignment_21371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42730(VarCurr,B)
      <=> v42732(VarCurr,B) ) ) ).

tff(addAssignment_21370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42732(VarCurr,B)
      <=> v42734(VarCurr,B) ) ) ).

tff(addAssignment_21369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42734(VarCurr,B)
      <=> v42736(VarCurr,B) ) ) ).

tff(addAssignment_21368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42736(VarCurr,B)
      <=> v42738(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_503,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42833(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v42738(VarNext,B)
            <=> v42738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_503,axiom,
    ! [VarNext: state_type] :
      ( v42833(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42738(VarNext,B)
          <=> v42843(VarNext,B) ) ) ) ).

tff(addAssignment_21367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42843(VarNext,B)
          <=> v42841(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42844(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42841(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_342,axiom,
    ! [VarCurr: state_type] :
      ( v42844(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42841(VarCurr,B)
          <=> v42760(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4079,axiom,
    ! [VarCurr: state_type] :
      ( v42844(VarCurr)
    <=> ( v42845(VarCurr)
        & v42846(VarCurr) ) ) ).

tff(writeUnaryOperator_2504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42846(VarCurr)
    <=> v42750(VarCurr) ) ).

tff(writeUnaryOperator_2503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42845(VarCurr)
    <=> v42740(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42833(VarNext)
      <=> v42834(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42834(VarNext)
      <=> ( v42835(VarNext)
          & v42764(VarNext) ) ) ) ).

tff(writeUnaryOperator_2502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42835(VarNext)
      <=> v42837(VarNext) ) ) ).

tff(addAssignment_21366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42837(VarNext)
      <=> v42764(VarCurr) ) ) ).

tff(addAssignment_21365,axiom,
    ! [VarCurr: state_type] :
      ( v42764(VarCurr)
    <=> v42766(VarCurr) ) ).

tff(addAssignment_21364,axiom,
    ! [VarCurr: state_type] :
      ( v42766(VarCurr)
    <=> v42768(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4076,axiom,
    ! [VarCurr: state_type] :
      ( v42768(VarCurr)
    <=> ( v42830(VarCurr)
        | v42826(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4075,axiom,
    ! [VarCurr: state_type] :
      ( v42830(VarCurr)
    <=> ( v42770(VarCurr)
        & v42774(VarCurr) ) ) ).

tff(addAssignment_21363,axiom,
    ! [VarCurr: state_type] :
      ( v42826(VarCurr)
    <=> v42828(VarCurr) ) ).

tff(addAssignment_21362,axiom,
    ! [VarCurr: state_type] :
      ( v42828(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42810(VarNext)
       => ( v42774(VarNext)
        <=> v42774(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_502,axiom,
    ! [VarNext: state_type] :
      ( v42810(VarNext)
     => ( v42774(VarNext)
      <=> v42820(VarNext) ) ) ).

tff(addAssignment_21361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42820(VarNext)
      <=> v42818(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4074,axiom,
    ! [VarCurr: state_type] :
      ( v42818(VarCurr)
    <=> ( v42821(VarCurr)
        & v42822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4073,axiom,
    ! [VarCurr: state_type] :
      ( v42822(VarCurr)
    <=> ( v42780(VarCurr)
        | v42805(VarCurr) ) ) ).

tff(writeUnaryOperator_2501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42821(VarCurr)
    <=> v42776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42810(VarNext)
      <=> v42811(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42811(VarNext)
      <=> ( v42813(VarNext)
          & v42815(VarNext) ) ) ) ).

tff(writeUnaryOperator_2500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42815(VarCurr)
    <=> v42770(VarCurr) ) ).

tff(addAssignment_21360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42813(VarNext)
      <=> v42770(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_179,axiom,
    ( v42774(constB0)
  <=> $true ) ).

tff(addAssignment_21359,axiom,
    ! [VarCurr: state_type] :
      ( v42805(VarCurr)
    <=> v42807(VarCurr) ) ).

tff(addAssignment_21358,axiom,
    ! [VarCurr: state_type] :
      ( v42807(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21357,axiom,
    ! [VarCurr: state_type] :
      ( v42780(VarCurr)
    <=> v42782(VarCurr) ) ).

tff(addAssignment_21356,axiom,
    ! [VarCurr: state_type] :
      ( v42782(VarCurr)
    <=> v42784(VarCurr) ) ).

tff(addAssignment_21355,axiom,
    ! [VarCurr: state_type] :
      ( v42784(VarCurr)
    <=> v42786(VarCurr) ) ).

tff(addAssignment_21354,axiom,
    ! [VarCurr: state_type] :
      ( v42786(VarCurr)
    <=> v42788(VarCurr) ) ).

tff(writeUnaryOperator_2499,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42788(VarCurr)
    <=> v42802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4070,axiom,
    ! [VarCurr: state_type] :
      ( v42802(VarCurr)
    <=> ( v42803(VarCurr)
        | v42798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4069,axiom,
    ! [VarCurr: state_type] :
      ( v42803(VarCurr)
    <=> ( v42790(VarCurr)
        | v42794(VarCurr) ) ) ).

tff(addAssignment_21353,axiom,
    ! [VarCurr: state_type] :
      ( v42798(VarCurr)
    <=> v42800(VarCurr) ) ).

tff(addAssignment_21352,axiom,
    ! [VarCurr: state_type] :
      ( v42800(VarCurr)
    <=> v42055(VarCurr,2) ) ).

tff(addAssignment_21351,axiom,
    ! [VarCurr: state_type] :
      ( v42794(VarCurr)
    <=> v42796(VarCurr) ) ).

tff(addAssignment_21350,axiom,
    ! [VarCurr: state_type] :
      ( v42796(VarCurr)
    <=> v42481(VarCurr,1) ) ).

tff(addAssignment_21349,axiom,
    ! [VarCurr: state_type] :
      ( v42790(VarCurr)
    <=> v42792(VarCurr) ) ).

tff(addAssignment_21348,axiom,
    ! [VarCurr: state_type] :
      ( v42792(VarCurr)
    <=> v42481(VarCurr,0) ) ).

tff(addAssignment_21347,axiom,
    ! [VarCurr: state_type] :
      ( v42776(VarCurr)
    <=> v42778(VarCurr) ) ).

tff(addAssignment_21346,axiom,
    ! [VarCurr: state_type] :
      ( v42778(VarCurr)
    <=> $false ) ).

tff(addAssignment_21345,axiom,
    ! [VarCurr: state_type] :
      ( v42770(VarCurr)
    <=> v42772(VarCurr) ) ).

tff(addAssignment_21344,axiom,
    ! [VarCurr: state_type] :
      ( v42772(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42760(VarCurr,B)
      <=> v42762(VarCurr,B) ) ) ).

tff(addAssignment_21342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42762(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21341,axiom,
    ! [VarCurr: state_type] :
      ( v42750(VarCurr)
    <=> v42752(VarCurr) ) ).

tff(addAssignment_21340,axiom,
    ! [VarCurr: state_type] :
      ( v42752(VarCurr)
    <=> v42754(VarCurr) ) ).

tff(addAssignment_21339,axiom,
    ! [VarCurr: state_type] :
      ( v42754(VarCurr)
    <=> v42756(VarCurr) ) ).

tff(addAssignment_21338,axiom,
    ! [VarCurr: state_type] :
      ( v42756(VarCurr)
    <=> v42758(VarCurr) ) ).

tff(addAssignment_21337,axiom,
    ! [VarCurr: state_type] :
      ( v42758(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21336,axiom,
    ! [VarCurr: state_type] :
      ( v42740(VarCurr)
    <=> v42742(VarCurr) ) ).

tff(addAssignment_21335,axiom,
    ! [VarCurr: state_type] :
      ( v42742(VarCurr)
    <=> v42744(VarCurr) ) ).

tff(addAssignment_21334,axiom,
    ! [VarCurr: state_type] :
      ( v42744(VarCurr)
    <=> v42746(VarCurr) ) ).

tff(addAssignment_21333,axiom,
    ! [VarCurr: state_type] :
      ( v42746(VarCurr)
    <=> v42748(VarCurr) ) ).

tff(addAssignment_21332,axiom,
    ! [VarCurr: state_type] :
      ( v42748(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_21331,axiom,
    ! [VarCurr: state_type] :
      ( v42699(VarCurr)
    <=> v42701(VarCurr) ) ).

tff(addAssignment_21330,axiom,
    ! [VarCurr: state_type] :
      ( v42701(VarCurr)
    <=> v42703(VarCurr) ) ).

tff(addAssignment_21329,axiom,
    ! [VarCurr: state_type] :
      ( v42703(VarCurr)
    <=> v42705(VarCurr) ) ).

tff(addAssignment_21328,axiom,
    ! [VarCurr: state_type] :
      ( v42705(VarCurr)
    <=> v42707(VarCurr) ) ).

tff(addAssignment_21327,axiom,
    ! [VarCurr: state_type] :
      ( v42707(VarCurr)
    <=> v42709(VarCurr) ) ).

tff(addAssignment_21326,axiom,
    ! [VarCurr: state_type] :
      ( v42709(VarCurr)
    <=> v42711(VarCurr) ) ).

tff(addAssignment_21325,axiom,
    ! [VarCurr: state_type] :
      ( v42711(VarCurr)
    <=> v42713(VarCurr) ) ).

tff(writeUnaryOperator_2498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42713(VarCurr)
    <=> v42727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4068,axiom,
    ! [VarCurr: state_type] :
      ( v42727(VarCurr)
    <=> ( v42728(VarCurr)
        | v42723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4067,axiom,
    ! [VarCurr: state_type] :
      ( v42728(VarCurr)
    <=> ( v42715(VarCurr)
        | v42719(VarCurr) ) ) ).

tff(addAssignment_21324,axiom,
    ! [VarCurr: state_type] :
      ( v42723(VarCurr)
    <=> v42725(VarCurr) ) ).

tff(addAssignment_21323,axiom,
    ! [VarCurr: state_type] :
      ( v42725(VarCurr)
    <=> v42145(VarCurr,2) ) ).

tff(addAssignment_21322,axiom,
    ! [VarCurr: state_type] :
      ( v42719(VarCurr)
    <=> v42721(VarCurr) ) ).

tff(addAssignment_21321,axiom,
    ! [VarCurr: state_type] :
      ( v42721(VarCurr)
    <=> v42228(VarCurr,1) ) ).

tff(addAssignment_21320,axiom,
    ! [VarCurr: state_type] :
      ( v42228(VarCurr,1)
    <=> v42230(VarCurr,1) ) ).

tff(addAssignment_21319,axiom,
    ! [VarCurr: state_type] :
      ( v42230(VarCurr,1)
    <=> v42232(VarCurr,1) ) ).

tff(addAssignment_21318,axiom,
    ! [VarCurr: state_type] :
      ( v42232(VarCurr,1)
    <=> v42237(VarCurr,1) ) ).

tff(addAssignment_21317,axiom,
    ! [VarCurr: state_type] :
      ( v42234(VarCurr,1)
    <=> v42236(VarCurr,1) ) ).

tff(addAssignment_21316,axiom,
    ! [VarCurr: state_type] :
      ( v42236(VarCurr,1)
    <=> v42145(VarCurr,1) ) ).

tff(addAssignment_21315,axiom,
    ! [VarCurr: state_type] :
      ( v42715(VarCurr)
    <=> v42717(VarCurr) ) ).

tff(addAssignment_21314,axiom,
    ! [VarCurr: state_type] :
      ( v42717(VarCurr)
    <=> v42145(VarCurr,0) ) ).

tff(addAssignment_21313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42579(VarCurr,B)
      <=> v42581(VarCurr,B) ) ) ).

tff(addAssignment_21312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42581(VarCurr,B)
      <=> v42583(VarCurr,B) ) ) ).

tff(addAssignment_21311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42583(VarCurr,B)
      <=> v42585(VarCurr,B) ) ) ).

tff(addAssignment_21310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42585(VarCurr,B)
      <=> v42587(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42682(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v42587(VarNext,B)
            <=> v42587(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_501,axiom,
    ! [VarNext: state_type] :
      ( v42682(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42587(VarNext,B)
          <=> v42692(VarNext,B) ) ) ) ).

tff(addAssignment_21309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42692(VarNext,B)
          <=> v42690(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42693(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42690(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_341,axiom,
    ! [VarCurr: state_type] :
      ( v42693(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42690(VarCurr,B)
          <=> v42609(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4066,axiom,
    ! [VarCurr: state_type] :
      ( v42693(VarCurr)
    <=> ( v42694(VarCurr)
        & v42695(VarCurr) ) ) ).

tff(writeUnaryOperator_2497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42695(VarCurr)
    <=> v42599(VarCurr) ) ).

tff(writeUnaryOperator_2496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42694(VarCurr)
    <=> v42589(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42682(VarNext)
      <=> v42683(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42683(VarNext)
      <=> ( v42684(VarNext)
          & v42613(VarNext) ) ) ) ).

tff(writeUnaryOperator_2495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42684(VarNext)
      <=> v42686(VarNext) ) ) ).

tff(addAssignment_21308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42686(VarNext)
      <=> v42613(VarCurr) ) ) ).

tff(addAssignment_21307,axiom,
    ! [VarCurr: state_type] :
      ( v42613(VarCurr)
    <=> v42615(VarCurr) ) ).

tff(addAssignment_21306,axiom,
    ! [VarCurr: state_type] :
      ( v42615(VarCurr)
    <=> v42617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4063,axiom,
    ! [VarCurr: state_type] :
      ( v42617(VarCurr)
    <=> ( v42679(VarCurr)
        | v42675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4062,axiom,
    ! [VarCurr: state_type] :
      ( v42679(VarCurr)
    <=> ( v42619(VarCurr)
        & v42623(VarCurr) ) ) ).

tff(addAssignment_21305,axiom,
    ! [VarCurr: state_type] :
      ( v42675(VarCurr)
    <=> v42677(VarCurr) ) ).

tff(addAssignment_21304,axiom,
    ! [VarCurr: state_type] :
      ( v42677(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42659(VarNext)
       => ( v42623(VarNext)
        <=> v42623(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_500,axiom,
    ! [VarNext: state_type] :
      ( v42659(VarNext)
     => ( v42623(VarNext)
      <=> v42669(VarNext) ) ) ).

tff(addAssignment_21303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42669(VarNext)
      <=> v42667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4061,axiom,
    ! [VarCurr: state_type] :
      ( v42667(VarCurr)
    <=> ( v42670(VarCurr)
        & v42671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4060,axiom,
    ! [VarCurr: state_type] :
      ( v42671(VarCurr)
    <=> ( v42629(VarCurr)
        | v42654(VarCurr) ) ) ).

tff(writeUnaryOperator_2494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42670(VarCurr)
    <=> v42625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42659(VarNext)
      <=> v42660(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42660(VarNext)
      <=> ( v42662(VarNext)
          & v42664(VarNext) ) ) ) ).

tff(writeUnaryOperator_2493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42664(VarCurr)
    <=> v42619(VarCurr) ) ).

tff(addAssignment_21302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42662(VarNext)
      <=> v42619(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_178,axiom,
    ( v42623(constB0)
  <=> $true ) ).

tff(addAssignment_21301,axiom,
    ! [VarCurr: state_type] :
      ( v42654(VarCurr)
    <=> v42656(VarCurr) ) ).

tff(addAssignment_21300,axiom,
    ! [VarCurr: state_type] :
      ( v42656(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21299,axiom,
    ! [VarCurr: state_type] :
      ( v42629(VarCurr)
    <=> v42631(VarCurr) ) ).

tff(addAssignment_21298,axiom,
    ! [VarCurr: state_type] :
      ( v42631(VarCurr)
    <=> v42633(VarCurr) ) ).

tff(addAssignment_21297,axiom,
    ! [VarCurr: state_type] :
      ( v42633(VarCurr)
    <=> v42635(VarCurr) ) ).

tff(addAssignment_21296,axiom,
    ! [VarCurr: state_type] :
      ( v42635(VarCurr)
    <=> v42637(VarCurr) ) ).

tff(writeUnaryOperator_2492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42637(VarCurr)
    <=> v42651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4057,axiom,
    ! [VarCurr: state_type] :
      ( v42651(VarCurr)
    <=> ( v42652(VarCurr)
        | v42647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4056,axiom,
    ! [VarCurr: state_type] :
      ( v42652(VarCurr)
    <=> ( v42639(VarCurr)
        | v42643(VarCurr) ) ) ).

tff(addAssignment_21295,axiom,
    ! [VarCurr: state_type] :
      ( v42647(VarCurr)
    <=> v42649(VarCurr) ) ).

tff(addAssignment_21294,axiom,
    ! [VarCurr: state_type] :
      ( v42649(VarCurr)
    <=> v42055(VarCurr,2) ) ).

tff(addAssignment_21293,axiom,
    ! [VarCurr: state_type] :
      ( v42643(VarCurr)
    <=> v42645(VarCurr) ) ).

tff(addAssignment_21292,axiom,
    ! [VarCurr: state_type] :
      ( v42645(VarCurr)
    <=> v42481(VarCurr,1) ) ).

tff(addAssignment_21291,axiom,
    ! [VarCurr: state_type] :
      ( v42481(VarCurr,1)
    <=> v42483(VarCurr,1) ) ).

tff(addAssignment_21290,axiom,
    ! [VarCurr: state_type] :
      ( v42483(VarCurr,1)
    <=> v42485(VarCurr,1) ) ).

tff(addAssignment_21289,axiom,
    ! [VarCurr: state_type] :
      ( v42485(VarCurr,1)
    <=> v42490(VarCurr,1) ) ).

tff(addAssignment_21288,axiom,
    ! [VarCurr: state_type] :
      ( v42487(VarCurr,1)
    <=> v42489(VarCurr,1) ) ).

tff(addAssignment_21287,axiom,
    ! [VarCurr: state_type] :
      ( v42489(VarCurr,1)
    <=> v42055(VarCurr,1) ) ).

tff(addAssignment_21286,axiom,
    ! [VarCurr: state_type] :
      ( v42639(VarCurr)
    <=> v42641(VarCurr) ) ).

tff(addAssignment_21285,axiom,
    ! [VarCurr: state_type] :
      ( v42641(VarCurr)
    <=> v42055(VarCurr,0) ) ).

tff(addAssignment_21284,axiom,
    ! [VarCurr: state_type] :
      ( v42625(VarCurr)
    <=> v42627(VarCurr) ) ).

tff(addAssignment_21283,axiom,
    ! [VarCurr: state_type] :
      ( v42627(VarCurr)
    <=> $false ) ).

tff(addAssignment_21282,axiom,
    ! [VarCurr: state_type] :
      ( v42619(VarCurr)
    <=> v42621(VarCurr) ) ).

tff(addAssignment_21281,axiom,
    ! [VarCurr: state_type] :
      ( v42621(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42609(VarCurr,B)
      <=> v42611(VarCurr,B) ) ) ).

tff(addAssignment_21279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42611(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21278,axiom,
    ! [VarCurr: state_type] :
      ( v42599(VarCurr)
    <=> v42601(VarCurr) ) ).

tff(addAssignment_21277,axiom,
    ! [VarCurr: state_type] :
      ( v42601(VarCurr)
    <=> v42603(VarCurr) ) ).

tff(addAssignment_21276,axiom,
    ! [VarCurr: state_type] :
      ( v42603(VarCurr)
    <=> v42605(VarCurr) ) ).

tff(addAssignment_21275,axiom,
    ! [VarCurr: state_type] :
      ( v42605(VarCurr)
    <=> v42607(VarCurr) ) ).

tff(addAssignment_21274,axiom,
    ! [VarCurr: state_type] :
      ( v42607(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21273,axiom,
    ! [VarCurr: state_type] :
      ( v42589(VarCurr)
    <=> v42591(VarCurr) ) ).

tff(addAssignment_21272,axiom,
    ! [VarCurr: state_type] :
      ( v42591(VarCurr)
    <=> v42593(VarCurr) ) ).

tff(addAssignment_21271,axiom,
    ! [VarCurr: state_type] :
      ( v42593(VarCurr)
    <=> v42595(VarCurr) ) ).

tff(addAssignment_21270,axiom,
    ! [VarCurr: state_type] :
      ( v42595(VarCurr)
    <=> v42597(VarCurr) ) ).

tff(addAssignment_21269,axiom,
    ! [VarCurr: state_type] :
      ( v42597(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_21268,axiom,
    ! [VarCurr: state_type] :
      ( v42548(VarCurr)
    <=> v42550(VarCurr) ) ).

tff(addAssignment_21267,axiom,
    ! [VarCurr: state_type] :
      ( v42550(VarCurr)
    <=> v42552(VarCurr) ) ).

tff(addAssignment_21266,axiom,
    ! [VarCurr: state_type] :
      ( v42552(VarCurr)
    <=> v42554(VarCurr) ) ).

tff(addAssignment_21265,axiom,
    ! [VarCurr: state_type] :
      ( v42554(VarCurr)
    <=> v42556(VarCurr) ) ).

tff(addAssignment_21264,axiom,
    ! [VarCurr: state_type] :
      ( v42556(VarCurr)
    <=> v42558(VarCurr) ) ).

tff(addAssignment_21263,axiom,
    ! [VarCurr: state_type] :
      ( v42558(VarCurr)
    <=> v42560(VarCurr) ) ).

tff(addAssignment_21262,axiom,
    ! [VarCurr: state_type] :
      ( v42560(VarCurr)
    <=> v42562(VarCurr) ) ).

tff(writeUnaryOperator_2491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42562(VarCurr)
    <=> v42576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4055,axiom,
    ! [VarCurr: state_type] :
      ( v42576(VarCurr)
    <=> ( v42577(VarCurr)
        | v42572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4054,axiom,
    ! [VarCurr: state_type] :
      ( v42577(VarCurr)
    <=> ( v42564(VarCurr)
        | v42568(VarCurr) ) ) ).

tff(addAssignment_21261,axiom,
    ! [VarCurr: state_type] :
      ( v42572(VarCurr)
    <=> v42574(VarCurr) ) ).

tff(addAssignment_21260,axiom,
    ! [VarCurr: state_type] :
      ( v42574(VarCurr)
    <=> v42145(VarCurr,2) ) ).

tff(addAssignment_21259,axiom,
    ! [VarCurr: state_type] :
      ( v42568(VarCurr)
    <=> v42570(VarCurr) ) ).

tff(addAssignment_21258,axiom,
    ! [VarCurr: state_type] :
      ( v42570(VarCurr)
    <=> v42145(VarCurr,1) ) ).

tff(addAssignment_21257,axiom,
    ! [VarCurr: state_type] :
      ( v42564(VarCurr)
    <=> v42566(VarCurr) ) ).

tff(addAssignment_21256,axiom,
    ! [VarCurr: state_type] :
      ( v42566(VarCurr)
    <=> v42228(VarCurr,0) ) ).

tff(addAssignment_21255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42417(VarCurr,B)
      <=> v42419(VarCurr,B) ) ) ).

tff(addAssignment_21254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42419(VarCurr,B)
      <=> v42421(VarCurr,B) ) ) ).

tff(addAssignment_21253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42421(VarCurr,B)
      <=> v42423(VarCurr,B) ) ) ).

tff(addAssignment_21252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42423(VarCurr,B)
      <=> v42425(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42531(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v42425(VarNext,B)
            <=> v42425(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_499,axiom,
    ! [VarNext: state_type] :
      ( v42531(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42425(VarNext,B)
          <=> v42541(VarNext,B) ) ) ) ).

tff(addAssignment_21251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42541(VarNext,B)
          <=> v42539(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42542(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42539(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_340,axiom,
    ! [VarCurr: state_type] :
      ( v42542(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42539(VarCurr,B)
          <=> v42447(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4053,axiom,
    ! [VarCurr: state_type] :
      ( v42542(VarCurr)
    <=> ( v42543(VarCurr)
        & v42544(VarCurr) ) ) ).

tff(writeUnaryOperator_2490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42544(VarCurr)
    <=> v42437(VarCurr) ) ).

tff(writeUnaryOperator_2489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42543(VarCurr)
    <=> v42427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42531(VarNext)
      <=> v42532(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42532(VarNext)
      <=> ( v42533(VarNext)
          & v42451(VarNext) ) ) ) ).

tff(writeUnaryOperator_2488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42533(VarNext)
      <=> v42535(VarNext) ) ) ).

tff(addAssignment_21250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42535(VarNext)
      <=> v42451(VarCurr) ) ) ).

tff(addAssignment_21249,axiom,
    ! [VarCurr: state_type] :
      ( v42451(VarCurr)
    <=> v42453(VarCurr) ) ).

tff(addAssignment_21248,axiom,
    ! [VarCurr: state_type] :
      ( v42453(VarCurr)
    <=> v42455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4050,axiom,
    ! [VarCurr: state_type] :
      ( v42455(VarCurr)
    <=> ( v42528(VarCurr)
        | v42524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4049,axiom,
    ! [VarCurr: state_type] :
      ( v42528(VarCurr)
    <=> ( v42457(VarCurr)
        & v42461(VarCurr) ) ) ).

tff(addAssignment_21247,axiom,
    ! [VarCurr: state_type] :
      ( v42524(VarCurr)
    <=> v42526(VarCurr) ) ).

tff(addAssignment_21246,axiom,
    ! [VarCurr: state_type] :
      ( v42526(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42508(VarNext)
       => ( v42461(VarNext)
        <=> v42461(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_498,axiom,
    ! [VarNext: state_type] :
      ( v42508(VarNext)
     => ( v42461(VarNext)
      <=> v42518(VarNext) ) ) ).

tff(addAssignment_21245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42518(VarNext)
      <=> v42516(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4048,axiom,
    ! [VarCurr: state_type] :
      ( v42516(VarCurr)
    <=> ( v42519(VarCurr)
        & v42520(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4047,axiom,
    ! [VarCurr: state_type] :
      ( v42520(VarCurr)
    <=> ( v42467(VarCurr)
        | v42503(VarCurr) ) ) ).

tff(writeUnaryOperator_2487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42519(VarCurr)
    <=> v42463(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42508(VarNext)
      <=> v42509(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4045,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42509(VarNext)
      <=> ( v42511(VarNext)
          & v42513(VarNext) ) ) ) ).

tff(writeUnaryOperator_2486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42513(VarCurr)
    <=> v42457(VarCurr) ) ).

tff(addAssignment_21244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42511(VarNext)
      <=> v42457(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_177,axiom,
    ( v42461(constB0)
  <=> $true ) ).

tff(addAssignment_21243,axiom,
    ! [VarCurr: state_type] :
      ( v42503(VarCurr)
    <=> v42505(VarCurr) ) ).

tff(addAssignment_21242,axiom,
    ! [VarCurr: state_type] :
      ( v42505(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21241,axiom,
    ! [VarCurr: state_type] :
      ( v42467(VarCurr)
    <=> v42469(VarCurr) ) ).

tff(addAssignment_21240,axiom,
    ! [VarCurr: state_type] :
      ( v42469(VarCurr)
    <=> v42471(VarCurr) ) ).

tff(addAssignment_21239,axiom,
    ! [VarCurr: state_type] :
      ( v42471(VarCurr)
    <=> v42473(VarCurr) ) ).

tff(addAssignment_21238,axiom,
    ! [VarCurr: state_type] :
      ( v42473(VarCurr)
    <=> v42475(VarCurr) ) ).

tff(writeUnaryOperator_2485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42475(VarCurr)
    <=> v42500(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4044,axiom,
    ! [VarCurr: state_type] :
      ( v42500(VarCurr)
    <=> ( v42501(VarCurr)
        | v42496(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4043,axiom,
    ! [VarCurr: state_type] :
      ( v42501(VarCurr)
    <=> ( v42477(VarCurr)
        | v42492(VarCurr) ) ) ).

tff(addAssignment_21237,axiom,
    ! [VarCurr: state_type] :
      ( v42496(VarCurr)
    <=> v42498(VarCurr) ) ).

tff(addAssignment_21236,axiom,
    ! [VarCurr: state_type] :
      ( v42498(VarCurr)
    <=> v42055(VarCurr,2) ) ).

tff(addAssignment_21235,axiom,
    ! [VarCurr: state_type] :
      ( v42492(VarCurr)
    <=> v42494(VarCurr) ) ).

tff(addAssignment_21234,axiom,
    ! [VarCurr: state_type] :
      ( v42494(VarCurr)
    <=> v42055(VarCurr,1) ) ).

tff(addAssignment_21233,axiom,
    ! [VarCurr: state_type] :
      ( v42477(VarCurr)
    <=> v42479(VarCurr) ) ).

tff(addAssignment_21232,axiom,
    ! [VarCurr: state_type] :
      ( v42479(VarCurr)
    <=> v42481(VarCurr,0) ) ).

tff(addAssignment_21231,axiom,
    ! [VarCurr: state_type] :
      ( v42481(VarCurr,0)
    <=> v42483(VarCurr,0) ) ).

tff(addAssignment_21230,axiom,
    ! [VarCurr: state_type] :
      ( v42483(VarCurr,0)
    <=> v42485(VarCurr,0) ) ).

tff(addAssignment_21229,axiom,
    ! [VarCurr: state_type] :
      ( v42485(VarCurr,0)
    <=> v42490(VarCurr,0) ) ).

tff(writeUnaryOperator_2484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v42490(VarCurr,B)
      <=> ~ v42487(VarCurr,B) ) ) ).

tff(addAssignment_21228,axiom,
    ! [VarCurr: state_type] :
      ( v42487(VarCurr,0)
    <=> v42489(VarCurr,0) ) ).

tff(addAssignment_21227,axiom,
    ! [VarCurr: state_type] :
      ( v42489(VarCurr,0)
    <=> v42055(VarCurr,0) ) ).

tff(addAssignment_21226,axiom,
    ! [VarCurr: state_type] :
      ( v42463(VarCurr)
    <=> v42465(VarCurr) ) ).

tff(addAssignment_21225,axiom,
    ! [VarCurr: state_type] :
      ( v42465(VarCurr)
    <=> $false ) ).

tff(addAssignment_21224,axiom,
    ! [VarCurr: state_type] :
      ( v42457(VarCurr)
    <=> v42459(VarCurr) ) ).

tff(addAssignment_21223,axiom,
    ! [VarCurr: state_type] :
      ( v42459(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42447(VarCurr,B)
      <=> v42449(VarCurr,B) ) ) ).

tff(addAssignment_21221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42449(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21220,axiom,
    ! [VarCurr: state_type] :
      ( v42437(VarCurr)
    <=> v42439(VarCurr) ) ).

tff(addAssignment_21219,axiom,
    ! [VarCurr: state_type] :
      ( v42439(VarCurr)
    <=> v42441(VarCurr) ) ).

tff(addAssignment_21218,axiom,
    ! [VarCurr: state_type] :
      ( v42441(VarCurr)
    <=> v42443(VarCurr) ) ).

tff(addAssignment_21217,axiom,
    ! [VarCurr: state_type] :
      ( v42443(VarCurr)
    <=> v42445(VarCurr) ) ).

tff(addAssignment_21216,axiom,
    ! [VarCurr: state_type] :
      ( v42445(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21215,axiom,
    ! [VarCurr: state_type] :
      ( v42427(VarCurr)
    <=> v42429(VarCurr) ) ).

tff(addAssignment_21214,axiom,
    ! [VarCurr: state_type] :
      ( v42429(VarCurr)
    <=> v42431(VarCurr) ) ).

tff(addAssignment_21213,axiom,
    ! [VarCurr: state_type] :
      ( v42431(VarCurr)
    <=> v42433(VarCurr) ) ).

tff(addAssignment_21212,axiom,
    ! [VarCurr: state_type] :
      ( v42433(VarCurr)
    <=> v42435(VarCurr) ) ).

tff(addAssignment_21211,axiom,
    ! [VarCurr: state_type] :
      ( v42435(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_21210,axiom,
    ! [VarCurr: state_type] :
      ( v42125(VarCurr)
    <=> v42127(VarCurr) ) ).

tff(addAssignment_21209,axiom,
    ! [VarCurr: state_type] :
      ( v42127(VarCurr)
    <=> v42129(VarCurr) ) ).

tff(addAssignment_21208,axiom,
    ! [VarCurr: state_type] :
      ( v42129(VarCurr)
    <=> v42131(VarCurr) ) ).

tff(addAssignment_21207,axiom,
    ! [VarCurr: state_type] :
      ( v42131(VarCurr)
    <=> v42133(VarCurr) ) ).

tff(addAssignment_21206,axiom,
    ! [VarCurr: state_type] :
      ( v42133(VarCurr)
    <=> v42135(VarCurr) ) ).

tff(addAssignment_21205,axiom,
    ! [VarCurr: state_type] :
      ( v42135(VarCurr)
    <=> v42137(VarCurr) ) ).

tff(addAssignment_21204,axiom,
    ! [VarCurr: state_type] :
      ( v42137(VarCurr)
    <=> v42139(VarCurr) ) ).

tff(writeUnaryOperator_2483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42139(VarCurr)
    <=> v42414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4042,axiom,
    ! [VarCurr: state_type] :
      ( v42414(VarCurr)
    <=> ( v42415(VarCurr)
        | v42410(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4041,axiom,
    ! [VarCurr: state_type] :
      ( v42415(VarCurr)
    <=> ( v42141(VarCurr)
        | v42406(VarCurr) ) ) ).

tff(addAssignment_21203,axiom,
    ! [VarCurr: state_type] :
      ( v42410(VarCurr)
    <=> v42412(VarCurr) ) ).

tff(addAssignment_21202,axiom,
    ! [VarCurr: state_type] :
      ( v42412(VarCurr)
    <=> v42145(VarCurr,2) ) ).

tff(addAssignment_21201,axiom,
    ! [VarCurr: state_type] :
      ( v42406(VarCurr)
    <=> v42408(VarCurr) ) ).

tff(addAssignment_21200,axiom,
    ! [VarCurr: state_type] :
      ( v42408(VarCurr)
    <=> v42145(VarCurr,1) ) ).

tff(addAssignment_21199,axiom,
    ! [VarCurr: state_type] :
      ( v42141(VarCurr)
    <=> v42143(VarCurr) ) ).

tff(addAssignment_21198,axiom,
    ! [VarCurr: state_type] :
      ( v42143(VarCurr)
    <=> v42145(VarCurr,0) ) ).

tff(addAssignment_21197,axiom,
    ! [VarCurr: state_type] :
      ( v42145(VarCurr,0)
    <=> v42057(VarCurr,3) ) ).

tff(addAssignment_21196,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,3)
    <=> v42059(VarCurr,3) ) ).

tff(addAssignment_21195,axiom,
    ! [VarNext: state_type] :
      ( v42059(VarNext,3)
    <=> v42398(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42399(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v42398(VarNext,B)
            <=> v42059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_497,axiom,
    ! [VarNext: state_type] :
      ( v42399(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42398(VarNext,B)
          <=> v42370(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42399(VarNext)
      <=> v42400(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42400(VarNext)
      <=> ( v42402(VarNext)
          & v42312(VarNext) ) ) ) ).

tff(writeUnaryOperator_2482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42402(VarNext)
      <=> v42364(VarNext) ) ) ).

tff(addAssignment_21194,axiom,
    ! [VarCurr: state_type] :
      ( v42169(VarCurr,3)
    <=> v42171(VarCurr,3) ) ).

tff(addAssignment_21193,axiom,
    ! [VarCurr: state_type] :
      ( v42171(VarCurr,3)
    <=> v42309(VarCurr,3) ) ).

tff(addAssignment_21192,axiom,
    ! [VarCurr: state_type] :
      ( v42173(VarCurr,0)
    <=> v42175(VarCurr,0) ) ).

tff(addAssignment_21191,axiom,
    ! [VarCurr: state_type] :
      ( v42175(VarCurr,0)
    <=> v42177(VarCurr,0) ) ).

tff(addAssignment_21190,axiom,
    ! [VarCurr: state_type] :
      ( v42177(VarCurr,0)
    <=> v42308(VarCurr,0) ) ).

tff(addAssignment_21189,axiom,
    ! [VarCurr: state_type] :
      ( v42245(VarCurr,0)
    <=> v42247(VarCurr,0) ) ).

tff(addAssignment_21188,axiom,
    ! [VarCurr: state_type] :
      ( v42247(VarCurr,0)
    <=> v42249(VarCurr,0) ) ).

tff(addAssignment_21187,axiom,
    ! [VarCurr: state_type] :
      ( v42249(VarCurr,0)
    <=> v42251(VarCurr,0) ) ).

tff(addAssignment_21186,axiom,
    ! [VarCurr: state_type] :
      ( v42251(VarCurr,0)
    <=> v42253(VarCurr,0) ) ).

tff(addAssignment_21185,axiom,
    ! [VarCurr: state_type] :
      ( v42253(VarCurr,0)
    <=> v42263(VarCurr,0) ) ).

tff(addAssignment_21184,axiom,
    ! [VarCurr: state_type] :
      ( v42179(VarCurr,0)
    <=> v42181(VarCurr,0) ) ).

tff(addAssignment_21183,axiom,
    ! [VarCurr: state_type] :
      ( v42181(VarCurr,0)
    <=> v42242(VarCurr,0) ) ).

tff(addAssignment_21182,axiom,
    ! [VarCurr: state_type] :
      ( v42183(VarCurr)
    <=> v41709(VarCurr,2) ) ).

tff(addAssignment_21181,axiom,
    ! [VarCurr: state_type] :
      ( v41709(VarCurr,2)
    <=> v41711(VarCurr,2) ) ).

tff(addAssignment_21180,axiom,
    ! [VarCurr: state_type] :
      ( v41711(VarCurr,2)
    <=> v41721(VarCurr,2) ) ).

tff(addAssignment_21179,axiom,
    ! [VarCurr: state_type] :
      ( v41713(VarCurr,2)
    <=> v41715(VarCurr,2) ) ).

tff(addAssignment_21178,axiom,
    ! [VarCurr: state_type] :
      ( v41715(VarCurr,2)
    <=> v41718(VarCurr,2) ) ).

tff(addAssignment_21177,axiom,
    ! [VarCurr: state_type] :
      ( v41719(VarCurr)
    <=> v42186(VarCurr,1) ) ).

tff(addAssignment_21176,axiom,
    ! [VarCurr: state_type] :
      ( v42186(VarCurr,1)
    <=> v42188(VarCurr,1) ) ).

tff(addAssignment_21175,axiom,
    ! [VarCurr: state_type] :
      ( v42188(VarCurr,1)
    <=> v42396(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v42396(VarCurr,B)
      <=> ( v42190(VarCurr,B)
          | v42196(VarCurr,B) ) ) ) ).

tff(addAssignment_21174,axiom,
    ! [VarCurr: state_type] :
      ( v42196(VarCurr,1)
    <=> v42198(VarCurr,1) ) ).

tff(addAssignment_21173,axiom,
    ! [VarCurr: state_type] :
      ( v42198(VarCurr,1)
    <=> v42394(VarCurr,1) ) ).

tff(addAssignment_21172,axiom,
    ! [VarCurr: state_type] :
      ( v42394(VarCurr,0)
    <=> v42395(VarCurr) ) ).

tff(addAssignment_21171,axiom,
    ! [VarCurr: state_type] :
      ( v42394(VarCurr,1)
    <=> v42200(VarCurr) ) ).

tff(addAssignment_21170,axiom,
    ! [VarCurr: state_type] :
      ( v42200(VarCurr)
    <=> v42202(VarCurr,1) ) ).

tff(addAssignment_21169,axiom,
    ! [VarCurr: state_type] :
      ( v42202(VarCurr,1)
    <=> v42204(VarCurr,1) ) ).

tff(addAssignment_21168,axiom,
    ! [VarCurr: state_type] :
      ( v42204(VarCurr,1)
    <=> v42393(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v42393(VarCurr,B)
      <=> ( v42206(VarCurr,B)
          & v42214(VarCurr,B) ) ) ) ).

tff(addAssignment_21167,axiom,
    ! [VarCurr: state_type] :
      ( v42214(VarCurr,1)
    <=> v42216(VarCurr,1) ) ).

tff(addAssignment_21166,axiom,
    ! [VarCurr: state_type] :
      ( v42216(VarCurr,1)
    <=> v42391(VarCurr,1) ) ).

tff(addAssignment_21165,axiom,
    ! [VarCurr: state_type] :
      ( v42391(VarCurr,0)
    <=> v42392(VarCurr) ) ).

tff(addAssignment_21164,axiom,
    ! [VarCurr: state_type] :
      ( v42391(VarCurr,1)
    <=> v42218(VarCurr) ) ).

tff(addAssignment_21163,axiom,
    ! [VarCurr: state_type] :
      ( v42218(VarCurr)
    <=> v42220(VarCurr) ) ).

tff(addAssignment_21162,axiom,
    ! [VarCurr: state_type] :
      ( v42220(VarCurr)
    <=> v42222(VarCurr) ) ).

tff(writeUnaryOperator_2481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42222(VarCurr)
    <=> v42389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4038,axiom,
    ! [VarCurr: state_type] :
      ( v42389(VarCurr)
    <=> ( v42390(VarCurr)
        | v42377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4037,axiom,
    ! [VarCurr: state_type] :
      ( v42390(VarCurr)
    <=> ( v42224(VarCurr)
        | v42239(VarCurr) ) ) ).

tff(addAssignment_21161,axiom,
    ! [VarCurr: state_type] :
      ( v42377(VarCurr)
    <=> v42379(VarCurr) ) ).

tff(addAssignment_21160,axiom,
    ! [VarCurr: state_type] :
      ( v42379(VarCurr)
    <=> v42228(VarCurr,2) ) ).

tff(addAssignment_21159,axiom,
    ! [VarCurr: state_type] :
      ( v42228(VarCurr,2)
    <=> v42230(VarCurr,2) ) ).

tff(addAssignment_21158,axiom,
    ! [VarCurr: state_type] :
      ( v42230(VarCurr,2)
    <=> v42232(VarCurr,2) ) ).

tff(addAssignment_21157,axiom,
    ! [VarCurr: state_type] :
      ( v42232(VarCurr,2)
    <=> v42237(VarCurr,2) ) ).

tff(addAssignment_21156,axiom,
    ! [VarCurr: state_type] :
      ( v42234(VarCurr,2)
    <=> v42236(VarCurr,2) ) ).

tff(addAssignment_21155,axiom,
    ! [VarCurr: state_type] :
      ( v42236(VarCurr,2)
    <=> v42145(VarCurr,2) ) ).

tff(addAssignment_21154,axiom,
    ! [VarCurr: state_type] :
      ( v42145(VarCurr,2)
    <=> v42057(VarCurr,5) ) ).

tff(addAssignment_21153,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,5)
    <=> v42059(VarCurr,5) ) ).

tff(addAssignment_21152,axiom,
    ! [VarNext: state_type] :
      ( v42059(VarNext,5)
    <=> v42381(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42382(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v42381(VarNext,B)
            <=> v42059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_496,axiom,
    ! [VarNext: state_type] :
      ( v42382(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42381(VarNext,B)
          <=> v42370(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42382(VarNext)
      <=> v42383(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42383(VarNext)
      <=> ( v42385(VarNext)
          & v42312(VarNext) ) ) ) ).

tff(writeUnaryOperator_2480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42385(VarNext)
      <=> v42364(VarNext) ) ) ).

tff(addAssignment_21151,axiom,
    ! [VarCurr: state_type] :
      ( v42169(VarCurr,5)
    <=> v42171(VarCurr,5) ) ).

tff(addAssignment_21150,axiom,
    ! [VarCurr: state_type] :
      ( v42171(VarCurr,5)
    <=> v42309(VarCurr,5) ) ).

tff(addAssignment_21149,axiom,
    ! [VarCurr: state_type] :
      ( v42173(VarCurr,2)
    <=> v42175(VarCurr,2) ) ).

tff(addAssignment_21148,axiom,
    ! [VarCurr: state_type] :
      ( v42175(VarCurr,2)
    <=> v42177(VarCurr,2) ) ).

tff(addAssignment_21147,axiom,
    ! [VarCurr: state_type] :
      ( v42177(VarCurr,2)
    <=> v42308(VarCurr,2) ) ).

tff(addAssignment_21146,axiom,
    ! [VarCurr: state_type] :
      ( v42245(VarCurr,2)
    <=> v42247(VarCurr,2) ) ).

tff(addAssignment_21145,axiom,
    ! [VarCurr: state_type] :
      ( v42247(VarCurr,2)
    <=> v42249(VarCurr,2) ) ).

tff(addAssignment_21144,axiom,
    ! [VarCurr: state_type] :
      ( v42249(VarCurr,2)
    <=> v42251(VarCurr,2) ) ).

tff(addAssignment_21143,axiom,
    ! [VarCurr: state_type] :
      ( v42251(VarCurr,2)
    <=> v42253(VarCurr,2) ) ).

tff(addAssignment_21142,axiom,
    ! [VarCurr: state_type] :
      ( v42253(VarCurr,2)
    <=> v42263(VarCurr,2) ) ).

tff(addAssignment_21141,axiom,
    ! [VarCurr: state_type] :
      ( v42255(VarCurr,2)
    <=> v42257(VarCurr,2) ) ).

tff(addAssignment_21140,axiom,
    ! [VarCurr: state_type] :
      ( v42257(VarCurr,2)
    <=> v42258(VarCurr,2) ) ).

tff(addAssignment_21139,axiom,
    ! [VarCurr: state_type] :
      ( v42179(VarCurr,2)
    <=> v42181(VarCurr,2) ) ).

tff(addAssignment_21138,axiom,
    ! [VarCurr: state_type] :
      ( v42181(VarCurr,2)
    <=> v42242(VarCurr,2) ) ).

tff(addAssignment_21137,axiom,
    ! [VarCurr: state_type] :
      ( v42239(VarCurr)
    <=> v42241(VarCurr) ) ).

tff(addAssignment_21136,axiom,
    ! [VarCurr: state_type] :
      ( v42241(VarCurr)
    <=> v42145(VarCurr,1) ) ).

tff(addAssignment_21135,axiom,
    ! [VarCurr: state_type] :
      ( v42145(VarCurr,1)
    <=> v42057(VarCurr,4) ) ).

tff(addAssignment_21134,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,4)
    <=> v42059(VarCurr,4) ) ).

tff(addAssignment_21133,axiom,
    ! [VarNext: state_type] :
      ( v42059(VarNext,4)
    <=> v42359(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42360(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v42359(VarNext,B)
            <=> v42059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_495,axiom,
    ! [VarNext: state_type] :
      ( v42360(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42359(VarNext,B)
          <=> v42370(VarNext,B) ) ) ) ).

tff(addAssignment_21132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42370(VarNext,B)
          <=> v42368(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42371(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42368(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_339,axiom,
    ! [VarCurr: state_type] :
      ( v42371(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v42368(VarCurr,B)
          <=> v42169(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4034,axiom,
    ! [VarCurr: state_type] :
      ( v42371(VarCurr)
    <=> ( v42372(VarCurr)
        & v42373(VarCurr) ) ) ).

tff(writeUnaryOperator_2479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42373(VarCurr)
    <=> v42159(VarCurr) ) ).

tff(writeUnaryOperator_2478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42372(VarCurr)
    <=> v42147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42360(VarNext)
      <=> v42361(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4032,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42361(VarNext)
      <=> ( v42362(VarNext)
          & v42312(VarNext) ) ) ) ).

tff(writeUnaryOperator_2477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42362(VarNext)
      <=> v42364(VarNext) ) ) ).

tff(addAssignment_21131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42364(VarNext)
      <=> v42312(VarCurr) ) ) ).

tff(addAssignment_21130,axiom,
    ! [VarCurr: state_type] :
      ( v42312(VarCurr)
    <=> v42314(VarCurr) ) ).

tff(addAssignment_21129,axiom,
    ! [VarCurr: state_type] :
      ( v42314(VarCurr)
    <=> v42316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4031,axiom,
    ! [VarCurr: state_type] :
      ( v42316(VarCurr)
    <=> ( v42357(VarCurr)
        | v42353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4030,axiom,
    ! [VarCurr: state_type] :
      ( v42357(VarCurr)
    <=> ( v42318(VarCurr)
        & v42322(VarCurr) ) ) ).

tff(addAssignment_21128,axiom,
    ! [VarCurr: state_type] :
      ( v42353(VarCurr)
    <=> v42355(VarCurr) ) ).

tff(addAssignment_21127,axiom,
    ! [VarCurr: state_type] :
      ( v42355(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42337(VarNext)
       => ( v42322(VarNext)
        <=> v42322(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_494,axiom,
    ! [VarNext: state_type] :
      ( v42337(VarNext)
     => ( v42322(VarNext)
      <=> v42347(VarNext) ) ) ).

tff(addAssignment_21126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42347(VarNext)
      <=> v42345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4029,axiom,
    ! [VarCurr: state_type] :
      ( v42345(VarCurr)
    <=> ( v42348(VarCurr)
        & v42349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4028,axiom,
    ! [VarCurr: state_type] :
      ( v42349(VarCurr)
    <=> ( v42328(VarCurr)
        | v42332(VarCurr) ) ) ).

tff(writeUnaryOperator_2476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42348(VarCurr)
    <=> v42324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42337(VarNext)
      <=> v42338(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42338(VarNext)
      <=> ( v42340(VarNext)
          & v42342(VarNext) ) ) ) ).

tff(writeUnaryOperator_2475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42342(VarCurr)
    <=> v42318(VarCurr) ) ).

tff(addAssignment_21125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42340(VarNext)
      <=> v42318(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_176,axiom,
    ( v42322(constB0)
  <=> $true ) ).

tff(addAssignment_21124,axiom,
    ! [VarCurr: state_type] :
      ( v42332(VarCurr)
    <=> v42334(VarCurr) ) ).

tff(addAssignment_21123,axiom,
    ! [VarCurr: state_type] :
      ( v42334(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21122,axiom,
    ! [VarCurr: state_type] :
      ( v42328(VarCurr)
    <=> v42330(VarCurr) ) ).

tff(addAssignment_21121,axiom,
    ! [VarCurr: state_type] :
      ( v42330(VarCurr)
    <=> $true ) ).

tff(addAssignment_21120,axiom,
    ! [VarCurr: state_type] :
      ( v42324(VarCurr)
    <=> v42326(VarCurr) ) ).

tff(addAssignment_21119,axiom,
    ! [VarCurr: state_type] :
      ( v42326(VarCurr)
    <=> $false ) ).

tff(addAssignment_21118,axiom,
    ! [VarCurr: state_type] :
      ( v42318(VarCurr)
    <=> v42320(VarCurr) ) ).

tff(addAssignment_21117,axiom,
    ! [VarCurr: state_type] :
      ( v42320(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21116,axiom,
    ! [VarCurr: state_type] :
      ( v42169(VarCurr,4)
    <=> v42171(VarCurr,4) ) ).

tff(addAssignment_21115,axiom,
    ! [VarCurr: state_type] :
      ( v42171(VarCurr,4)
    <=> v42309(VarCurr,4) ) ).

tff(addAssignment_21114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v42309(VarCurr,B)
      <=> v42310(VarCurr,B) ) ) ).

tff(addAssignment_21113,axiom,
    ! [VarCurr: state_type] :
      ( ( v42309(VarCurr,5)
      <=> v42173(VarCurr,2) )
      & ( v42309(VarCurr,4)
      <=> v42173(VarCurr,1) )
      & ( v42309(VarCurr,3)
      <=> v42173(VarCurr,0) ) ) ).

tff(addAssignment_21112,axiom,
    ! [VarCurr: state_type] :
      ( v42173(VarCurr,1)
    <=> v42175(VarCurr,1) ) ).

tff(addAssignment_21111,axiom,
    ! [VarCurr: state_type] :
      ( v42175(VarCurr,1)
    <=> v42177(VarCurr,1) ) ).

tff(addAssignment_21110,axiom,
    ! [VarCurr: state_type] :
      ( v42177(VarCurr,1)
    <=> v42308(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v42308(VarCurr,B)
      <=> ( v42179(VarCurr,B)
          & v42245(VarCurr,B) ) ) ) ).

tff(addAssignment_21109,axiom,
    ! [VarCurr: state_type] :
      ( v42245(VarCurr,1)
    <=> v42247(VarCurr,1) ) ).

tff(addAssignment_21108,axiom,
    ! [VarCurr: state_type] :
      ( v42247(VarCurr,1)
    <=> v42249(VarCurr,1) ) ).

tff(addAssignment_21107,axiom,
    ! [VarCurr: state_type] :
      ( v42249(VarCurr,1)
    <=> v42251(VarCurr,1) ) ).

tff(addAssignment_21106,axiom,
    ! [VarCurr: state_type] :
      ( v42251(VarCurr,1)
    <=> v42253(VarCurr,1) ) ).

tff(addAssignment_21105,axiom,
    ! [VarCurr: state_type] :
      ( v42253(VarCurr,1)
    <=> v42263(VarCurr,1) ) ).

tff(addAssignment_21104,axiom,
    ! [VarCurr: state_type] :
      ( v42263(VarCurr,0)
    <=> v42303(VarCurr) ) ).

tff(addAssignment_21103,axiom,
    ! [VarCurr: state_type] :
      ( v42263(VarCurr,1)
    <=> v42298(VarCurr) ) ).

tff(addAssignment_21102,axiom,
    ! [VarCurr: state_type] :
      ( v42263(VarCurr,2)
    <=> v42293(VarCurr) ) ).

tff(addAssignment_21101,axiom,
    ! [VarCurr: state_type] :
      ( v42263(VarCurr,3)
    <=> v42265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4025,axiom,
    ! [VarCurr: state_type] :
      ( v42303(VarCurr)
    <=> ( v42304(VarCurr)
        & v42307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4024,axiom,
    ! [VarCurr: state_type] :
      ( v42307(VarCurr)
    <=> ( v42255(VarCurr,0)
        | v42273(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4023,axiom,
    ! [VarCurr: state_type] :
      ( v42304(VarCurr)
    <=> ( v42305(VarCurr)
        | v42306(VarCurr) ) ) ).

tff(writeUnaryOperator_2474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42306(VarCurr)
    <=> v42273(VarCurr,0) ) ).

tff(writeUnaryOperator_2473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42305(VarCurr)
    <=> v42255(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4022,axiom,
    ! [VarCurr: state_type] :
      ( v42298(VarCurr)
    <=> ( v42299(VarCurr)
        & v42302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4021,axiom,
    ! [VarCurr: state_type] :
      ( v42302(VarCurr)
    <=> ( v42272(VarCurr)
        | v42274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4020,axiom,
    ! [VarCurr: state_type] :
      ( v42299(VarCurr)
    <=> ( v42300(VarCurr)
        | v42301(VarCurr) ) ) ).

tff(writeUnaryOperator_2472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42301(VarCurr)
    <=> v42274(VarCurr) ) ).

tff(writeUnaryOperator_2471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42300(VarCurr)
    <=> v42272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4019,axiom,
    ! [VarCurr: state_type] :
      ( v42293(VarCurr)
    <=> ( v42294(VarCurr)
        & v42297(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4018,axiom,
    ! [VarCurr: state_type] :
      ( v42297(VarCurr)
    <=> ( v42270(VarCurr)
        | v42280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4017,axiom,
    ! [VarCurr: state_type] :
      ( v42294(VarCurr)
    <=> ( v42295(VarCurr)
        | v42296(VarCurr) ) ) ).

tff(writeUnaryOperator_2470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42296(VarCurr)
    <=> v42280(VarCurr) ) ).

tff(writeUnaryOperator_2469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42295(VarCurr)
    <=> v42270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4016,axiom,
    ! [VarCurr: state_type] :
      ( v42265(VarCurr)
    <=> ( v42266(VarCurr)
        & v42292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4015,axiom,
    ! [VarCurr: state_type] :
      ( v42292(VarCurr)
    <=> ( v42268(VarCurr)
        | v42287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4014,axiom,
    ! [VarCurr: state_type] :
      ( v42266(VarCurr)
    <=> ( v42267(VarCurr)
        | v42286(VarCurr) ) ) ).

tff(writeUnaryOperator_2468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42286(VarCurr)
    <=> v42287(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4013,axiom,
    ! [VarCurr: state_type] :
      ( v42287(VarCurr)
    <=> ( v42288(VarCurr)
        & v42291(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_523,axiom,
    ! [VarCurr: state_type] :
      ( v42291(VarCurr)
    <=> ( v42255(VarCurr,3)
        | v42273(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4012,axiom,
    ! [VarCurr: state_type] :
      ( v42288(VarCurr)
    <=> ( v42289(VarCurr)
        | v42290(VarCurr) ) ) ).

tff(writeUnaryOperator_2467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42290(VarCurr)
    <=> v42273(VarCurr,3) ) ).

tff(writeUnaryOperator_2466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42289(VarCurr)
    <=> v42255(VarCurr,3) ) ).

tff(writeUnaryOperator_2465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42267(VarCurr)
    <=> v42268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4011,axiom,
    ! [VarCurr: state_type] :
      ( v42268(VarCurr)
    <=> ( v42269(VarCurr)
        | v42285(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_522,axiom,
    ! [VarCurr: state_type] :
      ( v42285(VarCurr)
    <=> ( v42255(VarCurr,2)
        & v42273(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4010,axiom,
    ! [VarCurr: state_type] :
      ( v42269(VarCurr)
    <=> ( v42270(VarCurr)
        & v42280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4009,axiom,
    ! [VarCurr: state_type] :
      ( v42280(VarCurr)
    <=> ( v42281(VarCurr)
        & v42284(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_521,axiom,
    ! [VarCurr: state_type] :
      ( v42284(VarCurr)
    <=> ( v42255(VarCurr,2)
        | v42273(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4008,axiom,
    ! [VarCurr: state_type] :
      ( v42281(VarCurr)
    <=> ( v42282(VarCurr)
        | v42283(VarCurr) ) ) ).

tff(writeUnaryOperator_2464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42283(VarCurr)
    <=> v42273(VarCurr,2) ) ).

tff(writeUnaryOperator_2463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42282(VarCurr)
    <=> v42255(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4007,axiom,
    ! [VarCurr: state_type] :
      ( v42270(VarCurr)
    <=> ( v42271(VarCurr)
        | v42279(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_520,axiom,
    ! [VarCurr: state_type] :
      ( v42279(VarCurr)
    <=> ( v42255(VarCurr,1)
        & v42273(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4006,axiom,
    ! [VarCurr: state_type] :
      ( v42271(VarCurr)
    <=> ( v42272(VarCurr)
        & v42274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4005,axiom,
    ! [VarCurr: state_type] :
      ( v42274(VarCurr)
    <=> ( v42275(VarCurr)
        & v42278(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_519,axiom,
    ! [VarCurr: state_type] :
      ( v42278(VarCurr)
    <=> ( v42255(VarCurr,1)
        | v42273(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4004,axiom,
    ! [VarCurr: state_type] :
      ( v42275(VarCurr)
    <=> ( v42276(VarCurr)
        | v42277(VarCurr) ) ) ).

tff(writeUnaryOperator_2462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42277(VarCurr)
    <=> v42273(VarCurr,1) ) ).

tff(writeUnaryOperator_2461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42276(VarCurr)
    <=> v42255(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4003,axiom,
    ! [VarCurr: state_type] :
      ( v42272(VarCurr)
    <=> ( v42255(VarCurr,0)
        & v42273(VarCurr,0) ) ) ).

tff(addAssignment_21100,axiom,
    ! [VarCurr: state_type] :
      ( v42273(VarCurr,0)
    <=> v42260(VarCurr) ) ).

tff(addAssignment_21099,axiom,
    ! [VarCurr: state_type] :
      ( ( v42273(VarCurr,3)
      <=> $false )
      & ( v42273(VarCurr,2)
      <=> $false )
      & ( v42273(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_21098,axiom,
    ! [VarCurr: state_type] :
      ( v42260(VarCurr)
    <=> v42262(VarCurr) ) ).

tff(addAssignment_21097,axiom,
    ! [VarCurr: state_type] :
      ( v42262(VarCurr)
    <=> v42210(VarCurr) ) ).

tff(addAssignment_21096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v42255(VarCurr,B)
      <=> v42257(VarCurr,B) ) ) ).

tff(addAssignment_21095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v42257(VarCurr,B)
      <=> v42258(VarCurr,B) ) ) ).

tff(addAssignment_21094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v42258(VarCurr,B)
      <=> v42145(VarCurr,B) ) ) ).

tff(addAssignment_21093,axiom,
    ! [VarCurr: state_type] :
      ( v42258(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_21092,axiom,
    ! [VarCurr: state_type] :
      ( v42179(VarCurr,1)
    <=> v42181(VarCurr,1) ) ).

tff(addAssignment_21091,axiom,
    ! [VarCurr: state_type] :
      ( v42181(VarCurr,1)
    <=> v42242(VarCurr,1) ) ).

tff(addAssignment_21090,axiom,
    ! [VarCurr: state_type] :
      ( v42242(VarCurr,0)
    <=> v42243(VarCurr) ) ).

tff(addAssignment_21089,axiom,
    ! [VarCurr: state_type] :
      ( v42242(VarCurr,1)
    <=> v42243(VarCurr) ) ).

tff(addAssignment_21088,axiom,
    ! [VarCurr: state_type] :
      ( v42242(VarCurr,2)
    <=> v42243(VarCurr) ) ).

tff(addAssignment_21087,axiom,
    ! [VarCurr: state_type] :
      ( v42243(VarCurr)
    <=> v42183(VarCurr) ) ).

tff(addAssignment_21086,axiom,
    ! [VarCurr: state_type] :
      ( v42224(VarCurr)
    <=> v42226(VarCurr) ) ).

tff(addAssignment_21085,axiom,
    ! [VarCurr: state_type] :
      ( v42226(VarCurr)
    <=> v42228(VarCurr,0) ) ).

tff(addAssignment_21084,axiom,
    ! [VarCurr: state_type] :
      ( v42228(VarCurr,0)
    <=> v42230(VarCurr,0) ) ).

tff(addAssignment_21083,axiom,
    ! [VarCurr: state_type] :
      ( v42230(VarCurr,0)
    <=> v42232(VarCurr,0) ) ).

tff(addAssignment_21082,axiom,
    ! [VarCurr: state_type] :
      ( v42232(VarCurr,0)
    <=> v42237(VarCurr,0) ) ).

tff(writeUnaryOperator_2460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v42237(VarCurr,B)
      <=> ~ v42234(VarCurr,B) ) ) ).

tff(addAssignment_21081,axiom,
    ! [VarCurr: state_type] :
      ( v42234(VarCurr,0)
    <=> v42236(VarCurr,0) ) ).

tff(addAssignment_21080,axiom,
    ! [VarCurr: state_type] :
      ( v42236(VarCurr,0)
    <=> v42145(VarCurr,0) ) ).

tff(addAssignment_21079,axiom,
    ! [VarCurr: state_type] :
      ( v42206(VarCurr,1)
    <=> v42208(VarCurr,1) ) ).

tff(addAssignment_21078,axiom,
    ! [VarCurr: state_type] :
      ( v42208(VarCurr,1)
    <=> v42211(VarCurr,1) ) ).

tff(addAssignment_21077,axiom,
    ! [VarCurr: state_type] :
      ( v42211(VarCurr,0)
    <=> v42212(VarCurr) ) ).

tff(addAssignment_21076,axiom,
    ! [VarCurr: state_type] :
      ( v42211(VarCurr,1)
    <=> v42210(VarCurr) ) ).

tff(addAssignment_21075,axiom,
    ! [VarCurr: state_type] :
      ( v42210(VarCurr)
    <=> v7230(VarCurr,7) ) ).

tff(addAssignment_21074,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,7)
    <=> v7232(VarCurr,7) ) ).

tff(addAssignment_21073,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,7)
    <=> v7234(VarCurr,7) ) ).

tff(addAssignment_21072,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,7)
    <=> v34455(VarCurr,7) ) ).

tff(addAssignment_21071,axiom,
    ! [VarCurr: state_type] :
      ( v42190(VarCurr,1)
    <=> v42192(VarCurr,1) ) ).

tff(addAssignment_21070,axiom,
    ! [VarCurr: state_type] :
      ( v42192(VarCurr,1)
    <=> v42193(VarCurr,1) ) ).

tff(addAssignment_21069,axiom,
    ! [VarCurr: state_type] :
      ( v42193(VarCurr,0)
    <=> v42194(VarCurr) ) ).

tff(addAssignment_21068,axiom,
    ! [VarCurr: state_type] :
      ( v42193(VarCurr,1)
    <=> v42194(VarCurr) ) ).

tff(addAssignment_21067,axiom,
    ! [VarCurr: state_type] :
      ( v42194(VarCurr)
    <=> v41717(VarCurr) ) ).

tff(addAssignment_21066,axiom,
    ! [VarCurr: state_type] :
      ( v42159(VarCurr)
    <=> v42161(VarCurr) ) ).

tff(addAssignment_21065,axiom,
    ! [VarCurr: state_type] :
      ( v42161(VarCurr)
    <=> v42163(VarCurr) ) ).

tff(addAssignment_21064,axiom,
    ! [VarCurr: state_type] :
      ( v42163(VarCurr)
    <=> v42165(VarCurr) ) ).

tff(addAssignment_21063,axiom,
    ! [VarCurr: state_type] :
      ( v42165(VarCurr)
    <=> v42167(VarCurr) ) ).

tff(addAssignment_21062,axiom,
    ! [VarCurr: state_type] :
      ( v42167(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_21061,axiom,
    ! [VarCurr: state_type] :
      ( v42147(VarCurr)
    <=> v42149(VarCurr) ) ).

tff(addAssignment_21060,axiom,
    ! [VarCurr: state_type] :
      ( v42149(VarCurr)
    <=> v42151(VarCurr) ) ).

tff(addAssignment_21059,axiom,
    ! [VarCurr: state_type] :
      ( v42151(VarCurr)
    <=> v42153(VarCurr) ) ).

tff(addAssignment_21058,axiom,
    ! [VarCurr: state_type] :
      ( v42153(VarCurr)
    <=> v42155(VarCurr) ) ).

tff(addAssignment_21057,axiom,
    ! [VarCurr: state_type] :
      ( v42155(VarCurr)
    <=> v42157(VarCurr) ) ).

tff(addAssignment_21056,axiom,
    ! [VarCurr: state_type] :
      ( v42157(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_21055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41655(VarCurr,B)
      <=> v41657(VarCurr,B) ) ) ).

tff(addAssignment_21054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41657(VarCurr,B)
      <=> v41659(VarCurr,B) ) ) ).

tff(addAssignment_21053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41659(VarCurr,B)
      <=> v41661(VarCurr,B) ) ) ).

tff(addAssignment_21052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41661(VarCurr,B)
      <=> v41663(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42108(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41663(VarNext,B)
            <=> v41663(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_493,axiom,
    ! [VarNext: state_type] :
      ( v42108(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41663(VarNext,B)
          <=> v42118(VarNext,B) ) ) ) ).

tff(addAssignment_21051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42118(VarNext,B)
          <=> v42116(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42119(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42116(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_338,axiom,
    ! [VarCurr: state_type] :
      ( v42119(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42116(VarCurr,B)
          <=> v41693(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4002,axiom,
    ! [VarCurr: state_type] :
      ( v42119(VarCurr)
    <=> ( v42120(VarCurr)
        & v42121(VarCurr) ) ) ).

tff(writeUnaryOperator_2459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42121(VarCurr)
    <=> v41679(VarCurr) ) ).

tff(writeUnaryOperator_2458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42120(VarCurr)
    <=> v41665(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42108(VarNext)
      <=> v42109(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42109(VarNext)
      <=> ( v42110(VarNext)
          & v42023(VarNext) ) ) ) ).

tff(writeUnaryOperator_2457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42110(VarNext)
      <=> v42112(VarNext) ) ) ).

tff(addAssignment_21050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42112(VarNext)
      <=> v42023(VarCurr) ) ) ).

tff(addAssignment_21049,axiom,
    ! [VarCurr: state_type] :
      ( v42023(VarCurr)
    <=> v42025(VarCurr) ) ).

tff(addAssignment_21048,axiom,
    ! [VarCurr: state_type] :
      ( v42025(VarCurr)
    <=> v42027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3999,axiom,
    ! [VarCurr: state_type] :
      ( v42027(VarCurr)
    <=> ( v42105(VarCurr)
        | v42097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3998,axiom,
    ! [VarCurr: state_type] :
      ( v42105(VarCurr)
    <=> ( v42029(VarCurr)
        & v42035(VarCurr) ) ) ).

tff(addAssignment_21047,axiom,
    ! [VarCurr: state_type] :
      ( v42097(VarCurr)
    <=> v42099(VarCurr) ) ).

tff(addAssignment_21046,axiom,
    ! [VarCurr: state_type] :
      ( v42099(VarCurr)
    <=> v42101(VarCurr) ) ).

tff(addAssignment_21045,axiom,
    ! [VarCurr: state_type] :
      ( v42101(VarCurr)
    <=> v42103(VarCurr) ) ).

tff(addAssignment_21044,axiom,
    ! [VarCurr: state_type] :
      ( v42103(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v42081(VarNext)
       => ( v42035(VarNext)
        <=> v42035(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_492,axiom,
    ! [VarNext: state_type] :
      ( v42081(VarNext)
     => ( v42035(VarNext)
      <=> v42091(VarNext) ) ) ).

tff(addAssignment_21043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42091(VarNext)
      <=> v42089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3997,axiom,
    ! [VarCurr: state_type] :
      ( v42089(VarCurr)
    <=> ( v42092(VarCurr)
        & v42093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3996,axiom,
    ! [VarCurr: state_type] :
      ( v42093(VarCurr)
    <=> ( v42041(VarCurr)
        | v42072(VarCurr) ) ) ).

tff(writeUnaryOperator_2456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42092(VarCurr)
    <=> v42037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42081(VarNext)
      <=> v42082(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42082(VarNext)
      <=> ( v42084(VarNext)
          & v42086(VarNext) ) ) ) ).

tff(writeUnaryOperator_2455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42086(VarCurr)
    <=> v42029(VarCurr) ) ).

tff(addAssignment_21042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v42084(VarNext)
      <=> v42029(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_175,axiom,
    ( v42035(constB0)
  <=> $true ) ).

tff(addAssignment_21041,axiom,
    ! [VarCurr: state_type] :
      ( v42072(VarCurr)
    <=> v42074(VarCurr) ) ).

tff(addAssignment_21040,axiom,
    ! [VarCurr: state_type] :
      ( v42074(VarCurr)
    <=> v42076(VarCurr) ) ).

tff(addAssignment_21039,axiom,
    ! [VarCurr: state_type] :
      ( v42076(VarCurr)
    <=> v42078(VarCurr) ) ).

tff(addAssignment_21038,axiom,
    ! [VarCurr: state_type] :
      ( v42078(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_21037,axiom,
    ! [VarCurr: state_type] :
      ( v42041(VarCurr)
    <=> v42043(VarCurr) ) ).

tff(addAssignment_21036,axiom,
    ! [VarCurr: state_type] :
      ( v42043(VarCurr)
    <=> v42045(VarCurr) ) ).

tff(addAssignment_21035,axiom,
    ! [VarCurr: state_type] :
      ( v42045(VarCurr)
    <=> v42047(VarCurr) ) ).

tff(addAssignment_21034,axiom,
    ! [VarCurr: state_type] :
      ( v42047(VarCurr)
    <=> v42049(VarCurr) ) ).

tff(writeUnaryOperator_2454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42049(VarCurr)
    <=> v42069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3993,axiom,
    ! [VarCurr: state_type] :
      ( v42069(VarCurr)
    <=> ( v42070(VarCurr)
        | v42065(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3992,axiom,
    ! [VarCurr: state_type] :
      ( v42070(VarCurr)
    <=> ( v42051(VarCurr)
        | v42061(VarCurr) ) ) ).

tff(addAssignment_21033,axiom,
    ! [VarCurr: state_type] :
      ( v42065(VarCurr)
    <=> v42067(VarCurr) ) ).

tff(addAssignment_21032,axiom,
    ! [VarCurr: state_type] :
      ( v42067(VarCurr)
    <=> v42055(VarCurr,2) ) ).

tff(addAssignment_21031,axiom,
    ! [VarCurr: state_type] :
      ( v42055(VarCurr,2)
    <=> v42057(VarCurr,2) ) ).

tff(addAssignment_21030,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,2)
    <=> v42059(VarCurr,2) ) ).

tff(addAssignment_21029,axiom,
    ! [VarCurr: state_type] :
      ( v42061(VarCurr)
    <=> v42063(VarCurr) ) ).

tff(addAssignment_21028,axiom,
    ! [VarCurr: state_type] :
      ( v42063(VarCurr)
    <=> v42055(VarCurr,1) ) ).

tff(addAssignment_21027,axiom,
    ! [VarCurr: state_type] :
      ( v42055(VarCurr,1)
    <=> v42057(VarCurr,1) ) ).

tff(addAssignment_21026,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,1)
    <=> v42059(VarCurr,1) ) ).

tff(addAssignment_21025,axiom,
    ! [VarCurr: state_type] :
      ( v42051(VarCurr)
    <=> v42053(VarCurr) ) ).

tff(addAssignment_21024,axiom,
    ! [VarCurr: state_type] :
      ( v42053(VarCurr)
    <=> v42055(VarCurr,0) ) ).

tff(addAssignment_21023,axiom,
    ! [VarCurr: state_type] :
      ( v42055(VarCurr,0)
    <=> v42057(VarCurr,0) ) ).

tff(addAssignment_21022,axiom,
    ! [VarCurr: state_type] :
      ( v42057(VarCurr,0)
    <=> v42059(VarCurr,0) ) ).

tff(addAssignment_21021,axiom,
    ! [VarCurr: state_type] :
      ( v42037(VarCurr)
    <=> v42039(VarCurr) ) ).

tff(addAssignment_21020,axiom,
    ! [VarCurr: state_type] :
      ( v42039(VarCurr)
    <=> $false ) ).

tff(addAssignment_21019,axiom,
    ! [VarCurr: state_type] :
      ( v42029(VarCurr)
    <=> v42031(VarCurr) ) ).

tff(addAssignment_21018,axiom,
    ! [VarCurr: state_type] :
      ( v42031(VarCurr)
    <=> v42033(VarCurr) ) ).

tff(addAssignment_21017,axiom,
    ! [VarCurr: state_type] :
      ( v42033(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_21016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41693(VarCurr,B)
      <=> v41695(VarCurr,B) ) ) ).

tff(addAssignment_21015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41695(VarCurr,B)
      <=> v41697(VarCurr,B) ) ) ).

tff(addAssignment_21014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41697(VarCurr,B)
      <=> v41699(VarCurr,B) ) ) ).

tff(addAssignment_21013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41699(VarCurr,B)
      <=> v41701(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_677,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41701(VarCurr,B)
      <=> ( v41703(VarCurr,B)
          & v41725(VarCurr,B) ) ) ) ).

tff(addAssignment_21012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41725(VarCurr,B)
      <=> v41727(VarCurr,B) ) ) ).

tff(addAssignment_21011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41727(VarCurr,B)
      <=> v41729(VarCurr,B) ) ) ).

tff(addAssignment_21010,axiom,
    ! [VarCurr: state_type] :
      ( ( v41729(VarCurr,11)
      <=> v6324(VarCurr,95) )
      & ( v41729(VarCurr,10)
      <=> v6324(VarCurr,94) )
      & ( v41729(VarCurr,9)
      <=> v6324(VarCurr,93) )
      & ( v41729(VarCurr,8)
      <=> v6324(VarCurr,92) )
      & ( v41729(VarCurr,7)
      <=> v6324(VarCurr,91) )
      & ( v41729(VarCurr,6)
      <=> v6324(VarCurr,90) )
      & ( v41729(VarCurr,5)
      <=> v6324(VarCurr,89) )
      & ( v41729(VarCurr,4)
      <=> v6324(VarCurr,88) )
      & ( v41729(VarCurr,3)
      <=> v6324(VarCurr,87) )
      & ( v41729(VarCurr,2)
      <=> v6324(VarCurr,86) )
      & ( v41729(VarCurr,1)
      <=> v6324(VarCurr,85) )
      & ( v41729(VarCurr,0)
      <=> v6324(VarCurr,84) ) ) ).

tff(addAssignment_21009,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,95)
      <=> v41731(VarCurr,11) )
      & ( v6324(VarCurr,94)
      <=> v41731(VarCurr,10) )
      & ( v6324(VarCurr,93)
      <=> v41731(VarCurr,9) )
      & ( v6324(VarCurr,92)
      <=> v41731(VarCurr,8) )
      & ( v6324(VarCurr,91)
      <=> v41731(VarCurr,7) )
      & ( v6324(VarCurr,90)
      <=> v41731(VarCurr,6) )
      & ( v6324(VarCurr,89)
      <=> v41731(VarCurr,5) )
      & ( v6324(VarCurr,88)
      <=> v41731(VarCurr,4) )
      & ( v6324(VarCurr,87)
      <=> v41731(VarCurr,3) )
      & ( v6324(VarCurr,86)
      <=> v41731(VarCurr,2) )
      & ( v6324(VarCurr,85)
      <=> v41731(VarCurr,1) )
      & ( v6324(VarCurr,84)
      <=> v41731(VarCurr,0) ) ) ).

tff(addAssignment_21008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41731(VarCurr,B)
      <=> v41733(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_676,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41733(VarCurr,B)
      <=> ( v42015(VarCurr,B)
          | v42018(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42018(VarCurr,B)
      <=> ( v41743(VarCurr,B)
          & v42019(VarCurr,B) ) ) ) ).

tff(addAssignment_21007,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,0)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21006,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,1)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21005,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,2)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21004,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,3)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21003,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,4)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21002,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,5)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21001,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,6)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_21000,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,7)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_20999,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,8)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_20998,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,9)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_20997,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,10)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_20996,axiom,
    ! [VarCurr: state_type] :
      ( v42019(VarCurr,11)
    <=> v42020(VarCurr) ) ).

tff(addAssignment_20995,axiom,
    ! [VarCurr: state_type] :
      ( v42020(VarCurr)
    <=> v42011(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v42015(VarCurr,B)
      <=> ( v41735(VarCurr,B)
          & v42016(VarCurr,B) ) ) ) ).

tff(addAssignment_20994,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,0)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20993,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,1)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20992,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,2)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20991,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,3)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20990,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,4)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20989,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,5)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20988,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,6)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20987,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,7)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20986,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,8)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20985,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,9)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20984,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,10)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20983,axiom,
    ! [VarCurr: state_type] :
      ( v42016(VarCurr,11)
    <=> v42017(VarCurr) ) ).

tff(addAssignment_20982,axiom,
    ! [VarCurr: state_type] :
      ( v42017(VarCurr)
    <=> v41739(VarCurr) ) ).

tff(addAssignment_20981,axiom,
    ! [VarCurr: state_type] :
      ( v42011(VarCurr)
    <=> v42013(VarCurr) ) ).

tff(addAssignment_20980,axiom,
    ! [VarCurr: state_type] :
      ( v42013(VarCurr)
    <=> v7021(VarCurr,7) ) ).

tff(addAssignment_20979,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,7)
    <=> v7023(VarCurr,7) ) ).

tff(addAssignment_20978,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,7)
    <=> v6623(VarCurr,7) ) ).

tff(addAssignment_20977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41743(VarCurr,B)
      <=> v41745(VarCurr,B) ) ) ).

tff(addAssignment_20976,axiom,
    ! [VarCurr: state_type] :
      ( ( v41745(VarCurr,11)
      <=> v6334(VarCurr,107) )
      & ( v41745(VarCurr,10)
      <=> v6334(VarCurr,106) )
      & ( v41745(VarCurr,9)
      <=> v6334(VarCurr,105) )
      & ( v41745(VarCurr,8)
      <=> v6334(VarCurr,104) )
      & ( v41745(VarCurr,7)
      <=> v6334(VarCurr,103) )
      & ( v41745(VarCurr,6)
      <=> v6334(VarCurr,102) )
      & ( v41745(VarCurr,5)
      <=> v6334(VarCurr,101) )
      & ( v41745(VarCurr,4)
      <=> v6334(VarCurr,100) )
      & ( v41745(VarCurr,3)
      <=> v6334(VarCurr,99) )
      & ( v41745(VarCurr,2)
      <=> v6334(VarCurr,98) )
      & ( v41745(VarCurr,1)
      <=> v6334(VarCurr,97) )
      & ( v41745(VarCurr,0)
      <=> v6334(VarCurr,96) ) ) ).

tff(addAssignment_20975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,108)
        & ~ $less(B,96) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_20974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,108)
        & ~ $less(B,96) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_20973,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,107)
      <=> v41747(VarCurr,11) )
      & ( v6338(VarCurr,106)
      <=> v41747(VarCurr,10) )
      & ( v6338(VarCurr,105)
      <=> v41747(VarCurr,9) )
      & ( v6338(VarCurr,104)
      <=> v41747(VarCurr,8) )
      & ( v6338(VarCurr,103)
      <=> v41747(VarCurr,7) )
      & ( v6338(VarCurr,102)
      <=> v41747(VarCurr,6) )
      & ( v6338(VarCurr,101)
      <=> v41747(VarCurr,5) )
      & ( v6338(VarCurr,100)
      <=> v41747(VarCurr,4) )
      & ( v6338(VarCurr,99)
      <=> v41747(VarCurr,3) )
      & ( v6338(VarCurr,98)
      <=> v41747(VarCurr,2) )
      & ( v6338(VarCurr,97)
      <=> v41747(VarCurr,1) )
      & ( v6338(VarCurr,96)
      <=> v41747(VarCurr,0) ) ) ).

tff(addAssignment_20972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41747(VarCurr,B)
      <=> v41749(VarCurr,B) ) ) ).

tff(addAssignment_20971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41749(VarCurr,B)
      <=> v41751(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41994(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41751(VarNext,B)
            <=> v41751(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_491,axiom,
    ! [VarNext: state_type] :
      ( v41994(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41751(VarNext,B)
          <=> v42004(VarNext,B) ) ) ) ).

tff(addAssignment_20970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42004(VarNext,B)
          <=> v42002(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42002(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_337,axiom,
    ! [VarCurr: state_type] :
      ( v42005(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v42002(VarCurr,B)
          <=> v41781(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3991,axiom,
    ! [VarCurr: state_type] :
      ( v42005(VarCurr)
    <=> ( v42006(VarCurr)
        & v42007(VarCurr) ) ) ).

tff(writeUnaryOperator_2453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42007(VarCurr)
    <=> v41767(VarCurr) ) ).

tff(writeUnaryOperator_2452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v42006(VarCurr)
    <=> v41753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41994(VarNext)
      <=> v41995(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41995(VarNext)
      <=> ( v41996(VarNext)
          & v41969(VarNext) ) ) ) ).

tff(writeUnaryOperator_2451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41996(VarNext)
      <=> v41998(VarNext) ) ) ).

tff(addAssignment_20969,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41998(VarNext)
      <=> v41969(VarCurr) ) ) ).

tff(addAssignment_20968,axiom,
    ! [VarCurr: state_type] :
      ( v41969(VarCurr)
    <=> v41971(VarCurr) ) ).

tff(addAssignment_20967,axiom,
    ! [VarCurr: state_type] :
      ( v41971(VarCurr)
    <=> v41973(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3988,axiom,
    ! [VarCurr: state_type] :
      ( v41973(VarCurr)
    <=> ( v41991(VarCurr)
        | v41983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3987,axiom,
    ! [VarCurr: state_type] :
      ( v41991(VarCurr)
    <=> ( v41975(VarCurr)
        & v41981(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_174,axiom,
    ( v41981(constB0)
  <=> $true ) ).

tff(addAssignment_20966,axiom,
    ! [VarCurr: state_type] :
      ( v41983(VarCurr)
    <=> v41985(VarCurr) ) ).

tff(addAssignment_20965,axiom,
    ! [VarCurr: state_type] :
      ( v41985(VarCurr)
    <=> v41987(VarCurr) ) ).

tff(addAssignment_20964,axiom,
    ! [VarCurr: state_type] :
      ( v41987(VarCurr)
    <=> v41989(VarCurr) ) ).

tff(addAssignment_20963,axiom,
    ! [VarCurr: state_type] :
      ( v41989(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_20962,axiom,
    ! [VarCurr: state_type] :
      ( v41975(VarCurr)
    <=> v41977(VarCurr) ) ).

tff(addAssignment_20961,axiom,
    ! [VarCurr: state_type] :
      ( v41977(VarCurr)
    <=> v41979(VarCurr) ) ).

tff(addAssignment_20960,axiom,
    ! [VarCurr: state_type] :
      ( v41979(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_20959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41781(VarCurr,B)
      <=> v41783(VarCurr,B) ) ) ).

tff(addAssignment_20958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41783(VarCurr,B)
      <=> v41785(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41785(VarCurr,B)
      <=> ( v41954(VarCurr,B)
          | v41965(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41965(VarCurr,B)
      <=> ( v41918(VarCurr,B)
          & v41966(VarCurr,B) ) ) ) ).

tff(addAssignment_20957,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,0)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20956,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,1)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20955,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,2)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20954,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,3)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20953,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,4)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20952,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,5)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20951,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,6)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20950,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,7)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20949,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,8)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20948,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,9)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20947,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,10)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20946,axiom,
    ! [VarCurr: state_type] :
      ( v41966(VarCurr,11)
    <=> v41967(VarCurr) ) ).

tff(addAssignment_20945,axiom,
    ! [VarCurr: state_type] :
      ( v41967(VarCurr)
    <=> v41928(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_671,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41954(VarCurr,B)
      <=> ( v41955(VarCurr,B)
          | v41962(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_670,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41962(VarCurr,B)
      <=> ( v41882(VarCurr,B)
          & v41963(VarCurr,B) ) ) ) ).

tff(addAssignment_20944,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,0)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20943,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,1)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20942,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,2)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20941,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,3)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20940,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,4)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20939,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,5)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20938,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,6)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20937,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,7)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20936,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,8)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20935,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,9)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20934,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,10)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20933,axiom,
    ! [VarCurr: state_type] :
      ( v41963(VarCurr,11)
    <=> v41964(VarCurr) ) ).

tff(addAssignment_20932,axiom,
    ! [VarCurr: state_type] :
      ( v41964(VarCurr)
    <=> v41892(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_669,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41955(VarCurr,B)
      <=> ( v41956(VarCurr,B)
          | v41959(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41959(VarCurr,B)
      <=> ( v41835(VarCurr,B)
          & v41960(VarCurr,B) ) ) ) ).

tff(addAssignment_20931,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,0)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20930,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,1)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20929,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,2)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20928,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,3)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20927,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,4)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20926,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,5)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20925,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,6)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20924,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,7)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20923,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,8)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20922,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,9)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20921,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,10)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20920,axiom,
    ! [VarCurr: state_type] :
      ( v41960(VarCurr,11)
    <=> v41961(VarCurr) ) ).

tff(addAssignment_20919,axiom,
    ! [VarCurr: state_type] :
      ( v41961(VarCurr)
    <=> v41845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41956(VarCurr,B)
      <=> ( v41787(VarCurr,B)
          & v41957(VarCurr,B) ) ) ) ).

tff(addAssignment_20918,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,0)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20917,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,1)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20916,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,2)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20915,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,3)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20914,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,4)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20913,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,5)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20912,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,6)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20911,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,7)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20910,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,8)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20909,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,9)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20908,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,10)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20907,axiom,
    ! [VarCurr: state_type] :
      ( v41957(VarCurr,11)
    <=> v41958(VarCurr) ) ).

tff(addAssignment_20906,axiom,
    ! [VarCurr: state_type] :
      ( v41958(VarCurr)
    <=> v41797(VarCurr) ) ).

tff(addAssignment_20905,axiom,
    ! [VarCurr: state_type] :
      ( v41928(VarCurr)
    <=> v41930(VarCurr) ) ).

tff(addAssignment_20904,axiom,
    ! [VarCurr: state_type] :
      ( v41930(VarCurr)
    <=> v41932(VarCurr) ) ).

tff(addAssignment_20903,axiom,
    ! [VarCurr: state_type] :
      ( v41932(VarCurr)
    <=> v41934(VarCurr) ) ).

tff(addAssignment_20902,axiom,
    ! [VarCurr: state_type] :
      ( v41934(VarCurr)
    <=> v41936(VarCurr) ) ).

tff(addAssignment_20901,axiom,
    ! [VarCurr: state_type] :
      ( v41936(VarCurr)
    <=> v41938(VarCurr) ) ).

tff(addAssignment_20900,axiom,
    ! [VarCurr: state_type] :
      ( v41938(VarCurr)
    <=> v41940(VarCurr) ) ).

tff(addAssignment_20899,axiom,
    ! [VarCurr: state_type] :
      ( v41940(VarCurr)
    <=> v41942(VarCurr) ) ).

tff(writeUnaryOperator_2450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41942(VarCurr)
    <=> v41952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3986,axiom,
    ! [VarCurr: state_type] :
      ( v41952(VarCurr)
    <=> ( v41944(VarCurr)
        | v41948(VarCurr) ) ) ).

tff(addAssignment_20898,axiom,
    ! [VarCurr: state_type] :
      ( v41948(VarCurr)
    <=> v41950(VarCurr) ) ).

tff(addAssignment_20897,axiom,
    ! [VarCurr: state_type] :
      ( v41950(VarCurr)
    <=> v41865(VarCurr,1) ) ).

tff(addAssignment_20896,axiom,
    ! [VarCurr: state_type] :
      ( v41944(VarCurr)
    <=> v41946(VarCurr) ) ).

tff(addAssignment_20895,axiom,
    ! [VarCurr: state_type] :
      ( v41946(VarCurr)
    <=> v41865(VarCurr,0) ) ).

tff(addAssignment_20894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41918(VarCurr,B)
      <=> v41920(VarCurr,B) ) ) ).

tff(addAssignment_20893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41920(VarCurr,B)
      <=> v41922(VarCurr,B) ) ) ).

tff(addAssignment_20892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41922(VarCurr,B)
      <=> v41924(VarCurr,B) ) ) ).

tff(addAssignment_20891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41924(VarCurr,B)
      <=> v41926(VarCurr,B) ) ) ).

tff(addAssignment_20890,axiom,
    ! [VarCurr: state_type] :
      ( v41892(VarCurr)
    <=> v41894(VarCurr) ) ).

tff(addAssignment_20889,axiom,
    ! [VarCurr: state_type] :
      ( v41894(VarCurr)
    <=> v41896(VarCurr) ) ).

tff(addAssignment_20888,axiom,
    ! [VarCurr: state_type] :
      ( v41896(VarCurr)
    <=> v41898(VarCurr) ) ).

tff(addAssignment_20887,axiom,
    ! [VarCurr: state_type] :
      ( v41898(VarCurr)
    <=> v41900(VarCurr) ) ).

tff(addAssignment_20886,axiom,
    ! [VarCurr: state_type] :
      ( v41900(VarCurr)
    <=> v41902(VarCurr) ) ).

tff(addAssignment_20885,axiom,
    ! [VarCurr: state_type] :
      ( v41902(VarCurr)
    <=> v41904(VarCurr) ) ).

tff(addAssignment_20884,axiom,
    ! [VarCurr: state_type] :
      ( v41904(VarCurr)
    <=> v41906(VarCurr) ) ).

tff(writeUnaryOperator_2449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41906(VarCurr)
    <=> v41916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3985,axiom,
    ! [VarCurr: state_type] :
      ( v41916(VarCurr)
    <=> ( v41908(VarCurr)
        | v41912(VarCurr) ) ) ).

tff(addAssignment_20883,axiom,
    ! [VarCurr: state_type] :
      ( v41912(VarCurr)
    <=> v41914(VarCurr) ) ).

tff(addAssignment_20882,axiom,
    ! [VarCurr: state_type] :
      ( v41914(VarCurr)
    <=> v41865(VarCurr,1) ) ).

tff(addAssignment_20881,axiom,
    ! [VarCurr: state_type] :
      ( v41865(VarCurr,1)
    <=> v41867(VarCurr,1) ) ).

tff(addAssignment_20880,axiom,
    ! [VarCurr: state_type] :
      ( v41867(VarCurr,1)
    <=> v41869(VarCurr,1) ) ).

tff(addAssignment_20879,axiom,
    ! [VarCurr: state_type] :
      ( v41869(VarCurr,1)
    <=> v41874(VarCurr,1) ) ).

tff(addAssignment_20878,axiom,
    ! [VarCurr: state_type] :
      ( v41871(VarCurr,1)
    <=> v41873(VarCurr,1) ) ).

tff(addAssignment_20877,axiom,
    ! [VarCurr: state_type] :
      ( v41873(VarCurr,1)
    <=> v41817(VarCurr,1) ) ).

tff(addAssignment_20876,axiom,
    ! [VarCurr: state_type] :
      ( v41908(VarCurr)
    <=> v41910(VarCurr) ) ).

tff(addAssignment_20875,axiom,
    ! [VarCurr: state_type] :
      ( v41910(VarCurr)
    <=> v41817(VarCurr,0) ) ).

tff(addAssignment_20874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41882(VarCurr,B)
      <=> v41884(VarCurr,B) ) ) ).

tff(addAssignment_20873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41884(VarCurr,B)
      <=> v41886(VarCurr,B) ) ) ).

tff(addAssignment_20872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41886(VarCurr,B)
      <=> v41888(VarCurr,B) ) ) ).

tff(addAssignment_20871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41888(VarCurr,B)
      <=> v41890(VarCurr,B) ) ) ).

tff(addAssignment_20870,axiom,
    ! [VarCurr: state_type] :
      ( v41845(VarCurr)
    <=> v41847(VarCurr) ) ).

tff(addAssignment_20869,axiom,
    ! [VarCurr: state_type] :
      ( v41847(VarCurr)
    <=> v41849(VarCurr) ) ).

tff(addAssignment_20868,axiom,
    ! [VarCurr: state_type] :
      ( v41849(VarCurr)
    <=> v41851(VarCurr) ) ).

tff(addAssignment_20867,axiom,
    ! [VarCurr: state_type] :
      ( v41851(VarCurr)
    <=> v41853(VarCurr) ) ).

tff(addAssignment_20866,axiom,
    ! [VarCurr: state_type] :
      ( v41853(VarCurr)
    <=> v41855(VarCurr) ) ).

tff(addAssignment_20865,axiom,
    ! [VarCurr: state_type] :
      ( v41855(VarCurr)
    <=> v41857(VarCurr) ) ).

tff(addAssignment_20864,axiom,
    ! [VarCurr: state_type] :
      ( v41857(VarCurr)
    <=> v41859(VarCurr) ) ).

tff(writeUnaryOperator_2448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41859(VarCurr)
    <=> v41880(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3984,axiom,
    ! [VarCurr: state_type] :
      ( v41880(VarCurr)
    <=> ( v41861(VarCurr)
        | v41876(VarCurr) ) ) ).

tff(addAssignment_20863,axiom,
    ! [VarCurr: state_type] :
      ( v41876(VarCurr)
    <=> v41878(VarCurr) ) ).

tff(addAssignment_20862,axiom,
    ! [VarCurr: state_type] :
      ( v41878(VarCurr)
    <=> v41817(VarCurr,1) ) ).

tff(addAssignment_20861,axiom,
    ! [VarCurr: state_type] :
      ( v41861(VarCurr)
    <=> v41863(VarCurr) ) ).

tff(addAssignment_20860,axiom,
    ! [VarCurr: state_type] :
      ( v41863(VarCurr)
    <=> v41865(VarCurr,0) ) ).

tff(addAssignment_20859,axiom,
    ! [VarCurr: state_type] :
      ( v41865(VarCurr,0)
    <=> v41867(VarCurr,0) ) ).

tff(addAssignment_20858,axiom,
    ! [VarCurr: state_type] :
      ( v41867(VarCurr,0)
    <=> v41869(VarCurr,0) ) ).

tff(addAssignment_20857,axiom,
    ! [VarCurr: state_type] :
      ( v41869(VarCurr,0)
    <=> v41874(VarCurr,0) ) ).

tff(writeUnaryOperator_2447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v41874(VarCurr,B)
      <=> ~ v41871(VarCurr,B) ) ) ).

tff(addAssignment_20856,axiom,
    ! [VarCurr: state_type] :
      ( v41871(VarCurr,0)
    <=> v41873(VarCurr,0) ) ).

tff(addAssignment_20855,axiom,
    ! [VarCurr: state_type] :
      ( v41873(VarCurr,0)
    <=> v41817(VarCurr,0) ) ).

tff(addAssignment_20854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41835(VarCurr,B)
      <=> v41837(VarCurr,B) ) ) ).

tff(addAssignment_20853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41837(VarCurr,B)
      <=> v41839(VarCurr,B) ) ) ).

tff(addAssignment_20852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41839(VarCurr,B)
      <=> v41841(VarCurr,B) ) ) ).

tff(addAssignment_20851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41841(VarCurr,B)
      <=> v41843(VarCurr,B) ) ) ).

tff(addAssignment_20850,axiom,
    ! [VarCurr: state_type] :
      ( v41797(VarCurr)
    <=> v41799(VarCurr) ) ).

tff(addAssignment_20849,axiom,
    ! [VarCurr: state_type] :
      ( v41799(VarCurr)
    <=> v41801(VarCurr) ) ).

tff(addAssignment_20848,axiom,
    ! [VarCurr: state_type] :
      ( v41801(VarCurr)
    <=> v41803(VarCurr) ) ).

tff(addAssignment_20847,axiom,
    ! [VarCurr: state_type] :
      ( v41803(VarCurr)
    <=> v41805(VarCurr) ) ).

tff(addAssignment_20846,axiom,
    ! [VarCurr: state_type] :
      ( v41805(VarCurr)
    <=> v41807(VarCurr) ) ).

tff(addAssignment_20845,axiom,
    ! [VarCurr: state_type] :
      ( v41807(VarCurr)
    <=> v41809(VarCurr) ) ).

tff(addAssignment_20844,axiom,
    ! [VarCurr: state_type] :
      ( v41809(VarCurr)
    <=> v41811(VarCurr) ) ).

tff(writeUnaryOperator_2446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41811(VarCurr)
    <=> v41833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3983,axiom,
    ! [VarCurr: state_type] :
      ( v41833(VarCurr)
    <=> ( v41813(VarCurr)
        | v41829(VarCurr) ) ) ).

tff(addAssignment_20843,axiom,
    ! [VarCurr: state_type] :
      ( v41829(VarCurr)
    <=> v41831(VarCurr) ) ).

tff(addAssignment_20842,axiom,
    ! [VarCurr: state_type] :
      ( v41831(VarCurr)
    <=> v41817(VarCurr,1) ) ).

tff(addAssignment_20841,axiom,
    ! [VarCurr: state_type] :
      ( v41817(VarCurr,1)
    <=> v41819(VarCurr,1) ) ).

tff(addAssignment_20840,axiom,
    ! [VarCurr: state_type] :
      ( v41819(VarCurr,1)
    <=> v41821(VarCurr,1) ) ).

tff(addAssignment_20839,axiom,
    ! [VarCurr: state_type] :
      ( v41821(VarCurr,1)
    <=> v41823(VarCurr,1) ) ).

tff(addAssignment_20838,axiom,
    ! [VarCurr: state_type] :
      ( v41823(VarCurr,1)
    <=> v41825(VarCurr,1) ) ).

tff(addAssignment_20837,axiom,
    ! [VarCurr: state_type] :
      ( v41825(VarCurr,1)
    <=> v41827(VarCurr,1) ) ).

tff(addAssignment_20836,axiom,
    ! [VarCurr: state_type] :
      ( v41813(VarCurr)
    <=> v41815(VarCurr) ) ).

tff(addAssignment_20835,axiom,
    ! [VarCurr: state_type] :
      ( v41815(VarCurr)
    <=> v41817(VarCurr,0) ) ).

tff(addAssignment_20834,axiom,
    ! [VarCurr: state_type] :
      ( v41817(VarCurr,0)
    <=> v41819(VarCurr,0) ) ).

tff(addAssignment_20833,axiom,
    ! [VarCurr: state_type] :
      ( v41819(VarCurr,0)
    <=> v41821(VarCurr,0) ) ).

tff(addAssignment_20832,axiom,
    ! [VarCurr: state_type] :
      ( v41821(VarCurr,0)
    <=> v41823(VarCurr,0) ) ).

tff(addAssignment_20831,axiom,
    ! [VarCurr: state_type] :
      ( v41823(VarCurr,0)
    <=> v41825(VarCurr,0) ) ).

tff(addAssignment_20830,axiom,
    ! [VarCurr: state_type] :
      ( v41825(VarCurr,0)
    <=> v41827(VarCurr,0) ) ).

tff(addAssignment_20829,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41787(VarCurr,B)
      <=> v41789(VarCurr,B) ) ) ).

tff(addAssignment_20828,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41789(VarCurr,B)
      <=> v41791(VarCurr,B) ) ) ).

tff(addAssignment_20827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41791(VarCurr,B)
      <=> v41793(VarCurr,B) ) ) ).

tff(addAssignment_20826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41793(VarCurr,B)
      <=> v41795(VarCurr,B) ) ) ).

tff(addAssignment_20825,axiom,
    ! [VarCurr: state_type] :
      ( v41767(VarCurr)
    <=> v41769(VarCurr) ) ).

tff(addAssignment_20824,axiom,
    ! [VarCurr: state_type] :
      ( v41769(VarCurr)
    <=> v41771(VarCurr) ) ).

tff(addAssignment_20823,axiom,
    ! [VarCurr: state_type] :
      ( v41771(VarCurr)
    <=> v41773(VarCurr) ) ).

tff(addAssignment_20822,axiom,
    ! [VarCurr: state_type] :
      ( v41773(VarCurr)
    <=> v41775(VarCurr) ) ).

tff(addAssignment_20821,axiom,
    ! [VarCurr: state_type] :
      ( v41775(VarCurr)
    <=> v41777(VarCurr) ) ).

tff(addAssignment_20820,axiom,
    ! [VarCurr: state_type] :
      ( v41777(VarCurr)
    <=> v41779(VarCurr) ) ).

tff(addAssignment_20819,axiom,
    ! [VarCurr: state_type] :
      ( v41779(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_20818,axiom,
    ! [VarCurr: state_type] :
      ( v41753(VarCurr)
    <=> v41755(VarCurr) ) ).

tff(addAssignment_20817,axiom,
    ! [VarCurr: state_type] :
      ( v41755(VarCurr)
    <=> v41757(VarCurr) ) ).

tff(addAssignment_20816,axiom,
    ! [VarCurr: state_type] :
      ( v41757(VarCurr)
    <=> v41759(VarCurr) ) ).

tff(addAssignment_20815,axiom,
    ! [VarCurr: state_type] :
      ( v41759(VarCurr)
    <=> v41761(VarCurr) ) ).

tff(addAssignment_20814,axiom,
    ! [VarCurr: state_type] :
      ( v41761(VarCurr)
    <=> v41763(VarCurr) ) ).

tff(addAssignment_20813,axiom,
    ! [VarCurr: state_type] :
      ( v41763(VarCurr)
    <=> v41765(VarCurr) ) ).

tff(addAssignment_20812,axiom,
    ! [VarCurr: state_type] :
      ( v41765(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_20811,axiom,
    ! [VarCurr: state_type] :
      ( v41739(VarCurr)
    <=> v41741(VarCurr) ) ).

tff(addAssignment_20810,axiom,
    ! [VarCurr: state_type] :
      ( v41741(VarCurr)
    <=> v6617(VarCurr,7) ) ).

tff(addAssignment_20809,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,7)
    <=> v6619(VarCurr,7) ) ).

tff(addAssignment_20808,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,7)
    <=> v6621(VarCurr,7) ) ).

tff(addAssignment_20807,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,7)
    <=> v6747(VarCurr,7) ) ).

tff(addAssignment_20806,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,7)
    <=> v6690(VarCurr,7) ) ).

tff(addAssignment_20805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41735(VarCurr,B)
      <=> v41737(VarCurr,B) ) ) ).

tff(addAssignment_20804,axiom,
    ! [VarCurr: state_type] :
      ( ( v41737(VarCurr,11)
      <=> v6334(VarCurr,95) )
      & ( v41737(VarCurr,10)
      <=> v6334(VarCurr,94) )
      & ( v41737(VarCurr,9)
      <=> v6334(VarCurr,93) )
      & ( v41737(VarCurr,8)
      <=> v6334(VarCurr,92) )
      & ( v41737(VarCurr,7)
      <=> v6334(VarCurr,91) )
      & ( v41737(VarCurr,6)
      <=> v6334(VarCurr,90) )
      & ( v41737(VarCurr,5)
      <=> v6334(VarCurr,89) )
      & ( v41737(VarCurr,4)
      <=> v6334(VarCurr,88) )
      & ( v41737(VarCurr,3)
      <=> v6334(VarCurr,87) )
      & ( v41737(VarCurr,2)
      <=> v6334(VarCurr,86) )
      & ( v41737(VarCurr,1)
      <=> v6334(VarCurr,85) )
      & ( v41737(VarCurr,0)
      <=> v6334(VarCurr,84) ) ) ).

tff(addAssignment_20803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41703(VarCurr,B)
      <=> v41705(VarCurr,B) ) ) ).

tff(addAssignment_20802,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,0)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20801,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,1)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20800,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,2)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20799,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,3)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20798,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,4)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20797,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,5)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20796,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,6)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20795,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,7)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20794,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,8)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20793,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,9)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20792,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,10)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20791,axiom,
    ! [VarCurr: state_type] :
      ( v41705(VarCurr,11)
    <=> v41723(VarCurr) ) ).

tff(addAssignment_20790,axiom,
    ! [VarCurr: state_type] :
      ( v41723(VarCurr)
    <=> v41707(VarCurr) ) ).

tff(addAssignment_20789,axiom,
    ! [VarCurr: state_type] :
      ( v41707(VarCurr)
    <=> v41709(VarCurr,0) ) ).

tff(addAssignment_20788,axiom,
    ! [VarCurr: state_type] :
      ( v41709(VarCurr,0)
    <=> v41711(VarCurr,0) ) ).

tff(addAssignment_20787,axiom,
    ! [VarCurr: state_type] :
      ( v41711(VarCurr,0)
    <=> v41721(VarCurr,0) ) ).

tff(writeUnaryOperator_2445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v41721(VarCurr,B)
      <=> ~ v41713(VarCurr,B) ) ) ).

tff(addAssignment_20786,axiom,
    ! [VarCurr: state_type] :
      ( v41713(VarCurr,0)
    <=> v41715(VarCurr,0) ) ).

tff(addAssignment_20785,axiom,
    ! [VarCurr: state_type] :
      ( v41715(VarCurr,0)
    <=> v41718(VarCurr,0) ) ).

tff(addAssignment_20784,axiom,
    ! [VarCurr: state_type] :
      ( v41718(VarCurr,0)
    <=> v41717(VarCurr) ) ).

tff(addAssignment_20783,axiom,
    ! [VarCurr: state_type] :
      ( v41718(VarCurr,1)
    <=> v41720(VarCurr) ) ).

tff(addAssignment_20782,axiom,
    ! [VarCurr: state_type] :
      ( v41718(VarCurr,2)
    <=> v41719(VarCurr) ) ).

tff(addAssignment_20781,axiom,
    ! [VarCurr: state_type] :
      ( v41717(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_20780,axiom,
    ! [VarCurr: state_type] :
      ( v41679(VarCurr)
    <=> v41681(VarCurr) ) ).

tff(addAssignment_20779,axiom,
    ! [VarCurr: state_type] :
      ( v41681(VarCurr)
    <=> v41683(VarCurr) ) ).

tff(addAssignment_20778,axiom,
    ! [VarCurr: state_type] :
      ( v41683(VarCurr)
    <=> v41685(VarCurr) ) ).

tff(addAssignment_20777,axiom,
    ! [VarCurr: state_type] :
      ( v41685(VarCurr)
    <=> v41687(VarCurr) ) ).

tff(addAssignment_20776,axiom,
    ! [VarCurr: state_type] :
      ( v41687(VarCurr)
    <=> v41689(VarCurr) ) ).

tff(addAssignment_20775,axiom,
    ! [VarCurr: state_type] :
      ( v41689(VarCurr)
    <=> v41691(VarCurr) ) ).

tff(addAssignment_20774,axiom,
    ! [VarCurr: state_type] :
      ( v41691(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_20773,axiom,
    ! [VarCurr: state_type] :
      ( v41665(VarCurr)
    <=> v41667(VarCurr) ) ).

tff(addAssignment_20772,axiom,
    ! [VarCurr: state_type] :
      ( v41667(VarCurr)
    <=> v41669(VarCurr) ) ).

tff(addAssignment_20771,axiom,
    ! [VarCurr: state_type] :
      ( v41669(VarCurr)
    <=> v41671(VarCurr) ) ).

tff(addAssignment_20770,axiom,
    ! [VarCurr: state_type] :
      ( v41671(VarCurr)
    <=> v41673(VarCurr) ) ).

tff(addAssignment_20769,axiom,
    ! [VarCurr: state_type] :
      ( v41673(VarCurr)
    <=> v41675(VarCurr) ) ).

tff(addAssignment_20768,axiom,
    ! [VarCurr: state_type] :
      ( v41675(VarCurr)
    <=> v41677(VarCurr) ) ).

tff(addAssignment_20767,axiom,
    ! [VarCurr: state_type] :
      ( v41677(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_20766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41641(VarCurr,B)
      <=> v41643(VarCurr,B) ) ) ).

tff(addAssignment_20765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41643(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_20764,axiom,
    ! [VarCurr: state_type] :
      ( v40085(VarCurr)
    <=> v40087(VarCurr) ) ).

tff(addAssignment_20763,axiom,
    ! [VarCurr: state_type] :
      ( v40087(VarCurr)
    <=> v40089(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_209,axiom,
    ! [VarCurr: state_type] :
      ( v40089(VarCurr)
    <=> ( ( v40091(VarCurr,11)
        <=> v40095(VarCurr,11) )
        & ( v40091(VarCurr,10)
        <=> v40095(VarCurr,10) )
        & ( v40091(VarCurr,9)
        <=> v40095(VarCurr,9) )
        & ( v40091(VarCurr,8)
        <=> v40095(VarCurr,8) )
        & ( v40091(VarCurr,7)
        <=> v40095(VarCurr,7) )
        & ( v40091(VarCurr,6)
        <=> v40095(VarCurr,6) )
        & ( v40091(VarCurr,5)
        <=> v40095(VarCurr,5) )
        & ( v40091(VarCurr,4)
        <=> v40095(VarCurr,4) )
        & ( v40091(VarCurr,3)
        <=> v40095(VarCurr,3) )
        & ( v40091(VarCurr,2)
        <=> v40095(VarCurr,2) )
        & ( v40091(VarCurr,1)
        <=> v40095(VarCurr,1) )
        & ( v40091(VarCurr,0)
        <=> v40095(VarCurr,0) ) ) ) ).

tff(addAssignment_20762,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40095(VarCurr,B)
      <=> v40097(VarCurr,B) ) ) ).

tff(addAssignment_20761,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40097(VarCurr,B)
      <=> v40099(VarCurr,B) ) ) ).

tff(addAssignment_20760,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40099(VarCurr,B)
      <=> v40101(VarCurr,B) ) ) ).

tff(addAssignment_20759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40101(VarCurr,B)
      <=> v40103(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40103(VarCurr,B)
      <=> ( v41611(VarCurr,B)
          | v41630(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41630(VarCurr,B)
      <=> ( v41482(VarCurr,B)
          & v41631(VarCurr,B) ) ) ) ).

tff(addAssignment_20758,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,0)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20757,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,1)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20756,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,2)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20755,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,3)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20754,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,4)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20753,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,5)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20752,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,6)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20751,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,7)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20750,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,8)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20749,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,9)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20748,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,10)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20747,axiom,
    ! [VarCurr: state_type] :
      ( v41631(VarCurr,11)
    <=> v41632(VarCurr) ) ).

tff(addAssignment_20746,axiom,
    ! [VarCurr: state_type] :
      ( v41632(VarCurr)
    <=> v41601(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41611(VarCurr,B)
      <=> ( v41612(VarCurr,B)
          | v41627(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41627(VarCurr,B)
      <=> ( v41331(VarCurr,B)
          & v41628(VarCurr,B) ) ) ) ).

tff(addAssignment_20745,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,0)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20744,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,1)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20743,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,2)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20742,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,3)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20741,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,4)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20740,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,5)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20739,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,6)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20738,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,7)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20737,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,8)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20736,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,9)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20735,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,10)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20734,axiom,
    ! [VarCurr: state_type] :
      ( v41628(VarCurr,11)
    <=> v41629(VarCurr) ) ).

tff(addAssignment_20733,axiom,
    ! [VarCurr: state_type] :
      ( v41629(VarCurr)
    <=> v41451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41612(VarCurr,B)
      <=> ( v41613(VarCurr,B)
          | v41624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41624(VarCurr,B)
      <=> ( v41180(VarCurr,B)
          & v41625(VarCurr,B) ) ) ) ).

tff(addAssignment_20732,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,0)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20731,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,1)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20730,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,2)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20729,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,3)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20728,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,4)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20727,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,5)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20726,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,6)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20725,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,7)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20724,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,8)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20723,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,9)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20722,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,10)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20721,axiom,
    ! [VarCurr: state_type] :
      ( v41625(VarCurr,11)
    <=> v41626(VarCurr) ) ).

tff(addAssignment_20720,axiom,
    ! [VarCurr: state_type] :
      ( v41626(VarCurr)
    <=> v41300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41613(VarCurr,B)
      <=> ( v41614(VarCurr,B)
          | v41621(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41621(VarCurr,B)
      <=> ( v41029(VarCurr,B)
          & v41622(VarCurr,B) ) ) ) ).

tff(addAssignment_20719,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,0)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20718,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,1)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20717,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,2)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20716,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,3)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20715,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,4)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20714,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,5)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20713,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,6)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20712,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,7)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20711,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,8)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20710,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,9)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20709,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,10)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20708,axiom,
    ! [VarCurr: state_type] :
      ( v41622(VarCurr,11)
    <=> v41623(VarCurr) ) ).

tff(addAssignment_20707,axiom,
    ! [VarCurr: state_type] :
      ( v41623(VarCurr)
    <=> v41149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41614(VarCurr,B)
      <=> ( v41615(VarCurr,B)
          | v41618(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41618(VarCurr,B)
      <=> ( v40867(VarCurr,B)
          & v41619(VarCurr,B) ) ) ) ).

tff(addAssignment_20706,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,0)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20705,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,1)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20704,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,2)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20703,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,3)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20702,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,4)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20701,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,5)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20700,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,6)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20699,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,7)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20698,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,8)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20697,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,9)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20696,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,10)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20695,axiom,
    ! [VarCurr: state_type] :
      ( v41619(VarCurr,11)
    <=> v41620(VarCurr) ) ).

tff(addAssignment_20694,axiom,
    ! [VarCurr: state_type] :
      ( v41620(VarCurr)
    <=> v40998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41615(VarCurr,B)
      <=> ( v40105(VarCurr,B)
          & v41616(VarCurr,B) ) ) ) ).

tff(addAssignment_20693,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,0)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20692,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,1)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20691,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,2)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20690,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,3)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20689,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,4)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20688,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,5)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20687,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,6)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20686,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,7)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20685,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,8)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20684,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,9)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20683,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,10)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20682,axiom,
    ! [VarCurr: state_type] :
      ( v41616(VarCurr,11)
    <=> v41617(VarCurr) ) ).

tff(addAssignment_20681,axiom,
    ! [VarCurr: state_type] :
      ( v41617(VarCurr)
    <=> v40575(VarCurr) ) ).

tff(addAssignment_20680,axiom,
    ! [VarCurr: state_type] :
      ( v41601(VarCurr)
    <=> v41603(VarCurr) ) ).

tff(addAssignment_20679,axiom,
    ! [VarCurr: state_type] :
      ( v41603(VarCurr)
    <=> v41605(VarCurr) ) ).

tff(addAssignment_20678,axiom,
    ! [VarCurr: state_type] :
      ( v41605(VarCurr)
    <=> v41607(VarCurr) ) ).

tff(addAssignment_20677,axiom,
    ! [VarCurr: state_type] :
      ( v41607(VarCurr)
    <=> v41609(VarCurr) ) ).

tff(addAssignment_20676,axiom,
    ! [VarCurr: state_type] :
      ( v41609(VarCurr)
    <=> v40668(VarCurr) ) ).

tff(addAssignment_20675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41482(VarCurr,B)
      <=> v41484(VarCurr,B) ) ) ).

tff(addAssignment_20674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41484(VarCurr,B)
      <=> v41486(VarCurr,B) ) ) ).

tff(addAssignment_20673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41486(VarCurr,B)
      <=> v41488(VarCurr,B) ) ) ).

tff(addAssignment_20672,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41488(VarCurr,B)
      <=> v41490(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41584(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41490(VarNext,B)
            <=> v41490(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_490,axiom,
    ! [VarNext: state_type] :
      ( v41584(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41490(VarNext,B)
          <=> v41594(VarNext,B) ) ) ) ).

tff(addAssignment_20671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41594(VarNext,B)
          <=> v41592(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41595(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41592(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_336,axiom,
    ! [VarCurr: state_type] :
      ( v41595(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41592(VarCurr,B)
          <=> v41512(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3982,axiom,
    ! [VarCurr: state_type] :
      ( v41595(VarCurr)
    <=> ( v41596(VarCurr)
        & v41597(VarCurr) ) ) ).

tff(writeUnaryOperator_2444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41597(VarCurr)
    <=> v41502(VarCurr) ) ).

tff(writeUnaryOperator_2443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41596(VarCurr)
    <=> v41492(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41584(VarNext)
      <=> v41585(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3980,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41585(VarNext)
      <=> ( v41586(VarNext)
          & v41516(VarNext) ) ) ) ).

tff(writeUnaryOperator_2442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41586(VarNext)
      <=> v41588(VarNext) ) ) ).

tff(addAssignment_20670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41588(VarNext)
      <=> v41516(VarCurr) ) ) ).

tff(addAssignment_20669,axiom,
    ! [VarCurr: state_type] :
      ( v41516(VarCurr)
    <=> v41518(VarCurr) ) ).

tff(addAssignment_20668,axiom,
    ! [VarCurr: state_type] :
      ( v41518(VarCurr)
    <=> v41520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3979,axiom,
    ! [VarCurr: state_type] :
      ( v41520(VarCurr)
    <=> ( v41581(VarCurr)
        | v41577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3978,axiom,
    ! [VarCurr: state_type] :
      ( v41581(VarCurr)
    <=> ( v41522(VarCurr)
        & v41526(VarCurr) ) ) ).

tff(addAssignment_20667,axiom,
    ! [VarCurr: state_type] :
      ( v41577(VarCurr)
    <=> v41579(VarCurr) ) ).

tff(addAssignment_20666,axiom,
    ! [VarCurr: state_type] :
      ( v41579(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41561(VarNext)
       => ( v41526(VarNext)
        <=> v41526(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_489,axiom,
    ! [VarNext: state_type] :
      ( v41561(VarNext)
     => ( v41526(VarNext)
      <=> v41571(VarNext) ) ) ).

tff(addAssignment_20665,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41571(VarNext)
      <=> v41569(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3977,axiom,
    ! [VarCurr: state_type] :
      ( v41569(VarCurr)
    <=> ( v41572(VarCurr)
        & v41573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3976,axiom,
    ! [VarCurr: state_type] :
      ( v41573(VarCurr)
    <=> ( v41532(VarCurr)
        | v41556(VarCurr) ) ) ).

tff(writeUnaryOperator_2441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41572(VarCurr)
    <=> v41528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41561(VarNext)
      <=> v41562(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41562(VarNext)
      <=> ( v41564(VarNext)
          & v41566(VarNext) ) ) ) ).

tff(writeUnaryOperator_2440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41566(VarCurr)
    <=> v41522(VarCurr) ) ).

tff(addAssignment_20664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41564(VarNext)
      <=> v41522(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_173,axiom,
    ( v41526(constB0)
  <=> $true ) ).

tff(addAssignment_20663,axiom,
    ! [VarCurr: state_type] :
      ( v41556(VarCurr)
    <=> v41558(VarCurr) ) ).

tff(addAssignment_20662,axiom,
    ! [VarCurr: state_type] :
      ( v41558(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20661,axiom,
    ! [VarCurr: state_type] :
      ( v41532(VarCurr)
    <=> v41534(VarCurr) ) ).

tff(addAssignment_20660,axiom,
    ! [VarCurr: state_type] :
      ( v41534(VarCurr)
    <=> v40842(VarCurr) ) ).

tff(addAssignment_20659,axiom,
    ! [VarCurr: state_type] :
      ( v40842(VarCurr)
    <=> v41537(VarCurr) ) ).

tff(addAssignment_20658,axiom,
    ! [VarCurr: state_type] :
      ( v41537(VarCurr)
    <=> v41539(VarCurr) ) ).

tff(writeUnaryOperator_2439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41539(VarCurr)
    <=> v41553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3973,axiom,
    ! [VarCurr: state_type] :
      ( v41553(VarCurr)
    <=> ( v41554(VarCurr)
        | v41549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3972,axiom,
    ! [VarCurr: state_type] :
      ( v41554(VarCurr)
    <=> ( v41541(VarCurr)
        | v41545(VarCurr) ) ) ).

tff(addAssignment_20657,axiom,
    ! [VarCurr: state_type] :
      ( v41549(VarCurr)
    <=> v41551(VarCurr) ) ).

tff(addAssignment_20656,axiom,
    ! [VarCurr: state_type] :
      ( v41551(VarCurr)
    <=> v40931(VarCurr,2) ) ).

tff(addAssignment_20655,axiom,
    ! [VarCurr: state_type] :
      ( v41545(VarCurr)
    <=> v41547(VarCurr) ) ).

tff(addAssignment_20654,axiom,
    ! [VarCurr: state_type] :
      ( v41547(VarCurr)
    <=> v40505(VarCurr,1) ) ).

tff(addAssignment_20653,axiom,
    ! [VarCurr: state_type] :
      ( v41541(VarCurr)
    <=> v41543(VarCurr) ) ).

tff(addAssignment_20652,axiom,
    ! [VarCurr: state_type] :
      ( v41543(VarCurr)
    <=> v40931(VarCurr,0) ) ).

tff(addAssignment_20651,axiom,
    ! [VarCurr: state_type] :
      ( v41528(VarCurr)
    <=> v41530(VarCurr) ) ).

tff(addAssignment_20650,axiom,
    ! [VarCurr: state_type] :
      ( v41530(VarCurr)
    <=> $false ) ).

tff(addAssignment_20649,axiom,
    ! [VarCurr: state_type] :
      ( v41522(VarCurr)
    <=> v41524(VarCurr) ) ).

tff(addAssignment_20648,axiom,
    ! [VarCurr: state_type] :
      ( v41524(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41512(VarCurr,B)
      <=> v41514(VarCurr,B) ) ) ).

tff(addAssignment_20646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41514(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20645,axiom,
    ! [VarCurr: state_type] :
      ( v41502(VarCurr)
    <=> v41504(VarCurr) ) ).

tff(addAssignment_20644,axiom,
    ! [VarCurr: state_type] :
      ( v41504(VarCurr)
    <=> v41506(VarCurr) ) ).

tff(addAssignment_20643,axiom,
    ! [VarCurr: state_type] :
      ( v41506(VarCurr)
    <=> v41508(VarCurr) ) ).

tff(addAssignment_20642,axiom,
    ! [VarCurr: state_type] :
      ( v41508(VarCurr)
    <=> v41510(VarCurr) ) ).

tff(addAssignment_20641,axiom,
    ! [VarCurr: state_type] :
      ( v41510(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20640,axiom,
    ! [VarCurr: state_type] :
      ( v41492(VarCurr)
    <=> v41494(VarCurr) ) ).

tff(addAssignment_20639,axiom,
    ! [VarCurr: state_type] :
      ( v41494(VarCurr)
    <=> v41496(VarCurr) ) ).

tff(addAssignment_20638,axiom,
    ! [VarCurr: state_type] :
      ( v41496(VarCurr)
    <=> v41498(VarCurr) ) ).

tff(addAssignment_20637,axiom,
    ! [VarCurr: state_type] :
      ( v41498(VarCurr)
    <=> v41500(VarCurr) ) ).

tff(addAssignment_20636,axiom,
    ! [VarCurr: state_type] :
      ( v41500(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_20635,axiom,
    ! [VarCurr: state_type] :
      ( v41451(VarCurr)
    <=> v41453(VarCurr) ) ).

tff(addAssignment_20634,axiom,
    ! [VarCurr: state_type] :
      ( v41453(VarCurr)
    <=> v41455(VarCurr) ) ).

tff(addAssignment_20633,axiom,
    ! [VarCurr: state_type] :
      ( v41455(VarCurr)
    <=> v41457(VarCurr) ) ).

tff(addAssignment_20632,axiom,
    ! [VarCurr: state_type] :
      ( v41457(VarCurr)
    <=> v41459(VarCurr) ) ).

tff(addAssignment_20631,axiom,
    ! [VarCurr: state_type] :
      ( v41459(VarCurr)
    <=> v41461(VarCurr) ) ).

tff(addAssignment_20630,axiom,
    ! [VarCurr: state_type] :
      ( v41461(VarCurr)
    <=> v41463(VarCurr) ) ).

tff(addAssignment_20629,axiom,
    ! [VarCurr: state_type] :
      ( v41463(VarCurr)
    <=> v41465(VarCurr) ) ).

tff(writeUnaryOperator_2438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41465(VarCurr)
    <=> v41479(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3971,axiom,
    ! [VarCurr: state_type] :
      ( v41479(VarCurr)
    <=> ( v41480(VarCurr)
        | v41475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3970,axiom,
    ! [VarCurr: state_type] :
      ( v41480(VarCurr)
    <=> ( v41467(VarCurr)
        | v41471(VarCurr) ) ) ).

tff(addAssignment_20628,axiom,
    ! [VarCurr: state_type] :
      ( v41475(VarCurr)
    <=> v41477(VarCurr) ) ).

tff(addAssignment_20627,axiom,
    ! [VarCurr: state_type] :
      ( v41477(VarCurr)
    <=> v40678(VarCurr,2) ) ).

tff(addAssignment_20626,axiom,
    ! [VarCurr: state_type] :
      ( v41471(VarCurr)
    <=> v41473(VarCurr) ) ).

tff(addAssignment_20625,axiom,
    ! [VarCurr: state_type] :
      ( v41473(VarCurr)
    <=> v40595(VarCurr,1) ) ).

tff(addAssignment_20624,axiom,
    ! [VarCurr: state_type] :
      ( v41467(VarCurr)
    <=> v41469(VarCurr) ) ).

tff(addAssignment_20623,axiom,
    ! [VarCurr: state_type] :
      ( v41469(VarCurr)
    <=> v40595(VarCurr,0) ) ).

tff(addAssignment_20622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41331(VarCurr,B)
      <=> v41333(VarCurr,B) ) ) ).

tff(addAssignment_20621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41333(VarCurr,B)
      <=> v41335(VarCurr,B) ) ) ).

tff(addAssignment_20620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41335(VarCurr,B)
      <=> v41337(VarCurr,B) ) ) ).

tff(addAssignment_20619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41337(VarCurr,B)
      <=> v41339(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41434(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41339(VarNext,B)
            <=> v41339(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_488,axiom,
    ! [VarNext: state_type] :
      ( v41434(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41339(VarNext,B)
          <=> v41444(VarNext,B) ) ) ) ).

tff(addAssignment_20618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41444(VarNext,B)
          <=> v41442(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41445(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41442(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_335,axiom,
    ! [VarCurr: state_type] :
      ( v41445(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41442(VarCurr,B)
          <=> v41361(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3969,axiom,
    ! [VarCurr: state_type] :
      ( v41445(VarCurr)
    <=> ( v41446(VarCurr)
        & v41447(VarCurr) ) ) ).

tff(writeUnaryOperator_2437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41447(VarCurr)
    <=> v41351(VarCurr) ) ).

tff(writeUnaryOperator_2436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41446(VarCurr)
    <=> v41341(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3968,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41434(VarNext)
      <=> v41435(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41435(VarNext)
      <=> ( v41436(VarNext)
          & v41365(VarNext) ) ) ) ).

tff(writeUnaryOperator_2435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41436(VarNext)
      <=> v41438(VarNext) ) ) ).

tff(addAssignment_20617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41438(VarNext)
      <=> v41365(VarCurr) ) ) ).

tff(addAssignment_20616,axiom,
    ! [VarCurr: state_type] :
      ( v41365(VarCurr)
    <=> v41367(VarCurr) ) ).

tff(addAssignment_20615,axiom,
    ! [VarCurr: state_type] :
      ( v41367(VarCurr)
    <=> v41369(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3966,axiom,
    ! [VarCurr: state_type] :
      ( v41369(VarCurr)
    <=> ( v41431(VarCurr)
        | v41427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3965,axiom,
    ! [VarCurr: state_type] :
      ( v41431(VarCurr)
    <=> ( v41371(VarCurr)
        & v41375(VarCurr) ) ) ).

tff(addAssignment_20614,axiom,
    ! [VarCurr: state_type] :
      ( v41427(VarCurr)
    <=> v41429(VarCurr) ) ).

tff(addAssignment_20613,axiom,
    ! [VarCurr: state_type] :
      ( v41429(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41411(VarNext)
       => ( v41375(VarNext)
        <=> v41375(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_487,axiom,
    ! [VarNext: state_type] :
      ( v41411(VarNext)
     => ( v41375(VarNext)
      <=> v41421(VarNext) ) ) ).

tff(addAssignment_20612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41421(VarNext)
      <=> v41419(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3964,axiom,
    ! [VarCurr: state_type] :
      ( v41419(VarCurr)
    <=> ( v41422(VarCurr)
        & v41423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3963,axiom,
    ! [VarCurr: state_type] :
      ( v41423(VarCurr)
    <=> ( v41381(VarCurr)
        | v41406(VarCurr) ) ) ).

tff(writeUnaryOperator_2434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41422(VarCurr)
    <=> v41377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41411(VarNext)
      <=> v41412(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41412(VarNext)
      <=> ( v41414(VarNext)
          & v41416(VarNext) ) ) ) ).

tff(writeUnaryOperator_2433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41416(VarCurr)
    <=> v41371(VarCurr) ) ).

tff(addAssignment_20611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41414(VarNext)
      <=> v41371(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_172,axiom,
    ( v41375(constB0)
  <=> $true ) ).

tff(addAssignment_20610,axiom,
    ! [VarCurr: state_type] :
      ( v41406(VarCurr)
    <=> v41408(VarCurr) ) ).

tff(addAssignment_20609,axiom,
    ! [VarCurr: state_type] :
      ( v41408(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20608,axiom,
    ! [VarCurr: state_type] :
      ( v41381(VarCurr)
    <=> v41383(VarCurr) ) ).

tff(addAssignment_20607,axiom,
    ! [VarCurr: state_type] :
      ( v41383(VarCurr)
    <=> v41385(VarCurr) ) ).

tff(addAssignment_20606,axiom,
    ! [VarCurr: state_type] :
      ( v41385(VarCurr)
    <=> v41387(VarCurr) ) ).

tff(addAssignment_20605,axiom,
    ! [VarCurr: state_type] :
      ( v41387(VarCurr)
    <=> v41389(VarCurr) ) ).

tff(writeUnaryOperator_2432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41389(VarCurr)
    <=> v41403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3960,axiom,
    ! [VarCurr: state_type] :
      ( v41403(VarCurr)
    <=> ( v41404(VarCurr)
        | v41399(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3959,axiom,
    ! [VarCurr: state_type] :
      ( v41404(VarCurr)
    <=> ( v41391(VarCurr)
        | v41395(VarCurr) ) ) ).

tff(addAssignment_20604,axiom,
    ! [VarCurr: state_type] :
      ( v41399(VarCurr)
    <=> v41401(VarCurr) ) ).

tff(addAssignment_20603,axiom,
    ! [VarCurr: state_type] :
      ( v41401(VarCurr)
    <=> v40931(VarCurr,2) ) ).

tff(addAssignment_20602,axiom,
    ! [VarCurr: state_type] :
      ( v40931(VarCurr,2)
    <=> v40933(VarCurr,2) ) ).

tff(addAssignment_20601,axiom,
    ! [VarCurr: state_type] :
      ( v40933(VarCurr,2)
    <=> v40935(VarCurr,2) ) ).

tff(addAssignment_20600,axiom,
    ! [VarCurr: state_type] :
      ( v40935(VarCurr,2)
    <=> v40940(VarCurr,2) ) ).

tff(addAssignment_20599,axiom,
    ! [VarCurr: state_type] :
      ( v40937(VarCurr,2)
    <=> v40939(VarCurr,2) ) ).

tff(addAssignment_20598,axiom,
    ! [VarCurr: state_type] :
      ( v40939(VarCurr,2)
    <=> v40505(VarCurr,2) ) ).

tff(addAssignment_20597,axiom,
    ! [VarCurr: state_type] :
      ( v41395(VarCurr)
    <=> v41397(VarCurr) ) ).

tff(addAssignment_20596,axiom,
    ! [VarCurr: state_type] :
      ( v41397(VarCurr)
    <=> v40505(VarCurr,1) ) ).

tff(addAssignment_20595,axiom,
    ! [VarCurr: state_type] :
      ( v41391(VarCurr)
    <=> v41393(VarCurr) ) ).

tff(addAssignment_20594,axiom,
    ! [VarCurr: state_type] :
      ( v41393(VarCurr)
    <=> v40505(VarCurr,0) ) ).

tff(addAssignment_20593,axiom,
    ! [VarCurr: state_type] :
      ( v41377(VarCurr)
    <=> v41379(VarCurr) ) ).

tff(addAssignment_20592,axiom,
    ! [VarCurr: state_type] :
      ( v41379(VarCurr)
    <=> $false ) ).

tff(addAssignment_20591,axiom,
    ! [VarCurr: state_type] :
      ( v41371(VarCurr)
    <=> v41373(VarCurr) ) ).

tff(addAssignment_20590,axiom,
    ! [VarCurr: state_type] :
      ( v41373(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41361(VarCurr,B)
      <=> v41363(VarCurr,B) ) ) ).

tff(addAssignment_20588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41363(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20587,axiom,
    ! [VarCurr: state_type] :
      ( v41351(VarCurr)
    <=> v41353(VarCurr) ) ).

tff(addAssignment_20586,axiom,
    ! [VarCurr: state_type] :
      ( v41353(VarCurr)
    <=> v41355(VarCurr) ) ).

tff(addAssignment_20585,axiom,
    ! [VarCurr: state_type] :
      ( v41355(VarCurr)
    <=> v41357(VarCurr) ) ).

tff(addAssignment_20584,axiom,
    ! [VarCurr: state_type] :
      ( v41357(VarCurr)
    <=> v41359(VarCurr) ) ).

tff(addAssignment_20583,axiom,
    ! [VarCurr: state_type] :
      ( v41359(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20582,axiom,
    ! [VarCurr: state_type] :
      ( v41341(VarCurr)
    <=> v41343(VarCurr) ) ).

tff(addAssignment_20581,axiom,
    ! [VarCurr: state_type] :
      ( v41343(VarCurr)
    <=> v41345(VarCurr) ) ).

tff(addAssignment_20580,axiom,
    ! [VarCurr: state_type] :
      ( v41345(VarCurr)
    <=> v41347(VarCurr) ) ).

tff(addAssignment_20579,axiom,
    ! [VarCurr: state_type] :
      ( v41347(VarCurr)
    <=> v41349(VarCurr) ) ).

tff(addAssignment_20578,axiom,
    ! [VarCurr: state_type] :
      ( v41349(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_20577,axiom,
    ! [VarCurr: state_type] :
      ( v41300(VarCurr)
    <=> v41302(VarCurr) ) ).

tff(addAssignment_20576,axiom,
    ! [VarCurr: state_type] :
      ( v41302(VarCurr)
    <=> v41304(VarCurr) ) ).

tff(addAssignment_20575,axiom,
    ! [VarCurr: state_type] :
      ( v41304(VarCurr)
    <=> v41306(VarCurr) ) ).

tff(addAssignment_20574,axiom,
    ! [VarCurr: state_type] :
      ( v41306(VarCurr)
    <=> v41308(VarCurr) ) ).

tff(addAssignment_20573,axiom,
    ! [VarCurr: state_type] :
      ( v41308(VarCurr)
    <=> v41310(VarCurr) ) ).

tff(addAssignment_20572,axiom,
    ! [VarCurr: state_type] :
      ( v41310(VarCurr)
    <=> v41312(VarCurr) ) ).

tff(addAssignment_20571,axiom,
    ! [VarCurr: state_type] :
      ( v41312(VarCurr)
    <=> v41314(VarCurr) ) ).

tff(writeUnaryOperator_2431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41314(VarCurr)
    <=> v41328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3958,axiom,
    ! [VarCurr: state_type] :
      ( v41328(VarCurr)
    <=> ( v41329(VarCurr)
        | v41324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3957,axiom,
    ! [VarCurr: state_type] :
      ( v41329(VarCurr)
    <=> ( v41316(VarCurr)
        | v41320(VarCurr) ) ) ).

tff(addAssignment_20570,axiom,
    ! [VarCurr: state_type] :
      ( v41324(VarCurr)
    <=> v41326(VarCurr) ) ).

tff(addAssignment_20569,axiom,
    ! [VarCurr: state_type] :
      ( v41326(VarCurr)
    <=> v40595(VarCurr,2) ) ).

tff(addAssignment_20568,axiom,
    ! [VarCurr: state_type] :
      ( v41320(VarCurr)
    <=> v41322(VarCurr) ) ).

tff(addAssignment_20567,axiom,
    ! [VarCurr: state_type] :
      ( v41322(VarCurr)
    <=> v40678(VarCurr,1) ) ).

tff(addAssignment_20566,axiom,
    ! [VarCurr: state_type] :
      ( v41316(VarCurr)
    <=> v41318(VarCurr) ) ).

tff(addAssignment_20565,axiom,
    ! [VarCurr: state_type] :
      ( v41318(VarCurr)
    <=> v40678(VarCurr,0) ) ).

tff(addAssignment_20564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41180(VarCurr,B)
      <=> v41182(VarCurr,B) ) ) ).

tff(addAssignment_20563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41182(VarCurr,B)
      <=> v41184(VarCurr,B) ) ) ).

tff(addAssignment_20562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41184(VarCurr,B)
      <=> v41186(VarCurr,B) ) ) ).

tff(addAssignment_20561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41186(VarCurr,B)
      <=> v41188(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41283(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41188(VarNext,B)
            <=> v41188(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_486,axiom,
    ! [VarNext: state_type] :
      ( v41283(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41188(VarNext,B)
          <=> v41293(VarNext,B) ) ) ) ).

tff(addAssignment_20560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41293(VarNext,B)
          <=> v41291(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41291(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_334,axiom,
    ! [VarCurr: state_type] :
      ( v41294(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41291(VarCurr,B)
          <=> v41210(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3956,axiom,
    ! [VarCurr: state_type] :
      ( v41294(VarCurr)
    <=> ( v41295(VarCurr)
        & v41296(VarCurr) ) ) ).

tff(writeUnaryOperator_2430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41296(VarCurr)
    <=> v41200(VarCurr) ) ).

tff(writeUnaryOperator_2429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41295(VarCurr)
    <=> v41190(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41283(VarNext)
      <=> v41284(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41284(VarNext)
      <=> ( v41285(VarNext)
          & v41214(VarNext) ) ) ) ).

tff(writeUnaryOperator_2428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41285(VarNext)
      <=> v41287(VarNext) ) ) ).

tff(addAssignment_20559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41287(VarNext)
      <=> v41214(VarCurr) ) ) ).

tff(addAssignment_20558,axiom,
    ! [VarCurr: state_type] :
      ( v41214(VarCurr)
    <=> v41216(VarCurr) ) ).

tff(addAssignment_20557,axiom,
    ! [VarCurr: state_type] :
      ( v41216(VarCurr)
    <=> v41218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3953,axiom,
    ! [VarCurr: state_type] :
      ( v41218(VarCurr)
    <=> ( v41280(VarCurr)
        | v41276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3952,axiom,
    ! [VarCurr: state_type] :
      ( v41280(VarCurr)
    <=> ( v41220(VarCurr)
        & v41224(VarCurr) ) ) ).

tff(addAssignment_20556,axiom,
    ! [VarCurr: state_type] :
      ( v41276(VarCurr)
    <=> v41278(VarCurr) ) ).

tff(addAssignment_20555,axiom,
    ! [VarCurr: state_type] :
      ( v41278(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41260(VarNext)
       => ( v41224(VarNext)
        <=> v41224(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_485,axiom,
    ! [VarNext: state_type] :
      ( v41260(VarNext)
     => ( v41224(VarNext)
      <=> v41270(VarNext) ) ) ).

tff(addAssignment_20554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41270(VarNext)
      <=> v41268(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3951,axiom,
    ! [VarCurr: state_type] :
      ( v41268(VarCurr)
    <=> ( v41271(VarCurr)
        & v41272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3950,axiom,
    ! [VarCurr: state_type] :
      ( v41272(VarCurr)
    <=> ( v41230(VarCurr)
        | v41255(VarCurr) ) ) ).

tff(writeUnaryOperator_2427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41271(VarCurr)
    <=> v41226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41260(VarNext)
      <=> v41261(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3948,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41261(VarNext)
      <=> ( v41263(VarNext)
          & v41265(VarNext) ) ) ) ).

tff(writeUnaryOperator_2426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41265(VarCurr)
    <=> v41220(VarCurr) ) ).

tff(addAssignment_20553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41263(VarNext)
      <=> v41220(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_171,axiom,
    ( v41224(constB0)
  <=> $true ) ).

tff(addAssignment_20552,axiom,
    ! [VarCurr: state_type] :
      ( v41255(VarCurr)
    <=> v41257(VarCurr) ) ).

tff(addAssignment_20551,axiom,
    ! [VarCurr: state_type] :
      ( v41257(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20550,axiom,
    ! [VarCurr: state_type] :
      ( v41230(VarCurr)
    <=> v41232(VarCurr) ) ).

tff(addAssignment_20549,axiom,
    ! [VarCurr: state_type] :
      ( v41232(VarCurr)
    <=> v41234(VarCurr) ) ).

tff(addAssignment_20548,axiom,
    ! [VarCurr: state_type] :
      ( v41234(VarCurr)
    <=> v41236(VarCurr) ) ).

tff(addAssignment_20547,axiom,
    ! [VarCurr: state_type] :
      ( v41236(VarCurr)
    <=> v41238(VarCurr) ) ).

tff(writeUnaryOperator_2425,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41238(VarCurr)
    <=> v41252(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3947,axiom,
    ! [VarCurr: state_type] :
      ( v41252(VarCurr)
    <=> ( v41253(VarCurr)
        | v41248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3946,axiom,
    ! [VarCurr: state_type] :
      ( v41253(VarCurr)
    <=> ( v41240(VarCurr)
        | v41244(VarCurr) ) ) ).

tff(addAssignment_20546,axiom,
    ! [VarCurr: state_type] :
      ( v41248(VarCurr)
    <=> v41250(VarCurr) ) ).

tff(addAssignment_20545,axiom,
    ! [VarCurr: state_type] :
      ( v41250(VarCurr)
    <=> v40505(VarCurr,2) ) ).

tff(addAssignment_20544,axiom,
    ! [VarCurr: state_type] :
      ( v41244(VarCurr)
    <=> v41246(VarCurr) ) ).

tff(addAssignment_20543,axiom,
    ! [VarCurr: state_type] :
      ( v41246(VarCurr)
    <=> v40931(VarCurr,1) ) ).

tff(addAssignment_20542,axiom,
    ! [VarCurr: state_type] :
      ( v41240(VarCurr)
    <=> v41242(VarCurr) ) ).

tff(addAssignment_20541,axiom,
    ! [VarCurr: state_type] :
      ( v41242(VarCurr)
    <=> v40931(VarCurr,0) ) ).

tff(addAssignment_20540,axiom,
    ! [VarCurr: state_type] :
      ( v41226(VarCurr)
    <=> v41228(VarCurr) ) ).

tff(addAssignment_20539,axiom,
    ! [VarCurr: state_type] :
      ( v41228(VarCurr)
    <=> $false ) ).

tff(addAssignment_20538,axiom,
    ! [VarCurr: state_type] :
      ( v41220(VarCurr)
    <=> v41222(VarCurr) ) ).

tff(addAssignment_20537,axiom,
    ! [VarCurr: state_type] :
      ( v41222(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41210(VarCurr,B)
      <=> v41212(VarCurr,B) ) ) ).

tff(addAssignment_20535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41212(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20534,axiom,
    ! [VarCurr: state_type] :
      ( v41200(VarCurr)
    <=> v41202(VarCurr) ) ).

tff(addAssignment_20533,axiom,
    ! [VarCurr: state_type] :
      ( v41202(VarCurr)
    <=> v41204(VarCurr) ) ).

tff(addAssignment_20532,axiom,
    ! [VarCurr: state_type] :
      ( v41204(VarCurr)
    <=> v41206(VarCurr) ) ).

tff(addAssignment_20531,axiom,
    ! [VarCurr: state_type] :
      ( v41206(VarCurr)
    <=> v41208(VarCurr) ) ).

tff(addAssignment_20530,axiom,
    ! [VarCurr: state_type] :
      ( v41208(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20529,axiom,
    ! [VarCurr: state_type] :
      ( v41190(VarCurr)
    <=> v41192(VarCurr) ) ).

tff(addAssignment_20528,axiom,
    ! [VarCurr: state_type] :
      ( v41192(VarCurr)
    <=> v41194(VarCurr) ) ).

tff(addAssignment_20527,axiom,
    ! [VarCurr: state_type] :
      ( v41194(VarCurr)
    <=> v41196(VarCurr) ) ).

tff(addAssignment_20526,axiom,
    ! [VarCurr: state_type] :
      ( v41196(VarCurr)
    <=> v41198(VarCurr) ) ).

tff(addAssignment_20525,axiom,
    ! [VarCurr: state_type] :
      ( v41198(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_20524,axiom,
    ! [VarCurr: state_type] :
      ( v41149(VarCurr)
    <=> v41151(VarCurr) ) ).

tff(addAssignment_20523,axiom,
    ! [VarCurr: state_type] :
      ( v41151(VarCurr)
    <=> v41153(VarCurr) ) ).

tff(addAssignment_20522,axiom,
    ! [VarCurr: state_type] :
      ( v41153(VarCurr)
    <=> v41155(VarCurr) ) ).

tff(addAssignment_20521,axiom,
    ! [VarCurr: state_type] :
      ( v41155(VarCurr)
    <=> v41157(VarCurr) ) ).

tff(addAssignment_20520,axiom,
    ! [VarCurr: state_type] :
      ( v41157(VarCurr)
    <=> v41159(VarCurr) ) ).

tff(addAssignment_20519,axiom,
    ! [VarCurr: state_type] :
      ( v41159(VarCurr)
    <=> v41161(VarCurr) ) ).

tff(addAssignment_20518,axiom,
    ! [VarCurr: state_type] :
      ( v41161(VarCurr)
    <=> v41163(VarCurr) ) ).

tff(writeUnaryOperator_2424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41163(VarCurr)
    <=> v41177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3945,axiom,
    ! [VarCurr: state_type] :
      ( v41177(VarCurr)
    <=> ( v41178(VarCurr)
        | v41173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3944,axiom,
    ! [VarCurr: state_type] :
      ( v41178(VarCurr)
    <=> ( v41165(VarCurr)
        | v41169(VarCurr) ) ) ).

tff(addAssignment_20517,axiom,
    ! [VarCurr: state_type] :
      ( v41173(VarCurr)
    <=> v41175(VarCurr) ) ).

tff(addAssignment_20516,axiom,
    ! [VarCurr: state_type] :
      ( v41175(VarCurr)
    <=> v40595(VarCurr,2) ) ).

tff(addAssignment_20515,axiom,
    ! [VarCurr: state_type] :
      ( v41169(VarCurr)
    <=> v41171(VarCurr) ) ).

tff(addAssignment_20514,axiom,
    ! [VarCurr: state_type] :
      ( v41171(VarCurr)
    <=> v40678(VarCurr,1) ) ).

tff(addAssignment_20513,axiom,
    ! [VarCurr: state_type] :
      ( v40678(VarCurr,1)
    <=> v40680(VarCurr,1) ) ).

tff(addAssignment_20512,axiom,
    ! [VarCurr: state_type] :
      ( v40680(VarCurr,1)
    <=> v40682(VarCurr,1) ) ).

tff(addAssignment_20511,axiom,
    ! [VarCurr: state_type] :
      ( v40682(VarCurr,1)
    <=> v40687(VarCurr,1) ) ).

tff(addAssignment_20510,axiom,
    ! [VarCurr: state_type] :
      ( v40684(VarCurr,1)
    <=> v40686(VarCurr,1) ) ).

tff(addAssignment_20509,axiom,
    ! [VarCurr: state_type] :
      ( v40686(VarCurr,1)
    <=> v40595(VarCurr,1) ) ).

tff(addAssignment_20508,axiom,
    ! [VarCurr: state_type] :
      ( v41165(VarCurr)
    <=> v41167(VarCurr) ) ).

tff(addAssignment_20507,axiom,
    ! [VarCurr: state_type] :
      ( v41167(VarCurr)
    <=> v40595(VarCurr,0) ) ).

tff(addAssignment_20506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41029(VarCurr,B)
      <=> v41031(VarCurr,B) ) ) ).

tff(addAssignment_20505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41031(VarCurr,B)
      <=> v41033(VarCurr,B) ) ) ).

tff(addAssignment_20504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41033(VarCurr,B)
      <=> v41035(VarCurr,B) ) ) ).

tff(addAssignment_20503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41035(VarCurr,B)
      <=> v41037(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41132(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v41037(VarNext,B)
            <=> v41037(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_484,axiom,
    ! [VarNext: state_type] :
      ( v41132(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41037(VarNext,B)
          <=> v41142(VarNext,B) ) ) ) ).

tff(addAssignment_20502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41142(VarNext,B)
          <=> v41140(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41143(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41140(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_333,axiom,
    ! [VarCurr: state_type] :
      ( v41143(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v41140(VarCurr,B)
          <=> v41059(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3943,axiom,
    ! [VarCurr: state_type] :
      ( v41143(VarCurr)
    <=> ( v41144(VarCurr)
        & v41145(VarCurr) ) ) ).

tff(writeUnaryOperator_2423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41145(VarCurr)
    <=> v41049(VarCurr) ) ).

tff(writeUnaryOperator_2422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41144(VarCurr)
    <=> v41039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41132(VarNext)
      <=> v41133(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41133(VarNext)
      <=> ( v41134(VarNext)
          & v41063(VarNext) ) ) ) ).

tff(writeUnaryOperator_2421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41134(VarNext)
      <=> v41136(VarNext) ) ) ).

tff(addAssignment_20501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41136(VarNext)
      <=> v41063(VarCurr) ) ) ).

tff(addAssignment_20500,axiom,
    ! [VarCurr: state_type] :
      ( v41063(VarCurr)
    <=> v41065(VarCurr) ) ).

tff(addAssignment_20499,axiom,
    ! [VarCurr: state_type] :
      ( v41065(VarCurr)
    <=> v41067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3940,axiom,
    ! [VarCurr: state_type] :
      ( v41067(VarCurr)
    <=> ( v41129(VarCurr)
        | v41125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3939,axiom,
    ! [VarCurr: state_type] :
      ( v41129(VarCurr)
    <=> ( v41069(VarCurr)
        & v41073(VarCurr) ) ) ).

tff(addAssignment_20498,axiom,
    ! [VarCurr: state_type] :
      ( v41125(VarCurr)
    <=> v41127(VarCurr) ) ).

tff(addAssignment_20497,axiom,
    ! [VarCurr: state_type] :
      ( v41127(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v41109(VarNext)
       => ( v41073(VarNext)
        <=> v41073(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_483,axiom,
    ! [VarNext: state_type] :
      ( v41109(VarNext)
     => ( v41073(VarNext)
      <=> v41119(VarNext) ) ) ).

tff(addAssignment_20496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41119(VarNext)
      <=> v41117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3938,axiom,
    ! [VarCurr: state_type] :
      ( v41117(VarCurr)
    <=> ( v41120(VarCurr)
        & v41121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3937,axiom,
    ! [VarCurr: state_type] :
      ( v41121(VarCurr)
    <=> ( v41079(VarCurr)
        | v41104(VarCurr) ) ) ).

tff(writeUnaryOperator_2420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41120(VarCurr)
    <=> v41075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41109(VarNext)
      <=> v41110(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41110(VarNext)
      <=> ( v41112(VarNext)
          & v41114(VarNext) ) ) ) ).

tff(writeUnaryOperator_2419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41114(VarCurr)
    <=> v41069(VarCurr) ) ).

tff(addAssignment_20495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v41112(VarNext)
      <=> v41069(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_170,axiom,
    ( v41073(constB0)
  <=> $true ) ).

tff(addAssignment_20494,axiom,
    ! [VarCurr: state_type] :
      ( v41104(VarCurr)
    <=> v41106(VarCurr) ) ).

tff(addAssignment_20493,axiom,
    ! [VarCurr: state_type] :
      ( v41106(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20492,axiom,
    ! [VarCurr: state_type] :
      ( v41079(VarCurr)
    <=> v41081(VarCurr) ) ).

tff(addAssignment_20491,axiom,
    ! [VarCurr: state_type] :
      ( v41081(VarCurr)
    <=> v41083(VarCurr) ) ).

tff(addAssignment_20490,axiom,
    ! [VarCurr: state_type] :
      ( v41083(VarCurr)
    <=> v41085(VarCurr) ) ).

tff(addAssignment_20489,axiom,
    ! [VarCurr: state_type] :
      ( v41085(VarCurr)
    <=> v41087(VarCurr) ) ).

tff(writeUnaryOperator_2418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41087(VarCurr)
    <=> v41101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3934,axiom,
    ! [VarCurr: state_type] :
      ( v41101(VarCurr)
    <=> ( v41102(VarCurr)
        | v41097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3933,axiom,
    ! [VarCurr: state_type] :
      ( v41102(VarCurr)
    <=> ( v41089(VarCurr)
        | v41093(VarCurr) ) ) ).

tff(addAssignment_20488,axiom,
    ! [VarCurr: state_type] :
      ( v41097(VarCurr)
    <=> v41099(VarCurr) ) ).

tff(addAssignment_20487,axiom,
    ! [VarCurr: state_type] :
      ( v41099(VarCurr)
    <=> v40505(VarCurr,2) ) ).

tff(addAssignment_20486,axiom,
    ! [VarCurr: state_type] :
      ( v41093(VarCurr)
    <=> v41095(VarCurr) ) ).

tff(addAssignment_20485,axiom,
    ! [VarCurr: state_type] :
      ( v41095(VarCurr)
    <=> v40931(VarCurr,1) ) ).

tff(addAssignment_20484,axiom,
    ! [VarCurr: state_type] :
      ( v40931(VarCurr,1)
    <=> v40933(VarCurr,1) ) ).

tff(addAssignment_20483,axiom,
    ! [VarCurr: state_type] :
      ( v40933(VarCurr,1)
    <=> v40935(VarCurr,1) ) ).

tff(addAssignment_20482,axiom,
    ! [VarCurr: state_type] :
      ( v40935(VarCurr,1)
    <=> v40940(VarCurr,1) ) ).

tff(addAssignment_20481,axiom,
    ! [VarCurr: state_type] :
      ( v40937(VarCurr,1)
    <=> v40939(VarCurr,1) ) ).

tff(addAssignment_20480,axiom,
    ! [VarCurr: state_type] :
      ( v40939(VarCurr,1)
    <=> v40505(VarCurr,1) ) ).

tff(addAssignment_20479,axiom,
    ! [VarCurr: state_type] :
      ( v41089(VarCurr)
    <=> v41091(VarCurr) ) ).

tff(addAssignment_20478,axiom,
    ! [VarCurr: state_type] :
      ( v41091(VarCurr)
    <=> v40505(VarCurr,0) ) ).

tff(addAssignment_20477,axiom,
    ! [VarCurr: state_type] :
      ( v41075(VarCurr)
    <=> v41077(VarCurr) ) ).

tff(addAssignment_20476,axiom,
    ! [VarCurr: state_type] :
      ( v41077(VarCurr)
    <=> $false ) ).

tff(addAssignment_20475,axiom,
    ! [VarCurr: state_type] :
      ( v41069(VarCurr)
    <=> v41071(VarCurr) ) ).

tff(addAssignment_20474,axiom,
    ! [VarCurr: state_type] :
      ( v41071(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41059(VarCurr,B)
      <=> v41061(VarCurr,B) ) ) ).

tff(addAssignment_20472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v41061(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20471,axiom,
    ! [VarCurr: state_type] :
      ( v41049(VarCurr)
    <=> v41051(VarCurr) ) ).

tff(addAssignment_20470,axiom,
    ! [VarCurr: state_type] :
      ( v41051(VarCurr)
    <=> v41053(VarCurr) ) ).

tff(addAssignment_20469,axiom,
    ! [VarCurr: state_type] :
      ( v41053(VarCurr)
    <=> v41055(VarCurr) ) ).

tff(addAssignment_20468,axiom,
    ! [VarCurr: state_type] :
      ( v41055(VarCurr)
    <=> v41057(VarCurr) ) ).

tff(addAssignment_20467,axiom,
    ! [VarCurr: state_type] :
      ( v41057(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20466,axiom,
    ! [VarCurr: state_type] :
      ( v41039(VarCurr)
    <=> v41041(VarCurr) ) ).

tff(addAssignment_20465,axiom,
    ! [VarCurr: state_type] :
      ( v41041(VarCurr)
    <=> v41043(VarCurr) ) ).

tff(addAssignment_20464,axiom,
    ! [VarCurr: state_type] :
      ( v41043(VarCurr)
    <=> v41045(VarCurr) ) ).

tff(addAssignment_20463,axiom,
    ! [VarCurr: state_type] :
      ( v41045(VarCurr)
    <=> v41047(VarCurr) ) ).

tff(addAssignment_20462,axiom,
    ! [VarCurr: state_type] :
      ( v41047(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_20461,axiom,
    ! [VarCurr: state_type] :
      ( v40998(VarCurr)
    <=> v41000(VarCurr) ) ).

tff(addAssignment_20460,axiom,
    ! [VarCurr: state_type] :
      ( v41000(VarCurr)
    <=> v41002(VarCurr) ) ).

tff(addAssignment_20459,axiom,
    ! [VarCurr: state_type] :
      ( v41002(VarCurr)
    <=> v41004(VarCurr) ) ).

tff(addAssignment_20458,axiom,
    ! [VarCurr: state_type] :
      ( v41004(VarCurr)
    <=> v41006(VarCurr) ) ).

tff(addAssignment_20457,axiom,
    ! [VarCurr: state_type] :
      ( v41006(VarCurr)
    <=> v41008(VarCurr) ) ).

tff(addAssignment_20456,axiom,
    ! [VarCurr: state_type] :
      ( v41008(VarCurr)
    <=> v41010(VarCurr) ) ).

tff(addAssignment_20455,axiom,
    ! [VarCurr: state_type] :
      ( v41010(VarCurr)
    <=> v41012(VarCurr) ) ).

tff(writeUnaryOperator_2417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v41012(VarCurr)
    <=> v41026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3932,axiom,
    ! [VarCurr: state_type] :
      ( v41026(VarCurr)
    <=> ( v41027(VarCurr)
        | v41022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3931,axiom,
    ! [VarCurr: state_type] :
      ( v41027(VarCurr)
    <=> ( v41014(VarCurr)
        | v41018(VarCurr) ) ) ).

tff(addAssignment_20454,axiom,
    ! [VarCurr: state_type] :
      ( v41022(VarCurr)
    <=> v41024(VarCurr) ) ).

tff(addAssignment_20453,axiom,
    ! [VarCurr: state_type] :
      ( v41024(VarCurr)
    <=> v40595(VarCurr,2) ) ).

tff(addAssignment_20452,axiom,
    ! [VarCurr: state_type] :
      ( v41018(VarCurr)
    <=> v41020(VarCurr) ) ).

tff(addAssignment_20451,axiom,
    ! [VarCurr: state_type] :
      ( v41020(VarCurr)
    <=> v40595(VarCurr,1) ) ).

tff(addAssignment_20450,axiom,
    ! [VarCurr: state_type] :
      ( v41014(VarCurr)
    <=> v41016(VarCurr) ) ).

tff(addAssignment_20449,axiom,
    ! [VarCurr: state_type] :
      ( v41016(VarCurr)
    <=> v40678(VarCurr,0) ) ).

tff(addAssignment_20448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40867(VarCurr,B)
      <=> v40869(VarCurr,B) ) ) ).

tff(addAssignment_20447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40869(VarCurr,B)
      <=> v40871(VarCurr,B) ) ) ).

tff(addAssignment_20446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40871(VarCurr,B)
      <=> v40873(VarCurr,B) ) ) ).

tff(addAssignment_20445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40873(VarCurr,B)
      <=> v40875(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40981(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v40875(VarNext,B)
            <=> v40875(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_482,axiom,
    ! [VarNext: state_type] :
      ( v40981(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40875(VarNext,B)
          <=> v40991(VarNext,B) ) ) ) ).

tff(addAssignment_20444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40991(VarNext,B)
          <=> v40989(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40992(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40989(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_332,axiom,
    ! [VarCurr: state_type] :
      ( v40992(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40989(VarCurr,B)
          <=> v40897(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3930,axiom,
    ! [VarCurr: state_type] :
      ( v40992(VarCurr)
    <=> ( v40993(VarCurr)
        & v40994(VarCurr) ) ) ).

tff(writeUnaryOperator_2416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40994(VarCurr)
    <=> v40887(VarCurr) ) ).

tff(writeUnaryOperator_2415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40993(VarCurr)
    <=> v40877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40981(VarNext)
      <=> v40982(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3928,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40982(VarNext)
      <=> ( v40983(VarNext)
          & v40901(VarNext) ) ) ) ).

tff(writeUnaryOperator_2414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40983(VarNext)
      <=> v40985(VarNext) ) ) ).

tff(addAssignment_20443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40985(VarNext)
      <=> v40901(VarCurr) ) ) ).

tff(addAssignment_20442,axiom,
    ! [VarCurr: state_type] :
      ( v40901(VarCurr)
    <=> v40903(VarCurr) ) ).

tff(addAssignment_20441,axiom,
    ! [VarCurr: state_type] :
      ( v40903(VarCurr)
    <=> v40905(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3927,axiom,
    ! [VarCurr: state_type] :
      ( v40905(VarCurr)
    <=> ( v40978(VarCurr)
        | v40974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3926,axiom,
    ! [VarCurr: state_type] :
      ( v40978(VarCurr)
    <=> ( v40907(VarCurr)
        & v40911(VarCurr) ) ) ).

tff(addAssignment_20440,axiom,
    ! [VarCurr: state_type] :
      ( v40974(VarCurr)
    <=> v40976(VarCurr) ) ).

tff(addAssignment_20439,axiom,
    ! [VarCurr: state_type] :
      ( v40976(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40958(VarNext)
       => ( v40911(VarNext)
        <=> v40911(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_481,axiom,
    ! [VarNext: state_type] :
      ( v40958(VarNext)
     => ( v40911(VarNext)
      <=> v40968(VarNext) ) ) ).

tff(addAssignment_20438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40968(VarNext)
      <=> v40966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3925,axiom,
    ! [VarCurr: state_type] :
      ( v40966(VarCurr)
    <=> ( v40969(VarCurr)
        & v40970(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3924,axiom,
    ! [VarCurr: state_type] :
      ( v40970(VarCurr)
    <=> ( v40917(VarCurr)
        | v40953(VarCurr) ) ) ).

tff(writeUnaryOperator_2413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40969(VarCurr)
    <=> v40913(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40958(VarNext)
      <=> v40959(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3922,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40959(VarNext)
      <=> ( v40961(VarNext)
          & v40963(VarNext) ) ) ) ).

tff(writeUnaryOperator_2412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40963(VarCurr)
    <=> v40907(VarCurr) ) ).

tff(addAssignment_20437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40961(VarNext)
      <=> v40907(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_169,axiom,
    ( v40911(constB0)
  <=> $true ) ).

tff(addAssignment_20436,axiom,
    ! [VarCurr: state_type] :
      ( v40953(VarCurr)
    <=> v40955(VarCurr) ) ).

tff(addAssignment_20435,axiom,
    ! [VarCurr: state_type] :
      ( v40955(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20434,axiom,
    ! [VarCurr: state_type] :
      ( v40917(VarCurr)
    <=> v40919(VarCurr) ) ).

tff(addAssignment_20433,axiom,
    ! [VarCurr: state_type] :
      ( v40919(VarCurr)
    <=> v40921(VarCurr) ) ).

tff(addAssignment_20432,axiom,
    ! [VarCurr: state_type] :
      ( v40921(VarCurr)
    <=> v40923(VarCurr) ) ).

tff(addAssignment_20431,axiom,
    ! [VarCurr: state_type] :
      ( v40923(VarCurr)
    <=> v40925(VarCurr) ) ).

tff(writeUnaryOperator_2411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40925(VarCurr)
    <=> v40950(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3921,axiom,
    ! [VarCurr: state_type] :
      ( v40950(VarCurr)
    <=> ( v40951(VarCurr)
        | v40946(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3920,axiom,
    ! [VarCurr: state_type] :
      ( v40951(VarCurr)
    <=> ( v40927(VarCurr)
        | v40942(VarCurr) ) ) ).

tff(addAssignment_20430,axiom,
    ! [VarCurr: state_type] :
      ( v40946(VarCurr)
    <=> v40948(VarCurr) ) ).

tff(addAssignment_20429,axiom,
    ! [VarCurr: state_type] :
      ( v40948(VarCurr)
    <=> v40505(VarCurr,2) ) ).

tff(addAssignment_20428,axiom,
    ! [VarCurr: state_type] :
      ( v40942(VarCurr)
    <=> v40944(VarCurr) ) ).

tff(addAssignment_20427,axiom,
    ! [VarCurr: state_type] :
      ( v40944(VarCurr)
    <=> v40505(VarCurr,1) ) ).

tff(addAssignment_20426,axiom,
    ! [VarCurr: state_type] :
      ( v40927(VarCurr)
    <=> v40929(VarCurr) ) ).

tff(addAssignment_20425,axiom,
    ! [VarCurr: state_type] :
      ( v40929(VarCurr)
    <=> v40931(VarCurr,0) ) ).

tff(addAssignment_20424,axiom,
    ! [VarCurr: state_type] :
      ( v40931(VarCurr,0)
    <=> v40933(VarCurr,0) ) ).

tff(addAssignment_20423,axiom,
    ! [VarCurr: state_type] :
      ( v40933(VarCurr,0)
    <=> v40935(VarCurr,0) ) ).

tff(addAssignment_20422,axiom,
    ! [VarCurr: state_type] :
      ( v40935(VarCurr,0)
    <=> v40940(VarCurr,0) ) ).

tff(writeUnaryOperator_2410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40940(VarCurr,B)
      <=> ~ v40937(VarCurr,B) ) ) ).

tff(addAssignment_20421,axiom,
    ! [VarCurr: state_type] :
      ( v40937(VarCurr,0)
    <=> v40939(VarCurr,0) ) ).

tff(addAssignment_20420,axiom,
    ! [VarCurr: state_type] :
      ( v40939(VarCurr,0)
    <=> v40505(VarCurr,0) ) ).

tff(addAssignment_20419,axiom,
    ! [VarCurr: state_type] :
      ( v40913(VarCurr)
    <=> v40915(VarCurr) ) ).

tff(addAssignment_20418,axiom,
    ! [VarCurr: state_type] :
      ( v40915(VarCurr)
    <=> $false ) ).

tff(addAssignment_20417,axiom,
    ! [VarCurr: state_type] :
      ( v40907(VarCurr)
    <=> v40909(VarCurr) ) ).

tff(addAssignment_20416,axiom,
    ! [VarCurr: state_type] :
      ( v40909(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40897(VarCurr,B)
      <=> v40899(VarCurr,B) ) ) ).

tff(addAssignment_20414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40899(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20413,axiom,
    ! [VarCurr: state_type] :
      ( v40887(VarCurr)
    <=> v40889(VarCurr) ) ).

tff(addAssignment_20412,axiom,
    ! [VarCurr: state_type] :
      ( v40889(VarCurr)
    <=> v40891(VarCurr) ) ).

tff(addAssignment_20411,axiom,
    ! [VarCurr: state_type] :
      ( v40891(VarCurr)
    <=> v40893(VarCurr) ) ).

tff(addAssignment_20410,axiom,
    ! [VarCurr: state_type] :
      ( v40893(VarCurr)
    <=> v40895(VarCurr) ) ).

tff(addAssignment_20409,axiom,
    ! [VarCurr: state_type] :
      ( v40895(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20408,axiom,
    ! [VarCurr: state_type] :
      ( v40877(VarCurr)
    <=> v40879(VarCurr) ) ).

tff(addAssignment_20407,axiom,
    ! [VarCurr: state_type] :
      ( v40879(VarCurr)
    <=> v40881(VarCurr) ) ).

tff(addAssignment_20406,axiom,
    ! [VarCurr: state_type] :
      ( v40881(VarCurr)
    <=> v40883(VarCurr) ) ).

tff(addAssignment_20405,axiom,
    ! [VarCurr: state_type] :
      ( v40883(VarCurr)
    <=> v40885(VarCurr) ) ).

tff(addAssignment_20404,axiom,
    ! [VarCurr: state_type] :
      ( v40885(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_20403,axiom,
    ! [VarCurr: state_type] :
      ( v40575(VarCurr)
    <=> v40577(VarCurr) ) ).

tff(addAssignment_20402,axiom,
    ! [VarCurr: state_type] :
      ( v40577(VarCurr)
    <=> v40579(VarCurr) ) ).

tff(addAssignment_20401,axiom,
    ! [VarCurr: state_type] :
      ( v40579(VarCurr)
    <=> v40581(VarCurr) ) ).

tff(addAssignment_20400,axiom,
    ! [VarCurr: state_type] :
      ( v40581(VarCurr)
    <=> v40583(VarCurr) ) ).

tff(addAssignment_20399,axiom,
    ! [VarCurr: state_type] :
      ( v40583(VarCurr)
    <=> v40585(VarCurr) ) ).

tff(addAssignment_20398,axiom,
    ! [VarCurr: state_type] :
      ( v40585(VarCurr)
    <=> v40587(VarCurr) ) ).

tff(addAssignment_20397,axiom,
    ! [VarCurr: state_type] :
      ( v40587(VarCurr)
    <=> v40589(VarCurr) ) ).

tff(writeUnaryOperator_2409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40589(VarCurr)
    <=> v40864(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3919,axiom,
    ! [VarCurr: state_type] :
      ( v40864(VarCurr)
    <=> ( v40865(VarCurr)
        | v40860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3918,axiom,
    ! [VarCurr: state_type] :
      ( v40865(VarCurr)
    <=> ( v40591(VarCurr)
        | v40856(VarCurr) ) ) ).

tff(addAssignment_20396,axiom,
    ! [VarCurr: state_type] :
      ( v40860(VarCurr)
    <=> v40862(VarCurr) ) ).

tff(addAssignment_20395,axiom,
    ! [VarCurr: state_type] :
      ( v40862(VarCurr)
    <=> v40595(VarCurr,2) ) ).

tff(addAssignment_20394,axiom,
    ! [VarCurr: state_type] :
      ( v40856(VarCurr)
    <=> v40858(VarCurr) ) ).

tff(addAssignment_20393,axiom,
    ! [VarCurr: state_type] :
      ( v40858(VarCurr)
    <=> v40595(VarCurr,1) ) ).

tff(addAssignment_20392,axiom,
    ! [VarCurr: state_type] :
      ( v40591(VarCurr)
    <=> v40593(VarCurr) ) ).

tff(addAssignment_20391,axiom,
    ! [VarCurr: state_type] :
      ( v40593(VarCurr)
    <=> v40595(VarCurr,0) ) ).

tff(addAssignment_20390,axiom,
    ! [VarCurr: state_type] :
      ( v40595(VarCurr,0)
    <=> v40507(VarCurr,3) ) ).

tff(addAssignment_20389,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,3)
    <=> v40509(VarCurr,3) ) ).

tff(addAssignment_20388,axiom,
    ! [VarNext: state_type] :
      ( v40509(VarNext,3)
    <=> v40848(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40849(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v40848(VarNext,B)
            <=> v40509(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_480,axiom,
    ! [VarNext: state_type] :
      ( v40849(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40848(VarNext,B)
          <=> v40820(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40849(VarNext)
      <=> v40850(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40850(VarNext)
      <=> ( v40852(VarNext)
          & v40762(VarNext) ) ) ) ).

tff(writeUnaryOperator_2408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40852(VarNext)
      <=> v40814(VarNext) ) ) ).

tff(addAssignment_20387,axiom,
    ! [VarCurr: state_type] :
      ( v40619(VarCurr,3)
    <=> v40621(VarCurr,3) ) ).

tff(addAssignment_20386,axiom,
    ! [VarCurr: state_type] :
      ( v40621(VarCurr,3)
    <=> v40759(VarCurr,3) ) ).

tff(addAssignment_20385,axiom,
    ! [VarCurr: state_type] :
      ( v40623(VarCurr,0)
    <=> v40625(VarCurr,0) ) ).

tff(addAssignment_20384,axiom,
    ! [VarCurr: state_type] :
      ( v40625(VarCurr,0)
    <=> v40627(VarCurr,0) ) ).

tff(addAssignment_20383,axiom,
    ! [VarCurr: state_type] :
      ( v40627(VarCurr,0)
    <=> v40758(VarCurr,0) ) ).

tff(addAssignment_20382,axiom,
    ! [VarCurr: state_type] :
      ( v40695(VarCurr,0)
    <=> v40697(VarCurr,0) ) ).

tff(addAssignment_20381,axiom,
    ! [VarCurr: state_type] :
      ( v40697(VarCurr,0)
    <=> v40699(VarCurr,0) ) ).

tff(addAssignment_20380,axiom,
    ! [VarCurr: state_type] :
      ( v40699(VarCurr,0)
    <=> v40701(VarCurr,0) ) ).

tff(addAssignment_20379,axiom,
    ! [VarCurr: state_type] :
      ( v40701(VarCurr,0)
    <=> v40703(VarCurr,0) ) ).

tff(addAssignment_20378,axiom,
    ! [VarCurr: state_type] :
      ( v40703(VarCurr,0)
    <=> v40713(VarCurr,0) ) ).

tff(addAssignment_20377,axiom,
    ! [VarCurr: state_type] :
      ( v40629(VarCurr,0)
    <=> v40631(VarCurr,0) ) ).

tff(addAssignment_20376,axiom,
    ! [VarCurr: state_type] :
      ( v40631(VarCurr,0)
    <=> v40692(VarCurr,0) ) ).

tff(addAssignment_20375,axiom,
    ! [VarCurr: state_type] :
      ( v40633(VarCurr)
    <=> v40159(VarCurr,2) ) ).

tff(addAssignment_20374,axiom,
    ! [VarCurr: state_type] :
      ( v40159(VarCurr,2)
    <=> v40161(VarCurr,2) ) ).

tff(addAssignment_20373,axiom,
    ! [VarCurr: state_type] :
      ( v40161(VarCurr,2)
    <=> v40171(VarCurr,2) ) ).

tff(addAssignment_20372,axiom,
    ! [VarCurr: state_type] :
      ( v40163(VarCurr,2)
    <=> v40165(VarCurr,2) ) ).

tff(addAssignment_20371,axiom,
    ! [VarCurr: state_type] :
      ( v40165(VarCurr,2)
    <=> v40168(VarCurr,2) ) ).

tff(addAssignment_20370,axiom,
    ! [VarCurr: state_type] :
      ( v40169(VarCurr)
    <=> v40636(VarCurr,1) ) ).

tff(addAssignment_20369,axiom,
    ! [VarCurr: state_type] :
      ( v40636(VarCurr,1)
    <=> v40638(VarCurr,1) ) ).

tff(addAssignment_20368,axiom,
    ! [VarCurr: state_type] :
      ( v40638(VarCurr,1)
    <=> v40846(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v40846(VarCurr,B)
      <=> ( v40640(VarCurr,B)
          | v40646(VarCurr,B) ) ) ) ).

tff(addAssignment_20367,axiom,
    ! [VarCurr: state_type] :
      ( v40646(VarCurr,1)
    <=> v40648(VarCurr,1) ) ).

tff(addAssignment_20366,axiom,
    ! [VarCurr: state_type] :
      ( v40648(VarCurr,1)
    <=> v40844(VarCurr,1) ) ).

tff(addAssignment_20365,axiom,
    ! [VarCurr: state_type] :
      ( v40844(VarCurr,0)
    <=> v40845(VarCurr) ) ).

tff(addAssignment_20364,axiom,
    ! [VarCurr: state_type] :
      ( v40844(VarCurr,1)
    <=> v40650(VarCurr) ) ).

tff(addAssignment_20363,axiom,
    ! [VarCurr: state_type] :
      ( v40650(VarCurr)
    <=> v40652(VarCurr,1) ) ).

tff(addAssignment_20362,axiom,
    ! [VarCurr: state_type] :
      ( v40652(VarCurr,1)
    <=> v40654(VarCurr,1) ) ).

tff(addAssignment_20361,axiom,
    ! [VarCurr: state_type] :
      ( v40654(VarCurr,1)
    <=> v40843(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v40843(VarCurr,B)
      <=> ( v40656(VarCurr,B)
          & v40664(VarCurr,B) ) ) ) ).

tff(addAssignment_20360,axiom,
    ! [VarCurr: state_type] :
      ( v40664(VarCurr,1)
    <=> v40666(VarCurr,1) ) ).

tff(addAssignment_20359,axiom,
    ! [VarCurr: state_type] :
      ( v40666(VarCurr,1)
    <=> v40841(VarCurr,1) ) ).

tff(addAssignment_20358,axiom,
    ! [VarCurr: state_type] :
      ( v40841(VarCurr,0)
    <=> v40842(VarCurr) ) ).

tff(addAssignment_20357,axiom,
    ! [VarCurr: state_type] :
      ( v40841(VarCurr,1)
    <=> v40668(VarCurr) ) ).

tff(addAssignment_20356,axiom,
    ! [VarCurr: state_type] :
      ( v40668(VarCurr)
    <=> v40670(VarCurr) ) ).

tff(addAssignment_20355,axiom,
    ! [VarCurr: state_type] :
      ( v40670(VarCurr)
    <=> v40672(VarCurr) ) ).

tff(writeUnaryOperator_2407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40672(VarCurr)
    <=> v40839(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3915,axiom,
    ! [VarCurr: state_type] :
      ( v40839(VarCurr)
    <=> ( v40840(VarCurr)
        | v40827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3914,axiom,
    ! [VarCurr: state_type] :
      ( v40840(VarCurr)
    <=> ( v40674(VarCurr)
        | v40689(VarCurr) ) ) ).

tff(addAssignment_20354,axiom,
    ! [VarCurr: state_type] :
      ( v40827(VarCurr)
    <=> v40829(VarCurr) ) ).

tff(addAssignment_20353,axiom,
    ! [VarCurr: state_type] :
      ( v40829(VarCurr)
    <=> v40678(VarCurr,2) ) ).

tff(addAssignment_20352,axiom,
    ! [VarCurr: state_type] :
      ( v40678(VarCurr,2)
    <=> v40680(VarCurr,2) ) ).

tff(addAssignment_20351,axiom,
    ! [VarCurr: state_type] :
      ( v40680(VarCurr,2)
    <=> v40682(VarCurr,2) ) ).

tff(addAssignment_20350,axiom,
    ! [VarCurr: state_type] :
      ( v40682(VarCurr,2)
    <=> v40687(VarCurr,2) ) ).

tff(addAssignment_20349,axiom,
    ! [VarCurr: state_type] :
      ( v40684(VarCurr,2)
    <=> v40686(VarCurr,2) ) ).

tff(addAssignment_20348,axiom,
    ! [VarCurr: state_type] :
      ( v40686(VarCurr,2)
    <=> v40595(VarCurr,2) ) ).

tff(addAssignment_20347,axiom,
    ! [VarCurr: state_type] :
      ( v40595(VarCurr,2)
    <=> v40507(VarCurr,5) ) ).

tff(addAssignment_20346,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,5)
    <=> v40509(VarCurr,5) ) ).

tff(addAssignment_20345,axiom,
    ! [VarNext: state_type] :
      ( v40509(VarNext,5)
    <=> v40831(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_479,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40832(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v40831(VarNext,B)
            <=> v40509(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_479,axiom,
    ! [VarNext: state_type] :
      ( v40832(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40831(VarNext,B)
          <=> v40820(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40832(VarNext)
      <=> v40833(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3912,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40833(VarNext)
      <=> ( v40835(VarNext)
          & v40762(VarNext) ) ) ) ).

tff(writeUnaryOperator_2406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40835(VarNext)
      <=> v40814(VarNext) ) ) ).

tff(addAssignment_20344,axiom,
    ! [VarCurr: state_type] :
      ( v40619(VarCurr,5)
    <=> v40621(VarCurr,5) ) ).

tff(addAssignment_20343,axiom,
    ! [VarCurr: state_type] :
      ( v40621(VarCurr,5)
    <=> v40759(VarCurr,5) ) ).

tff(addAssignment_20342,axiom,
    ! [VarCurr: state_type] :
      ( v40623(VarCurr,2)
    <=> v40625(VarCurr,2) ) ).

tff(addAssignment_20341,axiom,
    ! [VarCurr: state_type] :
      ( v40625(VarCurr,2)
    <=> v40627(VarCurr,2) ) ).

tff(addAssignment_20340,axiom,
    ! [VarCurr: state_type] :
      ( v40627(VarCurr,2)
    <=> v40758(VarCurr,2) ) ).

tff(addAssignment_20339,axiom,
    ! [VarCurr: state_type] :
      ( v40695(VarCurr,2)
    <=> v40697(VarCurr,2) ) ).

tff(addAssignment_20338,axiom,
    ! [VarCurr: state_type] :
      ( v40697(VarCurr,2)
    <=> v40699(VarCurr,2) ) ).

tff(addAssignment_20337,axiom,
    ! [VarCurr: state_type] :
      ( v40699(VarCurr,2)
    <=> v40701(VarCurr,2) ) ).

tff(addAssignment_20336,axiom,
    ! [VarCurr: state_type] :
      ( v40701(VarCurr,2)
    <=> v40703(VarCurr,2) ) ).

tff(addAssignment_20335,axiom,
    ! [VarCurr: state_type] :
      ( v40703(VarCurr,2)
    <=> v40713(VarCurr,2) ) ).

tff(addAssignment_20334,axiom,
    ! [VarCurr: state_type] :
      ( v40705(VarCurr,2)
    <=> v40707(VarCurr,2) ) ).

tff(addAssignment_20333,axiom,
    ! [VarCurr: state_type] :
      ( v40707(VarCurr,2)
    <=> v40708(VarCurr,2) ) ).

tff(addAssignment_20332,axiom,
    ! [VarCurr: state_type] :
      ( v40629(VarCurr,2)
    <=> v40631(VarCurr,2) ) ).

tff(addAssignment_20331,axiom,
    ! [VarCurr: state_type] :
      ( v40631(VarCurr,2)
    <=> v40692(VarCurr,2) ) ).

tff(addAssignment_20330,axiom,
    ! [VarCurr: state_type] :
      ( v40689(VarCurr)
    <=> v40691(VarCurr) ) ).

tff(addAssignment_20329,axiom,
    ! [VarCurr: state_type] :
      ( v40691(VarCurr)
    <=> v40595(VarCurr,1) ) ).

tff(addAssignment_20328,axiom,
    ! [VarCurr: state_type] :
      ( v40595(VarCurr,1)
    <=> v40507(VarCurr,4) ) ).

tff(addAssignment_20327,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,4)
    <=> v40509(VarCurr,4) ) ).

tff(addAssignment_20326,axiom,
    ! [VarNext: state_type] :
      ( v40509(VarNext,4)
    <=> v40809(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40810(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v40809(VarNext,B)
            <=> v40509(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_478,axiom,
    ! [VarNext: state_type] :
      ( v40810(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40809(VarNext,B)
          <=> v40820(VarNext,B) ) ) ) ).

tff(addAssignment_20325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40820(VarNext,B)
          <=> v40818(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40821(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40818(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_331,axiom,
    ! [VarCurr: state_type] :
      ( v40821(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v40818(VarCurr,B)
          <=> v40619(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3911,axiom,
    ! [VarCurr: state_type] :
      ( v40821(VarCurr)
    <=> ( v40822(VarCurr)
        & v40823(VarCurr) ) ) ).

tff(writeUnaryOperator_2405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40823(VarCurr)
    <=> v40609(VarCurr) ) ).

tff(writeUnaryOperator_2404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40822(VarCurr)
    <=> v40597(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40810(VarNext)
      <=> v40811(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3909,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40811(VarNext)
      <=> ( v40812(VarNext)
          & v40762(VarNext) ) ) ) ).

tff(writeUnaryOperator_2403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40812(VarNext)
      <=> v40814(VarNext) ) ) ).

tff(addAssignment_20324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40814(VarNext)
      <=> v40762(VarCurr) ) ) ).

tff(addAssignment_20323,axiom,
    ! [VarCurr: state_type] :
      ( v40762(VarCurr)
    <=> v40764(VarCurr) ) ).

tff(addAssignment_20322,axiom,
    ! [VarCurr: state_type] :
      ( v40764(VarCurr)
    <=> v40766(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3908,axiom,
    ! [VarCurr: state_type] :
      ( v40766(VarCurr)
    <=> ( v40807(VarCurr)
        | v40803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3907,axiom,
    ! [VarCurr: state_type] :
      ( v40807(VarCurr)
    <=> ( v40768(VarCurr)
        & v40772(VarCurr) ) ) ).

tff(addAssignment_20321,axiom,
    ! [VarCurr: state_type] :
      ( v40803(VarCurr)
    <=> v40805(VarCurr) ) ).

tff(addAssignment_20320,axiom,
    ! [VarCurr: state_type] :
      ( v40805(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_477,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40787(VarNext)
       => ( v40772(VarNext)
        <=> v40772(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_477,axiom,
    ! [VarNext: state_type] :
      ( v40787(VarNext)
     => ( v40772(VarNext)
      <=> v40797(VarNext) ) ) ).

tff(addAssignment_20319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40797(VarNext)
      <=> v40795(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3906,axiom,
    ! [VarCurr: state_type] :
      ( v40795(VarCurr)
    <=> ( v40798(VarCurr)
        & v40799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3905,axiom,
    ! [VarCurr: state_type] :
      ( v40799(VarCurr)
    <=> ( v40778(VarCurr)
        | v40782(VarCurr) ) ) ).

tff(writeUnaryOperator_2402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40798(VarCurr)
    <=> v40774(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40787(VarNext)
      <=> v40788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40788(VarNext)
      <=> ( v40790(VarNext)
          & v40792(VarNext) ) ) ) ).

tff(writeUnaryOperator_2401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40792(VarCurr)
    <=> v40768(VarCurr) ) ).

tff(addAssignment_20318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40790(VarNext)
      <=> v40768(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_168,axiom,
    ( v40772(constB0)
  <=> $true ) ).

tff(addAssignment_20317,axiom,
    ! [VarCurr: state_type] :
      ( v40782(VarCurr)
    <=> v40784(VarCurr) ) ).

tff(addAssignment_20316,axiom,
    ! [VarCurr: state_type] :
      ( v40784(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20315,axiom,
    ! [VarCurr: state_type] :
      ( v40778(VarCurr)
    <=> v40780(VarCurr) ) ).

tff(addAssignment_20314,axiom,
    ! [VarCurr: state_type] :
      ( v40780(VarCurr)
    <=> $true ) ).

tff(addAssignment_20313,axiom,
    ! [VarCurr: state_type] :
      ( v40774(VarCurr)
    <=> v40776(VarCurr) ) ).

tff(addAssignment_20312,axiom,
    ! [VarCurr: state_type] :
      ( v40776(VarCurr)
    <=> $false ) ).

tff(addAssignment_20311,axiom,
    ! [VarCurr: state_type] :
      ( v40768(VarCurr)
    <=> v40770(VarCurr) ) ).

tff(addAssignment_20310,axiom,
    ! [VarCurr: state_type] :
      ( v40770(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20309,axiom,
    ! [VarCurr: state_type] :
      ( v40619(VarCurr,4)
    <=> v40621(VarCurr,4) ) ).

tff(addAssignment_20308,axiom,
    ! [VarCurr: state_type] :
      ( v40621(VarCurr,4)
    <=> v40759(VarCurr,4) ) ).

tff(addAssignment_20307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40759(VarCurr,B)
      <=> v40760(VarCurr,B) ) ) ).

tff(addAssignment_20306,axiom,
    ! [VarCurr: state_type] :
      ( ( v40759(VarCurr,5)
      <=> v40623(VarCurr,2) )
      & ( v40759(VarCurr,4)
      <=> v40623(VarCurr,1) )
      & ( v40759(VarCurr,3)
      <=> v40623(VarCurr,0) ) ) ).

tff(addAssignment_20305,axiom,
    ! [VarCurr: state_type] :
      ( v40623(VarCurr,1)
    <=> v40625(VarCurr,1) ) ).

tff(addAssignment_20304,axiom,
    ! [VarCurr: state_type] :
      ( v40625(VarCurr,1)
    <=> v40627(VarCurr,1) ) ).

tff(addAssignment_20303,axiom,
    ! [VarCurr: state_type] :
      ( v40627(VarCurr,1)
    <=> v40758(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40758(VarCurr,B)
      <=> ( v40629(VarCurr,B)
          & v40695(VarCurr,B) ) ) ) ).

tff(addAssignment_20302,axiom,
    ! [VarCurr: state_type] :
      ( v40695(VarCurr,1)
    <=> v40697(VarCurr,1) ) ).

tff(addAssignment_20301,axiom,
    ! [VarCurr: state_type] :
      ( v40697(VarCurr,1)
    <=> v40699(VarCurr,1) ) ).

tff(addAssignment_20300,axiom,
    ! [VarCurr: state_type] :
      ( v40699(VarCurr,1)
    <=> v40701(VarCurr,1) ) ).

tff(addAssignment_20299,axiom,
    ! [VarCurr: state_type] :
      ( v40701(VarCurr,1)
    <=> v40703(VarCurr,1) ) ).

tff(addAssignment_20298,axiom,
    ! [VarCurr: state_type] :
      ( v40703(VarCurr,1)
    <=> v40713(VarCurr,1) ) ).

tff(addAssignment_20297,axiom,
    ! [VarCurr: state_type] :
      ( v40713(VarCurr,0)
    <=> v40753(VarCurr) ) ).

tff(addAssignment_20296,axiom,
    ! [VarCurr: state_type] :
      ( v40713(VarCurr,1)
    <=> v40748(VarCurr) ) ).

tff(addAssignment_20295,axiom,
    ! [VarCurr: state_type] :
      ( v40713(VarCurr,2)
    <=> v40743(VarCurr) ) ).

tff(addAssignment_20294,axiom,
    ! [VarCurr: state_type] :
      ( v40713(VarCurr,3)
    <=> v40715(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3902,axiom,
    ! [VarCurr: state_type] :
      ( v40753(VarCurr)
    <=> ( v40754(VarCurr)
        & v40757(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3901,axiom,
    ! [VarCurr: state_type] :
      ( v40757(VarCurr)
    <=> ( v40705(VarCurr,0)
        | v40723(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3900,axiom,
    ! [VarCurr: state_type] :
      ( v40754(VarCurr)
    <=> ( v40755(VarCurr)
        | v40756(VarCurr) ) ) ).

tff(writeUnaryOperator_2400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40756(VarCurr)
    <=> v40723(VarCurr,0) ) ).

tff(writeUnaryOperator_2399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40755(VarCurr)
    <=> v40705(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3899,axiom,
    ! [VarCurr: state_type] :
      ( v40748(VarCurr)
    <=> ( v40749(VarCurr)
        & v40752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3898,axiom,
    ! [VarCurr: state_type] :
      ( v40752(VarCurr)
    <=> ( v40722(VarCurr)
        | v40724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3897,axiom,
    ! [VarCurr: state_type] :
      ( v40749(VarCurr)
    <=> ( v40750(VarCurr)
        | v40751(VarCurr) ) ) ).

tff(writeUnaryOperator_2398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40751(VarCurr)
    <=> v40724(VarCurr) ) ).

tff(writeUnaryOperator_2397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40750(VarCurr)
    <=> v40722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3896,axiom,
    ! [VarCurr: state_type] :
      ( v40743(VarCurr)
    <=> ( v40744(VarCurr)
        & v40747(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3895,axiom,
    ! [VarCurr: state_type] :
      ( v40747(VarCurr)
    <=> ( v40720(VarCurr)
        | v40730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3894,axiom,
    ! [VarCurr: state_type] :
      ( v40744(VarCurr)
    <=> ( v40745(VarCurr)
        | v40746(VarCurr) ) ) ).

tff(writeUnaryOperator_2396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40746(VarCurr)
    <=> v40730(VarCurr) ) ).

tff(writeUnaryOperator_2395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40745(VarCurr)
    <=> v40720(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3893,axiom,
    ! [VarCurr: state_type] :
      ( v40715(VarCurr)
    <=> ( v40716(VarCurr)
        & v40742(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3892,axiom,
    ! [VarCurr: state_type] :
      ( v40742(VarCurr)
    <=> ( v40718(VarCurr)
        | v40737(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3891,axiom,
    ! [VarCurr: state_type] :
      ( v40716(VarCurr)
    <=> ( v40717(VarCurr)
        | v40736(VarCurr) ) ) ).

tff(writeUnaryOperator_2394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40736(VarCurr)
    <=> v40737(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3890,axiom,
    ! [VarCurr: state_type] :
      ( v40737(VarCurr)
    <=> ( v40738(VarCurr)
        & v40741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_518,axiom,
    ! [VarCurr: state_type] :
      ( v40741(VarCurr)
    <=> ( v40705(VarCurr,3)
        | v40723(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3889,axiom,
    ! [VarCurr: state_type] :
      ( v40738(VarCurr)
    <=> ( v40739(VarCurr)
        | v40740(VarCurr) ) ) ).

tff(writeUnaryOperator_2393,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40740(VarCurr)
    <=> v40723(VarCurr,3) ) ).

tff(writeUnaryOperator_2392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40739(VarCurr)
    <=> v40705(VarCurr,3) ) ).

tff(writeUnaryOperator_2391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40717(VarCurr)
    <=> v40718(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3888,axiom,
    ! [VarCurr: state_type] :
      ( v40718(VarCurr)
    <=> ( v40719(VarCurr)
        | v40735(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_517,axiom,
    ! [VarCurr: state_type] :
      ( v40735(VarCurr)
    <=> ( v40705(VarCurr,2)
        & v40723(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3887,axiom,
    ! [VarCurr: state_type] :
      ( v40719(VarCurr)
    <=> ( v40720(VarCurr)
        & v40730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3886,axiom,
    ! [VarCurr: state_type] :
      ( v40730(VarCurr)
    <=> ( v40731(VarCurr)
        & v40734(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_516,axiom,
    ! [VarCurr: state_type] :
      ( v40734(VarCurr)
    <=> ( v40705(VarCurr,2)
        | v40723(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3885,axiom,
    ! [VarCurr: state_type] :
      ( v40731(VarCurr)
    <=> ( v40732(VarCurr)
        | v40733(VarCurr) ) ) ).

tff(writeUnaryOperator_2390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40733(VarCurr)
    <=> v40723(VarCurr,2) ) ).

tff(writeUnaryOperator_2389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40732(VarCurr)
    <=> v40705(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3884,axiom,
    ! [VarCurr: state_type] :
      ( v40720(VarCurr)
    <=> ( v40721(VarCurr)
        | v40729(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_515,axiom,
    ! [VarCurr: state_type] :
      ( v40729(VarCurr)
    <=> ( v40705(VarCurr,1)
        & v40723(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3883,axiom,
    ! [VarCurr: state_type] :
      ( v40721(VarCurr)
    <=> ( v40722(VarCurr)
        & v40724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3882,axiom,
    ! [VarCurr: state_type] :
      ( v40724(VarCurr)
    <=> ( v40725(VarCurr)
        & v40728(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_514,axiom,
    ! [VarCurr: state_type] :
      ( v40728(VarCurr)
    <=> ( v40705(VarCurr,1)
        | v40723(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3881,axiom,
    ! [VarCurr: state_type] :
      ( v40725(VarCurr)
    <=> ( v40726(VarCurr)
        | v40727(VarCurr) ) ) ).

tff(writeUnaryOperator_2388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40727(VarCurr)
    <=> v40723(VarCurr,1) ) ).

tff(writeUnaryOperator_2387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40726(VarCurr)
    <=> v40705(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3880,axiom,
    ! [VarCurr: state_type] :
      ( v40722(VarCurr)
    <=> ( v40705(VarCurr,0)
        & v40723(VarCurr,0) ) ) ).

tff(addAssignment_20293,axiom,
    ! [VarCurr: state_type] :
      ( v40723(VarCurr,0)
    <=> v40710(VarCurr) ) ).

tff(addAssignment_20292,axiom,
    ! [VarCurr: state_type] :
      ( ( v40723(VarCurr,3)
      <=> $false )
      & ( v40723(VarCurr,2)
      <=> $false )
      & ( v40723(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_20291,axiom,
    ! [VarCurr: state_type] :
      ( v40710(VarCurr)
    <=> v40712(VarCurr) ) ).

tff(addAssignment_20290,axiom,
    ! [VarCurr: state_type] :
      ( v40712(VarCurr)
    <=> v40660(VarCurr) ) ).

tff(addAssignment_20289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v40705(VarCurr,B)
      <=> v40707(VarCurr,B) ) ) ).

tff(addAssignment_20288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v40707(VarCurr,B)
      <=> v40708(VarCurr,B) ) ) ).

tff(addAssignment_20287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40708(VarCurr,B)
      <=> v40595(VarCurr,B) ) ) ).

tff(addAssignment_20286,axiom,
    ! [VarCurr: state_type] :
      ( v40708(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_20285,axiom,
    ! [VarCurr: state_type] :
      ( v40629(VarCurr,1)
    <=> v40631(VarCurr,1) ) ).

tff(addAssignment_20284,axiom,
    ! [VarCurr: state_type] :
      ( v40631(VarCurr,1)
    <=> v40692(VarCurr,1) ) ).

tff(addAssignment_20283,axiom,
    ! [VarCurr: state_type] :
      ( v40692(VarCurr,0)
    <=> v40693(VarCurr) ) ).

tff(addAssignment_20282,axiom,
    ! [VarCurr: state_type] :
      ( v40692(VarCurr,1)
    <=> v40693(VarCurr) ) ).

tff(addAssignment_20281,axiom,
    ! [VarCurr: state_type] :
      ( v40692(VarCurr,2)
    <=> v40693(VarCurr) ) ).

tff(addAssignment_20280,axiom,
    ! [VarCurr: state_type] :
      ( v40693(VarCurr)
    <=> v40633(VarCurr) ) ).

tff(addAssignment_20279,axiom,
    ! [VarCurr: state_type] :
      ( v40674(VarCurr)
    <=> v40676(VarCurr) ) ).

tff(addAssignment_20278,axiom,
    ! [VarCurr: state_type] :
      ( v40676(VarCurr)
    <=> v40678(VarCurr,0) ) ).

tff(addAssignment_20277,axiom,
    ! [VarCurr: state_type] :
      ( v40678(VarCurr,0)
    <=> v40680(VarCurr,0) ) ).

tff(addAssignment_20276,axiom,
    ! [VarCurr: state_type] :
      ( v40680(VarCurr,0)
    <=> v40682(VarCurr,0) ) ).

tff(addAssignment_20275,axiom,
    ! [VarCurr: state_type] :
      ( v40682(VarCurr,0)
    <=> v40687(VarCurr,0) ) ).

tff(writeUnaryOperator_2386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40687(VarCurr,B)
      <=> ~ v40684(VarCurr,B) ) ) ).

tff(addAssignment_20274,axiom,
    ! [VarCurr: state_type] :
      ( v40684(VarCurr,0)
    <=> v40686(VarCurr,0) ) ).

tff(addAssignment_20273,axiom,
    ! [VarCurr: state_type] :
      ( v40686(VarCurr,0)
    <=> v40595(VarCurr,0) ) ).

tff(addAssignment_20272,axiom,
    ! [VarCurr: state_type] :
      ( v40656(VarCurr,1)
    <=> v40658(VarCurr,1) ) ).

tff(addAssignment_20271,axiom,
    ! [VarCurr: state_type] :
      ( v40658(VarCurr,1)
    <=> v40661(VarCurr,1) ) ).

tff(addAssignment_20270,axiom,
    ! [VarCurr: state_type] :
      ( v40661(VarCurr,0)
    <=> v40662(VarCurr) ) ).

tff(addAssignment_20269,axiom,
    ! [VarCurr: state_type] :
      ( v40661(VarCurr,1)
    <=> v40660(VarCurr) ) ).

tff(addAssignment_20268,axiom,
    ! [VarCurr: state_type] :
      ( v40660(VarCurr)
    <=> v7230(VarCurr,6) ) ).

tff(addAssignment_20267,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,6)
    <=> v7232(VarCurr,6) ) ).

tff(addAssignment_20266,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,6)
    <=> v7234(VarCurr,6) ) ).

tff(addAssignment_20265,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,6)
    <=> v34455(VarCurr,6) ) ).

tff(addAssignment_20264,axiom,
    ! [VarCurr: state_type] :
      ( v40640(VarCurr,1)
    <=> v40642(VarCurr,1) ) ).

tff(addAssignment_20263,axiom,
    ! [VarCurr: state_type] :
      ( v40642(VarCurr,1)
    <=> v40643(VarCurr,1) ) ).

tff(addAssignment_20262,axiom,
    ! [VarCurr: state_type] :
      ( v40643(VarCurr,0)
    <=> v40644(VarCurr) ) ).

tff(addAssignment_20261,axiom,
    ! [VarCurr: state_type] :
      ( v40643(VarCurr,1)
    <=> v40644(VarCurr) ) ).

tff(addAssignment_20260,axiom,
    ! [VarCurr: state_type] :
      ( v40644(VarCurr)
    <=> v40167(VarCurr) ) ).

tff(addAssignment_20259,axiom,
    ! [VarCurr: state_type] :
      ( v40609(VarCurr)
    <=> v40611(VarCurr) ) ).

tff(addAssignment_20258,axiom,
    ! [VarCurr: state_type] :
      ( v40611(VarCurr)
    <=> v40613(VarCurr) ) ).

tff(addAssignment_20257,axiom,
    ! [VarCurr: state_type] :
      ( v40613(VarCurr)
    <=> v40615(VarCurr) ) ).

tff(addAssignment_20256,axiom,
    ! [VarCurr: state_type] :
      ( v40615(VarCurr)
    <=> v40617(VarCurr) ) ).

tff(addAssignment_20255,axiom,
    ! [VarCurr: state_type] :
      ( v40617(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_20254,axiom,
    ! [VarCurr: state_type] :
      ( v40597(VarCurr)
    <=> v40599(VarCurr) ) ).

tff(addAssignment_20253,axiom,
    ! [VarCurr: state_type] :
      ( v40599(VarCurr)
    <=> v40601(VarCurr) ) ).

tff(addAssignment_20252,axiom,
    ! [VarCurr: state_type] :
      ( v40601(VarCurr)
    <=> v40603(VarCurr) ) ).

tff(addAssignment_20251,axiom,
    ! [VarCurr: state_type] :
      ( v40603(VarCurr)
    <=> v40605(VarCurr) ) ).

tff(addAssignment_20250,axiom,
    ! [VarCurr: state_type] :
      ( v40605(VarCurr)
    <=> v40607(VarCurr) ) ).

tff(addAssignment_20249,axiom,
    ! [VarCurr: state_type] :
      ( v40607(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_20248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40105(VarCurr,B)
      <=> v40107(VarCurr,B) ) ) ).

tff(addAssignment_20247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40107(VarCurr,B)
      <=> v40109(VarCurr,B) ) ) ).

tff(addAssignment_20246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40109(VarCurr,B)
      <=> v40111(VarCurr,B) ) ) ).

tff(addAssignment_20245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40111(VarCurr,B)
      <=> v40113(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40558(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v40113(VarNext,B)
            <=> v40113(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_476,axiom,
    ! [VarNext: state_type] :
      ( v40558(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40113(VarNext,B)
          <=> v40568(VarNext,B) ) ) ) ).

tff(addAssignment_20244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40568(VarNext,B)
          <=> v40566(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40566(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_330,axiom,
    ! [VarCurr: state_type] :
      ( v40569(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40566(VarCurr,B)
          <=> v40143(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3879,axiom,
    ! [VarCurr: state_type] :
      ( v40569(VarCurr)
    <=> ( v40570(VarCurr)
        & v40571(VarCurr) ) ) ).

tff(writeUnaryOperator_2385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40571(VarCurr)
    <=> v40129(VarCurr) ) ).

tff(writeUnaryOperator_2384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40570(VarCurr)
    <=> v40115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40558(VarNext)
      <=> v40559(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40559(VarNext)
      <=> ( v40560(VarNext)
          & v40473(VarNext) ) ) ) ).

tff(writeUnaryOperator_2383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40560(VarNext)
      <=> v40562(VarNext) ) ) ).

tff(addAssignment_20243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40562(VarNext)
      <=> v40473(VarCurr) ) ) ).

tff(addAssignment_20242,axiom,
    ! [VarCurr: state_type] :
      ( v40473(VarCurr)
    <=> v40475(VarCurr) ) ).

tff(addAssignment_20241,axiom,
    ! [VarCurr: state_type] :
      ( v40475(VarCurr)
    <=> v40477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3876,axiom,
    ! [VarCurr: state_type] :
      ( v40477(VarCurr)
    <=> ( v40555(VarCurr)
        | v40547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3875,axiom,
    ! [VarCurr: state_type] :
      ( v40555(VarCurr)
    <=> ( v40479(VarCurr)
        & v40485(VarCurr) ) ) ).

tff(addAssignment_20240,axiom,
    ! [VarCurr: state_type] :
      ( v40547(VarCurr)
    <=> v40549(VarCurr) ) ).

tff(addAssignment_20239,axiom,
    ! [VarCurr: state_type] :
      ( v40549(VarCurr)
    <=> v40551(VarCurr) ) ).

tff(addAssignment_20238,axiom,
    ! [VarCurr: state_type] :
      ( v40551(VarCurr)
    <=> v40553(VarCurr) ) ).

tff(addAssignment_20237,axiom,
    ! [VarCurr: state_type] :
      ( v40553(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40531(VarNext)
       => ( v40485(VarNext)
        <=> v40485(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_475,axiom,
    ! [VarNext: state_type] :
      ( v40531(VarNext)
     => ( v40485(VarNext)
      <=> v40541(VarNext) ) ) ).

tff(addAssignment_20236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40541(VarNext)
      <=> v40539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3874,axiom,
    ! [VarCurr: state_type] :
      ( v40539(VarCurr)
    <=> ( v40542(VarCurr)
        & v40543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3873,axiom,
    ! [VarCurr: state_type] :
      ( v40543(VarCurr)
    <=> ( v40491(VarCurr)
        | v40522(VarCurr) ) ) ).

tff(writeUnaryOperator_2382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40542(VarCurr)
    <=> v40487(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40531(VarNext)
      <=> v40532(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40532(VarNext)
      <=> ( v40534(VarNext)
          & v40536(VarNext) ) ) ) ).

tff(writeUnaryOperator_2381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40536(VarCurr)
    <=> v40479(VarCurr) ) ).

tff(addAssignment_20235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40534(VarNext)
      <=> v40479(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_167,axiom,
    ( v40485(constB0)
  <=> $true ) ).

tff(addAssignment_20234,axiom,
    ! [VarCurr: state_type] :
      ( v40522(VarCurr)
    <=> v40524(VarCurr) ) ).

tff(addAssignment_20233,axiom,
    ! [VarCurr: state_type] :
      ( v40524(VarCurr)
    <=> v40526(VarCurr) ) ).

tff(addAssignment_20232,axiom,
    ! [VarCurr: state_type] :
      ( v40526(VarCurr)
    <=> v40528(VarCurr) ) ).

tff(addAssignment_20231,axiom,
    ! [VarCurr: state_type] :
      ( v40528(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_20230,axiom,
    ! [VarCurr: state_type] :
      ( v40491(VarCurr)
    <=> v40493(VarCurr) ) ).

tff(addAssignment_20229,axiom,
    ! [VarCurr: state_type] :
      ( v40493(VarCurr)
    <=> v40495(VarCurr) ) ).

tff(addAssignment_20228,axiom,
    ! [VarCurr: state_type] :
      ( v40495(VarCurr)
    <=> v40497(VarCurr) ) ).

tff(addAssignment_20227,axiom,
    ! [VarCurr: state_type] :
      ( v40497(VarCurr)
    <=> v40499(VarCurr) ) ).

tff(writeUnaryOperator_2380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40499(VarCurr)
    <=> v40519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3870,axiom,
    ! [VarCurr: state_type] :
      ( v40519(VarCurr)
    <=> ( v40520(VarCurr)
        | v40515(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3869,axiom,
    ! [VarCurr: state_type] :
      ( v40520(VarCurr)
    <=> ( v40501(VarCurr)
        | v40511(VarCurr) ) ) ).

tff(addAssignment_20226,axiom,
    ! [VarCurr: state_type] :
      ( v40515(VarCurr)
    <=> v40517(VarCurr) ) ).

tff(addAssignment_20225,axiom,
    ! [VarCurr: state_type] :
      ( v40517(VarCurr)
    <=> v40505(VarCurr,2) ) ).

tff(addAssignment_20224,axiom,
    ! [VarCurr: state_type] :
      ( v40505(VarCurr,2)
    <=> v40507(VarCurr,2) ) ).

tff(addAssignment_20223,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,2)
    <=> v40509(VarCurr,2) ) ).

tff(addAssignment_20222,axiom,
    ! [VarCurr: state_type] :
      ( v40511(VarCurr)
    <=> v40513(VarCurr) ) ).

tff(addAssignment_20221,axiom,
    ! [VarCurr: state_type] :
      ( v40513(VarCurr)
    <=> v40505(VarCurr,1) ) ).

tff(addAssignment_20220,axiom,
    ! [VarCurr: state_type] :
      ( v40505(VarCurr,1)
    <=> v40507(VarCurr,1) ) ).

tff(addAssignment_20219,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,1)
    <=> v40509(VarCurr,1) ) ).

tff(addAssignment_20218,axiom,
    ! [VarCurr: state_type] :
      ( v40501(VarCurr)
    <=> v40503(VarCurr) ) ).

tff(addAssignment_20217,axiom,
    ! [VarCurr: state_type] :
      ( v40503(VarCurr)
    <=> v40505(VarCurr,0) ) ).

tff(addAssignment_20216,axiom,
    ! [VarCurr: state_type] :
      ( v40505(VarCurr,0)
    <=> v40507(VarCurr,0) ) ).

tff(addAssignment_20215,axiom,
    ! [VarCurr: state_type] :
      ( v40507(VarCurr,0)
    <=> v40509(VarCurr,0) ) ).

tff(addAssignment_20214,axiom,
    ! [VarCurr: state_type] :
      ( v40487(VarCurr)
    <=> v40489(VarCurr) ) ).

tff(addAssignment_20213,axiom,
    ! [VarCurr: state_type] :
      ( v40489(VarCurr)
    <=> $false ) ).

tff(addAssignment_20212,axiom,
    ! [VarCurr: state_type] :
      ( v40479(VarCurr)
    <=> v40481(VarCurr) ) ).

tff(addAssignment_20211,axiom,
    ! [VarCurr: state_type] :
      ( v40481(VarCurr)
    <=> v40483(VarCurr) ) ).

tff(addAssignment_20210,axiom,
    ! [VarCurr: state_type] :
      ( v40483(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_20209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40143(VarCurr,B)
      <=> v40145(VarCurr,B) ) ) ).

tff(addAssignment_20208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40145(VarCurr,B)
      <=> v40147(VarCurr,B) ) ) ).

tff(addAssignment_20207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40147(VarCurr,B)
      <=> v40149(VarCurr,B) ) ) ).

tff(addAssignment_20206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40149(VarCurr,B)
      <=> v40151(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40151(VarCurr,B)
      <=> ( v40153(VarCurr,B)
          & v40175(VarCurr,B) ) ) ) ).

tff(addAssignment_20205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40175(VarCurr,B)
      <=> v40177(VarCurr,B) ) ) ).

tff(addAssignment_20204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40177(VarCurr,B)
      <=> v40179(VarCurr,B) ) ) ).

tff(addAssignment_20203,axiom,
    ! [VarCurr: state_type] :
      ( ( v40179(VarCurr,11)
      <=> v6324(VarCurr,83) )
      & ( v40179(VarCurr,10)
      <=> v6324(VarCurr,82) )
      & ( v40179(VarCurr,9)
      <=> v6324(VarCurr,81) )
      & ( v40179(VarCurr,8)
      <=> v6324(VarCurr,80) )
      & ( v40179(VarCurr,7)
      <=> v6324(VarCurr,79) )
      & ( v40179(VarCurr,6)
      <=> v6324(VarCurr,78) )
      & ( v40179(VarCurr,5)
      <=> v6324(VarCurr,77) )
      & ( v40179(VarCurr,4)
      <=> v6324(VarCurr,76) )
      & ( v40179(VarCurr,3)
      <=> v6324(VarCurr,75) )
      & ( v40179(VarCurr,2)
      <=> v6324(VarCurr,74) )
      & ( v40179(VarCurr,1)
      <=> v6324(VarCurr,73) )
      & ( v40179(VarCurr,0)
      <=> v6324(VarCurr,72) ) ) ).

tff(addAssignment_20202,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,83)
      <=> v40181(VarCurr,11) )
      & ( v6324(VarCurr,82)
      <=> v40181(VarCurr,10) )
      & ( v6324(VarCurr,81)
      <=> v40181(VarCurr,9) )
      & ( v6324(VarCurr,80)
      <=> v40181(VarCurr,8) )
      & ( v6324(VarCurr,79)
      <=> v40181(VarCurr,7) )
      & ( v6324(VarCurr,78)
      <=> v40181(VarCurr,6) )
      & ( v6324(VarCurr,77)
      <=> v40181(VarCurr,5) )
      & ( v6324(VarCurr,76)
      <=> v40181(VarCurr,4) )
      & ( v6324(VarCurr,75)
      <=> v40181(VarCurr,3) )
      & ( v6324(VarCurr,74)
      <=> v40181(VarCurr,2) )
      & ( v6324(VarCurr,73)
      <=> v40181(VarCurr,1) )
      & ( v6324(VarCurr,72)
      <=> v40181(VarCurr,0) ) ) ).

tff(addAssignment_20201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40181(VarCurr,B)
      <=> v40183(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40183(VarCurr,B)
      <=> ( v40465(VarCurr,B)
          | v40468(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40468(VarCurr,B)
      <=> ( v40193(VarCurr,B)
          & v40469(VarCurr,B) ) ) ) ).

tff(addAssignment_20200,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,0)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20199,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,1)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20198,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,2)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20197,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,3)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20196,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,4)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20195,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,5)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20194,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,6)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20193,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,7)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20192,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,8)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20191,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,9)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20190,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,10)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20189,axiom,
    ! [VarCurr: state_type] :
      ( v40469(VarCurr,11)
    <=> v40470(VarCurr) ) ).

tff(addAssignment_20188,axiom,
    ! [VarCurr: state_type] :
      ( v40470(VarCurr)
    <=> v40461(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40465(VarCurr,B)
      <=> ( v40185(VarCurr,B)
          & v40466(VarCurr,B) ) ) ) ).

tff(addAssignment_20187,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,0)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20186,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,1)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20185,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,2)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20184,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,3)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20183,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,4)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20182,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,5)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20181,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,6)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20180,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,7)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20179,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,8)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20178,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,9)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20177,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,10)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20176,axiom,
    ! [VarCurr: state_type] :
      ( v40466(VarCurr,11)
    <=> v40467(VarCurr) ) ).

tff(addAssignment_20175,axiom,
    ! [VarCurr: state_type] :
      ( v40467(VarCurr)
    <=> v40189(VarCurr) ) ).

tff(addAssignment_20174,axiom,
    ! [VarCurr: state_type] :
      ( v40461(VarCurr)
    <=> v40463(VarCurr) ) ).

tff(addAssignment_20173,axiom,
    ! [VarCurr: state_type] :
      ( v40463(VarCurr)
    <=> v7021(VarCurr,6) ) ).

tff(addAssignment_20172,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,6)
    <=> v7023(VarCurr,6) ) ).

tff(addAssignment_20171,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,6)
    <=> v6623(VarCurr,6) ) ).

tff(addAssignment_20170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40193(VarCurr,B)
      <=> v40195(VarCurr,B) ) ) ).

tff(addAssignment_20169,axiom,
    ! [VarCurr: state_type] :
      ( ( v40195(VarCurr,11)
      <=> v6334(VarCurr,95) )
      & ( v40195(VarCurr,10)
      <=> v6334(VarCurr,94) )
      & ( v40195(VarCurr,9)
      <=> v6334(VarCurr,93) )
      & ( v40195(VarCurr,8)
      <=> v6334(VarCurr,92) )
      & ( v40195(VarCurr,7)
      <=> v6334(VarCurr,91) )
      & ( v40195(VarCurr,6)
      <=> v6334(VarCurr,90) )
      & ( v40195(VarCurr,5)
      <=> v6334(VarCurr,89) )
      & ( v40195(VarCurr,4)
      <=> v6334(VarCurr,88) )
      & ( v40195(VarCurr,3)
      <=> v6334(VarCurr,87) )
      & ( v40195(VarCurr,2)
      <=> v6334(VarCurr,86) )
      & ( v40195(VarCurr,1)
      <=> v6334(VarCurr,85) )
      & ( v40195(VarCurr,0)
      <=> v6334(VarCurr,84) ) ) ).

tff(addAssignment_20168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,96)
        & ~ $less(B,84) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_20167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,96)
        & ~ $less(B,84) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_20166,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,95)
      <=> v40197(VarCurr,11) )
      & ( v6338(VarCurr,94)
      <=> v40197(VarCurr,10) )
      & ( v6338(VarCurr,93)
      <=> v40197(VarCurr,9) )
      & ( v6338(VarCurr,92)
      <=> v40197(VarCurr,8) )
      & ( v6338(VarCurr,91)
      <=> v40197(VarCurr,7) )
      & ( v6338(VarCurr,90)
      <=> v40197(VarCurr,6) )
      & ( v6338(VarCurr,89)
      <=> v40197(VarCurr,5) )
      & ( v6338(VarCurr,88)
      <=> v40197(VarCurr,4) )
      & ( v6338(VarCurr,87)
      <=> v40197(VarCurr,3) )
      & ( v6338(VarCurr,86)
      <=> v40197(VarCurr,2) )
      & ( v6338(VarCurr,85)
      <=> v40197(VarCurr,1) )
      & ( v6338(VarCurr,84)
      <=> v40197(VarCurr,0) ) ) ).

tff(addAssignment_20165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40197(VarCurr,B)
      <=> v40199(VarCurr,B) ) ) ).

tff(addAssignment_20164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40199(VarCurr,B)
      <=> v40201(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40444(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v40201(VarNext,B)
            <=> v40201(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_474,axiom,
    ! [VarNext: state_type] :
      ( v40444(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40201(VarNext,B)
          <=> v40454(VarNext,B) ) ) ) ).

tff(addAssignment_20163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40454(VarNext,B)
          <=> v40452(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40455(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40452(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_329,axiom,
    ! [VarCurr: state_type] :
      ( v40455(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40452(VarCurr,B)
          <=> v40231(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3868,axiom,
    ! [VarCurr: state_type] :
      ( v40455(VarCurr)
    <=> ( v40456(VarCurr)
        & v40457(VarCurr) ) ) ).

tff(writeUnaryOperator_2379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40457(VarCurr)
    <=> v40217(VarCurr) ) ).

tff(writeUnaryOperator_2378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40456(VarCurr)
    <=> v40203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40444(VarNext)
      <=> v40445(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40445(VarNext)
      <=> ( v40446(VarNext)
          & v40419(VarNext) ) ) ) ).

tff(writeUnaryOperator_2377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40446(VarNext)
      <=> v40448(VarNext) ) ) ).

tff(addAssignment_20162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40448(VarNext)
      <=> v40419(VarCurr) ) ) ).

tff(addAssignment_20161,axiom,
    ! [VarCurr: state_type] :
      ( v40419(VarCurr)
    <=> v40421(VarCurr) ) ).

tff(addAssignment_20160,axiom,
    ! [VarCurr: state_type] :
      ( v40421(VarCurr)
    <=> v40423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3865,axiom,
    ! [VarCurr: state_type] :
      ( v40423(VarCurr)
    <=> ( v40441(VarCurr)
        | v40433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3864,axiom,
    ! [VarCurr: state_type] :
      ( v40441(VarCurr)
    <=> ( v40425(VarCurr)
        & v40431(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_166,axiom,
    ( v40431(constB0)
  <=> $true ) ).

tff(addAssignment_20159,axiom,
    ! [VarCurr: state_type] :
      ( v40433(VarCurr)
    <=> v40435(VarCurr) ) ).

tff(addAssignment_20158,axiom,
    ! [VarCurr: state_type] :
      ( v40435(VarCurr)
    <=> v40437(VarCurr) ) ).

tff(addAssignment_20157,axiom,
    ! [VarCurr: state_type] :
      ( v40437(VarCurr)
    <=> v40439(VarCurr) ) ).

tff(addAssignment_20156,axiom,
    ! [VarCurr: state_type] :
      ( v40439(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_20155,axiom,
    ! [VarCurr: state_type] :
      ( v40425(VarCurr)
    <=> v40427(VarCurr) ) ).

tff(addAssignment_20154,axiom,
    ! [VarCurr: state_type] :
      ( v40427(VarCurr)
    <=> v40429(VarCurr) ) ).

tff(addAssignment_20153,axiom,
    ! [VarCurr: state_type] :
      ( v40429(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_20152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40231(VarCurr,B)
      <=> v40233(VarCurr,B) ) ) ).

tff(addAssignment_20151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40233(VarCurr,B)
      <=> v40235(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40235(VarCurr,B)
      <=> ( v40404(VarCurr,B)
          | v40415(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40415(VarCurr,B)
      <=> ( v40368(VarCurr,B)
          & v40416(VarCurr,B) ) ) ) ).

tff(addAssignment_20150,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,0)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20149,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,1)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20148,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,2)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20147,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,3)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20146,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,4)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20145,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,5)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20144,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,6)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20143,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,7)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20142,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,8)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20141,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,9)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20140,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,10)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20139,axiom,
    ! [VarCurr: state_type] :
      ( v40416(VarCurr,11)
    <=> v40417(VarCurr) ) ).

tff(addAssignment_20138,axiom,
    ! [VarCurr: state_type] :
      ( v40417(VarCurr)
    <=> v40378(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40404(VarCurr,B)
      <=> ( v40405(VarCurr,B)
          | v40412(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40412(VarCurr,B)
      <=> ( v40332(VarCurr,B)
          & v40413(VarCurr,B) ) ) ) ).

tff(addAssignment_20137,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,0)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20136,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,1)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20135,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,2)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20134,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,3)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20133,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,4)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20132,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,5)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20131,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,6)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20130,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,7)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20129,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,8)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20128,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,9)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20127,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,10)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20126,axiom,
    ! [VarCurr: state_type] :
      ( v40413(VarCurr,11)
    <=> v40414(VarCurr) ) ).

tff(addAssignment_20125,axiom,
    ! [VarCurr: state_type] :
      ( v40414(VarCurr)
    <=> v40342(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40405(VarCurr,B)
      <=> ( v40406(VarCurr,B)
          | v40409(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40409(VarCurr,B)
      <=> ( v40285(VarCurr,B)
          & v40410(VarCurr,B) ) ) ) ).

tff(addAssignment_20124,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,0)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20123,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,1)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20122,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,2)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20121,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,3)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20120,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,4)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20119,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,5)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20118,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,6)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20117,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,7)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20116,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,8)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20115,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,9)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20114,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,10)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20113,axiom,
    ! [VarCurr: state_type] :
      ( v40410(VarCurr,11)
    <=> v40411(VarCurr) ) ).

tff(addAssignment_20112,axiom,
    ! [VarCurr: state_type] :
      ( v40411(VarCurr)
    <=> v40295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40406(VarCurr,B)
      <=> ( v40237(VarCurr,B)
          & v40407(VarCurr,B) ) ) ) ).

tff(addAssignment_20111,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,0)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20110,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,1)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20109,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,2)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20108,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,3)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20107,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,4)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20106,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,5)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20105,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,6)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20104,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,7)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20103,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,8)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20102,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,9)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20101,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,10)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20100,axiom,
    ! [VarCurr: state_type] :
      ( v40407(VarCurr,11)
    <=> v40408(VarCurr) ) ).

tff(addAssignment_20099,axiom,
    ! [VarCurr: state_type] :
      ( v40408(VarCurr)
    <=> v40247(VarCurr) ) ).

tff(addAssignment_20098,axiom,
    ! [VarCurr: state_type] :
      ( v40378(VarCurr)
    <=> v40380(VarCurr) ) ).

tff(addAssignment_20097,axiom,
    ! [VarCurr: state_type] :
      ( v40380(VarCurr)
    <=> v40382(VarCurr) ) ).

tff(addAssignment_20096,axiom,
    ! [VarCurr: state_type] :
      ( v40382(VarCurr)
    <=> v40384(VarCurr) ) ).

tff(addAssignment_20095,axiom,
    ! [VarCurr: state_type] :
      ( v40384(VarCurr)
    <=> v40386(VarCurr) ) ).

tff(addAssignment_20094,axiom,
    ! [VarCurr: state_type] :
      ( v40386(VarCurr)
    <=> v40388(VarCurr) ) ).

tff(addAssignment_20093,axiom,
    ! [VarCurr: state_type] :
      ( v40388(VarCurr)
    <=> v40390(VarCurr) ) ).

tff(addAssignment_20092,axiom,
    ! [VarCurr: state_type] :
      ( v40390(VarCurr)
    <=> v40392(VarCurr) ) ).

tff(writeUnaryOperator_2376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40392(VarCurr)
    <=> v40402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3863,axiom,
    ! [VarCurr: state_type] :
      ( v40402(VarCurr)
    <=> ( v40394(VarCurr)
        | v40398(VarCurr) ) ) ).

tff(addAssignment_20091,axiom,
    ! [VarCurr: state_type] :
      ( v40398(VarCurr)
    <=> v40400(VarCurr) ) ).

tff(addAssignment_20090,axiom,
    ! [VarCurr: state_type] :
      ( v40400(VarCurr)
    <=> v40315(VarCurr,1) ) ).

tff(addAssignment_20089,axiom,
    ! [VarCurr: state_type] :
      ( v40394(VarCurr)
    <=> v40396(VarCurr) ) ).

tff(addAssignment_20088,axiom,
    ! [VarCurr: state_type] :
      ( v40396(VarCurr)
    <=> v40315(VarCurr,0) ) ).

tff(addAssignment_20087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40368(VarCurr,B)
      <=> v40370(VarCurr,B) ) ) ).

tff(addAssignment_20086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40370(VarCurr,B)
      <=> v40372(VarCurr,B) ) ) ).

tff(addAssignment_20085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40372(VarCurr,B)
      <=> v40374(VarCurr,B) ) ) ).

tff(addAssignment_20084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40374(VarCurr,B)
      <=> v40376(VarCurr,B) ) ) ).

tff(addAssignment_20083,axiom,
    ! [VarCurr: state_type] :
      ( v40342(VarCurr)
    <=> v40344(VarCurr) ) ).

tff(addAssignment_20082,axiom,
    ! [VarCurr: state_type] :
      ( v40344(VarCurr)
    <=> v40346(VarCurr) ) ).

tff(addAssignment_20081,axiom,
    ! [VarCurr: state_type] :
      ( v40346(VarCurr)
    <=> v40348(VarCurr) ) ).

tff(addAssignment_20080,axiom,
    ! [VarCurr: state_type] :
      ( v40348(VarCurr)
    <=> v40350(VarCurr) ) ).

tff(addAssignment_20079,axiom,
    ! [VarCurr: state_type] :
      ( v40350(VarCurr)
    <=> v40352(VarCurr) ) ).

tff(addAssignment_20078,axiom,
    ! [VarCurr: state_type] :
      ( v40352(VarCurr)
    <=> v40354(VarCurr) ) ).

tff(addAssignment_20077,axiom,
    ! [VarCurr: state_type] :
      ( v40354(VarCurr)
    <=> v40356(VarCurr) ) ).

tff(writeUnaryOperator_2375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40356(VarCurr)
    <=> v40366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3862,axiom,
    ! [VarCurr: state_type] :
      ( v40366(VarCurr)
    <=> ( v40358(VarCurr)
        | v40362(VarCurr) ) ) ).

tff(addAssignment_20076,axiom,
    ! [VarCurr: state_type] :
      ( v40362(VarCurr)
    <=> v40364(VarCurr) ) ).

tff(addAssignment_20075,axiom,
    ! [VarCurr: state_type] :
      ( v40364(VarCurr)
    <=> v40315(VarCurr,1) ) ).

tff(addAssignment_20074,axiom,
    ! [VarCurr: state_type] :
      ( v40315(VarCurr,1)
    <=> v40317(VarCurr,1) ) ).

tff(addAssignment_20073,axiom,
    ! [VarCurr: state_type] :
      ( v40317(VarCurr,1)
    <=> v40319(VarCurr,1) ) ).

tff(addAssignment_20072,axiom,
    ! [VarCurr: state_type] :
      ( v40319(VarCurr,1)
    <=> v40324(VarCurr,1) ) ).

tff(addAssignment_20071,axiom,
    ! [VarCurr: state_type] :
      ( v40321(VarCurr,1)
    <=> v40323(VarCurr,1) ) ).

tff(addAssignment_20070,axiom,
    ! [VarCurr: state_type] :
      ( v40323(VarCurr,1)
    <=> v40267(VarCurr,1) ) ).

tff(addAssignment_20069,axiom,
    ! [VarCurr: state_type] :
      ( v40358(VarCurr)
    <=> v40360(VarCurr) ) ).

tff(addAssignment_20068,axiom,
    ! [VarCurr: state_type] :
      ( v40360(VarCurr)
    <=> v40267(VarCurr,0) ) ).

tff(addAssignment_20067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40332(VarCurr,B)
      <=> v40334(VarCurr,B) ) ) ).

tff(addAssignment_20066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40334(VarCurr,B)
      <=> v40336(VarCurr,B) ) ) ).

tff(addAssignment_20065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40336(VarCurr,B)
      <=> v40338(VarCurr,B) ) ) ).

tff(addAssignment_20064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40338(VarCurr,B)
      <=> v40340(VarCurr,B) ) ) ).

tff(addAssignment_20063,axiom,
    ! [VarCurr: state_type] :
      ( v40295(VarCurr)
    <=> v40297(VarCurr) ) ).

tff(addAssignment_20062,axiom,
    ! [VarCurr: state_type] :
      ( v40297(VarCurr)
    <=> v40299(VarCurr) ) ).

tff(addAssignment_20061,axiom,
    ! [VarCurr: state_type] :
      ( v40299(VarCurr)
    <=> v40301(VarCurr) ) ).

tff(addAssignment_20060,axiom,
    ! [VarCurr: state_type] :
      ( v40301(VarCurr)
    <=> v40303(VarCurr) ) ).

tff(addAssignment_20059,axiom,
    ! [VarCurr: state_type] :
      ( v40303(VarCurr)
    <=> v40305(VarCurr) ) ).

tff(addAssignment_20058,axiom,
    ! [VarCurr: state_type] :
      ( v40305(VarCurr)
    <=> v40307(VarCurr) ) ).

tff(addAssignment_20057,axiom,
    ! [VarCurr: state_type] :
      ( v40307(VarCurr)
    <=> v40309(VarCurr) ) ).

tff(writeUnaryOperator_2374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40309(VarCurr)
    <=> v40330(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3861,axiom,
    ! [VarCurr: state_type] :
      ( v40330(VarCurr)
    <=> ( v40311(VarCurr)
        | v40326(VarCurr) ) ) ).

tff(addAssignment_20056,axiom,
    ! [VarCurr: state_type] :
      ( v40326(VarCurr)
    <=> v40328(VarCurr) ) ).

tff(addAssignment_20055,axiom,
    ! [VarCurr: state_type] :
      ( v40328(VarCurr)
    <=> v40267(VarCurr,1) ) ).

tff(addAssignment_20054,axiom,
    ! [VarCurr: state_type] :
      ( v40311(VarCurr)
    <=> v40313(VarCurr) ) ).

tff(addAssignment_20053,axiom,
    ! [VarCurr: state_type] :
      ( v40313(VarCurr)
    <=> v40315(VarCurr,0) ) ).

tff(addAssignment_20052,axiom,
    ! [VarCurr: state_type] :
      ( v40315(VarCurr,0)
    <=> v40317(VarCurr,0) ) ).

tff(addAssignment_20051,axiom,
    ! [VarCurr: state_type] :
      ( v40317(VarCurr,0)
    <=> v40319(VarCurr,0) ) ).

tff(addAssignment_20050,axiom,
    ! [VarCurr: state_type] :
      ( v40319(VarCurr,0)
    <=> v40324(VarCurr,0) ) ).

tff(writeUnaryOperator_2373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v40324(VarCurr,B)
      <=> ~ v40321(VarCurr,B) ) ) ).

tff(addAssignment_20049,axiom,
    ! [VarCurr: state_type] :
      ( v40321(VarCurr,0)
    <=> v40323(VarCurr,0) ) ).

tff(addAssignment_20048,axiom,
    ! [VarCurr: state_type] :
      ( v40323(VarCurr,0)
    <=> v40267(VarCurr,0) ) ).

tff(addAssignment_20047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40285(VarCurr,B)
      <=> v40287(VarCurr,B) ) ) ).

tff(addAssignment_20046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40287(VarCurr,B)
      <=> v40289(VarCurr,B) ) ) ).

tff(addAssignment_20045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40289(VarCurr,B)
      <=> v40291(VarCurr,B) ) ) ).

tff(addAssignment_20044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40291(VarCurr,B)
      <=> v40293(VarCurr,B) ) ) ).

tff(addAssignment_20043,axiom,
    ! [VarCurr: state_type] :
      ( v40247(VarCurr)
    <=> v40249(VarCurr) ) ).

tff(addAssignment_20042,axiom,
    ! [VarCurr: state_type] :
      ( v40249(VarCurr)
    <=> v40251(VarCurr) ) ).

tff(addAssignment_20041,axiom,
    ! [VarCurr: state_type] :
      ( v40251(VarCurr)
    <=> v40253(VarCurr) ) ).

tff(addAssignment_20040,axiom,
    ! [VarCurr: state_type] :
      ( v40253(VarCurr)
    <=> v40255(VarCurr) ) ).

tff(addAssignment_20039,axiom,
    ! [VarCurr: state_type] :
      ( v40255(VarCurr)
    <=> v40257(VarCurr) ) ).

tff(addAssignment_20038,axiom,
    ! [VarCurr: state_type] :
      ( v40257(VarCurr)
    <=> v40259(VarCurr) ) ).

tff(addAssignment_20037,axiom,
    ! [VarCurr: state_type] :
      ( v40259(VarCurr)
    <=> v40261(VarCurr) ) ).

tff(writeUnaryOperator_2372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40261(VarCurr)
    <=> v40283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3860,axiom,
    ! [VarCurr: state_type] :
      ( v40283(VarCurr)
    <=> ( v40263(VarCurr)
        | v40279(VarCurr) ) ) ).

tff(addAssignment_20036,axiom,
    ! [VarCurr: state_type] :
      ( v40279(VarCurr)
    <=> v40281(VarCurr) ) ).

tff(addAssignment_20035,axiom,
    ! [VarCurr: state_type] :
      ( v40281(VarCurr)
    <=> v40267(VarCurr,1) ) ).

tff(addAssignment_20034,axiom,
    ! [VarCurr: state_type] :
      ( v40267(VarCurr,1)
    <=> v40269(VarCurr,1) ) ).

tff(addAssignment_20033,axiom,
    ! [VarCurr: state_type] :
      ( v40269(VarCurr,1)
    <=> v40271(VarCurr,1) ) ).

tff(addAssignment_20032,axiom,
    ! [VarCurr: state_type] :
      ( v40271(VarCurr,1)
    <=> v40273(VarCurr,1) ) ).

tff(addAssignment_20031,axiom,
    ! [VarCurr: state_type] :
      ( v40273(VarCurr,1)
    <=> v40275(VarCurr,1) ) ).

tff(addAssignment_20030,axiom,
    ! [VarCurr: state_type] :
      ( v40275(VarCurr,1)
    <=> v40277(VarCurr,1) ) ).

tff(addAssignment_20029,axiom,
    ! [VarCurr: state_type] :
      ( v40263(VarCurr)
    <=> v40265(VarCurr) ) ).

tff(addAssignment_20028,axiom,
    ! [VarCurr: state_type] :
      ( v40265(VarCurr)
    <=> v40267(VarCurr,0) ) ).

tff(addAssignment_20027,axiom,
    ! [VarCurr: state_type] :
      ( v40267(VarCurr,0)
    <=> v40269(VarCurr,0) ) ).

tff(addAssignment_20026,axiom,
    ! [VarCurr: state_type] :
      ( v40269(VarCurr,0)
    <=> v40271(VarCurr,0) ) ).

tff(addAssignment_20025,axiom,
    ! [VarCurr: state_type] :
      ( v40271(VarCurr,0)
    <=> v40273(VarCurr,0) ) ).

tff(addAssignment_20024,axiom,
    ! [VarCurr: state_type] :
      ( v40273(VarCurr,0)
    <=> v40275(VarCurr,0) ) ).

tff(addAssignment_20023,axiom,
    ! [VarCurr: state_type] :
      ( v40275(VarCurr,0)
    <=> v40277(VarCurr,0) ) ).

tff(addAssignment_20022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40237(VarCurr,B)
      <=> v40239(VarCurr,B) ) ) ).

tff(addAssignment_20021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40239(VarCurr,B)
      <=> v40241(VarCurr,B) ) ) ).

tff(addAssignment_20020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40241(VarCurr,B)
      <=> v40243(VarCurr,B) ) ) ).

tff(addAssignment_20019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40243(VarCurr,B)
      <=> v40245(VarCurr,B) ) ) ).

tff(addAssignment_20018,axiom,
    ! [VarCurr: state_type] :
      ( v40217(VarCurr)
    <=> v40219(VarCurr) ) ).

tff(addAssignment_20017,axiom,
    ! [VarCurr: state_type] :
      ( v40219(VarCurr)
    <=> v40221(VarCurr) ) ).

tff(addAssignment_20016,axiom,
    ! [VarCurr: state_type] :
      ( v40221(VarCurr)
    <=> v40223(VarCurr) ) ).

tff(addAssignment_20015,axiom,
    ! [VarCurr: state_type] :
      ( v40223(VarCurr)
    <=> v40225(VarCurr) ) ).

tff(addAssignment_20014,axiom,
    ! [VarCurr: state_type] :
      ( v40225(VarCurr)
    <=> v40227(VarCurr) ) ).

tff(addAssignment_20013,axiom,
    ! [VarCurr: state_type] :
      ( v40227(VarCurr)
    <=> v40229(VarCurr) ) ).

tff(addAssignment_20012,axiom,
    ! [VarCurr: state_type] :
      ( v40229(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_20011,axiom,
    ! [VarCurr: state_type] :
      ( v40203(VarCurr)
    <=> v40205(VarCurr) ) ).

tff(addAssignment_20010,axiom,
    ! [VarCurr: state_type] :
      ( v40205(VarCurr)
    <=> v40207(VarCurr) ) ).

tff(addAssignment_20009,axiom,
    ! [VarCurr: state_type] :
      ( v40207(VarCurr)
    <=> v40209(VarCurr) ) ).

tff(addAssignment_20008,axiom,
    ! [VarCurr: state_type] :
      ( v40209(VarCurr)
    <=> v40211(VarCurr) ) ).

tff(addAssignment_20007,axiom,
    ! [VarCurr: state_type] :
      ( v40211(VarCurr)
    <=> v40213(VarCurr) ) ).

tff(addAssignment_20006,axiom,
    ! [VarCurr: state_type] :
      ( v40213(VarCurr)
    <=> v40215(VarCurr) ) ).

tff(addAssignment_20005,axiom,
    ! [VarCurr: state_type] :
      ( v40215(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_20004,axiom,
    ! [VarCurr: state_type] :
      ( v40189(VarCurr)
    <=> v40191(VarCurr) ) ).

tff(addAssignment_20003,axiom,
    ! [VarCurr: state_type] :
      ( v40191(VarCurr)
    <=> v6617(VarCurr,6) ) ).

tff(addAssignment_20002,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,6)
    <=> v6619(VarCurr,6) ) ).

tff(addAssignment_20001,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,6)
    <=> v6621(VarCurr,6) ) ).

tff(addAssignment_20000,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,6)
    <=> v6747(VarCurr,6) ) ).

tff(addAssignment_19999,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,6)
    <=> v6690(VarCurr,6) ) ).

tff(addAssignment_19998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40185(VarCurr,B)
      <=> v40187(VarCurr,B) ) ) ).

tff(addAssignment_19997,axiom,
    ! [VarCurr: state_type] :
      ( ( v40187(VarCurr,11)
      <=> v6334(VarCurr,83) )
      & ( v40187(VarCurr,10)
      <=> v6334(VarCurr,82) )
      & ( v40187(VarCurr,9)
      <=> v6334(VarCurr,81) )
      & ( v40187(VarCurr,8)
      <=> v6334(VarCurr,80) )
      & ( v40187(VarCurr,7)
      <=> v6334(VarCurr,79) )
      & ( v40187(VarCurr,6)
      <=> v6334(VarCurr,78) )
      & ( v40187(VarCurr,5)
      <=> v6334(VarCurr,77) )
      & ( v40187(VarCurr,4)
      <=> v6334(VarCurr,76) )
      & ( v40187(VarCurr,3)
      <=> v6334(VarCurr,75) )
      & ( v40187(VarCurr,2)
      <=> v6334(VarCurr,74) )
      & ( v40187(VarCurr,1)
      <=> v6334(VarCurr,73) )
      & ( v40187(VarCurr,0)
      <=> v6334(VarCurr,72) ) ) ).

tff(addAssignment_19996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40153(VarCurr,B)
      <=> v40155(VarCurr,B) ) ) ).

tff(addAssignment_19995,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,0)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19994,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,1)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19993,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,2)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19992,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,3)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19991,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,4)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19990,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,5)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19989,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,6)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19988,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,7)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19987,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,8)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19986,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,9)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19985,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,10)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19984,axiom,
    ! [VarCurr: state_type] :
      ( v40155(VarCurr,11)
    <=> v40173(VarCurr) ) ).

tff(addAssignment_19983,axiom,
    ! [VarCurr: state_type] :
      ( v40173(VarCurr)
    <=> v40157(VarCurr) ) ).

tff(addAssignment_19982,axiom,
    ! [VarCurr: state_type] :
      ( v40157(VarCurr)
    <=> v40159(VarCurr,0) ) ).

tff(addAssignment_19981,axiom,
    ! [VarCurr: state_type] :
      ( v40159(VarCurr,0)
    <=> v40161(VarCurr,0) ) ).

tff(addAssignment_19980,axiom,
    ! [VarCurr: state_type] :
      ( v40161(VarCurr,0)
    <=> v40171(VarCurr,0) ) ).

tff(writeUnaryOperator_2371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v40171(VarCurr,B)
      <=> ~ v40163(VarCurr,B) ) ) ).

tff(addAssignment_19979,axiom,
    ! [VarCurr: state_type] :
      ( v40163(VarCurr,0)
    <=> v40165(VarCurr,0) ) ).

tff(addAssignment_19978,axiom,
    ! [VarCurr: state_type] :
      ( v40165(VarCurr,0)
    <=> v40168(VarCurr,0) ) ).

tff(addAssignment_19977,axiom,
    ! [VarCurr: state_type] :
      ( v40168(VarCurr,0)
    <=> v40167(VarCurr) ) ).

tff(addAssignment_19976,axiom,
    ! [VarCurr: state_type] :
      ( v40168(VarCurr,1)
    <=> v40170(VarCurr) ) ).

tff(addAssignment_19975,axiom,
    ! [VarCurr: state_type] :
      ( v40168(VarCurr,2)
    <=> v40169(VarCurr) ) ).

tff(addAssignment_19974,axiom,
    ! [VarCurr: state_type] :
      ( v40167(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_19973,axiom,
    ! [VarCurr: state_type] :
      ( v40129(VarCurr)
    <=> v40131(VarCurr) ) ).

tff(addAssignment_19972,axiom,
    ! [VarCurr: state_type] :
      ( v40131(VarCurr)
    <=> v40133(VarCurr) ) ).

tff(addAssignment_19971,axiom,
    ! [VarCurr: state_type] :
      ( v40133(VarCurr)
    <=> v40135(VarCurr) ) ).

tff(addAssignment_19970,axiom,
    ! [VarCurr: state_type] :
      ( v40135(VarCurr)
    <=> v40137(VarCurr) ) ).

tff(addAssignment_19969,axiom,
    ! [VarCurr: state_type] :
      ( v40137(VarCurr)
    <=> v40139(VarCurr) ) ).

tff(addAssignment_19968,axiom,
    ! [VarCurr: state_type] :
      ( v40139(VarCurr)
    <=> v40141(VarCurr) ) ).

tff(addAssignment_19967,axiom,
    ! [VarCurr: state_type] :
      ( v40141(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_19966,axiom,
    ! [VarCurr: state_type] :
      ( v40115(VarCurr)
    <=> v40117(VarCurr) ) ).

tff(addAssignment_19965,axiom,
    ! [VarCurr: state_type] :
      ( v40117(VarCurr)
    <=> v40119(VarCurr) ) ).

tff(addAssignment_19964,axiom,
    ! [VarCurr: state_type] :
      ( v40119(VarCurr)
    <=> v40121(VarCurr) ) ).

tff(addAssignment_19963,axiom,
    ! [VarCurr: state_type] :
      ( v40121(VarCurr)
    <=> v40123(VarCurr) ) ).

tff(addAssignment_19962,axiom,
    ! [VarCurr: state_type] :
      ( v40123(VarCurr)
    <=> v40125(VarCurr) ) ).

tff(addAssignment_19961,axiom,
    ! [VarCurr: state_type] :
      ( v40125(VarCurr)
    <=> v40127(VarCurr) ) ).

tff(addAssignment_19960,axiom,
    ! [VarCurr: state_type] :
      ( v40127(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_19959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40091(VarCurr,B)
      <=> v40093(VarCurr,B) ) ) ).

tff(addAssignment_19958,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40093(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_19957,axiom,
    ! [VarCurr: state_type] :
      ( v38535(VarCurr)
    <=> v38537(VarCurr) ) ).

tff(addAssignment_19956,axiom,
    ! [VarCurr: state_type] :
      ( v38537(VarCurr)
    <=> v38539(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_208,axiom,
    ! [VarCurr: state_type] :
      ( v38539(VarCurr)
    <=> ( ( v38541(VarCurr,11)
        <=> v38545(VarCurr,11) )
        & ( v38541(VarCurr,10)
        <=> v38545(VarCurr,10) )
        & ( v38541(VarCurr,9)
        <=> v38545(VarCurr,9) )
        & ( v38541(VarCurr,8)
        <=> v38545(VarCurr,8) )
        & ( v38541(VarCurr,7)
        <=> v38545(VarCurr,7) )
        & ( v38541(VarCurr,6)
        <=> v38545(VarCurr,6) )
        & ( v38541(VarCurr,5)
        <=> v38545(VarCurr,5) )
        & ( v38541(VarCurr,4)
        <=> v38545(VarCurr,4) )
        & ( v38541(VarCurr,3)
        <=> v38545(VarCurr,3) )
        & ( v38541(VarCurr,2)
        <=> v38545(VarCurr,2) )
        & ( v38541(VarCurr,1)
        <=> v38545(VarCurr,1) )
        & ( v38541(VarCurr,0)
        <=> v38545(VarCurr,0) ) ) ) ).

tff(addAssignment_19955,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38545(VarCurr,B)
      <=> v38547(VarCurr,B) ) ) ).

tff(addAssignment_19954,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38547(VarCurr,B)
      <=> v38549(VarCurr,B) ) ) ).

tff(addAssignment_19953,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38549(VarCurr,B)
      <=> v38551(VarCurr,B) ) ) ).

tff(addAssignment_19952,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38551(VarCurr,B)
      <=> v38553(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38553(VarCurr,B)
      <=> ( v40061(VarCurr,B)
          | v40080(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40080(VarCurr,B)
      <=> ( v39932(VarCurr,B)
          & v40081(VarCurr,B) ) ) ) ).

tff(addAssignment_19951,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,0)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19950,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,1)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19949,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,2)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19948,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,3)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19947,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,4)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19946,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,5)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19945,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,6)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19944,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,7)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19943,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,8)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19942,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,9)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19941,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,10)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19940,axiom,
    ! [VarCurr: state_type] :
      ( v40081(VarCurr,11)
    <=> v40082(VarCurr) ) ).

tff(addAssignment_19939,axiom,
    ! [VarCurr: state_type] :
      ( v40082(VarCurr)
    <=> v40051(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40061(VarCurr,B)
      <=> ( v40062(VarCurr,B)
          | v40077(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40077(VarCurr,B)
      <=> ( v39781(VarCurr,B)
          & v40078(VarCurr,B) ) ) ) ).

tff(addAssignment_19938,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,0)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19937,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,1)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19936,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,2)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19935,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,3)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19934,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,4)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19933,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,5)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19932,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,6)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19931,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,7)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19930,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,8)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19929,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,9)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19928,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,10)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19927,axiom,
    ! [VarCurr: state_type] :
      ( v40078(VarCurr,11)
    <=> v40079(VarCurr) ) ).

tff(addAssignment_19926,axiom,
    ! [VarCurr: state_type] :
      ( v40079(VarCurr)
    <=> v39901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_637,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40062(VarCurr,B)
      <=> ( v40063(VarCurr,B)
          | v40074(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40074(VarCurr,B)
      <=> ( v39630(VarCurr,B)
          & v40075(VarCurr,B) ) ) ) ).

tff(addAssignment_19925,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,0)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19924,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,1)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19923,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,2)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19922,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,3)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19921,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,4)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19920,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,5)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19919,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,6)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19918,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,7)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19917,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,8)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19916,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,9)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19915,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,10)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19914,axiom,
    ! [VarCurr: state_type] :
      ( v40075(VarCurr,11)
    <=> v40076(VarCurr) ) ).

tff(addAssignment_19913,axiom,
    ! [VarCurr: state_type] :
      ( v40076(VarCurr)
    <=> v39750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40063(VarCurr,B)
      <=> ( v40064(VarCurr,B)
          | v40071(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40071(VarCurr,B)
      <=> ( v39479(VarCurr,B)
          & v40072(VarCurr,B) ) ) ) ).

tff(addAssignment_19912,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,0)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19911,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,1)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19910,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,2)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19909,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,3)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19908,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,4)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19907,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,5)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19906,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,6)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19905,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,7)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19904,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,8)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19903,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,9)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19902,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,10)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19901,axiom,
    ! [VarCurr: state_type] :
      ( v40072(VarCurr,11)
    <=> v40073(VarCurr) ) ).

tff(addAssignment_19900,axiom,
    ! [VarCurr: state_type] :
      ( v40073(VarCurr)
    <=> v39599(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40064(VarCurr,B)
      <=> ( v40065(VarCurr,B)
          | v40068(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40068(VarCurr,B)
      <=> ( v39317(VarCurr,B)
          & v40069(VarCurr,B) ) ) ) ).

tff(addAssignment_19899,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,0)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19898,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,1)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19897,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,2)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19896,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,3)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19895,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,4)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19894,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,5)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19893,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,6)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19892,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,7)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19891,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,8)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19890,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,9)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19889,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,10)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19888,axiom,
    ! [VarCurr: state_type] :
      ( v40069(VarCurr,11)
    <=> v40070(VarCurr) ) ).

tff(addAssignment_19887,axiom,
    ! [VarCurr: state_type] :
      ( v40070(VarCurr)
    <=> v39448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v40065(VarCurr,B)
      <=> ( v38555(VarCurr,B)
          & v40066(VarCurr,B) ) ) ) ).

tff(addAssignment_19886,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,0)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19885,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,1)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19884,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,2)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19883,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,3)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19882,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,4)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19881,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,5)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19880,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,6)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19879,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,7)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19878,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,8)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19877,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,9)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19876,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,10)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19875,axiom,
    ! [VarCurr: state_type] :
      ( v40066(VarCurr,11)
    <=> v40067(VarCurr) ) ).

tff(addAssignment_19874,axiom,
    ! [VarCurr: state_type] :
      ( v40067(VarCurr)
    <=> v39025(VarCurr) ) ).

tff(addAssignment_19873,axiom,
    ! [VarCurr: state_type] :
      ( v40051(VarCurr)
    <=> v40053(VarCurr) ) ).

tff(addAssignment_19872,axiom,
    ! [VarCurr: state_type] :
      ( v40053(VarCurr)
    <=> v40055(VarCurr) ) ).

tff(addAssignment_19871,axiom,
    ! [VarCurr: state_type] :
      ( v40055(VarCurr)
    <=> v40057(VarCurr) ) ).

tff(addAssignment_19870,axiom,
    ! [VarCurr: state_type] :
      ( v40057(VarCurr)
    <=> v40059(VarCurr) ) ).

tff(addAssignment_19869,axiom,
    ! [VarCurr: state_type] :
      ( v40059(VarCurr)
    <=> v39118(VarCurr) ) ).

tff(addAssignment_19868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39932(VarCurr,B)
      <=> v39934(VarCurr,B) ) ) ).

tff(addAssignment_19867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39934(VarCurr,B)
      <=> v39936(VarCurr,B) ) ) ).

tff(addAssignment_19866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39936(VarCurr,B)
      <=> v39938(VarCurr,B) ) ) ).

tff(addAssignment_19865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39938(VarCurr,B)
      <=> v39940(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40034(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v39940(VarNext,B)
            <=> v39940(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_473,axiom,
    ! [VarNext: state_type] :
      ( v40034(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39940(VarNext,B)
          <=> v40044(VarNext,B) ) ) ) ).

tff(addAssignment_19864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40044(VarNext,B)
          <=> v40042(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40042(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_328,axiom,
    ! [VarCurr: state_type] :
      ( v40045(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v40042(VarCurr,B)
          <=> v39962(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3859,axiom,
    ! [VarCurr: state_type] :
      ( v40045(VarCurr)
    <=> ( v40046(VarCurr)
        & v40047(VarCurr) ) ) ).

tff(writeUnaryOperator_2370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40047(VarCurr)
    <=> v39952(VarCurr) ) ).

tff(writeUnaryOperator_2369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40046(VarCurr)
    <=> v39942(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40034(VarNext)
      <=> v40035(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40035(VarNext)
      <=> ( v40036(VarNext)
          & v39966(VarNext) ) ) ) ).

tff(writeUnaryOperator_2368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40036(VarNext)
      <=> v40038(VarNext) ) ) ).

tff(addAssignment_19863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40038(VarNext)
      <=> v39966(VarCurr) ) ) ).

tff(addAssignment_19862,axiom,
    ! [VarCurr: state_type] :
      ( v39966(VarCurr)
    <=> v39968(VarCurr) ) ).

tff(addAssignment_19861,axiom,
    ! [VarCurr: state_type] :
      ( v39968(VarCurr)
    <=> v39970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3856,axiom,
    ! [VarCurr: state_type] :
      ( v39970(VarCurr)
    <=> ( v40031(VarCurr)
        | v40027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3855,axiom,
    ! [VarCurr: state_type] :
      ( v40031(VarCurr)
    <=> ( v39972(VarCurr)
        & v39976(VarCurr) ) ) ).

tff(addAssignment_19860,axiom,
    ! [VarCurr: state_type] :
      ( v40027(VarCurr)
    <=> v40029(VarCurr) ) ).

tff(addAssignment_19859,axiom,
    ! [VarCurr: state_type] :
      ( v40029(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v40011(VarNext)
       => ( v39976(VarNext)
        <=> v39976(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_472,axiom,
    ! [VarNext: state_type] :
      ( v40011(VarNext)
     => ( v39976(VarNext)
      <=> v40021(VarNext) ) ) ).

tff(addAssignment_19858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40021(VarNext)
      <=> v40019(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3854,axiom,
    ! [VarCurr: state_type] :
      ( v40019(VarCurr)
    <=> ( v40022(VarCurr)
        & v40023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3853,axiom,
    ! [VarCurr: state_type] :
      ( v40023(VarCurr)
    <=> ( v39982(VarCurr)
        | v40006(VarCurr) ) ) ).

tff(writeUnaryOperator_2367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40022(VarCurr)
    <=> v39978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3852,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40011(VarNext)
      <=> v40012(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3851,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40012(VarNext)
      <=> ( v40014(VarNext)
          & v40016(VarNext) ) ) ) ).

tff(writeUnaryOperator_2366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v40016(VarCurr)
    <=> v39972(VarCurr) ) ).

tff(addAssignment_19857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v40014(VarNext)
      <=> v39972(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_165,axiom,
    ( v39976(constB0)
  <=> $true ) ).

tff(addAssignment_19856,axiom,
    ! [VarCurr: state_type] :
      ( v40006(VarCurr)
    <=> v40008(VarCurr) ) ).

tff(addAssignment_19855,axiom,
    ! [VarCurr: state_type] :
      ( v40008(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19854,axiom,
    ! [VarCurr: state_type] :
      ( v39982(VarCurr)
    <=> v39984(VarCurr) ) ).

tff(addAssignment_19853,axiom,
    ! [VarCurr: state_type] :
      ( v39984(VarCurr)
    <=> v39292(VarCurr) ) ).

tff(addAssignment_19852,axiom,
    ! [VarCurr: state_type] :
      ( v39292(VarCurr)
    <=> v39987(VarCurr) ) ).

tff(addAssignment_19851,axiom,
    ! [VarCurr: state_type] :
      ( v39987(VarCurr)
    <=> v39989(VarCurr) ) ).

tff(writeUnaryOperator_2365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39989(VarCurr)
    <=> v40003(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3850,axiom,
    ! [VarCurr: state_type] :
      ( v40003(VarCurr)
    <=> ( v40004(VarCurr)
        | v39999(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3849,axiom,
    ! [VarCurr: state_type] :
      ( v40004(VarCurr)
    <=> ( v39991(VarCurr)
        | v39995(VarCurr) ) ) ).

tff(addAssignment_19850,axiom,
    ! [VarCurr: state_type] :
      ( v39999(VarCurr)
    <=> v40001(VarCurr) ) ).

tff(addAssignment_19849,axiom,
    ! [VarCurr: state_type] :
      ( v40001(VarCurr)
    <=> v39381(VarCurr,2) ) ).

tff(addAssignment_19848,axiom,
    ! [VarCurr: state_type] :
      ( v39995(VarCurr)
    <=> v39997(VarCurr) ) ).

tff(addAssignment_19847,axiom,
    ! [VarCurr: state_type] :
      ( v39997(VarCurr)
    <=> v38955(VarCurr,1) ) ).

tff(addAssignment_19846,axiom,
    ! [VarCurr: state_type] :
      ( v39991(VarCurr)
    <=> v39993(VarCurr) ) ).

tff(addAssignment_19845,axiom,
    ! [VarCurr: state_type] :
      ( v39993(VarCurr)
    <=> v39381(VarCurr,0) ) ).

tff(addAssignment_19844,axiom,
    ! [VarCurr: state_type] :
      ( v39978(VarCurr)
    <=> v39980(VarCurr) ) ).

tff(addAssignment_19843,axiom,
    ! [VarCurr: state_type] :
      ( v39980(VarCurr)
    <=> $false ) ).

tff(addAssignment_19842,axiom,
    ! [VarCurr: state_type] :
      ( v39972(VarCurr)
    <=> v39974(VarCurr) ) ).

tff(addAssignment_19841,axiom,
    ! [VarCurr: state_type] :
      ( v39974(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39962(VarCurr,B)
      <=> v39964(VarCurr,B) ) ) ).

tff(addAssignment_19839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39964(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19838,axiom,
    ! [VarCurr: state_type] :
      ( v39952(VarCurr)
    <=> v39954(VarCurr) ) ).

tff(addAssignment_19837,axiom,
    ! [VarCurr: state_type] :
      ( v39954(VarCurr)
    <=> v39956(VarCurr) ) ).

tff(addAssignment_19836,axiom,
    ! [VarCurr: state_type] :
      ( v39956(VarCurr)
    <=> v39958(VarCurr) ) ).

tff(addAssignment_19835,axiom,
    ! [VarCurr: state_type] :
      ( v39958(VarCurr)
    <=> v39960(VarCurr) ) ).

tff(addAssignment_19834,axiom,
    ! [VarCurr: state_type] :
      ( v39960(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19833,axiom,
    ! [VarCurr: state_type] :
      ( v39942(VarCurr)
    <=> v39944(VarCurr) ) ).

tff(addAssignment_19832,axiom,
    ! [VarCurr: state_type] :
      ( v39944(VarCurr)
    <=> v39946(VarCurr) ) ).

tff(addAssignment_19831,axiom,
    ! [VarCurr: state_type] :
      ( v39946(VarCurr)
    <=> v39948(VarCurr) ) ).

tff(addAssignment_19830,axiom,
    ! [VarCurr: state_type] :
      ( v39948(VarCurr)
    <=> v39950(VarCurr) ) ).

tff(addAssignment_19829,axiom,
    ! [VarCurr: state_type] :
      ( v39950(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19828,axiom,
    ! [VarCurr: state_type] :
      ( v39901(VarCurr)
    <=> v39903(VarCurr) ) ).

tff(addAssignment_19827,axiom,
    ! [VarCurr: state_type] :
      ( v39903(VarCurr)
    <=> v39905(VarCurr) ) ).

tff(addAssignment_19826,axiom,
    ! [VarCurr: state_type] :
      ( v39905(VarCurr)
    <=> v39907(VarCurr) ) ).

tff(addAssignment_19825,axiom,
    ! [VarCurr: state_type] :
      ( v39907(VarCurr)
    <=> v39909(VarCurr) ) ).

tff(addAssignment_19824,axiom,
    ! [VarCurr: state_type] :
      ( v39909(VarCurr)
    <=> v39911(VarCurr) ) ).

tff(addAssignment_19823,axiom,
    ! [VarCurr: state_type] :
      ( v39911(VarCurr)
    <=> v39913(VarCurr) ) ).

tff(addAssignment_19822,axiom,
    ! [VarCurr: state_type] :
      ( v39913(VarCurr)
    <=> v39915(VarCurr) ) ).

tff(writeUnaryOperator_2364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39915(VarCurr)
    <=> v39929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3848,axiom,
    ! [VarCurr: state_type] :
      ( v39929(VarCurr)
    <=> ( v39930(VarCurr)
        | v39925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3847,axiom,
    ! [VarCurr: state_type] :
      ( v39930(VarCurr)
    <=> ( v39917(VarCurr)
        | v39921(VarCurr) ) ) ).

tff(addAssignment_19821,axiom,
    ! [VarCurr: state_type] :
      ( v39925(VarCurr)
    <=> v39927(VarCurr) ) ).

tff(addAssignment_19820,axiom,
    ! [VarCurr: state_type] :
      ( v39927(VarCurr)
    <=> v39128(VarCurr,2) ) ).

tff(addAssignment_19819,axiom,
    ! [VarCurr: state_type] :
      ( v39921(VarCurr)
    <=> v39923(VarCurr) ) ).

tff(addAssignment_19818,axiom,
    ! [VarCurr: state_type] :
      ( v39923(VarCurr)
    <=> v39045(VarCurr,1) ) ).

tff(addAssignment_19817,axiom,
    ! [VarCurr: state_type] :
      ( v39917(VarCurr)
    <=> v39919(VarCurr) ) ).

tff(addAssignment_19816,axiom,
    ! [VarCurr: state_type] :
      ( v39919(VarCurr)
    <=> v39045(VarCurr,0) ) ).

tff(addAssignment_19815,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39781(VarCurr,B)
      <=> v39783(VarCurr,B) ) ) ).

tff(addAssignment_19814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39783(VarCurr,B)
      <=> v39785(VarCurr,B) ) ) ).

tff(addAssignment_19813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39785(VarCurr,B)
      <=> v39787(VarCurr,B) ) ) ).

tff(addAssignment_19812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39787(VarCurr,B)
      <=> v39789(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_471,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39884(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v39789(VarNext,B)
            <=> v39789(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_471,axiom,
    ! [VarNext: state_type] :
      ( v39884(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39789(VarNext,B)
          <=> v39894(VarNext,B) ) ) ) ).

tff(addAssignment_19811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39894(VarNext,B)
          <=> v39892(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39895(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39892(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_327,axiom,
    ! [VarCurr: state_type] :
      ( v39895(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39892(VarCurr,B)
          <=> v39811(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3846,axiom,
    ! [VarCurr: state_type] :
      ( v39895(VarCurr)
    <=> ( v39896(VarCurr)
        & v39897(VarCurr) ) ) ).

tff(writeUnaryOperator_2363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39897(VarCurr)
    <=> v39801(VarCurr) ) ).

tff(writeUnaryOperator_2362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39896(VarCurr)
    <=> v39791(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3845,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39884(VarNext)
      <=> v39885(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39885(VarNext)
      <=> ( v39886(VarNext)
          & v39815(VarNext) ) ) ) ).

tff(writeUnaryOperator_2361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39886(VarNext)
      <=> v39888(VarNext) ) ) ).

tff(addAssignment_19810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39888(VarNext)
      <=> v39815(VarCurr) ) ) ).

tff(addAssignment_19809,axiom,
    ! [VarCurr: state_type] :
      ( v39815(VarCurr)
    <=> v39817(VarCurr) ) ).

tff(addAssignment_19808,axiom,
    ! [VarCurr: state_type] :
      ( v39817(VarCurr)
    <=> v39819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3843,axiom,
    ! [VarCurr: state_type] :
      ( v39819(VarCurr)
    <=> ( v39881(VarCurr)
        | v39877(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3842,axiom,
    ! [VarCurr: state_type] :
      ( v39881(VarCurr)
    <=> ( v39821(VarCurr)
        & v39825(VarCurr) ) ) ).

tff(addAssignment_19807,axiom,
    ! [VarCurr: state_type] :
      ( v39877(VarCurr)
    <=> v39879(VarCurr) ) ).

tff(addAssignment_19806,axiom,
    ! [VarCurr: state_type] :
      ( v39879(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39861(VarNext)
       => ( v39825(VarNext)
        <=> v39825(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_470,axiom,
    ! [VarNext: state_type] :
      ( v39861(VarNext)
     => ( v39825(VarNext)
      <=> v39871(VarNext) ) ) ).

tff(addAssignment_19805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39871(VarNext)
      <=> v39869(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3841,axiom,
    ! [VarCurr: state_type] :
      ( v39869(VarCurr)
    <=> ( v39872(VarCurr)
        & v39873(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3840,axiom,
    ! [VarCurr: state_type] :
      ( v39873(VarCurr)
    <=> ( v39831(VarCurr)
        | v39856(VarCurr) ) ) ).

tff(writeUnaryOperator_2360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39872(VarCurr)
    <=> v39827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39861(VarNext)
      <=> v39862(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39862(VarNext)
      <=> ( v39864(VarNext)
          & v39866(VarNext) ) ) ) ).

tff(writeUnaryOperator_2359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39866(VarCurr)
    <=> v39821(VarCurr) ) ).

tff(addAssignment_19804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39864(VarNext)
      <=> v39821(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_164,axiom,
    ( v39825(constB0)
  <=> $true ) ).

tff(addAssignment_19803,axiom,
    ! [VarCurr: state_type] :
      ( v39856(VarCurr)
    <=> v39858(VarCurr) ) ).

tff(addAssignment_19802,axiom,
    ! [VarCurr: state_type] :
      ( v39858(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19801,axiom,
    ! [VarCurr: state_type] :
      ( v39831(VarCurr)
    <=> v39833(VarCurr) ) ).

tff(addAssignment_19800,axiom,
    ! [VarCurr: state_type] :
      ( v39833(VarCurr)
    <=> v39835(VarCurr) ) ).

tff(addAssignment_19799,axiom,
    ! [VarCurr: state_type] :
      ( v39835(VarCurr)
    <=> v39837(VarCurr) ) ).

tff(addAssignment_19798,axiom,
    ! [VarCurr: state_type] :
      ( v39837(VarCurr)
    <=> v39839(VarCurr) ) ).

tff(writeUnaryOperator_2358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39839(VarCurr)
    <=> v39853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3837,axiom,
    ! [VarCurr: state_type] :
      ( v39853(VarCurr)
    <=> ( v39854(VarCurr)
        | v39849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3836,axiom,
    ! [VarCurr: state_type] :
      ( v39854(VarCurr)
    <=> ( v39841(VarCurr)
        | v39845(VarCurr) ) ) ).

tff(addAssignment_19797,axiom,
    ! [VarCurr: state_type] :
      ( v39849(VarCurr)
    <=> v39851(VarCurr) ) ).

tff(addAssignment_19796,axiom,
    ! [VarCurr: state_type] :
      ( v39851(VarCurr)
    <=> v39381(VarCurr,2) ) ).

tff(addAssignment_19795,axiom,
    ! [VarCurr: state_type] :
      ( v39381(VarCurr,2)
    <=> v39383(VarCurr,2) ) ).

tff(addAssignment_19794,axiom,
    ! [VarCurr: state_type] :
      ( v39383(VarCurr,2)
    <=> v39385(VarCurr,2) ) ).

tff(addAssignment_19793,axiom,
    ! [VarCurr: state_type] :
      ( v39385(VarCurr,2)
    <=> v39390(VarCurr,2) ) ).

tff(addAssignment_19792,axiom,
    ! [VarCurr: state_type] :
      ( v39387(VarCurr,2)
    <=> v39389(VarCurr,2) ) ).

tff(addAssignment_19791,axiom,
    ! [VarCurr: state_type] :
      ( v39389(VarCurr,2)
    <=> v38955(VarCurr,2) ) ).

tff(addAssignment_19790,axiom,
    ! [VarCurr: state_type] :
      ( v39845(VarCurr)
    <=> v39847(VarCurr) ) ).

tff(addAssignment_19789,axiom,
    ! [VarCurr: state_type] :
      ( v39847(VarCurr)
    <=> v38955(VarCurr,1) ) ).

tff(addAssignment_19788,axiom,
    ! [VarCurr: state_type] :
      ( v39841(VarCurr)
    <=> v39843(VarCurr) ) ).

tff(addAssignment_19787,axiom,
    ! [VarCurr: state_type] :
      ( v39843(VarCurr)
    <=> v38955(VarCurr,0) ) ).

tff(addAssignment_19786,axiom,
    ! [VarCurr: state_type] :
      ( v39827(VarCurr)
    <=> v39829(VarCurr) ) ).

tff(addAssignment_19785,axiom,
    ! [VarCurr: state_type] :
      ( v39829(VarCurr)
    <=> $false ) ).

tff(addAssignment_19784,axiom,
    ! [VarCurr: state_type] :
      ( v39821(VarCurr)
    <=> v39823(VarCurr) ) ).

tff(addAssignment_19783,axiom,
    ! [VarCurr: state_type] :
      ( v39823(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39811(VarCurr,B)
      <=> v39813(VarCurr,B) ) ) ).

tff(addAssignment_19781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39813(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19780,axiom,
    ! [VarCurr: state_type] :
      ( v39801(VarCurr)
    <=> v39803(VarCurr) ) ).

tff(addAssignment_19779,axiom,
    ! [VarCurr: state_type] :
      ( v39803(VarCurr)
    <=> v39805(VarCurr) ) ).

tff(addAssignment_19778,axiom,
    ! [VarCurr: state_type] :
      ( v39805(VarCurr)
    <=> v39807(VarCurr) ) ).

tff(addAssignment_19777,axiom,
    ! [VarCurr: state_type] :
      ( v39807(VarCurr)
    <=> v39809(VarCurr) ) ).

tff(addAssignment_19776,axiom,
    ! [VarCurr: state_type] :
      ( v39809(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19775,axiom,
    ! [VarCurr: state_type] :
      ( v39791(VarCurr)
    <=> v39793(VarCurr) ) ).

tff(addAssignment_19774,axiom,
    ! [VarCurr: state_type] :
      ( v39793(VarCurr)
    <=> v39795(VarCurr) ) ).

tff(addAssignment_19773,axiom,
    ! [VarCurr: state_type] :
      ( v39795(VarCurr)
    <=> v39797(VarCurr) ) ).

tff(addAssignment_19772,axiom,
    ! [VarCurr: state_type] :
      ( v39797(VarCurr)
    <=> v39799(VarCurr) ) ).

tff(addAssignment_19771,axiom,
    ! [VarCurr: state_type] :
      ( v39799(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19770,axiom,
    ! [VarCurr: state_type] :
      ( v39750(VarCurr)
    <=> v39752(VarCurr) ) ).

tff(addAssignment_19769,axiom,
    ! [VarCurr: state_type] :
      ( v39752(VarCurr)
    <=> v39754(VarCurr) ) ).

tff(addAssignment_19768,axiom,
    ! [VarCurr: state_type] :
      ( v39754(VarCurr)
    <=> v39756(VarCurr) ) ).

tff(addAssignment_19767,axiom,
    ! [VarCurr: state_type] :
      ( v39756(VarCurr)
    <=> v39758(VarCurr) ) ).

tff(addAssignment_19766,axiom,
    ! [VarCurr: state_type] :
      ( v39758(VarCurr)
    <=> v39760(VarCurr) ) ).

tff(addAssignment_19765,axiom,
    ! [VarCurr: state_type] :
      ( v39760(VarCurr)
    <=> v39762(VarCurr) ) ).

tff(addAssignment_19764,axiom,
    ! [VarCurr: state_type] :
      ( v39762(VarCurr)
    <=> v39764(VarCurr) ) ).

tff(writeUnaryOperator_2357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39764(VarCurr)
    <=> v39778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3835,axiom,
    ! [VarCurr: state_type] :
      ( v39778(VarCurr)
    <=> ( v39779(VarCurr)
        | v39774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3834,axiom,
    ! [VarCurr: state_type] :
      ( v39779(VarCurr)
    <=> ( v39766(VarCurr)
        | v39770(VarCurr) ) ) ).

tff(addAssignment_19763,axiom,
    ! [VarCurr: state_type] :
      ( v39774(VarCurr)
    <=> v39776(VarCurr) ) ).

tff(addAssignment_19762,axiom,
    ! [VarCurr: state_type] :
      ( v39776(VarCurr)
    <=> v39045(VarCurr,2) ) ).

tff(addAssignment_19761,axiom,
    ! [VarCurr: state_type] :
      ( v39770(VarCurr)
    <=> v39772(VarCurr) ) ).

tff(addAssignment_19760,axiom,
    ! [VarCurr: state_type] :
      ( v39772(VarCurr)
    <=> v39128(VarCurr,1) ) ).

tff(addAssignment_19759,axiom,
    ! [VarCurr: state_type] :
      ( v39766(VarCurr)
    <=> v39768(VarCurr) ) ).

tff(addAssignment_19758,axiom,
    ! [VarCurr: state_type] :
      ( v39768(VarCurr)
    <=> v39128(VarCurr,0) ) ).

tff(addAssignment_19757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39630(VarCurr,B)
      <=> v39632(VarCurr,B) ) ) ).

tff(addAssignment_19756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39632(VarCurr,B)
      <=> v39634(VarCurr,B) ) ) ).

tff(addAssignment_19755,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39634(VarCurr,B)
      <=> v39636(VarCurr,B) ) ) ).

tff(addAssignment_19754,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39636(VarCurr,B)
      <=> v39638(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39733(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v39638(VarNext,B)
            <=> v39638(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_469,axiom,
    ! [VarNext: state_type] :
      ( v39733(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39638(VarNext,B)
          <=> v39743(VarNext,B) ) ) ) ).

tff(addAssignment_19753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39743(VarNext,B)
          <=> v39741(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39741(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_326,axiom,
    ! [VarCurr: state_type] :
      ( v39744(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39741(VarCurr,B)
          <=> v39660(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3833,axiom,
    ! [VarCurr: state_type] :
      ( v39744(VarCurr)
    <=> ( v39745(VarCurr)
        & v39746(VarCurr) ) ) ).

tff(writeUnaryOperator_2356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39746(VarCurr)
    <=> v39650(VarCurr) ) ).

tff(writeUnaryOperator_2355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39745(VarCurr)
    <=> v39640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39733(VarNext)
      <=> v39734(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39734(VarNext)
      <=> ( v39735(VarNext)
          & v39664(VarNext) ) ) ) ).

tff(writeUnaryOperator_2354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39735(VarNext)
      <=> v39737(VarNext) ) ) ).

tff(addAssignment_19752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39737(VarNext)
      <=> v39664(VarCurr) ) ) ).

tff(addAssignment_19751,axiom,
    ! [VarCurr: state_type] :
      ( v39664(VarCurr)
    <=> v39666(VarCurr) ) ).

tff(addAssignment_19750,axiom,
    ! [VarCurr: state_type] :
      ( v39666(VarCurr)
    <=> v39668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3830,axiom,
    ! [VarCurr: state_type] :
      ( v39668(VarCurr)
    <=> ( v39730(VarCurr)
        | v39726(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3829,axiom,
    ! [VarCurr: state_type] :
      ( v39730(VarCurr)
    <=> ( v39670(VarCurr)
        & v39674(VarCurr) ) ) ).

tff(addAssignment_19749,axiom,
    ! [VarCurr: state_type] :
      ( v39726(VarCurr)
    <=> v39728(VarCurr) ) ).

tff(addAssignment_19748,axiom,
    ! [VarCurr: state_type] :
      ( v39728(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39710(VarNext)
       => ( v39674(VarNext)
        <=> v39674(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_468,axiom,
    ! [VarNext: state_type] :
      ( v39710(VarNext)
     => ( v39674(VarNext)
      <=> v39720(VarNext) ) ) ).

tff(addAssignment_19747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39720(VarNext)
      <=> v39718(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3828,axiom,
    ! [VarCurr: state_type] :
      ( v39718(VarCurr)
    <=> ( v39721(VarCurr)
        & v39722(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3827,axiom,
    ! [VarCurr: state_type] :
      ( v39722(VarCurr)
    <=> ( v39680(VarCurr)
        | v39705(VarCurr) ) ) ).

tff(writeUnaryOperator_2353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39721(VarCurr)
    <=> v39676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39710(VarNext)
      <=> v39711(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39711(VarNext)
      <=> ( v39713(VarNext)
          & v39715(VarNext) ) ) ) ).

tff(writeUnaryOperator_2352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39715(VarCurr)
    <=> v39670(VarCurr) ) ).

tff(addAssignment_19746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39713(VarNext)
      <=> v39670(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_163,axiom,
    ( v39674(constB0)
  <=> $true ) ).

tff(addAssignment_19745,axiom,
    ! [VarCurr: state_type] :
      ( v39705(VarCurr)
    <=> v39707(VarCurr) ) ).

tff(addAssignment_19744,axiom,
    ! [VarCurr: state_type] :
      ( v39707(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19743,axiom,
    ! [VarCurr: state_type] :
      ( v39680(VarCurr)
    <=> v39682(VarCurr) ) ).

tff(addAssignment_19742,axiom,
    ! [VarCurr: state_type] :
      ( v39682(VarCurr)
    <=> v39684(VarCurr) ) ).

tff(addAssignment_19741,axiom,
    ! [VarCurr: state_type] :
      ( v39684(VarCurr)
    <=> v39686(VarCurr) ) ).

tff(addAssignment_19740,axiom,
    ! [VarCurr: state_type] :
      ( v39686(VarCurr)
    <=> v39688(VarCurr) ) ).

tff(writeUnaryOperator_2351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39688(VarCurr)
    <=> v39702(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3824,axiom,
    ! [VarCurr: state_type] :
      ( v39702(VarCurr)
    <=> ( v39703(VarCurr)
        | v39698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3823,axiom,
    ! [VarCurr: state_type] :
      ( v39703(VarCurr)
    <=> ( v39690(VarCurr)
        | v39694(VarCurr) ) ) ).

tff(addAssignment_19739,axiom,
    ! [VarCurr: state_type] :
      ( v39698(VarCurr)
    <=> v39700(VarCurr) ) ).

tff(addAssignment_19738,axiom,
    ! [VarCurr: state_type] :
      ( v39700(VarCurr)
    <=> v38955(VarCurr,2) ) ).

tff(addAssignment_19737,axiom,
    ! [VarCurr: state_type] :
      ( v39694(VarCurr)
    <=> v39696(VarCurr) ) ).

tff(addAssignment_19736,axiom,
    ! [VarCurr: state_type] :
      ( v39696(VarCurr)
    <=> v39381(VarCurr,1) ) ).

tff(addAssignment_19735,axiom,
    ! [VarCurr: state_type] :
      ( v39690(VarCurr)
    <=> v39692(VarCurr) ) ).

tff(addAssignment_19734,axiom,
    ! [VarCurr: state_type] :
      ( v39692(VarCurr)
    <=> v39381(VarCurr,0) ) ).

tff(addAssignment_19733,axiom,
    ! [VarCurr: state_type] :
      ( v39676(VarCurr)
    <=> v39678(VarCurr) ) ).

tff(addAssignment_19732,axiom,
    ! [VarCurr: state_type] :
      ( v39678(VarCurr)
    <=> $false ) ).

tff(addAssignment_19731,axiom,
    ! [VarCurr: state_type] :
      ( v39670(VarCurr)
    <=> v39672(VarCurr) ) ).

tff(addAssignment_19730,axiom,
    ! [VarCurr: state_type] :
      ( v39672(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39660(VarCurr,B)
      <=> v39662(VarCurr,B) ) ) ).

tff(addAssignment_19728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39662(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19727,axiom,
    ! [VarCurr: state_type] :
      ( v39650(VarCurr)
    <=> v39652(VarCurr) ) ).

tff(addAssignment_19726,axiom,
    ! [VarCurr: state_type] :
      ( v39652(VarCurr)
    <=> v39654(VarCurr) ) ).

tff(addAssignment_19725,axiom,
    ! [VarCurr: state_type] :
      ( v39654(VarCurr)
    <=> v39656(VarCurr) ) ).

tff(addAssignment_19724,axiom,
    ! [VarCurr: state_type] :
      ( v39656(VarCurr)
    <=> v39658(VarCurr) ) ).

tff(addAssignment_19723,axiom,
    ! [VarCurr: state_type] :
      ( v39658(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19722,axiom,
    ! [VarCurr: state_type] :
      ( v39640(VarCurr)
    <=> v39642(VarCurr) ) ).

tff(addAssignment_19721,axiom,
    ! [VarCurr: state_type] :
      ( v39642(VarCurr)
    <=> v39644(VarCurr) ) ).

tff(addAssignment_19720,axiom,
    ! [VarCurr: state_type] :
      ( v39644(VarCurr)
    <=> v39646(VarCurr) ) ).

tff(addAssignment_19719,axiom,
    ! [VarCurr: state_type] :
      ( v39646(VarCurr)
    <=> v39648(VarCurr) ) ).

tff(addAssignment_19718,axiom,
    ! [VarCurr: state_type] :
      ( v39648(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19717,axiom,
    ! [VarCurr: state_type] :
      ( v39599(VarCurr)
    <=> v39601(VarCurr) ) ).

tff(addAssignment_19716,axiom,
    ! [VarCurr: state_type] :
      ( v39601(VarCurr)
    <=> v39603(VarCurr) ) ).

tff(addAssignment_19715,axiom,
    ! [VarCurr: state_type] :
      ( v39603(VarCurr)
    <=> v39605(VarCurr) ) ).

tff(addAssignment_19714,axiom,
    ! [VarCurr: state_type] :
      ( v39605(VarCurr)
    <=> v39607(VarCurr) ) ).

tff(addAssignment_19713,axiom,
    ! [VarCurr: state_type] :
      ( v39607(VarCurr)
    <=> v39609(VarCurr) ) ).

tff(addAssignment_19712,axiom,
    ! [VarCurr: state_type] :
      ( v39609(VarCurr)
    <=> v39611(VarCurr) ) ).

tff(addAssignment_19711,axiom,
    ! [VarCurr: state_type] :
      ( v39611(VarCurr)
    <=> v39613(VarCurr) ) ).

tff(writeUnaryOperator_2350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39613(VarCurr)
    <=> v39627(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3822,axiom,
    ! [VarCurr: state_type] :
      ( v39627(VarCurr)
    <=> ( v39628(VarCurr)
        | v39623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3821,axiom,
    ! [VarCurr: state_type] :
      ( v39628(VarCurr)
    <=> ( v39615(VarCurr)
        | v39619(VarCurr) ) ) ).

tff(addAssignment_19710,axiom,
    ! [VarCurr: state_type] :
      ( v39623(VarCurr)
    <=> v39625(VarCurr) ) ).

tff(addAssignment_19709,axiom,
    ! [VarCurr: state_type] :
      ( v39625(VarCurr)
    <=> v39045(VarCurr,2) ) ).

tff(addAssignment_19708,axiom,
    ! [VarCurr: state_type] :
      ( v39619(VarCurr)
    <=> v39621(VarCurr) ) ).

tff(addAssignment_19707,axiom,
    ! [VarCurr: state_type] :
      ( v39621(VarCurr)
    <=> v39128(VarCurr,1) ) ).

tff(addAssignment_19706,axiom,
    ! [VarCurr: state_type] :
      ( v39128(VarCurr,1)
    <=> v39130(VarCurr,1) ) ).

tff(addAssignment_19705,axiom,
    ! [VarCurr: state_type] :
      ( v39130(VarCurr,1)
    <=> v39132(VarCurr,1) ) ).

tff(addAssignment_19704,axiom,
    ! [VarCurr: state_type] :
      ( v39132(VarCurr,1)
    <=> v39137(VarCurr,1) ) ).

tff(addAssignment_19703,axiom,
    ! [VarCurr: state_type] :
      ( v39134(VarCurr,1)
    <=> v39136(VarCurr,1) ) ).

tff(addAssignment_19702,axiom,
    ! [VarCurr: state_type] :
      ( v39136(VarCurr,1)
    <=> v39045(VarCurr,1) ) ).

tff(addAssignment_19701,axiom,
    ! [VarCurr: state_type] :
      ( v39615(VarCurr)
    <=> v39617(VarCurr) ) ).

tff(addAssignment_19700,axiom,
    ! [VarCurr: state_type] :
      ( v39617(VarCurr)
    <=> v39045(VarCurr,0) ) ).

tff(addAssignment_19699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39479(VarCurr,B)
      <=> v39481(VarCurr,B) ) ) ).

tff(addAssignment_19698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39481(VarCurr,B)
      <=> v39483(VarCurr,B) ) ) ).

tff(addAssignment_19697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39483(VarCurr,B)
      <=> v39485(VarCurr,B) ) ) ).

tff(addAssignment_19696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39485(VarCurr,B)
      <=> v39487(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39582(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v39487(VarNext,B)
            <=> v39487(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_467,axiom,
    ! [VarNext: state_type] :
      ( v39582(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39487(VarNext,B)
          <=> v39592(VarNext,B) ) ) ) ).

tff(addAssignment_19695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39592(VarNext,B)
          <=> v39590(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39590(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_325,axiom,
    ! [VarCurr: state_type] :
      ( v39593(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39590(VarCurr,B)
          <=> v39509(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3820,axiom,
    ! [VarCurr: state_type] :
      ( v39593(VarCurr)
    <=> ( v39594(VarCurr)
        & v39595(VarCurr) ) ) ).

tff(writeUnaryOperator_2349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39595(VarCurr)
    <=> v39499(VarCurr) ) ).

tff(writeUnaryOperator_2348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39594(VarCurr)
    <=> v39489(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39582(VarNext)
      <=> v39583(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39583(VarNext)
      <=> ( v39584(VarNext)
          & v39513(VarNext) ) ) ) ).

tff(writeUnaryOperator_2347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39584(VarNext)
      <=> v39586(VarNext) ) ) ).

tff(addAssignment_19694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39586(VarNext)
      <=> v39513(VarCurr) ) ) ).

tff(addAssignment_19693,axiom,
    ! [VarCurr: state_type] :
      ( v39513(VarCurr)
    <=> v39515(VarCurr) ) ).

tff(addAssignment_19692,axiom,
    ! [VarCurr: state_type] :
      ( v39515(VarCurr)
    <=> v39517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3817,axiom,
    ! [VarCurr: state_type] :
      ( v39517(VarCurr)
    <=> ( v39579(VarCurr)
        | v39575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3816,axiom,
    ! [VarCurr: state_type] :
      ( v39579(VarCurr)
    <=> ( v39519(VarCurr)
        & v39523(VarCurr) ) ) ).

tff(addAssignment_19691,axiom,
    ! [VarCurr: state_type] :
      ( v39575(VarCurr)
    <=> v39577(VarCurr) ) ).

tff(addAssignment_19690,axiom,
    ! [VarCurr: state_type] :
      ( v39577(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_466,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39559(VarNext)
       => ( v39523(VarNext)
        <=> v39523(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_466,axiom,
    ! [VarNext: state_type] :
      ( v39559(VarNext)
     => ( v39523(VarNext)
      <=> v39569(VarNext) ) ) ).

tff(addAssignment_19689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39569(VarNext)
      <=> v39567(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3815,axiom,
    ! [VarCurr: state_type] :
      ( v39567(VarCurr)
    <=> ( v39570(VarCurr)
        & v39571(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3814,axiom,
    ! [VarCurr: state_type] :
      ( v39571(VarCurr)
    <=> ( v39529(VarCurr)
        | v39554(VarCurr) ) ) ).

tff(writeUnaryOperator_2346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39570(VarCurr)
    <=> v39525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39559(VarNext)
      <=> v39560(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39560(VarNext)
      <=> ( v39562(VarNext)
          & v39564(VarNext) ) ) ) ).

tff(writeUnaryOperator_2345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39564(VarCurr)
    <=> v39519(VarCurr) ) ).

tff(addAssignment_19688,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39562(VarNext)
      <=> v39519(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_162,axiom,
    ( v39523(constB0)
  <=> $true ) ).

tff(addAssignment_19687,axiom,
    ! [VarCurr: state_type] :
      ( v39554(VarCurr)
    <=> v39556(VarCurr) ) ).

tff(addAssignment_19686,axiom,
    ! [VarCurr: state_type] :
      ( v39556(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19685,axiom,
    ! [VarCurr: state_type] :
      ( v39529(VarCurr)
    <=> v39531(VarCurr) ) ).

tff(addAssignment_19684,axiom,
    ! [VarCurr: state_type] :
      ( v39531(VarCurr)
    <=> v39533(VarCurr) ) ).

tff(addAssignment_19683,axiom,
    ! [VarCurr: state_type] :
      ( v39533(VarCurr)
    <=> v39535(VarCurr) ) ).

tff(addAssignment_19682,axiom,
    ! [VarCurr: state_type] :
      ( v39535(VarCurr)
    <=> v39537(VarCurr) ) ).

tff(writeUnaryOperator_2344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39537(VarCurr)
    <=> v39551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3811,axiom,
    ! [VarCurr: state_type] :
      ( v39551(VarCurr)
    <=> ( v39552(VarCurr)
        | v39547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3810,axiom,
    ! [VarCurr: state_type] :
      ( v39552(VarCurr)
    <=> ( v39539(VarCurr)
        | v39543(VarCurr) ) ) ).

tff(addAssignment_19681,axiom,
    ! [VarCurr: state_type] :
      ( v39547(VarCurr)
    <=> v39549(VarCurr) ) ).

tff(addAssignment_19680,axiom,
    ! [VarCurr: state_type] :
      ( v39549(VarCurr)
    <=> v38955(VarCurr,2) ) ).

tff(addAssignment_19679,axiom,
    ! [VarCurr: state_type] :
      ( v39543(VarCurr)
    <=> v39545(VarCurr) ) ).

tff(addAssignment_19678,axiom,
    ! [VarCurr: state_type] :
      ( v39545(VarCurr)
    <=> v39381(VarCurr,1) ) ).

tff(addAssignment_19677,axiom,
    ! [VarCurr: state_type] :
      ( v39381(VarCurr,1)
    <=> v39383(VarCurr,1) ) ).

tff(addAssignment_19676,axiom,
    ! [VarCurr: state_type] :
      ( v39383(VarCurr,1)
    <=> v39385(VarCurr,1) ) ).

tff(addAssignment_19675,axiom,
    ! [VarCurr: state_type] :
      ( v39385(VarCurr,1)
    <=> v39390(VarCurr,1) ) ).

tff(addAssignment_19674,axiom,
    ! [VarCurr: state_type] :
      ( v39387(VarCurr,1)
    <=> v39389(VarCurr,1) ) ).

tff(addAssignment_19673,axiom,
    ! [VarCurr: state_type] :
      ( v39389(VarCurr,1)
    <=> v38955(VarCurr,1) ) ).

tff(addAssignment_19672,axiom,
    ! [VarCurr: state_type] :
      ( v39539(VarCurr)
    <=> v39541(VarCurr) ) ).

tff(addAssignment_19671,axiom,
    ! [VarCurr: state_type] :
      ( v39541(VarCurr)
    <=> v38955(VarCurr,0) ) ).

tff(addAssignment_19670,axiom,
    ! [VarCurr: state_type] :
      ( v39525(VarCurr)
    <=> v39527(VarCurr) ) ).

tff(addAssignment_19669,axiom,
    ! [VarCurr: state_type] :
      ( v39527(VarCurr)
    <=> $false ) ).

tff(addAssignment_19668,axiom,
    ! [VarCurr: state_type] :
      ( v39519(VarCurr)
    <=> v39521(VarCurr) ) ).

tff(addAssignment_19667,axiom,
    ! [VarCurr: state_type] :
      ( v39521(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39509(VarCurr,B)
      <=> v39511(VarCurr,B) ) ) ).

tff(addAssignment_19665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39511(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19664,axiom,
    ! [VarCurr: state_type] :
      ( v39499(VarCurr)
    <=> v39501(VarCurr) ) ).

tff(addAssignment_19663,axiom,
    ! [VarCurr: state_type] :
      ( v39501(VarCurr)
    <=> v39503(VarCurr) ) ).

tff(addAssignment_19662,axiom,
    ! [VarCurr: state_type] :
      ( v39503(VarCurr)
    <=> v39505(VarCurr) ) ).

tff(addAssignment_19661,axiom,
    ! [VarCurr: state_type] :
      ( v39505(VarCurr)
    <=> v39507(VarCurr) ) ).

tff(addAssignment_19660,axiom,
    ! [VarCurr: state_type] :
      ( v39507(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19659,axiom,
    ! [VarCurr: state_type] :
      ( v39489(VarCurr)
    <=> v39491(VarCurr) ) ).

tff(addAssignment_19658,axiom,
    ! [VarCurr: state_type] :
      ( v39491(VarCurr)
    <=> v39493(VarCurr) ) ).

tff(addAssignment_19657,axiom,
    ! [VarCurr: state_type] :
      ( v39493(VarCurr)
    <=> v39495(VarCurr) ) ).

tff(addAssignment_19656,axiom,
    ! [VarCurr: state_type] :
      ( v39495(VarCurr)
    <=> v39497(VarCurr) ) ).

tff(addAssignment_19655,axiom,
    ! [VarCurr: state_type] :
      ( v39497(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19654,axiom,
    ! [VarCurr: state_type] :
      ( v39448(VarCurr)
    <=> v39450(VarCurr) ) ).

tff(addAssignment_19653,axiom,
    ! [VarCurr: state_type] :
      ( v39450(VarCurr)
    <=> v39452(VarCurr) ) ).

tff(addAssignment_19652,axiom,
    ! [VarCurr: state_type] :
      ( v39452(VarCurr)
    <=> v39454(VarCurr) ) ).

tff(addAssignment_19651,axiom,
    ! [VarCurr: state_type] :
      ( v39454(VarCurr)
    <=> v39456(VarCurr) ) ).

tff(addAssignment_19650,axiom,
    ! [VarCurr: state_type] :
      ( v39456(VarCurr)
    <=> v39458(VarCurr) ) ).

tff(addAssignment_19649,axiom,
    ! [VarCurr: state_type] :
      ( v39458(VarCurr)
    <=> v39460(VarCurr) ) ).

tff(addAssignment_19648,axiom,
    ! [VarCurr: state_type] :
      ( v39460(VarCurr)
    <=> v39462(VarCurr) ) ).

tff(writeUnaryOperator_2343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39462(VarCurr)
    <=> v39476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3809,axiom,
    ! [VarCurr: state_type] :
      ( v39476(VarCurr)
    <=> ( v39477(VarCurr)
        | v39472(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3808,axiom,
    ! [VarCurr: state_type] :
      ( v39477(VarCurr)
    <=> ( v39464(VarCurr)
        | v39468(VarCurr) ) ) ).

tff(addAssignment_19647,axiom,
    ! [VarCurr: state_type] :
      ( v39472(VarCurr)
    <=> v39474(VarCurr) ) ).

tff(addAssignment_19646,axiom,
    ! [VarCurr: state_type] :
      ( v39474(VarCurr)
    <=> v39045(VarCurr,2) ) ).

tff(addAssignment_19645,axiom,
    ! [VarCurr: state_type] :
      ( v39468(VarCurr)
    <=> v39470(VarCurr) ) ).

tff(addAssignment_19644,axiom,
    ! [VarCurr: state_type] :
      ( v39470(VarCurr)
    <=> v39045(VarCurr,1) ) ).

tff(addAssignment_19643,axiom,
    ! [VarCurr: state_type] :
      ( v39464(VarCurr)
    <=> v39466(VarCurr) ) ).

tff(addAssignment_19642,axiom,
    ! [VarCurr: state_type] :
      ( v39466(VarCurr)
    <=> v39128(VarCurr,0) ) ).

tff(addAssignment_19641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39317(VarCurr,B)
      <=> v39319(VarCurr,B) ) ) ).

tff(addAssignment_19640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39319(VarCurr,B)
      <=> v39321(VarCurr,B) ) ) ).

tff(addAssignment_19639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39321(VarCurr,B)
      <=> v39323(VarCurr,B) ) ) ).

tff(addAssignment_19638,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39323(VarCurr,B)
      <=> v39325(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39431(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v39325(VarNext,B)
            <=> v39325(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_465,axiom,
    ! [VarNext: state_type] :
      ( v39431(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39325(VarNext,B)
          <=> v39441(VarNext,B) ) ) ) ).

tff(addAssignment_19637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39441(VarNext,B)
          <=> v39439(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39442(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39439(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_324,axiom,
    ! [VarCurr: state_type] :
      ( v39442(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39439(VarCurr,B)
          <=> v39347(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3807,axiom,
    ! [VarCurr: state_type] :
      ( v39442(VarCurr)
    <=> ( v39443(VarCurr)
        & v39444(VarCurr) ) ) ).

tff(writeUnaryOperator_2342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39444(VarCurr)
    <=> v39337(VarCurr) ) ).

tff(writeUnaryOperator_2341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39443(VarCurr)
    <=> v39327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39431(VarNext)
      <=> v39432(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3805,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39432(VarNext)
      <=> ( v39433(VarNext)
          & v39351(VarNext) ) ) ) ).

tff(writeUnaryOperator_2340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39433(VarNext)
      <=> v39435(VarNext) ) ) ).

tff(addAssignment_19636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39435(VarNext)
      <=> v39351(VarCurr) ) ) ).

tff(addAssignment_19635,axiom,
    ! [VarCurr: state_type] :
      ( v39351(VarCurr)
    <=> v39353(VarCurr) ) ).

tff(addAssignment_19634,axiom,
    ! [VarCurr: state_type] :
      ( v39353(VarCurr)
    <=> v39355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3804,axiom,
    ! [VarCurr: state_type] :
      ( v39355(VarCurr)
    <=> ( v39428(VarCurr)
        | v39424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3803,axiom,
    ! [VarCurr: state_type] :
      ( v39428(VarCurr)
    <=> ( v39357(VarCurr)
        & v39361(VarCurr) ) ) ).

tff(addAssignment_19633,axiom,
    ! [VarCurr: state_type] :
      ( v39424(VarCurr)
    <=> v39426(VarCurr) ) ).

tff(addAssignment_19632,axiom,
    ! [VarCurr: state_type] :
      ( v39426(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39408(VarNext)
       => ( v39361(VarNext)
        <=> v39361(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_464,axiom,
    ! [VarNext: state_type] :
      ( v39408(VarNext)
     => ( v39361(VarNext)
      <=> v39418(VarNext) ) ) ).

tff(addAssignment_19631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39418(VarNext)
      <=> v39416(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3802,axiom,
    ! [VarCurr: state_type] :
      ( v39416(VarCurr)
    <=> ( v39419(VarCurr)
        & v39420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3801,axiom,
    ! [VarCurr: state_type] :
      ( v39420(VarCurr)
    <=> ( v39367(VarCurr)
        | v39403(VarCurr) ) ) ).

tff(writeUnaryOperator_2339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39419(VarCurr)
    <=> v39363(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39408(VarNext)
      <=> v39409(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39409(VarNext)
      <=> ( v39411(VarNext)
          & v39413(VarNext) ) ) ) ).

tff(writeUnaryOperator_2338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39413(VarCurr)
    <=> v39357(VarCurr) ) ).

tff(addAssignment_19630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39411(VarNext)
      <=> v39357(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_161,axiom,
    ( v39361(constB0)
  <=> $true ) ).

tff(addAssignment_19629,axiom,
    ! [VarCurr: state_type] :
      ( v39403(VarCurr)
    <=> v39405(VarCurr) ) ).

tff(addAssignment_19628,axiom,
    ! [VarCurr: state_type] :
      ( v39405(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19627,axiom,
    ! [VarCurr: state_type] :
      ( v39367(VarCurr)
    <=> v39369(VarCurr) ) ).

tff(addAssignment_19626,axiom,
    ! [VarCurr: state_type] :
      ( v39369(VarCurr)
    <=> v39371(VarCurr) ) ).

tff(addAssignment_19625,axiom,
    ! [VarCurr: state_type] :
      ( v39371(VarCurr)
    <=> v39373(VarCurr) ) ).

tff(addAssignment_19624,axiom,
    ! [VarCurr: state_type] :
      ( v39373(VarCurr)
    <=> v39375(VarCurr) ) ).

tff(writeUnaryOperator_2337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39375(VarCurr)
    <=> v39400(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3798,axiom,
    ! [VarCurr: state_type] :
      ( v39400(VarCurr)
    <=> ( v39401(VarCurr)
        | v39396(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3797,axiom,
    ! [VarCurr: state_type] :
      ( v39401(VarCurr)
    <=> ( v39377(VarCurr)
        | v39392(VarCurr) ) ) ).

tff(addAssignment_19623,axiom,
    ! [VarCurr: state_type] :
      ( v39396(VarCurr)
    <=> v39398(VarCurr) ) ).

tff(addAssignment_19622,axiom,
    ! [VarCurr: state_type] :
      ( v39398(VarCurr)
    <=> v38955(VarCurr,2) ) ).

tff(addAssignment_19621,axiom,
    ! [VarCurr: state_type] :
      ( v39392(VarCurr)
    <=> v39394(VarCurr) ) ).

tff(addAssignment_19620,axiom,
    ! [VarCurr: state_type] :
      ( v39394(VarCurr)
    <=> v38955(VarCurr,1) ) ).

tff(addAssignment_19619,axiom,
    ! [VarCurr: state_type] :
      ( v39377(VarCurr)
    <=> v39379(VarCurr) ) ).

tff(addAssignment_19618,axiom,
    ! [VarCurr: state_type] :
      ( v39379(VarCurr)
    <=> v39381(VarCurr,0) ) ).

tff(addAssignment_19617,axiom,
    ! [VarCurr: state_type] :
      ( v39381(VarCurr,0)
    <=> v39383(VarCurr,0) ) ).

tff(addAssignment_19616,axiom,
    ! [VarCurr: state_type] :
      ( v39383(VarCurr,0)
    <=> v39385(VarCurr,0) ) ).

tff(addAssignment_19615,axiom,
    ! [VarCurr: state_type] :
      ( v39385(VarCurr,0)
    <=> v39390(VarCurr,0) ) ).

tff(writeUnaryOperator_2336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v39390(VarCurr,B)
      <=> ~ v39387(VarCurr,B) ) ) ).

tff(addAssignment_19614,axiom,
    ! [VarCurr: state_type] :
      ( v39387(VarCurr,0)
    <=> v39389(VarCurr,0) ) ).

tff(addAssignment_19613,axiom,
    ! [VarCurr: state_type] :
      ( v39389(VarCurr,0)
    <=> v38955(VarCurr,0) ) ).

tff(addAssignment_19612,axiom,
    ! [VarCurr: state_type] :
      ( v39363(VarCurr)
    <=> v39365(VarCurr) ) ).

tff(addAssignment_19611,axiom,
    ! [VarCurr: state_type] :
      ( v39365(VarCurr)
    <=> $false ) ).

tff(addAssignment_19610,axiom,
    ! [VarCurr: state_type] :
      ( v39357(VarCurr)
    <=> v39359(VarCurr) ) ).

tff(addAssignment_19609,axiom,
    ! [VarCurr: state_type] :
      ( v39359(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39347(VarCurr,B)
      <=> v39349(VarCurr,B) ) ) ).

tff(addAssignment_19607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v39349(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19606,axiom,
    ! [VarCurr: state_type] :
      ( v39337(VarCurr)
    <=> v39339(VarCurr) ) ).

tff(addAssignment_19605,axiom,
    ! [VarCurr: state_type] :
      ( v39339(VarCurr)
    <=> v39341(VarCurr) ) ).

tff(addAssignment_19604,axiom,
    ! [VarCurr: state_type] :
      ( v39341(VarCurr)
    <=> v39343(VarCurr) ) ).

tff(addAssignment_19603,axiom,
    ! [VarCurr: state_type] :
      ( v39343(VarCurr)
    <=> v39345(VarCurr) ) ).

tff(addAssignment_19602,axiom,
    ! [VarCurr: state_type] :
      ( v39345(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19601,axiom,
    ! [VarCurr: state_type] :
      ( v39327(VarCurr)
    <=> v39329(VarCurr) ) ).

tff(addAssignment_19600,axiom,
    ! [VarCurr: state_type] :
      ( v39329(VarCurr)
    <=> v39331(VarCurr) ) ).

tff(addAssignment_19599,axiom,
    ! [VarCurr: state_type] :
      ( v39331(VarCurr)
    <=> v39333(VarCurr) ) ).

tff(addAssignment_19598,axiom,
    ! [VarCurr: state_type] :
      ( v39333(VarCurr)
    <=> v39335(VarCurr) ) ).

tff(addAssignment_19597,axiom,
    ! [VarCurr: state_type] :
      ( v39335(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19596,axiom,
    ! [VarCurr: state_type] :
      ( v39025(VarCurr)
    <=> v39027(VarCurr) ) ).

tff(addAssignment_19595,axiom,
    ! [VarCurr: state_type] :
      ( v39027(VarCurr)
    <=> v39029(VarCurr) ) ).

tff(addAssignment_19594,axiom,
    ! [VarCurr: state_type] :
      ( v39029(VarCurr)
    <=> v39031(VarCurr) ) ).

tff(addAssignment_19593,axiom,
    ! [VarCurr: state_type] :
      ( v39031(VarCurr)
    <=> v39033(VarCurr) ) ).

tff(addAssignment_19592,axiom,
    ! [VarCurr: state_type] :
      ( v39033(VarCurr)
    <=> v39035(VarCurr) ) ).

tff(addAssignment_19591,axiom,
    ! [VarCurr: state_type] :
      ( v39035(VarCurr)
    <=> v39037(VarCurr) ) ).

tff(addAssignment_19590,axiom,
    ! [VarCurr: state_type] :
      ( v39037(VarCurr)
    <=> v39039(VarCurr) ) ).

tff(writeUnaryOperator_2335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39039(VarCurr)
    <=> v39314(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3796,axiom,
    ! [VarCurr: state_type] :
      ( v39314(VarCurr)
    <=> ( v39315(VarCurr)
        | v39310(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3795,axiom,
    ! [VarCurr: state_type] :
      ( v39315(VarCurr)
    <=> ( v39041(VarCurr)
        | v39306(VarCurr) ) ) ).

tff(addAssignment_19589,axiom,
    ! [VarCurr: state_type] :
      ( v39310(VarCurr)
    <=> v39312(VarCurr) ) ).

tff(addAssignment_19588,axiom,
    ! [VarCurr: state_type] :
      ( v39312(VarCurr)
    <=> v39045(VarCurr,2) ) ).

tff(addAssignment_19587,axiom,
    ! [VarCurr: state_type] :
      ( v39306(VarCurr)
    <=> v39308(VarCurr) ) ).

tff(addAssignment_19586,axiom,
    ! [VarCurr: state_type] :
      ( v39308(VarCurr)
    <=> v39045(VarCurr,1) ) ).

tff(addAssignment_19585,axiom,
    ! [VarCurr: state_type] :
      ( v39041(VarCurr)
    <=> v39043(VarCurr) ) ).

tff(addAssignment_19584,axiom,
    ! [VarCurr: state_type] :
      ( v39043(VarCurr)
    <=> v39045(VarCurr,0) ) ).

tff(addAssignment_19583,axiom,
    ! [VarCurr: state_type] :
      ( v39045(VarCurr,0)
    <=> v38957(VarCurr,3) ) ).

tff(addAssignment_19582,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,3)
    <=> v38959(VarCurr,3) ) ).

tff(addAssignment_19581,axiom,
    ! [VarNext: state_type] :
      ( v38959(VarNext,3)
    <=> v39298(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39299(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v39298(VarNext,B)
            <=> v38959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_463,axiom,
    ! [VarNext: state_type] :
      ( v39299(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39298(VarNext,B)
          <=> v39270(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3794,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39299(VarNext)
      <=> v39300(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39300(VarNext)
      <=> ( v39302(VarNext)
          & v39212(VarNext) ) ) ) ).

tff(writeUnaryOperator_2334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39302(VarNext)
      <=> v39264(VarNext) ) ) ).

tff(addAssignment_19580,axiom,
    ! [VarCurr: state_type] :
      ( v39069(VarCurr,3)
    <=> v39071(VarCurr,3) ) ).

tff(addAssignment_19579,axiom,
    ! [VarCurr: state_type] :
      ( v39071(VarCurr,3)
    <=> v39209(VarCurr,3) ) ).

tff(addAssignment_19578,axiom,
    ! [VarCurr: state_type] :
      ( v39073(VarCurr,0)
    <=> v39075(VarCurr,0) ) ).

tff(addAssignment_19577,axiom,
    ! [VarCurr: state_type] :
      ( v39075(VarCurr,0)
    <=> v39077(VarCurr,0) ) ).

tff(addAssignment_19576,axiom,
    ! [VarCurr: state_type] :
      ( v39077(VarCurr,0)
    <=> v39208(VarCurr,0) ) ).

tff(addAssignment_19575,axiom,
    ! [VarCurr: state_type] :
      ( v39145(VarCurr,0)
    <=> v39147(VarCurr,0) ) ).

tff(addAssignment_19574,axiom,
    ! [VarCurr: state_type] :
      ( v39147(VarCurr,0)
    <=> v39149(VarCurr,0) ) ).

tff(addAssignment_19573,axiom,
    ! [VarCurr: state_type] :
      ( v39149(VarCurr,0)
    <=> v39151(VarCurr,0) ) ).

tff(addAssignment_19572,axiom,
    ! [VarCurr: state_type] :
      ( v39151(VarCurr,0)
    <=> v39153(VarCurr,0) ) ).

tff(addAssignment_19571,axiom,
    ! [VarCurr: state_type] :
      ( v39153(VarCurr,0)
    <=> v39163(VarCurr,0) ) ).

tff(addAssignment_19570,axiom,
    ! [VarCurr: state_type] :
      ( v39079(VarCurr,0)
    <=> v39081(VarCurr,0) ) ).

tff(addAssignment_19569,axiom,
    ! [VarCurr: state_type] :
      ( v39081(VarCurr,0)
    <=> v39142(VarCurr,0) ) ).

tff(addAssignment_19568,axiom,
    ! [VarCurr: state_type] :
      ( v39083(VarCurr)
    <=> v38609(VarCurr,2) ) ).

tff(addAssignment_19567,axiom,
    ! [VarCurr: state_type] :
      ( v38609(VarCurr,2)
    <=> v38611(VarCurr,2) ) ).

tff(addAssignment_19566,axiom,
    ! [VarCurr: state_type] :
      ( v38611(VarCurr,2)
    <=> v38621(VarCurr,2) ) ).

tff(addAssignment_19565,axiom,
    ! [VarCurr: state_type] :
      ( v38613(VarCurr,2)
    <=> v38615(VarCurr,2) ) ).

tff(addAssignment_19564,axiom,
    ! [VarCurr: state_type] :
      ( v38615(VarCurr,2)
    <=> v38618(VarCurr,2) ) ).

tff(addAssignment_19563,axiom,
    ! [VarCurr: state_type] :
      ( v38619(VarCurr)
    <=> v39086(VarCurr,1) ) ).

tff(addAssignment_19562,axiom,
    ! [VarCurr: state_type] :
      ( v39086(VarCurr,1)
    <=> v39088(VarCurr,1) ) ).

tff(addAssignment_19561,axiom,
    ! [VarCurr: state_type] :
      ( v39088(VarCurr,1)
    <=> v39296(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v39296(VarCurr,B)
      <=> ( v39090(VarCurr,B)
          | v39096(VarCurr,B) ) ) ) ).

tff(addAssignment_19560,axiom,
    ! [VarCurr: state_type] :
      ( v39096(VarCurr,1)
    <=> v39098(VarCurr,1) ) ).

tff(addAssignment_19559,axiom,
    ! [VarCurr: state_type] :
      ( v39098(VarCurr,1)
    <=> v39294(VarCurr,1) ) ).

tff(addAssignment_19558,axiom,
    ! [VarCurr: state_type] :
      ( v39294(VarCurr,0)
    <=> v39295(VarCurr) ) ).

tff(addAssignment_19557,axiom,
    ! [VarCurr: state_type] :
      ( v39294(VarCurr,1)
    <=> v39100(VarCurr) ) ).

tff(addAssignment_19556,axiom,
    ! [VarCurr: state_type] :
      ( v39100(VarCurr)
    <=> v39102(VarCurr,1) ) ).

tff(addAssignment_19555,axiom,
    ! [VarCurr: state_type] :
      ( v39102(VarCurr,1)
    <=> v39104(VarCurr,1) ) ).

tff(addAssignment_19554,axiom,
    ! [VarCurr: state_type] :
      ( v39104(VarCurr,1)
    <=> v39293(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v39293(VarCurr,B)
      <=> ( v39106(VarCurr,B)
          & v39114(VarCurr,B) ) ) ) ).

tff(addAssignment_19553,axiom,
    ! [VarCurr: state_type] :
      ( v39114(VarCurr,1)
    <=> v39116(VarCurr,1) ) ).

tff(addAssignment_19552,axiom,
    ! [VarCurr: state_type] :
      ( v39116(VarCurr,1)
    <=> v39291(VarCurr,1) ) ).

tff(addAssignment_19551,axiom,
    ! [VarCurr: state_type] :
      ( v39291(VarCurr,0)
    <=> v39292(VarCurr) ) ).

tff(addAssignment_19550,axiom,
    ! [VarCurr: state_type] :
      ( v39291(VarCurr,1)
    <=> v39118(VarCurr) ) ).

tff(addAssignment_19549,axiom,
    ! [VarCurr: state_type] :
      ( v39118(VarCurr)
    <=> v39120(VarCurr) ) ).

tff(addAssignment_19548,axiom,
    ! [VarCurr: state_type] :
      ( v39120(VarCurr)
    <=> v39122(VarCurr) ) ).

tff(writeUnaryOperator_2333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39122(VarCurr)
    <=> v39289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3792,axiom,
    ! [VarCurr: state_type] :
      ( v39289(VarCurr)
    <=> ( v39290(VarCurr)
        | v39277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3791,axiom,
    ! [VarCurr: state_type] :
      ( v39290(VarCurr)
    <=> ( v39124(VarCurr)
        | v39139(VarCurr) ) ) ).

tff(addAssignment_19547,axiom,
    ! [VarCurr: state_type] :
      ( v39277(VarCurr)
    <=> v39279(VarCurr) ) ).

tff(addAssignment_19546,axiom,
    ! [VarCurr: state_type] :
      ( v39279(VarCurr)
    <=> v39128(VarCurr,2) ) ).

tff(addAssignment_19545,axiom,
    ! [VarCurr: state_type] :
      ( v39128(VarCurr,2)
    <=> v39130(VarCurr,2) ) ).

tff(addAssignment_19544,axiom,
    ! [VarCurr: state_type] :
      ( v39130(VarCurr,2)
    <=> v39132(VarCurr,2) ) ).

tff(addAssignment_19543,axiom,
    ! [VarCurr: state_type] :
      ( v39132(VarCurr,2)
    <=> v39137(VarCurr,2) ) ).

tff(addAssignment_19542,axiom,
    ! [VarCurr: state_type] :
      ( v39134(VarCurr,2)
    <=> v39136(VarCurr,2) ) ).

tff(addAssignment_19541,axiom,
    ! [VarCurr: state_type] :
      ( v39136(VarCurr,2)
    <=> v39045(VarCurr,2) ) ).

tff(addAssignment_19540,axiom,
    ! [VarCurr: state_type] :
      ( v39045(VarCurr,2)
    <=> v38957(VarCurr,5) ) ).

tff(addAssignment_19539,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,5)
    <=> v38959(VarCurr,5) ) ).

tff(addAssignment_19538,axiom,
    ! [VarNext: state_type] :
      ( v38959(VarNext,5)
    <=> v39281(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39282(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v39281(VarNext,B)
            <=> v38959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_462,axiom,
    ! [VarNext: state_type] :
      ( v39282(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39281(VarNext,B)
          <=> v39270(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39282(VarNext)
      <=> v39283(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39283(VarNext)
      <=> ( v39285(VarNext)
          & v39212(VarNext) ) ) ) ).

tff(writeUnaryOperator_2332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39285(VarNext)
      <=> v39264(VarNext) ) ) ).

tff(addAssignment_19537,axiom,
    ! [VarCurr: state_type] :
      ( v39069(VarCurr,5)
    <=> v39071(VarCurr,5) ) ).

tff(addAssignment_19536,axiom,
    ! [VarCurr: state_type] :
      ( v39071(VarCurr,5)
    <=> v39209(VarCurr,5) ) ).

tff(addAssignment_19535,axiom,
    ! [VarCurr: state_type] :
      ( v39073(VarCurr,2)
    <=> v39075(VarCurr,2) ) ).

tff(addAssignment_19534,axiom,
    ! [VarCurr: state_type] :
      ( v39075(VarCurr,2)
    <=> v39077(VarCurr,2) ) ).

tff(addAssignment_19533,axiom,
    ! [VarCurr: state_type] :
      ( v39077(VarCurr,2)
    <=> v39208(VarCurr,2) ) ).

tff(addAssignment_19532,axiom,
    ! [VarCurr: state_type] :
      ( v39145(VarCurr,2)
    <=> v39147(VarCurr,2) ) ).

tff(addAssignment_19531,axiom,
    ! [VarCurr: state_type] :
      ( v39147(VarCurr,2)
    <=> v39149(VarCurr,2) ) ).

tff(addAssignment_19530,axiom,
    ! [VarCurr: state_type] :
      ( v39149(VarCurr,2)
    <=> v39151(VarCurr,2) ) ).

tff(addAssignment_19529,axiom,
    ! [VarCurr: state_type] :
      ( v39151(VarCurr,2)
    <=> v39153(VarCurr,2) ) ).

tff(addAssignment_19528,axiom,
    ! [VarCurr: state_type] :
      ( v39153(VarCurr,2)
    <=> v39163(VarCurr,2) ) ).

tff(addAssignment_19527,axiom,
    ! [VarCurr: state_type] :
      ( v39155(VarCurr,2)
    <=> v39157(VarCurr,2) ) ).

tff(addAssignment_19526,axiom,
    ! [VarCurr: state_type] :
      ( v39157(VarCurr,2)
    <=> v39158(VarCurr,2) ) ).

tff(addAssignment_19525,axiom,
    ! [VarCurr: state_type] :
      ( v39079(VarCurr,2)
    <=> v39081(VarCurr,2) ) ).

tff(addAssignment_19524,axiom,
    ! [VarCurr: state_type] :
      ( v39081(VarCurr,2)
    <=> v39142(VarCurr,2) ) ).

tff(addAssignment_19523,axiom,
    ! [VarCurr: state_type] :
      ( v39139(VarCurr)
    <=> v39141(VarCurr) ) ).

tff(addAssignment_19522,axiom,
    ! [VarCurr: state_type] :
      ( v39141(VarCurr)
    <=> v39045(VarCurr,1) ) ).

tff(addAssignment_19521,axiom,
    ! [VarCurr: state_type] :
      ( v39045(VarCurr,1)
    <=> v38957(VarCurr,4) ) ).

tff(addAssignment_19520,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,4)
    <=> v38959(VarCurr,4) ) ).

tff(addAssignment_19519,axiom,
    ! [VarNext: state_type] :
      ( v38959(VarNext,4)
    <=> v39259(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39260(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v39259(VarNext,B)
            <=> v38959(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_461,axiom,
    ! [VarNext: state_type] :
      ( v39260(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39259(VarNext,B)
          <=> v39270(VarNext,B) ) ) ) ).

tff(addAssignment_19518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39270(VarNext,B)
          <=> v39268(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39271(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39268(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_323,axiom,
    ! [VarCurr: state_type] :
      ( v39271(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v39268(VarCurr,B)
          <=> v39069(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3788,axiom,
    ! [VarCurr: state_type] :
      ( v39271(VarCurr)
    <=> ( v39272(VarCurr)
        & v39273(VarCurr) ) ) ).

tff(writeUnaryOperator_2331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39273(VarCurr)
    <=> v39059(VarCurr) ) ).

tff(writeUnaryOperator_2330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39272(VarCurr)
    <=> v39047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3787,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39260(VarNext)
      <=> v39261(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39261(VarNext)
      <=> ( v39262(VarNext)
          & v39212(VarNext) ) ) ) ).

tff(writeUnaryOperator_2329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39262(VarNext)
      <=> v39264(VarNext) ) ) ).

tff(addAssignment_19517,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39264(VarNext)
      <=> v39212(VarCurr) ) ) ).

tff(addAssignment_19516,axiom,
    ! [VarCurr: state_type] :
      ( v39212(VarCurr)
    <=> v39214(VarCurr) ) ).

tff(addAssignment_19515,axiom,
    ! [VarCurr: state_type] :
      ( v39214(VarCurr)
    <=> v39216(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3785,axiom,
    ! [VarCurr: state_type] :
      ( v39216(VarCurr)
    <=> ( v39257(VarCurr)
        | v39253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3784,axiom,
    ! [VarCurr: state_type] :
      ( v39257(VarCurr)
    <=> ( v39218(VarCurr)
        & v39222(VarCurr) ) ) ).

tff(addAssignment_19514,axiom,
    ! [VarCurr: state_type] :
      ( v39253(VarCurr)
    <=> v39255(VarCurr) ) ).

tff(addAssignment_19513,axiom,
    ! [VarCurr: state_type] :
      ( v39255(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39237(VarNext)
       => ( v39222(VarNext)
        <=> v39222(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_460,axiom,
    ! [VarNext: state_type] :
      ( v39237(VarNext)
     => ( v39222(VarNext)
      <=> v39247(VarNext) ) ) ).

tff(addAssignment_19512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39247(VarNext)
      <=> v39245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3783,axiom,
    ! [VarCurr: state_type] :
      ( v39245(VarCurr)
    <=> ( v39248(VarCurr)
        & v39249(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3782,axiom,
    ! [VarCurr: state_type] :
      ( v39249(VarCurr)
    <=> ( v39228(VarCurr)
        | v39232(VarCurr) ) ) ).

tff(writeUnaryOperator_2328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39248(VarCurr)
    <=> v39224(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39237(VarNext)
      <=> v39238(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3780,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39238(VarNext)
      <=> ( v39240(VarNext)
          & v39242(VarNext) ) ) ) ).

tff(writeUnaryOperator_2327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39242(VarCurr)
    <=> v39218(VarCurr) ) ).

tff(addAssignment_19511,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39240(VarNext)
      <=> v39218(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_160,axiom,
    ( v39222(constB0)
  <=> $true ) ).

tff(addAssignment_19510,axiom,
    ! [VarCurr: state_type] :
      ( v39232(VarCurr)
    <=> v39234(VarCurr) ) ).

tff(addAssignment_19509,axiom,
    ! [VarCurr: state_type] :
      ( v39234(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19508,axiom,
    ! [VarCurr: state_type] :
      ( v39228(VarCurr)
    <=> v39230(VarCurr) ) ).

tff(addAssignment_19507,axiom,
    ! [VarCurr: state_type] :
      ( v39230(VarCurr)
    <=> $true ) ).

tff(addAssignment_19506,axiom,
    ! [VarCurr: state_type] :
      ( v39224(VarCurr)
    <=> v39226(VarCurr) ) ).

tff(addAssignment_19505,axiom,
    ! [VarCurr: state_type] :
      ( v39226(VarCurr)
    <=> $false ) ).

tff(addAssignment_19504,axiom,
    ! [VarCurr: state_type] :
      ( v39218(VarCurr)
    <=> v39220(VarCurr) ) ).

tff(addAssignment_19503,axiom,
    ! [VarCurr: state_type] :
      ( v39220(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19502,axiom,
    ! [VarCurr: state_type] :
      ( v39069(VarCurr,4)
    <=> v39071(VarCurr,4) ) ).

tff(addAssignment_19501,axiom,
    ! [VarCurr: state_type] :
      ( v39071(VarCurr,4)
    <=> v39209(VarCurr,4) ) ).

tff(addAssignment_19500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v39209(VarCurr,B)
      <=> v39210(VarCurr,B) ) ) ).

tff(addAssignment_19499,axiom,
    ! [VarCurr: state_type] :
      ( ( v39209(VarCurr,5)
      <=> v39073(VarCurr,2) )
      & ( v39209(VarCurr,4)
      <=> v39073(VarCurr,1) )
      & ( v39209(VarCurr,3)
      <=> v39073(VarCurr,0) ) ) ).

tff(addAssignment_19498,axiom,
    ! [VarCurr: state_type] :
      ( v39073(VarCurr,1)
    <=> v39075(VarCurr,1) ) ).

tff(addAssignment_19497,axiom,
    ! [VarCurr: state_type] :
      ( v39075(VarCurr,1)
    <=> v39077(VarCurr,1) ) ).

tff(addAssignment_19496,axiom,
    ! [VarCurr: state_type] :
      ( v39077(VarCurr,1)
    <=> v39208(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v39208(VarCurr,B)
      <=> ( v39079(VarCurr,B)
          & v39145(VarCurr,B) ) ) ) ).

tff(addAssignment_19495,axiom,
    ! [VarCurr: state_type] :
      ( v39145(VarCurr,1)
    <=> v39147(VarCurr,1) ) ).

tff(addAssignment_19494,axiom,
    ! [VarCurr: state_type] :
      ( v39147(VarCurr,1)
    <=> v39149(VarCurr,1) ) ).

tff(addAssignment_19493,axiom,
    ! [VarCurr: state_type] :
      ( v39149(VarCurr,1)
    <=> v39151(VarCurr,1) ) ).

tff(addAssignment_19492,axiom,
    ! [VarCurr: state_type] :
      ( v39151(VarCurr,1)
    <=> v39153(VarCurr,1) ) ).

tff(addAssignment_19491,axiom,
    ! [VarCurr: state_type] :
      ( v39153(VarCurr,1)
    <=> v39163(VarCurr,1) ) ).

tff(addAssignment_19490,axiom,
    ! [VarCurr: state_type] :
      ( v39163(VarCurr,0)
    <=> v39203(VarCurr) ) ).

tff(addAssignment_19489,axiom,
    ! [VarCurr: state_type] :
      ( v39163(VarCurr,1)
    <=> v39198(VarCurr) ) ).

tff(addAssignment_19488,axiom,
    ! [VarCurr: state_type] :
      ( v39163(VarCurr,2)
    <=> v39193(VarCurr) ) ).

tff(addAssignment_19487,axiom,
    ! [VarCurr: state_type] :
      ( v39163(VarCurr,3)
    <=> v39165(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3779,axiom,
    ! [VarCurr: state_type] :
      ( v39203(VarCurr)
    <=> ( v39204(VarCurr)
        & v39207(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3778,axiom,
    ! [VarCurr: state_type] :
      ( v39207(VarCurr)
    <=> ( v39155(VarCurr,0)
        | v39173(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3777,axiom,
    ! [VarCurr: state_type] :
      ( v39204(VarCurr)
    <=> ( v39205(VarCurr)
        | v39206(VarCurr) ) ) ).

tff(writeUnaryOperator_2326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39206(VarCurr)
    <=> v39173(VarCurr,0) ) ).

tff(writeUnaryOperator_2325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39205(VarCurr)
    <=> v39155(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3776,axiom,
    ! [VarCurr: state_type] :
      ( v39198(VarCurr)
    <=> ( v39199(VarCurr)
        & v39202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3775,axiom,
    ! [VarCurr: state_type] :
      ( v39202(VarCurr)
    <=> ( v39172(VarCurr)
        | v39174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3774,axiom,
    ! [VarCurr: state_type] :
      ( v39199(VarCurr)
    <=> ( v39200(VarCurr)
        | v39201(VarCurr) ) ) ).

tff(writeUnaryOperator_2324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39201(VarCurr)
    <=> v39174(VarCurr) ) ).

tff(writeUnaryOperator_2323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39200(VarCurr)
    <=> v39172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3773,axiom,
    ! [VarCurr: state_type] :
      ( v39193(VarCurr)
    <=> ( v39194(VarCurr)
        & v39197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3772,axiom,
    ! [VarCurr: state_type] :
      ( v39197(VarCurr)
    <=> ( v39170(VarCurr)
        | v39180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3771,axiom,
    ! [VarCurr: state_type] :
      ( v39194(VarCurr)
    <=> ( v39195(VarCurr)
        | v39196(VarCurr) ) ) ).

tff(writeUnaryOperator_2322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39196(VarCurr)
    <=> v39180(VarCurr) ) ).

tff(writeUnaryOperator_2321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39195(VarCurr)
    <=> v39170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3770,axiom,
    ! [VarCurr: state_type] :
      ( v39165(VarCurr)
    <=> ( v39166(VarCurr)
        & v39192(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3769,axiom,
    ! [VarCurr: state_type] :
      ( v39192(VarCurr)
    <=> ( v39168(VarCurr)
        | v39187(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3768,axiom,
    ! [VarCurr: state_type] :
      ( v39166(VarCurr)
    <=> ( v39167(VarCurr)
        | v39186(VarCurr) ) ) ).

tff(writeUnaryOperator_2320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39186(VarCurr)
    <=> v39187(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3767,axiom,
    ! [VarCurr: state_type] :
      ( v39187(VarCurr)
    <=> ( v39188(VarCurr)
        & v39191(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_513,axiom,
    ! [VarCurr: state_type] :
      ( v39191(VarCurr)
    <=> ( v39155(VarCurr,3)
        | v39173(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3766,axiom,
    ! [VarCurr: state_type] :
      ( v39188(VarCurr)
    <=> ( v39189(VarCurr)
        | v39190(VarCurr) ) ) ).

tff(writeUnaryOperator_2319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39190(VarCurr)
    <=> v39173(VarCurr,3) ) ).

tff(writeUnaryOperator_2318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39189(VarCurr)
    <=> v39155(VarCurr,3) ) ).

tff(writeUnaryOperator_2317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39167(VarCurr)
    <=> v39168(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3765,axiom,
    ! [VarCurr: state_type] :
      ( v39168(VarCurr)
    <=> ( v39169(VarCurr)
        | v39185(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_512,axiom,
    ! [VarCurr: state_type] :
      ( v39185(VarCurr)
    <=> ( v39155(VarCurr,2)
        & v39173(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3764,axiom,
    ! [VarCurr: state_type] :
      ( v39169(VarCurr)
    <=> ( v39170(VarCurr)
        & v39180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3763,axiom,
    ! [VarCurr: state_type] :
      ( v39180(VarCurr)
    <=> ( v39181(VarCurr)
        & v39184(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_511,axiom,
    ! [VarCurr: state_type] :
      ( v39184(VarCurr)
    <=> ( v39155(VarCurr,2)
        | v39173(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3762,axiom,
    ! [VarCurr: state_type] :
      ( v39181(VarCurr)
    <=> ( v39182(VarCurr)
        | v39183(VarCurr) ) ) ).

tff(writeUnaryOperator_2316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39183(VarCurr)
    <=> v39173(VarCurr,2) ) ).

tff(writeUnaryOperator_2315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39182(VarCurr)
    <=> v39155(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3761,axiom,
    ! [VarCurr: state_type] :
      ( v39170(VarCurr)
    <=> ( v39171(VarCurr)
        | v39179(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_510,axiom,
    ! [VarCurr: state_type] :
      ( v39179(VarCurr)
    <=> ( v39155(VarCurr,1)
        & v39173(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3760,axiom,
    ! [VarCurr: state_type] :
      ( v39171(VarCurr)
    <=> ( v39172(VarCurr)
        & v39174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3759,axiom,
    ! [VarCurr: state_type] :
      ( v39174(VarCurr)
    <=> ( v39175(VarCurr)
        & v39178(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_509,axiom,
    ! [VarCurr: state_type] :
      ( v39178(VarCurr)
    <=> ( v39155(VarCurr,1)
        | v39173(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3758,axiom,
    ! [VarCurr: state_type] :
      ( v39175(VarCurr)
    <=> ( v39176(VarCurr)
        | v39177(VarCurr) ) ) ).

tff(writeUnaryOperator_2314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39177(VarCurr)
    <=> v39173(VarCurr,1) ) ).

tff(writeUnaryOperator_2313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39176(VarCurr)
    <=> v39155(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3757,axiom,
    ! [VarCurr: state_type] :
      ( v39172(VarCurr)
    <=> ( v39155(VarCurr,0)
        & v39173(VarCurr,0) ) ) ).

tff(addAssignment_19486,axiom,
    ! [VarCurr: state_type] :
      ( v39173(VarCurr,0)
    <=> v39160(VarCurr) ) ).

tff(addAssignment_19485,axiom,
    ! [VarCurr: state_type] :
      ( ( v39173(VarCurr,3)
      <=> $false )
      & ( v39173(VarCurr,2)
      <=> $false )
      & ( v39173(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_19484,axiom,
    ! [VarCurr: state_type] :
      ( v39160(VarCurr)
    <=> v39162(VarCurr) ) ).

tff(addAssignment_19483,axiom,
    ! [VarCurr: state_type] :
      ( v39162(VarCurr)
    <=> v39110(VarCurr) ) ).

tff(addAssignment_19482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v39155(VarCurr,B)
      <=> v39157(VarCurr,B) ) ) ).

tff(addAssignment_19481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v39157(VarCurr,B)
      <=> v39158(VarCurr,B) ) ) ).

tff(addAssignment_19480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v39158(VarCurr,B)
      <=> v39045(VarCurr,B) ) ) ).

tff(addAssignment_19479,axiom,
    ! [VarCurr: state_type] :
      ( v39158(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_19478,axiom,
    ! [VarCurr: state_type] :
      ( v39079(VarCurr,1)
    <=> v39081(VarCurr,1) ) ).

tff(addAssignment_19477,axiom,
    ! [VarCurr: state_type] :
      ( v39081(VarCurr,1)
    <=> v39142(VarCurr,1) ) ).

tff(addAssignment_19476,axiom,
    ! [VarCurr: state_type] :
      ( v39142(VarCurr,0)
    <=> v39143(VarCurr) ) ).

tff(addAssignment_19475,axiom,
    ! [VarCurr: state_type] :
      ( v39142(VarCurr,1)
    <=> v39143(VarCurr) ) ).

tff(addAssignment_19474,axiom,
    ! [VarCurr: state_type] :
      ( v39142(VarCurr,2)
    <=> v39143(VarCurr) ) ).

tff(addAssignment_19473,axiom,
    ! [VarCurr: state_type] :
      ( v39143(VarCurr)
    <=> v39083(VarCurr) ) ).

tff(addAssignment_19472,axiom,
    ! [VarCurr: state_type] :
      ( v39124(VarCurr)
    <=> v39126(VarCurr) ) ).

tff(addAssignment_19471,axiom,
    ! [VarCurr: state_type] :
      ( v39126(VarCurr)
    <=> v39128(VarCurr,0) ) ).

tff(addAssignment_19470,axiom,
    ! [VarCurr: state_type] :
      ( v39128(VarCurr,0)
    <=> v39130(VarCurr,0) ) ).

tff(addAssignment_19469,axiom,
    ! [VarCurr: state_type] :
      ( v39130(VarCurr,0)
    <=> v39132(VarCurr,0) ) ).

tff(addAssignment_19468,axiom,
    ! [VarCurr: state_type] :
      ( v39132(VarCurr,0)
    <=> v39137(VarCurr,0) ) ).

tff(writeUnaryOperator_2312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v39137(VarCurr,B)
      <=> ~ v39134(VarCurr,B) ) ) ).

tff(addAssignment_19467,axiom,
    ! [VarCurr: state_type] :
      ( v39134(VarCurr,0)
    <=> v39136(VarCurr,0) ) ).

tff(addAssignment_19466,axiom,
    ! [VarCurr: state_type] :
      ( v39136(VarCurr,0)
    <=> v39045(VarCurr,0) ) ).

tff(addAssignment_19465,axiom,
    ! [VarCurr: state_type] :
      ( v39106(VarCurr,1)
    <=> v39108(VarCurr,1) ) ).

tff(addAssignment_19464,axiom,
    ! [VarCurr: state_type] :
      ( v39108(VarCurr,1)
    <=> v39111(VarCurr,1) ) ).

tff(addAssignment_19463,axiom,
    ! [VarCurr: state_type] :
      ( v39111(VarCurr,0)
    <=> v39112(VarCurr) ) ).

tff(addAssignment_19462,axiom,
    ! [VarCurr: state_type] :
      ( v39111(VarCurr,1)
    <=> v39110(VarCurr) ) ).

tff(addAssignment_19461,axiom,
    ! [VarCurr: state_type] :
      ( v39110(VarCurr)
    <=> v7230(VarCurr,5) ) ).

tff(addAssignment_19460,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,5)
    <=> v7232(VarCurr,5) ) ).

tff(addAssignment_19459,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,5)
    <=> v7234(VarCurr,5) ) ).

tff(addAssignment_19458,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,5)
    <=> v34455(VarCurr,5) ) ).

tff(addAssignment_19457,axiom,
    ! [VarCurr: state_type] :
      ( v39090(VarCurr,1)
    <=> v39092(VarCurr,1) ) ).

tff(addAssignment_19456,axiom,
    ! [VarCurr: state_type] :
      ( v39092(VarCurr,1)
    <=> v39093(VarCurr,1) ) ).

tff(addAssignment_19455,axiom,
    ! [VarCurr: state_type] :
      ( v39093(VarCurr,0)
    <=> v39094(VarCurr) ) ).

tff(addAssignment_19454,axiom,
    ! [VarCurr: state_type] :
      ( v39093(VarCurr,1)
    <=> v39094(VarCurr) ) ).

tff(addAssignment_19453,axiom,
    ! [VarCurr: state_type] :
      ( v39094(VarCurr)
    <=> v38617(VarCurr) ) ).

tff(addAssignment_19452,axiom,
    ! [VarCurr: state_type] :
      ( v39059(VarCurr)
    <=> v39061(VarCurr) ) ).

tff(addAssignment_19451,axiom,
    ! [VarCurr: state_type] :
      ( v39061(VarCurr)
    <=> v39063(VarCurr) ) ).

tff(addAssignment_19450,axiom,
    ! [VarCurr: state_type] :
      ( v39063(VarCurr)
    <=> v39065(VarCurr) ) ).

tff(addAssignment_19449,axiom,
    ! [VarCurr: state_type] :
      ( v39065(VarCurr)
    <=> v39067(VarCurr) ) ).

tff(addAssignment_19448,axiom,
    ! [VarCurr: state_type] :
      ( v39067(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19447,axiom,
    ! [VarCurr: state_type] :
      ( v39047(VarCurr)
    <=> v39049(VarCurr) ) ).

tff(addAssignment_19446,axiom,
    ! [VarCurr: state_type] :
      ( v39049(VarCurr)
    <=> v39051(VarCurr) ) ).

tff(addAssignment_19445,axiom,
    ! [VarCurr: state_type] :
      ( v39051(VarCurr)
    <=> v39053(VarCurr) ) ).

tff(addAssignment_19444,axiom,
    ! [VarCurr: state_type] :
      ( v39053(VarCurr)
    <=> v39055(VarCurr) ) ).

tff(addAssignment_19443,axiom,
    ! [VarCurr: state_type] :
      ( v39055(VarCurr)
    <=> v39057(VarCurr) ) ).

tff(addAssignment_19442,axiom,
    ! [VarCurr: state_type] :
      ( v39057(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_19441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38555(VarCurr,B)
      <=> v38557(VarCurr,B) ) ) ).

tff(addAssignment_19440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38557(VarCurr,B)
      <=> v38559(VarCurr,B) ) ) ).

tff(addAssignment_19439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38559(VarCurr,B)
      <=> v38561(VarCurr,B) ) ) ).

tff(addAssignment_19438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38561(VarCurr,B)
      <=> v38563(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39008(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v38563(VarNext,B)
            <=> v38563(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_459,axiom,
    ! [VarNext: state_type] :
      ( v39008(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38563(VarNext,B)
          <=> v39018(VarNext,B) ) ) ) ).

tff(addAssignment_19437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39018(VarNext,B)
          <=> v39016(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39016(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_322,axiom,
    ! [VarCurr: state_type] :
      ( v39019(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v39016(VarCurr,B)
          <=> v38593(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3756,axiom,
    ! [VarCurr: state_type] :
      ( v39019(VarCurr)
    <=> ( v39020(VarCurr)
        & v39021(VarCurr) ) ) ).

tff(writeUnaryOperator_2311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39021(VarCurr)
    <=> v38579(VarCurr) ) ).

tff(writeUnaryOperator_2310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v39020(VarCurr)
    <=> v38565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39008(VarNext)
      <=> v39009(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39009(VarNext)
      <=> ( v39010(VarNext)
          & v38923(VarNext) ) ) ) ).

tff(writeUnaryOperator_2309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v39010(VarNext)
      <=> v39012(VarNext) ) ) ).

tff(addAssignment_19436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v39012(VarNext)
      <=> v38923(VarCurr) ) ) ).

tff(addAssignment_19435,axiom,
    ! [VarCurr: state_type] :
      ( v38923(VarCurr)
    <=> v38925(VarCurr) ) ).

tff(addAssignment_19434,axiom,
    ! [VarCurr: state_type] :
      ( v38925(VarCurr)
    <=> v38927(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3753,axiom,
    ! [VarCurr: state_type] :
      ( v38927(VarCurr)
    <=> ( v39005(VarCurr)
        | v38997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3752,axiom,
    ! [VarCurr: state_type] :
      ( v39005(VarCurr)
    <=> ( v38929(VarCurr)
        & v38935(VarCurr) ) ) ).

tff(addAssignment_19433,axiom,
    ! [VarCurr: state_type] :
      ( v38997(VarCurr)
    <=> v38999(VarCurr) ) ).

tff(addAssignment_19432,axiom,
    ! [VarCurr: state_type] :
      ( v38999(VarCurr)
    <=> v39001(VarCurr) ) ).

tff(addAssignment_19431,axiom,
    ! [VarCurr: state_type] :
      ( v39001(VarCurr)
    <=> v39003(VarCurr) ) ).

tff(addAssignment_19430,axiom,
    ! [VarCurr: state_type] :
      ( v39003(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38981(VarNext)
       => ( v38935(VarNext)
        <=> v38935(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_458,axiom,
    ! [VarNext: state_type] :
      ( v38981(VarNext)
     => ( v38935(VarNext)
      <=> v38991(VarNext) ) ) ).

tff(addAssignment_19429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38991(VarNext)
      <=> v38989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3751,axiom,
    ! [VarCurr: state_type] :
      ( v38989(VarCurr)
    <=> ( v38992(VarCurr)
        & v38993(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3750,axiom,
    ! [VarCurr: state_type] :
      ( v38993(VarCurr)
    <=> ( v38941(VarCurr)
        | v38972(VarCurr) ) ) ).

tff(writeUnaryOperator_2308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38992(VarCurr)
    <=> v38937(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3749,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38981(VarNext)
      <=> v38982(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3748,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38982(VarNext)
      <=> ( v38984(VarNext)
          & v38986(VarNext) ) ) ) ).

tff(writeUnaryOperator_2307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38986(VarCurr)
    <=> v38929(VarCurr) ) ).

tff(addAssignment_19428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38984(VarNext)
      <=> v38929(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_159,axiom,
    ( v38935(constB0)
  <=> $true ) ).

tff(addAssignment_19427,axiom,
    ! [VarCurr: state_type] :
      ( v38972(VarCurr)
    <=> v38974(VarCurr) ) ).

tff(addAssignment_19426,axiom,
    ! [VarCurr: state_type] :
      ( v38974(VarCurr)
    <=> v38976(VarCurr) ) ).

tff(addAssignment_19425,axiom,
    ! [VarCurr: state_type] :
      ( v38976(VarCurr)
    <=> v38978(VarCurr) ) ).

tff(addAssignment_19424,axiom,
    ! [VarCurr: state_type] :
      ( v38978(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_19423,axiom,
    ! [VarCurr: state_type] :
      ( v38941(VarCurr)
    <=> v38943(VarCurr) ) ).

tff(addAssignment_19422,axiom,
    ! [VarCurr: state_type] :
      ( v38943(VarCurr)
    <=> v38945(VarCurr) ) ).

tff(addAssignment_19421,axiom,
    ! [VarCurr: state_type] :
      ( v38945(VarCurr)
    <=> v38947(VarCurr) ) ).

tff(addAssignment_19420,axiom,
    ! [VarCurr: state_type] :
      ( v38947(VarCurr)
    <=> v38949(VarCurr) ) ).

tff(writeUnaryOperator_2306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38949(VarCurr)
    <=> v38969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3747,axiom,
    ! [VarCurr: state_type] :
      ( v38969(VarCurr)
    <=> ( v38970(VarCurr)
        | v38965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3746,axiom,
    ! [VarCurr: state_type] :
      ( v38970(VarCurr)
    <=> ( v38951(VarCurr)
        | v38961(VarCurr) ) ) ).

tff(addAssignment_19419,axiom,
    ! [VarCurr: state_type] :
      ( v38965(VarCurr)
    <=> v38967(VarCurr) ) ).

tff(addAssignment_19418,axiom,
    ! [VarCurr: state_type] :
      ( v38967(VarCurr)
    <=> v38955(VarCurr,2) ) ).

tff(addAssignment_19417,axiom,
    ! [VarCurr: state_type] :
      ( v38955(VarCurr,2)
    <=> v38957(VarCurr,2) ) ).

tff(addAssignment_19416,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,2)
    <=> v38959(VarCurr,2) ) ).

tff(addAssignment_19415,axiom,
    ! [VarCurr: state_type] :
      ( v38961(VarCurr)
    <=> v38963(VarCurr) ) ).

tff(addAssignment_19414,axiom,
    ! [VarCurr: state_type] :
      ( v38963(VarCurr)
    <=> v38955(VarCurr,1) ) ).

tff(addAssignment_19413,axiom,
    ! [VarCurr: state_type] :
      ( v38955(VarCurr,1)
    <=> v38957(VarCurr,1) ) ).

tff(addAssignment_19412,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,1)
    <=> v38959(VarCurr,1) ) ).

tff(addAssignment_19411,axiom,
    ! [VarCurr: state_type] :
      ( v38951(VarCurr)
    <=> v38953(VarCurr) ) ).

tff(addAssignment_19410,axiom,
    ! [VarCurr: state_type] :
      ( v38953(VarCurr)
    <=> v38955(VarCurr,0) ) ).

tff(addAssignment_19409,axiom,
    ! [VarCurr: state_type] :
      ( v38955(VarCurr,0)
    <=> v38957(VarCurr,0) ) ).

tff(addAssignment_19408,axiom,
    ! [VarCurr: state_type] :
      ( v38957(VarCurr,0)
    <=> v38959(VarCurr,0) ) ).

tff(addAssignment_19407,axiom,
    ! [VarCurr: state_type] :
      ( v38937(VarCurr)
    <=> v38939(VarCurr) ) ).

tff(addAssignment_19406,axiom,
    ! [VarCurr: state_type] :
      ( v38939(VarCurr)
    <=> $false ) ).

tff(addAssignment_19405,axiom,
    ! [VarCurr: state_type] :
      ( v38929(VarCurr)
    <=> v38931(VarCurr) ) ).

tff(addAssignment_19404,axiom,
    ! [VarCurr: state_type] :
      ( v38931(VarCurr)
    <=> v38933(VarCurr) ) ).

tff(addAssignment_19403,axiom,
    ! [VarCurr: state_type] :
      ( v38933(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_19402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38593(VarCurr,B)
      <=> v38595(VarCurr,B) ) ) ).

tff(addAssignment_19401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38595(VarCurr,B)
      <=> v38597(VarCurr,B) ) ) ).

tff(addAssignment_19400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38597(VarCurr,B)
      <=> v38599(VarCurr,B) ) ) ).

tff(addAssignment_19399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38599(VarCurr,B)
      <=> v38601(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38601(VarCurr,B)
      <=> ( v38603(VarCurr,B)
          & v38625(VarCurr,B) ) ) ) ).

tff(addAssignment_19398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38625(VarCurr,B)
      <=> v38627(VarCurr,B) ) ) ).

tff(addAssignment_19397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38627(VarCurr,B)
      <=> v38629(VarCurr,B) ) ) ).

tff(addAssignment_19396,axiom,
    ! [VarCurr: state_type] :
      ( ( v38629(VarCurr,11)
      <=> v6324(VarCurr,71) )
      & ( v38629(VarCurr,10)
      <=> v6324(VarCurr,70) )
      & ( v38629(VarCurr,9)
      <=> v6324(VarCurr,69) )
      & ( v38629(VarCurr,8)
      <=> v6324(VarCurr,68) )
      & ( v38629(VarCurr,7)
      <=> v6324(VarCurr,67) )
      & ( v38629(VarCurr,6)
      <=> v6324(VarCurr,66) )
      & ( v38629(VarCurr,5)
      <=> v6324(VarCurr,65) )
      & ( v38629(VarCurr,4)
      <=> v6324(VarCurr,64) )
      & ( v38629(VarCurr,3)
      <=> v6324(VarCurr,63) )
      & ( v38629(VarCurr,2)
      <=> v6324(VarCurr,62) )
      & ( v38629(VarCurr,1)
      <=> v6324(VarCurr,61) )
      & ( v38629(VarCurr,0)
      <=> v6324(VarCurr,60) ) ) ).

tff(addAssignment_19395,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,71)
      <=> v38631(VarCurr,11) )
      & ( v6324(VarCurr,70)
      <=> v38631(VarCurr,10) )
      & ( v6324(VarCurr,69)
      <=> v38631(VarCurr,9) )
      & ( v6324(VarCurr,68)
      <=> v38631(VarCurr,8) )
      & ( v6324(VarCurr,67)
      <=> v38631(VarCurr,7) )
      & ( v6324(VarCurr,66)
      <=> v38631(VarCurr,6) )
      & ( v6324(VarCurr,65)
      <=> v38631(VarCurr,5) )
      & ( v6324(VarCurr,64)
      <=> v38631(VarCurr,4) )
      & ( v6324(VarCurr,63)
      <=> v38631(VarCurr,3) )
      & ( v6324(VarCurr,62)
      <=> v38631(VarCurr,2) )
      & ( v6324(VarCurr,61)
      <=> v38631(VarCurr,1) )
      & ( v6324(VarCurr,60)
      <=> v38631(VarCurr,0) ) ) ).

tff(addAssignment_19394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38631(VarCurr,B)
      <=> v38633(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38633(VarCurr,B)
      <=> ( v38915(VarCurr,B)
          | v38918(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38918(VarCurr,B)
      <=> ( v38643(VarCurr,B)
          & v38919(VarCurr,B) ) ) ) ).

tff(addAssignment_19393,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,0)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19392,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,1)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19391,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,2)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19390,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,3)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19389,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,4)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19388,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,5)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19387,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,6)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19386,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,7)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19385,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,8)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19384,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,9)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19383,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,10)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19382,axiom,
    ! [VarCurr: state_type] :
      ( v38919(VarCurr,11)
    <=> v38920(VarCurr) ) ).

tff(addAssignment_19381,axiom,
    ! [VarCurr: state_type] :
      ( v38920(VarCurr)
    <=> v38911(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38915(VarCurr,B)
      <=> ( v38635(VarCurr,B)
          & v38916(VarCurr,B) ) ) ) ).

tff(addAssignment_19380,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,0)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19379,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,1)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19378,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,2)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19377,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,3)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19376,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,4)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19375,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,5)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19374,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,6)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19373,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,7)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19372,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,8)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19371,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,9)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19370,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,10)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19369,axiom,
    ! [VarCurr: state_type] :
      ( v38916(VarCurr,11)
    <=> v38917(VarCurr) ) ).

tff(addAssignment_19368,axiom,
    ! [VarCurr: state_type] :
      ( v38917(VarCurr)
    <=> v38639(VarCurr) ) ).

tff(addAssignment_19367,axiom,
    ! [VarCurr: state_type] :
      ( v38911(VarCurr)
    <=> v38913(VarCurr) ) ).

tff(addAssignment_19366,axiom,
    ! [VarCurr: state_type] :
      ( v38913(VarCurr)
    <=> v7021(VarCurr,5) ) ).

tff(addAssignment_19365,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,5)
    <=> v7023(VarCurr,5) ) ).

tff(addAssignment_19364,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,5)
    <=> v6623(VarCurr,5) ) ).

tff(addAssignment_19363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38643(VarCurr,B)
      <=> v38645(VarCurr,B) ) ) ).

tff(addAssignment_19362,axiom,
    ! [VarCurr: state_type] :
      ( ( v38645(VarCurr,11)
      <=> v6334(VarCurr,83) )
      & ( v38645(VarCurr,10)
      <=> v6334(VarCurr,82) )
      & ( v38645(VarCurr,9)
      <=> v6334(VarCurr,81) )
      & ( v38645(VarCurr,8)
      <=> v6334(VarCurr,80) )
      & ( v38645(VarCurr,7)
      <=> v6334(VarCurr,79) )
      & ( v38645(VarCurr,6)
      <=> v6334(VarCurr,78) )
      & ( v38645(VarCurr,5)
      <=> v6334(VarCurr,77) )
      & ( v38645(VarCurr,4)
      <=> v6334(VarCurr,76) )
      & ( v38645(VarCurr,3)
      <=> v6334(VarCurr,75) )
      & ( v38645(VarCurr,2)
      <=> v6334(VarCurr,74) )
      & ( v38645(VarCurr,1)
      <=> v6334(VarCurr,73) )
      & ( v38645(VarCurr,0)
      <=> v6334(VarCurr,72) ) ) ).

tff(addAssignment_19361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,84)
        & ~ $less(B,72) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_19360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,84)
        & ~ $less(B,72) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_19359,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,83)
      <=> v38647(VarCurr,11) )
      & ( v6338(VarCurr,82)
      <=> v38647(VarCurr,10) )
      & ( v6338(VarCurr,81)
      <=> v38647(VarCurr,9) )
      & ( v6338(VarCurr,80)
      <=> v38647(VarCurr,8) )
      & ( v6338(VarCurr,79)
      <=> v38647(VarCurr,7) )
      & ( v6338(VarCurr,78)
      <=> v38647(VarCurr,6) )
      & ( v6338(VarCurr,77)
      <=> v38647(VarCurr,5) )
      & ( v6338(VarCurr,76)
      <=> v38647(VarCurr,4) )
      & ( v6338(VarCurr,75)
      <=> v38647(VarCurr,3) )
      & ( v6338(VarCurr,74)
      <=> v38647(VarCurr,2) )
      & ( v6338(VarCurr,73)
      <=> v38647(VarCurr,1) )
      & ( v6338(VarCurr,72)
      <=> v38647(VarCurr,0) ) ) ).

tff(addAssignment_19358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38647(VarCurr,B)
      <=> v38649(VarCurr,B) ) ) ).

tff(addAssignment_19357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38649(VarCurr,B)
      <=> v38651(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38894(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v38651(VarNext,B)
            <=> v38651(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_457,axiom,
    ! [VarNext: state_type] :
      ( v38894(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38651(VarNext,B)
          <=> v38904(VarNext,B) ) ) ) ).

tff(addAssignment_19356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38904(VarNext,B)
          <=> v38902(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38902(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_321,axiom,
    ! [VarCurr: state_type] :
      ( v38905(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38902(VarCurr,B)
          <=> v38681(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3745,axiom,
    ! [VarCurr: state_type] :
      ( v38905(VarCurr)
    <=> ( v38906(VarCurr)
        & v38907(VarCurr) ) ) ).

tff(writeUnaryOperator_2305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38907(VarCurr)
    <=> v38667(VarCurr) ) ).

tff(writeUnaryOperator_2304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38906(VarCurr)
    <=> v38653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3744,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38894(VarNext)
      <=> v38895(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3743,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38895(VarNext)
      <=> ( v38896(VarNext)
          & v38869(VarNext) ) ) ) ).

tff(writeUnaryOperator_2303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38896(VarNext)
      <=> v38898(VarNext) ) ) ).

tff(addAssignment_19355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38898(VarNext)
      <=> v38869(VarCurr) ) ) ).

tff(addAssignment_19354,axiom,
    ! [VarCurr: state_type] :
      ( v38869(VarCurr)
    <=> v38871(VarCurr) ) ).

tff(addAssignment_19353,axiom,
    ! [VarCurr: state_type] :
      ( v38871(VarCurr)
    <=> v38873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3742,axiom,
    ! [VarCurr: state_type] :
      ( v38873(VarCurr)
    <=> ( v38891(VarCurr)
        | v38883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3741,axiom,
    ! [VarCurr: state_type] :
      ( v38891(VarCurr)
    <=> ( v38875(VarCurr)
        & v38881(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_158,axiom,
    ( v38881(constB0)
  <=> $true ) ).

tff(addAssignment_19352,axiom,
    ! [VarCurr: state_type] :
      ( v38883(VarCurr)
    <=> v38885(VarCurr) ) ).

tff(addAssignment_19351,axiom,
    ! [VarCurr: state_type] :
      ( v38885(VarCurr)
    <=> v38887(VarCurr) ) ).

tff(addAssignment_19350,axiom,
    ! [VarCurr: state_type] :
      ( v38887(VarCurr)
    <=> v38889(VarCurr) ) ).

tff(addAssignment_19349,axiom,
    ! [VarCurr: state_type] :
      ( v38889(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_19348,axiom,
    ! [VarCurr: state_type] :
      ( v38875(VarCurr)
    <=> v38877(VarCurr) ) ).

tff(addAssignment_19347,axiom,
    ! [VarCurr: state_type] :
      ( v38877(VarCurr)
    <=> v38879(VarCurr) ) ).

tff(addAssignment_19346,axiom,
    ! [VarCurr: state_type] :
      ( v38879(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_19345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38681(VarCurr,B)
      <=> v38683(VarCurr,B) ) ) ).

tff(addAssignment_19344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38683(VarCurr,B)
      <=> v38685(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38685(VarCurr,B)
      <=> ( v38854(VarCurr,B)
          | v38865(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38865(VarCurr,B)
      <=> ( v38818(VarCurr,B)
          & v38866(VarCurr,B) ) ) ) ).

tff(addAssignment_19343,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,0)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19342,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,1)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19341,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,2)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19340,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,3)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19339,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,4)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19338,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,5)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19337,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,6)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19336,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,7)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19335,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,8)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19334,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,9)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19333,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,10)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19332,axiom,
    ! [VarCurr: state_type] :
      ( v38866(VarCurr,11)
    <=> v38867(VarCurr) ) ).

tff(addAssignment_19331,axiom,
    ! [VarCurr: state_type] :
      ( v38867(VarCurr)
    <=> v38828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38854(VarCurr,B)
      <=> ( v38855(VarCurr,B)
          | v38862(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38862(VarCurr,B)
      <=> ( v38782(VarCurr,B)
          & v38863(VarCurr,B) ) ) ) ).

tff(addAssignment_19330,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,0)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19329,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,1)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19328,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,2)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19327,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,3)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19326,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,4)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19325,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,5)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19324,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,6)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19323,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,7)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19322,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,8)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19321,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,9)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19320,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,10)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19319,axiom,
    ! [VarCurr: state_type] :
      ( v38863(VarCurr,11)
    <=> v38864(VarCurr) ) ).

tff(addAssignment_19318,axiom,
    ! [VarCurr: state_type] :
      ( v38864(VarCurr)
    <=> v38792(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38855(VarCurr,B)
      <=> ( v38856(VarCurr,B)
          | v38859(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38859(VarCurr,B)
      <=> ( v38735(VarCurr,B)
          & v38860(VarCurr,B) ) ) ) ).

tff(addAssignment_19317,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,0)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19316,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,1)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19315,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,2)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19314,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,3)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19313,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,4)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19312,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,5)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19311,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,6)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19310,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,7)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19309,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,8)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19308,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,9)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19307,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,10)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19306,axiom,
    ! [VarCurr: state_type] :
      ( v38860(VarCurr,11)
    <=> v38861(VarCurr) ) ).

tff(addAssignment_19305,axiom,
    ! [VarCurr: state_type] :
      ( v38861(VarCurr)
    <=> v38745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38856(VarCurr,B)
      <=> ( v38687(VarCurr,B)
          & v38857(VarCurr,B) ) ) ) ).

tff(addAssignment_19304,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,0)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19303,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,1)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19302,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,2)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19301,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,3)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19300,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,4)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19299,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,5)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19298,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,6)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19297,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,7)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19296,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,8)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19295,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,9)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19294,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,10)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19293,axiom,
    ! [VarCurr: state_type] :
      ( v38857(VarCurr,11)
    <=> v38858(VarCurr) ) ).

tff(addAssignment_19292,axiom,
    ! [VarCurr: state_type] :
      ( v38858(VarCurr)
    <=> v38697(VarCurr) ) ).

tff(addAssignment_19291,axiom,
    ! [VarCurr: state_type] :
      ( v38828(VarCurr)
    <=> v38830(VarCurr) ) ).

tff(addAssignment_19290,axiom,
    ! [VarCurr: state_type] :
      ( v38830(VarCurr)
    <=> v38832(VarCurr) ) ).

tff(addAssignment_19289,axiom,
    ! [VarCurr: state_type] :
      ( v38832(VarCurr)
    <=> v38834(VarCurr) ) ).

tff(addAssignment_19288,axiom,
    ! [VarCurr: state_type] :
      ( v38834(VarCurr)
    <=> v38836(VarCurr) ) ).

tff(addAssignment_19287,axiom,
    ! [VarCurr: state_type] :
      ( v38836(VarCurr)
    <=> v38838(VarCurr) ) ).

tff(addAssignment_19286,axiom,
    ! [VarCurr: state_type] :
      ( v38838(VarCurr)
    <=> v38840(VarCurr) ) ).

tff(addAssignment_19285,axiom,
    ! [VarCurr: state_type] :
      ( v38840(VarCurr)
    <=> v38842(VarCurr) ) ).

tff(writeUnaryOperator_2302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38842(VarCurr)
    <=> v38852(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3740,axiom,
    ! [VarCurr: state_type] :
      ( v38852(VarCurr)
    <=> ( v38844(VarCurr)
        | v38848(VarCurr) ) ) ).

tff(addAssignment_19284,axiom,
    ! [VarCurr: state_type] :
      ( v38848(VarCurr)
    <=> v38850(VarCurr) ) ).

tff(addAssignment_19283,axiom,
    ! [VarCurr: state_type] :
      ( v38850(VarCurr)
    <=> v38765(VarCurr,1) ) ).

tff(addAssignment_19282,axiom,
    ! [VarCurr: state_type] :
      ( v38844(VarCurr)
    <=> v38846(VarCurr) ) ).

tff(addAssignment_19281,axiom,
    ! [VarCurr: state_type] :
      ( v38846(VarCurr)
    <=> v38765(VarCurr,0) ) ).

tff(addAssignment_19280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38818(VarCurr,B)
      <=> v38820(VarCurr,B) ) ) ).

tff(addAssignment_19279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38820(VarCurr,B)
      <=> v38822(VarCurr,B) ) ) ).

tff(addAssignment_19278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38822(VarCurr,B)
      <=> v38824(VarCurr,B) ) ) ).

tff(addAssignment_19277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38824(VarCurr,B)
      <=> v38826(VarCurr,B) ) ) ).

tff(addAssignment_19276,axiom,
    ! [VarCurr: state_type] :
      ( v38792(VarCurr)
    <=> v38794(VarCurr) ) ).

tff(addAssignment_19275,axiom,
    ! [VarCurr: state_type] :
      ( v38794(VarCurr)
    <=> v38796(VarCurr) ) ).

tff(addAssignment_19274,axiom,
    ! [VarCurr: state_type] :
      ( v38796(VarCurr)
    <=> v38798(VarCurr) ) ).

tff(addAssignment_19273,axiom,
    ! [VarCurr: state_type] :
      ( v38798(VarCurr)
    <=> v38800(VarCurr) ) ).

tff(addAssignment_19272,axiom,
    ! [VarCurr: state_type] :
      ( v38800(VarCurr)
    <=> v38802(VarCurr) ) ).

tff(addAssignment_19271,axiom,
    ! [VarCurr: state_type] :
      ( v38802(VarCurr)
    <=> v38804(VarCurr) ) ).

tff(addAssignment_19270,axiom,
    ! [VarCurr: state_type] :
      ( v38804(VarCurr)
    <=> v38806(VarCurr) ) ).

tff(writeUnaryOperator_2301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38806(VarCurr)
    <=> v38816(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3739,axiom,
    ! [VarCurr: state_type] :
      ( v38816(VarCurr)
    <=> ( v38808(VarCurr)
        | v38812(VarCurr) ) ) ).

tff(addAssignment_19269,axiom,
    ! [VarCurr: state_type] :
      ( v38812(VarCurr)
    <=> v38814(VarCurr) ) ).

tff(addAssignment_19268,axiom,
    ! [VarCurr: state_type] :
      ( v38814(VarCurr)
    <=> v38765(VarCurr,1) ) ).

tff(addAssignment_19267,axiom,
    ! [VarCurr: state_type] :
      ( v38765(VarCurr,1)
    <=> v38767(VarCurr,1) ) ).

tff(addAssignment_19266,axiom,
    ! [VarCurr: state_type] :
      ( v38767(VarCurr,1)
    <=> v38769(VarCurr,1) ) ).

tff(addAssignment_19265,axiom,
    ! [VarCurr: state_type] :
      ( v38769(VarCurr,1)
    <=> v38774(VarCurr,1) ) ).

tff(addAssignment_19264,axiom,
    ! [VarCurr: state_type] :
      ( v38771(VarCurr,1)
    <=> v38773(VarCurr,1) ) ).

tff(addAssignment_19263,axiom,
    ! [VarCurr: state_type] :
      ( v38773(VarCurr,1)
    <=> v38717(VarCurr,1) ) ).

tff(addAssignment_19262,axiom,
    ! [VarCurr: state_type] :
      ( v38808(VarCurr)
    <=> v38810(VarCurr) ) ).

tff(addAssignment_19261,axiom,
    ! [VarCurr: state_type] :
      ( v38810(VarCurr)
    <=> v38717(VarCurr,0) ) ).

tff(addAssignment_19260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38782(VarCurr,B)
      <=> v38784(VarCurr,B) ) ) ).

tff(addAssignment_19259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38784(VarCurr,B)
      <=> v38786(VarCurr,B) ) ) ).

tff(addAssignment_19258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38786(VarCurr,B)
      <=> v38788(VarCurr,B) ) ) ).

tff(addAssignment_19257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38788(VarCurr,B)
      <=> v38790(VarCurr,B) ) ) ).

tff(addAssignment_19256,axiom,
    ! [VarCurr: state_type] :
      ( v38745(VarCurr)
    <=> v38747(VarCurr) ) ).

tff(addAssignment_19255,axiom,
    ! [VarCurr: state_type] :
      ( v38747(VarCurr)
    <=> v38749(VarCurr) ) ).

tff(addAssignment_19254,axiom,
    ! [VarCurr: state_type] :
      ( v38749(VarCurr)
    <=> v38751(VarCurr) ) ).

tff(addAssignment_19253,axiom,
    ! [VarCurr: state_type] :
      ( v38751(VarCurr)
    <=> v38753(VarCurr) ) ).

tff(addAssignment_19252,axiom,
    ! [VarCurr: state_type] :
      ( v38753(VarCurr)
    <=> v38755(VarCurr) ) ).

tff(addAssignment_19251,axiom,
    ! [VarCurr: state_type] :
      ( v38755(VarCurr)
    <=> v38757(VarCurr) ) ).

tff(addAssignment_19250,axiom,
    ! [VarCurr: state_type] :
      ( v38757(VarCurr)
    <=> v38759(VarCurr) ) ).

tff(writeUnaryOperator_2300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38759(VarCurr)
    <=> v38780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3738,axiom,
    ! [VarCurr: state_type] :
      ( v38780(VarCurr)
    <=> ( v38761(VarCurr)
        | v38776(VarCurr) ) ) ).

tff(addAssignment_19249,axiom,
    ! [VarCurr: state_type] :
      ( v38776(VarCurr)
    <=> v38778(VarCurr) ) ).

tff(addAssignment_19248,axiom,
    ! [VarCurr: state_type] :
      ( v38778(VarCurr)
    <=> v38717(VarCurr,1) ) ).

tff(addAssignment_19247,axiom,
    ! [VarCurr: state_type] :
      ( v38761(VarCurr)
    <=> v38763(VarCurr) ) ).

tff(addAssignment_19246,axiom,
    ! [VarCurr: state_type] :
      ( v38763(VarCurr)
    <=> v38765(VarCurr,0) ) ).

tff(addAssignment_19245,axiom,
    ! [VarCurr: state_type] :
      ( v38765(VarCurr,0)
    <=> v38767(VarCurr,0) ) ).

tff(addAssignment_19244,axiom,
    ! [VarCurr: state_type] :
      ( v38767(VarCurr,0)
    <=> v38769(VarCurr,0) ) ).

tff(addAssignment_19243,axiom,
    ! [VarCurr: state_type] :
      ( v38769(VarCurr,0)
    <=> v38774(VarCurr,0) ) ).

tff(writeUnaryOperator_2299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v38774(VarCurr,B)
      <=> ~ v38771(VarCurr,B) ) ) ).

tff(addAssignment_19242,axiom,
    ! [VarCurr: state_type] :
      ( v38771(VarCurr,0)
    <=> v38773(VarCurr,0) ) ).

tff(addAssignment_19241,axiom,
    ! [VarCurr: state_type] :
      ( v38773(VarCurr,0)
    <=> v38717(VarCurr,0) ) ).

tff(addAssignment_19240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38735(VarCurr,B)
      <=> v38737(VarCurr,B) ) ) ).

tff(addAssignment_19239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38737(VarCurr,B)
      <=> v38739(VarCurr,B) ) ) ).

tff(addAssignment_19238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38739(VarCurr,B)
      <=> v38741(VarCurr,B) ) ) ).

tff(addAssignment_19237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38741(VarCurr,B)
      <=> v38743(VarCurr,B) ) ) ).

tff(addAssignment_19236,axiom,
    ! [VarCurr: state_type] :
      ( v38697(VarCurr)
    <=> v38699(VarCurr) ) ).

tff(addAssignment_19235,axiom,
    ! [VarCurr: state_type] :
      ( v38699(VarCurr)
    <=> v38701(VarCurr) ) ).

tff(addAssignment_19234,axiom,
    ! [VarCurr: state_type] :
      ( v38701(VarCurr)
    <=> v38703(VarCurr) ) ).

tff(addAssignment_19233,axiom,
    ! [VarCurr: state_type] :
      ( v38703(VarCurr)
    <=> v38705(VarCurr) ) ).

tff(addAssignment_19232,axiom,
    ! [VarCurr: state_type] :
      ( v38705(VarCurr)
    <=> v38707(VarCurr) ) ).

tff(addAssignment_19231,axiom,
    ! [VarCurr: state_type] :
      ( v38707(VarCurr)
    <=> v38709(VarCurr) ) ).

tff(addAssignment_19230,axiom,
    ! [VarCurr: state_type] :
      ( v38709(VarCurr)
    <=> v38711(VarCurr) ) ).

tff(writeUnaryOperator_2298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38711(VarCurr)
    <=> v38733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3737,axiom,
    ! [VarCurr: state_type] :
      ( v38733(VarCurr)
    <=> ( v38713(VarCurr)
        | v38729(VarCurr) ) ) ).

tff(addAssignment_19229,axiom,
    ! [VarCurr: state_type] :
      ( v38729(VarCurr)
    <=> v38731(VarCurr) ) ).

tff(addAssignment_19228,axiom,
    ! [VarCurr: state_type] :
      ( v38731(VarCurr)
    <=> v38717(VarCurr,1) ) ).

tff(addAssignment_19227,axiom,
    ! [VarCurr: state_type] :
      ( v38717(VarCurr,1)
    <=> v38719(VarCurr,1) ) ).

tff(addAssignment_19226,axiom,
    ! [VarCurr: state_type] :
      ( v38719(VarCurr,1)
    <=> v38721(VarCurr,1) ) ).

tff(addAssignment_19225,axiom,
    ! [VarCurr: state_type] :
      ( v38721(VarCurr,1)
    <=> v38723(VarCurr,1) ) ).

tff(addAssignment_19224,axiom,
    ! [VarCurr: state_type] :
      ( v38723(VarCurr,1)
    <=> v38725(VarCurr,1) ) ).

tff(addAssignment_19223,axiom,
    ! [VarCurr: state_type] :
      ( v38725(VarCurr,1)
    <=> v38727(VarCurr,1) ) ).

tff(addAssignment_19222,axiom,
    ! [VarCurr: state_type] :
      ( v38713(VarCurr)
    <=> v38715(VarCurr) ) ).

tff(addAssignment_19221,axiom,
    ! [VarCurr: state_type] :
      ( v38715(VarCurr)
    <=> v38717(VarCurr,0) ) ).

tff(addAssignment_19220,axiom,
    ! [VarCurr: state_type] :
      ( v38717(VarCurr,0)
    <=> v38719(VarCurr,0) ) ).

tff(addAssignment_19219,axiom,
    ! [VarCurr: state_type] :
      ( v38719(VarCurr,0)
    <=> v38721(VarCurr,0) ) ).

tff(addAssignment_19218,axiom,
    ! [VarCurr: state_type] :
      ( v38721(VarCurr,0)
    <=> v38723(VarCurr,0) ) ).

tff(addAssignment_19217,axiom,
    ! [VarCurr: state_type] :
      ( v38723(VarCurr,0)
    <=> v38725(VarCurr,0) ) ).

tff(addAssignment_19216,axiom,
    ! [VarCurr: state_type] :
      ( v38725(VarCurr,0)
    <=> v38727(VarCurr,0) ) ).

tff(addAssignment_19215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38687(VarCurr,B)
      <=> v38689(VarCurr,B) ) ) ).

tff(addAssignment_19214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38689(VarCurr,B)
      <=> v38691(VarCurr,B) ) ) ).

tff(addAssignment_19213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38691(VarCurr,B)
      <=> v38693(VarCurr,B) ) ) ).

tff(addAssignment_19212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38693(VarCurr,B)
      <=> v38695(VarCurr,B) ) ) ).

tff(addAssignment_19211,axiom,
    ! [VarCurr: state_type] :
      ( v38667(VarCurr)
    <=> v38669(VarCurr) ) ).

tff(addAssignment_19210,axiom,
    ! [VarCurr: state_type] :
      ( v38669(VarCurr)
    <=> v38671(VarCurr) ) ).

tff(addAssignment_19209,axiom,
    ! [VarCurr: state_type] :
      ( v38671(VarCurr)
    <=> v38673(VarCurr) ) ).

tff(addAssignment_19208,axiom,
    ! [VarCurr: state_type] :
      ( v38673(VarCurr)
    <=> v38675(VarCurr) ) ).

tff(addAssignment_19207,axiom,
    ! [VarCurr: state_type] :
      ( v38675(VarCurr)
    <=> v38677(VarCurr) ) ).

tff(addAssignment_19206,axiom,
    ! [VarCurr: state_type] :
      ( v38677(VarCurr)
    <=> v38679(VarCurr) ) ).

tff(addAssignment_19205,axiom,
    ! [VarCurr: state_type] :
      ( v38679(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_19204,axiom,
    ! [VarCurr: state_type] :
      ( v38653(VarCurr)
    <=> v38655(VarCurr) ) ).

tff(addAssignment_19203,axiom,
    ! [VarCurr: state_type] :
      ( v38655(VarCurr)
    <=> v38657(VarCurr) ) ).

tff(addAssignment_19202,axiom,
    ! [VarCurr: state_type] :
      ( v38657(VarCurr)
    <=> v38659(VarCurr) ) ).

tff(addAssignment_19201,axiom,
    ! [VarCurr: state_type] :
      ( v38659(VarCurr)
    <=> v38661(VarCurr) ) ).

tff(addAssignment_19200,axiom,
    ! [VarCurr: state_type] :
      ( v38661(VarCurr)
    <=> v38663(VarCurr) ) ).

tff(addAssignment_19199,axiom,
    ! [VarCurr: state_type] :
      ( v38663(VarCurr)
    <=> v38665(VarCurr) ) ).

tff(addAssignment_19198,axiom,
    ! [VarCurr: state_type] :
      ( v38665(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_19197,axiom,
    ! [VarCurr: state_type] :
      ( v38639(VarCurr)
    <=> v38641(VarCurr) ) ).

tff(addAssignment_19196,axiom,
    ! [VarCurr: state_type] :
      ( v38641(VarCurr)
    <=> v6617(VarCurr,5) ) ).

tff(addAssignment_19195,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,5)
    <=> v6619(VarCurr,5) ) ).

tff(addAssignment_19194,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,5)
    <=> v6621(VarCurr,5) ) ).

tff(addAssignment_19193,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,5)
    <=> v6747(VarCurr,5) ) ).

tff(addAssignment_19192,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,5)
    <=> v6690(VarCurr,5) ) ).

tff(addAssignment_19191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38635(VarCurr,B)
      <=> v38637(VarCurr,B) ) ) ).

tff(addAssignment_19190,axiom,
    ! [VarCurr: state_type] :
      ( ( v38637(VarCurr,11)
      <=> v6334(VarCurr,71) )
      & ( v38637(VarCurr,10)
      <=> v6334(VarCurr,70) )
      & ( v38637(VarCurr,9)
      <=> v6334(VarCurr,69) )
      & ( v38637(VarCurr,8)
      <=> v6334(VarCurr,68) )
      & ( v38637(VarCurr,7)
      <=> v6334(VarCurr,67) )
      & ( v38637(VarCurr,6)
      <=> v6334(VarCurr,66) )
      & ( v38637(VarCurr,5)
      <=> v6334(VarCurr,65) )
      & ( v38637(VarCurr,4)
      <=> v6334(VarCurr,64) )
      & ( v38637(VarCurr,3)
      <=> v6334(VarCurr,63) )
      & ( v38637(VarCurr,2)
      <=> v6334(VarCurr,62) )
      & ( v38637(VarCurr,1)
      <=> v6334(VarCurr,61) )
      & ( v38637(VarCurr,0)
      <=> v6334(VarCurr,60) ) ) ).

tff(addAssignment_19189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38603(VarCurr,B)
      <=> v38605(VarCurr,B) ) ) ).

tff(addAssignment_19188,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,0)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19187,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,1)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19186,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,2)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19185,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,3)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19184,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,4)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19183,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,5)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19182,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,6)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19181,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,7)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19180,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,8)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19179,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,9)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19178,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,10)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19177,axiom,
    ! [VarCurr: state_type] :
      ( v38605(VarCurr,11)
    <=> v38623(VarCurr) ) ).

tff(addAssignment_19176,axiom,
    ! [VarCurr: state_type] :
      ( v38623(VarCurr)
    <=> v38607(VarCurr) ) ).

tff(addAssignment_19175,axiom,
    ! [VarCurr: state_type] :
      ( v38607(VarCurr)
    <=> v38609(VarCurr,0) ) ).

tff(addAssignment_19174,axiom,
    ! [VarCurr: state_type] :
      ( v38609(VarCurr,0)
    <=> v38611(VarCurr,0) ) ).

tff(addAssignment_19173,axiom,
    ! [VarCurr: state_type] :
      ( v38611(VarCurr,0)
    <=> v38621(VarCurr,0) ) ).

tff(writeUnaryOperator_2297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v38621(VarCurr,B)
      <=> ~ v38613(VarCurr,B) ) ) ).

tff(addAssignment_19172,axiom,
    ! [VarCurr: state_type] :
      ( v38613(VarCurr,0)
    <=> v38615(VarCurr,0) ) ).

tff(addAssignment_19171,axiom,
    ! [VarCurr: state_type] :
      ( v38615(VarCurr,0)
    <=> v38618(VarCurr,0) ) ).

tff(addAssignment_19170,axiom,
    ! [VarCurr: state_type] :
      ( v38618(VarCurr,0)
    <=> v38617(VarCurr) ) ).

tff(addAssignment_19169,axiom,
    ! [VarCurr: state_type] :
      ( v38618(VarCurr,1)
    <=> v38620(VarCurr) ) ).

tff(addAssignment_19168,axiom,
    ! [VarCurr: state_type] :
      ( v38618(VarCurr,2)
    <=> v38619(VarCurr) ) ).

tff(addAssignment_19167,axiom,
    ! [VarCurr: state_type] :
      ( v38617(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_19166,axiom,
    ! [VarCurr: state_type] :
      ( v38579(VarCurr)
    <=> v38581(VarCurr) ) ).

tff(addAssignment_19165,axiom,
    ! [VarCurr: state_type] :
      ( v38581(VarCurr)
    <=> v38583(VarCurr) ) ).

tff(addAssignment_19164,axiom,
    ! [VarCurr: state_type] :
      ( v38583(VarCurr)
    <=> v38585(VarCurr) ) ).

tff(addAssignment_19163,axiom,
    ! [VarCurr: state_type] :
      ( v38585(VarCurr)
    <=> v38587(VarCurr) ) ).

tff(addAssignment_19162,axiom,
    ! [VarCurr: state_type] :
      ( v38587(VarCurr)
    <=> v38589(VarCurr) ) ).

tff(addAssignment_19161,axiom,
    ! [VarCurr: state_type] :
      ( v38589(VarCurr)
    <=> v38591(VarCurr) ) ).

tff(addAssignment_19160,axiom,
    ! [VarCurr: state_type] :
      ( v38591(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_19159,axiom,
    ! [VarCurr: state_type] :
      ( v38565(VarCurr)
    <=> v38567(VarCurr) ) ).

tff(addAssignment_19158,axiom,
    ! [VarCurr: state_type] :
      ( v38567(VarCurr)
    <=> v38569(VarCurr) ) ).

tff(addAssignment_19157,axiom,
    ! [VarCurr: state_type] :
      ( v38569(VarCurr)
    <=> v38571(VarCurr) ) ).

tff(addAssignment_19156,axiom,
    ! [VarCurr: state_type] :
      ( v38571(VarCurr)
    <=> v38573(VarCurr) ) ).

tff(addAssignment_19155,axiom,
    ! [VarCurr: state_type] :
      ( v38573(VarCurr)
    <=> v38575(VarCurr) ) ).

tff(addAssignment_19154,axiom,
    ! [VarCurr: state_type] :
      ( v38575(VarCurr)
    <=> v38577(VarCurr) ) ).

tff(addAssignment_19153,axiom,
    ! [VarCurr: state_type] :
      ( v38577(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_19152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38541(VarCurr,B)
      <=> v38543(VarCurr,B) ) ) ).

tff(addAssignment_19151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38543(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_19150,axiom,
    ! [VarCurr: state_type] :
      ( v36985(VarCurr)
    <=> v36987(VarCurr) ) ).

tff(addAssignment_19149,axiom,
    ! [VarCurr: state_type] :
      ( v36987(VarCurr)
    <=> v36989(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_207,axiom,
    ! [VarCurr: state_type] :
      ( v36989(VarCurr)
    <=> ( ( v36991(VarCurr,11)
        <=> v36995(VarCurr,11) )
        & ( v36991(VarCurr,10)
        <=> v36995(VarCurr,10) )
        & ( v36991(VarCurr,9)
        <=> v36995(VarCurr,9) )
        & ( v36991(VarCurr,8)
        <=> v36995(VarCurr,8) )
        & ( v36991(VarCurr,7)
        <=> v36995(VarCurr,7) )
        & ( v36991(VarCurr,6)
        <=> v36995(VarCurr,6) )
        & ( v36991(VarCurr,5)
        <=> v36995(VarCurr,5) )
        & ( v36991(VarCurr,4)
        <=> v36995(VarCurr,4) )
        & ( v36991(VarCurr,3)
        <=> v36995(VarCurr,3) )
        & ( v36991(VarCurr,2)
        <=> v36995(VarCurr,2) )
        & ( v36991(VarCurr,1)
        <=> v36995(VarCurr,1) )
        & ( v36991(VarCurr,0)
        <=> v36995(VarCurr,0) ) ) ) ).

tff(addAssignment_19148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36995(VarCurr,B)
      <=> v36997(VarCurr,B) ) ) ).

tff(addAssignment_19147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36997(VarCurr,B)
      <=> v36999(VarCurr,B) ) ) ).

tff(addAssignment_19146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36999(VarCurr,B)
      <=> v37001(VarCurr,B) ) ) ).

tff(addAssignment_19145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37001(VarCurr,B)
      <=> v37003(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37003(VarCurr,B)
      <=> ( v38511(VarCurr,B)
          | v38530(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38530(VarCurr,B)
      <=> ( v38382(VarCurr,B)
          & v38531(VarCurr,B) ) ) ) ).

tff(addAssignment_19144,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,0)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19143,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,1)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19142,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,2)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19141,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,3)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19140,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,4)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19139,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,5)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19138,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,6)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19137,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,7)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19136,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,8)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19135,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,9)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19134,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,10)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19133,axiom,
    ! [VarCurr: state_type] :
      ( v38531(VarCurr,11)
    <=> v38532(VarCurr) ) ).

tff(addAssignment_19132,axiom,
    ! [VarCurr: state_type] :
      ( v38532(VarCurr)
    <=> v38501(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38511(VarCurr,B)
      <=> ( v38512(VarCurr,B)
          | v38527(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38527(VarCurr,B)
      <=> ( v38231(VarCurr,B)
          & v38528(VarCurr,B) ) ) ) ).

tff(addAssignment_19131,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,0)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19130,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,1)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19129,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,2)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19128,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,3)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19127,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,4)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19126,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,5)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19125,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,6)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19124,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,7)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19123,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,8)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19122,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,9)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19121,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,10)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19120,axiom,
    ! [VarCurr: state_type] :
      ( v38528(VarCurr,11)
    <=> v38529(VarCurr) ) ).

tff(addAssignment_19119,axiom,
    ! [VarCurr: state_type] :
      ( v38529(VarCurr)
    <=> v38351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38512(VarCurr,B)
      <=> ( v38513(VarCurr,B)
          | v38524(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38524(VarCurr,B)
      <=> ( v38080(VarCurr,B)
          & v38525(VarCurr,B) ) ) ) ).

tff(addAssignment_19118,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,0)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19117,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,1)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19116,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,2)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19115,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,3)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19114,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,4)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19113,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,5)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19112,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,6)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19111,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,7)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19110,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,8)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19109,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,9)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19108,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,10)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19107,axiom,
    ! [VarCurr: state_type] :
      ( v38525(VarCurr,11)
    <=> v38526(VarCurr) ) ).

tff(addAssignment_19106,axiom,
    ! [VarCurr: state_type] :
      ( v38526(VarCurr)
    <=> v38200(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38513(VarCurr,B)
      <=> ( v38514(VarCurr,B)
          | v38521(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38521(VarCurr,B)
      <=> ( v37929(VarCurr,B)
          & v38522(VarCurr,B) ) ) ) ).

tff(addAssignment_19105,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,0)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19104,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,1)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19103,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,2)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19102,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,3)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19101,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,4)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19100,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,5)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19099,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,6)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19098,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,7)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19097,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,8)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19096,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,9)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19095,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,10)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19094,axiom,
    ! [VarCurr: state_type] :
      ( v38522(VarCurr,11)
    <=> v38523(VarCurr) ) ).

tff(addAssignment_19093,axiom,
    ! [VarCurr: state_type] :
      ( v38523(VarCurr)
    <=> v38049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38514(VarCurr,B)
      <=> ( v38515(VarCurr,B)
          | v38518(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38518(VarCurr,B)
      <=> ( v37767(VarCurr,B)
          & v38519(VarCurr,B) ) ) ) ).

tff(addAssignment_19092,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,0)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19091,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,1)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19090,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,2)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19089,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,3)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19088,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,4)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19087,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,5)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19086,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,6)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19085,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,7)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19084,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,8)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19083,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,9)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19082,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,10)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19081,axiom,
    ! [VarCurr: state_type] :
      ( v38519(VarCurr,11)
    <=> v38520(VarCurr) ) ).

tff(addAssignment_19080,axiom,
    ! [VarCurr: state_type] :
      ( v38520(VarCurr)
    <=> v37898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38515(VarCurr,B)
      <=> ( v37005(VarCurr,B)
          & v38516(VarCurr,B) ) ) ) ).

tff(addAssignment_19079,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,0)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19078,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,1)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19077,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,2)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19076,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,3)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19075,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,4)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19074,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,5)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19073,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,6)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19072,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,7)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19071,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,8)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19070,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,9)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19069,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,10)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19068,axiom,
    ! [VarCurr: state_type] :
      ( v38516(VarCurr,11)
    <=> v38517(VarCurr) ) ).

tff(addAssignment_19067,axiom,
    ! [VarCurr: state_type] :
      ( v38517(VarCurr)
    <=> v37475(VarCurr) ) ).

tff(addAssignment_19066,axiom,
    ! [VarCurr: state_type] :
      ( v38501(VarCurr)
    <=> v38503(VarCurr) ) ).

tff(addAssignment_19065,axiom,
    ! [VarCurr: state_type] :
      ( v38503(VarCurr)
    <=> v38505(VarCurr) ) ).

tff(addAssignment_19064,axiom,
    ! [VarCurr: state_type] :
      ( v38505(VarCurr)
    <=> v38507(VarCurr) ) ).

tff(addAssignment_19063,axiom,
    ! [VarCurr: state_type] :
      ( v38507(VarCurr)
    <=> v38509(VarCurr) ) ).

tff(addAssignment_19062,axiom,
    ! [VarCurr: state_type] :
      ( v38509(VarCurr)
    <=> v37568(VarCurr) ) ).

tff(addAssignment_19061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38382(VarCurr,B)
      <=> v38384(VarCurr,B) ) ) ).

tff(addAssignment_19060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38384(VarCurr,B)
      <=> v38386(VarCurr,B) ) ) ).

tff(addAssignment_19059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38386(VarCurr,B)
      <=> v38388(VarCurr,B) ) ) ).

tff(addAssignment_19058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38388(VarCurr,B)
      <=> v38390(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38484(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v38390(VarNext,B)
            <=> v38390(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_456,axiom,
    ! [VarNext: state_type] :
      ( v38484(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38390(VarNext,B)
          <=> v38494(VarNext,B) ) ) ) ).

tff(addAssignment_19057,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38494(VarNext,B)
          <=> v38492(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38495(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38492(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_320,axiom,
    ! [VarCurr: state_type] :
      ( v38495(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38492(VarCurr,B)
          <=> v38412(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3736,axiom,
    ! [VarCurr: state_type] :
      ( v38495(VarCurr)
    <=> ( v38496(VarCurr)
        & v38497(VarCurr) ) ) ).

tff(writeUnaryOperator_2296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38497(VarCurr)
    <=> v38402(VarCurr) ) ).

tff(writeUnaryOperator_2295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38496(VarCurr)
    <=> v38392(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38484(VarNext)
      <=> v38485(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38485(VarNext)
      <=> ( v38486(VarNext)
          & v38416(VarNext) ) ) ) ).

tff(writeUnaryOperator_2294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38486(VarNext)
      <=> v38488(VarNext) ) ) ).

tff(addAssignment_19056,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38488(VarNext)
      <=> v38416(VarCurr) ) ) ).

tff(addAssignment_19055,axiom,
    ! [VarCurr: state_type] :
      ( v38416(VarCurr)
    <=> v38418(VarCurr) ) ).

tff(addAssignment_19054,axiom,
    ! [VarCurr: state_type] :
      ( v38418(VarCurr)
    <=> v38420(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3733,axiom,
    ! [VarCurr: state_type] :
      ( v38420(VarCurr)
    <=> ( v38481(VarCurr)
        | v38477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3732,axiom,
    ! [VarCurr: state_type] :
      ( v38481(VarCurr)
    <=> ( v38422(VarCurr)
        & v38426(VarCurr) ) ) ).

tff(addAssignment_19053,axiom,
    ! [VarCurr: state_type] :
      ( v38477(VarCurr)
    <=> v38479(VarCurr) ) ).

tff(addAssignment_19052,axiom,
    ! [VarCurr: state_type] :
      ( v38479(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38461(VarNext)
       => ( v38426(VarNext)
        <=> v38426(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_455,axiom,
    ! [VarNext: state_type] :
      ( v38461(VarNext)
     => ( v38426(VarNext)
      <=> v38471(VarNext) ) ) ).

tff(addAssignment_19051,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38471(VarNext)
      <=> v38469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3731,axiom,
    ! [VarCurr: state_type] :
      ( v38469(VarCurr)
    <=> ( v38472(VarCurr)
        & v38473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3730,axiom,
    ! [VarCurr: state_type] :
      ( v38473(VarCurr)
    <=> ( v38432(VarCurr)
        | v38456(VarCurr) ) ) ).

tff(writeUnaryOperator_2293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38472(VarCurr)
    <=> v38428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38461(VarNext)
      <=> v38462(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38462(VarNext)
      <=> ( v38464(VarNext)
          & v38466(VarNext) ) ) ) ).

tff(writeUnaryOperator_2292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38466(VarCurr)
    <=> v38422(VarCurr) ) ).

tff(addAssignment_19050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38464(VarNext)
      <=> v38422(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_157,axiom,
    ( v38426(constB0)
  <=> $true ) ).

tff(addAssignment_19049,axiom,
    ! [VarCurr: state_type] :
      ( v38456(VarCurr)
    <=> v38458(VarCurr) ) ).

tff(addAssignment_19048,axiom,
    ! [VarCurr: state_type] :
      ( v38458(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_19047,axiom,
    ! [VarCurr: state_type] :
      ( v38432(VarCurr)
    <=> v38434(VarCurr) ) ).

tff(addAssignment_19046,axiom,
    ! [VarCurr: state_type] :
      ( v38434(VarCurr)
    <=> v37742(VarCurr) ) ).

tff(addAssignment_19045,axiom,
    ! [VarCurr: state_type] :
      ( v37742(VarCurr)
    <=> v38437(VarCurr) ) ).

tff(addAssignment_19044,axiom,
    ! [VarCurr: state_type] :
      ( v38437(VarCurr)
    <=> v38439(VarCurr) ) ).

tff(writeUnaryOperator_2291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38439(VarCurr)
    <=> v38453(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3727,axiom,
    ! [VarCurr: state_type] :
      ( v38453(VarCurr)
    <=> ( v38454(VarCurr)
        | v38449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3726,axiom,
    ! [VarCurr: state_type] :
      ( v38454(VarCurr)
    <=> ( v38441(VarCurr)
        | v38445(VarCurr) ) ) ).

tff(addAssignment_19043,axiom,
    ! [VarCurr: state_type] :
      ( v38449(VarCurr)
    <=> v38451(VarCurr) ) ).

tff(addAssignment_19042,axiom,
    ! [VarCurr: state_type] :
      ( v38451(VarCurr)
    <=> v37831(VarCurr,2) ) ).

tff(addAssignment_19041,axiom,
    ! [VarCurr: state_type] :
      ( v38445(VarCurr)
    <=> v38447(VarCurr) ) ).

tff(addAssignment_19040,axiom,
    ! [VarCurr: state_type] :
      ( v38447(VarCurr)
    <=> v37405(VarCurr,1) ) ).

tff(addAssignment_19039,axiom,
    ! [VarCurr: state_type] :
      ( v38441(VarCurr)
    <=> v38443(VarCurr) ) ).

tff(addAssignment_19038,axiom,
    ! [VarCurr: state_type] :
      ( v38443(VarCurr)
    <=> v37831(VarCurr,0) ) ).

tff(addAssignment_19037,axiom,
    ! [VarCurr: state_type] :
      ( v38428(VarCurr)
    <=> v38430(VarCurr) ) ).

tff(addAssignment_19036,axiom,
    ! [VarCurr: state_type] :
      ( v38430(VarCurr)
    <=> $false ) ).

tff(addAssignment_19035,axiom,
    ! [VarCurr: state_type] :
      ( v38422(VarCurr)
    <=> v38424(VarCurr) ) ).

tff(addAssignment_19034,axiom,
    ! [VarCurr: state_type] :
      ( v38424(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_19033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38412(VarCurr,B)
      <=> v38414(VarCurr,B) ) ) ).

tff(addAssignment_19032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38414(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_19031,axiom,
    ! [VarCurr: state_type] :
      ( v38402(VarCurr)
    <=> v38404(VarCurr) ) ).

tff(addAssignment_19030,axiom,
    ! [VarCurr: state_type] :
      ( v38404(VarCurr)
    <=> v38406(VarCurr) ) ).

tff(addAssignment_19029,axiom,
    ! [VarCurr: state_type] :
      ( v38406(VarCurr)
    <=> v38408(VarCurr) ) ).

tff(addAssignment_19028,axiom,
    ! [VarCurr: state_type] :
      ( v38408(VarCurr)
    <=> v38410(VarCurr) ) ).

tff(addAssignment_19027,axiom,
    ! [VarCurr: state_type] :
      ( v38410(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_19026,axiom,
    ! [VarCurr: state_type] :
      ( v38392(VarCurr)
    <=> v38394(VarCurr) ) ).

tff(addAssignment_19025,axiom,
    ! [VarCurr: state_type] :
      ( v38394(VarCurr)
    <=> v38396(VarCurr) ) ).

tff(addAssignment_19024,axiom,
    ! [VarCurr: state_type] :
      ( v38396(VarCurr)
    <=> v38398(VarCurr) ) ).

tff(addAssignment_19023,axiom,
    ! [VarCurr: state_type] :
      ( v38398(VarCurr)
    <=> v38400(VarCurr) ) ).

tff(addAssignment_19022,axiom,
    ! [VarCurr: state_type] :
      ( v38400(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_19021,axiom,
    ! [VarCurr: state_type] :
      ( v38351(VarCurr)
    <=> v38353(VarCurr) ) ).

tff(addAssignment_19020,axiom,
    ! [VarCurr: state_type] :
      ( v38353(VarCurr)
    <=> v38355(VarCurr) ) ).

tff(addAssignment_19019,axiom,
    ! [VarCurr: state_type] :
      ( v38355(VarCurr)
    <=> v38357(VarCurr) ) ).

tff(addAssignment_19018,axiom,
    ! [VarCurr: state_type] :
      ( v38357(VarCurr)
    <=> v38359(VarCurr) ) ).

tff(addAssignment_19017,axiom,
    ! [VarCurr: state_type] :
      ( v38359(VarCurr)
    <=> v38361(VarCurr) ) ).

tff(addAssignment_19016,axiom,
    ! [VarCurr: state_type] :
      ( v38361(VarCurr)
    <=> v38363(VarCurr) ) ).

tff(addAssignment_19015,axiom,
    ! [VarCurr: state_type] :
      ( v38363(VarCurr)
    <=> v38365(VarCurr) ) ).

tff(writeUnaryOperator_2290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38365(VarCurr)
    <=> v38379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3725,axiom,
    ! [VarCurr: state_type] :
      ( v38379(VarCurr)
    <=> ( v38380(VarCurr)
        | v38375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3724,axiom,
    ! [VarCurr: state_type] :
      ( v38380(VarCurr)
    <=> ( v38367(VarCurr)
        | v38371(VarCurr) ) ) ).

tff(addAssignment_19014,axiom,
    ! [VarCurr: state_type] :
      ( v38375(VarCurr)
    <=> v38377(VarCurr) ) ).

tff(addAssignment_19013,axiom,
    ! [VarCurr: state_type] :
      ( v38377(VarCurr)
    <=> v37578(VarCurr,2) ) ).

tff(addAssignment_19012,axiom,
    ! [VarCurr: state_type] :
      ( v38371(VarCurr)
    <=> v38373(VarCurr) ) ).

tff(addAssignment_19011,axiom,
    ! [VarCurr: state_type] :
      ( v38373(VarCurr)
    <=> v37495(VarCurr,1) ) ).

tff(addAssignment_19010,axiom,
    ! [VarCurr: state_type] :
      ( v38367(VarCurr)
    <=> v38369(VarCurr) ) ).

tff(addAssignment_19009,axiom,
    ! [VarCurr: state_type] :
      ( v38369(VarCurr)
    <=> v37495(VarCurr,0) ) ).

tff(addAssignment_19008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38231(VarCurr,B)
      <=> v38233(VarCurr,B) ) ) ).

tff(addAssignment_19007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38233(VarCurr,B)
      <=> v38235(VarCurr,B) ) ) ).

tff(addAssignment_19006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38235(VarCurr,B)
      <=> v38237(VarCurr,B) ) ) ).

tff(addAssignment_19005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38237(VarCurr,B)
      <=> v38239(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38334(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v38239(VarNext,B)
            <=> v38239(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_454,axiom,
    ! [VarNext: state_type] :
      ( v38334(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38239(VarNext,B)
          <=> v38344(VarNext,B) ) ) ) ).

tff(addAssignment_19004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38344(VarNext,B)
          <=> v38342(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38342(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_319,axiom,
    ! [VarCurr: state_type] :
      ( v38345(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38342(VarCurr,B)
          <=> v38261(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3723,axiom,
    ! [VarCurr: state_type] :
      ( v38345(VarCurr)
    <=> ( v38346(VarCurr)
        & v38347(VarCurr) ) ) ).

tff(writeUnaryOperator_2289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38347(VarCurr)
    <=> v38251(VarCurr) ) ).

tff(writeUnaryOperator_2288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38346(VarCurr)
    <=> v38241(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38334(VarNext)
      <=> v38335(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38335(VarNext)
      <=> ( v38336(VarNext)
          & v38265(VarNext) ) ) ) ).

tff(writeUnaryOperator_2287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38336(VarNext)
      <=> v38338(VarNext) ) ) ).

tff(addAssignment_19003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38338(VarNext)
      <=> v38265(VarCurr) ) ) ).

tff(addAssignment_19002,axiom,
    ! [VarCurr: state_type] :
      ( v38265(VarCurr)
    <=> v38267(VarCurr) ) ).

tff(addAssignment_19001,axiom,
    ! [VarCurr: state_type] :
      ( v38267(VarCurr)
    <=> v38269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3720,axiom,
    ! [VarCurr: state_type] :
      ( v38269(VarCurr)
    <=> ( v38331(VarCurr)
        | v38327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3719,axiom,
    ! [VarCurr: state_type] :
      ( v38331(VarCurr)
    <=> ( v38271(VarCurr)
        & v38275(VarCurr) ) ) ).

tff(addAssignment_19000,axiom,
    ! [VarCurr: state_type] :
      ( v38327(VarCurr)
    <=> v38329(VarCurr) ) ).

tff(addAssignment_18999,axiom,
    ! [VarCurr: state_type] :
      ( v38329(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_453,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38311(VarNext)
       => ( v38275(VarNext)
        <=> v38275(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_453,axiom,
    ! [VarNext: state_type] :
      ( v38311(VarNext)
     => ( v38275(VarNext)
      <=> v38321(VarNext) ) ) ).

tff(addAssignment_18998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38321(VarNext)
      <=> v38319(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3718,axiom,
    ! [VarCurr: state_type] :
      ( v38319(VarCurr)
    <=> ( v38322(VarCurr)
        & v38323(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3717,axiom,
    ! [VarCurr: state_type] :
      ( v38323(VarCurr)
    <=> ( v38281(VarCurr)
        | v38306(VarCurr) ) ) ).

tff(writeUnaryOperator_2286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38322(VarCurr)
    <=> v38277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38311(VarNext)
      <=> v38312(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38312(VarNext)
      <=> ( v38314(VarNext)
          & v38316(VarNext) ) ) ) ).

tff(writeUnaryOperator_2285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38316(VarCurr)
    <=> v38271(VarCurr) ) ).

tff(addAssignment_18997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38314(VarNext)
      <=> v38271(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_156,axiom,
    ( v38275(constB0)
  <=> $true ) ).

tff(addAssignment_18996,axiom,
    ! [VarCurr: state_type] :
      ( v38306(VarCurr)
    <=> v38308(VarCurr) ) ).

tff(addAssignment_18995,axiom,
    ! [VarCurr: state_type] :
      ( v38308(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18994,axiom,
    ! [VarCurr: state_type] :
      ( v38281(VarCurr)
    <=> v38283(VarCurr) ) ).

tff(addAssignment_18993,axiom,
    ! [VarCurr: state_type] :
      ( v38283(VarCurr)
    <=> v38285(VarCurr) ) ).

tff(addAssignment_18992,axiom,
    ! [VarCurr: state_type] :
      ( v38285(VarCurr)
    <=> v38287(VarCurr) ) ).

tff(addAssignment_18991,axiom,
    ! [VarCurr: state_type] :
      ( v38287(VarCurr)
    <=> v38289(VarCurr) ) ).

tff(writeUnaryOperator_2284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38289(VarCurr)
    <=> v38303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3714,axiom,
    ! [VarCurr: state_type] :
      ( v38303(VarCurr)
    <=> ( v38304(VarCurr)
        | v38299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3713,axiom,
    ! [VarCurr: state_type] :
      ( v38304(VarCurr)
    <=> ( v38291(VarCurr)
        | v38295(VarCurr) ) ) ).

tff(addAssignment_18990,axiom,
    ! [VarCurr: state_type] :
      ( v38299(VarCurr)
    <=> v38301(VarCurr) ) ).

tff(addAssignment_18989,axiom,
    ! [VarCurr: state_type] :
      ( v38301(VarCurr)
    <=> v37831(VarCurr,2) ) ).

tff(addAssignment_18988,axiom,
    ! [VarCurr: state_type] :
      ( v37831(VarCurr,2)
    <=> v37833(VarCurr,2) ) ).

tff(addAssignment_18987,axiom,
    ! [VarCurr: state_type] :
      ( v37833(VarCurr,2)
    <=> v37835(VarCurr,2) ) ).

tff(addAssignment_18986,axiom,
    ! [VarCurr: state_type] :
      ( v37835(VarCurr,2)
    <=> v37840(VarCurr,2) ) ).

tff(addAssignment_18985,axiom,
    ! [VarCurr: state_type] :
      ( v37837(VarCurr,2)
    <=> v37839(VarCurr,2) ) ).

tff(addAssignment_18984,axiom,
    ! [VarCurr: state_type] :
      ( v37839(VarCurr,2)
    <=> v37405(VarCurr,2) ) ).

tff(addAssignment_18983,axiom,
    ! [VarCurr: state_type] :
      ( v38295(VarCurr)
    <=> v38297(VarCurr) ) ).

tff(addAssignment_18982,axiom,
    ! [VarCurr: state_type] :
      ( v38297(VarCurr)
    <=> v37405(VarCurr,1) ) ).

tff(addAssignment_18981,axiom,
    ! [VarCurr: state_type] :
      ( v38291(VarCurr)
    <=> v38293(VarCurr) ) ).

tff(addAssignment_18980,axiom,
    ! [VarCurr: state_type] :
      ( v38293(VarCurr)
    <=> v37405(VarCurr,0) ) ).

tff(addAssignment_18979,axiom,
    ! [VarCurr: state_type] :
      ( v38277(VarCurr)
    <=> v38279(VarCurr) ) ).

tff(addAssignment_18978,axiom,
    ! [VarCurr: state_type] :
      ( v38279(VarCurr)
    <=> $false ) ).

tff(addAssignment_18977,axiom,
    ! [VarCurr: state_type] :
      ( v38271(VarCurr)
    <=> v38273(VarCurr) ) ).

tff(addAssignment_18976,axiom,
    ! [VarCurr: state_type] :
      ( v38273(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38261(VarCurr,B)
      <=> v38263(VarCurr,B) ) ) ).

tff(addAssignment_18974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38263(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_18973,axiom,
    ! [VarCurr: state_type] :
      ( v38251(VarCurr)
    <=> v38253(VarCurr) ) ).

tff(addAssignment_18972,axiom,
    ! [VarCurr: state_type] :
      ( v38253(VarCurr)
    <=> v38255(VarCurr) ) ).

tff(addAssignment_18971,axiom,
    ! [VarCurr: state_type] :
      ( v38255(VarCurr)
    <=> v38257(VarCurr) ) ).

tff(addAssignment_18970,axiom,
    ! [VarCurr: state_type] :
      ( v38257(VarCurr)
    <=> v38259(VarCurr) ) ).

tff(addAssignment_18969,axiom,
    ! [VarCurr: state_type] :
      ( v38259(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18968,axiom,
    ! [VarCurr: state_type] :
      ( v38241(VarCurr)
    <=> v38243(VarCurr) ) ).

tff(addAssignment_18967,axiom,
    ! [VarCurr: state_type] :
      ( v38243(VarCurr)
    <=> v38245(VarCurr) ) ).

tff(addAssignment_18966,axiom,
    ! [VarCurr: state_type] :
      ( v38245(VarCurr)
    <=> v38247(VarCurr) ) ).

tff(addAssignment_18965,axiom,
    ! [VarCurr: state_type] :
      ( v38247(VarCurr)
    <=> v38249(VarCurr) ) ).

tff(addAssignment_18964,axiom,
    ! [VarCurr: state_type] :
      ( v38249(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_18963,axiom,
    ! [VarCurr: state_type] :
      ( v38200(VarCurr)
    <=> v38202(VarCurr) ) ).

tff(addAssignment_18962,axiom,
    ! [VarCurr: state_type] :
      ( v38202(VarCurr)
    <=> v38204(VarCurr) ) ).

tff(addAssignment_18961,axiom,
    ! [VarCurr: state_type] :
      ( v38204(VarCurr)
    <=> v38206(VarCurr) ) ).

tff(addAssignment_18960,axiom,
    ! [VarCurr: state_type] :
      ( v38206(VarCurr)
    <=> v38208(VarCurr) ) ).

tff(addAssignment_18959,axiom,
    ! [VarCurr: state_type] :
      ( v38208(VarCurr)
    <=> v38210(VarCurr) ) ).

tff(addAssignment_18958,axiom,
    ! [VarCurr: state_type] :
      ( v38210(VarCurr)
    <=> v38212(VarCurr) ) ).

tff(addAssignment_18957,axiom,
    ! [VarCurr: state_type] :
      ( v38212(VarCurr)
    <=> v38214(VarCurr) ) ).

tff(writeUnaryOperator_2283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38214(VarCurr)
    <=> v38228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3712,axiom,
    ! [VarCurr: state_type] :
      ( v38228(VarCurr)
    <=> ( v38229(VarCurr)
        | v38224(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3711,axiom,
    ! [VarCurr: state_type] :
      ( v38229(VarCurr)
    <=> ( v38216(VarCurr)
        | v38220(VarCurr) ) ) ).

tff(addAssignment_18956,axiom,
    ! [VarCurr: state_type] :
      ( v38224(VarCurr)
    <=> v38226(VarCurr) ) ).

tff(addAssignment_18955,axiom,
    ! [VarCurr: state_type] :
      ( v38226(VarCurr)
    <=> v37495(VarCurr,2) ) ).

tff(addAssignment_18954,axiom,
    ! [VarCurr: state_type] :
      ( v38220(VarCurr)
    <=> v38222(VarCurr) ) ).

tff(addAssignment_18953,axiom,
    ! [VarCurr: state_type] :
      ( v38222(VarCurr)
    <=> v37578(VarCurr,1) ) ).

tff(addAssignment_18952,axiom,
    ! [VarCurr: state_type] :
      ( v38216(VarCurr)
    <=> v38218(VarCurr) ) ).

tff(addAssignment_18951,axiom,
    ! [VarCurr: state_type] :
      ( v38218(VarCurr)
    <=> v37578(VarCurr,0) ) ).

tff(addAssignment_18950,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38080(VarCurr,B)
      <=> v38082(VarCurr,B) ) ) ).

tff(addAssignment_18949,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38082(VarCurr,B)
      <=> v38084(VarCurr,B) ) ) ).

tff(addAssignment_18948,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38084(VarCurr,B)
      <=> v38086(VarCurr,B) ) ) ).

tff(addAssignment_18947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38086(VarCurr,B)
      <=> v38088(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_452,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38183(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v38088(VarNext,B)
            <=> v38088(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_452,axiom,
    ! [VarNext: state_type] :
      ( v38183(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38088(VarNext,B)
          <=> v38193(VarNext,B) ) ) ) ).

tff(addAssignment_18946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38193(VarNext,B)
          <=> v38191(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38194(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38191(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_318,axiom,
    ! [VarCurr: state_type] :
      ( v38194(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38191(VarCurr,B)
          <=> v38110(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3710,axiom,
    ! [VarCurr: state_type] :
      ( v38194(VarCurr)
    <=> ( v38195(VarCurr)
        & v38196(VarCurr) ) ) ).

tff(writeUnaryOperator_2282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38196(VarCurr)
    <=> v38100(VarCurr) ) ).

tff(writeUnaryOperator_2281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38195(VarCurr)
    <=> v38090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38183(VarNext)
      <=> v38184(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38184(VarNext)
      <=> ( v38185(VarNext)
          & v38114(VarNext) ) ) ) ).

tff(writeUnaryOperator_2280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38185(VarNext)
      <=> v38187(VarNext) ) ) ).

tff(addAssignment_18945,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38187(VarNext)
      <=> v38114(VarCurr) ) ) ).

tff(addAssignment_18944,axiom,
    ! [VarCurr: state_type] :
      ( v38114(VarCurr)
    <=> v38116(VarCurr) ) ).

tff(addAssignment_18943,axiom,
    ! [VarCurr: state_type] :
      ( v38116(VarCurr)
    <=> v38118(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3707,axiom,
    ! [VarCurr: state_type] :
      ( v38118(VarCurr)
    <=> ( v38180(VarCurr)
        | v38176(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3706,axiom,
    ! [VarCurr: state_type] :
      ( v38180(VarCurr)
    <=> ( v38120(VarCurr)
        & v38124(VarCurr) ) ) ).

tff(addAssignment_18942,axiom,
    ! [VarCurr: state_type] :
      ( v38176(VarCurr)
    <=> v38178(VarCurr) ) ).

tff(addAssignment_18941,axiom,
    ! [VarCurr: state_type] :
      ( v38178(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_451,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38160(VarNext)
       => ( v38124(VarNext)
        <=> v38124(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_451,axiom,
    ! [VarNext: state_type] :
      ( v38160(VarNext)
     => ( v38124(VarNext)
      <=> v38170(VarNext) ) ) ).

tff(addAssignment_18940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38170(VarNext)
      <=> v38168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3705,axiom,
    ! [VarCurr: state_type] :
      ( v38168(VarCurr)
    <=> ( v38171(VarCurr)
        & v38172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3704,axiom,
    ! [VarCurr: state_type] :
      ( v38172(VarCurr)
    <=> ( v38130(VarCurr)
        | v38155(VarCurr) ) ) ).

tff(writeUnaryOperator_2279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38171(VarCurr)
    <=> v38126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38160(VarNext)
      <=> v38161(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38161(VarNext)
      <=> ( v38163(VarNext)
          & v38165(VarNext) ) ) ) ).

tff(writeUnaryOperator_2278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38165(VarCurr)
    <=> v38120(VarCurr) ) ).

tff(addAssignment_18939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38163(VarNext)
      <=> v38120(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_155,axiom,
    ( v38124(constB0)
  <=> $true ) ).

tff(addAssignment_18938,axiom,
    ! [VarCurr: state_type] :
      ( v38155(VarCurr)
    <=> v38157(VarCurr) ) ).

tff(addAssignment_18937,axiom,
    ! [VarCurr: state_type] :
      ( v38157(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18936,axiom,
    ! [VarCurr: state_type] :
      ( v38130(VarCurr)
    <=> v38132(VarCurr) ) ).

tff(addAssignment_18935,axiom,
    ! [VarCurr: state_type] :
      ( v38132(VarCurr)
    <=> v38134(VarCurr) ) ).

tff(addAssignment_18934,axiom,
    ! [VarCurr: state_type] :
      ( v38134(VarCurr)
    <=> v38136(VarCurr) ) ).

tff(addAssignment_18933,axiom,
    ! [VarCurr: state_type] :
      ( v38136(VarCurr)
    <=> v38138(VarCurr) ) ).

tff(writeUnaryOperator_2277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38138(VarCurr)
    <=> v38152(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3701,axiom,
    ! [VarCurr: state_type] :
      ( v38152(VarCurr)
    <=> ( v38153(VarCurr)
        | v38148(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3700,axiom,
    ! [VarCurr: state_type] :
      ( v38153(VarCurr)
    <=> ( v38140(VarCurr)
        | v38144(VarCurr) ) ) ).

tff(addAssignment_18932,axiom,
    ! [VarCurr: state_type] :
      ( v38148(VarCurr)
    <=> v38150(VarCurr) ) ).

tff(addAssignment_18931,axiom,
    ! [VarCurr: state_type] :
      ( v38150(VarCurr)
    <=> v37405(VarCurr,2) ) ).

tff(addAssignment_18930,axiom,
    ! [VarCurr: state_type] :
      ( v38144(VarCurr)
    <=> v38146(VarCurr) ) ).

tff(addAssignment_18929,axiom,
    ! [VarCurr: state_type] :
      ( v38146(VarCurr)
    <=> v37831(VarCurr,1) ) ).

tff(addAssignment_18928,axiom,
    ! [VarCurr: state_type] :
      ( v38140(VarCurr)
    <=> v38142(VarCurr) ) ).

tff(addAssignment_18927,axiom,
    ! [VarCurr: state_type] :
      ( v38142(VarCurr)
    <=> v37831(VarCurr,0) ) ).

tff(addAssignment_18926,axiom,
    ! [VarCurr: state_type] :
      ( v38126(VarCurr)
    <=> v38128(VarCurr) ) ).

tff(addAssignment_18925,axiom,
    ! [VarCurr: state_type] :
      ( v38128(VarCurr)
    <=> $false ) ).

tff(addAssignment_18924,axiom,
    ! [VarCurr: state_type] :
      ( v38120(VarCurr)
    <=> v38122(VarCurr) ) ).

tff(addAssignment_18923,axiom,
    ! [VarCurr: state_type] :
      ( v38122(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38110(VarCurr,B)
      <=> v38112(VarCurr,B) ) ) ).

tff(addAssignment_18921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v38112(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_18920,axiom,
    ! [VarCurr: state_type] :
      ( v38100(VarCurr)
    <=> v38102(VarCurr) ) ).

tff(addAssignment_18919,axiom,
    ! [VarCurr: state_type] :
      ( v38102(VarCurr)
    <=> v38104(VarCurr) ) ).

tff(addAssignment_18918,axiom,
    ! [VarCurr: state_type] :
      ( v38104(VarCurr)
    <=> v38106(VarCurr) ) ).

tff(addAssignment_18917,axiom,
    ! [VarCurr: state_type] :
      ( v38106(VarCurr)
    <=> v38108(VarCurr) ) ).

tff(addAssignment_18916,axiom,
    ! [VarCurr: state_type] :
      ( v38108(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18915,axiom,
    ! [VarCurr: state_type] :
      ( v38090(VarCurr)
    <=> v38092(VarCurr) ) ).

tff(addAssignment_18914,axiom,
    ! [VarCurr: state_type] :
      ( v38092(VarCurr)
    <=> v38094(VarCurr) ) ).

tff(addAssignment_18913,axiom,
    ! [VarCurr: state_type] :
      ( v38094(VarCurr)
    <=> v38096(VarCurr) ) ).

tff(addAssignment_18912,axiom,
    ! [VarCurr: state_type] :
      ( v38096(VarCurr)
    <=> v38098(VarCurr) ) ).

tff(addAssignment_18911,axiom,
    ! [VarCurr: state_type] :
      ( v38098(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_18910,axiom,
    ! [VarCurr: state_type] :
      ( v38049(VarCurr)
    <=> v38051(VarCurr) ) ).

tff(addAssignment_18909,axiom,
    ! [VarCurr: state_type] :
      ( v38051(VarCurr)
    <=> v38053(VarCurr) ) ).

tff(addAssignment_18908,axiom,
    ! [VarCurr: state_type] :
      ( v38053(VarCurr)
    <=> v38055(VarCurr) ) ).

tff(addAssignment_18907,axiom,
    ! [VarCurr: state_type] :
      ( v38055(VarCurr)
    <=> v38057(VarCurr) ) ).

tff(addAssignment_18906,axiom,
    ! [VarCurr: state_type] :
      ( v38057(VarCurr)
    <=> v38059(VarCurr) ) ).

tff(addAssignment_18905,axiom,
    ! [VarCurr: state_type] :
      ( v38059(VarCurr)
    <=> v38061(VarCurr) ) ).

tff(addAssignment_18904,axiom,
    ! [VarCurr: state_type] :
      ( v38061(VarCurr)
    <=> v38063(VarCurr) ) ).

tff(writeUnaryOperator_2276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38063(VarCurr)
    <=> v38077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3699,axiom,
    ! [VarCurr: state_type] :
      ( v38077(VarCurr)
    <=> ( v38078(VarCurr)
        | v38073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3698,axiom,
    ! [VarCurr: state_type] :
      ( v38078(VarCurr)
    <=> ( v38065(VarCurr)
        | v38069(VarCurr) ) ) ).

tff(addAssignment_18903,axiom,
    ! [VarCurr: state_type] :
      ( v38073(VarCurr)
    <=> v38075(VarCurr) ) ).

tff(addAssignment_18902,axiom,
    ! [VarCurr: state_type] :
      ( v38075(VarCurr)
    <=> v37495(VarCurr,2) ) ).

tff(addAssignment_18901,axiom,
    ! [VarCurr: state_type] :
      ( v38069(VarCurr)
    <=> v38071(VarCurr) ) ).

tff(addAssignment_18900,axiom,
    ! [VarCurr: state_type] :
      ( v38071(VarCurr)
    <=> v37578(VarCurr,1) ) ).

tff(addAssignment_18899,axiom,
    ! [VarCurr: state_type] :
      ( v37578(VarCurr,1)
    <=> v37580(VarCurr,1) ) ).

tff(addAssignment_18898,axiom,
    ! [VarCurr: state_type] :
      ( v37580(VarCurr,1)
    <=> v37582(VarCurr,1) ) ).

tff(addAssignment_18897,axiom,
    ! [VarCurr: state_type] :
      ( v37582(VarCurr,1)
    <=> v37587(VarCurr,1) ) ).

tff(addAssignment_18896,axiom,
    ! [VarCurr: state_type] :
      ( v37584(VarCurr,1)
    <=> v37586(VarCurr,1) ) ).

tff(addAssignment_18895,axiom,
    ! [VarCurr: state_type] :
      ( v37586(VarCurr,1)
    <=> v37495(VarCurr,1) ) ).

tff(addAssignment_18894,axiom,
    ! [VarCurr: state_type] :
      ( v38065(VarCurr)
    <=> v38067(VarCurr) ) ).

tff(addAssignment_18893,axiom,
    ! [VarCurr: state_type] :
      ( v38067(VarCurr)
    <=> v37495(VarCurr,0) ) ).

tff(addAssignment_18892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37929(VarCurr,B)
      <=> v37931(VarCurr,B) ) ) ).

tff(addAssignment_18891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37931(VarCurr,B)
      <=> v37933(VarCurr,B) ) ) ).

tff(addAssignment_18890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37933(VarCurr,B)
      <=> v37935(VarCurr,B) ) ) ).

tff(addAssignment_18889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37935(VarCurr,B)
      <=> v37937(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38032(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v37937(VarNext,B)
            <=> v37937(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_450,axiom,
    ! [VarNext: state_type] :
      ( v38032(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37937(VarNext,B)
          <=> v38042(VarNext,B) ) ) ) ).

tff(addAssignment_18888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38042(VarNext,B)
          <=> v38040(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38043(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38040(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_317,axiom,
    ! [VarCurr: state_type] :
      ( v38043(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v38040(VarCurr,B)
          <=> v37959(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3697,axiom,
    ! [VarCurr: state_type] :
      ( v38043(VarCurr)
    <=> ( v38044(VarCurr)
        & v38045(VarCurr) ) ) ).

tff(writeUnaryOperator_2275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38045(VarCurr)
    <=> v37949(VarCurr) ) ).

tff(writeUnaryOperator_2274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38044(VarCurr)
    <=> v37939(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38032(VarNext)
      <=> v38033(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38033(VarNext)
      <=> ( v38034(VarNext)
          & v37963(VarNext) ) ) ) ).

tff(writeUnaryOperator_2273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38034(VarNext)
      <=> v38036(VarNext) ) ) ).

tff(addAssignment_18887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38036(VarNext)
      <=> v37963(VarCurr) ) ) ).

tff(addAssignment_18886,axiom,
    ! [VarCurr: state_type] :
      ( v37963(VarCurr)
    <=> v37965(VarCurr) ) ).

tff(addAssignment_18885,axiom,
    ! [VarCurr: state_type] :
      ( v37965(VarCurr)
    <=> v37967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3694,axiom,
    ! [VarCurr: state_type] :
      ( v37967(VarCurr)
    <=> ( v38029(VarCurr)
        | v38025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3693,axiom,
    ! [VarCurr: state_type] :
      ( v38029(VarCurr)
    <=> ( v37969(VarCurr)
        & v37973(VarCurr) ) ) ).

tff(addAssignment_18884,axiom,
    ! [VarCurr: state_type] :
      ( v38025(VarCurr)
    <=> v38027(VarCurr) ) ).

tff(addAssignment_18883,axiom,
    ! [VarCurr: state_type] :
      ( v38027(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v38009(VarNext)
       => ( v37973(VarNext)
        <=> v37973(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_449,axiom,
    ! [VarNext: state_type] :
      ( v38009(VarNext)
     => ( v37973(VarNext)
      <=> v38019(VarNext) ) ) ).

tff(addAssignment_18882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38019(VarNext)
      <=> v38017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3692,axiom,
    ! [VarCurr: state_type] :
      ( v38017(VarCurr)
    <=> ( v38020(VarCurr)
        & v38021(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3691,axiom,
    ! [VarCurr: state_type] :
      ( v38021(VarCurr)
    <=> ( v37979(VarCurr)
        | v38004(VarCurr) ) ) ).

tff(writeUnaryOperator_2272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38020(VarCurr)
    <=> v37975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38009(VarNext)
      <=> v38010(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38010(VarNext)
      <=> ( v38012(VarNext)
          & v38014(VarNext) ) ) ) ).

tff(writeUnaryOperator_2271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v38014(VarCurr)
    <=> v37969(VarCurr) ) ).

tff(addAssignment_18881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v38012(VarNext)
      <=> v37969(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_154,axiom,
    ( v37973(constB0)
  <=> $true ) ).

tff(addAssignment_18880,axiom,
    ! [VarCurr: state_type] :
      ( v38004(VarCurr)
    <=> v38006(VarCurr) ) ).

tff(addAssignment_18879,axiom,
    ! [VarCurr: state_type] :
      ( v38006(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18878,axiom,
    ! [VarCurr: state_type] :
      ( v37979(VarCurr)
    <=> v37981(VarCurr) ) ).

tff(addAssignment_18877,axiom,
    ! [VarCurr: state_type] :
      ( v37981(VarCurr)
    <=> v37983(VarCurr) ) ).

tff(addAssignment_18876,axiom,
    ! [VarCurr: state_type] :
      ( v37983(VarCurr)
    <=> v37985(VarCurr) ) ).

tff(addAssignment_18875,axiom,
    ! [VarCurr: state_type] :
      ( v37985(VarCurr)
    <=> v37987(VarCurr) ) ).

tff(writeUnaryOperator_2270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37987(VarCurr)
    <=> v38001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3688,axiom,
    ! [VarCurr: state_type] :
      ( v38001(VarCurr)
    <=> ( v38002(VarCurr)
        | v37997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3687,axiom,
    ! [VarCurr: state_type] :
      ( v38002(VarCurr)
    <=> ( v37989(VarCurr)
        | v37993(VarCurr) ) ) ).

tff(addAssignment_18874,axiom,
    ! [VarCurr: state_type] :
      ( v37997(VarCurr)
    <=> v37999(VarCurr) ) ).

tff(addAssignment_18873,axiom,
    ! [VarCurr: state_type] :
      ( v37999(VarCurr)
    <=> v37405(VarCurr,2) ) ).

tff(addAssignment_18872,axiom,
    ! [VarCurr: state_type] :
      ( v37993(VarCurr)
    <=> v37995(VarCurr) ) ).

tff(addAssignment_18871,axiom,
    ! [VarCurr: state_type] :
      ( v37995(VarCurr)
    <=> v37831(VarCurr,1) ) ).

tff(addAssignment_18870,axiom,
    ! [VarCurr: state_type] :
      ( v37831(VarCurr,1)
    <=> v37833(VarCurr,1) ) ).

tff(addAssignment_18869,axiom,
    ! [VarCurr: state_type] :
      ( v37833(VarCurr,1)
    <=> v37835(VarCurr,1) ) ).

tff(addAssignment_18868,axiom,
    ! [VarCurr: state_type] :
      ( v37835(VarCurr,1)
    <=> v37840(VarCurr,1) ) ).

tff(addAssignment_18867,axiom,
    ! [VarCurr: state_type] :
      ( v37837(VarCurr,1)
    <=> v37839(VarCurr,1) ) ).

tff(addAssignment_18866,axiom,
    ! [VarCurr: state_type] :
      ( v37839(VarCurr,1)
    <=> v37405(VarCurr,1) ) ).

tff(addAssignment_18865,axiom,
    ! [VarCurr: state_type] :
      ( v37989(VarCurr)
    <=> v37991(VarCurr) ) ).

tff(addAssignment_18864,axiom,
    ! [VarCurr: state_type] :
      ( v37991(VarCurr)
    <=> v37405(VarCurr,0) ) ).

tff(addAssignment_18863,axiom,
    ! [VarCurr: state_type] :
      ( v37975(VarCurr)
    <=> v37977(VarCurr) ) ).

tff(addAssignment_18862,axiom,
    ! [VarCurr: state_type] :
      ( v37977(VarCurr)
    <=> $false ) ).

tff(addAssignment_18861,axiom,
    ! [VarCurr: state_type] :
      ( v37969(VarCurr)
    <=> v37971(VarCurr) ) ).

tff(addAssignment_18860,axiom,
    ! [VarCurr: state_type] :
      ( v37971(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37959(VarCurr,B)
      <=> v37961(VarCurr,B) ) ) ).

tff(addAssignment_18858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37961(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_18857,axiom,
    ! [VarCurr: state_type] :
      ( v37949(VarCurr)
    <=> v37951(VarCurr) ) ).

tff(addAssignment_18856,axiom,
    ! [VarCurr: state_type] :
      ( v37951(VarCurr)
    <=> v37953(VarCurr) ) ).

tff(addAssignment_18855,axiom,
    ! [VarCurr: state_type] :
      ( v37953(VarCurr)
    <=> v37955(VarCurr) ) ).

tff(addAssignment_18854,axiom,
    ! [VarCurr: state_type] :
      ( v37955(VarCurr)
    <=> v37957(VarCurr) ) ).

tff(addAssignment_18853,axiom,
    ! [VarCurr: state_type] :
      ( v37957(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18852,axiom,
    ! [VarCurr: state_type] :
      ( v37939(VarCurr)
    <=> v37941(VarCurr) ) ).

tff(addAssignment_18851,axiom,
    ! [VarCurr: state_type] :
      ( v37941(VarCurr)
    <=> v37943(VarCurr) ) ).

tff(addAssignment_18850,axiom,
    ! [VarCurr: state_type] :
      ( v37943(VarCurr)
    <=> v37945(VarCurr) ) ).

tff(addAssignment_18849,axiom,
    ! [VarCurr: state_type] :
      ( v37945(VarCurr)
    <=> v37947(VarCurr) ) ).

tff(addAssignment_18848,axiom,
    ! [VarCurr: state_type] :
      ( v37947(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_18847,axiom,
    ! [VarCurr: state_type] :
      ( v37898(VarCurr)
    <=> v37900(VarCurr) ) ).

tff(addAssignment_18846,axiom,
    ! [VarCurr: state_type] :
      ( v37900(VarCurr)
    <=> v37902(VarCurr) ) ).

tff(addAssignment_18845,axiom,
    ! [VarCurr: state_type] :
      ( v37902(VarCurr)
    <=> v37904(VarCurr) ) ).

tff(addAssignment_18844,axiom,
    ! [VarCurr: state_type] :
      ( v37904(VarCurr)
    <=> v37906(VarCurr) ) ).

tff(addAssignment_18843,axiom,
    ! [VarCurr: state_type] :
      ( v37906(VarCurr)
    <=> v37908(VarCurr) ) ).

tff(addAssignment_18842,axiom,
    ! [VarCurr: state_type] :
      ( v37908(VarCurr)
    <=> v37910(VarCurr) ) ).

tff(addAssignment_18841,axiom,
    ! [VarCurr: state_type] :
      ( v37910(VarCurr)
    <=> v37912(VarCurr) ) ).

tff(writeUnaryOperator_2269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37912(VarCurr)
    <=> v37926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3686,axiom,
    ! [VarCurr: state_type] :
      ( v37926(VarCurr)
    <=> ( v37927(VarCurr)
        | v37922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3685,axiom,
    ! [VarCurr: state_type] :
      ( v37927(VarCurr)
    <=> ( v37914(VarCurr)
        | v37918(VarCurr) ) ) ).

tff(addAssignment_18840,axiom,
    ! [VarCurr: state_type] :
      ( v37922(VarCurr)
    <=> v37924(VarCurr) ) ).

tff(addAssignment_18839,axiom,
    ! [VarCurr: state_type] :
      ( v37924(VarCurr)
    <=> v37495(VarCurr,2) ) ).

tff(addAssignment_18838,axiom,
    ! [VarCurr: state_type] :
      ( v37918(VarCurr)
    <=> v37920(VarCurr) ) ).

tff(addAssignment_18837,axiom,
    ! [VarCurr: state_type] :
      ( v37920(VarCurr)
    <=> v37495(VarCurr,1) ) ).

tff(addAssignment_18836,axiom,
    ! [VarCurr: state_type] :
      ( v37914(VarCurr)
    <=> v37916(VarCurr) ) ).

tff(addAssignment_18835,axiom,
    ! [VarCurr: state_type] :
      ( v37916(VarCurr)
    <=> v37578(VarCurr,0) ) ).

tff(addAssignment_18834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37767(VarCurr,B)
      <=> v37769(VarCurr,B) ) ) ).

tff(addAssignment_18833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37769(VarCurr,B)
      <=> v37771(VarCurr,B) ) ) ).

tff(addAssignment_18832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37771(VarCurr,B)
      <=> v37773(VarCurr,B) ) ) ).

tff(addAssignment_18831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37773(VarCurr,B)
      <=> v37775(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37881(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v37775(VarNext,B)
            <=> v37775(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_448,axiom,
    ! [VarNext: state_type] :
      ( v37881(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37775(VarNext,B)
          <=> v37891(VarNext,B) ) ) ) ).

tff(addAssignment_18830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37891(VarNext,B)
          <=> v37889(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37892(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37889(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_316,axiom,
    ! [VarCurr: state_type] :
      ( v37892(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37889(VarCurr,B)
          <=> v37797(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3684,axiom,
    ! [VarCurr: state_type] :
      ( v37892(VarCurr)
    <=> ( v37893(VarCurr)
        & v37894(VarCurr) ) ) ).

tff(writeUnaryOperator_2268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37894(VarCurr)
    <=> v37787(VarCurr) ) ).

tff(writeUnaryOperator_2267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37893(VarCurr)
    <=> v37777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3683,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37881(VarNext)
      <=> v37882(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3682,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37882(VarNext)
      <=> ( v37883(VarNext)
          & v37801(VarNext) ) ) ) ).

tff(writeUnaryOperator_2266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37883(VarNext)
      <=> v37885(VarNext) ) ) ).

tff(addAssignment_18829,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37885(VarNext)
      <=> v37801(VarCurr) ) ) ).

tff(addAssignment_18828,axiom,
    ! [VarCurr: state_type] :
      ( v37801(VarCurr)
    <=> v37803(VarCurr) ) ).

tff(addAssignment_18827,axiom,
    ! [VarCurr: state_type] :
      ( v37803(VarCurr)
    <=> v37805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3681,axiom,
    ! [VarCurr: state_type] :
      ( v37805(VarCurr)
    <=> ( v37878(VarCurr)
        | v37874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3680,axiom,
    ! [VarCurr: state_type] :
      ( v37878(VarCurr)
    <=> ( v37807(VarCurr)
        & v37811(VarCurr) ) ) ).

tff(addAssignment_18826,axiom,
    ! [VarCurr: state_type] :
      ( v37874(VarCurr)
    <=> v37876(VarCurr) ) ).

tff(addAssignment_18825,axiom,
    ! [VarCurr: state_type] :
      ( v37876(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37858(VarNext)
       => ( v37811(VarNext)
        <=> v37811(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_447,axiom,
    ! [VarNext: state_type] :
      ( v37858(VarNext)
     => ( v37811(VarNext)
      <=> v37868(VarNext) ) ) ).

tff(addAssignment_18824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37868(VarNext)
      <=> v37866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3679,axiom,
    ! [VarCurr: state_type] :
      ( v37866(VarCurr)
    <=> ( v37869(VarCurr)
        & v37870(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3678,axiom,
    ! [VarCurr: state_type] :
      ( v37870(VarCurr)
    <=> ( v37817(VarCurr)
        | v37853(VarCurr) ) ) ).

tff(writeUnaryOperator_2265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37869(VarCurr)
    <=> v37813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37858(VarNext)
      <=> v37859(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37859(VarNext)
      <=> ( v37861(VarNext)
          & v37863(VarNext) ) ) ) ).

tff(writeUnaryOperator_2264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37863(VarCurr)
    <=> v37807(VarCurr) ) ).

tff(addAssignment_18823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37861(VarNext)
      <=> v37807(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_153,axiom,
    ( v37811(constB0)
  <=> $true ) ).

tff(addAssignment_18822,axiom,
    ! [VarCurr: state_type] :
      ( v37853(VarCurr)
    <=> v37855(VarCurr) ) ).

tff(addAssignment_18821,axiom,
    ! [VarCurr: state_type] :
      ( v37855(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18820,axiom,
    ! [VarCurr: state_type] :
      ( v37817(VarCurr)
    <=> v37819(VarCurr) ) ).

tff(addAssignment_18819,axiom,
    ! [VarCurr: state_type] :
      ( v37819(VarCurr)
    <=> v37821(VarCurr) ) ).

tff(addAssignment_18818,axiom,
    ! [VarCurr: state_type] :
      ( v37821(VarCurr)
    <=> v37823(VarCurr) ) ).

tff(addAssignment_18817,axiom,
    ! [VarCurr: state_type] :
      ( v37823(VarCurr)
    <=> v37825(VarCurr) ) ).

tff(writeUnaryOperator_2263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37825(VarCurr)
    <=> v37850(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3675,axiom,
    ! [VarCurr: state_type] :
      ( v37850(VarCurr)
    <=> ( v37851(VarCurr)
        | v37846(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3674,axiom,
    ! [VarCurr: state_type] :
      ( v37851(VarCurr)
    <=> ( v37827(VarCurr)
        | v37842(VarCurr) ) ) ).

tff(addAssignment_18816,axiom,
    ! [VarCurr: state_type] :
      ( v37846(VarCurr)
    <=> v37848(VarCurr) ) ).

tff(addAssignment_18815,axiom,
    ! [VarCurr: state_type] :
      ( v37848(VarCurr)
    <=> v37405(VarCurr,2) ) ).

tff(addAssignment_18814,axiom,
    ! [VarCurr: state_type] :
      ( v37842(VarCurr)
    <=> v37844(VarCurr) ) ).

tff(addAssignment_18813,axiom,
    ! [VarCurr: state_type] :
      ( v37844(VarCurr)
    <=> v37405(VarCurr,1) ) ).

tff(addAssignment_18812,axiom,
    ! [VarCurr: state_type] :
      ( v37827(VarCurr)
    <=> v37829(VarCurr) ) ).

tff(addAssignment_18811,axiom,
    ! [VarCurr: state_type] :
      ( v37829(VarCurr)
    <=> v37831(VarCurr,0) ) ).

tff(addAssignment_18810,axiom,
    ! [VarCurr: state_type] :
      ( v37831(VarCurr,0)
    <=> v37833(VarCurr,0) ) ).

tff(addAssignment_18809,axiom,
    ! [VarCurr: state_type] :
      ( v37833(VarCurr,0)
    <=> v37835(VarCurr,0) ) ).

tff(addAssignment_18808,axiom,
    ! [VarCurr: state_type] :
      ( v37835(VarCurr,0)
    <=> v37840(VarCurr,0) ) ).

tff(writeUnaryOperator_2262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37840(VarCurr,B)
      <=> ~ v37837(VarCurr,B) ) ) ).

tff(addAssignment_18807,axiom,
    ! [VarCurr: state_type] :
      ( v37837(VarCurr,0)
    <=> v37839(VarCurr,0) ) ).

tff(addAssignment_18806,axiom,
    ! [VarCurr: state_type] :
      ( v37839(VarCurr,0)
    <=> v37405(VarCurr,0) ) ).

tff(addAssignment_18805,axiom,
    ! [VarCurr: state_type] :
      ( v37813(VarCurr)
    <=> v37815(VarCurr) ) ).

tff(addAssignment_18804,axiom,
    ! [VarCurr: state_type] :
      ( v37815(VarCurr)
    <=> $false ) ).

tff(addAssignment_18803,axiom,
    ! [VarCurr: state_type] :
      ( v37807(VarCurr)
    <=> v37809(VarCurr) ) ).

tff(addAssignment_18802,axiom,
    ! [VarCurr: state_type] :
      ( v37809(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37797(VarCurr,B)
      <=> v37799(VarCurr,B) ) ) ).

tff(addAssignment_18800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37799(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_18799,axiom,
    ! [VarCurr: state_type] :
      ( v37787(VarCurr)
    <=> v37789(VarCurr) ) ).

tff(addAssignment_18798,axiom,
    ! [VarCurr: state_type] :
      ( v37789(VarCurr)
    <=> v37791(VarCurr) ) ).

tff(addAssignment_18797,axiom,
    ! [VarCurr: state_type] :
      ( v37791(VarCurr)
    <=> v37793(VarCurr) ) ).

tff(addAssignment_18796,axiom,
    ! [VarCurr: state_type] :
      ( v37793(VarCurr)
    <=> v37795(VarCurr) ) ).

tff(addAssignment_18795,axiom,
    ! [VarCurr: state_type] :
      ( v37795(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18794,axiom,
    ! [VarCurr: state_type] :
      ( v37777(VarCurr)
    <=> v37779(VarCurr) ) ).

tff(addAssignment_18793,axiom,
    ! [VarCurr: state_type] :
      ( v37779(VarCurr)
    <=> v37781(VarCurr) ) ).

tff(addAssignment_18792,axiom,
    ! [VarCurr: state_type] :
      ( v37781(VarCurr)
    <=> v37783(VarCurr) ) ).

tff(addAssignment_18791,axiom,
    ! [VarCurr: state_type] :
      ( v37783(VarCurr)
    <=> v37785(VarCurr) ) ).

tff(addAssignment_18790,axiom,
    ! [VarCurr: state_type] :
      ( v37785(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_18789,axiom,
    ! [VarCurr: state_type] :
      ( v37475(VarCurr)
    <=> v37477(VarCurr) ) ).

tff(addAssignment_18788,axiom,
    ! [VarCurr: state_type] :
      ( v37477(VarCurr)
    <=> v37479(VarCurr) ) ).

tff(addAssignment_18787,axiom,
    ! [VarCurr: state_type] :
      ( v37479(VarCurr)
    <=> v37481(VarCurr) ) ).

tff(addAssignment_18786,axiom,
    ! [VarCurr: state_type] :
      ( v37481(VarCurr)
    <=> v37483(VarCurr) ) ).

tff(addAssignment_18785,axiom,
    ! [VarCurr: state_type] :
      ( v37483(VarCurr)
    <=> v37485(VarCurr) ) ).

tff(addAssignment_18784,axiom,
    ! [VarCurr: state_type] :
      ( v37485(VarCurr)
    <=> v37487(VarCurr) ) ).

tff(addAssignment_18783,axiom,
    ! [VarCurr: state_type] :
      ( v37487(VarCurr)
    <=> v37489(VarCurr) ) ).

tff(writeUnaryOperator_2261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37489(VarCurr)
    <=> v37764(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3673,axiom,
    ! [VarCurr: state_type] :
      ( v37764(VarCurr)
    <=> ( v37765(VarCurr)
        | v37760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3672,axiom,
    ! [VarCurr: state_type] :
      ( v37765(VarCurr)
    <=> ( v37491(VarCurr)
        | v37756(VarCurr) ) ) ).

tff(addAssignment_18782,axiom,
    ! [VarCurr: state_type] :
      ( v37760(VarCurr)
    <=> v37762(VarCurr) ) ).

tff(addAssignment_18781,axiom,
    ! [VarCurr: state_type] :
      ( v37762(VarCurr)
    <=> v37495(VarCurr,2) ) ).

tff(addAssignment_18780,axiom,
    ! [VarCurr: state_type] :
      ( v37756(VarCurr)
    <=> v37758(VarCurr) ) ).

tff(addAssignment_18779,axiom,
    ! [VarCurr: state_type] :
      ( v37758(VarCurr)
    <=> v37495(VarCurr,1) ) ).

tff(addAssignment_18778,axiom,
    ! [VarCurr: state_type] :
      ( v37491(VarCurr)
    <=> v37493(VarCurr) ) ).

tff(addAssignment_18777,axiom,
    ! [VarCurr: state_type] :
      ( v37493(VarCurr)
    <=> v37495(VarCurr,0) ) ).

tff(addAssignment_18776,axiom,
    ! [VarCurr: state_type] :
      ( v37495(VarCurr,0)
    <=> v37407(VarCurr,3) ) ).

tff(addAssignment_18775,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,3)
    <=> v37409(VarCurr,3) ) ).

tff(addAssignment_18774,axiom,
    ! [VarNext: state_type] :
      ( v37409(VarNext,3)
    <=> v37748(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_446,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37749(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v37748(VarNext,B)
            <=> v37409(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_446,axiom,
    ! [VarNext: state_type] :
      ( v37749(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37748(VarNext,B)
          <=> v37720(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37749(VarNext)
      <=> v37750(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3670,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37750(VarNext)
      <=> ( v37752(VarNext)
          & v37662(VarNext) ) ) ) ).

tff(writeUnaryOperator_2260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37752(VarNext)
      <=> v37714(VarNext) ) ) ).

tff(addAssignment_18773,axiom,
    ! [VarCurr: state_type] :
      ( v37519(VarCurr,3)
    <=> v37521(VarCurr,3) ) ).

tff(addAssignment_18772,axiom,
    ! [VarCurr: state_type] :
      ( v37521(VarCurr,3)
    <=> v37659(VarCurr,3) ) ).

tff(addAssignment_18771,axiom,
    ! [VarCurr: state_type] :
      ( v37523(VarCurr,0)
    <=> v37525(VarCurr,0) ) ).

tff(addAssignment_18770,axiom,
    ! [VarCurr: state_type] :
      ( v37525(VarCurr,0)
    <=> v37527(VarCurr,0) ) ).

tff(addAssignment_18769,axiom,
    ! [VarCurr: state_type] :
      ( v37527(VarCurr,0)
    <=> v37658(VarCurr,0) ) ).

tff(addAssignment_18768,axiom,
    ! [VarCurr: state_type] :
      ( v37595(VarCurr,0)
    <=> v37597(VarCurr,0) ) ).

tff(addAssignment_18767,axiom,
    ! [VarCurr: state_type] :
      ( v37597(VarCurr,0)
    <=> v37599(VarCurr,0) ) ).

tff(addAssignment_18766,axiom,
    ! [VarCurr: state_type] :
      ( v37599(VarCurr,0)
    <=> v37601(VarCurr,0) ) ).

tff(addAssignment_18765,axiom,
    ! [VarCurr: state_type] :
      ( v37601(VarCurr,0)
    <=> v37603(VarCurr,0) ) ).

tff(addAssignment_18764,axiom,
    ! [VarCurr: state_type] :
      ( v37603(VarCurr,0)
    <=> v37613(VarCurr,0) ) ).

tff(addAssignment_18763,axiom,
    ! [VarCurr: state_type] :
      ( v37529(VarCurr,0)
    <=> v37531(VarCurr,0) ) ).

tff(addAssignment_18762,axiom,
    ! [VarCurr: state_type] :
      ( v37531(VarCurr,0)
    <=> v37592(VarCurr,0) ) ).

tff(addAssignment_18761,axiom,
    ! [VarCurr: state_type] :
      ( v37533(VarCurr)
    <=> v37059(VarCurr,2) ) ).

tff(addAssignment_18760,axiom,
    ! [VarCurr: state_type] :
      ( v37059(VarCurr,2)
    <=> v37061(VarCurr,2) ) ).

tff(addAssignment_18759,axiom,
    ! [VarCurr: state_type] :
      ( v37061(VarCurr,2)
    <=> v37071(VarCurr,2) ) ).

tff(addAssignment_18758,axiom,
    ! [VarCurr: state_type] :
      ( v37063(VarCurr,2)
    <=> v37065(VarCurr,2) ) ).

tff(addAssignment_18757,axiom,
    ! [VarCurr: state_type] :
      ( v37065(VarCurr,2)
    <=> v37068(VarCurr,2) ) ).

tff(addAssignment_18756,axiom,
    ! [VarCurr: state_type] :
      ( v37069(VarCurr)
    <=> v37536(VarCurr,1) ) ).

tff(addAssignment_18755,axiom,
    ! [VarCurr: state_type] :
      ( v37536(VarCurr,1)
    <=> v37538(VarCurr,1) ) ).

tff(addAssignment_18754,axiom,
    ! [VarCurr: state_type] :
      ( v37538(VarCurr,1)
    <=> v37746(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v37746(VarCurr,B)
      <=> ( v37540(VarCurr,B)
          | v37546(VarCurr,B) ) ) ) ).

tff(addAssignment_18753,axiom,
    ! [VarCurr: state_type] :
      ( v37546(VarCurr,1)
    <=> v37548(VarCurr,1) ) ).

tff(addAssignment_18752,axiom,
    ! [VarCurr: state_type] :
      ( v37548(VarCurr,1)
    <=> v37744(VarCurr,1) ) ).

tff(addAssignment_18751,axiom,
    ! [VarCurr: state_type] :
      ( v37744(VarCurr,0)
    <=> v37745(VarCurr) ) ).

tff(addAssignment_18750,axiom,
    ! [VarCurr: state_type] :
      ( v37744(VarCurr,1)
    <=> v37550(VarCurr) ) ).

tff(addAssignment_18749,axiom,
    ! [VarCurr: state_type] :
      ( v37550(VarCurr)
    <=> v37552(VarCurr,1) ) ).

tff(addAssignment_18748,axiom,
    ! [VarCurr: state_type] :
      ( v37552(VarCurr,1)
    <=> v37554(VarCurr,1) ) ).

tff(addAssignment_18747,axiom,
    ! [VarCurr: state_type] :
      ( v37554(VarCurr,1)
    <=> v37743(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v37743(VarCurr,B)
      <=> ( v37556(VarCurr,B)
          & v37564(VarCurr,B) ) ) ) ).

tff(addAssignment_18746,axiom,
    ! [VarCurr: state_type] :
      ( v37564(VarCurr,1)
    <=> v37566(VarCurr,1) ) ).

tff(addAssignment_18745,axiom,
    ! [VarCurr: state_type] :
      ( v37566(VarCurr,1)
    <=> v37741(VarCurr,1) ) ).

tff(addAssignment_18744,axiom,
    ! [VarCurr: state_type] :
      ( v37741(VarCurr,0)
    <=> v37742(VarCurr) ) ).

tff(addAssignment_18743,axiom,
    ! [VarCurr: state_type] :
      ( v37741(VarCurr,1)
    <=> v37568(VarCurr) ) ).

tff(addAssignment_18742,axiom,
    ! [VarCurr: state_type] :
      ( v37568(VarCurr)
    <=> v37570(VarCurr) ) ).

tff(addAssignment_18741,axiom,
    ! [VarCurr: state_type] :
      ( v37570(VarCurr)
    <=> v37572(VarCurr) ) ).

tff(writeUnaryOperator_2259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37572(VarCurr)
    <=> v37739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3669,axiom,
    ! [VarCurr: state_type] :
      ( v37739(VarCurr)
    <=> ( v37740(VarCurr)
        | v37727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3668,axiom,
    ! [VarCurr: state_type] :
      ( v37740(VarCurr)
    <=> ( v37574(VarCurr)
        | v37589(VarCurr) ) ) ).

tff(addAssignment_18740,axiom,
    ! [VarCurr: state_type] :
      ( v37727(VarCurr)
    <=> v37729(VarCurr) ) ).

tff(addAssignment_18739,axiom,
    ! [VarCurr: state_type] :
      ( v37729(VarCurr)
    <=> v37578(VarCurr,2) ) ).

tff(addAssignment_18738,axiom,
    ! [VarCurr: state_type] :
      ( v37578(VarCurr,2)
    <=> v37580(VarCurr,2) ) ).

tff(addAssignment_18737,axiom,
    ! [VarCurr: state_type] :
      ( v37580(VarCurr,2)
    <=> v37582(VarCurr,2) ) ).

tff(addAssignment_18736,axiom,
    ! [VarCurr: state_type] :
      ( v37582(VarCurr,2)
    <=> v37587(VarCurr,2) ) ).

tff(addAssignment_18735,axiom,
    ! [VarCurr: state_type] :
      ( v37584(VarCurr,2)
    <=> v37586(VarCurr,2) ) ).

tff(addAssignment_18734,axiom,
    ! [VarCurr: state_type] :
      ( v37586(VarCurr,2)
    <=> v37495(VarCurr,2) ) ).

tff(addAssignment_18733,axiom,
    ! [VarCurr: state_type] :
      ( v37495(VarCurr,2)
    <=> v37407(VarCurr,5) ) ).

tff(addAssignment_18732,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,5)
    <=> v37409(VarCurr,5) ) ).

tff(addAssignment_18731,axiom,
    ! [VarNext: state_type] :
      ( v37409(VarNext,5)
    <=> v37731(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37732(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v37731(VarNext,B)
            <=> v37409(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_445,axiom,
    ! [VarNext: state_type] :
      ( v37732(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37731(VarNext,B)
          <=> v37720(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37732(VarNext)
      <=> v37733(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3666,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37733(VarNext)
      <=> ( v37735(VarNext)
          & v37662(VarNext) ) ) ) ).

tff(writeUnaryOperator_2258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37735(VarNext)
      <=> v37714(VarNext) ) ) ).

tff(addAssignment_18730,axiom,
    ! [VarCurr: state_type] :
      ( v37519(VarCurr,5)
    <=> v37521(VarCurr,5) ) ).

tff(addAssignment_18729,axiom,
    ! [VarCurr: state_type] :
      ( v37521(VarCurr,5)
    <=> v37659(VarCurr,5) ) ).

tff(addAssignment_18728,axiom,
    ! [VarCurr: state_type] :
      ( v37523(VarCurr,2)
    <=> v37525(VarCurr,2) ) ).

tff(addAssignment_18727,axiom,
    ! [VarCurr: state_type] :
      ( v37525(VarCurr,2)
    <=> v37527(VarCurr,2) ) ).

tff(addAssignment_18726,axiom,
    ! [VarCurr: state_type] :
      ( v37527(VarCurr,2)
    <=> v37658(VarCurr,2) ) ).

tff(addAssignment_18725,axiom,
    ! [VarCurr: state_type] :
      ( v37595(VarCurr,2)
    <=> v37597(VarCurr,2) ) ).

tff(addAssignment_18724,axiom,
    ! [VarCurr: state_type] :
      ( v37597(VarCurr,2)
    <=> v37599(VarCurr,2) ) ).

tff(addAssignment_18723,axiom,
    ! [VarCurr: state_type] :
      ( v37599(VarCurr,2)
    <=> v37601(VarCurr,2) ) ).

tff(addAssignment_18722,axiom,
    ! [VarCurr: state_type] :
      ( v37601(VarCurr,2)
    <=> v37603(VarCurr,2) ) ).

tff(addAssignment_18721,axiom,
    ! [VarCurr: state_type] :
      ( v37603(VarCurr,2)
    <=> v37613(VarCurr,2) ) ).

tff(addAssignment_18720,axiom,
    ! [VarCurr: state_type] :
      ( v37605(VarCurr,2)
    <=> v37607(VarCurr,2) ) ).

tff(addAssignment_18719,axiom,
    ! [VarCurr: state_type] :
      ( v37607(VarCurr,2)
    <=> v37608(VarCurr,2) ) ).

tff(addAssignment_18718,axiom,
    ! [VarCurr: state_type] :
      ( v37529(VarCurr,2)
    <=> v37531(VarCurr,2) ) ).

tff(addAssignment_18717,axiom,
    ! [VarCurr: state_type] :
      ( v37531(VarCurr,2)
    <=> v37592(VarCurr,2) ) ).

tff(addAssignment_18716,axiom,
    ! [VarCurr: state_type] :
      ( v37589(VarCurr)
    <=> v37591(VarCurr) ) ).

tff(addAssignment_18715,axiom,
    ! [VarCurr: state_type] :
      ( v37591(VarCurr)
    <=> v37495(VarCurr,1) ) ).

tff(addAssignment_18714,axiom,
    ! [VarCurr: state_type] :
      ( v37495(VarCurr,1)
    <=> v37407(VarCurr,4) ) ).

tff(addAssignment_18713,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,4)
    <=> v37409(VarCurr,4) ) ).

tff(addAssignment_18712,axiom,
    ! [VarNext: state_type] :
      ( v37409(VarNext,4)
    <=> v37709(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37710(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v37709(VarNext,B)
            <=> v37409(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_444,axiom,
    ! [VarNext: state_type] :
      ( v37710(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37709(VarNext,B)
          <=> v37720(VarNext,B) ) ) ) ).

tff(addAssignment_18711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37720(VarNext,B)
          <=> v37718(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37721(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37718(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_315,axiom,
    ! [VarCurr: state_type] :
      ( v37721(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v37718(VarCurr,B)
          <=> v37519(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3665,axiom,
    ! [VarCurr: state_type] :
      ( v37721(VarCurr)
    <=> ( v37722(VarCurr)
        & v37723(VarCurr) ) ) ).

tff(writeUnaryOperator_2257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37723(VarCurr)
    <=> v37509(VarCurr) ) ).

tff(writeUnaryOperator_2256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37722(VarCurr)
    <=> v37497(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37710(VarNext)
      <=> v37711(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3663,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37711(VarNext)
      <=> ( v37712(VarNext)
          & v37662(VarNext) ) ) ) ).

tff(writeUnaryOperator_2255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37712(VarNext)
      <=> v37714(VarNext) ) ) ).

tff(addAssignment_18710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37714(VarNext)
      <=> v37662(VarCurr) ) ) ).

tff(addAssignment_18709,axiom,
    ! [VarCurr: state_type] :
      ( v37662(VarCurr)
    <=> v37664(VarCurr) ) ).

tff(addAssignment_18708,axiom,
    ! [VarCurr: state_type] :
      ( v37664(VarCurr)
    <=> v37666(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3662,axiom,
    ! [VarCurr: state_type] :
      ( v37666(VarCurr)
    <=> ( v37707(VarCurr)
        | v37703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3661,axiom,
    ! [VarCurr: state_type] :
      ( v37707(VarCurr)
    <=> ( v37668(VarCurr)
        & v37672(VarCurr) ) ) ).

tff(addAssignment_18707,axiom,
    ! [VarCurr: state_type] :
      ( v37703(VarCurr)
    <=> v37705(VarCurr) ) ).

tff(addAssignment_18706,axiom,
    ! [VarCurr: state_type] :
      ( v37705(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37687(VarNext)
       => ( v37672(VarNext)
        <=> v37672(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_443,axiom,
    ! [VarNext: state_type] :
      ( v37687(VarNext)
     => ( v37672(VarNext)
      <=> v37697(VarNext) ) ) ).

tff(addAssignment_18705,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37697(VarNext)
      <=> v37695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3660,axiom,
    ! [VarCurr: state_type] :
      ( v37695(VarCurr)
    <=> ( v37698(VarCurr)
        & v37699(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3659,axiom,
    ! [VarCurr: state_type] :
      ( v37699(VarCurr)
    <=> ( v37678(VarCurr)
        | v37682(VarCurr) ) ) ).

tff(writeUnaryOperator_2254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37698(VarCurr)
    <=> v37674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37687(VarNext)
      <=> v37688(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37688(VarNext)
      <=> ( v37690(VarNext)
          & v37692(VarNext) ) ) ) ).

tff(writeUnaryOperator_2253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37692(VarCurr)
    <=> v37668(VarCurr) ) ).

tff(addAssignment_18704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37690(VarNext)
      <=> v37668(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_152,axiom,
    ( v37672(constB0)
  <=> $true ) ).

tff(addAssignment_18703,axiom,
    ! [VarCurr: state_type] :
      ( v37682(VarCurr)
    <=> v37684(VarCurr) ) ).

tff(addAssignment_18702,axiom,
    ! [VarCurr: state_type] :
      ( v37684(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18701,axiom,
    ! [VarCurr: state_type] :
      ( v37678(VarCurr)
    <=> v37680(VarCurr) ) ).

tff(addAssignment_18700,axiom,
    ! [VarCurr: state_type] :
      ( v37680(VarCurr)
    <=> $true ) ).

tff(addAssignment_18699,axiom,
    ! [VarCurr: state_type] :
      ( v37674(VarCurr)
    <=> v37676(VarCurr) ) ).

tff(addAssignment_18698,axiom,
    ! [VarCurr: state_type] :
      ( v37676(VarCurr)
    <=> $false ) ).

tff(addAssignment_18697,axiom,
    ! [VarCurr: state_type] :
      ( v37668(VarCurr)
    <=> v37670(VarCurr) ) ).

tff(addAssignment_18696,axiom,
    ! [VarCurr: state_type] :
      ( v37670(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18695,axiom,
    ! [VarCurr: state_type] :
      ( v37519(VarCurr,4)
    <=> v37521(VarCurr,4) ) ).

tff(addAssignment_18694,axiom,
    ! [VarCurr: state_type] :
      ( v37521(VarCurr,4)
    <=> v37659(VarCurr,4) ) ).

tff(addAssignment_18693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37659(VarCurr,B)
      <=> v37660(VarCurr,B) ) ) ).

tff(addAssignment_18692,axiom,
    ! [VarCurr: state_type] :
      ( ( v37659(VarCurr,5)
      <=> v37523(VarCurr,2) )
      & ( v37659(VarCurr,4)
      <=> v37523(VarCurr,1) )
      & ( v37659(VarCurr,3)
      <=> v37523(VarCurr,0) ) ) ).

tff(addAssignment_18691,axiom,
    ! [VarCurr: state_type] :
      ( v37523(VarCurr,1)
    <=> v37525(VarCurr,1) ) ).

tff(addAssignment_18690,axiom,
    ! [VarCurr: state_type] :
      ( v37525(VarCurr,1)
    <=> v37527(VarCurr,1) ) ).

tff(addAssignment_18689,axiom,
    ! [VarCurr: state_type] :
      ( v37527(VarCurr,1)
    <=> v37658(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_603,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37658(VarCurr,B)
      <=> ( v37529(VarCurr,B)
          & v37595(VarCurr,B) ) ) ) ).

tff(addAssignment_18688,axiom,
    ! [VarCurr: state_type] :
      ( v37595(VarCurr,1)
    <=> v37597(VarCurr,1) ) ).

tff(addAssignment_18687,axiom,
    ! [VarCurr: state_type] :
      ( v37597(VarCurr,1)
    <=> v37599(VarCurr,1) ) ).

tff(addAssignment_18686,axiom,
    ! [VarCurr: state_type] :
      ( v37599(VarCurr,1)
    <=> v37601(VarCurr,1) ) ).

tff(addAssignment_18685,axiom,
    ! [VarCurr: state_type] :
      ( v37601(VarCurr,1)
    <=> v37603(VarCurr,1) ) ).

tff(addAssignment_18684,axiom,
    ! [VarCurr: state_type] :
      ( v37603(VarCurr,1)
    <=> v37613(VarCurr,1) ) ).

tff(addAssignment_18683,axiom,
    ! [VarCurr: state_type] :
      ( v37613(VarCurr,0)
    <=> v37653(VarCurr) ) ).

tff(addAssignment_18682,axiom,
    ! [VarCurr: state_type] :
      ( v37613(VarCurr,1)
    <=> v37648(VarCurr) ) ).

tff(addAssignment_18681,axiom,
    ! [VarCurr: state_type] :
      ( v37613(VarCurr,2)
    <=> v37643(VarCurr) ) ).

tff(addAssignment_18680,axiom,
    ! [VarCurr: state_type] :
      ( v37613(VarCurr,3)
    <=> v37615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3656,axiom,
    ! [VarCurr: state_type] :
      ( v37653(VarCurr)
    <=> ( v37654(VarCurr)
        & v37657(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3655,axiom,
    ! [VarCurr: state_type] :
      ( v37657(VarCurr)
    <=> ( v37605(VarCurr,0)
        | v37623(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3654,axiom,
    ! [VarCurr: state_type] :
      ( v37654(VarCurr)
    <=> ( v37655(VarCurr)
        | v37656(VarCurr) ) ) ).

tff(writeUnaryOperator_2252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37656(VarCurr)
    <=> v37623(VarCurr,0) ) ).

tff(writeUnaryOperator_2251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37655(VarCurr)
    <=> v37605(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3653,axiom,
    ! [VarCurr: state_type] :
      ( v37648(VarCurr)
    <=> ( v37649(VarCurr)
        & v37652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3652,axiom,
    ! [VarCurr: state_type] :
      ( v37652(VarCurr)
    <=> ( v37622(VarCurr)
        | v37624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3651,axiom,
    ! [VarCurr: state_type] :
      ( v37649(VarCurr)
    <=> ( v37650(VarCurr)
        | v37651(VarCurr) ) ) ).

tff(writeUnaryOperator_2250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37651(VarCurr)
    <=> v37624(VarCurr) ) ).

tff(writeUnaryOperator_2249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37650(VarCurr)
    <=> v37622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3650,axiom,
    ! [VarCurr: state_type] :
      ( v37643(VarCurr)
    <=> ( v37644(VarCurr)
        & v37647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3649,axiom,
    ! [VarCurr: state_type] :
      ( v37647(VarCurr)
    <=> ( v37620(VarCurr)
        | v37630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3648,axiom,
    ! [VarCurr: state_type] :
      ( v37644(VarCurr)
    <=> ( v37645(VarCurr)
        | v37646(VarCurr) ) ) ).

tff(writeUnaryOperator_2248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37646(VarCurr)
    <=> v37630(VarCurr) ) ).

tff(writeUnaryOperator_2247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37645(VarCurr)
    <=> v37620(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3647,axiom,
    ! [VarCurr: state_type] :
      ( v37615(VarCurr)
    <=> ( v37616(VarCurr)
        & v37642(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3646,axiom,
    ! [VarCurr: state_type] :
      ( v37642(VarCurr)
    <=> ( v37618(VarCurr)
        | v37637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3645,axiom,
    ! [VarCurr: state_type] :
      ( v37616(VarCurr)
    <=> ( v37617(VarCurr)
        | v37636(VarCurr) ) ) ).

tff(writeUnaryOperator_2246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37636(VarCurr)
    <=> v37637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3644,axiom,
    ! [VarCurr: state_type] :
      ( v37637(VarCurr)
    <=> ( v37638(VarCurr)
        & v37641(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_508,axiom,
    ! [VarCurr: state_type] :
      ( v37641(VarCurr)
    <=> ( v37605(VarCurr,3)
        | v37623(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3643,axiom,
    ! [VarCurr: state_type] :
      ( v37638(VarCurr)
    <=> ( v37639(VarCurr)
        | v37640(VarCurr) ) ) ).

tff(writeUnaryOperator_2245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37640(VarCurr)
    <=> v37623(VarCurr,3) ) ).

tff(writeUnaryOperator_2244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37639(VarCurr)
    <=> v37605(VarCurr,3) ) ).

tff(writeUnaryOperator_2243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37617(VarCurr)
    <=> v37618(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3642,axiom,
    ! [VarCurr: state_type] :
      ( v37618(VarCurr)
    <=> ( v37619(VarCurr)
        | v37635(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_507,axiom,
    ! [VarCurr: state_type] :
      ( v37635(VarCurr)
    <=> ( v37605(VarCurr,2)
        & v37623(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3641,axiom,
    ! [VarCurr: state_type] :
      ( v37619(VarCurr)
    <=> ( v37620(VarCurr)
        & v37630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3640,axiom,
    ! [VarCurr: state_type] :
      ( v37630(VarCurr)
    <=> ( v37631(VarCurr)
        & v37634(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_506,axiom,
    ! [VarCurr: state_type] :
      ( v37634(VarCurr)
    <=> ( v37605(VarCurr,2)
        | v37623(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3639,axiom,
    ! [VarCurr: state_type] :
      ( v37631(VarCurr)
    <=> ( v37632(VarCurr)
        | v37633(VarCurr) ) ) ).

tff(writeUnaryOperator_2242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37633(VarCurr)
    <=> v37623(VarCurr,2) ) ).

tff(writeUnaryOperator_2241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37632(VarCurr)
    <=> v37605(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3638,axiom,
    ! [VarCurr: state_type] :
      ( v37620(VarCurr)
    <=> ( v37621(VarCurr)
        | v37629(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_505,axiom,
    ! [VarCurr: state_type] :
      ( v37629(VarCurr)
    <=> ( v37605(VarCurr,1)
        & v37623(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3637,axiom,
    ! [VarCurr: state_type] :
      ( v37621(VarCurr)
    <=> ( v37622(VarCurr)
        & v37624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3636,axiom,
    ! [VarCurr: state_type] :
      ( v37624(VarCurr)
    <=> ( v37625(VarCurr)
        & v37628(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_504,axiom,
    ! [VarCurr: state_type] :
      ( v37628(VarCurr)
    <=> ( v37605(VarCurr,1)
        | v37623(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3635,axiom,
    ! [VarCurr: state_type] :
      ( v37625(VarCurr)
    <=> ( v37626(VarCurr)
        | v37627(VarCurr) ) ) ).

tff(writeUnaryOperator_2240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37627(VarCurr)
    <=> v37623(VarCurr,1) ) ).

tff(writeUnaryOperator_2239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37626(VarCurr)
    <=> v37605(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3634,axiom,
    ! [VarCurr: state_type] :
      ( v37622(VarCurr)
    <=> ( v37605(VarCurr,0)
        & v37623(VarCurr,0) ) ) ).

tff(addAssignment_18679,axiom,
    ! [VarCurr: state_type] :
      ( v37623(VarCurr,0)
    <=> v37610(VarCurr) ) ).

tff(addAssignment_18678,axiom,
    ! [VarCurr: state_type] :
      ( ( v37623(VarCurr,3)
      <=> $false )
      & ( v37623(VarCurr,2)
      <=> $false )
      & ( v37623(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_18677,axiom,
    ! [VarCurr: state_type] :
      ( v37610(VarCurr)
    <=> v37612(VarCurr) ) ).

tff(addAssignment_18676,axiom,
    ! [VarCurr: state_type] :
      ( v37612(VarCurr)
    <=> v37560(VarCurr) ) ).

tff(addAssignment_18675,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v37605(VarCurr,B)
      <=> v37607(VarCurr,B) ) ) ).

tff(addAssignment_18674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v37607(VarCurr,B)
      <=> v37608(VarCurr,B) ) ) ).

tff(addAssignment_18673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37608(VarCurr,B)
      <=> v37495(VarCurr,B) ) ) ).

tff(addAssignment_18672,axiom,
    ! [VarCurr: state_type] :
      ( v37608(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_18671,axiom,
    ! [VarCurr: state_type] :
      ( v37529(VarCurr,1)
    <=> v37531(VarCurr,1) ) ).

tff(addAssignment_18670,axiom,
    ! [VarCurr: state_type] :
      ( v37531(VarCurr,1)
    <=> v37592(VarCurr,1) ) ).

tff(addAssignment_18669,axiom,
    ! [VarCurr: state_type] :
      ( v37592(VarCurr,0)
    <=> v37593(VarCurr) ) ).

tff(addAssignment_18668,axiom,
    ! [VarCurr: state_type] :
      ( v37592(VarCurr,1)
    <=> v37593(VarCurr) ) ).

tff(addAssignment_18667,axiom,
    ! [VarCurr: state_type] :
      ( v37592(VarCurr,2)
    <=> v37593(VarCurr) ) ).

tff(addAssignment_18666,axiom,
    ! [VarCurr: state_type] :
      ( v37593(VarCurr)
    <=> v37533(VarCurr) ) ).

tff(addAssignment_18665,axiom,
    ! [VarCurr: state_type] :
      ( v37574(VarCurr)
    <=> v37576(VarCurr) ) ).

tff(addAssignment_18664,axiom,
    ! [VarCurr: state_type] :
      ( v37576(VarCurr)
    <=> v37578(VarCurr,0) ) ).

tff(addAssignment_18663,axiom,
    ! [VarCurr: state_type] :
      ( v37578(VarCurr,0)
    <=> v37580(VarCurr,0) ) ).

tff(addAssignment_18662,axiom,
    ! [VarCurr: state_type] :
      ( v37580(VarCurr,0)
    <=> v37582(VarCurr,0) ) ).

tff(addAssignment_18661,axiom,
    ! [VarCurr: state_type] :
      ( v37582(VarCurr,0)
    <=> v37587(VarCurr,0) ) ).

tff(writeUnaryOperator_2238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37587(VarCurr,B)
      <=> ~ v37584(VarCurr,B) ) ) ).

tff(addAssignment_18660,axiom,
    ! [VarCurr: state_type] :
      ( v37584(VarCurr,0)
    <=> v37586(VarCurr,0) ) ).

tff(addAssignment_18659,axiom,
    ! [VarCurr: state_type] :
      ( v37586(VarCurr,0)
    <=> v37495(VarCurr,0) ) ).

tff(addAssignment_18658,axiom,
    ! [VarCurr: state_type] :
      ( v37556(VarCurr,1)
    <=> v37558(VarCurr,1) ) ).

tff(addAssignment_18657,axiom,
    ! [VarCurr: state_type] :
      ( v37558(VarCurr,1)
    <=> v37561(VarCurr,1) ) ).

tff(addAssignment_18656,axiom,
    ! [VarCurr: state_type] :
      ( v37561(VarCurr,0)
    <=> v37562(VarCurr) ) ).

tff(addAssignment_18655,axiom,
    ! [VarCurr: state_type] :
      ( v37561(VarCurr,1)
    <=> v37560(VarCurr) ) ).

tff(addAssignment_18654,axiom,
    ! [VarCurr: state_type] :
      ( v37560(VarCurr)
    <=> v7230(VarCurr,4) ) ).

tff(addAssignment_18653,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,4)
    <=> v7232(VarCurr,4) ) ).

tff(addAssignment_18652,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,4)
    <=> v7234(VarCurr,4) ) ).

tff(addAssignment_18651,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,4)
    <=> v34455(VarCurr,4) ) ).

tff(addAssignment_18650,axiom,
    ! [VarCurr: state_type] :
      ( v37540(VarCurr,1)
    <=> v37542(VarCurr,1) ) ).

tff(addAssignment_18649,axiom,
    ! [VarCurr: state_type] :
      ( v37542(VarCurr,1)
    <=> v37543(VarCurr,1) ) ).

tff(addAssignment_18648,axiom,
    ! [VarCurr: state_type] :
      ( v37543(VarCurr,0)
    <=> v37544(VarCurr) ) ).

tff(addAssignment_18647,axiom,
    ! [VarCurr: state_type] :
      ( v37543(VarCurr,1)
    <=> v37544(VarCurr) ) ).

tff(addAssignment_18646,axiom,
    ! [VarCurr: state_type] :
      ( v37544(VarCurr)
    <=> v37067(VarCurr) ) ).

tff(addAssignment_18645,axiom,
    ! [VarCurr: state_type] :
      ( v37509(VarCurr)
    <=> v37511(VarCurr) ) ).

tff(addAssignment_18644,axiom,
    ! [VarCurr: state_type] :
      ( v37511(VarCurr)
    <=> v37513(VarCurr) ) ).

tff(addAssignment_18643,axiom,
    ! [VarCurr: state_type] :
      ( v37513(VarCurr)
    <=> v37515(VarCurr) ) ).

tff(addAssignment_18642,axiom,
    ! [VarCurr: state_type] :
      ( v37515(VarCurr)
    <=> v37517(VarCurr) ) ).

tff(addAssignment_18641,axiom,
    ! [VarCurr: state_type] :
      ( v37517(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18640,axiom,
    ! [VarCurr: state_type] :
      ( v37497(VarCurr)
    <=> v37499(VarCurr) ) ).

tff(addAssignment_18639,axiom,
    ! [VarCurr: state_type] :
      ( v37499(VarCurr)
    <=> v37501(VarCurr) ) ).

tff(addAssignment_18638,axiom,
    ! [VarCurr: state_type] :
      ( v37501(VarCurr)
    <=> v37503(VarCurr) ) ).

tff(addAssignment_18637,axiom,
    ! [VarCurr: state_type] :
      ( v37503(VarCurr)
    <=> v37505(VarCurr) ) ).

tff(addAssignment_18636,axiom,
    ! [VarCurr: state_type] :
      ( v37505(VarCurr)
    <=> v37507(VarCurr) ) ).

tff(addAssignment_18635,axiom,
    ! [VarCurr: state_type] :
      ( v37507(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_18634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37005(VarCurr,B)
      <=> v37007(VarCurr,B) ) ) ).

tff(addAssignment_18633,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37007(VarCurr,B)
      <=> v37009(VarCurr,B) ) ) ).

tff(addAssignment_18632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37009(VarCurr,B)
      <=> v37011(VarCurr,B) ) ) ).

tff(addAssignment_18631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37011(VarCurr,B)
      <=> v37013(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37458(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v37013(VarNext,B)
            <=> v37013(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_442,axiom,
    ! [VarNext: state_type] :
      ( v37458(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37013(VarNext,B)
          <=> v37468(VarNext,B) ) ) ) ).

tff(addAssignment_18630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37468(VarNext,B)
          <=> v37466(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37469(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37466(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_314,axiom,
    ! [VarCurr: state_type] :
      ( v37469(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37466(VarCurr,B)
          <=> v37043(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3633,axiom,
    ! [VarCurr: state_type] :
      ( v37469(VarCurr)
    <=> ( v37470(VarCurr)
        & v37471(VarCurr) ) ) ).

tff(writeUnaryOperator_2237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37471(VarCurr)
    <=> v37029(VarCurr) ) ).

tff(writeUnaryOperator_2236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37470(VarCurr)
    <=> v37015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37458(VarNext)
      <=> v37459(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37459(VarNext)
      <=> ( v37460(VarNext)
          & v37373(VarNext) ) ) ) ).

tff(writeUnaryOperator_2235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37460(VarNext)
      <=> v37462(VarNext) ) ) ).

tff(addAssignment_18629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37462(VarNext)
      <=> v37373(VarCurr) ) ) ).

tff(addAssignment_18628,axiom,
    ! [VarCurr: state_type] :
      ( v37373(VarCurr)
    <=> v37375(VarCurr) ) ).

tff(addAssignment_18627,axiom,
    ! [VarCurr: state_type] :
      ( v37375(VarCurr)
    <=> v37377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3630,axiom,
    ! [VarCurr: state_type] :
      ( v37377(VarCurr)
    <=> ( v37455(VarCurr)
        | v37447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3629,axiom,
    ! [VarCurr: state_type] :
      ( v37455(VarCurr)
    <=> ( v37379(VarCurr)
        & v37385(VarCurr) ) ) ).

tff(addAssignment_18626,axiom,
    ! [VarCurr: state_type] :
      ( v37447(VarCurr)
    <=> v37449(VarCurr) ) ).

tff(addAssignment_18625,axiom,
    ! [VarCurr: state_type] :
      ( v37449(VarCurr)
    <=> v37451(VarCurr) ) ).

tff(addAssignment_18624,axiom,
    ! [VarCurr: state_type] :
      ( v37451(VarCurr)
    <=> v37453(VarCurr) ) ).

tff(addAssignment_18623,axiom,
    ! [VarCurr: state_type] :
      ( v37453(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37431(VarNext)
       => ( v37385(VarNext)
        <=> v37385(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_441,axiom,
    ! [VarNext: state_type] :
      ( v37431(VarNext)
     => ( v37385(VarNext)
      <=> v37441(VarNext) ) ) ).

tff(addAssignment_18622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37441(VarNext)
      <=> v37439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3628,axiom,
    ! [VarCurr: state_type] :
      ( v37439(VarCurr)
    <=> ( v37442(VarCurr)
        & v37443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3627,axiom,
    ! [VarCurr: state_type] :
      ( v37443(VarCurr)
    <=> ( v37391(VarCurr)
        | v37422(VarCurr) ) ) ).

tff(writeUnaryOperator_2234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37442(VarCurr)
    <=> v37387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37431(VarNext)
      <=> v37432(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37432(VarNext)
      <=> ( v37434(VarNext)
          & v37436(VarNext) ) ) ) ).

tff(writeUnaryOperator_2233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37436(VarCurr)
    <=> v37379(VarCurr) ) ).

tff(addAssignment_18621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37434(VarNext)
      <=> v37379(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_151,axiom,
    ( v37385(constB0)
  <=> $true ) ).

tff(addAssignment_18620,axiom,
    ! [VarCurr: state_type] :
      ( v37422(VarCurr)
    <=> v37424(VarCurr) ) ).

tff(addAssignment_18619,axiom,
    ! [VarCurr: state_type] :
      ( v37424(VarCurr)
    <=> v37426(VarCurr) ) ).

tff(addAssignment_18618,axiom,
    ! [VarCurr: state_type] :
      ( v37426(VarCurr)
    <=> v37428(VarCurr) ) ).

tff(addAssignment_18617,axiom,
    ! [VarCurr: state_type] :
      ( v37428(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_18616,axiom,
    ! [VarCurr: state_type] :
      ( v37391(VarCurr)
    <=> v37393(VarCurr) ) ).

tff(addAssignment_18615,axiom,
    ! [VarCurr: state_type] :
      ( v37393(VarCurr)
    <=> v37395(VarCurr) ) ).

tff(addAssignment_18614,axiom,
    ! [VarCurr: state_type] :
      ( v37395(VarCurr)
    <=> v37397(VarCurr) ) ).

tff(addAssignment_18613,axiom,
    ! [VarCurr: state_type] :
      ( v37397(VarCurr)
    <=> v37399(VarCurr) ) ).

tff(writeUnaryOperator_2232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37399(VarCurr)
    <=> v37419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3624,axiom,
    ! [VarCurr: state_type] :
      ( v37419(VarCurr)
    <=> ( v37420(VarCurr)
        | v37415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3623,axiom,
    ! [VarCurr: state_type] :
      ( v37420(VarCurr)
    <=> ( v37401(VarCurr)
        | v37411(VarCurr) ) ) ).

tff(addAssignment_18612,axiom,
    ! [VarCurr: state_type] :
      ( v37415(VarCurr)
    <=> v37417(VarCurr) ) ).

tff(addAssignment_18611,axiom,
    ! [VarCurr: state_type] :
      ( v37417(VarCurr)
    <=> v37405(VarCurr,2) ) ).

tff(addAssignment_18610,axiom,
    ! [VarCurr: state_type] :
      ( v37405(VarCurr,2)
    <=> v37407(VarCurr,2) ) ).

tff(addAssignment_18609,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,2)
    <=> v37409(VarCurr,2) ) ).

tff(addAssignment_18608,axiom,
    ! [VarCurr: state_type] :
      ( v37411(VarCurr)
    <=> v37413(VarCurr) ) ).

tff(addAssignment_18607,axiom,
    ! [VarCurr: state_type] :
      ( v37413(VarCurr)
    <=> v37405(VarCurr,1) ) ).

tff(addAssignment_18606,axiom,
    ! [VarCurr: state_type] :
      ( v37405(VarCurr,1)
    <=> v37407(VarCurr,1) ) ).

tff(addAssignment_18605,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,1)
    <=> v37409(VarCurr,1) ) ).

tff(addAssignment_18604,axiom,
    ! [VarCurr: state_type] :
      ( v37401(VarCurr)
    <=> v37403(VarCurr) ) ).

tff(addAssignment_18603,axiom,
    ! [VarCurr: state_type] :
      ( v37403(VarCurr)
    <=> v37405(VarCurr,0) ) ).

tff(addAssignment_18602,axiom,
    ! [VarCurr: state_type] :
      ( v37405(VarCurr,0)
    <=> v37407(VarCurr,0) ) ).

tff(addAssignment_18601,axiom,
    ! [VarCurr: state_type] :
      ( v37407(VarCurr,0)
    <=> v37409(VarCurr,0) ) ).

tff(addAssignment_18600,axiom,
    ! [VarCurr: state_type] :
      ( v37387(VarCurr)
    <=> v37389(VarCurr) ) ).

tff(addAssignment_18599,axiom,
    ! [VarCurr: state_type] :
      ( v37389(VarCurr)
    <=> $false ) ).

tff(addAssignment_18598,axiom,
    ! [VarCurr: state_type] :
      ( v37379(VarCurr)
    <=> v37381(VarCurr) ) ).

tff(addAssignment_18597,axiom,
    ! [VarCurr: state_type] :
      ( v37381(VarCurr)
    <=> v37383(VarCurr) ) ).

tff(addAssignment_18596,axiom,
    ! [VarCurr: state_type] :
      ( v37383(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_18595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37043(VarCurr,B)
      <=> v37045(VarCurr,B) ) ) ).

tff(addAssignment_18594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37045(VarCurr,B)
      <=> v37047(VarCurr,B) ) ) ).

tff(addAssignment_18593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37047(VarCurr,B)
      <=> v37049(VarCurr,B) ) ) ).

tff(addAssignment_18592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37049(VarCurr,B)
      <=> v37051(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37051(VarCurr,B)
      <=> ( v37053(VarCurr,B)
          & v37075(VarCurr,B) ) ) ) ).

tff(addAssignment_18591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37075(VarCurr,B)
      <=> v37077(VarCurr,B) ) ) ).

tff(addAssignment_18590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37077(VarCurr,B)
      <=> v37079(VarCurr,B) ) ) ).

tff(addAssignment_18589,axiom,
    ! [VarCurr: state_type] :
      ( ( v37079(VarCurr,11)
      <=> v6324(VarCurr,59) )
      & ( v37079(VarCurr,10)
      <=> v6324(VarCurr,58) )
      & ( v37079(VarCurr,9)
      <=> v6324(VarCurr,57) )
      & ( v37079(VarCurr,8)
      <=> v6324(VarCurr,56) )
      & ( v37079(VarCurr,7)
      <=> v6324(VarCurr,55) )
      & ( v37079(VarCurr,6)
      <=> v6324(VarCurr,54) )
      & ( v37079(VarCurr,5)
      <=> v6324(VarCurr,53) )
      & ( v37079(VarCurr,4)
      <=> v6324(VarCurr,52) )
      & ( v37079(VarCurr,3)
      <=> v6324(VarCurr,51) )
      & ( v37079(VarCurr,2)
      <=> v6324(VarCurr,50) )
      & ( v37079(VarCurr,1)
      <=> v6324(VarCurr,49) )
      & ( v37079(VarCurr,0)
      <=> v6324(VarCurr,48) ) ) ).

tff(addAssignment_18588,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,59)
      <=> v37081(VarCurr,11) )
      & ( v6324(VarCurr,58)
      <=> v37081(VarCurr,10) )
      & ( v6324(VarCurr,57)
      <=> v37081(VarCurr,9) )
      & ( v6324(VarCurr,56)
      <=> v37081(VarCurr,8) )
      & ( v6324(VarCurr,55)
      <=> v37081(VarCurr,7) )
      & ( v6324(VarCurr,54)
      <=> v37081(VarCurr,6) )
      & ( v6324(VarCurr,53)
      <=> v37081(VarCurr,5) )
      & ( v6324(VarCurr,52)
      <=> v37081(VarCurr,4) )
      & ( v6324(VarCurr,51)
      <=> v37081(VarCurr,3) )
      & ( v6324(VarCurr,50)
      <=> v37081(VarCurr,2) )
      & ( v6324(VarCurr,49)
      <=> v37081(VarCurr,1) )
      & ( v6324(VarCurr,48)
      <=> v37081(VarCurr,0) ) ) ).

tff(addAssignment_18587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37081(VarCurr,B)
      <=> v37083(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37083(VarCurr,B)
      <=> ( v37365(VarCurr,B)
          | v37368(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37368(VarCurr,B)
      <=> ( v37093(VarCurr,B)
          & v37369(VarCurr,B) ) ) ) ).

tff(addAssignment_18586,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,0)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18585,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,1)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18584,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,2)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18583,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,3)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18582,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,4)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18581,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,5)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18580,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,6)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18579,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,7)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18578,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,8)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18577,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,9)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18576,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,10)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18575,axiom,
    ! [VarCurr: state_type] :
      ( v37369(VarCurr,11)
    <=> v37370(VarCurr) ) ).

tff(addAssignment_18574,axiom,
    ! [VarCurr: state_type] :
      ( v37370(VarCurr)
    <=> v37361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37365(VarCurr,B)
      <=> ( v37085(VarCurr,B)
          & v37366(VarCurr,B) ) ) ) ).

tff(addAssignment_18573,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,0)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18572,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,1)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18571,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,2)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18570,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,3)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18569,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,4)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18568,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,5)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18567,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,6)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18566,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,7)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18565,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,8)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18564,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,9)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18563,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,10)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18562,axiom,
    ! [VarCurr: state_type] :
      ( v37366(VarCurr,11)
    <=> v37367(VarCurr) ) ).

tff(addAssignment_18561,axiom,
    ! [VarCurr: state_type] :
      ( v37367(VarCurr)
    <=> v37089(VarCurr) ) ).

tff(addAssignment_18560,axiom,
    ! [VarCurr: state_type] :
      ( v37361(VarCurr)
    <=> v37363(VarCurr) ) ).

tff(addAssignment_18559,axiom,
    ! [VarCurr: state_type] :
      ( v37363(VarCurr)
    <=> v7021(VarCurr,4) ) ).

tff(addAssignment_18558,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,4)
    <=> v7023(VarCurr,4) ) ).

tff(addAssignment_18557,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,4)
    <=> v6623(VarCurr,4) ) ).

tff(addAssignment_18556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37093(VarCurr,B)
      <=> v37095(VarCurr,B) ) ) ).

tff(addAssignment_18555,axiom,
    ! [VarCurr: state_type] :
      ( ( v37095(VarCurr,11)
      <=> v6334(VarCurr,71) )
      & ( v37095(VarCurr,10)
      <=> v6334(VarCurr,70) )
      & ( v37095(VarCurr,9)
      <=> v6334(VarCurr,69) )
      & ( v37095(VarCurr,8)
      <=> v6334(VarCurr,68) )
      & ( v37095(VarCurr,7)
      <=> v6334(VarCurr,67) )
      & ( v37095(VarCurr,6)
      <=> v6334(VarCurr,66) )
      & ( v37095(VarCurr,5)
      <=> v6334(VarCurr,65) )
      & ( v37095(VarCurr,4)
      <=> v6334(VarCurr,64) )
      & ( v37095(VarCurr,3)
      <=> v6334(VarCurr,63) )
      & ( v37095(VarCurr,2)
      <=> v6334(VarCurr,62) )
      & ( v37095(VarCurr,1)
      <=> v6334(VarCurr,61) )
      & ( v37095(VarCurr,0)
      <=> v6334(VarCurr,60) ) ) ).

tff(addAssignment_18554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,72)
        & ~ $less(B,60) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_18553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,72)
        & ~ $less(B,60) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_18552,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,71)
      <=> v37097(VarCurr,11) )
      & ( v6338(VarCurr,70)
      <=> v37097(VarCurr,10) )
      & ( v6338(VarCurr,69)
      <=> v37097(VarCurr,9) )
      & ( v6338(VarCurr,68)
      <=> v37097(VarCurr,8) )
      & ( v6338(VarCurr,67)
      <=> v37097(VarCurr,7) )
      & ( v6338(VarCurr,66)
      <=> v37097(VarCurr,6) )
      & ( v6338(VarCurr,65)
      <=> v37097(VarCurr,5) )
      & ( v6338(VarCurr,64)
      <=> v37097(VarCurr,4) )
      & ( v6338(VarCurr,63)
      <=> v37097(VarCurr,3) )
      & ( v6338(VarCurr,62)
      <=> v37097(VarCurr,2) )
      & ( v6338(VarCurr,61)
      <=> v37097(VarCurr,1) )
      & ( v6338(VarCurr,60)
      <=> v37097(VarCurr,0) ) ) ).

tff(addAssignment_18551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37097(VarCurr,B)
      <=> v37099(VarCurr,B) ) ) ).

tff(addAssignment_18550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37099(VarCurr,B)
      <=> v37101(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_440,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37344(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v37101(VarNext,B)
            <=> v37101(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_440,axiom,
    ! [VarNext: state_type] :
      ( v37344(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37101(VarNext,B)
          <=> v37354(VarNext,B) ) ) ) ).

tff(addAssignment_18549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37354(VarNext,B)
          <=> v37352(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37355(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37352(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_313,axiom,
    ! [VarCurr: state_type] :
      ( v37355(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v37352(VarCurr,B)
          <=> v37131(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3622,axiom,
    ! [VarCurr: state_type] :
      ( v37355(VarCurr)
    <=> ( v37356(VarCurr)
        & v37357(VarCurr) ) ) ).

tff(writeUnaryOperator_2231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37357(VarCurr)
    <=> v37117(VarCurr) ) ).

tff(writeUnaryOperator_2230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37356(VarCurr)
    <=> v37103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37344(VarNext)
      <=> v37345(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37345(VarNext)
      <=> ( v37346(VarNext)
          & v37319(VarNext) ) ) ) ).

tff(writeUnaryOperator_2229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v37346(VarNext)
      <=> v37348(VarNext) ) ) ).

tff(addAssignment_18548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v37348(VarNext)
      <=> v37319(VarCurr) ) ) ).

tff(addAssignment_18547,axiom,
    ! [VarCurr: state_type] :
      ( v37319(VarCurr)
    <=> v37321(VarCurr) ) ).

tff(addAssignment_18546,axiom,
    ! [VarCurr: state_type] :
      ( v37321(VarCurr)
    <=> v37323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3619,axiom,
    ! [VarCurr: state_type] :
      ( v37323(VarCurr)
    <=> ( v37341(VarCurr)
        | v37333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3618,axiom,
    ! [VarCurr: state_type] :
      ( v37341(VarCurr)
    <=> ( v37325(VarCurr)
        & v37331(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_150,axiom,
    ( v37331(constB0)
  <=> $true ) ).

tff(addAssignment_18545,axiom,
    ! [VarCurr: state_type] :
      ( v37333(VarCurr)
    <=> v37335(VarCurr) ) ).

tff(addAssignment_18544,axiom,
    ! [VarCurr: state_type] :
      ( v37335(VarCurr)
    <=> v37337(VarCurr) ) ).

tff(addAssignment_18543,axiom,
    ! [VarCurr: state_type] :
      ( v37337(VarCurr)
    <=> v37339(VarCurr) ) ).

tff(addAssignment_18542,axiom,
    ! [VarCurr: state_type] :
      ( v37339(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_18541,axiom,
    ! [VarCurr: state_type] :
      ( v37325(VarCurr)
    <=> v37327(VarCurr) ) ).

tff(addAssignment_18540,axiom,
    ! [VarCurr: state_type] :
      ( v37327(VarCurr)
    <=> v37329(VarCurr) ) ).

tff(addAssignment_18539,axiom,
    ! [VarCurr: state_type] :
      ( v37329(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_18538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37131(VarCurr,B)
      <=> v37133(VarCurr,B) ) ) ).

tff(addAssignment_18537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37133(VarCurr,B)
      <=> v37135(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37135(VarCurr,B)
      <=> ( v37304(VarCurr,B)
          | v37315(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37315(VarCurr,B)
      <=> ( v37268(VarCurr,B)
          & v37316(VarCurr,B) ) ) ) ).

tff(addAssignment_18536,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,0)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18535,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,1)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18534,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,2)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18533,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,3)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18532,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,4)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18531,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,5)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18530,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,6)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18529,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,7)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18528,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,8)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18527,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,9)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18526,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,10)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18525,axiom,
    ! [VarCurr: state_type] :
      ( v37316(VarCurr,11)
    <=> v37317(VarCurr) ) ).

tff(addAssignment_18524,axiom,
    ! [VarCurr: state_type] :
      ( v37317(VarCurr)
    <=> v37278(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37304(VarCurr,B)
      <=> ( v37305(VarCurr,B)
          | v37312(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37312(VarCurr,B)
      <=> ( v37232(VarCurr,B)
          & v37313(VarCurr,B) ) ) ) ).

tff(addAssignment_18523,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,0)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18522,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,1)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18521,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,2)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18520,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,3)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18519,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,4)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18518,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,5)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18517,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,6)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18516,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,7)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18515,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,8)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18514,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,9)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18513,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,10)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18512,axiom,
    ! [VarCurr: state_type] :
      ( v37313(VarCurr,11)
    <=> v37314(VarCurr) ) ).

tff(addAssignment_18511,axiom,
    ! [VarCurr: state_type] :
      ( v37314(VarCurr)
    <=> v37242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37305(VarCurr,B)
      <=> ( v37306(VarCurr,B)
          | v37309(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37309(VarCurr,B)
      <=> ( v37185(VarCurr,B)
          & v37310(VarCurr,B) ) ) ) ).

tff(addAssignment_18510,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,0)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18509,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,1)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18508,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,2)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18507,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,3)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18506,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,4)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18505,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,5)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18504,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,6)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18503,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,7)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18502,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,8)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18501,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,9)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18500,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,10)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18499,axiom,
    ! [VarCurr: state_type] :
      ( v37310(VarCurr,11)
    <=> v37311(VarCurr) ) ).

tff(addAssignment_18498,axiom,
    ! [VarCurr: state_type] :
      ( v37311(VarCurr)
    <=> v37195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37306(VarCurr,B)
      <=> ( v37137(VarCurr,B)
          & v37307(VarCurr,B) ) ) ) ).

tff(addAssignment_18497,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,0)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18496,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,1)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18495,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,2)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18494,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,3)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18493,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,4)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18492,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,5)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18491,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,6)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18490,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,7)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18489,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,8)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18488,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,9)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18487,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,10)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18486,axiom,
    ! [VarCurr: state_type] :
      ( v37307(VarCurr,11)
    <=> v37308(VarCurr) ) ).

tff(addAssignment_18485,axiom,
    ! [VarCurr: state_type] :
      ( v37308(VarCurr)
    <=> v37147(VarCurr) ) ).

tff(addAssignment_18484,axiom,
    ! [VarCurr: state_type] :
      ( v37278(VarCurr)
    <=> v37280(VarCurr) ) ).

tff(addAssignment_18483,axiom,
    ! [VarCurr: state_type] :
      ( v37280(VarCurr)
    <=> v37282(VarCurr) ) ).

tff(addAssignment_18482,axiom,
    ! [VarCurr: state_type] :
      ( v37282(VarCurr)
    <=> v37284(VarCurr) ) ).

tff(addAssignment_18481,axiom,
    ! [VarCurr: state_type] :
      ( v37284(VarCurr)
    <=> v37286(VarCurr) ) ).

tff(addAssignment_18480,axiom,
    ! [VarCurr: state_type] :
      ( v37286(VarCurr)
    <=> v37288(VarCurr) ) ).

tff(addAssignment_18479,axiom,
    ! [VarCurr: state_type] :
      ( v37288(VarCurr)
    <=> v37290(VarCurr) ) ).

tff(addAssignment_18478,axiom,
    ! [VarCurr: state_type] :
      ( v37290(VarCurr)
    <=> v37292(VarCurr) ) ).

tff(writeUnaryOperator_2228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37292(VarCurr)
    <=> v37302(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3617,axiom,
    ! [VarCurr: state_type] :
      ( v37302(VarCurr)
    <=> ( v37294(VarCurr)
        | v37298(VarCurr) ) ) ).

tff(addAssignment_18477,axiom,
    ! [VarCurr: state_type] :
      ( v37298(VarCurr)
    <=> v37300(VarCurr) ) ).

tff(addAssignment_18476,axiom,
    ! [VarCurr: state_type] :
      ( v37300(VarCurr)
    <=> v37215(VarCurr,1) ) ).

tff(addAssignment_18475,axiom,
    ! [VarCurr: state_type] :
      ( v37294(VarCurr)
    <=> v37296(VarCurr) ) ).

tff(addAssignment_18474,axiom,
    ! [VarCurr: state_type] :
      ( v37296(VarCurr)
    <=> v37215(VarCurr,0) ) ).

tff(addAssignment_18473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37268(VarCurr,B)
      <=> v37270(VarCurr,B) ) ) ).

tff(addAssignment_18472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37270(VarCurr,B)
      <=> v37272(VarCurr,B) ) ) ).

tff(addAssignment_18471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37272(VarCurr,B)
      <=> v37274(VarCurr,B) ) ) ).

tff(addAssignment_18470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37274(VarCurr,B)
      <=> v37276(VarCurr,B) ) ) ).

tff(addAssignment_18469,axiom,
    ! [VarCurr: state_type] :
      ( v37242(VarCurr)
    <=> v37244(VarCurr) ) ).

tff(addAssignment_18468,axiom,
    ! [VarCurr: state_type] :
      ( v37244(VarCurr)
    <=> v37246(VarCurr) ) ).

tff(addAssignment_18467,axiom,
    ! [VarCurr: state_type] :
      ( v37246(VarCurr)
    <=> v37248(VarCurr) ) ).

tff(addAssignment_18466,axiom,
    ! [VarCurr: state_type] :
      ( v37248(VarCurr)
    <=> v37250(VarCurr) ) ).

tff(addAssignment_18465,axiom,
    ! [VarCurr: state_type] :
      ( v37250(VarCurr)
    <=> v37252(VarCurr) ) ).

tff(addAssignment_18464,axiom,
    ! [VarCurr: state_type] :
      ( v37252(VarCurr)
    <=> v37254(VarCurr) ) ).

tff(addAssignment_18463,axiom,
    ! [VarCurr: state_type] :
      ( v37254(VarCurr)
    <=> v37256(VarCurr) ) ).

tff(writeUnaryOperator_2227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37256(VarCurr)
    <=> v37266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3616,axiom,
    ! [VarCurr: state_type] :
      ( v37266(VarCurr)
    <=> ( v37258(VarCurr)
        | v37262(VarCurr) ) ) ).

tff(addAssignment_18462,axiom,
    ! [VarCurr: state_type] :
      ( v37262(VarCurr)
    <=> v37264(VarCurr) ) ).

tff(addAssignment_18461,axiom,
    ! [VarCurr: state_type] :
      ( v37264(VarCurr)
    <=> v37215(VarCurr,1) ) ).

tff(addAssignment_18460,axiom,
    ! [VarCurr: state_type] :
      ( v37215(VarCurr,1)
    <=> v37217(VarCurr,1) ) ).

tff(addAssignment_18459,axiom,
    ! [VarCurr: state_type] :
      ( v37217(VarCurr,1)
    <=> v37219(VarCurr,1) ) ).

tff(addAssignment_18458,axiom,
    ! [VarCurr: state_type] :
      ( v37219(VarCurr,1)
    <=> v37224(VarCurr,1) ) ).

tff(addAssignment_18457,axiom,
    ! [VarCurr: state_type] :
      ( v37221(VarCurr,1)
    <=> v37223(VarCurr,1) ) ).

tff(addAssignment_18456,axiom,
    ! [VarCurr: state_type] :
      ( v37223(VarCurr,1)
    <=> v37167(VarCurr,1) ) ).

tff(addAssignment_18455,axiom,
    ! [VarCurr: state_type] :
      ( v37258(VarCurr)
    <=> v37260(VarCurr) ) ).

tff(addAssignment_18454,axiom,
    ! [VarCurr: state_type] :
      ( v37260(VarCurr)
    <=> v37167(VarCurr,0) ) ).

tff(addAssignment_18453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37232(VarCurr,B)
      <=> v37234(VarCurr,B) ) ) ).

tff(addAssignment_18452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37234(VarCurr,B)
      <=> v37236(VarCurr,B) ) ) ).

tff(addAssignment_18451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37236(VarCurr,B)
      <=> v37238(VarCurr,B) ) ) ).

tff(addAssignment_18450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37238(VarCurr,B)
      <=> v37240(VarCurr,B) ) ) ).

tff(addAssignment_18449,axiom,
    ! [VarCurr: state_type] :
      ( v37195(VarCurr)
    <=> v37197(VarCurr) ) ).

tff(addAssignment_18448,axiom,
    ! [VarCurr: state_type] :
      ( v37197(VarCurr)
    <=> v37199(VarCurr) ) ).

tff(addAssignment_18447,axiom,
    ! [VarCurr: state_type] :
      ( v37199(VarCurr)
    <=> v37201(VarCurr) ) ).

tff(addAssignment_18446,axiom,
    ! [VarCurr: state_type] :
      ( v37201(VarCurr)
    <=> v37203(VarCurr) ) ).

tff(addAssignment_18445,axiom,
    ! [VarCurr: state_type] :
      ( v37203(VarCurr)
    <=> v37205(VarCurr) ) ).

tff(addAssignment_18444,axiom,
    ! [VarCurr: state_type] :
      ( v37205(VarCurr)
    <=> v37207(VarCurr) ) ).

tff(addAssignment_18443,axiom,
    ! [VarCurr: state_type] :
      ( v37207(VarCurr)
    <=> v37209(VarCurr) ) ).

tff(writeUnaryOperator_2226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37209(VarCurr)
    <=> v37230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3615,axiom,
    ! [VarCurr: state_type] :
      ( v37230(VarCurr)
    <=> ( v37211(VarCurr)
        | v37226(VarCurr) ) ) ).

tff(addAssignment_18442,axiom,
    ! [VarCurr: state_type] :
      ( v37226(VarCurr)
    <=> v37228(VarCurr) ) ).

tff(addAssignment_18441,axiom,
    ! [VarCurr: state_type] :
      ( v37228(VarCurr)
    <=> v37167(VarCurr,1) ) ).

tff(addAssignment_18440,axiom,
    ! [VarCurr: state_type] :
      ( v37211(VarCurr)
    <=> v37213(VarCurr) ) ).

tff(addAssignment_18439,axiom,
    ! [VarCurr: state_type] :
      ( v37213(VarCurr)
    <=> v37215(VarCurr,0) ) ).

tff(addAssignment_18438,axiom,
    ! [VarCurr: state_type] :
      ( v37215(VarCurr,0)
    <=> v37217(VarCurr,0) ) ).

tff(addAssignment_18437,axiom,
    ! [VarCurr: state_type] :
      ( v37217(VarCurr,0)
    <=> v37219(VarCurr,0) ) ).

tff(addAssignment_18436,axiom,
    ! [VarCurr: state_type] :
      ( v37219(VarCurr,0)
    <=> v37224(VarCurr,0) ) ).

tff(writeUnaryOperator_2225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v37224(VarCurr,B)
      <=> ~ v37221(VarCurr,B) ) ) ).

tff(addAssignment_18435,axiom,
    ! [VarCurr: state_type] :
      ( v37221(VarCurr,0)
    <=> v37223(VarCurr,0) ) ).

tff(addAssignment_18434,axiom,
    ! [VarCurr: state_type] :
      ( v37223(VarCurr,0)
    <=> v37167(VarCurr,0) ) ).

tff(addAssignment_18433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37185(VarCurr,B)
      <=> v37187(VarCurr,B) ) ) ).

tff(addAssignment_18432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37187(VarCurr,B)
      <=> v37189(VarCurr,B) ) ) ).

tff(addAssignment_18431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37189(VarCurr,B)
      <=> v37191(VarCurr,B) ) ) ).

tff(addAssignment_18430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37191(VarCurr,B)
      <=> v37193(VarCurr,B) ) ) ).

tff(addAssignment_18429,axiom,
    ! [VarCurr: state_type] :
      ( v37147(VarCurr)
    <=> v37149(VarCurr) ) ).

tff(addAssignment_18428,axiom,
    ! [VarCurr: state_type] :
      ( v37149(VarCurr)
    <=> v37151(VarCurr) ) ).

tff(addAssignment_18427,axiom,
    ! [VarCurr: state_type] :
      ( v37151(VarCurr)
    <=> v37153(VarCurr) ) ).

tff(addAssignment_18426,axiom,
    ! [VarCurr: state_type] :
      ( v37153(VarCurr)
    <=> v37155(VarCurr) ) ).

tff(addAssignment_18425,axiom,
    ! [VarCurr: state_type] :
      ( v37155(VarCurr)
    <=> v37157(VarCurr) ) ).

tff(addAssignment_18424,axiom,
    ! [VarCurr: state_type] :
      ( v37157(VarCurr)
    <=> v37159(VarCurr) ) ).

tff(addAssignment_18423,axiom,
    ! [VarCurr: state_type] :
      ( v37159(VarCurr)
    <=> v37161(VarCurr) ) ).

tff(writeUnaryOperator_2224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v37161(VarCurr)
    <=> v37183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3614,axiom,
    ! [VarCurr: state_type] :
      ( v37183(VarCurr)
    <=> ( v37163(VarCurr)
        | v37179(VarCurr) ) ) ).

tff(addAssignment_18422,axiom,
    ! [VarCurr: state_type] :
      ( v37179(VarCurr)
    <=> v37181(VarCurr) ) ).

tff(addAssignment_18421,axiom,
    ! [VarCurr: state_type] :
      ( v37181(VarCurr)
    <=> v37167(VarCurr,1) ) ).

tff(addAssignment_18420,axiom,
    ! [VarCurr: state_type] :
      ( v37167(VarCurr,1)
    <=> v37169(VarCurr,1) ) ).

tff(addAssignment_18419,axiom,
    ! [VarCurr: state_type] :
      ( v37169(VarCurr,1)
    <=> v37171(VarCurr,1) ) ).

tff(addAssignment_18418,axiom,
    ! [VarCurr: state_type] :
      ( v37171(VarCurr,1)
    <=> v37173(VarCurr,1) ) ).

tff(addAssignment_18417,axiom,
    ! [VarCurr: state_type] :
      ( v37173(VarCurr,1)
    <=> v37175(VarCurr,1) ) ).

tff(addAssignment_18416,axiom,
    ! [VarCurr: state_type] :
      ( v37175(VarCurr,1)
    <=> v37177(VarCurr,1) ) ).

tff(addAssignment_18415,axiom,
    ! [VarCurr: state_type] :
      ( v37163(VarCurr)
    <=> v37165(VarCurr) ) ).

tff(addAssignment_18414,axiom,
    ! [VarCurr: state_type] :
      ( v37165(VarCurr)
    <=> v37167(VarCurr,0) ) ).

tff(addAssignment_18413,axiom,
    ! [VarCurr: state_type] :
      ( v37167(VarCurr,0)
    <=> v37169(VarCurr,0) ) ).

tff(addAssignment_18412,axiom,
    ! [VarCurr: state_type] :
      ( v37169(VarCurr,0)
    <=> v37171(VarCurr,0) ) ).

tff(addAssignment_18411,axiom,
    ! [VarCurr: state_type] :
      ( v37171(VarCurr,0)
    <=> v37173(VarCurr,0) ) ).

tff(addAssignment_18410,axiom,
    ! [VarCurr: state_type] :
      ( v37173(VarCurr,0)
    <=> v37175(VarCurr,0) ) ).

tff(addAssignment_18409,axiom,
    ! [VarCurr: state_type] :
      ( v37175(VarCurr,0)
    <=> v37177(VarCurr,0) ) ).

tff(addAssignment_18408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37137(VarCurr,B)
      <=> v37139(VarCurr,B) ) ) ).

tff(addAssignment_18407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37139(VarCurr,B)
      <=> v37141(VarCurr,B) ) ) ).

tff(addAssignment_18406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37141(VarCurr,B)
      <=> v37143(VarCurr,B) ) ) ).

tff(addAssignment_18405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37143(VarCurr,B)
      <=> v37145(VarCurr,B) ) ) ).

tff(addAssignment_18404,axiom,
    ! [VarCurr: state_type] :
      ( v37117(VarCurr)
    <=> v37119(VarCurr) ) ).

tff(addAssignment_18403,axiom,
    ! [VarCurr: state_type] :
      ( v37119(VarCurr)
    <=> v37121(VarCurr) ) ).

tff(addAssignment_18402,axiom,
    ! [VarCurr: state_type] :
      ( v37121(VarCurr)
    <=> v37123(VarCurr) ) ).

tff(addAssignment_18401,axiom,
    ! [VarCurr: state_type] :
      ( v37123(VarCurr)
    <=> v37125(VarCurr) ) ).

tff(addAssignment_18400,axiom,
    ! [VarCurr: state_type] :
      ( v37125(VarCurr)
    <=> v37127(VarCurr) ) ).

tff(addAssignment_18399,axiom,
    ! [VarCurr: state_type] :
      ( v37127(VarCurr)
    <=> v37129(VarCurr) ) ).

tff(addAssignment_18398,axiom,
    ! [VarCurr: state_type] :
      ( v37129(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_18397,axiom,
    ! [VarCurr: state_type] :
      ( v37103(VarCurr)
    <=> v37105(VarCurr) ) ).

tff(addAssignment_18396,axiom,
    ! [VarCurr: state_type] :
      ( v37105(VarCurr)
    <=> v37107(VarCurr) ) ).

tff(addAssignment_18395,axiom,
    ! [VarCurr: state_type] :
      ( v37107(VarCurr)
    <=> v37109(VarCurr) ) ).

tff(addAssignment_18394,axiom,
    ! [VarCurr: state_type] :
      ( v37109(VarCurr)
    <=> v37111(VarCurr) ) ).

tff(addAssignment_18393,axiom,
    ! [VarCurr: state_type] :
      ( v37111(VarCurr)
    <=> v37113(VarCurr) ) ).

tff(addAssignment_18392,axiom,
    ! [VarCurr: state_type] :
      ( v37113(VarCurr)
    <=> v37115(VarCurr) ) ).

tff(addAssignment_18391,axiom,
    ! [VarCurr: state_type] :
      ( v37115(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_18390,axiom,
    ! [VarCurr: state_type] :
      ( v37089(VarCurr)
    <=> v37091(VarCurr) ) ).

tff(addAssignment_18389,axiom,
    ! [VarCurr: state_type] :
      ( v37091(VarCurr)
    <=> v6617(VarCurr,4) ) ).

tff(addAssignment_18388,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,4)
    <=> v6619(VarCurr,4) ) ).

tff(addAssignment_18387,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,4)
    <=> v6621(VarCurr,4) ) ).

tff(addAssignment_18386,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,4)
    <=> v6747(VarCurr,4) ) ).

tff(addAssignment_18385,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,4)
    <=> v6690(VarCurr,4) ) ).

tff(addAssignment_18384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37085(VarCurr,B)
      <=> v37087(VarCurr,B) ) ) ).

tff(addAssignment_18383,axiom,
    ! [VarCurr: state_type] :
      ( ( v37087(VarCurr,11)
      <=> v6334(VarCurr,59) )
      & ( v37087(VarCurr,10)
      <=> v6334(VarCurr,58) )
      & ( v37087(VarCurr,9)
      <=> v6334(VarCurr,57) )
      & ( v37087(VarCurr,8)
      <=> v6334(VarCurr,56) )
      & ( v37087(VarCurr,7)
      <=> v6334(VarCurr,55) )
      & ( v37087(VarCurr,6)
      <=> v6334(VarCurr,54) )
      & ( v37087(VarCurr,5)
      <=> v6334(VarCurr,53) )
      & ( v37087(VarCurr,4)
      <=> v6334(VarCurr,52) )
      & ( v37087(VarCurr,3)
      <=> v6334(VarCurr,51) )
      & ( v37087(VarCurr,2)
      <=> v6334(VarCurr,50) )
      & ( v37087(VarCurr,1)
      <=> v6334(VarCurr,49) )
      & ( v37087(VarCurr,0)
      <=> v6334(VarCurr,48) ) ) ).

tff(addAssignment_18382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v37053(VarCurr,B)
      <=> v37055(VarCurr,B) ) ) ).

tff(addAssignment_18381,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,0)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18380,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,1)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18379,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,2)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18378,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,3)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18377,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,4)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18376,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,5)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18375,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,6)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18374,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,7)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18373,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,8)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18372,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,9)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18371,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,10)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18370,axiom,
    ! [VarCurr: state_type] :
      ( v37055(VarCurr,11)
    <=> v37073(VarCurr) ) ).

tff(addAssignment_18369,axiom,
    ! [VarCurr: state_type] :
      ( v37073(VarCurr)
    <=> v37057(VarCurr) ) ).

tff(addAssignment_18368,axiom,
    ! [VarCurr: state_type] :
      ( v37057(VarCurr)
    <=> v37059(VarCurr,0) ) ).

tff(addAssignment_18367,axiom,
    ! [VarCurr: state_type] :
      ( v37059(VarCurr,0)
    <=> v37061(VarCurr,0) ) ).

tff(addAssignment_18366,axiom,
    ! [VarCurr: state_type] :
      ( v37061(VarCurr,0)
    <=> v37071(VarCurr,0) ) ).

tff(writeUnaryOperator_2223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v37071(VarCurr,B)
      <=> ~ v37063(VarCurr,B) ) ) ).

tff(addAssignment_18365,axiom,
    ! [VarCurr: state_type] :
      ( v37063(VarCurr,0)
    <=> v37065(VarCurr,0) ) ).

tff(addAssignment_18364,axiom,
    ! [VarCurr: state_type] :
      ( v37065(VarCurr,0)
    <=> v37068(VarCurr,0) ) ).

tff(addAssignment_18363,axiom,
    ! [VarCurr: state_type] :
      ( v37068(VarCurr,0)
    <=> v37067(VarCurr) ) ).

tff(addAssignment_18362,axiom,
    ! [VarCurr: state_type] :
      ( v37068(VarCurr,1)
    <=> v37070(VarCurr) ) ).

tff(addAssignment_18361,axiom,
    ! [VarCurr: state_type] :
      ( v37068(VarCurr,2)
    <=> v37069(VarCurr) ) ).

tff(addAssignment_18360,axiom,
    ! [VarCurr: state_type] :
      ( v37067(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_18359,axiom,
    ! [VarCurr: state_type] :
      ( v37029(VarCurr)
    <=> v37031(VarCurr) ) ).

tff(addAssignment_18358,axiom,
    ! [VarCurr: state_type] :
      ( v37031(VarCurr)
    <=> v37033(VarCurr) ) ).

tff(addAssignment_18357,axiom,
    ! [VarCurr: state_type] :
      ( v37033(VarCurr)
    <=> v37035(VarCurr) ) ).

tff(addAssignment_18356,axiom,
    ! [VarCurr: state_type] :
      ( v37035(VarCurr)
    <=> v37037(VarCurr) ) ).

tff(addAssignment_18355,axiom,
    ! [VarCurr: state_type] :
      ( v37037(VarCurr)
    <=> v37039(VarCurr) ) ).

tff(addAssignment_18354,axiom,
    ! [VarCurr: state_type] :
      ( v37039(VarCurr)
    <=> v37041(VarCurr) ) ).

tff(addAssignment_18353,axiom,
    ! [VarCurr: state_type] :
      ( v37041(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_18352,axiom,
    ! [VarCurr: state_type] :
      ( v37015(VarCurr)
    <=> v37017(VarCurr) ) ).

tff(addAssignment_18351,axiom,
    ! [VarCurr: state_type] :
      ( v37017(VarCurr)
    <=> v37019(VarCurr) ) ).

tff(addAssignment_18350,axiom,
    ! [VarCurr: state_type] :
      ( v37019(VarCurr)
    <=> v37021(VarCurr) ) ).

tff(addAssignment_18349,axiom,
    ! [VarCurr: state_type] :
      ( v37021(VarCurr)
    <=> v37023(VarCurr) ) ).

tff(addAssignment_18348,axiom,
    ! [VarCurr: state_type] :
      ( v37023(VarCurr)
    <=> v37025(VarCurr) ) ).

tff(addAssignment_18347,axiom,
    ! [VarCurr: state_type] :
      ( v37025(VarCurr)
    <=> v37027(VarCurr) ) ).

tff(addAssignment_18346,axiom,
    ! [VarCurr: state_type] :
      ( v37027(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_18345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36991(VarCurr,B)
      <=> v36993(VarCurr,B) ) ) ).

tff(addAssignment_18344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36993(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_18343,axiom,
    ! [VarCurr: state_type] :
      ( v35435(VarCurr)
    <=> v35437(VarCurr) ) ).

tff(addAssignment_18342,axiom,
    ! [VarCurr: state_type] :
      ( v35437(VarCurr)
    <=> v35439(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_206,axiom,
    ! [VarCurr: state_type] :
      ( v35439(VarCurr)
    <=> ( ( v35441(VarCurr,11)
        <=> v35445(VarCurr,11) )
        & ( v35441(VarCurr,10)
        <=> v35445(VarCurr,10) )
        & ( v35441(VarCurr,9)
        <=> v35445(VarCurr,9) )
        & ( v35441(VarCurr,8)
        <=> v35445(VarCurr,8) )
        & ( v35441(VarCurr,7)
        <=> v35445(VarCurr,7) )
        & ( v35441(VarCurr,6)
        <=> v35445(VarCurr,6) )
        & ( v35441(VarCurr,5)
        <=> v35445(VarCurr,5) )
        & ( v35441(VarCurr,4)
        <=> v35445(VarCurr,4) )
        & ( v35441(VarCurr,3)
        <=> v35445(VarCurr,3) )
        & ( v35441(VarCurr,2)
        <=> v35445(VarCurr,2) )
        & ( v35441(VarCurr,1)
        <=> v35445(VarCurr,1) )
        & ( v35441(VarCurr,0)
        <=> v35445(VarCurr,0) ) ) ) ).

tff(addAssignment_18341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35445(VarCurr,B)
      <=> v35447(VarCurr,B) ) ) ).

tff(addAssignment_18340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35447(VarCurr,B)
      <=> v35449(VarCurr,B) ) ) ).

tff(addAssignment_18339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35449(VarCurr,B)
      <=> v35451(VarCurr,B) ) ) ).

tff(addAssignment_18338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35451(VarCurr,B)
      <=> v35453(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_591,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35453(VarCurr,B)
      <=> ( v36961(VarCurr,B)
          | v36980(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36980(VarCurr,B)
      <=> ( v36832(VarCurr,B)
          & v36981(VarCurr,B) ) ) ) ).

tff(addAssignment_18337,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,0)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18336,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,1)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18335,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,2)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18334,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,3)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18333,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,4)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18332,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,5)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18331,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,6)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18330,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,7)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18329,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,8)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18328,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,9)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18327,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,10)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18326,axiom,
    ! [VarCurr: state_type] :
      ( v36981(VarCurr,11)
    <=> v36982(VarCurr) ) ).

tff(addAssignment_18325,axiom,
    ! [VarCurr: state_type] :
      ( v36982(VarCurr)
    <=> v36951(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36961(VarCurr,B)
      <=> ( v36962(VarCurr,B)
          | v36977(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36977(VarCurr,B)
      <=> ( v36681(VarCurr,B)
          & v36978(VarCurr,B) ) ) ) ).

tff(addAssignment_18324,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,0)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18323,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,1)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18322,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,2)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18321,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,3)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18320,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,4)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18319,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,5)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18318,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,6)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18317,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,7)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18316,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,8)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18315,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,9)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18314,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,10)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18313,axiom,
    ! [VarCurr: state_type] :
      ( v36978(VarCurr,11)
    <=> v36979(VarCurr) ) ).

tff(addAssignment_18312,axiom,
    ! [VarCurr: state_type] :
      ( v36979(VarCurr)
    <=> v36801(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36962(VarCurr,B)
      <=> ( v36963(VarCurr,B)
          | v36974(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36974(VarCurr,B)
      <=> ( v36530(VarCurr,B)
          & v36975(VarCurr,B) ) ) ) ).

tff(addAssignment_18311,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,0)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18310,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,1)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18309,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,2)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18308,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,3)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18307,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,4)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18306,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,5)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18305,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,6)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18304,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,7)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18303,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,8)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18302,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,9)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18301,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,10)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18300,axiom,
    ! [VarCurr: state_type] :
      ( v36975(VarCurr,11)
    <=> v36976(VarCurr) ) ).

tff(addAssignment_18299,axiom,
    ! [VarCurr: state_type] :
      ( v36976(VarCurr)
    <=> v36650(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36963(VarCurr,B)
      <=> ( v36964(VarCurr,B)
          | v36971(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36971(VarCurr,B)
      <=> ( v36379(VarCurr,B)
          & v36972(VarCurr,B) ) ) ) ).

tff(addAssignment_18298,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,0)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18297,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,1)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18296,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,2)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18295,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,3)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18294,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,4)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18293,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,5)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18292,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,6)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18291,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,7)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18290,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,8)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18289,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,9)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18288,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,10)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18287,axiom,
    ! [VarCurr: state_type] :
      ( v36972(VarCurr,11)
    <=> v36973(VarCurr) ) ).

tff(addAssignment_18286,axiom,
    ! [VarCurr: state_type] :
      ( v36973(VarCurr)
    <=> v36499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36964(VarCurr,B)
      <=> ( v36965(VarCurr,B)
          | v36968(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36968(VarCurr,B)
      <=> ( v36217(VarCurr,B)
          & v36969(VarCurr,B) ) ) ) ).

tff(addAssignment_18285,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,0)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18284,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,1)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18283,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,2)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18282,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,3)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18281,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,4)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18280,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,5)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18279,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,6)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18278,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,7)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18277,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,8)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18276,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,9)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18275,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,10)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18274,axiom,
    ! [VarCurr: state_type] :
      ( v36969(VarCurr,11)
    <=> v36970(VarCurr) ) ).

tff(addAssignment_18273,axiom,
    ! [VarCurr: state_type] :
      ( v36970(VarCurr)
    <=> v36348(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36965(VarCurr,B)
      <=> ( v35455(VarCurr,B)
          & v36966(VarCurr,B) ) ) ) ).

tff(addAssignment_18272,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,0)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18271,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,1)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18270,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,2)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18269,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,3)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18268,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,4)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18267,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,5)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18266,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,6)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18265,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,7)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18264,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,8)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18263,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,9)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18262,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,10)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18261,axiom,
    ! [VarCurr: state_type] :
      ( v36966(VarCurr,11)
    <=> v36967(VarCurr) ) ).

tff(addAssignment_18260,axiom,
    ! [VarCurr: state_type] :
      ( v36967(VarCurr)
    <=> v35925(VarCurr) ) ).

tff(addAssignment_18259,axiom,
    ! [VarCurr: state_type] :
      ( v36951(VarCurr)
    <=> v36953(VarCurr) ) ).

tff(addAssignment_18258,axiom,
    ! [VarCurr: state_type] :
      ( v36953(VarCurr)
    <=> v36955(VarCurr) ) ).

tff(addAssignment_18257,axiom,
    ! [VarCurr: state_type] :
      ( v36955(VarCurr)
    <=> v36957(VarCurr) ) ).

tff(addAssignment_18256,axiom,
    ! [VarCurr: state_type] :
      ( v36957(VarCurr)
    <=> v36959(VarCurr) ) ).

tff(addAssignment_18255,axiom,
    ! [VarCurr: state_type] :
      ( v36959(VarCurr)
    <=> v36018(VarCurr) ) ).

tff(addAssignment_18254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36832(VarCurr,B)
      <=> v36834(VarCurr,B) ) ) ).

tff(addAssignment_18253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36834(VarCurr,B)
      <=> v36836(VarCurr,B) ) ) ).

tff(addAssignment_18252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36836(VarCurr,B)
      <=> v36838(VarCurr,B) ) ) ).

tff(addAssignment_18251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36838(VarCurr,B)
      <=> v36840(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36934(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v36840(VarNext,B)
            <=> v36840(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_439,axiom,
    ! [VarNext: state_type] :
      ( v36934(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36840(VarNext,B)
          <=> v36944(VarNext,B) ) ) ) ).

tff(addAssignment_18250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36944(VarNext,B)
          <=> v36942(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36945(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36942(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_312,axiom,
    ! [VarCurr: state_type] :
      ( v36945(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36942(VarCurr,B)
          <=> v36862(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3613,axiom,
    ! [VarCurr: state_type] :
      ( v36945(VarCurr)
    <=> ( v36946(VarCurr)
        & v36947(VarCurr) ) ) ).

tff(writeUnaryOperator_2222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36947(VarCurr)
    <=> v36852(VarCurr) ) ).

tff(writeUnaryOperator_2221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36946(VarCurr)
    <=> v36842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36934(VarNext)
      <=> v36935(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36935(VarNext)
      <=> ( v36936(VarNext)
          & v36866(VarNext) ) ) ) ).

tff(writeUnaryOperator_2220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36936(VarNext)
      <=> v36938(VarNext) ) ) ).

tff(addAssignment_18249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36938(VarNext)
      <=> v36866(VarCurr) ) ) ).

tff(addAssignment_18248,axiom,
    ! [VarCurr: state_type] :
      ( v36866(VarCurr)
    <=> v36868(VarCurr) ) ).

tff(addAssignment_18247,axiom,
    ! [VarCurr: state_type] :
      ( v36868(VarCurr)
    <=> v36870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3610,axiom,
    ! [VarCurr: state_type] :
      ( v36870(VarCurr)
    <=> ( v36931(VarCurr)
        | v36927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3609,axiom,
    ! [VarCurr: state_type] :
      ( v36931(VarCurr)
    <=> ( v36872(VarCurr)
        & v36876(VarCurr) ) ) ).

tff(addAssignment_18246,axiom,
    ! [VarCurr: state_type] :
      ( v36927(VarCurr)
    <=> v36929(VarCurr) ) ).

tff(addAssignment_18245,axiom,
    ! [VarCurr: state_type] :
      ( v36929(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36911(VarNext)
       => ( v36876(VarNext)
        <=> v36876(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_438,axiom,
    ! [VarNext: state_type] :
      ( v36911(VarNext)
     => ( v36876(VarNext)
      <=> v36921(VarNext) ) ) ).

tff(addAssignment_18244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36921(VarNext)
      <=> v36919(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3608,axiom,
    ! [VarCurr: state_type] :
      ( v36919(VarCurr)
    <=> ( v36922(VarCurr)
        & v36923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3607,axiom,
    ! [VarCurr: state_type] :
      ( v36923(VarCurr)
    <=> ( v36882(VarCurr)
        | v36906(VarCurr) ) ) ).

tff(writeUnaryOperator_2219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36922(VarCurr)
    <=> v36878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36911(VarNext)
      <=> v36912(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36912(VarNext)
      <=> ( v36914(VarNext)
          & v36916(VarNext) ) ) ) ).

tff(writeUnaryOperator_2218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36916(VarCurr)
    <=> v36872(VarCurr) ) ).

tff(addAssignment_18243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36914(VarNext)
      <=> v36872(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_149,axiom,
    ( v36876(constB0)
  <=> $true ) ).

tff(addAssignment_18242,axiom,
    ! [VarCurr: state_type] :
      ( v36906(VarCurr)
    <=> v36908(VarCurr) ) ).

tff(addAssignment_18241,axiom,
    ! [VarCurr: state_type] :
      ( v36908(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_18240,axiom,
    ! [VarCurr: state_type] :
      ( v36882(VarCurr)
    <=> v36884(VarCurr) ) ).

tff(addAssignment_18239,axiom,
    ! [VarCurr: state_type] :
      ( v36884(VarCurr)
    <=> v36192(VarCurr) ) ).

tff(addAssignment_18238,axiom,
    ! [VarCurr: state_type] :
      ( v36192(VarCurr)
    <=> v36887(VarCurr) ) ).

tff(addAssignment_18237,axiom,
    ! [VarCurr: state_type] :
      ( v36887(VarCurr)
    <=> v36889(VarCurr) ) ).

tff(writeUnaryOperator_2217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36889(VarCurr)
    <=> v36903(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3604,axiom,
    ! [VarCurr: state_type] :
      ( v36903(VarCurr)
    <=> ( v36904(VarCurr)
        | v36899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3603,axiom,
    ! [VarCurr: state_type] :
      ( v36904(VarCurr)
    <=> ( v36891(VarCurr)
        | v36895(VarCurr) ) ) ).

tff(addAssignment_18236,axiom,
    ! [VarCurr: state_type] :
      ( v36899(VarCurr)
    <=> v36901(VarCurr) ) ).

tff(addAssignment_18235,axiom,
    ! [VarCurr: state_type] :
      ( v36901(VarCurr)
    <=> v36281(VarCurr,2) ) ).

tff(addAssignment_18234,axiom,
    ! [VarCurr: state_type] :
      ( v36895(VarCurr)
    <=> v36897(VarCurr) ) ).

tff(addAssignment_18233,axiom,
    ! [VarCurr: state_type] :
      ( v36897(VarCurr)
    <=> v35855(VarCurr,1) ) ).

tff(addAssignment_18232,axiom,
    ! [VarCurr: state_type] :
      ( v36891(VarCurr)
    <=> v36893(VarCurr) ) ).

tff(addAssignment_18231,axiom,
    ! [VarCurr: state_type] :
      ( v36893(VarCurr)
    <=> v36281(VarCurr,0) ) ).

tff(addAssignment_18230,axiom,
    ! [VarCurr: state_type] :
      ( v36878(VarCurr)
    <=> v36880(VarCurr) ) ).

tff(addAssignment_18229,axiom,
    ! [VarCurr: state_type] :
      ( v36880(VarCurr)
    <=> $false ) ).

tff(addAssignment_18228,axiom,
    ! [VarCurr: state_type] :
      ( v36872(VarCurr)
    <=> v36874(VarCurr) ) ).

tff(addAssignment_18227,axiom,
    ! [VarCurr: state_type] :
      ( v36874(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_18226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36862(VarCurr,B)
      <=> v36864(VarCurr,B) ) ) ).

tff(addAssignment_18225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36864(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_18224,axiom,
    ! [VarCurr: state_type] :
      ( v36852(VarCurr)
    <=> v36854(VarCurr) ) ).

tff(addAssignment_18223,axiom,
    ! [VarCurr: state_type] :
      ( v36854(VarCurr)
    <=> v36856(VarCurr) ) ).

tff(addAssignment_18222,axiom,
    ! [VarCurr: state_type] :
      ( v36856(VarCurr)
    <=> v36858(VarCurr) ) ).

tff(addAssignment_18221,axiom,
    ! [VarCurr: state_type] :
      ( v36858(VarCurr)
    <=> v36860(VarCurr) ) ).

tff(addAssignment_18220,axiom,
    ! [VarCurr: state_type] :
      ( v36860(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_18219,axiom,
    ! [VarCurr: state_type] :
      ( v36842(VarCurr)
    <=> v36844(VarCurr) ) ).

tff(addAssignment_18218,axiom,
    ! [VarCurr: state_type] :
      ( v36844(VarCurr)
    <=> v36846(VarCurr) ) ).

tff(addAssignment_18217,axiom,
    ! [VarCurr: state_type] :
      ( v36846(VarCurr)
    <=> v36848(VarCurr) ) ).

tff(addAssignment_18216,axiom,
    ! [VarCurr: state_type] :
      ( v36848(VarCurr)
    <=> v36850(VarCurr) ) ).

tff(addAssignment_18215,axiom,
    ! [VarCurr: state_type] :
      ( v36850(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_18214,axiom,
    ! [VarCurr: state_type] :
      ( v36801(VarCurr)
    <=> v36803(VarCurr) ) ).

tff(addAssignment_18213,axiom,
    ! [VarCurr: state_type] :
      ( v36803(VarCurr)
    <=> v36805(VarCurr) ) ).

tff(addAssignment_18212,axiom,
    ! [VarCurr: state_type] :
      ( v36805(VarCurr)
    <=> v36807(VarCurr) ) ).

tff(addAssignment_18211,axiom,
    ! [VarCurr: state_type] :
      ( v36807(VarCurr)
    <=> v36809(VarCurr) ) ).

tff(addAssignment_18210,axiom,
    ! [VarCurr: state_type] :
      ( v36809(VarCurr)
    <=> v36811(VarCurr) ) ).

tff(addAssignment_18209,axiom,
    ! [VarCurr: state_type] :
      ( v36811(VarCurr)
    <=> v36813(VarCurr) ) ).

tff(addAssignment_18208,axiom,
    ! [VarCurr: state_type] :
      ( v36813(VarCurr)
    <=> v36815(VarCurr) ) ).

tff(writeUnaryOperator_2216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36815(VarCurr)
    <=> v36829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3602,axiom,
    ! [VarCurr: state_type] :
      ( v36829(VarCurr)
    <=> ( v36830(VarCurr)
        | v36825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3601,axiom,
    ! [VarCurr: state_type] :
      ( v36830(VarCurr)
    <=> ( v36817(VarCurr)
        | v36821(VarCurr) ) ) ).

tff(addAssignment_18207,axiom,
    ! [VarCurr: state_type] :
      ( v36825(VarCurr)
    <=> v36827(VarCurr) ) ).

tff(addAssignment_18206,axiom,
    ! [VarCurr: state_type] :
      ( v36827(VarCurr)
    <=> v36028(VarCurr,2) ) ).

tff(addAssignment_18205,axiom,
    ! [VarCurr: state_type] :
      ( v36821(VarCurr)
    <=> v36823(VarCurr) ) ).

tff(addAssignment_18204,axiom,
    ! [VarCurr: state_type] :
      ( v36823(VarCurr)
    <=> v35945(VarCurr,1) ) ).

tff(addAssignment_18203,axiom,
    ! [VarCurr: state_type] :
      ( v36817(VarCurr)
    <=> v36819(VarCurr) ) ).

tff(addAssignment_18202,axiom,
    ! [VarCurr: state_type] :
      ( v36819(VarCurr)
    <=> v35945(VarCurr,0) ) ).

tff(addAssignment_18201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36681(VarCurr,B)
      <=> v36683(VarCurr,B) ) ) ).

tff(addAssignment_18200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36683(VarCurr,B)
      <=> v36685(VarCurr,B) ) ) ).

tff(addAssignment_18199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36685(VarCurr,B)
      <=> v36687(VarCurr,B) ) ) ).

tff(addAssignment_18198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36687(VarCurr,B)
      <=> v36689(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36784(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v36689(VarNext,B)
            <=> v36689(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_437,axiom,
    ! [VarNext: state_type] :
      ( v36784(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36689(VarNext,B)
          <=> v36794(VarNext,B) ) ) ) ).

tff(addAssignment_18197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36794(VarNext,B)
          <=> v36792(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36792(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_311,axiom,
    ! [VarCurr: state_type] :
      ( v36795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36792(VarCurr,B)
          <=> v36711(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3600,axiom,
    ! [VarCurr: state_type] :
      ( v36795(VarCurr)
    <=> ( v36796(VarCurr)
        & v36797(VarCurr) ) ) ).

tff(writeUnaryOperator_2215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36797(VarCurr)
    <=> v36701(VarCurr) ) ).

tff(writeUnaryOperator_2214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36796(VarCurr)
    <=> v36691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36784(VarNext)
      <=> v36785(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36785(VarNext)
      <=> ( v36786(VarNext)
          & v36715(VarNext) ) ) ) ).

tff(writeUnaryOperator_2213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36786(VarNext)
      <=> v36788(VarNext) ) ) ).

tff(addAssignment_18196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36788(VarNext)
      <=> v36715(VarCurr) ) ) ).

tff(addAssignment_18195,axiom,
    ! [VarCurr: state_type] :
      ( v36715(VarCurr)
    <=> v36717(VarCurr) ) ).

tff(addAssignment_18194,axiom,
    ! [VarCurr: state_type] :
      ( v36717(VarCurr)
    <=> v36719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3597,axiom,
    ! [VarCurr: state_type] :
      ( v36719(VarCurr)
    <=> ( v36781(VarCurr)
        | v36777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3596,axiom,
    ! [VarCurr: state_type] :
      ( v36781(VarCurr)
    <=> ( v36721(VarCurr)
        & v36725(VarCurr) ) ) ).

tff(addAssignment_18193,axiom,
    ! [VarCurr: state_type] :
      ( v36777(VarCurr)
    <=> v36779(VarCurr) ) ).

tff(addAssignment_18192,axiom,
    ! [VarCurr: state_type] :
      ( v36779(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36761(VarNext)
       => ( v36725(VarNext)
        <=> v36725(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_436,axiom,
    ! [VarNext: state_type] :
      ( v36761(VarNext)
     => ( v36725(VarNext)
      <=> v36771(VarNext) ) ) ).

tff(addAssignment_18191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36771(VarNext)
      <=> v36769(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3595,axiom,
    ! [VarCurr: state_type] :
      ( v36769(VarCurr)
    <=> ( v36772(VarCurr)
        & v36773(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3594,axiom,
    ! [VarCurr: state_type] :
      ( v36773(VarCurr)
    <=> ( v36731(VarCurr)
        | v36756(VarCurr) ) ) ).

tff(writeUnaryOperator_2212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36772(VarCurr)
    <=> v36727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3593,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36761(VarNext)
      <=> v36762(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3592,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36762(VarNext)
      <=> ( v36764(VarNext)
          & v36766(VarNext) ) ) ) ).

tff(writeUnaryOperator_2211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36766(VarCurr)
    <=> v36721(VarCurr) ) ).

tff(addAssignment_18190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36764(VarNext)
      <=> v36721(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_148,axiom,
    ( v36725(constB0)
  <=> $true ) ).

tff(addAssignment_18189,axiom,
    ! [VarCurr: state_type] :
      ( v36756(VarCurr)
    <=> v36758(VarCurr) ) ).

tff(addAssignment_18188,axiom,
    ! [VarCurr: state_type] :
      ( v36758(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_18187,axiom,
    ! [VarCurr: state_type] :
      ( v36731(VarCurr)
    <=> v36733(VarCurr) ) ).

tff(addAssignment_18186,axiom,
    ! [VarCurr: state_type] :
      ( v36733(VarCurr)
    <=> v36735(VarCurr) ) ).

tff(addAssignment_18185,axiom,
    ! [VarCurr: state_type] :
      ( v36735(VarCurr)
    <=> v36737(VarCurr) ) ).

tff(addAssignment_18184,axiom,
    ! [VarCurr: state_type] :
      ( v36737(VarCurr)
    <=> v36739(VarCurr) ) ).

tff(writeUnaryOperator_2210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36739(VarCurr)
    <=> v36753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3591,axiom,
    ! [VarCurr: state_type] :
      ( v36753(VarCurr)
    <=> ( v36754(VarCurr)
        | v36749(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3590,axiom,
    ! [VarCurr: state_type] :
      ( v36754(VarCurr)
    <=> ( v36741(VarCurr)
        | v36745(VarCurr) ) ) ).

tff(addAssignment_18183,axiom,
    ! [VarCurr: state_type] :
      ( v36749(VarCurr)
    <=> v36751(VarCurr) ) ).

tff(addAssignment_18182,axiom,
    ! [VarCurr: state_type] :
      ( v36751(VarCurr)
    <=> v36281(VarCurr,2) ) ).

tff(addAssignment_18181,axiom,
    ! [VarCurr: state_type] :
      ( v36281(VarCurr,2)
    <=> v36283(VarCurr,2) ) ).

tff(addAssignment_18180,axiom,
    ! [VarCurr: state_type] :
      ( v36283(VarCurr,2)
    <=> v36285(VarCurr,2) ) ).

tff(addAssignment_18179,axiom,
    ! [VarCurr: state_type] :
      ( v36285(VarCurr,2)
    <=> v36290(VarCurr,2) ) ).

tff(addAssignment_18178,axiom,
    ! [VarCurr: state_type] :
      ( v36287(VarCurr,2)
    <=> v36289(VarCurr,2) ) ).

tff(addAssignment_18177,axiom,
    ! [VarCurr: state_type] :
      ( v36289(VarCurr,2)
    <=> v35855(VarCurr,2) ) ).

tff(addAssignment_18176,axiom,
    ! [VarCurr: state_type] :
      ( v36745(VarCurr)
    <=> v36747(VarCurr) ) ).

tff(addAssignment_18175,axiom,
    ! [VarCurr: state_type] :
      ( v36747(VarCurr)
    <=> v35855(VarCurr,1) ) ).

tff(addAssignment_18174,axiom,
    ! [VarCurr: state_type] :
      ( v36741(VarCurr)
    <=> v36743(VarCurr) ) ).

tff(addAssignment_18173,axiom,
    ! [VarCurr: state_type] :
      ( v36743(VarCurr)
    <=> v35855(VarCurr,0) ) ).

tff(addAssignment_18172,axiom,
    ! [VarCurr: state_type] :
      ( v36727(VarCurr)
    <=> v36729(VarCurr) ) ).

tff(addAssignment_18171,axiom,
    ! [VarCurr: state_type] :
      ( v36729(VarCurr)
    <=> $false ) ).

tff(addAssignment_18170,axiom,
    ! [VarCurr: state_type] :
      ( v36721(VarCurr)
    <=> v36723(VarCurr) ) ).

tff(addAssignment_18169,axiom,
    ! [VarCurr: state_type] :
      ( v36723(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_18168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36711(VarCurr,B)
      <=> v36713(VarCurr,B) ) ) ).

tff(addAssignment_18167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36713(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_18166,axiom,
    ! [VarCurr: state_type] :
      ( v36701(VarCurr)
    <=> v36703(VarCurr) ) ).

tff(addAssignment_18165,axiom,
    ! [VarCurr: state_type] :
      ( v36703(VarCurr)
    <=> v36705(VarCurr) ) ).

tff(addAssignment_18164,axiom,
    ! [VarCurr: state_type] :
      ( v36705(VarCurr)
    <=> v36707(VarCurr) ) ).

tff(addAssignment_18163,axiom,
    ! [VarCurr: state_type] :
      ( v36707(VarCurr)
    <=> v36709(VarCurr) ) ).

tff(addAssignment_18162,axiom,
    ! [VarCurr: state_type] :
      ( v36709(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_18161,axiom,
    ! [VarCurr: state_type] :
      ( v36691(VarCurr)
    <=> v36693(VarCurr) ) ).

tff(addAssignment_18160,axiom,
    ! [VarCurr: state_type] :
      ( v36693(VarCurr)
    <=> v36695(VarCurr) ) ).

tff(addAssignment_18159,axiom,
    ! [VarCurr: state_type] :
      ( v36695(VarCurr)
    <=> v36697(VarCurr) ) ).

tff(addAssignment_18158,axiom,
    ! [VarCurr: state_type] :
      ( v36697(VarCurr)
    <=> v36699(VarCurr) ) ).

tff(addAssignment_18157,axiom,
    ! [VarCurr: state_type] :
      ( v36699(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_18156,axiom,
    ! [VarCurr: state_type] :
      ( v36650(VarCurr)
    <=> v36652(VarCurr) ) ).

tff(addAssignment_18155,axiom,
    ! [VarCurr: state_type] :
      ( v36652(VarCurr)
    <=> v36654(VarCurr) ) ).

tff(addAssignment_18154,axiom,
    ! [VarCurr: state_type] :
      ( v36654(VarCurr)
    <=> v36656(VarCurr) ) ).

tff(addAssignment_18153,axiom,
    ! [VarCurr: state_type] :
      ( v36656(VarCurr)
    <=> v36658(VarCurr) ) ).

tff(addAssignment_18152,axiom,
    ! [VarCurr: state_type] :
      ( v36658(VarCurr)
    <=> v36660(VarCurr) ) ).

tff(addAssignment_18151,axiom,
    ! [VarCurr: state_type] :
      ( v36660(VarCurr)
    <=> v36662(VarCurr) ) ).

tff(addAssignment_18150,axiom,
    ! [VarCurr: state_type] :
      ( v36662(VarCurr)
    <=> v36664(VarCurr) ) ).

tff(writeUnaryOperator_2209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36664(VarCurr)
    <=> v36678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3589,axiom,
    ! [VarCurr: state_type] :
      ( v36678(VarCurr)
    <=> ( v36679(VarCurr)
        | v36674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3588,axiom,
    ! [VarCurr: state_type] :
      ( v36679(VarCurr)
    <=> ( v36666(VarCurr)
        | v36670(VarCurr) ) ) ).

tff(addAssignment_18149,axiom,
    ! [VarCurr: state_type] :
      ( v36674(VarCurr)
    <=> v36676(VarCurr) ) ).

tff(addAssignment_18148,axiom,
    ! [VarCurr: state_type] :
      ( v36676(VarCurr)
    <=> v35945(VarCurr,2) ) ).

tff(addAssignment_18147,axiom,
    ! [VarCurr: state_type] :
      ( v36670(VarCurr)
    <=> v36672(VarCurr) ) ).

tff(addAssignment_18146,axiom,
    ! [VarCurr: state_type] :
      ( v36672(VarCurr)
    <=> v36028(VarCurr,1) ) ).

tff(addAssignment_18145,axiom,
    ! [VarCurr: state_type] :
      ( v36666(VarCurr)
    <=> v36668(VarCurr) ) ).

tff(addAssignment_18144,axiom,
    ! [VarCurr: state_type] :
      ( v36668(VarCurr)
    <=> v36028(VarCurr,0) ) ).

tff(addAssignment_18143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36530(VarCurr,B)
      <=> v36532(VarCurr,B) ) ) ).

tff(addAssignment_18142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36532(VarCurr,B)
      <=> v36534(VarCurr,B) ) ) ).

tff(addAssignment_18141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36534(VarCurr,B)
      <=> v36536(VarCurr,B) ) ) ).

tff(addAssignment_18140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36536(VarCurr,B)
      <=> v36538(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36633(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v36538(VarNext,B)
            <=> v36538(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_435,axiom,
    ! [VarNext: state_type] :
      ( v36633(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36538(VarNext,B)
          <=> v36643(VarNext,B) ) ) ) ).

tff(addAssignment_18139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36643(VarNext,B)
          <=> v36641(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36644(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36641(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_310,axiom,
    ! [VarCurr: state_type] :
      ( v36644(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36641(VarCurr,B)
          <=> v36560(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3587,axiom,
    ! [VarCurr: state_type] :
      ( v36644(VarCurr)
    <=> ( v36645(VarCurr)
        & v36646(VarCurr) ) ) ).

tff(writeUnaryOperator_2208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36646(VarCurr)
    <=> v36550(VarCurr) ) ).

tff(writeUnaryOperator_2207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36645(VarCurr)
    <=> v36540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3586,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36633(VarNext)
      <=> v36634(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3585,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36634(VarNext)
      <=> ( v36635(VarNext)
          & v36564(VarNext) ) ) ) ).

tff(writeUnaryOperator_2206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36635(VarNext)
      <=> v36637(VarNext) ) ) ).

tff(addAssignment_18138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36637(VarNext)
      <=> v36564(VarCurr) ) ) ).

tff(addAssignment_18137,axiom,
    ! [VarCurr: state_type] :
      ( v36564(VarCurr)
    <=> v36566(VarCurr) ) ).

tff(addAssignment_18136,axiom,
    ! [VarCurr: state_type] :
      ( v36566(VarCurr)
    <=> v36568(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3584,axiom,
    ! [VarCurr: state_type] :
      ( v36568(VarCurr)
    <=> ( v36630(VarCurr)
        | v36626(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3583,axiom,
    ! [VarCurr: state_type] :
      ( v36630(VarCurr)
    <=> ( v36570(VarCurr)
        & v36574(VarCurr) ) ) ).

tff(addAssignment_18135,axiom,
    ! [VarCurr: state_type] :
      ( v36626(VarCurr)
    <=> v36628(VarCurr) ) ).

tff(addAssignment_18134,axiom,
    ! [VarCurr: state_type] :
      ( v36628(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36610(VarNext)
       => ( v36574(VarNext)
        <=> v36574(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_434,axiom,
    ! [VarNext: state_type] :
      ( v36610(VarNext)
     => ( v36574(VarNext)
      <=> v36620(VarNext) ) ) ).

tff(addAssignment_18133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36620(VarNext)
      <=> v36618(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3582,axiom,
    ! [VarCurr: state_type] :
      ( v36618(VarCurr)
    <=> ( v36621(VarCurr)
        & v36622(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3581,axiom,
    ! [VarCurr: state_type] :
      ( v36622(VarCurr)
    <=> ( v36580(VarCurr)
        | v36605(VarCurr) ) ) ).

tff(writeUnaryOperator_2205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36621(VarCurr)
    <=> v36576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36610(VarNext)
      <=> v36611(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36611(VarNext)
      <=> ( v36613(VarNext)
          & v36615(VarNext) ) ) ) ).

tff(writeUnaryOperator_2204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36615(VarCurr)
    <=> v36570(VarCurr) ) ).

tff(addAssignment_18132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36613(VarNext)
      <=> v36570(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_147,axiom,
    ( v36574(constB0)
  <=> $true ) ).

tff(addAssignment_18131,axiom,
    ! [VarCurr: state_type] :
      ( v36605(VarCurr)
    <=> v36607(VarCurr) ) ).

tff(addAssignment_18130,axiom,
    ! [VarCurr: state_type] :
      ( v36607(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_18129,axiom,
    ! [VarCurr: state_type] :
      ( v36580(VarCurr)
    <=> v36582(VarCurr) ) ).

tff(addAssignment_18128,axiom,
    ! [VarCurr: state_type] :
      ( v36582(VarCurr)
    <=> v36584(VarCurr) ) ).

tff(addAssignment_18127,axiom,
    ! [VarCurr: state_type] :
      ( v36584(VarCurr)
    <=> v36586(VarCurr) ) ).

tff(addAssignment_18126,axiom,
    ! [VarCurr: state_type] :
      ( v36586(VarCurr)
    <=> v36588(VarCurr) ) ).

tff(writeUnaryOperator_2203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36588(VarCurr)
    <=> v36602(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3578,axiom,
    ! [VarCurr: state_type] :
      ( v36602(VarCurr)
    <=> ( v36603(VarCurr)
        | v36598(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3577,axiom,
    ! [VarCurr: state_type] :
      ( v36603(VarCurr)
    <=> ( v36590(VarCurr)
        | v36594(VarCurr) ) ) ).

tff(addAssignment_18125,axiom,
    ! [VarCurr: state_type] :
      ( v36598(VarCurr)
    <=> v36600(VarCurr) ) ).

tff(addAssignment_18124,axiom,
    ! [VarCurr: state_type] :
      ( v36600(VarCurr)
    <=> v35855(VarCurr,2) ) ).

tff(addAssignment_18123,axiom,
    ! [VarCurr: state_type] :
      ( v36594(VarCurr)
    <=> v36596(VarCurr) ) ).

tff(addAssignment_18122,axiom,
    ! [VarCurr: state_type] :
      ( v36596(VarCurr)
    <=> v36281(VarCurr,1) ) ).

tff(addAssignment_18121,axiom,
    ! [VarCurr: state_type] :
      ( v36590(VarCurr)
    <=> v36592(VarCurr) ) ).

tff(addAssignment_18120,axiom,
    ! [VarCurr: state_type] :
      ( v36592(VarCurr)
    <=> v36281(VarCurr,0) ) ).

tff(addAssignment_18119,axiom,
    ! [VarCurr: state_type] :
      ( v36576(VarCurr)
    <=> v36578(VarCurr) ) ).

tff(addAssignment_18118,axiom,
    ! [VarCurr: state_type] :
      ( v36578(VarCurr)
    <=> $false ) ).

tff(addAssignment_18117,axiom,
    ! [VarCurr: state_type] :
      ( v36570(VarCurr)
    <=> v36572(VarCurr) ) ).

tff(addAssignment_18116,axiom,
    ! [VarCurr: state_type] :
      ( v36572(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_18115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36560(VarCurr,B)
      <=> v36562(VarCurr,B) ) ) ).

tff(addAssignment_18114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36562(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_18113,axiom,
    ! [VarCurr: state_type] :
      ( v36550(VarCurr)
    <=> v36552(VarCurr) ) ).

tff(addAssignment_18112,axiom,
    ! [VarCurr: state_type] :
      ( v36552(VarCurr)
    <=> v36554(VarCurr) ) ).

tff(addAssignment_18111,axiom,
    ! [VarCurr: state_type] :
      ( v36554(VarCurr)
    <=> v36556(VarCurr) ) ).

tff(addAssignment_18110,axiom,
    ! [VarCurr: state_type] :
      ( v36556(VarCurr)
    <=> v36558(VarCurr) ) ).

tff(addAssignment_18109,axiom,
    ! [VarCurr: state_type] :
      ( v36558(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_18108,axiom,
    ! [VarCurr: state_type] :
      ( v36540(VarCurr)
    <=> v36542(VarCurr) ) ).

tff(addAssignment_18107,axiom,
    ! [VarCurr: state_type] :
      ( v36542(VarCurr)
    <=> v36544(VarCurr) ) ).

tff(addAssignment_18106,axiom,
    ! [VarCurr: state_type] :
      ( v36544(VarCurr)
    <=> v36546(VarCurr) ) ).

tff(addAssignment_18105,axiom,
    ! [VarCurr: state_type] :
      ( v36546(VarCurr)
    <=> v36548(VarCurr) ) ).

tff(addAssignment_18104,axiom,
    ! [VarCurr: state_type] :
      ( v36548(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_18103,axiom,
    ! [VarCurr: state_type] :
      ( v36499(VarCurr)
    <=> v36501(VarCurr) ) ).

tff(addAssignment_18102,axiom,
    ! [VarCurr: state_type] :
      ( v36501(VarCurr)
    <=> v36503(VarCurr) ) ).

tff(addAssignment_18101,axiom,
    ! [VarCurr: state_type] :
      ( v36503(VarCurr)
    <=> v36505(VarCurr) ) ).

tff(addAssignment_18100,axiom,
    ! [VarCurr: state_type] :
      ( v36505(VarCurr)
    <=> v36507(VarCurr) ) ).

tff(addAssignment_18099,axiom,
    ! [VarCurr: state_type] :
      ( v36507(VarCurr)
    <=> v36509(VarCurr) ) ).

tff(addAssignment_18098,axiom,
    ! [VarCurr: state_type] :
      ( v36509(VarCurr)
    <=> v36511(VarCurr) ) ).

tff(addAssignment_18097,axiom,
    ! [VarCurr: state_type] :
      ( v36511(VarCurr)
    <=> v36513(VarCurr) ) ).

tff(writeUnaryOperator_2202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36513(VarCurr)
    <=> v36527(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3576,axiom,
    ! [VarCurr: state_type] :
      ( v36527(VarCurr)
    <=> ( v36528(VarCurr)
        | v36523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3575,axiom,
    ! [VarCurr: state_type] :
      ( v36528(VarCurr)
    <=> ( v36515(VarCurr)
        | v36519(VarCurr) ) ) ).

tff(addAssignment_18096,axiom,
    ! [VarCurr: state_type] :
      ( v36523(VarCurr)
    <=> v36525(VarCurr) ) ).

tff(addAssignment_18095,axiom,
    ! [VarCurr: state_type] :
      ( v36525(VarCurr)
    <=> v35945(VarCurr,2) ) ).

tff(addAssignment_18094,axiom,
    ! [VarCurr: state_type] :
      ( v36519(VarCurr)
    <=> v36521(VarCurr) ) ).

tff(addAssignment_18093,axiom,
    ! [VarCurr: state_type] :
      ( v36521(VarCurr)
    <=> v36028(VarCurr,1) ) ).

tff(addAssignment_18092,axiom,
    ! [VarCurr: state_type] :
      ( v36028(VarCurr,1)
    <=> v36030(VarCurr,1) ) ).

tff(addAssignment_18091,axiom,
    ! [VarCurr: state_type] :
      ( v36030(VarCurr,1)
    <=> v36032(VarCurr,1) ) ).

tff(addAssignment_18090,axiom,
    ! [VarCurr: state_type] :
      ( v36032(VarCurr,1)
    <=> v36037(VarCurr,1) ) ).

tff(addAssignment_18089,axiom,
    ! [VarCurr: state_type] :
      ( v36034(VarCurr,1)
    <=> v36036(VarCurr,1) ) ).

tff(addAssignment_18088,axiom,
    ! [VarCurr: state_type] :
      ( v36036(VarCurr,1)
    <=> v35945(VarCurr,1) ) ).

tff(addAssignment_18087,axiom,
    ! [VarCurr: state_type] :
      ( v36515(VarCurr)
    <=> v36517(VarCurr) ) ).

tff(addAssignment_18086,axiom,
    ! [VarCurr: state_type] :
      ( v36517(VarCurr)
    <=> v35945(VarCurr,0) ) ).

tff(addAssignment_18085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36379(VarCurr,B)
      <=> v36381(VarCurr,B) ) ) ).

tff(addAssignment_18084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36381(VarCurr,B)
      <=> v36383(VarCurr,B) ) ) ).

tff(addAssignment_18083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36383(VarCurr,B)
      <=> v36385(VarCurr,B) ) ) ).

tff(addAssignment_18082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36385(VarCurr,B)
      <=> v36387(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36482(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v36387(VarNext,B)
            <=> v36387(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_433,axiom,
    ! [VarNext: state_type] :
      ( v36482(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36387(VarNext,B)
          <=> v36492(VarNext,B) ) ) ) ).

tff(addAssignment_18081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36492(VarNext,B)
          <=> v36490(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36490(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_309,axiom,
    ! [VarCurr: state_type] :
      ( v36493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36490(VarCurr,B)
          <=> v36409(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3574,axiom,
    ! [VarCurr: state_type] :
      ( v36493(VarCurr)
    <=> ( v36494(VarCurr)
        & v36495(VarCurr) ) ) ).

tff(writeUnaryOperator_2201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36495(VarCurr)
    <=> v36399(VarCurr) ) ).

tff(writeUnaryOperator_2200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36494(VarCurr)
    <=> v36389(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36482(VarNext)
      <=> v36483(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36483(VarNext)
      <=> ( v36484(VarNext)
          & v36413(VarNext) ) ) ) ).

tff(writeUnaryOperator_2199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36484(VarNext)
      <=> v36486(VarNext) ) ) ).

tff(addAssignment_18080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36486(VarNext)
      <=> v36413(VarCurr) ) ) ).

tff(addAssignment_18079,axiom,
    ! [VarCurr: state_type] :
      ( v36413(VarCurr)
    <=> v36415(VarCurr) ) ).

tff(addAssignment_18078,axiom,
    ! [VarCurr: state_type] :
      ( v36415(VarCurr)
    <=> v36417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3571,axiom,
    ! [VarCurr: state_type] :
      ( v36417(VarCurr)
    <=> ( v36479(VarCurr)
        | v36475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3570,axiom,
    ! [VarCurr: state_type] :
      ( v36479(VarCurr)
    <=> ( v36419(VarCurr)
        & v36423(VarCurr) ) ) ).

tff(addAssignment_18077,axiom,
    ! [VarCurr: state_type] :
      ( v36475(VarCurr)
    <=> v36477(VarCurr) ) ).

tff(addAssignment_18076,axiom,
    ! [VarCurr: state_type] :
      ( v36477(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36459(VarNext)
       => ( v36423(VarNext)
        <=> v36423(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_432,axiom,
    ! [VarNext: state_type] :
      ( v36459(VarNext)
     => ( v36423(VarNext)
      <=> v36469(VarNext) ) ) ).

tff(addAssignment_18075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36469(VarNext)
      <=> v36467(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3569,axiom,
    ! [VarCurr: state_type] :
      ( v36467(VarCurr)
    <=> ( v36470(VarCurr)
        & v36471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3568,axiom,
    ! [VarCurr: state_type] :
      ( v36471(VarCurr)
    <=> ( v36429(VarCurr)
        | v36454(VarCurr) ) ) ).

tff(writeUnaryOperator_2198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36470(VarCurr)
    <=> v36425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36459(VarNext)
      <=> v36460(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36460(VarNext)
      <=> ( v36462(VarNext)
          & v36464(VarNext) ) ) ) ).

tff(writeUnaryOperator_2197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36464(VarCurr)
    <=> v36419(VarCurr) ) ).

tff(addAssignment_18074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36462(VarNext)
      <=> v36419(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_146,axiom,
    ( v36423(constB0)
  <=> $true ) ).

tff(addAssignment_18073,axiom,
    ! [VarCurr: state_type] :
      ( v36454(VarCurr)
    <=> v36456(VarCurr) ) ).

tff(addAssignment_18072,axiom,
    ! [VarCurr: state_type] :
      ( v36456(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_18071,axiom,
    ! [VarCurr: state_type] :
      ( v36429(VarCurr)
    <=> v36431(VarCurr) ) ).

tff(addAssignment_18070,axiom,
    ! [VarCurr: state_type] :
      ( v36431(VarCurr)
    <=> v36433(VarCurr) ) ).

tff(addAssignment_18069,axiom,
    ! [VarCurr: state_type] :
      ( v36433(VarCurr)
    <=> v36435(VarCurr) ) ).

tff(addAssignment_18068,axiom,
    ! [VarCurr: state_type] :
      ( v36435(VarCurr)
    <=> v36437(VarCurr) ) ).

tff(writeUnaryOperator_2196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36437(VarCurr)
    <=> v36451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3565,axiom,
    ! [VarCurr: state_type] :
      ( v36451(VarCurr)
    <=> ( v36452(VarCurr)
        | v36447(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3564,axiom,
    ! [VarCurr: state_type] :
      ( v36452(VarCurr)
    <=> ( v36439(VarCurr)
        | v36443(VarCurr) ) ) ).

tff(addAssignment_18067,axiom,
    ! [VarCurr: state_type] :
      ( v36447(VarCurr)
    <=> v36449(VarCurr) ) ).

tff(addAssignment_18066,axiom,
    ! [VarCurr: state_type] :
      ( v36449(VarCurr)
    <=> v35855(VarCurr,2) ) ).

tff(addAssignment_18065,axiom,
    ! [VarCurr: state_type] :
      ( v36443(VarCurr)
    <=> v36445(VarCurr) ) ).

tff(addAssignment_18064,axiom,
    ! [VarCurr: state_type] :
      ( v36445(VarCurr)
    <=> v36281(VarCurr,1) ) ).

tff(addAssignment_18063,axiom,
    ! [VarCurr: state_type] :
      ( v36281(VarCurr,1)
    <=> v36283(VarCurr,1) ) ).

tff(addAssignment_18062,axiom,
    ! [VarCurr: state_type] :
      ( v36283(VarCurr,1)
    <=> v36285(VarCurr,1) ) ).

tff(addAssignment_18061,axiom,
    ! [VarCurr: state_type] :
      ( v36285(VarCurr,1)
    <=> v36290(VarCurr,1) ) ).

tff(addAssignment_18060,axiom,
    ! [VarCurr: state_type] :
      ( v36287(VarCurr,1)
    <=> v36289(VarCurr,1) ) ).

tff(addAssignment_18059,axiom,
    ! [VarCurr: state_type] :
      ( v36289(VarCurr,1)
    <=> v35855(VarCurr,1) ) ).

tff(addAssignment_18058,axiom,
    ! [VarCurr: state_type] :
      ( v36439(VarCurr)
    <=> v36441(VarCurr) ) ).

tff(addAssignment_18057,axiom,
    ! [VarCurr: state_type] :
      ( v36441(VarCurr)
    <=> v35855(VarCurr,0) ) ).

tff(addAssignment_18056,axiom,
    ! [VarCurr: state_type] :
      ( v36425(VarCurr)
    <=> v36427(VarCurr) ) ).

tff(addAssignment_18055,axiom,
    ! [VarCurr: state_type] :
      ( v36427(VarCurr)
    <=> $false ) ).

tff(addAssignment_18054,axiom,
    ! [VarCurr: state_type] :
      ( v36419(VarCurr)
    <=> v36421(VarCurr) ) ).

tff(addAssignment_18053,axiom,
    ! [VarCurr: state_type] :
      ( v36421(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_18052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36409(VarCurr,B)
      <=> v36411(VarCurr,B) ) ) ).

tff(addAssignment_18051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36411(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_18050,axiom,
    ! [VarCurr: state_type] :
      ( v36399(VarCurr)
    <=> v36401(VarCurr) ) ).

tff(addAssignment_18049,axiom,
    ! [VarCurr: state_type] :
      ( v36401(VarCurr)
    <=> v36403(VarCurr) ) ).

tff(addAssignment_18048,axiom,
    ! [VarCurr: state_type] :
      ( v36403(VarCurr)
    <=> v36405(VarCurr) ) ).

tff(addAssignment_18047,axiom,
    ! [VarCurr: state_type] :
      ( v36405(VarCurr)
    <=> v36407(VarCurr) ) ).

tff(addAssignment_18046,axiom,
    ! [VarCurr: state_type] :
      ( v36407(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_18045,axiom,
    ! [VarCurr: state_type] :
      ( v36389(VarCurr)
    <=> v36391(VarCurr) ) ).

tff(addAssignment_18044,axiom,
    ! [VarCurr: state_type] :
      ( v36391(VarCurr)
    <=> v36393(VarCurr) ) ).

tff(addAssignment_18043,axiom,
    ! [VarCurr: state_type] :
      ( v36393(VarCurr)
    <=> v36395(VarCurr) ) ).

tff(addAssignment_18042,axiom,
    ! [VarCurr: state_type] :
      ( v36395(VarCurr)
    <=> v36397(VarCurr) ) ).

tff(addAssignment_18041,axiom,
    ! [VarCurr: state_type] :
      ( v36397(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_18040,axiom,
    ! [VarCurr: state_type] :
      ( v36348(VarCurr)
    <=> v36350(VarCurr) ) ).

tff(addAssignment_18039,axiom,
    ! [VarCurr: state_type] :
      ( v36350(VarCurr)
    <=> v36352(VarCurr) ) ).

tff(addAssignment_18038,axiom,
    ! [VarCurr: state_type] :
      ( v36352(VarCurr)
    <=> v36354(VarCurr) ) ).

tff(addAssignment_18037,axiom,
    ! [VarCurr: state_type] :
      ( v36354(VarCurr)
    <=> v36356(VarCurr) ) ).

tff(addAssignment_18036,axiom,
    ! [VarCurr: state_type] :
      ( v36356(VarCurr)
    <=> v36358(VarCurr) ) ).

tff(addAssignment_18035,axiom,
    ! [VarCurr: state_type] :
      ( v36358(VarCurr)
    <=> v36360(VarCurr) ) ).

tff(addAssignment_18034,axiom,
    ! [VarCurr: state_type] :
      ( v36360(VarCurr)
    <=> v36362(VarCurr) ) ).

tff(writeUnaryOperator_2195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36362(VarCurr)
    <=> v36376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3563,axiom,
    ! [VarCurr: state_type] :
      ( v36376(VarCurr)
    <=> ( v36377(VarCurr)
        | v36372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3562,axiom,
    ! [VarCurr: state_type] :
      ( v36377(VarCurr)
    <=> ( v36364(VarCurr)
        | v36368(VarCurr) ) ) ).

tff(addAssignment_18033,axiom,
    ! [VarCurr: state_type] :
      ( v36372(VarCurr)
    <=> v36374(VarCurr) ) ).

tff(addAssignment_18032,axiom,
    ! [VarCurr: state_type] :
      ( v36374(VarCurr)
    <=> v35945(VarCurr,2) ) ).

tff(addAssignment_18031,axiom,
    ! [VarCurr: state_type] :
      ( v36368(VarCurr)
    <=> v36370(VarCurr) ) ).

tff(addAssignment_18030,axiom,
    ! [VarCurr: state_type] :
      ( v36370(VarCurr)
    <=> v35945(VarCurr,1) ) ).

tff(addAssignment_18029,axiom,
    ! [VarCurr: state_type] :
      ( v36364(VarCurr)
    <=> v36366(VarCurr) ) ).

tff(addAssignment_18028,axiom,
    ! [VarCurr: state_type] :
      ( v36366(VarCurr)
    <=> v36028(VarCurr,0) ) ).

tff(addAssignment_18027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36217(VarCurr,B)
      <=> v36219(VarCurr,B) ) ) ).

tff(addAssignment_18026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36219(VarCurr,B)
      <=> v36221(VarCurr,B) ) ) ).

tff(addAssignment_18025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36221(VarCurr,B)
      <=> v36223(VarCurr,B) ) ) ).

tff(addAssignment_18024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36223(VarCurr,B)
      <=> v36225(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36331(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v36225(VarNext,B)
            <=> v36225(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_431,axiom,
    ! [VarNext: state_type] :
      ( v36331(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36225(VarNext,B)
          <=> v36341(VarNext,B) ) ) ) ).

tff(addAssignment_18023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36341(VarNext,B)
          <=> v36339(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36342(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36339(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_308,axiom,
    ! [VarCurr: state_type] :
      ( v36342(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v36339(VarCurr,B)
          <=> v36247(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3561,axiom,
    ! [VarCurr: state_type] :
      ( v36342(VarCurr)
    <=> ( v36343(VarCurr)
        & v36344(VarCurr) ) ) ).

tff(writeUnaryOperator_2194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36344(VarCurr)
    <=> v36237(VarCurr) ) ).

tff(writeUnaryOperator_2193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36343(VarCurr)
    <=> v36227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36331(VarNext)
      <=> v36332(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36332(VarNext)
      <=> ( v36333(VarNext)
          & v36251(VarNext) ) ) ) ).

tff(writeUnaryOperator_2192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36333(VarNext)
      <=> v36335(VarNext) ) ) ).

tff(addAssignment_18022,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36335(VarNext)
      <=> v36251(VarCurr) ) ) ).

tff(addAssignment_18021,axiom,
    ! [VarCurr: state_type] :
      ( v36251(VarCurr)
    <=> v36253(VarCurr) ) ).

tff(addAssignment_18020,axiom,
    ! [VarCurr: state_type] :
      ( v36253(VarCurr)
    <=> v36255(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3558,axiom,
    ! [VarCurr: state_type] :
      ( v36255(VarCurr)
    <=> ( v36328(VarCurr)
        | v36324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3557,axiom,
    ! [VarCurr: state_type] :
      ( v36328(VarCurr)
    <=> ( v36257(VarCurr)
        & v36261(VarCurr) ) ) ).

tff(addAssignment_18019,axiom,
    ! [VarCurr: state_type] :
      ( v36324(VarCurr)
    <=> v36326(VarCurr) ) ).

tff(addAssignment_18018,axiom,
    ! [VarCurr: state_type] :
      ( v36326(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36308(VarNext)
       => ( v36261(VarNext)
        <=> v36261(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_430,axiom,
    ! [VarNext: state_type] :
      ( v36308(VarNext)
     => ( v36261(VarNext)
      <=> v36318(VarNext) ) ) ).

tff(addAssignment_18017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36318(VarNext)
      <=> v36316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3556,axiom,
    ! [VarCurr: state_type] :
      ( v36316(VarCurr)
    <=> ( v36319(VarCurr)
        & v36320(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3555,axiom,
    ! [VarCurr: state_type] :
      ( v36320(VarCurr)
    <=> ( v36267(VarCurr)
        | v36303(VarCurr) ) ) ).

tff(writeUnaryOperator_2191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36319(VarCurr)
    <=> v36263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36308(VarNext)
      <=> v36309(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36309(VarNext)
      <=> ( v36311(VarNext)
          & v36313(VarNext) ) ) ) ).

tff(writeUnaryOperator_2190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36313(VarCurr)
    <=> v36257(VarCurr) ) ).

tff(addAssignment_18016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36311(VarNext)
      <=> v36257(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_145,axiom,
    ( v36261(constB0)
  <=> $true ) ).

tff(addAssignment_18015,axiom,
    ! [VarCurr: state_type] :
      ( v36303(VarCurr)
    <=> v36305(VarCurr) ) ).

tff(addAssignment_18014,axiom,
    ! [VarCurr: state_type] :
      ( v36305(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_18013,axiom,
    ! [VarCurr: state_type] :
      ( v36267(VarCurr)
    <=> v36269(VarCurr) ) ).

tff(addAssignment_18012,axiom,
    ! [VarCurr: state_type] :
      ( v36269(VarCurr)
    <=> v36271(VarCurr) ) ).

tff(addAssignment_18011,axiom,
    ! [VarCurr: state_type] :
      ( v36271(VarCurr)
    <=> v36273(VarCurr) ) ).

tff(addAssignment_18010,axiom,
    ! [VarCurr: state_type] :
      ( v36273(VarCurr)
    <=> v36275(VarCurr) ) ).

tff(writeUnaryOperator_2189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36275(VarCurr)
    <=> v36300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3552,axiom,
    ! [VarCurr: state_type] :
      ( v36300(VarCurr)
    <=> ( v36301(VarCurr)
        | v36296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3551,axiom,
    ! [VarCurr: state_type] :
      ( v36301(VarCurr)
    <=> ( v36277(VarCurr)
        | v36292(VarCurr) ) ) ).

tff(addAssignment_18009,axiom,
    ! [VarCurr: state_type] :
      ( v36296(VarCurr)
    <=> v36298(VarCurr) ) ).

tff(addAssignment_18008,axiom,
    ! [VarCurr: state_type] :
      ( v36298(VarCurr)
    <=> v35855(VarCurr,2) ) ).

tff(addAssignment_18007,axiom,
    ! [VarCurr: state_type] :
      ( v36292(VarCurr)
    <=> v36294(VarCurr) ) ).

tff(addAssignment_18006,axiom,
    ! [VarCurr: state_type] :
      ( v36294(VarCurr)
    <=> v35855(VarCurr,1) ) ).

tff(addAssignment_18005,axiom,
    ! [VarCurr: state_type] :
      ( v36277(VarCurr)
    <=> v36279(VarCurr) ) ).

tff(addAssignment_18004,axiom,
    ! [VarCurr: state_type] :
      ( v36279(VarCurr)
    <=> v36281(VarCurr,0) ) ).

tff(addAssignment_18003,axiom,
    ! [VarCurr: state_type] :
      ( v36281(VarCurr,0)
    <=> v36283(VarCurr,0) ) ).

tff(addAssignment_18002,axiom,
    ! [VarCurr: state_type] :
      ( v36283(VarCurr,0)
    <=> v36285(VarCurr,0) ) ).

tff(addAssignment_18001,axiom,
    ! [VarCurr: state_type] :
      ( v36285(VarCurr,0)
    <=> v36290(VarCurr,0) ) ).

tff(writeUnaryOperator_2188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v36290(VarCurr,B)
      <=> ~ v36287(VarCurr,B) ) ) ).

tff(addAssignment_18000,axiom,
    ! [VarCurr: state_type] :
      ( v36287(VarCurr,0)
    <=> v36289(VarCurr,0) ) ).

tff(addAssignment_17999,axiom,
    ! [VarCurr: state_type] :
      ( v36289(VarCurr,0)
    <=> v35855(VarCurr,0) ) ).

tff(addAssignment_17998,axiom,
    ! [VarCurr: state_type] :
      ( v36263(VarCurr)
    <=> v36265(VarCurr) ) ).

tff(addAssignment_17997,axiom,
    ! [VarCurr: state_type] :
      ( v36265(VarCurr)
    <=> $false ) ).

tff(addAssignment_17996,axiom,
    ! [VarCurr: state_type] :
      ( v36257(VarCurr)
    <=> v36259(VarCurr) ) ).

tff(addAssignment_17995,axiom,
    ! [VarCurr: state_type] :
      ( v36259(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_17994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36247(VarCurr,B)
      <=> v36249(VarCurr,B) ) ) ).

tff(addAssignment_17993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v36249(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_17992,axiom,
    ! [VarCurr: state_type] :
      ( v36237(VarCurr)
    <=> v36239(VarCurr) ) ).

tff(addAssignment_17991,axiom,
    ! [VarCurr: state_type] :
      ( v36239(VarCurr)
    <=> v36241(VarCurr) ) ).

tff(addAssignment_17990,axiom,
    ! [VarCurr: state_type] :
      ( v36241(VarCurr)
    <=> v36243(VarCurr) ) ).

tff(addAssignment_17989,axiom,
    ! [VarCurr: state_type] :
      ( v36243(VarCurr)
    <=> v36245(VarCurr) ) ).

tff(addAssignment_17988,axiom,
    ! [VarCurr: state_type] :
      ( v36245(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_17987,axiom,
    ! [VarCurr: state_type] :
      ( v36227(VarCurr)
    <=> v36229(VarCurr) ) ).

tff(addAssignment_17986,axiom,
    ! [VarCurr: state_type] :
      ( v36229(VarCurr)
    <=> v36231(VarCurr) ) ).

tff(addAssignment_17985,axiom,
    ! [VarCurr: state_type] :
      ( v36231(VarCurr)
    <=> v36233(VarCurr) ) ).

tff(addAssignment_17984,axiom,
    ! [VarCurr: state_type] :
      ( v36233(VarCurr)
    <=> v36235(VarCurr) ) ).

tff(addAssignment_17983,axiom,
    ! [VarCurr: state_type] :
      ( v36235(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_17982,axiom,
    ! [VarCurr: state_type] :
      ( v35925(VarCurr)
    <=> v35927(VarCurr) ) ).

tff(addAssignment_17981,axiom,
    ! [VarCurr: state_type] :
      ( v35927(VarCurr)
    <=> v35929(VarCurr) ) ).

tff(addAssignment_17980,axiom,
    ! [VarCurr: state_type] :
      ( v35929(VarCurr)
    <=> v35931(VarCurr) ) ).

tff(addAssignment_17979,axiom,
    ! [VarCurr: state_type] :
      ( v35931(VarCurr)
    <=> v35933(VarCurr) ) ).

tff(addAssignment_17978,axiom,
    ! [VarCurr: state_type] :
      ( v35933(VarCurr)
    <=> v35935(VarCurr) ) ).

tff(addAssignment_17977,axiom,
    ! [VarCurr: state_type] :
      ( v35935(VarCurr)
    <=> v35937(VarCurr) ) ).

tff(addAssignment_17976,axiom,
    ! [VarCurr: state_type] :
      ( v35937(VarCurr)
    <=> v35939(VarCurr) ) ).

tff(writeUnaryOperator_2187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35939(VarCurr)
    <=> v36214(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3550,axiom,
    ! [VarCurr: state_type] :
      ( v36214(VarCurr)
    <=> ( v36215(VarCurr)
        | v36210(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3549,axiom,
    ! [VarCurr: state_type] :
      ( v36215(VarCurr)
    <=> ( v35941(VarCurr)
        | v36206(VarCurr) ) ) ).

tff(addAssignment_17975,axiom,
    ! [VarCurr: state_type] :
      ( v36210(VarCurr)
    <=> v36212(VarCurr) ) ).

tff(addAssignment_17974,axiom,
    ! [VarCurr: state_type] :
      ( v36212(VarCurr)
    <=> v35945(VarCurr,2) ) ).

tff(addAssignment_17973,axiom,
    ! [VarCurr: state_type] :
      ( v36206(VarCurr)
    <=> v36208(VarCurr) ) ).

tff(addAssignment_17972,axiom,
    ! [VarCurr: state_type] :
      ( v36208(VarCurr)
    <=> v35945(VarCurr,1) ) ).

tff(addAssignment_17971,axiom,
    ! [VarCurr: state_type] :
      ( v35941(VarCurr)
    <=> v35943(VarCurr) ) ).

tff(addAssignment_17970,axiom,
    ! [VarCurr: state_type] :
      ( v35943(VarCurr)
    <=> v35945(VarCurr,0) ) ).

tff(addAssignment_17969,axiom,
    ! [VarCurr: state_type] :
      ( v35945(VarCurr,0)
    <=> v35857(VarCurr,3) ) ).

tff(addAssignment_17968,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,3)
    <=> v35859(VarCurr,3) ) ).

tff(addAssignment_17967,axiom,
    ! [VarNext: state_type] :
      ( v35859(VarNext,3)
    <=> v36198(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36199(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v36198(VarNext,B)
            <=> v35859(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_429,axiom,
    ! [VarNext: state_type] :
      ( v36199(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36198(VarNext,B)
          <=> v36170(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36199(VarNext)
      <=> v36200(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3547,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36200(VarNext)
      <=> ( v36202(VarNext)
          & v36112(VarNext) ) ) ) ).

tff(writeUnaryOperator_2186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36202(VarNext)
      <=> v36164(VarNext) ) ) ).

tff(addAssignment_17966,axiom,
    ! [VarCurr: state_type] :
      ( v35969(VarCurr,3)
    <=> v35971(VarCurr,3) ) ).

tff(addAssignment_17965,axiom,
    ! [VarCurr: state_type] :
      ( v35971(VarCurr,3)
    <=> v36109(VarCurr,3) ) ).

tff(addAssignment_17964,axiom,
    ! [VarCurr: state_type] :
      ( v35973(VarCurr,0)
    <=> v35975(VarCurr,0) ) ).

tff(addAssignment_17963,axiom,
    ! [VarCurr: state_type] :
      ( v35975(VarCurr,0)
    <=> v35977(VarCurr,0) ) ).

tff(addAssignment_17962,axiom,
    ! [VarCurr: state_type] :
      ( v35977(VarCurr,0)
    <=> v36108(VarCurr,0) ) ).

tff(addAssignment_17961,axiom,
    ! [VarCurr: state_type] :
      ( v36045(VarCurr,0)
    <=> v36047(VarCurr,0) ) ).

tff(addAssignment_17960,axiom,
    ! [VarCurr: state_type] :
      ( v36047(VarCurr,0)
    <=> v36049(VarCurr,0) ) ).

tff(addAssignment_17959,axiom,
    ! [VarCurr: state_type] :
      ( v36049(VarCurr,0)
    <=> v36051(VarCurr,0) ) ).

tff(addAssignment_17958,axiom,
    ! [VarCurr: state_type] :
      ( v36051(VarCurr,0)
    <=> v36053(VarCurr,0) ) ).

tff(addAssignment_17957,axiom,
    ! [VarCurr: state_type] :
      ( v36053(VarCurr,0)
    <=> v36063(VarCurr,0) ) ).

tff(addAssignment_17956,axiom,
    ! [VarCurr: state_type] :
      ( v35979(VarCurr,0)
    <=> v35981(VarCurr,0) ) ).

tff(addAssignment_17955,axiom,
    ! [VarCurr: state_type] :
      ( v35981(VarCurr,0)
    <=> v36042(VarCurr,0) ) ).

tff(addAssignment_17954,axiom,
    ! [VarCurr: state_type] :
      ( v35983(VarCurr)
    <=> v35509(VarCurr,2) ) ).

tff(addAssignment_17953,axiom,
    ! [VarCurr: state_type] :
      ( v35509(VarCurr,2)
    <=> v35511(VarCurr,2) ) ).

tff(addAssignment_17952,axiom,
    ! [VarCurr: state_type] :
      ( v35511(VarCurr,2)
    <=> v35521(VarCurr,2) ) ).

tff(addAssignment_17951,axiom,
    ! [VarCurr: state_type] :
      ( v35513(VarCurr,2)
    <=> v35515(VarCurr,2) ) ).

tff(addAssignment_17950,axiom,
    ! [VarCurr: state_type] :
      ( v35515(VarCurr,2)
    <=> v35518(VarCurr,2) ) ).

tff(addAssignment_17949,axiom,
    ! [VarCurr: state_type] :
      ( v35519(VarCurr)
    <=> v35986(VarCurr,1) ) ).

tff(addAssignment_17948,axiom,
    ! [VarCurr: state_type] :
      ( v35986(VarCurr,1)
    <=> v35988(VarCurr,1) ) ).

tff(addAssignment_17947,axiom,
    ! [VarCurr: state_type] :
      ( v35988(VarCurr,1)
    <=> v36196(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v36196(VarCurr,B)
      <=> ( v35990(VarCurr,B)
          | v35996(VarCurr,B) ) ) ) ).

tff(addAssignment_17946,axiom,
    ! [VarCurr: state_type] :
      ( v35996(VarCurr,1)
    <=> v35998(VarCurr,1) ) ).

tff(addAssignment_17945,axiom,
    ! [VarCurr: state_type] :
      ( v35998(VarCurr,1)
    <=> v36194(VarCurr,1) ) ).

tff(addAssignment_17944,axiom,
    ! [VarCurr: state_type] :
      ( v36194(VarCurr,0)
    <=> v36195(VarCurr) ) ).

tff(addAssignment_17943,axiom,
    ! [VarCurr: state_type] :
      ( v36194(VarCurr,1)
    <=> v36000(VarCurr) ) ).

tff(addAssignment_17942,axiom,
    ! [VarCurr: state_type] :
      ( v36000(VarCurr)
    <=> v36002(VarCurr,1) ) ).

tff(addAssignment_17941,axiom,
    ! [VarCurr: state_type] :
      ( v36002(VarCurr,1)
    <=> v36004(VarCurr,1) ) ).

tff(addAssignment_17940,axiom,
    ! [VarCurr: state_type] :
      ( v36004(VarCurr,1)
    <=> v36193(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v36193(VarCurr,B)
      <=> ( v36006(VarCurr,B)
          & v36014(VarCurr,B) ) ) ) ).

tff(addAssignment_17939,axiom,
    ! [VarCurr: state_type] :
      ( v36014(VarCurr,1)
    <=> v36016(VarCurr,1) ) ).

tff(addAssignment_17938,axiom,
    ! [VarCurr: state_type] :
      ( v36016(VarCurr,1)
    <=> v36191(VarCurr,1) ) ).

tff(addAssignment_17937,axiom,
    ! [VarCurr: state_type] :
      ( v36191(VarCurr,0)
    <=> v36192(VarCurr) ) ).

tff(addAssignment_17936,axiom,
    ! [VarCurr: state_type] :
      ( v36191(VarCurr,1)
    <=> v36018(VarCurr) ) ).

tff(addAssignment_17935,axiom,
    ! [VarCurr: state_type] :
      ( v36018(VarCurr)
    <=> v36020(VarCurr) ) ).

tff(addAssignment_17934,axiom,
    ! [VarCurr: state_type] :
      ( v36020(VarCurr)
    <=> v36022(VarCurr) ) ).

tff(writeUnaryOperator_2185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36022(VarCurr)
    <=> v36189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3546,axiom,
    ! [VarCurr: state_type] :
      ( v36189(VarCurr)
    <=> ( v36190(VarCurr)
        | v36177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3545,axiom,
    ! [VarCurr: state_type] :
      ( v36190(VarCurr)
    <=> ( v36024(VarCurr)
        | v36039(VarCurr) ) ) ).

tff(addAssignment_17933,axiom,
    ! [VarCurr: state_type] :
      ( v36177(VarCurr)
    <=> v36179(VarCurr) ) ).

tff(addAssignment_17932,axiom,
    ! [VarCurr: state_type] :
      ( v36179(VarCurr)
    <=> v36028(VarCurr,2) ) ).

tff(addAssignment_17931,axiom,
    ! [VarCurr: state_type] :
      ( v36028(VarCurr,2)
    <=> v36030(VarCurr,2) ) ).

tff(addAssignment_17930,axiom,
    ! [VarCurr: state_type] :
      ( v36030(VarCurr,2)
    <=> v36032(VarCurr,2) ) ).

tff(addAssignment_17929,axiom,
    ! [VarCurr: state_type] :
      ( v36032(VarCurr,2)
    <=> v36037(VarCurr,2) ) ).

tff(addAssignment_17928,axiom,
    ! [VarCurr: state_type] :
      ( v36034(VarCurr,2)
    <=> v36036(VarCurr,2) ) ).

tff(addAssignment_17927,axiom,
    ! [VarCurr: state_type] :
      ( v36036(VarCurr,2)
    <=> v35945(VarCurr,2) ) ).

tff(addAssignment_17926,axiom,
    ! [VarCurr: state_type] :
      ( v35945(VarCurr,2)
    <=> v35857(VarCurr,5) ) ).

tff(addAssignment_17925,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,5)
    <=> v35859(VarCurr,5) ) ).

tff(addAssignment_17924,axiom,
    ! [VarNext: state_type] :
      ( v35859(VarNext,5)
    <=> v36181(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36182(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v36181(VarNext,B)
            <=> v35859(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_428,axiom,
    ! [VarNext: state_type] :
      ( v36182(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36181(VarNext,B)
          <=> v36170(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36182(VarNext)
      <=> v36183(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36183(VarNext)
      <=> ( v36185(VarNext)
          & v36112(VarNext) ) ) ) ).

tff(writeUnaryOperator_2184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36185(VarNext)
      <=> v36164(VarNext) ) ) ).

tff(addAssignment_17923,axiom,
    ! [VarCurr: state_type] :
      ( v35969(VarCurr,5)
    <=> v35971(VarCurr,5) ) ).

tff(addAssignment_17922,axiom,
    ! [VarCurr: state_type] :
      ( v35971(VarCurr,5)
    <=> v36109(VarCurr,5) ) ).

tff(addAssignment_17921,axiom,
    ! [VarCurr: state_type] :
      ( v35973(VarCurr,2)
    <=> v35975(VarCurr,2) ) ).

tff(addAssignment_17920,axiom,
    ! [VarCurr: state_type] :
      ( v35975(VarCurr,2)
    <=> v35977(VarCurr,2) ) ).

tff(addAssignment_17919,axiom,
    ! [VarCurr: state_type] :
      ( v35977(VarCurr,2)
    <=> v36108(VarCurr,2) ) ).

tff(addAssignment_17918,axiom,
    ! [VarCurr: state_type] :
      ( v36045(VarCurr,2)
    <=> v36047(VarCurr,2) ) ).

tff(addAssignment_17917,axiom,
    ! [VarCurr: state_type] :
      ( v36047(VarCurr,2)
    <=> v36049(VarCurr,2) ) ).

tff(addAssignment_17916,axiom,
    ! [VarCurr: state_type] :
      ( v36049(VarCurr,2)
    <=> v36051(VarCurr,2) ) ).

tff(addAssignment_17915,axiom,
    ! [VarCurr: state_type] :
      ( v36051(VarCurr,2)
    <=> v36053(VarCurr,2) ) ).

tff(addAssignment_17914,axiom,
    ! [VarCurr: state_type] :
      ( v36053(VarCurr,2)
    <=> v36063(VarCurr,2) ) ).

tff(addAssignment_17913,axiom,
    ! [VarCurr: state_type] :
      ( v36055(VarCurr,2)
    <=> v36057(VarCurr,2) ) ).

tff(addAssignment_17912,axiom,
    ! [VarCurr: state_type] :
      ( v36057(VarCurr,2)
    <=> v36058(VarCurr,2) ) ).

tff(addAssignment_17911,axiom,
    ! [VarCurr: state_type] :
      ( v35979(VarCurr,2)
    <=> v35981(VarCurr,2) ) ).

tff(addAssignment_17910,axiom,
    ! [VarCurr: state_type] :
      ( v35981(VarCurr,2)
    <=> v36042(VarCurr,2) ) ).

tff(addAssignment_17909,axiom,
    ! [VarCurr: state_type] :
      ( v36039(VarCurr)
    <=> v36041(VarCurr) ) ).

tff(addAssignment_17908,axiom,
    ! [VarCurr: state_type] :
      ( v36041(VarCurr)
    <=> v35945(VarCurr,1) ) ).

tff(addAssignment_17907,axiom,
    ! [VarCurr: state_type] :
      ( v35945(VarCurr,1)
    <=> v35857(VarCurr,4) ) ).

tff(addAssignment_17906,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,4)
    <=> v35859(VarCurr,4) ) ).

tff(addAssignment_17905,axiom,
    ! [VarNext: state_type] :
      ( v35859(VarNext,4)
    <=> v36159(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36160(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v36159(VarNext,B)
            <=> v35859(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_427,axiom,
    ! [VarNext: state_type] :
      ( v36160(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36159(VarNext,B)
          <=> v36170(VarNext,B) ) ) ) ).

tff(addAssignment_17904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36170(VarNext,B)
          <=> v36168(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36171(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36168(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_307,axiom,
    ! [VarCurr: state_type] :
      ( v36171(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v36168(VarCurr,B)
          <=> v35969(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3542,axiom,
    ! [VarCurr: state_type] :
      ( v36171(VarCurr)
    <=> ( v36172(VarCurr)
        & v36173(VarCurr) ) ) ).

tff(writeUnaryOperator_2183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36173(VarCurr)
    <=> v35959(VarCurr) ) ).

tff(writeUnaryOperator_2182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36172(VarCurr)
    <=> v35947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36160(VarNext)
      <=> v36161(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36161(VarNext)
      <=> ( v36162(VarNext)
          & v36112(VarNext) ) ) ) ).

tff(writeUnaryOperator_2181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36162(VarNext)
      <=> v36164(VarNext) ) ) ).

tff(addAssignment_17903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36164(VarNext)
      <=> v36112(VarCurr) ) ) ).

tff(addAssignment_17902,axiom,
    ! [VarCurr: state_type] :
      ( v36112(VarCurr)
    <=> v36114(VarCurr) ) ).

tff(addAssignment_17901,axiom,
    ! [VarCurr: state_type] :
      ( v36114(VarCurr)
    <=> v36116(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3539,axiom,
    ! [VarCurr: state_type] :
      ( v36116(VarCurr)
    <=> ( v36157(VarCurr)
        | v36153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3538,axiom,
    ! [VarCurr: state_type] :
      ( v36157(VarCurr)
    <=> ( v36118(VarCurr)
        & v36122(VarCurr) ) ) ).

tff(addAssignment_17900,axiom,
    ! [VarCurr: state_type] :
      ( v36153(VarCurr)
    <=> v36155(VarCurr) ) ).

tff(addAssignment_17899,axiom,
    ! [VarCurr: state_type] :
      ( v36155(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_426,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v36137(VarNext)
       => ( v36122(VarNext)
        <=> v36122(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_426,axiom,
    ! [VarNext: state_type] :
      ( v36137(VarNext)
     => ( v36122(VarNext)
      <=> v36147(VarNext) ) ) ).

tff(addAssignment_17898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36147(VarNext)
      <=> v36145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3537,axiom,
    ! [VarCurr: state_type] :
      ( v36145(VarCurr)
    <=> ( v36148(VarCurr)
        & v36149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3536,axiom,
    ! [VarCurr: state_type] :
      ( v36149(VarCurr)
    <=> ( v36128(VarCurr)
        | v36132(VarCurr) ) ) ).

tff(writeUnaryOperator_2180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36148(VarCurr)
    <=> v36124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3535,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36137(VarNext)
      <=> v36138(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36138(VarNext)
      <=> ( v36140(VarNext)
          & v36142(VarNext) ) ) ) ).

tff(writeUnaryOperator_2179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36142(VarCurr)
    <=> v36118(VarCurr) ) ).

tff(addAssignment_17897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v36140(VarNext)
      <=> v36118(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_144,axiom,
    ( v36122(constB0)
  <=> $true ) ).

tff(addAssignment_17896,axiom,
    ! [VarCurr: state_type] :
      ( v36132(VarCurr)
    <=> v36134(VarCurr) ) ).

tff(addAssignment_17895,axiom,
    ! [VarCurr: state_type] :
      ( v36134(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_17894,axiom,
    ! [VarCurr: state_type] :
      ( v36128(VarCurr)
    <=> v36130(VarCurr) ) ).

tff(addAssignment_17893,axiom,
    ! [VarCurr: state_type] :
      ( v36130(VarCurr)
    <=> $true ) ).

tff(addAssignment_17892,axiom,
    ! [VarCurr: state_type] :
      ( v36124(VarCurr)
    <=> v36126(VarCurr) ) ).

tff(addAssignment_17891,axiom,
    ! [VarCurr: state_type] :
      ( v36126(VarCurr)
    <=> $false ) ).

tff(addAssignment_17890,axiom,
    ! [VarCurr: state_type] :
      ( v36118(VarCurr)
    <=> v36120(VarCurr) ) ).

tff(addAssignment_17889,axiom,
    ! [VarCurr: state_type] :
      ( v36120(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_17888,axiom,
    ! [VarCurr: state_type] :
      ( v35969(VarCurr,4)
    <=> v35971(VarCurr,4) ) ).

tff(addAssignment_17887,axiom,
    ! [VarCurr: state_type] :
      ( v35971(VarCurr,4)
    <=> v36109(VarCurr,4) ) ).

tff(addAssignment_17886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v36109(VarCurr,B)
      <=> v36110(VarCurr,B) ) ) ).

tff(addAssignment_17885,axiom,
    ! [VarCurr: state_type] :
      ( ( v36109(VarCurr,5)
      <=> v35973(VarCurr,2) )
      & ( v36109(VarCurr,4)
      <=> v35973(VarCurr,1) )
      & ( v36109(VarCurr,3)
      <=> v35973(VarCurr,0) ) ) ).

tff(addAssignment_17884,axiom,
    ! [VarCurr: state_type] :
      ( v35973(VarCurr,1)
    <=> v35975(VarCurr,1) ) ).

tff(addAssignment_17883,axiom,
    ! [VarCurr: state_type] :
      ( v35975(VarCurr,1)
    <=> v35977(VarCurr,1) ) ).

tff(addAssignment_17882,axiom,
    ! [VarCurr: state_type] :
      ( v35977(VarCurr,1)
    <=> v36108(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v36108(VarCurr,B)
      <=> ( v35979(VarCurr,B)
          & v36045(VarCurr,B) ) ) ) ).

tff(addAssignment_17881,axiom,
    ! [VarCurr: state_type] :
      ( v36045(VarCurr,1)
    <=> v36047(VarCurr,1) ) ).

tff(addAssignment_17880,axiom,
    ! [VarCurr: state_type] :
      ( v36047(VarCurr,1)
    <=> v36049(VarCurr,1) ) ).

tff(addAssignment_17879,axiom,
    ! [VarCurr: state_type] :
      ( v36049(VarCurr,1)
    <=> v36051(VarCurr,1) ) ).

tff(addAssignment_17878,axiom,
    ! [VarCurr: state_type] :
      ( v36051(VarCurr,1)
    <=> v36053(VarCurr,1) ) ).

tff(addAssignment_17877,axiom,
    ! [VarCurr: state_type] :
      ( v36053(VarCurr,1)
    <=> v36063(VarCurr,1) ) ).

tff(addAssignment_17876,axiom,
    ! [VarCurr: state_type] :
      ( v36063(VarCurr,0)
    <=> v36103(VarCurr) ) ).

tff(addAssignment_17875,axiom,
    ! [VarCurr: state_type] :
      ( v36063(VarCurr,1)
    <=> v36098(VarCurr) ) ).

tff(addAssignment_17874,axiom,
    ! [VarCurr: state_type] :
      ( v36063(VarCurr,2)
    <=> v36093(VarCurr) ) ).

tff(addAssignment_17873,axiom,
    ! [VarCurr: state_type] :
      ( v36063(VarCurr,3)
    <=> v36065(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3533,axiom,
    ! [VarCurr: state_type] :
      ( v36103(VarCurr)
    <=> ( v36104(VarCurr)
        & v36107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3532,axiom,
    ! [VarCurr: state_type] :
      ( v36107(VarCurr)
    <=> ( v36055(VarCurr,0)
        | v36073(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3531,axiom,
    ! [VarCurr: state_type] :
      ( v36104(VarCurr)
    <=> ( v36105(VarCurr)
        | v36106(VarCurr) ) ) ).

tff(writeUnaryOperator_2178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36106(VarCurr)
    <=> v36073(VarCurr,0) ) ).

tff(writeUnaryOperator_2177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36105(VarCurr)
    <=> v36055(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3530,axiom,
    ! [VarCurr: state_type] :
      ( v36098(VarCurr)
    <=> ( v36099(VarCurr)
        & v36102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3529,axiom,
    ! [VarCurr: state_type] :
      ( v36102(VarCurr)
    <=> ( v36072(VarCurr)
        | v36074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3528,axiom,
    ! [VarCurr: state_type] :
      ( v36099(VarCurr)
    <=> ( v36100(VarCurr)
        | v36101(VarCurr) ) ) ).

tff(writeUnaryOperator_2176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36101(VarCurr)
    <=> v36074(VarCurr) ) ).

tff(writeUnaryOperator_2175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36100(VarCurr)
    <=> v36072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3527,axiom,
    ! [VarCurr: state_type] :
      ( v36093(VarCurr)
    <=> ( v36094(VarCurr)
        & v36097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3526,axiom,
    ! [VarCurr: state_type] :
      ( v36097(VarCurr)
    <=> ( v36070(VarCurr)
        | v36080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3525,axiom,
    ! [VarCurr: state_type] :
      ( v36094(VarCurr)
    <=> ( v36095(VarCurr)
        | v36096(VarCurr) ) ) ).

tff(writeUnaryOperator_2174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36096(VarCurr)
    <=> v36080(VarCurr) ) ).

tff(writeUnaryOperator_2173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36095(VarCurr)
    <=> v36070(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3524,axiom,
    ! [VarCurr: state_type] :
      ( v36065(VarCurr)
    <=> ( v36066(VarCurr)
        & v36092(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3523,axiom,
    ! [VarCurr: state_type] :
      ( v36092(VarCurr)
    <=> ( v36068(VarCurr)
        | v36087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3522,axiom,
    ! [VarCurr: state_type] :
      ( v36066(VarCurr)
    <=> ( v36067(VarCurr)
        | v36086(VarCurr) ) ) ).

tff(writeUnaryOperator_2172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36086(VarCurr)
    <=> v36087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3521,axiom,
    ! [VarCurr: state_type] :
      ( v36087(VarCurr)
    <=> ( v36088(VarCurr)
        & v36091(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_503,axiom,
    ! [VarCurr: state_type] :
      ( v36091(VarCurr)
    <=> ( v36055(VarCurr,3)
        | v36073(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3520,axiom,
    ! [VarCurr: state_type] :
      ( v36088(VarCurr)
    <=> ( v36089(VarCurr)
        | v36090(VarCurr) ) ) ).

tff(writeUnaryOperator_2171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36090(VarCurr)
    <=> v36073(VarCurr,3) ) ).

tff(writeUnaryOperator_2170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36089(VarCurr)
    <=> v36055(VarCurr,3) ) ).

tff(writeUnaryOperator_2169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36067(VarCurr)
    <=> v36068(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3519,axiom,
    ! [VarCurr: state_type] :
      ( v36068(VarCurr)
    <=> ( v36069(VarCurr)
        | v36085(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_502,axiom,
    ! [VarCurr: state_type] :
      ( v36085(VarCurr)
    <=> ( v36055(VarCurr,2)
        & v36073(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3518,axiom,
    ! [VarCurr: state_type] :
      ( v36069(VarCurr)
    <=> ( v36070(VarCurr)
        & v36080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3517,axiom,
    ! [VarCurr: state_type] :
      ( v36080(VarCurr)
    <=> ( v36081(VarCurr)
        & v36084(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_501,axiom,
    ! [VarCurr: state_type] :
      ( v36084(VarCurr)
    <=> ( v36055(VarCurr,2)
        | v36073(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3516,axiom,
    ! [VarCurr: state_type] :
      ( v36081(VarCurr)
    <=> ( v36082(VarCurr)
        | v36083(VarCurr) ) ) ).

tff(writeUnaryOperator_2168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36083(VarCurr)
    <=> v36073(VarCurr,2) ) ).

tff(writeUnaryOperator_2167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36082(VarCurr)
    <=> v36055(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3515,axiom,
    ! [VarCurr: state_type] :
      ( v36070(VarCurr)
    <=> ( v36071(VarCurr)
        | v36079(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_500,axiom,
    ! [VarCurr: state_type] :
      ( v36079(VarCurr)
    <=> ( v36055(VarCurr,1)
        & v36073(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3514,axiom,
    ! [VarCurr: state_type] :
      ( v36071(VarCurr)
    <=> ( v36072(VarCurr)
        & v36074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3513,axiom,
    ! [VarCurr: state_type] :
      ( v36074(VarCurr)
    <=> ( v36075(VarCurr)
        & v36078(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_499,axiom,
    ! [VarCurr: state_type] :
      ( v36078(VarCurr)
    <=> ( v36055(VarCurr,1)
        | v36073(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3512,axiom,
    ! [VarCurr: state_type] :
      ( v36075(VarCurr)
    <=> ( v36076(VarCurr)
        | v36077(VarCurr) ) ) ).

tff(writeUnaryOperator_2166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36077(VarCurr)
    <=> v36073(VarCurr,1) ) ).

tff(writeUnaryOperator_2165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v36076(VarCurr)
    <=> v36055(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3511,axiom,
    ! [VarCurr: state_type] :
      ( v36072(VarCurr)
    <=> ( v36055(VarCurr,0)
        & v36073(VarCurr,0) ) ) ).

tff(addAssignment_17872,axiom,
    ! [VarCurr: state_type] :
      ( v36073(VarCurr,0)
    <=> v36060(VarCurr) ) ).

tff(addAssignment_17871,axiom,
    ! [VarCurr: state_type] :
      ( ( v36073(VarCurr,3)
      <=> $false )
      & ( v36073(VarCurr,2)
      <=> $false )
      & ( v36073(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_17870,axiom,
    ! [VarCurr: state_type] :
      ( v36060(VarCurr)
    <=> v36062(VarCurr) ) ).

tff(addAssignment_17869,axiom,
    ! [VarCurr: state_type] :
      ( v36062(VarCurr)
    <=> v36010(VarCurr) ) ).

tff(addAssignment_17868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v36055(VarCurr,B)
      <=> v36057(VarCurr,B) ) ) ).

tff(addAssignment_17867,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v36057(VarCurr,B)
      <=> v36058(VarCurr,B) ) ) ).

tff(addAssignment_17866,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v36058(VarCurr,B)
      <=> v35945(VarCurr,B) ) ) ).

tff(addAssignment_17865,axiom,
    ! [VarCurr: state_type] :
      ( v36058(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_17864,axiom,
    ! [VarCurr: state_type] :
      ( v35979(VarCurr,1)
    <=> v35981(VarCurr,1) ) ).

tff(addAssignment_17863,axiom,
    ! [VarCurr: state_type] :
      ( v35981(VarCurr,1)
    <=> v36042(VarCurr,1) ) ).

tff(addAssignment_17862,axiom,
    ! [VarCurr: state_type] :
      ( v36042(VarCurr,0)
    <=> v36043(VarCurr) ) ).

tff(addAssignment_17861,axiom,
    ! [VarCurr: state_type] :
      ( v36042(VarCurr,1)
    <=> v36043(VarCurr) ) ).

tff(addAssignment_17860,axiom,
    ! [VarCurr: state_type] :
      ( v36042(VarCurr,2)
    <=> v36043(VarCurr) ) ).

tff(addAssignment_17859,axiom,
    ! [VarCurr: state_type] :
      ( v36043(VarCurr)
    <=> v35983(VarCurr) ) ).

tff(addAssignment_17858,axiom,
    ! [VarCurr: state_type] :
      ( v36024(VarCurr)
    <=> v36026(VarCurr) ) ).

tff(addAssignment_17857,axiom,
    ! [VarCurr: state_type] :
      ( v36026(VarCurr)
    <=> v36028(VarCurr,0) ) ).

tff(addAssignment_17856,axiom,
    ! [VarCurr: state_type] :
      ( v36028(VarCurr,0)
    <=> v36030(VarCurr,0) ) ).

tff(addAssignment_17855,axiom,
    ! [VarCurr: state_type] :
      ( v36030(VarCurr,0)
    <=> v36032(VarCurr,0) ) ).

tff(addAssignment_17854,axiom,
    ! [VarCurr: state_type] :
      ( v36032(VarCurr,0)
    <=> v36037(VarCurr,0) ) ).

tff(writeUnaryOperator_2164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v36037(VarCurr,B)
      <=> ~ v36034(VarCurr,B) ) ) ).

tff(addAssignment_17853,axiom,
    ! [VarCurr: state_type] :
      ( v36034(VarCurr,0)
    <=> v36036(VarCurr,0) ) ).

tff(addAssignment_17852,axiom,
    ! [VarCurr: state_type] :
      ( v36036(VarCurr,0)
    <=> v35945(VarCurr,0) ) ).

tff(addAssignment_17851,axiom,
    ! [VarCurr: state_type] :
      ( v36006(VarCurr,1)
    <=> v36008(VarCurr,1) ) ).

tff(addAssignment_17850,axiom,
    ! [VarCurr: state_type] :
      ( v36008(VarCurr,1)
    <=> v36011(VarCurr,1) ) ).

tff(addAssignment_17849,axiom,
    ! [VarCurr: state_type] :
      ( v36011(VarCurr,0)
    <=> v36012(VarCurr) ) ).

tff(addAssignment_17848,axiom,
    ! [VarCurr: state_type] :
      ( v36011(VarCurr,1)
    <=> v36010(VarCurr) ) ).

tff(addAssignment_17847,axiom,
    ! [VarCurr: state_type] :
      ( v36010(VarCurr)
    <=> v7230(VarCurr,3) ) ).

tff(addAssignment_17846,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,3)
    <=> v7232(VarCurr,3) ) ).

tff(addAssignment_17845,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,3)
    <=> v7234(VarCurr,3) ) ).

tff(addAssignment_17844,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,3)
    <=> v34455(VarCurr,3) ) ).

tff(addAssignment_17843,axiom,
    ! [VarCurr: state_type] :
      ( v35990(VarCurr,1)
    <=> v35992(VarCurr,1) ) ).

tff(addAssignment_17842,axiom,
    ! [VarCurr: state_type] :
      ( v35992(VarCurr,1)
    <=> v35993(VarCurr,1) ) ).

tff(addAssignment_17841,axiom,
    ! [VarCurr: state_type] :
      ( v35993(VarCurr,0)
    <=> v35994(VarCurr) ) ).

tff(addAssignment_17840,axiom,
    ! [VarCurr: state_type] :
      ( v35993(VarCurr,1)
    <=> v35994(VarCurr) ) ).

tff(addAssignment_17839,axiom,
    ! [VarCurr: state_type] :
      ( v35994(VarCurr)
    <=> v35517(VarCurr) ) ).

tff(addAssignment_17838,axiom,
    ! [VarCurr: state_type] :
      ( v35959(VarCurr)
    <=> v35961(VarCurr) ) ).

tff(addAssignment_17837,axiom,
    ! [VarCurr: state_type] :
      ( v35961(VarCurr)
    <=> v35963(VarCurr) ) ).

tff(addAssignment_17836,axiom,
    ! [VarCurr: state_type] :
      ( v35963(VarCurr)
    <=> v35965(VarCurr) ) ).

tff(addAssignment_17835,axiom,
    ! [VarCurr: state_type] :
      ( v35965(VarCurr)
    <=> v35967(VarCurr) ) ).

tff(addAssignment_17834,axiom,
    ! [VarCurr: state_type] :
      ( v35967(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_17833,axiom,
    ! [VarCurr: state_type] :
      ( v35947(VarCurr)
    <=> v35949(VarCurr) ) ).

tff(addAssignment_17832,axiom,
    ! [VarCurr: state_type] :
      ( v35949(VarCurr)
    <=> v35951(VarCurr) ) ).

tff(addAssignment_17831,axiom,
    ! [VarCurr: state_type] :
      ( v35951(VarCurr)
    <=> v35953(VarCurr) ) ).

tff(addAssignment_17830,axiom,
    ! [VarCurr: state_type] :
      ( v35953(VarCurr)
    <=> v35955(VarCurr) ) ).

tff(addAssignment_17829,axiom,
    ! [VarCurr: state_type] :
      ( v35955(VarCurr)
    <=> v35957(VarCurr) ) ).

tff(addAssignment_17828,axiom,
    ! [VarCurr: state_type] :
      ( v35957(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_17827,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35455(VarCurr,B)
      <=> v35457(VarCurr,B) ) ) ).

tff(addAssignment_17826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35457(VarCurr,B)
      <=> v35459(VarCurr,B) ) ) ).

tff(addAssignment_17825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35459(VarCurr,B)
      <=> v35461(VarCurr,B) ) ) ).

tff(addAssignment_17824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35461(VarCurr,B)
      <=> v35463(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35908(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v35463(VarNext,B)
            <=> v35463(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_425,axiom,
    ! [VarNext: state_type] :
      ( v35908(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35463(VarNext,B)
          <=> v35918(VarNext,B) ) ) ) ).

tff(addAssignment_17823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35918(VarNext,B)
          <=> v35916(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35919(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35916(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_306,axiom,
    ! [VarCurr: state_type] :
      ( v35919(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35916(VarCurr,B)
          <=> v35493(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3510,axiom,
    ! [VarCurr: state_type] :
      ( v35919(VarCurr)
    <=> ( v35920(VarCurr)
        & v35921(VarCurr) ) ) ).

tff(writeUnaryOperator_2163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35921(VarCurr)
    <=> v35479(VarCurr) ) ).

tff(writeUnaryOperator_2162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35920(VarCurr)
    <=> v35465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35908(VarNext)
      <=> v35909(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35909(VarNext)
      <=> ( v35910(VarNext)
          & v35823(VarNext) ) ) ) ).

tff(writeUnaryOperator_2161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35910(VarNext)
      <=> v35912(VarNext) ) ) ).

tff(addAssignment_17822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35912(VarNext)
      <=> v35823(VarCurr) ) ) ).

tff(addAssignment_17821,axiom,
    ! [VarCurr: state_type] :
      ( v35823(VarCurr)
    <=> v35825(VarCurr) ) ).

tff(addAssignment_17820,axiom,
    ! [VarCurr: state_type] :
      ( v35825(VarCurr)
    <=> v35827(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3507,axiom,
    ! [VarCurr: state_type] :
      ( v35827(VarCurr)
    <=> ( v35905(VarCurr)
        | v35897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3506,axiom,
    ! [VarCurr: state_type] :
      ( v35905(VarCurr)
    <=> ( v35829(VarCurr)
        & v35835(VarCurr) ) ) ).

tff(addAssignment_17819,axiom,
    ! [VarCurr: state_type] :
      ( v35897(VarCurr)
    <=> v35899(VarCurr) ) ).

tff(addAssignment_17818,axiom,
    ! [VarCurr: state_type] :
      ( v35899(VarCurr)
    <=> v35901(VarCurr) ) ).

tff(addAssignment_17817,axiom,
    ! [VarCurr: state_type] :
      ( v35901(VarCurr)
    <=> v35903(VarCurr) ) ).

tff(addAssignment_17816,axiom,
    ! [VarCurr: state_type] :
      ( v35903(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35881(VarNext)
       => ( v35835(VarNext)
        <=> v35835(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_424,axiom,
    ! [VarNext: state_type] :
      ( v35881(VarNext)
     => ( v35835(VarNext)
      <=> v35891(VarNext) ) ) ).

tff(addAssignment_17815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35891(VarNext)
      <=> v35889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3505,axiom,
    ! [VarCurr: state_type] :
      ( v35889(VarCurr)
    <=> ( v35892(VarCurr)
        & v35893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3504,axiom,
    ! [VarCurr: state_type] :
      ( v35893(VarCurr)
    <=> ( v35841(VarCurr)
        | v35872(VarCurr) ) ) ).

tff(writeUnaryOperator_2160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35892(VarCurr)
    <=> v35837(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3503,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35881(VarNext)
      <=> v35882(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35882(VarNext)
      <=> ( v35884(VarNext)
          & v35886(VarNext) ) ) ) ).

tff(writeUnaryOperator_2159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35886(VarCurr)
    <=> v35829(VarCurr) ) ).

tff(addAssignment_17814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35884(VarNext)
      <=> v35829(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_143,axiom,
    ( v35835(constB0)
  <=> $true ) ).

tff(addAssignment_17813,axiom,
    ! [VarCurr: state_type] :
      ( v35872(VarCurr)
    <=> v35874(VarCurr) ) ).

tff(addAssignment_17812,axiom,
    ! [VarCurr: state_type] :
      ( v35874(VarCurr)
    <=> v35876(VarCurr) ) ).

tff(addAssignment_17811,axiom,
    ! [VarCurr: state_type] :
      ( v35876(VarCurr)
    <=> v35878(VarCurr) ) ).

tff(addAssignment_17810,axiom,
    ! [VarCurr: state_type] :
      ( v35878(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_17809,axiom,
    ! [VarCurr: state_type] :
      ( v35841(VarCurr)
    <=> v35843(VarCurr) ) ).

tff(addAssignment_17808,axiom,
    ! [VarCurr: state_type] :
      ( v35843(VarCurr)
    <=> v35845(VarCurr) ) ).

tff(addAssignment_17807,axiom,
    ! [VarCurr: state_type] :
      ( v35845(VarCurr)
    <=> v35847(VarCurr) ) ).

tff(addAssignment_17806,axiom,
    ! [VarCurr: state_type] :
      ( v35847(VarCurr)
    <=> v35849(VarCurr) ) ).

tff(writeUnaryOperator_2158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35849(VarCurr)
    <=> v35869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3501,axiom,
    ! [VarCurr: state_type] :
      ( v35869(VarCurr)
    <=> ( v35870(VarCurr)
        | v35865(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3500,axiom,
    ! [VarCurr: state_type] :
      ( v35870(VarCurr)
    <=> ( v35851(VarCurr)
        | v35861(VarCurr) ) ) ).

tff(addAssignment_17805,axiom,
    ! [VarCurr: state_type] :
      ( v35865(VarCurr)
    <=> v35867(VarCurr) ) ).

tff(addAssignment_17804,axiom,
    ! [VarCurr: state_type] :
      ( v35867(VarCurr)
    <=> v35855(VarCurr,2) ) ).

tff(addAssignment_17803,axiom,
    ! [VarCurr: state_type] :
      ( v35855(VarCurr,2)
    <=> v35857(VarCurr,2) ) ).

tff(addAssignment_17802,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,2)
    <=> v35859(VarCurr,2) ) ).

tff(addAssignment_17801,axiom,
    ! [VarCurr: state_type] :
      ( v35861(VarCurr)
    <=> v35863(VarCurr) ) ).

tff(addAssignment_17800,axiom,
    ! [VarCurr: state_type] :
      ( v35863(VarCurr)
    <=> v35855(VarCurr,1) ) ).

tff(addAssignment_17799,axiom,
    ! [VarCurr: state_type] :
      ( v35855(VarCurr,1)
    <=> v35857(VarCurr,1) ) ).

tff(addAssignment_17798,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,1)
    <=> v35859(VarCurr,1) ) ).

tff(addAssignment_17797,axiom,
    ! [VarCurr: state_type] :
      ( v35851(VarCurr)
    <=> v35853(VarCurr) ) ).

tff(addAssignment_17796,axiom,
    ! [VarCurr: state_type] :
      ( v35853(VarCurr)
    <=> v35855(VarCurr,0) ) ).

tff(addAssignment_17795,axiom,
    ! [VarCurr: state_type] :
      ( v35855(VarCurr,0)
    <=> v35857(VarCurr,0) ) ).

tff(addAssignment_17794,axiom,
    ! [VarCurr: state_type] :
      ( v35857(VarCurr,0)
    <=> v35859(VarCurr,0) ) ).

tff(addAssignment_17793,axiom,
    ! [VarCurr: state_type] :
      ( v35837(VarCurr)
    <=> v35839(VarCurr) ) ).

tff(addAssignment_17792,axiom,
    ! [VarCurr: state_type] :
      ( v35839(VarCurr)
    <=> $false ) ).

tff(addAssignment_17791,axiom,
    ! [VarCurr: state_type] :
      ( v35829(VarCurr)
    <=> v35831(VarCurr) ) ).

tff(addAssignment_17790,axiom,
    ! [VarCurr: state_type] :
      ( v35831(VarCurr)
    <=> v35833(VarCurr) ) ).

tff(addAssignment_17789,axiom,
    ! [VarCurr: state_type] :
      ( v35833(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_17788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35493(VarCurr,B)
      <=> v35495(VarCurr,B) ) ) ).

tff(addAssignment_17787,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35495(VarCurr,B)
      <=> v35497(VarCurr,B) ) ) ).

tff(addAssignment_17786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35497(VarCurr,B)
      <=> v35499(VarCurr,B) ) ) ).

tff(addAssignment_17785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35499(VarCurr,B)
      <=> v35501(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35501(VarCurr,B)
      <=> ( v35503(VarCurr,B)
          & v35525(VarCurr,B) ) ) ) ).

tff(addAssignment_17784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35525(VarCurr,B)
      <=> v35527(VarCurr,B) ) ) ).

tff(addAssignment_17783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35527(VarCurr,B)
      <=> v35529(VarCurr,B) ) ) ).

tff(addAssignment_17782,axiom,
    ! [VarCurr: state_type] :
      ( ( v35529(VarCurr,11)
      <=> v6324(VarCurr,47) )
      & ( v35529(VarCurr,10)
      <=> v6324(VarCurr,46) )
      & ( v35529(VarCurr,9)
      <=> v6324(VarCurr,45) )
      & ( v35529(VarCurr,8)
      <=> v6324(VarCurr,44) )
      & ( v35529(VarCurr,7)
      <=> v6324(VarCurr,43) )
      & ( v35529(VarCurr,6)
      <=> v6324(VarCurr,42) )
      & ( v35529(VarCurr,5)
      <=> v6324(VarCurr,41) )
      & ( v35529(VarCurr,4)
      <=> v6324(VarCurr,40) )
      & ( v35529(VarCurr,3)
      <=> v6324(VarCurr,39) )
      & ( v35529(VarCurr,2)
      <=> v6324(VarCurr,38) )
      & ( v35529(VarCurr,1)
      <=> v6324(VarCurr,37) )
      & ( v35529(VarCurr,0)
      <=> v6324(VarCurr,36) ) ) ).

tff(addAssignment_17781,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,47)
      <=> v35531(VarCurr,11) )
      & ( v6324(VarCurr,46)
      <=> v35531(VarCurr,10) )
      & ( v6324(VarCurr,45)
      <=> v35531(VarCurr,9) )
      & ( v6324(VarCurr,44)
      <=> v35531(VarCurr,8) )
      & ( v6324(VarCurr,43)
      <=> v35531(VarCurr,7) )
      & ( v6324(VarCurr,42)
      <=> v35531(VarCurr,6) )
      & ( v6324(VarCurr,41)
      <=> v35531(VarCurr,5) )
      & ( v6324(VarCurr,40)
      <=> v35531(VarCurr,4) )
      & ( v6324(VarCurr,39)
      <=> v35531(VarCurr,3) )
      & ( v6324(VarCurr,38)
      <=> v35531(VarCurr,2) )
      & ( v6324(VarCurr,37)
      <=> v35531(VarCurr,1) )
      & ( v6324(VarCurr,36)
      <=> v35531(VarCurr,0) ) ) ).

tff(addAssignment_17780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35531(VarCurr,B)
      <=> v35533(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35533(VarCurr,B)
      <=> ( v35815(VarCurr,B)
          | v35818(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35818(VarCurr,B)
      <=> ( v35543(VarCurr,B)
          & v35819(VarCurr,B) ) ) ) ).

tff(addAssignment_17779,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,0)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17778,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,1)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17777,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,2)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17776,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,3)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17775,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,4)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17774,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,5)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17773,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,6)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17772,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,7)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17771,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,8)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17770,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,9)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17769,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,10)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17768,axiom,
    ! [VarCurr: state_type] :
      ( v35819(VarCurr,11)
    <=> v35820(VarCurr) ) ).

tff(addAssignment_17767,axiom,
    ! [VarCurr: state_type] :
      ( v35820(VarCurr)
    <=> v35811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35815(VarCurr,B)
      <=> ( v35535(VarCurr,B)
          & v35816(VarCurr,B) ) ) ) ).

tff(addAssignment_17766,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,0)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17765,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,1)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17764,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,2)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17763,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,3)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17762,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,4)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17761,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,5)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17760,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,6)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17759,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,7)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17758,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,8)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17757,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,9)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17756,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,10)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17755,axiom,
    ! [VarCurr: state_type] :
      ( v35816(VarCurr,11)
    <=> v35817(VarCurr) ) ).

tff(addAssignment_17754,axiom,
    ! [VarCurr: state_type] :
      ( v35817(VarCurr)
    <=> v35539(VarCurr) ) ).

tff(addAssignment_17753,axiom,
    ! [VarCurr: state_type] :
      ( v35811(VarCurr)
    <=> v35813(VarCurr) ) ).

tff(addAssignment_17752,axiom,
    ! [VarCurr: state_type] :
      ( v35813(VarCurr)
    <=> v7021(VarCurr,3) ) ).

tff(addAssignment_17751,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,3)
    <=> v7023(VarCurr,3) ) ).

tff(addAssignment_17750,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,3)
    <=> v6623(VarCurr,3) ) ).

tff(addAssignment_17749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35543(VarCurr,B)
      <=> v35545(VarCurr,B) ) ) ).

tff(addAssignment_17748,axiom,
    ! [VarCurr: state_type] :
      ( ( v35545(VarCurr,11)
      <=> v6334(VarCurr,59) )
      & ( v35545(VarCurr,10)
      <=> v6334(VarCurr,58) )
      & ( v35545(VarCurr,9)
      <=> v6334(VarCurr,57) )
      & ( v35545(VarCurr,8)
      <=> v6334(VarCurr,56) )
      & ( v35545(VarCurr,7)
      <=> v6334(VarCurr,55) )
      & ( v35545(VarCurr,6)
      <=> v6334(VarCurr,54) )
      & ( v35545(VarCurr,5)
      <=> v6334(VarCurr,53) )
      & ( v35545(VarCurr,4)
      <=> v6334(VarCurr,52) )
      & ( v35545(VarCurr,3)
      <=> v6334(VarCurr,51) )
      & ( v35545(VarCurr,2)
      <=> v6334(VarCurr,50) )
      & ( v35545(VarCurr,1)
      <=> v6334(VarCurr,49) )
      & ( v35545(VarCurr,0)
      <=> v6334(VarCurr,48) ) ) ).

tff(addAssignment_17747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,60)
        & ~ $less(B,48) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_17746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,60)
        & ~ $less(B,48) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_17745,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,59)
      <=> v35547(VarCurr,11) )
      & ( v6338(VarCurr,58)
      <=> v35547(VarCurr,10) )
      & ( v6338(VarCurr,57)
      <=> v35547(VarCurr,9) )
      & ( v6338(VarCurr,56)
      <=> v35547(VarCurr,8) )
      & ( v6338(VarCurr,55)
      <=> v35547(VarCurr,7) )
      & ( v6338(VarCurr,54)
      <=> v35547(VarCurr,6) )
      & ( v6338(VarCurr,53)
      <=> v35547(VarCurr,5) )
      & ( v6338(VarCurr,52)
      <=> v35547(VarCurr,4) )
      & ( v6338(VarCurr,51)
      <=> v35547(VarCurr,3) )
      & ( v6338(VarCurr,50)
      <=> v35547(VarCurr,2) )
      & ( v6338(VarCurr,49)
      <=> v35547(VarCurr,1) )
      & ( v6338(VarCurr,48)
      <=> v35547(VarCurr,0) ) ) ).

tff(addAssignment_17744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35547(VarCurr,B)
      <=> v35549(VarCurr,B) ) ) ).

tff(addAssignment_17743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35549(VarCurr,B)
      <=> v35551(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35794(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v35551(VarNext,B)
            <=> v35551(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_423,axiom,
    ! [VarNext: state_type] :
      ( v35794(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35551(VarNext,B)
          <=> v35804(VarNext,B) ) ) ) ).

tff(addAssignment_17742,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35804(VarNext,B)
          <=> v35802(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35805(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35802(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_305,axiom,
    ! [VarCurr: state_type] :
      ( v35805(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35802(VarCurr,B)
          <=> v35581(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3499,axiom,
    ! [VarCurr: state_type] :
      ( v35805(VarCurr)
    <=> ( v35806(VarCurr)
        & v35807(VarCurr) ) ) ).

tff(writeUnaryOperator_2157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35807(VarCurr)
    <=> v35567(VarCurr) ) ).

tff(writeUnaryOperator_2156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35806(VarCurr)
    <=> v35553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35794(VarNext)
      <=> v35795(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35795(VarNext)
      <=> ( v35796(VarNext)
          & v35769(VarNext) ) ) ) ).

tff(writeUnaryOperator_2155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35796(VarNext)
      <=> v35798(VarNext) ) ) ).

tff(addAssignment_17741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35798(VarNext)
      <=> v35769(VarCurr) ) ) ).

tff(addAssignment_17740,axiom,
    ! [VarCurr: state_type] :
      ( v35769(VarCurr)
    <=> v35771(VarCurr) ) ).

tff(addAssignment_17739,axiom,
    ! [VarCurr: state_type] :
      ( v35771(VarCurr)
    <=> v35773(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3496,axiom,
    ! [VarCurr: state_type] :
      ( v35773(VarCurr)
    <=> ( v35791(VarCurr)
        | v35783(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3495,axiom,
    ! [VarCurr: state_type] :
      ( v35791(VarCurr)
    <=> ( v35775(VarCurr)
        & v35781(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_142,axiom,
    ( v35781(constB0)
  <=> $true ) ).

tff(addAssignment_17738,axiom,
    ! [VarCurr: state_type] :
      ( v35783(VarCurr)
    <=> v35785(VarCurr) ) ).

tff(addAssignment_17737,axiom,
    ! [VarCurr: state_type] :
      ( v35785(VarCurr)
    <=> v35787(VarCurr) ) ).

tff(addAssignment_17736,axiom,
    ! [VarCurr: state_type] :
      ( v35787(VarCurr)
    <=> v35789(VarCurr) ) ).

tff(addAssignment_17735,axiom,
    ! [VarCurr: state_type] :
      ( v35789(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_17734,axiom,
    ! [VarCurr: state_type] :
      ( v35775(VarCurr)
    <=> v35777(VarCurr) ) ).

tff(addAssignment_17733,axiom,
    ! [VarCurr: state_type] :
      ( v35777(VarCurr)
    <=> v35779(VarCurr) ) ).

tff(addAssignment_17732,axiom,
    ! [VarCurr: state_type] :
      ( v35779(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_17731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35581(VarCurr,B)
      <=> v35583(VarCurr,B) ) ) ).

tff(addAssignment_17730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35583(VarCurr,B)
      <=> v35585(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35585(VarCurr,B)
      <=> ( v35754(VarCurr,B)
          | v35765(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35765(VarCurr,B)
      <=> ( v35718(VarCurr,B)
          & v35766(VarCurr,B) ) ) ) ).

tff(addAssignment_17729,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,0)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17728,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,1)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17727,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,2)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17726,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,3)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17725,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,4)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17724,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,5)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17723,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,6)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17722,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,7)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17721,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,8)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17720,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,9)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17719,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,10)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17718,axiom,
    ! [VarCurr: state_type] :
      ( v35766(VarCurr,11)
    <=> v35767(VarCurr) ) ).

tff(addAssignment_17717,axiom,
    ! [VarCurr: state_type] :
      ( v35767(VarCurr)
    <=> v35728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35754(VarCurr,B)
      <=> ( v35755(VarCurr,B)
          | v35762(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35762(VarCurr,B)
      <=> ( v35682(VarCurr,B)
          & v35763(VarCurr,B) ) ) ) ).

tff(addAssignment_17716,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,0)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17715,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,1)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17714,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,2)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17713,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,3)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17712,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,4)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17711,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,5)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17710,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,6)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17709,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,7)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17708,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,8)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17707,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,9)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17706,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,10)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17705,axiom,
    ! [VarCurr: state_type] :
      ( v35763(VarCurr,11)
    <=> v35764(VarCurr) ) ).

tff(addAssignment_17704,axiom,
    ! [VarCurr: state_type] :
      ( v35764(VarCurr)
    <=> v35692(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_569,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35755(VarCurr,B)
      <=> ( v35756(VarCurr,B)
          | v35759(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35759(VarCurr,B)
      <=> ( v35635(VarCurr,B)
          & v35760(VarCurr,B) ) ) ) ).

tff(addAssignment_17703,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,0)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17702,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,1)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17701,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,2)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17700,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,3)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17699,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,4)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17698,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,5)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17697,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,6)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17696,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,7)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17695,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,8)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17694,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,9)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17693,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,10)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17692,axiom,
    ! [VarCurr: state_type] :
      ( v35760(VarCurr,11)
    <=> v35761(VarCurr) ) ).

tff(addAssignment_17691,axiom,
    ! [VarCurr: state_type] :
      ( v35761(VarCurr)
    <=> v35645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_567,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35756(VarCurr,B)
      <=> ( v35587(VarCurr,B)
          & v35757(VarCurr,B) ) ) ) ).

tff(addAssignment_17690,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,0)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17689,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,1)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17688,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,2)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17687,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,3)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17686,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,4)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17685,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,5)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17684,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,6)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17683,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,7)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17682,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,8)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17681,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,9)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17680,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,10)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17679,axiom,
    ! [VarCurr: state_type] :
      ( v35757(VarCurr,11)
    <=> v35758(VarCurr) ) ).

tff(addAssignment_17678,axiom,
    ! [VarCurr: state_type] :
      ( v35758(VarCurr)
    <=> v35597(VarCurr) ) ).

tff(addAssignment_17677,axiom,
    ! [VarCurr: state_type] :
      ( v35728(VarCurr)
    <=> v35730(VarCurr) ) ).

tff(addAssignment_17676,axiom,
    ! [VarCurr: state_type] :
      ( v35730(VarCurr)
    <=> v35732(VarCurr) ) ).

tff(addAssignment_17675,axiom,
    ! [VarCurr: state_type] :
      ( v35732(VarCurr)
    <=> v35734(VarCurr) ) ).

tff(addAssignment_17674,axiom,
    ! [VarCurr: state_type] :
      ( v35734(VarCurr)
    <=> v35736(VarCurr) ) ).

tff(addAssignment_17673,axiom,
    ! [VarCurr: state_type] :
      ( v35736(VarCurr)
    <=> v35738(VarCurr) ) ).

tff(addAssignment_17672,axiom,
    ! [VarCurr: state_type] :
      ( v35738(VarCurr)
    <=> v35740(VarCurr) ) ).

tff(addAssignment_17671,axiom,
    ! [VarCurr: state_type] :
      ( v35740(VarCurr)
    <=> v35742(VarCurr) ) ).

tff(writeUnaryOperator_2154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35742(VarCurr)
    <=> v35752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3494,axiom,
    ! [VarCurr: state_type] :
      ( v35752(VarCurr)
    <=> ( v35744(VarCurr)
        | v35748(VarCurr) ) ) ).

tff(addAssignment_17670,axiom,
    ! [VarCurr: state_type] :
      ( v35748(VarCurr)
    <=> v35750(VarCurr) ) ).

tff(addAssignment_17669,axiom,
    ! [VarCurr: state_type] :
      ( v35750(VarCurr)
    <=> v35665(VarCurr,1) ) ).

tff(addAssignment_17668,axiom,
    ! [VarCurr: state_type] :
      ( v35744(VarCurr)
    <=> v35746(VarCurr) ) ).

tff(addAssignment_17667,axiom,
    ! [VarCurr: state_type] :
      ( v35746(VarCurr)
    <=> v35665(VarCurr,0) ) ).

tff(addAssignment_17666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35718(VarCurr,B)
      <=> v35720(VarCurr,B) ) ) ).

tff(addAssignment_17665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35720(VarCurr,B)
      <=> v35722(VarCurr,B) ) ) ).

tff(addAssignment_17664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35722(VarCurr,B)
      <=> v35724(VarCurr,B) ) ) ).

tff(addAssignment_17663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35724(VarCurr,B)
      <=> v35726(VarCurr,B) ) ) ).

tff(addAssignment_17662,axiom,
    ! [VarCurr: state_type] :
      ( v35692(VarCurr)
    <=> v35694(VarCurr) ) ).

tff(addAssignment_17661,axiom,
    ! [VarCurr: state_type] :
      ( v35694(VarCurr)
    <=> v35696(VarCurr) ) ).

tff(addAssignment_17660,axiom,
    ! [VarCurr: state_type] :
      ( v35696(VarCurr)
    <=> v35698(VarCurr) ) ).

tff(addAssignment_17659,axiom,
    ! [VarCurr: state_type] :
      ( v35698(VarCurr)
    <=> v35700(VarCurr) ) ).

tff(addAssignment_17658,axiom,
    ! [VarCurr: state_type] :
      ( v35700(VarCurr)
    <=> v35702(VarCurr) ) ).

tff(addAssignment_17657,axiom,
    ! [VarCurr: state_type] :
      ( v35702(VarCurr)
    <=> v35704(VarCurr) ) ).

tff(addAssignment_17656,axiom,
    ! [VarCurr: state_type] :
      ( v35704(VarCurr)
    <=> v35706(VarCurr) ) ).

tff(writeUnaryOperator_2153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35706(VarCurr)
    <=> v35716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3493,axiom,
    ! [VarCurr: state_type] :
      ( v35716(VarCurr)
    <=> ( v35708(VarCurr)
        | v35712(VarCurr) ) ) ).

tff(addAssignment_17655,axiom,
    ! [VarCurr: state_type] :
      ( v35712(VarCurr)
    <=> v35714(VarCurr) ) ).

tff(addAssignment_17654,axiom,
    ! [VarCurr: state_type] :
      ( v35714(VarCurr)
    <=> v35665(VarCurr,1) ) ).

tff(addAssignment_17653,axiom,
    ! [VarCurr: state_type] :
      ( v35665(VarCurr,1)
    <=> v35667(VarCurr,1) ) ).

tff(addAssignment_17652,axiom,
    ! [VarCurr: state_type] :
      ( v35667(VarCurr,1)
    <=> v35669(VarCurr,1) ) ).

tff(addAssignment_17651,axiom,
    ! [VarCurr: state_type] :
      ( v35669(VarCurr,1)
    <=> v35674(VarCurr,1) ) ).

tff(addAssignment_17650,axiom,
    ! [VarCurr: state_type] :
      ( v35671(VarCurr,1)
    <=> v35673(VarCurr,1) ) ).

tff(addAssignment_17649,axiom,
    ! [VarCurr: state_type] :
      ( v35673(VarCurr,1)
    <=> v35617(VarCurr,1) ) ).

tff(addAssignment_17648,axiom,
    ! [VarCurr: state_type] :
      ( v35708(VarCurr)
    <=> v35710(VarCurr) ) ).

tff(addAssignment_17647,axiom,
    ! [VarCurr: state_type] :
      ( v35710(VarCurr)
    <=> v35617(VarCurr,0) ) ).

tff(addAssignment_17646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35682(VarCurr,B)
      <=> v35684(VarCurr,B) ) ) ).

tff(addAssignment_17645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35684(VarCurr,B)
      <=> v35686(VarCurr,B) ) ) ).

tff(addAssignment_17644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35686(VarCurr,B)
      <=> v35688(VarCurr,B) ) ) ).

tff(addAssignment_17643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35688(VarCurr,B)
      <=> v35690(VarCurr,B) ) ) ).

tff(addAssignment_17642,axiom,
    ! [VarCurr: state_type] :
      ( v35645(VarCurr)
    <=> v35647(VarCurr) ) ).

tff(addAssignment_17641,axiom,
    ! [VarCurr: state_type] :
      ( v35647(VarCurr)
    <=> v35649(VarCurr) ) ).

tff(addAssignment_17640,axiom,
    ! [VarCurr: state_type] :
      ( v35649(VarCurr)
    <=> v35651(VarCurr) ) ).

tff(addAssignment_17639,axiom,
    ! [VarCurr: state_type] :
      ( v35651(VarCurr)
    <=> v35653(VarCurr) ) ).

tff(addAssignment_17638,axiom,
    ! [VarCurr: state_type] :
      ( v35653(VarCurr)
    <=> v35655(VarCurr) ) ).

tff(addAssignment_17637,axiom,
    ! [VarCurr: state_type] :
      ( v35655(VarCurr)
    <=> v35657(VarCurr) ) ).

tff(addAssignment_17636,axiom,
    ! [VarCurr: state_type] :
      ( v35657(VarCurr)
    <=> v35659(VarCurr) ) ).

tff(writeUnaryOperator_2152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35659(VarCurr)
    <=> v35680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3492,axiom,
    ! [VarCurr: state_type] :
      ( v35680(VarCurr)
    <=> ( v35661(VarCurr)
        | v35676(VarCurr) ) ) ).

tff(addAssignment_17635,axiom,
    ! [VarCurr: state_type] :
      ( v35676(VarCurr)
    <=> v35678(VarCurr) ) ).

tff(addAssignment_17634,axiom,
    ! [VarCurr: state_type] :
      ( v35678(VarCurr)
    <=> v35617(VarCurr,1) ) ).

tff(addAssignment_17633,axiom,
    ! [VarCurr: state_type] :
      ( v35661(VarCurr)
    <=> v35663(VarCurr) ) ).

tff(addAssignment_17632,axiom,
    ! [VarCurr: state_type] :
      ( v35663(VarCurr)
    <=> v35665(VarCurr,0) ) ).

tff(addAssignment_17631,axiom,
    ! [VarCurr: state_type] :
      ( v35665(VarCurr,0)
    <=> v35667(VarCurr,0) ) ).

tff(addAssignment_17630,axiom,
    ! [VarCurr: state_type] :
      ( v35667(VarCurr,0)
    <=> v35669(VarCurr,0) ) ).

tff(addAssignment_17629,axiom,
    ! [VarCurr: state_type] :
      ( v35669(VarCurr,0)
    <=> v35674(VarCurr,0) ) ).

tff(writeUnaryOperator_2151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v35674(VarCurr,B)
      <=> ~ v35671(VarCurr,B) ) ) ).

tff(addAssignment_17628,axiom,
    ! [VarCurr: state_type] :
      ( v35671(VarCurr,0)
    <=> v35673(VarCurr,0) ) ).

tff(addAssignment_17627,axiom,
    ! [VarCurr: state_type] :
      ( v35673(VarCurr,0)
    <=> v35617(VarCurr,0) ) ).

tff(addAssignment_17626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35635(VarCurr,B)
      <=> v35637(VarCurr,B) ) ) ).

tff(addAssignment_17625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35637(VarCurr,B)
      <=> v35639(VarCurr,B) ) ) ).

tff(addAssignment_17624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35639(VarCurr,B)
      <=> v35641(VarCurr,B) ) ) ).

tff(addAssignment_17623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35641(VarCurr,B)
      <=> v35643(VarCurr,B) ) ) ).

tff(addAssignment_17622,axiom,
    ! [VarCurr: state_type] :
      ( v35597(VarCurr)
    <=> v35599(VarCurr) ) ).

tff(addAssignment_17621,axiom,
    ! [VarCurr: state_type] :
      ( v35599(VarCurr)
    <=> v35601(VarCurr) ) ).

tff(addAssignment_17620,axiom,
    ! [VarCurr: state_type] :
      ( v35601(VarCurr)
    <=> v35603(VarCurr) ) ).

tff(addAssignment_17619,axiom,
    ! [VarCurr: state_type] :
      ( v35603(VarCurr)
    <=> v35605(VarCurr) ) ).

tff(addAssignment_17618,axiom,
    ! [VarCurr: state_type] :
      ( v35605(VarCurr)
    <=> v35607(VarCurr) ) ).

tff(addAssignment_17617,axiom,
    ! [VarCurr: state_type] :
      ( v35607(VarCurr)
    <=> v35609(VarCurr) ) ).

tff(addAssignment_17616,axiom,
    ! [VarCurr: state_type] :
      ( v35609(VarCurr)
    <=> v35611(VarCurr) ) ).

tff(writeUnaryOperator_2150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35611(VarCurr)
    <=> v35633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3491,axiom,
    ! [VarCurr: state_type] :
      ( v35633(VarCurr)
    <=> ( v35613(VarCurr)
        | v35629(VarCurr) ) ) ).

tff(addAssignment_17615,axiom,
    ! [VarCurr: state_type] :
      ( v35629(VarCurr)
    <=> v35631(VarCurr) ) ).

tff(addAssignment_17614,axiom,
    ! [VarCurr: state_type] :
      ( v35631(VarCurr)
    <=> v35617(VarCurr,1) ) ).

tff(addAssignment_17613,axiom,
    ! [VarCurr: state_type] :
      ( v35617(VarCurr,1)
    <=> v35619(VarCurr,1) ) ).

tff(addAssignment_17612,axiom,
    ! [VarCurr: state_type] :
      ( v35619(VarCurr,1)
    <=> v35621(VarCurr,1) ) ).

tff(addAssignment_17611,axiom,
    ! [VarCurr: state_type] :
      ( v35621(VarCurr,1)
    <=> v35623(VarCurr,1) ) ).

tff(addAssignment_17610,axiom,
    ! [VarCurr: state_type] :
      ( v35623(VarCurr,1)
    <=> v35625(VarCurr,1) ) ).

tff(addAssignment_17609,axiom,
    ! [VarCurr: state_type] :
      ( v35625(VarCurr,1)
    <=> v35627(VarCurr,1) ) ).

tff(addAssignment_17608,axiom,
    ! [VarCurr: state_type] :
      ( v35613(VarCurr)
    <=> v35615(VarCurr) ) ).

tff(addAssignment_17607,axiom,
    ! [VarCurr: state_type] :
      ( v35615(VarCurr)
    <=> v35617(VarCurr,0) ) ).

tff(addAssignment_17606,axiom,
    ! [VarCurr: state_type] :
      ( v35617(VarCurr,0)
    <=> v35619(VarCurr,0) ) ).

tff(addAssignment_17605,axiom,
    ! [VarCurr: state_type] :
      ( v35619(VarCurr,0)
    <=> v35621(VarCurr,0) ) ).

tff(addAssignment_17604,axiom,
    ! [VarCurr: state_type] :
      ( v35621(VarCurr,0)
    <=> v35623(VarCurr,0) ) ).

tff(addAssignment_17603,axiom,
    ! [VarCurr: state_type] :
      ( v35623(VarCurr,0)
    <=> v35625(VarCurr,0) ) ).

tff(addAssignment_17602,axiom,
    ! [VarCurr: state_type] :
      ( v35625(VarCurr,0)
    <=> v35627(VarCurr,0) ) ).

tff(addAssignment_17601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35587(VarCurr,B)
      <=> v35589(VarCurr,B) ) ) ).

tff(addAssignment_17600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35589(VarCurr,B)
      <=> v35591(VarCurr,B) ) ) ).

tff(addAssignment_17599,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35591(VarCurr,B)
      <=> v35593(VarCurr,B) ) ) ).

tff(addAssignment_17598,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35593(VarCurr,B)
      <=> v35595(VarCurr,B) ) ) ).

tff(addAssignment_17597,axiom,
    ! [VarCurr: state_type] :
      ( v35567(VarCurr)
    <=> v35569(VarCurr) ) ).

tff(addAssignment_17596,axiom,
    ! [VarCurr: state_type] :
      ( v35569(VarCurr)
    <=> v35571(VarCurr) ) ).

tff(addAssignment_17595,axiom,
    ! [VarCurr: state_type] :
      ( v35571(VarCurr)
    <=> v35573(VarCurr) ) ).

tff(addAssignment_17594,axiom,
    ! [VarCurr: state_type] :
      ( v35573(VarCurr)
    <=> v35575(VarCurr) ) ).

tff(addAssignment_17593,axiom,
    ! [VarCurr: state_type] :
      ( v35575(VarCurr)
    <=> v35577(VarCurr) ) ).

tff(addAssignment_17592,axiom,
    ! [VarCurr: state_type] :
      ( v35577(VarCurr)
    <=> v35579(VarCurr) ) ).

tff(addAssignment_17591,axiom,
    ! [VarCurr: state_type] :
      ( v35579(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_17590,axiom,
    ! [VarCurr: state_type] :
      ( v35553(VarCurr)
    <=> v35555(VarCurr) ) ).

tff(addAssignment_17589,axiom,
    ! [VarCurr: state_type] :
      ( v35555(VarCurr)
    <=> v35557(VarCurr) ) ).

tff(addAssignment_17588,axiom,
    ! [VarCurr: state_type] :
      ( v35557(VarCurr)
    <=> v35559(VarCurr) ) ).

tff(addAssignment_17587,axiom,
    ! [VarCurr: state_type] :
      ( v35559(VarCurr)
    <=> v35561(VarCurr) ) ).

tff(addAssignment_17586,axiom,
    ! [VarCurr: state_type] :
      ( v35561(VarCurr)
    <=> v35563(VarCurr) ) ).

tff(addAssignment_17585,axiom,
    ! [VarCurr: state_type] :
      ( v35563(VarCurr)
    <=> v35565(VarCurr) ) ).

tff(addAssignment_17584,axiom,
    ! [VarCurr: state_type] :
      ( v35565(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_17583,axiom,
    ! [VarCurr: state_type] :
      ( v35539(VarCurr)
    <=> v35541(VarCurr) ) ).

tff(addAssignment_17582,axiom,
    ! [VarCurr: state_type] :
      ( v35541(VarCurr)
    <=> v6617(VarCurr,3) ) ).

tff(addAssignment_17581,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,3)
    <=> v6619(VarCurr,3) ) ).

tff(addAssignment_17580,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,3)
    <=> v6621(VarCurr,3) ) ).

tff(addAssignment_17579,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,3)
    <=> v6747(VarCurr,3) ) ).

tff(addAssignment_17578,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,3)
    <=> v6690(VarCurr,3) ) ).

tff(addAssignment_17577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35535(VarCurr,B)
      <=> v35537(VarCurr,B) ) ) ).

tff(addAssignment_17576,axiom,
    ! [VarCurr: state_type] :
      ( ( v35537(VarCurr,11)
      <=> v6334(VarCurr,47) )
      & ( v35537(VarCurr,10)
      <=> v6334(VarCurr,46) )
      & ( v35537(VarCurr,9)
      <=> v6334(VarCurr,45) )
      & ( v35537(VarCurr,8)
      <=> v6334(VarCurr,44) )
      & ( v35537(VarCurr,7)
      <=> v6334(VarCurr,43) )
      & ( v35537(VarCurr,6)
      <=> v6334(VarCurr,42) )
      & ( v35537(VarCurr,5)
      <=> v6334(VarCurr,41) )
      & ( v35537(VarCurr,4)
      <=> v6334(VarCurr,40) )
      & ( v35537(VarCurr,3)
      <=> v6334(VarCurr,39) )
      & ( v35537(VarCurr,2)
      <=> v6334(VarCurr,38) )
      & ( v35537(VarCurr,1)
      <=> v6334(VarCurr,37) )
      & ( v35537(VarCurr,0)
      <=> v6334(VarCurr,36) ) ) ).

tff(addAssignment_17575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35503(VarCurr,B)
      <=> v35505(VarCurr,B) ) ) ).

tff(addAssignment_17574,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,0)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17573,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,1)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17572,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,2)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17571,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,3)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17570,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,4)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17569,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,5)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17568,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,6)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17567,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,7)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17566,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,8)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17565,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,9)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17564,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,10)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17563,axiom,
    ! [VarCurr: state_type] :
      ( v35505(VarCurr,11)
    <=> v35523(VarCurr) ) ).

tff(addAssignment_17562,axiom,
    ! [VarCurr: state_type] :
      ( v35523(VarCurr)
    <=> v35507(VarCurr) ) ).

tff(addAssignment_17561,axiom,
    ! [VarCurr: state_type] :
      ( v35507(VarCurr)
    <=> v35509(VarCurr,0) ) ).

tff(addAssignment_17560,axiom,
    ! [VarCurr: state_type] :
      ( v35509(VarCurr,0)
    <=> v35511(VarCurr,0) ) ).

tff(addAssignment_17559,axiom,
    ! [VarCurr: state_type] :
      ( v35511(VarCurr,0)
    <=> v35521(VarCurr,0) ) ).

tff(writeUnaryOperator_2149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v35521(VarCurr,B)
      <=> ~ v35513(VarCurr,B) ) ) ).

tff(addAssignment_17558,axiom,
    ! [VarCurr: state_type] :
      ( v35513(VarCurr,0)
    <=> v35515(VarCurr,0) ) ).

tff(addAssignment_17557,axiom,
    ! [VarCurr: state_type] :
      ( v35515(VarCurr,0)
    <=> v35518(VarCurr,0) ) ).

tff(addAssignment_17556,axiom,
    ! [VarCurr: state_type] :
      ( v35518(VarCurr,0)
    <=> v35517(VarCurr) ) ).

tff(addAssignment_17555,axiom,
    ! [VarCurr: state_type] :
      ( v35518(VarCurr,1)
    <=> v35520(VarCurr) ) ).

tff(addAssignment_17554,axiom,
    ! [VarCurr: state_type] :
      ( v35518(VarCurr,2)
    <=> v35519(VarCurr) ) ).

tff(addAssignment_17553,axiom,
    ! [VarCurr: state_type] :
      ( v35517(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_17552,axiom,
    ! [VarCurr: state_type] :
      ( v35479(VarCurr)
    <=> v35481(VarCurr) ) ).

tff(addAssignment_17551,axiom,
    ! [VarCurr: state_type] :
      ( v35481(VarCurr)
    <=> v35483(VarCurr) ) ).

tff(addAssignment_17550,axiom,
    ! [VarCurr: state_type] :
      ( v35483(VarCurr)
    <=> v35485(VarCurr) ) ).

tff(addAssignment_17549,axiom,
    ! [VarCurr: state_type] :
      ( v35485(VarCurr)
    <=> v35487(VarCurr) ) ).

tff(addAssignment_17548,axiom,
    ! [VarCurr: state_type] :
      ( v35487(VarCurr)
    <=> v35489(VarCurr) ) ).

tff(addAssignment_17547,axiom,
    ! [VarCurr: state_type] :
      ( v35489(VarCurr)
    <=> v35491(VarCurr) ) ).

tff(addAssignment_17546,axiom,
    ! [VarCurr: state_type] :
      ( v35491(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_17545,axiom,
    ! [VarCurr: state_type] :
      ( v35465(VarCurr)
    <=> v35467(VarCurr) ) ).

tff(addAssignment_17544,axiom,
    ! [VarCurr: state_type] :
      ( v35467(VarCurr)
    <=> v35469(VarCurr) ) ).

tff(addAssignment_17543,axiom,
    ! [VarCurr: state_type] :
      ( v35469(VarCurr)
    <=> v35471(VarCurr) ) ).

tff(addAssignment_17542,axiom,
    ! [VarCurr: state_type] :
      ( v35471(VarCurr)
    <=> v35473(VarCurr) ) ).

tff(addAssignment_17541,axiom,
    ! [VarCurr: state_type] :
      ( v35473(VarCurr)
    <=> v35475(VarCurr) ) ).

tff(addAssignment_17540,axiom,
    ! [VarCurr: state_type] :
      ( v35475(VarCurr)
    <=> v35477(VarCurr) ) ).

tff(addAssignment_17539,axiom,
    ! [VarCurr: state_type] :
      ( v35477(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_17538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35441(VarCurr,B)
      <=> v35443(VarCurr,B) ) ) ).

tff(addAssignment_17537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35443(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_17536,axiom,
    ! [VarCurr: state_type] :
      ( v8496(VarCurr)
    <=> v8498(VarCurr) ) ).

tff(addAssignment_17535,axiom,
    ! [VarCurr: state_type] :
      ( v8498(VarCurr)
    <=> v8500(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_205,axiom,
    ! [VarCurr: state_type] :
      ( v8500(VarCurr)
    <=> ( ( v8502(VarCurr,11)
        <=> v8506(VarCurr,11) )
        & ( v8502(VarCurr,10)
        <=> v8506(VarCurr,10) )
        & ( v8502(VarCurr,9)
        <=> v8506(VarCurr,9) )
        & ( v8502(VarCurr,8)
        <=> v8506(VarCurr,8) )
        & ( v8502(VarCurr,7)
        <=> v8506(VarCurr,7) )
        & ( v8502(VarCurr,6)
        <=> v8506(VarCurr,6) )
        & ( v8502(VarCurr,5)
        <=> v8506(VarCurr,5) )
        & ( v8502(VarCurr,4)
        <=> v8506(VarCurr,4) )
        & ( v8502(VarCurr,3)
        <=> v8506(VarCurr,3) )
        & ( v8502(VarCurr,2)
        <=> v8506(VarCurr,2) )
        & ( v8502(VarCurr,1)
        <=> v8506(VarCurr,1) )
        & ( v8502(VarCurr,0)
        <=> v8506(VarCurr,0) ) ) ) ).

tff(addAssignment_17534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8506(VarCurr,B)
      <=> v8508(VarCurr,B) ) ) ).

tff(addAssignment_17533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8508(VarCurr,B)
      <=> v8510(VarCurr,B) ) ) ).

tff(addAssignment_17532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8510(VarCurr,B)
      <=> v8512(VarCurr,B) ) ) ).

tff(addAssignment_17531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8512(VarCurr,B)
      <=> v8514(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_566,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8514(VarCurr,B)
      <=> ( v35411(VarCurr,B)
          | v35430(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_565,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35430(VarCurr,B)
      <=> ( v35282(VarCurr,B)
          & v35431(VarCurr,B) ) ) ) ).

tff(addAssignment_17530,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,0)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17529,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,1)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17528,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,2)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17527,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,3)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17526,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,4)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17525,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,5)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17524,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,6)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17523,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,7)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17522,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,8)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17521,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,9)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17520,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,10)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17519,axiom,
    ! [VarCurr: state_type] :
      ( v35431(VarCurr,11)
    <=> v35432(VarCurr) ) ).

tff(addAssignment_17518,axiom,
    ! [VarCurr: state_type] :
      ( v35432(VarCurr)
    <=> v35401(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_564,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35411(VarCurr,B)
      <=> ( v35412(VarCurr,B)
          | v35427(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_563,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35427(VarCurr,B)
      <=> ( v35131(VarCurr,B)
          & v35428(VarCurr,B) ) ) ) ).

tff(addAssignment_17517,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,0)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17516,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,1)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17515,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,2)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17514,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,3)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17513,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,4)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17512,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,5)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17511,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,6)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17510,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,7)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17509,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,8)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17508,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,9)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17507,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,10)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17506,axiom,
    ! [VarCurr: state_type] :
      ( v35428(VarCurr,11)
    <=> v35429(VarCurr) ) ).

tff(addAssignment_17505,axiom,
    ! [VarCurr: state_type] :
      ( v35429(VarCurr)
    <=> v35251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35412(VarCurr,B)
      <=> ( v35413(VarCurr,B)
          | v35424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_561,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35424(VarCurr,B)
      <=> ( v34980(VarCurr,B)
          & v35425(VarCurr,B) ) ) ) ).

tff(addAssignment_17504,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,0)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17503,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,1)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17502,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,2)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17501,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,3)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17500,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,4)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17499,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,5)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17498,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,6)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17497,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,7)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17496,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,8)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17495,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,9)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17494,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,10)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17493,axiom,
    ! [VarCurr: state_type] :
      ( v35425(VarCurr,11)
    <=> v35426(VarCurr) ) ).

tff(addAssignment_17492,axiom,
    ! [VarCurr: state_type] :
      ( v35426(VarCurr)
    <=> v35100(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35413(VarCurr,B)
      <=> ( v35414(VarCurr,B)
          | v35421(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_559,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35421(VarCurr,B)
      <=> ( v34829(VarCurr,B)
          & v35422(VarCurr,B) ) ) ) ).

tff(addAssignment_17491,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,0)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17490,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,1)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17489,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,2)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17488,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,3)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17487,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,4)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17486,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,5)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17485,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,6)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17484,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,7)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17483,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,8)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17482,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,9)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17481,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,10)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17480,axiom,
    ! [VarCurr: state_type] :
      ( v35422(VarCurr,11)
    <=> v35423(VarCurr) ) ).

tff(addAssignment_17479,axiom,
    ! [VarCurr: state_type] :
      ( v35423(VarCurr)
    <=> v34949(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35414(VarCurr,B)
      <=> ( v35415(VarCurr,B)
          | v35418(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35418(VarCurr,B)
      <=> ( v34667(VarCurr,B)
          & v35419(VarCurr,B) ) ) ) ).

tff(addAssignment_17478,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,0)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17477,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,1)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17476,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,2)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17475,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,3)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17474,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,4)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17473,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,5)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17472,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,6)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17471,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,7)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17470,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,8)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17469,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,9)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17468,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,10)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17467,axiom,
    ! [VarCurr: state_type] :
      ( v35419(VarCurr,11)
    <=> v35420(VarCurr) ) ).

tff(addAssignment_17466,axiom,
    ! [VarCurr: state_type] :
      ( v35420(VarCurr)
    <=> v34798(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35415(VarCurr,B)
      <=> ( v8516(VarCurr,B)
          & v35416(VarCurr,B) ) ) ) ).

tff(addAssignment_17465,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,0)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17464,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,1)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17463,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,2)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17462,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,3)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17461,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,4)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17460,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,5)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17459,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,6)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17458,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,7)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17457,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,8)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17456,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,9)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17455,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,10)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17454,axiom,
    ! [VarCurr: state_type] :
      ( v35416(VarCurr,11)
    <=> v35417(VarCurr) ) ).

tff(addAssignment_17453,axiom,
    ! [VarCurr: state_type] :
      ( v35417(VarCurr)
    <=> v8986(VarCurr) ) ).

tff(addAssignment_17452,axiom,
    ! [VarCurr: state_type] :
      ( v35401(VarCurr)
    <=> v35403(VarCurr) ) ).

tff(addAssignment_17451,axiom,
    ! [VarCurr: state_type] :
      ( v35403(VarCurr)
    <=> v35405(VarCurr) ) ).

tff(addAssignment_17450,axiom,
    ! [VarCurr: state_type] :
      ( v35405(VarCurr)
    <=> v35407(VarCurr) ) ).

tff(addAssignment_17449,axiom,
    ! [VarCurr: state_type] :
      ( v35407(VarCurr)
    <=> v35409(VarCurr) ) ).

tff(addAssignment_17448,axiom,
    ! [VarCurr: state_type] :
      ( v35409(VarCurr)
    <=> v34468(VarCurr) ) ).

tff(addAssignment_17447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35282(VarCurr,B)
      <=> v35284(VarCurr,B) ) ) ).

tff(addAssignment_17446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35284(VarCurr,B)
      <=> v35286(VarCurr,B) ) ) ).

tff(addAssignment_17445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35286(VarCurr,B)
      <=> v35288(VarCurr,B) ) ) ).

tff(addAssignment_17444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35288(VarCurr,B)
      <=> v35290(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35384(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v35290(VarNext,B)
            <=> v35290(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_422,axiom,
    ! [VarNext: state_type] :
      ( v35384(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35290(VarNext,B)
          <=> v35394(VarNext,B) ) ) ) ).

tff(addAssignment_17443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35394(VarNext,B)
          <=> v35392(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35395(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35392(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_304,axiom,
    ! [VarCurr: state_type] :
      ( v35395(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35392(VarCurr,B)
          <=> v35312(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3490,axiom,
    ! [VarCurr: state_type] :
      ( v35395(VarCurr)
    <=> ( v35396(VarCurr)
        & v35397(VarCurr) ) ) ).

tff(writeUnaryOperator_2148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35397(VarCurr)
    <=> v35302(VarCurr) ) ).

tff(writeUnaryOperator_2147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35396(VarCurr)
    <=> v35292(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35384(VarNext)
      <=> v35385(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35385(VarNext)
      <=> ( v35386(VarNext)
          & v35316(VarNext) ) ) ) ).

tff(writeUnaryOperator_2146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35386(VarNext)
      <=> v35388(VarNext) ) ) ).

tff(addAssignment_17442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35388(VarNext)
      <=> v35316(VarCurr) ) ) ).

tff(addAssignment_17441,axiom,
    ! [VarCurr: state_type] :
      ( v35316(VarCurr)
    <=> v35318(VarCurr) ) ).

tff(addAssignment_17440,axiom,
    ! [VarCurr: state_type] :
      ( v35318(VarCurr)
    <=> v35320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3487,axiom,
    ! [VarCurr: state_type] :
      ( v35320(VarCurr)
    <=> ( v35381(VarCurr)
        | v35377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3486,axiom,
    ! [VarCurr: state_type] :
      ( v35381(VarCurr)
    <=> ( v35322(VarCurr)
        & v35326(VarCurr) ) ) ).

tff(addAssignment_17439,axiom,
    ! [VarCurr: state_type] :
      ( v35377(VarCurr)
    <=> v35379(VarCurr) ) ).

tff(addAssignment_17438,axiom,
    ! [VarCurr: state_type] :
      ( v35379(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35361(VarNext)
       => ( v35326(VarNext)
        <=> v35326(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_421,axiom,
    ! [VarNext: state_type] :
      ( v35361(VarNext)
     => ( v35326(VarNext)
      <=> v35371(VarNext) ) ) ).

tff(addAssignment_17437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35371(VarNext)
      <=> v35369(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3485,axiom,
    ! [VarCurr: state_type] :
      ( v35369(VarCurr)
    <=> ( v35372(VarCurr)
        & v35373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3484,axiom,
    ! [VarCurr: state_type] :
      ( v35373(VarCurr)
    <=> ( v35332(VarCurr)
        | v35356(VarCurr) ) ) ).

tff(writeUnaryOperator_2145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35372(VarCurr)
    <=> v35328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35361(VarNext)
      <=> v35362(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3482,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35362(VarNext)
      <=> ( v35364(VarNext)
          & v35366(VarNext) ) ) ) ).

tff(writeUnaryOperator_2144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35366(VarCurr)
    <=> v35322(VarCurr) ) ).

tff(addAssignment_17436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35364(VarNext)
      <=> v35322(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_141,axiom,
    ( v35326(constB0)
  <=> $true ) ).

tff(addAssignment_17435,axiom,
    ! [VarCurr: state_type] :
      ( v35356(VarCurr)
    <=> v35358(VarCurr) ) ).

tff(addAssignment_17434,axiom,
    ! [VarCurr: state_type] :
      ( v35358(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17433,axiom,
    ! [VarCurr: state_type] :
      ( v35332(VarCurr)
    <=> v35334(VarCurr) ) ).

tff(addAssignment_17432,axiom,
    ! [VarCurr: state_type] :
      ( v35334(VarCurr)
    <=> v34642(VarCurr) ) ).

tff(addAssignment_17431,axiom,
    ! [VarCurr: state_type] :
      ( v34642(VarCurr)
    <=> v35337(VarCurr) ) ).

tff(addAssignment_17430,axiom,
    ! [VarCurr: state_type] :
      ( v35337(VarCurr)
    <=> v35339(VarCurr) ) ).

tff(writeUnaryOperator_2143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35339(VarCurr)
    <=> v35353(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3481,axiom,
    ! [VarCurr: state_type] :
      ( v35353(VarCurr)
    <=> ( v35354(VarCurr)
        | v35349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3480,axiom,
    ! [VarCurr: state_type] :
      ( v35354(VarCurr)
    <=> ( v35341(VarCurr)
        | v35345(VarCurr) ) ) ).

tff(addAssignment_17429,axiom,
    ! [VarCurr: state_type] :
      ( v35349(VarCurr)
    <=> v35351(VarCurr) ) ).

tff(addAssignment_17428,axiom,
    ! [VarCurr: state_type] :
      ( v35351(VarCurr)
    <=> v34731(VarCurr,2) ) ).

tff(addAssignment_17427,axiom,
    ! [VarCurr: state_type] :
      ( v35345(VarCurr)
    <=> v35347(VarCurr) ) ).

tff(addAssignment_17426,axiom,
    ! [VarCurr: state_type] :
      ( v35347(VarCurr)
    <=> v8916(VarCurr,1) ) ).

tff(addAssignment_17425,axiom,
    ! [VarCurr: state_type] :
      ( v35341(VarCurr)
    <=> v35343(VarCurr) ) ).

tff(addAssignment_17424,axiom,
    ! [VarCurr: state_type] :
      ( v35343(VarCurr)
    <=> v34731(VarCurr,0) ) ).

tff(addAssignment_17423,axiom,
    ! [VarCurr: state_type] :
      ( v35328(VarCurr)
    <=> v35330(VarCurr) ) ).

tff(addAssignment_17422,axiom,
    ! [VarCurr: state_type] :
      ( v35330(VarCurr)
    <=> $false ) ).

tff(addAssignment_17421,axiom,
    ! [VarCurr: state_type] :
      ( v35322(VarCurr)
    <=> v35324(VarCurr) ) ).

tff(addAssignment_17420,axiom,
    ! [VarCurr: state_type] :
      ( v35324(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35312(VarCurr,B)
      <=> v35314(VarCurr,B) ) ) ).

tff(addAssignment_17418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35314(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_17417,axiom,
    ! [VarCurr: state_type] :
      ( v35302(VarCurr)
    <=> v35304(VarCurr) ) ).

tff(addAssignment_17416,axiom,
    ! [VarCurr: state_type] :
      ( v35304(VarCurr)
    <=> v35306(VarCurr) ) ).

tff(addAssignment_17415,axiom,
    ! [VarCurr: state_type] :
      ( v35306(VarCurr)
    <=> v35308(VarCurr) ) ).

tff(addAssignment_17414,axiom,
    ! [VarCurr: state_type] :
      ( v35308(VarCurr)
    <=> v35310(VarCurr) ) ).

tff(addAssignment_17413,axiom,
    ! [VarCurr: state_type] :
      ( v35310(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_17412,axiom,
    ! [VarCurr: state_type] :
      ( v35292(VarCurr)
    <=> v35294(VarCurr) ) ).

tff(addAssignment_17411,axiom,
    ! [VarCurr: state_type] :
      ( v35294(VarCurr)
    <=> v35296(VarCurr) ) ).

tff(addAssignment_17410,axiom,
    ! [VarCurr: state_type] :
      ( v35296(VarCurr)
    <=> v35298(VarCurr) ) ).

tff(addAssignment_17409,axiom,
    ! [VarCurr: state_type] :
      ( v35298(VarCurr)
    <=> v35300(VarCurr) ) ).

tff(addAssignment_17408,axiom,
    ! [VarCurr: state_type] :
      ( v35300(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_17407,axiom,
    ! [VarCurr: state_type] :
      ( v35251(VarCurr)
    <=> v35253(VarCurr) ) ).

tff(addAssignment_17406,axiom,
    ! [VarCurr: state_type] :
      ( v35253(VarCurr)
    <=> v35255(VarCurr) ) ).

tff(addAssignment_17405,axiom,
    ! [VarCurr: state_type] :
      ( v35255(VarCurr)
    <=> v35257(VarCurr) ) ).

tff(addAssignment_17404,axiom,
    ! [VarCurr: state_type] :
      ( v35257(VarCurr)
    <=> v35259(VarCurr) ) ).

tff(addAssignment_17403,axiom,
    ! [VarCurr: state_type] :
      ( v35259(VarCurr)
    <=> v35261(VarCurr) ) ).

tff(addAssignment_17402,axiom,
    ! [VarCurr: state_type] :
      ( v35261(VarCurr)
    <=> v35263(VarCurr) ) ).

tff(addAssignment_17401,axiom,
    ! [VarCurr: state_type] :
      ( v35263(VarCurr)
    <=> v35265(VarCurr) ) ).

tff(writeUnaryOperator_2142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35265(VarCurr)
    <=> v35279(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3479,axiom,
    ! [VarCurr: state_type] :
      ( v35279(VarCurr)
    <=> ( v35280(VarCurr)
        | v35275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3478,axiom,
    ! [VarCurr: state_type] :
      ( v35280(VarCurr)
    <=> ( v35267(VarCurr)
        | v35271(VarCurr) ) ) ).

tff(addAssignment_17400,axiom,
    ! [VarCurr: state_type] :
      ( v35275(VarCurr)
    <=> v35277(VarCurr) ) ).

tff(addAssignment_17399,axiom,
    ! [VarCurr: state_type] :
      ( v35277(VarCurr)
    <=> v34478(VarCurr,2) ) ).

tff(addAssignment_17398,axiom,
    ! [VarCurr: state_type] :
      ( v35271(VarCurr)
    <=> v35273(VarCurr) ) ).

tff(addAssignment_17397,axiom,
    ! [VarCurr: state_type] :
      ( v35273(VarCurr)
    <=> v9006(VarCurr,1) ) ).

tff(addAssignment_17396,axiom,
    ! [VarCurr: state_type] :
      ( v35267(VarCurr)
    <=> v35269(VarCurr) ) ).

tff(addAssignment_17395,axiom,
    ! [VarCurr: state_type] :
      ( v35269(VarCurr)
    <=> v9006(VarCurr,0) ) ).

tff(addAssignment_17394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35131(VarCurr,B)
      <=> v35133(VarCurr,B) ) ) ).

tff(addAssignment_17393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35133(VarCurr,B)
      <=> v35135(VarCurr,B) ) ) ).

tff(addAssignment_17392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35135(VarCurr,B)
      <=> v35137(VarCurr,B) ) ) ).

tff(addAssignment_17391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35137(VarCurr,B)
      <=> v35139(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35234(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v35139(VarNext,B)
            <=> v35139(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_420,axiom,
    ! [VarNext: state_type] :
      ( v35234(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35139(VarNext,B)
          <=> v35244(VarNext,B) ) ) ) ).

tff(addAssignment_17390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35244(VarNext,B)
          <=> v35242(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35245(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35242(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_303,axiom,
    ! [VarCurr: state_type] :
      ( v35245(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35242(VarCurr,B)
          <=> v35161(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3477,axiom,
    ! [VarCurr: state_type] :
      ( v35245(VarCurr)
    <=> ( v35246(VarCurr)
        & v35247(VarCurr) ) ) ).

tff(writeUnaryOperator_2141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35247(VarCurr)
    <=> v35151(VarCurr) ) ).

tff(writeUnaryOperator_2140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35246(VarCurr)
    <=> v35141(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35234(VarNext)
      <=> v35235(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35235(VarNext)
      <=> ( v35236(VarNext)
          & v35165(VarNext) ) ) ) ).

tff(writeUnaryOperator_2139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35236(VarNext)
      <=> v35238(VarNext) ) ) ).

tff(addAssignment_17389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35238(VarNext)
      <=> v35165(VarCurr) ) ) ).

tff(addAssignment_17388,axiom,
    ! [VarCurr: state_type] :
      ( v35165(VarCurr)
    <=> v35167(VarCurr) ) ).

tff(addAssignment_17387,axiom,
    ! [VarCurr: state_type] :
      ( v35167(VarCurr)
    <=> v35169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3474,axiom,
    ! [VarCurr: state_type] :
      ( v35169(VarCurr)
    <=> ( v35231(VarCurr)
        | v35227(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3473,axiom,
    ! [VarCurr: state_type] :
      ( v35231(VarCurr)
    <=> ( v35171(VarCurr)
        & v35175(VarCurr) ) ) ).

tff(addAssignment_17386,axiom,
    ! [VarCurr: state_type] :
      ( v35227(VarCurr)
    <=> v35229(VarCurr) ) ).

tff(addAssignment_17385,axiom,
    ! [VarCurr: state_type] :
      ( v35229(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35211(VarNext)
       => ( v35175(VarNext)
        <=> v35175(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_419,axiom,
    ! [VarNext: state_type] :
      ( v35211(VarNext)
     => ( v35175(VarNext)
      <=> v35221(VarNext) ) ) ).

tff(addAssignment_17384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35221(VarNext)
      <=> v35219(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3472,axiom,
    ! [VarCurr: state_type] :
      ( v35219(VarCurr)
    <=> ( v35222(VarCurr)
        & v35223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3471,axiom,
    ! [VarCurr: state_type] :
      ( v35223(VarCurr)
    <=> ( v35181(VarCurr)
        | v35206(VarCurr) ) ) ).

tff(writeUnaryOperator_2138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35222(VarCurr)
    <=> v35177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35211(VarNext)
      <=> v35212(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35212(VarNext)
      <=> ( v35214(VarNext)
          & v35216(VarNext) ) ) ) ).

tff(writeUnaryOperator_2137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35216(VarCurr)
    <=> v35171(VarCurr) ) ).

tff(addAssignment_17383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35214(VarNext)
      <=> v35171(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_140,axiom,
    ( v35175(constB0)
  <=> $true ) ).

tff(addAssignment_17382,axiom,
    ! [VarCurr: state_type] :
      ( v35206(VarCurr)
    <=> v35208(VarCurr) ) ).

tff(addAssignment_17381,axiom,
    ! [VarCurr: state_type] :
      ( v35208(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17380,axiom,
    ! [VarCurr: state_type] :
      ( v35181(VarCurr)
    <=> v35183(VarCurr) ) ).

tff(addAssignment_17379,axiom,
    ! [VarCurr: state_type] :
      ( v35183(VarCurr)
    <=> v35185(VarCurr) ) ).

tff(addAssignment_17378,axiom,
    ! [VarCurr: state_type] :
      ( v35185(VarCurr)
    <=> v35187(VarCurr) ) ).

tff(addAssignment_17377,axiom,
    ! [VarCurr: state_type] :
      ( v35187(VarCurr)
    <=> v35189(VarCurr) ) ).

tff(writeUnaryOperator_2136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35189(VarCurr)
    <=> v35203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3468,axiom,
    ! [VarCurr: state_type] :
      ( v35203(VarCurr)
    <=> ( v35204(VarCurr)
        | v35199(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3467,axiom,
    ! [VarCurr: state_type] :
      ( v35204(VarCurr)
    <=> ( v35191(VarCurr)
        | v35195(VarCurr) ) ) ).

tff(addAssignment_17376,axiom,
    ! [VarCurr: state_type] :
      ( v35199(VarCurr)
    <=> v35201(VarCurr) ) ).

tff(addAssignment_17375,axiom,
    ! [VarCurr: state_type] :
      ( v35201(VarCurr)
    <=> v34731(VarCurr,2) ) ).

tff(addAssignment_17374,axiom,
    ! [VarCurr: state_type] :
      ( v34731(VarCurr,2)
    <=> v34733(VarCurr,2) ) ).

tff(addAssignment_17373,axiom,
    ! [VarCurr: state_type] :
      ( v34733(VarCurr,2)
    <=> v34735(VarCurr,2) ) ).

tff(addAssignment_17372,axiom,
    ! [VarCurr: state_type] :
      ( v34735(VarCurr,2)
    <=> v34740(VarCurr,2) ) ).

tff(addAssignment_17371,axiom,
    ! [VarCurr: state_type] :
      ( v34737(VarCurr,2)
    <=> v34739(VarCurr,2) ) ).

tff(addAssignment_17370,axiom,
    ! [VarCurr: state_type] :
      ( v34739(VarCurr,2)
    <=> v8916(VarCurr,2) ) ).

tff(addAssignment_17369,axiom,
    ! [VarCurr: state_type] :
      ( v35195(VarCurr)
    <=> v35197(VarCurr) ) ).

tff(addAssignment_17368,axiom,
    ! [VarCurr: state_type] :
      ( v35197(VarCurr)
    <=> v8916(VarCurr,1) ) ).

tff(addAssignment_17367,axiom,
    ! [VarCurr: state_type] :
      ( v35191(VarCurr)
    <=> v35193(VarCurr) ) ).

tff(addAssignment_17366,axiom,
    ! [VarCurr: state_type] :
      ( v35193(VarCurr)
    <=> v8916(VarCurr,0) ) ).

tff(addAssignment_17365,axiom,
    ! [VarCurr: state_type] :
      ( v35177(VarCurr)
    <=> v35179(VarCurr) ) ).

tff(addAssignment_17364,axiom,
    ! [VarCurr: state_type] :
      ( v35179(VarCurr)
    <=> $false ) ).

tff(addAssignment_17363,axiom,
    ! [VarCurr: state_type] :
      ( v35171(VarCurr)
    <=> v35173(VarCurr) ) ).

tff(addAssignment_17362,axiom,
    ! [VarCurr: state_type] :
      ( v35173(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35161(VarCurr,B)
      <=> v35163(VarCurr,B) ) ) ).

tff(addAssignment_17360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35163(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_17359,axiom,
    ! [VarCurr: state_type] :
      ( v35151(VarCurr)
    <=> v35153(VarCurr) ) ).

tff(addAssignment_17358,axiom,
    ! [VarCurr: state_type] :
      ( v35153(VarCurr)
    <=> v35155(VarCurr) ) ).

tff(addAssignment_17357,axiom,
    ! [VarCurr: state_type] :
      ( v35155(VarCurr)
    <=> v35157(VarCurr) ) ).

tff(addAssignment_17356,axiom,
    ! [VarCurr: state_type] :
      ( v35157(VarCurr)
    <=> v35159(VarCurr) ) ).

tff(addAssignment_17355,axiom,
    ! [VarCurr: state_type] :
      ( v35159(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_17354,axiom,
    ! [VarCurr: state_type] :
      ( v35141(VarCurr)
    <=> v35143(VarCurr) ) ).

tff(addAssignment_17353,axiom,
    ! [VarCurr: state_type] :
      ( v35143(VarCurr)
    <=> v35145(VarCurr) ) ).

tff(addAssignment_17352,axiom,
    ! [VarCurr: state_type] :
      ( v35145(VarCurr)
    <=> v35147(VarCurr) ) ).

tff(addAssignment_17351,axiom,
    ! [VarCurr: state_type] :
      ( v35147(VarCurr)
    <=> v35149(VarCurr) ) ).

tff(addAssignment_17350,axiom,
    ! [VarCurr: state_type] :
      ( v35149(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_17349,axiom,
    ! [VarCurr: state_type] :
      ( v35100(VarCurr)
    <=> v35102(VarCurr) ) ).

tff(addAssignment_17348,axiom,
    ! [VarCurr: state_type] :
      ( v35102(VarCurr)
    <=> v35104(VarCurr) ) ).

tff(addAssignment_17347,axiom,
    ! [VarCurr: state_type] :
      ( v35104(VarCurr)
    <=> v35106(VarCurr) ) ).

tff(addAssignment_17346,axiom,
    ! [VarCurr: state_type] :
      ( v35106(VarCurr)
    <=> v35108(VarCurr) ) ).

tff(addAssignment_17345,axiom,
    ! [VarCurr: state_type] :
      ( v35108(VarCurr)
    <=> v35110(VarCurr) ) ).

tff(addAssignment_17344,axiom,
    ! [VarCurr: state_type] :
      ( v35110(VarCurr)
    <=> v35112(VarCurr) ) ).

tff(addAssignment_17343,axiom,
    ! [VarCurr: state_type] :
      ( v35112(VarCurr)
    <=> v35114(VarCurr) ) ).

tff(writeUnaryOperator_2135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35114(VarCurr)
    <=> v35128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3466,axiom,
    ! [VarCurr: state_type] :
      ( v35128(VarCurr)
    <=> ( v35129(VarCurr)
        | v35124(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3465,axiom,
    ! [VarCurr: state_type] :
      ( v35129(VarCurr)
    <=> ( v35116(VarCurr)
        | v35120(VarCurr) ) ) ).

tff(addAssignment_17342,axiom,
    ! [VarCurr: state_type] :
      ( v35124(VarCurr)
    <=> v35126(VarCurr) ) ).

tff(addAssignment_17341,axiom,
    ! [VarCurr: state_type] :
      ( v35126(VarCurr)
    <=> v9006(VarCurr,2) ) ).

tff(addAssignment_17340,axiom,
    ! [VarCurr: state_type] :
      ( v35120(VarCurr)
    <=> v35122(VarCurr) ) ).

tff(addAssignment_17339,axiom,
    ! [VarCurr: state_type] :
      ( v35122(VarCurr)
    <=> v34478(VarCurr,1) ) ).

tff(addAssignment_17338,axiom,
    ! [VarCurr: state_type] :
      ( v35116(VarCurr)
    <=> v35118(VarCurr) ) ).

tff(addAssignment_17337,axiom,
    ! [VarCurr: state_type] :
      ( v35118(VarCurr)
    <=> v34478(VarCurr,0) ) ).

tff(addAssignment_17336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34980(VarCurr,B)
      <=> v34982(VarCurr,B) ) ) ).

tff(addAssignment_17335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34982(VarCurr,B)
      <=> v34984(VarCurr,B) ) ) ).

tff(addAssignment_17334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34984(VarCurr,B)
      <=> v34986(VarCurr,B) ) ) ).

tff(addAssignment_17333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34986(VarCurr,B)
      <=> v34988(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35083(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v34988(VarNext,B)
            <=> v34988(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_418,axiom,
    ! [VarNext: state_type] :
      ( v35083(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34988(VarNext,B)
          <=> v35093(VarNext,B) ) ) ) ).

tff(addAssignment_17332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35093(VarNext,B)
          <=> v35091(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35094(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35091(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_302,axiom,
    ! [VarCurr: state_type] :
      ( v35094(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v35091(VarCurr,B)
          <=> v35010(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3464,axiom,
    ! [VarCurr: state_type] :
      ( v35094(VarCurr)
    <=> ( v35095(VarCurr)
        & v35096(VarCurr) ) ) ).

tff(writeUnaryOperator_2134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35096(VarCurr)
    <=> v35000(VarCurr) ) ).

tff(writeUnaryOperator_2133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35095(VarCurr)
    <=> v34990(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35083(VarNext)
      <=> v35084(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35084(VarNext)
      <=> ( v35085(VarNext)
          & v35014(VarNext) ) ) ) ).

tff(writeUnaryOperator_2132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35085(VarNext)
      <=> v35087(VarNext) ) ) ).

tff(addAssignment_17331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35087(VarNext)
      <=> v35014(VarCurr) ) ) ).

tff(addAssignment_17330,axiom,
    ! [VarCurr: state_type] :
      ( v35014(VarCurr)
    <=> v35016(VarCurr) ) ).

tff(addAssignment_17329,axiom,
    ! [VarCurr: state_type] :
      ( v35016(VarCurr)
    <=> v35018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3461,axiom,
    ! [VarCurr: state_type] :
      ( v35018(VarCurr)
    <=> ( v35080(VarCurr)
        | v35076(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3460,axiom,
    ! [VarCurr: state_type] :
      ( v35080(VarCurr)
    <=> ( v35020(VarCurr)
        & v35024(VarCurr) ) ) ).

tff(addAssignment_17328,axiom,
    ! [VarCurr: state_type] :
      ( v35076(VarCurr)
    <=> v35078(VarCurr) ) ).

tff(addAssignment_17327,axiom,
    ! [VarCurr: state_type] :
      ( v35078(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v35060(VarNext)
       => ( v35024(VarNext)
        <=> v35024(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_417,axiom,
    ! [VarNext: state_type] :
      ( v35060(VarNext)
     => ( v35024(VarNext)
      <=> v35070(VarNext) ) ) ).

tff(addAssignment_17326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35070(VarNext)
      <=> v35068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3459,axiom,
    ! [VarCurr: state_type] :
      ( v35068(VarCurr)
    <=> ( v35071(VarCurr)
        & v35072(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3458,axiom,
    ! [VarCurr: state_type] :
      ( v35072(VarCurr)
    <=> ( v35030(VarCurr)
        | v35055(VarCurr) ) ) ).

tff(writeUnaryOperator_2131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35071(VarCurr)
    <=> v35026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35060(VarNext)
      <=> v35061(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35061(VarNext)
      <=> ( v35063(VarNext)
          & v35065(VarNext) ) ) ) ).

tff(writeUnaryOperator_2130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35065(VarCurr)
    <=> v35020(VarCurr) ) ).

tff(addAssignment_17325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v35063(VarNext)
      <=> v35020(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_139,axiom,
    ( v35024(constB0)
  <=> $true ) ).

tff(addAssignment_17324,axiom,
    ! [VarCurr: state_type] :
      ( v35055(VarCurr)
    <=> v35057(VarCurr) ) ).

tff(addAssignment_17323,axiom,
    ! [VarCurr: state_type] :
      ( v35057(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17322,axiom,
    ! [VarCurr: state_type] :
      ( v35030(VarCurr)
    <=> v35032(VarCurr) ) ).

tff(addAssignment_17321,axiom,
    ! [VarCurr: state_type] :
      ( v35032(VarCurr)
    <=> v35034(VarCurr) ) ).

tff(addAssignment_17320,axiom,
    ! [VarCurr: state_type] :
      ( v35034(VarCurr)
    <=> v35036(VarCurr) ) ).

tff(addAssignment_17319,axiom,
    ! [VarCurr: state_type] :
      ( v35036(VarCurr)
    <=> v35038(VarCurr) ) ).

tff(writeUnaryOperator_2129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v35038(VarCurr)
    <=> v35052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3455,axiom,
    ! [VarCurr: state_type] :
      ( v35052(VarCurr)
    <=> ( v35053(VarCurr)
        | v35048(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3454,axiom,
    ! [VarCurr: state_type] :
      ( v35053(VarCurr)
    <=> ( v35040(VarCurr)
        | v35044(VarCurr) ) ) ).

tff(addAssignment_17318,axiom,
    ! [VarCurr: state_type] :
      ( v35048(VarCurr)
    <=> v35050(VarCurr) ) ).

tff(addAssignment_17317,axiom,
    ! [VarCurr: state_type] :
      ( v35050(VarCurr)
    <=> v8916(VarCurr,2) ) ).

tff(addAssignment_17316,axiom,
    ! [VarCurr: state_type] :
      ( v35044(VarCurr)
    <=> v35046(VarCurr) ) ).

tff(addAssignment_17315,axiom,
    ! [VarCurr: state_type] :
      ( v35046(VarCurr)
    <=> v34731(VarCurr,1) ) ).

tff(addAssignment_17314,axiom,
    ! [VarCurr: state_type] :
      ( v35040(VarCurr)
    <=> v35042(VarCurr) ) ).

tff(addAssignment_17313,axiom,
    ! [VarCurr: state_type] :
      ( v35042(VarCurr)
    <=> v34731(VarCurr,0) ) ).

tff(addAssignment_17312,axiom,
    ! [VarCurr: state_type] :
      ( v35026(VarCurr)
    <=> v35028(VarCurr) ) ).

tff(addAssignment_17311,axiom,
    ! [VarCurr: state_type] :
      ( v35028(VarCurr)
    <=> $false ) ).

tff(addAssignment_17310,axiom,
    ! [VarCurr: state_type] :
      ( v35020(VarCurr)
    <=> v35022(VarCurr) ) ).

tff(addAssignment_17309,axiom,
    ! [VarCurr: state_type] :
      ( v35022(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35010(VarCurr,B)
      <=> v35012(VarCurr,B) ) ) ).

tff(addAssignment_17307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v35012(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_17306,axiom,
    ! [VarCurr: state_type] :
      ( v35000(VarCurr)
    <=> v35002(VarCurr) ) ).

tff(addAssignment_17305,axiom,
    ! [VarCurr: state_type] :
      ( v35002(VarCurr)
    <=> v35004(VarCurr) ) ).

tff(addAssignment_17304,axiom,
    ! [VarCurr: state_type] :
      ( v35004(VarCurr)
    <=> v35006(VarCurr) ) ).

tff(addAssignment_17303,axiom,
    ! [VarCurr: state_type] :
      ( v35006(VarCurr)
    <=> v35008(VarCurr) ) ).

tff(addAssignment_17302,axiom,
    ! [VarCurr: state_type] :
      ( v35008(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_17301,axiom,
    ! [VarCurr: state_type] :
      ( v34990(VarCurr)
    <=> v34992(VarCurr) ) ).

tff(addAssignment_17300,axiom,
    ! [VarCurr: state_type] :
      ( v34992(VarCurr)
    <=> v34994(VarCurr) ) ).

tff(addAssignment_17299,axiom,
    ! [VarCurr: state_type] :
      ( v34994(VarCurr)
    <=> v34996(VarCurr) ) ).

tff(addAssignment_17298,axiom,
    ! [VarCurr: state_type] :
      ( v34996(VarCurr)
    <=> v34998(VarCurr) ) ).

tff(addAssignment_17297,axiom,
    ! [VarCurr: state_type] :
      ( v34998(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_17296,axiom,
    ! [VarCurr: state_type] :
      ( v34949(VarCurr)
    <=> v34951(VarCurr) ) ).

tff(addAssignment_17295,axiom,
    ! [VarCurr: state_type] :
      ( v34951(VarCurr)
    <=> v34953(VarCurr) ) ).

tff(addAssignment_17294,axiom,
    ! [VarCurr: state_type] :
      ( v34953(VarCurr)
    <=> v34955(VarCurr) ) ).

tff(addAssignment_17293,axiom,
    ! [VarCurr: state_type] :
      ( v34955(VarCurr)
    <=> v34957(VarCurr) ) ).

tff(addAssignment_17292,axiom,
    ! [VarCurr: state_type] :
      ( v34957(VarCurr)
    <=> v34959(VarCurr) ) ).

tff(addAssignment_17291,axiom,
    ! [VarCurr: state_type] :
      ( v34959(VarCurr)
    <=> v34961(VarCurr) ) ).

tff(addAssignment_17290,axiom,
    ! [VarCurr: state_type] :
      ( v34961(VarCurr)
    <=> v34963(VarCurr) ) ).

tff(writeUnaryOperator_2128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34963(VarCurr)
    <=> v34977(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3453,axiom,
    ! [VarCurr: state_type] :
      ( v34977(VarCurr)
    <=> ( v34978(VarCurr)
        | v34973(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3452,axiom,
    ! [VarCurr: state_type] :
      ( v34978(VarCurr)
    <=> ( v34965(VarCurr)
        | v34969(VarCurr) ) ) ).

tff(addAssignment_17289,axiom,
    ! [VarCurr: state_type] :
      ( v34973(VarCurr)
    <=> v34975(VarCurr) ) ).

tff(addAssignment_17288,axiom,
    ! [VarCurr: state_type] :
      ( v34975(VarCurr)
    <=> v9006(VarCurr,2) ) ).

tff(addAssignment_17287,axiom,
    ! [VarCurr: state_type] :
      ( v34969(VarCurr)
    <=> v34971(VarCurr) ) ).

tff(addAssignment_17286,axiom,
    ! [VarCurr: state_type] :
      ( v34971(VarCurr)
    <=> v34478(VarCurr,1) ) ).

tff(addAssignment_17285,axiom,
    ! [VarCurr: state_type] :
      ( v34478(VarCurr,1)
    <=> v34480(VarCurr,1) ) ).

tff(addAssignment_17284,axiom,
    ! [VarCurr: state_type] :
      ( v34480(VarCurr,1)
    <=> v34482(VarCurr,1) ) ).

tff(addAssignment_17283,axiom,
    ! [VarCurr: state_type] :
      ( v34482(VarCurr,1)
    <=> v34487(VarCurr,1) ) ).

tff(addAssignment_17282,axiom,
    ! [VarCurr: state_type] :
      ( v34484(VarCurr,1)
    <=> v34486(VarCurr,1) ) ).

tff(addAssignment_17281,axiom,
    ! [VarCurr: state_type] :
      ( v34486(VarCurr,1)
    <=> v9006(VarCurr,1) ) ).

tff(addAssignment_17280,axiom,
    ! [VarCurr: state_type] :
      ( v34965(VarCurr)
    <=> v34967(VarCurr) ) ).

tff(addAssignment_17279,axiom,
    ! [VarCurr: state_type] :
      ( v34967(VarCurr)
    <=> v9006(VarCurr,0) ) ).

tff(addAssignment_17278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34829(VarCurr,B)
      <=> v34831(VarCurr,B) ) ) ).

tff(addAssignment_17277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34831(VarCurr,B)
      <=> v34833(VarCurr,B) ) ) ).

tff(addAssignment_17276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34833(VarCurr,B)
      <=> v34835(VarCurr,B) ) ) ).

tff(addAssignment_17275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34835(VarCurr,B)
      <=> v34837(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34932(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v34837(VarNext,B)
            <=> v34837(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_416,axiom,
    ! [VarNext: state_type] :
      ( v34932(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34837(VarNext,B)
          <=> v34942(VarNext,B) ) ) ) ).

tff(addAssignment_17274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34942(VarNext,B)
          <=> v34940(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34943(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34940(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_301,axiom,
    ! [VarCurr: state_type] :
      ( v34943(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34940(VarCurr,B)
          <=> v34859(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3451,axiom,
    ! [VarCurr: state_type] :
      ( v34943(VarCurr)
    <=> ( v34944(VarCurr)
        & v34945(VarCurr) ) ) ).

tff(writeUnaryOperator_2127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34945(VarCurr)
    <=> v34849(VarCurr) ) ).

tff(writeUnaryOperator_2126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34944(VarCurr)
    <=> v34839(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34932(VarNext)
      <=> v34933(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34933(VarNext)
      <=> ( v34934(VarNext)
          & v34863(VarNext) ) ) ) ).

tff(writeUnaryOperator_2125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34934(VarNext)
      <=> v34936(VarNext) ) ) ).

tff(addAssignment_17273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34936(VarNext)
      <=> v34863(VarCurr) ) ) ).

tff(addAssignment_17272,axiom,
    ! [VarCurr: state_type] :
      ( v34863(VarCurr)
    <=> v34865(VarCurr) ) ).

tff(addAssignment_17271,axiom,
    ! [VarCurr: state_type] :
      ( v34865(VarCurr)
    <=> v34867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3448,axiom,
    ! [VarCurr: state_type] :
      ( v34867(VarCurr)
    <=> ( v34929(VarCurr)
        | v34925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3447,axiom,
    ! [VarCurr: state_type] :
      ( v34929(VarCurr)
    <=> ( v34869(VarCurr)
        & v34873(VarCurr) ) ) ).

tff(addAssignment_17270,axiom,
    ! [VarCurr: state_type] :
      ( v34925(VarCurr)
    <=> v34927(VarCurr) ) ).

tff(addAssignment_17269,axiom,
    ! [VarCurr: state_type] :
      ( v34927(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34909(VarNext)
       => ( v34873(VarNext)
        <=> v34873(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_415,axiom,
    ! [VarNext: state_type] :
      ( v34909(VarNext)
     => ( v34873(VarNext)
      <=> v34919(VarNext) ) ) ).

tff(addAssignment_17268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34919(VarNext)
      <=> v34917(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3446,axiom,
    ! [VarCurr: state_type] :
      ( v34917(VarCurr)
    <=> ( v34920(VarCurr)
        & v34921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3445,axiom,
    ! [VarCurr: state_type] :
      ( v34921(VarCurr)
    <=> ( v34879(VarCurr)
        | v34904(VarCurr) ) ) ).

tff(writeUnaryOperator_2124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34920(VarCurr)
    <=> v34875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34909(VarNext)
      <=> v34910(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34910(VarNext)
      <=> ( v34912(VarNext)
          & v34914(VarNext) ) ) ) ).

tff(writeUnaryOperator_2123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34914(VarCurr)
    <=> v34869(VarCurr) ) ).

tff(addAssignment_17267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34912(VarNext)
      <=> v34869(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_138,axiom,
    ( v34873(constB0)
  <=> $true ) ).

tff(addAssignment_17266,axiom,
    ! [VarCurr: state_type] :
      ( v34904(VarCurr)
    <=> v34906(VarCurr) ) ).

tff(addAssignment_17265,axiom,
    ! [VarCurr: state_type] :
      ( v34906(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17264,axiom,
    ! [VarCurr: state_type] :
      ( v34879(VarCurr)
    <=> v34881(VarCurr) ) ).

tff(addAssignment_17263,axiom,
    ! [VarCurr: state_type] :
      ( v34881(VarCurr)
    <=> v34883(VarCurr) ) ).

tff(addAssignment_17262,axiom,
    ! [VarCurr: state_type] :
      ( v34883(VarCurr)
    <=> v34885(VarCurr) ) ).

tff(addAssignment_17261,axiom,
    ! [VarCurr: state_type] :
      ( v34885(VarCurr)
    <=> v34887(VarCurr) ) ).

tff(writeUnaryOperator_2122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34887(VarCurr)
    <=> v34901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3442,axiom,
    ! [VarCurr: state_type] :
      ( v34901(VarCurr)
    <=> ( v34902(VarCurr)
        | v34897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3441,axiom,
    ! [VarCurr: state_type] :
      ( v34902(VarCurr)
    <=> ( v34889(VarCurr)
        | v34893(VarCurr) ) ) ).

tff(addAssignment_17260,axiom,
    ! [VarCurr: state_type] :
      ( v34897(VarCurr)
    <=> v34899(VarCurr) ) ).

tff(addAssignment_17259,axiom,
    ! [VarCurr: state_type] :
      ( v34899(VarCurr)
    <=> v8916(VarCurr,2) ) ).

tff(addAssignment_17258,axiom,
    ! [VarCurr: state_type] :
      ( v34893(VarCurr)
    <=> v34895(VarCurr) ) ).

tff(addAssignment_17257,axiom,
    ! [VarCurr: state_type] :
      ( v34895(VarCurr)
    <=> v34731(VarCurr,1) ) ).

tff(addAssignment_17256,axiom,
    ! [VarCurr: state_type] :
      ( v34731(VarCurr,1)
    <=> v34733(VarCurr,1) ) ).

tff(addAssignment_17255,axiom,
    ! [VarCurr: state_type] :
      ( v34733(VarCurr,1)
    <=> v34735(VarCurr,1) ) ).

tff(addAssignment_17254,axiom,
    ! [VarCurr: state_type] :
      ( v34735(VarCurr,1)
    <=> v34740(VarCurr,1) ) ).

tff(addAssignment_17253,axiom,
    ! [VarCurr: state_type] :
      ( v34737(VarCurr,1)
    <=> v34739(VarCurr,1) ) ).

tff(addAssignment_17252,axiom,
    ! [VarCurr: state_type] :
      ( v34739(VarCurr,1)
    <=> v8916(VarCurr,1) ) ).

tff(addAssignment_17251,axiom,
    ! [VarCurr: state_type] :
      ( v34889(VarCurr)
    <=> v34891(VarCurr) ) ).

tff(addAssignment_17250,axiom,
    ! [VarCurr: state_type] :
      ( v34891(VarCurr)
    <=> v8916(VarCurr,0) ) ).

tff(addAssignment_17249,axiom,
    ! [VarCurr: state_type] :
      ( v34875(VarCurr)
    <=> v34877(VarCurr) ) ).

tff(addAssignment_17248,axiom,
    ! [VarCurr: state_type] :
      ( v34877(VarCurr)
    <=> $false ) ).

tff(addAssignment_17247,axiom,
    ! [VarCurr: state_type] :
      ( v34869(VarCurr)
    <=> v34871(VarCurr) ) ).

tff(addAssignment_17246,axiom,
    ! [VarCurr: state_type] :
      ( v34871(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34859(VarCurr,B)
      <=> v34861(VarCurr,B) ) ) ).

tff(addAssignment_17244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34861(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_17243,axiom,
    ! [VarCurr: state_type] :
      ( v34849(VarCurr)
    <=> v34851(VarCurr) ) ).

tff(addAssignment_17242,axiom,
    ! [VarCurr: state_type] :
      ( v34851(VarCurr)
    <=> v34853(VarCurr) ) ).

tff(addAssignment_17241,axiom,
    ! [VarCurr: state_type] :
      ( v34853(VarCurr)
    <=> v34855(VarCurr) ) ).

tff(addAssignment_17240,axiom,
    ! [VarCurr: state_type] :
      ( v34855(VarCurr)
    <=> v34857(VarCurr) ) ).

tff(addAssignment_17239,axiom,
    ! [VarCurr: state_type] :
      ( v34857(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_17238,axiom,
    ! [VarCurr: state_type] :
      ( v34839(VarCurr)
    <=> v34841(VarCurr) ) ).

tff(addAssignment_17237,axiom,
    ! [VarCurr: state_type] :
      ( v34841(VarCurr)
    <=> v34843(VarCurr) ) ).

tff(addAssignment_17236,axiom,
    ! [VarCurr: state_type] :
      ( v34843(VarCurr)
    <=> v34845(VarCurr) ) ).

tff(addAssignment_17235,axiom,
    ! [VarCurr: state_type] :
      ( v34845(VarCurr)
    <=> v34847(VarCurr) ) ).

tff(addAssignment_17234,axiom,
    ! [VarCurr: state_type] :
      ( v34847(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_17233,axiom,
    ! [VarCurr: state_type] :
      ( v34798(VarCurr)
    <=> v34800(VarCurr) ) ).

tff(addAssignment_17232,axiom,
    ! [VarCurr: state_type] :
      ( v34800(VarCurr)
    <=> v34802(VarCurr) ) ).

tff(addAssignment_17231,axiom,
    ! [VarCurr: state_type] :
      ( v34802(VarCurr)
    <=> v34804(VarCurr) ) ).

tff(addAssignment_17230,axiom,
    ! [VarCurr: state_type] :
      ( v34804(VarCurr)
    <=> v34806(VarCurr) ) ).

tff(addAssignment_17229,axiom,
    ! [VarCurr: state_type] :
      ( v34806(VarCurr)
    <=> v34808(VarCurr) ) ).

tff(addAssignment_17228,axiom,
    ! [VarCurr: state_type] :
      ( v34808(VarCurr)
    <=> v34810(VarCurr) ) ).

tff(addAssignment_17227,axiom,
    ! [VarCurr: state_type] :
      ( v34810(VarCurr)
    <=> v34812(VarCurr) ) ).

tff(writeUnaryOperator_2121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34812(VarCurr)
    <=> v34826(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3440,axiom,
    ! [VarCurr: state_type] :
      ( v34826(VarCurr)
    <=> ( v34827(VarCurr)
        | v34822(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3439,axiom,
    ! [VarCurr: state_type] :
      ( v34827(VarCurr)
    <=> ( v34814(VarCurr)
        | v34818(VarCurr) ) ) ).

tff(addAssignment_17226,axiom,
    ! [VarCurr: state_type] :
      ( v34822(VarCurr)
    <=> v34824(VarCurr) ) ).

tff(addAssignment_17225,axiom,
    ! [VarCurr: state_type] :
      ( v34824(VarCurr)
    <=> v9006(VarCurr,2) ) ).

tff(addAssignment_17224,axiom,
    ! [VarCurr: state_type] :
      ( v34818(VarCurr)
    <=> v34820(VarCurr) ) ).

tff(addAssignment_17223,axiom,
    ! [VarCurr: state_type] :
      ( v34820(VarCurr)
    <=> v9006(VarCurr,1) ) ).

tff(addAssignment_17222,axiom,
    ! [VarCurr: state_type] :
      ( v34814(VarCurr)
    <=> v34816(VarCurr) ) ).

tff(addAssignment_17221,axiom,
    ! [VarCurr: state_type] :
      ( v34816(VarCurr)
    <=> v34478(VarCurr,0) ) ).

tff(addAssignment_17220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34667(VarCurr,B)
      <=> v34669(VarCurr,B) ) ) ).

tff(addAssignment_17219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34669(VarCurr,B)
      <=> v34671(VarCurr,B) ) ) ).

tff(addAssignment_17218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34671(VarCurr,B)
      <=> v34673(VarCurr,B) ) ) ).

tff(addAssignment_17217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34673(VarCurr,B)
      <=> v34675(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34781(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v34675(VarNext,B)
            <=> v34675(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_414,axiom,
    ! [VarNext: state_type] :
      ( v34781(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34675(VarNext,B)
          <=> v34791(VarNext,B) ) ) ) ).

tff(addAssignment_17216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34791(VarNext,B)
          <=> v34789(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_302,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34789(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_300,axiom,
    ! [VarCurr: state_type] :
      ( v34792(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v34789(VarCurr,B)
          <=> v34697(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3438,axiom,
    ! [VarCurr: state_type] :
      ( v34792(VarCurr)
    <=> ( v34793(VarCurr)
        & v34794(VarCurr) ) ) ).

tff(writeUnaryOperator_2120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34794(VarCurr)
    <=> v34687(VarCurr) ) ).

tff(writeUnaryOperator_2119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34793(VarCurr)
    <=> v34677(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34781(VarNext)
      <=> v34782(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3436,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34782(VarNext)
      <=> ( v34783(VarNext)
          & v34701(VarNext) ) ) ) ).

tff(writeUnaryOperator_2118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34783(VarNext)
      <=> v34785(VarNext) ) ) ).

tff(addAssignment_17215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34785(VarNext)
      <=> v34701(VarCurr) ) ) ).

tff(addAssignment_17214,axiom,
    ! [VarCurr: state_type] :
      ( v34701(VarCurr)
    <=> v34703(VarCurr) ) ).

tff(addAssignment_17213,axiom,
    ! [VarCurr: state_type] :
      ( v34703(VarCurr)
    <=> v34705(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3435,axiom,
    ! [VarCurr: state_type] :
      ( v34705(VarCurr)
    <=> ( v34778(VarCurr)
        | v34774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3434,axiom,
    ! [VarCurr: state_type] :
      ( v34778(VarCurr)
    <=> ( v34707(VarCurr)
        & v34711(VarCurr) ) ) ).

tff(addAssignment_17212,axiom,
    ! [VarCurr: state_type] :
      ( v34774(VarCurr)
    <=> v34776(VarCurr) ) ).

tff(addAssignment_17211,axiom,
    ! [VarCurr: state_type] :
      ( v34776(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34758(VarNext)
       => ( v34711(VarNext)
        <=> v34711(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_413,axiom,
    ! [VarNext: state_type] :
      ( v34758(VarNext)
     => ( v34711(VarNext)
      <=> v34768(VarNext) ) ) ).

tff(addAssignment_17210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34768(VarNext)
      <=> v34766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3433,axiom,
    ! [VarCurr: state_type] :
      ( v34766(VarCurr)
    <=> ( v34769(VarCurr)
        & v34770(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3432,axiom,
    ! [VarCurr: state_type] :
      ( v34770(VarCurr)
    <=> ( v34717(VarCurr)
        | v34753(VarCurr) ) ) ).

tff(writeUnaryOperator_2117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34769(VarCurr)
    <=> v34713(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3431,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34758(VarNext)
      <=> v34759(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34759(VarNext)
      <=> ( v34761(VarNext)
          & v34763(VarNext) ) ) ) ).

tff(writeUnaryOperator_2116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34763(VarCurr)
    <=> v34707(VarCurr) ) ).

tff(addAssignment_17209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34761(VarNext)
      <=> v34707(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_137,axiom,
    ( v34711(constB0)
  <=> $true ) ).

tff(addAssignment_17208,axiom,
    ! [VarCurr: state_type] :
      ( v34753(VarCurr)
    <=> v34755(VarCurr) ) ).

tff(addAssignment_17207,axiom,
    ! [VarCurr: state_type] :
      ( v34755(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17206,axiom,
    ! [VarCurr: state_type] :
      ( v34717(VarCurr)
    <=> v34719(VarCurr) ) ).

tff(addAssignment_17205,axiom,
    ! [VarCurr: state_type] :
      ( v34719(VarCurr)
    <=> v34721(VarCurr) ) ).

tff(addAssignment_17204,axiom,
    ! [VarCurr: state_type] :
      ( v34721(VarCurr)
    <=> v34723(VarCurr) ) ).

tff(addAssignment_17203,axiom,
    ! [VarCurr: state_type] :
      ( v34723(VarCurr)
    <=> v34725(VarCurr) ) ).

tff(writeUnaryOperator_2115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34725(VarCurr)
    <=> v34750(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3429,axiom,
    ! [VarCurr: state_type] :
      ( v34750(VarCurr)
    <=> ( v34751(VarCurr)
        | v34746(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3428,axiom,
    ! [VarCurr: state_type] :
      ( v34751(VarCurr)
    <=> ( v34727(VarCurr)
        | v34742(VarCurr) ) ) ).

tff(addAssignment_17202,axiom,
    ! [VarCurr: state_type] :
      ( v34746(VarCurr)
    <=> v34748(VarCurr) ) ).

tff(addAssignment_17201,axiom,
    ! [VarCurr: state_type] :
      ( v34748(VarCurr)
    <=> v8916(VarCurr,2) ) ).

tff(addAssignment_17200,axiom,
    ! [VarCurr: state_type] :
      ( v34742(VarCurr)
    <=> v34744(VarCurr) ) ).

tff(addAssignment_17199,axiom,
    ! [VarCurr: state_type] :
      ( v34744(VarCurr)
    <=> v8916(VarCurr,1) ) ).

tff(addAssignment_17198,axiom,
    ! [VarCurr: state_type] :
      ( v34727(VarCurr)
    <=> v34729(VarCurr) ) ).

tff(addAssignment_17197,axiom,
    ! [VarCurr: state_type] :
      ( v34729(VarCurr)
    <=> v34731(VarCurr,0) ) ).

tff(addAssignment_17196,axiom,
    ! [VarCurr: state_type] :
      ( v34731(VarCurr,0)
    <=> v34733(VarCurr,0) ) ).

tff(addAssignment_17195,axiom,
    ! [VarCurr: state_type] :
      ( v34733(VarCurr,0)
    <=> v34735(VarCurr,0) ) ).

tff(addAssignment_17194,axiom,
    ! [VarCurr: state_type] :
      ( v34735(VarCurr,0)
    <=> v34740(VarCurr,0) ) ).

tff(writeUnaryOperator_2114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v34740(VarCurr,B)
      <=> ~ v34737(VarCurr,B) ) ) ).

tff(addAssignment_17193,axiom,
    ! [VarCurr: state_type] :
      ( v34737(VarCurr,0)
    <=> v34739(VarCurr,0) ) ).

tff(addAssignment_17192,axiom,
    ! [VarCurr: state_type] :
      ( v34739(VarCurr,0)
    <=> v8916(VarCurr,0) ) ).

tff(addAssignment_17191,axiom,
    ! [VarCurr: state_type] :
      ( v34713(VarCurr)
    <=> v34715(VarCurr) ) ).

tff(addAssignment_17190,axiom,
    ! [VarCurr: state_type] :
      ( v34715(VarCurr)
    <=> $false ) ).

tff(addAssignment_17189,axiom,
    ! [VarCurr: state_type] :
      ( v34707(VarCurr)
    <=> v34709(VarCurr) ) ).

tff(addAssignment_17188,axiom,
    ! [VarCurr: state_type] :
      ( v34709(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34697(VarCurr,B)
      <=> v34699(VarCurr,B) ) ) ).

tff(addAssignment_17186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v34699(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_17185,axiom,
    ! [VarCurr: state_type] :
      ( v34687(VarCurr)
    <=> v34689(VarCurr) ) ).

tff(addAssignment_17184,axiom,
    ! [VarCurr: state_type] :
      ( v34689(VarCurr)
    <=> v34691(VarCurr) ) ).

tff(addAssignment_17183,axiom,
    ! [VarCurr: state_type] :
      ( v34691(VarCurr)
    <=> v34693(VarCurr) ) ).

tff(addAssignment_17182,axiom,
    ! [VarCurr: state_type] :
      ( v34693(VarCurr)
    <=> v34695(VarCurr) ) ).

tff(addAssignment_17181,axiom,
    ! [VarCurr: state_type] :
      ( v34695(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_17180,axiom,
    ! [VarCurr: state_type] :
      ( v34677(VarCurr)
    <=> v34679(VarCurr) ) ).

tff(addAssignment_17179,axiom,
    ! [VarCurr: state_type] :
      ( v34679(VarCurr)
    <=> v34681(VarCurr) ) ).

tff(addAssignment_17178,axiom,
    ! [VarCurr: state_type] :
      ( v34681(VarCurr)
    <=> v34683(VarCurr) ) ).

tff(addAssignment_17177,axiom,
    ! [VarCurr: state_type] :
      ( v34683(VarCurr)
    <=> v34685(VarCurr) ) ).

tff(addAssignment_17176,axiom,
    ! [VarCurr: state_type] :
      ( v34685(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_17175,axiom,
    ! [VarCurr: state_type] :
      ( v8986(VarCurr)
    <=> v8988(VarCurr) ) ).

tff(addAssignment_17174,axiom,
    ! [VarCurr: state_type] :
      ( v8988(VarCurr)
    <=> v8990(VarCurr) ) ).

tff(addAssignment_17173,axiom,
    ! [VarCurr: state_type] :
      ( v8990(VarCurr)
    <=> v8992(VarCurr) ) ).

tff(addAssignment_17172,axiom,
    ! [VarCurr: state_type] :
      ( v8992(VarCurr)
    <=> v8994(VarCurr) ) ).

tff(addAssignment_17171,axiom,
    ! [VarCurr: state_type] :
      ( v8994(VarCurr)
    <=> v8996(VarCurr) ) ).

tff(addAssignment_17170,axiom,
    ! [VarCurr: state_type] :
      ( v8996(VarCurr)
    <=> v8998(VarCurr) ) ).

tff(addAssignment_17169,axiom,
    ! [VarCurr: state_type] :
      ( v8998(VarCurr)
    <=> v9000(VarCurr) ) ).

tff(writeUnaryOperator_2113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9000(VarCurr)
    <=> v34664(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3427,axiom,
    ! [VarCurr: state_type] :
      ( v34664(VarCurr)
    <=> ( v34665(VarCurr)
        | v34660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3426,axiom,
    ! [VarCurr: state_type] :
      ( v34665(VarCurr)
    <=> ( v9002(VarCurr)
        | v34656(VarCurr) ) ) ).

tff(addAssignment_17168,axiom,
    ! [VarCurr: state_type] :
      ( v34660(VarCurr)
    <=> v34662(VarCurr) ) ).

tff(addAssignment_17167,axiom,
    ! [VarCurr: state_type] :
      ( v34662(VarCurr)
    <=> v9006(VarCurr,2) ) ).

tff(addAssignment_17166,axiom,
    ! [VarCurr: state_type] :
      ( v34656(VarCurr)
    <=> v34658(VarCurr) ) ).

tff(addAssignment_17165,axiom,
    ! [VarCurr: state_type] :
      ( v34658(VarCurr)
    <=> v9006(VarCurr,1) ) ).

tff(addAssignment_17164,axiom,
    ! [VarCurr: state_type] :
      ( v9002(VarCurr)
    <=> v9004(VarCurr) ) ).

tff(addAssignment_17163,axiom,
    ! [VarCurr: state_type] :
      ( v9004(VarCurr)
    <=> v9006(VarCurr,0) ) ).

tff(addAssignment_17162,axiom,
    ! [VarCurr: state_type] :
      ( v9006(VarCurr,0)
    <=> v8918(VarCurr,3) ) ).

tff(addAssignment_17161,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,3)
    <=> v8920(VarCurr,3) ) ).

tff(addAssignment_17160,axiom,
    ! [VarNext: state_type] :
      ( v8920(VarNext,3)
    <=> v34648(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34649(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v34648(VarNext,B)
            <=> v8920(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_412,axiom,
    ! [VarNext: state_type] :
      ( v34649(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34648(VarNext,B)
          <=> v34620(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34649(VarNext)
      <=> v34650(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34650(VarNext)
      <=> ( v34652(VarNext)
          & v34562(VarNext) ) ) ) ).

tff(writeUnaryOperator_2112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34652(VarNext)
      <=> v34614(VarNext) ) ) ).

tff(addAssignment_17159,axiom,
    ! [VarCurr: state_type] :
      ( v9030(VarCurr,3)
    <=> v9032(VarCurr,3) ) ).

tff(addAssignment_17158,axiom,
    ! [VarCurr: state_type] :
      ( v9032(VarCurr,3)
    <=> v34559(VarCurr,3) ) ).

tff(addAssignment_17157,axiom,
    ! [VarCurr: state_type] :
      ( v9034(VarCurr,0)
    <=> v9036(VarCurr,0) ) ).

tff(addAssignment_17156,axiom,
    ! [VarCurr: state_type] :
      ( v9036(VarCurr,0)
    <=> v9038(VarCurr,0) ) ).

tff(addAssignment_17155,axiom,
    ! [VarCurr: state_type] :
      ( v9038(VarCurr,0)
    <=> v34558(VarCurr,0) ) ).

tff(addAssignment_17154,axiom,
    ! [VarCurr: state_type] :
      ( v34495(VarCurr,0)
    <=> v34497(VarCurr,0) ) ).

tff(addAssignment_17153,axiom,
    ! [VarCurr: state_type] :
      ( v34497(VarCurr,0)
    <=> v34499(VarCurr,0) ) ).

tff(addAssignment_17152,axiom,
    ! [VarCurr: state_type] :
      ( v34499(VarCurr,0)
    <=> v34501(VarCurr,0) ) ).

tff(addAssignment_17151,axiom,
    ! [VarCurr: state_type] :
      ( v34501(VarCurr,0)
    <=> v34503(VarCurr,0) ) ).

tff(addAssignment_17150,axiom,
    ! [VarCurr: state_type] :
      ( v34503(VarCurr,0)
    <=> v34513(VarCurr,0) ) ).

tff(addAssignment_17149,axiom,
    ! [VarCurr: state_type] :
      ( v9040(VarCurr,0)
    <=> v9042(VarCurr,0) ) ).

tff(addAssignment_17148,axiom,
    ! [VarCurr: state_type] :
      ( v9042(VarCurr,0)
    <=> v34492(VarCurr,0) ) ).

tff(addAssignment_17147,axiom,
    ! [VarCurr: state_type] :
      ( v9044(VarCurr)
    <=> v8570(VarCurr,2) ) ).

tff(addAssignment_17146,axiom,
    ! [VarCurr: state_type] :
      ( v8570(VarCurr,2)
    <=> v8572(VarCurr,2) ) ).

tff(addAssignment_17145,axiom,
    ! [VarCurr: state_type] :
      ( v8572(VarCurr,2)
    <=> v8582(VarCurr,2) ) ).

tff(addAssignment_17144,axiom,
    ! [VarCurr: state_type] :
      ( v8574(VarCurr,2)
    <=> v8576(VarCurr,2) ) ).

tff(addAssignment_17143,axiom,
    ! [VarCurr: state_type] :
      ( v8576(VarCurr,2)
    <=> v8579(VarCurr,2) ) ).

tff(addAssignment_17142,axiom,
    ! [VarCurr: state_type] :
      ( v8580(VarCurr)
    <=> v9047(VarCurr,1) ) ).

tff(addAssignment_17141,axiom,
    ! [VarCurr: state_type] :
      ( v9047(VarCurr,1)
    <=> v9049(VarCurr,1) ) ).

tff(addAssignment_17140,axiom,
    ! [VarCurr: state_type] :
      ( v9049(VarCurr,1)
    <=> v34646(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v34646(VarCurr,B)
      <=> ( v9051(VarCurr,B)
          | v9057(VarCurr,B) ) ) ) ).

tff(addAssignment_17139,axiom,
    ! [VarCurr: state_type] :
      ( v9057(VarCurr,1)
    <=> v9059(VarCurr,1) ) ).

tff(addAssignment_17138,axiom,
    ! [VarCurr: state_type] :
      ( v9059(VarCurr,1)
    <=> v34644(VarCurr,1) ) ).

tff(addAssignment_17137,axiom,
    ! [VarCurr: state_type] :
      ( v34644(VarCurr,0)
    <=> v34645(VarCurr) ) ).

tff(addAssignment_17136,axiom,
    ! [VarCurr: state_type] :
      ( v34644(VarCurr,1)
    <=> v9061(VarCurr) ) ).

tff(addAssignment_17135,axiom,
    ! [VarCurr: state_type] :
      ( v9061(VarCurr)
    <=> v9063(VarCurr,1) ) ).

tff(addAssignment_17134,axiom,
    ! [VarCurr: state_type] :
      ( v9063(VarCurr,1)
    <=> v9065(VarCurr,1) ) ).

tff(addAssignment_17133,axiom,
    ! [VarCurr: state_type] :
      ( v9065(VarCurr,1)
    <=> v34643(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v34643(VarCurr,B)
      <=> ( v9067(VarCurr,B)
          & v34464(VarCurr,B) ) ) ) ).

tff(addAssignment_17132,axiom,
    ! [VarCurr: state_type] :
      ( v34464(VarCurr,1)
    <=> v34466(VarCurr,1) ) ).

tff(addAssignment_17131,axiom,
    ! [VarCurr: state_type] :
      ( v34466(VarCurr,1)
    <=> v34641(VarCurr,1) ) ).

tff(addAssignment_17130,axiom,
    ! [VarCurr: state_type] :
      ( v34641(VarCurr,0)
    <=> v34642(VarCurr) ) ).

tff(addAssignment_17129,axiom,
    ! [VarCurr: state_type] :
      ( v34641(VarCurr,1)
    <=> v34468(VarCurr) ) ).

tff(addAssignment_17128,axiom,
    ! [VarCurr: state_type] :
      ( v34468(VarCurr)
    <=> v34470(VarCurr) ) ).

tff(addAssignment_17127,axiom,
    ! [VarCurr: state_type] :
      ( v34470(VarCurr)
    <=> v34472(VarCurr) ) ).

tff(writeUnaryOperator_2111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34472(VarCurr)
    <=> v34639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3423,axiom,
    ! [VarCurr: state_type] :
      ( v34639(VarCurr)
    <=> ( v34640(VarCurr)
        | v34627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3422,axiom,
    ! [VarCurr: state_type] :
      ( v34640(VarCurr)
    <=> ( v34474(VarCurr)
        | v34489(VarCurr) ) ) ).

tff(addAssignment_17126,axiom,
    ! [VarCurr: state_type] :
      ( v34627(VarCurr)
    <=> v34629(VarCurr) ) ).

tff(addAssignment_17125,axiom,
    ! [VarCurr: state_type] :
      ( v34629(VarCurr)
    <=> v34478(VarCurr,2) ) ).

tff(addAssignment_17124,axiom,
    ! [VarCurr: state_type] :
      ( v34478(VarCurr,2)
    <=> v34480(VarCurr,2) ) ).

tff(addAssignment_17123,axiom,
    ! [VarCurr: state_type] :
      ( v34480(VarCurr,2)
    <=> v34482(VarCurr,2) ) ).

tff(addAssignment_17122,axiom,
    ! [VarCurr: state_type] :
      ( v34482(VarCurr,2)
    <=> v34487(VarCurr,2) ) ).

tff(addAssignment_17121,axiom,
    ! [VarCurr: state_type] :
      ( v34484(VarCurr,2)
    <=> v34486(VarCurr,2) ) ).

tff(addAssignment_17120,axiom,
    ! [VarCurr: state_type] :
      ( v34486(VarCurr,2)
    <=> v9006(VarCurr,2) ) ).

tff(addAssignment_17119,axiom,
    ! [VarCurr: state_type] :
      ( v9006(VarCurr,2)
    <=> v8918(VarCurr,5) ) ).

tff(addAssignment_17118,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,5)
    <=> v8920(VarCurr,5) ) ).

tff(addAssignment_17117,axiom,
    ! [VarNext: state_type] :
      ( v8920(VarNext,5)
    <=> v34631(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34632(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v34631(VarNext,B)
            <=> v8920(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_411,axiom,
    ! [VarNext: state_type] :
      ( v34632(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34631(VarNext,B)
          <=> v34620(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34632(VarNext)
      <=> v34633(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3420,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34633(VarNext)
      <=> ( v34635(VarNext)
          & v34562(VarNext) ) ) ) ).

tff(writeUnaryOperator_2110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34635(VarNext)
      <=> v34614(VarNext) ) ) ).

tff(addAssignment_17116,axiom,
    ! [VarCurr: state_type] :
      ( v9030(VarCurr,5)
    <=> v9032(VarCurr,5) ) ).

tff(addAssignment_17115,axiom,
    ! [VarCurr: state_type] :
      ( v9032(VarCurr,5)
    <=> v34559(VarCurr,5) ) ).

tff(addAssignment_17114,axiom,
    ! [VarCurr: state_type] :
      ( v9034(VarCurr,2)
    <=> v9036(VarCurr,2) ) ).

tff(addAssignment_17113,axiom,
    ! [VarCurr: state_type] :
      ( v9036(VarCurr,2)
    <=> v9038(VarCurr,2) ) ).

tff(addAssignment_17112,axiom,
    ! [VarCurr: state_type] :
      ( v9038(VarCurr,2)
    <=> v34558(VarCurr,2) ) ).

tff(addAssignment_17111,axiom,
    ! [VarCurr: state_type] :
      ( v34495(VarCurr,2)
    <=> v34497(VarCurr,2) ) ).

tff(addAssignment_17110,axiom,
    ! [VarCurr: state_type] :
      ( v34497(VarCurr,2)
    <=> v34499(VarCurr,2) ) ).

tff(addAssignment_17109,axiom,
    ! [VarCurr: state_type] :
      ( v34499(VarCurr,2)
    <=> v34501(VarCurr,2) ) ).

tff(addAssignment_17108,axiom,
    ! [VarCurr: state_type] :
      ( v34501(VarCurr,2)
    <=> v34503(VarCurr,2) ) ).

tff(addAssignment_17107,axiom,
    ! [VarCurr: state_type] :
      ( v34503(VarCurr,2)
    <=> v34513(VarCurr,2) ) ).

tff(addAssignment_17106,axiom,
    ! [VarCurr: state_type] :
      ( v34505(VarCurr,2)
    <=> v34507(VarCurr,2) ) ).

tff(addAssignment_17105,axiom,
    ! [VarCurr: state_type] :
      ( v34507(VarCurr,2)
    <=> v34508(VarCurr,2) ) ).

tff(addAssignment_17104,axiom,
    ! [VarCurr: state_type] :
      ( v9040(VarCurr,2)
    <=> v9042(VarCurr,2) ) ).

tff(addAssignment_17103,axiom,
    ! [VarCurr: state_type] :
      ( v9042(VarCurr,2)
    <=> v34492(VarCurr,2) ) ).

tff(addAssignment_17102,axiom,
    ! [VarCurr: state_type] :
      ( v34489(VarCurr)
    <=> v34491(VarCurr) ) ).

tff(addAssignment_17101,axiom,
    ! [VarCurr: state_type] :
      ( v34491(VarCurr)
    <=> v9006(VarCurr,1) ) ).

tff(addAssignment_17100,axiom,
    ! [VarCurr: state_type] :
      ( v9006(VarCurr,1)
    <=> v8918(VarCurr,4) ) ).

tff(addAssignment_17099,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,4)
    <=> v8920(VarCurr,4) ) ).

tff(addAssignment_17098,axiom,
    ! [VarNext: state_type] :
      ( v8920(VarNext,4)
    <=> v34609(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34610(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v34609(VarNext,B)
            <=> v8920(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_410,axiom,
    ! [VarNext: state_type] :
      ( v34610(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34609(VarNext,B)
          <=> v34620(VarNext,B) ) ) ) ).

tff(addAssignment_17097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34620(VarNext,B)
          <=> v34618(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34618(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_299,axiom,
    ! [VarCurr: state_type] :
      ( v34621(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v34618(VarCurr,B)
          <=> v9030(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3419,axiom,
    ! [VarCurr: state_type] :
      ( v34621(VarCurr)
    <=> ( v34622(VarCurr)
        & v34623(VarCurr) ) ) ).

tff(writeUnaryOperator_2109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34623(VarCurr)
    <=> v9020(VarCurr) ) ).

tff(writeUnaryOperator_2108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34622(VarCurr)
    <=> v9008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34610(VarNext)
      <=> v34611(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34611(VarNext)
      <=> ( v34612(VarNext)
          & v34562(VarNext) ) ) ) ).

tff(writeUnaryOperator_2107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34612(VarNext)
      <=> v34614(VarNext) ) ) ).

tff(addAssignment_17096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34614(VarNext)
      <=> v34562(VarCurr) ) ) ).

tff(addAssignment_17095,axiom,
    ! [VarCurr: state_type] :
      ( v34562(VarCurr)
    <=> v34564(VarCurr) ) ).

tff(addAssignment_17094,axiom,
    ! [VarCurr: state_type] :
      ( v34564(VarCurr)
    <=> v34566(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3416,axiom,
    ! [VarCurr: state_type] :
      ( v34566(VarCurr)
    <=> ( v34607(VarCurr)
        | v34603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3415,axiom,
    ! [VarCurr: state_type] :
      ( v34607(VarCurr)
    <=> ( v34568(VarCurr)
        & v34572(VarCurr) ) ) ).

tff(addAssignment_17093,axiom,
    ! [VarCurr: state_type] :
      ( v34603(VarCurr)
    <=> v34605(VarCurr) ) ).

tff(addAssignment_17092,axiom,
    ! [VarCurr: state_type] :
      ( v34605(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34587(VarNext)
       => ( v34572(VarNext)
        <=> v34572(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_409,axiom,
    ! [VarNext: state_type] :
      ( v34587(VarNext)
     => ( v34572(VarNext)
      <=> v34597(VarNext) ) ) ).

tff(addAssignment_17091,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34597(VarNext)
      <=> v34595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3414,axiom,
    ! [VarCurr: state_type] :
      ( v34595(VarCurr)
    <=> ( v34598(VarCurr)
        & v34599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3413,axiom,
    ! [VarCurr: state_type] :
      ( v34599(VarCurr)
    <=> ( v34578(VarCurr)
        | v34582(VarCurr) ) ) ).

tff(writeUnaryOperator_2106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34598(VarCurr)
    <=> v34574(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34587(VarNext)
      <=> v34588(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34588(VarNext)
      <=> ( v34590(VarNext)
          & v34592(VarNext) ) ) ) ).

tff(writeUnaryOperator_2105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34592(VarCurr)
    <=> v34568(VarCurr) ) ).

tff(addAssignment_17090,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34590(VarNext)
      <=> v34568(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_136,axiom,
    ( v34572(constB0)
  <=> $true ) ).

tff(addAssignment_17089,axiom,
    ! [VarCurr: state_type] :
      ( v34582(VarCurr)
    <=> v34584(VarCurr) ) ).

tff(addAssignment_17088,axiom,
    ! [VarCurr: state_type] :
      ( v34584(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_17087,axiom,
    ! [VarCurr: state_type] :
      ( v34578(VarCurr)
    <=> v34580(VarCurr) ) ).

tff(addAssignment_17086,axiom,
    ! [VarCurr: state_type] :
      ( v34580(VarCurr)
    <=> $true ) ).

tff(addAssignment_17085,axiom,
    ! [VarCurr: state_type] :
      ( v34574(VarCurr)
    <=> v34576(VarCurr) ) ).

tff(addAssignment_17084,axiom,
    ! [VarCurr: state_type] :
      ( v34576(VarCurr)
    <=> $false ) ).

tff(addAssignment_17083,axiom,
    ! [VarCurr: state_type] :
      ( v34568(VarCurr)
    <=> v34570(VarCurr) ) ).

tff(addAssignment_17082,axiom,
    ! [VarCurr: state_type] :
      ( v34570(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_17081,axiom,
    ! [VarCurr: state_type] :
      ( v9030(VarCurr,4)
    <=> v9032(VarCurr,4) ) ).

tff(addAssignment_17080,axiom,
    ! [VarCurr: state_type] :
      ( v9032(VarCurr,4)
    <=> v34559(VarCurr,4) ) ).

tff(addAssignment_17079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v34559(VarCurr,B)
      <=> v34560(VarCurr,B) ) ) ).

tff(addAssignment_17078,axiom,
    ! [VarCurr: state_type] :
      ( ( v34559(VarCurr,5)
      <=> v9034(VarCurr,2) )
      & ( v34559(VarCurr,4)
      <=> v9034(VarCurr,1) )
      & ( v34559(VarCurr,3)
      <=> v9034(VarCurr,0) ) ) ).

tff(addAssignment_17077,axiom,
    ! [VarCurr: state_type] :
      ( v9034(VarCurr,1)
    <=> v9036(VarCurr,1) ) ).

tff(addAssignment_17076,axiom,
    ! [VarCurr: state_type] :
      ( v9036(VarCurr,1)
    <=> v9038(VarCurr,1) ) ).

tff(addAssignment_17075,axiom,
    ! [VarCurr: state_type] :
      ( v9038(VarCurr,1)
    <=> v34558(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v34558(VarCurr,B)
      <=> ( v9040(VarCurr,B)
          & v34495(VarCurr,B) ) ) ) ).

tff(addAssignment_17074,axiom,
    ! [VarCurr: state_type] :
      ( v34495(VarCurr,1)
    <=> v34497(VarCurr,1) ) ).

tff(addAssignment_17073,axiom,
    ! [VarCurr: state_type] :
      ( v34497(VarCurr,1)
    <=> v34499(VarCurr,1) ) ).

tff(addAssignment_17072,axiom,
    ! [VarCurr: state_type] :
      ( v34499(VarCurr,1)
    <=> v34501(VarCurr,1) ) ).

tff(addAssignment_17071,axiom,
    ! [VarCurr: state_type] :
      ( v34501(VarCurr,1)
    <=> v34503(VarCurr,1) ) ).

tff(addAssignment_17070,axiom,
    ! [VarCurr: state_type] :
      ( v34503(VarCurr,1)
    <=> v34513(VarCurr,1) ) ).

tff(addAssignment_17069,axiom,
    ! [VarCurr: state_type] :
      ( v34513(VarCurr,0)
    <=> v34553(VarCurr) ) ).

tff(addAssignment_17068,axiom,
    ! [VarCurr: state_type] :
      ( v34513(VarCurr,1)
    <=> v34548(VarCurr) ) ).

tff(addAssignment_17067,axiom,
    ! [VarCurr: state_type] :
      ( v34513(VarCurr,2)
    <=> v34543(VarCurr) ) ).

tff(addAssignment_17066,axiom,
    ! [VarCurr: state_type] :
      ( v34513(VarCurr,3)
    <=> v34515(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3410,axiom,
    ! [VarCurr: state_type] :
      ( v34553(VarCurr)
    <=> ( v34554(VarCurr)
        & v34557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3409,axiom,
    ! [VarCurr: state_type] :
      ( v34557(VarCurr)
    <=> ( v34505(VarCurr,0)
        | v34523(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3408,axiom,
    ! [VarCurr: state_type] :
      ( v34554(VarCurr)
    <=> ( v34555(VarCurr)
        | v34556(VarCurr) ) ) ).

tff(writeUnaryOperator_2104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34556(VarCurr)
    <=> v34523(VarCurr,0) ) ).

tff(writeUnaryOperator_2103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34555(VarCurr)
    <=> v34505(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3407,axiom,
    ! [VarCurr: state_type] :
      ( v34548(VarCurr)
    <=> ( v34549(VarCurr)
        & v34552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3406,axiom,
    ! [VarCurr: state_type] :
      ( v34552(VarCurr)
    <=> ( v34522(VarCurr)
        | v34524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3405,axiom,
    ! [VarCurr: state_type] :
      ( v34549(VarCurr)
    <=> ( v34550(VarCurr)
        | v34551(VarCurr) ) ) ).

tff(writeUnaryOperator_2102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34551(VarCurr)
    <=> v34524(VarCurr) ) ).

tff(writeUnaryOperator_2101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34550(VarCurr)
    <=> v34522(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3404,axiom,
    ! [VarCurr: state_type] :
      ( v34543(VarCurr)
    <=> ( v34544(VarCurr)
        & v34547(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3403,axiom,
    ! [VarCurr: state_type] :
      ( v34547(VarCurr)
    <=> ( v34520(VarCurr)
        | v34530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3402,axiom,
    ! [VarCurr: state_type] :
      ( v34544(VarCurr)
    <=> ( v34545(VarCurr)
        | v34546(VarCurr) ) ) ).

tff(writeUnaryOperator_2100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34546(VarCurr)
    <=> v34530(VarCurr) ) ).

tff(writeUnaryOperator_2099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34545(VarCurr)
    <=> v34520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3401,axiom,
    ! [VarCurr: state_type] :
      ( v34515(VarCurr)
    <=> ( v34516(VarCurr)
        & v34542(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3400,axiom,
    ! [VarCurr: state_type] :
      ( v34542(VarCurr)
    <=> ( v34518(VarCurr)
        | v34537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3399,axiom,
    ! [VarCurr: state_type] :
      ( v34516(VarCurr)
    <=> ( v34517(VarCurr)
        | v34536(VarCurr) ) ) ).

tff(writeUnaryOperator_2098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34536(VarCurr)
    <=> v34537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3398,axiom,
    ! [VarCurr: state_type] :
      ( v34537(VarCurr)
    <=> ( v34538(VarCurr)
        & v34541(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_498,axiom,
    ! [VarCurr: state_type] :
      ( v34541(VarCurr)
    <=> ( v34505(VarCurr,3)
        | v34523(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3397,axiom,
    ! [VarCurr: state_type] :
      ( v34538(VarCurr)
    <=> ( v34539(VarCurr)
        | v34540(VarCurr) ) ) ).

tff(writeUnaryOperator_2097,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34540(VarCurr)
    <=> v34523(VarCurr,3) ) ).

tff(writeUnaryOperator_2096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34539(VarCurr)
    <=> v34505(VarCurr,3) ) ).

tff(writeUnaryOperator_2095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34517(VarCurr)
    <=> v34518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3396,axiom,
    ! [VarCurr: state_type] :
      ( v34518(VarCurr)
    <=> ( v34519(VarCurr)
        | v34535(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_497,axiom,
    ! [VarCurr: state_type] :
      ( v34535(VarCurr)
    <=> ( v34505(VarCurr,2)
        & v34523(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3395,axiom,
    ! [VarCurr: state_type] :
      ( v34519(VarCurr)
    <=> ( v34520(VarCurr)
        & v34530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3394,axiom,
    ! [VarCurr: state_type] :
      ( v34530(VarCurr)
    <=> ( v34531(VarCurr)
        & v34534(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_496,axiom,
    ! [VarCurr: state_type] :
      ( v34534(VarCurr)
    <=> ( v34505(VarCurr,2)
        | v34523(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3393,axiom,
    ! [VarCurr: state_type] :
      ( v34531(VarCurr)
    <=> ( v34532(VarCurr)
        | v34533(VarCurr) ) ) ).

tff(writeUnaryOperator_2094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34533(VarCurr)
    <=> v34523(VarCurr,2) ) ).

tff(writeUnaryOperator_2093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34532(VarCurr)
    <=> v34505(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3392,axiom,
    ! [VarCurr: state_type] :
      ( v34520(VarCurr)
    <=> ( v34521(VarCurr)
        | v34529(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_495,axiom,
    ! [VarCurr: state_type] :
      ( v34529(VarCurr)
    <=> ( v34505(VarCurr,1)
        & v34523(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3391,axiom,
    ! [VarCurr: state_type] :
      ( v34521(VarCurr)
    <=> ( v34522(VarCurr)
        & v34524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3390,axiom,
    ! [VarCurr: state_type] :
      ( v34524(VarCurr)
    <=> ( v34525(VarCurr)
        & v34528(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_494,axiom,
    ! [VarCurr: state_type] :
      ( v34528(VarCurr)
    <=> ( v34505(VarCurr,1)
        | v34523(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3389,axiom,
    ! [VarCurr: state_type] :
      ( v34525(VarCurr)
    <=> ( v34526(VarCurr)
        | v34527(VarCurr) ) ) ).

tff(writeUnaryOperator_2092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34527(VarCurr)
    <=> v34523(VarCurr,1) ) ).

tff(writeUnaryOperator_2091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34526(VarCurr)
    <=> v34505(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3388,axiom,
    ! [VarCurr: state_type] :
      ( v34522(VarCurr)
    <=> ( v34505(VarCurr,0)
        & v34523(VarCurr,0) ) ) ).

tff(addAssignment_17065,axiom,
    ! [VarCurr: state_type] :
      ( v34523(VarCurr,0)
    <=> v34510(VarCurr) ) ).

tff(addAssignment_17064,axiom,
    ! [VarCurr: state_type] :
      ( ( v34523(VarCurr,3)
      <=> $false )
      & ( v34523(VarCurr,2)
      <=> $false )
      & ( v34523(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_17063,axiom,
    ! [VarCurr: state_type] :
      ( v34510(VarCurr)
    <=> v34512(VarCurr) ) ).

tff(addAssignment_17062,axiom,
    ! [VarCurr: state_type] :
      ( v34512(VarCurr)
    <=> v9071(VarCurr) ) ).

tff(addAssignment_17061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v34505(VarCurr,B)
      <=> v34507(VarCurr,B) ) ) ).

tff(addAssignment_17060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v34507(VarCurr,B)
      <=> v34508(VarCurr,B) ) ) ).

tff(addAssignment_17059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v34508(VarCurr,B)
      <=> v9006(VarCurr,B) ) ) ).

tff(addAssignment_17058,axiom,
    ! [VarCurr: state_type] :
      ( v34508(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_17057,axiom,
    ! [VarCurr: state_type] :
      ( v9040(VarCurr,1)
    <=> v9042(VarCurr,1) ) ).

tff(addAssignment_17056,axiom,
    ! [VarCurr: state_type] :
      ( v9042(VarCurr,1)
    <=> v34492(VarCurr,1) ) ).

tff(addAssignment_17055,axiom,
    ! [VarCurr: state_type] :
      ( v34492(VarCurr,0)
    <=> v34493(VarCurr) ) ).

tff(addAssignment_17054,axiom,
    ! [VarCurr: state_type] :
      ( v34492(VarCurr,1)
    <=> v34493(VarCurr) ) ).

tff(addAssignment_17053,axiom,
    ! [VarCurr: state_type] :
      ( v34492(VarCurr,2)
    <=> v34493(VarCurr) ) ).

tff(addAssignment_17052,axiom,
    ! [VarCurr: state_type] :
      ( v34493(VarCurr)
    <=> v9044(VarCurr) ) ).

tff(addAssignment_17051,axiom,
    ! [VarCurr: state_type] :
      ( v34474(VarCurr)
    <=> v34476(VarCurr) ) ).

tff(addAssignment_17050,axiom,
    ! [VarCurr: state_type] :
      ( v34476(VarCurr)
    <=> v34478(VarCurr,0) ) ).

tff(addAssignment_17049,axiom,
    ! [VarCurr: state_type] :
      ( v34478(VarCurr,0)
    <=> v34480(VarCurr,0) ) ).

tff(addAssignment_17048,axiom,
    ! [VarCurr: state_type] :
      ( v34480(VarCurr,0)
    <=> v34482(VarCurr,0) ) ).

tff(addAssignment_17047,axiom,
    ! [VarCurr: state_type] :
      ( v34482(VarCurr,0)
    <=> v34487(VarCurr,0) ) ).

tff(writeUnaryOperator_2090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v34487(VarCurr,B)
      <=> ~ v34484(VarCurr,B) ) ) ).

tff(addAssignment_17046,axiom,
    ! [VarCurr: state_type] :
      ( v34484(VarCurr,0)
    <=> v34486(VarCurr,0) ) ).

tff(addAssignment_17045,axiom,
    ! [VarCurr: state_type] :
      ( v34486(VarCurr,0)
    <=> v9006(VarCurr,0) ) ).

tff(addAssignment_17044,axiom,
    ! [VarCurr: state_type] :
      ( v9067(VarCurr,1)
    <=> v9069(VarCurr,1) ) ).

tff(addAssignment_17043,axiom,
    ! [VarCurr: state_type] :
      ( v9069(VarCurr,1)
    <=> v34461(VarCurr,1) ) ).

tff(addAssignment_17042,axiom,
    ! [VarCurr: state_type] :
      ( v34461(VarCurr,0)
    <=> v34462(VarCurr) ) ).

tff(addAssignment_17041,axiom,
    ! [VarCurr: state_type] :
      ( v34461(VarCurr,1)
    <=> v9071(VarCurr) ) ).

tff(addAssignment_17040,axiom,
    ! [VarCurr: state_type] :
      ( v9071(VarCurr)
    <=> v7230(VarCurr,2) ) ).

tff(addAssignment_17039,axiom,
    ! [VarCurr: state_type] :
      ( v7230(VarCurr,2)
    <=> v7232(VarCurr,2) ) ).

tff(addAssignment_17038,axiom,
    ! [VarCurr: state_type] :
      ( v7232(VarCurr,2)
    <=> v7234(VarCurr,2) ) ).

tff(addAssignment_17037,axiom,
    ! [VarCurr: state_type] :
      ( v7234(VarCurr,2)
    <=> v34455(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v34455(VarCurr,B)
      <=> ( v34456(VarCurr,B)
          | v34457(VarCurr,B) ) ) ) ).

tff(addAssignment_17036,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,0)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17035,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,1)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17034,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,2)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17033,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,3)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17032,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,4)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17031,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,5)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17030,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,6)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17029,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,7)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17028,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,8)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17027,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,9)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17026,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,10)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17025,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,11)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17024,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,12)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17023,axiom,
    ! [VarCurr: state_type] :
      ( v34457(VarCurr,13)
    <=> v34458(VarCurr) ) ).

tff(addAssignment_17022,axiom,
    ! [VarCurr: state_type] :
      ( v34458(VarCurr)
    <=> v34459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3387,axiom,
    ! [VarCurr: state_type] :
      ( v34459(VarCurr)
    <=> ( v8288(VarCurr)
        & v34460(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3386,axiom,
    ! [VarCurr: state_type] :
      ( v34460(VarCurr)
    <=> ( v9073(VarCurr)
        | v10059(VarCurr) ) ) ).

tff(writeUnaryOperator_2089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v34456(VarCurr,B)
      <=> ~ v7236(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3385,axiom,
    ! [VarCurr: state_type] :
      ( v9073(VarCurr)
    <=> ( v9075(VarCurr)
        | v9077(VarCurr) ) ) ).

tff(addAssignment_17021,axiom,
    ! [VarCurr: state_type] :
      ( v9075(VarCurr)
    <=> v8292(VarCurr,0) ) ).

tff(addAssignment_17020,axiom,
    ! [VarCurr: state_type] :
      ( v8292(VarCurr,0)
    <=> v8294(VarCurr,0) ) ).

tff(addAssignment_17019,axiom,
    ! [VarNext: state_type] :
      ( v8294(VarNext,0)
    <=> v34437(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34438(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v34437(VarNext,B)
            <=> v8294(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_408,axiom,
    ! [VarNext: state_type] :
      ( v34438(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34437(VarNext,B)
          <=> v34448(VarNext,B) ) ) ) ).

tff(addAssignment_17018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34448(VarNext,B)
          <=> v34446(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34446(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_298,axiom,
    ! [VarCurr: state_type] :
      ( v34449(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34446(VarCurr,B)
          <=> v8304(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3384,axiom,
    ! [VarCurr: state_type] :
      ( v34449(VarCurr)
    <=> ( v34450(VarCurr)
        & v34451(VarCurr) ) ) ).

tff(writeUnaryOperator_2088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34451(VarCurr)
    <=> v8300(VarCurr) ) ).

tff(writeUnaryOperator_2087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34450(VarCurr)
    <=> v8296(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34438(VarNext)
      <=> v34439(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34439(VarNext)
      <=> ( v34440(VarNext)
          & v34433(VarNext) ) ) ) ).

tff(writeUnaryOperator_2086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34440(VarNext)
      <=> v34442(VarNext) ) ) ).

tff(addAssignment_17017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34442(VarNext)
      <=> v34433(VarCurr) ) ) ).

tff(addAssignment_17016,axiom,
    ! [VarCurr: state_type] :
      ( v34433(VarCurr)
    <=> v34435(VarCurr) ) ).

tff(addAssignment_17015,axiom,
    ! [VarCurr: state_type] :
      ( v34435(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_17014,axiom,
    ! [VarCurr: state_type] :
      ( v8304(VarCurr,0)
    <=> v8306(VarCurr,0) ) ).

tff(addAssignment_17013,axiom,
    ! [VarCurr: state_type] :
      ( v8306(VarCurr,0)
    <=> v8308(VarCurr,0) ) ).

tff(addAssignment_17012,axiom,
    ! [VarCurr: state_type] :
      ( v8308(VarCurr,0)
    <=> v34431(VarCurr,0) ) ).

tff(addAssignment_17011,axiom,
    ! [VarCurr: state_type] :
      ( v34431(VarCurr,0)
    <=> v9077(VarCurr) ) ).

tff(addAssignment_17010,axiom,
    ! [VarCurr: state_type] :
      ( v34431(VarCurr,1)
    <=> v8310(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3381,axiom,
    ! [VarCurr: state_type] :
      ( v9077(VarCurr)
    <=> ( v34401(VarCurr)
        & v34407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3380,axiom,
    ! [VarCurr: state_type] :
      ( v34407(VarCurr)
    <=> ( v34408(VarCurr)
        | v9075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3379,axiom,
    ! [VarCurr: state_type] :
      ( v34408(VarCurr)
    <=> ( v34409(VarCurr)
        | v34423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3378,axiom,
    ! [VarCurr: state_type] :
      ( v34423(VarCurr)
    <=> ( v30900(VarCurr)
        & v34424(VarCurr) ) ) ).

tff(writeUnaryOperator_2085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34424(VarCurr)
    <=> v34425(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_493,axiom,
    ! [VarCurr: state_type] :
      ( v34425(VarCurr)
    <=> ( v34427(VarCurr)
        | v30943(VarCurr,15) ) ) ).

tff(writeBinaryOperatorShiftedRanges_492,axiom,
    ! [VarCurr: state_type] :
      ( v34427(VarCurr)
    <=> ( v34428(VarCurr)
        | v30943(VarCurr,14) ) ) ).

tff(writeBinaryOperatorShiftedRanges_491,axiom,
    ! [VarCurr: state_type] :
      ( v34428(VarCurr)
    <=> ( v34429(VarCurr)
        | v30943(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_490,axiom,
    ! [VarCurr: state_type] :
      ( v34429(VarCurr)
    <=> ( v34430(VarCurr)
        | v30943(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_489,axiom,
    ! [VarCurr: state_type] :
      ( v34430(VarCurr)
    <=> ( v30943(VarCurr,10)
        | v30943(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_488,axiom,
    ! [VarCurr: state_type] :
      ( v34409(VarCurr)
    <=> ( v34411(VarCurr)
        & v9079(VarCurr,13) ) ) ).

tff(writeBinaryOperatorShiftedRanges_487,axiom,
    ! [VarCurr: state_type] :
      ( v34411(VarCurr)
    <=> ( v34412(VarCurr)
        & v9079(VarCurr,12) ) ) ).

tff(writeBinaryOperatorShiftedRanges_486,axiom,
    ! [VarCurr: state_type] :
      ( v34412(VarCurr)
    <=> ( v34413(VarCurr)
        & v9079(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_485,axiom,
    ! [VarCurr: state_type] :
      ( v34413(VarCurr)
    <=> ( v34414(VarCurr)
        & v9079(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_484,axiom,
    ! [VarCurr: state_type] :
      ( v34414(VarCurr)
    <=> ( v34415(VarCurr)
        & v9079(VarCurr,9) ) ) ).

tff(writeBinaryOperatorShiftedRanges_483,axiom,
    ! [VarCurr: state_type] :
      ( v34415(VarCurr)
    <=> ( v34416(VarCurr)
        & v9079(VarCurr,8) ) ) ).

tff(writeBinaryOperatorShiftedRanges_482,axiom,
    ! [VarCurr: state_type] :
      ( v34416(VarCurr)
    <=> ( v34417(VarCurr)
        & v9079(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_481,axiom,
    ! [VarCurr: state_type] :
      ( v34417(VarCurr)
    <=> ( v34418(VarCurr)
        & v9079(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_480,axiom,
    ! [VarCurr: state_type] :
      ( v34418(VarCurr)
    <=> ( v34419(VarCurr)
        & v9079(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_479,axiom,
    ! [VarCurr: state_type] :
      ( v34419(VarCurr)
    <=> ( v34420(VarCurr)
        & v9079(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_478,axiom,
    ! [VarCurr: state_type] :
      ( v34420(VarCurr)
    <=> ( v34421(VarCurr)
        & v9079(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_477,axiom,
    ! [VarCurr: state_type] :
      ( v34421(VarCurr)
    <=> ( v34422(VarCurr)
        & v9079(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_476,axiom,
    ! [VarCurr: state_type] :
      ( v34422(VarCurr)
    <=> ( v9079(VarCurr,0)
        & v9079(VarCurr,1) ) ) ).

tff(writeBinaryOperatorShiftedRanges_475,axiom,
    ! [VarCurr: state_type] :
      ( v34401(VarCurr)
    <=> ( v34402(VarCurr)
        | v8422(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3377,axiom,
    ! [VarCurr: state_type] :
      ( v34402(VarCurr)
    <=> ( v34403(VarCurr)
        | v8312(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3376,axiom,
    ! [VarCurr: state_type] :
      ( v34403(VarCurr)
    <=> ( v34404(VarCurr)
        | v5037(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_474,axiom,
    ! [VarCurr: state_type] :
      ( v34404(VarCurr)
    <=> ( v34406(VarCurr)
        | v4201(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_473,axiom,
    ! [VarCurr: state_type] :
      ( v34406(VarCurr)
    <=> ( v4201(VarCurr,0)
        | v4201(VarCurr,1) ) ) ).

tff(addAssignment_17009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30945(VarCurr,B)
      <=> v30947(VarCurr,B) ) ) ).

tff(addAssignment_17008,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30947(VarNext,B)
      <=> v34393(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34394(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v34393(VarNext,B)
            <=> v30947(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_407,axiom,
    ! [VarNext: state_type] :
      ( v34394(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34393(VarNext,B)
          <=> v34378(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34394(VarNext)
      <=> v34395(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34395(VarNext)
      <=> ( v34397(VarNext)
          & v34363(VarNext) ) ) ) ).

tff(writeUnaryOperator_2084,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34397(VarNext)
      <=> v34372(VarNext) ) ) ).

tff(addAssignment_17007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30957(VarCurr,B)
      <=> v30959(VarCurr,B) ) ) ).

tff(addAssignment_17006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30959(VarCurr,B)
      <=> v30961(VarCurr,B) ) ) ).

tff(addAssignment_17005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30961(VarCurr,B)
      <=> v30963(VarCurr,B) ) ) ).

tff(addAssignment_17004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v30963(VarCurr,B)
      <=> v34248(VarCurr,B) ) ) ).

tff(addAssignment_17003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31203(VarCurr,B)
      <=> v31266(VarCurr,B) ) ) ).

tff(addAssignment_17002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31205(VarCurr,B)
      <=> v31207(VarCurr,B) ) ) ).

tff(addAssignment_17001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31207(VarCurr,B)
      <=> v31209(VarCurr,B) ) ) ).

tff(addAssignment_17000,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31209(VarNext,B)
      <=> v34385(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34386(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v34385(VarNext,B)
            <=> v31209(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_406,axiom,
    ! [VarNext: state_type] :
      ( v34386(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34385(VarNext,B)
          <=> v31260(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34386(VarNext)
      <=> v34387(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34387(VarNext)
      <=> ( v34389(VarNext)
          & v31245(VarNext) ) ) ) ).

tff(writeUnaryOperator_2083,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34389(VarNext)
      <=> v31254(VarNext) ) ) ).

tff(addAssignment_16999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31219(VarCurr,B)
      <=> v31221(VarCurr,B) ) ) ).

tff(addAssignment_16998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31221(VarCurr,B)
      <=> v31236(VarCurr,B) ) ) ).

tff(addAssignment_16997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31223(VarCurr,B)
      <=> v31225(VarCurr,B) ) ) ).

tff(addAssignment_16996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31225(VarCurr,B)
      <=> v31228(VarCurr,B) ) ) ).

tff(addAssignment_16995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,10) )
     => ( v31227(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_16994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30943(VarCurr,B)
      <=> v30945(VarCurr,B) ) ) ).

tff(addAssignment_16993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30945(VarCurr,B)
      <=> v30947(VarCurr,B) ) ) ).

tff(addAssignment_16992,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30947(VarNext,B)
      <=> v34367(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34368(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v34367(VarNext,B)
            <=> v30947(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_405,axiom,
    ! [VarNext: state_type] :
      ( v34368(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34367(VarNext,B)
          <=> v34378(VarNext,B) ) ) ) ).

tff(addAssignment_16991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34378(VarNext,B)
          <=> v34376(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34379(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34376(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_297,axiom,
    ! [VarCurr: state_type] :
      ( v34379(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34376(VarCurr,B)
          <=> v30957(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3371,axiom,
    ! [VarCurr: state_type] :
      ( v34379(VarCurr)
    <=> ( v34380(VarCurr)
        & v34381(VarCurr) ) ) ).

tff(writeUnaryOperator_2082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34381(VarCurr)
    <=> v30953(VarCurr) ) ).

tff(writeUnaryOperator_2081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34380(VarCurr)
    <=> v30949(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34368(VarNext)
      <=> v34369(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34369(VarNext)
      <=> ( v34370(VarNext)
          & v34363(VarNext) ) ) ) ).

tff(writeUnaryOperator_2080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34370(VarNext)
      <=> v34372(VarNext) ) ) ).

tff(addAssignment_16990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34372(VarNext)
      <=> v34363(VarCurr) ) ) ).

tff(addAssignment_16989,axiom,
    ! [VarCurr: state_type] :
      ( v34363(VarCurr)
    <=> v34365(VarCurr) ) ).

tff(addAssignment_16988,axiom,
    ! [VarCurr: state_type] :
      ( v34365(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30957(VarCurr,B)
      <=> v30959(VarCurr,B) ) ) ).

tff(addAssignment_16986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30959(VarCurr,B)
      <=> v30961(VarCurr,B) ) ) ).

tff(addAssignment_16985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30961(VarCurr,B)
      <=> v30963(VarCurr,B) ) ) ).

tff(addAssignment_16984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v30963(VarCurr,B)
      <=> v34248(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v34248(VarCurr,B)
      <=> ( v34249(VarCurr,B)
          | v34359(VarCurr,B) ) ) ) ).

tff(addAssignment_16983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v34359(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_16982,axiom,
    ! [VarCurr: state_type] :
      ( v34359(VarCurr,7)
    <=> v34360(VarCurr) ) ).

tff(addAssignment_16981,axiom,
    ! [VarCurr: state_type] :
      ( ( v34359(VarCurr,15)
      <=> $false )
      & ( v34359(VarCurr,14)
      <=> $false )
      & ( v34359(VarCurr,13)
      <=> $false )
      & ( v34359(VarCurr,12)
      <=> $false )
      & ( v34359(VarCurr,11)
      <=> $false )
      & ( v34359(VarCurr,10)
      <=> $false )
      & ( v34359(VarCurr,9)
      <=> $false )
      & ( v34359(VarCurr,8)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3368,axiom,
    ! [VarCurr: state_type] :
      ( v34360(VarCurr)
    <=> ( v31269(VarCurr)
        | v34361(VarCurr) ) ) ).

tff(writeUnaryOperator_2079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34361(VarCurr)
    <=> v32524(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34249(VarCurr,B)
          <=> v31203(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_296,axiom,
    ! [VarCurr: state_type] :
      ( v34250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34249(VarCurr,B)
          <=> v34252(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34253(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34252(VarCurr,B)
          <=> v34254(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_295,axiom,
    ! [VarCurr: state_type] :
      ( v34253(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v34252(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_16980,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,0)
    <=> v34357(VarCurr) ) ).

tff(addAssignment_16979,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,1)
    <=> v34355(VarCurr) ) ).

tff(addAssignment_16978,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,2)
    <=> v34351(VarCurr) ) ).

tff(addAssignment_16977,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,3)
    <=> v34347(VarCurr) ) ).

tff(addAssignment_16976,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,4)
    <=> v34343(VarCurr) ) ).

tff(addAssignment_16975,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,5)
    <=> v34339(VarCurr) ) ).

tff(addAssignment_16974,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,6)
    <=> v34335(VarCurr) ) ).

tff(addAssignment_16973,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,7)
    <=> v34331(VarCurr) ) ).

tff(addAssignment_16972,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,8)
    <=> v34327(VarCurr) ) ).

tff(addAssignment_16971,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,9)
    <=> v34323(VarCurr) ) ).

tff(addAssignment_16970,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,10)
    <=> v34319(VarCurr) ) ).

tff(addAssignment_16969,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,11)
    <=> v34315(VarCurr) ) ).

tff(addAssignment_16968,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,12)
    <=> v34311(VarCurr) ) ).

tff(addAssignment_16967,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,13)
    <=> v34307(VarCurr) ) ).

tff(addAssignment_16966,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,14)
    <=> v34303(VarCurr) ) ).

tff(addAssignment_16965,axiom,
    ! [VarCurr: state_type] :
      ( v34254(VarCurr,15)
    <=> v34256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3367,axiom,
    ! [VarCurr: state_type] :
      ( v34355(VarCurr)
    <=> ( v34356(VarCurr)
        & v34358(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3366,axiom,
    ! [VarCurr: state_type] :
      ( v34358(VarCurr)
    <=> ( v30943(VarCurr,0)
        | v34287(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_472,axiom,
    ! [VarCurr: state_type] :
      ( v34356(VarCurr)
    <=> ( v34357(VarCurr)
        | v30943(VarCurr,1) ) ) ).

tff(writeUnaryOperator_2078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34357(VarCurr)
    <=> v30943(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3365,axiom,
    ! [VarCurr: state_type] :
      ( v34351(VarCurr)
    <=> ( v34352(VarCurr)
        & v34354(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3364,axiom,
    ! [VarCurr: state_type] :
      ( v34354(VarCurr)
    <=> ( v34285(VarCurr)
        | v34288(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_471,axiom,
    ! [VarCurr: state_type] :
      ( v34352(VarCurr)
    <=> ( v34353(VarCurr)
        | v30943(VarCurr,2) ) ) ).

tff(writeUnaryOperator_2077,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34353(VarCurr)
    <=> v34285(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3363,axiom,
    ! [VarCurr: state_type] :
      ( v34347(VarCurr)
    <=> ( v34348(VarCurr)
        & v34350(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3362,axiom,
    ! [VarCurr: state_type] :
      ( v34350(VarCurr)
    <=> ( v34283(VarCurr)
        | v34289(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_470,axiom,
    ! [VarCurr: state_type] :
      ( v34348(VarCurr)
    <=> ( v34349(VarCurr)
        | v30943(VarCurr,3) ) ) ).

tff(writeUnaryOperator_2076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34349(VarCurr)
    <=> v34283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3361,axiom,
    ! [VarCurr: state_type] :
      ( v34343(VarCurr)
    <=> ( v34344(VarCurr)
        & v34346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3360,axiom,
    ! [VarCurr: state_type] :
      ( v34346(VarCurr)
    <=> ( v34281(VarCurr)
        | v34290(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_469,axiom,
    ! [VarCurr: state_type] :
      ( v34344(VarCurr)
    <=> ( v34345(VarCurr)
        | v30943(VarCurr,4) ) ) ).

tff(writeUnaryOperator_2075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34345(VarCurr)
    <=> v34281(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3359,axiom,
    ! [VarCurr: state_type] :
      ( v34339(VarCurr)
    <=> ( v34340(VarCurr)
        & v34342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3358,axiom,
    ! [VarCurr: state_type] :
      ( v34342(VarCurr)
    <=> ( v34279(VarCurr)
        | v34291(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_468,axiom,
    ! [VarCurr: state_type] :
      ( v34340(VarCurr)
    <=> ( v34341(VarCurr)
        | v30943(VarCurr,5) ) ) ).

tff(writeUnaryOperator_2074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34341(VarCurr)
    <=> v34279(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3357,axiom,
    ! [VarCurr: state_type] :
      ( v34335(VarCurr)
    <=> ( v34336(VarCurr)
        & v34338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3356,axiom,
    ! [VarCurr: state_type] :
      ( v34338(VarCurr)
    <=> ( v34277(VarCurr)
        | v34292(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_467,axiom,
    ! [VarCurr: state_type] :
      ( v34336(VarCurr)
    <=> ( v34337(VarCurr)
        | v30943(VarCurr,6) ) ) ).

tff(writeUnaryOperator_2073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34337(VarCurr)
    <=> v34277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3355,axiom,
    ! [VarCurr: state_type] :
      ( v34331(VarCurr)
    <=> ( v34332(VarCurr)
        & v34334(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3354,axiom,
    ! [VarCurr: state_type] :
      ( v34334(VarCurr)
    <=> ( v34275(VarCurr)
        | v34293(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_466,axiom,
    ! [VarCurr: state_type] :
      ( v34332(VarCurr)
    <=> ( v34333(VarCurr)
        | v30943(VarCurr,7) ) ) ).

tff(writeUnaryOperator_2072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34333(VarCurr)
    <=> v34275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3353,axiom,
    ! [VarCurr: state_type] :
      ( v34327(VarCurr)
    <=> ( v34328(VarCurr)
        & v34330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3352,axiom,
    ! [VarCurr: state_type] :
      ( v34330(VarCurr)
    <=> ( v34273(VarCurr)
        | v34294(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_465,axiom,
    ! [VarCurr: state_type] :
      ( v34328(VarCurr)
    <=> ( v34329(VarCurr)
        | v30943(VarCurr,8) ) ) ).

tff(writeUnaryOperator_2071,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34329(VarCurr)
    <=> v34273(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3351,axiom,
    ! [VarCurr: state_type] :
      ( v34323(VarCurr)
    <=> ( v34324(VarCurr)
        & v34326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3350,axiom,
    ! [VarCurr: state_type] :
      ( v34326(VarCurr)
    <=> ( v34271(VarCurr)
        | v34295(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_464,axiom,
    ! [VarCurr: state_type] :
      ( v34324(VarCurr)
    <=> ( v34325(VarCurr)
        | v30943(VarCurr,9) ) ) ).

tff(writeUnaryOperator_2070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34325(VarCurr)
    <=> v34271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3349,axiom,
    ! [VarCurr: state_type] :
      ( v34319(VarCurr)
    <=> ( v34320(VarCurr)
        & v34322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3348,axiom,
    ! [VarCurr: state_type] :
      ( v34322(VarCurr)
    <=> ( v34269(VarCurr)
        | v34296(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_463,axiom,
    ! [VarCurr: state_type] :
      ( v34320(VarCurr)
    <=> ( v34321(VarCurr)
        | v30943(VarCurr,10) ) ) ).

tff(writeUnaryOperator_2069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34321(VarCurr)
    <=> v34269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3347,axiom,
    ! [VarCurr: state_type] :
      ( v34315(VarCurr)
    <=> ( v34316(VarCurr)
        & v34318(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3346,axiom,
    ! [VarCurr: state_type] :
      ( v34318(VarCurr)
    <=> ( v34267(VarCurr)
        | v34297(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_462,axiom,
    ! [VarCurr: state_type] :
      ( v34316(VarCurr)
    <=> ( v34317(VarCurr)
        | v30943(VarCurr,11) ) ) ).

tff(writeUnaryOperator_2068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34317(VarCurr)
    <=> v34267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3345,axiom,
    ! [VarCurr: state_type] :
      ( v34311(VarCurr)
    <=> ( v34312(VarCurr)
        & v34314(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3344,axiom,
    ! [VarCurr: state_type] :
      ( v34314(VarCurr)
    <=> ( v34265(VarCurr)
        | v34298(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_461,axiom,
    ! [VarCurr: state_type] :
      ( v34312(VarCurr)
    <=> ( v34313(VarCurr)
        | v30943(VarCurr,12) ) ) ).

tff(writeUnaryOperator_2067,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34313(VarCurr)
    <=> v34265(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3343,axiom,
    ! [VarCurr: state_type] :
      ( v34307(VarCurr)
    <=> ( v34308(VarCurr)
        & v34310(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3342,axiom,
    ! [VarCurr: state_type] :
      ( v34310(VarCurr)
    <=> ( v34263(VarCurr)
        | v34299(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_460,axiom,
    ! [VarCurr: state_type] :
      ( v34308(VarCurr)
    <=> ( v34309(VarCurr)
        | v30943(VarCurr,13) ) ) ).

tff(writeUnaryOperator_2066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34309(VarCurr)
    <=> v34263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3341,axiom,
    ! [VarCurr: state_type] :
      ( v34303(VarCurr)
    <=> ( v34304(VarCurr)
        & v34306(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3340,axiom,
    ! [VarCurr: state_type] :
      ( v34306(VarCurr)
    <=> ( v34261(VarCurr)
        | v34300(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_459,axiom,
    ! [VarCurr: state_type] :
      ( v34304(VarCurr)
    <=> ( v34305(VarCurr)
        | v30943(VarCurr,14) ) ) ).

tff(writeUnaryOperator_2065,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34305(VarCurr)
    <=> v34261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3339,axiom,
    ! [VarCurr: state_type] :
      ( v34256(VarCurr)
    <=> ( v34257(VarCurr)
        & v34301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3338,axiom,
    ! [VarCurr: state_type] :
      ( v34301(VarCurr)
    <=> ( v34259(VarCurr)
        | v34302(VarCurr) ) ) ).

tff(writeUnaryOperator_2064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34302(VarCurr)
    <=> v30943(VarCurr,15) ) ).

tff(writeBinaryOperatorShiftedRanges_458,axiom,
    ! [VarCurr: state_type] :
      ( v34257(VarCurr)
    <=> ( v34258(VarCurr)
        | v30943(VarCurr,15) ) ) ).

tff(writeUnaryOperator_2063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34258(VarCurr)
    <=> v34259(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_457,axiom,
    ! [VarCurr: state_type] :
      ( v34259(VarCurr)
    <=> ( v30943(VarCurr,14)
        | v34260(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3337,axiom,
    ! [VarCurr: state_type] :
      ( v34260(VarCurr)
    <=> ( v34261(VarCurr)
        & v34300(VarCurr) ) ) ).

tff(writeUnaryOperator_2062,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34300(VarCurr)
    <=> v30943(VarCurr,14) ) ).

tff(writeBinaryOperatorShiftedRanges_456,axiom,
    ! [VarCurr: state_type] :
      ( v34261(VarCurr)
    <=> ( v30943(VarCurr,13)
        | v34262(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3336,axiom,
    ! [VarCurr: state_type] :
      ( v34262(VarCurr)
    <=> ( v34263(VarCurr)
        & v34299(VarCurr) ) ) ).

tff(writeUnaryOperator_2061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34299(VarCurr)
    <=> v30943(VarCurr,13) ) ).

tff(writeBinaryOperatorShiftedRanges_455,axiom,
    ! [VarCurr: state_type] :
      ( v34263(VarCurr)
    <=> ( v30943(VarCurr,12)
        | v34264(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3335,axiom,
    ! [VarCurr: state_type] :
      ( v34264(VarCurr)
    <=> ( v34265(VarCurr)
        & v34298(VarCurr) ) ) ).

tff(writeUnaryOperator_2060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34298(VarCurr)
    <=> v30943(VarCurr,12) ) ).

tff(writeBinaryOperatorShiftedRanges_454,axiom,
    ! [VarCurr: state_type] :
      ( v34265(VarCurr)
    <=> ( v30943(VarCurr,11)
        | v34266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3334,axiom,
    ! [VarCurr: state_type] :
      ( v34266(VarCurr)
    <=> ( v34267(VarCurr)
        & v34297(VarCurr) ) ) ).

tff(writeUnaryOperator_2059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34297(VarCurr)
    <=> v30943(VarCurr,11) ) ).

tff(writeBinaryOperatorShiftedRanges_453,axiom,
    ! [VarCurr: state_type] :
      ( v34267(VarCurr)
    <=> ( v30943(VarCurr,10)
        | v34268(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3333,axiom,
    ! [VarCurr: state_type] :
      ( v34268(VarCurr)
    <=> ( v34269(VarCurr)
        & v34296(VarCurr) ) ) ).

tff(writeUnaryOperator_2058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34296(VarCurr)
    <=> v30943(VarCurr,10) ) ).

tff(writeBinaryOperatorShiftedRanges_452,axiom,
    ! [VarCurr: state_type] :
      ( v34269(VarCurr)
    <=> ( v30943(VarCurr,9)
        | v34270(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3332,axiom,
    ! [VarCurr: state_type] :
      ( v34270(VarCurr)
    <=> ( v34271(VarCurr)
        & v34295(VarCurr) ) ) ).

tff(writeUnaryOperator_2057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34295(VarCurr)
    <=> v30943(VarCurr,9) ) ).

tff(writeBinaryOperatorShiftedRanges_451,axiom,
    ! [VarCurr: state_type] :
      ( v34271(VarCurr)
    <=> ( v30943(VarCurr,8)
        | v34272(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3331,axiom,
    ! [VarCurr: state_type] :
      ( v34272(VarCurr)
    <=> ( v34273(VarCurr)
        & v34294(VarCurr) ) ) ).

tff(writeUnaryOperator_2056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34294(VarCurr)
    <=> v30943(VarCurr,8) ) ).

tff(writeBinaryOperatorShiftedRanges_450,axiom,
    ! [VarCurr: state_type] :
      ( v34273(VarCurr)
    <=> ( v30943(VarCurr,7)
        | v34274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3330,axiom,
    ! [VarCurr: state_type] :
      ( v34274(VarCurr)
    <=> ( v34275(VarCurr)
        & v34293(VarCurr) ) ) ).

tff(writeUnaryOperator_2055,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34293(VarCurr)
    <=> v30943(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_449,axiom,
    ! [VarCurr: state_type] :
      ( v34275(VarCurr)
    <=> ( v30943(VarCurr,6)
        | v34276(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3329,axiom,
    ! [VarCurr: state_type] :
      ( v34276(VarCurr)
    <=> ( v34277(VarCurr)
        & v34292(VarCurr) ) ) ).

tff(writeUnaryOperator_2054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34292(VarCurr)
    <=> v30943(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_448,axiom,
    ! [VarCurr: state_type] :
      ( v34277(VarCurr)
    <=> ( v30943(VarCurr,5)
        | v34278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3328,axiom,
    ! [VarCurr: state_type] :
      ( v34278(VarCurr)
    <=> ( v34279(VarCurr)
        & v34291(VarCurr) ) ) ).

tff(writeUnaryOperator_2053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34291(VarCurr)
    <=> v30943(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_447,axiom,
    ! [VarCurr: state_type] :
      ( v34279(VarCurr)
    <=> ( v30943(VarCurr,4)
        | v34280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3327,axiom,
    ! [VarCurr: state_type] :
      ( v34280(VarCurr)
    <=> ( v34281(VarCurr)
        & v34290(VarCurr) ) ) ).

tff(writeUnaryOperator_2052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34290(VarCurr)
    <=> v30943(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_446,axiom,
    ! [VarCurr: state_type] :
      ( v34281(VarCurr)
    <=> ( v30943(VarCurr,3)
        | v34282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3326,axiom,
    ! [VarCurr: state_type] :
      ( v34282(VarCurr)
    <=> ( v34283(VarCurr)
        & v34289(VarCurr) ) ) ).

tff(writeUnaryOperator_2051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34289(VarCurr)
    <=> v30943(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_445,axiom,
    ! [VarCurr: state_type] :
      ( v34283(VarCurr)
    <=> ( v30943(VarCurr,2)
        | v34284(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3325,axiom,
    ! [VarCurr: state_type] :
      ( v34284(VarCurr)
    <=> ( v34285(VarCurr)
        & v34288(VarCurr) ) ) ).

tff(writeUnaryOperator_2050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34288(VarCurr)
    <=> v30943(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_444,axiom,
    ! [VarCurr: state_type] :
      ( v34285(VarCurr)
    <=> ( v30943(VarCurr,1)
        | v34286(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3324,axiom,
    ! [VarCurr: state_type] :
      ( v34286(VarCurr)
    <=> ( v30943(VarCurr,0)
        & v34287(VarCurr) ) ) ).

tff(writeUnaryOperator_2049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34287(VarCurr)
    <=> v30943(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_204,axiom,
    ! [VarCurr: state_type] :
      ( v34253(VarCurr)
    <=> ( ( v30943(VarCurr,15)
        <=> $false )
        & ( v30943(VarCurr,14)
        <=> $false )
        & ( v30943(VarCurr,13)
        <=> $false )
        & ( v30943(VarCurr,12)
        <=> $false )
        & ( v30943(VarCurr,11)
        <=> $false )
        & ( v30943(VarCurr,10)
        <=> $false )
        & ( v30943(VarCurr,9)
        <=> $false )
        & ( v30943(VarCurr,8)
        <=> $false )
        & ( v30943(VarCurr,7)
        <=> $false )
        & ( v30943(VarCurr,6)
        <=> $false )
        & ( v30943(VarCurr,5)
        <=> $false )
        & ( v30943(VarCurr,4)
        <=> $false )
        & ( v30943(VarCurr,3)
        <=> $false )
        & ( v30943(VarCurr,2)
        <=> $false )
        & ( v30943(VarCurr,1)
        <=> $false )
        & ( v30943(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3323,axiom,
    ! [VarCurr: state_type] :
      ( v34250(VarCurr)
    <=> ( v30965(VarCurr)
        & v34251(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_203,axiom,
    ! [VarCurr: state_type] :
      ( v34251(VarCurr)
    <=> ( ( v30967(VarCurr,15)
        <=> $false )
        & ( v30967(VarCurr,14)
        <=> $false )
        & ( v30967(VarCurr,13)
        <=> $false )
        & ( v30967(VarCurr,12)
        <=> $false )
        & ( v30967(VarCurr,11)
        <=> $false )
        & ( v30967(VarCurr,10)
        <=> $false )
        & ( v30967(VarCurr,9)
        <=> $false )
        & ( v30967(VarCurr,8)
        <=> $false )
        & ( v30967(VarCurr,7)
        <=> $false )
        & ( v30967(VarCurr,6)
        <=> $false )
        & ( v30967(VarCurr,5)
        <=> $false )
        & ( v30967(VarCurr,4)
        <=> $false )
        & ( v30967(VarCurr,3)
        <=> $false )
        & ( v30967(VarCurr,2)
        <=> $false )
        & ( v30967(VarCurr,1)
        <=> $false )
        & ( v30967(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16964,axiom,
    ! [VarCurr: state_type] :
      ( v32524(VarCurr,0)
    <=> v32526(VarCurr) ) ).

tff(addAssignment_16963,axiom,
    ! [VarCurr: state_type] :
      ( v32526(VarCurr)
    <=> v32528(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34232(VarNext)
       => ( v32528(VarNext)
        <=> v32528(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_404,axiom,
    ! [VarNext: state_type] :
      ( v34232(VarNext)
     => ( v32528(VarNext)
      <=> v34242(VarNext) ) ) ).

tff(addAssignment_16962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34242(VarNext)
      <=> v34240(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34243(VarCurr)
     => ( v34240(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_294,axiom,
    ! [VarCurr: state_type] :
      ( v34243(VarCurr)
     => ( v34240(VarCurr)
      <=> v32538(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3322,axiom,
    ! [VarCurr: state_type] :
      ( v34243(VarCurr)
    <=> ( v34244(VarCurr)
        & v34245(VarCurr) ) ) ).

tff(writeUnaryOperator_2048,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34245(VarCurr)
    <=> v32534(VarCurr) ) ).

tff(writeUnaryOperator_2047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34244(VarCurr)
    <=> v32530(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34232(VarNext)
      <=> v34233(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34233(VarNext)
      <=> ( v34234(VarNext)
          & v34227(VarNext) ) ) ) ).

tff(writeUnaryOperator_2046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34234(VarNext)
      <=> v34236(VarNext) ) ) ).

tff(addAssignment_16961,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34236(VarNext)
      <=> v34227(VarCurr) ) ) ).

tff(addAssignment_16960,axiom,
    ! [VarCurr: state_type] :
      ( v34227(VarCurr)
    <=> v34229(VarCurr) ) ).

tff(addAssignment_16959,axiom,
    ! [VarCurr: state_type] :
      ( v34229(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16958,axiom,
    ! [VarCurr: state_type] :
      ( v32538(VarCurr)
    <=> v32540(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3319,axiom,
    ! [VarCurr: state_type] :
      ( v32540(VarCurr)
    <=> ( v34219(VarCurr)
        | v34222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3318,axiom,
    ! [VarCurr: state_type] :
      ( v34222(VarCurr)
    <=> ( v32526(VarCurr)
        & v34223(VarCurr) ) ) ).

tff(writeUnaryOperator_2045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34223(VarCurr)
    <=> v34224(VarCurr) ) ).

tff(addAssignment_16957,axiom,
    ! [VarCurr: state_type] :
      ( v34224(VarCurr)
    <=> v34225(VarCurr) ) ).

tff(addAssignment_16956,axiom,
    ! [VarCurr: state_type] :
      ( v34225(VarCurr)
    <=> v34210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3317,axiom,
    ! [VarCurr: state_type] :
      ( v34219(VarCurr)
    <=> ( v32542(VarCurr)
        & v34220(VarCurr) ) ) ).

tff(addAssignment_16955,axiom,
    ! [VarCurr: state_type] :
      ( v34220(VarCurr)
    <=> v34221(VarCurr) ) ).

tff(addAssignment_16954,axiom,
    ! [VarCurr: state_type] :
      ( v34221(VarCurr)
    <=> v34210(VarCurr) ) ).

tff(addAssignment_16953,axiom,
    ! [VarCurr: state_type] :
      ( v34210(VarCurr)
    <=> v34212(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3316,axiom,
    ! [VarCurr: state_type] :
      ( v34212(VarCurr)
    <=> ( v34214(VarCurr)
        | v4329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3315,axiom,
    ! [VarCurr: state_type] :
      ( v34214(VarCurr)
    <=> ( v34215(VarCurr)
        | v4283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3314,axiom,
    ! [VarCurr: state_type] :
      ( v34215(VarCurr)
    <=> ( v34216(VarCurr)
        | v32546(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3313,axiom,
    ! [VarCurr: state_type] :
      ( v34216(VarCurr)
    <=> ( v2354(VarCurr)
        & v34217(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_202,axiom,
    ! [VarCurr: state_type] :
      ( v34217(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_937,axiom,
    ~ b0100000010000(12) ).

tff(bitBlastConstant_936,axiom,
    b0100000010000(11) ).

tff(bitBlastConstant_935,axiom,
    ~ b0100000010000(10) ).

tff(bitBlastConstant_934,axiom,
    ~ b0100000010000(9) ).

tff(bitBlastConstant_933,axiom,
    ~ b0100000010000(8) ).

tff(bitBlastConstant_932,axiom,
    ~ b0100000010000(7) ).

tff(bitBlastConstant_931,axiom,
    ~ b0100000010000(6) ).

tff(bitBlastConstant_930,axiom,
    ~ b0100000010000(5) ).

tff(bitBlastConstant_929,axiom,
    b0100000010000(4) ).

tff(bitBlastConstant_928,axiom,
    ~ b0100000010000(3) ).

tff(bitBlastConstant_927,axiom,
    ~ b0100000010000(2) ).

tff(bitBlastConstant_926,axiom,
    ~ b0100000010000(1) ).

tff(bitBlastConstant_925,axiom,
    ~ b0100000010000(0) ).

tff(addAssignment_16952,axiom,
    ! [VarCurr: state_type] :
      ( v32542(VarCurr)
    <=> v32544(VarCurr,0) ) ).

tff(addAssignment_16951,axiom,
    ! [VarCurr: state_type] :
      ( v32544(VarCurr,0)
    <=> v34205(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32546(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34205(VarCurr,B)
          <=> v34207(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_293,axiom,
    ! [VarCurr: state_type] :
      ( v32546(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34205(VarCurr,B)
          <=> v34206(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34207(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_292,axiom,
    ! [VarCurr: state_type] :
      ( v34208(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34207(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3312,axiom,
    ! [VarCurr: state_type] :
      ( v34208(VarCurr)
    <=> ( v4283(VarCurr)
        | v4329(VarCurr) ) ) ).

tff(addAssignment_16950,axiom,
    ! [VarCurr: state_type] :
      ( v34206(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_16949,axiom,
    ! [VarCurr: state_type] :
      ( v34206(VarCurr,1)
    <=> v34197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3311,axiom,
    ! [VarCurr: state_type] :
      ( v32546(VarCurr)
    <=> ( v34202(VarCurr)
        | v34197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3310,axiom,
    ! [VarCurr: state_type] :
      ( v34202(VarCurr)
    <=> ( v34203(VarCurr)
        & v32548(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3309,axiom,
    ! [VarCurr: state_type] :
      ( v34203(VarCurr)
    <=> ( v32524(VarCurr,0)
        & v34204(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_201,axiom,
    ! [VarCurr: state_type] :
      ( v34204(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3308,axiom,
    ! [VarCurr: state_type] :
      ( v34197(VarCurr)
    <=> ( v34199(VarCurr)
        | v32570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3307,axiom,
    ! [VarCurr: state_type] :
      ( v34199(VarCurr)
    <=> ( v34200(VarCurr)
        | v33470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3306,axiom,
    ! [VarCurr: state_type] :
      ( v34200(VarCurr)
    <=> ( v32750(VarCurr)
        | v33202(VarCurr) ) ) ).

tff(addAssignment_16948,axiom,
    ! [VarCurr: state_type] :
      ( v32550(VarCurr,0)
    <=> v32552(VarCurr,0) ) ).

tff(addAssignment_16947,axiom,
    ! [VarNext: state_type] :
      ( v32552(VarNext,0)
    <=> v34189(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34190(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v34189(VarNext,B)
            <=> v32552(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_403,axiom,
    ! [VarNext: state_type] :
      ( v34190(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34189(VarNext,B)
          <=> v34013(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34190(VarNext)
      <=> v34191(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34191(VarNext)
      <=> ( v34193(VarNext)
          & v33998(VarNext) ) ) ) ).

tff(writeUnaryOperator_2044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34193(VarNext)
      <=> v34007(VarNext) ) ) ).

tff(addAssignment_16946,axiom,
    ! [VarCurr: state_type] :
      ( v32562(VarCurr,0)
    <=> v32564(VarCurr,0) ) ).

tff(addAssignment_16945,axiom,
    ! [VarCurr: state_type] :
      ( v32564(VarCurr,0)
    <=> v33989(VarCurr,0) ) ).

tff(addAssignment_16944,axiom,
    ! [VarCurr: state_type] :
      ( v32566(VarCurr,0)
    <=> v32568(VarCurr,0) ) ).

tff(addAssignment_16943,axiom,
    ! [VarCurr: state_type] :
      ( v32568(VarCurr,0)
    <=> v33970(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3303,axiom,
    ! [VarCurr: state_type] :
      ( v32570(VarCurr)
    <=> ( v34184(VarCurr)
        & v34187(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_200,axiom,
    ! [VarCurr: state_type] :
      ( v34187(VarCurr)
    <=> ( ( v34020(VarCurr,7)
        <=> $false )
        & ( v34020(VarCurr,6)
        <=> $false )
        & ( v34020(VarCurr,5)
        <=> $false )
        & ( v34020(VarCurr,4)
        <=> $false )
        & ( v34020(VarCurr,3)
        <=> $false )
        & ( v34020(VarCurr,2)
        <=> $false )
        & ( v34020(VarCurr,1)
        <=> $false )
        & ( v34020(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3302,axiom,
    ! [VarCurr: state_type] :
      ( v34184(VarCurr)
    <=> ( v32572(VarCurr)
        & v34185(VarCurr) ) ) ).

tff(writeUnaryOperator_2043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34185(VarCurr)
    <=> v34186(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_443,axiom,
    ! [VarCurr: state_type] :
      ( v34186(VarCurr)
    <=> ( v32548(VarCurr,0)
        | v32548(VarCurr,1) ) ) ).

tff(addAssignment_16942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34020(VarCurr,B)
      <=> v34022(VarCurr,B) ) ) ).

tff(addAssignment_16941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34022(VarCurr,B)
      <=> v34024(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34167(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v34024(VarNext,B)
            <=> v34024(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_402,axiom,
    ! [VarNext: state_type] :
      ( v34167(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34024(VarNext,B)
          <=> v34177(VarNext,B) ) ) ) ).

tff(addAssignment_16940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34177(VarNext,B)
          <=> v34175(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34175(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_291,axiom,
    ! [VarCurr: state_type] :
      ( v34178(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34175(VarCurr,B)
          <=> v34034(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3301,axiom,
    ! [VarCurr: state_type] :
      ( v34178(VarCurr)
    <=> ( v34179(VarCurr)
        & v34180(VarCurr) ) ) ).

tff(writeUnaryOperator_2042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34180(VarCurr)
    <=> v34030(VarCurr) ) ).

tff(writeUnaryOperator_2041,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34179(VarCurr)
    <=> v34026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34167(VarNext)
      <=> v34168(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34168(VarNext)
      <=> ( v34169(VarNext)
          & v34162(VarNext) ) ) ) ).

tff(writeUnaryOperator_2040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34169(VarNext)
      <=> v34171(VarNext) ) ) ).

tff(addAssignment_16939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34171(VarNext)
      <=> v34162(VarCurr) ) ) ).

tff(addAssignment_16938,axiom,
    ! [VarCurr: state_type] :
      ( v34162(VarCurr)
    <=> v34164(VarCurr) ) ).

tff(addAssignment_16937,axiom,
    ! [VarCurr: state_type] :
      ( v34164(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16936,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34034(VarCurr,B)
      <=> v34036(VarCurr,B) ) ) ).

tff(addAssignment_16935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34036(VarCurr,B)
      <=> v34038(VarCurr,B) ) ) ).

tff(addAssignment_16934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34038(VarCurr,B)
      <=> v34040(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34040(VarCurr,B)
      <=> ( v34107(VarCurr,B)
          | v34159(VarCurr,B) ) ) ) ).

tff(addAssignment_16933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v34159(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_16932,axiom,
    ! [VarCurr: state_type] :
      ( v34159(VarCurr,7)
    <=> v34160(VarCurr) ) ).

tff(writeUnaryOperator_2039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34160(VarCurr)
    <=> v32524(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32572(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34107(VarCurr,B)
          <=> v34042(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_290,axiom,
    ! [VarCurr: state_type] :
      ( v32572(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34107(VarCurr,B)
          <=> v34108(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34109(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34108(VarCurr,B)
          <=> v34110(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_289,axiom,
    ! [VarCurr: state_type] :
      ( v34109(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34108(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_16931,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,0)
    <=> v34157(VarCurr) ) ).

tff(addAssignment_16930,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,1)
    <=> v34155(VarCurr) ) ).

tff(addAssignment_16929,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,2)
    <=> v34151(VarCurr) ) ).

tff(addAssignment_16928,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,3)
    <=> v34147(VarCurr) ) ).

tff(addAssignment_16927,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,4)
    <=> v34143(VarCurr) ) ).

tff(addAssignment_16926,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,5)
    <=> v34139(VarCurr) ) ).

tff(addAssignment_16925,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,6)
    <=> v34135(VarCurr) ) ).

tff(addAssignment_16924,axiom,
    ! [VarCurr: state_type] :
      ( v34110(VarCurr,7)
    <=> v34112(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3298,axiom,
    ! [VarCurr: state_type] :
      ( v34155(VarCurr)
    <=> ( v34156(VarCurr)
        & v34158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3297,axiom,
    ! [VarCurr: state_type] :
      ( v34158(VarCurr)
    <=> ( v34020(VarCurr,0)
        | v34127(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_442,axiom,
    ! [VarCurr: state_type] :
      ( v34156(VarCurr)
    <=> ( v34157(VarCurr)
        | v34020(VarCurr,1) ) ) ).

tff(writeUnaryOperator_2038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34157(VarCurr)
    <=> v34020(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3296,axiom,
    ! [VarCurr: state_type] :
      ( v34151(VarCurr)
    <=> ( v34152(VarCurr)
        & v34154(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3295,axiom,
    ! [VarCurr: state_type] :
      ( v34154(VarCurr)
    <=> ( v34125(VarCurr)
        | v34128(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_441,axiom,
    ! [VarCurr: state_type] :
      ( v34152(VarCurr)
    <=> ( v34153(VarCurr)
        | v34020(VarCurr,2) ) ) ).

tff(writeUnaryOperator_2037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34153(VarCurr)
    <=> v34125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3294,axiom,
    ! [VarCurr: state_type] :
      ( v34147(VarCurr)
    <=> ( v34148(VarCurr)
        & v34150(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3293,axiom,
    ! [VarCurr: state_type] :
      ( v34150(VarCurr)
    <=> ( v34123(VarCurr)
        | v34129(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_440,axiom,
    ! [VarCurr: state_type] :
      ( v34148(VarCurr)
    <=> ( v34149(VarCurr)
        | v34020(VarCurr,3) ) ) ).

tff(writeUnaryOperator_2036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34149(VarCurr)
    <=> v34123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3292,axiom,
    ! [VarCurr: state_type] :
      ( v34143(VarCurr)
    <=> ( v34144(VarCurr)
        & v34146(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3291,axiom,
    ! [VarCurr: state_type] :
      ( v34146(VarCurr)
    <=> ( v34121(VarCurr)
        | v34130(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_439,axiom,
    ! [VarCurr: state_type] :
      ( v34144(VarCurr)
    <=> ( v34145(VarCurr)
        | v34020(VarCurr,4) ) ) ).

tff(writeUnaryOperator_2035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34145(VarCurr)
    <=> v34121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3290,axiom,
    ! [VarCurr: state_type] :
      ( v34139(VarCurr)
    <=> ( v34140(VarCurr)
        & v34142(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3289,axiom,
    ! [VarCurr: state_type] :
      ( v34142(VarCurr)
    <=> ( v34119(VarCurr)
        | v34131(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_438,axiom,
    ! [VarCurr: state_type] :
      ( v34140(VarCurr)
    <=> ( v34141(VarCurr)
        | v34020(VarCurr,5) ) ) ).

tff(writeUnaryOperator_2034,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34141(VarCurr)
    <=> v34119(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3288,axiom,
    ! [VarCurr: state_type] :
      ( v34135(VarCurr)
    <=> ( v34136(VarCurr)
        & v34138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3287,axiom,
    ! [VarCurr: state_type] :
      ( v34138(VarCurr)
    <=> ( v34117(VarCurr)
        | v34132(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_437,axiom,
    ! [VarCurr: state_type] :
      ( v34136(VarCurr)
    <=> ( v34137(VarCurr)
        | v34020(VarCurr,6) ) ) ).

tff(writeUnaryOperator_2033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34137(VarCurr)
    <=> v34117(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3286,axiom,
    ! [VarCurr: state_type] :
      ( v34112(VarCurr)
    <=> ( v34113(VarCurr)
        & v34133(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3285,axiom,
    ! [VarCurr: state_type] :
      ( v34133(VarCurr)
    <=> ( v34115(VarCurr)
        | v34134(VarCurr) ) ) ).

tff(writeUnaryOperator_2032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34134(VarCurr)
    <=> v34020(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_436,axiom,
    ! [VarCurr: state_type] :
      ( v34113(VarCurr)
    <=> ( v34114(VarCurr)
        | v34020(VarCurr,7) ) ) ).

tff(writeUnaryOperator_2031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34114(VarCurr)
    <=> v34115(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_435,axiom,
    ! [VarCurr: state_type] :
      ( v34115(VarCurr)
    <=> ( v34020(VarCurr,6)
        | v34116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3284,axiom,
    ! [VarCurr: state_type] :
      ( v34116(VarCurr)
    <=> ( v34117(VarCurr)
        & v34132(VarCurr) ) ) ).

tff(writeUnaryOperator_2030,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34132(VarCurr)
    <=> v34020(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_434,axiom,
    ! [VarCurr: state_type] :
      ( v34117(VarCurr)
    <=> ( v34020(VarCurr,5)
        | v34118(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3283,axiom,
    ! [VarCurr: state_type] :
      ( v34118(VarCurr)
    <=> ( v34119(VarCurr)
        & v34131(VarCurr) ) ) ).

tff(writeUnaryOperator_2029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34131(VarCurr)
    <=> v34020(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_433,axiom,
    ! [VarCurr: state_type] :
      ( v34119(VarCurr)
    <=> ( v34020(VarCurr,4)
        | v34120(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3282,axiom,
    ! [VarCurr: state_type] :
      ( v34120(VarCurr)
    <=> ( v34121(VarCurr)
        & v34130(VarCurr) ) ) ).

tff(writeUnaryOperator_2028,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34130(VarCurr)
    <=> v34020(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_432,axiom,
    ! [VarCurr: state_type] :
      ( v34121(VarCurr)
    <=> ( v34020(VarCurr,3)
        | v34122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3281,axiom,
    ! [VarCurr: state_type] :
      ( v34122(VarCurr)
    <=> ( v34123(VarCurr)
        & v34129(VarCurr) ) ) ).

tff(writeUnaryOperator_2027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34129(VarCurr)
    <=> v34020(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_431,axiom,
    ! [VarCurr: state_type] :
      ( v34123(VarCurr)
    <=> ( v34020(VarCurr,2)
        | v34124(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3280,axiom,
    ! [VarCurr: state_type] :
      ( v34124(VarCurr)
    <=> ( v34125(VarCurr)
        & v34128(VarCurr) ) ) ).

tff(writeUnaryOperator_2026,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34128(VarCurr)
    <=> v34020(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_430,axiom,
    ! [VarCurr: state_type] :
      ( v34125(VarCurr)
    <=> ( v34020(VarCurr,1)
        | v34126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3279,axiom,
    ! [VarCurr: state_type] :
      ( v34126(VarCurr)
    <=> ( v34020(VarCurr,0)
        & v34127(VarCurr) ) ) ).

tff(writeUnaryOperator_2025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34127(VarCurr)
    <=> v34020(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_199,axiom,
    ! [VarCurr: state_type] :
      ( v34109(VarCurr)
    <=> ( ( v34020(VarCurr,7)
        <=> $false )
        & ( v34020(VarCurr,6)
        <=> $false )
        & ( v34020(VarCurr,5)
        <=> $false )
        & ( v34020(VarCurr,4)
        <=> $false )
        & ( v34020(VarCurr,3)
        <=> $false )
        & ( v34020(VarCurr,2)
        <=> $false )
        & ( v34020(VarCurr,1)
        <=> $false )
        & ( v34020(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_2024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34042(VarCurr,B)
      <=> ~ v34044(VarCurr,B) ) ) ).

tff(addAssignment_16923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34044(VarCurr,B)
      <=> v34046(VarCurr,B) ) ) ).

tff(addAssignment_16922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34046(VarCurr,B)
      <=> v34048(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_401,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34089(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v34048(VarNext,B)
            <=> v34048(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_401,axiom,
    ! [VarNext: state_type] :
      ( v34089(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34048(VarNext,B)
          <=> v34099(VarNext,B) ) ) ) ).

tff(addAssignment_16921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34099(VarNext,B)
          <=> v34097(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34097(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_288,axiom,
    ! [VarCurr: state_type] :
      ( v34100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v34097(VarCurr,B)
          <=> v34058(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3278,axiom,
    ! [VarCurr: state_type] :
      ( v34100(VarCurr)
    <=> ( v34101(VarCurr)
        & v34102(VarCurr) ) ) ).

tff(writeUnaryOperator_2023,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34102(VarCurr)
    <=> v34054(VarCurr) ) ).

tff(writeUnaryOperator_2022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34101(VarCurr)
    <=> v34050(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34089(VarNext)
      <=> v34090(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34090(VarNext)
      <=> ( v34091(VarNext)
          & v34084(VarNext) ) ) ) ).

tff(writeUnaryOperator_2021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34091(VarNext)
      <=> v34093(VarNext) ) ) ).

tff(addAssignment_16920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34093(VarNext)
      <=> v34084(VarCurr) ) ) ).

tff(addAssignment_16919,axiom,
    ! [VarCurr: state_type] :
      ( v34084(VarCurr)
    <=> v34086(VarCurr) ) ).

tff(addAssignment_16918,axiom,
    ! [VarCurr: state_type] :
      ( v34086(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34058(VarCurr,B)
      <=> v34060(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34060(VarCurr,B)
      <=> ( v34076(VarCurr,B)
          | v34079(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34079(VarCurr,B)
      <=> ( v34046(VarCurr,B)
          & v34080(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_2020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34080(VarCurr,B)
      <=> ~ v34081(VarCurr,B) ) ) ).

tff(addAssignment_16916,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,0)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16915,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,1)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16914,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,2)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16913,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,3)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16912,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,4)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16911,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,5)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16910,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,6)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16909,axiom,
    ! [VarCurr: state_type] :
      ( v34081(VarCurr,7)
    <=> v34082(VarCurr) ) ).

tff(addAssignment_16908,axiom,
    ! [VarCurr: state_type] :
      ( v34082(VarCurr)
    <=> v34069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34076(VarCurr,B)
      <=> ( v34062(VarCurr,B)
          & v34077(VarCurr,B) ) ) ) ).

tff(addAssignment_16907,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,0)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16906,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,1)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16905,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,2)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16904,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,3)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16903,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,4)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16902,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,5)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16901,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,6)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16900,axiom,
    ! [VarCurr: state_type] :
      ( v34077(VarCurr,7)
    <=> v34078(VarCurr) ) ).

tff(addAssignment_16899,axiom,
    ! [VarCurr: state_type] :
      ( v34078(VarCurr)
    <=> v34069(VarCurr) ) ).

tff(addAssignment_16898,axiom,
    ! [VarCurr: state_type] :
      ( v34069(VarCurr)
    <=> v34071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3275,axiom,
    ! [VarCurr: state_type] :
      ( v34071(VarCurr)
    <=> ( v2354(VarCurr)
        & v34074(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_198,axiom,
    ! [VarCurr: state_type] :
      ( v34074(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_924,axiom,
    ~ b0100010011000(12) ).

tff(bitBlastConstant_923,axiom,
    b0100010011000(11) ).

tff(bitBlastConstant_922,axiom,
    ~ b0100010011000(10) ).

tff(bitBlastConstant_921,axiom,
    ~ b0100010011000(9) ).

tff(bitBlastConstant_920,axiom,
    ~ b0100010011000(8) ).

tff(bitBlastConstant_919,axiom,
    b0100010011000(7) ).

tff(bitBlastConstant_918,axiom,
    ~ b0100010011000(6) ).

tff(bitBlastConstant_917,axiom,
    ~ b0100010011000(5) ).

tff(bitBlastConstant_916,axiom,
    b0100010011000(4) ).

tff(bitBlastConstant_915,axiom,
    b0100010011000(3) ).

tff(bitBlastConstant_914,axiom,
    ~ b0100010011000(2) ).

tff(bitBlastConstant_913,axiom,
    ~ b0100010011000(1) ).

tff(bitBlastConstant_912,axiom,
    ~ b0100010011000(0) ).

tff(addAssignment_16897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34062(VarCurr,B)
      <=> v34064(VarCurr,B) ) ) ).

tff(writeUnaryOperator_2019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34064(VarCurr,B)
      <=> ~ v34066(VarCurr,B) ) ) ).

tff(addAssignment_16896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v34066(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_16895,axiom,
    ! [VarCurr: state_type] :
      ( v34054(VarCurr)
    <=> v34056(VarCurr) ) ).

tff(addAssignment_16894,axiom,
    ! [VarCurr: state_type] :
      ( v34056(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16893,axiom,
    ! [VarCurr: state_type] :
      ( v34050(VarCurr)
    <=> v34052(VarCurr) ) ).

tff(addAssignment_16892,axiom,
    ! [VarCurr: state_type] :
      ( v34052(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_16891,axiom,
    ! [VarCurr: state_type] :
      ( v34030(VarCurr)
    <=> v34032(VarCurr) ) ).

tff(addAssignment_16890,axiom,
    ! [VarCurr: state_type] :
      ( v34032(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16889,axiom,
    ! [VarCurr: state_type] :
      ( v34026(VarCurr)
    <=> v34028(VarCurr) ) ).

tff(addAssignment_16888,axiom,
    ! [VarCurr: state_type] :
      ( v34028(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v32548(VarCurr,B)
      <=> v32550(VarCurr,B) ) ) ).

tff(addAssignment_16886,axiom,
    ! [VarCurr: state_type] :
      ( v32550(VarCurr,1)
    <=> v32552(VarCurr,1) ) ).

tff(addAssignment_16885,axiom,
    ! [VarNext: state_type] :
      ( v32552(VarNext,1)
    <=> v34002(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34003(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v34002(VarNext,B)
            <=> v32552(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_400,axiom,
    ! [VarNext: state_type] :
      ( v34003(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34002(VarNext,B)
          <=> v34013(VarNext,B) ) ) ) ).

tff(addAssignment_16884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34013(VarNext,B)
          <=> v34011(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34014(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34011(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_287,axiom,
    ! [VarCurr: state_type] :
      ( v34014(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v34011(VarCurr,B)
          <=> v32562(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3274,axiom,
    ! [VarCurr: state_type] :
      ( v34014(VarCurr)
    <=> ( v34015(VarCurr)
        & v34016(VarCurr) ) ) ).

tff(writeUnaryOperator_2018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34016(VarCurr)
    <=> v32558(VarCurr) ) ).

tff(writeUnaryOperator_2017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v34015(VarCurr)
    <=> v32554(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34003(VarNext)
      <=> v34004(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34004(VarNext)
      <=> ( v34005(VarNext)
          & v33998(VarNext) ) ) ) ).

tff(writeUnaryOperator_2016,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v34005(VarNext)
      <=> v34007(VarNext) ) ) ).

tff(addAssignment_16883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v34007(VarNext)
      <=> v33998(VarCurr) ) ) ).

tff(addAssignment_16882,axiom,
    ! [VarCurr: state_type] :
      ( v33998(VarCurr)
    <=> v34000(VarCurr) ) ).

tff(addAssignment_16881,axiom,
    ! [VarCurr: state_type] :
      ( v34000(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16880,axiom,
    ! [VarCurr: state_type] :
      ( v32562(VarCurr,1)
    <=> v32564(VarCurr,1) ) ).

tff(addAssignment_16879,axiom,
    ! [VarCurr: state_type] :
      ( v32564(VarCurr,1)
    <=> v33989(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33989(VarCurr,B)
      <=> ( v33990(VarCurr,B)
          | v33993(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_545,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33993(VarCurr,B)
      <=> ( v32550(VarCurr,B)
          & v33994(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_2015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33994(VarCurr,B)
      <=> ~ v33995(VarCurr,B) ) ) ).

tff(addAssignment_16878,axiom,
    ! [VarCurr: state_type] :
      ( v33995(VarCurr,0)
    <=> v33996(VarCurr) ) ).

tff(addAssignment_16877,axiom,
    ! [VarCurr: state_type] :
      ( v33995(VarCurr,1)
    <=> v33996(VarCurr) ) ).

tff(addAssignment_16876,axiom,
    ! [VarCurr: state_type] :
      ( v33996(VarCurr)
    <=> v33978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_544,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33990(VarCurr,B)
      <=> ( v32566(VarCurr,B)
          & v33991(VarCurr,B) ) ) ) ).

tff(addAssignment_16875,axiom,
    ! [VarCurr: state_type] :
      ( v33991(VarCurr,0)
    <=> v33992(VarCurr) ) ).

tff(addAssignment_16874,axiom,
    ! [VarCurr: state_type] :
      ( v33991(VarCurr,1)
    <=> v33992(VarCurr) ) ).

tff(addAssignment_16873,axiom,
    ! [VarCurr: state_type] :
      ( v33992(VarCurr)
    <=> v33978(VarCurr) ) ).

tff(addAssignment_16872,axiom,
    ! [VarCurr: state_type] :
      ( v33978(VarCurr)
    <=> v33980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3271,axiom,
    ! [VarCurr: state_type] :
      ( v33980(VarCurr)
    <=> ( v33982(VarCurr)
        | v33987(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3270,axiom,
    ! [VarCurr: state_type] :
      ( v33987(VarCurr)
    <=> ( v2354(VarCurr)
        & v33988(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_197,axiom,
    ! [VarCurr: state_type] :
      ( v33988(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3269,axiom,
    ! [VarCurr: state_type] :
      ( v33982(VarCurr)
    <=> ( v33983(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3268,axiom,
    ! [VarCurr: state_type] :
      ( v33983(VarCurr)
    <=> ( v33984(VarCurr)
        | v33958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3267,axiom,
    ! [VarCurr: state_type] :
      ( v33984(VarCurr)
    <=> ( v33985(VarCurr)
        | v32570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3266,axiom,
    ! [VarCurr: state_type] :
      ( v33985(VarCurr)
    <=> ( v33986(VarCurr)
        | v33963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3265,axiom,
    ! [VarCurr: state_type] :
      ( v33986(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(addAssignment_16871,axiom,
    ! [VarCurr: state_type] :
      ( v32566(VarCurr,1)
    <=> v32568(VarCurr,1) ) ).

tff(addAssignment_16870,axiom,
    ! [VarCurr: state_type] :
      ( v32568(VarCurr,1)
    <=> v33970(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33971(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33970(VarCurr,B)
          <=> v33972(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_286,axiom,
    ! [VarCurr: state_type] :
      ( v33971(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33970(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32570(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33972(VarCurr,B)
          <=> v33973(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_285,axiom,
    ! [VarCurr: state_type] :
      ( v32570(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33972(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33973(VarCurr,B)
          <=> v33975(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_284,axiom,
    ! [VarCurr: state_type] :
      ( v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33973(VarCurr,B)
          <=> v33974(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33976(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33975(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_283,axiom,
    ! [VarCurr: state_type] :
      ( v33976(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33975(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3264,axiom,
    ! [VarCurr: state_type] :
      ( v33976(VarCurr)
    <=> ( v33958(VarCurr)
        | v33963(VarCurr) ) ) ).

tff(addAssignment_16869,axiom,
    ! [VarCurr: state_type] :
      ( v33974(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_16868,axiom,
    ! [VarCurr: state_type] :
      ( v33974(VarCurr,1)
    <=> v32548(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3263,axiom,
    ! [VarCurr: state_type] :
      ( v33971(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3262,axiom,
    ! [VarCurr: state_type] :
      ( v33963(VarCurr)
    <=> ( v33965(VarCurr)
        & v33969(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_196,axiom,
    ! [VarCurr: state_type] :
      ( v33969(VarCurr)
    <=> ( ( v32754(VarCurr,3)
        <=> $false )
        & ( v32754(VarCurr,2)
        <=> $true )
        & ( v32754(VarCurr,1)
        <=> $false )
        & ( v32754(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3261,axiom,
    ! [VarCurr: state_type] :
      ( v33965(VarCurr)
    <=> ( v32572(VarCurr)
        & v33966(VarCurr) ) ) ).

tff(writeUnaryOperator_2014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33966(VarCurr)
    <=> v33967(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_429,axiom,
    ! [VarCurr: state_type] :
      ( v33967(VarCurr)
    <=> ( v32548(VarCurr,0)
        | v32548(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3260,axiom,
    ! [VarCurr: state_type] :
      ( v33958(VarCurr)
    <=> ( v33960(VarCurr)
        & v33961(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_195,axiom,
    ! [VarCurr: state_type] :
      ( v33961(VarCurr)
    <=> ( ( v32851(VarCurr,9)
        <=> $false )
        & ( v32851(VarCurr,8)
        <=> $false )
        & ( v32851(VarCurr,7)
        <=> $false )
        & ( v32851(VarCurr,6)
        <=> $false )
        & ( v32851(VarCurr,5)
        <=> $false )
        & ( v32851(VarCurr,4)
        <=> $false )
        & ( v32851(VarCurr,3)
        <=> $false )
        & ( v32851(VarCurr,2)
        <=> $false )
        & ( v32851(VarCurr,1)
        <=> $false )
        & ( v32851(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3259,axiom,
    ! [VarCurr: state_type] :
      ( v33960(VarCurr)
    <=> ( v32583(VarCurr)
        & v32572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3258,axiom,
    ! [VarCurr: state_type] :
      ( v32575(VarCurr)
    <=> ( v32577(VarCurr)
        & v33956(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_194,axiom,
    ! [VarCurr: state_type] :
      ( v33956(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $false )
        & ( v4221(VarCurr,1)
        <=> $false )
        & ( v4221(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3257,axiom,
    ! [VarCurr: state_type] :
      ( v32577(VarCurr)
    <=> ( v33919(VarCurr)
        | v33912(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3256,axiom,
    ! [VarCurr: state_type] :
      ( v33919(VarCurr)
    <=> ( v33920(VarCurr)
        | v33810(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3255,axiom,
    ! [VarCurr: state_type] :
      ( v33920(VarCurr)
    <=> ( v33921(VarCurr)
        | v33802(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3254,axiom,
    ! [VarCurr: state_type] :
      ( v33921(VarCurr)
    <=> ( v33922(VarCurr)
        | v33778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3253,axiom,
    ! [VarCurr: state_type] :
      ( v33922(VarCurr)
    <=> ( v33923(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3252,axiom,
    ! [VarCurr: state_type] :
      ( v33923(VarCurr)
    <=> ( v33924(VarCurr)
        | v4280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3251,axiom,
    ! [VarCurr: state_type] :
      ( v33924(VarCurr)
    <=> ( v33925(VarCurr)
        | v33953(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3250,axiom,
    ! [VarCurr: state_type] :
      ( v33953(VarCurr)
    <=> ( v33954(VarCurr)
        & v33714(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_193,axiom,
    ! [VarCurr: state_type] :
      ( v33954(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3249,axiom,
    ! [VarCurr: state_type] :
      ( v33925(VarCurr)
    <=> ( v33926(VarCurr)
        | v33949(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3248,axiom,
    ! [VarCurr: state_type] :
      ( v33949(VarCurr)
    <=> ( v33950(VarCurr)
        & v33952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3247,axiom,
    ! [VarCurr: state_type] :
      ( v33952(VarCurr)
    <=> ( v32548(VarCurr,0)
        | v32570(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3246,axiom,
    ! [VarCurr: state_type] :
      ( v33950(VarCurr)
    <=> ( v32579(VarCurr)
        & v33951(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_192,axiom,
    ! [VarCurr: state_type] :
      ( v33951(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3245,axiom,
    ! [VarCurr: state_type] :
      ( v33926(VarCurr)
    <=> ( v33927(VarCurr)
        | v33945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3244,axiom,
    ! [VarCurr: state_type] :
      ( v33945(VarCurr)
    <=> ( v33946(VarCurr)
        & v33948(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3243,axiom,
    ! [VarCurr: state_type] :
      ( v33948(VarCurr)
    <=> ( v33448(VarCurr,0)
        | v33470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3242,axiom,
    ! [VarCurr: state_type] :
      ( v33946(VarCurr)
    <=> ( v32579(VarCurr)
        & v33947(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_191,axiom,
    ! [VarCurr: state_type] :
      ( v33947(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3241,axiom,
    ! [VarCurr: state_type] :
      ( v33927(VarCurr)
    <=> ( v33928(VarCurr)
        | v33941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3240,axiom,
    ! [VarCurr: state_type] :
      ( v33941(VarCurr)
    <=> ( v33942(VarCurr)
        & v33944(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3239,axiom,
    ! [VarCurr: state_type] :
      ( v33944(VarCurr)
    <=> ( v33180(VarCurr,0)
        | v33202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3238,axiom,
    ! [VarCurr: state_type] :
      ( v33942(VarCurr)
    <=> ( v32579(VarCurr)
        & v33943(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_190,axiom,
    ! [VarCurr: state_type] :
      ( v33943(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3237,axiom,
    ! [VarCurr: state_type] :
      ( v33928(VarCurr)
    <=> ( v33929(VarCurr)
        | v33937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3236,axiom,
    ! [VarCurr: state_type] :
      ( v33937(VarCurr)
    <=> ( v33938(VarCurr)
        & v33940(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3235,axiom,
    ! [VarCurr: state_type] :
      ( v33940(VarCurr)
    <=> ( v32728(VarCurr,0)
        | v32750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3234,axiom,
    ! [VarCurr: state_type] :
      ( v33938(VarCurr)
    <=> ( v32579(VarCurr)
        & v33939(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_189,axiom,
    ! [VarCurr: state_type] :
      ( v33939(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3233,axiom,
    ! [VarCurr: state_type] :
      ( v33929(VarCurr)
    <=> ( v33930(VarCurr)
        | v33934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3232,axiom,
    ! [VarCurr: state_type] :
      ( v33934(VarCurr)
    <=> ( v33935(VarCurr)
        & v32633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3231,axiom,
    ! [VarCurr: state_type] :
      ( v33935(VarCurr)
    <=> ( v32579(VarCurr)
        & v33936(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_188,axiom,
    ! [VarCurr: state_type] :
      ( v33936(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3230,axiom,
    ! [VarCurr: state_type] :
      ( v33930(VarCurr)
    <=> ( v4223(VarCurr)
        | v33931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3229,axiom,
    ! [VarCurr: state_type] :
      ( v33931(VarCurr)
    <=> ( v33932(VarCurr)
        & v4228(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3228,axiom,
    ! [VarCurr: state_type] :
      ( v33932(VarCurr)
    <=> ( v32579(VarCurr)
        & v33933(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_187,axiom,
    ! [VarCurr: state_type] :
      ( v33933(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16867,axiom,
    ! [VarCurr: state_type] :
      ( v33912(VarCurr)
    <=> v33914(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3227,axiom,
    ! [VarCurr: state_type] :
      ( v33914(VarCurr)
    <=> ( v33916(VarCurr)
        & v33917(VarCurr) ) ) ).

tff(writeUnaryOperator_2013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33917(VarCurr)
    <=> v4408(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3226,axiom,
    ! [VarCurr: state_type] :
      ( v33916(VarCurr)
    <=> ( v4386(VarCurr)
        & v4412(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3225,axiom,
    ! [VarCurr: state_type] :
      ( v33778(VarCurr)
    <=> ( v33910(VarCurr)
        & v33780(VarCurr) ) ) ).

tff(writeUnaryOperator_2012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33910(VarCurr)
    <=> v8312(VarCurr) ) ).

tff(addAssignment_16866,axiom,
    ! [VarCurr: state_type] :
      ( v33780(VarCurr)
    <=> v33782(VarCurr) ) ).

tff(addAssignment_16865,axiom,
    ! [VarCurr: state_type] :
      ( v33782(VarCurr)
    <=> v33784(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33893(VarNext)
       => ( v33784(VarNext)
        <=> v33784(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_399,axiom,
    ! [VarNext: state_type] :
      ( v33893(VarNext)
     => ( v33784(VarNext)
      <=> v33903(VarNext) ) ) ).

tff(addAssignment_16864,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33903(VarNext)
      <=> v33901(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33904(VarCurr)
     => ( v33901(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_282,axiom,
    ! [VarCurr: state_type] :
      ( v33904(VarCurr)
     => ( v33901(VarCurr)
      <=> v33794(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3224,axiom,
    ! [VarCurr: state_type] :
      ( v33904(VarCurr)
    <=> ( v33905(VarCurr)
        & v33906(VarCurr) ) ) ).

tff(writeUnaryOperator_2011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33906(VarCurr)
    <=> v33790(VarCurr) ) ).

tff(writeUnaryOperator_2010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33905(VarCurr)
    <=> v33786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33893(VarNext)
      <=> v33894(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33894(VarNext)
      <=> ( v33895(VarNext)
          & v33888(VarNext) ) ) ) ).

tff(writeUnaryOperator_2009,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33895(VarNext)
      <=> v33897(VarNext) ) ) ).

tff(addAssignment_16863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33897(VarNext)
      <=> v33888(VarCurr) ) ) ).

tff(addAssignment_16862,axiom,
    ! [VarCurr: state_type] :
      ( v33888(VarCurr)
    <=> v33890(VarCurr) ) ).

tff(addAssignment_16861,axiom,
    ! [VarCurr: state_type] :
      ( v33890(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16860,axiom,
    ! [VarCurr: state_type] :
      ( v33794(VarCurr)
    <=> v33796(VarCurr) ) ).

tff(addAssignment_16859,axiom,
    ! [VarCurr: state_type] :
      ( v33796(VarCurr)
    <=> v33798(VarCurr) ) ).

tff(addAssignment_16858,axiom,
    ! [VarCurr: state_type] :
      ( v33798(VarCurr)
    <=> v33800(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33802(VarCurr)
     => ( v33800(VarCurr)
      <=> v33885(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_281,axiom,
    ! [VarCurr: state_type] :
      ( v33802(VarCurr)
     => ( v33800(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33886(VarCurr)
     => ( v33885(VarCurr)
      <=> v33780(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_280,axiom,
    ! [VarCurr: state_type] :
      ( v33886(VarCurr)
     => ( v33885(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3221,axiom,
    ! [VarCurr: state_type] :
      ( v33886(VarCurr)
    <=> ( v33810(VarCurr)
        | v33778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3220,axiom,
    ! [VarCurr: state_type] :
      ( v33810(VarCurr)
    <=> ( v33883(VarCurr)
        & v33780(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_186,axiom,
    ! [VarCurr: state_type] :
      ( v33883(VarCurr)
    <=> ( ( v33812(VarCurr,2)
        <=> $true )
        & ( v33812(VarCurr,1)
        <=> $false )
        & ( v33812(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33812(VarCurr,B)
      <=> v33814(VarCurr,B) ) ) ).

tff(addAssignment_16856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33814(VarCurr,B)
      <=> v33816(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33866(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v33816(VarNext,B)
            <=> v33816(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_398,axiom,
    ! [VarNext: state_type] :
      ( v33866(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33816(VarNext,B)
          <=> v33876(VarNext,B) ) ) ) ).

tff(addAssignment_16855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33876(VarNext,B)
          <=> v33874(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33874(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_279,axiom,
    ! [VarCurr: state_type] :
      ( v33877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33874(VarCurr,B)
          <=> v33826(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3219,axiom,
    ! [VarCurr: state_type] :
      ( v33877(VarCurr)
    <=> ( v33878(VarCurr)
        & v33879(VarCurr) ) ) ).

tff(writeUnaryOperator_2008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33879(VarCurr)
    <=> v33822(VarCurr) ) ).

tff(writeUnaryOperator_2007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33878(VarCurr)
    <=> v33818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33866(VarNext)
      <=> v33867(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33867(VarNext)
      <=> ( v33868(VarNext)
          & v33861(VarNext) ) ) ) ).

tff(writeUnaryOperator_2006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33868(VarNext)
      <=> v33870(VarNext) ) ) ).

tff(addAssignment_16854,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33870(VarNext)
      <=> v33861(VarCurr) ) ) ).

tff(addAssignment_16853,axiom,
    ! [VarCurr: state_type] :
      ( v33861(VarCurr)
    <=> v33863(VarCurr) ) ).

tff(addAssignment_16852,axiom,
    ! [VarCurr: state_type] :
      ( v33863(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33826(VarCurr,B)
      <=> v33828(VarCurr,B) ) ) ).

tff(addAssignment_16850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33828(VarCurr,B)
      <=> v33830(VarCurr,B) ) ) ).

tff(addAssignment_16849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33830(VarCurr,B)
      <=> v33832(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33843(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33832(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_278,axiom,
    ! [VarCurr: state_type] :
      ( v33843(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33832(VarCurr,B)
          <=> v33847(VarCurr,B) ) ) ) ).

tff(addAssignment_16848,axiom,
    ! [VarCurr: state_type] :
      ( v33847(VarCurr,0)
    <=> v33857(VarCurr) ) ).

tff(addAssignment_16847,axiom,
    ! [VarCurr: state_type] :
      ( v33847(VarCurr,1)
    <=> v33855(VarCurr) ) ).

tff(addAssignment_16846,axiom,
    ! [VarCurr: state_type] :
      ( v33847(VarCurr,2)
    <=> v33849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3216,axiom,
    ! [VarCurr: state_type] :
      ( v33855(VarCurr)
    <=> ( v33856(VarCurr)
        & v33859(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_428,axiom,
    ! [VarCurr: state_type] :
      ( v33859(VarCurr)
    <=> ( v33812(VarCurr,0)
        | v33812(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3215,axiom,
    ! [VarCurr: state_type] :
      ( v33856(VarCurr)
    <=> ( v33857(VarCurr)
        | v33858(VarCurr) ) ) ).

tff(writeUnaryOperator_2005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33858(VarCurr)
    <=> v33812(VarCurr,1) ) ).

tff(writeUnaryOperator_2004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33857(VarCurr)
    <=> v33812(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3214,axiom,
    ! [VarCurr: state_type] :
      ( v33849(VarCurr)
    <=> ( v33850(VarCurr)
        & v33854(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_427,axiom,
    ! [VarCurr: state_type] :
      ( v33854(VarCurr)
    <=> ( v33852(VarCurr)
        | v33812(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3213,axiom,
    ! [VarCurr: state_type] :
      ( v33850(VarCurr)
    <=> ( v33851(VarCurr)
        | v33853(VarCurr) ) ) ).

tff(writeUnaryOperator_2003,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33853(VarCurr)
    <=> v33812(VarCurr,2) ) ).

tff(writeUnaryOperator_2002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33851(VarCurr)
    <=> v33852(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_426,axiom,
    ! [VarCurr: state_type] :
      ( v33852(VarCurr)
    <=> ( v33812(VarCurr,0)
        & v33812(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3212,axiom,
    ! [VarCurr: state_type] :
      ( v33843(VarCurr)
    <=> ( v33844(VarCurr)
        & v33846(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_185,axiom,
    ! [VarCurr: state_type] :
      ( v33846(VarCurr)
    <=> ( ( v33837(VarCurr,35)
        <=> $false )
        & ( v33837(VarCurr,34)
        <=> $false )
        & ( v33837(VarCurr,33)
        <=> $false )
        & ( v33837(VarCurr,32)
        <=> $false )
        & ( v33837(VarCurr,31)
        <=> $false )
        & ( v33837(VarCurr,30)
        <=> $false )
        & ( v33837(VarCurr,29)
        <=> $false )
        & ( v33837(VarCurr,28)
        <=> $false )
        & ( v33837(VarCurr,27)
        <=> $false )
        & ( v33837(VarCurr,26)
        <=> $false )
        & ( v33837(VarCurr,25)
        <=> $false )
        & ( v33837(VarCurr,24)
        <=> $false )
        & ( v33837(VarCurr,23)
        <=> $false )
        & ( v33837(VarCurr,22)
        <=> $false )
        & ( v33837(VarCurr,21)
        <=> $false )
        & ( v33837(VarCurr,20)
        <=> $false )
        & ( v33837(VarCurr,19)
        <=> $false )
        & ( v33837(VarCurr,18)
        <=> $false )
        & ( v33837(VarCurr,17)
        <=> $false )
        & ( v33837(VarCurr,16)
        <=> $false )
        & ( v33837(VarCurr,15)
        <=> $false )
        & ( v33837(VarCurr,14)
        <=> $false )
        & ( v33837(VarCurr,13)
        <=> $false )
        & ( v33837(VarCurr,12)
        <=> $false )
        & ( v33837(VarCurr,11)
        <=> $false )
        & ( v33837(VarCurr,10)
        <=> $false )
        & ( v33837(VarCurr,9)
        <=> $false )
        & ( v33837(VarCurr,8)
        <=> $false )
        & ( v33837(VarCurr,7)
        <=> $false )
        & ( v33837(VarCurr,6)
        <=> $false )
        & ( v33837(VarCurr,5)
        <=> $false )
        & ( v33837(VarCurr,4)
        <=> $false )
        & ( v33837(VarCurr,3)
        <=> $false )
        & ( v33837(VarCurr,2)
        <=> $false )
        & ( v33837(VarCurr,1)
        <=> $false )
        & ( v33837(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3211,axiom,
    ! [VarCurr: state_type] :
      ( v33844(VarCurr)
    <=> ( v33780(VarCurr)
        & v33845(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_184,axiom,
    ! [VarCurr: state_type] :
      ( v33845(VarCurr)
    <=> ( ( v33834(VarCurr,35)
        <=> $false )
        & ( v33834(VarCurr,34)
        <=> $false )
        & ( v33834(VarCurr,33)
        <=> $false )
        & ( v33834(VarCurr,32)
        <=> $false )
        & ( v33834(VarCurr,31)
        <=> $false )
        & ( v33834(VarCurr,30)
        <=> $false )
        & ( v33834(VarCurr,29)
        <=> $false )
        & ( v33834(VarCurr,28)
        <=> $false )
        & ( v33834(VarCurr,27)
        <=> $false )
        & ( v33834(VarCurr,26)
        <=> $false )
        & ( v33834(VarCurr,25)
        <=> $false )
        & ( v33834(VarCurr,24)
        <=> $false )
        & ( v33834(VarCurr,23)
        <=> $false )
        & ( v33834(VarCurr,22)
        <=> $false )
        & ( v33834(VarCurr,21)
        <=> $false )
        & ( v33834(VarCurr,20)
        <=> $false )
        & ( v33834(VarCurr,19)
        <=> $false )
        & ( v33834(VarCurr,18)
        <=> $false )
        & ( v33834(VarCurr,17)
        <=> $false )
        & ( v33834(VarCurr,16)
        <=> $false )
        & ( v33834(VarCurr,15)
        <=> $false )
        & ( v33834(VarCurr,14)
        <=> $false )
        & ( v33834(VarCurr,13)
        <=> $false )
        & ( v33834(VarCurr,12)
        <=> $false )
        & ( v33834(VarCurr,11)
        <=> $false )
        & ( v33834(VarCurr,10)
        <=> $false )
        & ( v33834(VarCurr,9)
        <=> $false )
        & ( v33834(VarCurr,8)
        <=> $false )
        & ( v33834(VarCurr,7)
        <=> $false )
        & ( v33834(VarCurr,6)
        <=> $false )
        & ( v33834(VarCurr,5)
        <=> $false )
        & ( v33834(VarCurr,4)
        <=> $false )
        & ( v33834(VarCurr,3)
        <=> $false )
        & ( v33834(VarCurr,2)
        <=> $false )
        & ( v33834(VarCurr,1)
        <=> $false )
        & ( v33834(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_911,axiom,
    ~ b000000000000000000000000000000000000(35) ).

tff(bitBlastConstant_910,axiom,
    ~ b000000000000000000000000000000000000(34) ).

tff(bitBlastConstant_909,axiom,
    ~ b000000000000000000000000000000000000(33) ).

tff(bitBlastConstant_908,axiom,
    ~ b000000000000000000000000000000000000(32) ).

tff(bitBlastConstant_907,axiom,
    ~ b000000000000000000000000000000000000(31) ).

tff(bitBlastConstant_906,axiom,
    ~ b000000000000000000000000000000000000(30) ).

tff(bitBlastConstant_905,axiom,
    ~ b000000000000000000000000000000000000(29) ).

tff(bitBlastConstant_904,axiom,
    ~ b000000000000000000000000000000000000(28) ).

tff(bitBlastConstant_903,axiom,
    ~ b000000000000000000000000000000000000(27) ).

tff(bitBlastConstant_902,axiom,
    ~ b000000000000000000000000000000000000(26) ).

tff(bitBlastConstant_901,axiom,
    ~ b000000000000000000000000000000000000(25) ).

tff(bitBlastConstant_900,axiom,
    ~ b000000000000000000000000000000000000(24) ).

tff(bitBlastConstant_899,axiom,
    ~ b000000000000000000000000000000000000(23) ).

tff(bitBlastConstant_898,axiom,
    ~ b000000000000000000000000000000000000(22) ).

tff(bitBlastConstant_897,axiom,
    ~ b000000000000000000000000000000000000(21) ).

tff(bitBlastConstant_896,axiom,
    ~ b000000000000000000000000000000000000(20) ).

tff(bitBlastConstant_895,axiom,
    ~ b000000000000000000000000000000000000(19) ).

tff(bitBlastConstant_894,axiom,
    ~ b000000000000000000000000000000000000(18) ).

tff(bitBlastConstant_893,axiom,
    ~ b000000000000000000000000000000000000(17) ).

tff(bitBlastConstant_892,axiom,
    ~ b000000000000000000000000000000000000(16) ).

tff(bitBlastConstant_891,axiom,
    ~ b000000000000000000000000000000000000(15) ).

tff(bitBlastConstant_890,axiom,
    ~ b000000000000000000000000000000000000(14) ).

tff(bitBlastConstant_889,axiom,
    ~ b000000000000000000000000000000000000(13) ).

tff(bitBlastConstant_888,axiom,
    ~ b000000000000000000000000000000000000(12) ).

tff(bitBlastConstant_887,axiom,
    ~ b000000000000000000000000000000000000(11) ).

tff(bitBlastConstant_886,axiom,
    ~ b000000000000000000000000000000000000(10) ).

tff(bitBlastConstant_885,axiom,
    ~ b000000000000000000000000000000000000(9) ).

tff(bitBlastConstant_884,axiom,
    ~ b000000000000000000000000000000000000(8) ).

tff(bitBlastConstant_883,axiom,
    ~ b000000000000000000000000000000000000(7) ).

tff(bitBlastConstant_882,axiom,
    ~ b000000000000000000000000000000000000(6) ).

tff(bitBlastConstant_881,axiom,
    ~ b000000000000000000000000000000000000(5) ).

tff(bitBlastConstant_880,axiom,
    ~ b000000000000000000000000000000000000(4) ).

tff(bitBlastConstant_879,axiom,
    ~ b000000000000000000000000000000000000(3) ).

tff(bitBlastConstant_878,axiom,
    ~ b000000000000000000000000000000000000(2) ).

tff(bitBlastConstant_877,axiom,
    ~ b000000000000000000000000000000000000(1) ).

tff(bitBlastConstant_876,axiom,
    ~ b000000000000000000000000000000000000(0) ).

tff(addAssignment_16845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v33837(VarCurr,B)
      <=> v33839(VarCurr,B) ) ) ).

tff(addAssignment_16844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v33839(VarCurr,B)
      <=> v33841(VarCurr,B) ) ) ).

tff(addAssignment_16843,axiom,
    ! [VarCurr: state_type] :
      ( ( v33841(VarCurr,35)
      <=> v12605(VarCurr,11) )
      & ( v33841(VarCurr,34)
      <=> v12605(VarCurr,10) )
      & ( v33841(VarCurr,33)
      <=> v12605(VarCurr,9) )
      & ( v33841(VarCurr,32)
      <=> v12605(VarCurr,8) )
      & ( v33841(VarCurr,31)
      <=> v12605(VarCurr,7) )
      & ( v33841(VarCurr,30)
      <=> v12605(VarCurr,6) )
      & ( v33841(VarCurr,29)
      <=> v12605(VarCurr,5) )
      & ( v33841(VarCurr,28)
      <=> v12605(VarCurr,4) )
      & ( v33841(VarCurr,27)
      <=> v12605(VarCurr,3) )
      & ( v33841(VarCurr,26)
      <=> v12605(VarCurr,2) )
      & ( v33841(VarCurr,25)
      <=> v12605(VarCurr,1) )
      & ( v33841(VarCurr,24)
      <=> v12605(VarCurr,0) ) ) ).

tff(addAssignment_16842,axiom,
    ! [VarCurr: state_type] :
      ( ( v33841(VarCurr,23)
      <=> v11055(VarCurr,11) )
      & ( v33841(VarCurr,22)
      <=> v11055(VarCurr,10) )
      & ( v33841(VarCurr,21)
      <=> v11055(VarCurr,9) )
      & ( v33841(VarCurr,20)
      <=> v11055(VarCurr,8) )
      & ( v33841(VarCurr,19)
      <=> v11055(VarCurr,7) )
      & ( v33841(VarCurr,18)
      <=> v11055(VarCurr,6) )
      & ( v33841(VarCurr,17)
      <=> v11055(VarCurr,5) )
      & ( v33841(VarCurr,16)
      <=> v11055(VarCurr,4) )
      & ( v33841(VarCurr,15)
      <=> v11055(VarCurr,3) )
      & ( v33841(VarCurr,14)
      <=> v11055(VarCurr,2) )
      & ( v33841(VarCurr,13)
      <=> v11055(VarCurr,1) )
      & ( v33841(VarCurr,12)
      <=> v11055(VarCurr,0) ) ) ).

tff(addAssignment_16841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v33841(VarCurr,B)
      <=> v9099(VarCurr,B) ) ) ).

tff(addAssignment_16840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v33834(VarCurr,B)
      <=> v6238(VarCurr,B) ) ) ).

tff(addAssignment_16839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,0) )
     => ( v6238(VarCurr,B)
      <=> v6240(VarCurr,B) ) ) ).

tff(addAssignment_16838,axiom,
    ! [VarCurr: state_type] :
      ( ( v6240(VarCurr,35)
      <=> v8510(VarCurr,11) )
      & ( v6240(VarCurr,34)
      <=> v8510(VarCurr,10) )
      & ( v6240(VarCurr,33)
      <=> v8510(VarCurr,9) )
      & ( v6240(VarCurr,32)
      <=> v8510(VarCurr,8) )
      & ( v6240(VarCurr,31)
      <=> v8510(VarCurr,7) )
      & ( v6240(VarCurr,30)
      <=> v8510(VarCurr,6) )
      & ( v6240(VarCurr,29)
      <=> v8510(VarCurr,5) )
      & ( v6240(VarCurr,28)
      <=> v8510(VarCurr,4) )
      & ( v6240(VarCurr,27)
      <=> v8510(VarCurr,3) )
      & ( v6240(VarCurr,26)
      <=> v8510(VarCurr,2) )
      & ( v6240(VarCurr,25)
      <=> v8510(VarCurr,1) )
      & ( v6240(VarCurr,24)
      <=> v8510(VarCurr,0) ) ) ).

tff(addAssignment_16837,axiom,
    ! [VarCurr: state_type] :
      ( ( v6240(VarCurr,23)
      <=> v6242(VarCurr,11) )
      & ( v6240(VarCurr,22)
      <=> v6242(VarCurr,10) )
      & ( v6240(VarCurr,21)
      <=> v6242(VarCurr,9) )
      & ( v6240(VarCurr,20)
      <=> v6242(VarCurr,8) ) ) ).

tff(addAssignment_16836,axiom,
    ! [VarCurr: state_type] :
      ( ( v6240(VarCurr,18)
      <=> v6242(VarCurr,6) )
      & ( v6240(VarCurr,17)
      <=> v6242(VarCurr,5) )
      & ( v6240(VarCurr,16)
      <=> v6242(VarCurr,4) )
      & ( v6240(VarCurr,15)
      <=> v6242(VarCurr,3) )
      & ( v6240(VarCurr,14)
      <=> v6242(VarCurr,2) )
      & ( v6240(VarCurr,13)
      <=> v6242(VarCurr,1) )
      & ( v6240(VarCurr,12)
      <=> v6242(VarCurr,0) ) ) ).

tff(addAssignment_16835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6240(VarCurr,B)
      <=> v4121(VarCurr,B) ) ) ).

tff(addAssignment_16834,axiom,
    ! [VarCurr: state_type] :
      ( v33822(VarCurr)
    <=> v33824(VarCurr) ) ).

tff(addAssignment_16833,axiom,
    ! [VarCurr: state_type] :
      ( v33824(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16832,axiom,
    ! [VarCurr: state_type] :
      ( v33818(VarCurr)
    <=> v33820(VarCurr) ) ).

tff(addAssignment_16831,axiom,
    ! [VarCurr: state_type] :
      ( v33820(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3210,axiom,
    ! [VarCurr: state_type] :
      ( v33802(VarCurr)
    <=> ( v33804(VarCurr)
        & v4250(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3209,axiom,
    ! [VarCurr: state_type] :
      ( v33804(VarCurr)
    <=> ( v33805(VarCurr)
        & v33808(VarCurr) ) ) ).

tff(writeUnaryOperator_2001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33808(VarCurr)
    <=> v33780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3208,axiom,
    ! [VarCurr: state_type] :
      ( v33805(VarCurr)
    <=> ( v33806(VarCurr)
        & v33807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3207,axiom,
    ! [VarCurr: state_type] :
      ( v33807(VarCurr)
    <=> ( v9073(VarCurr)
        | v10059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3206,axiom,
    ! [VarCurr: state_type] :
      ( v33806(VarCurr)
    <=> ( v8312(VarCurr)
        & v8288(VarCurr) ) ) ).

tff(addAssignment_16830,axiom,
    ! [VarCurr: state_type] :
      ( v33790(VarCurr)
    <=> v33792(VarCurr) ) ).

tff(addAssignment_16829,axiom,
    ! [VarCurr: state_type] :
      ( v33792(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16828,axiom,
    ! [VarCurr: state_type] :
      ( v33786(VarCurr)
    <=> v33788(VarCurr) ) ).

tff(addAssignment_16827,axiom,
    ! [VarCurr: state_type] :
      ( v33788(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_183,axiom,
    ! [VarCurr: state_type] :
      ( v33714(VarCurr)
    <=> ( ( v33716(VarCurr,2)
        <=> $true )
        & ( v33716(VarCurr,1)
        <=> $false )
        & ( v33716(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33716(VarCurr,B)
      <=> v33718(VarCurr,B) ) ) ).

tff(addAssignment_16825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33718(VarCurr,B)
      <=> v33720(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_397,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33760(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v33720(VarNext,B)
            <=> v33720(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_397,axiom,
    ! [VarNext: state_type] :
      ( v33760(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33720(VarNext,B)
          <=> v33770(VarNext,B) ) ) ) ).

tff(addAssignment_16824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33770(VarNext,B)
          <=> v33768(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33771(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33768(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_277,axiom,
    ! [VarCurr: state_type] :
      ( v33771(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33768(VarCurr,B)
          <=> v33730(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3205,axiom,
    ! [VarCurr: state_type] :
      ( v33771(VarCurr)
    <=> ( v33772(VarCurr)
        & v33773(VarCurr) ) ) ).

tff(writeUnaryOperator_2000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33773(VarCurr)
    <=> v33726(VarCurr) ) ).

tff(writeUnaryOperator_1999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33772(VarCurr)
    <=> v33722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33760(VarNext)
      <=> v33761(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33761(VarNext)
      <=> ( v33762(VarNext)
          & v33755(VarNext) ) ) ) ).

tff(writeUnaryOperator_1998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33762(VarNext)
      <=> v33764(VarNext) ) ) ).

tff(addAssignment_16823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33764(VarNext)
      <=> v33755(VarCurr) ) ) ).

tff(addAssignment_16822,axiom,
    ! [VarCurr: state_type] :
      ( v33755(VarCurr)
    <=> v33757(VarCurr) ) ).

tff(addAssignment_16821,axiom,
    ! [VarCurr: state_type] :
      ( v33757(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33730(VarCurr,B)
      <=> v33732(VarCurr,B) ) ) ).

tff(addAssignment_16819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33732(VarCurr,B)
      <=> v33734(VarCurr,B) ) ) ).

tff(addAssignment_16818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v33734(VarCurr,B)
      <=> v33736(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33738(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33736(VarCurr,B)
          <=> v33716(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_276,axiom,
    ! [VarCurr: state_type] :
      ( v33738(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v33736(VarCurr,B)
          <=> v33742(VarCurr,B) ) ) ) ).

tff(addAssignment_16817,axiom,
    ! [VarCurr: state_type] :
      ( v33742(VarCurr,0)
    <=> v33752(VarCurr) ) ).

tff(addAssignment_16816,axiom,
    ! [VarCurr: state_type] :
      ( v33742(VarCurr,1)
    <=> v33750(VarCurr) ) ).

tff(addAssignment_16815,axiom,
    ! [VarCurr: state_type] :
      ( v33742(VarCurr,2)
    <=> v33744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3202,axiom,
    ! [VarCurr: state_type] :
      ( v33750(VarCurr)
    <=> ( v33741(VarCurr)
        & v33751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3201,axiom,
    ! [VarCurr: state_type] :
      ( v33751(VarCurr)
    <=> ( v33752(VarCurr)
        | v33753(VarCurr) ) ) ).

tff(writeUnaryOperator_1997,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33753(VarCurr)
    <=> v33716(VarCurr,1) ) ).

tff(writeUnaryOperator_1996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33752(VarCurr)
    <=> v33716(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3200,axiom,
    ! [VarCurr: state_type] :
      ( v33744(VarCurr)
    <=> ( v33745(VarCurr)
        & v33749(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_425,axiom,
    ! [VarCurr: state_type] :
      ( v33749(VarCurr)
    <=> ( v33716(VarCurr,2)
        | v33748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3199,axiom,
    ! [VarCurr: state_type] :
      ( v33745(VarCurr)
    <=> ( v33746(VarCurr)
        | v33747(VarCurr) ) ) ).

tff(writeUnaryOperator_1995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33747(VarCurr)
    <=> v33748(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_424,axiom,
    ! [VarCurr: state_type] :
      ( v33748(VarCurr)
    <=> ( v33716(VarCurr,0)
        & v33716(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33746(VarCurr)
    <=> v33716(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3198,axiom,
    ! [VarCurr: state_type] :
      ( v33738(VarCurr)
    <=> ( v4516(VarCurr)
        | v33739(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_423,axiom,
    ! [VarCurr: state_type] :
      ( v33739(VarCurr)
    <=> ( v33741(VarCurr)
        | v33716(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_422,axiom,
    ! [VarCurr: state_type] :
      ( v33741(VarCurr)
    <=> ( v33716(VarCurr,0)
        | v33716(VarCurr,1) ) ) ).

tff(addAssignment_16814,axiom,
    ! [VarCurr: state_type] :
      ( v33726(VarCurr)
    <=> v33728(VarCurr) ) ).

tff(addAssignment_16813,axiom,
    ! [VarCurr: state_type] :
      ( v33728(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16812,axiom,
    ! [VarCurr: state_type] :
      ( v33722(VarCurr)
    <=> v33724(VarCurr) ) ).

tff(addAssignment_16811,axiom,
    ! [VarCurr: state_type] :
      ( v33724(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16810,axiom,
    ! [VarCurr: state_type] :
      ( v33450(VarCurr,0)
    <=> v33452(VarCurr,0) ) ).

tff(addAssignment_16809,axiom,
    ! [VarNext: state_type] :
      ( v33452(VarNext,0)
    <=> v33706(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33707(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33706(VarNext,B)
            <=> v33452(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_396,axiom,
    ! [VarNext: state_type] :
      ( v33707(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33706(VarNext,B)
          <=> v33530(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33707(VarNext)
      <=> v33708(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33708(VarNext)
      <=> ( v33710(VarNext)
          & v33515(VarNext) ) ) ) ).

tff(writeUnaryOperator_1993,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33710(VarNext)
      <=> v33524(VarNext) ) ) ).

tff(addAssignment_16808,axiom,
    ! [VarCurr: state_type] :
      ( v33462(VarCurr,0)
    <=> v33464(VarCurr,0) ) ).

tff(addAssignment_16807,axiom,
    ! [VarCurr: state_type] :
      ( v33464(VarCurr,0)
    <=> v33506(VarCurr,0) ) ).

tff(addAssignment_16806,axiom,
    ! [VarCurr: state_type] :
      ( v33466(VarCurr,0)
    <=> v33468(VarCurr,0) ) ).

tff(addAssignment_16805,axiom,
    ! [VarCurr: state_type] :
      ( v33468(VarCurr,0)
    <=> v33487(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3195,axiom,
    ! [VarCurr: state_type] :
      ( v33470(VarCurr)
    <=> ( v33701(VarCurr)
        & v33704(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_182,axiom,
    ! [VarCurr: state_type] :
      ( v33704(VarCurr)
    <=> ( ( v33537(VarCurr,7)
        <=> $false )
        & ( v33537(VarCurr,6)
        <=> $false )
        & ( v33537(VarCurr,5)
        <=> $false )
        & ( v33537(VarCurr,4)
        <=> $false )
        & ( v33537(VarCurr,3)
        <=> $false )
        & ( v33537(VarCurr,2)
        <=> $false )
        & ( v33537(VarCurr,1)
        <=> $false )
        & ( v33537(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3194,axiom,
    ! [VarCurr: state_type] :
      ( v33701(VarCurr)
    <=> ( v33472(VarCurr)
        & v33702(VarCurr) ) ) ).

tff(writeUnaryOperator_1992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33702(VarCurr)
    <=> v33703(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_421,axiom,
    ! [VarCurr: state_type] :
      ( v33703(VarCurr)
    <=> ( v33448(VarCurr,0)
        | v33448(VarCurr,1) ) ) ).

tff(addAssignment_16804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33537(VarCurr,B)
      <=> v33539(VarCurr,B) ) ) ).

tff(addAssignment_16803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33539(VarCurr,B)
      <=> v33541(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33684(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v33541(VarNext,B)
            <=> v33541(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_395,axiom,
    ! [VarNext: state_type] :
      ( v33684(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33541(VarNext,B)
          <=> v33694(VarNext,B) ) ) ) ).

tff(addAssignment_16802,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33694(VarNext,B)
          <=> v33692(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33692(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_275,axiom,
    ! [VarCurr: state_type] :
      ( v33695(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33692(VarCurr,B)
          <=> v33551(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3193,axiom,
    ! [VarCurr: state_type] :
      ( v33695(VarCurr)
    <=> ( v33696(VarCurr)
        & v33697(VarCurr) ) ) ).

tff(writeUnaryOperator_1991,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33697(VarCurr)
    <=> v33547(VarCurr) ) ).

tff(writeUnaryOperator_1990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33696(VarCurr)
    <=> v33543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33684(VarNext)
      <=> v33685(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33685(VarNext)
      <=> ( v33686(VarNext)
          & v33679(VarNext) ) ) ) ).

tff(writeUnaryOperator_1989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33686(VarNext)
      <=> v33688(VarNext) ) ) ).

tff(addAssignment_16801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33688(VarNext)
      <=> v33679(VarCurr) ) ) ).

tff(addAssignment_16800,axiom,
    ! [VarCurr: state_type] :
      ( v33679(VarCurr)
    <=> v33681(VarCurr) ) ).

tff(addAssignment_16799,axiom,
    ! [VarCurr: state_type] :
      ( v33681(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33551(VarCurr,B)
      <=> v33553(VarCurr,B) ) ) ).

tff(addAssignment_16797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33553(VarCurr,B)
      <=> v33555(VarCurr,B) ) ) ).

tff(addAssignment_16796,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33555(VarCurr,B)
      <=> v33557(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_543,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33557(VarCurr,B)
      <=> ( v33624(VarCurr,B)
          | v33676(VarCurr,B) ) ) ) ).

tff(addAssignment_16795,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v33676(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_16794,axiom,
    ! [VarCurr: state_type] :
      ( v33676(VarCurr,7)
    <=> v33677(VarCurr) ) ).

tff(writeUnaryOperator_1988,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33677(VarCurr)
    <=> v32524(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33472(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33624(VarCurr,B)
          <=> v33559(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_274,axiom,
    ! [VarCurr: state_type] :
      ( v33472(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33624(VarCurr,B)
          <=> v33625(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33626(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33625(VarCurr,B)
          <=> v33627(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_273,axiom,
    ! [VarCurr: state_type] :
      ( v33626(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33625(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_16793,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,0)
    <=> v33674(VarCurr) ) ).

tff(addAssignment_16792,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,1)
    <=> v33672(VarCurr) ) ).

tff(addAssignment_16791,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,2)
    <=> v33668(VarCurr) ) ).

tff(addAssignment_16790,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,3)
    <=> v33664(VarCurr) ) ).

tff(addAssignment_16789,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,4)
    <=> v33660(VarCurr) ) ).

tff(addAssignment_16788,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,5)
    <=> v33656(VarCurr) ) ).

tff(addAssignment_16787,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,6)
    <=> v33652(VarCurr) ) ).

tff(addAssignment_16786,axiom,
    ! [VarCurr: state_type] :
      ( v33627(VarCurr,7)
    <=> v33629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3190,axiom,
    ! [VarCurr: state_type] :
      ( v33672(VarCurr)
    <=> ( v33673(VarCurr)
        & v33675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3189,axiom,
    ! [VarCurr: state_type] :
      ( v33675(VarCurr)
    <=> ( v33537(VarCurr,0)
        | v33644(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_420,axiom,
    ! [VarCurr: state_type] :
      ( v33673(VarCurr)
    <=> ( v33674(VarCurr)
        | v33537(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33674(VarCurr)
    <=> v33537(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3188,axiom,
    ! [VarCurr: state_type] :
      ( v33668(VarCurr)
    <=> ( v33669(VarCurr)
        & v33671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3187,axiom,
    ! [VarCurr: state_type] :
      ( v33671(VarCurr)
    <=> ( v33642(VarCurr)
        | v33645(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_419,axiom,
    ! [VarCurr: state_type] :
      ( v33669(VarCurr)
    <=> ( v33670(VarCurr)
        | v33537(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33670(VarCurr)
    <=> v33642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3186,axiom,
    ! [VarCurr: state_type] :
      ( v33664(VarCurr)
    <=> ( v33665(VarCurr)
        & v33667(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3185,axiom,
    ! [VarCurr: state_type] :
      ( v33667(VarCurr)
    <=> ( v33640(VarCurr)
        | v33646(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_418,axiom,
    ! [VarCurr: state_type] :
      ( v33665(VarCurr)
    <=> ( v33666(VarCurr)
        | v33537(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33666(VarCurr)
    <=> v33640(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3184,axiom,
    ! [VarCurr: state_type] :
      ( v33660(VarCurr)
    <=> ( v33661(VarCurr)
        & v33663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3183,axiom,
    ! [VarCurr: state_type] :
      ( v33663(VarCurr)
    <=> ( v33638(VarCurr)
        | v33647(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_417,axiom,
    ! [VarCurr: state_type] :
      ( v33661(VarCurr)
    <=> ( v33662(VarCurr)
        | v33537(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33662(VarCurr)
    <=> v33638(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3182,axiom,
    ! [VarCurr: state_type] :
      ( v33656(VarCurr)
    <=> ( v33657(VarCurr)
        & v33659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3181,axiom,
    ! [VarCurr: state_type] :
      ( v33659(VarCurr)
    <=> ( v33636(VarCurr)
        | v33648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_416,axiom,
    ! [VarCurr: state_type] :
      ( v33657(VarCurr)
    <=> ( v33658(VarCurr)
        | v33537(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33658(VarCurr)
    <=> v33636(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3180,axiom,
    ! [VarCurr: state_type] :
      ( v33652(VarCurr)
    <=> ( v33653(VarCurr)
        & v33655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3179,axiom,
    ! [VarCurr: state_type] :
      ( v33655(VarCurr)
    <=> ( v33634(VarCurr)
        | v33649(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_415,axiom,
    ! [VarCurr: state_type] :
      ( v33653(VarCurr)
    <=> ( v33654(VarCurr)
        | v33537(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33654(VarCurr)
    <=> v33634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3178,axiom,
    ! [VarCurr: state_type] :
      ( v33629(VarCurr)
    <=> ( v33630(VarCurr)
        & v33650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3177,axiom,
    ! [VarCurr: state_type] :
      ( v33650(VarCurr)
    <=> ( v33632(VarCurr)
        | v33651(VarCurr) ) ) ).

tff(writeUnaryOperator_1981,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33651(VarCurr)
    <=> v33537(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_414,axiom,
    ! [VarCurr: state_type] :
      ( v33630(VarCurr)
    <=> ( v33631(VarCurr)
        | v33537(VarCurr,7) ) ) ).

tff(writeUnaryOperator_1980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33631(VarCurr)
    <=> v33632(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_413,axiom,
    ! [VarCurr: state_type] :
      ( v33632(VarCurr)
    <=> ( v33537(VarCurr,6)
        | v33633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3176,axiom,
    ! [VarCurr: state_type] :
      ( v33633(VarCurr)
    <=> ( v33634(VarCurr)
        & v33649(VarCurr) ) ) ).

tff(writeUnaryOperator_1979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33649(VarCurr)
    <=> v33537(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_412,axiom,
    ! [VarCurr: state_type] :
      ( v33634(VarCurr)
    <=> ( v33537(VarCurr,5)
        | v33635(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3175,axiom,
    ! [VarCurr: state_type] :
      ( v33635(VarCurr)
    <=> ( v33636(VarCurr)
        & v33648(VarCurr) ) ) ).

tff(writeUnaryOperator_1978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33648(VarCurr)
    <=> v33537(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_411,axiom,
    ! [VarCurr: state_type] :
      ( v33636(VarCurr)
    <=> ( v33537(VarCurr,4)
        | v33637(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3174,axiom,
    ! [VarCurr: state_type] :
      ( v33637(VarCurr)
    <=> ( v33638(VarCurr)
        & v33647(VarCurr) ) ) ).

tff(writeUnaryOperator_1977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33647(VarCurr)
    <=> v33537(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_410,axiom,
    ! [VarCurr: state_type] :
      ( v33638(VarCurr)
    <=> ( v33537(VarCurr,3)
        | v33639(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3173,axiom,
    ! [VarCurr: state_type] :
      ( v33639(VarCurr)
    <=> ( v33640(VarCurr)
        & v33646(VarCurr) ) ) ).

tff(writeUnaryOperator_1976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33646(VarCurr)
    <=> v33537(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_409,axiom,
    ! [VarCurr: state_type] :
      ( v33640(VarCurr)
    <=> ( v33537(VarCurr,2)
        | v33641(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3172,axiom,
    ! [VarCurr: state_type] :
      ( v33641(VarCurr)
    <=> ( v33642(VarCurr)
        & v33645(VarCurr) ) ) ).

tff(writeUnaryOperator_1975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33645(VarCurr)
    <=> v33537(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_408,axiom,
    ! [VarCurr: state_type] :
      ( v33642(VarCurr)
    <=> ( v33537(VarCurr,1)
        | v33643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3171,axiom,
    ! [VarCurr: state_type] :
      ( v33643(VarCurr)
    <=> ( v33537(VarCurr,0)
        & v33644(VarCurr) ) ) ).

tff(writeUnaryOperator_1974,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33644(VarCurr)
    <=> v33537(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_181,axiom,
    ! [VarCurr: state_type] :
      ( v33626(VarCurr)
    <=> ( ( v33537(VarCurr,7)
        <=> $false )
        & ( v33537(VarCurr,6)
        <=> $false )
        & ( v33537(VarCurr,5)
        <=> $false )
        & ( v33537(VarCurr,4)
        <=> $false )
        & ( v33537(VarCurr,3)
        <=> $false )
        & ( v33537(VarCurr,2)
        <=> $false )
        & ( v33537(VarCurr,1)
        <=> $false )
        & ( v33537(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_1973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33559(VarCurr,B)
      <=> ~ v33561(VarCurr,B) ) ) ).

tff(addAssignment_16785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33561(VarCurr,B)
      <=> v33563(VarCurr,B) ) ) ).

tff(addAssignment_16784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33563(VarCurr,B)
      <=> v33565(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33606(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v33565(VarNext,B)
            <=> v33565(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_394,axiom,
    ! [VarNext: state_type] :
      ( v33606(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33565(VarNext,B)
          <=> v33616(VarNext,B) ) ) ) ).

tff(addAssignment_16783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33616(VarNext,B)
          <=> v33614(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33614(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_272,axiom,
    ! [VarCurr: state_type] :
      ( v33617(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33614(VarCurr,B)
          <=> v33575(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3170,axiom,
    ! [VarCurr: state_type] :
      ( v33617(VarCurr)
    <=> ( v33618(VarCurr)
        & v33619(VarCurr) ) ) ).

tff(writeUnaryOperator_1972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33619(VarCurr)
    <=> v33571(VarCurr) ) ).

tff(writeUnaryOperator_1971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33618(VarCurr)
    <=> v33567(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33606(VarNext)
      <=> v33607(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33607(VarNext)
      <=> ( v33608(VarNext)
          & v33601(VarNext) ) ) ) ).

tff(writeUnaryOperator_1970,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33608(VarNext)
      <=> v33610(VarNext) ) ) ).

tff(addAssignment_16782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33610(VarNext)
      <=> v33601(VarCurr) ) ) ).

tff(addAssignment_16781,axiom,
    ! [VarCurr: state_type] :
      ( v33601(VarCurr)
    <=> v33603(VarCurr) ) ).

tff(addAssignment_16780,axiom,
    ! [VarCurr: state_type] :
      ( v33603(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33575(VarCurr,B)
      <=> v33577(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_542,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33577(VarCurr,B)
      <=> ( v33593(VarCurr,B)
          | v33596(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33596(VarCurr,B)
      <=> ( v33563(VarCurr,B)
          & v33597(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33597(VarCurr,B)
      <=> ~ v33598(VarCurr,B) ) ) ).

tff(addAssignment_16778,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,0)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16777,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,1)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16776,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,2)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16775,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,3)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16774,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,4)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16773,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,5)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16772,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,6)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16771,axiom,
    ! [VarCurr: state_type] :
      ( v33598(VarCurr,7)
    <=> v33599(VarCurr) ) ).

tff(addAssignment_16770,axiom,
    ! [VarCurr: state_type] :
      ( v33599(VarCurr)
    <=> v33586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_540,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33593(VarCurr,B)
      <=> ( v33579(VarCurr,B)
          & v33594(VarCurr,B) ) ) ) ).

tff(addAssignment_16769,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,0)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16768,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,1)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16767,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,2)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16766,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,3)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16765,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,4)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16764,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,5)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16763,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,6)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16762,axiom,
    ! [VarCurr: state_type] :
      ( v33594(VarCurr,7)
    <=> v33595(VarCurr) ) ).

tff(addAssignment_16761,axiom,
    ! [VarCurr: state_type] :
      ( v33595(VarCurr)
    <=> v33586(VarCurr) ) ).

tff(addAssignment_16760,axiom,
    ! [VarCurr: state_type] :
      ( v33586(VarCurr)
    <=> v33588(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3167,axiom,
    ! [VarCurr: state_type] :
      ( v33588(VarCurr)
    <=> ( v2354(VarCurr)
        & v33591(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_180,axiom,
    ! [VarCurr: state_type] :
      ( v33591(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_875,axiom,
    ~ b0100010001000(12) ).

tff(bitBlastConstant_874,axiom,
    b0100010001000(11) ).

tff(bitBlastConstant_873,axiom,
    ~ b0100010001000(10) ).

tff(bitBlastConstant_872,axiom,
    ~ b0100010001000(9) ).

tff(bitBlastConstant_871,axiom,
    ~ b0100010001000(8) ).

tff(bitBlastConstant_870,axiom,
    b0100010001000(7) ).

tff(bitBlastConstant_869,axiom,
    ~ b0100010001000(6) ).

tff(bitBlastConstant_868,axiom,
    ~ b0100010001000(5) ).

tff(bitBlastConstant_867,axiom,
    ~ b0100010001000(4) ).

tff(bitBlastConstant_866,axiom,
    b0100010001000(3) ).

tff(bitBlastConstant_865,axiom,
    ~ b0100010001000(2) ).

tff(bitBlastConstant_864,axiom,
    ~ b0100010001000(1) ).

tff(bitBlastConstant_863,axiom,
    ~ b0100010001000(0) ).

tff(addAssignment_16759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33579(VarCurr,B)
      <=> v33581(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33581(VarCurr,B)
      <=> ~ v33583(VarCurr,B) ) ) ).

tff(addAssignment_16758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33583(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_16757,axiom,
    ! [VarCurr: state_type] :
      ( v33571(VarCurr)
    <=> v33573(VarCurr) ) ).

tff(addAssignment_16756,axiom,
    ! [VarCurr: state_type] :
      ( v33573(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16755,axiom,
    ! [VarCurr: state_type] :
      ( v33567(VarCurr)
    <=> v33569(VarCurr) ) ).

tff(addAssignment_16754,axiom,
    ! [VarCurr: state_type] :
      ( v33569(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_16753,axiom,
    ! [VarCurr: state_type] :
      ( v33547(VarCurr)
    <=> v33549(VarCurr) ) ).

tff(addAssignment_16752,axiom,
    ! [VarCurr: state_type] :
      ( v33549(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16751,axiom,
    ! [VarCurr: state_type] :
      ( v33543(VarCurr)
    <=> v33545(VarCurr) ) ).

tff(addAssignment_16750,axiom,
    ! [VarCurr: state_type] :
      ( v33545(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33448(VarCurr,B)
      <=> v33450(VarCurr,B) ) ) ).

tff(addAssignment_16748,axiom,
    ! [VarCurr: state_type] :
      ( v33450(VarCurr,1)
    <=> v33452(VarCurr,1) ) ).

tff(addAssignment_16747,axiom,
    ! [VarNext: state_type] :
      ( v33452(VarNext,1)
    <=> v33519(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33520(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33519(VarNext,B)
            <=> v33452(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_393,axiom,
    ! [VarNext: state_type] :
      ( v33520(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33519(VarNext,B)
          <=> v33530(VarNext,B) ) ) ) ).

tff(addAssignment_16746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33530(VarNext,B)
          <=> v33528(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33531(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33528(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_271,axiom,
    ! [VarCurr: state_type] :
      ( v33531(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33528(VarCurr,B)
          <=> v33462(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3166,axiom,
    ! [VarCurr: state_type] :
      ( v33531(VarCurr)
    <=> ( v33532(VarCurr)
        & v33533(VarCurr) ) ) ).

tff(writeUnaryOperator_1967,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33533(VarCurr)
    <=> v33458(VarCurr) ) ).

tff(writeUnaryOperator_1966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33532(VarCurr)
    <=> v33454(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33520(VarNext)
      <=> v33521(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33521(VarNext)
      <=> ( v33522(VarNext)
          & v33515(VarNext) ) ) ) ).

tff(writeUnaryOperator_1965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33522(VarNext)
      <=> v33524(VarNext) ) ) ).

tff(addAssignment_16745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33524(VarNext)
      <=> v33515(VarCurr) ) ) ).

tff(addAssignment_16744,axiom,
    ! [VarCurr: state_type] :
      ( v33515(VarCurr)
    <=> v33517(VarCurr) ) ).

tff(addAssignment_16743,axiom,
    ! [VarCurr: state_type] :
      ( v33517(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16742,axiom,
    ! [VarCurr: state_type] :
      ( v33462(VarCurr,1)
    <=> v33464(VarCurr,1) ) ).

tff(addAssignment_16741,axiom,
    ! [VarCurr: state_type] :
      ( v33464(VarCurr,1)
    <=> v33506(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33506(VarCurr,B)
      <=> ( v33507(VarCurr,B)
          | v33510(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33510(VarCurr,B)
      <=> ( v33450(VarCurr,B)
          & v33511(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1964,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33511(VarCurr,B)
      <=> ~ v33512(VarCurr,B) ) ) ).

tff(addAssignment_16740,axiom,
    ! [VarCurr: state_type] :
      ( v33512(VarCurr,0)
    <=> v33513(VarCurr) ) ).

tff(addAssignment_16739,axiom,
    ! [VarCurr: state_type] :
      ( v33512(VarCurr,1)
    <=> v33513(VarCurr) ) ).

tff(addAssignment_16738,axiom,
    ! [VarCurr: state_type] :
      ( v33513(VarCurr)
    <=> v33495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33507(VarCurr,B)
      <=> ( v33466(VarCurr,B)
          & v33508(VarCurr,B) ) ) ) ).

tff(addAssignment_16737,axiom,
    ! [VarCurr: state_type] :
      ( v33508(VarCurr,0)
    <=> v33509(VarCurr) ) ).

tff(addAssignment_16736,axiom,
    ! [VarCurr: state_type] :
      ( v33508(VarCurr,1)
    <=> v33509(VarCurr) ) ).

tff(addAssignment_16735,axiom,
    ! [VarCurr: state_type] :
      ( v33509(VarCurr)
    <=> v33495(VarCurr) ) ).

tff(addAssignment_16734,axiom,
    ! [VarCurr: state_type] :
      ( v33495(VarCurr)
    <=> v33497(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3163,axiom,
    ! [VarCurr: state_type] :
      ( v33497(VarCurr)
    <=> ( v33499(VarCurr)
        | v33504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3162,axiom,
    ! [VarCurr: state_type] :
      ( v33504(VarCurr)
    <=> ( v2354(VarCurr)
        & v33505(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_179,axiom,
    ! [VarCurr: state_type] :
      ( v33505(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3161,axiom,
    ! [VarCurr: state_type] :
      ( v33499(VarCurr)
    <=> ( v33500(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3160,axiom,
    ! [VarCurr: state_type] :
      ( v33500(VarCurr)
    <=> ( v33501(VarCurr)
        | v33483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3159,axiom,
    ! [VarCurr: state_type] :
      ( v33501(VarCurr)
    <=> ( v33502(VarCurr)
        | v33475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3158,axiom,
    ! [VarCurr: state_type] :
      ( v33502(VarCurr)
    <=> ( v33503(VarCurr)
        | v33470(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3157,axiom,
    ! [VarCurr: state_type] :
      ( v33503(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(addAssignment_16733,axiom,
    ! [VarCurr: state_type] :
      ( v33466(VarCurr,1)
    <=> v33468(VarCurr,1) ) ).

tff(addAssignment_16732,axiom,
    ! [VarCurr: state_type] :
      ( v33468(VarCurr,1)
    <=> v33487(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33487(VarCurr,B)
          <=> v33489(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_270,axiom,
    ! [VarCurr: state_type] :
      ( v33488(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33487(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33470(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33489(VarCurr,B)
          <=> v33490(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_269,axiom,
    ! [VarCurr: state_type] :
      ( v33470(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33489(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33490(VarCurr,B)
          <=> v33492(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_268,axiom,
    ! [VarCurr: state_type] :
      ( v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33490(VarCurr,B)
          <=> v33491(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33492(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_267,axiom,
    ! [VarCurr: state_type] :
      ( v33493(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33492(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3156,axiom,
    ! [VarCurr: state_type] :
      ( v33493(VarCurr)
    <=> ( v33475(VarCurr)
        | v33483(VarCurr) ) ) ).

tff(addAssignment_16731,axiom,
    ! [VarCurr: state_type] :
      ( v33491(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_16730,axiom,
    ! [VarCurr: state_type] :
      ( v33491(VarCurr,1)
    <=> v33448(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3155,axiom,
    ! [VarCurr: state_type] :
      ( v33488(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3154,axiom,
    ! [VarCurr: state_type] :
      ( v33483(VarCurr)
    <=> ( v33485(VarCurr)
        & v33486(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_178,axiom,
    ! [VarCurr: state_type] :
      ( v33486(VarCurr)
    <=> ( ( v32851(VarCurr,9)
        <=> $false )
        & ( v32851(VarCurr,8)
        <=> $false )
        & ( v32851(VarCurr,7)
        <=> $false )
        & ( v32851(VarCurr,6)
        <=> $false )
        & ( v32851(VarCurr,5)
        <=> $false )
        & ( v32851(VarCurr,4)
        <=> $false )
        & ( v32851(VarCurr,3)
        <=> $false )
        & ( v32851(VarCurr,2)
        <=> $false )
        & ( v32851(VarCurr,1)
        <=> $false )
        & ( v32851(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3153,axiom,
    ! [VarCurr: state_type] :
      ( v33485(VarCurr)
    <=> ( v32583(VarCurr)
        & v33472(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3152,axiom,
    ! [VarCurr: state_type] :
      ( v33475(VarCurr)
    <=> ( v33477(VarCurr)
        & v33481(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_177,axiom,
    ! [VarCurr: state_type] :
      ( v33481(VarCurr)
    <=> ( ( v32754(VarCurr,3)
        <=> $true )
        & ( v32754(VarCurr,2)
        <=> $true )
        & ( v32754(VarCurr,1)
        <=> $true )
        & ( v32754(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3151,axiom,
    ! [VarCurr: state_type] :
      ( v33477(VarCurr)
    <=> ( v33472(VarCurr)
        & v33478(VarCurr) ) ) ).

tff(writeUnaryOperator_1963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33478(VarCurr)
    <=> v33479(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_407,axiom,
    ! [VarCurr: state_type] :
      ( v33479(VarCurr)
    <=> ( v33448(VarCurr,0)
        | v33448(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_176,axiom,
    ! [VarCurr: state_type] :
      ( v33472(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16729,axiom,
    ! [VarCurr: state_type] :
      ( v33458(VarCurr)
    <=> v33460(VarCurr) ) ).

tff(addAssignment_16728,axiom,
    ! [VarCurr: state_type] :
      ( v33460(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16727,axiom,
    ! [VarCurr: state_type] :
      ( v33454(VarCurr)
    <=> v33456(VarCurr) ) ).

tff(addAssignment_16726,axiom,
    ! [VarCurr: state_type] :
      ( v33456(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16725,axiom,
    ! [VarCurr: state_type] :
      ( v33182(VarCurr,0)
    <=> v33184(VarCurr,0) ) ).

tff(addAssignment_16724,axiom,
    ! [VarNext: state_type] :
      ( v33184(VarNext,0)
    <=> v33440(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33441(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33440(VarNext,B)
            <=> v33184(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_392,axiom,
    ! [VarNext: state_type] :
      ( v33441(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33440(VarNext,B)
          <=> v33263(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33441(VarNext)
      <=> v33442(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33442(VarNext)
      <=> ( v33444(VarNext)
          & v33248(VarNext) ) ) ) ).

tff(writeUnaryOperator_1962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33444(VarNext)
      <=> v33257(VarNext) ) ) ).

tff(addAssignment_16723,axiom,
    ! [VarCurr: state_type] :
      ( v33194(VarCurr,0)
    <=> v33196(VarCurr,0) ) ).

tff(addAssignment_16722,axiom,
    ! [VarCurr: state_type] :
      ( v33196(VarCurr,0)
    <=> v33239(VarCurr,0) ) ).

tff(addAssignment_16721,axiom,
    ! [VarCurr: state_type] :
      ( v33198(VarCurr,0)
    <=> v33200(VarCurr,0) ) ).

tff(addAssignment_16720,axiom,
    ! [VarCurr: state_type] :
      ( v33200(VarCurr,0)
    <=> v33219(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3148,axiom,
    ! [VarCurr: state_type] :
      ( v33202(VarCurr)
    <=> ( v33435(VarCurr)
        & v33438(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_175,axiom,
    ! [VarCurr: state_type] :
      ( v33438(VarCurr)
    <=> ( ( v33270(VarCurr,7)
        <=> $false )
        & ( v33270(VarCurr,6)
        <=> $false )
        & ( v33270(VarCurr,5)
        <=> $false )
        & ( v33270(VarCurr,4)
        <=> $false )
        & ( v33270(VarCurr,3)
        <=> $false )
        & ( v33270(VarCurr,2)
        <=> $false )
        & ( v33270(VarCurr,1)
        <=> $false )
        & ( v33270(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3147,axiom,
    ! [VarCurr: state_type] :
      ( v33435(VarCurr)
    <=> ( v33204(VarCurr)
        & v33436(VarCurr) ) ) ).

tff(writeUnaryOperator_1961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33436(VarCurr)
    <=> v33437(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_406,axiom,
    ! [VarCurr: state_type] :
      ( v33437(VarCurr)
    <=> ( v33180(VarCurr,0)
        | v33180(VarCurr,1) ) ) ).

tff(addAssignment_16719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33270(VarCurr,B)
      <=> v33272(VarCurr,B) ) ) ).

tff(addAssignment_16718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33272(VarCurr,B)
      <=> v33274(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_391,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33418(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v33274(VarNext,B)
            <=> v33274(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_391,axiom,
    ! [VarNext: state_type] :
      ( v33418(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33274(VarNext,B)
          <=> v33428(VarNext,B) ) ) ) ).

tff(addAssignment_16717,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33428(VarNext,B)
          <=> v33426(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33429(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33426(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_266,axiom,
    ! [VarCurr: state_type] :
      ( v33429(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33426(VarCurr,B)
          <=> v33284(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3146,axiom,
    ! [VarCurr: state_type] :
      ( v33429(VarCurr)
    <=> ( v33430(VarCurr)
        & v33431(VarCurr) ) ) ).

tff(writeUnaryOperator_1960,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33431(VarCurr)
    <=> v33280(VarCurr) ) ).

tff(writeUnaryOperator_1959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33430(VarCurr)
    <=> v33276(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33418(VarNext)
      <=> v33419(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33419(VarNext)
      <=> ( v33420(VarNext)
          & v33413(VarNext) ) ) ) ).

tff(writeUnaryOperator_1958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33420(VarNext)
      <=> v33422(VarNext) ) ) ).

tff(addAssignment_16716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33422(VarNext)
      <=> v33413(VarCurr) ) ) ).

tff(addAssignment_16715,axiom,
    ! [VarCurr: state_type] :
      ( v33413(VarCurr)
    <=> v33415(VarCurr) ) ).

tff(addAssignment_16714,axiom,
    ! [VarCurr: state_type] :
      ( v33415(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33284(VarCurr,B)
      <=> v33286(VarCurr,B) ) ) ).

tff(addAssignment_16712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33286(VarCurr,B)
      <=> v33288(VarCurr,B) ) ) ).

tff(addAssignment_16711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33288(VarCurr,B)
      <=> v33290(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33290(VarCurr,B)
      <=> ( v33357(VarCurr,B)
          | v33409(VarCurr,B) ) ) ) ).

tff(addAssignment_16710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v33409(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_16709,axiom,
    ! [VarCurr: state_type] :
      ( v33409(VarCurr,7)
    <=> v33410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3143,axiom,
    ! [VarCurr: state_type] :
      ( v33410(VarCurr)
    <=> ( v31269(VarCurr)
        | v33411(VarCurr) ) ) ).

tff(writeUnaryOperator_1957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33411(VarCurr)
    <=> v32524(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33357(VarCurr,B)
          <=> v33292(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_265,axiom,
    ! [VarCurr: state_type] :
      ( v33204(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33357(VarCurr,B)
          <=> v33358(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33358(VarCurr,B)
          <=> v33360(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_264,axiom,
    ! [VarCurr: state_type] :
      ( v33359(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33358(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_16708,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,0)
    <=> v33407(VarCurr) ) ).

tff(addAssignment_16707,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,1)
    <=> v33405(VarCurr) ) ).

tff(addAssignment_16706,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,2)
    <=> v33401(VarCurr) ) ).

tff(addAssignment_16705,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,3)
    <=> v33397(VarCurr) ) ).

tff(addAssignment_16704,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,4)
    <=> v33393(VarCurr) ) ).

tff(addAssignment_16703,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,5)
    <=> v33389(VarCurr) ) ).

tff(addAssignment_16702,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,6)
    <=> v33385(VarCurr) ) ).

tff(addAssignment_16701,axiom,
    ! [VarCurr: state_type] :
      ( v33360(VarCurr,7)
    <=> v33362(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3142,axiom,
    ! [VarCurr: state_type] :
      ( v33405(VarCurr)
    <=> ( v33406(VarCurr)
        & v33408(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3141,axiom,
    ! [VarCurr: state_type] :
      ( v33408(VarCurr)
    <=> ( v33270(VarCurr,0)
        | v33377(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_405,axiom,
    ! [VarCurr: state_type] :
      ( v33406(VarCurr)
    <=> ( v33407(VarCurr)
        | v33270(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1956,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33407(VarCurr)
    <=> v33270(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3140,axiom,
    ! [VarCurr: state_type] :
      ( v33401(VarCurr)
    <=> ( v33402(VarCurr)
        & v33404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3139,axiom,
    ! [VarCurr: state_type] :
      ( v33404(VarCurr)
    <=> ( v33375(VarCurr)
        | v33378(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_404,axiom,
    ! [VarCurr: state_type] :
      ( v33402(VarCurr)
    <=> ( v33403(VarCurr)
        | v33270(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33403(VarCurr)
    <=> v33375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3138,axiom,
    ! [VarCurr: state_type] :
      ( v33397(VarCurr)
    <=> ( v33398(VarCurr)
        & v33400(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3137,axiom,
    ! [VarCurr: state_type] :
      ( v33400(VarCurr)
    <=> ( v33373(VarCurr)
        | v33379(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_403,axiom,
    ! [VarCurr: state_type] :
      ( v33398(VarCurr)
    <=> ( v33399(VarCurr)
        | v33270(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1954,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33399(VarCurr)
    <=> v33373(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3136,axiom,
    ! [VarCurr: state_type] :
      ( v33393(VarCurr)
    <=> ( v33394(VarCurr)
        & v33396(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3135,axiom,
    ! [VarCurr: state_type] :
      ( v33396(VarCurr)
    <=> ( v33371(VarCurr)
        | v33380(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_402,axiom,
    ! [VarCurr: state_type] :
      ( v33394(VarCurr)
    <=> ( v33395(VarCurr)
        | v33270(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33395(VarCurr)
    <=> v33371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3134,axiom,
    ! [VarCurr: state_type] :
      ( v33389(VarCurr)
    <=> ( v33390(VarCurr)
        & v33392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3133,axiom,
    ! [VarCurr: state_type] :
      ( v33392(VarCurr)
    <=> ( v33369(VarCurr)
        | v33381(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_401,axiom,
    ! [VarCurr: state_type] :
      ( v33390(VarCurr)
    <=> ( v33391(VarCurr)
        | v33270(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1952,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33391(VarCurr)
    <=> v33369(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3132,axiom,
    ! [VarCurr: state_type] :
      ( v33385(VarCurr)
    <=> ( v33386(VarCurr)
        & v33388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3131,axiom,
    ! [VarCurr: state_type] :
      ( v33388(VarCurr)
    <=> ( v33367(VarCurr)
        | v33382(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_400,axiom,
    ! [VarCurr: state_type] :
      ( v33386(VarCurr)
    <=> ( v33387(VarCurr)
        | v33270(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33387(VarCurr)
    <=> v33367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3130,axiom,
    ! [VarCurr: state_type] :
      ( v33362(VarCurr)
    <=> ( v33363(VarCurr)
        & v33383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3129,axiom,
    ! [VarCurr: state_type] :
      ( v33383(VarCurr)
    <=> ( v33365(VarCurr)
        | v33384(VarCurr) ) ) ).

tff(writeUnaryOperator_1950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33384(VarCurr)
    <=> v33270(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_399,axiom,
    ! [VarCurr: state_type] :
      ( v33363(VarCurr)
    <=> ( v33364(VarCurr)
        | v33270(VarCurr,7) ) ) ).

tff(writeUnaryOperator_1949,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33364(VarCurr)
    <=> v33365(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_398,axiom,
    ! [VarCurr: state_type] :
      ( v33365(VarCurr)
    <=> ( v33270(VarCurr,6)
        | v33366(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3128,axiom,
    ! [VarCurr: state_type] :
      ( v33366(VarCurr)
    <=> ( v33367(VarCurr)
        & v33382(VarCurr) ) ) ).

tff(writeUnaryOperator_1948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33382(VarCurr)
    <=> v33270(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_397,axiom,
    ! [VarCurr: state_type] :
      ( v33367(VarCurr)
    <=> ( v33270(VarCurr,5)
        | v33368(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3127,axiom,
    ! [VarCurr: state_type] :
      ( v33368(VarCurr)
    <=> ( v33369(VarCurr)
        & v33381(VarCurr) ) ) ).

tff(writeUnaryOperator_1947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33381(VarCurr)
    <=> v33270(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_396,axiom,
    ! [VarCurr: state_type] :
      ( v33369(VarCurr)
    <=> ( v33270(VarCurr,4)
        | v33370(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3126,axiom,
    ! [VarCurr: state_type] :
      ( v33370(VarCurr)
    <=> ( v33371(VarCurr)
        & v33380(VarCurr) ) ) ).

tff(writeUnaryOperator_1946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33380(VarCurr)
    <=> v33270(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_395,axiom,
    ! [VarCurr: state_type] :
      ( v33371(VarCurr)
    <=> ( v33270(VarCurr,3)
        | v33372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3125,axiom,
    ! [VarCurr: state_type] :
      ( v33372(VarCurr)
    <=> ( v33373(VarCurr)
        & v33379(VarCurr) ) ) ).

tff(writeUnaryOperator_1945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33379(VarCurr)
    <=> v33270(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_394,axiom,
    ! [VarCurr: state_type] :
      ( v33373(VarCurr)
    <=> ( v33270(VarCurr,2)
        | v33374(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3124,axiom,
    ! [VarCurr: state_type] :
      ( v33374(VarCurr)
    <=> ( v33375(VarCurr)
        & v33378(VarCurr) ) ) ).

tff(writeUnaryOperator_1944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33378(VarCurr)
    <=> v33270(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_393,axiom,
    ! [VarCurr: state_type] :
      ( v33375(VarCurr)
    <=> ( v33270(VarCurr,1)
        | v33376(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3123,axiom,
    ! [VarCurr: state_type] :
      ( v33376(VarCurr)
    <=> ( v33270(VarCurr,0)
        & v33377(VarCurr) ) ) ).

tff(writeUnaryOperator_1943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33377(VarCurr)
    <=> v33270(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_174,axiom,
    ! [VarCurr: state_type] :
      ( v33359(VarCurr)
    <=> ( ( v33270(VarCurr,7)
        <=> $false )
        & ( v33270(VarCurr,6)
        <=> $false )
        & ( v33270(VarCurr,5)
        <=> $false )
        & ( v33270(VarCurr,4)
        <=> $false )
        & ( v33270(VarCurr,3)
        <=> $false )
        & ( v33270(VarCurr,2)
        <=> $false )
        & ( v33270(VarCurr,1)
        <=> $false )
        & ( v33270(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_862,axiom,
    ~ b00000000(7) ).

tff(bitBlastConstant_861,axiom,
    ~ b00000000(6) ).

tff(bitBlastConstant_860,axiom,
    ~ b00000000(5) ).

tff(bitBlastConstant_859,axiom,
    ~ b00000000(4) ).

tff(bitBlastConstant_858,axiom,
    ~ b00000000(3) ).

tff(bitBlastConstant_857,axiom,
    ~ b00000000(2) ).

tff(bitBlastConstant_856,axiom,
    ~ b00000000(1) ).

tff(bitBlastConstant_855,axiom,
    ~ b00000000(0) ).

tff(writeUnaryOperator_1942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33292(VarCurr,B)
      <=> ~ v33294(VarCurr,B) ) ) ).

tff(addAssignment_16700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33294(VarCurr,B)
      <=> v33296(VarCurr,B) ) ) ).

tff(addAssignment_16699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33296(VarCurr,B)
      <=> v33298(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33339(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v33298(VarNext,B)
            <=> v33298(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_390,axiom,
    ! [VarNext: state_type] :
      ( v33339(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33298(VarNext,B)
          <=> v33349(VarNext,B) ) ) ) ).

tff(addAssignment_16698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33349(VarNext,B)
          <=> v33347(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33347(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_263,axiom,
    ! [VarCurr: state_type] :
      ( v33350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v33347(VarCurr,B)
          <=> v33308(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3122,axiom,
    ! [VarCurr: state_type] :
      ( v33350(VarCurr)
    <=> ( v33351(VarCurr)
        & v33352(VarCurr) ) ) ).

tff(writeUnaryOperator_1941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33352(VarCurr)
    <=> v33304(VarCurr) ) ).

tff(writeUnaryOperator_1940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33351(VarCurr)
    <=> v33300(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33339(VarNext)
      <=> v33340(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33340(VarNext)
      <=> ( v33341(VarNext)
          & v33334(VarNext) ) ) ) ).

tff(writeUnaryOperator_1939,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33341(VarNext)
      <=> v33343(VarNext) ) ) ).

tff(addAssignment_16697,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33343(VarNext)
      <=> v33334(VarCurr) ) ) ).

tff(addAssignment_16696,axiom,
    ! [VarCurr: state_type] :
      ( v33334(VarCurr)
    <=> v33336(VarCurr) ) ).

tff(addAssignment_16695,axiom,
    ! [VarCurr: state_type] :
      ( v33336(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33308(VarCurr,B)
      <=> v33310(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33310(VarCurr,B)
      <=> ( v33326(VarCurr,B)
          | v33329(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33329(VarCurr,B)
      <=> ( v33296(VarCurr,B)
          & v33330(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33330(VarCurr,B)
      <=> ~ v33331(VarCurr,B) ) ) ).

tff(addAssignment_16693,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,0)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16692,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,1)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16691,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,2)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16690,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,3)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16689,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,4)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16688,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,5)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16687,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,6)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16686,axiom,
    ! [VarCurr: state_type] :
      ( v33331(VarCurr,7)
    <=> v33332(VarCurr) ) ).

tff(addAssignment_16685,axiom,
    ! [VarCurr: state_type] :
      ( v33332(VarCurr)
    <=> v33319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33326(VarCurr,B)
      <=> ( v33312(VarCurr,B)
          & v33327(VarCurr,B) ) ) ) ).

tff(addAssignment_16684,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,0)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16683,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,1)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16682,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,2)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16681,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,3)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16680,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,4)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16679,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,5)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16678,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,6)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16677,axiom,
    ! [VarCurr: state_type] :
      ( v33327(VarCurr,7)
    <=> v33328(VarCurr) ) ).

tff(addAssignment_16676,axiom,
    ! [VarCurr: state_type] :
      ( v33328(VarCurr)
    <=> v33319(VarCurr) ) ).

tff(addAssignment_16675,axiom,
    ! [VarCurr: state_type] :
      ( v33319(VarCurr)
    <=> v33321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3119,axiom,
    ! [VarCurr: state_type] :
      ( v33321(VarCurr)
    <=> ( v2354(VarCurr)
        & v33324(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_173,axiom,
    ! [VarCurr: state_type] :
      ( v33324(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_854,axiom,
    ~ b0100001111000(12) ).

tff(bitBlastConstant_853,axiom,
    b0100001111000(11) ).

tff(bitBlastConstant_852,axiom,
    ~ b0100001111000(10) ).

tff(bitBlastConstant_851,axiom,
    ~ b0100001111000(9) ).

tff(bitBlastConstant_850,axiom,
    ~ b0100001111000(8) ).

tff(bitBlastConstant_849,axiom,
    ~ b0100001111000(7) ).

tff(bitBlastConstant_848,axiom,
    b0100001111000(6) ).

tff(bitBlastConstant_847,axiom,
    b0100001111000(5) ).

tff(bitBlastConstant_846,axiom,
    b0100001111000(4) ).

tff(bitBlastConstant_845,axiom,
    b0100001111000(3) ).

tff(bitBlastConstant_844,axiom,
    ~ b0100001111000(2) ).

tff(bitBlastConstant_843,axiom,
    ~ b0100001111000(1) ).

tff(bitBlastConstant_842,axiom,
    ~ b0100001111000(0) ).

tff(addAssignment_16674,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33312(VarCurr,B)
      <=> v33314(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33314(VarCurr,B)
      <=> ~ v33316(VarCurr,B) ) ) ).

tff(addAssignment_16673,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v33316(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_16672,axiom,
    ! [VarCurr: state_type] :
      ( v33304(VarCurr)
    <=> v33306(VarCurr) ) ).

tff(addAssignment_16671,axiom,
    ! [VarCurr: state_type] :
      ( v33306(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16670,axiom,
    ! [VarCurr: state_type] :
      ( v33300(VarCurr)
    <=> v33302(VarCurr) ) ).

tff(addAssignment_16669,axiom,
    ! [VarCurr: state_type] :
      ( v33302(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_16668,axiom,
    ! [VarCurr: state_type] :
      ( v33280(VarCurr)
    <=> v33282(VarCurr) ) ).

tff(addAssignment_16667,axiom,
    ! [VarCurr: state_type] :
      ( v33282(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16666,axiom,
    ! [VarCurr: state_type] :
      ( v33276(VarCurr)
    <=> v33278(VarCurr) ) ).

tff(addAssignment_16665,axiom,
    ! [VarCurr: state_type] :
      ( v33278(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33180(VarCurr,B)
      <=> v33182(VarCurr,B) ) ) ).

tff(addAssignment_16663,axiom,
    ! [VarCurr: state_type] :
      ( v33182(VarCurr,1)
    <=> v33184(VarCurr,1) ) ).

tff(addAssignment_16662,axiom,
    ! [VarNext: state_type] :
      ( v33184(VarNext,1)
    <=> v33252(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33253(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33252(VarNext,B)
            <=> v33184(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_389,axiom,
    ! [VarNext: state_type] :
      ( v33253(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33252(VarNext,B)
          <=> v33263(VarNext,B) ) ) ) ).

tff(addAssignment_16661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33263(VarNext,B)
          <=> v33261(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33264(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33261(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_262,axiom,
    ! [VarCurr: state_type] :
      ( v33264(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33261(VarCurr,B)
          <=> v33194(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3118,axiom,
    ! [VarCurr: state_type] :
      ( v33264(VarCurr)
    <=> ( v33265(VarCurr)
        & v33266(VarCurr) ) ) ).

tff(writeUnaryOperator_1936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33266(VarCurr)
    <=> v33190(VarCurr) ) ).

tff(writeUnaryOperator_1935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33265(VarCurr)
    <=> v33186(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33253(VarNext)
      <=> v33254(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33254(VarNext)
      <=> ( v33255(VarNext)
          & v33248(VarNext) ) ) ) ).

tff(writeUnaryOperator_1934,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33255(VarNext)
      <=> v33257(VarNext) ) ) ).

tff(addAssignment_16660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33257(VarNext)
      <=> v33248(VarCurr) ) ) ).

tff(addAssignment_16659,axiom,
    ! [VarCurr: state_type] :
      ( v33248(VarCurr)
    <=> v33250(VarCurr) ) ).

tff(addAssignment_16658,axiom,
    ! [VarCurr: state_type] :
      ( v33250(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16657,axiom,
    ! [VarCurr: state_type] :
      ( v33194(VarCurr,1)
    <=> v33196(VarCurr,1) ) ).

tff(addAssignment_16656,axiom,
    ! [VarCurr: state_type] :
      ( v33196(VarCurr,1)
    <=> v33239(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33239(VarCurr,B)
      <=> ( v33240(VarCurr,B)
          | v33243(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33243(VarCurr,B)
      <=> ( v33182(VarCurr,B)
          & v33244(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33244(VarCurr,B)
      <=> ~ v33245(VarCurr,B) ) ) ).

tff(addAssignment_16655,axiom,
    ! [VarCurr: state_type] :
      ( v33245(VarCurr,0)
    <=> v33246(VarCurr) ) ).

tff(addAssignment_16654,axiom,
    ! [VarCurr: state_type] :
      ( v33245(VarCurr,1)
    <=> v33246(VarCurr) ) ).

tff(addAssignment_16653,axiom,
    ! [VarCurr: state_type] :
      ( v33246(VarCurr)
    <=> v33227(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33240(VarCurr,B)
      <=> ( v33198(VarCurr,B)
          & v33241(VarCurr,B) ) ) ) ).

tff(addAssignment_16652,axiom,
    ! [VarCurr: state_type] :
      ( v33241(VarCurr,0)
    <=> v33242(VarCurr) ) ).

tff(addAssignment_16651,axiom,
    ! [VarCurr: state_type] :
      ( v33241(VarCurr,1)
    <=> v33242(VarCurr) ) ).

tff(addAssignment_16650,axiom,
    ! [VarCurr: state_type] :
      ( v33242(VarCurr)
    <=> v33227(VarCurr) ) ).

tff(addAssignment_16649,axiom,
    ! [VarCurr: state_type] :
      ( v33227(VarCurr)
    <=> v33229(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3115,axiom,
    ! [VarCurr: state_type] :
      ( v33229(VarCurr)
    <=> ( v33232(VarCurr)
        | v33237(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3114,axiom,
    ! [VarCurr: state_type] :
      ( v33237(VarCurr)
    <=> ( v2354(VarCurr)
        & v33238(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_172,axiom,
    ! [VarCurr: state_type] :
      ( v33238(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_841,axiom,
    ~ b0100001110000(12) ).

tff(bitBlastConstant_840,axiom,
    b0100001110000(11) ).

tff(bitBlastConstant_839,axiom,
    ~ b0100001110000(10) ).

tff(bitBlastConstant_838,axiom,
    ~ b0100001110000(9) ).

tff(bitBlastConstant_837,axiom,
    ~ b0100001110000(8) ).

tff(bitBlastConstant_836,axiom,
    ~ b0100001110000(7) ).

tff(bitBlastConstant_835,axiom,
    b0100001110000(6) ).

tff(bitBlastConstant_834,axiom,
    b0100001110000(5) ).

tff(bitBlastConstant_833,axiom,
    b0100001110000(4) ).

tff(bitBlastConstant_832,axiom,
    ~ b0100001110000(3) ).

tff(bitBlastConstant_831,axiom,
    ~ b0100001110000(2) ).

tff(bitBlastConstant_830,axiom,
    ~ b0100001110000(1) ).

tff(bitBlastConstant_829,axiom,
    ~ b0100001110000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3113,axiom,
    ! [VarCurr: state_type] :
      ( v33232(VarCurr)
    <=> ( v33233(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3112,axiom,
    ! [VarCurr: state_type] :
      ( v33233(VarCurr)
    <=> ( v33234(VarCurr)
        | v33215(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3111,axiom,
    ! [VarCurr: state_type] :
      ( v33234(VarCurr)
    <=> ( v33235(VarCurr)
        | v33202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3110,axiom,
    ! [VarCurr: state_type] :
      ( v33235(VarCurr)
    <=> ( v33236(VarCurr)
        | v33207(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3109,axiom,
    ! [VarCurr: state_type] :
      ( v33236(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(addAssignment_16648,axiom,
    ! [VarCurr: state_type] :
      ( v33198(VarCurr,1)
    <=> v33200(VarCurr,1) ) ).

tff(addAssignment_16647,axiom,
    ! [VarCurr: state_type] :
      ( v33200(VarCurr,1)
    <=> v33219(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33219(VarCurr,B)
          <=> v33221(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_261,axiom,
    ! [VarCurr: state_type] :
      ( v33220(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33219(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33221(VarCurr,B)
          <=> v33222(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_260,axiom,
    ! [VarCurr: state_type] :
      ( v33202(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33221(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33222(VarCurr,B)
          <=> v33224(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_259,axiom,
    ! [VarCurr: state_type] :
      ( v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33222(VarCurr,B)
          <=> v33223(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33225(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33224(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_258,axiom,
    ! [VarCurr: state_type] :
      ( v33225(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33224(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3108,axiom,
    ! [VarCurr: state_type] :
      ( v33225(VarCurr)
    <=> ( v33207(VarCurr)
        | v33215(VarCurr) ) ) ).

tff(addAssignment_16646,axiom,
    ! [VarCurr: state_type] :
      ( v33223(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_16645,axiom,
    ! [VarCurr: state_type] :
      ( v33223(VarCurr,1)
    <=> v33180(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3107,axiom,
    ! [VarCurr: state_type] :
      ( v33220(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3106,axiom,
    ! [VarCurr: state_type] :
      ( v33215(VarCurr)
    <=> ( v33217(VarCurr)
        & v33218(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_171,axiom,
    ! [VarCurr: state_type] :
      ( v33218(VarCurr)
    <=> ( ( v32851(VarCurr,9)
        <=> $false )
        & ( v32851(VarCurr,8)
        <=> $false )
        & ( v32851(VarCurr,7)
        <=> $false )
        & ( v32851(VarCurr,6)
        <=> $false )
        & ( v32851(VarCurr,5)
        <=> $false )
        & ( v32851(VarCurr,4)
        <=> $false )
        & ( v32851(VarCurr,3)
        <=> $false )
        & ( v32851(VarCurr,2)
        <=> $false )
        & ( v32851(VarCurr,1)
        <=> $false )
        & ( v32851(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3105,axiom,
    ! [VarCurr: state_type] :
      ( v33217(VarCurr)
    <=> ( v31315(VarCurr)
        & v33204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3104,axiom,
    ! [VarCurr: state_type] :
      ( v33207(VarCurr)
    <=> ( v33209(VarCurr)
        & v33213(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_170,axiom,
    ! [VarCurr: state_type] :
      ( v33213(VarCurr)
    <=> ( ( v32754(VarCurr,3)
        <=> $false )
        & ( v32754(VarCurr,2)
        <=> $true )
        & ( v32754(VarCurr,1)
        <=> $false )
        & ( v32754(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3103,axiom,
    ! [VarCurr: state_type] :
      ( v33209(VarCurr)
    <=> ( v33204(VarCurr)
        & v33210(VarCurr) ) ) ).

tff(writeUnaryOperator_1932,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33210(VarCurr)
    <=> v33211(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_392,axiom,
    ! [VarCurr: state_type] :
      ( v33211(VarCurr)
    <=> ( v33180(VarCurr,0)
        | v33180(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_169,axiom,
    ! [VarCurr: state_type] :
      ( v33204(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_16644,axiom,
    ! [VarCurr: state_type] :
      ( v33190(VarCurr)
    <=> v33192(VarCurr) ) ).

tff(addAssignment_16643,axiom,
    ! [VarCurr: state_type] :
      ( v33192(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16642,axiom,
    ! [VarCurr: state_type] :
      ( v33186(VarCurr)
    <=> v33188(VarCurr) ) ).

tff(addAssignment_16641,axiom,
    ! [VarCurr: state_type] :
      ( v33188(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16640,axiom,
    ! [VarCurr: state_type] :
      ( v32730(VarCurr,0)
    <=> v32732(VarCurr,0) ) ).

tff(addAssignment_16639,axiom,
    ! [VarNext: state_type] :
      ( v32732(VarNext,0)
    <=> v33172(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_388,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33173(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33172(VarNext,B)
            <=> v32732(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_388,axiom,
    ! [VarNext: state_type] :
      ( v33173(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33172(VarNext,B)
          <=> v33158(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33173(VarNext)
      <=> v33174(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33174(VarNext)
      <=> ( v33176(VarNext)
          & v33143(VarNext) ) ) ) ).

tff(writeUnaryOperator_1931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33176(VarNext)
      <=> v33152(VarNext) ) ) ).

tff(addAssignment_16638,axiom,
    ! [VarCurr: state_type] :
      ( v32742(VarCurr,0)
    <=> v32744(VarCurr,0) ) ).

tff(addAssignment_16637,axiom,
    ! [VarCurr: state_type] :
      ( v32744(VarCurr,0)
    <=> v33134(VarCurr,0) ) ).

tff(addAssignment_16636,axiom,
    ! [VarCurr: state_type] :
      ( v32746(VarCurr,0)
    <=> v32748(VarCurr,0) ) ).

tff(addAssignment_16635,axiom,
    ! [VarCurr: state_type] :
      ( v32748(VarCurr,0)
    <=> v33114(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3100,axiom,
    ! [VarCurr: state_type] :
      ( v32750(VarCurr)
    <=> ( v33165(VarCurr)
        & v33170(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_168,axiom,
    ! [VarCurr: state_type] :
      ( v33170(VarCurr)
    <=> ( ( v30943(VarCurr,15)
        <=> $false )
        & ( v30943(VarCurr,14)
        <=> $false )
        & ( v30943(VarCurr,13)
        <=> $false )
        & ( v30943(VarCurr,12)
        <=> $false )
        & ( v30943(VarCurr,11)
        <=> $false )
        & ( v30943(VarCurr,10)
        <=> $false )
        & ( v30943(VarCurr,9)
        <=> $false )
        & ( v30943(VarCurr,8)
        <=> $false )
        & ( v30943(VarCurr,7)
        <=> $false )
        & ( v30943(VarCurr,6)
        <=> $false )
        & ( v30943(VarCurr,5)
        <=> $false )
        & ( v30943(VarCurr,4)
        <=> $false )
        & ( v30943(VarCurr,3)
        <=> $false )
        & ( v30943(VarCurr,2)
        <=> $false )
        & ( v30943(VarCurr,1)
        <=> $false )
        & ( v30943(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3099,axiom,
    ! [VarCurr: state_type] :
      ( v33165(VarCurr)
    <=> ( v33166(VarCurr)
        & v33169(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_167,axiom,
    ! [VarCurr: state_type] :
      ( v33169(VarCurr)
    <=> ( ( v30967(VarCurr,15)
        <=> $false )
        & ( v30967(VarCurr,14)
        <=> $false )
        & ( v30967(VarCurr,13)
        <=> $false )
        & ( v30967(VarCurr,12)
        <=> $false )
        & ( v30967(VarCurr,11)
        <=> $false )
        & ( v30967(VarCurr,10)
        <=> $false )
        & ( v30967(VarCurr,9)
        <=> $false )
        & ( v30967(VarCurr,8)
        <=> $false )
        & ( v30967(VarCurr,7)
        <=> $false )
        & ( v30967(VarCurr,6)
        <=> $false )
        & ( v30967(VarCurr,5)
        <=> $false )
        & ( v30967(VarCurr,4)
        <=> $false )
        & ( v30967(VarCurr,3)
        <=> $false )
        & ( v30967(VarCurr,2)
        <=> $false )
        & ( v30967(VarCurr,1)
        <=> $false )
        & ( v30967(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3098,axiom,
    ! [VarCurr: state_type] :
      ( v33166(VarCurr)
    <=> ( v30965(VarCurr)
        & v33167(VarCurr) ) ) ).

tff(writeUnaryOperator_1930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33167(VarCurr)
    <=> v33168(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_391,axiom,
    ! [VarCurr: state_type] :
      ( v33168(VarCurr)
    <=> ( v32728(VarCurr,0)
        | v32728(VarCurr,1) ) ) ).

tff(addAssignment_16634,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v32728(VarCurr,B)
      <=> v32730(VarCurr,B) ) ) ).

tff(addAssignment_16633,axiom,
    ! [VarCurr: state_type] :
      ( v32730(VarCurr,1)
    <=> v32732(VarCurr,1) ) ).

tff(addAssignment_16632,axiom,
    ! [VarNext: state_type] :
      ( v32732(VarNext,1)
    <=> v33147(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33148(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v33147(VarNext,B)
            <=> v32732(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_387,axiom,
    ! [VarNext: state_type] :
      ( v33148(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33147(VarNext,B)
          <=> v33158(VarNext,B) ) ) ) ).

tff(addAssignment_16631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33158(VarNext,B)
          <=> v33156(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33159(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33156(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_257,axiom,
    ! [VarCurr: state_type] :
      ( v33159(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33156(VarCurr,B)
          <=> v32742(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3097,axiom,
    ! [VarCurr: state_type] :
      ( v33159(VarCurr)
    <=> ( v33160(VarCurr)
        & v33161(VarCurr) ) ) ).

tff(writeUnaryOperator_1929,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33161(VarCurr)
    <=> v32738(VarCurr) ) ).

tff(writeUnaryOperator_1928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33160(VarCurr)
    <=> v32734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33148(VarNext)
      <=> v33149(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33149(VarNext)
      <=> ( v33150(VarNext)
          & v33143(VarNext) ) ) ) ).

tff(writeUnaryOperator_1927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33150(VarNext)
      <=> v33152(VarNext) ) ) ).

tff(addAssignment_16630,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33152(VarNext)
      <=> v33143(VarCurr) ) ) ).

tff(addAssignment_16629,axiom,
    ! [VarCurr: state_type] :
      ( v33143(VarCurr)
    <=> v33145(VarCurr) ) ).

tff(addAssignment_16628,axiom,
    ! [VarCurr: state_type] :
      ( v33145(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16627,axiom,
    ! [VarCurr: state_type] :
      ( v32742(VarCurr,1)
    <=> v32744(VarCurr,1) ) ).

tff(addAssignment_16626,axiom,
    ! [VarCurr: state_type] :
      ( v32744(VarCurr,1)
    <=> v33134(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33134(VarCurr,B)
      <=> ( v33135(VarCurr,B)
          | v33138(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33138(VarCurr,B)
      <=> ( v32730(VarCurr,B)
          & v33139(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33139(VarCurr,B)
      <=> ~ v33140(VarCurr,B) ) ) ).

tff(addAssignment_16625,axiom,
    ! [VarCurr: state_type] :
      ( v33140(VarCurr,0)
    <=> v33141(VarCurr) ) ).

tff(addAssignment_16624,axiom,
    ! [VarCurr: state_type] :
      ( v33140(VarCurr,1)
    <=> v33141(VarCurr) ) ).

tff(addAssignment_16623,axiom,
    ! [VarCurr: state_type] :
      ( v33141(VarCurr)
    <=> v33122(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v33135(VarCurr,B)
      <=> ( v32746(VarCurr,B)
          & v33136(VarCurr,B) ) ) ) ).

tff(addAssignment_16622,axiom,
    ! [VarCurr: state_type] :
      ( v33136(VarCurr,0)
    <=> v33137(VarCurr) ) ).

tff(addAssignment_16621,axiom,
    ! [VarCurr: state_type] :
      ( v33136(VarCurr,1)
    <=> v33137(VarCurr) ) ).

tff(addAssignment_16620,axiom,
    ! [VarCurr: state_type] :
      ( v33137(VarCurr)
    <=> v33122(VarCurr) ) ).

tff(addAssignment_16619,axiom,
    ! [VarCurr: state_type] :
      ( v33122(VarCurr)
    <=> v33124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3094,axiom,
    ! [VarCurr: state_type] :
      ( v33124(VarCurr)
    <=> ( v33127(VarCurr)
        | v33132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3093,axiom,
    ! [VarCurr: state_type] :
      ( v33132(VarCurr)
    <=> ( v2354(VarCurr)
        & v33133(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_166,axiom,
    ! [VarCurr: state_type] :
      ( v33133(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_828,axiom,
    ~ b0100001100000(12) ).

tff(bitBlastConstant_827,axiom,
    b0100001100000(11) ).

tff(bitBlastConstant_826,axiom,
    ~ b0100001100000(10) ).

tff(bitBlastConstant_825,axiom,
    ~ b0100001100000(9) ).

tff(bitBlastConstant_824,axiom,
    ~ b0100001100000(8) ).

tff(bitBlastConstant_823,axiom,
    ~ b0100001100000(7) ).

tff(bitBlastConstant_822,axiom,
    b0100001100000(6) ).

tff(bitBlastConstant_821,axiom,
    b0100001100000(5) ).

tff(bitBlastConstant_820,axiom,
    ~ b0100001100000(4) ).

tff(bitBlastConstant_819,axiom,
    ~ b0100001100000(3) ).

tff(bitBlastConstant_818,axiom,
    ~ b0100001100000(2) ).

tff(bitBlastConstant_817,axiom,
    ~ b0100001100000(1) ).

tff(bitBlastConstant_816,axiom,
    ~ b0100001100000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3092,axiom,
    ! [VarCurr: state_type] :
      ( v33127(VarCurr)
    <=> ( v33128(VarCurr)
        | v32575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3091,axiom,
    ! [VarCurr: state_type] :
      ( v33128(VarCurr)
    <=> ( v33129(VarCurr)
        | v32849(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3090,axiom,
    ! [VarCurr: state_type] :
      ( v33129(VarCurr)
    <=> ( v33130(VarCurr)
        | v32750(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3089,axiom,
    ! [VarCurr: state_type] :
      ( v33130(VarCurr)
    <=> ( v33131(VarCurr)
        | v32752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3088,axiom,
    ! [VarCurr: state_type] :
      ( v33131(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(addAssignment_16618,axiom,
    ! [VarCurr: state_type] :
      ( v32746(VarCurr,1)
    <=> v32748(VarCurr,1) ) ).

tff(addAssignment_16617,axiom,
    ! [VarCurr: state_type] :
      ( v32748(VarCurr,1)
    <=> v33114(VarCurr,1) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33115(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33114(VarCurr,B)
          <=> v33116(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_256,axiom,
    ! [VarCurr: state_type] :
      ( v33115(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33114(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33116(VarCurr,B)
          <=> v33117(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_255,axiom,
    ! [VarCurr: state_type] :
      ( v32750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33116(VarCurr,B)
          <=> b10(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33117(VarCurr,B)
          <=> v33119(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_254,axiom,
    ! [VarCurr: state_type] :
      ( v32575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33117(VarCurr,B)
          <=> v33118(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33120(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33119(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_253,axiom,
    ! [VarCurr: state_type] :
      ( v33120(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v33119(VarCurr,B)
          <=> b01(B) ) ) ) ).

tff(bitBlastConstant_815,axiom,
    ~ b01(1) ).

tff(bitBlastConstant_814,axiom,
    b01(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3087,axiom,
    ! [VarCurr: state_type] :
      ( v33120(VarCurr)
    <=> ( v32752(VarCurr)
        | v32849(VarCurr) ) ) ).

tff(addAssignment_16616,axiom,
    ! [VarCurr: state_type] :
      ( v33118(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_16615,axiom,
    ! [VarCurr: state_type] :
      ( v33118(VarCurr,1)
    <=> v32728(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3086,axiom,
    ! [VarCurr: state_type] :
      ( v33115(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3085,axiom,
    ! [VarCurr: state_type] :
      ( v32849(VarCurr)
    <=> ( v33112(VarCurr)
        & v33113(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_165,axiom,
    ! [VarCurr: state_type] :
      ( v33113(VarCurr)
    <=> ( ( v32851(VarCurr,9)
        <=> $false )
        & ( v32851(VarCurr,8)
        <=> $false )
        & ( v32851(VarCurr,7)
        <=> $false )
        & ( v32851(VarCurr,6)
        <=> $false )
        & ( v32851(VarCurr,5)
        <=> $false )
        & ( v32851(VarCurr,4)
        <=> $false )
        & ( v32851(VarCurr,3)
        <=> $false )
        & ( v32851(VarCurr,2)
        <=> $false )
        & ( v32851(VarCurr,1)
        <=> $false )
        & ( v32851(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3084,axiom,
    ! [VarCurr: state_type] :
      ( v33112(VarCurr)
    <=> ( v32581(VarCurr)
        & v30965(VarCurr) ) ) ).

tff(addAssignment_16614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v32851(VarCurr,B)
      <=> v32853(VarCurr,B) ) ) ).

tff(addAssignment_16613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v32853(VarCurr,B)
      <=> v32855(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33095(VarNext)
       => ! [B: $int] :
            ( ( $less(B,10)
              & ~ $less(B,0) )
           => ( v32855(VarNext,B)
            <=> v32855(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_386,axiom,
    ! [VarNext: state_type] :
      ( v33095(VarNext)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v32855(VarNext,B)
          <=> v33105(VarNext,B) ) ) ) ).

tff(addAssignment_16612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33105(VarNext,B)
          <=> v33103(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33106(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33103(VarCurr,B)
          <=> bxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_252,axiom,
    ! [VarCurr: state_type] :
      ( v33106(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33103(VarCurr,B)
          <=> v32865(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3083,axiom,
    ! [VarCurr: state_type] :
      ( v33106(VarCurr)
    <=> ( v33107(VarCurr)
        & v33108(VarCurr) ) ) ).

tff(writeUnaryOperator_1925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33108(VarCurr)
    <=> v32861(VarCurr) ) ).

tff(writeUnaryOperator_1924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33107(VarCurr)
    <=> v32857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33095(VarNext)
      <=> v33096(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33096(VarNext)
      <=> ( v33097(VarNext)
          & v33090(VarNext) ) ) ) ).

tff(writeUnaryOperator_1923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v33097(VarNext)
      <=> v33099(VarNext) ) ) ).

tff(addAssignment_16611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v33099(VarNext)
      <=> v33090(VarCurr) ) ) ).

tff(addAssignment_16610,axiom,
    ! [VarCurr: state_type] :
      ( v33090(VarCurr)
    <=> v33092(VarCurr) ) ).

tff(addAssignment_16609,axiom,
    ! [VarCurr: state_type] :
      ( v33092(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v32865(VarCurr,B)
      <=> v32867(VarCurr,B) ) ) ).

tff(addAssignment_16607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v32867(VarCurr,B)
      <=> v32869(VarCurr,B) ) ) ).

tff(addAssignment_16606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v32869(VarCurr,B)
      <=> v32871(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v32871(VarCurr,B)
          <=> $false ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_251,axiom,
    ! [VarCurr: state_type] :
      ( v33012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v32871(VarCurr,B)
          <=> v33013(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33014(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33013(VarCurr,B)
          <=> v33016(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_250,axiom,
    ! [VarCurr: state_type] :
      ( v33014(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33013(VarCurr,B)
          <=> v32873(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33017(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33016(VarCurr,B)
          <=> v33019(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_249,axiom,
    ! [VarCurr: state_type] :
      ( v33017(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33016(VarCurr,B)
          <=> v32951(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33019(VarCurr,B)
          <=> v33022(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_248,axiom,
    ! [VarCurr: state_type] :
      ( v33020(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33019(VarCurr,B)
          <=> b0000001111(B) ) ) ) ).

tff(bitBlastConstant_813,axiom,
    ~ b0000001111(9) ).

tff(bitBlastConstant_812,axiom,
    ~ b0000001111(8) ).

tff(bitBlastConstant_811,axiom,
    ~ b0000001111(7) ).

tff(bitBlastConstant_810,axiom,
    ~ b0000001111(6) ).

tff(bitBlastConstant_809,axiom,
    ~ b0000001111(5) ).

tff(bitBlastConstant_808,axiom,
    ~ b0000001111(4) ).

tff(bitBlastConstant_807,axiom,
    b0000001111(3) ).

tff(bitBlastConstant_806,axiom,
    b0000001111(2) ).

tff(bitBlastConstant_805,axiom,
    b0000001111(1) ).

tff(bitBlastConstant_804,axiom,
    b0000001111(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33023(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33022(VarCurr,B)
          <=> v33024(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_247,axiom,
    ! [VarCurr: state_type] :
      ( v33023(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33022(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33024(VarCurr,B)
          <=> v32851(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_246,axiom,
    ! [VarCurr: state_type] :
      ( v33004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,10)
            & ~ $less(B,0) )
         => ( v33024(VarCurr,B)
          <=> v33025(VarCurr,B) ) ) ) ).

tff(addAssignment_16605,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,0)
    <=> v33086(VarCurr) ) ).

tff(addAssignment_16604,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,1)
    <=> v33084(VarCurr) ) ).

tff(addAssignment_16603,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,2)
    <=> v33080(VarCurr) ) ).

tff(addAssignment_16602,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,3)
    <=> v33076(VarCurr) ) ).

tff(addAssignment_16601,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,4)
    <=> v33072(VarCurr) ) ).

tff(addAssignment_16600,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,5)
    <=> v33068(VarCurr) ) ).

tff(addAssignment_16599,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,6)
    <=> v33064(VarCurr) ) ).

tff(addAssignment_16598,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,7)
    <=> v33060(VarCurr) ) ).

tff(addAssignment_16597,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,8)
    <=> v33056(VarCurr) ) ).

tff(addAssignment_16596,axiom,
    ! [VarCurr: state_type] :
      ( v33025(VarCurr,9)
    <=> v33027(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3080,axiom,
    ! [VarCurr: state_type] :
      ( v33084(VarCurr)
    <=> ( v33085(VarCurr)
        & v33087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3079,axiom,
    ! [VarCurr: state_type] :
      ( v33087(VarCurr)
    <=> ( v32851(VarCurr,0)
        | v33046(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_390,axiom,
    ! [VarCurr: state_type] :
      ( v33085(VarCurr)
    <=> ( v33086(VarCurr)
        | v32851(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33086(VarCurr)
    <=> v32851(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3078,axiom,
    ! [VarCurr: state_type] :
      ( v33080(VarCurr)
    <=> ( v33081(VarCurr)
        & v33083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3077,axiom,
    ! [VarCurr: state_type] :
      ( v33083(VarCurr)
    <=> ( v33044(VarCurr)
        | v33047(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_389,axiom,
    ! [VarCurr: state_type] :
      ( v33081(VarCurr)
    <=> ( v33082(VarCurr)
        | v32851(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33082(VarCurr)
    <=> v33044(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3076,axiom,
    ! [VarCurr: state_type] :
      ( v33076(VarCurr)
    <=> ( v33077(VarCurr)
        & v33079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3075,axiom,
    ! [VarCurr: state_type] :
      ( v33079(VarCurr)
    <=> ( v33042(VarCurr)
        | v33048(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_388,axiom,
    ! [VarCurr: state_type] :
      ( v33077(VarCurr)
    <=> ( v33078(VarCurr)
        | v32851(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33078(VarCurr)
    <=> v33042(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3074,axiom,
    ! [VarCurr: state_type] :
      ( v33072(VarCurr)
    <=> ( v33073(VarCurr)
        & v33075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3073,axiom,
    ! [VarCurr: state_type] :
      ( v33075(VarCurr)
    <=> ( v33040(VarCurr)
        | v33049(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_387,axiom,
    ! [VarCurr: state_type] :
      ( v33073(VarCurr)
    <=> ( v33074(VarCurr)
        | v32851(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1919,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33074(VarCurr)
    <=> v33040(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3072,axiom,
    ! [VarCurr: state_type] :
      ( v33068(VarCurr)
    <=> ( v33069(VarCurr)
        & v33071(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3071,axiom,
    ! [VarCurr: state_type] :
      ( v33071(VarCurr)
    <=> ( v33038(VarCurr)
        | v33050(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_386,axiom,
    ! [VarCurr: state_type] :
      ( v33069(VarCurr)
    <=> ( v33070(VarCurr)
        | v32851(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33070(VarCurr)
    <=> v33038(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3070,axiom,
    ! [VarCurr: state_type] :
      ( v33064(VarCurr)
    <=> ( v33065(VarCurr)
        & v33067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3069,axiom,
    ! [VarCurr: state_type] :
      ( v33067(VarCurr)
    <=> ( v33036(VarCurr)
        | v33051(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_385,axiom,
    ! [VarCurr: state_type] :
      ( v33065(VarCurr)
    <=> ( v33066(VarCurr)
        | v32851(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1917,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33066(VarCurr)
    <=> v33036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3068,axiom,
    ! [VarCurr: state_type] :
      ( v33060(VarCurr)
    <=> ( v33061(VarCurr)
        & v33063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3067,axiom,
    ! [VarCurr: state_type] :
      ( v33063(VarCurr)
    <=> ( v33034(VarCurr)
        | v33052(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_384,axiom,
    ! [VarCurr: state_type] :
      ( v33061(VarCurr)
    <=> ( v33062(VarCurr)
        | v32851(VarCurr,7) ) ) ).

tff(writeUnaryOperator_1916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33062(VarCurr)
    <=> v33034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3066,axiom,
    ! [VarCurr: state_type] :
      ( v33056(VarCurr)
    <=> ( v33057(VarCurr)
        & v33059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3065,axiom,
    ! [VarCurr: state_type] :
      ( v33059(VarCurr)
    <=> ( v33032(VarCurr)
        | v33053(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_383,axiom,
    ! [VarCurr: state_type] :
      ( v33057(VarCurr)
    <=> ( v33058(VarCurr)
        | v32851(VarCurr,8) ) ) ).

tff(writeUnaryOperator_1915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33058(VarCurr)
    <=> v33032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3064,axiom,
    ! [VarCurr: state_type] :
      ( v33027(VarCurr)
    <=> ( v33028(VarCurr)
        & v33054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3063,axiom,
    ! [VarCurr: state_type] :
      ( v33054(VarCurr)
    <=> ( v33030(VarCurr)
        | v33055(VarCurr) ) ) ).

tff(writeUnaryOperator_1914,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33055(VarCurr)
    <=> v32851(VarCurr,9) ) ).

tff(writeBinaryOperatorShiftedRanges_382,axiom,
    ! [VarCurr: state_type] :
      ( v33028(VarCurr)
    <=> ( v33029(VarCurr)
        | v32851(VarCurr,9) ) ) ).

tff(writeUnaryOperator_1913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33029(VarCurr)
    <=> v33030(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_381,axiom,
    ! [VarCurr: state_type] :
      ( v33030(VarCurr)
    <=> ( v32851(VarCurr,8)
        | v33031(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3062,axiom,
    ! [VarCurr: state_type] :
      ( v33031(VarCurr)
    <=> ( v33032(VarCurr)
        & v33053(VarCurr) ) ) ).

tff(writeUnaryOperator_1912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33053(VarCurr)
    <=> v32851(VarCurr,8) ) ).

tff(writeBinaryOperatorShiftedRanges_380,axiom,
    ! [VarCurr: state_type] :
      ( v33032(VarCurr)
    <=> ( v32851(VarCurr,7)
        | v33033(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3061,axiom,
    ! [VarCurr: state_type] :
      ( v33033(VarCurr)
    <=> ( v33034(VarCurr)
        & v33052(VarCurr) ) ) ).

tff(writeUnaryOperator_1911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33052(VarCurr)
    <=> v32851(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_379,axiom,
    ! [VarCurr: state_type] :
      ( v33034(VarCurr)
    <=> ( v32851(VarCurr,6)
        | v33035(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3060,axiom,
    ! [VarCurr: state_type] :
      ( v33035(VarCurr)
    <=> ( v33036(VarCurr)
        & v33051(VarCurr) ) ) ).

tff(writeUnaryOperator_1910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33051(VarCurr)
    <=> v32851(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_378,axiom,
    ! [VarCurr: state_type] :
      ( v33036(VarCurr)
    <=> ( v32851(VarCurr,5)
        | v33037(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3059,axiom,
    ! [VarCurr: state_type] :
      ( v33037(VarCurr)
    <=> ( v33038(VarCurr)
        & v33050(VarCurr) ) ) ).

tff(writeUnaryOperator_1909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33050(VarCurr)
    <=> v32851(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_377,axiom,
    ! [VarCurr: state_type] :
      ( v33038(VarCurr)
    <=> ( v32851(VarCurr,4)
        | v33039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3058,axiom,
    ! [VarCurr: state_type] :
      ( v33039(VarCurr)
    <=> ( v33040(VarCurr)
        & v33049(VarCurr) ) ) ).

tff(writeUnaryOperator_1908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33049(VarCurr)
    <=> v32851(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_376,axiom,
    ! [VarCurr: state_type] :
      ( v33040(VarCurr)
    <=> ( v32851(VarCurr,3)
        | v33041(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3057,axiom,
    ! [VarCurr: state_type] :
      ( v33041(VarCurr)
    <=> ( v33042(VarCurr)
        & v33048(VarCurr) ) ) ).

tff(writeUnaryOperator_1907,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33048(VarCurr)
    <=> v32851(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_375,axiom,
    ! [VarCurr: state_type] :
      ( v33042(VarCurr)
    <=> ( v32851(VarCurr,2)
        | v33043(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3056,axiom,
    ! [VarCurr: state_type] :
      ( v33043(VarCurr)
    <=> ( v33044(VarCurr)
        & v33047(VarCurr) ) ) ).

tff(writeUnaryOperator_1906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33047(VarCurr)
    <=> v32851(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_374,axiom,
    ! [VarCurr: state_type] :
      ( v33044(VarCurr)
    <=> ( v32851(VarCurr,1)
        | v33045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3055,axiom,
    ! [VarCurr: state_type] :
      ( v33045(VarCurr)
    <=> ( v32851(VarCurr,0)
        & v33046(VarCurr) ) ) ).

tff(writeUnaryOperator_1905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33046(VarCurr)
    <=> v32851(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_164,axiom,
    ! [VarCurr: state_type] :
      ( v33023(VarCurr)
    <=> ( ( v32851(VarCurr,9)
        <=> $false )
        & ( v32851(VarCurr,8)
        <=> $false )
        & ( v32851(VarCurr,7)
        <=> $false )
        & ( v32851(VarCurr,6)
        <=> $false )
        & ( v32851(VarCurr,5)
        <=> $false )
        & ( v32851(VarCurr,4)
        <=> $false )
        & ( v32851(VarCurr,3)
        <=> $false )
        & ( v32851(VarCurr,2)
        <=> $false )
        & ( v32851(VarCurr,1)
        <=> $false )
        & ( v32851(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_803,axiom,
    ~ b0000000000(9) ).

tff(bitBlastConstant_802,axiom,
    ~ b0000000000(8) ).

tff(bitBlastConstant_801,axiom,
    ~ b0000000000(7) ).

tff(bitBlastConstant_800,axiom,
    ~ b0000000000(6) ).

tff(bitBlastConstant_799,axiom,
    ~ b0000000000(5) ).

tff(bitBlastConstant_798,axiom,
    ~ b0000000000(4) ).

tff(bitBlastConstant_797,axiom,
    ~ b0000000000(3) ).

tff(bitBlastConstant_796,axiom,
    ~ b0000000000(2) ).

tff(bitBlastConstant_795,axiom,
    ~ b0000000000(1) ).

tff(bitBlastConstant_794,axiom,
    ~ b0000000000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3054,axiom,
    ! [VarCurr: state_type] :
      ( v33020(VarCurr)
    <=> ( v33021(VarCurr)
        & v32577(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_163,axiom,
    ! [VarCurr: state_type] :
      ( v33021(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $true )
        & ( v4221(VarCurr,1)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3053,axiom,
    ! [VarCurr: state_type] :
      ( v33017(VarCurr)
    <=> ( v33018(VarCurr)
        & v32577(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_162,axiom,
    ! [VarCurr: state_type] :
      ( v33018(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $false )
        & ( v4221(VarCurr,1)
        <=> $true )
        & ( v4221(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3052,axiom,
    ! [VarCurr: state_type] :
      ( v33014(VarCurr)
    <=> ( v33015(VarCurr)
        & v32577(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_161,axiom,
    ! [VarCurr: state_type] :
      ( v33015(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $false )
        & ( v4221(VarCurr,1)
        <=> $true )
        & ( v4221(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3051,axiom,
    ! [VarCurr: state_type] :
      ( v33012(VarCurr)
    <=> ( v32581(VarCurr)
        | v32583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3050,axiom,
    ! [VarCurr: state_type] :
      ( v33004(VarCurr)
    <=> ( v33006(VarCurr)
        | v33010(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_160,axiom,
    ! [VarCurr: state_type] :
      ( v33010(VarCurr)
    <=> ( ( v4867(VarCurr,2)
        <=> $true )
        & ( v4867(VarCurr,1)
        <=> $false )
        & ( v4867(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3049,axiom,
    ! [VarCurr: state_type] :
      ( v33006(VarCurr)
    <=> ( v33007(VarCurr)
        | v33009(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_159,axiom,
    ! [VarCurr: state_type] :
      ( v33009(VarCurr)
    <=> ( ( v4793(VarCurr,2)
        <=> $true )
        & ( v4793(VarCurr,1)
        <=> $false )
        & ( v4793(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3048,axiom,
    ! [VarCurr: state_type] :
      ( v33007(VarCurr)
    <=> ( v33008(VarCurr)
        | v31315(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_158,axiom,
    ! [VarCurr: state_type] :
      ( v33008(VarCurr)
    <=> ( ( v4615(VarCurr,3)
        <=> $true )
        & ( v4615(VarCurr,2)
        <=> $false )
        & ( v4615(VarCurr,1)
        <=> $true )
        & ( v4615(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_16595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v32951(VarCurr,B)
      <=> v32953(VarCurr,B) ) ) ).

tff(addAssignment_16594,axiom,
    ! [VarCurr: state_type] :
      ( ( v32951(VarCurr,9)
      <=> $false )
      & ( v32951(VarCurr,8)
      <=> $false ) ) ).

tff(addAssignment_16593,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,0)
    <=> v33000(VarCurr) ) ).

tff(addAssignment_16592,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,1)
    <=> v32998(VarCurr) ) ).

tff(addAssignment_16591,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,2)
    <=> v32994(VarCurr) ) ).

tff(addAssignment_16590,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,3)
    <=> v32990(VarCurr) ) ).

tff(addAssignment_16589,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,4)
    <=> v32986(VarCurr) ) ).

tff(addAssignment_16588,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,5)
    <=> v32982(VarCurr) ) ).

tff(addAssignment_16587,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,6)
    <=> v32978(VarCurr) ) ).

tff(addAssignment_16586,axiom,
    ! [VarCurr: state_type] :
      ( v32953(VarCurr,7)
    <=> v32955(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3047,axiom,
    ! [VarCurr: state_type] :
      ( v32998(VarCurr)
    <=> ( v32999(VarCurr)
        & v33001(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_373,axiom,
    ! [VarCurr: state_type] :
      ( v33001(VarCurr)
    <=> ( v32875(VarCurr,13)
        | v32970(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_372,axiom,
    ! [VarCurr: state_type] :
      ( v32999(VarCurr)
    <=> ( v33000(VarCurr)
        | v32875(VarCurr,14) ) ) ).

tff(writeUnaryOperator_1904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v33000(VarCurr)
    <=> v32875(VarCurr,13) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3046,axiom,
    ! [VarCurr: state_type] :
      ( v32994(VarCurr)
    <=> ( v32995(VarCurr)
        & v32997(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3045,axiom,
    ! [VarCurr: state_type] :
      ( v32997(VarCurr)
    <=> ( v32968(VarCurr)
        | v32971(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_371,axiom,
    ! [VarCurr: state_type] :
      ( v32995(VarCurr)
    <=> ( v32996(VarCurr)
        | v32875(VarCurr,15) ) ) ).

tff(writeUnaryOperator_1903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32996(VarCurr)
    <=> v32968(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3044,axiom,
    ! [VarCurr: state_type] :
      ( v32990(VarCurr)
    <=> ( v32991(VarCurr)
        & v32993(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3043,axiom,
    ! [VarCurr: state_type] :
      ( v32993(VarCurr)
    <=> ( v32966(VarCurr)
        | v32972(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_370,axiom,
    ! [VarCurr: state_type] :
      ( v32991(VarCurr)
    <=> ( v32992(VarCurr)
        | v32875(VarCurr,16) ) ) ).

tff(writeUnaryOperator_1902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32992(VarCurr)
    <=> v32966(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3042,axiom,
    ! [VarCurr: state_type] :
      ( v32986(VarCurr)
    <=> ( v32987(VarCurr)
        & v32989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3041,axiom,
    ! [VarCurr: state_type] :
      ( v32989(VarCurr)
    <=> ( v32964(VarCurr)
        | v32973(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_369,axiom,
    ! [VarCurr: state_type] :
      ( v32987(VarCurr)
    <=> ( v32988(VarCurr)
        | v32875(VarCurr,17) ) ) ).

tff(writeUnaryOperator_1901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32988(VarCurr)
    <=> v32964(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3040,axiom,
    ! [VarCurr: state_type] :
      ( v32982(VarCurr)
    <=> ( v32983(VarCurr)
        & v32985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3039,axiom,
    ! [VarCurr: state_type] :
      ( v32985(VarCurr)
    <=> ( v32962(VarCurr)
        | v32974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_368,axiom,
    ! [VarCurr: state_type] :
      ( v32983(VarCurr)
    <=> ( v32984(VarCurr)
        | v32875(VarCurr,18) ) ) ).

tff(writeUnaryOperator_1900,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32984(VarCurr)
    <=> v32962(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3038,axiom,
    ! [VarCurr: state_type] :
      ( v32978(VarCurr)
    <=> ( v32979(VarCurr)
        & v32981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3037,axiom,
    ! [VarCurr: state_type] :
      ( v32981(VarCurr)
    <=> ( v32960(VarCurr)
        | v32975(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_367,axiom,
    ! [VarCurr: state_type] :
      ( v32979(VarCurr)
    <=> ( v32980(VarCurr)
        | v32875(VarCurr,19) ) ) ).

tff(writeUnaryOperator_1899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32980(VarCurr)
    <=> v32960(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3036,axiom,
    ! [VarCurr: state_type] :
      ( v32955(VarCurr)
    <=> ( v32956(VarCurr)
        & v32976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3035,axiom,
    ! [VarCurr: state_type] :
      ( v32976(VarCurr)
    <=> ( v32958(VarCurr)
        | v32977(VarCurr) ) ) ).

tff(writeUnaryOperator_1898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32977(VarCurr)
    <=> v32875(VarCurr,20) ) ).

tff(writeBinaryOperatorShiftedRanges_366,axiom,
    ! [VarCurr: state_type] :
      ( v32956(VarCurr)
    <=> ( v32957(VarCurr)
        | v32875(VarCurr,20) ) ) ).

tff(writeUnaryOperator_1897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32957(VarCurr)
    <=> v32958(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_365,axiom,
    ! [VarCurr: state_type] :
      ( v32958(VarCurr)
    <=> ( v32875(VarCurr,19)
        | v32959(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3034,axiom,
    ! [VarCurr: state_type] :
      ( v32959(VarCurr)
    <=> ( v32960(VarCurr)
        & v32975(VarCurr) ) ) ).

tff(writeUnaryOperator_1896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32975(VarCurr)
    <=> v32875(VarCurr,19) ) ).

tff(writeBinaryOperatorShiftedRanges_364,axiom,
    ! [VarCurr: state_type] :
      ( v32960(VarCurr)
    <=> ( v32875(VarCurr,18)
        | v32961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3033,axiom,
    ! [VarCurr: state_type] :
      ( v32961(VarCurr)
    <=> ( v32962(VarCurr)
        & v32974(VarCurr) ) ) ).

tff(writeUnaryOperator_1895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32974(VarCurr)
    <=> v32875(VarCurr,18) ) ).

tff(writeBinaryOperatorShiftedRanges_363,axiom,
    ! [VarCurr: state_type] :
      ( v32962(VarCurr)
    <=> ( v32875(VarCurr,17)
        | v32963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3032,axiom,
    ! [VarCurr: state_type] :
      ( v32963(VarCurr)
    <=> ( v32964(VarCurr)
        & v32973(VarCurr) ) ) ).

tff(writeUnaryOperator_1894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32973(VarCurr)
    <=> v32875(VarCurr,17) ) ).

tff(writeBinaryOperatorShiftedRanges_362,axiom,
    ! [VarCurr: state_type] :
      ( v32964(VarCurr)
    <=> ( v32875(VarCurr,16)
        | v32965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3031,axiom,
    ! [VarCurr: state_type] :
      ( v32965(VarCurr)
    <=> ( v32966(VarCurr)
        & v32972(VarCurr) ) ) ).

tff(writeUnaryOperator_1893,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32972(VarCurr)
    <=> v32875(VarCurr,16) ) ).

tff(writeBinaryOperatorShiftedRanges_361,axiom,
    ! [VarCurr: state_type] :
      ( v32966(VarCurr)
    <=> ( v32875(VarCurr,15)
        | v32967(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3030,axiom,
    ! [VarCurr: state_type] :
      ( v32967(VarCurr)
    <=> ( v32968(VarCurr)
        & v32971(VarCurr) ) ) ).

tff(writeUnaryOperator_1892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32971(VarCurr)
    <=> v32875(VarCurr,15) ) ).

tff(writeBinaryOperatorShiftedRanges_360,axiom,
    ! [VarCurr: state_type] :
      ( v32968(VarCurr)
    <=> ( v32875(VarCurr,14)
        | v32969(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_359,axiom,
    ! [VarCurr: state_type] :
      ( v32969(VarCurr)
    <=> ( v32875(VarCurr,13)
        & v32970(VarCurr) ) ) ).

tff(writeUnaryOperator_1891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32970(VarCurr)
    <=> v32875(VarCurr,14) ) ).

tff(addAssignment_16585,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,20)
    <=> v32885(VarCurr,20) ) ).

tff(addAssignment_16584,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,20)
    <=> $false ) ).

tff(addAssignment_16583,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,20)
    <=> v32879(VarCurr,19) ) ).

tff(addAssignment_16582,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,19)
    <=> v32881(VarCurr,19) ) ).

tff(addAssignment_16581,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,19)
    <=> v32885(VarCurr,19) ) ).

tff(addAssignment_16580,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,19)
    <=> $false ) ).

tff(addAssignment_16579,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,19)
    <=> v32879(VarCurr,18) ) ).

tff(addAssignment_16578,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,18)
    <=> v32881(VarCurr,18) ) ).

tff(addAssignment_16577,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,18)
    <=> v32885(VarCurr,18) ) ).

tff(addAssignment_16576,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,18)
    <=> $false ) ).

tff(addAssignment_16575,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,18)
    <=> v32879(VarCurr,17) ) ).

tff(addAssignment_16574,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,17)
    <=> v32881(VarCurr,17) ) ).

tff(addAssignment_16573,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,17)
    <=> v32885(VarCurr,17) ) ).

tff(addAssignment_16572,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,17)
    <=> $false ) ).

tff(addAssignment_16571,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,17)
    <=> v32879(VarCurr,16) ) ).

tff(addAssignment_16570,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,16)
    <=> v32881(VarCurr,16) ) ).

tff(addAssignment_16569,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,16)
    <=> v32885(VarCurr,16) ) ).

tff(addAssignment_16568,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,16)
    <=> $false ) ).

tff(addAssignment_16567,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,16)
    <=> v32879(VarCurr,15) ) ).

tff(addAssignment_16566,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,15)
    <=> v32881(VarCurr,15) ) ).

tff(addAssignment_16565,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,15)
    <=> v32885(VarCurr,15) ) ).

tff(addAssignment_16564,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,15)
    <=> $false ) ).

tff(addAssignment_16563,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,15)
    <=> v32879(VarCurr,14) ) ).

tff(addAssignment_16562,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,14)
    <=> v32881(VarCurr,14) ) ).

tff(addAssignment_16561,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,14)
    <=> v32885(VarCurr,14) ) ).

tff(addAssignment_16560,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,14)
    <=> $false ) ).

tff(addAssignment_16559,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,14)
    <=> v32879(VarCurr,13) ) ).

tff(addAssignment_16558,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,13)
    <=> v32881(VarCurr,13) ) ).

tff(addAssignment_16557,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,13)
    <=> v32885(VarCurr,13) ) ).

tff(addAssignment_16556,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,13)
    <=> $true ) ).

tff(addAssignment_16555,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,13)
    <=> v32879(VarCurr,12) ) ).

tff(addAssignment_16554,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,12)
    <=> v32881(VarCurr,12) ) ).

tff(addAssignment_16553,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,0)
    <=> v32948(VarCurr) ) ).

tff(addAssignment_16552,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,1)
    <=> v32946(VarCurr) ) ).

tff(addAssignment_16551,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,2)
    <=> v32942(VarCurr) ) ).

tff(addAssignment_16550,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,3)
    <=> v32938(VarCurr) ) ).

tff(addAssignment_16549,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,4)
    <=> v32934(VarCurr) ) ).

tff(addAssignment_16548,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,5)
    <=> v32930(VarCurr) ) ).

tff(addAssignment_16547,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,6)
    <=> v32926(VarCurr) ) ).

tff(addAssignment_16546,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,7)
    <=> v32922(VarCurr) ) ).

tff(addAssignment_16545,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,8)
    <=> v32918(VarCurr) ) ).

tff(addAssignment_16544,axiom,
    ! [VarCurr: state_type] :
      ( v32873(VarCurr,9)
    <=> v32889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3029,axiom,
    ! [VarCurr: state_type] :
      ( v32946(VarCurr)
    <=> ( v32947(VarCurr)
        & v32949(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_358,axiom,
    ! [VarCurr: state_type] :
      ( v32949(VarCurr)
    <=> ( v32875(VarCurr,21)
        | v32908(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_357,axiom,
    ! [VarCurr: state_type] :
      ( v32947(VarCurr)
    <=> ( v32948(VarCurr)
        | v32875(VarCurr,22) ) ) ).

tff(writeUnaryOperator_1890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32948(VarCurr)
    <=> v32875(VarCurr,21) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3028,axiom,
    ! [VarCurr: state_type] :
      ( v32942(VarCurr)
    <=> ( v32943(VarCurr)
        & v32945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3027,axiom,
    ! [VarCurr: state_type] :
      ( v32945(VarCurr)
    <=> ( v32906(VarCurr)
        | v32909(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_356,axiom,
    ! [VarCurr: state_type] :
      ( v32943(VarCurr)
    <=> ( v32944(VarCurr)
        | v32875(VarCurr,23) ) ) ).

tff(writeUnaryOperator_1889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32944(VarCurr)
    <=> v32906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3026,axiom,
    ! [VarCurr: state_type] :
      ( v32938(VarCurr)
    <=> ( v32939(VarCurr)
        & v32941(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3025,axiom,
    ! [VarCurr: state_type] :
      ( v32941(VarCurr)
    <=> ( v32904(VarCurr)
        | v32910(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_355,axiom,
    ! [VarCurr: state_type] :
      ( v32939(VarCurr)
    <=> ( v32940(VarCurr)
        | v32875(VarCurr,24) ) ) ).

tff(writeUnaryOperator_1888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32940(VarCurr)
    <=> v32904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3024,axiom,
    ! [VarCurr: state_type] :
      ( v32934(VarCurr)
    <=> ( v32935(VarCurr)
        & v32937(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3023,axiom,
    ! [VarCurr: state_type] :
      ( v32937(VarCurr)
    <=> ( v32902(VarCurr)
        | v32911(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_354,axiom,
    ! [VarCurr: state_type] :
      ( v32935(VarCurr)
    <=> ( v32936(VarCurr)
        | v32875(VarCurr,25) ) ) ).

tff(writeUnaryOperator_1887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32936(VarCurr)
    <=> v32902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3022,axiom,
    ! [VarCurr: state_type] :
      ( v32930(VarCurr)
    <=> ( v32931(VarCurr)
        & v32933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3021,axiom,
    ! [VarCurr: state_type] :
      ( v32933(VarCurr)
    <=> ( v32900(VarCurr)
        | v32912(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_353,axiom,
    ! [VarCurr: state_type] :
      ( v32931(VarCurr)
    <=> ( v32932(VarCurr)
        | v32875(VarCurr,26) ) ) ).

tff(writeUnaryOperator_1886,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32932(VarCurr)
    <=> v32900(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3020,axiom,
    ! [VarCurr: state_type] :
      ( v32926(VarCurr)
    <=> ( v32927(VarCurr)
        & v32929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3019,axiom,
    ! [VarCurr: state_type] :
      ( v32929(VarCurr)
    <=> ( v32898(VarCurr)
        | v32913(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_352,axiom,
    ! [VarCurr: state_type] :
      ( v32927(VarCurr)
    <=> ( v32928(VarCurr)
        | v32875(VarCurr,27) ) ) ).

tff(writeUnaryOperator_1885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32928(VarCurr)
    <=> v32898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3018,axiom,
    ! [VarCurr: state_type] :
      ( v32922(VarCurr)
    <=> ( v32923(VarCurr)
        & v32925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3017,axiom,
    ! [VarCurr: state_type] :
      ( v32925(VarCurr)
    <=> ( v32896(VarCurr)
        | v32914(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_351,axiom,
    ! [VarCurr: state_type] :
      ( v32923(VarCurr)
    <=> ( v32924(VarCurr)
        | v32875(VarCurr,28) ) ) ).

tff(writeUnaryOperator_1884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32924(VarCurr)
    <=> v32896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3016,axiom,
    ! [VarCurr: state_type] :
      ( v32918(VarCurr)
    <=> ( v32919(VarCurr)
        & v32921(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3015,axiom,
    ! [VarCurr: state_type] :
      ( v32921(VarCurr)
    <=> ( v32894(VarCurr)
        | v32915(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_350,axiom,
    ! [VarCurr: state_type] :
      ( v32919(VarCurr)
    <=> ( v32920(VarCurr)
        | v32875(VarCurr,29) ) ) ).

tff(writeUnaryOperator_1883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32920(VarCurr)
    <=> v32894(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3014,axiom,
    ! [VarCurr: state_type] :
      ( v32889(VarCurr)
    <=> ( v32890(VarCurr)
        & v32916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3013,axiom,
    ! [VarCurr: state_type] :
      ( v32916(VarCurr)
    <=> ( v32892(VarCurr)
        | v32917(VarCurr) ) ) ).

tff(writeUnaryOperator_1882,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32917(VarCurr)
    <=> v32875(VarCurr,30) ) ).

tff(writeBinaryOperatorShiftedRanges_349,axiom,
    ! [VarCurr: state_type] :
      ( v32890(VarCurr)
    <=> ( v32891(VarCurr)
        | v32875(VarCurr,30) ) ) ).

tff(writeUnaryOperator_1881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32891(VarCurr)
    <=> v32892(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_348,axiom,
    ! [VarCurr: state_type] :
      ( v32892(VarCurr)
    <=> ( v32875(VarCurr,29)
        | v32893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3012,axiom,
    ! [VarCurr: state_type] :
      ( v32893(VarCurr)
    <=> ( v32894(VarCurr)
        & v32915(VarCurr) ) ) ).

tff(writeUnaryOperator_1880,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32915(VarCurr)
    <=> v32875(VarCurr,29) ) ).

tff(writeBinaryOperatorShiftedRanges_347,axiom,
    ! [VarCurr: state_type] :
      ( v32894(VarCurr)
    <=> ( v32875(VarCurr,28)
        | v32895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3011,axiom,
    ! [VarCurr: state_type] :
      ( v32895(VarCurr)
    <=> ( v32896(VarCurr)
        & v32914(VarCurr) ) ) ).

tff(writeUnaryOperator_1879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32914(VarCurr)
    <=> v32875(VarCurr,28) ) ).

tff(writeBinaryOperatorShiftedRanges_346,axiom,
    ! [VarCurr: state_type] :
      ( v32896(VarCurr)
    <=> ( v32875(VarCurr,27)
        | v32897(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3010,axiom,
    ! [VarCurr: state_type] :
      ( v32897(VarCurr)
    <=> ( v32898(VarCurr)
        & v32913(VarCurr) ) ) ).

tff(writeUnaryOperator_1878,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32913(VarCurr)
    <=> v32875(VarCurr,27) ) ).

tff(writeBinaryOperatorShiftedRanges_345,axiom,
    ! [VarCurr: state_type] :
      ( v32898(VarCurr)
    <=> ( v32875(VarCurr,26)
        | v32899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3009,axiom,
    ! [VarCurr: state_type] :
      ( v32899(VarCurr)
    <=> ( v32900(VarCurr)
        & v32912(VarCurr) ) ) ).

tff(writeUnaryOperator_1877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32912(VarCurr)
    <=> v32875(VarCurr,26) ) ).

tff(writeBinaryOperatorShiftedRanges_344,axiom,
    ! [VarCurr: state_type] :
      ( v32900(VarCurr)
    <=> ( v32875(VarCurr,25)
        | v32901(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3008,axiom,
    ! [VarCurr: state_type] :
      ( v32901(VarCurr)
    <=> ( v32902(VarCurr)
        & v32911(VarCurr) ) ) ).

tff(writeUnaryOperator_1876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32911(VarCurr)
    <=> v32875(VarCurr,25) ) ).

tff(writeBinaryOperatorShiftedRanges_343,axiom,
    ! [VarCurr: state_type] :
      ( v32902(VarCurr)
    <=> ( v32875(VarCurr,24)
        | v32903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3007,axiom,
    ! [VarCurr: state_type] :
      ( v32903(VarCurr)
    <=> ( v32904(VarCurr)
        & v32910(VarCurr) ) ) ).

tff(writeUnaryOperator_1875,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32910(VarCurr)
    <=> v32875(VarCurr,24) ) ).

tff(writeBinaryOperatorShiftedRanges_342,axiom,
    ! [VarCurr: state_type] :
      ( v32904(VarCurr)
    <=> ( v32875(VarCurr,23)
        | v32905(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3006,axiom,
    ! [VarCurr: state_type] :
      ( v32905(VarCurr)
    <=> ( v32906(VarCurr)
        & v32909(VarCurr) ) ) ).

tff(writeUnaryOperator_1874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32909(VarCurr)
    <=> v32875(VarCurr,23) ) ).

tff(writeBinaryOperatorShiftedRanges_341,axiom,
    ! [VarCurr: state_type] :
      ( v32906(VarCurr)
    <=> ( v32875(VarCurr,22)
        | v32907(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_340,axiom,
    ! [VarCurr: state_type] :
      ( v32907(VarCurr)
    <=> ( v32875(VarCurr,21)
        & v32908(VarCurr) ) ) ).

tff(writeUnaryOperator_1873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32908(VarCurr)
    <=> v32875(VarCurr,22) ) ).

tff(addAssignment_16543,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,30)
    <=> v32885(VarCurr,30) ) ).

tff(addAssignment_16542,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_16541,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,30)
    <=> v32879(VarCurr,29) ) ).

tff(addAssignment_16540,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,29)
    <=> v32881(VarCurr,29) ) ).

tff(addAssignment_16539,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,29)
    <=> v32885(VarCurr,29) ) ).

tff(addAssignment_16538,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,29)
    <=> $false ) ).

tff(addAssignment_16537,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,29)
    <=> v32879(VarCurr,28) ) ).

tff(addAssignment_16536,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,28)
    <=> v32881(VarCurr,28) ) ).

tff(addAssignment_16535,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,28)
    <=> v32885(VarCurr,28) ) ).

tff(addAssignment_16534,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,28)
    <=> $true ) ).

tff(addAssignment_16533,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,28)
    <=> v32879(VarCurr,27) ) ).

tff(addAssignment_16532,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,27)
    <=> v32881(VarCurr,27) ) ).

tff(addAssignment_16531,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,27)
    <=> v32885(VarCurr,27) ) ).

tff(addAssignment_16530,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,27)
    <=> $true ) ).

tff(addAssignment_16529,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,27)
    <=> v32879(VarCurr,26) ) ).

tff(addAssignment_16528,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,26)
    <=> v32881(VarCurr,26) ) ).

tff(addAssignment_16527,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,26)
    <=> v32885(VarCurr,26) ) ).

tff(addAssignment_16526,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,26)
    <=> $false ) ).

tff(addAssignment_16525,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,26)
    <=> v32879(VarCurr,25) ) ).

tff(addAssignment_16524,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,25)
    <=> v32881(VarCurr,25) ) ).

tff(addAssignment_16523,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,25)
    <=> v32885(VarCurr,25) ) ).

tff(addAssignment_16522,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,25)
    <=> $false ) ).

tff(addAssignment_16521,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,25)
    <=> v32879(VarCurr,24) ) ).

tff(addAssignment_16520,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,24)
    <=> v32881(VarCurr,24) ) ).

tff(addAssignment_16519,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,24)
    <=> v32885(VarCurr,24) ) ).

tff(addAssignment_16518,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,24)
    <=> $true ) ).

tff(addAssignment_16517,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,24)
    <=> v32879(VarCurr,23) ) ).

tff(addAssignment_16516,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,23)
    <=> v32881(VarCurr,23) ) ).

tff(addAssignment_16515,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,23)
    <=> v32885(VarCurr,23) ) ).

tff(addAssignment_16514,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,23)
    <=> $false ) ).

tff(addAssignment_16513,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,23)
    <=> v32879(VarCurr,22) ) ).

tff(addAssignment_16512,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,22)
    <=> v32881(VarCurr,22) ) ).

tff(addAssignment_16511,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,22)
    <=> v32885(VarCurr,22) ) ).

tff(addAssignment_16510,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,22)
    <=> $false ) ).

tff(addAssignment_16509,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,22)
    <=> v32879(VarCurr,21) ) ).

tff(addAssignment_16508,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,21)
    <=> v32881(VarCurr,21) ) ).

tff(addAssignment_16507,axiom,
    ! [VarCurr: state_type] :
      ( v32875(VarCurr,21)
    <=> v32885(VarCurr,21) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,0) )
     => ( v32885(VarCurr,B)
      <=> ( v32877(VarCurr,B)
        <~> v32883(VarCurr,B) ) ) ) ).

tff(addAssignment_16506,axiom,
    ! [VarCurr: state_type] :
      ( v32883(VarCurr,21)
    <=> $false ) ).

tff(bitBlastConstant_793,axiom,
    ~ b0011001000000000010100000000100(30) ).

tff(bitBlastConstant_792,axiom,
    ~ b0011001000000000010100000000100(29) ).

tff(bitBlastConstant_791,axiom,
    b0011001000000000010100000000100(28) ).

tff(bitBlastConstant_790,axiom,
    b0011001000000000010100000000100(27) ).

tff(bitBlastConstant_789,axiom,
    ~ b0011001000000000010100000000100(26) ).

tff(bitBlastConstant_788,axiom,
    ~ b0011001000000000010100000000100(25) ).

tff(bitBlastConstant_787,axiom,
    b0011001000000000010100000000100(24) ).

tff(bitBlastConstant_786,axiom,
    ~ b0011001000000000010100000000100(23) ).

tff(bitBlastConstant_785,axiom,
    ~ b0011001000000000010100000000100(22) ).

tff(bitBlastConstant_784,axiom,
    ~ b0011001000000000010100000000100(21) ).

tff(bitBlastConstant_783,axiom,
    ~ b0011001000000000010100000000100(20) ).

tff(bitBlastConstant_782,axiom,
    ~ b0011001000000000010100000000100(19) ).

tff(bitBlastConstant_781,axiom,
    ~ b0011001000000000010100000000100(18) ).

tff(bitBlastConstant_780,axiom,
    ~ b0011001000000000010100000000100(17) ).

tff(bitBlastConstant_779,axiom,
    ~ b0011001000000000010100000000100(16) ).

tff(bitBlastConstant_778,axiom,
    ~ b0011001000000000010100000000100(15) ).

tff(bitBlastConstant_777,axiom,
    ~ b0011001000000000010100000000100(14) ).

tff(bitBlastConstant_776,axiom,
    b0011001000000000010100000000100(13) ).

tff(bitBlastConstant_775,axiom,
    ~ b0011001000000000010100000000100(12) ).

tff(bitBlastConstant_774,axiom,
    b0011001000000000010100000000100(11) ).

tff(bitBlastConstant_773,axiom,
    ~ b0011001000000000010100000000100(10) ).

tff(bitBlastConstant_772,axiom,
    ~ b0011001000000000010100000000100(9) ).

tff(bitBlastConstant_771,axiom,
    ~ b0011001000000000010100000000100(8) ).

tff(bitBlastConstant_770,axiom,
    ~ b0011001000000000010100000000100(7) ).

tff(bitBlastConstant_769,axiom,
    ~ b0011001000000000010100000000100(6) ).

tff(bitBlastConstant_768,axiom,
    ~ b0011001000000000010100000000100(5) ).

tff(bitBlastConstant_767,axiom,
    ~ b0011001000000000010100000000100(4) ).

tff(bitBlastConstant_766,axiom,
    ~ b0011001000000000010100000000100(3) ).

tff(bitBlastConstant_765,axiom,
    b0011001000000000010100000000100(2) ).

tff(bitBlastConstant_764,axiom,
    ~ b0011001000000000010100000000100(1) ).

tff(bitBlastConstant_763,axiom,
    ~ b0011001000000000010100000000100(0) ).

tff(addAssignment_16505,axiom,
    ! [VarCurr: state_type] :
      ( v32877(VarCurr,21)
    <=> v32879(VarCurr,20) ) ).

tff(addAssignment_16504,axiom,
    ! [VarCurr: state_type] :
      ( v32879(VarCurr,20)
    <=> v32881(VarCurr,20) ) ).

tff(addAssignment_16503,axiom,
    ! [VarCurr: state_type] :
      ( v32861(VarCurr)
    <=> v32863(VarCurr) ) ).

tff(addAssignment_16502,axiom,
    ! [VarCurr: state_type] :
      ( v32863(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16501,axiom,
    ! [VarCurr: state_type] :
      ( v32857(VarCurr)
    <=> v32859(VarCurr) ) ).

tff(addAssignment_16500,axiom,
    ! [VarCurr: state_type] :
      ( v32859(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3005,axiom,
    ! [VarCurr: state_type] :
      ( v32752(VarCurr)
    <=> ( v32841(VarCurr)
        & v32847(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_157,axiom,
    ! [VarCurr: state_type] :
      ( v32847(VarCurr)
    <=> ( ( v32754(VarCurr,3)
        <=> $true )
        & ( v32754(VarCurr,2)
        <=> $true )
        & ( v32754(VarCurr,1)
        <=> $true )
        & ( v32754(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3004,axiom,
    ! [VarCurr: state_type] :
      ( v32841(VarCurr)
    <=> ( v32842(VarCurr)
        & v32846(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_156,axiom,
    ! [VarCurr: state_type] :
      ( v32846(VarCurr)
    <=> ( ( v30967(VarCurr,15)
        <=> $false )
        & ( v30967(VarCurr,14)
        <=> $false )
        & ( v30967(VarCurr,13)
        <=> $false )
        & ( v30967(VarCurr,12)
        <=> $false )
        & ( v30967(VarCurr,11)
        <=> $false )
        & ( v30967(VarCurr,10)
        <=> $false )
        & ( v30967(VarCurr,9)
        <=> $false )
        & ( v30967(VarCurr,8)
        <=> $false )
        & ( v30967(VarCurr,7)
        <=> $false )
        & ( v30967(VarCurr,6)
        <=> $false )
        & ( v30967(VarCurr,5)
        <=> $false )
        & ( v30967(VarCurr,4)
        <=> $false )
        & ( v30967(VarCurr,3)
        <=> $false )
        & ( v30967(VarCurr,2)
        <=> $false )
        & ( v30967(VarCurr,1)
        <=> $false )
        & ( v30967(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3003,axiom,
    ! [VarCurr: state_type] :
      ( v32842(VarCurr)
    <=> ( v30965(VarCurr)
        & v32843(VarCurr) ) ) ).

tff(writeUnaryOperator_1872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32843(VarCurr)
    <=> v32844(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_339,axiom,
    ! [VarCurr: state_type] :
      ( v32844(VarCurr)
    <=> ( v32728(VarCurr,0)
        | v32728(VarCurr,1) ) ) ).

tff(addAssignment_16499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32754(VarCurr,B)
      <=> v32756(VarCurr,B) ) ) ).

tff(addAssignment_16498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32756(VarCurr,B)
      <=> v32758(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32824(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v32758(VarNext,B)
            <=> v32758(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_385,axiom,
    ! [VarNext: state_type] :
      ( v32824(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32758(VarNext,B)
          <=> v32834(VarNext,B) ) ) ) ).

tff(addAssignment_16497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32834(VarNext,B)
          <=> v32832(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32835(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32832(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_245,axiom,
    ! [VarCurr: state_type] :
      ( v32835(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32832(VarCurr,B)
          <=> v32768(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3002,axiom,
    ! [VarCurr: state_type] :
      ( v32835(VarCurr)
    <=> ( v32836(VarCurr)
        & v32837(VarCurr) ) ) ).

tff(writeUnaryOperator_1871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32837(VarCurr)
    <=> v32764(VarCurr) ) ).

tff(writeUnaryOperator_1870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32836(VarCurr)
    <=> v32760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32824(VarNext)
      <=> v32825(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32825(VarNext)
      <=> ( v32826(VarNext)
          & v32819(VarNext) ) ) ) ).

tff(writeUnaryOperator_1869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32826(VarNext)
      <=> v32828(VarNext) ) ) ).

tff(addAssignment_16496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32828(VarNext)
      <=> v32819(VarCurr) ) ) ).

tff(addAssignment_16495,axiom,
    ! [VarCurr: state_type] :
      ( v32819(VarCurr)
    <=> v32821(VarCurr) ) ).

tff(addAssignment_16494,axiom,
    ! [VarCurr: state_type] :
      ( v32821(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32768(VarCurr,B)
      <=> v32770(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32770(VarCurr,B)
      <=> ( v32772(VarCurr,B)
          & v32815(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1868,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32815(VarCurr,B)
      <=> ~ v32816(VarCurr,B) ) ) ).

tff(addAssignment_16492,axiom,
    ! [VarCurr: state_type] :
      ( v32816(VarCurr,0)
    <=> v32817(VarCurr) ) ).

tff(addAssignment_16491,axiom,
    ! [VarCurr: state_type] :
      ( v32816(VarCurr,1)
    <=> v32817(VarCurr) ) ).

tff(addAssignment_16490,axiom,
    ! [VarCurr: state_type] :
      ( v32816(VarCurr,2)
    <=> v32817(VarCurr) ) ).

tff(addAssignment_16489,axiom,
    ! [VarCurr: state_type] :
      ( v32816(VarCurr,3)
    <=> v32817(VarCurr) ) ).

tff(addAssignment_16488,axiom,
    ! [VarCurr: state_type] :
      ( v32817(VarCurr)
    <=> v32813(VarCurr) ) ).

tff(addAssignment_16487,axiom,
    ! [VarCurr: state_type] :
      ( v32813(VarCurr)
    <=> v32577(VarCurr) ) ).

tff(addAssignment_16486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32772(VarCurr,B)
      <=> v32774(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32782(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32774(VarCurr,B)
          <=> v32785(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_244,axiom,
    ! [VarCurr: state_type] :
      ( v32782(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32774(VarCurr,B)
          <=> $false ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32786(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32785(VarCurr,B)
          <=> v32754(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_243,axiom,
    ! [VarCurr: state_type] :
      ( v32786(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32785(VarCurr,B)
          <=> v32794(VarCurr,B) ) ) ) ).

tff(addAssignment_16485,axiom,
    ! [VarCurr: state_type] :
      ( v32794(VarCurr,0)
    <=> v32809(VarCurr) ) ).

tff(addAssignment_16484,axiom,
    ! [VarCurr: state_type] :
      ( v32794(VarCurr,1)
    <=> v32807(VarCurr) ) ).

tff(addAssignment_16483,axiom,
    ! [VarCurr: state_type] :
      ( v32794(VarCurr,2)
    <=> v32802(VarCurr) ) ).

tff(addAssignment_16482,axiom,
    ! [VarCurr: state_type] :
      ( v32794(VarCurr,3)
    <=> v32796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2999,axiom,
    ! [VarCurr: state_type] :
      ( v32807(VarCurr)
    <=> ( v32808(VarCurr)
        & v32811(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_338,axiom,
    ! [VarCurr: state_type] :
      ( v32811(VarCurr)
    <=> ( v32754(VarCurr,0)
        | v32754(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2998,axiom,
    ! [VarCurr: state_type] :
      ( v32808(VarCurr)
    <=> ( v32809(VarCurr)
        | v32810(VarCurr) ) ) ).

tff(writeUnaryOperator_1867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32810(VarCurr)
    <=> v32754(VarCurr,1) ) ).

tff(writeUnaryOperator_1866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32809(VarCurr)
    <=> v32754(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2997,axiom,
    ! [VarCurr: state_type] :
      ( v32802(VarCurr)
    <=> ( v32803(VarCurr)
        & v32806(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_337,axiom,
    ! [VarCurr: state_type] :
      ( v32806(VarCurr)
    <=> ( v32754(VarCurr,2)
        | v32793(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2996,axiom,
    ! [VarCurr: state_type] :
      ( v32803(VarCurr)
    <=> ( v32804(VarCurr)
        | v32805(VarCurr) ) ) ).

tff(writeUnaryOperator_1865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32805(VarCurr)
    <=> v32793(VarCurr) ) ).

tff(writeUnaryOperator_1864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32804(VarCurr)
    <=> v32754(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2995,axiom,
    ! [VarCurr: state_type] :
      ( v32796(VarCurr)
    <=> ( v32797(VarCurr)
        & v32801(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_336,axiom,
    ! [VarCurr: state_type] :
      ( v32801(VarCurr)
    <=> ( v32754(VarCurr,3)
        | v32800(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2994,axiom,
    ! [VarCurr: state_type] :
      ( v32797(VarCurr)
    <=> ( v32798(VarCurr)
        | v32799(VarCurr) ) ) ).

tff(writeUnaryOperator_1863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32799(VarCurr)
    <=> v32800(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_335,axiom,
    ! [VarCurr: state_type] :
      ( v32800(VarCurr)
    <=> ( v32754(VarCurr,2)
        & v32793(VarCurr) ) ) ).

tff(writeUnaryOperator_1862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32798(VarCurr)
    <=> v32754(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2993,axiom,
    ! [VarCurr: state_type] :
      ( v32786(VarCurr)
    <=> ( v32787(VarCurr)
        & v32789(VarCurr) ) ) ).

tff(writeUnaryOperator_1861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32789(VarCurr)
    <=> v32791(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_334,axiom,
    ! [VarCurr: state_type] :
      ( v32791(VarCurr)
    <=> ( v32792(VarCurr)
        & v32754(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_333,axiom,
    ! [VarCurr: state_type] :
      ( v32792(VarCurr)
    <=> ( v32793(VarCurr)
        & v32754(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_332,axiom,
    ! [VarCurr: state_type] :
      ( v32793(VarCurr)
    <=> ( v32754(VarCurr,0)
        & v32754(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2992,axiom,
    ! [VarCurr: state_type] :
      ( v32787(VarCurr)
    <=> ( v32788(VarCurr)
        & v32776(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_155,axiom,
    ! [VarCurr: state_type] :
      ( v32788(VarCurr)
    <=> ( ( v2388(VarCurr,5)
        <=> $false )
        & ( v2388(VarCurr,4)
        <=> $false )
        & ( v2388(VarCurr,3)
        <=> $false )
        & ( v2388(VarCurr,2)
        <=> $false )
        & ( v2388(VarCurr,1)
        <=> $false )
        & ( v2388(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2991,axiom,
    ! [VarCurr: state_type] :
      ( v32782(VarCurr)
    <=> ( v32783(VarCurr)
        & v32784(VarCurr) ) ) ).

tff(writeUnaryOperator_1860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32784(VarCurr)
    <=> v32776(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_154,axiom,
    ! [VarCurr: state_type] :
      ( v32783(VarCurr)
    <=> ( ( v2388(VarCurr,5)
        <=> $false )
        & ( v2388(VarCurr,4)
        <=> $false )
        & ( v2388(VarCurr,3)
        <=> $false )
        & ( v2388(VarCurr,2)
        <=> $false )
        & ( v2388(VarCurr,1)
        <=> $false )
        & ( v2388(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16481,axiom,
    ! [VarCurr: state_type] :
      ( v32776(VarCurr)
    <=> v32778(VarCurr) ) ).

tff(addAssignment_16480,axiom,
    ! [VarCurr: state_type] :
      ( v32778(VarCurr)
    <=> v32780(VarCurr) ) ).

tff(addAssignment_16479,axiom,
    ! [VarCurr: state_type] :
      ( v32764(VarCurr)
    <=> v32766(VarCurr) ) ).

tff(addAssignment_16478,axiom,
    ! [VarCurr: state_type] :
      ( v32766(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16477,axiom,
    ! [VarCurr: state_type] :
      ( v32760(VarCurr)
    <=> v32762(VarCurr) ) ).

tff(addAssignment_16476,axiom,
    ! [VarCurr: state_type] :
      ( v32762(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16475,axiom,
    ! [VarCurr: state_type] :
      ( v32738(VarCurr)
    <=> v32740(VarCurr) ) ).

tff(addAssignment_16474,axiom,
    ! [VarCurr: state_type] :
      ( v32740(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16473,axiom,
    ! [VarCurr: state_type] :
      ( v32734(VarCurr)
    <=> v32736(VarCurr) ) ).

tff(addAssignment_16472,axiom,
    ! [VarCurr: state_type] :
      ( v32736(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16471,axiom,
    ! [VarCurr: state_type] :
      ( v32633(VarCurr)
    <=> v32635(VarCurr) ) ).

tff(addAssignment_16470,axiom,
    ! [VarCurr: state_type] :
      ( v32635(VarCurr)
    <=> v32637(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_384,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32711(VarNext)
       => ( v32637(VarNext)
        <=> v32637(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_384,axiom,
    ! [VarNext: state_type] :
      ( v32711(VarNext)
     => ( v32637(VarNext)
      <=> v32721(VarNext) ) ) ).

tff(addAssignment_16469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32721(VarNext)
      <=> v32719(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32722(VarCurr)
     => ( v32719(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_242,axiom,
    ! [VarCurr: state_type] :
      ( v32722(VarCurr)
     => ( v32719(VarCurr)
      <=> v32647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2990,axiom,
    ! [VarCurr: state_type] :
      ( v32722(VarCurr)
    <=> ( v32723(VarCurr)
        & v32724(VarCurr) ) ) ).

tff(writeUnaryOperator_1859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32724(VarCurr)
    <=> v32643(VarCurr) ) ).

tff(writeUnaryOperator_1858,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32723(VarCurr)
    <=> v32639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32711(VarNext)
      <=> v32712(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32712(VarNext)
      <=> ( v32713(VarNext)
          & v32706(VarNext) ) ) ) ).

tff(writeUnaryOperator_1857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32713(VarNext)
      <=> v32715(VarNext) ) ) ).

tff(addAssignment_16468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32715(VarNext)
      <=> v32706(VarCurr) ) ) ).

tff(addAssignment_16467,axiom,
    ! [VarCurr: state_type] :
      ( v32706(VarCurr)
    <=> v32708(VarCurr) ) ).

tff(addAssignment_16466,axiom,
    ! [VarCurr: state_type] :
      ( v32708(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16465,axiom,
    ! [VarCurr: state_type] :
      ( v32647(VarCurr)
    <=> v32649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2987,axiom,
    ! [VarCurr: state_type] :
      ( v32649(VarCurr)
    <=> ( v32698(VarCurr)
        | v32701(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2986,axiom,
    ! [VarCurr: state_type] :
      ( v32701(VarCurr)
    <=> ( v32635(VarCurr)
        & v32702(VarCurr) ) ) ).

tff(writeUnaryOperator_1856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32702(VarCurr)
    <=> v32703(VarCurr) ) ).

tff(addAssignment_16464,axiom,
    ! [VarCurr: state_type] :
      ( v32703(VarCurr)
    <=> v32704(VarCurr) ) ).

tff(addAssignment_16463,axiom,
    ! [VarCurr: state_type] :
      ( v32704(VarCurr)
    <=> v32679(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2985,axiom,
    ! [VarCurr: state_type] :
      ( v32698(VarCurr)
    <=> ( v32651(VarCurr)
        & v32699(VarCurr) ) ) ).

tff(addAssignment_16462,axiom,
    ! [VarCurr: state_type] :
      ( v32699(VarCurr)
    <=> v32700(VarCurr) ) ).

tff(addAssignment_16461,axiom,
    ! [VarCurr: state_type] :
      ( v32700(VarCurr)
    <=> v32679(VarCurr) ) ).

tff(addAssignment_16460,axiom,
    ! [VarCurr: state_type] :
      ( v32679(VarCurr)
    <=> v32681(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2984,axiom,
    ! [VarCurr: state_type] :
      ( v32681(VarCurr)
    <=> ( v32684(VarCurr)
        | v32695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2983,axiom,
    ! [VarCurr: state_type] :
      ( v32695(VarCurr)
    <=> ( v2354(VarCurr)
        & v32696(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_153,axiom,
    ! [VarCurr: state_type] :
      ( v32696(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_762,axiom,
    ~ b0100001010000(12) ).

tff(bitBlastConstant_761,axiom,
    b0100001010000(11) ).

tff(bitBlastConstant_760,axiom,
    ~ b0100001010000(10) ).

tff(bitBlastConstant_759,axiom,
    ~ b0100001010000(9) ).

tff(bitBlastConstant_758,axiom,
    ~ b0100001010000(8) ).

tff(bitBlastConstant_757,axiom,
    ~ b0100001010000(7) ).

tff(bitBlastConstant_756,axiom,
    b0100001010000(6) ).

tff(bitBlastConstant_755,axiom,
    ~ b0100001010000(5) ).

tff(bitBlastConstant_754,axiom,
    b0100001010000(4) ).

tff(bitBlastConstant_753,axiom,
    ~ b0100001010000(3) ).

tff(bitBlastConstant_752,axiom,
    ~ b0100001010000(2) ).

tff(bitBlastConstant_751,axiom,
    ~ b0100001010000(1) ).

tff(bitBlastConstant_750,axiom,
    ~ b0100001010000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2982,axiom,
    ! [VarCurr: state_type] :
      ( v32684(VarCurr)
    <=> ( v32685(VarCurr)
        | v32691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2981,axiom,
    ! [VarCurr: state_type] :
      ( v32691(VarCurr)
    <=> ( v32692(VarCurr)
        & v32694(VarCurr) ) ) ).

tff(writeUnaryOperator_1855,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32694(VarCurr)
    <=> v32674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2980,axiom,
    ! [VarCurr: state_type] :
      ( v32692(VarCurr)
    <=> ( v32577(VarCurr)
        & v32693(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_152,axiom,
    ! [VarCurr: state_type] :
      ( v32693(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $false )
        & ( v4221(VarCurr,1)
        <=> $false )
        & ( v4221(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2979,axiom,
    ! [VarCurr: state_type] :
      ( v32685(VarCurr)
    <=> ( v32686(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2978,axiom,
    ! [VarCurr: state_type] :
      ( v32686(VarCurr)
    <=> ( v32687(VarCurr)
        | v4280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2977,axiom,
    ! [VarCurr: state_type] :
      ( v32687(VarCurr)
    <=> ( v32688(VarCurr)
        & v32690(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_151,axiom,
    ! [VarCurr: state_type] :
      ( v32690(VarCurr)
    <=> ( ( v32655(VarCurr,19)
        <=> $false )
        & ( v32655(VarCurr,18)
        <=> $false )
        & ( v32655(VarCurr,17)
        <=> $false )
        & ( v32655(VarCurr,16)
        <=> $false )
        & ( v32655(VarCurr,15)
        <=> $false )
        & ( v32655(VarCurr,14)
        <=> $false )
        & ( v32655(VarCurr,13)
        <=> $false )
        & ( v32655(VarCurr,12)
        <=> $false )
        & ( v32655(VarCurr,11)
        <=> $false )
        & ( v32655(VarCurr,10)
        <=> $false )
        & ( v32655(VarCurr,9)
        <=> $false )
        & ( v32655(VarCurr,8)
        <=> $false )
        & ( v32655(VarCurr,7)
        <=> $false )
        & ( v32655(VarCurr,6)
        <=> $false )
        & ( v32655(VarCurr,5)
        <=> $false )
        & ( v32655(VarCurr,4)
        <=> $false )
        & ( v32655(VarCurr,3)
        <=> $false )
        & ( v32655(VarCurr,2)
        <=> $false )
        & ( v32655(VarCurr,1)
        <=> $false )
        & ( v32655(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2976,axiom,
    ! [VarCurr: state_type] :
      ( v32688(VarCurr)
    <=> ( v4263(VarCurr)
        & v32689(VarCurr) ) ) ).

tff(writeUnaryOperator_1854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32689(VarCurr)
    <=> v32633(VarCurr) ) ).

tff(addAssignment_16459,axiom,
    ! [VarCurr: state_type] :
      ( v32651(VarCurr)
    <=> v32653(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32662(VarCurr)
     => ( v32653(VarCurr)
      <=> v32666(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_241,axiom,
    ! [VarCurr: state_type] :
      ( v32662(VarCurr)
     => ( v32653(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32667(VarCurr)
     => ( v32666(VarCurr)
      <=> v2363(VarCurr,0) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_240,axiom,
    ! [VarCurr: state_type] :
      ( v32667(VarCurr)
     => ( v32666(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2975,axiom,
    ! [VarCurr: state_type] :
      ( v32667(VarCurr)
    <=> ( v32668(VarCurr)
        | v32669(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2974,axiom,
    ! [VarCurr: state_type] :
      ( v32669(VarCurr)
    <=> ( v32670(VarCurr)
        & v32672(VarCurr) ) ) ).

tff(writeUnaryOperator_1853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32672(VarCurr)
    <=> v32674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2973,axiom,
    ! [VarCurr: state_type] :
      ( v32674(VarCurr)
    <=> ( v32675(VarCurr)
        & v32677(VarCurr) ) ) ).

tff(writeUnaryOperator_1852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32677(VarCurr)
    <=> v4201(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2972,axiom,
    ! [VarCurr: state_type] :
      ( v32675(VarCurr)
    <=> ( v4201(VarCurr,0)
        & v32676(VarCurr) ) ) ).

tff(writeUnaryOperator_1851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32676(VarCurr)
    <=> v4201(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2971,axiom,
    ! [VarCurr: state_type] :
      ( v32670(VarCurr)
    <=> ( v32577(VarCurr)
        & v32671(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_150,axiom,
    ! [VarCurr: state_type] :
      ( v32671(VarCurr)
    <=> ( ( v4221(VarCurr,2)
        <=> $false )
        & ( v4221(VarCurr,1)
        <=> $false )
        & ( v4221(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2970,axiom,
    ! [VarCurr: state_type] :
      ( v32668(VarCurr)
    <=> ( v4280(VarCurr)
        | v4266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2969,axiom,
    ! [VarCurr: state_type] :
      ( v32662(VarCurr)
    <=> ( v32663(VarCurr)
        & v32665(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_149,axiom,
    ! [VarCurr: state_type] :
      ( v32665(VarCurr)
    <=> ( ( v32655(VarCurr,19)
        <=> $false )
        & ( v32655(VarCurr,18)
        <=> $false )
        & ( v32655(VarCurr,17)
        <=> $false )
        & ( v32655(VarCurr,16)
        <=> $false )
        & ( v32655(VarCurr,15)
        <=> $false )
        & ( v32655(VarCurr,14)
        <=> $false )
        & ( v32655(VarCurr,13)
        <=> $false )
        & ( v32655(VarCurr,12)
        <=> $false )
        & ( v32655(VarCurr,11)
        <=> $false )
        & ( v32655(VarCurr,10)
        <=> $false )
        & ( v32655(VarCurr,9)
        <=> $false )
        & ( v32655(VarCurr,8)
        <=> $false )
        & ( v32655(VarCurr,7)
        <=> $false )
        & ( v32655(VarCurr,6)
        <=> $false )
        & ( v32655(VarCurr,5)
        <=> $false )
        & ( v32655(VarCurr,4)
        <=> $false )
        & ( v32655(VarCurr,3)
        <=> $false )
        & ( v32655(VarCurr,2)
        <=> $false )
        & ( v32655(VarCurr,1)
        <=> $false )
        & ( v32655(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_749,axiom,
    ~ b00000000000000000000(19) ).

tff(bitBlastConstant_748,axiom,
    ~ b00000000000000000000(18) ).

tff(bitBlastConstant_747,axiom,
    ~ b00000000000000000000(17) ).

tff(bitBlastConstant_746,axiom,
    ~ b00000000000000000000(16) ).

tff(bitBlastConstant_745,axiom,
    ~ b00000000000000000000(15) ).

tff(bitBlastConstant_744,axiom,
    ~ b00000000000000000000(14) ).

tff(bitBlastConstant_743,axiom,
    ~ b00000000000000000000(13) ).

tff(bitBlastConstant_742,axiom,
    ~ b00000000000000000000(12) ).

tff(bitBlastConstant_741,axiom,
    ~ b00000000000000000000(11) ).

tff(bitBlastConstant_740,axiom,
    ~ b00000000000000000000(10) ).

tff(bitBlastConstant_739,axiom,
    ~ b00000000000000000000(9) ).

tff(bitBlastConstant_738,axiom,
    ~ b00000000000000000000(8) ).

tff(bitBlastConstant_737,axiom,
    ~ b00000000000000000000(7) ).

tff(bitBlastConstant_736,axiom,
    ~ b00000000000000000000(6) ).

tff(bitBlastConstant_735,axiom,
    ~ b00000000000000000000(5) ).

tff(bitBlastConstant_734,axiom,
    ~ b00000000000000000000(4) ).

tff(bitBlastConstant_733,axiom,
    ~ b00000000000000000000(3) ).

tff(bitBlastConstant_732,axiom,
    ~ b00000000000000000000(2) ).

tff(bitBlastConstant_731,axiom,
    ~ b00000000000000000000(1) ).

tff(bitBlastConstant_730,axiom,
    ~ b00000000000000000000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2968,axiom,
    ! [VarCurr: state_type] :
      ( v32663(VarCurr)
    <=> ( v4263(VarCurr)
        & v32664(VarCurr) ) ) ).

tff(writeUnaryOperator_1850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32664(VarCurr)
    <=> v32633(VarCurr) ) ).

tff(addAssignment_16458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v32655(VarCurr,B)
      <=> v32657(VarCurr,B) ) ) ).

tff(addAssignment_16457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v32657(VarCurr,B)
      <=> v32659(VarCurr,B) ) ) ).

tff(addAssignment_16456,axiom,
    ! [VarCurr: state_type] :
      ( v32643(VarCurr)
    <=> v32645(VarCurr) ) ).

tff(addAssignment_16455,axiom,
    ! [VarCurr: state_type] :
      ( v32645(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16454,axiom,
    ! [VarCurr: state_type] :
      ( v32639(VarCurr)
    <=> v32641(VarCurr) ) ).

tff(addAssignment_16453,axiom,
    ! [VarCurr: state_type] :
      ( v32641(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2967,axiom,
    ! [VarCurr: state_type] :
      ( v32579(VarCurr)
    <=> ( v32631(VarCurr)
        | v32583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2966,axiom,
    ! [VarCurr: state_type] :
      ( v32631(VarCurr)
    <=> ( v32524(VarCurr,0)
        | v32581(VarCurr) ) ) ).

tff(addAssignment_16452,axiom,
    ! [VarCurr: state_type] :
      ( v32583(VarCurr)
    <=> v32585(VarCurr) ) ).

tff(addAssignment_16451,axiom,
    ! [VarCurr: state_type] :
      ( v32585(VarCurr)
    <=> v32587(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32614(VarNext)
       => ( v32587(VarNext)
        <=> v32587(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_383,axiom,
    ! [VarNext: state_type] :
      ( v32614(VarNext)
     => ( v32587(VarNext)
      <=> v32624(VarNext) ) ) ).

tff(addAssignment_16450,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32624(VarNext)
      <=> v32622(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32625(VarCurr)
     => ( v32622(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_239,axiom,
    ! [VarCurr: state_type] :
      ( v32625(VarCurr)
     => ( v32622(VarCurr)
      <=> v32597(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2965,axiom,
    ! [VarCurr: state_type] :
      ( v32625(VarCurr)
    <=> ( v32626(VarCurr)
        & v32627(VarCurr) ) ) ).

tff(writeUnaryOperator_1849,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32627(VarCurr)
    <=> v32593(VarCurr) ) ).

tff(writeUnaryOperator_1848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32626(VarCurr)
    <=> v32589(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32614(VarNext)
      <=> v32615(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32615(VarNext)
      <=> ( v32616(VarNext)
          & v32609(VarNext) ) ) ) ).

tff(writeUnaryOperator_1847,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32616(VarNext)
      <=> v32618(VarNext) ) ) ).

tff(addAssignment_16449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32618(VarNext)
      <=> v32609(VarCurr) ) ) ).

tff(addAssignment_16448,axiom,
    ! [VarCurr: state_type] :
      ( v32609(VarCurr)
    <=> v32611(VarCurr) ) ).

tff(addAssignment_16447,axiom,
    ! [VarCurr: state_type] :
      ( v32611(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16446,axiom,
    ! [VarCurr: state_type] :
      ( v32597(VarCurr)
    <=> v32599(VarCurr) ) ).

tff(addAssignment_16445,axiom,
    ! [VarCurr: state_type] :
      ( v32599(VarCurr)
    <=> v32601(VarCurr) ) ).

tff(addAssignment_16444,axiom,
    ! [VarCurr: state_type] :
      ( v32601(VarCurr)
    <=> v32603(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31315(VarCurr)
     => ( v32603(VarCurr)
      <=> v32605(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_238,axiom,
    ! [VarCurr: state_type] :
      ( v31315(VarCurr)
     => ( v32603(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32606(VarCurr)
     => ( v32605(VarCurr)
      <=> v32583(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_237,axiom,
    ! [VarCurr: state_type] :
      ( v32606(VarCurr)
     => ( v32605(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2962,axiom,
    ! [VarCurr: state_type] :
      ( v32606(VarCurr)
    <=> ( v4266(VarCurr)
        | v32607(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_148,axiom,
    ! [VarCurr: state_type] :
      ( v32607(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true ) ) ) ).

tff(addAssignment_16443,axiom,
    ! [VarCurr: state_type] :
      ( v32593(VarCurr)
    <=> v32595(VarCurr) ) ).

tff(addAssignment_16442,axiom,
    ! [VarCurr: state_type] :
      ( v32595(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16441,axiom,
    ! [VarCurr: state_type] :
      ( v32589(VarCurr)
    <=> v32591(VarCurr) ) ).

tff(addAssignment_16440,axiom,
    ! [VarCurr: state_type] :
      ( v32591(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16439,axiom,
    ! [VarCurr: state_type] :
      ( v32581(VarCurr)
    <=> v31293(VarCurr,0) ) ).

tff(addBitVectorEqualityBitBlasted_147,axiom,
    ! [VarCurr: state_type] :
      ( v32572(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_16438,axiom,
    ! [VarCurr: state_type] :
      ( v32558(VarCurr)
    <=> v32560(VarCurr) ) ).

tff(addAssignment_16437,axiom,
    ! [VarCurr: state_type] :
      ( v32560(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16436,axiom,
    ! [VarCurr: state_type] :
      ( v32554(VarCurr)
    <=> v32556(VarCurr) ) ).

tff(addAssignment_16435,axiom,
    ! [VarCurr: state_type] :
      ( v32556(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16434,axiom,
    ! [VarCurr: state_type] :
      ( v32534(VarCurr)
    <=> v32536(VarCurr) ) ).

tff(addAssignment_16433,axiom,
    ! [VarCurr: state_type] :
      ( v32536(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16432,axiom,
    ! [VarCurr: state_type] :
      ( v32530(VarCurr)
    <=> v32532(VarCurr) ) ).

tff(addAssignment_16431,axiom,
    ! [VarCurr: state_type] :
      ( v32532(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_16430,axiom,
    ! [VarCurr: state_type] :
      ( v31269(VarCurr)
    <=> v31271(VarCurr) ) ).

tff(addAssignment_16429,axiom,
    ! [VarCurr: state_type] :
      ( v31271(VarCurr)
    <=> v31273(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32507(VarNext)
       => ( v31273(VarNext)
        <=> v31273(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_382,axiom,
    ! [VarNext: state_type] :
      ( v32507(VarNext)
     => ( v31273(VarNext)
      <=> v32517(VarNext) ) ) ).

tff(addAssignment_16428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32517(VarNext)
      <=> v32515(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32518(VarCurr)
     => ( v32515(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_236,axiom,
    ! [VarCurr: state_type] :
      ( v32518(VarCurr)
     => ( v32515(VarCurr)
      <=> v31283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2961,axiom,
    ! [VarCurr: state_type] :
      ( v32518(VarCurr)
    <=> ( v32519(VarCurr)
        & v32520(VarCurr) ) ) ).

tff(writeUnaryOperator_1846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32520(VarCurr)
    <=> v31279(VarCurr) ) ).

tff(writeUnaryOperator_1845,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32519(VarCurr)
    <=> v31275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32507(VarNext)
      <=> v32508(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32508(VarNext)
      <=> ( v32509(VarNext)
          & v32502(VarNext) ) ) ) ).

tff(writeUnaryOperator_1844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32509(VarNext)
      <=> v32511(VarNext) ) ) ).

tff(addAssignment_16427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32511(VarNext)
      <=> v32502(VarCurr) ) ) ).

tff(addAssignment_16426,axiom,
    ! [VarCurr: state_type] :
      ( v32502(VarCurr)
    <=> v32504(VarCurr) ) ).

tff(addAssignment_16425,axiom,
    ! [VarCurr: state_type] :
      ( v32504(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16424,axiom,
    ! [VarCurr: state_type] :
      ( v31283(VarCurr)
    <=> v31285(VarCurr) ) ).

tff(addAssignment_16423,axiom,
    ! [VarCurr: state_type] :
      ( v31285(VarCurr)
    <=> v31287(VarCurr) ) ).

tff(addAssignment_16422,axiom,
    ! [VarCurr: state_type] :
      ( v31287(VarCurr)
    <=> v31289(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31291(VarCurr)
     => ( v31289(VarCurr)
      <=> v32500(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_235,axiom,
    ! [VarCurr: state_type] :
      ( v31291(VarCurr)
     => ( v31289(VarCurr)
      <=> $true ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31315(VarCurr)
     => ( v32500(VarCurr)
      <=> v31269(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_234,axiom,
    ! [VarCurr: state_type] :
      ( v31315(VarCurr)
     => ( v32500(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2958,axiom,
    ! [VarCurr: state_type] :
      ( v31291(VarCurr)
    <=> ( v32496(VarCurr)
        & v32498(VarCurr) ) ) ).

tff(writeUnaryOperator_1843,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32498(VarCurr)
    <=> v31269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2957,axiom,
    ! [VarCurr: state_type] :
      ( v32496(VarCurr)
    <=> ( v31293(VarCurr,0)
        & v32497(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_146,axiom,
    ! [VarCurr: state_type] :
      ( v32497(VarCurr)
    <=> ( ( v4697(VarCurr,5)
        <=> $false )
        & ( v4697(VarCurr,4)
        <=> $false )
        & ( v4697(VarCurr,3)
        <=> $false )
        & ( v4697(VarCurr,2)
        <=> $false )
        & ( v4697(VarCurr,1)
        <=> $true )
        & ( v4697(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_729,axiom,
    ~ b000011(5) ).

tff(bitBlastConstant_728,axiom,
    ~ b000011(4) ).

tff(bitBlastConstant_727,axiom,
    ~ b000011(3) ).

tff(bitBlastConstant_726,axiom,
    ~ b000011(2) ).

tff(bitBlastConstant_725,axiom,
    b000011(1) ).

tff(bitBlastConstant_724,axiom,
    b000011(0) ).

tff(addAssignment_16421,axiom,
    ! [VarCurr: state_type] :
      ( v31293(VarCurr,0)
    <=> v31295(VarCurr) ) ).

tff(addAssignment_16420,axiom,
    ! [VarCurr: state_type] :
      ( v31295(VarCurr)
    <=> v31297(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32478(VarNext)
       => ( v31297(VarNext)
        <=> v31297(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_381,axiom,
    ! [VarNext: state_type] :
      ( v32478(VarNext)
     => ( v31297(VarNext)
      <=> v32488(VarNext) ) ) ).

tff(addAssignment_16419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32488(VarNext)
      <=> v32486(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32489(VarCurr)
     => ( v32486(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_233,axiom,
    ! [VarCurr: state_type] :
      ( v32489(VarCurr)
     => ( v32486(VarCurr)
      <=> v31307(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2956,axiom,
    ! [VarCurr: state_type] :
      ( v32489(VarCurr)
    <=> ( v32490(VarCurr)
        & v32491(VarCurr) ) ) ).

tff(writeUnaryOperator_1842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32491(VarCurr)
    <=> v31303(VarCurr) ) ).

tff(writeUnaryOperator_1841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32490(VarCurr)
    <=> v31299(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32478(VarNext)
      <=> v32479(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32479(VarNext)
      <=> ( v32480(VarNext)
          & v32473(VarNext) ) ) ) ).

tff(writeUnaryOperator_1840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32480(VarNext)
      <=> v32482(VarNext) ) ) ).

tff(addAssignment_16418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32482(VarNext)
      <=> v32473(VarCurr) ) ) ).

tff(addAssignment_16417,axiom,
    ! [VarCurr: state_type] :
      ( v32473(VarCurr)
    <=> v32475(VarCurr) ) ).

tff(addAssignment_16416,axiom,
    ! [VarCurr: state_type] :
      ( v32475(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16415,axiom,
    ! [VarCurr: state_type] :
      ( v31307(VarCurr)
    <=> v31309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2953,axiom,
    ! [VarCurr: state_type] :
      ( v31309(VarCurr)
    <=> ( v32465(VarCurr)
        | v32468(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2952,axiom,
    ! [VarCurr: state_type] :
      ( v32468(VarCurr)
    <=> ( v31295(VarCurr)
        & v32469(VarCurr) ) ) ).

tff(writeUnaryOperator_1839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32469(VarCurr)
    <=> v32470(VarCurr) ) ).

tff(addAssignment_16414,axiom,
    ! [VarCurr: state_type] :
      ( v32470(VarCurr)
    <=> v32471(VarCurr) ) ).

tff(addAssignment_16413,axiom,
    ! [VarCurr: state_type] :
      ( v32471(VarCurr)
    <=> v32458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2951,axiom,
    ! [VarCurr: state_type] :
      ( v32465(VarCurr)
    <=> ( v31311(VarCurr)
        & v32466(VarCurr) ) ) ).

tff(addAssignment_16412,axiom,
    ! [VarCurr: state_type] :
      ( v32466(VarCurr)
    <=> v32467(VarCurr) ) ).

tff(addAssignment_16411,axiom,
    ! [VarCurr: state_type] :
      ( v32467(VarCurr)
    <=> v32458(VarCurr) ) ).

tff(addAssignment_16410,axiom,
    ! [VarCurr: state_type] :
      ( v32458(VarCurr)
    <=> v32460(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2950,axiom,
    ! [VarCurr: state_type] :
      ( v32460(VarCurr)
    <=> ( v32462(VarCurr)
        | v31315(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2949,axiom,
    ! [VarCurr: state_type] :
      ( v32462(VarCurr)
    <=> ( v2354(VarCurr)
        & v32463(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_145,axiom,
    ! [VarCurr: state_type] :
      ( v32463(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $true )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16409,axiom,
    ! [VarCurr: state_type] :
      ( v31311(VarCurr)
    <=> v31313(VarCurr,0) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_3,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31315(VarCurr)
     => ( v31313(VarCurr,0)
      <=> v2363(VarCurr,32) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_232,axiom,
    ! [VarCurr: state_type] :
      ( v31315(VarCurr)
     => ( v31313(VarCurr,0)
      <=> $false ) ) ).

tff(addAssignment_16408,axiom,
    ! [VarCurr: state_type] :
      ( v31315(VarCurr)
    <=> v31317(VarCurr) ) ).

tff(addAssignment_16407,axiom,
    ! [VarCurr: state_type] :
      ( v31317(VarCurr)
    <=> v31319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2948,axiom,
    ! [VarCurr: state_type] :
      ( v31319(VarCurr)
    <=> ( v32455(VarCurr)
        & v31357(VarCurr,0) ) ) ).

tff(writeUnaryOperator_1838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32455(VarCurr)
    <=> v31321(VarCurr,0) ) ).

tff(addAssignment_16406,axiom,
    ! [VarCurr: state_type] :
      ( v31321(VarCurr,0)
    <=> v32021(VarCurr,0) ) ).

tff(addAssignment_16405,axiom,
    ! [VarCurr: state_type] :
      ( v31323(VarCurr,0)
    <=> v31325(VarCurr,0) ) ).

tff(addAssignment_16404,axiom,
    ! [VarCurr: state_type] :
      ( v31325(VarCurr,0)
    <=> v31327(VarCurr,0) ) ).

tff(addAssignment_16403,axiom,
    ! [VarNext: state_type] :
      ( v31327(VarNext,0)
    <=> v32447(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32448(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v32447(VarNext,B)
            <=> v31327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_380,axiom,
    ! [VarNext: state_type] :
      ( v32448(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32447(VarNext,B)
          <=> v32015(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32448(VarNext)
      <=> v32449(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32449(VarNext)
      <=> ( v32451(VarNext)
          & v32000(VarNext) ) ) ) ).

tff(writeUnaryOperator_1837,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32451(VarNext)
      <=> v32009(VarNext) ) ) ).

tff(addAssignment_16402,axiom,
    ! [VarCurr: state_type] :
      ( v31349(VarCurr,0)
    <=> v31351(VarCurr,0) ) ).

tff(addAssignment_16401,axiom,
    ! [VarCurr: state_type] :
      ( v31351(VarCurr,0)
    <=> v31353(VarCurr,0) ) ).

tff(addAssignment_16400,axiom,
    ! [VarCurr: state_type] :
      ( v31353(VarCurr,0)
    <=> v31355(VarCurr,0) ) ).

tff(addAssignment_16399,axiom,
    ! [VarCurr: state_type] :
      ( v31355(VarCurr,0)
    <=> v31998(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32433(VarCurr)
     => ( v31357(VarCurr,0)
      <=> $false ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_231,axiom,
    ! [VarCurr: state_type] :
      ( v32433(VarCurr)
     => ( v31357(VarCurr,0)
      <=> v32444(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges3_3,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31975(VarCurr)
        & ~ v32436(VarCurr)
        & ~ v32437(VarCurr)
        & v32440(VarCurr) )
     => ( v32444(VarCurr)
      <=> v32419(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges2_3,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31975(VarCurr)
        & ~ v32436(VarCurr)
        & v32437(VarCurr) )
     => ( v32444(VarCurr)
      <=> v32405(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_379,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31975(VarCurr)
        & v32436(VarCurr) )
     => ( v32444(VarCurr)
      <=> v32391(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_379,axiom,
    ! [VarCurr: state_type] :
      ( v31975(VarCurr)
     => ( v32444(VarCurr)
      <=> v32445(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31974(VarCurr)
     => ( v32445(VarCurr)
      <=> $true ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_230,axiom,
    ! [VarCurr: state_type] :
      ( v31974(VarCurr)
     => ( v32445(VarCurr)
      <=> v32383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2945,axiom,
    ! [VarCurr: state_type] :
      ( v32433(VarCurr)
    <=> ( v32434(VarCurr)
        | v32440(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2944,axiom,
    ! [VarCurr: state_type] :
      ( v32440(VarCurr)
    <=> ( v32441(VarCurr)
        & v32443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2943,axiom,
    ! [VarCurr: state_type] :
      ( v32443(VarCurr)
    <=> ( v31996(VarCurr)
        & v31993(VarCurr) ) ) ).

tff(writeUnaryOperator_1836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32441(VarCurr)
    <=> v32442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2942,axiom,
    ! [VarCurr: state_type] :
      ( v32442(VarCurr)
    <=> ( v31981(VarCurr)
        | v31988(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2941,axiom,
    ! [VarCurr: state_type] :
      ( v32434(VarCurr)
    <=> ( v32435(VarCurr)
        | v32437(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2940,axiom,
    ! [VarCurr: state_type] :
      ( v32437(VarCurr)
    <=> ( v32438(VarCurr)
        & v32439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2939,axiom,
    ! [VarCurr: state_type] :
      ( v32439(VarCurr)
    <=> ( v31986(VarCurr)
        & v31988(VarCurr) ) ) ).

tff(writeUnaryOperator_1835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32438(VarCurr)
    <=> v31981(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2938,axiom,
    ! [VarCurr: state_type] :
      ( v32435(VarCurr)
    <=> ( v31975(VarCurr)
        | v32436(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2937,axiom,
    ! [VarCurr: state_type] :
      ( v32436(VarCurr)
    <=> ( v31979(VarCurr)
        & v31981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2936,axiom,
    ! [VarCurr: state_type] :
      ( v32419(VarCurr)
    <=> ( v31691(VarCurr)
        & v32421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2935,axiom,
    ! [VarCurr: state_type] :
      ( v32421(VarCurr)
    <=> ( v32422(VarCurr)
        | v31673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2934,axiom,
    ! [VarCurr: state_type] :
      ( v32422(VarCurr)
    <=> ( v32423(VarCurr)
        | v31656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2933,axiom,
    ! [VarCurr: state_type] :
      ( v32423(VarCurr)
    <=> ( v32424(VarCurr)
        | v32431(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2932,axiom,
    ! [VarCurr: state_type] :
      ( v32431(VarCurr)
    <=> ( v31650(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2931,axiom,
    ! [VarCurr: state_type] :
      ( v32424(VarCurr)
    <=> ( v32425(VarCurr)
        | v32429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2930,axiom,
    ! [VarCurr: state_type] :
      ( v32429(VarCurr)
    <=> ( v32430(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2929,axiom,
    ! [VarCurr: state_type] :
      ( v32430(VarCurr)
    <=> ( v31647(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2928,axiom,
    ! [VarCurr: state_type] :
      ( v32425(VarCurr)
    <=> ( v32426(VarCurr)
        | v32428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2927,axiom,
    ! [VarCurr: state_type] :
      ( v32428(VarCurr)
    <=> ( v31670(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2926,axiom,
    ! [VarCurr: state_type] :
      ( v32426(VarCurr)
    <=> ( v32427(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2925,axiom,
    ! [VarCurr: state_type] :
      ( v32427(VarCurr)
    <=> ( v31634(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2924,axiom,
    ! [VarCurr: state_type] :
      ( v32405(VarCurr)
    <=> ( v31691(VarCurr)
        & v32407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2923,axiom,
    ! [VarCurr: state_type] :
      ( v32407(VarCurr)
    <=> ( v32408(VarCurr)
        | v32417(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2922,axiom,
    ! [VarCurr: state_type] :
      ( v32417(VarCurr)
    <=> ( v31673(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2921,axiom,
    ! [VarCurr: state_type] :
      ( v32408(VarCurr)
    <=> ( v32409(VarCurr)
        | v32415(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2920,axiom,
    ! [VarCurr: state_type] :
      ( v32415(VarCurr)
    <=> ( v32416(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2919,axiom,
    ! [VarCurr: state_type] :
      ( v32416(VarCurr)
    <=> ( v31656(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2918,axiom,
    ! [VarCurr: state_type] :
      ( v32409(VarCurr)
    <=> ( v32410(VarCurr)
        | v32413(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2917,axiom,
    ! [VarCurr: state_type] :
      ( v32413(VarCurr)
    <=> ( v32414(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2916,axiom,
    ! [VarCurr: state_type] :
      ( v32414(VarCurr)
    <=> ( v31650(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2915,axiom,
    ! [VarCurr: state_type] :
      ( v32410(VarCurr)
    <=> ( v32411(VarCurr)
        | v31647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2914,axiom,
    ! [VarCurr: state_type] :
      ( v32411(VarCurr)
    <=> ( v32412(VarCurr)
        | v31670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2913,axiom,
    ! [VarCurr: state_type] :
      ( v32412(VarCurr)
    <=> ( v31634(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2912,axiom,
    ! [VarCurr: state_type] :
      ( v32391(VarCurr)
    <=> ( v31691(VarCurr)
        & v32393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2911,axiom,
    ! [VarCurr: state_type] :
      ( v32393(VarCurr)
    <=> ( v32394(VarCurr)
        | v32402(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2910,axiom,
    ! [VarCurr: state_type] :
      ( v32402(VarCurr)
    <=> ( v32403(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2909,axiom,
    ! [VarCurr: state_type] :
      ( v32403(VarCurr)
    <=> ( v31673(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2908,axiom,
    ! [VarCurr: state_type] :
      ( v32394(VarCurr)
    <=> ( v32395(VarCurr)
        | v32401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2907,axiom,
    ! [VarCurr: state_type] :
      ( v32401(VarCurr)
    <=> ( v31656(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2906,axiom,
    ! [VarCurr: state_type] :
      ( v32395(VarCurr)
    <=> ( v32396(VarCurr)
        | v31650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2905,axiom,
    ! [VarCurr: state_type] :
      ( v32396(VarCurr)
    <=> ( v32397(VarCurr)
        | v32400(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2904,axiom,
    ! [VarCurr: state_type] :
      ( v32400(VarCurr)
    <=> ( v31647(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2903,axiom,
    ! [VarCurr: state_type] :
      ( v32397(VarCurr)
    <=> ( v31634(VarCurr)
        | v32398(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2902,axiom,
    ! [VarCurr: state_type] :
      ( v32398(VarCurr)
    <=> ( v32399(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2901,axiom,
    ! [VarCurr: state_type] :
      ( v32399(VarCurr)
    <=> ( v31670(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2900,axiom,
    ! [VarCurr: state_type] :
      ( v32383(VarCurr)
    <=> ( v32388(VarCurr)
        | v32385(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2899,axiom,
    ! [VarCurr: state_type] :
      ( v32388(VarCurr)
    <=> ( v32389(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2898,axiom,
    ! [VarCurr: state_type] :
      ( v32389(VarCurr)
    <=> ( v31631(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_144,axiom,
    ! [VarCurr: state_type] :
      ( v32385(VarCurr)
    <=> ( ( v31409(VarCurr,31)
        <=> $false )
        & ( v31409(VarCurr,30)
        <=> $false )
        & ( v31409(VarCurr,29)
        <=> $false )
        & ( v31409(VarCurr,28)
        <=> $false )
        & ( v31409(VarCurr,27)
        <=> $false )
        & ( v31409(VarCurr,26)
        <=> $false ) ) ) ).

tff(addAssignment_16398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v31359(VarCurr,B)
      <=> v31361(VarCurr,B) ) ) ).

tff(addAssignment_16397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v31361(VarCurr,B)
      <=> v31363(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_378,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32366(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v31363(VarNext,B)
            <=> v31363(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_378,axiom,
    ! [VarNext: state_type] :
      ( v32366(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v31363(VarNext,B)
          <=> v32376(VarNext,B) ) ) ) ).

tff(addAssignment_16396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v32376(VarNext,B)
          <=> v32374(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32377(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v32374(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_229,axiom,
    ! [VarCurr: state_type] :
      ( v32377(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v32374(VarCurr,B)
          <=> v31373(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2897,axiom,
    ! [VarCurr: state_type] :
      ( v32377(VarCurr)
    <=> ( v32378(VarCurr)
        & v32379(VarCurr) ) ) ).

tff(writeUnaryOperator_1834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32379(VarCurr)
    <=> v31369(VarCurr) ) ).

tff(writeUnaryOperator_1833,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32378(VarCurr)
    <=> v31365(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2896,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32366(VarNext)
      <=> v32367(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32367(VarNext)
      <=> ( v32368(VarNext)
          & v32361(VarNext) ) ) ) ).

tff(writeUnaryOperator_1832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32368(VarNext)
      <=> v32370(VarNext) ) ) ).

tff(addAssignment_16395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32370(VarNext)
      <=> v32361(VarCurr) ) ) ).

tff(addAssignment_16394,axiom,
    ! [VarCurr: state_type] :
      ( v32361(VarCurr)
    <=> v32363(VarCurr) ) ).

tff(addAssignment_16393,axiom,
    ! [VarCurr: state_type] :
      ( v32363(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v31373(VarCurr,B)
      <=> v31375(VarCurr,B) ) ) ).

tff(addAssignment_16391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v31375(VarCurr,B)
      <=> v31377(VarCurr,B) ) ) ).

tff(addAssignment_16390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v31377(VarCurr,B)
      <=> v31379(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32330(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v31379(VarCurr,B)
          <=> v32331(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_5,axiom,
    ! [VarCurr: state_type] :
      ( v32330(VarCurr)
     => ( ( v31379(VarCurr,4)
        <=> v31409(VarCurr,25) )
        & ( v31379(VarCurr,3)
        <=> v31409(VarCurr,24) )
        & ( v31379(VarCurr,2)
        <=> v31409(VarCurr,23) )
        & ( v31379(VarCurr,1)
        <=> v31409(VarCurr,22) )
        & ( v31379(VarCurr,0)
        <=> v31409(VarCurr,21) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v32331(VarCurr,B)
          <=> v31359(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_228,axiom,
    ! [VarCurr: state_type] :
      ( v32327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v32331(VarCurr,B)
          <=> v32332(VarCurr,B) ) ) ) ).

tff(addAssignment_16389,axiom,
    ! [VarCurr: state_type] :
      ( v32332(VarCurr,0)
    <=> v32358(VarCurr) ) ).

tff(addAssignment_16388,axiom,
    ! [VarCurr: state_type] :
      ( v32332(VarCurr,1)
    <=> v32356(VarCurr) ) ).

tff(addAssignment_16387,axiom,
    ! [VarCurr: state_type] :
      ( v32332(VarCurr,2)
    <=> v32352(VarCurr) ) ).

tff(addAssignment_16386,axiom,
    ! [VarCurr: state_type] :
      ( v32332(VarCurr,3)
    <=> v32348(VarCurr) ) ).

tff(addAssignment_16385,axiom,
    ! [VarCurr: state_type] :
      ( v32332(VarCurr,4)
    <=> v32334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2894,axiom,
    ! [VarCurr: state_type] :
      ( v32356(VarCurr)
    <=> ( v32357(VarCurr)
        & v32359(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2893,axiom,
    ! [VarCurr: state_type] :
      ( v32359(VarCurr)
    <=> ( v31359(VarCurr,0)
        | v32343(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_331,axiom,
    ! [VarCurr: state_type] :
      ( v32357(VarCurr)
    <=> ( v32358(VarCurr)
        | v31359(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32358(VarCurr)
    <=> v31359(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2892,axiom,
    ! [VarCurr: state_type] :
      ( v32352(VarCurr)
    <=> ( v32353(VarCurr)
        & v32355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2891,axiom,
    ! [VarCurr: state_type] :
      ( v32355(VarCurr)
    <=> ( v32341(VarCurr)
        | v32344(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_330,axiom,
    ! [VarCurr: state_type] :
      ( v32353(VarCurr)
    <=> ( v32354(VarCurr)
        | v31359(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32354(VarCurr)
    <=> v32341(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2890,axiom,
    ! [VarCurr: state_type] :
      ( v32348(VarCurr)
    <=> ( v32349(VarCurr)
        & v32351(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2889,axiom,
    ! [VarCurr: state_type] :
      ( v32351(VarCurr)
    <=> ( v32339(VarCurr)
        | v32345(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_329,axiom,
    ! [VarCurr: state_type] :
      ( v32349(VarCurr)
    <=> ( v32350(VarCurr)
        | v31359(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32350(VarCurr)
    <=> v32339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2888,axiom,
    ! [VarCurr: state_type] :
      ( v32334(VarCurr)
    <=> ( v32335(VarCurr)
        & v32346(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2887,axiom,
    ! [VarCurr: state_type] :
      ( v32346(VarCurr)
    <=> ( v32337(VarCurr)
        | v32347(VarCurr) ) ) ).

tff(writeUnaryOperator_1828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32347(VarCurr)
    <=> v31359(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_328,axiom,
    ! [VarCurr: state_type] :
      ( v32335(VarCurr)
    <=> ( v32336(VarCurr)
        | v31359(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32336(VarCurr)
    <=> v32337(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_327,axiom,
    ! [VarCurr: state_type] :
      ( v32337(VarCurr)
    <=> ( v31359(VarCurr,3)
        | v32338(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2886,axiom,
    ! [VarCurr: state_type] :
      ( v32338(VarCurr)
    <=> ( v32339(VarCurr)
        & v32345(VarCurr) ) ) ).

tff(writeUnaryOperator_1826,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32345(VarCurr)
    <=> v31359(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_326,axiom,
    ! [VarCurr: state_type] :
      ( v32339(VarCurr)
    <=> ( v31359(VarCurr,2)
        | v32340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2885,axiom,
    ! [VarCurr: state_type] :
      ( v32340(VarCurr)
    <=> ( v32341(VarCurr)
        & v32344(VarCurr) ) ) ).

tff(writeUnaryOperator_1825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32344(VarCurr)
    <=> v31359(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_325,axiom,
    ! [VarCurr: state_type] :
      ( v32341(VarCurr)
    <=> ( v31359(VarCurr,1)
        | v32342(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2884,axiom,
    ! [VarCurr: state_type] :
      ( v32342(VarCurr)
    <=> ( v31359(VarCurr,0)
        & v32343(VarCurr) ) ) ).

tff(writeUnaryOperator_1824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32343(VarCurr)
    <=> v31359(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2883,axiom,
    ! [VarCurr: state_type] :
      ( v32330(VarCurr)
    <=> ( v31381(VarCurr)
        | v31385(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_324,axiom,
    ! [VarCurr: state_type] :
      ( v32327(VarCurr)
    <=> ( v31321(VarCurr,3)
        & v31549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2882,axiom,
    ! [VarCurr: state_type] :
      ( v31385(VarCurr)
    <=> ( v32320(VarCurr)
        & v32325(VarCurr) ) ) ).

tff(writeUnaryOperator_1823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32325(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2881,axiom,
    ! [VarCurr: state_type] :
      ( v32320(VarCurr)
    <=> ( v32321(VarCurr)
        & v32324(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_143,axiom,
    ! [VarCurr: state_type] :
      ( v32324(VarCurr)
    <=> ( ( v31597(VarCurr,6)
        <=> $false )
        & ( v31597(VarCurr,5)
        <=> $false )
        & ( v31597(VarCurr,4)
        <=> $false )
        & ( v31597(VarCurr,3)
        <=> $false )
        & ( v31597(VarCurr,2)
        <=> $false )
        & ( v31597(VarCurr,1)
        <=> $false )
        & ( v31597(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2880,axiom,
    ! [VarCurr: state_type] :
      ( v32321(VarCurr)
    <=> ( v32322(VarCurr)
        & v32323(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_142,axiom,
    ! [VarCurr: state_type] :
      ( v32323(VarCurr)
    <=> ( ( v31387(VarCurr,6)
        <=> $false )
        & ( v31387(VarCurr,5)
        <=> $false )
        & ( v31387(VarCurr,4)
        <=> $false )
        & ( v31387(VarCurr,3)
        <=> $false )
        & ( v31387(VarCurr,2)
        <=> $false )
        & ( v31387(VarCurr,1)
        <=> $false )
        & ( v31387(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_141,axiom,
    ! [VarCurr: state_type] :
      ( v32322(VarCurr)
    <=> ( ( v31359(VarCurr,4)
        <=> $false )
        & ( v31359(VarCurr,3)
        <=> $false )
        & ( v31359(VarCurr,2)
        <=> $false )
        & ( v31359(VarCurr,1)
        <=> $false )
        & ( v31359(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31387(VarCurr,B)
      <=> v31389(VarCurr,B) ) ) ).

tff(addAssignment_16383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31389(VarCurr,B)
      <=> v31391(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32303(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v31391(VarNext,B)
            <=> v31391(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_377,axiom,
    ! [VarNext: state_type] :
      ( v32303(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v31391(VarNext,B)
          <=> v32313(VarNext,B) ) ) ) ).

tff(addAssignment_16382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32313(VarNext,B)
          <=> v32311(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32314(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32311(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_227,axiom,
    ! [VarCurr: state_type] :
      ( v32314(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32311(VarCurr,B)
          <=> v31401(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2879,axiom,
    ! [VarCurr: state_type] :
      ( v32314(VarCurr)
    <=> ( v32315(VarCurr)
        & v32316(VarCurr) ) ) ).

tff(writeUnaryOperator_1822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32316(VarCurr)
    <=> v31397(VarCurr) ) ).

tff(writeUnaryOperator_1821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32315(VarCurr)
    <=> v31393(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32303(VarNext)
      <=> v32304(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32304(VarNext)
      <=> ( v32305(VarNext)
          & v32298(VarNext) ) ) ) ).

tff(writeUnaryOperator_1820,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32305(VarNext)
      <=> v32307(VarNext) ) ) ).

tff(addAssignment_16381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32307(VarNext)
      <=> v32298(VarCurr) ) ) ).

tff(addAssignment_16380,axiom,
    ! [VarCurr: state_type] :
      ( v32298(VarCurr)
    <=> v32300(VarCurr) ) ).

tff(addAssignment_16379,axiom,
    ! [VarCurr: state_type] :
      ( v32300(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31401(VarCurr,B)
      <=> v31403(VarCurr,B) ) ) ).

tff(addAssignment_16377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31403(VarCurr,B)
      <=> v31405(VarCurr,B) ) ) ).

tff(addAssignment_16376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31405(VarCurr,B)
      <=> v31407(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32253(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v31407(VarCurr,B)
          <=> v32254(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_4,axiom,
    ! [VarCurr: state_type] :
      ( v32253(VarCurr)
     => ( ( v31407(VarCurr,6)
        <=> v31409(VarCurr,19) )
        & ( v31407(VarCurr,5)
        <=> v31409(VarCurr,18) )
        & ( v31407(VarCurr,4)
        <=> v31409(VarCurr,17) )
        & ( v31407(VarCurr,3)
        <=> v31409(VarCurr,16) )
        & ( v31407(VarCurr,2)
        <=> v31409(VarCurr,15) )
        & ( v31407(VarCurr,1)
        <=> v31409(VarCurr,14) )
        & ( v31407(VarCurr,0)
        <=> v31409(VarCurr,13) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32254(VarCurr,B)
          <=> v31387(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_226,axiom,
    ! [VarCurr: state_type] :
      ( v31487(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32254(VarCurr,B)
          <=> v32255(VarCurr,B) ) ) ) ).

tff(addAssignment_16375,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,0)
    <=> v32295(VarCurr) ) ).

tff(addAssignment_16374,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,1)
    <=> v32293(VarCurr) ) ).

tff(addAssignment_16373,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,2)
    <=> v32289(VarCurr) ) ).

tff(addAssignment_16372,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,3)
    <=> v32285(VarCurr) ) ).

tff(addAssignment_16371,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,4)
    <=> v32281(VarCurr) ) ).

tff(addAssignment_16370,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,5)
    <=> v32277(VarCurr) ) ).

tff(addAssignment_16369,axiom,
    ! [VarCurr: state_type] :
      ( v32255(VarCurr,6)
    <=> v32257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2876,axiom,
    ! [VarCurr: state_type] :
      ( v32293(VarCurr)
    <=> ( v32294(VarCurr)
        & v32296(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2875,axiom,
    ! [VarCurr: state_type] :
      ( v32296(VarCurr)
    <=> ( v31387(VarCurr,0)
        | v32270(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_323,axiom,
    ! [VarCurr: state_type] :
      ( v32294(VarCurr)
    <=> ( v32295(VarCurr)
        | v31387(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1819,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32295(VarCurr)
    <=> v31387(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2874,axiom,
    ! [VarCurr: state_type] :
      ( v32289(VarCurr)
    <=> ( v32290(VarCurr)
        & v32292(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2873,axiom,
    ! [VarCurr: state_type] :
      ( v32292(VarCurr)
    <=> ( v32268(VarCurr)
        | v32271(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_322,axiom,
    ! [VarCurr: state_type] :
      ( v32290(VarCurr)
    <=> ( v32291(VarCurr)
        | v31387(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32291(VarCurr)
    <=> v32268(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2872,axiom,
    ! [VarCurr: state_type] :
      ( v32285(VarCurr)
    <=> ( v32286(VarCurr)
        & v32288(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2871,axiom,
    ! [VarCurr: state_type] :
      ( v32288(VarCurr)
    <=> ( v32266(VarCurr)
        | v32272(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_321,axiom,
    ! [VarCurr: state_type] :
      ( v32286(VarCurr)
    <=> ( v32287(VarCurr)
        | v31387(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32287(VarCurr)
    <=> v32266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2870,axiom,
    ! [VarCurr: state_type] :
      ( v32281(VarCurr)
    <=> ( v32282(VarCurr)
        & v32284(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2869,axiom,
    ! [VarCurr: state_type] :
      ( v32284(VarCurr)
    <=> ( v32264(VarCurr)
        | v32273(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_320,axiom,
    ! [VarCurr: state_type] :
      ( v32282(VarCurr)
    <=> ( v32283(VarCurr)
        | v31387(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32283(VarCurr)
    <=> v32264(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2868,axiom,
    ! [VarCurr: state_type] :
      ( v32277(VarCurr)
    <=> ( v32278(VarCurr)
        & v32280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2867,axiom,
    ! [VarCurr: state_type] :
      ( v32280(VarCurr)
    <=> ( v32262(VarCurr)
        | v32274(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_319,axiom,
    ! [VarCurr: state_type] :
      ( v32278(VarCurr)
    <=> ( v32279(VarCurr)
        | v31387(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32279(VarCurr)
    <=> v32262(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2866,axiom,
    ! [VarCurr: state_type] :
      ( v32257(VarCurr)
    <=> ( v32258(VarCurr)
        & v32275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2865,axiom,
    ! [VarCurr: state_type] :
      ( v32275(VarCurr)
    <=> ( v32260(VarCurr)
        | v32276(VarCurr) ) ) ).

tff(writeUnaryOperator_1814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32276(VarCurr)
    <=> v31387(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_318,axiom,
    ! [VarCurr: state_type] :
      ( v32258(VarCurr)
    <=> ( v32259(VarCurr)
        | v31387(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32259(VarCurr)
    <=> v32260(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_317,axiom,
    ! [VarCurr: state_type] :
      ( v32260(VarCurr)
    <=> ( v31387(VarCurr,5)
        | v32261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2864,axiom,
    ! [VarCurr: state_type] :
      ( v32261(VarCurr)
    <=> ( v32262(VarCurr)
        & v32274(VarCurr) ) ) ).

tff(writeUnaryOperator_1812,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32274(VarCurr)
    <=> v31387(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_316,axiom,
    ! [VarCurr: state_type] :
      ( v32262(VarCurr)
    <=> ( v31387(VarCurr,4)
        | v32263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2863,axiom,
    ! [VarCurr: state_type] :
      ( v32263(VarCurr)
    <=> ( v32264(VarCurr)
        & v32273(VarCurr) ) ) ).

tff(writeUnaryOperator_1811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32273(VarCurr)
    <=> v31387(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_315,axiom,
    ! [VarCurr: state_type] :
      ( v32264(VarCurr)
    <=> ( v31387(VarCurr,3)
        | v32265(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2862,axiom,
    ! [VarCurr: state_type] :
      ( v32265(VarCurr)
    <=> ( v32266(VarCurr)
        & v32272(VarCurr) ) ) ).

tff(writeUnaryOperator_1810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32272(VarCurr)
    <=> v31387(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_314,axiom,
    ! [VarCurr: state_type] :
      ( v32266(VarCurr)
    <=> ( v31387(VarCurr,2)
        | v32267(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2861,axiom,
    ! [VarCurr: state_type] :
      ( v32267(VarCurr)
    <=> ( v32268(VarCurr)
        & v32271(VarCurr) ) ) ).

tff(writeUnaryOperator_1809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32271(VarCurr)
    <=> v31387(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_313,axiom,
    ! [VarCurr: state_type] :
      ( v32268(VarCurr)
    <=> ( v31387(VarCurr,1)
        | v32269(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2860,axiom,
    ! [VarCurr: state_type] :
      ( v32269(VarCurr)
    <=> ( v31387(VarCurr,0)
        & v32270(VarCurr) ) ) ).

tff(writeUnaryOperator_1808,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32270(VarCurr)
    <=> v31387(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2859,axiom,
    ! [VarCurr: state_type] :
      ( v32253(VarCurr)
    <=> ( v31381(VarCurr)
        | v31385(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_312,axiom,
    ! [VarCurr: state_type] :
      ( v31487(VarCurr)
    <=> ( v31321(VarCurr,2)
        & v31549(VarCurr) ) ) ).

tff(addAssignment_16368,axiom,
    ! [VarCurr: state_type] :
      ( v31321(VarCurr,2)
    <=> v32021(VarCurr,2) ) ).

tff(addAssignment_16367,axiom,
    ! [VarCurr: state_type] :
      ( v31323(VarCurr,2)
    <=> v31325(VarCurr,2) ) ).

tff(addAssignment_16366,axiom,
    ! [VarCurr: state_type] :
      ( v31325(VarCurr,2)
    <=> v31327(VarCurr,2) ) ).

tff(addAssignment_16365,axiom,
    ! [VarNext: state_type] :
      ( v31327(VarNext,2)
    <=> v32244(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32245(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v32244(VarNext,B)
            <=> v31327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_376,axiom,
    ! [VarNext: state_type] :
      ( v32245(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32244(VarNext,B)
          <=> v32015(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32245(VarNext)
      <=> v32246(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2857,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32246(VarNext)
      <=> ( v32248(VarNext)
          & v32000(VarNext) ) ) ) ).

tff(writeUnaryOperator_1807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32248(VarNext)
      <=> v32009(VarNext) ) ) ).

tff(addAssignment_16364,axiom,
    ! [VarCurr: state_type] :
      ( v31349(VarCurr,2)
    <=> v31351(VarCurr,2) ) ).

tff(addAssignment_16363,axiom,
    ! [VarCurr: state_type] :
      ( v31351(VarCurr,2)
    <=> v31353(VarCurr,2) ) ).

tff(addAssignment_16362,axiom,
    ! [VarCurr: state_type] :
      ( v31353(VarCurr,2)
    <=> v31355(VarCurr,2) ) ).

tff(addAssignment_16361,axiom,
    ! [VarCurr: state_type] :
      ( v31355(VarCurr,2)
    <=> v31998(VarCurr,2) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_2,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32227(VarCurr)
     => ( v31357(VarCurr,2)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_3,axiom,
    ! [VarCurr: state_type] :
      ( v32227(VarCurr)
     => ( v31357(VarCurr,2)
      <=> v32241(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges3_2,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32230(VarCurr)
        & ~ v32231(VarCurr)
        & ~ v32234(VarCurr)
        & v32237(VarCurr) )
     => ( v32241(VarCurr)
      <=> v32209(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges2_2,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32230(VarCurr)
        & ~ v32231(VarCurr)
        & v32234(VarCurr) )
     => ( v32241(VarCurr)
      <=> v32242(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_375,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32230(VarCurr)
        & v32231(VarCurr) )
     => ( v32241(VarCurr)
      <=> v32186(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_375,axiom,
    ! [VarCurr: state_type] :
      ( v32230(VarCurr)
     => ( v32241(VarCurr)
      <=> v32171(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31986(VarCurr)
     => ( v32242(VarCurr)
      <=> $true ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_225,axiom,
    ! [VarCurr: state_type] :
      ( v31986(VarCurr)
     => ( v32242(VarCurr)
      <=> v32204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2856,axiom,
    ! [VarCurr: state_type] :
      ( v32227(VarCurr)
    <=> ( v32228(VarCurr)
        | v32237(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2855,axiom,
    ! [VarCurr: state_type] :
      ( v32237(VarCurr)
    <=> ( v32238(VarCurr)
        & v32240(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2854,axiom,
    ! [VarCurr: state_type] :
      ( v32240(VarCurr)
    <=> ( v31996(VarCurr)
        & v31993(VarCurr) ) ) ).

tff(writeUnaryOperator_1806,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32238(VarCurr)
    <=> v32239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2853,axiom,
    ! [VarCurr: state_type] :
      ( v32239(VarCurr)
    <=> ( v31975(VarCurr)
        | v31981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2852,axiom,
    ! [VarCurr: state_type] :
      ( v32228(VarCurr)
    <=> ( v32229(VarCurr)
        | v32234(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2851,axiom,
    ! [VarCurr: state_type] :
      ( v32234(VarCurr)
    <=> ( v32235(VarCurr)
        & v31988(VarCurr) ) ) ).

tff(writeUnaryOperator_1805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32235(VarCurr)
    <=> v32236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2850,axiom,
    ! [VarCurr: state_type] :
      ( v32236(VarCurr)
    <=> ( v31975(VarCurr)
        | v31981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2849,axiom,
    ! [VarCurr: state_type] :
      ( v32229(VarCurr)
    <=> ( v32230(VarCurr)
        | v32231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2848,axiom,
    ! [VarCurr: state_type] :
      ( v32231(VarCurr)
    <=> ( v32232(VarCurr)
        & v32233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2847,axiom,
    ! [VarCurr: state_type] :
      ( v32233(VarCurr)
    <=> ( v31979(VarCurr)
        & v31981(VarCurr) ) ) ).

tff(writeUnaryOperator_1804,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32232(VarCurr)
    <=> v31975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2846,axiom,
    ! [VarCurr: state_type] :
      ( v32230(VarCurr)
    <=> ( v31974(VarCurr)
        & v31975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2845,axiom,
    ! [VarCurr: state_type] :
      ( v32209(VarCurr)
    <=> ( v32211(VarCurr)
        & v32212(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2844,axiom,
    ! [VarCurr: state_type] :
      ( v32212(VarCurr)
    <=> ( v32213(VarCurr)
        | v32223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2843,axiom,
    ! [VarCurr: state_type] :
      ( v32223(VarCurr)
    <=> ( v32224(VarCurr)
        & v32225(VarCurr) ) ) ).

tff(writeUnaryOperator_1803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32225(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2842,axiom,
    ! [VarCurr: state_type] :
      ( v32224(VarCurr)
    <=> ( v31673(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2841,axiom,
    ! [VarCurr: state_type] :
      ( v32213(VarCurr)
    <=> ( v32214(VarCurr)
        | v32221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2840,axiom,
    ! [VarCurr: state_type] :
      ( v32221(VarCurr)
    <=> ( v31656(VarCurr)
        & v32222(VarCurr) ) ) ).

tff(writeUnaryOperator_1802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32222(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2839,axiom,
    ! [VarCurr: state_type] :
      ( v32214(VarCurr)
    <=> ( v32215(VarCurr)
        | v32218(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2838,axiom,
    ! [VarCurr: state_type] :
      ( v32218(VarCurr)
    <=> ( v32219(VarCurr)
        & v32220(VarCurr) ) ) ).

tff(writeUnaryOperator_1801,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32220(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2837,axiom,
    ! [VarCurr: state_type] :
      ( v32219(VarCurr)
    <=> ( v31650(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2836,axiom,
    ! [VarCurr: state_type] :
      ( v32215(VarCurr)
    <=> ( v32216(VarCurr)
        | v32217(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2835,axiom,
    ! [VarCurr: state_type] :
      ( v32217(VarCurr)
    <=> ( v31647(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2834,axiom,
    ! [VarCurr: state_type] :
      ( v32216(VarCurr)
    <=> ( v31634(VarCurr)
        | v31670(VarCurr) ) ) ).

tff(writeUnaryOperator_1800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32211(VarCurr)
    <=> v31653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2833,axiom,
    ! [VarCurr: state_type] :
      ( v32204(VarCurr)
    <=> ( v32206(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2832,axiom,
    ! [VarCurr: state_type] :
      ( v32206(VarCurr)
    <=> ( v32207(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeUnaryOperator_1799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32207(VarCurr)
    <=> v31653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2831,axiom,
    ! [VarCurr: state_type] :
      ( v32186(VarCurr)
    <=> ( v32188(VarCurr)
        & v32189(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2830,axiom,
    ! [VarCurr: state_type] :
      ( v32189(VarCurr)
    <=> ( v32190(VarCurr)
        | v31673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2829,axiom,
    ! [VarCurr: state_type] :
      ( v32190(VarCurr)
    <=> ( v32191(VarCurr)
        | v32200(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2828,axiom,
    ! [VarCurr: state_type] :
      ( v32200(VarCurr)
    <=> ( v32201(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2827,axiom,
    ! [VarCurr: state_type] :
      ( v32201(VarCurr)
    <=> ( v31656(VarCurr)
        & v32202(VarCurr) ) ) ).

tff(writeUnaryOperator_1798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32202(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2826,axiom,
    ! [VarCurr: state_type] :
      ( v32191(VarCurr)
    <=> ( v32192(VarCurr)
        | v32198(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2825,axiom,
    ! [VarCurr: state_type] :
      ( v32198(VarCurr)
    <=> ( v31650(VarCurr)
        & v32199(VarCurr) ) ) ).

tff(writeUnaryOperator_1797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32199(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2824,axiom,
    ! [VarCurr: state_type] :
      ( v32192(VarCurr)
    <=> ( v32193(VarCurr)
        | v31647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2823,axiom,
    ! [VarCurr: state_type] :
      ( v32193(VarCurr)
    <=> ( v32194(VarCurr)
        | v32197(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2822,axiom,
    ! [VarCurr: state_type] :
      ( v32197(VarCurr)
    <=> ( v31670(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2821,axiom,
    ! [VarCurr: state_type] :
      ( v32194(VarCurr)
    <=> ( v32195(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2820,axiom,
    ! [VarCurr: state_type] :
      ( v32195(VarCurr)
    <=> ( v31634(VarCurr)
        & v32196(VarCurr) ) ) ).

tff(writeUnaryOperator_1796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32196(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeUnaryOperator_1795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32188(VarCurr)
    <=> v31653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2819,axiom,
    ! [VarCurr: state_type] :
      ( v32171(VarCurr)
    <=> ( v32173(VarCurr)
        & v32174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2818,axiom,
    ! [VarCurr: state_type] :
      ( v32174(VarCurr)
    <=> ( v32175(VarCurr)
        | v32184(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2817,axiom,
    ! [VarCurr: state_type] :
      ( v32184(VarCurr)
    <=> ( v31673(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2816,axiom,
    ! [VarCurr: state_type] :
      ( v32175(VarCurr)
    <=> ( v32176(VarCurr)
        | v32182(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2815,axiom,
    ! [VarCurr: state_type] :
      ( v32182(VarCurr)
    <=> ( v32183(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2814,axiom,
    ! [VarCurr: state_type] :
      ( v32183(VarCurr)
    <=> ( v31670(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2813,axiom,
    ! [VarCurr: state_type] :
      ( v32176(VarCurr)
    <=> ( v32177(VarCurr)
        | v32180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2812,axiom,
    ! [VarCurr: state_type] :
      ( v32180(VarCurr)
    <=> ( v32181(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2811,axiom,
    ! [VarCurr: state_type] :
      ( v32181(VarCurr)
    <=> ( v31647(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2810,axiom,
    ! [VarCurr: state_type] :
      ( v32177(VarCurr)
    <=> ( v32178(VarCurr)
        | v32179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2809,axiom,
    ! [VarCurr: state_type] :
      ( v32179(VarCurr)
    <=> ( v31634(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2808,axiom,
    ! [VarCurr: state_type] :
      ( v32178(VarCurr)
    <=> ( v31650(VarCurr)
        | v31656(VarCurr) ) ) ).

tff(writeUnaryOperator_1794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32173(VarCurr)
    <=> v31653(VarCurr) ) ).

tff(addAssignment_16360,axiom,
    ! [VarCurr: state_type] :
      ( v31321(VarCurr,3)
    <=> v32021(VarCurr,3) ) ).

tff(addAssignment_16359,axiom,
    ! [VarCurr: state_type] :
      ( v31323(VarCurr,3)
    <=> v31325(VarCurr,3) ) ).

tff(addAssignment_16358,axiom,
    ! [VarCurr: state_type] :
      ( v31325(VarCurr,3)
    <=> v31327(VarCurr,3) ) ).

tff(addAssignment_16357,axiom,
    ! [VarNext: state_type] :
      ( v31327(VarNext,3)
    <=> v32163(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v32163(VarNext,B)
            <=> v31327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_374,axiom,
    ! [VarNext: state_type] :
      ( v32164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32163(VarNext,B)
          <=> v32015(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32164(VarNext)
      <=> v32165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32165(VarNext)
      <=> ( v32167(VarNext)
          & v32000(VarNext) ) ) ) ).

tff(writeUnaryOperator_1793,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32167(VarNext)
      <=> v32009(VarNext) ) ) ).

tff(addAssignment_16356,axiom,
    ! [VarCurr: state_type] :
      ( v31349(VarCurr,3)
    <=> v31351(VarCurr,3) ) ).

tff(addAssignment_16355,axiom,
    ! [VarCurr: state_type] :
      ( v31351(VarCurr,3)
    <=> v31353(VarCurr,3) ) ).

tff(addAssignment_16354,axiom,
    ! [VarCurr: state_type] :
      ( v31353(VarCurr,3)
    <=> v31355(VarCurr,3) ) ).

tff(addAssignment_16353,axiom,
    ! [VarCurr: state_type] :
      ( v31355(VarCurr,3)
    <=> v31998(VarCurr,3) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch_1,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32147(VarCurr)
     => ( v31357(VarCurr,3)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_2,axiom,
    ! [VarCurr: state_type] :
      ( v32147(VarCurr)
     => ( v31357(VarCurr,3)
      <=> v32160(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges3_1,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32150(VarCurr)
        & ~ v32151(VarCurr)
        & ~ v32153(VarCurr)
        & v32156(VarCurr) )
     => ( v32160(VarCurr)
      <=> v32129(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges2_1,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32150(VarCurr)
        & ~ v32151(VarCurr)
        & v32153(VarCurr) )
     => ( v32160(VarCurr)
      <=> v32111(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_373,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v32150(VarCurr)
        & v32151(VarCurr) )
     => ( v32160(VarCurr)
      <=> v32161(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_373,axiom,
    ! [VarCurr: state_type] :
      ( v32150(VarCurr)
     => ( v32160(VarCurr)
      <=> v32091(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31979(VarCurr)
     => ( v32161(VarCurr)
      <=> $true ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_224,axiom,
    ! [VarCurr: state_type] :
      ( v31979(VarCurr)
     => ( v32161(VarCurr)
      <=> v32106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2805,axiom,
    ! [VarCurr: state_type] :
      ( v32147(VarCurr)
    <=> ( v32148(VarCurr)
        | v32156(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2804,axiom,
    ! [VarCurr: state_type] :
      ( v32156(VarCurr)
    <=> ( v32157(VarCurr)
        & v32159(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2803,axiom,
    ! [VarCurr: state_type] :
      ( v32159(VarCurr)
    <=> ( v31996(VarCurr)
        & v31993(VarCurr) ) ) ).

tff(writeUnaryOperator_1792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32157(VarCurr)
    <=> v32158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2802,axiom,
    ! [VarCurr: state_type] :
      ( v32158(VarCurr)
    <=> ( v31975(VarCurr)
        | v31988(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2801,axiom,
    ! [VarCurr: state_type] :
      ( v32148(VarCurr)
    <=> ( v32149(VarCurr)
        | v32153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2800,axiom,
    ! [VarCurr: state_type] :
      ( v32153(VarCurr)
    <=> ( v32154(VarCurr)
        & v32155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2799,axiom,
    ! [VarCurr: state_type] :
      ( v32155(VarCurr)
    <=> ( v31986(VarCurr)
        & v31988(VarCurr) ) ) ).

tff(writeUnaryOperator_1791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32154(VarCurr)
    <=> v31975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2798,axiom,
    ! [VarCurr: state_type] :
      ( v32149(VarCurr)
    <=> ( v32150(VarCurr)
        | v32151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2797,axiom,
    ! [VarCurr: state_type] :
      ( v32151(VarCurr)
    <=> ( v32152(VarCurr)
        & v31981(VarCurr) ) ) ).

tff(writeUnaryOperator_1790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32152(VarCurr)
    <=> v31975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2796,axiom,
    ! [VarCurr: state_type] :
      ( v32150(VarCurr)
    <=> ( v31974(VarCurr)
        & v31975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2795,axiom,
    ! [VarCurr: state_type] :
      ( v32129(VarCurr)
    <=> ( v32131(VarCurr)
        & v32132(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2794,axiom,
    ! [VarCurr: state_type] :
      ( v32132(VarCurr)
    <=> ( v32133(VarCurr)
        | v32144(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2793,axiom,
    ! [VarCurr: state_type] :
      ( v32144(VarCurr)
    <=> ( v31673(VarCurr)
        & v32145(VarCurr) ) ) ).

tff(writeUnaryOperator_1789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32145(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2792,axiom,
    ! [VarCurr: state_type] :
      ( v32133(VarCurr)
    <=> ( v32134(VarCurr)
        | v32141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2791,axiom,
    ! [VarCurr: state_type] :
      ( v32141(VarCurr)
    <=> ( v32142(VarCurr)
        & v32143(VarCurr) ) ) ).

tff(writeUnaryOperator_1788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32143(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2790,axiom,
    ! [VarCurr: state_type] :
      ( v32142(VarCurr)
    <=> ( v31656(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2789,axiom,
    ! [VarCurr: state_type] :
      ( v32134(VarCurr)
    <=> ( v32135(VarCurr)
        | v31650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2788,axiom,
    ! [VarCurr: state_type] :
      ( v32135(VarCurr)
    <=> ( v32136(VarCurr)
        | v31647(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2787,axiom,
    ! [VarCurr: state_type] :
      ( v32136(VarCurr)
    <=> ( v32137(VarCurr)
        | v32138(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2786,axiom,
    ! [VarCurr: state_type] :
      ( v32138(VarCurr)
    <=> ( v32139(VarCurr)
        & v32140(VarCurr) ) ) ).

tff(writeUnaryOperator_1787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32140(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2785,axiom,
    ! [VarCurr: state_type] :
      ( v32139(VarCurr)
    <=> ( v31670(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2784,axiom,
    ! [VarCurr: state_type] :
      ( v32137(VarCurr)
    <=> ( v31634(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeUnaryOperator_1786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32131(VarCurr)
    <=> v31659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2783,axiom,
    ! [VarCurr: state_type] :
      ( v32111(VarCurr)
    <=> ( v32113(VarCurr)
        & v32114(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2782,axiom,
    ! [VarCurr: state_type] :
      ( v32114(VarCurr)
    <=> ( v32115(VarCurr)
        | v32125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2781,axiom,
    ! [VarCurr: state_type] :
      ( v32125(VarCurr)
    <=> ( v32126(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2780,axiom,
    ! [VarCurr: state_type] :
      ( v32126(VarCurr)
    <=> ( v31673(VarCurr)
        & v32127(VarCurr) ) ) ).

tff(writeUnaryOperator_1785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32127(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2779,axiom,
    ! [VarCurr: state_type] :
      ( v32115(VarCurr)
    <=> ( v32116(VarCurr)
        | v32124(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2778,axiom,
    ! [VarCurr: state_type] :
      ( v32124(VarCurr)
    <=> ( v31650(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2777,axiom,
    ! [VarCurr: state_type] :
      ( v32116(VarCurr)
    <=> ( v32117(VarCurr)
        | v32121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2776,axiom,
    ! [VarCurr: state_type] :
      ( v32121(VarCurr)
    <=> ( v32122(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2775,axiom,
    ! [VarCurr: state_type] :
      ( v32122(VarCurr)
    <=> ( v31647(VarCurr)
        & v32123(VarCurr) ) ) ).

tff(writeUnaryOperator_1784,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32123(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2774,axiom,
    ! [VarCurr: state_type] :
      ( v32117(VarCurr)
    <=> ( v32118(VarCurr)
        | v32119(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2773,axiom,
    ! [VarCurr: state_type] :
      ( v32119(VarCurr)
    <=> ( v31670(VarCurr)
        & v32120(VarCurr) ) ) ).

tff(writeUnaryOperator_1783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32120(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2772,axiom,
    ! [VarCurr: state_type] :
      ( v32118(VarCurr)
    <=> ( v31634(VarCurr)
        | v31656(VarCurr) ) ) ).

tff(writeUnaryOperator_1782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32113(VarCurr)
    <=> v31659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2771,axiom,
    ! [VarCurr: state_type] :
      ( v32106(VarCurr)
    <=> ( v32108(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2770,axiom,
    ! [VarCurr: state_type] :
      ( v32108(VarCurr)
    <=> ( v32109(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeUnaryOperator_1781,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32109(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2769,axiom,
    ! [VarCurr: state_type] :
      ( v32091(VarCurr)
    <=> ( v32093(VarCurr)
        & v32094(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2768,axiom,
    ! [VarCurr: state_type] :
      ( v32094(VarCurr)
    <=> ( v32095(VarCurr)
        | v32104(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2767,axiom,
    ! [VarCurr: state_type] :
      ( v32104(VarCurr)
    <=> ( v31656(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2766,axiom,
    ! [VarCurr: state_type] :
      ( v32095(VarCurr)
    <=> ( v32096(VarCurr)
        | v32102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2765,axiom,
    ! [VarCurr: state_type] :
      ( v32102(VarCurr)
    <=> ( v32103(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2764,axiom,
    ! [VarCurr: state_type] :
      ( v32103(VarCurr)
    <=> ( v31650(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2763,axiom,
    ! [VarCurr: state_type] :
      ( v32096(VarCurr)
    <=> ( v32097(VarCurr)
        | v32101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2762,axiom,
    ! [VarCurr: state_type] :
      ( v32101(VarCurr)
    <=> ( v31647(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2761,axiom,
    ! [VarCurr: state_type] :
      ( v32097(VarCurr)
    <=> ( v32098(VarCurr)
        | v32099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2760,axiom,
    ! [VarCurr: state_type] :
      ( v32099(VarCurr)
    <=> ( v32100(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2759,axiom,
    ! [VarCurr: state_type] :
      ( v32100(VarCurr)
    <=> ( v31634(VarCurr)
        & v31631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2758,axiom,
    ! [VarCurr: state_type] :
      ( v32098(VarCurr)
    <=> ( v31670(VarCurr)
        | v31673(VarCurr) ) ) ).

tff(writeUnaryOperator_1780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32093(VarCurr)
    <=> v31659(VarCurr) ) ).

tff(addAssignment_16352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31597(VarCurr,B)
      <=> v31599(VarCurr,B) ) ) ).

tff(addAssignment_16351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31599(VarCurr,B)
      <=> v31601(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32074(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v31601(VarNext,B)
            <=> v31601(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_372,axiom,
    ! [VarNext: state_type] :
      ( v32074(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v31601(VarNext,B)
          <=> v32084(VarNext,B) ) ) ) ).

tff(addAssignment_16350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32084(VarNext,B)
          <=> v32082(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32082(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_223,axiom,
    ! [VarCurr: state_type] :
      ( v32085(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32082(VarCurr,B)
          <=> v31611(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2757,axiom,
    ! [VarCurr: state_type] :
      ( v32085(VarCurr)
    <=> ( v32086(VarCurr)
        & v32087(VarCurr) ) ) ).

tff(writeUnaryOperator_1779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32087(VarCurr)
    <=> v31607(VarCurr) ) ).

tff(writeUnaryOperator_1778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32086(VarCurr)
    <=> v31603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32074(VarNext)
      <=> v32075(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32075(VarNext)
      <=> ( v32076(VarNext)
          & v32069(VarNext) ) ) ) ).

tff(writeUnaryOperator_1777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32076(VarNext)
      <=> v32078(VarNext) ) ) ).

tff(addAssignment_16349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32078(VarNext)
      <=> v32069(VarCurr) ) ) ).

tff(addAssignment_16348,axiom,
    ! [VarCurr: state_type] :
      ( v32069(VarCurr)
    <=> v32071(VarCurr) ) ).

tff(addAssignment_16347,axiom,
    ! [VarCurr: state_type] :
      ( v32071(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31611(VarCurr,B)
      <=> v31613(VarCurr,B) ) ) ).

tff(addAssignment_16345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31613(VarCurr,B)
      <=> v31615(VarCurr,B) ) ) ).

tff(addAssignment_16344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v31615(VarCurr,B)
      <=> v31617(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32024(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v31617(VarCurr,B)
          <=> v32025(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch_1,axiom,
    ! [VarCurr: state_type] :
      ( v32024(VarCurr)
     => ( ( v31617(VarCurr,6)
        <=> v31409(VarCurr,9) )
        & ( v31617(VarCurr,5)
        <=> v31409(VarCurr,8) )
        & ( v31617(VarCurr,4)
        <=> v31409(VarCurr,7) )
        & ( v31617(VarCurr,3)
        <=> v31409(VarCurr,6) )
        & ( v31617(VarCurr,2)
        <=> v31409(VarCurr,5) )
        & ( v31617(VarCurr,1)
        <=> v31409(VarCurr,4) )
        & ( v31617(VarCurr,0)
        <=> v31409(VarCurr,3) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31627(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32025(VarCurr,B)
          <=> v31597(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_222,axiom,
    ! [VarCurr: state_type] :
      ( v31627(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v32025(VarCurr,B)
          <=> v32026(VarCurr,B) ) ) ) ).

tff(addAssignment_16343,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,0)
    <=> v32066(VarCurr) ) ).

tff(addAssignment_16342,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,1)
    <=> v32064(VarCurr) ) ).

tff(addAssignment_16341,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,2)
    <=> v32060(VarCurr) ) ).

tff(addAssignment_16340,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,3)
    <=> v32056(VarCurr) ) ).

tff(addAssignment_16339,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,4)
    <=> v32052(VarCurr) ) ).

tff(addAssignment_16338,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,5)
    <=> v32048(VarCurr) ) ).

tff(addAssignment_16337,axiom,
    ! [VarCurr: state_type] :
      ( v32026(VarCurr,6)
    <=> v32028(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2754,axiom,
    ! [VarCurr: state_type] :
      ( v32064(VarCurr)
    <=> ( v32065(VarCurr)
        & v32067(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2753,axiom,
    ! [VarCurr: state_type] :
      ( v32067(VarCurr)
    <=> ( v31597(VarCurr,0)
        | v32041(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_311,axiom,
    ! [VarCurr: state_type] :
      ( v32065(VarCurr)
    <=> ( v32066(VarCurr)
        | v31597(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32066(VarCurr)
    <=> v31597(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2752,axiom,
    ! [VarCurr: state_type] :
      ( v32060(VarCurr)
    <=> ( v32061(VarCurr)
        & v32063(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2751,axiom,
    ! [VarCurr: state_type] :
      ( v32063(VarCurr)
    <=> ( v32039(VarCurr)
        | v32042(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_310,axiom,
    ! [VarCurr: state_type] :
      ( v32061(VarCurr)
    <=> ( v32062(VarCurr)
        | v31597(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1775,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32062(VarCurr)
    <=> v32039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2750,axiom,
    ! [VarCurr: state_type] :
      ( v32056(VarCurr)
    <=> ( v32057(VarCurr)
        & v32059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2749,axiom,
    ! [VarCurr: state_type] :
      ( v32059(VarCurr)
    <=> ( v32037(VarCurr)
        | v32043(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_309,axiom,
    ! [VarCurr: state_type] :
      ( v32057(VarCurr)
    <=> ( v32058(VarCurr)
        | v31597(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32058(VarCurr)
    <=> v32037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2748,axiom,
    ! [VarCurr: state_type] :
      ( v32052(VarCurr)
    <=> ( v32053(VarCurr)
        & v32055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2747,axiom,
    ! [VarCurr: state_type] :
      ( v32055(VarCurr)
    <=> ( v32035(VarCurr)
        | v32044(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_308,axiom,
    ! [VarCurr: state_type] :
      ( v32053(VarCurr)
    <=> ( v32054(VarCurr)
        | v31597(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32054(VarCurr)
    <=> v32035(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2746,axiom,
    ! [VarCurr: state_type] :
      ( v32048(VarCurr)
    <=> ( v32049(VarCurr)
        & v32051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2745,axiom,
    ! [VarCurr: state_type] :
      ( v32051(VarCurr)
    <=> ( v32033(VarCurr)
        | v32045(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_307,axiom,
    ! [VarCurr: state_type] :
      ( v32049(VarCurr)
    <=> ( v32050(VarCurr)
        | v31597(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32050(VarCurr)
    <=> v32033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2744,axiom,
    ! [VarCurr: state_type] :
      ( v32028(VarCurr)
    <=> ( v32029(VarCurr)
        & v32046(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2743,axiom,
    ! [VarCurr: state_type] :
      ( v32046(VarCurr)
    <=> ( v32031(VarCurr)
        | v32047(VarCurr) ) ) ).

tff(writeUnaryOperator_1771,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32047(VarCurr)
    <=> v31597(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_306,axiom,
    ! [VarCurr: state_type] :
      ( v32029(VarCurr)
    <=> ( v32030(VarCurr)
        | v31597(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32030(VarCurr)
    <=> v32031(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_305,axiom,
    ! [VarCurr: state_type] :
      ( v32031(VarCurr)
    <=> ( v31597(VarCurr,5)
        | v32032(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2742,axiom,
    ! [VarCurr: state_type] :
      ( v32032(VarCurr)
    <=> ( v32033(VarCurr)
        & v32045(VarCurr) ) ) ).

tff(writeUnaryOperator_1769,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32045(VarCurr)
    <=> v31597(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_304,axiom,
    ! [VarCurr: state_type] :
      ( v32033(VarCurr)
    <=> ( v31597(VarCurr,4)
        | v32034(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2741,axiom,
    ! [VarCurr: state_type] :
      ( v32034(VarCurr)
    <=> ( v32035(VarCurr)
        & v32044(VarCurr) ) ) ).

tff(writeUnaryOperator_1768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32044(VarCurr)
    <=> v31597(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_303,axiom,
    ! [VarCurr: state_type] :
      ( v32035(VarCurr)
    <=> ( v31597(VarCurr,3)
        | v32036(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2740,axiom,
    ! [VarCurr: state_type] :
      ( v32036(VarCurr)
    <=> ( v32037(VarCurr)
        & v32043(VarCurr) ) ) ).

tff(writeUnaryOperator_1767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32043(VarCurr)
    <=> v31597(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_302,axiom,
    ! [VarCurr: state_type] :
      ( v32037(VarCurr)
    <=> ( v31597(VarCurr,2)
        | v32038(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2739,axiom,
    ! [VarCurr: state_type] :
      ( v32038(VarCurr)
    <=> ( v32039(VarCurr)
        & v32042(VarCurr) ) ) ).

tff(writeUnaryOperator_1766,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32042(VarCurr)
    <=> v31597(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_301,axiom,
    ! [VarCurr: state_type] :
      ( v32039(VarCurr)
    <=> ( v31597(VarCurr,1)
        | v32040(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2738,axiom,
    ! [VarCurr: state_type] :
      ( v32040(VarCurr)
    <=> ( v31597(VarCurr,0)
        & v32041(VarCurr) ) ) ).

tff(writeUnaryOperator_1765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32041(VarCurr)
    <=> v31597(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2737,axiom,
    ! [VarCurr: state_type] :
      ( v32024(VarCurr)
    <=> ( v31381(VarCurr)
        | v31385(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_300,axiom,
    ! [VarCurr: state_type] :
      ( v31627(VarCurr)
    <=> ( v31321(VarCurr,1)
        & v31549(VarCurr) ) ) ).

tff(addAssignment_16336,axiom,
    ! [VarCurr: state_type] :
      ( v31321(VarCurr,1)
    <=> v32021(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v32021(VarCurr,B)
      <=> ( v31323(VarCurr,B)
        <~> b0001(B) ) ) ) ).

tff(addAssignment_16335,axiom,
    ! [VarCurr: state_type] :
      ( v31323(VarCurr,1)
    <=> v31325(VarCurr,1) ) ).

tff(addAssignment_16334,axiom,
    ! [VarCurr: state_type] :
      ( v31325(VarCurr,1)
    <=> v31327(VarCurr,1) ) ).

tff(addAssignment_16333,axiom,
    ! [VarNext: state_type] :
      ( v31327(VarNext,1)
    <=> v32004(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32005(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v32004(VarNext,B)
            <=> v31327(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_371,axiom,
    ! [VarNext: state_type] :
      ( v32005(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32004(VarNext,B)
          <=> v32015(VarNext,B) ) ) ) ).

tff(addAssignment_16332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32015(VarNext,B)
          <=> v32013(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32013(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_221,axiom,
    ! [VarCurr: state_type] :
      ( v32016(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v32013(VarCurr,B)
          <=> v31349(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2736,axiom,
    ! [VarCurr: state_type] :
      ( v32016(VarCurr)
    <=> ( v32017(VarCurr)
        & v32018(VarCurr) ) ) ).

tff(writeUnaryOperator_1764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32018(VarCurr)
    <=> v31339(VarCurr) ) ).

tff(writeUnaryOperator_1763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v32017(VarCurr)
    <=> v31329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32005(VarNext)
      <=> v32006(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32006(VarNext)
      <=> ( v32007(VarNext)
          & v32000(VarNext) ) ) ) ).

tff(writeUnaryOperator_1762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v32007(VarNext)
      <=> v32009(VarNext) ) ) ).

tff(addAssignment_16331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v32009(VarNext)
      <=> v32000(VarCurr) ) ) ).

tff(addAssignment_16330,axiom,
    ! [VarCurr: state_type] :
      ( v32000(VarCurr)
    <=> v32002(VarCurr) ) ).

tff(addAssignment_16329,axiom,
    ! [VarCurr: state_type] :
      ( v32002(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16328,axiom,
    ! [VarCurr: state_type] :
      ( v31349(VarCurr,1)
    <=> v31351(VarCurr,1) ) ).

tff(addAssignment_16327,axiom,
    ! [VarCurr: state_type] :
      ( v31351(VarCurr,1)
    <=> v31353(VarCurr,1) ) ).

tff(addAssignment_16326,axiom,
    ! [VarCurr: state_type] :
      ( v31353(VarCurr,1)
    <=> v31355(VarCurr,1) ) ).

tff(addAssignment_16325,axiom,
    ! [VarCurr: state_type] :
      ( v31355(VarCurr,1)
    <=> v31998(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v31998(VarCurr,B)
      <=> ( v31357(VarCurr,B)
        <~> b0001(B) ) ) ) ).

tff(addConditionBooleanCondShiftedRangesElseBranch,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31970(VarCurr)
     => ( v31357(VarCurr,1)
      <=> $false ) ) ).

tff(addConditionBooleanCondShiftedRangesThenBranch,axiom,
    ! [VarCurr: state_type] :
      ( v31970(VarCurr)
     => ( v31357(VarCurr,1)
      <=> v31994(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges3,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31973(VarCurr)
        & ~ v31976(VarCurr)
        & ~ v31982(VarCurr)
        & v31989(VarCurr) )
     => ( v31994(VarCurr)
      <=> v31995(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges2,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31973(VarCurr)
        & ~ v31976(VarCurr)
        & v31982(VarCurr) )
     => ( v31994(VarCurr)
      <=> v31947(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_370,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v31973(VarCurr)
        & v31976(VarCurr) )
     => ( v31994(VarCurr)
      <=> v31689(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_370,axiom,
    ! [VarCurr: state_type] :
      ( v31973(VarCurr)
     => ( v31994(VarCurr)
      <=> v31629(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31996(VarCurr)
     => ( v31995(VarCurr)
      <=> $true ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_220,axiom,
    ! [VarCurr: state_type] :
      ( v31996(VarCurr)
     => ( v31995(VarCurr)
      <=> v31965(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2733,axiom,
    ! [VarCurr: state_type] :
      ( v31996(VarCurr)
    <=> ( v31997(VarCurr)
        & v31549(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_140,axiom,
    ! [VarCurr: state_type] :
      ( v31997(VarCurr)
    <=> ( ( v31597(VarCurr,6)
        <=> $false )
        & ( v31597(VarCurr,5)
        <=> $false )
        & ( v31597(VarCurr,4)
        <=> $false )
        & ( v31597(VarCurr,3)
        <=> $false )
        & ( v31597(VarCurr,2)
        <=> $false )
        & ( v31597(VarCurr,1)
        <=> $false )
        & ( v31597(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2732,axiom,
    ! [VarCurr: state_type] :
      ( v31970(VarCurr)
    <=> ( v31971(VarCurr)
        | v31989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2731,axiom,
    ! [VarCurr: state_type] :
      ( v31989(VarCurr)
    <=> ( v31990(VarCurr)
        & v31993(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_139,axiom,
    ! [VarCurr: state_type] :
      ( v31993(VarCurr)
    <=> ( $true
      <=> v31321(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31990(VarCurr)
    <=> v31991(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2730,axiom,
    ! [VarCurr: state_type] :
      ( v31991(VarCurr)
    <=> ( v31992(VarCurr)
        | v31988(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2729,axiom,
    ! [VarCurr: state_type] :
      ( v31992(VarCurr)
    <=> ( v31975(VarCurr)
        | v31981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2728,axiom,
    ! [VarCurr: state_type] :
      ( v31971(VarCurr)
    <=> ( v31972(VarCurr)
        | v31982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2727,axiom,
    ! [VarCurr: state_type] :
      ( v31982(VarCurr)
    <=> ( v31983(VarCurr)
        & v31985(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2726,axiom,
    ! [VarCurr: state_type] :
      ( v31985(VarCurr)
    <=> ( v31986(VarCurr)
        & v31988(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_138,axiom,
    ! [VarCurr: state_type] :
      ( v31988(VarCurr)
    <=> ( $true
      <=> v31321(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2725,axiom,
    ! [VarCurr: state_type] :
      ( v31986(VarCurr)
    <=> ( v31987(VarCurr)
        & v31549(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_137,axiom,
    ! [VarCurr: state_type] :
      ( v31987(VarCurr)
    <=> ( ( v31387(VarCurr,6)
        <=> $false )
        & ( v31387(VarCurr,5)
        <=> $false )
        & ( v31387(VarCurr,4)
        <=> $false )
        & ( v31387(VarCurr,3)
        <=> $false )
        & ( v31387(VarCurr,2)
        <=> $false )
        & ( v31387(VarCurr,1)
        <=> $false )
        & ( v31387(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_723,axiom,
    ~ b0000001(6) ).

tff(bitBlastConstant_722,axiom,
    ~ b0000001(5) ).

tff(bitBlastConstant_721,axiom,
    ~ b0000001(4) ).

tff(bitBlastConstant_720,axiom,
    ~ b0000001(3) ).

tff(bitBlastConstant_719,axiom,
    ~ b0000001(2) ).

tff(bitBlastConstant_718,axiom,
    ~ b0000001(1) ).

tff(bitBlastConstant_717,axiom,
    b0000001(0) ).

tff(writeUnaryOperator_1760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31983(VarCurr)
    <=> v31984(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2724,axiom,
    ! [VarCurr: state_type] :
      ( v31984(VarCurr)
    <=> ( v31975(VarCurr)
        | v31981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2723,axiom,
    ! [VarCurr: state_type] :
      ( v31972(VarCurr)
    <=> ( v31973(VarCurr)
        | v31976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2722,axiom,
    ! [VarCurr: state_type] :
      ( v31976(VarCurr)
    <=> ( v31977(VarCurr)
        & v31978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2721,axiom,
    ! [VarCurr: state_type] :
      ( v31978(VarCurr)
    <=> ( v31979(VarCurr)
        & v31981(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_136,axiom,
    ! [VarCurr: state_type] :
      ( v31981(VarCurr)
    <=> ( $true
      <=> v31321(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2720,axiom,
    ! [VarCurr: state_type] :
      ( v31979(VarCurr)
    <=> ( v31980(VarCurr)
        & v31549(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_135,axiom,
    ! [VarCurr: state_type] :
      ( v31980(VarCurr)
    <=> ( ( v31359(VarCurr,4)
        <=> $false )
        & ( v31359(VarCurr,3)
        <=> $false )
        & ( v31359(VarCurr,2)
        <=> $false )
        & ( v31359(VarCurr,1)
        <=> $false )
        & ( v31359(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeUnaryOperator_1759,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31977(VarCurr)
    <=> v31975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2719,axiom,
    ! [VarCurr: state_type] :
      ( v31973(VarCurr)
    <=> ( v31974(VarCurr)
        & v31975(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_134,axiom,
    ! [VarCurr: state_type] :
      ( v31975(VarCurr)
    <=> ( $true
      <=> v31321(VarCurr,0) ) ) ).

tff(addBitVectorEqualityBitBlasted_133,axiom,
    ! [VarCurr: state_type] :
      ( v31974(VarCurr)
    <=> ( ( v31489(VarCurr,1)
        <=> $true )
        & ( v31489(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2718,axiom,
    ! [VarCurr: state_type] :
      ( v31965(VarCurr)
    <=> ( v31967(VarCurr)
        & v31968(VarCurr) ) ) ).

tff(writeUnaryOperator_1758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31968(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2717,axiom,
    ! [VarCurr: state_type] :
      ( v31967(VarCurr)
    <=> ( v31653(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2716,axiom,
    ! [VarCurr: state_type] :
      ( v31947(VarCurr)
    <=> ( v31949(VarCurr)
        & v31950(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2715,axiom,
    ! [VarCurr: state_type] :
      ( v31950(VarCurr)
    <=> ( v31951(VarCurr)
        | v31673(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2714,axiom,
    ! [VarCurr: state_type] :
      ( v31951(VarCurr)
    <=> ( v31952(VarCurr)
        | v31963(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2713,axiom,
    ! [VarCurr: state_type] :
      ( v31963(VarCurr)
    <=> ( v31656(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2712,axiom,
    ! [VarCurr: state_type] :
      ( v31952(VarCurr)
    <=> ( v31953(VarCurr)
        | v31650(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2711,axiom,
    ! [VarCurr: state_type] :
      ( v31953(VarCurr)
    <=> ( v31954(VarCurr)
        | v31961(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2710,axiom,
    ! [VarCurr: state_type] :
      ( v31961(VarCurr)
    <=> ( v31647(VarCurr)
        & v31962(VarCurr) ) ) ).

tff(writeUnaryOperator_1757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31962(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2709,axiom,
    ! [VarCurr: state_type] :
      ( v31954(VarCurr)
    <=> ( v31955(VarCurr)
        | v31958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2708,axiom,
    ! [VarCurr: state_type] :
      ( v31958(VarCurr)
    <=> ( v31959(VarCurr)
        & v31960(VarCurr) ) ) ).

tff(writeUnaryOperator_1756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31960(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2707,axiom,
    ! [VarCurr: state_type] :
      ( v31959(VarCurr)
    <=> ( v31670(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2706,axiom,
    ! [VarCurr: state_type] :
      ( v31955(VarCurr)
    <=> ( v31956(VarCurr)
        & v31957(VarCurr) ) ) ).

tff(writeUnaryOperator_1755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31957(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2705,axiom,
    ! [VarCurr: state_type] :
      ( v31956(VarCurr)
    <=> ( v31634(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeUnaryOperator_1754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31949(VarCurr)
    <=> v31631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2704,axiom,
    ! [VarCurr: state_type] :
      ( v31689(VarCurr)
    <=> ( v31931(VarCurr)
        & v31932(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2703,axiom,
    ! [VarCurr: state_type] :
      ( v31932(VarCurr)
    <=> ( v31933(VarCurr)
        | v31945(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2702,axiom,
    ! [VarCurr: state_type] :
      ( v31945(VarCurr)
    <=> ( v31673(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2701,axiom,
    ! [VarCurr: state_type] :
      ( v31933(VarCurr)
    <=> ( v31934(VarCurr)
        | v31656(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2700,axiom,
    ! [VarCurr: state_type] :
      ( v31934(VarCurr)
    <=> ( v31935(VarCurr)
        | v31942(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2699,axiom,
    ! [VarCurr: state_type] :
      ( v31942(VarCurr)
    <=> ( v31943(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2698,axiom,
    ! [VarCurr: state_type] :
      ( v31943(VarCurr)
    <=> ( v31650(VarCurr)
        & v31944(VarCurr) ) ) ).

tff(writeUnaryOperator_1753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31944(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2697,axiom,
    ! [VarCurr: state_type] :
      ( v31935(VarCurr)
    <=> ( v31936(VarCurr)
        | v31939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2696,axiom,
    ! [VarCurr: state_type] :
      ( v31939(VarCurr)
    <=> ( v31940(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2695,axiom,
    ! [VarCurr: state_type] :
      ( v31940(VarCurr)
    <=> ( v31647(VarCurr)
        & v31941(VarCurr) ) ) ).

tff(writeUnaryOperator_1752,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31941(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2694,axiom,
    ! [VarCurr: state_type] :
      ( v31936(VarCurr)
    <=> ( v31937(VarCurr)
        | v31670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2693,axiom,
    ! [VarCurr: state_type] :
      ( v31937(VarCurr)
    <=> ( v31634(VarCurr)
        & v31938(VarCurr) ) ) ).

tff(writeUnaryOperator_1751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31938(VarCurr)
    <=> v31691(VarCurr) ) ).

tff(writeUnaryOperator_1750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31931(VarCurr)
    <=> v31631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2692,axiom,
    ! [VarCurr: state_type] :
      ( v31691(VarCurr)
    <=> ( v31928(VarCurr)
        & v31929(VarCurr) ) ) ).

tff(writeUnaryOperator_1749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31929(VarCurr)
    <=> v31715(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_132,axiom,
    ! [VarCurr: state_type] :
      ( v31928(VarCurr)
    <=> ( ( v31693(VarCurr,5)
        <=> $false )
        & ( v31693(VarCurr,4)
        <=> $false )
        & ( v31693(VarCurr,3)
        <=> $false )
        & ( v31693(VarCurr,2)
        <=> $false )
        & ( v31693(VarCurr,1)
        <=> $false )
        & ( v31693(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v31693(VarCurr,B)
      <=> v31695(VarCurr,B) ) ) ).

tff(addAssignment_16323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v31695(VarCurr,B)
      <=> v31697(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31911(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v31697(VarNext,B)
            <=> v31697(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_369,axiom,
    ! [VarNext: state_type] :
      ( v31911(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31697(VarNext,B)
          <=> v31921(VarNext,B) ) ) ) ).

tff(addAssignment_16322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31921(VarNext,B)
          <=> v31919(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31922(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31919(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_219,axiom,
    ! [VarCurr: state_type] :
      ( v31922(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31919(VarCurr,B)
          <=> v31707(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2691,axiom,
    ! [VarCurr: state_type] :
      ( v31922(VarCurr)
    <=> ( v31923(VarCurr)
        & v31924(VarCurr) ) ) ).

tff(writeUnaryOperator_1748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31924(VarCurr)
    <=> v31703(VarCurr) ) ).

tff(writeUnaryOperator_1747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31923(VarCurr)
    <=> v31699(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31911(VarNext)
      <=> v31912(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31912(VarNext)
      <=> ( v31913(VarNext)
          & v31906(VarNext) ) ) ) ).

tff(writeUnaryOperator_1746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31913(VarNext)
      <=> v31915(VarNext) ) ) ).

tff(addAssignment_16321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31915(VarNext)
      <=> v31906(VarCurr) ) ) ).

tff(addAssignment_16320,axiom,
    ! [VarCurr: state_type] :
      ( v31906(VarCurr)
    <=> v31908(VarCurr) ) ).

tff(addAssignment_16319,axiom,
    ! [VarCurr: state_type] :
      ( v31908(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v31707(VarCurr,B)
      <=> v31709(VarCurr,B) ) ) ).

tff(addAssignment_16317,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v31709(VarCurr,B)
      <=> v31711(VarCurr,B) ) ) ).

tff(addAssignment_16316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v31711(VarCurr,B)
      <=> v31713(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31713(VarCurr,B)
          <=> v31869(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_218,axiom,
    ! [VarCurr: state_type] :
      ( v31823(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31713(VarCurr,B)
          <=> v31834(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31385(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31869(VarCurr,B)
          <=> v31693(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_217,axiom,
    ! [VarCurr: state_type] :
      ( v31385(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v31869(VarCurr,B)
          <=> v31870(VarCurr,B) ) ) ) ).

tff(addAssignment_16315,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,0)
    <=> v31903(VarCurr) ) ).

tff(addAssignment_16314,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,1)
    <=> v31901(VarCurr) ) ).

tff(addAssignment_16313,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,2)
    <=> v31897(VarCurr) ) ).

tff(addAssignment_16312,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,3)
    <=> v31893(VarCurr) ) ).

tff(addAssignment_16311,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,4)
    <=> v31889(VarCurr) ) ).

tff(addAssignment_16310,axiom,
    ! [VarCurr: state_type] :
      ( v31870(VarCurr,5)
    <=> v31872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2688,axiom,
    ! [VarCurr: state_type] :
      ( v31901(VarCurr)
    <=> ( v31902(VarCurr)
        & v31904(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2687,axiom,
    ! [VarCurr: state_type] :
      ( v31904(VarCurr)
    <=> ( v31693(VarCurr,0)
        | v31883(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_299,axiom,
    ! [VarCurr: state_type] :
      ( v31902(VarCurr)
    <=> ( v31903(VarCurr)
        | v31693(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1745,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31903(VarCurr)
    <=> v31693(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2686,axiom,
    ! [VarCurr: state_type] :
      ( v31897(VarCurr)
    <=> ( v31898(VarCurr)
        & v31900(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2685,axiom,
    ! [VarCurr: state_type] :
      ( v31900(VarCurr)
    <=> ( v31881(VarCurr)
        | v31884(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_298,axiom,
    ! [VarCurr: state_type] :
      ( v31898(VarCurr)
    <=> ( v31899(VarCurr)
        | v31693(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31899(VarCurr)
    <=> v31881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2684,axiom,
    ! [VarCurr: state_type] :
      ( v31893(VarCurr)
    <=> ( v31894(VarCurr)
        & v31896(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2683,axiom,
    ! [VarCurr: state_type] :
      ( v31896(VarCurr)
    <=> ( v31879(VarCurr)
        | v31885(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_297,axiom,
    ! [VarCurr: state_type] :
      ( v31894(VarCurr)
    <=> ( v31895(VarCurr)
        | v31693(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31895(VarCurr)
    <=> v31879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2682,axiom,
    ! [VarCurr: state_type] :
      ( v31889(VarCurr)
    <=> ( v31890(VarCurr)
        & v31892(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2681,axiom,
    ! [VarCurr: state_type] :
      ( v31892(VarCurr)
    <=> ( v31877(VarCurr)
        | v31886(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_296,axiom,
    ! [VarCurr: state_type] :
      ( v31890(VarCurr)
    <=> ( v31891(VarCurr)
        | v31693(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31891(VarCurr)
    <=> v31877(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2680,axiom,
    ! [VarCurr: state_type] :
      ( v31872(VarCurr)
    <=> ( v31873(VarCurr)
        & v31887(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2679,axiom,
    ! [VarCurr: state_type] :
      ( v31887(VarCurr)
    <=> ( v31875(VarCurr)
        | v31888(VarCurr) ) ) ).

tff(writeUnaryOperator_1741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31888(VarCurr)
    <=> v31693(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_295,axiom,
    ! [VarCurr: state_type] :
      ( v31873(VarCurr)
    <=> ( v31874(VarCurr)
        | v31693(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31874(VarCurr)
    <=> v31875(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_294,axiom,
    ! [VarCurr: state_type] :
      ( v31875(VarCurr)
    <=> ( v31693(VarCurr,4)
        | v31876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2678,axiom,
    ! [VarCurr: state_type] :
      ( v31876(VarCurr)
    <=> ( v31877(VarCurr)
        & v31886(VarCurr) ) ) ).

tff(writeUnaryOperator_1739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31886(VarCurr)
    <=> v31693(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_293,axiom,
    ! [VarCurr: state_type] :
      ( v31877(VarCurr)
    <=> ( v31693(VarCurr,3)
        | v31878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2677,axiom,
    ! [VarCurr: state_type] :
      ( v31878(VarCurr)
    <=> ( v31879(VarCurr)
        & v31885(VarCurr) ) ) ).

tff(writeUnaryOperator_1738,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31885(VarCurr)
    <=> v31693(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_292,axiom,
    ! [VarCurr: state_type] :
      ( v31879(VarCurr)
    <=> ( v31693(VarCurr,2)
        | v31880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2676,axiom,
    ! [VarCurr: state_type] :
      ( v31880(VarCurr)
    <=> ( v31881(VarCurr)
        & v31884(VarCurr) ) ) ).

tff(writeUnaryOperator_1737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31884(VarCurr)
    <=> v31693(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_291,axiom,
    ! [VarCurr: state_type] :
      ( v31881(VarCurr)
    <=> ( v31693(VarCurr,1)
        | v31882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2675,axiom,
    ! [VarCurr: state_type] :
      ( v31882(VarCurr)
    <=> ( v31693(VarCurr,0)
        & v31883(VarCurr) ) ) ).

tff(writeUnaryOperator_1736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31883(VarCurr)
    <=> v31693(VarCurr,1) ) ).

tff(addAssignment_16309,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,0)
    <=> v31867(VarCurr) ) ).

tff(addAssignment_16308,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,1)
    <=> v31865(VarCurr) ) ).

tff(addAssignment_16307,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,2)
    <=> v31861(VarCurr) ) ).

tff(addAssignment_16306,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,3)
    <=> v31857(VarCurr) ) ).

tff(addAssignment_16305,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,4)
    <=> v31853(VarCurr) ) ).

tff(addAssignment_16304,axiom,
    ! [VarCurr: state_type] :
      ( v31834(VarCurr,5)
    <=> v31836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2674,axiom,
    ! [VarCurr: state_type] :
      ( v31865(VarCurr)
    <=> ( v31866(VarCurr)
        & v31868(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_290,axiom,
    ! [VarCurr: state_type] :
      ( v31868(VarCurr)
    <=> ( v31409(VarCurr,26)
        | v31847(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_289,axiom,
    ! [VarCurr: state_type] :
      ( v31866(VarCurr)
    <=> ( v31867(VarCurr)
        | v31409(VarCurr,27) ) ) ).

tff(writeUnaryOperator_1735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31867(VarCurr)
    <=> v31409(VarCurr,26) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2673,axiom,
    ! [VarCurr: state_type] :
      ( v31861(VarCurr)
    <=> ( v31862(VarCurr)
        & v31864(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2672,axiom,
    ! [VarCurr: state_type] :
      ( v31864(VarCurr)
    <=> ( v31845(VarCurr)
        | v31848(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_288,axiom,
    ! [VarCurr: state_type] :
      ( v31862(VarCurr)
    <=> ( v31863(VarCurr)
        | v31409(VarCurr,28) ) ) ).

tff(writeUnaryOperator_1734,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31863(VarCurr)
    <=> v31845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2671,axiom,
    ! [VarCurr: state_type] :
      ( v31857(VarCurr)
    <=> ( v31858(VarCurr)
        & v31860(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2670,axiom,
    ! [VarCurr: state_type] :
      ( v31860(VarCurr)
    <=> ( v31843(VarCurr)
        | v31849(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_287,axiom,
    ! [VarCurr: state_type] :
      ( v31858(VarCurr)
    <=> ( v31859(VarCurr)
        | v31409(VarCurr,29) ) ) ).

tff(writeUnaryOperator_1733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31859(VarCurr)
    <=> v31843(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2669,axiom,
    ! [VarCurr: state_type] :
      ( v31853(VarCurr)
    <=> ( v31854(VarCurr)
        & v31856(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2668,axiom,
    ! [VarCurr: state_type] :
      ( v31856(VarCurr)
    <=> ( v31841(VarCurr)
        | v31850(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_286,axiom,
    ! [VarCurr: state_type] :
      ( v31854(VarCurr)
    <=> ( v31855(VarCurr)
        | v31409(VarCurr,30) ) ) ).

tff(writeUnaryOperator_1732,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31855(VarCurr)
    <=> v31841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2667,axiom,
    ! [VarCurr: state_type] :
      ( v31836(VarCurr)
    <=> ( v31837(VarCurr)
        & v31851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2666,axiom,
    ! [VarCurr: state_type] :
      ( v31851(VarCurr)
    <=> ( v31839(VarCurr)
        | v31852(VarCurr) ) ) ).

tff(writeUnaryOperator_1731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31852(VarCurr)
    <=> v31409(VarCurr,31) ) ).

tff(writeBinaryOperatorShiftedRanges_285,axiom,
    ! [VarCurr: state_type] :
      ( v31837(VarCurr)
    <=> ( v31838(VarCurr)
        | v31409(VarCurr,31) ) ) ).

tff(writeUnaryOperator_1730,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31838(VarCurr)
    <=> v31839(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_284,axiom,
    ! [VarCurr: state_type] :
      ( v31839(VarCurr)
    <=> ( v31409(VarCurr,30)
        | v31840(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2665,axiom,
    ! [VarCurr: state_type] :
      ( v31840(VarCurr)
    <=> ( v31841(VarCurr)
        & v31850(VarCurr) ) ) ).

tff(writeUnaryOperator_1729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31850(VarCurr)
    <=> v31409(VarCurr,30) ) ).

tff(writeBinaryOperatorShiftedRanges_283,axiom,
    ! [VarCurr: state_type] :
      ( v31841(VarCurr)
    <=> ( v31409(VarCurr,29)
        | v31842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2664,axiom,
    ! [VarCurr: state_type] :
      ( v31842(VarCurr)
    <=> ( v31843(VarCurr)
        & v31849(VarCurr) ) ) ).

tff(writeUnaryOperator_1728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31849(VarCurr)
    <=> v31409(VarCurr,29) ) ).

tff(writeBinaryOperatorShiftedRanges_282,axiom,
    ! [VarCurr: state_type] :
      ( v31843(VarCurr)
    <=> ( v31409(VarCurr,28)
        | v31844(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2663,axiom,
    ! [VarCurr: state_type] :
      ( v31844(VarCurr)
    <=> ( v31845(VarCurr)
        & v31848(VarCurr) ) ) ).

tff(writeUnaryOperator_1727,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31848(VarCurr)
    <=> v31409(VarCurr,28) ) ).

tff(writeBinaryOperatorShiftedRanges_281,axiom,
    ! [VarCurr: state_type] :
      ( v31845(VarCurr)
    <=> ( v31409(VarCurr,27)
        | v31846(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_280,axiom,
    ! [VarCurr: state_type] :
      ( v31846(VarCurr)
    <=> ( v31409(VarCurr,26)
        & v31847(VarCurr) ) ) ).

tff(writeUnaryOperator_1726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31847(VarCurr)
    <=> v31409(VarCurr,27) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2662,axiom,
    ! [VarCurr: state_type] :
      ( v31823(VarCurr)
    <=> ( v31381(VarCurr)
        | v31824(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2661,axiom,
    ! [VarCurr: state_type] :
      ( v31824(VarCurr)
    <=> ( v31825(VarCurr)
        & v31715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2660,axiom,
    ! [VarCurr: state_type] :
      ( v31825(VarCurr)
    <=> ( v31826(VarCurr)
        & v31833(VarCurr) ) ) ).

tff(writeUnaryOperator_1725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31833(VarCurr)
    <=> v31321(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2659,axiom,
    ! [VarCurr: state_type] :
      ( v31826(VarCurr)
    <=> ( v31827(VarCurr)
        & v31832(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_131,axiom,
    ! [VarCurr: state_type] :
      ( v31832(VarCurr)
    <=> ( ( v31693(VarCurr,5)
        <=> $false )
        & ( v31693(VarCurr,4)
        <=> $false )
        & ( v31693(VarCurr,3)
        <=> $false )
        & ( v31693(VarCurr,2)
        <=> $false )
        & ( v31693(VarCurr,1)
        <=> $false )
        & ( v31693(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2658,axiom,
    ! [VarCurr: state_type] :
      ( v31827(VarCurr)
    <=> ( v31828(VarCurr)
        & v31831(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_130,axiom,
    ! [VarCurr: state_type] :
      ( v31831(VarCurr)
    <=> ( ( v31597(VarCurr,6)
        <=> $false )
        & ( v31597(VarCurr,5)
        <=> $false )
        & ( v31597(VarCurr,4)
        <=> $false )
        & ( v31597(VarCurr,3)
        <=> $false )
        & ( v31597(VarCurr,2)
        <=> $false )
        & ( v31597(VarCurr,1)
        <=> $false )
        & ( v31597(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2657,axiom,
    ! [VarCurr: state_type] :
      ( v31828(VarCurr)
    <=> ( v31829(VarCurr)
        & v31830(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_129,axiom,
    ! [VarCurr: state_type] :
      ( v31830(VarCurr)
    <=> ( ( v31387(VarCurr,6)
        <=> $false )
        & ( v31387(VarCurr,5)
        <=> $false )
        & ( v31387(VarCurr,4)
        <=> $false )
        & ( v31387(VarCurr,3)
        <=> $false )
        & ( v31387(VarCurr,2)
        <=> $false )
        & ( v31387(VarCurr,1)
        <=> $false )
        & ( v31387(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_128,axiom,
    ! [VarCurr: state_type] :
      ( v31829(VarCurr)
    <=> ( ( v31359(VarCurr,4)
        <=> $false )
        & ( v31359(VarCurr,3)
        <=> $false )
        & ( v31359(VarCurr,2)
        <=> $false )
        & ( v31359(VarCurr,1)
        <=> $false )
        & ( v31359(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16303,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,31)
    <=> v31411(VarCurr,31) ) ).

tff(addAssignment_16302,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,31)
    <=> v31413(VarCurr,31) ) ).

tff(addAssignment_16301,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,31)
    <=> v31485(VarCurr,31) ) ).

tff(addAssignment_16300,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,31)
    <=> v31417(VarCurr,31) ) ).

tff(addAssignment_16299,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,31)
    <=> v31419(VarCurr,31) ) ).

tff(addAssignment_16298,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,31)
    <=> v31815(VarNext,31) ) ).

tff(addCaseBooleanConditionEqualRanges1_368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31816(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31815(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_368,axiom,
    ! [VarNext: state_type] :
      ( v31816(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31815(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31816(VarNext)
      <=> v31817(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31817(VarNext)
      <=> ( v31819(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31819(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16297,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,31)
    <=> v31431(VarCurr,31) ) ).

tff(addAssignment_16296,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,31)
    <=> v31454(VarCurr,31) ) ).

tff(addAssignment_16295,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,31)
    <=> v31435(VarCurr,31) ) ).

tff(addAssignment_16294,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,31)
    <=> v31447(VarCurr,31) ) ).

tff(addAssignment_16293,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,31)
    <=> $false ) ).

tff(addAssignment_16292,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,31)
    <=> v2365(VarCurr,31) ) ).

tff(addAssignment_16291,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,31)
    <=> v1119(VarCurr,31) ) ).

tff(addAssignment_16290,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,31)
    <=> v1121(VarCurr,31) ) ).

tff(addAssignment_16289,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,31)
    <=> v1123(VarCurr,31) ) ).

tff(addAssignment_16288,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,30)
    <=> v31411(VarCurr,30) ) ).

tff(addAssignment_16287,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,30)
    <=> v31413(VarCurr,30) ) ).

tff(addAssignment_16286,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,30)
    <=> v31485(VarCurr,30) ) ).

tff(addAssignment_16285,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,30)
    <=> v31417(VarCurr,30) ) ).

tff(addAssignment_16284,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,30)
    <=> v31419(VarCurr,30) ) ).

tff(addAssignment_16283,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,30)
    <=> v31807(VarNext,30) ) ).

tff(addCaseBooleanConditionEqualRanges1_367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31808(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31807(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_367,axiom,
    ! [VarNext: state_type] :
      ( v31808(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31807(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31808(VarNext)
      <=> v31809(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31809(VarNext)
      <=> ( v31811(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1723,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31811(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16282,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,30)
    <=> v31431(VarCurr,30) ) ).

tff(addAssignment_16281,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,30)
    <=> v31454(VarCurr,30) ) ).

tff(addAssignment_16280,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,30)
    <=> v31435(VarCurr,30) ) ).

tff(addAssignment_16279,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,30)
    <=> v31447(VarCurr,30) ) ).

tff(addAssignment_16278,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,30)
    <=> $false ) ).

tff(addAssignment_16277,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,30)
    <=> v2365(VarCurr,30) ) ).

tff(addAssignment_16276,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,30)
    <=> v1119(VarCurr,30) ) ).

tff(addAssignment_16275,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,30)
    <=> v1121(VarCurr,30) ) ).

tff(addAssignment_16274,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,30)
    <=> v1123(VarCurr,30) ) ).

tff(addAssignment_16273,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,29)
    <=> v31411(VarCurr,29) ) ).

tff(addAssignment_16272,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,29)
    <=> v31413(VarCurr,29) ) ).

tff(addAssignment_16271,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,29)
    <=> v31485(VarCurr,29) ) ).

tff(addAssignment_16270,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,29)
    <=> v31417(VarCurr,29) ) ).

tff(addAssignment_16269,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,29)
    <=> v31419(VarCurr,29) ) ).

tff(addAssignment_16268,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,29)
    <=> v31799(VarNext,29) ) ).

tff(addCaseBooleanConditionEqualRanges1_366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31800(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31799(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_366,axiom,
    ! [VarNext: state_type] :
      ( v31800(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31799(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2652,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31800(VarNext)
      <=> v31801(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31801(VarNext)
      <=> ( v31803(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1722,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31803(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16267,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,29)
    <=> v31431(VarCurr,29) ) ).

tff(addAssignment_16266,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,29)
    <=> v31454(VarCurr,29) ) ).

tff(addAssignment_16265,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,29)
    <=> v31435(VarCurr,29) ) ).

tff(addAssignment_16264,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,29)
    <=> v31447(VarCurr,29) ) ).

tff(addAssignment_16263,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,29)
    <=> $true ) ).

tff(addAssignment_16262,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,29)
    <=> v2365(VarCurr,29) ) ).

tff(addAssignment_16261,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,29)
    <=> v1119(VarCurr,29) ) ).

tff(addAssignment_16260,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,29)
    <=> v1121(VarCurr,29) ) ).

tff(addAssignment_16259,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,29)
    <=> v1123(VarCurr,29) ) ).

tff(addAssignment_16258,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,28)
    <=> v31411(VarCurr,28) ) ).

tff(addAssignment_16257,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,28)
    <=> v31413(VarCurr,28) ) ).

tff(addAssignment_16256,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,28)
    <=> v31485(VarCurr,28) ) ).

tff(addAssignment_16255,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,28)
    <=> v31417(VarCurr,28) ) ).

tff(addAssignment_16254,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,28)
    <=> v31419(VarCurr,28) ) ).

tff(addAssignment_16253,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,28)
    <=> v31791(VarNext,28) ) ).

tff(addCaseBooleanConditionEqualRanges1_365,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31792(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31791(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_365,axiom,
    ! [VarNext: state_type] :
      ( v31792(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31791(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31792(VarNext)
      <=> v31793(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31793(VarNext)
      <=> ( v31795(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31795(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16252,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,28)
    <=> v31431(VarCurr,28) ) ).

tff(addAssignment_16251,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,28)
    <=> v31454(VarCurr,28) ) ).

tff(addAssignment_16250,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,28)
    <=> v31435(VarCurr,28) ) ).

tff(addAssignment_16249,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,28)
    <=> v31447(VarCurr,28) ) ).

tff(addAssignment_16248,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,28)
    <=> $true ) ).

tff(addAssignment_16247,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,28)
    <=> v2365(VarCurr,28) ) ).

tff(addAssignment_16246,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,28)
    <=> v1119(VarCurr,28) ) ).

tff(addAssignment_16245,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,28)
    <=> v1121(VarCurr,28) ) ).

tff(addAssignment_16244,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,28)
    <=> v1123(VarCurr,28) ) ).

tff(addAssignment_16243,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,27)
    <=> v31411(VarCurr,27) ) ).

tff(addAssignment_16242,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,27)
    <=> v31413(VarCurr,27) ) ).

tff(addAssignment_16241,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,27)
    <=> v31485(VarCurr,27) ) ).

tff(addAssignment_16240,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,27)
    <=> v31417(VarCurr,27) ) ).

tff(addAssignment_16239,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,27)
    <=> v31419(VarCurr,27) ) ).

tff(addAssignment_16238,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,27)
    <=> v31783(VarNext,27) ) ).

tff(addCaseBooleanConditionEqualRanges1_364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31784(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31783(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_364,axiom,
    ! [VarNext: state_type] :
      ( v31784(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31783(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31784(VarNext)
      <=> v31785(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31785(VarNext)
      <=> ( v31787(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31787(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16237,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,27)
    <=> v31431(VarCurr,27) ) ).

tff(addAssignment_16236,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,27)
    <=> v31454(VarCurr,27) ) ).

tff(addAssignment_16235,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,27)
    <=> v31435(VarCurr,27) ) ).

tff(addAssignment_16234,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,27)
    <=> v31447(VarCurr,27) ) ).

tff(addAssignment_16233,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,27)
    <=> $true ) ).

tff(addAssignment_16232,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,27)
    <=> v2365(VarCurr,27) ) ).

tff(addAssignment_16231,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,27)
    <=> v1119(VarCurr,27) ) ).

tff(addAssignment_16230,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,27)
    <=> v1121(VarCurr,27) ) ).

tff(addAssignment_16229,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,27)
    <=> v1123(VarCurr,27) ) ).

tff(addAssignment_16228,axiom,
    ! [VarCurr: state_type] :
      ( v31409(VarCurr,26)
    <=> v31411(VarCurr,26) ) ).

tff(addAssignment_16227,axiom,
    ! [VarCurr: state_type] :
      ( v31411(VarCurr,26)
    <=> v31413(VarCurr,26) ) ).

tff(addAssignment_16226,axiom,
    ! [VarCurr: state_type] :
      ( v31413(VarCurr,26)
    <=> v31485(VarCurr,26) ) ).

tff(addAssignment_16225,axiom,
    ! [VarCurr: state_type] :
      ( v31415(VarCurr,26)
    <=> v31417(VarCurr,26) ) ).

tff(addAssignment_16224,axiom,
    ! [VarCurr: state_type] :
      ( v31417(VarCurr,26)
    <=> v31419(VarCurr,26) ) ).

tff(addAssignment_16223,axiom,
    ! [VarNext: state_type] :
      ( v31419(VarNext,26)
    <=> v31775(VarNext,26) ) ).

tff(addCaseBooleanConditionEqualRanges1_363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31776(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31775(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_363,axiom,
    ! [VarNext: state_type] :
      ( v31776(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31775(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31776(VarNext)
      <=> v31777(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2645,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31777(VarNext)
      <=> ( v31779(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31779(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16222,axiom,
    ! [VarCurr: state_type] :
      ( v31429(VarCurr,26)
    <=> v31431(VarCurr,26) ) ).

tff(addAssignment_16221,axiom,
    ! [VarCurr: state_type] :
      ( v31431(VarCurr,26)
    <=> v31454(VarCurr,26) ) ).

tff(addAssignment_16220,axiom,
    ! [VarCurr: state_type] :
      ( v31433(VarCurr,26)
    <=> v31435(VarCurr,26) ) ).

tff(addAssignment_16219,axiom,
    ! [VarCurr: state_type] :
      ( v31435(VarCurr,26)
    <=> v31447(VarCurr,26) ) ).

tff(addAssignment_16218,axiom,
    ! [VarCurr: state_type] :
      ( v31445(VarCurr,26)
    <=> $true ) ).

tff(addAssignment_16217,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,26)
    <=> v2365(VarCurr,26) ) ).

tff(addAssignment_16216,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,26)
    <=> v1119(VarCurr,26) ) ).

tff(addAssignment_16215,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,26)
    <=> v1121(VarCurr,26) ) ).

tff(addAssignment_16214,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,26)
    <=> v1123(VarCurr,26) ) ).

tff(addAssignment_16213,axiom,
    ! [VarCurr: state_type] :
      ( v31715(VarCurr)
    <=> v31717(VarCurr,3) ) ).

tff(addAssignment_16212,axiom,
    ! [VarCurr: state_type] :
      ( v31717(VarCurr,3)
    <=> v31719(VarCurr,3) ) ).

tff(addAssignment_16211,axiom,
    ! [VarCurr: state_type] :
      ( v31719(VarCurr,3)
    <=> v31293(VarCurr,3) ) ).

tff(addAssignment_16210,axiom,
    ! [VarCurr: state_type] :
      ( v31293(VarCurr,3)
    <=> v31721(VarCurr,0) ) ).

tff(addAssignment_16209,axiom,
    ! [VarCurr: state_type] :
      ( v31721(VarCurr,0)
    <=> v31723(VarCurr,0) ) ).

tff(addAssignment_16208,axiom,
    ! [VarNext: state_type] :
      ( v31723(VarNext,0)
    <=> v31757(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31758(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v31757(VarNext,B)
            <=> v31723(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_362,axiom,
    ! [VarNext: state_type] :
      ( v31758(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v31757(VarNext,B)
          <=> v31768(VarNext,B) ) ) ) ).

tff(addAssignment_16207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v31768(VarNext,B)
          <=> v31766(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v31766(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_216,axiom,
    ! [VarCurr: state_type] :
      ( v31769(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v31766(VarCurr,B)
          <=> v31733(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2644,axiom,
    ! [VarCurr: state_type] :
      ( v31769(VarCurr)
    <=> ( v31770(VarCurr)
        & v31771(VarCurr) ) ) ).

tff(writeUnaryOperator_1718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31771(VarCurr)
    <=> v31729(VarCurr) ) ).

tff(writeUnaryOperator_1717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31770(VarCurr)
    <=> v31725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31758(VarNext)
      <=> v31759(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31759(VarNext)
      <=> ( v31760(VarNext)
          & v31753(VarNext) ) ) ) ).

tff(writeUnaryOperator_1716,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31760(VarNext)
      <=> v31762(VarNext) ) ) ).

tff(addAssignment_16206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31762(VarNext)
      <=> v31753(VarCurr) ) ) ).

tff(addAssignment_16205,axiom,
    ! [VarCurr: state_type] :
      ( v31753(VarCurr)
    <=> v31755(VarCurr) ) ).

tff(addAssignment_16204,axiom,
    ! [VarCurr: state_type] :
      ( v31755(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16203,axiom,
    ! [VarCurr: state_type] :
      ( v31733(VarCurr,0)
    <=> v31735(VarCurr,0) ) ).

tff(addAssignment_16202,axiom,
    ! [VarCurr: state_type] :
      ( v31735(VarCurr,0)
    <=> v31744(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31744(VarCurr,B)
      <=> ( v31745(VarCurr,B)
          | v31748(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31748(VarCurr,B)
      <=> ( v31721(VarCurr,B)
          & v31749(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31749(VarCurr,B)
      <=> ~ v31750(VarCurr,B) ) ) ).

tff(addAssignment_16201,axiom,
    ! [VarCurr: state_type] :
      ( v31750(VarCurr,0)
    <=> v31751(VarCurr) ) ).

tff(addAssignment_16200,axiom,
    ! [VarCurr: state_type] :
      ( v31750(VarCurr,1)
    <=> v31751(VarCurr) ) ).

tff(addAssignment_16199,axiom,
    ! [VarCurr: state_type] :
      ( v31750(VarCurr,2)
    <=> v31751(VarCurr) ) ).

tff(addAssignment_16198,axiom,
    ! [VarCurr: state_type] :
      ( v31751(VarCurr)
    <=> v31739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31745(VarCurr,B)
      <=> ( v31737(VarCurr,B)
          & v31746(VarCurr,B) ) ) ) ).

tff(addAssignment_16197,axiom,
    ! [VarCurr: state_type] :
      ( v31746(VarCurr,0)
    <=> v31747(VarCurr) ) ).

tff(addAssignment_16196,axiom,
    ! [VarCurr: state_type] :
      ( v31746(VarCurr,1)
    <=> v31747(VarCurr) ) ).

tff(addAssignment_16195,axiom,
    ! [VarCurr: state_type] :
      ( v31746(VarCurr,2)
    <=> v31747(VarCurr) ) ).

tff(addAssignment_16194,axiom,
    ! [VarCurr: state_type] :
      ( v31747(VarCurr)
    <=> v31739(VarCurr) ) ).

tff(addAssignment_16193,axiom,
    ! [VarCurr: state_type] :
      ( v31739(VarCurr)
    <=> v31741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2641,axiom,
    ! [VarCurr: state_type] :
      ( v31741(VarCurr)
    <=> ( v2354(VarCurr)
        & v31743(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_127,axiom,
    ! [VarCurr: state_type] :
      ( v31743(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $true )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16192,axiom,
    ! [VarCurr: state_type] :
      ( v31737(VarCurr,0)
    <=> v31313(VarCurr,3) ) ).

tff(addAssignment_16191,axiom,
    ! [VarCurr: state_type] :
      ( v31313(VarCurr,3)
    <=> v2363(VarCurr,35) ) ).

tff(addAssignment_16190,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,35)
    <=> v2365(VarCurr,35) ) ).

tff(addAssignment_16189,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,35)
    <=> v1119(VarCurr,35) ) ).

tff(addAssignment_16188,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,35)
    <=> v1121(VarCurr,35) ) ).

tff(addAssignment_16187,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,35)
    <=> v1123(VarCurr,35) ) ).

tff(addAssignment_16186,axiom,
    ! [VarCurr: state_type] :
      ( v31729(VarCurr)
    <=> v31731(VarCurr) ) ).

tff(addAssignment_16185,axiom,
    ! [VarCurr: state_type] :
      ( v31731(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16184,axiom,
    ! [VarCurr: state_type] :
      ( v31725(VarCurr)
    <=> v31727(VarCurr) ) ).

tff(addAssignment_16183,axiom,
    ! [VarCurr: state_type] :
      ( v31727(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_16182,axiom,
    ! [VarCurr: state_type] :
      ( v31703(VarCurr)
    <=> v31705(VarCurr) ) ).

tff(addAssignment_16181,axiom,
    ! [VarCurr: state_type] :
      ( v31705(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16180,axiom,
    ! [VarCurr: state_type] :
      ( v31699(VarCurr)
    <=> v31701(VarCurr) ) ).

tff(addAssignment_16179,axiom,
    ! [VarCurr: state_type] :
      ( v31701(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2640,axiom,
    ! [VarCurr: state_type] :
      ( v31629(VarCurr)
    <=> ( v31676(VarCurr)
        & v31677(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2639,axiom,
    ! [VarCurr: state_type] :
      ( v31677(VarCurr)
    <=> ( v31678(VarCurr)
        | v31686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2638,axiom,
    ! [VarCurr: state_type] :
      ( v31686(VarCurr)
    <=> ( v31687(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2637,axiom,
    ! [VarCurr: state_type] :
      ( v31687(VarCurr)
    <=> ( v31673(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2636,axiom,
    ! [VarCurr: state_type] :
      ( v31678(VarCurr)
    <=> ( v31679(VarCurr)
        | v31685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2635,axiom,
    ! [VarCurr: state_type] :
      ( v31685(VarCurr)
    <=> ( v31670(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2634,axiom,
    ! [VarCurr: state_type] :
      ( v31679(VarCurr)
    <=> ( v31680(VarCurr)
        | v31683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2633,axiom,
    ! [VarCurr: state_type] :
      ( v31683(VarCurr)
    <=> ( v31684(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2632,axiom,
    ! [VarCurr: state_type] :
      ( v31684(VarCurr)
    <=> ( v31656(VarCurr)
        & v31659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2631,axiom,
    ! [VarCurr: state_type] :
      ( v31680(VarCurr)
    <=> ( v31681(VarCurr)
        | v31682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2630,axiom,
    ! [VarCurr: state_type] :
      ( v31682(VarCurr)
    <=> ( v31650(VarCurr)
        & v31653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2629,axiom,
    ! [VarCurr: state_type] :
      ( v31681(VarCurr)
    <=> ( v31634(VarCurr)
        | v31647(VarCurr) ) ) ).

tff(writeUnaryOperator_1714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31676(VarCurr)
    <=> v31631(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_126,axiom,
    ! [VarCurr: state_type] :
      ( v31673(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $true )
        & ( v31636(VarCurr,1)
        <=> $false )
        & ( v31636(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_125,axiom,
    ! [VarCurr: state_type] :
      ( v31670(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $true )
        & ( v31636(VarCurr,1)
        <=> $false )
        & ( v31636(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_124,axiom,
    ! [VarCurr: state_type] :
      ( v31659(VarCurr)
    <=> ( ( v31409(VarCurr,25)
        <=> $false )
        & ( v31409(VarCurr,24)
        <=> $false )
        & ( v31409(VarCurr,23)
        <=> $false )
        & ( v31409(VarCurr,22)
        <=> $false )
        & ( v31409(VarCurr,21)
        <=> $false ) ) ) ).

tff(addAssignment_16178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31409(VarCurr,B)
      <=> v31411(VarCurr,B) ) ) ).

tff(addAssignment_16177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31411(VarCurr,B)
      <=> v31413(VarCurr,B) ) ) ).

tff(addAssignment_16176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31413(VarCurr,B)
      <=> v31485(VarCurr,B) ) ) ).

tff(addAssignment_16175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31415(VarCurr,B)
      <=> v31417(VarCurr,B) ) ) ).

tff(addAssignment_16174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31417(VarCurr,B)
      <=> v31419(VarCurr,B) ) ) ).

tff(addAssignment_16173,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31419(VarNext,B)
      <=> v31661(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31662(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31661(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_361,axiom,
    ! [VarNext: state_type] :
      ( v31662(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31661(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31662(VarNext)
      <=> v31663(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2627,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31663(VarNext)
      <=> ( v31665(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31665(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31429(VarCurr,B)
      <=> v31431(VarCurr,B) ) ) ).

tff(addAssignment_16171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31431(VarCurr,B)
      <=> v31454(VarCurr,B) ) ) ).

tff(addAssignment_16170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31433(VarCurr,B)
      <=> v31435(VarCurr,B) ) ) ).

tff(addAssignment_16169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31435(VarCurr,B)
      <=> v31447(VarCurr,B) ) ) ).

tff(addAssignment_16168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v31445(VarCurr,B)
      <=> b00111100000000011110010001111000(B) ) ) ).

tff(addAssignment_16167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v2363(VarCurr,B)
      <=> v2365(VarCurr,B) ) ) ).

tff(addAssignment_16166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v2365(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_16165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v1119(VarCurr,B)
      <=> v1121(VarCurr,B) ) ) ).

tff(addAssignment_16164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,26)
        & ~ $less(B,21) )
     => ( v1121(VarCurr,B)
      <=> v1123(VarCurr,B) ) ) ).

tff(addBitVectorEqualityBitBlasted_123,axiom,
    ! [VarCurr: state_type] :
      ( v31656(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $false )
        & ( v31636(VarCurr,1)
        <=> $true )
        & ( v31636(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_122,axiom,
    ! [VarCurr: state_type] :
      ( v31653(VarCurr)
    <=> ( ( v31409(VarCurr,19)
        <=> $false )
        & ( v31409(VarCurr,18)
        <=> $false )
        & ( v31409(VarCurr,17)
        <=> $false )
        & ( v31409(VarCurr,16)
        <=> $false )
        & ( v31409(VarCurr,15)
        <=> $false )
        & ( v31409(VarCurr,14)
        <=> $false )
        & ( v31409(VarCurr,13)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_121,axiom,
    ! [VarCurr: state_type] :
      ( v31650(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $false )
        & ( v31636(VarCurr,1)
        <=> $true )
        & ( v31636(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_120,axiom,
    ! [VarCurr: state_type] :
      ( v31647(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $false )
        & ( v31636(VarCurr,1)
        <=> $false )
        & ( v31636(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_119,axiom,
    ! [VarCurr: state_type] :
      ( v31634(VarCurr)
    <=> ( ( v31636(VarCurr,2)
        <=> $false )
        & ( v31636(VarCurr,1)
        <=> $false )
        & ( v31636(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31636(VarCurr,B)
      <=> v31409(VarCurr,B) ) ) ).

tff(addAssignment_16162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31409(VarCurr,B)
      <=> v31411(VarCurr,B) ) ) ).

tff(addAssignment_16161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31411(VarCurr,B)
      <=> v31413(VarCurr,B) ) ) ).

tff(addAssignment_16160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31413(VarCurr,B)
      <=> v31485(VarCurr,B) ) ) ).

tff(addAssignment_16159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31415(VarCurr,B)
      <=> v31417(VarCurr,B) ) ) ).

tff(addAssignment_16158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31417(VarCurr,B)
      <=> v31419(VarCurr,B) ) ) ).

tff(addAssignment_16157,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31419(VarNext,B)
      <=> v31638(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31639(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31638(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_360,axiom,
    ! [VarNext: state_type] :
      ( v31639(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31638(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31639(VarNext)
      <=> v31640(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31640(VarNext)
      <=> ( v31642(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1712,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31642(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31429(VarCurr,B)
      <=> v31431(VarCurr,B) ) ) ).

tff(addAssignment_16155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31431(VarCurr,B)
      <=> v31454(VarCurr,B) ) ) ).

tff(addAssignment_16154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31433(VarCurr,B)
      <=> v31435(VarCurr,B) ) ) ).

tff(addAssignment_16153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31435(VarCurr,B)
      <=> v31447(VarCurr,B) ) ) ).

tff(addAssignment_16152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v31445(VarCurr,B)
      <=> b00111100000000011110010001111000(B) ) ) ).

tff(addBitVectorEqualityBitBlasted_118,axiom,
    ! [VarCurr: state_type] :
      ( v31631(VarCurr)
    <=> ( ( v31409(VarCurr,9)
        <=> $false )
        & ( v31409(VarCurr,8)
        <=> $false )
        & ( v31409(VarCurr,7)
        <=> $false )
        & ( v31409(VarCurr,6)
        <=> $false )
        & ( v31409(VarCurr,5)
        <=> $false )
        & ( v31409(VarCurr,4)
        <=> $false )
        & ( v31409(VarCurr,3)
        <=> $false ) ) ) ).

tff(addAssignment_16151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31409(VarCurr,B)
      <=> v31411(VarCurr,B) ) ) ).

tff(addAssignment_16150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31411(VarCurr,B)
      <=> v31413(VarCurr,B) ) ) ).

tff(addAssignment_16149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31413(VarCurr,B)
      <=> v31485(VarCurr,B) ) ) ).

tff(addAssignment_16148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31415(VarCurr,B)
      <=> v31417(VarCurr,B) ) ) ).

tff(addAssignment_16147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31417(VarCurr,B)
      <=> v31419(VarCurr,B) ) ) ).

tff(addAssignment_16146,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31419(VarNext,B)
      <=> v31619(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_359,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31620(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31619(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_359,axiom,
    ! [VarNext: state_type] :
      ( v31620(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31619(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2624,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31620(VarNext)
      <=> v31621(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31621(VarNext)
      <=> ( v31623(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1711,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31623(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31429(VarCurr,B)
      <=> v31431(VarCurr,B) ) ) ).

tff(addAssignment_16144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31431(VarCurr,B)
      <=> v31454(VarCurr,B) ) ) ).

tff(addAssignment_16143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31433(VarCurr,B)
      <=> v31435(VarCurr,B) ) ) ).

tff(addAssignment_16142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31435(VarCurr,B)
      <=> v31447(VarCurr,B) ) ) ).

tff(addAssignment_16141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,3) )
     => ( v31445(VarCurr,B)
      <=> b00111100000000011110010001111000(B) ) ) ).

tff(addAssignment_16140,axiom,
    ! [VarCurr: state_type] :
      ( v31607(VarCurr)
    <=> v31609(VarCurr) ) ).

tff(addAssignment_16139,axiom,
    ! [VarCurr: state_type] :
      ( v31609(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16138,axiom,
    ! [VarCurr: state_type] :
      ( v31603(VarCurr)
    <=> v31605(VarCurr) ) ).

tff(addAssignment_16137,axiom,
    ! [VarCurr: state_type] :
      ( v31605(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_16136,axiom,
    ! [VarCurr: state_type] :
      ( v31549(VarCurr)
    <=> v31551(VarCurr) ) ).

tff(addAssignment_16135,axiom,
    ! [VarCurr: state_type] :
      ( v31551(VarCurr)
    <=> v31553(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31579(VarNext)
       => ( v31553(VarNext)
        <=> v31553(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_358,axiom,
    ! [VarNext: state_type] :
      ( v31579(VarNext)
     => ( v31553(VarNext)
      <=> v31589(VarNext) ) ) ).

tff(addAssignment_16134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31589(VarNext)
      <=> v31587(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31590(VarCurr)
     => ( v31587(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_215,axiom,
    ! [VarCurr: state_type] :
      ( v31590(VarCurr)
     => ( v31587(VarCurr)
      <=> v31563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2622,axiom,
    ! [VarCurr: state_type] :
      ( v31590(VarCurr)
    <=> ( v31591(VarCurr)
        & v31592(VarCurr) ) ) ).

tff(writeUnaryOperator_1710,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31592(VarCurr)
    <=> v31559(VarCurr) ) ).

tff(writeUnaryOperator_1709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31591(VarCurr)
    <=> v31555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31579(VarNext)
      <=> v31580(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2620,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31580(VarNext)
      <=> ( v31581(VarNext)
          & v31574(VarNext) ) ) ) ).

tff(writeUnaryOperator_1708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31581(VarNext)
      <=> v31583(VarNext) ) ) ).

tff(addAssignment_16133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31583(VarNext)
      <=> v31574(VarCurr) ) ) ).

tff(addAssignment_16132,axiom,
    ! [VarCurr: state_type] :
      ( v31574(VarCurr)
    <=> v31576(VarCurr) ) ).

tff(addAssignment_16131,axiom,
    ! [VarCurr: state_type] :
      ( v31576(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16130,axiom,
    ! [VarCurr: state_type] :
      ( v31563(VarCurr)
    <=> v31565(VarCurr) ) ).

tff(addAssignment_16129,axiom,
    ! [VarCurr: state_type] :
      ( v31565(VarCurr)
    <=> v31567(VarCurr) ) ).

tff(addAssignment_16128,axiom,
    ! [VarCurr: state_type] :
      ( v31567(VarCurr)
    <=> v31569(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2619,axiom,
    ! [VarCurr: state_type] :
      ( v31569(VarCurr)
    <=> ( v31571(VarCurr)
        & v31572(VarCurr) ) ) ).

tff(writeUnaryOperator_1707,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31572(VarCurr)
    <=> v31549(VarCurr) ) ).

tff(writeUnaryOperator_1706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31571(VarCurr)
    <=> v31321(VarCurr,0) ) ).

tff(addAssignment_16127,axiom,
    ! [VarCurr: state_type] :
      ( v31559(VarCurr)
    <=> v31561(VarCurr) ) ).

tff(addAssignment_16126,axiom,
    ! [VarCurr: state_type] :
      ( v31561(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16125,axiom,
    ! [VarCurr: state_type] :
      ( v31555(VarCurr)
    <=> v31557(VarCurr) ) ).

tff(addAssignment_16124,axiom,
    ! [VarCurr: state_type] :
      ( v31557(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_16123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v31489(VarCurr,B)
      <=> v31491(VarCurr,B) ) ) ).

tff(addAssignment_16122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v31491(VarCurr,B)
      <=> v31493(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31532(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v31493(VarNext,B)
            <=> v31493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_357,axiom,
    ! [VarNext: state_type] :
      ( v31532(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31493(VarNext,B)
          <=> v31542(VarNext,B) ) ) ) ).

tff(addAssignment_16121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31542(VarNext,B)
          <=> v31540(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31543(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31540(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_214,axiom,
    ! [VarCurr: state_type] :
      ( v31543(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31540(VarCurr,B)
          <=> v31503(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2618,axiom,
    ! [VarCurr: state_type] :
      ( v31543(VarCurr)
    <=> ( v31544(VarCurr)
        & v31545(VarCurr) ) ) ).

tff(writeUnaryOperator_1705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31545(VarCurr)
    <=> v31499(VarCurr) ) ).

tff(writeUnaryOperator_1704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31544(VarCurr)
    <=> v31495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31532(VarNext)
      <=> v31533(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31533(VarNext)
      <=> ( v31534(VarNext)
          & v31523(VarNext) ) ) ) ).

tff(writeUnaryOperator_1703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31534(VarNext)
      <=> v31536(VarNext) ) ) ).

tff(addAssignment_16120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31536(VarNext)
      <=> v31523(VarCurr) ) ) ).

tff(addAssignment_16119,axiom,
    ! [VarCurr: state_type] :
      ( v31523(VarCurr)
    <=> v31525(VarCurr) ) ).

tff(addAssignment_16118,axiom,
    ! [VarCurr: state_type] :
      ( v31525(VarCurr)
    <=> v31527(VarCurr) ) ).

tff(addAssignment_16117,axiom,
    ! [VarCurr: state_type] :
      ( v31527(VarCurr)
    <=> v31529(VarCurr) ) ).

tff(addAssignment_16116,axiom,
    ! [VarCurr: state_type] :
      ( v31529(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v31503(VarCurr,B)
      <=> v31505(VarCurr,B) ) ) ).

tff(addAssignment_16114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v31505(VarCurr,B)
      <=> v31507(VarCurr,B) ) ) ).

tff(addAssignment_16113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v31507(VarCurr,B)
      <=> v31509(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31513(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31509(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_716,axiom,
    ~ b00(1) ).

tff(bitBlastConstant_715,axiom,
    ~ b00(0) ).

tff(addConditionBooleanCondEqualRangesThenBranch_213,axiom,
    ! [VarCurr: state_type] :
      ( v31513(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v31509(VarCurr,B)
          <=> v31516(VarCurr,B) ) ) ) ).

tff(addAssignment_16112,axiom,
    ! [VarCurr: state_type] :
      ( v31516(VarCurr,0)
    <=> v31520(VarCurr) ) ).

tff(addAssignment_16111,axiom,
    ! [VarCurr: state_type] :
      ( v31516(VarCurr,1)
    <=> v31518(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2615,axiom,
    ! [VarCurr: state_type] :
      ( v31518(VarCurr)
    <=> ( v31515(VarCurr)
        & v31519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2614,axiom,
    ! [VarCurr: state_type] :
      ( v31519(VarCurr)
    <=> ( v31520(VarCurr)
        | v31521(VarCurr) ) ) ).

tff(writeUnaryOperator_1702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31521(VarCurr)
    <=> v31489(VarCurr,1) ) ).

tff(writeUnaryOperator_1701,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31520(VarCurr)
    <=> v31489(VarCurr,0) ) ).

tff(writeBinaryOperatorShiftedRanges_279,axiom,
    ! [VarCurr: state_type] :
      ( v31515(VarCurr)
    <=> ( v31489(VarCurr,0)
        | v31489(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2613,axiom,
    ! [VarCurr: state_type] :
      ( v31513(VarCurr)
    <=> ( v31381(VarCurr)
        | v31514(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_278,axiom,
    ! [VarCurr: state_type] :
      ( v31514(VarCurr)
    <=> ( v31489(VarCurr,0)
        | v31489(VarCurr,1) ) ) ).

tff(addAssignment_16110,axiom,
    ! [VarCurr: state_type] :
      ( v31499(VarCurr)
    <=> v31501(VarCurr) ) ).

tff(addAssignment_16109,axiom,
    ! [VarCurr: state_type] :
      ( v31501(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16108,axiom,
    ! [VarCurr: state_type] :
      ( v31495(VarCurr)
    <=> v31497(VarCurr) ) ).

tff(addAssignment_16107,axiom,
    ! [VarCurr: state_type] :
      ( v31497(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_16106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31409(VarCurr,B)
      <=> v31411(VarCurr,B) ) ) ).

tff(addAssignment_16105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31411(VarCurr,B)
      <=> v31413(VarCurr,B) ) ) ).

tff(addAssignment_16104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31413(VarCurr,B)
      <=> v31485(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31485(VarCurr,B)
      <=> ( v31415(VarCurr,B)
        <~> v31445(VarCurr,B) ) ) ) ).

tff(addAssignment_16103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31415(VarCurr,B)
      <=> v31417(VarCurr,B) ) ) ).

tff(addAssignment_16102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31417(VarCurr,B)
      <=> v31419(VarCurr,B) ) ) ).

tff(addAssignment_16101,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31419(VarNext,B)
      <=> v31468(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31469(VarNext)
       => ! [B: $int] :
            ( ( $less(B,32)
              & ~ $less(B,0) )
           => ( v31468(VarNext,B)
            <=> v31419(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_356,axiom,
    ! [VarNext: state_type] :
      ( v31469(VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31468(VarNext,B)
          <=> v31479(VarNext,B) ) ) ) ).

tff(addAssignment_16100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31479(VarNext,B)
          <=> v31477(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31477(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_212,axiom,
    ! [VarCurr: state_type] :
      ( v31480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,32)
            & ~ $less(B,0) )
         => ( v31477(VarCurr,B)
          <=> v31429(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2612,axiom,
    ! [VarCurr: state_type] :
      ( v31480(VarCurr)
    <=> ( v31481(VarCurr)
        & v31482(VarCurr) ) ) ).

tff(writeUnaryOperator_1700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31482(VarCurr)
    <=> v31425(VarCurr) ) ).

tff(writeUnaryOperator_1699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31481(VarCurr)
    <=> v31421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31469(VarNext)
      <=> v31470(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31470(VarNext)
      <=> ( v31471(VarNext)
          & v31464(VarNext) ) ) ) ).

tff(writeUnaryOperator_1698,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31471(VarNext)
      <=> v31473(VarNext) ) ) ).

tff(addAssignment_16099,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31473(VarNext)
      <=> v31464(VarCurr) ) ) ).

tff(addAssignment_16098,axiom,
    ! [VarCurr: state_type] :
      ( v31464(VarCurr)
    <=> v31466(VarCurr) ) ).

tff(addAssignment_16097,axiom,
    ! [VarCurr: state_type] :
      ( v31466(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_16096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31429(VarCurr,B)
      <=> v31431(VarCurr,B) ) ) ).

tff(addAssignment_16095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31431(VarCurr,B)
      <=> v31454(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31454(VarCurr,B)
      <=> ( v31455(VarCurr,B)
          | v31458(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31458(VarCurr,B)
      <=> ( v31417(VarCurr,B)
          & v31459(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31459(VarCurr,B)
      <=> ~ v31460(VarCurr,B) ) ) ).

tff(addAssignment_16094,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,0)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16093,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,1)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16092,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,2)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16091,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,3)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16090,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,4)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16089,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,5)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16088,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,6)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16087,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,7)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16086,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,8)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16085,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,9)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16084,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,10)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16083,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,11)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16082,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,12)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16081,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,13)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16080,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,14)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16079,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,15)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16078,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,16)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16077,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,17)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16076,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,18)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16075,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,19)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16074,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,20)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16073,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,21)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16072,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,22)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16071,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,23)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16070,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,24)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16069,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,25)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16068,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,26)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16067,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,27)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16066,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,28)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16065,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,29)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16064,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,30)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16063,axiom,
    ! [VarCurr: state_type] :
      ( v31460(VarCurr,31)
    <=> v31461(VarCurr) ) ).

tff(addAssignment_16062,axiom,
    ! [VarCurr: state_type] :
      ( v31461(VarCurr)
    <=> v31449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31455(VarCurr,B)
      <=> ( v31433(VarCurr,B)
          & v31456(VarCurr,B) ) ) ) ).

tff(addAssignment_16061,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,0)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16060,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,1)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16059,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,2)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16058,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,3)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16057,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,4)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16056,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,5)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16055,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,6)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16054,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,7)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16053,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,8)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16052,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,9)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16051,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,10)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16050,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,11)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16049,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,12)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16048,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,13)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16047,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,14)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16046,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,15)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16045,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,16)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16044,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,17)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16043,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,18)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16042,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,19)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16041,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,20)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16040,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,21)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16039,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,22)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16038,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,23)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16037,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,24)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16036,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,25)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16035,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,26)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16034,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,27)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16033,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,28)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16032,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,29)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16031,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,30)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16030,axiom,
    ! [VarCurr: state_type] :
      ( v31456(VarCurr,31)
    <=> v31457(VarCurr) ) ).

tff(addAssignment_16029,axiom,
    ! [VarCurr: state_type] :
      ( v31457(VarCurr)
    <=> v31449(VarCurr) ) ).

tff(addAssignment_16028,axiom,
    ! [VarCurr: state_type] :
      ( v31449(VarCurr)
    <=> v31451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2609,axiom,
    ! [VarCurr: state_type] :
      ( v31451(VarCurr)
    <=> ( v2354(VarCurr)
        & v31453(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_117,axiom,
    ! [VarCurr: state_type] :
      ( v31453(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $true )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_16027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31433(VarCurr,B)
      <=> v31435(VarCurr,B) ) ) ).

tff(addAssignment_16026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31435(VarCurr,B)
      <=> v31447(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v31447(VarCurr,B)
      <=> ( v2363(VarCurr,B)
        <~> v31445(VarCurr,B) ) ) ) ).

tff(addAssignment_16025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,13) )
     => ( v31445(VarCurr,B)
      <=> b00111100000000011110010001111000(B) ) ) ).

tff(bitBlastConstant_714,axiom,
    ~ b00111100000000011110010001111000(31) ).

tff(bitBlastConstant_713,axiom,
    ~ b00111100000000011110010001111000(30) ).

tff(bitBlastConstant_712,axiom,
    b00111100000000011110010001111000(29) ).

tff(bitBlastConstant_711,axiom,
    b00111100000000011110010001111000(28) ).

tff(bitBlastConstant_710,axiom,
    b00111100000000011110010001111000(27) ).

tff(bitBlastConstant_709,axiom,
    b00111100000000011110010001111000(26) ).

tff(bitBlastConstant_708,axiom,
    ~ b00111100000000011110010001111000(25) ).

tff(bitBlastConstant_707,axiom,
    ~ b00111100000000011110010001111000(24) ).

tff(bitBlastConstant_706,axiom,
    ~ b00111100000000011110010001111000(23) ).

tff(bitBlastConstant_705,axiom,
    ~ b00111100000000011110010001111000(22) ).

tff(bitBlastConstant_704,axiom,
    ~ b00111100000000011110010001111000(21) ).

tff(bitBlastConstant_703,axiom,
    ~ b00111100000000011110010001111000(20) ).

tff(bitBlastConstant_702,axiom,
    ~ b00111100000000011110010001111000(19) ).

tff(bitBlastConstant_701,axiom,
    ~ b00111100000000011110010001111000(18) ).

tff(bitBlastConstant_700,axiom,
    ~ b00111100000000011110010001111000(17) ).

tff(bitBlastConstant_699,axiom,
    b00111100000000011110010001111000(16) ).

tff(bitBlastConstant_698,axiom,
    b00111100000000011110010001111000(15) ).

tff(bitBlastConstant_697,axiom,
    b00111100000000011110010001111000(14) ).

tff(bitBlastConstant_696,axiom,
    b00111100000000011110010001111000(13) ).

tff(bitBlastConstant_695,axiom,
    ~ b00111100000000011110010001111000(12) ).

tff(bitBlastConstant_694,axiom,
    ~ b00111100000000011110010001111000(11) ).

tff(bitBlastConstant_693,axiom,
    b00111100000000011110010001111000(10) ).

tff(bitBlastConstant_692,axiom,
    ~ b00111100000000011110010001111000(9) ).

tff(bitBlastConstant_691,axiom,
    ~ b00111100000000011110010001111000(8) ).

tff(bitBlastConstant_690,axiom,
    ~ b00111100000000011110010001111000(7) ).

tff(bitBlastConstant_689,axiom,
    b00111100000000011110010001111000(6) ).

tff(bitBlastConstant_688,axiom,
    b00111100000000011110010001111000(5) ).

tff(bitBlastConstant_687,axiom,
    b00111100000000011110010001111000(4) ).

tff(bitBlastConstant_686,axiom,
    b00111100000000011110010001111000(3) ).

tff(bitBlastConstant_685,axiom,
    ~ b00111100000000011110010001111000(2) ).

tff(bitBlastConstant_684,axiom,
    ~ b00111100000000011110010001111000(1) ).

tff(bitBlastConstant_683,axiom,
    ~ b00111100000000011110010001111000(0) ).

tff(addAssignment_16024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v2363(VarCurr,B)
      <=> v2365(VarCurr,B) ) ) ).

tff(addAssignment_16023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v2365(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_16022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v1119(VarCurr,B)
      <=> v1121(VarCurr,B) ) ) ).

tff(addAssignment_16021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,16) )
     => ( v1121(VarCurr,B)
      <=> v1123(VarCurr,B) ) ) ).

tff(addAssignment_16020,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,16)
    <=> v31437(VarNext,16) ) ).

tff(addCaseBooleanConditionEqualRanges1_355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31438(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v31437(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_355,axiom,
    ! [VarNext: state_type] :
      ( v31438(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v31437(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2608,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31438(VarNext)
      <=> v31439(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31439(VarNext)
      <=> ( v31441(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_1696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31441(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_16019,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,16)
    <=> v1135(VarCurr,16) ) ).

tff(addAssignment_16018,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,16)
    <=> v1137(VarCurr,16) ) ).

tff(addAssignment_16017,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,16)
    <=> v1697(VarCurr,16) ) ).

tff(addAssignment_16016,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,16)
    <=> v1141(VarCurr,16) ) ).

tff(addAssignment_16015,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,16)
    <=> v1143(VarCurr,16) ) ).

tff(addAssignment_16014,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,16)
    <=> v1145(VarCurr,16) ) ).

tff(addAssignment_16013,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,16)
    <=> v1147(VarCurr,16) ) ).

tff(addAssignment_16012,axiom,
    ! [VarCurr: state_type] :
      ( v31425(VarCurr)
    <=> v31427(VarCurr) ) ).

tff(addAssignment_16011,axiom,
    ! [VarCurr: state_type] :
      ( v31427(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_16010,axiom,
    ! [VarCurr: state_type] :
      ( v31421(VarCurr)
    <=> v31423(VarCurr) ) ).

tff(addAssignment_16009,axiom,
    ! [VarCurr: state_type] :
      ( v31423(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_16008,axiom,
    ! [VarCurr: state_type] :
      ( v31397(VarCurr)
    <=> v31399(VarCurr) ) ).

tff(addAssignment_16007,axiom,
    ! [VarCurr: state_type] :
      ( v31399(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16006,axiom,
    ! [VarCurr: state_type] :
      ( v31393(VarCurr)
    <=> v31395(VarCurr) ) ).

tff(addAssignment_16005,axiom,
    ! [VarCurr: state_type] :
      ( v31395(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_16004,axiom,
    ! [VarCurr: state_type] :
      ( v31381(VarCurr)
    <=> v31383(VarCurr) ) ).

tff(addAssignment_16003,axiom,
    ! [VarCurr: state_type] :
      ( v31383(VarCurr)
    <=> v31291(VarCurr) ) ).

tff(addAssignment_16002,axiom,
    ! [VarCurr: state_type] :
      ( v31369(VarCurr)
    <=> v31371(VarCurr) ) ).

tff(addAssignment_16001,axiom,
    ! [VarCurr: state_type] :
      ( v31371(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_16000,axiom,
    ! [VarCurr: state_type] :
      ( v31365(VarCurr)
    <=> v31367(VarCurr) ) ).

tff(addAssignment_15999,axiom,
    ! [VarCurr: state_type] :
      ( v31367(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_15998,axiom,
    ! [VarCurr: state_type] :
      ( v31339(VarCurr)
    <=> v31341(VarCurr) ) ).

tff(addAssignment_15997,axiom,
    ! [VarCurr: state_type] :
      ( v31341(VarCurr)
    <=> v31343(VarCurr) ) ).

tff(addAssignment_15996,axiom,
    ! [VarCurr: state_type] :
      ( v31343(VarCurr)
    <=> v31345(VarCurr) ) ).

tff(addAssignment_15995,axiom,
    ! [VarCurr: state_type] :
      ( v31345(VarCurr)
    <=> v31347(VarCurr) ) ).

tff(addAssignment_15994,axiom,
    ! [VarCurr: state_type] :
      ( v31347(VarCurr)
    <=> v2066(VarCurr) ) ).

tff(addAssignment_15993,axiom,
    ! [VarCurr: state_type] :
      ( v31329(VarCurr)
    <=> v31331(VarCurr) ) ).

tff(addAssignment_15992,axiom,
    ! [VarCurr: state_type] :
      ( v31331(VarCurr)
    <=> v31333(VarCurr) ) ).

tff(addAssignment_15991,axiom,
    ! [VarCurr: state_type] :
      ( v31333(VarCurr)
    <=> v31335(VarCurr) ) ).

tff(addAssignment_15990,axiom,
    ! [VarCurr: state_type] :
      ( v31335(VarCurr)
    <=> v31337(VarCurr) ) ).

tff(addAssignment_15989,axiom,
    ! [VarCurr: state_type] :
      ( v31337(VarCurr)
    <=> v2058(VarCurr) ) ).

tff(addAssignment_15988,axiom,
    ! [VarCurr: state_type] :
      ( v31303(VarCurr)
    <=> v31305(VarCurr) ) ).

tff(addAssignment_15987,axiom,
    ! [VarCurr: state_type] :
      ( v31305(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15986,axiom,
    ! [VarCurr: state_type] :
      ( v31299(VarCurr)
    <=> v31301(VarCurr) ) ).

tff(addAssignment_15985,axiom,
    ! [VarCurr: state_type] :
      ( v31301(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_15984,axiom,
    ! [VarCurr: state_type] :
      ( v31279(VarCurr)
    <=> v31281(VarCurr) ) ).

tff(addAssignment_15983,axiom,
    ! [VarCurr: state_type] :
      ( v31281(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15982,axiom,
    ! [VarCurr: state_type] :
      ( v31275(VarCurr)
    <=> v31277(VarCurr) ) ).

tff(addAssignment_15981,axiom,
    ! [VarCurr: state_type] :
      ( v31277(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_15980,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31203(VarCurr,B)
      <=> v31266(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31266(VarCurr,B)
      <=> ~ v31205(VarCurr,B) ) ) ).

tff(addAssignment_15979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31205(VarCurr,B)
      <=> v31207(VarCurr,B) ) ) ).

tff(addAssignment_15978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31207(VarCurr,B)
      <=> v31209(VarCurr,B) ) ) ).

tff(addAssignment_15977,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31209(VarNext,B)
      <=> v31249(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31250(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v31249(VarNext,B)
            <=> v31209(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_354,axiom,
    ! [VarNext: state_type] :
      ( v31250(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31249(VarNext,B)
          <=> v31260(VarNext,B) ) ) ) ).

tff(addAssignment_15976,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31260(VarNext,B)
          <=> v31258(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31261(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31258(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_211,axiom,
    ! [VarCurr: state_type] :
      ( v31261(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31258(VarCurr,B)
          <=> v31219(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2606,axiom,
    ! [VarCurr: state_type] :
      ( v31261(VarCurr)
    <=> ( v31262(VarCurr)
        & v31263(VarCurr) ) ) ).

tff(writeUnaryOperator_1694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31263(VarCurr)
    <=> v31215(VarCurr) ) ).

tff(writeUnaryOperator_1693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31262(VarCurr)
    <=> v31211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2605,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31250(VarNext)
      <=> v31251(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31251(VarNext)
      <=> ( v31252(VarNext)
          & v31245(VarNext) ) ) ) ).

tff(writeUnaryOperator_1692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31252(VarNext)
      <=> v31254(VarNext) ) ) ).

tff(addAssignment_15975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31254(VarNext)
      <=> v31245(VarCurr) ) ) ).

tff(addAssignment_15974,axiom,
    ! [VarCurr: state_type] :
      ( v31245(VarCurr)
    <=> v31247(VarCurr) ) ).

tff(addAssignment_15973,axiom,
    ! [VarCurr: state_type] :
      ( v31247(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_15972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31219(VarCurr,B)
      <=> v31221(VarCurr,B) ) ) ).

tff(addAssignment_15971,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31221(VarCurr,B)
      <=> v31236(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31236(VarCurr,B)
      <=> ( v31237(VarCurr,B)
          | v31240(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31240(VarCurr,B)
      <=> ( v31207(VarCurr,B)
          & v31241(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1691,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31241(VarCurr,B)
      <=> ~ v31242(VarCurr,B) ) ) ).

tff(addAssignment_15970,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,0)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15969,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,1)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15968,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,2)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15967,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,3)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15966,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,4)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15965,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,5)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15964,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,6)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15963,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,7)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15962,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,8)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15961,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,9)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15960,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,10)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15959,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,11)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15958,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,12)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15957,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,13)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15956,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,14)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15955,axiom,
    ! [VarCurr: state_type] :
      ( v31242(VarCurr,15)
    <=> v31243(VarCurr) ) ).

tff(addAssignment_15954,axiom,
    ! [VarCurr: state_type] :
      ( v31243(VarCurr)
    <=> v31230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31237(VarCurr,B)
      <=> ( v31223(VarCurr,B)
          & v31238(VarCurr,B) ) ) ) ).

tff(addAssignment_15953,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,0)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15952,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,1)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15951,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,2)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15950,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,3)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15949,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,4)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15948,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,5)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15947,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,6)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15946,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,7)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15945,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,8)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15944,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,9)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15943,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,10)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15942,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,11)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15941,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,12)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15940,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,13)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15939,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,14)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15938,axiom,
    ! [VarCurr: state_type] :
      ( v31238(VarCurr,15)
    <=> v31239(VarCurr) ) ).

tff(addAssignment_15937,axiom,
    ! [VarCurr: state_type] :
      ( v31239(VarCurr)
    <=> v31230(VarCurr) ) ).

tff(addAssignment_15936,axiom,
    ! [VarCurr: state_type] :
      ( v31230(VarCurr)
    <=> v31232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2603,axiom,
    ! [VarCurr: state_type] :
      ( v31232(VarCurr)
    <=> ( v2354(VarCurr)
        & v31235(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_116,axiom,
    ! [VarCurr: state_type] :
      ( v31235(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_682,axiom,
    ~ b0100001101000(12) ).

tff(bitBlastConstant_681,axiom,
    b0100001101000(11) ).

tff(bitBlastConstant_680,axiom,
    ~ b0100001101000(10) ).

tff(bitBlastConstant_679,axiom,
    ~ b0100001101000(9) ).

tff(bitBlastConstant_678,axiom,
    ~ b0100001101000(8) ).

tff(bitBlastConstant_677,axiom,
    ~ b0100001101000(7) ).

tff(bitBlastConstant_676,axiom,
    b0100001101000(6) ).

tff(bitBlastConstant_675,axiom,
    b0100001101000(5) ).

tff(bitBlastConstant_674,axiom,
    ~ b0100001101000(4) ).

tff(bitBlastConstant_673,axiom,
    b0100001101000(3) ).

tff(bitBlastConstant_672,axiom,
    ~ b0100001101000(2) ).

tff(bitBlastConstant_671,axiom,
    ~ b0100001101000(1) ).

tff(bitBlastConstant_670,axiom,
    ~ b0100001101000(0) ).

tff(addAssignment_15935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31223(VarCurr,B)
      <=> v31225(VarCurr,B) ) ) ).

tff(addAssignment_15934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31225(VarCurr,B)
      <=> v31228(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31228(VarCurr,B)
      <=> ~ v31227(VarCurr,B) ) ) ).

tff(addAssignment_15933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v31227(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_15932,axiom,
    ! [VarCurr: state_type] :
      ( v31215(VarCurr)
    <=> v31217(VarCurr) ) ).

tff(addAssignment_15931,axiom,
    ! [VarCurr: state_type] :
      ( v31217(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15930,axiom,
    ! [VarCurr: state_type] :
      ( v31211(VarCurr)
    <=> v31213(VarCurr) ) ).

tff(addAssignment_15929,axiom,
    ! [VarCurr: state_type] :
      ( v31213(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_15928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30967(VarCurr,B)
      <=> v30969(VarCurr,B) ) ) ).

tff(addAssignment_15927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30969(VarCurr,B)
      <=> v30971(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31186(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v30971(VarNext,B)
            <=> v30971(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_353,axiom,
    ! [VarNext: state_type] :
      ( v31186(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v30971(VarNext,B)
          <=> v31196(VarNext,B) ) ) ) ).

tff(addAssignment_15926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31196(VarNext,B)
          <=> v31194(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31197(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31194(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_210,axiom,
    ! [VarCurr: state_type] :
      ( v31197(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31194(VarCurr,B)
          <=> v30981(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2602,axiom,
    ! [VarCurr: state_type] :
      ( v31197(VarCurr)
    <=> ( v31198(VarCurr)
        & v31199(VarCurr) ) ) ).

tff(writeUnaryOperator_1689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31199(VarCurr)
    <=> v30977(VarCurr) ) ).

tff(writeUnaryOperator_1688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31198(VarCurr)
    <=> v30973(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2601,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31186(VarNext)
      <=> v31187(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31187(VarNext)
      <=> ( v31188(VarNext)
          & v31181(VarNext) ) ) ) ).

tff(writeUnaryOperator_1687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31188(VarNext)
      <=> v31190(VarNext) ) ) ).

tff(addAssignment_15925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31190(VarNext)
      <=> v31181(VarCurr) ) ) ).

tff(addAssignment_15924,axiom,
    ! [VarCurr: state_type] :
      ( v31181(VarCurr)
    <=> v31183(VarCurr) ) ).

tff(addAssignment_15923,axiom,
    ! [VarCurr: state_type] :
      ( v31183(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_15922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30981(VarCurr,B)
      <=> v30983(VarCurr,B) ) ) ).

tff(addAssignment_15921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30983(VarCurr,B)
      <=> v30985(VarCurr,B) ) ) ).

tff(addAssignment_15920,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v30985(VarCurr,B)
      <=> v30987(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v30987(VarCurr,B)
          <=> v30991(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_209,axiom,
    ! [VarCurr: state_type] :
      ( v30965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v30987(VarCurr,B)
          <=> v31073(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31074(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31073(VarCurr,B)
          <=> v31075(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_208,axiom,
    ! [VarCurr: state_type] :
      ( v31074(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31073(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_15919,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,0)
    <=> v31178(VarCurr) ) ).

tff(addAssignment_15918,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,1)
    <=> v31176(VarCurr) ) ).

tff(addAssignment_15917,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,2)
    <=> v31172(VarCurr) ) ).

tff(addAssignment_15916,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,3)
    <=> v31168(VarCurr) ) ).

tff(addAssignment_15915,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,4)
    <=> v31164(VarCurr) ) ).

tff(addAssignment_15914,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,5)
    <=> v31160(VarCurr) ) ).

tff(addAssignment_15913,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,6)
    <=> v31156(VarCurr) ) ).

tff(addAssignment_15912,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,7)
    <=> v31152(VarCurr) ) ).

tff(addAssignment_15911,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,8)
    <=> v31148(VarCurr) ) ).

tff(addAssignment_15910,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,9)
    <=> v31144(VarCurr) ) ).

tff(addAssignment_15909,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,10)
    <=> v31140(VarCurr) ) ).

tff(addAssignment_15908,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,11)
    <=> v31136(VarCurr) ) ).

tff(addAssignment_15907,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,12)
    <=> v31132(VarCurr) ) ).

tff(addAssignment_15906,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,13)
    <=> v31128(VarCurr) ) ).

tff(addAssignment_15905,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,14)
    <=> v31124(VarCurr) ) ).

tff(addAssignment_15904,axiom,
    ! [VarCurr: state_type] :
      ( v31075(VarCurr,15)
    <=> v31077(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2599,axiom,
    ! [VarCurr: state_type] :
      ( v31176(VarCurr)
    <=> ( v31177(VarCurr)
        & v31179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2598,axiom,
    ! [VarCurr: state_type] :
      ( v31179(VarCurr)
    <=> ( v30967(VarCurr,0)
        | v31108(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_277,axiom,
    ! [VarCurr: state_type] :
      ( v31177(VarCurr)
    <=> ( v31178(VarCurr)
        | v30967(VarCurr,1) ) ) ).

tff(writeUnaryOperator_1686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31178(VarCurr)
    <=> v30967(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2597,axiom,
    ! [VarCurr: state_type] :
      ( v31172(VarCurr)
    <=> ( v31173(VarCurr)
        & v31175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2596,axiom,
    ! [VarCurr: state_type] :
      ( v31175(VarCurr)
    <=> ( v31106(VarCurr)
        | v31109(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_276,axiom,
    ! [VarCurr: state_type] :
      ( v31173(VarCurr)
    <=> ( v31174(VarCurr)
        | v30967(VarCurr,2) ) ) ).

tff(writeUnaryOperator_1685,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31174(VarCurr)
    <=> v31106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2595,axiom,
    ! [VarCurr: state_type] :
      ( v31168(VarCurr)
    <=> ( v31169(VarCurr)
        & v31171(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2594,axiom,
    ! [VarCurr: state_type] :
      ( v31171(VarCurr)
    <=> ( v31104(VarCurr)
        | v31110(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_275,axiom,
    ! [VarCurr: state_type] :
      ( v31169(VarCurr)
    <=> ( v31170(VarCurr)
        | v30967(VarCurr,3) ) ) ).

tff(writeUnaryOperator_1684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31170(VarCurr)
    <=> v31104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2593,axiom,
    ! [VarCurr: state_type] :
      ( v31164(VarCurr)
    <=> ( v31165(VarCurr)
        & v31167(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2592,axiom,
    ! [VarCurr: state_type] :
      ( v31167(VarCurr)
    <=> ( v31102(VarCurr)
        | v31111(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_274,axiom,
    ! [VarCurr: state_type] :
      ( v31165(VarCurr)
    <=> ( v31166(VarCurr)
        | v30967(VarCurr,4) ) ) ).

tff(writeUnaryOperator_1683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31166(VarCurr)
    <=> v31102(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2591,axiom,
    ! [VarCurr: state_type] :
      ( v31160(VarCurr)
    <=> ( v31161(VarCurr)
        & v31163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2590,axiom,
    ! [VarCurr: state_type] :
      ( v31163(VarCurr)
    <=> ( v31100(VarCurr)
        | v31112(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_273,axiom,
    ! [VarCurr: state_type] :
      ( v31161(VarCurr)
    <=> ( v31162(VarCurr)
        | v30967(VarCurr,5) ) ) ).

tff(writeUnaryOperator_1682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31162(VarCurr)
    <=> v31100(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2589,axiom,
    ! [VarCurr: state_type] :
      ( v31156(VarCurr)
    <=> ( v31157(VarCurr)
        & v31159(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2588,axiom,
    ! [VarCurr: state_type] :
      ( v31159(VarCurr)
    <=> ( v31098(VarCurr)
        | v31113(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_272,axiom,
    ! [VarCurr: state_type] :
      ( v31157(VarCurr)
    <=> ( v31158(VarCurr)
        | v30967(VarCurr,6) ) ) ).

tff(writeUnaryOperator_1681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31158(VarCurr)
    <=> v31098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2587,axiom,
    ! [VarCurr: state_type] :
      ( v31152(VarCurr)
    <=> ( v31153(VarCurr)
        & v31155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2586,axiom,
    ! [VarCurr: state_type] :
      ( v31155(VarCurr)
    <=> ( v31096(VarCurr)
        | v31114(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_271,axiom,
    ! [VarCurr: state_type] :
      ( v31153(VarCurr)
    <=> ( v31154(VarCurr)
        | v30967(VarCurr,7) ) ) ).

tff(writeUnaryOperator_1680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31154(VarCurr)
    <=> v31096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2585,axiom,
    ! [VarCurr: state_type] :
      ( v31148(VarCurr)
    <=> ( v31149(VarCurr)
        & v31151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2584,axiom,
    ! [VarCurr: state_type] :
      ( v31151(VarCurr)
    <=> ( v31094(VarCurr)
        | v31115(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_270,axiom,
    ! [VarCurr: state_type] :
      ( v31149(VarCurr)
    <=> ( v31150(VarCurr)
        | v30967(VarCurr,8) ) ) ).

tff(writeUnaryOperator_1679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31150(VarCurr)
    <=> v31094(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2583,axiom,
    ! [VarCurr: state_type] :
      ( v31144(VarCurr)
    <=> ( v31145(VarCurr)
        & v31147(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2582,axiom,
    ! [VarCurr: state_type] :
      ( v31147(VarCurr)
    <=> ( v31092(VarCurr)
        | v31116(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_269,axiom,
    ! [VarCurr: state_type] :
      ( v31145(VarCurr)
    <=> ( v31146(VarCurr)
        | v30967(VarCurr,9) ) ) ).

tff(writeUnaryOperator_1678,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31146(VarCurr)
    <=> v31092(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2581,axiom,
    ! [VarCurr: state_type] :
      ( v31140(VarCurr)
    <=> ( v31141(VarCurr)
        & v31143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2580,axiom,
    ! [VarCurr: state_type] :
      ( v31143(VarCurr)
    <=> ( v31090(VarCurr)
        | v31117(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_268,axiom,
    ! [VarCurr: state_type] :
      ( v31141(VarCurr)
    <=> ( v31142(VarCurr)
        | v30967(VarCurr,10) ) ) ).

tff(writeUnaryOperator_1677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31142(VarCurr)
    <=> v31090(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2579,axiom,
    ! [VarCurr: state_type] :
      ( v31136(VarCurr)
    <=> ( v31137(VarCurr)
        & v31139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2578,axiom,
    ! [VarCurr: state_type] :
      ( v31139(VarCurr)
    <=> ( v31088(VarCurr)
        | v31118(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_267,axiom,
    ! [VarCurr: state_type] :
      ( v31137(VarCurr)
    <=> ( v31138(VarCurr)
        | v30967(VarCurr,11) ) ) ).

tff(writeUnaryOperator_1676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31138(VarCurr)
    <=> v31088(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2577,axiom,
    ! [VarCurr: state_type] :
      ( v31132(VarCurr)
    <=> ( v31133(VarCurr)
        & v31135(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2576,axiom,
    ! [VarCurr: state_type] :
      ( v31135(VarCurr)
    <=> ( v31086(VarCurr)
        | v31119(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_266,axiom,
    ! [VarCurr: state_type] :
      ( v31133(VarCurr)
    <=> ( v31134(VarCurr)
        | v30967(VarCurr,12) ) ) ).

tff(writeUnaryOperator_1675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31134(VarCurr)
    <=> v31086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2575,axiom,
    ! [VarCurr: state_type] :
      ( v31128(VarCurr)
    <=> ( v31129(VarCurr)
        & v31131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2574,axiom,
    ! [VarCurr: state_type] :
      ( v31131(VarCurr)
    <=> ( v31084(VarCurr)
        | v31120(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_265,axiom,
    ! [VarCurr: state_type] :
      ( v31129(VarCurr)
    <=> ( v31130(VarCurr)
        | v30967(VarCurr,13) ) ) ).

tff(writeUnaryOperator_1674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31130(VarCurr)
    <=> v31084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2573,axiom,
    ! [VarCurr: state_type] :
      ( v31124(VarCurr)
    <=> ( v31125(VarCurr)
        & v31127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2572,axiom,
    ! [VarCurr: state_type] :
      ( v31127(VarCurr)
    <=> ( v31082(VarCurr)
        | v31121(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_264,axiom,
    ! [VarCurr: state_type] :
      ( v31125(VarCurr)
    <=> ( v31126(VarCurr)
        | v30967(VarCurr,14) ) ) ).

tff(writeUnaryOperator_1673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31126(VarCurr)
    <=> v31082(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2571,axiom,
    ! [VarCurr: state_type] :
      ( v31077(VarCurr)
    <=> ( v31078(VarCurr)
        & v31122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2570,axiom,
    ! [VarCurr: state_type] :
      ( v31122(VarCurr)
    <=> ( v31080(VarCurr)
        | v31123(VarCurr) ) ) ).

tff(writeUnaryOperator_1672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31123(VarCurr)
    <=> v30967(VarCurr,15) ) ).

tff(writeBinaryOperatorShiftedRanges_263,axiom,
    ! [VarCurr: state_type] :
      ( v31078(VarCurr)
    <=> ( v31079(VarCurr)
        | v30967(VarCurr,15) ) ) ).

tff(writeUnaryOperator_1671,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31079(VarCurr)
    <=> v31080(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_262,axiom,
    ! [VarCurr: state_type] :
      ( v31080(VarCurr)
    <=> ( v30967(VarCurr,14)
        | v31081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2569,axiom,
    ! [VarCurr: state_type] :
      ( v31081(VarCurr)
    <=> ( v31082(VarCurr)
        & v31121(VarCurr) ) ) ).

tff(writeUnaryOperator_1670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31121(VarCurr)
    <=> v30967(VarCurr,14) ) ).

tff(writeBinaryOperatorShiftedRanges_261,axiom,
    ! [VarCurr: state_type] :
      ( v31082(VarCurr)
    <=> ( v30967(VarCurr,13)
        | v31083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2568,axiom,
    ! [VarCurr: state_type] :
      ( v31083(VarCurr)
    <=> ( v31084(VarCurr)
        & v31120(VarCurr) ) ) ).

tff(writeUnaryOperator_1669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31120(VarCurr)
    <=> v30967(VarCurr,13) ) ).

tff(writeBinaryOperatorShiftedRanges_260,axiom,
    ! [VarCurr: state_type] :
      ( v31084(VarCurr)
    <=> ( v30967(VarCurr,12)
        | v31085(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2567,axiom,
    ! [VarCurr: state_type] :
      ( v31085(VarCurr)
    <=> ( v31086(VarCurr)
        & v31119(VarCurr) ) ) ).

tff(writeUnaryOperator_1668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31119(VarCurr)
    <=> v30967(VarCurr,12) ) ).

tff(writeBinaryOperatorShiftedRanges_259,axiom,
    ! [VarCurr: state_type] :
      ( v31086(VarCurr)
    <=> ( v30967(VarCurr,11)
        | v31087(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2566,axiom,
    ! [VarCurr: state_type] :
      ( v31087(VarCurr)
    <=> ( v31088(VarCurr)
        & v31118(VarCurr) ) ) ).

tff(writeUnaryOperator_1667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31118(VarCurr)
    <=> v30967(VarCurr,11) ) ).

tff(writeBinaryOperatorShiftedRanges_258,axiom,
    ! [VarCurr: state_type] :
      ( v31088(VarCurr)
    <=> ( v30967(VarCurr,10)
        | v31089(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2565,axiom,
    ! [VarCurr: state_type] :
      ( v31089(VarCurr)
    <=> ( v31090(VarCurr)
        & v31117(VarCurr) ) ) ).

tff(writeUnaryOperator_1666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31117(VarCurr)
    <=> v30967(VarCurr,10) ) ).

tff(writeBinaryOperatorShiftedRanges_257,axiom,
    ! [VarCurr: state_type] :
      ( v31090(VarCurr)
    <=> ( v30967(VarCurr,9)
        | v31091(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2564,axiom,
    ! [VarCurr: state_type] :
      ( v31091(VarCurr)
    <=> ( v31092(VarCurr)
        & v31116(VarCurr) ) ) ).

tff(writeUnaryOperator_1665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31116(VarCurr)
    <=> v30967(VarCurr,9) ) ).

tff(writeBinaryOperatorShiftedRanges_256,axiom,
    ! [VarCurr: state_type] :
      ( v31092(VarCurr)
    <=> ( v30967(VarCurr,8)
        | v31093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2563,axiom,
    ! [VarCurr: state_type] :
      ( v31093(VarCurr)
    <=> ( v31094(VarCurr)
        & v31115(VarCurr) ) ) ).

tff(writeUnaryOperator_1664,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31115(VarCurr)
    <=> v30967(VarCurr,8) ) ).

tff(writeBinaryOperatorShiftedRanges_255,axiom,
    ! [VarCurr: state_type] :
      ( v31094(VarCurr)
    <=> ( v30967(VarCurr,7)
        | v31095(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2562,axiom,
    ! [VarCurr: state_type] :
      ( v31095(VarCurr)
    <=> ( v31096(VarCurr)
        & v31114(VarCurr) ) ) ).

tff(writeUnaryOperator_1663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31114(VarCurr)
    <=> v30967(VarCurr,7) ) ).

tff(writeBinaryOperatorShiftedRanges_254,axiom,
    ! [VarCurr: state_type] :
      ( v31096(VarCurr)
    <=> ( v30967(VarCurr,6)
        | v31097(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2561,axiom,
    ! [VarCurr: state_type] :
      ( v31097(VarCurr)
    <=> ( v31098(VarCurr)
        & v31113(VarCurr) ) ) ).

tff(writeUnaryOperator_1662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31113(VarCurr)
    <=> v30967(VarCurr,6) ) ).

tff(writeBinaryOperatorShiftedRanges_253,axiom,
    ! [VarCurr: state_type] :
      ( v31098(VarCurr)
    <=> ( v30967(VarCurr,5)
        | v31099(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2560,axiom,
    ! [VarCurr: state_type] :
      ( v31099(VarCurr)
    <=> ( v31100(VarCurr)
        & v31112(VarCurr) ) ) ).

tff(writeUnaryOperator_1661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31112(VarCurr)
    <=> v30967(VarCurr,5) ) ).

tff(writeBinaryOperatorShiftedRanges_252,axiom,
    ! [VarCurr: state_type] :
      ( v31100(VarCurr)
    <=> ( v30967(VarCurr,4)
        | v31101(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2559,axiom,
    ! [VarCurr: state_type] :
      ( v31101(VarCurr)
    <=> ( v31102(VarCurr)
        & v31111(VarCurr) ) ) ).

tff(writeUnaryOperator_1660,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31111(VarCurr)
    <=> v30967(VarCurr,4) ) ).

tff(writeBinaryOperatorShiftedRanges_251,axiom,
    ! [VarCurr: state_type] :
      ( v31102(VarCurr)
    <=> ( v30967(VarCurr,3)
        | v31103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2558,axiom,
    ! [VarCurr: state_type] :
      ( v31103(VarCurr)
    <=> ( v31104(VarCurr)
        & v31110(VarCurr) ) ) ).

tff(writeUnaryOperator_1659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31110(VarCurr)
    <=> v30967(VarCurr,3) ) ).

tff(writeBinaryOperatorShiftedRanges_250,axiom,
    ! [VarCurr: state_type] :
      ( v31104(VarCurr)
    <=> ( v30967(VarCurr,2)
        | v31105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2557,axiom,
    ! [VarCurr: state_type] :
      ( v31105(VarCurr)
    <=> ( v31106(VarCurr)
        & v31109(VarCurr) ) ) ).

tff(writeUnaryOperator_1658,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31109(VarCurr)
    <=> v30967(VarCurr,2) ) ).

tff(writeBinaryOperatorShiftedRanges_249,axiom,
    ! [VarCurr: state_type] :
      ( v31106(VarCurr)
    <=> ( v30967(VarCurr,1)
        | v31107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2556,axiom,
    ! [VarCurr: state_type] :
      ( v31107(VarCurr)
    <=> ( v30967(VarCurr,0)
        & v31108(VarCurr) ) ) ).

tff(writeUnaryOperator_1657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31108(VarCurr)
    <=> v30967(VarCurr,1) ) ).

tff(addBitVectorEqualityBitBlasted_115,axiom,
    ! [VarCurr: state_type] :
      ( v31074(VarCurr)
    <=> ( ( v30967(VarCurr,15)
        <=> $false )
        & ( v30967(VarCurr,14)
        <=> $false )
        & ( v30967(VarCurr,13)
        <=> $false )
        & ( v30967(VarCurr,12)
        <=> $false )
        & ( v30967(VarCurr,11)
        <=> $false )
        & ( v30967(VarCurr,10)
        <=> $false )
        & ( v30967(VarCurr,9)
        <=> $false )
        & ( v30967(VarCurr,8)
        <=> $false )
        & ( v30967(VarCurr,7)
        <=> $false )
        & ( v30967(VarCurr,6)
        <=> $false )
        & ( v30967(VarCurr,5)
        <=> $false )
        & ( v30967(VarCurr,4)
        <=> $false )
        & ( v30967(VarCurr,3)
        <=> $false )
        & ( v30967(VarCurr,2)
        <=> $false )
        & ( v30967(VarCurr,1)
        <=> $false )
        & ( v30967(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_669,axiom,
    ~ b0000000000000000(15) ).

tff(bitBlastConstant_668,axiom,
    ~ b0000000000000000(14) ).

tff(bitBlastConstant_667,axiom,
    ~ b0000000000000000(13) ).

tff(bitBlastConstant_666,axiom,
    ~ b0000000000000000(12) ).

tff(bitBlastConstant_665,axiom,
    ~ b0000000000000000(11) ).

tff(bitBlastConstant_664,axiom,
    ~ b0000000000000000(10) ).

tff(bitBlastConstant_663,axiom,
    ~ b0000000000000000(9) ).

tff(bitBlastConstant_662,axiom,
    ~ b0000000000000000(8) ).

tff(bitBlastConstant_661,axiom,
    ~ b0000000000000000(7) ).

tff(bitBlastConstant_660,axiom,
    ~ b0000000000000000(6) ).

tff(bitBlastConstant_659,axiom,
    ~ b0000000000000000(5) ).

tff(bitBlastConstant_658,axiom,
    ~ b0000000000000000(4) ).

tff(bitBlastConstant_657,axiom,
    ~ b0000000000000000(3) ).

tff(bitBlastConstant_656,axiom,
    ~ b0000000000000000(2) ).

tff(bitBlastConstant_655,axiom,
    ~ b0000000000000000(1) ).

tff(bitBlastConstant_654,axiom,
    ~ b0000000000000000(0) ).

tff(addAssignment_15903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v30991(VarCurr,B)
      <=> v30993(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v30991(VarCurr,B)
      <=> ~ v31060(VarCurr,B) ) ) ).

tff(addAssignment_15902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31060(VarCurr,B)
      <=> v30993(VarCurr,B) ) ) ).

tff(addAssignment_15901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v30993(VarCurr,B)
      <=> v30995(VarCurr,B) ) ) ).

tff(addAssignment_15900,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v30995(VarNext,B)
      <=> v31064(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31065(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v31064(VarNext,B)
            <=> v30995(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_352,axiom,
    ! [VarNext: state_type] :
      ( v31065(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31064(VarNext,B)
          <=> v31053(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2555,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31065(VarNext)
      <=> v31066(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2554,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31066(VarNext)
      <=> ( v31068(VarNext)
          & v31038(VarNext) ) ) ) ).

tff(writeUnaryOperator_1655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31068(VarNext)
      <=> v31047(VarNext) ) ) ).

tff(addAssignment_15899,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31005(VarCurr,B)
      <=> v31007(VarCurr,B) ) ) ).

tff(addAssignment_15898,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31007(VarCurr,B)
      <=> v31029(VarCurr,B) ) ) ).

tff(addAssignment_15897,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31009(VarCurr,B)
      <=> v31020(VarCurr,B) ) ) ).

tff(writeUnaryOperator_1654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31021(VarCurr,B)
      <=> ~ v31011(VarCurr,B) ) ) ).

tff(addAssignment_15896,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31011(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_15895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v30993(VarCurr,B)
      <=> v30995(VarCurr,B) ) ) ).

tff(addAssignment_15894,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v30995(VarNext,B)
      <=> v31042(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31043(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v31042(VarNext,B)
            <=> v30995(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_351,axiom,
    ! [VarNext: state_type] :
      ( v31043(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31042(VarNext,B)
          <=> v31053(VarNext,B) ) ) ) ).

tff(addAssignment_15893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31053(VarNext,B)
          <=> v31051(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31054(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31051(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_207,axiom,
    ! [VarCurr: state_type] :
      ( v31054(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v31051(VarCurr,B)
          <=> v31005(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2553,axiom,
    ! [VarCurr: state_type] :
      ( v31054(VarCurr)
    <=> ( v31055(VarCurr)
        & v31056(VarCurr) ) ) ).

tff(writeUnaryOperator_1653,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31056(VarCurr)
    <=> v31001(VarCurr) ) ).

tff(writeUnaryOperator_1652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v31055(VarCurr)
    <=> v30997(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31043(VarNext)
      <=> v31044(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31044(VarNext)
      <=> ( v31045(VarNext)
          & v31038(VarNext) ) ) ) ).

tff(writeUnaryOperator_1651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31045(VarNext)
      <=> v31047(VarNext) ) ) ).

tff(addAssignment_15892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31047(VarNext)
      <=> v31038(VarCurr) ) ) ).

tff(addAssignment_15891,axiom,
    ! [VarCurr: state_type] :
      ( v31038(VarCurr)
    <=> v31040(VarCurr) ) ).

tff(addAssignment_15890,axiom,
    ! [VarCurr: state_type] :
      ( v31040(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_15889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v31005(VarCurr,B)
      <=> v31007(VarCurr,B) ) ) ).

tff(addAssignment_15888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v31007(VarCurr,B)
      <=> v31029(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31029(VarCurr,B)
      <=> ( v31030(VarCurr,B)
          | v31033(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31033(VarCurr,B)
      <=> ( v30993(VarCurr,B)
          & v31034(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_1650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31034(VarCurr,B)
      <=> ~ v31035(VarCurr,B) ) ) ).

tff(addAssignment_15887,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,0)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15886,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,1)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15885,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,2)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15884,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,3)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15883,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,4)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15882,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,5)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15881,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,6)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15880,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,7)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15879,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,8)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15878,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,9)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15877,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,10)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15876,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,11)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15875,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,12)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15874,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,13)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15873,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,14)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15872,axiom,
    ! [VarCurr: state_type] :
      ( v31035(VarCurr,15)
    <=> v31036(VarCurr) ) ).

tff(addAssignment_15871,axiom,
    ! [VarCurr: state_type] :
      ( v31036(VarCurr)
    <=> v31023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v31030(VarCurr,B)
      <=> ( v31009(VarCurr,B)
          & v31031(VarCurr,B) ) ) ) ).

tff(addAssignment_15870,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,0)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15869,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,1)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15868,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,2)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15867,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,3)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15866,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,4)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15865,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,5)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15864,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,6)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15863,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,7)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15862,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,8)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15861,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,9)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15860,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,10)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15859,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,11)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15858,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,12)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15857,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,13)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15856,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,14)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15855,axiom,
    ! [VarCurr: state_type] :
      ( v31031(VarCurr,15)
    <=> v31032(VarCurr) ) ).

tff(addAssignment_15854,axiom,
    ! [VarCurr: state_type] :
      ( v31032(VarCurr)
    <=> v31023(VarCurr) ) ).

tff(addAssignment_15853,axiom,
    ! [VarCurr: state_type] :
      ( v31023(VarCurr)
    <=> v31025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2550,axiom,
    ! [VarCurr: state_type] :
      ( v31025(VarCurr)
    <=> ( v2354(VarCurr)
        & v31028(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_114,axiom,
    ! [VarCurr: state_type] :
      ( v31028(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_653,axiom,
    ~ b0100001011000(12) ).

tff(bitBlastConstant_652,axiom,
    b0100001011000(11) ).

tff(bitBlastConstant_651,axiom,
    ~ b0100001011000(10) ).

tff(bitBlastConstant_650,axiom,
    ~ b0100001011000(9) ).

tff(bitBlastConstant_649,axiom,
    ~ b0100001011000(8) ).

tff(bitBlastConstant_648,axiom,
    ~ b0100001011000(7) ).

tff(bitBlastConstant_647,axiom,
    b0100001011000(6) ).

tff(bitBlastConstant_646,axiom,
    ~ b0100001011000(5) ).

tff(bitBlastConstant_645,axiom,
    b0100001011000(4) ).

tff(bitBlastConstant_644,axiom,
    b0100001011000(3) ).

tff(bitBlastConstant_643,axiom,
    ~ b0100001011000(2) ).

tff(bitBlastConstant_642,axiom,
    ~ b0100001011000(1) ).

tff(bitBlastConstant_641,axiom,
    ~ b0100001011000(0) ).

tff(addAssignment_15852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v31009(VarCurr,B)
      <=> v31020(VarCurr,B) ) ) ).

tff(addAssignment_15851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v31020(VarCurr,B)
      <=> v31021(VarCurr,B) ) ) ).

tff(addAssignment_15850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v31020(VarCurr,B)
      <=> v31011(VarCurr,B) ) ) ).

tff(addAssignment_15849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,8) )
     => ( v31011(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_15848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v2363(VarCurr,B)
      <=> v2365(VarCurr,B) ) ) ).

tff(addAssignment_15847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v2365(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_15846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1119(VarCurr,B)
      <=> v1121(VarCurr,B) ) ) ).

tff(addAssignment_15845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1121(VarCurr,B)
      <=> v1123(VarCurr,B) ) ) ).

tff(addAssignment_15844,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1123(VarNext,B)
      <=> v31013(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31014(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v31013(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_350,axiom,
    ! [VarNext: state_type] :
      ( v31014(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v31013(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31014(VarNext)
      <=> v31015(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v31015(VarNext)
      <=> ( v31017(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_1649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v31017(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_15843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1133(VarCurr,B)
      <=> v1135(VarCurr,B) ) ) ).

tff(addAssignment_15842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1135(VarCurr,B)
      <=> v1137(VarCurr,B) ) ) ).

tff(addAssignment_15841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1137(VarCurr,B)
      <=> v1697(VarCurr,B) ) ) ).

tff(addAssignment_15840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1139(VarCurr,B)
      <=> v1141(VarCurr,B) ) ) ).

tff(addAssignment_15839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1141(VarCurr,B)
      <=> v1143(VarCurr,B) ) ) ).

tff(addAssignment_15838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1143(VarCurr,B)
      <=> v1145(VarCurr,B) ) ) ).

tff(addAssignment_15837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,12) )
     => ( v1145(VarCurr,B)
      <=> v1147(VarCurr,B) ) ) ).

tff(addAssignment_15836,axiom,
    ! [VarCurr: state_type] :
      ( v31001(VarCurr)
    <=> v31003(VarCurr) ) ).

tff(addAssignment_15835,axiom,
    ! [VarCurr: state_type] :
      ( v31003(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15834,axiom,
    ! [VarCurr: state_type] :
      ( v30997(VarCurr)
    <=> v30999(VarCurr) ) ).

tff(addAssignment_15833,axiom,
    ! [VarCurr: state_type] :
      ( v30999(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_15832,axiom,
    ! [VarCurr: state_type] :
      ( v30977(VarCurr)
    <=> v30979(VarCurr) ) ).

tff(addAssignment_15831,axiom,
    ! [VarCurr: state_type] :
      ( v30979(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15830,axiom,
    ! [VarCurr: state_type] :
      ( v30973(VarCurr)
    <=> v30975(VarCurr) ) ).

tff(addAssignment_15829,axiom,
    ! [VarCurr: state_type] :
      ( v30975(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_15828,axiom,
    ! [VarCurr: state_type] :
      ( v30965(VarCurr)
    <=> v4613(VarCurr) ) ).

tff(addAssignment_15827,axiom,
    ! [VarCurr: state_type] :
      ( v30953(VarCurr)
    <=> v30955(VarCurr) ) ).

tff(addAssignment_15826,axiom,
    ! [VarCurr: state_type] :
      ( v30955(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_15825,axiom,
    ! [VarCurr: state_type] :
      ( v30949(VarCurr)
    <=> v30951(VarCurr) ) ).

tff(addAssignment_15824,axiom,
    ! [VarCurr: state_type] :
      ( v30951(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2547,axiom,
    ! [VarCurr: state_type] :
      ( v30900(VarCurr)
    <=> ( v30916(VarCurr)
        | v30941(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_113,axiom,
    ! [VarCurr: state_type] :
      ( v30941(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $false )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_640,axiom,
    ~ b01111111111111(13) ).

tff(bitBlastConstant_639,axiom,
    b01111111111111(12) ).

tff(bitBlastConstant_638,axiom,
    b01111111111111(11) ).

tff(bitBlastConstant_637,axiom,
    b01111111111111(10) ).

tff(bitBlastConstant_636,axiom,
    b01111111111111(9) ).

tff(bitBlastConstant_635,axiom,
    b01111111111111(8) ).

tff(bitBlastConstant_634,axiom,
    b01111111111111(7) ).

tff(bitBlastConstant_633,axiom,
    b01111111111111(6) ).

tff(bitBlastConstant_632,axiom,
    b01111111111111(5) ).

tff(bitBlastConstant_631,axiom,
    b01111111111111(4) ).

tff(bitBlastConstant_630,axiom,
    b01111111111111(3) ).

tff(bitBlastConstant_629,axiom,
    b01111111111111(2) ).

tff(bitBlastConstant_628,axiom,
    b01111111111111(1) ).

tff(bitBlastConstant_627,axiom,
    b01111111111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2546,axiom,
    ! [VarCurr: state_type] :
      ( v30916(VarCurr)
    <=> ( v30917(VarCurr)
        | v30940(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_112,axiom,
    ! [VarCurr: state_type] :
      ( v30940(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $false )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_626,axiom,
    b10111111111111(13) ).

tff(bitBlastConstant_625,axiom,
    ~ b10111111111111(12) ).

tff(bitBlastConstant_624,axiom,
    b10111111111111(11) ).

tff(bitBlastConstant_623,axiom,
    b10111111111111(10) ).

tff(bitBlastConstant_622,axiom,
    b10111111111111(9) ).

tff(bitBlastConstant_621,axiom,
    b10111111111111(8) ).

tff(bitBlastConstant_620,axiom,
    b10111111111111(7) ).

tff(bitBlastConstant_619,axiom,
    b10111111111111(6) ).

tff(bitBlastConstant_618,axiom,
    b10111111111111(5) ).

tff(bitBlastConstant_617,axiom,
    b10111111111111(4) ).

tff(bitBlastConstant_616,axiom,
    b10111111111111(3) ).

tff(bitBlastConstant_615,axiom,
    b10111111111111(2) ).

tff(bitBlastConstant_614,axiom,
    b10111111111111(1) ).

tff(bitBlastConstant_613,axiom,
    b10111111111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2545,axiom,
    ! [VarCurr: state_type] :
      ( v30917(VarCurr)
    <=> ( v30918(VarCurr)
        | v30939(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_111,axiom,
    ! [VarCurr: state_type] :
      ( v30939(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $false )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_612,axiom,
    b11011111111111(13) ).

tff(bitBlastConstant_611,axiom,
    b11011111111111(12) ).

tff(bitBlastConstant_610,axiom,
    ~ b11011111111111(11) ).

tff(bitBlastConstant_609,axiom,
    b11011111111111(10) ).

tff(bitBlastConstant_608,axiom,
    b11011111111111(9) ).

tff(bitBlastConstant_607,axiom,
    b11011111111111(8) ).

tff(bitBlastConstant_606,axiom,
    b11011111111111(7) ).

tff(bitBlastConstant_605,axiom,
    b11011111111111(6) ).

tff(bitBlastConstant_604,axiom,
    b11011111111111(5) ).

tff(bitBlastConstant_603,axiom,
    b11011111111111(4) ).

tff(bitBlastConstant_602,axiom,
    b11011111111111(3) ).

tff(bitBlastConstant_601,axiom,
    b11011111111111(2) ).

tff(bitBlastConstant_600,axiom,
    b11011111111111(1) ).

tff(bitBlastConstant_599,axiom,
    b11011111111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2544,axiom,
    ! [VarCurr: state_type] :
      ( v30918(VarCurr)
    <=> ( v30919(VarCurr)
        | v30938(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_110,axiom,
    ! [VarCurr: state_type] :
      ( v30938(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $false )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_598,axiom,
    b11101111111111(13) ).

tff(bitBlastConstant_597,axiom,
    b11101111111111(12) ).

tff(bitBlastConstant_596,axiom,
    b11101111111111(11) ).

tff(bitBlastConstant_595,axiom,
    ~ b11101111111111(10) ).

tff(bitBlastConstant_594,axiom,
    b11101111111111(9) ).

tff(bitBlastConstant_593,axiom,
    b11101111111111(8) ).

tff(bitBlastConstant_592,axiom,
    b11101111111111(7) ).

tff(bitBlastConstant_591,axiom,
    b11101111111111(6) ).

tff(bitBlastConstant_590,axiom,
    b11101111111111(5) ).

tff(bitBlastConstant_589,axiom,
    b11101111111111(4) ).

tff(bitBlastConstant_588,axiom,
    b11101111111111(3) ).

tff(bitBlastConstant_587,axiom,
    b11101111111111(2) ).

tff(bitBlastConstant_586,axiom,
    b11101111111111(1) ).

tff(bitBlastConstant_585,axiom,
    b11101111111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2543,axiom,
    ! [VarCurr: state_type] :
      ( v30919(VarCurr)
    <=> ( v30920(VarCurr)
        | v30937(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_109,axiom,
    ! [VarCurr: state_type] :
      ( v30937(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $false )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_584,axiom,
    b11110111111111(13) ).

tff(bitBlastConstant_583,axiom,
    b11110111111111(12) ).

tff(bitBlastConstant_582,axiom,
    b11110111111111(11) ).

tff(bitBlastConstant_581,axiom,
    b11110111111111(10) ).

tff(bitBlastConstant_580,axiom,
    ~ b11110111111111(9) ).

tff(bitBlastConstant_579,axiom,
    b11110111111111(8) ).

tff(bitBlastConstant_578,axiom,
    b11110111111111(7) ).

tff(bitBlastConstant_577,axiom,
    b11110111111111(6) ).

tff(bitBlastConstant_576,axiom,
    b11110111111111(5) ).

tff(bitBlastConstant_575,axiom,
    b11110111111111(4) ).

tff(bitBlastConstant_574,axiom,
    b11110111111111(3) ).

tff(bitBlastConstant_573,axiom,
    b11110111111111(2) ).

tff(bitBlastConstant_572,axiom,
    b11110111111111(1) ).

tff(bitBlastConstant_571,axiom,
    b11110111111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2542,axiom,
    ! [VarCurr: state_type] :
      ( v30920(VarCurr)
    <=> ( v30921(VarCurr)
        | v30936(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_108,axiom,
    ! [VarCurr: state_type] :
      ( v30936(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $false )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_570,axiom,
    b11111011111111(13) ).

tff(bitBlastConstant_569,axiom,
    b11111011111111(12) ).

tff(bitBlastConstant_568,axiom,
    b11111011111111(11) ).

tff(bitBlastConstant_567,axiom,
    b11111011111111(10) ).

tff(bitBlastConstant_566,axiom,
    b11111011111111(9) ).

tff(bitBlastConstant_565,axiom,
    ~ b11111011111111(8) ).

tff(bitBlastConstant_564,axiom,
    b11111011111111(7) ).

tff(bitBlastConstant_563,axiom,
    b11111011111111(6) ).

tff(bitBlastConstant_562,axiom,
    b11111011111111(5) ).

tff(bitBlastConstant_561,axiom,
    b11111011111111(4) ).

tff(bitBlastConstant_560,axiom,
    b11111011111111(3) ).

tff(bitBlastConstant_559,axiom,
    b11111011111111(2) ).

tff(bitBlastConstant_558,axiom,
    b11111011111111(1) ).

tff(bitBlastConstant_557,axiom,
    b11111011111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2541,axiom,
    ! [VarCurr: state_type] :
      ( v30921(VarCurr)
    <=> ( v30922(VarCurr)
        | v30935(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_107,axiom,
    ! [VarCurr: state_type] :
      ( v30935(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $false )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_556,axiom,
    b11111101111111(13) ).

tff(bitBlastConstant_555,axiom,
    b11111101111111(12) ).

tff(bitBlastConstant_554,axiom,
    b11111101111111(11) ).

tff(bitBlastConstant_553,axiom,
    b11111101111111(10) ).

tff(bitBlastConstant_552,axiom,
    b11111101111111(9) ).

tff(bitBlastConstant_551,axiom,
    b11111101111111(8) ).

tff(bitBlastConstant_550,axiom,
    ~ b11111101111111(7) ).

tff(bitBlastConstant_549,axiom,
    b11111101111111(6) ).

tff(bitBlastConstant_548,axiom,
    b11111101111111(5) ).

tff(bitBlastConstant_547,axiom,
    b11111101111111(4) ).

tff(bitBlastConstant_546,axiom,
    b11111101111111(3) ).

tff(bitBlastConstant_545,axiom,
    b11111101111111(2) ).

tff(bitBlastConstant_544,axiom,
    b11111101111111(1) ).

tff(bitBlastConstant_543,axiom,
    b11111101111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2540,axiom,
    ! [VarCurr: state_type] :
      ( v30922(VarCurr)
    <=> ( v30923(VarCurr)
        | v30934(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_106,axiom,
    ! [VarCurr: state_type] :
      ( v30934(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $false )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_542,axiom,
    b11111110111111(13) ).

tff(bitBlastConstant_541,axiom,
    b11111110111111(12) ).

tff(bitBlastConstant_540,axiom,
    b11111110111111(11) ).

tff(bitBlastConstant_539,axiom,
    b11111110111111(10) ).

tff(bitBlastConstant_538,axiom,
    b11111110111111(9) ).

tff(bitBlastConstant_537,axiom,
    b11111110111111(8) ).

tff(bitBlastConstant_536,axiom,
    b11111110111111(7) ).

tff(bitBlastConstant_535,axiom,
    ~ b11111110111111(6) ).

tff(bitBlastConstant_534,axiom,
    b11111110111111(5) ).

tff(bitBlastConstant_533,axiom,
    b11111110111111(4) ).

tff(bitBlastConstant_532,axiom,
    b11111110111111(3) ).

tff(bitBlastConstant_531,axiom,
    b11111110111111(2) ).

tff(bitBlastConstant_530,axiom,
    b11111110111111(1) ).

tff(bitBlastConstant_529,axiom,
    b11111110111111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2539,axiom,
    ! [VarCurr: state_type] :
      ( v30923(VarCurr)
    <=> ( v30924(VarCurr)
        | v30933(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_105,axiom,
    ! [VarCurr: state_type] :
      ( v30933(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $false )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_528,axiom,
    b11111111011111(13) ).

tff(bitBlastConstant_527,axiom,
    b11111111011111(12) ).

tff(bitBlastConstant_526,axiom,
    b11111111011111(11) ).

tff(bitBlastConstant_525,axiom,
    b11111111011111(10) ).

tff(bitBlastConstant_524,axiom,
    b11111111011111(9) ).

tff(bitBlastConstant_523,axiom,
    b11111111011111(8) ).

tff(bitBlastConstant_522,axiom,
    b11111111011111(7) ).

tff(bitBlastConstant_521,axiom,
    b11111111011111(6) ).

tff(bitBlastConstant_520,axiom,
    ~ b11111111011111(5) ).

tff(bitBlastConstant_519,axiom,
    b11111111011111(4) ).

tff(bitBlastConstant_518,axiom,
    b11111111011111(3) ).

tff(bitBlastConstant_517,axiom,
    b11111111011111(2) ).

tff(bitBlastConstant_516,axiom,
    b11111111011111(1) ).

tff(bitBlastConstant_515,axiom,
    b11111111011111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2538,axiom,
    ! [VarCurr: state_type] :
      ( v30924(VarCurr)
    <=> ( v30925(VarCurr)
        | v30932(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_104,axiom,
    ! [VarCurr: state_type] :
      ( v30932(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $false )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_514,axiom,
    b11111111101111(13) ).

tff(bitBlastConstant_513,axiom,
    b11111111101111(12) ).

tff(bitBlastConstant_512,axiom,
    b11111111101111(11) ).

tff(bitBlastConstant_511,axiom,
    b11111111101111(10) ).

tff(bitBlastConstant_510,axiom,
    b11111111101111(9) ).

tff(bitBlastConstant_509,axiom,
    b11111111101111(8) ).

tff(bitBlastConstant_508,axiom,
    b11111111101111(7) ).

tff(bitBlastConstant_507,axiom,
    b11111111101111(6) ).

tff(bitBlastConstant_506,axiom,
    b11111111101111(5) ).

tff(bitBlastConstant_505,axiom,
    ~ b11111111101111(4) ).

tff(bitBlastConstant_504,axiom,
    b11111111101111(3) ).

tff(bitBlastConstant_503,axiom,
    b11111111101111(2) ).

tff(bitBlastConstant_502,axiom,
    b11111111101111(1) ).

tff(bitBlastConstant_501,axiom,
    b11111111101111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2537,axiom,
    ! [VarCurr: state_type] :
      ( v30925(VarCurr)
    <=> ( v30926(VarCurr)
        | v30931(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_103,axiom,
    ! [VarCurr: state_type] :
      ( v30931(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $false )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_500,axiom,
    b11111111110111(13) ).

tff(bitBlastConstant_499,axiom,
    b11111111110111(12) ).

tff(bitBlastConstant_498,axiom,
    b11111111110111(11) ).

tff(bitBlastConstant_497,axiom,
    b11111111110111(10) ).

tff(bitBlastConstant_496,axiom,
    b11111111110111(9) ).

tff(bitBlastConstant_495,axiom,
    b11111111110111(8) ).

tff(bitBlastConstant_494,axiom,
    b11111111110111(7) ).

tff(bitBlastConstant_493,axiom,
    b11111111110111(6) ).

tff(bitBlastConstant_492,axiom,
    b11111111110111(5) ).

tff(bitBlastConstant_491,axiom,
    b11111111110111(4) ).

tff(bitBlastConstant_490,axiom,
    ~ b11111111110111(3) ).

tff(bitBlastConstant_489,axiom,
    b11111111110111(2) ).

tff(bitBlastConstant_488,axiom,
    b11111111110111(1) ).

tff(bitBlastConstant_487,axiom,
    b11111111110111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2536,axiom,
    ! [VarCurr: state_type] :
      ( v30926(VarCurr)
    <=> ( v30927(VarCurr)
        | v30930(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_102,axiom,
    ! [VarCurr: state_type] :
      ( v30930(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $false )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_486,axiom,
    b11111111111011(13) ).

tff(bitBlastConstant_485,axiom,
    b11111111111011(12) ).

tff(bitBlastConstant_484,axiom,
    b11111111111011(11) ).

tff(bitBlastConstant_483,axiom,
    b11111111111011(10) ).

tff(bitBlastConstant_482,axiom,
    b11111111111011(9) ).

tff(bitBlastConstant_481,axiom,
    b11111111111011(8) ).

tff(bitBlastConstant_480,axiom,
    b11111111111011(7) ).

tff(bitBlastConstant_479,axiom,
    b11111111111011(6) ).

tff(bitBlastConstant_478,axiom,
    b11111111111011(5) ).

tff(bitBlastConstant_477,axiom,
    b11111111111011(4) ).

tff(bitBlastConstant_476,axiom,
    b11111111111011(3) ).

tff(bitBlastConstant_475,axiom,
    ~ b11111111111011(2) ).

tff(bitBlastConstant_474,axiom,
    b11111111111011(1) ).

tff(bitBlastConstant_473,axiom,
    b11111111111011(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2535,axiom,
    ! [VarCurr: state_type] :
      ( v30927(VarCurr)
    <=> ( v30928(VarCurr)
        | v30929(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_101,axiom,
    ! [VarCurr: state_type] :
      ( v30929(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $false )
        & ( v9079(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_472,axiom,
    b11111111111101(13) ).

tff(bitBlastConstant_471,axiom,
    b11111111111101(12) ).

tff(bitBlastConstant_470,axiom,
    b11111111111101(11) ).

tff(bitBlastConstant_469,axiom,
    b11111111111101(10) ).

tff(bitBlastConstant_468,axiom,
    b11111111111101(9) ).

tff(bitBlastConstant_467,axiom,
    b11111111111101(8) ).

tff(bitBlastConstant_466,axiom,
    b11111111111101(7) ).

tff(bitBlastConstant_465,axiom,
    b11111111111101(6) ).

tff(bitBlastConstant_464,axiom,
    b11111111111101(5) ).

tff(bitBlastConstant_463,axiom,
    b11111111111101(4) ).

tff(bitBlastConstant_462,axiom,
    b11111111111101(3) ).

tff(bitBlastConstant_461,axiom,
    b11111111111101(2) ).

tff(bitBlastConstant_460,axiom,
    ~ b11111111111101(1) ).

tff(bitBlastConstant_459,axiom,
    b11111111111101(0) ).

tff(addBitVectorEqualityBitBlasted_100,axiom,
    ! [VarCurr: state_type] :
      ( v30928(VarCurr)
    <=> ( ( v9079(VarCurr,13)
        <=> $true )
        & ( v9079(VarCurr,12)
        <=> $true )
        & ( v9079(VarCurr,11)
        <=> $true )
        & ( v9079(VarCurr,10)
        <=> $true )
        & ( v9079(VarCurr,9)
        <=> $true )
        & ( v9079(VarCurr,8)
        <=> $true )
        & ( v9079(VarCurr,7)
        <=> $true )
        & ( v9079(VarCurr,6)
        <=> $true )
        & ( v9079(VarCurr,5)
        <=> $true )
        & ( v9079(VarCurr,4)
        <=> $true )
        & ( v9079(VarCurr,3)
        <=> $true )
        & ( v9079(VarCurr,2)
        <=> $true )
        & ( v9079(VarCurr,1)
        <=> $true )
        & ( v9079(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_458,axiom,
    b11111111111110(13) ).

tff(bitBlastConstant_457,axiom,
    b11111111111110(12) ).

tff(bitBlastConstant_456,axiom,
    b11111111111110(11) ).

tff(bitBlastConstant_455,axiom,
    b11111111111110(10) ).

tff(bitBlastConstant_454,axiom,
    b11111111111110(9) ).

tff(bitBlastConstant_453,axiom,
    b11111111111110(8) ).

tff(bitBlastConstant_452,axiom,
    b11111111111110(7) ).

tff(bitBlastConstant_451,axiom,
    b11111111111110(6) ).

tff(bitBlastConstant_450,axiom,
    b11111111111110(5) ).

tff(bitBlastConstant_449,axiom,
    b11111111111110(4) ).

tff(bitBlastConstant_448,axiom,
    b11111111111110(3) ).

tff(bitBlastConstant_447,axiom,
    b11111111111110(2) ).

tff(bitBlastConstant_446,axiom,
    b11111111111110(1) ).

tff(bitBlastConstant_445,axiom,
    ~ b11111111111110(0) ).

tff(addAssignment_15823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v9079(VarCurr,B)
      <=> v9081(VarCurr,B) ) ) ).

tff(addAssignment_15822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v9081(VarCurr,B)
      <=> v9083(VarCurr,B) ) ) ).

tff(addAssignment_15821,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,13)
    <=> v29641(VarCurr) ) ).

tff(addAssignment_15820,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,12)
    <=> v28091(VarCurr) ) ).

tff(addAssignment_15819,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,11)
    <=> v26541(VarCurr) ) ).

tff(addAssignment_15818,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,10)
    <=> v24991(VarCurr) ) ).

tff(addAssignment_15817,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,9)
    <=> v23441(VarCurr) ) ).

tff(addAssignment_15816,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,8)
    <=> v21891(VarCurr) ) ).

tff(addAssignment_15815,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,7)
    <=> v20341(VarCurr) ) ).

tff(addAssignment_15814,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,6)
    <=> v18791(VarCurr) ) ).

tff(addAssignment_15813,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,5)
    <=> v17241(VarCurr) ) ).

tff(addAssignment_15812,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,4)
    <=> v15691(VarCurr) ) ).

tff(addAssignment_15811,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,3)
    <=> v14141(VarCurr) ) ).

tff(addAssignment_15810,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,2)
    <=> v12591(VarCurr) ) ).

tff(addAssignment_15809,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,1)
    <=> v11041(VarCurr) ) ).

tff(addAssignment_15808,axiom,
    ! [VarCurr: state_type] :
      ( v9083(VarCurr,0)
    <=> v9085(VarCurr) ) ).

tff(addAssignment_15807,axiom,
    ! [VarCurr: state_type] :
      ( v29641(VarCurr)
    <=> v29643(VarCurr) ) ).

tff(addAssignment_15806,axiom,
    ! [VarCurr: state_type] :
      ( v29643(VarCurr)
    <=> v29645(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_99,axiom,
    ! [VarCurr: state_type] :
      ( v29645(VarCurr)
    <=> ( ( v29647(VarCurr,11)
        <=> v29651(VarCurr,11) )
        & ( v29647(VarCurr,10)
        <=> v29651(VarCurr,10) )
        & ( v29647(VarCurr,9)
        <=> v29651(VarCurr,9) )
        & ( v29647(VarCurr,8)
        <=> v29651(VarCurr,8) )
        & ( v29647(VarCurr,7)
        <=> v29651(VarCurr,7) )
        & ( v29647(VarCurr,6)
        <=> v29651(VarCurr,6) )
        & ( v29647(VarCurr,5)
        <=> v29651(VarCurr,5) )
        & ( v29647(VarCurr,4)
        <=> v29651(VarCurr,4) )
        & ( v29647(VarCurr,3)
        <=> v29651(VarCurr,3) )
        & ( v29647(VarCurr,2)
        <=> v29651(VarCurr,2) )
        & ( v29647(VarCurr,1)
        <=> v29651(VarCurr,1) )
        & ( v29647(VarCurr,0)
        <=> v29651(VarCurr,0) ) ) ) ).

tff(addAssignment_15805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29651(VarCurr,B)
      <=> v29653(VarCurr,B) ) ) ).

tff(addAssignment_15804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29653(VarCurr,B)
      <=> v29655(VarCurr,B) ) ) ).

tff(addAssignment_15803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29655(VarCurr,B)
      <=> v29657(VarCurr,B) ) ) ).

tff(addAssignment_15802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29657(VarCurr,B)
      <=> v29659(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29659(VarCurr,B)
      <=> ( v30876(VarCurr,B)
          | v30895(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30895(VarCurr,B)
      <=> ( v30747(VarCurr,B)
          & v30896(VarCurr,B) ) ) ) ).

tff(addAssignment_15801,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,0)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15800,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,1)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15799,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,2)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15798,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,3)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15797,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,4)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15796,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,5)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15795,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,6)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15794,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,7)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15793,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,8)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15792,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,9)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15791,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,10)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15790,axiom,
    ! [VarCurr: state_type] :
      ( v30896(VarCurr,11)
    <=> v30897(VarCurr) ) ).

tff(addAssignment_15789,axiom,
    ! [VarCurr: state_type] :
      ( v30897(VarCurr)
    <=> v30866(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30876(VarCurr,B)
      <=> ( v30877(VarCurr,B)
          | v30892(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30892(VarCurr,B)
      <=> ( v30596(VarCurr,B)
          & v30893(VarCurr,B) ) ) ) ).

tff(addAssignment_15788,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,0)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15787,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,1)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15786,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,2)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15785,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,3)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15784,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,4)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15783,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,5)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15782,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,6)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15781,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,7)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15780,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,8)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15779,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,9)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15778,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,10)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15777,axiom,
    ! [VarCurr: state_type] :
      ( v30893(VarCurr,11)
    <=> v30894(VarCurr) ) ).

tff(addAssignment_15776,axiom,
    ! [VarCurr: state_type] :
      ( v30894(VarCurr)
    <=> v30716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30877(VarCurr,B)
      <=> ( v30878(VarCurr,B)
          | v30889(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30889(VarCurr,B)
      <=> ( v30445(VarCurr,B)
          & v30890(VarCurr,B) ) ) ) ).

tff(addAssignment_15775,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,0)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15774,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,1)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15773,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,2)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15772,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,3)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15771,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,4)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15770,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,5)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15769,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,6)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15768,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,7)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15767,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,8)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15766,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,9)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15765,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,10)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15764,axiom,
    ! [VarCurr: state_type] :
      ( v30890(VarCurr,11)
    <=> v30891(VarCurr) ) ).

tff(addAssignment_15763,axiom,
    ! [VarCurr: state_type] :
      ( v30891(VarCurr)
    <=> v30565(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30878(VarCurr,B)
      <=> ( v30879(VarCurr,B)
          | v30886(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30886(VarCurr,B)
      <=> ( v30294(VarCurr,B)
          & v30887(VarCurr,B) ) ) ) ).

tff(addAssignment_15762,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,0)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15761,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,1)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15760,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,2)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15759,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,3)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15758,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,4)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15757,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,5)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15756,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,6)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15755,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,7)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15754,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,8)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15753,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,9)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15752,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,10)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15751,axiom,
    ! [VarCurr: state_type] :
      ( v30887(VarCurr,11)
    <=> v30888(VarCurr) ) ).

tff(addAssignment_15750,axiom,
    ! [VarCurr: state_type] :
      ( v30888(VarCurr)
    <=> v30414(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30879(VarCurr,B)
      <=> ( v30880(VarCurr,B)
          | v30883(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30883(VarCurr,B)
      <=> ( v30132(VarCurr,B)
          & v30884(VarCurr,B) ) ) ) ).

tff(addAssignment_15749,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,0)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15748,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,1)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15747,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,2)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15746,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,3)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15745,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,4)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15744,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,5)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15743,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,6)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15742,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,7)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15741,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,8)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15740,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,9)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15739,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,10)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15738,axiom,
    ! [VarCurr: state_type] :
      ( v30884(VarCurr,11)
    <=> v30885(VarCurr) ) ).

tff(addAssignment_15737,axiom,
    ! [VarCurr: state_type] :
      ( v30885(VarCurr)
    <=> v30263(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30880(VarCurr,B)
      <=> ( v29661(VarCurr,B)
          & v30881(VarCurr,B) ) ) ) ).

tff(addAssignment_15736,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,0)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15735,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,1)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15734,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,2)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15733,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,3)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15732,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,4)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15731,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,5)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15730,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,6)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15729,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,7)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15728,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,8)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15727,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,9)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15726,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,10)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15725,axiom,
    ! [VarCurr: state_type] :
      ( v30881(VarCurr,11)
    <=> v30882(VarCurr) ) ).

tff(addAssignment_15724,axiom,
    ! [VarCurr: state_type] :
      ( v30882(VarCurr)
    <=> v29840(VarCurr) ) ).

tff(addAssignment_15723,axiom,
    ! [VarCurr: state_type] :
      ( v30866(VarCurr)
    <=> v30868(VarCurr) ) ).

tff(addAssignment_15722,axiom,
    ! [VarCurr: state_type] :
      ( v30868(VarCurr)
    <=> v30870(VarCurr) ) ).

tff(addAssignment_15721,axiom,
    ! [VarCurr: state_type] :
      ( v30870(VarCurr)
    <=> v30872(VarCurr) ) ).

tff(addAssignment_15720,axiom,
    ! [VarCurr: state_type] :
      ( v30872(VarCurr)
    <=> v30874(VarCurr) ) ).

tff(addAssignment_15719,axiom,
    ! [VarCurr: state_type] :
      ( v30874(VarCurr)
    <=> v29933(VarCurr) ) ).

tff(addAssignment_15718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30747(VarCurr,B)
      <=> v30749(VarCurr,B) ) ) ).

tff(addAssignment_15717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30749(VarCurr,B)
      <=> v30751(VarCurr,B) ) ) ).

tff(addAssignment_15716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30751(VarCurr,B)
      <=> v30753(VarCurr,B) ) ) ).

tff(addAssignment_15715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30753(VarCurr,B)
      <=> v30755(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_349,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30849(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v30755(VarNext,B)
            <=> v30755(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_349,axiom,
    ! [VarNext: state_type] :
      ( v30849(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30755(VarNext,B)
          <=> v30859(VarNext,B) ) ) ) ).

tff(addAssignment_15714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30859(VarNext,B)
          <=> v30857(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30857(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_206,axiom,
    ! [VarCurr: state_type] :
      ( v30860(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30857(VarCurr,B)
          <=> v30777(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2534,axiom,
    ! [VarCurr: state_type] :
      ( v30860(VarCurr)
    <=> ( v30861(VarCurr)
        & v30862(VarCurr) ) ) ).

tff(writeUnaryOperator_1648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30862(VarCurr)
    <=> v30767(VarCurr) ) ).

tff(writeUnaryOperator_1647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30861(VarCurr)
    <=> v30757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30849(VarNext)
      <=> v30850(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30850(VarNext)
      <=> ( v30851(VarNext)
          & v30781(VarNext) ) ) ) ).

tff(writeUnaryOperator_1646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30851(VarNext)
      <=> v30853(VarNext) ) ) ).

tff(addAssignment_15713,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30853(VarNext)
      <=> v30781(VarCurr) ) ) ).

tff(addAssignment_15712,axiom,
    ! [VarCurr: state_type] :
      ( v30781(VarCurr)
    <=> v30783(VarCurr) ) ).

tff(addAssignment_15711,axiom,
    ! [VarCurr: state_type] :
      ( v30783(VarCurr)
    <=> v30785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2531,axiom,
    ! [VarCurr: state_type] :
      ( v30785(VarCurr)
    <=> ( v30846(VarCurr)
        | v30842(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2530,axiom,
    ! [VarCurr: state_type] :
      ( v30846(VarCurr)
    <=> ( v30787(VarCurr)
        & v30791(VarCurr) ) ) ).

tff(addAssignment_15710,axiom,
    ! [VarCurr: state_type] :
      ( v30842(VarCurr)
    <=> v30844(VarCurr) ) ).

tff(addAssignment_15709,axiom,
    ! [VarCurr: state_type] :
      ( v30844(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30826(VarNext)
       => ( v30791(VarNext)
        <=> v30791(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_348,axiom,
    ! [VarNext: state_type] :
      ( v30826(VarNext)
     => ( v30791(VarNext)
      <=> v30836(VarNext) ) ) ).

tff(addAssignment_15708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30836(VarNext)
      <=> v30834(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2529,axiom,
    ! [VarCurr: state_type] :
      ( v30834(VarCurr)
    <=> ( v30837(VarCurr)
        & v30838(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2528,axiom,
    ! [VarCurr: state_type] :
      ( v30838(VarCurr)
    <=> ( v30797(VarCurr)
        | v30821(VarCurr) ) ) ).

tff(writeUnaryOperator_1645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30837(VarCurr)
    <=> v30793(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30826(VarNext)
      <=> v30827(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30827(VarNext)
      <=> ( v30829(VarNext)
          & v30831(VarNext) ) ) ) ).

tff(writeUnaryOperator_1644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30831(VarCurr)
    <=> v30787(VarCurr) ) ).

tff(addAssignment_15707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30829(VarNext)
      <=> v30787(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_135,axiom,
    ( v30791(constB0)
  <=> $true ) ).

tff(addAssignment_15706,axiom,
    ! [VarCurr: state_type] :
      ( v30821(VarCurr)
    <=> v30823(VarCurr) ) ).

tff(addAssignment_15705,axiom,
    ! [VarCurr: state_type] :
      ( v30823(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15704,axiom,
    ! [VarCurr: state_type] :
      ( v30797(VarCurr)
    <=> v30799(VarCurr) ) ).

tff(addAssignment_15703,axiom,
    ! [VarCurr: state_type] :
      ( v30799(VarCurr)
    <=> v30107(VarCurr) ) ).

tff(addAssignment_15702,axiom,
    ! [VarCurr: state_type] :
      ( v30107(VarCurr)
    <=> v30802(VarCurr) ) ).

tff(addAssignment_15701,axiom,
    ! [VarCurr: state_type] :
      ( v30802(VarCurr)
    <=> v30804(VarCurr) ) ).

tff(writeUnaryOperator_1643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30804(VarCurr)
    <=> v30818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2525,axiom,
    ! [VarCurr: state_type] :
      ( v30818(VarCurr)
    <=> ( v30819(VarCurr)
        | v30814(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2524,axiom,
    ! [VarCurr: state_type] :
      ( v30819(VarCurr)
    <=> ( v30806(VarCurr)
        | v30810(VarCurr) ) ) ).

tff(addAssignment_15700,axiom,
    ! [VarCurr: state_type] :
      ( v30814(VarCurr)
    <=> v30816(VarCurr) ) ).

tff(addAssignment_15699,axiom,
    ! [VarCurr: state_type] :
      ( v30816(VarCurr)
    <=> v30196(VarCurr,2) ) ).

tff(addAssignment_15698,axiom,
    ! [VarCurr: state_type] :
      ( v30810(VarCurr)
    <=> v30812(VarCurr) ) ).

tff(addAssignment_15697,axiom,
    ! [VarCurr: state_type] :
      ( v30812(VarCurr)
    <=> v29770(VarCurr,1) ) ).

tff(addAssignment_15696,axiom,
    ! [VarCurr: state_type] :
      ( v30806(VarCurr)
    <=> v30808(VarCurr) ) ).

tff(addAssignment_15695,axiom,
    ! [VarCurr: state_type] :
      ( v30808(VarCurr)
    <=> v30196(VarCurr,0) ) ).

tff(addAssignment_15694,axiom,
    ! [VarCurr: state_type] :
      ( v30793(VarCurr)
    <=> v30795(VarCurr) ) ).

tff(addAssignment_15693,axiom,
    ! [VarCurr: state_type] :
      ( v30795(VarCurr)
    <=> $false ) ).

tff(addAssignment_15692,axiom,
    ! [VarCurr: state_type] :
      ( v30787(VarCurr)
    <=> v30789(VarCurr) ) ).

tff(addAssignment_15691,axiom,
    ! [VarCurr: state_type] :
      ( v30789(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15690,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30777(VarCurr,B)
      <=> v30779(VarCurr,B) ) ) ).

tff(addAssignment_15689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30779(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15688,axiom,
    ! [VarCurr: state_type] :
      ( v30767(VarCurr)
    <=> v30769(VarCurr) ) ).

tff(addAssignment_15687,axiom,
    ! [VarCurr: state_type] :
      ( v30769(VarCurr)
    <=> v30771(VarCurr) ) ).

tff(addAssignment_15686,axiom,
    ! [VarCurr: state_type] :
      ( v30771(VarCurr)
    <=> v30773(VarCurr) ) ).

tff(addAssignment_15685,axiom,
    ! [VarCurr: state_type] :
      ( v30773(VarCurr)
    <=> v30775(VarCurr) ) ).

tff(addAssignment_15684,axiom,
    ! [VarCurr: state_type] :
      ( v30775(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15683,axiom,
    ! [VarCurr: state_type] :
      ( v30757(VarCurr)
    <=> v30759(VarCurr) ) ).

tff(addAssignment_15682,axiom,
    ! [VarCurr: state_type] :
      ( v30759(VarCurr)
    <=> v30761(VarCurr) ) ).

tff(addAssignment_15681,axiom,
    ! [VarCurr: state_type] :
      ( v30761(VarCurr)
    <=> v30763(VarCurr) ) ).

tff(addAssignment_15680,axiom,
    ! [VarCurr: state_type] :
      ( v30763(VarCurr)
    <=> v30765(VarCurr) ) ).

tff(addAssignment_15679,axiom,
    ! [VarCurr: state_type] :
      ( v30765(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15678,axiom,
    ! [VarCurr: state_type] :
      ( v30716(VarCurr)
    <=> v30718(VarCurr) ) ).

tff(addAssignment_15677,axiom,
    ! [VarCurr: state_type] :
      ( v30718(VarCurr)
    <=> v30720(VarCurr) ) ).

tff(addAssignment_15676,axiom,
    ! [VarCurr: state_type] :
      ( v30720(VarCurr)
    <=> v30722(VarCurr) ) ).

tff(addAssignment_15675,axiom,
    ! [VarCurr: state_type] :
      ( v30722(VarCurr)
    <=> v30724(VarCurr) ) ).

tff(addAssignment_15674,axiom,
    ! [VarCurr: state_type] :
      ( v30724(VarCurr)
    <=> v30726(VarCurr) ) ).

tff(addAssignment_15673,axiom,
    ! [VarCurr: state_type] :
      ( v30726(VarCurr)
    <=> v30728(VarCurr) ) ).

tff(addAssignment_15672,axiom,
    ! [VarCurr: state_type] :
      ( v30728(VarCurr)
    <=> v30730(VarCurr) ) ).

tff(writeUnaryOperator_1642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30730(VarCurr)
    <=> v30744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2523,axiom,
    ! [VarCurr: state_type] :
      ( v30744(VarCurr)
    <=> ( v30745(VarCurr)
        | v30740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2522,axiom,
    ! [VarCurr: state_type] :
      ( v30745(VarCurr)
    <=> ( v30732(VarCurr)
        | v30736(VarCurr) ) ) ).

tff(addAssignment_15671,axiom,
    ! [VarCurr: state_type] :
      ( v30740(VarCurr)
    <=> v30742(VarCurr) ) ).

tff(addAssignment_15670,axiom,
    ! [VarCurr: state_type] :
      ( v30742(VarCurr)
    <=> v29943(VarCurr,2) ) ).

tff(addAssignment_15669,axiom,
    ! [VarCurr: state_type] :
      ( v30736(VarCurr)
    <=> v30738(VarCurr) ) ).

tff(addAssignment_15668,axiom,
    ! [VarCurr: state_type] :
      ( v30738(VarCurr)
    <=> v29860(VarCurr,1) ) ).

tff(addAssignment_15667,axiom,
    ! [VarCurr: state_type] :
      ( v30732(VarCurr)
    <=> v30734(VarCurr) ) ).

tff(addAssignment_15666,axiom,
    ! [VarCurr: state_type] :
      ( v30734(VarCurr)
    <=> v29860(VarCurr,0) ) ).

tff(addAssignment_15665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30596(VarCurr,B)
      <=> v30598(VarCurr,B) ) ) ).

tff(addAssignment_15664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30598(VarCurr,B)
      <=> v30600(VarCurr,B) ) ) ).

tff(addAssignment_15663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30600(VarCurr,B)
      <=> v30602(VarCurr,B) ) ) ).

tff(addAssignment_15662,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30602(VarCurr,B)
      <=> v30604(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30699(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v30604(VarNext,B)
            <=> v30604(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_347,axiom,
    ! [VarNext: state_type] :
      ( v30699(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30604(VarNext,B)
          <=> v30709(VarNext,B) ) ) ) ).

tff(addAssignment_15661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30709(VarNext,B)
          <=> v30707(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30707(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_205,axiom,
    ! [VarCurr: state_type] :
      ( v30710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30707(VarCurr,B)
          <=> v30626(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2521,axiom,
    ! [VarCurr: state_type] :
      ( v30710(VarCurr)
    <=> ( v30711(VarCurr)
        & v30712(VarCurr) ) ) ).

tff(writeUnaryOperator_1641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30712(VarCurr)
    <=> v30616(VarCurr) ) ).

tff(writeUnaryOperator_1640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30711(VarCurr)
    <=> v30606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30699(VarNext)
      <=> v30700(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30700(VarNext)
      <=> ( v30701(VarNext)
          & v30630(VarNext) ) ) ) ).

tff(writeUnaryOperator_1639,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30701(VarNext)
      <=> v30703(VarNext) ) ) ).

tff(addAssignment_15660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30703(VarNext)
      <=> v30630(VarCurr) ) ) ).

tff(addAssignment_15659,axiom,
    ! [VarCurr: state_type] :
      ( v30630(VarCurr)
    <=> v30632(VarCurr) ) ).

tff(addAssignment_15658,axiom,
    ! [VarCurr: state_type] :
      ( v30632(VarCurr)
    <=> v30634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2518,axiom,
    ! [VarCurr: state_type] :
      ( v30634(VarCurr)
    <=> ( v30696(VarCurr)
        | v30692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2517,axiom,
    ! [VarCurr: state_type] :
      ( v30696(VarCurr)
    <=> ( v30636(VarCurr)
        & v30640(VarCurr) ) ) ).

tff(addAssignment_15657,axiom,
    ! [VarCurr: state_type] :
      ( v30692(VarCurr)
    <=> v30694(VarCurr) ) ).

tff(addAssignment_15656,axiom,
    ! [VarCurr: state_type] :
      ( v30694(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30676(VarNext)
       => ( v30640(VarNext)
        <=> v30640(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_346,axiom,
    ! [VarNext: state_type] :
      ( v30676(VarNext)
     => ( v30640(VarNext)
      <=> v30686(VarNext) ) ) ).

tff(addAssignment_15655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30686(VarNext)
      <=> v30684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2516,axiom,
    ! [VarCurr: state_type] :
      ( v30684(VarCurr)
    <=> ( v30687(VarCurr)
        & v30688(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2515,axiom,
    ! [VarCurr: state_type] :
      ( v30688(VarCurr)
    <=> ( v30646(VarCurr)
        | v30671(VarCurr) ) ) ).

tff(writeUnaryOperator_1638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30687(VarCurr)
    <=> v30642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30676(VarNext)
      <=> v30677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30677(VarNext)
      <=> ( v30679(VarNext)
          & v30681(VarNext) ) ) ) ).

tff(writeUnaryOperator_1637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30681(VarCurr)
    <=> v30636(VarCurr) ) ).

tff(addAssignment_15654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30679(VarNext)
      <=> v30636(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_134,axiom,
    ( v30640(constB0)
  <=> $true ) ).

tff(addAssignment_15653,axiom,
    ! [VarCurr: state_type] :
      ( v30671(VarCurr)
    <=> v30673(VarCurr) ) ).

tff(addAssignment_15652,axiom,
    ! [VarCurr: state_type] :
      ( v30673(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15651,axiom,
    ! [VarCurr: state_type] :
      ( v30646(VarCurr)
    <=> v30648(VarCurr) ) ).

tff(addAssignment_15650,axiom,
    ! [VarCurr: state_type] :
      ( v30648(VarCurr)
    <=> v30650(VarCurr) ) ).

tff(addAssignment_15649,axiom,
    ! [VarCurr: state_type] :
      ( v30650(VarCurr)
    <=> v30652(VarCurr) ) ).

tff(addAssignment_15648,axiom,
    ! [VarCurr: state_type] :
      ( v30652(VarCurr)
    <=> v30654(VarCurr) ) ).

tff(writeUnaryOperator_1636,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30654(VarCurr)
    <=> v30668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2512,axiom,
    ! [VarCurr: state_type] :
      ( v30668(VarCurr)
    <=> ( v30669(VarCurr)
        | v30664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2511,axiom,
    ! [VarCurr: state_type] :
      ( v30669(VarCurr)
    <=> ( v30656(VarCurr)
        | v30660(VarCurr) ) ) ).

tff(addAssignment_15647,axiom,
    ! [VarCurr: state_type] :
      ( v30664(VarCurr)
    <=> v30666(VarCurr) ) ).

tff(addAssignment_15646,axiom,
    ! [VarCurr: state_type] :
      ( v30666(VarCurr)
    <=> v30196(VarCurr,2) ) ).

tff(addAssignment_15645,axiom,
    ! [VarCurr: state_type] :
      ( v30196(VarCurr,2)
    <=> v30198(VarCurr,2) ) ).

tff(addAssignment_15644,axiom,
    ! [VarCurr: state_type] :
      ( v30198(VarCurr,2)
    <=> v30200(VarCurr,2) ) ).

tff(addAssignment_15643,axiom,
    ! [VarCurr: state_type] :
      ( v30200(VarCurr,2)
    <=> v30205(VarCurr,2) ) ).

tff(addAssignment_15642,axiom,
    ! [VarCurr: state_type] :
      ( v30202(VarCurr,2)
    <=> v30204(VarCurr,2) ) ).

tff(addAssignment_15641,axiom,
    ! [VarCurr: state_type] :
      ( v30204(VarCurr,2)
    <=> v29770(VarCurr,2) ) ).

tff(addAssignment_15640,axiom,
    ! [VarCurr: state_type] :
      ( v30660(VarCurr)
    <=> v30662(VarCurr) ) ).

tff(addAssignment_15639,axiom,
    ! [VarCurr: state_type] :
      ( v30662(VarCurr)
    <=> v29770(VarCurr,1) ) ).

tff(addAssignment_15638,axiom,
    ! [VarCurr: state_type] :
      ( v30656(VarCurr)
    <=> v30658(VarCurr) ) ).

tff(addAssignment_15637,axiom,
    ! [VarCurr: state_type] :
      ( v30658(VarCurr)
    <=> v29770(VarCurr,0) ) ).

tff(addAssignment_15636,axiom,
    ! [VarCurr: state_type] :
      ( v30642(VarCurr)
    <=> v30644(VarCurr) ) ).

tff(addAssignment_15635,axiom,
    ! [VarCurr: state_type] :
      ( v30644(VarCurr)
    <=> $false ) ).

tff(addAssignment_15634,axiom,
    ! [VarCurr: state_type] :
      ( v30636(VarCurr)
    <=> v30638(VarCurr) ) ).

tff(addAssignment_15633,axiom,
    ! [VarCurr: state_type] :
      ( v30638(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30626(VarCurr,B)
      <=> v30628(VarCurr,B) ) ) ).

tff(addAssignment_15631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30628(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15630,axiom,
    ! [VarCurr: state_type] :
      ( v30616(VarCurr)
    <=> v30618(VarCurr) ) ).

tff(addAssignment_15629,axiom,
    ! [VarCurr: state_type] :
      ( v30618(VarCurr)
    <=> v30620(VarCurr) ) ).

tff(addAssignment_15628,axiom,
    ! [VarCurr: state_type] :
      ( v30620(VarCurr)
    <=> v30622(VarCurr) ) ).

tff(addAssignment_15627,axiom,
    ! [VarCurr: state_type] :
      ( v30622(VarCurr)
    <=> v30624(VarCurr) ) ).

tff(addAssignment_15626,axiom,
    ! [VarCurr: state_type] :
      ( v30624(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15625,axiom,
    ! [VarCurr: state_type] :
      ( v30606(VarCurr)
    <=> v30608(VarCurr) ) ).

tff(addAssignment_15624,axiom,
    ! [VarCurr: state_type] :
      ( v30608(VarCurr)
    <=> v30610(VarCurr) ) ).

tff(addAssignment_15623,axiom,
    ! [VarCurr: state_type] :
      ( v30610(VarCurr)
    <=> v30612(VarCurr) ) ).

tff(addAssignment_15622,axiom,
    ! [VarCurr: state_type] :
      ( v30612(VarCurr)
    <=> v30614(VarCurr) ) ).

tff(addAssignment_15621,axiom,
    ! [VarCurr: state_type] :
      ( v30614(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15620,axiom,
    ! [VarCurr: state_type] :
      ( v30565(VarCurr)
    <=> v30567(VarCurr) ) ).

tff(addAssignment_15619,axiom,
    ! [VarCurr: state_type] :
      ( v30567(VarCurr)
    <=> v30569(VarCurr) ) ).

tff(addAssignment_15618,axiom,
    ! [VarCurr: state_type] :
      ( v30569(VarCurr)
    <=> v30571(VarCurr) ) ).

tff(addAssignment_15617,axiom,
    ! [VarCurr: state_type] :
      ( v30571(VarCurr)
    <=> v30573(VarCurr) ) ).

tff(addAssignment_15616,axiom,
    ! [VarCurr: state_type] :
      ( v30573(VarCurr)
    <=> v30575(VarCurr) ) ).

tff(addAssignment_15615,axiom,
    ! [VarCurr: state_type] :
      ( v30575(VarCurr)
    <=> v30577(VarCurr) ) ).

tff(addAssignment_15614,axiom,
    ! [VarCurr: state_type] :
      ( v30577(VarCurr)
    <=> v30579(VarCurr) ) ).

tff(writeUnaryOperator_1635,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30579(VarCurr)
    <=> v30593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2510,axiom,
    ! [VarCurr: state_type] :
      ( v30593(VarCurr)
    <=> ( v30594(VarCurr)
        | v30589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2509,axiom,
    ! [VarCurr: state_type] :
      ( v30594(VarCurr)
    <=> ( v30581(VarCurr)
        | v30585(VarCurr) ) ) ).

tff(addAssignment_15613,axiom,
    ! [VarCurr: state_type] :
      ( v30589(VarCurr)
    <=> v30591(VarCurr) ) ).

tff(addAssignment_15612,axiom,
    ! [VarCurr: state_type] :
      ( v30591(VarCurr)
    <=> v29860(VarCurr,2) ) ).

tff(addAssignment_15611,axiom,
    ! [VarCurr: state_type] :
      ( v30585(VarCurr)
    <=> v30587(VarCurr) ) ).

tff(addAssignment_15610,axiom,
    ! [VarCurr: state_type] :
      ( v30587(VarCurr)
    <=> v29943(VarCurr,1) ) ).

tff(addAssignment_15609,axiom,
    ! [VarCurr: state_type] :
      ( v30581(VarCurr)
    <=> v30583(VarCurr) ) ).

tff(addAssignment_15608,axiom,
    ! [VarCurr: state_type] :
      ( v30583(VarCurr)
    <=> v29943(VarCurr,0) ) ).

tff(addAssignment_15607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30445(VarCurr,B)
      <=> v30447(VarCurr,B) ) ) ).

tff(addAssignment_15606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30447(VarCurr,B)
      <=> v30449(VarCurr,B) ) ) ).

tff(addAssignment_15605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30449(VarCurr,B)
      <=> v30451(VarCurr,B) ) ) ).

tff(addAssignment_15604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30451(VarCurr,B)
      <=> v30453(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30548(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v30453(VarNext,B)
            <=> v30453(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_345,axiom,
    ! [VarNext: state_type] :
      ( v30548(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30453(VarNext,B)
          <=> v30558(VarNext,B) ) ) ) ).

tff(addAssignment_15603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30558(VarNext,B)
          <=> v30556(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30559(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30556(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_204,axiom,
    ! [VarCurr: state_type] :
      ( v30559(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30556(VarCurr,B)
          <=> v30475(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2508,axiom,
    ! [VarCurr: state_type] :
      ( v30559(VarCurr)
    <=> ( v30560(VarCurr)
        & v30561(VarCurr) ) ) ).

tff(writeUnaryOperator_1634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30561(VarCurr)
    <=> v30465(VarCurr) ) ).

tff(writeUnaryOperator_1633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30560(VarCurr)
    <=> v30455(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2507,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30548(VarNext)
      <=> v30549(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30549(VarNext)
      <=> ( v30550(VarNext)
          & v30479(VarNext) ) ) ) ).

tff(writeUnaryOperator_1632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30550(VarNext)
      <=> v30552(VarNext) ) ) ).

tff(addAssignment_15602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30552(VarNext)
      <=> v30479(VarCurr) ) ) ).

tff(addAssignment_15601,axiom,
    ! [VarCurr: state_type] :
      ( v30479(VarCurr)
    <=> v30481(VarCurr) ) ).

tff(addAssignment_15600,axiom,
    ! [VarCurr: state_type] :
      ( v30481(VarCurr)
    <=> v30483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2505,axiom,
    ! [VarCurr: state_type] :
      ( v30483(VarCurr)
    <=> ( v30545(VarCurr)
        | v30541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2504,axiom,
    ! [VarCurr: state_type] :
      ( v30545(VarCurr)
    <=> ( v30485(VarCurr)
        & v30489(VarCurr) ) ) ).

tff(addAssignment_15599,axiom,
    ! [VarCurr: state_type] :
      ( v30541(VarCurr)
    <=> v30543(VarCurr) ) ).

tff(addAssignment_15598,axiom,
    ! [VarCurr: state_type] :
      ( v30543(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30525(VarNext)
       => ( v30489(VarNext)
        <=> v30489(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_344,axiom,
    ! [VarNext: state_type] :
      ( v30525(VarNext)
     => ( v30489(VarNext)
      <=> v30535(VarNext) ) ) ).

tff(addAssignment_15597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30535(VarNext)
      <=> v30533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2503,axiom,
    ! [VarCurr: state_type] :
      ( v30533(VarCurr)
    <=> ( v30536(VarCurr)
        & v30537(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2502,axiom,
    ! [VarCurr: state_type] :
      ( v30537(VarCurr)
    <=> ( v30495(VarCurr)
        | v30520(VarCurr) ) ) ).

tff(writeUnaryOperator_1631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30536(VarCurr)
    <=> v30491(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30525(VarNext)
      <=> v30526(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30526(VarNext)
      <=> ( v30528(VarNext)
          & v30530(VarNext) ) ) ) ).

tff(writeUnaryOperator_1630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30530(VarCurr)
    <=> v30485(VarCurr) ) ).

tff(addAssignment_15596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30528(VarNext)
      <=> v30485(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_133,axiom,
    ( v30489(constB0)
  <=> $true ) ).

tff(addAssignment_15595,axiom,
    ! [VarCurr: state_type] :
      ( v30520(VarCurr)
    <=> v30522(VarCurr) ) ).

tff(addAssignment_15594,axiom,
    ! [VarCurr: state_type] :
      ( v30522(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15593,axiom,
    ! [VarCurr: state_type] :
      ( v30495(VarCurr)
    <=> v30497(VarCurr) ) ).

tff(addAssignment_15592,axiom,
    ! [VarCurr: state_type] :
      ( v30497(VarCurr)
    <=> v30499(VarCurr) ) ).

tff(addAssignment_15591,axiom,
    ! [VarCurr: state_type] :
      ( v30499(VarCurr)
    <=> v30501(VarCurr) ) ).

tff(addAssignment_15590,axiom,
    ! [VarCurr: state_type] :
      ( v30501(VarCurr)
    <=> v30503(VarCurr) ) ).

tff(writeUnaryOperator_1629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30503(VarCurr)
    <=> v30517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2499,axiom,
    ! [VarCurr: state_type] :
      ( v30517(VarCurr)
    <=> ( v30518(VarCurr)
        | v30513(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2498,axiom,
    ! [VarCurr: state_type] :
      ( v30518(VarCurr)
    <=> ( v30505(VarCurr)
        | v30509(VarCurr) ) ) ).

tff(addAssignment_15589,axiom,
    ! [VarCurr: state_type] :
      ( v30513(VarCurr)
    <=> v30515(VarCurr) ) ).

tff(addAssignment_15588,axiom,
    ! [VarCurr: state_type] :
      ( v30515(VarCurr)
    <=> v29770(VarCurr,2) ) ).

tff(addAssignment_15587,axiom,
    ! [VarCurr: state_type] :
      ( v30509(VarCurr)
    <=> v30511(VarCurr) ) ).

tff(addAssignment_15586,axiom,
    ! [VarCurr: state_type] :
      ( v30511(VarCurr)
    <=> v30196(VarCurr,1) ) ).

tff(addAssignment_15585,axiom,
    ! [VarCurr: state_type] :
      ( v30505(VarCurr)
    <=> v30507(VarCurr) ) ).

tff(addAssignment_15584,axiom,
    ! [VarCurr: state_type] :
      ( v30507(VarCurr)
    <=> v30196(VarCurr,0) ) ).

tff(addAssignment_15583,axiom,
    ! [VarCurr: state_type] :
      ( v30491(VarCurr)
    <=> v30493(VarCurr) ) ).

tff(addAssignment_15582,axiom,
    ! [VarCurr: state_type] :
      ( v30493(VarCurr)
    <=> $false ) ).

tff(addAssignment_15581,axiom,
    ! [VarCurr: state_type] :
      ( v30485(VarCurr)
    <=> v30487(VarCurr) ) ).

tff(addAssignment_15580,axiom,
    ! [VarCurr: state_type] :
      ( v30487(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30475(VarCurr,B)
      <=> v30477(VarCurr,B) ) ) ).

tff(addAssignment_15578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30477(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15577,axiom,
    ! [VarCurr: state_type] :
      ( v30465(VarCurr)
    <=> v30467(VarCurr) ) ).

tff(addAssignment_15576,axiom,
    ! [VarCurr: state_type] :
      ( v30467(VarCurr)
    <=> v30469(VarCurr) ) ).

tff(addAssignment_15575,axiom,
    ! [VarCurr: state_type] :
      ( v30469(VarCurr)
    <=> v30471(VarCurr) ) ).

tff(addAssignment_15574,axiom,
    ! [VarCurr: state_type] :
      ( v30471(VarCurr)
    <=> v30473(VarCurr) ) ).

tff(addAssignment_15573,axiom,
    ! [VarCurr: state_type] :
      ( v30473(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15572,axiom,
    ! [VarCurr: state_type] :
      ( v30455(VarCurr)
    <=> v30457(VarCurr) ) ).

tff(addAssignment_15571,axiom,
    ! [VarCurr: state_type] :
      ( v30457(VarCurr)
    <=> v30459(VarCurr) ) ).

tff(addAssignment_15570,axiom,
    ! [VarCurr: state_type] :
      ( v30459(VarCurr)
    <=> v30461(VarCurr) ) ).

tff(addAssignment_15569,axiom,
    ! [VarCurr: state_type] :
      ( v30461(VarCurr)
    <=> v30463(VarCurr) ) ).

tff(addAssignment_15568,axiom,
    ! [VarCurr: state_type] :
      ( v30463(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15567,axiom,
    ! [VarCurr: state_type] :
      ( v30414(VarCurr)
    <=> v30416(VarCurr) ) ).

tff(addAssignment_15566,axiom,
    ! [VarCurr: state_type] :
      ( v30416(VarCurr)
    <=> v30418(VarCurr) ) ).

tff(addAssignment_15565,axiom,
    ! [VarCurr: state_type] :
      ( v30418(VarCurr)
    <=> v30420(VarCurr) ) ).

tff(addAssignment_15564,axiom,
    ! [VarCurr: state_type] :
      ( v30420(VarCurr)
    <=> v30422(VarCurr) ) ).

tff(addAssignment_15563,axiom,
    ! [VarCurr: state_type] :
      ( v30422(VarCurr)
    <=> v30424(VarCurr) ) ).

tff(addAssignment_15562,axiom,
    ! [VarCurr: state_type] :
      ( v30424(VarCurr)
    <=> v30426(VarCurr) ) ).

tff(addAssignment_15561,axiom,
    ! [VarCurr: state_type] :
      ( v30426(VarCurr)
    <=> v30428(VarCurr) ) ).

tff(writeUnaryOperator_1628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30428(VarCurr)
    <=> v30442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2497,axiom,
    ! [VarCurr: state_type] :
      ( v30442(VarCurr)
    <=> ( v30443(VarCurr)
        | v30438(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2496,axiom,
    ! [VarCurr: state_type] :
      ( v30443(VarCurr)
    <=> ( v30430(VarCurr)
        | v30434(VarCurr) ) ) ).

tff(addAssignment_15560,axiom,
    ! [VarCurr: state_type] :
      ( v30438(VarCurr)
    <=> v30440(VarCurr) ) ).

tff(addAssignment_15559,axiom,
    ! [VarCurr: state_type] :
      ( v30440(VarCurr)
    <=> v29860(VarCurr,2) ) ).

tff(addAssignment_15558,axiom,
    ! [VarCurr: state_type] :
      ( v30434(VarCurr)
    <=> v30436(VarCurr) ) ).

tff(addAssignment_15557,axiom,
    ! [VarCurr: state_type] :
      ( v30436(VarCurr)
    <=> v29943(VarCurr,1) ) ).

tff(addAssignment_15556,axiom,
    ! [VarCurr: state_type] :
      ( v29943(VarCurr,1)
    <=> v29945(VarCurr,1) ) ).

tff(addAssignment_15555,axiom,
    ! [VarCurr: state_type] :
      ( v29945(VarCurr,1)
    <=> v29947(VarCurr,1) ) ).

tff(addAssignment_15554,axiom,
    ! [VarCurr: state_type] :
      ( v29947(VarCurr,1)
    <=> v29952(VarCurr,1) ) ).

tff(addAssignment_15553,axiom,
    ! [VarCurr: state_type] :
      ( v29949(VarCurr,1)
    <=> v29951(VarCurr,1) ) ).

tff(addAssignment_15552,axiom,
    ! [VarCurr: state_type] :
      ( v29951(VarCurr,1)
    <=> v29860(VarCurr,1) ) ).

tff(addAssignment_15551,axiom,
    ! [VarCurr: state_type] :
      ( v30430(VarCurr)
    <=> v30432(VarCurr) ) ).

tff(addAssignment_15550,axiom,
    ! [VarCurr: state_type] :
      ( v30432(VarCurr)
    <=> v29860(VarCurr,0) ) ).

tff(addAssignment_15549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30294(VarCurr,B)
      <=> v30296(VarCurr,B) ) ) ).

tff(addAssignment_15548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30296(VarCurr,B)
      <=> v30298(VarCurr,B) ) ) ).

tff(addAssignment_15547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30298(VarCurr,B)
      <=> v30300(VarCurr,B) ) ) ).

tff(addAssignment_15546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30300(VarCurr,B)
      <=> v30302(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_343,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30397(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v30302(VarNext,B)
            <=> v30302(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_343,axiom,
    ! [VarNext: state_type] :
      ( v30397(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30302(VarNext,B)
          <=> v30407(VarNext,B) ) ) ) ).

tff(addAssignment_15545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30407(VarNext,B)
          <=> v30405(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30405(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_203,axiom,
    ! [VarCurr: state_type] :
      ( v30408(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30405(VarCurr,B)
          <=> v30324(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2495,axiom,
    ! [VarCurr: state_type] :
      ( v30408(VarCurr)
    <=> ( v30409(VarCurr)
        & v30410(VarCurr) ) ) ).

tff(writeUnaryOperator_1627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30410(VarCurr)
    <=> v30314(VarCurr) ) ).

tff(writeUnaryOperator_1626,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30409(VarCurr)
    <=> v30304(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30397(VarNext)
      <=> v30398(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30398(VarNext)
      <=> ( v30399(VarNext)
          & v30328(VarNext) ) ) ) ).

tff(writeUnaryOperator_1625,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30399(VarNext)
      <=> v30401(VarNext) ) ) ).

tff(addAssignment_15544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30401(VarNext)
      <=> v30328(VarCurr) ) ) ).

tff(addAssignment_15543,axiom,
    ! [VarCurr: state_type] :
      ( v30328(VarCurr)
    <=> v30330(VarCurr) ) ).

tff(addAssignment_15542,axiom,
    ! [VarCurr: state_type] :
      ( v30330(VarCurr)
    <=> v30332(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2492,axiom,
    ! [VarCurr: state_type] :
      ( v30332(VarCurr)
    <=> ( v30394(VarCurr)
        | v30390(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2491,axiom,
    ! [VarCurr: state_type] :
      ( v30394(VarCurr)
    <=> ( v30334(VarCurr)
        & v30338(VarCurr) ) ) ).

tff(addAssignment_15541,axiom,
    ! [VarCurr: state_type] :
      ( v30390(VarCurr)
    <=> v30392(VarCurr) ) ).

tff(addAssignment_15540,axiom,
    ! [VarCurr: state_type] :
      ( v30392(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30374(VarNext)
       => ( v30338(VarNext)
        <=> v30338(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_342,axiom,
    ! [VarNext: state_type] :
      ( v30374(VarNext)
     => ( v30338(VarNext)
      <=> v30384(VarNext) ) ) ).

tff(addAssignment_15539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30384(VarNext)
      <=> v30382(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2490,axiom,
    ! [VarCurr: state_type] :
      ( v30382(VarCurr)
    <=> ( v30385(VarCurr)
        & v30386(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2489,axiom,
    ! [VarCurr: state_type] :
      ( v30386(VarCurr)
    <=> ( v30344(VarCurr)
        | v30369(VarCurr) ) ) ).

tff(writeUnaryOperator_1624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30385(VarCurr)
    <=> v30340(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30374(VarNext)
      <=> v30375(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30375(VarNext)
      <=> ( v30377(VarNext)
          & v30379(VarNext) ) ) ) ).

tff(writeUnaryOperator_1623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30379(VarCurr)
    <=> v30334(VarCurr) ) ).

tff(addAssignment_15538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30377(VarNext)
      <=> v30334(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_132,axiom,
    ( v30338(constB0)
  <=> $true ) ).

tff(addAssignment_15537,axiom,
    ! [VarCurr: state_type] :
      ( v30369(VarCurr)
    <=> v30371(VarCurr) ) ).

tff(addAssignment_15536,axiom,
    ! [VarCurr: state_type] :
      ( v30371(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15535,axiom,
    ! [VarCurr: state_type] :
      ( v30344(VarCurr)
    <=> v30346(VarCurr) ) ).

tff(addAssignment_15534,axiom,
    ! [VarCurr: state_type] :
      ( v30346(VarCurr)
    <=> v30348(VarCurr) ) ).

tff(addAssignment_15533,axiom,
    ! [VarCurr: state_type] :
      ( v30348(VarCurr)
    <=> v30350(VarCurr) ) ).

tff(addAssignment_15532,axiom,
    ! [VarCurr: state_type] :
      ( v30350(VarCurr)
    <=> v30352(VarCurr) ) ).

tff(writeUnaryOperator_1622,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30352(VarCurr)
    <=> v30366(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2486,axiom,
    ! [VarCurr: state_type] :
      ( v30366(VarCurr)
    <=> ( v30367(VarCurr)
        | v30362(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2485,axiom,
    ! [VarCurr: state_type] :
      ( v30367(VarCurr)
    <=> ( v30354(VarCurr)
        | v30358(VarCurr) ) ) ).

tff(addAssignment_15531,axiom,
    ! [VarCurr: state_type] :
      ( v30362(VarCurr)
    <=> v30364(VarCurr) ) ).

tff(addAssignment_15530,axiom,
    ! [VarCurr: state_type] :
      ( v30364(VarCurr)
    <=> v29770(VarCurr,2) ) ).

tff(addAssignment_15529,axiom,
    ! [VarCurr: state_type] :
      ( v30358(VarCurr)
    <=> v30360(VarCurr) ) ).

tff(addAssignment_15528,axiom,
    ! [VarCurr: state_type] :
      ( v30360(VarCurr)
    <=> v30196(VarCurr,1) ) ).

tff(addAssignment_15527,axiom,
    ! [VarCurr: state_type] :
      ( v30196(VarCurr,1)
    <=> v30198(VarCurr,1) ) ).

tff(addAssignment_15526,axiom,
    ! [VarCurr: state_type] :
      ( v30198(VarCurr,1)
    <=> v30200(VarCurr,1) ) ).

tff(addAssignment_15525,axiom,
    ! [VarCurr: state_type] :
      ( v30200(VarCurr,1)
    <=> v30205(VarCurr,1) ) ).

tff(addAssignment_15524,axiom,
    ! [VarCurr: state_type] :
      ( v30202(VarCurr,1)
    <=> v30204(VarCurr,1) ) ).

tff(addAssignment_15523,axiom,
    ! [VarCurr: state_type] :
      ( v30204(VarCurr,1)
    <=> v29770(VarCurr,1) ) ).

tff(addAssignment_15522,axiom,
    ! [VarCurr: state_type] :
      ( v30354(VarCurr)
    <=> v30356(VarCurr) ) ).

tff(addAssignment_15521,axiom,
    ! [VarCurr: state_type] :
      ( v30356(VarCurr)
    <=> v29770(VarCurr,0) ) ).

tff(addAssignment_15520,axiom,
    ! [VarCurr: state_type] :
      ( v30340(VarCurr)
    <=> v30342(VarCurr) ) ).

tff(addAssignment_15519,axiom,
    ! [VarCurr: state_type] :
      ( v30342(VarCurr)
    <=> $false ) ).

tff(addAssignment_15518,axiom,
    ! [VarCurr: state_type] :
      ( v30334(VarCurr)
    <=> v30336(VarCurr) ) ).

tff(addAssignment_15517,axiom,
    ! [VarCurr: state_type] :
      ( v30336(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30324(VarCurr,B)
      <=> v30326(VarCurr,B) ) ) ).

tff(addAssignment_15515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30326(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15514,axiom,
    ! [VarCurr: state_type] :
      ( v30314(VarCurr)
    <=> v30316(VarCurr) ) ).

tff(addAssignment_15513,axiom,
    ! [VarCurr: state_type] :
      ( v30316(VarCurr)
    <=> v30318(VarCurr) ) ).

tff(addAssignment_15512,axiom,
    ! [VarCurr: state_type] :
      ( v30318(VarCurr)
    <=> v30320(VarCurr) ) ).

tff(addAssignment_15511,axiom,
    ! [VarCurr: state_type] :
      ( v30320(VarCurr)
    <=> v30322(VarCurr) ) ).

tff(addAssignment_15510,axiom,
    ! [VarCurr: state_type] :
      ( v30322(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15509,axiom,
    ! [VarCurr: state_type] :
      ( v30304(VarCurr)
    <=> v30306(VarCurr) ) ).

tff(addAssignment_15508,axiom,
    ! [VarCurr: state_type] :
      ( v30306(VarCurr)
    <=> v30308(VarCurr) ) ).

tff(addAssignment_15507,axiom,
    ! [VarCurr: state_type] :
      ( v30308(VarCurr)
    <=> v30310(VarCurr) ) ).

tff(addAssignment_15506,axiom,
    ! [VarCurr: state_type] :
      ( v30310(VarCurr)
    <=> v30312(VarCurr) ) ).

tff(addAssignment_15505,axiom,
    ! [VarCurr: state_type] :
      ( v30312(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15504,axiom,
    ! [VarCurr: state_type] :
      ( v30263(VarCurr)
    <=> v30265(VarCurr) ) ).

tff(addAssignment_15503,axiom,
    ! [VarCurr: state_type] :
      ( v30265(VarCurr)
    <=> v30267(VarCurr) ) ).

tff(addAssignment_15502,axiom,
    ! [VarCurr: state_type] :
      ( v30267(VarCurr)
    <=> v30269(VarCurr) ) ).

tff(addAssignment_15501,axiom,
    ! [VarCurr: state_type] :
      ( v30269(VarCurr)
    <=> v30271(VarCurr) ) ).

tff(addAssignment_15500,axiom,
    ! [VarCurr: state_type] :
      ( v30271(VarCurr)
    <=> v30273(VarCurr) ) ).

tff(addAssignment_15499,axiom,
    ! [VarCurr: state_type] :
      ( v30273(VarCurr)
    <=> v30275(VarCurr) ) ).

tff(addAssignment_15498,axiom,
    ! [VarCurr: state_type] :
      ( v30275(VarCurr)
    <=> v30277(VarCurr) ) ).

tff(writeUnaryOperator_1621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30277(VarCurr)
    <=> v30291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2484,axiom,
    ! [VarCurr: state_type] :
      ( v30291(VarCurr)
    <=> ( v30292(VarCurr)
        | v30287(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2483,axiom,
    ! [VarCurr: state_type] :
      ( v30292(VarCurr)
    <=> ( v30279(VarCurr)
        | v30283(VarCurr) ) ) ).

tff(addAssignment_15497,axiom,
    ! [VarCurr: state_type] :
      ( v30287(VarCurr)
    <=> v30289(VarCurr) ) ).

tff(addAssignment_15496,axiom,
    ! [VarCurr: state_type] :
      ( v30289(VarCurr)
    <=> v29860(VarCurr,2) ) ).

tff(addAssignment_15495,axiom,
    ! [VarCurr: state_type] :
      ( v30283(VarCurr)
    <=> v30285(VarCurr) ) ).

tff(addAssignment_15494,axiom,
    ! [VarCurr: state_type] :
      ( v30285(VarCurr)
    <=> v29860(VarCurr,1) ) ).

tff(addAssignment_15493,axiom,
    ! [VarCurr: state_type] :
      ( v30279(VarCurr)
    <=> v30281(VarCurr) ) ).

tff(addAssignment_15492,axiom,
    ! [VarCurr: state_type] :
      ( v30281(VarCurr)
    <=> v29943(VarCurr,0) ) ).

tff(addAssignment_15491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30132(VarCurr,B)
      <=> v30134(VarCurr,B) ) ) ).

tff(addAssignment_15490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30134(VarCurr,B)
      <=> v30136(VarCurr,B) ) ) ).

tff(addAssignment_15489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30136(VarCurr,B)
      <=> v30138(VarCurr,B) ) ) ).

tff(addAssignment_15488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30138(VarCurr,B)
      <=> v30140(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30246(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v30140(VarNext,B)
            <=> v30140(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_341,axiom,
    ! [VarNext: state_type] :
      ( v30246(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30140(VarNext,B)
          <=> v30256(VarNext,B) ) ) ) ).

tff(addAssignment_15487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30256(VarNext,B)
          <=> v30254(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30254(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_202,axiom,
    ! [VarCurr: state_type] :
      ( v30257(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v30254(VarCurr,B)
          <=> v30162(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2482,axiom,
    ! [VarCurr: state_type] :
      ( v30257(VarCurr)
    <=> ( v30258(VarCurr)
        & v30259(VarCurr) ) ) ).

tff(writeUnaryOperator_1620,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30259(VarCurr)
    <=> v30152(VarCurr) ) ).

tff(writeUnaryOperator_1619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30258(VarCurr)
    <=> v30142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30246(VarNext)
      <=> v30247(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30247(VarNext)
      <=> ( v30248(VarNext)
          & v30166(VarNext) ) ) ) ).

tff(writeUnaryOperator_1618,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30248(VarNext)
      <=> v30250(VarNext) ) ) ).

tff(addAssignment_15486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30250(VarNext)
      <=> v30166(VarCurr) ) ) ).

tff(addAssignment_15485,axiom,
    ! [VarCurr: state_type] :
      ( v30166(VarCurr)
    <=> v30168(VarCurr) ) ).

tff(addAssignment_15484,axiom,
    ! [VarCurr: state_type] :
      ( v30168(VarCurr)
    <=> v30170(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2479,axiom,
    ! [VarCurr: state_type] :
      ( v30170(VarCurr)
    <=> ( v30243(VarCurr)
        | v30239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2478,axiom,
    ! [VarCurr: state_type] :
      ( v30243(VarCurr)
    <=> ( v30172(VarCurr)
        & v30176(VarCurr) ) ) ).

tff(addAssignment_15483,axiom,
    ! [VarCurr: state_type] :
      ( v30239(VarCurr)
    <=> v30241(VarCurr) ) ).

tff(addAssignment_15482,axiom,
    ! [VarCurr: state_type] :
      ( v30241(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30223(VarNext)
       => ( v30176(VarNext)
        <=> v30176(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_340,axiom,
    ! [VarNext: state_type] :
      ( v30223(VarNext)
     => ( v30176(VarNext)
      <=> v30233(VarNext) ) ) ).

tff(addAssignment_15481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30233(VarNext)
      <=> v30231(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2477,axiom,
    ! [VarCurr: state_type] :
      ( v30231(VarCurr)
    <=> ( v30234(VarCurr)
        & v30235(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2476,axiom,
    ! [VarCurr: state_type] :
      ( v30235(VarCurr)
    <=> ( v30182(VarCurr)
        | v30218(VarCurr) ) ) ).

tff(writeUnaryOperator_1617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30234(VarCurr)
    <=> v30178(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30223(VarNext)
      <=> v30224(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2474,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30224(VarNext)
      <=> ( v30226(VarNext)
          & v30228(VarNext) ) ) ) ).

tff(writeUnaryOperator_1616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30228(VarCurr)
    <=> v30172(VarCurr) ) ).

tff(addAssignment_15480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30226(VarNext)
      <=> v30172(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_131,axiom,
    ( v30176(constB0)
  <=> $true ) ).

tff(addAssignment_15479,axiom,
    ! [VarCurr: state_type] :
      ( v30218(VarCurr)
    <=> v30220(VarCurr) ) ).

tff(addAssignment_15478,axiom,
    ! [VarCurr: state_type] :
      ( v30220(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15477,axiom,
    ! [VarCurr: state_type] :
      ( v30182(VarCurr)
    <=> v30184(VarCurr) ) ).

tff(addAssignment_15476,axiom,
    ! [VarCurr: state_type] :
      ( v30184(VarCurr)
    <=> v30186(VarCurr) ) ).

tff(addAssignment_15475,axiom,
    ! [VarCurr: state_type] :
      ( v30186(VarCurr)
    <=> v30188(VarCurr) ) ).

tff(addAssignment_15474,axiom,
    ! [VarCurr: state_type] :
      ( v30188(VarCurr)
    <=> v30190(VarCurr) ) ).

tff(writeUnaryOperator_1615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30190(VarCurr)
    <=> v30215(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2473,axiom,
    ! [VarCurr: state_type] :
      ( v30215(VarCurr)
    <=> ( v30216(VarCurr)
        | v30211(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2472,axiom,
    ! [VarCurr: state_type] :
      ( v30216(VarCurr)
    <=> ( v30192(VarCurr)
        | v30207(VarCurr) ) ) ).

tff(addAssignment_15473,axiom,
    ! [VarCurr: state_type] :
      ( v30211(VarCurr)
    <=> v30213(VarCurr) ) ).

tff(addAssignment_15472,axiom,
    ! [VarCurr: state_type] :
      ( v30213(VarCurr)
    <=> v29770(VarCurr,2) ) ).

tff(addAssignment_15471,axiom,
    ! [VarCurr: state_type] :
      ( v30207(VarCurr)
    <=> v30209(VarCurr) ) ).

tff(addAssignment_15470,axiom,
    ! [VarCurr: state_type] :
      ( v30209(VarCurr)
    <=> v29770(VarCurr,1) ) ).

tff(addAssignment_15469,axiom,
    ! [VarCurr: state_type] :
      ( v30192(VarCurr)
    <=> v30194(VarCurr) ) ).

tff(addAssignment_15468,axiom,
    ! [VarCurr: state_type] :
      ( v30194(VarCurr)
    <=> v30196(VarCurr,0) ) ).

tff(addAssignment_15467,axiom,
    ! [VarCurr: state_type] :
      ( v30196(VarCurr,0)
    <=> v30198(VarCurr,0) ) ).

tff(addAssignment_15466,axiom,
    ! [VarCurr: state_type] :
      ( v30198(VarCurr,0)
    <=> v30200(VarCurr,0) ) ).

tff(addAssignment_15465,axiom,
    ! [VarCurr: state_type] :
      ( v30200(VarCurr,0)
    <=> v30205(VarCurr,0) ) ).

tff(writeUnaryOperator_1614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v30205(VarCurr,B)
      <=> ~ v30202(VarCurr,B) ) ) ).

tff(addAssignment_15464,axiom,
    ! [VarCurr: state_type] :
      ( v30202(VarCurr,0)
    <=> v30204(VarCurr,0) ) ).

tff(addAssignment_15463,axiom,
    ! [VarCurr: state_type] :
      ( v30204(VarCurr,0)
    <=> v29770(VarCurr,0) ) ).

tff(addAssignment_15462,axiom,
    ! [VarCurr: state_type] :
      ( v30178(VarCurr)
    <=> v30180(VarCurr) ) ).

tff(addAssignment_15461,axiom,
    ! [VarCurr: state_type] :
      ( v30180(VarCurr)
    <=> $false ) ).

tff(addAssignment_15460,axiom,
    ! [VarCurr: state_type] :
      ( v30172(VarCurr)
    <=> v30174(VarCurr) ) ).

tff(addAssignment_15459,axiom,
    ! [VarCurr: state_type] :
      ( v30174(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30162(VarCurr,B)
      <=> v30164(VarCurr,B) ) ) ).

tff(addAssignment_15457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v30164(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15456,axiom,
    ! [VarCurr: state_type] :
      ( v30152(VarCurr)
    <=> v30154(VarCurr) ) ).

tff(addAssignment_15455,axiom,
    ! [VarCurr: state_type] :
      ( v30154(VarCurr)
    <=> v30156(VarCurr) ) ).

tff(addAssignment_15454,axiom,
    ! [VarCurr: state_type] :
      ( v30156(VarCurr)
    <=> v30158(VarCurr) ) ).

tff(addAssignment_15453,axiom,
    ! [VarCurr: state_type] :
      ( v30158(VarCurr)
    <=> v30160(VarCurr) ) ).

tff(addAssignment_15452,axiom,
    ! [VarCurr: state_type] :
      ( v30160(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15451,axiom,
    ! [VarCurr: state_type] :
      ( v30142(VarCurr)
    <=> v30144(VarCurr) ) ).

tff(addAssignment_15450,axiom,
    ! [VarCurr: state_type] :
      ( v30144(VarCurr)
    <=> v30146(VarCurr) ) ).

tff(addAssignment_15449,axiom,
    ! [VarCurr: state_type] :
      ( v30146(VarCurr)
    <=> v30148(VarCurr) ) ).

tff(addAssignment_15448,axiom,
    ! [VarCurr: state_type] :
      ( v30148(VarCurr)
    <=> v30150(VarCurr) ) ).

tff(addAssignment_15447,axiom,
    ! [VarCurr: state_type] :
      ( v30150(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15446,axiom,
    ! [VarCurr: state_type] :
      ( v29840(VarCurr)
    <=> v29842(VarCurr) ) ).

tff(addAssignment_15445,axiom,
    ! [VarCurr: state_type] :
      ( v29842(VarCurr)
    <=> v29844(VarCurr) ) ).

tff(addAssignment_15444,axiom,
    ! [VarCurr: state_type] :
      ( v29844(VarCurr)
    <=> v29846(VarCurr) ) ).

tff(addAssignment_15443,axiom,
    ! [VarCurr: state_type] :
      ( v29846(VarCurr)
    <=> v29848(VarCurr) ) ).

tff(addAssignment_15442,axiom,
    ! [VarCurr: state_type] :
      ( v29848(VarCurr)
    <=> v29850(VarCurr) ) ).

tff(addAssignment_15441,axiom,
    ! [VarCurr: state_type] :
      ( v29850(VarCurr)
    <=> v29852(VarCurr) ) ).

tff(addAssignment_15440,axiom,
    ! [VarCurr: state_type] :
      ( v29852(VarCurr)
    <=> v29854(VarCurr) ) ).

tff(writeUnaryOperator_1613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29854(VarCurr)
    <=> v30129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2471,axiom,
    ! [VarCurr: state_type] :
      ( v30129(VarCurr)
    <=> ( v30130(VarCurr)
        | v30125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2470,axiom,
    ! [VarCurr: state_type] :
      ( v30130(VarCurr)
    <=> ( v29856(VarCurr)
        | v30121(VarCurr) ) ) ).

tff(addAssignment_15439,axiom,
    ! [VarCurr: state_type] :
      ( v30125(VarCurr)
    <=> v30127(VarCurr) ) ).

tff(addAssignment_15438,axiom,
    ! [VarCurr: state_type] :
      ( v30127(VarCurr)
    <=> v29860(VarCurr,2) ) ).

tff(addAssignment_15437,axiom,
    ! [VarCurr: state_type] :
      ( v30121(VarCurr)
    <=> v30123(VarCurr) ) ).

tff(addAssignment_15436,axiom,
    ! [VarCurr: state_type] :
      ( v30123(VarCurr)
    <=> v29860(VarCurr,1) ) ).

tff(addAssignment_15435,axiom,
    ! [VarCurr: state_type] :
      ( v29856(VarCurr)
    <=> v29858(VarCurr) ) ).

tff(addAssignment_15434,axiom,
    ! [VarCurr: state_type] :
      ( v29858(VarCurr)
    <=> v29860(VarCurr,0) ) ).

tff(addAssignment_15433,axiom,
    ! [VarCurr: state_type] :
      ( v29860(VarCurr,0)
    <=> v29772(VarCurr,3) ) ).

tff(addAssignment_15432,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,3)
    <=> v29774(VarCurr,3) ) ).

tff(addAssignment_15431,axiom,
    ! [VarNext: state_type] :
      ( v29774(VarNext,3)
    <=> v30113(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30114(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v30113(VarNext,B)
            <=> v29774(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_339,axiom,
    ! [VarNext: state_type] :
      ( v30114(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30113(VarNext,B)
          <=> v30085(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2469,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30114(VarNext)
      <=> v30115(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30115(VarNext)
      <=> ( v30117(VarNext)
          & v30027(VarNext) ) ) ) ).

tff(writeUnaryOperator_1612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30117(VarNext)
      <=> v30079(VarNext) ) ) ).

tff(addAssignment_15430,axiom,
    ! [VarCurr: state_type] :
      ( v29884(VarCurr,3)
    <=> v29886(VarCurr,3) ) ).

tff(addAssignment_15429,axiom,
    ! [VarCurr: state_type] :
      ( v29886(VarCurr,3)
    <=> v30024(VarCurr,3) ) ).

tff(addAssignment_15428,axiom,
    ! [VarCurr: state_type] :
      ( v29888(VarCurr,0)
    <=> v29890(VarCurr,0) ) ).

tff(addAssignment_15427,axiom,
    ! [VarCurr: state_type] :
      ( v29890(VarCurr,0)
    <=> v29892(VarCurr,0) ) ).

tff(addAssignment_15426,axiom,
    ! [VarCurr: state_type] :
      ( v29892(VarCurr,0)
    <=> v30023(VarCurr,0) ) ).

tff(addAssignment_15425,axiom,
    ! [VarCurr: state_type] :
      ( v29960(VarCurr,0)
    <=> v29962(VarCurr,0) ) ).

tff(addAssignment_15424,axiom,
    ! [VarCurr: state_type] :
      ( v29962(VarCurr,0)
    <=> v29964(VarCurr,0) ) ).

tff(addAssignment_15423,axiom,
    ! [VarCurr: state_type] :
      ( v29964(VarCurr,0)
    <=> v29966(VarCurr,0) ) ).

tff(addAssignment_15422,axiom,
    ! [VarCurr: state_type] :
      ( v29966(VarCurr,0)
    <=> v29968(VarCurr,0) ) ).

tff(addAssignment_15421,axiom,
    ! [VarCurr: state_type] :
      ( v29968(VarCurr,0)
    <=> v29978(VarCurr,0) ) ).

tff(addAssignment_15420,axiom,
    ! [VarCurr: state_type] :
      ( v29894(VarCurr,0)
    <=> v29896(VarCurr,0) ) ).

tff(addAssignment_15419,axiom,
    ! [VarCurr: state_type] :
      ( v29896(VarCurr,0)
    <=> v29957(VarCurr,0) ) ).

tff(addAssignment_15418,axiom,
    ! [VarCurr: state_type] :
      ( v29898(VarCurr)
    <=> v29715(VarCurr,2) ) ).

tff(addAssignment_15417,axiom,
    ! [VarCurr: state_type] :
      ( v29715(VarCurr,2)
    <=> v29717(VarCurr,2) ) ).

tff(addAssignment_15416,axiom,
    ! [VarCurr: state_type] :
      ( v29717(VarCurr,2)
    <=> v29727(VarCurr,2) ) ).

tff(addAssignment_15415,axiom,
    ! [VarCurr: state_type] :
      ( v29719(VarCurr,2)
    <=> v29721(VarCurr,2) ) ).

tff(addAssignment_15414,axiom,
    ! [VarCurr: state_type] :
      ( v29721(VarCurr,2)
    <=> v29724(VarCurr,2) ) ).

tff(addAssignment_15413,axiom,
    ! [VarCurr: state_type] :
      ( v29725(VarCurr)
    <=> v29901(VarCurr,1) ) ).

tff(addAssignment_15412,axiom,
    ! [VarCurr: state_type] :
      ( v29901(VarCurr,1)
    <=> v29903(VarCurr,1) ) ).

tff(addAssignment_15411,axiom,
    ! [VarCurr: state_type] :
      ( v29903(VarCurr,1)
    <=> v30111(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v30111(VarCurr,B)
      <=> ( v29905(VarCurr,B)
          | v29911(VarCurr,B) ) ) ) ).

tff(addAssignment_15410,axiom,
    ! [VarCurr: state_type] :
      ( v29911(VarCurr,1)
    <=> v29913(VarCurr,1) ) ).

tff(addAssignment_15409,axiom,
    ! [VarCurr: state_type] :
      ( v29913(VarCurr,1)
    <=> v30109(VarCurr,1) ) ).

tff(addAssignment_15408,axiom,
    ! [VarCurr: state_type] :
      ( v30109(VarCurr,0)
    <=> v30110(VarCurr) ) ).

tff(addAssignment_15407,axiom,
    ! [VarCurr: state_type] :
      ( v30109(VarCurr,1)
    <=> v29915(VarCurr) ) ).

tff(addAssignment_15406,axiom,
    ! [VarCurr: state_type] :
      ( v29915(VarCurr)
    <=> v29917(VarCurr,1) ) ).

tff(addAssignment_15405,axiom,
    ! [VarCurr: state_type] :
      ( v29917(VarCurr,1)
    <=> v29919(VarCurr,1) ) ).

tff(addAssignment_15404,axiom,
    ! [VarCurr: state_type] :
      ( v29919(VarCurr,1)
    <=> v30108(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v30108(VarCurr,B)
      <=> ( v29921(VarCurr,B)
          & v29929(VarCurr,B) ) ) ) ).

tff(addAssignment_15403,axiom,
    ! [VarCurr: state_type] :
      ( v29929(VarCurr,1)
    <=> v29931(VarCurr,1) ) ).

tff(addAssignment_15402,axiom,
    ! [VarCurr: state_type] :
      ( v29931(VarCurr,1)
    <=> v30106(VarCurr,1) ) ).

tff(addAssignment_15401,axiom,
    ! [VarCurr: state_type] :
      ( v30106(VarCurr,0)
    <=> v30107(VarCurr) ) ).

tff(addAssignment_15400,axiom,
    ! [VarCurr: state_type] :
      ( v30106(VarCurr,1)
    <=> v29933(VarCurr) ) ).

tff(addAssignment_15399,axiom,
    ! [VarCurr: state_type] :
      ( v29933(VarCurr)
    <=> v29935(VarCurr) ) ).

tff(addAssignment_15398,axiom,
    ! [VarCurr: state_type] :
      ( v29935(VarCurr)
    <=> v29937(VarCurr) ) ).

tff(writeUnaryOperator_1611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29937(VarCurr)
    <=> v30104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2467,axiom,
    ! [VarCurr: state_type] :
      ( v30104(VarCurr)
    <=> ( v30105(VarCurr)
        | v30092(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2466,axiom,
    ! [VarCurr: state_type] :
      ( v30105(VarCurr)
    <=> ( v29939(VarCurr)
        | v29954(VarCurr) ) ) ).

tff(addAssignment_15397,axiom,
    ! [VarCurr: state_type] :
      ( v30092(VarCurr)
    <=> v30094(VarCurr) ) ).

tff(addAssignment_15396,axiom,
    ! [VarCurr: state_type] :
      ( v30094(VarCurr)
    <=> v29943(VarCurr,2) ) ).

tff(addAssignment_15395,axiom,
    ! [VarCurr: state_type] :
      ( v29943(VarCurr,2)
    <=> v29945(VarCurr,2) ) ).

tff(addAssignment_15394,axiom,
    ! [VarCurr: state_type] :
      ( v29945(VarCurr,2)
    <=> v29947(VarCurr,2) ) ).

tff(addAssignment_15393,axiom,
    ! [VarCurr: state_type] :
      ( v29947(VarCurr,2)
    <=> v29952(VarCurr,2) ) ).

tff(addAssignment_15392,axiom,
    ! [VarCurr: state_type] :
      ( v29949(VarCurr,2)
    <=> v29951(VarCurr,2) ) ).

tff(addAssignment_15391,axiom,
    ! [VarCurr: state_type] :
      ( v29951(VarCurr,2)
    <=> v29860(VarCurr,2) ) ).

tff(addAssignment_15390,axiom,
    ! [VarCurr: state_type] :
      ( v29860(VarCurr,2)
    <=> v29772(VarCurr,5) ) ).

tff(addAssignment_15389,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,5)
    <=> v29774(VarCurr,5) ) ).

tff(addAssignment_15388,axiom,
    ! [VarNext: state_type] :
      ( v29774(VarNext,5)
    <=> v30096(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30097(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v30096(VarNext,B)
            <=> v29774(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_338,axiom,
    ! [VarNext: state_type] :
      ( v30097(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30096(VarNext,B)
          <=> v30085(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2465,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30097(VarNext)
      <=> v30098(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30098(VarNext)
      <=> ( v30100(VarNext)
          & v30027(VarNext) ) ) ) ).

tff(writeUnaryOperator_1610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30100(VarNext)
      <=> v30079(VarNext) ) ) ).

tff(addAssignment_15387,axiom,
    ! [VarCurr: state_type] :
      ( v29884(VarCurr,5)
    <=> v29886(VarCurr,5) ) ).

tff(addAssignment_15386,axiom,
    ! [VarCurr: state_type] :
      ( v29886(VarCurr,5)
    <=> v30024(VarCurr,5) ) ).

tff(addAssignment_15385,axiom,
    ! [VarCurr: state_type] :
      ( v29888(VarCurr,2)
    <=> v29890(VarCurr,2) ) ).

tff(addAssignment_15384,axiom,
    ! [VarCurr: state_type] :
      ( v29890(VarCurr,2)
    <=> v29892(VarCurr,2) ) ).

tff(addAssignment_15383,axiom,
    ! [VarCurr: state_type] :
      ( v29892(VarCurr,2)
    <=> v30023(VarCurr,2) ) ).

tff(addAssignment_15382,axiom,
    ! [VarCurr: state_type] :
      ( v29960(VarCurr,2)
    <=> v29962(VarCurr,2) ) ).

tff(addAssignment_15381,axiom,
    ! [VarCurr: state_type] :
      ( v29962(VarCurr,2)
    <=> v29964(VarCurr,2) ) ).

tff(addAssignment_15380,axiom,
    ! [VarCurr: state_type] :
      ( v29964(VarCurr,2)
    <=> v29966(VarCurr,2) ) ).

tff(addAssignment_15379,axiom,
    ! [VarCurr: state_type] :
      ( v29966(VarCurr,2)
    <=> v29968(VarCurr,2) ) ).

tff(addAssignment_15378,axiom,
    ! [VarCurr: state_type] :
      ( v29968(VarCurr,2)
    <=> v29978(VarCurr,2) ) ).

tff(addAssignment_15377,axiom,
    ! [VarCurr: state_type] :
      ( v29970(VarCurr,2)
    <=> v29972(VarCurr,2) ) ).

tff(addAssignment_15376,axiom,
    ! [VarCurr: state_type] :
      ( v29972(VarCurr,2)
    <=> v29973(VarCurr,2) ) ).

tff(addAssignment_15375,axiom,
    ! [VarCurr: state_type] :
      ( v29894(VarCurr,2)
    <=> v29896(VarCurr,2) ) ).

tff(addAssignment_15374,axiom,
    ! [VarCurr: state_type] :
      ( v29896(VarCurr,2)
    <=> v29957(VarCurr,2) ) ).

tff(addAssignment_15373,axiom,
    ! [VarCurr: state_type] :
      ( v29954(VarCurr)
    <=> v29956(VarCurr) ) ).

tff(addAssignment_15372,axiom,
    ! [VarCurr: state_type] :
      ( v29956(VarCurr)
    <=> v29860(VarCurr,1) ) ).

tff(addAssignment_15371,axiom,
    ! [VarCurr: state_type] :
      ( v29860(VarCurr,1)
    <=> v29772(VarCurr,4) ) ).

tff(addAssignment_15370,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,4)
    <=> v29774(VarCurr,4) ) ).

tff(addAssignment_15369,axiom,
    ! [VarNext: state_type] :
      ( v29774(VarNext,4)
    <=> v30074(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30075(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v30074(VarNext,B)
            <=> v29774(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_337,axiom,
    ! [VarNext: state_type] :
      ( v30075(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30074(VarNext,B)
          <=> v30085(VarNext,B) ) ) ) ).

tff(addAssignment_15368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30085(VarNext,B)
          <=> v30083(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30086(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30083(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_201,axiom,
    ! [VarCurr: state_type] :
      ( v30086(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v30083(VarCurr,B)
          <=> v29884(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2463,axiom,
    ! [VarCurr: state_type] :
      ( v30086(VarCurr)
    <=> ( v30087(VarCurr)
        & v30088(VarCurr) ) ) ).

tff(writeUnaryOperator_1609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30088(VarCurr)
    <=> v29874(VarCurr) ) ).

tff(writeUnaryOperator_1608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30087(VarCurr)
    <=> v29862(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30075(VarNext)
      <=> v30076(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30076(VarNext)
      <=> ( v30077(VarNext)
          & v30027(VarNext) ) ) ) ).

tff(writeUnaryOperator_1607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30077(VarNext)
      <=> v30079(VarNext) ) ) ).

tff(addAssignment_15367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30079(VarNext)
      <=> v30027(VarCurr) ) ) ).

tff(addAssignment_15366,axiom,
    ! [VarCurr: state_type] :
      ( v30027(VarCurr)
    <=> v30029(VarCurr) ) ).

tff(addAssignment_15365,axiom,
    ! [VarCurr: state_type] :
      ( v30029(VarCurr)
    <=> v30031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2460,axiom,
    ! [VarCurr: state_type] :
      ( v30031(VarCurr)
    <=> ( v30072(VarCurr)
        | v30068(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2459,axiom,
    ! [VarCurr: state_type] :
      ( v30072(VarCurr)
    <=> ( v30033(VarCurr)
        & v30037(VarCurr) ) ) ).

tff(addAssignment_15364,axiom,
    ! [VarCurr: state_type] :
      ( v30068(VarCurr)
    <=> v30070(VarCurr) ) ).

tff(addAssignment_15363,axiom,
    ! [VarCurr: state_type] :
      ( v30070(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_336,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v30052(VarNext)
       => ( v30037(VarNext)
        <=> v30037(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_336,axiom,
    ! [VarNext: state_type] :
      ( v30052(VarNext)
     => ( v30037(VarNext)
      <=> v30062(VarNext) ) ) ).

tff(addAssignment_15362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30062(VarNext)
      <=> v30060(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2458,axiom,
    ! [VarCurr: state_type] :
      ( v30060(VarCurr)
    <=> ( v30063(VarCurr)
        & v30064(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2457,axiom,
    ! [VarCurr: state_type] :
      ( v30064(VarCurr)
    <=> ( v30043(VarCurr)
        | v30047(VarCurr) ) ) ).

tff(writeUnaryOperator_1606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30063(VarCurr)
    <=> v30039(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30052(VarNext)
      <=> v30053(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30053(VarNext)
      <=> ( v30055(VarNext)
          & v30057(VarNext) ) ) ) ).

tff(writeUnaryOperator_1605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30057(VarCurr)
    <=> v30033(VarCurr) ) ).

tff(addAssignment_15361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v30055(VarNext)
      <=> v30033(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_130,axiom,
    ( v30037(constB0)
  <=> $true ) ).

tff(addAssignment_15360,axiom,
    ! [VarCurr: state_type] :
      ( v30047(VarCurr)
    <=> v30049(VarCurr) ) ).

tff(addAssignment_15359,axiom,
    ! [VarCurr: state_type] :
      ( v30049(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15358,axiom,
    ! [VarCurr: state_type] :
      ( v30043(VarCurr)
    <=> v30045(VarCurr) ) ).

tff(addAssignment_15357,axiom,
    ! [VarCurr: state_type] :
      ( v30045(VarCurr)
    <=> $true ) ).

tff(addAssignment_15356,axiom,
    ! [VarCurr: state_type] :
      ( v30039(VarCurr)
    <=> v30041(VarCurr) ) ).

tff(addAssignment_15355,axiom,
    ! [VarCurr: state_type] :
      ( v30041(VarCurr)
    <=> $false ) ).

tff(addAssignment_15354,axiom,
    ! [VarCurr: state_type] :
      ( v30033(VarCurr)
    <=> v30035(VarCurr) ) ).

tff(addAssignment_15353,axiom,
    ! [VarCurr: state_type] :
      ( v30035(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15352,axiom,
    ! [VarCurr: state_type] :
      ( v29884(VarCurr,4)
    <=> v29886(VarCurr,4) ) ).

tff(addAssignment_15351,axiom,
    ! [VarCurr: state_type] :
      ( v29886(VarCurr,4)
    <=> v30024(VarCurr,4) ) ).

tff(addAssignment_15350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v30024(VarCurr,B)
      <=> v30025(VarCurr,B) ) ) ).

tff(addAssignment_15349,axiom,
    ! [VarCurr: state_type] :
      ( ( v30024(VarCurr,5)
      <=> v29888(VarCurr,2) )
      & ( v30024(VarCurr,4)
      <=> v29888(VarCurr,1) )
      & ( v30024(VarCurr,3)
      <=> v29888(VarCurr,0) ) ) ).

tff(addAssignment_15348,axiom,
    ! [VarCurr: state_type] :
      ( v29888(VarCurr,1)
    <=> v29890(VarCurr,1) ) ).

tff(addAssignment_15347,axiom,
    ! [VarCurr: state_type] :
      ( v29890(VarCurr,1)
    <=> v29892(VarCurr,1) ) ).

tff(addAssignment_15346,axiom,
    ! [VarCurr: state_type] :
      ( v29892(VarCurr,1)
    <=> v30023(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_495,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v30023(VarCurr,B)
      <=> ( v29894(VarCurr,B)
          & v29960(VarCurr,B) ) ) ) ).

tff(addAssignment_15345,axiom,
    ! [VarCurr: state_type] :
      ( v29960(VarCurr,1)
    <=> v29962(VarCurr,1) ) ).

tff(addAssignment_15344,axiom,
    ! [VarCurr: state_type] :
      ( v29962(VarCurr,1)
    <=> v29964(VarCurr,1) ) ).

tff(addAssignment_15343,axiom,
    ! [VarCurr: state_type] :
      ( v29964(VarCurr,1)
    <=> v29966(VarCurr,1) ) ).

tff(addAssignment_15342,axiom,
    ! [VarCurr: state_type] :
      ( v29966(VarCurr,1)
    <=> v29968(VarCurr,1) ) ).

tff(addAssignment_15341,axiom,
    ! [VarCurr: state_type] :
      ( v29968(VarCurr,1)
    <=> v29978(VarCurr,1) ) ).

tff(addAssignment_15340,axiom,
    ! [VarCurr: state_type] :
      ( v29978(VarCurr,0)
    <=> v30018(VarCurr) ) ).

tff(addAssignment_15339,axiom,
    ! [VarCurr: state_type] :
      ( v29978(VarCurr,1)
    <=> v30013(VarCurr) ) ).

tff(addAssignment_15338,axiom,
    ! [VarCurr: state_type] :
      ( v29978(VarCurr,2)
    <=> v30008(VarCurr) ) ).

tff(addAssignment_15337,axiom,
    ! [VarCurr: state_type] :
      ( v29978(VarCurr,3)
    <=> v29980(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2454,axiom,
    ! [VarCurr: state_type] :
      ( v30018(VarCurr)
    <=> ( v30019(VarCurr)
        & v30022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2453,axiom,
    ! [VarCurr: state_type] :
      ( v30022(VarCurr)
    <=> ( v29970(VarCurr,0)
        | v29988(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2452,axiom,
    ! [VarCurr: state_type] :
      ( v30019(VarCurr)
    <=> ( v30020(VarCurr)
        | v30021(VarCurr) ) ) ).

tff(writeUnaryOperator_1604,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30021(VarCurr)
    <=> v29988(VarCurr,0) ) ).

tff(writeUnaryOperator_1603,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30020(VarCurr)
    <=> v29970(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2451,axiom,
    ! [VarCurr: state_type] :
      ( v30013(VarCurr)
    <=> ( v30014(VarCurr)
        & v30017(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2450,axiom,
    ! [VarCurr: state_type] :
      ( v30017(VarCurr)
    <=> ( v29987(VarCurr)
        | v29989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2449,axiom,
    ! [VarCurr: state_type] :
      ( v30014(VarCurr)
    <=> ( v30015(VarCurr)
        | v30016(VarCurr) ) ) ).

tff(writeUnaryOperator_1602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30016(VarCurr)
    <=> v29989(VarCurr) ) ).

tff(writeUnaryOperator_1601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30015(VarCurr)
    <=> v29987(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2448,axiom,
    ! [VarCurr: state_type] :
      ( v30008(VarCurr)
    <=> ( v30009(VarCurr)
        & v30012(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2447,axiom,
    ! [VarCurr: state_type] :
      ( v30012(VarCurr)
    <=> ( v29985(VarCurr)
        | v29995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2446,axiom,
    ! [VarCurr: state_type] :
      ( v30009(VarCurr)
    <=> ( v30010(VarCurr)
        | v30011(VarCurr) ) ) ).

tff(writeUnaryOperator_1600,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30011(VarCurr)
    <=> v29995(VarCurr) ) ).

tff(writeUnaryOperator_1599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30010(VarCurr)
    <=> v29985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2445,axiom,
    ! [VarCurr: state_type] :
      ( v29980(VarCurr)
    <=> ( v29981(VarCurr)
        & v30007(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2444,axiom,
    ! [VarCurr: state_type] :
      ( v30007(VarCurr)
    <=> ( v29983(VarCurr)
        | v30002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2443,axiom,
    ! [VarCurr: state_type] :
      ( v29981(VarCurr)
    <=> ( v29982(VarCurr)
        | v30001(VarCurr) ) ) ).

tff(writeUnaryOperator_1598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30001(VarCurr)
    <=> v30002(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2442,axiom,
    ! [VarCurr: state_type] :
      ( v30002(VarCurr)
    <=> ( v30003(VarCurr)
        & v30006(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_248,axiom,
    ! [VarCurr: state_type] :
      ( v30006(VarCurr)
    <=> ( v29970(VarCurr,3)
        | v29988(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2441,axiom,
    ! [VarCurr: state_type] :
      ( v30003(VarCurr)
    <=> ( v30004(VarCurr)
        | v30005(VarCurr) ) ) ).

tff(writeUnaryOperator_1597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30005(VarCurr)
    <=> v29988(VarCurr,3) ) ).

tff(writeUnaryOperator_1596,axiom,
    ! [VarCurr: state_type] :
      ( ~ v30004(VarCurr)
    <=> v29970(VarCurr,3) ) ).

tff(writeUnaryOperator_1595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29982(VarCurr)
    <=> v29983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2440,axiom,
    ! [VarCurr: state_type] :
      ( v29983(VarCurr)
    <=> ( v29984(VarCurr)
        | v30000(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_247,axiom,
    ! [VarCurr: state_type] :
      ( v30000(VarCurr)
    <=> ( v29970(VarCurr,2)
        & v29988(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2439,axiom,
    ! [VarCurr: state_type] :
      ( v29984(VarCurr)
    <=> ( v29985(VarCurr)
        & v29995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2438,axiom,
    ! [VarCurr: state_type] :
      ( v29995(VarCurr)
    <=> ( v29996(VarCurr)
        & v29999(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_246,axiom,
    ! [VarCurr: state_type] :
      ( v29999(VarCurr)
    <=> ( v29970(VarCurr,2)
        | v29988(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2437,axiom,
    ! [VarCurr: state_type] :
      ( v29996(VarCurr)
    <=> ( v29997(VarCurr)
        | v29998(VarCurr) ) ) ).

tff(writeUnaryOperator_1594,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29998(VarCurr)
    <=> v29988(VarCurr,2) ) ).

tff(writeUnaryOperator_1593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29997(VarCurr)
    <=> v29970(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2436,axiom,
    ! [VarCurr: state_type] :
      ( v29985(VarCurr)
    <=> ( v29986(VarCurr)
        | v29994(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_245,axiom,
    ! [VarCurr: state_type] :
      ( v29994(VarCurr)
    <=> ( v29970(VarCurr,1)
        & v29988(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2435,axiom,
    ! [VarCurr: state_type] :
      ( v29986(VarCurr)
    <=> ( v29987(VarCurr)
        & v29989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2434,axiom,
    ! [VarCurr: state_type] :
      ( v29989(VarCurr)
    <=> ( v29990(VarCurr)
        & v29993(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_244,axiom,
    ! [VarCurr: state_type] :
      ( v29993(VarCurr)
    <=> ( v29970(VarCurr,1)
        | v29988(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2433,axiom,
    ! [VarCurr: state_type] :
      ( v29990(VarCurr)
    <=> ( v29991(VarCurr)
        | v29992(VarCurr) ) ) ).

tff(writeUnaryOperator_1592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29992(VarCurr)
    <=> v29988(VarCurr,1) ) ).

tff(writeUnaryOperator_1591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29991(VarCurr)
    <=> v29970(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2432,axiom,
    ! [VarCurr: state_type] :
      ( v29987(VarCurr)
    <=> ( v29970(VarCurr,0)
        & v29988(VarCurr,0) ) ) ).

tff(addAssignment_15336,axiom,
    ! [VarCurr: state_type] :
      ( v29988(VarCurr,0)
    <=> v29975(VarCurr) ) ).

tff(addAssignment_15335,axiom,
    ! [VarCurr: state_type] :
      ( ( v29988(VarCurr,3)
      <=> $false )
      & ( v29988(VarCurr,2)
      <=> $false )
      & ( v29988(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_15334,axiom,
    ! [VarCurr: state_type] :
      ( v29975(VarCurr)
    <=> v29977(VarCurr) ) ).

tff(addAssignment_15333,axiom,
    ! [VarCurr: state_type] :
      ( v29977(VarCurr)
    <=> v29925(VarCurr) ) ).

tff(addAssignment_15332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v29970(VarCurr,B)
      <=> v29972(VarCurr,B) ) ) ).

tff(addAssignment_15331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v29972(VarCurr,B)
      <=> v29973(VarCurr,B) ) ) ).

tff(addAssignment_15330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v29973(VarCurr,B)
      <=> v29860(VarCurr,B) ) ) ).

tff(addAssignment_15329,axiom,
    ! [VarCurr: state_type] :
      ( v29973(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_15328,axiom,
    ! [VarCurr: state_type] :
      ( v29894(VarCurr,1)
    <=> v29896(VarCurr,1) ) ).

tff(addAssignment_15327,axiom,
    ! [VarCurr: state_type] :
      ( v29896(VarCurr,1)
    <=> v29957(VarCurr,1) ) ).

tff(addAssignment_15326,axiom,
    ! [VarCurr: state_type] :
      ( v29957(VarCurr,0)
    <=> v29958(VarCurr) ) ).

tff(addAssignment_15325,axiom,
    ! [VarCurr: state_type] :
      ( v29957(VarCurr,1)
    <=> v29958(VarCurr) ) ).

tff(addAssignment_15324,axiom,
    ! [VarCurr: state_type] :
      ( v29957(VarCurr,2)
    <=> v29958(VarCurr) ) ).

tff(addAssignment_15323,axiom,
    ! [VarCurr: state_type] :
      ( v29958(VarCurr)
    <=> v29898(VarCurr) ) ).

tff(addAssignment_15322,axiom,
    ! [VarCurr: state_type] :
      ( v29939(VarCurr)
    <=> v29941(VarCurr) ) ).

tff(addAssignment_15321,axiom,
    ! [VarCurr: state_type] :
      ( v29941(VarCurr)
    <=> v29943(VarCurr,0) ) ).

tff(addAssignment_15320,axiom,
    ! [VarCurr: state_type] :
      ( v29943(VarCurr,0)
    <=> v29945(VarCurr,0) ) ).

tff(addAssignment_15319,axiom,
    ! [VarCurr: state_type] :
      ( v29945(VarCurr,0)
    <=> v29947(VarCurr,0) ) ).

tff(addAssignment_15318,axiom,
    ! [VarCurr: state_type] :
      ( v29947(VarCurr,0)
    <=> v29952(VarCurr,0) ) ).

tff(writeUnaryOperator_1590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v29952(VarCurr,B)
      <=> ~ v29949(VarCurr,B) ) ) ).

tff(addAssignment_15317,axiom,
    ! [VarCurr: state_type] :
      ( v29949(VarCurr,0)
    <=> v29951(VarCurr,0) ) ).

tff(addAssignment_15316,axiom,
    ! [VarCurr: state_type] :
      ( v29951(VarCurr,0)
    <=> v29860(VarCurr,0) ) ).

tff(addAssignment_15315,axiom,
    ! [VarCurr: state_type] :
      ( v29921(VarCurr,1)
    <=> v29923(VarCurr,1) ) ).

tff(addAssignment_15314,axiom,
    ! [VarCurr: state_type] :
      ( v29923(VarCurr,1)
    <=> v29926(VarCurr,1) ) ).

tff(addAssignment_15313,axiom,
    ! [VarCurr: state_type] :
      ( v29926(VarCurr,0)
    <=> v29927(VarCurr) ) ).

tff(addAssignment_15312,axiom,
    ! [VarCurr: state_type] :
      ( v29926(VarCurr,1)
    <=> v29925(VarCurr) ) ).

tff(addAssignment_15311,axiom,
    ! [VarCurr: state_type] :
      ( v29925(VarCurr)
    <=> v10053(VarCurr,13) ) ).

tff(addAssignment_15310,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,13)
    <=> v10055(VarCurr,13) ) ).

tff(addAssignment_15309,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,13)
    <=> v10057(VarCurr,13) ) ).

tff(addAssignment_15308,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,13)
    <=> v10061(VarCurr,13) ) ).

tff(addAssignment_15307,axiom,
    ! [VarCurr: state_type] :
      ( v29905(VarCurr,1)
    <=> v29907(VarCurr,1) ) ).

tff(addAssignment_15306,axiom,
    ! [VarCurr: state_type] :
      ( v29907(VarCurr,1)
    <=> v29908(VarCurr,1) ) ).

tff(addAssignment_15305,axiom,
    ! [VarCurr: state_type] :
      ( v29908(VarCurr,0)
    <=> v29909(VarCurr) ) ).

tff(addAssignment_15304,axiom,
    ! [VarCurr: state_type] :
      ( v29908(VarCurr,1)
    <=> v29909(VarCurr) ) ).

tff(addAssignment_15303,axiom,
    ! [VarCurr: state_type] :
      ( v29909(VarCurr)
    <=> v29723(VarCurr) ) ).

tff(addAssignment_15302,axiom,
    ! [VarCurr: state_type] :
      ( v29874(VarCurr)
    <=> v29876(VarCurr) ) ).

tff(addAssignment_15301,axiom,
    ! [VarCurr: state_type] :
      ( v29876(VarCurr)
    <=> v29878(VarCurr) ) ).

tff(addAssignment_15300,axiom,
    ! [VarCurr: state_type] :
      ( v29878(VarCurr)
    <=> v29880(VarCurr) ) ).

tff(addAssignment_15299,axiom,
    ! [VarCurr: state_type] :
      ( v29880(VarCurr)
    <=> v29882(VarCurr) ) ).

tff(addAssignment_15298,axiom,
    ! [VarCurr: state_type] :
      ( v29882(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15297,axiom,
    ! [VarCurr: state_type] :
      ( v29862(VarCurr)
    <=> v29864(VarCurr) ) ).

tff(addAssignment_15296,axiom,
    ! [VarCurr: state_type] :
      ( v29864(VarCurr)
    <=> v29866(VarCurr) ) ).

tff(addAssignment_15295,axiom,
    ! [VarCurr: state_type] :
      ( v29866(VarCurr)
    <=> v29868(VarCurr) ) ).

tff(addAssignment_15294,axiom,
    ! [VarCurr: state_type] :
      ( v29868(VarCurr)
    <=> v29870(VarCurr) ) ).

tff(addAssignment_15293,axiom,
    ! [VarCurr: state_type] :
      ( v29870(VarCurr)
    <=> v29872(VarCurr) ) ).

tff(addAssignment_15292,axiom,
    ! [VarCurr: state_type] :
      ( v29872(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_15291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29661(VarCurr,B)
      <=> v29663(VarCurr,B) ) ) ).

tff(addAssignment_15290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29663(VarCurr,B)
      <=> v29665(VarCurr,B) ) ) ).

tff(addAssignment_15289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29665(VarCurr,B)
      <=> v29667(VarCurr,B) ) ) ).

tff(addAssignment_15288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29667(VarCurr,B)
      <=> v29669(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_335,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29823(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v29669(VarNext,B)
            <=> v29669(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_335,axiom,
    ! [VarNext: state_type] :
      ( v29823(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29669(VarNext,B)
          <=> v29833(VarNext,B) ) ) ) ).

tff(addAssignment_15287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29833(VarNext,B)
          <=> v29831(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29831(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_200,axiom,
    ! [VarCurr: state_type] :
      ( v29834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29831(VarCurr,B)
          <=> v29699(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2431,axiom,
    ! [VarCurr: state_type] :
      ( v29834(VarCurr)
    <=> ( v29835(VarCurr)
        & v29836(VarCurr) ) ) ).

tff(writeUnaryOperator_1589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29836(VarCurr)
    <=> v29685(VarCurr) ) ).

tff(writeUnaryOperator_1588,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29835(VarCurr)
    <=> v29671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29823(VarNext)
      <=> v29824(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29824(VarNext)
      <=> ( v29825(VarNext)
          & v29738(VarNext) ) ) ) ).

tff(writeUnaryOperator_1587,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29825(VarNext)
      <=> v29827(VarNext) ) ) ).

tff(addAssignment_15286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29827(VarNext)
      <=> v29738(VarCurr) ) ) ).

tff(addAssignment_15285,axiom,
    ! [VarCurr: state_type] :
      ( v29738(VarCurr)
    <=> v29740(VarCurr) ) ).

tff(addAssignment_15284,axiom,
    ! [VarCurr: state_type] :
      ( v29740(VarCurr)
    <=> v29742(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2428,axiom,
    ! [VarCurr: state_type] :
      ( v29742(VarCurr)
    <=> ( v29820(VarCurr)
        | v29812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2427,axiom,
    ! [VarCurr: state_type] :
      ( v29820(VarCurr)
    <=> ( v29744(VarCurr)
        & v29750(VarCurr) ) ) ).

tff(addAssignment_15283,axiom,
    ! [VarCurr: state_type] :
      ( v29812(VarCurr)
    <=> v29814(VarCurr) ) ).

tff(addAssignment_15282,axiom,
    ! [VarCurr: state_type] :
      ( v29814(VarCurr)
    <=> v29816(VarCurr) ) ).

tff(addAssignment_15281,axiom,
    ! [VarCurr: state_type] :
      ( v29816(VarCurr)
    <=> v29818(VarCurr) ) ).

tff(addAssignment_15280,axiom,
    ! [VarCurr: state_type] :
      ( v29818(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29796(VarNext)
       => ( v29750(VarNext)
        <=> v29750(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_334,axiom,
    ! [VarNext: state_type] :
      ( v29796(VarNext)
     => ( v29750(VarNext)
      <=> v29806(VarNext) ) ) ).

tff(addAssignment_15279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29806(VarNext)
      <=> v29804(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2426,axiom,
    ! [VarCurr: state_type] :
      ( v29804(VarCurr)
    <=> ( v29807(VarCurr)
        & v29808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2425,axiom,
    ! [VarCurr: state_type] :
      ( v29808(VarCurr)
    <=> ( v29756(VarCurr)
        | v29787(VarCurr) ) ) ).

tff(writeUnaryOperator_1586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29807(VarCurr)
    <=> v29752(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2424,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29796(VarNext)
      <=> v29797(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29797(VarNext)
      <=> ( v29799(VarNext)
          & v29801(VarNext) ) ) ) ).

tff(writeUnaryOperator_1585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29801(VarCurr)
    <=> v29744(VarCurr) ) ).

tff(addAssignment_15278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29799(VarNext)
      <=> v29744(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_129,axiom,
    ( v29750(constB0)
  <=> $true ) ).

tff(addAssignment_15277,axiom,
    ! [VarCurr: state_type] :
      ( v29787(VarCurr)
    <=> v29789(VarCurr) ) ).

tff(addAssignment_15276,axiom,
    ! [VarCurr: state_type] :
      ( v29789(VarCurr)
    <=> v29791(VarCurr) ) ).

tff(addAssignment_15275,axiom,
    ! [VarCurr: state_type] :
      ( v29791(VarCurr)
    <=> v29793(VarCurr) ) ).

tff(addAssignment_15274,axiom,
    ! [VarCurr: state_type] :
      ( v29793(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_15273,axiom,
    ! [VarCurr: state_type] :
      ( v29756(VarCurr)
    <=> v29758(VarCurr) ) ).

tff(addAssignment_15272,axiom,
    ! [VarCurr: state_type] :
      ( v29758(VarCurr)
    <=> v29760(VarCurr) ) ).

tff(addAssignment_15271,axiom,
    ! [VarCurr: state_type] :
      ( v29760(VarCurr)
    <=> v29762(VarCurr) ) ).

tff(addAssignment_15270,axiom,
    ! [VarCurr: state_type] :
      ( v29762(VarCurr)
    <=> v29764(VarCurr) ) ).

tff(writeUnaryOperator_1584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29764(VarCurr)
    <=> v29784(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2422,axiom,
    ! [VarCurr: state_type] :
      ( v29784(VarCurr)
    <=> ( v29785(VarCurr)
        | v29780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2421,axiom,
    ! [VarCurr: state_type] :
      ( v29785(VarCurr)
    <=> ( v29766(VarCurr)
        | v29776(VarCurr) ) ) ).

tff(addAssignment_15269,axiom,
    ! [VarCurr: state_type] :
      ( v29780(VarCurr)
    <=> v29782(VarCurr) ) ).

tff(addAssignment_15268,axiom,
    ! [VarCurr: state_type] :
      ( v29782(VarCurr)
    <=> v29770(VarCurr,2) ) ).

tff(addAssignment_15267,axiom,
    ! [VarCurr: state_type] :
      ( v29770(VarCurr,2)
    <=> v29772(VarCurr,2) ) ).

tff(addAssignment_15266,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,2)
    <=> v29774(VarCurr,2) ) ).

tff(addAssignment_15265,axiom,
    ! [VarCurr: state_type] :
      ( v29776(VarCurr)
    <=> v29778(VarCurr) ) ).

tff(addAssignment_15264,axiom,
    ! [VarCurr: state_type] :
      ( v29778(VarCurr)
    <=> v29770(VarCurr,1) ) ).

tff(addAssignment_15263,axiom,
    ! [VarCurr: state_type] :
      ( v29770(VarCurr,1)
    <=> v29772(VarCurr,1) ) ).

tff(addAssignment_15262,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,1)
    <=> v29774(VarCurr,1) ) ).

tff(addAssignment_15261,axiom,
    ! [VarCurr: state_type] :
      ( v29766(VarCurr)
    <=> v29768(VarCurr) ) ).

tff(addAssignment_15260,axiom,
    ! [VarCurr: state_type] :
      ( v29768(VarCurr)
    <=> v29770(VarCurr,0) ) ).

tff(addAssignment_15259,axiom,
    ! [VarCurr: state_type] :
      ( v29770(VarCurr,0)
    <=> v29772(VarCurr,0) ) ).

tff(addAssignment_15258,axiom,
    ! [VarCurr: state_type] :
      ( v29772(VarCurr,0)
    <=> v29774(VarCurr,0) ) ).

tff(addAssignment_15257,axiom,
    ! [VarCurr: state_type] :
      ( v29752(VarCurr)
    <=> v29754(VarCurr) ) ).

tff(addAssignment_15256,axiom,
    ! [VarCurr: state_type] :
      ( v29754(VarCurr)
    <=> $false ) ).

tff(addAssignment_15255,axiom,
    ! [VarCurr: state_type] :
      ( v29744(VarCurr)
    <=> v29746(VarCurr) ) ).

tff(addAssignment_15254,axiom,
    ! [VarCurr: state_type] :
      ( v29746(VarCurr)
    <=> v29748(VarCurr) ) ).

tff(addAssignment_15253,axiom,
    ! [VarCurr: state_type] :
      ( v29748(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_15252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29699(VarCurr,B)
      <=> v29701(VarCurr,B) ) ) ).

tff(addAssignment_15251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29701(VarCurr,B)
      <=> v29703(VarCurr,B) ) ) ).

tff(addAssignment_15250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29703(VarCurr,B)
      <=> v29705(VarCurr,B) ) ) ).

tff(addAssignment_15249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29705(VarCurr,B)
      <=> v29707(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29707(VarCurr,B)
      <=> ( v29709(VarCurr,B)
          & v29731(VarCurr,B) ) ) ) ).

tff(addAssignment_15248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29731(VarCurr,B)
      <=> v29733(VarCurr,B) ) ) ).

tff(addAssignment_15247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29733(VarCurr,B)
      <=> v29735(VarCurr,B) ) ) ).

tff(addAssignment_15246,axiom,
    ! [VarCurr: state_type] :
      ( ( v29735(VarCurr,11)
      <=> v9198(VarCurr,167) )
      & ( v29735(VarCurr,10)
      <=> v9198(VarCurr,166) )
      & ( v29735(VarCurr,9)
      <=> v9198(VarCurr,165) )
      & ( v29735(VarCurr,8)
      <=> v9198(VarCurr,164) )
      & ( v29735(VarCurr,7)
      <=> v9198(VarCurr,163) )
      & ( v29735(VarCurr,6)
      <=> v9198(VarCurr,162) )
      & ( v29735(VarCurr,5)
      <=> v9198(VarCurr,161) )
      & ( v29735(VarCurr,4)
      <=> v9198(VarCurr,160) )
      & ( v29735(VarCurr,3)
      <=> v9198(VarCurr,159) )
      & ( v29735(VarCurr,2)
      <=> v9198(VarCurr,158) )
      & ( v29735(VarCurr,1)
      <=> v9198(VarCurr,157) )
      & ( v29735(VarCurr,0)
      <=> v9198(VarCurr,156) ) ) ).

tff(addAssignment_15245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v9198(VarCurr,B)
      <=> v9208(VarCurr,B) ) ) ).

tff(addAssignment_15244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29709(VarCurr,B)
      <=> v29711(VarCurr,B) ) ) ).

tff(addAssignment_15243,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,0)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15242,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,1)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15241,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,2)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15240,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,3)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15239,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,4)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15238,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,5)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15237,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,6)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15236,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,7)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15235,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,8)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15234,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,9)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15233,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,10)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15232,axiom,
    ! [VarCurr: state_type] :
      ( v29711(VarCurr,11)
    <=> v29729(VarCurr) ) ).

tff(addAssignment_15231,axiom,
    ! [VarCurr: state_type] :
      ( v29729(VarCurr)
    <=> v29713(VarCurr) ) ).

tff(addAssignment_15230,axiom,
    ! [VarCurr: state_type] :
      ( v29713(VarCurr)
    <=> v29715(VarCurr,0) ) ).

tff(addAssignment_15229,axiom,
    ! [VarCurr: state_type] :
      ( v29715(VarCurr,0)
    <=> v29717(VarCurr,0) ) ).

tff(addAssignment_15228,axiom,
    ! [VarCurr: state_type] :
      ( v29717(VarCurr,0)
    <=> v29727(VarCurr,0) ) ).

tff(writeUnaryOperator_1583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v29727(VarCurr,B)
      <=> ~ v29719(VarCurr,B) ) ) ).

tff(addAssignment_15227,axiom,
    ! [VarCurr: state_type] :
      ( v29719(VarCurr,0)
    <=> v29721(VarCurr,0) ) ).

tff(addAssignment_15226,axiom,
    ! [VarCurr: state_type] :
      ( v29721(VarCurr,0)
    <=> v29724(VarCurr,0) ) ).

tff(addAssignment_15225,axiom,
    ! [VarCurr: state_type] :
      ( v29724(VarCurr,0)
    <=> v29723(VarCurr) ) ).

tff(addAssignment_15224,axiom,
    ! [VarCurr: state_type] :
      ( v29724(VarCurr,1)
    <=> v29726(VarCurr) ) ).

tff(addAssignment_15223,axiom,
    ! [VarCurr: state_type] :
      ( v29724(VarCurr,2)
    <=> v29725(VarCurr) ) ).

tff(addAssignment_15222,axiom,
    ! [VarCurr: state_type] :
      ( v29723(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_15221,axiom,
    ! [VarCurr: state_type] :
      ( v29685(VarCurr)
    <=> v29687(VarCurr) ) ).

tff(addAssignment_15220,axiom,
    ! [VarCurr: state_type] :
      ( v29687(VarCurr)
    <=> v29689(VarCurr) ) ).

tff(addAssignment_15219,axiom,
    ! [VarCurr: state_type] :
      ( v29689(VarCurr)
    <=> v29691(VarCurr) ) ).

tff(addAssignment_15218,axiom,
    ! [VarCurr: state_type] :
      ( v29691(VarCurr)
    <=> v29693(VarCurr) ) ).

tff(addAssignment_15217,axiom,
    ! [VarCurr: state_type] :
      ( v29693(VarCurr)
    <=> v29695(VarCurr) ) ).

tff(addAssignment_15216,axiom,
    ! [VarCurr: state_type] :
      ( v29695(VarCurr)
    <=> v29697(VarCurr) ) ).

tff(addAssignment_15215,axiom,
    ! [VarCurr: state_type] :
      ( v29697(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_15214,axiom,
    ! [VarCurr: state_type] :
      ( v29671(VarCurr)
    <=> v29673(VarCurr) ) ).

tff(addAssignment_15213,axiom,
    ! [VarCurr: state_type] :
      ( v29673(VarCurr)
    <=> v29675(VarCurr) ) ).

tff(addAssignment_15212,axiom,
    ! [VarCurr: state_type] :
      ( v29675(VarCurr)
    <=> v29677(VarCurr) ) ).

tff(addAssignment_15211,axiom,
    ! [VarCurr: state_type] :
      ( v29677(VarCurr)
    <=> v29679(VarCurr) ) ).

tff(addAssignment_15210,axiom,
    ! [VarCurr: state_type] :
      ( v29679(VarCurr)
    <=> v29681(VarCurr) ) ).

tff(addAssignment_15209,axiom,
    ! [VarCurr: state_type] :
      ( v29681(VarCurr)
    <=> v29683(VarCurr) ) ).

tff(addAssignment_15208,axiom,
    ! [VarCurr: state_type] :
      ( v29683(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_15207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29647(VarCurr,B)
      <=> v29649(VarCurr,B) ) ) ).

tff(addAssignment_15206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29649(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_15205,axiom,
    ! [VarCurr: state_type] :
      ( v28091(VarCurr)
    <=> v28093(VarCurr) ) ).

tff(addAssignment_15204,axiom,
    ! [VarCurr: state_type] :
      ( v28093(VarCurr)
    <=> v28095(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_98,axiom,
    ! [VarCurr: state_type] :
      ( v28095(VarCurr)
    <=> ( ( v28097(VarCurr,11)
        <=> v28101(VarCurr,11) )
        & ( v28097(VarCurr,10)
        <=> v28101(VarCurr,10) )
        & ( v28097(VarCurr,9)
        <=> v28101(VarCurr,9) )
        & ( v28097(VarCurr,8)
        <=> v28101(VarCurr,8) )
        & ( v28097(VarCurr,7)
        <=> v28101(VarCurr,7) )
        & ( v28097(VarCurr,6)
        <=> v28101(VarCurr,6) )
        & ( v28097(VarCurr,5)
        <=> v28101(VarCurr,5) )
        & ( v28097(VarCurr,4)
        <=> v28101(VarCurr,4) )
        & ( v28097(VarCurr,3)
        <=> v28101(VarCurr,3) )
        & ( v28097(VarCurr,2)
        <=> v28101(VarCurr,2) )
        & ( v28097(VarCurr,1)
        <=> v28101(VarCurr,1) )
        & ( v28097(VarCurr,0)
        <=> v28101(VarCurr,0) ) ) ) ).

tff(addAssignment_15203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28101(VarCurr,B)
      <=> v28103(VarCurr,B) ) ) ).

tff(addAssignment_15202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28103(VarCurr,B)
      <=> v28105(VarCurr,B) ) ) ).

tff(addAssignment_15201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28105(VarCurr,B)
      <=> v28107(VarCurr,B) ) ) ).

tff(addAssignment_15200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28107(VarCurr,B)
      <=> v28109(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28109(VarCurr,B)
      <=> ( v29617(VarCurr,B)
          | v29636(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29636(VarCurr,B)
      <=> ( v29488(VarCurr,B)
          & v29637(VarCurr,B) ) ) ) ).

tff(addAssignment_15199,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,0)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15198,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,1)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15197,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,2)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15196,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,3)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15195,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,4)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15194,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,5)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15193,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,6)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15192,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,7)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15191,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,8)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15190,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,9)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15189,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,10)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15188,axiom,
    ! [VarCurr: state_type] :
      ( v29637(VarCurr,11)
    <=> v29638(VarCurr) ) ).

tff(addAssignment_15187,axiom,
    ! [VarCurr: state_type] :
      ( v29638(VarCurr)
    <=> v29607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29617(VarCurr,B)
      <=> ( v29618(VarCurr,B)
          | v29633(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29633(VarCurr,B)
      <=> ( v29337(VarCurr,B)
          & v29634(VarCurr,B) ) ) ) ).

tff(addAssignment_15186,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,0)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15185,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,1)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15184,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,2)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15183,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,3)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15182,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,4)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15181,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,5)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15180,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,6)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15179,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,7)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15178,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,8)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15177,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,9)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15176,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,10)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15175,axiom,
    ! [VarCurr: state_type] :
      ( v29634(VarCurr,11)
    <=> v29635(VarCurr) ) ).

tff(addAssignment_15174,axiom,
    ! [VarCurr: state_type] :
      ( v29635(VarCurr)
    <=> v29457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29618(VarCurr,B)
      <=> ( v29619(VarCurr,B)
          | v29630(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29630(VarCurr,B)
      <=> ( v29186(VarCurr,B)
          & v29631(VarCurr,B) ) ) ) ).

tff(addAssignment_15173,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,0)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15172,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,1)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15171,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,2)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15170,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,3)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15169,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,4)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15168,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,5)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15167,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,6)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15166,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,7)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15165,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,8)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15164,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,9)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15163,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,10)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15162,axiom,
    ! [VarCurr: state_type] :
      ( v29631(VarCurr,11)
    <=> v29632(VarCurr) ) ).

tff(addAssignment_15161,axiom,
    ! [VarCurr: state_type] :
      ( v29632(VarCurr)
    <=> v29306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29619(VarCurr,B)
      <=> ( v29620(VarCurr,B)
          | v29627(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29627(VarCurr,B)
      <=> ( v29035(VarCurr,B)
          & v29628(VarCurr,B) ) ) ) ).

tff(addAssignment_15160,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,0)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15159,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,1)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15158,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,2)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15157,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,3)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15156,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,4)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15155,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,5)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15154,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,6)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15153,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,7)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15152,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,8)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15151,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,9)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15150,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,10)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15149,axiom,
    ! [VarCurr: state_type] :
      ( v29628(VarCurr,11)
    <=> v29629(VarCurr) ) ).

tff(addAssignment_15148,axiom,
    ! [VarCurr: state_type] :
      ( v29629(VarCurr)
    <=> v29155(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29620(VarCurr,B)
      <=> ( v29621(VarCurr,B)
          | v29624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29624(VarCurr,B)
      <=> ( v28873(VarCurr,B)
          & v29625(VarCurr,B) ) ) ) ).

tff(addAssignment_15147,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,0)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15146,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,1)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15145,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,2)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15144,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,3)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15143,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,4)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15142,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,5)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15141,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,6)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15140,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,7)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15139,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,8)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15138,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,9)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15137,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,10)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15136,axiom,
    ! [VarCurr: state_type] :
      ( v29625(VarCurr,11)
    <=> v29626(VarCurr) ) ).

tff(addAssignment_15135,axiom,
    ! [VarCurr: state_type] :
      ( v29626(VarCurr)
    <=> v29004(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29621(VarCurr,B)
      <=> ( v28111(VarCurr,B)
          & v29622(VarCurr,B) ) ) ) ).

tff(addAssignment_15134,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,0)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15133,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,1)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15132,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,2)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15131,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,3)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15130,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,4)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15129,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,5)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15128,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,6)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15127,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,7)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15126,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,8)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15125,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,9)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15124,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,10)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15123,axiom,
    ! [VarCurr: state_type] :
      ( v29622(VarCurr,11)
    <=> v29623(VarCurr) ) ).

tff(addAssignment_15122,axiom,
    ! [VarCurr: state_type] :
      ( v29623(VarCurr)
    <=> v28581(VarCurr) ) ).

tff(addAssignment_15121,axiom,
    ! [VarCurr: state_type] :
      ( v29607(VarCurr)
    <=> v29609(VarCurr) ) ).

tff(addAssignment_15120,axiom,
    ! [VarCurr: state_type] :
      ( v29609(VarCurr)
    <=> v29611(VarCurr) ) ).

tff(addAssignment_15119,axiom,
    ! [VarCurr: state_type] :
      ( v29611(VarCurr)
    <=> v29613(VarCurr) ) ).

tff(addAssignment_15118,axiom,
    ! [VarCurr: state_type] :
      ( v29613(VarCurr)
    <=> v29615(VarCurr) ) ).

tff(addAssignment_15117,axiom,
    ! [VarCurr: state_type] :
      ( v29615(VarCurr)
    <=> v28674(VarCurr) ) ).

tff(addAssignment_15116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29488(VarCurr,B)
      <=> v29490(VarCurr,B) ) ) ).

tff(addAssignment_15115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29490(VarCurr,B)
      <=> v29492(VarCurr,B) ) ) ).

tff(addAssignment_15114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29492(VarCurr,B)
      <=> v29494(VarCurr,B) ) ) ).

tff(addAssignment_15113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29494(VarCurr,B)
      <=> v29496(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_333,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29590(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v29496(VarNext,B)
            <=> v29496(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_333,axiom,
    ! [VarNext: state_type] :
      ( v29590(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29496(VarNext,B)
          <=> v29600(VarNext,B) ) ) ) ).

tff(addAssignment_15112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29600(VarNext,B)
          <=> v29598(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29598(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_199,axiom,
    ! [VarCurr: state_type] :
      ( v29601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29598(VarCurr,B)
          <=> v29518(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2420,axiom,
    ! [VarCurr: state_type] :
      ( v29601(VarCurr)
    <=> ( v29602(VarCurr)
        & v29603(VarCurr) ) ) ).

tff(writeUnaryOperator_1582,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29603(VarCurr)
    <=> v29508(VarCurr) ) ).

tff(writeUnaryOperator_1581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29602(VarCurr)
    <=> v29498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29590(VarNext)
      <=> v29591(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29591(VarNext)
      <=> ( v29592(VarNext)
          & v29522(VarNext) ) ) ) ).

tff(writeUnaryOperator_1580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29592(VarNext)
      <=> v29594(VarNext) ) ) ).

tff(addAssignment_15111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29594(VarNext)
      <=> v29522(VarCurr) ) ) ).

tff(addAssignment_15110,axiom,
    ! [VarCurr: state_type] :
      ( v29522(VarCurr)
    <=> v29524(VarCurr) ) ).

tff(addAssignment_15109,axiom,
    ! [VarCurr: state_type] :
      ( v29524(VarCurr)
    <=> v29526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2417,axiom,
    ! [VarCurr: state_type] :
      ( v29526(VarCurr)
    <=> ( v29587(VarCurr)
        | v29583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2416,axiom,
    ! [VarCurr: state_type] :
      ( v29587(VarCurr)
    <=> ( v29528(VarCurr)
        & v29532(VarCurr) ) ) ).

tff(addAssignment_15108,axiom,
    ! [VarCurr: state_type] :
      ( v29583(VarCurr)
    <=> v29585(VarCurr) ) ).

tff(addAssignment_15107,axiom,
    ! [VarCurr: state_type] :
      ( v29585(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29567(VarNext)
       => ( v29532(VarNext)
        <=> v29532(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_332,axiom,
    ! [VarNext: state_type] :
      ( v29567(VarNext)
     => ( v29532(VarNext)
      <=> v29577(VarNext) ) ) ).

tff(addAssignment_15106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29577(VarNext)
      <=> v29575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2415,axiom,
    ! [VarCurr: state_type] :
      ( v29575(VarCurr)
    <=> ( v29578(VarCurr)
        & v29579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2414,axiom,
    ! [VarCurr: state_type] :
      ( v29579(VarCurr)
    <=> ( v29538(VarCurr)
        | v29562(VarCurr) ) ) ).

tff(writeUnaryOperator_1579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29578(VarCurr)
    <=> v29534(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29567(VarNext)
      <=> v29568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2412,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29568(VarNext)
      <=> ( v29570(VarNext)
          & v29572(VarNext) ) ) ) ).

tff(writeUnaryOperator_1578,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29572(VarCurr)
    <=> v29528(VarCurr) ) ).

tff(addAssignment_15105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29570(VarNext)
      <=> v29528(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_128,axiom,
    ( v29532(constB0)
  <=> $true ) ).

tff(addAssignment_15104,axiom,
    ! [VarCurr: state_type] :
      ( v29562(VarCurr)
    <=> v29564(VarCurr) ) ).

tff(addAssignment_15103,axiom,
    ! [VarCurr: state_type] :
      ( v29564(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_15102,axiom,
    ! [VarCurr: state_type] :
      ( v29538(VarCurr)
    <=> v29540(VarCurr) ) ).

tff(addAssignment_15101,axiom,
    ! [VarCurr: state_type] :
      ( v29540(VarCurr)
    <=> v28848(VarCurr) ) ).

tff(addAssignment_15100,axiom,
    ! [VarCurr: state_type] :
      ( v28848(VarCurr)
    <=> v29543(VarCurr) ) ).

tff(addAssignment_15099,axiom,
    ! [VarCurr: state_type] :
      ( v29543(VarCurr)
    <=> v29545(VarCurr) ) ).

tff(writeUnaryOperator_1577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29545(VarCurr)
    <=> v29559(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2411,axiom,
    ! [VarCurr: state_type] :
      ( v29559(VarCurr)
    <=> ( v29560(VarCurr)
        | v29555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2410,axiom,
    ! [VarCurr: state_type] :
      ( v29560(VarCurr)
    <=> ( v29547(VarCurr)
        | v29551(VarCurr) ) ) ).

tff(addAssignment_15098,axiom,
    ! [VarCurr: state_type] :
      ( v29555(VarCurr)
    <=> v29557(VarCurr) ) ).

tff(addAssignment_15097,axiom,
    ! [VarCurr: state_type] :
      ( v29557(VarCurr)
    <=> v28937(VarCurr,2) ) ).

tff(addAssignment_15096,axiom,
    ! [VarCurr: state_type] :
      ( v29551(VarCurr)
    <=> v29553(VarCurr) ) ).

tff(addAssignment_15095,axiom,
    ! [VarCurr: state_type] :
      ( v29553(VarCurr)
    <=> v28511(VarCurr,1) ) ).

tff(addAssignment_15094,axiom,
    ! [VarCurr: state_type] :
      ( v29547(VarCurr)
    <=> v29549(VarCurr) ) ).

tff(addAssignment_15093,axiom,
    ! [VarCurr: state_type] :
      ( v29549(VarCurr)
    <=> v28937(VarCurr,0) ) ).

tff(addAssignment_15092,axiom,
    ! [VarCurr: state_type] :
      ( v29534(VarCurr)
    <=> v29536(VarCurr) ) ).

tff(addAssignment_15091,axiom,
    ! [VarCurr: state_type] :
      ( v29536(VarCurr)
    <=> $false ) ).

tff(addAssignment_15090,axiom,
    ! [VarCurr: state_type] :
      ( v29528(VarCurr)
    <=> v29530(VarCurr) ) ).

tff(addAssignment_15089,axiom,
    ! [VarCurr: state_type] :
      ( v29530(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_15088,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29518(VarCurr,B)
      <=> v29520(VarCurr,B) ) ) ).

tff(addAssignment_15087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29520(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_15086,axiom,
    ! [VarCurr: state_type] :
      ( v29508(VarCurr)
    <=> v29510(VarCurr) ) ).

tff(addAssignment_15085,axiom,
    ! [VarCurr: state_type] :
      ( v29510(VarCurr)
    <=> v29512(VarCurr) ) ).

tff(addAssignment_15084,axiom,
    ! [VarCurr: state_type] :
      ( v29512(VarCurr)
    <=> v29514(VarCurr) ) ).

tff(addAssignment_15083,axiom,
    ! [VarCurr: state_type] :
      ( v29514(VarCurr)
    <=> v29516(VarCurr) ) ).

tff(addAssignment_15082,axiom,
    ! [VarCurr: state_type] :
      ( v29516(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_15081,axiom,
    ! [VarCurr: state_type] :
      ( v29498(VarCurr)
    <=> v29500(VarCurr) ) ).

tff(addAssignment_15080,axiom,
    ! [VarCurr: state_type] :
      ( v29500(VarCurr)
    <=> v29502(VarCurr) ) ).

tff(addAssignment_15079,axiom,
    ! [VarCurr: state_type] :
      ( v29502(VarCurr)
    <=> v29504(VarCurr) ) ).

tff(addAssignment_15078,axiom,
    ! [VarCurr: state_type] :
      ( v29504(VarCurr)
    <=> v29506(VarCurr) ) ).

tff(addAssignment_15077,axiom,
    ! [VarCurr: state_type] :
      ( v29506(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_15076,axiom,
    ! [VarCurr: state_type] :
      ( v29457(VarCurr)
    <=> v29459(VarCurr) ) ).

tff(addAssignment_15075,axiom,
    ! [VarCurr: state_type] :
      ( v29459(VarCurr)
    <=> v29461(VarCurr) ) ).

tff(addAssignment_15074,axiom,
    ! [VarCurr: state_type] :
      ( v29461(VarCurr)
    <=> v29463(VarCurr) ) ).

tff(addAssignment_15073,axiom,
    ! [VarCurr: state_type] :
      ( v29463(VarCurr)
    <=> v29465(VarCurr) ) ).

tff(addAssignment_15072,axiom,
    ! [VarCurr: state_type] :
      ( v29465(VarCurr)
    <=> v29467(VarCurr) ) ).

tff(addAssignment_15071,axiom,
    ! [VarCurr: state_type] :
      ( v29467(VarCurr)
    <=> v29469(VarCurr) ) ).

tff(addAssignment_15070,axiom,
    ! [VarCurr: state_type] :
      ( v29469(VarCurr)
    <=> v29471(VarCurr) ) ).

tff(writeUnaryOperator_1576,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29471(VarCurr)
    <=> v29485(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2409,axiom,
    ! [VarCurr: state_type] :
      ( v29485(VarCurr)
    <=> ( v29486(VarCurr)
        | v29481(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2408,axiom,
    ! [VarCurr: state_type] :
      ( v29486(VarCurr)
    <=> ( v29473(VarCurr)
        | v29477(VarCurr) ) ) ).

tff(addAssignment_15069,axiom,
    ! [VarCurr: state_type] :
      ( v29481(VarCurr)
    <=> v29483(VarCurr) ) ).

tff(addAssignment_15068,axiom,
    ! [VarCurr: state_type] :
      ( v29483(VarCurr)
    <=> v28684(VarCurr,2) ) ).

tff(addAssignment_15067,axiom,
    ! [VarCurr: state_type] :
      ( v29477(VarCurr)
    <=> v29479(VarCurr) ) ).

tff(addAssignment_15066,axiom,
    ! [VarCurr: state_type] :
      ( v29479(VarCurr)
    <=> v28601(VarCurr,1) ) ).

tff(addAssignment_15065,axiom,
    ! [VarCurr: state_type] :
      ( v29473(VarCurr)
    <=> v29475(VarCurr) ) ).

tff(addAssignment_15064,axiom,
    ! [VarCurr: state_type] :
      ( v29475(VarCurr)
    <=> v28601(VarCurr,0) ) ).

tff(addAssignment_15063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29337(VarCurr,B)
      <=> v29339(VarCurr,B) ) ) ).

tff(addAssignment_15062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29339(VarCurr,B)
      <=> v29341(VarCurr,B) ) ) ).

tff(addAssignment_15061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29341(VarCurr,B)
      <=> v29343(VarCurr,B) ) ) ).

tff(addAssignment_15060,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29343(VarCurr,B)
      <=> v29345(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29440(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v29345(VarNext,B)
            <=> v29345(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_331,axiom,
    ! [VarNext: state_type] :
      ( v29440(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29345(VarNext,B)
          <=> v29450(VarNext,B) ) ) ) ).

tff(addAssignment_15059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29450(VarNext,B)
          <=> v29448(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29451(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29448(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_198,axiom,
    ! [VarCurr: state_type] :
      ( v29451(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29448(VarCurr,B)
          <=> v29367(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2407,axiom,
    ! [VarCurr: state_type] :
      ( v29451(VarCurr)
    <=> ( v29452(VarCurr)
        & v29453(VarCurr) ) ) ).

tff(writeUnaryOperator_1575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29453(VarCurr)
    <=> v29357(VarCurr) ) ).

tff(writeUnaryOperator_1574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29452(VarCurr)
    <=> v29347(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2406,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29440(VarNext)
      <=> v29441(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2405,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29441(VarNext)
      <=> ( v29442(VarNext)
          & v29371(VarNext) ) ) ) ).

tff(writeUnaryOperator_1573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29442(VarNext)
      <=> v29444(VarNext) ) ) ).

tff(addAssignment_15058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29444(VarNext)
      <=> v29371(VarCurr) ) ) ).

tff(addAssignment_15057,axiom,
    ! [VarCurr: state_type] :
      ( v29371(VarCurr)
    <=> v29373(VarCurr) ) ).

tff(addAssignment_15056,axiom,
    ! [VarCurr: state_type] :
      ( v29373(VarCurr)
    <=> v29375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2404,axiom,
    ! [VarCurr: state_type] :
      ( v29375(VarCurr)
    <=> ( v29437(VarCurr)
        | v29433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2403,axiom,
    ! [VarCurr: state_type] :
      ( v29437(VarCurr)
    <=> ( v29377(VarCurr)
        & v29381(VarCurr) ) ) ).

tff(addAssignment_15055,axiom,
    ! [VarCurr: state_type] :
      ( v29433(VarCurr)
    <=> v29435(VarCurr) ) ).

tff(addAssignment_15054,axiom,
    ! [VarCurr: state_type] :
      ( v29435(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29417(VarNext)
       => ( v29381(VarNext)
        <=> v29381(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_330,axiom,
    ! [VarNext: state_type] :
      ( v29417(VarNext)
     => ( v29381(VarNext)
      <=> v29427(VarNext) ) ) ).

tff(addAssignment_15053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29427(VarNext)
      <=> v29425(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2402,axiom,
    ! [VarCurr: state_type] :
      ( v29425(VarCurr)
    <=> ( v29428(VarCurr)
        & v29429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2401,axiom,
    ! [VarCurr: state_type] :
      ( v29429(VarCurr)
    <=> ( v29387(VarCurr)
        | v29412(VarCurr) ) ) ).

tff(writeUnaryOperator_1572,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29428(VarCurr)
    <=> v29383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29417(VarNext)
      <=> v29418(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29418(VarNext)
      <=> ( v29420(VarNext)
          & v29422(VarNext) ) ) ) ).

tff(writeUnaryOperator_1571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29422(VarCurr)
    <=> v29377(VarCurr) ) ).

tff(addAssignment_15052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29420(VarNext)
      <=> v29377(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_127,axiom,
    ( v29381(constB0)
  <=> $true ) ).

tff(addAssignment_15051,axiom,
    ! [VarCurr: state_type] :
      ( v29412(VarCurr)
    <=> v29414(VarCurr) ) ).

tff(addAssignment_15050,axiom,
    ! [VarCurr: state_type] :
      ( v29414(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_15049,axiom,
    ! [VarCurr: state_type] :
      ( v29387(VarCurr)
    <=> v29389(VarCurr) ) ).

tff(addAssignment_15048,axiom,
    ! [VarCurr: state_type] :
      ( v29389(VarCurr)
    <=> v29391(VarCurr) ) ).

tff(addAssignment_15047,axiom,
    ! [VarCurr: state_type] :
      ( v29391(VarCurr)
    <=> v29393(VarCurr) ) ).

tff(addAssignment_15046,axiom,
    ! [VarCurr: state_type] :
      ( v29393(VarCurr)
    <=> v29395(VarCurr) ) ).

tff(writeUnaryOperator_1570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29395(VarCurr)
    <=> v29409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2398,axiom,
    ! [VarCurr: state_type] :
      ( v29409(VarCurr)
    <=> ( v29410(VarCurr)
        | v29405(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2397,axiom,
    ! [VarCurr: state_type] :
      ( v29410(VarCurr)
    <=> ( v29397(VarCurr)
        | v29401(VarCurr) ) ) ).

tff(addAssignment_15045,axiom,
    ! [VarCurr: state_type] :
      ( v29405(VarCurr)
    <=> v29407(VarCurr) ) ).

tff(addAssignment_15044,axiom,
    ! [VarCurr: state_type] :
      ( v29407(VarCurr)
    <=> v28937(VarCurr,2) ) ).

tff(addAssignment_15043,axiom,
    ! [VarCurr: state_type] :
      ( v28937(VarCurr,2)
    <=> v28939(VarCurr,2) ) ).

tff(addAssignment_15042,axiom,
    ! [VarCurr: state_type] :
      ( v28939(VarCurr,2)
    <=> v28941(VarCurr,2) ) ).

tff(addAssignment_15041,axiom,
    ! [VarCurr: state_type] :
      ( v28941(VarCurr,2)
    <=> v28946(VarCurr,2) ) ).

tff(addAssignment_15040,axiom,
    ! [VarCurr: state_type] :
      ( v28943(VarCurr,2)
    <=> v28945(VarCurr,2) ) ).

tff(addAssignment_15039,axiom,
    ! [VarCurr: state_type] :
      ( v28945(VarCurr,2)
    <=> v28511(VarCurr,2) ) ).

tff(addAssignment_15038,axiom,
    ! [VarCurr: state_type] :
      ( v29401(VarCurr)
    <=> v29403(VarCurr) ) ).

tff(addAssignment_15037,axiom,
    ! [VarCurr: state_type] :
      ( v29403(VarCurr)
    <=> v28511(VarCurr,1) ) ).

tff(addAssignment_15036,axiom,
    ! [VarCurr: state_type] :
      ( v29397(VarCurr)
    <=> v29399(VarCurr) ) ).

tff(addAssignment_15035,axiom,
    ! [VarCurr: state_type] :
      ( v29399(VarCurr)
    <=> v28511(VarCurr,0) ) ).

tff(addAssignment_15034,axiom,
    ! [VarCurr: state_type] :
      ( v29383(VarCurr)
    <=> v29385(VarCurr) ) ).

tff(addAssignment_15033,axiom,
    ! [VarCurr: state_type] :
      ( v29385(VarCurr)
    <=> $false ) ).

tff(addAssignment_15032,axiom,
    ! [VarCurr: state_type] :
      ( v29377(VarCurr)
    <=> v29379(VarCurr) ) ).

tff(addAssignment_15031,axiom,
    ! [VarCurr: state_type] :
      ( v29379(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_15030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29367(VarCurr,B)
      <=> v29369(VarCurr,B) ) ) ).

tff(addAssignment_15029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29369(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_15028,axiom,
    ! [VarCurr: state_type] :
      ( v29357(VarCurr)
    <=> v29359(VarCurr) ) ).

tff(addAssignment_15027,axiom,
    ! [VarCurr: state_type] :
      ( v29359(VarCurr)
    <=> v29361(VarCurr) ) ).

tff(addAssignment_15026,axiom,
    ! [VarCurr: state_type] :
      ( v29361(VarCurr)
    <=> v29363(VarCurr) ) ).

tff(addAssignment_15025,axiom,
    ! [VarCurr: state_type] :
      ( v29363(VarCurr)
    <=> v29365(VarCurr) ) ).

tff(addAssignment_15024,axiom,
    ! [VarCurr: state_type] :
      ( v29365(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_15023,axiom,
    ! [VarCurr: state_type] :
      ( v29347(VarCurr)
    <=> v29349(VarCurr) ) ).

tff(addAssignment_15022,axiom,
    ! [VarCurr: state_type] :
      ( v29349(VarCurr)
    <=> v29351(VarCurr) ) ).

tff(addAssignment_15021,axiom,
    ! [VarCurr: state_type] :
      ( v29351(VarCurr)
    <=> v29353(VarCurr) ) ).

tff(addAssignment_15020,axiom,
    ! [VarCurr: state_type] :
      ( v29353(VarCurr)
    <=> v29355(VarCurr) ) ).

tff(addAssignment_15019,axiom,
    ! [VarCurr: state_type] :
      ( v29355(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_15018,axiom,
    ! [VarCurr: state_type] :
      ( v29306(VarCurr)
    <=> v29308(VarCurr) ) ).

tff(addAssignment_15017,axiom,
    ! [VarCurr: state_type] :
      ( v29308(VarCurr)
    <=> v29310(VarCurr) ) ).

tff(addAssignment_15016,axiom,
    ! [VarCurr: state_type] :
      ( v29310(VarCurr)
    <=> v29312(VarCurr) ) ).

tff(addAssignment_15015,axiom,
    ! [VarCurr: state_type] :
      ( v29312(VarCurr)
    <=> v29314(VarCurr) ) ).

tff(addAssignment_15014,axiom,
    ! [VarCurr: state_type] :
      ( v29314(VarCurr)
    <=> v29316(VarCurr) ) ).

tff(addAssignment_15013,axiom,
    ! [VarCurr: state_type] :
      ( v29316(VarCurr)
    <=> v29318(VarCurr) ) ).

tff(addAssignment_15012,axiom,
    ! [VarCurr: state_type] :
      ( v29318(VarCurr)
    <=> v29320(VarCurr) ) ).

tff(writeUnaryOperator_1569,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29320(VarCurr)
    <=> v29334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2396,axiom,
    ! [VarCurr: state_type] :
      ( v29334(VarCurr)
    <=> ( v29335(VarCurr)
        | v29330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2395,axiom,
    ! [VarCurr: state_type] :
      ( v29335(VarCurr)
    <=> ( v29322(VarCurr)
        | v29326(VarCurr) ) ) ).

tff(addAssignment_15011,axiom,
    ! [VarCurr: state_type] :
      ( v29330(VarCurr)
    <=> v29332(VarCurr) ) ).

tff(addAssignment_15010,axiom,
    ! [VarCurr: state_type] :
      ( v29332(VarCurr)
    <=> v28601(VarCurr,2) ) ).

tff(addAssignment_15009,axiom,
    ! [VarCurr: state_type] :
      ( v29326(VarCurr)
    <=> v29328(VarCurr) ) ).

tff(addAssignment_15008,axiom,
    ! [VarCurr: state_type] :
      ( v29328(VarCurr)
    <=> v28684(VarCurr,1) ) ).

tff(addAssignment_15007,axiom,
    ! [VarCurr: state_type] :
      ( v29322(VarCurr)
    <=> v29324(VarCurr) ) ).

tff(addAssignment_15006,axiom,
    ! [VarCurr: state_type] :
      ( v29324(VarCurr)
    <=> v28684(VarCurr,0) ) ).

tff(addAssignment_15005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29186(VarCurr,B)
      <=> v29188(VarCurr,B) ) ) ).

tff(addAssignment_15004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29188(VarCurr,B)
      <=> v29190(VarCurr,B) ) ) ).

tff(addAssignment_15003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29190(VarCurr,B)
      <=> v29192(VarCurr,B) ) ) ).

tff(addAssignment_15002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29192(VarCurr,B)
      <=> v29194(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29289(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v29194(VarNext,B)
            <=> v29194(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_329,axiom,
    ! [VarNext: state_type] :
      ( v29289(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29194(VarNext,B)
          <=> v29299(VarNext,B) ) ) ) ).

tff(addAssignment_15001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29299(VarNext,B)
          <=> v29297(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29300(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29297(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_197,axiom,
    ! [VarCurr: state_type] :
      ( v29300(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29297(VarCurr,B)
          <=> v29216(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2394,axiom,
    ! [VarCurr: state_type] :
      ( v29300(VarCurr)
    <=> ( v29301(VarCurr)
        & v29302(VarCurr) ) ) ).

tff(writeUnaryOperator_1568,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29302(VarCurr)
    <=> v29206(VarCurr) ) ).

tff(writeUnaryOperator_1567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29301(VarCurr)
    <=> v29196(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29289(VarNext)
      <=> v29290(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2392,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29290(VarNext)
      <=> ( v29291(VarNext)
          & v29220(VarNext) ) ) ) ).

tff(writeUnaryOperator_1566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29291(VarNext)
      <=> v29293(VarNext) ) ) ).

tff(addAssignment_15000,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29293(VarNext)
      <=> v29220(VarCurr) ) ) ).

tff(addAssignment_14999,axiom,
    ! [VarCurr: state_type] :
      ( v29220(VarCurr)
    <=> v29222(VarCurr) ) ).

tff(addAssignment_14998,axiom,
    ! [VarCurr: state_type] :
      ( v29222(VarCurr)
    <=> v29224(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2391,axiom,
    ! [VarCurr: state_type] :
      ( v29224(VarCurr)
    <=> ( v29286(VarCurr)
        | v29282(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2390,axiom,
    ! [VarCurr: state_type] :
      ( v29286(VarCurr)
    <=> ( v29226(VarCurr)
        & v29230(VarCurr) ) ) ).

tff(addAssignment_14997,axiom,
    ! [VarCurr: state_type] :
      ( v29282(VarCurr)
    <=> v29284(VarCurr) ) ).

tff(addAssignment_14996,axiom,
    ! [VarCurr: state_type] :
      ( v29284(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29266(VarNext)
       => ( v29230(VarNext)
        <=> v29230(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_328,axiom,
    ! [VarNext: state_type] :
      ( v29266(VarNext)
     => ( v29230(VarNext)
      <=> v29276(VarNext) ) ) ).

tff(addAssignment_14995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29276(VarNext)
      <=> v29274(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2389,axiom,
    ! [VarCurr: state_type] :
      ( v29274(VarCurr)
    <=> ( v29277(VarCurr)
        & v29278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2388,axiom,
    ! [VarCurr: state_type] :
      ( v29278(VarCurr)
    <=> ( v29236(VarCurr)
        | v29261(VarCurr) ) ) ).

tff(writeUnaryOperator_1565,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29277(VarCurr)
    <=> v29232(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29266(VarNext)
      <=> v29267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29267(VarNext)
      <=> ( v29269(VarNext)
          & v29271(VarNext) ) ) ) ).

tff(writeUnaryOperator_1564,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29271(VarCurr)
    <=> v29226(VarCurr) ) ).

tff(addAssignment_14994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29269(VarNext)
      <=> v29226(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_126,axiom,
    ( v29230(constB0)
  <=> $true ) ).

tff(addAssignment_14993,axiom,
    ! [VarCurr: state_type] :
      ( v29261(VarCurr)
    <=> v29263(VarCurr) ) ).

tff(addAssignment_14992,axiom,
    ! [VarCurr: state_type] :
      ( v29263(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_14991,axiom,
    ! [VarCurr: state_type] :
      ( v29236(VarCurr)
    <=> v29238(VarCurr) ) ).

tff(addAssignment_14990,axiom,
    ! [VarCurr: state_type] :
      ( v29238(VarCurr)
    <=> v29240(VarCurr) ) ).

tff(addAssignment_14989,axiom,
    ! [VarCurr: state_type] :
      ( v29240(VarCurr)
    <=> v29242(VarCurr) ) ).

tff(addAssignment_14988,axiom,
    ! [VarCurr: state_type] :
      ( v29242(VarCurr)
    <=> v29244(VarCurr) ) ).

tff(writeUnaryOperator_1563,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29244(VarCurr)
    <=> v29258(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2385,axiom,
    ! [VarCurr: state_type] :
      ( v29258(VarCurr)
    <=> ( v29259(VarCurr)
        | v29254(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2384,axiom,
    ! [VarCurr: state_type] :
      ( v29259(VarCurr)
    <=> ( v29246(VarCurr)
        | v29250(VarCurr) ) ) ).

tff(addAssignment_14987,axiom,
    ! [VarCurr: state_type] :
      ( v29254(VarCurr)
    <=> v29256(VarCurr) ) ).

tff(addAssignment_14986,axiom,
    ! [VarCurr: state_type] :
      ( v29256(VarCurr)
    <=> v28511(VarCurr,2) ) ).

tff(addAssignment_14985,axiom,
    ! [VarCurr: state_type] :
      ( v29250(VarCurr)
    <=> v29252(VarCurr) ) ).

tff(addAssignment_14984,axiom,
    ! [VarCurr: state_type] :
      ( v29252(VarCurr)
    <=> v28937(VarCurr,1) ) ).

tff(addAssignment_14983,axiom,
    ! [VarCurr: state_type] :
      ( v29246(VarCurr)
    <=> v29248(VarCurr) ) ).

tff(addAssignment_14982,axiom,
    ! [VarCurr: state_type] :
      ( v29248(VarCurr)
    <=> v28937(VarCurr,0) ) ).

tff(addAssignment_14981,axiom,
    ! [VarCurr: state_type] :
      ( v29232(VarCurr)
    <=> v29234(VarCurr) ) ).

tff(addAssignment_14980,axiom,
    ! [VarCurr: state_type] :
      ( v29234(VarCurr)
    <=> $false ) ).

tff(addAssignment_14979,axiom,
    ! [VarCurr: state_type] :
      ( v29226(VarCurr)
    <=> v29228(VarCurr) ) ).

tff(addAssignment_14978,axiom,
    ! [VarCurr: state_type] :
      ( v29228(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_14977,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29216(VarCurr,B)
      <=> v29218(VarCurr,B) ) ) ).

tff(addAssignment_14976,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29218(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_14975,axiom,
    ! [VarCurr: state_type] :
      ( v29206(VarCurr)
    <=> v29208(VarCurr) ) ).

tff(addAssignment_14974,axiom,
    ! [VarCurr: state_type] :
      ( v29208(VarCurr)
    <=> v29210(VarCurr) ) ).

tff(addAssignment_14973,axiom,
    ! [VarCurr: state_type] :
      ( v29210(VarCurr)
    <=> v29212(VarCurr) ) ).

tff(addAssignment_14972,axiom,
    ! [VarCurr: state_type] :
      ( v29212(VarCurr)
    <=> v29214(VarCurr) ) ).

tff(addAssignment_14971,axiom,
    ! [VarCurr: state_type] :
      ( v29214(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_14970,axiom,
    ! [VarCurr: state_type] :
      ( v29196(VarCurr)
    <=> v29198(VarCurr) ) ).

tff(addAssignment_14969,axiom,
    ! [VarCurr: state_type] :
      ( v29198(VarCurr)
    <=> v29200(VarCurr) ) ).

tff(addAssignment_14968,axiom,
    ! [VarCurr: state_type] :
      ( v29200(VarCurr)
    <=> v29202(VarCurr) ) ).

tff(addAssignment_14967,axiom,
    ! [VarCurr: state_type] :
      ( v29202(VarCurr)
    <=> v29204(VarCurr) ) ).

tff(addAssignment_14966,axiom,
    ! [VarCurr: state_type] :
      ( v29204(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_14965,axiom,
    ! [VarCurr: state_type] :
      ( v29155(VarCurr)
    <=> v29157(VarCurr) ) ).

tff(addAssignment_14964,axiom,
    ! [VarCurr: state_type] :
      ( v29157(VarCurr)
    <=> v29159(VarCurr) ) ).

tff(addAssignment_14963,axiom,
    ! [VarCurr: state_type] :
      ( v29159(VarCurr)
    <=> v29161(VarCurr) ) ).

tff(addAssignment_14962,axiom,
    ! [VarCurr: state_type] :
      ( v29161(VarCurr)
    <=> v29163(VarCurr) ) ).

tff(addAssignment_14961,axiom,
    ! [VarCurr: state_type] :
      ( v29163(VarCurr)
    <=> v29165(VarCurr) ) ).

tff(addAssignment_14960,axiom,
    ! [VarCurr: state_type] :
      ( v29165(VarCurr)
    <=> v29167(VarCurr) ) ).

tff(addAssignment_14959,axiom,
    ! [VarCurr: state_type] :
      ( v29167(VarCurr)
    <=> v29169(VarCurr) ) ).

tff(writeUnaryOperator_1562,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29169(VarCurr)
    <=> v29183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2383,axiom,
    ! [VarCurr: state_type] :
      ( v29183(VarCurr)
    <=> ( v29184(VarCurr)
        | v29179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2382,axiom,
    ! [VarCurr: state_type] :
      ( v29184(VarCurr)
    <=> ( v29171(VarCurr)
        | v29175(VarCurr) ) ) ).

tff(addAssignment_14958,axiom,
    ! [VarCurr: state_type] :
      ( v29179(VarCurr)
    <=> v29181(VarCurr) ) ).

tff(addAssignment_14957,axiom,
    ! [VarCurr: state_type] :
      ( v29181(VarCurr)
    <=> v28601(VarCurr,2) ) ).

tff(addAssignment_14956,axiom,
    ! [VarCurr: state_type] :
      ( v29175(VarCurr)
    <=> v29177(VarCurr) ) ).

tff(addAssignment_14955,axiom,
    ! [VarCurr: state_type] :
      ( v29177(VarCurr)
    <=> v28684(VarCurr,1) ) ).

tff(addAssignment_14954,axiom,
    ! [VarCurr: state_type] :
      ( v28684(VarCurr,1)
    <=> v28686(VarCurr,1) ) ).

tff(addAssignment_14953,axiom,
    ! [VarCurr: state_type] :
      ( v28686(VarCurr,1)
    <=> v28688(VarCurr,1) ) ).

tff(addAssignment_14952,axiom,
    ! [VarCurr: state_type] :
      ( v28688(VarCurr,1)
    <=> v28693(VarCurr,1) ) ).

tff(addAssignment_14951,axiom,
    ! [VarCurr: state_type] :
      ( v28690(VarCurr,1)
    <=> v28692(VarCurr,1) ) ).

tff(addAssignment_14950,axiom,
    ! [VarCurr: state_type] :
      ( v28692(VarCurr,1)
    <=> v28601(VarCurr,1) ) ).

tff(addAssignment_14949,axiom,
    ! [VarCurr: state_type] :
      ( v29171(VarCurr)
    <=> v29173(VarCurr) ) ).

tff(addAssignment_14948,axiom,
    ! [VarCurr: state_type] :
      ( v29173(VarCurr)
    <=> v28601(VarCurr,0) ) ).

tff(addAssignment_14947,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29035(VarCurr,B)
      <=> v29037(VarCurr,B) ) ) ).

tff(addAssignment_14946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29037(VarCurr,B)
      <=> v29039(VarCurr,B) ) ) ).

tff(addAssignment_14945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29039(VarCurr,B)
      <=> v29041(VarCurr,B) ) ) ).

tff(addAssignment_14944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29041(VarCurr,B)
      <=> v29043(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_327,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29138(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v29043(VarNext,B)
            <=> v29043(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_327,axiom,
    ! [VarNext: state_type] :
      ( v29138(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29043(VarNext,B)
          <=> v29148(VarNext,B) ) ) ) ).

tff(addAssignment_14943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29148(VarNext,B)
          <=> v29146(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29146(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_196,axiom,
    ! [VarCurr: state_type] :
      ( v29149(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v29146(VarCurr,B)
          <=> v29065(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2381,axiom,
    ! [VarCurr: state_type] :
      ( v29149(VarCurr)
    <=> ( v29150(VarCurr)
        & v29151(VarCurr) ) ) ).

tff(writeUnaryOperator_1561,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29151(VarCurr)
    <=> v29055(VarCurr) ) ).

tff(writeUnaryOperator_1560,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29150(VarCurr)
    <=> v29045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29138(VarNext)
      <=> v29139(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2379,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29139(VarNext)
      <=> ( v29140(VarNext)
          & v29069(VarNext) ) ) ) ).

tff(writeUnaryOperator_1559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29140(VarNext)
      <=> v29142(VarNext) ) ) ).

tff(addAssignment_14942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29142(VarNext)
      <=> v29069(VarCurr) ) ) ).

tff(addAssignment_14941,axiom,
    ! [VarCurr: state_type] :
      ( v29069(VarCurr)
    <=> v29071(VarCurr) ) ).

tff(addAssignment_14940,axiom,
    ! [VarCurr: state_type] :
      ( v29071(VarCurr)
    <=> v29073(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2378,axiom,
    ! [VarCurr: state_type] :
      ( v29073(VarCurr)
    <=> ( v29135(VarCurr)
        | v29131(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2377,axiom,
    ! [VarCurr: state_type] :
      ( v29135(VarCurr)
    <=> ( v29075(VarCurr)
        & v29079(VarCurr) ) ) ).

tff(addAssignment_14939,axiom,
    ! [VarCurr: state_type] :
      ( v29131(VarCurr)
    <=> v29133(VarCurr) ) ).

tff(addAssignment_14938,axiom,
    ! [VarCurr: state_type] :
      ( v29133(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v29115(VarNext)
       => ( v29079(VarNext)
        <=> v29079(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_326,axiom,
    ! [VarNext: state_type] :
      ( v29115(VarNext)
     => ( v29079(VarNext)
      <=> v29125(VarNext) ) ) ).

tff(addAssignment_14937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29125(VarNext)
      <=> v29123(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2376,axiom,
    ! [VarCurr: state_type] :
      ( v29123(VarCurr)
    <=> ( v29126(VarCurr)
        & v29127(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2375,axiom,
    ! [VarCurr: state_type] :
      ( v29127(VarCurr)
    <=> ( v29085(VarCurr)
        | v29110(VarCurr) ) ) ).

tff(writeUnaryOperator_1558,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29126(VarCurr)
    <=> v29081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29115(VarNext)
      <=> v29116(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29116(VarNext)
      <=> ( v29118(VarNext)
          & v29120(VarNext) ) ) ) ).

tff(writeUnaryOperator_1557,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29120(VarCurr)
    <=> v29075(VarCurr) ) ).

tff(addAssignment_14936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v29118(VarNext)
      <=> v29075(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_125,axiom,
    ( v29079(constB0)
  <=> $true ) ).

tff(addAssignment_14935,axiom,
    ! [VarCurr: state_type] :
      ( v29110(VarCurr)
    <=> v29112(VarCurr) ) ).

tff(addAssignment_14934,axiom,
    ! [VarCurr: state_type] :
      ( v29112(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_14933,axiom,
    ! [VarCurr: state_type] :
      ( v29085(VarCurr)
    <=> v29087(VarCurr) ) ).

tff(addAssignment_14932,axiom,
    ! [VarCurr: state_type] :
      ( v29087(VarCurr)
    <=> v29089(VarCurr) ) ).

tff(addAssignment_14931,axiom,
    ! [VarCurr: state_type] :
      ( v29089(VarCurr)
    <=> v29091(VarCurr) ) ).

tff(addAssignment_14930,axiom,
    ! [VarCurr: state_type] :
      ( v29091(VarCurr)
    <=> v29093(VarCurr) ) ).

tff(writeUnaryOperator_1556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29093(VarCurr)
    <=> v29107(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2372,axiom,
    ! [VarCurr: state_type] :
      ( v29107(VarCurr)
    <=> ( v29108(VarCurr)
        | v29103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2371,axiom,
    ! [VarCurr: state_type] :
      ( v29108(VarCurr)
    <=> ( v29095(VarCurr)
        | v29099(VarCurr) ) ) ).

tff(addAssignment_14929,axiom,
    ! [VarCurr: state_type] :
      ( v29103(VarCurr)
    <=> v29105(VarCurr) ) ).

tff(addAssignment_14928,axiom,
    ! [VarCurr: state_type] :
      ( v29105(VarCurr)
    <=> v28511(VarCurr,2) ) ).

tff(addAssignment_14927,axiom,
    ! [VarCurr: state_type] :
      ( v29099(VarCurr)
    <=> v29101(VarCurr) ) ).

tff(addAssignment_14926,axiom,
    ! [VarCurr: state_type] :
      ( v29101(VarCurr)
    <=> v28937(VarCurr,1) ) ).

tff(addAssignment_14925,axiom,
    ! [VarCurr: state_type] :
      ( v28937(VarCurr,1)
    <=> v28939(VarCurr,1) ) ).

tff(addAssignment_14924,axiom,
    ! [VarCurr: state_type] :
      ( v28939(VarCurr,1)
    <=> v28941(VarCurr,1) ) ).

tff(addAssignment_14923,axiom,
    ! [VarCurr: state_type] :
      ( v28941(VarCurr,1)
    <=> v28946(VarCurr,1) ) ).

tff(addAssignment_14922,axiom,
    ! [VarCurr: state_type] :
      ( v28943(VarCurr,1)
    <=> v28945(VarCurr,1) ) ).

tff(addAssignment_14921,axiom,
    ! [VarCurr: state_type] :
      ( v28945(VarCurr,1)
    <=> v28511(VarCurr,1) ) ).

tff(addAssignment_14920,axiom,
    ! [VarCurr: state_type] :
      ( v29095(VarCurr)
    <=> v29097(VarCurr) ) ).

tff(addAssignment_14919,axiom,
    ! [VarCurr: state_type] :
      ( v29097(VarCurr)
    <=> v28511(VarCurr,0) ) ).

tff(addAssignment_14918,axiom,
    ! [VarCurr: state_type] :
      ( v29081(VarCurr)
    <=> v29083(VarCurr) ) ).

tff(addAssignment_14917,axiom,
    ! [VarCurr: state_type] :
      ( v29083(VarCurr)
    <=> $false ) ).

tff(addAssignment_14916,axiom,
    ! [VarCurr: state_type] :
      ( v29075(VarCurr)
    <=> v29077(VarCurr) ) ).

tff(addAssignment_14915,axiom,
    ! [VarCurr: state_type] :
      ( v29077(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_14914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29065(VarCurr,B)
      <=> v29067(VarCurr,B) ) ) ).

tff(addAssignment_14913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v29067(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_14912,axiom,
    ! [VarCurr: state_type] :
      ( v29055(VarCurr)
    <=> v29057(VarCurr) ) ).

tff(addAssignment_14911,axiom,
    ! [VarCurr: state_type] :
      ( v29057(VarCurr)
    <=> v29059(VarCurr) ) ).

tff(addAssignment_14910,axiom,
    ! [VarCurr: state_type] :
      ( v29059(VarCurr)
    <=> v29061(VarCurr) ) ).

tff(addAssignment_14909,axiom,
    ! [VarCurr: state_type] :
      ( v29061(VarCurr)
    <=> v29063(VarCurr) ) ).

tff(addAssignment_14908,axiom,
    ! [VarCurr: state_type] :
      ( v29063(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_14907,axiom,
    ! [VarCurr: state_type] :
      ( v29045(VarCurr)
    <=> v29047(VarCurr) ) ).

tff(addAssignment_14906,axiom,
    ! [VarCurr: state_type] :
      ( v29047(VarCurr)
    <=> v29049(VarCurr) ) ).

tff(addAssignment_14905,axiom,
    ! [VarCurr: state_type] :
      ( v29049(VarCurr)
    <=> v29051(VarCurr) ) ).

tff(addAssignment_14904,axiom,
    ! [VarCurr: state_type] :
      ( v29051(VarCurr)
    <=> v29053(VarCurr) ) ).

tff(addAssignment_14903,axiom,
    ! [VarCurr: state_type] :
      ( v29053(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_14902,axiom,
    ! [VarCurr: state_type] :
      ( v29004(VarCurr)
    <=> v29006(VarCurr) ) ).

tff(addAssignment_14901,axiom,
    ! [VarCurr: state_type] :
      ( v29006(VarCurr)
    <=> v29008(VarCurr) ) ).

tff(addAssignment_14900,axiom,
    ! [VarCurr: state_type] :
      ( v29008(VarCurr)
    <=> v29010(VarCurr) ) ).

tff(addAssignment_14899,axiom,
    ! [VarCurr: state_type] :
      ( v29010(VarCurr)
    <=> v29012(VarCurr) ) ).

tff(addAssignment_14898,axiom,
    ! [VarCurr: state_type] :
      ( v29012(VarCurr)
    <=> v29014(VarCurr) ) ).

tff(addAssignment_14897,axiom,
    ! [VarCurr: state_type] :
      ( v29014(VarCurr)
    <=> v29016(VarCurr) ) ).

tff(addAssignment_14896,axiom,
    ! [VarCurr: state_type] :
      ( v29016(VarCurr)
    <=> v29018(VarCurr) ) ).

tff(writeUnaryOperator_1555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29018(VarCurr)
    <=> v29032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2370,axiom,
    ! [VarCurr: state_type] :
      ( v29032(VarCurr)
    <=> ( v29033(VarCurr)
        | v29028(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2369,axiom,
    ! [VarCurr: state_type] :
      ( v29033(VarCurr)
    <=> ( v29020(VarCurr)
        | v29024(VarCurr) ) ) ).

tff(addAssignment_14895,axiom,
    ! [VarCurr: state_type] :
      ( v29028(VarCurr)
    <=> v29030(VarCurr) ) ).

tff(addAssignment_14894,axiom,
    ! [VarCurr: state_type] :
      ( v29030(VarCurr)
    <=> v28601(VarCurr,2) ) ).

tff(addAssignment_14893,axiom,
    ! [VarCurr: state_type] :
      ( v29024(VarCurr)
    <=> v29026(VarCurr) ) ).

tff(addAssignment_14892,axiom,
    ! [VarCurr: state_type] :
      ( v29026(VarCurr)
    <=> v28601(VarCurr,1) ) ).

tff(addAssignment_14891,axiom,
    ! [VarCurr: state_type] :
      ( v29020(VarCurr)
    <=> v29022(VarCurr) ) ).

tff(addAssignment_14890,axiom,
    ! [VarCurr: state_type] :
      ( v29022(VarCurr)
    <=> v28684(VarCurr,0) ) ).

tff(addAssignment_14889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28873(VarCurr,B)
      <=> v28875(VarCurr,B) ) ) ).

tff(addAssignment_14888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28875(VarCurr,B)
      <=> v28877(VarCurr,B) ) ) ).

tff(addAssignment_14887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28877(VarCurr,B)
      <=> v28879(VarCurr,B) ) ) ).

tff(addAssignment_14886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28879(VarCurr,B)
      <=> v28881(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28987(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v28881(VarNext,B)
            <=> v28881(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_325,axiom,
    ! [VarNext: state_type] :
      ( v28987(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28881(VarNext,B)
          <=> v28997(VarNext,B) ) ) ) ).

tff(addAssignment_14885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28997(VarNext,B)
          <=> v28995(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28998(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28995(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_195,axiom,
    ! [VarCurr: state_type] :
      ( v28998(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28995(VarCurr,B)
          <=> v28903(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2368,axiom,
    ! [VarCurr: state_type] :
      ( v28998(VarCurr)
    <=> ( v28999(VarCurr)
        & v29000(VarCurr) ) ) ).

tff(writeUnaryOperator_1554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v29000(VarCurr)
    <=> v28893(VarCurr) ) ).

tff(writeUnaryOperator_1553,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28999(VarCurr)
    <=> v28883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28987(VarNext)
      <=> v28988(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28988(VarNext)
      <=> ( v28989(VarNext)
          & v28907(VarNext) ) ) ) ).

tff(writeUnaryOperator_1552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28989(VarNext)
      <=> v28991(VarNext) ) ) ).

tff(addAssignment_14884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28991(VarNext)
      <=> v28907(VarCurr) ) ) ).

tff(addAssignment_14883,axiom,
    ! [VarCurr: state_type] :
      ( v28907(VarCurr)
    <=> v28909(VarCurr) ) ).

tff(addAssignment_14882,axiom,
    ! [VarCurr: state_type] :
      ( v28909(VarCurr)
    <=> v28911(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2365,axiom,
    ! [VarCurr: state_type] :
      ( v28911(VarCurr)
    <=> ( v28984(VarCurr)
        | v28980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2364,axiom,
    ! [VarCurr: state_type] :
      ( v28984(VarCurr)
    <=> ( v28913(VarCurr)
        & v28917(VarCurr) ) ) ).

tff(addAssignment_14881,axiom,
    ! [VarCurr: state_type] :
      ( v28980(VarCurr)
    <=> v28982(VarCurr) ) ).

tff(addAssignment_14880,axiom,
    ! [VarCurr: state_type] :
      ( v28982(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28964(VarNext)
       => ( v28917(VarNext)
        <=> v28917(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_324,axiom,
    ! [VarNext: state_type] :
      ( v28964(VarNext)
     => ( v28917(VarNext)
      <=> v28974(VarNext) ) ) ).

tff(addAssignment_14879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28974(VarNext)
      <=> v28972(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2363,axiom,
    ! [VarCurr: state_type] :
      ( v28972(VarCurr)
    <=> ( v28975(VarCurr)
        & v28976(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2362,axiom,
    ! [VarCurr: state_type] :
      ( v28976(VarCurr)
    <=> ( v28923(VarCurr)
        | v28959(VarCurr) ) ) ).

tff(writeUnaryOperator_1551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28975(VarCurr)
    <=> v28919(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28964(VarNext)
      <=> v28965(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2360,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28965(VarNext)
      <=> ( v28967(VarNext)
          & v28969(VarNext) ) ) ) ).

tff(writeUnaryOperator_1550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28969(VarCurr)
    <=> v28913(VarCurr) ) ).

tff(addAssignment_14878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28967(VarNext)
      <=> v28913(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_124,axiom,
    ( v28917(constB0)
  <=> $true ) ).

tff(addAssignment_14877,axiom,
    ! [VarCurr: state_type] :
      ( v28959(VarCurr)
    <=> v28961(VarCurr) ) ).

tff(addAssignment_14876,axiom,
    ! [VarCurr: state_type] :
      ( v28961(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_14875,axiom,
    ! [VarCurr: state_type] :
      ( v28923(VarCurr)
    <=> v28925(VarCurr) ) ).

tff(addAssignment_14874,axiom,
    ! [VarCurr: state_type] :
      ( v28925(VarCurr)
    <=> v28927(VarCurr) ) ).

tff(addAssignment_14873,axiom,
    ! [VarCurr: state_type] :
      ( v28927(VarCurr)
    <=> v28929(VarCurr) ) ).

tff(addAssignment_14872,axiom,
    ! [VarCurr: state_type] :
      ( v28929(VarCurr)
    <=> v28931(VarCurr) ) ).

tff(writeUnaryOperator_1549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28931(VarCurr)
    <=> v28956(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2359,axiom,
    ! [VarCurr: state_type] :
      ( v28956(VarCurr)
    <=> ( v28957(VarCurr)
        | v28952(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2358,axiom,
    ! [VarCurr: state_type] :
      ( v28957(VarCurr)
    <=> ( v28933(VarCurr)
        | v28948(VarCurr) ) ) ).

tff(addAssignment_14871,axiom,
    ! [VarCurr: state_type] :
      ( v28952(VarCurr)
    <=> v28954(VarCurr) ) ).

tff(addAssignment_14870,axiom,
    ! [VarCurr: state_type] :
      ( v28954(VarCurr)
    <=> v28511(VarCurr,2) ) ).

tff(addAssignment_14869,axiom,
    ! [VarCurr: state_type] :
      ( v28948(VarCurr)
    <=> v28950(VarCurr) ) ).

tff(addAssignment_14868,axiom,
    ! [VarCurr: state_type] :
      ( v28950(VarCurr)
    <=> v28511(VarCurr,1) ) ).

tff(addAssignment_14867,axiom,
    ! [VarCurr: state_type] :
      ( v28933(VarCurr)
    <=> v28935(VarCurr) ) ).

tff(addAssignment_14866,axiom,
    ! [VarCurr: state_type] :
      ( v28935(VarCurr)
    <=> v28937(VarCurr,0) ) ).

tff(addAssignment_14865,axiom,
    ! [VarCurr: state_type] :
      ( v28937(VarCurr,0)
    <=> v28939(VarCurr,0) ) ).

tff(addAssignment_14864,axiom,
    ! [VarCurr: state_type] :
      ( v28939(VarCurr,0)
    <=> v28941(VarCurr,0) ) ).

tff(addAssignment_14863,axiom,
    ! [VarCurr: state_type] :
      ( v28941(VarCurr,0)
    <=> v28946(VarCurr,0) ) ).

tff(writeUnaryOperator_1548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28946(VarCurr,B)
      <=> ~ v28943(VarCurr,B) ) ) ).

tff(addAssignment_14862,axiom,
    ! [VarCurr: state_type] :
      ( v28943(VarCurr,0)
    <=> v28945(VarCurr,0) ) ).

tff(addAssignment_14861,axiom,
    ! [VarCurr: state_type] :
      ( v28945(VarCurr,0)
    <=> v28511(VarCurr,0) ) ).

tff(addAssignment_14860,axiom,
    ! [VarCurr: state_type] :
      ( v28919(VarCurr)
    <=> v28921(VarCurr) ) ).

tff(addAssignment_14859,axiom,
    ! [VarCurr: state_type] :
      ( v28921(VarCurr)
    <=> $false ) ).

tff(addAssignment_14858,axiom,
    ! [VarCurr: state_type] :
      ( v28913(VarCurr)
    <=> v28915(VarCurr) ) ).

tff(addAssignment_14857,axiom,
    ! [VarCurr: state_type] :
      ( v28915(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_14856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28903(VarCurr,B)
      <=> v28905(VarCurr,B) ) ) ).

tff(addAssignment_14855,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28905(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_14854,axiom,
    ! [VarCurr: state_type] :
      ( v28893(VarCurr)
    <=> v28895(VarCurr) ) ).

tff(addAssignment_14853,axiom,
    ! [VarCurr: state_type] :
      ( v28895(VarCurr)
    <=> v28897(VarCurr) ) ).

tff(addAssignment_14852,axiom,
    ! [VarCurr: state_type] :
      ( v28897(VarCurr)
    <=> v28899(VarCurr) ) ).

tff(addAssignment_14851,axiom,
    ! [VarCurr: state_type] :
      ( v28899(VarCurr)
    <=> v28901(VarCurr) ) ).

tff(addAssignment_14850,axiom,
    ! [VarCurr: state_type] :
      ( v28901(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_14849,axiom,
    ! [VarCurr: state_type] :
      ( v28883(VarCurr)
    <=> v28885(VarCurr) ) ).

tff(addAssignment_14848,axiom,
    ! [VarCurr: state_type] :
      ( v28885(VarCurr)
    <=> v28887(VarCurr) ) ).

tff(addAssignment_14847,axiom,
    ! [VarCurr: state_type] :
      ( v28887(VarCurr)
    <=> v28889(VarCurr) ) ).

tff(addAssignment_14846,axiom,
    ! [VarCurr: state_type] :
      ( v28889(VarCurr)
    <=> v28891(VarCurr) ) ).

tff(addAssignment_14845,axiom,
    ! [VarCurr: state_type] :
      ( v28891(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_14844,axiom,
    ! [VarCurr: state_type] :
      ( v28581(VarCurr)
    <=> v28583(VarCurr) ) ).

tff(addAssignment_14843,axiom,
    ! [VarCurr: state_type] :
      ( v28583(VarCurr)
    <=> v28585(VarCurr) ) ).

tff(addAssignment_14842,axiom,
    ! [VarCurr: state_type] :
      ( v28585(VarCurr)
    <=> v28587(VarCurr) ) ).

tff(addAssignment_14841,axiom,
    ! [VarCurr: state_type] :
      ( v28587(VarCurr)
    <=> v28589(VarCurr) ) ).

tff(addAssignment_14840,axiom,
    ! [VarCurr: state_type] :
      ( v28589(VarCurr)
    <=> v28591(VarCurr) ) ).

tff(addAssignment_14839,axiom,
    ! [VarCurr: state_type] :
      ( v28591(VarCurr)
    <=> v28593(VarCurr) ) ).

tff(addAssignment_14838,axiom,
    ! [VarCurr: state_type] :
      ( v28593(VarCurr)
    <=> v28595(VarCurr) ) ).

tff(writeUnaryOperator_1547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28595(VarCurr)
    <=> v28870(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2357,axiom,
    ! [VarCurr: state_type] :
      ( v28870(VarCurr)
    <=> ( v28871(VarCurr)
        | v28866(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2356,axiom,
    ! [VarCurr: state_type] :
      ( v28871(VarCurr)
    <=> ( v28597(VarCurr)
        | v28862(VarCurr) ) ) ).

tff(addAssignment_14837,axiom,
    ! [VarCurr: state_type] :
      ( v28866(VarCurr)
    <=> v28868(VarCurr) ) ).

tff(addAssignment_14836,axiom,
    ! [VarCurr: state_type] :
      ( v28868(VarCurr)
    <=> v28601(VarCurr,2) ) ).

tff(addAssignment_14835,axiom,
    ! [VarCurr: state_type] :
      ( v28862(VarCurr)
    <=> v28864(VarCurr) ) ).

tff(addAssignment_14834,axiom,
    ! [VarCurr: state_type] :
      ( v28864(VarCurr)
    <=> v28601(VarCurr,1) ) ).

tff(addAssignment_14833,axiom,
    ! [VarCurr: state_type] :
      ( v28597(VarCurr)
    <=> v28599(VarCurr) ) ).

tff(addAssignment_14832,axiom,
    ! [VarCurr: state_type] :
      ( v28599(VarCurr)
    <=> v28601(VarCurr,0) ) ).

tff(addAssignment_14831,axiom,
    ! [VarCurr: state_type] :
      ( v28601(VarCurr,0)
    <=> v28513(VarCurr,3) ) ).

tff(addAssignment_14830,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,3)
    <=> v28515(VarCurr,3) ) ).

tff(addAssignment_14829,axiom,
    ! [VarNext: state_type] :
      ( v28515(VarNext,3)
    <=> v28854(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28855(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v28854(VarNext,B)
            <=> v28515(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_323,axiom,
    ! [VarNext: state_type] :
      ( v28855(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28854(VarNext,B)
          <=> v28826(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28855(VarNext)
      <=> v28856(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28856(VarNext)
      <=> ( v28858(VarNext)
          & v28768(VarNext) ) ) ) ).

tff(writeUnaryOperator_1546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28858(VarNext)
      <=> v28820(VarNext) ) ) ).

tff(addAssignment_14828,axiom,
    ! [VarCurr: state_type] :
      ( v28625(VarCurr,3)
    <=> v28627(VarCurr,3) ) ).

tff(addAssignment_14827,axiom,
    ! [VarCurr: state_type] :
      ( v28627(VarCurr,3)
    <=> v28765(VarCurr,3) ) ).

tff(addAssignment_14826,axiom,
    ! [VarCurr: state_type] :
      ( v28629(VarCurr,0)
    <=> v28631(VarCurr,0) ) ).

tff(addAssignment_14825,axiom,
    ! [VarCurr: state_type] :
      ( v28631(VarCurr,0)
    <=> v28633(VarCurr,0) ) ).

tff(addAssignment_14824,axiom,
    ! [VarCurr: state_type] :
      ( v28633(VarCurr,0)
    <=> v28764(VarCurr,0) ) ).

tff(addAssignment_14823,axiom,
    ! [VarCurr: state_type] :
      ( v28701(VarCurr,0)
    <=> v28703(VarCurr,0) ) ).

tff(addAssignment_14822,axiom,
    ! [VarCurr: state_type] :
      ( v28703(VarCurr,0)
    <=> v28705(VarCurr,0) ) ).

tff(addAssignment_14821,axiom,
    ! [VarCurr: state_type] :
      ( v28705(VarCurr,0)
    <=> v28707(VarCurr,0) ) ).

tff(addAssignment_14820,axiom,
    ! [VarCurr: state_type] :
      ( v28707(VarCurr,0)
    <=> v28709(VarCurr,0) ) ).

tff(addAssignment_14819,axiom,
    ! [VarCurr: state_type] :
      ( v28709(VarCurr,0)
    <=> v28719(VarCurr,0) ) ).

tff(addAssignment_14818,axiom,
    ! [VarCurr: state_type] :
      ( v28635(VarCurr,0)
    <=> v28637(VarCurr,0) ) ).

tff(addAssignment_14817,axiom,
    ! [VarCurr: state_type] :
      ( v28637(VarCurr,0)
    <=> v28698(VarCurr,0) ) ).

tff(addAssignment_14816,axiom,
    ! [VarCurr: state_type] :
      ( v28639(VarCurr)
    <=> v28165(VarCurr,2) ) ).

tff(addAssignment_14815,axiom,
    ! [VarCurr: state_type] :
      ( v28165(VarCurr,2)
    <=> v28167(VarCurr,2) ) ).

tff(addAssignment_14814,axiom,
    ! [VarCurr: state_type] :
      ( v28167(VarCurr,2)
    <=> v28177(VarCurr,2) ) ).

tff(addAssignment_14813,axiom,
    ! [VarCurr: state_type] :
      ( v28169(VarCurr,2)
    <=> v28171(VarCurr,2) ) ).

tff(addAssignment_14812,axiom,
    ! [VarCurr: state_type] :
      ( v28171(VarCurr,2)
    <=> v28174(VarCurr,2) ) ).

tff(addAssignment_14811,axiom,
    ! [VarCurr: state_type] :
      ( v28175(VarCurr)
    <=> v28642(VarCurr,1) ) ).

tff(addAssignment_14810,axiom,
    ! [VarCurr: state_type] :
      ( v28642(VarCurr,1)
    <=> v28644(VarCurr,1) ) ).

tff(addAssignment_14809,axiom,
    ! [VarCurr: state_type] :
      ( v28644(VarCurr,1)
    <=> v28852(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v28852(VarCurr,B)
      <=> ( v28646(VarCurr,B)
          | v28652(VarCurr,B) ) ) ) ).

tff(addAssignment_14808,axiom,
    ! [VarCurr: state_type] :
      ( v28652(VarCurr,1)
    <=> v28654(VarCurr,1) ) ).

tff(addAssignment_14807,axiom,
    ! [VarCurr: state_type] :
      ( v28654(VarCurr,1)
    <=> v28850(VarCurr,1) ) ).

tff(addAssignment_14806,axiom,
    ! [VarCurr: state_type] :
      ( v28850(VarCurr,0)
    <=> v28851(VarCurr) ) ).

tff(addAssignment_14805,axiom,
    ! [VarCurr: state_type] :
      ( v28850(VarCurr,1)
    <=> v28656(VarCurr) ) ).

tff(addAssignment_14804,axiom,
    ! [VarCurr: state_type] :
      ( v28656(VarCurr)
    <=> v28658(VarCurr,1) ) ).

tff(addAssignment_14803,axiom,
    ! [VarCurr: state_type] :
      ( v28658(VarCurr,1)
    <=> v28660(VarCurr,1) ) ).

tff(addAssignment_14802,axiom,
    ! [VarCurr: state_type] :
      ( v28660(VarCurr,1)
    <=> v28849(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v28849(VarCurr,B)
      <=> ( v28662(VarCurr,B)
          & v28670(VarCurr,B) ) ) ) ).

tff(addAssignment_14801,axiom,
    ! [VarCurr: state_type] :
      ( v28670(VarCurr,1)
    <=> v28672(VarCurr,1) ) ).

tff(addAssignment_14800,axiom,
    ! [VarCurr: state_type] :
      ( v28672(VarCurr,1)
    <=> v28847(VarCurr,1) ) ).

tff(addAssignment_14799,axiom,
    ! [VarCurr: state_type] :
      ( v28847(VarCurr,0)
    <=> v28848(VarCurr) ) ).

tff(addAssignment_14798,axiom,
    ! [VarCurr: state_type] :
      ( v28847(VarCurr,1)
    <=> v28674(VarCurr) ) ).

tff(addAssignment_14797,axiom,
    ! [VarCurr: state_type] :
      ( v28674(VarCurr)
    <=> v28676(VarCurr) ) ).

tff(addAssignment_14796,axiom,
    ! [VarCurr: state_type] :
      ( v28676(VarCurr)
    <=> v28678(VarCurr) ) ).

tff(writeUnaryOperator_1545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28678(VarCurr)
    <=> v28845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2353,axiom,
    ! [VarCurr: state_type] :
      ( v28845(VarCurr)
    <=> ( v28846(VarCurr)
        | v28833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2352,axiom,
    ! [VarCurr: state_type] :
      ( v28846(VarCurr)
    <=> ( v28680(VarCurr)
        | v28695(VarCurr) ) ) ).

tff(addAssignment_14795,axiom,
    ! [VarCurr: state_type] :
      ( v28833(VarCurr)
    <=> v28835(VarCurr) ) ).

tff(addAssignment_14794,axiom,
    ! [VarCurr: state_type] :
      ( v28835(VarCurr)
    <=> v28684(VarCurr,2) ) ).

tff(addAssignment_14793,axiom,
    ! [VarCurr: state_type] :
      ( v28684(VarCurr,2)
    <=> v28686(VarCurr,2) ) ).

tff(addAssignment_14792,axiom,
    ! [VarCurr: state_type] :
      ( v28686(VarCurr,2)
    <=> v28688(VarCurr,2) ) ).

tff(addAssignment_14791,axiom,
    ! [VarCurr: state_type] :
      ( v28688(VarCurr,2)
    <=> v28693(VarCurr,2) ) ).

tff(addAssignment_14790,axiom,
    ! [VarCurr: state_type] :
      ( v28690(VarCurr,2)
    <=> v28692(VarCurr,2) ) ).

tff(addAssignment_14789,axiom,
    ! [VarCurr: state_type] :
      ( v28692(VarCurr,2)
    <=> v28601(VarCurr,2) ) ).

tff(addAssignment_14788,axiom,
    ! [VarCurr: state_type] :
      ( v28601(VarCurr,2)
    <=> v28513(VarCurr,5) ) ).

tff(addAssignment_14787,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,5)
    <=> v28515(VarCurr,5) ) ).

tff(addAssignment_14786,axiom,
    ! [VarNext: state_type] :
      ( v28515(VarNext,5)
    <=> v28837(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28838(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v28837(VarNext,B)
            <=> v28515(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_322,axiom,
    ! [VarNext: state_type] :
      ( v28838(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28837(VarNext,B)
          <=> v28826(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28838(VarNext)
      <=> v28839(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2350,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28839(VarNext)
      <=> ( v28841(VarNext)
          & v28768(VarNext) ) ) ) ).

tff(writeUnaryOperator_1544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28841(VarNext)
      <=> v28820(VarNext) ) ) ).

tff(addAssignment_14785,axiom,
    ! [VarCurr: state_type] :
      ( v28625(VarCurr,5)
    <=> v28627(VarCurr,5) ) ).

tff(addAssignment_14784,axiom,
    ! [VarCurr: state_type] :
      ( v28627(VarCurr,5)
    <=> v28765(VarCurr,5) ) ).

tff(addAssignment_14783,axiom,
    ! [VarCurr: state_type] :
      ( v28629(VarCurr,2)
    <=> v28631(VarCurr,2) ) ).

tff(addAssignment_14782,axiom,
    ! [VarCurr: state_type] :
      ( v28631(VarCurr,2)
    <=> v28633(VarCurr,2) ) ).

tff(addAssignment_14781,axiom,
    ! [VarCurr: state_type] :
      ( v28633(VarCurr,2)
    <=> v28764(VarCurr,2) ) ).

tff(addAssignment_14780,axiom,
    ! [VarCurr: state_type] :
      ( v28701(VarCurr,2)
    <=> v28703(VarCurr,2) ) ).

tff(addAssignment_14779,axiom,
    ! [VarCurr: state_type] :
      ( v28703(VarCurr,2)
    <=> v28705(VarCurr,2) ) ).

tff(addAssignment_14778,axiom,
    ! [VarCurr: state_type] :
      ( v28705(VarCurr,2)
    <=> v28707(VarCurr,2) ) ).

tff(addAssignment_14777,axiom,
    ! [VarCurr: state_type] :
      ( v28707(VarCurr,2)
    <=> v28709(VarCurr,2) ) ).

tff(addAssignment_14776,axiom,
    ! [VarCurr: state_type] :
      ( v28709(VarCurr,2)
    <=> v28719(VarCurr,2) ) ).

tff(addAssignment_14775,axiom,
    ! [VarCurr: state_type] :
      ( v28711(VarCurr,2)
    <=> v28713(VarCurr,2) ) ).

tff(addAssignment_14774,axiom,
    ! [VarCurr: state_type] :
      ( v28713(VarCurr,2)
    <=> v28714(VarCurr,2) ) ).

tff(addAssignment_14773,axiom,
    ! [VarCurr: state_type] :
      ( v28635(VarCurr,2)
    <=> v28637(VarCurr,2) ) ).

tff(addAssignment_14772,axiom,
    ! [VarCurr: state_type] :
      ( v28637(VarCurr,2)
    <=> v28698(VarCurr,2) ) ).

tff(addAssignment_14771,axiom,
    ! [VarCurr: state_type] :
      ( v28695(VarCurr)
    <=> v28697(VarCurr) ) ).

tff(addAssignment_14770,axiom,
    ! [VarCurr: state_type] :
      ( v28697(VarCurr)
    <=> v28601(VarCurr,1) ) ).

tff(addAssignment_14769,axiom,
    ! [VarCurr: state_type] :
      ( v28601(VarCurr,1)
    <=> v28513(VarCurr,4) ) ).

tff(addAssignment_14768,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,4)
    <=> v28515(VarCurr,4) ) ).

tff(addAssignment_14767,axiom,
    ! [VarNext: state_type] :
      ( v28515(VarNext,4)
    <=> v28815(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28816(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v28815(VarNext,B)
            <=> v28515(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_321,axiom,
    ! [VarNext: state_type] :
      ( v28816(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28815(VarNext,B)
          <=> v28826(VarNext,B) ) ) ) ).

tff(addAssignment_14766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28826(VarNext,B)
          <=> v28824(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28824(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_194,axiom,
    ! [VarCurr: state_type] :
      ( v28827(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v28824(VarCurr,B)
          <=> v28625(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2349,axiom,
    ! [VarCurr: state_type] :
      ( v28827(VarCurr)
    <=> ( v28828(VarCurr)
        & v28829(VarCurr) ) ) ).

tff(writeUnaryOperator_1543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28829(VarCurr)
    <=> v28615(VarCurr) ) ).

tff(writeUnaryOperator_1542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28828(VarCurr)
    <=> v28603(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28816(VarNext)
      <=> v28817(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28817(VarNext)
      <=> ( v28818(VarNext)
          & v28768(VarNext) ) ) ) ).

tff(writeUnaryOperator_1541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28818(VarNext)
      <=> v28820(VarNext) ) ) ).

tff(addAssignment_14765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28820(VarNext)
      <=> v28768(VarCurr) ) ) ).

tff(addAssignment_14764,axiom,
    ! [VarCurr: state_type] :
      ( v28768(VarCurr)
    <=> v28770(VarCurr) ) ).

tff(addAssignment_14763,axiom,
    ! [VarCurr: state_type] :
      ( v28770(VarCurr)
    <=> v28772(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2346,axiom,
    ! [VarCurr: state_type] :
      ( v28772(VarCurr)
    <=> ( v28813(VarCurr)
        | v28809(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2345,axiom,
    ! [VarCurr: state_type] :
      ( v28813(VarCurr)
    <=> ( v28774(VarCurr)
        & v28778(VarCurr) ) ) ).

tff(addAssignment_14762,axiom,
    ! [VarCurr: state_type] :
      ( v28809(VarCurr)
    <=> v28811(VarCurr) ) ).

tff(addAssignment_14761,axiom,
    ! [VarCurr: state_type] :
      ( v28811(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28793(VarNext)
       => ( v28778(VarNext)
        <=> v28778(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_320,axiom,
    ! [VarNext: state_type] :
      ( v28793(VarNext)
     => ( v28778(VarNext)
      <=> v28803(VarNext) ) ) ).

tff(addAssignment_14760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28803(VarNext)
      <=> v28801(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2344,axiom,
    ! [VarCurr: state_type] :
      ( v28801(VarCurr)
    <=> ( v28804(VarCurr)
        & v28805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2343,axiom,
    ! [VarCurr: state_type] :
      ( v28805(VarCurr)
    <=> ( v28784(VarCurr)
        | v28788(VarCurr) ) ) ).

tff(writeUnaryOperator_1540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28804(VarCurr)
    <=> v28780(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28793(VarNext)
      <=> v28794(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28794(VarNext)
      <=> ( v28796(VarNext)
          & v28798(VarNext) ) ) ) ).

tff(writeUnaryOperator_1539,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28798(VarCurr)
    <=> v28774(VarCurr) ) ).

tff(addAssignment_14759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28796(VarNext)
      <=> v28774(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_123,axiom,
    ( v28778(constB0)
  <=> $true ) ).

tff(addAssignment_14758,axiom,
    ! [VarCurr: state_type] :
      ( v28788(VarCurr)
    <=> v28790(VarCurr) ) ).

tff(addAssignment_14757,axiom,
    ! [VarCurr: state_type] :
      ( v28790(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_14756,axiom,
    ! [VarCurr: state_type] :
      ( v28784(VarCurr)
    <=> v28786(VarCurr) ) ).

tff(addAssignment_14755,axiom,
    ! [VarCurr: state_type] :
      ( v28786(VarCurr)
    <=> $true ) ).

tff(addAssignment_14754,axiom,
    ! [VarCurr: state_type] :
      ( v28780(VarCurr)
    <=> v28782(VarCurr) ) ).

tff(addAssignment_14753,axiom,
    ! [VarCurr: state_type] :
      ( v28782(VarCurr)
    <=> $false ) ).

tff(addAssignment_14752,axiom,
    ! [VarCurr: state_type] :
      ( v28774(VarCurr)
    <=> v28776(VarCurr) ) ).

tff(addAssignment_14751,axiom,
    ! [VarCurr: state_type] :
      ( v28776(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_14750,axiom,
    ! [VarCurr: state_type] :
      ( v28625(VarCurr,4)
    <=> v28627(VarCurr,4) ) ).

tff(addAssignment_14749,axiom,
    ! [VarCurr: state_type] :
      ( v28627(VarCurr,4)
    <=> v28765(VarCurr,4) ) ).

tff(addAssignment_14748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28765(VarCurr,B)
      <=> v28766(VarCurr,B) ) ) ).

tff(addAssignment_14747,axiom,
    ! [VarCurr: state_type] :
      ( ( v28765(VarCurr,5)
      <=> v28629(VarCurr,2) )
      & ( v28765(VarCurr,4)
      <=> v28629(VarCurr,1) )
      & ( v28765(VarCurr,3)
      <=> v28629(VarCurr,0) ) ) ).

tff(addAssignment_14746,axiom,
    ! [VarCurr: state_type] :
      ( v28629(VarCurr,1)
    <=> v28631(VarCurr,1) ) ).

tff(addAssignment_14745,axiom,
    ! [VarCurr: state_type] :
      ( v28631(VarCurr,1)
    <=> v28633(VarCurr,1) ) ).

tff(addAssignment_14744,axiom,
    ! [VarCurr: state_type] :
      ( v28633(VarCurr,1)
    <=> v28764(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28764(VarCurr,B)
      <=> ( v28635(VarCurr,B)
          & v28701(VarCurr,B) ) ) ) ).

tff(addAssignment_14743,axiom,
    ! [VarCurr: state_type] :
      ( v28701(VarCurr,1)
    <=> v28703(VarCurr,1) ) ).

tff(addAssignment_14742,axiom,
    ! [VarCurr: state_type] :
      ( v28703(VarCurr,1)
    <=> v28705(VarCurr,1) ) ).

tff(addAssignment_14741,axiom,
    ! [VarCurr: state_type] :
      ( v28705(VarCurr,1)
    <=> v28707(VarCurr,1) ) ).

tff(addAssignment_14740,axiom,
    ! [VarCurr: state_type] :
      ( v28707(VarCurr,1)
    <=> v28709(VarCurr,1) ) ).

tff(addAssignment_14739,axiom,
    ! [VarCurr: state_type] :
      ( v28709(VarCurr,1)
    <=> v28719(VarCurr,1) ) ).

tff(addAssignment_14738,axiom,
    ! [VarCurr: state_type] :
      ( v28719(VarCurr,0)
    <=> v28759(VarCurr) ) ).

tff(addAssignment_14737,axiom,
    ! [VarCurr: state_type] :
      ( v28719(VarCurr,1)
    <=> v28754(VarCurr) ) ).

tff(addAssignment_14736,axiom,
    ! [VarCurr: state_type] :
      ( v28719(VarCurr,2)
    <=> v28749(VarCurr) ) ).

tff(addAssignment_14735,axiom,
    ! [VarCurr: state_type] :
      ( v28719(VarCurr,3)
    <=> v28721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2340,axiom,
    ! [VarCurr: state_type] :
      ( v28759(VarCurr)
    <=> ( v28760(VarCurr)
        & v28763(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2339,axiom,
    ! [VarCurr: state_type] :
      ( v28763(VarCurr)
    <=> ( v28711(VarCurr,0)
        | v28729(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2338,axiom,
    ! [VarCurr: state_type] :
      ( v28760(VarCurr)
    <=> ( v28761(VarCurr)
        | v28762(VarCurr) ) ) ).

tff(writeUnaryOperator_1538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28762(VarCurr)
    <=> v28729(VarCurr,0) ) ).

tff(writeUnaryOperator_1537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28761(VarCurr)
    <=> v28711(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2337,axiom,
    ! [VarCurr: state_type] :
      ( v28754(VarCurr)
    <=> ( v28755(VarCurr)
        & v28758(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2336,axiom,
    ! [VarCurr: state_type] :
      ( v28758(VarCurr)
    <=> ( v28728(VarCurr)
        | v28730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2335,axiom,
    ! [VarCurr: state_type] :
      ( v28755(VarCurr)
    <=> ( v28756(VarCurr)
        | v28757(VarCurr) ) ) ).

tff(writeUnaryOperator_1536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28757(VarCurr)
    <=> v28730(VarCurr) ) ).

tff(writeUnaryOperator_1535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28756(VarCurr)
    <=> v28728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2334,axiom,
    ! [VarCurr: state_type] :
      ( v28749(VarCurr)
    <=> ( v28750(VarCurr)
        & v28753(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2333,axiom,
    ! [VarCurr: state_type] :
      ( v28753(VarCurr)
    <=> ( v28726(VarCurr)
        | v28736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2332,axiom,
    ! [VarCurr: state_type] :
      ( v28750(VarCurr)
    <=> ( v28751(VarCurr)
        | v28752(VarCurr) ) ) ).

tff(writeUnaryOperator_1534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28752(VarCurr)
    <=> v28736(VarCurr) ) ).

tff(writeUnaryOperator_1533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28751(VarCurr)
    <=> v28726(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2331,axiom,
    ! [VarCurr: state_type] :
      ( v28721(VarCurr)
    <=> ( v28722(VarCurr)
        & v28748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2330,axiom,
    ! [VarCurr: state_type] :
      ( v28748(VarCurr)
    <=> ( v28724(VarCurr)
        | v28743(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2329,axiom,
    ! [VarCurr: state_type] :
      ( v28722(VarCurr)
    <=> ( v28723(VarCurr)
        | v28742(VarCurr) ) ) ).

tff(writeUnaryOperator_1532,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28742(VarCurr)
    <=> v28743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2328,axiom,
    ! [VarCurr: state_type] :
      ( v28743(VarCurr)
    <=> ( v28744(VarCurr)
        & v28747(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_243,axiom,
    ! [VarCurr: state_type] :
      ( v28747(VarCurr)
    <=> ( v28711(VarCurr,3)
        | v28729(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2327,axiom,
    ! [VarCurr: state_type] :
      ( v28744(VarCurr)
    <=> ( v28745(VarCurr)
        | v28746(VarCurr) ) ) ).

tff(writeUnaryOperator_1531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28746(VarCurr)
    <=> v28729(VarCurr,3) ) ).

tff(writeUnaryOperator_1530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28745(VarCurr)
    <=> v28711(VarCurr,3) ) ).

tff(writeUnaryOperator_1529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28723(VarCurr)
    <=> v28724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2326,axiom,
    ! [VarCurr: state_type] :
      ( v28724(VarCurr)
    <=> ( v28725(VarCurr)
        | v28741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_242,axiom,
    ! [VarCurr: state_type] :
      ( v28741(VarCurr)
    <=> ( v28711(VarCurr,2)
        & v28729(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2325,axiom,
    ! [VarCurr: state_type] :
      ( v28725(VarCurr)
    <=> ( v28726(VarCurr)
        & v28736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2324,axiom,
    ! [VarCurr: state_type] :
      ( v28736(VarCurr)
    <=> ( v28737(VarCurr)
        & v28740(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_241,axiom,
    ! [VarCurr: state_type] :
      ( v28740(VarCurr)
    <=> ( v28711(VarCurr,2)
        | v28729(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2323,axiom,
    ! [VarCurr: state_type] :
      ( v28737(VarCurr)
    <=> ( v28738(VarCurr)
        | v28739(VarCurr) ) ) ).

tff(writeUnaryOperator_1528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28739(VarCurr)
    <=> v28729(VarCurr,2) ) ).

tff(writeUnaryOperator_1527,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28738(VarCurr)
    <=> v28711(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2322,axiom,
    ! [VarCurr: state_type] :
      ( v28726(VarCurr)
    <=> ( v28727(VarCurr)
        | v28735(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_240,axiom,
    ! [VarCurr: state_type] :
      ( v28735(VarCurr)
    <=> ( v28711(VarCurr,1)
        & v28729(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2321,axiom,
    ! [VarCurr: state_type] :
      ( v28727(VarCurr)
    <=> ( v28728(VarCurr)
        & v28730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2320,axiom,
    ! [VarCurr: state_type] :
      ( v28730(VarCurr)
    <=> ( v28731(VarCurr)
        & v28734(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_239,axiom,
    ! [VarCurr: state_type] :
      ( v28734(VarCurr)
    <=> ( v28711(VarCurr,1)
        | v28729(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2319,axiom,
    ! [VarCurr: state_type] :
      ( v28731(VarCurr)
    <=> ( v28732(VarCurr)
        | v28733(VarCurr) ) ) ).

tff(writeUnaryOperator_1526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28733(VarCurr)
    <=> v28729(VarCurr,1) ) ).

tff(writeUnaryOperator_1525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28732(VarCurr)
    <=> v28711(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2318,axiom,
    ! [VarCurr: state_type] :
      ( v28728(VarCurr)
    <=> ( v28711(VarCurr,0)
        & v28729(VarCurr,0) ) ) ).

tff(addAssignment_14734,axiom,
    ! [VarCurr: state_type] :
      ( v28729(VarCurr,0)
    <=> v28716(VarCurr) ) ).

tff(addAssignment_14733,axiom,
    ! [VarCurr: state_type] :
      ( ( v28729(VarCurr,3)
      <=> $false )
      & ( v28729(VarCurr,2)
      <=> $false )
      & ( v28729(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_14732,axiom,
    ! [VarCurr: state_type] :
      ( v28716(VarCurr)
    <=> v28718(VarCurr) ) ).

tff(addAssignment_14731,axiom,
    ! [VarCurr: state_type] :
      ( v28718(VarCurr)
    <=> v28666(VarCurr) ) ).

tff(addAssignment_14730,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v28711(VarCurr,B)
      <=> v28713(VarCurr,B) ) ) ).

tff(addAssignment_14729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v28713(VarCurr,B)
      <=> v28714(VarCurr,B) ) ) ).

tff(addAssignment_14728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28714(VarCurr,B)
      <=> v28601(VarCurr,B) ) ) ).

tff(addAssignment_14727,axiom,
    ! [VarCurr: state_type] :
      ( v28714(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_14726,axiom,
    ! [VarCurr: state_type] :
      ( v28635(VarCurr,1)
    <=> v28637(VarCurr,1) ) ).

tff(addAssignment_14725,axiom,
    ! [VarCurr: state_type] :
      ( v28637(VarCurr,1)
    <=> v28698(VarCurr,1) ) ).

tff(addAssignment_14724,axiom,
    ! [VarCurr: state_type] :
      ( v28698(VarCurr,0)
    <=> v28699(VarCurr) ) ).

tff(addAssignment_14723,axiom,
    ! [VarCurr: state_type] :
      ( v28698(VarCurr,1)
    <=> v28699(VarCurr) ) ).

tff(addAssignment_14722,axiom,
    ! [VarCurr: state_type] :
      ( v28698(VarCurr,2)
    <=> v28699(VarCurr) ) ).

tff(addAssignment_14721,axiom,
    ! [VarCurr: state_type] :
      ( v28699(VarCurr)
    <=> v28639(VarCurr) ) ).

tff(addAssignment_14720,axiom,
    ! [VarCurr: state_type] :
      ( v28680(VarCurr)
    <=> v28682(VarCurr) ) ).

tff(addAssignment_14719,axiom,
    ! [VarCurr: state_type] :
      ( v28682(VarCurr)
    <=> v28684(VarCurr,0) ) ).

tff(addAssignment_14718,axiom,
    ! [VarCurr: state_type] :
      ( v28684(VarCurr,0)
    <=> v28686(VarCurr,0) ) ).

tff(addAssignment_14717,axiom,
    ! [VarCurr: state_type] :
      ( v28686(VarCurr,0)
    <=> v28688(VarCurr,0) ) ).

tff(addAssignment_14716,axiom,
    ! [VarCurr: state_type] :
      ( v28688(VarCurr,0)
    <=> v28693(VarCurr,0) ) ).

tff(writeUnaryOperator_1524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28693(VarCurr,B)
      <=> ~ v28690(VarCurr,B) ) ) ).

tff(addAssignment_14715,axiom,
    ! [VarCurr: state_type] :
      ( v28690(VarCurr,0)
    <=> v28692(VarCurr,0) ) ).

tff(addAssignment_14714,axiom,
    ! [VarCurr: state_type] :
      ( v28692(VarCurr,0)
    <=> v28601(VarCurr,0) ) ).

tff(addAssignment_14713,axiom,
    ! [VarCurr: state_type] :
      ( v28662(VarCurr,1)
    <=> v28664(VarCurr,1) ) ).

tff(addAssignment_14712,axiom,
    ! [VarCurr: state_type] :
      ( v28664(VarCurr,1)
    <=> v28667(VarCurr,1) ) ).

tff(addAssignment_14711,axiom,
    ! [VarCurr: state_type] :
      ( v28667(VarCurr,0)
    <=> v28668(VarCurr) ) ).

tff(addAssignment_14710,axiom,
    ! [VarCurr: state_type] :
      ( v28667(VarCurr,1)
    <=> v28666(VarCurr) ) ).

tff(addAssignment_14709,axiom,
    ! [VarCurr: state_type] :
      ( v28666(VarCurr)
    <=> v10053(VarCurr,12) ) ).

tff(addAssignment_14708,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,12)
    <=> v10055(VarCurr,12) ) ).

tff(addAssignment_14707,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,12)
    <=> v10057(VarCurr,12) ) ).

tff(addAssignment_14706,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,12)
    <=> v10061(VarCurr,12) ) ).

tff(addAssignment_14705,axiom,
    ! [VarCurr: state_type] :
      ( v28646(VarCurr,1)
    <=> v28648(VarCurr,1) ) ).

tff(addAssignment_14704,axiom,
    ! [VarCurr: state_type] :
      ( v28648(VarCurr,1)
    <=> v28649(VarCurr,1) ) ).

tff(addAssignment_14703,axiom,
    ! [VarCurr: state_type] :
      ( v28649(VarCurr,0)
    <=> v28650(VarCurr) ) ).

tff(addAssignment_14702,axiom,
    ! [VarCurr: state_type] :
      ( v28649(VarCurr,1)
    <=> v28650(VarCurr) ) ).

tff(addAssignment_14701,axiom,
    ! [VarCurr: state_type] :
      ( v28650(VarCurr)
    <=> v28173(VarCurr) ) ).

tff(addAssignment_14700,axiom,
    ! [VarCurr: state_type] :
      ( v28615(VarCurr)
    <=> v28617(VarCurr) ) ).

tff(addAssignment_14699,axiom,
    ! [VarCurr: state_type] :
      ( v28617(VarCurr)
    <=> v28619(VarCurr) ) ).

tff(addAssignment_14698,axiom,
    ! [VarCurr: state_type] :
      ( v28619(VarCurr)
    <=> v28621(VarCurr) ) ).

tff(addAssignment_14697,axiom,
    ! [VarCurr: state_type] :
      ( v28621(VarCurr)
    <=> v28623(VarCurr) ) ).

tff(addAssignment_14696,axiom,
    ! [VarCurr: state_type] :
      ( v28623(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_14695,axiom,
    ! [VarCurr: state_type] :
      ( v28603(VarCurr)
    <=> v28605(VarCurr) ) ).

tff(addAssignment_14694,axiom,
    ! [VarCurr: state_type] :
      ( v28605(VarCurr)
    <=> v28607(VarCurr) ) ).

tff(addAssignment_14693,axiom,
    ! [VarCurr: state_type] :
      ( v28607(VarCurr)
    <=> v28609(VarCurr) ) ).

tff(addAssignment_14692,axiom,
    ! [VarCurr: state_type] :
      ( v28609(VarCurr)
    <=> v28611(VarCurr) ) ).

tff(addAssignment_14691,axiom,
    ! [VarCurr: state_type] :
      ( v28611(VarCurr)
    <=> v28613(VarCurr) ) ).

tff(addAssignment_14690,axiom,
    ! [VarCurr: state_type] :
      ( v28613(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_14689,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28111(VarCurr,B)
      <=> v28113(VarCurr,B) ) ) ).

tff(addAssignment_14688,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28113(VarCurr,B)
      <=> v28115(VarCurr,B) ) ) ).

tff(addAssignment_14687,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28115(VarCurr,B)
      <=> v28117(VarCurr,B) ) ) ).

tff(addAssignment_14686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28117(VarCurr,B)
      <=> v28119(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28564(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v28119(VarNext,B)
            <=> v28119(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_319,axiom,
    ! [VarNext: state_type] :
      ( v28564(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28119(VarNext,B)
          <=> v28574(VarNext,B) ) ) ) ).

tff(addAssignment_14685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28574(VarNext,B)
          <=> v28572(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28572(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_193,axiom,
    ! [VarCurr: state_type] :
      ( v28575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28572(VarCurr,B)
          <=> v28149(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2317,axiom,
    ! [VarCurr: state_type] :
      ( v28575(VarCurr)
    <=> ( v28576(VarCurr)
        & v28577(VarCurr) ) ) ).

tff(writeUnaryOperator_1523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28577(VarCurr)
    <=> v28135(VarCurr) ) ).

tff(writeUnaryOperator_1522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28576(VarCurr)
    <=> v28121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28564(VarNext)
      <=> v28565(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28565(VarNext)
      <=> ( v28566(VarNext)
          & v28479(VarNext) ) ) ) ).

tff(writeUnaryOperator_1521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28566(VarNext)
      <=> v28568(VarNext) ) ) ).

tff(addAssignment_14684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28568(VarNext)
      <=> v28479(VarCurr) ) ) ).

tff(addAssignment_14683,axiom,
    ! [VarCurr: state_type] :
      ( v28479(VarCurr)
    <=> v28481(VarCurr) ) ).

tff(addAssignment_14682,axiom,
    ! [VarCurr: state_type] :
      ( v28481(VarCurr)
    <=> v28483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2314,axiom,
    ! [VarCurr: state_type] :
      ( v28483(VarCurr)
    <=> ( v28561(VarCurr)
        | v28553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2313,axiom,
    ! [VarCurr: state_type] :
      ( v28561(VarCurr)
    <=> ( v28485(VarCurr)
        & v28491(VarCurr) ) ) ).

tff(addAssignment_14681,axiom,
    ! [VarCurr: state_type] :
      ( v28553(VarCurr)
    <=> v28555(VarCurr) ) ).

tff(addAssignment_14680,axiom,
    ! [VarCurr: state_type] :
      ( v28555(VarCurr)
    <=> v28557(VarCurr) ) ).

tff(addAssignment_14679,axiom,
    ! [VarCurr: state_type] :
      ( v28557(VarCurr)
    <=> v28559(VarCurr) ) ).

tff(addAssignment_14678,axiom,
    ! [VarCurr: state_type] :
      ( v28559(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_318,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28537(VarNext)
       => ( v28491(VarNext)
        <=> v28491(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_318,axiom,
    ! [VarNext: state_type] :
      ( v28537(VarNext)
     => ( v28491(VarNext)
      <=> v28547(VarNext) ) ) ).

tff(addAssignment_14677,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28547(VarNext)
      <=> v28545(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2312,axiom,
    ! [VarCurr: state_type] :
      ( v28545(VarCurr)
    <=> ( v28548(VarCurr)
        & v28549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2311,axiom,
    ! [VarCurr: state_type] :
      ( v28549(VarCurr)
    <=> ( v28497(VarCurr)
        | v28528(VarCurr) ) ) ).

tff(writeUnaryOperator_1520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28548(VarCurr)
    <=> v28493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28537(VarNext)
      <=> v28538(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28538(VarNext)
      <=> ( v28540(VarNext)
          & v28542(VarNext) ) ) ) ).

tff(writeUnaryOperator_1519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28542(VarCurr)
    <=> v28485(VarCurr) ) ).

tff(addAssignment_14676,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28540(VarNext)
      <=> v28485(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_122,axiom,
    ( v28491(constB0)
  <=> $true ) ).

tff(addAssignment_14675,axiom,
    ! [VarCurr: state_type] :
      ( v28528(VarCurr)
    <=> v28530(VarCurr) ) ).

tff(addAssignment_14674,axiom,
    ! [VarCurr: state_type] :
      ( v28530(VarCurr)
    <=> v28532(VarCurr) ) ).

tff(addAssignment_14673,axiom,
    ! [VarCurr: state_type] :
      ( v28532(VarCurr)
    <=> v28534(VarCurr) ) ).

tff(addAssignment_14672,axiom,
    ! [VarCurr: state_type] :
      ( v28534(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_14671,axiom,
    ! [VarCurr: state_type] :
      ( v28497(VarCurr)
    <=> v28499(VarCurr) ) ).

tff(addAssignment_14670,axiom,
    ! [VarCurr: state_type] :
      ( v28499(VarCurr)
    <=> v28501(VarCurr) ) ).

tff(addAssignment_14669,axiom,
    ! [VarCurr: state_type] :
      ( v28501(VarCurr)
    <=> v28503(VarCurr) ) ).

tff(addAssignment_14668,axiom,
    ! [VarCurr: state_type] :
      ( v28503(VarCurr)
    <=> v28505(VarCurr) ) ).

tff(writeUnaryOperator_1518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28505(VarCurr)
    <=> v28525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2308,axiom,
    ! [VarCurr: state_type] :
      ( v28525(VarCurr)
    <=> ( v28526(VarCurr)
        | v28521(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2307,axiom,
    ! [VarCurr: state_type] :
      ( v28526(VarCurr)
    <=> ( v28507(VarCurr)
        | v28517(VarCurr) ) ) ).

tff(addAssignment_14667,axiom,
    ! [VarCurr: state_type] :
      ( v28521(VarCurr)
    <=> v28523(VarCurr) ) ).

tff(addAssignment_14666,axiom,
    ! [VarCurr: state_type] :
      ( v28523(VarCurr)
    <=> v28511(VarCurr,2) ) ).

tff(addAssignment_14665,axiom,
    ! [VarCurr: state_type] :
      ( v28511(VarCurr,2)
    <=> v28513(VarCurr,2) ) ).

tff(addAssignment_14664,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,2)
    <=> v28515(VarCurr,2) ) ).

tff(addAssignment_14663,axiom,
    ! [VarCurr: state_type] :
      ( v28517(VarCurr)
    <=> v28519(VarCurr) ) ).

tff(addAssignment_14662,axiom,
    ! [VarCurr: state_type] :
      ( v28519(VarCurr)
    <=> v28511(VarCurr,1) ) ).

tff(addAssignment_14661,axiom,
    ! [VarCurr: state_type] :
      ( v28511(VarCurr,1)
    <=> v28513(VarCurr,1) ) ).

tff(addAssignment_14660,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,1)
    <=> v28515(VarCurr,1) ) ).

tff(addAssignment_14659,axiom,
    ! [VarCurr: state_type] :
      ( v28507(VarCurr)
    <=> v28509(VarCurr) ) ).

tff(addAssignment_14658,axiom,
    ! [VarCurr: state_type] :
      ( v28509(VarCurr)
    <=> v28511(VarCurr,0) ) ).

tff(addAssignment_14657,axiom,
    ! [VarCurr: state_type] :
      ( v28511(VarCurr,0)
    <=> v28513(VarCurr,0) ) ).

tff(addAssignment_14656,axiom,
    ! [VarCurr: state_type] :
      ( v28513(VarCurr,0)
    <=> v28515(VarCurr,0) ) ).

tff(addAssignment_14655,axiom,
    ! [VarCurr: state_type] :
      ( v28493(VarCurr)
    <=> v28495(VarCurr) ) ).

tff(addAssignment_14654,axiom,
    ! [VarCurr: state_type] :
      ( v28495(VarCurr)
    <=> $false ) ).

tff(addAssignment_14653,axiom,
    ! [VarCurr: state_type] :
      ( v28485(VarCurr)
    <=> v28487(VarCurr) ) ).

tff(addAssignment_14652,axiom,
    ! [VarCurr: state_type] :
      ( v28487(VarCurr)
    <=> v28489(VarCurr) ) ).

tff(addAssignment_14651,axiom,
    ! [VarCurr: state_type] :
      ( v28489(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_14650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28149(VarCurr,B)
      <=> v28151(VarCurr,B) ) ) ).

tff(addAssignment_14649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28151(VarCurr,B)
      <=> v28153(VarCurr,B) ) ) ).

tff(addAssignment_14648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28153(VarCurr,B)
      <=> v28155(VarCurr,B) ) ) ).

tff(addAssignment_14647,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28155(VarCurr,B)
      <=> v28157(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28157(VarCurr,B)
      <=> ( v28159(VarCurr,B)
          & v28181(VarCurr,B) ) ) ) ).

tff(addAssignment_14646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28181(VarCurr,B)
      <=> v28183(VarCurr,B) ) ) ).

tff(addAssignment_14645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28183(VarCurr,B)
      <=> v28185(VarCurr,B) ) ) ).

tff(addAssignment_14644,axiom,
    ! [VarCurr: state_type] :
      ( ( v28185(VarCurr,11)
      <=> v9198(VarCurr,155) )
      & ( v28185(VarCurr,10)
      <=> v9198(VarCurr,154) )
      & ( v28185(VarCurr,9)
      <=> v9198(VarCurr,153) )
      & ( v28185(VarCurr,8)
      <=> v9198(VarCurr,152) )
      & ( v28185(VarCurr,7)
      <=> v9198(VarCurr,151) )
      & ( v28185(VarCurr,6)
      <=> v9198(VarCurr,150) )
      & ( v28185(VarCurr,5)
      <=> v9198(VarCurr,149) )
      & ( v28185(VarCurr,4)
      <=> v9198(VarCurr,148) )
      & ( v28185(VarCurr,3)
      <=> v9198(VarCurr,147) )
      & ( v28185(VarCurr,2)
      <=> v9198(VarCurr,146) )
      & ( v28185(VarCurr,1)
      <=> v9198(VarCurr,145) )
      & ( v28185(VarCurr,0)
      <=> v9198(VarCurr,144) ) ) ).

tff(addAssignment_14643,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,155)
      <=> v28187(VarCurr,11) )
      & ( v9198(VarCurr,154)
      <=> v28187(VarCurr,10) )
      & ( v9198(VarCurr,153)
      <=> v28187(VarCurr,9) )
      & ( v9198(VarCurr,152)
      <=> v28187(VarCurr,8) )
      & ( v9198(VarCurr,151)
      <=> v28187(VarCurr,7) )
      & ( v9198(VarCurr,150)
      <=> v28187(VarCurr,6) )
      & ( v9198(VarCurr,149)
      <=> v28187(VarCurr,5) )
      & ( v9198(VarCurr,148)
      <=> v28187(VarCurr,4) )
      & ( v9198(VarCurr,147)
      <=> v28187(VarCurr,3) )
      & ( v9198(VarCurr,146)
      <=> v28187(VarCurr,2) )
      & ( v9198(VarCurr,145)
      <=> v28187(VarCurr,1) )
      & ( v9198(VarCurr,144)
      <=> v28187(VarCurr,0) ) ) ).

tff(addAssignment_14642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28187(VarCurr,B)
      <=> v28189(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28189(VarCurr,B)
      <=> ( v28471(VarCurr,B)
          | v28474(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28474(VarCurr,B)
      <=> ( v28199(VarCurr,B)
          & v28475(VarCurr,B) ) ) ) ).

tff(addAssignment_14641,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,0)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14640,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,1)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14639,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,2)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14638,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,3)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14637,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,4)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14636,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,5)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14635,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,6)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14634,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,7)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14633,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,8)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14632,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,9)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14631,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,10)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14630,axiom,
    ! [VarCurr: state_type] :
      ( v28475(VarCurr,11)
    <=> v28476(VarCurr) ) ).

tff(addAssignment_14629,axiom,
    ! [VarCurr: state_type] :
      ( v28476(VarCurr)
    <=> v28467(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28471(VarCurr,B)
      <=> ( v28191(VarCurr,B)
          & v28472(VarCurr,B) ) ) ) ).

tff(addAssignment_14628,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,0)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14627,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,1)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14626,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,2)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14625,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,3)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14624,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,4)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14623,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,5)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14622,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,6)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14621,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,7)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14620,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,8)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14619,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,9)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14618,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,10)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14617,axiom,
    ! [VarCurr: state_type] :
      ( v28472(VarCurr,11)
    <=> v28473(VarCurr) ) ).

tff(addAssignment_14616,axiom,
    ! [VarCurr: state_type] :
      ( v28473(VarCurr)
    <=> v28195(VarCurr) ) ).

tff(addAssignment_14615,axiom,
    ! [VarCurr: state_type] :
      ( v28467(VarCurr)
    <=> v28469(VarCurr) ) ).

tff(addAssignment_14614,axiom,
    ! [VarCurr: state_type] :
      ( v28469(VarCurr)
    <=> v9844(VarCurr,12) ) ).

tff(addAssignment_14613,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,12)
    <=> v9846(VarCurr,12) ) ).

tff(addAssignment_14612,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,12)
    <=> v9496(VarCurr,12) ) ).

tff(addAssignment_14611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28199(VarCurr,B)
      <=> v28201(VarCurr,B) ) ) ).

tff(addAssignment_14610,axiom,
    ! [VarCurr: state_type] :
      ( ( v28201(VarCurr,11)
      <=> v9208(VarCurr,167) )
      & ( v28201(VarCurr,10)
      <=> v9208(VarCurr,166) )
      & ( v28201(VarCurr,9)
      <=> v9208(VarCurr,165) )
      & ( v28201(VarCurr,8)
      <=> v9208(VarCurr,164) )
      & ( v28201(VarCurr,7)
      <=> v9208(VarCurr,163) )
      & ( v28201(VarCurr,6)
      <=> v9208(VarCurr,162) )
      & ( v28201(VarCurr,5)
      <=> v9208(VarCurr,161) )
      & ( v28201(VarCurr,4)
      <=> v9208(VarCurr,160) )
      & ( v28201(VarCurr,3)
      <=> v9208(VarCurr,159) )
      & ( v28201(VarCurr,2)
      <=> v9208(VarCurr,158) )
      & ( v28201(VarCurr,1)
      <=> v9208(VarCurr,157) )
      & ( v28201(VarCurr,0)
      <=> v9208(VarCurr,156) ) ) ).

tff(addAssignment_14609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_14608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,168)
        & ~ $less(B,156) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_14607,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,167)
      <=> v28203(VarCurr,11) )
      & ( v9212(VarCurr,166)
      <=> v28203(VarCurr,10) )
      & ( v9212(VarCurr,165)
      <=> v28203(VarCurr,9) )
      & ( v9212(VarCurr,164)
      <=> v28203(VarCurr,8) )
      & ( v9212(VarCurr,163)
      <=> v28203(VarCurr,7) )
      & ( v9212(VarCurr,162)
      <=> v28203(VarCurr,6) )
      & ( v9212(VarCurr,161)
      <=> v28203(VarCurr,5) )
      & ( v9212(VarCurr,160)
      <=> v28203(VarCurr,4) )
      & ( v9212(VarCurr,159)
      <=> v28203(VarCurr,3) )
      & ( v9212(VarCurr,158)
      <=> v28203(VarCurr,2) )
      & ( v9212(VarCurr,157)
      <=> v28203(VarCurr,1) )
      & ( v9212(VarCurr,156)
      <=> v28203(VarCurr,0) ) ) ).

tff(addAssignment_14606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28203(VarCurr,B)
      <=> v28205(VarCurr,B) ) ) ).

tff(addAssignment_14605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28205(VarCurr,B)
      <=> v28207(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28450(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v28207(VarNext,B)
            <=> v28207(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_317,axiom,
    ! [VarNext: state_type] :
      ( v28450(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28207(VarNext,B)
          <=> v28460(VarNext,B) ) ) ) ).

tff(addAssignment_14604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28460(VarNext,B)
          <=> v28458(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28461(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28458(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_192,axiom,
    ! [VarCurr: state_type] :
      ( v28461(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28458(VarCurr,B)
          <=> v28237(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2306,axiom,
    ! [VarCurr: state_type] :
      ( v28461(VarCurr)
    <=> ( v28462(VarCurr)
        & v28463(VarCurr) ) ) ).

tff(writeUnaryOperator_1517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28463(VarCurr)
    <=> v28223(VarCurr) ) ).

tff(writeUnaryOperator_1516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28462(VarCurr)
    <=> v28209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28450(VarNext)
      <=> v28451(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28451(VarNext)
      <=> ( v28452(VarNext)
          & v28425(VarNext) ) ) ) ).

tff(writeUnaryOperator_1515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28452(VarNext)
      <=> v28454(VarNext) ) ) ).

tff(addAssignment_14603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28454(VarNext)
      <=> v28425(VarCurr) ) ) ).

tff(addAssignment_14602,axiom,
    ! [VarCurr: state_type] :
      ( v28425(VarCurr)
    <=> v28427(VarCurr) ) ).

tff(addAssignment_14601,axiom,
    ! [VarCurr: state_type] :
      ( v28427(VarCurr)
    <=> v28429(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2303,axiom,
    ! [VarCurr: state_type] :
      ( v28429(VarCurr)
    <=> ( v28447(VarCurr)
        | v28439(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2302,axiom,
    ! [VarCurr: state_type] :
      ( v28447(VarCurr)
    <=> ( v28431(VarCurr)
        & v28437(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_121,axiom,
    ( v28437(constB0)
  <=> $true ) ).

tff(addAssignment_14600,axiom,
    ! [VarCurr: state_type] :
      ( v28439(VarCurr)
    <=> v28441(VarCurr) ) ).

tff(addAssignment_14599,axiom,
    ! [VarCurr: state_type] :
      ( v28441(VarCurr)
    <=> v28443(VarCurr) ) ).

tff(addAssignment_14598,axiom,
    ! [VarCurr: state_type] :
      ( v28443(VarCurr)
    <=> v28445(VarCurr) ) ).

tff(addAssignment_14597,axiom,
    ! [VarCurr: state_type] :
      ( v28445(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_14596,axiom,
    ! [VarCurr: state_type] :
      ( v28431(VarCurr)
    <=> v28433(VarCurr) ) ).

tff(addAssignment_14595,axiom,
    ! [VarCurr: state_type] :
      ( v28433(VarCurr)
    <=> v28435(VarCurr) ) ).

tff(addAssignment_14594,axiom,
    ! [VarCurr: state_type] :
      ( v28435(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_14593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28237(VarCurr,B)
      <=> v28239(VarCurr,B) ) ) ).

tff(addAssignment_14592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28239(VarCurr,B)
      <=> v28241(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28241(VarCurr,B)
      <=> ( v28410(VarCurr,B)
          | v28421(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28421(VarCurr,B)
      <=> ( v28374(VarCurr,B)
          & v28422(VarCurr,B) ) ) ) ).

tff(addAssignment_14591,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,0)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14590,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,1)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14589,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,2)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14588,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,3)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14587,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,4)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14586,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,5)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14585,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,6)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14584,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,7)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14583,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,8)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14582,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,9)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14581,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,10)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14580,axiom,
    ! [VarCurr: state_type] :
      ( v28422(VarCurr,11)
    <=> v28423(VarCurr) ) ).

tff(addAssignment_14579,axiom,
    ! [VarCurr: state_type] :
      ( v28423(VarCurr)
    <=> v28384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28410(VarCurr,B)
      <=> ( v28411(VarCurr,B)
          | v28418(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28418(VarCurr,B)
      <=> ( v28338(VarCurr,B)
          & v28419(VarCurr,B) ) ) ) ).

tff(addAssignment_14578,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,0)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14577,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,1)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14576,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,2)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14575,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,3)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14574,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,4)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14573,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,5)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14572,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,6)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14571,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,7)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14570,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,8)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14569,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,9)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14568,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,10)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14567,axiom,
    ! [VarCurr: state_type] :
      ( v28419(VarCurr,11)
    <=> v28420(VarCurr) ) ).

tff(addAssignment_14566,axiom,
    ! [VarCurr: state_type] :
      ( v28420(VarCurr)
    <=> v28348(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28411(VarCurr,B)
      <=> ( v28412(VarCurr,B)
          | v28415(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28415(VarCurr,B)
      <=> ( v28291(VarCurr,B)
          & v28416(VarCurr,B) ) ) ) ).

tff(addAssignment_14565,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,0)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14564,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,1)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14563,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,2)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14562,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,3)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14561,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,4)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14560,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,5)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14559,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,6)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14558,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,7)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14557,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,8)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14556,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,9)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14555,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,10)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14554,axiom,
    ! [VarCurr: state_type] :
      ( v28416(VarCurr,11)
    <=> v28417(VarCurr) ) ).

tff(addAssignment_14553,axiom,
    ! [VarCurr: state_type] :
      ( v28417(VarCurr)
    <=> v28301(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28412(VarCurr,B)
      <=> ( v28243(VarCurr,B)
          & v28413(VarCurr,B) ) ) ) ).

tff(addAssignment_14552,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,0)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14551,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,1)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14550,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,2)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14549,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,3)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14548,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,4)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14547,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,5)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14546,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,6)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14545,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,7)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14544,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,8)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14543,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,9)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14542,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,10)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14541,axiom,
    ! [VarCurr: state_type] :
      ( v28413(VarCurr,11)
    <=> v28414(VarCurr) ) ).

tff(addAssignment_14540,axiom,
    ! [VarCurr: state_type] :
      ( v28414(VarCurr)
    <=> v28253(VarCurr) ) ).

tff(addAssignment_14539,axiom,
    ! [VarCurr: state_type] :
      ( v28384(VarCurr)
    <=> v28386(VarCurr) ) ).

tff(addAssignment_14538,axiom,
    ! [VarCurr: state_type] :
      ( v28386(VarCurr)
    <=> v28388(VarCurr) ) ).

tff(addAssignment_14537,axiom,
    ! [VarCurr: state_type] :
      ( v28388(VarCurr)
    <=> v28390(VarCurr) ) ).

tff(addAssignment_14536,axiom,
    ! [VarCurr: state_type] :
      ( v28390(VarCurr)
    <=> v28392(VarCurr) ) ).

tff(addAssignment_14535,axiom,
    ! [VarCurr: state_type] :
      ( v28392(VarCurr)
    <=> v28394(VarCurr) ) ).

tff(addAssignment_14534,axiom,
    ! [VarCurr: state_type] :
      ( v28394(VarCurr)
    <=> v28396(VarCurr) ) ).

tff(addAssignment_14533,axiom,
    ! [VarCurr: state_type] :
      ( v28396(VarCurr)
    <=> v28398(VarCurr) ) ).

tff(writeUnaryOperator_1514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28398(VarCurr)
    <=> v28408(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2301,axiom,
    ! [VarCurr: state_type] :
      ( v28408(VarCurr)
    <=> ( v28400(VarCurr)
        | v28404(VarCurr) ) ) ).

tff(addAssignment_14532,axiom,
    ! [VarCurr: state_type] :
      ( v28404(VarCurr)
    <=> v28406(VarCurr) ) ).

tff(addAssignment_14531,axiom,
    ! [VarCurr: state_type] :
      ( v28406(VarCurr)
    <=> v28321(VarCurr,1) ) ).

tff(addAssignment_14530,axiom,
    ! [VarCurr: state_type] :
      ( v28400(VarCurr)
    <=> v28402(VarCurr) ) ).

tff(addAssignment_14529,axiom,
    ! [VarCurr: state_type] :
      ( v28402(VarCurr)
    <=> v28321(VarCurr,0) ) ).

tff(addAssignment_14528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28374(VarCurr,B)
      <=> v28376(VarCurr,B) ) ) ).

tff(addAssignment_14527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28376(VarCurr,B)
      <=> v28378(VarCurr,B) ) ) ).

tff(addAssignment_14526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28378(VarCurr,B)
      <=> v28380(VarCurr,B) ) ) ).

tff(addAssignment_14525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28380(VarCurr,B)
      <=> v28382(VarCurr,B) ) ) ).

tff(addAssignment_14524,axiom,
    ! [VarCurr: state_type] :
      ( v28348(VarCurr)
    <=> v28350(VarCurr) ) ).

tff(addAssignment_14523,axiom,
    ! [VarCurr: state_type] :
      ( v28350(VarCurr)
    <=> v28352(VarCurr) ) ).

tff(addAssignment_14522,axiom,
    ! [VarCurr: state_type] :
      ( v28352(VarCurr)
    <=> v28354(VarCurr) ) ).

tff(addAssignment_14521,axiom,
    ! [VarCurr: state_type] :
      ( v28354(VarCurr)
    <=> v28356(VarCurr) ) ).

tff(addAssignment_14520,axiom,
    ! [VarCurr: state_type] :
      ( v28356(VarCurr)
    <=> v28358(VarCurr) ) ).

tff(addAssignment_14519,axiom,
    ! [VarCurr: state_type] :
      ( v28358(VarCurr)
    <=> v28360(VarCurr) ) ).

tff(addAssignment_14518,axiom,
    ! [VarCurr: state_type] :
      ( v28360(VarCurr)
    <=> v28362(VarCurr) ) ).

tff(writeUnaryOperator_1513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28362(VarCurr)
    <=> v28372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2300,axiom,
    ! [VarCurr: state_type] :
      ( v28372(VarCurr)
    <=> ( v28364(VarCurr)
        | v28368(VarCurr) ) ) ).

tff(addAssignment_14517,axiom,
    ! [VarCurr: state_type] :
      ( v28368(VarCurr)
    <=> v28370(VarCurr) ) ).

tff(addAssignment_14516,axiom,
    ! [VarCurr: state_type] :
      ( v28370(VarCurr)
    <=> v28321(VarCurr,1) ) ).

tff(addAssignment_14515,axiom,
    ! [VarCurr: state_type] :
      ( v28321(VarCurr,1)
    <=> v28323(VarCurr,1) ) ).

tff(addAssignment_14514,axiom,
    ! [VarCurr: state_type] :
      ( v28323(VarCurr,1)
    <=> v28325(VarCurr,1) ) ).

tff(addAssignment_14513,axiom,
    ! [VarCurr: state_type] :
      ( v28325(VarCurr,1)
    <=> v28330(VarCurr,1) ) ).

tff(addAssignment_14512,axiom,
    ! [VarCurr: state_type] :
      ( v28327(VarCurr,1)
    <=> v28329(VarCurr,1) ) ).

tff(addAssignment_14511,axiom,
    ! [VarCurr: state_type] :
      ( v28329(VarCurr,1)
    <=> v28273(VarCurr,1) ) ).

tff(addAssignment_14510,axiom,
    ! [VarCurr: state_type] :
      ( v28364(VarCurr)
    <=> v28366(VarCurr) ) ).

tff(addAssignment_14509,axiom,
    ! [VarCurr: state_type] :
      ( v28366(VarCurr)
    <=> v28273(VarCurr,0) ) ).

tff(addAssignment_14508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28338(VarCurr,B)
      <=> v28340(VarCurr,B) ) ) ).

tff(addAssignment_14507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28340(VarCurr,B)
      <=> v28342(VarCurr,B) ) ) ).

tff(addAssignment_14506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28342(VarCurr,B)
      <=> v28344(VarCurr,B) ) ) ).

tff(addAssignment_14505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28344(VarCurr,B)
      <=> v28346(VarCurr,B) ) ) ).

tff(addAssignment_14504,axiom,
    ! [VarCurr: state_type] :
      ( v28301(VarCurr)
    <=> v28303(VarCurr) ) ).

tff(addAssignment_14503,axiom,
    ! [VarCurr: state_type] :
      ( v28303(VarCurr)
    <=> v28305(VarCurr) ) ).

tff(addAssignment_14502,axiom,
    ! [VarCurr: state_type] :
      ( v28305(VarCurr)
    <=> v28307(VarCurr) ) ).

tff(addAssignment_14501,axiom,
    ! [VarCurr: state_type] :
      ( v28307(VarCurr)
    <=> v28309(VarCurr) ) ).

tff(addAssignment_14500,axiom,
    ! [VarCurr: state_type] :
      ( v28309(VarCurr)
    <=> v28311(VarCurr) ) ).

tff(addAssignment_14499,axiom,
    ! [VarCurr: state_type] :
      ( v28311(VarCurr)
    <=> v28313(VarCurr) ) ).

tff(addAssignment_14498,axiom,
    ! [VarCurr: state_type] :
      ( v28313(VarCurr)
    <=> v28315(VarCurr) ) ).

tff(writeUnaryOperator_1512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28315(VarCurr)
    <=> v28336(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2299,axiom,
    ! [VarCurr: state_type] :
      ( v28336(VarCurr)
    <=> ( v28317(VarCurr)
        | v28332(VarCurr) ) ) ).

tff(addAssignment_14497,axiom,
    ! [VarCurr: state_type] :
      ( v28332(VarCurr)
    <=> v28334(VarCurr) ) ).

tff(addAssignment_14496,axiom,
    ! [VarCurr: state_type] :
      ( v28334(VarCurr)
    <=> v28273(VarCurr,1) ) ).

tff(addAssignment_14495,axiom,
    ! [VarCurr: state_type] :
      ( v28317(VarCurr)
    <=> v28319(VarCurr) ) ).

tff(addAssignment_14494,axiom,
    ! [VarCurr: state_type] :
      ( v28319(VarCurr)
    <=> v28321(VarCurr,0) ) ).

tff(addAssignment_14493,axiom,
    ! [VarCurr: state_type] :
      ( v28321(VarCurr,0)
    <=> v28323(VarCurr,0) ) ).

tff(addAssignment_14492,axiom,
    ! [VarCurr: state_type] :
      ( v28323(VarCurr,0)
    <=> v28325(VarCurr,0) ) ).

tff(addAssignment_14491,axiom,
    ! [VarCurr: state_type] :
      ( v28325(VarCurr,0)
    <=> v28330(VarCurr,0) ) ).

tff(writeUnaryOperator_1511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v28330(VarCurr,B)
      <=> ~ v28327(VarCurr,B) ) ) ).

tff(addAssignment_14490,axiom,
    ! [VarCurr: state_type] :
      ( v28327(VarCurr,0)
    <=> v28329(VarCurr,0) ) ).

tff(addAssignment_14489,axiom,
    ! [VarCurr: state_type] :
      ( v28329(VarCurr,0)
    <=> v28273(VarCurr,0) ) ).

tff(addAssignment_14488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28291(VarCurr,B)
      <=> v28293(VarCurr,B) ) ) ).

tff(addAssignment_14487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28293(VarCurr,B)
      <=> v28295(VarCurr,B) ) ) ).

tff(addAssignment_14486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28295(VarCurr,B)
      <=> v28297(VarCurr,B) ) ) ).

tff(addAssignment_14485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28297(VarCurr,B)
      <=> v28299(VarCurr,B) ) ) ).

tff(addAssignment_14484,axiom,
    ! [VarCurr: state_type] :
      ( v28253(VarCurr)
    <=> v28255(VarCurr) ) ).

tff(addAssignment_14483,axiom,
    ! [VarCurr: state_type] :
      ( v28255(VarCurr)
    <=> v28257(VarCurr) ) ).

tff(addAssignment_14482,axiom,
    ! [VarCurr: state_type] :
      ( v28257(VarCurr)
    <=> v28259(VarCurr) ) ).

tff(addAssignment_14481,axiom,
    ! [VarCurr: state_type] :
      ( v28259(VarCurr)
    <=> v28261(VarCurr) ) ).

tff(addAssignment_14480,axiom,
    ! [VarCurr: state_type] :
      ( v28261(VarCurr)
    <=> v28263(VarCurr) ) ).

tff(addAssignment_14479,axiom,
    ! [VarCurr: state_type] :
      ( v28263(VarCurr)
    <=> v28265(VarCurr) ) ).

tff(addAssignment_14478,axiom,
    ! [VarCurr: state_type] :
      ( v28265(VarCurr)
    <=> v28267(VarCurr) ) ).

tff(writeUnaryOperator_1510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28267(VarCurr)
    <=> v28289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2298,axiom,
    ! [VarCurr: state_type] :
      ( v28289(VarCurr)
    <=> ( v28269(VarCurr)
        | v28285(VarCurr) ) ) ).

tff(addAssignment_14477,axiom,
    ! [VarCurr: state_type] :
      ( v28285(VarCurr)
    <=> v28287(VarCurr) ) ).

tff(addAssignment_14476,axiom,
    ! [VarCurr: state_type] :
      ( v28287(VarCurr)
    <=> v28273(VarCurr,1) ) ).

tff(addAssignment_14475,axiom,
    ! [VarCurr: state_type] :
      ( v28273(VarCurr,1)
    <=> v28275(VarCurr,1) ) ).

tff(addAssignment_14474,axiom,
    ! [VarCurr: state_type] :
      ( v28275(VarCurr,1)
    <=> v28277(VarCurr,1) ) ).

tff(addAssignment_14473,axiom,
    ! [VarCurr: state_type] :
      ( v28277(VarCurr,1)
    <=> v28279(VarCurr,1) ) ).

tff(addAssignment_14472,axiom,
    ! [VarCurr: state_type] :
      ( v28279(VarCurr,1)
    <=> v28281(VarCurr,1) ) ).

tff(addAssignment_14471,axiom,
    ! [VarCurr: state_type] :
      ( v28281(VarCurr,1)
    <=> v28283(VarCurr,1) ) ).

tff(addAssignment_14470,axiom,
    ! [VarCurr: state_type] :
      ( v28269(VarCurr)
    <=> v28271(VarCurr) ) ).

tff(addAssignment_14469,axiom,
    ! [VarCurr: state_type] :
      ( v28271(VarCurr)
    <=> v28273(VarCurr,0) ) ).

tff(addAssignment_14468,axiom,
    ! [VarCurr: state_type] :
      ( v28273(VarCurr,0)
    <=> v28275(VarCurr,0) ) ).

tff(addAssignment_14467,axiom,
    ! [VarCurr: state_type] :
      ( v28275(VarCurr,0)
    <=> v28277(VarCurr,0) ) ).

tff(addAssignment_14466,axiom,
    ! [VarCurr: state_type] :
      ( v28277(VarCurr,0)
    <=> v28279(VarCurr,0) ) ).

tff(addAssignment_14465,axiom,
    ! [VarCurr: state_type] :
      ( v28279(VarCurr,0)
    <=> v28281(VarCurr,0) ) ).

tff(addAssignment_14464,axiom,
    ! [VarCurr: state_type] :
      ( v28281(VarCurr,0)
    <=> v28283(VarCurr,0) ) ).

tff(addAssignment_14463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28243(VarCurr,B)
      <=> v28245(VarCurr,B) ) ) ).

tff(addAssignment_14462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28245(VarCurr,B)
      <=> v28247(VarCurr,B) ) ) ).

tff(addAssignment_14461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28247(VarCurr,B)
      <=> v28249(VarCurr,B) ) ) ).

tff(addAssignment_14460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28249(VarCurr,B)
      <=> v28251(VarCurr,B) ) ) ).

tff(addAssignment_14459,axiom,
    ! [VarCurr: state_type] :
      ( v28223(VarCurr)
    <=> v28225(VarCurr) ) ).

tff(addAssignment_14458,axiom,
    ! [VarCurr: state_type] :
      ( v28225(VarCurr)
    <=> v28227(VarCurr) ) ).

tff(addAssignment_14457,axiom,
    ! [VarCurr: state_type] :
      ( v28227(VarCurr)
    <=> v28229(VarCurr) ) ).

tff(addAssignment_14456,axiom,
    ! [VarCurr: state_type] :
      ( v28229(VarCurr)
    <=> v28231(VarCurr) ) ).

tff(addAssignment_14455,axiom,
    ! [VarCurr: state_type] :
      ( v28231(VarCurr)
    <=> v28233(VarCurr) ) ).

tff(addAssignment_14454,axiom,
    ! [VarCurr: state_type] :
      ( v28233(VarCurr)
    <=> v28235(VarCurr) ) ).

tff(addAssignment_14453,axiom,
    ! [VarCurr: state_type] :
      ( v28235(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_14452,axiom,
    ! [VarCurr: state_type] :
      ( v28209(VarCurr)
    <=> v28211(VarCurr) ) ).

tff(addAssignment_14451,axiom,
    ! [VarCurr: state_type] :
      ( v28211(VarCurr)
    <=> v28213(VarCurr) ) ).

tff(addAssignment_14450,axiom,
    ! [VarCurr: state_type] :
      ( v28213(VarCurr)
    <=> v28215(VarCurr) ) ).

tff(addAssignment_14449,axiom,
    ! [VarCurr: state_type] :
      ( v28215(VarCurr)
    <=> v28217(VarCurr) ) ).

tff(addAssignment_14448,axiom,
    ! [VarCurr: state_type] :
      ( v28217(VarCurr)
    <=> v28219(VarCurr) ) ).

tff(addAssignment_14447,axiom,
    ! [VarCurr: state_type] :
      ( v28219(VarCurr)
    <=> v28221(VarCurr) ) ).

tff(addAssignment_14446,axiom,
    ! [VarCurr: state_type] :
      ( v28221(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_14445,axiom,
    ! [VarCurr: state_type] :
      ( v28195(VarCurr)
    <=> v28197(VarCurr) ) ).

tff(addAssignment_14444,axiom,
    ! [VarCurr: state_type] :
      ( v28197(VarCurr)
    <=> v9490(VarCurr,12) ) ).

tff(addAssignment_14443,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,12)
    <=> v9492(VarCurr,12) ) ).

tff(addAssignment_14442,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,12)
    <=> v9494(VarCurr,12) ) ).

tff(addAssignment_14441,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,12)
    <=> v9570(VarCurr,12) ) ).

tff(addAssignment_14440,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,12)
    <=> v9513(VarCurr,12) ) ).

tff(addAssignment_14439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28191(VarCurr,B)
      <=> v28193(VarCurr,B) ) ) ).

tff(addAssignment_14438,axiom,
    ! [VarCurr: state_type] :
      ( ( v28193(VarCurr,11)
      <=> v9208(VarCurr,155) )
      & ( v28193(VarCurr,10)
      <=> v9208(VarCurr,154) )
      & ( v28193(VarCurr,9)
      <=> v9208(VarCurr,153) )
      & ( v28193(VarCurr,8)
      <=> v9208(VarCurr,152) )
      & ( v28193(VarCurr,7)
      <=> v9208(VarCurr,151) )
      & ( v28193(VarCurr,6)
      <=> v9208(VarCurr,150) )
      & ( v28193(VarCurr,5)
      <=> v9208(VarCurr,149) )
      & ( v28193(VarCurr,4)
      <=> v9208(VarCurr,148) )
      & ( v28193(VarCurr,3)
      <=> v9208(VarCurr,147) )
      & ( v28193(VarCurr,2)
      <=> v9208(VarCurr,146) )
      & ( v28193(VarCurr,1)
      <=> v9208(VarCurr,145) )
      & ( v28193(VarCurr,0)
      <=> v9208(VarCurr,144) ) ) ).

tff(addAssignment_14437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28159(VarCurr,B)
      <=> v28161(VarCurr,B) ) ) ).

tff(addAssignment_14436,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,0)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14435,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,1)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14434,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,2)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14433,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,3)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14432,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,4)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14431,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,5)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14430,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,6)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14429,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,7)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14428,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,8)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14427,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,9)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14426,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,10)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14425,axiom,
    ! [VarCurr: state_type] :
      ( v28161(VarCurr,11)
    <=> v28179(VarCurr) ) ).

tff(addAssignment_14424,axiom,
    ! [VarCurr: state_type] :
      ( v28179(VarCurr)
    <=> v28163(VarCurr) ) ).

tff(addAssignment_14423,axiom,
    ! [VarCurr: state_type] :
      ( v28163(VarCurr)
    <=> v28165(VarCurr,0) ) ).

tff(addAssignment_14422,axiom,
    ! [VarCurr: state_type] :
      ( v28165(VarCurr,0)
    <=> v28167(VarCurr,0) ) ).

tff(addAssignment_14421,axiom,
    ! [VarCurr: state_type] :
      ( v28167(VarCurr,0)
    <=> v28177(VarCurr,0) ) ).

tff(writeUnaryOperator_1509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v28177(VarCurr,B)
      <=> ~ v28169(VarCurr,B) ) ) ).

tff(addAssignment_14420,axiom,
    ! [VarCurr: state_type] :
      ( v28169(VarCurr,0)
    <=> v28171(VarCurr,0) ) ).

tff(addAssignment_14419,axiom,
    ! [VarCurr: state_type] :
      ( v28171(VarCurr,0)
    <=> v28174(VarCurr,0) ) ).

tff(addAssignment_14418,axiom,
    ! [VarCurr: state_type] :
      ( v28174(VarCurr,0)
    <=> v28173(VarCurr) ) ).

tff(addAssignment_14417,axiom,
    ! [VarCurr: state_type] :
      ( v28174(VarCurr,1)
    <=> v28176(VarCurr) ) ).

tff(addAssignment_14416,axiom,
    ! [VarCurr: state_type] :
      ( v28174(VarCurr,2)
    <=> v28175(VarCurr) ) ).

tff(addAssignment_14415,axiom,
    ! [VarCurr: state_type] :
      ( v28173(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_14414,axiom,
    ! [VarCurr: state_type] :
      ( v28135(VarCurr)
    <=> v28137(VarCurr) ) ).

tff(addAssignment_14413,axiom,
    ! [VarCurr: state_type] :
      ( v28137(VarCurr)
    <=> v28139(VarCurr) ) ).

tff(addAssignment_14412,axiom,
    ! [VarCurr: state_type] :
      ( v28139(VarCurr)
    <=> v28141(VarCurr) ) ).

tff(addAssignment_14411,axiom,
    ! [VarCurr: state_type] :
      ( v28141(VarCurr)
    <=> v28143(VarCurr) ) ).

tff(addAssignment_14410,axiom,
    ! [VarCurr: state_type] :
      ( v28143(VarCurr)
    <=> v28145(VarCurr) ) ).

tff(addAssignment_14409,axiom,
    ! [VarCurr: state_type] :
      ( v28145(VarCurr)
    <=> v28147(VarCurr) ) ).

tff(addAssignment_14408,axiom,
    ! [VarCurr: state_type] :
      ( v28147(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_14407,axiom,
    ! [VarCurr: state_type] :
      ( v28121(VarCurr)
    <=> v28123(VarCurr) ) ).

tff(addAssignment_14406,axiom,
    ! [VarCurr: state_type] :
      ( v28123(VarCurr)
    <=> v28125(VarCurr) ) ).

tff(addAssignment_14405,axiom,
    ! [VarCurr: state_type] :
      ( v28125(VarCurr)
    <=> v28127(VarCurr) ) ).

tff(addAssignment_14404,axiom,
    ! [VarCurr: state_type] :
      ( v28127(VarCurr)
    <=> v28129(VarCurr) ) ).

tff(addAssignment_14403,axiom,
    ! [VarCurr: state_type] :
      ( v28129(VarCurr)
    <=> v28131(VarCurr) ) ).

tff(addAssignment_14402,axiom,
    ! [VarCurr: state_type] :
      ( v28131(VarCurr)
    <=> v28133(VarCurr) ) ).

tff(addAssignment_14401,axiom,
    ! [VarCurr: state_type] :
      ( v28133(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_14400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28097(VarCurr,B)
      <=> v28099(VarCurr,B) ) ) ).

tff(addAssignment_14399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28099(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_14398,axiom,
    ! [VarCurr: state_type] :
      ( v26541(VarCurr)
    <=> v26543(VarCurr) ) ).

tff(addAssignment_14397,axiom,
    ! [VarCurr: state_type] :
      ( v26543(VarCurr)
    <=> v26545(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_97,axiom,
    ! [VarCurr: state_type] :
      ( v26545(VarCurr)
    <=> ( ( v26547(VarCurr,11)
        <=> v26551(VarCurr,11) )
        & ( v26547(VarCurr,10)
        <=> v26551(VarCurr,10) )
        & ( v26547(VarCurr,9)
        <=> v26551(VarCurr,9) )
        & ( v26547(VarCurr,8)
        <=> v26551(VarCurr,8) )
        & ( v26547(VarCurr,7)
        <=> v26551(VarCurr,7) )
        & ( v26547(VarCurr,6)
        <=> v26551(VarCurr,6) )
        & ( v26547(VarCurr,5)
        <=> v26551(VarCurr,5) )
        & ( v26547(VarCurr,4)
        <=> v26551(VarCurr,4) )
        & ( v26547(VarCurr,3)
        <=> v26551(VarCurr,3) )
        & ( v26547(VarCurr,2)
        <=> v26551(VarCurr,2) )
        & ( v26547(VarCurr,1)
        <=> v26551(VarCurr,1) )
        & ( v26547(VarCurr,0)
        <=> v26551(VarCurr,0) ) ) ) ).

tff(addAssignment_14396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26551(VarCurr,B)
      <=> v26553(VarCurr,B) ) ) ).

tff(addAssignment_14395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26553(VarCurr,B)
      <=> v26555(VarCurr,B) ) ) ).

tff(addAssignment_14394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26555(VarCurr,B)
      <=> v26557(VarCurr,B) ) ) ).

tff(addAssignment_14393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26557(VarCurr,B)
      <=> v26559(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26559(VarCurr,B)
      <=> ( v28067(VarCurr,B)
          | v28086(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28086(VarCurr,B)
      <=> ( v27938(VarCurr,B)
          & v28087(VarCurr,B) ) ) ) ).

tff(addAssignment_14392,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,0)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14391,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,1)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14390,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,2)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14389,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,3)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14388,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,4)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14387,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,5)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14386,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,6)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14385,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,7)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14384,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,8)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14383,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,9)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14382,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,10)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14381,axiom,
    ! [VarCurr: state_type] :
      ( v28087(VarCurr,11)
    <=> v28088(VarCurr) ) ).

tff(addAssignment_14380,axiom,
    ! [VarCurr: state_type] :
      ( v28088(VarCurr)
    <=> v28057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28067(VarCurr,B)
      <=> ( v28068(VarCurr,B)
          | v28083(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28083(VarCurr,B)
      <=> ( v27787(VarCurr,B)
          & v28084(VarCurr,B) ) ) ) ).

tff(addAssignment_14379,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,0)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14378,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,1)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14377,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,2)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14376,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,3)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14375,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,4)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14374,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,5)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14373,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,6)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14372,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,7)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14371,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,8)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14370,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,9)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14369,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,10)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14368,axiom,
    ! [VarCurr: state_type] :
      ( v28084(VarCurr,11)
    <=> v28085(VarCurr) ) ).

tff(addAssignment_14367,axiom,
    ! [VarCurr: state_type] :
      ( v28085(VarCurr)
    <=> v27907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28068(VarCurr,B)
      <=> ( v28069(VarCurr,B)
          | v28080(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_463,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28080(VarCurr,B)
      <=> ( v27636(VarCurr,B)
          & v28081(VarCurr,B) ) ) ) ).

tff(addAssignment_14366,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,0)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14365,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,1)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14364,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,2)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14363,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,3)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14362,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,4)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14361,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,5)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14360,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,6)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14359,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,7)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14358,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,8)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14357,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,9)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14356,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,10)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14355,axiom,
    ! [VarCurr: state_type] :
      ( v28081(VarCurr,11)
    <=> v28082(VarCurr) ) ).

tff(addAssignment_14354,axiom,
    ! [VarCurr: state_type] :
      ( v28082(VarCurr)
    <=> v27756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28069(VarCurr,B)
      <=> ( v28070(VarCurr,B)
          | v28077(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28077(VarCurr,B)
      <=> ( v27485(VarCurr,B)
          & v28078(VarCurr,B) ) ) ) ).

tff(addAssignment_14353,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,0)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14352,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,1)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14351,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,2)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14350,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,3)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14349,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,4)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14348,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,5)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14347,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,6)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14346,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,7)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14345,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,8)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14344,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,9)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14343,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,10)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14342,axiom,
    ! [VarCurr: state_type] :
      ( v28078(VarCurr,11)
    <=> v28079(VarCurr) ) ).

tff(addAssignment_14341,axiom,
    ! [VarCurr: state_type] :
      ( v28079(VarCurr)
    <=> v27605(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28070(VarCurr,B)
      <=> ( v28071(VarCurr,B)
          | v28074(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28074(VarCurr,B)
      <=> ( v27323(VarCurr,B)
          & v28075(VarCurr,B) ) ) ) ).

tff(addAssignment_14340,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,0)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14339,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,1)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14338,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,2)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14337,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,3)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14336,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,4)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14335,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,5)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14334,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,6)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14333,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,7)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14332,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,8)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14331,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,9)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14330,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,10)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14329,axiom,
    ! [VarCurr: state_type] :
      ( v28075(VarCurr,11)
    <=> v28076(VarCurr) ) ).

tff(addAssignment_14328,axiom,
    ! [VarCurr: state_type] :
      ( v28076(VarCurr)
    <=> v27454(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v28071(VarCurr,B)
      <=> ( v26561(VarCurr,B)
          & v28072(VarCurr,B) ) ) ) ).

tff(addAssignment_14327,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,0)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14326,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,1)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14325,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,2)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14324,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,3)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14323,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,4)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14322,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,5)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14321,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,6)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14320,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,7)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14319,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,8)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14318,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,9)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14317,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,10)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14316,axiom,
    ! [VarCurr: state_type] :
      ( v28072(VarCurr,11)
    <=> v28073(VarCurr) ) ).

tff(addAssignment_14315,axiom,
    ! [VarCurr: state_type] :
      ( v28073(VarCurr)
    <=> v27031(VarCurr) ) ).

tff(addAssignment_14314,axiom,
    ! [VarCurr: state_type] :
      ( v28057(VarCurr)
    <=> v28059(VarCurr) ) ).

tff(addAssignment_14313,axiom,
    ! [VarCurr: state_type] :
      ( v28059(VarCurr)
    <=> v28061(VarCurr) ) ).

tff(addAssignment_14312,axiom,
    ! [VarCurr: state_type] :
      ( v28061(VarCurr)
    <=> v28063(VarCurr) ) ).

tff(addAssignment_14311,axiom,
    ! [VarCurr: state_type] :
      ( v28063(VarCurr)
    <=> v28065(VarCurr) ) ).

tff(addAssignment_14310,axiom,
    ! [VarCurr: state_type] :
      ( v28065(VarCurr)
    <=> v27124(VarCurr) ) ).

tff(addAssignment_14309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27938(VarCurr,B)
      <=> v27940(VarCurr,B) ) ) ).

tff(addAssignment_14308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27940(VarCurr,B)
      <=> v27942(VarCurr,B) ) ) ).

tff(addAssignment_14307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27942(VarCurr,B)
      <=> v27944(VarCurr,B) ) ) ).

tff(addAssignment_14306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27944(VarCurr,B)
      <=> v27946(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28040(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v27946(VarNext,B)
            <=> v27946(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_316,axiom,
    ! [VarNext: state_type] :
      ( v28040(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27946(VarNext,B)
          <=> v28050(VarNext,B) ) ) ) ).

tff(addAssignment_14305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28050(VarNext,B)
          <=> v28048(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28048(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_191,axiom,
    ! [VarCurr: state_type] :
      ( v28051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v28048(VarCurr,B)
          <=> v27968(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2297,axiom,
    ! [VarCurr: state_type] :
      ( v28051(VarCurr)
    <=> ( v28052(VarCurr)
        & v28053(VarCurr) ) ) ).

tff(writeUnaryOperator_1508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28053(VarCurr)
    <=> v27958(VarCurr) ) ).

tff(writeUnaryOperator_1507,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28052(VarCurr)
    <=> v27948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28040(VarNext)
      <=> v28041(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28041(VarNext)
      <=> ( v28042(VarNext)
          & v27972(VarNext) ) ) ) ).

tff(writeUnaryOperator_1506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28042(VarNext)
      <=> v28044(VarNext) ) ) ).

tff(addAssignment_14304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28044(VarNext)
      <=> v27972(VarCurr) ) ) ).

tff(addAssignment_14303,axiom,
    ! [VarCurr: state_type] :
      ( v27972(VarCurr)
    <=> v27974(VarCurr) ) ).

tff(addAssignment_14302,axiom,
    ! [VarCurr: state_type] :
      ( v27974(VarCurr)
    <=> v27976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2294,axiom,
    ! [VarCurr: state_type] :
      ( v27976(VarCurr)
    <=> ( v28037(VarCurr)
        | v28033(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2293,axiom,
    ! [VarCurr: state_type] :
      ( v28037(VarCurr)
    <=> ( v27978(VarCurr)
        & v27982(VarCurr) ) ) ).

tff(addAssignment_14301,axiom,
    ! [VarCurr: state_type] :
      ( v28033(VarCurr)
    <=> v28035(VarCurr) ) ).

tff(addAssignment_14300,axiom,
    ! [VarCurr: state_type] :
      ( v28035(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_315,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v28017(VarNext)
       => ( v27982(VarNext)
        <=> v27982(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_315,axiom,
    ! [VarNext: state_type] :
      ( v28017(VarNext)
     => ( v27982(VarNext)
      <=> v28027(VarNext) ) ) ).

tff(addAssignment_14299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28027(VarNext)
      <=> v28025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2292,axiom,
    ! [VarCurr: state_type] :
      ( v28025(VarCurr)
    <=> ( v28028(VarCurr)
        & v28029(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2291,axiom,
    ! [VarCurr: state_type] :
      ( v28029(VarCurr)
    <=> ( v27988(VarCurr)
        | v28012(VarCurr) ) ) ).

tff(writeUnaryOperator_1505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28028(VarCurr)
    <=> v27984(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28017(VarNext)
      <=> v28018(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28018(VarNext)
      <=> ( v28020(VarNext)
          & v28022(VarNext) ) ) ) ).

tff(writeUnaryOperator_1504,axiom,
    ! [VarCurr: state_type] :
      ( ~ v28022(VarCurr)
    <=> v27978(VarCurr) ) ).

tff(addAssignment_14298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v28020(VarNext)
      <=> v27978(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_120,axiom,
    ( v27982(constB0)
  <=> $true ) ).

tff(addAssignment_14297,axiom,
    ! [VarCurr: state_type] :
      ( v28012(VarCurr)
    <=> v28014(VarCurr) ) ).

tff(addAssignment_14296,axiom,
    ! [VarCurr: state_type] :
      ( v28014(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_14295,axiom,
    ! [VarCurr: state_type] :
      ( v27988(VarCurr)
    <=> v27990(VarCurr) ) ).

tff(addAssignment_14294,axiom,
    ! [VarCurr: state_type] :
      ( v27990(VarCurr)
    <=> v27298(VarCurr) ) ).

tff(addAssignment_14293,axiom,
    ! [VarCurr: state_type] :
      ( v27298(VarCurr)
    <=> v27993(VarCurr) ) ).

tff(addAssignment_14292,axiom,
    ! [VarCurr: state_type] :
      ( v27993(VarCurr)
    <=> v27995(VarCurr) ) ).

tff(writeUnaryOperator_1503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27995(VarCurr)
    <=> v28009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2288,axiom,
    ! [VarCurr: state_type] :
      ( v28009(VarCurr)
    <=> ( v28010(VarCurr)
        | v28005(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2287,axiom,
    ! [VarCurr: state_type] :
      ( v28010(VarCurr)
    <=> ( v27997(VarCurr)
        | v28001(VarCurr) ) ) ).

tff(addAssignment_14291,axiom,
    ! [VarCurr: state_type] :
      ( v28005(VarCurr)
    <=> v28007(VarCurr) ) ).

tff(addAssignment_14290,axiom,
    ! [VarCurr: state_type] :
      ( v28007(VarCurr)
    <=> v27387(VarCurr,2) ) ).

tff(addAssignment_14289,axiom,
    ! [VarCurr: state_type] :
      ( v28001(VarCurr)
    <=> v28003(VarCurr) ) ).

tff(addAssignment_14288,axiom,
    ! [VarCurr: state_type] :
      ( v28003(VarCurr)
    <=> v26961(VarCurr,1) ) ).

tff(addAssignment_14287,axiom,
    ! [VarCurr: state_type] :
      ( v27997(VarCurr)
    <=> v27999(VarCurr) ) ).

tff(addAssignment_14286,axiom,
    ! [VarCurr: state_type] :
      ( v27999(VarCurr)
    <=> v27387(VarCurr,0) ) ).

tff(addAssignment_14285,axiom,
    ! [VarCurr: state_type] :
      ( v27984(VarCurr)
    <=> v27986(VarCurr) ) ).

tff(addAssignment_14284,axiom,
    ! [VarCurr: state_type] :
      ( v27986(VarCurr)
    <=> $false ) ).

tff(addAssignment_14283,axiom,
    ! [VarCurr: state_type] :
      ( v27978(VarCurr)
    <=> v27980(VarCurr) ) ).

tff(addAssignment_14282,axiom,
    ! [VarCurr: state_type] :
      ( v27980(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_14281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27968(VarCurr,B)
      <=> v27970(VarCurr,B) ) ) ).

tff(addAssignment_14280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27970(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_14279,axiom,
    ! [VarCurr: state_type] :
      ( v27958(VarCurr)
    <=> v27960(VarCurr) ) ).

tff(addAssignment_14278,axiom,
    ! [VarCurr: state_type] :
      ( v27960(VarCurr)
    <=> v27962(VarCurr) ) ).

tff(addAssignment_14277,axiom,
    ! [VarCurr: state_type] :
      ( v27962(VarCurr)
    <=> v27964(VarCurr) ) ).

tff(addAssignment_14276,axiom,
    ! [VarCurr: state_type] :
      ( v27964(VarCurr)
    <=> v27966(VarCurr) ) ).

tff(addAssignment_14275,axiom,
    ! [VarCurr: state_type] :
      ( v27966(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_14274,axiom,
    ! [VarCurr: state_type] :
      ( v27948(VarCurr)
    <=> v27950(VarCurr) ) ).

tff(addAssignment_14273,axiom,
    ! [VarCurr: state_type] :
      ( v27950(VarCurr)
    <=> v27952(VarCurr) ) ).

tff(addAssignment_14272,axiom,
    ! [VarCurr: state_type] :
      ( v27952(VarCurr)
    <=> v27954(VarCurr) ) ).

tff(addAssignment_14271,axiom,
    ! [VarCurr: state_type] :
      ( v27954(VarCurr)
    <=> v27956(VarCurr) ) ).

tff(addAssignment_14270,axiom,
    ! [VarCurr: state_type] :
      ( v27956(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_14269,axiom,
    ! [VarCurr: state_type] :
      ( v27907(VarCurr)
    <=> v27909(VarCurr) ) ).

tff(addAssignment_14268,axiom,
    ! [VarCurr: state_type] :
      ( v27909(VarCurr)
    <=> v27911(VarCurr) ) ).

tff(addAssignment_14267,axiom,
    ! [VarCurr: state_type] :
      ( v27911(VarCurr)
    <=> v27913(VarCurr) ) ).

tff(addAssignment_14266,axiom,
    ! [VarCurr: state_type] :
      ( v27913(VarCurr)
    <=> v27915(VarCurr) ) ).

tff(addAssignment_14265,axiom,
    ! [VarCurr: state_type] :
      ( v27915(VarCurr)
    <=> v27917(VarCurr) ) ).

tff(addAssignment_14264,axiom,
    ! [VarCurr: state_type] :
      ( v27917(VarCurr)
    <=> v27919(VarCurr) ) ).

tff(addAssignment_14263,axiom,
    ! [VarCurr: state_type] :
      ( v27919(VarCurr)
    <=> v27921(VarCurr) ) ).

tff(writeUnaryOperator_1502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27921(VarCurr)
    <=> v27935(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2286,axiom,
    ! [VarCurr: state_type] :
      ( v27935(VarCurr)
    <=> ( v27936(VarCurr)
        | v27931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2285,axiom,
    ! [VarCurr: state_type] :
      ( v27936(VarCurr)
    <=> ( v27923(VarCurr)
        | v27927(VarCurr) ) ) ).

tff(addAssignment_14262,axiom,
    ! [VarCurr: state_type] :
      ( v27931(VarCurr)
    <=> v27933(VarCurr) ) ).

tff(addAssignment_14261,axiom,
    ! [VarCurr: state_type] :
      ( v27933(VarCurr)
    <=> v27134(VarCurr,2) ) ).

tff(addAssignment_14260,axiom,
    ! [VarCurr: state_type] :
      ( v27927(VarCurr)
    <=> v27929(VarCurr) ) ).

tff(addAssignment_14259,axiom,
    ! [VarCurr: state_type] :
      ( v27929(VarCurr)
    <=> v27051(VarCurr,1) ) ).

tff(addAssignment_14258,axiom,
    ! [VarCurr: state_type] :
      ( v27923(VarCurr)
    <=> v27925(VarCurr) ) ).

tff(addAssignment_14257,axiom,
    ! [VarCurr: state_type] :
      ( v27925(VarCurr)
    <=> v27051(VarCurr,0) ) ).

tff(addAssignment_14256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27787(VarCurr,B)
      <=> v27789(VarCurr,B) ) ) ).

tff(addAssignment_14255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27789(VarCurr,B)
      <=> v27791(VarCurr,B) ) ) ).

tff(addAssignment_14254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27791(VarCurr,B)
      <=> v27793(VarCurr,B) ) ) ).

tff(addAssignment_14253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27793(VarCurr,B)
      <=> v27795(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_314,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27890(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v27795(VarNext,B)
            <=> v27795(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_314,axiom,
    ! [VarNext: state_type] :
      ( v27890(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27795(VarNext,B)
          <=> v27900(VarNext,B) ) ) ) ).

tff(addAssignment_14252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27900(VarNext,B)
          <=> v27898(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27901(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27898(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_190,axiom,
    ! [VarCurr: state_type] :
      ( v27901(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27898(VarCurr,B)
          <=> v27817(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2284,axiom,
    ! [VarCurr: state_type] :
      ( v27901(VarCurr)
    <=> ( v27902(VarCurr)
        & v27903(VarCurr) ) ) ).

tff(writeUnaryOperator_1501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27903(VarCurr)
    <=> v27807(VarCurr) ) ).

tff(writeUnaryOperator_1500,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27902(VarCurr)
    <=> v27797(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27890(VarNext)
      <=> v27891(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27891(VarNext)
      <=> ( v27892(VarNext)
          & v27821(VarNext) ) ) ) ).

tff(writeUnaryOperator_1499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27892(VarNext)
      <=> v27894(VarNext) ) ) ).

tff(addAssignment_14251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27894(VarNext)
      <=> v27821(VarCurr) ) ) ).

tff(addAssignment_14250,axiom,
    ! [VarCurr: state_type] :
      ( v27821(VarCurr)
    <=> v27823(VarCurr) ) ).

tff(addAssignment_14249,axiom,
    ! [VarCurr: state_type] :
      ( v27823(VarCurr)
    <=> v27825(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2281,axiom,
    ! [VarCurr: state_type] :
      ( v27825(VarCurr)
    <=> ( v27887(VarCurr)
        | v27883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2280,axiom,
    ! [VarCurr: state_type] :
      ( v27887(VarCurr)
    <=> ( v27827(VarCurr)
        & v27831(VarCurr) ) ) ).

tff(addAssignment_14248,axiom,
    ! [VarCurr: state_type] :
      ( v27883(VarCurr)
    <=> v27885(VarCurr) ) ).

tff(addAssignment_14247,axiom,
    ! [VarCurr: state_type] :
      ( v27885(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_313,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27867(VarNext)
       => ( v27831(VarNext)
        <=> v27831(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_313,axiom,
    ! [VarNext: state_type] :
      ( v27867(VarNext)
     => ( v27831(VarNext)
      <=> v27877(VarNext) ) ) ).

tff(addAssignment_14246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27877(VarNext)
      <=> v27875(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2279,axiom,
    ! [VarCurr: state_type] :
      ( v27875(VarCurr)
    <=> ( v27878(VarCurr)
        & v27879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2278,axiom,
    ! [VarCurr: state_type] :
      ( v27879(VarCurr)
    <=> ( v27837(VarCurr)
        | v27862(VarCurr) ) ) ).

tff(writeUnaryOperator_1498,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27878(VarCurr)
    <=> v27833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27867(VarNext)
      <=> v27868(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27868(VarNext)
      <=> ( v27870(VarNext)
          & v27872(VarNext) ) ) ) ).

tff(writeUnaryOperator_1497,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27872(VarCurr)
    <=> v27827(VarCurr) ) ).

tff(addAssignment_14245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27870(VarNext)
      <=> v27827(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_119,axiom,
    ( v27831(constB0)
  <=> $true ) ).

tff(addAssignment_14244,axiom,
    ! [VarCurr: state_type] :
      ( v27862(VarCurr)
    <=> v27864(VarCurr) ) ).

tff(addAssignment_14243,axiom,
    ! [VarCurr: state_type] :
      ( v27864(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_14242,axiom,
    ! [VarCurr: state_type] :
      ( v27837(VarCurr)
    <=> v27839(VarCurr) ) ).

tff(addAssignment_14241,axiom,
    ! [VarCurr: state_type] :
      ( v27839(VarCurr)
    <=> v27841(VarCurr) ) ).

tff(addAssignment_14240,axiom,
    ! [VarCurr: state_type] :
      ( v27841(VarCurr)
    <=> v27843(VarCurr) ) ).

tff(addAssignment_14239,axiom,
    ! [VarCurr: state_type] :
      ( v27843(VarCurr)
    <=> v27845(VarCurr) ) ).

tff(writeUnaryOperator_1496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27845(VarCurr)
    <=> v27859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2275,axiom,
    ! [VarCurr: state_type] :
      ( v27859(VarCurr)
    <=> ( v27860(VarCurr)
        | v27855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2274,axiom,
    ! [VarCurr: state_type] :
      ( v27860(VarCurr)
    <=> ( v27847(VarCurr)
        | v27851(VarCurr) ) ) ).

tff(addAssignment_14238,axiom,
    ! [VarCurr: state_type] :
      ( v27855(VarCurr)
    <=> v27857(VarCurr) ) ).

tff(addAssignment_14237,axiom,
    ! [VarCurr: state_type] :
      ( v27857(VarCurr)
    <=> v27387(VarCurr,2) ) ).

tff(addAssignment_14236,axiom,
    ! [VarCurr: state_type] :
      ( v27387(VarCurr,2)
    <=> v27389(VarCurr,2) ) ).

tff(addAssignment_14235,axiom,
    ! [VarCurr: state_type] :
      ( v27389(VarCurr,2)
    <=> v27391(VarCurr,2) ) ).

tff(addAssignment_14234,axiom,
    ! [VarCurr: state_type] :
      ( v27391(VarCurr,2)
    <=> v27396(VarCurr,2) ) ).

tff(addAssignment_14233,axiom,
    ! [VarCurr: state_type] :
      ( v27393(VarCurr,2)
    <=> v27395(VarCurr,2) ) ).

tff(addAssignment_14232,axiom,
    ! [VarCurr: state_type] :
      ( v27395(VarCurr,2)
    <=> v26961(VarCurr,2) ) ).

tff(addAssignment_14231,axiom,
    ! [VarCurr: state_type] :
      ( v27851(VarCurr)
    <=> v27853(VarCurr) ) ).

tff(addAssignment_14230,axiom,
    ! [VarCurr: state_type] :
      ( v27853(VarCurr)
    <=> v26961(VarCurr,1) ) ).

tff(addAssignment_14229,axiom,
    ! [VarCurr: state_type] :
      ( v27847(VarCurr)
    <=> v27849(VarCurr) ) ).

tff(addAssignment_14228,axiom,
    ! [VarCurr: state_type] :
      ( v27849(VarCurr)
    <=> v26961(VarCurr,0) ) ).

tff(addAssignment_14227,axiom,
    ! [VarCurr: state_type] :
      ( v27833(VarCurr)
    <=> v27835(VarCurr) ) ).

tff(addAssignment_14226,axiom,
    ! [VarCurr: state_type] :
      ( v27835(VarCurr)
    <=> $false ) ).

tff(addAssignment_14225,axiom,
    ! [VarCurr: state_type] :
      ( v27827(VarCurr)
    <=> v27829(VarCurr) ) ).

tff(addAssignment_14224,axiom,
    ! [VarCurr: state_type] :
      ( v27829(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_14223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27817(VarCurr,B)
      <=> v27819(VarCurr,B) ) ) ).

tff(addAssignment_14222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27819(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_14221,axiom,
    ! [VarCurr: state_type] :
      ( v27807(VarCurr)
    <=> v27809(VarCurr) ) ).

tff(addAssignment_14220,axiom,
    ! [VarCurr: state_type] :
      ( v27809(VarCurr)
    <=> v27811(VarCurr) ) ).

tff(addAssignment_14219,axiom,
    ! [VarCurr: state_type] :
      ( v27811(VarCurr)
    <=> v27813(VarCurr) ) ).

tff(addAssignment_14218,axiom,
    ! [VarCurr: state_type] :
      ( v27813(VarCurr)
    <=> v27815(VarCurr) ) ).

tff(addAssignment_14217,axiom,
    ! [VarCurr: state_type] :
      ( v27815(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_14216,axiom,
    ! [VarCurr: state_type] :
      ( v27797(VarCurr)
    <=> v27799(VarCurr) ) ).

tff(addAssignment_14215,axiom,
    ! [VarCurr: state_type] :
      ( v27799(VarCurr)
    <=> v27801(VarCurr) ) ).

tff(addAssignment_14214,axiom,
    ! [VarCurr: state_type] :
      ( v27801(VarCurr)
    <=> v27803(VarCurr) ) ).

tff(addAssignment_14213,axiom,
    ! [VarCurr: state_type] :
      ( v27803(VarCurr)
    <=> v27805(VarCurr) ) ).

tff(addAssignment_14212,axiom,
    ! [VarCurr: state_type] :
      ( v27805(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_14211,axiom,
    ! [VarCurr: state_type] :
      ( v27756(VarCurr)
    <=> v27758(VarCurr) ) ).

tff(addAssignment_14210,axiom,
    ! [VarCurr: state_type] :
      ( v27758(VarCurr)
    <=> v27760(VarCurr) ) ).

tff(addAssignment_14209,axiom,
    ! [VarCurr: state_type] :
      ( v27760(VarCurr)
    <=> v27762(VarCurr) ) ).

tff(addAssignment_14208,axiom,
    ! [VarCurr: state_type] :
      ( v27762(VarCurr)
    <=> v27764(VarCurr) ) ).

tff(addAssignment_14207,axiom,
    ! [VarCurr: state_type] :
      ( v27764(VarCurr)
    <=> v27766(VarCurr) ) ).

tff(addAssignment_14206,axiom,
    ! [VarCurr: state_type] :
      ( v27766(VarCurr)
    <=> v27768(VarCurr) ) ).

tff(addAssignment_14205,axiom,
    ! [VarCurr: state_type] :
      ( v27768(VarCurr)
    <=> v27770(VarCurr) ) ).

tff(writeUnaryOperator_1495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27770(VarCurr)
    <=> v27784(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2273,axiom,
    ! [VarCurr: state_type] :
      ( v27784(VarCurr)
    <=> ( v27785(VarCurr)
        | v27780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2272,axiom,
    ! [VarCurr: state_type] :
      ( v27785(VarCurr)
    <=> ( v27772(VarCurr)
        | v27776(VarCurr) ) ) ).

tff(addAssignment_14204,axiom,
    ! [VarCurr: state_type] :
      ( v27780(VarCurr)
    <=> v27782(VarCurr) ) ).

tff(addAssignment_14203,axiom,
    ! [VarCurr: state_type] :
      ( v27782(VarCurr)
    <=> v27051(VarCurr,2) ) ).

tff(addAssignment_14202,axiom,
    ! [VarCurr: state_type] :
      ( v27776(VarCurr)
    <=> v27778(VarCurr) ) ).

tff(addAssignment_14201,axiom,
    ! [VarCurr: state_type] :
      ( v27778(VarCurr)
    <=> v27134(VarCurr,1) ) ).

tff(addAssignment_14200,axiom,
    ! [VarCurr: state_type] :
      ( v27772(VarCurr)
    <=> v27774(VarCurr) ) ).

tff(addAssignment_14199,axiom,
    ! [VarCurr: state_type] :
      ( v27774(VarCurr)
    <=> v27134(VarCurr,0) ) ).

tff(addAssignment_14198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27636(VarCurr,B)
      <=> v27638(VarCurr,B) ) ) ).

tff(addAssignment_14197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27638(VarCurr,B)
      <=> v27640(VarCurr,B) ) ) ).

tff(addAssignment_14196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27640(VarCurr,B)
      <=> v27642(VarCurr,B) ) ) ).

tff(addAssignment_14195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27642(VarCurr,B)
      <=> v27644(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27739(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v27644(VarNext,B)
            <=> v27644(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_312,axiom,
    ! [VarNext: state_type] :
      ( v27739(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27644(VarNext,B)
          <=> v27749(VarNext,B) ) ) ) ).

tff(addAssignment_14194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27749(VarNext,B)
          <=> v27747(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27747(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_189,axiom,
    ! [VarCurr: state_type] :
      ( v27750(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27747(VarCurr,B)
          <=> v27666(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2271,axiom,
    ! [VarCurr: state_type] :
      ( v27750(VarCurr)
    <=> ( v27751(VarCurr)
        & v27752(VarCurr) ) ) ).

tff(writeUnaryOperator_1494,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27752(VarCurr)
    <=> v27656(VarCurr) ) ).

tff(writeUnaryOperator_1493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27751(VarCurr)
    <=> v27646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27739(VarNext)
      <=> v27740(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27740(VarNext)
      <=> ( v27741(VarNext)
          & v27670(VarNext) ) ) ) ).

tff(writeUnaryOperator_1492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27741(VarNext)
      <=> v27743(VarNext) ) ) ).

tff(addAssignment_14193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27743(VarNext)
      <=> v27670(VarCurr) ) ) ).

tff(addAssignment_14192,axiom,
    ! [VarCurr: state_type] :
      ( v27670(VarCurr)
    <=> v27672(VarCurr) ) ).

tff(addAssignment_14191,axiom,
    ! [VarCurr: state_type] :
      ( v27672(VarCurr)
    <=> v27674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2268,axiom,
    ! [VarCurr: state_type] :
      ( v27674(VarCurr)
    <=> ( v27736(VarCurr)
        | v27732(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2267,axiom,
    ! [VarCurr: state_type] :
      ( v27736(VarCurr)
    <=> ( v27676(VarCurr)
        & v27680(VarCurr) ) ) ).

tff(addAssignment_14190,axiom,
    ! [VarCurr: state_type] :
      ( v27732(VarCurr)
    <=> v27734(VarCurr) ) ).

tff(addAssignment_14189,axiom,
    ! [VarCurr: state_type] :
      ( v27734(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27716(VarNext)
       => ( v27680(VarNext)
        <=> v27680(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_311,axiom,
    ! [VarNext: state_type] :
      ( v27716(VarNext)
     => ( v27680(VarNext)
      <=> v27726(VarNext) ) ) ).

tff(addAssignment_14188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27726(VarNext)
      <=> v27724(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2266,axiom,
    ! [VarCurr: state_type] :
      ( v27724(VarCurr)
    <=> ( v27727(VarCurr)
        & v27728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2265,axiom,
    ! [VarCurr: state_type] :
      ( v27728(VarCurr)
    <=> ( v27686(VarCurr)
        | v27711(VarCurr) ) ) ).

tff(writeUnaryOperator_1491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27727(VarCurr)
    <=> v27682(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27716(VarNext)
      <=> v27717(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27717(VarNext)
      <=> ( v27719(VarNext)
          & v27721(VarNext) ) ) ) ).

tff(writeUnaryOperator_1490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27721(VarCurr)
    <=> v27676(VarCurr) ) ).

tff(addAssignment_14187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27719(VarNext)
      <=> v27676(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_118,axiom,
    ( v27680(constB0)
  <=> $true ) ).

tff(addAssignment_14186,axiom,
    ! [VarCurr: state_type] :
      ( v27711(VarCurr)
    <=> v27713(VarCurr) ) ).

tff(addAssignment_14185,axiom,
    ! [VarCurr: state_type] :
      ( v27713(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_14184,axiom,
    ! [VarCurr: state_type] :
      ( v27686(VarCurr)
    <=> v27688(VarCurr) ) ).

tff(addAssignment_14183,axiom,
    ! [VarCurr: state_type] :
      ( v27688(VarCurr)
    <=> v27690(VarCurr) ) ).

tff(addAssignment_14182,axiom,
    ! [VarCurr: state_type] :
      ( v27690(VarCurr)
    <=> v27692(VarCurr) ) ).

tff(addAssignment_14181,axiom,
    ! [VarCurr: state_type] :
      ( v27692(VarCurr)
    <=> v27694(VarCurr) ) ).

tff(writeUnaryOperator_1489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27694(VarCurr)
    <=> v27708(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2262,axiom,
    ! [VarCurr: state_type] :
      ( v27708(VarCurr)
    <=> ( v27709(VarCurr)
        | v27704(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2261,axiom,
    ! [VarCurr: state_type] :
      ( v27709(VarCurr)
    <=> ( v27696(VarCurr)
        | v27700(VarCurr) ) ) ).

tff(addAssignment_14180,axiom,
    ! [VarCurr: state_type] :
      ( v27704(VarCurr)
    <=> v27706(VarCurr) ) ).

tff(addAssignment_14179,axiom,
    ! [VarCurr: state_type] :
      ( v27706(VarCurr)
    <=> v26961(VarCurr,2) ) ).

tff(addAssignment_14178,axiom,
    ! [VarCurr: state_type] :
      ( v27700(VarCurr)
    <=> v27702(VarCurr) ) ).

tff(addAssignment_14177,axiom,
    ! [VarCurr: state_type] :
      ( v27702(VarCurr)
    <=> v27387(VarCurr,1) ) ).

tff(addAssignment_14176,axiom,
    ! [VarCurr: state_type] :
      ( v27696(VarCurr)
    <=> v27698(VarCurr) ) ).

tff(addAssignment_14175,axiom,
    ! [VarCurr: state_type] :
      ( v27698(VarCurr)
    <=> v27387(VarCurr,0) ) ).

tff(addAssignment_14174,axiom,
    ! [VarCurr: state_type] :
      ( v27682(VarCurr)
    <=> v27684(VarCurr) ) ).

tff(addAssignment_14173,axiom,
    ! [VarCurr: state_type] :
      ( v27684(VarCurr)
    <=> $false ) ).

tff(addAssignment_14172,axiom,
    ! [VarCurr: state_type] :
      ( v27676(VarCurr)
    <=> v27678(VarCurr) ) ).

tff(addAssignment_14171,axiom,
    ! [VarCurr: state_type] :
      ( v27678(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_14170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27666(VarCurr,B)
      <=> v27668(VarCurr,B) ) ) ).

tff(addAssignment_14169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27668(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_14168,axiom,
    ! [VarCurr: state_type] :
      ( v27656(VarCurr)
    <=> v27658(VarCurr) ) ).

tff(addAssignment_14167,axiom,
    ! [VarCurr: state_type] :
      ( v27658(VarCurr)
    <=> v27660(VarCurr) ) ).

tff(addAssignment_14166,axiom,
    ! [VarCurr: state_type] :
      ( v27660(VarCurr)
    <=> v27662(VarCurr) ) ).

tff(addAssignment_14165,axiom,
    ! [VarCurr: state_type] :
      ( v27662(VarCurr)
    <=> v27664(VarCurr) ) ).

tff(addAssignment_14164,axiom,
    ! [VarCurr: state_type] :
      ( v27664(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_14163,axiom,
    ! [VarCurr: state_type] :
      ( v27646(VarCurr)
    <=> v27648(VarCurr) ) ).

tff(addAssignment_14162,axiom,
    ! [VarCurr: state_type] :
      ( v27648(VarCurr)
    <=> v27650(VarCurr) ) ).

tff(addAssignment_14161,axiom,
    ! [VarCurr: state_type] :
      ( v27650(VarCurr)
    <=> v27652(VarCurr) ) ).

tff(addAssignment_14160,axiom,
    ! [VarCurr: state_type] :
      ( v27652(VarCurr)
    <=> v27654(VarCurr) ) ).

tff(addAssignment_14159,axiom,
    ! [VarCurr: state_type] :
      ( v27654(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_14158,axiom,
    ! [VarCurr: state_type] :
      ( v27605(VarCurr)
    <=> v27607(VarCurr) ) ).

tff(addAssignment_14157,axiom,
    ! [VarCurr: state_type] :
      ( v27607(VarCurr)
    <=> v27609(VarCurr) ) ).

tff(addAssignment_14156,axiom,
    ! [VarCurr: state_type] :
      ( v27609(VarCurr)
    <=> v27611(VarCurr) ) ).

tff(addAssignment_14155,axiom,
    ! [VarCurr: state_type] :
      ( v27611(VarCurr)
    <=> v27613(VarCurr) ) ).

tff(addAssignment_14154,axiom,
    ! [VarCurr: state_type] :
      ( v27613(VarCurr)
    <=> v27615(VarCurr) ) ).

tff(addAssignment_14153,axiom,
    ! [VarCurr: state_type] :
      ( v27615(VarCurr)
    <=> v27617(VarCurr) ) ).

tff(addAssignment_14152,axiom,
    ! [VarCurr: state_type] :
      ( v27617(VarCurr)
    <=> v27619(VarCurr) ) ).

tff(writeUnaryOperator_1488,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27619(VarCurr)
    <=> v27633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2260,axiom,
    ! [VarCurr: state_type] :
      ( v27633(VarCurr)
    <=> ( v27634(VarCurr)
        | v27629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2259,axiom,
    ! [VarCurr: state_type] :
      ( v27634(VarCurr)
    <=> ( v27621(VarCurr)
        | v27625(VarCurr) ) ) ).

tff(addAssignment_14151,axiom,
    ! [VarCurr: state_type] :
      ( v27629(VarCurr)
    <=> v27631(VarCurr) ) ).

tff(addAssignment_14150,axiom,
    ! [VarCurr: state_type] :
      ( v27631(VarCurr)
    <=> v27051(VarCurr,2) ) ).

tff(addAssignment_14149,axiom,
    ! [VarCurr: state_type] :
      ( v27625(VarCurr)
    <=> v27627(VarCurr) ) ).

tff(addAssignment_14148,axiom,
    ! [VarCurr: state_type] :
      ( v27627(VarCurr)
    <=> v27134(VarCurr,1) ) ).

tff(addAssignment_14147,axiom,
    ! [VarCurr: state_type] :
      ( v27134(VarCurr,1)
    <=> v27136(VarCurr,1) ) ).

tff(addAssignment_14146,axiom,
    ! [VarCurr: state_type] :
      ( v27136(VarCurr,1)
    <=> v27138(VarCurr,1) ) ).

tff(addAssignment_14145,axiom,
    ! [VarCurr: state_type] :
      ( v27138(VarCurr,1)
    <=> v27143(VarCurr,1) ) ).

tff(addAssignment_14144,axiom,
    ! [VarCurr: state_type] :
      ( v27140(VarCurr,1)
    <=> v27142(VarCurr,1) ) ).

tff(addAssignment_14143,axiom,
    ! [VarCurr: state_type] :
      ( v27142(VarCurr,1)
    <=> v27051(VarCurr,1) ) ).

tff(addAssignment_14142,axiom,
    ! [VarCurr: state_type] :
      ( v27621(VarCurr)
    <=> v27623(VarCurr) ) ).

tff(addAssignment_14141,axiom,
    ! [VarCurr: state_type] :
      ( v27623(VarCurr)
    <=> v27051(VarCurr,0) ) ).

tff(addAssignment_14140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27485(VarCurr,B)
      <=> v27487(VarCurr,B) ) ) ).

tff(addAssignment_14139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27487(VarCurr,B)
      <=> v27489(VarCurr,B) ) ) ).

tff(addAssignment_14138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27489(VarCurr,B)
      <=> v27491(VarCurr,B) ) ) ).

tff(addAssignment_14137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27491(VarCurr,B)
      <=> v27493(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27588(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v27493(VarNext,B)
            <=> v27493(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_310,axiom,
    ! [VarNext: state_type] :
      ( v27588(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27493(VarNext,B)
          <=> v27598(VarNext,B) ) ) ) ).

tff(addAssignment_14136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27598(VarNext,B)
          <=> v27596(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27599(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27596(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_188,axiom,
    ! [VarCurr: state_type] :
      ( v27599(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27596(VarCurr,B)
          <=> v27515(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2258,axiom,
    ! [VarCurr: state_type] :
      ( v27599(VarCurr)
    <=> ( v27600(VarCurr)
        & v27601(VarCurr) ) ) ).

tff(writeUnaryOperator_1487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27601(VarCurr)
    <=> v27505(VarCurr) ) ).

tff(writeUnaryOperator_1486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27600(VarCurr)
    <=> v27495(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27588(VarNext)
      <=> v27589(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27589(VarNext)
      <=> ( v27590(VarNext)
          & v27519(VarNext) ) ) ) ).

tff(writeUnaryOperator_1485,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27590(VarNext)
      <=> v27592(VarNext) ) ) ).

tff(addAssignment_14135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27592(VarNext)
      <=> v27519(VarCurr) ) ) ).

tff(addAssignment_14134,axiom,
    ! [VarCurr: state_type] :
      ( v27519(VarCurr)
    <=> v27521(VarCurr) ) ).

tff(addAssignment_14133,axiom,
    ! [VarCurr: state_type] :
      ( v27521(VarCurr)
    <=> v27523(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2255,axiom,
    ! [VarCurr: state_type] :
      ( v27523(VarCurr)
    <=> ( v27585(VarCurr)
        | v27581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2254,axiom,
    ! [VarCurr: state_type] :
      ( v27585(VarCurr)
    <=> ( v27525(VarCurr)
        & v27529(VarCurr) ) ) ).

tff(addAssignment_14132,axiom,
    ! [VarCurr: state_type] :
      ( v27581(VarCurr)
    <=> v27583(VarCurr) ) ).

tff(addAssignment_14131,axiom,
    ! [VarCurr: state_type] :
      ( v27583(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27565(VarNext)
       => ( v27529(VarNext)
        <=> v27529(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_309,axiom,
    ! [VarNext: state_type] :
      ( v27565(VarNext)
     => ( v27529(VarNext)
      <=> v27575(VarNext) ) ) ).

tff(addAssignment_14130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27575(VarNext)
      <=> v27573(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2253,axiom,
    ! [VarCurr: state_type] :
      ( v27573(VarCurr)
    <=> ( v27576(VarCurr)
        & v27577(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2252,axiom,
    ! [VarCurr: state_type] :
      ( v27577(VarCurr)
    <=> ( v27535(VarCurr)
        | v27560(VarCurr) ) ) ).

tff(writeUnaryOperator_1484,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27576(VarCurr)
    <=> v27531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27565(VarNext)
      <=> v27566(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27566(VarNext)
      <=> ( v27568(VarNext)
          & v27570(VarNext) ) ) ) ).

tff(writeUnaryOperator_1483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27570(VarCurr)
    <=> v27525(VarCurr) ) ).

tff(addAssignment_14129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27568(VarNext)
      <=> v27525(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_117,axiom,
    ( v27529(constB0)
  <=> $true ) ).

tff(addAssignment_14128,axiom,
    ! [VarCurr: state_type] :
      ( v27560(VarCurr)
    <=> v27562(VarCurr) ) ).

tff(addAssignment_14127,axiom,
    ! [VarCurr: state_type] :
      ( v27562(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_14126,axiom,
    ! [VarCurr: state_type] :
      ( v27535(VarCurr)
    <=> v27537(VarCurr) ) ).

tff(addAssignment_14125,axiom,
    ! [VarCurr: state_type] :
      ( v27537(VarCurr)
    <=> v27539(VarCurr) ) ).

tff(addAssignment_14124,axiom,
    ! [VarCurr: state_type] :
      ( v27539(VarCurr)
    <=> v27541(VarCurr) ) ).

tff(addAssignment_14123,axiom,
    ! [VarCurr: state_type] :
      ( v27541(VarCurr)
    <=> v27543(VarCurr) ) ).

tff(writeUnaryOperator_1482,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27543(VarCurr)
    <=> v27557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2249,axiom,
    ! [VarCurr: state_type] :
      ( v27557(VarCurr)
    <=> ( v27558(VarCurr)
        | v27553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2248,axiom,
    ! [VarCurr: state_type] :
      ( v27558(VarCurr)
    <=> ( v27545(VarCurr)
        | v27549(VarCurr) ) ) ).

tff(addAssignment_14122,axiom,
    ! [VarCurr: state_type] :
      ( v27553(VarCurr)
    <=> v27555(VarCurr) ) ).

tff(addAssignment_14121,axiom,
    ! [VarCurr: state_type] :
      ( v27555(VarCurr)
    <=> v26961(VarCurr,2) ) ).

tff(addAssignment_14120,axiom,
    ! [VarCurr: state_type] :
      ( v27549(VarCurr)
    <=> v27551(VarCurr) ) ).

tff(addAssignment_14119,axiom,
    ! [VarCurr: state_type] :
      ( v27551(VarCurr)
    <=> v27387(VarCurr,1) ) ).

tff(addAssignment_14118,axiom,
    ! [VarCurr: state_type] :
      ( v27387(VarCurr,1)
    <=> v27389(VarCurr,1) ) ).

tff(addAssignment_14117,axiom,
    ! [VarCurr: state_type] :
      ( v27389(VarCurr,1)
    <=> v27391(VarCurr,1) ) ).

tff(addAssignment_14116,axiom,
    ! [VarCurr: state_type] :
      ( v27391(VarCurr,1)
    <=> v27396(VarCurr,1) ) ).

tff(addAssignment_14115,axiom,
    ! [VarCurr: state_type] :
      ( v27393(VarCurr,1)
    <=> v27395(VarCurr,1) ) ).

tff(addAssignment_14114,axiom,
    ! [VarCurr: state_type] :
      ( v27395(VarCurr,1)
    <=> v26961(VarCurr,1) ) ).

tff(addAssignment_14113,axiom,
    ! [VarCurr: state_type] :
      ( v27545(VarCurr)
    <=> v27547(VarCurr) ) ).

tff(addAssignment_14112,axiom,
    ! [VarCurr: state_type] :
      ( v27547(VarCurr)
    <=> v26961(VarCurr,0) ) ).

tff(addAssignment_14111,axiom,
    ! [VarCurr: state_type] :
      ( v27531(VarCurr)
    <=> v27533(VarCurr) ) ).

tff(addAssignment_14110,axiom,
    ! [VarCurr: state_type] :
      ( v27533(VarCurr)
    <=> $false ) ).

tff(addAssignment_14109,axiom,
    ! [VarCurr: state_type] :
      ( v27525(VarCurr)
    <=> v27527(VarCurr) ) ).

tff(addAssignment_14108,axiom,
    ! [VarCurr: state_type] :
      ( v27527(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_14107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27515(VarCurr,B)
      <=> v27517(VarCurr,B) ) ) ).

tff(addAssignment_14106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27517(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_14105,axiom,
    ! [VarCurr: state_type] :
      ( v27505(VarCurr)
    <=> v27507(VarCurr) ) ).

tff(addAssignment_14104,axiom,
    ! [VarCurr: state_type] :
      ( v27507(VarCurr)
    <=> v27509(VarCurr) ) ).

tff(addAssignment_14103,axiom,
    ! [VarCurr: state_type] :
      ( v27509(VarCurr)
    <=> v27511(VarCurr) ) ).

tff(addAssignment_14102,axiom,
    ! [VarCurr: state_type] :
      ( v27511(VarCurr)
    <=> v27513(VarCurr) ) ).

tff(addAssignment_14101,axiom,
    ! [VarCurr: state_type] :
      ( v27513(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_14100,axiom,
    ! [VarCurr: state_type] :
      ( v27495(VarCurr)
    <=> v27497(VarCurr) ) ).

tff(addAssignment_14099,axiom,
    ! [VarCurr: state_type] :
      ( v27497(VarCurr)
    <=> v27499(VarCurr) ) ).

tff(addAssignment_14098,axiom,
    ! [VarCurr: state_type] :
      ( v27499(VarCurr)
    <=> v27501(VarCurr) ) ).

tff(addAssignment_14097,axiom,
    ! [VarCurr: state_type] :
      ( v27501(VarCurr)
    <=> v27503(VarCurr) ) ).

tff(addAssignment_14096,axiom,
    ! [VarCurr: state_type] :
      ( v27503(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_14095,axiom,
    ! [VarCurr: state_type] :
      ( v27454(VarCurr)
    <=> v27456(VarCurr) ) ).

tff(addAssignment_14094,axiom,
    ! [VarCurr: state_type] :
      ( v27456(VarCurr)
    <=> v27458(VarCurr) ) ).

tff(addAssignment_14093,axiom,
    ! [VarCurr: state_type] :
      ( v27458(VarCurr)
    <=> v27460(VarCurr) ) ).

tff(addAssignment_14092,axiom,
    ! [VarCurr: state_type] :
      ( v27460(VarCurr)
    <=> v27462(VarCurr) ) ).

tff(addAssignment_14091,axiom,
    ! [VarCurr: state_type] :
      ( v27462(VarCurr)
    <=> v27464(VarCurr) ) ).

tff(addAssignment_14090,axiom,
    ! [VarCurr: state_type] :
      ( v27464(VarCurr)
    <=> v27466(VarCurr) ) ).

tff(addAssignment_14089,axiom,
    ! [VarCurr: state_type] :
      ( v27466(VarCurr)
    <=> v27468(VarCurr) ) ).

tff(writeUnaryOperator_1481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27468(VarCurr)
    <=> v27482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2247,axiom,
    ! [VarCurr: state_type] :
      ( v27482(VarCurr)
    <=> ( v27483(VarCurr)
        | v27478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2246,axiom,
    ! [VarCurr: state_type] :
      ( v27483(VarCurr)
    <=> ( v27470(VarCurr)
        | v27474(VarCurr) ) ) ).

tff(addAssignment_14088,axiom,
    ! [VarCurr: state_type] :
      ( v27478(VarCurr)
    <=> v27480(VarCurr) ) ).

tff(addAssignment_14087,axiom,
    ! [VarCurr: state_type] :
      ( v27480(VarCurr)
    <=> v27051(VarCurr,2) ) ).

tff(addAssignment_14086,axiom,
    ! [VarCurr: state_type] :
      ( v27474(VarCurr)
    <=> v27476(VarCurr) ) ).

tff(addAssignment_14085,axiom,
    ! [VarCurr: state_type] :
      ( v27476(VarCurr)
    <=> v27051(VarCurr,1) ) ).

tff(addAssignment_14084,axiom,
    ! [VarCurr: state_type] :
      ( v27470(VarCurr)
    <=> v27472(VarCurr) ) ).

tff(addAssignment_14083,axiom,
    ! [VarCurr: state_type] :
      ( v27472(VarCurr)
    <=> v27134(VarCurr,0) ) ).

tff(addAssignment_14082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27323(VarCurr,B)
      <=> v27325(VarCurr,B) ) ) ).

tff(addAssignment_14081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27325(VarCurr,B)
      <=> v27327(VarCurr,B) ) ) ).

tff(addAssignment_14080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27327(VarCurr,B)
      <=> v27329(VarCurr,B) ) ) ).

tff(addAssignment_14079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27329(VarCurr,B)
      <=> v27331(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_308,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27437(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v27331(VarNext,B)
            <=> v27331(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_308,axiom,
    ! [VarNext: state_type] :
      ( v27437(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27331(VarNext,B)
          <=> v27447(VarNext,B) ) ) ) ).

tff(addAssignment_14078,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27447(VarNext,B)
          <=> v27445(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27448(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27445(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_187,axiom,
    ! [VarCurr: state_type] :
      ( v27448(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27445(VarCurr,B)
          <=> v27353(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2245,axiom,
    ! [VarCurr: state_type] :
      ( v27448(VarCurr)
    <=> ( v27449(VarCurr)
        & v27450(VarCurr) ) ) ).

tff(writeUnaryOperator_1480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27450(VarCurr)
    <=> v27343(VarCurr) ) ).

tff(writeUnaryOperator_1479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27449(VarCurr)
    <=> v27333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27437(VarNext)
      <=> v27438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27438(VarNext)
      <=> ( v27439(VarNext)
          & v27357(VarNext) ) ) ) ).

tff(writeUnaryOperator_1478,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27439(VarNext)
      <=> v27441(VarNext) ) ) ).

tff(addAssignment_14077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27441(VarNext)
      <=> v27357(VarCurr) ) ) ).

tff(addAssignment_14076,axiom,
    ! [VarCurr: state_type] :
      ( v27357(VarCurr)
    <=> v27359(VarCurr) ) ).

tff(addAssignment_14075,axiom,
    ! [VarCurr: state_type] :
      ( v27359(VarCurr)
    <=> v27361(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2242,axiom,
    ! [VarCurr: state_type] :
      ( v27361(VarCurr)
    <=> ( v27434(VarCurr)
        | v27430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2241,axiom,
    ! [VarCurr: state_type] :
      ( v27434(VarCurr)
    <=> ( v27363(VarCurr)
        & v27367(VarCurr) ) ) ).

tff(addAssignment_14074,axiom,
    ! [VarCurr: state_type] :
      ( v27430(VarCurr)
    <=> v27432(VarCurr) ) ).

tff(addAssignment_14073,axiom,
    ! [VarCurr: state_type] :
      ( v27432(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_307,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27414(VarNext)
       => ( v27367(VarNext)
        <=> v27367(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_307,axiom,
    ! [VarNext: state_type] :
      ( v27414(VarNext)
     => ( v27367(VarNext)
      <=> v27424(VarNext) ) ) ).

tff(addAssignment_14072,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27424(VarNext)
      <=> v27422(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2240,axiom,
    ! [VarCurr: state_type] :
      ( v27422(VarCurr)
    <=> ( v27425(VarCurr)
        & v27426(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2239,axiom,
    ! [VarCurr: state_type] :
      ( v27426(VarCurr)
    <=> ( v27373(VarCurr)
        | v27409(VarCurr) ) ) ).

tff(writeUnaryOperator_1477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27425(VarCurr)
    <=> v27369(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27414(VarNext)
      <=> v27415(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27415(VarNext)
      <=> ( v27417(VarNext)
          & v27419(VarNext) ) ) ) ).

tff(writeUnaryOperator_1476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27419(VarCurr)
    <=> v27363(VarCurr) ) ).

tff(addAssignment_14071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27417(VarNext)
      <=> v27363(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_116,axiom,
    ( v27367(constB0)
  <=> $true ) ).

tff(addAssignment_14070,axiom,
    ! [VarCurr: state_type] :
      ( v27409(VarCurr)
    <=> v27411(VarCurr) ) ).

tff(addAssignment_14069,axiom,
    ! [VarCurr: state_type] :
      ( v27411(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_14068,axiom,
    ! [VarCurr: state_type] :
      ( v27373(VarCurr)
    <=> v27375(VarCurr) ) ).

tff(addAssignment_14067,axiom,
    ! [VarCurr: state_type] :
      ( v27375(VarCurr)
    <=> v27377(VarCurr) ) ).

tff(addAssignment_14066,axiom,
    ! [VarCurr: state_type] :
      ( v27377(VarCurr)
    <=> v27379(VarCurr) ) ).

tff(addAssignment_14065,axiom,
    ! [VarCurr: state_type] :
      ( v27379(VarCurr)
    <=> v27381(VarCurr) ) ).

tff(writeUnaryOperator_1475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27381(VarCurr)
    <=> v27406(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2236,axiom,
    ! [VarCurr: state_type] :
      ( v27406(VarCurr)
    <=> ( v27407(VarCurr)
        | v27402(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2235,axiom,
    ! [VarCurr: state_type] :
      ( v27407(VarCurr)
    <=> ( v27383(VarCurr)
        | v27398(VarCurr) ) ) ).

tff(addAssignment_14064,axiom,
    ! [VarCurr: state_type] :
      ( v27402(VarCurr)
    <=> v27404(VarCurr) ) ).

tff(addAssignment_14063,axiom,
    ! [VarCurr: state_type] :
      ( v27404(VarCurr)
    <=> v26961(VarCurr,2) ) ).

tff(addAssignment_14062,axiom,
    ! [VarCurr: state_type] :
      ( v27398(VarCurr)
    <=> v27400(VarCurr) ) ).

tff(addAssignment_14061,axiom,
    ! [VarCurr: state_type] :
      ( v27400(VarCurr)
    <=> v26961(VarCurr,1) ) ).

tff(addAssignment_14060,axiom,
    ! [VarCurr: state_type] :
      ( v27383(VarCurr)
    <=> v27385(VarCurr) ) ).

tff(addAssignment_14059,axiom,
    ! [VarCurr: state_type] :
      ( v27385(VarCurr)
    <=> v27387(VarCurr,0) ) ).

tff(addAssignment_14058,axiom,
    ! [VarCurr: state_type] :
      ( v27387(VarCurr,0)
    <=> v27389(VarCurr,0) ) ).

tff(addAssignment_14057,axiom,
    ! [VarCurr: state_type] :
      ( v27389(VarCurr,0)
    <=> v27391(VarCurr,0) ) ).

tff(addAssignment_14056,axiom,
    ! [VarCurr: state_type] :
      ( v27391(VarCurr,0)
    <=> v27396(VarCurr,0) ) ).

tff(writeUnaryOperator_1474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v27396(VarCurr,B)
      <=> ~ v27393(VarCurr,B) ) ) ).

tff(addAssignment_14055,axiom,
    ! [VarCurr: state_type] :
      ( v27393(VarCurr,0)
    <=> v27395(VarCurr,0) ) ).

tff(addAssignment_14054,axiom,
    ! [VarCurr: state_type] :
      ( v27395(VarCurr,0)
    <=> v26961(VarCurr,0) ) ).

tff(addAssignment_14053,axiom,
    ! [VarCurr: state_type] :
      ( v27369(VarCurr)
    <=> v27371(VarCurr) ) ).

tff(addAssignment_14052,axiom,
    ! [VarCurr: state_type] :
      ( v27371(VarCurr)
    <=> $false ) ).

tff(addAssignment_14051,axiom,
    ! [VarCurr: state_type] :
      ( v27363(VarCurr)
    <=> v27365(VarCurr) ) ).

tff(addAssignment_14050,axiom,
    ! [VarCurr: state_type] :
      ( v27365(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_14049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27353(VarCurr,B)
      <=> v27355(VarCurr,B) ) ) ).

tff(addAssignment_14048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v27355(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_14047,axiom,
    ! [VarCurr: state_type] :
      ( v27343(VarCurr)
    <=> v27345(VarCurr) ) ).

tff(addAssignment_14046,axiom,
    ! [VarCurr: state_type] :
      ( v27345(VarCurr)
    <=> v27347(VarCurr) ) ).

tff(addAssignment_14045,axiom,
    ! [VarCurr: state_type] :
      ( v27347(VarCurr)
    <=> v27349(VarCurr) ) ).

tff(addAssignment_14044,axiom,
    ! [VarCurr: state_type] :
      ( v27349(VarCurr)
    <=> v27351(VarCurr) ) ).

tff(addAssignment_14043,axiom,
    ! [VarCurr: state_type] :
      ( v27351(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_14042,axiom,
    ! [VarCurr: state_type] :
      ( v27333(VarCurr)
    <=> v27335(VarCurr) ) ).

tff(addAssignment_14041,axiom,
    ! [VarCurr: state_type] :
      ( v27335(VarCurr)
    <=> v27337(VarCurr) ) ).

tff(addAssignment_14040,axiom,
    ! [VarCurr: state_type] :
      ( v27337(VarCurr)
    <=> v27339(VarCurr) ) ).

tff(addAssignment_14039,axiom,
    ! [VarCurr: state_type] :
      ( v27339(VarCurr)
    <=> v27341(VarCurr) ) ).

tff(addAssignment_14038,axiom,
    ! [VarCurr: state_type] :
      ( v27341(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_14037,axiom,
    ! [VarCurr: state_type] :
      ( v27031(VarCurr)
    <=> v27033(VarCurr) ) ).

tff(addAssignment_14036,axiom,
    ! [VarCurr: state_type] :
      ( v27033(VarCurr)
    <=> v27035(VarCurr) ) ).

tff(addAssignment_14035,axiom,
    ! [VarCurr: state_type] :
      ( v27035(VarCurr)
    <=> v27037(VarCurr) ) ).

tff(addAssignment_14034,axiom,
    ! [VarCurr: state_type] :
      ( v27037(VarCurr)
    <=> v27039(VarCurr) ) ).

tff(addAssignment_14033,axiom,
    ! [VarCurr: state_type] :
      ( v27039(VarCurr)
    <=> v27041(VarCurr) ) ).

tff(addAssignment_14032,axiom,
    ! [VarCurr: state_type] :
      ( v27041(VarCurr)
    <=> v27043(VarCurr) ) ).

tff(addAssignment_14031,axiom,
    ! [VarCurr: state_type] :
      ( v27043(VarCurr)
    <=> v27045(VarCurr) ) ).

tff(writeUnaryOperator_1473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27045(VarCurr)
    <=> v27320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2234,axiom,
    ! [VarCurr: state_type] :
      ( v27320(VarCurr)
    <=> ( v27321(VarCurr)
        | v27316(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2233,axiom,
    ! [VarCurr: state_type] :
      ( v27321(VarCurr)
    <=> ( v27047(VarCurr)
        | v27312(VarCurr) ) ) ).

tff(addAssignment_14030,axiom,
    ! [VarCurr: state_type] :
      ( v27316(VarCurr)
    <=> v27318(VarCurr) ) ).

tff(addAssignment_14029,axiom,
    ! [VarCurr: state_type] :
      ( v27318(VarCurr)
    <=> v27051(VarCurr,2) ) ).

tff(addAssignment_14028,axiom,
    ! [VarCurr: state_type] :
      ( v27312(VarCurr)
    <=> v27314(VarCurr) ) ).

tff(addAssignment_14027,axiom,
    ! [VarCurr: state_type] :
      ( v27314(VarCurr)
    <=> v27051(VarCurr,1) ) ).

tff(addAssignment_14026,axiom,
    ! [VarCurr: state_type] :
      ( v27047(VarCurr)
    <=> v27049(VarCurr) ) ).

tff(addAssignment_14025,axiom,
    ! [VarCurr: state_type] :
      ( v27049(VarCurr)
    <=> v27051(VarCurr,0) ) ).

tff(addAssignment_14024,axiom,
    ! [VarCurr: state_type] :
      ( v27051(VarCurr,0)
    <=> v26963(VarCurr,3) ) ).

tff(addAssignment_14023,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,3)
    <=> v26965(VarCurr,3) ) ).

tff(addAssignment_14022,axiom,
    ! [VarNext: state_type] :
      ( v26965(VarNext,3)
    <=> v27304(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27305(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v27304(VarNext,B)
            <=> v26965(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_306,axiom,
    ! [VarNext: state_type] :
      ( v27305(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27304(VarNext,B)
          <=> v27276(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27305(VarNext)
      <=> v27306(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27306(VarNext)
      <=> ( v27308(VarNext)
          & v27218(VarNext) ) ) ) ).

tff(writeUnaryOperator_1472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27308(VarNext)
      <=> v27270(VarNext) ) ) ).

tff(addAssignment_14021,axiom,
    ! [VarCurr: state_type] :
      ( v27075(VarCurr,3)
    <=> v27077(VarCurr,3) ) ).

tff(addAssignment_14020,axiom,
    ! [VarCurr: state_type] :
      ( v27077(VarCurr,3)
    <=> v27215(VarCurr,3) ) ).

tff(addAssignment_14019,axiom,
    ! [VarCurr: state_type] :
      ( v27079(VarCurr,0)
    <=> v27081(VarCurr,0) ) ).

tff(addAssignment_14018,axiom,
    ! [VarCurr: state_type] :
      ( v27081(VarCurr,0)
    <=> v27083(VarCurr,0) ) ).

tff(addAssignment_14017,axiom,
    ! [VarCurr: state_type] :
      ( v27083(VarCurr,0)
    <=> v27214(VarCurr,0) ) ).

tff(addAssignment_14016,axiom,
    ! [VarCurr: state_type] :
      ( v27151(VarCurr,0)
    <=> v27153(VarCurr,0) ) ).

tff(addAssignment_14015,axiom,
    ! [VarCurr: state_type] :
      ( v27153(VarCurr,0)
    <=> v27155(VarCurr,0) ) ).

tff(addAssignment_14014,axiom,
    ! [VarCurr: state_type] :
      ( v27155(VarCurr,0)
    <=> v27157(VarCurr,0) ) ).

tff(addAssignment_14013,axiom,
    ! [VarCurr: state_type] :
      ( v27157(VarCurr,0)
    <=> v27159(VarCurr,0) ) ).

tff(addAssignment_14012,axiom,
    ! [VarCurr: state_type] :
      ( v27159(VarCurr,0)
    <=> v27169(VarCurr,0) ) ).

tff(addAssignment_14011,axiom,
    ! [VarCurr: state_type] :
      ( v27085(VarCurr,0)
    <=> v27087(VarCurr,0) ) ).

tff(addAssignment_14010,axiom,
    ! [VarCurr: state_type] :
      ( v27087(VarCurr,0)
    <=> v27148(VarCurr,0) ) ).

tff(addAssignment_14009,axiom,
    ! [VarCurr: state_type] :
      ( v27089(VarCurr)
    <=> v26615(VarCurr,2) ) ).

tff(addAssignment_14008,axiom,
    ! [VarCurr: state_type] :
      ( v26615(VarCurr,2)
    <=> v26617(VarCurr,2) ) ).

tff(addAssignment_14007,axiom,
    ! [VarCurr: state_type] :
      ( v26617(VarCurr,2)
    <=> v26627(VarCurr,2) ) ).

tff(addAssignment_14006,axiom,
    ! [VarCurr: state_type] :
      ( v26619(VarCurr,2)
    <=> v26621(VarCurr,2) ) ).

tff(addAssignment_14005,axiom,
    ! [VarCurr: state_type] :
      ( v26621(VarCurr,2)
    <=> v26624(VarCurr,2) ) ).

tff(addAssignment_14004,axiom,
    ! [VarCurr: state_type] :
      ( v26625(VarCurr)
    <=> v27092(VarCurr,1) ) ).

tff(addAssignment_14003,axiom,
    ! [VarCurr: state_type] :
      ( v27092(VarCurr,1)
    <=> v27094(VarCurr,1) ) ).

tff(addAssignment_14002,axiom,
    ! [VarCurr: state_type] :
      ( v27094(VarCurr,1)
    <=> v27302(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v27302(VarCurr,B)
      <=> ( v27096(VarCurr,B)
          | v27102(VarCurr,B) ) ) ) ).

tff(addAssignment_14001,axiom,
    ! [VarCurr: state_type] :
      ( v27102(VarCurr,1)
    <=> v27104(VarCurr,1) ) ).

tff(addAssignment_14000,axiom,
    ! [VarCurr: state_type] :
      ( v27104(VarCurr,1)
    <=> v27300(VarCurr,1) ) ).

tff(addAssignment_13999,axiom,
    ! [VarCurr: state_type] :
      ( v27300(VarCurr,0)
    <=> v27301(VarCurr) ) ).

tff(addAssignment_13998,axiom,
    ! [VarCurr: state_type] :
      ( v27300(VarCurr,1)
    <=> v27106(VarCurr) ) ).

tff(addAssignment_13997,axiom,
    ! [VarCurr: state_type] :
      ( v27106(VarCurr)
    <=> v27108(VarCurr,1) ) ).

tff(addAssignment_13996,axiom,
    ! [VarCurr: state_type] :
      ( v27108(VarCurr,1)
    <=> v27110(VarCurr,1) ) ).

tff(addAssignment_13995,axiom,
    ! [VarCurr: state_type] :
      ( v27110(VarCurr,1)
    <=> v27299(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v27299(VarCurr,B)
      <=> ( v27112(VarCurr,B)
          & v27120(VarCurr,B) ) ) ) ).

tff(addAssignment_13994,axiom,
    ! [VarCurr: state_type] :
      ( v27120(VarCurr,1)
    <=> v27122(VarCurr,1) ) ).

tff(addAssignment_13993,axiom,
    ! [VarCurr: state_type] :
      ( v27122(VarCurr,1)
    <=> v27297(VarCurr,1) ) ).

tff(addAssignment_13992,axiom,
    ! [VarCurr: state_type] :
      ( v27297(VarCurr,0)
    <=> v27298(VarCurr) ) ).

tff(addAssignment_13991,axiom,
    ! [VarCurr: state_type] :
      ( v27297(VarCurr,1)
    <=> v27124(VarCurr) ) ).

tff(addAssignment_13990,axiom,
    ! [VarCurr: state_type] :
      ( v27124(VarCurr)
    <=> v27126(VarCurr) ) ).

tff(addAssignment_13989,axiom,
    ! [VarCurr: state_type] :
      ( v27126(VarCurr)
    <=> v27128(VarCurr) ) ).

tff(writeUnaryOperator_1471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27128(VarCurr)
    <=> v27295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2230,axiom,
    ! [VarCurr: state_type] :
      ( v27295(VarCurr)
    <=> ( v27296(VarCurr)
        | v27283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2229,axiom,
    ! [VarCurr: state_type] :
      ( v27296(VarCurr)
    <=> ( v27130(VarCurr)
        | v27145(VarCurr) ) ) ).

tff(addAssignment_13988,axiom,
    ! [VarCurr: state_type] :
      ( v27283(VarCurr)
    <=> v27285(VarCurr) ) ).

tff(addAssignment_13987,axiom,
    ! [VarCurr: state_type] :
      ( v27285(VarCurr)
    <=> v27134(VarCurr,2) ) ).

tff(addAssignment_13986,axiom,
    ! [VarCurr: state_type] :
      ( v27134(VarCurr,2)
    <=> v27136(VarCurr,2) ) ).

tff(addAssignment_13985,axiom,
    ! [VarCurr: state_type] :
      ( v27136(VarCurr,2)
    <=> v27138(VarCurr,2) ) ).

tff(addAssignment_13984,axiom,
    ! [VarCurr: state_type] :
      ( v27138(VarCurr,2)
    <=> v27143(VarCurr,2) ) ).

tff(addAssignment_13983,axiom,
    ! [VarCurr: state_type] :
      ( v27140(VarCurr,2)
    <=> v27142(VarCurr,2) ) ).

tff(addAssignment_13982,axiom,
    ! [VarCurr: state_type] :
      ( v27142(VarCurr,2)
    <=> v27051(VarCurr,2) ) ).

tff(addAssignment_13981,axiom,
    ! [VarCurr: state_type] :
      ( v27051(VarCurr,2)
    <=> v26963(VarCurr,5) ) ).

tff(addAssignment_13980,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,5)
    <=> v26965(VarCurr,5) ) ).

tff(addAssignment_13979,axiom,
    ! [VarNext: state_type] :
      ( v26965(VarNext,5)
    <=> v27287(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27288(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v27287(VarNext,B)
            <=> v26965(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_305,axiom,
    ! [VarNext: state_type] :
      ( v27288(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27287(VarNext,B)
          <=> v27276(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27288(VarNext)
      <=> v27289(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27289(VarNext)
      <=> ( v27291(VarNext)
          & v27218(VarNext) ) ) ) ).

tff(writeUnaryOperator_1470,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27291(VarNext)
      <=> v27270(VarNext) ) ) ).

tff(addAssignment_13978,axiom,
    ! [VarCurr: state_type] :
      ( v27075(VarCurr,5)
    <=> v27077(VarCurr,5) ) ).

tff(addAssignment_13977,axiom,
    ! [VarCurr: state_type] :
      ( v27077(VarCurr,5)
    <=> v27215(VarCurr,5) ) ).

tff(addAssignment_13976,axiom,
    ! [VarCurr: state_type] :
      ( v27079(VarCurr,2)
    <=> v27081(VarCurr,2) ) ).

tff(addAssignment_13975,axiom,
    ! [VarCurr: state_type] :
      ( v27081(VarCurr,2)
    <=> v27083(VarCurr,2) ) ).

tff(addAssignment_13974,axiom,
    ! [VarCurr: state_type] :
      ( v27083(VarCurr,2)
    <=> v27214(VarCurr,2) ) ).

tff(addAssignment_13973,axiom,
    ! [VarCurr: state_type] :
      ( v27151(VarCurr,2)
    <=> v27153(VarCurr,2) ) ).

tff(addAssignment_13972,axiom,
    ! [VarCurr: state_type] :
      ( v27153(VarCurr,2)
    <=> v27155(VarCurr,2) ) ).

tff(addAssignment_13971,axiom,
    ! [VarCurr: state_type] :
      ( v27155(VarCurr,2)
    <=> v27157(VarCurr,2) ) ).

tff(addAssignment_13970,axiom,
    ! [VarCurr: state_type] :
      ( v27157(VarCurr,2)
    <=> v27159(VarCurr,2) ) ).

tff(addAssignment_13969,axiom,
    ! [VarCurr: state_type] :
      ( v27159(VarCurr,2)
    <=> v27169(VarCurr,2) ) ).

tff(addAssignment_13968,axiom,
    ! [VarCurr: state_type] :
      ( v27161(VarCurr,2)
    <=> v27163(VarCurr,2) ) ).

tff(addAssignment_13967,axiom,
    ! [VarCurr: state_type] :
      ( v27163(VarCurr,2)
    <=> v27164(VarCurr,2) ) ).

tff(addAssignment_13966,axiom,
    ! [VarCurr: state_type] :
      ( v27085(VarCurr,2)
    <=> v27087(VarCurr,2) ) ).

tff(addAssignment_13965,axiom,
    ! [VarCurr: state_type] :
      ( v27087(VarCurr,2)
    <=> v27148(VarCurr,2) ) ).

tff(addAssignment_13964,axiom,
    ! [VarCurr: state_type] :
      ( v27145(VarCurr)
    <=> v27147(VarCurr) ) ).

tff(addAssignment_13963,axiom,
    ! [VarCurr: state_type] :
      ( v27147(VarCurr)
    <=> v27051(VarCurr,1) ) ).

tff(addAssignment_13962,axiom,
    ! [VarCurr: state_type] :
      ( v27051(VarCurr,1)
    <=> v26963(VarCurr,4) ) ).

tff(addAssignment_13961,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,4)
    <=> v26965(VarCurr,4) ) ).

tff(addAssignment_13960,axiom,
    ! [VarNext: state_type] :
      ( v26965(VarNext,4)
    <=> v27265(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27266(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v27265(VarNext,B)
            <=> v26965(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_304,axiom,
    ! [VarNext: state_type] :
      ( v27266(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27265(VarNext,B)
          <=> v27276(VarNext,B) ) ) ) ).

tff(addAssignment_13959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27276(VarNext,B)
          <=> v27274(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27277(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27274(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_186,axiom,
    ! [VarCurr: state_type] :
      ( v27277(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v27274(VarCurr,B)
          <=> v27075(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2226,axiom,
    ! [VarCurr: state_type] :
      ( v27277(VarCurr)
    <=> ( v27278(VarCurr)
        & v27279(VarCurr) ) ) ).

tff(writeUnaryOperator_1469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27279(VarCurr)
    <=> v27065(VarCurr) ) ).

tff(writeUnaryOperator_1468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27278(VarCurr)
    <=> v27053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27266(VarNext)
      <=> v27267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27267(VarNext)
      <=> ( v27268(VarNext)
          & v27218(VarNext) ) ) ) ).

tff(writeUnaryOperator_1467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27268(VarNext)
      <=> v27270(VarNext) ) ) ).

tff(addAssignment_13958,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27270(VarNext)
      <=> v27218(VarCurr) ) ) ).

tff(addAssignment_13957,axiom,
    ! [VarCurr: state_type] :
      ( v27218(VarCurr)
    <=> v27220(VarCurr) ) ).

tff(addAssignment_13956,axiom,
    ! [VarCurr: state_type] :
      ( v27220(VarCurr)
    <=> v27222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2223,axiom,
    ! [VarCurr: state_type] :
      ( v27222(VarCurr)
    <=> ( v27263(VarCurr)
        | v27259(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2222,axiom,
    ! [VarCurr: state_type] :
      ( v27263(VarCurr)
    <=> ( v27224(VarCurr)
        & v27228(VarCurr) ) ) ).

tff(addAssignment_13955,axiom,
    ! [VarCurr: state_type] :
      ( v27259(VarCurr)
    <=> v27261(VarCurr) ) ).

tff(addAssignment_13954,axiom,
    ! [VarCurr: state_type] :
      ( v27261(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27243(VarNext)
       => ( v27228(VarNext)
        <=> v27228(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_303,axiom,
    ! [VarNext: state_type] :
      ( v27243(VarNext)
     => ( v27228(VarNext)
      <=> v27253(VarNext) ) ) ).

tff(addAssignment_13953,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27253(VarNext)
      <=> v27251(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2221,axiom,
    ! [VarCurr: state_type] :
      ( v27251(VarCurr)
    <=> ( v27254(VarCurr)
        & v27255(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2220,axiom,
    ! [VarCurr: state_type] :
      ( v27255(VarCurr)
    <=> ( v27234(VarCurr)
        | v27238(VarCurr) ) ) ).

tff(writeUnaryOperator_1466,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27254(VarCurr)
    <=> v27230(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27243(VarNext)
      <=> v27244(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27244(VarNext)
      <=> ( v27246(VarNext)
          & v27248(VarNext) ) ) ) ).

tff(writeUnaryOperator_1465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27248(VarCurr)
    <=> v27224(VarCurr) ) ).

tff(addAssignment_13952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27246(VarNext)
      <=> v27224(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_115,axiom,
    ( v27228(constB0)
  <=> $true ) ).

tff(addAssignment_13951,axiom,
    ! [VarCurr: state_type] :
      ( v27238(VarCurr)
    <=> v27240(VarCurr) ) ).

tff(addAssignment_13950,axiom,
    ! [VarCurr: state_type] :
      ( v27240(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_13949,axiom,
    ! [VarCurr: state_type] :
      ( v27234(VarCurr)
    <=> v27236(VarCurr) ) ).

tff(addAssignment_13948,axiom,
    ! [VarCurr: state_type] :
      ( v27236(VarCurr)
    <=> $true ) ).

tff(addAssignment_13947,axiom,
    ! [VarCurr: state_type] :
      ( v27230(VarCurr)
    <=> v27232(VarCurr) ) ).

tff(addAssignment_13946,axiom,
    ! [VarCurr: state_type] :
      ( v27232(VarCurr)
    <=> $false ) ).

tff(addAssignment_13945,axiom,
    ! [VarCurr: state_type] :
      ( v27224(VarCurr)
    <=> v27226(VarCurr) ) ).

tff(addAssignment_13944,axiom,
    ! [VarCurr: state_type] :
      ( v27226(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_13943,axiom,
    ! [VarCurr: state_type] :
      ( v27075(VarCurr,4)
    <=> v27077(VarCurr,4) ) ).

tff(addAssignment_13942,axiom,
    ! [VarCurr: state_type] :
      ( v27077(VarCurr,4)
    <=> v27215(VarCurr,4) ) ).

tff(addAssignment_13941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v27215(VarCurr,B)
      <=> v27216(VarCurr,B) ) ) ).

tff(addAssignment_13940,axiom,
    ! [VarCurr: state_type] :
      ( ( v27215(VarCurr,5)
      <=> v27079(VarCurr,2) )
      & ( v27215(VarCurr,4)
      <=> v27079(VarCurr,1) )
      & ( v27215(VarCurr,3)
      <=> v27079(VarCurr,0) ) ) ).

tff(addAssignment_13939,axiom,
    ! [VarCurr: state_type] :
      ( v27079(VarCurr,1)
    <=> v27081(VarCurr,1) ) ).

tff(addAssignment_13938,axiom,
    ! [VarCurr: state_type] :
      ( v27081(VarCurr,1)
    <=> v27083(VarCurr,1) ) ).

tff(addAssignment_13937,axiom,
    ! [VarCurr: state_type] :
      ( v27083(VarCurr,1)
    <=> v27214(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v27214(VarCurr,B)
      <=> ( v27085(VarCurr,B)
          & v27151(VarCurr,B) ) ) ) ).

tff(addAssignment_13936,axiom,
    ! [VarCurr: state_type] :
      ( v27151(VarCurr,1)
    <=> v27153(VarCurr,1) ) ).

tff(addAssignment_13935,axiom,
    ! [VarCurr: state_type] :
      ( v27153(VarCurr,1)
    <=> v27155(VarCurr,1) ) ).

tff(addAssignment_13934,axiom,
    ! [VarCurr: state_type] :
      ( v27155(VarCurr,1)
    <=> v27157(VarCurr,1) ) ).

tff(addAssignment_13933,axiom,
    ! [VarCurr: state_type] :
      ( v27157(VarCurr,1)
    <=> v27159(VarCurr,1) ) ).

tff(addAssignment_13932,axiom,
    ! [VarCurr: state_type] :
      ( v27159(VarCurr,1)
    <=> v27169(VarCurr,1) ) ).

tff(addAssignment_13931,axiom,
    ! [VarCurr: state_type] :
      ( v27169(VarCurr,0)
    <=> v27209(VarCurr) ) ).

tff(addAssignment_13930,axiom,
    ! [VarCurr: state_type] :
      ( v27169(VarCurr,1)
    <=> v27204(VarCurr) ) ).

tff(addAssignment_13929,axiom,
    ! [VarCurr: state_type] :
      ( v27169(VarCurr,2)
    <=> v27199(VarCurr) ) ).

tff(addAssignment_13928,axiom,
    ! [VarCurr: state_type] :
      ( v27169(VarCurr,3)
    <=> v27171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2217,axiom,
    ! [VarCurr: state_type] :
      ( v27209(VarCurr)
    <=> ( v27210(VarCurr)
        & v27213(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2216,axiom,
    ! [VarCurr: state_type] :
      ( v27213(VarCurr)
    <=> ( v27161(VarCurr,0)
        | v27179(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2215,axiom,
    ! [VarCurr: state_type] :
      ( v27210(VarCurr)
    <=> ( v27211(VarCurr)
        | v27212(VarCurr) ) ) ).

tff(writeUnaryOperator_1464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27212(VarCurr)
    <=> v27179(VarCurr,0) ) ).

tff(writeUnaryOperator_1463,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27211(VarCurr)
    <=> v27161(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2214,axiom,
    ! [VarCurr: state_type] :
      ( v27204(VarCurr)
    <=> ( v27205(VarCurr)
        & v27208(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2213,axiom,
    ! [VarCurr: state_type] :
      ( v27208(VarCurr)
    <=> ( v27178(VarCurr)
        | v27180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2212,axiom,
    ! [VarCurr: state_type] :
      ( v27205(VarCurr)
    <=> ( v27206(VarCurr)
        | v27207(VarCurr) ) ) ).

tff(writeUnaryOperator_1462,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27207(VarCurr)
    <=> v27180(VarCurr) ) ).

tff(writeUnaryOperator_1461,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27206(VarCurr)
    <=> v27178(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2211,axiom,
    ! [VarCurr: state_type] :
      ( v27199(VarCurr)
    <=> ( v27200(VarCurr)
        & v27203(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2210,axiom,
    ! [VarCurr: state_type] :
      ( v27203(VarCurr)
    <=> ( v27176(VarCurr)
        | v27186(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2209,axiom,
    ! [VarCurr: state_type] :
      ( v27200(VarCurr)
    <=> ( v27201(VarCurr)
        | v27202(VarCurr) ) ) ).

tff(writeUnaryOperator_1460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27202(VarCurr)
    <=> v27186(VarCurr) ) ).

tff(writeUnaryOperator_1459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27201(VarCurr)
    <=> v27176(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2208,axiom,
    ! [VarCurr: state_type] :
      ( v27171(VarCurr)
    <=> ( v27172(VarCurr)
        & v27198(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2207,axiom,
    ! [VarCurr: state_type] :
      ( v27198(VarCurr)
    <=> ( v27174(VarCurr)
        | v27193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2206,axiom,
    ! [VarCurr: state_type] :
      ( v27172(VarCurr)
    <=> ( v27173(VarCurr)
        | v27192(VarCurr) ) ) ).

tff(writeUnaryOperator_1458,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27192(VarCurr)
    <=> v27193(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2205,axiom,
    ! [VarCurr: state_type] :
      ( v27193(VarCurr)
    <=> ( v27194(VarCurr)
        & v27197(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_238,axiom,
    ! [VarCurr: state_type] :
      ( v27197(VarCurr)
    <=> ( v27161(VarCurr,3)
        | v27179(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2204,axiom,
    ! [VarCurr: state_type] :
      ( v27194(VarCurr)
    <=> ( v27195(VarCurr)
        | v27196(VarCurr) ) ) ).

tff(writeUnaryOperator_1457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27196(VarCurr)
    <=> v27179(VarCurr,3) ) ).

tff(writeUnaryOperator_1456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27195(VarCurr)
    <=> v27161(VarCurr,3) ) ).

tff(writeUnaryOperator_1455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27173(VarCurr)
    <=> v27174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2203,axiom,
    ! [VarCurr: state_type] :
      ( v27174(VarCurr)
    <=> ( v27175(VarCurr)
        | v27191(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_237,axiom,
    ! [VarCurr: state_type] :
      ( v27191(VarCurr)
    <=> ( v27161(VarCurr,2)
        & v27179(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2202,axiom,
    ! [VarCurr: state_type] :
      ( v27175(VarCurr)
    <=> ( v27176(VarCurr)
        & v27186(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2201,axiom,
    ! [VarCurr: state_type] :
      ( v27186(VarCurr)
    <=> ( v27187(VarCurr)
        & v27190(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_236,axiom,
    ! [VarCurr: state_type] :
      ( v27190(VarCurr)
    <=> ( v27161(VarCurr,2)
        | v27179(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2200,axiom,
    ! [VarCurr: state_type] :
      ( v27187(VarCurr)
    <=> ( v27188(VarCurr)
        | v27189(VarCurr) ) ) ).

tff(writeUnaryOperator_1454,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27189(VarCurr)
    <=> v27179(VarCurr,2) ) ).

tff(writeUnaryOperator_1453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27188(VarCurr)
    <=> v27161(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2199,axiom,
    ! [VarCurr: state_type] :
      ( v27176(VarCurr)
    <=> ( v27177(VarCurr)
        | v27185(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_235,axiom,
    ! [VarCurr: state_type] :
      ( v27185(VarCurr)
    <=> ( v27161(VarCurr,1)
        & v27179(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2198,axiom,
    ! [VarCurr: state_type] :
      ( v27177(VarCurr)
    <=> ( v27178(VarCurr)
        & v27180(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2197,axiom,
    ! [VarCurr: state_type] :
      ( v27180(VarCurr)
    <=> ( v27181(VarCurr)
        & v27184(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_234,axiom,
    ! [VarCurr: state_type] :
      ( v27184(VarCurr)
    <=> ( v27161(VarCurr,1)
        | v27179(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2196,axiom,
    ! [VarCurr: state_type] :
      ( v27181(VarCurr)
    <=> ( v27182(VarCurr)
        | v27183(VarCurr) ) ) ).

tff(writeUnaryOperator_1452,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27183(VarCurr)
    <=> v27179(VarCurr,1) ) ).

tff(writeUnaryOperator_1451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27182(VarCurr)
    <=> v27161(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2195,axiom,
    ! [VarCurr: state_type] :
      ( v27178(VarCurr)
    <=> ( v27161(VarCurr,0)
        & v27179(VarCurr,0) ) ) ).

tff(addAssignment_13927,axiom,
    ! [VarCurr: state_type] :
      ( v27179(VarCurr,0)
    <=> v27166(VarCurr) ) ).

tff(addAssignment_13926,axiom,
    ! [VarCurr: state_type] :
      ( ( v27179(VarCurr,3)
      <=> $false )
      & ( v27179(VarCurr,2)
      <=> $false )
      & ( v27179(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_13925,axiom,
    ! [VarCurr: state_type] :
      ( v27166(VarCurr)
    <=> v27168(VarCurr) ) ).

tff(addAssignment_13924,axiom,
    ! [VarCurr: state_type] :
      ( v27168(VarCurr)
    <=> v27116(VarCurr) ) ).

tff(addAssignment_13923,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v27161(VarCurr,B)
      <=> v27163(VarCurr,B) ) ) ).

tff(addAssignment_13922,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v27163(VarCurr,B)
      <=> v27164(VarCurr,B) ) ) ).

tff(addAssignment_13921,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v27164(VarCurr,B)
      <=> v27051(VarCurr,B) ) ) ).

tff(addAssignment_13920,axiom,
    ! [VarCurr: state_type] :
      ( v27164(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_13919,axiom,
    ! [VarCurr: state_type] :
      ( v27085(VarCurr,1)
    <=> v27087(VarCurr,1) ) ).

tff(addAssignment_13918,axiom,
    ! [VarCurr: state_type] :
      ( v27087(VarCurr,1)
    <=> v27148(VarCurr,1) ) ).

tff(addAssignment_13917,axiom,
    ! [VarCurr: state_type] :
      ( v27148(VarCurr,0)
    <=> v27149(VarCurr) ) ).

tff(addAssignment_13916,axiom,
    ! [VarCurr: state_type] :
      ( v27148(VarCurr,1)
    <=> v27149(VarCurr) ) ).

tff(addAssignment_13915,axiom,
    ! [VarCurr: state_type] :
      ( v27148(VarCurr,2)
    <=> v27149(VarCurr) ) ).

tff(addAssignment_13914,axiom,
    ! [VarCurr: state_type] :
      ( v27149(VarCurr)
    <=> v27089(VarCurr) ) ).

tff(addAssignment_13913,axiom,
    ! [VarCurr: state_type] :
      ( v27130(VarCurr)
    <=> v27132(VarCurr) ) ).

tff(addAssignment_13912,axiom,
    ! [VarCurr: state_type] :
      ( v27132(VarCurr)
    <=> v27134(VarCurr,0) ) ).

tff(addAssignment_13911,axiom,
    ! [VarCurr: state_type] :
      ( v27134(VarCurr,0)
    <=> v27136(VarCurr,0) ) ).

tff(addAssignment_13910,axiom,
    ! [VarCurr: state_type] :
      ( v27136(VarCurr,0)
    <=> v27138(VarCurr,0) ) ).

tff(addAssignment_13909,axiom,
    ! [VarCurr: state_type] :
      ( v27138(VarCurr,0)
    <=> v27143(VarCurr,0) ) ).

tff(writeUnaryOperator_1450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v27143(VarCurr,B)
      <=> ~ v27140(VarCurr,B) ) ) ).

tff(addAssignment_13908,axiom,
    ! [VarCurr: state_type] :
      ( v27140(VarCurr,0)
    <=> v27142(VarCurr,0) ) ).

tff(addAssignment_13907,axiom,
    ! [VarCurr: state_type] :
      ( v27142(VarCurr,0)
    <=> v27051(VarCurr,0) ) ).

tff(addAssignment_13906,axiom,
    ! [VarCurr: state_type] :
      ( v27112(VarCurr,1)
    <=> v27114(VarCurr,1) ) ).

tff(addAssignment_13905,axiom,
    ! [VarCurr: state_type] :
      ( v27114(VarCurr,1)
    <=> v27117(VarCurr,1) ) ).

tff(addAssignment_13904,axiom,
    ! [VarCurr: state_type] :
      ( v27117(VarCurr,0)
    <=> v27118(VarCurr) ) ).

tff(addAssignment_13903,axiom,
    ! [VarCurr: state_type] :
      ( v27117(VarCurr,1)
    <=> v27116(VarCurr) ) ).

tff(addAssignment_13902,axiom,
    ! [VarCurr: state_type] :
      ( v27116(VarCurr)
    <=> v10053(VarCurr,11) ) ).

tff(addAssignment_13901,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,11)
    <=> v10055(VarCurr,11) ) ).

tff(addAssignment_13900,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,11)
    <=> v10057(VarCurr,11) ) ).

tff(addAssignment_13899,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,11)
    <=> v10061(VarCurr,11) ) ).

tff(addAssignment_13898,axiom,
    ! [VarCurr: state_type] :
      ( v27096(VarCurr,1)
    <=> v27098(VarCurr,1) ) ).

tff(addAssignment_13897,axiom,
    ! [VarCurr: state_type] :
      ( v27098(VarCurr,1)
    <=> v27099(VarCurr,1) ) ).

tff(addAssignment_13896,axiom,
    ! [VarCurr: state_type] :
      ( v27099(VarCurr,0)
    <=> v27100(VarCurr) ) ).

tff(addAssignment_13895,axiom,
    ! [VarCurr: state_type] :
      ( v27099(VarCurr,1)
    <=> v27100(VarCurr) ) ).

tff(addAssignment_13894,axiom,
    ! [VarCurr: state_type] :
      ( v27100(VarCurr)
    <=> v26623(VarCurr) ) ).

tff(addAssignment_13893,axiom,
    ! [VarCurr: state_type] :
      ( v27065(VarCurr)
    <=> v27067(VarCurr) ) ).

tff(addAssignment_13892,axiom,
    ! [VarCurr: state_type] :
      ( v27067(VarCurr)
    <=> v27069(VarCurr) ) ).

tff(addAssignment_13891,axiom,
    ! [VarCurr: state_type] :
      ( v27069(VarCurr)
    <=> v27071(VarCurr) ) ).

tff(addAssignment_13890,axiom,
    ! [VarCurr: state_type] :
      ( v27071(VarCurr)
    <=> v27073(VarCurr) ) ).

tff(addAssignment_13889,axiom,
    ! [VarCurr: state_type] :
      ( v27073(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_13888,axiom,
    ! [VarCurr: state_type] :
      ( v27053(VarCurr)
    <=> v27055(VarCurr) ) ).

tff(addAssignment_13887,axiom,
    ! [VarCurr: state_type] :
      ( v27055(VarCurr)
    <=> v27057(VarCurr) ) ).

tff(addAssignment_13886,axiom,
    ! [VarCurr: state_type] :
      ( v27057(VarCurr)
    <=> v27059(VarCurr) ) ).

tff(addAssignment_13885,axiom,
    ! [VarCurr: state_type] :
      ( v27059(VarCurr)
    <=> v27061(VarCurr) ) ).

tff(addAssignment_13884,axiom,
    ! [VarCurr: state_type] :
      ( v27061(VarCurr)
    <=> v27063(VarCurr) ) ).

tff(addAssignment_13883,axiom,
    ! [VarCurr: state_type] :
      ( v27063(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_13882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26561(VarCurr,B)
      <=> v26563(VarCurr,B) ) ) ).

tff(addAssignment_13881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26563(VarCurr,B)
      <=> v26565(VarCurr,B) ) ) ).

tff(addAssignment_13880,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26565(VarCurr,B)
      <=> v26567(VarCurr,B) ) ) ).

tff(addAssignment_13879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26567(VarCurr,B)
      <=> v26569(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27014(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v26569(VarNext,B)
            <=> v26569(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_302,axiom,
    ! [VarNext: state_type] :
      ( v27014(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26569(VarNext,B)
          <=> v27024(VarNext,B) ) ) ) ).

tff(addAssignment_13878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27024(VarNext,B)
          <=> v27022(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27025(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27022(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_185,axiom,
    ! [VarCurr: state_type] :
      ( v27025(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v27022(VarCurr,B)
          <=> v26599(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2194,axiom,
    ! [VarCurr: state_type] :
      ( v27025(VarCurr)
    <=> ( v27026(VarCurr)
        & v27027(VarCurr) ) ) ).

tff(writeUnaryOperator_1449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27027(VarCurr)
    <=> v26585(VarCurr) ) ).

tff(writeUnaryOperator_1448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v27026(VarCurr)
    <=> v26571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27014(VarNext)
      <=> v27015(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27015(VarNext)
      <=> ( v27016(VarNext)
          & v26929(VarNext) ) ) ) ).

tff(writeUnaryOperator_1447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v27016(VarNext)
      <=> v27018(VarNext) ) ) ).

tff(addAssignment_13877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v27018(VarNext)
      <=> v26929(VarCurr) ) ) ).

tff(addAssignment_13876,axiom,
    ! [VarCurr: state_type] :
      ( v26929(VarCurr)
    <=> v26931(VarCurr) ) ).

tff(addAssignment_13875,axiom,
    ! [VarCurr: state_type] :
      ( v26931(VarCurr)
    <=> v26933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2191,axiom,
    ! [VarCurr: state_type] :
      ( v26933(VarCurr)
    <=> ( v27011(VarCurr)
        | v27003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2190,axiom,
    ! [VarCurr: state_type] :
      ( v27011(VarCurr)
    <=> ( v26935(VarCurr)
        & v26941(VarCurr) ) ) ).

tff(addAssignment_13874,axiom,
    ! [VarCurr: state_type] :
      ( v27003(VarCurr)
    <=> v27005(VarCurr) ) ).

tff(addAssignment_13873,axiom,
    ! [VarCurr: state_type] :
      ( v27005(VarCurr)
    <=> v27007(VarCurr) ) ).

tff(addAssignment_13872,axiom,
    ! [VarCurr: state_type] :
      ( v27007(VarCurr)
    <=> v27009(VarCurr) ) ).

tff(addAssignment_13871,axiom,
    ! [VarCurr: state_type] :
      ( v27009(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_301,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26987(VarNext)
       => ( v26941(VarNext)
        <=> v26941(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_301,axiom,
    ! [VarNext: state_type] :
      ( v26987(VarNext)
     => ( v26941(VarNext)
      <=> v26997(VarNext) ) ) ).

tff(addAssignment_13870,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26997(VarNext)
      <=> v26995(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2189,axiom,
    ! [VarCurr: state_type] :
      ( v26995(VarCurr)
    <=> ( v26998(VarCurr)
        & v26999(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2188,axiom,
    ! [VarCurr: state_type] :
      ( v26999(VarCurr)
    <=> ( v26947(VarCurr)
        | v26978(VarCurr) ) ) ).

tff(writeUnaryOperator_1446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26998(VarCurr)
    <=> v26943(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26987(VarNext)
      <=> v26988(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26988(VarNext)
      <=> ( v26990(VarNext)
          & v26992(VarNext) ) ) ) ).

tff(writeUnaryOperator_1445,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26992(VarCurr)
    <=> v26935(VarCurr) ) ).

tff(addAssignment_13869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26990(VarNext)
      <=> v26935(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_114,axiom,
    ( v26941(constB0)
  <=> $true ) ).

tff(addAssignment_13868,axiom,
    ! [VarCurr: state_type] :
      ( v26978(VarCurr)
    <=> v26980(VarCurr) ) ).

tff(addAssignment_13867,axiom,
    ! [VarCurr: state_type] :
      ( v26980(VarCurr)
    <=> v26982(VarCurr) ) ).

tff(addAssignment_13866,axiom,
    ! [VarCurr: state_type] :
      ( v26982(VarCurr)
    <=> v26984(VarCurr) ) ).

tff(addAssignment_13865,axiom,
    ! [VarCurr: state_type] :
      ( v26984(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_13864,axiom,
    ! [VarCurr: state_type] :
      ( v26947(VarCurr)
    <=> v26949(VarCurr) ) ).

tff(addAssignment_13863,axiom,
    ! [VarCurr: state_type] :
      ( v26949(VarCurr)
    <=> v26951(VarCurr) ) ).

tff(addAssignment_13862,axiom,
    ! [VarCurr: state_type] :
      ( v26951(VarCurr)
    <=> v26953(VarCurr) ) ).

tff(addAssignment_13861,axiom,
    ! [VarCurr: state_type] :
      ( v26953(VarCurr)
    <=> v26955(VarCurr) ) ).

tff(writeUnaryOperator_1444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26955(VarCurr)
    <=> v26975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2185,axiom,
    ! [VarCurr: state_type] :
      ( v26975(VarCurr)
    <=> ( v26976(VarCurr)
        | v26971(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2184,axiom,
    ! [VarCurr: state_type] :
      ( v26976(VarCurr)
    <=> ( v26957(VarCurr)
        | v26967(VarCurr) ) ) ).

tff(addAssignment_13860,axiom,
    ! [VarCurr: state_type] :
      ( v26971(VarCurr)
    <=> v26973(VarCurr) ) ).

tff(addAssignment_13859,axiom,
    ! [VarCurr: state_type] :
      ( v26973(VarCurr)
    <=> v26961(VarCurr,2) ) ).

tff(addAssignment_13858,axiom,
    ! [VarCurr: state_type] :
      ( v26961(VarCurr,2)
    <=> v26963(VarCurr,2) ) ).

tff(addAssignment_13857,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,2)
    <=> v26965(VarCurr,2) ) ).

tff(addAssignment_13856,axiom,
    ! [VarCurr: state_type] :
      ( v26967(VarCurr)
    <=> v26969(VarCurr) ) ).

tff(addAssignment_13855,axiom,
    ! [VarCurr: state_type] :
      ( v26969(VarCurr)
    <=> v26961(VarCurr,1) ) ).

tff(addAssignment_13854,axiom,
    ! [VarCurr: state_type] :
      ( v26961(VarCurr,1)
    <=> v26963(VarCurr,1) ) ).

tff(addAssignment_13853,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,1)
    <=> v26965(VarCurr,1) ) ).

tff(addAssignment_13852,axiom,
    ! [VarCurr: state_type] :
      ( v26957(VarCurr)
    <=> v26959(VarCurr) ) ).

tff(addAssignment_13851,axiom,
    ! [VarCurr: state_type] :
      ( v26959(VarCurr)
    <=> v26961(VarCurr,0) ) ).

tff(addAssignment_13850,axiom,
    ! [VarCurr: state_type] :
      ( v26961(VarCurr,0)
    <=> v26963(VarCurr,0) ) ).

tff(addAssignment_13849,axiom,
    ! [VarCurr: state_type] :
      ( v26963(VarCurr,0)
    <=> v26965(VarCurr,0) ) ).

tff(addAssignment_13848,axiom,
    ! [VarCurr: state_type] :
      ( v26943(VarCurr)
    <=> v26945(VarCurr) ) ).

tff(addAssignment_13847,axiom,
    ! [VarCurr: state_type] :
      ( v26945(VarCurr)
    <=> $false ) ).

tff(addAssignment_13846,axiom,
    ! [VarCurr: state_type] :
      ( v26935(VarCurr)
    <=> v26937(VarCurr) ) ).

tff(addAssignment_13845,axiom,
    ! [VarCurr: state_type] :
      ( v26937(VarCurr)
    <=> v26939(VarCurr) ) ).

tff(addAssignment_13844,axiom,
    ! [VarCurr: state_type] :
      ( v26939(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_13843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26599(VarCurr,B)
      <=> v26601(VarCurr,B) ) ) ).

tff(addAssignment_13842,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26601(VarCurr,B)
      <=> v26603(VarCurr,B) ) ) ).

tff(addAssignment_13841,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26603(VarCurr,B)
      <=> v26605(VarCurr,B) ) ) ).

tff(addAssignment_13840,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26605(VarCurr,B)
      <=> v26607(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26607(VarCurr,B)
      <=> ( v26609(VarCurr,B)
          & v26631(VarCurr,B) ) ) ) ).

tff(addAssignment_13839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26631(VarCurr,B)
      <=> v26633(VarCurr,B) ) ) ).

tff(addAssignment_13838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26633(VarCurr,B)
      <=> v26635(VarCurr,B) ) ) ).

tff(addAssignment_13837,axiom,
    ! [VarCurr: state_type] :
      ( ( v26635(VarCurr,11)
      <=> v9198(VarCurr,143) )
      & ( v26635(VarCurr,10)
      <=> v9198(VarCurr,142) )
      & ( v26635(VarCurr,9)
      <=> v9198(VarCurr,141) )
      & ( v26635(VarCurr,8)
      <=> v9198(VarCurr,140) )
      & ( v26635(VarCurr,7)
      <=> v9198(VarCurr,139) )
      & ( v26635(VarCurr,6)
      <=> v9198(VarCurr,138) )
      & ( v26635(VarCurr,5)
      <=> v9198(VarCurr,137) )
      & ( v26635(VarCurr,4)
      <=> v9198(VarCurr,136) )
      & ( v26635(VarCurr,3)
      <=> v9198(VarCurr,135) )
      & ( v26635(VarCurr,2)
      <=> v9198(VarCurr,134) )
      & ( v26635(VarCurr,1)
      <=> v9198(VarCurr,133) )
      & ( v26635(VarCurr,0)
      <=> v9198(VarCurr,132) ) ) ).

tff(addAssignment_13836,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,143)
      <=> v26637(VarCurr,11) )
      & ( v9198(VarCurr,142)
      <=> v26637(VarCurr,10) )
      & ( v9198(VarCurr,141)
      <=> v26637(VarCurr,9) )
      & ( v9198(VarCurr,140)
      <=> v26637(VarCurr,8) )
      & ( v9198(VarCurr,139)
      <=> v26637(VarCurr,7) )
      & ( v9198(VarCurr,138)
      <=> v26637(VarCurr,6) )
      & ( v9198(VarCurr,137)
      <=> v26637(VarCurr,5) )
      & ( v9198(VarCurr,136)
      <=> v26637(VarCurr,4) )
      & ( v9198(VarCurr,135)
      <=> v26637(VarCurr,3) )
      & ( v9198(VarCurr,134)
      <=> v26637(VarCurr,2) )
      & ( v9198(VarCurr,133)
      <=> v26637(VarCurr,1) )
      & ( v9198(VarCurr,132)
      <=> v26637(VarCurr,0) ) ) ).

tff(addAssignment_13835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26637(VarCurr,B)
      <=> v26639(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26639(VarCurr,B)
      <=> ( v26921(VarCurr,B)
          | v26924(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26924(VarCurr,B)
      <=> ( v26649(VarCurr,B)
          & v26925(VarCurr,B) ) ) ) ).

tff(addAssignment_13834,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,0)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13833,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,1)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13832,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,2)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13831,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,3)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13830,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,4)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13829,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,5)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13828,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,6)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13827,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,7)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13826,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,8)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13825,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,9)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13824,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,10)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13823,axiom,
    ! [VarCurr: state_type] :
      ( v26925(VarCurr,11)
    <=> v26926(VarCurr) ) ).

tff(addAssignment_13822,axiom,
    ! [VarCurr: state_type] :
      ( v26926(VarCurr)
    <=> v26917(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26921(VarCurr,B)
      <=> ( v26641(VarCurr,B)
          & v26922(VarCurr,B) ) ) ) ).

tff(addAssignment_13821,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,0)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13820,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,1)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13819,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,2)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13818,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,3)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13817,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,4)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13816,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,5)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13815,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,6)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13814,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,7)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13813,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,8)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13812,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,9)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13811,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,10)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13810,axiom,
    ! [VarCurr: state_type] :
      ( v26922(VarCurr,11)
    <=> v26923(VarCurr) ) ).

tff(addAssignment_13809,axiom,
    ! [VarCurr: state_type] :
      ( v26923(VarCurr)
    <=> v26645(VarCurr) ) ).

tff(addAssignment_13808,axiom,
    ! [VarCurr: state_type] :
      ( v26917(VarCurr)
    <=> v26919(VarCurr) ) ).

tff(addAssignment_13807,axiom,
    ! [VarCurr: state_type] :
      ( v26919(VarCurr)
    <=> v9844(VarCurr,11) ) ).

tff(addAssignment_13806,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,11)
    <=> v9846(VarCurr,11) ) ).

tff(addAssignment_13805,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,11)
    <=> v9496(VarCurr,11) ) ).

tff(addAssignment_13804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26649(VarCurr,B)
      <=> v26651(VarCurr,B) ) ) ).

tff(addAssignment_13803,axiom,
    ! [VarCurr: state_type] :
      ( ( v26651(VarCurr,11)
      <=> v9208(VarCurr,155) )
      & ( v26651(VarCurr,10)
      <=> v9208(VarCurr,154) )
      & ( v26651(VarCurr,9)
      <=> v9208(VarCurr,153) )
      & ( v26651(VarCurr,8)
      <=> v9208(VarCurr,152) )
      & ( v26651(VarCurr,7)
      <=> v9208(VarCurr,151) )
      & ( v26651(VarCurr,6)
      <=> v9208(VarCurr,150) )
      & ( v26651(VarCurr,5)
      <=> v9208(VarCurr,149) )
      & ( v26651(VarCurr,4)
      <=> v9208(VarCurr,148) )
      & ( v26651(VarCurr,3)
      <=> v9208(VarCurr,147) )
      & ( v26651(VarCurr,2)
      <=> v9208(VarCurr,146) )
      & ( v26651(VarCurr,1)
      <=> v9208(VarCurr,145) )
      & ( v26651(VarCurr,0)
      <=> v9208(VarCurr,144) ) ) ).

tff(addAssignment_13802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,156)
        & ~ $less(B,144) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_13801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,156)
        & ~ $less(B,144) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_13800,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,155)
      <=> v26653(VarCurr,11) )
      & ( v9212(VarCurr,154)
      <=> v26653(VarCurr,10) )
      & ( v9212(VarCurr,153)
      <=> v26653(VarCurr,9) )
      & ( v9212(VarCurr,152)
      <=> v26653(VarCurr,8) )
      & ( v9212(VarCurr,151)
      <=> v26653(VarCurr,7) )
      & ( v9212(VarCurr,150)
      <=> v26653(VarCurr,6) )
      & ( v9212(VarCurr,149)
      <=> v26653(VarCurr,5) )
      & ( v9212(VarCurr,148)
      <=> v26653(VarCurr,4) )
      & ( v9212(VarCurr,147)
      <=> v26653(VarCurr,3) )
      & ( v9212(VarCurr,146)
      <=> v26653(VarCurr,2) )
      & ( v9212(VarCurr,145)
      <=> v26653(VarCurr,1) )
      & ( v9212(VarCurr,144)
      <=> v26653(VarCurr,0) ) ) ).

tff(addAssignment_13799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26653(VarCurr,B)
      <=> v26655(VarCurr,B) ) ) ).

tff(addAssignment_13798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26655(VarCurr,B)
      <=> v26657(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_300,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26900(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v26657(VarNext,B)
            <=> v26657(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_300,axiom,
    ! [VarNext: state_type] :
      ( v26900(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26657(VarNext,B)
          <=> v26910(VarNext,B) ) ) ) ).

tff(addAssignment_13797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26910(VarNext,B)
          <=> v26908(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26911(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26908(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_184,axiom,
    ! [VarCurr: state_type] :
      ( v26911(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26908(VarCurr,B)
          <=> v26687(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2183,axiom,
    ! [VarCurr: state_type] :
      ( v26911(VarCurr)
    <=> ( v26912(VarCurr)
        & v26913(VarCurr) ) ) ).

tff(writeUnaryOperator_1443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26913(VarCurr)
    <=> v26673(VarCurr) ) ).

tff(writeUnaryOperator_1442,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26912(VarCurr)
    <=> v26659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26900(VarNext)
      <=> v26901(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26901(VarNext)
      <=> ( v26902(VarNext)
          & v26875(VarNext) ) ) ) ).

tff(writeUnaryOperator_1441,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26902(VarNext)
      <=> v26904(VarNext) ) ) ).

tff(addAssignment_13796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26904(VarNext)
      <=> v26875(VarCurr) ) ) ).

tff(addAssignment_13795,axiom,
    ! [VarCurr: state_type] :
      ( v26875(VarCurr)
    <=> v26877(VarCurr) ) ).

tff(addAssignment_13794,axiom,
    ! [VarCurr: state_type] :
      ( v26877(VarCurr)
    <=> v26879(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2180,axiom,
    ! [VarCurr: state_type] :
      ( v26879(VarCurr)
    <=> ( v26897(VarCurr)
        | v26889(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2179,axiom,
    ! [VarCurr: state_type] :
      ( v26897(VarCurr)
    <=> ( v26881(VarCurr)
        & v26887(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_113,axiom,
    ( v26887(constB0)
  <=> $true ) ).

tff(addAssignment_13793,axiom,
    ! [VarCurr: state_type] :
      ( v26889(VarCurr)
    <=> v26891(VarCurr) ) ).

tff(addAssignment_13792,axiom,
    ! [VarCurr: state_type] :
      ( v26891(VarCurr)
    <=> v26893(VarCurr) ) ).

tff(addAssignment_13791,axiom,
    ! [VarCurr: state_type] :
      ( v26893(VarCurr)
    <=> v26895(VarCurr) ) ).

tff(addAssignment_13790,axiom,
    ! [VarCurr: state_type] :
      ( v26895(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_13789,axiom,
    ! [VarCurr: state_type] :
      ( v26881(VarCurr)
    <=> v26883(VarCurr) ) ).

tff(addAssignment_13788,axiom,
    ! [VarCurr: state_type] :
      ( v26883(VarCurr)
    <=> v26885(VarCurr) ) ).

tff(addAssignment_13787,axiom,
    ! [VarCurr: state_type] :
      ( v26885(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_13786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26687(VarCurr,B)
      <=> v26689(VarCurr,B) ) ) ).

tff(addAssignment_13785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26689(VarCurr,B)
      <=> v26691(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26691(VarCurr,B)
      <=> ( v26860(VarCurr,B)
          | v26871(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26871(VarCurr,B)
      <=> ( v26824(VarCurr,B)
          & v26872(VarCurr,B) ) ) ) ).

tff(addAssignment_13784,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,0)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13783,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,1)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13782,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,2)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13781,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,3)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13780,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,4)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13779,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,5)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13778,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,6)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13777,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,7)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13776,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,8)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13775,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,9)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13774,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,10)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13773,axiom,
    ! [VarCurr: state_type] :
      ( v26872(VarCurr,11)
    <=> v26873(VarCurr) ) ).

tff(addAssignment_13772,axiom,
    ! [VarCurr: state_type] :
      ( v26873(VarCurr)
    <=> v26834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26860(VarCurr,B)
      <=> ( v26861(VarCurr,B)
          | v26868(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26868(VarCurr,B)
      <=> ( v26788(VarCurr,B)
          & v26869(VarCurr,B) ) ) ) ).

tff(addAssignment_13771,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,0)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13770,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,1)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13769,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,2)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13768,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,3)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13767,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,4)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13766,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,5)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13765,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,6)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13764,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,7)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13763,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,8)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13762,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,9)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13761,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,10)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13760,axiom,
    ! [VarCurr: state_type] :
      ( v26869(VarCurr,11)
    <=> v26870(VarCurr) ) ).

tff(addAssignment_13759,axiom,
    ! [VarCurr: state_type] :
      ( v26870(VarCurr)
    <=> v26798(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26861(VarCurr,B)
      <=> ( v26862(VarCurr,B)
          | v26865(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_445,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26865(VarCurr,B)
      <=> ( v26741(VarCurr,B)
          & v26866(VarCurr,B) ) ) ) ).

tff(addAssignment_13758,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,0)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13757,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,1)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13756,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,2)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13755,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,3)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13754,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,4)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13753,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,5)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13752,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,6)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13751,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,7)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13750,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,8)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13749,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,9)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13748,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,10)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13747,axiom,
    ! [VarCurr: state_type] :
      ( v26866(VarCurr,11)
    <=> v26867(VarCurr) ) ).

tff(addAssignment_13746,axiom,
    ! [VarCurr: state_type] :
      ( v26867(VarCurr)
    <=> v26751(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_444,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26862(VarCurr,B)
      <=> ( v26693(VarCurr,B)
          & v26863(VarCurr,B) ) ) ) ).

tff(addAssignment_13745,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,0)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13744,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,1)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13743,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,2)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13742,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,3)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13741,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,4)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13740,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,5)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13739,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,6)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13738,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,7)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13737,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,8)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13736,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,9)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13735,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,10)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13734,axiom,
    ! [VarCurr: state_type] :
      ( v26863(VarCurr,11)
    <=> v26864(VarCurr) ) ).

tff(addAssignment_13733,axiom,
    ! [VarCurr: state_type] :
      ( v26864(VarCurr)
    <=> v26703(VarCurr) ) ).

tff(addAssignment_13732,axiom,
    ! [VarCurr: state_type] :
      ( v26834(VarCurr)
    <=> v26836(VarCurr) ) ).

tff(addAssignment_13731,axiom,
    ! [VarCurr: state_type] :
      ( v26836(VarCurr)
    <=> v26838(VarCurr) ) ).

tff(addAssignment_13730,axiom,
    ! [VarCurr: state_type] :
      ( v26838(VarCurr)
    <=> v26840(VarCurr) ) ).

tff(addAssignment_13729,axiom,
    ! [VarCurr: state_type] :
      ( v26840(VarCurr)
    <=> v26842(VarCurr) ) ).

tff(addAssignment_13728,axiom,
    ! [VarCurr: state_type] :
      ( v26842(VarCurr)
    <=> v26844(VarCurr) ) ).

tff(addAssignment_13727,axiom,
    ! [VarCurr: state_type] :
      ( v26844(VarCurr)
    <=> v26846(VarCurr) ) ).

tff(addAssignment_13726,axiom,
    ! [VarCurr: state_type] :
      ( v26846(VarCurr)
    <=> v26848(VarCurr) ) ).

tff(writeUnaryOperator_1440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26848(VarCurr)
    <=> v26858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2178,axiom,
    ! [VarCurr: state_type] :
      ( v26858(VarCurr)
    <=> ( v26850(VarCurr)
        | v26854(VarCurr) ) ) ).

tff(addAssignment_13725,axiom,
    ! [VarCurr: state_type] :
      ( v26854(VarCurr)
    <=> v26856(VarCurr) ) ).

tff(addAssignment_13724,axiom,
    ! [VarCurr: state_type] :
      ( v26856(VarCurr)
    <=> v26771(VarCurr,1) ) ).

tff(addAssignment_13723,axiom,
    ! [VarCurr: state_type] :
      ( v26850(VarCurr)
    <=> v26852(VarCurr) ) ).

tff(addAssignment_13722,axiom,
    ! [VarCurr: state_type] :
      ( v26852(VarCurr)
    <=> v26771(VarCurr,0) ) ).

tff(addAssignment_13721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26824(VarCurr,B)
      <=> v26826(VarCurr,B) ) ) ).

tff(addAssignment_13720,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26826(VarCurr,B)
      <=> v26828(VarCurr,B) ) ) ).

tff(addAssignment_13719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26828(VarCurr,B)
      <=> v26830(VarCurr,B) ) ) ).

tff(addAssignment_13718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26830(VarCurr,B)
      <=> v26832(VarCurr,B) ) ) ).

tff(addAssignment_13717,axiom,
    ! [VarCurr: state_type] :
      ( v26798(VarCurr)
    <=> v26800(VarCurr) ) ).

tff(addAssignment_13716,axiom,
    ! [VarCurr: state_type] :
      ( v26800(VarCurr)
    <=> v26802(VarCurr) ) ).

tff(addAssignment_13715,axiom,
    ! [VarCurr: state_type] :
      ( v26802(VarCurr)
    <=> v26804(VarCurr) ) ).

tff(addAssignment_13714,axiom,
    ! [VarCurr: state_type] :
      ( v26804(VarCurr)
    <=> v26806(VarCurr) ) ).

tff(addAssignment_13713,axiom,
    ! [VarCurr: state_type] :
      ( v26806(VarCurr)
    <=> v26808(VarCurr) ) ).

tff(addAssignment_13712,axiom,
    ! [VarCurr: state_type] :
      ( v26808(VarCurr)
    <=> v26810(VarCurr) ) ).

tff(addAssignment_13711,axiom,
    ! [VarCurr: state_type] :
      ( v26810(VarCurr)
    <=> v26812(VarCurr) ) ).

tff(writeUnaryOperator_1439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26812(VarCurr)
    <=> v26822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2177,axiom,
    ! [VarCurr: state_type] :
      ( v26822(VarCurr)
    <=> ( v26814(VarCurr)
        | v26818(VarCurr) ) ) ).

tff(addAssignment_13710,axiom,
    ! [VarCurr: state_type] :
      ( v26818(VarCurr)
    <=> v26820(VarCurr) ) ).

tff(addAssignment_13709,axiom,
    ! [VarCurr: state_type] :
      ( v26820(VarCurr)
    <=> v26771(VarCurr,1) ) ).

tff(addAssignment_13708,axiom,
    ! [VarCurr: state_type] :
      ( v26771(VarCurr,1)
    <=> v26773(VarCurr,1) ) ).

tff(addAssignment_13707,axiom,
    ! [VarCurr: state_type] :
      ( v26773(VarCurr,1)
    <=> v26775(VarCurr,1) ) ).

tff(addAssignment_13706,axiom,
    ! [VarCurr: state_type] :
      ( v26775(VarCurr,1)
    <=> v26780(VarCurr,1) ) ).

tff(addAssignment_13705,axiom,
    ! [VarCurr: state_type] :
      ( v26777(VarCurr,1)
    <=> v26779(VarCurr,1) ) ).

tff(addAssignment_13704,axiom,
    ! [VarCurr: state_type] :
      ( v26779(VarCurr,1)
    <=> v26723(VarCurr,1) ) ).

tff(addAssignment_13703,axiom,
    ! [VarCurr: state_type] :
      ( v26814(VarCurr)
    <=> v26816(VarCurr) ) ).

tff(addAssignment_13702,axiom,
    ! [VarCurr: state_type] :
      ( v26816(VarCurr)
    <=> v26723(VarCurr,0) ) ).

tff(addAssignment_13701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26788(VarCurr,B)
      <=> v26790(VarCurr,B) ) ) ).

tff(addAssignment_13700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26790(VarCurr,B)
      <=> v26792(VarCurr,B) ) ) ).

tff(addAssignment_13699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26792(VarCurr,B)
      <=> v26794(VarCurr,B) ) ) ).

tff(addAssignment_13698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26794(VarCurr,B)
      <=> v26796(VarCurr,B) ) ) ).

tff(addAssignment_13697,axiom,
    ! [VarCurr: state_type] :
      ( v26751(VarCurr)
    <=> v26753(VarCurr) ) ).

tff(addAssignment_13696,axiom,
    ! [VarCurr: state_type] :
      ( v26753(VarCurr)
    <=> v26755(VarCurr) ) ).

tff(addAssignment_13695,axiom,
    ! [VarCurr: state_type] :
      ( v26755(VarCurr)
    <=> v26757(VarCurr) ) ).

tff(addAssignment_13694,axiom,
    ! [VarCurr: state_type] :
      ( v26757(VarCurr)
    <=> v26759(VarCurr) ) ).

tff(addAssignment_13693,axiom,
    ! [VarCurr: state_type] :
      ( v26759(VarCurr)
    <=> v26761(VarCurr) ) ).

tff(addAssignment_13692,axiom,
    ! [VarCurr: state_type] :
      ( v26761(VarCurr)
    <=> v26763(VarCurr) ) ).

tff(addAssignment_13691,axiom,
    ! [VarCurr: state_type] :
      ( v26763(VarCurr)
    <=> v26765(VarCurr) ) ).

tff(writeUnaryOperator_1438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26765(VarCurr)
    <=> v26786(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2176,axiom,
    ! [VarCurr: state_type] :
      ( v26786(VarCurr)
    <=> ( v26767(VarCurr)
        | v26782(VarCurr) ) ) ).

tff(addAssignment_13690,axiom,
    ! [VarCurr: state_type] :
      ( v26782(VarCurr)
    <=> v26784(VarCurr) ) ).

tff(addAssignment_13689,axiom,
    ! [VarCurr: state_type] :
      ( v26784(VarCurr)
    <=> v26723(VarCurr,1) ) ).

tff(addAssignment_13688,axiom,
    ! [VarCurr: state_type] :
      ( v26767(VarCurr)
    <=> v26769(VarCurr) ) ).

tff(addAssignment_13687,axiom,
    ! [VarCurr: state_type] :
      ( v26769(VarCurr)
    <=> v26771(VarCurr,0) ) ).

tff(addAssignment_13686,axiom,
    ! [VarCurr: state_type] :
      ( v26771(VarCurr,0)
    <=> v26773(VarCurr,0) ) ).

tff(addAssignment_13685,axiom,
    ! [VarCurr: state_type] :
      ( v26773(VarCurr,0)
    <=> v26775(VarCurr,0) ) ).

tff(addAssignment_13684,axiom,
    ! [VarCurr: state_type] :
      ( v26775(VarCurr,0)
    <=> v26780(VarCurr,0) ) ).

tff(writeUnaryOperator_1437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v26780(VarCurr,B)
      <=> ~ v26777(VarCurr,B) ) ) ).

tff(addAssignment_13683,axiom,
    ! [VarCurr: state_type] :
      ( v26777(VarCurr,0)
    <=> v26779(VarCurr,0) ) ).

tff(addAssignment_13682,axiom,
    ! [VarCurr: state_type] :
      ( v26779(VarCurr,0)
    <=> v26723(VarCurr,0) ) ).

tff(addAssignment_13681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26741(VarCurr,B)
      <=> v26743(VarCurr,B) ) ) ).

tff(addAssignment_13680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26743(VarCurr,B)
      <=> v26745(VarCurr,B) ) ) ).

tff(addAssignment_13679,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26745(VarCurr,B)
      <=> v26747(VarCurr,B) ) ) ).

tff(addAssignment_13678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26747(VarCurr,B)
      <=> v26749(VarCurr,B) ) ) ).

tff(addAssignment_13677,axiom,
    ! [VarCurr: state_type] :
      ( v26703(VarCurr)
    <=> v26705(VarCurr) ) ).

tff(addAssignment_13676,axiom,
    ! [VarCurr: state_type] :
      ( v26705(VarCurr)
    <=> v26707(VarCurr) ) ).

tff(addAssignment_13675,axiom,
    ! [VarCurr: state_type] :
      ( v26707(VarCurr)
    <=> v26709(VarCurr) ) ).

tff(addAssignment_13674,axiom,
    ! [VarCurr: state_type] :
      ( v26709(VarCurr)
    <=> v26711(VarCurr) ) ).

tff(addAssignment_13673,axiom,
    ! [VarCurr: state_type] :
      ( v26711(VarCurr)
    <=> v26713(VarCurr) ) ).

tff(addAssignment_13672,axiom,
    ! [VarCurr: state_type] :
      ( v26713(VarCurr)
    <=> v26715(VarCurr) ) ).

tff(addAssignment_13671,axiom,
    ! [VarCurr: state_type] :
      ( v26715(VarCurr)
    <=> v26717(VarCurr) ) ).

tff(writeUnaryOperator_1436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26717(VarCurr)
    <=> v26739(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2175,axiom,
    ! [VarCurr: state_type] :
      ( v26739(VarCurr)
    <=> ( v26719(VarCurr)
        | v26735(VarCurr) ) ) ).

tff(addAssignment_13670,axiom,
    ! [VarCurr: state_type] :
      ( v26735(VarCurr)
    <=> v26737(VarCurr) ) ).

tff(addAssignment_13669,axiom,
    ! [VarCurr: state_type] :
      ( v26737(VarCurr)
    <=> v26723(VarCurr,1) ) ).

tff(addAssignment_13668,axiom,
    ! [VarCurr: state_type] :
      ( v26723(VarCurr,1)
    <=> v26725(VarCurr,1) ) ).

tff(addAssignment_13667,axiom,
    ! [VarCurr: state_type] :
      ( v26725(VarCurr,1)
    <=> v26727(VarCurr,1) ) ).

tff(addAssignment_13666,axiom,
    ! [VarCurr: state_type] :
      ( v26727(VarCurr,1)
    <=> v26729(VarCurr,1) ) ).

tff(addAssignment_13665,axiom,
    ! [VarCurr: state_type] :
      ( v26729(VarCurr,1)
    <=> v26731(VarCurr,1) ) ).

tff(addAssignment_13664,axiom,
    ! [VarCurr: state_type] :
      ( v26731(VarCurr,1)
    <=> v26733(VarCurr,1) ) ).

tff(addAssignment_13663,axiom,
    ! [VarCurr: state_type] :
      ( v26719(VarCurr)
    <=> v26721(VarCurr) ) ).

tff(addAssignment_13662,axiom,
    ! [VarCurr: state_type] :
      ( v26721(VarCurr)
    <=> v26723(VarCurr,0) ) ).

tff(addAssignment_13661,axiom,
    ! [VarCurr: state_type] :
      ( v26723(VarCurr,0)
    <=> v26725(VarCurr,0) ) ).

tff(addAssignment_13660,axiom,
    ! [VarCurr: state_type] :
      ( v26725(VarCurr,0)
    <=> v26727(VarCurr,0) ) ).

tff(addAssignment_13659,axiom,
    ! [VarCurr: state_type] :
      ( v26727(VarCurr,0)
    <=> v26729(VarCurr,0) ) ).

tff(addAssignment_13658,axiom,
    ! [VarCurr: state_type] :
      ( v26729(VarCurr,0)
    <=> v26731(VarCurr,0) ) ).

tff(addAssignment_13657,axiom,
    ! [VarCurr: state_type] :
      ( v26731(VarCurr,0)
    <=> v26733(VarCurr,0) ) ).

tff(addAssignment_13656,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26693(VarCurr,B)
      <=> v26695(VarCurr,B) ) ) ).

tff(addAssignment_13655,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26695(VarCurr,B)
      <=> v26697(VarCurr,B) ) ) ).

tff(addAssignment_13654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26697(VarCurr,B)
      <=> v26699(VarCurr,B) ) ) ).

tff(addAssignment_13653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26699(VarCurr,B)
      <=> v26701(VarCurr,B) ) ) ).

tff(addAssignment_13652,axiom,
    ! [VarCurr: state_type] :
      ( v26673(VarCurr)
    <=> v26675(VarCurr) ) ).

tff(addAssignment_13651,axiom,
    ! [VarCurr: state_type] :
      ( v26675(VarCurr)
    <=> v26677(VarCurr) ) ).

tff(addAssignment_13650,axiom,
    ! [VarCurr: state_type] :
      ( v26677(VarCurr)
    <=> v26679(VarCurr) ) ).

tff(addAssignment_13649,axiom,
    ! [VarCurr: state_type] :
      ( v26679(VarCurr)
    <=> v26681(VarCurr) ) ).

tff(addAssignment_13648,axiom,
    ! [VarCurr: state_type] :
      ( v26681(VarCurr)
    <=> v26683(VarCurr) ) ).

tff(addAssignment_13647,axiom,
    ! [VarCurr: state_type] :
      ( v26683(VarCurr)
    <=> v26685(VarCurr) ) ).

tff(addAssignment_13646,axiom,
    ! [VarCurr: state_type] :
      ( v26685(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_13645,axiom,
    ! [VarCurr: state_type] :
      ( v26659(VarCurr)
    <=> v26661(VarCurr) ) ).

tff(addAssignment_13644,axiom,
    ! [VarCurr: state_type] :
      ( v26661(VarCurr)
    <=> v26663(VarCurr) ) ).

tff(addAssignment_13643,axiom,
    ! [VarCurr: state_type] :
      ( v26663(VarCurr)
    <=> v26665(VarCurr) ) ).

tff(addAssignment_13642,axiom,
    ! [VarCurr: state_type] :
      ( v26665(VarCurr)
    <=> v26667(VarCurr) ) ).

tff(addAssignment_13641,axiom,
    ! [VarCurr: state_type] :
      ( v26667(VarCurr)
    <=> v26669(VarCurr) ) ).

tff(addAssignment_13640,axiom,
    ! [VarCurr: state_type] :
      ( v26669(VarCurr)
    <=> v26671(VarCurr) ) ).

tff(addAssignment_13639,axiom,
    ! [VarCurr: state_type] :
      ( v26671(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_13638,axiom,
    ! [VarCurr: state_type] :
      ( v26645(VarCurr)
    <=> v26647(VarCurr) ) ).

tff(addAssignment_13637,axiom,
    ! [VarCurr: state_type] :
      ( v26647(VarCurr)
    <=> v9490(VarCurr,11) ) ).

tff(addAssignment_13636,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,11)
    <=> v9492(VarCurr,11) ) ).

tff(addAssignment_13635,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,11)
    <=> v9494(VarCurr,11) ) ).

tff(addAssignment_13634,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,11)
    <=> v9570(VarCurr,11) ) ).

tff(addAssignment_13633,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,11)
    <=> v9513(VarCurr,11) ) ).

tff(addAssignment_13632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26641(VarCurr,B)
      <=> v26643(VarCurr,B) ) ) ).

tff(addAssignment_13631,axiom,
    ! [VarCurr: state_type] :
      ( ( v26643(VarCurr,11)
      <=> v9208(VarCurr,143) )
      & ( v26643(VarCurr,10)
      <=> v9208(VarCurr,142) )
      & ( v26643(VarCurr,9)
      <=> v9208(VarCurr,141) )
      & ( v26643(VarCurr,8)
      <=> v9208(VarCurr,140) )
      & ( v26643(VarCurr,7)
      <=> v9208(VarCurr,139) )
      & ( v26643(VarCurr,6)
      <=> v9208(VarCurr,138) )
      & ( v26643(VarCurr,5)
      <=> v9208(VarCurr,137) )
      & ( v26643(VarCurr,4)
      <=> v9208(VarCurr,136) )
      & ( v26643(VarCurr,3)
      <=> v9208(VarCurr,135) )
      & ( v26643(VarCurr,2)
      <=> v9208(VarCurr,134) )
      & ( v26643(VarCurr,1)
      <=> v9208(VarCurr,133) )
      & ( v26643(VarCurr,0)
      <=> v9208(VarCurr,132) ) ) ).

tff(addAssignment_13630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26609(VarCurr,B)
      <=> v26611(VarCurr,B) ) ) ).

tff(addAssignment_13629,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,0)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13628,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,1)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13627,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,2)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13626,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,3)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13625,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,4)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13624,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,5)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13623,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,6)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13622,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,7)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13621,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,8)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13620,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,9)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13619,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,10)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13618,axiom,
    ! [VarCurr: state_type] :
      ( v26611(VarCurr,11)
    <=> v26629(VarCurr) ) ).

tff(addAssignment_13617,axiom,
    ! [VarCurr: state_type] :
      ( v26629(VarCurr)
    <=> v26613(VarCurr) ) ).

tff(addAssignment_13616,axiom,
    ! [VarCurr: state_type] :
      ( v26613(VarCurr)
    <=> v26615(VarCurr,0) ) ).

tff(addAssignment_13615,axiom,
    ! [VarCurr: state_type] :
      ( v26615(VarCurr,0)
    <=> v26617(VarCurr,0) ) ).

tff(addAssignment_13614,axiom,
    ! [VarCurr: state_type] :
      ( v26617(VarCurr,0)
    <=> v26627(VarCurr,0) ) ).

tff(writeUnaryOperator_1435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v26627(VarCurr,B)
      <=> ~ v26619(VarCurr,B) ) ) ).

tff(addAssignment_13613,axiom,
    ! [VarCurr: state_type] :
      ( v26619(VarCurr,0)
    <=> v26621(VarCurr,0) ) ).

tff(addAssignment_13612,axiom,
    ! [VarCurr: state_type] :
      ( v26621(VarCurr,0)
    <=> v26624(VarCurr,0) ) ).

tff(addAssignment_13611,axiom,
    ! [VarCurr: state_type] :
      ( v26624(VarCurr,0)
    <=> v26623(VarCurr) ) ).

tff(addAssignment_13610,axiom,
    ! [VarCurr: state_type] :
      ( v26624(VarCurr,1)
    <=> v26626(VarCurr) ) ).

tff(addAssignment_13609,axiom,
    ! [VarCurr: state_type] :
      ( v26624(VarCurr,2)
    <=> v26625(VarCurr) ) ).

tff(addAssignment_13608,axiom,
    ! [VarCurr: state_type] :
      ( v26623(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_13607,axiom,
    ! [VarCurr: state_type] :
      ( v26585(VarCurr)
    <=> v26587(VarCurr) ) ).

tff(addAssignment_13606,axiom,
    ! [VarCurr: state_type] :
      ( v26587(VarCurr)
    <=> v26589(VarCurr) ) ).

tff(addAssignment_13605,axiom,
    ! [VarCurr: state_type] :
      ( v26589(VarCurr)
    <=> v26591(VarCurr) ) ).

tff(addAssignment_13604,axiom,
    ! [VarCurr: state_type] :
      ( v26591(VarCurr)
    <=> v26593(VarCurr) ) ).

tff(addAssignment_13603,axiom,
    ! [VarCurr: state_type] :
      ( v26593(VarCurr)
    <=> v26595(VarCurr) ) ).

tff(addAssignment_13602,axiom,
    ! [VarCurr: state_type] :
      ( v26595(VarCurr)
    <=> v26597(VarCurr) ) ).

tff(addAssignment_13601,axiom,
    ! [VarCurr: state_type] :
      ( v26597(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_13600,axiom,
    ! [VarCurr: state_type] :
      ( v26571(VarCurr)
    <=> v26573(VarCurr) ) ).

tff(addAssignment_13599,axiom,
    ! [VarCurr: state_type] :
      ( v26573(VarCurr)
    <=> v26575(VarCurr) ) ).

tff(addAssignment_13598,axiom,
    ! [VarCurr: state_type] :
      ( v26575(VarCurr)
    <=> v26577(VarCurr) ) ).

tff(addAssignment_13597,axiom,
    ! [VarCurr: state_type] :
      ( v26577(VarCurr)
    <=> v26579(VarCurr) ) ).

tff(addAssignment_13596,axiom,
    ! [VarCurr: state_type] :
      ( v26579(VarCurr)
    <=> v26581(VarCurr) ) ).

tff(addAssignment_13595,axiom,
    ! [VarCurr: state_type] :
      ( v26581(VarCurr)
    <=> v26583(VarCurr) ) ).

tff(addAssignment_13594,axiom,
    ! [VarCurr: state_type] :
      ( v26583(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_13593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26547(VarCurr,B)
      <=> v26549(VarCurr,B) ) ) ).

tff(addAssignment_13592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26549(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_13591,axiom,
    ! [VarCurr: state_type] :
      ( v24991(VarCurr)
    <=> v24993(VarCurr) ) ).

tff(addAssignment_13590,axiom,
    ! [VarCurr: state_type] :
      ( v24993(VarCurr)
    <=> v24995(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_96,axiom,
    ! [VarCurr: state_type] :
      ( v24995(VarCurr)
    <=> ( ( v24997(VarCurr,11)
        <=> v25001(VarCurr,11) )
        & ( v24997(VarCurr,10)
        <=> v25001(VarCurr,10) )
        & ( v24997(VarCurr,9)
        <=> v25001(VarCurr,9) )
        & ( v24997(VarCurr,8)
        <=> v25001(VarCurr,8) )
        & ( v24997(VarCurr,7)
        <=> v25001(VarCurr,7) )
        & ( v24997(VarCurr,6)
        <=> v25001(VarCurr,6) )
        & ( v24997(VarCurr,5)
        <=> v25001(VarCurr,5) )
        & ( v24997(VarCurr,4)
        <=> v25001(VarCurr,4) )
        & ( v24997(VarCurr,3)
        <=> v25001(VarCurr,3) )
        & ( v24997(VarCurr,2)
        <=> v25001(VarCurr,2) )
        & ( v24997(VarCurr,1)
        <=> v25001(VarCurr,1) )
        & ( v24997(VarCurr,0)
        <=> v25001(VarCurr,0) ) ) ) ).

tff(addAssignment_13589,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25001(VarCurr,B)
      <=> v25003(VarCurr,B) ) ) ).

tff(addAssignment_13588,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25003(VarCurr,B)
      <=> v25005(VarCurr,B) ) ) ).

tff(addAssignment_13587,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25005(VarCurr,B)
      <=> v25007(VarCurr,B) ) ) ).

tff(addAssignment_13586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25007(VarCurr,B)
      <=> v25009(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_443,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25009(VarCurr,B)
      <=> ( v26517(VarCurr,B)
          | v26536(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_442,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26536(VarCurr,B)
      <=> ( v26388(VarCurr,B)
          & v26537(VarCurr,B) ) ) ) ).

tff(addAssignment_13585,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,0)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13584,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,1)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13583,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,2)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13582,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,3)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13581,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,4)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13580,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,5)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13579,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,6)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13578,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,7)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13577,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,8)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13576,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,9)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13575,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,10)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13574,axiom,
    ! [VarCurr: state_type] :
      ( v26537(VarCurr,11)
    <=> v26538(VarCurr) ) ).

tff(addAssignment_13573,axiom,
    ! [VarCurr: state_type] :
      ( v26538(VarCurr)
    <=> v26507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_441,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26517(VarCurr,B)
      <=> ( v26518(VarCurr,B)
          | v26533(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_440,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26533(VarCurr,B)
      <=> ( v26237(VarCurr,B)
          & v26534(VarCurr,B) ) ) ) ).

tff(addAssignment_13572,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,0)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13571,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,1)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13570,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,2)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13569,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,3)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13568,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,4)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13567,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,5)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13566,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,6)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13565,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,7)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13564,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,8)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13563,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,9)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13562,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,10)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13561,axiom,
    ! [VarCurr: state_type] :
      ( v26534(VarCurr,11)
    <=> v26535(VarCurr) ) ).

tff(addAssignment_13560,axiom,
    ! [VarCurr: state_type] :
      ( v26535(VarCurr)
    <=> v26357(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26518(VarCurr,B)
      <=> ( v26519(VarCurr,B)
          | v26530(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26530(VarCurr,B)
      <=> ( v26086(VarCurr,B)
          & v26531(VarCurr,B) ) ) ) ).

tff(addAssignment_13559,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,0)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13558,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,1)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13557,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,2)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13556,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,3)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13555,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,4)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13554,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,5)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13553,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,6)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13552,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,7)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13551,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,8)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13550,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,9)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13549,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,10)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13548,axiom,
    ! [VarCurr: state_type] :
      ( v26531(VarCurr,11)
    <=> v26532(VarCurr) ) ).

tff(addAssignment_13547,axiom,
    ! [VarCurr: state_type] :
      ( v26532(VarCurr)
    <=> v26206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26519(VarCurr,B)
      <=> ( v26520(VarCurr,B)
          | v26527(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26527(VarCurr,B)
      <=> ( v25935(VarCurr,B)
          & v26528(VarCurr,B) ) ) ) ).

tff(addAssignment_13546,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,0)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13545,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,1)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13544,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,2)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13543,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,3)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13542,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,4)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13541,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,5)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13540,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,6)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13539,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,7)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13538,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,8)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13537,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,9)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13536,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,10)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13535,axiom,
    ! [VarCurr: state_type] :
      ( v26528(VarCurr,11)
    <=> v26529(VarCurr) ) ).

tff(addAssignment_13534,axiom,
    ! [VarCurr: state_type] :
      ( v26529(VarCurr)
    <=> v26055(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26520(VarCurr,B)
      <=> ( v26521(VarCurr,B)
          | v26524(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26524(VarCurr,B)
      <=> ( v25773(VarCurr,B)
          & v26525(VarCurr,B) ) ) ) ).

tff(addAssignment_13533,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,0)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13532,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,1)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13531,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,2)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13530,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,3)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13529,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,4)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13528,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,5)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13527,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,6)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13526,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,7)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13525,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,8)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13524,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,9)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13523,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,10)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13522,axiom,
    ! [VarCurr: state_type] :
      ( v26525(VarCurr,11)
    <=> v26526(VarCurr) ) ).

tff(addAssignment_13521,axiom,
    ! [VarCurr: state_type] :
      ( v26526(VarCurr)
    <=> v25904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26521(VarCurr,B)
      <=> ( v25011(VarCurr,B)
          & v26522(VarCurr,B) ) ) ) ).

tff(addAssignment_13520,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,0)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13519,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,1)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13518,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,2)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13517,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,3)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13516,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,4)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13515,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,5)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13514,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,6)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13513,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,7)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13512,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,8)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13511,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,9)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13510,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,10)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13509,axiom,
    ! [VarCurr: state_type] :
      ( v26522(VarCurr,11)
    <=> v26523(VarCurr) ) ).

tff(addAssignment_13508,axiom,
    ! [VarCurr: state_type] :
      ( v26523(VarCurr)
    <=> v25481(VarCurr) ) ).

tff(addAssignment_13507,axiom,
    ! [VarCurr: state_type] :
      ( v26507(VarCurr)
    <=> v26509(VarCurr) ) ).

tff(addAssignment_13506,axiom,
    ! [VarCurr: state_type] :
      ( v26509(VarCurr)
    <=> v26511(VarCurr) ) ).

tff(addAssignment_13505,axiom,
    ! [VarCurr: state_type] :
      ( v26511(VarCurr)
    <=> v26513(VarCurr) ) ).

tff(addAssignment_13504,axiom,
    ! [VarCurr: state_type] :
      ( v26513(VarCurr)
    <=> v26515(VarCurr) ) ).

tff(addAssignment_13503,axiom,
    ! [VarCurr: state_type] :
      ( v26515(VarCurr)
    <=> v25574(VarCurr) ) ).

tff(addAssignment_13502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26388(VarCurr,B)
      <=> v26390(VarCurr,B) ) ) ).

tff(addAssignment_13501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26390(VarCurr,B)
      <=> v26392(VarCurr,B) ) ) ).

tff(addAssignment_13500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26392(VarCurr,B)
      <=> v26394(VarCurr,B) ) ) ).

tff(addAssignment_13499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26394(VarCurr,B)
      <=> v26396(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26490(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v26396(VarNext,B)
            <=> v26396(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_299,axiom,
    ! [VarNext: state_type] :
      ( v26490(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26396(VarNext,B)
          <=> v26500(VarNext,B) ) ) ) ).

tff(addAssignment_13498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26500(VarNext,B)
          <=> v26498(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26498(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_183,axiom,
    ! [VarCurr: state_type] :
      ( v26501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26498(VarCurr,B)
          <=> v26418(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2174,axiom,
    ! [VarCurr: state_type] :
      ( v26501(VarCurr)
    <=> ( v26502(VarCurr)
        & v26503(VarCurr) ) ) ).

tff(writeUnaryOperator_1434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26503(VarCurr)
    <=> v26408(VarCurr) ) ).

tff(writeUnaryOperator_1433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26502(VarCurr)
    <=> v26398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26490(VarNext)
      <=> v26491(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26491(VarNext)
      <=> ( v26492(VarNext)
          & v26422(VarNext) ) ) ) ).

tff(writeUnaryOperator_1432,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26492(VarNext)
      <=> v26494(VarNext) ) ) ).

tff(addAssignment_13497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26494(VarNext)
      <=> v26422(VarCurr) ) ) ).

tff(addAssignment_13496,axiom,
    ! [VarCurr: state_type] :
      ( v26422(VarCurr)
    <=> v26424(VarCurr) ) ).

tff(addAssignment_13495,axiom,
    ! [VarCurr: state_type] :
      ( v26424(VarCurr)
    <=> v26426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2171,axiom,
    ! [VarCurr: state_type] :
      ( v26426(VarCurr)
    <=> ( v26487(VarCurr)
        | v26483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2170,axiom,
    ! [VarCurr: state_type] :
      ( v26487(VarCurr)
    <=> ( v26428(VarCurr)
        & v26432(VarCurr) ) ) ).

tff(addAssignment_13494,axiom,
    ! [VarCurr: state_type] :
      ( v26483(VarCurr)
    <=> v26485(VarCurr) ) ).

tff(addAssignment_13493,axiom,
    ! [VarCurr: state_type] :
      ( v26485(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26467(VarNext)
       => ( v26432(VarNext)
        <=> v26432(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_298,axiom,
    ! [VarNext: state_type] :
      ( v26467(VarNext)
     => ( v26432(VarNext)
      <=> v26477(VarNext) ) ) ).

tff(addAssignment_13492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26477(VarNext)
      <=> v26475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2169,axiom,
    ! [VarCurr: state_type] :
      ( v26475(VarCurr)
    <=> ( v26478(VarCurr)
        & v26479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2168,axiom,
    ! [VarCurr: state_type] :
      ( v26479(VarCurr)
    <=> ( v26438(VarCurr)
        | v26462(VarCurr) ) ) ).

tff(writeUnaryOperator_1431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26478(VarCurr)
    <=> v26434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26467(VarNext)
      <=> v26468(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26468(VarNext)
      <=> ( v26470(VarNext)
          & v26472(VarNext) ) ) ) ).

tff(writeUnaryOperator_1430,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26472(VarCurr)
    <=> v26428(VarCurr) ) ).

tff(addAssignment_13491,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26470(VarNext)
      <=> v26428(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_112,axiom,
    ( v26432(constB0)
  <=> $true ) ).

tff(addAssignment_13490,axiom,
    ! [VarCurr: state_type] :
      ( v26462(VarCurr)
    <=> v26464(VarCurr) ) ).

tff(addAssignment_13489,axiom,
    ! [VarCurr: state_type] :
      ( v26464(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13488,axiom,
    ! [VarCurr: state_type] :
      ( v26438(VarCurr)
    <=> v26440(VarCurr) ) ).

tff(addAssignment_13487,axiom,
    ! [VarCurr: state_type] :
      ( v26440(VarCurr)
    <=> v25748(VarCurr) ) ).

tff(addAssignment_13486,axiom,
    ! [VarCurr: state_type] :
      ( v25748(VarCurr)
    <=> v26443(VarCurr) ) ).

tff(addAssignment_13485,axiom,
    ! [VarCurr: state_type] :
      ( v26443(VarCurr)
    <=> v26445(VarCurr) ) ).

tff(writeUnaryOperator_1429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26445(VarCurr)
    <=> v26459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2165,axiom,
    ! [VarCurr: state_type] :
      ( v26459(VarCurr)
    <=> ( v26460(VarCurr)
        | v26455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2164,axiom,
    ! [VarCurr: state_type] :
      ( v26460(VarCurr)
    <=> ( v26447(VarCurr)
        | v26451(VarCurr) ) ) ).

tff(addAssignment_13484,axiom,
    ! [VarCurr: state_type] :
      ( v26455(VarCurr)
    <=> v26457(VarCurr) ) ).

tff(addAssignment_13483,axiom,
    ! [VarCurr: state_type] :
      ( v26457(VarCurr)
    <=> v25837(VarCurr,2) ) ).

tff(addAssignment_13482,axiom,
    ! [VarCurr: state_type] :
      ( v26451(VarCurr)
    <=> v26453(VarCurr) ) ).

tff(addAssignment_13481,axiom,
    ! [VarCurr: state_type] :
      ( v26453(VarCurr)
    <=> v25411(VarCurr,1) ) ).

tff(addAssignment_13480,axiom,
    ! [VarCurr: state_type] :
      ( v26447(VarCurr)
    <=> v26449(VarCurr) ) ).

tff(addAssignment_13479,axiom,
    ! [VarCurr: state_type] :
      ( v26449(VarCurr)
    <=> v25837(VarCurr,0) ) ).

tff(addAssignment_13478,axiom,
    ! [VarCurr: state_type] :
      ( v26434(VarCurr)
    <=> v26436(VarCurr) ) ).

tff(addAssignment_13477,axiom,
    ! [VarCurr: state_type] :
      ( v26436(VarCurr)
    <=> $false ) ).

tff(addAssignment_13476,axiom,
    ! [VarCurr: state_type] :
      ( v26428(VarCurr)
    <=> v26430(VarCurr) ) ).

tff(addAssignment_13475,axiom,
    ! [VarCurr: state_type] :
      ( v26430(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26418(VarCurr,B)
      <=> v26420(VarCurr,B) ) ) ).

tff(addAssignment_13473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26420(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13472,axiom,
    ! [VarCurr: state_type] :
      ( v26408(VarCurr)
    <=> v26410(VarCurr) ) ).

tff(addAssignment_13471,axiom,
    ! [VarCurr: state_type] :
      ( v26410(VarCurr)
    <=> v26412(VarCurr) ) ).

tff(addAssignment_13470,axiom,
    ! [VarCurr: state_type] :
      ( v26412(VarCurr)
    <=> v26414(VarCurr) ) ).

tff(addAssignment_13469,axiom,
    ! [VarCurr: state_type] :
      ( v26414(VarCurr)
    <=> v26416(VarCurr) ) ).

tff(addAssignment_13468,axiom,
    ! [VarCurr: state_type] :
      ( v26416(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13467,axiom,
    ! [VarCurr: state_type] :
      ( v26398(VarCurr)
    <=> v26400(VarCurr) ) ).

tff(addAssignment_13466,axiom,
    ! [VarCurr: state_type] :
      ( v26400(VarCurr)
    <=> v26402(VarCurr) ) ).

tff(addAssignment_13465,axiom,
    ! [VarCurr: state_type] :
      ( v26402(VarCurr)
    <=> v26404(VarCurr) ) ).

tff(addAssignment_13464,axiom,
    ! [VarCurr: state_type] :
      ( v26404(VarCurr)
    <=> v26406(VarCurr) ) ).

tff(addAssignment_13463,axiom,
    ! [VarCurr: state_type] :
      ( v26406(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_13462,axiom,
    ! [VarCurr: state_type] :
      ( v26357(VarCurr)
    <=> v26359(VarCurr) ) ).

tff(addAssignment_13461,axiom,
    ! [VarCurr: state_type] :
      ( v26359(VarCurr)
    <=> v26361(VarCurr) ) ).

tff(addAssignment_13460,axiom,
    ! [VarCurr: state_type] :
      ( v26361(VarCurr)
    <=> v26363(VarCurr) ) ).

tff(addAssignment_13459,axiom,
    ! [VarCurr: state_type] :
      ( v26363(VarCurr)
    <=> v26365(VarCurr) ) ).

tff(addAssignment_13458,axiom,
    ! [VarCurr: state_type] :
      ( v26365(VarCurr)
    <=> v26367(VarCurr) ) ).

tff(addAssignment_13457,axiom,
    ! [VarCurr: state_type] :
      ( v26367(VarCurr)
    <=> v26369(VarCurr) ) ).

tff(addAssignment_13456,axiom,
    ! [VarCurr: state_type] :
      ( v26369(VarCurr)
    <=> v26371(VarCurr) ) ).

tff(writeUnaryOperator_1428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26371(VarCurr)
    <=> v26385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2163,axiom,
    ! [VarCurr: state_type] :
      ( v26385(VarCurr)
    <=> ( v26386(VarCurr)
        | v26381(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2162,axiom,
    ! [VarCurr: state_type] :
      ( v26386(VarCurr)
    <=> ( v26373(VarCurr)
        | v26377(VarCurr) ) ) ).

tff(addAssignment_13455,axiom,
    ! [VarCurr: state_type] :
      ( v26381(VarCurr)
    <=> v26383(VarCurr) ) ).

tff(addAssignment_13454,axiom,
    ! [VarCurr: state_type] :
      ( v26383(VarCurr)
    <=> v25584(VarCurr,2) ) ).

tff(addAssignment_13453,axiom,
    ! [VarCurr: state_type] :
      ( v26377(VarCurr)
    <=> v26379(VarCurr) ) ).

tff(addAssignment_13452,axiom,
    ! [VarCurr: state_type] :
      ( v26379(VarCurr)
    <=> v25501(VarCurr,1) ) ).

tff(addAssignment_13451,axiom,
    ! [VarCurr: state_type] :
      ( v26373(VarCurr)
    <=> v26375(VarCurr) ) ).

tff(addAssignment_13450,axiom,
    ! [VarCurr: state_type] :
      ( v26375(VarCurr)
    <=> v25501(VarCurr,0) ) ).

tff(addAssignment_13449,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26237(VarCurr,B)
      <=> v26239(VarCurr,B) ) ) ).

tff(addAssignment_13448,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26239(VarCurr,B)
      <=> v26241(VarCurr,B) ) ) ).

tff(addAssignment_13447,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26241(VarCurr,B)
      <=> v26243(VarCurr,B) ) ) ).

tff(addAssignment_13446,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26243(VarCurr,B)
      <=> v26245(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_297,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26340(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v26245(VarNext,B)
            <=> v26245(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_297,axiom,
    ! [VarNext: state_type] :
      ( v26340(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26245(VarNext,B)
          <=> v26350(VarNext,B) ) ) ) ).

tff(addAssignment_13445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26350(VarNext,B)
          <=> v26348(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26348(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_182,axiom,
    ! [VarCurr: state_type] :
      ( v26351(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26348(VarCurr,B)
          <=> v26267(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2161,axiom,
    ! [VarCurr: state_type] :
      ( v26351(VarCurr)
    <=> ( v26352(VarCurr)
        & v26353(VarCurr) ) ) ).

tff(writeUnaryOperator_1427,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26353(VarCurr)
    <=> v26257(VarCurr) ) ).

tff(writeUnaryOperator_1426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26352(VarCurr)
    <=> v26247(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26340(VarNext)
      <=> v26341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26341(VarNext)
      <=> ( v26342(VarNext)
          & v26271(VarNext) ) ) ) ).

tff(writeUnaryOperator_1425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26342(VarNext)
      <=> v26344(VarNext) ) ) ).

tff(addAssignment_13444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26344(VarNext)
      <=> v26271(VarCurr) ) ) ).

tff(addAssignment_13443,axiom,
    ! [VarCurr: state_type] :
      ( v26271(VarCurr)
    <=> v26273(VarCurr) ) ).

tff(addAssignment_13442,axiom,
    ! [VarCurr: state_type] :
      ( v26273(VarCurr)
    <=> v26275(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2158,axiom,
    ! [VarCurr: state_type] :
      ( v26275(VarCurr)
    <=> ( v26337(VarCurr)
        | v26333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2157,axiom,
    ! [VarCurr: state_type] :
      ( v26337(VarCurr)
    <=> ( v26277(VarCurr)
        & v26281(VarCurr) ) ) ).

tff(addAssignment_13441,axiom,
    ! [VarCurr: state_type] :
      ( v26333(VarCurr)
    <=> v26335(VarCurr) ) ).

tff(addAssignment_13440,axiom,
    ! [VarCurr: state_type] :
      ( v26335(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_296,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26317(VarNext)
       => ( v26281(VarNext)
        <=> v26281(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_296,axiom,
    ! [VarNext: state_type] :
      ( v26317(VarNext)
     => ( v26281(VarNext)
      <=> v26327(VarNext) ) ) ).

tff(addAssignment_13439,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26327(VarNext)
      <=> v26325(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2156,axiom,
    ! [VarCurr: state_type] :
      ( v26325(VarCurr)
    <=> ( v26328(VarCurr)
        & v26329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2155,axiom,
    ! [VarCurr: state_type] :
      ( v26329(VarCurr)
    <=> ( v26287(VarCurr)
        | v26312(VarCurr) ) ) ).

tff(writeUnaryOperator_1424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26328(VarCurr)
    <=> v26283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26317(VarNext)
      <=> v26318(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26318(VarNext)
      <=> ( v26320(VarNext)
          & v26322(VarNext) ) ) ) ).

tff(writeUnaryOperator_1423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26322(VarCurr)
    <=> v26277(VarCurr) ) ).

tff(addAssignment_13438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26320(VarNext)
      <=> v26277(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_111,axiom,
    ( v26281(constB0)
  <=> $true ) ).

tff(addAssignment_13437,axiom,
    ! [VarCurr: state_type] :
      ( v26312(VarCurr)
    <=> v26314(VarCurr) ) ).

tff(addAssignment_13436,axiom,
    ! [VarCurr: state_type] :
      ( v26314(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13435,axiom,
    ! [VarCurr: state_type] :
      ( v26287(VarCurr)
    <=> v26289(VarCurr) ) ).

tff(addAssignment_13434,axiom,
    ! [VarCurr: state_type] :
      ( v26289(VarCurr)
    <=> v26291(VarCurr) ) ).

tff(addAssignment_13433,axiom,
    ! [VarCurr: state_type] :
      ( v26291(VarCurr)
    <=> v26293(VarCurr) ) ).

tff(addAssignment_13432,axiom,
    ! [VarCurr: state_type] :
      ( v26293(VarCurr)
    <=> v26295(VarCurr) ) ).

tff(writeUnaryOperator_1422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26295(VarCurr)
    <=> v26309(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2152,axiom,
    ! [VarCurr: state_type] :
      ( v26309(VarCurr)
    <=> ( v26310(VarCurr)
        | v26305(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2151,axiom,
    ! [VarCurr: state_type] :
      ( v26310(VarCurr)
    <=> ( v26297(VarCurr)
        | v26301(VarCurr) ) ) ).

tff(addAssignment_13431,axiom,
    ! [VarCurr: state_type] :
      ( v26305(VarCurr)
    <=> v26307(VarCurr) ) ).

tff(addAssignment_13430,axiom,
    ! [VarCurr: state_type] :
      ( v26307(VarCurr)
    <=> v25837(VarCurr,2) ) ).

tff(addAssignment_13429,axiom,
    ! [VarCurr: state_type] :
      ( v25837(VarCurr,2)
    <=> v25839(VarCurr,2) ) ).

tff(addAssignment_13428,axiom,
    ! [VarCurr: state_type] :
      ( v25839(VarCurr,2)
    <=> v25841(VarCurr,2) ) ).

tff(addAssignment_13427,axiom,
    ! [VarCurr: state_type] :
      ( v25841(VarCurr,2)
    <=> v25846(VarCurr,2) ) ).

tff(addAssignment_13426,axiom,
    ! [VarCurr: state_type] :
      ( v25843(VarCurr,2)
    <=> v25845(VarCurr,2) ) ).

tff(addAssignment_13425,axiom,
    ! [VarCurr: state_type] :
      ( v25845(VarCurr,2)
    <=> v25411(VarCurr,2) ) ).

tff(addAssignment_13424,axiom,
    ! [VarCurr: state_type] :
      ( v26301(VarCurr)
    <=> v26303(VarCurr) ) ).

tff(addAssignment_13423,axiom,
    ! [VarCurr: state_type] :
      ( v26303(VarCurr)
    <=> v25411(VarCurr,1) ) ).

tff(addAssignment_13422,axiom,
    ! [VarCurr: state_type] :
      ( v26297(VarCurr)
    <=> v26299(VarCurr) ) ).

tff(addAssignment_13421,axiom,
    ! [VarCurr: state_type] :
      ( v26299(VarCurr)
    <=> v25411(VarCurr,0) ) ).

tff(addAssignment_13420,axiom,
    ! [VarCurr: state_type] :
      ( v26283(VarCurr)
    <=> v26285(VarCurr) ) ).

tff(addAssignment_13419,axiom,
    ! [VarCurr: state_type] :
      ( v26285(VarCurr)
    <=> $false ) ).

tff(addAssignment_13418,axiom,
    ! [VarCurr: state_type] :
      ( v26277(VarCurr)
    <=> v26279(VarCurr) ) ).

tff(addAssignment_13417,axiom,
    ! [VarCurr: state_type] :
      ( v26279(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26267(VarCurr,B)
      <=> v26269(VarCurr,B) ) ) ).

tff(addAssignment_13415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26269(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13414,axiom,
    ! [VarCurr: state_type] :
      ( v26257(VarCurr)
    <=> v26259(VarCurr) ) ).

tff(addAssignment_13413,axiom,
    ! [VarCurr: state_type] :
      ( v26259(VarCurr)
    <=> v26261(VarCurr) ) ).

tff(addAssignment_13412,axiom,
    ! [VarCurr: state_type] :
      ( v26261(VarCurr)
    <=> v26263(VarCurr) ) ).

tff(addAssignment_13411,axiom,
    ! [VarCurr: state_type] :
      ( v26263(VarCurr)
    <=> v26265(VarCurr) ) ).

tff(addAssignment_13410,axiom,
    ! [VarCurr: state_type] :
      ( v26265(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13409,axiom,
    ! [VarCurr: state_type] :
      ( v26247(VarCurr)
    <=> v26249(VarCurr) ) ).

tff(addAssignment_13408,axiom,
    ! [VarCurr: state_type] :
      ( v26249(VarCurr)
    <=> v26251(VarCurr) ) ).

tff(addAssignment_13407,axiom,
    ! [VarCurr: state_type] :
      ( v26251(VarCurr)
    <=> v26253(VarCurr) ) ).

tff(addAssignment_13406,axiom,
    ! [VarCurr: state_type] :
      ( v26253(VarCurr)
    <=> v26255(VarCurr) ) ).

tff(addAssignment_13405,axiom,
    ! [VarCurr: state_type] :
      ( v26255(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_13404,axiom,
    ! [VarCurr: state_type] :
      ( v26206(VarCurr)
    <=> v26208(VarCurr) ) ).

tff(addAssignment_13403,axiom,
    ! [VarCurr: state_type] :
      ( v26208(VarCurr)
    <=> v26210(VarCurr) ) ).

tff(addAssignment_13402,axiom,
    ! [VarCurr: state_type] :
      ( v26210(VarCurr)
    <=> v26212(VarCurr) ) ).

tff(addAssignment_13401,axiom,
    ! [VarCurr: state_type] :
      ( v26212(VarCurr)
    <=> v26214(VarCurr) ) ).

tff(addAssignment_13400,axiom,
    ! [VarCurr: state_type] :
      ( v26214(VarCurr)
    <=> v26216(VarCurr) ) ).

tff(addAssignment_13399,axiom,
    ! [VarCurr: state_type] :
      ( v26216(VarCurr)
    <=> v26218(VarCurr) ) ).

tff(addAssignment_13398,axiom,
    ! [VarCurr: state_type] :
      ( v26218(VarCurr)
    <=> v26220(VarCurr) ) ).

tff(writeUnaryOperator_1421,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26220(VarCurr)
    <=> v26234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2150,axiom,
    ! [VarCurr: state_type] :
      ( v26234(VarCurr)
    <=> ( v26235(VarCurr)
        | v26230(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2149,axiom,
    ! [VarCurr: state_type] :
      ( v26235(VarCurr)
    <=> ( v26222(VarCurr)
        | v26226(VarCurr) ) ) ).

tff(addAssignment_13397,axiom,
    ! [VarCurr: state_type] :
      ( v26230(VarCurr)
    <=> v26232(VarCurr) ) ).

tff(addAssignment_13396,axiom,
    ! [VarCurr: state_type] :
      ( v26232(VarCurr)
    <=> v25501(VarCurr,2) ) ).

tff(addAssignment_13395,axiom,
    ! [VarCurr: state_type] :
      ( v26226(VarCurr)
    <=> v26228(VarCurr) ) ).

tff(addAssignment_13394,axiom,
    ! [VarCurr: state_type] :
      ( v26228(VarCurr)
    <=> v25584(VarCurr,1) ) ).

tff(addAssignment_13393,axiom,
    ! [VarCurr: state_type] :
      ( v26222(VarCurr)
    <=> v26224(VarCurr) ) ).

tff(addAssignment_13392,axiom,
    ! [VarCurr: state_type] :
      ( v26224(VarCurr)
    <=> v25584(VarCurr,0) ) ).

tff(addAssignment_13391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26086(VarCurr,B)
      <=> v26088(VarCurr,B) ) ) ).

tff(addAssignment_13390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26088(VarCurr,B)
      <=> v26090(VarCurr,B) ) ) ).

tff(addAssignment_13389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26090(VarCurr,B)
      <=> v26092(VarCurr,B) ) ) ).

tff(addAssignment_13388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26092(VarCurr,B)
      <=> v26094(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26189(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v26094(VarNext,B)
            <=> v26094(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_295,axiom,
    ! [VarNext: state_type] :
      ( v26189(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26094(VarNext,B)
          <=> v26199(VarNext,B) ) ) ) ).

tff(addAssignment_13387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26199(VarNext,B)
          <=> v26197(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26200(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26197(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_181,axiom,
    ! [VarCurr: state_type] :
      ( v26200(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26197(VarCurr,B)
          <=> v26116(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2148,axiom,
    ! [VarCurr: state_type] :
      ( v26200(VarCurr)
    <=> ( v26201(VarCurr)
        & v26202(VarCurr) ) ) ).

tff(writeUnaryOperator_1420,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26202(VarCurr)
    <=> v26106(VarCurr) ) ).

tff(writeUnaryOperator_1419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26201(VarCurr)
    <=> v26096(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26189(VarNext)
      <=> v26190(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26190(VarNext)
      <=> ( v26191(VarNext)
          & v26120(VarNext) ) ) ) ).

tff(writeUnaryOperator_1418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26191(VarNext)
      <=> v26193(VarNext) ) ) ).

tff(addAssignment_13386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26193(VarNext)
      <=> v26120(VarCurr) ) ) ).

tff(addAssignment_13385,axiom,
    ! [VarCurr: state_type] :
      ( v26120(VarCurr)
    <=> v26122(VarCurr) ) ).

tff(addAssignment_13384,axiom,
    ! [VarCurr: state_type] :
      ( v26122(VarCurr)
    <=> v26124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2145,axiom,
    ! [VarCurr: state_type] :
      ( v26124(VarCurr)
    <=> ( v26186(VarCurr)
        | v26182(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2144,axiom,
    ! [VarCurr: state_type] :
      ( v26186(VarCurr)
    <=> ( v26126(VarCurr)
        & v26130(VarCurr) ) ) ).

tff(addAssignment_13383,axiom,
    ! [VarCurr: state_type] :
      ( v26182(VarCurr)
    <=> v26184(VarCurr) ) ).

tff(addAssignment_13382,axiom,
    ! [VarCurr: state_type] :
      ( v26184(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26166(VarNext)
       => ( v26130(VarNext)
        <=> v26130(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_294,axiom,
    ! [VarNext: state_type] :
      ( v26166(VarNext)
     => ( v26130(VarNext)
      <=> v26176(VarNext) ) ) ).

tff(addAssignment_13381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26176(VarNext)
      <=> v26174(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2143,axiom,
    ! [VarCurr: state_type] :
      ( v26174(VarCurr)
    <=> ( v26177(VarCurr)
        & v26178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2142,axiom,
    ! [VarCurr: state_type] :
      ( v26178(VarCurr)
    <=> ( v26136(VarCurr)
        | v26161(VarCurr) ) ) ).

tff(writeUnaryOperator_1417,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26177(VarCurr)
    <=> v26132(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26166(VarNext)
      <=> v26167(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26167(VarNext)
      <=> ( v26169(VarNext)
          & v26171(VarNext) ) ) ) ).

tff(writeUnaryOperator_1416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26171(VarCurr)
    <=> v26126(VarCurr) ) ).

tff(addAssignment_13380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26169(VarNext)
      <=> v26126(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_110,axiom,
    ( v26130(constB0)
  <=> $true ) ).

tff(addAssignment_13379,axiom,
    ! [VarCurr: state_type] :
      ( v26161(VarCurr)
    <=> v26163(VarCurr) ) ).

tff(addAssignment_13378,axiom,
    ! [VarCurr: state_type] :
      ( v26163(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13377,axiom,
    ! [VarCurr: state_type] :
      ( v26136(VarCurr)
    <=> v26138(VarCurr) ) ).

tff(addAssignment_13376,axiom,
    ! [VarCurr: state_type] :
      ( v26138(VarCurr)
    <=> v26140(VarCurr) ) ).

tff(addAssignment_13375,axiom,
    ! [VarCurr: state_type] :
      ( v26140(VarCurr)
    <=> v26142(VarCurr) ) ).

tff(addAssignment_13374,axiom,
    ! [VarCurr: state_type] :
      ( v26142(VarCurr)
    <=> v26144(VarCurr) ) ).

tff(writeUnaryOperator_1415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26144(VarCurr)
    <=> v26158(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2139,axiom,
    ! [VarCurr: state_type] :
      ( v26158(VarCurr)
    <=> ( v26159(VarCurr)
        | v26154(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2138,axiom,
    ! [VarCurr: state_type] :
      ( v26159(VarCurr)
    <=> ( v26146(VarCurr)
        | v26150(VarCurr) ) ) ).

tff(addAssignment_13373,axiom,
    ! [VarCurr: state_type] :
      ( v26154(VarCurr)
    <=> v26156(VarCurr) ) ).

tff(addAssignment_13372,axiom,
    ! [VarCurr: state_type] :
      ( v26156(VarCurr)
    <=> v25411(VarCurr,2) ) ).

tff(addAssignment_13371,axiom,
    ! [VarCurr: state_type] :
      ( v26150(VarCurr)
    <=> v26152(VarCurr) ) ).

tff(addAssignment_13370,axiom,
    ! [VarCurr: state_type] :
      ( v26152(VarCurr)
    <=> v25837(VarCurr,1) ) ).

tff(addAssignment_13369,axiom,
    ! [VarCurr: state_type] :
      ( v26146(VarCurr)
    <=> v26148(VarCurr) ) ).

tff(addAssignment_13368,axiom,
    ! [VarCurr: state_type] :
      ( v26148(VarCurr)
    <=> v25837(VarCurr,0) ) ).

tff(addAssignment_13367,axiom,
    ! [VarCurr: state_type] :
      ( v26132(VarCurr)
    <=> v26134(VarCurr) ) ).

tff(addAssignment_13366,axiom,
    ! [VarCurr: state_type] :
      ( v26134(VarCurr)
    <=> $false ) ).

tff(addAssignment_13365,axiom,
    ! [VarCurr: state_type] :
      ( v26126(VarCurr)
    <=> v26128(VarCurr) ) ).

tff(addAssignment_13364,axiom,
    ! [VarCurr: state_type] :
      ( v26128(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26116(VarCurr,B)
      <=> v26118(VarCurr,B) ) ) ).

tff(addAssignment_13362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v26118(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13361,axiom,
    ! [VarCurr: state_type] :
      ( v26106(VarCurr)
    <=> v26108(VarCurr) ) ).

tff(addAssignment_13360,axiom,
    ! [VarCurr: state_type] :
      ( v26108(VarCurr)
    <=> v26110(VarCurr) ) ).

tff(addAssignment_13359,axiom,
    ! [VarCurr: state_type] :
      ( v26110(VarCurr)
    <=> v26112(VarCurr) ) ).

tff(addAssignment_13358,axiom,
    ! [VarCurr: state_type] :
      ( v26112(VarCurr)
    <=> v26114(VarCurr) ) ).

tff(addAssignment_13357,axiom,
    ! [VarCurr: state_type] :
      ( v26114(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13356,axiom,
    ! [VarCurr: state_type] :
      ( v26096(VarCurr)
    <=> v26098(VarCurr) ) ).

tff(addAssignment_13355,axiom,
    ! [VarCurr: state_type] :
      ( v26098(VarCurr)
    <=> v26100(VarCurr) ) ).

tff(addAssignment_13354,axiom,
    ! [VarCurr: state_type] :
      ( v26100(VarCurr)
    <=> v26102(VarCurr) ) ).

tff(addAssignment_13353,axiom,
    ! [VarCurr: state_type] :
      ( v26102(VarCurr)
    <=> v26104(VarCurr) ) ).

tff(addAssignment_13352,axiom,
    ! [VarCurr: state_type] :
      ( v26104(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_13351,axiom,
    ! [VarCurr: state_type] :
      ( v26055(VarCurr)
    <=> v26057(VarCurr) ) ).

tff(addAssignment_13350,axiom,
    ! [VarCurr: state_type] :
      ( v26057(VarCurr)
    <=> v26059(VarCurr) ) ).

tff(addAssignment_13349,axiom,
    ! [VarCurr: state_type] :
      ( v26059(VarCurr)
    <=> v26061(VarCurr) ) ).

tff(addAssignment_13348,axiom,
    ! [VarCurr: state_type] :
      ( v26061(VarCurr)
    <=> v26063(VarCurr) ) ).

tff(addAssignment_13347,axiom,
    ! [VarCurr: state_type] :
      ( v26063(VarCurr)
    <=> v26065(VarCurr) ) ).

tff(addAssignment_13346,axiom,
    ! [VarCurr: state_type] :
      ( v26065(VarCurr)
    <=> v26067(VarCurr) ) ).

tff(addAssignment_13345,axiom,
    ! [VarCurr: state_type] :
      ( v26067(VarCurr)
    <=> v26069(VarCurr) ) ).

tff(writeUnaryOperator_1414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26069(VarCurr)
    <=> v26083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2137,axiom,
    ! [VarCurr: state_type] :
      ( v26083(VarCurr)
    <=> ( v26084(VarCurr)
        | v26079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2136,axiom,
    ! [VarCurr: state_type] :
      ( v26084(VarCurr)
    <=> ( v26071(VarCurr)
        | v26075(VarCurr) ) ) ).

tff(addAssignment_13344,axiom,
    ! [VarCurr: state_type] :
      ( v26079(VarCurr)
    <=> v26081(VarCurr) ) ).

tff(addAssignment_13343,axiom,
    ! [VarCurr: state_type] :
      ( v26081(VarCurr)
    <=> v25501(VarCurr,2) ) ).

tff(addAssignment_13342,axiom,
    ! [VarCurr: state_type] :
      ( v26075(VarCurr)
    <=> v26077(VarCurr) ) ).

tff(addAssignment_13341,axiom,
    ! [VarCurr: state_type] :
      ( v26077(VarCurr)
    <=> v25584(VarCurr,1) ) ).

tff(addAssignment_13340,axiom,
    ! [VarCurr: state_type] :
      ( v25584(VarCurr,1)
    <=> v25586(VarCurr,1) ) ).

tff(addAssignment_13339,axiom,
    ! [VarCurr: state_type] :
      ( v25586(VarCurr,1)
    <=> v25588(VarCurr,1) ) ).

tff(addAssignment_13338,axiom,
    ! [VarCurr: state_type] :
      ( v25588(VarCurr,1)
    <=> v25593(VarCurr,1) ) ).

tff(addAssignment_13337,axiom,
    ! [VarCurr: state_type] :
      ( v25590(VarCurr,1)
    <=> v25592(VarCurr,1) ) ).

tff(addAssignment_13336,axiom,
    ! [VarCurr: state_type] :
      ( v25592(VarCurr,1)
    <=> v25501(VarCurr,1) ) ).

tff(addAssignment_13335,axiom,
    ! [VarCurr: state_type] :
      ( v26071(VarCurr)
    <=> v26073(VarCurr) ) ).

tff(addAssignment_13334,axiom,
    ! [VarCurr: state_type] :
      ( v26073(VarCurr)
    <=> v25501(VarCurr,0) ) ).

tff(addAssignment_13333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25935(VarCurr,B)
      <=> v25937(VarCurr,B) ) ) ).

tff(addAssignment_13332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25937(VarCurr,B)
      <=> v25939(VarCurr,B) ) ) ).

tff(addAssignment_13331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25939(VarCurr,B)
      <=> v25941(VarCurr,B) ) ) ).

tff(addAssignment_13330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25941(VarCurr,B)
      <=> v25943(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26038(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v25943(VarNext,B)
            <=> v25943(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_293,axiom,
    ! [VarNext: state_type] :
      ( v26038(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25943(VarNext,B)
          <=> v26048(VarNext,B) ) ) ) ).

tff(addAssignment_13329,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26048(VarNext,B)
          <=> v26046(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26049(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26046(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_180,axiom,
    ! [VarCurr: state_type] :
      ( v26049(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v26046(VarCurr,B)
          <=> v25965(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2135,axiom,
    ! [VarCurr: state_type] :
      ( v26049(VarCurr)
    <=> ( v26050(VarCurr)
        & v26051(VarCurr) ) ) ).

tff(writeUnaryOperator_1413,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26051(VarCurr)
    <=> v25955(VarCurr) ) ).

tff(writeUnaryOperator_1412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26050(VarCurr)
    <=> v25945(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26038(VarNext)
      <=> v26039(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26039(VarNext)
      <=> ( v26040(VarNext)
          & v25969(VarNext) ) ) ) ).

tff(writeUnaryOperator_1411,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26040(VarNext)
      <=> v26042(VarNext) ) ) ).

tff(addAssignment_13328,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26042(VarNext)
      <=> v25969(VarCurr) ) ) ).

tff(addAssignment_13327,axiom,
    ! [VarCurr: state_type] :
      ( v25969(VarCurr)
    <=> v25971(VarCurr) ) ).

tff(addAssignment_13326,axiom,
    ! [VarCurr: state_type] :
      ( v25971(VarCurr)
    <=> v25973(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2132,axiom,
    ! [VarCurr: state_type] :
      ( v25973(VarCurr)
    <=> ( v26035(VarCurr)
        | v26031(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2131,axiom,
    ! [VarCurr: state_type] :
      ( v26035(VarCurr)
    <=> ( v25975(VarCurr)
        & v25979(VarCurr) ) ) ).

tff(addAssignment_13325,axiom,
    ! [VarCurr: state_type] :
      ( v26031(VarCurr)
    <=> v26033(VarCurr) ) ).

tff(addAssignment_13324,axiom,
    ! [VarCurr: state_type] :
      ( v26033(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v26015(VarNext)
       => ( v25979(VarNext)
        <=> v25979(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_292,axiom,
    ! [VarNext: state_type] :
      ( v26015(VarNext)
     => ( v25979(VarNext)
      <=> v26025(VarNext) ) ) ).

tff(addAssignment_13323,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26025(VarNext)
      <=> v26023(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2130,axiom,
    ! [VarCurr: state_type] :
      ( v26023(VarCurr)
    <=> ( v26026(VarCurr)
        & v26027(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2129,axiom,
    ! [VarCurr: state_type] :
      ( v26027(VarCurr)
    <=> ( v25985(VarCurr)
        | v26010(VarCurr) ) ) ).

tff(writeUnaryOperator_1410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26026(VarCurr)
    <=> v25981(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26015(VarNext)
      <=> v26016(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26016(VarNext)
      <=> ( v26018(VarNext)
          & v26020(VarNext) ) ) ) ).

tff(writeUnaryOperator_1409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v26020(VarCurr)
    <=> v25975(VarCurr) ) ).

tff(addAssignment_13322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v26018(VarNext)
      <=> v25975(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_109,axiom,
    ( v25979(constB0)
  <=> $true ) ).

tff(addAssignment_13321,axiom,
    ! [VarCurr: state_type] :
      ( v26010(VarCurr)
    <=> v26012(VarCurr) ) ).

tff(addAssignment_13320,axiom,
    ! [VarCurr: state_type] :
      ( v26012(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13319,axiom,
    ! [VarCurr: state_type] :
      ( v25985(VarCurr)
    <=> v25987(VarCurr) ) ).

tff(addAssignment_13318,axiom,
    ! [VarCurr: state_type] :
      ( v25987(VarCurr)
    <=> v25989(VarCurr) ) ).

tff(addAssignment_13317,axiom,
    ! [VarCurr: state_type] :
      ( v25989(VarCurr)
    <=> v25991(VarCurr) ) ).

tff(addAssignment_13316,axiom,
    ! [VarCurr: state_type] :
      ( v25991(VarCurr)
    <=> v25993(VarCurr) ) ).

tff(writeUnaryOperator_1408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25993(VarCurr)
    <=> v26007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2126,axiom,
    ! [VarCurr: state_type] :
      ( v26007(VarCurr)
    <=> ( v26008(VarCurr)
        | v26003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2125,axiom,
    ! [VarCurr: state_type] :
      ( v26008(VarCurr)
    <=> ( v25995(VarCurr)
        | v25999(VarCurr) ) ) ).

tff(addAssignment_13315,axiom,
    ! [VarCurr: state_type] :
      ( v26003(VarCurr)
    <=> v26005(VarCurr) ) ).

tff(addAssignment_13314,axiom,
    ! [VarCurr: state_type] :
      ( v26005(VarCurr)
    <=> v25411(VarCurr,2) ) ).

tff(addAssignment_13313,axiom,
    ! [VarCurr: state_type] :
      ( v25999(VarCurr)
    <=> v26001(VarCurr) ) ).

tff(addAssignment_13312,axiom,
    ! [VarCurr: state_type] :
      ( v26001(VarCurr)
    <=> v25837(VarCurr,1) ) ).

tff(addAssignment_13311,axiom,
    ! [VarCurr: state_type] :
      ( v25837(VarCurr,1)
    <=> v25839(VarCurr,1) ) ).

tff(addAssignment_13310,axiom,
    ! [VarCurr: state_type] :
      ( v25839(VarCurr,1)
    <=> v25841(VarCurr,1) ) ).

tff(addAssignment_13309,axiom,
    ! [VarCurr: state_type] :
      ( v25841(VarCurr,1)
    <=> v25846(VarCurr,1) ) ).

tff(addAssignment_13308,axiom,
    ! [VarCurr: state_type] :
      ( v25843(VarCurr,1)
    <=> v25845(VarCurr,1) ) ).

tff(addAssignment_13307,axiom,
    ! [VarCurr: state_type] :
      ( v25845(VarCurr,1)
    <=> v25411(VarCurr,1) ) ).

tff(addAssignment_13306,axiom,
    ! [VarCurr: state_type] :
      ( v25995(VarCurr)
    <=> v25997(VarCurr) ) ).

tff(addAssignment_13305,axiom,
    ! [VarCurr: state_type] :
      ( v25997(VarCurr)
    <=> v25411(VarCurr,0) ) ).

tff(addAssignment_13304,axiom,
    ! [VarCurr: state_type] :
      ( v25981(VarCurr)
    <=> v25983(VarCurr) ) ).

tff(addAssignment_13303,axiom,
    ! [VarCurr: state_type] :
      ( v25983(VarCurr)
    <=> $false ) ).

tff(addAssignment_13302,axiom,
    ! [VarCurr: state_type] :
      ( v25975(VarCurr)
    <=> v25977(VarCurr) ) ).

tff(addAssignment_13301,axiom,
    ! [VarCurr: state_type] :
      ( v25977(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25965(VarCurr,B)
      <=> v25967(VarCurr,B) ) ) ).

tff(addAssignment_13299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25967(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13298,axiom,
    ! [VarCurr: state_type] :
      ( v25955(VarCurr)
    <=> v25957(VarCurr) ) ).

tff(addAssignment_13297,axiom,
    ! [VarCurr: state_type] :
      ( v25957(VarCurr)
    <=> v25959(VarCurr) ) ).

tff(addAssignment_13296,axiom,
    ! [VarCurr: state_type] :
      ( v25959(VarCurr)
    <=> v25961(VarCurr) ) ).

tff(addAssignment_13295,axiom,
    ! [VarCurr: state_type] :
      ( v25961(VarCurr)
    <=> v25963(VarCurr) ) ).

tff(addAssignment_13294,axiom,
    ! [VarCurr: state_type] :
      ( v25963(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13293,axiom,
    ! [VarCurr: state_type] :
      ( v25945(VarCurr)
    <=> v25947(VarCurr) ) ).

tff(addAssignment_13292,axiom,
    ! [VarCurr: state_type] :
      ( v25947(VarCurr)
    <=> v25949(VarCurr) ) ).

tff(addAssignment_13291,axiom,
    ! [VarCurr: state_type] :
      ( v25949(VarCurr)
    <=> v25951(VarCurr) ) ).

tff(addAssignment_13290,axiom,
    ! [VarCurr: state_type] :
      ( v25951(VarCurr)
    <=> v25953(VarCurr) ) ).

tff(addAssignment_13289,axiom,
    ! [VarCurr: state_type] :
      ( v25953(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_13288,axiom,
    ! [VarCurr: state_type] :
      ( v25904(VarCurr)
    <=> v25906(VarCurr) ) ).

tff(addAssignment_13287,axiom,
    ! [VarCurr: state_type] :
      ( v25906(VarCurr)
    <=> v25908(VarCurr) ) ).

tff(addAssignment_13286,axiom,
    ! [VarCurr: state_type] :
      ( v25908(VarCurr)
    <=> v25910(VarCurr) ) ).

tff(addAssignment_13285,axiom,
    ! [VarCurr: state_type] :
      ( v25910(VarCurr)
    <=> v25912(VarCurr) ) ).

tff(addAssignment_13284,axiom,
    ! [VarCurr: state_type] :
      ( v25912(VarCurr)
    <=> v25914(VarCurr) ) ).

tff(addAssignment_13283,axiom,
    ! [VarCurr: state_type] :
      ( v25914(VarCurr)
    <=> v25916(VarCurr) ) ).

tff(addAssignment_13282,axiom,
    ! [VarCurr: state_type] :
      ( v25916(VarCurr)
    <=> v25918(VarCurr) ) ).

tff(writeUnaryOperator_1407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25918(VarCurr)
    <=> v25932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2124,axiom,
    ! [VarCurr: state_type] :
      ( v25932(VarCurr)
    <=> ( v25933(VarCurr)
        | v25928(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2123,axiom,
    ! [VarCurr: state_type] :
      ( v25933(VarCurr)
    <=> ( v25920(VarCurr)
        | v25924(VarCurr) ) ) ).

tff(addAssignment_13281,axiom,
    ! [VarCurr: state_type] :
      ( v25928(VarCurr)
    <=> v25930(VarCurr) ) ).

tff(addAssignment_13280,axiom,
    ! [VarCurr: state_type] :
      ( v25930(VarCurr)
    <=> v25501(VarCurr,2) ) ).

tff(addAssignment_13279,axiom,
    ! [VarCurr: state_type] :
      ( v25924(VarCurr)
    <=> v25926(VarCurr) ) ).

tff(addAssignment_13278,axiom,
    ! [VarCurr: state_type] :
      ( v25926(VarCurr)
    <=> v25501(VarCurr,1) ) ).

tff(addAssignment_13277,axiom,
    ! [VarCurr: state_type] :
      ( v25920(VarCurr)
    <=> v25922(VarCurr) ) ).

tff(addAssignment_13276,axiom,
    ! [VarCurr: state_type] :
      ( v25922(VarCurr)
    <=> v25584(VarCurr,0) ) ).

tff(addAssignment_13275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25773(VarCurr,B)
      <=> v25775(VarCurr,B) ) ) ).

tff(addAssignment_13274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25775(VarCurr,B)
      <=> v25777(VarCurr,B) ) ) ).

tff(addAssignment_13273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25777(VarCurr,B)
      <=> v25779(VarCurr,B) ) ) ).

tff(addAssignment_13272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25779(VarCurr,B)
      <=> v25781(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_291,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25887(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v25781(VarNext,B)
            <=> v25781(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_291,axiom,
    ! [VarNext: state_type] :
      ( v25887(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25781(VarNext,B)
          <=> v25897(VarNext,B) ) ) ) ).

tff(addAssignment_13271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25897(VarNext,B)
          <=> v25895(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25898(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25895(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_179,axiom,
    ! [VarCurr: state_type] :
      ( v25898(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25895(VarCurr,B)
          <=> v25803(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2122,axiom,
    ! [VarCurr: state_type] :
      ( v25898(VarCurr)
    <=> ( v25899(VarCurr)
        & v25900(VarCurr) ) ) ).

tff(writeUnaryOperator_1406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25900(VarCurr)
    <=> v25793(VarCurr) ) ).

tff(writeUnaryOperator_1405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25899(VarCurr)
    <=> v25783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25887(VarNext)
      <=> v25888(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25888(VarNext)
      <=> ( v25889(VarNext)
          & v25807(VarNext) ) ) ) ).

tff(writeUnaryOperator_1404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25889(VarNext)
      <=> v25891(VarNext) ) ) ).

tff(addAssignment_13270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25891(VarNext)
      <=> v25807(VarCurr) ) ) ).

tff(addAssignment_13269,axiom,
    ! [VarCurr: state_type] :
      ( v25807(VarCurr)
    <=> v25809(VarCurr) ) ).

tff(addAssignment_13268,axiom,
    ! [VarCurr: state_type] :
      ( v25809(VarCurr)
    <=> v25811(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2119,axiom,
    ! [VarCurr: state_type] :
      ( v25811(VarCurr)
    <=> ( v25884(VarCurr)
        | v25880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2118,axiom,
    ! [VarCurr: state_type] :
      ( v25884(VarCurr)
    <=> ( v25813(VarCurr)
        & v25817(VarCurr) ) ) ).

tff(addAssignment_13267,axiom,
    ! [VarCurr: state_type] :
      ( v25880(VarCurr)
    <=> v25882(VarCurr) ) ).

tff(addAssignment_13266,axiom,
    ! [VarCurr: state_type] :
      ( v25882(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_290,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25864(VarNext)
       => ( v25817(VarNext)
        <=> v25817(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_290,axiom,
    ! [VarNext: state_type] :
      ( v25864(VarNext)
     => ( v25817(VarNext)
      <=> v25874(VarNext) ) ) ).

tff(addAssignment_13265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25874(VarNext)
      <=> v25872(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2117,axiom,
    ! [VarCurr: state_type] :
      ( v25872(VarCurr)
    <=> ( v25875(VarCurr)
        & v25876(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2116,axiom,
    ! [VarCurr: state_type] :
      ( v25876(VarCurr)
    <=> ( v25823(VarCurr)
        | v25859(VarCurr) ) ) ).

tff(writeUnaryOperator_1403,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25875(VarCurr)
    <=> v25819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25864(VarNext)
      <=> v25865(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25865(VarNext)
      <=> ( v25867(VarNext)
          & v25869(VarNext) ) ) ) ).

tff(writeUnaryOperator_1402,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25869(VarCurr)
    <=> v25813(VarCurr) ) ).

tff(addAssignment_13264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25867(VarNext)
      <=> v25813(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_108,axiom,
    ( v25817(constB0)
  <=> $true ) ).

tff(addAssignment_13263,axiom,
    ! [VarCurr: state_type] :
      ( v25859(VarCurr)
    <=> v25861(VarCurr) ) ).

tff(addAssignment_13262,axiom,
    ! [VarCurr: state_type] :
      ( v25861(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13261,axiom,
    ! [VarCurr: state_type] :
      ( v25823(VarCurr)
    <=> v25825(VarCurr) ) ).

tff(addAssignment_13260,axiom,
    ! [VarCurr: state_type] :
      ( v25825(VarCurr)
    <=> v25827(VarCurr) ) ).

tff(addAssignment_13259,axiom,
    ! [VarCurr: state_type] :
      ( v25827(VarCurr)
    <=> v25829(VarCurr) ) ).

tff(addAssignment_13258,axiom,
    ! [VarCurr: state_type] :
      ( v25829(VarCurr)
    <=> v25831(VarCurr) ) ).

tff(writeUnaryOperator_1401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25831(VarCurr)
    <=> v25856(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2113,axiom,
    ! [VarCurr: state_type] :
      ( v25856(VarCurr)
    <=> ( v25857(VarCurr)
        | v25852(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2112,axiom,
    ! [VarCurr: state_type] :
      ( v25857(VarCurr)
    <=> ( v25833(VarCurr)
        | v25848(VarCurr) ) ) ).

tff(addAssignment_13257,axiom,
    ! [VarCurr: state_type] :
      ( v25852(VarCurr)
    <=> v25854(VarCurr) ) ).

tff(addAssignment_13256,axiom,
    ! [VarCurr: state_type] :
      ( v25854(VarCurr)
    <=> v25411(VarCurr,2) ) ).

tff(addAssignment_13255,axiom,
    ! [VarCurr: state_type] :
      ( v25848(VarCurr)
    <=> v25850(VarCurr) ) ).

tff(addAssignment_13254,axiom,
    ! [VarCurr: state_type] :
      ( v25850(VarCurr)
    <=> v25411(VarCurr,1) ) ).

tff(addAssignment_13253,axiom,
    ! [VarCurr: state_type] :
      ( v25833(VarCurr)
    <=> v25835(VarCurr) ) ).

tff(addAssignment_13252,axiom,
    ! [VarCurr: state_type] :
      ( v25835(VarCurr)
    <=> v25837(VarCurr,0) ) ).

tff(addAssignment_13251,axiom,
    ! [VarCurr: state_type] :
      ( v25837(VarCurr,0)
    <=> v25839(VarCurr,0) ) ).

tff(addAssignment_13250,axiom,
    ! [VarCurr: state_type] :
      ( v25839(VarCurr,0)
    <=> v25841(VarCurr,0) ) ).

tff(addAssignment_13249,axiom,
    ! [VarCurr: state_type] :
      ( v25841(VarCurr,0)
    <=> v25846(VarCurr,0) ) ).

tff(writeUnaryOperator_1400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25846(VarCurr,B)
      <=> ~ v25843(VarCurr,B) ) ) ).

tff(addAssignment_13248,axiom,
    ! [VarCurr: state_type] :
      ( v25843(VarCurr,0)
    <=> v25845(VarCurr,0) ) ).

tff(addAssignment_13247,axiom,
    ! [VarCurr: state_type] :
      ( v25845(VarCurr,0)
    <=> v25411(VarCurr,0) ) ).

tff(addAssignment_13246,axiom,
    ! [VarCurr: state_type] :
      ( v25819(VarCurr)
    <=> v25821(VarCurr) ) ).

tff(addAssignment_13245,axiom,
    ! [VarCurr: state_type] :
      ( v25821(VarCurr)
    <=> $false ) ).

tff(addAssignment_13244,axiom,
    ! [VarCurr: state_type] :
      ( v25813(VarCurr)
    <=> v25815(VarCurr) ) ).

tff(addAssignment_13243,axiom,
    ! [VarCurr: state_type] :
      ( v25815(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25803(VarCurr,B)
      <=> v25805(VarCurr,B) ) ) ).

tff(addAssignment_13241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25805(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13240,axiom,
    ! [VarCurr: state_type] :
      ( v25793(VarCurr)
    <=> v25795(VarCurr) ) ).

tff(addAssignment_13239,axiom,
    ! [VarCurr: state_type] :
      ( v25795(VarCurr)
    <=> v25797(VarCurr) ) ).

tff(addAssignment_13238,axiom,
    ! [VarCurr: state_type] :
      ( v25797(VarCurr)
    <=> v25799(VarCurr) ) ).

tff(addAssignment_13237,axiom,
    ! [VarCurr: state_type] :
      ( v25799(VarCurr)
    <=> v25801(VarCurr) ) ).

tff(addAssignment_13236,axiom,
    ! [VarCurr: state_type] :
      ( v25801(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13235,axiom,
    ! [VarCurr: state_type] :
      ( v25783(VarCurr)
    <=> v25785(VarCurr) ) ).

tff(addAssignment_13234,axiom,
    ! [VarCurr: state_type] :
      ( v25785(VarCurr)
    <=> v25787(VarCurr) ) ).

tff(addAssignment_13233,axiom,
    ! [VarCurr: state_type] :
      ( v25787(VarCurr)
    <=> v25789(VarCurr) ) ).

tff(addAssignment_13232,axiom,
    ! [VarCurr: state_type] :
      ( v25789(VarCurr)
    <=> v25791(VarCurr) ) ).

tff(addAssignment_13231,axiom,
    ! [VarCurr: state_type] :
      ( v25791(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_13230,axiom,
    ! [VarCurr: state_type] :
      ( v25481(VarCurr)
    <=> v25483(VarCurr) ) ).

tff(addAssignment_13229,axiom,
    ! [VarCurr: state_type] :
      ( v25483(VarCurr)
    <=> v25485(VarCurr) ) ).

tff(addAssignment_13228,axiom,
    ! [VarCurr: state_type] :
      ( v25485(VarCurr)
    <=> v25487(VarCurr) ) ).

tff(addAssignment_13227,axiom,
    ! [VarCurr: state_type] :
      ( v25487(VarCurr)
    <=> v25489(VarCurr) ) ).

tff(addAssignment_13226,axiom,
    ! [VarCurr: state_type] :
      ( v25489(VarCurr)
    <=> v25491(VarCurr) ) ).

tff(addAssignment_13225,axiom,
    ! [VarCurr: state_type] :
      ( v25491(VarCurr)
    <=> v25493(VarCurr) ) ).

tff(addAssignment_13224,axiom,
    ! [VarCurr: state_type] :
      ( v25493(VarCurr)
    <=> v25495(VarCurr) ) ).

tff(writeUnaryOperator_1399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25495(VarCurr)
    <=> v25770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2111,axiom,
    ! [VarCurr: state_type] :
      ( v25770(VarCurr)
    <=> ( v25771(VarCurr)
        | v25766(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2110,axiom,
    ! [VarCurr: state_type] :
      ( v25771(VarCurr)
    <=> ( v25497(VarCurr)
        | v25762(VarCurr) ) ) ).

tff(addAssignment_13223,axiom,
    ! [VarCurr: state_type] :
      ( v25766(VarCurr)
    <=> v25768(VarCurr) ) ).

tff(addAssignment_13222,axiom,
    ! [VarCurr: state_type] :
      ( v25768(VarCurr)
    <=> v25501(VarCurr,2) ) ).

tff(addAssignment_13221,axiom,
    ! [VarCurr: state_type] :
      ( v25762(VarCurr)
    <=> v25764(VarCurr) ) ).

tff(addAssignment_13220,axiom,
    ! [VarCurr: state_type] :
      ( v25764(VarCurr)
    <=> v25501(VarCurr,1) ) ).

tff(addAssignment_13219,axiom,
    ! [VarCurr: state_type] :
      ( v25497(VarCurr)
    <=> v25499(VarCurr) ) ).

tff(addAssignment_13218,axiom,
    ! [VarCurr: state_type] :
      ( v25499(VarCurr)
    <=> v25501(VarCurr,0) ) ).

tff(addAssignment_13217,axiom,
    ! [VarCurr: state_type] :
      ( v25501(VarCurr,0)
    <=> v25413(VarCurr,3) ) ).

tff(addAssignment_13216,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,3)
    <=> v25415(VarCurr,3) ) ).

tff(addAssignment_13215,axiom,
    ! [VarNext: state_type] :
      ( v25415(VarNext,3)
    <=> v25754(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_289,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25755(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v25754(VarNext,B)
            <=> v25415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_289,axiom,
    ! [VarNext: state_type] :
      ( v25755(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25754(VarNext,B)
          <=> v25726(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25755(VarNext)
      <=> v25756(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25756(VarNext)
      <=> ( v25758(VarNext)
          & v25668(VarNext) ) ) ) ).

tff(writeUnaryOperator_1398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25758(VarNext)
      <=> v25720(VarNext) ) ) ).

tff(addAssignment_13214,axiom,
    ! [VarCurr: state_type] :
      ( v25525(VarCurr,3)
    <=> v25527(VarCurr,3) ) ).

tff(addAssignment_13213,axiom,
    ! [VarCurr: state_type] :
      ( v25527(VarCurr,3)
    <=> v25665(VarCurr,3) ) ).

tff(addAssignment_13212,axiom,
    ! [VarCurr: state_type] :
      ( v25529(VarCurr,0)
    <=> v25531(VarCurr,0) ) ).

tff(addAssignment_13211,axiom,
    ! [VarCurr: state_type] :
      ( v25531(VarCurr,0)
    <=> v25533(VarCurr,0) ) ).

tff(addAssignment_13210,axiom,
    ! [VarCurr: state_type] :
      ( v25533(VarCurr,0)
    <=> v25664(VarCurr,0) ) ).

tff(addAssignment_13209,axiom,
    ! [VarCurr: state_type] :
      ( v25601(VarCurr,0)
    <=> v25603(VarCurr,0) ) ).

tff(addAssignment_13208,axiom,
    ! [VarCurr: state_type] :
      ( v25603(VarCurr,0)
    <=> v25605(VarCurr,0) ) ).

tff(addAssignment_13207,axiom,
    ! [VarCurr: state_type] :
      ( v25605(VarCurr,0)
    <=> v25607(VarCurr,0) ) ).

tff(addAssignment_13206,axiom,
    ! [VarCurr: state_type] :
      ( v25607(VarCurr,0)
    <=> v25609(VarCurr,0) ) ).

tff(addAssignment_13205,axiom,
    ! [VarCurr: state_type] :
      ( v25609(VarCurr,0)
    <=> v25619(VarCurr,0) ) ).

tff(addAssignment_13204,axiom,
    ! [VarCurr: state_type] :
      ( v25535(VarCurr,0)
    <=> v25537(VarCurr,0) ) ).

tff(addAssignment_13203,axiom,
    ! [VarCurr: state_type] :
      ( v25537(VarCurr,0)
    <=> v25598(VarCurr,0) ) ).

tff(addAssignment_13202,axiom,
    ! [VarCurr: state_type] :
      ( v25539(VarCurr)
    <=> v25065(VarCurr,2) ) ).

tff(addAssignment_13201,axiom,
    ! [VarCurr: state_type] :
      ( v25065(VarCurr,2)
    <=> v25067(VarCurr,2) ) ).

tff(addAssignment_13200,axiom,
    ! [VarCurr: state_type] :
      ( v25067(VarCurr,2)
    <=> v25077(VarCurr,2) ) ).

tff(addAssignment_13199,axiom,
    ! [VarCurr: state_type] :
      ( v25069(VarCurr,2)
    <=> v25071(VarCurr,2) ) ).

tff(addAssignment_13198,axiom,
    ! [VarCurr: state_type] :
      ( v25071(VarCurr,2)
    <=> v25074(VarCurr,2) ) ).

tff(addAssignment_13197,axiom,
    ! [VarCurr: state_type] :
      ( v25075(VarCurr)
    <=> v25542(VarCurr,1) ) ).

tff(addAssignment_13196,axiom,
    ! [VarCurr: state_type] :
      ( v25542(VarCurr,1)
    <=> v25544(VarCurr,1) ) ).

tff(addAssignment_13195,axiom,
    ! [VarCurr: state_type] :
      ( v25544(VarCurr,1)
    <=> v25752(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v25752(VarCurr,B)
      <=> ( v25546(VarCurr,B)
          | v25552(VarCurr,B) ) ) ) ).

tff(addAssignment_13194,axiom,
    ! [VarCurr: state_type] :
      ( v25552(VarCurr,1)
    <=> v25554(VarCurr,1) ) ).

tff(addAssignment_13193,axiom,
    ! [VarCurr: state_type] :
      ( v25554(VarCurr,1)
    <=> v25750(VarCurr,1) ) ).

tff(addAssignment_13192,axiom,
    ! [VarCurr: state_type] :
      ( v25750(VarCurr,0)
    <=> v25751(VarCurr) ) ).

tff(addAssignment_13191,axiom,
    ! [VarCurr: state_type] :
      ( v25750(VarCurr,1)
    <=> v25556(VarCurr) ) ).

tff(addAssignment_13190,axiom,
    ! [VarCurr: state_type] :
      ( v25556(VarCurr)
    <=> v25558(VarCurr,1) ) ).

tff(addAssignment_13189,axiom,
    ! [VarCurr: state_type] :
      ( v25558(VarCurr,1)
    <=> v25560(VarCurr,1) ) ).

tff(addAssignment_13188,axiom,
    ! [VarCurr: state_type] :
      ( v25560(VarCurr,1)
    <=> v25749(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v25749(VarCurr,B)
      <=> ( v25562(VarCurr,B)
          & v25570(VarCurr,B) ) ) ) ).

tff(addAssignment_13187,axiom,
    ! [VarCurr: state_type] :
      ( v25570(VarCurr,1)
    <=> v25572(VarCurr,1) ) ).

tff(addAssignment_13186,axiom,
    ! [VarCurr: state_type] :
      ( v25572(VarCurr,1)
    <=> v25747(VarCurr,1) ) ).

tff(addAssignment_13185,axiom,
    ! [VarCurr: state_type] :
      ( v25747(VarCurr,0)
    <=> v25748(VarCurr) ) ).

tff(addAssignment_13184,axiom,
    ! [VarCurr: state_type] :
      ( v25747(VarCurr,1)
    <=> v25574(VarCurr) ) ).

tff(addAssignment_13183,axiom,
    ! [VarCurr: state_type] :
      ( v25574(VarCurr)
    <=> v25576(VarCurr) ) ).

tff(addAssignment_13182,axiom,
    ! [VarCurr: state_type] :
      ( v25576(VarCurr)
    <=> v25578(VarCurr) ) ).

tff(writeUnaryOperator_1397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25578(VarCurr)
    <=> v25745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2107,axiom,
    ! [VarCurr: state_type] :
      ( v25745(VarCurr)
    <=> ( v25746(VarCurr)
        | v25733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2106,axiom,
    ! [VarCurr: state_type] :
      ( v25746(VarCurr)
    <=> ( v25580(VarCurr)
        | v25595(VarCurr) ) ) ).

tff(addAssignment_13181,axiom,
    ! [VarCurr: state_type] :
      ( v25733(VarCurr)
    <=> v25735(VarCurr) ) ).

tff(addAssignment_13180,axiom,
    ! [VarCurr: state_type] :
      ( v25735(VarCurr)
    <=> v25584(VarCurr,2) ) ).

tff(addAssignment_13179,axiom,
    ! [VarCurr: state_type] :
      ( v25584(VarCurr,2)
    <=> v25586(VarCurr,2) ) ).

tff(addAssignment_13178,axiom,
    ! [VarCurr: state_type] :
      ( v25586(VarCurr,2)
    <=> v25588(VarCurr,2) ) ).

tff(addAssignment_13177,axiom,
    ! [VarCurr: state_type] :
      ( v25588(VarCurr,2)
    <=> v25593(VarCurr,2) ) ).

tff(addAssignment_13176,axiom,
    ! [VarCurr: state_type] :
      ( v25590(VarCurr,2)
    <=> v25592(VarCurr,2) ) ).

tff(addAssignment_13175,axiom,
    ! [VarCurr: state_type] :
      ( v25592(VarCurr,2)
    <=> v25501(VarCurr,2) ) ).

tff(addAssignment_13174,axiom,
    ! [VarCurr: state_type] :
      ( v25501(VarCurr,2)
    <=> v25413(VarCurr,5) ) ).

tff(addAssignment_13173,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,5)
    <=> v25415(VarCurr,5) ) ).

tff(addAssignment_13172,axiom,
    ! [VarNext: state_type] :
      ( v25415(VarNext,5)
    <=> v25737(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25738(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v25737(VarNext,B)
            <=> v25415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_288,axiom,
    ! [VarNext: state_type] :
      ( v25738(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25737(VarNext,B)
          <=> v25726(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25738(VarNext)
      <=> v25739(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25739(VarNext)
      <=> ( v25741(VarNext)
          & v25668(VarNext) ) ) ) ).

tff(writeUnaryOperator_1396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25741(VarNext)
      <=> v25720(VarNext) ) ) ).

tff(addAssignment_13171,axiom,
    ! [VarCurr: state_type] :
      ( v25525(VarCurr,5)
    <=> v25527(VarCurr,5) ) ).

tff(addAssignment_13170,axiom,
    ! [VarCurr: state_type] :
      ( v25527(VarCurr,5)
    <=> v25665(VarCurr,5) ) ).

tff(addAssignment_13169,axiom,
    ! [VarCurr: state_type] :
      ( v25529(VarCurr,2)
    <=> v25531(VarCurr,2) ) ).

tff(addAssignment_13168,axiom,
    ! [VarCurr: state_type] :
      ( v25531(VarCurr,2)
    <=> v25533(VarCurr,2) ) ).

tff(addAssignment_13167,axiom,
    ! [VarCurr: state_type] :
      ( v25533(VarCurr,2)
    <=> v25664(VarCurr,2) ) ).

tff(addAssignment_13166,axiom,
    ! [VarCurr: state_type] :
      ( v25601(VarCurr,2)
    <=> v25603(VarCurr,2) ) ).

tff(addAssignment_13165,axiom,
    ! [VarCurr: state_type] :
      ( v25603(VarCurr,2)
    <=> v25605(VarCurr,2) ) ).

tff(addAssignment_13164,axiom,
    ! [VarCurr: state_type] :
      ( v25605(VarCurr,2)
    <=> v25607(VarCurr,2) ) ).

tff(addAssignment_13163,axiom,
    ! [VarCurr: state_type] :
      ( v25607(VarCurr,2)
    <=> v25609(VarCurr,2) ) ).

tff(addAssignment_13162,axiom,
    ! [VarCurr: state_type] :
      ( v25609(VarCurr,2)
    <=> v25619(VarCurr,2) ) ).

tff(addAssignment_13161,axiom,
    ! [VarCurr: state_type] :
      ( v25611(VarCurr,2)
    <=> v25613(VarCurr,2) ) ).

tff(addAssignment_13160,axiom,
    ! [VarCurr: state_type] :
      ( v25613(VarCurr,2)
    <=> v25614(VarCurr,2) ) ).

tff(addAssignment_13159,axiom,
    ! [VarCurr: state_type] :
      ( v25535(VarCurr,2)
    <=> v25537(VarCurr,2) ) ).

tff(addAssignment_13158,axiom,
    ! [VarCurr: state_type] :
      ( v25537(VarCurr,2)
    <=> v25598(VarCurr,2) ) ).

tff(addAssignment_13157,axiom,
    ! [VarCurr: state_type] :
      ( v25595(VarCurr)
    <=> v25597(VarCurr) ) ).

tff(addAssignment_13156,axiom,
    ! [VarCurr: state_type] :
      ( v25597(VarCurr)
    <=> v25501(VarCurr,1) ) ).

tff(addAssignment_13155,axiom,
    ! [VarCurr: state_type] :
      ( v25501(VarCurr,1)
    <=> v25413(VarCurr,4) ) ).

tff(addAssignment_13154,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,4)
    <=> v25415(VarCurr,4) ) ).

tff(addAssignment_13153,axiom,
    ! [VarNext: state_type] :
      ( v25415(VarNext,4)
    <=> v25715(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25716(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v25715(VarNext,B)
            <=> v25415(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_287,axiom,
    ! [VarNext: state_type] :
      ( v25716(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25715(VarNext,B)
          <=> v25726(VarNext,B) ) ) ) ).

tff(addAssignment_13152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25726(VarNext,B)
          <=> v25724(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_178,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25727(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25724(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_178,axiom,
    ! [VarCurr: state_type] :
      ( v25727(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v25724(VarCurr,B)
          <=> v25525(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2103,axiom,
    ! [VarCurr: state_type] :
      ( v25727(VarCurr)
    <=> ( v25728(VarCurr)
        & v25729(VarCurr) ) ) ).

tff(writeUnaryOperator_1395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25729(VarCurr)
    <=> v25515(VarCurr) ) ).

tff(writeUnaryOperator_1394,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25728(VarCurr)
    <=> v25503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25716(VarNext)
      <=> v25717(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25717(VarNext)
      <=> ( v25718(VarNext)
          & v25668(VarNext) ) ) ) ).

tff(writeUnaryOperator_1393,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25718(VarNext)
      <=> v25720(VarNext) ) ) ).

tff(addAssignment_13151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25720(VarNext)
      <=> v25668(VarCurr) ) ) ).

tff(addAssignment_13150,axiom,
    ! [VarCurr: state_type] :
      ( v25668(VarCurr)
    <=> v25670(VarCurr) ) ).

tff(addAssignment_13149,axiom,
    ! [VarCurr: state_type] :
      ( v25670(VarCurr)
    <=> v25672(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2100,axiom,
    ! [VarCurr: state_type] :
      ( v25672(VarCurr)
    <=> ( v25713(VarCurr)
        | v25709(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2099,axiom,
    ! [VarCurr: state_type] :
      ( v25713(VarCurr)
    <=> ( v25674(VarCurr)
        & v25678(VarCurr) ) ) ).

tff(addAssignment_13148,axiom,
    ! [VarCurr: state_type] :
      ( v25709(VarCurr)
    <=> v25711(VarCurr) ) ).

tff(addAssignment_13147,axiom,
    ! [VarCurr: state_type] :
      ( v25711(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25693(VarNext)
       => ( v25678(VarNext)
        <=> v25678(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_286,axiom,
    ! [VarNext: state_type] :
      ( v25693(VarNext)
     => ( v25678(VarNext)
      <=> v25703(VarNext) ) ) ).

tff(addAssignment_13146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25703(VarNext)
      <=> v25701(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2098,axiom,
    ! [VarCurr: state_type] :
      ( v25701(VarCurr)
    <=> ( v25704(VarCurr)
        & v25705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2097,axiom,
    ! [VarCurr: state_type] :
      ( v25705(VarCurr)
    <=> ( v25684(VarCurr)
        | v25688(VarCurr) ) ) ).

tff(writeUnaryOperator_1392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25704(VarCurr)
    <=> v25680(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2096,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25693(VarNext)
      <=> v25694(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25694(VarNext)
      <=> ( v25696(VarNext)
          & v25698(VarNext) ) ) ) ).

tff(writeUnaryOperator_1391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25698(VarCurr)
    <=> v25674(VarCurr) ) ).

tff(addAssignment_13145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25696(VarNext)
      <=> v25674(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_107,axiom,
    ( v25678(constB0)
  <=> $true ) ).

tff(addAssignment_13144,axiom,
    ! [VarCurr: state_type] :
      ( v25688(VarCurr)
    <=> v25690(VarCurr) ) ).

tff(addAssignment_13143,axiom,
    ! [VarCurr: state_type] :
      ( v25690(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13142,axiom,
    ! [VarCurr: state_type] :
      ( v25684(VarCurr)
    <=> v25686(VarCurr) ) ).

tff(addAssignment_13141,axiom,
    ! [VarCurr: state_type] :
      ( v25686(VarCurr)
    <=> $true ) ).

tff(addAssignment_13140,axiom,
    ! [VarCurr: state_type] :
      ( v25680(VarCurr)
    <=> v25682(VarCurr) ) ).

tff(addAssignment_13139,axiom,
    ! [VarCurr: state_type] :
      ( v25682(VarCurr)
    <=> $false ) ).

tff(addAssignment_13138,axiom,
    ! [VarCurr: state_type] :
      ( v25674(VarCurr)
    <=> v25676(VarCurr) ) ).

tff(addAssignment_13137,axiom,
    ! [VarCurr: state_type] :
      ( v25676(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13136,axiom,
    ! [VarCurr: state_type] :
      ( v25525(VarCurr,4)
    <=> v25527(VarCurr,4) ) ).

tff(addAssignment_13135,axiom,
    ! [VarCurr: state_type] :
      ( v25527(VarCurr,4)
    <=> v25665(VarCurr,4) ) ).

tff(addAssignment_13134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25665(VarCurr,B)
      <=> v25666(VarCurr,B) ) ) ).

tff(addAssignment_13133,axiom,
    ! [VarCurr: state_type] :
      ( ( v25665(VarCurr,5)
      <=> v25529(VarCurr,2) )
      & ( v25665(VarCurr,4)
      <=> v25529(VarCurr,1) )
      & ( v25665(VarCurr,3)
      <=> v25529(VarCurr,0) ) ) ).

tff(addAssignment_13132,axiom,
    ! [VarCurr: state_type] :
      ( v25529(VarCurr,1)
    <=> v25531(VarCurr,1) ) ).

tff(addAssignment_13131,axiom,
    ! [VarCurr: state_type] :
      ( v25531(VarCurr,1)
    <=> v25533(VarCurr,1) ) ).

tff(addAssignment_13130,axiom,
    ! [VarCurr: state_type] :
      ( v25533(VarCurr,1)
    <=> v25664(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25664(VarCurr,B)
      <=> ( v25535(VarCurr,B)
          & v25601(VarCurr,B) ) ) ) ).

tff(addAssignment_13129,axiom,
    ! [VarCurr: state_type] :
      ( v25601(VarCurr,1)
    <=> v25603(VarCurr,1) ) ).

tff(addAssignment_13128,axiom,
    ! [VarCurr: state_type] :
      ( v25603(VarCurr,1)
    <=> v25605(VarCurr,1) ) ).

tff(addAssignment_13127,axiom,
    ! [VarCurr: state_type] :
      ( v25605(VarCurr,1)
    <=> v25607(VarCurr,1) ) ).

tff(addAssignment_13126,axiom,
    ! [VarCurr: state_type] :
      ( v25607(VarCurr,1)
    <=> v25609(VarCurr,1) ) ).

tff(addAssignment_13125,axiom,
    ! [VarCurr: state_type] :
      ( v25609(VarCurr,1)
    <=> v25619(VarCurr,1) ) ).

tff(addAssignment_13124,axiom,
    ! [VarCurr: state_type] :
      ( v25619(VarCurr,0)
    <=> v25659(VarCurr) ) ).

tff(addAssignment_13123,axiom,
    ! [VarCurr: state_type] :
      ( v25619(VarCurr,1)
    <=> v25654(VarCurr) ) ).

tff(addAssignment_13122,axiom,
    ! [VarCurr: state_type] :
      ( v25619(VarCurr,2)
    <=> v25649(VarCurr) ) ).

tff(addAssignment_13121,axiom,
    ! [VarCurr: state_type] :
      ( v25619(VarCurr,3)
    <=> v25621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2094,axiom,
    ! [VarCurr: state_type] :
      ( v25659(VarCurr)
    <=> ( v25660(VarCurr)
        & v25663(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2093,axiom,
    ! [VarCurr: state_type] :
      ( v25663(VarCurr)
    <=> ( v25611(VarCurr,0)
        | v25629(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2092,axiom,
    ! [VarCurr: state_type] :
      ( v25660(VarCurr)
    <=> ( v25661(VarCurr)
        | v25662(VarCurr) ) ) ).

tff(writeUnaryOperator_1390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25662(VarCurr)
    <=> v25629(VarCurr,0) ) ).

tff(writeUnaryOperator_1389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25661(VarCurr)
    <=> v25611(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2091,axiom,
    ! [VarCurr: state_type] :
      ( v25654(VarCurr)
    <=> ( v25655(VarCurr)
        & v25658(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2090,axiom,
    ! [VarCurr: state_type] :
      ( v25658(VarCurr)
    <=> ( v25628(VarCurr)
        | v25630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2089,axiom,
    ! [VarCurr: state_type] :
      ( v25655(VarCurr)
    <=> ( v25656(VarCurr)
        | v25657(VarCurr) ) ) ).

tff(writeUnaryOperator_1388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25657(VarCurr)
    <=> v25630(VarCurr) ) ).

tff(writeUnaryOperator_1387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25656(VarCurr)
    <=> v25628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2088,axiom,
    ! [VarCurr: state_type] :
      ( v25649(VarCurr)
    <=> ( v25650(VarCurr)
        & v25653(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2087,axiom,
    ! [VarCurr: state_type] :
      ( v25653(VarCurr)
    <=> ( v25626(VarCurr)
        | v25636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2086,axiom,
    ! [VarCurr: state_type] :
      ( v25650(VarCurr)
    <=> ( v25651(VarCurr)
        | v25652(VarCurr) ) ) ).

tff(writeUnaryOperator_1386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25652(VarCurr)
    <=> v25636(VarCurr) ) ).

tff(writeUnaryOperator_1385,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25651(VarCurr)
    <=> v25626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2085,axiom,
    ! [VarCurr: state_type] :
      ( v25621(VarCurr)
    <=> ( v25622(VarCurr)
        & v25648(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2084,axiom,
    ! [VarCurr: state_type] :
      ( v25648(VarCurr)
    <=> ( v25624(VarCurr)
        | v25643(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2083,axiom,
    ! [VarCurr: state_type] :
      ( v25622(VarCurr)
    <=> ( v25623(VarCurr)
        | v25642(VarCurr) ) ) ).

tff(writeUnaryOperator_1384,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25642(VarCurr)
    <=> v25643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2082,axiom,
    ! [VarCurr: state_type] :
      ( v25643(VarCurr)
    <=> ( v25644(VarCurr)
        & v25647(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_233,axiom,
    ! [VarCurr: state_type] :
      ( v25647(VarCurr)
    <=> ( v25611(VarCurr,3)
        | v25629(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2081,axiom,
    ! [VarCurr: state_type] :
      ( v25644(VarCurr)
    <=> ( v25645(VarCurr)
        | v25646(VarCurr) ) ) ).

tff(writeUnaryOperator_1383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25646(VarCurr)
    <=> v25629(VarCurr,3) ) ).

tff(writeUnaryOperator_1382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25645(VarCurr)
    <=> v25611(VarCurr,3) ) ).

tff(writeUnaryOperator_1381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25623(VarCurr)
    <=> v25624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2080,axiom,
    ! [VarCurr: state_type] :
      ( v25624(VarCurr)
    <=> ( v25625(VarCurr)
        | v25641(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_232,axiom,
    ! [VarCurr: state_type] :
      ( v25641(VarCurr)
    <=> ( v25611(VarCurr,2)
        & v25629(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2079,axiom,
    ! [VarCurr: state_type] :
      ( v25625(VarCurr)
    <=> ( v25626(VarCurr)
        & v25636(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2078,axiom,
    ! [VarCurr: state_type] :
      ( v25636(VarCurr)
    <=> ( v25637(VarCurr)
        & v25640(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_231,axiom,
    ! [VarCurr: state_type] :
      ( v25640(VarCurr)
    <=> ( v25611(VarCurr,2)
        | v25629(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2077,axiom,
    ! [VarCurr: state_type] :
      ( v25637(VarCurr)
    <=> ( v25638(VarCurr)
        | v25639(VarCurr) ) ) ).

tff(writeUnaryOperator_1380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25639(VarCurr)
    <=> v25629(VarCurr,2) ) ).

tff(writeUnaryOperator_1379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25638(VarCurr)
    <=> v25611(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2076,axiom,
    ! [VarCurr: state_type] :
      ( v25626(VarCurr)
    <=> ( v25627(VarCurr)
        | v25635(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_230,axiom,
    ! [VarCurr: state_type] :
      ( v25635(VarCurr)
    <=> ( v25611(VarCurr,1)
        & v25629(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2075,axiom,
    ! [VarCurr: state_type] :
      ( v25627(VarCurr)
    <=> ( v25628(VarCurr)
        & v25630(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2074,axiom,
    ! [VarCurr: state_type] :
      ( v25630(VarCurr)
    <=> ( v25631(VarCurr)
        & v25634(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_229,axiom,
    ! [VarCurr: state_type] :
      ( v25634(VarCurr)
    <=> ( v25611(VarCurr,1)
        | v25629(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2073,axiom,
    ! [VarCurr: state_type] :
      ( v25631(VarCurr)
    <=> ( v25632(VarCurr)
        | v25633(VarCurr) ) ) ).

tff(writeUnaryOperator_1378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25633(VarCurr)
    <=> v25629(VarCurr,1) ) ).

tff(writeUnaryOperator_1377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25632(VarCurr)
    <=> v25611(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2072,axiom,
    ! [VarCurr: state_type] :
      ( v25628(VarCurr)
    <=> ( v25611(VarCurr,0)
        & v25629(VarCurr,0) ) ) ).

tff(addAssignment_13120,axiom,
    ! [VarCurr: state_type] :
      ( v25629(VarCurr,0)
    <=> v25616(VarCurr) ) ).

tff(addAssignment_13119,axiom,
    ! [VarCurr: state_type] :
      ( ( v25629(VarCurr,3)
      <=> $false )
      & ( v25629(VarCurr,2)
      <=> $false )
      & ( v25629(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_13118,axiom,
    ! [VarCurr: state_type] :
      ( v25616(VarCurr)
    <=> v25618(VarCurr) ) ).

tff(addAssignment_13117,axiom,
    ! [VarCurr: state_type] :
      ( v25618(VarCurr)
    <=> v25566(VarCurr) ) ).

tff(addAssignment_13116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v25611(VarCurr,B)
      <=> v25613(VarCurr,B) ) ) ).

tff(addAssignment_13115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v25613(VarCurr,B)
      <=> v25614(VarCurr,B) ) ) ).

tff(addAssignment_13114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25614(VarCurr,B)
      <=> v25501(VarCurr,B) ) ) ).

tff(addAssignment_13113,axiom,
    ! [VarCurr: state_type] :
      ( v25614(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_13112,axiom,
    ! [VarCurr: state_type] :
      ( v25535(VarCurr,1)
    <=> v25537(VarCurr,1) ) ).

tff(addAssignment_13111,axiom,
    ! [VarCurr: state_type] :
      ( v25537(VarCurr,1)
    <=> v25598(VarCurr,1) ) ).

tff(addAssignment_13110,axiom,
    ! [VarCurr: state_type] :
      ( v25598(VarCurr,0)
    <=> v25599(VarCurr) ) ).

tff(addAssignment_13109,axiom,
    ! [VarCurr: state_type] :
      ( v25598(VarCurr,1)
    <=> v25599(VarCurr) ) ).

tff(addAssignment_13108,axiom,
    ! [VarCurr: state_type] :
      ( v25598(VarCurr,2)
    <=> v25599(VarCurr) ) ).

tff(addAssignment_13107,axiom,
    ! [VarCurr: state_type] :
      ( v25599(VarCurr)
    <=> v25539(VarCurr) ) ).

tff(addAssignment_13106,axiom,
    ! [VarCurr: state_type] :
      ( v25580(VarCurr)
    <=> v25582(VarCurr) ) ).

tff(addAssignment_13105,axiom,
    ! [VarCurr: state_type] :
      ( v25582(VarCurr)
    <=> v25584(VarCurr,0) ) ).

tff(addAssignment_13104,axiom,
    ! [VarCurr: state_type] :
      ( v25584(VarCurr,0)
    <=> v25586(VarCurr,0) ) ).

tff(addAssignment_13103,axiom,
    ! [VarCurr: state_type] :
      ( v25586(VarCurr,0)
    <=> v25588(VarCurr,0) ) ).

tff(addAssignment_13102,axiom,
    ! [VarCurr: state_type] :
      ( v25588(VarCurr,0)
    <=> v25593(VarCurr,0) ) ).

tff(writeUnaryOperator_1376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25593(VarCurr,B)
      <=> ~ v25590(VarCurr,B) ) ) ).

tff(addAssignment_13101,axiom,
    ! [VarCurr: state_type] :
      ( v25590(VarCurr,0)
    <=> v25592(VarCurr,0) ) ).

tff(addAssignment_13100,axiom,
    ! [VarCurr: state_type] :
      ( v25592(VarCurr,0)
    <=> v25501(VarCurr,0) ) ).

tff(addAssignment_13099,axiom,
    ! [VarCurr: state_type] :
      ( v25562(VarCurr,1)
    <=> v25564(VarCurr,1) ) ).

tff(addAssignment_13098,axiom,
    ! [VarCurr: state_type] :
      ( v25564(VarCurr,1)
    <=> v25567(VarCurr,1) ) ).

tff(addAssignment_13097,axiom,
    ! [VarCurr: state_type] :
      ( v25567(VarCurr,0)
    <=> v25568(VarCurr) ) ).

tff(addAssignment_13096,axiom,
    ! [VarCurr: state_type] :
      ( v25567(VarCurr,1)
    <=> v25566(VarCurr) ) ).

tff(addAssignment_13095,axiom,
    ! [VarCurr: state_type] :
      ( v25566(VarCurr)
    <=> v10053(VarCurr,10) ) ).

tff(addAssignment_13094,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,10)
    <=> v10055(VarCurr,10) ) ).

tff(addAssignment_13093,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,10)
    <=> v10057(VarCurr,10) ) ).

tff(addAssignment_13092,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,10)
    <=> v10061(VarCurr,10) ) ).

tff(addAssignment_13091,axiom,
    ! [VarCurr: state_type] :
      ( v25546(VarCurr,1)
    <=> v25548(VarCurr,1) ) ).

tff(addAssignment_13090,axiom,
    ! [VarCurr: state_type] :
      ( v25548(VarCurr,1)
    <=> v25549(VarCurr,1) ) ).

tff(addAssignment_13089,axiom,
    ! [VarCurr: state_type] :
      ( v25549(VarCurr,0)
    <=> v25550(VarCurr) ) ).

tff(addAssignment_13088,axiom,
    ! [VarCurr: state_type] :
      ( v25549(VarCurr,1)
    <=> v25550(VarCurr) ) ).

tff(addAssignment_13087,axiom,
    ! [VarCurr: state_type] :
      ( v25550(VarCurr)
    <=> v25073(VarCurr) ) ).

tff(addAssignment_13086,axiom,
    ! [VarCurr: state_type] :
      ( v25515(VarCurr)
    <=> v25517(VarCurr) ) ).

tff(addAssignment_13085,axiom,
    ! [VarCurr: state_type] :
      ( v25517(VarCurr)
    <=> v25519(VarCurr) ) ).

tff(addAssignment_13084,axiom,
    ! [VarCurr: state_type] :
      ( v25519(VarCurr)
    <=> v25521(VarCurr) ) ).

tff(addAssignment_13083,axiom,
    ! [VarCurr: state_type] :
      ( v25521(VarCurr)
    <=> v25523(VarCurr) ) ).

tff(addAssignment_13082,axiom,
    ! [VarCurr: state_type] :
      ( v25523(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_13081,axiom,
    ! [VarCurr: state_type] :
      ( v25503(VarCurr)
    <=> v25505(VarCurr) ) ).

tff(addAssignment_13080,axiom,
    ! [VarCurr: state_type] :
      ( v25505(VarCurr)
    <=> v25507(VarCurr) ) ).

tff(addAssignment_13079,axiom,
    ! [VarCurr: state_type] :
      ( v25507(VarCurr)
    <=> v25509(VarCurr) ) ).

tff(addAssignment_13078,axiom,
    ! [VarCurr: state_type] :
      ( v25509(VarCurr)
    <=> v25511(VarCurr) ) ).

tff(addAssignment_13077,axiom,
    ! [VarCurr: state_type] :
      ( v25511(VarCurr)
    <=> v25513(VarCurr) ) ).

tff(addAssignment_13076,axiom,
    ! [VarCurr: state_type] :
      ( v25513(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_13075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25011(VarCurr,B)
      <=> v25013(VarCurr,B) ) ) ).

tff(addAssignment_13074,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25013(VarCurr,B)
      <=> v25015(VarCurr,B) ) ) ).

tff(addAssignment_13073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25015(VarCurr,B)
      <=> v25017(VarCurr,B) ) ) ).

tff(addAssignment_13072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25017(VarCurr,B)
      <=> v25019(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25464(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v25019(VarNext,B)
            <=> v25019(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_285,axiom,
    ! [VarNext: state_type] :
      ( v25464(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25019(VarNext,B)
          <=> v25474(VarNext,B) ) ) ) ).

tff(addAssignment_13071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25474(VarNext,B)
          <=> v25472(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25475(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25472(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_177,axiom,
    ! [VarCurr: state_type] :
      ( v25475(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25472(VarCurr,B)
          <=> v25049(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2071,axiom,
    ! [VarCurr: state_type] :
      ( v25475(VarCurr)
    <=> ( v25476(VarCurr)
        & v25477(VarCurr) ) ) ).

tff(writeUnaryOperator_1375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25477(VarCurr)
    <=> v25035(VarCurr) ) ).

tff(writeUnaryOperator_1374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25476(VarCurr)
    <=> v25021(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25464(VarNext)
      <=> v25465(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2069,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25465(VarNext)
      <=> ( v25466(VarNext)
          & v25379(VarNext) ) ) ) ).

tff(writeUnaryOperator_1373,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25466(VarNext)
      <=> v25468(VarNext) ) ) ).

tff(addAssignment_13070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25468(VarNext)
      <=> v25379(VarCurr) ) ) ).

tff(addAssignment_13069,axiom,
    ! [VarCurr: state_type] :
      ( v25379(VarCurr)
    <=> v25381(VarCurr) ) ).

tff(addAssignment_13068,axiom,
    ! [VarCurr: state_type] :
      ( v25381(VarCurr)
    <=> v25383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2068,axiom,
    ! [VarCurr: state_type] :
      ( v25383(VarCurr)
    <=> ( v25461(VarCurr)
        | v25453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2067,axiom,
    ! [VarCurr: state_type] :
      ( v25461(VarCurr)
    <=> ( v25385(VarCurr)
        & v25391(VarCurr) ) ) ).

tff(addAssignment_13067,axiom,
    ! [VarCurr: state_type] :
      ( v25453(VarCurr)
    <=> v25455(VarCurr) ) ).

tff(addAssignment_13066,axiom,
    ! [VarCurr: state_type] :
      ( v25455(VarCurr)
    <=> v25457(VarCurr) ) ).

tff(addAssignment_13065,axiom,
    ! [VarCurr: state_type] :
      ( v25457(VarCurr)
    <=> v25459(VarCurr) ) ).

tff(addAssignment_13064,axiom,
    ! [VarCurr: state_type] :
      ( v25459(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25437(VarNext)
       => ( v25391(VarNext)
        <=> v25391(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_284,axiom,
    ! [VarNext: state_type] :
      ( v25437(VarNext)
     => ( v25391(VarNext)
      <=> v25447(VarNext) ) ) ).

tff(addAssignment_13063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25447(VarNext)
      <=> v25445(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2066,axiom,
    ! [VarCurr: state_type] :
      ( v25445(VarCurr)
    <=> ( v25448(VarCurr)
        & v25449(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2065,axiom,
    ! [VarCurr: state_type] :
      ( v25449(VarCurr)
    <=> ( v25397(VarCurr)
        | v25428(VarCurr) ) ) ).

tff(writeUnaryOperator_1372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25448(VarCurr)
    <=> v25393(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2064,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25437(VarNext)
      <=> v25438(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2063,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25438(VarNext)
      <=> ( v25440(VarNext)
          & v25442(VarNext) ) ) ) ).

tff(writeUnaryOperator_1371,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25442(VarCurr)
    <=> v25385(VarCurr) ) ).

tff(addAssignment_13062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25440(VarNext)
      <=> v25385(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_106,axiom,
    ( v25391(constB0)
  <=> $true ) ).

tff(addAssignment_13061,axiom,
    ! [VarCurr: state_type] :
      ( v25428(VarCurr)
    <=> v25430(VarCurr) ) ).

tff(addAssignment_13060,axiom,
    ! [VarCurr: state_type] :
      ( v25430(VarCurr)
    <=> v25432(VarCurr) ) ).

tff(addAssignment_13059,axiom,
    ! [VarCurr: state_type] :
      ( v25432(VarCurr)
    <=> v25434(VarCurr) ) ).

tff(addAssignment_13058,axiom,
    ! [VarCurr: state_type] :
      ( v25434(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_13057,axiom,
    ! [VarCurr: state_type] :
      ( v25397(VarCurr)
    <=> v25399(VarCurr) ) ).

tff(addAssignment_13056,axiom,
    ! [VarCurr: state_type] :
      ( v25399(VarCurr)
    <=> v25401(VarCurr) ) ).

tff(addAssignment_13055,axiom,
    ! [VarCurr: state_type] :
      ( v25401(VarCurr)
    <=> v25403(VarCurr) ) ).

tff(addAssignment_13054,axiom,
    ! [VarCurr: state_type] :
      ( v25403(VarCurr)
    <=> v25405(VarCurr) ) ).

tff(writeUnaryOperator_1370,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25405(VarCurr)
    <=> v25425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2062,axiom,
    ! [VarCurr: state_type] :
      ( v25425(VarCurr)
    <=> ( v25426(VarCurr)
        | v25421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2061,axiom,
    ! [VarCurr: state_type] :
      ( v25426(VarCurr)
    <=> ( v25407(VarCurr)
        | v25417(VarCurr) ) ) ).

tff(addAssignment_13053,axiom,
    ! [VarCurr: state_type] :
      ( v25421(VarCurr)
    <=> v25423(VarCurr) ) ).

tff(addAssignment_13052,axiom,
    ! [VarCurr: state_type] :
      ( v25423(VarCurr)
    <=> v25411(VarCurr,2) ) ).

tff(addAssignment_13051,axiom,
    ! [VarCurr: state_type] :
      ( v25411(VarCurr,2)
    <=> v25413(VarCurr,2) ) ).

tff(addAssignment_13050,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,2)
    <=> v25415(VarCurr,2) ) ).

tff(addAssignment_13049,axiom,
    ! [VarCurr: state_type] :
      ( v25417(VarCurr)
    <=> v25419(VarCurr) ) ).

tff(addAssignment_13048,axiom,
    ! [VarCurr: state_type] :
      ( v25419(VarCurr)
    <=> v25411(VarCurr,1) ) ).

tff(addAssignment_13047,axiom,
    ! [VarCurr: state_type] :
      ( v25411(VarCurr,1)
    <=> v25413(VarCurr,1) ) ).

tff(addAssignment_13046,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,1)
    <=> v25415(VarCurr,1) ) ).

tff(addAssignment_13045,axiom,
    ! [VarCurr: state_type] :
      ( v25407(VarCurr)
    <=> v25409(VarCurr) ) ).

tff(addAssignment_13044,axiom,
    ! [VarCurr: state_type] :
      ( v25409(VarCurr)
    <=> v25411(VarCurr,0) ) ).

tff(addAssignment_13043,axiom,
    ! [VarCurr: state_type] :
      ( v25411(VarCurr,0)
    <=> v25413(VarCurr,0) ) ).

tff(addAssignment_13042,axiom,
    ! [VarCurr: state_type] :
      ( v25413(VarCurr,0)
    <=> v25415(VarCurr,0) ) ).

tff(addAssignment_13041,axiom,
    ! [VarCurr: state_type] :
      ( v25393(VarCurr)
    <=> v25395(VarCurr) ) ).

tff(addAssignment_13040,axiom,
    ! [VarCurr: state_type] :
      ( v25395(VarCurr)
    <=> $false ) ).

tff(addAssignment_13039,axiom,
    ! [VarCurr: state_type] :
      ( v25385(VarCurr)
    <=> v25387(VarCurr) ) ).

tff(addAssignment_13038,axiom,
    ! [VarCurr: state_type] :
      ( v25387(VarCurr)
    <=> v25389(VarCurr) ) ).

tff(addAssignment_13037,axiom,
    ! [VarCurr: state_type] :
      ( v25389(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_13036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25049(VarCurr,B)
      <=> v25051(VarCurr,B) ) ) ).

tff(addAssignment_13035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25051(VarCurr,B)
      <=> v25053(VarCurr,B) ) ) ).

tff(addAssignment_13034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25053(VarCurr,B)
      <=> v25055(VarCurr,B) ) ) ).

tff(addAssignment_13033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25055(VarCurr,B)
      <=> v25057(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25057(VarCurr,B)
      <=> ( v25059(VarCurr,B)
          & v25081(VarCurr,B) ) ) ) ).

tff(addAssignment_13032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25081(VarCurr,B)
      <=> v25083(VarCurr,B) ) ) ).

tff(addAssignment_13031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25083(VarCurr,B)
      <=> v25085(VarCurr,B) ) ) ).

tff(addAssignment_13030,axiom,
    ! [VarCurr: state_type] :
      ( ( v25085(VarCurr,11)
      <=> v9198(VarCurr,131) )
      & ( v25085(VarCurr,10)
      <=> v9198(VarCurr,130) )
      & ( v25085(VarCurr,9)
      <=> v9198(VarCurr,129) )
      & ( v25085(VarCurr,8)
      <=> v9198(VarCurr,128) )
      & ( v25085(VarCurr,7)
      <=> v9198(VarCurr,127) )
      & ( v25085(VarCurr,6)
      <=> v9198(VarCurr,126) )
      & ( v25085(VarCurr,5)
      <=> v9198(VarCurr,125) )
      & ( v25085(VarCurr,4)
      <=> v9198(VarCurr,124) )
      & ( v25085(VarCurr,3)
      <=> v9198(VarCurr,123) )
      & ( v25085(VarCurr,2)
      <=> v9198(VarCurr,122) )
      & ( v25085(VarCurr,1)
      <=> v9198(VarCurr,121) )
      & ( v25085(VarCurr,0)
      <=> v9198(VarCurr,120) ) ) ).

tff(addAssignment_13029,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,131)
      <=> v25087(VarCurr,11) )
      & ( v9198(VarCurr,130)
      <=> v25087(VarCurr,10) )
      & ( v9198(VarCurr,129)
      <=> v25087(VarCurr,9) )
      & ( v9198(VarCurr,128)
      <=> v25087(VarCurr,8) )
      & ( v9198(VarCurr,127)
      <=> v25087(VarCurr,7) )
      & ( v9198(VarCurr,126)
      <=> v25087(VarCurr,6) )
      & ( v9198(VarCurr,125)
      <=> v25087(VarCurr,5) )
      & ( v9198(VarCurr,124)
      <=> v25087(VarCurr,4) )
      & ( v9198(VarCurr,123)
      <=> v25087(VarCurr,3) )
      & ( v9198(VarCurr,122)
      <=> v25087(VarCurr,2) )
      & ( v9198(VarCurr,121)
      <=> v25087(VarCurr,1) )
      & ( v9198(VarCurr,120)
      <=> v25087(VarCurr,0) ) ) ).

tff(addAssignment_13028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25087(VarCurr,B)
      <=> v25089(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25089(VarCurr,B)
      <=> ( v25371(VarCurr,B)
          | v25374(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25374(VarCurr,B)
      <=> ( v25099(VarCurr,B)
          & v25375(VarCurr,B) ) ) ) ).

tff(addAssignment_13027,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,0)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13026,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,1)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13025,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,2)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13024,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,3)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13023,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,4)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13022,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,5)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13021,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,6)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13020,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,7)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13019,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,8)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13018,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,9)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13017,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,10)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13016,axiom,
    ! [VarCurr: state_type] :
      ( v25375(VarCurr,11)
    <=> v25376(VarCurr) ) ).

tff(addAssignment_13015,axiom,
    ! [VarCurr: state_type] :
      ( v25376(VarCurr)
    <=> v25367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25371(VarCurr,B)
      <=> ( v25091(VarCurr,B)
          & v25372(VarCurr,B) ) ) ) ).

tff(addAssignment_13014,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,0)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13013,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,1)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13012,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,2)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13011,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,3)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13010,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,4)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13009,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,5)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13008,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,6)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13007,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,7)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13006,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,8)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13005,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,9)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13004,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,10)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13003,axiom,
    ! [VarCurr: state_type] :
      ( v25372(VarCurr,11)
    <=> v25373(VarCurr) ) ).

tff(addAssignment_13002,axiom,
    ! [VarCurr: state_type] :
      ( v25373(VarCurr)
    <=> v25095(VarCurr) ) ).

tff(addAssignment_13001,axiom,
    ! [VarCurr: state_type] :
      ( v25367(VarCurr)
    <=> v25369(VarCurr) ) ).

tff(addAssignment_13000,axiom,
    ! [VarCurr: state_type] :
      ( v25369(VarCurr)
    <=> v9844(VarCurr,10) ) ).

tff(addAssignment_12999,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,10)
    <=> v9846(VarCurr,10) ) ).

tff(addAssignment_12998,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,10)
    <=> v9496(VarCurr,10) ) ).

tff(addAssignment_12997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25099(VarCurr,B)
      <=> v25101(VarCurr,B) ) ) ).

tff(addAssignment_12996,axiom,
    ! [VarCurr: state_type] :
      ( ( v25101(VarCurr,11)
      <=> v9208(VarCurr,143) )
      & ( v25101(VarCurr,10)
      <=> v9208(VarCurr,142) )
      & ( v25101(VarCurr,9)
      <=> v9208(VarCurr,141) )
      & ( v25101(VarCurr,8)
      <=> v9208(VarCurr,140) )
      & ( v25101(VarCurr,7)
      <=> v9208(VarCurr,139) )
      & ( v25101(VarCurr,6)
      <=> v9208(VarCurr,138) )
      & ( v25101(VarCurr,5)
      <=> v9208(VarCurr,137) )
      & ( v25101(VarCurr,4)
      <=> v9208(VarCurr,136) )
      & ( v25101(VarCurr,3)
      <=> v9208(VarCurr,135) )
      & ( v25101(VarCurr,2)
      <=> v9208(VarCurr,134) )
      & ( v25101(VarCurr,1)
      <=> v9208(VarCurr,133) )
      & ( v25101(VarCurr,0)
      <=> v9208(VarCurr,132) ) ) ).

tff(addAssignment_12995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,144)
        & ~ $less(B,132) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_12994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,144)
        & ~ $less(B,132) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_12993,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,143)
      <=> v25103(VarCurr,11) )
      & ( v9212(VarCurr,142)
      <=> v25103(VarCurr,10) )
      & ( v9212(VarCurr,141)
      <=> v25103(VarCurr,9) )
      & ( v9212(VarCurr,140)
      <=> v25103(VarCurr,8) )
      & ( v9212(VarCurr,139)
      <=> v25103(VarCurr,7) )
      & ( v9212(VarCurr,138)
      <=> v25103(VarCurr,6) )
      & ( v9212(VarCurr,137)
      <=> v25103(VarCurr,5) )
      & ( v9212(VarCurr,136)
      <=> v25103(VarCurr,4) )
      & ( v9212(VarCurr,135)
      <=> v25103(VarCurr,3) )
      & ( v9212(VarCurr,134)
      <=> v25103(VarCurr,2) )
      & ( v9212(VarCurr,133)
      <=> v25103(VarCurr,1) )
      & ( v9212(VarCurr,132)
      <=> v25103(VarCurr,0) ) ) ).

tff(addAssignment_12992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25103(VarCurr,B)
      <=> v25105(VarCurr,B) ) ) ).

tff(addAssignment_12991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25105(VarCurr,B)
      <=> v25107(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_283,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25350(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v25107(VarNext,B)
            <=> v25107(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_283,axiom,
    ! [VarNext: state_type] :
      ( v25350(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25107(VarNext,B)
          <=> v25360(VarNext,B) ) ) ) ).

tff(addAssignment_12990,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25360(VarNext,B)
          <=> v25358(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_176,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25361(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25358(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_176,axiom,
    ! [VarCurr: state_type] :
      ( v25361(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v25358(VarCurr,B)
          <=> v25137(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2060,axiom,
    ! [VarCurr: state_type] :
      ( v25361(VarCurr)
    <=> ( v25362(VarCurr)
        & v25363(VarCurr) ) ) ).

tff(writeUnaryOperator_1369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25363(VarCurr)
    <=> v25123(VarCurr) ) ).

tff(writeUnaryOperator_1368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25362(VarCurr)
    <=> v25109(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25350(VarNext)
      <=> v25351(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2058,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25351(VarNext)
      <=> ( v25352(VarNext)
          & v25325(VarNext) ) ) ) ).

tff(writeUnaryOperator_1367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v25352(VarNext)
      <=> v25354(VarNext) ) ) ).

tff(addAssignment_12989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v25354(VarNext)
      <=> v25325(VarCurr) ) ) ).

tff(addAssignment_12988,axiom,
    ! [VarCurr: state_type] :
      ( v25325(VarCurr)
    <=> v25327(VarCurr) ) ).

tff(addAssignment_12987,axiom,
    ! [VarCurr: state_type] :
      ( v25327(VarCurr)
    <=> v25329(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2057,axiom,
    ! [VarCurr: state_type] :
      ( v25329(VarCurr)
    <=> ( v25347(VarCurr)
        | v25339(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2056,axiom,
    ! [VarCurr: state_type] :
      ( v25347(VarCurr)
    <=> ( v25331(VarCurr)
        & v25337(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_105,axiom,
    ( v25337(constB0)
  <=> $true ) ).

tff(addAssignment_12986,axiom,
    ! [VarCurr: state_type] :
      ( v25339(VarCurr)
    <=> v25341(VarCurr) ) ).

tff(addAssignment_12985,axiom,
    ! [VarCurr: state_type] :
      ( v25341(VarCurr)
    <=> v25343(VarCurr) ) ).

tff(addAssignment_12984,axiom,
    ! [VarCurr: state_type] :
      ( v25343(VarCurr)
    <=> v25345(VarCurr) ) ).

tff(addAssignment_12983,axiom,
    ! [VarCurr: state_type] :
      ( v25345(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_12982,axiom,
    ! [VarCurr: state_type] :
      ( v25331(VarCurr)
    <=> v25333(VarCurr) ) ).

tff(addAssignment_12981,axiom,
    ! [VarCurr: state_type] :
      ( v25333(VarCurr)
    <=> v25335(VarCurr) ) ).

tff(addAssignment_12980,axiom,
    ! [VarCurr: state_type] :
      ( v25335(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_12979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25137(VarCurr,B)
      <=> v25139(VarCurr,B) ) ) ).

tff(addAssignment_12978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25139(VarCurr,B)
      <=> v25141(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25141(VarCurr,B)
      <=> ( v25310(VarCurr,B)
          | v25321(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25321(VarCurr,B)
      <=> ( v25274(VarCurr,B)
          & v25322(VarCurr,B) ) ) ) ).

tff(addAssignment_12977,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,0)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12976,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,1)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12975,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,2)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12974,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,3)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12973,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,4)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12972,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,5)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12971,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,6)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12970,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,7)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12969,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,8)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12968,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,9)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12967,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,10)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12966,axiom,
    ! [VarCurr: state_type] :
      ( v25322(VarCurr,11)
    <=> v25323(VarCurr) ) ).

tff(addAssignment_12965,axiom,
    ! [VarCurr: state_type] :
      ( v25323(VarCurr)
    <=> v25284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25310(VarCurr,B)
      <=> ( v25311(VarCurr,B)
          | v25318(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25318(VarCurr,B)
      <=> ( v25238(VarCurr,B)
          & v25319(VarCurr,B) ) ) ) ).

tff(addAssignment_12964,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,0)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12963,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,1)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12962,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,2)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12961,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,3)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12960,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,4)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12959,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,5)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12958,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,6)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12957,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,7)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12956,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,8)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12955,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,9)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12954,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,10)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12953,axiom,
    ! [VarCurr: state_type] :
      ( v25319(VarCurr,11)
    <=> v25320(VarCurr) ) ).

tff(addAssignment_12952,axiom,
    ! [VarCurr: state_type] :
      ( v25320(VarCurr)
    <=> v25248(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25311(VarCurr,B)
      <=> ( v25312(VarCurr,B)
          | v25315(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25315(VarCurr,B)
      <=> ( v25191(VarCurr,B)
          & v25316(VarCurr,B) ) ) ) ).

tff(addAssignment_12951,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,0)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12950,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,1)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12949,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,2)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12948,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,3)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12947,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,4)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12946,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,5)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12945,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,6)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12944,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,7)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12943,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,8)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12942,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,9)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12941,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,10)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12940,axiom,
    ! [VarCurr: state_type] :
      ( v25316(VarCurr,11)
    <=> v25317(VarCurr) ) ).

tff(addAssignment_12939,axiom,
    ! [VarCurr: state_type] :
      ( v25317(VarCurr)
    <=> v25201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25312(VarCurr,B)
      <=> ( v25143(VarCurr,B)
          & v25313(VarCurr,B) ) ) ) ).

tff(addAssignment_12938,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,0)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12937,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,1)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12936,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,2)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12935,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,3)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12934,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,4)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12933,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,5)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12932,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,6)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12931,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,7)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12930,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,8)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12929,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,9)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12928,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,10)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12927,axiom,
    ! [VarCurr: state_type] :
      ( v25313(VarCurr,11)
    <=> v25314(VarCurr) ) ).

tff(addAssignment_12926,axiom,
    ! [VarCurr: state_type] :
      ( v25314(VarCurr)
    <=> v25153(VarCurr) ) ).

tff(addAssignment_12925,axiom,
    ! [VarCurr: state_type] :
      ( v25284(VarCurr)
    <=> v25286(VarCurr) ) ).

tff(addAssignment_12924,axiom,
    ! [VarCurr: state_type] :
      ( v25286(VarCurr)
    <=> v25288(VarCurr) ) ).

tff(addAssignment_12923,axiom,
    ! [VarCurr: state_type] :
      ( v25288(VarCurr)
    <=> v25290(VarCurr) ) ).

tff(addAssignment_12922,axiom,
    ! [VarCurr: state_type] :
      ( v25290(VarCurr)
    <=> v25292(VarCurr) ) ).

tff(addAssignment_12921,axiom,
    ! [VarCurr: state_type] :
      ( v25292(VarCurr)
    <=> v25294(VarCurr) ) ).

tff(addAssignment_12920,axiom,
    ! [VarCurr: state_type] :
      ( v25294(VarCurr)
    <=> v25296(VarCurr) ) ).

tff(addAssignment_12919,axiom,
    ! [VarCurr: state_type] :
      ( v25296(VarCurr)
    <=> v25298(VarCurr) ) ).

tff(writeUnaryOperator_1366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25298(VarCurr)
    <=> v25308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2055,axiom,
    ! [VarCurr: state_type] :
      ( v25308(VarCurr)
    <=> ( v25300(VarCurr)
        | v25304(VarCurr) ) ) ).

tff(addAssignment_12918,axiom,
    ! [VarCurr: state_type] :
      ( v25304(VarCurr)
    <=> v25306(VarCurr) ) ).

tff(addAssignment_12917,axiom,
    ! [VarCurr: state_type] :
      ( v25306(VarCurr)
    <=> v25221(VarCurr,1) ) ).

tff(addAssignment_12916,axiom,
    ! [VarCurr: state_type] :
      ( v25300(VarCurr)
    <=> v25302(VarCurr) ) ).

tff(addAssignment_12915,axiom,
    ! [VarCurr: state_type] :
      ( v25302(VarCurr)
    <=> v25221(VarCurr,0) ) ).

tff(addAssignment_12914,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25274(VarCurr,B)
      <=> v25276(VarCurr,B) ) ) ).

tff(addAssignment_12913,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25276(VarCurr,B)
      <=> v25278(VarCurr,B) ) ) ).

tff(addAssignment_12912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25278(VarCurr,B)
      <=> v25280(VarCurr,B) ) ) ).

tff(addAssignment_12911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25280(VarCurr,B)
      <=> v25282(VarCurr,B) ) ) ).

tff(addAssignment_12910,axiom,
    ! [VarCurr: state_type] :
      ( v25248(VarCurr)
    <=> v25250(VarCurr) ) ).

tff(addAssignment_12909,axiom,
    ! [VarCurr: state_type] :
      ( v25250(VarCurr)
    <=> v25252(VarCurr) ) ).

tff(addAssignment_12908,axiom,
    ! [VarCurr: state_type] :
      ( v25252(VarCurr)
    <=> v25254(VarCurr) ) ).

tff(addAssignment_12907,axiom,
    ! [VarCurr: state_type] :
      ( v25254(VarCurr)
    <=> v25256(VarCurr) ) ).

tff(addAssignment_12906,axiom,
    ! [VarCurr: state_type] :
      ( v25256(VarCurr)
    <=> v25258(VarCurr) ) ).

tff(addAssignment_12905,axiom,
    ! [VarCurr: state_type] :
      ( v25258(VarCurr)
    <=> v25260(VarCurr) ) ).

tff(addAssignment_12904,axiom,
    ! [VarCurr: state_type] :
      ( v25260(VarCurr)
    <=> v25262(VarCurr) ) ).

tff(writeUnaryOperator_1365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25262(VarCurr)
    <=> v25272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2054,axiom,
    ! [VarCurr: state_type] :
      ( v25272(VarCurr)
    <=> ( v25264(VarCurr)
        | v25268(VarCurr) ) ) ).

tff(addAssignment_12903,axiom,
    ! [VarCurr: state_type] :
      ( v25268(VarCurr)
    <=> v25270(VarCurr) ) ).

tff(addAssignment_12902,axiom,
    ! [VarCurr: state_type] :
      ( v25270(VarCurr)
    <=> v25221(VarCurr,1) ) ).

tff(addAssignment_12901,axiom,
    ! [VarCurr: state_type] :
      ( v25221(VarCurr,1)
    <=> v25223(VarCurr,1) ) ).

tff(addAssignment_12900,axiom,
    ! [VarCurr: state_type] :
      ( v25223(VarCurr,1)
    <=> v25225(VarCurr,1) ) ).

tff(addAssignment_12899,axiom,
    ! [VarCurr: state_type] :
      ( v25225(VarCurr,1)
    <=> v25230(VarCurr,1) ) ).

tff(addAssignment_12898,axiom,
    ! [VarCurr: state_type] :
      ( v25227(VarCurr,1)
    <=> v25229(VarCurr,1) ) ).

tff(addAssignment_12897,axiom,
    ! [VarCurr: state_type] :
      ( v25229(VarCurr,1)
    <=> v25173(VarCurr,1) ) ).

tff(addAssignment_12896,axiom,
    ! [VarCurr: state_type] :
      ( v25264(VarCurr)
    <=> v25266(VarCurr) ) ).

tff(addAssignment_12895,axiom,
    ! [VarCurr: state_type] :
      ( v25266(VarCurr)
    <=> v25173(VarCurr,0) ) ).

tff(addAssignment_12894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25238(VarCurr,B)
      <=> v25240(VarCurr,B) ) ) ).

tff(addAssignment_12893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25240(VarCurr,B)
      <=> v25242(VarCurr,B) ) ) ).

tff(addAssignment_12892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25242(VarCurr,B)
      <=> v25244(VarCurr,B) ) ) ).

tff(addAssignment_12891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25244(VarCurr,B)
      <=> v25246(VarCurr,B) ) ) ).

tff(addAssignment_12890,axiom,
    ! [VarCurr: state_type] :
      ( v25201(VarCurr)
    <=> v25203(VarCurr) ) ).

tff(addAssignment_12889,axiom,
    ! [VarCurr: state_type] :
      ( v25203(VarCurr)
    <=> v25205(VarCurr) ) ).

tff(addAssignment_12888,axiom,
    ! [VarCurr: state_type] :
      ( v25205(VarCurr)
    <=> v25207(VarCurr) ) ).

tff(addAssignment_12887,axiom,
    ! [VarCurr: state_type] :
      ( v25207(VarCurr)
    <=> v25209(VarCurr) ) ).

tff(addAssignment_12886,axiom,
    ! [VarCurr: state_type] :
      ( v25209(VarCurr)
    <=> v25211(VarCurr) ) ).

tff(addAssignment_12885,axiom,
    ! [VarCurr: state_type] :
      ( v25211(VarCurr)
    <=> v25213(VarCurr) ) ).

tff(addAssignment_12884,axiom,
    ! [VarCurr: state_type] :
      ( v25213(VarCurr)
    <=> v25215(VarCurr) ) ).

tff(writeUnaryOperator_1364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25215(VarCurr)
    <=> v25236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2053,axiom,
    ! [VarCurr: state_type] :
      ( v25236(VarCurr)
    <=> ( v25217(VarCurr)
        | v25232(VarCurr) ) ) ).

tff(addAssignment_12883,axiom,
    ! [VarCurr: state_type] :
      ( v25232(VarCurr)
    <=> v25234(VarCurr) ) ).

tff(addAssignment_12882,axiom,
    ! [VarCurr: state_type] :
      ( v25234(VarCurr)
    <=> v25173(VarCurr,1) ) ).

tff(addAssignment_12881,axiom,
    ! [VarCurr: state_type] :
      ( v25217(VarCurr)
    <=> v25219(VarCurr) ) ).

tff(addAssignment_12880,axiom,
    ! [VarCurr: state_type] :
      ( v25219(VarCurr)
    <=> v25221(VarCurr,0) ) ).

tff(addAssignment_12879,axiom,
    ! [VarCurr: state_type] :
      ( v25221(VarCurr,0)
    <=> v25223(VarCurr,0) ) ).

tff(addAssignment_12878,axiom,
    ! [VarCurr: state_type] :
      ( v25223(VarCurr,0)
    <=> v25225(VarCurr,0) ) ).

tff(addAssignment_12877,axiom,
    ! [VarCurr: state_type] :
      ( v25225(VarCurr,0)
    <=> v25230(VarCurr,0) ) ).

tff(writeUnaryOperator_1363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v25230(VarCurr,B)
      <=> ~ v25227(VarCurr,B) ) ) ).

tff(addAssignment_12876,axiom,
    ! [VarCurr: state_type] :
      ( v25227(VarCurr,0)
    <=> v25229(VarCurr,0) ) ).

tff(addAssignment_12875,axiom,
    ! [VarCurr: state_type] :
      ( v25229(VarCurr,0)
    <=> v25173(VarCurr,0) ) ).

tff(addAssignment_12874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25191(VarCurr,B)
      <=> v25193(VarCurr,B) ) ) ).

tff(addAssignment_12873,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25193(VarCurr,B)
      <=> v25195(VarCurr,B) ) ) ).

tff(addAssignment_12872,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25195(VarCurr,B)
      <=> v25197(VarCurr,B) ) ) ).

tff(addAssignment_12871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25197(VarCurr,B)
      <=> v25199(VarCurr,B) ) ) ).

tff(addAssignment_12870,axiom,
    ! [VarCurr: state_type] :
      ( v25153(VarCurr)
    <=> v25155(VarCurr) ) ).

tff(addAssignment_12869,axiom,
    ! [VarCurr: state_type] :
      ( v25155(VarCurr)
    <=> v25157(VarCurr) ) ).

tff(addAssignment_12868,axiom,
    ! [VarCurr: state_type] :
      ( v25157(VarCurr)
    <=> v25159(VarCurr) ) ).

tff(addAssignment_12867,axiom,
    ! [VarCurr: state_type] :
      ( v25159(VarCurr)
    <=> v25161(VarCurr) ) ).

tff(addAssignment_12866,axiom,
    ! [VarCurr: state_type] :
      ( v25161(VarCurr)
    <=> v25163(VarCurr) ) ).

tff(addAssignment_12865,axiom,
    ! [VarCurr: state_type] :
      ( v25163(VarCurr)
    <=> v25165(VarCurr) ) ).

tff(addAssignment_12864,axiom,
    ! [VarCurr: state_type] :
      ( v25165(VarCurr)
    <=> v25167(VarCurr) ) ).

tff(writeUnaryOperator_1362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v25167(VarCurr)
    <=> v25189(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2052,axiom,
    ! [VarCurr: state_type] :
      ( v25189(VarCurr)
    <=> ( v25169(VarCurr)
        | v25185(VarCurr) ) ) ).

tff(addAssignment_12863,axiom,
    ! [VarCurr: state_type] :
      ( v25185(VarCurr)
    <=> v25187(VarCurr) ) ).

tff(addAssignment_12862,axiom,
    ! [VarCurr: state_type] :
      ( v25187(VarCurr)
    <=> v25173(VarCurr,1) ) ).

tff(addAssignment_12861,axiom,
    ! [VarCurr: state_type] :
      ( v25173(VarCurr,1)
    <=> v25175(VarCurr,1) ) ).

tff(addAssignment_12860,axiom,
    ! [VarCurr: state_type] :
      ( v25175(VarCurr,1)
    <=> v25177(VarCurr,1) ) ).

tff(addAssignment_12859,axiom,
    ! [VarCurr: state_type] :
      ( v25177(VarCurr,1)
    <=> v25179(VarCurr,1) ) ).

tff(addAssignment_12858,axiom,
    ! [VarCurr: state_type] :
      ( v25179(VarCurr,1)
    <=> v25181(VarCurr,1) ) ).

tff(addAssignment_12857,axiom,
    ! [VarCurr: state_type] :
      ( v25181(VarCurr,1)
    <=> v25183(VarCurr,1) ) ).

tff(addAssignment_12856,axiom,
    ! [VarCurr: state_type] :
      ( v25169(VarCurr)
    <=> v25171(VarCurr) ) ).

tff(addAssignment_12855,axiom,
    ! [VarCurr: state_type] :
      ( v25171(VarCurr)
    <=> v25173(VarCurr,0) ) ).

tff(addAssignment_12854,axiom,
    ! [VarCurr: state_type] :
      ( v25173(VarCurr,0)
    <=> v25175(VarCurr,0) ) ).

tff(addAssignment_12853,axiom,
    ! [VarCurr: state_type] :
      ( v25175(VarCurr,0)
    <=> v25177(VarCurr,0) ) ).

tff(addAssignment_12852,axiom,
    ! [VarCurr: state_type] :
      ( v25177(VarCurr,0)
    <=> v25179(VarCurr,0) ) ).

tff(addAssignment_12851,axiom,
    ! [VarCurr: state_type] :
      ( v25179(VarCurr,0)
    <=> v25181(VarCurr,0) ) ).

tff(addAssignment_12850,axiom,
    ! [VarCurr: state_type] :
      ( v25181(VarCurr,0)
    <=> v25183(VarCurr,0) ) ).

tff(addAssignment_12849,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25143(VarCurr,B)
      <=> v25145(VarCurr,B) ) ) ).

tff(addAssignment_12848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25145(VarCurr,B)
      <=> v25147(VarCurr,B) ) ) ).

tff(addAssignment_12847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25147(VarCurr,B)
      <=> v25149(VarCurr,B) ) ) ).

tff(addAssignment_12846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25149(VarCurr,B)
      <=> v25151(VarCurr,B) ) ) ).

tff(addAssignment_12845,axiom,
    ! [VarCurr: state_type] :
      ( v25123(VarCurr)
    <=> v25125(VarCurr) ) ).

tff(addAssignment_12844,axiom,
    ! [VarCurr: state_type] :
      ( v25125(VarCurr)
    <=> v25127(VarCurr) ) ).

tff(addAssignment_12843,axiom,
    ! [VarCurr: state_type] :
      ( v25127(VarCurr)
    <=> v25129(VarCurr) ) ).

tff(addAssignment_12842,axiom,
    ! [VarCurr: state_type] :
      ( v25129(VarCurr)
    <=> v25131(VarCurr) ) ).

tff(addAssignment_12841,axiom,
    ! [VarCurr: state_type] :
      ( v25131(VarCurr)
    <=> v25133(VarCurr) ) ).

tff(addAssignment_12840,axiom,
    ! [VarCurr: state_type] :
      ( v25133(VarCurr)
    <=> v25135(VarCurr) ) ).

tff(addAssignment_12839,axiom,
    ! [VarCurr: state_type] :
      ( v25135(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_12838,axiom,
    ! [VarCurr: state_type] :
      ( v25109(VarCurr)
    <=> v25111(VarCurr) ) ).

tff(addAssignment_12837,axiom,
    ! [VarCurr: state_type] :
      ( v25111(VarCurr)
    <=> v25113(VarCurr) ) ).

tff(addAssignment_12836,axiom,
    ! [VarCurr: state_type] :
      ( v25113(VarCurr)
    <=> v25115(VarCurr) ) ).

tff(addAssignment_12835,axiom,
    ! [VarCurr: state_type] :
      ( v25115(VarCurr)
    <=> v25117(VarCurr) ) ).

tff(addAssignment_12834,axiom,
    ! [VarCurr: state_type] :
      ( v25117(VarCurr)
    <=> v25119(VarCurr) ) ).

tff(addAssignment_12833,axiom,
    ! [VarCurr: state_type] :
      ( v25119(VarCurr)
    <=> v25121(VarCurr) ) ).

tff(addAssignment_12832,axiom,
    ! [VarCurr: state_type] :
      ( v25121(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_12831,axiom,
    ! [VarCurr: state_type] :
      ( v25095(VarCurr)
    <=> v25097(VarCurr) ) ).

tff(addAssignment_12830,axiom,
    ! [VarCurr: state_type] :
      ( v25097(VarCurr)
    <=> v9490(VarCurr,10) ) ).

tff(addAssignment_12829,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,10)
    <=> v9492(VarCurr,10) ) ).

tff(addAssignment_12828,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,10)
    <=> v9494(VarCurr,10) ) ).

tff(addAssignment_12827,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,10)
    <=> v9570(VarCurr,10) ) ).

tff(addAssignment_12826,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,10)
    <=> v9513(VarCurr,10) ) ).

tff(addAssignment_12825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25091(VarCurr,B)
      <=> v25093(VarCurr,B) ) ) ).

tff(addAssignment_12824,axiom,
    ! [VarCurr: state_type] :
      ( ( v25093(VarCurr,11)
      <=> v9208(VarCurr,131) )
      & ( v25093(VarCurr,10)
      <=> v9208(VarCurr,130) )
      & ( v25093(VarCurr,9)
      <=> v9208(VarCurr,129) )
      & ( v25093(VarCurr,8)
      <=> v9208(VarCurr,128) )
      & ( v25093(VarCurr,7)
      <=> v9208(VarCurr,127) )
      & ( v25093(VarCurr,6)
      <=> v9208(VarCurr,126) )
      & ( v25093(VarCurr,5)
      <=> v9208(VarCurr,125) )
      & ( v25093(VarCurr,4)
      <=> v9208(VarCurr,124) )
      & ( v25093(VarCurr,3)
      <=> v9208(VarCurr,123) )
      & ( v25093(VarCurr,2)
      <=> v9208(VarCurr,122) )
      & ( v25093(VarCurr,1)
      <=> v9208(VarCurr,121) )
      & ( v25093(VarCurr,0)
      <=> v9208(VarCurr,120) ) ) ).

tff(addAssignment_12823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v25059(VarCurr,B)
      <=> v25061(VarCurr,B) ) ) ).

tff(addAssignment_12822,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,0)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12821,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,1)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12820,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,2)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12819,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,3)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12818,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,4)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12817,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,5)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12816,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,6)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12815,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,7)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12814,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,8)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12813,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,9)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12812,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,10)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12811,axiom,
    ! [VarCurr: state_type] :
      ( v25061(VarCurr,11)
    <=> v25079(VarCurr) ) ).

tff(addAssignment_12810,axiom,
    ! [VarCurr: state_type] :
      ( v25079(VarCurr)
    <=> v25063(VarCurr) ) ).

tff(addAssignment_12809,axiom,
    ! [VarCurr: state_type] :
      ( v25063(VarCurr)
    <=> v25065(VarCurr,0) ) ).

tff(addAssignment_12808,axiom,
    ! [VarCurr: state_type] :
      ( v25065(VarCurr,0)
    <=> v25067(VarCurr,0) ) ).

tff(addAssignment_12807,axiom,
    ! [VarCurr: state_type] :
      ( v25067(VarCurr,0)
    <=> v25077(VarCurr,0) ) ).

tff(writeUnaryOperator_1361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v25077(VarCurr,B)
      <=> ~ v25069(VarCurr,B) ) ) ).

tff(addAssignment_12806,axiom,
    ! [VarCurr: state_type] :
      ( v25069(VarCurr,0)
    <=> v25071(VarCurr,0) ) ).

tff(addAssignment_12805,axiom,
    ! [VarCurr: state_type] :
      ( v25071(VarCurr,0)
    <=> v25074(VarCurr,0) ) ).

tff(addAssignment_12804,axiom,
    ! [VarCurr: state_type] :
      ( v25074(VarCurr,0)
    <=> v25073(VarCurr) ) ).

tff(addAssignment_12803,axiom,
    ! [VarCurr: state_type] :
      ( v25074(VarCurr,1)
    <=> v25076(VarCurr) ) ).

tff(addAssignment_12802,axiom,
    ! [VarCurr: state_type] :
      ( v25074(VarCurr,2)
    <=> v25075(VarCurr) ) ).

tff(addAssignment_12801,axiom,
    ! [VarCurr: state_type] :
      ( v25073(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_12800,axiom,
    ! [VarCurr: state_type] :
      ( v25035(VarCurr)
    <=> v25037(VarCurr) ) ).

tff(addAssignment_12799,axiom,
    ! [VarCurr: state_type] :
      ( v25037(VarCurr)
    <=> v25039(VarCurr) ) ).

tff(addAssignment_12798,axiom,
    ! [VarCurr: state_type] :
      ( v25039(VarCurr)
    <=> v25041(VarCurr) ) ).

tff(addAssignment_12797,axiom,
    ! [VarCurr: state_type] :
      ( v25041(VarCurr)
    <=> v25043(VarCurr) ) ).

tff(addAssignment_12796,axiom,
    ! [VarCurr: state_type] :
      ( v25043(VarCurr)
    <=> v25045(VarCurr) ) ).

tff(addAssignment_12795,axiom,
    ! [VarCurr: state_type] :
      ( v25045(VarCurr)
    <=> v25047(VarCurr) ) ).

tff(addAssignment_12794,axiom,
    ! [VarCurr: state_type] :
      ( v25047(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_12793,axiom,
    ! [VarCurr: state_type] :
      ( v25021(VarCurr)
    <=> v25023(VarCurr) ) ).

tff(addAssignment_12792,axiom,
    ! [VarCurr: state_type] :
      ( v25023(VarCurr)
    <=> v25025(VarCurr) ) ).

tff(addAssignment_12791,axiom,
    ! [VarCurr: state_type] :
      ( v25025(VarCurr)
    <=> v25027(VarCurr) ) ).

tff(addAssignment_12790,axiom,
    ! [VarCurr: state_type] :
      ( v25027(VarCurr)
    <=> v25029(VarCurr) ) ).

tff(addAssignment_12789,axiom,
    ! [VarCurr: state_type] :
      ( v25029(VarCurr)
    <=> v25031(VarCurr) ) ).

tff(addAssignment_12788,axiom,
    ! [VarCurr: state_type] :
      ( v25031(VarCurr)
    <=> v25033(VarCurr) ) ).

tff(addAssignment_12787,axiom,
    ! [VarCurr: state_type] :
      ( v25033(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_12786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24997(VarCurr,B)
      <=> v24999(VarCurr,B) ) ) ).

tff(addAssignment_12785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24999(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_12784,axiom,
    ! [VarCurr: state_type] :
      ( v23441(VarCurr)
    <=> v23443(VarCurr) ) ).

tff(addAssignment_12783,axiom,
    ! [VarCurr: state_type] :
      ( v23443(VarCurr)
    <=> v23445(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_95,axiom,
    ! [VarCurr: state_type] :
      ( v23445(VarCurr)
    <=> ( ( v23447(VarCurr,11)
        <=> v23451(VarCurr,11) )
        & ( v23447(VarCurr,10)
        <=> v23451(VarCurr,10) )
        & ( v23447(VarCurr,9)
        <=> v23451(VarCurr,9) )
        & ( v23447(VarCurr,8)
        <=> v23451(VarCurr,8) )
        & ( v23447(VarCurr,7)
        <=> v23451(VarCurr,7) )
        & ( v23447(VarCurr,6)
        <=> v23451(VarCurr,6) )
        & ( v23447(VarCurr,5)
        <=> v23451(VarCurr,5) )
        & ( v23447(VarCurr,4)
        <=> v23451(VarCurr,4) )
        & ( v23447(VarCurr,3)
        <=> v23451(VarCurr,3) )
        & ( v23447(VarCurr,2)
        <=> v23451(VarCurr,2) )
        & ( v23447(VarCurr,1)
        <=> v23451(VarCurr,1) )
        & ( v23447(VarCurr,0)
        <=> v23451(VarCurr,0) ) ) ) ).

tff(addAssignment_12782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23451(VarCurr,B)
      <=> v23453(VarCurr,B) ) ) ).

tff(addAssignment_12781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23453(VarCurr,B)
      <=> v23455(VarCurr,B) ) ) ).

tff(addAssignment_12780,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23455(VarCurr,B)
      <=> v23457(VarCurr,B) ) ) ).

tff(addAssignment_12779,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23457(VarCurr,B)
      <=> v23459(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23459(VarCurr,B)
      <=> ( v24967(VarCurr,B)
          | v24986(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24986(VarCurr,B)
      <=> ( v24838(VarCurr,B)
          & v24987(VarCurr,B) ) ) ) ).

tff(addAssignment_12778,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,0)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12777,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,1)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12776,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,2)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12775,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,3)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12774,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,4)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12773,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,5)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12772,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,6)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12771,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,7)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12770,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,8)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12769,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,9)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12768,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,10)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12767,axiom,
    ! [VarCurr: state_type] :
      ( v24987(VarCurr,11)
    <=> v24988(VarCurr) ) ).

tff(addAssignment_12766,axiom,
    ! [VarCurr: state_type] :
      ( v24988(VarCurr)
    <=> v24957(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24967(VarCurr,B)
      <=> ( v24968(VarCurr,B)
          | v24983(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24983(VarCurr,B)
      <=> ( v24687(VarCurr,B)
          & v24984(VarCurr,B) ) ) ) ).

tff(addAssignment_12765,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,0)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12764,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,1)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12763,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,2)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12762,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,3)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12761,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,4)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12760,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,5)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12759,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,6)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12758,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,7)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12757,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,8)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12756,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,9)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12755,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,10)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12754,axiom,
    ! [VarCurr: state_type] :
      ( v24984(VarCurr,11)
    <=> v24985(VarCurr) ) ).

tff(addAssignment_12753,axiom,
    ! [VarCurr: state_type] :
      ( v24985(VarCurr)
    <=> v24807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24968(VarCurr,B)
      <=> ( v24969(VarCurr,B)
          | v24980(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24980(VarCurr,B)
      <=> ( v24536(VarCurr,B)
          & v24981(VarCurr,B) ) ) ) ).

tff(addAssignment_12752,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,0)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12751,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,1)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12750,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,2)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12749,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,3)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12748,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,4)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12747,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,5)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12746,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,6)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12745,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,7)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12744,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,8)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12743,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,9)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12742,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,10)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12741,axiom,
    ! [VarCurr: state_type] :
      ( v24981(VarCurr,11)
    <=> v24982(VarCurr) ) ).

tff(addAssignment_12740,axiom,
    ! [VarCurr: state_type] :
      ( v24982(VarCurr)
    <=> v24656(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24969(VarCurr,B)
      <=> ( v24970(VarCurr,B)
          | v24977(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24977(VarCurr,B)
      <=> ( v24385(VarCurr,B)
          & v24978(VarCurr,B) ) ) ) ).

tff(addAssignment_12739,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,0)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12738,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,1)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12737,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,2)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12736,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,3)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12735,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,4)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12734,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,5)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12733,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,6)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12732,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,7)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12731,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,8)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12730,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,9)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12729,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,10)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12728,axiom,
    ! [VarCurr: state_type] :
      ( v24978(VarCurr,11)
    <=> v24979(VarCurr) ) ).

tff(addAssignment_12727,axiom,
    ! [VarCurr: state_type] :
      ( v24979(VarCurr)
    <=> v24505(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_410,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24970(VarCurr,B)
      <=> ( v24971(VarCurr,B)
          | v24974(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_409,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24974(VarCurr,B)
      <=> ( v24223(VarCurr,B)
          & v24975(VarCurr,B) ) ) ) ).

tff(addAssignment_12726,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,0)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12725,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,1)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12724,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,2)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12723,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,3)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12722,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,4)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12721,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,5)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12720,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,6)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12719,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,7)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12718,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,8)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12717,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,9)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12716,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,10)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12715,axiom,
    ! [VarCurr: state_type] :
      ( v24975(VarCurr,11)
    <=> v24976(VarCurr) ) ).

tff(addAssignment_12714,axiom,
    ! [VarCurr: state_type] :
      ( v24976(VarCurr)
    <=> v24354(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_408,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24971(VarCurr,B)
      <=> ( v23461(VarCurr,B)
          & v24972(VarCurr,B) ) ) ) ).

tff(addAssignment_12713,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,0)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12712,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,1)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12711,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,2)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12710,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,3)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12709,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,4)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12708,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,5)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12707,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,6)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12706,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,7)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12705,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,8)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12704,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,9)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12703,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,10)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12702,axiom,
    ! [VarCurr: state_type] :
      ( v24972(VarCurr,11)
    <=> v24973(VarCurr) ) ).

tff(addAssignment_12701,axiom,
    ! [VarCurr: state_type] :
      ( v24973(VarCurr)
    <=> v23931(VarCurr) ) ).

tff(addAssignment_12700,axiom,
    ! [VarCurr: state_type] :
      ( v24957(VarCurr)
    <=> v24959(VarCurr) ) ).

tff(addAssignment_12699,axiom,
    ! [VarCurr: state_type] :
      ( v24959(VarCurr)
    <=> v24961(VarCurr) ) ).

tff(addAssignment_12698,axiom,
    ! [VarCurr: state_type] :
      ( v24961(VarCurr)
    <=> v24963(VarCurr) ) ).

tff(addAssignment_12697,axiom,
    ! [VarCurr: state_type] :
      ( v24963(VarCurr)
    <=> v24965(VarCurr) ) ).

tff(addAssignment_12696,axiom,
    ! [VarCurr: state_type] :
      ( v24965(VarCurr)
    <=> v24024(VarCurr) ) ).

tff(addAssignment_12695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24838(VarCurr,B)
      <=> v24840(VarCurr,B) ) ) ).

tff(addAssignment_12694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24840(VarCurr,B)
      <=> v24842(VarCurr,B) ) ) ).

tff(addAssignment_12693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24842(VarCurr,B)
      <=> v24844(VarCurr,B) ) ) ).

tff(addAssignment_12692,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24844(VarCurr,B)
      <=> v24846(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_282,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24940(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v24846(VarNext,B)
            <=> v24846(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_282,axiom,
    ! [VarNext: state_type] :
      ( v24940(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24846(VarNext,B)
          <=> v24950(VarNext,B) ) ) ) ).

tff(addAssignment_12691,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24950(VarNext,B)
          <=> v24948(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24948(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_175,axiom,
    ! [VarCurr: state_type] :
      ( v24951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24948(VarCurr,B)
          <=> v24868(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2051,axiom,
    ! [VarCurr: state_type] :
      ( v24951(VarCurr)
    <=> ( v24952(VarCurr)
        & v24953(VarCurr) ) ) ).

tff(writeUnaryOperator_1360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24953(VarCurr)
    <=> v24858(VarCurr) ) ).

tff(writeUnaryOperator_1359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24952(VarCurr)
    <=> v24848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2050,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24940(VarNext)
      <=> v24941(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2049,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24941(VarNext)
      <=> ( v24942(VarNext)
          & v24872(VarNext) ) ) ) ).

tff(writeUnaryOperator_1358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24942(VarNext)
      <=> v24944(VarNext) ) ) ).

tff(addAssignment_12690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24944(VarNext)
      <=> v24872(VarCurr) ) ) ).

tff(addAssignment_12689,axiom,
    ! [VarCurr: state_type] :
      ( v24872(VarCurr)
    <=> v24874(VarCurr) ) ).

tff(addAssignment_12688,axiom,
    ! [VarCurr: state_type] :
      ( v24874(VarCurr)
    <=> v24876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2048,axiom,
    ! [VarCurr: state_type] :
      ( v24876(VarCurr)
    <=> ( v24937(VarCurr)
        | v24933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2047,axiom,
    ! [VarCurr: state_type] :
      ( v24937(VarCurr)
    <=> ( v24878(VarCurr)
        & v24882(VarCurr) ) ) ).

tff(addAssignment_12687,axiom,
    ! [VarCurr: state_type] :
      ( v24933(VarCurr)
    <=> v24935(VarCurr) ) ).

tff(addAssignment_12686,axiom,
    ! [VarCurr: state_type] :
      ( v24935(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24917(VarNext)
       => ( v24882(VarNext)
        <=> v24882(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_281,axiom,
    ! [VarNext: state_type] :
      ( v24917(VarNext)
     => ( v24882(VarNext)
      <=> v24927(VarNext) ) ) ).

tff(addAssignment_12685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24927(VarNext)
      <=> v24925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2046,axiom,
    ! [VarCurr: state_type] :
      ( v24925(VarCurr)
    <=> ( v24928(VarCurr)
        & v24929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2045,axiom,
    ! [VarCurr: state_type] :
      ( v24929(VarCurr)
    <=> ( v24888(VarCurr)
        | v24912(VarCurr) ) ) ).

tff(writeUnaryOperator_1357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24928(VarCurr)
    <=> v24884(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2044,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24917(VarNext)
      <=> v24918(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24918(VarNext)
      <=> ( v24920(VarNext)
          & v24922(VarNext) ) ) ) ).

tff(writeUnaryOperator_1356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24922(VarCurr)
    <=> v24878(VarCurr) ) ).

tff(addAssignment_12684,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24920(VarNext)
      <=> v24878(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_104,axiom,
    ( v24882(constB0)
  <=> $true ) ).

tff(addAssignment_12683,axiom,
    ! [VarCurr: state_type] :
      ( v24912(VarCurr)
    <=> v24914(VarCurr) ) ).

tff(addAssignment_12682,axiom,
    ! [VarCurr: state_type] :
      ( v24914(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12681,axiom,
    ! [VarCurr: state_type] :
      ( v24888(VarCurr)
    <=> v24890(VarCurr) ) ).

tff(addAssignment_12680,axiom,
    ! [VarCurr: state_type] :
      ( v24890(VarCurr)
    <=> v24198(VarCurr) ) ).

tff(addAssignment_12679,axiom,
    ! [VarCurr: state_type] :
      ( v24198(VarCurr)
    <=> v24893(VarCurr) ) ).

tff(addAssignment_12678,axiom,
    ! [VarCurr: state_type] :
      ( v24893(VarCurr)
    <=> v24895(VarCurr) ) ).

tff(writeUnaryOperator_1355,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24895(VarCurr)
    <=> v24909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2042,axiom,
    ! [VarCurr: state_type] :
      ( v24909(VarCurr)
    <=> ( v24910(VarCurr)
        | v24905(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2041,axiom,
    ! [VarCurr: state_type] :
      ( v24910(VarCurr)
    <=> ( v24897(VarCurr)
        | v24901(VarCurr) ) ) ).

tff(addAssignment_12677,axiom,
    ! [VarCurr: state_type] :
      ( v24905(VarCurr)
    <=> v24907(VarCurr) ) ).

tff(addAssignment_12676,axiom,
    ! [VarCurr: state_type] :
      ( v24907(VarCurr)
    <=> v24287(VarCurr,2) ) ).

tff(addAssignment_12675,axiom,
    ! [VarCurr: state_type] :
      ( v24901(VarCurr)
    <=> v24903(VarCurr) ) ).

tff(addAssignment_12674,axiom,
    ! [VarCurr: state_type] :
      ( v24903(VarCurr)
    <=> v23861(VarCurr,1) ) ).

tff(addAssignment_12673,axiom,
    ! [VarCurr: state_type] :
      ( v24897(VarCurr)
    <=> v24899(VarCurr) ) ).

tff(addAssignment_12672,axiom,
    ! [VarCurr: state_type] :
      ( v24899(VarCurr)
    <=> v24287(VarCurr,0) ) ).

tff(addAssignment_12671,axiom,
    ! [VarCurr: state_type] :
      ( v24884(VarCurr)
    <=> v24886(VarCurr) ) ).

tff(addAssignment_12670,axiom,
    ! [VarCurr: state_type] :
      ( v24886(VarCurr)
    <=> $false ) ).

tff(addAssignment_12669,axiom,
    ! [VarCurr: state_type] :
      ( v24878(VarCurr)
    <=> v24880(VarCurr) ) ).

tff(addAssignment_12668,axiom,
    ! [VarCurr: state_type] :
      ( v24880(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12667,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24868(VarCurr,B)
      <=> v24870(VarCurr,B) ) ) ).

tff(addAssignment_12666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24870(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12665,axiom,
    ! [VarCurr: state_type] :
      ( v24858(VarCurr)
    <=> v24860(VarCurr) ) ).

tff(addAssignment_12664,axiom,
    ! [VarCurr: state_type] :
      ( v24860(VarCurr)
    <=> v24862(VarCurr) ) ).

tff(addAssignment_12663,axiom,
    ! [VarCurr: state_type] :
      ( v24862(VarCurr)
    <=> v24864(VarCurr) ) ).

tff(addAssignment_12662,axiom,
    ! [VarCurr: state_type] :
      ( v24864(VarCurr)
    <=> v24866(VarCurr) ) ).

tff(addAssignment_12661,axiom,
    ! [VarCurr: state_type] :
      ( v24866(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12660,axiom,
    ! [VarCurr: state_type] :
      ( v24848(VarCurr)
    <=> v24850(VarCurr) ) ).

tff(addAssignment_12659,axiom,
    ! [VarCurr: state_type] :
      ( v24850(VarCurr)
    <=> v24852(VarCurr) ) ).

tff(addAssignment_12658,axiom,
    ! [VarCurr: state_type] :
      ( v24852(VarCurr)
    <=> v24854(VarCurr) ) ).

tff(addAssignment_12657,axiom,
    ! [VarCurr: state_type] :
      ( v24854(VarCurr)
    <=> v24856(VarCurr) ) ).

tff(addAssignment_12656,axiom,
    ! [VarCurr: state_type] :
      ( v24856(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_12655,axiom,
    ! [VarCurr: state_type] :
      ( v24807(VarCurr)
    <=> v24809(VarCurr) ) ).

tff(addAssignment_12654,axiom,
    ! [VarCurr: state_type] :
      ( v24809(VarCurr)
    <=> v24811(VarCurr) ) ).

tff(addAssignment_12653,axiom,
    ! [VarCurr: state_type] :
      ( v24811(VarCurr)
    <=> v24813(VarCurr) ) ).

tff(addAssignment_12652,axiom,
    ! [VarCurr: state_type] :
      ( v24813(VarCurr)
    <=> v24815(VarCurr) ) ).

tff(addAssignment_12651,axiom,
    ! [VarCurr: state_type] :
      ( v24815(VarCurr)
    <=> v24817(VarCurr) ) ).

tff(addAssignment_12650,axiom,
    ! [VarCurr: state_type] :
      ( v24817(VarCurr)
    <=> v24819(VarCurr) ) ).

tff(addAssignment_12649,axiom,
    ! [VarCurr: state_type] :
      ( v24819(VarCurr)
    <=> v24821(VarCurr) ) ).

tff(writeUnaryOperator_1354,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24821(VarCurr)
    <=> v24835(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2040,axiom,
    ! [VarCurr: state_type] :
      ( v24835(VarCurr)
    <=> ( v24836(VarCurr)
        | v24831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2039,axiom,
    ! [VarCurr: state_type] :
      ( v24836(VarCurr)
    <=> ( v24823(VarCurr)
        | v24827(VarCurr) ) ) ).

tff(addAssignment_12648,axiom,
    ! [VarCurr: state_type] :
      ( v24831(VarCurr)
    <=> v24833(VarCurr) ) ).

tff(addAssignment_12647,axiom,
    ! [VarCurr: state_type] :
      ( v24833(VarCurr)
    <=> v24034(VarCurr,2) ) ).

tff(addAssignment_12646,axiom,
    ! [VarCurr: state_type] :
      ( v24827(VarCurr)
    <=> v24829(VarCurr) ) ).

tff(addAssignment_12645,axiom,
    ! [VarCurr: state_type] :
      ( v24829(VarCurr)
    <=> v23951(VarCurr,1) ) ).

tff(addAssignment_12644,axiom,
    ! [VarCurr: state_type] :
      ( v24823(VarCurr)
    <=> v24825(VarCurr) ) ).

tff(addAssignment_12643,axiom,
    ! [VarCurr: state_type] :
      ( v24825(VarCurr)
    <=> v23951(VarCurr,0) ) ).

tff(addAssignment_12642,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24687(VarCurr,B)
      <=> v24689(VarCurr,B) ) ) ).

tff(addAssignment_12641,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24689(VarCurr,B)
      <=> v24691(VarCurr,B) ) ) ).

tff(addAssignment_12640,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24691(VarCurr,B)
      <=> v24693(VarCurr,B) ) ) ).

tff(addAssignment_12639,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24693(VarCurr,B)
      <=> v24695(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24790(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v24695(VarNext,B)
            <=> v24695(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_280,axiom,
    ! [VarNext: state_type] :
      ( v24790(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24695(VarNext,B)
          <=> v24800(VarNext,B) ) ) ) ).

tff(addAssignment_12638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24800(VarNext,B)
          <=> v24798(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_174,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24801(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24798(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_174,axiom,
    ! [VarCurr: state_type] :
      ( v24801(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24798(VarCurr,B)
          <=> v24717(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2038,axiom,
    ! [VarCurr: state_type] :
      ( v24801(VarCurr)
    <=> ( v24802(VarCurr)
        & v24803(VarCurr) ) ) ).

tff(writeUnaryOperator_1353,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24803(VarCurr)
    <=> v24707(VarCurr) ) ).

tff(writeUnaryOperator_1352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24802(VarCurr)
    <=> v24697(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24790(VarNext)
      <=> v24791(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24791(VarNext)
      <=> ( v24792(VarNext)
          & v24721(VarNext) ) ) ) ).

tff(writeUnaryOperator_1351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24792(VarNext)
      <=> v24794(VarNext) ) ) ).

tff(addAssignment_12637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24794(VarNext)
      <=> v24721(VarCurr) ) ) ).

tff(addAssignment_12636,axiom,
    ! [VarCurr: state_type] :
      ( v24721(VarCurr)
    <=> v24723(VarCurr) ) ).

tff(addAssignment_12635,axiom,
    ! [VarCurr: state_type] :
      ( v24723(VarCurr)
    <=> v24725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2035,axiom,
    ! [VarCurr: state_type] :
      ( v24725(VarCurr)
    <=> ( v24787(VarCurr)
        | v24783(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2034,axiom,
    ! [VarCurr: state_type] :
      ( v24787(VarCurr)
    <=> ( v24727(VarCurr)
        & v24731(VarCurr) ) ) ).

tff(addAssignment_12634,axiom,
    ! [VarCurr: state_type] :
      ( v24783(VarCurr)
    <=> v24785(VarCurr) ) ).

tff(addAssignment_12633,axiom,
    ! [VarCurr: state_type] :
      ( v24785(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24767(VarNext)
       => ( v24731(VarNext)
        <=> v24731(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_279,axiom,
    ! [VarNext: state_type] :
      ( v24767(VarNext)
     => ( v24731(VarNext)
      <=> v24777(VarNext) ) ) ).

tff(addAssignment_12632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24777(VarNext)
      <=> v24775(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2033,axiom,
    ! [VarCurr: state_type] :
      ( v24775(VarCurr)
    <=> ( v24778(VarCurr)
        & v24779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2032,axiom,
    ! [VarCurr: state_type] :
      ( v24779(VarCurr)
    <=> ( v24737(VarCurr)
        | v24762(VarCurr) ) ) ).

tff(writeUnaryOperator_1350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24778(VarCurr)
    <=> v24733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2031,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24767(VarNext)
      <=> v24768(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2030,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24768(VarNext)
      <=> ( v24770(VarNext)
          & v24772(VarNext) ) ) ) ).

tff(writeUnaryOperator_1349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24772(VarCurr)
    <=> v24727(VarCurr) ) ).

tff(addAssignment_12631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24770(VarNext)
      <=> v24727(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_103,axiom,
    ( v24731(constB0)
  <=> $true ) ).

tff(addAssignment_12630,axiom,
    ! [VarCurr: state_type] :
      ( v24762(VarCurr)
    <=> v24764(VarCurr) ) ).

tff(addAssignment_12629,axiom,
    ! [VarCurr: state_type] :
      ( v24764(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12628,axiom,
    ! [VarCurr: state_type] :
      ( v24737(VarCurr)
    <=> v24739(VarCurr) ) ).

tff(addAssignment_12627,axiom,
    ! [VarCurr: state_type] :
      ( v24739(VarCurr)
    <=> v24741(VarCurr) ) ).

tff(addAssignment_12626,axiom,
    ! [VarCurr: state_type] :
      ( v24741(VarCurr)
    <=> v24743(VarCurr) ) ).

tff(addAssignment_12625,axiom,
    ! [VarCurr: state_type] :
      ( v24743(VarCurr)
    <=> v24745(VarCurr) ) ).

tff(writeUnaryOperator_1348,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24745(VarCurr)
    <=> v24759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2029,axiom,
    ! [VarCurr: state_type] :
      ( v24759(VarCurr)
    <=> ( v24760(VarCurr)
        | v24755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2028,axiom,
    ! [VarCurr: state_type] :
      ( v24760(VarCurr)
    <=> ( v24747(VarCurr)
        | v24751(VarCurr) ) ) ).

tff(addAssignment_12624,axiom,
    ! [VarCurr: state_type] :
      ( v24755(VarCurr)
    <=> v24757(VarCurr) ) ).

tff(addAssignment_12623,axiom,
    ! [VarCurr: state_type] :
      ( v24757(VarCurr)
    <=> v24287(VarCurr,2) ) ).

tff(addAssignment_12622,axiom,
    ! [VarCurr: state_type] :
      ( v24287(VarCurr,2)
    <=> v24289(VarCurr,2) ) ).

tff(addAssignment_12621,axiom,
    ! [VarCurr: state_type] :
      ( v24289(VarCurr,2)
    <=> v24291(VarCurr,2) ) ).

tff(addAssignment_12620,axiom,
    ! [VarCurr: state_type] :
      ( v24291(VarCurr,2)
    <=> v24296(VarCurr,2) ) ).

tff(addAssignment_12619,axiom,
    ! [VarCurr: state_type] :
      ( v24293(VarCurr,2)
    <=> v24295(VarCurr,2) ) ).

tff(addAssignment_12618,axiom,
    ! [VarCurr: state_type] :
      ( v24295(VarCurr,2)
    <=> v23861(VarCurr,2) ) ).

tff(addAssignment_12617,axiom,
    ! [VarCurr: state_type] :
      ( v24751(VarCurr)
    <=> v24753(VarCurr) ) ).

tff(addAssignment_12616,axiom,
    ! [VarCurr: state_type] :
      ( v24753(VarCurr)
    <=> v23861(VarCurr,1) ) ).

tff(addAssignment_12615,axiom,
    ! [VarCurr: state_type] :
      ( v24747(VarCurr)
    <=> v24749(VarCurr) ) ).

tff(addAssignment_12614,axiom,
    ! [VarCurr: state_type] :
      ( v24749(VarCurr)
    <=> v23861(VarCurr,0) ) ).

tff(addAssignment_12613,axiom,
    ! [VarCurr: state_type] :
      ( v24733(VarCurr)
    <=> v24735(VarCurr) ) ).

tff(addAssignment_12612,axiom,
    ! [VarCurr: state_type] :
      ( v24735(VarCurr)
    <=> $false ) ).

tff(addAssignment_12611,axiom,
    ! [VarCurr: state_type] :
      ( v24727(VarCurr)
    <=> v24729(VarCurr) ) ).

tff(addAssignment_12610,axiom,
    ! [VarCurr: state_type] :
      ( v24729(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24717(VarCurr,B)
      <=> v24719(VarCurr,B) ) ) ).

tff(addAssignment_12608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24719(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12607,axiom,
    ! [VarCurr: state_type] :
      ( v24707(VarCurr)
    <=> v24709(VarCurr) ) ).

tff(addAssignment_12606,axiom,
    ! [VarCurr: state_type] :
      ( v24709(VarCurr)
    <=> v24711(VarCurr) ) ).

tff(addAssignment_12605,axiom,
    ! [VarCurr: state_type] :
      ( v24711(VarCurr)
    <=> v24713(VarCurr) ) ).

tff(addAssignment_12604,axiom,
    ! [VarCurr: state_type] :
      ( v24713(VarCurr)
    <=> v24715(VarCurr) ) ).

tff(addAssignment_12603,axiom,
    ! [VarCurr: state_type] :
      ( v24715(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12602,axiom,
    ! [VarCurr: state_type] :
      ( v24697(VarCurr)
    <=> v24699(VarCurr) ) ).

tff(addAssignment_12601,axiom,
    ! [VarCurr: state_type] :
      ( v24699(VarCurr)
    <=> v24701(VarCurr) ) ).

tff(addAssignment_12600,axiom,
    ! [VarCurr: state_type] :
      ( v24701(VarCurr)
    <=> v24703(VarCurr) ) ).

tff(addAssignment_12599,axiom,
    ! [VarCurr: state_type] :
      ( v24703(VarCurr)
    <=> v24705(VarCurr) ) ).

tff(addAssignment_12598,axiom,
    ! [VarCurr: state_type] :
      ( v24705(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_12597,axiom,
    ! [VarCurr: state_type] :
      ( v24656(VarCurr)
    <=> v24658(VarCurr) ) ).

tff(addAssignment_12596,axiom,
    ! [VarCurr: state_type] :
      ( v24658(VarCurr)
    <=> v24660(VarCurr) ) ).

tff(addAssignment_12595,axiom,
    ! [VarCurr: state_type] :
      ( v24660(VarCurr)
    <=> v24662(VarCurr) ) ).

tff(addAssignment_12594,axiom,
    ! [VarCurr: state_type] :
      ( v24662(VarCurr)
    <=> v24664(VarCurr) ) ).

tff(addAssignment_12593,axiom,
    ! [VarCurr: state_type] :
      ( v24664(VarCurr)
    <=> v24666(VarCurr) ) ).

tff(addAssignment_12592,axiom,
    ! [VarCurr: state_type] :
      ( v24666(VarCurr)
    <=> v24668(VarCurr) ) ).

tff(addAssignment_12591,axiom,
    ! [VarCurr: state_type] :
      ( v24668(VarCurr)
    <=> v24670(VarCurr) ) ).

tff(writeUnaryOperator_1347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24670(VarCurr)
    <=> v24684(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2027,axiom,
    ! [VarCurr: state_type] :
      ( v24684(VarCurr)
    <=> ( v24685(VarCurr)
        | v24680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2026,axiom,
    ! [VarCurr: state_type] :
      ( v24685(VarCurr)
    <=> ( v24672(VarCurr)
        | v24676(VarCurr) ) ) ).

tff(addAssignment_12590,axiom,
    ! [VarCurr: state_type] :
      ( v24680(VarCurr)
    <=> v24682(VarCurr) ) ).

tff(addAssignment_12589,axiom,
    ! [VarCurr: state_type] :
      ( v24682(VarCurr)
    <=> v23951(VarCurr,2) ) ).

tff(addAssignment_12588,axiom,
    ! [VarCurr: state_type] :
      ( v24676(VarCurr)
    <=> v24678(VarCurr) ) ).

tff(addAssignment_12587,axiom,
    ! [VarCurr: state_type] :
      ( v24678(VarCurr)
    <=> v24034(VarCurr,1) ) ).

tff(addAssignment_12586,axiom,
    ! [VarCurr: state_type] :
      ( v24672(VarCurr)
    <=> v24674(VarCurr) ) ).

tff(addAssignment_12585,axiom,
    ! [VarCurr: state_type] :
      ( v24674(VarCurr)
    <=> v24034(VarCurr,0) ) ).

tff(addAssignment_12584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24536(VarCurr,B)
      <=> v24538(VarCurr,B) ) ) ).

tff(addAssignment_12583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24538(VarCurr,B)
      <=> v24540(VarCurr,B) ) ) ).

tff(addAssignment_12582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24540(VarCurr,B)
      <=> v24542(VarCurr,B) ) ) ).

tff(addAssignment_12581,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24542(VarCurr,B)
      <=> v24544(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_278,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24639(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v24544(VarNext,B)
            <=> v24544(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_278,axiom,
    ! [VarNext: state_type] :
      ( v24639(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24544(VarNext,B)
          <=> v24649(VarNext,B) ) ) ) ).

tff(addAssignment_12580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24649(VarNext,B)
          <=> v24647(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24650(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24647(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_173,axiom,
    ! [VarCurr: state_type] :
      ( v24650(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24647(VarCurr,B)
          <=> v24566(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2025,axiom,
    ! [VarCurr: state_type] :
      ( v24650(VarCurr)
    <=> ( v24651(VarCurr)
        & v24652(VarCurr) ) ) ).

tff(writeUnaryOperator_1346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24652(VarCurr)
    <=> v24556(VarCurr) ) ).

tff(writeUnaryOperator_1345,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24651(VarCurr)
    <=> v24546(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24639(VarNext)
      <=> v24640(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24640(VarNext)
      <=> ( v24641(VarNext)
          & v24570(VarNext) ) ) ) ).

tff(writeUnaryOperator_1344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24641(VarNext)
      <=> v24643(VarNext) ) ) ).

tff(addAssignment_12579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24643(VarNext)
      <=> v24570(VarCurr) ) ) ).

tff(addAssignment_12578,axiom,
    ! [VarCurr: state_type] :
      ( v24570(VarCurr)
    <=> v24572(VarCurr) ) ).

tff(addAssignment_12577,axiom,
    ! [VarCurr: state_type] :
      ( v24572(VarCurr)
    <=> v24574(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2022,axiom,
    ! [VarCurr: state_type] :
      ( v24574(VarCurr)
    <=> ( v24636(VarCurr)
        | v24632(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2021,axiom,
    ! [VarCurr: state_type] :
      ( v24636(VarCurr)
    <=> ( v24576(VarCurr)
        & v24580(VarCurr) ) ) ).

tff(addAssignment_12576,axiom,
    ! [VarCurr: state_type] :
      ( v24632(VarCurr)
    <=> v24634(VarCurr) ) ).

tff(addAssignment_12575,axiom,
    ! [VarCurr: state_type] :
      ( v24634(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24616(VarNext)
       => ( v24580(VarNext)
        <=> v24580(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_277,axiom,
    ! [VarNext: state_type] :
      ( v24616(VarNext)
     => ( v24580(VarNext)
      <=> v24626(VarNext) ) ) ).

tff(addAssignment_12574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24626(VarNext)
      <=> v24624(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2020,axiom,
    ! [VarCurr: state_type] :
      ( v24624(VarCurr)
    <=> ( v24627(VarCurr)
        & v24628(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2019,axiom,
    ! [VarCurr: state_type] :
      ( v24628(VarCurr)
    <=> ( v24586(VarCurr)
        | v24611(VarCurr) ) ) ).

tff(writeUnaryOperator_1343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24627(VarCurr)
    <=> v24582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24616(VarNext)
      <=> v24617(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24617(VarNext)
      <=> ( v24619(VarNext)
          & v24621(VarNext) ) ) ) ).

tff(writeUnaryOperator_1342,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24621(VarCurr)
    <=> v24576(VarCurr) ) ).

tff(addAssignment_12573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24619(VarNext)
      <=> v24576(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_102,axiom,
    ( v24580(constB0)
  <=> $true ) ).

tff(addAssignment_12572,axiom,
    ! [VarCurr: state_type] :
      ( v24611(VarCurr)
    <=> v24613(VarCurr) ) ).

tff(addAssignment_12571,axiom,
    ! [VarCurr: state_type] :
      ( v24613(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12570,axiom,
    ! [VarCurr: state_type] :
      ( v24586(VarCurr)
    <=> v24588(VarCurr) ) ).

tff(addAssignment_12569,axiom,
    ! [VarCurr: state_type] :
      ( v24588(VarCurr)
    <=> v24590(VarCurr) ) ).

tff(addAssignment_12568,axiom,
    ! [VarCurr: state_type] :
      ( v24590(VarCurr)
    <=> v24592(VarCurr) ) ).

tff(addAssignment_12567,axiom,
    ! [VarCurr: state_type] :
      ( v24592(VarCurr)
    <=> v24594(VarCurr) ) ).

tff(writeUnaryOperator_1341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24594(VarCurr)
    <=> v24608(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2016,axiom,
    ! [VarCurr: state_type] :
      ( v24608(VarCurr)
    <=> ( v24609(VarCurr)
        | v24604(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2015,axiom,
    ! [VarCurr: state_type] :
      ( v24609(VarCurr)
    <=> ( v24596(VarCurr)
        | v24600(VarCurr) ) ) ).

tff(addAssignment_12566,axiom,
    ! [VarCurr: state_type] :
      ( v24604(VarCurr)
    <=> v24606(VarCurr) ) ).

tff(addAssignment_12565,axiom,
    ! [VarCurr: state_type] :
      ( v24606(VarCurr)
    <=> v23861(VarCurr,2) ) ).

tff(addAssignment_12564,axiom,
    ! [VarCurr: state_type] :
      ( v24600(VarCurr)
    <=> v24602(VarCurr) ) ).

tff(addAssignment_12563,axiom,
    ! [VarCurr: state_type] :
      ( v24602(VarCurr)
    <=> v24287(VarCurr,1) ) ).

tff(addAssignment_12562,axiom,
    ! [VarCurr: state_type] :
      ( v24596(VarCurr)
    <=> v24598(VarCurr) ) ).

tff(addAssignment_12561,axiom,
    ! [VarCurr: state_type] :
      ( v24598(VarCurr)
    <=> v24287(VarCurr,0) ) ).

tff(addAssignment_12560,axiom,
    ! [VarCurr: state_type] :
      ( v24582(VarCurr)
    <=> v24584(VarCurr) ) ).

tff(addAssignment_12559,axiom,
    ! [VarCurr: state_type] :
      ( v24584(VarCurr)
    <=> $false ) ).

tff(addAssignment_12558,axiom,
    ! [VarCurr: state_type] :
      ( v24576(VarCurr)
    <=> v24578(VarCurr) ) ).

tff(addAssignment_12557,axiom,
    ! [VarCurr: state_type] :
      ( v24578(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12556,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24566(VarCurr,B)
      <=> v24568(VarCurr,B) ) ) ).

tff(addAssignment_12555,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24568(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12554,axiom,
    ! [VarCurr: state_type] :
      ( v24556(VarCurr)
    <=> v24558(VarCurr) ) ).

tff(addAssignment_12553,axiom,
    ! [VarCurr: state_type] :
      ( v24558(VarCurr)
    <=> v24560(VarCurr) ) ).

tff(addAssignment_12552,axiom,
    ! [VarCurr: state_type] :
      ( v24560(VarCurr)
    <=> v24562(VarCurr) ) ).

tff(addAssignment_12551,axiom,
    ! [VarCurr: state_type] :
      ( v24562(VarCurr)
    <=> v24564(VarCurr) ) ).

tff(addAssignment_12550,axiom,
    ! [VarCurr: state_type] :
      ( v24564(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12549,axiom,
    ! [VarCurr: state_type] :
      ( v24546(VarCurr)
    <=> v24548(VarCurr) ) ).

tff(addAssignment_12548,axiom,
    ! [VarCurr: state_type] :
      ( v24548(VarCurr)
    <=> v24550(VarCurr) ) ).

tff(addAssignment_12547,axiom,
    ! [VarCurr: state_type] :
      ( v24550(VarCurr)
    <=> v24552(VarCurr) ) ).

tff(addAssignment_12546,axiom,
    ! [VarCurr: state_type] :
      ( v24552(VarCurr)
    <=> v24554(VarCurr) ) ).

tff(addAssignment_12545,axiom,
    ! [VarCurr: state_type] :
      ( v24554(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_12544,axiom,
    ! [VarCurr: state_type] :
      ( v24505(VarCurr)
    <=> v24507(VarCurr) ) ).

tff(addAssignment_12543,axiom,
    ! [VarCurr: state_type] :
      ( v24507(VarCurr)
    <=> v24509(VarCurr) ) ).

tff(addAssignment_12542,axiom,
    ! [VarCurr: state_type] :
      ( v24509(VarCurr)
    <=> v24511(VarCurr) ) ).

tff(addAssignment_12541,axiom,
    ! [VarCurr: state_type] :
      ( v24511(VarCurr)
    <=> v24513(VarCurr) ) ).

tff(addAssignment_12540,axiom,
    ! [VarCurr: state_type] :
      ( v24513(VarCurr)
    <=> v24515(VarCurr) ) ).

tff(addAssignment_12539,axiom,
    ! [VarCurr: state_type] :
      ( v24515(VarCurr)
    <=> v24517(VarCurr) ) ).

tff(addAssignment_12538,axiom,
    ! [VarCurr: state_type] :
      ( v24517(VarCurr)
    <=> v24519(VarCurr) ) ).

tff(writeUnaryOperator_1340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24519(VarCurr)
    <=> v24533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2014,axiom,
    ! [VarCurr: state_type] :
      ( v24533(VarCurr)
    <=> ( v24534(VarCurr)
        | v24529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2013,axiom,
    ! [VarCurr: state_type] :
      ( v24534(VarCurr)
    <=> ( v24521(VarCurr)
        | v24525(VarCurr) ) ) ).

tff(addAssignment_12537,axiom,
    ! [VarCurr: state_type] :
      ( v24529(VarCurr)
    <=> v24531(VarCurr) ) ).

tff(addAssignment_12536,axiom,
    ! [VarCurr: state_type] :
      ( v24531(VarCurr)
    <=> v23951(VarCurr,2) ) ).

tff(addAssignment_12535,axiom,
    ! [VarCurr: state_type] :
      ( v24525(VarCurr)
    <=> v24527(VarCurr) ) ).

tff(addAssignment_12534,axiom,
    ! [VarCurr: state_type] :
      ( v24527(VarCurr)
    <=> v24034(VarCurr,1) ) ).

tff(addAssignment_12533,axiom,
    ! [VarCurr: state_type] :
      ( v24034(VarCurr,1)
    <=> v24036(VarCurr,1) ) ).

tff(addAssignment_12532,axiom,
    ! [VarCurr: state_type] :
      ( v24036(VarCurr,1)
    <=> v24038(VarCurr,1) ) ).

tff(addAssignment_12531,axiom,
    ! [VarCurr: state_type] :
      ( v24038(VarCurr,1)
    <=> v24043(VarCurr,1) ) ).

tff(addAssignment_12530,axiom,
    ! [VarCurr: state_type] :
      ( v24040(VarCurr,1)
    <=> v24042(VarCurr,1) ) ).

tff(addAssignment_12529,axiom,
    ! [VarCurr: state_type] :
      ( v24042(VarCurr,1)
    <=> v23951(VarCurr,1) ) ).

tff(addAssignment_12528,axiom,
    ! [VarCurr: state_type] :
      ( v24521(VarCurr)
    <=> v24523(VarCurr) ) ).

tff(addAssignment_12527,axiom,
    ! [VarCurr: state_type] :
      ( v24523(VarCurr)
    <=> v23951(VarCurr,0) ) ).

tff(addAssignment_12526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24385(VarCurr,B)
      <=> v24387(VarCurr,B) ) ) ).

tff(addAssignment_12525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24387(VarCurr,B)
      <=> v24389(VarCurr,B) ) ) ).

tff(addAssignment_12524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24389(VarCurr,B)
      <=> v24391(VarCurr,B) ) ) ).

tff(addAssignment_12523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24391(VarCurr,B)
      <=> v24393(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_276,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24488(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v24393(VarNext,B)
            <=> v24393(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_276,axiom,
    ! [VarNext: state_type] :
      ( v24488(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24393(VarNext,B)
          <=> v24498(VarNext,B) ) ) ) ).

tff(addAssignment_12522,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24498(VarNext,B)
          <=> v24496(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24499(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24496(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_172,axiom,
    ! [VarCurr: state_type] :
      ( v24499(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24496(VarCurr,B)
          <=> v24415(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2012,axiom,
    ! [VarCurr: state_type] :
      ( v24499(VarCurr)
    <=> ( v24500(VarCurr)
        & v24501(VarCurr) ) ) ).

tff(writeUnaryOperator_1339,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24501(VarCurr)
    <=> v24405(VarCurr) ) ).

tff(writeUnaryOperator_1338,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24500(VarCurr)
    <=> v24395(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2011,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24488(VarNext)
      <=> v24489(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2010,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24489(VarNext)
      <=> ( v24490(VarNext)
          & v24419(VarNext) ) ) ) ).

tff(writeUnaryOperator_1337,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24490(VarNext)
      <=> v24492(VarNext) ) ) ).

tff(addAssignment_12521,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24492(VarNext)
      <=> v24419(VarCurr) ) ) ).

tff(addAssignment_12520,axiom,
    ! [VarCurr: state_type] :
      ( v24419(VarCurr)
    <=> v24421(VarCurr) ) ).

tff(addAssignment_12519,axiom,
    ! [VarCurr: state_type] :
      ( v24421(VarCurr)
    <=> v24423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2009,axiom,
    ! [VarCurr: state_type] :
      ( v24423(VarCurr)
    <=> ( v24485(VarCurr)
        | v24481(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2008,axiom,
    ! [VarCurr: state_type] :
      ( v24485(VarCurr)
    <=> ( v24425(VarCurr)
        & v24429(VarCurr) ) ) ).

tff(addAssignment_12518,axiom,
    ! [VarCurr: state_type] :
      ( v24481(VarCurr)
    <=> v24483(VarCurr) ) ).

tff(addAssignment_12517,axiom,
    ! [VarCurr: state_type] :
      ( v24483(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_275,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24465(VarNext)
       => ( v24429(VarNext)
        <=> v24429(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_275,axiom,
    ! [VarNext: state_type] :
      ( v24465(VarNext)
     => ( v24429(VarNext)
      <=> v24475(VarNext) ) ) ).

tff(addAssignment_12516,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24475(VarNext)
      <=> v24473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2007,axiom,
    ! [VarCurr: state_type] :
      ( v24473(VarCurr)
    <=> ( v24476(VarCurr)
        & v24477(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2006,axiom,
    ! [VarCurr: state_type] :
      ( v24477(VarCurr)
    <=> ( v24435(VarCurr)
        | v24460(VarCurr) ) ) ).

tff(writeUnaryOperator_1336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24476(VarCurr)
    <=> v24431(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24465(VarNext)
      <=> v24466(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2004,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24466(VarNext)
      <=> ( v24468(VarNext)
          & v24470(VarNext) ) ) ) ).

tff(writeUnaryOperator_1335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24470(VarCurr)
    <=> v24425(VarCurr) ) ).

tff(addAssignment_12515,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24468(VarNext)
      <=> v24425(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_101,axiom,
    ( v24429(constB0)
  <=> $true ) ).

tff(addAssignment_12514,axiom,
    ! [VarCurr: state_type] :
      ( v24460(VarCurr)
    <=> v24462(VarCurr) ) ).

tff(addAssignment_12513,axiom,
    ! [VarCurr: state_type] :
      ( v24462(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12512,axiom,
    ! [VarCurr: state_type] :
      ( v24435(VarCurr)
    <=> v24437(VarCurr) ) ).

tff(addAssignment_12511,axiom,
    ! [VarCurr: state_type] :
      ( v24437(VarCurr)
    <=> v24439(VarCurr) ) ).

tff(addAssignment_12510,axiom,
    ! [VarCurr: state_type] :
      ( v24439(VarCurr)
    <=> v24441(VarCurr) ) ).

tff(addAssignment_12509,axiom,
    ! [VarCurr: state_type] :
      ( v24441(VarCurr)
    <=> v24443(VarCurr) ) ).

tff(writeUnaryOperator_1334,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24443(VarCurr)
    <=> v24457(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2003,axiom,
    ! [VarCurr: state_type] :
      ( v24457(VarCurr)
    <=> ( v24458(VarCurr)
        | v24453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2002,axiom,
    ! [VarCurr: state_type] :
      ( v24458(VarCurr)
    <=> ( v24445(VarCurr)
        | v24449(VarCurr) ) ) ).

tff(addAssignment_12508,axiom,
    ! [VarCurr: state_type] :
      ( v24453(VarCurr)
    <=> v24455(VarCurr) ) ).

tff(addAssignment_12507,axiom,
    ! [VarCurr: state_type] :
      ( v24455(VarCurr)
    <=> v23861(VarCurr,2) ) ).

tff(addAssignment_12506,axiom,
    ! [VarCurr: state_type] :
      ( v24449(VarCurr)
    <=> v24451(VarCurr) ) ).

tff(addAssignment_12505,axiom,
    ! [VarCurr: state_type] :
      ( v24451(VarCurr)
    <=> v24287(VarCurr,1) ) ).

tff(addAssignment_12504,axiom,
    ! [VarCurr: state_type] :
      ( v24287(VarCurr,1)
    <=> v24289(VarCurr,1) ) ).

tff(addAssignment_12503,axiom,
    ! [VarCurr: state_type] :
      ( v24289(VarCurr,1)
    <=> v24291(VarCurr,1) ) ).

tff(addAssignment_12502,axiom,
    ! [VarCurr: state_type] :
      ( v24291(VarCurr,1)
    <=> v24296(VarCurr,1) ) ).

tff(addAssignment_12501,axiom,
    ! [VarCurr: state_type] :
      ( v24293(VarCurr,1)
    <=> v24295(VarCurr,1) ) ).

tff(addAssignment_12500,axiom,
    ! [VarCurr: state_type] :
      ( v24295(VarCurr,1)
    <=> v23861(VarCurr,1) ) ).

tff(addAssignment_12499,axiom,
    ! [VarCurr: state_type] :
      ( v24445(VarCurr)
    <=> v24447(VarCurr) ) ).

tff(addAssignment_12498,axiom,
    ! [VarCurr: state_type] :
      ( v24447(VarCurr)
    <=> v23861(VarCurr,0) ) ).

tff(addAssignment_12497,axiom,
    ! [VarCurr: state_type] :
      ( v24431(VarCurr)
    <=> v24433(VarCurr) ) ).

tff(addAssignment_12496,axiom,
    ! [VarCurr: state_type] :
      ( v24433(VarCurr)
    <=> $false ) ).

tff(addAssignment_12495,axiom,
    ! [VarCurr: state_type] :
      ( v24425(VarCurr)
    <=> v24427(VarCurr) ) ).

tff(addAssignment_12494,axiom,
    ! [VarCurr: state_type] :
      ( v24427(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24415(VarCurr,B)
      <=> v24417(VarCurr,B) ) ) ).

tff(addAssignment_12492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24417(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12491,axiom,
    ! [VarCurr: state_type] :
      ( v24405(VarCurr)
    <=> v24407(VarCurr) ) ).

tff(addAssignment_12490,axiom,
    ! [VarCurr: state_type] :
      ( v24407(VarCurr)
    <=> v24409(VarCurr) ) ).

tff(addAssignment_12489,axiom,
    ! [VarCurr: state_type] :
      ( v24409(VarCurr)
    <=> v24411(VarCurr) ) ).

tff(addAssignment_12488,axiom,
    ! [VarCurr: state_type] :
      ( v24411(VarCurr)
    <=> v24413(VarCurr) ) ).

tff(addAssignment_12487,axiom,
    ! [VarCurr: state_type] :
      ( v24413(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12486,axiom,
    ! [VarCurr: state_type] :
      ( v24395(VarCurr)
    <=> v24397(VarCurr) ) ).

tff(addAssignment_12485,axiom,
    ! [VarCurr: state_type] :
      ( v24397(VarCurr)
    <=> v24399(VarCurr) ) ).

tff(addAssignment_12484,axiom,
    ! [VarCurr: state_type] :
      ( v24399(VarCurr)
    <=> v24401(VarCurr) ) ).

tff(addAssignment_12483,axiom,
    ! [VarCurr: state_type] :
      ( v24401(VarCurr)
    <=> v24403(VarCurr) ) ).

tff(addAssignment_12482,axiom,
    ! [VarCurr: state_type] :
      ( v24403(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_12481,axiom,
    ! [VarCurr: state_type] :
      ( v24354(VarCurr)
    <=> v24356(VarCurr) ) ).

tff(addAssignment_12480,axiom,
    ! [VarCurr: state_type] :
      ( v24356(VarCurr)
    <=> v24358(VarCurr) ) ).

tff(addAssignment_12479,axiom,
    ! [VarCurr: state_type] :
      ( v24358(VarCurr)
    <=> v24360(VarCurr) ) ).

tff(addAssignment_12478,axiom,
    ! [VarCurr: state_type] :
      ( v24360(VarCurr)
    <=> v24362(VarCurr) ) ).

tff(addAssignment_12477,axiom,
    ! [VarCurr: state_type] :
      ( v24362(VarCurr)
    <=> v24364(VarCurr) ) ).

tff(addAssignment_12476,axiom,
    ! [VarCurr: state_type] :
      ( v24364(VarCurr)
    <=> v24366(VarCurr) ) ).

tff(addAssignment_12475,axiom,
    ! [VarCurr: state_type] :
      ( v24366(VarCurr)
    <=> v24368(VarCurr) ) ).

tff(writeUnaryOperator_1333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24368(VarCurr)
    <=> v24382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2001,axiom,
    ! [VarCurr: state_type] :
      ( v24382(VarCurr)
    <=> ( v24383(VarCurr)
        | v24378(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2000,axiom,
    ! [VarCurr: state_type] :
      ( v24383(VarCurr)
    <=> ( v24370(VarCurr)
        | v24374(VarCurr) ) ) ).

tff(addAssignment_12474,axiom,
    ! [VarCurr: state_type] :
      ( v24378(VarCurr)
    <=> v24380(VarCurr) ) ).

tff(addAssignment_12473,axiom,
    ! [VarCurr: state_type] :
      ( v24380(VarCurr)
    <=> v23951(VarCurr,2) ) ).

tff(addAssignment_12472,axiom,
    ! [VarCurr: state_type] :
      ( v24374(VarCurr)
    <=> v24376(VarCurr) ) ).

tff(addAssignment_12471,axiom,
    ! [VarCurr: state_type] :
      ( v24376(VarCurr)
    <=> v23951(VarCurr,1) ) ).

tff(addAssignment_12470,axiom,
    ! [VarCurr: state_type] :
      ( v24370(VarCurr)
    <=> v24372(VarCurr) ) ).

tff(addAssignment_12469,axiom,
    ! [VarCurr: state_type] :
      ( v24372(VarCurr)
    <=> v24034(VarCurr,0) ) ).

tff(addAssignment_12468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24223(VarCurr,B)
      <=> v24225(VarCurr,B) ) ) ).

tff(addAssignment_12467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24225(VarCurr,B)
      <=> v24227(VarCurr,B) ) ) ).

tff(addAssignment_12466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24227(VarCurr,B)
      <=> v24229(VarCurr,B) ) ) ).

tff(addAssignment_12465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24229(VarCurr,B)
      <=> v24231(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24337(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v24231(VarNext,B)
            <=> v24231(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_274,axiom,
    ! [VarNext: state_type] :
      ( v24337(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24231(VarNext,B)
          <=> v24347(VarNext,B) ) ) ) ).

tff(addAssignment_12464,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24347(VarNext,B)
          <=> v24345(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_171,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24348(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24345(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_171,axiom,
    ! [VarCurr: state_type] :
      ( v24348(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v24345(VarCurr,B)
          <=> v24253(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1999,axiom,
    ! [VarCurr: state_type] :
      ( v24348(VarCurr)
    <=> ( v24349(VarCurr)
        & v24350(VarCurr) ) ) ).

tff(writeUnaryOperator_1332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24350(VarCurr)
    <=> v24243(VarCurr) ) ).

tff(writeUnaryOperator_1331,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24349(VarCurr)
    <=> v24233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24337(VarNext)
      <=> v24338(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24338(VarNext)
      <=> ( v24339(VarNext)
          & v24257(VarNext) ) ) ) ).

tff(writeUnaryOperator_1330,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24339(VarNext)
      <=> v24341(VarNext) ) ) ).

tff(addAssignment_12463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24341(VarNext)
      <=> v24257(VarCurr) ) ) ).

tff(addAssignment_12462,axiom,
    ! [VarCurr: state_type] :
      ( v24257(VarCurr)
    <=> v24259(VarCurr) ) ).

tff(addAssignment_12461,axiom,
    ! [VarCurr: state_type] :
      ( v24259(VarCurr)
    <=> v24261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1996,axiom,
    ! [VarCurr: state_type] :
      ( v24261(VarCurr)
    <=> ( v24334(VarCurr)
        | v24330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1995,axiom,
    ! [VarCurr: state_type] :
      ( v24334(VarCurr)
    <=> ( v24263(VarCurr)
        & v24267(VarCurr) ) ) ).

tff(addAssignment_12460,axiom,
    ! [VarCurr: state_type] :
      ( v24330(VarCurr)
    <=> v24332(VarCurr) ) ).

tff(addAssignment_12459,axiom,
    ! [VarCurr: state_type] :
      ( v24332(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24314(VarNext)
       => ( v24267(VarNext)
        <=> v24267(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_273,axiom,
    ! [VarNext: state_type] :
      ( v24314(VarNext)
     => ( v24267(VarNext)
      <=> v24324(VarNext) ) ) ).

tff(addAssignment_12458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24324(VarNext)
      <=> v24322(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1994,axiom,
    ! [VarCurr: state_type] :
      ( v24322(VarCurr)
    <=> ( v24325(VarCurr)
        & v24326(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1993,axiom,
    ! [VarCurr: state_type] :
      ( v24326(VarCurr)
    <=> ( v24273(VarCurr)
        | v24309(VarCurr) ) ) ).

tff(writeUnaryOperator_1329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24325(VarCurr)
    <=> v24269(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1992,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24314(VarNext)
      <=> v24315(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1991,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24315(VarNext)
      <=> ( v24317(VarNext)
          & v24319(VarNext) ) ) ) ).

tff(writeUnaryOperator_1328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24319(VarCurr)
    <=> v24263(VarCurr) ) ).

tff(addAssignment_12457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24317(VarNext)
      <=> v24263(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_100,axiom,
    ( v24267(constB0)
  <=> $true ) ).

tff(addAssignment_12456,axiom,
    ! [VarCurr: state_type] :
      ( v24309(VarCurr)
    <=> v24311(VarCurr) ) ).

tff(addAssignment_12455,axiom,
    ! [VarCurr: state_type] :
      ( v24311(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12454,axiom,
    ! [VarCurr: state_type] :
      ( v24273(VarCurr)
    <=> v24275(VarCurr) ) ).

tff(addAssignment_12453,axiom,
    ! [VarCurr: state_type] :
      ( v24275(VarCurr)
    <=> v24277(VarCurr) ) ).

tff(addAssignment_12452,axiom,
    ! [VarCurr: state_type] :
      ( v24277(VarCurr)
    <=> v24279(VarCurr) ) ).

tff(addAssignment_12451,axiom,
    ! [VarCurr: state_type] :
      ( v24279(VarCurr)
    <=> v24281(VarCurr) ) ).

tff(writeUnaryOperator_1327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24281(VarCurr)
    <=> v24306(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1990,axiom,
    ! [VarCurr: state_type] :
      ( v24306(VarCurr)
    <=> ( v24307(VarCurr)
        | v24302(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1989,axiom,
    ! [VarCurr: state_type] :
      ( v24307(VarCurr)
    <=> ( v24283(VarCurr)
        | v24298(VarCurr) ) ) ).

tff(addAssignment_12450,axiom,
    ! [VarCurr: state_type] :
      ( v24302(VarCurr)
    <=> v24304(VarCurr) ) ).

tff(addAssignment_12449,axiom,
    ! [VarCurr: state_type] :
      ( v24304(VarCurr)
    <=> v23861(VarCurr,2) ) ).

tff(addAssignment_12448,axiom,
    ! [VarCurr: state_type] :
      ( v24298(VarCurr)
    <=> v24300(VarCurr) ) ).

tff(addAssignment_12447,axiom,
    ! [VarCurr: state_type] :
      ( v24300(VarCurr)
    <=> v23861(VarCurr,1) ) ).

tff(addAssignment_12446,axiom,
    ! [VarCurr: state_type] :
      ( v24283(VarCurr)
    <=> v24285(VarCurr) ) ).

tff(addAssignment_12445,axiom,
    ! [VarCurr: state_type] :
      ( v24285(VarCurr)
    <=> v24287(VarCurr,0) ) ).

tff(addAssignment_12444,axiom,
    ! [VarCurr: state_type] :
      ( v24287(VarCurr,0)
    <=> v24289(VarCurr,0) ) ).

tff(addAssignment_12443,axiom,
    ! [VarCurr: state_type] :
      ( v24289(VarCurr,0)
    <=> v24291(VarCurr,0) ) ).

tff(addAssignment_12442,axiom,
    ! [VarCurr: state_type] :
      ( v24291(VarCurr,0)
    <=> v24296(VarCurr,0) ) ).

tff(writeUnaryOperator_1326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v24296(VarCurr,B)
      <=> ~ v24293(VarCurr,B) ) ) ).

tff(addAssignment_12441,axiom,
    ! [VarCurr: state_type] :
      ( v24293(VarCurr,0)
    <=> v24295(VarCurr,0) ) ).

tff(addAssignment_12440,axiom,
    ! [VarCurr: state_type] :
      ( v24295(VarCurr,0)
    <=> v23861(VarCurr,0) ) ).

tff(addAssignment_12439,axiom,
    ! [VarCurr: state_type] :
      ( v24269(VarCurr)
    <=> v24271(VarCurr) ) ).

tff(addAssignment_12438,axiom,
    ! [VarCurr: state_type] :
      ( v24271(VarCurr)
    <=> $false ) ).

tff(addAssignment_12437,axiom,
    ! [VarCurr: state_type] :
      ( v24263(VarCurr)
    <=> v24265(VarCurr) ) ).

tff(addAssignment_12436,axiom,
    ! [VarCurr: state_type] :
      ( v24265(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24253(VarCurr,B)
      <=> v24255(VarCurr,B) ) ) ).

tff(addAssignment_12434,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v24255(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12433,axiom,
    ! [VarCurr: state_type] :
      ( v24243(VarCurr)
    <=> v24245(VarCurr) ) ).

tff(addAssignment_12432,axiom,
    ! [VarCurr: state_type] :
      ( v24245(VarCurr)
    <=> v24247(VarCurr) ) ).

tff(addAssignment_12431,axiom,
    ! [VarCurr: state_type] :
      ( v24247(VarCurr)
    <=> v24249(VarCurr) ) ).

tff(addAssignment_12430,axiom,
    ! [VarCurr: state_type] :
      ( v24249(VarCurr)
    <=> v24251(VarCurr) ) ).

tff(addAssignment_12429,axiom,
    ! [VarCurr: state_type] :
      ( v24251(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12428,axiom,
    ! [VarCurr: state_type] :
      ( v24233(VarCurr)
    <=> v24235(VarCurr) ) ).

tff(addAssignment_12427,axiom,
    ! [VarCurr: state_type] :
      ( v24235(VarCurr)
    <=> v24237(VarCurr) ) ).

tff(addAssignment_12426,axiom,
    ! [VarCurr: state_type] :
      ( v24237(VarCurr)
    <=> v24239(VarCurr) ) ).

tff(addAssignment_12425,axiom,
    ! [VarCurr: state_type] :
      ( v24239(VarCurr)
    <=> v24241(VarCurr) ) ).

tff(addAssignment_12424,axiom,
    ! [VarCurr: state_type] :
      ( v24241(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_12423,axiom,
    ! [VarCurr: state_type] :
      ( v23931(VarCurr)
    <=> v23933(VarCurr) ) ).

tff(addAssignment_12422,axiom,
    ! [VarCurr: state_type] :
      ( v23933(VarCurr)
    <=> v23935(VarCurr) ) ).

tff(addAssignment_12421,axiom,
    ! [VarCurr: state_type] :
      ( v23935(VarCurr)
    <=> v23937(VarCurr) ) ).

tff(addAssignment_12420,axiom,
    ! [VarCurr: state_type] :
      ( v23937(VarCurr)
    <=> v23939(VarCurr) ) ).

tff(addAssignment_12419,axiom,
    ! [VarCurr: state_type] :
      ( v23939(VarCurr)
    <=> v23941(VarCurr) ) ).

tff(addAssignment_12418,axiom,
    ! [VarCurr: state_type] :
      ( v23941(VarCurr)
    <=> v23943(VarCurr) ) ).

tff(addAssignment_12417,axiom,
    ! [VarCurr: state_type] :
      ( v23943(VarCurr)
    <=> v23945(VarCurr) ) ).

tff(writeUnaryOperator_1325,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23945(VarCurr)
    <=> v24220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1988,axiom,
    ! [VarCurr: state_type] :
      ( v24220(VarCurr)
    <=> ( v24221(VarCurr)
        | v24216(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1987,axiom,
    ! [VarCurr: state_type] :
      ( v24221(VarCurr)
    <=> ( v23947(VarCurr)
        | v24212(VarCurr) ) ) ).

tff(addAssignment_12416,axiom,
    ! [VarCurr: state_type] :
      ( v24216(VarCurr)
    <=> v24218(VarCurr) ) ).

tff(addAssignment_12415,axiom,
    ! [VarCurr: state_type] :
      ( v24218(VarCurr)
    <=> v23951(VarCurr,2) ) ).

tff(addAssignment_12414,axiom,
    ! [VarCurr: state_type] :
      ( v24212(VarCurr)
    <=> v24214(VarCurr) ) ).

tff(addAssignment_12413,axiom,
    ! [VarCurr: state_type] :
      ( v24214(VarCurr)
    <=> v23951(VarCurr,1) ) ).

tff(addAssignment_12412,axiom,
    ! [VarCurr: state_type] :
      ( v23947(VarCurr)
    <=> v23949(VarCurr) ) ).

tff(addAssignment_12411,axiom,
    ! [VarCurr: state_type] :
      ( v23949(VarCurr)
    <=> v23951(VarCurr,0) ) ).

tff(addAssignment_12410,axiom,
    ! [VarCurr: state_type] :
      ( v23951(VarCurr,0)
    <=> v23863(VarCurr,3) ) ).

tff(addAssignment_12409,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,3)
    <=> v23865(VarCurr,3) ) ).

tff(addAssignment_12408,axiom,
    ! [VarNext: state_type] :
      ( v23865(VarNext,3)
    <=> v24204(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24205(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v24204(VarNext,B)
            <=> v23865(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_272,axiom,
    ! [VarNext: state_type] :
      ( v24205(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24204(VarNext,B)
          <=> v24176(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1986,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24205(VarNext)
      <=> v24206(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1985,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24206(VarNext)
      <=> ( v24208(VarNext)
          & v24118(VarNext) ) ) ) ).

tff(writeUnaryOperator_1324,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24208(VarNext)
      <=> v24170(VarNext) ) ) ).

tff(addAssignment_12407,axiom,
    ! [VarCurr: state_type] :
      ( v23975(VarCurr,3)
    <=> v23977(VarCurr,3) ) ).

tff(addAssignment_12406,axiom,
    ! [VarCurr: state_type] :
      ( v23977(VarCurr,3)
    <=> v24115(VarCurr,3) ) ).

tff(addAssignment_12405,axiom,
    ! [VarCurr: state_type] :
      ( v23979(VarCurr,0)
    <=> v23981(VarCurr,0) ) ).

tff(addAssignment_12404,axiom,
    ! [VarCurr: state_type] :
      ( v23981(VarCurr,0)
    <=> v23983(VarCurr,0) ) ).

tff(addAssignment_12403,axiom,
    ! [VarCurr: state_type] :
      ( v23983(VarCurr,0)
    <=> v24114(VarCurr,0) ) ).

tff(addAssignment_12402,axiom,
    ! [VarCurr: state_type] :
      ( v24051(VarCurr,0)
    <=> v24053(VarCurr,0) ) ).

tff(addAssignment_12401,axiom,
    ! [VarCurr: state_type] :
      ( v24053(VarCurr,0)
    <=> v24055(VarCurr,0) ) ).

tff(addAssignment_12400,axiom,
    ! [VarCurr: state_type] :
      ( v24055(VarCurr,0)
    <=> v24057(VarCurr,0) ) ).

tff(addAssignment_12399,axiom,
    ! [VarCurr: state_type] :
      ( v24057(VarCurr,0)
    <=> v24059(VarCurr,0) ) ).

tff(addAssignment_12398,axiom,
    ! [VarCurr: state_type] :
      ( v24059(VarCurr,0)
    <=> v24069(VarCurr,0) ) ).

tff(addAssignment_12397,axiom,
    ! [VarCurr: state_type] :
      ( v23985(VarCurr,0)
    <=> v23987(VarCurr,0) ) ).

tff(addAssignment_12396,axiom,
    ! [VarCurr: state_type] :
      ( v23987(VarCurr,0)
    <=> v24048(VarCurr,0) ) ).

tff(addAssignment_12395,axiom,
    ! [VarCurr: state_type] :
      ( v23989(VarCurr)
    <=> v23515(VarCurr,2) ) ).

tff(addAssignment_12394,axiom,
    ! [VarCurr: state_type] :
      ( v23515(VarCurr,2)
    <=> v23517(VarCurr,2) ) ).

tff(addAssignment_12393,axiom,
    ! [VarCurr: state_type] :
      ( v23517(VarCurr,2)
    <=> v23527(VarCurr,2) ) ).

tff(addAssignment_12392,axiom,
    ! [VarCurr: state_type] :
      ( v23519(VarCurr,2)
    <=> v23521(VarCurr,2) ) ).

tff(addAssignment_12391,axiom,
    ! [VarCurr: state_type] :
      ( v23521(VarCurr,2)
    <=> v23524(VarCurr,2) ) ).

tff(addAssignment_12390,axiom,
    ! [VarCurr: state_type] :
      ( v23525(VarCurr)
    <=> v23992(VarCurr,1) ) ).

tff(addAssignment_12389,axiom,
    ! [VarCurr: state_type] :
      ( v23992(VarCurr,1)
    <=> v23994(VarCurr,1) ) ).

tff(addAssignment_12388,axiom,
    ! [VarCurr: state_type] :
      ( v23994(VarCurr,1)
    <=> v24202(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_407,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v24202(VarCurr,B)
      <=> ( v23996(VarCurr,B)
          | v24002(VarCurr,B) ) ) ) ).

tff(addAssignment_12387,axiom,
    ! [VarCurr: state_type] :
      ( v24002(VarCurr,1)
    <=> v24004(VarCurr,1) ) ).

tff(addAssignment_12386,axiom,
    ! [VarCurr: state_type] :
      ( v24004(VarCurr,1)
    <=> v24200(VarCurr,1) ) ).

tff(addAssignment_12385,axiom,
    ! [VarCurr: state_type] :
      ( v24200(VarCurr,0)
    <=> v24201(VarCurr) ) ).

tff(addAssignment_12384,axiom,
    ! [VarCurr: state_type] :
      ( v24200(VarCurr,1)
    <=> v24006(VarCurr) ) ).

tff(addAssignment_12383,axiom,
    ! [VarCurr: state_type] :
      ( v24006(VarCurr)
    <=> v24008(VarCurr,1) ) ).

tff(addAssignment_12382,axiom,
    ! [VarCurr: state_type] :
      ( v24008(VarCurr,1)
    <=> v24010(VarCurr,1) ) ).

tff(addAssignment_12381,axiom,
    ! [VarCurr: state_type] :
      ( v24010(VarCurr,1)
    <=> v24199(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_406,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v24199(VarCurr,B)
      <=> ( v24012(VarCurr,B)
          & v24020(VarCurr,B) ) ) ) ).

tff(addAssignment_12380,axiom,
    ! [VarCurr: state_type] :
      ( v24020(VarCurr,1)
    <=> v24022(VarCurr,1) ) ).

tff(addAssignment_12379,axiom,
    ! [VarCurr: state_type] :
      ( v24022(VarCurr,1)
    <=> v24197(VarCurr,1) ) ).

tff(addAssignment_12378,axiom,
    ! [VarCurr: state_type] :
      ( v24197(VarCurr,0)
    <=> v24198(VarCurr) ) ).

tff(addAssignment_12377,axiom,
    ! [VarCurr: state_type] :
      ( v24197(VarCurr,1)
    <=> v24024(VarCurr) ) ).

tff(addAssignment_12376,axiom,
    ! [VarCurr: state_type] :
      ( v24024(VarCurr)
    <=> v24026(VarCurr) ) ).

tff(addAssignment_12375,axiom,
    ! [VarCurr: state_type] :
      ( v24026(VarCurr)
    <=> v24028(VarCurr) ) ).

tff(writeUnaryOperator_1323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24028(VarCurr)
    <=> v24195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1984,axiom,
    ! [VarCurr: state_type] :
      ( v24195(VarCurr)
    <=> ( v24196(VarCurr)
        | v24183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1983,axiom,
    ! [VarCurr: state_type] :
      ( v24196(VarCurr)
    <=> ( v24030(VarCurr)
        | v24045(VarCurr) ) ) ).

tff(addAssignment_12374,axiom,
    ! [VarCurr: state_type] :
      ( v24183(VarCurr)
    <=> v24185(VarCurr) ) ).

tff(addAssignment_12373,axiom,
    ! [VarCurr: state_type] :
      ( v24185(VarCurr)
    <=> v24034(VarCurr,2) ) ).

tff(addAssignment_12372,axiom,
    ! [VarCurr: state_type] :
      ( v24034(VarCurr,2)
    <=> v24036(VarCurr,2) ) ).

tff(addAssignment_12371,axiom,
    ! [VarCurr: state_type] :
      ( v24036(VarCurr,2)
    <=> v24038(VarCurr,2) ) ).

tff(addAssignment_12370,axiom,
    ! [VarCurr: state_type] :
      ( v24038(VarCurr,2)
    <=> v24043(VarCurr,2) ) ).

tff(addAssignment_12369,axiom,
    ! [VarCurr: state_type] :
      ( v24040(VarCurr,2)
    <=> v24042(VarCurr,2) ) ).

tff(addAssignment_12368,axiom,
    ! [VarCurr: state_type] :
      ( v24042(VarCurr,2)
    <=> v23951(VarCurr,2) ) ).

tff(addAssignment_12367,axiom,
    ! [VarCurr: state_type] :
      ( v23951(VarCurr,2)
    <=> v23863(VarCurr,5) ) ).

tff(addAssignment_12366,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,5)
    <=> v23865(VarCurr,5) ) ).

tff(addAssignment_12365,axiom,
    ! [VarNext: state_type] :
      ( v23865(VarNext,5)
    <=> v24187(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_271,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24188(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v24187(VarNext,B)
            <=> v23865(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_271,axiom,
    ! [VarNext: state_type] :
      ( v24188(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24187(VarNext,B)
          <=> v24176(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24188(VarNext)
      <=> v24189(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24189(VarNext)
      <=> ( v24191(VarNext)
          & v24118(VarNext) ) ) ) ).

tff(writeUnaryOperator_1322,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24191(VarNext)
      <=> v24170(VarNext) ) ) ).

tff(addAssignment_12364,axiom,
    ! [VarCurr: state_type] :
      ( v23975(VarCurr,5)
    <=> v23977(VarCurr,5) ) ).

tff(addAssignment_12363,axiom,
    ! [VarCurr: state_type] :
      ( v23977(VarCurr,5)
    <=> v24115(VarCurr,5) ) ).

tff(addAssignment_12362,axiom,
    ! [VarCurr: state_type] :
      ( v23979(VarCurr,2)
    <=> v23981(VarCurr,2) ) ).

tff(addAssignment_12361,axiom,
    ! [VarCurr: state_type] :
      ( v23981(VarCurr,2)
    <=> v23983(VarCurr,2) ) ).

tff(addAssignment_12360,axiom,
    ! [VarCurr: state_type] :
      ( v23983(VarCurr,2)
    <=> v24114(VarCurr,2) ) ).

tff(addAssignment_12359,axiom,
    ! [VarCurr: state_type] :
      ( v24051(VarCurr,2)
    <=> v24053(VarCurr,2) ) ).

tff(addAssignment_12358,axiom,
    ! [VarCurr: state_type] :
      ( v24053(VarCurr,2)
    <=> v24055(VarCurr,2) ) ).

tff(addAssignment_12357,axiom,
    ! [VarCurr: state_type] :
      ( v24055(VarCurr,2)
    <=> v24057(VarCurr,2) ) ).

tff(addAssignment_12356,axiom,
    ! [VarCurr: state_type] :
      ( v24057(VarCurr,2)
    <=> v24059(VarCurr,2) ) ).

tff(addAssignment_12355,axiom,
    ! [VarCurr: state_type] :
      ( v24059(VarCurr,2)
    <=> v24069(VarCurr,2) ) ).

tff(addAssignment_12354,axiom,
    ! [VarCurr: state_type] :
      ( v24061(VarCurr,2)
    <=> v24063(VarCurr,2) ) ).

tff(addAssignment_12353,axiom,
    ! [VarCurr: state_type] :
      ( v24063(VarCurr,2)
    <=> v24064(VarCurr,2) ) ).

tff(addAssignment_12352,axiom,
    ! [VarCurr: state_type] :
      ( v23985(VarCurr,2)
    <=> v23987(VarCurr,2) ) ).

tff(addAssignment_12351,axiom,
    ! [VarCurr: state_type] :
      ( v23987(VarCurr,2)
    <=> v24048(VarCurr,2) ) ).

tff(addAssignment_12350,axiom,
    ! [VarCurr: state_type] :
      ( v24045(VarCurr)
    <=> v24047(VarCurr) ) ).

tff(addAssignment_12349,axiom,
    ! [VarCurr: state_type] :
      ( v24047(VarCurr)
    <=> v23951(VarCurr,1) ) ).

tff(addAssignment_12348,axiom,
    ! [VarCurr: state_type] :
      ( v23951(VarCurr,1)
    <=> v23863(VarCurr,4) ) ).

tff(addAssignment_12347,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,4)
    <=> v23865(VarCurr,4) ) ).

tff(addAssignment_12346,axiom,
    ! [VarNext: state_type] :
      ( v23865(VarNext,4)
    <=> v24165(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24166(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v24165(VarNext,B)
            <=> v23865(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_270,axiom,
    ! [VarNext: state_type] :
      ( v24166(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24165(VarNext,B)
          <=> v24176(VarNext,B) ) ) ) ).

tff(addAssignment_12345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24176(VarNext,B)
          <=> v24174(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24177(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24174(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_170,axiom,
    ! [VarCurr: state_type] :
      ( v24177(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v24174(VarCurr,B)
          <=> v23975(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1980,axiom,
    ! [VarCurr: state_type] :
      ( v24177(VarCurr)
    <=> ( v24178(VarCurr)
        & v24179(VarCurr) ) ) ).

tff(writeUnaryOperator_1321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24179(VarCurr)
    <=> v23965(VarCurr) ) ).

tff(writeUnaryOperator_1320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24178(VarCurr)
    <=> v23953(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1979,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24166(VarNext)
      <=> v24167(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1978,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24167(VarNext)
      <=> ( v24168(VarNext)
          & v24118(VarNext) ) ) ) ).

tff(writeUnaryOperator_1319,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24168(VarNext)
      <=> v24170(VarNext) ) ) ).

tff(addAssignment_12344,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24170(VarNext)
      <=> v24118(VarCurr) ) ) ).

tff(addAssignment_12343,axiom,
    ! [VarCurr: state_type] :
      ( v24118(VarCurr)
    <=> v24120(VarCurr) ) ).

tff(addAssignment_12342,axiom,
    ! [VarCurr: state_type] :
      ( v24120(VarCurr)
    <=> v24122(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1977,axiom,
    ! [VarCurr: state_type] :
      ( v24122(VarCurr)
    <=> ( v24163(VarCurr)
        | v24159(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1976,axiom,
    ! [VarCurr: state_type] :
      ( v24163(VarCurr)
    <=> ( v24124(VarCurr)
        & v24128(VarCurr) ) ) ).

tff(addAssignment_12341,axiom,
    ! [VarCurr: state_type] :
      ( v24159(VarCurr)
    <=> v24161(VarCurr) ) ).

tff(addAssignment_12340,axiom,
    ! [VarCurr: state_type] :
      ( v24161(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v24143(VarNext)
       => ( v24128(VarNext)
        <=> v24128(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_269,axiom,
    ! [VarNext: state_type] :
      ( v24143(VarNext)
     => ( v24128(VarNext)
      <=> v24153(VarNext) ) ) ).

tff(addAssignment_12339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24153(VarNext)
      <=> v24151(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1975,axiom,
    ! [VarCurr: state_type] :
      ( v24151(VarCurr)
    <=> ( v24154(VarCurr)
        & v24155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1974,axiom,
    ! [VarCurr: state_type] :
      ( v24155(VarCurr)
    <=> ( v24134(VarCurr)
        | v24138(VarCurr) ) ) ).

tff(writeUnaryOperator_1318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24154(VarCurr)
    <=> v24130(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1973,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24143(VarNext)
      <=> v24144(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1972,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24144(VarNext)
      <=> ( v24146(VarNext)
          & v24148(VarNext) ) ) ) ).

tff(writeUnaryOperator_1317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24148(VarCurr)
    <=> v24124(VarCurr) ) ).

tff(addAssignment_12338,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v24146(VarNext)
      <=> v24124(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_99,axiom,
    ( v24128(constB0)
  <=> $true ) ).

tff(addAssignment_12337,axiom,
    ! [VarCurr: state_type] :
      ( v24138(VarCurr)
    <=> v24140(VarCurr) ) ).

tff(addAssignment_12336,axiom,
    ! [VarCurr: state_type] :
      ( v24140(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12335,axiom,
    ! [VarCurr: state_type] :
      ( v24134(VarCurr)
    <=> v24136(VarCurr) ) ).

tff(addAssignment_12334,axiom,
    ! [VarCurr: state_type] :
      ( v24136(VarCurr)
    <=> $true ) ).

tff(addAssignment_12333,axiom,
    ! [VarCurr: state_type] :
      ( v24130(VarCurr)
    <=> v24132(VarCurr) ) ).

tff(addAssignment_12332,axiom,
    ! [VarCurr: state_type] :
      ( v24132(VarCurr)
    <=> $false ) ).

tff(addAssignment_12331,axiom,
    ! [VarCurr: state_type] :
      ( v24124(VarCurr)
    <=> v24126(VarCurr) ) ).

tff(addAssignment_12330,axiom,
    ! [VarCurr: state_type] :
      ( v24126(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12329,axiom,
    ! [VarCurr: state_type] :
      ( v23975(VarCurr,4)
    <=> v23977(VarCurr,4) ) ).

tff(addAssignment_12328,axiom,
    ! [VarCurr: state_type] :
      ( v23977(VarCurr,4)
    <=> v24115(VarCurr,4) ) ).

tff(addAssignment_12327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v24115(VarCurr,B)
      <=> v24116(VarCurr,B) ) ) ).

tff(addAssignment_12326,axiom,
    ! [VarCurr: state_type] :
      ( ( v24115(VarCurr,5)
      <=> v23979(VarCurr,2) )
      & ( v24115(VarCurr,4)
      <=> v23979(VarCurr,1) )
      & ( v24115(VarCurr,3)
      <=> v23979(VarCurr,0) ) ) ).

tff(addAssignment_12325,axiom,
    ! [VarCurr: state_type] :
      ( v23979(VarCurr,1)
    <=> v23981(VarCurr,1) ) ).

tff(addAssignment_12324,axiom,
    ! [VarCurr: state_type] :
      ( v23981(VarCurr,1)
    <=> v23983(VarCurr,1) ) ).

tff(addAssignment_12323,axiom,
    ! [VarCurr: state_type] :
      ( v23983(VarCurr,1)
    <=> v24114(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_405,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v24114(VarCurr,B)
      <=> ( v23985(VarCurr,B)
          & v24051(VarCurr,B) ) ) ) ).

tff(addAssignment_12322,axiom,
    ! [VarCurr: state_type] :
      ( v24051(VarCurr,1)
    <=> v24053(VarCurr,1) ) ).

tff(addAssignment_12321,axiom,
    ! [VarCurr: state_type] :
      ( v24053(VarCurr,1)
    <=> v24055(VarCurr,1) ) ).

tff(addAssignment_12320,axiom,
    ! [VarCurr: state_type] :
      ( v24055(VarCurr,1)
    <=> v24057(VarCurr,1) ) ).

tff(addAssignment_12319,axiom,
    ! [VarCurr: state_type] :
      ( v24057(VarCurr,1)
    <=> v24059(VarCurr,1) ) ).

tff(addAssignment_12318,axiom,
    ! [VarCurr: state_type] :
      ( v24059(VarCurr,1)
    <=> v24069(VarCurr,1) ) ).

tff(addAssignment_12317,axiom,
    ! [VarCurr: state_type] :
      ( v24069(VarCurr,0)
    <=> v24109(VarCurr) ) ).

tff(addAssignment_12316,axiom,
    ! [VarCurr: state_type] :
      ( v24069(VarCurr,1)
    <=> v24104(VarCurr) ) ).

tff(addAssignment_12315,axiom,
    ! [VarCurr: state_type] :
      ( v24069(VarCurr,2)
    <=> v24099(VarCurr) ) ).

tff(addAssignment_12314,axiom,
    ! [VarCurr: state_type] :
      ( v24069(VarCurr,3)
    <=> v24071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1971,axiom,
    ! [VarCurr: state_type] :
      ( v24109(VarCurr)
    <=> ( v24110(VarCurr)
        & v24113(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1970,axiom,
    ! [VarCurr: state_type] :
      ( v24113(VarCurr)
    <=> ( v24061(VarCurr,0)
        | v24079(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1969,axiom,
    ! [VarCurr: state_type] :
      ( v24110(VarCurr)
    <=> ( v24111(VarCurr)
        | v24112(VarCurr) ) ) ).

tff(writeUnaryOperator_1316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24112(VarCurr)
    <=> v24079(VarCurr,0) ) ).

tff(writeUnaryOperator_1315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24111(VarCurr)
    <=> v24061(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1968,axiom,
    ! [VarCurr: state_type] :
      ( v24104(VarCurr)
    <=> ( v24105(VarCurr)
        & v24108(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1967,axiom,
    ! [VarCurr: state_type] :
      ( v24108(VarCurr)
    <=> ( v24078(VarCurr)
        | v24080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1966,axiom,
    ! [VarCurr: state_type] :
      ( v24105(VarCurr)
    <=> ( v24106(VarCurr)
        | v24107(VarCurr) ) ) ).

tff(writeUnaryOperator_1314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24107(VarCurr)
    <=> v24080(VarCurr) ) ).

tff(writeUnaryOperator_1313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24106(VarCurr)
    <=> v24078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1965,axiom,
    ! [VarCurr: state_type] :
      ( v24099(VarCurr)
    <=> ( v24100(VarCurr)
        & v24103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1964,axiom,
    ! [VarCurr: state_type] :
      ( v24103(VarCurr)
    <=> ( v24076(VarCurr)
        | v24086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1963,axiom,
    ! [VarCurr: state_type] :
      ( v24100(VarCurr)
    <=> ( v24101(VarCurr)
        | v24102(VarCurr) ) ) ).

tff(writeUnaryOperator_1312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24102(VarCurr)
    <=> v24086(VarCurr) ) ).

tff(writeUnaryOperator_1311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24101(VarCurr)
    <=> v24076(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1962,axiom,
    ! [VarCurr: state_type] :
      ( v24071(VarCurr)
    <=> ( v24072(VarCurr)
        & v24098(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1961,axiom,
    ! [VarCurr: state_type] :
      ( v24098(VarCurr)
    <=> ( v24074(VarCurr)
        | v24093(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1960,axiom,
    ! [VarCurr: state_type] :
      ( v24072(VarCurr)
    <=> ( v24073(VarCurr)
        | v24092(VarCurr) ) ) ).

tff(writeUnaryOperator_1310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24092(VarCurr)
    <=> v24093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1959,axiom,
    ! [VarCurr: state_type] :
      ( v24093(VarCurr)
    <=> ( v24094(VarCurr)
        & v24097(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_228,axiom,
    ! [VarCurr: state_type] :
      ( v24097(VarCurr)
    <=> ( v24061(VarCurr,3)
        | v24079(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1958,axiom,
    ! [VarCurr: state_type] :
      ( v24094(VarCurr)
    <=> ( v24095(VarCurr)
        | v24096(VarCurr) ) ) ).

tff(writeUnaryOperator_1309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24096(VarCurr)
    <=> v24079(VarCurr,3) ) ).

tff(writeUnaryOperator_1308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24095(VarCurr)
    <=> v24061(VarCurr,3) ) ).

tff(writeUnaryOperator_1307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24073(VarCurr)
    <=> v24074(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1957,axiom,
    ! [VarCurr: state_type] :
      ( v24074(VarCurr)
    <=> ( v24075(VarCurr)
        | v24091(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_227,axiom,
    ! [VarCurr: state_type] :
      ( v24091(VarCurr)
    <=> ( v24061(VarCurr,2)
        & v24079(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1956,axiom,
    ! [VarCurr: state_type] :
      ( v24075(VarCurr)
    <=> ( v24076(VarCurr)
        & v24086(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1955,axiom,
    ! [VarCurr: state_type] :
      ( v24086(VarCurr)
    <=> ( v24087(VarCurr)
        & v24090(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_226,axiom,
    ! [VarCurr: state_type] :
      ( v24090(VarCurr)
    <=> ( v24061(VarCurr,2)
        | v24079(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1954,axiom,
    ! [VarCurr: state_type] :
      ( v24087(VarCurr)
    <=> ( v24088(VarCurr)
        | v24089(VarCurr) ) ) ).

tff(writeUnaryOperator_1306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24089(VarCurr)
    <=> v24079(VarCurr,2) ) ).

tff(writeUnaryOperator_1305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24088(VarCurr)
    <=> v24061(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1953,axiom,
    ! [VarCurr: state_type] :
      ( v24076(VarCurr)
    <=> ( v24077(VarCurr)
        | v24085(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_225,axiom,
    ! [VarCurr: state_type] :
      ( v24085(VarCurr)
    <=> ( v24061(VarCurr,1)
        & v24079(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1952,axiom,
    ! [VarCurr: state_type] :
      ( v24077(VarCurr)
    <=> ( v24078(VarCurr)
        & v24080(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1951,axiom,
    ! [VarCurr: state_type] :
      ( v24080(VarCurr)
    <=> ( v24081(VarCurr)
        & v24084(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_224,axiom,
    ! [VarCurr: state_type] :
      ( v24084(VarCurr)
    <=> ( v24061(VarCurr,1)
        | v24079(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1950,axiom,
    ! [VarCurr: state_type] :
      ( v24081(VarCurr)
    <=> ( v24082(VarCurr)
        | v24083(VarCurr) ) ) ).

tff(writeUnaryOperator_1304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24083(VarCurr)
    <=> v24079(VarCurr,1) ) ).

tff(writeUnaryOperator_1303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v24082(VarCurr)
    <=> v24061(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1949,axiom,
    ! [VarCurr: state_type] :
      ( v24078(VarCurr)
    <=> ( v24061(VarCurr,0)
        & v24079(VarCurr,0) ) ) ).

tff(addAssignment_12313,axiom,
    ! [VarCurr: state_type] :
      ( v24079(VarCurr,0)
    <=> v24066(VarCurr) ) ).

tff(addAssignment_12312,axiom,
    ! [VarCurr: state_type] :
      ( ( v24079(VarCurr,3)
      <=> $false )
      & ( v24079(VarCurr,2)
      <=> $false )
      & ( v24079(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_12311,axiom,
    ! [VarCurr: state_type] :
      ( v24066(VarCurr)
    <=> v24068(VarCurr) ) ).

tff(addAssignment_12310,axiom,
    ! [VarCurr: state_type] :
      ( v24068(VarCurr)
    <=> v24016(VarCurr) ) ).

tff(addAssignment_12309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v24061(VarCurr,B)
      <=> v24063(VarCurr,B) ) ) ).

tff(addAssignment_12308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v24063(VarCurr,B)
      <=> v24064(VarCurr,B) ) ) ).

tff(addAssignment_12307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v24064(VarCurr,B)
      <=> v23951(VarCurr,B) ) ) ).

tff(addAssignment_12306,axiom,
    ! [VarCurr: state_type] :
      ( v24064(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_12305,axiom,
    ! [VarCurr: state_type] :
      ( v23985(VarCurr,1)
    <=> v23987(VarCurr,1) ) ).

tff(addAssignment_12304,axiom,
    ! [VarCurr: state_type] :
      ( v23987(VarCurr,1)
    <=> v24048(VarCurr,1) ) ).

tff(addAssignment_12303,axiom,
    ! [VarCurr: state_type] :
      ( v24048(VarCurr,0)
    <=> v24049(VarCurr) ) ).

tff(addAssignment_12302,axiom,
    ! [VarCurr: state_type] :
      ( v24048(VarCurr,1)
    <=> v24049(VarCurr) ) ).

tff(addAssignment_12301,axiom,
    ! [VarCurr: state_type] :
      ( v24048(VarCurr,2)
    <=> v24049(VarCurr) ) ).

tff(addAssignment_12300,axiom,
    ! [VarCurr: state_type] :
      ( v24049(VarCurr)
    <=> v23989(VarCurr) ) ).

tff(addAssignment_12299,axiom,
    ! [VarCurr: state_type] :
      ( v24030(VarCurr)
    <=> v24032(VarCurr) ) ).

tff(addAssignment_12298,axiom,
    ! [VarCurr: state_type] :
      ( v24032(VarCurr)
    <=> v24034(VarCurr,0) ) ).

tff(addAssignment_12297,axiom,
    ! [VarCurr: state_type] :
      ( v24034(VarCurr,0)
    <=> v24036(VarCurr,0) ) ).

tff(addAssignment_12296,axiom,
    ! [VarCurr: state_type] :
      ( v24036(VarCurr,0)
    <=> v24038(VarCurr,0) ) ).

tff(addAssignment_12295,axiom,
    ! [VarCurr: state_type] :
      ( v24038(VarCurr,0)
    <=> v24043(VarCurr,0) ) ).

tff(writeUnaryOperator_1302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v24043(VarCurr,B)
      <=> ~ v24040(VarCurr,B) ) ) ).

tff(addAssignment_12294,axiom,
    ! [VarCurr: state_type] :
      ( v24040(VarCurr,0)
    <=> v24042(VarCurr,0) ) ).

tff(addAssignment_12293,axiom,
    ! [VarCurr: state_type] :
      ( v24042(VarCurr,0)
    <=> v23951(VarCurr,0) ) ).

tff(addAssignment_12292,axiom,
    ! [VarCurr: state_type] :
      ( v24012(VarCurr,1)
    <=> v24014(VarCurr,1) ) ).

tff(addAssignment_12291,axiom,
    ! [VarCurr: state_type] :
      ( v24014(VarCurr,1)
    <=> v24017(VarCurr,1) ) ).

tff(addAssignment_12290,axiom,
    ! [VarCurr: state_type] :
      ( v24017(VarCurr,0)
    <=> v24018(VarCurr) ) ).

tff(addAssignment_12289,axiom,
    ! [VarCurr: state_type] :
      ( v24017(VarCurr,1)
    <=> v24016(VarCurr) ) ).

tff(addAssignment_12288,axiom,
    ! [VarCurr: state_type] :
      ( v24016(VarCurr)
    <=> v10053(VarCurr,9) ) ).

tff(addAssignment_12287,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,9)
    <=> v10055(VarCurr,9) ) ).

tff(addAssignment_12286,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,9)
    <=> v10057(VarCurr,9) ) ).

tff(addAssignment_12285,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,9)
    <=> v10061(VarCurr,9) ) ).

tff(addAssignment_12284,axiom,
    ! [VarCurr: state_type] :
      ( v23996(VarCurr,1)
    <=> v23998(VarCurr,1) ) ).

tff(addAssignment_12283,axiom,
    ! [VarCurr: state_type] :
      ( v23998(VarCurr,1)
    <=> v23999(VarCurr,1) ) ).

tff(addAssignment_12282,axiom,
    ! [VarCurr: state_type] :
      ( v23999(VarCurr,0)
    <=> v24000(VarCurr) ) ).

tff(addAssignment_12281,axiom,
    ! [VarCurr: state_type] :
      ( v23999(VarCurr,1)
    <=> v24000(VarCurr) ) ).

tff(addAssignment_12280,axiom,
    ! [VarCurr: state_type] :
      ( v24000(VarCurr)
    <=> v23523(VarCurr) ) ).

tff(addAssignment_12279,axiom,
    ! [VarCurr: state_type] :
      ( v23965(VarCurr)
    <=> v23967(VarCurr) ) ).

tff(addAssignment_12278,axiom,
    ! [VarCurr: state_type] :
      ( v23967(VarCurr)
    <=> v23969(VarCurr) ) ).

tff(addAssignment_12277,axiom,
    ! [VarCurr: state_type] :
      ( v23969(VarCurr)
    <=> v23971(VarCurr) ) ).

tff(addAssignment_12276,axiom,
    ! [VarCurr: state_type] :
      ( v23971(VarCurr)
    <=> v23973(VarCurr) ) ).

tff(addAssignment_12275,axiom,
    ! [VarCurr: state_type] :
      ( v23973(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_12274,axiom,
    ! [VarCurr: state_type] :
      ( v23953(VarCurr)
    <=> v23955(VarCurr) ) ).

tff(addAssignment_12273,axiom,
    ! [VarCurr: state_type] :
      ( v23955(VarCurr)
    <=> v23957(VarCurr) ) ).

tff(addAssignment_12272,axiom,
    ! [VarCurr: state_type] :
      ( v23957(VarCurr)
    <=> v23959(VarCurr) ) ).

tff(addAssignment_12271,axiom,
    ! [VarCurr: state_type] :
      ( v23959(VarCurr)
    <=> v23961(VarCurr) ) ).

tff(addAssignment_12270,axiom,
    ! [VarCurr: state_type] :
      ( v23961(VarCurr)
    <=> v23963(VarCurr) ) ).

tff(addAssignment_12269,axiom,
    ! [VarCurr: state_type] :
      ( v23963(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_12268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23461(VarCurr,B)
      <=> v23463(VarCurr,B) ) ) ).

tff(addAssignment_12267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23463(VarCurr,B)
      <=> v23465(VarCurr,B) ) ) ).

tff(addAssignment_12266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23465(VarCurr,B)
      <=> v23467(VarCurr,B) ) ) ).

tff(addAssignment_12265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23467(VarCurr,B)
      <=> v23469(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_268,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23914(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v23469(VarNext,B)
            <=> v23469(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_268,axiom,
    ! [VarNext: state_type] :
      ( v23914(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23469(VarNext,B)
          <=> v23924(VarNext,B) ) ) ) ).

tff(addAssignment_12264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23924(VarNext,B)
          <=> v23922(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23925(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23922(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_169,axiom,
    ! [VarCurr: state_type] :
      ( v23925(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23922(VarCurr,B)
          <=> v23499(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1948,axiom,
    ! [VarCurr: state_type] :
      ( v23925(VarCurr)
    <=> ( v23926(VarCurr)
        & v23927(VarCurr) ) ) ).

tff(writeUnaryOperator_1301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23927(VarCurr)
    <=> v23485(VarCurr) ) ).

tff(writeUnaryOperator_1300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23926(VarCurr)
    <=> v23471(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1947,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23914(VarNext)
      <=> v23915(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1946,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23915(VarNext)
      <=> ( v23916(VarNext)
          & v23829(VarNext) ) ) ) ).

tff(writeUnaryOperator_1299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23916(VarNext)
      <=> v23918(VarNext) ) ) ).

tff(addAssignment_12263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23918(VarNext)
      <=> v23829(VarCurr) ) ) ).

tff(addAssignment_12262,axiom,
    ! [VarCurr: state_type] :
      ( v23829(VarCurr)
    <=> v23831(VarCurr) ) ).

tff(addAssignment_12261,axiom,
    ! [VarCurr: state_type] :
      ( v23831(VarCurr)
    <=> v23833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1945,axiom,
    ! [VarCurr: state_type] :
      ( v23833(VarCurr)
    <=> ( v23911(VarCurr)
        | v23903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1944,axiom,
    ! [VarCurr: state_type] :
      ( v23911(VarCurr)
    <=> ( v23835(VarCurr)
        & v23841(VarCurr) ) ) ).

tff(addAssignment_12260,axiom,
    ! [VarCurr: state_type] :
      ( v23903(VarCurr)
    <=> v23905(VarCurr) ) ).

tff(addAssignment_12259,axiom,
    ! [VarCurr: state_type] :
      ( v23905(VarCurr)
    <=> v23907(VarCurr) ) ).

tff(addAssignment_12258,axiom,
    ! [VarCurr: state_type] :
      ( v23907(VarCurr)
    <=> v23909(VarCurr) ) ).

tff(addAssignment_12257,axiom,
    ! [VarCurr: state_type] :
      ( v23909(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23887(VarNext)
       => ( v23841(VarNext)
        <=> v23841(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_267,axiom,
    ! [VarNext: state_type] :
      ( v23887(VarNext)
     => ( v23841(VarNext)
      <=> v23897(VarNext) ) ) ).

tff(addAssignment_12256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23897(VarNext)
      <=> v23895(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1943,axiom,
    ! [VarCurr: state_type] :
      ( v23895(VarCurr)
    <=> ( v23898(VarCurr)
        & v23899(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1942,axiom,
    ! [VarCurr: state_type] :
      ( v23899(VarCurr)
    <=> ( v23847(VarCurr)
        | v23878(VarCurr) ) ) ).

tff(writeUnaryOperator_1298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23898(VarCurr)
    <=> v23843(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23887(VarNext)
      <=> v23888(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23888(VarNext)
      <=> ( v23890(VarNext)
          & v23892(VarNext) ) ) ) ).

tff(writeUnaryOperator_1297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23892(VarCurr)
    <=> v23835(VarCurr) ) ).

tff(addAssignment_12255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23890(VarNext)
      <=> v23835(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_98,axiom,
    ( v23841(constB0)
  <=> $true ) ).

tff(addAssignment_12254,axiom,
    ! [VarCurr: state_type] :
      ( v23878(VarCurr)
    <=> v23880(VarCurr) ) ).

tff(addAssignment_12253,axiom,
    ! [VarCurr: state_type] :
      ( v23880(VarCurr)
    <=> v23882(VarCurr) ) ).

tff(addAssignment_12252,axiom,
    ! [VarCurr: state_type] :
      ( v23882(VarCurr)
    <=> v23884(VarCurr) ) ).

tff(addAssignment_12251,axiom,
    ! [VarCurr: state_type] :
      ( v23884(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_12250,axiom,
    ! [VarCurr: state_type] :
      ( v23847(VarCurr)
    <=> v23849(VarCurr) ) ).

tff(addAssignment_12249,axiom,
    ! [VarCurr: state_type] :
      ( v23849(VarCurr)
    <=> v23851(VarCurr) ) ).

tff(addAssignment_12248,axiom,
    ! [VarCurr: state_type] :
      ( v23851(VarCurr)
    <=> v23853(VarCurr) ) ).

tff(addAssignment_12247,axiom,
    ! [VarCurr: state_type] :
      ( v23853(VarCurr)
    <=> v23855(VarCurr) ) ).

tff(writeUnaryOperator_1296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23855(VarCurr)
    <=> v23875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1939,axiom,
    ! [VarCurr: state_type] :
      ( v23875(VarCurr)
    <=> ( v23876(VarCurr)
        | v23871(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1938,axiom,
    ! [VarCurr: state_type] :
      ( v23876(VarCurr)
    <=> ( v23857(VarCurr)
        | v23867(VarCurr) ) ) ).

tff(addAssignment_12246,axiom,
    ! [VarCurr: state_type] :
      ( v23871(VarCurr)
    <=> v23873(VarCurr) ) ).

tff(addAssignment_12245,axiom,
    ! [VarCurr: state_type] :
      ( v23873(VarCurr)
    <=> v23861(VarCurr,2) ) ).

tff(addAssignment_12244,axiom,
    ! [VarCurr: state_type] :
      ( v23861(VarCurr,2)
    <=> v23863(VarCurr,2) ) ).

tff(addAssignment_12243,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,2)
    <=> v23865(VarCurr,2) ) ).

tff(addAssignment_12242,axiom,
    ! [VarCurr: state_type] :
      ( v23867(VarCurr)
    <=> v23869(VarCurr) ) ).

tff(addAssignment_12241,axiom,
    ! [VarCurr: state_type] :
      ( v23869(VarCurr)
    <=> v23861(VarCurr,1) ) ).

tff(addAssignment_12240,axiom,
    ! [VarCurr: state_type] :
      ( v23861(VarCurr,1)
    <=> v23863(VarCurr,1) ) ).

tff(addAssignment_12239,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,1)
    <=> v23865(VarCurr,1) ) ).

tff(addAssignment_12238,axiom,
    ! [VarCurr: state_type] :
      ( v23857(VarCurr)
    <=> v23859(VarCurr) ) ).

tff(addAssignment_12237,axiom,
    ! [VarCurr: state_type] :
      ( v23859(VarCurr)
    <=> v23861(VarCurr,0) ) ).

tff(addAssignment_12236,axiom,
    ! [VarCurr: state_type] :
      ( v23861(VarCurr,0)
    <=> v23863(VarCurr,0) ) ).

tff(addAssignment_12235,axiom,
    ! [VarCurr: state_type] :
      ( v23863(VarCurr,0)
    <=> v23865(VarCurr,0) ) ).

tff(addAssignment_12234,axiom,
    ! [VarCurr: state_type] :
      ( v23843(VarCurr)
    <=> v23845(VarCurr) ) ).

tff(addAssignment_12233,axiom,
    ! [VarCurr: state_type] :
      ( v23845(VarCurr)
    <=> $false ) ).

tff(addAssignment_12232,axiom,
    ! [VarCurr: state_type] :
      ( v23835(VarCurr)
    <=> v23837(VarCurr) ) ).

tff(addAssignment_12231,axiom,
    ! [VarCurr: state_type] :
      ( v23837(VarCurr)
    <=> v23839(VarCurr) ) ).

tff(addAssignment_12230,axiom,
    ! [VarCurr: state_type] :
      ( v23839(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_12229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23499(VarCurr,B)
      <=> v23501(VarCurr,B) ) ) ).

tff(addAssignment_12228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23501(VarCurr,B)
      <=> v23503(VarCurr,B) ) ) ).

tff(addAssignment_12227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23503(VarCurr,B)
      <=> v23505(VarCurr,B) ) ) ).

tff(addAssignment_12226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23505(VarCurr,B)
      <=> v23507(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23507(VarCurr,B)
      <=> ( v23509(VarCurr,B)
          & v23531(VarCurr,B) ) ) ) ).

tff(addAssignment_12225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23531(VarCurr,B)
      <=> v23533(VarCurr,B) ) ) ).

tff(addAssignment_12224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23533(VarCurr,B)
      <=> v23535(VarCurr,B) ) ) ).

tff(addAssignment_12223,axiom,
    ! [VarCurr: state_type] :
      ( ( v23535(VarCurr,11)
      <=> v9198(VarCurr,119) )
      & ( v23535(VarCurr,10)
      <=> v9198(VarCurr,118) )
      & ( v23535(VarCurr,9)
      <=> v9198(VarCurr,117) )
      & ( v23535(VarCurr,8)
      <=> v9198(VarCurr,116) )
      & ( v23535(VarCurr,7)
      <=> v9198(VarCurr,115) )
      & ( v23535(VarCurr,6)
      <=> v9198(VarCurr,114) )
      & ( v23535(VarCurr,5)
      <=> v9198(VarCurr,113) )
      & ( v23535(VarCurr,4)
      <=> v9198(VarCurr,112) )
      & ( v23535(VarCurr,3)
      <=> v9198(VarCurr,111) )
      & ( v23535(VarCurr,2)
      <=> v9198(VarCurr,110) )
      & ( v23535(VarCurr,1)
      <=> v9198(VarCurr,109) )
      & ( v23535(VarCurr,0)
      <=> v9198(VarCurr,108) ) ) ).

tff(addAssignment_12222,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,119)
      <=> v23537(VarCurr,11) )
      & ( v9198(VarCurr,118)
      <=> v23537(VarCurr,10) )
      & ( v9198(VarCurr,117)
      <=> v23537(VarCurr,9) )
      & ( v9198(VarCurr,116)
      <=> v23537(VarCurr,8) )
      & ( v9198(VarCurr,115)
      <=> v23537(VarCurr,7) )
      & ( v9198(VarCurr,114)
      <=> v23537(VarCurr,6) )
      & ( v9198(VarCurr,113)
      <=> v23537(VarCurr,5) )
      & ( v9198(VarCurr,112)
      <=> v23537(VarCurr,4) )
      & ( v9198(VarCurr,111)
      <=> v23537(VarCurr,3) )
      & ( v9198(VarCurr,110)
      <=> v23537(VarCurr,2) )
      & ( v9198(VarCurr,109)
      <=> v23537(VarCurr,1) )
      & ( v9198(VarCurr,108)
      <=> v23537(VarCurr,0) ) ) ).

tff(addAssignment_12221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23537(VarCurr,B)
      <=> v23539(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23539(VarCurr,B)
      <=> ( v23821(VarCurr,B)
          | v23824(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23824(VarCurr,B)
      <=> ( v23549(VarCurr,B)
          & v23825(VarCurr,B) ) ) ) ).

tff(addAssignment_12220,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,0)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12219,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,1)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12218,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,2)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12217,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,3)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12216,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,4)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12215,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,5)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12214,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,6)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12213,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,7)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12212,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,8)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12211,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,9)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12210,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,10)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12209,axiom,
    ! [VarCurr: state_type] :
      ( v23825(VarCurr,11)
    <=> v23826(VarCurr) ) ).

tff(addAssignment_12208,axiom,
    ! [VarCurr: state_type] :
      ( v23826(VarCurr)
    <=> v23817(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_401,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23821(VarCurr,B)
      <=> ( v23541(VarCurr,B)
          & v23822(VarCurr,B) ) ) ) ).

tff(addAssignment_12207,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,0)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12206,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,1)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12205,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,2)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12204,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,3)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12203,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,4)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12202,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,5)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12201,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,6)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12200,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,7)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12199,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,8)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12198,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,9)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12197,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,10)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12196,axiom,
    ! [VarCurr: state_type] :
      ( v23822(VarCurr,11)
    <=> v23823(VarCurr) ) ).

tff(addAssignment_12195,axiom,
    ! [VarCurr: state_type] :
      ( v23823(VarCurr)
    <=> v23545(VarCurr) ) ).

tff(addAssignment_12194,axiom,
    ! [VarCurr: state_type] :
      ( v23817(VarCurr)
    <=> v23819(VarCurr) ) ).

tff(addAssignment_12193,axiom,
    ! [VarCurr: state_type] :
      ( v23819(VarCurr)
    <=> v9844(VarCurr,9) ) ).

tff(addAssignment_12192,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,9)
    <=> v9846(VarCurr,9) ) ).

tff(addAssignment_12191,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,9)
    <=> v9496(VarCurr,9) ) ).

tff(addAssignment_12190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23549(VarCurr,B)
      <=> v23551(VarCurr,B) ) ) ).

tff(addAssignment_12189,axiom,
    ! [VarCurr: state_type] :
      ( ( v23551(VarCurr,11)
      <=> v9208(VarCurr,131) )
      & ( v23551(VarCurr,10)
      <=> v9208(VarCurr,130) )
      & ( v23551(VarCurr,9)
      <=> v9208(VarCurr,129) )
      & ( v23551(VarCurr,8)
      <=> v9208(VarCurr,128) )
      & ( v23551(VarCurr,7)
      <=> v9208(VarCurr,127) )
      & ( v23551(VarCurr,6)
      <=> v9208(VarCurr,126) )
      & ( v23551(VarCurr,5)
      <=> v9208(VarCurr,125) )
      & ( v23551(VarCurr,4)
      <=> v9208(VarCurr,124) )
      & ( v23551(VarCurr,3)
      <=> v9208(VarCurr,123) )
      & ( v23551(VarCurr,2)
      <=> v9208(VarCurr,122) )
      & ( v23551(VarCurr,1)
      <=> v9208(VarCurr,121) )
      & ( v23551(VarCurr,0)
      <=> v9208(VarCurr,120) ) ) ).

tff(addAssignment_12188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,132)
        & ~ $less(B,120) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_12187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,132)
        & ~ $less(B,120) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_12186,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,131)
      <=> v23553(VarCurr,11) )
      & ( v9212(VarCurr,130)
      <=> v23553(VarCurr,10) )
      & ( v9212(VarCurr,129)
      <=> v23553(VarCurr,9) )
      & ( v9212(VarCurr,128)
      <=> v23553(VarCurr,8) )
      & ( v9212(VarCurr,127)
      <=> v23553(VarCurr,7) )
      & ( v9212(VarCurr,126)
      <=> v23553(VarCurr,6) )
      & ( v9212(VarCurr,125)
      <=> v23553(VarCurr,5) )
      & ( v9212(VarCurr,124)
      <=> v23553(VarCurr,4) )
      & ( v9212(VarCurr,123)
      <=> v23553(VarCurr,3) )
      & ( v9212(VarCurr,122)
      <=> v23553(VarCurr,2) )
      & ( v9212(VarCurr,121)
      <=> v23553(VarCurr,1) )
      & ( v9212(VarCurr,120)
      <=> v23553(VarCurr,0) ) ) ).

tff(addAssignment_12185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23553(VarCurr,B)
      <=> v23555(VarCurr,B) ) ) ).

tff(addAssignment_12184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23555(VarCurr,B)
      <=> v23557(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23800(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v23557(VarNext,B)
            <=> v23557(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_266,axiom,
    ! [VarNext: state_type] :
      ( v23800(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23557(VarNext,B)
          <=> v23810(VarNext,B) ) ) ) ).

tff(addAssignment_12183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23810(VarNext,B)
          <=> v23808(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23811(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23808(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_168,axiom,
    ! [VarCurr: state_type] :
      ( v23811(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23808(VarCurr,B)
          <=> v23587(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1937,axiom,
    ! [VarCurr: state_type] :
      ( v23811(VarCurr)
    <=> ( v23812(VarCurr)
        & v23813(VarCurr) ) ) ).

tff(writeUnaryOperator_1295,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23813(VarCurr)
    <=> v23573(VarCurr) ) ).

tff(writeUnaryOperator_1294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23812(VarCurr)
    <=> v23559(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23800(VarNext)
      <=> v23801(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1935,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23801(VarNext)
      <=> ( v23802(VarNext)
          & v23775(VarNext) ) ) ) ).

tff(writeUnaryOperator_1293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23802(VarNext)
      <=> v23804(VarNext) ) ) ).

tff(addAssignment_12182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23804(VarNext)
      <=> v23775(VarCurr) ) ) ).

tff(addAssignment_12181,axiom,
    ! [VarCurr: state_type] :
      ( v23775(VarCurr)
    <=> v23777(VarCurr) ) ).

tff(addAssignment_12180,axiom,
    ! [VarCurr: state_type] :
      ( v23777(VarCurr)
    <=> v23779(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1934,axiom,
    ! [VarCurr: state_type] :
      ( v23779(VarCurr)
    <=> ( v23797(VarCurr)
        | v23789(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1933,axiom,
    ! [VarCurr: state_type] :
      ( v23797(VarCurr)
    <=> ( v23781(VarCurr)
        & v23787(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_97,axiom,
    ( v23787(constB0)
  <=> $true ) ).

tff(addAssignment_12179,axiom,
    ! [VarCurr: state_type] :
      ( v23789(VarCurr)
    <=> v23791(VarCurr) ) ).

tff(addAssignment_12178,axiom,
    ! [VarCurr: state_type] :
      ( v23791(VarCurr)
    <=> v23793(VarCurr) ) ).

tff(addAssignment_12177,axiom,
    ! [VarCurr: state_type] :
      ( v23793(VarCurr)
    <=> v23795(VarCurr) ) ).

tff(addAssignment_12176,axiom,
    ! [VarCurr: state_type] :
      ( v23795(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_12175,axiom,
    ! [VarCurr: state_type] :
      ( v23781(VarCurr)
    <=> v23783(VarCurr) ) ).

tff(addAssignment_12174,axiom,
    ! [VarCurr: state_type] :
      ( v23783(VarCurr)
    <=> v23785(VarCurr) ) ).

tff(addAssignment_12173,axiom,
    ! [VarCurr: state_type] :
      ( v23785(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_12172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23587(VarCurr,B)
      <=> v23589(VarCurr,B) ) ) ).

tff(addAssignment_12171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23589(VarCurr,B)
      <=> v23591(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23591(VarCurr,B)
      <=> ( v23760(VarCurr,B)
          | v23771(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23771(VarCurr,B)
      <=> ( v23724(VarCurr,B)
          & v23772(VarCurr,B) ) ) ) ).

tff(addAssignment_12170,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,0)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12169,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,1)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12168,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,2)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12167,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,3)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12166,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,4)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12165,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,5)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12164,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,6)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12163,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,7)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12162,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,8)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12161,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,9)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12160,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,10)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12159,axiom,
    ! [VarCurr: state_type] :
      ( v23772(VarCurr,11)
    <=> v23773(VarCurr) ) ).

tff(addAssignment_12158,axiom,
    ! [VarCurr: state_type] :
      ( v23773(VarCurr)
    <=> v23734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_398,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23760(VarCurr,B)
      <=> ( v23761(VarCurr,B)
          | v23768(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_397,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23768(VarCurr,B)
      <=> ( v23688(VarCurr,B)
          & v23769(VarCurr,B) ) ) ) ).

tff(addAssignment_12157,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,0)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12156,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,1)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12155,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,2)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12154,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,3)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12153,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,4)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12152,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,5)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12151,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,6)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12150,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,7)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12149,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,8)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12148,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,9)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12147,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,10)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12146,axiom,
    ! [VarCurr: state_type] :
      ( v23769(VarCurr,11)
    <=> v23770(VarCurr) ) ).

tff(addAssignment_12145,axiom,
    ! [VarCurr: state_type] :
      ( v23770(VarCurr)
    <=> v23698(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_396,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23761(VarCurr,B)
      <=> ( v23762(VarCurr,B)
          | v23765(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_395,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23765(VarCurr,B)
      <=> ( v23641(VarCurr,B)
          & v23766(VarCurr,B) ) ) ) ).

tff(addAssignment_12144,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,0)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12143,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,1)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12142,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,2)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12141,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,3)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12140,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,4)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12139,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,5)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12138,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,6)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12137,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,7)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12136,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,8)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12135,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,9)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12134,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,10)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12133,axiom,
    ! [VarCurr: state_type] :
      ( v23766(VarCurr,11)
    <=> v23767(VarCurr) ) ).

tff(addAssignment_12132,axiom,
    ! [VarCurr: state_type] :
      ( v23767(VarCurr)
    <=> v23651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23762(VarCurr,B)
      <=> ( v23593(VarCurr,B)
          & v23763(VarCurr,B) ) ) ) ).

tff(addAssignment_12131,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,0)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12130,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,1)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12129,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,2)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12128,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,3)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12127,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,4)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12126,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,5)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12125,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,6)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12124,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,7)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12123,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,8)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12122,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,9)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12121,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,10)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12120,axiom,
    ! [VarCurr: state_type] :
      ( v23763(VarCurr,11)
    <=> v23764(VarCurr) ) ).

tff(addAssignment_12119,axiom,
    ! [VarCurr: state_type] :
      ( v23764(VarCurr)
    <=> v23603(VarCurr) ) ).

tff(addAssignment_12118,axiom,
    ! [VarCurr: state_type] :
      ( v23734(VarCurr)
    <=> v23736(VarCurr) ) ).

tff(addAssignment_12117,axiom,
    ! [VarCurr: state_type] :
      ( v23736(VarCurr)
    <=> v23738(VarCurr) ) ).

tff(addAssignment_12116,axiom,
    ! [VarCurr: state_type] :
      ( v23738(VarCurr)
    <=> v23740(VarCurr) ) ).

tff(addAssignment_12115,axiom,
    ! [VarCurr: state_type] :
      ( v23740(VarCurr)
    <=> v23742(VarCurr) ) ).

tff(addAssignment_12114,axiom,
    ! [VarCurr: state_type] :
      ( v23742(VarCurr)
    <=> v23744(VarCurr) ) ).

tff(addAssignment_12113,axiom,
    ! [VarCurr: state_type] :
      ( v23744(VarCurr)
    <=> v23746(VarCurr) ) ).

tff(addAssignment_12112,axiom,
    ! [VarCurr: state_type] :
      ( v23746(VarCurr)
    <=> v23748(VarCurr) ) ).

tff(writeUnaryOperator_1292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23748(VarCurr)
    <=> v23758(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1932,axiom,
    ! [VarCurr: state_type] :
      ( v23758(VarCurr)
    <=> ( v23750(VarCurr)
        | v23754(VarCurr) ) ) ).

tff(addAssignment_12111,axiom,
    ! [VarCurr: state_type] :
      ( v23754(VarCurr)
    <=> v23756(VarCurr) ) ).

tff(addAssignment_12110,axiom,
    ! [VarCurr: state_type] :
      ( v23756(VarCurr)
    <=> v23671(VarCurr,1) ) ).

tff(addAssignment_12109,axiom,
    ! [VarCurr: state_type] :
      ( v23750(VarCurr)
    <=> v23752(VarCurr) ) ).

tff(addAssignment_12108,axiom,
    ! [VarCurr: state_type] :
      ( v23752(VarCurr)
    <=> v23671(VarCurr,0) ) ).

tff(addAssignment_12107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23724(VarCurr,B)
      <=> v23726(VarCurr,B) ) ) ).

tff(addAssignment_12106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23726(VarCurr,B)
      <=> v23728(VarCurr,B) ) ) ).

tff(addAssignment_12105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23728(VarCurr,B)
      <=> v23730(VarCurr,B) ) ) ).

tff(addAssignment_12104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23730(VarCurr,B)
      <=> v23732(VarCurr,B) ) ) ).

tff(addAssignment_12103,axiom,
    ! [VarCurr: state_type] :
      ( v23698(VarCurr)
    <=> v23700(VarCurr) ) ).

tff(addAssignment_12102,axiom,
    ! [VarCurr: state_type] :
      ( v23700(VarCurr)
    <=> v23702(VarCurr) ) ).

tff(addAssignment_12101,axiom,
    ! [VarCurr: state_type] :
      ( v23702(VarCurr)
    <=> v23704(VarCurr) ) ).

tff(addAssignment_12100,axiom,
    ! [VarCurr: state_type] :
      ( v23704(VarCurr)
    <=> v23706(VarCurr) ) ).

tff(addAssignment_12099,axiom,
    ! [VarCurr: state_type] :
      ( v23706(VarCurr)
    <=> v23708(VarCurr) ) ).

tff(addAssignment_12098,axiom,
    ! [VarCurr: state_type] :
      ( v23708(VarCurr)
    <=> v23710(VarCurr) ) ).

tff(addAssignment_12097,axiom,
    ! [VarCurr: state_type] :
      ( v23710(VarCurr)
    <=> v23712(VarCurr) ) ).

tff(writeUnaryOperator_1291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23712(VarCurr)
    <=> v23722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1931,axiom,
    ! [VarCurr: state_type] :
      ( v23722(VarCurr)
    <=> ( v23714(VarCurr)
        | v23718(VarCurr) ) ) ).

tff(addAssignment_12096,axiom,
    ! [VarCurr: state_type] :
      ( v23718(VarCurr)
    <=> v23720(VarCurr) ) ).

tff(addAssignment_12095,axiom,
    ! [VarCurr: state_type] :
      ( v23720(VarCurr)
    <=> v23671(VarCurr,1) ) ).

tff(addAssignment_12094,axiom,
    ! [VarCurr: state_type] :
      ( v23671(VarCurr,1)
    <=> v23673(VarCurr,1) ) ).

tff(addAssignment_12093,axiom,
    ! [VarCurr: state_type] :
      ( v23673(VarCurr,1)
    <=> v23675(VarCurr,1) ) ).

tff(addAssignment_12092,axiom,
    ! [VarCurr: state_type] :
      ( v23675(VarCurr,1)
    <=> v23680(VarCurr,1) ) ).

tff(addAssignment_12091,axiom,
    ! [VarCurr: state_type] :
      ( v23677(VarCurr,1)
    <=> v23679(VarCurr,1) ) ).

tff(addAssignment_12090,axiom,
    ! [VarCurr: state_type] :
      ( v23679(VarCurr,1)
    <=> v23623(VarCurr,1) ) ).

tff(addAssignment_12089,axiom,
    ! [VarCurr: state_type] :
      ( v23714(VarCurr)
    <=> v23716(VarCurr) ) ).

tff(addAssignment_12088,axiom,
    ! [VarCurr: state_type] :
      ( v23716(VarCurr)
    <=> v23623(VarCurr,0) ) ).

tff(addAssignment_12087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23688(VarCurr,B)
      <=> v23690(VarCurr,B) ) ) ).

tff(addAssignment_12086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23690(VarCurr,B)
      <=> v23692(VarCurr,B) ) ) ).

tff(addAssignment_12085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23692(VarCurr,B)
      <=> v23694(VarCurr,B) ) ) ).

tff(addAssignment_12084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23694(VarCurr,B)
      <=> v23696(VarCurr,B) ) ) ).

tff(addAssignment_12083,axiom,
    ! [VarCurr: state_type] :
      ( v23651(VarCurr)
    <=> v23653(VarCurr) ) ).

tff(addAssignment_12082,axiom,
    ! [VarCurr: state_type] :
      ( v23653(VarCurr)
    <=> v23655(VarCurr) ) ).

tff(addAssignment_12081,axiom,
    ! [VarCurr: state_type] :
      ( v23655(VarCurr)
    <=> v23657(VarCurr) ) ).

tff(addAssignment_12080,axiom,
    ! [VarCurr: state_type] :
      ( v23657(VarCurr)
    <=> v23659(VarCurr) ) ).

tff(addAssignment_12079,axiom,
    ! [VarCurr: state_type] :
      ( v23659(VarCurr)
    <=> v23661(VarCurr) ) ).

tff(addAssignment_12078,axiom,
    ! [VarCurr: state_type] :
      ( v23661(VarCurr)
    <=> v23663(VarCurr) ) ).

tff(addAssignment_12077,axiom,
    ! [VarCurr: state_type] :
      ( v23663(VarCurr)
    <=> v23665(VarCurr) ) ).

tff(writeUnaryOperator_1290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23665(VarCurr)
    <=> v23686(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1930,axiom,
    ! [VarCurr: state_type] :
      ( v23686(VarCurr)
    <=> ( v23667(VarCurr)
        | v23682(VarCurr) ) ) ).

tff(addAssignment_12076,axiom,
    ! [VarCurr: state_type] :
      ( v23682(VarCurr)
    <=> v23684(VarCurr) ) ).

tff(addAssignment_12075,axiom,
    ! [VarCurr: state_type] :
      ( v23684(VarCurr)
    <=> v23623(VarCurr,1) ) ).

tff(addAssignment_12074,axiom,
    ! [VarCurr: state_type] :
      ( v23667(VarCurr)
    <=> v23669(VarCurr) ) ).

tff(addAssignment_12073,axiom,
    ! [VarCurr: state_type] :
      ( v23669(VarCurr)
    <=> v23671(VarCurr,0) ) ).

tff(addAssignment_12072,axiom,
    ! [VarCurr: state_type] :
      ( v23671(VarCurr,0)
    <=> v23673(VarCurr,0) ) ).

tff(addAssignment_12071,axiom,
    ! [VarCurr: state_type] :
      ( v23673(VarCurr,0)
    <=> v23675(VarCurr,0) ) ).

tff(addAssignment_12070,axiom,
    ! [VarCurr: state_type] :
      ( v23675(VarCurr,0)
    <=> v23680(VarCurr,0) ) ).

tff(writeUnaryOperator_1289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v23680(VarCurr,B)
      <=> ~ v23677(VarCurr,B) ) ) ).

tff(addAssignment_12069,axiom,
    ! [VarCurr: state_type] :
      ( v23677(VarCurr,0)
    <=> v23679(VarCurr,0) ) ).

tff(addAssignment_12068,axiom,
    ! [VarCurr: state_type] :
      ( v23679(VarCurr,0)
    <=> v23623(VarCurr,0) ) ).

tff(addAssignment_12067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23641(VarCurr,B)
      <=> v23643(VarCurr,B) ) ) ).

tff(addAssignment_12066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23643(VarCurr,B)
      <=> v23645(VarCurr,B) ) ) ).

tff(addAssignment_12065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23645(VarCurr,B)
      <=> v23647(VarCurr,B) ) ) ).

tff(addAssignment_12064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23647(VarCurr,B)
      <=> v23649(VarCurr,B) ) ) ).

tff(addAssignment_12063,axiom,
    ! [VarCurr: state_type] :
      ( v23603(VarCurr)
    <=> v23605(VarCurr) ) ).

tff(addAssignment_12062,axiom,
    ! [VarCurr: state_type] :
      ( v23605(VarCurr)
    <=> v23607(VarCurr) ) ).

tff(addAssignment_12061,axiom,
    ! [VarCurr: state_type] :
      ( v23607(VarCurr)
    <=> v23609(VarCurr) ) ).

tff(addAssignment_12060,axiom,
    ! [VarCurr: state_type] :
      ( v23609(VarCurr)
    <=> v23611(VarCurr) ) ).

tff(addAssignment_12059,axiom,
    ! [VarCurr: state_type] :
      ( v23611(VarCurr)
    <=> v23613(VarCurr) ) ).

tff(addAssignment_12058,axiom,
    ! [VarCurr: state_type] :
      ( v23613(VarCurr)
    <=> v23615(VarCurr) ) ).

tff(addAssignment_12057,axiom,
    ! [VarCurr: state_type] :
      ( v23615(VarCurr)
    <=> v23617(VarCurr) ) ).

tff(writeUnaryOperator_1288,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23617(VarCurr)
    <=> v23639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1929,axiom,
    ! [VarCurr: state_type] :
      ( v23639(VarCurr)
    <=> ( v23619(VarCurr)
        | v23635(VarCurr) ) ) ).

tff(addAssignment_12056,axiom,
    ! [VarCurr: state_type] :
      ( v23635(VarCurr)
    <=> v23637(VarCurr) ) ).

tff(addAssignment_12055,axiom,
    ! [VarCurr: state_type] :
      ( v23637(VarCurr)
    <=> v23623(VarCurr,1) ) ).

tff(addAssignment_12054,axiom,
    ! [VarCurr: state_type] :
      ( v23623(VarCurr,1)
    <=> v23625(VarCurr,1) ) ).

tff(addAssignment_12053,axiom,
    ! [VarCurr: state_type] :
      ( v23625(VarCurr,1)
    <=> v23627(VarCurr,1) ) ).

tff(addAssignment_12052,axiom,
    ! [VarCurr: state_type] :
      ( v23627(VarCurr,1)
    <=> v23629(VarCurr,1) ) ).

tff(addAssignment_12051,axiom,
    ! [VarCurr: state_type] :
      ( v23629(VarCurr,1)
    <=> v23631(VarCurr,1) ) ).

tff(addAssignment_12050,axiom,
    ! [VarCurr: state_type] :
      ( v23631(VarCurr,1)
    <=> v23633(VarCurr,1) ) ).

tff(addAssignment_12049,axiom,
    ! [VarCurr: state_type] :
      ( v23619(VarCurr)
    <=> v23621(VarCurr) ) ).

tff(addAssignment_12048,axiom,
    ! [VarCurr: state_type] :
      ( v23621(VarCurr)
    <=> v23623(VarCurr,0) ) ).

tff(addAssignment_12047,axiom,
    ! [VarCurr: state_type] :
      ( v23623(VarCurr,0)
    <=> v23625(VarCurr,0) ) ).

tff(addAssignment_12046,axiom,
    ! [VarCurr: state_type] :
      ( v23625(VarCurr,0)
    <=> v23627(VarCurr,0) ) ).

tff(addAssignment_12045,axiom,
    ! [VarCurr: state_type] :
      ( v23627(VarCurr,0)
    <=> v23629(VarCurr,0) ) ).

tff(addAssignment_12044,axiom,
    ! [VarCurr: state_type] :
      ( v23629(VarCurr,0)
    <=> v23631(VarCurr,0) ) ).

tff(addAssignment_12043,axiom,
    ! [VarCurr: state_type] :
      ( v23631(VarCurr,0)
    <=> v23633(VarCurr,0) ) ).

tff(addAssignment_12042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23593(VarCurr,B)
      <=> v23595(VarCurr,B) ) ) ).

tff(addAssignment_12041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23595(VarCurr,B)
      <=> v23597(VarCurr,B) ) ) ).

tff(addAssignment_12040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23597(VarCurr,B)
      <=> v23599(VarCurr,B) ) ) ).

tff(addAssignment_12039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23599(VarCurr,B)
      <=> v23601(VarCurr,B) ) ) ).

tff(addAssignment_12038,axiom,
    ! [VarCurr: state_type] :
      ( v23573(VarCurr)
    <=> v23575(VarCurr) ) ).

tff(addAssignment_12037,axiom,
    ! [VarCurr: state_type] :
      ( v23575(VarCurr)
    <=> v23577(VarCurr) ) ).

tff(addAssignment_12036,axiom,
    ! [VarCurr: state_type] :
      ( v23577(VarCurr)
    <=> v23579(VarCurr) ) ).

tff(addAssignment_12035,axiom,
    ! [VarCurr: state_type] :
      ( v23579(VarCurr)
    <=> v23581(VarCurr) ) ).

tff(addAssignment_12034,axiom,
    ! [VarCurr: state_type] :
      ( v23581(VarCurr)
    <=> v23583(VarCurr) ) ).

tff(addAssignment_12033,axiom,
    ! [VarCurr: state_type] :
      ( v23583(VarCurr)
    <=> v23585(VarCurr) ) ).

tff(addAssignment_12032,axiom,
    ! [VarCurr: state_type] :
      ( v23585(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_12031,axiom,
    ! [VarCurr: state_type] :
      ( v23559(VarCurr)
    <=> v23561(VarCurr) ) ).

tff(addAssignment_12030,axiom,
    ! [VarCurr: state_type] :
      ( v23561(VarCurr)
    <=> v23563(VarCurr) ) ).

tff(addAssignment_12029,axiom,
    ! [VarCurr: state_type] :
      ( v23563(VarCurr)
    <=> v23565(VarCurr) ) ).

tff(addAssignment_12028,axiom,
    ! [VarCurr: state_type] :
      ( v23565(VarCurr)
    <=> v23567(VarCurr) ) ).

tff(addAssignment_12027,axiom,
    ! [VarCurr: state_type] :
      ( v23567(VarCurr)
    <=> v23569(VarCurr) ) ).

tff(addAssignment_12026,axiom,
    ! [VarCurr: state_type] :
      ( v23569(VarCurr)
    <=> v23571(VarCurr) ) ).

tff(addAssignment_12025,axiom,
    ! [VarCurr: state_type] :
      ( v23571(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_12024,axiom,
    ! [VarCurr: state_type] :
      ( v23545(VarCurr)
    <=> v23547(VarCurr) ) ).

tff(addAssignment_12023,axiom,
    ! [VarCurr: state_type] :
      ( v23547(VarCurr)
    <=> v9490(VarCurr,9) ) ).

tff(addAssignment_12022,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,9)
    <=> v9492(VarCurr,9) ) ).

tff(addAssignment_12021,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,9)
    <=> v9494(VarCurr,9) ) ).

tff(addAssignment_12020,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,9)
    <=> v9570(VarCurr,9) ) ).

tff(addAssignment_12019,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,9)
    <=> v9513(VarCurr,9) ) ).

tff(addAssignment_12018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23541(VarCurr,B)
      <=> v23543(VarCurr,B) ) ) ).

tff(addAssignment_12017,axiom,
    ! [VarCurr: state_type] :
      ( ( v23543(VarCurr,11)
      <=> v9208(VarCurr,119) )
      & ( v23543(VarCurr,10)
      <=> v9208(VarCurr,118) )
      & ( v23543(VarCurr,9)
      <=> v9208(VarCurr,117) )
      & ( v23543(VarCurr,8)
      <=> v9208(VarCurr,116) )
      & ( v23543(VarCurr,7)
      <=> v9208(VarCurr,115) )
      & ( v23543(VarCurr,6)
      <=> v9208(VarCurr,114) )
      & ( v23543(VarCurr,5)
      <=> v9208(VarCurr,113) )
      & ( v23543(VarCurr,4)
      <=> v9208(VarCurr,112) )
      & ( v23543(VarCurr,3)
      <=> v9208(VarCurr,111) )
      & ( v23543(VarCurr,2)
      <=> v9208(VarCurr,110) )
      & ( v23543(VarCurr,1)
      <=> v9208(VarCurr,109) )
      & ( v23543(VarCurr,0)
      <=> v9208(VarCurr,108) ) ) ).

tff(addAssignment_12016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23509(VarCurr,B)
      <=> v23511(VarCurr,B) ) ) ).

tff(addAssignment_12015,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,0)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12014,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,1)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12013,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,2)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12012,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,3)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12011,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,4)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12010,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,5)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12009,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,6)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12008,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,7)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12007,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,8)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12006,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,9)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12005,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,10)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12004,axiom,
    ! [VarCurr: state_type] :
      ( v23511(VarCurr,11)
    <=> v23529(VarCurr) ) ).

tff(addAssignment_12003,axiom,
    ! [VarCurr: state_type] :
      ( v23529(VarCurr)
    <=> v23513(VarCurr) ) ).

tff(addAssignment_12002,axiom,
    ! [VarCurr: state_type] :
      ( v23513(VarCurr)
    <=> v23515(VarCurr,0) ) ).

tff(addAssignment_12001,axiom,
    ! [VarCurr: state_type] :
      ( v23515(VarCurr,0)
    <=> v23517(VarCurr,0) ) ).

tff(addAssignment_12000,axiom,
    ! [VarCurr: state_type] :
      ( v23517(VarCurr,0)
    <=> v23527(VarCurr,0) ) ).

tff(writeUnaryOperator_1287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v23527(VarCurr,B)
      <=> ~ v23519(VarCurr,B) ) ) ).

tff(addAssignment_11999,axiom,
    ! [VarCurr: state_type] :
      ( v23519(VarCurr,0)
    <=> v23521(VarCurr,0) ) ).

tff(addAssignment_11998,axiom,
    ! [VarCurr: state_type] :
      ( v23521(VarCurr,0)
    <=> v23524(VarCurr,0) ) ).

tff(addAssignment_11997,axiom,
    ! [VarCurr: state_type] :
      ( v23524(VarCurr,0)
    <=> v23523(VarCurr) ) ).

tff(addAssignment_11996,axiom,
    ! [VarCurr: state_type] :
      ( v23524(VarCurr,1)
    <=> v23526(VarCurr) ) ).

tff(addAssignment_11995,axiom,
    ! [VarCurr: state_type] :
      ( v23524(VarCurr,2)
    <=> v23525(VarCurr) ) ).

tff(addAssignment_11994,axiom,
    ! [VarCurr: state_type] :
      ( v23523(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_11993,axiom,
    ! [VarCurr: state_type] :
      ( v23485(VarCurr)
    <=> v23487(VarCurr) ) ).

tff(addAssignment_11992,axiom,
    ! [VarCurr: state_type] :
      ( v23487(VarCurr)
    <=> v23489(VarCurr) ) ).

tff(addAssignment_11991,axiom,
    ! [VarCurr: state_type] :
      ( v23489(VarCurr)
    <=> v23491(VarCurr) ) ).

tff(addAssignment_11990,axiom,
    ! [VarCurr: state_type] :
      ( v23491(VarCurr)
    <=> v23493(VarCurr) ) ).

tff(addAssignment_11989,axiom,
    ! [VarCurr: state_type] :
      ( v23493(VarCurr)
    <=> v23495(VarCurr) ) ).

tff(addAssignment_11988,axiom,
    ! [VarCurr: state_type] :
      ( v23495(VarCurr)
    <=> v23497(VarCurr) ) ).

tff(addAssignment_11987,axiom,
    ! [VarCurr: state_type] :
      ( v23497(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_11986,axiom,
    ! [VarCurr: state_type] :
      ( v23471(VarCurr)
    <=> v23473(VarCurr) ) ).

tff(addAssignment_11985,axiom,
    ! [VarCurr: state_type] :
      ( v23473(VarCurr)
    <=> v23475(VarCurr) ) ).

tff(addAssignment_11984,axiom,
    ! [VarCurr: state_type] :
      ( v23475(VarCurr)
    <=> v23477(VarCurr) ) ).

tff(addAssignment_11983,axiom,
    ! [VarCurr: state_type] :
      ( v23477(VarCurr)
    <=> v23479(VarCurr) ) ).

tff(addAssignment_11982,axiom,
    ! [VarCurr: state_type] :
      ( v23479(VarCurr)
    <=> v23481(VarCurr) ) ).

tff(addAssignment_11981,axiom,
    ! [VarCurr: state_type] :
      ( v23481(VarCurr)
    <=> v23483(VarCurr) ) ).

tff(addAssignment_11980,axiom,
    ! [VarCurr: state_type] :
      ( v23483(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_11979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23447(VarCurr,B)
      <=> v23449(VarCurr,B) ) ) ).

tff(addAssignment_11978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23449(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_11977,axiom,
    ! [VarCurr: state_type] :
      ( v21891(VarCurr)
    <=> v21893(VarCurr) ) ).

tff(addAssignment_11976,axiom,
    ! [VarCurr: state_type] :
      ( v21893(VarCurr)
    <=> v21895(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_94,axiom,
    ! [VarCurr: state_type] :
      ( v21895(VarCurr)
    <=> ( ( v21897(VarCurr,11)
        <=> v21901(VarCurr,11) )
        & ( v21897(VarCurr,10)
        <=> v21901(VarCurr,10) )
        & ( v21897(VarCurr,9)
        <=> v21901(VarCurr,9) )
        & ( v21897(VarCurr,8)
        <=> v21901(VarCurr,8) )
        & ( v21897(VarCurr,7)
        <=> v21901(VarCurr,7) )
        & ( v21897(VarCurr,6)
        <=> v21901(VarCurr,6) )
        & ( v21897(VarCurr,5)
        <=> v21901(VarCurr,5) )
        & ( v21897(VarCurr,4)
        <=> v21901(VarCurr,4) )
        & ( v21897(VarCurr,3)
        <=> v21901(VarCurr,3) )
        & ( v21897(VarCurr,2)
        <=> v21901(VarCurr,2) )
        & ( v21897(VarCurr,1)
        <=> v21901(VarCurr,1) )
        & ( v21897(VarCurr,0)
        <=> v21901(VarCurr,0) ) ) ) ).

tff(addAssignment_11975,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21901(VarCurr,B)
      <=> v21903(VarCurr,B) ) ) ).

tff(addAssignment_11974,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21903(VarCurr,B)
      <=> v21905(VarCurr,B) ) ) ).

tff(addAssignment_11973,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21905(VarCurr,B)
      <=> v21907(VarCurr,B) ) ) ).

tff(addAssignment_11972,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21907(VarCurr,B)
      <=> v21909(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21909(VarCurr,B)
      <=> ( v23417(VarCurr,B)
          | v23436(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23436(VarCurr,B)
      <=> ( v23288(VarCurr,B)
          & v23437(VarCurr,B) ) ) ) ).

tff(addAssignment_11971,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,0)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11970,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,1)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11969,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,2)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11968,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,3)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11967,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,4)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11966,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,5)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11965,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,6)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11964,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,7)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11963,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,8)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11962,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,9)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11961,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,10)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11960,axiom,
    ! [VarCurr: state_type] :
      ( v23437(VarCurr,11)
    <=> v23438(VarCurr) ) ).

tff(addAssignment_11959,axiom,
    ! [VarCurr: state_type] :
      ( v23438(VarCurr)
    <=> v23407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23417(VarCurr,B)
      <=> ( v23418(VarCurr,B)
          | v23433(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23433(VarCurr,B)
      <=> ( v23137(VarCurr,B)
          & v23434(VarCurr,B) ) ) ) ).

tff(addAssignment_11958,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,0)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11957,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,1)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11956,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,2)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11955,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,3)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11954,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,4)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11953,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,5)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11952,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,6)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11951,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,7)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11950,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,8)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11949,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,9)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11948,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,10)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11947,axiom,
    ! [VarCurr: state_type] :
      ( v23434(VarCurr,11)
    <=> v23435(VarCurr) ) ).

tff(addAssignment_11946,axiom,
    ! [VarCurr: state_type] :
      ( v23435(VarCurr)
    <=> v23257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23418(VarCurr,B)
      <=> ( v23419(VarCurr,B)
          | v23430(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23430(VarCurr,B)
      <=> ( v22986(VarCurr,B)
          & v23431(VarCurr,B) ) ) ) ).

tff(addAssignment_11945,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,0)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11944,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,1)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11943,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,2)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11942,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,3)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11941,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,4)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11940,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,5)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11939,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,6)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11938,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,7)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11937,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,8)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11936,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,9)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11935,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,10)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11934,axiom,
    ! [VarCurr: state_type] :
      ( v23431(VarCurr,11)
    <=> v23432(VarCurr) ) ).

tff(addAssignment_11933,axiom,
    ! [VarCurr: state_type] :
      ( v23432(VarCurr)
    <=> v23106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23419(VarCurr,B)
      <=> ( v23420(VarCurr,B)
          | v23427(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23427(VarCurr,B)
      <=> ( v22835(VarCurr,B)
          & v23428(VarCurr,B) ) ) ) ).

tff(addAssignment_11932,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,0)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11931,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,1)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11930,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,2)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11929,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,3)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11928,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,4)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11927,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,5)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11926,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,6)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11925,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,7)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11924,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,8)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11923,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,9)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11922,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,10)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11921,axiom,
    ! [VarCurr: state_type] :
      ( v23428(VarCurr,11)
    <=> v23429(VarCurr) ) ).

tff(addAssignment_11920,axiom,
    ! [VarCurr: state_type] :
      ( v23429(VarCurr)
    <=> v22955(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23420(VarCurr,B)
      <=> ( v23421(VarCurr,B)
          | v23424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23424(VarCurr,B)
      <=> ( v22673(VarCurr,B)
          & v23425(VarCurr,B) ) ) ) ).

tff(addAssignment_11919,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,0)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11918,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,1)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11917,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,2)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11916,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,3)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11915,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,4)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11914,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,5)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11913,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,6)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11912,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,7)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11911,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,8)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11910,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,9)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11909,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,10)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11908,axiom,
    ! [VarCurr: state_type] :
      ( v23425(VarCurr,11)
    <=> v23426(VarCurr) ) ).

tff(addAssignment_11907,axiom,
    ! [VarCurr: state_type] :
      ( v23426(VarCurr)
    <=> v22804(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23421(VarCurr,B)
      <=> ( v21911(VarCurr,B)
          & v23422(VarCurr,B) ) ) ) ).

tff(addAssignment_11906,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,0)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11905,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,1)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11904,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,2)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11903,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,3)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11902,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,4)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11901,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,5)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11900,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,6)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11899,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,7)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11898,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,8)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11897,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,9)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11896,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,10)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11895,axiom,
    ! [VarCurr: state_type] :
      ( v23422(VarCurr,11)
    <=> v23423(VarCurr) ) ).

tff(addAssignment_11894,axiom,
    ! [VarCurr: state_type] :
      ( v23423(VarCurr)
    <=> v22381(VarCurr) ) ).

tff(addAssignment_11893,axiom,
    ! [VarCurr: state_type] :
      ( v23407(VarCurr)
    <=> v23409(VarCurr) ) ).

tff(addAssignment_11892,axiom,
    ! [VarCurr: state_type] :
      ( v23409(VarCurr)
    <=> v23411(VarCurr) ) ).

tff(addAssignment_11891,axiom,
    ! [VarCurr: state_type] :
      ( v23411(VarCurr)
    <=> v23413(VarCurr) ) ).

tff(addAssignment_11890,axiom,
    ! [VarCurr: state_type] :
      ( v23413(VarCurr)
    <=> v23415(VarCurr) ) ).

tff(addAssignment_11889,axiom,
    ! [VarCurr: state_type] :
      ( v23415(VarCurr)
    <=> v22474(VarCurr) ) ).

tff(addAssignment_11888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23288(VarCurr,B)
      <=> v23290(VarCurr,B) ) ) ).

tff(addAssignment_11887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23290(VarCurr,B)
      <=> v23292(VarCurr,B) ) ) ).

tff(addAssignment_11886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23292(VarCurr,B)
      <=> v23294(VarCurr,B) ) ) ).

tff(addAssignment_11885,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23294(VarCurr,B)
      <=> v23296(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_265,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23390(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v23296(VarNext,B)
            <=> v23296(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_265,axiom,
    ! [VarNext: state_type] :
      ( v23390(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23296(VarNext,B)
          <=> v23400(VarNext,B) ) ) ) ).

tff(addAssignment_11884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23400(VarNext,B)
          <=> v23398(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23398(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_167,axiom,
    ! [VarCurr: state_type] :
      ( v23401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23398(VarCurr,B)
          <=> v23318(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1928,axiom,
    ! [VarCurr: state_type] :
      ( v23401(VarCurr)
    <=> ( v23402(VarCurr)
        & v23403(VarCurr) ) ) ).

tff(writeUnaryOperator_1286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23403(VarCurr)
    <=> v23308(VarCurr) ) ).

tff(writeUnaryOperator_1285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23402(VarCurr)
    <=> v23298(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1927,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23390(VarNext)
      <=> v23391(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1926,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23391(VarNext)
      <=> ( v23392(VarNext)
          & v23322(VarNext) ) ) ) ).

tff(writeUnaryOperator_1284,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23392(VarNext)
      <=> v23394(VarNext) ) ) ).

tff(addAssignment_11883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23394(VarNext)
      <=> v23322(VarCurr) ) ) ).

tff(addAssignment_11882,axiom,
    ! [VarCurr: state_type] :
      ( v23322(VarCurr)
    <=> v23324(VarCurr) ) ).

tff(addAssignment_11881,axiom,
    ! [VarCurr: state_type] :
      ( v23324(VarCurr)
    <=> v23326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1925,axiom,
    ! [VarCurr: state_type] :
      ( v23326(VarCurr)
    <=> ( v23387(VarCurr)
        | v23383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1924,axiom,
    ! [VarCurr: state_type] :
      ( v23387(VarCurr)
    <=> ( v23328(VarCurr)
        & v23332(VarCurr) ) ) ).

tff(addAssignment_11880,axiom,
    ! [VarCurr: state_type] :
      ( v23383(VarCurr)
    <=> v23385(VarCurr) ) ).

tff(addAssignment_11879,axiom,
    ! [VarCurr: state_type] :
      ( v23385(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23367(VarNext)
       => ( v23332(VarNext)
        <=> v23332(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_264,axiom,
    ! [VarNext: state_type] :
      ( v23367(VarNext)
     => ( v23332(VarNext)
      <=> v23377(VarNext) ) ) ).

tff(addAssignment_11878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23377(VarNext)
      <=> v23375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1923,axiom,
    ! [VarCurr: state_type] :
      ( v23375(VarCurr)
    <=> ( v23378(VarCurr)
        & v23379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1922,axiom,
    ! [VarCurr: state_type] :
      ( v23379(VarCurr)
    <=> ( v23338(VarCurr)
        | v23362(VarCurr) ) ) ).

tff(writeUnaryOperator_1283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23378(VarCurr)
    <=> v23334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1921,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23367(VarNext)
      <=> v23368(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1920,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23368(VarNext)
      <=> ( v23370(VarNext)
          & v23372(VarNext) ) ) ) ).

tff(writeUnaryOperator_1282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23372(VarCurr)
    <=> v23328(VarCurr) ) ).

tff(addAssignment_11877,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23370(VarNext)
      <=> v23328(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_96,axiom,
    ( v23332(constB0)
  <=> $true ) ).

tff(addAssignment_11876,axiom,
    ! [VarCurr: state_type] :
      ( v23362(VarCurr)
    <=> v23364(VarCurr) ) ).

tff(addAssignment_11875,axiom,
    ! [VarCurr: state_type] :
      ( v23364(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11874,axiom,
    ! [VarCurr: state_type] :
      ( v23338(VarCurr)
    <=> v23340(VarCurr) ) ).

tff(addAssignment_11873,axiom,
    ! [VarCurr: state_type] :
      ( v23340(VarCurr)
    <=> v22648(VarCurr) ) ).

tff(addAssignment_11872,axiom,
    ! [VarCurr: state_type] :
      ( v22648(VarCurr)
    <=> v23343(VarCurr) ) ).

tff(addAssignment_11871,axiom,
    ! [VarCurr: state_type] :
      ( v23343(VarCurr)
    <=> v23345(VarCurr) ) ).

tff(writeUnaryOperator_1281,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23345(VarCurr)
    <=> v23359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1919,axiom,
    ! [VarCurr: state_type] :
      ( v23359(VarCurr)
    <=> ( v23360(VarCurr)
        | v23355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1918,axiom,
    ! [VarCurr: state_type] :
      ( v23360(VarCurr)
    <=> ( v23347(VarCurr)
        | v23351(VarCurr) ) ) ).

tff(addAssignment_11870,axiom,
    ! [VarCurr: state_type] :
      ( v23355(VarCurr)
    <=> v23357(VarCurr) ) ).

tff(addAssignment_11869,axiom,
    ! [VarCurr: state_type] :
      ( v23357(VarCurr)
    <=> v22737(VarCurr,2) ) ).

tff(addAssignment_11868,axiom,
    ! [VarCurr: state_type] :
      ( v23351(VarCurr)
    <=> v23353(VarCurr) ) ).

tff(addAssignment_11867,axiom,
    ! [VarCurr: state_type] :
      ( v23353(VarCurr)
    <=> v22311(VarCurr,1) ) ).

tff(addAssignment_11866,axiom,
    ! [VarCurr: state_type] :
      ( v23347(VarCurr)
    <=> v23349(VarCurr) ) ).

tff(addAssignment_11865,axiom,
    ! [VarCurr: state_type] :
      ( v23349(VarCurr)
    <=> v22737(VarCurr,0) ) ).

tff(addAssignment_11864,axiom,
    ! [VarCurr: state_type] :
      ( v23334(VarCurr)
    <=> v23336(VarCurr) ) ).

tff(addAssignment_11863,axiom,
    ! [VarCurr: state_type] :
      ( v23336(VarCurr)
    <=> $false ) ).

tff(addAssignment_11862,axiom,
    ! [VarCurr: state_type] :
      ( v23328(VarCurr)
    <=> v23330(VarCurr) ) ).

tff(addAssignment_11861,axiom,
    ! [VarCurr: state_type] :
      ( v23330(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11860,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23318(VarCurr,B)
      <=> v23320(VarCurr,B) ) ) ).

tff(addAssignment_11859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23320(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11858,axiom,
    ! [VarCurr: state_type] :
      ( v23308(VarCurr)
    <=> v23310(VarCurr) ) ).

tff(addAssignment_11857,axiom,
    ! [VarCurr: state_type] :
      ( v23310(VarCurr)
    <=> v23312(VarCurr) ) ).

tff(addAssignment_11856,axiom,
    ! [VarCurr: state_type] :
      ( v23312(VarCurr)
    <=> v23314(VarCurr) ) ).

tff(addAssignment_11855,axiom,
    ! [VarCurr: state_type] :
      ( v23314(VarCurr)
    <=> v23316(VarCurr) ) ).

tff(addAssignment_11854,axiom,
    ! [VarCurr: state_type] :
      ( v23316(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11853,axiom,
    ! [VarCurr: state_type] :
      ( v23298(VarCurr)
    <=> v23300(VarCurr) ) ).

tff(addAssignment_11852,axiom,
    ! [VarCurr: state_type] :
      ( v23300(VarCurr)
    <=> v23302(VarCurr) ) ).

tff(addAssignment_11851,axiom,
    ! [VarCurr: state_type] :
      ( v23302(VarCurr)
    <=> v23304(VarCurr) ) ).

tff(addAssignment_11850,axiom,
    ! [VarCurr: state_type] :
      ( v23304(VarCurr)
    <=> v23306(VarCurr) ) ).

tff(addAssignment_11849,axiom,
    ! [VarCurr: state_type] :
      ( v23306(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11848,axiom,
    ! [VarCurr: state_type] :
      ( v23257(VarCurr)
    <=> v23259(VarCurr) ) ).

tff(addAssignment_11847,axiom,
    ! [VarCurr: state_type] :
      ( v23259(VarCurr)
    <=> v23261(VarCurr) ) ).

tff(addAssignment_11846,axiom,
    ! [VarCurr: state_type] :
      ( v23261(VarCurr)
    <=> v23263(VarCurr) ) ).

tff(addAssignment_11845,axiom,
    ! [VarCurr: state_type] :
      ( v23263(VarCurr)
    <=> v23265(VarCurr) ) ).

tff(addAssignment_11844,axiom,
    ! [VarCurr: state_type] :
      ( v23265(VarCurr)
    <=> v23267(VarCurr) ) ).

tff(addAssignment_11843,axiom,
    ! [VarCurr: state_type] :
      ( v23267(VarCurr)
    <=> v23269(VarCurr) ) ).

tff(addAssignment_11842,axiom,
    ! [VarCurr: state_type] :
      ( v23269(VarCurr)
    <=> v23271(VarCurr) ) ).

tff(writeUnaryOperator_1280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23271(VarCurr)
    <=> v23285(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1917,axiom,
    ! [VarCurr: state_type] :
      ( v23285(VarCurr)
    <=> ( v23286(VarCurr)
        | v23281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1916,axiom,
    ! [VarCurr: state_type] :
      ( v23286(VarCurr)
    <=> ( v23273(VarCurr)
        | v23277(VarCurr) ) ) ).

tff(addAssignment_11841,axiom,
    ! [VarCurr: state_type] :
      ( v23281(VarCurr)
    <=> v23283(VarCurr) ) ).

tff(addAssignment_11840,axiom,
    ! [VarCurr: state_type] :
      ( v23283(VarCurr)
    <=> v22484(VarCurr,2) ) ).

tff(addAssignment_11839,axiom,
    ! [VarCurr: state_type] :
      ( v23277(VarCurr)
    <=> v23279(VarCurr) ) ).

tff(addAssignment_11838,axiom,
    ! [VarCurr: state_type] :
      ( v23279(VarCurr)
    <=> v22401(VarCurr,1) ) ).

tff(addAssignment_11837,axiom,
    ! [VarCurr: state_type] :
      ( v23273(VarCurr)
    <=> v23275(VarCurr) ) ).

tff(addAssignment_11836,axiom,
    ! [VarCurr: state_type] :
      ( v23275(VarCurr)
    <=> v22401(VarCurr,0) ) ).

tff(addAssignment_11835,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23137(VarCurr,B)
      <=> v23139(VarCurr,B) ) ) ).

tff(addAssignment_11834,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23139(VarCurr,B)
      <=> v23141(VarCurr,B) ) ) ).

tff(addAssignment_11833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23141(VarCurr,B)
      <=> v23143(VarCurr,B) ) ) ).

tff(addAssignment_11832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23143(VarCurr,B)
      <=> v23145(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23240(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v23145(VarNext,B)
            <=> v23145(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_263,axiom,
    ! [VarNext: state_type] :
      ( v23240(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23145(VarNext,B)
          <=> v23250(VarNext,B) ) ) ) ).

tff(addAssignment_11831,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23250(VarNext,B)
          <=> v23248(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23251(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23248(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_166,axiom,
    ! [VarCurr: state_type] :
      ( v23251(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23248(VarCurr,B)
          <=> v23167(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1915,axiom,
    ! [VarCurr: state_type] :
      ( v23251(VarCurr)
    <=> ( v23252(VarCurr)
        & v23253(VarCurr) ) ) ).

tff(writeUnaryOperator_1279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23253(VarCurr)
    <=> v23157(VarCurr) ) ).

tff(writeUnaryOperator_1278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23252(VarCurr)
    <=> v23147(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23240(VarNext)
      <=> v23241(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1913,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23241(VarNext)
      <=> ( v23242(VarNext)
          & v23171(VarNext) ) ) ) ).

tff(writeUnaryOperator_1277,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23242(VarNext)
      <=> v23244(VarNext) ) ) ).

tff(addAssignment_11830,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23244(VarNext)
      <=> v23171(VarCurr) ) ) ).

tff(addAssignment_11829,axiom,
    ! [VarCurr: state_type] :
      ( v23171(VarCurr)
    <=> v23173(VarCurr) ) ).

tff(addAssignment_11828,axiom,
    ! [VarCurr: state_type] :
      ( v23173(VarCurr)
    <=> v23175(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1912,axiom,
    ! [VarCurr: state_type] :
      ( v23175(VarCurr)
    <=> ( v23237(VarCurr)
        | v23233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1911,axiom,
    ! [VarCurr: state_type] :
      ( v23237(VarCurr)
    <=> ( v23177(VarCurr)
        & v23181(VarCurr) ) ) ).

tff(addAssignment_11827,axiom,
    ! [VarCurr: state_type] :
      ( v23233(VarCurr)
    <=> v23235(VarCurr) ) ).

tff(addAssignment_11826,axiom,
    ! [VarCurr: state_type] :
      ( v23235(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_262,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23217(VarNext)
       => ( v23181(VarNext)
        <=> v23181(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_262,axiom,
    ! [VarNext: state_type] :
      ( v23217(VarNext)
     => ( v23181(VarNext)
      <=> v23227(VarNext) ) ) ).

tff(addAssignment_11825,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23227(VarNext)
      <=> v23225(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1910,axiom,
    ! [VarCurr: state_type] :
      ( v23225(VarCurr)
    <=> ( v23228(VarCurr)
        & v23229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1909,axiom,
    ! [VarCurr: state_type] :
      ( v23229(VarCurr)
    <=> ( v23187(VarCurr)
        | v23212(VarCurr) ) ) ).

tff(writeUnaryOperator_1276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23228(VarCurr)
    <=> v23183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23217(VarNext)
      <=> v23218(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23218(VarNext)
      <=> ( v23220(VarNext)
          & v23222(VarNext) ) ) ) ).

tff(writeUnaryOperator_1275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23222(VarCurr)
    <=> v23177(VarCurr) ) ).

tff(addAssignment_11824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23220(VarNext)
      <=> v23177(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_95,axiom,
    ( v23181(constB0)
  <=> $true ) ).

tff(addAssignment_11823,axiom,
    ! [VarCurr: state_type] :
      ( v23212(VarCurr)
    <=> v23214(VarCurr) ) ).

tff(addAssignment_11822,axiom,
    ! [VarCurr: state_type] :
      ( v23214(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11821,axiom,
    ! [VarCurr: state_type] :
      ( v23187(VarCurr)
    <=> v23189(VarCurr) ) ).

tff(addAssignment_11820,axiom,
    ! [VarCurr: state_type] :
      ( v23189(VarCurr)
    <=> v23191(VarCurr) ) ).

tff(addAssignment_11819,axiom,
    ! [VarCurr: state_type] :
      ( v23191(VarCurr)
    <=> v23193(VarCurr) ) ).

tff(addAssignment_11818,axiom,
    ! [VarCurr: state_type] :
      ( v23193(VarCurr)
    <=> v23195(VarCurr) ) ).

tff(writeUnaryOperator_1274,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23195(VarCurr)
    <=> v23209(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1906,axiom,
    ! [VarCurr: state_type] :
      ( v23209(VarCurr)
    <=> ( v23210(VarCurr)
        | v23205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1905,axiom,
    ! [VarCurr: state_type] :
      ( v23210(VarCurr)
    <=> ( v23197(VarCurr)
        | v23201(VarCurr) ) ) ).

tff(addAssignment_11817,axiom,
    ! [VarCurr: state_type] :
      ( v23205(VarCurr)
    <=> v23207(VarCurr) ) ).

tff(addAssignment_11816,axiom,
    ! [VarCurr: state_type] :
      ( v23207(VarCurr)
    <=> v22737(VarCurr,2) ) ).

tff(addAssignment_11815,axiom,
    ! [VarCurr: state_type] :
      ( v22737(VarCurr,2)
    <=> v22739(VarCurr,2) ) ).

tff(addAssignment_11814,axiom,
    ! [VarCurr: state_type] :
      ( v22739(VarCurr,2)
    <=> v22741(VarCurr,2) ) ).

tff(addAssignment_11813,axiom,
    ! [VarCurr: state_type] :
      ( v22741(VarCurr,2)
    <=> v22746(VarCurr,2) ) ).

tff(addAssignment_11812,axiom,
    ! [VarCurr: state_type] :
      ( v22743(VarCurr,2)
    <=> v22745(VarCurr,2) ) ).

tff(addAssignment_11811,axiom,
    ! [VarCurr: state_type] :
      ( v22745(VarCurr,2)
    <=> v22311(VarCurr,2) ) ).

tff(addAssignment_11810,axiom,
    ! [VarCurr: state_type] :
      ( v23201(VarCurr)
    <=> v23203(VarCurr) ) ).

tff(addAssignment_11809,axiom,
    ! [VarCurr: state_type] :
      ( v23203(VarCurr)
    <=> v22311(VarCurr,1) ) ).

tff(addAssignment_11808,axiom,
    ! [VarCurr: state_type] :
      ( v23197(VarCurr)
    <=> v23199(VarCurr) ) ).

tff(addAssignment_11807,axiom,
    ! [VarCurr: state_type] :
      ( v23199(VarCurr)
    <=> v22311(VarCurr,0) ) ).

tff(addAssignment_11806,axiom,
    ! [VarCurr: state_type] :
      ( v23183(VarCurr)
    <=> v23185(VarCurr) ) ).

tff(addAssignment_11805,axiom,
    ! [VarCurr: state_type] :
      ( v23185(VarCurr)
    <=> $false ) ).

tff(addAssignment_11804,axiom,
    ! [VarCurr: state_type] :
      ( v23177(VarCurr)
    <=> v23179(VarCurr) ) ).

tff(addAssignment_11803,axiom,
    ! [VarCurr: state_type] :
      ( v23179(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23167(VarCurr,B)
      <=> v23169(VarCurr,B) ) ) ).

tff(addAssignment_11801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23169(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11800,axiom,
    ! [VarCurr: state_type] :
      ( v23157(VarCurr)
    <=> v23159(VarCurr) ) ).

tff(addAssignment_11799,axiom,
    ! [VarCurr: state_type] :
      ( v23159(VarCurr)
    <=> v23161(VarCurr) ) ).

tff(addAssignment_11798,axiom,
    ! [VarCurr: state_type] :
      ( v23161(VarCurr)
    <=> v23163(VarCurr) ) ).

tff(addAssignment_11797,axiom,
    ! [VarCurr: state_type] :
      ( v23163(VarCurr)
    <=> v23165(VarCurr) ) ).

tff(addAssignment_11796,axiom,
    ! [VarCurr: state_type] :
      ( v23165(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11795,axiom,
    ! [VarCurr: state_type] :
      ( v23147(VarCurr)
    <=> v23149(VarCurr) ) ).

tff(addAssignment_11794,axiom,
    ! [VarCurr: state_type] :
      ( v23149(VarCurr)
    <=> v23151(VarCurr) ) ).

tff(addAssignment_11793,axiom,
    ! [VarCurr: state_type] :
      ( v23151(VarCurr)
    <=> v23153(VarCurr) ) ).

tff(addAssignment_11792,axiom,
    ! [VarCurr: state_type] :
      ( v23153(VarCurr)
    <=> v23155(VarCurr) ) ).

tff(addAssignment_11791,axiom,
    ! [VarCurr: state_type] :
      ( v23155(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11790,axiom,
    ! [VarCurr: state_type] :
      ( v23106(VarCurr)
    <=> v23108(VarCurr) ) ).

tff(addAssignment_11789,axiom,
    ! [VarCurr: state_type] :
      ( v23108(VarCurr)
    <=> v23110(VarCurr) ) ).

tff(addAssignment_11788,axiom,
    ! [VarCurr: state_type] :
      ( v23110(VarCurr)
    <=> v23112(VarCurr) ) ).

tff(addAssignment_11787,axiom,
    ! [VarCurr: state_type] :
      ( v23112(VarCurr)
    <=> v23114(VarCurr) ) ).

tff(addAssignment_11786,axiom,
    ! [VarCurr: state_type] :
      ( v23114(VarCurr)
    <=> v23116(VarCurr) ) ).

tff(addAssignment_11785,axiom,
    ! [VarCurr: state_type] :
      ( v23116(VarCurr)
    <=> v23118(VarCurr) ) ).

tff(addAssignment_11784,axiom,
    ! [VarCurr: state_type] :
      ( v23118(VarCurr)
    <=> v23120(VarCurr) ) ).

tff(writeUnaryOperator_1273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23120(VarCurr)
    <=> v23134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1904,axiom,
    ! [VarCurr: state_type] :
      ( v23134(VarCurr)
    <=> ( v23135(VarCurr)
        | v23130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1903,axiom,
    ! [VarCurr: state_type] :
      ( v23135(VarCurr)
    <=> ( v23122(VarCurr)
        | v23126(VarCurr) ) ) ).

tff(addAssignment_11783,axiom,
    ! [VarCurr: state_type] :
      ( v23130(VarCurr)
    <=> v23132(VarCurr) ) ).

tff(addAssignment_11782,axiom,
    ! [VarCurr: state_type] :
      ( v23132(VarCurr)
    <=> v22401(VarCurr,2) ) ).

tff(addAssignment_11781,axiom,
    ! [VarCurr: state_type] :
      ( v23126(VarCurr)
    <=> v23128(VarCurr) ) ).

tff(addAssignment_11780,axiom,
    ! [VarCurr: state_type] :
      ( v23128(VarCurr)
    <=> v22484(VarCurr,1) ) ).

tff(addAssignment_11779,axiom,
    ! [VarCurr: state_type] :
      ( v23122(VarCurr)
    <=> v23124(VarCurr) ) ).

tff(addAssignment_11778,axiom,
    ! [VarCurr: state_type] :
      ( v23124(VarCurr)
    <=> v22484(VarCurr,0) ) ).

tff(addAssignment_11777,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22986(VarCurr,B)
      <=> v22988(VarCurr,B) ) ) ).

tff(addAssignment_11776,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22988(VarCurr,B)
      <=> v22990(VarCurr,B) ) ) ).

tff(addAssignment_11775,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22990(VarCurr,B)
      <=> v22992(VarCurr,B) ) ) ).

tff(addAssignment_11774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22992(VarCurr,B)
      <=> v22994(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_261,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23089(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v22994(VarNext,B)
            <=> v22994(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_261,axiom,
    ! [VarNext: state_type] :
      ( v23089(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22994(VarNext,B)
          <=> v23099(VarNext,B) ) ) ) ).

tff(addAssignment_11773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23099(VarNext,B)
          <=> v23097(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23097(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_165,axiom,
    ! [VarCurr: state_type] :
      ( v23100(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v23097(VarCurr,B)
          <=> v23016(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1902,axiom,
    ! [VarCurr: state_type] :
      ( v23100(VarCurr)
    <=> ( v23101(VarCurr)
        & v23102(VarCurr) ) ) ).

tff(writeUnaryOperator_1272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23102(VarCurr)
    <=> v23006(VarCurr) ) ).

tff(writeUnaryOperator_1271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23101(VarCurr)
    <=> v22996(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23089(VarNext)
      <=> v23090(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23090(VarNext)
      <=> ( v23091(VarNext)
          & v23020(VarNext) ) ) ) ).

tff(writeUnaryOperator_1270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23091(VarNext)
      <=> v23093(VarNext) ) ) ).

tff(addAssignment_11772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23093(VarNext)
      <=> v23020(VarCurr) ) ) ).

tff(addAssignment_11771,axiom,
    ! [VarCurr: state_type] :
      ( v23020(VarCurr)
    <=> v23022(VarCurr) ) ).

tff(addAssignment_11770,axiom,
    ! [VarCurr: state_type] :
      ( v23022(VarCurr)
    <=> v23024(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1899,axiom,
    ! [VarCurr: state_type] :
      ( v23024(VarCurr)
    <=> ( v23086(VarCurr)
        | v23082(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1898,axiom,
    ! [VarCurr: state_type] :
      ( v23086(VarCurr)
    <=> ( v23026(VarCurr)
        & v23030(VarCurr) ) ) ).

tff(addAssignment_11769,axiom,
    ! [VarCurr: state_type] :
      ( v23082(VarCurr)
    <=> v23084(VarCurr) ) ).

tff(addAssignment_11768,axiom,
    ! [VarCurr: state_type] :
      ( v23084(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v23066(VarNext)
       => ( v23030(VarNext)
        <=> v23030(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_260,axiom,
    ! [VarNext: state_type] :
      ( v23066(VarNext)
     => ( v23030(VarNext)
      <=> v23076(VarNext) ) ) ).

tff(addAssignment_11767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23076(VarNext)
      <=> v23074(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1897,axiom,
    ! [VarCurr: state_type] :
      ( v23074(VarCurr)
    <=> ( v23077(VarCurr)
        & v23078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1896,axiom,
    ! [VarCurr: state_type] :
      ( v23078(VarCurr)
    <=> ( v23036(VarCurr)
        | v23061(VarCurr) ) ) ).

tff(writeUnaryOperator_1269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23077(VarCurr)
    <=> v23032(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1895,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23066(VarNext)
      <=> v23067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1894,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23067(VarNext)
      <=> ( v23069(VarNext)
          & v23071(VarNext) ) ) ) ).

tff(writeUnaryOperator_1268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23071(VarCurr)
    <=> v23026(VarCurr) ) ).

tff(addAssignment_11766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v23069(VarNext)
      <=> v23026(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_94,axiom,
    ( v23030(constB0)
  <=> $true ) ).

tff(addAssignment_11765,axiom,
    ! [VarCurr: state_type] :
      ( v23061(VarCurr)
    <=> v23063(VarCurr) ) ).

tff(addAssignment_11764,axiom,
    ! [VarCurr: state_type] :
      ( v23063(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11763,axiom,
    ! [VarCurr: state_type] :
      ( v23036(VarCurr)
    <=> v23038(VarCurr) ) ).

tff(addAssignment_11762,axiom,
    ! [VarCurr: state_type] :
      ( v23038(VarCurr)
    <=> v23040(VarCurr) ) ).

tff(addAssignment_11761,axiom,
    ! [VarCurr: state_type] :
      ( v23040(VarCurr)
    <=> v23042(VarCurr) ) ).

tff(addAssignment_11760,axiom,
    ! [VarCurr: state_type] :
      ( v23042(VarCurr)
    <=> v23044(VarCurr) ) ).

tff(writeUnaryOperator_1267,axiom,
    ! [VarCurr: state_type] :
      ( ~ v23044(VarCurr)
    <=> v23058(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1893,axiom,
    ! [VarCurr: state_type] :
      ( v23058(VarCurr)
    <=> ( v23059(VarCurr)
        | v23054(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1892,axiom,
    ! [VarCurr: state_type] :
      ( v23059(VarCurr)
    <=> ( v23046(VarCurr)
        | v23050(VarCurr) ) ) ).

tff(addAssignment_11759,axiom,
    ! [VarCurr: state_type] :
      ( v23054(VarCurr)
    <=> v23056(VarCurr) ) ).

tff(addAssignment_11758,axiom,
    ! [VarCurr: state_type] :
      ( v23056(VarCurr)
    <=> v22311(VarCurr,2) ) ).

tff(addAssignment_11757,axiom,
    ! [VarCurr: state_type] :
      ( v23050(VarCurr)
    <=> v23052(VarCurr) ) ).

tff(addAssignment_11756,axiom,
    ! [VarCurr: state_type] :
      ( v23052(VarCurr)
    <=> v22737(VarCurr,1) ) ).

tff(addAssignment_11755,axiom,
    ! [VarCurr: state_type] :
      ( v23046(VarCurr)
    <=> v23048(VarCurr) ) ).

tff(addAssignment_11754,axiom,
    ! [VarCurr: state_type] :
      ( v23048(VarCurr)
    <=> v22737(VarCurr,0) ) ).

tff(addAssignment_11753,axiom,
    ! [VarCurr: state_type] :
      ( v23032(VarCurr)
    <=> v23034(VarCurr) ) ).

tff(addAssignment_11752,axiom,
    ! [VarCurr: state_type] :
      ( v23034(VarCurr)
    <=> $false ) ).

tff(addAssignment_11751,axiom,
    ! [VarCurr: state_type] :
      ( v23026(VarCurr)
    <=> v23028(VarCurr) ) ).

tff(addAssignment_11750,axiom,
    ! [VarCurr: state_type] :
      ( v23028(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11749,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23016(VarCurr,B)
      <=> v23018(VarCurr,B) ) ) ).

tff(addAssignment_11748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v23018(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11747,axiom,
    ! [VarCurr: state_type] :
      ( v23006(VarCurr)
    <=> v23008(VarCurr) ) ).

tff(addAssignment_11746,axiom,
    ! [VarCurr: state_type] :
      ( v23008(VarCurr)
    <=> v23010(VarCurr) ) ).

tff(addAssignment_11745,axiom,
    ! [VarCurr: state_type] :
      ( v23010(VarCurr)
    <=> v23012(VarCurr) ) ).

tff(addAssignment_11744,axiom,
    ! [VarCurr: state_type] :
      ( v23012(VarCurr)
    <=> v23014(VarCurr) ) ).

tff(addAssignment_11743,axiom,
    ! [VarCurr: state_type] :
      ( v23014(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11742,axiom,
    ! [VarCurr: state_type] :
      ( v22996(VarCurr)
    <=> v22998(VarCurr) ) ).

tff(addAssignment_11741,axiom,
    ! [VarCurr: state_type] :
      ( v22998(VarCurr)
    <=> v23000(VarCurr) ) ).

tff(addAssignment_11740,axiom,
    ! [VarCurr: state_type] :
      ( v23000(VarCurr)
    <=> v23002(VarCurr) ) ).

tff(addAssignment_11739,axiom,
    ! [VarCurr: state_type] :
      ( v23002(VarCurr)
    <=> v23004(VarCurr) ) ).

tff(addAssignment_11738,axiom,
    ! [VarCurr: state_type] :
      ( v23004(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11737,axiom,
    ! [VarCurr: state_type] :
      ( v22955(VarCurr)
    <=> v22957(VarCurr) ) ).

tff(addAssignment_11736,axiom,
    ! [VarCurr: state_type] :
      ( v22957(VarCurr)
    <=> v22959(VarCurr) ) ).

tff(addAssignment_11735,axiom,
    ! [VarCurr: state_type] :
      ( v22959(VarCurr)
    <=> v22961(VarCurr) ) ).

tff(addAssignment_11734,axiom,
    ! [VarCurr: state_type] :
      ( v22961(VarCurr)
    <=> v22963(VarCurr) ) ).

tff(addAssignment_11733,axiom,
    ! [VarCurr: state_type] :
      ( v22963(VarCurr)
    <=> v22965(VarCurr) ) ).

tff(addAssignment_11732,axiom,
    ! [VarCurr: state_type] :
      ( v22965(VarCurr)
    <=> v22967(VarCurr) ) ).

tff(addAssignment_11731,axiom,
    ! [VarCurr: state_type] :
      ( v22967(VarCurr)
    <=> v22969(VarCurr) ) ).

tff(writeUnaryOperator_1266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22969(VarCurr)
    <=> v22983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1891,axiom,
    ! [VarCurr: state_type] :
      ( v22983(VarCurr)
    <=> ( v22984(VarCurr)
        | v22979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1890,axiom,
    ! [VarCurr: state_type] :
      ( v22984(VarCurr)
    <=> ( v22971(VarCurr)
        | v22975(VarCurr) ) ) ).

tff(addAssignment_11730,axiom,
    ! [VarCurr: state_type] :
      ( v22979(VarCurr)
    <=> v22981(VarCurr) ) ).

tff(addAssignment_11729,axiom,
    ! [VarCurr: state_type] :
      ( v22981(VarCurr)
    <=> v22401(VarCurr,2) ) ).

tff(addAssignment_11728,axiom,
    ! [VarCurr: state_type] :
      ( v22975(VarCurr)
    <=> v22977(VarCurr) ) ).

tff(addAssignment_11727,axiom,
    ! [VarCurr: state_type] :
      ( v22977(VarCurr)
    <=> v22484(VarCurr,1) ) ).

tff(addAssignment_11726,axiom,
    ! [VarCurr: state_type] :
      ( v22484(VarCurr,1)
    <=> v22486(VarCurr,1) ) ).

tff(addAssignment_11725,axiom,
    ! [VarCurr: state_type] :
      ( v22486(VarCurr,1)
    <=> v22488(VarCurr,1) ) ).

tff(addAssignment_11724,axiom,
    ! [VarCurr: state_type] :
      ( v22488(VarCurr,1)
    <=> v22493(VarCurr,1) ) ).

tff(addAssignment_11723,axiom,
    ! [VarCurr: state_type] :
      ( v22490(VarCurr,1)
    <=> v22492(VarCurr,1) ) ).

tff(addAssignment_11722,axiom,
    ! [VarCurr: state_type] :
      ( v22492(VarCurr,1)
    <=> v22401(VarCurr,1) ) ).

tff(addAssignment_11721,axiom,
    ! [VarCurr: state_type] :
      ( v22971(VarCurr)
    <=> v22973(VarCurr) ) ).

tff(addAssignment_11720,axiom,
    ! [VarCurr: state_type] :
      ( v22973(VarCurr)
    <=> v22401(VarCurr,0) ) ).

tff(addAssignment_11719,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22835(VarCurr,B)
      <=> v22837(VarCurr,B) ) ) ).

tff(addAssignment_11718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22837(VarCurr,B)
      <=> v22839(VarCurr,B) ) ) ).

tff(addAssignment_11717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22839(VarCurr,B)
      <=> v22841(VarCurr,B) ) ) ).

tff(addAssignment_11716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22841(VarCurr,B)
      <=> v22843(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22938(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v22843(VarNext,B)
            <=> v22843(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_259,axiom,
    ! [VarNext: state_type] :
      ( v22938(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22843(VarNext,B)
          <=> v22948(VarNext,B) ) ) ) ).

tff(addAssignment_11715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22948(VarNext,B)
          <=> v22946(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22949(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22946(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_164,axiom,
    ! [VarCurr: state_type] :
      ( v22949(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22946(VarCurr,B)
          <=> v22865(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1889,axiom,
    ! [VarCurr: state_type] :
      ( v22949(VarCurr)
    <=> ( v22950(VarCurr)
        & v22951(VarCurr) ) ) ).

tff(writeUnaryOperator_1265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22951(VarCurr)
    <=> v22855(VarCurr) ) ).

tff(writeUnaryOperator_1264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22950(VarCurr)
    <=> v22845(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22938(VarNext)
      <=> v22939(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22939(VarNext)
      <=> ( v22940(VarNext)
          & v22869(VarNext) ) ) ) ).

tff(writeUnaryOperator_1263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22940(VarNext)
      <=> v22942(VarNext) ) ) ).

tff(addAssignment_11714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22942(VarNext)
      <=> v22869(VarCurr) ) ) ).

tff(addAssignment_11713,axiom,
    ! [VarCurr: state_type] :
      ( v22869(VarCurr)
    <=> v22871(VarCurr) ) ).

tff(addAssignment_11712,axiom,
    ! [VarCurr: state_type] :
      ( v22871(VarCurr)
    <=> v22873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1886,axiom,
    ! [VarCurr: state_type] :
      ( v22873(VarCurr)
    <=> ( v22935(VarCurr)
        | v22931(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1885,axiom,
    ! [VarCurr: state_type] :
      ( v22935(VarCurr)
    <=> ( v22875(VarCurr)
        & v22879(VarCurr) ) ) ).

tff(addAssignment_11711,axiom,
    ! [VarCurr: state_type] :
      ( v22931(VarCurr)
    <=> v22933(VarCurr) ) ).

tff(addAssignment_11710,axiom,
    ! [VarCurr: state_type] :
      ( v22933(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22915(VarNext)
       => ( v22879(VarNext)
        <=> v22879(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_258,axiom,
    ! [VarNext: state_type] :
      ( v22915(VarNext)
     => ( v22879(VarNext)
      <=> v22925(VarNext) ) ) ).

tff(addAssignment_11709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22925(VarNext)
      <=> v22923(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1884,axiom,
    ! [VarCurr: state_type] :
      ( v22923(VarCurr)
    <=> ( v22926(VarCurr)
        & v22927(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1883,axiom,
    ! [VarCurr: state_type] :
      ( v22927(VarCurr)
    <=> ( v22885(VarCurr)
        | v22910(VarCurr) ) ) ).

tff(writeUnaryOperator_1262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22926(VarCurr)
    <=> v22881(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22915(VarNext)
      <=> v22916(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22916(VarNext)
      <=> ( v22918(VarNext)
          & v22920(VarNext) ) ) ) ).

tff(writeUnaryOperator_1261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22920(VarCurr)
    <=> v22875(VarCurr) ) ).

tff(addAssignment_11708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22918(VarNext)
      <=> v22875(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_93,axiom,
    ( v22879(constB0)
  <=> $true ) ).

tff(addAssignment_11707,axiom,
    ! [VarCurr: state_type] :
      ( v22910(VarCurr)
    <=> v22912(VarCurr) ) ).

tff(addAssignment_11706,axiom,
    ! [VarCurr: state_type] :
      ( v22912(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11705,axiom,
    ! [VarCurr: state_type] :
      ( v22885(VarCurr)
    <=> v22887(VarCurr) ) ).

tff(addAssignment_11704,axiom,
    ! [VarCurr: state_type] :
      ( v22887(VarCurr)
    <=> v22889(VarCurr) ) ).

tff(addAssignment_11703,axiom,
    ! [VarCurr: state_type] :
      ( v22889(VarCurr)
    <=> v22891(VarCurr) ) ).

tff(addAssignment_11702,axiom,
    ! [VarCurr: state_type] :
      ( v22891(VarCurr)
    <=> v22893(VarCurr) ) ).

tff(writeUnaryOperator_1260,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22893(VarCurr)
    <=> v22907(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1880,axiom,
    ! [VarCurr: state_type] :
      ( v22907(VarCurr)
    <=> ( v22908(VarCurr)
        | v22903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1879,axiom,
    ! [VarCurr: state_type] :
      ( v22908(VarCurr)
    <=> ( v22895(VarCurr)
        | v22899(VarCurr) ) ) ).

tff(addAssignment_11701,axiom,
    ! [VarCurr: state_type] :
      ( v22903(VarCurr)
    <=> v22905(VarCurr) ) ).

tff(addAssignment_11700,axiom,
    ! [VarCurr: state_type] :
      ( v22905(VarCurr)
    <=> v22311(VarCurr,2) ) ).

tff(addAssignment_11699,axiom,
    ! [VarCurr: state_type] :
      ( v22899(VarCurr)
    <=> v22901(VarCurr) ) ).

tff(addAssignment_11698,axiom,
    ! [VarCurr: state_type] :
      ( v22901(VarCurr)
    <=> v22737(VarCurr,1) ) ).

tff(addAssignment_11697,axiom,
    ! [VarCurr: state_type] :
      ( v22737(VarCurr,1)
    <=> v22739(VarCurr,1) ) ).

tff(addAssignment_11696,axiom,
    ! [VarCurr: state_type] :
      ( v22739(VarCurr,1)
    <=> v22741(VarCurr,1) ) ).

tff(addAssignment_11695,axiom,
    ! [VarCurr: state_type] :
      ( v22741(VarCurr,1)
    <=> v22746(VarCurr,1) ) ).

tff(addAssignment_11694,axiom,
    ! [VarCurr: state_type] :
      ( v22743(VarCurr,1)
    <=> v22745(VarCurr,1) ) ).

tff(addAssignment_11693,axiom,
    ! [VarCurr: state_type] :
      ( v22745(VarCurr,1)
    <=> v22311(VarCurr,1) ) ).

tff(addAssignment_11692,axiom,
    ! [VarCurr: state_type] :
      ( v22895(VarCurr)
    <=> v22897(VarCurr) ) ).

tff(addAssignment_11691,axiom,
    ! [VarCurr: state_type] :
      ( v22897(VarCurr)
    <=> v22311(VarCurr,0) ) ).

tff(addAssignment_11690,axiom,
    ! [VarCurr: state_type] :
      ( v22881(VarCurr)
    <=> v22883(VarCurr) ) ).

tff(addAssignment_11689,axiom,
    ! [VarCurr: state_type] :
      ( v22883(VarCurr)
    <=> $false ) ).

tff(addAssignment_11688,axiom,
    ! [VarCurr: state_type] :
      ( v22875(VarCurr)
    <=> v22877(VarCurr) ) ).

tff(addAssignment_11687,axiom,
    ! [VarCurr: state_type] :
      ( v22877(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22865(VarCurr,B)
      <=> v22867(VarCurr,B) ) ) ).

tff(addAssignment_11685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22867(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11684,axiom,
    ! [VarCurr: state_type] :
      ( v22855(VarCurr)
    <=> v22857(VarCurr) ) ).

tff(addAssignment_11683,axiom,
    ! [VarCurr: state_type] :
      ( v22857(VarCurr)
    <=> v22859(VarCurr) ) ).

tff(addAssignment_11682,axiom,
    ! [VarCurr: state_type] :
      ( v22859(VarCurr)
    <=> v22861(VarCurr) ) ).

tff(addAssignment_11681,axiom,
    ! [VarCurr: state_type] :
      ( v22861(VarCurr)
    <=> v22863(VarCurr) ) ).

tff(addAssignment_11680,axiom,
    ! [VarCurr: state_type] :
      ( v22863(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11679,axiom,
    ! [VarCurr: state_type] :
      ( v22845(VarCurr)
    <=> v22847(VarCurr) ) ).

tff(addAssignment_11678,axiom,
    ! [VarCurr: state_type] :
      ( v22847(VarCurr)
    <=> v22849(VarCurr) ) ).

tff(addAssignment_11677,axiom,
    ! [VarCurr: state_type] :
      ( v22849(VarCurr)
    <=> v22851(VarCurr) ) ).

tff(addAssignment_11676,axiom,
    ! [VarCurr: state_type] :
      ( v22851(VarCurr)
    <=> v22853(VarCurr) ) ).

tff(addAssignment_11675,axiom,
    ! [VarCurr: state_type] :
      ( v22853(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11674,axiom,
    ! [VarCurr: state_type] :
      ( v22804(VarCurr)
    <=> v22806(VarCurr) ) ).

tff(addAssignment_11673,axiom,
    ! [VarCurr: state_type] :
      ( v22806(VarCurr)
    <=> v22808(VarCurr) ) ).

tff(addAssignment_11672,axiom,
    ! [VarCurr: state_type] :
      ( v22808(VarCurr)
    <=> v22810(VarCurr) ) ).

tff(addAssignment_11671,axiom,
    ! [VarCurr: state_type] :
      ( v22810(VarCurr)
    <=> v22812(VarCurr) ) ).

tff(addAssignment_11670,axiom,
    ! [VarCurr: state_type] :
      ( v22812(VarCurr)
    <=> v22814(VarCurr) ) ).

tff(addAssignment_11669,axiom,
    ! [VarCurr: state_type] :
      ( v22814(VarCurr)
    <=> v22816(VarCurr) ) ).

tff(addAssignment_11668,axiom,
    ! [VarCurr: state_type] :
      ( v22816(VarCurr)
    <=> v22818(VarCurr) ) ).

tff(writeUnaryOperator_1259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22818(VarCurr)
    <=> v22832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1878,axiom,
    ! [VarCurr: state_type] :
      ( v22832(VarCurr)
    <=> ( v22833(VarCurr)
        | v22828(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1877,axiom,
    ! [VarCurr: state_type] :
      ( v22833(VarCurr)
    <=> ( v22820(VarCurr)
        | v22824(VarCurr) ) ) ).

tff(addAssignment_11667,axiom,
    ! [VarCurr: state_type] :
      ( v22828(VarCurr)
    <=> v22830(VarCurr) ) ).

tff(addAssignment_11666,axiom,
    ! [VarCurr: state_type] :
      ( v22830(VarCurr)
    <=> v22401(VarCurr,2) ) ).

tff(addAssignment_11665,axiom,
    ! [VarCurr: state_type] :
      ( v22824(VarCurr)
    <=> v22826(VarCurr) ) ).

tff(addAssignment_11664,axiom,
    ! [VarCurr: state_type] :
      ( v22826(VarCurr)
    <=> v22401(VarCurr,1) ) ).

tff(addAssignment_11663,axiom,
    ! [VarCurr: state_type] :
      ( v22820(VarCurr)
    <=> v22822(VarCurr) ) ).

tff(addAssignment_11662,axiom,
    ! [VarCurr: state_type] :
      ( v22822(VarCurr)
    <=> v22484(VarCurr,0) ) ).

tff(addAssignment_11661,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22673(VarCurr,B)
      <=> v22675(VarCurr,B) ) ) ).

tff(addAssignment_11660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22675(VarCurr,B)
      <=> v22677(VarCurr,B) ) ) ).

tff(addAssignment_11659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22677(VarCurr,B)
      <=> v22679(VarCurr,B) ) ) ).

tff(addAssignment_11658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22679(VarCurr,B)
      <=> v22681(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_257,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22787(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v22681(VarNext,B)
            <=> v22681(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_257,axiom,
    ! [VarNext: state_type] :
      ( v22787(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22681(VarNext,B)
          <=> v22797(VarNext,B) ) ) ) ).

tff(addAssignment_11657,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22797(VarNext,B)
          <=> v22795(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22798(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22795(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_163,axiom,
    ! [VarCurr: state_type] :
      ( v22798(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22795(VarCurr,B)
          <=> v22703(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1876,axiom,
    ! [VarCurr: state_type] :
      ( v22798(VarCurr)
    <=> ( v22799(VarCurr)
        & v22800(VarCurr) ) ) ).

tff(writeUnaryOperator_1258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22800(VarCurr)
    <=> v22693(VarCurr) ) ).

tff(writeUnaryOperator_1257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22799(VarCurr)
    <=> v22683(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22787(VarNext)
      <=> v22788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22788(VarNext)
      <=> ( v22789(VarNext)
          & v22707(VarNext) ) ) ) ).

tff(writeUnaryOperator_1256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22789(VarNext)
      <=> v22791(VarNext) ) ) ).

tff(addAssignment_11656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22791(VarNext)
      <=> v22707(VarCurr) ) ) ).

tff(addAssignment_11655,axiom,
    ! [VarCurr: state_type] :
      ( v22707(VarCurr)
    <=> v22709(VarCurr) ) ).

tff(addAssignment_11654,axiom,
    ! [VarCurr: state_type] :
      ( v22709(VarCurr)
    <=> v22711(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1873,axiom,
    ! [VarCurr: state_type] :
      ( v22711(VarCurr)
    <=> ( v22784(VarCurr)
        | v22780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1872,axiom,
    ! [VarCurr: state_type] :
      ( v22784(VarCurr)
    <=> ( v22713(VarCurr)
        & v22717(VarCurr) ) ) ).

tff(addAssignment_11653,axiom,
    ! [VarCurr: state_type] :
      ( v22780(VarCurr)
    <=> v22782(VarCurr) ) ).

tff(addAssignment_11652,axiom,
    ! [VarCurr: state_type] :
      ( v22782(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_256,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22764(VarNext)
       => ( v22717(VarNext)
        <=> v22717(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_256,axiom,
    ! [VarNext: state_type] :
      ( v22764(VarNext)
     => ( v22717(VarNext)
      <=> v22774(VarNext) ) ) ).

tff(addAssignment_11651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22774(VarNext)
      <=> v22772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1871,axiom,
    ! [VarCurr: state_type] :
      ( v22772(VarCurr)
    <=> ( v22775(VarCurr)
        & v22776(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1870,axiom,
    ! [VarCurr: state_type] :
      ( v22776(VarCurr)
    <=> ( v22723(VarCurr)
        | v22759(VarCurr) ) ) ).

tff(writeUnaryOperator_1255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22775(VarCurr)
    <=> v22719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1869,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22764(VarNext)
      <=> v22765(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22765(VarNext)
      <=> ( v22767(VarNext)
          & v22769(VarNext) ) ) ) ).

tff(writeUnaryOperator_1254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22769(VarCurr)
    <=> v22713(VarCurr) ) ).

tff(addAssignment_11650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22767(VarNext)
      <=> v22713(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_92,axiom,
    ( v22717(constB0)
  <=> $true ) ).

tff(addAssignment_11649,axiom,
    ! [VarCurr: state_type] :
      ( v22759(VarCurr)
    <=> v22761(VarCurr) ) ).

tff(addAssignment_11648,axiom,
    ! [VarCurr: state_type] :
      ( v22761(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11647,axiom,
    ! [VarCurr: state_type] :
      ( v22723(VarCurr)
    <=> v22725(VarCurr) ) ).

tff(addAssignment_11646,axiom,
    ! [VarCurr: state_type] :
      ( v22725(VarCurr)
    <=> v22727(VarCurr) ) ).

tff(addAssignment_11645,axiom,
    ! [VarCurr: state_type] :
      ( v22727(VarCurr)
    <=> v22729(VarCurr) ) ).

tff(addAssignment_11644,axiom,
    ! [VarCurr: state_type] :
      ( v22729(VarCurr)
    <=> v22731(VarCurr) ) ).

tff(writeUnaryOperator_1253,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22731(VarCurr)
    <=> v22756(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1867,axiom,
    ! [VarCurr: state_type] :
      ( v22756(VarCurr)
    <=> ( v22757(VarCurr)
        | v22752(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1866,axiom,
    ! [VarCurr: state_type] :
      ( v22757(VarCurr)
    <=> ( v22733(VarCurr)
        | v22748(VarCurr) ) ) ).

tff(addAssignment_11643,axiom,
    ! [VarCurr: state_type] :
      ( v22752(VarCurr)
    <=> v22754(VarCurr) ) ).

tff(addAssignment_11642,axiom,
    ! [VarCurr: state_type] :
      ( v22754(VarCurr)
    <=> v22311(VarCurr,2) ) ).

tff(addAssignment_11641,axiom,
    ! [VarCurr: state_type] :
      ( v22748(VarCurr)
    <=> v22750(VarCurr) ) ).

tff(addAssignment_11640,axiom,
    ! [VarCurr: state_type] :
      ( v22750(VarCurr)
    <=> v22311(VarCurr,1) ) ).

tff(addAssignment_11639,axiom,
    ! [VarCurr: state_type] :
      ( v22733(VarCurr)
    <=> v22735(VarCurr) ) ).

tff(addAssignment_11638,axiom,
    ! [VarCurr: state_type] :
      ( v22735(VarCurr)
    <=> v22737(VarCurr,0) ) ).

tff(addAssignment_11637,axiom,
    ! [VarCurr: state_type] :
      ( v22737(VarCurr,0)
    <=> v22739(VarCurr,0) ) ).

tff(addAssignment_11636,axiom,
    ! [VarCurr: state_type] :
      ( v22739(VarCurr,0)
    <=> v22741(VarCurr,0) ) ).

tff(addAssignment_11635,axiom,
    ! [VarCurr: state_type] :
      ( v22741(VarCurr,0)
    <=> v22746(VarCurr,0) ) ).

tff(writeUnaryOperator_1252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v22746(VarCurr,B)
      <=> ~ v22743(VarCurr,B) ) ) ).

tff(addAssignment_11634,axiom,
    ! [VarCurr: state_type] :
      ( v22743(VarCurr,0)
    <=> v22745(VarCurr,0) ) ).

tff(addAssignment_11633,axiom,
    ! [VarCurr: state_type] :
      ( v22745(VarCurr,0)
    <=> v22311(VarCurr,0) ) ).

tff(addAssignment_11632,axiom,
    ! [VarCurr: state_type] :
      ( v22719(VarCurr)
    <=> v22721(VarCurr) ) ).

tff(addAssignment_11631,axiom,
    ! [VarCurr: state_type] :
      ( v22721(VarCurr)
    <=> $false ) ).

tff(addAssignment_11630,axiom,
    ! [VarCurr: state_type] :
      ( v22713(VarCurr)
    <=> v22715(VarCurr) ) ).

tff(addAssignment_11629,axiom,
    ! [VarCurr: state_type] :
      ( v22715(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22703(VarCurr,B)
      <=> v22705(VarCurr,B) ) ) ).

tff(addAssignment_11627,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22705(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11626,axiom,
    ! [VarCurr: state_type] :
      ( v22693(VarCurr)
    <=> v22695(VarCurr) ) ).

tff(addAssignment_11625,axiom,
    ! [VarCurr: state_type] :
      ( v22695(VarCurr)
    <=> v22697(VarCurr) ) ).

tff(addAssignment_11624,axiom,
    ! [VarCurr: state_type] :
      ( v22697(VarCurr)
    <=> v22699(VarCurr) ) ).

tff(addAssignment_11623,axiom,
    ! [VarCurr: state_type] :
      ( v22699(VarCurr)
    <=> v22701(VarCurr) ) ).

tff(addAssignment_11622,axiom,
    ! [VarCurr: state_type] :
      ( v22701(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11621,axiom,
    ! [VarCurr: state_type] :
      ( v22683(VarCurr)
    <=> v22685(VarCurr) ) ).

tff(addAssignment_11620,axiom,
    ! [VarCurr: state_type] :
      ( v22685(VarCurr)
    <=> v22687(VarCurr) ) ).

tff(addAssignment_11619,axiom,
    ! [VarCurr: state_type] :
      ( v22687(VarCurr)
    <=> v22689(VarCurr) ) ).

tff(addAssignment_11618,axiom,
    ! [VarCurr: state_type] :
      ( v22689(VarCurr)
    <=> v22691(VarCurr) ) ).

tff(addAssignment_11617,axiom,
    ! [VarCurr: state_type] :
      ( v22691(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11616,axiom,
    ! [VarCurr: state_type] :
      ( v22381(VarCurr)
    <=> v22383(VarCurr) ) ).

tff(addAssignment_11615,axiom,
    ! [VarCurr: state_type] :
      ( v22383(VarCurr)
    <=> v22385(VarCurr) ) ).

tff(addAssignment_11614,axiom,
    ! [VarCurr: state_type] :
      ( v22385(VarCurr)
    <=> v22387(VarCurr) ) ).

tff(addAssignment_11613,axiom,
    ! [VarCurr: state_type] :
      ( v22387(VarCurr)
    <=> v22389(VarCurr) ) ).

tff(addAssignment_11612,axiom,
    ! [VarCurr: state_type] :
      ( v22389(VarCurr)
    <=> v22391(VarCurr) ) ).

tff(addAssignment_11611,axiom,
    ! [VarCurr: state_type] :
      ( v22391(VarCurr)
    <=> v22393(VarCurr) ) ).

tff(addAssignment_11610,axiom,
    ! [VarCurr: state_type] :
      ( v22393(VarCurr)
    <=> v22395(VarCurr) ) ).

tff(writeUnaryOperator_1251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22395(VarCurr)
    <=> v22670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1865,axiom,
    ! [VarCurr: state_type] :
      ( v22670(VarCurr)
    <=> ( v22671(VarCurr)
        | v22666(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1864,axiom,
    ! [VarCurr: state_type] :
      ( v22671(VarCurr)
    <=> ( v22397(VarCurr)
        | v22662(VarCurr) ) ) ).

tff(addAssignment_11609,axiom,
    ! [VarCurr: state_type] :
      ( v22666(VarCurr)
    <=> v22668(VarCurr) ) ).

tff(addAssignment_11608,axiom,
    ! [VarCurr: state_type] :
      ( v22668(VarCurr)
    <=> v22401(VarCurr,2) ) ).

tff(addAssignment_11607,axiom,
    ! [VarCurr: state_type] :
      ( v22662(VarCurr)
    <=> v22664(VarCurr) ) ).

tff(addAssignment_11606,axiom,
    ! [VarCurr: state_type] :
      ( v22664(VarCurr)
    <=> v22401(VarCurr,1) ) ).

tff(addAssignment_11605,axiom,
    ! [VarCurr: state_type] :
      ( v22397(VarCurr)
    <=> v22399(VarCurr) ) ).

tff(addAssignment_11604,axiom,
    ! [VarCurr: state_type] :
      ( v22399(VarCurr)
    <=> v22401(VarCurr,0) ) ).

tff(addAssignment_11603,axiom,
    ! [VarCurr: state_type] :
      ( v22401(VarCurr,0)
    <=> v22313(VarCurr,3) ) ).

tff(addAssignment_11602,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,3)
    <=> v22315(VarCurr,3) ) ).

tff(addAssignment_11601,axiom,
    ! [VarNext: state_type] :
      ( v22315(VarNext,3)
    <=> v22654(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_255,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22655(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v22654(VarNext,B)
            <=> v22315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_255,axiom,
    ! [VarNext: state_type] :
      ( v22655(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22654(VarNext,B)
          <=> v22626(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1863,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22655(VarNext)
      <=> v22656(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22656(VarNext)
      <=> ( v22658(VarNext)
          & v22568(VarNext) ) ) ) ).

tff(writeUnaryOperator_1250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22658(VarNext)
      <=> v22620(VarNext) ) ) ).

tff(addAssignment_11600,axiom,
    ! [VarCurr: state_type] :
      ( v22425(VarCurr,3)
    <=> v22427(VarCurr,3) ) ).

tff(addAssignment_11599,axiom,
    ! [VarCurr: state_type] :
      ( v22427(VarCurr,3)
    <=> v22565(VarCurr,3) ) ).

tff(addAssignment_11598,axiom,
    ! [VarCurr: state_type] :
      ( v22429(VarCurr,0)
    <=> v22431(VarCurr,0) ) ).

tff(addAssignment_11597,axiom,
    ! [VarCurr: state_type] :
      ( v22431(VarCurr,0)
    <=> v22433(VarCurr,0) ) ).

tff(addAssignment_11596,axiom,
    ! [VarCurr: state_type] :
      ( v22433(VarCurr,0)
    <=> v22564(VarCurr,0) ) ).

tff(addAssignment_11595,axiom,
    ! [VarCurr: state_type] :
      ( v22501(VarCurr,0)
    <=> v22503(VarCurr,0) ) ).

tff(addAssignment_11594,axiom,
    ! [VarCurr: state_type] :
      ( v22503(VarCurr,0)
    <=> v22505(VarCurr,0) ) ).

tff(addAssignment_11593,axiom,
    ! [VarCurr: state_type] :
      ( v22505(VarCurr,0)
    <=> v22507(VarCurr,0) ) ).

tff(addAssignment_11592,axiom,
    ! [VarCurr: state_type] :
      ( v22507(VarCurr,0)
    <=> v22509(VarCurr,0) ) ).

tff(addAssignment_11591,axiom,
    ! [VarCurr: state_type] :
      ( v22509(VarCurr,0)
    <=> v22519(VarCurr,0) ) ).

tff(addAssignment_11590,axiom,
    ! [VarCurr: state_type] :
      ( v22435(VarCurr,0)
    <=> v22437(VarCurr,0) ) ).

tff(addAssignment_11589,axiom,
    ! [VarCurr: state_type] :
      ( v22437(VarCurr,0)
    <=> v22498(VarCurr,0) ) ).

tff(addAssignment_11588,axiom,
    ! [VarCurr: state_type] :
      ( v22439(VarCurr)
    <=> v21965(VarCurr,2) ) ).

tff(addAssignment_11587,axiom,
    ! [VarCurr: state_type] :
      ( v21965(VarCurr,2)
    <=> v21967(VarCurr,2) ) ).

tff(addAssignment_11586,axiom,
    ! [VarCurr: state_type] :
      ( v21967(VarCurr,2)
    <=> v21977(VarCurr,2) ) ).

tff(addAssignment_11585,axiom,
    ! [VarCurr: state_type] :
      ( v21969(VarCurr,2)
    <=> v21971(VarCurr,2) ) ).

tff(addAssignment_11584,axiom,
    ! [VarCurr: state_type] :
      ( v21971(VarCurr,2)
    <=> v21974(VarCurr,2) ) ).

tff(addAssignment_11583,axiom,
    ! [VarCurr: state_type] :
      ( v21975(VarCurr)
    <=> v22442(VarCurr,1) ) ).

tff(addAssignment_11582,axiom,
    ! [VarCurr: state_type] :
      ( v22442(VarCurr,1)
    <=> v22444(VarCurr,1) ) ).

tff(addAssignment_11581,axiom,
    ! [VarCurr: state_type] :
      ( v22444(VarCurr,1)
    <=> v22652(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v22652(VarCurr,B)
      <=> ( v22446(VarCurr,B)
          | v22452(VarCurr,B) ) ) ) ).

tff(addAssignment_11580,axiom,
    ! [VarCurr: state_type] :
      ( v22452(VarCurr,1)
    <=> v22454(VarCurr,1) ) ).

tff(addAssignment_11579,axiom,
    ! [VarCurr: state_type] :
      ( v22454(VarCurr,1)
    <=> v22650(VarCurr,1) ) ).

tff(addAssignment_11578,axiom,
    ! [VarCurr: state_type] :
      ( v22650(VarCurr,0)
    <=> v22651(VarCurr) ) ).

tff(addAssignment_11577,axiom,
    ! [VarCurr: state_type] :
      ( v22650(VarCurr,1)
    <=> v22456(VarCurr) ) ).

tff(addAssignment_11576,axiom,
    ! [VarCurr: state_type] :
      ( v22456(VarCurr)
    <=> v22458(VarCurr,1) ) ).

tff(addAssignment_11575,axiom,
    ! [VarCurr: state_type] :
      ( v22458(VarCurr,1)
    <=> v22460(VarCurr,1) ) ).

tff(addAssignment_11574,axiom,
    ! [VarCurr: state_type] :
      ( v22460(VarCurr,1)
    <=> v22649(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v22649(VarCurr,B)
      <=> ( v22462(VarCurr,B)
          & v22470(VarCurr,B) ) ) ) ).

tff(addAssignment_11573,axiom,
    ! [VarCurr: state_type] :
      ( v22470(VarCurr,1)
    <=> v22472(VarCurr,1) ) ).

tff(addAssignment_11572,axiom,
    ! [VarCurr: state_type] :
      ( v22472(VarCurr,1)
    <=> v22647(VarCurr,1) ) ).

tff(addAssignment_11571,axiom,
    ! [VarCurr: state_type] :
      ( v22647(VarCurr,0)
    <=> v22648(VarCurr) ) ).

tff(addAssignment_11570,axiom,
    ! [VarCurr: state_type] :
      ( v22647(VarCurr,1)
    <=> v22474(VarCurr) ) ).

tff(addAssignment_11569,axiom,
    ! [VarCurr: state_type] :
      ( v22474(VarCurr)
    <=> v22476(VarCurr) ) ).

tff(addAssignment_11568,axiom,
    ! [VarCurr: state_type] :
      ( v22476(VarCurr)
    <=> v22478(VarCurr) ) ).

tff(writeUnaryOperator_1249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22478(VarCurr)
    <=> v22645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1861,axiom,
    ! [VarCurr: state_type] :
      ( v22645(VarCurr)
    <=> ( v22646(VarCurr)
        | v22633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1860,axiom,
    ! [VarCurr: state_type] :
      ( v22646(VarCurr)
    <=> ( v22480(VarCurr)
        | v22495(VarCurr) ) ) ).

tff(addAssignment_11567,axiom,
    ! [VarCurr: state_type] :
      ( v22633(VarCurr)
    <=> v22635(VarCurr) ) ).

tff(addAssignment_11566,axiom,
    ! [VarCurr: state_type] :
      ( v22635(VarCurr)
    <=> v22484(VarCurr,2) ) ).

tff(addAssignment_11565,axiom,
    ! [VarCurr: state_type] :
      ( v22484(VarCurr,2)
    <=> v22486(VarCurr,2) ) ).

tff(addAssignment_11564,axiom,
    ! [VarCurr: state_type] :
      ( v22486(VarCurr,2)
    <=> v22488(VarCurr,2) ) ).

tff(addAssignment_11563,axiom,
    ! [VarCurr: state_type] :
      ( v22488(VarCurr,2)
    <=> v22493(VarCurr,2) ) ).

tff(addAssignment_11562,axiom,
    ! [VarCurr: state_type] :
      ( v22490(VarCurr,2)
    <=> v22492(VarCurr,2) ) ).

tff(addAssignment_11561,axiom,
    ! [VarCurr: state_type] :
      ( v22492(VarCurr,2)
    <=> v22401(VarCurr,2) ) ).

tff(addAssignment_11560,axiom,
    ! [VarCurr: state_type] :
      ( v22401(VarCurr,2)
    <=> v22313(VarCurr,5) ) ).

tff(addAssignment_11559,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,5)
    <=> v22315(VarCurr,5) ) ).

tff(addAssignment_11558,axiom,
    ! [VarNext: state_type] :
      ( v22315(VarNext,5)
    <=> v22637(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22638(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v22637(VarNext,B)
            <=> v22315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_254,axiom,
    ! [VarNext: state_type] :
      ( v22638(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22637(VarNext,B)
          <=> v22626(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1859,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22638(VarNext)
      <=> v22639(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1858,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22639(VarNext)
      <=> ( v22641(VarNext)
          & v22568(VarNext) ) ) ) ).

tff(writeUnaryOperator_1248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22641(VarNext)
      <=> v22620(VarNext) ) ) ).

tff(addAssignment_11557,axiom,
    ! [VarCurr: state_type] :
      ( v22425(VarCurr,5)
    <=> v22427(VarCurr,5) ) ).

tff(addAssignment_11556,axiom,
    ! [VarCurr: state_type] :
      ( v22427(VarCurr,5)
    <=> v22565(VarCurr,5) ) ).

tff(addAssignment_11555,axiom,
    ! [VarCurr: state_type] :
      ( v22429(VarCurr,2)
    <=> v22431(VarCurr,2) ) ).

tff(addAssignment_11554,axiom,
    ! [VarCurr: state_type] :
      ( v22431(VarCurr,2)
    <=> v22433(VarCurr,2) ) ).

tff(addAssignment_11553,axiom,
    ! [VarCurr: state_type] :
      ( v22433(VarCurr,2)
    <=> v22564(VarCurr,2) ) ).

tff(addAssignment_11552,axiom,
    ! [VarCurr: state_type] :
      ( v22501(VarCurr,2)
    <=> v22503(VarCurr,2) ) ).

tff(addAssignment_11551,axiom,
    ! [VarCurr: state_type] :
      ( v22503(VarCurr,2)
    <=> v22505(VarCurr,2) ) ).

tff(addAssignment_11550,axiom,
    ! [VarCurr: state_type] :
      ( v22505(VarCurr,2)
    <=> v22507(VarCurr,2) ) ).

tff(addAssignment_11549,axiom,
    ! [VarCurr: state_type] :
      ( v22507(VarCurr,2)
    <=> v22509(VarCurr,2) ) ).

tff(addAssignment_11548,axiom,
    ! [VarCurr: state_type] :
      ( v22509(VarCurr,2)
    <=> v22519(VarCurr,2) ) ).

tff(addAssignment_11547,axiom,
    ! [VarCurr: state_type] :
      ( v22511(VarCurr,2)
    <=> v22513(VarCurr,2) ) ).

tff(addAssignment_11546,axiom,
    ! [VarCurr: state_type] :
      ( v22513(VarCurr,2)
    <=> v22514(VarCurr,2) ) ).

tff(addAssignment_11545,axiom,
    ! [VarCurr: state_type] :
      ( v22435(VarCurr,2)
    <=> v22437(VarCurr,2) ) ).

tff(addAssignment_11544,axiom,
    ! [VarCurr: state_type] :
      ( v22437(VarCurr,2)
    <=> v22498(VarCurr,2) ) ).

tff(addAssignment_11543,axiom,
    ! [VarCurr: state_type] :
      ( v22495(VarCurr)
    <=> v22497(VarCurr) ) ).

tff(addAssignment_11542,axiom,
    ! [VarCurr: state_type] :
      ( v22497(VarCurr)
    <=> v22401(VarCurr,1) ) ).

tff(addAssignment_11541,axiom,
    ! [VarCurr: state_type] :
      ( v22401(VarCurr,1)
    <=> v22313(VarCurr,4) ) ).

tff(addAssignment_11540,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,4)
    <=> v22315(VarCurr,4) ) ).

tff(addAssignment_11539,axiom,
    ! [VarNext: state_type] :
      ( v22315(VarNext,4)
    <=> v22615(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22616(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v22615(VarNext,B)
            <=> v22315(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_253,axiom,
    ! [VarNext: state_type] :
      ( v22616(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22615(VarNext,B)
          <=> v22626(VarNext,B) ) ) ) ).

tff(addAssignment_11538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22626(VarNext,B)
          <=> v22624(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22627(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22624(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_162,axiom,
    ! [VarCurr: state_type] :
      ( v22627(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v22624(VarCurr,B)
          <=> v22425(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1857,axiom,
    ! [VarCurr: state_type] :
      ( v22627(VarCurr)
    <=> ( v22628(VarCurr)
        & v22629(VarCurr) ) ) ).

tff(writeUnaryOperator_1247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22629(VarCurr)
    <=> v22415(VarCurr) ) ).

tff(writeUnaryOperator_1246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22628(VarCurr)
    <=> v22403(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1856,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22616(VarNext)
      <=> v22617(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22617(VarNext)
      <=> ( v22618(VarNext)
          & v22568(VarNext) ) ) ) ).

tff(writeUnaryOperator_1245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22618(VarNext)
      <=> v22620(VarNext) ) ) ).

tff(addAssignment_11537,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22620(VarNext)
      <=> v22568(VarCurr) ) ) ).

tff(addAssignment_11536,axiom,
    ! [VarCurr: state_type] :
      ( v22568(VarCurr)
    <=> v22570(VarCurr) ) ).

tff(addAssignment_11535,axiom,
    ! [VarCurr: state_type] :
      ( v22570(VarCurr)
    <=> v22572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1854,axiom,
    ! [VarCurr: state_type] :
      ( v22572(VarCurr)
    <=> ( v22613(VarCurr)
        | v22609(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1853,axiom,
    ! [VarCurr: state_type] :
      ( v22613(VarCurr)
    <=> ( v22574(VarCurr)
        & v22578(VarCurr) ) ) ).

tff(addAssignment_11534,axiom,
    ! [VarCurr: state_type] :
      ( v22609(VarCurr)
    <=> v22611(VarCurr) ) ).

tff(addAssignment_11533,axiom,
    ! [VarCurr: state_type] :
      ( v22611(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22593(VarNext)
       => ( v22578(VarNext)
        <=> v22578(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_252,axiom,
    ! [VarNext: state_type] :
      ( v22593(VarNext)
     => ( v22578(VarNext)
      <=> v22603(VarNext) ) ) ).

tff(addAssignment_11532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22603(VarNext)
      <=> v22601(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1852,axiom,
    ! [VarCurr: state_type] :
      ( v22601(VarCurr)
    <=> ( v22604(VarCurr)
        & v22605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1851,axiom,
    ! [VarCurr: state_type] :
      ( v22605(VarCurr)
    <=> ( v22584(VarCurr)
        | v22588(VarCurr) ) ) ).

tff(writeUnaryOperator_1244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22604(VarCurr)
    <=> v22580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22593(VarNext)
      <=> v22594(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22594(VarNext)
      <=> ( v22596(VarNext)
          & v22598(VarNext) ) ) ) ).

tff(writeUnaryOperator_1243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22598(VarCurr)
    <=> v22574(VarCurr) ) ).

tff(addAssignment_11531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22596(VarNext)
      <=> v22574(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_91,axiom,
    ( v22578(constB0)
  <=> $true ) ).

tff(addAssignment_11530,axiom,
    ! [VarCurr: state_type] :
      ( v22588(VarCurr)
    <=> v22590(VarCurr) ) ).

tff(addAssignment_11529,axiom,
    ! [VarCurr: state_type] :
      ( v22590(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11528,axiom,
    ! [VarCurr: state_type] :
      ( v22584(VarCurr)
    <=> v22586(VarCurr) ) ).

tff(addAssignment_11527,axiom,
    ! [VarCurr: state_type] :
      ( v22586(VarCurr)
    <=> $true ) ).

tff(addAssignment_11526,axiom,
    ! [VarCurr: state_type] :
      ( v22580(VarCurr)
    <=> v22582(VarCurr) ) ).

tff(addAssignment_11525,axiom,
    ! [VarCurr: state_type] :
      ( v22582(VarCurr)
    <=> $false ) ).

tff(addAssignment_11524,axiom,
    ! [VarCurr: state_type] :
      ( v22574(VarCurr)
    <=> v22576(VarCurr) ) ).

tff(addAssignment_11523,axiom,
    ! [VarCurr: state_type] :
      ( v22576(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11522,axiom,
    ! [VarCurr: state_type] :
      ( v22425(VarCurr,4)
    <=> v22427(VarCurr,4) ) ).

tff(addAssignment_11521,axiom,
    ! [VarCurr: state_type] :
      ( v22427(VarCurr,4)
    <=> v22565(VarCurr,4) ) ).

tff(addAssignment_11520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v22565(VarCurr,B)
      <=> v22566(VarCurr,B) ) ) ).

tff(addAssignment_11519,axiom,
    ! [VarCurr: state_type] :
      ( ( v22565(VarCurr,5)
      <=> v22429(VarCurr,2) )
      & ( v22565(VarCurr,4)
      <=> v22429(VarCurr,1) )
      & ( v22565(VarCurr,3)
      <=> v22429(VarCurr,0) ) ) ).

tff(addAssignment_11518,axiom,
    ! [VarCurr: state_type] :
      ( v22429(VarCurr,1)
    <=> v22431(VarCurr,1) ) ).

tff(addAssignment_11517,axiom,
    ! [VarCurr: state_type] :
      ( v22431(VarCurr,1)
    <=> v22433(VarCurr,1) ) ).

tff(addAssignment_11516,axiom,
    ! [VarCurr: state_type] :
      ( v22433(VarCurr,1)
    <=> v22564(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v22564(VarCurr,B)
      <=> ( v22435(VarCurr,B)
          & v22501(VarCurr,B) ) ) ) ).

tff(addAssignment_11515,axiom,
    ! [VarCurr: state_type] :
      ( v22501(VarCurr,1)
    <=> v22503(VarCurr,1) ) ).

tff(addAssignment_11514,axiom,
    ! [VarCurr: state_type] :
      ( v22503(VarCurr,1)
    <=> v22505(VarCurr,1) ) ).

tff(addAssignment_11513,axiom,
    ! [VarCurr: state_type] :
      ( v22505(VarCurr,1)
    <=> v22507(VarCurr,1) ) ).

tff(addAssignment_11512,axiom,
    ! [VarCurr: state_type] :
      ( v22507(VarCurr,1)
    <=> v22509(VarCurr,1) ) ).

tff(addAssignment_11511,axiom,
    ! [VarCurr: state_type] :
      ( v22509(VarCurr,1)
    <=> v22519(VarCurr,1) ) ).

tff(addAssignment_11510,axiom,
    ! [VarCurr: state_type] :
      ( v22519(VarCurr,0)
    <=> v22559(VarCurr) ) ).

tff(addAssignment_11509,axiom,
    ! [VarCurr: state_type] :
      ( v22519(VarCurr,1)
    <=> v22554(VarCurr) ) ).

tff(addAssignment_11508,axiom,
    ! [VarCurr: state_type] :
      ( v22519(VarCurr,2)
    <=> v22549(VarCurr) ) ).

tff(addAssignment_11507,axiom,
    ! [VarCurr: state_type] :
      ( v22519(VarCurr,3)
    <=> v22521(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1848,axiom,
    ! [VarCurr: state_type] :
      ( v22559(VarCurr)
    <=> ( v22560(VarCurr)
        & v22563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1847,axiom,
    ! [VarCurr: state_type] :
      ( v22563(VarCurr)
    <=> ( v22511(VarCurr,0)
        | v22529(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1846,axiom,
    ! [VarCurr: state_type] :
      ( v22560(VarCurr)
    <=> ( v22561(VarCurr)
        | v22562(VarCurr) ) ) ).

tff(writeUnaryOperator_1242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22562(VarCurr)
    <=> v22529(VarCurr,0) ) ).

tff(writeUnaryOperator_1241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22561(VarCurr)
    <=> v22511(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1845,axiom,
    ! [VarCurr: state_type] :
      ( v22554(VarCurr)
    <=> ( v22555(VarCurr)
        & v22558(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1844,axiom,
    ! [VarCurr: state_type] :
      ( v22558(VarCurr)
    <=> ( v22528(VarCurr)
        | v22530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1843,axiom,
    ! [VarCurr: state_type] :
      ( v22555(VarCurr)
    <=> ( v22556(VarCurr)
        | v22557(VarCurr) ) ) ).

tff(writeUnaryOperator_1240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22557(VarCurr)
    <=> v22530(VarCurr) ) ).

tff(writeUnaryOperator_1239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22556(VarCurr)
    <=> v22528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1842,axiom,
    ! [VarCurr: state_type] :
      ( v22549(VarCurr)
    <=> ( v22550(VarCurr)
        & v22553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1841,axiom,
    ! [VarCurr: state_type] :
      ( v22553(VarCurr)
    <=> ( v22526(VarCurr)
        | v22536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1840,axiom,
    ! [VarCurr: state_type] :
      ( v22550(VarCurr)
    <=> ( v22551(VarCurr)
        | v22552(VarCurr) ) ) ).

tff(writeUnaryOperator_1238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22552(VarCurr)
    <=> v22536(VarCurr) ) ).

tff(writeUnaryOperator_1237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22551(VarCurr)
    <=> v22526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1839,axiom,
    ! [VarCurr: state_type] :
      ( v22521(VarCurr)
    <=> ( v22522(VarCurr)
        & v22548(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1838,axiom,
    ! [VarCurr: state_type] :
      ( v22548(VarCurr)
    <=> ( v22524(VarCurr)
        | v22543(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1837,axiom,
    ! [VarCurr: state_type] :
      ( v22522(VarCurr)
    <=> ( v22523(VarCurr)
        | v22542(VarCurr) ) ) ).

tff(writeUnaryOperator_1236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22542(VarCurr)
    <=> v22543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1836,axiom,
    ! [VarCurr: state_type] :
      ( v22543(VarCurr)
    <=> ( v22544(VarCurr)
        & v22547(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_223,axiom,
    ! [VarCurr: state_type] :
      ( v22547(VarCurr)
    <=> ( v22511(VarCurr,3)
        | v22529(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1835,axiom,
    ! [VarCurr: state_type] :
      ( v22544(VarCurr)
    <=> ( v22545(VarCurr)
        | v22546(VarCurr) ) ) ).

tff(writeUnaryOperator_1235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22546(VarCurr)
    <=> v22529(VarCurr,3) ) ).

tff(writeUnaryOperator_1234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22545(VarCurr)
    <=> v22511(VarCurr,3) ) ).

tff(writeUnaryOperator_1233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22523(VarCurr)
    <=> v22524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1834,axiom,
    ! [VarCurr: state_type] :
      ( v22524(VarCurr)
    <=> ( v22525(VarCurr)
        | v22541(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_222,axiom,
    ! [VarCurr: state_type] :
      ( v22541(VarCurr)
    <=> ( v22511(VarCurr,2)
        & v22529(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1833,axiom,
    ! [VarCurr: state_type] :
      ( v22525(VarCurr)
    <=> ( v22526(VarCurr)
        & v22536(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1832,axiom,
    ! [VarCurr: state_type] :
      ( v22536(VarCurr)
    <=> ( v22537(VarCurr)
        & v22540(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_221,axiom,
    ! [VarCurr: state_type] :
      ( v22540(VarCurr)
    <=> ( v22511(VarCurr,2)
        | v22529(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1831,axiom,
    ! [VarCurr: state_type] :
      ( v22537(VarCurr)
    <=> ( v22538(VarCurr)
        | v22539(VarCurr) ) ) ).

tff(writeUnaryOperator_1232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22539(VarCurr)
    <=> v22529(VarCurr,2) ) ).

tff(writeUnaryOperator_1231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22538(VarCurr)
    <=> v22511(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1830,axiom,
    ! [VarCurr: state_type] :
      ( v22526(VarCurr)
    <=> ( v22527(VarCurr)
        | v22535(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_220,axiom,
    ! [VarCurr: state_type] :
      ( v22535(VarCurr)
    <=> ( v22511(VarCurr,1)
        & v22529(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1829,axiom,
    ! [VarCurr: state_type] :
      ( v22527(VarCurr)
    <=> ( v22528(VarCurr)
        & v22530(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1828,axiom,
    ! [VarCurr: state_type] :
      ( v22530(VarCurr)
    <=> ( v22531(VarCurr)
        & v22534(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_219,axiom,
    ! [VarCurr: state_type] :
      ( v22534(VarCurr)
    <=> ( v22511(VarCurr,1)
        | v22529(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1827,axiom,
    ! [VarCurr: state_type] :
      ( v22531(VarCurr)
    <=> ( v22532(VarCurr)
        | v22533(VarCurr) ) ) ).

tff(writeUnaryOperator_1230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22533(VarCurr)
    <=> v22529(VarCurr,1) ) ).

tff(writeUnaryOperator_1229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22532(VarCurr)
    <=> v22511(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1826,axiom,
    ! [VarCurr: state_type] :
      ( v22528(VarCurr)
    <=> ( v22511(VarCurr,0)
        & v22529(VarCurr,0) ) ) ).

tff(addAssignment_11506,axiom,
    ! [VarCurr: state_type] :
      ( v22529(VarCurr,0)
    <=> v22516(VarCurr) ) ).

tff(addAssignment_11505,axiom,
    ! [VarCurr: state_type] :
      ( ( v22529(VarCurr,3)
      <=> $false )
      & ( v22529(VarCurr,2)
      <=> $false )
      & ( v22529(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_11504,axiom,
    ! [VarCurr: state_type] :
      ( v22516(VarCurr)
    <=> v22518(VarCurr) ) ).

tff(addAssignment_11503,axiom,
    ! [VarCurr: state_type] :
      ( v22518(VarCurr)
    <=> v22466(VarCurr) ) ).

tff(addAssignment_11502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v22511(VarCurr,B)
      <=> v22513(VarCurr,B) ) ) ).

tff(addAssignment_11501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v22513(VarCurr,B)
      <=> v22514(VarCurr,B) ) ) ).

tff(addAssignment_11500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v22514(VarCurr,B)
      <=> v22401(VarCurr,B) ) ) ).

tff(addAssignment_11499,axiom,
    ! [VarCurr: state_type] :
      ( v22514(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_11498,axiom,
    ! [VarCurr: state_type] :
      ( v22435(VarCurr,1)
    <=> v22437(VarCurr,1) ) ).

tff(addAssignment_11497,axiom,
    ! [VarCurr: state_type] :
      ( v22437(VarCurr,1)
    <=> v22498(VarCurr,1) ) ).

tff(addAssignment_11496,axiom,
    ! [VarCurr: state_type] :
      ( v22498(VarCurr,0)
    <=> v22499(VarCurr) ) ).

tff(addAssignment_11495,axiom,
    ! [VarCurr: state_type] :
      ( v22498(VarCurr,1)
    <=> v22499(VarCurr) ) ).

tff(addAssignment_11494,axiom,
    ! [VarCurr: state_type] :
      ( v22498(VarCurr,2)
    <=> v22499(VarCurr) ) ).

tff(addAssignment_11493,axiom,
    ! [VarCurr: state_type] :
      ( v22499(VarCurr)
    <=> v22439(VarCurr) ) ).

tff(addAssignment_11492,axiom,
    ! [VarCurr: state_type] :
      ( v22480(VarCurr)
    <=> v22482(VarCurr) ) ).

tff(addAssignment_11491,axiom,
    ! [VarCurr: state_type] :
      ( v22482(VarCurr)
    <=> v22484(VarCurr,0) ) ).

tff(addAssignment_11490,axiom,
    ! [VarCurr: state_type] :
      ( v22484(VarCurr,0)
    <=> v22486(VarCurr,0) ) ).

tff(addAssignment_11489,axiom,
    ! [VarCurr: state_type] :
      ( v22486(VarCurr,0)
    <=> v22488(VarCurr,0) ) ).

tff(addAssignment_11488,axiom,
    ! [VarCurr: state_type] :
      ( v22488(VarCurr,0)
    <=> v22493(VarCurr,0) ) ).

tff(writeUnaryOperator_1228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v22493(VarCurr,B)
      <=> ~ v22490(VarCurr,B) ) ) ).

tff(addAssignment_11487,axiom,
    ! [VarCurr: state_type] :
      ( v22490(VarCurr,0)
    <=> v22492(VarCurr,0) ) ).

tff(addAssignment_11486,axiom,
    ! [VarCurr: state_type] :
      ( v22492(VarCurr,0)
    <=> v22401(VarCurr,0) ) ).

tff(addAssignment_11485,axiom,
    ! [VarCurr: state_type] :
      ( v22462(VarCurr,1)
    <=> v22464(VarCurr,1) ) ).

tff(addAssignment_11484,axiom,
    ! [VarCurr: state_type] :
      ( v22464(VarCurr,1)
    <=> v22467(VarCurr,1) ) ).

tff(addAssignment_11483,axiom,
    ! [VarCurr: state_type] :
      ( v22467(VarCurr,0)
    <=> v22468(VarCurr) ) ).

tff(addAssignment_11482,axiom,
    ! [VarCurr: state_type] :
      ( v22467(VarCurr,1)
    <=> v22466(VarCurr) ) ).

tff(addAssignment_11481,axiom,
    ! [VarCurr: state_type] :
      ( v22466(VarCurr)
    <=> v10053(VarCurr,8) ) ).

tff(addAssignment_11480,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,8)
    <=> v10055(VarCurr,8) ) ).

tff(addAssignment_11479,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,8)
    <=> v10057(VarCurr,8) ) ).

tff(addAssignment_11478,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,8)
    <=> v10061(VarCurr,8) ) ).

tff(addAssignment_11477,axiom,
    ! [VarCurr: state_type] :
      ( v22446(VarCurr,1)
    <=> v22448(VarCurr,1) ) ).

tff(addAssignment_11476,axiom,
    ! [VarCurr: state_type] :
      ( v22448(VarCurr,1)
    <=> v22449(VarCurr,1) ) ).

tff(addAssignment_11475,axiom,
    ! [VarCurr: state_type] :
      ( v22449(VarCurr,0)
    <=> v22450(VarCurr) ) ).

tff(addAssignment_11474,axiom,
    ! [VarCurr: state_type] :
      ( v22449(VarCurr,1)
    <=> v22450(VarCurr) ) ).

tff(addAssignment_11473,axiom,
    ! [VarCurr: state_type] :
      ( v22450(VarCurr)
    <=> v21973(VarCurr) ) ).

tff(addAssignment_11472,axiom,
    ! [VarCurr: state_type] :
      ( v22415(VarCurr)
    <=> v22417(VarCurr) ) ).

tff(addAssignment_11471,axiom,
    ! [VarCurr: state_type] :
      ( v22417(VarCurr)
    <=> v22419(VarCurr) ) ).

tff(addAssignment_11470,axiom,
    ! [VarCurr: state_type] :
      ( v22419(VarCurr)
    <=> v22421(VarCurr) ) ).

tff(addAssignment_11469,axiom,
    ! [VarCurr: state_type] :
      ( v22421(VarCurr)
    <=> v22423(VarCurr) ) ).

tff(addAssignment_11468,axiom,
    ! [VarCurr: state_type] :
      ( v22423(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11467,axiom,
    ! [VarCurr: state_type] :
      ( v22403(VarCurr)
    <=> v22405(VarCurr) ) ).

tff(addAssignment_11466,axiom,
    ! [VarCurr: state_type] :
      ( v22405(VarCurr)
    <=> v22407(VarCurr) ) ).

tff(addAssignment_11465,axiom,
    ! [VarCurr: state_type] :
      ( v22407(VarCurr)
    <=> v22409(VarCurr) ) ).

tff(addAssignment_11464,axiom,
    ! [VarCurr: state_type] :
      ( v22409(VarCurr)
    <=> v22411(VarCurr) ) ).

tff(addAssignment_11463,axiom,
    ! [VarCurr: state_type] :
      ( v22411(VarCurr)
    <=> v22413(VarCurr) ) ).

tff(addAssignment_11462,axiom,
    ! [VarCurr: state_type] :
      ( v22413(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_11461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21911(VarCurr,B)
      <=> v21913(VarCurr,B) ) ) ).

tff(addAssignment_11460,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21913(VarCurr,B)
      <=> v21915(VarCurr,B) ) ) ).

tff(addAssignment_11459,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21915(VarCurr,B)
      <=> v21917(VarCurr,B) ) ) ).

tff(addAssignment_11458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21917(VarCurr,B)
      <=> v21919(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_251,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22364(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21919(VarNext,B)
            <=> v21919(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_251,axiom,
    ! [VarNext: state_type] :
      ( v22364(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21919(VarNext,B)
          <=> v22374(VarNext,B) ) ) ) ).

tff(addAssignment_11457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22374(VarNext,B)
          <=> v22372(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22375(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22372(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_161,axiom,
    ! [VarCurr: state_type] :
      ( v22375(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22372(VarCurr,B)
          <=> v21949(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1825,axiom,
    ! [VarCurr: state_type] :
      ( v22375(VarCurr)
    <=> ( v22376(VarCurr)
        & v22377(VarCurr) ) ) ).

tff(writeUnaryOperator_1227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22377(VarCurr)
    <=> v21935(VarCurr) ) ).

tff(writeUnaryOperator_1226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22376(VarCurr)
    <=> v21921(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1824,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22364(VarNext)
      <=> v22365(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1823,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22365(VarNext)
      <=> ( v22366(VarNext)
          & v22279(VarNext) ) ) ) ).

tff(writeUnaryOperator_1225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22366(VarNext)
      <=> v22368(VarNext) ) ) ).

tff(addAssignment_11456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22368(VarNext)
      <=> v22279(VarCurr) ) ) ).

tff(addAssignment_11455,axiom,
    ! [VarCurr: state_type] :
      ( v22279(VarCurr)
    <=> v22281(VarCurr) ) ).

tff(addAssignment_11454,axiom,
    ! [VarCurr: state_type] :
      ( v22281(VarCurr)
    <=> v22283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1822,axiom,
    ! [VarCurr: state_type] :
      ( v22283(VarCurr)
    <=> ( v22361(VarCurr)
        | v22353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1821,axiom,
    ! [VarCurr: state_type] :
      ( v22361(VarCurr)
    <=> ( v22285(VarCurr)
        & v22291(VarCurr) ) ) ).

tff(addAssignment_11453,axiom,
    ! [VarCurr: state_type] :
      ( v22353(VarCurr)
    <=> v22355(VarCurr) ) ).

tff(addAssignment_11452,axiom,
    ! [VarCurr: state_type] :
      ( v22355(VarCurr)
    <=> v22357(VarCurr) ) ).

tff(addAssignment_11451,axiom,
    ! [VarCurr: state_type] :
      ( v22357(VarCurr)
    <=> v22359(VarCurr) ) ).

tff(addAssignment_11450,axiom,
    ! [VarCurr: state_type] :
      ( v22359(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22337(VarNext)
       => ( v22291(VarNext)
        <=> v22291(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_250,axiom,
    ! [VarNext: state_type] :
      ( v22337(VarNext)
     => ( v22291(VarNext)
      <=> v22347(VarNext) ) ) ).

tff(addAssignment_11449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22347(VarNext)
      <=> v22345(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1820,axiom,
    ! [VarCurr: state_type] :
      ( v22345(VarCurr)
    <=> ( v22348(VarCurr)
        & v22349(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1819,axiom,
    ! [VarCurr: state_type] :
      ( v22349(VarCurr)
    <=> ( v22297(VarCurr)
        | v22328(VarCurr) ) ) ).

tff(writeUnaryOperator_1224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22348(VarCurr)
    <=> v22293(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1818,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22337(VarNext)
      <=> v22338(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1817,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22338(VarNext)
      <=> ( v22340(VarNext)
          & v22342(VarNext) ) ) ) ).

tff(writeUnaryOperator_1223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22342(VarCurr)
    <=> v22285(VarCurr) ) ).

tff(addAssignment_11448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22340(VarNext)
      <=> v22285(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_90,axiom,
    ( v22291(constB0)
  <=> $true ) ).

tff(addAssignment_11447,axiom,
    ! [VarCurr: state_type] :
      ( v22328(VarCurr)
    <=> v22330(VarCurr) ) ).

tff(addAssignment_11446,axiom,
    ! [VarCurr: state_type] :
      ( v22330(VarCurr)
    <=> v22332(VarCurr) ) ).

tff(addAssignment_11445,axiom,
    ! [VarCurr: state_type] :
      ( v22332(VarCurr)
    <=> v22334(VarCurr) ) ).

tff(addAssignment_11444,axiom,
    ! [VarCurr: state_type] :
      ( v22334(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_11443,axiom,
    ! [VarCurr: state_type] :
      ( v22297(VarCurr)
    <=> v22299(VarCurr) ) ).

tff(addAssignment_11442,axiom,
    ! [VarCurr: state_type] :
      ( v22299(VarCurr)
    <=> v22301(VarCurr) ) ).

tff(addAssignment_11441,axiom,
    ! [VarCurr: state_type] :
      ( v22301(VarCurr)
    <=> v22303(VarCurr) ) ).

tff(addAssignment_11440,axiom,
    ! [VarCurr: state_type] :
      ( v22303(VarCurr)
    <=> v22305(VarCurr) ) ).

tff(writeUnaryOperator_1222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22305(VarCurr)
    <=> v22325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1816,axiom,
    ! [VarCurr: state_type] :
      ( v22325(VarCurr)
    <=> ( v22326(VarCurr)
        | v22321(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1815,axiom,
    ! [VarCurr: state_type] :
      ( v22326(VarCurr)
    <=> ( v22307(VarCurr)
        | v22317(VarCurr) ) ) ).

tff(addAssignment_11439,axiom,
    ! [VarCurr: state_type] :
      ( v22321(VarCurr)
    <=> v22323(VarCurr) ) ).

tff(addAssignment_11438,axiom,
    ! [VarCurr: state_type] :
      ( v22323(VarCurr)
    <=> v22311(VarCurr,2) ) ).

tff(addAssignment_11437,axiom,
    ! [VarCurr: state_type] :
      ( v22311(VarCurr,2)
    <=> v22313(VarCurr,2) ) ).

tff(addAssignment_11436,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,2)
    <=> v22315(VarCurr,2) ) ).

tff(addAssignment_11435,axiom,
    ! [VarCurr: state_type] :
      ( v22317(VarCurr)
    <=> v22319(VarCurr) ) ).

tff(addAssignment_11434,axiom,
    ! [VarCurr: state_type] :
      ( v22319(VarCurr)
    <=> v22311(VarCurr,1) ) ).

tff(addAssignment_11433,axiom,
    ! [VarCurr: state_type] :
      ( v22311(VarCurr,1)
    <=> v22313(VarCurr,1) ) ).

tff(addAssignment_11432,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,1)
    <=> v22315(VarCurr,1) ) ).

tff(addAssignment_11431,axiom,
    ! [VarCurr: state_type] :
      ( v22307(VarCurr)
    <=> v22309(VarCurr) ) ).

tff(addAssignment_11430,axiom,
    ! [VarCurr: state_type] :
      ( v22309(VarCurr)
    <=> v22311(VarCurr,0) ) ).

tff(addAssignment_11429,axiom,
    ! [VarCurr: state_type] :
      ( v22311(VarCurr,0)
    <=> v22313(VarCurr,0) ) ).

tff(addAssignment_11428,axiom,
    ! [VarCurr: state_type] :
      ( v22313(VarCurr,0)
    <=> v22315(VarCurr,0) ) ).

tff(addAssignment_11427,axiom,
    ! [VarCurr: state_type] :
      ( v22293(VarCurr)
    <=> v22295(VarCurr) ) ).

tff(addAssignment_11426,axiom,
    ! [VarCurr: state_type] :
      ( v22295(VarCurr)
    <=> $false ) ).

tff(addAssignment_11425,axiom,
    ! [VarCurr: state_type] :
      ( v22285(VarCurr)
    <=> v22287(VarCurr) ) ).

tff(addAssignment_11424,axiom,
    ! [VarCurr: state_type] :
      ( v22287(VarCurr)
    <=> v22289(VarCurr) ) ).

tff(addAssignment_11423,axiom,
    ! [VarCurr: state_type] :
      ( v22289(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_11422,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21949(VarCurr,B)
      <=> v21951(VarCurr,B) ) ) ).

tff(addAssignment_11421,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21951(VarCurr,B)
      <=> v21953(VarCurr,B) ) ) ).

tff(addAssignment_11420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21953(VarCurr,B)
      <=> v21955(VarCurr,B) ) ) ).

tff(addAssignment_11419,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21955(VarCurr,B)
      <=> v21957(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21957(VarCurr,B)
      <=> ( v21959(VarCurr,B)
          & v21981(VarCurr,B) ) ) ) ).

tff(addAssignment_11418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21981(VarCurr,B)
      <=> v21983(VarCurr,B) ) ) ).

tff(addAssignment_11417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21983(VarCurr,B)
      <=> v21985(VarCurr,B) ) ) ).

tff(addAssignment_11416,axiom,
    ! [VarCurr: state_type] :
      ( ( v21985(VarCurr,11)
      <=> v9198(VarCurr,107) )
      & ( v21985(VarCurr,10)
      <=> v9198(VarCurr,106) )
      & ( v21985(VarCurr,9)
      <=> v9198(VarCurr,105) )
      & ( v21985(VarCurr,8)
      <=> v9198(VarCurr,104) )
      & ( v21985(VarCurr,7)
      <=> v9198(VarCurr,103) )
      & ( v21985(VarCurr,6)
      <=> v9198(VarCurr,102) )
      & ( v21985(VarCurr,5)
      <=> v9198(VarCurr,101) )
      & ( v21985(VarCurr,4)
      <=> v9198(VarCurr,100) )
      & ( v21985(VarCurr,3)
      <=> v9198(VarCurr,99) )
      & ( v21985(VarCurr,2)
      <=> v9198(VarCurr,98) )
      & ( v21985(VarCurr,1)
      <=> v9198(VarCurr,97) )
      & ( v21985(VarCurr,0)
      <=> v9198(VarCurr,96) ) ) ).

tff(addAssignment_11415,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,107)
      <=> v21987(VarCurr,11) )
      & ( v9198(VarCurr,106)
      <=> v21987(VarCurr,10) )
      & ( v9198(VarCurr,105)
      <=> v21987(VarCurr,9) )
      & ( v9198(VarCurr,104)
      <=> v21987(VarCurr,8) )
      & ( v9198(VarCurr,103)
      <=> v21987(VarCurr,7) )
      & ( v9198(VarCurr,102)
      <=> v21987(VarCurr,6) )
      & ( v9198(VarCurr,101)
      <=> v21987(VarCurr,5) )
      & ( v9198(VarCurr,100)
      <=> v21987(VarCurr,4) )
      & ( v9198(VarCurr,99)
      <=> v21987(VarCurr,3) )
      & ( v9198(VarCurr,98)
      <=> v21987(VarCurr,2) )
      & ( v9198(VarCurr,97)
      <=> v21987(VarCurr,1) )
      & ( v9198(VarCurr,96)
      <=> v21987(VarCurr,0) ) ) ).

tff(addAssignment_11414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21987(VarCurr,B)
      <=> v21989(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21989(VarCurr,B)
      <=> ( v22271(VarCurr,B)
          | v22274(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22274(VarCurr,B)
      <=> ( v21999(VarCurr,B)
          & v22275(VarCurr,B) ) ) ) ).

tff(addAssignment_11413,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,0)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11412,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,1)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11411,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,2)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11410,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,3)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11409,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,4)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11408,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,5)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11407,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,6)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11406,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,7)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11405,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,8)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11404,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,9)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11403,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,10)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11402,axiom,
    ! [VarCurr: state_type] :
      ( v22275(VarCurr,11)
    <=> v22276(VarCurr) ) ).

tff(addAssignment_11401,axiom,
    ! [VarCurr: state_type] :
      ( v22276(VarCurr)
    <=> v22267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22271(VarCurr,B)
      <=> ( v21991(VarCurr,B)
          & v22272(VarCurr,B) ) ) ) ).

tff(addAssignment_11400,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,0)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11399,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,1)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11398,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,2)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11397,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,3)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11396,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,4)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11395,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,5)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11394,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,6)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11393,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,7)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11392,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,8)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11391,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,9)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11390,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,10)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11389,axiom,
    ! [VarCurr: state_type] :
      ( v22272(VarCurr,11)
    <=> v22273(VarCurr) ) ).

tff(addAssignment_11388,axiom,
    ! [VarCurr: state_type] :
      ( v22273(VarCurr)
    <=> v21995(VarCurr) ) ).

tff(addAssignment_11387,axiom,
    ! [VarCurr: state_type] :
      ( v22267(VarCurr)
    <=> v22269(VarCurr) ) ).

tff(addAssignment_11386,axiom,
    ! [VarCurr: state_type] :
      ( v22269(VarCurr)
    <=> v9844(VarCurr,8) ) ).

tff(addAssignment_11385,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,8)
    <=> v9846(VarCurr,8) ) ).

tff(addAssignment_11384,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,8)
    <=> v9496(VarCurr,8) ) ).

tff(addAssignment_11383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21999(VarCurr,B)
      <=> v22001(VarCurr,B) ) ) ).

tff(addAssignment_11382,axiom,
    ! [VarCurr: state_type] :
      ( ( v22001(VarCurr,11)
      <=> v9208(VarCurr,119) )
      & ( v22001(VarCurr,10)
      <=> v9208(VarCurr,118) )
      & ( v22001(VarCurr,9)
      <=> v9208(VarCurr,117) )
      & ( v22001(VarCurr,8)
      <=> v9208(VarCurr,116) )
      & ( v22001(VarCurr,7)
      <=> v9208(VarCurr,115) )
      & ( v22001(VarCurr,6)
      <=> v9208(VarCurr,114) )
      & ( v22001(VarCurr,5)
      <=> v9208(VarCurr,113) )
      & ( v22001(VarCurr,4)
      <=> v9208(VarCurr,112) )
      & ( v22001(VarCurr,3)
      <=> v9208(VarCurr,111) )
      & ( v22001(VarCurr,2)
      <=> v9208(VarCurr,110) )
      & ( v22001(VarCurr,1)
      <=> v9208(VarCurr,109) )
      & ( v22001(VarCurr,0)
      <=> v9208(VarCurr,108) ) ) ).

tff(addAssignment_11381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,120)
        & ~ $less(B,108) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_11380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,120)
        & ~ $less(B,108) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_11379,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,119)
      <=> v22003(VarCurr,11) )
      & ( v9212(VarCurr,118)
      <=> v22003(VarCurr,10) )
      & ( v9212(VarCurr,117)
      <=> v22003(VarCurr,9) )
      & ( v9212(VarCurr,116)
      <=> v22003(VarCurr,8) )
      & ( v9212(VarCurr,115)
      <=> v22003(VarCurr,7) )
      & ( v9212(VarCurr,114)
      <=> v22003(VarCurr,6) )
      & ( v9212(VarCurr,113)
      <=> v22003(VarCurr,5) )
      & ( v9212(VarCurr,112)
      <=> v22003(VarCurr,4) )
      & ( v9212(VarCurr,111)
      <=> v22003(VarCurr,3) )
      & ( v9212(VarCurr,110)
      <=> v22003(VarCurr,2) )
      & ( v9212(VarCurr,109)
      <=> v22003(VarCurr,1) )
      & ( v9212(VarCurr,108)
      <=> v22003(VarCurr,0) ) ) ).

tff(addAssignment_11378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22003(VarCurr,B)
      <=> v22005(VarCurr,B) ) ) ).

tff(addAssignment_11377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22005(VarCurr,B)
      <=> v22007(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22250(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v22007(VarNext,B)
            <=> v22007(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_249,axiom,
    ! [VarNext: state_type] :
      ( v22250(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22007(VarNext,B)
          <=> v22260(VarNext,B) ) ) ) ).

tff(addAssignment_11376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22260(VarNext,B)
          <=> v22258(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22261(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22258(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_160,axiom,
    ! [VarCurr: state_type] :
      ( v22261(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v22258(VarCurr,B)
          <=> v22037(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1814,axiom,
    ! [VarCurr: state_type] :
      ( v22261(VarCurr)
    <=> ( v22262(VarCurr)
        & v22263(VarCurr) ) ) ).

tff(writeUnaryOperator_1221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22263(VarCurr)
    <=> v22023(VarCurr) ) ).

tff(writeUnaryOperator_1220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22262(VarCurr)
    <=> v22009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22250(VarNext)
      <=> v22251(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22251(VarNext)
      <=> ( v22252(VarNext)
          & v22225(VarNext) ) ) ) ).

tff(writeUnaryOperator_1219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v22252(VarNext)
      <=> v22254(VarNext) ) ) ).

tff(addAssignment_11375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v22254(VarNext)
      <=> v22225(VarCurr) ) ) ).

tff(addAssignment_11374,axiom,
    ! [VarCurr: state_type] :
      ( v22225(VarCurr)
    <=> v22227(VarCurr) ) ).

tff(addAssignment_11373,axiom,
    ! [VarCurr: state_type] :
      ( v22227(VarCurr)
    <=> v22229(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1811,axiom,
    ! [VarCurr: state_type] :
      ( v22229(VarCurr)
    <=> ( v22247(VarCurr)
        | v22239(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1810,axiom,
    ! [VarCurr: state_type] :
      ( v22247(VarCurr)
    <=> ( v22231(VarCurr)
        & v22237(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_89,axiom,
    ( v22237(constB0)
  <=> $true ) ).

tff(addAssignment_11372,axiom,
    ! [VarCurr: state_type] :
      ( v22239(VarCurr)
    <=> v22241(VarCurr) ) ).

tff(addAssignment_11371,axiom,
    ! [VarCurr: state_type] :
      ( v22241(VarCurr)
    <=> v22243(VarCurr) ) ).

tff(addAssignment_11370,axiom,
    ! [VarCurr: state_type] :
      ( v22243(VarCurr)
    <=> v22245(VarCurr) ) ).

tff(addAssignment_11369,axiom,
    ! [VarCurr: state_type] :
      ( v22245(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_11368,axiom,
    ! [VarCurr: state_type] :
      ( v22231(VarCurr)
    <=> v22233(VarCurr) ) ).

tff(addAssignment_11367,axiom,
    ! [VarCurr: state_type] :
      ( v22233(VarCurr)
    <=> v22235(VarCurr) ) ).

tff(addAssignment_11366,axiom,
    ! [VarCurr: state_type] :
      ( v22235(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_11365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22037(VarCurr,B)
      <=> v22039(VarCurr,B) ) ) ).

tff(addAssignment_11364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22039(VarCurr,B)
      <=> v22041(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22041(VarCurr,B)
      <=> ( v22210(VarCurr,B)
          | v22221(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_374,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22221(VarCurr,B)
      <=> ( v22174(VarCurr,B)
          & v22222(VarCurr,B) ) ) ) ).

tff(addAssignment_11363,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,0)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11362,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,1)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11361,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,2)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11360,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,3)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11359,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,4)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11358,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,5)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11357,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,6)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11356,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,7)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11355,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,8)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11354,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,9)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11353,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,10)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11352,axiom,
    ! [VarCurr: state_type] :
      ( v22222(VarCurr,11)
    <=> v22223(VarCurr) ) ).

tff(addAssignment_11351,axiom,
    ! [VarCurr: state_type] :
      ( v22223(VarCurr)
    <=> v22184(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_373,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22210(VarCurr,B)
      <=> ( v22211(VarCurr,B)
          | v22218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_372,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22218(VarCurr,B)
      <=> ( v22138(VarCurr,B)
          & v22219(VarCurr,B) ) ) ) ).

tff(addAssignment_11350,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,0)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11349,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,1)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11348,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,2)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11347,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,3)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11346,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,4)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11345,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,5)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11344,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,6)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11343,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,7)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11342,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,8)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11341,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,9)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11340,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,10)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11339,axiom,
    ! [VarCurr: state_type] :
      ( v22219(VarCurr,11)
    <=> v22220(VarCurr) ) ).

tff(addAssignment_11338,axiom,
    ! [VarCurr: state_type] :
      ( v22220(VarCurr)
    <=> v22148(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_371,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22211(VarCurr,B)
      <=> ( v22212(VarCurr,B)
          | v22215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22215(VarCurr,B)
      <=> ( v22091(VarCurr,B)
          & v22216(VarCurr,B) ) ) ) ).

tff(addAssignment_11337,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,0)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11336,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,1)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11335,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,2)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11334,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,3)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11333,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,4)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11332,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,5)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11331,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,6)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11330,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,7)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11329,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,8)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11328,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,9)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11327,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,10)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11326,axiom,
    ! [VarCurr: state_type] :
      ( v22216(VarCurr,11)
    <=> v22217(VarCurr) ) ).

tff(addAssignment_11325,axiom,
    ! [VarCurr: state_type] :
      ( v22217(VarCurr)
    <=> v22101(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22212(VarCurr,B)
      <=> ( v22043(VarCurr,B)
          & v22213(VarCurr,B) ) ) ) ).

tff(addAssignment_11324,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,0)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11323,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,1)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11322,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,2)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11321,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,3)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11320,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,4)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11319,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,5)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11318,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,6)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11317,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,7)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11316,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,8)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11315,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,9)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11314,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,10)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11313,axiom,
    ! [VarCurr: state_type] :
      ( v22213(VarCurr,11)
    <=> v22214(VarCurr) ) ).

tff(addAssignment_11312,axiom,
    ! [VarCurr: state_type] :
      ( v22214(VarCurr)
    <=> v22053(VarCurr) ) ).

tff(addAssignment_11311,axiom,
    ! [VarCurr: state_type] :
      ( v22184(VarCurr)
    <=> v22186(VarCurr) ) ).

tff(addAssignment_11310,axiom,
    ! [VarCurr: state_type] :
      ( v22186(VarCurr)
    <=> v22188(VarCurr) ) ).

tff(addAssignment_11309,axiom,
    ! [VarCurr: state_type] :
      ( v22188(VarCurr)
    <=> v22190(VarCurr) ) ).

tff(addAssignment_11308,axiom,
    ! [VarCurr: state_type] :
      ( v22190(VarCurr)
    <=> v22192(VarCurr) ) ).

tff(addAssignment_11307,axiom,
    ! [VarCurr: state_type] :
      ( v22192(VarCurr)
    <=> v22194(VarCurr) ) ).

tff(addAssignment_11306,axiom,
    ! [VarCurr: state_type] :
      ( v22194(VarCurr)
    <=> v22196(VarCurr) ) ).

tff(addAssignment_11305,axiom,
    ! [VarCurr: state_type] :
      ( v22196(VarCurr)
    <=> v22198(VarCurr) ) ).

tff(writeUnaryOperator_1218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22198(VarCurr)
    <=> v22208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1809,axiom,
    ! [VarCurr: state_type] :
      ( v22208(VarCurr)
    <=> ( v22200(VarCurr)
        | v22204(VarCurr) ) ) ).

tff(addAssignment_11304,axiom,
    ! [VarCurr: state_type] :
      ( v22204(VarCurr)
    <=> v22206(VarCurr) ) ).

tff(addAssignment_11303,axiom,
    ! [VarCurr: state_type] :
      ( v22206(VarCurr)
    <=> v22121(VarCurr,1) ) ).

tff(addAssignment_11302,axiom,
    ! [VarCurr: state_type] :
      ( v22200(VarCurr)
    <=> v22202(VarCurr) ) ).

tff(addAssignment_11301,axiom,
    ! [VarCurr: state_type] :
      ( v22202(VarCurr)
    <=> v22121(VarCurr,0) ) ).

tff(addAssignment_11300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22174(VarCurr,B)
      <=> v22176(VarCurr,B) ) ) ).

tff(addAssignment_11299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22176(VarCurr,B)
      <=> v22178(VarCurr,B) ) ) ).

tff(addAssignment_11298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22178(VarCurr,B)
      <=> v22180(VarCurr,B) ) ) ).

tff(addAssignment_11297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22180(VarCurr,B)
      <=> v22182(VarCurr,B) ) ) ).

tff(addAssignment_11296,axiom,
    ! [VarCurr: state_type] :
      ( v22148(VarCurr)
    <=> v22150(VarCurr) ) ).

tff(addAssignment_11295,axiom,
    ! [VarCurr: state_type] :
      ( v22150(VarCurr)
    <=> v22152(VarCurr) ) ).

tff(addAssignment_11294,axiom,
    ! [VarCurr: state_type] :
      ( v22152(VarCurr)
    <=> v22154(VarCurr) ) ).

tff(addAssignment_11293,axiom,
    ! [VarCurr: state_type] :
      ( v22154(VarCurr)
    <=> v22156(VarCurr) ) ).

tff(addAssignment_11292,axiom,
    ! [VarCurr: state_type] :
      ( v22156(VarCurr)
    <=> v22158(VarCurr) ) ).

tff(addAssignment_11291,axiom,
    ! [VarCurr: state_type] :
      ( v22158(VarCurr)
    <=> v22160(VarCurr) ) ).

tff(addAssignment_11290,axiom,
    ! [VarCurr: state_type] :
      ( v22160(VarCurr)
    <=> v22162(VarCurr) ) ).

tff(writeUnaryOperator_1217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22162(VarCurr)
    <=> v22172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1808,axiom,
    ! [VarCurr: state_type] :
      ( v22172(VarCurr)
    <=> ( v22164(VarCurr)
        | v22168(VarCurr) ) ) ).

tff(addAssignment_11289,axiom,
    ! [VarCurr: state_type] :
      ( v22168(VarCurr)
    <=> v22170(VarCurr) ) ).

tff(addAssignment_11288,axiom,
    ! [VarCurr: state_type] :
      ( v22170(VarCurr)
    <=> v22121(VarCurr,1) ) ).

tff(addAssignment_11287,axiom,
    ! [VarCurr: state_type] :
      ( v22121(VarCurr,1)
    <=> v22123(VarCurr,1) ) ).

tff(addAssignment_11286,axiom,
    ! [VarCurr: state_type] :
      ( v22123(VarCurr,1)
    <=> v22125(VarCurr,1) ) ).

tff(addAssignment_11285,axiom,
    ! [VarCurr: state_type] :
      ( v22125(VarCurr,1)
    <=> v22130(VarCurr,1) ) ).

tff(addAssignment_11284,axiom,
    ! [VarCurr: state_type] :
      ( v22127(VarCurr,1)
    <=> v22129(VarCurr,1) ) ).

tff(addAssignment_11283,axiom,
    ! [VarCurr: state_type] :
      ( v22129(VarCurr,1)
    <=> v22073(VarCurr,1) ) ).

tff(addAssignment_11282,axiom,
    ! [VarCurr: state_type] :
      ( v22164(VarCurr)
    <=> v22166(VarCurr) ) ).

tff(addAssignment_11281,axiom,
    ! [VarCurr: state_type] :
      ( v22166(VarCurr)
    <=> v22073(VarCurr,0) ) ).

tff(addAssignment_11280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22138(VarCurr,B)
      <=> v22140(VarCurr,B) ) ) ).

tff(addAssignment_11279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22140(VarCurr,B)
      <=> v22142(VarCurr,B) ) ) ).

tff(addAssignment_11278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22142(VarCurr,B)
      <=> v22144(VarCurr,B) ) ) ).

tff(addAssignment_11277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22144(VarCurr,B)
      <=> v22146(VarCurr,B) ) ) ).

tff(addAssignment_11276,axiom,
    ! [VarCurr: state_type] :
      ( v22101(VarCurr)
    <=> v22103(VarCurr) ) ).

tff(addAssignment_11275,axiom,
    ! [VarCurr: state_type] :
      ( v22103(VarCurr)
    <=> v22105(VarCurr) ) ).

tff(addAssignment_11274,axiom,
    ! [VarCurr: state_type] :
      ( v22105(VarCurr)
    <=> v22107(VarCurr) ) ).

tff(addAssignment_11273,axiom,
    ! [VarCurr: state_type] :
      ( v22107(VarCurr)
    <=> v22109(VarCurr) ) ).

tff(addAssignment_11272,axiom,
    ! [VarCurr: state_type] :
      ( v22109(VarCurr)
    <=> v22111(VarCurr) ) ).

tff(addAssignment_11271,axiom,
    ! [VarCurr: state_type] :
      ( v22111(VarCurr)
    <=> v22113(VarCurr) ) ).

tff(addAssignment_11270,axiom,
    ! [VarCurr: state_type] :
      ( v22113(VarCurr)
    <=> v22115(VarCurr) ) ).

tff(writeUnaryOperator_1216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22115(VarCurr)
    <=> v22136(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1807,axiom,
    ! [VarCurr: state_type] :
      ( v22136(VarCurr)
    <=> ( v22117(VarCurr)
        | v22132(VarCurr) ) ) ).

tff(addAssignment_11269,axiom,
    ! [VarCurr: state_type] :
      ( v22132(VarCurr)
    <=> v22134(VarCurr) ) ).

tff(addAssignment_11268,axiom,
    ! [VarCurr: state_type] :
      ( v22134(VarCurr)
    <=> v22073(VarCurr,1) ) ).

tff(addAssignment_11267,axiom,
    ! [VarCurr: state_type] :
      ( v22117(VarCurr)
    <=> v22119(VarCurr) ) ).

tff(addAssignment_11266,axiom,
    ! [VarCurr: state_type] :
      ( v22119(VarCurr)
    <=> v22121(VarCurr,0) ) ).

tff(addAssignment_11265,axiom,
    ! [VarCurr: state_type] :
      ( v22121(VarCurr,0)
    <=> v22123(VarCurr,0) ) ).

tff(addAssignment_11264,axiom,
    ! [VarCurr: state_type] :
      ( v22123(VarCurr,0)
    <=> v22125(VarCurr,0) ) ).

tff(addAssignment_11263,axiom,
    ! [VarCurr: state_type] :
      ( v22125(VarCurr,0)
    <=> v22130(VarCurr,0) ) ).

tff(writeUnaryOperator_1215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v22130(VarCurr,B)
      <=> ~ v22127(VarCurr,B) ) ) ).

tff(addAssignment_11262,axiom,
    ! [VarCurr: state_type] :
      ( v22127(VarCurr,0)
    <=> v22129(VarCurr,0) ) ).

tff(addAssignment_11261,axiom,
    ! [VarCurr: state_type] :
      ( v22129(VarCurr,0)
    <=> v22073(VarCurr,0) ) ).

tff(addAssignment_11260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22091(VarCurr,B)
      <=> v22093(VarCurr,B) ) ) ).

tff(addAssignment_11259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22093(VarCurr,B)
      <=> v22095(VarCurr,B) ) ) ).

tff(addAssignment_11258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22095(VarCurr,B)
      <=> v22097(VarCurr,B) ) ) ).

tff(addAssignment_11257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22097(VarCurr,B)
      <=> v22099(VarCurr,B) ) ) ).

tff(addAssignment_11256,axiom,
    ! [VarCurr: state_type] :
      ( v22053(VarCurr)
    <=> v22055(VarCurr) ) ).

tff(addAssignment_11255,axiom,
    ! [VarCurr: state_type] :
      ( v22055(VarCurr)
    <=> v22057(VarCurr) ) ).

tff(addAssignment_11254,axiom,
    ! [VarCurr: state_type] :
      ( v22057(VarCurr)
    <=> v22059(VarCurr) ) ).

tff(addAssignment_11253,axiom,
    ! [VarCurr: state_type] :
      ( v22059(VarCurr)
    <=> v22061(VarCurr) ) ).

tff(addAssignment_11252,axiom,
    ! [VarCurr: state_type] :
      ( v22061(VarCurr)
    <=> v22063(VarCurr) ) ).

tff(addAssignment_11251,axiom,
    ! [VarCurr: state_type] :
      ( v22063(VarCurr)
    <=> v22065(VarCurr) ) ).

tff(addAssignment_11250,axiom,
    ! [VarCurr: state_type] :
      ( v22065(VarCurr)
    <=> v22067(VarCurr) ) ).

tff(writeUnaryOperator_1214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v22067(VarCurr)
    <=> v22089(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1806,axiom,
    ! [VarCurr: state_type] :
      ( v22089(VarCurr)
    <=> ( v22069(VarCurr)
        | v22085(VarCurr) ) ) ).

tff(addAssignment_11249,axiom,
    ! [VarCurr: state_type] :
      ( v22085(VarCurr)
    <=> v22087(VarCurr) ) ).

tff(addAssignment_11248,axiom,
    ! [VarCurr: state_type] :
      ( v22087(VarCurr)
    <=> v22073(VarCurr,1) ) ).

tff(addAssignment_11247,axiom,
    ! [VarCurr: state_type] :
      ( v22073(VarCurr,1)
    <=> v22075(VarCurr,1) ) ).

tff(addAssignment_11246,axiom,
    ! [VarCurr: state_type] :
      ( v22075(VarCurr,1)
    <=> v22077(VarCurr,1) ) ).

tff(addAssignment_11245,axiom,
    ! [VarCurr: state_type] :
      ( v22077(VarCurr,1)
    <=> v22079(VarCurr,1) ) ).

tff(addAssignment_11244,axiom,
    ! [VarCurr: state_type] :
      ( v22079(VarCurr,1)
    <=> v22081(VarCurr,1) ) ).

tff(addAssignment_11243,axiom,
    ! [VarCurr: state_type] :
      ( v22081(VarCurr,1)
    <=> v22083(VarCurr,1) ) ).

tff(addAssignment_11242,axiom,
    ! [VarCurr: state_type] :
      ( v22069(VarCurr)
    <=> v22071(VarCurr) ) ).

tff(addAssignment_11241,axiom,
    ! [VarCurr: state_type] :
      ( v22071(VarCurr)
    <=> v22073(VarCurr,0) ) ).

tff(addAssignment_11240,axiom,
    ! [VarCurr: state_type] :
      ( v22073(VarCurr,0)
    <=> v22075(VarCurr,0) ) ).

tff(addAssignment_11239,axiom,
    ! [VarCurr: state_type] :
      ( v22075(VarCurr,0)
    <=> v22077(VarCurr,0) ) ).

tff(addAssignment_11238,axiom,
    ! [VarCurr: state_type] :
      ( v22077(VarCurr,0)
    <=> v22079(VarCurr,0) ) ).

tff(addAssignment_11237,axiom,
    ! [VarCurr: state_type] :
      ( v22079(VarCurr,0)
    <=> v22081(VarCurr,0) ) ).

tff(addAssignment_11236,axiom,
    ! [VarCurr: state_type] :
      ( v22081(VarCurr,0)
    <=> v22083(VarCurr,0) ) ).

tff(addAssignment_11235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22043(VarCurr,B)
      <=> v22045(VarCurr,B) ) ) ).

tff(addAssignment_11234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22045(VarCurr,B)
      <=> v22047(VarCurr,B) ) ) ).

tff(addAssignment_11233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22047(VarCurr,B)
      <=> v22049(VarCurr,B) ) ) ).

tff(addAssignment_11232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v22049(VarCurr,B)
      <=> v22051(VarCurr,B) ) ) ).

tff(addAssignment_11231,axiom,
    ! [VarCurr: state_type] :
      ( v22023(VarCurr)
    <=> v22025(VarCurr) ) ).

tff(addAssignment_11230,axiom,
    ! [VarCurr: state_type] :
      ( v22025(VarCurr)
    <=> v22027(VarCurr) ) ).

tff(addAssignment_11229,axiom,
    ! [VarCurr: state_type] :
      ( v22027(VarCurr)
    <=> v22029(VarCurr) ) ).

tff(addAssignment_11228,axiom,
    ! [VarCurr: state_type] :
      ( v22029(VarCurr)
    <=> v22031(VarCurr) ) ).

tff(addAssignment_11227,axiom,
    ! [VarCurr: state_type] :
      ( v22031(VarCurr)
    <=> v22033(VarCurr) ) ).

tff(addAssignment_11226,axiom,
    ! [VarCurr: state_type] :
      ( v22033(VarCurr)
    <=> v22035(VarCurr) ) ).

tff(addAssignment_11225,axiom,
    ! [VarCurr: state_type] :
      ( v22035(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_11224,axiom,
    ! [VarCurr: state_type] :
      ( v22009(VarCurr)
    <=> v22011(VarCurr) ) ).

tff(addAssignment_11223,axiom,
    ! [VarCurr: state_type] :
      ( v22011(VarCurr)
    <=> v22013(VarCurr) ) ).

tff(addAssignment_11222,axiom,
    ! [VarCurr: state_type] :
      ( v22013(VarCurr)
    <=> v22015(VarCurr) ) ).

tff(addAssignment_11221,axiom,
    ! [VarCurr: state_type] :
      ( v22015(VarCurr)
    <=> v22017(VarCurr) ) ).

tff(addAssignment_11220,axiom,
    ! [VarCurr: state_type] :
      ( v22017(VarCurr)
    <=> v22019(VarCurr) ) ).

tff(addAssignment_11219,axiom,
    ! [VarCurr: state_type] :
      ( v22019(VarCurr)
    <=> v22021(VarCurr) ) ).

tff(addAssignment_11218,axiom,
    ! [VarCurr: state_type] :
      ( v22021(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_11217,axiom,
    ! [VarCurr: state_type] :
      ( v21995(VarCurr)
    <=> v21997(VarCurr) ) ).

tff(addAssignment_11216,axiom,
    ! [VarCurr: state_type] :
      ( v21997(VarCurr)
    <=> v9490(VarCurr,8) ) ).

tff(addAssignment_11215,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,8)
    <=> v9492(VarCurr,8) ) ).

tff(addAssignment_11214,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,8)
    <=> v9494(VarCurr,8) ) ).

tff(addAssignment_11213,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,8)
    <=> v9570(VarCurr,8) ) ).

tff(addAssignment_11212,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,8)
    <=> v9513(VarCurr,8) ) ).

tff(addAssignment_11211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21991(VarCurr,B)
      <=> v21993(VarCurr,B) ) ) ).

tff(addAssignment_11210,axiom,
    ! [VarCurr: state_type] :
      ( ( v21993(VarCurr,11)
      <=> v9208(VarCurr,107) )
      & ( v21993(VarCurr,10)
      <=> v9208(VarCurr,106) )
      & ( v21993(VarCurr,9)
      <=> v9208(VarCurr,105) )
      & ( v21993(VarCurr,8)
      <=> v9208(VarCurr,104) )
      & ( v21993(VarCurr,7)
      <=> v9208(VarCurr,103) )
      & ( v21993(VarCurr,6)
      <=> v9208(VarCurr,102) )
      & ( v21993(VarCurr,5)
      <=> v9208(VarCurr,101) )
      & ( v21993(VarCurr,4)
      <=> v9208(VarCurr,100) )
      & ( v21993(VarCurr,3)
      <=> v9208(VarCurr,99) )
      & ( v21993(VarCurr,2)
      <=> v9208(VarCurr,98) )
      & ( v21993(VarCurr,1)
      <=> v9208(VarCurr,97) )
      & ( v21993(VarCurr,0)
      <=> v9208(VarCurr,96) ) ) ).

tff(addAssignment_11209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21959(VarCurr,B)
      <=> v21961(VarCurr,B) ) ) ).

tff(addAssignment_11208,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,0)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11207,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,1)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11206,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,2)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11205,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,3)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11204,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,4)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11203,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,5)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11202,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,6)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11201,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,7)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11200,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,8)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11199,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,9)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11198,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,10)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11197,axiom,
    ! [VarCurr: state_type] :
      ( v21961(VarCurr,11)
    <=> v21979(VarCurr) ) ).

tff(addAssignment_11196,axiom,
    ! [VarCurr: state_type] :
      ( v21979(VarCurr)
    <=> v21963(VarCurr) ) ).

tff(addAssignment_11195,axiom,
    ! [VarCurr: state_type] :
      ( v21963(VarCurr)
    <=> v21965(VarCurr,0) ) ).

tff(addAssignment_11194,axiom,
    ! [VarCurr: state_type] :
      ( v21965(VarCurr,0)
    <=> v21967(VarCurr,0) ) ).

tff(addAssignment_11193,axiom,
    ! [VarCurr: state_type] :
      ( v21967(VarCurr,0)
    <=> v21977(VarCurr,0) ) ).

tff(writeUnaryOperator_1213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v21977(VarCurr,B)
      <=> ~ v21969(VarCurr,B) ) ) ).

tff(addAssignment_11192,axiom,
    ! [VarCurr: state_type] :
      ( v21969(VarCurr,0)
    <=> v21971(VarCurr,0) ) ).

tff(addAssignment_11191,axiom,
    ! [VarCurr: state_type] :
      ( v21971(VarCurr,0)
    <=> v21974(VarCurr,0) ) ).

tff(addAssignment_11190,axiom,
    ! [VarCurr: state_type] :
      ( v21974(VarCurr,0)
    <=> v21973(VarCurr) ) ).

tff(addAssignment_11189,axiom,
    ! [VarCurr: state_type] :
      ( v21974(VarCurr,1)
    <=> v21976(VarCurr) ) ).

tff(addAssignment_11188,axiom,
    ! [VarCurr: state_type] :
      ( v21974(VarCurr,2)
    <=> v21975(VarCurr) ) ).

tff(addAssignment_11187,axiom,
    ! [VarCurr: state_type] :
      ( v21973(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_11186,axiom,
    ! [VarCurr: state_type] :
      ( v21935(VarCurr)
    <=> v21937(VarCurr) ) ).

tff(addAssignment_11185,axiom,
    ! [VarCurr: state_type] :
      ( v21937(VarCurr)
    <=> v21939(VarCurr) ) ).

tff(addAssignment_11184,axiom,
    ! [VarCurr: state_type] :
      ( v21939(VarCurr)
    <=> v21941(VarCurr) ) ).

tff(addAssignment_11183,axiom,
    ! [VarCurr: state_type] :
      ( v21941(VarCurr)
    <=> v21943(VarCurr) ) ).

tff(addAssignment_11182,axiom,
    ! [VarCurr: state_type] :
      ( v21943(VarCurr)
    <=> v21945(VarCurr) ) ).

tff(addAssignment_11181,axiom,
    ! [VarCurr: state_type] :
      ( v21945(VarCurr)
    <=> v21947(VarCurr) ) ).

tff(addAssignment_11180,axiom,
    ! [VarCurr: state_type] :
      ( v21947(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_11179,axiom,
    ! [VarCurr: state_type] :
      ( v21921(VarCurr)
    <=> v21923(VarCurr) ) ).

tff(addAssignment_11178,axiom,
    ! [VarCurr: state_type] :
      ( v21923(VarCurr)
    <=> v21925(VarCurr) ) ).

tff(addAssignment_11177,axiom,
    ! [VarCurr: state_type] :
      ( v21925(VarCurr)
    <=> v21927(VarCurr) ) ).

tff(addAssignment_11176,axiom,
    ! [VarCurr: state_type] :
      ( v21927(VarCurr)
    <=> v21929(VarCurr) ) ).

tff(addAssignment_11175,axiom,
    ! [VarCurr: state_type] :
      ( v21929(VarCurr)
    <=> v21931(VarCurr) ) ).

tff(addAssignment_11174,axiom,
    ! [VarCurr: state_type] :
      ( v21931(VarCurr)
    <=> v21933(VarCurr) ) ).

tff(addAssignment_11173,axiom,
    ! [VarCurr: state_type] :
      ( v21933(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_11172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21897(VarCurr,B)
      <=> v21899(VarCurr,B) ) ) ).

tff(addAssignment_11171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21899(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_11170,axiom,
    ! [VarCurr: state_type] :
      ( v20341(VarCurr)
    <=> v20343(VarCurr) ) ).

tff(addAssignment_11169,axiom,
    ! [VarCurr: state_type] :
      ( v20343(VarCurr)
    <=> v20345(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_93,axiom,
    ! [VarCurr: state_type] :
      ( v20345(VarCurr)
    <=> ( ( v20347(VarCurr,11)
        <=> v20351(VarCurr,11) )
        & ( v20347(VarCurr,10)
        <=> v20351(VarCurr,10) )
        & ( v20347(VarCurr,9)
        <=> v20351(VarCurr,9) )
        & ( v20347(VarCurr,8)
        <=> v20351(VarCurr,8) )
        & ( v20347(VarCurr,7)
        <=> v20351(VarCurr,7) )
        & ( v20347(VarCurr,6)
        <=> v20351(VarCurr,6) )
        & ( v20347(VarCurr,5)
        <=> v20351(VarCurr,5) )
        & ( v20347(VarCurr,4)
        <=> v20351(VarCurr,4) )
        & ( v20347(VarCurr,3)
        <=> v20351(VarCurr,3) )
        & ( v20347(VarCurr,2)
        <=> v20351(VarCurr,2) )
        & ( v20347(VarCurr,1)
        <=> v20351(VarCurr,1) )
        & ( v20347(VarCurr,0)
        <=> v20351(VarCurr,0) ) ) ) ).

tff(addAssignment_11168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20351(VarCurr,B)
      <=> v20353(VarCurr,B) ) ) ).

tff(addAssignment_11167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20353(VarCurr,B)
      <=> v20355(VarCurr,B) ) ) ).

tff(addAssignment_11166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20355(VarCurr,B)
      <=> v20357(VarCurr,B) ) ) ).

tff(addAssignment_11165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20357(VarCurr,B)
      <=> v20359(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_368,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20359(VarCurr,B)
      <=> ( v21867(VarCurr,B)
          | v21886(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21886(VarCurr,B)
      <=> ( v21738(VarCurr,B)
          & v21887(VarCurr,B) ) ) ) ).

tff(addAssignment_11164,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,0)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11163,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,1)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11162,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,2)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11161,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,3)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11160,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,4)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11159,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,5)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11158,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,6)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11157,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,7)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11156,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,8)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11155,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,9)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11154,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,10)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11153,axiom,
    ! [VarCurr: state_type] :
      ( v21887(VarCurr,11)
    <=> v21888(VarCurr) ) ).

tff(addAssignment_11152,axiom,
    ! [VarCurr: state_type] :
      ( v21888(VarCurr)
    <=> v21857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_366,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21867(VarCurr,B)
      <=> ( v21868(VarCurr,B)
          | v21883(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21883(VarCurr,B)
      <=> ( v21587(VarCurr,B)
          & v21884(VarCurr,B) ) ) ) ).

tff(addAssignment_11151,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,0)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11150,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,1)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11149,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,2)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11148,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,3)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11147,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,4)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11146,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,5)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11145,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,6)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11144,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,7)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11143,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,8)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11142,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,9)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11141,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,10)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11140,axiom,
    ! [VarCurr: state_type] :
      ( v21884(VarCurr,11)
    <=> v21885(VarCurr) ) ).

tff(addAssignment_11139,axiom,
    ! [VarCurr: state_type] :
      ( v21885(VarCurr)
    <=> v21707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21868(VarCurr,B)
      <=> ( v21869(VarCurr,B)
          | v21880(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_363,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21880(VarCurr,B)
      <=> ( v21436(VarCurr,B)
          & v21881(VarCurr,B) ) ) ) ).

tff(addAssignment_11138,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,0)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11137,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,1)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11136,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,2)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11135,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,3)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11134,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,4)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11133,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,5)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11132,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,6)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11131,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,7)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11130,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,8)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11129,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,9)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11128,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,10)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11127,axiom,
    ! [VarCurr: state_type] :
      ( v21881(VarCurr,11)
    <=> v21882(VarCurr) ) ).

tff(addAssignment_11126,axiom,
    ! [VarCurr: state_type] :
      ( v21882(VarCurr)
    <=> v21556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_362,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21869(VarCurr,B)
      <=> ( v21870(VarCurr,B)
          | v21877(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21877(VarCurr,B)
      <=> ( v21285(VarCurr,B)
          & v21878(VarCurr,B) ) ) ) ).

tff(addAssignment_11125,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,0)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11124,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,1)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11123,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,2)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11122,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,3)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11121,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,4)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11120,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,5)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11119,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,6)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11118,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,7)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11117,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,8)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11116,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,9)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11115,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,10)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11114,axiom,
    ! [VarCurr: state_type] :
      ( v21878(VarCurr,11)
    <=> v21879(VarCurr) ) ).

tff(addAssignment_11113,axiom,
    ! [VarCurr: state_type] :
      ( v21879(VarCurr)
    <=> v21405(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21870(VarCurr,B)
      <=> ( v21871(VarCurr,B)
          | v21874(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21874(VarCurr,B)
      <=> ( v21123(VarCurr,B)
          & v21875(VarCurr,B) ) ) ) ).

tff(addAssignment_11112,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,0)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11111,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,1)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11110,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,2)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11109,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,3)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11108,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,4)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11107,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,5)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11106,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,6)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11105,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,7)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11104,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,8)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11103,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,9)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11102,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,10)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11101,axiom,
    ! [VarCurr: state_type] :
      ( v21875(VarCurr,11)
    <=> v21876(VarCurr) ) ).

tff(addAssignment_11100,axiom,
    ! [VarCurr: state_type] :
      ( v21876(VarCurr)
    <=> v21254(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21871(VarCurr,B)
      <=> ( v20361(VarCurr,B)
          & v21872(VarCurr,B) ) ) ) ).

tff(addAssignment_11099,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,0)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11098,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,1)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11097,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,2)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11096,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,3)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11095,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,4)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11094,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,5)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11093,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,6)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11092,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,7)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11091,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,8)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11090,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,9)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11089,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,10)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11088,axiom,
    ! [VarCurr: state_type] :
      ( v21872(VarCurr,11)
    <=> v21873(VarCurr) ) ).

tff(addAssignment_11087,axiom,
    ! [VarCurr: state_type] :
      ( v21873(VarCurr)
    <=> v20831(VarCurr) ) ).

tff(addAssignment_11086,axiom,
    ! [VarCurr: state_type] :
      ( v21857(VarCurr)
    <=> v21859(VarCurr) ) ).

tff(addAssignment_11085,axiom,
    ! [VarCurr: state_type] :
      ( v21859(VarCurr)
    <=> v21861(VarCurr) ) ).

tff(addAssignment_11084,axiom,
    ! [VarCurr: state_type] :
      ( v21861(VarCurr)
    <=> v21863(VarCurr) ) ).

tff(addAssignment_11083,axiom,
    ! [VarCurr: state_type] :
      ( v21863(VarCurr)
    <=> v21865(VarCurr) ) ).

tff(addAssignment_11082,axiom,
    ! [VarCurr: state_type] :
      ( v21865(VarCurr)
    <=> v20924(VarCurr) ) ).

tff(addAssignment_11081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21738(VarCurr,B)
      <=> v21740(VarCurr,B) ) ) ).

tff(addAssignment_11080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21740(VarCurr,B)
      <=> v21742(VarCurr,B) ) ) ).

tff(addAssignment_11079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21742(VarCurr,B)
      <=> v21744(VarCurr,B) ) ) ).

tff(addAssignment_11078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21744(VarCurr,B)
      <=> v21746(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21840(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21746(VarNext,B)
            <=> v21746(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_248,axiom,
    ! [VarNext: state_type] :
      ( v21840(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21746(VarNext,B)
          <=> v21850(VarNext,B) ) ) ) ).

tff(addAssignment_11077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21850(VarNext,B)
          <=> v21848(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21848(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_159,axiom,
    ! [VarCurr: state_type] :
      ( v21851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21848(VarCurr,B)
          <=> v21768(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1805,axiom,
    ! [VarCurr: state_type] :
      ( v21851(VarCurr)
    <=> ( v21852(VarCurr)
        & v21853(VarCurr) ) ) ).

tff(writeUnaryOperator_1212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21853(VarCurr)
    <=> v21758(VarCurr) ) ).

tff(writeUnaryOperator_1211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21852(VarCurr)
    <=> v21748(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21840(VarNext)
      <=> v21841(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21841(VarNext)
      <=> ( v21842(VarNext)
          & v21772(VarNext) ) ) ) ).

tff(writeUnaryOperator_1210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21842(VarNext)
      <=> v21844(VarNext) ) ) ).

tff(addAssignment_11076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21844(VarNext)
      <=> v21772(VarCurr) ) ) ).

tff(addAssignment_11075,axiom,
    ! [VarCurr: state_type] :
      ( v21772(VarCurr)
    <=> v21774(VarCurr) ) ).

tff(addAssignment_11074,axiom,
    ! [VarCurr: state_type] :
      ( v21774(VarCurr)
    <=> v21776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1802,axiom,
    ! [VarCurr: state_type] :
      ( v21776(VarCurr)
    <=> ( v21837(VarCurr)
        | v21833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1801,axiom,
    ! [VarCurr: state_type] :
      ( v21837(VarCurr)
    <=> ( v21778(VarCurr)
        & v21782(VarCurr) ) ) ).

tff(addAssignment_11073,axiom,
    ! [VarCurr: state_type] :
      ( v21833(VarCurr)
    <=> v21835(VarCurr) ) ).

tff(addAssignment_11072,axiom,
    ! [VarCurr: state_type] :
      ( v21835(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21817(VarNext)
       => ( v21782(VarNext)
        <=> v21782(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_247,axiom,
    ! [VarNext: state_type] :
      ( v21817(VarNext)
     => ( v21782(VarNext)
      <=> v21827(VarNext) ) ) ).

tff(addAssignment_11071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21827(VarNext)
      <=> v21825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1800,axiom,
    ! [VarCurr: state_type] :
      ( v21825(VarCurr)
    <=> ( v21828(VarCurr)
        & v21829(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1799,axiom,
    ! [VarCurr: state_type] :
      ( v21829(VarCurr)
    <=> ( v21788(VarCurr)
        | v21812(VarCurr) ) ) ).

tff(writeUnaryOperator_1209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21828(VarCurr)
    <=> v21784(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1798,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21817(VarNext)
      <=> v21818(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1797,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21818(VarNext)
      <=> ( v21820(VarNext)
          & v21822(VarNext) ) ) ) ).

tff(writeUnaryOperator_1208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21822(VarCurr)
    <=> v21778(VarCurr) ) ).

tff(addAssignment_11070,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21820(VarNext)
      <=> v21778(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_88,axiom,
    ( v21782(constB0)
  <=> $true ) ).

tff(addAssignment_11069,axiom,
    ! [VarCurr: state_type] :
      ( v21812(VarCurr)
    <=> v21814(VarCurr) ) ).

tff(addAssignment_11068,axiom,
    ! [VarCurr: state_type] :
      ( v21814(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_11067,axiom,
    ! [VarCurr: state_type] :
      ( v21788(VarCurr)
    <=> v21790(VarCurr) ) ).

tff(addAssignment_11066,axiom,
    ! [VarCurr: state_type] :
      ( v21790(VarCurr)
    <=> v21098(VarCurr) ) ).

tff(addAssignment_11065,axiom,
    ! [VarCurr: state_type] :
      ( v21098(VarCurr)
    <=> v21793(VarCurr) ) ).

tff(addAssignment_11064,axiom,
    ! [VarCurr: state_type] :
      ( v21793(VarCurr)
    <=> v21795(VarCurr) ) ).

tff(writeUnaryOperator_1207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21795(VarCurr)
    <=> v21809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1796,axiom,
    ! [VarCurr: state_type] :
      ( v21809(VarCurr)
    <=> ( v21810(VarCurr)
        | v21805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1795,axiom,
    ! [VarCurr: state_type] :
      ( v21810(VarCurr)
    <=> ( v21797(VarCurr)
        | v21801(VarCurr) ) ) ).

tff(addAssignment_11063,axiom,
    ! [VarCurr: state_type] :
      ( v21805(VarCurr)
    <=> v21807(VarCurr) ) ).

tff(addAssignment_11062,axiom,
    ! [VarCurr: state_type] :
      ( v21807(VarCurr)
    <=> v21187(VarCurr,2) ) ).

tff(addAssignment_11061,axiom,
    ! [VarCurr: state_type] :
      ( v21801(VarCurr)
    <=> v21803(VarCurr) ) ).

tff(addAssignment_11060,axiom,
    ! [VarCurr: state_type] :
      ( v21803(VarCurr)
    <=> v20761(VarCurr,1) ) ).

tff(addAssignment_11059,axiom,
    ! [VarCurr: state_type] :
      ( v21797(VarCurr)
    <=> v21799(VarCurr) ) ).

tff(addAssignment_11058,axiom,
    ! [VarCurr: state_type] :
      ( v21799(VarCurr)
    <=> v21187(VarCurr,0) ) ).

tff(addAssignment_11057,axiom,
    ! [VarCurr: state_type] :
      ( v21784(VarCurr)
    <=> v21786(VarCurr) ) ).

tff(addAssignment_11056,axiom,
    ! [VarCurr: state_type] :
      ( v21786(VarCurr)
    <=> $false ) ).

tff(addAssignment_11055,axiom,
    ! [VarCurr: state_type] :
      ( v21778(VarCurr)
    <=> v21780(VarCurr) ) ).

tff(addAssignment_11054,axiom,
    ! [VarCurr: state_type] :
      ( v21780(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_11053,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21768(VarCurr,B)
      <=> v21770(VarCurr,B) ) ) ).

tff(addAssignment_11052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21770(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_11051,axiom,
    ! [VarCurr: state_type] :
      ( v21758(VarCurr)
    <=> v21760(VarCurr) ) ).

tff(addAssignment_11050,axiom,
    ! [VarCurr: state_type] :
      ( v21760(VarCurr)
    <=> v21762(VarCurr) ) ).

tff(addAssignment_11049,axiom,
    ! [VarCurr: state_type] :
      ( v21762(VarCurr)
    <=> v21764(VarCurr) ) ).

tff(addAssignment_11048,axiom,
    ! [VarCurr: state_type] :
      ( v21764(VarCurr)
    <=> v21766(VarCurr) ) ).

tff(addAssignment_11047,axiom,
    ! [VarCurr: state_type] :
      ( v21766(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_11046,axiom,
    ! [VarCurr: state_type] :
      ( v21748(VarCurr)
    <=> v21750(VarCurr) ) ).

tff(addAssignment_11045,axiom,
    ! [VarCurr: state_type] :
      ( v21750(VarCurr)
    <=> v21752(VarCurr) ) ).

tff(addAssignment_11044,axiom,
    ! [VarCurr: state_type] :
      ( v21752(VarCurr)
    <=> v21754(VarCurr) ) ).

tff(addAssignment_11043,axiom,
    ! [VarCurr: state_type] :
      ( v21754(VarCurr)
    <=> v21756(VarCurr) ) ).

tff(addAssignment_11042,axiom,
    ! [VarCurr: state_type] :
      ( v21756(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_11041,axiom,
    ! [VarCurr: state_type] :
      ( v21707(VarCurr)
    <=> v21709(VarCurr) ) ).

tff(addAssignment_11040,axiom,
    ! [VarCurr: state_type] :
      ( v21709(VarCurr)
    <=> v21711(VarCurr) ) ).

tff(addAssignment_11039,axiom,
    ! [VarCurr: state_type] :
      ( v21711(VarCurr)
    <=> v21713(VarCurr) ) ).

tff(addAssignment_11038,axiom,
    ! [VarCurr: state_type] :
      ( v21713(VarCurr)
    <=> v21715(VarCurr) ) ).

tff(addAssignment_11037,axiom,
    ! [VarCurr: state_type] :
      ( v21715(VarCurr)
    <=> v21717(VarCurr) ) ).

tff(addAssignment_11036,axiom,
    ! [VarCurr: state_type] :
      ( v21717(VarCurr)
    <=> v21719(VarCurr) ) ).

tff(addAssignment_11035,axiom,
    ! [VarCurr: state_type] :
      ( v21719(VarCurr)
    <=> v21721(VarCurr) ) ).

tff(writeUnaryOperator_1206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21721(VarCurr)
    <=> v21735(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1794,axiom,
    ! [VarCurr: state_type] :
      ( v21735(VarCurr)
    <=> ( v21736(VarCurr)
        | v21731(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1793,axiom,
    ! [VarCurr: state_type] :
      ( v21736(VarCurr)
    <=> ( v21723(VarCurr)
        | v21727(VarCurr) ) ) ).

tff(addAssignment_11034,axiom,
    ! [VarCurr: state_type] :
      ( v21731(VarCurr)
    <=> v21733(VarCurr) ) ).

tff(addAssignment_11033,axiom,
    ! [VarCurr: state_type] :
      ( v21733(VarCurr)
    <=> v20934(VarCurr,2) ) ).

tff(addAssignment_11032,axiom,
    ! [VarCurr: state_type] :
      ( v21727(VarCurr)
    <=> v21729(VarCurr) ) ).

tff(addAssignment_11031,axiom,
    ! [VarCurr: state_type] :
      ( v21729(VarCurr)
    <=> v20851(VarCurr,1) ) ).

tff(addAssignment_11030,axiom,
    ! [VarCurr: state_type] :
      ( v21723(VarCurr)
    <=> v21725(VarCurr) ) ).

tff(addAssignment_11029,axiom,
    ! [VarCurr: state_type] :
      ( v21725(VarCurr)
    <=> v20851(VarCurr,0) ) ).

tff(addAssignment_11028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21587(VarCurr,B)
      <=> v21589(VarCurr,B) ) ) ).

tff(addAssignment_11027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21589(VarCurr,B)
      <=> v21591(VarCurr,B) ) ) ).

tff(addAssignment_11026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21591(VarCurr,B)
      <=> v21593(VarCurr,B) ) ) ).

tff(addAssignment_11025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21593(VarCurr,B)
      <=> v21595(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_246,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21690(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21595(VarNext,B)
            <=> v21595(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_246,axiom,
    ! [VarNext: state_type] :
      ( v21690(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21595(VarNext,B)
          <=> v21700(VarNext,B) ) ) ) ).

tff(addAssignment_11024,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21700(VarNext,B)
          <=> v21698(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21701(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21698(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_158,axiom,
    ! [VarCurr: state_type] :
      ( v21701(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21698(VarCurr,B)
          <=> v21617(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1792,axiom,
    ! [VarCurr: state_type] :
      ( v21701(VarCurr)
    <=> ( v21702(VarCurr)
        & v21703(VarCurr) ) ) ).

tff(writeUnaryOperator_1205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21703(VarCurr)
    <=> v21607(VarCurr) ) ).

tff(writeUnaryOperator_1204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21702(VarCurr)
    <=> v21597(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1791,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21690(VarNext)
      <=> v21691(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21691(VarNext)
      <=> ( v21692(VarNext)
          & v21621(VarNext) ) ) ) ).

tff(writeUnaryOperator_1203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21692(VarNext)
      <=> v21694(VarNext) ) ) ).

tff(addAssignment_11023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21694(VarNext)
      <=> v21621(VarCurr) ) ) ).

tff(addAssignment_11022,axiom,
    ! [VarCurr: state_type] :
      ( v21621(VarCurr)
    <=> v21623(VarCurr) ) ).

tff(addAssignment_11021,axiom,
    ! [VarCurr: state_type] :
      ( v21623(VarCurr)
    <=> v21625(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1789,axiom,
    ! [VarCurr: state_type] :
      ( v21625(VarCurr)
    <=> ( v21687(VarCurr)
        | v21683(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1788,axiom,
    ! [VarCurr: state_type] :
      ( v21687(VarCurr)
    <=> ( v21627(VarCurr)
        & v21631(VarCurr) ) ) ).

tff(addAssignment_11020,axiom,
    ! [VarCurr: state_type] :
      ( v21683(VarCurr)
    <=> v21685(VarCurr) ) ).

tff(addAssignment_11019,axiom,
    ! [VarCurr: state_type] :
      ( v21685(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_245,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21667(VarNext)
       => ( v21631(VarNext)
        <=> v21631(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_245,axiom,
    ! [VarNext: state_type] :
      ( v21667(VarNext)
     => ( v21631(VarNext)
      <=> v21677(VarNext) ) ) ).

tff(addAssignment_11018,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21677(VarNext)
      <=> v21675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1787,axiom,
    ! [VarCurr: state_type] :
      ( v21675(VarCurr)
    <=> ( v21678(VarCurr)
        & v21679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1786,axiom,
    ! [VarCurr: state_type] :
      ( v21679(VarCurr)
    <=> ( v21637(VarCurr)
        | v21662(VarCurr) ) ) ).

tff(writeUnaryOperator_1202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21678(VarCurr)
    <=> v21633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21667(VarNext)
      <=> v21668(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21668(VarNext)
      <=> ( v21670(VarNext)
          & v21672(VarNext) ) ) ) ).

tff(writeUnaryOperator_1201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21672(VarCurr)
    <=> v21627(VarCurr) ) ).

tff(addAssignment_11017,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21670(VarNext)
      <=> v21627(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_87,axiom,
    ( v21631(constB0)
  <=> $true ) ).

tff(addAssignment_11016,axiom,
    ! [VarCurr: state_type] :
      ( v21662(VarCurr)
    <=> v21664(VarCurr) ) ).

tff(addAssignment_11015,axiom,
    ! [VarCurr: state_type] :
      ( v21664(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_11014,axiom,
    ! [VarCurr: state_type] :
      ( v21637(VarCurr)
    <=> v21639(VarCurr) ) ).

tff(addAssignment_11013,axiom,
    ! [VarCurr: state_type] :
      ( v21639(VarCurr)
    <=> v21641(VarCurr) ) ).

tff(addAssignment_11012,axiom,
    ! [VarCurr: state_type] :
      ( v21641(VarCurr)
    <=> v21643(VarCurr) ) ).

tff(addAssignment_11011,axiom,
    ! [VarCurr: state_type] :
      ( v21643(VarCurr)
    <=> v21645(VarCurr) ) ).

tff(writeUnaryOperator_1200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21645(VarCurr)
    <=> v21659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1783,axiom,
    ! [VarCurr: state_type] :
      ( v21659(VarCurr)
    <=> ( v21660(VarCurr)
        | v21655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1782,axiom,
    ! [VarCurr: state_type] :
      ( v21660(VarCurr)
    <=> ( v21647(VarCurr)
        | v21651(VarCurr) ) ) ).

tff(addAssignment_11010,axiom,
    ! [VarCurr: state_type] :
      ( v21655(VarCurr)
    <=> v21657(VarCurr) ) ).

tff(addAssignment_11009,axiom,
    ! [VarCurr: state_type] :
      ( v21657(VarCurr)
    <=> v21187(VarCurr,2) ) ).

tff(addAssignment_11008,axiom,
    ! [VarCurr: state_type] :
      ( v21187(VarCurr,2)
    <=> v21189(VarCurr,2) ) ).

tff(addAssignment_11007,axiom,
    ! [VarCurr: state_type] :
      ( v21189(VarCurr,2)
    <=> v21191(VarCurr,2) ) ).

tff(addAssignment_11006,axiom,
    ! [VarCurr: state_type] :
      ( v21191(VarCurr,2)
    <=> v21196(VarCurr,2) ) ).

tff(addAssignment_11005,axiom,
    ! [VarCurr: state_type] :
      ( v21193(VarCurr,2)
    <=> v21195(VarCurr,2) ) ).

tff(addAssignment_11004,axiom,
    ! [VarCurr: state_type] :
      ( v21195(VarCurr,2)
    <=> v20761(VarCurr,2) ) ).

tff(addAssignment_11003,axiom,
    ! [VarCurr: state_type] :
      ( v21651(VarCurr)
    <=> v21653(VarCurr) ) ).

tff(addAssignment_11002,axiom,
    ! [VarCurr: state_type] :
      ( v21653(VarCurr)
    <=> v20761(VarCurr,1) ) ).

tff(addAssignment_11001,axiom,
    ! [VarCurr: state_type] :
      ( v21647(VarCurr)
    <=> v21649(VarCurr) ) ).

tff(addAssignment_11000,axiom,
    ! [VarCurr: state_type] :
      ( v21649(VarCurr)
    <=> v20761(VarCurr,0) ) ).

tff(addAssignment_10999,axiom,
    ! [VarCurr: state_type] :
      ( v21633(VarCurr)
    <=> v21635(VarCurr) ) ).

tff(addAssignment_10998,axiom,
    ! [VarCurr: state_type] :
      ( v21635(VarCurr)
    <=> $false ) ).

tff(addAssignment_10997,axiom,
    ! [VarCurr: state_type] :
      ( v21627(VarCurr)
    <=> v21629(VarCurr) ) ).

tff(addAssignment_10996,axiom,
    ! [VarCurr: state_type] :
      ( v21629(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21617(VarCurr,B)
      <=> v21619(VarCurr,B) ) ) ).

tff(addAssignment_10994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21619(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_10993,axiom,
    ! [VarCurr: state_type] :
      ( v21607(VarCurr)
    <=> v21609(VarCurr) ) ).

tff(addAssignment_10992,axiom,
    ! [VarCurr: state_type] :
      ( v21609(VarCurr)
    <=> v21611(VarCurr) ) ).

tff(addAssignment_10991,axiom,
    ! [VarCurr: state_type] :
      ( v21611(VarCurr)
    <=> v21613(VarCurr) ) ).

tff(addAssignment_10990,axiom,
    ! [VarCurr: state_type] :
      ( v21613(VarCurr)
    <=> v21615(VarCurr) ) ).

tff(addAssignment_10989,axiom,
    ! [VarCurr: state_type] :
      ( v21615(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10988,axiom,
    ! [VarCurr: state_type] :
      ( v21597(VarCurr)
    <=> v21599(VarCurr) ) ).

tff(addAssignment_10987,axiom,
    ! [VarCurr: state_type] :
      ( v21599(VarCurr)
    <=> v21601(VarCurr) ) ).

tff(addAssignment_10986,axiom,
    ! [VarCurr: state_type] :
      ( v21601(VarCurr)
    <=> v21603(VarCurr) ) ).

tff(addAssignment_10985,axiom,
    ! [VarCurr: state_type] :
      ( v21603(VarCurr)
    <=> v21605(VarCurr) ) ).

tff(addAssignment_10984,axiom,
    ! [VarCurr: state_type] :
      ( v21605(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_10983,axiom,
    ! [VarCurr: state_type] :
      ( v21556(VarCurr)
    <=> v21558(VarCurr) ) ).

tff(addAssignment_10982,axiom,
    ! [VarCurr: state_type] :
      ( v21558(VarCurr)
    <=> v21560(VarCurr) ) ).

tff(addAssignment_10981,axiom,
    ! [VarCurr: state_type] :
      ( v21560(VarCurr)
    <=> v21562(VarCurr) ) ).

tff(addAssignment_10980,axiom,
    ! [VarCurr: state_type] :
      ( v21562(VarCurr)
    <=> v21564(VarCurr) ) ).

tff(addAssignment_10979,axiom,
    ! [VarCurr: state_type] :
      ( v21564(VarCurr)
    <=> v21566(VarCurr) ) ).

tff(addAssignment_10978,axiom,
    ! [VarCurr: state_type] :
      ( v21566(VarCurr)
    <=> v21568(VarCurr) ) ).

tff(addAssignment_10977,axiom,
    ! [VarCurr: state_type] :
      ( v21568(VarCurr)
    <=> v21570(VarCurr) ) ).

tff(writeUnaryOperator_1199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21570(VarCurr)
    <=> v21584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1781,axiom,
    ! [VarCurr: state_type] :
      ( v21584(VarCurr)
    <=> ( v21585(VarCurr)
        | v21580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1780,axiom,
    ! [VarCurr: state_type] :
      ( v21585(VarCurr)
    <=> ( v21572(VarCurr)
        | v21576(VarCurr) ) ) ).

tff(addAssignment_10976,axiom,
    ! [VarCurr: state_type] :
      ( v21580(VarCurr)
    <=> v21582(VarCurr) ) ).

tff(addAssignment_10975,axiom,
    ! [VarCurr: state_type] :
      ( v21582(VarCurr)
    <=> v20851(VarCurr,2) ) ).

tff(addAssignment_10974,axiom,
    ! [VarCurr: state_type] :
      ( v21576(VarCurr)
    <=> v21578(VarCurr) ) ).

tff(addAssignment_10973,axiom,
    ! [VarCurr: state_type] :
      ( v21578(VarCurr)
    <=> v20934(VarCurr,1) ) ).

tff(addAssignment_10972,axiom,
    ! [VarCurr: state_type] :
      ( v21572(VarCurr)
    <=> v21574(VarCurr) ) ).

tff(addAssignment_10971,axiom,
    ! [VarCurr: state_type] :
      ( v21574(VarCurr)
    <=> v20934(VarCurr,0) ) ).

tff(addAssignment_10970,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21436(VarCurr,B)
      <=> v21438(VarCurr,B) ) ) ).

tff(addAssignment_10969,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21438(VarCurr,B)
      <=> v21440(VarCurr,B) ) ) ).

tff(addAssignment_10968,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21440(VarCurr,B)
      <=> v21442(VarCurr,B) ) ) ).

tff(addAssignment_10967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21442(VarCurr,B)
      <=> v21444(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21539(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21444(VarNext,B)
            <=> v21444(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_244,axiom,
    ! [VarNext: state_type] :
      ( v21539(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21444(VarNext,B)
          <=> v21549(VarNext,B) ) ) ) ).

tff(addAssignment_10966,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21549(VarNext,B)
          <=> v21547(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21550(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21547(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_157,axiom,
    ! [VarCurr: state_type] :
      ( v21550(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21547(VarCurr,B)
          <=> v21466(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1779,axiom,
    ! [VarCurr: state_type] :
      ( v21550(VarCurr)
    <=> ( v21551(VarCurr)
        & v21552(VarCurr) ) ) ).

tff(writeUnaryOperator_1198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21552(VarCurr)
    <=> v21456(VarCurr) ) ).

tff(writeUnaryOperator_1197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21551(VarCurr)
    <=> v21446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1778,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21539(VarNext)
      <=> v21540(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1777,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21540(VarNext)
      <=> ( v21541(VarNext)
          & v21470(VarNext) ) ) ) ).

tff(writeUnaryOperator_1196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21541(VarNext)
      <=> v21543(VarNext) ) ) ).

tff(addAssignment_10965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21543(VarNext)
      <=> v21470(VarCurr) ) ) ).

tff(addAssignment_10964,axiom,
    ! [VarCurr: state_type] :
      ( v21470(VarCurr)
    <=> v21472(VarCurr) ) ).

tff(addAssignment_10963,axiom,
    ! [VarCurr: state_type] :
      ( v21472(VarCurr)
    <=> v21474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1776,axiom,
    ! [VarCurr: state_type] :
      ( v21474(VarCurr)
    <=> ( v21536(VarCurr)
        | v21532(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1775,axiom,
    ! [VarCurr: state_type] :
      ( v21536(VarCurr)
    <=> ( v21476(VarCurr)
        & v21480(VarCurr) ) ) ).

tff(addAssignment_10962,axiom,
    ! [VarCurr: state_type] :
      ( v21532(VarCurr)
    <=> v21534(VarCurr) ) ).

tff(addAssignment_10961,axiom,
    ! [VarCurr: state_type] :
      ( v21534(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21516(VarNext)
       => ( v21480(VarNext)
        <=> v21480(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_243,axiom,
    ! [VarNext: state_type] :
      ( v21516(VarNext)
     => ( v21480(VarNext)
      <=> v21526(VarNext) ) ) ).

tff(addAssignment_10960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21526(VarNext)
      <=> v21524(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1774,axiom,
    ! [VarCurr: state_type] :
      ( v21524(VarCurr)
    <=> ( v21527(VarCurr)
        & v21528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1773,axiom,
    ! [VarCurr: state_type] :
      ( v21528(VarCurr)
    <=> ( v21486(VarCurr)
        | v21511(VarCurr) ) ) ).

tff(writeUnaryOperator_1195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21527(VarCurr)
    <=> v21482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1772,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21516(VarNext)
      <=> v21517(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21517(VarNext)
      <=> ( v21519(VarNext)
          & v21521(VarNext) ) ) ) ).

tff(writeUnaryOperator_1194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21521(VarCurr)
    <=> v21476(VarCurr) ) ).

tff(addAssignment_10959,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21519(VarNext)
      <=> v21476(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_86,axiom,
    ( v21480(constB0)
  <=> $true ) ).

tff(addAssignment_10958,axiom,
    ! [VarCurr: state_type] :
      ( v21511(VarCurr)
    <=> v21513(VarCurr) ) ).

tff(addAssignment_10957,axiom,
    ! [VarCurr: state_type] :
      ( v21513(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_10956,axiom,
    ! [VarCurr: state_type] :
      ( v21486(VarCurr)
    <=> v21488(VarCurr) ) ).

tff(addAssignment_10955,axiom,
    ! [VarCurr: state_type] :
      ( v21488(VarCurr)
    <=> v21490(VarCurr) ) ).

tff(addAssignment_10954,axiom,
    ! [VarCurr: state_type] :
      ( v21490(VarCurr)
    <=> v21492(VarCurr) ) ).

tff(addAssignment_10953,axiom,
    ! [VarCurr: state_type] :
      ( v21492(VarCurr)
    <=> v21494(VarCurr) ) ).

tff(writeUnaryOperator_1193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21494(VarCurr)
    <=> v21508(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1770,axiom,
    ! [VarCurr: state_type] :
      ( v21508(VarCurr)
    <=> ( v21509(VarCurr)
        | v21504(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1769,axiom,
    ! [VarCurr: state_type] :
      ( v21509(VarCurr)
    <=> ( v21496(VarCurr)
        | v21500(VarCurr) ) ) ).

tff(addAssignment_10952,axiom,
    ! [VarCurr: state_type] :
      ( v21504(VarCurr)
    <=> v21506(VarCurr) ) ).

tff(addAssignment_10951,axiom,
    ! [VarCurr: state_type] :
      ( v21506(VarCurr)
    <=> v20761(VarCurr,2) ) ).

tff(addAssignment_10950,axiom,
    ! [VarCurr: state_type] :
      ( v21500(VarCurr)
    <=> v21502(VarCurr) ) ).

tff(addAssignment_10949,axiom,
    ! [VarCurr: state_type] :
      ( v21502(VarCurr)
    <=> v21187(VarCurr,1) ) ).

tff(addAssignment_10948,axiom,
    ! [VarCurr: state_type] :
      ( v21496(VarCurr)
    <=> v21498(VarCurr) ) ).

tff(addAssignment_10947,axiom,
    ! [VarCurr: state_type] :
      ( v21498(VarCurr)
    <=> v21187(VarCurr,0) ) ).

tff(addAssignment_10946,axiom,
    ! [VarCurr: state_type] :
      ( v21482(VarCurr)
    <=> v21484(VarCurr) ) ).

tff(addAssignment_10945,axiom,
    ! [VarCurr: state_type] :
      ( v21484(VarCurr)
    <=> $false ) ).

tff(addAssignment_10944,axiom,
    ! [VarCurr: state_type] :
      ( v21476(VarCurr)
    <=> v21478(VarCurr) ) ).

tff(addAssignment_10943,axiom,
    ! [VarCurr: state_type] :
      ( v21478(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21466(VarCurr,B)
      <=> v21468(VarCurr,B) ) ) ).

tff(addAssignment_10941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21468(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_10940,axiom,
    ! [VarCurr: state_type] :
      ( v21456(VarCurr)
    <=> v21458(VarCurr) ) ).

tff(addAssignment_10939,axiom,
    ! [VarCurr: state_type] :
      ( v21458(VarCurr)
    <=> v21460(VarCurr) ) ).

tff(addAssignment_10938,axiom,
    ! [VarCurr: state_type] :
      ( v21460(VarCurr)
    <=> v21462(VarCurr) ) ).

tff(addAssignment_10937,axiom,
    ! [VarCurr: state_type] :
      ( v21462(VarCurr)
    <=> v21464(VarCurr) ) ).

tff(addAssignment_10936,axiom,
    ! [VarCurr: state_type] :
      ( v21464(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10935,axiom,
    ! [VarCurr: state_type] :
      ( v21446(VarCurr)
    <=> v21448(VarCurr) ) ).

tff(addAssignment_10934,axiom,
    ! [VarCurr: state_type] :
      ( v21448(VarCurr)
    <=> v21450(VarCurr) ) ).

tff(addAssignment_10933,axiom,
    ! [VarCurr: state_type] :
      ( v21450(VarCurr)
    <=> v21452(VarCurr) ) ).

tff(addAssignment_10932,axiom,
    ! [VarCurr: state_type] :
      ( v21452(VarCurr)
    <=> v21454(VarCurr) ) ).

tff(addAssignment_10931,axiom,
    ! [VarCurr: state_type] :
      ( v21454(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_10930,axiom,
    ! [VarCurr: state_type] :
      ( v21405(VarCurr)
    <=> v21407(VarCurr) ) ).

tff(addAssignment_10929,axiom,
    ! [VarCurr: state_type] :
      ( v21407(VarCurr)
    <=> v21409(VarCurr) ) ).

tff(addAssignment_10928,axiom,
    ! [VarCurr: state_type] :
      ( v21409(VarCurr)
    <=> v21411(VarCurr) ) ).

tff(addAssignment_10927,axiom,
    ! [VarCurr: state_type] :
      ( v21411(VarCurr)
    <=> v21413(VarCurr) ) ).

tff(addAssignment_10926,axiom,
    ! [VarCurr: state_type] :
      ( v21413(VarCurr)
    <=> v21415(VarCurr) ) ).

tff(addAssignment_10925,axiom,
    ! [VarCurr: state_type] :
      ( v21415(VarCurr)
    <=> v21417(VarCurr) ) ).

tff(addAssignment_10924,axiom,
    ! [VarCurr: state_type] :
      ( v21417(VarCurr)
    <=> v21419(VarCurr) ) ).

tff(writeUnaryOperator_1192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21419(VarCurr)
    <=> v21433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1768,axiom,
    ! [VarCurr: state_type] :
      ( v21433(VarCurr)
    <=> ( v21434(VarCurr)
        | v21429(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1767,axiom,
    ! [VarCurr: state_type] :
      ( v21434(VarCurr)
    <=> ( v21421(VarCurr)
        | v21425(VarCurr) ) ) ).

tff(addAssignment_10923,axiom,
    ! [VarCurr: state_type] :
      ( v21429(VarCurr)
    <=> v21431(VarCurr) ) ).

tff(addAssignment_10922,axiom,
    ! [VarCurr: state_type] :
      ( v21431(VarCurr)
    <=> v20851(VarCurr,2) ) ).

tff(addAssignment_10921,axiom,
    ! [VarCurr: state_type] :
      ( v21425(VarCurr)
    <=> v21427(VarCurr) ) ).

tff(addAssignment_10920,axiom,
    ! [VarCurr: state_type] :
      ( v21427(VarCurr)
    <=> v20934(VarCurr,1) ) ).

tff(addAssignment_10919,axiom,
    ! [VarCurr: state_type] :
      ( v20934(VarCurr,1)
    <=> v20936(VarCurr,1) ) ).

tff(addAssignment_10918,axiom,
    ! [VarCurr: state_type] :
      ( v20936(VarCurr,1)
    <=> v20938(VarCurr,1) ) ).

tff(addAssignment_10917,axiom,
    ! [VarCurr: state_type] :
      ( v20938(VarCurr,1)
    <=> v20943(VarCurr,1) ) ).

tff(addAssignment_10916,axiom,
    ! [VarCurr: state_type] :
      ( v20940(VarCurr,1)
    <=> v20942(VarCurr,1) ) ).

tff(addAssignment_10915,axiom,
    ! [VarCurr: state_type] :
      ( v20942(VarCurr,1)
    <=> v20851(VarCurr,1) ) ).

tff(addAssignment_10914,axiom,
    ! [VarCurr: state_type] :
      ( v21421(VarCurr)
    <=> v21423(VarCurr) ) ).

tff(addAssignment_10913,axiom,
    ! [VarCurr: state_type] :
      ( v21423(VarCurr)
    <=> v20851(VarCurr,0) ) ).

tff(addAssignment_10912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21285(VarCurr,B)
      <=> v21287(VarCurr,B) ) ) ).

tff(addAssignment_10911,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21287(VarCurr,B)
      <=> v21289(VarCurr,B) ) ) ).

tff(addAssignment_10910,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21289(VarCurr,B)
      <=> v21291(VarCurr,B) ) ) ).

tff(addAssignment_10909,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21291(VarCurr,B)
      <=> v21293(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_242,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21388(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21293(VarNext,B)
            <=> v21293(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_242,axiom,
    ! [VarNext: state_type] :
      ( v21388(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21293(VarNext,B)
          <=> v21398(VarNext,B) ) ) ) ).

tff(addAssignment_10908,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21398(VarNext,B)
          <=> v21396(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21399(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21396(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_156,axiom,
    ! [VarCurr: state_type] :
      ( v21399(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21396(VarCurr,B)
          <=> v21315(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1766,axiom,
    ! [VarCurr: state_type] :
      ( v21399(VarCurr)
    <=> ( v21400(VarCurr)
        & v21401(VarCurr) ) ) ).

tff(writeUnaryOperator_1191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21401(VarCurr)
    <=> v21305(VarCurr) ) ).

tff(writeUnaryOperator_1190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21400(VarCurr)
    <=> v21295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21388(VarNext)
      <=> v21389(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21389(VarNext)
      <=> ( v21390(VarNext)
          & v21319(VarNext) ) ) ) ).

tff(writeUnaryOperator_1189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21390(VarNext)
      <=> v21392(VarNext) ) ) ).

tff(addAssignment_10907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21392(VarNext)
      <=> v21319(VarCurr) ) ) ).

tff(addAssignment_10906,axiom,
    ! [VarCurr: state_type] :
      ( v21319(VarCurr)
    <=> v21321(VarCurr) ) ).

tff(addAssignment_10905,axiom,
    ! [VarCurr: state_type] :
      ( v21321(VarCurr)
    <=> v21323(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1763,axiom,
    ! [VarCurr: state_type] :
      ( v21323(VarCurr)
    <=> ( v21385(VarCurr)
        | v21381(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1762,axiom,
    ! [VarCurr: state_type] :
      ( v21385(VarCurr)
    <=> ( v21325(VarCurr)
        & v21329(VarCurr) ) ) ).

tff(addAssignment_10904,axiom,
    ! [VarCurr: state_type] :
      ( v21381(VarCurr)
    <=> v21383(VarCurr) ) ).

tff(addAssignment_10903,axiom,
    ! [VarCurr: state_type] :
      ( v21383(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21365(VarNext)
       => ( v21329(VarNext)
        <=> v21329(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_241,axiom,
    ! [VarNext: state_type] :
      ( v21365(VarNext)
     => ( v21329(VarNext)
      <=> v21375(VarNext) ) ) ).

tff(addAssignment_10902,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21375(VarNext)
      <=> v21373(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1761,axiom,
    ! [VarCurr: state_type] :
      ( v21373(VarCurr)
    <=> ( v21376(VarCurr)
        & v21377(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1760,axiom,
    ! [VarCurr: state_type] :
      ( v21377(VarCurr)
    <=> ( v21335(VarCurr)
        | v21360(VarCurr) ) ) ).

tff(writeUnaryOperator_1188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21376(VarCurr)
    <=> v21331(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21365(VarNext)
      <=> v21366(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21366(VarNext)
      <=> ( v21368(VarNext)
          & v21370(VarNext) ) ) ) ).

tff(writeUnaryOperator_1187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21370(VarCurr)
    <=> v21325(VarCurr) ) ).

tff(addAssignment_10901,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21368(VarNext)
      <=> v21325(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_85,axiom,
    ( v21329(constB0)
  <=> $true ) ).

tff(addAssignment_10900,axiom,
    ! [VarCurr: state_type] :
      ( v21360(VarCurr)
    <=> v21362(VarCurr) ) ).

tff(addAssignment_10899,axiom,
    ! [VarCurr: state_type] :
      ( v21362(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_10898,axiom,
    ! [VarCurr: state_type] :
      ( v21335(VarCurr)
    <=> v21337(VarCurr) ) ).

tff(addAssignment_10897,axiom,
    ! [VarCurr: state_type] :
      ( v21337(VarCurr)
    <=> v21339(VarCurr) ) ).

tff(addAssignment_10896,axiom,
    ! [VarCurr: state_type] :
      ( v21339(VarCurr)
    <=> v21341(VarCurr) ) ).

tff(addAssignment_10895,axiom,
    ! [VarCurr: state_type] :
      ( v21341(VarCurr)
    <=> v21343(VarCurr) ) ).

tff(writeUnaryOperator_1186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21343(VarCurr)
    <=> v21357(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1757,axiom,
    ! [VarCurr: state_type] :
      ( v21357(VarCurr)
    <=> ( v21358(VarCurr)
        | v21353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1756,axiom,
    ! [VarCurr: state_type] :
      ( v21358(VarCurr)
    <=> ( v21345(VarCurr)
        | v21349(VarCurr) ) ) ).

tff(addAssignment_10894,axiom,
    ! [VarCurr: state_type] :
      ( v21353(VarCurr)
    <=> v21355(VarCurr) ) ).

tff(addAssignment_10893,axiom,
    ! [VarCurr: state_type] :
      ( v21355(VarCurr)
    <=> v20761(VarCurr,2) ) ).

tff(addAssignment_10892,axiom,
    ! [VarCurr: state_type] :
      ( v21349(VarCurr)
    <=> v21351(VarCurr) ) ).

tff(addAssignment_10891,axiom,
    ! [VarCurr: state_type] :
      ( v21351(VarCurr)
    <=> v21187(VarCurr,1) ) ).

tff(addAssignment_10890,axiom,
    ! [VarCurr: state_type] :
      ( v21187(VarCurr,1)
    <=> v21189(VarCurr,1) ) ).

tff(addAssignment_10889,axiom,
    ! [VarCurr: state_type] :
      ( v21189(VarCurr,1)
    <=> v21191(VarCurr,1) ) ).

tff(addAssignment_10888,axiom,
    ! [VarCurr: state_type] :
      ( v21191(VarCurr,1)
    <=> v21196(VarCurr,1) ) ).

tff(addAssignment_10887,axiom,
    ! [VarCurr: state_type] :
      ( v21193(VarCurr,1)
    <=> v21195(VarCurr,1) ) ).

tff(addAssignment_10886,axiom,
    ! [VarCurr: state_type] :
      ( v21195(VarCurr,1)
    <=> v20761(VarCurr,1) ) ).

tff(addAssignment_10885,axiom,
    ! [VarCurr: state_type] :
      ( v21345(VarCurr)
    <=> v21347(VarCurr) ) ).

tff(addAssignment_10884,axiom,
    ! [VarCurr: state_type] :
      ( v21347(VarCurr)
    <=> v20761(VarCurr,0) ) ).

tff(addAssignment_10883,axiom,
    ! [VarCurr: state_type] :
      ( v21331(VarCurr)
    <=> v21333(VarCurr) ) ).

tff(addAssignment_10882,axiom,
    ! [VarCurr: state_type] :
      ( v21333(VarCurr)
    <=> $false ) ).

tff(addAssignment_10881,axiom,
    ! [VarCurr: state_type] :
      ( v21325(VarCurr)
    <=> v21327(VarCurr) ) ).

tff(addAssignment_10880,axiom,
    ! [VarCurr: state_type] :
      ( v21327(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21315(VarCurr,B)
      <=> v21317(VarCurr,B) ) ) ).

tff(addAssignment_10878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21317(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_10877,axiom,
    ! [VarCurr: state_type] :
      ( v21305(VarCurr)
    <=> v21307(VarCurr) ) ).

tff(addAssignment_10876,axiom,
    ! [VarCurr: state_type] :
      ( v21307(VarCurr)
    <=> v21309(VarCurr) ) ).

tff(addAssignment_10875,axiom,
    ! [VarCurr: state_type] :
      ( v21309(VarCurr)
    <=> v21311(VarCurr) ) ).

tff(addAssignment_10874,axiom,
    ! [VarCurr: state_type] :
      ( v21311(VarCurr)
    <=> v21313(VarCurr) ) ).

tff(addAssignment_10873,axiom,
    ! [VarCurr: state_type] :
      ( v21313(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10872,axiom,
    ! [VarCurr: state_type] :
      ( v21295(VarCurr)
    <=> v21297(VarCurr) ) ).

tff(addAssignment_10871,axiom,
    ! [VarCurr: state_type] :
      ( v21297(VarCurr)
    <=> v21299(VarCurr) ) ).

tff(addAssignment_10870,axiom,
    ! [VarCurr: state_type] :
      ( v21299(VarCurr)
    <=> v21301(VarCurr) ) ).

tff(addAssignment_10869,axiom,
    ! [VarCurr: state_type] :
      ( v21301(VarCurr)
    <=> v21303(VarCurr) ) ).

tff(addAssignment_10868,axiom,
    ! [VarCurr: state_type] :
      ( v21303(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_10867,axiom,
    ! [VarCurr: state_type] :
      ( v21254(VarCurr)
    <=> v21256(VarCurr) ) ).

tff(addAssignment_10866,axiom,
    ! [VarCurr: state_type] :
      ( v21256(VarCurr)
    <=> v21258(VarCurr) ) ).

tff(addAssignment_10865,axiom,
    ! [VarCurr: state_type] :
      ( v21258(VarCurr)
    <=> v21260(VarCurr) ) ).

tff(addAssignment_10864,axiom,
    ! [VarCurr: state_type] :
      ( v21260(VarCurr)
    <=> v21262(VarCurr) ) ).

tff(addAssignment_10863,axiom,
    ! [VarCurr: state_type] :
      ( v21262(VarCurr)
    <=> v21264(VarCurr) ) ).

tff(addAssignment_10862,axiom,
    ! [VarCurr: state_type] :
      ( v21264(VarCurr)
    <=> v21266(VarCurr) ) ).

tff(addAssignment_10861,axiom,
    ! [VarCurr: state_type] :
      ( v21266(VarCurr)
    <=> v21268(VarCurr) ) ).

tff(writeUnaryOperator_1185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21268(VarCurr)
    <=> v21282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1755,axiom,
    ! [VarCurr: state_type] :
      ( v21282(VarCurr)
    <=> ( v21283(VarCurr)
        | v21278(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1754,axiom,
    ! [VarCurr: state_type] :
      ( v21283(VarCurr)
    <=> ( v21270(VarCurr)
        | v21274(VarCurr) ) ) ).

tff(addAssignment_10860,axiom,
    ! [VarCurr: state_type] :
      ( v21278(VarCurr)
    <=> v21280(VarCurr) ) ).

tff(addAssignment_10859,axiom,
    ! [VarCurr: state_type] :
      ( v21280(VarCurr)
    <=> v20851(VarCurr,2) ) ).

tff(addAssignment_10858,axiom,
    ! [VarCurr: state_type] :
      ( v21274(VarCurr)
    <=> v21276(VarCurr) ) ).

tff(addAssignment_10857,axiom,
    ! [VarCurr: state_type] :
      ( v21276(VarCurr)
    <=> v20851(VarCurr,1) ) ).

tff(addAssignment_10856,axiom,
    ! [VarCurr: state_type] :
      ( v21270(VarCurr)
    <=> v21272(VarCurr) ) ).

tff(addAssignment_10855,axiom,
    ! [VarCurr: state_type] :
      ( v21272(VarCurr)
    <=> v20934(VarCurr,0) ) ).

tff(addAssignment_10854,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21123(VarCurr,B)
      <=> v21125(VarCurr,B) ) ) ).

tff(addAssignment_10853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21125(VarCurr,B)
      <=> v21127(VarCurr,B) ) ) ).

tff(addAssignment_10852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21127(VarCurr,B)
      <=> v21129(VarCurr,B) ) ) ).

tff(addAssignment_10851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21129(VarCurr,B)
      <=> v21131(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21237(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v21131(VarNext,B)
            <=> v21131(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_240,axiom,
    ! [VarNext: state_type] :
      ( v21237(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21131(VarNext,B)
          <=> v21247(VarNext,B) ) ) ) ).

tff(addAssignment_10850,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21247(VarNext,B)
          <=> v21245(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21248(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21245(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_155,axiom,
    ! [VarCurr: state_type] :
      ( v21248(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v21245(VarCurr,B)
          <=> v21153(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1753,axiom,
    ! [VarCurr: state_type] :
      ( v21248(VarCurr)
    <=> ( v21249(VarCurr)
        & v21250(VarCurr) ) ) ).

tff(writeUnaryOperator_1184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21250(VarCurr)
    <=> v21143(VarCurr) ) ).

tff(writeUnaryOperator_1183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21249(VarCurr)
    <=> v21133(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21237(VarNext)
      <=> v21238(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21238(VarNext)
      <=> ( v21239(VarNext)
          & v21157(VarNext) ) ) ) ).

tff(writeUnaryOperator_1182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21239(VarNext)
      <=> v21241(VarNext) ) ) ).

tff(addAssignment_10849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21241(VarNext)
      <=> v21157(VarCurr) ) ) ).

tff(addAssignment_10848,axiom,
    ! [VarCurr: state_type] :
      ( v21157(VarCurr)
    <=> v21159(VarCurr) ) ).

tff(addAssignment_10847,axiom,
    ! [VarCurr: state_type] :
      ( v21159(VarCurr)
    <=> v21161(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1750,axiom,
    ! [VarCurr: state_type] :
      ( v21161(VarCurr)
    <=> ( v21234(VarCurr)
        | v21230(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1749,axiom,
    ! [VarCurr: state_type] :
      ( v21234(VarCurr)
    <=> ( v21163(VarCurr)
        & v21167(VarCurr) ) ) ).

tff(addAssignment_10846,axiom,
    ! [VarCurr: state_type] :
      ( v21230(VarCurr)
    <=> v21232(VarCurr) ) ).

tff(addAssignment_10845,axiom,
    ! [VarCurr: state_type] :
      ( v21232(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_239,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21214(VarNext)
       => ( v21167(VarNext)
        <=> v21167(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_239,axiom,
    ! [VarNext: state_type] :
      ( v21214(VarNext)
     => ( v21167(VarNext)
      <=> v21224(VarNext) ) ) ).

tff(addAssignment_10844,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21224(VarNext)
      <=> v21222(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1748,axiom,
    ! [VarCurr: state_type] :
      ( v21222(VarCurr)
    <=> ( v21225(VarCurr)
        & v21226(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1747,axiom,
    ! [VarCurr: state_type] :
      ( v21226(VarCurr)
    <=> ( v21173(VarCurr)
        | v21209(VarCurr) ) ) ).

tff(writeUnaryOperator_1181,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21225(VarCurr)
    <=> v21169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21214(VarNext)
      <=> v21215(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21215(VarNext)
      <=> ( v21217(VarNext)
          & v21219(VarNext) ) ) ) ).

tff(writeUnaryOperator_1180,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21219(VarCurr)
    <=> v21163(VarCurr) ) ).

tff(addAssignment_10843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21217(VarNext)
      <=> v21163(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_84,axiom,
    ( v21167(constB0)
  <=> $true ) ).

tff(addAssignment_10842,axiom,
    ! [VarCurr: state_type] :
      ( v21209(VarCurr)
    <=> v21211(VarCurr) ) ).

tff(addAssignment_10841,axiom,
    ! [VarCurr: state_type] :
      ( v21211(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_10840,axiom,
    ! [VarCurr: state_type] :
      ( v21173(VarCurr)
    <=> v21175(VarCurr) ) ).

tff(addAssignment_10839,axiom,
    ! [VarCurr: state_type] :
      ( v21175(VarCurr)
    <=> v21177(VarCurr) ) ).

tff(addAssignment_10838,axiom,
    ! [VarCurr: state_type] :
      ( v21177(VarCurr)
    <=> v21179(VarCurr) ) ).

tff(addAssignment_10837,axiom,
    ! [VarCurr: state_type] :
      ( v21179(VarCurr)
    <=> v21181(VarCurr) ) ).

tff(writeUnaryOperator_1179,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21181(VarCurr)
    <=> v21206(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1744,axiom,
    ! [VarCurr: state_type] :
      ( v21206(VarCurr)
    <=> ( v21207(VarCurr)
        | v21202(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1743,axiom,
    ! [VarCurr: state_type] :
      ( v21207(VarCurr)
    <=> ( v21183(VarCurr)
        | v21198(VarCurr) ) ) ).

tff(addAssignment_10836,axiom,
    ! [VarCurr: state_type] :
      ( v21202(VarCurr)
    <=> v21204(VarCurr) ) ).

tff(addAssignment_10835,axiom,
    ! [VarCurr: state_type] :
      ( v21204(VarCurr)
    <=> v20761(VarCurr,2) ) ).

tff(addAssignment_10834,axiom,
    ! [VarCurr: state_type] :
      ( v21198(VarCurr)
    <=> v21200(VarCurr) ) ).

tff(addAssignment_10833,axiom,
    ! [VarCurr: state_type] :
      ( v21200(VarCurr)
    <=> v20761(VarCurr,1) ) ).

tff(addAssignment_10832,axiom,
    ! [VarCurr: state_type] :
      ( v21183(VarCurr)
    <=> v21185(VarCurr) ) ).

tff(addAssignment_10831,axiom,
    ! [VarCurr: state_type] :
      ( v21185(VarCurr)
    <=> v21187(VarCurr,0) ) ).

tff(addAssignment_10830,axiom,
    ! [VarCurr: state_type] :
      ( v21187(VarCurr,0)
    <=> v21189(VarCurr,0) ) ).

tff(addAssignment_10829,axiom,
    ! [VarCurr: state_type] :
      ( v21189(VarCurr,0)
    <=> v21191(VarCurr,0) ) ).

tff(addAssignment_10828,axiom,
    ! [VarCurr: state_type] :
      ( v21191(VarCurr,0)
    <=> v21196(VarCurr,0) ) ).

tff(writeUnaryOperator_1178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v21196(VarCurr,B)
      <=> ~ v21193(VarCurr,B) ) ) ).

tff(addAssignment_10827,axiom,
    ! [VarCurr: state_type] :
      ( v21193(VarCurr,0)
    <=> v21195(VarCurr,0) ) ).

tff(addAssignment_10826,axiom,
    ! [VarCurr: state_type] :
      ( v21195(VarCurr,0)
    <=> v20761(VarCurr,0) ) ).

tff(addAssignment_10825,axiom,
    ! [VarCurr: state_type] :
      ( v21169(VarCurr)
    <=> v21171(VarCurr) ) ).

tff(addAssignment_10824,axiom,
    ! [VarCurr: state_type] :
      ( v21171(VarCurr)
    <=> $false ) ).

tff(addAssignment_10823,axiom,
    ! [VarCurr: state_type] :
      ( v21163(VarCurr)
    <=> v21165(VarCurr) ) ).

tff(addAssignment_10822,axiom,
    ! [VarCurr: state_type] :
      ( v21165(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21153(VarCurr,B)
      <=> v21155(VarCurr,B) ) ) ).

tff(addAssignment_10820,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v21155(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_10819,axiom,
    ! [VarCurr: state_type] :
      ( v21143(VarCurr)
    <=> v21145(VarCurr) ) ).

tff(addAssignment_10818,axiom,
    ! [VarCurr: state_type] :
      ( v21145(VarCurr)
    <=> v21147(VarCurr) ) ).

tff(addAssignment_10817,axiom,
    ! [VarCurr: state_type] :
      ( v21147(VarCurr)
    <=> v21149(VarCurr) ) ).

tff(addAssignment_10816,axiom,
    ! [VarCurr: state_type] :
      ( v21149(VarCurr)
    <=> v21151(VarCurr) ) ).

tff(addAssignment_10815,axiom,
    ! [VarCurr: state_type] :
      ( v21151(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10814,axiom,
    ! [VarCurr: state_type] :
      ( v21133(VarCurr)
    <=> v21135(VarCurr) ) ).

tff(addAssignment_10813,axiom,
    ! [VarCurr: state_type] :
      ( v21135(VarCurr)
    <=> v21137(VarCurr) ) ).

tff(addAssignment_10812,axiom,
    ! [VarCurr: state_type] :
      ( v21137(VarCurr)
    <=> v21139(VarCurr) ) ).

tff(addAssignment_10811,axiom,
    ! [VarCurr: state_type] :
      ( v21139(VarCurr)
    <=> v21141(VarCurr) ) ).

tff(addAssignment_10810,axiom,
    ! [VarCurr: state_type] :
      ( v21141(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_10809,axiom,
    ! [VarCurr: state_type] :
      ( v20831(VarCurr)
    <=> v20833(VarCurr) ) ).

tff(addAssignment_10808,axiom,
    ! [VarCurr: state_type] :
      ( v20833(VarCurr)
    <=> v20835(VarCurr) ) ).

tff(addAssignment_10807,axiom,
    ! [VarCurr: state_type] :
      ( v20835(VarCurr)
    <=> v20837(VarCurr) ) ).

tff(addAssignment_10806,axiom,
    ! [VarCurr: state_type] :
      ( v20837(VarCurr)
    <=> v20839(VarCurr) ) ).

tff(addAssignment_10805,axiom,
    ! [VarCurr: state_type] :
      ( v20839(VarCurr)
    <=> v20841(VarCurr) ) ).

tff(addAssignment_10804,axiom,
    ! [VarCurr: state_type] :
      ( v20841(VarCurr)
    <=> v20843(VarCurr) ) ).

tff(addAssignment_10803,axiom,
    ! [VarCurr: state_type] :
      ( v20843(VarCurr)
    <=> v20845(VarCurr) ) ).

tff(writeUnaryOperator_1177,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20845(VarCurr)
    <=> v21120(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1742,axiom,
    ! [VarCurr: state_type] :
      ( v21120(VarCurr)
    <=> ( v21121(VarCurr)
        | v21116(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1741,axiom,
    ! [VarCurr: state_type] :
      ( v21121(VarCurr)
    <=> ( v20847(VarCurr)
        | v21112(VarCurr) ) ) ).

tff(addAssignment_10802,axiom,
    ! [VarCurr: state_type] :
      ( v21116(VarCurr)
    <=> v21118(VarCurr) ) ).

tff(addAssignment_10801,axiom,
    ! [VarCurr: state_type] :
      ( v21118(VarCurr)
    <=> v20851(VarCurr,2) ) ).

tff(addAssignment_10800,axiom,
    ! [VarCurr: state_type] :
      ( v21112(VarCurr)
    <=> v21114(VarCurr) ) ).

tff(addAssignment_10799,axiom,
    ! [VarCurr: state_type] :
      ( v21114(VarCurr)
    <=> v20851(VarCurr,1) ) ).

tff(addAssignment_10798,axiom,
    ! [VarCurr: state_type] :
      ( v20847(VarCurr)
    <=> v20849(VarCurr) ) ).

tff(addAssignment_10797,axiom,
    ! [VarCurr: state_type] :
      ( v20849(VarCurr)
    <=> v20851(VarCurr,0) ) ).

tff(addAssignment_10796,axiom,
    ! [VarCurr: state_type] :
      ( v20851(VarCurr,0)
    <=> v20763(VarCurr,3) ) ).

tff(addAssignment_10795,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,3)
    <=> v20765(VarCurr,3) ) ).

tff(addAssignment_10794,axiom,
    ! [VarNext: state_type] :
      ( v20765(VarNext,3)
    <=> v21104(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_238,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21105(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v21104(VarNext,B)
            <=> v20765(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_238,axiom,
    ! [VarNext: state_type] :
      ( v21105(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21104(VarNext,B)
          <=> v21076(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21105(VarNext)
      <=> v21106(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21106(VarNext)
      <=> ( v21108(VarNext)
          & v21018(VarNext) ) ) ) ).

tff(writeUnaryOperator_1176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21108(VarNext)
      <=> v21070(VarNext) ) ) ).

tff(addAssignment_10793,axiom,
    ! [VarCurr: state_type] :
      ( v20875(VarCurr,3)
    <=> v20877(VarCurr,3) ) ).

tff(addAssignment_10792,axiom,
    ! [VarCurr: state_type] :
      ( v20877(VarCurr,3)
    <=> v21015(VarCurr,3) ) ).

tff(addAssignment_10791,axiom,
    ! [VarCurr: state_type] :
      ( v20879(VarCurr,0)
    <=> v20881(VarCurr,0) ) ).

tff(addAssignment_10790,axiom,
    ! [VarCurr: state_type] :
      ( v20881(VarCurr,0)
    <=> v20883(VarCurr,0) ) ).

tff(addAssignment_10789,axiom,
    ! [VarCurr: state_type] :
      ( v20883(VarCurr,0)
    <=> v21014(VarCurr,0) ) ).

tff(addAssignment_10788,axiom,
    ! [VarCurr: state_type] :
      ( v20951(VarCurr,0)
    <=> v20953(VarCurr,0) ) ).

tff(addAssignment_10787,axiom,
    ! [VarCurr: state_type] :
      ( v20953(VarCurr,0)
    <=> v20955(VarCurr,0) ) ).

tff(addAssignment_10786,axiom,
    ! [VarCurr: state_type] :
      ( v20955(VarCurr,0)
    <=> v20957(VarCurr,0) ) ).

tff(addAssignment_10785,axiom,
    ! [VarCurr: state_type] :
      ( v20957(VarCurr,0)
    <=> v20959(VarCurr,0) ) ).

tff(addAssignment_10784,axiom,
    ! [VarCurr: state_type] :
      ( v20959(VarCurr,0)
    <=> v20969(VarCurr,0) ) ).

tff(addAssignment_10783,axiom,
    ! [VarCurr: state_type] :
      ( v20885(VarCurr,0)
    <=> v20887(VarCurr,0) ) ).

tff(addAssignment_10782,axiom,
    ! [VarCurr: state_type] :
      ( v20887(VarCurr,0)
    <=> v20948(VarCurr,0) ) ).

tff(addAssignment_10781,axiom,
    ! [VarCurr: state_type] :
      ( v20889(VarCurr)
    <=> v20415(VarCurr,2) ) ).

tff(addAssignment_10780,axiom,
    ! [VarCurr: state_type] :
      ( v20415(VarCurr,2)
    <=> v20417(VarCurr,2) ) ).

tff(addAssignment_10779,axiom,
    ! [VarCurr: state_type] :
      ( v20417(VarCurr,2)
    <=> v20427(VarCurr,2) ) ).

tff(addAssignment_10778,axiom,
    ! [VarCurr: state_type] :
      ( v20419(VarCurr,2)
    <=> v20421(VarCurr,2) ) ).

tff(addAssignment_10777,axiom,
    ! [VarCurr: state_type] :
      ( v20421(VarCurr,2)
    <=> v20424(VarCurr,2) ) ).

tff(addAssignment_10776,axiom,
    ! [VarCurr: state_type] :
      ( v20425(VarCurr)
    <=> v20892(VarCurr,1) ) ).

tff(addAssignment_10775,axiom,
    ! [VarCurr: state_type] :
      ( v20892(VarCurr,1)
    <=> v20894(VarCurr,1) ) ).

tff(addAssignment_10774,axiom,
    ! [VarCurr: state_type] :
      ( v20894(VarCurr,1)
    <=> v21102(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_357,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v21102(VarCurr,B)
      <=> ( v20896(VarCurr,B)
          | v20902(VarCurr,B) ) ) ) ).

tff(addAssignment_10773,axiom,
    ! [VarCurr: state_type] :
      ( v20902(VarCurr,1)
    <=> v20904(VarCurr,1) ) ).

tff(addAssignment_10772,axiom,
    ! [VarCurr: state_type] :
      ( v20904(VarCurr,1)
    <=> v21100(VarCurr,1) ) ).

tff(addAssignment_10771,axiom,
    ! [VarCurr: state_type] :
      ( v21100(VarCurr,0)
    <=> v21101(VarCurr) ) ).

tff(addAssignment_10770,axiom,
    ! [VarCurr: state_type] :
      ( v21100(VarCurr,1)
    <=> v20906(VarCurr) ) ).

tff(addAssignment_10769,axiom,
    ! [VarCurr: state_type] :
      ( v20906(VarCurr)
    <=> v20908(VarCurr,1) ) ).

tff(addAssignment_10768,axiom,
    ! [VarCurr: state_type] :
      ( v20908(VarCurr,1)
    <=> v20910(VarCurr,1) ) ).

tff(addAssignment_10767,axiom,
    ! [VarCurr: state_type] :
      ( v20910(VarCurr,1)
    <=> v21099(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v21099(VarCurr,B)
      <=> ( v20912(VarCurr,B)
          & v20920(VarCurr,B) ) ) ) ).

tff(addAssignment_10766,axiom,
    ! [VarCurr: state_type] :
      ( v20920(VarCurr,1)
    <=> v20922(VarCurr,1) ) ).

tff(addAssignment_10765,axiom,
    ! [VarCurr: state_type] :
      ( v20922(VarCurr,1)
    <=> v21097(VarCurr,1) ) ).

tff(addAssignment_10764,axiom,
    ! [VarCurr: state_type] :
      ( v21097(VarCurr,0)
    <=> v21098(VarCurr) ) ).

tff(addAssignment_10763,axiom,
    ! [VarCurr: state_type] :
      ( v21097(VarCurr,1)
    <=> v20924(VarCurr) ) ).

tff(addAssignment_10762,axiom,
    ! [VarCurr: state_type] :
      ( v20924(VarCurr)
    <=> v20926(VarCurr) ) ).

tff(addAssignment_10761,axiom,
    ! [VarCurr: state_type] :
      ( v20926(VarCurr)
    <=> v20928(VarCurr) ) ).

tff(writeUnaryOperator_1175,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20928(VarCurr)
    <=> v21095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1738,axiom,
    ! [VarCurr: state_type] :
      ( v21095(VarCurr)
    <=> ( v21096(VarCurr)
        | v21083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1737,axiom,
    ! [VarCurr: state_type] :
      ( v21096(VarCurr)
    <=> ( v20930(VarCurr)
        | v20945(VarCurr) ) ) ).

tff(addAssignment_10760,axiom,
    ! [VarCurr: state_type] :
      ( v21083(VarCurr)
    <=> v21085(VarCurr) ) ).

tff(addAssignment_10759,axiom,
    ! [VarCurr: state_type] :
      ( v21085(VarCurr)
    <=> v20934(VarCurr,2) ) ).

tff(addAssignment_10758,axiom,
    ! [VarCurr: state_type] :
      ( v20934(VarCurr,2)
    <=> v20936(VarCurr,2) ) ).

tff(addAssignment_10757,axiom,
    ! [VarCurr: state_type] :
      ( v20936(VarCurr,2)
    <=> v20938(VarCurr,2) ) ).

tff(addAssignment_10756,axiom,
    ! [VarCurr: state_type] :
      ( v20938(VarCurr,2)
    <=> v20943(VarCurr,2) ) ).

tff(addAssignment_10755,axiom,
    ! [VarCurr: state_type] :
      ( v20940(VarCurr,2)
    <=> v20942(VarCurr,2) ) ).

tff(addAssignment_10754,axiom,
    ! [VarCurr: state_type] :
      ( v20942(VarCurr,2)
    <=> v20851(VarCurr,2) ) ).

tff(addAssignment_10753,axiom,
    ! [VarCurr: state_type] :
      ( v20851(VarCurr,2)
    <=> v20763(VarCurr,5) ) ).

tff(addAssignment_10752,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,5)
    <=> v20765(VarCurr,5) ) ).

tff(addAssignment_10751,axiom,
    ! [VarNext: state_type] :
      ( v20765(VarNext,5)
    <=> v21087(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_237,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21088(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v21087(VarNext,B)
            <=> v20765(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_237,axiom,
    ! [VarNext: state_type] :
      ( v21088(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21087(VarNext,B)
          <=> v21076(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1736,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21088(VarNext)
      <=> v21089(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1735,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21089(VarNext)
      <=> ( v21091(VarNext)
          & v21018(VarNext) ) ) ) ).

tff(writeUnaryOperator_1174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21091(VarNext)
      <=> v21070(VarNext) ) ) ).

tff(addAssignment_10750,axiom,
    ! [VarCurr: state_type] :
      ( v20875(VarCurr,5)
    <=> v20877(VarCurr,5) ) ).

tff(addAssignment_10749,axiom,
    ! [VarCurr: state_type] :
      ( v20877(VarCurr,5)
    <=> v21015(VarCurr,5) ) ).

tff(addAssignment_10748,axiom,
    ! [VarCurr: state_type] :
      ( v20879(VarCurr,2)
    <=> v20881(VarCurr,2) ) ).

tff(addAssignment_10747,axiom,
    ! [VarCurr: state_type] :
      ( v20881(VarCurr,2)
    <=> v20883(VarCurr,2) ) ).

tff(addAssignment_10746,axiom,
    ! [VarCurr: state_type] :
      ( v20883(VarCurr,2)
    <=> v21014(VarCurr,2) ) ).

tff(addAssignment_10745,axiom,
    ! [VarCurr: state_type] :
      ( v20951(VarCurr,2)
    <=> v20953(VarCurr,2) ) ).

tff(addAssignment_10744,axiom,
    ! [VarCurr: state_type] :
      ( v20953(VarCurr,2)
    <=> v20955(VarCurr,2) ) ).

tff(addAssignment_10743,axiom,
    ! [VarCurr: state_type] :
      ( v20955(VarCurr,2)
    <=> v20957(VarCurr,2) ) ).

tff(addAssignment_10742,axiom,
    ! [VarCurr: state_type] :
      ( v20957(VarCurr,2)
    <=> v20959(VarCurr,2) ) ).

tff(addAssignment_10741,axiom,
    ! [VarCurr: state_type] :
      ( v20959(VarCurr,2)
    <=> v20969(VarCurr,2) ) ).

tff(addAssignment_10740,axiom,
    ! [VarCurr: state_type] :
      ( v20961(VarCurr,2)
    <=> v20963(VarCurr,2) ) ).

tff(addAssignment_10739,axiom,
    ! [VarCurr: state_type] :
      ( v20963(VarCurr,2)
    <=> v20964(VarCurr,2) ) ).

tff(addAssignment_10738,axiom,
    ! [VarCurr: state_type] :
      ( v20885(VarCurr,2)
    <=> v20887(VarCurr,2) ) ).

tff(addAssignment_10737,axiom,
    ! [VarCurr: state_type] :
      ( v20887(VarCurr,2)
    <=> v20948(VarCurr,2) ) ).

tff(addAssignment_10736,axiom,
    ! [VarCurr: state_type] :
      ( v20945(VarCurr)
    <=> v20947(VarCurr) ) ).

tff(addAssignment_10735,axiom,
    ! [VarCurr: state_type] :
      ( v20947(VarCurr)
    <=> v20851(VarCurr,1) ) ).

tff(addAssignment_10734,axiom,
    ! [VarCurr: state_type] :
      ( v20851(VarCurr,1)
    <=> v20763(VarCurr,4) ) ).

tff(addAssignment_10733,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,4)
    <=> v20765(VarCurr,4) ) ).

tff(addAssignment_10732,axiom,
    ! [VarNext: state_type] :
      ( v20765(VarNext,4)
    <=> v21065(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21066(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v21065(VarNext,B)
            <=> v20765(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_236,axiom,
    ! [VarNext: state_type] :
      ( v21066(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21065(VarNext,B)
          <=> v21076(VarNext,B) ) ) ) ).

tff(addAssignment_10731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21076(VarNext,B)
          <=> v21074(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_154,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21074(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_154,axiom,
    ! [VarCurr: state_type] :
      ( v21077(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v21074(VarCurr,B)
          <=> v20875(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1734,axiom,
    ! [VarCurr: state_type] :
      ( v21077(VarCurr)
    <=> ( v21078(VarCurr)
        & v21079(VarCurr) ) ) ).

tff(writeUnaryOperator_1173,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21079(VarCurr)
    <=> v20865(VarCurr) ) ).

tff(writeUnaryOperator_1172,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21078(VarCurr)
    <=> v20853(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21066(VarNext)
      <=> v21067(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21067(VarNext)
      <=> ( v21068(VarNext)
          & v21018(VarNext) ) ) ) ).

tff(writeUnaryOperator_1171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21068(VarNext)
      <=> v21070(VarNext) ) ) ).

tff(addAssignment_10730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21070(VarNext)
      <=> v21018(VarCurr) ) ) ).

tff(addAssignment_10729,axiom,
    ! [VarCurr: state_type] :
      ( v21018(VarCurr)
    <=> v21020(VarCurr) ) ).

tff(addAssignment_10728,axiom,
    ! [VarCurr: state_type] :
      ( v21020(VarCurr)
    <=> v21022(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1731,axiom,
    ! [VarCurr: state_type] :
      ( v21022(VarCurr)
    <=> ( v21063(VarCurr)
        | v21059(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1730,axiom,
    ! [VarCurr: state_type] :
      ( v21063(VarCurr)
    <=> ( v21024(VarCurr)
        & v21028(VarCurr) ) ) ).

tff(addAssignment_10727,axiom,
    ! [VarCurr: state_type] :
      ( v21059(VarCurr)
    <=> v21061(VarCurr) ) ).

tff(addAssignment_10726,axiom,
    ! [VarCurr: state_type] :
      ( v21061(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v21043(VarNext)
       => ( v21028(VarNext)
        <=> v21028(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_235,axiom,
    ! [VarNext: state_type] :
      ( v21043(VarNext)
     => ( v21028(VarNext)
      <=> v21053(VarNext) ) ) ).

tff(addAssignment_10725,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21053(VarNext)
      <=> v21051(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1729,axiom,
    ! [VarCurr: state_type] :
      ( v21051(VarCurr)
    <=> ( v21054(VarCurr)
        & v21055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1728,axiom,
    ! [VarCurr: state_type] :
      ( v21055(VarCurr)
    <=> ( v21034(VarCurr)
        | v21038(VarCurr) ) ) ).

tff(writeUnaryOperator_1170,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21054(VarCurr)
    <=> v21030(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21043(VarNext)
      <=> v21044(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21044(VarNext)
      <=> ( v21046(VarNext)
          & v21048(VarNext) ) ) ) ).

tff(writeUnaryOperator_1169,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21048(VarCurr)
    <=> v21024(VarCurr) ) ).

tff(addAssignment_10724,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v21046(VarNext)
      <=> v21024(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_83,axiom,
    ( v21028(constB0)
  <=> $true ) ).

tff(addAssignment_10723,axiom,
    ! [VarCurr: state_type] :
      ( v21038(VarCurr)
    <=> v21040(VarCurr) ) ).

tff(addAssignment_10722,axiom,
    ! [VarCurr: state_type] :
      ( v21040(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_10721,axiom,
    ! [VarCurr: state_type] :
      ( v21034(VarCurr)
    <=> v21036(VarCurr) ) ).

tff(addAssignment_10720,axiom,
    ! [VarCurr: state_type] :
      ( v21036(VarCurr)
    <=> $true ) ).

tff(addAssignment_10719,axiom,
    ! [VarCurr: state_type] :
      ( v21030(VarCurr)
    <=> v21032(VarCurr) ) ).

tff(addAssignment_10718,axiom,
    ! [VarCurr: state_type] :
      ( v21032(VarCurr)
    <=> $false ) ).

tff(addAssignment_10717,axiom,
    ! [VarCurr: state_type] :
      ( v21024(VarCurr)
    <=> v21026(VarCurr) ) ).

tff(addAssignment_10716,axiom,
    ! [VarCurr: state_type] :
      ( v21026(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10715,axiom,
    ! [VarCurr: state_type] :
      ( v20875(VarCurr,4)
    <=> v20877(VarCurr,4) ) ).

tff(addAssignment_10714,axiom,
    ! [VarCurr: state_type] :
      ( v20877(VarCurr,4)
    <=> v21015(VarCurr,4) ) ).

tff(addAssignment_10713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v21015(VarCurr,B)
      <=> v21016(VarCurr,B) ) ) ).

tff(addAssignment_10712,axiom,
    ! [VarCurr: state_type] :
      ( ( v21015(VarCurr,5)
      <=> v20879(VarCurr,2) )
      & ( v21015(VarCurr,4)
      <=> v20879(VarCurr,1) )
      & ( v21015(VarCurr,3)
      <=> v20879(VarCurr,0) ) ) ).

tff(addAssignment_10711,axiom,
    ! [VarCurr: state_type] :
      ( v20879(VarCurr,1)
    <=> v20881(VarCurr,1) ) ).

tff(addAssignment_10710,axiom,
    ! [VarCurr: state_type] :
      ( v20881(VarCurr,1)
    <=> v20883(VarCurr,1) ) ).

tff(addAssignment_10709,axiom,
    ! [VarCurr: state_type] :
      ( v20883(VarCurr,1)
    <=> v21014(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v21014(VarCurr,B)
      <=> ( v20885(VarCurr,B)
          & v20951(VarCurr,B) ) ) ) ).

tff(addAssignment_10708,axiom,
    ! [VarCurr: state_type] :
      ( v20951(VarCurr,1)
    <=> v20953(VarCurr,1) ) ).

tff(addAssignment_10707,axiom,
    ! [VarCurr: state_type] :
      ( v20953(VarCurr,1)
    <=> v20955(VarCurr,1) ) ).

tff(addAssignment_10706,axiom,
    ! [VarCurr: state_type] :
      ( v20955(VarCurr,1)
    <=> v20957(VarCurr,1) ) ).

tff(addAssignment_10705,axiom,
    ! [VarCurr: state_type] :
      ( v20957(VarCurr,1)
    <=> v20959(VarCurr,1) ) ).

tff(addAssignment_10704,axiom,
    ! [VarCurr: state_type] :
      ( v20959(VarCurr,1)
    <=> v20969(VarCurr,1) ) ).

tff(addAssignment_10703,axiom,
    ! [VarCurr: state_type] :
      ( v20969(VarCurr,0)
    <=> v21009(VarCurr) ) ).

tff(addAssignment_10702,axiom,
    ! [VarCurr: state_type] :
      ( v20969(VarCurr,1)
    <=> v21004(VarCurr) ) ).

tff(addAssignment_10701,axiom,
    ! [VarCurr: state_type] :
      ( v20969(VarCurr,2)
    <=> v20999(VarCurr) ) ).

tff(addAssignment_10700,axiom,
    ! [VarCurr: state_type] :
      ( v20969(VarCurr,3)
    <=> v20971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1725,axiom,
    ! [VarCurr: state_type] :
      ( v21009(VarCurr)
    <=> ( v21010(VarCurr)
        & v21013(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1724,axiom,
    ! [VarCurr: state_type] :
      ( v21013(VarCurr)
    <=> ( v20961(VarCurr,0)
        | v20979(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1723,axiom,
    ! [VarCurr: state_type] :
      ( v21010(VarCurr)
    <=> ( v21011(VarCurr)
        | v21012(VarCurr) ) ) ).

tff(writeUnaryOperator_1168,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21012(VarCurr)
    <=> v20979(VarCurr,0) ) ).

tff(writeUnaryOperator_1167,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21011(VarCurr)
    <=> v20961(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1722,axiom,
    ! [VarCurr: state_type] :
      ( v21004(VarCurr)
    <=> ( v21005(VarCurr)
        & v21008(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1721,axiom,
    ! [VarCurr: state_type] :
      ( v21008(VarCurr)
    <=> ( v20978(VarCurr)
        | v20980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1720,axiom,
    ! [VarCurr: state_type] :
      ( v21005(VarCurr)
    <=> ( v21006(VarCurr)
        | v21007(VarCurr) ) ) ).

tff(writeUnaryOperator_1166,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21007(VarCurr)
    <=> v20980(VarCurr) ) ).

tff(writeUnaryOperator_1165,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21006(VarCurr)
    <=> v20978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1719,axiom,
    ! [VarCurr: state_type] :
      ( v20999(VarCurr)
    <=> ( v21000(VarCurr)
        & v21003(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1718,axiom,
    ! [VarCurr: state_type] :
      ( v21003(VarCurr)
    <=> ( v20976(VarCurr)
        | v20986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1717,axiom,
    ! [VarCurr: state_type] :
      ( v21000(VarCurr)
    <=> ( v21001(VarCurr)
        | v21002(VarCurr) ) ) ).

tff(writeUnaryOperator_1164,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21002(VarCurr)
    <=> v20986(VarCurr) ) ).

tff(writeUnaryOperator_1163,axiom,
    ! [VarCurr: state_type] :
      ( ~ v21001(VarCurr)
    <=> v20976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1716,axiom,
    ! [VarCurr: state_type] :
      ( v20971(VarCurr)
    <=> ( v20972(VarCurr)
        & v20998(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1715,axiom,
    ! [VarCurr: state_type] :
      ( v20998(VarCurr)
    <=> ( v20974(VarCurr)
        | v20993(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1714,axiom,
    ! [VarCurr: state_type] :
      ( v20972(VarCurr)
    <=> ( v20973(VarCurr)
        | v20992(VarCurr) ) ) ).

tff(writeUnaryOperator_1162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20992(VarCurr)
    <=> v20993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1713,axiom,
    ! [VarCurr: state_type] :
      ( v20993(VarCurr)
    <=> ( v20994(VarCurr)
        & v20997(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_218,axiom,
    ! [VarCurr: state_type] :
      ( v20997(VarCurr)
    <=> ( v20961(VarCurr,3)
        | v20979(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1712,axiom,
    ! [VarCurr: state_type] :
      ( v20994(VarCurr)
    <=> ( v20995(VarCurr)
        | v20996(VarCurr) ) ) ).

tff(writeUnaryOperator_1161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20996(VarCurr)
    <=> v20979(VarCurr,3) ) ).

tff(writeUnaryOperator_1160,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20995(VarCurr)
    <=> v20961(VarCurr,3) ) ).

tff(writeUnaryOperator_1159,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20973(VarCurr)
    <=> v20974(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1711,axiom,
    ! [VarCurr: state_type] :
      ( v20974(VarCurr)
    <=> ( v20975(VarCurr)
        | v20991(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_217,axiom,
    ! [VarCurr: state_type] :
      ( v20991(VarCurr)
    <=> ( v20961(VarCurr,2)
        & v20979(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1710,axiom,
    ! [VarCurr: state_type] :
      ( v20975(VarCurr)
    <=> ( v20976(VarCurr)
        & v20986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1709,axiom,
    ! [VarCurr: state_type] :
      ( v20986(VarCurr)
    <=> ( v20987(VarCurr)
        & v20990(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_216,axiom,
    ! [VarCurr: state_type] :
      ( v20990(VarCurr)
    <=> ( v20961(VarCurr,2)
        | v20979(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1708,axiom,
    ! [VarCurr: state_type] :
      ( v20987(VarCurr)
    <=> ( v20988(VarCurr)
        | v20989(VarCurr) ) ) ).

tff(writeUnaryOperator_1158,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20989(VarCurr)
    <=> v20979(VarCurr,2) ) ).

tff(writeUnaryOperator_1157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20988(VarCurr)
    <=> v20961(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1707,axiom,
    ! [VarCurr: state_type] :
      ( v20976(VarCurr)
    <=> ( v20977(VarCurr)
        | v20985(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_215,axiom,
    ! [VarCurr: state_type] :
      ( v20985(VarCurr)
    <=> ( v20961(VarCurr,1)
        & v20979(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1706,axiom,
    ! [VarCurr: state_type] :
      ( v20977(VarCurr)
    <=> ( v20978(VarCurr)
        & v20980(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1705,axiom,
    ! [VarCurr: state_type] :
      ( v20980(VarCurr)
    <=> ( v20981(VarCurr)
        & v20984(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_214,axiom,
    ! [VarCurr: state_type] :
      ( v20984(VarCurr)
    <=> ( v20961(VarCurr,1)
        | v20979(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1704,axiom,
    ! [VarCurr: state_type] :
      ( v20981(VarCurr)
    <=> ( v20982(VarCurr)
        | v20983(VarCurr) ) ) ).

tff(writeUnaryOperator_1156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20983(VarCurr)
    <=> v20979(VarCurr,1) ) ).

tff(writeUnaryOperator_1155,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20982(VarCurr)
    <=> v20961(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1703,axiom,
    ! [VarCurr: state_type] :
      ( v20978(VarCurr)
    <=> ( v20961(VarCurr,0)
        & v20979(VarCurr,0) ) ) ).

tff(addAssignment_10699,axiom,
    ! [VarCurr: state_type] :
      ( v20979(VarCurr,0)
    <=> v20966(VarCurr) ) ).

tff(addAssignment_10698,axiom,
    ! [VarCurr: state_type] :
      ( ( v20979(VarCurr,3)
      <=> $false )
      & ( v20979(VarCurr,2)
      <=> $false )
      & ( v20979(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_10697,axiom,
    ! [VarCurr: state_type] :
      ( v20966(VarCurr)
    <=> v20968(VarCurr) ) ).

tff(addAssignment_10696,axiom,
    ! [VarCurr: state_type] :
      ( v20968(VarCurr)
    <=> v20916(VarCurr) ) ).

tff(addAssignment_10695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v20961(VarCurr,B)
      <=> v20963(VarCurr,B) ) ) ).

tff(addAssignment_10694,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v20963(VarCurr,B)
      <=> v20964(VarCurr,B) ) ) ).

tff(addAssignment_10693,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v20964(VarCurr,B)
      <=> v20851(VarCurr,B) ) ) ).

tff(addAssignment_10692,axiom,
    ! [VarCurr: state_type] :
      ( v20964(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_10691,axiom,
    ! [VarCurr: state_type] :
      ( v20885(VarCurr,1)
    <=> v20887(VarCurr,1) ) ).

tff(addAssignment_10690,axiom,
    ! [VarCurr: state_type] :
      ( v20887(VarCurr,1)
    <=> v20948(VarCurr,1) ) ).

tff(addAssignment_10689,axiom,
    ! [VarCurr: state_type] :
      ( v20948(VarCurr,0)
    <=> v20949(VarCurr) ) ).

tff(addAssignment_10688,axiom,
    ! [VarCurr: state_type] :
      ( v20948(VarCurr,1)
    <=> v20949(VarCurr) ) ).

tff(addAssignment_10687,axiom,
    ! [VarCurr: state_type] :
      ( v20948(VarCurr,2)
    <=> v20949(VarCurr) ) ).

tff(addAssignment_10686,axiom,
    ! [VarCurr: state_type] :
      ( v20949(VarCurr)
    <=> v20889(VarCurr) ) ).

tff(addAssignment_10685,axiom,
    ! [VarCurr: state_type] :
      ( v20930(VarCurr)
    <=> v20932(VarCurr) ) ).

tff(addAssignment_10684,axiom,
    ! [VarCurr: state_type] :
      ( v20932(VarCurr)
    <=> v20934(VarCurr,0) ) ).

tff(addAssignment_10683,axiom,
    ! [VarCurr: state_type] :
      ( v20934(VarCurr,0)
    <=> v20936(VarCurr,0) ) ).

tff(addAssignment_10682,axiom,
    ! [VarCurr: state_type] :
      ( v20936(VarCurr,0)
    <=> v20938(VarCurr,0) ) ).

tff(addAssignment_10681,axiom,
    ! [VarCurr: state_type] :
      ( v20938(VarCurr,0)
    <=> v20943(VarCurr,0) ) ).

tff(writeUnaryOperator_1154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v20943(VarCurr,B)
      <=> ~ v20940(VarCurr,B) ) ) ).

tff(addAssignment_10680,axiom,
    ! [VarCurr: state_type] :
      ( v20940(VarCurr,0)
    <=> v20942(VarCurr,0) ) ).

tff(addAssignment_10679,axiom,
    ! [VarCurr: state_type] :
      ( v20942(VarCurr,0)
    <=> v20851(VarCurr,0) ) ).

tff(addAssignment_10678,axiom,
    ! [VarCurr: state_type] :
      ( v20912(VarCurr,1)
    <=> v20914(VarCurr,1) ) ).

tff(addAssignment_10677,axiom,
    ! [VarCurr: state_type] :
      ( v20914(VarCurr,1)
    <=> v20917(VarCurr,1) ) ).

tff(addAssignment_10676,axiom,
    ! [VarCurr: state_type] :
      ( v20917(VarCurr,0)
    <=> v20918(VarCurr) ) ).

tff(addAssignment_10675,axiom,
    ! [VarCurr: state_type] :
      ( v20917(VarCurr,1)
    <=> v20916(VarCurr) ) ).

tff(addAssignment_10674,axiom,
    ! [VarCurr: state_type] :
      ( v20916(VarCurr)
    <=> v10053(VarCurr,7) ) ).

tff(addAssignment_10673,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,7)
    <=> v10055(VarCurr,7) ) ).

tff(addAssignment_10672,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,7)
    <=> v10057(VarCurr,7) ) ).

tff(addAssignment_10671,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,7)
    <=> v10061(VarCurr,7) ) ).

tff(addAssignment_10670,axiom,
    ! [VarCurr: state_type] :
      ( v20896(VarCurr,1)
    <=> v20898(VarCurr,1) ) ).

tff(addAssignment_10669,axiom,
    ! [VarCurr: state_type] :
      ( v20898(VarCurr,1)
    <=> v20899(VarCurr,1) ) ).

tff(addAssignment_10668,axiom,
    ! [VarCurr: state_type] :
      ( v20899(VarCurr,0)
    <=> v20900(VarCurr) ) ).

tff(addAssignment_10667,axiom,
    ! [VarCurr: state_type] :
      ( v20899(VarCurr,1)
    <=> v20900(VarCurr) ) ).

tff(addAssignment_10666,axiom,
    ! [VarCurr: state_type] :
      ( v20900(VarCurr)
    <=> v20423(VarCurr) ) ).

tff(addAssignment_10665,axiom,
    ! [VarCurr: state_type] :
      ( v20865(VarCurr)
    <=> v20867(VarCurr) ) ).

tff(addAssignment_10664,axiom,
    ! [VarCurr: state_type] :
      ( v20867(VarCurr)
    <=> v20869(VarCurr) ) ).

tff(addAssignment_10663,axiom,
    ! [VarCurr: state_type] :
      ( v20869(VarCurr)
    <=> v20871(VarCurr) ) ).

tff(addAssignment_10662,axiom,
    ! [VarCurr: state_type] :
      ( v20871(VarCurr)
    <=> v20873(VarCurr) ) ).

tff(addAssignment_10661,axiom,
    ! [VarCurr: state_type] :
      ( v20873(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10660,axiom,
    ! [VarCurr: state_type] :
      ( v20853(VarCurr)
    <=> v20855(VarCurr) ) ).

tff(addAssignment_10659,axiom,
    ! [VarCurr: state_type] :
      ( v20855(VarCurr)
    <=> v20857(VarCurr) ) ).

tff(addAssignment_10658,axiom,
    ! [VarCurr: state_type] :
      ( v20857(VarCurr)
    <=> v20859(VarCurr) ) ).

tff(addAssignment_10657,axiom,
    ! [VarCurr: state_type] :
      ( v20859(VarCurr)
    <=> v20861(VarCurr) ) ).

tff(addAssignment_10656,axiom,
    ! [VarCurr: state_type] :
      ( v20861(VarCurr)
    <=> v20863(VarCurr) ) ).

tff(addAssignment_10655,axiom,
    ! [VarCurr: state_type] :
      ( v20863(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_10654,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20361(VarCurr,B)
      <=> v20363(VarCurr,B) ) ) ).

tff(addAssignment_10653,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20363(VarCurr,B)
      <=> v20365(VarCurr,B) ) ) ).

tff(addAssignment_10652,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20365(VarCurr,B)
      <=> v20367(VarCurr,B) ) ) ).

tff(addAssignment_10651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20367(VarCurr,B)
      <=> v20369(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20814(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v20369(VarNext,B)
            <=> v20369(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_234,axiom,
    ! [VarNext: state_type] :
      ( v20814(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20369(VarNext,B)
          <=> v20824(VarNext,B) ) ) ) ).

tff(addAssignment_10650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20824(VarNext,B)
          <=> v20822(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20825(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20822(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_153,axiom,
    ! [VarCurr: state_type] :
      ( v20825(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20822(VarCurr,B)
          <=> v20399(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1702,axiom,
    ! [VarCurr: state_type] :
      ( v20825(VarCurr)
    <=> ( v20826(VarCurr)
        & v20827(VarCurr) ) ) ).

tff(writeUnaryOperator_1153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20827(VarCurr)
    <=> v20385(VarCurr) ) ).

tff(writeUnaryOperator_1152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20826(VarCurr)
    <=> v20371(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20814(VarNext)
      <=> v20815(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1700,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20815(VarNext)
      <=> ( v20816(VarNext)
          & v20729(VarNext) ) ) ) ).

tff(writeUnaryOperator_1151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20816(VarNext)
      <=> v20818(VarNext) ) ) ).

tff(addAssignment_10649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20818(VarNext)
      <=> v20729(VarCurr) ) ) ).

tff(addAssignment_10648,axiom,
    ! [VarCurr: state_type] :
      ( v20729(VarCurr)
    <=> v20731(VarCurr) ) ).

tff(addAssignment_10647,axiom,
    ! [VarCurr: state_type] :
      ( v20731(VarCurr)
    <=> v20733(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1699,axiom,
    ! [VarCurr: state_type] :
      ( v20733(VarCurr)
    <=> ( v20811(VarCurr)
        | v20803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1698,axiom,
    ! [VarCurr: state_type] :
      ( v20811(VarCurr)
    <=> ( v20735(VarCurr)
        & v20741(VarCurr) ) ) ).

tff(addAssignment_10646,axiom,
    ! [VarCurr: state_type] :
      ( v20803(VarCurr)
    <=> v20805(VarCurr) ) ).

tff(addAssignment_10645,axiom,
    ! [VarCurr: state_type] :
      ( v20805(VarCurr)
    <=> v20807(VarCurr) ) ).

tff(addAssignment_10644,axiom,
    ! [VarCurr: state_type] :
      ( v20807(VarCurr)
    <=> v20809(VarCurr) ) ).

tff(addAssignment_10643,axiom,
    ! [VarCurr: state_type] :
      ( v20809(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_233,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20787(VarNext)
       => ( v20741(VarNext)
        <=> v20741(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_233,axiom,
    ! [VarNext: state_type] :
      ( v20787(VarNext)
     => ( v20741(VarNext)
      <=> v20797(VarNext) ) ) ).

tff(addAssignment_10642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20797(VarNext)
      <=> v20795(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1697,axiom,
    ! [VarCurr: state_type] :
      ( v20795(VarCurr)
    <=> ( v20798(VarCurr)
        & v20799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1696,axiom,
    ! [VarCurr: state_type] :
      ( v20799(VarCurr)
    <=> ( v20747(VarCurr)
        | v20778(VarCurr) ) ) ).

tff(writeUnaryOperator_1150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20798(VarCurr)
    <=> v20743(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20787(VarNext)
      <=> v20788(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20788(VarNext)
      <=> ( v20790(VarNext)
          & v20792(VarNext) ) ) ) ).

tff(writeUnaryOperator_1149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20792(VarCurr)
    <=> v20735(VarCurr) ) ).

tff(addAssignment_10641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20790(VarNext)
      <=> v20735(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_82,axiom,
    ( v20741(constB0)
  <=> $true ) ).

tff(addAssignment_10640,axiom,
    ! [VarCurr: state_type] :
      ( v20778(VarCurr)
    <=> v20780(VarCurr) ) ).

tff(addAssignment_10639,axiom,
    ! [VarCurr: state_type] :
      ( v20780(VarCurr)
    <=> v20782(VarCurr) ) ).

tff(addAssignment_10638,axiom,
    ! [VarCurr: state_type] :
      ( v20782(VarCurr)
    <=> v20784(VarCurr) ) ).

tff(addAssignment_10637,axiom,
    ! [VarCurr: state_type] :
      ( v20784(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_10636,axiom,
    ! [VarCurr: state_type] :
      ( v20747(VarCurr)
    <=> v20749(VarCurr) ) ).

tff(addAssignment_10635,axiom,
    ! [VarCurr: state_type] :
      ( v20749(VarCurr)
    <=> v20751(VarCurr) ) ).

tff(addAssignment_10634,axiom,
    ! [VarCurr: state_type] :
      ( v20751(VarCurr)
    <=> v20753(VarCurr) ) ).

tff(addAssignment_10633,axiom,
    ! [VarCurr: state_type] :
      ( v20753(VarCurr)
    <=> v20755(VarCurr) ) ).

tff(writeUnaryOperator_1148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20755(VarCurr)
    <=> v20775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1693,axiom,
    ! [VarCurr: state_type] :
      ( v20775(VarCurr)
    <=> ( v20776(VarCurr)
        | v20771(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1692,axiom,
    ! [VarCurr: state_type] :
      ( v20776(VarCurr)
    <=> ( v20757(VarCurr)
        | v20767(VarCurr) ) ) ).

tff(addAssignment_10632,axiom,
    ! [VarCurr: state_type] :
      ( v20771(VarCurr)
    <=> v20773(VarCurr) ) ).

tff(addAssignment_10631,axiom,
    ! [VarCurr: state_type] :
      ( v20773(VarCurr)
    <=> v20761(VarCurr,2) ) ).

tff(addAssignment_10630,axiom,
    ! [VarCurr: state_type] :
      ( v20761(VarCurr,2)
    <=> v20763(VarCurr,2) ) ).

tff(addAssignment_10629,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,2)
    <=> v20765(VarCurr,2) ) ).

tff(addAssignment_10628,axiom,
    ! [VarCurr: state_type] :
      ( v20767(VarCurr)
    <=> v20769(VarCurr) ) ).

tff(addAssignment_10627,axiom,
    ! [VarCurr: state_type] :
      ( v20769(VarCurr)
    <=> v20761(VarCurr,1) ) ).

tff(addAssignment_10626,axiom,
    ! [VarCurr: state_type] :
      ( v20761(VarCurr,1)
    <=> v20763(VarCurr,1) ) ).

tff(addAssignment_10625,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,1)
    <=> v20765(VarCurr,1) ) ).

tff(addAssignment_10624,axiom,
    ! [VarCurr: state_type] :
      ( v20757(VarCurr)
    <=> v20759(VarCurr) ) ).

tff(addAssignment_10623,axiom,
    ! [VarCurr: state_type] :
      ( v20759(VarCurr)
    <=> v20761(VarCurr,0) ) ).

tff(addAssignment_10622,axiom,
    ! [VarCurr: state_type] :
      ( v20761(VarCurr,0)
    <=> v20763(VarCurr,0) ) ).

tff(addAssignment_10621,axiom,
    ! [VarCurr: state_type] :
      ( v20763(VarCurr,0)
    <=> v20765(VarCurr,0) ) ).

tff(addAssignment_10620,axiom,
    ! [VarCurr: state_type] :
      ( v20743(VarCurr)
    <=> v20745(VarCurr) ) ).

tff(addAssignment_10619,axiom,
    ! [VarCurr: state_type] :
      ( v20745(VarCurr)
    <=> $false ) ).

tff(addAssignment_10618,axiom,
    ! [VarCurr: state_type] :
      ( v20735(VarCurr)
    <=> v20737(VarCurr) ) ).

tff(addAssignment_10617,axiom,
    ! [VarCurr: state_type] :
      ( v20737(VarCurr)
    <=> v20739(VarCurr) ) ).

tff(addAssignment_10616,axiom,
    ! [VarCurr: state_type] :
      ( v20739(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_10615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20399(VarCurr,B)
      <=> v20401(VarCurr,B) ) ) ).

tff(addAssignment_10614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20401(VarCurr,B)
      <=> v20403(VarCurr,B) ) ) ).

tff(addAssignment_10613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20403(VarCurr,B)
      <=> v20405(VarCurr,B) ) ) ).

tff(addAssignment_10612,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20405(VarCurr,B)
      <=> v20407(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20407(VarCurr,B)
      <=> ( v20409(VarCurr,B)
          & v20431(VarCurr,B) ) ) ) ).

tff(addAssignment_10611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20431(VarCurr,B)
      <=> v20433(VarCurr,B) ) ) ).

tff(addAssignment_10610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20433(VarCurr,B)
      <=> v20435(VarCurr,B) ) ) ).

tff(addAssignment_10609,axiom,
    ! [VarCurr: state_type] :
      ( ( v20435(VarCurr,11)
      <=> v9198(VarCurr,95) )
      & ( v20435(VarCurr,10)
      <=> v9198(VarCurr,94) )
      & ( v20435(VarCurr,9)
      <=> v9198(VarCurr,93) )
      & ( v20435(VarCurr,8)
      <=> v9198(VarCurr,92) )
      & ( v20435(VarCurr,7)
      <=> v9198(VarCurr,91) )
      & ( v20435(VarCurr,6)
      <=> v9198(VarCurr,90) )
      & ( v20435(VarCurr,5)
      <=> v9198(VarCurr,89) )
      & ( v20435(VarCurr,4)
      <=> v9198(VarCurr,88) )
      & ( v20435(VarCurr,3)
      <=> v9198(VarCurr,87) )
      & ( v20435(VarCurr,2)
      <=> v9198(VarCurr,86) )
      & ( v20435(VarCurr,1)
      <=> v9198(VarCurr,85) )
      & ( v20435(VarCurr,0)
      <=> v9198(VarCurr,84) ) ) ).

tff(addAssignment_10608,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,95)
      <=> v20437(VarCurr,11) )
      & ( v9198(VarCurr,94)
      <=> v20437(VarCurr,10) )
      & ( v9198(VarCurr,93)
      <=> v20437(VarCurr,9) )
      & ( v9198(VarCurr,92)
      <=> v20437(VarCurr,8) )
      & ( v9198(VarCurr,91)
      <=> v20437(VarCurr,7) )
      & ( v9198(VarCurr,90)
      <=> v20437(VarCurr,6) )
      & ( v9198(VarCurr,89)
      <=> v20437(VarCurr,5) )
      & ( v9198(VarCurr,88)
      <=> v20437(VarCurr,4) )
      & ( v9198(VarCurr,87)
      <=> v20437(VarCurr,3) )
      & ( v9198(VarCurr,86)
      <=> v20437(VarCurr,2) )
      & ( v9198(VarCurr,85)
      <=> v20437(VarCurr,1) )
      & ( v9198(VarCurr,84)
      <=> v20437(VarCurr,0) ) ) ).

tff(addAssignment_10607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20437(VarCurr,B)
      <=> v20439(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20439(VarCurr,B)
      <=> ( v20721(VarCurr,B)
          | v20724(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_352,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20724(VarCurr,B)
      <=> ( v20449(VarCurr,B)
          & v20725(VarCurr,B) ) ) ) ).

tff(addAssignment_10606,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,0)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10605,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,1)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10604,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,2)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10603,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,3)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10602,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,4)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10601,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,5)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10600,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,6)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10599,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,7)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10598,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,8)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10597,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,9)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10596,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,10)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10595,axiom,
    ! [VarCurr: state_type] :
      ( v20725(VarCurr,11)
    <=> v20726(VarCurr) ) ).

tff(addAssignment_10594,axiom,
    ! [VarCurr: state_type] :
      ( v20726(VarCurr)
    <=> v20717(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_351,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20721(VarCurr,B)
      <=> ( v20441(VarCurr,B)
          & v20722(VarCurr,B) ) ) ) ).

tff(addAssignment_10593,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,0)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10592,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,1)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10591,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,2)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10590,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,3)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10589,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,4)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10588,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,5)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10587,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,6)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10586,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,7)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10585,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,8)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10584,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,9)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10583,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,10)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10582,axiom,
    ! [VarCurr: state_type] :
      ( v20722(VarCurr,11)
    <=> v20723(VarCurr) ) ).

tff(addAssignment_10581,axiom,
    ! [VarCurr: state_type] :
      ( v20723(VarCurr)
    <=> v20445(VarCurr) ) ).

tff(addAssignment_10580,axiom,
    ! [VarCurr: state_type] :
      ( v20717(VarCurr)
    <=> v20719(VarCurr) ) ).

tff(addAssignment_10579,axiom,
    ! [VarCurr: state_type] :
      ( v20719(VarCurr)
    <=> v9844(VarCurr,7) ) ).

tff(addAssignment_10578,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,7)
    <=> v9846(VarCurr,7) ) ).

tff(addAssignment_10577,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,7)
    <=> v9496(VarCurr,7) ) ).

tff(addAssignment_10576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20449(VarCurr,B)
      <=> v20451(VarCurr,B) ) ) ).

tff(addAssignment_10575,axiom,
    ! [VarCurr: state_type] :
      ( ( v20451(VarCurr,11)
      <=> v9208(VarCurr,107) )
      & ( v20451(VarCurr,10)
      <=> v9208(VarCurr,106) )
      & ( v20451(VarCurr,9)
      <=> v9208(VarCurr,105) )
      & ( v20451(VarCurr,8)
      <=> v9208(VarCurr,104) )
      & ( v20451(VarCurr,7)
      <=> v9208(VarCurr,103) )
      & ( v20451(VarCurr,6)
      <=> v9208(VarCurr,102) )
      & ( v20451(VarCurr,5)
      <=> v9208(VarCurr,101) )
      & ( v20451(VarCurr,4)
      <=> v9208(VarCurr,100) )
      & ( v20451(VarCurr,3)
      <=> v9208(VarCurr,99) )
      & ( v20451(VarCurr,2)
      <=> v9208(VarCurr,98) )
      & ( v20451(VarCurr,1)
      <=> v9208(VarCurr,97) )
      & ( v20451(VarCurr,0)
      <=> v9208(VarCurr,96) ) ) ).

tff(addAssignment_10574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,108)
        & ~ $less(B,96) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_10573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,108)
        & ~ $less(B,96) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_10572,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,107)
      <=> v20453(VarCurr,11) )
      & ( v9212(VarCurr,106)
      <=> v20453(VarCurr,10) )
      & ( v9212(VarCurr,105)
      <=> v20453(VarCurr,9) )
      & ( v9212(VarCurr,104)
      <=> v20453(VarCurr,8) )
      & ( v9212(VarCurr,103)
      <=> v20453(VarCurr,7) )
      & ( v9212(VarCurr,102)
      <=> v20453(VarCurr,6) )
      & ( v9212(VarCurr,101)
      <=> v20453(VarCurr,5) )
      & ( v9212(VarCurr,100)
      <=> v20453(VarCurr,4) )
      & ( v9212(VarCurr,99)
      <=> v20453(VarCurr,3) )
      & ( v9212(VarCurr,98)
      <=> v20453(VarCurr,2) )
      & ( v9212(VarCurr,97)
      <=> v20453(VarCurr,1) )
      & ( v9212(VarCurr,96)
      <=> v20453(VarCurr,0) ) ) ).

tff(addAssignment_10571,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20453(VarCurr,B)
      <=> v20455(VarCurr,B) ) ) ).

tff(addAssignment_10570,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20455(VarCurr,B)
      <=> v20457(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_232,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20700(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v20457(VarNext,B)
            <=> v20457(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_232,axiom,
    ! [VarNext: state_type] :
      ( v20700(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20457(VarNext,B)
          <=> v20710(VarNext,B) ) ) ) ).

tff(addAssignment_10569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20710(VarNext,B)
          <=> v20708(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20711(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20708(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_152,axiom,
    ! [VarCurr: state_type] :
      ( v20711(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20708(VarCurr,B)
          <=> v20487(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1691,axiom,
    ! [VarCurr: state_type] :
      ( v20711(VarCurr)
    <=> ( v20712(VarCurr)
        & v20713(VarCurr) ) ) ).

tff(writeUnaryOperator_1147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20713(VarCurr)
    <=> v20473(VarCurr) ) ).

tff(writeUnaryOperator_1146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20712(VarCurr)
    <=> v20459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20700(VarNext)
      <=> v20701(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20701(VarNext)
      <=> ( v20702(VarNext)
          & v20675(VarNext) ) ) ) ).

tff(writeUnaryOperator_1145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20702(VarNext)
      <=> v20704(VarNext) ) ) ).

tff(addAssignment_10568,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20704(VarNext)
      <=> v20675(VarCurr) ) ) ).

tff(addAssignment_10567,axiom,
    ! [VarCurr: state_type] :
      ( v20675(VarCurr)
    <=> v20677(VarCurr) ) ).

tff(addAssignment_10566,axiom,
    ! [VarCurr: state_type] :
      ( v20677(VarCurr)
    <=> v20679(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1688,axiom,
    ! [VarCurr: state_type] :
      ( v20679(VarCurr)
    <=> ( v20697(VarCurr)
        | v20689(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1687,axiom,
    ! [VarCurr: state_type] :
      ( v20697(VarCurr)
    <=> ( v20681(VarCurr)
        & v20687(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_81,axiom,
    ( v20687(constB0)
  <=> $true ) ).

tff(addAssignment_10565,axiom,
    ! [VarCurr: state_type] :
      ( v20689(VarCurr)
    <=> v20691(VarCurr) ) ).

tff(addAssignment_10564,axiom,
    ! [VarCurr: state_type] :
      ( v20691(VarCurr)
    <=> v20693(VarCurr) ) ).

tff(addAssignment_10563,axiom,
    ! [VarCurr: state_type] :
      ( v20693(VarCurr)
    <=> v20695(VarCurr) ) ).

tff(addAssignment_10562,axiom,
    ! [VarCurr: state_type] :
      ( v20695(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_10561,axiom,
    ! [VarCurr: state_type] :
      ( v20681(VarCurr)
    <=> v20683(VarCurr) ) ).

tff(addAssignment_10560,axiom,
    ! [VarCurr: state_type] :
      ( v20683(VarCurr)
    <=> v20685(VarCurr) ) ).

tff(addAssignment_10559,axiom,
    ! [VarCurr: state_type] :
      ( v20685(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_10558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20487(VarCurr,B)
      <=> v20489(VarCurr,B) ) ) ).

tff(addAssignment_10557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20489(VarCurr,B)
      <=> v20491(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_350,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20491(VarCurr,B)
      <=> ( v20660(VarCurr,B)
          | v20671(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_349,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20671(VarCurr,B)
      <=> ( v20624(VarCurr,B)
          & v20672(VarCurr,B) ) ) ) ).

tff(addAssignment_10556,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,0)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10555,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,1)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10554,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,2)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10553,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,3)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10552,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,4)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10551,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,5)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10550,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,6)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10549,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,7)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10548,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,8)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10547,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,9)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10546,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,10)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10545,axiom,
    ! [VarCurr: state_type] :
      ( v20672(VarCurr,11)
    <=> v20673(VarCurr) ) ).

tff(addAssignment_10544,axiom,
    ! [VarCurr: state_type] :
      ( v20673(VarCurr)
    <=> v20634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20660(VarCurr,B)
      <=> ( v20661(VarCurr,B)
          | v20668(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_347,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20668(VarCurr,B)
      <=> ( v20588(VarCurr,B)
          & v20669(VarCurr,B) ) ) ) ).

tff(addAssignment_10543,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,0)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10542,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,1)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10541,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,2)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10540,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,3)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10539,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,4)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10538,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,5)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10537,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,6)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10536,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,7)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10535,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,8)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10534,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,9)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10533,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,10)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10532,axiom,
    ! [VarCurr: state_type] :
      ( v20669(VarCurr,11)
    <=> v20670(VarCurr) ) ).

tff(addAssignment_10531,axiom,
    ! [VarCurr: state_type] :
      ( v20670(VarCurr)
    <=> v20598(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20661(VarCurr,B)
      <=> ( v20662(VarCurr,B)
          | v20665(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20665(VarCurr,B)
      <=> ( v20541(VarCurr,B)
          & v20666(VarCurr,B) ) ) ) ).

tff(addAssignment_10530,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,0)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10529,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,1)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10528,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,2)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10527,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,3)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10526,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,4)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10525,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,5)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10524,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,6)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10523,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,7)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10522,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,8)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10521,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,9)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10520,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,10)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10519,axiom,
    ! [VarCurr: state_type] :
      ( v20666(VarCurr,11)
    <=> v20667(VarCurr) ) ).

tff(addAssignment_10518,axiom,
    ! [VarCurr: state_type] :
      ( v20667(VarCurr)
    <=> v20551(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_344,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20662(VarCurr,B)
      <=> ( v20493(VarCurr,B)
          & v20663(VarCurr,B) ) ) ) ).

tff(addAssignment_10517,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,0)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10516,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,1)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10515,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,2)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10514,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,3)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10513,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,4)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10512,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,5)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10511,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,6)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10510,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,7)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10509,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,8)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10508,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,9)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10507,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,10)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10506,axiom,
    ! [VarCurr: state_type] :
      ( v20663(VarCurr,11)
    <=> v20664(VarCurr) ) ).

tff(addAssignment_10505,axiom,
    ! [VarCurr: state_type] :
      ( v20664(VarCurr)
    <=> v20503(VarCurr) ) ).

tff(addAssignment_10504,axiom,
    ! [VarCurr: state_type] :
      ( v20634(VarCurr)
    <=> v20636(VarCurr) ) ).

tff(addAssignment_10503,axiom,
    ! [VarCurr: state_type] :
      ( v20636(VarCurr)
    <=> v20638(VarCurr) ) ).

tff(addAssignment_10502,axiom,
    ! [VarCurr: state_type] :
      ( v20638(VarCurr)
    <=> v20640(VarCurr) ) ).

tff(addAssignment_10501,axiom,
    ! [VarCurr: state_type] :
      ( v20640(VarCurr)
    <=> v20642(VarCurr) ) ).

tff(addAssignment_10500,axiom,
    ! [VarCurr: state_type] :
      ( v20642(VarCurr)
    <=> v20644(VarCurr) ) ).

tff(addAssignment_10499,axiom,
    ! [VarCurr: state_type] :
      ( v20644(VarCurr)
    <=> v20646(VarCurr) ) ).

tff(addAssignment_10498,axiom,
    ! [VarCurr: state_type] :
      ( v20646(VarCurr)
    <=> v20648(VarCurr) ) ).

tff(writeUnaryOperator_1144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20648(VarCurr)
    <=> v20658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1686,axiom,
    ! [VarCurr: state_type] :
      ( v20658(VarCurr)
    <=> ( v20650(VarCurr)
        | v20654(VarCurr) ) ) ).

tff(addAssignment_10497,axiom,
    ! [VarCurr: state_type] :
      ( v20654(VarCurr)
    <=> v20656(VarCurr) ) ).

tff(addAssignment_10496,axiom,
    ! [VarCurr: state_type] :
      ( v20656(VarCurr)
    <=> v20571(VarCurr,1) ) ).

tff(addAssignment_10495,axiom,
    ! [VarCurr: state_type] :
      ( v20650(VarCurr)
    <=> v20652(VarCurr) ) ).

tff(addAssignment_10494,axiom,
    ! [VarCurr: state_type] :
      ( v20652(VarCurr)
    <=> v20571(VarCurr,0) ) ).

tff(addAssignment_10493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20624(VarCurr,B)
      <=> v20626(VarCurr,B) ) ) ).

tff(addAssignment_10492,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20626(VarCurr,B)
      <=> v20628(VarCurr,B) ) ) ).

tff(addAssignment_10491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20628(VarCurr,B)
      <=> v20630(VarCurr,B) ) ) ).

tff(addAssignment_10490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20630(VarCurr,B)
      <=> v20632(VarCurr,B) ) ) ).

tff(addAssignment_10489,axiom,
    ! [VarCurr: state_type] :
      ( v20598(VarCurr)
    <=> v20600(VarCurr) ) ).

tff(addAssignment_10488,axiom,
    ! [VarCurr: state_type] :
      ( v20600(VarCurr)
    <=> v20602(VarCurr) ) ).

tff(addAssignment_10487,axiom,
    ! [VarCurr: state_type] :
      ( v20602(VarCurr)
    <=> v20604(VarCurr) ) ).

tff(addAssignment_10486,axiom,
    ! [VarCurr: state_type] :
      ( v20604(VarCurr)
    <=> v20606(VarCurr) ) ).

tff(addAssignment_10485,axiom,
    ! [VarCurr: state_type] :
      ( v20606(VarCurr)
    <=> v20608(VarCurr) ) ).

tff(addAssignment_10484,axiom,
    ! [VarCurr: state_type] :
      ( v20608(VarCurr)
    <=> v20610(VarCurr) ) ).

tff(addAssignment_10483,axiom,
    ! [VarCurr: state_type] :
      ( v20610(VarCurr)
    <=> v20612(VarCurr) ) ).

tff(writeUnaryOperator_1143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20612(VarCurr)
    <=> v20622(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1685,axiom,
    ! [VarCurr: state_type] :
      ( v20622(VarCurr)
    <=> ( v20614(VarCurr)
        | v20618(VarCurr) ) ) ).

tff(addAssignment_10482,axiom,
    ! [VarCurr: state_type] :
      ( v20618(VarCurr)
    <=> v20620(VarCurr) ) ).

tff(addAssignment_10481,axiom,
    ! [VarCurr: state_type] :
      ( v20620(VarCurr)
    <=> v20571(VarCurr,1) ) ).

tff(addAssignment_10480,axiom,
    ! [VarCurr: state_type] :
      ( v20571(VarCurr,1)
    <=> v20573(VarCurr,1) ) ).

tff(addAssignment_10479,axiom,
    ! [VarCurr: state_type] :
      ( v20573(VarCurr,1)
    <=> v20575(VarCurr,1) ) ).

tff(addAssignment_10478,axiom,
    ! [VarCurr: state_type] :
      ( v20575(VarCurr,1)
    <=> v20580(VarCurr,1) ) ).

tff(addAssignment_10477,axiom,
    ! [VarCurr: state_type] :
      ( v20577(VarCurr,1)
    <=> v20579(VarCurr,1) ) ).

tff(addAssignment_10476,axiom,
    ! [VarCurr: state_type] :
      ( v20579(VarCurr,1)
    <=> v20523(VarCurr,1) ) ).

tff(addAssignment_10475,axiom,
    ! [VarCurr: state_type] :
      ( v20614(VarCurr)
    <=> v20616(VarCurr) ) ).

tff(addAssignment_10474,axiom,
    ! [VarCurr: state_type] :
      ( v20616(VarCurr)
    <=> v20523(VarCurr,0) ) ).

tff(addAssignment_10473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20588(VarCurr,B)
      <=> v20590(VarCurr,B) ) ) ).

tff(addAssignment_10472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20590(VarCurr,B)
      <=> v20592(VarCurr,B) ) ) ).

tff(addAssignment_10471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20592(VarCurr,B)
      <=> v20594(VarCurr,B) ) ) ).

tff(addAssignment_10470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20594(VarCurr,B)
      <=> v20596(VarCurr,B) ) ) ).

tff(addAssignment_10469,axiom,
    ! [VarCurr: state_type] :
      ( v20551(VarCurr)
    <=> v20553(VarCurr) ) ).

tff(addAssignment_10468,axiom,
    ! [VarCurr: state_type] :
      ( v20553(VarCurr)
    <=> v20555(VarCurr) ) ).

tff(addAssignment_10467,axiom,
    ! [VarCurr: state_type] :
      ( v20555(VarCurr)
    <=> v20557(VarCurr) ) ).

tff(addAssignment_10466,axiom,
    ! [VarCurr: state_type] :
      ( v20557(VarCurr)
    <=> v20559(VarCurr) ) ).

tff(addAssignment_10465,axiom,
    ! [VarCurr: state_type] :
      ( v20559(VarCurr)
    <=> v20561(VarCurr) ) ).

tff(addAssignment_10464,axiom,
    ! [VarCurr: state_type] :
      ( v20561(VarCurr)
    <=> v20563(VarCurr) ) ).

tff(addAssignment_10463,axiom,
    ! [VarCurr: state_type] :
      ( v20563(VarCurr)
    <=> v20565(VarCurr) ) ).

tff(writeUnaryOperator_1142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20565(VarCurr)
    <=> v20586(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1684,axiom,
    ! [VarCurr: state_type] :
      ( v20586(VarCurr)
    <=> ( v20567(VarCurr)
        | v20582(VarCurr) ) ) ).

tff(addAssignment_10462,axiom,
    ! [VarCurr: state_type] :
      ( v20582(VarCurr)
    <=> v20584(VarCurr) ) ).

tff(addAssignment_10461,axiom,
    ! [VarCurr: state_type] :
      ( v20584(VarCurr)
    <=> v20523(VarCurr,1) ) ).

tff(addAssignment_10460,axiom,
    ! [VarCurr: state_type] :
      ( v20567(VarCurr)
    <=> v20569(VarCurr) ) ).

tff(addAssignment_10459,axiom,
    ! [VarCurr: state_type] :
      ( v20569(VarCurr)
    <=> v20571(VarCurr,0) ) ).

tff(addAssignment_10458,axiom,
    ! [VarCurr: state_type] :
      ( v20571(VarCurr,0)
    <=> v20573(VarCurr,0) ) ).

tff(addAssignment_10457,axiom,
    ! [VarCurr: state_type] :
      ( v20573(VarCurr,0)
    <=> v20575(VarCurr,0) ) ).

tff(addAssignment_10456,axiom,
    ! [VarCurr: state_type] :
      ( v20575(VarCurr,0)
    <=> v20580(VarCurr,0) ) ).

tff(writeUnaryOperator_1141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v20580(VarCurr,B)
      <=> ~ v20577(VarCurr,B) ) ) ).

tff(addAssignment_10455,axiom,
    ! [VarCurr: state_type] :
      ( v20577(VarCurr,0)
    <=> v20579(VarCurr,0) ) ).

tff(addAssignment_10454,axiom,
    ! [VarCurr: state_type] :
      ( v20579(VarCurr,0)
    <=> v20523(VarCurr,0) ) ).

tff(addAssignment_10453,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20541(VarCurr,B)
      <=> v20543(VarCurr,B) ) ) ).

tff(addAssignment_10452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20543(VarCurr,B)
      <=> v20545(VarCurr,B) ) ) ).

tff(addAssignment_10451,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20545(VarCurr,B)
      <=> v20547(VarCurr,B) ) ) ).

tff(addAssignment_10450,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20547(VarCurr,B)
      <=> v20549(VarCurr,B) ) ) ).

tff(addAssignment_10449,axiom,
    ! [VarCurr: state_type] :
      ( v20503(VarCurr)
    <=> v20505(VarCurr) ) ).

tff(addAssignment_10448,axiom,
    ! [VarCurr: state_type] :
      ( v20505(VarCurr)
    <=> v20507(VarCurr) ) ).

tff(addAssignment_10447,axiom,
    ! [VarCurr: state_type] :
      ( v20507(VarCurr)
    <=> v20509(VarCurr) ) ).

tff(addAssignment_10446,axiom,
    ! [VarCurr: state_type] :
      ( v20509(VarCurr)
    <=> v20511(VarCurr) ) ).

tff(addAssignment_10445,axiom,
    ! [VarCurr: state_type] :
      ( v20511(VarCurr)
    <=> v20513(VarCurr) ) ).

tff(addAssignment_10444,axiom,
    ! [VarCurr: state_type] :
      ( v20513(VarCurr)
    <=> v20515(VarCurr) ) ).

tff(addAssignment_10443,axiom,
    ! [VarCurr: state_type] :
      ( v20515(VarCurr)
    <=> v20517(VarCurr) ) ).

tff(writeUnaryOperator_1140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20517(VarCurr)
    <=> v20539(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1683,axiom,
    ! [VarCurr: state_type] :
      ( v20539(VarCurr)
    <=> ( v20519(VarCurr)
        | v20535(VarCurr) ) ) ).

tff(addAssignment_10442,axiom,
    ! [VarCurr: state_type] :
      ( v20535(VarCurr)
    <=> v20537(VarCurr) ) ).

tff(addAssignment_10441,axiom,
    ! [VarCurr: state_type] :
      ( v20537(VarCurr)
    <=> v20523(VarCurr,1) ) ).

tff(addAssignment_10440,axiom,
    ! [VarCurr: state_type] :
      ( v20523(VarCurr,1)
    <=> v20525(VarCurr,1) ) ).

tff(addAssignment_10439,axiom,
    ! [VarCurr: state_type] :
      ( v20525(VarCurr,1)
    <=> v20527(VarCurr,1) ) ).

tff(addAssignment_10438,axiom,
    ! [VarCurr: state_type] :
      ( v20527(VarCurr,1)
    <=> v20529(VarCurr,1) ) ).

tff(addAssignment_10437,axiom,
    ! [VarCurr: state_type] :
      ( v20529(VarCurr,1)
    <=> v20531(VarCurr,1) ) ).

tff(addAssignment_10436,axiom,
    ! [VarCurr: state_type] :
      ( v20531(VarCurr,1)
    <=> v20533(VarCurr,1) ) ).

tff(addAssignment_10435,axiom,
    ! [VarCurr: state_type] :
      ( v20519(VarCurr)
    <=> v20521(VarCurr) ) ).

tff(addAssignment_10434,axiom,
    ! [VarCurr: state_type] :
      ( v20521(VarCurr)
    <=> v20523(VarCurr,0) ) ).

tff(addAssignment_10433,axiom,
    ! [VarCurr: state_type] :
      ( v20523(VarCurr,0)
    <=> v20525(VarCurr,0) ) ).

tff(addAssignment_10432,axiom,
    ! [VarCurr: state_type] :
      ( v20525(VarCurr,0)
    <=> v20527(VarCurr,0) ) ).

tff(addAssignment_10431,axiom,
    ! [VarCurr: state_type] :
      ( v20527(VarCurr,0)
    <=> v20529(VarCurr,0) ) ).

tff(addAssignment_10430,axiom,
    ! [VarCurr: state_type] :
      ( v20529(VarCurr,0)
    <=> v20531(VarCurr,0) ) ).

tff(addAssignment_10429,axiom,
    ! [VarCurr: state_type] :
      ( v20531(VarCurr,0)
    <=> v20533(VarCurr,0) ) ).

tff(addAssignment_10428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20493(VarCurr,B)
      <=> v20495(VarCurr,B) ) ) ).

tff(addAssignment_10427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20495(VarCurr,B)
      <=> v20497(VarCurr,B) ) ) ).

tff(addAssignment_10426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20497(VarCurr,B)
      <=> v20499(VarCurr,B) ) ) ).

tff(addAssignment_10425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20499(VarCurr,B)
      <=> v20501(VarCurr,B) ) ) ).

tff(addAssignment_10424,axiom,
    ! [VarCurr: state_type] :
      ( v20473(VarCurr)
    <=> v20475(VarCurr) ) ).

tff(addAssignment_10423,axiom,
    ! [VarCurr: state_type] :
      ( v20475(VarCurr)
    <=> v20477(VarCurr) ) ).

tff(addAssignment_10422,axiom,
    ! [VarCurr: state_type] :
      ( v20477(VarCurr)
    <=> v20479(VarCurr) ) ).

tff(addAssignment_10421,axiom,
    ! [VarCurr: state_type] :
      ( v20479(VarCurr)
    <=> v20481(VarCurr) ) ).

tff(addAssignment_10420,axiom,
    ! [VarCurr: state_type] :
      ( v20481(VarCurr)
    <=> v20483(VarCurr) ) ).

tff(addAssignment_10419,axiom,
    ! [VarCurr: state_type] :
      ( v20483(VarCurr)
    <=> v20485(VarCurr) ) ).

tff(addAssignment_10418,axiom,
    ! [VarCurr: state_type] :
      ( v20485(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_10417,axiom,
    ! [VarCurr: state_type] :
      ( v20459(VarCurr)
    <=> v20461(VarCurr) ) ).

tff(addAssignment_10416,axiom,
    ! [VarCurr: state_type] :
      ( v20461(VarCurr)
    <=> v20463(VarCurr) ) ).

tff(addAssignment_10415,axiom,
    ! [VarCurr: state_type] :
      ( v20463(VarCurr)
    <=> v20465(VarCurr) ) ).

tff(addAssignment_10414,axiom,
    ! [VarCurr: state_type] :
      ( v20465(VarCurr)
    <=> v20467(VarCurr) ) ).

tff(addAssignment_10413,axiom,
    ! [VarCurr: state_type] :
      ( v20467(VarCurr)
    <=> v20469(VarCurr) ) ).

tff(addAssignment_10412,axiom,
    ! [VarCurr: state_type] :
      ( v20469(VarCurr)
    <=> v20471(VarCurr) ) ).

tff(addAssignment_10411,axiom,
    ! [VarCurr: state_type] :
      ( v20471(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_10410,axiom,
    ! [VarCurr: state_type] :
      ( v20445(VarCurr)
    <=> v20447(VarCurr) ) ).

tff(addAssignment_10409,axiom,
    ! [VarCurr: state_type] :
      ( v20447(VarCurr)
    <=> v9490(VarCurr,7) ) ).

tff(addAssignment_10408,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,7)
    <=> v9492(VarCurr,7) ) ).

tff(addAssignment_10407,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,7)
    <=> v9494(VarCurr,7) ) ).

tff(addAssignment_10406,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,7)
    <=> v9570(VarCurr,7) ) ).

tff(addAssignment_10405,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,7)
    <=> v9513(VarCurr,7) ) ).

tff(addAssignment_10404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20441(VarCurr,B)
      <=> v20443(VarCurr,B) ) ) ).

tff(addAssignment_10403,axiom,
    ! [VarCurr: state_type] :
      ( ( v20443(VarCurr,11)
      <=> v9208(VarCurr,95) )
      & ( v20443(VarCurr,10)
      <=> v9208(VarCurr,94) )
      & ( v20443(VarCurr,9)
      <=> v9208(VarCurr,93) )
      & ( v20443(VarCurr,8)
      <=> v9208(VarCurr,92) )
      & ( v20443(VarCurr,7)
      <=> v9208(VarCurr,91) )
      & ( v20443(VarCurr,6)
      <=> v9208(VarCurr,90) )
      & ( v20443(VarCurr,5)
      <=> v9208(VarCurr,89) )
      & ( v20443(VarCurr,4)
      <=> v9208(VarCurr,88) )
      & ( v20443(VarCurr,3)
      <=> v9208(VarCurr,87) )
      & ( v20443(VarCurr,2)
      <=> v9208(VarCurr,86) )
      & ( v20443(VarCurr,1)
      <=> v9208(VarCurr,85) )
      & ( v20443(VarCurr,0)
      <=> v9208(VarCurr,84) ) ) ).

tff(addAssignment_10402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20409(VarCurr,B)
      <=> v20411(VarCurr,B) ) ) ).

tff(addAssignment_10401,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,0)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10400,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,1)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10399,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,2)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10398,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,3)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10397,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,4)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10396,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,5)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10395,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,6)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10394,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,7)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10393,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,8)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10392,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,9)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10391,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,10)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10390,axiom,
    ! [VarCurr: state_type] :
      ( v20411(VarCurr,11)
    <=> v20429(VarCurr) ) ).

tff(addAssignment_10389,axiom,
    ! [VarCurr: state_type] :
      ( v20429(VarCurr)
    <=> v20413(VarCurr) ) ).

tff(addAssignment_10388,axiom,
    ! [VarCurr: state_type] :
      ( v20413(VarCurr)
    <=> v20415(VarCurr,0) ) ).

tff(addAssignment_10387,axiom,
    ! [VarCurr: state_type] :
      ( v20415(VarCurr,0)
    <=> v20417(VarCurr,0) ) ).

tff(addAssignment_10386,axiom,
    ! [VarCurr: state_type] :
      ( v20417(VarCurr,0)
    <=> v20427(VarCurr,0) ) ).

tff(writeUnaryOperator_1139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v20427(VarCurr,B)
      <=> ~ v20419(VarCurr,B) ) ) ).

tff(addAssignment_10385,axiom,
    ! [VarCurr: state_type] :
      ( v20419(VarCurr,0)
    <=> v20421(VarCurr,0) ) ).

tff(addAssignment_10384,axiom,
    ! [VarCurr: state_type] :
      ( v20421(VarCurr,0)
    <=> v20424(VarCurr,0) ) ).

tff(addAssignment_10383,axiom,
    ! [VarCurr: state_type] :
      ( v20424(VarCurr,0)
    <=> v20423(VarCurr) ) ).

tff(addAssignment_10382,axiom,
    ! [VarCurr: state_type] :
      ( v20424(VarCurr,1)
    <=> v20426(VarCurr) ) ).

tff(addAssignment_10381,axiom,
    ! [VarCurr: state_type] :
      ( v20424(VarCurr,2)
    <=> v20425(VarCurr) ) ).

tff(addAssignment_10380,axiom,
    ! [VarCurr: state_type] :
      ( v20423(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_10379,axiom,
    ! [VarCurr: state_type] :
      ( v20385(VarCurr)
    <=> v20387(VarCurr) ) ).

tff(addAssignment_10378,axiom,
    ! [VarCurr: state_type] :
      ( v20387(VarCurr)
    <=> v20389(VarCurr) ) ).

tff(addAssignment_10377,axiom,
    ! [VarCurr: state_type] :
      ( v20389(VarCurr)
    <=> v20391(VarCurr) ) ).

tff(addAssignment_10376,axiom,
    ! [VarCurr: state_type] :
      ( v20391(VarCurr)
    <=> v20393(VarCurr) ) ).

tff(addAssignment_10375,axiom,
    ! [VarCurr: state_type] :
      ( v20393(VarCurr)
    <=> v20395(VarCurr) ) ).

tff(addAssignment_10374,axiom,
    ! [VarCurr: state_type] :
      ( v20395(VarCurr)
    <=> v20397(VarCurr) ) ).

tff(addAssignment_10373,axiom,
    ! [VarCurr: state_type] :
      ( v20397(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_10372,axiom,
    ! [VarCurr: state_type] :
      ( v20371(VarCurr)
    <=> v20373(VarCurr) ) ).

tff(addAssignment_10371,axiom,
    ! [VarCurr: state_type] :
      ( v20373(VarCurr)
    <=> v20375(VarCurr) ) ).

tff(addAssignment_10370,axiom,
    ! [VarCurr: state_type] :
      ( v20375(VarCurr)
    <=> v20377(VarCurr) ) ).

tff(addAssignment_10369,axiom,
    ! [VarCurr: state_type] :
      ( v20377(VarCurr)
    <=> v20379(VarCurr) ) ).

tff(addAssignment_10368,axiom,
    ! [VarCurr: state_type] :
      ( v20379(VarCurr)
    <=> v20381(VarCurr) ) ).

tff(addAssignment_10367,axiom,
    ! [VarCurr: state_type] :
      ( v20381(VarCurr)
    <=> v20383(VarCurr) ) ).

tff(addAssignment_10366,axiom,
    ! [VarCurr: state_type] :
      ( v20383(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_10365,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20347(VarCurr,B)
      <=> v20349(VarCurr,B) ) ) ).

tff(addAssignment_10364,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20349(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_10363,axiom,
    ! [VarCurr: state_type] :
      ( v18791(VarCurr)
    <=> v18793(VarCurr) ) ).

tff(addAssignment_10362,axiom,
    ! [VarCurr: state_type] :
      ( v18793(VarCurr)
    <=> v18795(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_92,axiom,
    ! [VarCurr: state_type] :
      ( v18795(VarCurr)
    <=> ( ( v18797(VarCurr,11)
        <=> v18801(VarCurr,11) )
        & ( v18797(VarCurr,10)
        <=> v18801(VarCurr,10) )
        & ( v18797(VarCurr,9)
        <=> v18801(VarCurr,9) )
        & ( v18797(VarCurr,8)
        <=> v18801(VarCurr,8) )
        & ( v18797(VarCurr,7)
        <=> v18801(VarCurr,7) )
        & ( v18797(VarCurr,6)
        <=> v18801(VarCurr,6) )
        & ( v18797(VarCurr,5)
        <=> v18801(VarCurr,5) )
        & ( v18797(VarCurr,4)
        <=> v18801(VarCurr,4) )
        & ( v18797(VarCurr,3)
        <=> v18801(VarCurr,3) )
        & ( v18797(VarCurr,2)
        <=> v18801(VarCurr,2) )
        & ( v18797(VarCurr,1)
        <=> v18801(VarCurr,1) )
        & ( v18797(VarCurr,0)
        <=> v18801(VarCurr,0) ) ) ) ).

tff(addAssignment_10361,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18801(VarCurr,B)
      <=> v18803(VarCurr,B) ) ) ).

tff(addAssignment_10360,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18803(VarCurr,B)
      <=> v18805(VarCurr,B) ) ) ).

tff(addAssignment_10359,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18805(VarCurr,B)
      <=> v18807(VarCurr,B) ) ) ).

tff(addAssignment_10358,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18807(VarCurr,B)
      <=> v18809(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18809(VarCurr,B)
      <=> ( v20317(VarCurr,B)
          | v20336(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20336(VarCurr,B)
      <=> ( v20188(VarCurr,B)
          & v20337(VarCurr,B) ) ) ) ).

tff(addAssignment_10357,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,0)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10356,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,1)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10355,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,2)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10354,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,3)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10353,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,4)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10352,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,5)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10351,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,6)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10350,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,7)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10349,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,8)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10348,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,9)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10347,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,10)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10346,axiom,
    ! [VarCurr: state_type] :
      ( v20337(VarCurr,11)
    <=> v20338(VarCurr) ) ).

tff(addAssignment_10345,axiom,
    ! [VarCurr: state_type] :
      ( v20338(VarCurr)
    <=> v20307(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_341,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20317(VarCurr,B)
      <=> ( v20318(VarCurr,B)
          | v20333(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_340,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20333(VarCurr,B)
      <=> ( v20037(VarCurr,B)
          & v20334(VarCurr,B) ) ) ) ).

tff(addAssignment_10344,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,0)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10343,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,1)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10342,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,2)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10341,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,3)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10340,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,4)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10339,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,5)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10338,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,6)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10337,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,7)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10336,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,8)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10335,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,9)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10334,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,10)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10333,axiom,
    ! [VarCurr: state_type] :
      ( v20334(VarCurr,11)
    <=> v20335(VarCurr) ) ).

tff(addAssignment_10332,axiom,
    ! [VarCurr: state_type] :
      ( v20335(VarCurr)
    <=> v20157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_339,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20318(VarCurr,B)
      <=> ( v20319(VarCurr,B)
          | v20330(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20330(VarCurr,B)
      <=> ( v19886(VarCurr,B)
          & v20331(VarCurr,B) ) ) ) ).

tff(addAssignment_10331,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,0)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10330,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,1)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10329,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,2)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10328,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,3)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10327,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,4)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10326,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,5)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10325,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,6)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10324,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,7)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10323,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,8)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10322,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,9)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10321,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,10)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10320,axiom,
    ! [VarCurr: state_type] :
      ( v20331(VarCurr,11)
    <=> v20332(VarCurr) ) ).

tff(addAssignment_10319,axiom,
    ! [VarCurr: state_type] :
      ( v20332(VarCurr)
    <=> v20006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_337,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20319(VarCurr,B)
      <=> ( v20320(VarCurr,B)
          | v20327(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_336,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20327(VarCurr,B)
      <=> ( v19735(VarCurr,B)
          & v20328(VarCurr,B) ) ) ) ).

tff(addAssignment_10318,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,0)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10317,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,1)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10316,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,2)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10315,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,3)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10314,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,4)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10313,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,5)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10312,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,6)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10311,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,7)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10310,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,8)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10309,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,9)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10308,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,10)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10307,axiom,
    ! [VarCurr: state_type] :
      ( v20328(VarCurr,11)
    <=> v20329(VarCurr) ) ).

tff(addAssignment_10306,axiom,
    ! [VarCurr: state_type] :
      ( v20329(VarCurr)
    <=> v19855(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_335,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20320(VarCurr,B)
      <=> ( v20321(VarCurr,B)
          | v20324(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_334,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20324(VarCurr,B)
      <=> ( v19573(VarCurr,B)
          & v20325(VarCurr,B) ) ) ) ).

tff(addAssignment_10305,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,0)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10304,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,1)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10303,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,2)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10302,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,3)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10301,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,4)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10300,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,5)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10299,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,6)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10298,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,7)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10297,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,8)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10296,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,9)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10295,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,10)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10294,axiom,
    ! [VarCurr: state_type] :
      ( v20325(VarCurr,11)
    <=> v20326(VarCurr) ) ).

tff(addAssignment_10293,axiom,
    ! [VarCurr: state_type] :
      ( v20326(VarCurr)
    <=> v19704(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_333,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20321(VarCurr,B)
      <=> ( v18811(VarCurr,B)
          & v20322(VarCurr,B) ) ) ) ).

tff(addAssignment_10292,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,0)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10291,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,1)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10290,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,2)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10289,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,3)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10288,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,4)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10287,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,5)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10286,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,6)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10285,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,7)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10284,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,8)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10283,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,9)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10282,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,10)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10281,axiom,
    ! [VarCurr: state_type] :
      ( v20322(VarCurr,11)
    <=> v20323(VarCurr) ) ).

tff(addAssignment_10280,axiom,
    ! [VarCurr: state_type] :
      ( v20323(VarCurr)
    <=> v19281(VarCurr) ) ).

tff(addAssignment_10279,axiom,
    ! [VarCurr: state_type] :
      ( v20307(VarCurr)
    <=> v20309(VarCurr) ) ).

tff(addAssignment_10278,axiom,
    ! [VarCurr: state_type] :
      ( v20309(VarCurr)
    <=> v20311(VarCurr) ) ).

tff(addAssignment_10277,axiom,
    ! [VarCurr: state_type] :
      ( v20311(VarCurr)
    <=> v20313(VarCurr) ) ).

tff(addAssignment_10276,axiom,
    ! [VarCurr: state_type] :
      ( v20313(VarCurr)
    <=> v20315(VarCurr) ) ).

tff(addAssignment_10275,axiom,
    ! [VarCurr: state_type] :
      ( v20315(VarCurr)
    <=> v19374(VarCurr) ) ).

tff(addAssignment_10274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20188(VarCurr,B)
      <=> v20190(VarCurr,B) ) ) ).

tff(addAssignment_10273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20190(VarCurr,B)
      <=> v20192(VarCurr,B) ) ) ).

tff(addAssignment_10272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20192(VarCurr,B)
      <=> v20194(VarCurr,B) ) ) ).

tff(addAssignment_10271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20194(VarCurr,B)
      <=> v20196(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_231,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20290(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v20196(VarNext,B)
            <=> v20196(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_231,axiom,
    ! [VarNext: state_type] :
      ( v20290(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20196(VarNext,B)
          <=> v20300(VarNext,B) ) ) ) ).

tff(addAssignment_10270,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20300(VarNext,B)
          <=> v20298(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20298(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_151,axiom,
    ! [VarCurr: state_type] :
      ( v20301(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20298(VarCurr,B)
          <=> v20218(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1682,axiom,
    ! [VarCurr: state_type] :
      ( v20301(VarCurr)
    <=> ( v20302(VarCurr)
        & v20303(VarCurr) ) ) ).

tff(writeUnaryOperator_1138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20303(VarCurr)
    <=> v20208(VarCurr) ) ).

tff(writeUnaryOperator_1137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20302(VarCurr)
    <=> v20198(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1681,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20290(VarNext)
      <=> v20291(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20291(VarNext)
      <=> ( v20292(VarNext)
          & v20222(VarNext) ) ) ) ).

tff(writeUnaryOperator_1136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20292(VarNext)
      <=> v20294(VarNext) ) ) ).

tff(addAssignment_10269,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20294(VarNext)
      <=> v20222(VarCurr) ) ) ).

tff(addAssignment_10268,axiom,
    ! [VarCurr: state_type] :
      ( v20222(VarCurr)
    <=> v20224(VarCurr) ) ).

tff(addAssignment_10267,axiom,
    ! [VarCurr: state_type] :
      ( v20224(VarCurr)
    <=> v20226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1679,axiom,
    ! [VarCurr: state_type] :
      ( v20226(VarCurr)
    <=> ( v20287(VarCurr)
        | v20283(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1678,axiom,
    ! [VarCurr: state_type] :
      ( v20287(VarCurr)
    <=> ( v20228(VarCurr)
        & v20232(VarCurr) ) ) ).

tff(addAssignment_10266,axiom,
    ! [VarCurr: state_type] :
      ( v20283(VarCurr)
    <=> v20285(VarCurr) ) ).

tff(addAssignment_10265,axiom,
    ! [VarCurr: state_type] :
      ( v20285(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20267(VarNext)
       => ( v20232(VarNext)
        <=> v20232(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_230,axiom,
    ! [VarNext: state_type] :
      ( v20267(VarNext)
     => ( v20232(VarNext)
      <=> v20277(VarNext) ) ) ).

tff(addAssignment_10264,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20277(VarNext)
      <=> v20275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1677,axiom,
    ! [VarCurr: state_type] :
      ( v20275(VarCurr)
    <=> ( v20278(VarCurr)
        & v20279(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1676,axiom,
    ! [VarCurr: state_type] :
      ( v20279(VarCurr)
    <=> ( v20238(VarCurr)
        | v20262(VarCurr) ) ) ).

tff(writeUnaryOperator_1135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20278(VarCurr)
    <=> v20234(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20267(VarNext)
      <=> v20268(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20268(VarNext)
      <=> ( v20270(VarNext)
          & v20272(VarNext) ) ) ) ).

tff(writeUnaryOperator_1134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20272(VarCurr)
    <=> v20228(VarCurr) ) ).

tff(addAssignment_10263,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20270(VarNext)
      <=> v20228(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_80,axiom,
    ( v20232(constB0)
  <=> $true ) ).

tff(addAssignment_10262,axiom,
    ! [VarCurr: state_type] :
      ( v20262(VarCurr)
    <=> v20264(VarCurr) ) ).

tff(addAssignment_10261,axiom,
    ! [VarCurr: state_type] :
      ( v20264(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_10260,axiom,
    ! [VarCurr: state_type] :
      ( v20238(VarCurr)
    <=> v20240(VarCurr) ) ).

tff(addAssignment_10259,axiom,
    ! [VarCurr: state_type] :
      ( v20240(VarCurr)
    <=> v19548(VarCurr) ) ).

tff(addAssignment_10258,axiom,
    ! [VarCurr: state_type] :
      ( v19548(VarCurr)
    <=> v20243(VarCurr) ) ).

tff(addAssignment_10257,axiom,
    ! [VarCurr: state_type] :
      ( v20243(VarCurr)
    <=> v20245(VarCurr) ) ).

tff(writeUnaryOperator_1133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20245(VarCurr)
    <=> v20259(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1673,axiom,
    ! [VarCurr: state_type] :
      ( v20259(VarCurr)
    <=> ( v20260(VarCurr)
        | v20255(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1672,axiom,
    ! [VarCurr: state_type] :
      ( v20260(VarCurr)
    <=> ( v20247(VarCurr)
        | v20251(VarCurr) ) ) ).

tff(addAssignment_10256,axiom,
    ! [VarCurr: state_type] :
      ( v20255(VarCurr)
    <=> v20257(VarCurr) ) ).

tff(addAssignment_10255,axiom,
    ! [VarCurr: state_type] :
      ( v20257(VarCurr)
    <=> v19637(VarCurr,2) ) ).

tff(addAssignment_10254,axiom,
    ! [VarCurr: state_type] :
      ( v20251(VarCurr)
    <=> v20253(VarCurr) ) ).

tff(addAssignment_10253,axiom,
    ! [VarCurr: state_type] :
      ( v20253(VarCurr)
    <=> v19211(VarCurr,1) ) ).

tff(addAssignment_10252,axiom,
    ! [VarCurr: state_type] :
      ( v20247(VarCurr)
    <=> v20249(VarCurr) ) ).

tff(addAssignment_10251,axiom,
    ! [VarCurr: state_type] :
      ( v20249(VarCurr)
    <=> v19637(VarCurr,0) ) ).

tff(addAssignment_10250,axiom,
    ! [VarCurr: state_type] :
      ( v20234(VarCurr)
    <=> v20236(VarCurr) ) ).

tff(addAssignment_10249,axiom,
    ! [VarCurr: state_type] :
      ( v20236(VarCurr)
    <=> $false ) ).

tff(addAssignment_10248,axiom,
    ! [VarCurr: state_type] :
      ( v20228(VarCurr)
    <=> v20230(VarCurr) ) ).

tff(addAssignment_10247,axiom,
    ! [VarCurr: state_type] :
      ( v20230(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_10246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20218(VarCurr,B)
      <=> v20220(VarCurr,B) ) ) ).

tff(addAssignment_10245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20220(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_10244,axiom,
    ! [VarCurr: state_type] :
      ( v20208(VarCurr)
    <=> v20210(VarCurr) ) ).

tff(addAssignment_10243,axiom,
    ! [VarCurr: state_type] :
      ( v20210(VarCurr)
    <=> v20212(VarCurr) ) ).

tff(addAssignment_10242,axiom,
    ! [VarCurr: state_type] :
      ( v20212(VarCurr)
    <=> v20214(VarCurr) ) ).

tff(addAssignment_10241,axiom,
    ! [VarCurr: state_type] :
      ( v20214(VarCurr)
    <=> v20216(VarCurr) ) ).

tff(addAssignment_10240,axiom,
    ! [VarCurr: state_type] :
      ( v20216(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_10239,axiom,
    ! [VarCurr: state_type] :
      ( v20198(VarCurr)
    <=> v20200(VarCurr) ) ).

tff(addAssignment_10238,axiom,
    ! [VarCurr: state_type] :
      ( v20200(VarCurr)
    <=> v20202(VarCurr) ) ).

tff(addAssignment_10237,axiom,
    ! [VarCurr: state_type] :
      ( v20202(VarCurr)
    <=> v20204(VarCurr) ) ).

tff(addAssignment_10236,axiom,
    ! [VarCurr: state_type] :
      ( v20204(VarCurr)
    <=> v20206(VarCurr) ) ).

tff(addAssignment_10235,axiom,
    ! [VarCurr: state_type] :
      ( v20206(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_10234,axiom,
    ! [VarCurr: state_type] :
      ( v20157(VarCurr)
    <=> v20159(VarCurr) ) ).

tff(addAssignment_10233,axiom,
    ! [VarCurr: state_type] :
      ( v20159(VarCurr)
    <=> v20161(VarCurr) ) ).

tff(addAssignment_10232,axiom,
    ! [VarCurr: state_type] :
      ( v20161(VarCurr)
    <=> v20163(VarCurr) ) ).

tff(addAssignment_10231,axiom,
    ! [VarCurr: state_type] :
      ( v20163(VarCurr)
    <=> v20165(VarCurr) ) ).

tff(addAssignment_10230,axiom,
    ! [VarCurr: state_type] :
      ( v20165(VarCurr)
    <=> v20167(VarCurr) ) ).

tff(addAssignment_10229,axiom,
    ! [VarCurr: state_type] :
      ( v20167(VarCurr)
    <=> v20169(VarCurr) ) ).

tff(addAssignment_10228,axiom,
    ! [VarCurr: state_type] :
      ( v20169(VarCurr)
    <=> v20171(VarCurr) ) ).

tff(writeUnaryOperator_1132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20171(VarCurr)
    <=> v20185(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1671,axiom,
    ! [VarCurr: state_type] :
      ( v20185(VarCurr)
    <=> ( v20186(VarCurr)
        | v20181(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1670,axiom,
    ! [VarCurr: state_type] :
      ( v20186(VarCurr)
    <=> ( v20173(VarCurr)
        | v20177(VarCurr) ) ) ).

tff(addAssignment_10227,axiom,
    ! [VarCurr: state_type] :
      ( v20181(VarCurr)
    <=> v20183(VarCurr) ) ).

tff(addAssignment_10226,axiom,
    ! [VarCurr: state_type] :
      ( v20183(VarCurr)
    <=> v19384(VarCurr,2) ) ).

tff(addAssignment_10225,axiom,
    ! [VarCurr: state_type] :
      ( v20177(VarCurr)
    <=> v20179(VarCurr) ) ).

tff(addAssignment_10224,axiom,
    ! [VarCurr: state_type] :
      ( v20179(VarCurr)
    <=> v19301(VarCurr,1) ) ).

tff(addAssignment_10223,axiom,
    ! [VarCurr: state_type] :
      ( v20173(VarCurr)
    <=> v20175(VarCurr) ) ).

tff(addAssignment_10222,axiom,
    ! [VarCurr: state_type] :
      ( v20175(VarCurr)
    <=> v19301(VarCurr,0) ) ).

tff(addAssignment_10221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20037(VarCurr,B)
      <=> v20039(VarCurr,B) ) ) ).

tff(addAssignment_10220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20039(VarCurr,B)
      <=> v20041(VarCurr,B) ) ) ).

tff(addAssignment_10219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20041(VarCurr,B)
      <=> v20043(VarCurr,B) ) ) ).

tff(addAssignment_10218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20043(VarCurr,B)
      <=> v20045(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20140(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v20045(VarNext,B)
            <=> v20045(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_229,axiom,
    ! [VarNext: state_type] :
      ( v20140(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20045(VarNext,B)
          <=> v20150(VarNext,B) ) ) ) ).

tff(addAssignment_10217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20150(VarNext,B)
          <=> v20148(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20151(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20148(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_150,axiom,
    ! [VarCurr: state_type] :
      ( v20151(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v20148(VarCurr,B)
          <=> v20067(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1669,axiom,
    ! [VarCurr: state_type] :
      ( v20151(VarCurr)
    <=> ( v20152(VarCurr)
        & v20153(VarCurr) ) ) ).

tff(writeUnaryOperator_1131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20153(VarCurr)
    <=> v20057(VarCurr) ) ).

tff(writeUnaryOperator_1130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20152(VarCurr)
    <=> v20047(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1668,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20140(VarNext)
      <=> v20141(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1667,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20141(VarNext)
      <=> ( v20142(VarNext)
          & v20071(VarNext) ) ) ) ).

tff(writeUnaryOperator_1129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20142(VarNext)
      <=> v20144(VarNext) ) ) ).

tff(addAssignment_10216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20144(VarNext)
      <=> v20071(VarCurr) ) ) ).

tff(addAssignment_10215,axiom,
    ! [VarCurr: state_type] :
      ( v20071(VarCurr)
    <=> v20073(VarCurr) ) ).

tff(addAssignment_10214,axiom,
    ! [VarCurr: state_type] :
      ( v20073(VarCurr)
    <=> v20075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1666,axiom,
    ! [VarCurr: state_type] :
      ( v20075(VarCurr)
    <=> ( v20137(VarCurr)
        | v20133(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1665,axiom,
    ! [VarCurr: state_type] :
      ( v20137(VarCurr)
    <=> ( v20077(VarCurr)
        & v20081(VarCurr) ) ) ).

tff(addAssignment_10213,axiom,
    ! [VarCurr: state_type] :
      ( v20133(VarCurr)
    <=> v20135(VarCurr) ) ).

tff(addAssignment_10212,axiom,
    ! [VarCurr: state_type] :
      ( v20135(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v20117(VarNext)
       => ( v20081(VarNext)
        <=> v20081(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_228,axiom,
    ! [VarNext: state_type] :
      ( v20117(VarNext)
     => ( v20081(VarNext)
      <=> v20127(VarNext) ) ) ).

tff(addAssignment_10211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20127(VarNext)
      <=> v20125(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1664,axiom,
    ! [VarCurr: state_type] :
      ( v20125(VarCurr)
    <=> ( v20128(VarCurr)
        & v20129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1663,axiom,
    ! [VarCurr: state_type] :
      ( v20129(VarCurr)
    <=> ( v20087(VarCurr)
        | v20112(VarCurr) ) ) ).

tff(writeUnaryOperator_1128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20128(VarCurr)
    <=> v20083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1662,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20117(VarNext)
      <=> v20118(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20118(VarNext)
      <=> ( v20120(VarNext)
          & v20122(VarNext) ) ) ) ).

tff(writeUnaryOperator_1127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20122(VarCurr)
    <=> v20077(VarCurr) ) ).

tff(addAssignment_10210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v20120(VarNext)
      <=> v20077(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_79,axiom,
    ( v20081(constB0)
  <=> $true ) ).

tff(addAssignment_10209,axiom,
    ! [VarCurr: state_type] :
      ( v20112(VarCurr)
    <=> v20114(VarCurr) ) ).

tff(addAssignment_10208,axiom,
    ! [VarCurr: state_type] :
      ( v20114(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_10207,axiom,
    ! [VarCurr: state_type] :
      ( v20087(VarCurr)
    <=> v20089(VarCurr) ) ).

tff(addAssignment_10206,axiom,
    ! [VarCurr: state_type] :
      ( v20089(VarCurr)
    <=> v20091(VarCurr) ) ).

tff(addAssignment_10205,axiom,
    ! [VarCurr: state_type] :
      ( v20091(VarCurr)
    <=> v20093(VarCurr) ) ).

tff(addAssignment_10204,axiom,
    ! [VarCurr: state_type] :
      ( v20093(VarCurr)
    <=> v20095(VarCurr) ) ).

tff(writeUnaryOperator_1126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20095(VarCurr)
    <=> v20109(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1660,axiom,
    ! [VarCurr: state_type] :
      ( v20109(VarCurr)
    <=> ( v20110(VarCurr)
        | v20105(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1659,axiom,
    ! [VarCurr: state_type] :
      ( v20110(VarCurr)
    <=> ( v20097(VarCurr)
        | v20101(VarCurr) ) ) ).

tff(addAssignment_10203,axiom,
    ! [VarCurr: state_type] :
      ( v20105(VarCurr)
    <=> v20107(VarCurr) ) ).

tff(addAssignment_10202,axiom,
    ! [VarCurr: state_type] :
      ( v20107(VarCurr)
    <=> v19637(VarCurr,2) ) ).

tff(addAssignment_10201,axiom,
    ! [VarCurr: state_type] :
      ( v19637(VarCurr,2)
    <=> v19639(VarCurr,2) ) ).

tff(addAssignment_10200,axiom,
    ! [VarCurr: state_type] :
      ( v19639(VarCurr,2)
    <=> v19641(VarCurr,2) ) ).

tff(addAssignment_10199,axiom,
    ! [VarCurr: state_type] :
      ( v19641(VarCurr,2)
    <=> v19646(VarCurr,2) ) ).

tff(addAssignment_10198,axiom,
    ! [VarCurr: state_type] :
      ( v19643(VarCurr,2)
    <=> v19645(VarCurr,2) ) ).

tff(addAssignment_10197,axiom,
    ! [VarCurr: state_type] :
      ( v19645(VarCurr,2)
    <=> v19211(VarCurr,2) ) ).

tff(addAssignment_10196,axiom,
    ! [VarCurr: state_type] :
      ( v20101(VarCurr)
    <=> v20103(VarCurr) ) ).

tff(addAssignment_10195,axiom,
    ! [VarCurr: state_type] :
      ( v20103(VarCurr)
    <=> v19211(VarCurr,1) ) ).

tff(addAssignment_10194,axiom,
    ! [VarCurr: state_type] :
      ( v20097(VarCurr)
    <=> v20099(VarCurr) ) ).

tff(addAssignment_10193,axiom,
    ! [VarCurr: state_type] :
      ( v20099(VarCurr)
    <=> v19211(VarCurr,0) ) ).

tff(addAssignment_10192,axiom,
    ! [VarCurr: state_type] :
      ( v20083(VarCurr)
    <=> v20085(VarCurr) ) ).

tff(addAssignment_10191,axiom,
    ! [VarCurr: state_type] :
      ( v20085(VarCurr)
    <=> $false ) ).

tff(addAssignment_10190,axiom,
    ! [VarCurr: state_type] :
      ( v20077(VarCurr)
    <=> v20079(VarCurr) ) ).

tff(addAssignment_10189,axiom,
    ! [VarCurr: state_type] :
      ( v20079(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_10188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20067(VarCurr,B)
      <=> v20069(VarCurr,B) ) ) ).

tff(addAssignment_10187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v20069(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_10186,axiom,
    ! [VarCurr: state_type] :
      ( v20057(VarCurr)
    <=> v20059(VarCurr) ) ).

tff(addAssignment_10185,axiom,
    ! [VarCurr: state_type] :
      ( v20059(VarCurr)
    <=> v20061(VarCurr) ) ).

tff(addAssignment_10184,axiom,
    ! [VarCurr: state_type] :
      ( v20061(VarCurr)
    <=> v20063(VarCurr) ) ).

tff(addAssignment_10183,axiom,
    ! [VarCurr: state_type] :
      ( v20063(VarCurr)
    <=> v20065(VarCurr) ) ).

tff(addAssignment_10182,axiom,
    ! [VarCurr: state_type] :
      ( v20065(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_10181,axiom,
    ! [VarCurr: state_type] :
      ( v20047(VarCurr)
    <=> v20049(VarCurr) ) ).

tff(addAssignment_10180,axiom,
    ! [VarCurr: state_type] :
      ( v20049(VarCurr)
    <=> v20051(VarCurr) ) ).

tff(addAssignment_10179,axiom,
    ! [VarCurr: state_type] :
      ( v20051(VarCurr)
    <=> v20053(VarCurr) ) ).

tff(addAssignment_10178,axiom,
    ! [VarCurr: state_type] :
      ( v20053(VarCurr)
    <=> v20055(VarCurr) ) ).

tff(addAssignment_10177,axiom,
    ! [VarCurr: state_type] :
      ( v20055(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_10176,axiom,
    ! [VarCurr: state_type] :
      ( v20006(VarCurr)
    <=> v20008(VarCurr) ) ).

tff(addAssignment_10175,axiom,
    ! [VarCurr: state_type] :
      ( v20008(VarCurr)
    <=> v20010(VarCurr) ) ).

tff(addAssignment_10174,axiom,
    ! [VarCurr: state_type] :
      ( v20010(VarCurr)
    <=> v20012(VarCurr) ) ).

tff(addAssignment_10173,axiom,
    ! [VarCurr: state_type] :
      ( v20012(VarCurr)
    <=> v20014(VarCurr) ) ).

tff(addAssignment_10172,axiom,
    ! [VarCurr: state_type] :
      ( v20014(VarCurr)
    <=> v20016(VarCurr) ) ).

tff(addAssignment_10171,axiom,
    ! [VarCurr: state_type] :
      ( v20016(VarCurr)
    <=> v20018(VarCurr) ) ).

tff(addAssignment_10170,axiom,
    ! [VarCurr: state_type] :
      ( v20018(VarCurr)
    <=> v20020(VarCurr) ) ).

tff(writeUnaryOperator_1125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20020(VarCurr)
    <=> v20034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1658,axiom,
    ! [VarCurr: state_type] :
      ( v20034(VarCurr)
    <=> ( v20035(VarCurr)
        | v20030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1657,axiom,
    ! [VarCurr: state_type] :
      ( v20035(VarCurr)
    <=> ( v20022(VarCurr)
        | v20026(VarCurr) ) ) ).

tff(addAssignment_10169,axiom,
    ! [VarCurr: state_type] :
      ( v20030(VarCurr)
    <=> v20032(VarCurr) ) ).

tff(addAssignment_10168,axiom,
    ! [VarCurr: state_type] :
      ( v20032(VarCurr)
    <=> v19301(VarCurr,2) ) ).

tff(addAssignment_10167,axiom,
    ! [VarCurr: state_type] :
      ( v20026(VarCurr)
    <=> v20028(VarCurr) ) ).

tff(addAssignment_10166,axiom,
    ! [VarCurr: state_type] :
      ( v20028(VarCurr)
    <=> v19384(VarCurr,1) ) ).

tff(addAssignment_10165,axiom,
    ! [VarCurr: state_type] :
      ( v20022(VarCurr)
    <=> v20024(VarCurr) ) ).

tff(addAssignment_10164,axiom,
    ! [VarCurr: state_type] :
      ( v20024(VarCurr)
    <=> v19384(VarCurr,0) ) ).

tff(addAssignment_10163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19886(VarCurr,B)
      <=> v19888(VarCurr,B) ) ) ).

tff(addAssignment_10162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19888(VarCurr,B)
      <=> v19890(VarCurr,B) ) ) ).

tff(addAssignment_10161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19890(VarCurr,B)
      <=> v19892(VarCurr,B) ) ) ).

tff(addAssignment_10160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19892(VarCurr,B)
      <=> v19894(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19989(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v19894(VarNext,B)
            <=> v19894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_227,axiom,
    ! [VarNext: state_type] :
      ( v19989(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19894(VarNext,B)
          <=> v19999(VarNext,B) ) ) ) ).

tff(addAssignment_10159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19999(VarNext,B)
          <=> v19997(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20000(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19997(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_149,axiom,
    ! [VarCurr: state_type] :
      ( v20000(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19997(VarCurr,B)
          <=> v19916(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1656,axiom,
    ! [VarCurr: state_type] :
      ( v20000(VarCurr)
    <=> ( v20001(VarCurr)
        & v20002(VarCurr) ) ) ).

tff(writeUnaryOperator_1124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20002(VarCurr)
    <=> v19906(VarCurr) ) ).

tff(writeUnaryOperator_1123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v20001(VarCurr)
    <=> v19896(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19989(VarNext)
      <=> v19990(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19990(VarNext)
      <=> ( v19991(VarNext)
          & v19920(VarNext) ) ) ) ).

tff(writeUnaryOperator_1122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19991(VarNext)
      <=> v19993(VarNext) ) ) ).

tff(addAssignment_10158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19993(VarNext)
      <=> v19920(VarCurr) ) ) ).

tff(addAssignment_10157,axiom,
    ! [VarCurr: state_type] :
      ( v19920(VarCurr)
    <=> v19922(VarCurr) ) ).

tff(addAssignment_10156,axiom,
    ! [VarCurr: state_type] :
      ( v19922(VarCurr)
    <=> v19924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1653,axiom,
    ! [VarCurr: state_type] :
      ( v19924(VarCurr)
    <=> ( v19986(VarCurr)
        | v19982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1652,axiom,
    ! [VarCurr: state_type] :
      ( v19986(VarCurr)
    <=> ( v19926(VarCurr)
        & v19930(VarCurr) ) ) ).

tff(addAssignment_10155,axiom,
    ! [VarCurr: state_type] :
      ( v19982(VarCurr)
    <=> v19984(VarCurr) ) ).

tff(addAssignment_10154,axiom,
    ! [VarCurr: state_type] :
      ( v19984(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19966(VarNext)
       => ( v19930(VarNext)
        <=> v19930(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_226,axiom,
    ! [VarNext: state_type] :
      ( v19966(VarNext)
     => ( v19930(VarNext)
      <=> v19976(VarNext) ) ) ).

tff(addAssignment_10153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19976(VarNext)
      <=> v19974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1651,axiom,
    ! [VarCurr: state_type] :
      ( v19974(VarCurr)
    <=> ( v19977(VarCurr)
        & v19978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1650,axiom,
    ! [VarCurr: state_type] :
      ( v19978(VarCurr)
    <=> ( v19936(VarCurr)
        | v19961(VarCurr) ) ) ).

tff(writeUnaryOperator_1121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19977(VarCurr)
    <=> v19932(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19966(VarNext)
      <=> v19967(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19967(VarNext)
      <=> ( v19969(VarNext)
          & v19971(VarNext) ) ) ) ).

tff(writeUnaryOperator_1120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19971(VarCurr)
    <=> v19926(VarCurr) ) ).

tff(addAssignment_10152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19969(VarNext)
      <=> v19926(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_78,axiom,
    ( v19930(constB0)
  <=> $true ) ).

tff(addAssignment_10151,axiom,
    ! [VarCurr: state_type] :
      ( v19961(VarCurr)
    <=> v19963(VarCurr) ) ).

tff(addAssignment_10150,axiom,
    ! [VarCurr: state_type] :
      ( v19963(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_10149,axiom,
    ! [VarCurr: state_type] :
      ( v19936(VarCurr)
    <=> v19938(VarCurr) ) ).

tff(addAssignment_10148,axiom,
    ! [VarCurr: state_type] :
      ( v19938(VarCurr)
    <=> v19940(VarCurr) ) ).

tff(addAssignment_10147,axiom,
    ! [VarCurr: state_type] :
      ( v19940(VarCurr)
    <=> v19942(VarCurr) ) ).

tff(addAssignment_10146,axiom,
    ! [VarCurr: state_type] :
      ( v19942(VarCurr)
    <=> v19944(VarCurr) ) ).

tff(writeUnaryOperator_1119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19944(VarCurr)
    <=> v19958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1647,axiom,
    ! [VarCurr: state_type] :
      ( v19958(VarCurr)
    <=> ( v19959(VarCurr)
        | v19954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1646,axiom,
    ! [VarCurr: state_type] :
      ( v19959(VarCurr)
    <=> ( v19946(VarCurr)
        | v19950(VarCurr) ) ) ).

tff(addAssignment_10145,axiom,
    ! [VarCurr: state_type] :
      ( v19954(VarCurr)
    <=> v19956(VarCurr) ) ).

tff(addAssignment_10144,axiom,
    ! [VarCurr: state_type] :
      ( v19956(VarCurr)
    <=> v19211(VarCurr,2) ) ).

tff(addAssignment_10143,axiom,
    ! [VarCurr: state_type] :
      ( v19950(VarCurr)
    <=> v19952(VarCurr) ) ).

tff(addAssignment_10142,axiom,
    ! [VarCurr: state_type] :
      ( v19952(VarCurr)
    <=> v19637(VarCurr,1) ) ).

tff(addAssignment_10141,axiom,
    ! [VarCurr: state_type] :
      ( v19946(VarCurr)
    <=> v19948(VarCurr) ) ).

tff(addAssignment_10140,axiom,
    ! [VarCurr: state_type] :
      ( v19948(VarCurr)
    <=> v19637(VarCurr,0) ) ).

tff(addAssignment_10139,axiom,
    ! [VarCurr: state_type] :
      ( v19932(VarCurr)
    <=> v19934(VarCurr) ) ).

tff(addAssignment_10138,axiom,
    ! [VarCurr: state_type] :
      ( v19934(VarCurr)
    <=> $false ) ).

tff(addAssignment_10137,axiom,
    ! [VarCurr: state_type] :
      ( v19926(VarCurr)
    <=> v19928(VarCurr) ) ).

tff(addAssignment_10136,axiom,
    ! [VarCurr: state_type] :
      ( v19928(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_10135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19916(VarCurr,B)
      <=> v19918(VarCurr,B) ) ) ).

tff(addAssignment_10134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19918(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_10133,axiom,
    ! [VarCurr: state_type] :
      ( v19906(VarCurr)
    <=> v19908(VarCurr) ) ).

tff(addAssignment_10132,axiom,
    ! [VarCurr: state_type] :
      ( v19908(VarCurr)
    <=> v19910(VarCurr) ) ).

tff(addAssignment_10131,axiom,
    ! [VarCurr: state_type] :
      ( v19910(VarCurr)
    <=> v19912(VarCurr) ) ).

tff(addAssignment_10130,axiom,
    ! [VarCurr: state_type] :
      ( v19912(VarCurr)
    <=> v19914(VarCurr) ) ).

tff(addAssignment_10129,axiom,
    ! [VarCurr: state_type] :
      ( v19914(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_10128,axiom,
    ! [VarCurr: state_type] :
      ( v19896(VarCurr)
    <=> v19898(VarCurr) ) ).

tff(addAssignment_10127,axiom,
    ! [VarCurr: state_type] :
      ( v19898(VarCurr)
    <=> v19900(VarCurr) ) ).

tff(addAssignment_10126,axiom,
    ! [VarCurr: state_type] :
      ( v19900(VarCurr)
    <=> v19902(VarCurr) ) ).

tff(addAssignment_10125,axiom,
    ! [VarCurr: state_type] :
      ( v19902(VarCurr)
    <=> v19904(VarCurr) ) ).

tff(addAssignment_10124,axiom,
    ! [VarCurr: state_type] :
      ( v19904(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_10123,axiom,
    ! [VarCurr: state_type] :
      ( v19855(VarCurr)
    <=> v19857(VarCurr) ) ).

tff(addAssignment_10122,axiom,
    ! [VarCurr: state_type] :
      ( v19857(VarCurr)
    <=> v19859(VarCurr) ) ).

tff(addAssignment_10121,axiom,
    ! [VarCurr: state_type] :
      ( v19859(VarCurr)
    <=> v19861(VarCurr) ) ).

tff(addAssignment_10120,axiom,
    ! [VarCurr: state_type] :
      ( v19861(VarCurr)
    <=> v19863(VarCurr) ) ).

tff(addAssignment_10119,axiom,
    ! [VarCurr: state_type] :
      ( v19863(VarCurr)
    <=> v19865(VarCurr) ) ).

tff(addAssignment_10118,axiom,
    ! [VarCurr: state_type] :
      ( v19865(VarCurr)
    <=> v19867(VarCurr) ) ).

tff(addAssignment_10117,axiom,
    ! [VarCurr: state_type] :
      ( v19867(VarCurr)
    <=> v19869(VarCurr) ) ).

tff(writeUnaryOperator_1118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19869(VarCurr)
    <=> v19883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1645,axiom,
    ! [VarCurr: state_type] :
      ( v19883(VarCurr)
    <=> ( v19884(VarCurr)
        | v19879(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1644,axiom,
    ! [VarCurr: state_type] :
      ( v19884(VarCurr)
    <=> ( v19871(VarCurr)
        | v19875(VarCurr) ) ) ).

tff(addAssignment_10116,axiom,
    ! [VarCurr: state_type] :
      ( v19879(VarCurr)
    <=> v19881(VarCurr) ) ).

tff(addAssignment_10115,axiom,
    ! [VarCurr: state_type] :
      ( v19881(VarCurr)
    <=> v19301(VarCurr,2) ) ).

tff(addAssignment_10114,axiom,
    ! [VarCurr: state_type] :
      ( v19875(VarCurr)
    <=> v19877(VarCurr) ) ).

tff(addAssignment_10113,axiom,
    ! [VarCurr: state_type] :
      ( v19877(VarCurr)
    <=> v19384(VarCurr,1) ) ).

tff(addAssignment_10112,axiom,
    ! [VarCurr: state_type] :
      ( v19384(VarCurr,1)
    <=> v19386(VarCurr,1) ) ).

tff(addAssignment_10111,axiom,
    ! [VarCurr: state_type] :
      ( v19386(VarCurr,1)
    <=> v19388(VarCurr,1) ) ).

tff(addAssignment_10110,axiom,
    ! [VarCurr: state_type] :
      ( v19388(VarCurr,1)
    <=> v19393(VarCurr,1) ) ).

tff(addAssignment_10109,axiom,
    ! [VarCurr: state_type] :
      ( v19390(VarCurr,1)
    <=> v19392(VarCurr,1) ) ).

tff(addAssignment_10108,axiom,
    ! [VarCurr: state_type] :
      ( v19392(VarCurr,1)
    <=> v19301(VarCurr,1) ) ).

tff(addAssignment_10107,axiom,
    ! [VarCurr: state_type] :
      ( v19871(VarCurr)
    <=> v19873(VarCurr) ) ).

tff(addAssignment_10106,axiom,
    ! [VarCurr: state_type] :
      ( v19873(VarCurr)
    <=> v19301(VarCurr,0) ) ).

tff(addAssignment_10105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19735(VarCurr,B)
      <=> v19737(VarCurr,B) ) ) ).

tff(addAssignment_10104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19737(VarCurr,B)
      <=> v19739(VarCurr,B) ) ) ).

tff(addAssignment_10103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19739(VarCurr,B)
      <=> v19741(VarCurr,B) ) ) ).

tff(addAssignment_10102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19741(VarCurr,B)
      <=> v19743(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19838(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v19743(VarNext,B)
            <=> v19743(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_225,axiom,
    ! [VarNext: state_type] :
      ( v19838(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19743(VarNext,B)
          <=> v19848(VarNext,B) ) ) ) ).

tff(addAssignment_10101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19848(VarNext,B)
          <=> v19846(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19849(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19846(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_148,axiom,
    ! [VarCurr: state_type] :
      ( v19849(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19846(VarCurr,B)
          <=> v19765(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1643,axiom,
    ! [VarCurr: state_type] :
      ( v19849(VarCurr)
    <=> ( v19850(VarCurr)
        & v19851(VarCurr) ) ) ).

tff(writeUnaryOperator_1117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19851(VarCurr)
    <=> v19755(VarCurr) ) ).

tff(writeUnaryOperator_1116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19850(VarCurr)
    <=> v19745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1642,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19838(VarNext)
      <=> v19839(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1641,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19839(VarNext)
      <=> ( v19840(VarNext)
          & v19769(VarNext) ) ) ) ).

tff(writeUnaryOperator_1115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19840(VarNext)
      <=> v19842(VarNext) ) ) ).

tff(addAssignment_10100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19842(VarNext)
      <=> v19769(VarCurr) ) ) ).

tff(addAssignment_10099,axiom,
    ! [VarCurr: state_type] :
      ( v19769(VarCurr)
    <=> v19771(VarCurr) ) ).

tff(addAssignment_10098,axiom,
    ! [VarCurr: state_type] :
      ( v19771(VarCurr)
    <=> v19773(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1640,axiom,
    ! [VarCurr: state_type] :
      ( v19773(VarCurr)
    <=> ( v19835(VarCurr)
        | v19831(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1639,axiom,
    ! [VarCurr: state_type] :
      ( v19835(VarCurr)
    <=> ( v19775(VarCurr)
        & v19779(VarCurr) ) ) ).

tff(addAssignment_10097,axiom,
    ! [VarCurr: state_type] :
      ( v19831(VarCurr)
    <=> v19833(VarCurr) ) ).

tff(addAssignment_10096,axiom,
    ! [VarCurr: state_type] :
      ( v19833(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19815(VarNext)
       => ( v19779(VarNext)
        <=> v19779(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_224,axiom,
    ! [VarNext: state_type] :
      ( v19815(VarNext)
     => ( v19779(VarNext)
      <=> v19825(VarNext) ) ) ).

tff(addAssignment_10095,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19825(VarNext)
      <=> v19823(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1638,axiom,
    ! [VarCurr: state_type] :
      ( v19823(VarCurr)
    <=> ( v19826(VarCurr)
        & v19827(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1637,axiom,
    ! [VarCurr: state_type] :
      ( v19827(VarCurr)
    <=> ( v19785(VarCurr)
        | v19810(VarCurr) ) ) ).

tff(writeUnaryOperator_1114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19826(VarCurr)
    <=> v19781(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1636,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19815(VarNext)
      <=> v19816(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1635,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19816(VarNext)
      <=> ( v19818(VarNext)
          & v19820(VarNext) ) ) ) ).

tff(writeUnaryOperator_1113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19820(VarCurr)
    <=> v19775(VarCurr) ) ).

tff(addAssignment_10094,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19818(VarNext)
      <=> v19775(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_77,axiom,
    ( v19779(constB0)
  <=> $true ) ).

tff(addAssignment_10093,axiom,
    ! [VarCurr: state_type] :
      ( v19810(VarCurr)
    <=> v19812(VarCurr) ) ).

tff(addAssignment_10092,axiom,
    ! [VarCurr: state_type] :
      ( v19812(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_10091,axiom,
    ! [VarCurr: state_type] :
      ( v19785(VarCurr)
    <=> v19787(VarCurr) ) ).

tff(addAssignment_10090,axiom,
    ! [VarCurr: state_type] :
      ( v19787(VarCurr)
    <=> v19789(VarCurr) ) ).

tff(addAssignment_10089,axiom,
    ! [VarCurr: state_type] :
      ( v19789(VarCurr)
    <=> v19791(VarCurr) ) ).

tff(addAssignment_10088,axiom,
    ! [VarCurr: state_type] :
      ( v19791(VarCurr)
    <=> v19793(VarCurr) ) ).

tff(writeUnaryOperator_1112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19793(VarCurr)
    <=> v19807(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1634,axiom,
    ! [VarCurr: state_type] :
      ( v19807(VarCurr)
    <=> ( v19808(VarCurr)
        | v19803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1633,axiom,
    ! [VarCurr: state_type] :
      ( v19808(VarCurr)
    <=> ( v19795(VarCurr)
        | v19799(VarCurr) ) ) ).

tff(addAssignment_10087,axiom,
    ! [VarCurr: state_type] :
      ( v19803(VarCurr)
    <=> v19805(VarCurr) ) ).

tff(addAssignment_10086,axiom,
    ! [VarCurr: state_type] :
      ( v19805(VarCurr)
    <=> v19211(VarCurr,2) ) ).

tff(addAssignment_10085,axiom,
    ! [VarCurr: state_type] :
      ( v19799(VarCurr)
    <=> v19801(VarCurr) ) ).

tff(addAssignment_10084,axiom,
    ! [VarCurr: state_type] :
      ( v19801(VarCurr)
    <=> v19637(VarCurr,1) ) ).

tff(addAssignment_10083,axiom,
    ! [VarCurr: state_type] :
      ( v19637(VarCurr,1)
    <=> v19639(VarCurr,1) ) ).

tff(addAssignment_10082,axiom,
    ! [VarCurr: state_type] :
      ( v19639(VarCurr,1)
    <=> v19641(VarCurr,1) ) ).

tff(addAssignment_10081,axiom,
    ! [VarCurr: state_type] :
      ( v19641(VarCurr,1)
    <=> v19646(VarCurr,1) ) ).

tff(addAssignment_10080,axiom,
    ! [VarCurr: state_type] :
      ( v19643(VarCurr,1)
    <=> v19645(VarCurr,1) ) ).

tff(addAssignment_10079,axiom,
    ! [VarCurr: state_type] :
      ( v19645(VarCurr,1)
    <=> v19211(VarCurr,1) ) ).

tff(addAssignment_10078,axiom,
    ! [VarCurr: state_type] :
      ( v19795(VarCurr)
    <=> v19797(VarCurr) ) ).

tff(addAssignment_10077,axiom,
    ! [VarCurr: state_type] :
      ( v19797(VarCurr)
    <=> v19211(VarCurr,0) ) ).

tff(addAssignment_10076,axiom,
    ! [VarCurr: state_type] :
      ( v19781(VarCurr)
    <=> v19783(VarCurr) ) ).

tff(addAssignment_10075,axiom,
    ! [VarCurr: state_type] :
      ( v19783(VarCurr)
    <=> $false ) ).

tff(addAssignment_10074,axiom,
    ! [VarCurr: state_type] :
      ( v19775(VarCurr)
    <=> v19777(VarCurr) ) ).

tff(addAssignment_10073,axiom,
    ! [VarCurr: state_type] :
      ( v19777(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_10072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19765(VarCurr,B)
      <=> v19767(VarCurr,B) ) ) ).

tff(addAssignment_10071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19767(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_10070,axiom,
    ! [VarCurr: state_type] :
      ( v19755(VarCurr)
    <=> v19757(VarCurr) ) ).

tff(addAssignment_10069,axiom,
    ! [VarCurr: state_type] :
      ( v19757(VarCurr)
    <=> v19759(VarCurr) ) ).

tff(addAssignment_10068,axiom,
    ! [VarCurr: state_type] :
      ( v19759(VarCurr)
    <=> v19761(VarCurr) ) ).

tff(addAssignment_10067,axiom,
    ! [VarCurr: state_type] :
      ( v19761(VarCurr)
    <=> v19763(VarCurr) ) ).

tff(addAssignment_10066,axiom,
    ! [VarCurr: state_type] :
      ( v19763(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_10065,axiom,
    ! [VarCurr: state_type] :
      ( v19745(VarCurr)
    <=> v19747(VarCurr) ) ).

tff(addAssignment_10064,axiom,
    ! [VarCurr: state_type] :
      ( v19747(VarCurr)
    <=> v19749(VarCurr) ) ).

tff(addAssignment_10063,axiom,
    ! [VarCurr: state_type] :
      ( v19749(VarCurr)
    <=> v19751(VarCurr) ) ).

tff(addAssignment_10062,axiom,
    ! [VarCurr: state_type] :
      ( v19751(VarCurr)
    <=> v19753(VarCurr) ) ).

tff(addAssignment_10061,axiom,
    ! [VarCurr: state_type] :
      ( v19753(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_10060,axiom,
    ! [VarCurr: state_type] :
      ( v19704(VarCurr)
    <=> v19706(VarCurr) ) ).

tff(addAssignment_10059,axiom,
    ! [VarCurr: state_type] :
      ( v19706(VarCurr)
    <=> v19708(VarCurr) ) ).

tff(addAssignment_10058,axiom,
    ! [VarCurr: state_type] :
      ( v19708(VarCurr)
    <=> v19710(VarCurr) ) ).

tff(addAssignment_10057,axiom,
    ! [VarCurr: state_type] :
      ( v19710(VarCurr)
    <=> v19712(VarCurr) ) ).

tff(addAssignment_10056,axiom,
    ! [VarCurr: state_type] :
      ( v19712(VarCurr)
    <=> v19714(VarCurr) ) ).

tff(addAssignment_10055,axiom,
    ! [VarCurr: state_type] :
      ( v19714(VarCurr)
    <=> v19716(VarCurr) ) ).

tff(addAssignment_10054,axiom,
    ! [VarCurr: state_type] :
      ( v19716(VarCurr)
    <=> v19718(VarCurr) ) ).

tff(writeUnaryOperator_1111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19718(VarCurr)
    <=> v19732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1632,axiom,
    ! [VarCurr: state_type] :
      ( v19732(VarCurr)
    <=> ( v19733(VarCurr)
        | v19728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1631,axiom,
    ! [VarCurr: state_type] :
      ( v19733(VarCurr)
    <=> ( v19720(VarCurr)
        | v19724(VarCurr) ) ) ).

tff(addAssignment_10053,axiom,
    ! [VarCurr: state_type] :
      ( v19728(VarCurr)
    <=> v19730(VarCurr) ) ).

tff(addAssignment_10052,axiom,
    ! [VarCurr: state_type] :
      ( v19730(VarCurr)
    <=> v19301(VarCurr,2) ) ).

tff(addAssignment_10051,axiom,
    ! [VarCurr: state_type] :
      ( v19724(VarCurr)
    <=> v19726(VarCurr) ) ).

tff(addAssignment_10050,axiom,
    ! [VarCurr: state_type] :
      ( v19726(VarCurr)
    <=> v19301(VarCurr,1) ) ).

tff(addAssignment_10049,axiom,
    ! [VarCurr: state_type] :
      ( v19720(VarCurr)
    <=> v19722(VarCurr) ) ).

tff(addAssignment_10048,axiom,
    ! [VarCurr: state_type] :
      ( v19722(VarCurr)
    <=> v19384(VarCurr,0) ) ).

tff(addAssignment_10047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19573(VarCurr,B)
      <=> v19575(VarCurr,B) ) ) ).

tff(addAssignment_10046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19575(VarCurr,B)
      <=> v19577(VarCurr,B) ) ) ).

tff(addAssignment_10045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19577(VarCurr,B)
      <=> v19579(VarCurr,B) ) ) ).

tff(addAssignment_10044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19579(VarCurr,B)
      <=> v19581(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19687(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v19581(VarNext,B)
            <=> v19581(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_223,axiom,
    ! [VarNext: state_type] :
      ( v19687(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19581(VarNext,B)
          <=> v19697(VarNext,B) ) ) ) ).

tff(addAssignment_10043,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19697(VarNext,B)
          <=> v19695(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19695(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_147,axiom,
    ! [VarCurr: state_type] :
      ( v19698(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19695(VarCurr,B)
          <=> v19603(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1630,axiom,
    ! [VarCurr: state_type] :
      ( v19698(VarCurr)
    <=> ( v19699(VarCurr)
        & v19700(VarCurr) ) ) ).

tff(writeUnaryOperator_1110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19700(VarCurr)
    <=> v19593(VarCurr) ) ).

tff(writeUnaryOperator_1109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19699(VarCurr)
    <=> v19583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1629,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19687(VarNext)
      <=> v19688(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1628,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19688(VarNext)
      <=> ( v19689(VarNext)
          & v19607(VarNext) ) ) ) ).

tff(writeUnaryOperator_1108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19689(VarNext)
      <=> v19691(VarNext) ) ) ).

tff(addAssignment_10042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19691(VarNext)
      <=> v19607(VarCurr) ) ) ).

tff(addAssignment_10041,axiom,
    ! [VarCurr: state_type] :
      ( v19607(VarCurr)
    <=> v19609(VarCurr) ) ).

tff(addAssignment_10040,axiom,
    ! [VarCurr: state_type] :
      ( v19609(VarCurr)
    <=> v19611(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1627,axiom,
    ! [VarCurr: state_type] :
      ( v19611(VarCurr)
    <=> ( v19684(VarCurr)
        | v19680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1626,axiom,
    ! [VarCurr: state_type] :
      ( v19684(VarCurr)
    <=> ( v19613(VarCurr)
        & v19617(VarCurr) ) ) ).

tff(addAssignment_10039,axiom,
    ! [VarCurr: state_type] :
      ( v19680(VarCurr)
    <=> v19682(VarCurr) ) ).

tff(addAssignment_10038,axiom,
    ! [VarCurr: state_type] :
      ( v19682(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19664(VarNext)
       => ( v19617(VarNext)
        <=> v19617(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_222,axiom,
    ! [VarNext: state_type] :
      ( v19664(VarNext)
     => ( v19617(VarNext)
      <=> v19674(VarNext) ) ) ).

tff(addAssignment_10037,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19674(VarNext)
      <=> v19672(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1625,axiom,
    ! [VarCurr: state_type] :
      ( v19672(VarCurr)
    <=> ( v19675(VarCurr)
        & v19676(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1624,axiom,
    ! [VarCurr: state_type] :
      ( v19676(VarCurr)
    <=> ( v19623(VarCurr)
        | v19659(VarCurr) ) ) ).

tff(writeUnaryOperator_1107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19675(VarCurr)
    <=> v19619(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1623,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19664(VarNext)
      <=> v19665(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19665(VarNext)
      <=> ( v19667(VarNext)
          & v19669(VarNext) ) ) ) ).

tff(writeUnaryOperator_1106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19669(VarCurr)
    <=> v19613(VarCurr) ) ).

tff(addAssignment_10036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19667(VarNext)
      <=> v19613(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_76,axiom,
    ( v19617(constB0)
  <=> $true ) ).

tff(addAssignment_10035,axiom,
    ! [VarCurr: state_type] :
      ( v19659(VarCurr)
    <=> v19661(VarCurr) ) ).

tff(addAssignment_10034,axiom,
    ! [VarCurr: state_type] :
      ( v19661(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_10033,axiom,
    ! [VarCurr: state_type] :
      ( v19623(VarCurr)
    <=> v19625(VarCurr) ) ).

tff(addAssignment_10032,axiom,
    ! [VarCurr: state_type] :
      ( v19625(VarCurr)
    <=> v19627(VarCurr) ) ).

tff(addAssignment_10031,axiom,
    ! [VarCurr: state_type] :
      ( v19627(VarCurr)
    <=> v19629(VarCurr) ) ).

tff(addAssignment_10030,axiom,
    ! [VarCurr: state_type] :
      ( v19629(VarCurr)
    <=> v19631(VarCurr) ) ).

tff(writeUnaryOperator_1105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19631(VarCurr)
    <=> v19656(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1621,axiom,
    ! [VarCurr: state_type] :
      ( v19656(VarCurr)
    <=> ( v19657(VarCurr)
        | v19652(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1620,axiom,
    ! [VarCurr: state_type] :
      ( v19657(VarCurr)
    <=> ( v19633(VarCurr)
        | v19648(VarCurr) ) ) ).

tff(addAssignment_10029,axiom,
    ! [VarCurr: state_type] :
      ( v19652(VarCurr)
    <=> v19654(VarCurr) ) ).

tff(addAssignment_10028,axiom,
    ! [VarCurr: state_type] :
      ( v19654(VarCurr)
    <=> v19211(VarCurr,2) ) ).

tff(addAssignment_10027,axiom,
    ! [VarCurr: state_type] :
      ( v19648(VarCurr)
    <=> v19650(VarCurr) ) ).

tff(addAssignment_10026,axiom,
    ! [VarCurr: state_type] :
      ( v19650(VarCurr)
    <=> v19211(VarCurr,1) ) ).

tff(addAssignment_10025,axiom,
    ! [VarCurr: state_type] :
      ( v19633(VarCurr)
    <=> v19635(VarCurr) ) ).

tff(addAssignment_10024,axiom,
    ! [VarCurr: state_type] :
      ( v19635(VarCurr)
    <=> v19637(VarCurr,0) ) ).

tff(addAssignment_10023,axiom,
    ! [VarCurr: state_type] :
      ( v19637(VarCurr,0)
    <=> v19639(VarCurr,0) ) ).

tff(addAssignment_10022,axiom,
    ! [VarCurr: state_type] :
      ( v19639(VarCurr,0)
    <=> v19641(VarCurr,0) ) ).

tff(addAssignment_10021,axiom,
    ! [VarCurr: state_type] :
      ( v19641(VarCurr,0)
    <=> v19646(VarCurr,0) ) ).

tff(writeUnaryOperator_1104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v19646(VarCurr,B)
      <=> ~ v19643(VarCurr,B) ) ) ).

tff(addAssignment_10020,axiom,
    ! [VarCurr: state_type] :
      ( v19643(VarCurr,0)
    <=> v19645(VarCurr,0) ) ).

tff(addAssignment_10019,axiom,
    ! [VarCurr: state_type] :
      ( v19645(VarCurr,0)
    <=> v19211(VarCurr,0) ) ).

tff(addAssignment_10018,axiom,
    ! [VarCurr: state_type] :
      ( v19619(VarCurr)
    <=> v19621(VarCurr) ) ).

tff(addAssignment_10017,axiom,
    ! [VarCurr: state_type] :
      ( v19621(VarCurr)
    <=> $false ) ).

tff(addAssignment_10016,axiom,
    ! [VarCurr: state_type] :
      ( v19613(VarCurr)
    <=> v19615(VarCurr) ) ).

tff(addAssignment_10015,axiom,
    ! [VarCurr: state_type] :
      ( v19615(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_10014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19603(VarCurr,B)
      <=> v19605(VarCurr,B) ) ) ).

tff(addAssignment_10013,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19605(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_10012,axiom,
    ! [VarCurr: state_type] :
      ( v19593(VarCurr)
    <=> v19595(VarCurr) ) ).

tff(addAssignment_10011,axiom,
    ! [VarCurr: state_type] :
      ( v19595(VarCurr)
    <=> v19597(VarCurr) ) ).

tff(addAssignment_10010,axiom,
    ! [VarCurr: state_type] :
      ( v19597(VarCurr)
    <=> v19599(VarCurr) ) ).

tff(addAssignment_10009,axiom,
    ! [VarCurr: state_type] :
      ( v19599(VarCurr)
    <=> v19601(VarCurr) ) ).

tff(addAssignment_10008,axiom,
    ! [VarCurr: state_type] :
      ( v19601(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_10007,axiom,
    ! [VarCurr: state_type] :
      ( v19583(VarCurr)
    <=> v19585(VarCurr) ) ).

tff(addAssignment_10006,axiom,
    ! [VarCurr: state_type] :
      ( v19585(VarCurr)
    <=> v19587(VarCurr) ) ).

tff(addAssignment_10005,axiom,
    ! [VarCurr: state_type] :
      ( v19587(VarCurr)
    <=> v19589(VarCurr) ) ).

tff(addAssignment_10004,axiom,
    ! [VarCurr: state_type] :
      ( v19589(VarCurr)
    <=> v19591(VarCurr) ) ).

tff(addAssignment_10003,axiom,
    ! [VarCurr: state_type] :
      ( v19591(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_10002,axiom,
    ! [VarCurr: state_type] :
      ( v19281(VarCurr)
    <=> v19283(VarCurr) ) ).

tff(addAssignment_10001,axiom,
    ! [VarCurr: state_type] :
      ( v19283(VarCurr)
    <=> v19285(VarCurr) ) ).

tff(addAssignment_10000,axiom,
    ! [VarCurr: state_type] :
      ( v19285(VarCurr)
    <=> v19287(VarCurr) ) ).

tff(addAssignment_9999,axiom,
    ! [VarCurr: state_type] :
      ( v19287(VarCurr)
    <=> v19289(VarCurr) ) ).

tff(addAssignment_9998,axiom,
    ! [VarCurr: state_type] :
      ( v19289(VarCurr)
    <=> v19291(VarCurr) ) ).

tff(addAssignment_9997,axiom,
    ! [VarCurr: state_type] :
      ( v19291(VarCurr)
    <=> v19293(VarCurr) ) ).

tff(addAssignment_9996,axiom,
    ! [VarCurr: state_type] :
      ( v19293(VarCurr)
    <=> v19295(VarCurr) ) ).

tff(writeUnaryOperator_1103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19295(VarCurr)
    <=> v19570(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1619,axiom,
    ! [VarCurr: state_type] :
      ( v19570(VarCurr)
    <=> ( v19571(VarCurr)
        | v19566(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1618,axiom,
    ! [VarCurr: state_type] :
      ( v19571(VarCurr)
    <=> ( v19297(VarCurr)
        | v19562(VarCurr) ) ) ).

tff(addAssignment_9995,axiom,
    ! [VarCurr: state_type] :
      ( v19566(VarCurr)
    <=> v19568(VarCurr) ) ).

tff(addAssignment_9994,axiom,
    ! [VarCurr: state_type] :
      ( v19568(VarCurr)
    <=> v19301(VarCurr,2) ) ).

tff(addAssignment_9993,axiom,
    ! [VarCurr: state_type] :
      ( v19562(VarCurr)
    <=> v19564(VarCurr) ) ).

tff(addAssignment_9992,axiom,
    ! [VarCurr: state_type] :
      ( v19564(VarCurr)
    <=> v19301(VarCurr,1) ) ).

tff(addAssignment_9991,axiom,
    ! [VarCurr: state_type] :
      ( v19297(VarCurr)
    <=> v19299(VarCurr) ) ).

tff(addAssignment_9990,axiom,
    ! [VarCurr: state_type] :
      ( v19299(VarCurr)
    <=> v19301(VarCurr,0) ) ).

tff(addAssignment_9989,axiom,
    ! [VarCurr: state_type] :
      ( v19301(VarCurr,0)
    <=> v19213(VarCurr,3) ) ).

tff(addAssignment_9988,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,3)
    <=> v19215(VarCurr,3) ) ).

tff(addAssignment_9987,axiom,
    ! [VarNext: state_type] :
      ( v19215(VarNext,3)
    <=> v19554(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19555(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v19554(VarNext,B)
            <=> v19215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_221,axiom,
    ! [VarNext: state_type] :
      ( v19555(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19554(VarNext,B)
          <=> v19526(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1617,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19555(VarNext)
      <=> v19556(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19556(VarNext)
      <=> ( v19558(VarNext)
          & v19468(VarNext) ) ) ) ).

tff(writeUnaryOperator_1102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19558(VarNext)
      <=> v19520(VarNext) ) ) ).

tff(addAssignment_9986,axiom,
    ! [VarCurr: state_type] :
      ( v19325(VarCurr,3)
    <=> v19327(VarCurr,3) ) ).

tff(addAssignment_9985,axiom,
    ! [VarCurr: state_type] :
      ( v19327(VarCurr,3)
    <=> v19465(VarCurr,3) ) ).

tff(addAssignment_9984,axiom,
    ! [VarCurr: state_type] :
      ( v19329(VarCurr,0)
    <=> v19331(VarCurr,0) ) ).

tff(addAssignment_9983,axiom,
    ! [VarCurr: state_type] :
      ( v19331(VarCurr,0)
    <=> v19333(VarCurr,0) ) ).

tff(addAssignment_9982,axiom,
    ! [VarCurr: state_type] :
      ( v19333(VarCurr,0)
    <=> v19464(VarCurr,0) ) ).

tff(addAssignment_9981,axiom,
    ! [VarCurr: state_type] :
      ( v19401(VarCurr,0)
    <=> v19403(VarCurr,0) ) ).

tff(addAssignment_9980,axiom,
    ! [VarCurr: state_type] :
      ( v19403(VarCurr,0)
    <=> v19405(VarCurr,0) ) ).

tff(addAssignment_9979,axiom,
    ! [VarCurr: state_type] :
      ( v19405(VarCurr,0)
    <=> v19407(VarCurr,0) ) ).

tff(addAssignment_9978,axiom,
    ! [VarCurr: state_type] :
      ( v19407(VarCurr,0)
    <=> v19409(VarCurr,0) ) ).

tff(addAssignment_9977,axiom,
    ! [VarCurr: state_type] :
      ( v19409(VarCurr,0)
    <=> v19419(VarCurr,0) ) ).

tff(addAssignment_9976,axiom,
    ! [VarCurr: state_type] :
      ( v19335(VarCurr,0)
    <=> v19337(VarCurr,0) ) ).

tff(addAssignment_9975,axiom,
    ! [VarCurr: state_type] :
      ( v19337(VarCurr,0)
    <=> v19398(VarCurr,0) ) ).

tff(addAssignment_9974,axiom,
    ! [VarCurr: state_type] :
      ( v19339(VarCurr)
    <=> v18865(VarCurr,2) ) ).

tff(addAssignment_9973,axiom,
    ! [VarCurr: state_type] :
      ( v18865(VarCurr,2)
    <=> v18867(VarCurr,2) ) ).

tff(addAssignment_9972,axiom,
    ! [VarCurr: state_type] :
      ( v18867(VarCurr,2)
    <=> v18877(VarCurr,2) ) ).

tff(addAssignment_9971,axiom,
    ! [VarCurr: state_type] :
      ( v18869(VarCurr,2)
    <=> v18871(VarCurr,2) ) ).

tff(addAssignment_9970,axiom,
    ! [VarCurr: state_type] :
      ( v18871(VarCurr,2)
    <=> v18874(VarCurr,2) ) ).

tff(addAssignment_9969,axiom,
    ! [VarCurr: state_type] :
      ( v18875(VarCurr)
    <=> v19342(VarCurr,1) ) ).

tff(addAssignment_9968,axiom,
    ! [VarCurr: state_type] :
      ( v19342(VarCurr,1)
    <=> v19344(VarCurr,1) ) ).

tff(addAssignment_9967,axiom,
    ! [VarCurr: state_type] :
      ( v19344(VarCurr,1)
    <=> v19552(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_332,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v19552(VarCurr,B)
      <=> ( v19346(VarCurr,B)
          | v19352(VarCurr,B) ) ) ) ).

tff(addAssignment_9966,axiom,
    ! [VarCurr: state_type] :
      ( v19352(VarCurr,1)
    <=> v19354(VarCurr,1) ) ).

tff(addAssignment_9965,axiom,
    ! [VarCurr: state_type] :
      ( v19354(VarCurr,1)
    <=> v19550(VarCurr,1) ) ).

tff(addAssignment_9964,axiom,
    ! [VarCurr: state_type] :
      ( v19550(VarCurr,0)
    <=> v19551(VarCurr) ) ).

tff(addAssignment_9963,axiom,
    ! [VarCurr: state_type] :
      ( v19550(VarCurr,1)
    <=> v19356(VarCurr) ) ).

tff(addAssignment_9962,axiom,
    ! [VarCurr: state_type] :
      ( v19356(VarCurr)
    <=> v19358(VarCurr,1) ) ).

tff(addAssignment_9961,axiom,
    ! [VarCurr: state_type] :
      ( v19358(VarCurr,1)
    <=> v19360(VarCurr,1) ) ).

tff(addAssignment_9960,axiom,
    ! [VarCurr: state_type] :
      ( v19360(VarCurr,1)
    <=> v19549(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_331,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v19549(VarCurr,B)
      <=> ( v19362(VarCurr,B)
          & v19370(VarCurr,B) ) ) ) ).

tff(addAssignment_9959,axiom,
    ! [VarCurr: state_type] :
      ( v19370(VarCurr,1)
    <=> v19372(VarCurr,1) ) ).

tff(addAssignment_9958,axiom,
    ! [VarCurr: state_type] :
      ( v19372(VarCurr,1)
    <=> v19547(VarCurr,1) ) ).

tff(addAssignment_9957,axiom,
    ! [VarCurr: state_type] :
      ( v19547(VarCurr,0)
    <=> v19548(VarCurr) ) ).

tff(addAssignment_9956,axiom,
    ! [VarCurr: state_type] :
      ( v19547(VarCurr,1)
    <=> v19374(VarCurr) ) ).

tff(addAssignment_9955,axiom,
    ! [VarCurr: state_type] :
      ( v19374(VarCurr)
    <=> v19376(VarCurr) ) ).

tff(addAssignment_9954,axiom,
    ! [VarCurr: state_type] :
      ( v19376(VarCurr)
    <=> v19378(VarCurr) ) ).

tff(writeUnaryOperator_1101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19378(VarCurr)
    <=> v19545(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1615,axiom,
    ! [VarCurr: state_type] :
      ( v19545(VarCurr)
    <=> ( v19546(VarCurr)
        | v19533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1614,axiom,
    ! [VarCurr: state_type] :
      ( v19546(VarCurr)
    <=> ( v19380(VarCurr)
        | v19395(VarCurr) ) ) ).

tff(addAssignment_9953,axiom,
    ! [VarCurr: state_type] :
      ( v19533(VarCurr)
    <=> v19535(VarCurr) ) ).

tff(addAssignment_9952,axiom,
    ! [VarCurr: state_type] :
      ( v19535(VarCurr)
    <=> v19384(VarCurr,2) ) ).

tff(addAssignment_9951,axiom,
    ! [VarCurr: state_type] :
      ( v19384(VarCurr,2)
    <=> v19386(VarCurr,2) ) ).

tff(addAssignment_9950,axiom,
    ! [VarCurr: state_type] :
      ( v19386(VarCurr,2)
    <=> v19388(VarCurr,2) ) ).

tff(addAssignment_9949,axiom,
    ! [VarCurr: state_type] :
      ( v19388(VarCurr,2)
    <=> v19393(VarCurr,2) ) ).

tff(addAssignment_9948,axiom,
    ! [VarCurr: state_type] :
      ( v19390(VarCurr,2)
    <=> v19392(VarCurr,2) ) ).

tff(addAssignment_9947,axiom,
    ! [VarCurr: state_type] :
      ( v19392(VarCurr,2)
    <=> v19301(VarCurr,2) ) ).

tff(addAssignment_9946,axiom,
    ! [VarCurr: state_type] :
      ( v19301(VarCurr,2)
    <=> v19213(VarCurr,5) ) ).

tff(addAssignment_9945,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,5)
    <=> v19215(VarCurr,5) ) ).

tff(addAssignment_9944,axiom,
    ! [VarNext: state_type] :
      ( v19215(VarNext,5)
    <=> v19537(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19538(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v19537(VarNext,B)
            <=> v19215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_220,axiom,
    ! [VarNext: state_type] :
      ( v19538(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19537(VarNext,B)
          <=> v19526(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1613,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19538(VarNext)
      <=> v19539(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19539(VarNext)
      <=> ( v19541(VarNext)
          & v19468(VarNext) ) ) ) ).

tff(writeUnaryOperator_1100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19541(VarNext)
      <=> v19520(VarNext) ) ) ).

tff(addAssignment_9943,axiom,
    ! [VarCurr: state_type] :
      ( v19325(VarCurr,5)
    <=> v19327(VarCurr,5) ) ).

tff(addAssignment_9942,axiom,
    ! [VarCurr: state_type] :
      ( v19327(VarCurr,5)
    <=> v19465(VarCurr,5) ) ).

tff(addAssignment_9941,axiom,
    ! [VarCurr: state_type] :
      ( v19329(VarCurr,2)
    <=> v19331(VarCurr,2) ) ).

tff(addAssignment_9940,axiom,
    ! [VarCurr: state_type] :
      ( v19331(VarCurr,2)
    <=> v19333(VarCurr,2) ) ).

tff(addAssignment_9939,axiom,
    ! [VarCurr: state_type] :
      ( v19333(VarCurr,2)
    <=> v19464(VarCurr,2) ) ).

tff(addAssignment_9938,axiom,
    ! [VarCurr: state_type] :
      ( v19401(VarCurr,2)
    <=> v19403(VarCurr,2) ) ).

tff(addAssignment_9937,axiom,
    ! [VarCurr: state_type] :
      ( v19403(VarCurr,2)
    <=> v19405(VarCurr,2) ) ).

tff(addAssignment_9936,axiom,
    ! [VarCurr: state_type] :
      ( v19405(VarCurr,2)
    <=> v19407(VarCurr,2) ) ).

tff(addAssignment_9935,axiom,
    ! [VarCurr: state_type] :
      ( v19407(VarCurr,2)
    <=> v19409(VarCurr,2) ) ).

tff(addAssignment_9934,axiom,
    ! [VarCurr: state_type] :
      ( v19409(VarCurr,2)
    <=> v19419(VarCurr,2) ) ).

tff(addAssignment_9933,axiom,
    ! [VarCurr: state_type] :
      ( v19411(VarCurr,2)
    <=> v19413(VarCurr,2) ) ).

tff(addAssignment_9932,axiom,
    ! [VarCurr: state_type] :
      ( v19413(VarCurr,2)
    <=> v19414(VarCurr,2) ) ).

tff(addAssignment_9931,axiom,
    ! [VarCurr: state_type] :
      ( v19335(VarCurr,2)
    <=> v19337(VarCurr,2) ) ).

tff(addAssignment_9930,axiom,
    ! [VarCurr: state_type] :
      ( v19337(VarCurr,2)
    <=> v19398(VarCurr,2) ) ).

tff(addAssignment_9929,axiom,
    ! [VarCurr: state_type] :
      ( v19395(VarCurr)
    <=> v19397(VarCurr) ) ).

tff(addAssignment_9928,axiom,
    ! [VarCurr: state_type] :
      ( v19397(VarCurr)
    <=> v19301(VarCurr,1) ) ).

tff(addAssignment_9927,axiom,
    ! [VarCurr: state_type] :
      ( v19301(VarCurr,1)
    <=> v19213(VarCurr,4) ) ).

tff(addAssignment_9926,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,4)
    <=> v19215(VarCurr,4) ) ).

tff(addAssignment_9925,axiom,
    ! [VarNext: state_type] :
      ( v19215(VarNext,4)
    <=> v19515(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19516(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v19515(VarNext,B)
            <=> v19215(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_219,axiom,
    ! [VarNext: state_type] :
      ( v19516(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19515(VarNext,B)
          <=> v19526(VarNext,B) ) ) ) ).

tff(addAssignment_9924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19526(VarNext,B)
          <=> v19524(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19527(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19524(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_146,axiom,
    ! [VarCurr: state_type] :
      ( v19527(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v19524(VarCurr,B)
          <=> v19325(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1611,axiom,
    ! [VarCurr: state_type] :
      ( v19527(VarCurr)
    <=> ( v19528(VarCurr)
        & v19529(VarCurr) ) ) ).

tff(writeUnaryOperator_1099,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19529(VarCurr)
    <=> v19315(VarCurr) ) ).

tff(writeUnaryOperator_1098,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19528(VarCurr)
    <=> v19303(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1610,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19516(VarNext)
      <=> v19517(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1609,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19517(VarNext)
      <=> ( v19518(VarNext)
          & v19468(VarNext) ) ) ) ).

tff(writeUnaryOperator_1097,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19518(VarNext)
      <=> v19520(VarNext) ) ) ).

tff(addAssignment_9923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19520(VarNext)
      <=> v19468(VarCurr) ) ) ).

tff(addAssignment_9922,axiom,
    ! [VarCurr: state_type] :
      ( v19468(VarCurr)
    <=> v19470(VarCurr) ) ).

tff(addAssignment_9921,axiom,
    ! [VarCurr: state_type] :
      ( v19470(VarCurr)
    <=> v19472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1608,axiom,
    ! [VarCurr: state_type] :
      ( v19472(VarCurr)
    <=> ( v19513(VarCurr)
        | v19509(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1607,axiom,
    ! [VarCurr: state_type] :
      ( v19513(VarCurr)
    <=> ( v19474(VarCurr)
        & v19478(VarCurr) ) ) ).

tff(addAssignment_9920,axiom,
    ! [VarCurr: state_type] :
      ( v19509(VarCurr)
    <=> v19511(VarCurr) ) ).

tff(addAssignment_9919,axiom,
    ! [VarCurr: state_type] :
      ( v19511(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19493(VarNext)
       => ( v19478(VarNext)
        <=> v19478(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_218,axiom,
    ! [VarNext: state_type] :
      ( v19493(VarNext)
     => ( v19478(VarNext)
      <=> v19503(VarNext) ) ) ).

tff(addAssignment_9918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19503(VarNext)
      <=> v19501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1606,axiom,
    ! [VarCurr: state_type] :
      ( v19501(VarCurr)
    <=> ( v19504(VarCurr)
        & v19505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1605,axiom,
    ! [VarCurr: state_type] :
      ( v19505(VarCurr)
    <=> ( v19484(VarCurr)
        | v19488(VarCurr) ) ) ).

tff(writeUnaryOperator_1096,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19504(VarCurr)
    <=> v19480(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19493(VarNext)
      <=> v19494(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19494(VarNext)
      <=> ( v19496(VarNext)
          & v19498(VarNext) ) ) ) ).

tff(writeUnaryOperator_1095,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19498(VarCurr)
    <=> v19474(VarCurr) ) ).

tff(addAssignment_9917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19496(VarNext)
      <=> v19474(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_75,axiom,
    ( v19478(constB0)
  <=> $true ) ).

tff(addAssignment_9916,axiom,
    ! [VarCurr: state_type] :
      ( v19488(VarCurr)
    <=> v19490(VarCurr) ) ).

tff(addAssignment_9915,axiom,
    ! [VarCurr: state_type] :
      ( v19490(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_9914,axiom,
    ! [VarCurr: state_type] :
      ( v19484(VarCurr)
    <=> v19486(VarCurr) ) ).

tff(addAssignment_9913,axiom,
    ! [VarCurr: state_type] :
      ( v19486(VarCurr)
    <=> $true ) ).

tff(addAssignment_9912,axiom,
    ! [VarCurr: state_type] :
      ( v19480(VarCurr)
    <=> v19482(VarCurr) ) ).

tff(addAssignment_9911,axiom,
    ! [VarCurr: state_type] :
      ( v19482(VarCurr)
    <=> $false ) ).

tff(addAssignment_9910,axiom,
    ! [VarCurr: state_type] :
      ( v19474(VarCurr)
    <=> v19476(VarCurr) ) ).

tff(addAssignment_9909,axiom,
    ! [VarCurr: state_type] :
      ( v19476(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_9908,axiom,
    ! [VarCurr: state_type] :
      ( v19325(VarCurr,4)
    <=> v19327(VarCurr,4) ) ).

tff(addAssignment_9907,axiom,
    ! [VarCurr: state_type] :
      ( v19327(VarCurr,4)
    <=> v19465(VarCurr,4) ) ).

tff(addAssignment_9906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v19465(VarCurr,B)
      <=> v19466(VarCurr,B) ) ) ).

tff(addAssignment_9905,axiom,
    ! [VarCurr: state_type] :
      ( ( v19465(VarCurr,5)
      <=> v19329(VarCurr,2) )
      & ( v19465(VarCurr,4)
      <=> v19329(VarCurr,1) )
      & ( v19465(VarCurr,3)
      <=> v19329(VarCurr,0) ) ) ).

tff(addAssignment_9904,axiom,
    ! [VarCurr: state_type] :
      ( v19329(VarCurr,1)
    <=> v19331(VarCurr,1) ) ).

tff(addAssignment_9903,axiom,
    ! [VarCurr: state_type] :
      ( v19331(VarCurr,1)
    <=> v19333(VarCurr,1) ) ).

tff(addAssignment_9902,axiom,
    ! [VarCurr: state_type] :
      ( v19333(VarCurr,1)
    <=> v19464(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v19464(VarCurr,B)
      <=> ( v19335(VarCurr,B)
          & v19401(VarCurr,B) ) ) ) ).

tff(addAssignment_9901,axiom,
    ! [VarCurr: state_type] :
      ( v19401(VarCurr,1)
    <=> v19403(VarCurr,1) ) ).

tff(addAssignment_9900,axiom,
    ! [VarCurr: state_type] :
      ( v19403(VarCurr,1)
    <=> v19405(VarCurr,1) ) ).

tff(addAssignment_9899,axiom,
    ! [VarCurr: state_type] :
      ( v19405(VarCurr,1)
    <=> v19407(VarCurr,1) ) ).

tff(addAssignment_9898,axiom,
    ! [VarCurr: state_type] :
      ( v19407(VarCurr,1)
    <=> v19409(VarCurr,1) ) ).

tff(addAssignment_9897,axiom,
    ! [VarCurr: state_type] :
      ( v19409(VarCurr,1)
    <=> v19419(VarCurr,1) ) ).

tff(addAssignment_9896,axiom,
    ! [VarCurr: state_type] :
      ( v19419(VarCurr,0)
    <=> v19459(VarCurr) ) ).

tff(addAssignment_9895,axiom,
    ! [VarCurr: state_type] :
      ( v19419(VarCurr,1)
    <=> v19454(VarCurr) ) ).

tff(addAssignment_9894,axiom,
    ! [VarCurr: state_type] :
      ( v19419(VarCurr,2)
    <=> v19449(VarCurr) ) ).

tff(addAssignment_9893,axiom,
    ! [VarCurr: state_type] :
      ( v19419(VarCurr,3)
    <=> v19421(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1602,axiom,
    ! [VarCurr: state_type] :
      ( v19459(VarCurr)
    <=> ( v19460(VarCurr)
        & v19463(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1601,axiom,
    ! [VarCurr: state_type] :
      ( v19463(VarCurr)
    <=> ( v19411(VarCurr,0)
        | v19429(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1600,axiom,
    ! [VarCurr: state_type] :
      ( v19460(VarCurr)
    <=> ( v19461(VarCurr)
        | v19462(VarCurr) ) ) ).

tff(writeUnaryOperator_1094,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19462(VarCurr)
    <=> v19429(VarCurr,0) ) ).

tff(writeUnaryOperator_1093,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19461(VarCurr)
    <=> v19411(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1599,axiom,
    ! [VarCurr: state_type] :
      ( v19454(VarCurr)
    <=> ( v19455(VarCurr)
        & v19458(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1598,axiom,
    ! [VarCurr: state_type] :
      ( v19458(VarCurr)
    <=> ( v19428(VarCurr)
        | v19430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1597,axiom,
    ! [VarCurr: state_type] :
      ( v19455(VarCurr)
    <=> ( v19456(VarCurr)
        | v19457(VarCurr) ) ) ).

tff(writeUnaryOperator_1092,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19457(VarCurr)
    <=> v19430(VarCurr) ) ).

tff(writeUnaryOperator_1091,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19456(VarCurr)
    <=> v19428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1596,axiom,
    ! [VarCurr: state_type] :
      ( v19449(VarCurr)
    <=> ( v19450(VarCurr)
        & v19453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1595,axiom,
    ! [VarCurr: state_type] :
      ( v19453(VarCurr)
    <=> ( v19426(VarCurr)
        | v19436(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1594,axiom,
    ! [VarCurr: state_type] :
      ( v19450(VarCurr)
    <=> ( v19451(VarCurr)
        | v19452(VarCurr) ) ) ).

tff(writeUnaryOperator_1090,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19452(VarCurr)
    <=> v19436(VarCurr) ) ).

tff(writeUnaryOperator_1089,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19451(VarCurr)
    <=> v19426(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1593,axiom,
    ! [VarCurr: state_type] :
      ( v19421(VarCurr)
    <=> ( v19422(VarCurr)
        & v19448(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1592,axiom,
    ! [VarCurr: state_type] :
      ( v19448(VarCurr)
    <=> ( v19424(VarCurr)
        | v19443(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1591,axiom,
    ! [VarCurr: state_type] :
      ( v19422(VarCurr)
    <=> ( v19423(VarCurr)
        | v19442(VarCurr) ) ) ).

tff(writeUnaryOperator_1088,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19442(VarCurr)
    <=> v19443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1590,axiom,
    ! [VarCurr: state_type] :
      ( v19443(VarCurr)
    <=> ( v19444(VarCurr)
        & v19447(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_213,axiom,
    ! [VarCurr: state_type] :
      ( v19447(VarCurr)
    <=> ( v19411(VarCurr,3)
        | v19429(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1589,axiom,
    ! [VarCurr: state_type] :
      ( v19444(VarCurr)
    <=> ( v19445(VarCurr)
        | v19446(VarCurr) ) ) ).

tff(writeUnaryOperator_1087,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19446(VarCurr)
    <=> v19429(VarCurr,3) ) ).

tff(writeUnaryOperator_1086,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19445(VarCurr)
    <=> v19411(VarCurr,3) ) ).

tff(writeUnaryOperator_1085,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19423(VarCurr)
    <=> v19424(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1588,axiom,
    ! [VarCurr: state_type] :
      ( v19424(VarCurr)
    <=> ( v19425(VarCurr)
        | v19441(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_212,axiom,
    ! [VarCurr: state_type] :
      ( v19441(VarCurr)
    <=> ( v19411(VarCurr,2)
        & v19429(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1587,axiom,
    ! [VarCurr: state_type] :
      ( v19425(VarCurr)
    <=> ( v19426(VarCurr)
        & v19436(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1586,axiom,
    ! [VarCurr: state_type] :
      ( v19436(VarCurr)
    <=> ( v19437(VarCurr)
        & v19440(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_211,axiom,
    ! [VarCurr: state_type] :
      ( v19440(VarCurr)
    <=> ( v19411(VarCurr,2)
        | v19429(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1585,axiom,
    ! [VarCurr: state_type] :
      ( v19437(VarCurr)
    <=> ( v19438(VarCurr)
        | v19439(VarCurr) ) ) ).

tff(writeUnaryOperator_1084,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19439(VarCurr)
    <=> v19429(VarCurr,2) ) ).

tff(writeUnaryOperator_1083,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19438(VarCurr)
    <=> v19411(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1584,axiom,
    ! [VarCurr: state_type] :
      ( v19426(VarCurr)
    <=> ( v19427(VarCurr)
        | v19435(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_210,axiom,
    ! [VarCurr: state_type] :
      ( v19435(VarCurr)
    <=> ( v19411(VarCurr,1)
        & v19429(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1583,axiom,
    ! [VarCurr: state_type] :
      ( v19427(VarCurr)
    <=> ( v19428(VarCurr)
        & v19430(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1582,axiom,
    ! [VarCurr: state_type] :
      ( v19430(VarCurr)
    <=> ( v19431(VarCurr)
        & v19434(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_209,axiom,
    ! [VarCurr: state_type] :
      ( v19434(VarCurr)
    <=> ( v19411(VarCurr,1)
        | v19429(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1581,axiom,
    ! [VarCurr: state_type] :
      ( v19431(VarCurr)
    <=> ( v19432(VarCurr)
        | v19433(VarCurr) ) ) ).

tff(writeUnaryOperator_1082,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19433(VarCurr)
    <=> v19429(VarCurr,1) ) ).

tff(writeUnaryOperator_1081,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19432(VarCurr)
    <=> v19411(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1580,axiom,
    ! [VarCurr: state_type] :
      ( v19428(VarCurr)
    <=> ( v19411(VarCurr,0)
        & v19429(VarCurr,0) ) ) ).

tff(addAssignment_9892,axiom,
    ! [VarCurr: state_type] :
      ( v19429(VarCurr,0)
    <=> v19416(VarCurr) ) ).

tff(addAssignment_9891,axiom,
    ! [VarCurr: state_type] :
      ( ( v19429(VarCurr,3)
      <=> $false )
      & ( v19429(VarCurr,2)
      <=> $false )
      & ( v19429(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_9890,axiom,
    ! [VarCurr: state_type] :
      ( v19416(VarCurr)
    <=> v19418(VarCurr) ) ).

tff(addAssignment_9889,axiom,
    ! [VarCurr: state_type] :
      ( v19418(VarCurr)
    <=> v19366(VarCurr) ) ).

tff(addAssignment_9888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v19411(VarCurr,B)
      <=> v19413(VarCurr,B) ) ) ).

tff(addAssignment_9887,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v19413(VarCurr,B)
      <=> v19414(VarCurr,B) ) ) ).

tff(addAssignment_9886,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v19414(VarCurr,B)
      <=> v19301(VarCurr,B) ) ) ).

tff(addAssignment_9885,axiom,
    ! [VarCurr: state_type] :
      ( v19414(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_9884,axiom,
    ! [VarCurr: state_type] :
      ( v19335(VarCurr,1)
    <=> v19337(VarCurr,1) ) ).

tff(addAssignment_9883,axiom,
    ! [VarCurr: state_type] :
      ( v19337(VarCurr,1)
    <=> v19398(VarCurr,1) ) ).

tff(addAssignment_9882,axiom,
    ! [VarCurr: state_type] :
      ( v19398(VarCurr,0)
    <=> v19399(VarCurr) ) ).

tff(addAssignment_9881,axiom,
    ! [VarCurr: state_type] :
      ( v19398(VarCurr,1)
    <=> v19399(VarCurr) ) ).

tff(addAssignment_9880,axiom,
    ! [VarCurr: state_type] :
      ( v19398(VarCurr,2)
    <=> v19399(VarCurr) ) ).

tff(addAssignment_9879,axiom,
    ! [VarCurr: state_type] :
      ( v19399(VarCurr)
    <=> v19339(VarCurr) ) ).

tff(addAssignment_9878,axiom,
    ! [VarCurr: state_type] :
      ( v19380(VarCurr)
    <=> v19382(VarCurr) ) ).

tff(addAssignment_9877,axiom,
    ! [VarCurr: state_type] :
      ( v19382(VarCurr)
    <=> v19384(VarCurr,0) ) ).

tff(addAssignment_9876,axiom,
    ! [VarCurr: state_type] :
      ( v19384(VarCurr,0)
    <=> v19386(VarCurr,0) ) ).

tff(addAssignment_9875,axiom,
    ! [VarCurr: state_type] :
      ( v19386(VarCurr,0)
    <=> v19388(VarCurr,0) ) ).

tff(addAssignment_9874,axiom,
    ! [VarCurr: state_type] :
      ( v19388(VarCurr,0)
    <=> v19393(VarCurr,0) ) ).

tff(writeUnaryOperator_1080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v19393(VarCurr,B)
      <=> ~ v19390(VarCurr,B) ) ) ).

tff(addAssignment_9873,axiom,
    ! [VarCurr: state_type] :
      ( v19390(VarCurr,0)
    <=> v19392(VarCurr,0) ) ).

tff(addAssignment_9872,axiom,
    ! [VarCurr: state_type] :
      ( v19392(VarCurr,0)
    <=> v19301(VarCurr,0) ) ).

tff(addAssignment_9871,axiom,
    ! [VarCurr: state_type] :
      ( v19362(VarCurr,1)
    <=> v19364(VarCurr,1) ) ).

tff(addAssignment_9870,axiom,
    ! [VarCurr: state_type] :
      ( v19364(VarCurr,1)
    <=> v19367(VarCurr,1) ) ).

tff(addAssignment_9869,axiom,
    ! [VarCurr: state_type] :
      ( v19367(VarCurr,0)
    <=> v19368(VarCurr) ) ).

tff(addAssignment_9868,axiom,
    ! [VarCurr: state_type] :
      ( v19367(VarCurr,1)
    <=> v19366(VarCurr) ) ).

tff(addAssignment_9867,axiom,
    ! [VarCurr: state_type] :
      ( v19366(VarCurr)
    <=> v10053(VarCurr,6) ) ).

tff(addAssignment_9866,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,6)
    <=> v10055(VarCurr,6) ) ).

tff(addAssignment_9865,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,6)
    <=> v10057(VarCurr,6) ) ).

tff(addAssignment_9864,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,6)
    <=> v10061(VarCurr,6) ) ).

tff(addAssignment_9863,axiom,
    ! [VarCurr: state_type] :
      ( v19346(VarCurr,1)
    <=> v19348(VarCurr,1) ) ).

tff(addAssignment_9862,axiom,
    ! [VarCurr: state_type] :
      ( v19348(VarCurr,1)
    <=> v19349(VarCurr,1) ) ).

tff(addAssignment_9861,axiom,
    ! [VarCurr: state_type] :
      ( v19349(VarCurr,0)
    <=> v19350(VarCurr) ) ).

tff(addAssignment_9860,axiom,
    ! [VarCurr: state_type] :
      ( v19349(VarCurr,1)
    <=> v19350(VarCurr) ) ).

tff(addAssignment_9859,axiom,
    ! [VarCurr: state_type] :
      ( v19350(VarCurr)
    <=> v18873(VarCurr) ) ).

tff(addAssignment_9858,axiom,
    ! [VarCurr: state_type] :
      ( v19315(VarCurr)
    <=> v19317(VarCurr) ) ).

tff(addAssignment_9857,axiom,
    ! [VarCurr: state_type] :
      ( v19317(VarCurr)
    <=> v19319(VarCurr) ) ).

tff(addAssignment_9856,axiom,
    ! [VarCurr: state_type] :
      ( v19319(VarCurr)
    <=> v19321(VarCurr) ) ).

tff(addAssignment_9855,axiom,
    ! [VarCurr: state_type] :
      ( v19321(VarCurr)
    <=> v19323(VarCurr) ) ).

tff(addAssignment_9854,axiom,
    ! [VarCurr: state_type] :
      ( v19323(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_9853,axiom,
    ! [VarCurr: state_type] :
      ( v19303(VarCurr)
    <=> v19305(VarCurr) ) ).

tff(addAssignment_9852,axiom,
    ! [VarCurr: state_type] :
      ( v19305(VarCurr)
    <=> v19307(VarCurr) ) ).

tff(addAssignment_9851,axiom,
    ! [VarCurr: state_type] :
      ( v19307(VarCurr)
    <=> v19309(VarCurr) ) ).

tff(addAssignment_9850,axiom,
    ! [VarCurr: state_type] :
      ( v19309(VarCurr)
    <=> v19311(VarCurr) ) ).

tff(addAssignment_9849,axiom,
    ! [VarCurr: state_type] :
      ( v19311(VarCurr)
    <=> v19313(VarCurr) ) ).

tff(addAssignment_9848,axiom,
    ! [VarCurr: state_type] :
      ( v19313(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_9847,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18811(VarCurr,B)
      <=> v18813(VarCurr,B) ) ) ).

tff(addAssignment_9846,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18813(VarCurr,B)
      <=> v18815(VarCurr,B) ) ) ).

tff(addAssignment_9845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18815(VarCurr,B)
      <=> v18817(VarCurr,B) ) ) ).

tff(addAssignment_9844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18817(VarCurr,B)
      <=> v18819(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19264(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18819(VarNext,B)
            <=> v18819(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_217,axiom,
    ! [VarNext: state_type] :
      ( v19264(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18819(VarNext,B)
          <=> v19274(VarNext,B) ) ) ) ).

tff(addAssignment_9843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19274(VarNext,B)
          <=> v19272(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19272(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_145,axiom,
    ! [VarCurr: state_type] :
      ( v19275(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19272(VarCurr,B)
          <=> v18849(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1579,axiom,
    ! [VarCurr: state_type] :
      ( v19275(VarCurr)
    <=> ( v19276(VarCurr)
        & v19277(VarCurr) ) ) ).

tff(writeUnaryOperator_1079,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19277(VarCurr)
    <=> v18835(VarCurr) ) ).

tff(writeUnaryOperator_1078,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19276(VarCurr)
    <=> v18821(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19264(VarNext)
      <=> v19265(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19265(VarNext)
      <=> ( v19266(VarNext)
          & v19179(VarNext) ) ) ) ).

tff(writeUnaryOperator_1077,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19266(VarNext)
      <=> v19268(VarNext) ) ) ).

tff(addAssignment_9842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19268(VarNext)
      <=> v19179(VarCurr) ) ) ).

tff(addAssignment_9841,axiom,
    ! [VarCurr: state_type] :
      ( v19179(VarCurr)
    <=> v19181(VarCurr) ) ).

tff(addAssignment_9840,axiom,
    ! [VarCurr: state_type] :
      ( v19181(VarCurr)
    <=> v19183(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1576,axiom,
    ! [VarCurr: state_type] :
      ( v19183(VarCurr)
    <=> ( v19261(VarCurr)
        | v19253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1575,axiom,
    ! [VarCurr: state_type] :
      ( v19261(VarCurr)
    <=> ( v19185(VarCurr)
        & v19191(VarCurr) ) ) ).

tff(addAssignment_9839,axiom,
    ! [VarCurr: state_type] :
      ( v19253(VarCurr)
    <=> v19255(VarCurr) ) ).

tff(addAssignment_9838,axiom,
    ! [VarCurr: state_type] :
      ( v19255(VarCurr)
    <=> v19257(VarCurr) ) ).

tff(addAssignment_9837,axiom,
    ! [VarCurr: state_type] :
      ( v19257(VarCurr)
    <=> v19259(VarCurr) ) ).

tff(addAssignment_9836,axiom,
    ! [VarCurr: state_type] :
      ( v19259(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19237(VarNext)
       => ( v19191(VarNext)
        <=> v19191(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_216,axiom,
    ! [VarNext: state_type] :
      ( v19237(VarNext)
     => ( v19191(VarNext)
      <=> v19247(VarNext) ) ) ).

tff(addAssignment_9835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19247(VarNext)
      <=> v19245(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1574,axiom,
    ! [VarCurr: state_type] :
      ( v19245(VarCurr)
    <=> ( v19248(VarCurr)
        & v19249(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1573,axiom,
    ! [VarCurr: state_type] :
      ( v19249(VarCurr)
    <=> ( v19197(VarCurr)
        | v19228(VarCurr) ) ) ).

tff(writeUnaryOperator_1076,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19248(VarCurr)
    <=> v19193(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19237(VarNext)
      <=> v19238(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19238(VarNext)
      <=> ( v19240(VarNext)
          & v19242(VarNext) ) ) ) ).

tff(writeUnaryOperator_1075,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19242(VarCurr)
    <=> v19185(VarCurr) ) ).

tff(addAssignment_9834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19240(VarNext)
      <=> v19185(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_74,axiom,
    ( v19191(constB0)
  <=> $true ) ).

tff(addAssignment_9833,axiom,
    ! [VarCurr: state_type] :
      ( v19228(VarCurr)
    <=> v19230(VarCurr) ) ).

tff(addAssignment_9832,axiom,
    ! [VarCurr: state_type] :
      ( v19230(VarCurr)
    <=> v19232(VarCurr) ) ).

tff(addAssignment_9831,axiom,
    ! [VarCurr: state_type] :
      ( v19232(VarCurr)
    <=> v19234(VarCurr) ) ).

tff(addAssignment_9830,axiom,
    ! [VarCurr: state_type] :
      ( v19234(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_9829,axiom,
    ! [VarCurr: state_type] :
      ( v19197(VarCurr)
    <=> v19199(VarCurr) ) ).

tff(addAssignment_9828,axiom,
    ! [VarCurr: state_type] :
      ( v19199(VarCurr)
    <=> v19201(VarCurr) ) ).

tff(addAssignment_9827,axiom,
    ! [VarCurr: state_type] :
      ( v19201(VarCurr)
    <=> v19203(VarCurr) ) ).

tff(addAssignment_9826,axiom,
    ! [VarCurr: state_type] :
      ( v19203(VarCurr)
    <=> v19205(VarCurr) ) ).

tff(writeUnaryOperator_1074,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19205(VarCurr)
    <=> v19225(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1570,axiom,
    ! [VarCurr: state_type] :
      ( v19225(VarCurr)
    <=> ( v19226(VarCurr)
        | v19221(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1569,axiom,
    ! [VarCurr: state_type] :
      ( v19226(VarCurr)
    <=> ( v19207(VarCurr)
        | v19217(VarCurr) ) ) ).

tff(addAssignment_9825,axiom,
    ! [VarCurr: state_type] :
      ( v19221(VarCurr)
    <=> v19223(VarCurr) ) ).

tff(addAssignment_9824,axiom,
    ! [VarCurr: state_type] :
      ( v19223(VarCurr)
    <=> v19211(VarCurr,2) ) ).

tff(addAssignment_9823,axiom,
    ! [VarCurr: state_type] :
      ( v19211(VarCurr,2)
    <=> v19213(VarCurr,2) ) ).

tff(addAssignment_9822,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,2)
    <=> v19215(VarCurr,2) ) ).

tff(addAssignment_9821,axiom,
    ! [VarCurr: state_type] :
      ( v19217(VarCurr)
    <=> v19219(VarCurr) ) ).

tff(addAssignment_9820,axiom,
    ! [VarCurr: state_type] :
      ( v19219(VarCurr)
    <=> v19211(VarCurr,1) ) ).

tff(addAssignment_9819,axiom,
    ! [VarCurr: state_type] :
      ( v19211(VarCurr,1)
    <=> v19213(VarCurr,1) ) ).

tff(addAssignment_9818,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,1)
    <=> v19215(VarCurr,1) ) ).

tff(addAssignment_9817,axiom,
    ! [VarCurr: state_type] :
      ( v19207(VarCurr)
    <=> v19209(VarCurr) ) ).

tff(addAssignment_9816,axiom,
    ! [VarCurr: state_type] :
      ( v19209(VarCurr)
    <=> v19211(VarCurr,0) ) ).

tff(addAssignment_9815,axiom,
    ! [VarCurr: state_type] :
      ( v19211(VarCurr,0)
    <=> v19213(VarCurr,0) ) ).

tff(addAssignment_9814,axiom,
    ! [VarCurr: state_type] :
      ( v19213(VarCurr,0)
    <=> v19215(VarCurr,0) ) ).

tff(addAssignment_9813,axiom,
    ! [VarCurr: state_type] :
      ( v19193(VarCurr)
    <=> v19195(VarCurr) ) ).

tff(addAssignment_9812,axiom,
    ! [VarCurr: state_type] :
      ( v19195(VarCurr)
    <=> $false ) ).

tff(addAssignment_9811,axiom,
    ! [VarCurr: state_type] :
      ( v19185(VarCurr)
    <=> v19187(VarCurr) ) ).

tff(addAssignment_9810,axiom,
    ! [VarCurr: state_type] :
      ( v19187(VarCurr)
    <=> v19189(VarCurr) ) ).

tff(addAssignment_9809,axiom,
    ! [VarCurr: state_type] :
      ( v19189(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_9808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18849(VarCurr,B)
      <=> v18851(VarCurr,B) ) ) ).

tff(addAssignment_9807,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18851(VarCurr,B)
      <=> v18853(VarCurr,B) ) ) ).

tff(addAssignment_9806,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18853(VarCurr,B)
      <=> v18855(VarCurr,B) ) ) ).

tff(addAssignment_9805,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18855(VarCurr,B)
      <=> v18857(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18857(VarCurr,B)
      <=> ( v18859(VarCurr,B)
          & v18881(VarCurr,B) ) ) ) ).

tff(addAssignment_9804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18881(VarCurr,B)
      <=> v18883(VarCurr,B) ) ) ).

tff(addAssignment_9803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18883(VarCurr,B)
      <=> v18885(VarCurr,B) ) ) ).

tff(addAssignment_9802,axiom,
    ! [VarCurr: state_type] :
      ( ( v18885(VarCurr,11)
      <=> v9198(VarCurr,83) )
      & ( v18885(VarCurr,10)
      <=> v9198(VarCurr,82) )
      & ( v18885(VarCurr,9)
      <=> v9198(VarCurr,81) )
      & ( v18885(VarCurr,8)
      <=> v9198(VarCurr,80) )
      & ( v18885(VarCurr,7)
      <=> v9198(VarCurr,79) )
      & ( v18885(VarCurr,6)
      <=> v9198(VarCurr,78) )
      & ( v18885(VarCurr,5)
      <=> v9198(VarCurr,77) )
      & ( v18885(VarCurr,4)
      <=> v9198(VarCurr,76) )
      & ( v18885(VarCurr,3)
      <=> v9198(VarCurr,75) )
      & ( v18885(VarCurr,2)
      <=> v9198(VarCurr,74) )
      & ( v18885(VarCurr,1)
      <=> v9198(VarCurr,73) )
      & ( v18885(VarCurr,0)
      <=> v9198(VarCurr,72) ) ) ).

tff(addAssignment_9801,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,83)
      <=> v18887(VarCurr,11) )
      & ( v9198(VarCurr,82)
      <=> v18887(VarCurr,10) )
      & ( v9198(VarCurr,81)
      <=> v18887(VarCurr,9) )
      & ( v9198(VarCurr,80)
      <=> v18887(VarCurr,8) )
      & ( v9198(VarCurr,79)
      <=> v18887(VarCurr,7) )
      & ( v9198(VarCurr,78)
      <=> v18887(VarCurr,6) )
      & ( v9198(VarCurr,77)
      <=> v18887(VarCurr,5) )
      & ( v9198(VarCurr,76)
      <=> v18887(VarCurr,4) )
      & ( v9198(VarCurr,75)
      <=> v18887(VarCurr,3) )
      & ( v9198(VarCurr,74)
      <=> v18887(VarCurr,2) )
      & ( v9198(VarCurr,73)
      <=> v18887(VarCurr,1) )
      & ( v9198(VarCurr,72)
      <=> v18887(VarCurr,0) ) ) ).

tff(addAssignment_9800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18887(VarCurr,B)
      <=> v18889(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18889(VarCurr,B)
      <=> ( v19171(VarCurr,B)
          | v19174(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19174(VarCurr,B)
      <=> ( v18899(VarCurr,B)
          & v19175(VarCurr,B) ) ) ) ).

tff(addAssignment_9799,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,0)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9798,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,1)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9797,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,2)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9796,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,3)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9795,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,4)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9794,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,5)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9793,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,6)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9792,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,7)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9791,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,8)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9790,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,9)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9789,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,10)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9788,axiom,
    ! [VarCurr: state_type] :
      ( v19175(VarCurr,11)
    <=> v19176(VarCurr) ) ).

tff(addAssignment_9787,axiom,
    ! [VarCurr: state_type] :
      ( v19176(VarCurr)
    <=> v19167(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19171(VarCurr,B)
      <=> ( v18891(VarCurr,B)
          & v19172(VarCurr,B) ) ) ) ).

tff(addAssignment_9786,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,0)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9785,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,1)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9784,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,2)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9783,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,3)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9782,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,4)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9781,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,5)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9780,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,6)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9779,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,7)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9778,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,8)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9777,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,9)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9776,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,10)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9775,axiom,
    ! [VarCurr: state_type] :
      ( v19172(VarCurr,11)
    <=> v19173(VarCurr) ) ).

tff(addAssignment_9774,axiom,
    ! [VarCurr: state_type] :
      ( v19173(VarCurr)
    <=> v18895(VarCurr) ) ).

tff(addAssignment_9773,axiom,
    ! [VarCurr: state_type] :
      ( v19167(VarCurr)
    <=> v19169(VarCurr) ) ).

tff(addAssignment_9772,axiom,
    ! [VarCurr: state_type] :
      ( v19169(VarCurr)
    <=> v9844(VarCurr,6) ) ).

tff(addAssignment_9771,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,6)
    <=> v9846(VarCurr,6) ) ).

tff(addAssignment_9770,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,6)
    <=> v9496(VarCurr,6) ) ).

tff(addAssignment_9769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18899(VarCurr,B)
      <=> v18901(VarCurr,B) ) ) ).

tff(addAssignment_9768,axiom,
    ! [VarCurr: state_type] :
      ( ( v18901(VarCurr,11)
      <=> v9208(VarCurr,95) )
      & ( v18901(VarCurr,10)
      <=> v9208(VarCurr,94) )
      & ( v18901(VarCurr,9)
      <=> v9208(VarCurr,93) )
      & ( v18901(VarCurr,8)
      <=> v9208(VarCurr,92) )
      & ( v18901(VarCurr,7)
      <=> v9208(VarCurr,91) )
      & ( v18901(VarCurr,6)
      <=> v9208(VarCurr,90) )
      & ( v18901(VarCurr,5)
      <=> v9208(VarCurr,89) )
      & ( v18901(VarCurr,4)
      <=> v9208(VarCurr,88) )
      & ( v18901(VarCurr,3)
      <=> v9208(VarCurr,87) )
      & ( v18901(VarCurr,2)
      <=> v9208(VarCurr,86) )
      & ( v18901(VarCurr,1)
      <=> v9208(VarCurr,85) )
      & ( v18901(VarCurr,0)
      <=> v9208(VarCurr,84) ) ) ).

tff(addAssignment_9767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,96)
        & ~ $less(B,84) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_9766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,96)
        & ~ $less(B,84) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_9765,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,95)
      <=> v18903(VarCurr,11) )
      & ( v9212(VarCurr,94)
      <=> v18903(VarCurr,10) )
      & ( v9212(VarCurr,93)
      <=> v18903(VarCurr,9) )
      & ( v9212(VarCurr,92)
      <=> v18903(VarCurr,8) )
      & ( v9212(VarCurr,91)
      <=> v18903(VarCurr,7) )
      & ( v9212(VarCurr,90)
      <=> v18903(VarCurr,6) )
      & ( v9212(VarCurr,89)
      <=> v18903(VarCurr,5) )
      & ( v9212(VarCurr,88)
      <=> v18903(VarCurr,4) )
      & ( v9212(VarCurr,87)
      <=> v18903(VarCurr,3) )
      & ( v9212(VarCurr,86)
      <=> v18903(VarCurr,2) )
      & ( v9212(VarCurr,85)
      <=> v18903(VarCurr,1) )
      & ( v9212(VarCurr,84)
      <=> v18903(VarCurr,0) ) ) ).

tff(addAssignment_9764,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18903(VarCurr,B)
      <=> v18905(VarCurr,B) ) ) ).

tff(addAssignment_9763,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18905(VarCurr,B)
      <=> v18907(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19150(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18907(VarNext,B)
            <=> v18907(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_215,axiom,
    ! [VarNext: state_type] :
      ( v19150(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18907(VarNext,B)
          <=> v19160(VarNext,B) ) ) ) ).

tff(addAssignment_9762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19160(VarNext,B)
          <=> v19158(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19161(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19158(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_144,axiom,
    ! [VarCurr: state_type] :
      ( v19161(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v19158(VarCurr,B)
          <=> v18937(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1568,axiom,
    ! [VarCurr: state_type] :
      ( v19161(VarCurr)
    <=> ( v19162(VarCurr)
        & v19163(VarCurr) ) ) ).

tff(writeUnaryOperator_1073,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19163(VarCurr)
    <=> v18923(VarCurr) ) ).

tff(writeUnaryOperator_1072,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19162(VarCurr)
    <=> v18909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19150(VarNext)
      <=> v19151(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19151(VarNext)
      <=> ( v19152(VarNext)
          & v19125(VarNext) ) ) ) ).

tff(writeUnaryOperator_1071,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v19152(VarNext)
      <=> v19154(VarNext) ) ) ).

tff(addAssignment_9761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v19154(VarNext)
      <=> v19125(VarCurr) ) ) ).

tff(addAssignment_9760,axiom,
    ! [VarCurr: state_type] :
      ( v19125(VarCurr)
    <=> v19127(VarCurr) ) ).

tff(addAssignment_9759,axiom,
    ! [VarCurr: state_type] :
      ( v19127(VarCurr)
    <=> v19129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1565,axiom,
    ! [VarCurr: state_type] :
      ( v19129(VarCurr)
    <=> ( v19147(VarCurr)
        | v19139(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1564,axiom,
    ! [VarCurr: state_type] :
      ( v19147(VarCurr)
    <=> ( v19131(VarCurr)
        & v19137(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_73,axiom,
    ( v19137(constB0)
  <=> $true ) ).

tff(addAssignment_9758,axiom,
    ! [VarCurr: state_type] :
      ( v19139(VarCurr)
    <=> v19141(VarCurr) ) ).

tff(addAssignment_9757,axiom,
    ! [VarCurr: state_type] :
      ( v19141(VarCurr)
    <=> v19143(VarCurr) ) ).

tff(addAssignment_9756,axiom,
    ! [VarCurr: state_type] :
      ( v19143(VarCurr)
    <=> v19145(VarCurr) ) ).

tff(addAssignment_9755,axiom,
    ! [VarCurr: state_type] :
      ( v19145(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_9754,axiom,
    ! [VarCurr: state_type] :
      ( v19131(VarCurr)
    <=> v19133(VarCurr) ) ).

tff(addAssignment_9753,axiom,
    ! [VarCurr: state_type] :
      ( v19133(VarCurr)
    <=> v19135(VarCurr) ) ).

tff(addAssignment_9752,axiom,
    ! [VarCurr: state_type] :
      ( v19135(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_9751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18937(VarCurr,B)
      <=> v18939(VarCurr,B) ) ) ).

tff(addAssignment_9750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18939(VarCurr,B)
      <=> v18941(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18941(VarCurr,B)
      <=> ( v19110(VarCurr,B)
          | v19121(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19121(VarCurr,B)
      <=> ( v19074(VarCurr,B)
          & v19122(VarCurr,B) ) ) ) ).

tff(addAssignment_9749,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,0)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9748,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,1)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9747,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,2)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9746,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,3)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9745,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,4)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9744,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,5)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9743,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,6)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9742,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,7)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9741,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,8)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9740,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,9)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9739,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,10)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9738,axiom,
    ! [VarCurr: state_type] :
      ( v19122(VarCurr,11)
    <=> v19123(VarCurr) ) ).

tff(addAssignment_9737,axiom,
    ! [VarCurr: state_type] :
      ( v19123(VarCurr)
    <=> v19084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19110(VarCurr,B)
      <=> ( v19111(VarCurr,B)
          | v19118(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_322,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19118(VarCurr,B)
      <=> ( v19038(VarCurr,B)
          & v19119(VarCurr,B) ) ) ) ).

tff(addAssignment_9736,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,0)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9735,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,1)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9734,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,2)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9733,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,3)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9732,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,4)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9731,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,5)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9730,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,6)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9729,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,7)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9728,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,8)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9727,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,9)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9726,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,10)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9725,axiom,
    ! [VarCurr: state_type] :
      ( v19119(VarCurr,11)
    <=> v19120(VarCurr) ) ).

tff(addAssignment_9724,axiom,
    ! [VarCurr: state_type] :
      ( v19120(VarCurr)
    <=> v19048(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19111(VarCurr,B)
      <=> ( v19112(VarCurr,B)
          | v19115(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19115(VarCurr,B)
      <=> ( v18991(VarCurr,B)
          & v19116(VarCurr,B) ) ) ) ).

tff(addAssignment_9723,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,0)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9722,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,1)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9721,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,2)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9720,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,3)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9719,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,4)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9718,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,5)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9717,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,6)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9716,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,7)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9715,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,8)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9714,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,9)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9713,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,10)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9712,axiom,
    ! [VarCurr: state_type] :
      ( v19116(VarCurr,11)
    <=> v19117(VarCurr) ) ).

tff(addAssignment_9711,axiom,
    ! [VarCurr: state_type] :
      ( v19117(VarCurr)
    <=> v19001(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19112(VarCurr,B)
      <=> ( v18943(VarCurr,B)
          & v19113(VarCurr,B) ) ) ) ).

tff(addAssignment_9710,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,0)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9709,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,1)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9708,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,2)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9707,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,3)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9706,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,4)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9705,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,5)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9704,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,6)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9703,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,7)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9702,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,8)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9701,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,9)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9700,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,10)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9699,axiom,
    ! [VarCurr: state_type] :
      ( v19113(VarCurr,11)
    <=> v19114(VarCurr) ) ).

tff(addAssignment_9698,axiom,
    ! [VarCurr: state_type] :
      ( v19114(VarCurr)
    <=> v18953(VarCurr) ) ).

tff(addAssignment_9697,axiom,
    ! [VarCurr: state_type] :
      ( v19084(VarCurr)
    <=> v19086(VarCurr) ) ).

tff(addAssignment_9696,axiom,
    ! [VarCurr: state_type] :
      ( v19086(VarCurr)
    <=> v19088(VarCurr) ) ).

tff(addAssignment_9695,axiom,
    ! [VarCurr: state_type] :
      ( v19088(VarCurr)
    <=> v19090(VarCurr) ) ).

tff(addAssignment_9694,axiom,
    ! [VarCurr: state_type] :
      ( v19090(VarCurr)
    <=> v19092(VarCurr) ) ).

tff(addAssignment_9693,axiom,
    ! [VarCurr: state_type] :
      ( v19092(VarCurr)
    <=> v19094(VarCurr) ) ).

tff(addAssignment_9692,axiom,
    ! [VarCurr: state_type] :
      ( v19094(VarCurr)
    <=> v19096(VarCurr) ) ).

tff(addAssignment_9691,axiom,
    ! [VarCurr: state_type] :
      ( v19096(VarCurr)
    <=> v19098(VarCurr) ) ).

tff(writeUnaryOperator_1070,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19098(VarCurr)
    <=> v19108(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1563,axiom,
    ! [VarCurr: state_type] :
      ( v19108(VarCurr)
    <=> ( v19100(VarCurr)
        | v19104(VarCurr) ) ) ).

tff(addAssignment_9690,axiom,
    ! [VarCurr: state_type] :
      ( v19104(VarCurr)
    <=> v19106(VarCurr) ) ).

tff(addAssignment_9689,axiom,
    ! [VarCurr: state_type] :
      ( v19106(VarCurr)
    <=> v19021(VarCurr,1) ) ).

tff(addAssignment_9688,axiom,
    ! [VarCurr: state_type] :
      ( v19100(VarCurr)
    <=> v19102(VarCurr) ) ).

tff(addAssignment_9687,axiom,
    ! [VarCurr: state_type] :
      ( v19102(VarCurr)
    <=> v19021(VarCurr,0) ) ).

tff(addAssignment_9686,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19074(VarCurr,B)
      <=> v19076(VarCurr,B) ) ) ).

tff(addAssignment_9685,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19076(VarCurr,B)
      <=> v19078(VarCurr,B) ) ) ).

tff(addAssignment_9684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19078(VarCurr,B)
      <=> v19080(VarCurr,B) ) ) ).

tff(addAssignment_9683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19080(VarCurr,B)
      <=> v19082(VarCurr,B) ) ) ).

tff(addAssignment_9682,axiom,
    ! [VarCurr: state_type] :
      ( v19048(VarCurr)
    <=> v19050(VarCurr) ) ).

tff(addAssignment_9681,axiom,
    ! [VarCurr: state_type] :
      ( v19050(VarCurr)
    <=> v19052(VarCurr) ) ).

tff(addAssignment_9680,axiom,
    ! [VarCurr: state_type] :
      ( v19052(VarCurr)
    <=> v19054(VarCurr) ) ).

tff(addAssignment_9679,axiom,
    ! [VarCurr: state_type] :
      ( v19054(VarCurr)
    <=> v19056(VarCurr) ) ).

tff(addAssignment_9678,axiom,
    ! [VarCurr: state_type] :
      ( v19056(VarCurr)
    <=> v19058(VarCurr) ) ).

tff(addAssignment_9677,axiom,
    ! [VarCurr: state_type] :
      ( v19058(VarCurr)
    <=> v19060(VarCurr) ) ).

tff(addAssignment_9676,axiom,
    ! [VarCurr: state_type] :
      ( v19060(VarCurr)
    <=> v19062(VarCurr) ) ).

tff(writeUnaryOperator_1069,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19062(VarCurr)
    <=> v19072(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1562,axiom,
    ! [VarCurr: state_type] :
      ( v19072(VarCurr)
    <=> ( v19064(VarCurr)
        | v19068(VarCurr) ) ) ).

tff(addAssignment_9675,axiom,
    ! [VarCurr: state_type] :
      ( v19068(VarCurr)
    <=> v19070(VarCurr) ) ).

tff(addAssignment_9674,axiom,
    ! [VarCurr: state_type] :
      ( v19070(VarCurr)
    <=> v19021(VarCurr,1) ) ).

tff(addAssignment_9673,axiom,
    ! [VarCurr: state_type] :
      ( v19021(VarCurr,1)
    <=> v19023(VarCurr,1) ) ).

tff(addAssignment_9672,axiom,
    ! [VarCurr: state_type] :
      ( v19023(VarCurr,1)
    <=> v19025(VarCurr,1) ) ).

tff(addAssignment_9671,axiom,
    ! [VarCurr: state_type] :
      ( v19025(VarCurr,1)
    <=> v19030(VarCurr,1) ) ).

tff(addAssignment_9670,axiom,
    ! [VarCurr: state_type] :
      ( v19027(VarCurr,1)
    <=> v19029(VarCurr,1) ) ).

tff(addAssignment_9669,axiom,
    ! [VarCurr: state_type] :
      ( v19029(VarCurr,1)
    <=> v18973(VarCurr,1) ) ).

tff(addAssignment_9668,axiom,
    ! [VarCurr: state_type] :
      ( v19064(VarCurr)
    <=> v19066(VarCurr) ) ).

tff(addAssignment_9667,axiom,
    ! [VarCurr: state_type] :
      ( v19066(VarCurr)
    <=> v18973(VarCurr,0) ) ).

tff(addAssignment_9666,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19038(VarCurr,B)
      <=> v19040(VarCurr,B) ) ) ).

tff(addAssignment_9665,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19040(VarCurr,B)
      <=> v19042(VarCurr,B) ) ) ).

tff(addAssignment_9664,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19042(VarCurr,B)
      <=> v19044(VarCurr,B) ) ) ).

tff(addAssignment_9663,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v19044(VarCurr,B)
      <=> v19046(VarCurr,B) ) ) ).

tff(addAssignment_9662,axiom,
    ! [VarCurr: state_type] :
      ( v19001(VarCurr)
    <=> v19003(VarCurr) ) ).

tff(addAssignment_9661,axiom,
    ! [VarCurr: state_type] :
      ( v19003(VarCurr)
    <=> v19005(VarCurr) ) ).

tff(addAssignment_9660,axiom,
    ! [VarCurr: state_type] :
      ( v19005(VarCurr)
    <=> v19007(VarCurr) ) ).

tff(addAssignment_9659,axiom,
    ! [VarCurr: state_type] :
      ( v19007(VarCurr)
    <=> v19009(VarCurr) ) ).

tff(addAssignment_9658,axiom,
    ! [VarCurr: state_type] :
      ( v19009(VarCurr)
    <=> v19011(VarCurr) ) ).

tff(addAssignment_9657,axiom,
    ! [VarCurr: state_type] :
      ( v19011(VarCurr)
    <=> v19013(VarCurr) ) ).

tff(addAssignment_9656,axiom,
    ! [VarCurr: state_type] :
      ( v19013(VarCurr)
    <=> v19015(VarCurr) ) ).

tff(writeUnaryOperator_1068,axiom,
    ! [VarCurr: state_type] :
      ( ~ v19015(VarCurr)
    <=> v19036(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1561,axiom,
    ! [VarCurr: state_type] :
      ( v19036(VarCurr)
    <=> ( v19017(VarCurr)
        | v19032(VarCurr) ) ) ).

tff(addAssignment_9655,axiom,
    ! [VarCurr: state_type] :
      ( v19032(VarCurr)
    <=> v19034(VarCurr) ) ).

tff(addAssignment_9654,axiom,
    ! [VarCurr: state_type] :
      ( v19034(VarCurr)
    <=> v18973(VarCurr,1) ) ).

tff(addAssignment_9653,axiom,
    ! [VarCurr: state_type] :
      ( v19017(VarCurr)
    <=> v19019(VarCurr) ) ).

tff(addAssignment_9652,axiom,
    ! [VarCurr: state_type] :
      ( v19019(VarCurr)
    <=> v19021(VarCurr,0) ) ).

tff(addAssignment_9651,axiom,
    ! [VarCurr: state_type] :
      ( v19021(VarCurr,0)
    <=> v19023(VarCurr,0) ) ).

tff(addAssignment_9650,axiom,
    ! [VarCurr: state_type] :
      ( v19023(VarCurr,0)
    <=> v19025(VarCurr,0) ) ).

tff(addAssignment_9649,axiom,
    ! [VarCurr: state_type] :
      ( v19025(VarCurr,0)
    <=> v19030(VarCurr,0) ) ).

tff(writeUnaryOperator_1067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v19030(VarCurr,B)
      <=> ~ v19027(VarCurr,B) ) ) ).

tff(addAssignment_9648,axiom,
    ! [VarCurr: state_type] :
      ( v19027(VarCurr,0)
    <=> v19029(VarCurr,0) ) ).

tff(addAssignment_9647,axiom,
    ! [VarCurr: state_type] :
      ( v19029(VarCurr,0)
    <=> v18973(VarCurr,0) ) ).

tff(addAssignment_9646,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18991(VarCurr,B)
      <=> v18993(VarCurr,B) ) ) ).

tff(addAssignment_9645,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18993(VarCurr,B)
      <=> v18995(VarCurr,B) ) ) ).

tff(addAssignment_9644,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18995(VarCurr,B)
      <=> v18997(VarCurr,B) ) ) ).

tff(addAssignment_9643,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18997(VarCurr,B)
      <=> v18999(VarCurr,B) ) ) ).

tff(addAssignment_9642,axiom,
    ! [VarCurr: state_type] :
      ( v18953(VarCurr)
    <=> v18955(VarCurr) ) ).

tff(addAssignment_9641,axiom,
    ! [VarCurr: state_type] :
      ( v18955(VarCurr)
    <=> v18957(VarCurr) ) ).

tff(addAssignment_9640,axiom,
    ! [VarCurr: state_type] :
      ( v18957(VarCurr)
    <=> v18959(VarCurr) ) ).

tff(addAssignment_9639,axiom,
    ! [VarCurr: state_type] :
      ( v18959(VarCurr)
    <=> v18961(VarCurr) ) ).

tff(addAssignment_9638,axiom,
    ! [VarCurr: state_type] :
      ( v18961(VarCurr)
    <=> v18963(VarCurr) ) ).

tff(addAssignment_9637,axiom,
    ! [VarCurr: state_type] :
      ( v18963(VarCurr)
    <=> v18965(VarCurr) ) ).

tff(addAssignment_9636,axiom,
    ! [VarCurr: state_type] :
      ( v18965(VarCurr)
    <=> v18967(VarCurr) ) ).

tff(writeUnaryOperator_1066,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18967(VarCurr)
    <=> v18989(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1560,axiom,
    ! [VarCurr: state_type] :
      ( v18989(VarCurr)
    <=> ( v18969(VarCurr)
        | v18985(VarCurr) ) ) ).

tff(addAssignment_9635,axiom,
    ! [VarCurr: state_type] :
      ( v18985(VarCurr)
    <=> v18987(VarCurr) ) ).

tff(addAssignment_9634,axiom,
    ! [VarCurr: state_type] :
      ( v18987(VarCurr)
    <=> v18973(VarCurr,1) ) ).

tff(addAssignment_9633,axiom,
    ! [VarCurr: state_type] :
      ( v18973(VarCurr,1)
    <=> v18975(VarCurr,1) ) ).

tff(addAssignment_9632,axiom,
    ! [VarCurr: state_type] :
      ( v18975(VarCurr,1)
    <=> v18977(VarCurr,1) ) ).

tff(addAssignment_9631,axiom,
    ! [VarCurr: state_type] :
      ( v18977(VarCurr,1)
    <=> v18979(VarCurr,1) ) ).

tff(addAssignment_9630,axiom,
    ! [VarCurr: state_type] :
      ( v18979(VarCurr,1)
    <=> v18981(VarCurr,1) ) ).

tff(addAssignment_9629,axiom,
    ! [VarCurr: state_type] :
      ( v18981(VarCurr,1)
    <=> v18983(VarCurr,1) ) ).

tff(addAssignment_9628,axiom,
    ! [VarCurr: state_type] :
      ( v18969(VarCurr)
    <=> v18971(VarCurr) ) ).

tff(addAssignment_9627,axiom,
    ! [VarCurr: state_type] :
      ( v18971(VarCurr)
    <=> v18973(VarCurr,0) ) ).

tff(addAssignment_9626,axiom,
    ! [VarCurr: state_type] :
      ( v18973(VarCurr,0)
    <=> v18975(VarCurr,0) ) ).

tff(addAssignment_9625,axiom,
    ! [VarCurr: state_type] :
      ( v18975(VarCurr,0)
    <=> v18977(VarCurr,0) ) ).

tff(addAssignment_9624,axiom,
    ! [VarCurr: state_type] :
      ( v18977(VarCurr,0)
    <=> v18979(VarCurr,0) ) ).

tff(addAssignment_9623,axiom,
    ! [VarCurr: state_type] :
      ( v18979(VarCurr,0)
    <=> v18981(VarCurr,0) ) ).

tff(addAssignment_9622,axiom,
    ! [VarCurr: state_type] :
      ( v18981(VarCurr,0)
    <=> v18983(VarCurr,0) ) ).

tff(addAssignment_9621,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18943(VarCurr,B)
      <=> v18945(VarCurr,B) ) ) ).

tff(addAssignment_9620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18945(VarCurr,B)
      <=> v18947(VarCurr,B) ) ) ).

tff(addAssignment_9619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18947(VarCurr,B)
      <=> v18949(VarCurr,B) ) ) ).

tff(addAssignment_9618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18949(VarCurr,B)
      <=> v18951(VarCurr,B) ) ) ).

tff(addAssignment_9617,axiom,
    ! [VarCurr: state_type] :
      ( v18923(VarCurr)
    <=> v18925(VarCurr) ) ).

tff(addAssignment_9616,axiom,
    ! [VarCurr: state_type] :
      ( v18925(VarCurr)
    <=> v18927(VarCurr) ) ).

tff(addAssignment_9615,axiom,
    ! [VarCurr: state_type] :
      ( v18927(VarCurr)
    <=> v18929(VarCurr) ) ).

tff(addAssignment_9614,axiom,
    ! [VarCurr: state_type] :
      ( v18929(VarCurr)
    <=> v18931(VarCurr) ) ).

tff(addAssignment_9613,axiom,
    ! [VarCurr: state_type] :
      ( v18931(VarCurr)
    <=> v18933(VarCurr) ) ).

tff(addAssignment_9612,axiom,
    ! [VarCurr: state_type] :
      ( v18933(VarCurr)
    <=> v18935(VarCurr) ) ).

tff(addAssignment_9611,axiom,
    ! [VarCurr: state_type] :
      ( v18935(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_9610,axiom,
    ! [VarCurr: state_type] :
      ( v18909(VarCurr)
    <=> v18911(VarCurr) ) ).

tff(addAssignment_9609,axiom,
    ! [VarCurr: state_type] :
      ( v18911(VarCurr)
    <=> v18913(VarCurr) ) ).

tff(addAssignment_9608,axiom,
    ! [VarCurr: state_type] :
      ( v18913(VarCurr)
    <=> v18915(VarCurr) ) ).

tff(addAssignment_9607,axiom,
    ! [VarCurr: state_type] :
      ( v18915(VarCurr)
    <=> v18917(VarCurr) ) ).

tff(addAssignment_9606,axiom,
    ! [VarCurr: state_type] :
      ( v18917(VarCurr)
    <=> v18919(VarCurr) ) ).

tff(addAssignment_9605,axiom,
    ! [VarCurr: state_type] :
      ( v18919(VarCurr)
    <=> v18921(VarCurr) ) ).

tff(addAssignment_9604,axiom,
    ! [VarCurr: state_type] :
      ( v18921(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_9603,axiom,
    ! [VarCurr: state_type] :
      ( v18895(VarCurr)
    <=> v18897(VarCurr) ) ).

tff(addAssignment_9602,axiom,
    ! [VarCurr: state_type] :
      ( v18897(VarCurr)
    <=> v9490(VarCurr,6) ) ).

tff(addAssignment_9601,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,6)
    <=> v9492(VarCurr,6) ) ).

tff(addAssignment_9600,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,6)
    <=> v9494(VarCurr,6) ) ).

tff(addAssignment_9599,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,6)
    <=> v9570(VarCurr,6) ) ).

tff(addAssignment_9598,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,6)
    <=> v9513(VarCurr,6) ) ).

tff(addAssignment_9597,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18891(VarCurr,B)
      <=> v18893(VarCurr,B) ) ) ).

tff(addAssignment_9596,axiom,
    ! [VarCurr: state_type] :
      ( ( v18893(VarCurr,11)
      <=> v9208(VarCurr,83) )
      & ( v18893(VarCurr,10)
      <=> v9208(VarCurr,82) )
      & ( v18893(VarCurr,9)
      <=> v9208(VarCurr,81) )
      & ( v18893(VarCurr,8)
      <=> v9208(VarCurr,80) )
      & ( v18893(VarCurr,7)
      <=> v9208(VarCurr,79) )
      & ( v18893(VarCurr,6)
      <=> v9208(VarCurr,78) )
      & ( v18893(VarCurr,5)
      <=> v9208(VarCurr,77) )
      & ( v18893(VarCurr,4)
      <=> v9208(VarCurr,76) )
      & ( v18893(VarCurr,3)
      <=> v9208(VarCurr,75) )
      & ( v18893(VarCurr,2)
      <=> v9208(VarCurr,74) )
      & ( v18893(VarCurr,1)
      <=> v9208(VarCurr,73) )
      & ( v18893(VarCurr,0)
      <=> v9208(VarCurr,72) ) ) ).

tff(addAssignment_9595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18859(VarCurr,B)
      <=> v18861(VarCurr,B) ) ) ).

tff(addAssignment_9594,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,0)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9593,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,1)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9592,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,2)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9591,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,3)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9590,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,4)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9589,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,5)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9588,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,6)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9587,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,7)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9586,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,8)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9585,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,9)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9584,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,10)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9583,axiom,
    ! [VarCurr: state_type] :
      ( v18861(VarCurr,11)
    <=> v18879(VarCurr) ) ).

tff(addAssignment_9582,axiom,
    ! [VarCurr: state_type] :
      ( v18879(VarCurr)
    <=> v18863(VarCurr) ) ).

tff(addAssignment_9581,axiom,
    ! [VarCurr: state_type] :
      ( v18863(VarCurr)
    <=> v18865(VarCurr,0) ) ).

tff(addAssignment_9580,axiom,
    ! [VarCurr: state_type] :
      ( v18865(VarCurr,0)
    <=> v18867(VarCurr,0) ) ).

tff(addAssignment_9579,axiom,
    ! [VarCurr: state_type] :
      ( v18867(VarCurr,0)
    <=> v18877(VarCurr,0) ) ).

tff(writeUnaryOperator_1065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v18877(VarCurr,B)
      <=> ~ v18869(VarCurr,B) ) ) ).

tff(addAssignment_9578,axiom,
    ! [VarCurr: state_type] :
      ( v18869(VarCurr,0)
    <=> v18871(VarCurr,0) ) ).

tff(addAssignment_9577,axiom,
    ! [VarCurr: state_type] :
      ( v18871(VarCurr,0)
    <=> v18874(VarCurr,0) ) ).

tff(addAssignment_9576,axiom,
    ! [VarCurr: state_type] :
      ( v18874(VarCurr,0)
    <=> v18873(VarCurr) ) ).

tff(addAssignment_9575,axiom,
    ! [VarCurr: state_type] :
      ( v18874(VarCurr,1)
    <=> v18876(VarCurr) ) ).

tff(addAssignment_9574,axiom,
    ! [VarCurr: state_type] :
      ( v18874(VarCurr,2)
    <=> v18875(VarCurr) ) ).

tff(addAssignment_9573,axiom,
    ! [VarCurr: state_type] :
      ( v18873(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_9572,axiom,
    ! [VarCurr: state_type] :
      ( v18835(VarCurr)
    <=> v18837(VarCurr) ) ).

tff(addAssignment_9571,axiom,
    ! [VarCurr: state_type] :
      ( v18837(VarCurr)
    <=> v18839(VarCurr) ) ).

tff(addAssignment_9570,axiom,
    ! [VarCurr: state_type] :
      ( v18839(VarCurr)
    <=> v18841(VarCurr) ) ).

tff(addAssignment_9569,axiom,
    ! [VarCurr: state_type] :
      ( v18841(VarCurr)
    <=> v18843(VarCurr) ) ).

tff(addAssignment_9568,axiom,
    ! [VarCurr: state_type] :
      ( v18843(VarCurr)
    <=> v18845(VarCurr) ) ).

tff(addAssignment_9567,axiom,
    ! [VarCurr: state_type] :
      ( v18845(VarCurr)
    <=> v18847(VarCurr) ) ).

tff(addAssignment_9566,axiom,
    ! [VarCurr: state_type] :
      ( v18847(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_9565,axiom,
    ! [VarCurr: state_type] :
      ( v18821(VarCurr)
    <=> v18823(VarCurr) ) ).

tff(addAssignment_9564,axiom,
    ! [VarCurr: state_type] :
      ( v18823(VarCurr)
    <=> v18825(VarCurr) ) ).

tff(addAssignment_9563,axiom,
    ! [VarCurr: state_type] :
      ( v18825(VarCurr)
    <=> v18827(VarCurr) ) ).

tff(addAssignment_9562,axiom,
    ! [VarCurr: state_type] :
      ( v18827(VarCurr)
    <=> v18829(VarCurr) ) ).

tff(addAssignment_9561,axiom,
    ! [VarCurr: state_type] :
      ( v18829(VarCurr)
    <=> v18831(VarCurr) ) ).

tff(addAssignment_9560,axiom,
    ! [VarCurr: state_type] :
      ( v18831(VarCurr)
    <=> v18833(VarCurr) ) ).

tff(addAssignment_9559,axiom,
    ! [VarCurr: state_type] :
      ( v18833(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_9558,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18797(VarCurr,B)
      <=> v18799(VarCurr,B) ) ) ).

tff(addAssignment_9557,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18799(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_9556,axiom,
    ! [VarCurr: state_type] :
      ( v17241(VarCurr)
    <=> v17243(VarCurr) ) ).

tff(addAssignment_9555,axiom,
    ! [VarCurr: state_type] :
      ( v17243(VarCurr)
    <=> v17245(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_91,axiom,
    ! [VarCurr: state_type] :
      ( v17245(VarCurr)
    <=> ( ( v17247(VarCurr,11)
        <=> v17251(VarCurr,11) )
        & ( v17247(VarCurr,10)
        <=> v17251(VarCurr,10) )
        & ( v17247(VarCurr,9)
        <=> v17251(VarCurr,9) )
        & ( v17247(VarCurr,8)
        <=> v17251(VarCurr,8) )
        & ( v17247(VarCurr,7)
        <=> v17251(VarCurr,7) )
        & ( v17247(VarCurr,6)
        <=> v17251(VarCurr,6) )
        & ( v17247(VarCurr,5)
        <=> v17251(VarCurr,5) )
        & ( v17247(VarCurr,4)
        <=> v17251(VarCurr,4) )
        & ( v17247(VarCurr,3)
        <=> v17251(VarCurr,3) )
        & ( v17247(VarCurr,2)
        <=> v17251(VarCurr,2) )
        & ( v17247(VarCurr,1)
        <=> v17251(VarCurr,1) )
        & ( v17247(VarCurr,0)
        <=> v17251(VarCurr,0) ) ) ) ).

tff(addAssignment_9554,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17251(VarCurr,B)
      <=> v17253(VarCurr,B) ) ) ).

tff(addAssignment_9553,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17253(VarCurr,B)
      <=> v17255(VarCurr,B) ) ) ).

tff(addAssignment_9552,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17255(VarCurr,B)
      <=> v17257(VarCurr,B) ) ) ).

tff(addAssignment_9551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17257(VarCurr,B)
      <=> v17259(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17259(VarCurr,B)
      <=> ( v18767(VarCurr,B)
          | v18786(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_317,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18786(VarCurr,B)
      <=> ( v18638(VarCurr,B)
          & v18787(VarCurr,B) ) ) ) ).

tff(addAssignment_9550,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,0)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9549,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,1)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9548,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,2)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9547,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,3)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9546,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,4)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9545,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,5)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9544,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,6)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9543,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,7)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9542,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,8)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9541,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,9)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9540,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,10)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9539,axiom,
    ! [VarCurr: state_type] :
      ( v18787(VarCurr,11)
    <=> v18788(VarCurr) ) ).

tff(addAssignment_9538,axiom,
    ! [VarCurr: state_type] :
      ( v18788(VarCurr)
    <=> v18757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_316,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18767(VarCurr,B)
      <=> ( v18768(VarCurr,B)
          | v18783(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_315,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18783(VarCurr,B)
      <=> ( v18487(VarCurr,B)
          & v18784(VarCurr,B) ) ) ) ).

tff(addAssignment_9537,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,0)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9536,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,1)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9535,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,2)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9534,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,3)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9533,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,4)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9532,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,5)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9531,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,6)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9530,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,7)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9529,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,8)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9528,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,9)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9527,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,10)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9526,axiom,
    ! [VarCurr: state_type] :
      ( v18784(VarCurr,11)
    <=> v18785(VarCurr) ) ).

tff(addAssignment_9525,axiom,
    ! [VarCurr: state_type] :
      ( v18785(VarCurr)
    <=> v18607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_314,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18768(VarCurr,B)
      <=> ( v18769(VarCurr,B)
          | v18780(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_313,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18780(VarCurr,B)
      <=> ( v18336(VarCurr,B)
          & v18781(VarCurr,B) ) ) ) ).

tff(addAssignment_9524,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,0)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9523,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,1)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9522,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,2)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9521,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,3)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9520,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,4)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9519,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,5)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9518,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,6)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9517,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,7)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9516,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,8)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9515,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,9)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9514,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,10)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9513,axiom,
    ! [VarCurr: state_type] :
      ( v18781(VarCurr,11)
    <=> v18782(VarCurr) ) ).

tff(addAssignment_9512,axiom,
    ! [VarCurr: state_type] :
      ( v18782(VarCurr)
    <=> v18456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_312,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18769(VarCurr,B)
      <=> ( v18770(VarCurr,B)
          | v18777(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18777(VarCurr,B)
      <=> ( v18185(VarCurr,B)
          & v18778(VarCurr,B) ) ) ) ).

tff(addAssignment_9511,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,0)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9510,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,1)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9509,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,2)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9508,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,3)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9507,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,4)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9506,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,5)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9505,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,6)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9504,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,7)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9503,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,8)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9502,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,9)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9501,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,10)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9500,axiom,
    ! [VarCurr: state_type] :
      ( v18778(VarCurr,11)
    <=> v18779(VarCurr) ) ).

tff(addAssignment_9499,axiom,
    ! [VarCurr: state_type] :
      ( v18779(VarCurr)
    <=> v18305(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18770(VarCurr,B)
      <=> ( v18771(VarCurr,B)
          | v18774(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18774(VarCurr,B)
      <=> ( v18023(VarCurr,B)
          & v18775(VarCurr,B) ) ) ) ).

tff(addAssignment_9498,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,0)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9497,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,1)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9496,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,2)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9495,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,3)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9494,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,4)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9493,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,5)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9492,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,6)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9491,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,7)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9490,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,8)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9489,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,9)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9488,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,10)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9487,axiom,
    ! [VarCurr: state_type] :
      ( v18775(VarCurr,11)
    <=> v18776(VarCurr) ) ).

tff(addAssignment_9486,axiom,
    ! [VarCurr: state_type] :
      ( v18776(VarCurr)
    <=> v18154(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18771(VarCurr,B)
      <=> ( v17261(VarCurr,B)
          & v18772(VarCurr,B) ) ) ) ).

tff(addAssignment_9485,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,0)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9484,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,1)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9483,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,2)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9482,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,3)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9481,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,4)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9480,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,5)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9479,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,6)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9478,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,7)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9477,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,8)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9476,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,9)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9475,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,10)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9474,axiom,
    ! [VarCurr: state_type] :
      ( v18772(VarCurr,11)
    <=> v18773(VarCurr) ) ).

tff(addAssignment_9473,axiom,
    ! [VarCurr: state_type] :
      ( v18773(VarCurr)
    <=> v17731(VarCurr) ) ).

tff(addAssignment_9472,axiom,
    ! [VarCurr: state_type] :
      ( v18757(VarCurr)
    <=> v18759(VarCurr) ) ).

tff(addAssignment_9471,axiom,
    ! [VarCurr: state_type] :
      ( v18759(VarCurr)
    <=> v18761(VarCurr) ) ).

tff(addAssignment_9470,axiom,
    ! [VarCurr: state_type] :
      ( v18761(VarCurr)
    <=> v18763(VarCurr) ) ).

tff(addAssignment_9469,axiom,
    ! [VarCurr: state_type] :
      ( v18763(VarCurr)
    <=> v18765(VarCurr) ) ).

tff(addAssignment_9468,axiom,
    ! [VarCurr: state_type] :
      ( v18765(VarCurr)
    <=> v17824(VarCurr) ) ).

tff(addAssignment_9467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18638(VarCurr,B)
      <=> v18640(VarCurr,B) ) ) ).

tff(addAssignment_9466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18640(VarCurr,B)
      <=> v18642(VarCurr,B) ) ) ).

tff(addAssignment_9465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18642(VarCurr,B)
      <=> v18644(VarCurr,B) ) ) ).

tff(addAssignment_9464,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18644(VarCurr,B)
      <=> v18646(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18740(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18646(VarNext,B)
            <=> v18646(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_214,axiom,
    ! [VarNext: state_type] :
      ( v18740(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18646(VarNext,B)
          <=> v18750(VarNext,B) ) ) ) ).

tff(addAssignment_9463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18750(VarNext,B)
          <=> v18748(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18751(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18748(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_143,axiom,
    ! [VarCurr: state_type] :
      ( v18751(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18748(VarCurr,B)
          <=> v18668(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1559,axiom,
    ! [VarCurr: state_type] :
      ( v18751(VarCurr)
    <=> ( v18752(VarCurr)
        & v18753(VarCurr) ) ) ).

tff(writeUnaryOperator_1064,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18753(VarCurr)
    <=> v18658(VarCurr) ) ).

tff(writeUnaryOperator_1063,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18752(VarCurr)
    <=> v18648(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18740(VarNext)
      <=> v18741(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18741(VarNext)
      <=> ( v18742(VarNext)
          & v18672(VarNext) ) ) ) ).

tff(writeUnaryOperator_1062,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18742(VarNext)
      <=> v18744(VarNext) ) ) ).

tff(addAssignment_9462,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18744(VarNext)
      <=> v18672(VarCurr) ) ) ).

tff(addAssignment_9461,axiom,
    ! [VarCurr: state_type] :
      ( v18672(VarCurr)
    <=> v18674(VarCurr) ) ).

tff(addAssignment_9460,axiom,
    ! [VarCurr: state_type] :
      ( v18674(VarCurr)
    <=> v18676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1556,axiom,
    ! [VarCurr: state_type] :
      ( v18676(VarCurr)
    <=> ( v18737(VarCurr)
        | v18733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1555,axiom,
    ! [VarCurr: state_type] :
      ( v18737(VarCurr)
    <=> ( v18678(VarCurr)
        & v18682(VarCurr) ) ) ).

tff(addAssignment_9459,axiom,
    ! [VarCurr: state_type] :
      ( v18733(VarCurr)
    <=> v18735(VarCurr) ) ).

tff(addAssignment_9458,axiom,
    ! [VarCurr: state_type] :
      ( v18735(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18717(VarNext)
       => ( v18682(VarNext)
        <=> v18682(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_213,axiom,
    ! [VarNext: state_type] :
      ( v18717(VarNext)
     => ( v18682(VarNext)
      <=> v18727(VarNext) ) ) ).

tff(addAssignment_9457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18727(VarNext)
      <=> v18725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1554,axiom,
    ! [VarCurr: state_type] :
      ( v18725(VarCurr)
    <=> ( v18728(VarCurr)
        & v18729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1553,axiom,
    ! [VarCurr: state_type] :
      ( v18729(VarCurr)
    <=> ( v18688(VarCurr)
        | v18712(VarCurr) ) ) ).

tff(writeUnaryOperator_1061,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18728(VarCurr)
    <=> v18684(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1552,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18717(VarNext)
      <=> v18718(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1551,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18718(VarNext)
      <=> ( v18720(VarNext)
          & v18722(VarNext) ) ) ) ).

tff(writeUnaryOperator_1060,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18722(VarCurr)
    <=> v18678(VarCurr) ) ).

tff(addAssignment_9456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18720(VarNext)
      <=> v18678(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_72,axiom,
    ( v18682(constB0)
  <=> $true ) ).

tff(addAssignment_9455,axiom,
    ! [VarCurr: state_type] :
      ( v18712(VarCurr)
    <=> v18714(VarCurr) ) ).

tff(addAssignment_9454,axiom,
    ! [VarCurr: state_type] :
      ( v18714(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9453,axiom,
    ! [VarCurr: state_type] :
      ( v18688(VarCurr)
    <=> v18690(VarCurr) ) ).

tff(addAssignment_9452,axiom,
    ! [VarCurr: state_type] :
      ( v18690(VarCurr)
    <=> v17998(VarCurr) ) ).

tff(addAssignment_9451,axiom,
    ! [VarCurr: state_type] :
      ( v17998(VarCurr)
    <=> v18693(VarCurr) ) ).

tff(addAssignment_9450,axiom,
    ! [VarCurr: state_type] :
      ( v18693(VarCurr)
    <=> v18695(VarCurr) ) ).

tff(writeUnaryOperator_1059,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18695(VarCurr)
    <=> v18709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1550,axiom,
    ! [VarCurr: state_type] :
      ( v18709(VarCurr)
    <=> ( v18710(VarCurr)
        | v18705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1549,axiom,
    ! [VarCurr: state_type] :
      ( v18710(VarCurr)
    <=> ( v18697(VarCurr)
        | v18701(VarCurr) ) ) ).

tff(addAssignment_9449,axiom,
    ! [VarCurr: state_type] :
      ( v18705(VarCurr)
    <=> v18707(VarCurr) ) ).

tff(addAssignment_9448,axiom,
    ! [VarCurr: state_type] :
      ( v18707(VarCurr)
    <=> v18087(VarCurr,2) ) ).

tff(addAssignment_9447,axiom,
    ! [VarCurr: state_type] :
      ( v18701(VarCurr)
    <=> v18703(VarCurr) ) ).

tff(addAssignment_9446,axiom,
    ! [VarCurr: state_type] :
      ( v18703(VarCurr)
    <=> v17661(VarCurr,1) ) ).

tff(addAssignment_9445,axiom,
    ! [VarCurr: state_type] :
      ( v18697(VarCurr)
    <=> v18699(VarCurr) ) ).

tff(addAssignment_9444,axiom,
    ! [VarCurr: state_type] :
      ( v18699(VarCurr)
    <=> v18087(VarCurr,0) ) ).

tff(addAssignment_9443,axiom,
    ! [VarCurr: state_type] :
      ( v18684(VarCurr)
    <=> v18686(VarCurr) ) ).

tff(addAssignment_9442,axiom,
    ! [VarCurr: state_type] :
      ( v18686(VarCurr)
    <=> $false ) ).

tff(addAssignment_9441,axiom,
    ! [VarCurr: state_type] :
      ( v18678(VarCurr)
    <=> v18680(VarCurr) ) ).

tff(addAssignment_9440,axiom,
    ! [VarCurr: state_type] :
      ( v18680(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9439,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18668(VarCurr,B)
      <=> v18670(VarCurr,B) ) ) ).

tff(addAssignment_9438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18670(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_9437,axiom,
    ! [VarCurr: state_type] :
      ( v18658(VarCurr)
    <=> v18660(VarCurr) ) ).

tff(addAssignment_9436,axiom,
    ! [VarCurr: state_type] :
      ( v18660(VarCurr)
    <=> v18662(VarCurr) ) ).

tff(addAssignment_9435,axiom,
    ! [VarCurr: state_type] :
      ( v18662(VarCurr)
    <=> v18664(VarCurr) ) ).

tff(addAssignment_9434,axiom,
    ! [VarCurr: state_type] :
      ( v18664(VarCurr)
    <=> v18666(VarCurr) ) ).

tff(addAssignment_9433,axiom,
    ! [VarCurr: state_type] :
      ( v18666(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9432,axiom,
    ! [VarCurr: state_type] :
      ( v18648(VarCurr)
    <=> v18650(VarCurr) ) ).

tff(addAssignment_9431,axiom,
    ! [VarCurr: state_type] :
      ( v18650(VarCurr)
    <=> v18652(VarCurr) ) ).

tff(addAssignment_9430,axiom,
    ! [VarCurr: state_type] :
      ( v18652(VarCurr)
    <=> v18654(VarCurr) ) ).

tff(addAssignment_9429,axiom,
    ! [VarCurr: state_type] :
      ( v18654(VarCurr)
    <=> v18656(VarCurr) ) ).

tff(addAssignment_9428,axiom,
    ! [VarCurr: state_type] :
      ( v18656(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_9427,axiom,
    ! [VarCurr: state_type] :
      ( v18607(VarCurr)
    <=> v18609(VarCurr) ) ).

tff(addAssignment_9426,axiom,
    ! [VarCurr: state_type] :
      ( v18609(VarCurr)
    <=> v18611(VarCurr) ) ).

tff(addAssignment_9425,axiom,
    ! [VarCurr: state_type] :
      ( v18611(VarCurr)
    <=> v18613(VarCurr) ) ).

tff(addAssignment_9424,axiom,
    ! [VarCurr: state_type] :
      ( v18613(VarCurr)
    <=> v18615(VarCurr) ) ).

tff(addAssignment_9423,axiom,
    ! [VarCurr: state_type] :
      ( v18615(VarCurr)
    <=> v18617(VarCurr) ) ).

tff(addAssignment_9422,axiom,
    ! [VarCurr: state_type] :
      ( v18617(VarCurr)
    <=> v18619(VarCurr) ) ).

tff(addAssignment_9421,axiom,
    ! [VarCurr: state_type] :
      ( v18619(VarCurr)
    <=> v18621(VarCurr) ) ).

tff(writeUnaryOperator_1058,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18621(VarCurr)
    <=> v18635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1548,axiom,
    ! [VarCurr: state_type] :
      ( v18635(VarCurr)
    <=> ( v18636(VarCurr)
        | v18631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1547,axiom,
    ! [VarCurr: state_type] :
      ( v18636(VarCurr)
    <=> ( v18623(VarCurr)
        | v18627(VarCurr) ) ) ).

tff(addAssignment_9420,axiom,
    ! [VarCurr: state_type] :
      ( v18631(VarCurr)
    <=> v18633(VarCurr) ) ).

tff(addAssignment_9419,axiom,
    ! [VarCurr: state_type] :
      ( v18633(VarCurr)
    <=> v17834(VarCurr,2) ) ).

tff(addAssignment_9418,axiom,
    ! [VarCurr: state_type] :
      ( v18627(VarCurr)
    <=> v18629(VarCurr) ) ).

tff(addAssignment_9417,axiom,
    ! [VarCurr: state_type] :
      ( v18629(VarCurr)
    <=> v17751(VarCurr,1) ) ).

tff(addAssignment_9416,axiom,
    ! [VarCurr: state_type] :
      ( v18623(VarCurr)
    <=> v18625(VarCurr) ) ).

tff(addAssignment_9415,axiom,
    ! [VarCurr: state_type] :
      ( v18625(VarCurr)
    <=> v17751(VarCurr,0) ) ).

tff(addAssignment_9414,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18487(VarCurr,B)
      <=> v18489(VarCurr,B) ) ) ).

tff(addAssignment_9413,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18489(VarCurr,B)
      <=> v18491(VarCurr,B) ) ) ).

tff(addAssignment_9412,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18491(VarCurr,B)
      <=> v18493(VarCurr,B) ) ) ).

tff(addAssignment_9411,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18493(VarCurr,B)
      <=> v18495(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18590(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18495(VarNext,B)
            <=> v18495(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_212,axiom,
    ! [VarNext: state_type] :
      ( v18590(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18495(VarNext,B)
          <=> v18600(VarNext,B) ) ) ) ).

tff(addAssignment_9410,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18600(VarNext,B)
          <=> v18598(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18598(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_142,axiom,
    ! [VarCurr: state_type] :
      ( v18601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18598(VarCurr,B)
          <=> v18517(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1546,axiom,
    ! [VarCurr: state_type] :
      ( v18601(VarCurr)
    <=> ( v18602(VarCurr)
        & v18603(VarCurr) ) ) ).

tff(writeUnaryOperator_1057,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18603(VarCurr)
    <=> v18507(VarCurr) ) ).

tff(writeUnaryOperator_1056,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18602(VarCurr)
    <=> v18497(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18590(VarNext)
      <=> v18591(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18591(VarNext)
      <=> ( v18592(VarNext)
          & v18521(VarNext) ) ) ) ).

tff(writeUnaryOperator_1055,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18592(VarNext)
      <=> v18594(VarNext) ) ) ).

tff(addAssignment_9409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18594(VarNext)
      <=> v18521(VarCurr) ) ) ).

tff(addAssignment_9408,axiom,
    ! [VarCurr: state_type] :
      ( v18521(VarCurr)
    <=> v18523(VarCurr) ) ).

tff(addAssignment_9407,axiom,
    ! [VarCurr: state_type] :
      ( v18523(VarCurr)
    <=> v18525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1543,axiom,
    ! [VarCurr: state_type] :
      ( v18525(VarCurr)
    <=> ( v18587(VarCurr)
        | v18583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1542,axiom,
    ! [VarCurr: state_type] :
      ( v18587(VarCurr)
    <=> ( v18527(VarCurr)
        & v18531(VarCurr) ) ) ).

tff(addAssignment_9406,axiom,
    ! [VarCurr: state_type] :
      ( v18583(VarCurr)
    <=> v18585(VarCurr) ) ).

tff(addAssignment_9405,axiom,
    ! [VarCurr: state_type] :
      ( v18585(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18567(VarNext)
       => ( v18531(VarNext)
        <=> v18531(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_211,axiom,
    ! [VarNext: state_type] :
      ( v18567(VarNext)
     => ( v18531(VarNext)
      <=> v18577(VarNext) ) ) ).

tff(addAssignment_9404,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18577(VarNext)
      <=> v18575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1541,axiom,
    ! [VarCurr: state_type] :
      ( v18575(VarCurr)
    <=> ( v18578(VarCurr)
        & v18579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1540,axiom,
    ! [VarCurr: state_type] :
      ( v18579(VarCurr)
    <=> ( v18537(VarCurr)
        | v18562(VarCurr) ) ) ).

tff(writeUnaryOperator_1054,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18578(VarCurr)
    <=> v18533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18567(VarNext)
      <=> v18568(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18568(VarNext)
      <=> ( v18570(VarNext)
          & v18572(VarNext) ) ) ) ).

tff(writeUnaryOperator_1053,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18572(VarCurr)
    <=> v18527(VarCurr) ) ).

tff(addAssignment_9403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18570(VarNext)
      <=> v18527(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_71,axiom,
    ( v18531(constB0)
  <=> $true ) ).

tff(addAssignment_9402,axiom,
    ! [VarCurr: state_type] :
      ( v18562(VarCurr)
    <=> v18564(VarCurr) ) ).

tff(addAssignment_9401,axiom,
    ! [VarCurr: state_type] :
      ( v18564(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9400,axiom,
    ! [VarCurr: state_type] :
      ( v18537(VarCurr)
    <=> v18539(VarCurr) ) ).

tff(addAssignment_9399,axiom,
    ! [VarCurr: state_type] :
      ( v18539(VarCurr)
    <=> v18541(VarCurr) ) ).

tff(addAssignment_9398,axiom,
    ! [VarCurr: state_type] :
      ( v18541(VarCurr)
    <=> v18543(VarCurr) ) ).

tff(addAssignment_9397,axiom,
    ! [VarCurr: state_type] :
      ( v18543(VarCurr)
    <=> v18545(VarCurr) ) ).

tff(writeUnaryOperator_1052,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18545(VarCurr)
    <=> v18559(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1537,axiom,
    ! [VarCurr: state_type] :
      ( v18559(VarCurr)
    <=> ( v18560(VarCurr)
        | v18555(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1536,axiom,
    ! [VarCurr: state_type] :
      ( v18560(VarCurr)
    <=> ( v18547(VarCurr)
        | v18551(VarCurr) ) ) ).

tff(addAssignment_9396,axiom,
    ! [VarCurr: state_type] :
      ( v18555(VarCurr)
    <=> v18557(VarCurr) ) ).

tff(addAssignment_9395,axiom,
    ! [VarCurr: state_type] :
      ( v18557(VarCurr)
    <=> v18087(VarCurr,2) ) ).

tff(addAssignment_9394,axiom,
    ! [VarCurr: state_type] :
      ( v18087(VarCurr,2)
    <=> v18089(VarCurr,2) ) ).

tff(addAssignment_9393,axiom,
    ! [VarCurr: state_type] :
      ( v18089(VarCurr,2)
    <=> v18091(VarCurr,2) ) ).

tff(addAssignment_9392,axiom,
    ! [VarCurr: state_type] :
      ( v18091(VarCurr,2)
    <=> v18096(VarCurr,2) ) ).

tff(addAssignment_9391,axiom,
    ! [VarCurr: state_type] :
      ( v18093(VarCurr,2)
    <=> v18095(VarCurr,2) ) ).

tff(addAssignment_9390,axiom,
    ! [VarCurr: state_type] :
      ( v18095(VarCurr,2)
    <=> v17661(VarCurr,2) ) ).

tff(addAssignment_9389,axiom,
    ! [VarCurr: state_type] :
      ( v18551(VarCurr)
    <=> v18553(VarCurr) ) ).

tff(addAssignment_9388,axiom,
    ! [VarCurr: state_type] :
      ( v18553(VarCurr)
    <=> v17661(VarCurr,1) ) ).

tff(addAssignment_9387,axiom,
    ! [VarCurr: state_type] :
      ( v18547(VarCurr)
    <=> v18549(VarCurr) ) ).

tff(addAssignment_9386,axiom,
    ! [VarCurr: state_type] :
      ( v18549(VarCurr)
    <=> v17661(VarCurr,0) ) ).

tff(addAssignment_9385,axiom,
    ! [VarCurr: state_type] :
      ( v18533(VarCurr)
    <=> v18535(VarCurr) ) ).

tff(addAssignment_9384,axiom,
    ! [VarCurr: state_type] :
      ( v18535(VarCurr)
    <=> $false ) ).

tff(addAssignment_9383,axiom,
    ! [VarCurr: state_type] :
      ( v18527(VarCurr)
    <=> v18529(VarCurr) ) ).

tff(addAssignment_9382,axiom,
    ! [VarCurr: state_type] :
      ( v18529(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9381,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18517(VarCurr,B)
      <=> v18519(VarCurr,B) ) ) ).

tff(addAssignment_9380,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18519(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_9379,axiom,
    ! [VarCurr: state_type] :
      ( v18507(VarCurr)
    <=> v18509(VarCurr) ) ).

tff(addAssignment_9378,axiom,
    ! [VarCurr: state_type] :
      ( v18509(VarCurr)
    <=> v18511(VarCurr) ) ).

tff(addAssignment_9377,axiom,
    ! [VarCurr: state_type] :
      ( v18511(VarCurr)
    <=> v18513(VarCurr) ) ).

tff(addAssignment_9376,axiom,
    ! [VarCurr: state_type] :
      ( v18513(VarCurr)
    <=> v18515(VarCurr) ) ).

tff(addAssignment_9375,axiom,
    ! [VarCurr: state_type] :
      ( v18515(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9374,axiom,
    ! [VarCurr: state_type] :
      ( v18497(VarCurr)
    <=> v18499(VarCurr) ) ).

tff(addAssignment_9373,axiom,
    ! [VarCurr: state_type] :
      ( v18499(VarCurr)
    <=> v18501(VarCurr) ) ).

tff(addAssignment_9372,axiom,
    ! [VarCurr: state_type] :
      ( v18501(VarCurr)
    <=> v18503(VarCurr) ) ).

tff(addAssignment_9371,axiom,
    ! [VarCurr: state_type] :
      ( v18503(VarCurr)
    <=> v18505(VarCurr) ) ).

tff(addAssignment_9370,axiom,
    ! [VarCurr: state_type] :
      ( v18505(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_9369,axiom,
    ! [VarCurr: state_type] :
      ( v18456(VarCurr)
    <=> v18458(VarCurr) ) ).

tff(addAssignment_9368,axiom,
    ! [VarCurr: state_type] :
      ( v18458(VarCurr)
    <=> v18460(VarCurr) ) ).

tff(addAssignment_9367,axiom,
    ! [VarCurr: state_type] :
      ( v18460(VarCurr)
    <=> v18462(VarCurr) ) ).

tff(addAssignment_9366,axiom,
    ! [VarCurr: state_type] :
      ( v18462(VarCurr)
    <=> v18464(VarCurr) ) ).

tff(addAssignment_9365,axiom,
    ! [VarCurr: state_type] :
      ( v18464(VarCurr)
    <=> v18466(VarCurr) ) ).

tff(addAssignment_9364,axiom,
    ! [VarCurr: state_type] :
      ( v18466(VarCurr)
    <=> v18468(VarCurr) ) ).

tff(addAssignment_9363,axiom,
    ! [VarCurr: state_type] :
      ( v18468(VarCurr)
    <=> v18470(VarCurr) ) ).

tff(writeUnaryOperator_1051,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18470(VarCurr)
    <=> v18484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1535,axiom,
    ! [VarCurr: state_type] :
      ( v18484(VarCurr)
    <=> ( v18485(VarCurr)
        | v18480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1534,axiom,
    ! [VarCurr: state_type] :
      ( v18485(VarCurr)
    <=> ( v18472(VarCurr)
        | v18476(VarCurr) ) ) ).

tff(addAssignment_9362,axiom,
    ! [VarCurr: state_type] :
      ( v18480(VarCurr)
    <=> v18482(VarCurr) ) ).

tff(addAssignment_9361,axiom,
    ! [VarCurr: state_type] :
      ( v18482(VarCurr)
    <=> v17751(VarCurr,2) ) ).

tff(addAssignment_9360,axiom,
    ! [VarCurr: state_type] :
      ( v18476(VarCurr)
    <=> v18478(VarCurr) ) ).

tff(addAssignment_9359,axiom,
    ! [VarCurr: state_type] :
      ( v18478(VarCurr)
    <=> v17834(VarCurr,1) ) ).

tff(addAssignment_9358,axiom,
    ! [VarCurr: state_type] :
      ( v18472(VarCurr)
    <=> v18474(VarCurr) ) ).

tff(addAssignment_9357,axiom,
    ! [VarCurr: state_type] :
      ( v18474(VarCurr)
    <=> v17834(VarCurr,0) ) ).

tff(addAssignment_9356,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18336(VarCurr,B)
      <=> v18338(VarCurr,B) ) ) ).

tff(addAssignment_9355,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18338(VarCurr,B)
      <=> v18340(VarCurr,B) ) ) ).

tff(addAssignment_9354,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18340(VarCurr,B)
      <=> v18342(VarCurr,B) ) ) ).

tff(addAssignment_9353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18342(VarCurr,B)
      <=> v18344(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18439(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18344(VarNext,B)
            <=> v18344(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_210,axiom,
    ! [VarNext: state_type] :
      ( v18439(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18344(VarNext,B)
          <=> v18449(VarNext,B) ) ) ) ).

tff(addAssignment_9352,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18449(VarNext,B)
          <=> v18447(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_141,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18450(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18447(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_141,axiom,
    ! [VarCurr: state_type] :
      ( v18450(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18447(VarCurr,B)
          <=> v18366(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1533,axiom,
    ! [VarCurr: state_type] :
      ( v18450(VarCurr)
    <=> ( v18451(VarCurr)
        & v18452(VarCurr) ) ) ).

tff(writeUnaryOperator_1050,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18452(VarCurr)
    <=> v18356(VarCurr) ) ).

tff(writeUnaryOperator_1049,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18451(VarCurr)
    <=> v18346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18439(VarNext)
      <=> v18440(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18440(VarNext)
      <=> ( v18441(VarNext)
          & v18370(VarNext) ) ) ) ).

tff(writeUnaryOperator_1048,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18441(VarNext)
      <=> v18443(VarNext) ) ) ).

tff(addAssignment_9351,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18443(VarNext)
      <=> v18370(VarCurr) ) ) ).

tff(addAssignment_9350,axiom,
    ! [VarCurr: state_type] :
      ( v18370(VarCurr)
    <=> v18372(VarCurr) ) ).

tff(addAssignment_9349,axiom,
    ! [VarCurr: state_type] :
      ( v18372(VarCurr)
    <=> v18374(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1530,axiom,
    ! [VarCurr: state_type] :
      ( v18374(VarCurr)
    <=> ( v18436(VarCurr)
        | v18432(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1529,axiom,
    ! [VarCurr: state_type] :
      ( v18436(VarCurr)
    <=> ( v18376(VarCurr)
        & v18380(VarCurr) ) ) ).

tff(addAssignment_9348,axiom,
    ! [VarCurr: state_type] :
      ( v18432(VarCurr)
    <=> v18434(VarCurr) ) ).

tff(addAssignment_9347,axiom,
    ! [VarCurr: state_type] :
      ( v18434(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18416(VarNext)
       => ( v18380(VarNext)
        <=> v18380(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_209,axiom,
    ! [VarNext: state_type] :
      ( v18416(VarNext)
     => ( v18380(VarNext)
      <=> v18426(VarNext) ) ) ).

tff(addAssignment_9346,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18426(VarNext)
      <=> v18424(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1528,axiom,
    ! [VarCurr: state_type] :
      ( v18424(VarCurr)
    <=> ( v18427(VarCurr)
        & v18428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1527,axiom,
    ! [VarCurr: state_type] :
      ( v18428(VarCurr)
    <=> ( v18386(VarCurr)
        | v18411(VarCurr) ) ) ).

tff(writeUnaryOperator_1047,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18427(VarCurr)
    <=> v18382(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1526,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18416(VarNext)
      <=> v18417(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1525,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18417(VarNext)
      <=> ( v18419(VarNext)
          & v18421(VarNext) ) ) ) ).

tff(writeUnaryOperator_1046,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18421(VarCurr)
    <=> v18376(VarCurr) ) ).

tff(addAssignment_9345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18419(VarNext)
      <=> v18376(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_70,axiom,
    ( v18380(constB0)
  <=> $true ) ).

tff(addAssignment_9344,axiom,
    ! [VarCurr: state_type] :
      ( v18411(VarCurr)
    <=> v18413(VarCurr) ) ).

tff(addAssignment_9343,axiom,
    ! [VarCurr: state_type] :
      ( v18413(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9342,axiom,
    ! [VarCurr: state_type] :
      ( v18386(VarCurr)
    <=> v18388(VarCurr) ) ).

tff(addAssignment_9341,axiom,
    ! [VarCurr: state_type] :
      ( v18388(VarCurr)
    <=> v18390(VarCurr) ) ).

tff(addAssignment_9340,axiom,
    ! [VarCurr: state_type] :
      ( v18390(VarCurr)
    <=> v18392(VarCurr) ) ).

tff(addAssignment_9339,axiom,
    ! [VarCurr: state_type] :
      ( v18392(VarCurr)
    <=> v18394(VarCurr) ) ).

tff(writeUnaryOperator_1045,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18394(VarCurr)
    <=> v18408(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1524,axiom,
    ! [VarCurr: state_type] :
      ( v18408(VarCurr)
    <=> ( v18409(VarCurr)
        | v18404(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1523,axiom,
    ! [VarCurr: state_type] :
      ( v18409(VarCurr)
    <=> ( v18396(VarCurr)
        | v18400(VarCurr) ) ) ).

tff(addAssignment_9338,axiom,
    ! [VarCurr: state_type] :
      ( v18404(VarCurr)
    <=> v18406(VarCurr) ) ).

tff(addAssignment_9337,axiom,
    ! [VarCurr: state_type] :
      ( v18406(VarCurr)
    <=> v17661(VarCurr,2) ) ).

tff(addAssignment_9336,axiom,
    ! [VarCurr: state_type] :
      ( v18400(VarCurr)
    <=> v18402(VarCurr) ) ).

tff(addAssignment_9335,axiom,
    ! [VarCurr: state_type] :
      ( v18402(VarCurr)
    <=> v18087(VarCurr,1) ) ).

tff(addAssignment_9334,axiom,
    ! [VarCurr: state_type] :
      ( v18396(VarCurr)
    <=> v18398(VarCurr) ) ).

tff(addAssignment_9333,axiom,
    ! [VarCurr: state_type] :
      ( v18398(VarCurr)
    <=> v18087(VarCurr,0) ) ).

tff(addAssignment_9332,axiom,
    ! [VarCurr: state_type] :
      ( v18382(VarCurr)
    <=> v18384(VarCurr) ) ).

tff(addAssignment_9331,axiom,
    ! [VarCurr: state_type] :
      ( v18384(VarCurr)
    <=> $false ) ).

tff(addAssignment_9330,axiom,
    ! [VarCurr: state_type] :
      ( v18376(VarCurr)
    <=> v18378(VarCurr) ) ).

tff(addAssignment_9329,axiom,
    ! [VarCurr: state_type] :
      ( v18378(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9328,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18366(VarCurr,B)
      <=> v18368(VarCurr,B) ) ) ).

tff(addAssignment_9327,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18368(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_9326,axiom,
    ! [VarCurr: state_type] :
      ( v18356(VarCurr)
    <=> v18358(VarCurr) ) ).

tff(addAssignment_9325,axiom,
    ! [VarCurr: state_type] :
      ( v18358(VarCurr)
    <=> v18360(VarCurr) ) ).

tff(addAssignment_9324,axiom,
    ! [VarCurr: state_type] :
      ( v18360(VarCurr)
    <=> v18362(VarCurr) ) ).

tff(addAssignment_9323,axiom,
    ! [VarCurr: state_type] :
      ( v18362(VarCurr)
    <=> v18364(VarCurr) ) ).

tff(addAssignment_9322,axiom,
    ! [VarCurr: state_type] :
      ( v18364(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9321,axiom,
    ! [VarCurr: state_type] :
      ( v18346(VarCurr)
    <=> v18348(VarCurr) ) ).

tff(addAssignment_9320,axiom,
    ! [VarCurr: state_type] :
      ( v18348(VarCurr)
    <=> v18350(VarCurr) ) ).

tff(addAssignment_9319,axiom,
    ! [VarCurr: state_type] :
      ( v18350(VarCurr)
    <=> v18352(VarCurr) ) ).

tff(addAssignment_9318,axiom,
    ! [VarCurr: state_type] :
      ( v18352(VarCurr)
    <=> v18354(VarCurr) ) ).

tff(addAssignment_9317,axiom,
    ! [VarCurr: state_type] :
      ( v18354(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_9316,axiom,
    ! [VarCurr: state_type] :
      ( v18305(VarCurr)
    <=> v18307(VarCurr) ) ).

tff(addAssignment_9315,axiom,
    ! [VarCurr: state_type] :
      ( v18307(VarCurr)
    <=> v18309(VarCurr) ) ).

tff(addAssignment_9314,axiom,
    ! [VarCurr: state_type] :
      ( v18309(VarCurr)
    <=> v18311(VarCurr) ) ).

tff(addAssignment_9313,axiom,
    ! [VarCurr: state_type] :
      ( v18311(VarCurr)
    <=> v18313(VarCurr) ) ).

tff(addAssignment_9312,axiom,
    ! [VarCurr: state_type] :
      ( v18313(VarCurr)
    <=> v18315(VarCurr) ) ).

tff(addAssignment_9311,axiom,
    ! [VarCurr: state_type] :
      ( v18315(VarCurr)
    <=> v18317(VarCurr) ) ).

tff(addAssignment_9310,axiom,
    ! [VarCurr: state_type] :
      ( v18317(VarCurr)
    <=> v18319(VarCurr) ) ).

tff(writeUnaryOperator_1044,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18319(VarCurr)
    <=> v18333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1522,axiom,
    ! [VarCurr: state_type] :
      ( v18333(VarCurr)
    <=> ( v18334(VarCurr)
        | v18329(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1521,axiom,
    ! [VarCurr: state_type] :
      ( v18334(VarCurr)
    <=> ( v18321(VarCurr)
        | v18325(VarCurr) ) ) ).

tff(addAssignment_9309,axiom,
    ! [VarCurr: state_type] :
      ( v18329(VarCurr)
    <=> v18331(VarCurr) ) ).

tff(addAssignment_9308,axiom,
    ! [VarCurr: state_type] :
      ( v18331(VarCurr)
    <=> v17751(VarCurr,2) ) ).

tff(addAssignment_9307,axiom,
    ! [VarCurr: state_type] :
      ( v18325(VarCurr)
    <=> v18327(VarCurr) ) ).

tff(addAssignment_9306,axiom,
    ! [VarCurr: state_type] :
      ( v18327(VarCurr)
    <=> v17834(VarCurr,1) ) ).

tff(addAssignment_9305,axiom,
    ! [VarCurr: state_type] :
      ( v17834(VarCurr,1)
    <=> v17836(VarCurr,1) ) ).

tff(addAssignment_9304,axiom,
    ! [VarCurr: state_type] :
      ( v17836(VarCurr,1)
    <=> v17838(VarCurr,1) ) ).

tff(addAssignment_9303,axiom,
    ! [VarCurr: state_type] :
      ( v17838(VarCurr,1)
    <=> v17843(VarCurr,1) ) ).

tff(addAssignment_9302,axiom,
    ! [VarCurr: state_type] :
      ( v17840(VarCurr,1)
    <=> v17842(VarCurr,1) ) ).

tff(addAssignment_9301,axiom,
    ! [VarCurr: state_type] :
      ( v17842(VarCurr,1)
    <=> v17751(VarCurr,1) ) ).

tff(addAssignment_9300,axiom,
    ! [VarCurr: state_type] :
      ( v18321(VarCurr)
    <=> v18323(VarCurr) ) ).

tff(addAssignment_9299,axiom,
    ! [VarCurr: state_type] :
      ( v18323(VarCurr)
    <=> v17751(VarCurr,0) ) ).

tff(addAssignment_9298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18185(VarCurr,B)
      <=> v18187(VarCurr,B) ) ) ).

tff(addAssignment_9297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18187(VarCurr,B)
      <=> v18189(VarCurr,B) ) ) ).

tff(addAssignment_9296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18189(VarCurr,B)
      <=> v18191(VarCurr,B) ) ) ).

tff(addAssignment_9295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18191(VarCurr,B)
      <=> v18193(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18288(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18193(VarNext,B)
            <=> v18193(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_208,axiom,
    ! [VarNext: state_type] :
      ( v18288(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18193(VarNext,B)
          <=> v18298(VarNext,B) ) ) ) ).

tff(addAssignment_9294,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18298(VarNext,B)
          <=> v18296(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18299(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18296(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_140,axiom,
    ! [VarCurr: state_type] :
      ( v18299(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18296(VarCurr,B)
          <=> v18215(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1520,axiom,
    ! [VarCurr: state_type] :
      ( v18299(VarCurr)
    <=> ( v18300(VarCurr)
        & v18301(VarCurr) ) ) ).

tff(writeUnaryOperator_1043,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18301(VarCurr)
    <=> v18205(VarCurr) ) ).

tff(writeUnaryOperator_1042,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18300(VarCurr)
    <=> v18195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18288(VarNext)
      <=> v18289(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1518,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18289(VarNext)
      <=> ( v18290(VarNext)
          & v18219(VarNext) ) ) ) ).

tff(writeUnaryOperator_1041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18290(VarNext)
      <=> v18292(VarNext) ) ) ).

tff(addAssignment_9293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18292(VarNext)
      <=> v18219(VarCurr) ) ) ).

tff(addAssignment_9292,axiom,
    ! [VarCurr: state_type] :
      ( v18219(VarCurr)
    <=> v18221(VarCurr) ) ).

tff(addAssignment_9291,axiom,
    ! [VarCurr: state_type] :
      ( v18221(VarCurr)
    <=> v18223(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1517,axiom,
    ! [VarCurr: state_type] :
      ( v18223(VarCurr)
    <=> ( v18285(VarCurr)
        | v18281(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1516,axiom,
    ! [VarCurr: state_type] :
      ( v18285(VarCurr)
    <=> ( v18225(VarCurr)
        & v18229(VarCurr) ) ) ).

tff(addAssignment_9290,axiom,
    ! [VarCurr: state_type] :
      ( v18281(VarCurr)
    <=> v18283(VarCurr) ) ).

tff(addAssignment_9289,axiom,
    ! [VarCurr: state_type] :
      ( v18283(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18265(VarNext)
       => ( v18229(VarNext)
        <=> v18229(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_207,axiom,
    ! [VarNext: state_type] :
      ( v18265(VarNext)
     => ( v18229(VarNext)
      <=> v18275(VarNext) ) ) ).

tff(addAssignment_9288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18275(VarNext)
      <=> v18273(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1515,axiom,
    ! [VarCurr: state_type] :
      ( v18273(VarCurr)
    <=> ( v18276(VarCurr)
        & v18277(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1514,axiom,
    ! [VarCurr: state_type] :
      ( v18277(VarCurr)
    <=> ( v18235(VarCurr)
        | v18260(VarCurr) ) ) ).

tff(writeUnaryOperator_1040,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18276(VarCurr)
    <=> v18231(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18265(VarNext)
      <=> v18266(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1512,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18266(VarNext)
      <=> ( v18268(VarNext)
          & v18270(VarNext) ) ) ) ).

tff(writeUnaryOperator_1039,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18270(VarCurr)
    <=> v18225(VarCurr) ) ).

tff(addAssignment_9287,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18268(VarNext)
      <=> v18225(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_69,axiom,
    ( v18229(constB0)
  <=> $true ) ).

tff(addAssignment_9286,axiom,
    ! [VarCurr: state_type] :
      ( v18260(VarCurr)
    <=> v18262(VarCurr) ) ).

tff(addAssignment_9285,axiom,
    ! [VarCurr: state_type] :
      ( v18262(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9284,axiom,
    ! [VarCurr: state_type] :
      ( v18235(VarCurr)
    <=> v18237(VarCurr) ) ).

tff(addAssignment_9283,axiom,
    ! [VarCurr: state_type] :
      ( v18237(VarCurr)
    <=> v18239(VarCurr) ) ).

tff(addAssignment_9282,axiom,
    ! [VarCurr: state_type] :
      ( v18239(VarCurr)
    <=> v18241(VarCurr) ) ).

tff(addAssignment_9281,axiom,
    ! [VarCurr: state_type] :
      ( v18241(VarCurr)
    <=> v18243(VarCurr) ) ).

tff(writeUnaryOperator_1038,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18243(VarCurr)
    <=> v18257(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1511,axiom,
    ! [VarCurr: state_type] :
      ( v18257(VarCurr)
    <=> ( v18258(VarCurr)
        | v18253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1510,axiom,
    ! [VarCurr: state_type] :
      ( v18258(VarCurr)
    <=> ( v18245(VarCurr)
        | v18249(VarCurr) ) ) ).

tff(addAssignment_9280,axiom,
    ! [VarCurr: state_type] :
      ( v18253(VarCurr)
    <=> v18255(VarCurr) ) ).

tff(addAssignment_9279,axiom,
    ! [VarCurr: state_type] :
      ( v18255(VarCurr)
    <=> v17661(VarCurr,2) ) ).

tff(addAssignment_9278,axiom,
    ! [VarCurr: state_type] :
      ( v18249(VarCurr)
    <=> v18251(VarCurr) ) ).

tff(addAssignment_9277,axiom,
    ! [VarCurr: state_type] :
      ( v18251(VarCurr)
    <=> v18087(VarCurr,1) ) ).

tff(addAssignment_9276,axiom,
    ! [VarCurr: state_type] :
      ( v18087(VarCurr,1)
    <=> v18089(VarCurr,1) ) ).

tff(addAssignment_9275,axiom,
    ! [VarCurr: state_type] :
      ( v18089(VarCurr,1)
    <=> v18091(VarCurr,1) ) ).

tff(addAssignment_9274,axiom,
    ! [VarCurr: state_type] :
      ( v18091(VarCurr,1)
    <=> v18096(VarCurr,1) ) ).

tff(addAssignment_9273,axiom,
    ! [VarCurr: state_type] :
      ( v18093(VarCurr,1)
    <=> v18095(VarCurr,1) ) ).

tff(addAssignment_9272,axiom,
    ! [VarCurr: state_type] :
      ( v18095(VarCurr,1)
    <=> v17661(VarCurr,1) ) ).

tff(addAssignment_9271,axiom,
    ! [VarCurr: state_type] :
      ( v18245(VarCurr)
    <=> v18247(VarCurr) ) ).

tff(addAssignment_9270,axiom,
    ! [VarCurr: state_type] :
      ( v18247(VarCurr)
    <=> v17661(VarCurr,0) ) ).

tff(addAssignment_9269,axiom,
    ! [VarCurr: state_type] :
      ( v18231(VarCurr)
    <=> v18233(VarCurr) ) ).

tff(addAssignment_9268,axiom,
    ! [VarCurr: state_type] :
      ( v18233(VarCurr)
    <=> $false ) ).

tff(addAssignment_9267,axiom,
    ! [VarCurr: state_type] :
      ( v18225(VarCurr)
    <=> v18227(VarCurr) ) ).

tff(addAssignment_9266,axiom,
    ! [VarCurr: state_type] :
      ( v18227(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18215(VarCurr,B)
      <=> v18217(VarCurr,B) ) ) ).

tff(addAssignment_9264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18217(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_9263,axiom,
    ! [VarCurr: state_type] :
      ( v18205(VarCurr)
    <=> v18207(VarCurr) ) ).

tff(addAssignment_9262,axiom,
    ! [VarCurr: state_type] :
      ( v18207(VarCurr)
    <=> v18209(VarCurr) ) ).

tff(addAssignment_9261,axiom,
    ! [VarCurr: state_type] :
      ( v18209(VarCurr)
    <=> v18211(VarCurr) ) ).

tff(addAssignment_9260,axiom,
    ! [VarCurr: state_type] :
      ( v18211(VarCurr)
    <=> v18213(VarCurr) ) ).

tff(addAssignment_9259,axiom,
    ! [VarCurr: state_type] :
      ( v18213(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9258,axiom,
    ! [VarCurr: state_type] :
      ( v18195(VarCurr)
    <=> v18197(VarCurr) ) ).

tff(addAssignment_9257,axiom,
    ! [VarCurr: state_type] :
      ( v18197(VarCurr)
    <=> v18199(VarCurr) ) ).

tff(addAssignment_9256,axiom,
    ! [VarCurr: state_type] :
      ( v18199(VarCurr)
    <=> v18201(VarCurr) ) ).

tff(addAssignment_9255,axiom,
    ! [VarCurr: state_type] :
      ( v18201(VarCurr)
    <=> v18203(VarCurr) ) ).

tff(addAssignment_9254,axiom,
    ! [VarCurr: state_type] :
      ( v18203(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_9253,axiom,
    ! [VarCurr: state_type] :
      ( v18154(VarCurr)
    <=> v18156(VarCurr) ) ).

tff(addAssignment_9252,axiom,
    ! [VarCurr: state_type] :
      ( v18156(VarCurr)
    <=> v18158(VarCurr) ) ).

tff(addAssignment_9251,axiom,
    ! [VarCurr: state_type] :
      ( v18158(VarCurr)
    <=> v18160(VarCurr) ) ).

tff(addAssignment_9250,axiom,
    ! [VarCurr: state_type] :
      ( v18160(VarCurr)
    <=> v18162(VarCurr) ) ).

tff(addAssignment_9249,axiom,
    ! [VarCurr: state_type] :
      ( v18162(VarCurr)
    <=> v18164(VarCurr) ) ).

tff(addAssignment_9248,axiom,
    ! [VarCurr: state_type] :
      ( v18164(VarCurr)
    <=> v18166(VarCurr) ) ).

tff(addAssignment_9247,axiom,
    ! [VarCurr: state_type] :
      ( v18166(VarCurr)
    <=> v18168(VarCurr) ) ).

tff(writeUnaryOperator_1037,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18168(VarCurr)
    <=> v18182(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1509,axiom,
    ! [VarCurr: state_type] :
      ( v18182(VarCurr)
    <=> ( v18183(VarCurr)
        | v18178(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1508,axiom,
    ! [VarCurr: state_type] :
      ( v18183(VarCurr)
    <=> ( v18170(VarCurr)
        | v18174(VarCurr) ) ) ).

tff(addAssignment_9246,axiom,
    ! [VarCurr: state_type] :
      ( v18178(VarCurr)
    <=> v18180(VarCurr) ) ).

tff(addAssignment_9245,axiom,
    ! [VarCurr: state_type] :
      ( v18180(VarCurr)
    <=> v17751(VarCurr,2) ) ).

tff(addAssignment_9244,axiom,
    ! [VarCurr: state_type] :
      ( v18174(VarCurr)
    <=> v18176(VarCurr) ) ).

tff(addAssignment_9243,axiom,
    ! [VarCurr: state_type] :
      ( v18176(VarCurr)
    <=> v17751(VarCurr,1) ) ).

tff(addAssignment_9242,axiom,
    ! [VarCurr: state_type] :
      ( v18170(VarCurr)
    <=> v18172(VarCurr) ) ).

tff(addAssignment_9241,axiom,
    ! [VarCurr: state_type] :
      ( v18172(VarCurr)
    <=> v17834(VarCurr,0) ) ).

tff(addAssignment_9240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18023(VarCurr,B)
      <=> v18025(VarCurr,B) ) ) ).

tff(addAssignment_9239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18025(VarCurr,B)
      <=> v18027(VarCurr,B) ) ) ).

tff(addAssignment_9238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18027(VarCurr,B)
      <=> v18029(VarCurr,B) ) ) ).

tff(addAssignment_9237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18029(VarCurr,B)
      <=> v18031(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18137(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v18031(VarNext,B)
            <=> v18031(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_206,axiom,
    ! [VarNext: state_type] :
      ( v18137(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18031(VarNext,B)
          <=> v18147(VarNext,B) ) ) ) ).

tff(addAssignment_9236,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18147(VarNext,B)
          <=> v18145(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18148(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18145(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_139,axiom,
    ! [VarCurr: state_type] :
      ( v18148(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v18145(VarCurr,B)
          <=> v18053(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1507,axiom,
    ! [VarCurr: state_type] :
      ( v18148(VarCurr)
    <=> ( v18149(VarCurr)
        & v18150(VarCurr) ) ) ).

tff(writeUnaryOperator_1036,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18150(VarCurr)
    <=> v18043(VarCurr) ) ).

tff(writeUnaryOperator_1035,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18149(VarCurr)
    <=> v18033(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1506,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18137(VarNext)
      <=> v18138(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1505,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18138(VarNext)
      <=> ( v18139(VarNext)
          & v18057(VarNext) ) ) ) ).

tff(writeUnaryOperator_1034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18139(VarNext)
      <=> v18141(VarNext) ) ) ).

tff(addAssignment_9235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18141(VarNext)
      <=> v18057(VarCurr) ) ) ).

tff(addAssignment_9234,axiom,
    ! [VarCurr: state_type] :
      ( v18057(VarCurr)
    <=> v18059(VarCurr) ) ).

tff(addAssignment_9233,axiom,
    ! [VarCurr: state_type] :
      ( v18059(VarCurr)
    <=> v18061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1504,axiom,
    ! [VarCurr: state_type] :
      ( v18061(VarCurr)
    <=> ( v18134(VarCurr)
        | v18130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1503,axiom,
    ! [VarCurr: state_type] :
      ( v18134(VarCurr)
    <=> ( v18063(VarCurr)
        & v18067(VarCurr) ) ) ).

tff(addAssignment_9232,axiom,
    ! [VarCurr: state_type] :
      ( v18130(VarCurr)
    <=> v18132(VarCurr) ) ).

tff(addAssignment_9231,axiom,
    ! [VarCurr: state_type] :
      ( v18132(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18114(VarNext)
       => ( v18067(VarNext)
        <=> v18067(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_205,axiom,
    ! [VarNext: state_type] :
      ( v18114(VarNext)
     => ( v18067(VarNext)
      <=> v18124(VarNext) ) ) ).

tff(addAssignment_9230,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18124(VarNext)
      <=> v18122(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1502,axiom,
    ! [VarCurr: state_type] :
      ( v18122(VarCurr)
    <=> ( v18125(VarCurr)
        & v18126(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1501,axiom,
    ! [VarCurr: state_type] :
      ( v18126(VarCurr)
    <=> ( v18073(VarCurr)
        | v18109(VarCurr) ) ) ).

tff(writeUnaryOperator_1033,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18125(VarCurr)
    <=> v18069(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1500,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18114(VarNext)
      <=> v18115(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18115(VarNext)
      <=> ( v18117(VarNext)
          & v18119(VarNext) ) ) ) ).

tff(writeUnaryOperator_1032,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18119(VarCurr)
    <=> v18063(VarCurr) ) ).

tff(addAssignment_9229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18117(VarNext)
      <=> v18063(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_68,axiom,
    ( v18067(constB0)
  <=> $true ) ).

tff(addAssignment_9228,axiom,
    ! [VarCurr: state_type] :
      ( v18109(VarCurr)
    <=> v18111(VarCurr) ) ).

tff(addAssignment_9227,axiom,
    ! [VarCurr: state_type] :
      ( v18111(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9226,axiom,
    ! [VarCurr: state_type] :
      ( v18073(VarCurr)
    <=> v18075(VarCurr) ) ).

tff(addAssignment_9225,axiom,
    ! [VarCurr: state_type] :
      ( v18075(VarCurr)
    <=> v18077(VarCurr) ) ).

tff(addAssignment_9224,axiom,
    ! [VarCurr: state_type] :
      ( v18077(VarCurr)
    <=> v18079(VarCurr) ) ).

tff(addAssignment_9223,axiom,
    ! [VarCurr: state_type] :
      ( v18079(VarCurr)
    <=> v18081(VarCurr) ) ).

tff(writeUnaryOperator_1031,axiom,
    ! [VarCurr: state_type] :
      ( ~ v18081(VarCurr)
    <=> v18106(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1498,axiom,
    ! [VarCurr: state_type] :
      ( v18106(VarCurr)
    <=> ( v18107(VarCurr)
        | v18102(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1497,axiom,
    ! [VarCurr: state_type] :
      ( v18107(VarCurr)
    <=> ( v18083(VarCurr)
        | v18098(VarCurr) ) ) ).

tff(addAssignment_9222,axiom,
    ! [VarCurr: state_type] :
      ( v18102(VarCurr)
    <=> v18104(VarCurr) ) ).

tff(addAssignment_9221,axiom,
    ! [VarCurr: state_type] :
      ( v18104(VarCurr)
    <=> v17661(VarCurr,2) ) ).

tff(addAssignment_9220,axiom,
    ! [VarCurr: state_type] :
      ( v18098(VarCurr)
    <=> v18100(VarCurr) ) ).

tff(addAssignment_9219,axiom,
    ! [VarCurr: state_type] :
      ( v18100(VarCurr)
    <=> v17661(VarCurr,1) ) ).

tff(addAssignment_9218,axiom,
    ! [VarCurr: state_type] :
      ( v18083(VarCurr)
    <=> v18085(VarCurr) ) ).

tff(addAssignment_9217,axiom,
    ! [VarCurr: state_type] :
      ( v18085(VarCurr)
    <=> v18087(VarCurr,0) ) ).

tff(addAssignment_9216,axiom,
    ! [VarCurr: state_type] :
      ( v18087(VarCurr,0)
    <=> v18089(VarCurr,0) ) ).

tff(addAssignment_9215,axiom,
    ! [VarCurr: state_type] :
      ( v18089(VarCurr,0)
    <=> v18091(VarCurr,0) ) ).

tff(addAssignment_9214,axiom,
    ! [VarCurr: state_type] :
      ( v18091(VarCurr,0)
    <=> v18096(VarCurr,0) ) ).

tff(writeUnaryOperator_1030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v18096(VarCurr,B)
      <=> ~ v18093(VarCurr,B) ) ) ).

tff(addAssignment_9213,axiom,
    ! [VarCurr: state_type] :
      ( v18093(VarCurr,0)
    <=> v18095(VarCurr,0) ) ).

tff(addAssignment_9212,axiom,
    ! [VarCurr: state_type] :
      ( v18095(VarCurr,0)
    <=> v17661(VarCurr,0) ) ).

tff(addAssignment_9211,axiom,
    ! [VarCurr: state_type] :
      ( v18069(VarCurr)
    <=> v18071(VarCurr) ) ).

tff(addAssignment_9210,axiom,
    ! [VarCurr: state_type] :
      ( v18071(VarCurr)
    <=> $false ) ).

tff(addAssignment_9209,axiom,
    ! [VarCurr: state_type] :
      ( v18063(VarCurr)
    <=> v18065(VarCurr) ) ).

tff(addAssignment_9208,axiom,
    ! [VarCurr: state_type] :
      ( v18065(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18053(VarCurr,B)
      <=> v18055(VarCurr,B) ) ) ).

tff(addAssignment_9206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v18055(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_9205,axiom,
    ! [VarCurr: state_type] :
      ( v18043(VarCurr)
    <=> v18045(VarCurr) ) ).

tff(addAssignment_9204,axiom,
    ! [VarCurr: state_type] :
      ( v18045(VarCurr)
    <=> v18047(VarCurr) ) ).

tff(addAssignment_9203,axiom,
    ! [VarCurr: state_type] :
      ( v18047(VarCurr)
    <=> v18049(VarCurr) ) ).

tff(addAssignment_9202,axiom,
    ! [VarCurr: state_type] :
      ( v18049(VarCurr)
    <=> v18051(VarCurr) ) ).

tff(addAssignment_9201,axiom,
    ! [VarCurr: state_type] :
      ( v18051(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9200,axiom,
    ! [VarCurr: state_type] :
      ( v18033(VarCurr)
    <=> v18035(VarCurr) ) ).

tff(addAssignment_9199,axiom,
    ! [VarCurr: state_type] :
      ( v18035(VarCurr)
    <=> v18037(VarCurr) ) ).

tff(addAssignment_9198,axiom,
    ! [VarCurr: state_type] :
      ( v18037(VarCurr)
    <=> v18039(VarCurr) ) ).

tff(addAssignment_9197,axiom,
    ! [VarCurr: state_type] :
      ( v18039(VarCurr)
    <=> v18041(VarCurr) ) ).

tff(addAssignment_9196,axiom,
    ! [VarCurr: state_type] :
      ( v18041(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_9195,axiom,
    ! [VarCurr: state_type] :
      ( v17731(VarCurr)
    <=> v17733(VarCurr) ) ).

tff(addAssignment_9194,axiom,
    ! [VarCurr: state_type] :
      ( v17733(VarCurr)
    <=> v17735(VarCurr) ) ).

tff(addAssignment_9193,axiom,
    ! [VarCurr: state_type] :
      ( v17735(VarCurr)
    <=> v17737(VarCurr) ) ).

tff(addAssignment_9192,axiom,
    ! [VarCurr: state_type] :
      ( v17737(VarCurr)
    <=> v17739(VarCurr) ) ).

tff(addAssignment_9191,axiom,
    ! [VarCurr: state_type] :
      ( v17739(VarCurr)
    <=> v17741(VarCurr) ) ).

tff(addAssignment_9190,axiom,
    ! [VarCurr: state_type] :
      ( v17741(VarCurr)
    <=> v17743(VarCurr) ) ).

tff(addAssignment_9189,axiom,
    ! [VarCurr: state_type] :
      ( v17743(VarCurr)
    <=> v17745(VarCurr) ) ).

tff(writeUnaryOperator_1029,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17745(VarCurr)
    <=> v18020(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1496,axiom,
    ! [VarCurr: state_type] :
      ( v18020(VarCurr)
    <=> ( v18021(VarCurr)
        | v18016(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1495,axiom,
    ! [VarCurr: state_type] :
      ( v18021(VarCurr)
    <=> ( v17747(VarCurr)
        | v18012(VarCurr) ) ) ).

tff(addAssignment_9188,axiom,
    ! [VarCurr: state_type] :
      ( v18016(VarCurr)
    <=> v18018(VarCurr) ) ).

tff(addAssignment_9187,axiom,
    ! [VarCurr: state_type] :
      ( v18018(VarCurr)
    <=> v17751(VarCurr,2) ) ).

tff(addAssignment_9186,axiom,
    ! [VarCurr: state_type] :
      ( v18012(VarCurr)
    <=> v18014(VarCurr) ) ).

tff(addAssignment_9185,axiom,
    ! [VarCurr: state_type] :
      ( v18014(VarCurr)
    <=> v17751(VarCurr,1) ) ).

tff(addAssignment_9184,axiom,
    ! [VarCurr: state_type] :
      ( v17747(VarCurr)
    <=> v17749(VarCurr) ) ).

tff(addAssignment_9183,axiom,
    ! [VarCurr: state_type] :
      ( v17749(VarCurr)
    <=> v17751(VarCurr,0) ) ).

tff(addAssignment_9182,axiom,
    ! [VarCurr: state_type] :
      ( v17751(VarCurr,0)
    <=> v17663(VarCurr,3) ) ).

tff(addAssignment_9181,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,3)
    <=> v17665(VarCurr,3) ) ).

tff(addAssignment_9180,axiom,
    ! [VarNext: state_type] :
      ( v17665(VarNext,3)
    <=> v18004(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18005(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v18004(VarNext,B)
            <=> v17665(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_204,axiom,
    ! [VarNext: state_type] :
      ( v18005(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v18004(VarNext,B)
          <=> v17976(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18005(VarNext)
      <=> v18006(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v18006(VarNext)
      <=> ( v18008(VarNext)
          & v17918(VarNext) ) ) ) ).

tff(writeUnaryOperator_1028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v18008(VarNext)
      <=> v17970(VarNext) ) ) ).

tff(addAssignment_9179,axiom,
    ! [VarCurr: state_type] :
      ( v17775(VarCurr,3)
    <=> v17777(VarCurr,3) ) ).

tff(addAssignment_9178,axiom,
    ! [VarCurr: state_type] :
      ( v17777(VarCurr,3)
    <=> v17915(VarCurr,3) ) ).

tff(addAssignment_9177,axiom,
    ! [VarCurr: state_type] :
      ( v17779(VarCurr,0)
    <=> v17781(VarCurr,0) ) ).

tff(addAssignment_9176,axiom,
    ! [VarCurr: state_type] :
      ( v17781(VarCurr,0)
    <=> v17783(VarCurr,0) ) ).

tff(addAssignment_9175,axiom,
    ! [VarCurr: state_type] :
      ( v17783(VarCurr,0)
    <=> v17914(VarCurr,0) ) ).

tff(addAssignment_9174,axiom,
    ! [VarCurr: state_type] :
      ( v17851(VarCurr,0)
    <=> v17853(VarCurr,0) ) ).

tff(addAssignment_9173,axiom,
    ! [VarCurr: state_type] :
      ( v17853(VarCurr,0)
    <=> v17855(VarCurr,0) ) ).

tff(addAssignment_9172,axiom,
    ! [VarCurr: state_type] :
      ( v17855(VarCurr,0)
    <=> v17857(VarCurr,0) ) ).

tff(addAssignment_9171,axiom,
    ! [VarCurr: state_type] :
      ( v17857(VarCurr,0)
    <=> v17859(VarCurr,0) ) ).

tff(addAssignment_9170,axiom,
    ! [VarCurr: state_type] :
      ( v17859(VarCurr,0)
    <=> v17869(VarCurr,0) ) ).

tff(addAssignment_9169,axiom,
    ! [VarCurr: state_type] :
      ( v17785(VarCurr,0)
    <=> v17787(VarCurr,0) ) ).

tff(addAssignment_9168,axiom,
    ! [VarCurr: state_type] :
      ( v17787(VarCurr,0)
    <=> v17848(VarCurr,0) ) ).

tff(addAssignment_9167,axiom,
    ! [VarCurr: state_type] :
      ( v17789(VarCurr)
    <=> v17315(VarCurr,2) ) ).

tff(addAssignment_9166,axiom,
    ! [VarCurr: state_type] :
      ( v17315(VarCurr,2)
    <=> v17317(VarCurr,2) ) ).

tff(addAssignment_9165,axiom,
    ! [VarCurr: state_type] :
      ( v17317(VarCurr,2)
    <=> v17327(VarCurr,2) ) ).

tff(addAssignment_9164,axiom,
    ! [VarCurr: state_type] :
      ( v17319(VarCurr,2)
    <=> v17321(VarCurr,2) ) ).

tff(addAssignment_9163,axiom,
    ! [VarCurr: state_type] :
      ( v17321(VarCurr,2)
    <=> v17324(VarCurr,2) ) ).

tff(addAssignment_9162,axiom,
    ! [VarCurr: state_type] :
      ( v17325(VarCurr)
    <=> v17792(VarCurr,1) ) ).

tff(addAssignment_9161,axiom,
    ! [VarCurr: state_type] :
      ( v17792(VarCurr,1)
    <=> v17794(VarCurr,1) ) ).

tff(addAssignment_9160,axiom,
    ! [VarCurr: state_type] :
      ( v17794(VarCurr,1)
    <=> v18002(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_307,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v18002(VarCurr,B)
      <=> ( v17796(VarCurr,B)
          | v17802(VarCurr,B) ) ) ) ).

tff(addAssignment_9159,axiom,
    ! [VarCurr: state_type] :
      ( v17802(VarCurr,1)
    <=> v17804(VarCurr,1) ) ).

tff(addAssignment_9158,axiom,
    ! [VarCurr: state_type] :
      ( v17804(VarCurr,1)
    <=> v18000(VarCurr,1) ) ).

tff(addAssignment_9157,axiom,
    ! [VarCurr: state_type] :
      ( v18000(VarCurr,0)
    <=> v18001(VarCurr) ) ).

tff(addAssignment_9156,axiom,
    ! [VarCurr: state_type] :
      ( v18000(VarCurr,1)
    <=> v17806(VarCurr) ) ).

tff(addAssignment_9155,axiom,
    ! [VarCurr: state_type] :
      ( v17806(VarCurr)
    <=> v17808(VarCurr,1) ) ).

tff(addAssignment_9154,axiom,
    ! [VarCurr: state_type] :
      ( v17808(VarCurr,1)
    <=> v17810(VarCurr,1) ) ).

tff(addAssignment_9153,axiom,
    ! [VarCurr: state_type] :
      ( v17810(VarCurr,1)
    <=> v17999(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_306,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v17999(VarCurr,B)
      <=> ( v17812(VarCurr,B)
          & v17820(VarCurr,B) ) ) ) ).

tff(addAssignment_9152,axiom,
    ! [VarCurr: state_type] :
      ( v17820(VarCurr,1)
    <=> v17822(VarCurr,1) ) ).

tff(addAssignment_9151,axiom,
    ! [VarCurr: state_type] :
      ( v17822(VarCurr,1)
    <=> v17997(VarCurr,1) ) ).

tff(addAssignment_9150,axiom,
    ! [VarCurr: state_type] :
      ( v17997(VarCurr,0)
    <=> v17998(VarCurr) ) ).

tff(addAssignment_9149,axiom,
    ! [VarCurr: state_type] :
      ( v17997(VarCurr,1)
    <=> v17824(VarCurr) ) ).

tff(addAssignment_9148,axiom,
    ! [VarCurr: state_type] :
      ( v17824(VarCurr)
    <=> v17826(VarCurr) ) ).

tff(addAssignment_9147,axiom,
    ! [VarCurr: state_type] :
      ( v17826(VarCurr)
    <=> v17828(VarCurr) ) ).

tff(writeUnaryOperator_1027,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17828(VarCurr)
    <=> v17995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1492,axiom,
    ! [VarCurr: state_type] :
      ( v17995(VarCurr)
    <=> ( v17996(VarCurr)
        | v17983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1491,axiom,
    ! [VarCurr: state_type] :
      ( v17996(VarCurr)
    <=> ( v17830(VarCurr)
        | v17845(VarCurr) ) ) ).

tff(addAssignment_9146,axiom,
    ! [VarCurr: state_type] :
      ( v17983(VarCurr)
    <=> v17985(VarCurr) ) ).

tff(addAssignment_9145,axiom,
    ! [VarCurr: state_type] :
      ( v17985(VarCurr)
    <=> v17834(VarCurr,2) ) ).

tff(addAssignment_9144,axiom,
    ! [VarCurr: state_type] :
      ( v17834(VarCurr,2)
    <=> v17836(VarCurr,2) ) ).

tff(addAssignment_9143,axiom,
    ! [VarCurr: state_type] :
      ( v17836(VarCurr,2)
    <=> v17838(VarCurr,2) ) ).

tff(addAssignment_9142,axiom,
    ! [VarCurr: state_type] :
      ( v17838(VarCurr,2)
    <=> v17843(VarCurr,2) ) ).

tff(addAssignment_9141,axiom,
    ! [VarCurr: state_type] :
      ( v17840(VarCurr,2)
    <=> v17842(VarCurr,2) ) ).

tff(addAssignment_9140,axiom,
    ! [VarCurr: state_type] :
      ( v17842(VarCurr,2)
    <=> v17751(VarCurr,2) ) ).

tff(addAssignment_9139,axiom,
    ! [VarCurr: state_type] :
      ( v17751(VarCurr,2)
    <=> v17663(VarCurr,5) ) ).

tff(addAssignment_9138,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,5)
    <=> v17665(VarCurr,5) ) ).

tff(addAssignment_9137,axiom,
    ! [VarNext: state_type] :
      ( v17665(VarNext,5)
    <=> v17987(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17988(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v17987(VarNext,B)
            <=> v17665(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_203,axiom,
    ! [VarNext: state_type] :
      ( v17988(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v17987(VarNext,B)
          <=> v17976(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17988(VarNext)
      <=> v17989(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17989(VarNext)
      <=> ( v17991(VarNext)
          & v17918(VarNext) ) ) ) ).

tff(writeUnaryOperator_1026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17991(VarNext)
      <=> v17970(VarNext) ) ) ).

tff(addAssignment_9136,axiom,
    ! [VarCurr: state_type] :
      ( v17775(VarCurr,5)
    <=> v17777(VarCurr,5) ) ).

tff(addAssignment_9135,axiom,
    ! [VarCurr: state_type] :
      ( v17777(VarCurr,5)
    <=> v17915(VarCurr,5) ) ).

tff(addAssignment_9134,axiom,
    ! [VarCurr: state_type] :
      ( v17779(VarCurr,2)
    <=> v17781(VarCurr,2) ) ).

tff(addAssignment_9133,axiom,
    ! [VarCurr: state_type] :
      ( v17781(VarCurr,2)
    <=> v17783(VarCurr,2) ) ).

tff(addAssignment_9132,axiom,
    ! [VarCurr: state_type] :
      ( v17783(VarCurr,2)
    <=> v17914(VarCurr,2) ) ).

tff(addAssignment_9131,axiom,
    ! [VarCurr: state_type] :
      ( v17851(VarCurr,2)
    <=> v17853(VarCurr,2) ) ).

tff(addAssignment_9130,axiom,
    ! [VarCurr: state_type] :
      ( v17853(VarCurr,2)
    <=> v17855(VarCurr,2) ) ).

tff(addAssignment_9129,axiom,
    ! [VarCurr: state_type] :
      ( v17855(VarCurr,2)
    <=> v17857(VarCurr,2) ) ).

tff(addAssignment_9128,axiom,
    ! [VarCurr: state_type] :
      ( v17857(VarCurr,2)
    <=> v17859(VarCurr,2) ) ).

tff(addAssignment_9127,axiom,
    ! [VarCurr: state_type] :
      ( v17859(VarCurr,2)
    <=> v17869(VarCurr,2) ) ).

tff(addAssignment_9126,axiom,
    ! [VarCurr: state_type] :
      ( v17861(VarCurr,2)
    <=> v17863(VarCurr,2) ) ).

tff(addAssignment_9125,axiom,
    ! [VarCurr: state_type] :
      ( v17863(VarCurr,2)
    <=> v17864(VarCurr,2) ) ).

tff(addAssignment_9124,axiom,
    ! [VarCurr: state_type] :
      ( v17785(VarCurr,2)
    <=> v17787(VarCurr,2) ) ).

tff(addAssignment_9123,axiom,
    ! [VarCurr: state_type] :
      ( v17787(VarCurr,2)
    <=> v17848(VarCurr,2) ) ).

tff(addAssignment_9122,axiom,
    ! [VarCurr: state_type] :
      ( v17845(VarCurr)
    <=> v17847(VarCurr) ) ).

tff(addAssignment_9121,axiom,
    ! [VarCurr: state_type] :
      ( v17847(VarCurr)
    <=> v17751(VarCurr,1) ) ).

tff(addAssignment_9120,axiom,
    ! [VarCurr: state_type] :
      ( v17751(VarCurr,1)
    <=> v17663(VarCurr,4) ) ).

tff(addAssignment_9119,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,4)
    <=> v17665(VarCurr,4) ) ).

tff(addAssignment_9118,axiom,
    ! [VarNext: state_type] :
      ( v17665(VarNext,4)
    <=> v17965(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17966(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v17965(VarNext,B)
            <=> v17665(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_202,axiom,
    ! [VarNext: state_type] :
      ( v17966(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v17965(VarNext,B)
          <=> v17976(VarNext,B) ) ) ) ).

tff(addAssignment_9117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v17976(VarNext,B)
          <=> v17974(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17977(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v17974(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_138,axiom,
    ! [VarCurr: state_type] :
      ( v17977(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v17974(VarCurr,B)
          <=> v17775(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1488,axiom,
    ! [VarCurr: state_type] :
      ( v17977(VarCurr)
    <=> ( v17978(VarCurr)
        & v17979(VarCurr) ) ) ).

tff(writeUnaryOperator_1025,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17979(VarCurr)
    <=> v17765(VarCurr) ) ).

tff(writeUnaryOperator_1024,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17978(VarCurr)
    <=> v17753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17966(VarNext)
      <=> v17967(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17967(VarNext)
      <=> ( v17968(VarNext)
          & v17918(VarNext) ) ) ) ).

tff(writeUnaryOperator_1023,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17968(VarNext)
      <=> v17970(VarNext) ) ) ).

tff(addAssignment_9116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17970(VarNext)
      <=> v17918(VarCurr) ) ) ).

tff(addAssignment_9115,axiom,
    ! [VarCurr: state_type] :
      ( v17918(VarCurr)
    <=> v17920(VarCurr) ) ).

tff(addAssignment_9114,axiom,
    ! [VarCurr: state_type] :
      ( v17920(VarCurr)
    <=> v17922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1485,axiom,
    ! [VarCurr: state_type] :
      ( v17922(VarCurr)
    <=> ( v17963(VarCurr)
        | v17959(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1484,axiom,
    ! [VarCurr: state_type] :
      ( v17963(VarCurr)
    <=> ( v17924(VarCurr)
        & v17928(VarCurr) ) ) ).

tff(addAssignment_9113,axiom,
    ! [VarCurr: state_type] :
      ( v17959(VarCurr)
    <=> v17961(VarCurr) ) ).

tff(addAssignment_9112,axiom,
    ! [VarCurr: state_type] :
      ( v17961(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17943(VarNext)
       => ( v17928(VarNext)
        <=> v17928(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_201,axiom,
    ! [VarNext: state_type] :
      ( v17943(VarNext)
     => ( v17928(VarNext)
      <=> v17953(VarNext) ) ) ).

tff(addAssignment_9111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17953(VarNext)
      <=> v17951(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1483,axiom,
    ! [VarCurr: state_type] :
      ( v17951(VarCurr)
    <=> ( v17954(VarCurr)
        & v17955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1482,axiom,
    ! [VarCurr: state_type] :
      ( v17955(VarCurr)
    <=> ( v17934(VarCurr)
        | v17938(VarCurr) ) ) ).

tff(writeUnaryOperator_1022,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17954(VarCurr)
    <=> v17930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17943(VarNext)
      <=> v17944(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17944(VarNext)
      <=> ( v17946(VarNext)
          & v17948(VarNext) ) ) ) ).

tff(writeUnaryOperator_1021,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17948(VarCurr)
    <=> v17924(VarCurr) ) ).

tff(addAssignment_9110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17946(VarNext)
      <=> v17924(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_67,axiom,
    ( v17928(constB0)
  <=> $true ) ).

tff(addAssignment_9109,axiom,
    ! [VarCurr: state_type] :
      ( v17938(VarCurr)
    <=> v17940(VarCurr) ) ).

tff(addAssignment_9108,axiom,
    ! [VarCurr: state_type] :
      ( v17940(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9107,axiom,
    ! [VarCurr: state_type] :
      ( v17934(VarCurr)
    <=> v17936(VarCurr) ) ).

tff(addAssignment_9106,axiom,
    ! [VarCurr: state_type] :
      ( v17936(VarCurr)
    <=> $true ) ).

tff(addAssignment_9105,axiom,
    ! [VarCurr: state_type] :
      ( v17930(VarCurr)
    <=> v17932(VarCurr) ) ).

tff(addAssignment_9104,axiom,
    ! [VarCurr: state_type] :
      ( v17932(VarCurr)
    <=> $false ) ).

tff(addAssignment_9103,axiom,
    ! [VarCurr: state_type] :
      ( v17924(VarCurr)
    <=> v17926(VarCurr) ) ).

tff(addAssignment_9102,axiom,
    ! [VarCurr: state_type] :
      ( v17926(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9101,axiom,
    ! [VarCurr: state_type] :
      ( v17775(VarCurr,4)
    <=> v17777(VarCurr,4) ) ).

tff(addAssignment_9100,axiom,
    ! [VarCurr: state_type] :
      ( v17777(VarCurr,4)
    <=> v17915(VarCurr,4) ) ).

tff(addAssignment_9099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v17915(VarCurr,B)
      <=> v17916(VarCurr,B) ) ) ).

tff(addAssignment_9098,axiom,
    ! [VarCurr: state_type] :
      ( ( v17915(VarCurr,5)
      <=> v17779(VarCurr,2) )
      & ( v17915(VarCurr,4)
      <=> v17779(VarCurr,1) )
      & ( v17915(VarCurr,3)
      <=> v17779(VarCurr,0) ) ) ).

tff(addAssignment_9097,axiom,
    ! [VarCurr: state_type] :
      ( v17779(VarCurr,1)
    <=> v17781(VarCurr,1) ) ).

tff(addAssignment_9096,axiom,
    ! [VarCurr: state_type] :
      ( v17781(VarCurr,1)
    <=> v17783(VarCurr,1) ) ).

tff(addAssignment_9095,axiom,
    ! [VarCurr: state_type] :
      ( v17783(VarCurr,1)
    <=> v17914(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_305,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v17914(VarCurr,B)
      <=> ( v17785(VarCurr,B)
          & v17851(VarCurr,B) ) ) ) ).

tff(addAssignment_9094,axiom,
    ! [VarCurr: state_type] :
      ( v17851(VarCurr,1)
    <=> v17853(VarCurr,1) ) ).

tff(addAssignment_9093,axiom,
    ! [VarCurr: state_type] :
      ( v17853(VarCurr,1)
    <=> v17855(VarCurr,1) ) ).

tff(addAssignment_9092,axiom,
    ! [VarCurr: state_type] :
      ( v17855(VarCurr,1)
    <=> v17857(VarCurr,1) ) ).

tff(addAssignment_9091,axiom,
    ! [VarCurr: state_type] :
      ( v17857(VarCurr,1)
    <=> v17859(VarCurr,1) ) ).

tff(addAssignment_9090,axiom,
    ! [VarCurr: state_type] :
      ( v17859(VarCurr,1)
    <=> v17869(VarCurr,1) ) ).

tff(addAssignment_9089,axiom,
    ! [VarCurr: state_type] :
      ( v17869(VarCurr,0)
    <=> v17909(VarCurr) ) ).

tff(addAssignment_9088,axiom,
    ! [VarCurr: state_type] :
      ( v17869(VarCurr,1)
    <=> v17904(VarCurr) ) ).

tff(addAssignment_9087,axiom,
    ! [VarCurr: state_type] :
      ( v17869(VarCurr,2)
    <=> v17899(VarCurr) ) ).

tff(addAssignment_9086,axiom,
    ! [VarCurr: state_type] :
      ( v17869(VarCurr,3)
    <=> v17871(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1479,axiom,
    ! [VarCurr: state_type] :
      ( v17909(VarCurr)
    <=> ( v17910(VarCurr)
        & v17913(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1478,axiom,
    ! [VarCurr: state_type] :
      ( v17913(VarCurr)
    <=> ( v17861(VarCurr,0)
        | v17879(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1477,axiom,
    ! [VarCurr: state_type] :
      ( v17910(VarCurr)
    <=> ( v17911(VarCurr)
        | v17912(VarCurr) ) ) ).

tff(writeUnaryOperator_1020,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17912(VarCurr)
    <=> v17879(VarCurr,0) ) ).

tff(writeUnaryOperator_1019,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17911(VarCurr)
    <=> v17861(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1476,axiom,
    ! [VarCurr: state_type] :
      ( v17904(VarCurr)
    <=> ( v17905(VarCurr)
        & v17908(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1475,axiom,
    ! [VarCurr: state_type] :
      ( v17908(VarCurr)
    <=> ( v17878(VarCurr)
        | v17880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1474,axiom,
    ! [VarCurr: state_type] :
      ( v17905(VarCurr)
    <=> ( v17906(VarCurr)
        | v17907(VarCurr) ) ) ).

tff(writeUnaryOperator_1018,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17907(VarCurr)
    <=> v17880(VarCurr) ) ).

tff(writeUnaryOperator_1017,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17906(VarCurr)
    <=> v17878(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1473,axiom,
    ! [VarCurr: state_type] :
      ( v17899(VarCurr)
    <=> ( v17900(VarCurr)
        & v17903(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1472,axiom,
    ! [VarCurr: state_type] :
      ( v17903(VarCurr)
    <=> ( v17876(VarCurr)
        | v17886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1471,axiom,
    ! [VarCurr: state_type] :
      ( v17900(VarCurr)
    <=> ( v17901(VarCurr)
        | v17902(VarCurr) ) ) ).

tff(writeUnaryOperator_1016,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17902(VarCurr)
    <=> v17886(VarCurr) ) ).

tff(writeUnaryOperator_1015,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17901(VarCurr)
    <=> v17876(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1470,axiom,
    ! [VarCurr: state_type] :
      ( v17871(VarCurr)
    <=> ( v17872(VarCurr)
        & v17898(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1469,axiom,
    ! [VarCurr: state_type] :
      ( v17898(VarCurr)
    <=> ( v17874(VarCurr)
        | v17893(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1468,axiom,
    ! [VarCurr: state_type] :
      ( v17872(VarCurr)
    <=> ( v17873(VarCurr)
        | v17892(VarCurr) ) ) ).

tff(writeUnaryOperator_1014,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17892(VarCurr)
    <=> v17893(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1467,axiom,
    ! [VarCurr: state_type] :
      ( v17893(VarCurr)
    <=> ( v17894(VarCurr)
        & v17897(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_208,axiom,
    ! [VarCurr: state_type] :
      ( v17897(VarCurr)
    <=> ( v17861(VarCurr,3)
        | v17879(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1466,axiom,
    ! [VarCurr: state_type] :
      ( v17894(VarCurr)
    <=> ( v17895(VarCurr)
        | v17896(VarCurr) ) ) ).

tff(writeUnaryOperator_1013,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17896(VarCurr)
    <=> v17879(VarCurr,3) ) ).

tff(writeUnaryOperator_1012,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17895(VarCurr)
    <=> v17861(VarCurr,3) ) ).

tff(writeUnaryOperator_1011,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17873(VarCurr)
    <=> v17874(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1465,axiom,
    ! [VarCurr: state_type] :
      ( v17874(VarCurr)
    <=> ( v17875(VarCurr)
        | v17891(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_207,axiom,
    ! [VarCurr: state_type] :
      ( v17891(VarCurr)
    <=> ( v17861(VarCurr,2)
        & v17879(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1464,axiom,
    ! [VarCurr: state_type] :
      ( v17875(VarCurr)
    <=> ( v17876(VarCurr)
        & v17886(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1463,axiom,
    ! [VarCurr: state_type] :
      ( v17886(VarCurr)
    <=> ( v17887(VarCurr)
        & v17890(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_206,axiom,
    ! [VarCurr: state_type] :
      ( v17890(VarCurr)
    <=> ( v17861(VarCurr,2)
        | v17879(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1462,axiom,
    ! [VarCurr: state_type] :
      ( v17887(VarCurr)
    <=> ( v17888(VarCurr)
        | v17889(VarCurr) ) ) ).

tff(writeUnaryOperator_1010,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17889(VarCurr)
    <=> v17879(VarCurr,2) ) ).

tff(writeUnaryOperator_1009,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17888(VarCurr)
    <=> v17861(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1461,axiom,
    ! [VarCurr: state_type] :
      ( v17876(VarCurr)
    <=> ( v17877(VarCurr)
        | v17885(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_205,axiom,
    ! [VarCurr: state_type] :
      ( v17885(VarCurr)
    <=> ( v17861(VarCurr,1)
        & v17879(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1460,axiom,
    ! [VarCurr: state_type] :
      ( v17877(VarCurr)
    <=> ( v17878(VarCurr)
        & v17880(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1459,axiom,
    ! [VarCurr: state_type] :
      ( v17880(VarCurr)
    <=> ( v17881(VarCurr)
        & v17884(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_204,axiom,
    ! [VarCurr: state_type] :
      ( v17884(VarCurr)
    <=> ( v17861(VarCurr,1)
        | v17879(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1458,axiom,
    ! [VarCurr: state_type] :
      ( v17881(VarCurr)
    <=> ( v17882(VarCurr)
        | v17883(VarCurr) ) ) ).

tff(writeUnaryOperator_1008,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17883(VarCurr)
    <=> v17879(VarCurr,1) ) ).

tff(writeUnaryOperator_1007,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17882(VarCurr)
    <=> v17861(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1457,axiom,
    ! [VarCurr: state_type] :
      ( v17878(VarCurr)
    <=> ( v17861(VarCurr,0)
        & v17879(VarCurr,0) ) ) ).

tff(addAssignment_9085,axiom,
    ! [VarCurr: state_type] :
      ( v17879(VarCurr,0)
    <=> v17866(VarCurr) ) ).

tff(addAssignment_9084,axiom,
    ! [VarCurr: state_type] :
      ( ( v17879(VarCurr,3)
      <=> $false )
      & ( v17879(VarCurr,2)
      <=> $false )
      & ( v17879(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_9083,axiom,
    ! [VarCurr: state_type] :
      ( v17866(VarCurr)
    <=> v17868(VarCurr) ) ).

tff(addAssignment_9082,axiom,
    ! [VarCurr: state_type] :
      ( v17868(VarCurr)
    <=> v17816(VarCurr) ) ).

tff(addAssignment_9081,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v17861(VarCurr,B)
      <=> v17863(VarCurr,B) ) ) ).

tff(addAssignment_9080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v17863(VarCurr,B)
      <=> v17864(VarCurr,B) ) ) ).

tff(addAssignment_9079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v17864(VarCurr,B)
      <=> v17751(VarCurr,B) ) ) ).

tff(addAssignment_9078,axiom,
    ! [VarCurr: state_type] :
      ( v17864(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_9077,axiom,
    ! [VarCurr: state_type] :
      ( v17785(VarCurr,1)
    <=> v17787(VarCurr,1) ) ).

tff(addAssignment_9076,axiom,
    ! [VarCurr: state_type] :
      ( v17787(VarCurr,1)
    <=> v17848(VarCurr,1) ) ).

tff(addAssignment_9075,axiom,
    ! [VarCurr: state_type] :
      ( v17848(VarCurr,0)
    <=> v17849(VarCurr) ) ).

tff(addAssignment_9074,axiom,
    ! [VarCurr: state_type] :
      ( v17848(VarCurr,1)
    <=> v17849(VarCurr) ) ).

tff(addAssignment_9073,axiom,
    ! [VarCurr: state_type] :
      ( v17848(VarCurr,2)
    <=> v17849(VarCurr) ) ).

tff(addAssignment_9072,axiom,
    ! [VarCurr: state_type] :
      ( v17849(VarCurr)
    <=> v17789(VarCurr) ) ).

tff(addAssignment_9071,axiom,
    ! [VarCurr: state_type] :
      ( v17830(VarCurr)
    <=> v17832(VarCurr) ) ).

tff(addAssignment_9070,axiom,
    ! [VarCurr: state_type] :
      ( v17832(VarCurr)
    <=> v17834(VarCurr,0) ) ).

tff(addAssignment_9069,axiom,
    ! [VarCurr: state_type] :
      ( v17834(VarCurr,0)
    <=> v17836(VarCurr,0) ) ).

tff(addAssignment_9068,axiom,
    ! [VarCurr: state_type] :
      ( v17836(VarCurr,0)
    <=> v17838(VarCurr,0) ) ).

tff(addAssignment_9067,axiom,
    ! [VarCurr: state_type] :
      ( v17838(VarCurr,0)
    <=> v17843(VarCurr,0) ) ).

tff(writeUnaryOperator_1006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v17843(VarCurr,B)
      <=> ~ v17840(VarCurr,B) ) ) ).

tff(addAssignment_9066,axiom,
    ! [VarCurr: state_type] :
      ( v17840(VarCurr,0)
    <=> v17842(VarCurr,0) ) ).

tff(addAssignment_9065,axiom,
    ! [VarCurr: state_type] :
      ( v17842(VarCurr,0)
    <=> v17751(VarCurr,0) ) ).

tff(addAssignment_9064,axiom,
    ! [VarCurr: state_type] :
      ( v17812(VarCurr,1)
    <=> v17814(VarCurr,1) ) ).

tff(addAssignment_9063,axiom,
    ! [VarCurr: state_type] :
      ( v17814(VarCurr,1)
    <=> v17817(VarCurr,1) ) ).

tff(addAssignment_9062,axiom,
    ! [VarCurr: state_type] :
      ( v17817(VarCurr,0)
    <=> v17818(VarCurr) ) ).

tff(addAssignment_9061,axiom,
    ! [VarCurr: state_type] :
      ( v17817(VarCurr,1)
    <=> v17816(VarCurr) ) ).

tff(addAssignment_9060,axiom,
    ! [VarCurr: state_type] :
      ( v17816(VarCurr)
    <=> v10053(VarCurr,5) ) ).

tff(addAssignment_9059,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,5)
    <=> v10055(VarCurr,5) ) ).

tff(addAssignment_9058,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,5)
    <=> v10057(VarCurr,5) ) ).

tff(addAssignment_9057,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,5)
    <=> v10061(VarCurr,5) ) ).

tff(addAssignment_9056,axiom,
    ! [VarCurr: state_type] :
      ( v17796(VarCurr,1)
    <=> v17798(VarCurr,1) ) ).

tff(addAssignment_9055,axiom,
    ! [VarCurr: state_type] :
      ( v17798(VarCurr,1)
    <=> v17799(VarCurr,1) ) ).

tff(addAssignment_9054,axiom,
    ! [VarCurr: state_type] :
      ( v17799(VarCurr,0)
    <=> v17800(VarCurr) ) ).

tff(addAssignment_9053,axiom,
    ! [VarCurr: state_type] :
      ( v17799(VarCurr,1)
    <=> v17800(VarCurr) ) ).

tff(addAssignment_9052,axiom,
    ! [VarCurr: state_type] :
      ( v17800(VarCurr)
    <=> v17323(VarCurr) ) ).

tff(addAssignment_9051,axiom,
    ! [VarCurr: state_type] :
      ( v17765(VarCurr)
    <=> v17767(VarCurr) ) ).

tff(addAssignment_9050,axiom,
    ! [VarCurr: state_type] :
      ( v17767(VarCurr)
    <=> v17769(VarCurr) ) ).

tff(addAssignment_9049,axiom,
    ! [VarCurr: state_type] :
      ( v17769(VarCurr)
    <=> v17771(VarCurr) ) ).

tff(addAssignment_9048,axiom,
    ! [VarCurr: state_type] :
      ( v17771(VarCurr)
    <=> v17773(VarCurr) ) ).

tff(addAssignment_9047,axiom,
    ! [VarCurr: state_type] :
      ( v17773(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_9046,axiom,
    ! [VarCurr: state_type] :
      ( v17753(VarCurr)
    <=> v17755(VarCurr) ) ).

tff(addAssignment_9045,axiom,
    ! [VarCurr: state_type] :
      ( v17755(VarCurr)
    <=> v17757(VarCurr) ) ).

tff(addAssignment_9044,axiom,
    ! [VarCurr: state_type] :
      ( v17757(VarCurr)
    <=> v17759(VarCurr) ) ).

tff(addAssignment_9043,axiom,
    ! [VarCurr: state_type] :
      ( v17759(VarCurr)
    <=> v17761(VarCurr) ) ).

tff(addAssignment_9042,axiom,
    ! [VarCurr: state_type] :
      ( v17761(VarCurr)
    <=> v17763(VarCurr) ) ).

tff(addAssignment_9041,axiom,
    ! [VarCurr: state_type] :
      ( v17763(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_9040,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17261(VarCurr,B)
      <=> v17263(VarCurr,B) ) ) ).

tff(addAssignment_9039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17263(VarCurr,B)
      <=> v17265(VarCurr,B) ) ) ).

tff(addAssignment_9038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17265(VarCurr,B)
      <=> v17267(VarCurr,B) ) ) ).

tff(addAssignment_9037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17267(VarCurr,B)
      <=> v17269(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17714(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v17269(VarNext,B)
            <=> v17269(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_200,axiom,
    ! [VarNext: state_type] :
      ( v17714(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17269(VarNext,B)
          <=> v17724(VarNext,B) ) ) ) ).

tff(addAssignment_9036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17724(VarNext,B)
          <=> v17722(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17725(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17722(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_137,axiom,
    ! [VarCurr: state_type] :
      ( v17725(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17722(VarCurr,B)
          <=> v17299(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1456,axiom,
    ! [VarCurr: state_type] :
      ( v17725(VarCurr)
    <=> ( v17726(VarCurr)
        & v17727(VarCurr) ) ) ).

tff(writeUnaryOperator_1005,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17727(VarCurr)
    <=> v17285(VarCurr) ) ).

tff(writeUnaryOperator_1004,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17726(VarCurr)
    <=> v17271(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1455,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17714(VarNext)
      <=> v17715(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1454,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17715(VarNext)
      <=> ( v17716(VarNext)
          & v17629(VarNext) ) ) ) ).

tff(writeUnaryOperator_1003,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17716(VarNext)
      <=> v17718(VarNext) ) ) ).

tff(addAssignment_9035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17718(VarNext)
      <=> v17629(VarCurr) ) ) ).

tff(addAssignment_9034,axiom,
    ! [VarCurr: state_type] :
      ( v17629(VarCurr)
    <=> v17631(VarCurr) ) ).

tff(addAssignment_9033,axiom,
    ! [VarCurr: state_type] :
      ( v17631(VarCurr)
    <=> v17633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1453,axiom,
    ! [VarCurr: state_type] :
      ( v17633(VarCurr)
    <=> ( v17711(VarCurr)
        | v17703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1452,axiom,
    ! [VarCurr: state_type] :
      ( v17711(VarCurr)
    <=> ( v17635(VarCurr)
        & v17641(VarCurr) ) ) ).

tff(addAssignment_9032,axiom,
    ! [VarCurr: state_type] :
      ( v17703(VarCurr)
    <=> v17705(VarCurr) ) ).

tff(addAssignment_9031,axiom,
    ! [VarCurr: state_type] :
      ( v17705(VarCurr)
    <=> v17707(VarCurr) ) ).

tff(addAssignment_9030,axiom,
    ! [VarCurr: state_type] :
      ( v17707(VarCurr)
    <=> v17709(VarCurr) ) ).

tff(addAssignment_9029,axiom,
    ! [VarCurr: state_type] :
      ( v17709(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17687(VarNext)
       => ( v17641(VarNext)
        <=> v17641(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_199,axiom,
    ! [VarNext: state_type] :
      ( v17687(VarNext)
     => ( v17641(VarNext)
      <=> v17697(VarNext) ) ) ).

tff(addAssignment_9028,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17697(VarNext)
      <=> v17695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1451,axiom,
    ! [VarCurr: state_type] :
      ( v17695(VarCurr)
    <=> ( v17698(VarCurr)
        & v17699(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1450,axiom,
    ! [VarCurr: state_type] :
      ( v17699(VarCurr)
    <=> ( v17647(VarCurr)
        | v17678(VarCurr) ) ) ).

tff(writeUnaryOperator_1002,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17698(VarCurr)
    <=> v17643(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1449,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17687(VarNext)
      <=> v17688(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17688(VarNext)
      <=> ( v17690(VarNext)
          & v17692(VarNext) ) ) ) ).

tff(writeUnaryOperator_1001,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17692(VarCurr)
    <=> v17635(VarCurr) ) ).

tff(addAssignment_9027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17690(VarNext)
      <=> v17635(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_66,axiom,
    ( v17641(constB0)
  <=> $true ) ).

tff(addAssignment_9026,axiom,
    ! [VarCurr: state_type] :
      ( v17678(VarCurr)
    <=> v17680(VarCurr) ) ).

tff(addAssignment_9025,axiom,
    ! [VarCurr: state_type] :
      ( v17680(VarCurr)
    <=> v17682(VarCurr) ) ).

tff(addAssignment_9024,axiom,
    ! [VarCurr: state_type] :
      ( v17682(VarCurr)
    <=> v17684(VarCurr) ) ).

tff(addAssignment_9023,axiom,
    ! [VarCurr: state_type] :
      ( v17684(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_9022,axiom,
    ! [VarCurr: state_type] :
      ( v17647(VarCurr)
    <=> v17649(VarCurr) ) ).

tff(addAssignment_9021,axiom,
    ! [VarCurr: state_type] :
      ( v17649(VarCurr)
    <=> v17651(VarCurr) ) ).

tff(addAssignment_9020,axiom,
    ! [VarCurr: state_type] :
      ( v17651(VarCurr)
    <=> v17653(VarCurr) ) ).

tff(addAssignment_9019,axiom,
    ! [VarCurr: state_type] :
      ( v17653(VarCurr)
    <=> v17655(VarCurr) ) ).

tff(writeUnaryOperator_1000,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17655(VarCurr)
    <=> v17675(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1447,axiom,
    ! [VarCurr: state_type] :
      ( v17675(VarCurr)
    <=> ( v17676(VarCurr)
        | v17671(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1446,axiom,
    ! [VarCurr: state_type] :
      ( v17676(VarCurr)
    <=> ( v17657(VarCurr)
        | v17667(VarCurr) ) ) ).

tff(addAssignment_9018,axiom,
    ! [VarCurr: state_type] :
      ( v17671(VarCurr)
    <=> v17673(VarCurr) ) ).

tff(addAssignment_9017,axiom,
    ! [VarCurr: state_type] :
      ( v17673(VarCurr)
    <=> v17661(VarCurr,2) ) ).

tff(addAssignment_9016,axiom,
    ! [VarCurr: state_type] :
      ( v17661(VarCurr,2)
    <=> v17663(VarCurr,2) ) ).

tff(addAssignment_9015,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,2)
    <=> v17665(VarCurr,2) ) ).

tff(addAssignment_9014,axiom,
    ! [VarCurr: state_type] :
      ( v17667(VarCurr)
    <=> v17669(VarCurr) ) ).

tff(addAssignment_9013,axiom,
    ! [VarCurr: state_type] :
      ( v17669(VarCurr)
    <=> v17661(VarCurr,1) ) ).

tff(addAssignment_9012,axiom,
    ! [VarCurr: state_type] :
      ( v17661(VarCurr,1)
    <=> v17663(VarCurr,1) ) ).

tff(addAssignment_9011,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,1)
    <=> v17665(VarCurr,1) ) ).

tff(addAssignment_9010,axiom,
    ! [VarCurr: state_type] :
      ( v17657(VarCurr)
    <=> v17659(VarCurr) ) ).

tff(addAssignment_9009,axiom,
    ! [VarCurr: state_type] :
      ( v17659(VarCurr)
    <=> v17661(VarCurr,0) ) ).

tff(addAssignment_9008,axiom,
    ! [VarCurr: state_type] :
      ( v17661(VarCurr,0)
    <=> v17663(VarCurr,0) ) ).

tff(addAssignment_9007,axiom,
    ! [VarCurr: state_type] :
      ( v17663(VarCurr,0)
    <=> v17665(VarCurr,0) ) ).

tff(addAssignment_9006,axiom,
    ! [VarCurr: state_type] :
      ( v17643(VarCurr)
    <=> v17645(VarCurr) ) ).

tff(addAssignment_9005,axiom,
    ! [VarCurr: state_type] :
      ( v17645(VarCurr)
    <=> $false ) ).

tff(addAssignment_9004,axiom,
    ! [VarCurr: state_type] :
      ( v17635(VarCurr)
    <=> v17637(VarCurr) ) ).

tff(addAssignment_9003,axiom,
    ! [VarCurr: state_type] :
      ( v17637(VarCurr)
    <=> v17639(VarCurr) ) ).

tff(addAssignment_9002,axiom,
    ! [VarCurr: state_type] :
      ( v17639(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_9001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17299(VarCurr,B)
      <=> v17301(VarCurr,B) ) ) ).

tff(addAssignment_9000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17301(VarCurr,B)
      <=> v17303(VarCurr,B) ) ) ).

tff(addAssignment_8999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17303(VarCurr,B)
      <=> v17305(VarCurr,B) ) ) ).

tff(addAssignment_8998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17305(VarCurr,B)
      <=> v17307(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_304,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17307(VarCurr,B)
      <=> ( v17309(VarCurr,B)
          & v17331(VarCurr,B) ) ) ) ).

tff(addAssignment_8997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17331(VarCurr,B)
      <=> v17333(VarCurr,B) ) ) ).

tff(addAssignment_8996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17333(VarCurr,B)
      <=> v17335(VarCurr,B) ) ) ).

tff(addAssignment_8995,axiom,
    ! [VarCurr: state_type] :
      ( ( v17335(VarCurr,11)
      <=> v9198(VarCurr,71) )
      & ( v17335(VarCurr,10)
      <=> v9198(VarCurr,70) )
      & ( v17335(VarCurr,9)
      <=> v9198(VarCurr,69) )
      & ( v17335(VarCurr,8)
      <=> v9198(VarCurr,68) )
      & ( v17335(VarCurr,7)
      <=> v9198(VarCurr,67) )
      & ( v17335(VarCurr,6)
      <=> v9198(VarCurr,66) )
      & ( v17335(VarCurr,5)
      <=> v9198(VarCurr,65) )
      & ( v17335(VarCurr,4)
      <=> v9198(VarCurr,64) )
      & ( v17335(VarCurr,3)
      <=> v9198(VarCurr,63) )
      & ( v17335(VarCurr,2)
      <=> v9198(VarCurr,62) )
      & ( v17335(VarCurr,1)
      <=> v9198(VarCurr,61) )
      & ( v17335(VarCurr,0)
      <=> v9198(VarCurr,60) ) ) ).

tff(addAssignment_8994,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,71)
      <=> v17337(VarCurr,11) )
      & ( v9198(VarCurr,70)
      <=> v17337(VarCurr,10) )
      & ( v9198(VarCurr,69)
      <=> v17337(VarCurr,9) )
      & ( v9198(VarCurr,68)
      <=> v17337(VarCurr,8) )
      & ( v9198(VarCurr,67)
      <=> v17337(VarCurr,7) )
      & ( v9198(VarCurr,66)
      <=> v17337(VarCurr,6) )
      & ( v9198(VarCurr,65)
      <=> v17337(VarCurr,5) )
      & ( v9198(VarCurr,64)
      <=> v17337(VarCurr,4) )
      & ( v9198(VarCurr,63)
      <=> v17337(VarCurr,3) )
      & ( v9198(VarCurr,62)
      <=> v17337(VarCurr,2) )
      & ( v9198(VarCurr,61)
      <=> v17337(VarCurr,1) )
      & ( v9198(VarCurr,60)
      <=> v17337(VarCurr,0) ) ) ).

tff(addAssignment_8993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17337(VarCurr,B)
      <=> v17339(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_303,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17339(VarCurr,B)
      <=> ( v17621(VarCurr,B)
          | v17624(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_302,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17624(VarCurr,B)
      <=> ( v17349(VarCurr,B)
          & v17625(VarCurr,B) ) ) ) ).

tff(addAssignment_8992,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,0)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8991,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,1)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8990,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,2)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8989,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,3)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8988,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,4)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8987,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,5)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8986,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,6)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8985,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,7)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8984,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,8)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8983,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,9)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8982,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,10)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8981,axiom,
    ! [VarCurr: state_type] :
      ( v17625(VarCurr,11)
    <=> v17626(VarCurr) ) ).

tff(addAssignment_8980,axiom,
    ! [VarCurr: state_type] :
      ( v17626(VarCurr)
    <=> v17617(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_301,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17621(VarCurr,B)
      <=> ( v17341(VarCurr,B)
          & v17622(VarCurr,B) ) ) ) ).

tff(addAssignment_8979,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,0)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8978,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,1)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8977,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,2)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8976,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,3)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8975,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,4)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8974,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,5)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8973,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,6)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8972,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,7)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8971,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,8)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8970,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,9)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8969,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,10)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8968,axiom,
    ! [VarCurr: state_type] :
      ( v17622(VarCurr,11)
    <=> v17623(VarCurr) ) ).

tff(addAssignment_8967,axiom,
    ! [VarCurr: state_type] :
      ( v17623(VarCurr)
    <=> v17345(VarCurr) ) ).

tff(addAssignment_8966,axiom,
    ! [VarCurr: state_type] :
      ( v17617(VarCurr)
    <=> v17619(VarCurr) ) ).

tff(addAssignment_8965,axiom,
    ! [VarCurr: state_type] :
      ( v17619(VarCurr)
    <=> v9844(VarCurr,5) ) ).

tff(addAssignment_8964,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,5)
    <=> v9846(VarCurr,5) ) ).

tff(addAssignment_8963,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,5)
    <=> v9496(VarCurr,5) ) ).

tff(addAssignment_8962,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17349(VarCurr,B)
      <=> v17351(VarCurr,B) ) ) ).

tff(addAssignment_8961,axiom,
    ! [VarCurr: state_type] :
      ( ( v17351(VarCurr,11)
      <=> v9208(VarCurr,83) )
      & ( v17351(VarCurr,10)
      <=> v9208(VarCurr,82) )
      & ( v17351(VarCurr,9)
      <=> v9208(VarCurr,81) )
      & ( v17351(VarCurr,8)
      <=> v9208(VarCurr,80) )
      & ( v17351(VarCurr,7)
      <=> v9208(VarCurr,79) )
      & ( v17351(VarCurr,6)
      <=> v9208(VarCurr,78) )
      & ( v17351(VarCurr,5)
      <=> v9208(VarCurr,77) )
      & ( v17351(VarCurr,4)
      <=> v9208(VarCurr,76) )
      & ( v17351(VarCurr,3)
      <=> v9208(VarCurr,75) )
      & ( v17351(VarCurr,2)
      <=> v9208(VarCurr,74) )
      & ( v17351(VarCurr,1)
      <=> v9208(VarCurr,73) )
      & ( v17351(VarCurr,0)
      <=> v9208(VarCurr,72) ) ) ).

tff(addAssignment_8960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,84)
        & ~ $less(B,72) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_8959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,84)
        & ~ $less(B,72) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_8958,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,83)
      <=> v17353(VarCurr,11) )
      & ( v9212(VarCurr,82)
      <=> v17353(VarCurr,10) )
      & ( v9212(VarCurr,81)
      <=> v17353(VarCurr,9) )
      & ( v9212(VarCurr,80)
      <=> v17353(VarCurr,8) )
      & ( v9212(VarCurr,79)
      <=> v17353(VarCurr,7) )
      & ( v9212(VarCurr,78)
      <=> v17353(VarCurr,6) )
      & ( v9212(VarCurr,77)
      <=> v17353(VarCurr,5) )
      & ( v9212(VarCurr,76)
      <=> v17353(VarCurr,4) )
      & ( v9212(VarCurr,75)
      <=> v17353(VarCurr,3) )
      & ( v9212(VarCurr,74)
      <=> v17353(VarCurr,2) )
      & ( v9212(VarCurr,73)
      <=> v17353(VarCurr,1) )
      & ( v9212(VarCurr,72)
      <=> v17353(VarCurr,0) ) ) ).

tff(addAssignment_8957,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17353(VarCurr,B)
      <=> v17355(VarCurr,B) ) ) ).

tff(addAssignment_8956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17355(VarCurr,B)
      <=> v17357(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17600(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v17357(VarNext,B)
            <=> v17357(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_198,axiom,
    ! [VarNext: state_type] :
      ( v17600(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17357(VarNext,B)
          <=> v17610(VarNext,B) ) ) ) ).

tff(addAssignment_8955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17610(VarNext,B)
          <=> v17608(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17611(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17608(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_136,axiom,
    ! [VarCurr: state_type] :
      ( v17611(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17608(VarCurr,B)
          <=> v17387(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1445,axiom,
    ! [VarCurr: state_type] :
      ( v17611(VarCurr)
    <=> ( v17612(VarCurr)
        & v17613(VarCurr) ) ) ).

tff(writeUnaryOperator_999,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17613(VarCurr)
    <=> v17373(VarCurr) ) ).

tff(writeUnaryOperator_998,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17612(VarCurr)
    <=> v17359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1444,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17600(VarNext)
      <=> v17601(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17601(VarNext)
      <=> ( v17602(VarNext)
          & v17575(VarNext) ) ) ) ).

tff(writeUnaryOperator_997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17602(VarNext)
      <=> v17604(VarNext) ) ) ).

tff(addAssignment_8954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17604(VarNext)
      <=> v17575(VarCurr) ) ) ).

tff(addAssignment_8953,axiom,
    ! [VarCurr: state_type] :
      ( v17575(VarCurr)
    <=> v17577(VarCurr) ) ).

tff(addAssignment_8952,axiom,
    ! [VarCurr: state_type] :
      ( v17577(VarCurr)
    <=> v17579(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1442,axiom,
    ! [VarCurr: state_type] :
      ( v17579(VarCurr)
    <=> ( v17597(VarCurr)
        | v17589(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1441,axiom,
    ! [VarCurr: state_type] :
      ( v17597(VarCurr)
    <=> ( v17581(VarCurr)
        & v17587(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_65,axiom,
    ( v17587(constB0)
  <=> $true ) ).

tff(addAssignment_8951,axiom,
    ! [VarCurr: state_type] :
      ( v17589(VarCurr)
    <=> v17591(VarCurr) ) ).

tff(addAssignment_8950,axiom,
    ! [VarCurr: state_type] :
      ( v17591(VarCurr)
    <=> v17593(VarCurr) ) ).

tff(addAssignment_8949,axiom,
    ! [VarCurr: state_type] :
      ( v17593(VarCurr)
    <=> v17595(VarCurr) ) ).

tff(addAssignment_8948,axiom,
    ! [VarCurr: state_type] :
      ( v17595(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_8947,axiom,
    ! [VarCurr: state_type] :
      ( v17581(VarCurr)
    <=> v17583(VarCurr) ) ).

tff(addAssignment_8946,axiom,
    ! [VarCurr: state_type] :
      ( v17583(VarCurr)
    <=> v17585(VarCurr) ) ).

tff(addAssignment_8945,axiom,
    ! [VarCurr: state_type] :
      ( v17585(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_8944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17387(VarCurr,B)
      <=> v17389(VarCurr,B) ) ) ).

tff(addAssignment_8943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17389(VarCurr,B)
      <=> v17391(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_300,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17391(VarCurr,B)
      <=> ( v17560(VarCurr,B)
          | v17571(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17571(VarCurr,B)
      <=> ( v17524(VarCurr,B)
          & v17572(VarCurr,B) ) ) ) ).

tff(addAssignment_8942,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,0)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8941,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,1)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8940,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,2)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8939,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,3)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8938,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,4)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8937,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,5)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8936,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,6)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8935,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,7)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8934,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,8)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8933,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,9)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8932,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,10)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8931,axiom,
    ! [VarCurr: state_type] :
      ( v17572(VarCurr,11)
    <=> v17573(VarCurr) ) ).

tff(addAssignment_8930,axiom,
    ! [VarCurr: state_type] :
      ( v17573(VarCurr)
    <=> v17534(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17560(VarCurr,B)
      <=> ( v17561(VarCurr,B)
          | v17568(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_297,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17568(VarCurr,B)
      <=> ( v17488(VarCurr,B)
          & v17569(VarCurr,B) ) ) ) ).

tff(addAssignment_8929,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,0)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8928,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,1)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8927,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,2)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8926,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,3)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8925,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,4)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8924,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,5)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8923,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,6)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8922,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,7)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8921,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,8)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8920,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,9)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8919,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,10)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8918,axiom,
    ! [VarCurr: state_type] :
      ( v17569(VarCurr,11)
    <=> v17570(VarCurr) ) ).

tff(addAssignment_8917,axiom,
    ! [VarCurr: state_type] :
      ( v17570(VarCurr)
    <=> v17498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_296,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17561(VarCurr,B)
      <=> ( v17562(VarCurr,B)
          | v17565(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_295,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17565(VarCurr,B)
      <=> ( v17441(VarCurr,B)
          & v17566(VarCurr,B) ) ) ) ).

tff(addAssignment_8916,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,0)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8915,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,1)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8914,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,2)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8913,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,3)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8912,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,4)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8911,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,5)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8910,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,6)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8909,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,7)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8908,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,8)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8907,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,9)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8906,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,10)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8905,axiom,
    ! [VarCurr: state_type] :
      ( v17566(VarCurr,11)
    <=> v17567(VarCurr) ) ).

tff(addAssignment_8904,axiom,
    ! [VarCurr: state_type] :
      ( v17567(VarCurr)
    <=> v17451(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_294,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17562(VarCurr,B)
      <=> ( v17393(VarCurr,B)
          & v17563(VarCurr,B) ) ) ) ).

tff(addAssignment_8903,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,0)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8902,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,1)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8901,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,2)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8900,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,3)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8899,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,4)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8898,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,5)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8897,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,6)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8896,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,7)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8895,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,8)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8894,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,9)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8893,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,10)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8892,axiom,
    ! [VarCurr: state_type] :
      ( v17563(VarCurr,11)
    <=> v17564(VarCurr) ) ).

tff(addAssignment_8891,axiom,
    ! [VarCurr: state_type] :
      ( v17564(VarCurr)
    <=> v17403(VarCurr) ) ).

tff(addAssignment_8890,axiom,
    ! [VarCurr: state_type] :
      ( v17534(VarCurr)
    <=> v17536(VarCurr) ) ).

tff(addAssignment_8889,axiom,
    ! [VarCurr: state_type] :
      ( v17536(VarCurr)
    <=> v17538(VarCurr) ) ).

tff(addAssignment_8888,axiom,
    ! [VarCurr: state_type] :
      ( v17538(VarCurr)
    <=> v17540(VarCurr) ) ).

tff(addAssignment_8887,axiom,
    ! [VarCurr: state_type] :
      ( v17540(VarCurr)
    <=> v17542(VarCurr) ) ).

tff(addAssignment_8886,axiom,
    ! [VarCurr: state_type] :
      ( v17542(VarCurr)
    <=> v17544(VarCurr) ) ).

tff(addAssignment_8885,axiom,
    ! [VarCurr: state_type] :
      ( v17544(VarCurr)
    <=> v17546(VarCurr) ) ).

tff(addAssignment_8884,axiom,
    ! [VarCurr: state_type] :
      ( v17546(VarCurr)
    <=> v17548(VarCurr) ) ).

tff(writeUnaryOperator_996,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17548(VarCurr)
    <=> v17558(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1440,axiom,
    ! [VarCurr: state_type] :
      ( v17558(VarCurr)
    <=> ( v17550(VarCurr)
        | v17554(VarCurr) ) ) ).

tff(addAssignment_8883,axiom,
    ! [VarCurr: state_type] :
      ( v17554(VarCurr)
    <=> v17556(VarCurr) ) ).

tff(addAssignment_8882,axiom,
    ! [VarCurr: state_type] :
      ( v17556(VarCurr)
    <=> v17471(VarCurr,1) ) ).

tff(addAssignment_8881,axiom,
    ! [VarCurr: state_type] :
      ( v17550(VarCurr)
    <=> v17552(VarCurr) ) ).

tff(addAssignment_8880,axiom,
    ! [VarCurr: state_type] :
      ( v17552(VarCurr)
    <=> v17471(VarCurr,0) ) ).

tff(addAssignment_8879,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17524(VarCurr,B)
      <=> v17526(VarCurr,B) ) ) ).

tff(addAssignment_8878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17526(VarCurr,B)
      <=> v17528(VarCurr,B) ) ) ).

tff(addAssignment_8877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17528(VarCurr,B)
      <=> v17530(VarCurr,B) ) ) ).

tff(addAssignment_8876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17530(VarCurr,B)
      <=> v17532(VarCurr,B) ) ) ).

tff(addAssignment_8875,axiom,
    ! [VarCurr: state_type] :
      ( v17498(VarCurr)
    <=> v17500(VarCurr) ) ).

tff(addAssignment_8874,axiom,
    ! [VarCurr: state_type] :
      ( v17500(VarCurr)
    <=> v17502(VarCurr) ) ).

tff(addAssignment_8873,axiom,
    ! [VarCurr: state_type] :
      ( v17502(VarCurr)
    <=> v17504(VarCurr) ) ).

tff(addAssignment_8872,axiom,
    ! [VarCurr: state_type] :
      ( v17504(VarCurr)
    <=> v17506(VarCurr) ) ).

tff(addAssignment_8871,axiom,
    ! [VarCurr: state_type] :
      ( v17506(VarCurr)
    <=> v17508(VarCurr) ) ).

tff(addAssignment_8870,axiom,
    ! [VarCurr: state_type] :
      ( v17508(VarCurr)
    <=> v17510(VarCurr) ) ).

tff(addAssignment_8869,axiom,
    ! [VarCurr: state_type] :
      ( v17510(VarCurr)
    <=> v17512(VarCurr) ) ).

tff(writeUnaryOperator_995,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17512(VarCurr)
    <=> v17522(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1439,axiom,
    ! [VarCurr: state_type] :
      ( v17522(VarCurr)
    <=> ( v17514(VarCurr)
        | v17518(VarCurr) ) ) ).

tff(addAssignment_8868,axiom,
    ! [VarCurr: state_type] :
      ( v17518(VarCurr)
    <=> v17520(VarCurr) ) ).

tff(addAssignment_8867,axiom,
    ! [VarCurr: state_type] :
      ( v17520(VarCurr)
    <=> v17471(VarCurr,1) ) ).

tff(addAssignment_8866,axiom,
    ! [VarCurr: state_type] :
      ( v17471(VarCurr,1)
    <=> v17473(VarCurr,1) ) ).

tff(addAssignment_8865,axiom,
    ! [VarCurr: state_type] :
      ( v17473(VarCurr,1)
    <=> v17475(VarCurr,1) ) ).

tff(addAssignment_8864,axiom,
    ! [VarCurr: state_type] :
      ( v17475(VarCurr,1)
    <=> v17480(VarCurr,1) ) ).

tff(addAssignment_8863,axiom,
    ! [VarCurr: state_type] :
      ( v17477(VarCurr,1)
    <=> v17479(VarCurr,1) ) ).

tff(addAssignment_8862,axiom,
    ! [VarCurr: state_type] :
      ( v17479(VarCurr,1)
    <=> v17423(VarCurr,1) ) ).

tff(addAssignment_8861,axiom,
    ! [VarCurr: state_type] :
      ( v17514(VarCurr)
    <=> v17516(VarCurr) ) ).

tff(addAssignment_8860,axiom,
    ! [VarCurr: state_type] :
      ( v17516(VarCurr)
    <=> v17423(VarCurr,0) ) ).

tff(addAssignment_8859,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17488(VarCurr,B)
      <=> v17490(VarCurr,B) ) ) ).

tff(addAssignment_8858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17490(VarCurr,B)
      <=> v17492(VarCurr,B) ) ) ).

tff(addAssignment_8857,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17492(VarCurr,B)
      <=> v17494(VarCurr,B) ) ) ).

tff(addAssignment_8856,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17494(VarCurr,B)
      <=> v17496(VarCurr,B) ) ) ).

tff(addAssignment_8855,axiom,
    ! [VarCurr: state_type] :
      ( v17451(VarCurr)
    <=> v17453(VarCurr) ) ).

tff(addAssignment_8854,axiom,
    ! [VarCurr: state_type] :
      ( v17453(VarCurr)
    <=> v17455(VarCurr) ) ).

tff(addAssignment_8853,axiom,
    ! [VarCurr: state_type] :
      ( v17455(VarCurr)
    <=> v17457(VarCurr) ) ).

tff(addAssignment_8852,axiom,
    ! [VarCurr: state_type] :
      ( v17457(VarCurr)
    <=> v17459(VarCurr) ) ).

tff(addAssignment_8851,axiom,
    ! [VarCurr: state_type] :
      ( v17459(VarCurr)
    <=> v17461(VarCurr) ) ).

tff(addAssignment_8850,axiom,
    ! [VarCurr: state_type] :
      ( v17461(VarCurr)
    <=> v17463(VarCurr) ) ).

tff(addAssignment_8849,axiom,
    ! [VarCurr: state_type] :
      ( v17463(VarCurr)
    <=> v17465(VarCurr) ) ).

tff(writeUnaryOperator_994,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17465(VarCurr)
    <=> v17486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1438,axiom,
    ! [VarCurr: state_type] :
      ( v17486(VarCurr)
    <=> ( v17467(VarCurr)
        | v17482(VarCurr) ) ) ).

tff(addAssignment_8848,axiom,
    ! [VarCurr: state_type] :
      ( v17482(VarCurr)
    <=> v17484(VarCurr) ) ).

tff(addAssignment_8847,axiom,
    ! [VarCurr: state_type] :
      ( v17484(VarCurr)
    <=> v17423(VarCurr,1) ) ).

tff(addAssignment_8846,axiom,
    ! [VarCurr: state_type] :
      ( v17467(VarCurr)
    <=> v17469(VarCurr) ) ).

tff(addAssignment_8845,axiom,
    ! [VarCurr: state_type] :
      ( v17469(VarCurr)
    <=> v17471(VarCurr,0) ) ).

tff(addAssignment_8844,axiom,
    ! [VarCurr: state_type] :
      ( v17471(VarCurr,0)
    <=> v17473(VarCurr,0) ) ).

tff(addAssignment_8843,axiom,
    ! [VarCurr: state_type] :
      ( v17473(VarCurr,0)
    <=> v17475(VarCurr,0) ) ).

tff(addAssignment_8842,axiom,
    ! [VarCurr: state_type] :
      ( v17475(VarCurr,0)
    <=> v17480(VarCurr,0) ) ).

tff(writeUnaryOperator_993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v17480(VarCurr,B)
      <=> ~ v17477(VarCurr,B) ) ) ).

tff(addAssignment_8841,axiom,
    ! [VarCurr: state_type] :
      ( v17477(VarCurr,0)
    <=> v17479(VarCurr,0) ) ).

tff(addAssignment_8840,axiom,
    ! [VarCurr: state_type] :
      ( v17479(VarCurr,0)
    <=> v17423(VarCurr,0) ) ).

tff(addAssignment_8839,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17441(VarCurr,B)
      <=> v17443(VarCurr,B) ) ) ).

tff(addAssignment_8838,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17443(VarCurr,B)
      <=> v17445(VarCurr,B) ) ) ).

tff(addAssignment_8837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17445(VarCurr,B)
      <=> v17447(VarCurr,B) ) ) ).

tff(addAssignment_8836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17447(VarCurr,B)
      <=> v17449(VarCurr,B) ) ) ).

tff(addAssignment_8835,axiom,
    ! [VarCurr: state_type] :
      ( v17403(VarCurr)
    <=> v17405(VarCurr) ) ).

tff(addAssignment_8834,axiom,
    ! [VarCurr: state_type] :
      ( v17405(VarCurr)
    <=> v17407(VarCurr) ) ).

tff(addAssignment_8833,axiom,
    ! [VarCurr: state_type] :
      ( v17407(VarCurr)
    <=> v17409(VarCurr) ) ).

tff(addAssignment_8832,axiom,
    ! [VarCurr: state_type] :
      ( v17409(VarCurr)
    <=> v17411(VarCurr) ) ).

tff(addAssignment_8831,axiom,
    ! [VarCurr: state_type] :
      ( v17411(VarCurr)
    <=> v17413(VarCurr) ) ).

tff(addAssignment_8830,axiom,
    ! [VarCurr: state_type] :
      ( v17413(VarCurr)
    <=> v17415(VarCurr) ) ).

tff(addAssignment_8829,axiom,
    ! [VarCurr: state_type] :
      ( v17415(VarCurr)
    <=> v17417(VarCurr) ) ).

tff(writeUnaryOperator_992,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17417(VarCurr)
    <=> v17439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1437,axiom,
    ! [VarCurr: state_type] :
      ( v17439(VarCurr)
    <=> ( v17419(VarCurr)
        | v17435(VarCurr) ) ) ).

tff(addAssignment_8828,axiom,
    ! [VarCurr: state_type] :
      ( v17435(VarCurr)
    <=> v17437(VarCurr) ) ).

tff(addAssignment_8827,axiom,
    ! [VarCurr: state_type] :
      ( v17437(VarCurr)
    <=> v17423(VarCurr,1) ) ).

tff(addAssignment_8826,axiom,
    ! [VarCurr: state_type] :
      ( v17423(VarCurr,1)
    <=> v17425(VarCurr,1) ) ).

tff(addAssignment_8825,axiom,
    ! [VarCurr: state_type] :
      ( v17425(VarCurr,1)
    <=> v17427(VarCurr,1) ) ).

tff(addAssignment_8824,axiom,
    ! [VarCurr: state_type] :
      ( v17427(VarCurr,1)
    <=> v17429(VarCurr,1) ) ).

tff(addAssignment_8823,axiom,
    ! [VarCurr: state_type] :
      ( v17429(VarCurr,1)
    <=> v17431(VarCurr,1) ) ).

tff(addAssignment_8822,axiom,
    ! [VarCurr: state_type] :
      ( v17431(VarCurr,1)
    <=> v17433(VarCurr,1) ) ).

tff(addAssignment_8821,axiom,
    ! [VarCurr: state_type] :
      ( v17419(VarCurr)
    <=> v17421(VarCurr) ) ).

tff(addAssignment_8820,axiom,
    ! [VarCurr: state_type] :
      ( v17421(VarCurr)
    <=> v17423(VarCurr,0) ) ).

tff(addAssignment_8819,axiom,
    ! [VarCurr: state_type] :
      ( v17423(VarCurr,0)
    <=> v17425(VarCurr,0) ) ).

tff(addAssignment_8818,axiom,
    ! [VarCurr: state_type] :
      ( v17425(VarCurr,0)
    <=> v17427(VarCurr,0) ) ).

tff(addAssignment_8817,axiom,
    ! [VarCurr: state_type] :
      ( v17427(VarCurr,0)
    <=> v17429(VarCurr,0) ) ).

tff(addAssignment_8816,axiom,
    ! [VarCurr: state_type] :
      ( v17429(VarCurr,0)
    <=> v17431(VarCurr,0) ) ).

tff(addAssignment_8815,axiom,
    ! [VarCurr: state_type] :
      ( v17431(VarCurr,0)
    <=> v17433(VarCurr,0) ) ).

tff(addAssignment_8814,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17393(VarCurr,B)
      <=> v17395(VarCurr,B) ) ) ).

tff(addAssignment_8813,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17395(VarCurr,B)
      <=> v17397(VarCurr,B) ) ) ).

tff(addAssignment_8812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17397(VarCurr,B)
      <=> v17399(VarCurr,B) ) ) ).

tff(addAssignment_8811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17399(VarCurr,B)
      <=> v17401(VarCurr,B) ) ) ).

tff(addAssignment_8810,axiom,
    ! [VarCurr: state_type] :
      ( v17373(VarCurr)
    <=> v17375(VarCurr) ) ).

tff(addAssignment_8809,axiom,
    ! [VarCurr: state_type] :
      ( v17375(VarCurr)
    <=> v17377(VarCurr) ) ).

tff(addAssignment_8808,axiom,
    ! [VarCurr: state_type] :
      ( v17377(VarCurr)
    <=> v17379(VarCurr) ) ).

tff(addAssignment_8807,axiom,
    ! [VarCurr: state_type] :
      ( v17379(VarCurr)
    <=> v17381(VarCurr) ) ).

tff(addAssignment_8806,axiom,
    ! [VarCurr: state_type] :
      ( v17381(VarCurr)
    <=> v17383(VarCurr) ) ).

tff(addAssignment_8805,axiom,
    ! [VarCurr: state_type] :
      ( v17383(VarCurr)
    <=> v17385(VarCurr) ) ).

tff(addAssignment_8804,axiom,
    ! [VarCurr: state_type] :
      ( v17385(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_8803,axiom,
    ! [VarCurr: state_type] :
      ( v17359(VarCurr)
    <=> v17361(VarCurr) ) ).

tff(addAssignment_8802,axiom,
    ! [VarCurr: state_type] :
      ( v17361(VarCurr)
    <=> v17363(VarCurr) ) ).

tff(addAssignment_8801,axiom,
    ! [VarCurr: state_type] :
      ( v17363(VarCurr)
    <=> v17365(VarCurr) ) ).

tff(addAssignment_8800,axiom,
    ! [VarCurr: state_type] :
      ( v17365(VarCurr)
    <=> v17367(VarCurr) ) ).

tff(addAssignment_8799,axiom,
    ! [VarCurr: state_type] :
      ( v17367(VarCurr)
    <=> v17369(VarCurr) ) ).

tff(addAssignment_8798,axiom,
    ! [VarCurr: state_type] :
      ( v17369(VarCurr)
    <=> v17371(VarCurr) ) ).

tff(addAssignment_8797,axiom,
    ! [VarCurr: state_type] :
      ( v17371(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_8796,axiom,
    ! [VarCurr: state_type] :
      ( v17345(VarCurr)
    <=> v17347(VarCurr) ) ).

tff(addAssignment_8795,axiom,
    ! [VarCurr: state_type] :
      ( v17347(VarCurr)
    <=> v9490(VarCurr,5) ) ).

tff(addAssignment_8794,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,5)
    <=> v9492(VarCurr,5) ) ).

tff(addAssignment_8793,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,5)
    <=> v9494(VarCurr,5) ) ).

tff(addAssignment_8792,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,5)
    <=> v9570(VarCurr,5) ) ).

tff(addAssignment_8791,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,5)
    <=> v9513(VarCurr,5) ) ).

tff(addAssignment_8790,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17341(VarCurr,B)
      <=> v17343(VarCurr,B) ) ) ).

tff(addAssignment_8789,axiom,
    ! [VarCurr: state_type] :
      ( ( v17343(VarCurr,11)
      <=> v9208(VarCurr,71) )
      & ( v17343(VarCurr,10)
      <=> v9208(VarCurr,70) )
      & ( v17343(VarCurr,9)
      <=> v9208(VarCurr,69) )
      & ( v17343(VarCurr,8)
      <=> v9208(VarCurr,68) )
      & ( v17343(VarCurr,7)
      <=> v9208(VarCurr,67) )
      & ( v17343(VarCurr,6)
      <=> v9208(VarCurr,66) )
      & ( v17343(VarCurr,5)
      <=> v9208(VarCurr,65) )
      & ( v17343(VarCurr,4)
      <=> v9208(VarCurr,64) )
      & ( v17343(VarCurr,3)
      <=> v9208(VarCurr,63) )
      & ( v17343(VarCurr,2)
      <=> v9208(VarCurr,62) )
      & ( v17343(VarCurr,1)
      <=> v9208(VarCurr,61) )
      & ( v17343(VarCurr,0)
      <=> v9208(VarCurr,60) ) ) ).

tff(addAssignment_8788,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17309(VarCurr,B)
      <=> v17311(VarCurr,B) ) ) ).

tff(addAssignment_8787,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,0)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8786,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,1)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8785,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,2)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8784,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,3)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8783,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,4)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8782,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,5)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8781,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,6)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8780,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,7)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8779,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,8)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8778,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,9)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8777,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,10)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8776,axiom,
    ! [VarCurr: state_type] :
      ( v17311(VarCurr,11)
    <=> v17329(VarCurr) ) ).

tff(addAssignment_8775,axiom,
    ! [VarCurr: state_type] :
      ( v17329(VarCurr)
    <=> v17313(VarCurr) ) ).

tff(addAssignment_8774,axiom,
    ! [VarCurr: state_type] :
      ( v17313(VarCurr)
    <=> v17315(VarCurr,0) ) ).

tff(addAssignment_8773,axiom,
    ! [VarCurr: state_type] :
      ( v17315(VarCurr,0)
    <=> v17317(VarCurr,0) ) ).

tff(addAssignment_8772,axiom,
    ! [VarCurr: state_type] :
      ( v17317(VarCurr,0)
    <=> v17327(VarCurr,0) ) ).

tff(writeUnaryOperator_991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v17327(VarCurr,B)
      <=> ~ v17319(VarCurr,B) ) ) ).

tff(addAssignment_8771,axiom,
    ! [VarCurr: state_type] :
      ( v17319(VarCurr,0)
    <=> v17321(VarCurr,0) ) ).

tff(addAssignment_8770,axiom,
    ! [VarCurr: state_type] :
      ( v17321(VarCurr,0)
    <=> v17324(VarCurr,0) ) ).

tff(addAssignment_8769,axiom,
    ! [VarCurr: state_type] :
      ( v17324(VarCurr,0)
    <=> v17323(VarCurr) ) ).

tff(addAssignment_8768,axiom,
    ! [VarCurr: state_type] :
      ( v17324(VarCurr,1)
    <=> v17326(VarCurr) ) ).

tff(addAssignment_8767,axiom,
    ! [VarCurr: state_type] :
      ( v17324(VarCurr,2)
    <=> v17325(VarCurr) ) ).

tff(addAssignment_8766,axiom,
    ! [VarCurr: state_type] :
      ( v17323(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_8765,axiom,
    ! [VarCurr: state_type] :
      ( v17285(VarCurr)
    <=> v17287(VarCurr) ) ).

tff(addAssignment_8764,axiom,
    ! [VarCurr: state_type] :
      ( v17287(VarCurr)
    <=> v17289(VarCurr) ) ).

tff(addAssignment_8763,axiom,
    ! [VarCurr: state_type] :
      ( v17289(VarCurr)
    <=> v17291(VarCurr) ) ).

tff(addAssignment_8762,axiom,
    ! [VarCurr: state_type] :
      ( v17291(VarCurr)
    <=> v17293(VarCurr) ) ).

tff(addAssignment_8761,axiom,
    ! [VarCurr: state_type] :
      ( v17293(VarCurr)
    <=> v17295(VarCurr) ) ).

tff(addAssignment_8760,axiom,
    ! [VarCurr: state_type] :
      ( v17295(VarCurr)
    <=> v17297(VarCurr) ) ).

tff(addAssignment_8759,axiom,
    ! [VarCurr: state_type] :
      ( v17297(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_8758,axiom,
    ! [VarCurr: state_type] :
      ( v17271(VarCurr)
    <=> v17273(VarCurr) ) ).

tff(addAssignment_8757,axiom,
    ! [VarCurr: state_type] :
      ( v17273(VarCurr)
    <=> v17275(VarCurr) ) ).

tff(addAssignment_8756,axiom,
    ! [VarCurr: state_type] :
      ( v17275(VarCurr)
    <=> v17277(VarCurr) ) ).

tff(addAssignment_8755,axiom,
    ! [VarCurr: state_type] :
      ( v17277(VarCurr)
    <=> v17279(VarCurr) ) ).

tff(addAssignment_8754,axiom,
    ! [VarCurr: state_type] :
      ( v17279(VarCurr)
    <=> v17281(VarCurr) ) ).

tff(addAssignment_8753,axiom,
    ! [VarCurr: state_type] :
      ( v17281(VarCurr)
    <=> v17283(VarCurr) ) ).

tff(addAssignment_8752,axiom,
    ! [VarCurr: state_type] :
      ( v17283(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_8751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17247(VarCurr,B)
      <=> v17249(VarCurr,B) ) ) ).

tff(addAssignment_8750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17249(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_8749,axiom,
    ! [VarCurr: state_type] :
      ( v15691(VarCurr)
    <=> v15693(VarCurr) ) ).

tff(addAssignment_8748,axiom,
    ! [VarCurr: state_type] :
      ( v15693(VarCurr)
    <=> v15695(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_90,axiom,
    ! [VarCurr: state_type] :
      ( v15695(VarCurr)
    <=> ( ( v15697(VarCurr,11)
        <=> v15701(VarCurr,11) )
        & ( v15697(VarCurr,10)
        <=> v15701(VarCurr,10) )
        & ( v15697(VarCurr,9)
        <=> v15701(VarCurr,9) )
        & ( v15697(VarCurr,8)
        <=> v15701(VarCurr,8) )
        & ( v15697(VarCurr,7)
        <=> v15701(VarCurr,7) )
        & ( v15697(VarCurr,6)
        <=> v15701(VarCurr,6) )
        & ( v15697(VarCurr,5)
        <=> v15701(VarCurr,5) )
        & ( v15697(VarCurr,4)
        <=> v15701(VarCurr,4) )
        & ( v15697(VarCurr,3)
        <=> v15701(VarCurr,3) )
        & ( v15697(VarCurr,2)
        <=> v15701(VarCurr,2) )
        & ( v15697(VarCurr,1)
        <=> v15701(VarCurr,1) )
        & ( v15697(VarCurr,0)
        <=> v15701(VarCurr,0) ) ) ) ).

tff(addAssignment_8747,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15701(VarCurr,B)
      <=> v15703(VarCurr,B) ) ) ).

tff(addAssignment_8746,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15703(VarCurr,B)
      <=> v15705(VarCurr,B) ) ) ).

tff(addAssignment_8745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15705(VarCurr,B)
      <=> v15707(VarCurr,B) ) ) ).

tff(addAssignment_8744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15707(VarCurr,B)
      <=> v15709(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15709(VarCurr,B)
      <=> ( v17217(VarCurr,B)
          | v17236(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17236(VarCurr,B)
      <=> ( v17088(VarCurr,B)
          & v17237(VarCurr,B) ) ) ) ).

tff(addAssignment_8743,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,0)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8742,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,1)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8741,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,2)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8740,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,3)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8739,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,4)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8738,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,5)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8737,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,6)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8736,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,7)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8735,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,8)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8734,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,9)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8733,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,10)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8732,axiom,
    ! [VarCurr: state_type] :
      ( v17237(VarCurr,11)
    <=> v17238(VarCurr) ) ).

tff(addAssignment_8731,axiom,
    ! [VarCurr: state_type] :
      ( v17238(VarCurr)
    <=> v17207(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17217(VarCurr,B)
      <=> ( v17218(VarCurr,B)
          | v17233(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17233(VarCurr,B)
      <=> ( v16937(VarCurr,B)
          & v17234(VarCurr,B) ) ) ) ).

tff(addAssignment_8730,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,0)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8729,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,1)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8728,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,2)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8727,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,3)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8726,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,4)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8725,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,5)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8724,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,6)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8723,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,7)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8722,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,8)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8721,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,9)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8720,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,10)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8719,axiom,
    ! [VarCurr: state_type] :
      ( v17234(VarCurr,11)
    <=> v17235(VarCurr) ) ).

tff(addAssignment_8718,axiom,
    ! [VarCurr: state_type] :
      ( v17235(VarCurr)
    <=> v17057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17218(VarCurr,B)
      <=> ( v17219(VarCurr,B)
          | v17230(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17230(VarCurr,B)
      <=> ( v16786(VarCurr,B)
          & v17231(VarCurr,B) ) ) ) ).

tff(addAssignment_8717,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,0)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8716,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,1)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8715,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,2)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8714,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,3)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8713,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,4)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8712,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,5)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8711,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,6)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8710,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,7)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8709,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,8)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8708,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,9)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8707,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,10)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8706,axiom,
    ! [VarCurr: state_type] :
      ( v17231(VarCurr,11)
    <=> v17232(VarCurr) ) ).

tff(addAssignment_8705,axiom,
    ! [VarCurr: state_type] :
      ( v17232(VarCurr)
    <=> v16906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17219(VarCurr,B)
      <=> ( v17220(VarCurr,B)
          | v17227(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17227(VarCurr,B)
      <=> ( v16635(VarCurr,B)
          & v17228(VarCurr,B) ) ) ) ).

tff(addAssignment_8704,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,0)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8703,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,1)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8702,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,2)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8701,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,3)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8700,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,4)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8699,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,5)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8698,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,6)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8697,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,7)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8696,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,8)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8695,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,9)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8694,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,10)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8693,axiom,
    ! [VarCurr: state_type] :
      ( v17228(VarCurr,11)
    <=> v17229(VarCurr) ) ).

tff(addAssignment_8692,axiom,
    ! [VarCurr: state_type] :
      ( v17229(VarCurr)
    <=> v16755(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17220(VarCurr,B)
      <=> ( v17221(VarCurr,B)
          | v17224(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17224(VarCurr,B)
      <=> ( v16473(VarCurr,B)
          & v17225(VarCurr,B) ) ) ) ).

tff(addAssignment_8691,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,0)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8690,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,1)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8689,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,2)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8688,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,3)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8687,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,4)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8686,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,5)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8685,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,6)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8684,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,7)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8683,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,8)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8682,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,9)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8681,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,10)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8680,axiom,
    ! [VarCurr: state_type] :
      ( v17225(VarCurr,11)
    <=> v17226(VarCurr) ) ).

tff(addAssignment_8679,axiom,
    ! [VarCurr: state_type] :
      ( v17226(VarCurr)
    <=> v16604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_283,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17221(VarCurr,B)
      <=> ( v15711(VarCurr,B)
          & v17222(VarCurr,B) ) ) ) ).

tff(addAssignment_8678,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,0)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8677,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,1)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8676,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,2)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8675,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,3)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8674,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,4)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8673,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,5)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8672,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,6)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8671,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,7)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8670,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,8)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8669,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,9)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8668,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,10)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8667,axiom,
    ! [VarCurr: state_type] :
      ( v17222(VarCurr,11)
    <=> v17223(VarCurr) ) ).

tff(addAssignment_8666,axiom,
    ! [VarCurr: state_type] :
      ( v17223(VarCurr)
    <=> v16181(VarCurr) ) ).

tff(addAssignment_8665,axiom,
    ! [VarCurr: state_type] :
      ( v17207(VarCurr)
    <=> v17209(VarCurr) ) ).

tff(addAssignment_8664,axiom,
    ! [VarCurr: state_type] :
      ( v17209(VarCurr)
    <=> v17211(VarCurr) ) ).

tff(addAssignment_8663,axiom,
    ! [VarCurr: state_type] :
      ( v17211(VarCurr)
    <=> v17213(VarCurr) ) ).

tff(addAssignment_8662,axiom,
    ! [VarCurr: state_type] :
      ( v17213(VarCurr)
    <=> v17215(VarCurr) ) ).

tff(addAssignment_8661,axiom,
    ! [VarCurr: state_type] :
      ( v17215(VarCurr)
    <=> v16274(VarCurr) ) ).

tff(addAssignment_8660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17088(VarCurr,B)
      <=> v17090(VarCurr,B) ) ) ).

tff(addAssignment_8659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17090(VarCurr,B)
      <=> v17092(VarCurr,B) ) ) ).

tff(addAssignment_8658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17092(VarCurr,B)
      <=> v17094(VarCurr,B) ) ) ).

tff(addAssignment_8657,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17094(VarCurr,B)
      <=> v17096(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17190(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v17096(VarNext,B)
            <=> v17096(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_197,axiom,
    ! [VarNext: state_type] :
      ( v17190(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17096(VarNext,B)
          <=> v17200(VarNext,B) ) ) ) ).

tff(addAssignment_8656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17200(VarNext,B)
          <=> v17198(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17198(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_135,axiom,
    ! [VarCurr: state_type] :
      ( v17201(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17198(VarCurr,B)
          <=> v17118(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1436,axiom,
    ! [VarCurr: state_type] :
      ( v17201(VarCurr)
    <=> ( v17202(VarCurr)
        & v17203(VarCurr) ) ) ).

tff(writeUnaryOperator_990,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17203(VarCurr)
    <=> v17108(VarCurr) ) ).

tff(writeUnaryOperator_989,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17202(VarCurr)
    <=> v17098(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1435,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17190(VarNext)
      <=> v17191(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17191(VarNext)
      <=> ( v17192(VarNext)
          & v17122(VarNext) ) ) ) ).

tff(writeUnaryOperator_988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17192(VarNext)
      <=> v17194(VarNext) ) ) ).

tff(addAssignment_8655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17194(VarNext)
      <=> v17122(VarCurr) ) ) ).

tff(addAssignment_8654,axiom,
    ! [VarCurr: state_type] :
      ( v17122(VarCurr)
    <=> v17124(VarCurr) ) ).

tff(addAssignment_8653,axiom,
    ! [VarCurr: state_type] :
      ( v17124(VarCurr)
    <=> v17126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1433,axiom,
    ! [VarCurr: state_type] :
      ( v17126(VarCurr)
    <=> ( v17187(VarCurr)
        | v17183(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1432,axiom,
    ! [VarCurr: state_type] :
      ( v17187(VarCurr)
    <=> ( v17128(VarCurr)
        & v17132(VarCurr) ) ) ).

tff(addAssignment_8652,axiom,
    ! [VarCurr: state_type] :
      ( v17183(VarCurr)
    <=> v17185(VarCurr) ) ).

tff(addAssignment_8651,axiom,
    ! [VarCurr: state_type] :
      ( v17185(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17167(VarNext)
       => ( v17132(VarNext)
        <=> v17132(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_196,axiom,
    ! [VarNext: state_type] :
      ( v17167(VarNext)
     => ( v17132(VarNext)
      <=> v17177(VarNext) ) ) ).

tff(addAssignment_8650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17177(VarNext)
      <=> v17175(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1431,axiom,
    ! [VarCurr: state_type] :
      ( v17175(VarCurr)
    <=> ( v17178(VarCurr)
        & v17179(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1430,axiom,
    ! [VarCurr: state_type] :
      ( v17179(VarCurr)
    <=> ( v17138(VarCurr)
        | v17162(VarCurr) ) ) ).

tff(writeUnaryOperator_987,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17178(VarCurr)
    <=> v17134(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17167(VarNext)
      <=> v17168(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17168(VarNext)
      <=> ( v17170(VarNext)
          & v17172(VarNext) ) ) ) ).

tff(writeUnaryOperator_986,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17172(VarCurr)
    <=> v17128(VarCurr) ) ).

tff(addAssignment_8649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17170(VarNext)
      <=> v17128(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_64,axiom,
    ( v17132(constB0)
  <=> $true ) ).

tff(addAssignment_8648,axiom,
    ! [VarCurr: state_type] :
      ( v17162(VarCurr)
    <=> v17164(VarCurr) ) ).

tff(addAssignment_8647,axiom,
    ! [VarCurr: state_type] :
      ( v17164(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8646,axiom,
    ! [VarCurr: state_type] :
      ( v17138(VarCurr)
    <=> v17140(VarCurr) ) ).

tff(addAssignment_8645,axiom,
    ! [VarCurr: state_type] :
      ( v17140(VarCurr)
    <=> v16448(VarCurr) ) ).

tff(addAssignment_8644,axiom,
    ! [VarCurr: state_type] :
      ( v16448(VarCurr)
    <=> v17143(VarCurr) ) ).

tff(addAssignment_8643,axiom,
    ! [VarCurr: state_type] :
      ( v17143(VarCurr)
    <=> v17145(VarCurr) ) ).

tff(writeUnaryOperator_985,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17145(VarCurr)
    <=> v17159(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1427,axiom,
    ! [VarCurr: state_type] :
      ( v17159(VarCurr)
    <=> ( v17160(VarCurr)
        | v17155(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1426,axiom,
    ! [VarCurr: state_type] :
      ( v17160(VarCurr)
    <=> ( v17147(VarCurr)
        | v17151(VarCurr) ) ) ).

tff(addAssignment_8642,axiom,
    ! [VarCurr: state_type] :
      ( v17155(VarCurr)
    <=> v17157(VarCurr) ) ).

tff(addAssignment_8641,axiom,
    ! [VarCurr: state_type] :
      ( v17157(VarCurr)
    <=> v16537(VarCurr,2) ) ).

tff(addAssignment_8640,axiom,
    ! [VarCurr: state_type] :
      ( v17151(VarCurr)
    <=> v17153(VarCurr) ) ).

tff(addAssignment_8639,axiom,
    ! [VarCurr: state_type] :
      ( v17153(VarCurr)
    <=> v16111(VarCurr,1) ) ).

tff(addAssignment_8638,axiom,
    ! [VarCurr: state_type] :
      ( v17147(VarCurr)
    <=> v17149(VarCurr) ) ).

tff(addAssignment_8637,axiom,
    ! [VarCurr: state_type] :
      ( v17149(VarCurr)
    <=> v16537(VarCurr,0) ) ).

tff(addAssignment_8636,axiom,
    ! [VarCurr: state_type] :
      ( v17134(VarCurr)
    <=> v17136(VarCurr) ) ).

tff(addAssignment_8635,axiom,
    ! [VarCurr: state_type] :
      ( v17136(VarCurr)
    <=> $false ) ).

tff(addAssignment_8634,axiom,
    ! [VarCurr: state_type] :
      ( v17128(VarCurr)
    <=> v17130(VarCurr) ) ).

tff(addAssignment_8633,axiom,
    ! [VarCurr: state_type] :
      ( v17130(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8632,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17118(VarCurr,B)
      <=> v17120(VarCurr,B) ) ) ).

tff(addAssignment_8631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v17120(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8630,axiom,
    ! [VarCurr: state_type] :
      ( v17108(VarCurr)
    <=> v17110(VarCurr) ) ).

tff(addAssignment_8629,axiom,
    ! [VarCurr: state_type] :
      ( v17110(VarCurr)
    <=> v17112(VarCurr) ) ).

tff(addAssignment_8628,axiom,
    ! [VarCurr: state_type] :
      ( v17112(VarCurr)
    <=> v17114(VarCurr) ) ).

tff(addAssignment_8627,axiom,
    ! [VarCurr: state_type] :
      ( v17114(VarCurr)
    <=> v17116(VarCurr) ) ).

tff(addAssignment_8626,axiom,
    ! [VarCurr: state_type] :
      ( v17116(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8625,axiom,
    ! [VarCurr: state_type] :
      ( v17098(VarCurr)
    <=> v17100(VarCurr) ) ).

tff(addAssignment_8624,axiom,
    ! [VarCurr: state_type] :
      ( v17100(VarCurr)
    <=> v17102(VarCurr) ) ).

tff(addAssignment_8623,axiom,
    ! [VarCurr: state_type] :
      ( v17102(VarCurr)
    <=> v17104(VarCurr) ) ).

tff(addAssignment_8622,axiom,
    ! [VarCurr: state_type] :
      ( v17104(VarCurr)
    <=> v17106(VarCurr) ) ).

tff(addAssignment_8621,axiom,
    ! [VarCurr: state_type] :
      ( v17106(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_8620,axiom,
    ! [VarCurr: state_type] :
      ( v17057(VarCurr)
    <=> v17059(VarCurr) ) ).

tff(addAssignment_8619,axiom,
    ! [VarCurr: state_type] :
      ( v17059(VarCurr)
    <=> v17061(VarCurr) ) ).

tff(addAssignment_8618,axiom,
    ! [VarCurr: state_type] :
      ( v17061(VarCurr)
    <=> v17063(VarCurr) ) ).

tff(addAssignment_8617,axiom,
    ! [VarCurr: state_type] :
      ( v17063(VarCurr)
    <=> v17065(VarCurr) ) ).

tff(addAssignment_8616,axiom,
    ! [VarCurr: state_type] :
      ( v17065(VarCurr)
    <=> v17067(VarCurr) ) ).

tff(addAssignment_8615,axiom,
    ! [VarCurr: state_type] :
      ( v17067(VarCurr)
    <=> v17069(VarCurr) ) ).

tff(addAssignment_8614,axiom,
    ! [VarCurr: state_type] :
      ( v17069(VarCurr)
    <=> v17071(VarCurr) ) ).

tff(writeUnaryOperator_984,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17071(VarCurr)
    <=> v17085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1425,axiom,
    ! [VarCurr: state_type] :
      ( v17085(VarCurr)
    <=> ( v17086(VarCurr)
        | v17081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1424,axiom,
    ! [VarCurr: state_type] :
      ( v17086(VarCurr)
    <=> ( v17073(VarCurr)
        | v17077(VarCurr) ) ) ).

tff(addAssignment_8613,axiom,
    ! [VarCurr: state_type] :
      ( v17081(VarCurr)
    <=> v17083(VarCurr) ) ).

tff(addAssignment_8612,axiom,
    ! [VarCurr: state_type] :
      ( v17083(VarCurr)
    <=> v16284(VarCurr,2) ) ).

tff(addAssignment_8611,axiom,
    ! [VarCurr: state_type] :
      ( v17077(VarCurr)
    <=> v17079(VarCurr) ) ).

tff(addAssignment_8610,axiom,
    ! [VarCurr: state_type] :
      ( v17079(VarCurr)
    <=> v16201(VarCurr,1) ) ).

tff(addAssignment_8609,axiom,
    ! [VarCurr: state_type] :
      ( v17073(VarCurr)
    <=> v17075(VarCurr) ) ).

tff(addAssignment_8608,axiom,
    ! [VarCurr: state_type] :
      ( v17075(VarCurr)
    <=> v16201(VarCurr,0) ) ).

tff(addAssignment_8607,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16937(VarCurr,B)
      <=> v16939(VarCurr,B) ) ) ).

tff(addAssignment_8606,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16939(VarCurr,B)
      <=> v16941(VarCurr,B) ) ) ).

tff(addAssignment_8605,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16941(VarCurr,B)
      <=> v16943(VarCurr,B) ) ) ).

tff(addAssignment_8604,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16943(VarCurr,B)
      <=> v16945(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17040(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v16945(VarNext,B)
            <=> v16945(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_195,axiom,
    ! [VarNext: state_type] :
      ( v17040(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16945(VarNext,B)
          <=> v17050(VarNext,B) ) ) ) ).

tff(addAssignment_8603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17050(VarNext,B)
          <=> v17048(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17048(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_134,axiom,
    ! [VarCurr: state_type] :
      ( v17051(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v17048(VarCurr,B)
          <=> v16967(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1423,axiom,
    ! [VarCurr: state_type] :
      ( v17051(VarCurr)
    <=> ( v17052(VarCurr)
        & v17053(VarCurr) ) ) ).

tff(writeUnaryOperator_983,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17053(VarCurr)
    <=> v16957(VarCurr) ) ).

tff(writeUnaryOperator_982,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17052(VarCurr)
    <=> v16947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17040(VarNext)
      <=> v17041(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17041(VarNext)
      <=> ( v17042(VarNext)
          & v16971(VarNext) ) ) ) ).

tff(writeUnaryOperator_981,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17042(VarNext)
      <=> v17044(VarNext) ) ) ).

tff(addAssignment_8602,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17044(VarNext)
      <=> v16971(VarCurr) ) ) ).

tff(addAssignment_8601,axiom,
    ! [VarCurr: state_type] :
      ( v16971(VarCurr)
    <=> v16973(VarCurr) ) ).

tff(addAssignment_8600,axiom,
    ! [VarCurr: state_type] :
      ( v16973(VarCurr)
    <=> v16975(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1420,axiom,
    ! [VarCurr: state_type] :
      ( v16975(VarCurr)
    <=> ( v17037(VarCurr)
        | v17033(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1419,axiom,
    ! [VarCurr: state_type] :
      ( v17037(VarCurr)
    <=> ( v16977(VarCurr)
        & v16981(VarCurr) ) ) ).

tff(addAssignment_8599,axiom,
    ! [VarCurr: state_type] :
      ( v17033(VarCurr)
    <=> v17035(VarCurr) ) ).

tff(addAssignment_8598,axiom,
    ! [VarCurr: state_type] :
      ( v17035(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v17017(VarNext)
       => ( v16981(VarNext)
        <=> v16981(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_194,axiom,
    ! [VarNext: state_type] :
      ( v17017(VarNext)
     => ( v16981(VarNext)
      <=> v17027(VarNext) ) ) ).

tff(addAssignment_8597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17027(VarNext)
      <=> v17025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1418,axiom,
    ! [VarCurr: state_type] :
      ( v17025(VarCurr)
    <=> ( v17028(VarCurr)
        & v17029(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1417,axiom,
    ! [VarCurr: state_type] :
      ( v17029(VarCurr)
    <=> ( v16987(VarCurr)
        | v17012(VarCurr) ) ) ).

tff(writeUnaryOperator_980,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17028(VarCurr)
    <=> v16983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17017(VarNext)
      <=> v17018(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1415,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17018(VarNext)
      <=> ( v17020(VarNext)
          & v17022(VarNext) ) ) ) ).

tff(writeUnaryOperator_979,axiom,
    ! [VarCurr: state_type] :
      ( ~ v17022(VarCurr)
    <=> v16977(VarCurr) ) ).

tff(addAssignment_8596,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v17020(VarNext)
      <=> v16977(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_63,axiom,
    ( v16981(constB0)
  <=> $true ) ).

tff(addAssignment_8595,axiom,
    ! [VarCurr: state_type] :
      ( v17012(VarCurr)
    <=> v17014(VarCurr) ) ).

tff(addAssignment_8594,axiom,
    ! [VarCurr: state_type] :
      ( v17014(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8593,axiom,
    ! [VarCurr: state_type] :
      ( v16987(VarCurr)
    <=> v16989(VarCurr) ) ).

tff(addAssignment_8592,axiom,
    ! [VarCurr: state_type] :
      ( v16989(VarCurr)
    <=> v16991(VarCurr) ) ).

tff(addAssignment_8591,axiom,
    ! [VarCurr: state_type] :
      ( v16991(VarCurr)
    <=> v16993(VarCurr) ) ).

tff(addAssignment_8590,axiom,
    ! [VarCurr: state_type] :
      ( v16993(VarCurr)
    <=> v16995(VarCurr) ) ).

tff(writeUnaryOperator_978,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16995(VarCurr)
    <=> v17009(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1414,axiom,
    ! [VarCurr: state_type] :
      ( v17009(VarCurr)
    <=> ( v17010(VarCurr)
        | v17005(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1413,axiom,
    ! [VarCurr: state_type] :
      ( v17010(VarCurr)
    <=> ( v16997(VarCurr)
        | v17001(VarCurr) ) ) ).

tff(addAssignment_8589,axiom,
    ! [VarCurr: state_type] :
      ( v17005(VarCurr)
    <=> v17007(VarCurr) ) ).

tff(addAssignment_8588,axiom,
    ! [VarCurr: state_type] :
      ( v17007(VarCurr)
    <=> v16537(VarCurr,2) ) ).

tff(addAssignment_8587,axiom,
    ! [VarCurr: state_type] :
      ( v16537(VarCurr,2)
    <=> v16539(VarCurr,2) ) ).

tff(addAssignment_8586,axiom,
    ! [VarCurr: state_type] :
      ( v16539(VarCurr,2)
    <=> v16541(VarCurr,2) ) ).

tff(addAssignment_8585,axiom,
    ! [VarCurr: state_type] :
      ( v16541(VarCurr,2)
    <=> v16546(VarCurr,2) ) ).

tff(addAssignment_8584,axiom,
    ! [VarCurr: state_type] :
      ( v16543(VarCurr,2)
    <=> v16545(VarCurr,2) ) ).

tff(addAssignment_8583,axiom,
    ! [VarCurr: state_type] :
      ( v16545(VarCurr,2)
    <=> v16111(VarCurr,2) ) ).

tff(addAssignment_8582,axiom,
    ! [VarCurr: state_type] :
      ( v17001(VarCurr)
    <=> v17003(VarCurr) ) ).

tff(addAssignment_8581,axiom,
    ! [VarCurr: state_type] :
      ( v17003(VarCurr)
    <=> v16111(VarCurr,1) ) ).

tff(addAssignment_8580,axiom,
    ! [VarCurr: state_type] :
      ( v16997(VarCurr)
    <=> v16999(VarCurr) ) ).

tff(addAssignment_8579,axiom,
    ! [VarCurr: state_type] :
      ( v16999(VarCurr)
    <=> v16111(VarCurr,0) ) ).

tff(addAssignment_8578,axiom,
    ! [VarCurr: state_type] :
      ( v16983(VarCurr)
    <=> v16985(VarCurr) ) ).

tff(addAssignment_8577,axiom,
    ! [VarCurr: state_type] :
      ( v16985(VarCurr)
    <=> $false ) ).

tff(addAssignment_8576,axiom,
    ! [VarCurr: state_type] :
      ( v16977(VarCurr)
    <=> v16979(VarCurr) ) ).

tff(addAssignment_8575,axiom,
    ! [VarCurr: state_type] :
      ( v16979(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16967(VarCurr,B)
      <=> v16969(VarCurr,B) ) ) ).

tff(addAssignment_8573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16969(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8572,axiom,
    ! [VarCurr: state_type] :
      ( v16957(VarCurr)
    <=> v16959(VarCurr) ) ).

tff(addAssignment_8571,axiom,
    ! [VarCurr: state_type] :
      ( v16959(VarCurr)
    <=> v16961(VarCurr) ) ).

tff(addAssignment_8570,axiom,
    ! [VarCurr: state_type] :
      ( v16961(VarCurr)
    <=> v16963(VarCurr) ) ).

tff(addAssignment_8569,axiom,
    ! [VarCurr: state_type] :
      ( v16963(VarCurr)
    <=> v16965(VarCurr) ) ).

tff(addAssignment_8568,axiom,
    ! [VarCurr: state_type] :
      ( v16965(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8567,axiom,
    ! [VarCurr: state_type] :
      ( v16947(VarCurr)
    <=> v16949(VarCurr) ) ).

tff(addAssignment_8566,axiom,
    ! [VarCurr: state_type] :
      ( v16949(VarCurr)
    <=> v16951(VarCurr) ) ).

tff(addAssignment_8565,axiom,
    ! [VarCurr: state_type] :
      ( v16951(VarCurr)
    <=> v16953(VarCurr) ) ).

tff(addAssignment_8564,axiom,
    ! [VarCurr: state_type] :
      ( v16953(VarCurr)
    <=> v16955(VarCurr) ) ).

tff(addAssignment_8563,axiom,
    ! [VarCurr: state_type] :
      ( v16955(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_8562,axiom,
    ! [VarCurr: state_type] :
      ( v16906(VarCurr)
    <=> v16908(VarCurr) ) ).

tff(addAssignment_8561,axiom,
    ! [VarCurr: state_type] :
      ( v16908(VarCurr)
    <=> v16910(VarCurr) ) ).

tff(addAssignment_8560,axiom,
    ! [VarCurr: state_type] :
      ( v16910(VarCurr)
    <=> v16912(VarCurr) ) ).

tff(addAssignment_8559,axiom,
    ! [VarCurr: state_type] :
      ( v16912(VarCurr)
    <=> v16914(VarCurr) ) ).

tff(addAssignment_8558,axiom,
    ! [VarCurr: state_type] :
      ( v16914(VarCurr)
    <=> v16916(VarCurr) ) ).

tff(addAssignment_8557,axiom,
    ! [VarCurr: state_type] :
      ( v16916(VarCurr)
    <=> v16918(VarCurr) ) ).

tff(addAssignment_8556,axiom,
    ! [VarCurr: state_type] :
      ( v16918(VarCurr)
    <=> v16920(VarCurr) ) ).

tff(writeUnaryOperator_977,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16920(VarCurr)
    <=> v16934(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1412,axiom,
    ! [VarCurr: state_type] :
      ( v16934(VarCurr)
    <=> ( v16935(VarCurr)
        | v16930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1411,axiom,
    ! [VarCurr: state_type] :
      ( v16935(VarCurr)
    <=> ( v16922(VarCurr)
        | v16926(VarCurr) ) ) ).

tff(addAssignment_8555,axiom,
    ! [VarCurr: state_type] :
      ( v16930(VarCurr)
    <=> v16932(VarCurr) ) ).

tff(addAssignment_8554,axiom,
    ! [VarCurr: state_type] :
      ( v16932(VarCurr)
    <=> v16201(VarCurr,2) ) ).

tff(addAssignment_8553,axiom,
    ! [VarCurr: state_type] :
      ( v16926(VarCurr)
    <=> v16928(VarCurr) ) ).

tff(addAssignment_8552,axiom,
    ! [VarCurr: state_type] :
      ( v16928(VarCurr)
    <=> v16284(VarCurr,1) ) ).

tff(addAssignment_8551,axiom,
    ! [VarCurr: state_type] :
      ( v16922(VarCurr)
    <=> v16924(VarCurr) ) ).

tff(addAssignment_8550,axiom,
    ! [VarCurr: state_type] :
      ( v16924(VarCurr)
    <=> v16284(VarCurr,0) ) ).

tff(addAssignment_8549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16786(VarCurr,B)
      <=> v16788(VarCurr,B) ) ) ).

tff(addAssignment_8548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16788(VarCurr,B)
      <=> v16790(VarCurr,B) ) ) ).

tff(addAssignment_8547,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16790(VarCurr,B)
      <=> v16792(VarCurr,B) ) ) ).

tff(addAssignment_8546,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16792(VarCurr,B)
      <=> v16794(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16889(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v16794(VarNext,B)
            <=> v16794(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_193,axiom,
    ! [VarNext: state_type] :
      ( v16889(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16794(VarNext,B)
          <=> v16899(VarNext,B) ) ) ) ).

tff(addAssignment_8545,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16899(VarNext,B)
          <=> v16897(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16900(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16897(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_133,axiom,
    ! [VarCurr: state_type] :
      ( v16900(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16897(VarCurr,B)
          <=> v16816(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1410,axiom,
    ! [VarCurr: state_type] :
      ( v16900(VarCurr)
    <=> ( v16901(VarCurr)
        & v16902(VarCurr) ) ) ).

tff(writeUnaryOperator_976,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16902(VarCurr)
    <=> v16806(VarCurr) ) ).

tff(writeUnaryOperator_975,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16901(VarCurr)
    <=> v16796(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1409,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16889(VarNext)
      <=> v16890(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16890(VarNext)
      <=> ( v16891(VarNext)
          & v16820(VarNext) ) ) ) ).

tff(writeUnaryOperator_974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16891(VarNext)
      <=> v16893(VarNext) ) ) ).

tff(addAssignment_8544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16893(VarNext)
      <=> v16820(VarCurr) ) ) ).

tff(addAssignment_8543,axiom,
    ! [VarCurr: state_type] :
      ( v16820(VarCurr)
    <=> v16822(VarCurr) ) ).

tff(addAssignment_8542,axiom,
    ! [VarCurr: state_type] :
      ( v16822(VarCurr)
    <=> v16824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1407,axiom,
    ! [VarCurr: state_type] :
      ( v16824(VarCurr)
    <=> ( v16886(VarCurr)
        | v16882(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1406,axiom,
    ! [VarCurr: state_type] :
      ( v16886(VarCurr)
    <=> ( v16826(VarCurr)
        & v16830(VarCurr) ) ) ).

tff(addAssignment_8541,axiom,
    ! [VarCurr: state_type] :
      ( v16882(VarCurr)
    <=> v16884(VarCurr) ) ).

tff(addAssignment_8540,axiom,
    ! [VarCurr: state_type] :
      ( v16884(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_192,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16866(VarNext)
       => ( v16830(VarNext)
        <=> v16830(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_192,axiom,
    ! [VarNext: state_type] :
      ( v16866(VarNext)
     => ( v16830(VarNext)
      <=> v16876(VarNext) ) ) ).

tff(addAssignment_8539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16876(VarNext)
      <=> v16874(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1405,axiom,
    ! [VarCurr: state_type] :
      ( v16874(VarCurr)
    <=> ( v16877(VarCurr)
        & v16878(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1404,axiom,
    ! [VarCurr: state_type] :
      ( v16878(VarCurr)
    <=> ( v16836(VarCurr)
        | v16861(VarCurr) ) ) ).

tff(writeUnaryOperator_973,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16877(VarCurr)
    <=> v16832(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16866(VarNext)
      <=> v16867(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1402,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16867(VarNext)
      <=> ( v16869(VarNext)
          & v16871(VarNext) ) ) ) ).

tff(writeUnaryOperator_972,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16871(VarCurr)
    <=> v16826(VarCurr) ) ).

tff(addAssignment_8538,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16869(VarNext)
      <=> v16826(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_62,axiom,
    ( v16830(constB0)
  <=> $true ) ).

tff(addAssignment_8537,axiom,
    ! [VarCurr: state_type] :
      ( v16861(VarCurr)
    <=> v16863(VarCurr) ) ).

tff(addAssignment_8536,axiom,
    ! [VarCurr: state_type] :
      ( v16863(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8535,axiom,
    ! [VarCurr: state_type] :
      ( v16836(VarCurr)
    <=> v16838(VarCurr) ) ).

tff(addAssignment_8534,axiom,
    ! [VarCurr: state_type] :
      ( v16838(VarCurr)
    <=> v16840(VarCurr) ) ).

tff(addAssignment_8533,axiom,
    ! [VarCurr: state_type] :
      ( v16840(VarCurr)
    <=> v16842(VarCurr) ) ).

tff(addAssignment_8532,axiom,
    ! [VarCurr: state_type] :
      ( v16842(VarCurr)
    <=> v16844(VarCurr) ) ).

tff(writeUnaryOperator_971,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16844(VarCurr)
    <=> v16858(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1401,axiom,
    ! [VarCurr: state_type] :
      ( v16858(VarCurr)
    <=> ( v16859(VarCurr)
        | v16854(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1400,axiom,
    ! [VarCurr: state_type] :
      ( v16859(VarCurr)
    <=> ( v16846(VarCurr)
        | v16850(VarCurr) ) ) ).

tff(addAssignment_8531,axiom,
    ! [VarCurr: state_type] :
      ( v16854(VarCurr)
    <=> v16856(VarCurr) ) ).

tff(addAssignment_8530,axiom,
    ! [VarCurr: state_type] :
      ( v16856(VarCurr)
    <=> v16111(VarCurr,2) ) ).

tff(addAssignment_8529,axiom,
    ! [VarCurr: state_type] :
      ( v16850(VarCurr)
    <=> v16852(VarCurr) ) ).

tff(addAssignment_8528,axiom,
    ! [VarCurr: state_type] :
      ( v16852(VarCurr)
    <=> v16537(VarCurr,1) ) ).

tff(addAssignment_8527,axiom,
    ! [VarCurr: state_type] :
      ( v16846(VarCurr)
    <=> v16848(VarCurr) ) ).

tff(addAssignment_8526,axiom,
    ! [VarCurr: state_type] :
      ( v16848(VarCurr)
    <=> v16537(VarCurr,0) ) ).

tff(addAssignment_8525,axiom,
    ! [VarCurr: state_type] :
      ( v16832(VarCurr)
    <=> v16834(VarCurr) ) ).

tff(addAssignment_8524,axiom,
    ! [VarCurr: state_type] :
      ( v16834(VarCurr)
    <=> $false ) ).

tff(addAssignment_8523,axiom,
    ! [VarCurr: state_type] :
      ( v16826(VarCurr)
    <=> v16828(VarCurr) ) ).

tff(addAssignment_8522,axiom,
    ! [VarCurr: state_type] :
      ( v16828(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16816(VarCurr,B)
      <=> v16818(VarCurr,B) ) ) ).

tff(addAssignment_8520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16818(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8519,axiom,
    ! [VarCurr: state_type] :
      ( v16806(VarCurr)
    <=> v16808(VarCurr) ) ).

tff(addAssignment_8518,axiom,
    ! [VarCurr: state_type] :
      ( v16808(VarCurr)
    <=> v16810(VarCurr) ) ).

tff(addAssignment_8517,axiom,
    ! [VarCurr: state_type] :
      ( v16810(VarCurr)
    <=> v16812(VarCurr) ) ).

tff(addAssignment_8516,axiom,
    ! [VarCurr: state_type] :
      ( v16812(VarCurr)
    <=> v16814(VarCurr) ) ).

tff(addAssignment_8515,axiom,
    ! [VarCurr: state_type] :
      ( v16814(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8514,axiom,
    ! [VarCurr: state_type] :
      ( v16796(VarCurr)
    <=> v16798(VarCurr) ) ).

tff(addAssignment_8513,axiom,
    ! [VarCurr: state_type] :
      ( v16798(VarCurr)
    <=> v16800(VarCurr) ) ).

tff(addAssignment_8512,axiom,
    ! [VarCurr: state_type] :
      ( v16800(VarCurr)
    <=> v16802(VarCurr) ) ).

tff(addAssignment_8511,axiom,
    ! [VarCurr: state_type] :
      ( v16802(VarCurr)
    <=> v16804(VarCurr) ) ).

tff(addAssignment_8510,axiom,
    ! [VarCurr: state_type] :
      ( v16804(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_8509,axiom,
    ! [VarCurr: state_type] :
      ( v16755(VarCurr)
    <=> v16757(VarCurr) ) ).

tff(addAssignment_8508,axiom,
    ! [VarCurr: state_type] :
      ( v16757(VarCurr)
    <=> v16759(VarCurr) ) ).

tff(addAssignment_8507,axiom,
    ! [VarCurr: state_type] :
      ( v16759(VarCurr)
    <=> v16761(VarCurr) ) ).

tff(addAssignment_8506,axiom,
    ! [VarCurr: state_type] :
      ( v16761(VarCurr)
    <=> v16763(VarCurr) ) ).

tff(addAssignment_8505,axiom,
    ! [VarCurr: state_type] :
      ( v16763(VarCurr)
    <=> v16765(VarCurr) ) ).

tff(addAssignment_8504,axiom,
    ! [VarCurr: state_type] :
      ( v16765(VarCurr)
    <=> v16767(VarCurr) ) ).

tff(addAssignment_8503,axiom,
    ! [VarCurr: state_type] :
      ( v16767(VarCurr)
    <=> v16769(VarCurr) ) ).

tff(writeUnaryOperator_970,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16769(VarCurr)
    <=> v16783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1399,axiom,
    ! [VarCurr: state_type] :
      ( v16783(VarCurr)
    <=> ( v16784(VarCurr)
        | v16779(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1398,axiom,
    ! [VarCurr: state_type] :
      ( v16784(VarCurr)
    <=> ( v16771(VarCurr)
        | v16775(VarCurr) ) ) ).

tff(addAssignment_8502,axiom,
    ! [VarCurr: state_type] :
      ( v16779(VarCurr)
    <=> v16781(VarCurr) ) ).

tff(addAssignment_8501,axiom,
    ! [VarCurr: state_type] :
      ( v16781(VarCurr)
    <=> v16201(VarCurr,2) ) ).

tff(addAssignment_8500,axiom,
    ! [VarCurr: state_type] :
      ( v16775(VarCurr)
    <=> v16777(VarCurr) ) ).

tff(addAssignment_8499,axiom,
    ! [VarCurr: state_type] :
      ( v16777(VarCurr)
    <=> v16284(VarCurr,1) ) ).

tff(addAssignment_8498,axiom,
    ! [VarCurr: state_type] :
      ( v16284(VarCurr,1)
    <=> v16286(VarCurr,1) ) ).

tff(addAssignment_8497,axiom,
    ! [VarCurr: state_type] :
      ( v16286(VarCurr,1)
    <=> v16288(VarCurr,1) ) ).

tff(addAssignment_8496,axiom,
    ! [VarCurr: state_type] :
      ( v16288(VarCurr,1)
    <=> v16293(VarCurr,1) ) ).

tff(addAssignment_8495,axiom,
    ! [VarCurr: state_type] :
      ( v16290(VarCurr,1)
    <=> v16292(VarCurr,1) ) ).

tff(addAssignment_8494,axiom,
    ! [VarCurr: state_type] :
      ( v16292(VarCurr,1)
    <=> v16201(VarCurr,1) ) ).

tff(addAssignment_8493,axiom,
    ! [VarCurr: state_type] :
      ( v16771(VarCurr)
    <=> v16773(VarCurr) ) ).

tff(addAssignment_8492,axiom,
    ! [VarCurr: state_type] :
      ( v16773(VarCurr)
    <=> v16201(VarCurr,0) ) ).

tff(addAssignment_8491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16635(VarCurr,B)
      <=> v16637(VarCurr,B) ) ) ).

tff(addAssignment_8490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16637(VarCurr,B)
      <=> v16639(VarCurr,B) ) ) ).

tff(addAssignment_8489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16639(VarCurr,B)
      <=> v16641(VarCurr,B) ) ) ).

tff(addAssignment_8488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16641(VarCurr,B)
      <=> v16643(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16738(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v16643(VarNext,B)
            <=> v16643(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_191,axiom,
    ! [VarNext: state_type] :
      ( v16738(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16643(VarNext,B)
          <=> v16748(VarNext,B) ) ) ) ).

tff(addAssignment_8487,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16748(VarNext,B)
          <=> v16746(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16749(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16746(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_132,axiom,
    ! [VarCurr: state_type] :
      ( v16749(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16746(VarCurr,B)
          <=> v16665(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1397,axiom,
    ! [VarCurr: state_type] :
      ( v16749(VarCurr)
    <=> ( v16750(VarCurr)
        & v16751(VarCurr) ) ) ).

tff(writeUnaryOperator_969,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16751(VarCurr)
    <=> v16655(VarCurr) ) ).

tff(writeUnaryOperator_968,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16750(VarCurr)
    <=> v16645(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1396,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16738(VarNext)
      <=> v16739(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1395,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16739(VarNext)
      <=> ( v16740(VarNext)
          & v16669(VarNext) ) ) ) ).

tff(writeUnaryOperator_967,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16740(VarNext)
      <=> v16742(VarNext) ) ) ).

tff(addAssignment_8486,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16742(VarNext)
      <=> v16669(VarCurr) ) ) ).

tff(addAssignment_8485,axiom,
    ! [VarCurr: state_type] :
      ( v16669(VarCurr)
    <=> v16671(VarCurr) ) ).

tff(addAssignment_8484,axiom,
    ! [VarCurr: state_type] :
      ( v16671(VarCurr)
    <=> v16673(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1394,axiom,
    ! [VarCurr: state_type] :
      ( v16673(VarCurr)
    <=> ( v16735(VarCurr)
        | v16731(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1393,axiom,
    ! [VarCurr: state_type] :
      ( v16735(VarCurr)
    <=> ( v16675(VarCurr)
        & v16679(VarCurr) ) ) ).

tff(addAssignment_8483,axiom,
    ! [VarCurr: state_type] :
      ( v16731(VarCurr)
    <=> v16733(VarCurr) ) ).

tff(addAssignment_8482,axiom,
    ! [VarCurr: state_type] :
      ( v16733(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16715(VarNext)
       => ( v16679(VarNext)
        <=> v16679(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_190,axiom,
    ! [VarNext: state_type] :
      ( v16715(VarNext)
     => ( v16679(VarNext)
      <=> v16725(VarNext) ) ) ).

tff(addAssignment_8481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16725(VarNext)
      <=> v16723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1392,axiom,
    ! [VarCurr: state_type] :
      ( v16723(VarCurr)
    <=> ( v16726(VarCurr)
        & v16727(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1391,axiom,
    ! [VarCurr: state_type] :
      ( v16727(VarCurr)
    <=> ( v16685(VarCurr)
        | v16710(VarCurr) ) ) ).

tff(writeUnaryOperator_966,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16726(VarCurr)
    <=> v16681(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16715(VarNext)
      <=> v16716(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16716(VarNext)
      <=> ( v16718(VarNext)
          & v16720(VarNext) ) ) ) ).

tff(writeUnaryOperator_965,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16720(VarCurr)
    <=> v16675(VarCurr) ) ).

tff(addAssignment_8480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16718(VarNext)
      <=> v16675(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_61,axiom,
    ( v16679(constB0)
  <=> $true ) ).

tff(addAssignment_8479,axiom,
    ! [VarCurr: state_type] :
      ( v16710(VarCurr)
    <=> v16712(VarCurr) ) ).

tff(addAssignment_8478,axiom,
    ! [VarCurr: state_type] :
      ( v16712(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8477,axiom,
    ! [VarCurr: state_type] :
      ( v16685(VarCurr)
    <=> v16687(VarCurr) ) ).

tff(addAssignment_8476,axiom,
    ! [VarCurr: state_type] :
      ( v16687(VarCurr)
    <=> v16689(VarCurr) ) ).

tff(addAssignment_8475,axiom,
    ! [VarCurr: state_type] :
      ( v16689(VarCurr)
    <=> v16691(VarCurr) ) ).

tff(addAssignment_8474,axiom,
    ! [VarCurr: state_type] :
      ( v16691(VarCurr)
    <=> v16693(VarCurr) ) ).

tff(writeUnaryOperator_964,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16693(VarCurr)
    <=> v16707(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1388,axiom,
    ! [VarCurr: state_type] :
      ( v16707(VarCurr)
    <=> ( v16708(VarCurr)
        | v16703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1387,axiom,
    ! [VarCurr: state_type] :
      ( v16708(VarCurr)
    <=> ( v16695(VarCurr)
        | v16699(VarCurr) ) ) ).

tff(addAssignment_8473,axiom,
    ! [VarCurr: state_type] :
      ( v16703(VarCurr)
    <=> v16705(VarCurr) ) ).

tff(addAssignment_8472,axiom,
    ! [VarCurr: state_type] :
      ( v16705(VarCurr)
    <=> v16111(VarCurr,2) ) ).

tff(addAssignment_8471,axiom,
    ! [VarCurr: state_type] :
      ( v16699(VarCurr)
    <=> v16701(VarCurr) ) ).

tff(addAssignment_8470,axiom,
    ! [VarCurr: state_type] :
      ( v16701(VarCurr)
    <=> v16537(VarCurr,1) ) ).

tff(addAssignment_8469,axiom,
    ! [VarCurr: state_type] :
      ( v16537(VarCurr,1)
    <=> v16539(VarCurr,1) ) ).

tff(addAssignment_8468,axiom,
    ! [VarCurr: state_type] :
      ( v16539(VarCurr,1)
    <=> v16541(VarCurr,1) ) ).

tff(addAssignment_8467,axiom,
    ! [VarCurr: state_type] :
      ( v16541(VarCurr,1)
    <=> v16546(VarCurr,1) ) ).

tff(addAssignment_8466,axiom,
    ! [VarCurr: state_type] :
      ( v16543(VarCurr,1)
    <=> v16545(VarCurr,1) ) ).

tff(addAssignment_8465,axiom,
    ! [VarCurr: state_type] :
      ( v16545(VarCurr,1)
    <=> v16111(VarCurr,1) ) ).

tff(addAssignment_8464,axiom,
    ! [VarCurr: state_type] :
      ( v16695(VarCurr)
    <=> v16697(VarCurr) ) ).

tff(addAssignment_8463,axiom,
    ! [VarCurr: state_type] :
      ( v16697(VarCurr)
    <=> v16111(VarCurr,0) ) ).

tff(addAssignment_8462,axiom,
    ! [VarCurr: state_type] :
      ( v16681(VarCurr)
    <=> v16683(VarCurr) ) ).

tff(addAssignment_8461,axiom,
    ! [VarCurr: state_type] :
      ( v16683(VarCurr)
    <=> $false ) ).

tff(addAssignment_8460,axiom,
    ! [VarCurr: state_type] :
      ( v16675(VarCurr)
    <=> v16677(VarCurr) ) ).

tff(addAssignment_8459,axiom,
    ! [VarCurr: state_type] :
      ( v16677(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16665(VarCurr,B)
      <=> v16667(VarCurr,B) ) ) ).

tff(addAssignment_8457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16667(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8456,axiom,
    ! [VarCurr: state_type] :
      ( v16655(VarCurr)
    <=> v16657(VarCurr) ) ).

tff(addAssignment_8455,axiom,
    ! [VarCurr: state_type] :
      ( v16657(VarCurr)
    <=> v16659(VarCurr) ) ).

tff(addAssignment_8454,axiom,
    ! [VarCurr: state_type] :
      ( v16659(VarCurr)
    <=> v16661(VarCurr) ) ).

tff(addAssignment_8453,axiom,
    ! [VarCurr: state_type] :
      ( v16661(VarCurr)
    <=> v16663(VarCurr) ) ).

tff(addAssignment_8452,axiom,
    ! [VarCurr: state_type] :
      ( v16663(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8451,axiom,
    ! [VarCurr: state_type] :
      ( v16645(VarCurr)
    <=> v16647(VarCurr) ) ).

tff(addAssignment_8450,axiom,
    ! [VarCurr: state_type] :
      ( v16647(VarCurr)
    <=> v16649(VarCurr) ) ).

tff(addAssignment_8449,axiom,
    ! [VarCurr: state_type] :
      ( v16649(VarCurr)
    <=> v16651(VarCurr) ) ).

tff(addAssignment_8448,axiom,
    ! [VarCurr: state_type] :
      ( v16651(VarCurr)
    <=> v16653(VarCurr) ) ).

tff(addAssignment_8447,axiom,
    ! [VarCurr: state_type] :
      ( v16653(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_8446,axiom,
    ! [VarCurr: state_type] :
      ( v16604(VarCurr)
    <=> v16606(VarCurr) ) ).

tff(addAssignment_8445,axiom,
    ! [VarCurr: state_type] :
      ( v16606(VarCurr)
    <=> v16608(VarCurr) ) ).

tff(addAssignment_8444,axiom,
    ! [VarCurr: state_type] :
      ( v16608(VarCurr)
    <=> v16610(VarCurr) ) ).

tff(addAssignment_8443,axiom,
    ! [VarCurr: state_type] :
      ( v16610(VarCurr)
    <=> v16612(VarCurr) ) ).

tff(addAssignment_8442,axiom,
    ! [VarCurr: state_type] :
      ( v16612(VarCurr)
    <=> v16614(VarCurr) ) ).

tff(addAssignment_8441,axiom,
    ! [VarCurr: state_type] :
      ( v16614(VarCurr)
    <=> v16616(VarCurr) ) ).

tff(addAssignment_8440,axiom,
    ! [VarCurr: state_type] :
      ( v16616(VarCurr)
    <=> v16618(VarCurr) ) ).

tff(writeUnaryOperator_963,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16618(VarCurr)
    <=> v16632(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1386,axiom,
    ! [VarCurr: state_type] :
      ( v16632(VarCurr)
    <=> ( v16633(VarCurr)
        | v16628(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1385,axiom,
    ! [VarCurr: state_type] :
      ( v16633(VarCurr)
    <=> ( v16620(VarCurr)
        | v16624(VarCurr) ) ) ).

tff(addAssignment_8439,axiom,
    ! [VarCurr: state_type] :
      ( v16628(VarCurr)
    <=> v16630(VarCurr) ) ).

tff(addAssignment_8438,axiom,
    ! [VarCurr: state_type] :
      ( v16630(VarCurr)
    <=> v16201(VarCurr,2) ) ).

tff(addAssignment_8437,axiom,
    ! [VarCurr: state_type] :
      ( v16624(VarCurr)
    <=> v16626(VarCurr) ) ).

tff(addAssignment_8436,axiom,
    ! [VarCurr: state_type] :
      ( v16626(VarCurr)
    <=> v16201(VarCurr,1) ) ).

tff(addAssignment_8435,axiom,
    ! [VarCurr: state_type] :
      ( v16620(VarCurr)
    <=> v16622(VarCurr) ) ).

tff(addAssignment_8434,axiom,
    ! [VarCurr: state_type] :
      ( v16622(VarCurr)
    <=> v16284(VarCurr,0) ) ).

tff(addAssignment_8433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16473(VarCurr,B)
      <=> v16475(VarCurr,B) ) ) ).

tff(addAssignment_8432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16475(VarCurr,B)
      <=> v16477(VarCurr,B) ) ) ).

tff(addAssignment_8431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16477(VarCurr,B)
      <=> v16479(VarCurr,B) ) ) ).

tff(addAssignment_8430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16479(VarCurr,B)
      <=> v16481(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16587(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v16481(VarNext,B)
            <=> v16481(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_189,axiom,
    ! [VarNext: state_type] :
      ( v16587(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16481(VarNext,B)
          <=> v16597(VarNext,B) ) ) ) ).

tff(addAssignment_8429,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16597(VarNext,B)
          <=> v16595(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16598(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16595(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_131,axiom,
    ! [VarCurr: state_type] :
      ( v16598(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16595(VarCurr,B)
          <=> v16503(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1384,axiom,
    ! [VarCurr: state_type] :
      ( v16598(VarCurr)
    <=> ( v16599(VarCurr)
        & v16600(VarCurr) ) ) ).

tff(writeUnaryOperator_962,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16600(VarCurr)
    <=> v16493(VarCurr) ) ).

tff(writeUnaryOperator_961,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16599(VarCurr)
    <=> v16483(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1383,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16587(VarNext)
      <=> v16588(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1382,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16588(VarNext)
      <=> ( v16589(VarNext)
          & v16507(VarNext) ) ) ) ).

tff(writeUnaryOperator_960,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16589(VarNext)
      <=> v16591(VarNext) ) ) ).

tff(addAssignment_8428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16591(VarNext)
      <=> v16507(VarCurr) ) ) ).

tff(addAssignment_8427,axiom,
    ! [VarCurr: state_type] :
      ( v16507(VarCurr)
    <=> v16509(VarCurr) ) ).

tff(addAssignment_8426,axiom,
    ! [VarCurr: state_type] :
      ( v16509(VarCurr)
    <=> v16511(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1381,axiom,
    ! [VarCurr: state_type] :
      ( v16511(VarCurr)
    <=> ( v16584(VarCurr)
        | v16580(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1380,axiom,
    ! [VarCurr: state_type] :
      ( v16584(VarCurr)
    <=> ( v16513(VarCurr)
        & v16517(VarCurr) ) ) ).

tff(addAssignment_8425,axiom,
    ! [VarCurr: state_type] :
      ( v16580(VarCurr)
    <=> v16582(VarCurr) ) ).

tff(addAssignment_8424,axiom,
    ! [VarCurr: state_type] :
      ( v16582(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16564(VarNext)
       => ( v16517(VarNext)
        <=> v16517(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_188,axiom,
    ! [VarNext: state_type] :
      ( v16564(VarNext)
     => ( v16517(VarNext)
      <=> v16574(VarNext) ) ) ).

tff(addAssignment_8423,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16574(VarNext)
      <=> v16572(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1379,axiom,
    ! [VarCurr: state_type] :
      ( v16572(VarCurr)
    <=> ( v16575(VarCurr)
        & v16576(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1378,axiom,
    ! [VarCurr: state_type] :
      ( v16576(VarCurr)
    <=> ( v16523(VarCurr)
        | v16559(VarCurr) ) ) ).

tff(writeUnaryOperator_959,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16575(VarCurr)
    <=> v16519(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1377,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16564(VarNext)
      <=> v16565(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1376,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16565(VarNext)
      <=> ( v16567(VarNext)
          & v16569(VarNext) ) ) ) ).

tff(writeUnaryOperator_958,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16569(VarCurr)
    <=> v16513(VarCurr) ) ).

tff(addAssignment_8422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16567(VarNext)
      <=> v16513(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_60,axiom,
    ( v16517(constB0)
  <=> $true ) ).

tff(addAssignment_8421,axiom,
    ! [VarCurr: state_type] :
      ( v16559(VarCurr)
    <=> v16561(VarCurr) ) ).

tff(addAssignment_8420,axiom,
    ! [VarCurr: state_type] :
      ( v16561(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8419,axiom,
    ! [VarCurr: state_type] :
      ( v16523(VarCurr)
    <=> v16525(VarCurr) ) ).

tff(addAssignment_8418,axiom,
    ! [VarCurr: state_type] :
      ( v16525(VarCurr)
    <=> v16527(VarCurr) ) ).

tff(addAssignment_8417,axiom,
    ! [VarCurr: state_type] :
      ( v16527(VarCurr)
    <=> v16529(VarCurr) ) ).

tff(addAssignment_8416,axiom,
    ! [VarCurr: state_type] :
      ( v16529(VarCurr)
    <=> v16531(VarCurr) ) ).

tff(writeUnaryOperator_957,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16531(VarCurr)
    <=> v16556(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1375,axiom,
    ! [VarCurr: state_type] :
      ( v16556(VarCurr)
    <=> ( v16557(VarCurr)
        | v16552(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1374,axiom,
    ! [VarCurr: state_type] :
      ( v16557(VarCurr)
    <=> ( v16533(VarCurr)
        | v16548(VarCurr) ) ) ).

tff(addAssignment_8415,axiom,
    ! [VarCurr: state_type] :
      ( v16552(VarCurr)
    <=> v16554(VarCurr) ) ).

tff(addAssignment_8414,axiom,
    ! [VarCurr: state_type] :
      ( v16554(VarCurr)
    <=> v16111(VarCurr,2) ) ).

tff(addAssignment_8413,axiom,
    ! [VarCurr: state_type] :
      ( v16548(VarCurr)
    <=> v16550(VarCurr) ) ).

tff(addAssignment_8412,axiom,
    ! [VarCurr: state_type] :
      ( v16550(VarCurr)
    <=> v16111(VarCurr,1) ) ).

tff(addAssignment_8411,axiom,
    ! [VarCurr: state_type] :
      ( v16533(VarCurr)
    <=> v16535(VarCurr) ) ).

tff(addAssignment_8410,axiom,
    ! [VarCurr: state_type] :
      ( v16535(VarCurr)
    <=> v16537(VarCurr,0) ) ).

tff(addAssignment_8409,axiom,
    ! [VarCurr: state_type] :
      ( v16537(VarCurr,0)
    <=> v16539(VarCurr,0) ) ).

tff(addAssignment_8408,axiom,
    ! [VarCurr: state_type] :
      ( v16539(VarCurr,0)
    <=> v16541(VarCurr,0) ) ).

tff(addAssignment_8407,axiom,
    ! [VarCurr: state_type] :
      ( v16541(VarCurr,0)
    <=> v16546(VarCurr,0) ) ).

tff(writeUnaryOperator_956,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v16546(VarCurr,B)
      <=> ~ v16543(VarCurr,B) ) ) ).

tff(addAssignment_8406,axiom,
    ! [VarCurr: state_type] :
      ( v16543(VarCurr,0)
    <=> v16545(VarCurr,0) ) ).

tff(addAssignment_8405,axiom,
    ! [VarCurr: state_type] :
      ( v16545(VarCurr,0)
    <=> v16111(VarCurr,0) ) ).

tff(addAssignment_8404,axiom,
    ! [VarCurr: state_type] :
      ( v16519(VarCurr)
    <=> v16521(VarCurr) ) ).

tff(addAssignment_8403,axiom,
    ! [VarCurr: state_type] :
      ( v16521(VarCurr)
    <=> $false ) ).

tff(addAssignment_8402,axiom,
    ! [VarCurr: state_type] :
      ( v16513(VarCurr)
    <=> v16515(VarCurr) ) ).

tff(addAssignment_8401,axiom,
    ! [VarCurr: state_type] :
      ( v16515(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8400,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16503(VarCurr,B)
      <=> v16505(VarCurr,B) ) ) ).

tff(addAssignment_8399,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16505(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8398,axiom,
    ! [VarCurr: state_type] :
      ( v16493(VarCurr)
    <=> v16495(VarCurr) ) ).

tff(addAssignment_8397,axiom,
    ! [VarCurr: state_type] :
      ( v16495(VarCurr)
    <=> v16497(VarCurr) ) ).

tff(addAssignment_8396,axiom,
    ! [VarCurr: state_type] :
      ( v16497(VarCurr)
    <=> v16499(VarCurr) ) ).

tff(addAssignment_8395,axiom,
    ! [VarCurr: state_type] :
      ( v16499(VarCurr)
    <=> v16501(VarCurr) ) ).

tff(addAssignment_8394,axiom,
    ! [VarCurr: state_type] :
      ( v16501(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8393,axiom,
    ! [VarCurr: state_type] :
      ( v16483(VarCurr)
    <=> v16485(VarCurr) ) ).

tff(addAssignment_8392,axiom,
    ! [VarCurr: state_type] :
      ( v16485(VarCurr)
    <=> v16487(VarCurr) ) ).

tff(addAssignment_8391,axiom,
    ! [VarCurr: state_type] :
      ( v16487(VarCurr)
    <=> v16489(VarCurr) ) ).

tff(addAssignment_8390,axiom,
    ! [VarCurr: state_type] :
      ( v16489(VarCurr)
    <=> v16491(VarCurr) ) ).

tff(addAssignment_8389,axiom,
    ! [VarCurr: state_type] :
      ( v16491(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_8388,axiom,
    ! [VarCurr: state_type] :
      ( v16181(VarCurr)
    <=> v16183(VarCurr) ) ).

tff(addAssignment_8387,axiom,
    ! [VarCurr: state_type] :
      ( v16183(VarCurr)
    <=> v16185(VarCurr) ) ).

tff(addAssignment_8386,axiom,
    ! [VarCurr: state_type] :
      ( v16185(VarCurr)
    <=> v16187(VarCurr) ) ).

tff(addAssignment_8385,axiom,
    ! [VarCurr: state_type] :
      ( v16187(VarCurr)
    <=> v16189(VarCurr) ) ).

tff(addAssignment_8384,axiom,
    ! [VarCurr: state_type] :
      ( v16189(VarCurr)
    <=> v16191(VarCurr) ) ).

tff(addAssignment_8383,axiom,
    ! [VarCurr: state_type] :
      ( v16191(VarCurr)
    <=> v16193(VarCurr) ) ).

tff(addAssignment_8382,axiom,
    ! [VarCurr: state_type] :
      ( v16193(VarCurr)
    <=> v16195(VarCurr) ) ).

tff(writeUnaryOperator_955,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16195(VarCurr)
    <=> v16470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1373,axiom,
    ! [VarCurr: state_type] :
      ( v16470(VarCurr)
    <=> ( v16471(VarCurr)
        | v16466(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1372,axiom,
    ! [VarCurr: state_type] :
      ( v16471(VarCurr)
    <=> ( v16197(VarCurr)
        | v16462(VarCurr) ) ) ).

tff(addAssignment_8381,axiom,
    ! [VarCurr: state_type] :
      ( v16466(VarCurr)
    <=> v16468(VarCurr) ) ).

tff(addAssignment_8380,axiom,
    ! [VarCurr: state_type] :
      ( v16468(VarCurr)
    <=> v16201(VarCurr,2) ) ).

tff(addAssignment_8379,axiom,
    ! [VarCurr: state_type] :
      ( v16462(VarCurr)
    <=> v16464(VarCurr) ) ).

tff(addAssignment_8378,axiom,
    ! [VarCurr: state_type] :
      ( v16464(VarCurr)
    <=> v16201(VarCurr,1) ) ).

tff(addAssignment_8377,axiom,
    ! [VarCurr: state_type] :
      ( v16197(VarCurr)
    <=> v16199(VarCurr) ) ).

tff(addAssignment_8376,axiom,
    ! [VarCurr: state_type] :
      ( v16199(VarCurr)
    <=> v16201(VarCurr,0) ) ).

tff(addAssignment_8375,axiom,
    ! [VarCurr: state_type] :
      ( v16201(VarCurr,0)
    <=> v16113(VarCurr,3) ) ).

tff(addAssignment_8374,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,3)
    <=> v16115(VarCurr,3) ) ).

tff(addAssignment_8373,axiom,
    ! [VarNext: state_type] :
      ( v16115(VarNext,3)
    <=> v16454(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_187,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16455(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v16454(VarNext,B)
            <=> v16115(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_187,axiom,
    ! [VarNext: state_type] :
      ( v16455(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16454(VarNext,B)
          <=> v16426(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16455(VarNext)
      <=> v16456(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16456(VarNext)
      <=> ( v16458(VarNext)
          & v16368(VarNext) ) ) ) ).

tff(writeUnaryOperator_954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16458(VarNext)
      <=> v16420(VarNext) ) ) ).

tff(addAssignment_8372,axiom,
    ! [VarCurr: state_type] :
      ( v16225(VarCurr,3)
    <=> v16227(VarCurr,3) ) ).

tff(addAssignment_8371,axiom,
    ! [VarCurr: state_type] :
      ( v16227(VarCurr,3)
    <=> v16365(VarCurr,3) ) ).

tff(addAssignment_8370,axiom,
    ! [VarCurr: state_type] :
      ( v16229(VarCurr,0)
    <=> v16231(VarCurr,0) ) ).

tff(addAssignment_8369,axiom,
    ! [VarCurr: state_type] :
      ( v16231(VarCurr,0)
    <=> v16233(VarCurr,0) ) ).

tff(addAssignment_8368,axiom,
    ! [VarCurr: state_type] :
      ( v16233(VarCurr,0)
    <=> v16364(VarCurr,0) ) ).

tff(addAssignment_8367,axiom,
    ! [VarCurr: state_type] :
      ( v16301(VarCurr,0)
    <=> v16303(VarCurr,0) ) ).

tff(addAssignment_8366,axiom,
    ! [VarCurr: state_type] :
      ( v16303(VarCurr,0)
    <=> v16305(VarCurr,0) ) ).

tff(addAssignment_8365,axiom,
    ! [VarCurr: state_type] :
      ( v16305(VarCurr,0)
    <=> v16307(VarCurr,0) ) ).

tff(addAssignment_8364,axiom,
    ! [VarCurr: state_type] :
      ( v16307(VarCurr,0)
    <=> v16309(VarCurr,0) ) ).

tff(addAssignment_8363,axiom,
    ! [VarCurr: state_type] :
      ( v16309(VarCurr,0)
    <=> v16319(VarCurr,0) ) ).

tff(addAssignment_8362,axiom,
    ! [VarCurr: state_type] :
      ( v16235(VarCurr,0)
    <=> v16237(VarCurr,0) ) ).

tff(addAssignment_8361,axiom,
    ! [VarCurr: state_type] :
      ( v16237(VarCurr,0)
    <=> v16298(VarCurr,0) ) ).

tff(addAssignment_8360,axiom,
    ! [VarCurr: state_type] :
      ( v16239(VarCurr)
    <=> v15765(VarCurr,2) ) ).

tff(addAssignment_8359,axiom,
    ! [VarCurr: state_type] :
      ( v15765(VarCurr,2)
    <=> v15767(VarCurr,2) ) ).

tff(addAssignment_8358,axiom,
    ! [VarCurr: state_type] :
      ( v15767(VarCurr,2)
    <=> v15777(VarCurr,2) ) ).

tff(addAssignment_8357,axiom,
    ! [VarCurr: state_type] :
      ( v15769(VarCurr,2)
    <=> v15771(VarCurr,2) ) ).

tff(addAssignment_8356,axiom,
    ! [VarCurr: state_type] :
      ( v15771(VarCurr,2)
    <=> v15774(VarCurr,2) ) ).

tff(addAssignment_8355,axiom,
    ! [VarCurr: state_type] :
      ( v15775(VarCurr)
    <=> v16242(VarCurr,1) ) ).

tff(addAssignment_8354,axiom,
    ! [VarCurr: state_type] :
      ( v16242(VarCurr,1)
    <=> v16244(VarCurr,1) ) ).

tff(addAssignment_8353,axiom,
    ! [VarCurr: state_type] :
      ( v16244(VarCurr,1)
    <=> v16452(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_282,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v16452(VarCurr,B)
      <=> ( v16246(VarCurr,B)
          | v16252(VarCurr,B) ) ) ) ).

tff(addAssignment_8352,axiom,
    ! [VarCurr: state_type] :
      ( v16252(VarCurr,1)
    <=> v16254(VarCurr,1) ) ).

tff(addAssignment_8351,axiom,
    ! [VarCurr: state_type] :
      ( v16254(VarCurr,1)
    <=> v16450(VarCurr,1) ) ).

tff(addAssignment_8350,axiom,
    ! [VarCurr: state_type] :
      ( v16450(VarCurr,0)
    <=> v16451(VarCurr) ) ).

tff(addAssignment_8349,axiom,
    ! [VarCurr: state_type] :
      ( v16450(VarCurr,1)
    <=> v16256(VarCurr) ) ).

tff(addAssignment_8348,axiom,
    ! [VarCurr: state_type] :
      ( v16256(VarCurr)
    <=> v16258(VarCurr,1) ) ).

tff(addAssignment_8347,axiom,
    ! [VarCurr: state_type] :
      ( v16258(VarCurr,1)
    <=> v16260(VarCurr,1) ) ).

tff(addAssignment_8346,axiom,
    ! [VarCurr: state_type] :
      ( v16260(VarCurr,1)
    <=> v16449(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_281,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v16449(VarCurr,B)
      <=> ( v16262(VarCurr,B)
          & v16270(VarCurr,B) ) ) ) ).

tff(addAssignment_8345,axiom,
    ! [VarCurr: state_type] :
      ( v16270(VarCurr,1)
    <=> v16272(VarCurr,1) ) ).

tff(addAssignment_8344,axiom,
    ! [VarCurr: state_type] :
      ( v16272(VarCurr,1)
    <=> v16447(VarCurr,1) ) ).

tff(addAssignment_8343,axiom,
    ! [VarCurr: state_type] :
      ( v16447(VarCurr,0)
    <=> v16448(VarCurr) ) ).

tff(addAssignment_8342,axiom,
    ! [VarCurr: state_type] :
      ( v16447(VarCurr,1)
    <=> v16274(VarCurr) ) ).

tff(addAssignment_8341,axiom,
    ! [VarCurr: state_type] :
      ( v16274(VarCurr)
    <=> v16276(VarCurr) ) ).

tff(addAssignment_8340,axiom,
    ! [VarCurr: state_type] :
      ( v16276(VarCurr)
    <=> v16278(VarCurr) ) ).

tff(writeUnaryOperator_953,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16278(VarCurr)
    <=> v16445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1369,axiom,
    ! [VarCurr: state_type] :
      ( v16445(VarCurr)
    <=> ( v16446(VarCurr)
        | v16433(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1368,axiom,
    ! [VarCurr: state_type] :
      ( v16446(VarCurr)
    <=> ( v16280(VarCurr)
        | v16295(VarCurr) ) ) ).

tff(addAssignment_8339,axiom,
    ! [VarCurr: state_type] :
      ( v16433(VarCurr)
    <=> v16435(VarCurr) ) ).

tff(addAssignment_8338,axiom,
    ! [VarCurr: state_type] :
      ( v16435(VarCurr)
    <=> v16284(VarCurr,2) ) ).

tff(addAssignment_8337,axiom,
    ! [VarCurr: state_type] :
      ( v16284(VarCurr,2)
    <=> v16286(VarCurr,2) ) ).

tff(addAssignment_8336,axiom,
    ! [VarCurr: state_type] :
      ( v16286(VarCurr,2)
    <=> v16288(VarCurr,2) ) ).

tff(addAssignment_8335,axiom,
    ! [VarCurr: state_type] :
      ( v16288(VarCurr,2)
    <=> v16293(VarCurr,2) ) ).

tff(addAssignment_8334,axiom,
    ! [VarCurr: state_type] :
      ( v16290(VarCurr,2)
    <=> v16292(VarCurr,2) ) ).

tff(addAssignment_8333,axiom,
    ! [VarCurr: state_type] :
      ( v16292(VarCurr,2)
    <=> v16201(VarCurr,2) ) ).

tff(addAssignment_8332,axiom,
    ! [VarCurr: state_type] :
      ( v16201(VarCurr,2)
    <=> v16113(VarCurr,5) ) ).

tff(addAssignment_8331,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,5)
    <=> v16115(VarCurr,5) ) ).

tff(addAssignment_8330,axiom,
    ! [VarNext: state_type] :
      ( v16115(VarNext,5)
    <=> v16437(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_186,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16438(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v16437(VarNext,B)
            <=> v16115(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_186,axiom,
    ! [VarNext: state_type] :
      ( v16438(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16437(VarNext,B)
          <=> v16426(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1367,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16438(VarNext)
      <=> v16439(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1366,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16439(VarNext)
      <=> ( v16441(VarNext)
          & v16368(VarNext) ) ) ) ).

tff(writeUnaryOperator_952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16441(VarNext)
      <=> v16420(VarNext) ) ) ).

tff(addAssignment_8329,axiom,
    ! [VarCurr: state_type] :
      ( v16225(VarCurr,5)
    <=> v16227(VarCurr,5) ) ).

tff(addAssignment_8328,axiom,
    ! [VarCurr: state_type] :
      ( v16227(VarCurr,5)
    <=> v16365(VarCurr,5) ) ).

tff(addAssignment_8327,axiom,
    ! [VarCurr: state_type] :
      ( v16229(VarCurr,2)
    <=> v16231(VarCurr,2) ) ).

tff(addAssignment_8326,axiom,
    ! [VarCurr: state_type] :
      ( v16231(VarCurr,2)
    <=> v16233(VarCurr,2) ) ).

tff(addAssignment_8325,axiom,
    ! [VarCurr: state_type] :
      ( v16233(VarCurr,2)
    <=> v16364(VarCurr,2) ) ).

tff(addAssignment_8324,axiom,
    ! [VarCurr: state_type] :
      ( v16301(VarCurr,2)
    <=> v16303(VarCurr,2) ) ).

tff(addAssignment_8323,axiom,
    ! [VarCurr: state_type] :
      ( v16303(VarCurr,2)
    <=> v16305(VarCurr,2) ) ).

tff(addAssignment_8322,axiom,
    ! [VarCurr: state_type] :
      ( v16305(VarCurr,2)
    <=> v16307(VarCurr,2) ) ).

tff(addAssignment_8321,axiom,
    ! [VarCurr: state_type] :
      ( v16307(VarCurr,2)
    <=> v16309(VarCurr,2) ) ).

tff(addAssignment_8320,axiom,
    ! [VarCurr: state_type] :
      ( v16309(VarCurr,2)
    <=> v16319(VarCurr,2) ) ).

tff(addAssignment_8319,axiom,
    ! [VarCurr: state_type] :
      ( v16311(VarCurr,2)
    <=> v16313(VarCurr,2) ) ).

tff(addAssignment_8318,axiom,
    ! [VarCurr: state_type] :
      ( v16313(VarCurr,2)
    <=> v16314(VarCurr,2) ) ).

tff(addAssignment_8317,axiom,
    ! [VarCurr: state_type] :
      ( v16235(VarCurr,2)
    <=> v16237(VarCurr,2) ) ).

tff(addAssignment_8316,axiom,
    ! [VarCurr: state_type] :
      ( v16237(VarCurr,2)
    <=> v16298(VarCurr,2) ) ).

tff(addAssignment_8315,axiom,
    ! [VarCurr: state_type] :
      ( v16295(VarCurr)
    <=> v16297(VarCurr) ) ).

tff(addAssignment_8314,axiom,
    ! [VarCurr: state_type] :
      ( v16297(VarCurr)
    <=> v16201(VarCurr,1) ) ).

tff(addAssignment_8313,axiom,
    ! [VarCurr: state_type] :
      ( v16201(VarCurr,1)
    <=> v16113(VarCurr,4) ) ).

tff(addAssignment_8312,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,4)
    <=> v16115(VarCurr,4) ) ).

tff(addAssignment_8311,axiom,
    ! [VarNext: state_type] :
      ( v16115(VarNext,4)
    <=> v16415(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_185,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16416(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v16415(VarNext,B)
            <=> v16115(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_185,axiom,
    ! [VarNext: state_type] :
      ( v16416(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16415(VarNext,B)
          <=> v16426(VarNext,B) ) ) ) ).

tff(addAssignment_8310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16426(VarNext,B)
          <=> v16424(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16427(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16424(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_130,axiom,
    ! [VarCurr: state_type] :
      ( v16427(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v16424(VarCurr,B)
          <=> v16225(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1365,axiom,
    ! [VarCurr: state_type] :
      ( v16427(VarCurr)
    <=> ( v16428(VarCurr)
        & v16429(VarCurr) ) ) ).

tff(writeUnaryOperator_951,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16429(VarCurr)
    <=> v16215(VarCurr) ) ).

tff(writeUnaryOperator_950,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16428(VarCurr)
    <=> v16203(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1364,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16416(VarNext)
      <=> v16417(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16417(VarNext)
      <=> ( v16418(VarNext)
          & v16368(VarNext) ) ) ) ).

tff(writeUnaryOperator_949,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16418(VarNext)
      <=> v16420(VarNext) ) ) ).

tff(addAssignment_8309,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16420(VarNext)
      <=> v16368(VarCurr) ) ) ).

tff(addAssignment_8308,axiom,
    ! [VarCurr: state_type] :
      ( v16368(VarCurr)
    <=> v16370(VarCurr) ) ).

tff(addAssignment_8307,axiom,
    ! [VarCurr: state_type] :
      ( v16370(VarCurr)
    <=> v16372(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1362,axiom,
    ! [VarCurr: state_type] :
      ( v16372(VarCurr)
    <=> ( v16413(VarCurr)
        | v16409(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1361,axiom,
    ! [VarCurr: state_type] :
      ( v16413(VarCurr)
    <=> ( v16374(VarCurr)
        & v16378(VarCurr) ) ) ).

tff(addAssignment_8306,axiom,
    ! [VarCurr: state_type] :
      ( v16409(VarCurr)
    <=> v16411(VarCurr) ) ).

tff(addAssignment_8305,axiom,
    ! [VarCurr: state_type] :
      ( v16411(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_184,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16393(VarNext)
       => ( v16378(VarNext)
        <=> v16378(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_184,axiom,
    ! [VarNext: state_type] :
      ( v16393(VarNext)
     => ( v16378(VarNext)
      <=> v16403(VarNext) ) ) ).

tff(addAssignment_8304,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16403(VarNext)
      <=> v16401(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1360,axiom,
    ! [VarCurr: state_type] :
      ( v16401(VarCurr)
    <=> ( v16404(VarCurr)
        & v16405(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1359,axiom,
    ! [VarCurr: state_type] :
      ( v16405(VarCurr)
    <=> ( v16384(VarCurr)
        | v16388(VarCurr) ) ) ).

tff(writeUnaryOperator_948,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16404(VarCurr)
    <=> v16380(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1358,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16393(VarNext)
      <=> v16394(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1357,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16394(VarNext)
      <=> ( v16396(VarNext)
          & v16398(VarNext) ) ) ) ).

tff(writeUnaryOperator_947,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16398(VarCurr)
    <=> v16374(VarCurr) ) ).

tff(addAssignment_8303,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16396(VarNext)
      <=> v16374(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_59,axiom,
    ( v16378(constB0)
  <=> $true ) ).

tff(addAssignment_8302,axiom,
    ! [VarCurr: state_type] :
      ( v16388(VarCurr)
    <=> v16390(VarCurr) ) ).

tff(addAssignment_8301,axiom,
    ! [VarCurr: state_type] :
      ( v16390(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8300,axiom,
    ! [VarCurr: state_type] :
      ( v16384(VarCurr)
    <=> v16386(VarCurr) ) ).

tff(addAssignment_8299,axiom,
    ! [VarCurr: state_type] :
      ( v16386(VarCurr)
    <=> $true ) ).

tff(addAssignment_8298,axiom,
    ! [VarCurr: state_type] :
      ( v16380(VarCurr)
    <=> v16382(VarCurr) ) ).

tff(addAssignment_8297,axiom,
    ! [VarCurr: state_type] :
      ( v16382(VarCurr)
    <=> $false ) ).

tff(addAssignment_8296,axiom,
    ! [VarCurr: state_type] :
      ( v16374(VarCurr)
    <=> v16376(VarCurr) ) ).

tff(addAssignment_8295,axiom,
    ! [VarCurr: state_type] :
      ( v16376(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8294,axiom,
    ! [VarCurr: state_type] :
      ( v16225(VarCurr,4)
    <=> v16227(VarCurr,4) ) ).

tff(addAssignment_8293,axiom,
    ! [VarCurr: state_type] :
      ( v16227(VarCurr,4)
    <=> v16365(VarCurr,4) ) ).

tff(addAssignment_8292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v16365(VarCurr,B)
      <=> v16366(VarCurr,B) ) ) ).

tff(addAssignment_8291,axiom,
    ! [VarCurr: state_type] :
      ( ( v16365(VarCurr,5)
      <=> v16229(VarCurr,2) )
      & ( v16365(VarCurr,4)
      <=> v16229(VarCurr,1) )
      & ( v16365(VarCurr,3)
      <=> v16229(VarCurr,0) ) ) ).

tff(addAssignment_8290,axiom,
    ! [VarCurr: state_type] :
      ( v16229(VarCurr,1)
    <=> v16231(VarCurr,1) ) ).

tff(addAssignment_8289,axiom,
    ! [VarCurr: state_type] :
      ( v16231(VarCurr,1)
    <=> v16233(VarCurr,1) ) ).

tff(addAssignment_8288,axiom,
    ! [VarCurr: state_type] :
      ( v16233(VarCurr,1)
    <=> v16364(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_280,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v16364(VarCurr,B)
      <=> ( v16235(VarCurr,B)
          & v16301(VarCurr,B) ) ) ) ).

tff(addAssignment_8287,axiom,
    ! [VarCurr: state_type] :
      ( v16301(VarCurr,1)
    <=> v16303(VarCurr,1) ) ).

tff(addAssignment_8286,axiom,
    ! [VarCurr: state_type] :
      ( v16303(VarCurr,1)
    <=> v16305(VarCurr,1) ) ).

tff(addAssignment_8285,axiom,
    ! [VarCurr: state_type] :
      ( v16305(VarCurr,1)
    <=> v16307(VarCurr,1) ) ).

tff(addAssignment_8284,axiom,
    ! [VarCurr: state_type] :
      ( v16307(VarCurr,1)
    <=> v16309(VarCurr,1) ) ).

tff(addAssignment_8283,axiom,
    ! [VarCurr: state_type] :
      ( v16309(VarCurr,1)
    <=> v16319(VarCurr,1) ) ).

tff(addAssignment_8282,axiom,
    ! [VarCurr: state_type] :
      ( v16319(VarCurr,0)
    <=> v16359(VarCurr) ) ).

tff(addAssignment_8281,axiom,
    ! [VarCurr: state_type] :
      ( v16319(VarCurr,1)
    <=> v16354(VarCurr) ) ).

tff(addAssignment_8280,axiom,
    ! [VarCurr: state_type] :
      ( v16319(VarCurr,2)
    <=> v16349(VarCurr) ) ).

tff(addAssignment_8279,axiom,
    ! [VarCurr: state_type] :
      ( v16319(VarCurr,3)
    <=> v16321(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1356,axiom,
    ! [VarCurr: state_type] :
      ( v16359(VarCurr)
    <=> ( v16360(VarCurr)
        & v16363(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1355,axiom,
    ! [VarCurr: state_type] :
      ( v16363(VarCurr)
    <=> ( v16311(VarCurr,0)
        | v16329(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1354,axiom,
    ! [VarCurr: state_type] :
      ( v16360(VarCurr)
    <=> ( v16361(VarCurr)
        | v16362(VarCurr) ) ) ).

tff(writeUnaryOperator_946,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16362(VarCurr)
    <=> v16329(VarCurr,0) ) ).

tff(writeUnaryOperator_945,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16361(VarCurr)
    <=> v16311(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1353,axiom,
    ! [VarCurr: state_type] :
      ( v16354(VarCurr)
    <=> ( v16355(VarCurr)
        & v16358(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1352,axiom,
    ! [VarCurr: state_type] :
      ( v16358(VarCurr)
    <=> ( v16328(VarCurr)
        | v16330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1351,axiom,
    ! [VarCurr: state_type] :
      ( v16355(VarCurr)
    <=> ( v16356(VarCurr)
        | v16357(VarCurr) ) ) ).

tff(writeUnaryOperator_944,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16357(VarCurr)
    <=> v16330(VarCurr) ) ).

tff(writeUnaryOperator_943,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16356(VarCurr)
    <=> v16328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1350,axiom,
    ! [VarCurr: state_type] :
      ( v16349(VarCurr)
    <=> ( v16350(VarCurr)
        & v16353(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1349,axiom,
    ! [VarCurr: state_type] :
      ( v16353(VarCurr)
    <=> ( v16326(VarCurr)
        | v16336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1348,axiom,
    ! [VarCurr: state_type] :
      ( v16350(VarCurr)
    <=> ( v16351(VarCurr)
        | v16352(VarCurr) ) ) ).

tff(writeUnaryOperator_942,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16352(VarCurr)
    <=> v16336(VarCurr) ) ).

tff(writeUnaryOperator_941,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16351(VarCurr)
    <=> v16326(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1347,axiom,
    ! [VarCurr: state_type] :
      ( v16321(VarCurr)
    <=> ( v16322(VarCurr)
        & v16348(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1346,axiom,
    ! [VarCurr: state_type] :
      ( v16348(VarCurr)
    <=> ( v16324(VarCurr)
        | v16343(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1345,axiom,
    ! [VarCurr: state_type] :
      ( v16322(VarCurr)
    <=> ( v16323(VarCurr)
        | v16342(VarCurr) ) ) ).

tff(writeUnaryOperator_940,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16342(VarCurr)
    <=> v16343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1344,axiom,
    ! [VarCurr: state_type] :
      ( v16343(VarCurr)
    <=> ( v16344(VarCurr)
        & v16347(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_203,axiom,
    ! [VarCurr: state_type] :
      ( v16347(VarCurr)
    <=> ( v16311(VarCurr,3)
        | v16329(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1343,axiom,
    ! [VarCurr: state_type] :
      ( v16344(VarCurr)
    <=> ( v16345(VarCurr)
        | v16346(VarCurr) ) ) ).

tff(writeUnaryOperator_939,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16346(VarCurr)
    <=> v16329(VarCurr,3) ) ).

tff(writeUnaryOperator_938,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16345(VarCurr)
    <=> v16311(VarCurr,3) ) ).

tff(writeUnaryOperator_937,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16323(VarCurr)
    <=> v16324(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1342,axiom,
    ! [VarCurr: state_type] :
      ( v16324(VarCurr)
    <=> ( v16325(VarCurr)
        | v16341(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_202,axiom,
    ! [VarCurr: state_type] :
      ( v16341(VarCurr)
    <=> ( v16311(VarCurr,2)
        & v16329(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1341,axiom,
    ! [VarCurr: state_type] :
      ( v16325(VarCurr)
    <=> ( v16326(VarCurr)
        & v16336(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1340,axiom,
    ! [VarCurr: state_type] :
      ( v16336(VarCurr)
    <=> ( v16337(VarCurr)
        & v16340(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_201,axiom,
    ! [VarCurr: state_type] :
      ( v16340(VarCurr)
    <=> ( v16311(VarCurr,2)
        | v16329(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1339,axiom,
    ! [VarCurr: state_type] :
      ( v16337(VarCurr)
    <=> ( v16338(VarCurr)
        | v16339(VarCurr) ) ) ).

tff(writeUnaryOperator_936,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16339(VarCurr)
    <=> v16329(VarCurr,2) ) ).

tff(writeUnaryOperator_935,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16338(VarCurr)
    <=> v16311(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1338,axiom,
    ! [VarCurr: state_type] :
      ( v16326(VarCurr)
    <=> ( v16327(VarCurr)
        | v16335(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_200,axiom,
    ! [VarCurr: state_type] :
      ( v16335(VarCurr)
    <=> ( v16311(VarCurr,1)
        & v16329(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1337,axiom,
    ! [VarCurr: state_type] :
      ( v16327(VarCurr)
    <=> ( v16328(VarCurr)
        & v16330(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1336,axiom,
    ! [VarCurr: state_type] :
      ( v16330(VarCurr)
    <=> ( v16331(VarCurr)
        & v16334(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_199,axiom,
    ! [VarCurr: state_type] :
      ( v16334(VarCurr)
    <=> ( v16311(VarCurr,1)
        | v16329(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1335,axiom,
    ! [VarCurr: state_type] :
      ( v16331(VarCurr)
    <=> ( v16332(VarCurr)
        | v16333(VarCurr) ) ) ).

tff(writeUnaryOperator_934,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16333(VarCurr)
    <=> v16329(VarCurr,1) ) ).

tff(writeUnaryOperator_933,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16332(VarCurr)
    <=> v16311(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1334,axiom,
    ! [VarCurr: state_type] :
      ( v16328(VarCurr)
    <=> ( v16311(VarCurr,0)
        & v16329(VarCurr,0) ) ) ).

tff(addAssignment_8278,axiom,
    ! [VarCurr: state_type] :
      ( v16329(VarCurr,0)
    <=> v16316(VarCurr) ) ).

tff(addAssignment_8277,axiom,
    ! [VarCurr: state_type] :
      ( ( v16329(VarCurr,3)
      <=> $false )
      & ( v16329(VarCurr,2)
      <=> $false )
      & ( v16329(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_8276,axiom,
    ! [VarCurr: state_type] :
      ( v16316(VarCurr)
    <=> v16318(VarCurr) ) ).

tff(addAssignment_8275,axiom,
    ! [VarCurr: state_type] :
      ( v16318(VarCurr)
    <=> v16266(VarCurr) ) ).

tff(addAssignment_8274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v16311(VarCurr,B)
      <=> v16313(VarCurr,B) ) ) ).

tff(addAssignment_8273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v16313(VarCurr,B)
      <=> v16314(VarCurr,B) ) ) ).

tff(addAssignment_8272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v16314(VarCurr,B)
      <=> v16201(VarCurr,B) ) ) ).

tff(addAssignment_8271,axiom,
    ! [VarCurr: state_type] :
      ( v16314(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_8270,axiom,
    ! [VarCurr: state_type] :
      ( v16235(VarCurr,1)
    <=> v16237(VarCurr,1) ) ).

tff(addAssignment_8269,axiom,
    ! [VarCurr: state_type] :
      ( v16237(VarCurr,1)
    <=> v16298(VarCurr,1) ) ).

tff(addAssignment_8268,axiom,
    ! [VarCurr: state_type] :
      ( v16298(VarCurr,0)
    <=> v16299(VarCurr) ) ).

tff(addAssignment_8267,axiom,
    ! [VarCurr: state_type] :
      ( v16298(VarCurr,1)
    <=> v16299(VarCurr) ) ).

tff(addAssignment_8266,axiom,
    ! [VarCurr: state_type] :
      ( v16298(VarCurr,2)
    <=> v16299(VarCurr) ) ).

tff(addAssignment_8265,axiom,
    ! [VarCurr: state_type] :
      ( v16299(VarCurr)
    <=> v16239(VarCurr) ) ).

tff(addAssignment_8264,axiom,
    ! [VarCurr: state_type] :
      ( v16280(VarCurr)
    <=> v16282(VarCurr) ) ).

tff(addAssignment_8263,axiom,
    ! [VarCurr: state_type] :
      ( v16282(VarCurr)
    <=> v16284(VarCurr,0) ) ).

tff(addAssignment_8262,axiom,
    ! [VarCurr: state_type] :
      ( v16284(VarCurr,0)
    <=> v16286(VarCurr,0) ) ).

tff(addAssignment_8261,axiom,
    ! [VarCurr: state_type] :
      ( v16286(VarCurr,0)
    <=> v16288(VarCurr,0) ) ).

tff(addAssignment_8260,axiom,
    ! [VarCurr: state_type] :
      ( v16288(VarCurr,0)
    <=> v16293(VarCurr,0) ) ).

tff(writeUnaryOperator_932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v16293(VarCurr,B)
      <=> ~ v16290(VarCurr,B) ) ) ).

tff(addAssignment_8259,axiom,
    ! [VarCurr: state_type] :
      ( v16290(VarCurr,0)
    <=> v16292(VarCurr,0) ) ).

tff(addAssignment_8258,axiom,
    ! [VarCurr: state_type] :
      ( v16292(VarCurr,0)
    <=> v16201(VarCurr,0) ) ).

tff(addAssignment_8257,axiom,
    ! [VarCurr: state_type] :
      ( v16262(VarCurr,1)
    <=> v16264(VarCurr,1) ) ).

tff(addAssignment_8256,axiom,
    ! [VarCurr: state_type] :
      ( v16264(VarCurr,1)
    <=> v16267(VarCurr,1) ) ).

tff(addAssignment_8255,axiom,
    ! [VarCurr: state_type] :
      ( v16267(VarCurr,0)
    <=> v16268(VarCurr) ) ).

tff(addAssignment_8254,axiom,
    ! [VarCurr: state_type] :
      ( v16267(VarCurr,1)
    <=> v16266(VarCurr) ) ).

tff(addAssignment_8253,axiom,
    ! [VarCurr: state_type] :
      ( v16266(VarCurr)
    <=> v10053(VarCurr,4) ) ).

tff(addAssignment_8252,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,4)
    <=> v10055(VarCurr,4) ) ).

tff(addAssignment_8251,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,4)
    <=> v10057(VarCurr,4) ) ).

tff(addAssignment_8250,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,4)
    <=> v10061(VarCurr,4) ) ).

tff(addAssignment_8249,axiom,
    ! [VarCurr: state_type] :
      ( v16246(VarCurr,1)
    <=> v16248(VarCurr,1) ) ).

tff(addAssignment_8248,axiom,
    ! [VarCurr: state_type] :
      ( v16248(VarCurr,1)
    <=> v16249(VarCurr,1) ) ).

tff(addAssignment_8247,axiom,
    ! [VarCurr: state_type] :
      ( v16249(VarCurr,0)
    <=> v16250(VarCurr) ) ).

tff(addAssignment_8246,axiom,
    ! [VarCurr: state_type] :
      ( v16249(VarCurr,1)
    <=> v16250(VarCurr) ) ).

tff(addAssignment_8245,axiom,
    ! [VarCurr: state_type] :
      ( v16250(VarCurr)
    <=> v15773(VarCurr) ) ).

tff(addAssignment_8244,axiom,
    ! [VarCurr: state_type] :
      ( v16215(VarCurr)
    <=> v16217(VarCurr) ) ).

tff(addAssignment_8243,axiom,
    ! [VarCurr: state_type] :
      ( v16217(VarCurr)
    <=> v16219(VarCurr) ) ).

tff(addAssignment_8242,axiom,
    ! [VarCurr: state_type] :
      ( v16219(VarCurr)
    <=> v16221(VarCurr) ) ).

tff(addAssignment_8241,axiom,
    ! [VarCurr: state_type] :
      ( v16221(VarCurr)
    <=> v16223(VarCurr) ) ).

tff(addAssignment_8240,axiom,
    ! [VarCurr: state_type] :
      ( v16223(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_8239,axiom,
    ! [VarCurr: state_type] :
      ( v16203(VarCurr)
    <=> v16205(VarCurr) ) ).

tff(addAssignment_8238,axiom,
    ! [VarCurr: state_type] :
      ( v16205(VarCurr)
    <=> v16207(VarCurr) ) ).

tff(addAssignment_8237,axiom,
    ! [VarCurr: state_type] :
      ( v16207(VarCurr)
    <=> v16209(VarCurr) ) ).

tff(addAssignment_8236,axiom,
    ! [VarCurr: state_type] :
      ( v16209(VarCurr)
    <=> v16211(VarCurr) ) ).

tff(addAssignment_8235,axiom,
    ! [VarCurr: state_type] :
      ( v16211(VarCurr)
    <=> v16213(VarCurr) ) ).

tff(addAssignment_8234,axiom,
    ! [VarCurr: state_type] :
      ( v16213(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_8233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15711(VarCurr,B)
      <=> v15713(VarCurr,B) ) ) ).

tff(addAssignment_8232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15713(VarCurr,B)
      <=> v15715(VarCurr,B) ) ) ).

tff(addAssignment_8231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15715(VarCurr,B)
      <=> v15717(VarCurr,B) ) ) ).

tff(addAssignment_8230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15717(VarCurr,B)
      <=> v15719(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16164(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15719(VarNext,B)
            <=> v15719(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_183,axiom,
    ! [VarNext: state_type] :
      ( v16164(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15719(VarNext,B)
          <=> v16174(VarNext,B) ) ) ) ).

tff(addAssignment_8229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16174(VarNext,B)
          <=> v16172(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16172(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_129,axiom,
    ! [VarCurr: state_type] :
      ( v16175(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16172(VarCurr,B)
          <=> v15749(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1333,axiom,
    ! [VarCurr: state_type] :
      ( v16175(VarCurr)
    <=> ( v16176(VarCurr)
        & v16177(VarCurr) ) ) ).

tff(writeUnaryOperator_931,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16177(VarCurr)
    <=> v15735(VarCurr) ) ).

tff(writeUnaryOperator_930,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16176(VarCurr)
    <=> v15721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1332,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16164(VarNext)
      <=> v16165(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16165(VarNext)
      <=> ( v16166(VarNext)
          & v16079(VarNext) ) ) ) ).

tff(writeUnaryOperator_929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16166(VarNext)
      <=> v16168(VarNext) ) ) ).

tff(addAssignment_8228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16168(VarNext)
      <=> v16079(VarCurr) ) ) ).

tff(addAssignment_8227,axiom,
    ! [VarCurr: state_type] :
      ( v16079(VarCurr)
    <=> v16081(VarCurr) ) ).

tff(addAssignment_8226,axiom,
    ! [VarCurr: state_type] :
      ( v16081(VarCurr)
    <=> v16083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1330,axiom,
    ! [VarCurr: state_type] :
      ( v16083(VarCurr)
    <=> ( v16161(VarCurr)
        | v16153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1329,axiom,
    ! [VarCurr: state_type] :
      ( v16161(VarCurr)
    <=> ( v16085(VarCurr)
        & v16091(VarCurr) ) ) ).

tff(addAssignment_8225,axiom,
    ! [VarCurr: state_type] :
      ( v16153(VarCurr)
    <=> v16155(VarCurr) ) ).

tff(addAssignment_8224,axiom,
    ! [VarCurr: state_type] :
      ( v16155(VarCurr)
    <=> v16157(VarCurr) ) ).

tff(addAssignment_8223,axiom,
    ! [VarCurr: state_type] :
      ( v16157(VarCurr)
    <=> v16159(VarCurr) ) ).

tff(addAssignment_8222,axiom,
    ! [VarCurr: state_type] :
      ( v16159(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16137(VarNext)
       => ( v16091(VarNext)
        <=> v16091(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_182,axiom,
    ! [VarNext: state_type] :
      ( v16137(VarNext)
     => ( v16091(VarNext)
      <=> v16147(VarNext) ) ) ).

tff(addAssignment_8221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16147(VarNext)
      <=> v16145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1328,axiom,
    ! [VarCurr: state_type] :
      ( v16145(VarCurr)
    <=> ( v16148(VarCurr)
        & v16149(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1327,axiom,
    ! [VarCurr: state_type] :
      ( v16149(VarCurr)
    <=> ( v16097(VarCurr)
        | v16128(VarCurr) ) ) ).

tff(writeUnaryOperator_928,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16148(VarCurr)
    <=> v16093(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1326,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16137(VarNext)
      <=> v16138(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16138(VarNext)
      <=> ( v16140(VarNext)
          & v16142(VarNext) ) ) ) ).

tff(writeUnaryOperator_927,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16142(VarCurr)
    <=> v16085(VarCurr) ) ).

tff(addAssignment_8220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16140(VarNext)
      <=> v16085(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_58,axiom,
    ( v16091(constB0)
  <=> $true ) ).

tff(addAssignment_8219,axiom,
    ! [VarCurr: state_type] :
      ( v16128(VarCurr)
    <=> v16130(VarCurr) ) ).

tff(addAssignment_8218,axiom,
    ! [VarCurr: state_type] :
      ( v16130(VarCurr)
    <=> v16132(VarCurr) ) ).

tff(addAssignment_8217,axiom,
    ! [VarCurr: state_type] :
      ( v16132(VarCurr)
    <=> v16134(VarCurr) ) ).

tff(addAssignment_8216,axiom,
    ! [VarCurr: state_type] :
      ( v16134(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_8215,axiom,
    ! [VarCurr: state_type] :
      ( v16097(VarCurr)
    <=> v16099(VarCurr) ) ).

tff(addAssignment_8214,axiom,
    ! [VarCurr: state_type] :
      ( v16099(VarCurr)
    <=> v16101(VarCurr) ) ).

tff(addAssignment_8213,axiom,
    ! [VarCurr: state_type] :
      ( v16101(VarCurr)
    <=> v16103(VarCurr) ) ).

tff(addAssignment_8212,axiom,
    ! [VarCurr: state_type] :
      ( v16103(VarCurr)
    <=> v16105(VarCurr) ) ).

tff(writeUnaryOperator_926,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16105(VarCurr)
    <=> v16125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1324,axiom,
    ! [VarCurr: state_type] :
      ( v16125(VarCurr)
    <=> ( v16126(VarCurr)
        | v16121(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1323,axiom,
    ! [VarCurr: state_type] :
      ( v16126(VarCurr)
    <=> ( v16107(VarCurr)
        | v16117(VarCurr) ) ) ).

tff(addAssignment_8211,axiom,
    ! [VarCurr: state_type] :
      ( v16121(VarCurr)
    <=> v16123(VarCurr) ) ).

tff(addAssignment_8210,axiom,
    ! [VarCurr: state_type] :
      ( v16123(VarCurr)
    <=> v16111(VarCurr,2) ) ).

tff(addAssignment_8209,axiom,
    ! [VarCurr: state_type] :
      ( v16111(VarCurr,2)
    <=> v16113(VarCurr,2) ) ).

tff(addAssignment_8208,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,2)
    <=> v16115(VarCurr,2) ) ).

tff(addAssignment_8207,axiom,
    ! [VarCurr: state_type] :
      ( v16117(VarCurr)
    <=> v16119(VarCurr) ) ).

tff(addAssignment_8206,axiom,
    ! [VarCurr: state_type] :
      ( v16119(VarCurr)
    <=> v16111(VarCurr,1) ) ).

tff(addAssignment_8205,axiom,
    ! [VarCurr: state_type] :
      ( v16111(VarCurr,1)
    <=> v16113(VarCurr,1) ) ).

tff(addAssignment_8204,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,1)
    <=> v16115(VarCurr,1) ) ).

tff(addAssignment_8203,axiom,
    ! [VarCurr: state_type] :
      ( v16107(VarCurr)
    <=> v16109(VarCurr) ) ).

tff(addAssignment_8202,axiom,
    ! [VarCurr: state_type] :
      ( v16109(VarCurr)
    <=> v16111(VarCurr,0) ) ).

tff(addAssignment_8201,axiom,
    ! [VarCurr: state_type] :
      ( v16111(VarCurr,0)
    <=> v16113(VarCurr,0) ) ).

tff(addAssignment_8200,axiom,
    ! [VarCurr: state_type] :
      ( v16113(VarCurr,0)
    <=> v16115(VarCurr,0) ) ).

tff(addAssignment_8199,axiom,
    ! [VarCurr: state_type] :
      ( v16093(VarCurr)
    <=> v16095(VarCurr) ) ).

tff(addAssignment_8198,axiom,
    ! [VarCurr: state_type] :
      ( v16095(VarCurr)
    <=> $false ) ).

tff(addAssignment_8197,axiom,
    ! [VarCurr: state_type] :
      ( v16085(VarCurr)
    <=> v16087(VarCurr) ) ).

tff(addAssignment_8196,axiom,
    ! [VarCurr: state_type] :
      ( v16087(VarCurr)
    <=> v16089(VarCurr) ) ).

tff(addAssignment_8195,axiom,
    ! [VarCurr: state_type] :
      ( v16089(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_8194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15749(VarCurr,B)
      <=> v15751(VarCurr,B) ) ) ).

tff(addAssignment_8193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15751(VarCurr,B)
      <=> v15753(VarCurr,B) ) ) ).

tff(addAssignment_8192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15753(VarCurr,B)
      <=> v15755(VarCurr,B) ) ) ).

tff(addAssignment_8191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15755(VarCurr,B)
      <=> v15757(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_279,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15757(VarCurr,B)
      <=> ( v15759(VarCurr,B)
          & v15781(VarCurr,B) ) ) ) ).

tff(addAssignment_8190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15781(VarCurr,B)
      <=> v15783(VarCurr,B) ) ) ).

tff(addAssignment_8189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15783(VarCurr,B)
      <=> v15785(VarCurr,B) ) ) ).

tff(addAssignment_8188,axiom,
    ! [VarCurr: state_type] :
      ( ( v15785(VarCurr,11)
      <=> v9198(VarCurr,59) )
      & ( v15785(VarCurr,10)
      <=> v9198(VarCurr,58) )
      & ( v15785(VarCurr,9)
      <=> v9198(VarCurr,57) )
      & ( v15785(VarCurr,8)
      <=> v9198(VarCurr,56) )
      & ( v15785(VarCurr,7)
      <=> v9198(VarCurr,55) )
      & ( v15785(VarCurr,6)
      <=> v9198(VarCurr,54) )
      & ( v15785(VarCurr,5)
      <=> v9198(VarCurr,53) )
      & ( v15785(VarCurr,4)
      <=> v9198(VarCurr,52) )
      & ( v15785(VarCurr,3)
      <=> v9198(VarCurr,51) )
      & ( v15785(VarCurr,2)
      <=> v9198(VarCurr,50) )
      & ( v15785(VarCurr,1)
      <=> v9198(VarCurr,49) )
      & ( v15785(VarCurr,0)
      <=> v9198(VarCurr,48) ) ) ).

tff(addAssignment_8187,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,59)
      <=> v15787(VarCurr,11) )
      & ( v9198(VarCurr,58)
      <=> v15787(VarCurr,10) )
      & ( v9198(VarCurr,57)
      <=> v15787(VarCurr,9) )
      & ( v9198(VarCurr,56)
      <=> v15787(VarCurr,8) )
      & ( v9198(VarCurr,55)
      <=> v15787(VarCurr,7) )
      & ( v9198(VarCurr,54)
      <=> v15787(VarCurr,6) )
      & ( v9198(VarCurr,53)
      <=> v15787(VarCurr,5) )
      & ( v9198(VarCurr,52)
      <=> v15787(VarCurr,4) )
      & ( v9198(VarCurr,51)
      <=> v15787(VarCurr,3) )
      & ( v9198(VarCurr,50)
      <=> v15787(VarCurr,2) )
      & ( v9198(VarCurr,49)
      <=> v15787(VarCurr,1) )
      & ( v9198(VarCurr,48)
      <=> v15787(VarCurr,0) ) ) ).

tff(addAssignment_8186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15787(VarCurr,B)
      <=> v15789(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_278,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15789(VarCurr,B)
      <=> ( v16071(VarCurr,B)
          | v16074(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_277,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16074(VarCurr,B)
      <=> ( v15799(VarCurr,B)
          & v16075(VarCurr,B) ) ) ) ).

tff(addAssignment_8185,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,0)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8184,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,1)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8183,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,2)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8182,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,3)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8181,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,4)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8180,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,5)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8179,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,6)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8178,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,7)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8177,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,8)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8176,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,9)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8175,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,10)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8174,axiom,
    ! [VarCurr: state_type] :
      ( v16075(VarCurr,11)
    <=> v16076(VarCurr) ) ).

tff(addAssignment_8173,axiom,
    ! [VarCurr: state_type] :
      ( v16076(VarCurr)
    <=> v16067(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_276,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16071(VarCurr,B)
      <=> ( v15791(VarCurr,B)
          & v16072(VarCurr,B) ) ) ) ).

tff(addAssignment_8172,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,0)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8171,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,1)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8170,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,2)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8169,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,3)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8168,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,4)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8167,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,5)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8166,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,6)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8165,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,7)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8164,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,8)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8163,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,9)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8162,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,10)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8161,axiom,
    ! [VarCurr: state_type] :
      ( v16072(VarCurr,11)
    <=> v16073(VarCurr) ) ).

tff(addAssignment_8160,axiom,
    ! [VarCurr: state_type] :
      ( v16073(VarCurr)
    <=> v15795(VarCurr) ) ).

tff(addAssignment_8159,axiom,
    ! [VarCurr: state_type] :
      ( v16067(VarCurr)
    <=> v16069(VarCurr) ) ).

tff(addAssignment_8158,axiom,
    ! [VarCurr: state_type] :
      ( v16069(VarCurr)
    <=> v9844(VarCurr,4) ) ).

tff(addAssignment_8157,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,4)
    <=> v9846(VarCurr,4) ) ).

tff(addAssignment_8156,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,4)
    <=> v9496(VarCurr,4) ) ).

tff(addAssignment_8155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15799(VarCurr,B)
      <=> v15801(VarCurr,B) ) ) ).

tff(addAssignment_8154,axiom,
    ! [VarCurr: state_type] :
      ( ( v15801(VarCurr,11)
      <=> v9208(VarCurr,71) )
      & ( v15801(VarCurr,10)
      <=> v9208(VarCurr,70) )
      & ( v15801(VarCurr,9)
      <=> v9208(VarCurr,69) )
      & ( v15801(VarCurr,8)
      <=> v9208(VarCurr,68) )
      & ( v15801(VarCurr,7)
      <=> v9208(VarCurr,67) )
      & ( v15801(VarCurr,6)
      <=> v9208(VarCurr,66) )
      & ( v15801(VarCurr,5)
      <=> v9208(VarCurr,65) )
      & ( v15801(VarCurr,4)
      <=> v9208(VarCurr,64) )
      & ( v15801(VarCurr,3)
      <=> v9208(VarCurr,63) )
      & ( v15801(VarCurr,2)
      <=> v9208(VarCurr,62) )
      & ( v15801(VarCurr,1)
      <=> v9208(VarCurr,61) )
      & ( v15801(VarCurr,0)
      <=> v9208(VarCurr,60) ) ) ).

tff(addAssignment_8153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,72)
        & ~ $less(B,60) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_8152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,72)
        & ~ $less(B,60) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_8151,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,71)
      <=> v15803(VarCurr,11) )
      & ( v9212(VarCurr,70)
      <=> v15803(VarCurr,10) )
      & ( v9212(VarCurr,69)
      <=> v15803(VarCurr,9) )
      & ( v9212(VarCurr,68)
      <=> v15803(VarCurr,8) )
      & ( v9212(VarCurr,67)
      <=> v15803(VarCurr,7) )
      & ( v9212(VarCurr,66)
      <=> v15803(VarCurr,6) )
      & ( v9212(VarCurr,65)
      <=> v15803(VarCurr,5) )
      & ( v9212(VarCurr,64)
      <=> v15803(VarCurr,4) )
      & ( v9212(VarCurr,63)
      <=> v15803(VarCurr,3) )
      & ( v9212(VarCurr,62)
      <=> v15803(VarCurr,2) )
      & ( v9212(VarCurr,61)
      <=> v15803(VarCurr,1) )
      & ( v9212(VarCurr,60)
      <=> v15803(VarCurr,0) ) ) ).

tff(addAssignment_8150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15803(VarCurr,B)
      <=> v15805(VarCurr,B) ) ) ).

tff(addAssignment_8149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15805(VarCurr,B)
      <=> v15807(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16050(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15807(VarNext,B)
            <=> v15807(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_181,axiom,
    ! [VarNext: state_type] :
      ( v16050(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15807(VarNext,B)
          <=> v16060(VarNext,B) ) ) ) ).

tff(addAssignment_8148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16060(VarNext,B)
          <=> v16058(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16061(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16058(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_128,axiom,
    ! [VarCurr: state_type] :
      ( v16061(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v16058(VarCurr,B)
          <=> v15837(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1322,axiom,
    ! [VarCurr: state_type] :
      ( v16061(VarCurr)
    <=> ( v16062(VarCurr)
        & v16063(VarCurr) ) ) ).

tff(writeUnaryOperator_925,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16063(VarCurr)
    <=> v15823(VarCurr) ) ).

tff(writeUnaryOperator_924,axiom,
    ! [VarCurr: state_type] :
      ( ~ v16062(VarCurr)
    <=> v15809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1321,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16050(VarNext)
      <=> v16051(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1320,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16051(VarNext)
      <=> ( v16052(VarNext)
          & v16025(VarNext) ) ) ) ).

tff(writeUnaryOperator_923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v16052(VarNext)
      <=> v16054(VarNext) ) ) ).

tff(addAssignment_8147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v16054(VarNext)
      <=> v16025(VarCurr) ) ) ).

tff(addAssignment_8146,axiom,
    ! [VarCurr: state_type] :
      ( v16025(VarCurr)
    <=> v16027(VarCurr) ) ).

tff(addAssignment_8145,axiom,
    ! [VarCurr: state_type] :
      ( v16027(VarCurr)
    <=> v16029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1319,axiom,
    ! [VarCurr: state_type] :
      ( v16029(VarCurr)
    <=> ( v16047(VarCurr)
        | v16039(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1318,axiom,
    ! [VarCurr: state_type] :
      ( v16047(VarCurr)
    <=> ( v16031(VarCurr)
        & v16037(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_57,axiom,
    ( v16037(constB0)
  <=> $true ) ).

tff(addAssignment_8144,axiom,
    ! [VarCurr: state_type] :
      ( v16039(VarCurr)
    <=> v16041(VarCurr) ) ).

tff(addAssignment_8143,axiom,
    ! [VarCurr: state_type] :
      ( v16041(VarCurr)
    <=> v16043(VarCurr) ) ).

tff(addAssignment_8142,axiom,
    ! [VarCurr: state_type] :
      ( v16043(VarCurr)
    <=> v16045(VarCurr) ) ).

tff(addAssignment_8141,axiom,
    ! [VarCurr: state_type] :
      ( v16045(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_8140,axiom,
    ! [VarCurr: state_type] :
      ( v16031(VarCurr)
    <=> v16033(VarCurr) ) ).

tff(addAssignment_8139,axiom,
    ! [VarCurr: state_type] :
      ( v16033(VarCurr)
    <=> v16035(VarCurr) ) ).

tff(addAssignment_8138,axiom,
    ! [VarCurr: state_type] :
      ( v16035(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_8137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15837(VarCurr,B)
      <=> v15839(VarCurr,B) ) ) ).

tff(addAssignment_8136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15839(VarCurr,B)
      <=> v15841(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_275,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15841(VarCurr,B)
      <=> ( v16010(VarCurr,B)
          | v16021(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_274,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16021(VarCurr,B)
      <=> ( v15974(VarCurr,B)
          & v16022(VarCurr,B) ) ) ) ).

tff(addAssignment_8135,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,0)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8134,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,1)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8133,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,2)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8132,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,3)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8131,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,4)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8130,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,5)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8129,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,6)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8128,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,7)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8127,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,8)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8126,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,9)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8125,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,10)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8124,axiom,
    ! [VarCurr: state_type] :
      ( v16022(VarCurr,11)
    <=> v16023(VarCurr) ) ).

tff(addAssignment_8123,axiom,
    ! [VarCurr: state_type] :
      ( v16023(VarCurr)
    <=> v15984(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_273,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16010(VarCurr,B)
      <=> ( v16011(VarCurr,B)
          | v16018(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_272,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16018(VarCurr,B)
      <=> ( v15938(VarCurr,B)
          & v16019(VarCurr,B) ) ) ) ).

tff(addAssignment_8122,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,0)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8121,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,1)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8120,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,2)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8119,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,3)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8118,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,4)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8117,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,5)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8116,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,6)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8115,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,7)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8114,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,8)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8113,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,9)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8112,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,10)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8111,axiom,
    ! [VarCurr: state_type] :
      ( v16019(VarCurr,11)
    <=> v16020(VarCurr) ) ).

tff(addAssignment_8110,axiom,
    ! [VarCurr: state_type] :
      ( v16020(VarCurr)
    <=> v15948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16011(VarCurr,B)
      <=> ( v16012(VarCurr,B)
          | v16015(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16015(VarCurr,B)
      <=> ( v15891(VarCurr,B)
          & v16016(VarCurr,B) ) ) ) ).

tff(addAssignment_8109,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,0)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8108,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,1)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8107,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,2)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8106,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,3)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8105,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,4)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8104,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,5)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8103,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,6)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8102,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,7)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8101,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,8)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8100,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,9)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8099,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,10)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8098,axiom,
    ! [VarCurr: state_type] :
      ( v16016(VarCurr,11)
    <=> v16017(VarCurr) ) ).

tff(addAssignment_8097,axiom,
    ! [VarCurr: state_type] :
      ( v16017(VarCurr)
    <=> v15901(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_269,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v16012(VarCurr,B)
      <=> ( v15843(VarCurr,B)
          & v16013(VarCurr,B) ) ) ) ).

tff(addAssignment_8096,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,0)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8095,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,1)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8094,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,2)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8093,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,3)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8092,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,4)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8091,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,5)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8090,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,6)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8089,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,7)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8088,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,8)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8087,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,9)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8086,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,10)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8085,axiom,
    ! [VarCurr: state_type] :
      ( v16013(VarCurr,11)
    <=> v16014(VarCurr) ) ).

tff(addAssignment_8084,axiom,
    ! [VarCurr: state_type] :
      ( v16014(VarCurr)
    <=> v15853(VarCurr) ) ).

tff(addAssignment_8083,axiom,
    ! [VarCurr: state_type] :
      ( v15984(VarCurr)
    <=> v15986(VarCurr) ) ).

tff(addAssignment_8082,axiom,
    ! [VarCurr: state_type] :
      ( v15986(VarCurr)
    <=> v15988(VarCurr) ) ).

tff(addAssignment_8081,axiom,
    ! [VarCurr: state_type] :
      ( v15988(VarCurr)
    <=> v15990(VarCurr) ) ).

tff(addAssignment_8080,axiom,
    ! [VarCurr: state_type] :
      ( v15990(VarCurr)
    <=> v15992(VarCurr) ) ).

tff(addAssignment_8079,axiom,
    ! [VarCurr: state_type] :
      ( v15992(VarCurr)
    <=> v15994(VarCurr) ) ).

tff(addAssignment_8078,axiom,
    ! [VarCurr: state_type] :
      ( v15994(VarCurr)
    <=> v15996(VarCurr) ) ).

tff(addAssignment_8077,axiom,
    ! [VarCurr: state_type] :
      ( v15996(VarCurr)
    <=> v15998(VarCurr) ) ).

tff(writeUnaryOperator_922,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15998(VarCurr)
    <=> v16008(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1317,axiom,
    ! [VarCurr: state_type] :
      ( v16008(VarCurr)
    <=> ( v16000(VarCurr)
        | v16004(VarCurr) ) ) ).

tff(addAssignment_8076,axiom,
    ! [VarCurr: state_type] :
      ( v16004(VarCurr)
    <=> v16006(VarCurr) ) ).

tff(addAssignment_8075,axiom,
    ! [VarCurr: state_type] :
      ( v16006(VarCurr)
    <=> v15921(VarCurr,1) ) ).

tff(addAssignment_8074,axiom,
    ! [VarCurr: state_type] :
      ( v16000(VarCurr)
    <=> v16002(VarCurr) ) ).

tff(addAssignment_8073,axiom,
    ! [VarCurr: state_type] :
      ( v16002(VarCurr)
    <=> v15921(VarCurr,0) ) ).

tff(addAssignment_8072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15974(VarCurr,B)
      <=> v15976(VarCurr,B) ) ) ).

tff(addAssignment_8071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15976(VarCurr,B)
      <=> v15978(VarCurr,B) ) ) ).

tff(addAssignment_8070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15978(VarCurr,B)
      <=> v15980(VarCurr,B) ) ) ).

tff(addAssignment_8069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15980(VarCurr,B)
      <=> v15982(VarCurr,B) ) ) ).

tff(addAssignment_8068,axiom,
    ! [VarCurr: state_type] :
      ( v15948(VarCurr)
    <=> v15950(VarCurr) ) ).

tff(addAssignment_8067,axiom,
    ! [VarCurr: state_type] :
      ( v15950(VarCurr)
    <=> v15952(VarCurr) ) ).

tff(addAssignment_8066,axiom,
    ! [VarCurr: state_type] :
      ( v15952(VarCurr)
    <=> v15954(VarCurr) ) ).

tff(addAssignment_8065,axiom,
    ! [VarCurr: state_type] :
      ( v15954(VarCurr)
    <=> v15956(VarCurr) ) ).

tff(addAssignment_8064,axiom,
    ! [VarCurr: state_type] :
      ( v15956(VarCurr)
    <=> v15958(VarCurr) ) ).

tff(addAssignment_8063,axiom,
    ! [VarCurr: state_type] :
      ( v15958(VarCurr)
    <=> v15960(VarCurr) ) ).

tff(addAssignment_8062,axiom,
    ! [VarCurr: state_type] :
      ( v15960(VarCurr)
    <=> v15962(VarCurr) ) ).

tff(writeUnaryOperator_921,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15962(VarCurr)
    <=> v15972(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1316,axiom,
    ! [VarCurr: state_type] :
      ( v15972(VarCurr)
    <=> ( v15964(VarCurr)
        | v15968(VarCurr) ) ) ).

tff(addAssignment_8061,axiom,
    ! [VarCurr: state_type] :
      ( v15968(VarCurr)
    <=> v15970(VarCurr) ) ).

tff(addAssignment_8060,axiom,
    ! [VarCurr: state_type] :
      ( v15970(VarCurr)
    <=> v15921(VarCurr,1) ) ).

tff(addAssignment_8059,axiom,
    ! [VarCurr: state_type] :
      ( v15921(VarCurr,1)
    <=> v15923(VarCurr,1) ) ).

tff(addAssignment_8058,axiom,
    ! [VarCurr: state_type] :
      ( v15923(VarCurr,1)
    <=> v15925(VarCurr,1) ) ).

tff(addAssignment_8057,axiom,
    ! [VarCurr: state_type] :
      ( v15925(VarCurr,1)
    <=> v15930(VarCurr,1) ) ).

tff(addAssignment_8056,axiom,
    ! [VarCurr: state_type] :
      ( v15927(VarCurr,1)
    <=> v15929(VarCurr,1) ) ).

tff(addAssignment_8055,axiom,
    ! [VarCurr: state_type] :
      ( v15929(VarCurr,1)
    <=> v15873(VarCurr,1) ) ).

tff(addAssignment_8054,axiom,
    ! [VarCurr: state_type] :
      ( v15964(VarCurr)
    <=> v15966(VarCurr) ) ).

tff(addAssignment_8053,axiom,
    ! [VarCurr: state_type] :
      ( v15966(VarCurr)
    <=> v15873(VarCurr,0) ) ).

tff(addAssignment_8052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15938(VarCurr,B)
      <=> v15940(VarCurr,B) ) ) ).

tff(addAssignment_8051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15940(VarCurr,B)
      <=> v15942(VarCurr,B) ) ) ).

tff(addAssignment_8050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15942(VarCurr,B)
      <=> v15944(VarCurr,B) ) ) ).

tff(addAssignment_8049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15944(VarCurr,B)
      <=> v15946(VarCurr,B) ) ) ).

tff(addAssignment_8048,axiom,
    ! [VarCurr: state_type] :
      ( v15901(VarCurr)
    <=> v15903(VarCurr) ) ).

tff(addAssignment_8047,axiom,
    ! [VarCurr: state_type] :
      ( v15903(VarCurr)
    <=> v15905(VarCurr) ) ).

tff(addAssignment_8046,axiom,
    ! [VarCurr: state_type] :
      ( v15905(VarCurr)
    <=> v15907(VarCurr) ) ).

tff(addAssignment_8045,axiom,
    ! [VarCurr: state_type] :
      ( v15907(VarCurr)
    <=> v15909(VarCurr) ) ).

tff(addAssignment_8044,axiom,
    ! [VarCurr: state_type] :
      ( v15909(VarCurr)
    <=> v15911(VarCurr) ) ).

tff(addAssignment_8043,axiom,
    ! [VarCurr: state_type] :
      ( v15911(VarCurr)
    <=> v15913(VarCurr) ) ).

tff(addAssignment_8042,axiom,
    ! [VarCurr: state_type] :
      ( v15913(VarCurr)
    <=> v15915(VarCurr) ) ).

tff(writeUnaryOperator_920,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15915(VarCurr)
    <=> v15936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1315,axiom,
    ! [VarCurr: state_type] :
      ( v15936(VarCurr)
    <=> ( v15917(VarCurr)
        | v15932(VarCurr) ) ) ).

tff(addAssignment_8041,axiom,
    ! [VarCurr: state_type] :
      ( v15932(VarCurr)
    <=> v15934(VarCurr) ) ).

tff(addAssignment_8040,axiom,
    ! [VarCurr: state_type] :
      ( v15934(VarCurr)
    <=> v15873(VarCurr,1) ) ).

tff(addAssignment_8039,axiom,
    ! [VarCurr: state_type] :
      ( v15917(VarCurr)
    <=> v15919(VarCurr) ) ).

tff(addAssignment_8038,axiom,
    ! [VarCurr: state_type] :
      ( v15919(VarCurr)
    <=> v15921(VarCurr,0) ) ).

tff(addAssignment_8037,axiom,
    ! [VarCurr: state_type] :
      ( v15921(VarCurr,0)
    <=> v15923(VarCurr,0) ) ).

tff(addAssignment_8036,axiom,
    ! [VarCurr: state_type] :
      ( v15923(VarCurr,0)
    <=> v15925(VarCurr,0) ) ).

tff(addAssignment_8035,axiom,
    ! [VarCurr: state_type] :
      ( v15925(VarCurr,0)
    <=> v15930(VarCurr,0) ) ).

tff(writeUnaryOperator_919,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v15930(VarCurr,B)
      <=> ~ v15927(VarCurr,B) ) ) ).

tff(addAssignment_8034,axiom,
    ! [VarCurr: state_type] :
      ( v15927(VarCurr,0)
    <=> v15929(VarCurr,0) ) ).

tff(addAssignment_8033,axiom,
    ! [VarCurr: state_type] :
      ( v15929(VarCurr,0)
    <=> v15873(VarCurr,0) ) ).

tff(addAssignment_8032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15891(VarCurr,B)
      <=> v15893(VarCurr,B) ) ) ).

tff(addAssignment_8031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15893(VarCurr,B)
      <=> v15895(VarCurr,B) ) ) ).

tff(addAssignment_8030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15895(VarCurr,B)
      <=> v15897(VarCurr,B) ) ) ).

tff(addAssignment_8029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15897(VarCurr,B)
      <=> v15899(VarCurr,B) ) ) ).

tff(addAssignment_8028,axiom,
    ! [VarCurr: state_type] :
      ( v15853(VarCurr)
    <=> v15855(VarCurr) ) ).

tff(addAssignment_8027,axiom,
    ! [VarCurr: state_type] :
      ( v15855(VarCurr)
    <=> v15857(VarCurr) ) ).

tff(addAssignment_8026,axiom,
    ! [VarCurr: state_type] :
      ( v15857(VarCurr)
    <=> v15859(VarCurr) ) ).

tff(addAssignment_8025,axiom,
    ! [VarCurr: state_type] :
      ( v15859(VarCurr)
    <=> v15861(VarCurr) ) ).

tff(addAssignment_8024,axiom,
    ! [VarCurr: state_type] :
      ( v15861(VarCurr)
    <=> v15863(VarCurr) ) ).

tff(addAssignment_8023,axiom,
    ! [VarCurr: state_type] :
      ( v15863(VarCurr)
    <=> v15865(VarCurr) ) ).

tff(addAssignment_8022,axiom,
    ! [VarCurr: state_type] :
      ( v15865(VarCurr)
    <=> v15867(VarCurr) ) ).

tff(writeUnaryOperator_918,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15867(VarCurr)
    <=> v15889(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1314,axiom,
    ! [VarCurr: state_type] :
      ( v15889(VarCurr)
    <=> ( v15869(VarCurr)
        | v15885(VarCurr) ) ) ).

tff(addAssignment_8021,axiom,
    ! [VarCurr: state_type] :
      ( v15885(VarCurr)
    <=> v15887(VarCurr) ) ).

tff(addAssignment_8020,axiom,
    ! [VarCurr: state_type] :
      ( v15887(VarCurr)
    <=> v15873(VarCurr,1) ) ).

tff(addAssignment_8019,axiom,
    ! [VarCurr: state_type] :
      ( v15873(VarCurr,1)
    <=> v15875(VarCurr,1) ) ).

tff(addAssignment_8018,axiom,
    ! [VarCurr: state_type] :
      ( v15875(VarCurr,1)
    <=> v15877(VarCurr,1) ) ).

tff(addAssignment_8017,axiom,
    ! [VarCurr: state_type] :
      ( v15877(VarCurr,1)
    <=> v15879(VarCurr,1) ) ).

tff(addAssignment_8016,axiom,
    ! [VarCurr: state_type] :
      ( v15879(VarCurr,1)
    <=> v15881(VarCurr,1) ) ).

tff(addAssignment_8015,axiom,
    ! [VarCurr: state_type] :
      ( v15881(VarCurr,1)
    <=> v15883(VarCurr,1) ) ).

tff(addAssignment_8014,axiom,
    ! [VarCurr: state_type] :
      ( v15869(VarCurr)
    <=> v15871(VarCurr) ) ).

tff(addAssignment_8013,axiom,
    ! [VarCurr: state_type] :
      ( v15871(VarCurr)
    <=> v15873(VarCurr,0) ) ).

tff(addAssignment_8012,axiom,
    ! [VarCurr: state_type] :
      ( v15873(VarCurr,0)
    <=> v15875(VarCurr,0) ) ).

tff(addAssignment_8011,axiom,
    ! [VarCurr: state_type] :
      ( v15875(VarCurr,0)
    <=> v15877(VarCurr,0) ) ).

tff(addAssignment_8010,axiom,
    ! [VarCurr: state_type] :
      ( v15877(VarCurr,0)
    <=> v15879(VarCurr,0) ) ).

tff(addAssignment_8009,axiom,
    ! [VarCurr: state_type] :
      ( v15879(VarCurr,0)
    <=> v15881(VarCurr,0) ) ).

tff(addAssignment_8008,axiom,
    ! [VarCurr: state_type] :
      ( v15881(VarCurr,0)
    <=> v15883(VarCurr,0) ) ).

tff(addAssignment_8007,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15843(VarCurr,B)
      <=> v15845(VarCurr,B) ) ) ).

tff(addAssignment_8006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15845(VarCurr,B)
      <=> v15847(VarCurr,B) ) ) ).

tff(addAssignment_8005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15847(VarCurr,B)
      <=> v15849(VarCurr,B) ) ) ).

tff(addAssignment_8004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15849(VarCurr,B)
      <=> v15851(VarCurr,B) ) ) ).

tff(addAssignment_8003,axiom,
    ! [VarCurr: state_type] :
      ( v15823(VarCurr)
    <=> v15825(VarCurr) ) ).

tff(addAssignment_8002,axiom,
    ! [VarCurr: state_type] :
      ( v15825(VarCurr)
    <=> v15827(VarCurr) ) ).

tff(addAssignment_8001,axiom,
    ! [VarCurr: state_type] :
      ( v15827(VarCurr)
    <=> v15829(VarCurr) ) ).

tff(addAssignment_8000,axiom,
    ! [VarCurr: state_type] :
      ( v15829(VarCurr)
    <=> v15831(VarCurr) ) ).

tff(addAssignment_7999,axiom,
    ! [VarCurr: state_type] :
      ( v15831(VarCurr)
    <=> v15833(VarCurr) ) ).

tff(addAssignment_7998,axiom,
    ! [VarCurr: state_type] :
      ( v15833(VarCurr)
    <=> v15835(VarCurr) ) ).

tff(addAssignment_7997,axiom,
    ! [VarCurr: state_type] :
      ( v15835(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_7996,axiom,
    ! [VarCurr: state_type] :
      ( v15809(VarCurr)
    <=> v15811(VarCurr) ) ).

tff(addAssignment_7995,axiom,
    ! [VarCurr: state_type] :
      ( v15811(VarCurr)
    <=> v15813(VarCurr) ) ).

tff(addAssignment_7994,axiom,
    ! [VarCurr: state_type] :
      ( v15813(VarCurr)
    <=> v15815(VarCurr) ) ).

tff(addAssignment_7993,axiom,
    ! [VarCurr: state_type] :
      ( v15815(VarCurr)
    <=> v15817(VarCurr) ) ).

tff(addAssignment_7992,axiom,
    ! [VarCurr: state_type] :
      ( v15817(VarCurr)
    <=> v15819(VarCurr) ) ).

tff(addAssignment_7991,axiom,
    ! [VarCurr: state_type] :
      ( v15819(VarCurr)
    <=> v15821(VarCurr) ) ).

tff(addAssignment_7990,axiom,
    ! [VarCurr: state_type] :
      ( v15821(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_7989,axiom,
    ! [VarCurr: state_type] :
      ( v15795(VarCurr)
    <=> v15797(VarCurr) ) ).

tff(addAssignment_7988,axiom,
    ! [VarCurr: state_type] :
      ( v15797(VarCurr)
    <=> v9490(VarCurr,4) ) ).

tff(addAssignment_7987,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,4)
    <=> v9492(VarCurr,4) ) ).

tff(addAssignment_7986,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,4)
    <=> v9494(VarCurr,4) ) ).

tff(addAssignment_7985,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,4)
    <=> v9570(VarCurr,4) ) ).

tff(addAssignment_7984,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,4)
    <=> v9513(VarCurr,4) ) ).

tff(addAssignment_7983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15791(VarCurr,B)
      <=> v15793(VarCurr,B) ) ) ).

tff(addAssignment_7982,axiom,
    ! [VarCurr: state_type] :
      ( ( v15793(VarCurr,11)
      <=> v9208(VarCurr,59) )
      & ( v15793(VarCurr,10)
      <=> v9208(VarCurr,58) )
      & ( v15793(VarCurr,9)
      <=> v9208(VarCurr,57) )
      & ( v15793(VarCurr,8)
      <=> v9208(VarCurr,56) )
      & ( v15793(VarCurr,7)
      <=> v9208(VarCurr,55) )
      & ( v15793(VarCurr,6)
      <=> v9208(VarCurr,54) )
      & ( v15793(VarCurr,5)
      <=> v9208(VarCurr,53) )
      & ( v15793(VarCurr,4)
      <=> v9208(VarCurr,52) )
      & ( v15793(VarCurr,3)
      <=> v9208(VarCurr,51) )
      & ( v15793(VarCurr,2)
      <=> v9208(VarCurr,50) )
      & ( v15793(VarCurr,1)
      <=> v9208(VarCurr,49) )
      & ( v15793(VarCurr,0)
      <=> v9208(VarCurr,48) ) ) ).

tff(addAssignment_7981,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15759(VarCurr,B)
      <=> v15761(VarCurr,B) ) ) ).

tff(addAssignment_7980,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,0)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7979,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,1)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7978,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,2)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7977,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,3)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7976,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,4)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7975,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,5)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7974,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,6)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7973,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,7)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7972,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,8)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7971,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,9)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7970,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,10)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7969,axiom,
    ! [VarCurr: state_type] :
      ( v15761(VarCurr,11)
    <=> v15779(VarCurr) ) ).

tff(addAssignment_7968,axiom,
    ! [VarCurr: state_type] :
      ( v15779(VarCurr)
    <=> v15763(VarCurr) ) ).

tff(addAssignment_7967,axiom,
    ! [VarCurr: state_type] :
      ( v15763(VarCurr)
    <=> v15765(VarCurr,0) ) ).

tff(addAssignment_7966,axiom,
    ! [VarCurr: state_type] :
      ( v15765(VarCurr,0)
    <=> v15767(VarCurr,0) ) ).

tff(addAssignment_7965,axiom,
    ! [VarCurr: state_type] :
      ( v15767(VarCurr,0)
    <=> v15777(VarCurr,0) ) ).

tff(writeUnaryOperator_917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v15777(VarCurr,B)
      <=> ~ v15769(VarCurr,B) ) ) ).

tff(addAssignment_7964,axiom,
    ! [VarCurr: state_type] :
      ( v15769(VarCurr,0)
    <=> v15771(VarCurr,0) ) ).

tff(addAssignment_7963,axiom,
    ! [VarCurr: state_type] :
      ( v15771(VarCurr,0)
    <=> v15774(VarCurr,0) ) ).

tff(addAssignment_7962,axiom,
    ! [VarCurr: state_type] :
      ( v15774(VarCurr,0)
    <=> v15773(VarCurr) ) ).

tff(addAssignment_7961,axiom,
    ! [VarCurr: state_type] :
      ( v15774(VarCurr,1)
    <=> v15776(VarCurr) ) ).

tff(addAssignment_7960,axiom,
    ! [VarCurr: state_type] :
      ( v15774(VarCurr,2)
    <=> v15775(VarCurr) ) ).

tff(addAssignment_7959,axiom,
    ! [VarCurr: state_type] :
      ( v15773(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_7958,axiom,
    ! [VarCurr: state_type] :
      ( v15735(VarCurr)
    <=> v15737(VarCurr) ) ).

tff(addAssignment_7957,axiom,
    ! [VarCurr: state_type] :
      ( v15737(VarCurr)
    <=> v15739(VarCurr) ) ).

tff(addAssignment_7956,axiom,
    ! [VarCurr: state_type] :
      ( v15739(VarCurr)
    <=> v15741(VarCurr) ) ).

tff(addAssignment_7955,axiom,
    ! [VarCurr: state_type] :
      ( v15741(VarCurr)
    <=> v15743(VarCurr) ) ).

tff(addAssignment_7954,axiom,
    ! [VarCurr: state_type] :
      ( v15743(VarCurr)
    <=> v15745(VarCurr) ) ).

tff(addAssignment_7953,axiom,
    ! [VarCurr: state_type] :
      ( v15745(VarCurr)
    <=> v15747(VarCurr) ) ).

tff(addAssignment_7952,axiom,
    ! [VarCurr: state_type] :
      ( v15747(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_7951,axiom,
    ! [VarCurr: state_type] :
      ( v15721(VarCurr)
    <=> v15723(VarCurr) ) ).

tff(addAssignment_7950,axiom,
    ! [VarCurr: state_type] :
      ( v15723(VarCurr)
    <=> v15725(VarCurr) ) ).

tff(addAssignment_7949,axiom,
    ! [VarCurr: state_type] :
      ( v15725(VarCurr)
    <=> v15727(VarCurr) ) ).

tff(addAssignment_7948,axiom,
    ! [VarCurr: state_type] :
      ( v15727(VarCurr)
    <=> v15729(VarCurr) ) ).

tff(addAssignment_7947,axiom,
    ! [VarCurr: state_type] :
      ( v15729(VarCurr)
    <=> v15731(VarCurr) ) ).

tff(addAssignment_7946,axiom,
    ! [VarCurr: state_type] :
      ( v15731(VarCurr)
    <=> v15733(VarCurr) ) ).

tff(addAssignment_7945,axiom,
    ! [VarCurr: state_type] :
      ( v15733(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_7944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15697(VarCurr,B)
      <=> v15699(VarCurr,B) ) ) ).

tff(addAssignment_7943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15699(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_7942,axiom,
    ! [VarCurr: state_type] :
      ( v14141(VarCurr)
    <=> v14143(VarCurr) ) ).

tff(addAssignment_7941,axiom,
    ! [VarCurr: state_type] :
      ( v14143(VarCurr)
    <=> v14145(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_89,axiom,
    ! [VarCurr: state_type] :
      ( v14145(VarCurr)
    <=> ( ( v14147(VarCurr,11)
        <=> v14151(VarCurr,11) )
        & ( v14147(VarCurr,10)
        <=> v14151(VarCurr,10) )
        & ( v14147(VarCurr,9)
        <=> v14151(VarCurr,9) )
        & ( v14147(VarCurr,8)
        <=> v14151(VarCurr,8) )
        & ( v14147(VarCurr,7)
        <=> v14151(VarCurr,7) )
        & ( v14147(VarCurr,6)
        <=> v14151(VarCurr,6) )
        & ( v14147(VarCurr,5)
        <=> v14151(VarCurr,5) )
        & ( v14147(VarCurr,4)
        <=> v14151(VarCurr,4) )
        & ( v14147(VarCurr,3)
        <=> v14151(VarCurr,3) )
        & ( v14147(VarCurr,2)
        <=> v14151(VarCurr,2) )
        & ( v14147(VarCurr,1)
        <=> v14151(VarCurr,1) )
        & ( v14147(VarCurr,0)
        <=> v14151(VarCurr,0) ) ) ) ).

tff(addAssignment_7940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14151(VarCurr,B)
      <=> v14153(VarCurr,B) ) ) ).

tff(addAssignment_7939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14153(VarCurr,B)
      <=> v14155(VarCurr,B) ) ) ).

tff(addAssignment_7938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14155(VarCurr,B)
      <=> v14157(VarCurr,B) ) ) ).

tff(addAssignment_7937,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14157(VarCurr,B)
      <=> v14159(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14159(VarCurr,B)
      <=> ( v15667(VarCurr,B)
          | v15686(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_267,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15686(VarCurr,B)
      <=> ( v15538(VarCurr,B)
          & v15687(VarCurr,B) ) ) ) ).

tff(addAssignment_7936,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,0)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7935,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,1)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7934,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,2)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7933,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,3)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7932,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,4)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7931,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,5)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7930,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,6)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7929,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,7)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7928,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,8)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7927,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,9)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7926,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,10)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7925,axiom,
    ! [VarCurr: state_type] :
      ( v15687(VarCurr,11)
    <=> v15688(VarCurr) ) ).

tff(addAssignment_7924,axiom,
    ! [VarCurr: state_type] :
      ( v15688(VarCurr)
    <=> v15657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_266,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15667(VarCurr,B)
      <=> ( v15668(VarCurr,B)
          | v15683(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15683(VarCurr,B)
      <=> ( v15387(VarCurr,B)
          & v15684(VarCurr,B) ) ) ) ).

tff(addAssignment_7923,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,0)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7922,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,1)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7921,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,2)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7920,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,3)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7919,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,4)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7918,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,5)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7917,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,6)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7916,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,7)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7915,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,8)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7914,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,9)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7913,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,10)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7912,axiom,
    ! [VarCurr: state_type] :
      ( v15684(VarCurr,11)
    <=> v15685(VarCurr) ) ).

tff(addAssignment_7911,axiom,
    ! [VarCurr: state_type] :
      ( v15685(VarCurr)
    <=> v15507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15668(VarCurr,B)
      <=> ( v15669(VarCurr,B)
          | v15680(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15680(VarCurr,B)
      <=> ( v15236(VarCurr,B)
          & v15681(VarCurr,B) ) ) ) ).

tff(addAssignment_7910,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,0)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7909,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,1)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7908,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,2)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7907,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,3)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7906,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,4)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7905,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,5)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7904,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,6)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7903,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,7)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7902,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,8)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7901,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,9)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7900,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,10)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7899,axiom,
    ! [VarCurr: state_type] :
      ( v15681(VarCurr,11)
    <=> v15682(VarCurr) ) ).

tff(addAssignment_7898,axiom,
    ! [VarCurr: state_type] :
      ( v15682(VarCurr)
    <=> v15356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15669(VarCurr,B)
      <=> ( v15670(VarCurr,B)
          | v15677(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15677(VarCurr,B)
      <=> ( v15085(VarCurr,B)
          & v15678(VarCurr,B) ) ) ) ).

tff(addAssignment_7897,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,0)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7896,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,1)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7895,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,2)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7894,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,3)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7893,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,4)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7892,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,5)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7891,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,6)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7890,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,7)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7889,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,8)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7888,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,9)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7887,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,10)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7886,axiom,
    ! [VarCurr: state_type] :
      ( v15678(VarCurr,11)
    <=> v15679(VarCurr) ) ).

tff(addAssignment_7885,axiom,
    ! [VarCurr: state_type] :
      ( v15679(VarCurr)
    <=> v15205(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15670(VarCurr,B)
      <=> ( v15671(VarCurr,B)
          | v15674(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_259,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15674(VarCurr,B)
      <=> ( v14923(VarCurr,B)
          & v15675(VarCurr,B) ) ) ) ).

tff(addAssignment_7884,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,0)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7883,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,1)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7882,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,2)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7881,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,3)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7880,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,4)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7879,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,5)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7878,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,6)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7877,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,7)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7876,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,8)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7875,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,9)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7874,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,10)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7873,axiom,
    ! [VarCurr: state_type] :
      ( v15675(VarCurr,11)
    <=> v15676(VarCurr) ) ).

tff(addAssignment_7872,axiom,
    ! [VarCurr: state_type] :
      ( v15676(VarCurr)
    <=> v15054(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_258,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15671(VarCurr,B)
      <=> ( v14161(VarCurr,B)
          & v15672(VarCurr,B) ) ) ) ).

tff(addAssignment_7871,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,0)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7870,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,1)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7869,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,2)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7868,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,3)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7867,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,4)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7866,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,5)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7865,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,6)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7864,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,7)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7863,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,8)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7862,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,9)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7861,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,10)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7860,axiom,
    ! [VarCurr: state_type] :
      ( v15672(VarCurr,11)
    <=> v15673(VarCurr) ) ).

tff(addAssignment_7859,axiom,
    ! [VarCurr: state_type] :
      ( v15673(VarCurr)
    <=> v14631(VarCurr) ) ).

tff(addAssignment_7858,axiom,
    ! [VarCurr: state_type] :
      ( v15657(VarCurr)
    <=> v15659(VarCurr) ) ).

tff(addAssignment_7857,axiom,
    ! [VarCurr: state_type] :
      ( v15659(VarCurr)
    <=> v15661(VarCurr) ) ).

tff(addAssignment_7856,axiom,
    ! [VarCurr: state_type] :
      ( v15661(VarCurr)
    <=> v15663(VarCurr) ) ).

tff(addAssignment_7855,axiom,
    ! [VarCurr: state_type] :
      ( v15663(VarCurr)
    <=> v15665(VarCurr) ) ).

tff(addAssignment_7854,axiom,
    ! [VarCurr: state_type] :
      ( v15665(VarCurr)
    <=> v14724(VarCurr) ) ).

tff(addAssignment_7853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15538(VarCurr,B)
      <=> v15540(VarCurr,B) ) ) ).

tff(addAssignment_7852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15540(VarCurr,B)
      <=> v15542(VarCurr,B) ) ) ).

tff(addAssignment_7851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15542(VarCurr,B)
      <=> v15544(VarCurr,B) ) ) ).

tff(addAssignment_7850,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15544(VarCurr,B)
      <=> v15546(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15640(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15546(VarNext,B)
            <=> v15546(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_180,axiom,
    ! [VarNext: state_type] :
      ( v15640(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15546(VarNext,B)
          <=> v15650(VarNext,B) ) ) ) ).

tff(addAssignment_7849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15650(VarNext,B)
          <=> v15648(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15651(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15648(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_127,axiom,
    ! [VarCurr: state_type] :
      ( v15651(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15648(VarCurr,B)
          <=> v15568(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1313,axiom,
    ! [VarCurr: state_type] :
      ( v15651(VarCurr)
    <=> ( v15652(VarCurr)
        & v15653(VarCurr) ) ) ).

tff(writeUnaryOperator_916,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15653(VarCurr)
    <=> v15558(VarCurr) ) ).

tff(writeUnaryOperator_915,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15652(VarCurr)
    <=> v15548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1312,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15640(VarNext)
      <=> v15641(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15641(VarNext)
      <=> ( v15642(VarNext)
          & v15572(VarNext) ) ) ) ).

tff(writeUnaryOperator_914,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15642(VarNext)
      <=> v15644(VarNext) ) ) ).

tff(addAssignment_7848,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15644(VarNext)
      <=> v15572(VarCurr) ) ) ).

tff(addAssignment_7847,axiom,
    ! [VarCurr: state_type] :
      ( v15572(VarCurr)
    <=> v15574(VarCurr) ) ).

tff(addAssignment_7846,axiom,
    ! [VarCurr: state_type] :
      ( v15574(VarCurr)
    <=> v15576(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1310,axiom,
    ! [VarCurr: state_type] :
      ( v15576(VarCurr)
    <=> ( v15637(VarCurr)
        | v15633(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1309,axiom,
    ! [VarCurr: state_type] :
      ( v15637(VarCurr)
    <=> ( v15578(VarCurr)
        & v15582(VarCurr) ) ) ).

tff(addAssignment_7845,axiom,
    ! [VarCurr: state_type] :
      ( v15633(VarCurr)
    <=> v15635(VarCurr) ) ).

tff(addAssignment_7844,axiom,
    ! [VarCurr: state_type] :
      ( v15635(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15617(VarNext)
       => ( v15582(VarNext)
        <=> v15582(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_179,axiom,
    ! [VarNext: state_type] :
      ( v15617(VarNext)
     => ( v15582(VarNext)
      <=> v15627(VarNext) ) ) ).

tff(addAssignment_7843,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15627(VarNext)
      <=> v15625(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1308,axiom,
    ! [VarCurr: state_type] :
      ( v15625(VarCurr)
    <=> ( v15628(VarCurr)
        & v15629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1307,axiom,
    ! [VarCurr: state_type] :
      ( v15629(VarCurr)
    <=> ( v15588(VarCurr)
        | v15612(VarCurr) ) ) ).

tff(writeUnaryOperator_913,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15628(VarCurr)
    <=> v15584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1306,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15617(VarNext)
      <=> v15618(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1305,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15618(VarNext)
      <=> ( v15620(VarNext)
          & v15622(VarNext) ) ) ) ).

tff(writeUnaryOperator_912,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15622(VarCurr)
    <=> v15578(VarCurr) ) ).

tff(addAssignment_7842,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15620(VarNext)
      <=> v15578(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_56,axiom,
    ( v15582(constB0)
  <=> $true ) ).

tff(addAssignment_7841,axiom,
    ! [VarCurr: state_type] :
      ( v15612(VarCurr)
    <=> v15614(VarCurr) ) ).

tff(addAssignment_7840,axiom,
    ! [VarCurr: state_type] :
      ( v15614(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7839,axiom,
    ! [VarCurr: state_type] :
      ( v15588(VarCurr)
    <=> v15590(VarCurr) ) ).

tff(addAssignment_7838,axiom,
    ! [VarCurr: state_type] :
      ( v15590(VarCurr)
    <=> v14898(VarCurr) ) ).

tff(addAssignment_7837,axiom,
    ! [VarCurr: state_type] :
      ( v14898(VarCurr)
    <=> v15593(VarCurr) ) ).

tff(addAssignment_7836,axiom,
    ! [VarCurr: state_type] :
      ( v15593(VarCurr)
    <=> v15595(VarCurr) ) ).

tff(writeUnaryOperator_911,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15595(VarCurr)
    <=> v15609(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1304,axiom,
    ! [VarCurr: state_type] :
      ( v15609(VarCurr)
    <=> ( v15610(VarCurr)
        | v15605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1303,axiom,
    ! [VarCurr: state_type] :
      ( v15610(VarCurr)
    <=> ( v15597(VarCurr)
        | v15601(VarCurr) ) ) ).

tff(addAssignment_7835,axiom,
    ! [VarCurr: state_type] :
      ( v15605(VarCurr)
    <=> v15607(VarCurr) ) ).

tff(addAssignment_7834,axiom,
    ! [VarCurr: state_type] :
      ( v15607(VarCurr)
    <=> v14987(VarCurr,2) ) ).

tff(addAssignment_7833,axiom,
    ! [VarCurr: state_type] :
      ( v15601(VarCurr)
    <=> v15603(VarCurr) ) ).

tff(addAssignment_7832,axiom,
    ! [VarCurr: state_type] :
      ( v15603(VarCurr)
    <=> v14561(VarCurr,1) ) ).

tff(addAssignment_7831,axiom,
    ! [VarCurr: state_type] :
      ( v15597(VarCurr)
    <=> v15599(VarCurr) ) ).

tff(addAssignment_7830,axiom,
    ! [VarCurr: state_type] :
      ( v15599(VarCurr)
    <=> v14987(VarCurr,0) ) ).

tff(addAssignment_7829,axiom,
    ! [VarCurr: state_type] :
      ( v15584(VarCurr)
    <=> v15586(VarCurr) ) ).

tff(addAssignment_7828,axiom,
    ! [VarCurr: state_type] :
      ( v15586(VarCurr)
    <=> $false ) ).

tff(addAssignment_7827,axiom,
    ! [VarCurr: state_type] :
      ( v15578(VarCurr)
    <=> v15580(VarCurr) ) ).

tff(addAssignment_7826,axiom,
    ! [VarCurr: state_type] :
      ( v15580(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15568(VarCurr,B)
      <=> v15570(VarCurr,B) ) ) ).

tff(addAssignment_7824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15570(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7823,axiom,
    ! [VarCurr: state_type] :
      ( v15558(VarCurr)
    <=> v15560(VarCurr) ) ).

tff(addAssignment_7822,axiom,
    ! [VarCurr: state_type] :
      ( v15560(VarCurr)
    <=> v15562(VarCurr) ) ).

tff(addAssignment_7821,axiom,
    ! [VarCurr: state_type] :
      ( v15562(VarCurr)
    <=> v15564(VarCurr) ) ).

tff(addAssignment_7820,axiom,
    ! [VarCurr: state_type] :
      ( v15564(VarCurr)
    <=> v15566(VarCurr) ) ).

tff(addAssignment_7819,axiom,
    ! [VarCurr: state_type] :
      ( v15566(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7818,axiom,
    ! [VarCurr: state_type] :
      ( v15548(VarCurr)
    <=> v15550(VarCurr) ) ).

tff(addAssignment_7817,axiom,
    ! [VarCurr: state_type] :
      ( v15550(VarCurr)
    <=> v15552(VarCurr) ) ).

tff(addAssignment_7816,axiom,
    ! [VarCurr: state_type] :
      ( v15552(VarCurr)
    <=> v15554(VarCurr) ) ).

tff(addAssignment_7815,axiom,
    ! [VarCurr: state_type] :
      ( v15554(VarCurr)
    <=> v15556(VarCurr) ) ).

tff(addAssignment_7814,axiom,
    ! [VarCurr: state_type] :
      ( v15556(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7813,axiom,
    ! [VarCurr: state_type] :
      ( v15507(VarCurr)
    <=> v15509(VarCurr) ) ).

tff(addAssignment_7812,axiom,
    ! [VarCurr: state_type] :
      ( v15509(VarCurr)
    <=> v15511(VarCurr) ) ).

tff(addAssignment_7811,axiom,
    ! [VarCurr: state_type] :
      ( v15511(VarCurr)
    <=> v15513(VarCurr) ) ).

tff(addAssignment_7810,axiom,
    ! [VarCurr: state_type] :
      ( v15513(VarCurr)
    <=> v15515(VarCurr) ) ).

tff(addAssignment_7809,axiom,
    ! [VarCurr: state_type] :
      ( v15515(VarCurr)
    <=> v15517(VarCurr) ) ).

tff(addAssignment_7808,axiom,
    ! [VarCurr: state_type] :
      ( v15517(VarCurr)
    <=> v15519(VarCurr) ) ).

tff(addAssignment_7807,axiom,
    ! [VarCurr: state_type] :
      ( v15519(VarCurr)
    <=> v15521(VarCurr) ) ).

tff(writeUnaryOperator_910,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15521(VarCurr)
    <=> v15535(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1302,axiom,
    ! [VarCurr: state_type] :
      ( v15535(VarCurr)
    <=> ( v15536(VarCurr)
        | v15531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1301,axiom,
    ! [VarCurr: state_type] :
      ( v15536(VarCurr)
    <=> ( v15523(VarCurr)
        | v15527(VarCurr) ) ) ).

tff(addAssignment_7806,axiom,
    ! [VarCurr: state_type] :
      ( v15531(VarCurr)
    <=> v15533(VarCurr) ) ).

tff(addAssignment_7805,axiom,
    ! [VarCurr: state_type] :
      ( v15533(VarCurr)
    <=> v14734(VarCurr,2) ) ).

tff(addAssignment_7804,axiom,
    ! [VarCurr: state_type] :
      ( v15527(VarCurr)
    <=> v15529(VarCurr) ) ).

tff(addAssignment_7803,axiom,
    ! [VarCurr: state_type] :
      ( v15529(VarCurr)
    <=> v14651(VarCurr,1) ) ).

tff(addAssignment_7802,axiom,
    ! [VarCurr: state_type] :
      ( v15523(VarCurr)
    <=> v15525(VarCurr) ) ).

tff(addAssignment_7801,axiom,
    ! [VarCurr: state_type] :
      ( v15525(VarCurr)
    <=> v14651(VarCurr,0) ) ).

tff(addAssignment_7800,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15387(VarCurr,B)
      <=> v15389(VarCurr,B) ) ) ).

tff(addAssignment_7799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15389(VarCurr,B)
      <=> v15391(VarCurr,B) ) ) ).

tff(addAssignment_7798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15391(VarCurr,B)
      <=> v15393(VarCurr,B) ) ) ).

tff(addAssignment_7797,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15393(VarCurr,B)
      <=> v15395(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15490(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15395(VarNext,B)
            <=> v15395(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_178,axiom,
    ! [VarNext: state_type] :
      ( v15490(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15395(VarNext,B)
          <=> v15500(VarNext,B) ) ) ) ).

tff(addAssignment_7796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15500(VarNext,B)
          <=> v15498(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15498(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_126,axiom,
    ! [VarCurr: state_type] :
      ( v15501(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15498(VarCurr,B)
          <=> v15417(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1300,axiom,
    ! [VarCurr: state_type] :
      ( v15501(VarCurr)
    <=> ( v15502(VarCurr)
        & v15503(VarCurr) ) ) ).

tff(writeUnaryOperator_909,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15503(VarCurr)
    <=> v15407(VarCurr) ) ).

tff(writeUnaryOperator_908,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15502(VarCurr)
    <=> v15397(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1299,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15490(VarNext)
      <=> v15491(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1298,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15491(VarNext)
      <=> ( v15492(VarNext)
          & v15421(VarNext) ) ) ) ).

tff(writeUnaryOperator_907,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15492(VarNext)
      <=> v15494(VarNext) ) ) ).

tff(addAssignment_7795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15494(VarNext)
      <=> v15421(VarCurr) ) ) ).

tff(addAssignment_7794,axiom,
    ! [VarCurr: state_type] :
      ( v15421(VarCurr)
    <=> v15423(VarCurr) ) ).

tff(addAssignment_7793,axiom,
    ! [VarCurr: state_type] :
      ( v15423(VarCurr)
    <=> v15425(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1297,axiom,
    ! [VarCurr: state_type] :
      ( v15425(VarCurr)
    <=> ( v15487(VarCurr)
        | v15483(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1296,axiom,
    ! [VarCurr: state_type] :
      ( v15487(VarCurr)
    <=> ( v15427(VarCurr)
        & v15431(VarCurr) ) ) ).

tff(addAssignment_7792,axiom,
    ! [VarCurr: state_type] :
      ( v15483(VarCurr)
    <=> v15485(VarCurr) ) ).

tff(addAssignment_7791,axiom,
    ! [VarCurr: state_type] :
      ( v15485(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15467(VarNext)
       => ( v15431(VarNext)
        <=> v15431(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_177,axiom,
    ! [VarNext: state_type] :
      ( v15467(VarNext)
     => ( v15431(VarNext)
      <=> v15477(VarNext) ) ) ).

tff(addAssignment_7790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15477(VarNext)
      <=> v15475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1295,axiom,
    ! [VarCurr: state_type] :
      ( v15475(VarCurr)
    <=> ( v15478(VarCurr)
        & v15479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1294,axiom,
    ! [VarCurr: state_type] :
      ( v15479(VarCurr)
    <=> ( v15437(VarCurr)
        | v15462(VarCurr) ) ) ).

tff(writeUnaryOperator_906,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15478(VarCurr)
    <=> v15433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1293,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15467(VarNext)
      <=> v15468(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1292,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15468(VarNext)
      <=> ( v15470(VarNext)
          & v15472(VarNext) ) ) ) ).

tff(writeUnaryOperator_905,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15472(VarCurr)
    <=> v15427(VarCurr) ) ).

tff(addAssignment_7789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15470(VarNext)
      <=> v15427(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_55,axiom,
    ( v15431(constB0)
  <=> $true ) ).

tff(addAssignment_7788,axiom,
    ! [VarCurr: state_type] :
      ( v15462(VarCurr)
    <=> v15464(VarCurr) ) ).

tff(addAssignment_7787,axiom,
    ! [VarCurr: state_type] :
      ( v15464(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7786,axiom,
    ! [VarCurr: state_type] :
      ( v15437(VarCurr)
    <=> v15439(VarCurr) ) ).

tff(addAssignment_7785,axiom,
    ! [VarCurr: state_type] :
      ( v15439(VarCurr)
    <=> v15441(VarCurr) ) ).

tff(addAssignment_7784,axiom,
    ! [VarCurr: state_type] :
      ( v15441(VarCurr)
    <=> v15443(VarCurr) ) ).

tff(addAssignment_7783,axiom,
    ! [VarCurr: state_type] :
      ( v15443(VarCurr)
    <=> v15445(VarCurr) ) ).

tff(writeUnaryOperator_904,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15445(VarCurr)
    <=> v15459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1291,axiom,
    ! [VarCurr: state_type] :
      ( v15459(VarCurr)
    <=> ( v15460(VarCurr)
        | v15455(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1290,axiom,
    ! [VarCurr: state_type] :
      ( v15460(VarCurr)
    <=> ( v15447(VarCurr)
        | v15451(VarCurr) ) ) ).

tff(addAssignment_7782,axiom,
    ! [VarCurr: state_type] :
      ( v15455(VarCurr)
    <=> v15457(VarCurr) ) ).

tff(addAssignment_7781,axiom,
    ! [VarCurr: state_type] :
      ( v15457(VarCurr)
    <=> v14987(VarCurr,2) ) ).

tff(addAssignment_7780,axiom,
    ! [VarCurr: state_type] :
      ( v14987(VarCurr,2)
    <=> v14989(VarCurr,2) ) ).

tff(addAssignment_7779,axiom,
    ! [VarCurr: state_type] :
      ( v14989(VarCurr,2)
    <=> v14991(VarCurr,2) ) ).

tff(addAssignment_7778,axiom,
    ! [VarCurr: state_type] :
      ( v14991(VarCurr,2)
    <=> v14996(VarCurr,2) ) ).

tff(addAssignment_7777,axiom,
    ! [VarCurr: state_type] :
      ( v14993(VarCurr,2)
    <=> v14995(VarCurr,2) ) ).

tff(addAssignment_7776,axiom,
    ! [VarCurr: state_type] :
      ( v14995(VarCurr,2)
    <=> v14561(VarCurr,2) ) ).

tff(addAssignment_7775,axiom,
    ! [VarCurr: state_type] :
      ( v15451(VarCurr)
    <=> v15453(VarCurr) ) ).

tff(addAssignment_7774,axiom,
    ! [VarCurr: state_type] :
      ( v15453(VarCurr)
    <=> v14561(VarCurr,1) ) ).

tff(addAssignment_7773,axiom,
    ! [VarCurr: state_type] :
      ( v15447(VarCurr)
    <=> v15449(VarCurr) ) ).

tff(addAssignment_7772,axiom,
    ! [VarCurr: state_type] :
      ( v15449(VarCurr)
    <=> v14561(VarCurr,0) ) ).

tff(addAssignment_7771,axiom,
    ! [VarCurr: state_type] :
      ( v15433(VarCurr)
    <=> v15435(VarCurr) ) ).

tff(addAssignment_7770,axiom,
    ! [VarCurr: state_type] :
      ( v15435(VarCurr)
    <=> $false ) ).

tff(addAssignment_7769,axiom,
    ! [VarCurr: state_type] :
      ( v15427(VarCurr)
    <=> v15429(VarCurr) ) ).

tff(addAssignment_7768,axiom,
    ! [VarCurr: state_type] :
      ( v15429(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7767,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15417(VarCurr,B)
      <=> v15419(VarCurr,B) ) ) ).

tff(addAssignment_7766,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15419(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7765,axiom,
    ! [VarCurr: state_type] :
      ( v15407(VarCurr)
    <=> v15409(VarCurr) ) ).

tff(addAssignment_7764,axiom,
    ! [VarCurr: state_type] :
      ( v15409(VarCurr)
    <=> v15411(VarCurr) ) ).

tff(addAssignment_7763,axiom,
    ! [VarCurr: state_type] :
      ( v15411(VarCurr)
    <=> v15413(VarCurr) ) ).

tff(addAssignment_7762,axiom,
    ! [VarCurr: state_type] :
      ( v15413(VarCurr)
    <=> v15415(VarCurr) ) ).

tff(addAssignment_7761,axiom,
    ! [VarCurr: state_type] :
      ( v15415(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7760,axiom,
    ! [VarCurr: state_type] :
      ( v15397(VarCurr)
    <=> v15399(VarCurr) ) ).

tff(addAssignment_7759,axiom,
    ! [VarCurr: state_type] :
      ( v15399(VarCurr)
    <=> v15401(VarCurr) ) ).

tff(addAssignment_7758,axiom,
    ! [VarCurr: state_type] :
      ( v15401(VarCurr)
    <=> v15403(VarCurr) ) ).

tff(addAssignment_7757,axiom,
    ! [VarCurr: state_type] :
      ( v15403(VarCurr)
    <=> v15405(VarCurr) ) ).

tff(addAssignment_7756,axiom,
    ! [VarCurr: state_type] :
      ( v15405(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7755,axiom,
    ! [VarCurr: state_type] :
      ( v15356(VarCurr)
    <=> v15358(VarCurr) ) ).

tff(addAssignment_7754,axiom,
    ! [VarCurr: state_type] :
      ( v15358(VarCurr)
    <=> v15360(VarCurr) ) ).

tff(addAssignment_7753,axiom,
    ! [VarCurr: state_type] :
      ( v15360(VarCurr)
    <=> v15362(VarCurr) ) ).

tff(addAssignment_7752,axiom,
    ! [VarCurr: state_type] :
      ( v15362(VarCurr)
    <=> v15364(VarCurr) ) ).

tff(addAssignment_7751,axiom,
    ! [VarCurr: state_type] :
      ( v15364(VarCurr)
    <=> v15366(VarCurr) ) ).

tff(addAssignment_7750,axiom,
    ! [VarCurr: state_type] :
      ( v15366(VarCurr)
    <=> v15368(VarCurr) ) ).

tff(addAssignment_7749,axiom,
    ! [VarCurr: state_type] :
      ( v15368(VarCurr)
    <=> v15370(VarCurr) ) ).

tff(writeUnaryOperator_903,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15370(VarCurr)
    <=> v15384(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1289,axiom,
    ! [VarCurr: state_type] :
      ( v15384(VarCurr)
    <=> ( v15385(VarCurr)
        | v15380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1288,axiom,
    ! [VarCurr: state_type] :
      ( v15385(VarCurr)
    <=> ( v15372(VarCurr)
        | v15376(VarCurr) ) ) ).

tff(addAssignment_7748,axiom,
    ! [VarCurr: state_type] :
      ( v15380(VarCurr)
    <=> v15382(VarCurr) ) ).

tff(addAssignment_7747,axiom,
    ! [VarCurr: state_type] :
      ( v15382(VarCurr)
    <=> v14651(VarCurr,2) ) ).

tff(addAssignment_7746,axiom,
    ! [VarCurr: state_type] :
      ( v15376(VarCurr)
    <=> v15378(VarCurr) ) ).

tff(addAssignment_7745,axiom,
    ! [VarCurr: state_type] :
      ( v15378(VarCurr)
    <=> v14734(VarCurr,1) ) ).

tff(addAssignment_7744,axiom,
    ! [VarCurr: state_type] :
      ( v15372(VarCurr)
    <=> v15374(VarCurr) ) ).

tff(addAssignment_7743,axiom,
    ! [VarCurr: state_type] :
      ( v15374(VarCurr)
    <=> v14734(VarCurr,0) ) ).

tff(addAssignment_7742,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15236(VarCurr,B)
      <=> v15238(VarCurr,B) ) ) ).

tff(addAssignment_7741,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15238(VarCurr,B)
      <=> v15240(VarCurr,B) ) ) ).

tff(addAssignment_7740,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15240(VarCurr,B)
      <=> v15242(VarCurr,B) ) ) ).

tff(addAssignment_7739,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15242(VarCurr,B)
      <=> v15244(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15339(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15244(VarNext,B)
            <=> v15244(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_176,axiom,
    ! [VarNext: state_type] :
      ( v15339(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15244(VarNext,B)
          <=> v15349(VarNext,B) ) ) ) ).

tff(addAssignment_7738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15349(VarNext,B)
          <=> v15347(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15347(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_125,axiom,
    ! [VarCurr: state_type] :
      ( v15350(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15347(VarCurr,B)
          <=> v15266(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1287,axiom,
    ! [VarCurr: state_type] :
      ( v15350(VarCurr)
    <=> ( v15351(VarCurr)
        & v15352(VarCurr) ) ) ).

tff(writeUnaryOperator_902,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15352(VarCurr)
    <=> v15256(VarCurr) ) ).

tff(writeUnaryOperator_901,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15351(VarCurr)
    <=> v15246(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1286,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15339(VarNext)
      <=> v15340(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1285,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15340(VarNext)
      <=> ( v15341(VarNext)
          & v15270(VarNext) ) ) ) ).

tff(writeUnaryOperator_900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15341(VarNext)
      <=> v15343(VarNext) ) ) ).

tff(addAssignment_7737,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15343(VarNext)
      <=> v15270(VarCurr) ) ) ).

tff(addAssignment_7736,axiom,
    ! [VarCurr: state_type] :
      ( v15270(VarCurr)
    <=> v15272(VarCurr) ) ).

tff(addAssignment_7735,axiom,
    ! [VarCurr: state_type] :
      ( v15272(VarCurr)
    <=> v15274(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1284,axiom,
    ! [VarCurr: state_type] :
      ( v15274(VarCurr)
    <=> ( v15336(VarCurr)
        | v15332(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1283,axiom,
    ! [VarCurr: state_type] :
      ( v15336(VarCurr)
    <=> ( v15276(VarCurr)
        & v15280(VarCurr) ) ) ).

tff(addAssignment_7734,axiom,
    ! [VarCurr: state_type] :
      ( v15332(VarCurr)
    <=> v15334(VarCurr) ) ).

tff(addAssignment_7733,axiom,
    ! [VarCurr: state_type] :
      ( v15334(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15316(VarNext)
       => ( v15280(VarNext)
        <=> v15280(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_175,axiom,
    ! [VarNext: state_type] :
      ( v15316(VarNext)
     => ( v15280(VarNext)
      <=> v15326(VarNext) ) ) ).

tff(addAssignment_7732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15326(VarNext)
      <=> v15324(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1282,axiom,
    ! [VarCurr: state_type] :
      ( v15324(VarCurr)
    <=> ( v15327(VarCurr)
        & v15328(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1281,axiom,
    ! [VarCurr: state_type] :
      ( v15328(VarCurr)
    <=> ( v15286(VarCurr)
        | v15311(VarCurr) ) ) ).

tff(writeUnaryOperator_899,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15327(VarCurr)
    <=> v15282(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1280,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15316(VarNext)
      <=> v15317(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1279,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15317(VarNext)
      <=> ( v15319(VarNext)
          & v15321(VarNext) ) ) ) ).

tff(writeUnaryOperator_898,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15321(VarCurr)
    <=> v15276(VarCurr) ) ).

tff(addAssignment_7731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15319(VarNext)
      <=> v15276(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_54,axiom,
    ( v15280(constB0)
  <=> $true ) ).

tff(addAssignment_7730,axiom,
    ! [VarCurr: state_type] :
      ( v15311(VarCurr)
    <=> v15313(VarCurr) ) ).

tff(addAssignment_7729,axiom,
    ! [VarCurr: state_type] :
      ( v15313(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7728,axiom,
    ! [VarCurr: state_type] :
      ( v15286(VarCurr)
    <=> v15288(VarCurr) ) ).

tff(addAssignment_7727,axiom,
    ! [VarCurr: state_type] :
      ( v15288(VarCurr)
    <=> v15290(VarCurr) ) ).

tff(addAssignment_7726,axiom,
    ! [VarCurr: state_type] :
      ( v15290(VarCurr)
    <=> v15292(VarCurr) ) ).

tff(addAssignment_7725,axiom,
    ! [VarCurr: state_type] :
      ( v15292(VarCurr)
    <=> v15294(VarCurr) ) ).

tff(writeUnaryOperator_897,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15294(VarCurr)
    <=> v15308(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1278,axiom,
    ! [VarCurr: state_type] :
      ( v15308(VarCurr)
    <=> ( v15309(VarCurr)
        | v15304(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1277,axiom,
    ! [VarCurr: state_type] :
      ( v15309(VarCurr)
    <=> ( v15296(VarCurr)
        | v15300(VarCurr) ) ) ).

tff(addAssignment_7724,axiom,
    ! [VarCurr: state_type] :
      ( v15304(VarCurr)
    <=> v15306(VarCurr) ) ).

tff(addAssignment_7723,axiom,
    ! [VarCurr: state_type] :
      ( v15306(VarCurr)
    <=> v14561(VarCurr,2) ) ).

tff(addAssignment_7722,axiom,
    ! [VarCurr: state_type] :
      ( v15300(VarCurr)
    <=> v15302(VarCurr) ) ).

tff(addAssignment_7721,axiom,
    ! [VarCurr: state_type] :
      ( v15302(VarCurr)
    <=> v14987(VarCurr,1) ) ).

tff(addAssignment_7720,axiom,
    ! [VarCurr: state_type] :
      ( v15296(VarCurr)
    <=> v15298(VarCurr) ) ).

tff(addAssignment_7719,axiom,
    ! [VarCurr: state_type] :
      ( v15298(VarCurr)
    <=> v14987(VarCurr,0) ) ).

tff(addAssignment_7718,axiom,
    ! [VarCurr: state_type] :
      ( v15282(VarCurr)
    <=> v15284(VarCurr) ) ).

tff(addAssignment_7717,axiom,
    ! [VarCurr: state_type] :
      ( v15284(VarCurr)
    <=> $false ) ).

tff(addAssignment_7716,axiom,
    ! [VarCurr: state_type] :
      ( v15276(VarCurr)
    <=> v15278(VarCurr) ) ).

tff(addAssignment_7715,axiom,
    ! [VarCurr: state_type] :
      ( v15278(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15266(VarCurr,B)
      <=> v15268(VarCurr,B) ) ) ).

tff(addAssignment_7713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15268(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7712,axiom,
    ! [VarCurr: state_type] :
      ( v15256(VarCurr)
    <=> v15258(VarCurr) ) ).

tff(addAssignment_7711,axiom,
    ! [VarCurr: state_type] :
      ( v15258(VarCurr)
    <=> v15260(VarCurr) ) ).

tff(addAssignment_7710,axiom,
    ! [VarCurr: state_type] :
      ( v15260(VarCurr)
    <=> v15262(VarCurr) ) ).

tff(addAssignment_7709,axiom,
    ! [VarCurr: state_type] :
      ( v15262(VarCurr)
    <=> v15264(VarCurr) ) ).

tff(addAssignment_7708,axiom,
    ! [VarCurr: state_type] :
      ( v15264(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7707,axiom,
    ! [VarCurr: state_type] :
      ( v15246(VarCurr)
    <=> v15248(VarCurr) ) ).

tff(addAssignment_7706,axiom,
    ! [VarCurr: state_type] :
      ( v15248(VarCurr)
    <=> v15250(VarCurr) ) ).

tff(addAssignment_7705,axiom,
    ! [VarCurr: state_type] :
      ( v15250(VarCurr)
    <=> v15252(VarCurr) ) ).

tff(addAssignment_7704,axiom,
    ! [VarCurr: state_type] :
      ( v15252(VarCurr)
    <=> v15254(VarCurr) ) ).

tff(addAssignment_7703,axiom,
    ! [VarCurr: state_type] :
      ( v15254(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7702,axiom,
    ! [VarCurr: state_type] :
      ( v15205(VarCurr)
    <=> v15207(VarCurr) ) ).

tff(addAssignment_7701,axiom,
    ! [VarCurr: state_type] :
      ( v15207(VarCurr)
    <=> v15209(VarCurr) ) ).

tff(addAssignment_7700,axiom,
    ! [VarCurr: state_type] :
      ( v15209(VarCurr)
    <=> v15211(VarCurr) ) ).

tff(addAssignment_7699,axiom,
    ! [VarCurr: state_type] :
      ( v15211(VarCurr)
    <=> v15213(VarCurr) ) ).

tff(addAssignment_7698,axiom,
    ! [VarCurr: state_type] :
      ( v15213(VarCurr)
    <=> v15215(VarCurr) ) ).

tff(addAssignment_7697,axiom,
    ! [VarCurr: state_type] :
      ( v15215(VarCurr)
    <=> v15217(VarCurr) ) ).

tff(addAssignment_7696,axiom,
    ! [VarCurr: state_type] :
      ( v15217(VarCurr)
    <=> v15219(VarCurr) ) ).

tff(writeUnaryOperator_896,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15219(VarCurr)
    <=> v15233(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1276,axiom,
    ! [VarCurr: state_type] :
      ( v15233(VarCurr)
    <=> ( v15234(VarCurr)
        | v15229(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1275,axiom,
    ! [VarCurr: state_type] :
      ( v15234(VarCurr)
    <=> ( v15221(VarCurr)
        | v15225(VarCurr) ) ) ).

tff(addAssignment_7695,axiom,
    ! [VarCurr: state_type] :
      ( v15229(VarCurr)
    <=> v15231(VarCurr) ) ).

tff(addAssignment_7694,axiom,
    ! [VarCurr: state_type] :
      ( v15231(VarCurr)
    <=> v14651(VarCurr,2) ) ).

tff(addAssignment_7693,axiom,
    ! [VarCurr: state_type] :
      ( v15225(VarCurr)
    <=> v15227(VarCurr) ) ).

tff(addAssignment_7692,axiom,
    ! [VarCurr: state_type] :
      ( v15227(VarCurr)
    <=> v14734(VarCurr,1) ) ).

tff(addAssignment_7691,axiom,
    ! [VarCurr: state_type] :
      ( v14734(VarCurr,1)
    <=> v14736(VarCurr,1) ) ).

tff(addAssignment_7690,axiom,
    ! [VarCurr: state_type] :
      ( v14736(VarCurr,1)
    <=> v14738(VarCurr,1) ) ).

tff(addAssignment_7689,axiom,
    ! [VarCurr: state_type] :
      ( v14738(VarCurr,1)
    <=> v14743(VarCurr,1) ) ).

tff(addAssignment_7688,axiom,
    ! [VarCurr: state_type] :
      ( v14740(VarCurr,1)
    <=> v14742(VarCurr,1) ) ).

tff(addAssignment_7687,axiom,
    ! [VarCurr: state_type] :
      ( v14742(VarCurr,1)
    <=> v14651(VarCurr,1) ) ).

tff(addAssignment_7686,axiom,
    ! [VarCurr: state_type] :
      ( v15221(VarCurr)
    <=> v15223(VarCurr) ) ).

tff(addAssignment_7685,axiom,
    ! [VarCurr: state_type] :
      ( v15223(VarCurr)
    <=> v14651(VarCurr,0) ) ).

tff(addAssignment_7684,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15085(VarCurr,B)
      <=> v15087(VarCurr,B) ) ) ).

tff(addAssignment_7683,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15087(VarCurr,B)
      <=> v15089(VarCurr,B) ) ) ).

tff(addAssignment_7682,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15089(VarCurr,B)
      <=> v15091(VarCurr,B) ) ) ).

tff(addAssignment_7681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15091(VarCurr,B)
      <=> v15093(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15188(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v15093(VarNext,B)
            <=> v15093(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_174,axiom,
    ! [VarNext: state_type] :
      ( v15188(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15093(VarNext,B)
          <=> v15198(VarNext,B) ) ) ) ).

tff(addAssignment_7680,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15198(VarNext,B)
          <=> v15196(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15199(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15196(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_124,axiom,
    ! [VarCurr: state_type] :
      ( v15199(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15196(VarCurr,B)
          <=> v15115(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1274,axiom,
    ! [VarCurr: state_type] :
      ( v15199(VarCurr)
    <=> ( v15200(VarCurr)
        & v15201(VarCurr) ) ) ).

tff(writeUnaryOperator_895,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15201(VarCurr)
    <=> v15105(VarCurr) ) ).

tff(writeUnaryOperator_894,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15200(VarCurr)
    <=> v15095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1273,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15188(VarNext)
      <=> v15189(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1272,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15189(VarNext)
      <=> ( v15190(VarNext)
          & v15119(VarNext) ) ) ) ).

tff(writeUnaryOperator_893,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15190(VarNext)
      <=> v15192(VarNext) ) ) ).

tff(addAssignment_7679,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15192(VarNext)
      <=> v15119(VarCurr) ) ) ).

tff(addAssignment_7678,axiom,
    ! [VarCurr: state_type] :
      ( v15119(VarCurr)
    <=> v15121(VarCurr) ) ).

tff(addAssignment_7677,axiom,
    ! [VarCurr: state_type] :
      ( v15121(VarCurr)
    <=> v15123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1271,axiom,
    ! [VarCurr: state_type] :
      ( v15123(VarCurr)
    <=> ( v15185(VarCurr)
        | v15181(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1270,axiom,
    ! [VarCurr: state_type] :
      ( v15185(VarCurr)
    <=> ( v15125(VarCurr)
        & v15129(VarCurr) ) ) ).

tff(addAssignment_7676,axiom,
    ! [VarCurr: state_type] :
      ( v15181(VarCurr)
    <=> v15183(VarCurr) ) ).

tff(addAssignment_7675,axiom,
    ! [VarCurr: state_type] :
      ( v15183(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15165(VarNext)
       => ( v15129(VarNext)
        <=> v15129(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_173,axiom,
    ! [VarNext: state_type] :
      ( v15165(VarNext)
     => ( v15129(VarNext)
      <=> v15175(VarNext) ) ) ).

tff(addAssignment_7674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15175(VarNext)
      <=> v15173(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1269,axiom,
    ! [VarCurr: state_type] :
      ( v15173(VarCurr)
    <=> ( v15176(VarCurr)
        & v15177(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1268,axiom,
    ! [VarCurr: state_type] :
      ( v15177(VarCurr)
    <=> ( v15135(VarCurr)
        | v15160(VarCurr) ) ) ).

tff(writeUnaryOperator_892,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15176(VarCurr)
    <=> v15131(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15165(VarNext)
      <=> v15166(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1266,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15166(VarNext)
      <=> ( v15168(VarNext)
          & v15170(VarNext) ) ) ) ).

tff(writeUnaryOperator_891,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15170(VarCurr)
    <=> v15125(VarCurr) ) ).

tff(addAssignment_7673,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15168(VarNext)
      <=> v15125(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_53,axiom,
    ( v15129(constB0)
  <=> $true ) ).

tff(addAssignment_7672,axiom,
    ! [VarCurr: state_type] :
      ( v15160(VarCurr)
    <=> v15162(VarCurr) ) ).

tff(addAssignment_7671,axiom,
    ! [VarCurr: state_type] :
      ( v15162(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7670,axiom,
    ! [VarCurr: state_type] :
      ( v15135(VarCurr)
    <=> v15137(VarCurr) ) ).

tff(addAssignment_7669,axiom,
    ! [VarCurr: state_type] :
      ( v15137(VarCurr)
    <=> v15139(VarCurr) ) ).

tff(addAssignment_7668,axiom,
    ! [VarCurr: state_type] :
      ( v15139(VarCurr)
    <=> v15141(VarCurr) ) ).

tff(addAssignment_7667,axiom,
    ! [VarCurr: state_type] :
      ( v15141(VarCurr)
    <=> v15143(VarCurr) ) ).

tff(writeUnaryOperator_890,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15143(VarCurr)
    <=> v15157(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1265,axiom,
    ! [VarCurr: state_type] :
      ( v15157(VarCurr)
    <=> ( v15158(VarCurr)
        | v15153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1264,axiom,
    ! [VarCurr: state_type] :
      ( v15158(VarCurr)
    <=> ( v15145(VarCurr)
        | v15149(VarCurr) ) ) ).

tff(addAssignment_7666,axiom,
    ! [VarCurr: state_type] :
      ( v15153(VarCurr)
    <=> v15155(VarCurr) ) ).

tff(addAssignment_7665,axiom,
    ! [VarCurr: state_type] :
      ( v15155(VarCurr)
    <=> v14561(VarCurr,2) ) ).

tff(addAssignment_7664,axiom,
    ! [VarCurr: state_type] :
      ( v15149(VarCurr)
    <=> v15151(VarCurr) ) ).

tff(addAssignment_7663,axiom,
    ! [VarCurr: state_type] :
      ( v15151(VarCurr)
    <=> v14987(VarCurr,1) ) ).

tff(addAssignment_7662,axiom,
    ! [VarCurr: state_type] :
      ( v14987(VarCurr,1)
    <=> v14989(VarCurr,1) ) ).

tff(addAssignment_7661,axiom,
    ! [VarCurr: state_type] :
      ( v14989(VarCurr,1)
    <=> v14991(VarCurr,1) ) ).

tff(addAssignment_7660,axiom,
    ! [VarCurr: state_type] :
      ( v14991(VarCurr,1)
    <=> v14996(VarCurr,1) ) ).

tff(addAssignment_7659,axiom,
    ! [VarCurr: state_type] :
      ( v14993(VarCurr,1)
    <=> v14995(VarCurr,1) ) ).

tff(addAssignment_7658,axiom,
    ! [VarCurr: state_type] :
      ( v14995(VarCurr,1)
    <=> v14561(VarCurr,1) ) ).

tff(addAssignment_7657,axiom,
    ! [VarCurr: state_type] :
      ( v15145(VarCurr)
    <=> v15147(VarCurr) ) ).

tff(addAssignment_7656,axiom,
    ! [VarCurr: state_type] :
      ( v15147(VarCurr)
    <=> v14561(VarCurr,0) ) ).

tff(addAssignment_7655,axiom,
    ! [VarCurr: state_type] :
      ( v15131(VarCurr)
    <=> v15133(VarCurr) ) ).

tff(addAssignment_7654,axiom,
    ! [VarCurr: state_type] :
      ( v15133(VarCurr)
    <=> $false ) ).

tff(addAssignment_7653,axiom,
    ! [VarCurr: state_type] :
      ( v15125(VarCurr)
    <=> v15127(VarCurr) ) ).

tff(addAssignment_7652,axiom,
    ! [VarCurr: state_type] :
      ( v15127(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15115(VarCurr,B)
      <=> v15117(VarCurr,B) ) ) ).

tff(addAssignment_7650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v15117(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7649,axiom,
    ! [VarCurr: state_type] :
      ( v15105(VarCurr)
    <=> v15107(VarCurr) ) ).

tff(addAssignment_7648,axiom,
    ! [VarCurr: state_type] :
      ( v15107(VarCurr)
    <=> v15109(VarCurr) ) ).

tff(addAssignment_7647,axiom,
    ! [VarCurr: state_type] :
      ( v15109(VarCurr)
    <=> v15111(VarCurr) ) ).

tff(addAssignment_7646,axiom,
    ! [VarCurr: state_type] :
      ( v15111(VarCurr)
    <=> v15113(VarCurr) ) ).

tff(addAssignment_7645,axiom,
    ! [VarCurr: state_type] :
      ( v15113(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7644,axiom,
    ! [VarCurr: state_type] :
      ( v15095(VarCurr)
    <=> v15097(VarCurr) ) ).

tff(addAssignment_7643,axiom,
    ! [VarCurr: state_type] :
      ( v15097(VarCurr)
    <=> v15099(VarCurr) ) ).

tff(addAssignment_7642,axiom,
    ! [VarCurr: state_type] :
      ( v15099(VarCurr)
    <=> v15101(VarCurr) ) ).

tff(addAssignment_7641,axiom,
    ! [VarCurr: state_type] :
      ( v15101(VarCurr)
    <=> v15103(VarCurr) ) ).

tff(addAssignment_7640,axiom,
    ! [VarCurr: state_type] :
      ( v15103(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7639,axiom,
    ! [VarCurr: state_type] :
      ( v15054(VarCurr)
    <=> v15056(VarCurr) ) ).

tff(addAssignment_7638,axiom,
    ! [VarCurr: state_type] :
      ( v15056(VarCurr)
    <=> v15058(VarCurr) ) ).

tff(addAssignment_7637,axiom,
    ! [VarCurr: state_type] :
      ( v15058(VarCurr)
    <=> v15060(VarCurr) ) ).

tff(addAssignment_7636,axiom,
    ! [VarCurr: state_type] :
      ( v15060(VarCurr)
    <=> v15062(VarCurr) ) ).

tff(addAssignment_7635,axiom,
    ! [VarCurr: state_type] :
      ( v15062(VarCurr)
    <=> v15064(VarCurr) ) ).

tff(addAssignment_7634,axiom,
    ! [VarCurr: state_type] :
      ( v15064(VarCurr)
    <=> v15066(VarCurr) ) ).

tff(addAssignment_7633,axiom,
    ! [VarCurr: state_type] :
      ( v15066(VarCurr)
    <=> v15068(VarCurr) ) ).

tff(writeUnaryOperator_889,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15068(VarCurr)
    <=> v15082(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1263,axiom,
    ! [VarCurr: state_type] :
      ( v15082(VarCurr)
    <=> ( v15083(VarCurr)
        | v15078(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1262,axiom,
    ! [VarCurr: state_type] :
      ( v15083(VarCurr)
    <=> ( v15070(VarCurr)
        | v15074(VarCurr) ) ) ).

tff(addAssignment_7632,axiom,
    ! [VarCurr: state_type] :
      ( v15078(VarCurr)
    <=> v15080(VarCurr) ) ).

tff(addAssignment_7631,axiom,
    ! [VarCurr: state_type] :
      ( v15080(VarCurr)
    <=> v14651(VarCurr,2) ) ).

tff(addAssignment_7630,axiom,
    ! [VarCurr: state_type] :
      ( v15074(VarCurr)
    <=> v15076(VarCurr) ) ).

tff(addAssignment_7629,axiom,
    ! [VarCurr: state_type] :
      ( v15076(VarCurr)
    <=> v14651(VarCurr,1) ) ).

tff(addAssignment_7628,axiom,
    ! [VarCurr: state_type] :
      ( v15070(VarCurr)
    <=> v15072(VarCurr) ) ).

tff(addAssignment_7627,axiom,
    ! [VarCurr: state_type] :
      ( v15072(VarCurr)
    <=> v14734(VarCurr,0) ) ).

tff(addAssignment_7626,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14923(VarCurr,B)
      <=> v14925(VarCurr,B) ) ) ).

tff(addAssignment_7625,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14925(VarCurr,B)
      <=> v14927(VarCurr,B) ) ) ).

tff(addAssignment_7624,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14927(VarCurr,B)
      <=> v14929(VarCurr,B) ) ) ).

tff(addAssignment_7623,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14929(VarCurr,B)
      <=> v14931(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15037(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v14931(VarNext,B)
            <=> v14931(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_172,axiom,
    ! [VarNext: state_type] :
      ( v15037(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14931(VarNext,B)
          <=> v15047(VarNext,B) ) ) ) ).

tff(addAssignment_7622,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15047(VarNext,B)
          <=> v15045(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15048(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15045(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_123,axiom,
    ! [VarCurr: state_type] :
      ( v15048(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v15045(VarCurr,B)
          <=> v14953(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1261,axiom,
    ! [VarCurr: state_type] :
      ( v15048(VarCurr)
    <=> ( v15049(VarCurr)
        & v15050(VarCurr) ) ) ).

tff(writeUnaryOperator_888,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15050(VarCurr)
    <=> v14943(VarCurr) ) ).

tff(writeUnaryOperator_887,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15049(VarCurr)
    <=> v14933(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15037(VarNext)
      <=> v15038(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15038(VarNext)
      <=> ( v15039(VarNext)
          & v14957(VarNext) ) ) ) ).

tff(writeUnaryOperator_886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15039(VarNext)
      <=> v15041(VarNext) ) ) ).

tff(addAssignment_7621,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15041(VarNext)
      <=> v14957(VarCurr) ) ) ).

tff(addAssignment_7620,axiom,
    ! [VarCurr: state_type] :
      ( v14957(VarCurr)
    <=> v14959(VarCurr) ) ).

tff(addAssignment_7619,axiom,
    ! [VarCurr: state_type] :
      ( v14959(VarCurr)
    <=> v14961(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1258,axiom,
    ! [VarCurr: state_type] :
      ( v14961(VarCurr)
    <=> ( v15034(VarCurr)
        | v15030(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1257,axiom,
    ! [VarCurr: state_type] :
      ( v15034(VarCurr)
    <=> ( v14963(VarCurr)
        & v14967(VarCurr) ) ) ).

tff(addAssignment_7618,axiom,
    ! [VarCurr: state_type] :
      ( v15030(VarCurr)
    <=> v15032(VarCurr) ) ).

tff(addAssignment_7617,axiom,
    ! [VarCurr: state_type] :
      ( v15032(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v15014(VarNext)
       => ( v14967(VarNext)
        <=> v14967(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_171,axiom,
    ! [VarNext: state_type] :
      ( v15014(VarNext)
     => ( v14967(VarNext)
      <=> v15024(VarNext) ) ) ).

tff(addAssignment_7616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15024(VarNext)
      <=> v15022(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1256,axiom,
    ! [VarCurr: state_type] :
      ( v15022(VarCurr)
    <=> ( v15025(VarCurr)
        & v15026(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1255,axiom,
    ! [VarCurr: state_type] :
      ( v15026(VarCurr)
    <=> ( v14973(VarCurr)
        | v15009(VarCurr) ) ) ).

tff(writeUnaryOperator_885,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15025(VarCurr)
    <=> v14969(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15014(VarNext)
      <=> v15015(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15015(VarNext)
      <=> ( v15017(VarNext)
          & v15019(VarNext) ) ) ) ).

tff(writeUnaryOperator_884,axiom,
    ! [VarCurr: state_type] :
      ( ~ v15019(VarCurr)
    <=> v14963(VarCurr) ) ).

tff(addAssignment_7615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v15017(VarNext)
      <=> v14963(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_52,axiom,
    ( v14967(constB0)
  <=> $true ) ).

tff(addAssignment_7614,axiom,
    ! [VarCurr: state_type] :
      ( v15009(VarCurr)
    <=> v15011(VarCurr) ) ).

tff(addAssignment_7613,axiom,
    ! [VarCurr: state_type] :
      ( v15011(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7612,axiom,
    ! [VarCurr: state_type] :
      ( v14973(VarCurr)
    <=> v14975(VarCurr) ) ).

tff(addAssignment_7611,axiom,
    ! [VarCurr: state_type] :
      ( v14975(VarCurr)
    <=> v14977(VarCurr) ) ).

tff(addAssignment_7610,axiom,
    ! [VarCurr: state_type] :
      ( v14977(VarCurr)
    <=> v14979(VarCurr) ) ).

tff(addAssignment_7609,axiom,
    ! [VarCurr: state_type] :
      ( v14979(VarCurr)
    <=> v14981(VarCurr) ) ).

tff(writeUnaryOperator_883,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14981(VarCurr)
    <=> v15006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1252,axiom,
    ! [VarCurr: state_type] :
      ( v15006(VarCurr)
    <=> ( v15007(VarCurr)
        | v15002(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1251,axiom,
    ! [VarCurr: state_type] :
      ( v15007(VarCurr)
    <=> ( v14983(VarCurr)
        | v14998(VarCurr) ) ) ).

tff(addAssignment_7608,axiom,
    ! [VarCurr: state_type] :
      ( v15002(VarCurr)
    <=> v15004(VarCurr) ) ).

tff(addAssignment_7607,axiom,
    ! [VarCurr: state_type] :
      ( v15004(VarCurr)
    <=> v14561(VarCurr,2) ) ).

tff(addAssignment_7606,axiom,
    ! [VarCurr: state_type] :
      ( v14998(VarCurr)
    <=> v15000(VarCurr) ) ).

tff(addAssignment_7605,axiom,
    ! [VarCurr: state_type] :
      ( v15000(VarCurr)
    <=> v14561(VarCurr,1) ) ).

tff(addAssignment_7604,axiom,
    ! [VarCurr: state_type] :
      ( v14983(VarCurr)
    <=> v14985(VarCurr) ) ).

tff(addAssignment_7603,axiom,
    ! [VarCurr: state_type] :
      ( v14985(VarCurr)
    <=> v14987(VarCurr,0) ) ).

tff(addAssignment_7602,axiom,
    ! [VarCurr: state_type] :
      ( v14987(VarCurr,0)
    <=> v14989(VarCurr,0) ) ).

tff(addAssignment_7601,axiom,
    ! [VarCurr: state_type] :
      ( v14989(VarCurr,0)
    <=> v14991(VarCurr,0) ) ).

tff(addAssignment_7600,axiom,
    ! [VarCurr: state_type] :
      ( v14991(VarCurr,0)
    <=> v14996(VarCurr,0) ) ).

tff(writeUnaryOperator_882,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14996(VarCurr,B)
      <=> ~ v14993(VarCurr,B) ) ) ).

tff(addAssignment_7599,axiom,
    ! [VarCurr: state_type] :
      ( v14993(VarCurr,0)
    <=> v14995(VarCurr,0) ) ).

tff(addAssignment_7598,axiom,
    ! [VarCurr: state_type] :
      ( v14995(VarCurr,0)
    <=> v14561(VarCurr,0) ) ).

tff(addAssignment_7597,axiom,
    ! [VarCurr: state_type] :
      ( v14969(VarCurr)
    <=> v14971(VarCurr) ) ).

tff(addAssignment_7596,axiom,
    ! [VarCurr: state_type] :
      ( v14971(VarCurr)
    <=> $false ) ).

tff(addAssignment_7595,axiom,
    ! [VarCurr: state_type] :
      ( v14963(VarCurr)
    <=> v14965(VarCurr) ) ).

tff(addAssignment_7594,axiom,
    ! [VarCurr: state_type] :
      ( v14965(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14953(VarCurr,B)
      <=> v14955(VarCurr,B) ) ) ).

tff(addAssignment_7592,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14955(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7591,axiom,
    ! [VarCurr: state_type] :
      ( v14943(VarCurr)
    <=> v14945(VarCurr) ) ).

tff(addAssignment_7590,axiom,
    ! [VarCurr: state_type] :
      ( v14945(VarCurr)
    <=> v14947(VarCurr) ) ).

tff(addAssignment_7589,axiom,
    ! [VarCurr: state_type] :
      ( v14947(VarCurr)
    <=> v14949(VarCurr) ) ).

tff(addAssignment_7588,axiom,
    ! [VarCurr: state_type] :
      ( v14949(VarCurr)
    <=> v14951(VarCurr) ) ).

tff(addAssignment_7587,axiom,
    ! [VarCurr: state_type] :
      ( v14951(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7586,axiom,
    ! [VarCurr: state_type] :
      ( v14933(VarCurr)
    <=> v14935(VarCurr) ) ).

tff(addAssignment_7585,axiom,
    ! [VarCurr: state_type] :
      ( v14935(VarCurr)
    <=> v14937(VarCurr) ) ).

tff(addAssignment_7584,axiom,
    ! [VarCurr: state_type] :
      ( v14937(VarCurr)
    <=> v14939(VarCurr) ) ).

tff(addAssignment_7583,axiom,
    ! [VarCurr: state_type] :
      ( v14939(VarCurr)
    <=> v14941(VarCurr) ) ).

tff(addAssignment_7582,axiom,
    ! [VarCurr: state_type] :
      ( v14941(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7581,axiom,
    ! [VarCurr: state_type] :
      ( v14631(VarCurr)
    <=> v14633(VarCurr) ) ).

tff(addAssignment_7580,axiom,
    ! [VarCurr: state_type] :
      ( v14633(VarCurr)
    <=> v14635(VarCurr) ) ).

tff(addAssignment_7579,axiom,
    ! [VarCurr: state_type] :
      ( v14635(VarCurr)
    <=> v14637(VarCurr) ) ).

tff(addAssignment_7578,axiom,
    ! [VarCurr: state_type] :
      ( v14637(VarCurr)
    <=> v14639(VarCurr) ) ).

tff(addAssignment_7577,axiom,
    ! [VarCurr: state_type] :
      ( v14639(VarCurr)
    <=> v14641(VarCurr) ) ).

tff(addAssignment_7576,axiom,
    ! [VarCurr: state_type] :
      ( v14641(VarCurr)
    <=> v14643(VarCurr) ) ).

tff(addAssignment_7575,axiom,
    ! [VarCurr: state_type] :
      ( v14643(VarCurr)
    <=> v14645(VarCurr) ) ).

tff(writeUnaryOperator_881,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14645(VarCurr)
    <=> v14920(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1250,axiom,
    ! [VarCurr: state_type] :
      ( v14920(VarCurr)
    <=> ( v14921(VarCurr)
        | v14916(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1249,axiom,
    ! [VarCurr: state_type] :
      ( v14921(VarCurr)
    <=> ( v14647(VarCurr)
        | v14912(VarCurr) ) ) ).

tff(addAssignment_7574,axiom,
    ! [VarCurr: state_type] :
      ( v14916(VarCurr)
    <=> v14918(VarCurr) ) ).

tff(addAssignment_7573,axiom,
    ! [VarCurr: state_type] :
      ( v14918(VarCurr)
    <=> v14651(VarCurr,2) ) ).

tff(addAssignment_7572,axiom,
    ! [VarCurr: state_type] :
      ( v14912(VarCurr)
    <=> v14914(VarCurr) ) ).

tff(addAssignment_7571,axiom,
    ! [VarCurr: state_type] :
      ( v14914(VarCurr)
    <=> v14651(VarCurr,1) ) ).

tff(addAssignment_7570,axiom,
    ! [VarCurr: state_type] :
      ( v14647(VarCurr)
    <=> v14649(VarCurr) ) ).

tff(addAssignment_7569,axiom,
    ! [VarCurr: state_type] :
      ( v14649(VarCurr)
    <=> v14651(VarCurr,0) ) ).

tff(addAssignment_7568,axiom,
    ! [VarCurr: state_type] :
      ( v14651(VarCurr,0)
    <=> v14563(VarCurr,3) ) ).

tff(addAssignment_7567,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,3)
    <=> v14565(VarCurr,3) ) ).

tff(addAssignment_7566,axiom,
    ! [VarNext: state_type] :
      ( v14565(VarNext,3)
    <=> v14904(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14905(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v14904(VarNext,B)
            <=> v14565(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_170,axiom,
    ! [VarNext: state_type] :
      ( v14905(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14904(VarNext,B)
          <=> v14876(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1248,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14905(VarNext)
      <=> v14906(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1247,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14906(VarNext)
      <=> ( v14908(VarNext)
          & v14818(VarNext) ) ) ) ).

tff(writeUnaryOperator_880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14908(VarNext)
      <=> v14870(VarNext) ) ) ).

tff(addAssignment_7565,axiom,
    ! [VarCurr: state_type] :
      ( v14675(VarCurr,3)
    <=> v14677(VarCurr,3) ) ).

tff(addAssignment_7564,axiom,
    ! [VarCurr: state_type] :
      ( v14677(VarCurr,3)
    <=> v14815(VarCurr,3) ) ).

tff(addAssignment_7563,axiom,
    ! [VarCurr: state_type] :
      ( v14679(VarCurr,0)
    <=> v14681(VarCurr,0) ) ).

tff(addAssignment_7562,axiom,
    ! [VarCurr: state_type] :
      ( v14681(VarCurr,0)
    <=> v14683(VarCurr,0) ) ).

tff(addAssignment_7561,axiom,
    ! [VarCurr: state_type] :
      ( v14683(VarCurr,0)
    <=> v14814(VarCurr,0) ) ).

tff(addAssignment_7560,axiom,
    ! [VarCurr: state_type] :
      ( v14751(VarCurr,0)
    <=> v14753(VarCurr,0) ) ).

tff(addAssignment_7559,axiom,
    ! [VarCurr: state_type] :
      ( v14753(VarCurr,0)
    <=> v14755(VarCurr,0) ) ).

tff(addAssignment_7558,axiom,
    ! [VarCurr: state_type] :
      ( v14755(VarCurr,0)
    <=> v14757(VarCurr,0) ) ).

tff(addAssignment_7557,axiom,
    ! [VarCurr: state_type] :
      ( v14757(VarCurr,0)
    <=> v14759(VarCurr,0) ) ).

tff(addAssignment_7556,axiom,
    ! [VarCurr: state_type] :
      ( v14759(VarCurr,0)
    <=> v14769(VarCurr,0) ) ).

tff(addAssignment_7555,axiom,
    ! [VarCurr: state_type] :
      ( v14685(VarCurr,0)
    <=> v14687(VarCurr,0) ) ).

tff(addAssignment_7554,axiom,
    ! [VarCurr: state_type] :
      ( v14687(VarCurr,0)
    <=> v14748(VarCurr,0) ) ).

tff(addAssignment_7553,axiom,
    ! [VarCurr: state_type] :
      ( v14689(VarCurr)
    <=> v14215(VarCurr,2) ) ).

tff(addAssignment_7552,axiom,
    ! [VarCurr: state_type] :
      ( v14215(VarCurr,2)
    <=> v14217(VarCurr,2) ) ).

tff(addAssignment_7551,axiom,
    ! [VarCurr: state_type] :
      ( v14217(VarCurr,2)
    <=> v14227(VarCurr,2) ) ).

tff(addAssignment_7550,axiom,
    ! [VarCurr: state_type] :
      ( v14219(VarCurr,2)
    <=> v14221(VarCurr,2) ) ).

tff(addAssignment_7549,axiom,
    ! [VarCurr: state_type] :
      ( v14221(VarCurr,2)
    <=> v14224(VarCurr,2) ) ).

tff(addAssignment_7548,axiom,
    ! [VarCurr: state_type] :
      ( v14225(VarCurr)
    <=> v14692(VarCurr,1) ) ).

tff(addAssignment_7547,axiom,
    ! [VarCurr: state_type] :
      ( v14692(VarCurr,1)
    <=> v14694(VarCurr,1) ) ).

tff(addAssignment_7546,axiom,
    ! [VarCurr: state_type] :
      ( v14694(VarCurr,1)
    <=> v14902(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_257,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v14902(VarCurr,B)
      <=> ( v14696(VarCurr,B)
          | v14702(VarCurr,B) ) ) ) ).

tff(addAssignment_7545,axiom,
    ! [VarCurr: state_type] :
      ( v14702(VarCurr,1)
    <=> v14704(VarCurr,1) ) ).

tff(addAssignment_7544,axiom,
    ! [VarCurr: state_type] :
      ( v14704(VarCurr,1)
    <=> v14900(VarCurr,1) ) ).

tff(addAssignment_7543,axiom,
    ! [VarCurr: state_type] :
      ( v14900(VarCurr,0)
    <=> v14901(VarCurr) ) ).

tff(addAssignment_7542,axiom,
    ! [VarCurr: state_type] :
      ( v14900(VarCurr,1)
    <=> v14706(VarCurr) ) ).

tff(addAssignment_7541,axiom,
    ! [VarCurr: state_type] :
      ( v14706(VarCurr)
    <=> v14708(VarCurr,1) ) ).

tff(addAssignment_7540,axiom,
    ! [VarCurr: state_type] :
      ( v14708(VarCurr,1)
    <=> v14710(VarCurr,1) ) ).

tff(addAssignment_7539,axiom,
    ! [VarCurr: state_type] :
      ( v14710(VarCurr,1)
    <=> v14899(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_256,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v14899(VarCurr,B)
      <=> ( v14712(VarCurr,B)
          & v14720(VarCurr,B) ) ) ) ).

tff(addAssignment_7538,axiom,
    ! [VarCurr: state_type] :
      ( v14720(VarCurr,1)
    <=> v14722(VarCurr,1) ) ).

tff(addAssignment_7537,axiom,
    ! [VarCurr: state_type] :
      ( v14722(VarCurr,1)
    <=> v14897(VarCurr,1) ) ).

tff(addAssignment_7536,axiom,
    ! [VarCurr: state_type] :
      ( v14897(VarCurr,0)
    <=> v14898(VarCurr) ) ).

tff(addAssignment_7535,axiom,
    ! [VarCurr: state_type] :
      ( v14897(VarCurr,1)
    <=> v14724(VarCurr) ) ).

tff(addAssignment_7534,axiom,
    ! [VarCurr: state_type] :
      ( v14724(VarCurr)
    <=> v14726(VarCurr) ) ).

tff(addAssignment_7533,axiom,
    ! [VarCurr: state_type] :
      ( v14726(VarCurr)
    <=> v14728(VarCurr) ) ).

tff(writeUnaryOperator_879,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14728(VarCurr)
    <=> v14895(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1246,axiom,
    ! [VarCurr: state_type] :
      ( v14895(VarCurr)
    <=> ( v14896(VarCurr)
        | v14883(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1245,axiom,
    ! [VarCurr: state_type] :
      ( v14896(VarCurr)
    <=> ( v14730(VarCurr)
        | v14745(VarCurr) ) ) ).

tff(addAssignment_7532,axiom,
    ! [VarCurr: state_type] :
      ( v14883(VarCurr)
    <=> v14885(VarCurr) ) ).

tff(addAssignment_7531,axiom,
    ! [VarCurr: state_type] :
      ( v14885(VarCurr)
    <=> v14734(VarCurr,2) ) ).

tff(addAssignment_7530,axiom,
    ! [VarCurr: state_type] :
      ( v14734(VarCurr,2)
    <=> v14736(VarCurr,2) ) ).

tff(addAssignment_7529,axiom,
    ! [VarCurr: state_type] :
      ( v14736(VarCurr,2)
    <=> v14738(VarCurr,2) ) ).

tff(addAssignment_7528,axiom,
    ! [VarCurr: state_type] :
      ( v14738(VarCurr,2)
    <=> v14743(VarCurr,2) ) ).

tff(addAssignment_7527,axiom,
    ! [VarCurr: state_type] :
      ( v14740(VarCurr,2)
    <=> v14742(VarCurr,2) ) ).

tff(addAssignment_7526,axiom,
    ! [VarCurr: state_type] :
      ( v14742(VarCurr,2)
    <=> v14651(VarCurr,2) ) ).

tff(addAssignment_7525,axiom,
    ! [VarCurr: state_type] :
      ( v14651(VarCurr,2)
    <=> v14563(VarCurr,5) ) ).

tff(addAssignment_7524,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,5)
    <=> v14565(VarCurr,5) ) ).

tff(addAssignment_7523,axiom,
    ! [VarNext: state_type] :
      ( v14565(VarNext,5)
    <=> v14887(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14888(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v14887(VarNext,B)
            <=> v14565(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_169,axiom,
    ! [VarNext: state_type] :
      ( v14888(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14887(VarNext,B)
          <=> v14876(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1244,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14888(VarNext)
      <=> v14889(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1243,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14889(VarNext)
      <=> ( v14891(VarNext)
          & v14818(VarNext) ) ) ) ).

tff(writeUnaryOperator_878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14891(VarNext)
      <=> v14870(VarNext) ) ) ).

tff(addAssignment_7522,axiom,
    ! [VarCurr: state_type] :
      ( v14675(VarCurr,5)
    <=> v14677(VarCurr,5) ) ).

tff(addAssignment_7521,axiom,
    ! [VarCurr: state_type] :
      ( v14677(VarCurr,5)
    <=> v14815(VarCurr,5) ) ).

tff(addAssignment_7520,axiom,
    ! [VarCurr: state_type] :
      ( v14679(VarCurr,2)
    <=> v14681(VarCurr,2) ) ).

tff(addAssignment_7519,axiom,
    ! [VarCurr: state_type] :
      ( v14681(VarCurr,2)
    <=> v14683(VarCurr,2) ) ).

tff(addAssignment_7518,axiom,
    ! [VarCurr: state_type] :
      ( v14683(VarCurr,2)
    <=> v14814(VarCurr,2) ) ).

tff(addAssignment_7517,axiom,
    ! [VarCurr: state_type] :
      ( v14751(VarCurr,2)
    <=> v14753(VarCurr,2) ) ).

tff(addAssignment_7516,axiom,
    ! [VarCurr: state_type] :
      ( v14753(VarCurr,2)
    <=> v14755(VarCurr,2) ) ).

tff(addAssignment_7515,axiom,
    ! [VarCurr: state_type] :
      ( v14755(VarCurr,2)
    <=> v14757(VarCurr,2) ) ).

tff(addAssignment_7514,axiom,
    ! [VarCurr: state_type] :
      ( v14757(VarCurr,2)
    <=> v14759(VarCurr,2) ) ).

tff(addAssignment_7513,axiom,
    ! [VarCurr: state_type] :
      ( v14759(VarCurr,2)
    <=> v14769(VarCurr,2) ) ).

tff(addAssignment_7512,axiom,
    ! [VarCurr: state_type] :
      ( v14761(VarCurr,2)
    <=> v14763(VarCurr,2) ) ).

tff(addAssignment_7511,axiom,
    ! [VarCurr: state_type] :
      ( v14763(VarCurr,2)
    <=> v14764(VarCurr,2) ) ).

tff(addAssignment_7510,axiom,
    ! [VarCurr: state_type] :
      ( v14685(VarCurr,2)
    <=> v14687(VarCurr,2) ) ).

tff(addAssignment_7509,axiom,
    ! [VarCurr: state_type] :
      ( v14687(VarCurr,2)
    <=> v14748(VarCurr,2) ) ).

tff(addAssignment_7508,axiom,
    ! [VarCurr: state_type] :
      ( v14745(VarCurr)
    <=> v14747(VarCurr) ) ).

tff(addAssignment_7507,axiom,
    ! [VarCurr: state_type] :
      ( v14747(VarCurr)
    <=> v14651(VarCurr,1) ) ).

tff(addAssignment_7506,axiom,
    ! [VarCurr: state_type] :
      ( v14651(VarCurr,1)
    <=> v14563(VarCurr,4) ) ).

tff(addAssignment_7505,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,4)
    <=> v14565(VarCurr,4) ) ).

tff(addAssignment_7504,axiom,
    ! [VarNext: state_type] :
      ( v14565(VarNext,4)
    <=> v14865(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14866(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v14865(VarNext,B)
            <=> v14565(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_168,axiom,
    ! [VarNext: state_type] :
      ( v14866(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14865(VarNext,B)
          <=> v14876(VarNext,B) ) ) ) ).

tff(addAssignment_7503,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14876(VarNext,B)
          <=> v14874(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_122,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14874(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_122,axiom,
    ! [VarCurr: state_type] :
      ( v14877(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v14874(VarCurr,B)
          <=> v14675(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1242,axiom,
    ! [VarCurr: state_type] :
      ( v14877(VarCurr)
    <=> ( v14878(VarCurr)
        & v14879(VarCurr) ) ) ).

tff(writeUnaryOperator_877,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14879(VarCurr)
    <=> v14665(VarCurr) ) ).

tff(writeUnaryOperator_876,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14878(VarCurr)
    <=> v14653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1241,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14866(VarNext)
      <=> v14867(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1240,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14867(VarNext)
      <=> ( v14868(VarNext)
          & v14818(VarNext) ) ) ) ).

tff(writeUnaryOperator_875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14868(VarNext)
      <=> v14870(VarNext) ) ) ).

tff(addAssignment_7502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14870(VarNext)
      <=> v14818(VarCurr) ) ) ).

tff(addAssignment_7501,axiom,
    ! [VarCurr: state_type] :
      ( v14818(VarCurr)
    <=> v14820(VarCurr) ) ).

tff(addAssignment_7500,axiom,
    ! [VarCurr: state_type] :
      ( v14820(VarCurr)
    <=> v14822(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1239,axiom,
    ! [VarCurr: state_type] :
      ( v14822(VarCurr)
    <=> ( v14863(VarCurr)
        | v14859(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1238,axiom,
    ! [VarCurr: state_type] :
      ( v14863(VarCurr)
    <=> ( v14824(VarCurr)
        & v14828(VarCurr) ) ) ).

tff(addAssignment_7499,axiom,
    ! [VarCurr: state_type] :
      ( v14859(VarCurr)
    <=> v14861(VarCurr) ) ).

tff(addAssignment_7498,axiom,
    ! [VarCurr: state_type] :
      ( v14861(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14843(VarNext)
       => ( v14828(VarNext)
        <=> v14828(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_167,axiom,
    ! [VarNext: state_type] :
      ( v14843(VarNext)
     => ( v14828(VarNext)
      <=> v14853(VarNext) ) ) ).

tff(addAssignment_7497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14853(VarNext)
      <=> v14851(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1237,axiom,
    ! [VarCurr: state_type] :
      ( v14851(VarCurr)
    <=> ( v14854(VarCurr)
        & v14855(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1236,axiom,
    ! [VarCurr: state_type] :
      ( v14855(VarCurr)
    <=> ( v14834(VarCurr)
        | v14838(VarCurr) ) ) ).

tff(writeUnaryOperator_874,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14854(VarCurr)
    <=> v14830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14843(VarNext)
      <=> v14844(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14844(VarNext)
      <=> ( v14846(VarNext)
          & v14848(VarNext) ) ) ) ).

tff(writeUnaryOperator_873,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14848(VarCurr)
    <=> v14824(VarCurr) ) ).

tff(addAssignment_7496,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14846(VarNext)
      <=> v14824(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_51,axiom,
    ( v14828(constB0)
  <=> $true ) ).

tff(addAssignment_7495,axiom,
    ! [VarCurr: state_type] :
      ( v14838(VarCurr)
    <=> v14840(VarCurr) ) ).

tff(addAssignment_7494,axiom,
    ! [VarCurr: state_type] :
      ( v14840(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7493,axiom,
    ! [VarCurr: state_type] :
      ( v14834(VarCurr)
    <=> v14836(VarCurr) ) ).

tff(addAssignment_7492,axiom,
    ! [VarCurr: state_type] :
      ( v14836(VarCurr)
    <=> $true ) ).

tff(addAssignment_7491,axiom,
    ! [VarCurr: state_type] :
      ( v14830(VarCurr)
    <=> v14832(VarCurr) ) ).

tff(addAssignment_7490,axiom,
    ! [VarCurr: state_type] :
      ( v14832(VarCurr)
    <=> $false ) ).

tff(addAssignment_7489,axiom,
    ! [VarCurr: state_type] :
      ( v14824(VarCurr)
    <=> v14826(VarCurr) ) ).

tff(addAssignment_7488,axiom,
    ! [VarCurr: state_type] :
      ( v14826(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7487,axiom,
    ! [VarCurr: state_type] :
      ( v14675(VarCurr,4)
    <=> v14677(VarCurr,4) ) ).

tff(addAssignment_7486,axiom,
    ! [VarCurr: state_type] :
      ( v14677(VarCurr,4)
    <=> v14815(VarCurr,4) ) ).

tff(addAssignment_7485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14815(VarCurr,B)
      <=> v14816(VarCurr,B) ) ) ).

tff(addAssignment_7484,axiom,
    ! [VarCurr: state_type] :
      ( ( v14815(VarCurr,5)
      <=> v14679(VarCurr,2) )
      & ( v14815(VarCurr,4)
      <=> v14679(VarCurr,1) )
      & ( v14815(VarCurr,3)
      <=> v14679(VarCurr,0) ) ) ).

tff(addAssignment_7483,axiom,
    ! [VarCurr: state_type] :
      ( v14679(VarCurr,1)
    <=> v14681(VarCurr,1) ) ).

tff(addAssignment_7482,axiom,
    ! [VarCurr: state_type] :
      ( v14681(VarCurr,1)
    <=> v14683(VarCurr,1) ) ).

tff(addAssignment_7481,axiom,
    ! [VarCurr: state_type] :
      ( v14683(VarCurr,1)
    <=> v14814(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_255,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14814(VarCurr,B)
      <=> ( v14685(VarCurr,B)
          & v14751(VarCurr,B) ) ) ) ).

tff(addAssignment_7480,axiom,
    ! [VarCurr: state_type] :
      ( v14751(VarCurr,1)
    <=> v14753(VarCurr,1) ) ).

tff(addAssignment_7479,axiom,
    ! [VarCurr: state_type] :
      ( v14753(VarCurr,1)
    <=> v14755(VarCurr,1) ) ).

tff(addAssignment_7478,axiom,
    ! [VarCurr: state_type] :
      ( v14755(VarCurr,1)
    <=> v14757(VarCurr,1) ) ).

tff(addAssignment_7477,axiom,
    ! [VarCurr: state_type] :
      ( v14757(VarCurr,1)
    <=> v14759(VarCurr,1) ) ).

tff(addAssignment_7476,axiom,
    ! [VarCurr: state_type] :
      ( v14759(VarCurr,1)
    <=> v14769(VarCurr,1) ) ).

tff(addAssignment_7475,axiom,
    ! [VarCurr: state_type] :
      ( v14769(VarCurr,0)
    <=> v14809(VarCurr) ) ).

tff(addAssignment_7474,axiom,
    ! [VarCurr: state_type] :
      ( v14769(VarCurr,1)
    <=> v14804(VarCurr) ) ).

tff(addAssignment_7473,axiom,
    ! [VarCurr: state_type] :
      ( v14769(VarCurr,2)
    <=> v14799(VarCurr) ) ).

tff(addAssignment_7472,axiom,
    ! [VarCurr: state_type] :
      ( v14769(VarCurr,3)
    <=> v14771(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1233,axiom,
    ! [VarCurr: state_type] :
      ( v14809(VarCurr)
    <=> ( v14810(VarCurr)
        & v14813(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1232,axiom,
    ! [VarCurr: state_type] :
      ( v14813(VarCurr)
    <=> ( v14761(VarCurr,0)
        | v14779(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1231,axiom,
    ! [VarCurr: state_type] :
      ( v14810(VarCurr)
    <=> ( v14811(VarCurr)
        | v14812(VarCurr) ) ) ).

tff(writeUnaryOperator_872,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14812(VarCurr)
    <=> v14779(VarCurr,0) ) ).

tff(writeUnaryOperator_871,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14811(VarCurr)
    <=> v14761(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1230,axiom,
    ! [VarCurr: state_type] :
      ( v14804(VarCurr)
    <=> ( v14805(VarCurr)
        & v14808(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1229,axiom,
    ! [VarCurr: state_type] :
      ( v14808(VarCurr)
    <=> ( v14778(VarCurr)
        | v14780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1228,axiom,
    ! [VarCurr: state_type] :
      ( v14805(VarCurr)
    <=> ( v14806(VarCurr)
        | v14807(VarCurr) ) ) ).

tff(writeUnaryOperator_870,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14807(VarCurr)
    <=> v14780(VarCurr) ) ).

tff(writeUnaryOperator_869,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14806(VarCurr)
    <=> v14778(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1227,axiom,
    ! [VarCurr: state_type] :
      ( v14799(VarCurr)
    <=> ( v14800(VarCurr)
        & v14803(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1226,axiom,
    ! [VarCurr: state_type] :
      ( v14803(VarCurr)
    <=> ( v14776(VarCurr)
        | v14786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1225,axiom,
    ! [VarCurr: state_type] :
      ( v14800(VarCurr)
    <=> ( v14801(VarCurr)
        | v14802(VarCurr) ) ) ).

tff(writeUnaryOperator_868,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14802(VarCurr)
    <=> v14786(VarCurr) ) ).

tff(writeUnaryOperator_867,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14801(VarCurr)
    <=> v14776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1224,axiom,
    ! [VarCurr: state_type] :
      ( v14771(VarCurr)
    <=> ( v14772(VarCurr)
        & v14798(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1223,axiom,
    ! [VarCurr: state_type] :
      ( v14798(VarCurr)
    <=> ( v14774(VarCurr)
        | v14793(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1222,axiom,
    ! [VarCurr: state_type] :
      ( v14772(VarCurr)
    <=> ( v14773(VarCurr)
        | v14792(VarCurr) ) ) ).

tff(writeUnaryOperator_866,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14792(VarCurr)
    <=> v14793(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1221,axiom,
    ! [VarCurr: state_type] :
      ( v14793(VarCurr)
    <=> ( v14794(VarCurr)
        & v14797(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_198,axiom,
    ! [VarCurr: state_type] :
      ( v14797(VarCurr)
    <=> ( v14761(VarCurr,3)
        | v14779(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1220,axiom,
    ! [VarCurr: state_type] :
      ( v14794(VarCurr)
    <=> ( v14795(VarCurr)
        | v14796(VarCurr) ) ) ).

tff(writeUnaryOperator_865,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14796(VarCurr)
    <=> v14779(VarCurr,3) ) ).

tff(writeUnaryOperator_864,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14795(VarCurr)
    <=> v14761(VarCurr,3) ) ).

tff(writeUnaryOperator_863,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14773(VarCurr)
    <=> v14774(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1219,axiom,
    ! [VarCurr: state_type] :
      ( v14774(VarCurr)
    <=> ( v14775(VarCurr)
        | v14791(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_197,axiom,
    ! [VarCurr: state_type] :
      ( v14791(VarCurr)
    <=> ( v14761(VarCurr,2)
        & v14779(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1218,axiom,
    ! [VarCurr: state_type] :
      ( v14775(VarCurr)
    <=> ( v14776(VarCurr)
        & v14786(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1217,axiom,
    ! [VarCurr: state_type] :
      ( v14786(VarCurr)
    <=> ( v14787(VarCurr)
        & v14790(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_196,axiom,
    ! [VarCurr: state_type] :
      ( v14790(VarCurr)
    <=> ( v14761(VarCurr,2)
        | v14779(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1216,axiom,
    ! [VarCurr: state_type] :
      ( v14787(VarCurr)
    <=> ( v14788(VarCurr)
        | v14789(VarCurr) ) ) ).

tff(writeUnaryOperator_862,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14789(VarCurr)
    <=> v14779(VarCurr,2) ) ).

tff(writeUnaryOperator_861,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14788(VarCurr)
    <=> v14761(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1215,axiom,
    ! [VarCurr: state_type] :
      ( v14776(VarCurr)
    <=> ( v14777(VarCurr)
        | v14785(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_195,axiom,
    ! [VarCurr: state_type] :
      ( v14785(VarCurr)
    <=> ( v14761(VarCurr,1)
        & v14779(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1214,axiom,
    ! [VarCurr: state_type] :
      ( v14777(VarCurr)
    <=> ( v14778(VarCurr)
        & v14780(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1213,axiom,
    ! [VarCurr: state_type] :
      ( v14780(VarCurr)
    <=> ( v14781(VarCurr)
        & v14784(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_194,axiom,
    ! [VarCurr: state_type] :
      ( v14784(VarCurr)
    <=> ( v14761(VarCurr,1)
        | v14779(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1212,axiom,
    ! [VarCurr: state_type] :
      ( v14781(VarCurr)
    <=> ( v14782(VarCurr)
        | v14783(VarCurr) ) ) ).

tff(writeUnaryOperator_860,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14783(VarCurr)
    <=> v14779(VarCurr,1) ) ).

tff(writeUnaryOperator_859,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14782(VarCurr)
    <=> v14761(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1211,axiom,
    ! [VarCurr: state_type] :
      ( v14778(VarCurr)
    <=> ( v14761(VarCurr,0)
        & v14779(VarCurr,0) ) ) ).

tff(addAssignment_7471,axiom,
    ! [VarCurr: state_type] :
      ( v14779(VarCurr,0)
    <=> v14766(VarCurr) ) ).

tff(addAssignment_7470,axiom,
    ! [VarCurr: state_type] :
      ( ( v14779(VarCurr,3)
      <=> $false )
      & ( v14779(VarCurr,2)
      <=> $false )
      & ( v14779(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_7469,axiom,
    ! [VarCurr: state_type] :
      ( v14766(VarCurr)
    <=> v14768(VarCurr) ) ).

tff(addAssignment_7468,axiom,
    ! [VarCurr: state_type] :
      ( v14768(VarCurr)
    <=> v14716(VarCurr) ) ).

tff(addAssignment_7467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v14761(VarCurr,B)
      <=> v14763(VarCurr,B) ) ) ).

tff(addAssignment_7466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v14763(VarCurr,B)
      <=> v14764(VarCurr,B) ) ) ).

tff(addAssignment_7465,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14764(VarCurr,B)
      <=> v14651(VarCurr,B) ) ) ).

tff(addAssignment_7464,axiom,
    ! [VarCurr: state_type] :
      ( v14764(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_7463,axiom,
    ! [VarCurr: state_type] :
      ( v14685(VarCurr,1)
    <=> v14687(VarCurr,1) ) ).

tff(addAssignment_7462,axiom,
    ! [VarCurr: state_type] :
      ( v14687(VarCurr,1)
    <=> v14748(VarCurr,1) ) ).

tff(addAssignment_7461,axiom,
    ! [VarCurr: state_type] :
      ( v14748(VarCurr,0)
    <=> v14749(VarCurr) ) ).

tff(addAssignment_7460,axiom,
    ! [VarCurr: state_type] :
      ( v14748(VarCurr,1)
    <=> v14749(VarCurr) ) ).

tff(addAssignment_7459,axiom,
    ! [VarCurr: state_type] :
      ( v14748(VarCurr,2)
    <=> v14749(VarCurr) ) ).

tff(addAssignment_7458,axiom,
    ! [VarCurr: state_type] :
      ( v14749(VarCurr)
    <=> v14689(VarCurr) ) ).

tff(addAssignment_7457,axiom,
    ! [VarCurr: state_type] :
      ( v14730(VarCurr)
    <=> v14732(VarCurr) ) ).

tff(addAssignment_7456,axiom,
    ! [VarCurr: state_type] :
      ( v14732(VarCurr)
    <=> v14734(VarCurr,0) ) ).

tff(addAssignment_7455,axiom,
    ! [VarCurr: state_type] :
      ( v14734(VarCurr,0)
    <=> v14736(VarCurr,0) ) ).

tff(addAssignment_7454,axiom,
    ! [VarCurr: state_type] :
      ( v14736(VarCurr,0)
    <=> v14738(VarCurr,0) ) ).

tff(addAssignment_7453,axiom,
    ! [VarCurr: state_type] :
      ( v14738(VarCurr,0)
    <=> v14743(VarCurr,0) ) ).

tff(writeUnaryOperator_858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14743(VarCurr,B)
      <=> ~ v14740(VarCurr,B) ) ) ).

tff(addAssignment_7452,axiom,
    ! [VarCurr: state_type] :
      ( v14740(VarCurr,0)
    <=> v14742(VarCurr,0) ) ).

tff(addAssignment_7451,axiom,
    ! [VarCurr: state_type] :
      ( v14742(VarCurr,0)
    <=> v14651(VarCurr,0) ) ).

tff(addAssignment_7450,axiom,
    ! [VarCurr: state_type] :
      ( v14712(VarCurr,1)
    <=> v14714(VarCurr,1) ) ).

tff(addAssignment_7449,axiom,
    ! [VarCurr: state_type] :
      ( v14714(VarCurr,1)
    <=> v14717(VarCurr,1) ) ).

tff(addAssignment_7448,axiom,
    ! [VarCurr: state_type] :
      ( v14717(VarCurr,0)
    <=> v14718(VarCurr) ) ).

tff(addAssignment_7447,axiom,
    ! [VarCurr: state_type] :
      ( v14717(VarCurr,1)
    <=> v14716(VarCurr) ) ).

tff(addAssignment_7446,axiom,
    ! [VarCurr: state_type] :
      ( v14716(VarCurr)
    <=> v10053(VarCurr,3) ) ).

tff(addAssignment_7445,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,3)
    <=> v10055(VarCurr,3) ) ).

tff(addAssignment_7444,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,3)
    <=> v10057(VarCurr,3) ) ).

tff(addAssignment_7443,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,3)
    <=> v10061(VarCurr,3) ) ).

tff(addAssignment_7442,axiom,
    ! [VarCurr: state_type] :
      ( v14696(VarCurr,1)
    <=> v14698(VarCurr,1) ) ).

tff(addAssignment_7441,axiom,
    ! [VarCurr: state_type] :
      ( v14698(VarCurr,1)
    <=> v14699(VarCurr,1) ) ).

tff(addAssignment_7440,axiom,
    ! [VarCurr: state_type] :
      ( v14699(VarCurr,0)
    <=> v14700(VarCurr) ) ).

tff(addAssignment_7439,axiom,
    ! [VarCurr: state_type] :
      ( v14699(VarCurr,1)
    <=> v14700(VarCurr) ) ).

tff(addAssignment_7438,axiom,
    ! [VarCurr: state_type] :
      ( v14700(VarCurr)
    <=> v14223(VarCurr) ) ).

tff(addAssignment_7437,axiom,
    ! [VarCurr: state_type] :
      ( v14665(VarCurr)
    <=> v14667(VarCurr) ) ).

tff(addAssignment_7436,axiom,
    ! [VarCurr: state_type] :
      ( v14667(VarCurr)
    <=> v14669(VarCurr) ) ).

tff(addAssignment_7435,axiom,
    ! [VarCurr: state_type] :
      ( v14669(VarCurr)
    <=> v14671(VarCurr) ) ).

tff(addAssignment_7434,axiom,
    ! [VarCurr: state_type] :
      ( v14671(VarCurr)
    <=> v14673(VarCurr) ) ).

tff(addAssignment_7433,axiom,
    ! [VarCurr: state_type] :
      ( v14673(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7432,axiom,
    ! [VarCurr: state_type] :
      ( v14653(VarCurr)
    <=> v14655(VarCurr) ) ).

tff(addAssignment_7431,axiom,
    ! [VarCurr: state_type] :
      ( v14655(VarCurr)
    <=> v14657(VarCurr) ) ).

tff(addAssignment_7430,axiom,
    ! [VarCurr: state_type] :
      ( v14657(VarCurr)
    <=> v14659(VarCurr) ) ).

tff(addAssignment_7429,axiom,
    ! [VarCurr: state_type] :
      ( v14659(VarCurr)
    <=> v14661(VarCurr) ) ).

tff(addAssignment_7428,axiom,
    ! [VarCurr: state_type] :
      ( v14661(VarCurr)
    <=> v14663(VarCurr) ) ).

tff(addAssignment_7427,axiom,
    ! [VarCurr: state_type] :
      ( v14663(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_7426,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14161(VarCurr,B)
      <=> v14163(VarCurr,B) ) ) ).

tff(addAssignment_7425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14163(VarCurr,B)
      <=> v14165(VarCurr,B) ) ) ).

tff(addAssignment_7424,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14165(VarCurr,B)
      <=> v14167(VarCurr,B) ) ) ).

tff(addAssignment_7423,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14167(VarCurr,B)
      <=> v14169(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14614(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v14169(VarNext,B)
            <=> v14169(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_166,axiom,
    ! [VarNext: state_type] :
      ( v14614(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14169(VarNext,B)
          <=> v14624(VarNext,B) ) ) ) ).

tff(addAssignment_7422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14624(VarNext,B)
          <=> v14622(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14625(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14622(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_121,axiom,
    ! [VarCurr: state_type] :
      ( v14625(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14622(VarCurr,B)
          <=> v14199(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1210,axiom,
    ! [VarCurr: state_type] :
      ( v14625(VarCurr)
    <=> ( v14626(VarCurr)
        & v14627(VarCurr) ) ) ).

tff(writeUnaryOperator_857,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14627(VarCurr)
    <=> v14185(VarCurr) ) ).

tff(writeUnaryOperator_856,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14626(VarCurr)
    <=> v14171(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14614(VarNext)
      <=> v14615(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14615(VarNext)
      <=> ( v14616(VarNext)
          & v14529(VarNext) ) ) ) ).

tff(writeUnaryOperator_855,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14616(VarNext)
      <=> v14618(VarNext) ) ) ).

tff(addAssignment_7421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14618(VarNext)
      <=> v14529(VarCurr) ) ) ).

tff(addAssignment_7420,axiom,
    ! [VarCurr: state_type] :
      ( v14529(VarCurr)
    <=> v14531(VarCurr) ) ).

tff(addAssignment_7419,axiom,
    ! [VarCurr: state_type] :
      ( v14531(VarCurr)
    <=> v14533(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1207,axiom,
    ! [VarCurr: state_type] :
      ( v14533(VarCurr)
    <=> ( v14611(VarCurr)
        | v14603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1206,axiom,
    ! [VarCurr: state_type] :
      ( v14611(VarCurr)
    <=> ( v14535(VarCurr)
        & v14541(VarCurr) ) ) ).

tff(addAssignment_7418,axiom,
    ! [VarCurr: state_type] :
      ( v14603(VarCurr)
    <=> v14605(VarCurr) ) ).

tff(addAssignment_7417,axiom,
    ! [VarCurr: state_type] :
      ( v14605(VarCurr)
    <=> v14607(VarCurr) ) ).

tff(addAssignment_7416,axiom,
    ! [VarCurr: state_type] :
      ( v14607(VarCurr)
    <=> v14609(VarCurr) ) ).

tff(addAssignment_7415,axiom,
    ! [VarCurr: state_type] :
      ( v14609(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14587(VarNext)
       => ( v14541(VarNext)
        <=> v14541(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_165,axiom,
    ! [VarNext: state_type] :
      ( v14587(VarNext)
     => ( v14541(VarNext)
      <=> v14597(VarNext) ) ) ).

tff(addAssignment_7414,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14597(VarNext)
      <=> v14595(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1205,axiom,
    ! [VarCurr: state_type] :
      ( v14595(VarCurr)
    <=> ( v14598(VarCurr)
        & v14599(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1204,axiom,
    ! [VarCurr: state_type] :
      ( v14599(VarCurr)
    <=> ( v14547(VarCurr)
        | v14578(VarCurr) ) ) ).

tff(writeUnaryOperator_854,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14598(VarCurr)
    <=> v14543(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14587(VarNext)
      <=> v14588(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14588(VarNext)
      <=> ( v14590(VarNext)
          & v14592(VarNext) ) ) ) ).

tff(writeUnaryOperator_853,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14592(VarCurr)
    <=> v14535(VarCurr) ) ).

tff(addAssignment_7413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14590(VarNext)
      <=> v14535(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_50,axiom,
    ( v14541(constB0)
  <=> $true ) ).

tff(addAssignment_7412,axiom,
    ! [VarCurr: state_type] :
      ( v14578(VarCurr)
    <=> v14580(VarCurr) ) ).

tff(addAssignment_7411,axiom,
    ! [VarCurr: state_type] :
      ( v14580(VarCurr)
    <=> v14582(VarCurr) ) ).

tff(addAssignment_7410,axiom,
    ! [VarCurr: state_type] :
      ( v14582(VarCurr)
    <=> v14584(VarCurr) ) ).

tff(addAssignment_7409,axiom,
    ! [VarCurr: state_type] :
      ( v14584(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_7408,axiom,
    ! [VarCurr: state_type] :
      ( v14547(VarCurr)
    <=> v14549(VarCurr) ) ).

tff(addAssignment_7407,axiom,
    ! [VarCurr: state_type] :
      ( v14549(VarCurr)
    <=> v14551(VarCurr) ) ).

tff(addAssignment_7406,axiom,
    ! [VarCurr: state_type] :
      ( v14551(VarCurr)
    <=> v14553(VarCurr) ) ).

tff(addAssignment_7405,axiom,
    ! [VarCurr: state_type] :
      ( v14553(VarCurr)
    <=> v14555(VarCurr) ) ).

tff(writeUnaryOperator_852,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14555(VarCurr)
    <=> v14575(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1201,axiom,
    ! [VarCurr: state_type] :
      ( v14575(VarCurr)
    <=> ( v14576(VarCurr)
        | v14571(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1200,axiom,
    ! [VarCurr: state_type] :
      ( v14576(VarCurr)
    <=> ( v14557(VarCurr)
        | v14567(VarCurr) ) ) ).

tff(addAssignment_7404,axiom,
    ! [VarCurr: state_type] :
      ( v14571(VarCurr)
    <=> v14573(VarCurr) ) ).

tff(addAssignment_7403,axiom,
    ! [VarCurr: state_type] :
      ( v14573(VarCurr)
    <=> v14561(VarCurr,2) ) ).

tff(addAssignment_7402,axiom,
    ! [VarCurr: state_type] :
      ( v14561(VarCurr,2)
    <=> v14563(VarCurr,2) ) ).

tff(addAssignment_7401,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,2)
    <=> v14565(VarCurr,2) ) ).

tff(addAssignment_7400,axiom,
    ! [VarCurr: state_type] :
      ( v14567(VarCurr)
    <=> v14569(VarCurr) ) ).

tff(addAssignment_7399,axiom,
    ! [VarCurr: state_type] :
      ( v14569(VarCurr)
    <=> v14561(VarCurr,1) ) ).

tff(addAssignment_7398,axiom,
    ! [VarCurr: state_type] :
      ( v14561(VarCurr,1)
    <=> v14563(VarCurr,1) ) ).

tff(addAssignment_7397,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,1)
    <=> v14565(VarCurr,1) ) ).

tff(addAssignment_7396,axiom,
    ! [VarCurr: state_type] :
      ( v14557(VarCurr)
    <=> v14559(VarCurr) ) ).

tff(addAssignment_7395,axiom,
    ! [VarCurr: state_type] :
      ( v14559(VarCurr)
    <=> v14561(VarCurr,0) ) ).

tff(addAssignment_7394,axiom,
    ! [VarCurr: state_type] :
      ( v14561(VarCurr,0)
    <=> v14563(VarCurr,0) ) ).

tff(addAssignment_7393,axiom,
    ! [VarCurr: state_type] :
      ( v14563(VarCurr,0)
    <=> v14565(VarCurr,0) ) ).

tff(addAssignment_7392,axiom,
    ! [VarCurr: state_type] :
      ( v14543(VarCurr)
    <=> v14545(VarCurr) ) ).

tff(addAssignment_7391,axiom,
    ! [VarCurr: state_type] :
      ( v14545(VarCurr)
    <=> $false ) ).

tff(addAssignment_7390,axiom,
    ! [VarCurr: state_type] :
      ( v14535(VarCurr)
    <=> v14537(VarCurr) ) ).

tff(addAssignment_7389,axiom,
    ! [VarCurr: state_type] :
      ( v14537(VarCurr)
    <=> v14539(VarCurr) ) ).

tff(addAssignment_7388,axiom,
    ! [VarCurr: state_type] :
      ( v14539(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_7387,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14199(VarCurr,B)
      <=> v14201(VarCurr,B) ) ) ).

tff(addAssignment_7386,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14201(VarCurr,B)
      <=> v14203(VarCurr,B) ) ) ).

tff(addAssignment_7385,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14203(VarCurr,B)
      <=> v14205(VarCurr,B) ) ) ).

tff(addAssignment_7384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14205(VarCurr,B)
      <=> v14207(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_254,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14207(VarCurr,B)
      <=> ( v14209(VarCurr,B)
          & v14231(VarCurr,B) ) ) ) ).

tff(addAssignment_7383,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14231(VarCurr,B)
      <=> v14233(VarCurr,B) ) ) ).

tff(addAssignment_7382,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14233(VarCurr,B)
      <=> v14235(VarCurr,B) ) ) ).

tff(addAssignment_7381,axiom,
    ! [VarCurr: state_type] :
      ( ( v14235(VarCurr,11)
      <=> v9198(VarCurr,47) )
      & ( v14235(VarCurr,10)
      <=> v9198(VarCurr,46) )
      & ( v14235(VarCurr,9)
      <=> v9198(VarCurr,45) )
      & ( v14235(VarCurr,8)
      <=> v9198(VarCurr,44) )
      & ( v14235(VarCurr,7)
      <=> v9198(VarCurr,43) )
      & ( v14235(VarCurr,6)
      <=> v9198(VarCurr,42) )
      & ( v14235(VarCurr,5)
      <=> v9198(VarCurr,41) )
      & ( v14235(VarCurr,4)
      <=> v9198(VarCurr,40) )
      & ( v14235(VarCurr,3)
      <=> v9198(VarCurr,39) )
      & ( v14235(VarCurr,2)
      <=> v9198(VarCurr,38) )
      & ( v14235(VarCurr,1)
      <=> v9198(VarCurr,37) )
      & ( v14235(VarCurr,0)
      <=> v9198(VarCurr,36) ) ) ).

tff(addAssignment_7380,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,47)
      <=> v14237(VarCurr,11) )
      & ( v9198(VarCurr,46)
      <=> v14237(VarCurr,10) )
      & ( v9198(VarCurr,45)
      <=> v14237(VarCurr,9) )
      & ( v9198(VarCurr,44)
      <=> v14237(VarCurr,8) )
      & ( v9198(VarCurr,43)
      <=> v14237(VarCurr,7) )
      & ( v9198(VarCurr,42)
      <=> v14237(VarCurr,6) )
      & ( v9198(VarCurr,41)
      <=> v14237(VarCurr,5) )
      & ( v9198(VarCurr,40)
      <=> v14237(VarCurr,4) )
      & ( v9198(VarCurr,39)
      <=> v14237(VarCurr,3) )
      & ( v9198(VarCurr,38)
      <=> v14237(VarCurr,2) )
      & ( v9198(VarCurr,37)
      <=> v14237(VarCurr,1) )
      & ( v9198(VarCurr,36)
      <=> v14237(VarCurr,0) ) ) ).

tff(addAssignment_7379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14237(VarCurr,B)
      <=> v14239(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14239(VarCurr,B)
      <=> ( v14521(VarCurr,B)
          | v14524(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14524(VarCurr,B)
      <=> ( v14249(VarCurr,B)
          & v14525(VarCurr,B) ) ) ) ).

tff(addAssignment_7378,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,0)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7377,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,1)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7376,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,2)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7375,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,3)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7374,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,4)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7373,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,5)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7372,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,6)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7371,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,7)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7370,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,8)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7369,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,9)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7368,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,10)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7367,axiom,
    ! [VarCurr: state_type] :
      ( v14525(VarCurr,11)
    <=> v14526(VarCurr) ) ).

tff(addAssignment_7366,axiom,
    ! [VarCurr: state_type] :
      ( v14526(VarCurr)
    <=> v14517(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_251,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14521(VarCurr,B)
      <=> ( v14241(VarCurr,B)
          & v14522(VarCurr,B) ) ) ) ).

tff(addAssignment_7365,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,0)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7364,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,1)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7363,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,2)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7362,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,3)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7361,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,4)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7360,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,5)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7359,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,6)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7358,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,7)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7357,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,8)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7356,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,9)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7355,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,10)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7354,axiom,
    ! [VarCurr: state_type] :
      ( v14522(VarCurr,11)
    <=> v14523(VarCurr) ) ).

tff(addAssignment_7353,axiom,
    ! [VarCurr: state_type] :
      ( v14523(VarCurr)
    <=> v14245(VarCurr) ) ).

tff(addAssignment_7352,axiom,
    ! [VarCurr: state_type] :
      ( v14517(VarCurr)
    <=> v14519(VarCurr) ) ).

tff(addAssignment_7351,axiom,
    ! [VarCurr: state_type] :
      ( v14519(VarCurr)
    <=> v9844(VarCurr,3) ) ).

tff(addAssignment_7350,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,3)
    <=> v9846(VarCurr,3) ) ).

tff(addAssignment_7349,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,3)
    <=> v9496(VarCurr,3) ) ).

tff(addAssignment_7348,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14249(VarCurr,B)
      <=> v14251(VarCurr,B) ) ) ).

tff(addAssignment_7347,axiom,
    ! [VarCurr: state_type] :
      ( ( v14251(VarCurr,11)
      <=> v9208(VarCurr,59) )
      & ( v14251(VarCurr,10)
      <=> v9208(VarCurr,58) )
      & ( v14251(VarCurr,9)
      <=> v9208(VarCurr,57) )
      & ( v14251(VarCurr,8)
      <=> v9208(VarCurr,56) )
      & ( v14251(VarCurr,7)
      <=> v9208(VarCurr,55) )
      & ( v14251(VarCurr,6)
      <=> v9208(VarCurr,54) )
      & ( v14251(VarCurr,5)
      <=> v9208(VarCurr,53) )
      & ( v14251(VarCurr,4)
      <=> v9208(VarCurr,52) )
      & ( v14251(VarCurr,3)
      <=> v9208(VarCurr,51) )
      & ( v14251(VarCurr,2)
      <=> v9208(VarCurr,50) )
      & ( v14251(VarCurr,1)
      <=> v9208(VarCurr,49) )
      & ( v14251(VarCurr,0)
      <=> v9208(VarCurr,48) ) ) ).

tff(addAssignment_7346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,60)
        & ~ $less(B,48) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_7345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,60)
        & ~ $less(B,48) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_7344,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,59)
      <=> v14253(VarCurr,11) )
      & ( v9212(VarCurr,58)
      <=> v14253(VarCurr,10) )
      & ( v9212(VarCurr,57)
      <=> v14253(VarCurr,9) )
      & ( v9212(VarCurr,56)
      <=> v14253(VarCurr,8) )
      & ( v9212(VarCurr,55)
      <=> v14253(VarCurr,7) )
      & ( v9212(VarCurr,54)
      <=> v14253(VarCurr,6) )
      & ( v9212(VarCurr,53)
      <=> v14253(VarCurr,5) )
      & ( v9212(VarCurr,52)
      <=> v14253(VarCurr,4) )
      & ( v9212(VarCurr,51)
      <=> v14253(VarCurr,3) )
      & ( v9212(VarCurr,50)
      <=> v14253(VarCurr,2) )
      & ( v9212(VarCurr,49)
      <=> v14253(VarCurr,1) )
      & ( v9212(VarCurr,48)
      <=> v14253(VarCurr,0) ) ) ).

tff(addAssignment_7343,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14253(VarCurr,B)
      <=> v14255(VarCurr,B) ) ) ).

tff(addAssignment_7342,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14255(VarCurr,B)
      <=> v14257(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14500(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v14257(VarNext,B)
            <=> v14257(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_164,axiom,
    ! [VarNext: state_type] :
      ( v14500(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14257(VarNext,B)
          <=> v14510(VarNext,B) ) ) ) ).

tff(addAssignment_7341,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14510(VarNext,B)
          <=> v14508(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_120,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14511(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14508(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_120,axiom,
    ! [VarCurr: state_type] :
      ( v14511(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14508(VarCurr,B)
          <=> v14287(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1199,axiom,
    ! [VarCurr: state_type] :
      ( v14511(VarCurr)
    <=> ( v14512(VarCurr)
        & v14513(VarCurr) ) ) ).

tff(writeUnaryOperator_851,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14513(VarCurr)
    <=> v14273(VarCurr) ) ).

tff(writeUnaryOperator_850,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14512(VarCurr)
    <=> v14259(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14500(VarNext)
      <=> v14501(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14501(VarNext)
      <=> ( v14502(VarNext)
          & v14475(VarNext) ) ) ) ).

tff(writeUnaryOperator_849,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14502(VarNext)
      <=> v14504(VarNext) ) ) ).

tff(addAssignment_7340,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14504(VarNext)
      <=> v14475(VarCurr) ) ) ).

tff(addAssignment_7339,axiom,
    ! [VarCurr: state_type] :
      ( v14475(VarCurr)
    <=> v14477(VarCurr) ) ).

tff(addAssignment_7338,axiom,
    ! [VarCurr: state_type] :
      ( v14477(VarCurr)
    <=> v14479(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1196,axiom,
    ! [VarCurr: state_type] :
      ( v14479(VarCurr)
    <=> ( v14497(VarCurr)
        | v14489(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1195,axiom,
    ! [VarCurr: state_type] :
      ( v14497(VarCurr)
    <=> ( v14481(VarCurr)
        & v14487(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_49,axiom,
    ( v14487(constB0)
  <=> $true ) ).

tff(addAssignment_7337,axiom,
    ! [VarCurr: state_type] :
      ( v14489(VarCurr)
    <=> v14491(VarCurr) ) ).

tff(addAssignment_7336,axiom,
    ! [VarCurr: state_type] :
      ( v14491(VarCurr)
    <=> v14493(VarCurr) ) ).

tff(addAssignment_7335,axiom,
    ! [VarCurr: state_type] :
      ( v14493(VarCurr)
    <=> v14495(VarCurr) ) ).

tff(addAssignment_7334,axiom,
    ! [VarCurr: state_type] :
      ( v14495(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_7333,axiom,
    ! [VarCurr: state_type] :
      ( v14481(VarCurr)
    <=> v14483(VarCurr) ) ).

tff(addAssignment_7332,axiom,
    ! [VarCurr: state_type] :
      ( v14483(VarCurr)
    <=> v14485(VarCurr) ) ).

tff(addAssignment_7331,axiom,
    ! [VarCurr: state_type] :
      ( v14485(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_7330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14287(VarCurr,B)
      <=> v14289(VarCurr,B) ) ) ).

tff(addAssignment_7329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14289(VarCurr,B)
      <=> v14291(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_250,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14291(VarCurr,B)
      <=> ( v14460(VarCurr,B)
          | v14471(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_249,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14471(VarCurr,B)
      <=> ( v14424(VarCurr,B)
          & v14472(VarCurr,B) ) ) ) ).

tff(addAssignment_7328,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,0)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7327,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,1)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7326,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,2)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7325,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,3)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7324,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,4)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7323,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,5)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7322,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,6)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7321,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,7)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7320,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,8)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7319,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,9)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7318,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,10)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7317,axiom,
    ! [VarCurr: state_type] :
      ( v14472(VarCurr,11)
    <=> v14473(VarCurr) ) ).

tff(addAssignment_7316,axiom,
    ! [VarCurr: state_type] :
      ( v14473(VarCurr)
    <=> v14434(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_248,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14460(VarCurr,B)
      <=> ( v14461(VarCurr,B)
          | v14468(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_247,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14468(VarCurr,B)
      <=> ( v14388(VarCurr,B)
          & v14469(VarCurr,B) ) ) ) ).

tff(addAssignment_7315,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,0)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7314,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,1)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7313,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,2)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7312,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,3)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7311,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,4)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7310,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,5)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7309,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,6)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7308,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,7)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7307,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,8)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7306,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,9)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7305,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,10)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7304,axiom,
    ! [VarCurr: state_type] :
      ( v14469(VarCurr,11)
    <=> v14470(VarCurr) ) ).

tff(addAssignment_7303,axiom,
    ! [VarCurr: state_type] :
      ( v14470(VarCurr)
    <=> v14398(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14461(VarCurr,B)
      <=> ( v14462(VarCurr,B)
          | v14465(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14465(VarCurr,B)
      <=> ( v14341(VarCurr,B)
          & v14466(VarCurr,B) ) ) ) ).

tff(addAssignment_7302,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,0)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7301,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,1)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7300,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,2)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7299,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,3)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7298,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,4)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7297,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,5)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7296,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,6)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7295,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,7)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7294,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,8)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7293,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,9)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7292,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,10)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7291,axiom,
    ! [VarCurr: state_type] :
      ( v14466(VarCurr,11)
    <=> v14467(VarCurr) ) ).

tff(addAssignment_7290,axiom,
    ! [VarCurr: state_type] :
      ( v14467(VarCurr)
    <=> v14351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14462(VarCurr,B)
      <=> ( v14293(VarCurr,B)
          & v14463(VarCurr,B) ) ) ) ).

tff(addAssignment_7289,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,0)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7288,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,1)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7287,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,2)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7286,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,3)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7285,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,4)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7284,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,5)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7283,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,6)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7282,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,7)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7281,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,8)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7280,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,9)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7279,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,10)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7278,axiom,
    ! [VarCurr: state_type] :
      ( v14463(VarCurr,11)
    <=> v14464(VarCurr) ) ).

tff(addAssignment_7277,axiom,
    ! [VarCurr: state_type] :
      ( v14464(VarCurr)
    <=> v14303(VarCurr) ) ).

tff(addAssignment_7276,axiom,
    ! [VarCurr: state_type] :
      ( v14434(VarCurr)
    <=> v14436(VarCurr) ) ).

tff(addAssignment_7275,axiom,
    ! [VarCurr: state_type] :
      ( v14436(VarCurr)
    <=> v14438(VarCurr) ) ).

tff(addAssignment_7274,axiom,
    ! [VarCurr: state_type] :
      ( v14438(VarCurr)
    <=> v14440(VarCurr) ) ).

tff(addAssignment_7273,axiom,
    ! [VarCurr: state_type] :
      ( v14440(VarCurr)
    <=> v14442(VarCurr) ) ).

tff(addAssignment_7272,axiom,
    ! [VarCurr: state_type] :
      ( v14442(VarCurr)
    <=> v14444(VarCurr) ) ).

tff(addAssignment_7271,axiom,
    ! [VarCurr: state_type] :
      ( v14444(VarCurr)
    <=> v14446(VarCurr) ) ).

tff(addAssignment_7270,axiom,
    ! [VarCurr: state_type] :
      ( v14446(VarCurr)
    <=> v14448(VarCurr) ) ).

tff(writeUnaryOperator_848,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14448(VarCurr)
    <=> v14458(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1194,axiom,
    ! [VarCurr: state_type] :
      ( v14458(VarCurr)
    <=> ( v14450(VarCurr)
        | v14454(VarCurr) ) ) ).

tff(addAssignment_7269,axiom,
    ! [VarCurr: state_type] :
      ( v14454(VarCurr)
    <=> v14456(VarCurr) ) ).

tff(addAssignment_7268,axiom,
    ! [VarCurr: state_type] :
      ( v14456(VarCurr)
    <=> v14371(VarCurr,1) ) ).

tff(addAssignment_7267,axiom,
    ! [VarCurr: state_type] :
      ( v14450(VarCurr)
    <=> v14452(VarCurr) ) ).

tff(addAssignment_7266,axiom,
    ! [VarCurr: state_type] :
      ( v14452(VarCurr)
    <=> v14371(VarCurr,0) ) ).

tff(addAssignment_7265,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14424(VarCurr,B)
      <=> v14426(VarCurr,B) ) ) ).

tff(addAssignment_7264,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14426(VarCurr,B)
      <=> v14428(VarCurr,B) ) ) ).

tff(addAssignment_7263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14428(VarCurr,B)
      <=> v14430(VarCurr,B) ) ) ).

tff(addAssignment_7262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14430(VarCurr,B)
      <=> v14432(VarCurr,B) ) ) ).

tff(addAssignment_7261,axiom,
    ! [VarCurr: state_type] :
      ( v14398(VarCurr)
    <=> v14400(VarCurr) ) ).

tff(addAssignment_7260,axiom,
    ! [VarCurr: state_type] :
      ( v14400(VarCurr)
    <=> v14402(VarCurr) ) ).

tff(addAssignment_7259,axiom,
    ! [VarCurr: state_type] :
      ( v14402(VarCurr)
    <=> v14404(VarCurr) ) ).

tff(addAssignment_7258,axiom,
    ! [VarCurr: state_type] :
      ( v14404(VarCurr)
    <=> v14406(VarCurr) ) ).

tff(addAssignment_7257,axiom,
    ! [VarCurr: state_type] :
      ( v14406(VarCurr)
    <=> v14408(VarCurr) ) ).

tff(addAssignment_7256,axiom,
    ! [VarCurr: state_type] :
      ( v14408(VarCurr)
    <=> v14410(VarCurr) ) ).

tff(addAssignment_7255,axiom,
    ! [VarCurr: state_type] :
      ( v14410(VarCurr)
    <=> v14412(VarCurr) ) ).

tff(writeUnaryOperator_847,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14412(VarCurr)
    <=> v14422(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1193,axiom,
    ! [VarCurr: state_type] :
      ( v14422(VarCurr)
    <=> ( v14414(VarCurr)
        | v14418(VarCurr) ) ) ).

tff(addAssignment_7254,axiom,
    ! [VarCurr: state_type] :
      ( v14418(VarCurr)
    <=> v14420(VarCurr) ) ).

tff(addAssignment_7253,axiom,
    ! [VarCurr: state_type] :
      ( v14420(VarCurr)
    <=> v14371(VarCurr,1) ) ).

tff(addAssignment_7252,axiom,
    ! [VarCurr: state_type] :
      ( v14371(VarCurr,1)
    <=> v14373(VarCurr,1) ) ).

tff(addAssignment_7251,axiom,
    ! [VarCurr: state_type] :
      ( v14373(VarCurr,1)
    <=> v14375(VarCurr,1) ) ).

tff(addAssignment_7250,axiom,
    ! [VarCurr: state_type] :
      ( v14375(VarCurr,1)
    <=> v14380(VarCurr,1) ) ).

tff(addAssignment_7249,axiom,
    ! [VarCurr: state_type] :
      ( v14377(VarCurr,1)
    <=> v14379(VarCurr,1) ) ).

tff(addAssignment_7248,axiom,
    ! [VarCurr: state_type] :
      ( v14379(VarCurr,1)
    <=> v14323(VarCurr,1) ) ).

tff(addAssignment_7247,axiom,
    ! [VarCurr: state_type] :
      ( v14414(VarCurr)
    <=> v14416(VarCurr) ) ).

tff(addAssignment_7246,axiom,
    ! [VarCurr: state_type] :
      ( v14416(VarCurr)
    <=> v14323(VarCurr,0) ) ).

tff(addAssignment_7245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14388(VarCurr,B)
      <=> v14390(VarCurr,B) ) ) ).

tff(addAssignment_7244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14390(VarCurr,B)
      <=> v14392(VarCurr,B) ) ) ).

tff(addAssignment_7243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14392(VarCurr,B)
      <=> v14394(VarCurr,B) ) ) ).

tff(addAssignment_7242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14394(VarCurr,B)
      <=> v14396(VarCurr,B) ) ) ).

tff(addAssignment_7241,axiom,
    ! [VarCurr: state_type] :
      ( v14351(VarCurr)
    <=> v14353(VarCurr) ) ).

tff(addAssignment_7240,axiom,
    ! [VarCurr: state_type] :
      ( v14353(VarCurr)
    <=> v14355(VarCurr) ) ).

tff(addAssignment_7239,axiom,
    ! [VarCurr: state_type] :
      ( v14355(VarCurr)
    <=> v14357(VarCurr) ) ).

tff(addAssignment_7238,axiom,
    ! [VarCurr: state_type] :
      ( v14357(VarCurr)
    <=> v14359(VarCurr) ) ).

tff(addAssignment_7237,axiom,
    ! [VarCurr: state_type] :
      ( v14359(VarCurr)
    <=> v14361(VarCurr) ) ).

tff(addAssignment_7236,axiom,
    ! [VarCurr: state_type] :
      ( v14361(VarCurr)
    <=> v14363(VarCurr) ) ).

tff(addAssignment_7235,axiom,
    ! [VarCurr: state_type] :
      ( v14363(VarCurr)
    <=> v14365(VarCurr) ) ).

tff(writeUnaryOperator_846,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14365(VarCurr)
    <=> v14386(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1192,axiom,
    ! [VarCurr: state_type] :
      ( v14386(VarCurr)
    <=> ( v14367(VarCurr)
        | v14382(VarCurr) ) ) ).

tff(addAssignment_7234,axiom,
    ! [VarCurr: state_type] :
      ( v14382(VarCurr)
    <=> v14384(VarCurr) ) ).

tff(addAssignment_7233,axiom,
    ! [VarCurr: state_type] :
      ( v14384(VarCurr)
    <=> v14323(VarCurr,1) ) ).

tff(addAssignment_7232,axiom,
    ! [VarCurr: state_type] :
      ( v14367(VarCurr)
    <=> v14369(VarCurr) ) ).

tff(addAssignment_7231,axiom,
    ! [VarCurr: state_type] :
      ( v14369(VarCurr)
    <=> v14371(VarCurr,0) ) ).

tff(addAssignment_7230,axiom,
    ! [VarCurr: state_type] :
      ( v14371(VarCurr,0)
    <=> v14373(VarCurr,0) ) ).

tff(addAssignment_7229,axiom,
    ! [VarCurr: state_type] :
      ( v14373(VarCurr,0)
    <=> v14375(VarCurr,0) ) ).

tff(addAssignment_7228,axiom,
    ! [VarCurr: state_type] :
      ( v14375(VarCurr,0)
    <=> v14380(VarCurr,0) ) ).

tff(writeUnaryOperator_845,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v14380(VarCurr,B)
      <=> ~ v14377(VarCurr,B) ) ) ).

tff(addAssignment_7227,axiom,
    ! [VarCurr: state_type] :
      ( v14377(VarCurr,0)
    <=> v14379(VarCurr,0) ) ).

tff(addAssignment_7226,axiom,
    ! [VarCurr: state_type] :
      ( v14379(VarCurr,0)
    <=> v14323(VarCurr,0) ) ).

tff(addAssignment_7225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14341(VarCurr,B)
      <=> v14343(VarCurr,B) ) ) ).

tff(addAssignment_7224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14343(VarCurr,B)
      <=> v14345(VarCurr,B) ) ) ).

tff(addAssignment_7223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14345(VarCurr,B)
      <=> v14347(VarCurr,B) ) ) ).

tff(addAssignment_7222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14347(VarCurr,B)
      <=> v14349(VarCurr,B) ) ) ).

tff(addAssignment_7221,axiom,
    ! [VarCurr: state_type] :
      ( v14303(VarCurr)
    <=> v14305(VarCurr) ) ).

tff(addAssignment_7220,axiom,
    ! [VarCurr: state_type] :
      ( v14305(VarCurr)
    <=> v14307(VarCurr) ) ).

tff(addAssignment_7219,axiom,
    ! [VarCurr: state_type] :
      ( v14307(VarCurr)
    <=> v14309(VarCurr) ) ).

tff(addAssignment_7218,axiom,
    ! [VarCurr: state_type] :
      ( v14309(VarCurr)
    <=> v14311(VarCurr) ) ).

tff(addAssignment_7217,axiom,
    ! [VarCurr: state_type] :
      ( v14311(VarCurr)
    <=> v14313(VarCurr) ) ).

tff(addAssignment_7216,axiom,
    ! [VarCurr: state_type] :
      ( v14313(VarCurr)
    <=> v14315(VarCurr) ) ).

tff(addAssignment_7215,axiom,
    ! [VarCurr: state_type] :
      ( v14315(VarCurr)
    <=> v14317(VarCurr) ) ).

tff(writeUnaryOperator_844,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14317(VarCurr)
    <=> v14339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1191,axiom,
    ! [VarCurr: state_type] :
      ( v14339(VarCurr)
    <=> ( v14319(VarCurr)
        | v14335(VarCurr) ) ) ).

tff(addAssignment_7214,axiom,
    ! [VarCurr: state_type] :
      ( v14335(VarCurr)
    <=> v14337(VarCurr) ) ).

tff(addAssignment_7213,axiom,
    ! [VarCurr: state_type] :
      ( v14337(VarCurr)
    <=> v14323(VarCurr,1) ) ).

tff(addAssignment_7212,axiom,
    ! [VarCurr: state_type] :
      ( v14323(VarCurr,1)
    <=> v14325(VarCurr,1) ) ).

tff(addAssignment_7211,axiom,
    ! [VarCurr: state_type] :
      ( v14325(VarCurr,1)
    <=> v14327(VarCurr,1) ) ).

tff(addAssignment_7210,axiom,
    ! [VarCurr: state_type] :
      ( v14327(VarCurr,1)
    <=> v14329(VarCurr,1) ) ).

tff(addAssignment_7209,axiom,
    ! [VarCurr: state_type] :
      ( v14329(VarCurr,1)
    <=> v14331(VarCurr,1) ) ).

tff(addAssignment_7208,axiom,
    ! [VarCurr: state_type] :
      ( v14331(VarCurr,1)
    <=> v14333(VarCurr,1) ) ).

tff(addAssignment_7207,axiom,
    ! [VarCurr: state_type] :
      ( v14319(VarCurr)
    <=> v14321(VarCurr) ) ).

tff(addAssignment_7206,axiom,
    ! [VarCurr: state_type] :
      ( v14321(VarCurr)
    <=> v14323(VarCurr,0) ) ).

tff(addAssignment_7205,axiom,
    ! [VarCurr: state_type] :
      ( v14323(VarCurr,0)
    <=> v14325(VarCurr,0) ) ).

tff(addAssignment_7204,axiom,
    ! [VarCurr: state_type] :
      ( v14325(VarCurr,0)
    <=> v14327(VarCurr,0) ) ).

tff(addAssignment_7203,axiom,
    ! [VarCurr: state_type] :
      ( v14327(VarCurr,0)
    <=> v14329(VarCurr,0) ) ).

tff(addAssignment_7202,axiom,
    ! [VarCurr: state_type] :
      ( v14329(VarCurr,0)
    <=> v14331(VarCurr,0) ) ).

tff(addAssignment_7201,axiom,
    ! [VarCurr: state_type] :
      ( v14331(VarCurr,0)
    <=> v14333(VarCurr,0) ) ).

tff(addAssignment_7200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14293(VarCurr,B)
      <=> v14295(VarCurr,B) ) ) ).

tff(addAssignment_7199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14295(VarCurr,B)
      <=> v14297(VarCurr,B) ) ) ).

tff(addAssignment_7198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14297(VarCurr,B)
      <=> v14299(VarCurr,B) ) ) ).

tff(addAssignment_7197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14299(VarCurr,B)
      <=> v14301(VarCurr,B) ) ) ).

tff(addAssignment_7196,axiom,
    ! [VarCurr: state_type] :
      ( v14273(VarCurr)
    <=> v14275(VarCurr) ) ).

tff(addAssignment_7195,axiom,
    ! [VarCurr: state_type] :
      ( v14275(VarCurr)
    <=> v14277(VarCurr) ) ).

tff(addAssignment_7194,axiom,
    ! [VarCurr: state_type] :
      ( v14277(VarCurr)
    <=> v14279(VarCurr) ) ).

tff(addAssignment_7193,axiom,
    ! [VarCurr: state_type] :
      ( v14279(VarCurr)
    <=> v14281(VarCurr) ) ).

tff(addAssignment_7192,axiom,
    ! [VarCurr: state_type] :
      ( v14281(VarCurr)
    <=> v14283(VarCurr) ) ).

tff(addAssignment_7191,axiom,
    ! [VarCurr: state_type] :
      ( v14283(VarCurr)
    <=> v14285(VarCurr) ) ).

tff(addAssignment_7190,axiom,
    ! [VarCurr: state_type] :
      ( v14285(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_7189,axiom,
    ! [VarCurr: state_type] :
      ( v14259(VarCurr)
    <=> v14261(VarCurr) ) ).

tff(addAssignment_7188,axiom,
    ! [VarCurr: state_type] :
      ( v14261(VarCurr)
    <=> v14263(VarCurr) ) ).

tff(addAssignment_7187,axiom,
    ! [VarCurr: state_type] :
      ( v14263(VarCurr)
    <=> v14265(VarCurr) ) ).

tff(addAssignment_7186,axiom,
    ! [VarCurr: state_type] :
      ( v14265(VarCurr)
    <=> v14267(VarCurr) ) ).

tff(addAssignment_7185,axiom,
    ! [VarCurr: state_type] :
      ( v14267(VarCurr)
    <=> v14269(VarCurr) ) ).

tff(addAssignment_7184,axiom,
    ! [VarCurr: state_type] :
      ( v14269(VarCurr)
    <=> v14271(VarCurr) ) ).

tff(addAssignment_7183,axiom,
    ! [VarCurr: state_type] :
      ( v14271(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_7182,axiom,
    ! [VarCurr: state_type] :
      ( v14245(VarCurr)
    <=> v14247(VarCurr) ) ).

tff(addAssignment_7181,axiom,
    ! [VarCurr: state_type] :
      ( v14247(VarCurr)
    <=> v9490(VarCurr,3) ) ).

tff(addAssignment_7180,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,3)
    <=> v9492(VarCurr,3) ) ).

tff(addAssignment_7179,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,3)
    <=> v9494(VarCurr,3) ) ).

tff(addAssignment_7178,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,3)
    <=> v9570(VarCurr,3) ) ).

tff(addAssignment_7177,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,3)
    <=> v9513(VarCurr,3) ) ).

tff(addAssignment_7176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14241(VarCurr,B)
      <=> v14243(VarCurr,B) ) ) ).

tff(addAssignment_7175,axiom,
    ! [VarCurr: state_type] :
      ( ( v14243(VarCurr,11)
      <=> v9208(VarCurr,47) )
      & ( v14243(VarCurr,10)
      <=> v9208(VarCurr,46) )
      & ( v14243(VarCurr,9)
      <=> v9208(VarCurr,45) )
      & ( v14243(VarCurr,8)
      <=> v9208(VarCurr,44) )
      & ( v14243(VarCurr,7)
      <=> v9208(VarCurr,43) )
      & ( v14243(VarCurr,6)
      <=> v9208(VarCurr,42) )
      & ( v14243(VarCurr,5)
      <=> v9208(VarCurr,41) )
      & ( v14243(VarCurr,4)
      <=> v9208(VarCurr,40) )
      & ( v14243(VarCurr,3)
      <=> v9208(VarCurr,39) )
      & ( v14243(VarCurr,2)
      <=> v9208(VarCurr,38) )
      & ( v14243(VarCurr,1)
      <=> v9208(VarCurr,37) )
      & ( v14243(VarCurr,0)
      <=> v9208(VarCurr,36) ) ) ).

tff(addAssignment_7174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14209(VarCurr,B)
      <=> v14211(VarCurr,B) ) ) ).

tff(addAssignment_7173,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,0)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7172,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,1)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7171,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,2)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7170,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,3)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7169,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,4)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7168,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,5)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7167,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,6)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7166,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,7)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7165,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,8)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7164,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,9)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7163,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,10)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7162,axiom,
    ! [VarCurr: state_type] :
      ( v14211(VarCurr,11)
    <=> v14229(VarCurr) ) ).

tff(addAssignment_7161,axiom,
    ! [VarCurr: state_type] :
      ( v14229(VarCurr)
    <=> v14213(VarCurr) ) ).

tff(addAssignment_7160,axiom,
    ! [VarCurr: state_type] :
      ( v14213(VarCurr)
    <=> v14215(VarCurr,0) ) ).

tff(addAssignment_7159,axiom,
    ! [VarCurr: state_type] :
      ( v14215(VarCurr,0)
    <=> v14217(VarCurr,0) ) ).

tff(addAssignment_7158,axiom,
    ! [VarCurr: state_type] :
      ( v14217(VarCurr,0)
    <=> v14227(VarCurr,0) ) ).

tff(writeUnaryOperator_843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v14227(VarCurr,B)
      <=> ~ v14219(VarCurr,B) ) ) ).

tff(addAssignment_7157,axiom,
    ! [VarCurr: state_type] :
      ( v14219(VarCurr,0)
    <=> v14221(VarCurr,0) ) ).

tff(addAssignment_7156,axiom,
    ! [VarCurr: state_type] :
      ( v14221(VarCurr,0)
    <=> v14224(VarCurr,0) ) ).

tff(addAssignment_7155,axiom,
    ! [VarCurr: state_type] :
      ( v14224(VarCurr,0)
    <=> v14223(VarCurr) ) ).

tff(addAssignment_7154,axiom,
    ! [VarCurr: state_type] :
      ( v14224(VarCurr,1)
    <=> v14226(VarCurr) ) ).

tff(addAssignment_7153,axiom,
    ! [VarCurr: state_type] :
      ( v14224(VarCurr,2)
    <=> v14225(VarCurr) ) ).

tff(addAssignment_7152,axiom,
    ! [VarCurr: state_type] :
      ( v14223(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_7151,axiom,
    ! [VarCurr: state_type] :
      ( v14185(VarCurr)
    <=> v14187(VarCurr) ) ).

tff(addAssignment_7150,axiom,
    ! [VarCurr: state_type] :
      ( v14187(VarCurr)
    <=> v14189(VarCurr) ) ).

tff(addAssignment_7149,axiom,
    ! [VarCurr: state_type] :
      ( v14189(VarCurr)
    <=> v14191(VarCurr) ) ).

tff(addAssignment_7148,axiom,
    ! [VarCurr: state_type] :
      ( v14191(VarCurr)
    <=> v14193(VarCurr) ) ).

tff(addAssignment_7147,axiom,
    ! [VarCurr: state_type] :
      ( v14193(VarCurr)
    <=> v14195(VarCurr) ) ).

tff(addAssignment_7146,axiom,
    ! [VarCurr: state_type] :
      ( v14195(VarCurr)
    <=> v14197(VarCurr) ) ).

tff(addAssignment_7145,axiom,
    ! [VarCurr: state_type] :
      ( v14197(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_7144,axiom,
    ! [VarCurr: state_type] :
      ( v14171(VarCurr)
    <=> v14173(VarCurr) ) ).

tff(addAssignment_7143,axiom,
    ! [VarCurr: state_type] :
      ( v14173(VarCurr)
    <=> v14175(VarCurr) ) ).

tff(addAssignment_7142,axiom,
    ! [VarCurr: state_type] :
      ( v14175(VarCurr)
    <=> v14177(VarCurr) ) ).

tff(addAssignment_7141,axiom,
    ! [VarCurr: state_type] :
      ( v14177(VarCurr)
    <=> v14179(VarCurr) ) ).

tff(addAssignment_7140,axiom,
    ! [VarCurr: state_type] :
      ( v14179(VarCurr)
    <=> v14181(VarCurr) ) ).

tff(addAssignment_7139,axiom,
    ! [VarCurr: state_type] :
      ( v14181(VarCurr)
    <=> v14183(VarCurr) ) ).

tff(addAssignment_7138,axiom,
    ! [VarCurr: state_type] :
      ( v14183(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_7137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14147(VarCurr,B)
      <=> v14149(VarCurr,B) ) ) ).

tff(addAssignment_7136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14149(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_7135,axiom,
    ! [VarCurr: state_type] :
      ( v12591(VarCurr)
    <=> v12593(VarCurr) ) ).

tff(addAssignment_7134,axiom,
    ! [VarCurr: state_type] :
      ( v12593(VarCurr)
    <=> v12595(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_88,axiom,
    ! [VarCurr: state_type] :
      ( v12595(VarCurr)
    <=> ( ( v12597(VarCurr,11)
        <=> v12601(VarCurr,11) )
        & ( v12597(VarCurr,10)
        <=> v12601(VarCurr,10) )
        & ( v12597(VarCurr,9)
        <=> v12601(VarCurr,9) )
        & ( v12597(VarCurr,8)
        <=> v12601(VarCurr,8) )
        & ( v12597(VarCurr,7)
        <=> v12601(VarCurr,7) )
        & ( v12597(VarCurr,6)
        <=> v12601(VarCurr,6) )
        & ( v12597(VarCurr,5)
        <=> v12601(VarCurr,5) )
        & ( v12597(VarCurr,4)
        <=> v12601(VarCurr,4) )
        & ( v12597(VarCurr,3)
        <=> v12601(VarCurr,3) )
        & ( v12597(VarCurr,2)
        <=> v12601(VarCurr,2) )
        & ( v12597(VarCurr,1)
        <=> v12601(VarCurr,1) )
        & ( v12597(VarCurr,0)
        <=> v12601(VarCurr,0) ) ) ) ).

tff(addAssignment_7133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12601(VarCurr,B)
      <=> v12603(VarCurr,B) ) ) ).

tff(addAssignment_7132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12603(VarCurr,B)
      <=> v12605(VarCurr,B) ) ) ).

tff(addAssignment_7131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12605(VarCurr,B)
      <=> v12607(VarCurr,B) ) ) ).

tff(addAssignment_7130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12607(VarCurr,B)
      <=> v12609(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12609(VarCurr,B)
      <=> ( v14117(VarCurr,B)
          | v14136(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_242,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14136(VarCurr,B)
      <=> ( v13988(VarCurr,B)
          & v14137(VarCurr,B) ) ) ) ).

tff(addAssignment_7129,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,0)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7128,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,1)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7127,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,2)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7126,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,3)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7125,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,4)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7124,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,5)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7123,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,6)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7122,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,7)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7121,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,8)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7120,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,9)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7119,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,10)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7118,axiom,
    ! [VarCurr: state_type] :
      ( v14137(VarCurr,11)
    <=> v14138(VarCurr) ) ).

tff(addAssignment_7117,axiom,
    ! [VarCurr: state_type] :
      ( v14138(VarCurr)
    <=> v14107(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_241,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14117(VarCurr,B)
      <=> ( v14118(VarCurr,B)
          | v14133(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_240,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14133(VarCurr,B)
      <=> ( v13837(VarCurr,B)
          & v14134(VarCurr,B) ) ) ) ).

tff(addAssignment_7116,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,0)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7115,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,1)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7114,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,2)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7113,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,3)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7112,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,4)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7111,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,5)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7110,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,6)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7109,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,7)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7108,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,8)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7107,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,9)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7106,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,10)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7105,axiom,
    ! [VarCurr: state_type] :
      ( v14134(VarCurr,11)
    <=> v14135(VarCurr) ) ).

tff(addAssignment_7104,axiom,
    ! [VarCurr: state_type] :
      ( v14135(VarCurr)
    <=> v13957(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14118(VarCurr,B)
      <=> ( v14119(VarCurr,B)
          | v14130(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14130(VarCurr,B)
      <=> ( v13686(VarCurr,B)
          & v14131(VarCurr,B) ) ) ) ).

tff(addAssignment_7103,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,0)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7102,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,1)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7101,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,2)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7100,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,3)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7099,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,4)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7098,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,5)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7097,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,6)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7096,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,7)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7095,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,8)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7094,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,9)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7093,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,10)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7092,axiom,
    ! [VarCurr: state_type] :
      ( v14131(VarCurr,11)
    <=> v14132(VarCurr) ) ).

tff(addAssignment_7091,axiom,
    ! [VarCurr: state_type] :
      ( v14132(VarCurr)
    <=> v13806(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14119(VarCurr,B)
      <=> ( v14120(VarCurr,B)
          | v14127(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14127(VarCurr,B)
      <=> ( v13535(VarCurr,B)
          & v14128(VarCurr,B) ) ) ) ).

tff(addAssignment_7090,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,0)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7089,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,1)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7088,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,2)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7087,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,3)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7086,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,4)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7085,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,5)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7084,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,6)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7083,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,7)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7082,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,8)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7081,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,9)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7080,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,10)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7079,axiom,
    ! [VarCurr: state_type] :
      ( v14128(VarCurr,11)
    <=> v14129(VarCurr) ) ).

tff(addAssignment_7078,axiom,
    ! [VarCurr: state_type] :
      ( v14129(VarCurr)
    <=> v13655(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_235,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14120(VarCurr,B)
      <=> ( v14121(VarCurr,B)
          | v14124(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_234,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14124(VarCurr,B)
      <=> ( v13373(VarCurr,B)
          & v14125(VarCurr,B) ) ) ) ).

tff(addAssignment_7077,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,0)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7076,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,1)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7075,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,2)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7074,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,3)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7073,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,4)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7072,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,5)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7071,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,6)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7070,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,7)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7069,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,8)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7068,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,9)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7067,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,10)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7066,axiom,
    ! [VarCurr: state_type] :
      ( v14125(VarCurr,11)
    <=> v14126(VarCurr) ) ).

tff(addAssignment_7065,axiom,
    ! [VarCurr: state_type] :
      ( v14126(VarCurr)
    <=> v13504(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_233,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14121(VarCurr,B)
      <=> ( v12611(VarCurr,B)
          & v14122(VarCurr,B) ) ) ) ).

tff(addAssignment_7064,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,0)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7063,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,1)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7062,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,2)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7061,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,3)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7060,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,4)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7059,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,5)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7058,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,6)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7057,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,7)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7056,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,8)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7055,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,9)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7054,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,10)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7053,axiom,
    ! [VarCurr: state_type] :
      ( v14122(VarCurr,11)
    <=> v14123(VarCurr) ) ).

tff(addAssignment_7052,axiom,
    ! [VarCurr: state_type] :
      ( v14123(VarCurr)
    <=> v13081(VarCurr) ) ).

tff(addAssignment_7051,axiom,
    ! [VarCurr: state_type] :
      ( v14107(VarCurr)
    <=> v14109(VarCurr) ) ).

tff(addAssignment_7050,axiom,
    ! [VarCurr: state_type] :
      ( v14109(VarCurr)
    <=> v14111(VarCurr) ) ).

tff(addAssignment_7049,axiom,
    ! [VarCurr: state_type] :
      ( v14111(VarCurr)
    <=> v14113(VarCurr) ) ).

tff(addAssignment_7048,axiom,
    ! [VarCurr: state_type] :
      ( v14113(VarCurr)
    <=> v14115(VarCurr) ) ).

tff(addAssignment_7047,axiom,
    ! [VarCurr: state_type] :
      ( v14115(VarCurr)
    <=> v13174(VarCurr) ) ).

tff(addAssignment_7046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13988(VarCurr,B)
      <=> v13990(VarCurr,B) ) ) ).

tff(addAssignment_7045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13990(VarCurr,B)
      <=> v13992(VarCurr,B) ) ) ).

tff(addAssignment_7044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13992(VarCurr,B)
      <=> v13994(VarCurr,B) ) ) ).

tff(addAssignment_7043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13994(VarCurr,B)
      <=> v13996(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14090(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v13996(VarNext,B)
            <=> v13996(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_163,axiom,
    ! [VarNext: state_type] :
      ( v14090(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13996(VarNext,B)
          <=> v14100(VarNext,B) ) ) ) ).

tff(addAssignment_7042,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14100(VarNext,B)
          <=> v14098(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14101(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14098(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_119,axiom,
    ! [VarCurr: state_type] :
      ( v14101(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v14098(VarCurr,B)
          <=> v14018(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1190,axiom,
    ! [VarCurr: state_type] :
      ( v14101(VarCurr)
    <=> ( v14102(VarCurr)
        & v14103(VarCurr) ) ) ).

tff(writeUnaryOperator_842,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14103(VarCurr)
    <=> v14008(VarCurr) ) ).

tff(writeUnaryOperator_841,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14102(VarCurr)
    <=> v13998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14090(VarNext)
      <=> v14091(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14091(VarNext)
      <=> ( v14092(VarNext)
          & v14022(VarNext) ) ) ) ).

tff(writeUnaryOperator_840,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14092(VarNext)
      <=> v14094(VarNext) ) ) ).

tff(addAssignment_7041,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14094(VarNext)
      <=> v14022(VarCurr) ) ) ).

tff(addAssignment_7040,axiom,
    ! [VarCurr: state_type] :
      ( v14022(VarCurr)
    <=> v14024(VarCurr) ) ).

tff(addAssignment_7039,axiom,
    ! [VarCurr: state_type] :
      ( v14024(VarCurr)
    <=> v14026(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1187,axiom,
    ! [VarCurr: state_type] :
      ( v14026(VarCurr)
    <=> ( v14087(VarCurr)
        | v14083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1186,axiom,
    ! [VarCurr: state_type] :
      ( v14087(VarCurr)
    <=> ( v14028(VarCurr)
        & v14032(VarCurr) ) ) ).

tff(addAssignment_7038,axiom,
    ! [VarCurr: state_type] :
      ( v14083(VarCurr)
    <=> v14085(VarCurr) ) ).

tff(addAssignment_7037,axiom,
    ! [VarCurr: state_type] :
      ( v14085(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v14067(VarNext)
       => ( v14032(VarNext)
        <=> v14032(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_162,axiom,
    ! [VarNext: state_type] :
      ( v14067(VarNext)
     => ( v14032(VarNext)
      <=> v14077(VarNext) ) ) ).

tff(addAssignment_7036,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14077(VarNext)
      <=> v14075(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1185,axiom,
    ! [VarCurr: state_type] :
      ( v14075(VarCurr)
    <=> ( v14078(VarCurr)
        & v14079(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1184,axiom,
    ! [VarCurr: state_type] :
      ( v14079(VarCurr)
    <=> ( v14038(VarCurr)
        | v14062(VarCurr) ) ) ).

tff(writeUnaryOperator_839,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14078(VarCurr)
    <=> v14034(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14067(VarNext)
      <=> v14068(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14068(VarNext)
      <=> ( v14070(VarNext)
          & v14072(VarNext) ) ) ) ).

tff(writeUnaryOperator_838,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14072(VarCurr)
    <=> v14028(VarCurr) ) ).

tff(addAssignment_7035,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v14070(VarNext)
      <=> v14028(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_48,axiom,
    ( v14032(constB0)
  <=> $true ) ).

tff(addAssignment_7034,axiom,
    ! [VarCurr: state_type] :
      ( v14062(VarCurr)
    <=> v14064(VarCurr) ) ).

tff(addAssignment_7033,axiom,
    ! [VarCurr: state_type] :
      ( v14064(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_7032,axiom,
    ! [VarCurr: state_type] :
      ( v14038(VarCurr)
    <=> v14040(VarCurr) ) ).

tff(addAssignment_7031,axiom,
    ! [VarCurr: state_type] :
      ( v14040(VarCurr)
    <=> v13348(VarCurr) ) ).

tff(addAssignment_7030,axiom,
    ! [VarCurr: state_type] :
      ( v13348(VarCurr)
    <=> v14043(VarCurr) ) ).

tff(addAssignment_7029,axiom,
    ! [VarCurr: state_type] :
      ( v14043(VarCurr)
    <=> v14045(VarCurr) ) ).

tff(writeUnaryOperator_837,axiom,
    ! [VarCurr: state_type] :
      ( ~ v14045(VarCurr)
    <=> v14059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1181,axiom,
    ! [VarCurr: state_type] :
      ( v14059(VarCurr)
    <=> ( v14060(VarCurr)
        | v14055(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1180,axiom,
    ! [VarCurr: state_type] :
      ( v14060(VarCurr)
    <=> ( v14047(VarCurr)
        | v14051(VarCurr) ) ) ).

tff(addAssignment_7028,axiom,
    ! [VarCurr: state_type] :
      ( v14055(VarCurr)
    <=> v14057(VarCurr) ) ).

tff(addAssignment_7027,axiom,
    ! [VarCurr: state_type] :
      ( v14057(VarCurr)
    <=> v13437(VarCurr,2) ) ).

tff(addAssignment_7026,axiom,
    ! [VarCurr: state_type] :
      ( v14051(VarCurr)
    <=> v14053(VarCurr) ) ).

tff(addAssignment_7025,axiom,
    ! [VarCurr: state_type] :
      ( v14053(VarCurr)
    <=> v13011(VarCurr,1) ) ).

tff(addAssignment_7024,axiom,
    ! [VarCurr: state_type] :
      ( v14047(VarCurr)
    <=> v14049(VarCurr) ) ).

tff(addAssignment_7023,axiom,
    ! [VarCurr: state_type] :
      ( v14049(VarCurr)
    <=> v13437(VarCurr,0) ) ).

tff(addAssignment_7022,axiom,
    ! [VarCurr: state_type] :
      ( v14034(VarCurr)
    <=> v14036(VarCurr) ) ).

tff(addAssignment_7021,axiom,
    ! [VarCurr: state_type] :
      ( v14036(VarCurr)
    <=> $false ) ).

tff(addAssignment_7020,axiom,
    ! [VarCurr: state_type] :
      ( v14028(VarCurr)
    <=> v14030(VarCurr) ) ).

tff(addAssignment_7019,axiom,
    ! [VarCurr: state_type] :
      ( v14030(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_7018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14018(VarCurr,B)
      <=> v14020(VarCurr,B) ) ) ).

tff(addAssignment_7017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v14020(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_7016,axiom,
    ! [VarCurr: state_type] :
      ( v14008(VarCurr)
    <=> v14010(VarCurr) ) ).

tff(addAssignment_7015,axiom,
    ! [VarCurr: state_type] :
      ( v14010(VarCurr)
    <=> v14012(VarCurr) ) ).

tff(addAssignment_7014,axiom,
    ! [VarCurr: state_type] :
      ( v14012(VarCurr)
    <=> v14014(VarCurr) ) ).

tff(addAssignment_7013,axiom,
    ! [VarCurr: state_type] :
      ( v14014(VarCurr)
    <=> v14016(VarCurr) ) ).

tff(addAssignment_7012,axiom,
    ! [VarCurr: state_type] :
      ( v14016(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_7011,axiom,
    ! [VarCurr: state_type] :
      ( v13998(VarCurr)
    <=> v14000(VarCurr) ) ).

tff(addAssignment_7010,axiom,
    ! [VarCurr: state_type] :
      ( v14000(VarCurr)
    <=> v14002(VarCurr) ) ).

tff(addAssignment_7009,axiom,
    ! [VarCurr: state_type] :
      ( v14002(VarCurr)
    <=> v14004(VarCurr) ) ).

tff(addAssignment_7008,axiom,
    ! [VarCurr: state_type] :
      ( v14004(VarCurr)
    <=> v14006(VarCurr) ) ).

tff(addAssignment_7007,axiom,
    ! [VarCurr: state_type] :
      ( v14006(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_7006,axiom,
    ! [VarCurr: state_type] :
      ( v13957(VarCurr)
    <=> v13959(VarCurr) ) ).

tff(addAssignment_7005,axiom,
    ! [VarCurr: state_type] :
      ( v13959(VarCurr)
    <=> v13961(VarCurr) ) ).

tff(addAssignment_7004,axiom,
    ! [VarCurr: state_type] :
      ( v13961(VarCurr)
    <=> v13963(VarCurr) ) ).

tff(addAssignment_7003,axiom,
    ! [VarCurr: state_type] :
      ( v13963(VarCurr)
    <=> v13965(VarCurr) ) ).

tff(addAssignment_7002,axiom,
    ! [VarCurr: state_type] :
      ( v13965(VarCurr)
    <=> v13967(VarCurr) ) ).

tff(addAssignment_7001,axiom,
    ! [VarCurr: state_type] :
      ( v13967(VarCurr)
    <=> v13969(VarCurr) ) ).

tff(addAssignment_7000,axiom,
    ! [VarCurr: state_type] :
      ( v13969(VarCurr)
    <=> v13971(VarCurr) ) ).

tff(writeUnaryOperator_836,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13971(VarCurr)
    <=> v13985(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1179,axiom,
    ! [VarCurr: state_type] :
      ( v13985(VarCurr)
    <=> ( v13986(VarCurr)
        | v13981(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1178,axiom,
    ! [VarCurr: state_type] :
      ( v13986(VarCurr)
    <=> ( v13973(VarCurr)
        | v13977(VarCurr) ) ) ).

tff(addAssignment_6999,axiom,
    ! [VarCurr: state_type] :
      ( v13981(VarCurr)
    <=> v13983(VarCurr) ) ).

tff(addAssignment_6998,axiom,
    ! [VarCurr: state_type] :
      ( v13983(VarCurr)
    <=> v13184(VarCurr,2) ) ).

tff(addAssignment_6997,axiom,
    ! [VarCurr: state_type] :
      ( v13977(VarCurr)
    <=> v13979(VarCurr) ) ).

tff(addAssignment_6996,axiom,
    ! [VarCurr: state_type] :
      ( v13979(VarCurr)
    <=> v13101(VarCurr,1) ) ).

tff(addAssignment_6995,axiom,
    ! [VarCurr: state_type] :
      ( v13973(VarCurr)
    <=> v13975(VarCurr) ) ).

tff(addAssignment_6994,axiom,
    ! [VarCurr: state_type] :
      ( v13975(VarCurr)
    <=> v13101(VarCurr,0) ) ).

tff(addAssignment_6993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13837(VarCurr,B)
      <=> v13839(VarCurr,B) ) ) ).

tff(addAssignment_6992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13839(VarCurr,B)
      <=> v13841(VarCurr,B) ) ) ).

tff(addAssignment_6991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13841(VarCurr,B)
      <=> v13843(VarCurr,B) ) ) ).

tff(addAssignment_6990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13843(VarCurr,B)
      <=> v13845(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_161,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13940(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v13845(VarNext,B)
            <=> v13845(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_161,axiom,
    ! [VarNext: state_type] :
      ( v13940(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13845(VarNext,B)
          <=> v13950(VarNext,B) ) ) ) ).

tff(addAssignment_6989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13950(VarNext,B)
          <=> v13948(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13948(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_118,axiom,
    ! [VarCurr: state_type] :
      ( v13951(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13948(VarCurr,B)
          <=> v13867(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1177,axiom,
    ! [VarCurr: state_type] :
      ( v13951(VarCurr)
    <=> ( v13952(VarCurr)
        & v13953(VarCurr) ) ) ).

tff(writeUnaryOperator_835,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13953(VarCurr)
    <=> v13857(VarCurr) ) ).

tff(writeUnaryOperator_834,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13952(VarCurr)
    <=> v13847(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13940(VarNext)
      <=> v13941(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13941(VarNext)
      <=> ( v13942(VarNext)
          & v13871(VarNext) ) ) ) ).

tff(writeUnaryOperator_833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13942(VarNext)
      <=> v13944(VarNext) ) ) ).

tff(addAssignment_6988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13944(VarNext)
      <=> v13871(VarCurr) ) ) ).

tff(addAssignment_6987,axiom,
    ! [VarCurr: state_type] :
      ( v13871(VarCurr)
    <=> v13873(VarCurr) ) ).

tff(addAssignment_6986,axiom,
    ! [VarCurr: state_type] :
      ( v13873(VarCurr)
    <=> v13875(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1174,axiom,
    ! [VarCurr: state_type] :
      ( v13875(VarCurr)
    <=> ( v13937(VarCurr)
        | v13933(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1173,axiom,
    ! [VarCurr: state_type] :
      ( v13937(VarCurr)
    <=> ( v13877(VarCurr)
        & v13881(VarCurr) ) ) ).

tff(addAssignment_6985,axiom,
    ! [VarCurr: state_type] :
      ( v13933(VarCurr)
    <=> v13935(VarCurr) ) ).

tff(addAssignment_6984,axiom,
    ! [VarCurr: state_type] :
      ( v13935(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13917(VarNext)
       => ( v13881(VarNext)
        <=> v13881(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_160,axiom,
    ! [VarNext: state_type] :
      ( v13917(VarNext)
     => ( v13881(VarNext)
      <=> v13927(VarNext) ) ) ).

tff(addAssignment_6983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13927(VarNext)
      <=> v13925(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1172,axiom,
    ! [VarCurr: state_type] :
      ( v13925(VarCurr)
    <=> ( v13928(VarCurr)
        & v13929(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1171,axiom,
    ! [VarCurr: state_type] :
      ( v13929(VarCurr)
    <=> ( v13887(VarCurr)
        | v13912(VarCurr) ) ) ).

tff(writeUnaryOperator_832,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13928(VarCurr)
    <=> v13883(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13917(VarNext)
      <=> v13918(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13918(VarNext)
      <=> ( v13920(VarNext)
          & v13922(VarNext) ) ) ) ).

tff(writeUnaryOperator_831,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13922(VarCurr)
    <=> v13877(VarCurr) ) ).

tff(addAssignment_6982,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13920(VarNext)
      <=> v13877(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_47,axiom,
    ( v13881(constB0)
  <=> $true ) ).

tff(addAssignment_6981,axiom,
    ! [VarCurr: state_type] :
      ( v13912(VarCurr)
    <=> v13914(VarCurr) ) ).

tff(addAssignment_6980,axiom,
    ! [VarCurr: state_type] :
      ( v13914(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6979,axiom,
    ! [VarCurr: state_type] :
      ( v13887(VarCurr)
    <=> v13889(VarCurr) ) ).

tff(addAssignment_6978,axiom,
    ! [VarCurr: state_type] :
      ( v13889(VarCurr)
    <=> v13891(VarCurr) ) ).

tff(addAssignment_6977,axiom,
    ! [VarCurr: state_type] :
      ( v13891(VarCurr)
    <=> v13893(VarCurr) ) ).

tff(addAssignment_6976,axiom,
    ! [VarCurr: state_type] :
      ( v13893(VarCurr)
    <=> v13895(VarCurr) ) ).

tff(writeUnaryOperator_830,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13895(VarCurr)
    <=> v13909(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1168,axiom,
    ! [VarCurr: state_type] :
      ( v13909(VarCurr)
    <=> ( v13910(VarCurr)
        | v13905(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1167,axiom,
    ! [VarCurr: state_type] :
      ( v13910(VarCurr)
    <=> ( v13897(VarCurr)
        | v13901(VarCurr) ) ) ).

tff(addAssignment_6975,axiom,
    ! [VarCurr: state_type] :
      ( v13905(VarCurr)
    <=> v13907(VarCurr) ) ).

tff(addAssignment_6974,axiom,
    ! [VarCurr: state_type] :
      ( v13907(VarCurr)
    <=> v13437(VarCurr,2) ) ).

tff(addAssignment_6973,axiom,
    ! [VarCurr: state_type] :
      ( v13437(VarCurr,2)
    <=> v13439(VarCurr,2) ) ).

tff(addAssignment_6972,axiom,
    ! [VarCurr: state_type] :
      ( v13439(VarCurr,2)
    <=> v13441(VarCurr,2) ) ).

tff(addAssignment_6971,axiom,
    ! [VarCurr: state_type] :
      ( v13441(VarCurr,2)
    <=> v13446(VarCurr,2) ) ).

tff(addAssignment_6970,axiom,
    ! [VarCurr: state_type] :
      ( v13443(VarCurr,2)
    <=> v13445(VarCurr,2) ) ).

tff(addAssignment_6969,axiom,
    ! [VarCurr: state_type] :
      ( v13445(VarCurr,2)
    <=> v13011(VarCurr,2) ) ).

tff(addAssignment_6968,axiom,
    ! [VarCurr: state_type] :
      ( v13901(VarCurr)
    <=> v13903(VarCurr) ) ).

tff(addAssignment_6967,axiom,
    ! [VarCurr: state_type] :
      ( v13903(VarCurr)
    <=> v13011(VarCurr,1) ) ).

tff(addAssignment_6966,axiom,
    ! [VarCurr: state_type] :
      ( v13897(VarCurr)
    <=> v13899(VarCurr) ) ).

tff(addAssignment_6965,axiom,
    ! [VarCurr: state_type] :
      ( v13899(VarCurr)
    <=> v13011(VarCurr,0) ) ).

tff(addAssignment_6964,axiom,
    ! [VarCurr: state_type] :
      ( v13883(VarCurr)
    <=> v13885(VarCurr) ) ).

tff(addAssignment_6963,axiom,
    ! [VarCurr: state_type] :
      ( v13885(VarCurr)
    <=> $false ) ).

tff(addAssignment_6962,axiom,
    ! [VarCurr: state_type] :
      ( v13877(VarCurr)
    <=> v13879(VarCurr) ) ).

tff(addAssignment_6961,axiom,
    ! [VarCurr: state_type] :
      ( v13879(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6960,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13867(VarCurr,B)
      <=> v13869(VarCurr,B) ) ) ).

tff(addAssignment_6959,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13869(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_6958,axiom,
    ! [VarCurr: state_type] :
      ( v13857(VarCurr)
    <=> v13859(VarCurr) ) ).

tff(addAssignment_6957,axiom,
    ! [VarCurr: state_type] :
      ( v13859(VarCurr)
    <=> v13861(VarCurr) ) ).

tff(addAssignment_6956,axiom,
    ! [VarCurr: state_type] :
      ( v13861(VarCurr)
    <=> v13863(VarCurr) ) ).

tff(addAssignment_6955,axiom,
    ! [VarCurr: state_type] :
      ( v13863(VarCurr)
    <=> v13865(VarCurr) ) ).

tff(addAssignment_6954,axiom,
    ! [VarCurr: state_type] :
      ( v13865(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6953,axiom,
    ! [VarCurr: state_type] :
      ( v13847(VarCurr)
    <=> v13849(VarCurr) ) ).

tff(addAssignment_6952,axiom,
    ! [VarCurr: state_type] :
      ( v13849(VarCurr)
    <=> v13851(VarCurr) ) ).

tff(addAssignment_6951,axiom,
    ! [VarCurr: state_type] :
      ( v13851(VarCurr)
    <=> v13853(VarCurr) ) ).

tff(addAssignment_6950,axiom,
    ! [VarCurr: state_type] :
      ( v13853(VarCurr)
    <=> v13855(VarCurr) ) ).

tff(addAssignment_6949,axiom,
    ! [VarCurr: state_type] :
      ( v13855(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_6948,axiom,
    ! [VarCurr: state_type] :
      ( v13806(VarCurr)
    <=> v13808(VarCurr) ) ).

tff(addAssignment_6947,axiom,
    ! [VarCurr: state_type] :
      ( v13808(VarCurr)
    <=> v13810(VarCurr) ) ).

tff(addAssignment_6946,axiom,
    ! [VarCurr: state_type] :
      ( v13810(VarCurr)
    <=> v13812(VarCurr) ) ).

tff(addAssignment_6945,axiom,
    ! [VarCurr: state_type] :
      ( v13812(VarCurr)
    <=> v13814(VarCurr) ) ).

tff(addAssignment_6944,axiom,
    ! [VarCurr: state_type] :
      ( v13814(VarCurr)
    <=> v13816(VarCurr) ) ).

tff(addAssignment_6943,axiom,
    ! [VarCurr: state_type] :
      ( v13816(VarCurr)
    <=> v13818(VarCurr) ) ).

tff(addAssignment_6942,axiom,
    ! [VarCurr: state_type] :
      ( v13818(VarCurr)
    <=> v13820(VarCurr) ) ).

tff(writeUnaryOperator_829,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13820(VarCurr)
    <=> v13834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1166,axiom,
    ! [VarCurr: state_type] :
      ( v13834(VarCurr)
    <=> ( v13835(VarCurr)
        | v13830(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1165,axiom,
    ! [VarCurr: state_type] :
      ( v13835(VarCurr)
    <=> ( v13822(VarCurr)
        | v13826(VarCurr) ) ) ).

tff(addAssignment_6941,axiom,
    ! [VarCurr: state_type] :
      ( v13830(VarCurr)
    <=> v13832(VarCurr) ) ).

tff(addAssignment_6940,axiom,
    ! [VarCurr: state_type] :
      ( v13832(VarCurr)
    <=> v13101(VarCurr,2) ) ).

tff(addAssignment_6939,axiom,
    ! [VarCurr: state_type] :
      ( v13826(VarCurr)
    <=> v13828(VarCurr) ) ).

tff(addAssignment_6938,axiom,
    ! [VarCurr: state_type] :
      ( v13828(VarCurr)
    <=> v13184(VarCurr,1) ) ).

tff(addAssignment_6937,axiom,
    ! [VarCurr: state_type] :
      ( v13822(VarCurr)
    <=> v13824(VarCurr) ) ).

tff(addAssignment_6936,axiom,
    ! [VarCurr: state_type] :
      ( v13824(VarCurr)
    <=> v13184(VarCurr,0) ) ).

tff(addAssignment_6935,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13686(VarCurr,B)
      <=> v13688(VarCurr,B) ) ) ).

tff(addAssignment_6934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13688(VarCurr,B)
      <=> v13690(VarCurr,B) ) ) ).

tff(addAssignment_6933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13690(VarCurr,B)
      <=> v13692(VarCurr,B) ) ) ).

tff(addAssignment_6932,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13692(VarCurr,B)
      <=> v13694(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_159,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13789(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v13694(VarNext,B)
            <=> v13694(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_159,axiom,
    ! [VarNext: state_type] :
      ( v13789(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13694(VarNext,B)
          <=> v13799(VarNext,B) ) ) ) ).

tff(addAssignment_6931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13799(VarNext,B)
          <=> v13797(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_117,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13797(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_117,axiom,
    ! [VarCurr: state_type] :
      ( v13800(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13797(VarCurr,B)
          <=> v13716(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1164,axiom,
    ! [VarCurr: state_type] :
      ( v13800(VarCurr)
    <=> ( v13801(VarCurr)
        & v13802(VarCurr) ) ) ).

tff(writeUnaryOperator_828,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13802(VarCurr)
    <=> v13706(VarCurr) ) ).

tff(writeUnaryOperator_827,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13801(VarCurr)
    <=> v13696(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13789(VarNext)
      <=> v13790(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1162,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13790(VarNext)
      <=> ( v13791(VarNext)
          & v13720(VarNext) ) ) ) ).

tff(writeUnaryOperator_826,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13791(VarNext)
      <=> v13793(VarNext) ) ) ).

tff(addAssignment_6930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13793(VarNext)
      <=> v13720(VarCurr) ) ) ).

tff(addAssignment_6929,axiom,
    ! [VarCurr: state_type] :
      ( v13720(VarCurr)
    <=> v13722(VarCurr) ) ).

tff(addAssignment_6928,axiom,
    ! [VarCurr: state_type] :
      ( v13722(VarCurr)
    <=> v13724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1161,axiom,
    ! [VarCurr: state_type] :
      ( v13724(VarCurr)
    <=> ( v13786(VarCurr)
        | v13782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1160,axiom,
    ! [VarCurr: state_type] :
      ( v13786(VarCurr)
    <=> ( v13726(VarCurr)
        & v13730(VarCurr) ) ) ).

tff(addAssignment_6927,axiom,
    ! [VarCurr: state_type] :
      ( v13782(VarCurr)
    <=> v13784(VarCurr) ) ).

tff(addAssignment_6926,axiom,
    ! [VarCurr: state_type] :
      ( v13784(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_158,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13766(VarNext)
       => ( v13730(VarNext)
        <=> v13730(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_158,axiom,
    ! [VarNext: state_type] :
      ( v13766(VarNext)
     => ( v13730(VarNext)
      <=> v13776(VarNext) ) ) ).

tff(addAssignment_6925,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13776(VarNext)
      <=> v13774(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1159,axiom,
    ! [VarCurr: state_type] :
      ( v13774(VarCurr)
    <=> ( v13777(VarCurr)
        & v13778(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1158,axiom,
    ! [VarCurr: state_type] :
      ( v13778(VarCurr)
    <=> ( v13736(VarCurr)
        | v13761(VarCurr) ) ) ).

tff(writeUnaryOperator_825,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13777(VarCurr)
    <=> v13732(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13766(VarNext)
      <=> v13767(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13767(VarNext)
      <=> ( v13769(VarNext)
          & v13771(VarNext) ) ) ) ).

tff(writeUnaryOperator_824,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13771(VarCurr)
    <=> v13726(VarCurr) ) ).

tff(addAssignment_6924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13769(VarNext)
      <=> v13726(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_46,axiom,
    ( v13730(constB0)
  <=> $true ) ).

tff(addAssignment_6923,axiom,
    ! [VarCurr: state_type] :
      ( v13761(VarCurr)
    <=> v13763(VarCurr) ) ).

tff(addAssignment_6922,axiom,
    ! [VarCurr: state_type] :
      ( v13763(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6921,axiom,
    ! [VarCurr: state_type] :
      ( v13736(VarCurr)
    <=> v13738(VarCurr) ) ).

tff(addAssignment_6920,axiom,
    ! [VarCurr: state_type] :
      ( v13738(VarCurr)
    <=> v13740(VarCurr) ) ).

tff(addAssignment_6919,axiom,
    ! [VarCurr: state_type] :
      ( v13740(VarCurr)
    <=> v13742(VarCurr) ) ).

tff(addAssignment_6918,axiom,
    ! [VarCurr: state_type] :
      ( v13742(VarCurr)
    <=> v13744(VarCurr) ) ).

tff(writeUnaryOperator_823,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13744(VarCurr)
    <=> v13758(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1155,axiom,
    ! [VarCurr: state_type] :
      ( v13758(VarCurr)
    <=> ( v13759(VarCurr)
        | v13754(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1154,axiom,
    ! [VarCurr: state_type] :
      ( v13759(VarCurr)
    <=> ( v13746(VarCurr)
        | v13750(VarCurr) ) ) ).

tff(addAssignment_6917,axiom,
    ! [VarCurr: state_type] :
      ( v13754(VarCurr)
    <=> v13756(VarCurr) ) ).

tff(addAssignment_6916,axiom,
    ! [VarCurr: state_type] :
      ( v13756(VarCurr)
    <=> v13011(VarCurr,2) ) ).

tff(addAssignment_6915,axiom,
    ! [VarCurr: state_type] :
      ( v13750(VarCurr)
    <=> v13752(VarCurr) ) ).

tff(addAssignment_6914,axiom,
    ! [VarCurr: state_type] :
      ( v13752(VarCurr)
    <=> v13437(VarCurr,1) ) ).

tff(addAssignment_6913,axiom,
    ! [VarCurr: state_type] :
      ( v13746(VarCurr)
    <=> v13748(VarCurr) ) ).

tff(addAssignment_6912,axiom,
    ! [VarCurr: state_type] :
      ( v13748(VarCurr)
    <=> v13437(VarCurr,0) ) ).

tff(addAssignment_6911,axiom,
    ! [VarCurr: state_type] :
      ( v13732(VarCurr)
    <=> v13734(VarCurr) ) ).

tff(addAssignment_6910,axiom,
    ! [VarCurr: state_type] :
      ( v13734(VarCurr)
    <=> $false ) ).

tff(addAssignment_6909,axiom,
    ! [VarCurr: state_type] :
      ( v13726(VarCurr)
    <=> v13728(VarCurr) ) ).

tff(addAssignment_6908,axiom,
    ! [VarCurr: state_type] :
      ( v13728(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13716(VarCurr,B)
      <=> v13718(VarCurr,B) ) ) ).

tff(addAssignment_6906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13718(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_6905,axiom,
    ! [VarCurr: state_type] :
      ( v13706(VarCurr)
    <=> v13708(VarCurr) ) ).

tff(addAssignment_6904,axiom,
    ! [VarCurr: state_type] :
      ( v13708(VarCurr)
    <=> v13710(VarCurr) ) ).

tff(addAssignment_6903,axiom,
    ! [VarCurr: state_type] :
      ( v13710(VarCurr)
    <=> v13712(VarCurr) ) ).

tff(addAssignment_6902,axiom,
    ! [VarCurr: state_type] :
      ( v13712(VarCurr)
    <=> v13714(VarCurr) ) ).

tff(addAssignment_6901,axiom,
    ! [VarCurr: state_type] :
      ( v13714(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6900,axiom,
    ! [VarCurr: state_type] :
      ( v13696(VarCurr)
    <=> v13698(VarCurr) ) ).

tff(addAssignment_6899,axiom,
    ! [VarCurr: state_type] :
      ( v13698(VarCurr)
    <=> v13700(VarCurr) ) ).

tff(addAssignment_6898,axiom,
    ! [VarCurr: state_type] :
      ( v13700(VarCurr)
    <=> v13702(VarCurr) ) ).

tff(addAssignment_6897,axiom,
    ! [VarCurr: state_type] :
      ( v13702(VarCurr)
    <=> v13704(VarCurr) ) ).

tff(addAssignment_6896,axiom,
    ! [VarCurr: state_type] :
      ( v13704(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_6895,axiom,
    ! [VarCurr: state_type] :
      ( v13655(VarCurr)
    <=> v13657(VarCurr) ) ).

tff(addAssignment_6894,axiom,
    ! [VarCurr: state_type] :
      ( v13657(VarCurr)
    <=> v13659(VarCurr) ) ).

tff(addAssignment_6893,axiom,
    ! [VarCurr: state_type] :
      ( v13659(VarCurr)
    <=> v13661(VarCurr) ) ).

tff(addAssignment_6892,axiom,
    ! [VarCurr: state_type] :
      ( v13661(VarCurr)
    <=> v13663(VarCurr) ) ).

tff(addAssignment_6891,axiom,
    ! [VarCurr: state_type] :
      ( v13663(VarCurr)
    <=> v13665(VarCurr) ) ).

tff(addAssignment_6890,axiom,
    ! [VarCurr: state_type] :
      ( v13665(VarCurr)
    <=> v13667(VarCurr) ) ).

tff(addAssignment_6889,axiom,
    ! [VarCurr: state_type] :
      ( v13667(VarCurr)
    <=> v13669(VarCurr) ) ).

tff(writeUnaryOperator_822,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13669(VarCurr)
    <=> v13683(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1153,axiom,
    ! [VarCurr: state_type] :
      ( v13683(VarCurr)
    <=> ( v13684(VarCurr)
        | v13679(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1152,axiom,
    ! [VarCurr: state_type] :
      ( v13684(VarCurr)
    <=> ( v13671(VarCurr)
        | v13675(VarCurr) ) ) ).

tff(addAssignment_6888,axiom,
    ! [VarCurr: state_type] :
      ( v13679(VarCurr)
    <=> v13681(VarCurr) ) ).

tff(addAssignment_6887,axiom,
    ! [VarCurr: state_type] :
      ( v13681(VarCurr)
    <=> v13101(VarCurr,2) ) ).

tff(addAssignment_6886,axiom,
    ! [VarCurr: state_type] :
      ( v13675(VarCurr)
    <=> v13677(VarCurr) ) ).

tff(addAssignment_6885,axiom,
    ! [VarCurr: state_type] :
      ( v13677(VarCurr)
    <=> v13184(VarCurr,1) ) ).

tff(addAssignment_6884,axiom,
    ! [VarCurr: state_type] :
      ( v13184(VarCurr,1)
    <=> v13186(VarCurr,1) ) ).

tff(addAssignment_6883,axiom,
    ! [VarCurr: state_type] :
      ( v13186(VarCurr,1)
    <=> v13188(VarCurr,1) ) ).

tff(addAssignment_6882,axiom,
    ! [VarCurr: state_type] :
      ( v13188(VarCurr,1)
    <=> v13193(VarCurr,1) ) ).

tff(addAssignment_6881,axiom,
    ! [VarCurr: state_type] :
      ( v13190(VarCurr,1)
    <=> v13192(VarCurr,1) ) ).

tff(addAssignment_6880,axiom,
    ! [VarCurr: state_type] :
      ( v13192(VarCurr,1)
    <=> v13101(VarCurr,1) ) ).

tff(addAssignment_6879,axiom,
    ! [VarCurr: state_type] :
      ( v13671(VarCurr)
    <=> v13673(VarCurr) ) ).

tff(addAssignment_6878,axiom,
    ! [VarCurr: state_type] :
      ( v13673(VarCurr)
    <=> v13101(VarCurr,0) ) ).

tff(addAssignment_6877,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13535(VarCurr,B)
      <=> v13537(VarCurr,B) ) ) ).

tff(addAssignment_6876,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13537(VarCurr,B)
      <=> v13539(VarCurr,B) ) ) ).

tff(addAssignment_6875,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13539(VarCurr,B)
      <=> v13541(VarCurr,B) ) ) ).

tff(addAssignment_6874,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13541(VarCurr,B)
      <=> v13543(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_157,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13638(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v13543(VarNext,B)
            <=> v13543(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_157,axiom,
    ! [VarNext: state_type] :
      ( v13638(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13543(VarNext,B)
          <=> v13648(VarNext,B) ) ) ) ).

tff(addAssignment_6873,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13648(VarNext,B)
          <=> v13646(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_116,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13649(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13646(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_116,axiom,
    ! [VarCurr: state_type] :
      ( v13649(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13646(VarCurr,B)
          <=> v13565(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1151,axiom,
    ! [VarCurr: state_type] :
      ( v13649(VarCurr)
    <=> ( v13650(VarCurr)
        & v13651(VarCurr) ) ) ).

tff(writeUnaryOperator_821,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13651(VarCurr)
    <=> v13555(VarCurr) ) ).

tff(writeUnaryOperator_820,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13650(VarCurr)
    <=> v13545(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13638(VarNext)
      <=> v13639(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13639(VarNext)
      <=> ( v13640(VarNext)
          & v13569(VarNext) ) ) ) ).

tff(writeUnaryOperator_819,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13640(VarNext)
      <=> v13642(VarNext) ) ) ).

tff(addAssignment_6872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13642(VarNext)
      <=> v13569(VarCurr) ) ) ).

tff(addAssignment_6871,axiom,
    ! [VarCurr: state_type] :
      ( v13569(VarCurr)
    <=> v13571(VarCurr) ) ).

tff(addAssignment_6870,axiom,
    ! [VarCurr: state_type] :
      ( v13571(VarCurr)
    <=> v13573(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1148,axiom,
    ! [VarCurr: state_type] :
      ( v13573(VarCurr)
    <=> ( v13635(VarCurr)
        | v13631(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1147,axiom,
    ! [VarCurr: state_type] :
      ( v13635(VarCurr)
    <=> ( v13575(VarCurr)
        & v13579(VarCurr) ) ) ).

tff(addAssignment_6869,axiom,
    ! [VarCurr: state_type] :
      ( v13631(VarCurr)
    <=> v13633(VarCurr) ) ).

tff(addAssignment_6868,axiom,
    ! [VarCurr: state_type] :
      ( v13633(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_156,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13615(VarNext)
       => ( v13579(VarNext)
        <=> v13579(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_156,axiom,
    ! [VarNext: state_type] :
      ( v13615(VarNext)
     => ( v13579(VarNext)
      <=> v13625(VarNext) ) ) ).

tff(addAssignment_6867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13625(VarNext)
      <=> v13623(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1146,axiom,
    ! [VarCurr: state_type] :
      ( v13623(VarCurr)
    <=> ( v13626(VarCurr)
        & v13627(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1145,axiom,
    ! [VarCurr: state_type] :
      ( v13627(VarCurr)
    <=> ( v13585(VarCurr)
        | v13610(VarCurr) ) ) ).

tff(writeUnaryOperator_818,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13626(VarCurr)
    <=> v13581(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13615(VarNext)
      <=> v13616(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13616(VarNext)
      <=> ( v13618(VarNext)
          & v13620(VarNext) ) ) ) ).

tff(writeUnaryOperator_817,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13620(VarCurr)
    <=> v13575(VarCurr) ) ).

tff(addAssignment_6866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13618(VarNext)
      <=> v13575(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_45,axiom,
    ( v13579(constB0)
  <=> $true ) ).

tff(addAssignment_6865,axiom,
    ! [VarCurr: state_type] :
      ( v13610(VarCurr)
    <=> v13612(VarCurr) ) ).

tff(addAssignment_6864,axiom,
    ! [VarCurr: state_type] :
      ( v13612(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6863,axiom,
    ! [VarCurr: state_type] :
      ( v13585(VarCurr)
    <=> v13587(VarCurr) ) ).

tff(addAssignment_6862,axiom,
    ! [VarCurr: state_type] :
      ( v13587(VarCurr)
    <=> v13589(VarCurr) ) ).

tff(addAssignment_6861,axiom,
    ! [VarCurr: state_type] :
      ( v13589(VarCurr)
    <=> v13591(VarCurr) ) ).

tff(addAssignment_6860,axiom,
    ! [VarCurr: state_type] :
      ( v13591(VarCurr)
    <=> v13593(VarCurr) ) ).

tff(writeUnaryOperator_816,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13593(VarCurr)
    <=> v13607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1142,axiom,
    ! [VarCurr: state_type] :
      ( v13607(VarCurr)
    <=> ( v13608(VarCurr)
        | v13603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1141,axiom,
    ! [VarCurr: state_type] :
      ( v13608(VarCurr)
    <=> ( v13595(VarCurr)
        | v13599(VarCurr) ) ) ).

tff(addAssignment_6859,axiom,
    ! [VarCurr: state_type] :
      ( v13603(VarCurr)
    <=> v13605(VarCurr) ) ).

tff(addAssignment_6858,axiom,
    ! [VarCurr: state_type] :
      ( v13605(VarCurr)
    <=> v13011(VarCurr,2) ) ).

tff(addAssignment_6857,axiom,
    ! [VarCurr: state_type] :
      ( v13599(VarCurr)
    <=> v13601(VarCurr) ) ).

tff(addAssignment_6856,axiom,
    ! [VarCurr: state_type] :
      ( v13601(VarCurr)
    <=> v13437(VarCurr,1) ) ).

tff(addAssignment_6855,axiom,
    ! [VarCurr: state_type] :
      ( v13437(VarCurr,1)
    <=> v13439(VarCurr,1) ) ).

tff(addAssignment_6854,axiom,
    ! [VarCurr: state_type] :
      ( v13439(VarCurr,1)
    <=> v13441(VarCurr,1) ) ).

tff(addAssignment_6853,axiom,
    ! [VarCurr: state_type] :
      ( v13441(VarCurr,1)
    <=> v13446(VarCurr,1) ) ).

tff(addAssignment_6852,axiom,
    ! [VarCurr: state_type] :
      ( v13443(VarCurr,1)
    <=> v13445(VarCurr,1) ) ).

tff(addAssignment_6851,axiom,
    ! [VarCurr: state_type] :
      ( v13445(VarCurr,1)
    <=> v13011(VarCurr,1) ) ).

tff(addAssignment_6850,axiom,
    ! [VarCurr: state_type] :
      ( v13595(VarCurr)
    <=> v13597(VarCurr) ) ).

tff(addAssignment_6849,axiom,
    ! [VarCurr: state_type] :
      ( v13597(VarCurr)
    <=> v13011(VarCurr,0) ) ).

tff(addAssignment_6848,axiom,
    ! [VarCurr: state_type] :
      ( v13581(VarCurr)
    <=> v13583(VarCurr) ) ).

tff(addAssignment_6847,axiom,
    ! [VarCurr: state_type] :
      ( v13583(VarCurr)
    <=> $false ) ).

tff(addAssignment_6846,axiom,
    ! [VarCurr: state_type] :
      ( v13575(VarCurr)
    <=> v13577(VarCurr) ) ).

tff(addAssignment_6845,axiom,
    ! [VarCurr: state_type] :
      ( v13577(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6844,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13565(VarCurr,B)
      <=> v13567(VarCurr,B) ) ) ).

tff(addAssignment_6843,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13567(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_6842,axiom,
    ! [VarCurr: state_type] :
      ( v13555(VarCurr)
    <=> v13557(VarCurr) ) ).

tff(addAssignment_6841,axiom,
    ! [VarCurr: state_type] :
      ( v13557(VarCurr)
    <=> v13559(VarCurr) ) ).

tff(addAssignment_6840,axiom,
    ! [VarCurr: state_type] :
      ( v13559(VarCurr)
    <=> v13561(VarCurr) ) ).

tff(addAssignment_6839,axiom,
    ! [VarCurr: state_type] :
      ( v13561(VarCurr)
    <=> v13563(VarCurr) ) ).

tff(addAssignment_6838,axiom,
    ! [VarCurr: state_type] :
      ( v13563(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6837,axiom,
    ! [VarCurr: state_type] :
      ( v13545(VarCurr)
    <=> v13547(VarCurr) ) ).

tff(addAssignment_6836,axiom,
    ! [VarCurr: state_type] :
      ( v13547(VarCurr)
    <=> v13549(VarCurr) ) ).

tff(addAssignment_6835,axiom,
    ! [VarCurr: state_type] :
      ( v13549(VarCurr)
    <=> v13551(VarCurr) ) ).

tff(addAssignment_6834,axiom,
    ! [VarCurr: state_type] :
      ( v13551(VarCurr)
    <=> v13553(VarCurr) ) ).

tff(addAssignment_6833,axiom,
    ! [VarCurr: state_type] :
      ( v13553(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_6832,axiom,
    ! [VarCurr: state_type] :
      ( v13504(VarCurr)
    <=> v13506(VarCurr) ) ).

tff(addAssignment_6831,axiom,
    ! [VarCurr: state_type] :
      ( v13506(VarCurr)
    <=> v13508(VarCurr) ) ).

tff(addAssignment_6830,axiom,
    ! [VarCurr: state_type] :
      ( v13508(VarCurr)
    <=> v13510(VarCurr) ) ).

tff(addAssignment_6829,axiom,
    ! [VarCurr: state_type] :
      ( v13510(VarCurr)
    <=> v13512(VarCurr) ) ).

tff(addAssignment_6828,axiom,
    ! [VarCurr: state_type] :
      ( v13512(VarCurr)
    <=> v13514(VarCurr) ) ).

tff(addAssignment_6827,axiom,
    ! [VarCurr: state_type] :
      ( v13514(VarCurr)
    <=> v13516(VarCurr) ) ).

tff(addAssignment_6826,axiom,
    ! [VarCurr: state_type] :
      ( v13516(VarCurr)
    <=> v13518(VarCurr) ) ).

tff(writeUnaryOperator_815,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13518(VarCurr)
    <=> v13532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1140,axiom,
    ! [VarCurr: state_type] :
      ( v13532(VarCurr)
    <=> ( v13533(VarCurr)
        | v13528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1139,axiom,
    ! [VarCurr: state_type] :
      ( v13533(VarCurr)
    <=> ( v13520(VarCurr)
        | v13524(VarCurr) ) ) ).

tff(addAssignment_6825,axiom,
    ! [VarCurr: state_type] :
      ( v13528(VarCurr)
    <=> v13530(VarCurr) ) ).

tff(addAssignment_6824,axiom,
    ! [VarCurr: state_type] :
      ( v13530(VarCurr)
    <=> v13101(VarCurr,2) ) ).

tff(addAssignment_6823,axiom,
    ! [VarCurr: state_type] :
      ( v13524(VarCurr)
    <=> v13526(VarCurr) ) ).

tff(addAssignment_6822,axiom,
    ! [VarCurr: state_type] :
      ( v13526(VarCurr)
    <=> v13101(VarCurr,1) ) ).

tff(addAssignment_6821,axiom,
    ! [VarCurr: state_type] :
      ( v13520(VarCurr)
    <=> v13522(VarCurr) ) ).

tff(addAssignment_6820,axiom,
    ! [VarCurr: state_type] :
      ( v13522(VarCurr)
    <=> v13184(VarCurr,0) ) ).

tff(addAssignment_6819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13373(VarCurr,B)
      <=> v13375(VarCurr,B) ) ) ).

tff(addAssignment_6818,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13375(VarCurr,B)
      <=> v13377(VarCurr,B) ) ) ).

tff(addAssignment_6817,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13377(VarCurr,B)
      <=> v13379(VarCurr,B) ) ) ).

tff(addAssignment_6816,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13379(VarCurr,B)
      <=> v13381(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13487(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v13381(VarNext,B)
            <=> v13381(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_155,axiom,
    ! [VarNext: state_type] :
      ( v13487(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13381(VarNext,B)
          <=> v13497(VarNext,B) ) ) ) ).

tff(addAssignment_6815,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13497(VarNext,B)
          <=> v13495(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13498(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13495(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_115,axiom,
    ! [VarCurr: state_type] :
      ( v13498(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13495(VarCurr,B)
          <=> v13403(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1138,axiom,
    ! [VarCurr: state_type] :
      ( v13498(VarCurr)
    <=> ( v13499(VarCurr)
        & v13500(VarCurr) ) ) ).

tff(writeUnaryOperator_814,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13500(VarCurr)
    <=> v13393(VarCurr) ) ).

tff(writeUnaryOperator_813,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13499(VarCurr)
    <=> v13383(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13487(VarNext)
      <=> v13488(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13488(VarNext)
      <=> ( v13489(VarNext)
          & v13407(VarNext) ) ) ) ).

tff(writeUnaryOperator_812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13489(VarNext)
      <=> v13491(VarNext) ) ) ).

tff(addAssignment_6814,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13491(VarNext)
      <=> v13407(VarCurr) ) ) ).

tff(addAssignment_6813,axiom,
    ! [VarCurr: state_type] :
      ( v13407(VarCurr)
    <=> v13409(VarCurr) ) ).

tff(addAssignment_6812,axiom,
    ! [VarCurr: state_type] :
      ( v13409(VarCurr)
    <=> v13411(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1135,axiom,
    ! [VarCurr: state_type] :
      ( v13411(VarCurr)
    <=> ( v13484(VarCurr)
        | v13480(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1134,axiom,
    ! [VarCurr: state_type] :
      ( v13484(VarCurr)
    <=> ( v13413(VarCurr)
        & v13417(VarCurr) ) ) ).

tff(addAssignment_6811,axiom,
    ! [VarCurr: state_type] :
      ( v13480(VarCurr)
    <=> v13482(VarCurr) ) ).

tff(addAssignment_6810,axiom,
    ! [VarCurr: state_type] :
      ( v13482(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_154,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13464(VarNext)
       => ( v13417(VarNext)
        <=> v13417(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_154,axiom,
    ! [VarNext: state_type] :
      ( v13464(VarNext)
     => ( v13417(VarNext)
      <=> v13474(VarNext) ) ) ).

tff(addAssignment_6809,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13474(VarNext)
      <=> v13472(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1133,axiom,
    ! [VarCurr: state_type] :
      ( v13472(VarCurr)
    <=> ( v13475(VarCurr)
        & v13476(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1132,axiom,
    ! [VarCurr: state_type] :
      ( v13476(VarCurr)
    <=> ( v13423(VarCurr)
        | v13459(VarCurr) ) ) ).

tff(writeUnaryOperator_811,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13475(VarCurr)
    <=> v13419(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13464(VarNext)
      <=> v13465(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13465(VarNext)
      <=> ( v13467(VarNext)
          & v13469(VarNext) ) ) ) ).

tff(writeUnaryOperator_810,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13469(VarCurr)
    <=> v13413(VarCurr) ) ).

tff(addAssignment_6808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13467(VarNext)
      <=> v13413(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_44,axiom,
    ( v13417(constB0)
  <=> $true ) ).

tff(addAssignment_6807,axiom,
    ! [VarCurr: state_type] :
      ( v13459(VarCurr)
    <=> v13461(VarCurr) ) ).

tff(addAssignment_6806,axiom,
    ! [VarCurr: state_type] :
      ( v13461(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6805,axiom,
    ! [VarCurr: state_type] :
      ( v13423(VarCurr)
    <=> v13425(VarCurr) ) ).

tff(addAssignment_6804,axiom,
    ! [VarCurr: state_type] :
      ( v13425(VarCurr)
    <=> v13427(VarCurr) ) ).

tff(addAssignment_6803,axiom,
    ! [VarCurr: state_type] :
      ( v13427(VarCurr)
    <=> v13429(VarCurr) ) ).

tff(addAssignment_6802,axiom,
    ! [VarCurr: state_type] :
      ( v13429(VarCurr)
    <=> v13431(VarCurr) ) ).

tff(writeUnaryOperator_809,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13431(VarCurr)
    <=> v13456(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1129,axiom,
    ! [VarCurr: state_type] :
      ( v13456(VarCurr)
    <=> ( v13457(VarCurr)
        | v13452(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1128,axiom,
    ! [VarCurr: state_type] :
      ( v13457(VarCurr)
    <=> ( v13433(VarCurr)
        | v13448(VarCurr) ) ) ).

tff(addAssignment_6801,axiom,
    ! [VarCurr: state_type] :
      ( v13452(VarCurr)
    <=> v13454(VarCurr) ) ).

tff(addAssignment_6800,axiom,
    ! [VarCurr: state_type] :
      ( v13454(VarCurr)
    <=> v13011(VarCurr,2) ) ).

tff(addAssignment_6799,axiom,
    ! [VarCurr: state_type] :
      ( v13448(VarCurr)
    <=> v13450(VarCurr) ) ).

tff(addAssignment_6798,axiom,
    ! [VarCurr: state_type] :
      ( v13450(VarCurr)
    <=> v13011(VarCurr,1) ) ).

tff(addAssignment_6797,axiom,
    ! [VarCurr: state_type] :
      ( v13433(VarCurr)
    <=> v13435(VarCurr) ) ).

tff(addAssignment_6796,axiom,
    ! [VarCurr: state_type] :
      ( v13435(VarCurr)
    <=> v13437(VarCurr,0) ) ).

tff(addAssignment_6795,axiom,
    ! [VarCurr: state_type] :
      ( v13437(VarCurr,0)
    <=> v13439(VarCurr,0) ) ).

tff(addAssignment_6794,axiom,
    ! [VarCurr: state_type] :
      ( v13439(VarCurr,0)
    <=> v13441(VarCurr,0) ) ).

tff(addAssignment_6793,axiom,
    ! [VarCurr: state_type] :
      ( v13441(VarCurr,0)
    <=> v13446(VarCurr,0) ) ).

tff(writeUnaryOperator_808,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v13446(VarCurr,B)
      <=> ~ v13443(VarCurr,B) ) ) ).

tff(addAssignment_6792,axiom,
    ! [VarCurr: state_type] :
      ( v13443(VarCurr,0)
    <=> v13445(VarCurr,0) ) ).

tff(addAssignment_6791,axiom,
    ! [VarCurr: state_type] :
      ( v13445(VarCurr,0)
    <=> v13011(VarCurr,0) ) ).

tff(addAssignment_6790,axiom,
    ! [VarCurr: state_type] :
      ( v13419(VarCurr)
    <=> v13421(VarCurr) ) ).

tff(addAssignment_6789,axiom,
    ! [VarCurr: state_type] :
      ( v13421(VarCurr)
    <=> $false ) ).

tff(addAssignment_6788,axiom,
    ! [VarCurr: state_type] :
      ( v13413(VarCurr)
    <=> v13415(VarCurr) ) ).

tff(addAssignment_6787,axiom,
    ! [VarCurr: state_type] :
      ( v13415(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6786,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13403(VarCurr,B)
      <=> v13405(VarCurr,B) ) ) ).

tff(addAssignment_6785,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v13405(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_6784,axiom,
    ! [VarCurr: state_type] :
      ( v13393(VarCurr)
    <=> v13395(VarCurr) ) ).

tff(addAssignment_6783,axiom,
    ! [VarCurr: state_type] :
      ( v13395(VarCurr)
    <=> v13397(VarCurr) ) ).

tff(addAssignment_6782,axiom,
    ! [VarCurr: state_type] :
      ( v13397(VarCurr)
    <=> v13399(VarCurr) ) ).

tff(addAssignment_6781,axiom,
    ! [VarCurr: state_type] :
      ( v13399(VarCurr)
    <=> v13401(VarCurr) ) ).

tff(addAssignment_6780,axiom,
    ! [VarCurr: state_type] :
      ( v13401(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6779,axiom,
    ! [VarCurr: state_type] :
      ( v13383(VarCurr)
    <=> v13385(VarCurr) ) ).

tff(addAssignment_6778,axiom,
    ! [VarCurr: state_type] :
      ( v13385(VarCurr)
    <=> v13387(VarCurr) ) ).

tff(addAssignment_6777,axiom,
    ! [VarCurr: state_type] :
      ( v13387(VarCurr)
    <=> v13389(VarCurr) ) ).

tff(addAssignment_6776,axiom,
    ! [VarCurr: state_type] :
      ( v13389(VarCurr)
    <=> v13391(VarCurr) ) ).

tff(addAssignment_6775,axiom,
    ! [VarCurr: state_type] :
      ( v13391(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_6774,axiom,
    ! [VarCurr: state_type] :
      ( v13081(VarCurr)
    <=> v13083(VarCurr) ) ).

tff(addAssignment_6773,axiom,
    ! [VarCurr: state_type] :
      ( v13083(VarCurr)
    <=> v13085(VarCurr) ) ).

tff(addAssignment_6772,axiom,
    ! [VarCurr: state_type] :
      ( v13085(VarCurr)
    <=> v13087(VarCurr) ) ).

tff(addAssignment_6771,axiom,
    ! [VarCurr: state_type] :
      ( v13087(VarCurr)
    <=> v13089(VarCurr) ) ).

tff(addAssignment_6770,axiom,
    ! [VarCurr: state_type] :
      ( v13089(VarCurr)
    <=> v13091(VarCurr) ) ).

tff(addAssignment_6769,axiom,
    ! [VarCurr: state_type] :
      ( v13091(VarCurr)
    <=> v13093(VarCurr) ) ).

tff(addAssignment_6768,axiom,
    ! [VarCurr: state_type] :
      ( v13093(VarCurr)
    <=> v13095(VarCurr) ) ).

tff(writeUnaryOperator_807,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13095(VarCurr)
    <=> v13370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1127,axiom,
    ! [VarCurr: state_type] :
      ( v13370(VarCurr)
    <=> ( v13371(VarCurr)
        | v13366(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1126,axiom,
    ! [VarCurr: state_type] :
      ( v13371(VarCurr)
    <=> ( v13097(VarCurr)
        | v13362(VarCurr) ) ) ).

tff(addAssignment_6767,axiom,
    ! [VarCurr: state_type] :
      ( v13366(VarCurr)
    <=> v13368(VarCurr) ) ).

tff(addAssignment_6766,axiom,
    ! [VarCurr: state_type] :
      ( v13368(VarCurr)
    <=> v13101(VarCurr,2) ) ).

tff(addAssignment_6765,axiom,
    ! [VarCurr: state_type] :
      ( v13362(VarCurr)
    <=> v13364(VarCurr) ) ).

tff(addAssignment_6764,axiom,
    ! [VarCurr: state_type] :
      ( v13364(VarCurr)
    <=> v13101(VarCurr,1) ) ).

tff(addAssignment_6763,axiom,
    ! [VarCurr: state_type] :
      ( v13097(VarCurr)
    <=> v13099(VarCurr) ) ).

tff(addAssignment_6762,axiom,
    ! [VarCurr: state_type] :
      ( v13099(VarCurr)
    <=> v13101(VarCurr,0) ) ).

tff(addAssignment_6761,axiom,
    ! [VarCurr: state_type] :
      ( v13101(VarCurr,0)
    <=> v13013(VarCurr,3) ) ).

tff(addAssignment_6760,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,3)
    <=> v13015(VarCurr,3) ) ).

tff(addAssignment_6759,axiom,
    ! [VarNext: state_type] :
      ( v13015(VarNext,3)
    <=> v13354(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_153,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13355(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v13354(VarNext,B)
            <=> v13015(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_153,axiom,
    ! [VarNext: state_type] :
      ( v13355(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13354(VarNext,B)
          <=> v13326(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13355(VarNext)
      <=> v13356(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13356(VarNext)
      <=> ( v13358(VarNext)
          & v13268(VarNext) ) ) ) ).

tff(writeUnaryOperator_806,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13358(VarNext)
      <=> v13320(VarNext) ) ) ).

tff(addAssignment_6758,axiom,
    ! [VarCurr: state_type] :
      ( v13125(VarCurr,3)
    <=> v13127(VarCurr,3) ) ).

tff(addAssignment_6757,axiom,
    ! [VarCurr: state_type] :
      ( v13127(VarCurr,3)
    <=> v13265(VarCurr,3) ) ).

tff(addAssignment_6756,axiom,
    ! [VarCurr: state_type] :
      ( v13129(VarCurr,0)
    <=> v13131(VarCurr,0) ) ).

tff(addAssignment_6755,axiom,
    ! [VarCurr: state_type] :
      ( v13131(VarCurr,0)
    <=> v13133(VarCurr,0) ) ).

tff(addAssignment_6754,axiom,
    ! [VarCurr: state_type] :
      ( v13133(VarCurr,0)
    <=> v13264(VarCurr,0) ) ).

tff(addAssignment_6753,axiom,
    ! [VarCurr: state_type] :
      ( v13201(VarCurr,0)
    <=> v13203(VarCurr,0) ) ).

tff(addAssignment_6752,axiom,
    ! [VarCurr: state_type] :
      ( v13203(VarCurr,0)
    <=> v13205(VarCurr,0) ) ).

tff(addAssignment_6751,axiom,
    ! [VarCurr: state_type] :
      ( v13205(VarCurr,0)
    <=> v13207(VarCurr,0) ) ).

tff(addAssignment_6750,axiom,
    ! [VarCurr: state_type] :
      ( v13207(VarCurr,0)
    <=> v13209(VarCurr,0) ) ).

tff(addAssignment_6749,axiom,
    ! [VarCurr: state_type] :
      ( v13209(VarCurr,0)
    <=> v13219(VarCurr,0) ) ).

tff(addAssignment_6748,axiom,
    ! [VarCurr: state_type] :
      ( v13135(VarCurr,0)
    <=> v13137(VarCurr,0) ) ).

tff(addAssignment_6747,axiom,
    ! [VarCurr: state_type] :
      ( v13137(VarCurr,0)
    <=> v13198(VarCurr,0) ) ).

tff(addAssignment_6746,axiom,
    ! [VarCurr: state_type] :
      ( v13139(VarCurr)
    <=> v12665(VarCurr,2) ) ).

tff(addAssignment_6745,axiom,
    ! [VarCurr: state_type] :
      ( v12665(VarCurr,2)
    <=> v12667(VarCurr,2) ) ).

tff(addAssignment_6744,axiom,
    ! [VarCurr: state_type] :
      ( v12667(VarCurr,2)
    <=> v12677(VarCurr,2) ) ).

tff(addAssignment_6743,axiom,
    ! [VarCurr: state_type] :
      ( v12669(VarCurr,2)
    <=> v12671(VarCurr,2) ) ).

tff(addAssignment_6742,axiom,
    ! [VarCurr: state_type] :
      ( v12671(VarCurr,2)
    <=> v12674(VarCurr,2) ) ).

tff(addAssignment_6741,axiom,
    ! [VarCurr: state_type] :
      ( v12675(VarCurr)
    <=> v13142(VarCurr,1) ) ).

tff(addAssignment_6740,axiom,
    ! [VarCurr: state_type] :
      ( v13142(VarCurr,1)
    <=> v13144(VarCurr,1) ) ).

tff(addAssignment_6739,axiom,
    ! [VarCurr: state_type] :
      ( v13144(VarCurr,1)
    <=> v13352(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_232,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v13352(VarCurr,B)
      <=> ( v13146(VarCurr,B)
          | v13152(VarCurr,B) ) ) ) ).

tff(addAssignment_6738,axiom,
    ! [VarCurr: state_type] :
      ( v13152(VarCurr,1)
    <=> v13154(VarCurr,1) ) ).

tff(addAssignment_6737,axiom,
    ! [VarCurr: state_type] :
      ( v13154(VarCurr,1)
    <=> v13350(VarCurr,1) ) ).

tff(addAssignment_6736,axiom,
    ! [VarCurr: state_type] :
      ( v13350(VarCurr,0)
    <=> v13351(VarCurr) ) ).

tff(addAssignment_6735,axiom,
    ! [VarCurr: state_type] :
      ( v13350(VarCurr,1)
    <=> v13156(VarCurr) ) ).

tff(addAssignment_6734,axiom,
    ! [VarCurr: state_type] :
      ( v13156(VarCurr)
    <=> v13158(VarCurr,1) ) ).

tff(addAssignment_6733,axiom,
    ! [VarCurr: state_type] :
      ( v13158(VarCurr,1)
    <=> v13160(VarCurr,1) ) ).

tff(addAssignment_6732,axiom,
    ! [VarCurr: state_type] :
      ( v13160(VarCurr,1)
    <=> v13349(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_231,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v13349(VarCurr,B)
      <=> ( v13162(VarCurr,B)
          & v13170(VarCurr,B) ) ) ) ).

tff(addAssignment_6731,axiom,
    ! [VarCurr: state_type] :
      ( v13170(VarCurr,1)
    <=> v13172(VarCurr,1) ) ).

tff(addAssignment_6730,axiom,
    ! [VarCurr: state_type] :
      ( v13172(VarCurr,1)
    <=> v13347(VarCurr,1) ) ).

tff(addAssignment_6729,axiom,
    ! [VarCurr: state_type] :
      ( v13347(VarCurr,0)
    <=> v13348(VarCurr) ) ).

tff(addAssignment_6728,axiom,
    ! [VarCurr: state_type] :
      ( v13347(VarCurr,1)
    <=> v13174(VarCurr) ) ).

tff(addAssignment_6727,axiom,
    ! [VarCurr: state_type] :
      ( v13174(VarCurr)
    <=> v13176(VarCurr) ) ).

tff(addAssignment_6726,axiom,
    ! [VarCurr: state_type] :
      ( v13176(VarCurr)
    <=> v13178(VarCurr) ) ).

tff(writeUnaryOperator_805,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13178(VarCurr)
    <=> v13345(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1123,axiom,
    ! [VarCurr: state_type] :
      ( v13345(VarCurr)
    <=> ( v13346(VarCurr)
        | v13333(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1122,axiom,
    ! [VarCurr: state_type] :
      ( v13346(VarCurr)
    <=> ( v13180(VarCurr)
        | v13195(VarCurr) ) ) ).

tff(addAssignment_6725,axiom,
    ! [VarCurr: state_type] :
      ( v13333(VarCurr)
    <=> v13335(VarCurr) ) ).

tff(addAssignment_6724,axiom,
    ! [VarCurr: state_type] :
      ( v13335(VarCurr)
    <=> v13184(VarCurr,2) ) ).

tff(addAssignment_6723,axiom,
    ! [VarCurr: state_type] :
      ( v13184(VarCurr,2)
    <=> v13186(VarCurr,2) ) ).

tff(addAssignment_6722,axiom,
    ! [VarCurr: state_type] :
      ( v13186(VarCurr,2)
    <=> v13188(VarCurr,2) ) ).

tff(addAssignment_6721,axiom,
    ! [VarCurr: state_type] :
      ( v13188(VarCurr,2)
    <=> v13193(VarCurr,2) ) ).

tff(addAssignment_6720,axiom,
    ! [VarCurr: state_type] :
      ( v13190(VarCurr,2)
    <=> v13192(VarCurr,2) ) ).

tff(addAssignment_6719,axiom,
    ! [VarCurr: state_type] :
      ( v13192(VarCurr,2)
    <=> v13101(VarCurr,2) ) ).

tff(addAssignment_6718,axiom,
    ! [VarCurr: state_type] :
      ( v13101(VarCurr,2)
    <=> v13013(VarCurr,5) ) ).

tff(addAssignment_6717,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,5)
    <=> v13015(VarCurr,5) ) ).

tff(addAssignment_6716,axiom,
    ! [VarNext: state_type] :
      ( v13015(VarNext,5)
    <=> v13337(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_152,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13338(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v13337(VarNext,B)
            <=> v13015(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_152,axiom,
    ! [VarNext: state_type] :
      ( v13338(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13337(VarNext,B)
          <=> v13326(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13338(VarNext)
      <=> v13339(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13339(VarNext)
      <=> ( v13341(VarNext)
          & v13268(VarNext) ) ) ) ).

tff(writeUnaryOperator_804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13341(VarNext)
      <=> v13320(VarNext) ) ) ).

tff(addAssignment_6715,axiom,
    ! [VarCurr: state_type] :
      ( v13125(VarCurr,5)
    <=> v13127(VarCurr,5) ) ).

tff(addAssignment_6714,axiom,
    ! [VarCurr: state_type] :
      ( v13127(VarCurr,5)
    <=> v13265(VarCurr,5) ) ).

tff(addAssignment_6713,axiom,
    ! [VarCurr: state_type] :
      ( v13129(VarCurr,2)
    <=> v13131(VarCurr,2) ) ).

tff(addAssignment_6712,axiom,
    ! [VarCurr: state_type] :
      ( v13131(VarCurr,2)
    <=> v13133(VarCurr,2) ) ).

tff(addAssignment_6711,axiom,
    ! [VarCurr: state_type] :
      ( v13133(VarCurr,2)
    <=> v13264(VarCurr,2) ) ).

tff(addAssignment_6710,axiom,
    ! [VarCurr: state_type] :
      ( v13201(VarCurr,2)
    <=> v13203(VarCurr,2) ) ).

tff(addAssignment_6709,axiom,
    ! [VarCurr: state_type] :
      ( v13203(VarCurr,2)
    <=> v13205(VarCurr,2) ) ).

tff(addAssignment_6708,axiom,
    ! [VarCurr: state_type] :
      ( v13205(VarCurr,2)
    <=> v13207(VarCurr,2) ) ).

tff(addAssignment_6707,axiom,
    ! [VarCurr: state_type] :
      ( v13207(VarCurr,2)
    <=> v13209(VarCurr,2) ) ).

tff(addAssignment_6706,axiom,
    ! [VarCurr: state_type] :
      ( v13209(VarCurr,2)
    <=> v13219(VarCurr,2) ) ).

tff(addAssignment_6705,axiom,
    ! [VarCurr: state_type] :
      ( v13211(VarCurr,2)
    <=> v13213(VarCurr,2) ) ).

tff(addAssignment_6704,axiom,
    ! [VarCurr: state_type] :
      ( v13213(VarCurr,2)
    <=> v13214(VarCurr,2) ) ).

tff(addAssignment_6703,axiom,
    ! [VarCurr: state_type] :
      ( v13135(VarCurr,2)
    <=> v13137(VarCurr,2) ) ).

tff(addAssignment_6702,axiom,
    ! [VarCurr: state_type] :
      ( v13137(VarCurr,2)
    <=> v13198(VarCurr,2) ) ).

tff(addAssignment_6701,axiom,
    ! [VarCurr: state_type] :
      ( v13195(VarCurr)
    <=> v13197(VarCurr) ) ).

tff(addAssignment_6700,axiom,
    ! [VarCurr: state_type] :
      ( v13197(VarCurr)
    <=> v13101(VarCurr,1) ) ).

tff(addAssignment_6699,axiom,
    ! [VarCurr: state_type] :
      ( v13101(VarCurr,1)
    <=> v13013(VarCurr,4) ) ).

tff(addAssignment_6698,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,4)
    <=> v13015(VarCurr,4) ) ).

tff(addAssignment_6697,axiom,
    ! [VarNext: state_type] :
      ( v13015(VarNext,4)
    <=> v13315(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_151,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13316(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v13315(VarNext,B)
            <=> v13015(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_151,axiom,
    ! [VarNext: state_type] :
      ( v13316(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13315(VarNext,B)
          <=> v13326(VarNext,B) ) ) ) ).

tff(addAssignment_6696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13326(VarNext,B)
          <=> v13324(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13324(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_114,axiom,
    ! [VarCurr: state_type] :
      ( v13327(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v13324(VarCurr,B)
          <=> v13125(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1119,axiom,
    ! [VarCurr: state_type] :
      ( v13327(VarCurr)
    <=> ( v13328(VarCurr)
        & v13329(VarCurr) ) ) ).

tff(writeUnaryOperator_803,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13329(VarCurr)
    <=> v13115(VarCurr) ) ).

tff(writeUnaryOperator_802,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13328(VarCurr)
    <=> v13103(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13316(VarNext)
      <=> v13317(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13317(VarNext)
      <=> ( v13318(VarNext)
          & v13268(VarNext) ) ) ) ).

tff(writeUnaryOperator_801,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13318(VarNext)
      <=> v13320(VarNext) ) ) ).

tff(addAssignment_6695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13320(VarNext)
      <=> v13268(VarCurr) ) ) ).

tff(addAssignment_6694,axiom,
    ! [VarCurr: state_type] :
      ( v13268(VarCurr)
    <=> v13270(VarCurr) ) ).

tff(addAssignment_6693,axiom,
    ! [VarCurr: state_type] :
      ( v13270(VarCurr)
    <=> v13272(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1116,axiom,
    ! [VarCurr: state_type] :
      ( v13272(VarCurr)
    <=> ( v13313(VarCurr)
        | v13309(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1115,axiom,
    ! [VarCurr: state_type] :
      ( v13313(VarCurr)
    <=> ( v13274(VarCurr)
        & v13278(VarCurr) ) ) ).

tff(addAssignment_6692,axiom,
    ! [VarCurr: state_type] :
      ( v13309(VarCurr)
    <=> v13311(VarCurr) ) ).

tff(addAssignment_6691,axiom,
    ! [VarCurr: state_type] :
      ( v13311(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_150,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13293(VarNext)
       => ( v13278(VarNext)
        <=> v13278(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_150,axiom,
    ! [VarNext: state_type] :
      ( v13293(VarNext)
     => ( v13278(VarNext)
      <=> v13303(VarNext) ) ) ).

tff(addAssignment_6690,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13303(VarNext)
      <=> v13301(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1114,axiom,
    ! [VarCurr: state_type] :
      ( v13301(VarCurr)
    <=> ( v13304(VarCurr)
        & v13305(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1113,axiom,
    ! [VarCurr: state_type] :
      ( v13305(VarCurr)
    <=> ( v13284(VarCurr)
        | v13288(VarCurr) ) ) ).

tff(writeUnaryOperator_800,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13304(VarCurr)
    <=> v13280(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13293(VarNext)
      <=> v13294(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13294(VarNext)
      <=> ( v13296(VarNext)
          & v13298(VarNext) ) ) ) ).

tff(writeUnaryOperator_799,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13298(VarCurr)
    <=> v13274(VarCurr) ) ).

tff(addAssignment_6689,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13296(VarNext)
      <=> v13274(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_43,axiom,
    ( v13278(constB0)
  <=> $true ) ).

tff(addAssignment_6688,axiom,
    ! [VarCurr: state_type] :
      ( v13288(VarCurr)
    <=> v13290(VarCurr) ) ).

tff(addAssignment_6687,axiom,
    ! [VarCurr: state_type] :
      ( v13290(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6686,axiom,
    ! [VarCurr: state_type] :
      ( v13284(VarCurr)
    <=> v13286(VarCurr) ) ).

tff(addAssignment_6685,axiom,
    ! [VarCurr: state_type] :
      ( v13286(VarCurr)
    <=> $true ) ).

tff(addAssignment_6684,axiom,
    ! [VarCurr: state_type] :
      ( v13280(VarCurr)
    <=> v13282(VarCurr) ) ).

tff(addAssignment_6683,axiom,
    ! [VarCurr: state_type] :
      ( v13282(VarCurr)
    <=> $false ) ).

tff(addAssignment_6682,axiom,
    ! [VarCurr: state_type] :
      ( v13274(VarCurr)
    <=> v13276(VarCurr) ) ).

tff(addAssignment_6681,axiom,
    ! [VarCurr: state_type] :
      ( v13276(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6680,axiom,
    ! [VarCurr: state_type] :
      ( v13125(VarCurr,4)
    <=> v13127(VarCurr,4) ) ).

tff(addAssignment_6679,axiom,
    ! [VarCurr: state_type] :
      ( v13127(VarCurr,4)
    <=> v13265(VarCurr,4) ) ).

tff(addAssignment_6678,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v13265(VarCurr,B)
      <=> v13266(VarCurr,B) ) ) ).

tff(addAssignment_6677,axiom,
    ! [VarCurr: state_type] :
      ( ( v13265(VarCurr,5)
      <=> v13129(VarCurr,2) )
      & ( v13265(VarCurr,4)
      <=> v13129(VarCurr,1) )
      & ( v13265(VarCurr,3)
      <=> v13129(VarCurr,0) ) ) ).

tff(addAssignment_6676,axiom,
    ! [VarCurr: state_type] :
      ( v13129(VarCurr,1)
    <=> v13131(VarCurr,1) ) ).

tff(addAssignment_6675,axiom,
    ! [VarCurr: state_type] :
      ( v13131(VarCurr,1)
    <=> v13133(VarCurr,1) ) ).

tff(addAssignment_6674,axiom,
    ! [VarCurr: state_type] :
      ( v13133(VarCurr,1)
    <=> v13264(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v13264(VarCurr,B)
      <=> ( v13135(VarCurr,B)
          & v13201(VarCurr,B) ) ) ) ).

tff(addAssignment_6673,axiom,
    ! [VarCurr: state_type] :
      ( v13201(VarCurr,1)
    <=> v13203(VarCurr,1) ) ).

tff(addAssignment_6672,axiom,
    ! [VarCurr: state_type] :
      ( v13203(VarCurr,1)
    <=> v13205(VarCurr,1) ) ).

tff(addAssignment_6671,axiom,
    ! [VarCurr: state_type] :
      ( v13205(VarCurr,1)
    <=> v13207(VarCurr,1) ) ).

tff(addAssignment_6670,axiom,
    ! [VarCurr: state_type] :
      ( v13207(VarCurr,1)
    <=> v13209(VarCurr,1) ) ).

tff(addAssignment_6669,axiom,
    ! [VarCurr: state_type] :
      ( v13209(VarCurr,1)
    <=> v13219(VarCurr,1) ) ).

tff(addAssignment_6668,axiom,
    ! [VarCurr: state_type] :
      ( v13219(VarCurr,0)
    <=> v13259(VarCurr) ) ).

tff(addAssignment_6667,axiom,
    ! [VarCurr: state_type] :
      ( v13219(VarCurr,1)
    <=> v13254(VarCurr) ) ).

tff(addAssignment_6666,axiom,
    ! [VarCurr: state_type] :
      ( v13219(VarCurr,2)
    <=> v13249(VarCurr) ) ).

tff(addAssignment_6665,axiom,
    ! [VarCurr: state_type] :
      ( v13219(VarCurr,3)
    <=> v13221(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1110,axiom,
    ! [VarCurr: state_type] :
      ( v13259(VarCurr)
    <=> ( v13260(VarCurr)
        & v13263(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1109,axiom,
    ! [VarCurr: state_type] :
      ( v13263(VarCurr)
    <=> ( v13211(VarCurr,0)
        | v13229(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1108,axiom,
    ! [VarCurr: state_type] :
      ( v13260(VarCurr)
    <=> ( v13261(VarCurr)
        | v13262(VarCurr) ) ) ).

tff(writeUnaryOperator_798,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13262(VarCurr)
    <=> v13229(VarCurr,0) ) ).

tff(writeUnaryOperator_797,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13261(VarCurr)
    <=> v13211(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1107,axiom,
    ! [VarCurr: state_type] :
      ( v13254(VarCurr)
    <=> ( v13255(VarCurr)
        & v13258(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1106,axiom,
    ! [VarCurr: state_type] :
      ( v13258(VarCurr)
    <=> ( v13228(VarCurr)
        | v13230(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1105,axiom,
    ! [VarCurr: state_type] :
      ( v13255(VarCurr)
    <=> ( v13256(VarCurr)
        | v13257(VarCurr) ) ) ).

tff(writeUnaryOperator_796,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13257(VarCurr)
    <=> v13230(VarCurr) ) ).

tff(writeUnaryOperator_795,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13256(VarCurr)
    <=> v13228(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1104,axiom,
    ! [VarCurr: state_type] :
      ( v13249(VarCurr)
    <=> ( v13250(VarCurr)
        & v13253(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1103,axiom,
    ! [VarCurr: state_type] :
      ( v13253(VarCurr)
    <=> ( v13226(VarCurr)
        | v13236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1102,axiom,
    ! [VarCurr: state_type] :
      ( v13250(VarCurr)
    <=> ( v13251(VarCurr)
        | v13252(VarCurr) ) ) ).

tff(writeUnaryOperator_794,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13252(VarCurr)
    <=> v13236(VarCurr) ) ).

tff(writeUnaryOperator_793,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13251(VarCurr)
    <=> v13226(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1101,axiom,
    ! [VarCurr: state_type] :
      ( v13221(VarCurr)
    <=> ( v13222(VarCurr)
        & v13248(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1100,axiom,
    ! [VarCurr: state_type] :
      ( v13248(VarCurr)
    <=> ( v13224(VarCurr)
        | v13243(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1099,axiom,
    ! [VarCurr: state_type] :
      ( v13222(VarCurr)
    <=> ( v13223(VarCurr)
        | v13242(VarCurr) ) ) ).

tff(writeUnaryOperator_792,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13242(VarCurr)
    <=> v13243(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1098,axiom,
    ! [VarCurr: state_type] :
      ( v13243(VarCurr)
    <=> ( v13244(VarCurr)
        & v13247(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_193,axiom,
    ! [VarCurr: state_type] :
      ( v13247(VarCurr)
    <=> ( v13211(VarCurr,3)
        | v13229(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1097,axiom,
    ! [VarCurr: state_type] :
      ( v13244(VarCurr)
    <=> ( v13245(VarCurr)
        | v13246(VarCurr) ) ) ).

tff(writeUnaryOperator_791,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13246(VarCurr)
    <=> v13229(VarCurr,3) ) ).

tff(writeUnaryOperator_790,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13245(VarCurr)
    <=> v13211(VarCurr,3) ) ).

tff(writeUnaryOperator_789,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13223(VarCurr)
    <=> v13224(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1096,axiom,
    ! [VarCurr: state_type] :
      ( v13224(VarCurr)
    <=> ( v13225(VarCurr)
        | v13241(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_192,axiom,
    ! [VarCurr: state_type] :
      ( v13241(VarCurr)
    <=> ( v13211(VarCurr,2)
        & v13229(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1095,axiom,
    ! [VarCurr: state_type] :
      ( v13225(VarCurr)
    <=> ( v13226(VarCurr)
        & v13236(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1094,axiom,
    ! [VarCurr: state_type] :
      ( v13236(VarCurr)
    <=> ( v13237(VarCurr)
        & v13240(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_191,axiom,
    ! [VarCurr: state_type] :
      ( v13240(VarCurr)
    <=> ( v13211(VarCurr,2)
        | v13229(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1093,axiom,
    ! [VarCurr: state_type] :
      ( v13237(VarCurr)
    <=> ( v13238(VarCurr)
        | v13239(VarCurr) ) ) ).

tff(writeUnaryOperator_788,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13239(VarCurr)
    <=> v13229(VarCurr,2) ) ).

tff(writeUnaryOperator_787,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13238(VarCurr)
    <=> v13211(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1092,axiom,
    ! [VarCurr: state_type] :
      ( v13226(VarCurr)
    <=> ( v13227(VarCurr)
        | v13235(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_190,axiom,
    ! [VarCurr: state_type] :
      ( v13235(VarCurr)
    <=> ( v13211(VarCurr,1)
        & v13229(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1091,axiom,
    ! [VarCurr: state_type] :
      ( v13227(VarCurr)
    <=> ( v13228(VarCurr)
        & v13230(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1090,axiom,
    ! [VarCurr: state_type] :
      ( v13230(VarCurr)
    <=> ( v13231(VarCurr)
        & v13234(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_189,axiom,
    ! [VarCurr: state_type] :
      ( v13234(VarCurr)
    <=> ( v13211(VarCurr,1)
        | v13229(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1089,axiom,
    ! [VarCurr: state_type] :
      ( v13231(VarCurr)
    <=> ( v13232(VarCurr)
        | v13233(VarCurr) ) ) ).

tff(writeUnaryOperator_786,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13233(VarCurr)
    <=> v13229(VarCurr,1) ) ).

tff(writeUnaryOperator_785,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13232(VarCurr)
    <=> v13211(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1088,axiom,
    ! [VarCurr: state_type] :
      ( v13228(VarCurr)
    <=> ( v13211(VarCurr,0)
        & v13229(VarCurr,0) ) ) ).

tff(addAssignment_6664,axiom,
    ! [VarCurr: state_type] :
      ( v13229(VarCurr,0)
    <=> v13216(VarCurr) ) ).

tff(addAssignment_6663,axiom,
    ! [VarCurr: state_type] :
      ( ( v13229(VarCurr,3)
      <=> $false )
      & ( v13229(VarCurr,2)
      <=> $false )
      & ( v13229(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_6662,axiom,
    ! [VarCurr: state_type] :
      ( v13216(VarCurr)
    <=> v13218(VarCurr) ) ).

tff(addAssignment_6661,axiom,
    ! [VarCurr: state_type] :
      ( v13218(VarCurr)
    <=> v13166(VarCurr) ) ).

tff(addAssignment_6660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v13211(VarCurr,B)
      <=> v13213(VarCurr,B) ) ) ).

tff(addAssignment_6659,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v13213(VarCurr,B)
      <=> v13214(VarCurr,B) ) ) ).

tff(addAssignment_6658,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v13214(VarCurr,B)
      <=> v13101(VarCurr,B) ) ) ).

tff(addAssignment_6657,axiom,
    ! [VarCurr: state_type] :
      ( v13214(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_6656,axiom,
    ! [VarCurr: state_type] :
      ( v13135(VarCurr,1)
    <=> v13137(VarCurr,1) ) ).

tff(addAssignment_6655,axiom,
    ! [VarCurr: state_type] :
      ( v13137(VarCurr,1)
    <=> v13198(VarCurr,1) ) ).

tff(addAssignment_6654,axiom,
    ! [VarCurr: state_type] :
      ( v13198(VarCurr,0)
    <=> v13199(VarCurr) ) ).

tff(addAssignment_6653,axiom,
    ! [VarCurr: state_type] :
      ( v13198(VarCurr,1)
    <=> v13199(VarCurr) ) ).

tff(addAssignment_6652,axiom,
    ! [VarCurr: state_type] :
      ( v13198(VarCurr,2)
    <=> v13199(VarCurr) ) ).

tff(addAssignment_6651,axiom,
    ! [VarCurr: state_type] :
      ( v13199(VarCurr)
    <=> v13139(VarCurr) ) ).

tff(addAssignment_6650,axiom,
    ! [VarCurr: state_type] :
      ( v13180(VarCurr)
    <=> v13182(VarCurr) ) ).

tff(addAssignment_6649,axiom,
    ! [VarCurr: state_type] :
      ( v13182(VarCurr)
    <=> v13184(VarCurr,0) ) ).

tff(addAssignment_6648,axiom,
    ! [VarCurr: state_type] :
      ( v13184(VarCurr,0)
    <=> v13186(VarCurr,0) ) ).

tff(addAssignment_6647,axiom,
    ! [VarCurr: state_type] :
      ( v13186(VarCurr,0)
    <=> v13188(VarCurr,0) ) ).

tff(addAssignment_6646,axiom,
    ! [VarCurr: state_type] :
      ( v13188(VarCurr,0)
    <=> v13193(VarCurr,0) ) ).

tff(writeUnaryOperator_784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v13193(VarCurr,B)
      <=> ~ v13190(VarCurr,B) ) ) ).

tff(addAssignment_6645,axiom,
    ! [VarCurr: state_type] :
      ( v13190(VarCurr,0)
    <=> v13192(VarCurr,0) ) ).

tff(addAssignment_6644,axiom,
    ! [VarCurr: state_type] :
      ( v13192(VarCurr,0)
    <=> v13101(VarCurr,0) ) ).

tff(addAssignment_6643,axiom,
    ! [VarCurr: state_type] :
      ( v13162(VarCurr,1)
    <=> v13164(VarCurr,1) ) ).

tff(addAssignment_6642,axiom,
    ! [VarCurr: state_type] :
      ( v13164(VarCurr,1)
    <=> v13167(VarCurr,1) ) ).

tff(addAssignment_6641,axiom,
    ! [VarCurr: state_type] :
      ( v13167(VarCurr,0)
    <=> v13168(VarCurr) ) ).

tff(addAssignment_6640,axiom,
    ! [VarCurr: state_type] :
      ( v13167(VarCurr,1)
    <=> v13166(VarCurr) ) ).

tff(addAssignment_6639,axiom,
    ! [VarCurr: state_type] :
      ( v13166(VarCurr)
    <=> v10053(VarCurr,2) ) ).

tff(addAssignment_6638,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,2)
    <=> v10055(VarCurr,2) ) ).

tff(addAssignment_6637,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,2)
    <=> v10057(VarCurr,2) ) ).

tff(addAssignment_6636,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,2)
    <=> v10061(VarCurr,2) ) ).

tff(addAssignment_6635,axiom,
    ! [VarCurr: state_type] :
      ( v13146(VarCurr,1)
    <=> v13148(VarCurr,1) ) ).

tff(addAssignment_6634,axiom,
    ! [VarCurr: state_type] :
      ( v13148(VarCurr,1)
    <=> v13149(VarCurr,1) ) ).

tff(addAssignment_6633,axiom,
    ! [VarCurr: state_type] :
      ( v13149(VarCurr,0)
    <=> v13150(VarCurr) ) ).

tff(addAssignment_6632,axiom,
    ! [VarCurr: state_type] :
      ( v13149(VarCurr,1)
    <=> v13150(VarCurr) ) ).

tff(addAssignment_6631,axiom,
    ! [VarCurr: state_type] :
      ( v13150(VarCurr)
    <=> v12673(VarCurr) ) ).

tff(addAssignment_6630,axiom,
    ! [VarCurr: state_type] :
      ( v13115(VarCurr)
    <=> v13117(VarCurr) ) ).

tff(addAssignment_6629,axiom,
    ! [VarCurr: state_type] :
      ( v13117(VarCurr)
    <=> v13119(VarCurr) ) ).

tff(addAssignment_6628,axiom,
    ! [VarCurr: state_type] :
      ( v13119(VarCurr)
    <=> v13121(VarCurr) ) ).

tff(addAssignment_6627,axiom,
    ! [VarCurr: state_type] :
      ( v13121(VarCurr)
    <=> v13123(VarCurr) ) ).

tff(addAssignment_6626,axiom,
    ! [VarCurr: state_type] :
      ( v13123(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6625,axiom,
    ! [VarCurr: state_type] :
      ( v13103(VarCurr)
    <=> v13105(VarCurr) ) ).

tff(addAssignment_6624,axiom,
    ! [VarCurr: state_type] :
      ( v13105(VarCurr)
    <=> v13107(VarCurr) ) ).

tff(addAssignment_6623,axiom,
    ! [VarCurr: state_type] :
      ( v13107(VarCurr)
    <=> v13109(VarCurr) ) ).

tff(addAssignment_6622,axiom,
    ! [VarCurr: state_type] :
      ( v13109(VarCurr)
    <=> v13111(VarCurr) ) ).

tff(addAssignment_6621,axiom,
    ! [VarCurr: state_type] :
      ( v13111(VarCurr)
    <=> v13113(VarCurr) ) ).

tff(addAssignment_6620,axiom,
    ! [VarCurr: state_type] :
      ( v13113(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_6619,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12611(VarCurr,B)
      <=> v12613(VarCurr,B) ) ) ).

tff(addAssignment_6618,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12613(VarCurr,B)
      <=> v12615(VarCurr,B) ) ) ).

tff(addAssignment_6617,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12615(VarCurr,B)
      <=> v12617(VarCurr,B) ) ) ).

tff(addAssignment_6616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12617(VarCurr,B)
      <=> v12619(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_149,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13064(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v12619(VarNext,B)
            <=> v12619(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_149,axiom,
    ! [VarNext: state_type] :
      ( v13064(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12619(VarNext,B)
          <=> v13074(VarNext,B) ) ) ) ).

tff(addAssignment_6615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13074(VarNext,B)
          <=> v13072(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_113,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13075(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13072(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_113,axiom,
    ! [VarCurr: state_type] :
      ( v13075(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v13072(VarCurr,B)
          <=> v12649(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1087,axiom,
    ! [VarCurr: state_type] :
      ( v13075(VarCurr)
    <=> ( v13076(VarCurr)
        & v13077(VarCurr) ) ) ).

tff(writeUnaryOperator_783,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13077(VarCurr)
    <=> v12635(VarCurr) ) ).

tff(writeUnaryOperator_782,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13076(VarCurr)
    <=> v12621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1086,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13064(VarNext)
      <=> v13065(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1085,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13065(VarNext)
      <=> ( v13066(VarNext)
          & v12979(VarNext) ) ) ) ).

tff(writeUnaryOperator_781,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13066(VarNext)
      <=> v13068(VarNext) ) ) ).

tff(addAssignment_6614,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13068(VarNext)
      <=> v12979(VarCurr) ) ) ).

tff(addAssignment_6613,axiom,
    ! [VarCurr: state_type] :
      ( v12979(VarCurr)
    <=> v12981(VarCurr) ) ).

tff(addAssignment_6612,axiom,
    ! [VarCurr: state_type] :
      ( v12981(VarCurr)
    <=> v12983(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1084,axiom,
    ! [VarCurr: state_type] :
      ( v12983(VarCurr)
    <=> ( v13061(VarCurr)
        | v13053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1083,axiom,
    ! [VarCurr: state_type] :
      ( v13061(VarCurr)
    <=> ( v12985(VarCurr)
        & v12991(VarCurr) ) ) ).

tff(addAssignment_6611,axiom,
    ! [VarCurr: state_type] :
      ( v13053(VarCurr)
    <=> v13055(VarCurr) ) ).

tff(addAssignment_6610,axiom,
    ! [VarCurr: state_type] :
      ( v13055(VarCurr)
    <=> v13057(VarCurr) ) ).

tff(addAssignment_6609,axiom,
    ! [VarCurr: state_type] :
      ( v13057(VarCurr)
    <=> v13059(VarCurr) ) ).

tff(addAssignment_6608,axiom,
    ! [VarCurr: state_type] :
      ( v13059(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_148,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v13037(VarNext)
       => ( v12991(VarNext)
        <=> v12991(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_148,axiom,
    ! [VarNext: state_type] :
      ( v13037(VarNext)
     => ( v12991(VarNext)
      <=> v13047(VarNext) ) ) ).

tff(addAssignment_6607,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13047(VarNext)
      <=> v13045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1082,axiom,
    ! [VarCurr: state_type] :
      ( v13045(VarCurr)
    <=> ( v13048(VarCurr)
        & v13049(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1081,axiom,
    ! [VarCurr: state_type] :
      ( v13049(VarCurr)
    <=> ( v12997(VarCurr)
        | v13028(VarCurr) ) ) ).

tff(writeUnaryOperator_780,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13048(VarCurr)
    <=> v12993(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1080,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13037(VarNext)
      <=> v13038(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1079,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13038(VarNext)
      <=> ( v13040(VarNext)
          & v13042(VarNext) ) ) ) ).

tff(writeUnaryOperator_779,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13042(VarCurr)
    <=> v12985(VarCurr) ) ).

tff(addAssignment_6606,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v13040(VarNext)
      <=> v12985(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_42,axiom,
    ( v12991(constB0)
  <=> $true ) ).

tff(addAssignment_6605,axiom,
    ! [VarCurr: state_type] :
      ( v13028(VarCurr)
    <=> v13030(VarCurr) ) ).

tff(addAssignment_6604,axiom,
    ! [VarCurr: state_type] :
      ( v13030(VarCurr)
    <=> v13032(VarCurr) ) ).

tff(addAssignment_6603,axiom,
    ! [VarCurr: state_type] :
      ( v13032(VarCurr)
    <=> v13034(VarCurr) ) ).

tff(addAssignment_6602,axiom,
    ! [VarCurr: state_type] :
      ( v13034(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_6601,axiom,
    ! [VarCurr: state_type] :
      ( v12997(VarCurr)
    <=> v12999(VarCurr) ) ).

tff(addAssignment_6600,axiom,
    ! [VarCurr: state_type] :
      ( v12999(VarCurr)
    <=> v13001(VarCurr) ) ).

tff(addAssignment_6599,axiom,
    ! [VarCurr: state_type] :
      ( v13001(VarCurr)
    <=> v13003(VarCurr) ) ).

tff(addAssignment_6598,axiom,
    ! [VarCurr: state_type] :
      ( v13003(VarCurr)
    <=> v13005(VarCurr) ) ).

tff(writeUnaryOperator_778,axiom,
    ! [VarCurr: state_type] :
      ( ~ v13005(VarCurr)
    <=> v13025(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1078,axiom,
    ! [VarCurr: state_type] :
      ( v13025(VarCurr)
    <=> ( v13026(VarCurr)
        | v13021(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1077,axiom,
    ! [VarCurr: state_type] :
      ( v13026(VarCurr)
    <=> ( v13007(VarCurr)
        | v13017(VarCurr) ) ) ).

tff(addAssignment_6597,axiom,
    ! [VarCurr: state_type] :
      ( v13021(VarCurr)
    <=> v13023(VarCurr) ) ).

tff(addAssignment_6596,axiom,
    ! [VarCurr: state_type] :
      ( v13023(VarCurr)
    <=> v13011(VarCurr,2) ) ).

tff(addAssignment_6595,axiom,
    ! [VarCurr: state_type] :
      ( v13011(VarCurr,2)
    <=> v13013(VarCurr,2) ) ).

tff(addAssignment_6594,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,2)
    <=> v13015(VarCurr,2) ) ).

tff(addAssignment_6593,axiom,
    ! [VarCurr: state_type] :
      ( v13017(VarCurr)
    <=> v13019(VarCurr) ) ).

tff(addAssignment_6592,axiom,
    ! [VarCurr: state_type] :
      ( v13019(VarCurr)
    <=> v13011(VarCurr,1) ) ).

tff(addAssignment_6591,axiom,
    ! [VarCurr: state_type] :
      ( v13011(VarCurr,1)
    <=> v13013(VarCurr,1) ) ).

tff(addAssignment_6590,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,1)
    <=> v13015(VarCurr,1) ) ).

tff(addAssignment_6589,axiom,
    ! [VarCurr: state_type] :
      ( v13007(VarCurr)
    <=> v13009(VarCurr) ) ).

tff(addAssignment_6588,axiom,
    ! [VarCurr: state_type] :
      ( v13009(VarCurr)
    <=> v13011(VarCurr,0) ) ).

tff(addAssignment_6587,axiom,
    ! [VarCurr: state_type] :
      ( v13011(VarCurr,0)
    <=> v13013(VarCurr,0) ) ).

tff(addAssignment_6586,axiom,
    ! [VarCurr: state_type] :
      ( v13013(VarCurr,0)
    <=> v13015(VarCurr,0) ) ).

tff(addAssignment_6585,axiom,
    ! [VarCurr: state_type] :
      ( v12993(VarCurr)
    <=> v12995(VarCurr) ) ).

tff(addAssignment_6584,axiom,
    ! [VarCurr: state_type] :
      ( v12995(VarCurr)
    <=> $false ) ).

tff(addAssignment_6583,axiom,
    ! [VarCurr: state_type] :
      ( v12985(VarCurr)
    <=> v12987(VarCurr) ) ).

tff(addAssignment_6582,axiom,
    ! [VarCurr: state_type] :
      ( v12987(VarCurr)
    <=> v12989(VarCurr) ) ).

tff(addAssignment_6581,axiom,
    ! [VarCurr: state_type] :
      ( v12989(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_6580,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12649(VarCurr,B)
      <=> v12651(VarCurr,B) ) ) ).

tff(addAssignment_6579,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12651(VarCurr,B)
      <=> v12653(VarCurr,B) ) ) ).

tff(addAssignment_6578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12653(VarCurr,B)
      <=> v12655(VarCurr,B) ) ) ).

tff(addAssignment_6577,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12655(VarCurr,B)
      <=> v12657(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12657(VarCurr,B)
      <=> ( v12659(VarCurr,B)
          & v12681(VarCurr,B) ) ) ) ).

tff(addAssignment_6576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12681(VarCurr,B)
      <=> v12683(VarCurr,B) ) ) ).

tff(addAssignment_6575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12683(VarCurr,B)
      <=> v12685(VarCurr,B) ) ) ).

tff(addAssignment_6574,axiom,
    ! [VarCurr: state_type] :
      ( ( v12685(VarCurr,11)
      <=> v9198(VarCurr,35) )
      & ( v12685(VarCurr,10)
      <=> v9198(VarCurr,34) )
      & ( v12685(VarCurr,9)
      <=> v9198(VarCurr,33) )
      & ( v12685(VarCurr,8)
      <=> v9198(VarCurr,32) )
      & ( v12685(VarCurr,7)
      <=> v9198(VarCurr,31) )
      & ( v12685(VarCurr,6)
      <=> v9198(VarCurr,30) )
      & ( v12685(VarCurr,5)
      <=> v9198(VarCurr,29) )
      & ( v12685(VarCurr,4)
      <=> v9198(VarCurr,28) )
      & ( v12685(VarCurr,3)
      <=> v9198(VarCurr,27) )
      & ( v12685(VarCurr,2)
      <=> v9198(VarCurr,26) )
      & ( v12685(VarCurr,1)
      <=> v9198(VarCurr,25) )
      & ( v12685(VarCurr,0)
      <=> v9198(VarCurr,24) ) ) ).

tff(addAssignment_6573,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,35)
      <=> v12687(VarCurr,11) )
      & ( v9198(VarCurr,34)
      <=> v12687(VarCurr,10) )
      & ( v9198(VarCurr,33)
      <=> v12687(VarCurr,9) )
      & ( v9198(VarCurr,32)
      <=> v12687(VarCurr,8) )
      & ( v9198(VarCurr,31)
      <=> v12687(VarCurr,7) )
      & ( v9198(VarCurr,30)
      <=> v12687(VarCurr,6) )
      & ( v9198(VarCurr,29)
      <=> v12687(VarCurr,5) )
      & ( v9198(VarCurr,28)
      <=> v12687(VarCurr,4) )
      & ( v9198(VarCurr,27)
      <=> v12687(VarCurr,3) )
      & ( v9198(VarCurr,26)
      <=> v12687(VarCurr,2) )
      & ( v9198(VarCurr,25)
      <=> v12687(VarCurr,1) )
      & ( v9198(VarCurr,24)
      <=> v12687(VarCurr,0) ) ) ).

tff(addAssignment_6572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12687(VarCurr,B)
      <=> v12689(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_228,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12689(VarCurr,B)
      <=> ( v12971(VarCurr,B)
          | v12974(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12974(VarCurr,B)
      <=> ( v12699(VarCurr,B)
          & v12975(VarCurr,B) ) ) ) ).

tff(addAssignment_6571,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,0)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6570,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,1)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6569,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,2)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6568,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,3)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6567,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,4)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6566,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,5)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6565,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,6)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6564,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,7)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6563,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,8)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6562,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,9)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6561,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,10)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6560,axiom,
    ! [VarCurr: state_type] :
      ( v12975(VarCurr,11)
    <=> v12976(VarCurr) ) ).

tff(addAssignment_6559,axiom,
    ! [VarCurr: state_type] :
      ( v12976(VarCurr)
    <=> v12967(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12971(VarCurr,B)
      <=> ( v12691(VarCurr,B)
          & v12972(VarCurr,B) ) ) ) ).

tff(addAssignment_6558,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,0)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6557,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,1)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6556,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,2)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6555,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,3)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6554,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,4)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6553,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,5)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6552,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,6)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6551,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,7)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6550,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,8)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6549,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,9)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6548,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,10)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6547,axiom,
    ! [VarCurr: state_type] :
      ( v12972(VarCurr,11)
    <=> v12973(VarCurr) ) ).

tff(addAssignment_6546,axiom,
    ! [VarCurr: state_type] :
      ( v12973(VarCurr)
    <=> v12695(VarCurr) ) ).

tff(addAssignment_6545,axiom,
    ! [VarCurr: state_type] :
      ( v12967(VarCurr)
    <=> v12969(VarCurr) ) ).

tff(addAssignment_6544,axiom,
    ! [VarCurr: state_type] :
      ( v12969(VarCurr)
    <=> v9844(VarCurr,2) ) ).

tff(addAssignment_6543,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,2)
    <=> v9846(VarCurr,2) ) ).

tff(addAssignment_6542,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,2)
    <=> v9496(VarCurr,2) ) ).

tff(addAssignment_6541,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12699(VarCurr,B)
      <=> v12701(VarCurr,B) ) ) ).

tff(addAssignment_6540,axiom,
    ! [VarCurr: state_type] :
      ( ( v12701(VarCurr,11)
      <=> v9208(VarCurr,47) )
      & ( v12701(VarCurr,10)
      <=> v9208(VarCurr,46) )
      & ( v12701(VarCurr,9)
      <=> v9208(VarCurr,45) )
      & ( v12701(VarCurr,8)
      <=> v9208(VarCurr,44) )
      & ( v12701(VarCurr,7)
      <=> v9208(VarCurr,43) )
      & ( v12701(VarCurr,6)
      <=> v9208(VarCurr,42) )
      & ( v12701(VarCurr,5)
      <=> v9208(VarCurr,41) )
      & ( v12701(VarCurr,4)
      <=> v9208(VarCurr,40) )
      & ( v12701(VarCurr,3)
      <=> v9208(VarCurr,39) )
      & ( v12701(VarCurr,2)
      <=> v9208(VarCurr,38) )
      & ( v12701(VarCurr,1)
      <=> v9208(VarCurr,37) )
      & ( v12701(VarCurr,0)
      <=> v9208(VarCurr,36) ) ) ).

tff(addAssignment_6539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,36) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_6538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,36) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_6537,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,47)
      <=> v12703(VarCurr,11) )
      & ( v9212(VarCurr,46)
      <=> v12703(VarCurr,10) )
      & ( v9212(VarCurr,45)
      <=> v12703(VarCurr,9) )
      & ( v9212(VarCurr,44)
      <=> v12703(VarCurr,8) )
      & ( v9212(VarCurr,43)
      <=> v12703(VarCurr,7) )
      & ( v9212(VarCurr,42)
      <=> v12703(VarCurr,6) )
      & ( v9212(VarCurr,41)
      <=> v12703(VarCurr,5) )
      & ( v9212(VarCurr,40)
      <=> v12703(VarCurr,4) )
      & ( v9212(VarCurr,39)
      <=> v12703(VarCurr,3) )
      & ( v9212(VarCurr,38)
      <=> v12703(VarCurr,2) )
      & ( v9212(VarCurr,37)
      <=> v12703(VarCurr,1) )
      & ( v9212(VarCurr,36)
      <=> v12703(VarCurr,0) ) ) ).

tff(addAssignment_6536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12703(VarCurr,B)
      <=> v12705(VarCurr,B) ) ) ).

tff(addAssignment_6535,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12705(VarCurr,B)
      <=> v12707(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12950(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v12707(VarNext,B)
            <=> v12707(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_147,axiom,
    ! [VarNext: state_type] :
      ( v12950(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12707(VarNext,B)
          <=> v12960(VarNext,B) ) ) ) ).

tff(addAssignment_6534,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12960(VarNext,B)
          <=> v12958(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_112,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12958(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_112,axiom,
    ! [VarCurr: state_type] :
      ( v12961(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12958(VarCurr,B)
          <=> v12737(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1076,axiom,
    ! [VarCurr: state_type] :
      ( v12961(VarCurr)
    <=> ( v12962(VarCurr)
        & v12963(VarCurr) ) ) ).

tff(writeUnaryOperator_777,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12963(VarCurr)
    <=> v12723(VarCurr) ) ).

tff(writeUnaryOperator_776,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12962(VarCurr)
    <=> v12709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12950(VarNext)
      <=> v12951(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1074,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12951(VarNext)
      <=> ( v12952(VarNext)
          & v12925(VarNext) ) ) ) ).

tff(writeUnaryOperator_775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12952(VarNext)
      <=> v12954(VarNext) ) ) ).

tff(addAssignment_6533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12954(VarNext)
      <=> v12925(VarCurr) ) ) ).

tff(addAssignment_6532,axiom,
    ! [VarCurr: state_type] :
      ( v12925(VarCurr)
    <=> v12927(VarCurr) ) ).

tff(addAssignment_6531,axiom,
    ! [VarCurr: state_type] :
      ( v12927(VarCurr)
    <=> v12929(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1073,axiom,
    ! [VarCurr: state_type] :
      ( v12929(VarCurr)
    <=> ( v12947(VarCurr)
        | v12939(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1072,axiom,
    ! [VarCurr: state_type] :
      ( v12947(VarCurr)
    <=> ( v12931(VarCurr)
        & v12937(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_41,axiom,
    ( v12937(constB0)
  <=> $true ) ).

tff(addAssignment_6530,axiom,
    ! [VarCurr: state_type] :
      ( v12939(VarCurr)
    <=> v12941(VarCurr) ) ).

tff(addAssignment_6529,axiom,
    ! [VarCurr: state_type] :
      ( v12941(VarCurr)
    <=> v12943(VarCurr) ) ).

tff(addAssignment_6528,axiom,
    ! [VarCurr: state_type] :
      ( v12943(VarCurr)
    <=> v12945(VarCurr) ) ).

tff(addAssignment_6527,axiom,
    ! [VarCurr: state_type] :
      ( v12945(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_6526,axiom,
    ! [VarCurr: state_type] :
      ( v12931(VarCurr)
    <=> v12933(VarCurr) ) ).

tff(addAssignment_6525,axiom,
    ! [VarCurr: state_type] :
      ( v12933(VarCurr)
    <=> v12935(VarCurr) ) ).

tff(addAssignment_6524,axiom,
    ! [VarCurr: state_type] :
      ( v12935(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_6523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12737(VarCurr,B)
      <=> v12739(VarCurr,B) ) ) ).

tff(addAssignment_6522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12739(VarCurr,B)
      <=> v12741(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12741(VarCurr,B)
      <=> ( v12910(VarCurr,B)
          | v12921(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_224,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12921(VarCurr,B)
      <=> ( v12874(VarCurr,B)
          & v12922(VarCurr,B) ) ) ) ).

tff(addAssignment_6521,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,0)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6520,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,1)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6519,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,2)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6518,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,3)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6517,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,4)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6516,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,5)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6515,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,6)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6514,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,7)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6513,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,8)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6512,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,9)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6511,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,10)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6510,axiom,
    ! [VarCurr: state_type] :
      ( v12922(VarCurr,11)
    <=> v12923(VarCurr) ) ).

tff(addAssignment_6509,axiom,
    ! [VarCurr: state_type] :
      ( v12923(VarCurr)
    <=> v12884(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_223,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12910(VarCurr,B)
      <=> ( v12911(VarCurr,B)
          | v12918(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12918(VarCurr,B)
      <=> ( v12838(VarCurr,B)
          & v12919(VarCurr,B) ) ) ) ).

tff(addAssignment_6508,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,0)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6507,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,1)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6506,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,2)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6505,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,3)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6504,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,4)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6503,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,5)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6502,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,6)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6501,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,7)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6500,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,8)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6499,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,9)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6498,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,10)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6497,axiom,
    ! [VarCurr: state_type] :
      ( v12919(VarCurr,11)
    <=> v12920(VarCurr) ) ).

tff(addAssignment_6496,axiom,
    ! [VarCurr: state_type] :
      ( v12920(VarCurr)
    <=> v12848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_221,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12911(VarCurr,B)
      <=> ( v12912(VarCurr,B)
          | v12915(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12915(VarCurr,B)
      <=> ( v12791(VarCurr,B)
          & v12916(VarCurr,B) ) ) ) ).

tff(addAssignment_6495,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,0)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6494,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,1)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6493,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,2)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6492,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,3)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6491,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,4)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6490,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,5)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6489,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,6)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6488,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,7)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6487,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,8)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6486,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,9)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6485,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,10)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6484,axiom,
    ! [VarCurr: state_type] :
      ( v12916(VarCurr,11)
    <=> v12917(VarCurr) ) ).

tff(addAssignment_6483,axiom,
    ! [VarCurr: state_type] :
      ( v12917(VarCurr)
    <=> v12801(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_219,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12912(VarCurr,B)
      <=> ( v12743(VarCurr,B)
          & v12913(VarCurr,B) ) ) ) ).

tff(addAssignment_6482,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,0)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6481,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,1)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6480,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,2)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6479,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,3)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6478,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,4)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6477,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,5)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6476,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,6)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6475,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,7)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6474,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,8)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6473,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,9)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6472,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,10)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6471,axiom,
    ! [VarCurr: state_type] :
      ( v12913(VarCurr,11)
    <=> v12914(VarCurr) ) ).

tff(addAssignment_6470,axiom,
    ! [VarCurr: state_type] :
      ( v12914(VarCurr)
    <=> v12753(VarCurr) ) ).

tff(addAssignment_6469,axiom,
    ! [VarCurr: state_type] :
      ( v12884(VarCurr)
    <=> v12886(VarCurr) ) ).

tff(addAssignment_6468,axiom,
    ! [VarCurr: state_type] :
      ( v12886(VarCurr)
    <=> v12888(VarCurr) ) ).

tff(addAssignment_6467,axiom,
    ! [VarCurr: state_type] :
      ( v12888(VarCurr)
    <=> v12890(VarCurr) ) ).

tff(addAssignment_6466,axiom,
    ! [VarCurr: state_type] :
      ( v12890(VarCurr)
    <=> v12892(VarCurr) ) ).

tff(addAssignment_6465,axiom,
    ! [VarCurr: state_type] :
      ( v12892(VarCurr)
    <=> v12894(VarCurr) ) ).

tff(addAssignment_6464,axiom,
    ! [VarCurr: state_type] :
      ( v12894(VarCurr)
    <=> v12896(VarCurr) ) ).

tff(addAssignment_6463,axiom,
    ! [VarCurr: state_type] :
      ( v12896(VarCurr)
    <=> v12898(VarCurr) ) ).

tff(writeUnaryOperator_774,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12898(VarCurr)
    <=> v12908(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1071,axiom,
    ! [VarCurr: state_type] :
      ( v12908(VarCurr)
    <=> ( v12900(VarCurr)
        | v12904(VarCurr) ) ) ).

tff(addAssignment_6462,axiom,
    ! [VarCurr: state_type] :
      ( v12904(VarCurr)
    <=> v12906(VarCurr) ) ).

tff(addAssignment_6461,axiom,
    ! [VarCurr: state_type] :
      ( v12906(VarCurr)
    <=> v12821(VarCurr,1) ) ).

tff(addAssignment_6460,axiom,
    ! [VarCurr: state_type] :
      ( v12900(VarCurr)
    <=> v12902(VarCurr) ) ).

tff(addAssignment_6459,axiom,
    ! [VarCurr: state_type] :
      ( v12902(VarCurr)
    <=> v12821(VarCurr,0) ) ).

tff(addAssignment_6458,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12874(VarCurr,B)
      <=> v12876(VarCurr,B) ) ) ).

tff(addAssignment_6457,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12876(VarCurr,B)
      <=> v12878(VarCurr,B) ) ) ).

tff(addAssignment_6456,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12878(VarCurr,B)
      <=> v12880(VarCurr,B) ) ) ).

tff(addAssignment_6455,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12880(VarCurr,B)
      <=> v12882(VarCurr,B) ) ) ).

tff(addAssignment_6454,axiom,
    ! [VarCurr: state_type] :
      ( v12848(VarCurr)
    <=> v12850(VarCurr) ) ).

tff(addAssignment_6453,axiom,
    ! [VarCurr: state_type] :
      ( v12850(VarCurr)
    <=> v12852(VarCurr) ) ).

tff(addAssignment_6452,axiom,
    ! [VarCurr: state_type] :
      ( v12852(VarCurr)
    <=> v12854(VarCurr) ) ).

tff(addAssignment_6451,axiom,
    ! [VarCurr: state_type] :
      ( v12854(VarCurr)
    <=> v12856(VarCurr) ) ).

tff(addAssignment_6450,axiom,
    ! [VarCurr: state_type] :
      ( v12856(VarCurr)
    <=> v12858(VarCurr) ) ).

tff(addAssignment_6449,axiom,
    ! [VarCurr: state_type] :
      ( v12858(VarCurr)
    <=> v12860(VarCurr) ) ).

tff(addAssignment_6448,axiom,
    ! [VarCurr: state_type] :
      ( v12860(VarCurr)
    <=> v12862(VarCurr) ) ).

tff(writeUnaryOperator_773,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12862(VarCurr)
    <=> v12872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1070,axiom,
    ! [VarCurr: state_type] :
      ( v12872(VarCurr)
    <=> ( v12864(VarCurr)
        | v12868(VarCurr) ) ) ).

tff(addAssignment_6447,axiom,
    ! [VarCurr: state_type] :
      ( v12868(VarCurr)
    <=> v12870(VarCurr) ) ).

tff(addAssignment_6446,axiom,
    ! [VarCurr: state_type] :
      ( v12870(VarCurr)
    <=> v12821(VarCurr,1) ) ).

tff(addAssignment_6445,axiom,
    ! [VarCurr: state_type] :
      ( v12821(VarCurr,1)
    <=> v12823(VarCurr,1) ) ).

tff(addAssignment_6444,axiom,
    ! [VarCurr: state_type] :
      ( v12823(VarCurr,1)
    <=> v12825(VarCurr,1) ) ).

tff(addAssignment_6443,axiom,
    ! [VarCurr: state_type] :
      ( v12825(VarCurr,1)
    <=> v12830(VarCurr,1) ) ).

tff(addAssignment_6442,axiom,
    ! [VarCurr: state_type] :
      ( v12827(VarCurr,1)
    <=> v12829(VarCurr,1) ) ).

tff(addAssignment_6441,axiom,
    ! [VarCurr: state_type] :
      ( v12829(VarCurr,1)
    <=> v12773(VarCurr,1) ) ).

tff(addAssignment_6440,axiom,
    ! [VarCurr: state_type] :
      ( v12864(VarCurr)
    <=> v12866(VarCurr) ) ).

tff(addAssignment_6439,axiom,
    ! [VarCurr: state_type] :
      ( v12866(VarCurr)
    <=> v12773(VarCurr,0) ) ).

tff(addAssignment_6438,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12838(VarCurr,B)
      <=> v12840(VarCurr,B) ) ) ).

tff(addAssignment_6437,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12840(VarCurr,B)
      <=> v12842(VarCurr,B) ) ) ).

tff(addAssignment_6436,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12842(VarCurr,B)
      <=> v12844(VarCurr,B) ) ) ).

tff(addAssignment_6435,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12844(VarCurr,B)
      <=> v12846(VarCurr,B) ) ) ).

tff(addAssignment_6434,axiom,
    ! [VarCurr: state_type] :
      ( v12801(VarCurr)
    <=> v12803(VarCurr) ) ).

tff(addAssignment_6433,axiom,
    ! [VarCurr: state_type] :
      ( v12803(VarCurr)
    <=> v12805(VarCurr) ) ).

tff(addAssignment_6432,axiom,
    ! [VarCurr: state_type] :
      ( v12805(VarCurr)
    <=> v12807(VarCurr) ) ).

tff(addAssignment_6431,axiom,
    ! [VarCurr: state_type] :
      ( v12807(VarCurr)
    <=> v12809(VarCurr) ) ).

tff(addAssignment_6430,axiom,
    ! [VarCurr: state_type] :
      ( v12809(VarCurr)
    <=> v12811(VarCurr) ) ).

tff(addAssignment_6429,axiom,
    ! [VarCurr: state_type] :
      ( v12811(VarCurr)
    <=> v12813(VarCurr) ) ).

tff(addAssignment_6428,axiom,
    ! [VarCurr: state_type] :
      ( v12813(VarCurr)
    <=> v12815(VarCurr) ) ).

tff(writeUnaryOperator_772,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12815(VarCurr)
    <=> v12836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1069,axiom,
    ! [VarCurr: state_type] :
      ( v12836(VarCurr)
    <=> ( v12817(VarCurr)
        | v12832(VarCurr) ) ) ).

tff(addAssignment_6427,axiom,
    ! [VarCurr: state_type] :
      ( v12832(VarCurr)
    <=> v12834(VarCurr) ) ).

tff(addAssignment_6426,axiom,
    ! [VarCurr: state_type] :
      ( v12834(VarCurr)
    <=> v12773(VarCurr,1) ) ).

tff(addAssignment_6425,axiom,
    ! [VarCurr: state_type] :
      ( v12817(VarCurr)
    <=> v12819(VarCurr) ) ).

tff(addAssignment_6424,axiom,
    ! [VarCurr: state_type] :
      ( v12819(VarCurr)
    <=> v12821(VarCurr,0) ) ).

tff(addAssignment_6423,axiom,
    ! [VarCurr: state_type] :
      ( v12821(VarCurr,0)
    <=> v12823(VarCurr,0) ) ).

tff(addAssignment_6422,axiom,
    ! [VarCurr: state_type] :
      ( v12823(VarCurr,0)
    <=> v12825(VarCurr,0) ) ).

tff(addAssignment_6421,axiom,
    ! [VarCurr: state_type] :
      ( v12825(VarCurr,0)
    <=> v12830(VarCurr,0) ) ).

tff(writeUnaryOperator_771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v12830(VarCurr,B)
      <=> ~ v12827(VarCurr,B) ) ) ).

tff(addAssignment_6420,axiom,
    ! [VarCurr: state_type] :
      ( v12827(VarCurr,0)
    <=> v12829(VarCurr,0) ) ).

tff(addAssignment_6419,axiom,
    ! [VarCurr: state_type] :
      ( v12829(VarCurr,0)
    <=> v12773(VarCurr,0) ) ).

tff(addAssignment_6418,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12791(VarCurr,B)
      <=> v12793(VarCurr,B) ) ) ).

tff(addAssignment_6417,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12793(VarCurr,B)
      <=> v12795(VarCurr,B) ) ) ).

tff(addAssignment_6416,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12795(VarCurr,B)
      <=> v12797(VarCurr,B) ) ) ).

tff(addAssignment_6415,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12797(VarCurr,B)
      <=> v12799(VarCurr,B) ) ) ).

tff(addAssignment_6414,axiom,
    ! [VarCurr: state_type] :
      ( v12753(VarCurr)
    <=> v12755(VarCurr) ) ).

tff(addAssignment_6413,axiom,
    ! [VarCurr: state_type] :
      ( v12755(VarCurr)
    <=> v12757(VarCurr) ) ).

tff(addAssignment_6412,axiom,
    ! [VarCurr: state_type] :
      ( v12757(VarCurr)
    <=> v12759(VarCurr) ) ).

tff(addAssignment_6411,axiom,
    ! [VarCurr: state_type] :
      ( v12759(VarCurr)
    <=> v12761(VarCurr) ) ).

tff(addAssignment_6410,axiom,
    ! [VarCurr: state_type] :
      ( v12761(VarCurr)
    <=> v12763(VarCurr) ) ).

tff(addAssignment_6409,axiom,
    ! [VarCurr: state_type] :
      ( v12763(VarCurr)
    <=> v12765(VarCurr) ) ).

tff(addAssignment_6408,axiom,
    ! [VarCurr: state_type] :
      ( v12765(VarCurr)
    <=> v12767(VarCurr) ) ).

tff(writeUnaryOperator_770,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12767(VarCurr)
    <=> v12789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1068,axiom,
    ! [VarCurr: state_type] :
      ( v12789(VarCurr)
    <=> ( v12769(VarCurr)
        | v12785(VarCurr) ) ) ).

tff(addAssignment_6407,axiom,
    ! [VarCurr: state_type] :
      ( v12785(VarCurr)
    <=> v12787(VarCurr) ) ).

tff(addAssignment_6406,axiom,
    ! [VarCurr: state_type] :
      ( v12787(VarCurr)
    <=> v12773(VarCurr,1) ) ).

tff(addAssignment_6405,axiom,
    ! [VarCurr: state_type] :
      ( v12773(VarCurr,1)
    <=> v12775(VarCurr,1) ) ).

tff(addAssignment_6404,axiom,
    ! [VarCurr: state_type] :
      ( v12775(VarCurr,1)
    <=> v12777(VarCurr,1) ) ).

tff(addAssignment_6403,axiom,
    ! [VarCurr: state_type] :
      ( v12777(VarCurr,1)
    <=> v12779(VarCurr,1) ) ).

tff(addAssignment_6402,axiom,
    ! [VarCurr: state_type] :
      ( v12779(VarCurr,1)
    <=> v12781(VarCurr,1) ) ).

tff(addAssignment_6401,axiom,
    ! [VarCurr: state_type] :
      ( v12781(VarCurr,1)
    <=> v12783(VarCurr,1) ) ).

tff(addAssignment_6400,axiom,
    ! [VarCurr: state_type] :
      ( v12769(VarCurr)
    <=> v12771(VarCurr) ) ).

tff(addAssignment_6399,axiom,
    ! [VarCurr: state_type] :
      ( v12771(VarCurr)
    <=> v12773(VarCurr,0) ) ).

tff(addAssignment_6398,axiom,
    ! [VarCurr: state_type] :
      ( v12773(VarCurr,0)
    <=> v12775(VarCurr,0) ) ).

tff(addAssignment_6397,axiom,
    ! [VarCurr: state_type] :
      ( v12775(VarCurr,0)
    <=> v12777(VarCurr,0) ) ).

tff(addAssignment_6396,axiom,
    ! [VarCurr: state_type] :
      ( v12777(VarCurr,0)
    <=> v12779(VarCurr,0) ) ).

tff(addAssignment_6395,axiom,
    ! [VarCurr: state_type] :
      ( v12779(VarCurr,0)
    <=> v12781(VarCurr,0) ) ).

tff(addAssignment_6394,axiom,
    ! [VarCurr: state_type] :
      ( v12781(VarCurr,0)
    <=> v12783(VarCurr,0) ) ).

tff(addAssignment_6393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12743(VarCurr,B)
      <=> v12745(VarCurr,B) ) ) ).

tff(addAssignment_6392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12745(VarCurr,B)
      <=> v12747(VarCurr,B) ) ) ).

tff(addAssignment_6391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12747(VarCurr,B)
      <=> v12749(VarCurr,B) ) ) ).

tff(addAssignment_6390,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12749(VarCurr,B)
      <=> v12751(VarCurr,B) ) ) ).

tff(addAssignment_6389,axiom,
    ! [VarCurr: state_type] :
      ( v12723(VarCurr)
    <=> v12725(VarCurr) ) ).

tff(addAssignment_6388,axiom,
    ! [VarCurr: state_type] :
      ( v12725(VarCurr)
    <=> v12727(VarCurr) ) ).

tff(addAssignment_6387,axiom,
    ! [VarCurr: state_type] :
      ( v12727(VarCurr)
    <=> v12729(VarCurr) ) ).

tff(addAssignment_6386,axiom,
    ! [VarCurr: state_type] :
      ( v12729(VarCurr)
    <=> v12731(VarCurr) ) ).

tff(addAssignment_6385,axiom,
    ! [VarCurr: state_type] :
      ( v12731(VarCurr)
    <=> v12733(VarCurr) ) ).

tff(addAssignment_6384,axiom,
    ! [VarCurr: state_type] :
      ( v12733(VarCurr)
    <=> v12735(VarCurr) ) ).

tff(addAssignment_6383,axiom,
    ! [VarCurr: state_type] :
      ( v12735(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_6382,axiom,
    ! [VarCurr: state_type] :
      ( v12709(VarCurr)
    <=> v12711(VarCurr) ) ).

tff(addAssignment_6381,axiom,
    ! [VarCurr: state_type] :
      ( v12711(VarCurr)
    <=> v12713(VarCurr) ) ).

tff(addAssignment_6380,axiom,
    ! [VarCurr: state_type] :
      ( v12713(VarCurr)
    <=> v12715(VarCurr) ) ).

tff(addAssignment_6379,axiom,
    ! [VarCurr: state_type] :
      ( v12715(VarCurr)
    <=> v12717(VarCurr) ) ).

tff(addAssignment_6378,axiom,
    ! [VarCurr: state_type] :
      ( v12717(VarCurr)
    <=> v12719(VarCurr) ) ).

tff(addAssignment_6377,axiom,
    ! [VarCurr: state_type] :
      ( v12719(VarCurr)
    <=> v12721(VarCurr) ) ).

tff(addAssignment_6376,axiom,
    ! [VarCurr: state_type] :
      ( v12721(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_6375,axiom,
    ! [VarCurr: state_type] :
      ( v12695(VarCurr)
    <=> v12697(VarCurr) ) ).

tff(addAssignment_6374,axiom,
    ! [VarCurr: state_type] :
      ( v12697(VarCurr)
    <=> v9490(VarCurr,2) ) ).

tff(addAssignment_6373,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,2)
    <=> v9492(VarCurr,2) ) ).

tff(addAssignment_6372,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,2)
    <=> v9494(VarCurr,2) ) ).

tff(addAssignment_6371,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,2)
    <=> v9570(VarCurr,2) ) ).

tff(addAssignment_6370,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,2)
    <=> v9513(VarCurr,2) ) ).

tff(addAssignment_6369,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12691(VarCurr,B)
      <=> v12693(VarCurr,B) ) ) ).

tff(addAssignment_6368,axiom,
    ! [VarCurr: state_type] :
      ( ( v12693(VarCurr,11)
      <=> v9208(VarCurr,35) )
      & ( v12693(VarCurr,10)
      <=> v9208(VarCurr,34) )
      & ( v12693(VarCurr,9)
      <=> v9208(VarCurr,33) )
      & ( v12693(VarCurr,8)
      <=> v9208(VarCurr,32) )
      & ( v12693(VarCurr,7)
      <=> v9208(VarCurr,31) )
      & ( v12693(VarCurr,6)
      <=> v9208(VarCurr,30) )
      & ( v12693(VarCurr,5)
      <=> v9208(VarCurr,29) )
      & ( v12693(VarCurr,4)
      <=> v9208(VarCurr,28) )
      & ( v12693(VarCurr,3)
      <=> v9208(VarCurr,27) )
      & ( v12693(VarCurr,2)
      <=> v9208(VarCurr,26) )
      & ( v12693(VarCurr,1)
      <=> v9208(VarCurr,25) )
      & ( v12693(VarCurr,0)
      <=> v9208(VarCurr,24) ) ) ).

tff(addAssignment_6367,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12659(VarCurr,B)
      <=> v12661(VarCurr,B) ) ) ).

tff(addAssignment_6366,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,0)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6365,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,1)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6364,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,2)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6363,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,3)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6362,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,4)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6361,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,5)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6360,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,6)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6359,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,7)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6358,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,8)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6357,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,9)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6356,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,10)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6355,axiom,
    ! [VarCurr: state_type] :
      ( v12661(VarCurr,11)
    <=> v12679(VarCurr) ) ).

tff(addAssignment_6354,axiom,
    ! [VarCurr: state_type] :
      ( v12679(VarCurr)
    <=> v12663(VarCurr) ) ).

tff(addAssignment_6353,axiom,
    ! [VarCurr: state_type] :
      ( v12663(VarCurr)
    <=> v12665(VarCurr,0) ) ).

tff(addAssignment_6352,axiom,
    ! [VarCurr: state_type] :
      ( v12665(VarCurr,0)
    <=> v12667(VarCurr,0) ) ).

tff(addAssignment_6351,axiom,
    ! [VarCurr: state_type] :
      ( v12667(VarCurr,0)
    <=> v12677(VarCurr,0) ) ).

tff(writeUnaryOperator_769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v12677(VarCurr,B)
      <=> ~ v12669(VarCurr,B) ) ) ).

tff(addAssignment_6350,axiom,
    ! [VarCurr: state_type] :
      ( v12669(VarCurr,0)
    <=> v12671(VarCurr,0) ) ).

tff(addAssignment_6349,axiom,
    ! [VarCurr: state_type] :
      ( v12671(VarCurr,0)
    <=> v12674(VarCurr,0) ) ).

tff(addAssignment_6348,axiom,
    ! [VarCurr: state_type] :
      ( v12674(VarCurr,0)
    <=> v12673(VarCurr) ) ).

tff(addAssignment_6347,axiom,
    ! [VarCurr: state_type] :
      ( v12674(VarCurr,1)
    <=> v12676(VarCurr) ) ).

tff(addAssignment_6346,axiom,
    ! [VarCurr: state_type] :
      ( v12674(VarCurr,2)
    <=> v12675(VarCurr) ) ).

tff(addAssignment_6345,axiom,
    ! [VarCurr: state_type] :
      ( v12673(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_6344,axiom,
    ! [VarCurr: state_type] :
      ( v12635(VarCurr)
    <=> v12637(VarCurr) ) ).

tff(addAssignment_6343,axiom,
    ! [VarCurr: state_type] :
      ( v12637(VarCurr)
    <=> v12639(VarCurr) ) ).

tff(addAssignment_6342,axiom,
    ! [VarCurr: state_type] :
      ( v12639(VarCurr)
    <=> v12641(VarCurr) ) ).

tff(addAssignment_6341,axiom,
    ! [VarCurr: state_type] :
      ( v12641(VarCurr)
    <=> v12643(VarCurr) ) ).

tff(addAssignment_6340,axiom,
    ! [VarCurr: state_type] :
      ( v12643(VarCurr)
    <=> v12645(VarCurr) ) ).

tff(addAssignment_6339,axiom,
    ! [VarCurr: state_type] :
      ( v12645(VarCurr)
    <=> v12647(VarCurr) ) ).

tff(addAssignment_6338,axiom,
    ! [VarCurr: state_type] :
      ( v12647(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_6337,axiom,
    ! [VarCurr: state_type] :
      ( v12621(VarCurr)
    <=> v12623(VarCurr) ) ).

tff(addAssignment_6336,axiom,
    ! [VarCurr: state_type] :
      ( v12623(VarCurr)
    <=> v12625(VarCurr) ) ).

tff(addAssignment_6335,axiom,
    ! [VarCurr: state_type] :
      ( v12625(VarCurr)
    <=> v12627(VarCurr) ) ).

tff(addAssignment_6334,axiom,
    ! [VarCurr: state_type] :
      ( v12627(VarCurr)
    <=> v12629(VarCurr) ) ).

tff(addAssignment_6333,axiom,
    ! [VarCurr: state_type] :
      ( v12629(VarCurr)
    <=> v12631(VarCurr) ) ).

tff(addAssignment_6332,axiom,
    ! [VarCurr: state_type] :
      ( v12631(VarCurr)
    <=> v12633(VarCurr) ) ).

tff(addAssignment_6331,axiom,
    ! [VarCurr: state_type] :
      ( v12633(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_6330,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12597(VarCurr,B)
      <=> v12599(VarCurr,B) ) ) ).

tff(addAssignment_6329,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12599(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_6328,axiom,
    ! [VarCurr: state_type] :
      ( v11041(VarCurr)
    <=> v11043(VarCurr) ) ).

tff(addAssignment_6327,axiom,
    ! [VarCurr: state_type] :
      ( v11043(VarCurr)
    <=> v11045(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_87,axiom,
    ! [VarCurr: state_type] :
      ( v11045(VarCurr)
    <=> ( ( v11047(VarCurr,11)
        <=> v11051(VarCurr,11) )
        & ( v11047(VarCurr,10)
        <=> v11051(VarCurr,10) )
        & ( v11047(VarCurr,9)
        <=> v11051(VarCurr,9) )
        & ( v11047(VarCurr,8)
        <=> v11051(VarCurr,8) )
        & ( v11047(VarCurr,7)
        <=> v11051(VarCurr,7) )
        & ( v11047(VarCurr,6)
        <=> v11051(VarCurr,6) )
        & ( v11047(VarCurr,5)
        <=> v11051(VarCurr,5) )
        & ( v11047(VarCurr,4)
        <=> v11051(VarCurr,4) )
        & ( v11047(VarCurr,3)
        <=> v11051(VarCurr,3) )
        & ( v11047(VarCurr,2)
        <=> v11051(VarCurr,2) )
        & ( v11047(VarCurr,1)
        <=> v11051(VarCurr,1) )
        & ( v11047(VarCurr,0)
        <=> v11051(VarCurr,0) ) ) ) ).

tff(addAssignment_6326,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11051(VarCurr,B)
      <=> v11053(VarCurr,B) ) ) ).

tff(addAssignment_6325,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11053(VarCurr,B)
      <=> v11055(VarCurr,B) ) ) ).

tff(addAssignment_6324,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11055(VarCurr,B)
      <=> v11057(VarCurr,B) ) ) ).

tff(addAssignment_6323,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11057(VarCurr,B)
      <=> v11059(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11059(VarCurr,B)
      <=> ( v12567(VarCurr,B)
          | v12586(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_217,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12586(VarCurr,B)
      <=> ( v12438(VarCurr,B)
          & v12587(VarCurr,B) ) ) ) ).

tff(addAssignment_6322,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,0)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6321,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,1)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6320,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,2)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6319,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,3)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6318,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,4)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6317,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,5)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6316,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,6)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6315,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,7)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6314,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,8)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6313,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,9)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6312,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,10)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6311,axiom,
    ! [VarCurr: state_type] :
      ( v12587(VarCurr,11)
    <=> v12588(VarCurr) ) ).

tff(addAssignment_6310,axiom,
    ! [VarCurr: state_type] :
      ( v12588(VarCurr)
    <=> v12557(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_216,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12567(VarCurr,B)
      <=> ( v12568(VarCurr,B)
          | v12583(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_215,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12583(VarCurr,B)
      <=> ( v12287(VarCurr,B)
          & v12584(VarCurr,B) ) ) ) ).

tff(addAssignment_6309,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,0)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6308,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,1)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6307,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,2)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6306,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,3)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6305,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,4)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6304,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,5)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6303,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,6)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6302,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,7)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6301,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,8)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6300,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,9)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6299,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,10)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6298,axiom,
    ! [VarCurr: state_type] :
      ( v12584(VarCurr,11)
    <=> v12585(VarCurr) ) ).

tff(addAssignment_6297,axiom,
    ! [VarCurr: state_type] :
      ( v12585(VarCurr)
    <=> v12407(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_214,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12568(VarCurr,B)
      <=> ( v12569(VarCurr,B)
          | v12580(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_213,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12580(VarCurr,B)
      <=> ( v12136(VarCurr,B)
          & v12581(VarCurr,B) ) ) ) ).

tff(addAssignment_6296,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,0)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6295,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,1)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6294,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,2)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6293,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,3)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6292,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,4)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6291,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,5)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6290,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,6)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6289,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,7)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6288,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,8)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6287,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,9)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6286,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,10)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6285,axiom,
    ! [VarCurr: state_type] :
      ( v12581(VarCurr,11)
    <=> v12582(VarCurr) ) ).

tff(addAssignment_6284,axiom,
    ! [VarCurr: state_type] :
      ( v12582(VarCurr)
    <=> v12256(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_212,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12569(VarCurr,B)
      <=> ( v12570(VarCurr,B)
          | v12577(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12577(VarCurr,B)
      <=> ( v11985(VarCurr,B)
          & v12578(VarCurr,B) ) ) ) ).

tff(addAssignment_6283,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,0)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6282,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,1)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6281,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,2)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6280,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,3)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6279,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,4)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6278,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,5)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6277,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,6)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6276,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,7)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6275,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,8)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6274,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,9)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6273,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,10)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6272,axiom,
    ! [VarCurr: state_type] :
      ( v12578(VarCurr,11)
    <=> v12579(VarCurr) ) ).

tff(addAssignment_6271,axiom,
    ! [VarCurr: state_type] :
      ( v12579(VarCurr)
    <=> v12105(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12570(VarCurr,B)
      <=> ( v12571(VarCurr,B)
          | v12574(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_209,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12574(VarCurr,B)
      <=> ( v11823(VarCurr,B)
          & v12575(VarCurr,B) ) ) ) ).

tff(addAssignment_6270,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,0)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6269,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,1)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6268,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,2)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6267,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,3)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6266,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,4)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6265,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,5)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6264,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,6)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6263,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,7)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6262,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,8)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6261,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,9)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6260,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,10)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6259,axiom,
    ! [VarCurr: state_type] :
      ( v12575(VarCurr,11)
    <=> v12576(VarCurr) ) ).

tff(addAssignment_6258,axiom,
    ! [VarCurr: state_type] :
      ( v12576(VarCurr)
    <=> v11954(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_208,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12571(VarCurr,B)
      <=> ( v11061(VarCurr,B)
          & v12572(VarCurr,B) ) ) ) ).

tff(addAssignment_6257,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,0)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6256,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,1)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6255,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,2)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6254,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,3)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6253,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,4)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6252,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,5)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6251,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,6)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6250,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,7)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6249,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,8)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6248,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,9)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6247,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,10)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6246,axiom,
    ! [VarCurr: state_type] :
      ( v12572(VarCurr,11)
    <=> v12573(VarCurr) ) ).

tff(addAssignment_6245,axiom,
    ! [VarCurr: state_type] :
      ( v12573(VarCurr)
    <=> v11531(VarCurr) ) ).

tff(addAssignment_6244,axiom,
    ! [VarCurr: state_type] :
      ( v12557(VarCurr)
    <=> v12559(VarCurr) ) ).

tff(addAssignment_6243,axiom,
    ! [VarCurr: state_type] :
      ( v12559(VarCurr)
    <=> v12561(VarCurr) ) ).

tff(addAssignment_6242,axiom,
    ! [VarCurr: state_type] :
      ( v12561(VarCurr)
    <=> v12563(VarCurr) ) ).

tff(addAssignment_6241,axiom,
    ! [VarCurr: state_type] :
      ( v12563(VarCurr)
    <=> v12565(VarCurr) ) ).

tff(addAssignment_6240,axiom,
    ! [VarCurr: state_type] :
      ( v12565(VarCurr)
    <=> v11624(VarCurr) ) ).

tff(addAssignment_6239,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12438(VarCurr,B)
      <=> v12440(VarCurr,B) ) ) ).

tff(addAssignment_6238,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12440(VarCurr,B)
      <=> v12442(VarCurr,B) ) ) ).

tff(addAssignment_6237,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12442(VarCurr,B)
      <=> v12444(VarCurr,B) ) ) ).

tff(addAssignment_6236,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12444(VarCurr,B)
      <=> v12446(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12540(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v12446(VarNext,B)
            <=> v12446(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_146,axiom,
    ! [VarNext: state_type] :
      ( v12540(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12446(VarNext,B)
          <=> v12550(VarNext,B) ) ) ) ).

tff(addAssignment_6235,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12550(VarNext,B)
          <=> v12548(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_111,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12548(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_111,axiom,
    ! [VarCurr: state_type] :
      ( v12551(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12548(VarCurr,B)
          <=> v12468(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1067,axiom,
    ! [VarCurr: state_type] :
      ( v12551(VarCurr)
    <=> ( v12552(VarCurr)
        & v12553(VarCurr) ) ) ).

tff(writeUnaryOperator_768,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12553(VarCurr)
    <=> v12458(VarCurr) ) ).

tff(writeUnaryOperator_767,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12552(VarCurr)
    <=> v12448(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12540(VarNext)
      <=> v12541(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12541(VarNext)
      <=> ( v12542(VarNext)
          & v12472(VarNext) ) ) ) ).

tff(writeUnaryOperator_766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12542(VarNext)
      <=> v12544(VarNext) ) ) ).

tff(addAssignment_6234,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12544(VarNext)
      <=> v12472(VarCurr) ) ) ).

tff(addAssignment_6233,axiom,
    ! [VarCurr: state_type] :
      ( v12472(VarCurr)
    <=> v12474(VarCurr) ) ).

tff(addAssignment_6232,axiom,
    ! [VarCurr: state_type] :
      ( v12474(VarCurr)
    <=> v12476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1064,axiom,
    ! [VarCurr: state_type] :
      ( v12476(VarCurr)
    <=> ( v12537(VarCurr)
        | v12533(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1063,axiom,
    ! [VarCurr: state_type] :
      ( v12537(VarCurr)
    <=> ( v12478(VarCurr)
        & v12482(VarCurr) ) ) ).

tff(addAssignment_6231,axiom,
    ! [VarCurr: state_type] :
      ( v12533(VarCurr)
    <=> v12535(VarCurr) ) ).

tff(addAssignment_6230,axiom,
    ! [VarCurr: state_type] :
      ( v12535(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12517(VarNext)
       => ( v12482(VarNext)
        <=> v12482(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_145,axiom,
    ! [VarNext: state_type] :
      ( v12517(VarNext)
     => ( v12482(VarNext)
      <=> v12527(VarNext) ) ) ).

tff(addAssignment_6229,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12527(VarNext)
      <=> v12525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1062,axiom,
    ! [VarCurr: state_type] :
      ( v12525(VarCurr)
    <=> ( v12528(VarCurr)
        & v12529(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1061,axiom,
    ! [VarCurr: state_type] :
      ( v12529(VarCurr)
    <=> ( v12488(VarCurr)
        | v12512(VarCurr) ) ) ).

tff(writeUnaryOperator_765,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12528(VarCurr)
    <=> v12484(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12517(VarNext)
      <=> v12518(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12518(VarNext)
      <=> ( v12520(VarNext)
          & v12522(VarNext) ) ) ) ).

tff(writeUnaryOperator_764,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12522(VarCurr)
    <=> v12478(VarCurr) ) ).

tff(addAssignment_6228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12520(VarNext)
      <=> v12478(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_40,axiom,
    ( v12482(constB0)
  <=> $true ) ).

tff(addAssignment_6227,axiom,
    ! [VarCurr: state_type] :
      ( v12512(VarCurr)
    <=> v12514(VarCurr) ) ).

tff(addAssignment_6226,axiom,
    ! [VarCurr: state_type] :
      ( v12514(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_6225,axiom,
    ! [VarCurr: state_type] :
      ( v12488(VarCurr)
    <=> v12490(VarCurr) ) ).

tff(addAssignment_6224,axiom,
    ! [VarCurr: state_type] :
      ( v12490(VarCurr)
    <=> v11798(VarCurr) ) ).

tff(addAssignment_6223,axiom,
    ! [VarCurr: state_type] :
      ( v11798(VarCurr)
    <=> v12493(VarCurr) ) ).

tff(addAssignment_6222,axiom,
    ! [VarCurr: state_type] :
      ( v12493(VarCurr)
    <=> v12495(VarCurr) ) ).

tff(writeUnaryOperator_763,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12495(VarCurr)
    <=> v12509(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1058,axiom,
    ! [VarCurr: state_type] :
      ( v12509(VarCurr)
    <=> ( v12510(VarCurr)
        | v12505(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1057,axiom,
    ! [VarCurr: state_type] :
      ( v12510(VarCurr)
    <=> ( v12497(VarCurr)
        | v12501(VarCurr) ) ) ).

tff(addAssignment_6221,axiom,
    ! [VarCurr: state_type] :
      ( v12505(VarCurr)
    <=> v12507(VarCurr) ) ).

tff(addAssignment_6220,axiom,
    ! [VarCurr: state_type] :
      ( v12507(VarCurr)
    <=> v11887(VarCurr,2) ) ).

tff(addAssignment_6219,axiom,
    ! [VarCurr: state_type] :
      ( v12501(VarCurr)
    <=> v12503(VarCurr) ) ).

tff(addAssignment_6218,axiom,
    ! [VarCurr: state_type] :
      ( v12503(VarCurr)
    <=> v11461(VarCurr,1) ) ).

tff(addAssignment_6217,axiom,
    ! [VarCurr: state_type] :
      ( v12497(VarCurr)
    <=> v12499(VarCurr) ) ).

tff(addAssignment_6216,axiom,
    ! [VarCurr: state_type] :
      ( v12499(VarCurr)
    <=> v11887(VarCurr,0) ) ).

tff(addAssignment_6215,axiom,
    ! [VarCurr: state_type] :
      ( v12484(VarCurr)
    <=> v12486(VarCurr) ) ).

tff(addAssignment_6214,axiom,
    ! [VarCurr: state_type] :
      ( v12486(VarCurr)
    <=> $false ) ).

tff(addAssignment_6213,axiom,
    ! [VarCurr: state_type] :
      ( v12478(VarCurr)
    <=> v12480(VarCurr) ) ).

tff(addAssignment_6212,axiom,
    ! [VarCurr: state_type] :
      ( v12480(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_6211,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12468(VarCurr,B)
      <=> v12470(VarCurr,B) ) ) ).

tff(addAssignment_6210,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12470(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_6209,axiom,
    ! [VarCurr: state_type] :
      ( v12458(VarCurr)
    <=> v12460(VarCurr) ) ).

tff(addAssignment_6208,axiom,
    ! [VarCurr: state_type] :
      ( v12460(VarCurr)
    <=> v12462(VarCurr) ) ).

tff(addAssignment_6207,axiom,
    ! [VarCurr: state_type] :
      ( v12462(VarCurr)
    <=> v12464(VarCurr) ) ).

tff(addAssignment_6206,axiom,
    ! [VarCurr: state_type] :
      ( v12464(VarCurr)
    <=> v12466(VarCurr) ) ).

tff(addAssignment_6205,axiom,
    ! [VarCurr: state_type] :
      ( v12466(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_6204,axiom,
    ! [VarCurr: state_type] :
      ( v12448(VarCurr)
    <=> v12450(VarCurr) ) ).

tff(addAssignment_6203,axiom,
    ! [VarCurr: state_type] :
      ( v12450(VarCurr)
    <=> v12452(VarCurr) ) ).

tff(addAssignment_6202,axiom,
    ! [VarCurr: state_type] :
      ( v12452(VarCurr)
    <=> v12454(VarCurr) ) ).

tff(addAssignment_6201,axiom,
    ! [VarCurr: state_type] :
      ( v12454(VarCurr)
    <=> v12456(VarCurr) ) ).

tff(addAssignment_6200,axiom,
    ! [VarCurr: state_type] :
      ( v12456(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_6199,axiom,
    ! [VarCurr: state_type] :
      ( v12407(VarCurr)
    <=> v12409(VarCurr) ) ).

tff(addAssignment_6198,axiom,
    ! [VarCurr: state_type] :
      ( v12409(VarCurr)
    <=> v12411(VarCurr) ) ).

tff(addAssignment_6197,axiom,
    ! [VarCurr: state_type] :
      ( v12411(VarCurr)
    <=> v12413(VarCurr) ) ).

tff(addAssignment_6196,axiom,
    ! [VarCurr: state_type] :
      ( v12413(VarCurr)
    <=> v12415(VarCurr) ) ).

tff(addAssignment_6195,axiom,
    ! [VarCurr: state_type] :
      ( v12415(VarCurr)
    <=> v12417(VarCurr) ) ).

tff(addAssignment_6194,axiom,
    ! [VarCurr: state_type] :
      ( v12417(VarCurr)
    <=> v12419(VarCurr) ) ).

tff(addAssignment_6193,axiom,
    ! [VarCurr: state_type] :
      ( v12419(VarCurr)
    <=> v12421(VarCurr) ) ).

tff(writeUnaryOperator_762,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12421(VarCurr)
    <=> v12435(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1056,axiom,
    ! [VarCurr: state_type] :
      ( v12435(VarCurr)
    <=> ( v12436(VarCurr)
        | v12431(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1055,axiom,
    ! [VarCurr: state_type] :
      ( v12436(VarCurr)
    <=> ( v12423(VarCurr)
        | v12427(VarCurr) ) ) ).

tff(addAssignment_6192,axiom,
    ! [VarCurr: state_type] :
      ( v12431(VarCurr)
    <=> v12433(VarCurr) ) ).

tff(addAssignment_6191,axiom,
    ! [VarCurr: state_type] :
      ( v12433(VarCurr)
    <=> v11634(VarCurr,2) ) ).

tff(addAssignment_6190,axiom,
    ! [VarCurr: state_type] :
      ( v12427(VarCurr)
    <=> v12429(VarCurr) ) ).

tff(addAssignment_6189,axiom,
    ! [VarCurr: state_type] :
      ( v12429(VarCurr)
    <=> v11551(VarCurr,1) ) ).

tff(addAssignment_6188,axiom,
    ! [VarCurr: state_type] :
      ( v12423(VarCurr)
    <=> v12425(VarCurr) ) ).

tff(addAssignment_6187,axiom,
    ! [VarCurr: state_type] :
      ( v12425(VarCurr)
    <=> v11551(VarCurr,0) ) ).

tff(addAssignment_6186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12287(VarCurr,B)
      <=> v12289(VarCurr,B) ) ) ).

tff(addAssignment_6185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12289(VarCurr,B)
      <=> v12291(VarCurr,B) ) ) ).

tff(addAssignment_6184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12291(VarCurr,B)
      <=> v12293(VarCurr,B) ) ) ).

tff(addAssignment_6183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12293(VarCurr,B)
      <=> v12295(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_144,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12390(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v12295(VarNext,B)
            <=> v12295(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_144,axiom,
    ! [VarNext: state_type] :
      ( v12390(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12295(VarNext,B)
          <=> v12400(VarNext,B) ) ) ) ).

tff(addAssignment_6182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12400(VarNext,B)
          <=> v12398(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12398(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_110,axiom,
    ! [VarCurr: state_type] :
      ( v12401(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12398(VarCurr,B)
          <=> v12317(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1054,axiom,
    ! [VarCurr: state_type] :
      ( v12401(VarCurr)
    <=> ( v12402(VarCurr)
        & v12403(VarCurr) ) ) ).

tff(writeUnaryOperator_761,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12403(VarCurr)
    <=> v12307(VarCurr) ) ).

tff(writeUnaryOperator_760,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12402(VarCurr)
    <=> v12297(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1053,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12390(VarNext)
      <=> v12391(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1052,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12391(VarNext)
      <=> ( v12392(VarNext)
          & v12321(VarNext) ) ) ) ).

tff(writeUnaryOperator_759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12392(VarNext)
      <=> v12394(VarNext) ) ) ).

tff(addAssignment_6181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12394(VarNext)
      <=> v12321(VarCurr) ) ) ).

tff(addAssignment_6180,axiom,
    ! [VarCurr: state_type] :
      ( v12321(VarCurr)
    <=> v12323(VarCurr) ) ).

tff(addAssignment_6179,axiom,
    ! [VarCurr: state_type] :
      ( v12323(VarCurr)
    <=> v12325(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1051,axiom,
    ! [VarCurr: state_type] :
      ( v12325(VarCurr)
    <=> ( v12387(VarCurr)
        | v12383(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1050,axiom,
    ! [VarCurr: state_type] :
      ( v12387(VarCurr)
    <=> ( v12327(VarCurr)
        & v12331(VarCurr) ) ) ).

tff(addAssignment_6178,axiom,
    ! [VarCurr: state_type] :
      ( v12383(VarCurr)
    <=> v12385(VarCurr) ) ).

tff(addAssignment_6177,axiom,
    ! [VarCurr: state_type] :
      ( v12385(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_143,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12367(VarNext)
       => ( v12331(VarNext)
        <=> v12331(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_143,axiom,
    ! [VarNext: state_type] :
      ( v12367(VarNext)
     => ( v12331(VarNext)
      <=> v12377(VarNext) ) ) ).

tff(addAssignment_6176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12377(VarNext)
      <=> v12375(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1049,axiom,
    ! [VarCurr: state_type] :
      ( v12375(VarCurr)
    <=> ( v12378(VarCurr)
        & v12379(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1048,axiom,
    ! [VarCurr: state_type] :
      ( v12379(VarCurr)
    <=> ( v12337(VarCurr)
        | v12362(VarCurr) ) ) ).

tff(writeUnaryOperator_758,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12378(VarCurr)
    <=> v12333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1047,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12367(VarNext)
      <=> v12368(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1046,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12368(VarNext)
      <=> ( v12370(VarNext)
          & v12372(VarNext) ) ) ) ).

tff(writeUnaryOperator_757,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12372(VarCurr)
    <=> v12327(VarCurr) ) ).

tff(addAssignment_6175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12370(VarNext)
      <=> v12327(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_39,axiom,
    ( v12331(constB0)
  <=> $true ) ).

tff(addAssignment_6174,axiom,
    ! [VarCurr: state_type] :
      ( v12362(VarCurr)
    <=> v12364(VarCurr) ) ).

tff(addAssignment_6173,axiom,
    ! [VarCurr: state_type] :
      ( v12364(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_6172,axiom,
    ! [VarCurr: state_type] :
      ( v12337(VarCurr)
    <=> v12339(VarCurr) ) ).

tff(addAssignment_6171,axiom,
    ! [VarCurr: state_type] :
      ( v12339(VarCurr)
    <=> v12341(VarCurr) ) ).

tff(addAssignment_6170,axiom,
    ! [VarCurr: state_type] :
      ( v12341(VarCurr)
    <=> v12343(VarCurr) ) ).

tff(addAssignment_6169,axiom,
    ! [VarCurr: state_type] :
      ( v12343(VarCurr)
    <=> v12345(VarCurr) ) ).

tff(writeUnaryOperator_756,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12345(VarCurr)
    <=> v12359(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1045,axiom,
    ! [VarCurr: state_type] :
      ( v12359(VarCurr)
    <=> ( v12360(VarCurr)
        | v12355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1044,axiom,
    ! [VarCurr: state_type] :
      ( v12360(VarCurr)
    <=> ( v12347(VarCurr)
        | v12351(VarCurr) ) ) ).

tff(addAssignment_6168,axiom,
    ! [VarCurr: state_type] :
      ( v12355(VarCurr)
    <=> v12357(VarCurr) ) ).

tff(addAssignment_6167,axiom,
    ! [VarCurr: state_type] :
      ( v12357(VarCurr)
    <=> v11887(VarCurr,2) ) ).

tff(addAssignment_6166,axiom,
    ! [VarCurr: state_type] :
      ( v11887(VarCurr,2)
    <=> v11889(VarCurr,2) ) ).

tff(addAssignment_6165,axiom,
    ! [VarCurr: state_type] :
      ( v11889(VarCurr,2)
    <=> v11891(VarCurr,2) ) ).

tff(addAssignment_6164,axiom,
    ! [VarCurr: state_type] :
      ( v11891(VarCurr,2)
    <=> v11896(VarCurr,2) ) ).

tff(addAssignment_6163,axiom,
    ! [VarCurr: state_type] :
      ( v11893(VarCurr,2)
    <=> v11895(VarCurr,2) ) ).

tff(addAssignment_6162,axiom,
    ! [VarCurr: state_type] :
      ( v11895(VarCurr,2)
    <=> v11461(VarCurr,2) ) ).

tff(addAssignment_6161,axiom,
    ! [VarCurr: state_type] :
      ( v12351(VarCurr)
    <=> v12353(VarCurr) ) ).

tff(addAssignment_6160,axiom,
    ! [VarCurr: state_type] :
      ( v12353(VarCurr)
    <=> v11461(VarCurr,1) ) ).

tff(addAssignment_6159,axiom,
    ! [VarCurr: state_type] :
      ( v12347(VarCurr)
    <=> v12349(VarCurr) ) ).

tff(addAssignment_6158,axiom,
    ! [VarCurr: state_type] :
      ( v12349(VarCurr)
    <=> v11461(VarCurr,0) ) ).

tff(addAssignment_6157,axiom,
    ! [VarCurr: state_type] :
      ( v12333(VarCurr)
    <=> v12335(VarCurr) ) ).

tff(addAssignment_6156,axiom,
    ! [VarCurr: state_type] :
      ( v12335(VarCurr)
    <=> $false ) ).

tff(addAssignment_6155,axiom,
    ! [VarCurr: state_type] :
      ( v12327(VarCurr)
    <=> v12329(VarCurr) ) ).

tff(addAssignment_6154,axiom,
    ! [VarCurr: state_type] :
      ( v12329(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_6153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12317(VarCurr,B)
      <=> v12319(VarCurr,B) ) ) ).

tff(addAssignment_6152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12319(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_6151,axiom,
    ! [VarCurr: state_type] :
      ( v12307(VarCurr)
    <=> v12309(VarCurr) ) ).

tff(addAssignment_6150,axiom,
    ! [VarCurr: state_type] :
      ( v12309(VarCurr)
    <=> v12311(VarCurr) ) ).

tff(addAssignment_6149,axiom,
    ! [VarCurr: state_type] :
      ( v12311(VarCurr)
    <=> v12313(VarCurr) ) ).

tff(addAssignment_6148,axiom,
    ! [VarCurr: state_type] :
      ( v12313(VarCurr)
    <=> v12315(VarCurr) ) ).

tff(addAssignment_6147,axiom,
    ! [VarCurr: state_type] :
      ( v12315(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_6146,axiom,
    ! [VarCurr: state_type] :
      ( v12297(VarCurr)
    <=> v12299(VarCurr) ) ).

tff(addAssignment_6145,axiom,
    ! [VarCurr: state_type] :
      ( v12299(VarCurr)
    <=> v12301(VarCurr) ) ).

tff(addAssignment_6144,axiom,
    ! [VarCurr: state_type] :
      ( v12301(VarCurr)
    <=> v12303(VarCurr) ) ).

tff(addAssignment_6143,axiom,
    ! [VarCurr: state_type] :
      ( v12303(VarCurr)
    <=> v12305(VarCurr) ) ).

tff(addAssignment_6142,axiom,
    ! [VarCurr: state_type] :
      ( v12305(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_6141,axiom,
    ! [VarCurr: state_type] :
      ( v12256(VarCurr)
    <=> v12258(VarCurr) ) ).

tff(addAssignment_6140,axiom,
    ! [VarCurr: state_type] :
      ( v12258(VarCurr)
    <=> v12260(VarCurr) ) ).

tff(addAssignment_6139,axiom,
    ! [VarCurr: state_type] :
      ( v12260(VarCurr)
    <=> v12262(VarCurr) ) ).

tff(addAssignment_6138,axiom,
    ! [VarCurr: state_type] :
      ( v12262(VarCurr)
    <=> v12264(VarCurr) ) ).

tff(addAssignment_6137,axiom,
    ! [VarCurr: state_type] :
      ( v12264(VarCurr)
    <=> v12266(VarCurr) ) ).

tff(addAssignment_6136,axiom,
    ! [VarCurr: state_type] :
      ( v12266(VarCurr)
    <=> v12268(VarCurr) ) ).

tff(addAssignment_6135,axiom,
    ! [VarCurr: state_type] :
      ( v12268(VarCurr)
    <=> v12270(VarCurr) ) ).

tff(writeUnaryOperator_755,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12270(VarCurr)
    <=> v12284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1043,axiom,
    ! [VarCurr: state_type] :
      ( v12284(VarCurr)
    <=> ( v12285(VarCurr)
        | v12280(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1042,axiom,
    ! [VarCurr: state_type] :
      ( v12285(VarCurr)
    <=> ( v12272(VarCurr)
        | v12276(VarCurr) ) ) ).

tff(addAssignment_6134,axiom,
    ! [VarCurr: state_type] :
      ( v12280(VarCurr)
    <=> v12282(VarCurr) ) ).

tff(addAssignment_6133,axiom,
    ! [VarCurr: state_type] :
      ( v12282(VarCurr)
    <=> v11551(VarCurr,2) ) ).

tff(addAssignment_6132,axiom,
    ! [VarCurr: state_type] :
      ( v12276(VarCurr)
    <=> v12278(VarCurr) ) ).

tff(addAssignment_6131,axiom,
    ! [VarCurr: state_type] :
      ( v12278(VarCurr)
    <=> v11634(VarCurr,1) ) ).

tff(addAssignment_6130,axiom,
    ! [VarCurr: state_type] :
      ( v12272(VarCurr)
    <=> v12274(VarCurr) ) ).

tff(addAssignment_6129,axiom,
    ! [VarCurr: state_type] :
      ( v12274(VarCurr)
    <=> v11634(VarCurr,0) ) ).

tff(addAssignment_6128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12136(VarCurr,B)
      <=> v12138(VarCurr,B) ) ) ).

tff(addAssignment_6127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12138(VarCurr,B)
      <=> v12140(VarCurr,B) ) ) ).

tff(addAssignment_6126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12140(VarCurr,B)
      <=> v12142(VarCurr,B) ) ) ).

tff(addAssignment_6125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12142(VarCurr,B)
      <=> v12144(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_142,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12239(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v12144(VarNext,B)
            <=> v12144(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_142,axiom,
    ! [VarNext: state_type] :
      ( v12239(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12144(VarNext,B)
          <=> v12249(VarNext,B) ) ) ) ).

tff(addAssignment_6124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12249(VarNext,B)
          <=> v12247(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12247(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_109,axiom,
    ! [VarCurr: state_type] :
      ( v12250(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12247(VarCurr,B)
          <=> v12166(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1041,axiom,
    ! [VarCurr: state_type] :
      ( v12250(VarCurr)
    <=> ( v12251(VarCurr)
        & v12252(VarCurr) ) ) ).

tff(writeUnaryOperator_754,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12252(VarCurr)
    <=> v12156(VarCurr) ) ).

tff(writeUnaryOperator_753,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12251(VarCurr)
    <=> v12146(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1040,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12239(VarNext)
      <=> v12240(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1039,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12240(VarNext)
      <=> ( v12241(VarNext)
          & v12170(VarNext) ) ) ) ).

tff(writeUnaryOperator_752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12241(VarNext)
      <=> v12243(VarNext) ) ) ).

tff(addAssignment_6123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12243(VarNext)
      <=> v12170(VarCurr) ) ) ).

tff(addAssignment_6122,axiom,
    ! [VarCurr: state_type] :
      ( v12170(VarCurr)
    <=> v12172(VarCurr) ) ).

tff(addAssignment_6121,axiom,
    ! [VarCurr: state_type] :
      ( v12172(VarCurr)
    <=> v12174(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1038,axiom,
    ! [VarCurr: state_type] :
      ( v12174(VarCurr)
    <=> ( v12236(VarCurr)
        | v12232(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1037,axiom,
    ! [VarCurr: state_type] :
      ( v12236(VarCurr)
    <=> ( v12176(VarCurr)
        & v12180(VarCurr) ) ) ).

tff(addAssignment_6120,axiom,
    ! [VarCurr: state_type] :
      ( v12232(VarCurr)
    <=> v12234(VarCurr) ) ).

tff(addAssignment_6119,axiom,
    ! [VarCurr: state_type] :
      ( v12234(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12216(VarNext)
       => ( v12180(VarNext)
        <=> v12180(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_141,axiom,
    ! [VarNext: state_type] :
      ( v12216(VarNext)
     => ( v12180(VarNext)
      <=> v12226(VarNext) ) ) ).

tff(addAssignment_6118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12226(VarNext)
      <=> v12224(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1036,axiom,
    ! [VarCurr: state_type] :
      ( v12224(VarCurr)
    <=> ( v12227(VarCurr)
        & v12228(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1035,axiom,
    ! [VarCurr: state_type] :
      ( v12228(VarCurr)
    <=> ( v12186(VarCurr)
        | v12211(VarCurr) ) ) ).

tff(writeUnaryOperator_751,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12227(VarCurr)
    <=> v12182(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1034,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12216(VarNext)
      <=> v12217(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1033,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12217(VarNext)
      <=> ( v12219(VarNext)
          & v12221(VarNext) ) ) ) ).

tff(writeUnaryOperator_750,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12221(VarCurr)
    <=> v12176(VarCurr) ) ).

tff(addAssignment_6117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12219(VarNext)
      <=> v12176(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_38,axiom,
    ( v12180(constB0)
  <=> $true ) ).

tff(addAssignment_6116,axiom,
    ! [VarCurr: state_type] :
      ( v12211(VarCurr)
    <=> v12213(VarCurr) ) ).

tff(addAssignment_6115,axiom,
    ! [VarCurr: state_type] :
      ( v12213(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_6114,axiom,
    ! [VarCurr: state_type] :
      ( v12186(VarCurr)
    <=> v12188(VarCurr) ) ).

tff(addAssignment_6113,axiom,
    ! [VarCurr: state_type] :
      ( v12188(VarCurr)
    <=> v12190(VarCurr) ) ).

tff(addAssignment_6112,axiom,
    ! [VarCurr: state_type] :
      ( v12190(VarCurr)
    <=> v12192(VarCurr) ) ).

tff(addAssignment_6111,axiom,
    ! [VarCurr: state_type] :
      ( v12192(VarCurr)
    <=> v12194(VarCurr) ) ).

tff(writeUnaryOperator_749,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12194(VarCurr)
    <=> v12208(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1032,axiom,
    ! [VarCurr: state_type] :
      ( v12208(VarCurr)
    <=> ( v12209(VarCurr)
        | v12204(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1031,axiom,
    ! [VarCurr: state_type] :
      ( v12209(VarCurr)
    <=> ( v12196(VarCurr)
        | v12200(VarCurr) ) ) ).

tff(addAssignment_6110,axiom,
    ! [VarCurr: state_type] :
      ( v12204(VarCurr)
    <=> v12206(VarCurr) ) ).

tff(addAssignment_6109,axiom,
    ! [VarCurr: state_type] :
      ( v12206(VarCurr)
    <=> v11461(VarCurr,2) ) ).

tff(addAssignment_6108,axiom,
    ! [VarCurr: state_type] :
      ( v12200(VarCurr)
    <=> v12202(VarCurr) ) ).

tff(addAssignment_6107,axiom,
    ! [VarCurr: state_type] :
      ( v12202(VarCurr)
    <=> v11887(VarCurr,1) ) ).

tff(addAssignment_6106,axiom,
    ! [VarCurr: state_type] :
      ( v12196(VarCurr)
    <=> v12198(VarCurr) ) ).

tff(addAssignment_6105,axiom,
    ! [VarCurr: state_type] :
      ( v12198(VarCurr)
    <=> v11887(VarCurr,0) ) ).

tff(addAssignment_6104,axiom,
    ! [VarCurr: state_type] :
      ( v12182(VarCurr)
    <=> v12184(VarCurr) ) ).

tff(addAssignment_6103,axiom,
    ! [VarCurr: state_type] :
      ( v12184(VarCurr)
    <=> $false ) ).

tff(addAssignment_6102,axiom,
    ! [VarCurr: state_type] :
      ( v12176(VarCurr)
    <=> v12178(VarCurr) ) ).

tff(addAssignment_6101,axiom,
    ! [VarCurr: state_type] :
      ( v12178(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_6100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12166(VarCurr,B)
      <=> v12168(VarCurr,B) ) ) ).

tff(addAssignment_6099,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12168(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_6098,axiom,
    ! [VarCurr: state_type] :
      ( v12156(VarCurr)
    <=> v12158(VarCurr) ) ).

tff(addAssignment_6097,axiom,
    ! [VarCurr: state_type] :
      ( v12158(VarCurr)
    <=> v12160(VarCurr) ) ).

tff(addAssignment_6096,axiom,
    ! [VarCurr: state_type] :
      ( v12160(VarCurr)
    <=> v12162(VarCurr) ) ).

tff(addAssignment_6095,axiom,
    ! [VarCurr: state_type] :
      ( v12162(VarCurr)
    <=> v12164(VarCurr) ) ).

tff(addAssignment_6094,axiom,
    ! [VarCurr: state_type] :
      ( v12164(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_6093,axiom,
    ! [VarCurr: state_type] :
      ( v12146(VarCurr)
    <=> v12148(VarCurr) ) ).

tff(addAssignment_6092,axiom,
    ! [VarCurr: state_type] :
      ( v12148(VarCurr)
    <=> v12150(VarCurr) ) ).

tff(addAssignment_6091,axiom,
    ! [VarCurr: state_type] :
      ( v12150(VarCurr)
    <=> v12152(VarCurr) ) ).

tff(addAssignment_6090,axiom,
    ! [VarCurr: state_type] :
      ( v12152(VarCurr)
    <=> v12154(VarCurr) ) ).

tff(addAssignment_6089,axiom,
    ! [VarCurr: state_type] :
      ( v12154(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_6088,axiom,
    ! [VarCurr: state_type] :
      ( v12105(VarCurr)
    <=> v12107(VarCurr) ) ).

tff(addAssignment_6087,axiom,
    ! [VarCurr: state_type] :
      ( v12107(VarCurr)
    <=> v12109(VarCurr) ) ).

tff(addAssignment_6086,axiom,
    ! [VarCurr: state_type] :
      ( v12109(VarCurr)
    <=> v12111(VarCurr) ) ).

tff(addAssignment_6085,axiom,
    ! [VarCurr: state_type] :
      ( v12111(VarCurr)
    <=> v12113(VarCurr) ) ).

tff(addAssignment_6084,axiom,
    ! [VarCurr: state_type] :
      ( v12113(VarCurr)
    <=> v12115(VarCurr) ) ).

tff(addAssignment_6083,axiom,
    ! [VarCurr: state_type] :
      ( v12115(VarCurr)
    <=> v12117(VarCurr) ) ).

tff(addAssignment_6082,axiom,
    ! [VarCurr: state_type] :
      ( v12117(VarCurr)
    <=> v12119(VarCurr) ) ).

tff(writeUnaryOperator_748,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12119(VarCurr)
    <=> v12133(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1030,axiom,
    ! [VarCurr: state_type] :
      ( v12133(VarCurr)
    <=> ( v12134(VarCurr)
        | v12129(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1029,axiom,
    ! [VarCurr: state_type] :
      ( v12134(VarCurr)
    <=> ( v12121(VarCurr)
        | v12125(VarCurr) ) ) ).

tff(addAssignment_6081,axiom,
    ! [VarCurr: state_type] :
      ( v12129(VarCurr)
    <=> v12131(VarCurr) ) ).

tff(addAssignment_6080,axiom,
    ! [VarCurr: state_type] :
      ( v12131(VarCurr)
    <=> v11551(VarCurr,2) ) ).

tff(addAssignment_6079,axiom,
    ! [VarCurr: state_type] :
      ( v12125(VarCurr)
    <=> v12127(VarCurr) ) ).

tff(addAssignment_6078,axiom,
    ! [VarCurr: state_type] :
      ( v12127(VarCurr)
    <=> v11634(VarCurr,1) ) ).

tff(addAssignment_6077,axiom,
    ! [VarCurr: state_type] :
      ( v11634(VarCurr,1)
    <=> v11636(VarCurr,1) ) ).

tff(addAssignment_6076,axiom,
    ! [VarCurr: state_type] :
      ( v11636(VarCurr,1)
    <=> v11638(VarCurr,1) ) ).

tff(addAssignment_6075,axiom,
    ! [VarCurr: state_type] :
      ( v11638(VarCurr,1)
    <=> v11643(VarCurr,1) ) ).

tff(addAssignment_6074,axiom,
    ! [VarCurr: state_type] :
      ( v11640(VarCurr,1)
    <=> v11642(VarCurr,1) ) ).

tff(addAssignment_6073,axiom,
    ! [VarCurr: state_type] :
      ( v11642(VarCurr,1)
    <=> v11551(VarCurr,1) ) ).

tff(addAssignment_6072,axiom,
    ! [VarCurr: state_type] :
      ( v12121(VarCurr)
    <=> v12123(VarCurr) ) ).

tff(addAssignment_6071,axiom,
    ! [VarCurr: state_type] :
      ( v12123(VarCurr)
    <=> v11551(VarCurr,0) ) ).

tff(addAssignment_6070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11985(VarCurr,B)
      <=> v11987(VarCurr,B) ) ) ).

tff(addAssignment_6069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11987(VarCurr,B)
      <=> v11989(VarCurr,B) ) ) ).

tff(addAssignment_6068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11989(VarCurr,B)
      <=> v11991(VarCurr,B) ) ) ).

tff(addAssignment_6067,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11991(VarCurr,B)
      <=> v11993(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12088(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v11993(VarNext,B)
            <=> v11993(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_140,axiom,
    ! [VarNext: state_type] :
      ( v12088(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11993(VarNext,B)
          <=> v12098(VarNext,B) ) ) ) ).

tff(addAssignment_6066,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12098(VarNext,B)
          <=> v12096(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_108,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12099(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12096(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_108,axiom,
    ! [VarCurr: state_type] :
      ( v12099(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v12096(VarCurr,B)
          <=> v12015(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1028,axiom,
    ! [VarCurr: state_type] :
      ( v12099(VarCurr)
    <=> ( v12100(VarCurr)
        & v12101(VarCurr) ) ) ).

tff(writeUnaryOperator_747,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12101(VarCurr)
    <=> v12005(VarCurr) ) ).

tff(writeUnaryOperator_746,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12100(VarCurr)
    <=> v11995(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1027,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12088(VarNext)
      <=> v12089(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1026,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12089(VarNext)
      <=> ( v12090(VarNext)
          & v12019(VarNext) ) ) ) ).

tff(writeUnaryOperator_745,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12090(VarNext)
      <=> v12092(VarNext) ) ) ).

tff(addAssignment_6065,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12092(VarNext)
      <=> v12019(VarCurr) ) ) ).

tff(addAssignment_6064,axiom,
    ! [VarCurr: state_type] :
      ( v12019(VarCurr)
    <=> v12021(VarCurr) ) ).

tff(addAssignment_6063,axiom,
    ! [VarCurr: state_type] :
      ( v12021(VarCurr)
    <=> v12023(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1025,axiom,
    ! [VarCurr: state_type] :
      ( v12023(VarCurr)
    <=> ( v12085(VarCurr)
        | v12081(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1024,axiom,
    ! [VarCurr: state_type] :
      ( v12085(VarCurr)
    <=> ( v12025(VarCurr)
        & v12029(VarCurr) ) ) ).

tff(addAssignment_6062,axiom,
    ! [VarCurr: state_type] :
      ( v12081(VarCurr)
    <=> v12083(VarCurr) ) ).

tff(addAssignment_6061,axiom,
    ! [VarCurr: state_type] :
      ( v12083(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_139,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v12065(VarNext)
       => ( v12029(VarNext)
        <=> v12029(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_139,axiom,
    ! [VarNext: state_type] :
      ( v12065(VarNext)
     => ( v12029(VarNext)
      <=> v12075(VarNext) ) ) ).

tff(addAssignment_6060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12075(VarNext)
      <=> v12073(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1023,axiom,
    ! [VarCurr: state_type] :
      ( v12073(VarCurr)
    <=> ( v12076(VarCurr)
        & v12077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1022,axiom,
    ! [VarCurr: state_type] :
      ( v12077(VarCurr)
    <=> ( v12035(VarCurr)
        | v12060(VarCurr) ) ) ).

tff(writeUnaryOperator_744,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12076(VarCurr)
    <=> v12031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1021,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12065(VarNext)
      <=> v12066(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1020,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12066(VarNext)
      <=> ( v12068(VarNext)
          & v12070(VarNext) ) ) ) ).

tff(writeUnaryOperator_743,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12070(VarCurr)
    <=> v12025(VarCurr) ) ).

tff(addAssignment_6059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v12068(VarNext)
      <=> v12025(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_37,axiom,
    ( v12029(constB0)
  <=> $true ) ).

tff(addAssignment_6058,axiom,
    ! [VarCurr: state_type] :
      ( v12060(VarCurr)
    <=> v12062(VarCurr) ) ).

tff(addAssignment_6057,axiom,
    ! [VarCurr: state_type] :
      ( v12062(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_6056,axiom,
    ! [VarCurr: state_type] :
      ( v12035(VarCurr)
    <=> v12037(VarCurr) ) ).

tff(addAssignment_6055,axiom,
    ! [VarCurr: state_type] :
      ( v12037(VarCurr)
    <=> v12039(VarCurr) ) ).

tff(addAssignment_6054,axiom,
    ! [VarCurr: state_type] :
      ( v12039(VarCurr)
    <=> v12041(VarCurr) ) ).

tff(addAssignment_6053,axiom,
    ! [VarCurr: state_type] :
      ( v12041(VarCurr)
    <=> v12043(VarCurr) ) ).

tff(writeUnaryOperator_742,axiom,
    ! [VarCurr: state_type] :
      ( ~ v12043(VarCurr)
    <=> v12057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1019,axiom,
    ! [VarCurr: state_type] :
      ( v12057(VarCurr)
    <=> ( v12058(VarCurr)
        | v12053(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1018,axiom,
    ! [VarCurr: state_type] :
      ( v12058(VarCurr)
    <=> ( v12045(VarCurr)
        | v12049(VarCurr) ) ) ).

tff(addAssignment_6052,axiom,
    ! [VarCurr: state_type] :
      ( v12053(VarCurr)
    <=> v12055(VarCurr) ) ).

tff(addAssignment_6051,axiom,
    ! [VarCurr: state_type] :
      ( v12055(VarCurr)
    <=> v11461(VarCurr,2) ) ).

tff(addAssignment_6050,axiom,
    ! [VarCurr: state_type] :
      ( v12049(VarCurr)
    <=> v12051(VarCurr) ) ).

tff(addAssignment_6049,axiom,
    ! [VarCurr: state_type] :
      ( v12051(VarCurr)
    <=> v11887(VarCurr,1) ) ).

tff(addAssignment_6048,axiom,
    ! [VarCurr: state_type] :
      ( v11887(VarCurr,1)
    <=> v11889(VarCurr,1) ) ).

tff(addAssignment_6047,axiom,
    ! [VarCurr: state_type] :
      ( v11889(VarCurr,1)
    <=> v11891(VarCurr,1) ) ).

tff(addAssignment_6046,axiom,
    ! [VarCurr: state_type] :
      ( v11891(VarCurr,1)
    <=> v11896(VarCurr,1) ) ).

tff(addAssignment_6045,axiom,
    ! [VarCurr: state_type] :
      ( v11893(VarCurr,1)
    <=> v11895(VarCurr,1) ) ).

tff(addAssignment_6044,axiom,
    ! [VarCurr: state_type] :
      ( v11895(VarCurr,1)
    <=> v11461(VarCurr,1) ) ).

tff(addAssignment_6043,axiom,
    ! [VarCurr: state_type] :
      ( v12045(VarCurr)
    <=> v12047(VarCurr) ) ).

tff(addAssignment_6042,axiom,
    ! [VarCurr: state_type] :
      ( v12047(VarCurr)
    <=> v11461(VarCurr,0) ) ).

tff(addAssignment_6041,axiom,
    ! [VarCurr: state_type] :
      ( v12031(VarCurr)
    <=> v12033(VarCurr) ) ).

tff(addAssignment_6040,axiom,
    ! [VarCurr: state_type] :
      ( v12033(VarCurr)
    <=> $false ) ).

tff(addAssignment_6039,axiom,
    ! [VarCurr: state_type] :
      ( v12025(VarCurr)
    <=> v12027(VarCurr) ) ).

tff(addAssignment_6038,axiom,
    ! [VarCurr: state_type] :
      ( v12027(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_6037,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12015(VarCurr,B)
      <=> v12017(VarCurr,B) ) ) ).

tff(addAssignment_6036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v12017(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_6035,axiom,
    ! [VarCurr: state_type] :
      ( v12005(VarCurr)
    <=> v12007(VarCurr) ) ).

tff(addAssignment_6034,axiom,
    ! [VarCurr: state_type] :
      ( v12007(VarCurr)
    <=> v12009(VarCurr) ) ).

tff(addAssignment_6033,axiom,
    ! [VarCurr: state_type] :
      ( v12009(VarCurr)
    <=> v12011(VarCurr) ) ).

tff(addAssignment_6032,axiom,
    ! [VarCurr: state_type] :
      ( v12011(VarCurr)
    <=> v12013(VarCurr) ) ).

tff(addAssignment_6031,axiom,
    ! [VarCurr: state_type] :
      ( v12013(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_6030,axiom,
    ! [VarCurr: state_type] :
      ( v11995(VarCurr)
    <=> v11997(VarCurr) ) ).

tff(addAssignment_6029,axiom,
    ! [VarCurr: state_type] :
      ( v11997(VarCurr)
    <=> v11999(VarCurr) ) ).

tff(addAssignment_6028,axiom,
    ! [VarCurr: state_type] :
      ( v11999(VarCurr)
    <=> v12001(VarCurr) ) ).

tff(addAssignment_6027,axiom,
    ! [VarCurr: state_type] :
      ( v12001(VarCurr)
    <=> v12003(VarCurr) ) ).

tff(addAssignment_6026,axiom,
    ! [VarCurr: state_type] :
      ( v12003(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_6025,axiom,
    ! [VarCurr: state_type] :
      ( v11954(VarCurr)
    <=> v11956(VarCurr) ) ).

tff(addAssignment_6024,axiom,
    ! [VarCurr: state_type] :
      ( v11956(VarCurr)
    <=> v11958(VarCurr) ) ).

tff(addAssignment_6023,axiom,
    ! [VarCurr: state_type] :
      ( v11958(VarCurr)
    <=> v11960(VarCurr) ) ).

tff(addAssignment_6022,axiom,
    ! [VarCurr: state_type] :
      ( v11960(VarCurr)
    <=> v11962(VarCurr) ) ).

tff(addAssignment_6021,axiom,
    ! [VarCurr: state_type] :
      ( v11962(VarCurr)
    <=> v11964(VarCurr) ) ).

tff(addAssignment_6020,axiom,
    ! [VarCurr: state_type] :
      ( v11964(VarCurr)
    <=> v11966(VarCurr) ) ).

tff(addAssignment_6019,axiom,
    ! [VarCurr: state_type] :
      ( v11966(VarCurr)
    <=> v11968(VarCurr) ) ).

tff(writeUnaryOperator_741,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11968(VarCurr)
    <=> v11982(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1017,axiom,
    ! [VarCurr: state_type] :
      ( v11982(VarCurr)
    <=> ( v11983(VarCurr)
        | v11978(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1016,axiom,
    ! [VarCurr: state_type] :
      ( v11983(VarCurr)
    <=> ( v11970(VarCurr)
        | v11974(VarCurr) ) ) ).

tff(addAssignment_6018,axiom,
    ! [VarCurr: state_type] :
      ( v11978(VarCurr)
    <=> v11980(VarCurr) ) ).

tff(addAssignment_6017,axiom,
    ! [VarCurr: state_type] :
      ( v11980(VarCurr)
    <=> v11551(VarCurr,2) ) ).

tff(addAssignment_6016,axiom,
    ! [VarCurr: state_type] :
      ( v11974(VarCurr)
    <=> v11976(VarCurr) ) ).

tff(addAssignment_6015,axiom,
    ! [VarCurr: state_type] :
      ( v11976(VarCurr)
    <=> v11551(VarCurr,1) ) ).

tff(addAssignment_6014,axiom,
    ! [VarCurr: state_type] :
      ( v11970(VarCurr)
    <=> v11972(VarCurr) ) ).

tff(addAssignment_6013,axiom,
    ! [VarCurr: state_type] :
      ( v11972(VarCurr)
    <=> v11634(VarCurr,0) ) ).

tff(addAssignment_6012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11823(VarCurr,B)
      <=> v11825(VarCurr,B) ) ) ).

tff(addAssignment_6011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11825(VarCurr,B)
      <=> v11827(VarCurr,B) ) ) ).

tff(addAssignment_6010,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11827(VarCurr,B)
      <=> v11829(VarCurr,B) ) ) ).

tff(addAssignment_6009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11829(VarCurr,B)
      <=> v11831(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11937(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v11831(VarNext,B)
            <=> v11831(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_138,axiom,
    ! [VarNext: state_type] :
      ( v11937(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11831(VarNext,B)
          <=> v11947(VarNext,B) ) ) ) ).

tff(addAssignment_6008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11947(VarNext,B)
          <=> v11945(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_107,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11948(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11945(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_107,axiom,
    ! [VarCurr: state_type] :
      ( v11948(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11945(VarCurr,B)
          <=> v11853(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1015,axiom,
    ! [VarCurr: state_type] :
      ( v11948(VarCurr)
    <=> ( v11949(VarCurr)
        & v11950(VarCurr) ) ) ).

tff(writeUnaryOperator_740,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11950(VarCurr)
    <=> v11843(VarCurr) ) ).

tff(writeUnaryOperator_739,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11949(VarCurr)
    <=> v11833(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1014,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11937(VarNext)
      <=> v11938(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1013,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11938(VarNext)
      <=> ( v11939(VarNext)
          & v11857(VarNext) ) ) ) ).

tff(writeUnaryOperator_738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11939(VarNext)
      <=> v11941(VarNext) ) ) ).

tff(addAssignment_6007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11941(VarNext)
      <=> v11857(VarCurr) ) ) ).

tff(addAssignment_6006,axiom,
    ! [VarCurr: state_type] :
      ( v11857(VarCurr)
    <=> v11859(VarCurr) ) ).

tff(addAssignment_6005,axiom,
    ! [VarCurr: state_type] :
      ( v11859(VarCurr)
    <=> v11861(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1012,axiom,
    ! [VarCurr: state_type] :
      ( v11861(VarCurr)
    <=> ( v11934(VarCurr)
        | v11930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1011,axiom,
    ! [VarCurr: state_type] :
      ( v11934(VarCurr)
    <=> ( v11863(VarCurr)
        & v11867(VarCurr) ) ) ).

tff(addAssignment_6004,axiom,
    ! [VarCurr: state_type] :
      ( v11930(VarCurr)
    <=> v11932(VarCurr) ) ).

tff(addAssignment_6003,axiom,
    ! [VarCurr: state_type] :
      ( v11932(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11914(VarNext)
       => ( v11867(VarNext)
        <=> v11867(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_137,axiom,
    ! [VarNext: state_type] :
      ( v11914(VarNext)
     => ( v11867(VarNext)
      <=> v11924(VarNext) ) ) ).

tff(addAssignment_6002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11924(VarNext)
      <=> v11922(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1010,axiom,
    ! [VarCurr: state_type] :
      ( v11922(VarCurr)
    <=> ( v11925(VarCurr)
        & v11926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1009,axiom,
    ! [VarCurr: state_type] :
      ( v11926(VarCurr)
    <=> ( v11873(VarCurr)
        | v11909(VarCurr) ) ) ).

tff(writeUnaryOperator_737,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11925(VarCurr)
    <=> v11869(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1008,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11914(VarNext)
      <=> v11915(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1007,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11915(VarNext)
      <=> ( v11917(VarNext)
          & v11919(VarNext) ) ) ) ).

tff(writeUnaryOperator_736,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11919(VarCurr)
    <=> v11863(VarCurr) ) ).

tff(addAssignment_6001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11917(VarNext)
      <=> v11863(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_36,axiom,
    ( v11867(constB0)
  <=> $true ) ).

tff(addAssignment_6000,axiom,
    ! [VarCurr: state_type] :
      ( v11909(VarCurr)
    <=> v11911(VarCurr) ) ).

tff(addAssignment_5999,axiom,
    ! [VarCurr: state_type] :
      ( v11911(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_5998,axiom,
    ! [VarCurr: state_type] :
      ( v11873(VarCurr)
    <=> v11875(VarCurr) ) ).

tff(addAssignment_5997,axiom,
    ! [VarCurr: state_type] :
      ( v11875(VarCurr)
    <=> v11877(VarCurr) ) ).

tff(addAssignment_5996,axiom,
    ! [VarCurr: state_type] :
      ( v11877(VarCurr)
    <=> v11879(VarCurr) ) ).

tff(addAssignment_5995,axiom,
    ! [VarCurr: state_type] :
      ( v11879(VarCurr)
    <=> v11881(VarCurr) ) ).

tff(writeUnaryOperator_735,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11881(VarCurr)
    <=> v11906(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1006,axiom,
    ! [VarCurr: state_type] :
      ( v11906(VarCurr)
    <=> ( v11907(VarCurr)
        | v11902(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1005,axiom,
    ! [VarCurr: state_type] :
      ( v11907(VarCurr)
    <=> ( v11883(VarCurr)
        | v11898(VarCurr) ) ) ).

tff(addAssignment_5994,axiom,
    ! [VarCurr: state_type] :
      ( v11902(VarCurr)
    <=> v11904(VarCurr) ) ).

tff(addAssignment_5993,axiom,
    ! [VarCurr: state_type] :
      ( v11904(VarCurr)
    <=> v11461(VarCurr,2) ) ).

tff(addAssignment_5992,axiom,
    ! [VarCurr: state_type] :
      ( v11898(VarCurr)
    <=> v11900(VarCurr) ) ).

tff(addAssignment_5991,axiom,
    ! [VarCurr: state_type] :
      ( v11900(VarCurr)
    <=> v11461(VarCurr,1) ) ).

tff(addAssignment_5990,axiom,
    ! [VarCurr: state_type] :
      ( v11883(VarCurr)
    <=> v11885(VarCurr) ) ).

tff(addAssignment_5989,axiom,
    ! [VarCurr: state_type] :
      ( v11885(VarCurr)
    <=> v11887(VarCurr,0) ) ).

tff(addAssignment_5988,axiom,
    ! [VarCurr: state_type] :
      ( v11887(VarCurr,0)
    <=> v11889(VarCurr,0) ) ).

tff(addAssignment_5987,axiom,
    ! [VarCurr: state_type] :
      ( v11889(VarCurr,0)
    <=> v11891(VarCurr,0) ) ).

tff(addAssignment_5986,axiom,
    ! [VarCurr: state_type] :
      ( v11891(VarCurr,0)
    <=> v11896(VarCurr,0) ) ).

tff(writeUnaryOperator_734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11896(VarCurr,B)
      <=> ~ v11893(VarCurr,B) ) ) ).

tff(addAssignment_5985,axiom,
    ! [VarCurr: state_type] :
      ( v11893(VarCurr,0)
    <=> v11895(VarCurr,0) ) ).

tff(addAssignment_5984,axiom,
    ! [VarCurr: state_type] :
      ( v11895(VarCurr,0)
    <=> v11461(VarCurr,0) ) ).

tff(addAssignment_5983,axiom,
    ! [VarCurr: state_type] :
      ( v11869(VarCurr)
    <=> v11871(VarCurr) ) ).

tff(addAssignment_5982,axiom,
    ! [VarCurr: state_type] :
      ( v11871(VarCurr)
    <=> $false ) ).

tff(addAssignment_5981,axiom,
    ! [VarCurr: state_type] :
      ( v11863(VarCurr)
    <=> v11865(VarCurr) ) ).

tff(addAssignment_5980,axiom,
    ! [VarCurr: state_type] :
      ( v11865(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_5979,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11853(VarCurr,B)
      <=> v11855(VarCurr,B) ) ) ).

tff(addAssignment_5978,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11855(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_5977,axiom,
    ! [VarCurr: state_type] :
      ( v11843(VarCurr)
    <=> v11845(VarCurr) ) ).

tff(addAssignment_5976,axiom,
    ! [VarCurr: state_type] :
      ( v11845(VarCurr)
    <=> v11847(VarCurr) ) ).

tff(addAssignment_5975,axiom,
    ! [VarCurr: state_type] :
      ( v11847(VarCurr)
    <=> v11849(VarCurr) ) ).

tff(addAssignment_5974,axiom,
    ! [VarCurr: state_type] :
      ( v11849(VarCurr)
    <=> v11851(VarCurr) ) ).

tff(addAssignment_5973,axiom,
    ! [VarCurr: state_type] :
      ( v11851(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_5972,axiom,
    ! [VarCurr: state_type] :
      ( v11833(VarCurr)
    <=> v11835(VarCurr) ) ).

tff(addAssignment_5971,axiom,
    ! [VarCurr: state_type] :
      ( v11835(VarCurr)
    <=> v11837(VarCurr) ) ).

tff(addAssignment_5970,axiom,
    ! [VarCurr: state_type] :
      ( v11837(VarCurr)
    <=> v11839(VarCurr) ) ).

tff(addAssignment_5969,axiom,
    ! [VarCurr: state_type] :
      ( v11839(VarCurr)
    <=> v11841(VarCurr) ) ).

tff(addAssignment_5968,axiom,
    ! [VarCurr: state_type] :
      ( v11841(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_5967,axiom,
    ! [VarCurr: state_type] :
      ( v11531(VarCurr)
    <=> v11533(VarCurr) ) ).

tff(addAssignment_5966,axiom,
    ! [VarCurr: state_type] :
      ( v11533(VarCurr)
    <=> v11535(VarCurr) ) ).

tff(addAssignment_5965,axiom,
    ! [VarCurr: state_type] :
      ( v11535(VarCurr)
    <=> v11537(VarCurr) ) ).

tff(addAssignment_5964,axiom,
    ! [VarCurr: state_type] :
      ( v11537(VarCurr)
    <=> v11539(VarCurr) ) ).

tff(addAssignment_5963,axiom,
    ! [VarCurr: state_type] :
      ( v11539(VarCurr)
    <=> v11541(VarCurr) ) ).

tff(addAssignment_5962,axiom,
    ! [VarCurr: state_type] :
      ( v11541(VarCurr)
    <=> v11543(VarCurr) ) ).

tff(addAssignment_5961,axiom,
    ! [VarCurr: state_type] :
      ( v11543(VarCurr)
    <=> v11545(VarCurr) ) ).

tff(writeUnaryOperator_733,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11545(VarCurr)
    <=> v11820(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1004,axiom,
    ! [VarCurr: state_type] :
      ( v11820(VarCurr)
    <=> ( v11821(VarCurr)
        | v11816(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1003,axiom,
    ! [VarCurr: state_type] :
      ( v11821(VarCurr)
    <=> ( v11547(VarCurr)
        | v11812(VarCurr) ) ) ).

tff(addAssignment_5960,axiom,
    ! [VarCurr: state_type] :
      ( v11816(VarCurr)
    <=> v11818(VarCurr) ) ).

tff(addAssignment_5959,axiom,
    ! [VarCurr: state_type] :
      ( v11818(VarCurr)
    <=> v11551(VarCurr,2) ) ).

tff(addAssignment_5958,axiom,
    ! [VarCurr: state_type] :
      ( v11812(VarCurr)
    <=> v11814(VarCurr) ) ).

tff(addAssignment_5957,axiom,
    ! [VarCurr: state_type] :
      ( v11814(VarCurr)
    <=> v11551(VarCurr,1) ) ).

tff(addAssignment_5956,axiom,
    ! [VarCurr: state_type] :
      ( v11547(VarCurr)
    <=> v11549(VarCurr) ) ).

tff(addAssignment_5955,axiom,
    ! [VarCurr: state_type] :
      ( v11549(VarCurr)
    <=> v11551(VarCurr,0) ) ).

tff(addAssignment_5954,axiom,
    ! [VarCurr: state_type] :
      ( v11551(VarCurr,0)
    <=> v11463(VarCurr,3) ) ).

tff(addAssignment_5953,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,3)
    <=> v11465(VarCurr,3) ) ).

tff(addAssignment_5952,axiom,
    ! [VarNext: state_type] :
      ( v11465(VarNext,3)
    <=> v11804(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_136,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11805(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v11804(VarNext,B)
            <=> v11465(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_136,axiom,
    ! [VarNext: state_type] :
      ( v11805(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11804(VarNext,B)
          <=> v11776(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1002,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11805(VarNext)
      <=> v11806(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1001,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11806(VarNext)
      <=> ( v11808(VarNext)
          & v11718(VarNext) ) ) ) ).

tff(writeUnaryOperator_732,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11808(VarNext)
      <=> v11770(VarNext) ) ) ).

tff(addAssignment_5951,axiom,
    ! [VarCurr: state_type] :
      ( v11575(VarCurr,3)
    <=> v11577(VarCurr,3) ) ).

tff(addAssignment_5950,axiom,
    ! [VarCurr: state_type] :
      ( v11577(VarCurr,3)
    <=> v11715(VarCurr,3) ) ).

tff(addAssignment_5949,axiom,
    ! [VarCurr: state_type] :
      ( v11579(VarCurr,0)
    <=> v11581(VarCurr,0) ) ).

tff(addAssignment_5948,axiom,
    ! [VarCurr: state_type] :
      ( v11581(VarCurr,0)
    <=> v11583(VarCurr,0) ) ).

tff(addAssignment_5947,axiom,
    ! [VarCurr: state_type] :
      ( v11583(VarCurr,0)
    <=> v11714(VarCurr,0) ) ).

tff(addAssignment_5946,axiom,
    ! [VarCurr: state_type] :
      ( v11651(VarCurr,0)
    <=> v11653(VarCurr,0) ) ).

tff(addAssignment_5945,axiom,
    ! [VarCurr: state_type] :
      ( v11653(VarCurr,0)
    <=> v11655(VarCurr,0) ) ).

tff(addAssignment_5944,axiom,
    ! [VarCurr: state_type] :
      ( v11655(VarCurr,0)
    <=> v11657(VarCurr,0) ) ).

tff(addAssignment_5943,axiom,
    ! [VarCurr: state_type] :
      ( v11657(VarCurr,0)
    <=> v11659(VarCurr,0) ) ).

tff(addAssignment_5942,axiom,
    ! [VarCurr: state_type] :
      ( v11659(VarCurr,0)
    <=> v11669(VarCurr,0) ) ).

tff(addAssignment_5941,axiom,
    ! [VarCurr: state_type] :
      ( v11585(VarCurr,0)
    <=> v11587(VarCurr,0) ) ).

tff(addAssignment_5940,axiom,
    ! [VarCurr: state_type] :
      ( v11587(VarCurr,0)
    <=> v11648(VarCurr,0) ) ).

tff(addAssignment_5939,axiom,
    ! [VarCurr: state_type] :
      ( v11589(VarCurr)
    <=> v11115(VarCurr,2) ) ).

tff(addAssignment_5938,axiom,
    ! [VarCurr: state_type] :
      ( v11115(VarCurr,2)
    <=> v11117(VarCurr,2) ) ).

tff(addAssignment_5937,axiom,
    ! [VarCurr: state_type] :
      ( v11117(VarCurr,2)
    <=> v11127(VarCurr,2) ) ).

tff(addAssignment_5936,axiom,
    ! [VarCurr: state_type] :
      ( v11119(VarCurr,2)
    <=> v11121(VarCurr,2) ) ).

tff(addAssignment_5935,axiom,
    ! [VarCurr: state_type] :
      ( v11121(VarCurr,2)
    <=> v11124(VarCurr,2) ) ).

tff(addAssignment_5934,axiom,
    ! [VarCurr: state_type] :
      ( v11125(VarCurr)
    <=> v11592(VarCurr,1) ) ).

tff(addAssignment_5933,axiom,
    ! [VarCurr: state_type] :
      ( v11592(VarCurr,1)
    <=> v11594(VarCurr,1) ) ).

tff(addAssignment_5932,axiom,
    ! [VarCurr: state_type] :
      ( v11594(VarCurr,1)
    <=> v11802(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_207,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v11802(VarCurr,B)
      <=> ( v11596(VarCurr,B)
          | v11602(VarCurr,B) ) ) ) ).

tff(addAssignment_5931,axiom,
    ! [VarCurr: state_type] :
      ( v11602(VarCurr,1)
    <=> v11604(VarCurr,1) ) ).

tff(addAssignment_5930,axiom,
    ! [VarCurr: state_type] :
      ( v11604(VarCurr,1)
    <=> v11800(VarCurr,1) ) ).

tff(addAssignment_5929,axiom,
    ! [VarCurr: state_type] :
      ( v11800(VarCurr,0)
    <=> v11801(VarCurr) ) ).

tff(addAssignment_5928,axiom,
    ! [VarCurr: state_type] :
      ( v11800(VarCurr,1)
    <=> v11606(VarCurr) ) ).

tff(addAssignment_5927,axiom,
    ! [VarCurr: state_type] :
      ( v11606(VarCurr)
    <=> v11608(VarCurr,1) ) ).

tff(addAssignment_5926,axiom,
    ! [VarCurr: state_type] :
      ( v11608(VarCurr,1)
    <=> v11610(VarCurr,1) ) ).

tff(addAssignment_5925,axiom,
    ! [VarCurr: state_type] :
      ( v11610(VarCurr,1)
    <=> v11799(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_206,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v11799(VarCurr,B)
      <=> ( v11612(VarCurr,B)
          & v11620(VarCurr,B) ) ) ) ).

tff(addAssignment_5924,axiom,
    ! [VarCurr: state_type] :
      ( v11620(VarCurr,1)
    <=> v11622(VarCurr,1) ) ).

tff(addAssignment_5923,axiom,
    ! [VarCurr: state_type] :
      ( v11622(VarCurr,1)
    <=> v11797(VarCurr,1) ) ).

tff(addAssignment_5922,axiom,
    ! [VarCurr: state_type] :
      ( v11797(VarCurr,0)
    <=> v11798(VarCurr) ) ).

tff(addAssignment_5921,axiom,
    ! [VarCurr: state_type] :
      ( v11797(VarCurr,1)
    <=> v11624(VarCurr) ) ).

tff(addAssignment_5920,axiom,
    ! [VarCurr: state_type] :
      ( v11624(VarCurr)
    <=> v11626(VarCurr) ) ).

tff(addAssignment_5919,axiom,
    ! [VarCurr: state_type] :
      ( v11626(VarCurr)
    <=> v11628(VarCurr) ) ).

tff(writeUnaryOperator_731,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11628(VarCurr)
    <=> v11795(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1000,axiom,
    ! [VarCurr: state_type] :
      ( v11795(VarCurr)
    <=> ( v11796(VarCurr)
        | v11783(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_999,axiom,
    ! [VarCurr: state_type] :
      ( v11796(VarCurr)
    <=> ( v11630(VarCurr)
        | v11645(VarCurr) ) ) ).

tff(addAssignment_5918,axiom,
    ! [VarCurr: state_type] :
      ( v11783(VarCurr)
    <=> v11785(VarCurr) ) ).

tff(addAssignment_5917,axiom,
    ! [VarCurr: state_type] :
      ( v11785(VarCurr)
    <=> v11634(VarCurr,2) ) ).

tff(addAssignment_5916,axiom,
    ! [VarCurr: state_type] :
      ( v11634(VarCurr,2)
    <=> v11636(VarCurr,2) ) ).

tff(addAssignment_5915,axiom,
    ! [VarCurr: state_type] :
      ( v11636(VarCurr,2)
    <=> v11638(VarCurr,2) ) ).

tff(addAssignment_5914,axiom,
    ! [VarCurr: state_type] :
      ( v11638(VarCurr,2)
    <=> v11643(VarCurr,2) ) ).

tff(addAssignment_5913,axiom,
    ! [VarCurr: state_type] :
      ( v11640(VarCurr,2)
    <=> v11642(VarCurr,2) ) ).

tff(addAssignment_5912,axiom,
    ! [VarCurr: state_type] :
      ( v11642(VarCurr,2)
    <=> v11551(VarCurr,2) ) ).

tff(addAssignment_5911,axiom,
    ! [VarCurr: state_type] :
      ( v11551(VarCurr,2)
    <=> v11463(VarCurr,5) ) ).

tff(addAssignment_5910,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,5)
    <=> v11465(VarCurr,5) ) ).

tff(addAssignment_5909,axiom,
    ! [VarNext: state_type] :
      ( v11465(VarNext,5)
    <=> v11787(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11788(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v11787(VarNext,B)
            <=> v11465(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_135,axiom,
    ! [VarNext: state_type] :
      ( v11788(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11787(VarNext,B)
          <=> v11776(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_998,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11788(VarNext)
      <=> v11789(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_997,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11789(VarNext)
      <=> ( v11791(VarNext)
          & v11718(VarNext) ) ) ) ).

tff(writeUnaryOperator_730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11791(VarNext)
      <=> v11770(VarNext) ) ) ).

tff(addAssignment_5908,axiom,
    ! [VarCurr: state_type] :
      ( v11575(VarCurr,5)
    <=> v11577(VarCurr,5) ) ).

tff(addAssignment_5907,axiom,
    ! [VarCurr: state_type] :
      ( v11577(VarCurr,5)
    <=> v11715(VarCurr,5) ) ).

tff(addAssignment_5906,axiom,
    ! [VarCurr: state_type] :
      ( v11579(VarCurr,2)
    <=> v11581(VarCurr,2) ) ).

tff(addAssignment_5905,axiom,
    ! [VarCurr: state_type] :
      ( v11581(VarCurr,2)
    <=> v11583(VarCurr,2) ) ).

tff(addAssignment_5904,axiom,
    ! [VarCurr: state_type] :
      ( v11583(VarCurr,2)
    <=> v11714(VarCurr,2) ) ).

tff(addAssignment_5903,axiom,
    ! [VarCurr: state_type] :
      ( v11651(VarCurr,2)
    <=> v11653(VarCurr,2) ) ).

tff(addAssignment_5902,axiom,
    ! [VarCurr: state_type] :
      ( v11653(VarCurr,2)
    <=> v11655(VarCurr,2) ) ).

tff(addAssignment_5901,axiom,
    ! [VarCurr: state_type] :
      ( v11655(VarCurr,2)
    <=> v11657(VarCurr,2) ) ).

tff(addAssignment_5900,axiom,
    ! [VarCurr: state_type] :
      ( v11657(VarCurr,2)
    <=> v11659(VarCurr,2) ) ).

tff(addAssignment_5899,axiom,
    ! [VarCurr: state_type] :
      ( v11659(VarCurr,2)
    <=> v11669(VarCurr,2) ) ).

tff(addAssignment_5898,axiom,
    ! [VarCurr: state_type] :
      ( v11661(VarCurr,2)
    <=> v11663(VarCurr,2) ) ).

tff(addAssignment_5897,axiom,
    ! [VarCurr: state_type] :
      ( v11663(VarCurr,2)
    <=> v11664(VarCurr,2) ) ).

tff(addAssignment_5896,axiom,
    ! [VarCurr: state_type] :
      ( v11585(VarCurr,2)
    <=> v11587(VarCurr,2) ) ).

tff(addAssignment_5895,axiom,
    ! [VarCurr: state_type] :
      ( v11587(VarCurr,2)
    <=> v11648(VarCurr,2) ) ).

tff(addAssignment_5894,axiom,
    ! [VarCurr: state_type] :
      ( v11645(VarCurr)
    <=> v11647(VarCurr) ) ).

tff(addAssignment_5893,axiom,
    ! [VarCurr: state_type] :
      ( v11647(VarCurr)
    <=> v11551(VarCurr,1) ) ).

tff(addAssignment_5892,axiom,
    ! [VarCurr: state_type] :
      ( v11551(VarCurr,1)
    <=> v11463(VarCurr,4) ) ).

tff(addAssignment_5891,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,4)
    <=> v11465(VarCurr,4) ) ).

tff(addAssignment_5890,axiom,
    ! [VarNext: state_type] :
      ( v11465(VarNext,4)
    <=> v11765(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11766(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v11765(VarNext,B)
            <=> v11465(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_134,axiom,
    ! [VarNext: state_type] :
      ( v11766(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11765(VarNext,B)
          <=> v11776(VarNext,B) ) ) ) ).

tff(addAssignment_5889,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11776(VarNext,B)
          <=> v11774(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11777(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11774(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_106,axiom,
    ! [VarCurr: state_type] :
      ( v11777(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v11774(VarCurr,B)
          <=> v11575(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_996,axiom,
    ! [VarCurr: state_type] :
      ( v11777(VarCurr)
    <=> ( v11778(VarCurr)
        & v11779(VarCurr) ) ) ).

tff(writeUnaryOperator_729,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11779(VarCurr)
    <=> v11565(VarCurr) ) ).

tff(writeUnaryOperator_728,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11778(VarCurr)
    <=> v11553(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_995,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11766(VarNext)
      <=> v11767(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_994,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11767(VarNext)
      <=> ( v11768(VarNext)
          & v11718(VarNext) ) ) ) ).

tff(writeUnaryOperator_727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11768(VarNext)
      <=> v11770(VarNext) ) ) ).

tff(addAssignment_5888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11770(VarNext)
      <=> v11718(VarCurr) ) ) ).

tff(addAssignment_5887,axiom,
    ! [VarCurr: state_type] :
      ( v11718(VarCurr)
    <=> v11720(VarCurr) ) ).

tff(addAssignment_5886,axiom,
    ! [VarCurr: state_type] :
      ( v11720(VarCurr)
    <=> v11722(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_993,axiom,
    ! [VarCurr: state_type] :
      ( v11722(VarCurr)
    <=> ( v11763(VarCurr)
        | v11759(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_992,axiom,
    ! [VarCurr: state_type] :
      ( v11763(VarCurr)
    <=> ( v11724(VarCurr)
        & v11728(VarCurr) ) ) ).

tff(addAssignment_5885,axiom,
    ! [VarCurr: state_type] :
      ( v11759(VarCurr)
    <=> v11761(VarCurr) ) ).

tff(addAssignment_5884,axiom,
    ! [VarCurr: state_type] :
      ( v11761(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11743(VarNext)
       => ( v11728(VarNext)
        <=> v11728(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_133,axiom,
    ! [VarNext: state_type] :
      ( v11743(VarNext)
     => ( v11728(VarNext)
      <=> v11753(VarNext) ) ) ).

tff(addAssignment_5883,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11753(VarNext)
      <=> v11751(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_991,axiom,
    ! [VarCurr: state_type] :
      ( v11751(VarCurr)
    <=> ( v11754(VarCurr)
        & v11755(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_990,axiom,
    ! [VarCurr: state_type] :
      ( v11755(VarCurr)
    <=> ( v11734(VarCurr)
        | v11738(VarCurr) ) ) ).

tff(writeUnaryOperator_726,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11754(VarCurr)
    <=> v11730(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_989,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11743(VarNext)
      <=> v11744(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_988,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11744(VarNext)
      <=> ( v11746(VarNext)
          & v11748(VarNext) ) ) ) ).

tff(writeUnaryOperator_725,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11748(VarCurr)
    <=> v11724(VarCurr) ) ).

tff(addAssignment_5882,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11746(VarNext)
      <=> v11724(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_35,axiom,
    ( v11728(constB0)
  <=> $true ) ).

tff(addAssignment_5881,axiom,
    ! [VarCurr: state_type] :
      ( v11738(VarCurr)
    <=> v11740(VarCurr) ) ).

tff(addAssignment_5880,axiom,
    ! [VarCurr: state_type] :
      ( v11740(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_5879,axiom,
    ! [VarCurr: state_type] :
      ( v11734(VarCurr)
    <=> v11736(VarCurr) ) ).

tff(addAssignment_5878,axiom,
    ! [VarCurr: state_type] :
      ( v11736(VarCurr)
    <=> $true ) ).

tff(addAssignment_5877,axiom,
    ! [VarCurr: state_type] :
      ( v11730(VarCurr)
    <=> v11732(VarCurr) ) ).

tff(addAssignment_5876,axiom,
    ! [VarCurr: state_type] :
      ( v11732(VarCurr)
    <=> $false ) ).

tff(addAssignment_5875,axiom,
    ! [VarCurr: state_type] :
      ( v11724(VarCurr)
    <=> v11726(VarCurr) ) ).

tff(addAssignment_5874,axiom,
    ! [VarCurr: state_type] :
      ( v11726(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_5873,axiom,
    ! [VarCurr: state_type] :
      ( v11575(VarCurr,4)
    <=> v11577(VarCurr,4) ) ).

tff(addAssignment_5872,axiom,
    ! [VarCurr: state_type] :
      ( v11577(VarCurr,4)
    <=> v11715(VarCurr,4) ) ).

tff(addAssignment_5871,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11715(VarCurr,B)
      <=> v11716(VarCurr,B) ) ) ).

tff(addAssignment_5870,axiom,
    ! [VarCurr: state_type] :
      ( ( v11715(VarCurr,5)
      <=> v11579(VarCurr,2) )
      & ( v11715(VarCurr,4)
      <=> v11579(VarCurr,1) )
      & ( v11715(VarCurr,3)
      <=> v11579(VarCurr,0) ) ) ).

tff(addAssignment_5869,axiom,
    ! [VarCurr: state_type] :
      ( v11579(VarCurr,1)
    <=> v11581(VarCurr,1) ) ).

tff(addAssignment_5868,axiom,
    ! [VarCurr: state_type] :
      ( v11581(VarCurr,1)
    <=> v11583(VarCurr,1) ) ).

tff(addAssignment_5867,axiom,
    ! [VarCurr: state_type] :
      ( v11583(VarCurr,1)
    <=> v11714(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11714(VarCurr,B)
      <=> ( v11585(VarCurr,B)
          & v11651(VarCurr,B) ) ) ) ).

tff(addAssignment_5866,axiom,
    ! [VarCurr: state_type] :
      ( v11651(VarCurr,1)
    <=> v11653(VarCurr,1) ) ).

tff(addAssignment_5865,axiom,
    ! [VarCurr: state_type] :
      ( v11653(VarCurr,1)
    <=> v11655(VarCurr,1) ) ).

tff(addAssignment_5864,axiom,
    ! [VarCurr: state_type] :
      ( v11655(VarCurr,1)
    <=> v11657(VarCurr,1) ) ).

tff(addAssignment_5863,axiom,
    ! [VarCurr: state_type] :
      ( v11657(VarCurr,1)
    <=> v11659(VarCurr,1) ) ).

tff(addAssignment_5862,axiom,
    ! [VarCurr: state_type] :
      ( v11659(VarCurr,1)
    <=> v11669(VarCurr,1) ) ).

tff(addAssignment_5861,axiom,
    ! [VarCurr: state_type] :
      ( v11669(VarCurr,0)
    <=> v11709(VarCurr) ) ).

tff(addAssignment_5860,axiom,
    ! [VarCurr: state_type] :
      ( v11669(VarCurr,1)
    <=> v11704(VarCurr) ) ).

tff(addAssignment_5859,axiom,
    ! [VarCurr: state_type] :
      ( v11669(VarCurr,2)
    <=> v11699(VarCurr) ) ).

tff(addAssignment_5858,axiom,
    ! [VarCurr: state_type] :
      ( v11669(VarCurr,3)
    <=> v11671(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_987,axiom,
    ! [VarCurr: state_type] :
      ( v11709(VarCurr)
    <=> ( v11710(VarCurr)
        & v11713(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_986,axiom,
    ! [VarCurr: state_type] :
      ( v11713(VarCurr)
    <=> ( v11661(VarCurr,0)
        | v11679(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_985,axiom,
    ! [VarCurr: state_type] :
      ( v11710(VarCurr)
    <=> ( v11711(VarCurr)
        | v11712(VarCurr) ) ) ).

tff(writeUnaryOperator_724,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11712(VarCurr)
    <=> v11679(VarCurr,0) ) ).

tff(writeUnaryOperator_723,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11711(VarCurr)
    <=> v11661(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_984,axiom,
    ! [VarCurr: state_type] :
      ( v11704(VarCurr)
    <=> ( v11705(VarCurr)
        & v11708(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_983,axiom,
    ! [VarCurr: state_type] :
      ( v11708(VarCurr)
    <=> ( v11678(VarCurr)
        | v11680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_982,axiom,
    ! [VarCurr: state_type] :
      ( v11705(VarCurr)
    <=> ( v11706(VarCurr)
        | v11707(VarCurr) ) ) ).

tff(writeUnaryOperator_722,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11707(VarCurr)
    <=> v11680(VarCurr) ) ).

tff(writeUnaryOperator_721,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11706(VarCurr)
    <=> v11678(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_981,axiom,
    ! [VarCurr: state_type] :
      ( v11699(VarCurr)
    <=> ( v11700(VarCurr)
        & v11703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_980,axiom,
    ! [VarCurr: state_type] :
      ( v11703(VarCurr)
    <=> ( v11676(VarCurr)
        | v11686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_979,axiom,
    ! [VarCurr: state_type] :
      ( v11700(VarCurr)
    <=> ( v11701(VarCurr)
        | v11702(VarCurr) ) ) ).

tff(writeUnaryOperator_720,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11702(VarCurr)
    <=> v11686(VarCurr) ) ).

tff(writeUnaryOperator_719,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11701(VarCurr)
    <=> v11676(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_978,axiom,
    ! [VarCurr: state_type] :
      ( v11671(VarCurr)
    <=> ( v11672(VarCurr)
        & v11698(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_977,axiom,
    ! [VarCurr: state_type] :
      ( v11698(VarCurr)
    <=> ( v11674(VarCurr)
        | v11693(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_976,axiom,
    ! [VarCurr: state_type] :
      ( v11672(VarCurr)
    <=> ( v11673(VarCurr)
        | v11692(VarCurr) ) ) ).

tff(writeUnaryOperator_718,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11692(VarCurr)
    <=> v11693(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_975,axiom,
    ! [VarCurr: state_type] :
      ( v11693(VarCurr)
    <=> ( v11694(VarCurr)
        & v11697(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_188,axiom,
    ! [VarCurr: state_type] :
      ( v11697(VarCurr)
    <=> ( v11661(VarCurr,3)
        | v11679(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_974,axiom,
    ! [VarCurr: state_type] :
      ( v11694(VarCurr)
    <=> ( v11695(VarCurr)
        | v11696(VarCurr) ) ) ).

tff(writeUnaryOperator_717,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11696(VarCurr)
    <=> v11679(VarCurr,3) ) ).

tff(writeUnaryOperator_716,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11695(VarCurr)
    <=> v11661(VarCurr,3) ) ).

tff(writeUnaryOperator_715,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11673(VarCurr)
    <=> v11674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_973,axiom,
    ! [VarCurr: state_type] :
      ( v11674(VarCurr)
    <=> ( v11675(VarCurr)
        | v11691(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_187,axiom,
    ! [VarCurr: state_type] :
      ( v11691(VarCurr)
    <=> ( v11661(VarCurr,2)
        & v11679(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_972,axiom,
    ! [VarCurr: state_type] :
      ( v11675(VarCurr)
    <=> ( v11676(VarCurr)
        & v11686(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_971,axiom,
    ! [VarCurr: state_type] :
      ( v11686(VarCurr)
    <=> ( v11687(VarCurr)
        & v11690(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_186,axiom,
    ! [VarCurr: state_type] :
      ( v11690(VarCurr)
    <=> ( v11661(VarCurr,2)
        | v11679(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_970,axiom,
    ! [VarCurr: state_type] :
      ( v11687(VarCurr)
    <=> ( v11688(VarCurr)
        | v11689(VarCurr) ) ) ).

tff(writeUnaryOperator_714,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11689(VarCurr)
    <=> v11679(VarCurr,2) ) ).

tff(writeUnaryOperator_713,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11688(VarCurr)
    <=> v11661(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_969,axiom,
    ! [VarCurr: state_type] :
      ( v11676(VarCurr)
    <=> ( v11677(VarCurr)
        | v11685(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_185,axiom,
    ! [VarCurr: state_type] :
      ( v11685(VarCurr)
    <=> ( v11661(VarCurr,1)
        & v11679(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_968,axiom,
    ! [VarCurr: state_type] :
      ( v11677(VarCurr)
    <=> ( v11678(VarCurr)
        & v11680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_967,axiom,
    ! [VarCurr: state_type] :
      ( v11680(VarCurr)
    <=> ( v11681(VarCurr)
        & v11684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_184,axiom,
    ! [VarCurr: state_type] :
      ( v11684(VarCurr)
    <=> ( v11661(VarCurr,1)
        | v11679(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_966,axiom,
    ! [VarCurr: state_type] :
      ( v11681(VarCurr)
    <=> ( v11682(VarCurr)
        | v11683(VarCurr) ) ) ).

tff(writeUnaryOperator_712,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11683(VarCurr)
    <=> v11679(VarCurr,1) ) ).

tff(writeUnaryOperator_711,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11682(VarCurr)
    <=> v11661(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_965,axiom,
    ! [VarCurr: state_type] :
      ( v11678(VarCurr)
    <=> ( v11661(VarCurr,0)
        & v11679(VarCurr,0) ) ) ).

tff(addAssignment_5857,axiom,
    ! [VarCurr: state_type] :
      ( v11679(VarCurr,0)
    <=> v11666(VarCurr) ) ).

tff(addAssignment_5856,axiom,
    ! [VarCurr: state_type] :
      ( ( v11679(VarCurr,3)
      <=> $false )
      & ( v11679(VarCurr,2)
      <=> $false )
      & ( v11679(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_5855,axiom,
    ! [VarCurr: state_type] :
      ( v11666(VarCurr)
    <=> v11668(VarCurr) ) ).

tff(addAssignment_5854,axiom,
    ! [VarCurr: state_type] :
      ( v11668(VarCurr)
    <=> v11616(VarCurr) ) ).

tff(addAssignment_5853,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v11661(VarCurr,B)
      <=> v11663(VarCurr,B) ) ) ).

tff(addAssignment_5852,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v11663(VarCurr,B)
      <=> v11664(VarCurr,B) ) ) ).

tff(addAssignment_5851,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11664(VarCurr,B)
      <=> v11551(VarCurr,B) ) ) ).

tff(addAssignment_5850,axiom,
    ! [VarCurr: state_type] :
      ( v11664(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_5849,axiom,
    ! [VarCurr: state_type] :
      ( v11585(VarCurr,1)
    <=> v11587(VarCurr,1) ) ).

tff(addAssignment_5848,axiom,
    ! [VarCurr: state_type] :
      ( v11587(VarCurr,1)
    <=> v11648(VarCurr,1) ) ).

tff(addAssignment_5847,axiom,
    ! [VarCurr: state_type] :
      ( v11648(VarCurr,0)
    <=> v11649(VarCurr) ) ).

tff(addAssignment_5846,axiom,
    ! [VarCurr: state_type] :
      ( v11648(VarCurr,1)
    <=> v11649(VarCurr) ) ).

tff(addAssignment_5845,axiom,
    ! [VarCurr: state_type] :
      ( v11648(VarCurr,2)
    <=> v11649(VarCurr) ) ).

tff(addAssignment_5844,axiom,
    ! [VarCurr: state_type] :
      ( v11649(VarCurr)
    <=> v11589(VarCurr) ) ).

tff(addAssignment_5843,axiom,
    ! [VarCurr: state_type] :
      ( v11630(VarCurr)
    <=> v11632(VarCurr) ) ).

tff(addAssignment_5842,axiom,
    ! [VarCurr: state_type] :
      ( v11632(VarCurr)
    <=> v11634(VarCurr,0) ) ).

tff(addAssignment_5841,axiom,
    ! [VarCurr: state_type] :
      ( v11634(VarCurr,0)
    <=> v11636(VarCurr,0) ) ).

tff(addAssignment_5840,axiom,
    ! [VarCurr: state_type] :
      ( v11636(VarCurr,0)
    <=> v11638(VarCurr,0) ) ).

tff(addAssignment_5839,axiom,
    ! [VarCurr: state_type] :
      ( v11638(VarCurr,0)
    <=> v11643(VarCurr,0) ) ).

tff(writeUnaryOperator_710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11643(VarCurr,B)
      <=> ~ v11640(VarCurr,B) ) ) ).

tff(addAssignment_5838,axiom,
    ! [VarCurr: state_type] :
      ( v11640(VarCurr,0)
    <=> v11642(VarCurr,0) ) ).

tff(addAssignment_5837,axiom,
    ! [VarCurr: state_type] :
      ( v11642(VarCurr,0)
    <=> v11551(VarCurr,0) ) ).

tff(addAssignment_5836,axiom,
    ! [VarCurr: state_type] :
      ( v11612(VarCurr,1)
    <=> v11614(VarCurr,1) ) ).

tff(addAssignment_5835,axiom,
    ! [VarCurr: state_type] :
      ( v11614(VarCurr,1)
    <=> v11617(VarCurr,1) ) ).

tff(addAssignment_5834,axiom,
    ! [VarCurr: state_type] :
      ( v11617(VarCurr,0)
    <=> v11618(VarCurr) ) ).

tff(addAssignment_5833,axiom,
    ! [VarCurr: state_type] :
      ( v11617(VarCurr,1)
    <=> v11616(VarCurr) ) ).

tff(addAssignment_5832,axiom,
    ! [VarCurr: state_type] :
      ( v11616(VarCurr)
    <=> v10053(VarCurr,1) ) ).

tff(addAssignment_5831,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,1)
    <=> v10055(VarCurr,1) ) ).

tff(addAssignment_5830,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,1)
    <=> v10057(VarCurr,1) ) ).

tff(addAssignment_5829,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,1)
    <=> v10061(VarCurr,1) ) ).

tff(addAssignment_5828,axiom,
    ! [VarCurr: state_type] :
      ( v11596(VarCurr,1)
    <=> v11598(VarCurr,1) ) ).

tff(addAssignment_5827,axiom,
    ! [VarCurr: state_type] :
      ( v11598(VarCurr,1)
    <=> v11599(VarCurr,1) ) ).

tff(addAssignment_5826,axiom,
    ! [VarCurr: state_type] :
      ( v11599(VarCurr,0)
    <=> v11600(VarCurr) ) ).

tff(addAssignment_5825,axiom,
    ! [VarCurr: state_type] :
      ( v11599(VarCurr,1)
    <=> v11600(VarCurr) ) ).

tff(addAssignment_5824,axiom,
    ! [VarCurr: state_type] :
      ( v11600(VarCurr)
    <=> v11123(VarCurr) ) ).

tff(addAssignment_5823,axiom,
    ! [VarCurr: state_type] :
      ( v11565(VarCurr)
    <=> v11567(VarCurr) ) ).

tff(addAssignment_5822,axiom,
    ! [VarCurr: state_type] :
      ( v11567(VarCurr)
    <=> v11569(VarCurr) ) ).

tff(addAssignment_5821,axiom,
    ! [VarCurr: state_type] :
      ( v11569(VarCurr)
    <=> v11571(VarCurr) ) ).

tff(addAssignment_5820,axiom,
    ! [VarCurr: state_type] :
      ( v11571(VarCurr)
    <=> v11573(VarCurr) ) ).

tff(addAssignment_5819,axiom,
    ! [VarCurr: state_type] :
      ( v11573(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_5818,axiom,
    ! [VarCurr: state_type] :
      ( v11553(VarCurr)
    <=> v11555(VarCurr) ) ).

tff(addAssignment_5817,axiom,
    ! [VarCurr: state_type] :
      ( v11555(VarCurr)
    <=> v11557(VarCurr) ) ).

tff(addAssignment_5816,axiom,
    ! [VarCurr: state_type] :
      ( v11557(VarCurr)
    <=> v11559(VarCurr) ) ).

tff(addAssignment_5815,axiom,
    ! [VarCurr: state_type] :
      ( v11559(VarCurr)
    <=> v11561(VarCurr) ) ).

tff(addAssignment_5814,axiom,
    ! [VarCurr: state_type] :
      ( v11561(VarCurr)
    <=> v11563(VarCurr) ) ).

tff(addAssignment_5813,axiom,
    ! [VarCurr: state_type] :
      ( v11563(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_5812,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11061(VarCurr,B)
      <=> v11063(VarCurr,B) ) ) ).

tff(addAssignment_5811,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11063(VarCurr,B)
      <=> v11065(VarCurr,B) ) ) ).

tff(addAssignment_5810,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11065(VarCurr,B)
      <=> v11067(VarCurr,B) ) ) ).

tff(addAssignment_5809,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11067(VarCurr,B)
      <=> v11069(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11514(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v11069(VarNext,B)
            <=> v11069(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_132,axiom,
    ! [VarNext: state_type] :
      ( v11514(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11069(VarNext,B)
          <=> v11524(VarNext,B) ) ) ) ).

tff(addAssignment_5808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11524(VarNext,B)
          <=> v11522(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11522(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_105,axiom,
    ! [VarCurr: state_type] :
      ( v11525(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11522(VarCurr,B)
          <=> v11099(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_964,axiom,
    ! [VarCurr: state_type] :
      ( v11525(VarCurr)
    <=> ( v11526(VarCurr)
        & v11527(VarCurr) ) ) ).

tff(writeUnaryOperator_709,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11527(VarCurr)
    <=> v11085(VarCurr) ) ).

tff(writeUnaryOperator_708,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11526(VarCurr)
    <=> v11071(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_963,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11514(VarNext)
      <=> v11515(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_962,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11515(VarNext)
      <=> ( v11516(VarNext)
          & v11429(VarNext) ) ) ) ).

tff(writeUnaryOperator_707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11516(VarNext)
      <=> v11518(VarNext) ) ) ).

tff(addAssignment_5807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11518(VarNext)
      <=> v11429(VarCurr) ) ) ).

tff(addAssignment_5806,axiom,
    ! [VarCurr: state_type] :
      ( v11429(VarCurr)
    <=> v11431(VarCurr) ) ).

tff(addAssignment_5805,axiom,
    ! [VarCurr: state_type] :
      ( v11431(VarCurr)
    <=> v11433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_961,axiom,
    ! [VarCurr: state_type] :
      ( v11433(VarCurr)
    <=> ( v11511(VarCurr)
        | v11503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_960,axiom,
    ! [VarCurr: state_type] :
      ( v11511(VarCurr)
    <=> ( v11435(VarCurr)
        & v11441(VarCurr) ) ) ).

tff(addAssignment_5804,axiom,
    ! [VarCurr: state_type] :
      ( v11503(VarCurr)
    <=> v11505(VarCurr) ) ).

tff(addAssignment_5803,axiom,
    ! [VarCurr: state_type] :
      ( v11505(VarCurr)
    <=> v11507(VarCurr) ) ).

tff(addAssignment_5802,axiom,
    ! [VarCurr: state_type] :
      ( v11507(VarCurr)
    <=> v11509(VarCurr) ) ).

tff(addAssignment_5801,axiom,
    ! [VarCurr: state_type] :
      ( v11509(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11487(VarNext)
       => ( v11441(VarNext)
        <=> v11441(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_131,axiom,
    ! [VarNext: state_type] :
      ( v11487(VarNext)
     => ( v11441(VarNext)
      <=> v11497(VarNext) ) ) ).

tff(addAssignment_5800,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11497(VarNext)
      <=> v11495(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_959,axiom,
    ! [VarCurr: state_type] :
      ( v11495(VarCurr)
    <=> ( v11498(VarCurr)
        & v11499(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_958,axiom,
    ! [VarCurr: state_type] :
      ( v11499(VarCurr)
    <=> ( v11447(VarCurr)
        | v11478(VarCurr) ) ) ).

tff(writeUnaryOperator_706,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11498(VarCurr)
    <=> v11443(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_957,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11487(VarNext)
      <=> v11488(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_956,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11488(VarNext)
      <=> ( v11490(VarNext)
          & v11492(VarNext) ) ) ) ).

tff(writeUnaryOperator_705,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11492(VarCurr)
    <=> v11435(VarCurr) ) ).

tff(addAssignment_5799,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11490(VarNext)
      <=> v11435(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_34,axiom,
    ( v11441(constB0)
  <=> $true ) ).

tff(addAssignment_5798,axiom,
    ! [VarCurr: state_type] :
      ( v11478(VarCurr)
    <=> v11480(VarCurr) ) ).

tff(addAssignment_5797,axiom,
    ! [VarCurr: state_type] :
      ( v11480(VarCurr)
    <=> v11482(VarCurr) ) ).

tff(addAssignment_5796,axiom,
    ! [VarCurr: state_type] :
      ( v11482(VarCurr)
    <=> v11484(VarCurr) ) ).

tff(addAssignment_5795,axiom,
    ! [VarCurr: state_type] :
      ( v11484(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_5794,axiom,
    ! [VarCurr: state_type] :
      ( v11447(VarCurr)
    <=> v11449(VarCurr) ) ).

tff(addAssignment_5793,axiom,
    ! [VarCurr: state_type] :
      ( v11449(VarCurr)
    <=> v11451(VarCurr) ) ).

tff(addAssignment_5792,axiom,
    ! [VarCurr: state_type] :
      ( v11451(VarCurr)
    <=> v11453(VarCurr) ) ).

tff(addAssignment_5791,axiom,
    ! [VarCurr: state_type] :
      ( v11453(VarCurr)
    <=> v11455(VarCurr) ) ).

tff(writeUnaryOperator_704,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11455(VarCurr)
    <=> v11475(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_955,axiom,
    ! [VarCurr: state_type] :
      ( v11475(VarCurr)
    <=> ( v11476(VarCurr)
        | v11471(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_954,axiom,
    ! [VarCurr: state_type] :
      ( v11476(VarCurr)
    <=> ( v11457(VarCurr)
        | v11467(VarCurr) ) ) ).

tff(addAssignment_5790,axiom,
    ! [VarCurr: state_type] :
      ( v11471(VarCurr)
    <=> v11473(VarCurr) ) ).

tff(addAssignment_5789,axiom,
    ! [VarCurr: state_type] :
      ( v11473(VarCurr)
    <=> v11461(VarCurr,2) ) ).

tff(addAssignment_5788,axiom,
    ! [VarCurr: state_type] :
      ( v11461(VarCurr,2)
    <=> v11463(VarCurr,2) ) ).

tff(addAssignment_5787,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,2)
    <=> v11465(VarCurr,2) ) ).

tff(addAssignment_5786,axiom,
    ! [VarCurr: state_type] :
      ( v11467(VarCurr)
    <=> v11469(VarCurr) ) ).

tff(addAssignment_5785,axiom,
    ! [VarCurr: state_type] :
      ( v11469(VarCurr)
    <=> v11461(VarCurr,1) ) ).

tff(addAssignment_5784,axiom,
    ! [VarCurr: state_type] :
      ( v11461(VarCurr,1)
    <=> v11463(VarCurr,1) ) ).

tff(addAssignment_5783,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,1)
    <=> v11465(VarCurr,1) ) ).

tff(addAssignment_5782,axiom,
    ! [VarCurr: state_type] :
      ( v11457(VarCurr)
    <=> v11459(VarCurr) ) ).

tff(addAssignment_5781,axiom,
    ! [VarCurr: state_type] :
      ( v11459(VarCurr)
    <=> v11461(VarCurr,0) ) ).

tff(addAssignment_5780,axiom,
    ! [VarCurr: state_type] :
      ( v11461(VarCurr,0)
    <=> v11463(VarCurr,0) ) ).

tff(addAssignment_5779,axiom,
    ! [VarCurr: state_type] :
      ( v11463(VarCurr,0)
    <=> v11465(VarCurr,0) ) ).

tff(addAssignment_5778,axiom,
    ! [VarCurr: state_type] :
      ( v11443(VarCurr)
    <=> v11445(VarCurr) ) ).

tff(addAssignment_5777,axiom,
    ! [VarCurr: state_type] :
      ( v11445(VarCurr)
    <=> $false ) ).

tff(addAssignment_5776,axiom,
    ! [VarCurr: state_type] :
      ( v11435(VarCurr)
    <=> v11437(VarCurr) ) ).

tff(addAssignment_5775,axiom,
    ! [VarCurr: state_type] :
      ( v11437(VarCurr)
    <=> v11439(VarCurr) ) ).

tff(addAssignment_5774,axiom,
    ! [VarCurr: state_type] :
      ( v11439(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_5773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11099(VarCurr,B)
      <=> v11101(VarCurr,B) ) ) ).

tff(addAssignment_5772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11101(VarCurr,B)
      <=> v11103(VarCurr,B) ) ) ).

tff(addAssignment_5771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11103(VarCurr,B)
      <=> v11105(VarCurr,B) ) ) ).

tff(addAssignment_5770,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11105(VarCurr,B)
      <=> v11107(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11107(VarCurr,B)
      <=> ( v11109(VarCurr,B)
          & v11131(VarCurr,B) ) ) ) ).

tff(addAssignment_5769,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11131(VarCurr,B)
      <=> v11133(VarCurr,B) ) ) ).

tff(addAssignment_5768,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11133(VarCurr,B)
      <=> v11135(VarCurr,B) ) ) ).

tff(addAssignment_5767,axiom,
    ! [VarCurr: state_type] :
      ( ( v11135(VarCurr,11)
      <=> v9198(VarCurr,23) )
      & ( v11135(VarCurr,10)
      <=> v9198(VarCurr,22) )
      & ( v11135(VarCurr,9)
      <=> v9198(VarCurr,21) )
      & ( v11135(VarCurr,8)
      <=> v9198(VarCurr,20) )
      & ( v11135(VarCurr,7)
      <=> v9198(VarCurr,19) )
      & ( v11135(VarCurr,6)
      <=> v9198(VarCurr,18) )
      & ( v11135(VarCurr,5)
      <=> v9198(VarCurr,17) )
      & ( v11135(VarCurr,4)
      <=> v9198(VarCurr,16) )
      & ( v11135(VarCurr,3)
      <=> v9198(VarCurr,15) )
      & ( v11135(VarCurr,2)
      <=> v9198(VarCurr,14) )
      & ( v11135(VarCurr,1)
      <=> v9198(VarCurr,13) )
      & ( v11135(VarCurr,0)
      <=> v9198(VarCurr,12) ) ) ).

tff(addAssignment_5766,axiom,
    ! [VarCurr: state_type] :
      ( ( v9198(VarCurr,23)
      <=> v11137(VarCurr,11) )
      & ( v9198(VarCurr,22)
      <=> v11137(VarCurr,10) )
      & ( v9198(VarCurr,21)
      <=> v11137(VarCurr,9) )
      & ( v9198(VarCurr,20)
      <=> v11137(VarCurr,8) )
      & ( v9198(VarCurr,19)
      <=> v11137(VarCurr,7) )
      & ( v9198(VarCurr,18)
      <=> v11137(VarCurr,6) )
      & ( v9198(VarCurr,17)
      <=> v11137(VarCurr,5) )
      & ( v9198(VarCurr,16)
      <=> v11137(VarCurr,4) )
      & ( v9198(VarCurr,15)
      <=> v11137(VarCurr,3) )
      & ( v9198(VarCurr,14)
      <=> v11137(VarCurr,2) )
      & ( v9198(VarCurr,13)
      <=> v11137(VarCurr,1) )
      & ( v9198(VarCurr,12)
      <=> v11137(VarCurr,0) ) ) ).

tff(addAssignment_5765,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11137(VarCurr,B)
      <=> v11139(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11139(VarCurr,B)
      <=> ( v11421(VarCurr,B)
          | v11424(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11424(VarCurr,B)
      <=> ( v11149(VarCurr,B)
          & v11425(VarCurr,B) ) ) ) ).

tff(addAssignment_5764,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,0)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5763,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,1)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5762,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,2)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5761,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,3)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5760,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,4)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5759,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,5)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5758,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,6)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5757,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,7)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5756,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,8)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5755,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,9)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5754,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,10)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5753,axiom,
    ! [VarCurr: state_type] :
      ( v11425(VarCurr,11)
    <=> v11426(VarCurr) ) ).

tff(addAssignment_5752,axiom,
    ! [VarCurr: state_type] :
      ( v11426(VarCurr)
    <=> v11417(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_201,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11421(VarCurr,B)
      <=> ( v11141(VarCurr,B)
          & v11422(VarCurr,B) ) ) ) ).

tff(addAssignment_5751,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,0)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5750,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,1)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5749,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,2)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5748,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,3)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5747,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,4)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5746,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,5)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5745,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,6)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5744,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,7)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5743,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,8)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5742,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,9)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5741,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,10)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5740,axiom,
    ! [VarCurr: state_type] :
      ( v11422(VarCurr,11)
    <=> v11423(VarCurr) ) ).

tff(addAssignment_5739,axiom,
    ! [VarCurr: state_type] :
      ( v11423(VarCurr)
    <=> v11145(VarCurr) ) ).

tff(addAssignment_5738,axiom,
    ! [VarCurr: state_type] :
      ( v11417(VarCurr)
    <=> v11419(VarCurr) ) ).

tff(addAssignment_5737,axiom,
    ! [VarCurr: state_type] :
      ( v11419(VarCurr)
    <=> v9844(VarCurr,1) ) ).

tff(addAssignment_5736,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,1)
    <=> v9846(VarCurr,1) ) ).

tff(addAssignment_5735,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,1)
    <=> v9496(VarCurr,1) ) ).

tff(addAssignment_5734,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11149(VarCurr,B)
      <=> v11151(VarCurr,B) ) ) ).

tff(addAssignment_5733,axiom,
    ! [VarCurr: state_type] :
      ( ( v11151(VarCurr,11)
      <=> v9208(VarCurr,35) )
      & ( v11151(VarCurr,10)
      <=> v9208(VarCurr,34) )
      & ( v11151(VarCurr,9)
      <=> v9208(VarCurr,33) )
      & ( v11151(VarCurr,8)
      <=> v9208(VarCurr,32) )
      & ( v11151(VarCurr,7)
      <=> v9208(VarCurr,31) )
      & ( v11151(VarCurr,6)
      <=> v9208(VarCurr,30) )
      & ( v11151(VarCurr,5)
      <=> v9208(VarCurr,29) )
      & ( v11151(VarCurr,4)
      <=> v9208(VarCurr,28) )
      & ( v11151(VarCurr,3)
      <=> v9208(VarCurr,27) )
      & ( v11151(VarCurr,2)
      <=> v9208(VarCurr,26) )
      & ( v11151(VarCurr,1)
      <=> v9208(VarCurr,25) )
      & ( v11151(VarCurr,0)
      <=> v9208(VarCurr,24) ) ) ).

tff(addAssignment_5732,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,24) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_5731,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,24) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_5730,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,35)
      <=> v11153(VarCurr,11) )
      & ( v9212(VarCurr,34)
      <=> v11153(VarCurr,10) )
      & ( v9212(VarCurr,33)
      <=> v11153(VarCurr,9) )
      & ( v9212(VarCurr,32)
      <=> v11153(VarCurr,8) )
      & ( v9212(VarCurr,31)
      <=> v11153(VarCurr,7) )
      & ( v9212(VarCurr,30)
      <=> v11153(VarCurr,6) )
      & ( v9212(VarCurr,29)
      <=> v11153(VarCurr,5) )
      & ( v9212(VarCurr,28)
      <=> v11153(VarCurr,4) )
      & ( v9212(VarCurr,27)
      <=> v11153(VarCurr,3) )
      & ( v9212(VarCurr,26)
      <=> v11153(VarCurr,2) )
      & ( v9212(VarCurr,25)
      <=> v11153(VarCurr,1) )
      & ( v9212(VarCurr,24)
      <=> v11153(VarCurr,0) ) ) ).

tff(addAssignment_5729,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11153(VarCurr,B)
      <=> v11155(VarCurr,B) ) ) ).

tff(addAssignment_5728,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11155(VarCurr,B)
      <=> v11157(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11400(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v11157(VarNext,B)
            <=> v11157(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_130,axiom,
    ! [VarNext: state_type] :
      ( v11400(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11157(VarNext,B)
          <=> v11410(VarNext,B) ) ) ) ).

tff(addAssignment_5727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11410(VarNext,B)
          <=> v11408(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_104,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11411(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11408(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_104,axiom,
    ! [VarCurr: state_type] :
      ( v11411(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11408(VarCurr,B)
          <=> v11187(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_953,axiom,
    ! [VarCurr: state_type] :
      ( v11411(VarCurr)
    <=> ( v11412(VarCurr)
        & v11413(VarCurr) ) ) ).

tff(writeUnaryOperator_703,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11413(VarCurr)
    <=> v11173(VarCurr) ) ).

tff(writeUnaryOperator_702,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11412(VarCurr)
    <=> v11159(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_952,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11400(VarNext)
      <=> v11401(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_951,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11401(VarNext)
      <=> ( v11402(VarNext)
          & v11375(VarNext) ) ) ) ).

tff(writeUnaryOperator_701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v11402(VarNext)
      <=> v11404(VarNext) ) ) ).

tff(addAssignment_5726,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v11404(VarNext)
      <=> v11375(VarCurr) ) ) ).

tff(addAssignment_5725,axiom,
    ! [VarCurr: state_type] :
      ( v11375(VarCurr)
    <=> v11377(VarCurr) ) ).

tff(addAssignment_5724,axiom,
    ! [VarCurr: state_type] :
      ( v11377(VarCurr)
    <=> v11379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_950,axiom,
    ! [VarCurr: state_type] :
      ( v11379(VarCurr)
    <=> ( v11397(VarCurr)
        | v11389(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_949,axiom,
    ! [VarCurr: state_type] :
      ( v11397(VarCurr)
    <=> ( v11381(VarCurr)
        & v11387(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_33,axiom,
    ( v11387(constB0)
  <=> $true ) ).

tff(addAssignment_5723,axiom,
    ! [VarCurr: state_type] :
      ( v11389(VarCurr)
    <=> v11391(VarCurr) ) ).

tff(addAssignment_5722,axiom,
    ! [VarCurr: state_type] :
      ( v11391(VarCurr)
    <=> v11393(VarCurr) ) ).

tff(addAssignment_5721,axiom,
    ! [VarCurr: state_type] :
      ( v11393(VarCurr)
    <=> v11395(VarCurr) ) ).

tff(addAssignment_5720,axiom,
    ! [VarCurr: state_type] :
      ( v11395(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_5719,axiom,
    ! [VarCurr: state_type] :
      ( v11381(VarCurr)
    <=> v11383(VarCurr) ) ).

tff(addAssignment_5718,axiom,
    ! [VarCurr: state_type] :
      ( v11383(VarCurr)
    <=> v11385(VarCurr) ) ).

tff(addAssignment_5717,axiom,
    ! [VarCurr: state_type] :
      ( v11385(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_5716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11187(VarCurr,B)
      <=> v11189(VarCurr,B) ) ) ).

tff(addAssignment_5715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11189(VarCurr,B)
      <=> v11191(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_200,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11191(VarCurr,B)
      <=> ( v11360(VarCurr,B)
          | v11371(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_199,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11371(VarCurr,B)
      <=> ( v11324(VarCurr,B)
          & v11372(VarCurr,B) ) ) ) ).

tff(addAssignment_5714,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,0)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5713,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,1)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5712,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,2)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5711,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,3)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5710,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,4)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5709,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,5)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5708,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,6)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5707,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,7)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5706,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,8)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5705,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,9)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5704,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,10)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5703,axiom,
    ! [VarCurr: state_type] :
      ( v11372(VarCurr,11)
    <=> v11373(VarCurr) ) ).

tff(addAssignment_5702,axiom,
    ! [VarCurr: state_type] :
      ( v11373(VarCurr)
    <=> v11334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_198,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11360(VarCurr,B)
      <=> ( v11361(VarCurr,B)
          | v11368(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_197,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11368(VarCurr,B)
      <=> ( v11288(VarCurr,B)
          & v11369(VarCurr,B) ) ) ) ).

tff(addAssignment_5701,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,0)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5700,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,1)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5699,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,2)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5698,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,3)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5697,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,4)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5696,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,5)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5695,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,6)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5694,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,7)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5693,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,8)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5692,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,9)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5691,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,10)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5690,axiom,
    ! [VarCurr: state_type] :
      ( v11369(VarCurr,11)
    <=> v11370(VarCurr) ) ).

tff(addAssignment_5689,axiom,
    ! [VarCurr: state_type] :
      ( v11370(VarCurr)
    <=> v11298(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_196,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11361(VarCurr,B)
      <=> ( v11362(VarCurr,B)
          | v11365(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_195,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11365(VarCurr,B)
      <=> ( v11241(VarCurr,B)
          & v11366(VarCurr,B) ) ) ) ).

tff(addAssignment_5688,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,0)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5687,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,1)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5686,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,2)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5685,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,3)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5684,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,4)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5683,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,5)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5682,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,6)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5681,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,7)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5680,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,8)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5679,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,9)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5678,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,10)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5677,axiom,
    ! [VarCurr: state_type] :
      ( v11366(VarCurr,11)
    <=> v11367(VarCurr) ) ).

tff(addAssignment_5676,axiom,
    ! [VarCurr: state_type] :
      ( v11367(VarCurr)
    <=> v11251(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_194,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11362(VarCurr,B)
      <=> ( v11193(VarCurr,B)
          & v11363(VarCurr,B) ) ) ) ).

tff(addAssignment_5675,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,0)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5674,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,1)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5673,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,2)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5672,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,3)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5671,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,4)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5670,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,5)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5669,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,6)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5668,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,7)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5667,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,8)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5666,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,9)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5665,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,10)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5664,axiom,
    ! [VarCurr: state_type] :
      ( v11363(VarCurr,11)
    <=> v11364(VarCurr) ) ).

tff(addAssignment_5663,axiom,
    ! [VarCurr: state_type] :
      ( v11364(VarCurr)
    <=> v11203(VarCurr) ) ).

tff(addAssignment_5662,axiom,
    ! [VarCurr: state_type] :
      ( v11334(VarCurr)
    <=> v11336(VarCurr) ) ).

tff(addAssignment_5661,axiom,
    ! [VarCurr: state_type] :
      ( v11336(VarCurr)
    <=> v11338(VarCurr) ) ).

tff(addAssignment_5660,axiom,
    ! [VarCurr: state_type] :
      ( v11338(VarCurr)
    <=> v11340(VarCurr) ) ).

tff(addAssignment_5659,axiom,
    ! [VarCurr: state_type] :
      ( v11340(VarCurr)
    <=> v11342(VarCurr) ) ).

tff(addAssignment_5658,axiom,
    ! [VarCurr: state_type] :
      ( v11342(VarCurr)
    <=> v11344(VarCurr) ) ).

tff(addAssignment_5657,axiom,
    ! [VarCurr: state_type] :
      ( v11344(VarCurr)
    <=> v11346(VarCurr) ) ).

tff(addAssignment_5656,axiom,
    ! [VarCurr: state_type] :
      ( v11346(VarCurr)
    <=> v11348(VarCurr) ) ).

tff(writeUnaryOperator_700,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11348(VarCurr)
    <=> v11358(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_948,axiom,
    ! [VarCurr: state_type] :
      ( v11358(VarCurr)
    <=> ( v11350(VarCurr)
        | v11354(VarCurr) ) ) ).

tff(addAssignment_5655,axiom,
    ! [VarCurr: state_type] :
      ( v11354(VarCurr)
    <=> v11356(VarCurr) ) ).

tff(addAssignment_5654,axiom,
    ! [VarCurr: state_type] :
      ( v11356(VarCurr)
    <=> v11271(VarCurr,1) ) ).

tff(addAssignment_5653,axiom,
    ! [VarCurr: state_type] :
      ( v11350(VarCurr)
    <=> v11352(VarCurr) ) ).

tff(addAssignment_5652,axiom,
    ! [VarCurr: state_type] :
      ( v11352(VarCurr)
    <=> v11271(VarCurr,0) ) ).

tff(addAssignment_5651,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11324(VarCurr,B)
      <=> v11326(VarCurr,B) ) ) ).

tff(addAssignment_5650,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11326(VarCurr,B)
      <=> v11328(VarCurr,B) ) ) ).

tff(addAssignment_5649,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11328(VarCurr,B)
      <=> v11330(VarCurr,B) ) ) ).

tff(addAssignment_5648,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11330(VarCurr,B)
      <=> v11332(VarCurr,B) ) ) ).

tff(addAssignment_5647,axiom,
    ! [VarCurr: state_type] :
      ( v11298(VarCurr)
    <=> v11300(VarCurr) ) ).

tff(addAssignment_5646,axiom,
    ! [VarCurr: state_type] :
      ( v11300(VarCurr)
    <=> v11302(VarCurr) ) ).

tff(addAssignment_5645,axiom,
    ! [VarCurr: state_type] :
      ( v11302(VarCurr)
    <=> v11304(VarCurr) ) ).

tff(addAssignment_5644,axiom,
    ! [VarCurr: state_type] :
      ( v11304(VarCurr)
    <=> v11306(VarCurr) ) ).

tff(addAssignment_5643,axiom,
    ! [VarCurr: state_type] :
      ( v11306(VarCurr)
    <=> v11308(VarCurr) ) ).

tff(addAssignment_5642,axiom,
    ! [VarCurr: state_type] :
      ( v11308(VarCurr)
    <=> v11310(VarCurr) ) ).

tff(addAssignment_5641,axiom,
    ! [VarCurr: state_type] :
      ( v11310(VarCurr)
    <=> v11312(VarCurr) ) ).

tff(writeUnaryOperator_699,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11312(VarCurr)
    <=> v11322(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_947,axiom,
    ! [VarCurr: state_type] :
      ( v11322(VarCurr)
    <=> ( v11314(VarCurr)
        | v11318(VarCurr) ) ) ).

tff(addAssignment_5640,axiom,
    ! [VarCurr: state_type] :
      ( v11318(VarCurr)
    <=> v11320(VarCurr) ) ).

tff(addAssignment_5639,axiom,
    ! [VarCurr: state_type] :
      ( v11320(VarCurr)
    <=> v11271(VarCurr,1) ) ).

tff(addAssignment_5638,axiom,
    ! [VarCurr: state_type] :
      ( v11271(VarCurr,1)
    <=> v11273(VarCurr,1) ) ).

tff(addAssignment_5637,axiom,
    ! [VarCurr: state_type] :
      ( v11273(VarCurr,1)
    <=> v11275(VarCurr,1) ) ).

tff(addAssignment_5636,axiom,
    ! [VarCurr: state_type] :
      ( v11275(VarCurr,1)
    <=> v11280(VarCurr,1) ) ).

tff(addAssignment_5635,axiom,
    ! [VarCurr: state_type] :
      ( v11277(VarCurr,1)
    <=> v11279(VarCurr,1) ) ).

tff(addAssignment_5634,axiom,
    ! [VarCurr: state_type] :
      ( v11279(VarCurr,1)
    <=> v11223(VarCurr,1) ) ).

tff(addAssignment_5633,axiom,
    ! [VarCurr: state_type] :
      ( v11314(VarCurr)
    <=> v11316(VarCurr) ) ).

tff(addAssignment_5632,axiom,
    ! [VarCurr: state_type] :
      ( v11316(VarCurr)
    <=> v11223(VarCurr,0) ) ).

tff(addAssignment_5631,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11288(VarCurr,B)
      <=> v11290(VarCurr,B) ) ) ).

tff(addAssignment_5630,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11290(VarCurr,B)
      <=> v11292(VarCurr,B) ) ) ).

tff(addAssignment_5629,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11292(VarCurr,B)
      <=> v11294(VarCurr,B) ) ) ).

tff(addAssignment_5628,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11294(VarCurr,B)
      <=> v11296(VarCurr,B) ) ) ).

tff(addAssignment_5627,axiom,
    ! [VarCurr: state_type] :
      ( v11251(VarCurr)
    <=> v11253(VarCurr) ) ).

tff(addAssignment_5626,axiom,
    ! [VarCurr: state_type] :
      ( v11253(VarCurr)
    <=> v11255(VarCurr) ) ).

tff(addAssignment_5625,axiom,
    ! [VarCurr: state_type] :
      ( v11255(VarCurr)
    <=> v11257(VarCurr) ) ).

tff(addAssignment_5624,axiom,
    ! [VarCurr: state_type] :
      ( v11257(VarCurr)
    <=> v11259(VarCurr) ) ).

tff(addAssignment_5623,axiom,
    ! [VarCurr: state_type] :
      ( v11259(VarCurr)
    <=> v11261(VarCurr) ) ).

tff(addAssignment_5622,axiom,
    ! [VarCurr: state_type] :
      ( v11261(VarCurr)
    <=> v11263(VarCurr) ) ).

tff(addAssignment_5621,axiom,
    ! [VarCurr: state_type] :
      ( v11263(VarCurr)
    <=> v11265(VarCurr) ) ).

tff(writeUnaryOperator_698,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11265(VarCurr)
    <=> v11286(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_946,axiom,
    ! [VarCurr: state_type] :
      ( v11286(VarCurr)
    <=> ( v11267(VarCurr)
        | v11282(VarCurr) ) ) ).

tff(addAssignment_5620,axiom,
    ! [VarCurr: state_type] :
      ( v11282(VarCurr)
    <=> v11284(VarCurr) ) ).

tff(addAssignment_5619,axiom,
    ! [VarCurr: state_type] :
      ( v11284(VarCurr)
    <=> v11223(VarCurr,1) ) ).

tff(addAssignment_5618,axiom,
    ! [VarCurr: state_type] :
      ( v11267(VarCurr)
    <=> v11269(VarCurr) ) ).

tff(addAssignment_5617,axiom,
    ! [VarCurr: state_type] :
      ( v11269(VarCurr)
    <=> v11271(VarCurr,0) ) ).

tff(addAssignment_5616,axiom,
    ! [VarCurr: state_type] :
      ( v11271(VarCurr,0)
    <=> v11273(VarCurr,0) ) ).

tff(addAssignment_5615,axiom,
    ! [VarCurr: state_type] :
      ( v11273(VarCurr,0)
    <=> v11275(VarCurr,0) ) ).

tff(addAssignment_5614,axiom,
    ! [VarCurr: state_type] :
      ( v11275(VarCurr,0)
    <=> v11280(VarCurr,0) ) ).

tff(writeUnaryOperator_697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v11280(VarCurr,B)
      <=> ~ v11277(VarCurr,B) ) ) ).

tff(addAssignment_5613,axiom,
    ! [VarCurr: state_type] :
      ( v11277(VarCurr,0)
    <=> v11279(VarCurr,0) ) ).

tff(addAssignment_5612,axiom,
    ! [VarCurr: state_type] :
      ( v11279(VarCurr,0)
    <=> v11223(VarCurr,0) ) ).

tff(addAssignment_5611,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11241(VarCurr,B)
      <=> v11243(VarCurr,B) ) ) ).

tff(addAssignment_5610,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11243(VarCurr,B)
      <=> v11245(VarCurr,B) ) ) ).

tff(addAssignment_5609,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11245(VarCurr,B)
      <=> v11247(VarCurr,B) ) ) ).

tff(addAssignment_5608,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11247(VarCurr,B)
      <=> v11249(VarCurr,B) ) ) ).

tff(addAssignment_5607,axiom,
    ! [VarCurr: state_type] :
      ( v11203(VarCurr)
    <=> v11205(VarCurr) ) ).

tff(addAssignment_5606,axiom,
    ! [VarCurr: state_type] :
      ( v11205(VarCurr)
    <=> v11207(VarCurr) ) ).

tff(addAssignment_5605,axiom,
    ! [VarCurr: state_type] :
      ( v11207(VarCurr)
    <=> v11209(VarCurr) ) ).

tff(addAssignment_5604,axiom,
    ! [VarCurr: state_type] :
      ( v11209(VarCurr)
    <=> v11211(VarCurr) ) ).

tff(addAssignment_5603,axiom,
    ! [VarCurr: state_type] :
      ( v11211(VarCurr)
    <=> v11213(VarCurr) ) ).

tff(addAssignment_5602,axiom,
    ! [VarCurr: state_type] :
      ( v11213(VarCurr)
    <=> v11215(VarCurr) ) ).

tff(addAssignment_5601,axiom,
    ! [VarCurr: state_type] :
      ( v11215(VarCurr)
    <=> v11217(VarCurr) ) ).

tff(writeUnaryOperator_696,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11217(VarCurr)
    <=> v11239(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_945,axiom,
    ! [VarCurr: state_type] :
      ( v11239(VarCurr)
    <=> ( v11219(VarCurr)
        | v11235(VarCurr) ) ) ).

tff(addAssignment_5600,axiom,
    ! [VarCurr: state_type] :
      ( v11235(VarCurr)
    <=> v11237(VarCurr) ) ).

tff(addAssignment_5599,axiom,
    ! [VarCurr: state_type] :
      ( v11237(VarCurr)
    <=> v11223(VarCurr,1) ) ).

tff(addAssignment_5598,axiom,
    ! [VarCurr: state_type] :
      ( v11223(VarCurr,1)
    <=> v11225(VarCurr,1) ) ).

tff(addAssignment_5597,axiom,
    ! [VarCurr: state_type] :
      ( v11225(VarCurr,1)
    <=> v11227(VarCurr,1) ) ).

tff(addAssignment_5596,axiom,
    ! [VarCurr: state_type] :
      ( v11227(VarCurr,1)
    <=> v11229(VarCurr,1) ) ).

tff(addAssignment_5595,axiom,
    ! [VarCurr: state_type] :
      ( v11229(VarCurr,1)
    <=> v11231(VarCurr,1) ) ).

tff(addAssignment_5594,axiom,
    ! [VarCurr: state_type] :
      ( v11231(VarCurr,1)
    <=> v11233(VarCurr,1) ) ).

tff(addAssignment_5593,axiom,
    ! [VarCurr: state_type] :
      ( v11219(VarCurr)
    <=> v11221(VarCurr) ) ).

tff(addAssignment_5592,axiom,
    ! [VarCurr: state_type] :
      ( v11221(VarCurr)
    <=> v11223(VarCurr,0) ) ).

tff(addAssignment_5591,axiom,
    ! [VarCurr: state_type] :
      ( v11223(VarCurr,0)
    <=> v11225(VarCurr,0) ) ).

tff(addAssignment_5590,axiom,
    ! [VarCurr: state_type] :
      ( v11225(VarCurr,0)
    <=> v11227(VarCurr,0) ) ).

tff(addAssignment_5589,axiom,
    ! [VarCurr: state_type] :
      ( v11227(VarCurr,0)
    <=> v11229(VarCurr,0) ) ).

tff(addAssignment_5588,axiom,
    ! [VarCurr: state_type] :
      ( v11229(VarCurr,0)
    <=> v11231(VarCurr,0) ) ).

tff(addAssignment_5587,axiom,
    ! [VarCurr: state_type] :
      ( v11231(VarCurr,0)
    <=> v11233(VarCurr,0) ) ).

tff(addAssignment_5586,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11193(VarCurr,B)
      <=> v11195(VarCurr,B) ) ) ).

tff(addAssignment_5585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11195(VarCurr,B)
      <=> v11197(VarCurr,B) ) ) ).

tff(addAssignment_5584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11197(VarCurr,B)
      <=> v11199(VarCurr,B) ) ) ).

tff(addAssignment_5583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11199(VarCurr,B)
      <=> v11201(VarCurr,B) ) ) ).

tff(addAssignment_5582,axiom,
    ! [VarCurr: state_type] :
      ( v11173(VarCurr)
    <=> v11175(VarCurr) ) ).

tff(addAssignment_5581,axiom,
    ! [VarCurr: state_type] :
      ( v11175(VarCurr)
    <=> v11177(VarCurr) ) ).

tff(addAssignment_5580,axiom,
    ! [VarCurr: state_type] :
      ( v11177(VarCurr)
    <=> v11179(VarCurr) ) ).

tff(addAssignment_5579,axiom,
    ! [VarCurr: state_type] :
      ( v11179(VarCurr)
    <=> v11181(VarCurr) ) ).

tff(addAssignment_5578,axiom,
    ! [VarCurr: state_type] :
      ( v11181(VarCurr)
    <=> v11183(VarCurr) ) ).

tff(addAssignment_5577,axiom,
    ! [VarCurr: state_type] :
      ( v11183(VarCurr)
    <=> v11185(VarCurr) ) ).

tff(addAssignment_5576,axiom,
    ! [VarCurr: state_type] :
      ( v11185(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_5575,axiom,
    ! [VarCurr: state_type] :
      ( v11159(VarCurr)
    <=> v11161(VarCurr) ) ).

tff(addAssignment_5574,axiom,
    ! [VarCurr: state_type] :
      ( v11161(VarCurr)
    <=> v11163(VarCurr) ) ).

tff(addAssignment_5573,axiom,
    ! [VarCurr: state_type] :
      ( v11163(VarCurr)
    <=> v11165(VarCurr) ) ).

tff(addAssignment_5572,axiom,
    ! [VarCurr: state_type] :
      ( v11165(VarCurr)
    <=> v11167(VarCurr) ) ).

tff(addAssignment_5571,axiom,
    ! [VarCurr: state_type] :
      ( v11167(VarCurr)
    <=> v11169(VarCurr) ) ).

tff(addAssignment_5570,axiom,
    ! [VarCurr: state_type] :
      ( v11169(VarCurr)
    <=> v11171(VarCurr) ) ).

tff(addAssignment_5569,axiom,
    ! [VarCurr: state_type] :
      ( v11171(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_5568,axiom,
    ! [VarCurr: state_type] :
      ( v11145(VarCurr)
    <=> v11147(VarCurr) ) ).

tff(addAssignment_5567,axiom,
    ! [VarCurr: state_type] :
      ( v11147(VarCurr)
    <=> v9490(VarCurr,1) ) ).

tff(addAssignment_5566,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,1)
    <=> v9492(VarCurr,1) ) ).

tff(addAssignment_5565,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,1)
    <=> v9494(VarCurr,1) ) ).

tff(addAssignment_5564,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,1)
    <=> v9570(VarCurr,1) ) ).

tff(addAssignment_5563,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,1)
    <=> v9513(VarCurr,1) ) ).

tff(addAssignment_5562,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11141(VarCurr,B)
      <=> v11143(VarCurr,B) ) ) ).

tff(addAssignment_5561,axiom,
    ! [VarCurr: state_type] :
      ( ( v11143(VarCurr,11)
      <=> v9208(VarCurr,23) )
      & ( v11143(VarCurr,10)
      <=> v9208(VarCurr,22) )
      & ( v11143(VarCurr,9)
      <=> v9208(VarCurr,21) )
      & ( v11143(VarCurr,8)
      <=> v9208(VarCurr,20) )
      & ( v11143(VarCurr,7)
      <=> v9208(VarCurr,19) )
      & ( v11143(VarCurr,6)
      <=> v9208(VarCurr,18) )
      & ( v11143(VarCurr,5)
      <=> v9208(VarCurr,17) )
      & ( v11143(VarCurr,4)
      <=> v9208(VarCurr,16) )
      & ( v11143(VarCurr,3)
      <=> v9208(VarCurr,15) )
      & ( v11143(VarCurr,2)
      <=> v9208(VarCurr,14) )
      & ( v11143(VarCurr,1)
      <=> v9208(VarCurr,13) )
      & ( v11143(VarCurr,0)
      <=> v9208(VarCurr,12) ) ) ).

tff(addAssignment_5560,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11109(VarCurr,B)
      <=> v11111(VarCurr,B) ) ) ).

tff(addAssignment_5559,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,0)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5558,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,1)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5557,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,2)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5556,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,3)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5555,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,4)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5554,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,5)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5553,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,6)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5552,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,7)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5551,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,8)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5550,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,9)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5549,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,10)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5548,axiom,
    ! [VarCurr: state_type] :
      ( v11111(VarCurr,11)
    <=> v11129(VarCurr) ) ).

tff(addAssignment_5547,axiom,
    ! [VarCurr: state_type] :
      ( v11129(VarCurr)
    <=> v11113(VarCurr) ) ).

tff(addAssignment_5546,axiom,
    ! [VarCurr: state_type] :
      ( v11113(VarCurr)
    <=> v11115(VarCurr,0) ) ).

tff(addAssignment_5545,axiom,
    ! [VarCurr: state_type] :
      ( v11115(VarCurr,0)
    <=> v11117(VarCurr,0) ) ).

tff(addAssignment_5544,axiom,
    ! [VarCurr: state_type] :
      ( v11117(VarCurr,0)
    <=> v11127(VarCurr,0) ) ).

tff(writeUnaryOperator_695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v11127(VarCurr,B)
      <=> ~ v11119(VarCurr,B) ) ) ).

tff(addAssignment_5543,axiom,
    ! [VarCurr: state_type] :
      ( v11119(VarCurr,0)
    <=> v11121(VarCurr,0) ) ).

tff(addAssignment_5542,axiom,
    ! [VarCurr: state_type] :
      ( v11121(VarCurr,0)
    <=> v11124(VarCurr,0) ) ).

tff(addAssignment_5541,axiom,
    ! [VarCurr: state_type] :
      ( v11124(VarCurr,0)
    <=> v11123(VarCurr) ) ).

tff(addAssignment_5540,axiom,
    ! [VarCurr: state_type] :
      ( v11124(VarCurr,1)
    <=> v11126(VarCurr) ) ).

tff(addAssignment_5539,axiom,
    ! [VarCurr: state_type] :
      ( v11124(VarCurr,2)
    <=> v11125(VarCurr) ) ).

tff(addAssignment_5538,axiom,
    ! [VarCurr: state_type] :
      ( v11123(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_5537,axiom,
    ! [VarCurr: state_type] :
      ( v11085(VarCurr)
    <=> v11087(VarCurr) ) ).

tff(addAssignment_5536,axiom,
    ! [VarCurr: state_type] :
      ( v11087(VarCurr)
    <=> v11089(VarCurr) ) ).

tff(addAssignment_5535,axiom,
    ! [VarCurr: state_type] :
      ( v11089(VarCurr)
    <=> v11091(VarCurr) ) ).

tff(addAssignment_5534,axiom,
    ! [VarCurr: state_type] :
      ( v11091(VarCurr)
    <=> v11093(VarCurr) ) ).

tff(addAssignment_5533,axiom,
    ! [VarCurr: state_type] :
      ( v11093(VarCurr)
    <=> v11095(VarCurr) ) ).

tff(addAssignment_5532,axiom,
    ! [VarCurr: state_type] :
      ( v11095(VarCurr)
    <=> v11097(VarCurr) ) ).

tff(addAssignment_5531,axiom,
    ! [VarCurr: state_type] :
      ( v11097(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_5530,axiom,
    ! [VarCurr: state_type] :
      ( v11071(VarCurr)
    <=> v11073(VarCurr) ) ).

tff(addAssignment_5529,axiom,
    ! [VarCurr: state_type] :
      ( v11073(VarCurr)
    <=> v11075(VarCurr) ) ).

tff(addAssignment_5528,axiom,
    ! [VarCurr: state_type] :
      ( v11075(VarCurr)
    <=> v11077(VarCurr) ) ).

tff(addAssignment_5527,axiom,
    ! [VarCurr: state_type] :
      ( v11077(VarCurr)
    <=> v11079(VarCurr) ) ).

tff(addAssignment_5526,axiom,
    ! [VarCurr: state_type] :
      ( v11079(VarCurr)
    <=> v11081(VarCurr) ) ).

tff(addAssignment_5525,axiom,
    ! [VarCurr: state_type] :
      ( v11081(VarCurr)
    <=> v11083(VarCurr) ) ).

tff(addAssignment_5524,axiom,
    ! [VarCurr: state_type] :
      ( v11083(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_5523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11047(VarCurr,B)
      <=> v11049(VarCurr,B) ) ) ).

tff(addAssignment_5522,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11049(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_5521,axiom,
    ! [VarCurr: state_type] :
      ( v9085(VarCurr)
    <=> v9087(VarCurr) ) ).

tff(addAssignment_5520,axiom,
    ! [VarCurr: state_type] :
      ( v9087(VarCurr)
    <=> v9089(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_86,axiom,
    ! [VarCurr: state_type] :
      ( v9089(VarCurr)
    <=> ( ( v9091(VarCurr,11)
        <=> v9095(VarCurr,11) )
        & ( v9091(VarCurr,10)
        <=> v9095(VarCurr,10) )
        & ( v9091(VarCurr,9)
        <=> v9095(VarCurr,9) )
        & ( v9091(VarCurr,8)
        <=> v9095(VarCurr,8) )
        & ( v9091(VarCurr,7)
        <=> v9095(VarCurr,7) )
        & ( v9091(VarCurr,6)
        <=> v9095(VarCurr,6) )
        & ( v9091(VarCurr,5)
        <=> v9095(VarCurr,5) )
        & ( v9091(VarCurr,4)
        <=> v9095(VarCurr,4) )
        & ( v9091(VarCurr,3)
        <=> v9095(VarCurr,3) )
        & ( v9091(VarCurr,2)
        <=> v9095(VarCurr,2) )
        & ( v9091(VarCurr,1)
        <=> v9095(VarCurr,1) )
        & ( v9091(VarCurr,0)
        <=> v9095(VarCurr,0) ) ) ) ).

tff(addAssignment_5519,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9095(VarCurr,B)
      <=> v9097(VarCurr,B) ) ) ).

tff(addAssignment_5518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9097(VarCurr,B)
      <=> v9099(VarCurr,B) ) ) ).

tff(addAssignment_5517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9099(VarCurr,B)
      <=> v9101(VarCurr,B) ) ) ).

tff(addAssignment_5516,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9101(VarCurr,B)
      <=> v9103(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_193,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9103(VarCurr,B)
      <=> ( v11017(VarCurr,B)
          | v11036(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_192,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11036(VarCurr,B)
      <=> ( v10888(VarCurr,B)
          & v11037(VarCurr,B) ) ) ) ).

tff(addAssignment_5515,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,0)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5514,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,1)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5513,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,2)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5512,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,3)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5511,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,4)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5510,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,5)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5509,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,6)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5508,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,7)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5507,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,8)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5506,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,9)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5505,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,10)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5504,axiom,
    ! [VarCurr: state_type] :
      ( v11037(VarCurr,11)
    <=> v11038(VarCurr) ) ).

tff(addAssignment_5503,axiom,
    ! [VarCurr: state_type] :
      ( v11038(VarCurr)
    <=> v11007(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_191,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11017(VarCurr,B)
      <=> ( v11018(VarCurr,B)
          | v11033(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_190,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11033(VarCurr,B)
      <=> ( v10737(VarCurr,B)
          & v11034(VarCurr,B) ) ) ) ).

tff(addAssignment_5502,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,0)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5501,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,1)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5500,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,2)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5499,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,3)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5498,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,4)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5497,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,5)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5496,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,6)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5495,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,7)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5494,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,8)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5493,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,9)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5492,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,10)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5491,axiom,
    ! [VarCurr: state_type] :
      ( v11034(VarCurr,11)
    <=> v11035(VarCurr) ) ).

tff(addAssignment_5490,axiom,
    ! [VarCurr: state_type] :
      ( v11035(VarCurr)
    <=> v10857(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_189,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11018(VarCurr,B)
      <=> ( v11019(VarCurr,B)
          | v11030(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_188,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11030(VarCurr,B)
      <=> ( v10586(VarCurr,B)
          & v11031(VarCurr,B) ) ) ) ).

tff(addAssignment_5489,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,0)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5488,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,1)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5487,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,2)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5486,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,3)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5485,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,4)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5484,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,5)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5483,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,6)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5482,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,7)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5481,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,8)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5480,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,9)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5479,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,10)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5478,axiom,
    ! [VarCurr: state_type] :
      ( v11031(VarCurr,11)
    <=> v11032(VarCurr) ) ).

tff(addAssignment_5477,axiom,
    ! [VarCurr: state_type] :
      ( v11032(VarCurr)
    <=> v10706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_187,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11019(VarCurr,B)
      <=> ( v11020(VarCurr,B)
          | v11027(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_186,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11027(VarCurr,B)
      <=> ( v10435(VarCurr,B)
          & v11028(VarCurr,B) ) ) ) ).

tff(addAssignment_5476,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,0)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5475,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,1)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5474,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,2)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5473,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,3)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5472,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,4)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5471,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,5)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5470,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,6)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5469,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,7)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5468,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,8)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5467,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,9)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5466,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,10)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5465,axiom,
    ! [VarCurr: state_type] :
      ( v11028(VarCurr,11)
    <=> v11029(VarCurr) ) ).

tff(addAssignment_5464,axiom,
    ! [VarCurr: state_type] :
      ( v11029(VarCurr)
    <=> v10555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_185,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11020(VarCurr,B)
      <=> ( v11021(VarCurr,B)
          | v11024(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_184,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11024(VarCurr,B)
      <=> ( v10273(VarCurr,B)
          & v11025(VarCurr,B) ) ) ) ).

tff(addAssignment_5463,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,0)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5462,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,1)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5461,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,2)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5460,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,3)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5459,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,4)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5458,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,5)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5457,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,6)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5456,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,7)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5455,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,8)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5454,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,9)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5453,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,10)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5452,axiom,
    ! [VarCurr: state_type] :
      ( v11025(VarCurr,11)
    <=> v11026(VarCurr) ) ).

tff(addAssignment_5451,axiom,
    ! [VarCurr: state_type] :
      ( v11026(VarCurr)
    <=> v10404(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v11021(VarCurr,B)
      <=> ( v9105(VarCurr,B)
          & v11022(VarCurr,B) ) ) ) ).

tff(addAssignment_5450,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,0)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5449,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,1)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5448,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,2)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5447,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,3)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5446,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,4)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5445,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,5)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5444,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,6)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5443,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,7)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5442,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,8)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5441,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,9)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5440,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,10)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5439,axiom,
    ! [VarCurr: state_type] :
      ( v11022(VarCurr,11)
    <=> v11023(VarCurr) ) ).

tff(addAssignment_5438,axiom,
    ! [VarCurr: state_type] :
      ( v11023(VarCurr)
    <=> v9964(VarCurr) ) ).

tff(addAssignment_5437,axiom,
    ! [VarCurr: state_type] :
      ( v11007(VarCurr)
    <=> v11009(VarCurr) ) ).

tff(addAssignment_5436,axiom,
    ! [VarCurr: state_type] :
      ( v11009(VarCurr)
    <=> v11011(VarCurr) ) ).

tff(addAssignment_5435,axiom,
    ! [VarCurr: state_type] :
      ( v11011(VarCurr)
    <=> v11013(VarCurr) ) ).

tff(addAssignment_5434,axiom,
    ! [VarCurr: state_type] :
      ( v11013(VarCurr)
    <=> v11015(VarCurr) ) ).

tff(addAssignment_5433,axiom,
    ! [VarCurr: state_type] :
      ( v11015(VarCurr)
    <=> v10074(VarCurr) ) ).

tff(addAssignment_5432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10888(VarCurr,B)
      <=> v10890(VarCurr,B) ) ) ).

tff(addAssignment_5431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10890(VarCurr,B)
      <=> v10892(VarCurr,B) ) ) ).

tff(addAssignment_5430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10892(VarCurr,B)
      <=> v10894(VarCurr,B) ) ) ).

tff(addAssignment_5429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10894(VarCurr,B)
      <=> v10896(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_129,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10990(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v10896(VarNext,B)
            <=> v10896(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_129,axiom,
    ! [VarNext: state_type] :
      ( v10990(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10896(VarNext,B)
          <=> v11000(VarNext,B) ) ) ) ).

tff(addAssignment_5428,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v11000(VarNext,B)
          <=> v10998(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11001(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10998(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_103,axiom,
    ! [VarCurr: state_type] :
      ( v11001(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10998(VarCurr,B)
          <=> v10918(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_944,axiom,
    ! [VarCurr: state_type] :
      ( v11001(VarCurr)
    <=> ( v11002(VarCurr)
        & v11003(VarCurr) ) ) ).

tff(writeUnaryOperator_694,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11003(VarCurr)
    <=> v10908(VarCurr) ) ).

tff(writeUnaryOperator_693,axiom,
    ! [VarCurr: state_type] :
      ( ~ v11002(VarCurr)
    <=> v10898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_943,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10990(VarNext)
      <=> v10991(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_942,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10991(VarNext)
      <=> ( v10992(VarNext)
          & v10922(VarNext) ) ) ) ).

tff(writeUnaryOperator_692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10992(VarNext)
      <=> v10994(VarNext) ) ) ).

tff(addAssignment_5427,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10994(VarNext)
      <=> v10922(VarCurr) ) ) ).

tff(addAssignment_5426,axiom,
    ! [VarCurr: state_type] :
      ( v10922(VarCurr)
    <=> v10924(VarCurr) ) ).

tff(addAssignment_5425,axiom,
    ! [VarCurr: state_type] :
      ( v10924(VarCurr)
    <=> v10926(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_941,axiom,
    ! [VarCurr: state_type] :
      ( v10926(VarCurr)
    <=> ( v10987(VarCurr)
        | v10983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_940,axiom,
    ! [VarCurr: state_type] :
      ( v10987(VarCurr)
    <=> ( v10928(VarCurr)
        & v10932(VarCurr) ) ) ).

tff(addAssignment_5424,axiom,
    ! [VarCurr: state_type] :
      ( v10983(VarCurr)
    <=> v10985(VarCurr) ) ).

tff(addAssignment_5423,axiom,
    ! [VarCurr: state_type] :
      ( v10985(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10967(VarNext)
       => ( v10932(VarNext)
        <=> v10932(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_128,axiom,
    ! [VarNext: state_type] :
      ( v10967(VarNext)
     => ( v10932(VarNext)
      <=> v10977(VarNext) ) ) ).

tff(addAssignment_5422,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10977(VarNext)
      <=> v10975(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_939,axiom,
    ! [VarCurr: state_type] :
      ( v10975(VarCurr)
    <=> ( v10978(VarCurr)
        & v10979(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_938,axiom,
    ! [VarCurr: state_type] :
      ( v10979(VarCurr)
    <=> ( v10938(VarCurr)
        | v10962(VarCurr) ) ) ).

tff(writeUnaryOperator_691,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10978(VarCurr)
    <=> v10934(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_937,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10967(VarNext)
      <=> v10968(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_936,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10968(VarNext)
      <=> ( v10970(VarNext)
          & v10972(VarNext) ) ) ) ).

tff(writeUnaryOperator_690,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10972(VarCurr)
    <=> v10928(VarCurr) ) ).

tff(addAssignment_5421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10970(VarNext)
      <=> v10928(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_32,axiom,
    ( v10932(constB0)
  <=> $true ) ).

tff(addAssignment_5420,axiom,
    ! [VarCurr: state_type] :
      ( v10962(VarCurr)
    <=> v10964(VarCurr) ) ).

tff(addAssignment_5419,axiom,
    ! [VarCurr: state_type] :
      ( v10964(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5418,axiom,
    ! [VarCurr: state_type] :
      ( v10938(VarCurr)
    <=> v10940(VarCurr) ) ).

tff(addAssignment_5417,axiom,
    ! [VarCurr: state_type] :
      ( v10940(VarCurr)
    <=> v10248(VarCurr) ) ).

tff(addAssignment_5416,axiom,
    ! [VarCurr: state_type] :
      ( v10248(VarCurr)
    <=> v10943(VarCurr) ) ).

tff(addAssignment_5415,axiom,
    ! [VarCurr: state_type] :
      ( v10943(VarCurr)
    <=> v10945(VarCurr) ) ).

tff(writeUnaryOperator_689,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10945(VarCurr)
    <=> v10959(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_935,axiom,
    ! [VarCurr: state_type] :
      ( v10959(VarCurr)
    <=> ( v10960(VarCurr)
        | v10955(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_934,axiom,
    ! [VarCurr: state_type] :
      ( v10960(VarCurr)
    <=> ( v10947(VarCurr)
        | v10951(VarCurr) ) ) ).

tff(addAssignment_5414,axiom,
    ! [VarCurr: state_type] :
      ( v10955(VarCurr)
    <=> v10957(VarCurr) ) ).

tff(addAssignment_5413,axiom,
    ! [VarCurr: state_type] :
      ( v10957(VarCurr)
    <=> v10337(VarCurr,2) ) ).

tff(addAssignment_5412,axiom,
    ! [VarCurr: state_type] :
      ( v10951(VarCurr)
    <=> v10953(VarCurr) ) ).

tff(addAssignment_5411,axiom,
    ! [VarCurr: state_type] :
      ( v10953(VarCurr)
    <=> v9890(VarCurr,1) ) ).

tff(addAssignment_5410,axiom,
    ! [VarCurr: state_type] :
      ( v10947(VarCurr)
    <=> v10949(VarCurr) ) ).

tff(addAssignment_5409,axiom,
    ! [VarCurr: state_type] :
      ( v10949(VarCurr)
    <=> v10337(VarCurr,0) ) ).

tff(addAssignment_5408,axiom,
    ! [VarCurr: state_type] :
      ( v10934(VarCurr)
    <=> v10936(VarCurr) ) ).

tff(addAssignment_5407,axiom,
    ! [VarCurr: state_type] :
      ( v10936(VarCurr)
    <=> $false ) ).

tff(addAssignment_5406,axiom,
    ! [VarCurr: state_type] :
      ( v10928(VarCurr)
    <=> v10930(VarCurr) ) ).

tff(addAssignment_5405,axiom,
    ! [VarCurr: state_type] :
      ( v10930(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5404,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10918(VarCurr,B)
      <=> v10920(VarCurr,B) ) ) ).

tff(addAssignment_5403,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10920(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_5402,axiom,
    ! [VarCurr: state_type] :
      ( v10908(VarCurr)
    <=> v10910(VarCurr) ) ).

tff(addAssignment_5401,axiom,
    ! [VarCurr: state_type] :
      ( v10910(VarCurr)
    <=> v10912(VarCurr) ) ).

tff(addAssignment_5400,axiom,
    ! [VarCurr: state_type] :
      ( v10912(VarCurr)
    <=> v10914(VarCurr) ) ).

tff(addAssignment_5399,axiom,
    ! [VarCurr: state_type] :
      ( v10914(VarCurr)
    <=> v10916(VarCurr) ) ).

tff(addAssignment_5398,axiom,
    ! [VarCurr: state_type] :
      ( v10916(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_5397,axiom,
    ! [VarCurr: state_type] :
      ( v10898(VarCurr)
    <=> v10900(VarCurr) ) ).

tff(addAssignment_5396,axiom,
    ! [VarCurr: state_type] :
      ( v10900(VarCurr)
    <=> v10902(VarCurr) ) ).

tff(addAssignment_5395,axiom,
    ! [VarCurr: state_type] :
      ( v10902(VarCurr)
    <=> v10904(VarCurr) ) ).

tff(addAssignment_5394,axiom,
    ! [VarCurr: state_type] :
      ( v10904(VarCurr)
    <=> v10906(VarCurr) ) ).

tff(addAssignment_5393,axiom,
    ! [VarCurr: state_type] :
      ( v10906(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_5392,axiom,
    ! [VarCurr: state_type] :
      ( v10857(VarCurr)
    <=> v10859(VarCurr) ) ).

tff(addAssignment_5391,axiom,
    ! [VarCurr: state_type] :
      ( v10859(VarCurr)
    <=> v10861(VarCurr) ) ).

tff(addAssignment_5390,axiom,
    ! [VarCurr: state_type] :
      ( v10861(VarCurr)
    <=> v10863(VarCurr) ) ).

tff(addAssignment_5389,axiom,
    ! [VarCurr: state_type] :
      ( v10863(VarCurr)
    <=> v10865(VarCurr) ) ).

tff(addAssignment_5388,axiom,
    ! [VarCurr: state_type] :
      ( v10865(VarCurr)
    <=> v10867(VarCurr) ) ).

tff(addAssignment_5387,axiom,
    ! [VarCurr: state_type] :
      ( v10867(VarCurr)
    <=> v10869(VarCurr) ) ).

tff(addAssignment_5386,axiom,
    ! [VarCurr: state_type] :
      ( v10869(VarCurr)
    <=> v10871(VarCurr) ) ).

tff(writeUnaryOperator_688,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10871(VarCurr)
    <=> v10885(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_933,axiom,
    ! [VarCurr: state_type] :
      ( v10885(VarCurr)
    <=> ( v10886(VarCurr)
        | v10881(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_932,axiom,
    ! [VarCurr: state_type] :
      ( v10886(VarCurr)
    <=> ( v10873(VarCurr)
        | v10877(VarCurr) ) ) ).

tff(addAssignment_5385,axiom,
    ! [VarCurr: state_type] :
      ( v10881(VarCurr)
    <=> v10883(VarCurr) ) ).

tff(addAssignment_5384,axiom,
    ! [VarCurr: state_type] :
      ( v10883(VarCurr)
    <=> v10084(VarCurr,2) ) ).

tff(addAssignment_5383,axiom,
    ! [VarCurr: state_type] :
      ( v10877(VarCurr)
    <=> v10879(VarCurr) ) ).

tff(addAssignment_5382,axiom,
    ! [VarCurr: state_type] :
      ( v10879(VarCurr)
    <=> v9984(VarCurr,1) ) ).

tff(addAssignment_5381,axiom,
    ! [VarCurr: state_type] :
      ( v10873(VarCurr)
    <=> v10875(VarCurr) ) ).

tff(addAssignment_5380,axiom,
    ! [VarCurr: state_type] :
      ( v10875(VarCurr)
    <=> v9984(VarCurr,0) ) ).

tff(addAssignment_5379,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10737(VarCurr,B)
      <=> v10739(VarCurr,B) ) ) ).

tff(addAssignment_5378,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10739(VarCurr,B)
      <=> v10741(VarCurr,B) ) ) ).

tff(addAssignment_5377,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10741(VarCurr,B)
      <=> v10743(VarCurr,B) ) ) ).

tff(addAssignment_5376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10743(VarCurr,B)
      <=> v10745(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10840(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v10745(VarNext,B)
            <=> v10745(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_127,axiom,
    ! [VarNext: state_type] :
      ( v10840(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10745(VarNext,B)
          <=> v10850(VarNext,B) ) ) ) ).

tff(addAssignment_5375,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10850(VarNext,B)
          <=> v10848(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10848(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_102,axiom,
    ! [VarCurr: state_type] :
      ( v10851(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10848(VarCurr,B)
          <=> v10767(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_931,axiom,
    ! [VarCurr: state_type] :
      ( v10851(VarCurr)
    <=> ( v10852(VarCurr)
        & v10853(VarCurr) ) ) ).

tff(writeUnaryOperator_687,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10853(VarCurr)
    <=> v10757(VarCurr) ) ).

tff(writeUnaryOperator_686,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10852(VarCurr)
    <=> v10747(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_930,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10840(VarNext)
      <=> v10841(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_929,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10841(VarNext)
      <=> ( v10842(VarNext)
          & v10771(VarNext) ) ) ) ).

tff(writeUnaryOperator_685,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10842(VarNext)
      <=> v10844(VarNext) ) ) ).

tff(addAssignment_5374,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10844(VarNext)
      <=> v10771(VarCurr) ) ) ).

tff(addAssignment_5373,axiom,
    ! [VarCurr: state_type] :
      ( v10771(VarCurr)
    <=> v10773(VarCurr) ) ).

tff(addAssignment_5372,axiom,
    ! [VarCurr: state_type] :
      ( v10773(VarCurr)
    <=> v10775(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_928,axiom,
    ! [VarCurr: state_type] :
      ( v10775(VarCurr)
    <=> ( v10837(VarCurr)
        | v10833(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_927,axiom,
    ! [VarCurr: state_type] :
      ( v10837(VarCurr)
    <=> ( v10777(VarCurr)
        & v10781(VarCurr) ) ) ).

tff(addAssignment_5371,axiom,
    ! [VarCurr: state_type] :
      ( v10833(VarCurr)
    <=> v10835(VarCurr) ) ).

tff(addAssignment_5370,axiom,
    ! [VarCurr: state_type] :
      ( v10835(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_126,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10817(VarNext)
       => ( v10781(VarNext)
        <=> v10781(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_126,axiom,
    ! [VarNext: state_type] :
      ( v10817(VarNext)
     => ( v10781(VarNext)
      <=> v10827(VarNext) ) ) ).

tff(addAssignment_5369,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10827(VarNext)
      <=> v10825(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_926,axiom,
    ! [VarCurr: state_type] :
      ( v10825(VarCurr)
    <=> ( v10828(VarCurr)
        & v10829(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_925,axiom,
    ! [VarCurr: state_type] :
      ( v10829(VarCurr)
    <=> ( v10787(VarCurr)
        | v10812(VarCurr) ) ) ).

tff(writeUnaryOperator_684,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10828(VarCurr)
    <=> v10783(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_924,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10817(VarNext)
      <=> v10818(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_923,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10818(VarNext)
      <=> ( v10820(VarNext)
          & v10822(VarNext) ) ) ) ).

tff(writeUnaryOperator_683,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10822(VarCurr)
    <=> v10777(VarCurr) ) ).

tff(addAssignment_5368,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10820(VarNext)
      <=> v10777(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_31,axiom,
    ( v10781(constB0)
  <=> $true ) ).

tff(addAssignment_5367,axiom,
    ! [VarCurr: state_type] :
      ( v10812(VarCurr)
    <=> v10814(VarCurr) ) ).

tff(addAssignment_5366,axiom,
    ! [VarCurr: state_type] :
      ( v10814(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5365,axiom,
    ! [VarCurr: state_type] :
      ( v10787(VarCurr)
    <=> v10789(VarCurr) ) ).

tff(addAssignment_5364,axiom,
    ! [VarCurr: state_type] :
      ( v10789(VarCurr)
    <=> v10791(VarCurr) ) ).

tff(addAssignment_5363,axiom,
    ! [VarCurr: state_type] :
      ( v10791(VarCurr)
    <=> v10793(VarCurr) ) ).

tff(addAssignment_5362,axiom,
    ! [VarCurr: state_type] :
      ( v10793(VarCurr)
    <=> v10795(VarCurr) ) ).

tff(writeUnaryOperator_682,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10795(VarCurr)
    <=> v10809(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_922,axiom,
    ! [VarCurr: state_type] :
      ( v10809(VarCurr)
    <=> ( v10810(VarCurr)
        | v10805(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_921,axiom,
    ! [VarCurr: state_type] :
      ( v10810(VarCurr)
    <=> ( v10797(VarCurr)
        | v10801(VarCurr) ) ) ).

tff(addAssignment_5361,axiom,
    ! [VarCurr: state_type] :
      ( v10805(VarCurr)
    <=> v10807(VarCurr) ) ).

tff(addAssignment_5360,axiom,
    ! [VarCurr: state_type] :
      ( v10807(VarCurr)
    <=> v10337(VarCurr,2) ) ).

tff(addAssignment_5359,axiom,
    ! [VarCurr: state_type] :
      ( v10337(VarCurr,2)
    <=> v10339(VarCurr,2) ) ).

tff(addAssignment_5358,axiom,
    ! [VarCurr: state_type] :
      ( v10339(VarCurr,2)
    <=> v10341(VarCurr,2) ) ).

tff(addAssignment_5357,axiom,
    ! [VarCurr: state_type] :
      ( v10341(VarCurr,2)
    <=> v10346(VarCurr,2) ) ).

tff(addAssignment_5356,axiom,
    ! [VarCurr: state_type] :
      ( v10343(VarCurr,2)
    <=> v10345(VarCurr,2) ) ).

tff(addAssignment_5355,axiom,
    ! [VarCurr: state_type] :
      ( v10345(VarCurr,2)
    <=> v9890(VarCurr,2) ) ).

tff(addAssignment_5354,axiom,
    ! [VarCurr: state_type] :
      ( v10801(VarCurr)
    <=> v10803(VarCurr) ) ).

tff(addAssignment_5353,axiom,
    ! [VarCurr: state_type] :
      ( v10803(VarCurr)
    <=> v9890(VarCurr,1) ) ).

tff(addAssignment_5352,axiom,
    ! [VarCurr: state_type] :
      ( v10797(VarCurr)
    <=> v10799(VarCurr) ) ).

tff(addAssignment_5351,axiom,
    ! [VarCurr: state_type] :
      ( v10799(VarCurr)
    <=> v9890(VarCurr,0) ) ).

tff(addAssignment_5350,axiom,
    ! [VarCurr: state_type] :
      ( v10783(VarCurr)
    <=> v10785(VarCurr) ) ).

tff(addAssignment_5349,axiom,
    ! [VarCurr: state_type] :
      ( v10785(VarCurr)
    <=> $false ) ).

tff(addAssignment_5348,axiom,
    ! [VarCurr: state_type] :
      ( v10777(VarCurr)
    <=> v10779(VarCurr) ) ).

tff(addAssignment_5347,axiom,
    ! [VarCurr: state_type] :
      ( v10779(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5346,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10767(VarCurr,B)
      <=> v10769(VarCurr,B) ) ) ).

tff(addAssignment_5345,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10769(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_5344,axiom,
    ! [VarCurr: state_type] :
      ( v10757(VarCurr)
    <=> v10759(VarCurr) ) ).

tff(addAssignment_5343,axiom,
    ! [VarCurr: state_type] :
      ( v10759(VarCurr)
    <=> v10761(VarCurr) ) ).

tff(addAssignment_5342,axiom,
    ! [VarCurr: state_type] :
      ( v10761(VarCurr)
    <=> v10763(VarCurr) ) ).

tff(addAssignment_5341,axiom,
    ! [VarCurr: state_type] :
      ( v10763(VarCurr)
    <=> v10765(VarCurr) ) ).

tff(addAssignment_5340,axiom,
    ! [VarCurr: state_type] :
      ( v10765(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_5339,axiom,
    ! [VarCurr: state_type] :
      ( v10747(VarCurr)
    <=> v10749(VarCurr) ) ).

tff(addAssignment_5338,axiom,
    ! [VarCurr: state_type] :
      ( v10749(VarCurr)
    <=> v10751(VarCurr) ) ).

tff(addAssignment_5337,axiom,
    ! [VarCurr: state_type] :
      ( v10751(VarCurr)
    <=> v10753(VarCurr) ) ).

tff(addAssignment_5336,axiom,
    ! [VarCurr: state_type] :
      ( v10753(VarCurr)
    <=> v10755(VarCurr) ) ).

tff(addAssignment_5335,axiom,
    ! [VarCurr: state_type] :
      ( v10755(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_5334,axiom,
    ! [VarCurr: state_type] :
      ( v10706(VarCurr)
    <=> v10708(VarCurr) ) ).

tff(addAssignment_5333,axiom,
    ! [VarCurr: state_type] :
      ( v10708(VarCurr)
    <=> v10710(VarCurr) ) ).

tff(addAssignment_5332,axiom,
    ! [VarCurr: state_type] :
      ( v10710(VarCurr)
    <=> v10712(VarCurr) ) ).

tff(addAssignment_5331,axiom,
    ! [VarCurr: state_type] :
      ( v10712(VarCurr)
    <=> v10714(VarCurr) ) ).

tff(addAssignment_5330,axiom,
    ! [VarCurr: state_type] :
      ( v10714(VarCurr)
    <=> v10716(VarCurr) ) ).

tff(addAssignment_5329,axiom,
    ! [VarCurr: state_type] :
      ( v10716(VarCurr)
    <=> v10718(VarCurr) ) ).

tff(addAssignment_5328,axiom,
    ! [VarCurr: state_type] :
      ( v10718(VarCurr)
    <=> v10720(VarCurr) ) ).

tff(writeUnaryOperator_681,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10720(VarCurr)
    <=> v10734(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_920,axiom,
    ! [VarCurr: state_type] :
      ( v10734(VarCurr)
    <=> ( v10735(VarCurr)
        | v10730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_919,axiom,
    ! [VarCurr: state_type] :
      ( v10735(VarCurr)
    <=> ( v10722(VarCurr)
        | v10726(VarCurr) ) ) ).

tff(addAssignment_5327,axiom,
    ! [VarCurr: state_type] :
      ( v10730(VarCurr)
    <=> v10732(VarCurr) ) ).

tff(addAssignment_5326,axiom,
    ! [VarCurr: state_type] :
      ( v10732(VarCurr)
    <=> v9984(VarCurr,2) ) ).

tff(addAssignment_5325,axiom,
    ! [VarCurr: state_type] :
      ( v10726(VarCurr)
    <=> v10728(VarCurr) ) ).

tff(addAssignment_5324,axiom,
    ! [VarCurr: state_type] :
      ( v10728(VarCurr)
    <=> v10084(VarCurr,1) ) ).

tff(addAssignment_5323,axiom,
    ! [VarCurr: state_type] :
      ( v10722(VarCurr)
    <=> v10724(VarCurr) ) ).

tff(addAssignment_5322,axiom,
    ! [VarCurr: state_type] :
      ( v10724(VarCurr)
    <=> v10084(VarCurr,0) ) ).

tff(addAssignment_5321,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10586(VarCurr,B)
      <=> v10588(VarCurr,B) ) ) ).

tff(addAssignment_5320,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10588(VarCurr,B)
      <=> v10590(VarCurr,B) ) ) ).

tff(addAssignment_5319,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10590(VarCurr,B)
      <=> v10592(VarCurr,B) ) ) ).

tff(addAssignment_5318,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10592(VarCurr,B)
      <=> v10594(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10689(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v10594(VarNext,B)
            <=> v10594(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_125,axiom,
    ! [VarNext: state_type] :
      ( v10689(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10594(VarNext,B)
          <=> v10699(VarNext,B) ) ) ) ).

tff(addAssignment_5317,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10699(VarNext,B)
          <=> v10697(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10700(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10697(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_101,axiom,
    ! [VarCurr: state_type] :
      ( v10700(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10697(VarCurr,B)
          <=> v10616(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_918,axiom,
    ! [VarCurr: state_type] :
      ( v10700(VarCurr)
    <=> ( v10701(VarCurr)
        & v10702(VarCurr) ) ) ).

tff(writeUnaryOperator_680,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10702(VarCurr)
    <=> v10606(VarCurr) ) ).

tff(writeUnaryOperator_679,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10701(VarCurr)
    <=> v10596(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_917,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10689(VarNext)
      <=> v10690(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10690(VarNext)
      <=> ( v10691(VarNext)
          & v10620(VarNext) ) ) ) ).

tff(writeUnaryOperator_678,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10691(VarNext)
      <=> v10693(VarNext) ) ) ).

tff(addAssignment_5316,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10693(VarNext)
      <=> v10620(VarCurr) ) ) ).

tff(addAssignment_5315,axiom,
    ! [VarCurr: state_type] :
      ( v10620(VarCurr)
    <=> v10622(VarCurr) ) ).

tff(addAssignment_5314,axiom,
    ! [VarCurr: state_type] :
      ( v10622(VarCurr)
    <=> v10624(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_915,axiom,
    ! [VarCurr: state_type] :
      ( v10624(VarCurr)
    <=> ( v10686(VarCurr)
        | v10682(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_914,axiom,
    ! [VarCurr: state_type] :
      ( v10686(VarCurr)
    <=> ( v10626(VarCurr)
        & v10630(VarCurr) ) ) ).

tff(addAssignment_5313,axiom,
    ! [VarCurr: state_type] :
      ( v10682(VarCurr)
    <=> v10684(VarCurr) ) ).

tff(addAssignment_5312,axiom,
    ! [VarCurr: state_type] :
      ( v10684(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10666(VarNext)
       => ( v10630(VarNext)
        <=> v10630(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_124,axiom,
    ! [VarNext: state_type] :
      ( v10666(VarNext)
     => ( v10630(VarNext)
      <=> v10676(VarNext) ) ) ).

tff(addAssignment_5311,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10676(VarNext)
      <=> v10674(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_913,axiom,
    ! [VarCurr: state_type] :
      ( v10674(VarCurr)
    <=> ( v10677(VarCurr)
        & v10678(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_912,axiom,
    ! [VarCurr: state_type] :
      ( v10678(VarCurr)
    <=> ( v10636(VarCurr)
        | v10661(VarCurr) ) ) ).

tff(writeUnaryOperator_677,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10677(VarCurr)
    <=> v10632(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_911,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10666(VarNext)
      <=> v10667(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_910,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10667(VarNext)
      <=> ( v10669(VarNext)
          & v10671(VarNext) ) ) ) ).

tff(writeUnaryOperator_676,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10671(VarCurr)
    <=> v10626(VarCurr) ) ).

tff(addAssignment_5310,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10669(VarNext)
      <=> v10626(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_30,axiom,
    ( v10630(constB0)
  <=> $true ) ).

tff(addAssignment_5309,axiom,
    ! [VarCurr: state_type] :
      ( v10661(VarCurr)
    <=> v10663(VarCurr) ) ).

tff(addAssignment_5308,axiom,
    ! [VarCurr: state_type] :
      ( v10663(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5307,axiom,
    ! [VarCurr: state_type] :
      ( v10636(VarCurr)
    <=> v10638(VarCurr) ) ).

tff(addAssignment_5306,axiom,
    ! [VarCurr: state_type] :
      ( v10638(VarCurr)
    <=> v10640(VarCurr) ) ).

tff(addAssignment_5305,axiom,
    ! [VarCurr: state_type] :
      ( v10640(VarCurr)
    <=> v10642(VarCurr) ) ).

tff(addAssignment_5304,axiom,
    ! [VarCurr: state_type] :
      ( v10642(VarCurr)
    <=> v10644(VarCurr) ) ).

tff(writeUnaryOperator_675,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10644(VarCurr)
    <=> v10658(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_909,axiom,
    ! [VarCurr: state_type] :
      ( v10658(VarCurr)
    <=> ( v10659(VarCurr)
        | v10654(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_908,axiom,
    ! [VarCurr: state_type] :
      ( v10659(VarCurr)
    <=> ( v10646(VarCurr)
        | v10650(VarCurr) ) ) ).

tff(addAssignment_5303,axiom,
    ! [VarCurr: state_type] :
      ( v10654(VarCurr)
    <=> v10656(VarCurr) ) ).

tff(addAssignment_5302,axiom,
    ! [VarCurr: state_type] :
      ( v10656(VarCurr)
    <=> v9890(VarCurr,2) ) ).

tff(addAssignment_5301,axiom,
    ! [VarCurr: state_type] :
      ( v10650(VarCurr)
    <=> v10652(VarCurr) ) ).

tff(addAssignment_5300,axiom,
    ! [VarCurr: state_type] :
      ( v10652(VarCurr)
    <=> v10337(VarCurr,1) ) ).

tff(addAssignment_5299,axiom,
    ! [VarCurr: state_type] :
      ( v10646(VarCurr)
    <=> v10648(VarCurr) ) ).

tff(addAssignment_5298,axiom,
    ! [VarCurr: state_type] :
      ( v10648(VarCurr)
    <=> v10337(VarCurr,0) ) ).

tff(addAssignment_5297,axiom,
    ! [VarCurr: state_type] :
      ( v10632(VarCurr)
    <=> v10634(VarCurr) ) ).

tff(addAssignment_5296,axiom,
    ! [VarCurr: state_type] :
      ( v10634(VarCurr)
    <=> $false ) ).

tff(addAssignment_5295,axiom,
    ! [VarCurr: state_type] :
      ( v10626(VarCurr)
    <=> v10628(VarCurr) ) ).

tff(addAssignment_5294,axiom,
    ! [VarCurr: state_type] :
      ( v10628(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5293,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10616(VarCurr,B)
      <=> v10618(VarCurr,B) ) ) ).

tff(addAssignment_5292,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10618(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_5291,axiom,
    ! [VarCurr: state_type] :
      ( v10606(VarCurr)
    <=> v10608(VarCurr) ) ).

tff(addAssignment_5290,axiom,
    ! [VarCurr: state_type] :
      ( v10608(VarCurr)
    <=> v10610(VarCurr) ) ).

tff(addAssignment_5289,axiom,
    ! [VarCurr: state_type] :
      ( v10610(VarCurr)
    <=> v10612(VarCurr) ) ).

tff(addAssignment_5288,axiom,
    ! [VarCurr: state_type] :
      ( v10612(VarCurr)
    <=> v10614(VarCurr) ) ).

tff(addAssignment_5287,axiom,
    ! [VarCurr: state_type] :
      ( v10614(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_5286,axiom,
    ! [VarCurr: state_type] :
      ( v10596(VarCurr)
    <=> v10598(VarCurr) ) ).

tff(addAssignment_5285,axiom,
    ! [VarCurr: state_type] :
      ( v10598(VarCurr)
    <=> v10600(VarCurr) ) ).

tff(addAssignment_5284,axiom,
    ! [VarCurr: state_type] :
      ( v10600(VarCurr)
    <=> v10602(VarCurr) ) ).

tff(addAssignment_5283,axiom,
    ! [VarCurr: state_type] :
      ( v10602(VarCurr)
    <=> v10604(VarCurr) ) ).

tff(addAssignment_5282,axiom,
    ! [VarCurr: state_type] :
      ( v10604(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_5281,axiom,
    ! [VarCurr: state_type] :
      ( v10555(VarCurr)
    <=> v10557(VarCurr) ) ).

tff(addAssignment_5280,axiom,
    ! [VarCurr: state_type] :
      ( v10557(VarCurr)
    <=> v10559(VarCurr) ) ).

tff(addAssignment_5279,axiom,
    ! [VarCurr: state_type] :
      ( v10559(VarCurr)
    <=> v10561(VarCurr) ) ).

tff(addAssignment_5278,axiom,
    ! [VarCurr: state_type] :
      ( v10561(VarCurr)
    <=> v10563(VarCurr) ) ).

tff(addAssignment_5277,axiom,
    ! [VarCurr: state_type] :
      ( v10563(VarCurr)
    <=> v10565(VarCurr) ) ).

tff(addAssignment_5276,axiom,
    ! [VarCurr: state_type] :
      ( v10565(VarCurr)
    <=> v10567(VarCurr) ) ).

tff(addAssignment_5275,axiom,
    ! [VarCurr: state_type] :
      ( v10567(VarCurr)
    <=> v10569(VarCurr) ) ).

tff(writeUnaryOperator_674,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10569(VarCurr)
    <=> v10583(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_907,axiom,
    ! [VarCurr: state_type] :
      ( v10583(VarCurr)
    <=> ( v10584(VarCurr)
        | v10579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_906,axiom,
    ! [VarCurr: state_type] :
      ( v10584(VarCurr)
    <=> ( v10571(VarCurr)
        | v10575(VarCurr) ) ) ).

tff(addAssignment_5274,axiom,
    ! [VarCurr: state_type] :
      ( v10579(VarCurr)
    <=> v10581(VarCurr) ) ).

tff(addAssignment_5273,axiom,
    ! [VarCurr: state_type] :
      ( v10581(VarCurr)
    <=> v9984(VarCurr,2) ) ).

tff(addAssignment_5272,axiom,
    ! [VarCurr: state_type] :
      ( v10575(VarCurr)
    <=> v10577(VarCurr) ) ).

tff(addAssignment_5271,axiom,
    ! [VarCurr: state_type] :
      ( v10577(VarCurr)
    <=> v10084(VarCurr,1) ) ).

tff(addAssignment_5270,axiom,
    ! [VarCurr: state_type] :
      ( v10084(VarCurr,1)
    <=> v10086(VarCurr,1) ) ).

tff(addAssignment_5269,axiom,
    ! [VarCurr: state_type] :
      ( v10086(VarCurr,1)
    <=> v10088(VarCurr,1) ) ).

tff(addAssignment_5268,axiom,
    ! [VarCurr: state_type] :
      ( v10088(VarCurr,1)
    <=> v10093(VarCurr,1) ) ).

tff(addAssignment_5267,axiom,
    ! [VarCurr: state_type] :
      ( v10090(VarCurr,1)
    <=> v10092(VarCurr,1) ) ).

tff(addAssignment_5266,axiom,
    ! [VarCurr: state_type] :
      ( v10092(VarCurr,1)
    <=> v9984(VarCurr,1) ) ).

tff(addAssignment_5265,axiom,
    ! [VarCurr: state_type] :
      ( v10571(VarCurr)
    <=> v10573(VarCurr) ) ).

tff(addAssignment_5264,axiom,
    ! [VarCurr: state_type] :
      ( v10573(VarCurr)
    <=> v9984(VarCurr,0) ) ).

tff(addAssignment_5263,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10435(VarCurr,B)
      <=> v10437(VarCurr,B) ) ) ).

tff(addAssignment_5262,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10437(VarCurr,B)
      <=> v10439(VarCurr,B) ) ) ).

tff(addAssignment_5261,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10439(VarCurr,B)
      <=> v10441(VarCurr,B) ) ) ).

tff(addAssignment_5260,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10441(VarCurr,B)
      <=> v10443(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_123,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10538(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v10443(VarNext,B)
            <=> v10443(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_123,axiom,
    ! [VarNext: state_type] :
      ( v10538(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10443(VarNext,B)
          <=> v10548(VarNext,B) ) ) ) ).

tff(addAssignment_5259,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10548(VarNext,B)
          <=> v10546(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10546(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_100,axiom,
    ! [VarCurr: state_type] :
      ( v10549(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10546(VarCurr,B)
          <=> v10465(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_905,axiom,
    ! [VarCurr: state_type] :
      ( v10549(VarCurr)
    <=> ( v10550(VarCurr)
        & v10551(VarCurr) ) ) ).

tff(writeUnaryOperator_673,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10551(VarCurr)
    <=> v10455(VarCurr) ) ).

tff(writeUnaryOperator_672,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10550(VarCurr)
    <=> v10445(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_904,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10538(VarNext)
      <=> v10539(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_903,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10539(VarNext)
      <=> ( v10540(VarNext)
          & v10469(VarNext) ) ) ) ).

tff(writeUnaryOperator_671,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10540(VarNext)
      <=> v10542(VarNext) ) ) ).

tff(addAssignment_5258,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10542(VarNext)
      <=> v10469(VarCurr) ) ) ).

tff(addAssignment_5257,axiom,
    ! [VarCurr: state_type] :
      ( v10469(VarCurr)
    <=> v10471(VarCurr) ) ).

tff(addAssignment_5256,axiom,
    ! [VarCurr: state_type] :
      ( v10471(VarCurr)
    <=> v10473(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_902,axiom,
    ! [VarCurr: state_type] :
      ( v10473(VarCurr)
    <=> ( v10535(VarCurr)
        | v10531(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_901,axiom,
    ! [VarCurr: state_type] :
      ( v10535(VarCurr)
    <=> ( v10475(VarCurr)
        & v10479(VarCurr) ) ) ).

tff(addAssignment_5255,axiom,
    ! [VarCurr: state_type] :
      ( v10531(VarCurr)
    <=> v10533(VarCurr) ) ).

tff(addAssignment_5254,axiom,
    ! [VarCurr: state_type] :
      ( v10533(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10515(VarNext)
       => ( v10479(VarNext)
        <=> v10479(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_122,axiom,
    ! [VarNext: state_type] :
      ( v10515(VarNext)
     => ( v10479(VarNext)
      <=> v10525(VarNext) ) ) ).

tff(addAssignment_5253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10525(VarNext)
      <=> v10523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_900,axiom,
    ! [VarCurr: state_type] :
      ( v10523(VarCurr)
    <=> ( v10526(VarCurr)
        & v10527(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_899,axiom,
    ! [VarCurr: state_type] :
      ( v10527(VarCurr)
    <=> ( v10485(VarCurr)
        | v10510(VarCurr) ) ) ).

tff(writeUnaryOperator_670,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10526(VarCurr)
    <=> v10481(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10515(VarNext)
      <=> v10516(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_897,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10516(VarNext)
      <=> ( v10518(VarNext)
          & v10520(VarNext) ) ) ) ).

tff(writeUnaryOperator_669,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10520(VarCurr)
    <=> v10475(VarCurr) ) ).

tff(addAssignment_5252,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10518(VarNext)
      <=> v10475(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_29,axiom,
    ( v10479(constB0)
  <=> $true ) ).

tff(addAssignment_5251,axiom,
    ! [VarCurr: state_type] :
      ( v10510(VarCurr)
    <=> v10512(VarCurr) ) ).

tff(addAssignment_5250,axiom,
    ! [VarCurr: state_type] :
      ( v10512(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5249,axiom,
    ! [VarCurr: state_type] :
      ( v10485(VarCurr)
    <=> v10487(VarCurr) ) ).

tff(addAssignment_5248,axiom,
    ! [VarCurr: state_type] :
      ( v10487(VarCurr)
    <=> v10489(VarCurr) ) ).

tff(addAssignment_5247,axiom,
    ! [VarCurr: state_type] :
      ( v10489(VarCurr)
    <=> v10491(VarCurr) ) ).

tff(addAssignment_5246,axiom,
    ! [VarCurr: state_type] :
      ( v10491(VarCurr)
    <=> v10493(VarCurr) ) ).

tff(writeUnaryOperator_668,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10493(VarCurr)
    <=> v10507(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_896,axiom,
    ! [VarCurr: state_type] :
      ( v10507(VarCurr)
    <=> ( v10508(VarCurr)
        | v10503(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_895,axiom,
    ! [VarCurr: state_type] :
      ( v10508(VarCurr)
    <=> ( v10495(VarCurr)
        | v10499(VarCurr) ) ) ).

tff(addAssignment_5245,axiom,
    ! [VarCurr: state_type] :
      ( v10503(VarCurr)
    <=> v10505(VarCurr) ) ).

tff(addAssignment_5244,axiom,
    ! [VarCurr: state_type] :
      ( v10505(VarCurr)
    <=> v9890(VarCurr,2) ) ).

tff(addAssignment_5243,axiom,
    ! [VarCurr: state_type] :
      ( v10499(VarCurr)
    <=> v10501(VarCurr) ) ).

tff(addAssignment_5242,axiom,
    ! [VarCurr: state_type] :
      ( v10501(VarCurr)
    <=> v10337(VarCurr,1) ) ).

tff(addAssignment_5241,axiom,
    ! [VarCurr: state_type] :
      ( v10337(VarCurr,1)
    <=> v10339(VarCurr,1) ) ).

tff(addAssignment_5240,axiom,
    ! [VarCurr: state_type] :
      ( v10339(VarCurr,1)
    <=> v10341(VarCurr,1) ) ).

tff(addAssignment_5239,axiom,
    ! [VarCurr: state_type] :
      ( v10341(VarCurr,1)
    <=> v10346(VarCurr,1) ) ).

tff(addAssignment_5238,axiom,
    ! [VarCurr: state_type] :
      ( v10343(VarCurr,1)
    <=> v10345(VarCurr,1) ) ).

tff(addAssignment_5237,axiom,
    ! [VarCurr: state_type] :
      ( v10345(VarCurr,1)
    <=> v9890(VarCurr,1) ) ).

tff(addAssignment_5236,axiom,
    ! [VarCurr: state_type] :
      ( v10495(VarCurr)
    <=> v10497(VarCurr) ) ).

tff(addAssignment_5235,axiom,
    ! [VarCurr: state_type] :
      ( v10497(VarCurr)
    <=> v9890(VarCurr,0) ) ).

tff(addAssignment_5234,axiom,
    ! [VarCurr: state_type] :
      ( v10481(VarCurr)
    <=> v10483(VarCurr) ) ).

tff(addAssignment_5233,axiom,
    ! [VarCurr: state_type] :
      ( v10483(VarCurr)
    <=> $false ) ).

tff(addAssignment_5232,axiom,
    ! [VarCurr: state_type] :
      ( v10475(VarCurr)
    <=> v10477(VarCurr) ) ).

tff(addAssignment_5231,axiom,
    ! [VarCurr: state_type] :
      ( v10477(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5230,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10465(VarCurr,B)
      <=> v10467(VarCurr,B) ) ) ).

tff(addAssignment_5229,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10467(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_5228,axiom,
    ! [VarCurr: state_type] :
      ( v10455(VarCurr)
    <=> v10457(VarCurr) ) ).

tff(addAssignment_5227,axiom,
    ! [VarCurr: state_type] :
      ( v10457(VarCurr)
    <=> v10459(VarCurr) ) ).

tff(addAssignment_5226,axiom,
    ! [VarCurr: state_type] :
      ( v10459(VarCurr)
    <=> v10461(VarCurr) ) ).

tff(addAssignment_5225,axiom,
    ! [VarCurr: state_type] :
      ( v10461(VarCurr)
    <=> v10463(VarCurr) ) ).

tff(addAssignment_5224,axiom,
    ! [VarCurr: state_type] :
      ( v10463(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_5223,axiom,
    ! [VarCurr: state_type] :
      ( v10445(VarCurr)
    <=> v10447(VarCurr) ) ).

tff(addAssignment_5222,axiom,
    ! [VarCurr: state_type] :
      ( v10447(VarCurr)
    <=> v10449(VarCurr) ) ).

tff(addAssignment_5221,axiom,
    ! [VarCurr: state_type] :
      ( v10449(VarCurr)
    <=> v10451(VarCurr) ) ).

tff(addAssignment_5220,axiom,
    ! [VarCurr: state_type] :
      ( v10451(VarCurr)
    <=> v10453(VarCurr) ) ).

tff(addAssignment_5219,axiom,
    ! [VarCurr: state_type] :
      ( v10453(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_5218,axiom,
    ! [VarCurr: state_type] :
      ( v10404(VarCurr)
    <=> v10406(VarCurr) ) ).

tff(addAssignment_5217,axiom,
    ! [VarCurr: state_type] :
      ( v10406(VarCurr)
    <=> v10408(VarCurr) ) ).

tff(addAssignment_5216,axiom,
    ! [VarCurr: state_type] :
      ( v10408(VarCurr)
    <=> v10410(VarCurr) ) ).

tff(addAssignment_5215,axiom,
    ! [VarCurr: state_type] :
      ( v10410(VarCurr)
    <=> v10412(VarCurr) ) ).

tff(addAssignment_5214,axiom,
    ! [VarCurr: state_type] :
      ( v10412(VarCurr)
    <=> v10414(VarCurr) ) ).

tff(addAssignment_5213,axiom,
    ! [VarCurr: state_type] :
      ( v10414(VarCurr)
    <=> v10416(VarCurr) ) ).

tff(addAssignment_5212,axiom,
    ! [VarCurr: state_type] :
      ( v10416(VarCurr)
    <=> v10418(VarCurr) ) ).

tff(writeUnaryOperator_667,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10418(VarCurr)
    <=> v10432(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_894,axiom,
    ! [VarCurr: state_type] :
      ( v10432(VarCurr)
    <=> ( v10433(VarCurr)
        | v10428(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_893,axiom,
    ! [VarCurr: state_type] :
      ( v10433(VarCurr)
    <=> ( v10420(VarCurr)
        | v10424(VarCurr) ) ) ).

tff(addAssignment_5211,axiom,
    ! [VarCurr: state_type] :
      ( v10428(VarCurr)
    <=> v10430(VarCurr) ) ).

tff(addAssignment_5210,axiom,
    ! [VarCurr: state_type] :
      ( v10430(VarCurr)
    <=> v9984(VarCurr,2) ) ).

tff(addAssignment_5209,axiom,
    ! [VarCurr: state_type] :
      ( v10424(VarCurr)
    <=> v10426(VarCurr) ) ).

tff(addAssignment_5208,axiom,
    ! [VarCurr: state_type] :
      ( v10426(VarCurr)
    <=> v9984(VarCurr,1) ) ).

tff(addAssignment_5207,axiom,
    ! [VarCurr: state_type] :
      ( v10420(VarCurr)
    <=> v10422(VarCurr) ) ).

tff(addAssignment_5206,axiom,
    ! [VarCurr: state_type] :
      ( v10422(VarCurr)
    <=> v10084(VarCurr,0) ) ).

tff(addAssignment_5205,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10273(VarCurr,B)
      <=> v10275(VarCurr,B) ) ) ).

tff(addAssignment_5204,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10275(VarCurr,B)
      <=> v10277(VarCurr,B) ) ) ).

tff(addAssignment_5203,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10277(VarCurr,B)
      <=> v10279(VarCurr,B) ) ) ).

tff(addAssignment_5202,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10279(VarCurr,B)
      <=> v10281(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_121,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10387(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v10281(VarNext,B)
            <=> v10281(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_121,axiom,
    ! [VarNext: state_type] :
      ( v10387(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10281(VarNext,B)
          <=> v10397(VarNext,B) ) ) ) ).

tff(addAssignment_5201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10397(VarNext,B)
          <=> v10395(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_99,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10398(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10395(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_99,axiom,
    ! [VarCurr: state_type] :
      ( v10398(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v10395(VarCurr,B)
          <=> v10303(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_892,axiom,
    ! [VarCurr: state_type] :
      ( v10398(VarCurr)
    <=> ( v10399(VarCurr)
        & v10400(VarCurr) ) ) ).

tff(writeUnaryOperator_666,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10400(VarCurr)
    <=> v10293(VarCurr) ) ).

tff(writeUnaryOperator_665,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10399(VarCurr)
    <=> v10283(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10387(VarNext)
      <=> v10388(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_890,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10388(VarNext)
      <=> ( v10389(VarNext)
          & v10307(VarNext) ) ) ) ).

tff(writeUnaryOperator_664,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10389(VarNext)
      <=> v10391(VarNext) ) ) ).

tff(addAssignment_5200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10391(VarNext)
      <=> v10307(VarCurr) ) ) ).

tff(addAssignment_5199,axiom,
    ! [VarCurr: state_type] :
      ( v10307(VarCurr)
    <=> v10309(VarCurr) ) ).

tff(addAssignment_5198,axiom,
    ! [VarCurr: state_type] :
      ( v10309(VarCurr)
    <=> v10311(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_889,axiom,
    ! [VarCurr: state_type] :
      ( v10311(VarCurr)
    <=> ( v10384(VarCurr)
        | v10380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_888,axiom,
    ! [VarCurr: state_type] :
      ( v10384(VarCurr)
    <=> ( v10313(VarCurr)
        & v10317(VarCurr) ) ) ).

tff(addAssignment_5197,axiom,
    ! [VarCurr: state_type] :
      ( v10380(VarCurr)
    <=> v10382(VarCurr) ) ).

tff(addAssignment_5196,axiom,
    ! [VarCurr: state_type] :
      ( v10382(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10364(VarNext)
       => ( v10317(VarNext)
        <=> v10317(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_120,axiom,
    ! [VarNext: state_type] :
      ( v10364(VarNext)
     => ( v10317(VarNext)
      <=> v10374(VarNext) ) ) ).

tff(addAssignment_5195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10374(VarNext)
      <=> v10372(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_887,axiom,
    ! [VarCurr: state_type] :
      ( v10372(VarCurr)
    <=> ( v10375(VarCurr)
        & v10376(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_886,axiom,
    ! [VarCurr: state_type] :
      ( v10376(VarCurr)
    <=> ( v10323(VarCurr)
        | v10359(VarCurr) ) ) ).

tff(writeUnaryOperator_663,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10375(VarCurr)
    <=> v10319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_885,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10364(VarNext)
      <=> v10365(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_884,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10365(VarNext)
      <=> ( v10367(VarNext)
          & v10369(VarNext) ) ) ) ).

tff(writeUnaryOperator_662,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10369(VarCurr)
    <=> v10313(VarCurr) ) ).

tff(addAssignment_5194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10367(VarNext)
      <=> v10313(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_28,axiom,
    ( v10317(constB0)
  <=> $true ) ).

tff(addAssignment_5193,axiom,
    ! [VarCurr: state_type] :
      ( v10359(VarCurr)
    <=> v10361(VarCurr) ) ).

tff(addAssignment_5192,axiom,
    ! [VarCurr: state_type] :
      ( v10361(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5191,axiom,
    ! [VarCurr: state_type] :
      ( v10323(VarCurr)
    <=> v10325(VarCurr) ) ).

tff(addAssignment_5190,axiom,
    ! [VarCurr: state_type] :
      ( v10325(VarCurr)
    <=> v10327(VarCurr) ) ).

tff(addAssignment_5189,axiom,
    ! [VarCurr: state_type] :
      ( v10327(VarCurr)
    <=> v10329(VarCurr) ) ).

tff(addAssignment_5188,axiom,
    ! [VarCurr: state_type] :
      ( v10329(VarCurr)
    <=> v10331(VarCurr) ) ).

tff(writeUnaryOperator_661,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10331(VarCurr)
    <=> v10356(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_883,axiom,
    ! [VarCurr: state_type] :
      ( v10356(VarCurr)
    <=> ( v10357(VarCurr)
        | v10352(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_882,axiom,
    ! [VarCurr: state_type] :
      ( v10357(VarCurr)
    <=> ( v10333(VarCurr)
        | v10348(VarCurr) ) ) ).

tff(addAssignment_5187,axiom,
    ! [VarCurr: state_type] :
      ( v10352(VarCurr)
    <=> v10354(VarCurr) ) ).

tff(addAssignment_5186,axiom,
    ! [VarCurr: state_type] :
      ( v10354(VarCurr)
    <=> v9890(VarCurr,2) ) ).

tff(addAssignment_5185,axiom,
    ! [VarCurr: state_type] :
      ( v10348(VarCurr)
    <=> v10350(VarCurr) ) ).

tff(addAssignment_5184,axiom,
    ! [VarCurr: state_type] :
      ( v10350(VarCurr)
    <=> v9890(VarCurr,1) ) ).

tff(addAssignment_5183,axiom,
    ! [VarCurr: state_type] :
      ( v10333(VarCurr)
    <=> v10335(VarCurr) ) ).

tff(addAssignment_5182,axiom,
    ! [VarCurr: state_type] :
      ( v10335(VarCurr)
    <=> v10337(VarCurr,0) ) ).

tff(addAssignment_5181,axiom,
    ! [VarCurr: state_type] :
      ( v10337(VarCurr,0)
    <=> v10339(VarCurr,0) ) ).

tff(addAssignment_5180,axiom,
    ! [VarCurr: state_type] :
      ( v10339(VarCurr,0)
    <=> v10341(VarCurr,0) ) ).

tff(addAssignment_5179,axiom,
    ! [VarCurr: state_type] :
      ( v10341(VarCurr,0)
    <=> v10346(VarCurr,0) ) ).

tff(writeUnaryOperator_660,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v10346(VarCurr,B)
      <=> ~ v10343(VarCurr,B) ) ) ).

tff(addAssignment_5178,axiom,
    ! [VarCurr: state_type] :
      ( v10343(VarCurr,0)
    <=> v10345(VarCurr,0) ) ).

tff(addAssignment_5177,axiom,
    ! [VarCurr: state_type] :
      ( v10345(VarCurr,0)
    <=> v9890(VarCurr,0) ) ).

tff(addAssignment_5176,axiom,
    ! [VarCurr: state_type] :
      ( v10319(VarCurr)
    <=> v10321(VarCurr) ) ).

tff(addAssignment_5175,axiom,
    ! [VarCurr: state_type] :
      ( v10321(VarCurr)
    <=> $false ) ).

tff(addAssignment_5174,axiom,
    ! [VarCurr: state_type] :
      ( v10313(VarCurr)
    <=> v10315(VarCurr) ) ).

tff(addAssignment_5173,axiom,
    ! [VarCurr: state_type] :
      ( v10315(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10303(VarCurr,B)
      <=> v10305(VarCurr,B) ) ) ).

tff(addAssignment_5171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v10305(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_5170,axiom,
    ! [VarCurr: state_type] :
      ( v10293(VarCurr)
    <=> v10295(VarCurr) ) ).

tff(addAssignment_5169,axiom,
    ! [VarCurr: state_type] :
      ( v10295(VarCurr)
    <=> v10297(VarCurr) ) ).

tff(addAssignment_5168,axiom,
    ! [VarCurr: state_type] :
      ( v10297(VarCurr)
    <=> v10299(VarCurr) ) ).

tff(addAssignment_5167,axiom,
    ! [VarCurr: state_type] :
      ( v10299(VarCurr)
    <=> v10301(VarCurr) ) ).

tff(addAssignment_5166,axiom,
    ! [VarCurr: state_type] :
      ( v10301(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_5165,axiom,
    ! [VarCurr: state_type] :
      ( v10283(VarCurr)
    <=> v10285(VarCurr) ) ).

tff(addAssignment_5164,axiom,
    ! [VarCurr: state_type] :
      ( v10285(VarCurr)
    <=> v10287(VarCurr) ) ).

tff(addAssignment_5163,axiom,
    ! [VarCurr: state_type] :
      ( v10287(VarCurr)
    <=> v10289(VarCurr) ) ).

tff(addAssignment_5162,axiom,
    ! [VarCurr: state_type] :
      ( v10289(VarCurr)
    <=> v10291(VarCurr) ) ).

tff(addAssignment_5161,axiom,
    ! [VarCurr: state_type] :
      ( v10291(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_5160,axiom,
    ! [VarCurr: state_type] :
      ( v9964(VarCurr)
    <=> v9966(VarCurr) ) ).

tff(addAssignment_5159,axiom,
    ! [VarCurr: state_type] :
      ( v9966(VarCurr)
    <=> v9968(VarCurr) ) ).

tff(addAssignment_5158,axiom,
    ! [VarCurr: state_type] :
      ( v9968(VarCurr)
    <=> v9970(VarCurr) ) ).

tff(addAssignment_5157,axiom,
    ! [VarCurr: state_type] :
      ( v9970(VarCurr)
    <=> v9972(VarCurr) ) ).

tff(addAssignment_5156,axiom,
    ! [VarCurr: state_type] :
      ( v9972(VarCurr)
    <=> v9974(VarCurr) ) ).

tff(addAssignment_5155,axiom,
    ! [VarCurr: state_type] :
      ( v9974(VarCurr)
    <=> v9976(VarCurr) ) ).

tff(addAssignment_5154,axiom,
    ! [VarCurr: state_type] :
      ( v9976(VarCurr)
    <=> v9978(VarCurr) ) ).

tff(writeUnaryOperator_659,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9978(VarCurr)
    <=> v10270(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_881,axiom,
    ! [VarCurr: state_type] :
      ( v10270(VarCurr)
    <=> ( v10271(VarCurr)
        | v10266(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_880,axiom,
    ! [VarCurr: state_type] :
      ( v10271(VarCurr)
    <=> ( v9980(VarCurr)
        | v10262(VarCurr) ) ) ).

tff(addAssignment_5153,axiom,
    ! [VarCurr: state_type] :
      ( v10266(VarCurr)
    <=> v10268(VarCurr) ) ).

tff(addAssignment_5152,axiom,
    ! [VarCurr: state_type] :
      ( v10268(VarCurr)
    <=> v9984(VarCurr,2) ) ).

tff(addAssignment_5151,axiom,
    ! [VarCurr: state_type] :
      ( v10262(VarCurr)
    <=> v10264(VarCurr) ) ).

tff(addAssignment_5150,axiom,
    ! [VarCurr: state_type] :
      ( v10264(VarCurr)
    <=> v9984(VarCurr,1) ) ).

tff(addAssignment_5149,axiom,
    ! [VarCurr: state_type] :
      ( v9980(VarCurr)
    <=> v9982(VarCurr) ) ).

tff(addAssignment_5148,axiom,
    ! [VarCurr: state_type] :
      ( v9982(VarCurr)
    <=> v9984(VarCurr,0) ) ).

tff(addAssignment_5147,axiom,
    ! [VarCurr: state_type] :
      ( v9984(VarCurr,0)
    <=> v9892(VarCurr,3) ) ).

tff(addAssignment_5146,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,3)
    <=> v9894(VarCurr,3) ) ).

tff(addAssignment_5145,axiom,
    ! [VarNext: state_type] :
      ( v9894(VarNext,3)
    <=> v10254(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_119,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10255(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v10254(VarNext,B)
            <=> v9894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_119,axiom,
    ! [VarNext: state_type] :
      ( v10255(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10254(VarNext,B)
          <=> v10226(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_879,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10255(VarNext)
      <=> v10256(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_878,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10256(VarNext)
      <=> ( v10258(VarNext)
          & v10168(VarNext) ) ) ) ).

tff(writeUnaryOperator_658,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10258(VarNext)
      <=> v10220(VarNext) ) ) ).

tff(addAssignment_5144,axiom,
    ! [VarCurr: state_type] :
      ( v10010(VarCurr,3)
    <=> v10012(VarCurr,3) ) ).

tff(addAssignment_5143,axiom,
    ! [VarCurr: state_type] :
      ( v10012(VarCurr,3)
    <=> v10165(VarCurr,3) ) ).

tff(addAssignment_5142,axiom,
    ! [VarCurr: state_type] :
      ( v10014(VarCurr,0)
    <=> v10016(VarCurr,0) ) ).

tff(addAssignment_5141,axiom,
    ! [VarCurr: state_type] :
      ( v10016(VarCurr,0)
    <=> v10018(VarCurr,0) ) ).

tff(addAssignment_5140,axiom,
    ! [VarCurr: state_type] :
      ( v10018(VarCurr,0)
    <=> v10164(VarCurr,0) ) ).

tff(addAssignment_5139,axiom,
    ! [VarCurr: state_type] :
      ( v10101(VarCurr,0)
    <=> v10103(VarCurr,0) ) ).

tff(addAssignment_5138,axiom,
    ! [VarCurr: state_type] :
      ( v10103(VarCurr,0)
    <=> v10105(VarCurr,0) ) ).

tff(addAssignment_5137,axiom,
    ! [VarCurr: state_type] :
      ( v10105(VarCurr,0)
    <=> v10107(VarCurr,0) ) ).

tff(addAssignment_5136,axiom,
    ! [VarCurr: state_type] :
      ( v10107(VarCurr,0)
    <=> v10109(VarCurr,0) ) ).

tff(addAssignment_5135,axiom,
    ! [VarCurr: state_type] :
      ( v10109(VarCurr,0)
    <=> v10119(VarCurr,0) ) ).

tff(addAssignment_5134,axiom,
    ! [VarCurr: state_type] :
      ( v10020(VarCurr,0)
    <=> v10022(VarCurr,0) ) ).

tff(addAssignment_5133,axiom,
    ! [VarCurr: state_type] :
      ( v10022(VarCurr,0)
    <=> v10098(VarCurr,0) ) ).

tff(addAssignment_5132,axiom,
    ! [VarCurr: state_type] :
      ( v10024(VarCurr)
    <=> v9163(VarCurr,2) ) ).

tff(addAssignment_5131,axiom,
    ! [VarCurr: state_type] :
      ( v9163(VarCurr,2)
    <=> v9165(VarCurr,2) ) ).

tff(addAssignment_5130,axiom,
    ! [VarCurr: state_type] :
      ( v9165(VarCurr,2)
    <=> v9188(VarCurr,2) ) ).

tff(addAssignment_5129,axiom,
    ! [VarCurr: state_type] :
      ( v9167(VarCurr,2)
    <=> v9169(VarCurr,2) ) ).

tff(addAssignment_5128,axiom,
    ! [VarCurr: state_type] :
      ( v9169(VarCurr,2)
    <=> v9185(VarCurr,2) ) ).

tff(addAssignment_5127,axiom,
    ! [VarCurr: state_type] :
      ( v9186(VarCurr)
    <=> v10027(VarCurr,1) ) ).

tff(addAssignment_5126,axiom,
    ! [VarCurr: state_type] :
      ( v10027(VarCurr,1)
    <=> v10029(VarCurr,1) ) ).

tff(addAssignment_5125,axiom,
    ! [VarCurr: state_type] :
      ( v10029(VarCurr,1)
    <=> v10252(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v10252(VarCurr,B)
      <=> ( v10031(VarCurr,B)
          | v10037(VarCurr,B) ) ) ) ).

tff(addAssignment_5124,axiom,
    ! [VarCurr: state_type] :
      ( v10037(VarCurr,1)
    <=> v10039(VarCurr,1) ) ).

tff(addAssignment_5123,axiom,
    ! [VarCurr: state_type] :
      ( v10039(VarCurr,1)
    <=> v10250(VarCurr,1) ) ).

tff(addAssignment_5122,axiom,
    ! [VarCurr: state_type] :
      ( v10250(VarCurr,0)
    <=> v10251(VarCurr) ) ).

tff(addAssignment_5121,axiom,
    ! [VarCurr: state_type] :
      ( v10250(VarCurr,1)
    <=> v10041(VarCurr) ) ).

tff(addAssignment_5120,axiom,
    ! [VarCurr: state_type] :
      ( v10041(VarCurr)
    <=> v10043(VarCurr,1) ) ).

tff(addAssignment_5119,axiom,
    ! [VarCurr: state_type] :
      ( v10043(VarCurr,1)
    <=> v10045(VarCurr,1) ) ).

tff(addAssignment_5118,axiom,
    ! [VarCurr: state_type] :
      ( v10045(VarCurr,1)
    <=> v10249(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_181,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v10249(VarCurr,B)
      <=> ( v10047(VarCurr,B)
          & v10070(VarCurr,B) ) ) ) ).

tff(addAssignment_5117,axiom,
    ! [VarCurr: state_type] :
      ( v10070(VarCurr,1)
    <=> v10072(VarCurr,1) ) ).

tff(addAssignment_5116,axiom,
    ! [VarCurr: state_type] :
      ( v10072(VarCurr,1)
    <=> v10247(VarCurr,1) ) ).

tff(addAssignment_5115,axiom,
    ! [VarCurr: state_type] :
      ( v10247(VarCurr,0)
    <=> v10248(VarCurr) ) ).

tff(addAssignment_5114,axiom,
    ! [VarCurr: state_type] :
      ( v10247(VarCurr,1)
    <=> v10074(VarCurr) ) ).

tff(addAssignment_5113,axiom,
    ! [VarCurr: state_type] :
      ( v10074(VarCurr)
    <=> v10076(VarCurr) ) ).

tff(addAssignment_5112,axiom,
    ! [VarCurr: state_type] :
      ( v10076(VarCurr)
    <=> v10078(VarCurr) ) ).

tff(writeUnaryOperator_657,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10078(VarCurr)
    <=> v10245(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_877,axiom,
    ! [VarCurr: state_type] :
      ( v10245(VarCurr)
    <=> ( v10246(VarCurr)
        | v10233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_876,axiom,
    ! [VarCurr: state_type] :
      ( v10246(VarCurr)
    <=> ( v10080(VarCurr)
        | v10095(VarCurr) ) ) ).

tff(addAssignment_5111,axiom,
    ! [VarCurr: state_type] :
      ( v10233(VarCurr)
    <=> v10235(VarCurr) ) ).

tff(addAssignment_5110,axiom,
    ! [VarCurr: state_type] :
      ( v10235(VarCurr)
    <=> v10084(VarCurr,2) ) ).

tff(addAssignment_5109,axiom,
    ! [VarCurr: state_type] :
      ( v10084(VarCurr,2)
    <=> v10086(VarCurr,2) ) ).

tff(addAssignment_5108,axiom,
    ! [VarCurr: state_type] :
      ( v10086(VarCurr,2)
    <=> v10088(VarCurr,2) ) ).

tff(addAssignment_5107,axiom,
    ! [VarCurr: state_type] :
      ( v10088(VarCurr,2)
    <=> v10093(VarCurr,2) ) ).

tff(addAssignment_5106,axiom,
    ! [VarCurr: state_type] :
      ( v10090(VarCurr,2)
    <=> v10092(VarCurr,2) ) ).

tff(addAssignment_5105,axiom,
    ! [VarCurr: state_type] :
      ( v10092(VarCurr,2)
    <=> v9984(VarCurr,2) ) ).

tff(addAssignment_5104,axiom,
    ! [VarCurr: state_type] :
      ( v9984(VarCurr,2)
    <=> v9892(VarCurr,5) ) ).

tff(addAssignment_5103,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,5)
    <=> v9894(VarCurr,5) ) ).

tff(addAssignment_5102,axiom,
    ! [VarNext: state_type] :
      ( v9894(VarNext,5)
    <=> v10237(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_118,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10238(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v10237(VarNext,B)
            <=> v9894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_118,axiom,
    ! [VarNext: state_type] :
      ( v10238(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10237(VarNext,B)
          <=> v10226(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_875,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10238(VarNext)
      <=> v10239(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_874,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10239(VarNext)
      <=> ( v10241(VarNext)
          & v10168(VarNext) ) ) ) ).

tff(writeUnaryOperator_656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10241(VarNext)
      <=> v10220(VarNext) ) ) ).

tff(addAssignment_5101,axiom,
    ! [VarCurr: state_type] :
      ( v10010(VarCurr,5)
    <=> v10012(VarCurr,5) ) ).

tff(addAssignment_5100,axiom,
    ! [VarCurr: state_type] :
      ( v10012(VarCurr,5)
    <=> v10165(VarCurr,5) ) ).

tff(addAssignment_5099,axiom,
    ! [VarCurr: state_type] :
      ( v10014(VarCurr,2)
    <=> v10016(VarCurr,2) ) ).

tff(addAssignment_5098,axiom,
    ! [VarCurr: state_type] :
      ( v10016(VarCurr,2)
    <=> v10018(VarCurr,2) ) ).

tff(addAssignment_5097,axiom,
    ! [VarCurr: state_type] :
      ( v10018(VarCurr,2)
    <=> v10164(VarCurr,2) ) ).

tff(addAssignment_5096,axiom,
    ! [VarCurr: state_type] :
      ( v10101(VarCurr,2)
    <=> v10103(VarCurr,2) ) ).

tff(addAssignment_5095,axiom,
    ! [VarCurr: state_type] :
      ( v10103(VarCurr,2)
    <=> v10105(VarCurr,2) ) ).

tff(addAssignment_5094,axiom,
    ! [VarCurr: state_type] :
      ( v10105(VarCurr,2)
    <=> v10107(VarCurr,2) ) ).

tff(addAssignment_5093,axiom,
    ! [VarCurr: state_type] :
      ( v10107(VarCurr,2)
    <=> v10109(VarCurr,2) ) ).

tff(addAssignment_5092,axiom,
    ! [VarCurr: state_type] :
      ( v10109(VarCurr,2)
    <=> v10119(VarCurr,2) ) ).

tff(addAssignment_5091,axiom,
    ! [VarCurr: state_type] :
      ( v10111(VarCurr,2)
    <=> v10113(VarCurr,2) ) ).

tff(addAssignment_5090,axiom,
    ! [VarCurr: state_type] :
      ( v10113(VarCurr,2)
    <=> v10114(VarCurr,2) ) ).

tff(addAssignment_5089,axiom,
    ! [VarCurr: state_type] :
      ( v10020(VarCurr,2)
    <=> v10022(VarCurr,2) ) ).

tff(addAssignment_5088,axiom,
    ! [VarCurr: state_type] :
      ( v10022(VarCurr,2)
    <=> v10098(VarCurr,2) ) ).

tff(addAssignment_5087,axiom,
    ! [VarCurr: state_type] :
      ( v10095(VarCurr)
    <=> v10097(VarCurr) ) ).

tff(addAssignment_5086,axiom,
    ! [VarCurr: state_type] :
      ( v10097(VarCurr)
    <=> v9984(VarCurr,1) ) ).

tff(addAssignment_5085,axiom,
    ! [VarCurr: state_type] :
      ( v9984(VarCurr,1)
    <=> v9892(VarCurr,4) ) ).

tff(addAssignment_5084,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,4)
    <=> v9894(VarCurr,4) ) ).

tff(addAssignment_5083,axiom,
    ! [VarNext: state_type] :
      ( v9894(VarNext,4)
    <=> v10215(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10216(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v10215(VarNext,B)
            <=> v9894(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_117,axiom,
    ! [VarNext: state_type] :
      ( v10216(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10215(VarNext,B)
          <=> v10226(VarNext,B) ) ) ) ).

tff(addAssignment_5082,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10226(VarNext,B)
          <=> v10224(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_98,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10227(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10224(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_98,axiom,
    ! [VarCurr: state_type] :
      ( v10227(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v10224(VarCurr,B)
          <=> v10010(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_873,axiom,
    ! [VarCurr: state_type] :
      ( v10227(VarCurr)
    <=> ( v10228(VarCurr)
        & v10229(VarCurr) ) ) ).

tff(writeUnaryOperator_655,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10229(VarCurr)
    <=> v10000(VarCurr) ) ).

tff(writeUnaryOperator_654,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10228(VarCurr)
    <=> v9986(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_872,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10216(VarNext)
      <=> v10217(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_871,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10217(VarNext)
      <=> ( v10218(VarNext)
          & v10168(VarNext) ) ) ) ).

tff(writeUnaryOperator_653,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10218(VarNext)
      <=> v10220(VarNext) ) ) ).

tff(addAssignment_5081,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10220(VarNext)
      <=> v10168(VarCurr) ) ) ).

tff(addAssignment_5080,axiom,
    ! [VarCurr: state_type] :
      ( v10168(VarCurr)
    <=> v10170(VarCurr) ) ).

tff(addAssignment_5079,axiom,
    ! [VarCurr: state_type] :
      ( v10170(VarCurr)
    <=> v10172(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_870,axiom,
    ! [VarCurr: state_type] :
      ( v10172(VarCurr)
    <=> ( v10213(VarCurr)
        | v10209(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_869,axiom,
    ! [VarCurr: state_type] :
      ( v10213(VarCurr)
    <=> ( v10174(VarCurr)
        & v10178(VarCurr) ) ) ).

tff(addAssignment_5078,axiom,
    ! [VarCurr: state_type] :
      ( v10209(VarCurr)
    <=> v10211(VarCurr) ) ).

tff(addAssignment_5077,axiom,
    ! [VarCurr: state_type] :
      ( v10211(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v10193(VarNext)
       => ( v10178(VarNext)
        <=> v10178(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_116,axiom,
    ! [VarNext: state_type] :
      ( v10193(VarNext)
     => ( v10178(VarNext)
      <=> v10203(VarNext) ) ) ).

tff(addAssignment_5076,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10203(VarNext)
      <=> v10201(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_868,axiom,
    ! [VarCurr: state_type] :
      ( v10201(VarCurr)
    <=> ( v10204(VarCurr)
        & v10205(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_867,axiom,
    ! [VarCurr: state_type] :
      ( v10205(VarCurr)
    <=> ( v10184(VarCurr)
        | v10188(VarCurr) ) ) ).

tff(writeUnaryOperator_652,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10204(VarCurr)
    <=> v10180(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_866,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10193(VarNext)
      <=> v10194(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_865,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10194(VarNext)
      <=> ( v10196(VarNext)
          & v10198(VarNext) ) ) ) ).

tff(writeUnaryOperator_651,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10198(VarCurr)
    <=> v10174(VarCurr) ) ).

tff(addAssignment_5075,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v10196(VarNext)
      <=> v10174(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_27,axiom,
    ( v10178(constB0)
  <=> $true ) ).

tff(addAssignment_5074,axiom,
    ! [VarCurr: state_type] :
      ( v10188(VarCurr)
    <=> v10190(VarCurr) ) ).

tff(addAssignment_5073,axiom,
    ! [VarCurr: state_type] :
      ( v10190(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_5072,axiom,
    ! [VarCurr: state_type] :
      ( v10184(VarCurr)
    <=> v10186(VarCurr) ) ).

tff(addAssignment_5071,axiom,
    ! [VarCurr: state_type] :
      ( v10186(VarCurr)
    <=> $true ) ).

tff(addAssignment_5070,axiom,
    ! [VarCurr: state_type] :
      ( v10180(VarCurr)
    <=> v10182(VarCurr) ) ).

tff(addAssignment_5069,axiom,
    ! [VarCurr: state_type] :
      ( v10182(VarCurr)
    <=> $false ) ).

tff(addAssignment_5068,axiom,
    ! [VarCurr: state_type] :
      ( v10174(VarCurr)
    <=> v10176(VarCurr) ) ).

tff(addAssignment_5067,axiom,
    ! [VarCurr: state_type] :
      ( v10176(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_5066,axiom,
    ! [VarCurr: state_type] :
      ( v10010(VarCurr,4)
    <=> v10012(VarCurr,4) ) ).

tff(addAssignment_5065,axiom,
    ! [VarCurr: state_type] :
      ( v10012(VarCurr,4)
    <=> v10165(VarCurr,4) ) ).

tff(addAssignment_5064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v10165(VarCurr,B)
      <=> v10166(VarCurr,B) ) ) ).

tff(addAssignment_5063,axiom,
    ! [VarCurr: state_type] :
      ( ( v10165(VarCurr,5)
      <=> v10014(VarCurr,2) )
      & ( v10165(VarCurr,4)
      <=> v10014(VarCurr,1) )
      & ( v10165(VarCurr,3)
      <=> v10014(VarCurr,0) ) ) ).

tff(addAssignment_5062,axiom,
    ! [VarCurr: state_type] :
      ( v10014(VarCurr,1)
    <=> v10016(VarCurr,1) ) ).

tff(addAssignment_5061,axiom,
    ! [VarCurr: state_type] :
      ( v10016(VarCurr,1)
    <=> v10018(VarCurr,1) ) ).

tff(addAssignment_5060,axiom,
    ! [VarCurr: state_type] :
      ( v10018(VarCurr,1)
    <=> v10164(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_180,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v10164(VarCurr,B)
      <=> ( v10020(VarCurr,B)
          & v10101(VarCurr,B) ) ) ) ).

tff(addAssignment_5059,axiom,
    ! [VarCurr: state_type] :
      ( v10101(VarCurr,1)
    <=> v10103(VarCurr,1) ) ).

tff(addAssignment_5058,axiom,
    ! [VarCurr: state_type] :
      ( v10103(VarCurr,1)
    <=> v10105(VarCurr,1) ) ).

tff(addAssignment_5057,axiom,
    ! [VarCurr: state_type] :
      ( v10105(VarCurr,1)
    <=> v10107(VarCurr,1) ) ).

tff(addAssignment_5056,axiom,
    ! [VarCurr: state_type] :
      ( v10107(VarCurr,1)
    <=> v10109(VarCurr,1) ) ).

tff(addAssignment_5055,axiom,
    ! [VarCurr: state_type] :
      ( v10109(VarCurr,1)
    <=> v10119(VarCurr,1) ) ).

tff(addAssignment_5054,axiom,
    ! [VarCurr: state_type] :
      ( v10119(VarCurr,0)
    <=> v10159(VarCurr) ) ).

tff(addAssignment_5053,axiom,
    ! [VarCurr: state_type] :
      ( v10119(VarCurr,1)
    <=> v10154(VarCurr) ) ).

tff(addAssignment_5052,axiom,
    ! [VarCurr: state_type] :
      ( v10119(VarCurr,2)
    <=> v10149(VarCurr) ) ).

tff(addAssignment_5051,axiom,
    ! [VarCurr: state_type] :
      ( v10119(VarCurr,3)
    <=> v10121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_864,axiom,
    ! [VarCurr: state_type] :
      ( v10159(VarCurr)
    <=> ( v10160(VarCurr)
        & v10163(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_863,axiom,
    ! [VarCurr: state_type] :
      ( v10163(VarCurr)
    <=> ( v10111(VarCurr,0)
        | v10129(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_862,axiom,
    ! [VarCurr: state_type] :
      ( v10160(VarCurr)
    <=> ( v10161(VarCurr)
        | v10162(VarCurr) ) ) ).

tff(writeUnaryOperator_650,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10162(VarCurr)
    <=> v10129(VarCurr,0) ) ).

tff(writeUnaryOperator_649,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10161(VarCurr)
    <=> v10111(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_861,axiom,
    ! [VarCurr: state_type] :
      ( v10154(VarCurr)
    <=> ( v10155(VarCurr)
        & v10158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_860,axiom,
    ! [VarCurr: state_type] :
      ( v10158(VarCurr)
    <=> ( v10128(VarCurr)
        | v10130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_859,axiom,
    ! [VarCurr: state_type] :
      ( v10155(VarCurr)
    <=> ( v10156(VarCurr)
        | v10157(VarCurr) ) ) ).

tff(writeUnaryOperator_648,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10157(VarCurr)
    <=> v10130(VarCurr) ) ).

tff(writeUnaryOperator_647,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10156(VarCurr)
    <=> v10128(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_858,axiom,
    ! [VarCurr: state_type] :
      ( v10149(VarCurr)
    <=> ( v10150(VarCurr)
        & v10153(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_857,axiom,
    ! [VarCurr: state_type] :
      ( v10153(VarCurr)
    <=> ( v10126(VarCurr)
        | v10136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_856,axiom,
    ! [VarCurr: state_type] :
      ( v10150(VarCurr)
    <=> ( v10151(VarCurr)
        | v10152(VarCurr) ) ) ).

tff(writeUnaryOperator_646,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10152(VarCurr)
    <=> v10136(VarCurr) ) ).

tff(writeUnaryOperator_645,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10151(VarCurr)
    <=> v10126(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_855,axiom,
    ! [VarCurr: state_type] :
      ( v10121(VarCurr)
    <=> ( v10122(VarCurr)
        & v10148(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_854,axiom,
    ! [VarCurr: state_type] :
      ( v10148(VarCurr)
    <=> ( v10124(VarCurr)
        | v10143(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_853,axiom,
    ! [VarCurr: state_type] :
      ( v10122(VarCurr)
    <=> ( v10123(VarCurr)
        | v10142(VarCurr) ) ) ).

tff(writeUnaryOperator_644,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10142(VarCurr)
    <=> v10143(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_852,axiom,
    ! [VarCurr: state_type] :
      ( v10143(VarCurr)
    <=> ( v10144(VarCurr)
        & v10147(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_183,axiom,
    ! [VarCurr: state_type] :
      ( v10147(VarCurr)
    <=> ( v10111(VarCurr,3)
        | v10129(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_851,axiom,
    ! [VarCurr: state_type] :
      ( v10144(VarCurr)
    <=> ( v10145(VarCurr)
        | v10146(VarCurr) ) ) ).

tff(writeUnaryOperator_643,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10146(VarCurr)
    <=> v10129(VarCurr,3) ) ).

tff(writeUnaryOperator_642,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10145(VarCurr)
    <=> v10111(VarCurr,3) ) ).

tff(writeUnaryOperator_641,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10123(VarCurr)
    <=> v10124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_850,axiom,
    ! [VarCurr: state_type] :
      ( v10124(VarCurr)
    <=> ( v10125(VarCurr)
        | v10141(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_182,axiom,
    ! [VarCurr: state_type] :
      ( v10141(VarCurr)
    <=> ( v10111(VarCurr,2)
        & v10129(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_849,axiom,
    ! [VarCurr: state_type] :
      ( v10125(VarCurr)
    <=> ( v10126(VarCurr)
        & v10136(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_848,axiom,
    ! [VarCurr: state_type] :
      ( v10136(VarCurr)
    <=> ( v10137(VarCurr)
        & v10140(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_181,axiom,
    ! [VarCurr: state_type] :
      ( v10140(VarCurr)
    <=> ( v10111(VarCurr,2)
        | v10129(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_847,axiom,
    ! [VarCurr: state_type] :
      ( v10137(VarCurr)
    <=> ( v10138(VarCurr)
        | v10139(VarCurr) ) ) ).

tff(writeUnaryOperator_640,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10139(VarCurr)
    <=> v10129(VarCurr,2) ) ).

tff(writeUnaryOperator_639,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10138(VarCurr)
    <=> v10111(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_846,axiom,
    ! [VarCurr: state_type] :
      ( v10126(VarCurr)
    <=> ( v10127(VarCurr)
        | v10135(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_180,axiom,
    ! [VarCurr: state_type] :
      ( v10135(VarCurr)
    <=> ( v10111(VarCurr,1)
        & v10129(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_845,axiom,
    ! [VarCurr: state_type] :
      ( v10127(VarCurr)
    <=> ( v10128(VarCurr)
        & v10130(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_844,axiom,
    ! [VarCurr: state_type] :
      ( v10130(VarCurr)
    <=> ( v10131(VarCurr)
        & v10134(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_179,axiom,
    ! [VarCurr: state_type] :
      ( v10134(VarCurr)
    <=> ( v10111(VarCurr,1)
        | v10129(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_843,axiom,
    ! [VarCurr: state_type] :
      ( v10131(VarCurr)
    <=> ( v10132(VarCurr)
        | v10133(VarCurr) ) ) ).

tff(writeUnaryOperator_638,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10133(VarCurr)
    <=> v10129(VarCurr,1) ) ).

tff(writeUnaryOperator_637,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10132(VarCurr)
    <=> v10111(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_842,axiom,
    ! [VarCurr: state_type] :
      ( v10128(VarCurr)
    <=> ( v10111(VarCurr,0)
        & v10129(VarCurr,0) ) ) ).

tff(addAssignment_5050,axiom,
    ! [VarCurr: state_type] :
      ( v10129(VarCurr,0)
    <=> v10116(VarCurr) ) ).

tff(addAssignment_5049,axiom,
    ! [VarCurr: state_type] :
      ( ( v10129(VarCurr,3)
      <=> $false )
      & ( v10129(VarCurr,2)
      <=> $false )
      & ( v10129(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_5048,axiom,
    ! [VarCurr: state_type] :
      ( v10116(VarCurr)
    <=> v10118(VarCurr) ) ).

tff(addAssignment_5047,axiom,
    ! [VarCurr: state_type] :
      ( v10118(VarCurr)
    <=> v10051(VarCurr) ) ).

tff(addAssignment_5046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v10111(VarCurr,B)
      <=> v10113(VarCurr,B) ) ) ).

tff(addAssignment_5045,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v10113(VarCurr,B)
      <=> v10114(VarCurr,B) ) ) ).

tff(addAssignment_5044,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v10114(VarCurr,B)
      <=> v9984(VarCurr,B) ) ) ).

tff(addAssignment_5043,axiom,
    ! [VarCurr: state_type] :
      ( v10114(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_5042,axiom,
    ! [VarCurr: state_type] :
      ( v10020(VarCurr,1)
    <=> v10022(VarCurr,1) ) ).

tff(addAssignment_5041,axiom,
    ! [VarCurr: state_type] :
      ( v10022(VarCurr,1)
    <=> v10098(VarCurr,1) ) ).

tff(addAssignment_5040,axiom,
    ! [VarCurr: state_type] :
      ( v10098(VarCurr,0)
    <=> v10099(VarCurr) ) ).

tff(addAssignment_5039,axiom,
    ! [VarCurr: state_type] :
      ( v10098(VarCurr,1)
    <=> v10099(VarCurr) ) ).

tff(addAssignment_5038,axiom,
    ! [VarCurr: state_type] :
      ( v10098(VarCurr,2)
    <=> v10099(VarCurr) ) ).

tff(addAssignment_5037,axiom,
    ! [VarCurr: state_type] :
      ( v10099(VarCurr)
    <=> v10024(VarCurr) ) ).

tff(addAssignment_5036,axiom,
    ! [VarCurr: state_type] :
      ( v10080(VarCurr)
    <=> v10082(VarCurr) ) ).

tff(addAssignment_5035,axiom,
    ! [VarCurr: state_type] :
      ( v10082(VarCurr)
    <=> v10084(VarCurr,0) ) ).

tff(addAssignment_5034,axiom,
    ! [VarCurr: state_type] :
      ( v10084(VarCurr,0)
    <=> v10086(VarCurr,0) ) ).

tff(addAssignment_5033,axiom,
    ! [VarCurr: state_type] :
      ( v10086(VarCurr,0)
    <=> v10088(VarCurr,0) ) ).

tff(addAssignment_5032,axiom,
    ! [VarCurr: state_type] :
      ( v10088(VarCurr,0)
    <=> v10093(VarCurr,0) ) ).

tff(writeUnaryOperator_636,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v10093(VarCurr,B)
      <=> ~ v10090(VarCurr,B) ) ) ).

tff(addAssignment_5031,axiom,
    ! [VarCurr: state_type] :
      ( v10090(VarCurr,0)
    <=> v10092(VarCurr,0) ) ).

tff(addAssignment_5030,axiom,
    ! [VarCurr: state_type] :
      ( v10092(VarCurr,0)
    <=> v9984(VarCurr,0) ) ).

tff(addAssignment_5029,axiom,
    ! [VarCurr: state_type] :
      ( v10047(VarCurr,1)
    <=> v10049(VarCurr,1) ) ).

tff(addAssignment_5028,axiom,
    ! [VarCurr: state_type] :
      ( v10049(VarCurr,1)
    <=> v10067(VarCurr,1) ) ).

tff(addAssignment_5027,axiom,
    ! [VarCurr: state_type] :
      ( v10067(VarCurr,0)
    <=> v10068(VarCurr) ) ).

tff(addAssignment_5026,axiom,
    ! [VarCurr: state_type] :
      ( v10067(VarCurr,1)
    <=> v10051(VarCurr) ) ).

tff(addAssignment_5025,axiom,
    ! [VarCurr: state_type] :
      ( v10051(VarCurr)
    <=> v10053(VarCurr,0) ) ).

tff(addAssignment_5024,axiom,
    ! [VarCurr: state_type] :
      ( v10053(VarCurr,0)
    <=> v10055(VarCurr,0) ) ).

tff(addAssignment_5023,axiom,
    ! [VarCurr: state_type] :
      ( v10055(VarCurr,0)
    <=> v10057(VarCurr,0) ) ).

tff(addAssignment_5022,axiom,
    ! [VarCurr: state_type] :
      ( v10057(VarCurr,0)
    <=> v10061(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_97,axiom,
    ! [VarCurr: state_type] :
      ( ~ v10059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v10061(VarCurr,B)
          <=> v10062(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_97,axiom,
    ! [VarCurr: state_type] :
      ( v10059(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v10061(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_444,axiom,
    ~ b00000000000000(13) ).

tff(bitBlastConstant_443,axiom,
    ~ b00000000000000(12) ).

tff(bitBlastConstant_442,axiom,
    ~ b00000000000000(11) ).

tff(bitBlastConstant_441,axiom,
    ~ b00000000000000(10) ).

tff(bitBlastConstant_440,axiom,
    ~ b00000000000000(9) ).

tff(bitBlastConstant_439,axiom,
    ~ b00000000000000(8) ).

tff(bitBlastConstant_438,axiom,
    ~ b00000000000000(7) ).

tff(bitBlastConstant_437,axiom,
    ~ b00000000000000(6) ).

tff(bitBlastConstant_436,axiom,
    ~ b00000000000000(5) ).

tff(bitBlastConstant_435,axiom,
    ~ b00000000000000(4) ).

tff(bitBlastConstant_434,axiom,
    ~ b00000000000000(3) ).

tff(bitBlastConstant_433,axiom,
    ~ b00000000000000(2) ).

tff(bitBlastConstant_432,axiom,
    ~ b00000000000000(1) ).

tff(bitBlastConstant_431,axiom,
    ~ b00000000000000(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_179,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v10062(VarCurr,B)
      <=> ( v10063(VarCurr,B)
          | v10064(VarCurr,B) ) ) ) ).

tff(addAssignment_5021,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,0)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5020,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,1)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5019,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,2)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5018,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,3)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5017,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,4)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5016,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,5)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5015,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,6)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5014,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,7)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5013,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,8)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5012,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,9)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5011,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,10)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5010,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,11)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5009,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,12)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5008,axiom,
    ! [VarCurr: state_type] :
      ( v10064(VarCurr,13)
    <=> v10065(VarCurr) ) ).

tff(addAssignment_5007,axiom,
    ! [VarCurr: state_type] :
      ( v10065(VarCurr)
    <=> v10066(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_841,axiom,
    ! [VarCurr: state_type] :
      ( v10066(VarCurr)
    <=> ( v8288(VarCurr)
        & v9073(VarCurr) ) ) ).

tff(writeUnaryOperator_635,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v10063(VarCurr,B)
      <=> ~ v9079(VarCurr,B) ) ) ).

tff(addAssignment_5006,axiom,
    ! [VarCurr: state_type] :
      ( v10059(VarCurr)
    <=> v1049(VarCurr) ) ).

tff(addAssignment_5005,axiom,
    ! [VarCurr: state_type] :
      ( v10031(VarCurr,1)
    <=> v10033(VarCurr,1) ) ).

tff(addAssignment_5004,axiom,
    ! [VarCurr: state_type] :
      ( v10033(VarCurr,1)
    <=> v10034(VarCurr,1) ) ).

tff(addAssignment_5003,axiom,
    ! [VarCurr: state_type] :
      ( v10034(VarCurr,0)
    <=> v10035(VarCurr) ) ).

tff(addAssignment_5002,axiom,
    ! [VarCurr: state_type] :
      ( v10034(VarCurr,1)
    <=> v10035(VarCurr) ) ).

tff(addAssignment_5001,axiom,
    ! [VarCurr: state_type] :
      ( v10035(VarCurr)
    <=> v9171(VarCurr) ) ).

tff(addAssignment_5000,axiom,
    ! [VarCurr: state_type] :
      ( v10000(VarCurr)
    <=> v10002(VarCurr) ) ).

tff(addAssignment_4999,axiom,
    ! [VarCurr: state_type] :
      ( v10002(VarCurr)
    <=> v10004(VarCurr) ) ).

tff(addAssignment_4998,axiom,
    ! [VarCurr: state_type] :
      ( v10004(VarCurr)
    <=> v10006(VarCurr) ) ).

tff(addAssignment_4997,axiom,
    ! [VarCurr: state_type] :
      ( v10006(VarCurr)
    <=> v10008(VarCurr) ) ).

tff(addAssignment_4996,axiom,
    ! [VarCurr: state_type] :
      ( v10008(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_4995,axiom,
    ! [VarCurr: state_type] :
      ( v9986(VarCurr)
    <=> v9988(VarCurr) ) ).

tff(addAssignment_4994,axiom,
    ! [VarCurr: state_type] :
      ( v9988(VarCurr)
    <=> v9990(VarCurr) ) ).

tff(addAssignment_4993,axiom,
    ! [VarCurr: state_type] :
      ( v9990(VarCurr)
    <=> v9992(VarCurr) ) ).

tff(addAssignment_4992,axiom,
    ! [VarCurr: state_type] :
      ( v9992(VarCurr)
    <=> v9994(VarCurr) ) ).

tff(addAssignment_4991,axiom,
    ! [VarCurr: state_type] :
      ( v9994(VarCurr)
    <=> v9996(VarCurr) ) ).

tff(addAssignment_4990,axiom,
    ! [VarCurr: state_type] :
      ( v9996(VarCurr)
    <=> v9998(VarCurr) ) ).

tff(addAssignment_4989,axiom,
    ! [VarCurr: state_type] :
      ( v9998(VarCurr)
    <=> v1063(VarCurr) ) ).

tff(addAssignment_4988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9105(VarCurr,B)
      <=> v9107(VarCurr,B) ) ) ).

tff(addAssignment_4987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9107(VarCurr,B)
      <=> v9109(VarCurr,B) ) ) ).

tff(addAssignment_4986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9109(VarCurr,B)
      <=> v9111(VarCurr,B) ) ) ).

tff(addAssignment_4985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9111(VarCurr,B)
      <=> v9113(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9947(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v9113(VarNext,B)
            <=> v9113(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_115,axiom,
    ! [VarNext: state_type] :
      ( v9947(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9113(VarNext,B)
          <=> v9957(VarNext,B) ) ) ) ).

tff(addAssignment_4984,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9957(VarNext,B)
          <=> v9955(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_96,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9955(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_96,axiom,
    ! [VarCurr: state_type] :
      ( v9958(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9955(VarCurr,B)
          <=> v9147(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_840,axiom,
    ! [VarCurr: state_type] :
      ( v9958(VarCurr)
    <=> ( v9959(VarCurr)
        & v9960(VarCurr) ) ) ).

tff(writeUnaryOperator_634,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9960(VarCurr)
    <=> v9131(VarCurr) ) ).

tff(writeUnaryOperator_633,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9959(VarCurr)
    <=> v9115(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_839,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9947(VarNext)
      <=> v9948(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_838,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9948(VarNext)
      <=> ( v9949(VarNext)
          & v9856(VarNext) ) ) ) ).

tff(writeUnaryOperator_632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9949(VarNext)
      <=> v9951(VarNext) ) ) ).

tff(addAssignment_4983,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9951(VarNext)
      <=> v9856(VarCurr) ) ) ).

tff(addAssignment_4982,axiom,
    ! [VarCurr: state_type] :
      ( v9856(VarCurr)
    <=> v9858(VarCurr) ) ).

tff(addAssignment_4981,axiom,
    ! [VarCurr: state_type] :
      ( v9858(VarCurr)
    <=> v9860(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_837,axiom,
    ! [VarCurr: state_type] :
      ( v9860(VarCurr)
    <=> ( v9944(VarCurr)
        | v9934(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_836,axiom,
    ! [VarCurr: state_type] :
      ( v9944(VarCurr)
    <=> ( v9862(VarCurr)
        & v9870(VarCurr) ) ) ).

tff(addAssignment_4980,axiom,
    ! [VarCurr: state_type] :
      ( v9934(VarCurr)
    <=> v9936(VarCurr) ) ).

tff(addAssignment_4979,axiom,
    ! [VarCurr: state_type] :
      ( v9936(VarCurr)
    <=> v9938(VarCurr) ) ).

tff(addAssignment_4978,axiom,
    ! [VarCurr: state_type] :
      ( v9938(VarCurr)
    <=> v9940(VarCurr) ) ).

tff(addAssignment_4977,axiom,
    ! [VarCurr: state_type] :
      ( v9940(VarCurr)
    <=> v9942(VarCurr) ) ).

tff(addAssignment_4976,axiom,
    ! [VarCurr: state_type] :
      ( v9942(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9918(VarNext)
       => ( v9870(VarNext)
        <=> v9870(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_114,axiom,
    ! [VarNext: state_type] :
      ( v9918(VarNext)
     => ( v9870(VarNext)
      <=> v9928(VarNext) ) ) ).

tff(addAssignment_4975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9928(VarNext)
      <=> v9926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_835,axiom,
    ! [VarCurr: state_type] :
      ( v9926(VarCurr)
    <=> ( v9929(VarCurr)
        & v9930(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_834,axiom,
    ! [VarCurr: state_type] :
      ( v9930(VarCurr)
    <=> ( v9876(VarCurr)
        | v9907(VarCurr) ) ) ).

tff(writeUnaryOperator_631,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9929(VarCurr)
    <=> v9872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_833,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9918(VarNext)
      <=> v9919(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_832,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9919(VarNext)
      <=> ( v9921(VarNext)
          & v9923(VarNext) ) ) ) ).

tff(writeUnaryOperator_630,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9923(VarCurr)
    <=> v9862(VarCurr) ) ).

tff(addAssignment_4974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9921(VarNext)
      <=> v9862(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_26,axiom,
    ( v9870(constB0)
  <=> $true ) ).

tff(addAssignment_4973,axiom,
    ! [VarCurr: state_type] :
      ( v9907(VarCurr)
    <=> v9909(VarCurr) ) ).

tff(addAssignment_4972,axiom,
    ! [VarCurr: state_type] :
      ( v9909(VarCurr)
    <=> v9911(VarCurr) ) ).

tff(addAssignment_4971,axiom,
    ! [VarCurr: state_type] :
      ( v9911(VarCurr)
    <=> v9913(VarCurr) ) ).

tff(addAssignment_4970,axiom,
    ! [VarCurr: state_type] :
      ( v9913(VarCurr)
    <=> v9915(VarCurr) ) ).

tff(addAssignment_4969,axiom,
    ! [VarCurr: state_type] :
      ( v9915(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_4968,axiom,
    ! [VarCurr: state_type] :
      ( v9876(VarCurr)
    <=> v9878(VarCurr) ) ).

tff(addAssignment_4967,axiom,
    ! [VarCurr: state_type] :
      ( v9878(VarCurr)
    <=> v9880(VarCurr) ) ).

tff(addAssignment_4966,axiom,
    ! [VarCurr: state_type] :
      ( v9880(VarCurr)
    <=> v9882(VarCurr) ) ).

tff(addAssignment_4965,axiom,
    ! [VarCurr: state_type] :
      ( v9882(VarCurr)
    <=> v9884(VarCurr) ) ).

tff(writeUnaryOperator_629,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9884(VarCurr)
    <=> v9904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_831,axiom,
    ! [VarCurr: state_type] :
      ( v9904(VarCurr)
    <=> ( v9905(VarCurr)
        | v9900(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_830,axiom,
    ! [VarCurr: state_type] :
      ( v9905(VarCurr)
    <=> ( v9886(VarCurr)
        | v9896(VarCurr) ) ) ).

tff(addAssignment_4964,axiom,
    ! [VarCurr: state_type] :
      ( v9900(VarCurr)
    <=> v9902(VarCurr) ) ).

tff(addAssignment_4963,axiom,
    ! [VarCurr: state_type] :
      ( v9902(VarCurr)
    <=> v9890(VarCurr,2) ) ).

tff(addAssignment_4962,axiom,
    ! [VarCurr: state_type] :
      ( v9890(VarCurr,2)
    <=> v9892(VarCurr,2) ) ).

tff(addAssignment_4961,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,2)
    <=> v9894(VarCurr,2) ) ).

tff(addAssignment_4960,axiom,
    ! [VarCurr: state_type] :
      ( v9896(VarCurr)
    <=> v9898(VarCurr) ) ).

tff(addAssignment_4959,axiom,
    ! [VarCurr: state_type] :
      ( v9898(VarCurr)
    <=> v9890(VarCurr,1) ) ).

tff(addAssignment_4958,axiom,
    ! [VarCurr: state_type] :
      ( v9890(VarCurr,1)
    <=> v9892(VarCurr,1) ) ).

tff(addAssignment_4957,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,1)
    <=> v9894(VarCurr,1) ) ).

tff(addAssignment_4956,axiom,
    ! [VarCurr: state_type] :
      ( v9886(VarCurr)
    <=> v9888(VarCurr) ) ).

tff(addAssignment_4955,axiom,
    ! [VarCurr: state_type] :
      ( v9888(VarCurr)
    <=> v9890(VarCurr,0) ) ).

tff(addAssignment_4954,axiom,
    ! [VarCurr: state_type] :
      ( v9890(VarCurr,0)
    <=> v9892(VarCurr,0) ) ).

tff(addAssignment_4953,axiom,
    ! [VarCurr: state_type] :
      ( v9892(VarCurr,0)
    <=> v9894(VarCurr,0) ) ).

tff(addAssignment_4952,axiom,
    ! [VarCurr: state_type] :
      ( v9872(VarCurr)
    <=> v9874(VarCurr) ) ).

tff(addAssignment_4951,axiom,
    ! [VarCurr: state_type] :
      ( v9874(VarCurr)
    <=> $false ) ).

tff(addAssignment_4950,axiom,
    ! [VarCurr: state_type] :
      ( v9862(VarCurr)
    <=> v9864(VarCurr) ) ).

tff(addAssignment_4949,axiom,
    ! [VarCurr: state_type] :
      ( v9864(VarCurr)
    <=> v9866(VarCurr) ) ).

tff(addAssignment_4948,axiom,
    ! [VarCurr: state_type] :
      ( v9866(VarCurr)
    <=> v9868(VarCurr) ) ).

tff(addAssignment_4947,axiom,
    ! [VarCurr: state_type] :
      ( v9868(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_4946,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9147(VarCurr,B)
      <=> v9149(VarCurr,B) ) ) ).

tff(addAssignment_4945,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9149(VarCurr,B)
      <=> v9151(VarCurr,B) ) ) ).

tff(addAssignment_4944,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9151(VarCurr,B)
      <=> v9153(VarCurr,B) ) ) ).

tff(addAssignment_4943,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9153(VarCurr,B)
      <=> v9155(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_178,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9155(VarCurr,B)
      <=> ( v9157(VarCurr,B)
          & v9192(VarCurr,B) ) ) ) ).

tff(addAssignment_4942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9192(VarCurr,B)
      <=> v9194(VarCurr,B) ) ) ).

tff(addAssignment_4941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9194(VarCurr,B)
      <=> v9196(VarCurr,B) ) ) ).

tff(addAssignment_4940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9196(VarCurr,B)
      <=> v9198(VarCurr,B) ) ) ).

tff(addAssignment_4939,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9198(VarCurr,B)
      <=> v9200(VarCurr,B) ) ) ).

tff(addAssignment_4938,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9200(VarCurr,B)
      <=> v9202(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9202(VarCurr,B)
      <=> ( v9848(VarCurr,B)
          | v9851(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9851(VarCurr,B)
      <=> ( v9572(VarCurr,B)
          & v9852(VarCurr,B) ) ) ) ).

tff(addAssignment_4937,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,0)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4936,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,1)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4935,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,2)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4934,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,3)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4933,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,4)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4932,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,5)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4931,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,6)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4930,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,7)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4929,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,8)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4928,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,9)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4927,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,10)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4926,axiom,
    ! [VarCurr: state_type] :
      ( v9852(VarCurr,11)
    <=> v9853(VarCurr) ) ).

tff(addAssignment_4925,axiom,
    ! [VarCurr: state_type] :
      ( v9853(VarCurr)
    <=> v9840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9848(VarCurr,B)
      <=> ( v9204(VarCurr,B)
          & v9849(VarCurr,B) ) ) ) ).

tff(addAssignment_4924,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,0)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4923,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,1)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4922,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,2)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4921,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,3)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4920,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,4)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4919,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,5)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4918,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,6)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4917,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,7)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4916,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,8)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4915,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,9)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4914,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,10)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4913,axiom,
    ! [VarCurr: state_type] :
      ( v9849(VarCurr,11)
    <=> v9850(VarCurr) ) ).

tff(addAssignment_4912,axiom,
    ! [VarCurr: state_type] :
      ( v9850(VarCurr)
    <=> v9486(VarCurr) ) ).

tff(addAssignment_4911,axiom,
    ! [VarCurr: state_type] :
      ( v9840(VarCurr)
    <=> v9842(VarCurr) ) ).

tff(addAssignment_4910,axiom,
    ! [VarCurr: state_type] :
      ( v9842(VarCurr)
    <=> v9844(VarCurr,0) ) ).

tff(addAssignment_4909,axiom,
    ! [VarCurr: state_type] :
      ( v9844(VarCurr,0)
    <=> v9846(VarCurr,0) ) ).

tff(addAssignment_4908,axiom,
    ! [VarCurr: state_type] :
      ( v9846(VarCurr,0)
    <=> v9496(VarCurr,0) ) ).

tff(addAssignment_4907,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9572(VarCurr,B)
      <=> v9574(VarCurr,B) ) ) ).

tff(addAssignment_4906,axiom,
    ! [VarCurr: state_type] :
      ( ( v9574(VarCurr,11)
      <=> v9208(VarCurr,23) )
      & ( v9574(VarCurr,10)
      <=> v9208(VarCurr,22) )
      & ( v9574(VarCurr,9)
      <=> v9208(VarCurr,21) )
      & ( v9574(VarCurr,8)
      <=> v9208(VarCurr,20) )
      & ( v9574(VarCurr,7)
      <=> v9208(VarCurr,19) )
      & ( v9574(VarCurr,6)
      <=> v9208(VarCurr,18) )
      & ( v9574(VarCurr,5)
      <=> v9208(VarCurr,17) )
      & ( v9574(VarCurr,4)
      <=> v9208(VarCurr,16) )
      & ( v9574(VarCurr,3)
      <=> v9208(VarCurr,15) )
      & ( v9574(VarCurr,2)
      <=> v9208(VarCurr,14) )
      & ( v9574(VarCurr,1)
      <=> v9208(VarCurr,13) )
      & ( v9574(VarCurr,0)
      <=> v9208(VarCurr,12) ) ) ).

tff(addAssignment_4905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,12) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_4904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,12) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_4903,axiom,
    ! [VarCurr: state_type] :
      ( ( v9212(VarCurr,23)
      <=> v9576(VarCurr,11) )
      & ( v9212(VarCurr,22)
      <=> v9576(VarCurr,10) )
      & ( v9212(VarCurr,21)
      <=> v9576(VarCurr,9) )
      & ( v9212(VarCurr,20)
      <=> v9576(VarCurr,8) )
      & ( v9212(VarCurr,19)
      <=> v9576(VarCurr,7) )
      & ( v9212(VarCurr,18)
      <=> v9576(VarCurr,6) )
      & ( v9212(VarCurr,17)
      <=> v9576(VarCurr,5) )
      & ( v9212(VarCurr,16)
      <=> v9576(VarCurr,4) )
      & ( v9212(VarCurr,15)
      <=> v9576(VarCurr,3) )
      & ( v9212(VarCurr,14)
      <=> v9576(VarCurr,2) )
      & ( v9212(VarCurr,13)
      <=> v9576(VarCurr,1) )
      & ( v9212(VarCurr,12)
      <=> v9576(VarCurr,0) ) ) ).

tff(addAssignment_4902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9576(VarCurr,B)
      <=> v9578(VarCurr,B) ) ) ).

tff(addAssignment_4901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9578(VarCurr,B)
      <=> v9580(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9823(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v9580(VarNext,B)
            <=> v9580(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_113,axiom,
    ! [VarNext: state_type] :
      ( v9823(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9580(VarNext,B)
          <=> v9833(VarNext,B) ) ) ) ).

tff(addAssignment_4900,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9833(VarNext,B)
          <=> v9831(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_95,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9831(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_95,axiom,
    ! [VarCurr: state_type] :
      ( v9834(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9831(VarCurr,B)
          <=> v9610(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_829,axiom,
    ! [VarCurr: state_type] :
      ( v9834(VarCurr)
    <=> ( v9835(VarCurr)
        & v9836(VarCurr) ) ) ).

tff(writeUnaryOperator_628,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9836(VarCurr)
    <=> v9596(VarCurr) ) ).

tff(writeUnaryOperator_627,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9835(VarCurr)
    <=> v9582(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9823(VarNext)
      <=> v9824(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9824(VarNext)
      <=> ( v9825(VarNext)
          & v9798(VarNext) ) ) ) ).

tff(writeUnaryOperator_626,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9825(VarNext)
      <=> v9827(VarNext) ) ) ).

tff(addAssignment_4899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9827(VarNext)
      <=> v9798(VarCurr) ) ) ).

tff(addAssignment_4898,axiom,
    ! [VarCurr: state_type] :
      ( v9798(VarCurr)
    <=> v9800(VarCurr) ) ).

tff(addAssignment_4897,axiom,
    ! [VarCurr: state_type] :
      ( v9800(VarCurr)
    <=> v9802(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_826,axiom,
    ! [VarCurr: state_type] :
      ( v9802(VarCurr)
    <=> ( v9820(VarCurr)
        | v9812(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_825,axiom,
    ! [VarCurr: state_type] :
      ( v9820(VarCurr)
    <=> ( v9804(VarCurr)
        & v9810(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_25,axiom,
    ( v9810(constB0)
  <=> $true ) ).

tff(addAssignment_4896,axiom,
    ! [VarCurr: state_type] :
      ( v9812(VarCurr)
    <=> v9814(VarCurr) ) ).

tff(addAssignment_4895,axiom,
    ! [VarCurr: state_type] :
      ( v9814(VarCurr)
    <=> v9816(VarCurr) ) ).

tff(addAssignment_4894,axiom,
    ! [VarCurr: state_type] :
      ( v9816(VarCurr)
    <=> v9818(VarCurr) ) ).

tff(addAssignment_4893,axiom,
    ! [VarCurr: state_type] :
      ( v9818(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_4892,axiom,
    ! [VarCurr: state_type] :
      ( v9804(VarCurr)
    <=> v9806(VarCurr) ) ).

tff(addAssignment_4891,axiom,
    ! [VarCurr: state_type] :
      ( v9806(VarCurr)
    <=> v9808(VarCurr) ) ).

tff(addAssignment_4890,axiom,
    ! [VarCurr: state_type] :
      ( v9808(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_4889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9610(VarCurr,B)
      <=> v9612(VarCurr,B) ) ) ).

tff(addAssignment_4888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9612(VarCurr,B)
      <=> v9614(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9614(VarCurr,B)
      <=> ( v9783(VarCurr,B)
          | v9794(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_173,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9794(VarCurr,B)
      <=> ( v9747(VarCurr,B)
          & v9795(VarCurr,B) ) ) ) ).

tff(addAssignment_4887,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,0)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4886,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,1)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4885,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,2)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4884,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,3)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4883,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,4)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4882,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,5)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4881,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,6)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4880,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,7)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4879,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,8)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4878,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,9)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4877,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,10)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4876,axiom,
    ! [VarCurr: state_type] :
      ( v9795(VarCurr,11)
    <=> v9796(VarCurr) ) ).

tff(addAssignment_4875,axiom,
    ! [VarCurr: state_type] :
      ( v9796(VarCurr)
    <=> v9757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_172,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9783(VarCurr,B)
      <=> ( v9784(VarCurr,B)
          | v9791(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_171,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9791(VarCurr,B)
      <=> ( v9711(VarCurr,B)
          & v9792(VarCurr,B) ) ) ) ).

tff(addAssignment_4874,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,0)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4873,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,1)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4872,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,2)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4871,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,3)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4870,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,4)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4869,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,5)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4868,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,6)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4867,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,7)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4866,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,8)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4865,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,9)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4864,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,10)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4863,axiom,
    ! [VarCurr: state_type] :
      ( v9792(VarCurr,11)
    <=> v9793(VarCurr) ) ).

tff(addAssignment_4862,axiom,
    ! [VarCurr: state_type] :
      ( v9793(VarCurr)
    <=> v9721(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_170,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9784(VarCurr,B)
      <=> ( v9785(VarCurr,B)
          | v9788(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9788(VarCurr,B)
      <=> ( v9664(VarCurr,B)
          & v9789(VarCurr,B) ) ) ) ).

tff(addAssignment_4861,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,0)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4860,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,1)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4859,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,2)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4858,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,3)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4857,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,4)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4856,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,5)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4855,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,6)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4854,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,7)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4853,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,8)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4852,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,9)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4851,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,10)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4850,axiom,
    ! [VarCurr: state_type] :
      ( v9789(VarCurr,11)
    <=> v9790(VarCurr) ) ).

tff(addAssignment_4849,axiom,
    ! [VarCurr: state_type] :
      ( v9790(VarCurr)
    <=> v9674(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9785(VarCurr,B)
      <=> ( v9616(VarCurr,B)
          & v9786(VarCurr,B) ) ) ) ).

tff(addAssignment_4848,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,0)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4847,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,1)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4846,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,2)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4845,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,3)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4844,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,4)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4843,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,5)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4842,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,6)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4841,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,7)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4840,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,8)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4839,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,9)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4838,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,10)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4837,axiom,
    ! [VarCurr: state_type] :
      ( v9786(VarCurr,11)
    <=> v9787(VarCurr) ) ).

tff(addAssignment_4836,axiom,
    ! [VarCurr: state_type] :
      ( v9787(VarCurr)
    <=> v9626(VarCurr) ) ).

tff(addAssignment_4835,axiom,
    ! [VarCurr: state_type] :
      ( v9757(VarCurr)
    <=> v9759(VarCurr) ) ).

tff(addAssignment_4834,axiom,
    ! [VarCurr: state_type] :
      ( v9759(VarCurr)
    <=> v9761(VarCurr) ) ).

tff(addAssignment_4833,axiom,
    ! [VarCurr: state_type] :
      ( v9761(VarCurr)
    <=> v9763(VarCurr) ) ).

tff(addAssignment_4832,axiom,
    ! [VarCurr: state_type] :
      ( v9763(VarCurr)
    <=> v9765(VarCurr) ) ).

tff(addAssignment_4831,axiom,
    ! [VarCurr: state_type] :
      ( v9765(VarCurr)
    <=> v9767(VarCurr) ) ).

tff(addAssignment_4830,axiom,
    ! [VarCurr: state_type] :
      ( v9767(VarCurr)
    <=> v9769(VarCurr) ) ).

tff(addAssignment_4829,axiom,
    ! [VarCurr: state_type] :
      ( v9769(VarCurr)
    <=> v9771(VarCurr) ) ).

tff(writeUnaryOperator_625,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9771(VarCurr)
    <=> v9781(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_824,axiom,
    ! [VarCurr: state_type] :
      ( v9781(VarCurr)
    <=> ( v9773(VarCurr)
        | v9777(VarCurr) ) ) ).

tff(addAssignment_4828,axiom,
    ! [VarCurr: state_type] :
      ( v9777(VarCurr)
    <=> v9779(VarCurr) ) ).

tff(addAssignment_4827,axiom,
    ! [VarCurr: state_type] :
      ( v9779(VarCurr)
    <=> v9694(VarCurr,1) ) ).

tff(addAssignment_4826,axiom,
    ! [VarCurr: state_type] :
      ( v9773(VarCurr)
    <=> v9775(VarCurr) ) ).

tff(addAssignment_4825,axiom,
    ! [VarCurr: state_type] :
      ( v9775(VarCurr)
    <=> v9694(VarCurr,0) ) ).

tff(addAssignment_4824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9747(VarCurr,B)
      <=> v9749(VarCurr,B) ) ) ).

tff(addAssignment_4823,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9749(VarCurr,B)
      <=> v9751(VarCurr,B) ) ) ).

tff(addAssignment_4822,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9751(VarCurr,B)
      <=> v9753(VarCurr,B) ) ) ).

tff(addAssignment_4821,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9753(VarCurr,B)
      <=> v9755(VarCurr,B) ) ) ).

tff(addAssignment_4820,axiom,
    ! [VarCurr: state_type] :
      ( v9721(VarCurr)
    <=> v9723(VarCurr) ) ).

tff(addAssignment_4819,axiom,
    ! [VarCurr: state_type] :
      ( v9723(VarCurr)
    <=> v9725(VarCurr) ) ).

tff(addAssignment_4818,axiom,
    ! [VarCurr: state_type] :
      ( v9725(VarCurr)
    <=> v9727(VarCurr) ) ).

tff(addAssignment_4817,axiom,
    ! [VarCurr: state_type] :
      ( v9727(VarCurr)
    <=> v9729(VarCurr) ) ).

tff(addAssignment_4816,axiom,
    ! [VarCurr: state_type] :
      ( v9729(VarCurr)
    <=> v9731(VarCurr) ) ).

tff(addAssignment_4815,axiom,
    ! [VarCurr: state_type] :
      ( v9731(VarCurr)
    <=> v9733(VarCurr) ) ).

tff(addAssignment_4814,axiom,
    ! [VarCurr: state_type] :
      ( v9733(VarCurr)
    <=> v9735(VarCurr) ) ).

tff(writeUnaryOperator_624,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9735(VarCurr)
    <=> v9745(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_823,axiom,
    ! [VarCurr: state_type] :
      ( v9745(VarCurr)
    <=> ( v9737(VarCurr)
        | v9741(VarCurr) ) ) ).

tff(addAssignment_4813,axiom,
    ! [VarCurr: state_type] :
      ( v9741(VarCurr)
    <=> v9743(VarCurr) ) ).

tff(addAssignment_4812,axiom,
    ! [VarCurr: state_type] :
      ( v9743(VarCurr)
    <=> v9694(VarCurr,1) ) ).

tff(addAssignment_4811,axiom,
    ! [VarCurr: state_type] :
      ( v9694(VarCurr,1)
    <=> v9696(VarCurr,1) ) ).

tff(addAssignment_4810,axiom,
    ! [VarCurr: state_type] :
      ( v9696(VarCurr,1)
    <=> v9698(VarCurr,1) ) ).

tff(addAssignment_4809,axiom,
    ! [VarCurr: state_type] :
      ( v9698(VarCurr,1)
    <=> v9703(VarCurr,1) ) ).

tff(addAssignment_4808,axiom,
    ! [VarCurr: state_type] :
      ( v9700(VarCurr,1)
    <=> v9702(VarCurr,1) ) ).

tff(addAssignment_4807,axiom,
    ! [VarCurr: state_type] :
      ( v9702(VarCurr,1)
    <=> v9646(VarCurr,1) ) ).

tff(addAssignment_4806,axiom,
    ! [VarCurr: state_type] :
      ( v9737(VarCurr)
    <=> v9739(VarCurr) ) ).

tff(addAssignment_4805,axiom,
    ! [VarCurr: state_type] :
      ( v9739(VarCurr)
    <=> v9646(VarCurr,0) ) ).

tff(addAssignment_4804,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9711(VarCurr,B)
      <=> v9713(VarCurr,B) ) ) ).

tff(addAssignment_4803,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9713(VarCurr,B)
      <=> v9715(VarCurr,B) ) ) ).

tff(addAssignment_4802,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9715(VarCurr,B)
      <=> v9717(VarCurr,B) ) ) ).

tff(addAssignment_4801,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9717(VarCurr,B)
      <=> v9719(VarCurr,B) ) ) ).

tff(addAssignment_4800,axiom,
    ! [VarCurr: state_type] :
      ( v9674(VarCurr)
    <=> v9676(VarCurr) ) ).

tff(addAssignment_4799,axiom,
    ! [VarCurr: state_type] :
      ( v9676(VarCurr)
    <=> v9678(VarCurr) ) ).

tff(addAssignment_4798,axiom,
    ! [VarCurr: state_type] :
      ( v9678(VarCurr)
    <=> v9680(VarCurr) ) ).

tff(addAssignment_4797,axiom,
    ! [VarCurr: state_type] :
      ( v9680(VarCurr)
    <=> v9682(VarCurr) ) ).

tff(addAssignment_4796,axiom,
    ! [VarCurr: state_type] :
      ( v9682(VarCurr)
    <=> v9684(VarCurr) ) ).

tff(addAssignment_4795,axiom,
    ! [VarCurr: state_type] :
      ( v9684(VarCurr)
    <=> v9686(VarCurr) ) ).

tff(addAssignment_4794,axiom,
    ! [VarCurr: state_type] :
      ( v9686(VarCurr)
    <=> v9688(VarCurr) ) ).

tff(writeUnaryOperator_623,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9688(VarCurr)
    <=> v9709(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_822,axiom,
    ! [VarCurr: state_type] :
      ( v9709(VarCurr)
    <=> ( v9690(VarCurr)
        | v9705(VarCurr) ) ) ).

tff(addAssignment_4793,axiom,
    ! [VarCurr: state_type] :
      ( v9705(VarCurr)
    <=> v9707(VarCurr) ) ).

tff(addAssignment_4792,axiom,
    ! [VarCurr: state_type] :
      ( v9707(VarCurr)
    <=> v9646(VarCurr,1) ) ).

tff(addAssignment_4791,axiom,
    ! [VarCurr: state_type] :
      ( v9690(VarCurr)
    <=> v9692(VarCurr) ) ).

tff(addAssignment_4790,axiom,
    ! [VarCurr: state_type] :
      ( v9692(VarCurr)
    <=> v9694(VarCurr,0) ) ).

tff(addAssignment_4789,axiom,
    ! [VarCurr: state_type] :
      ( v9694(VarCurr,0)
    <=> v9696(VarCurr,0) ) ).

tff(addAssignment_4788,axiom,
    ! [VarCurr: state_type] :
      ( v9696(VarCurr,0)
    <=> v9698(VarCurr,0) ) ).

tff(addAssignment_4787,axiom,
    ! [VarCurr: state_type] :
      ( v9698(VarCurr,0)
    <=> v9703(VarCurr,0) ) ).

tff(writeUnaryOperator_622,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v9703(VarCurr,B)
      <=> ~ v9700(VarCurr,B) ) ) ).

tff(addAssignment_4786,axiom,
    ! [VarCurr: state_type] :
      ( v9700(VarCurr,0)
    <=> v9702(VarCurr,0) ) ).

tff(addAssignment_4785,axiom,
    ! [VarCurr: state_type] :
      ( v9702(VarCurr,0)
    <=> v9646(VarCurr,0) ) ).

tff(addAssignment_4784,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9664(VarCurr,B)
      <=> v9666(VarCurr,B) ) ) ).

tff(addAssignment_4783,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9666(VarCurr,B)
      <=> v9668(VarCurr,B) ) ) ).

tff(addAssignment_4782,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9668(VarCurr,B)
      <=> v9670(VarCurr,B) ) ) ).

tff(addAssignment_4781,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9670(VarCurr,B)
      <=> v9672(VarCurr,B) ) ) ).

tff(addAssignment_4780,axiom,
    ! [VarCurr: state_type] :
      ( v9626(VarCurr)
    <=> v9628(VarCurr) ) ).

tff(addAssignment_4779,axiom,
    ! [VarCurr: state_type] :
      ( v9628(VarCurr)
    <=> v9630(VarCurr) ) ).

tff(addAssignment_4778,axiom,
    ! [VarCurr: state_type] :
      ( v9630(VarCurr)
    <=> v9632(VarCurr) ) ).

tff(addAssignment_4777,axiom,
    ! [VarCurr: state_type] :
      ( v9632(VarCurr)
    <=> v9634(VarCurr) ) ).

tff(addAssignment_4776,axiom,
    ! [VarCurr: state_type] :
      ( v9634(VarCurr)
    <=> v9636(VarCurr) ) ).

tff(addAssignment_4775,axiom,
    ! [VarCurr: state_type] :
      ( v9636(VarCurr)
    <=> v9638(VarCurr) ) ).

tff(addAssignment_4774,axiom,
    ! [VarCurr: state_type] :
      ( v9638(VarCurr)
    <=> v9640(VarCurr) ) ).

tff(writeUnaryOperator_621,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9640(VarCurr)
    <=> v9662(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_821,axiom,
    ! [VarCurr: state_type] :
      ( v9662(VarCurr)
    <=> ( v9642(VarCurr)
        | v9658(VarCurr) ) ) ).

tff(addAssignment_4773,axiom,
    ! [VarCurr: state_type] :
      ( v9658(VarCurr)
    <=> v9660(VarCurr) ) ).

tff(addAssignment_4772,axiom,
    ! [VarCurr: state_type] :
      ( v9660(VarCurr)
    <=> v9646(VarCurr,1) ) ).

tff(addAssignment_4771,axiom,
    ! [VarCurr: state_type] :
      ( v9646(VarCurr,1)
    <=> v9648(VarCurr,1) ) ).

tff(addAssignment_4770,axiom,
    ! [VarCurr: state_type] :
      ( v9648(VarCurr,1)
    <=> v9650(VarCurr,1) ) ).

tff(addAssignment_4769,axiom,
    ! [VarCurr: state_type] :
      ( v9650(VarCurr,1)
    <=> v9652(VarCurr,1) ) ).

tff(addAssignment_4768,axiom,
    ! [VarCurr: state_type] :
      ( v9652(VarCurr,1)
    <=> v9654(VarCurr,1) ) ).

tff(addAssignment_4767,axiom,
    ! [VarCurr: state_type] :
      ( v9654(VarCurr,1)
    <=> v9656(VarCurr,1) ) ).

tff(addAssignment_4766,axiom,
    ! [VarCurr: state_type] :
      ( v9642(VarCurr)
    <=> v9644(VarCurr) ) ).

tff(addAssignment_4765,axiom,
    ! [VarCurr: state_type] :
      ( v9644(VarCurr)
    <=> v9646(VarCurr,0) ) ).

tff(addAssignment_4764,axiom,
    ! [VarCurr: state_type] :
      ( v9646(VarCurr,0)
    <=> v9648(VarCurr,0) ) ).

tff(addAssignment_4763,axiom,
    ! [VarCurr: state_type] :
      ( v9648(VarCurr,0)
    <=> v9650(VarCurr,0) ) ).

tff(addAssignment_4762,axiom,
    ! [VarCurr: state_type] :
      ( v9650(VarCurr,0)
    <=> v9652(VarCurr,0) ) ).

tff(addAssignment_4761,axiom,
    ! [VarCurr: state_type] :
      ( v9652(VarCurr,0)
    <=> v9654(VarCurr,0) ) ).

tff(addAssignment_4760,axiom,
    ! [VarCurr: state_type] :
      ( v9654(VarCurr,0)
    <=> v9656(VarCurr,0) ) ).

tff(addAssignment_4759,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9616(VarCurr,B)
      <=> v9618(VarCurr,B) ) ) ).

tff(addAssignment_4758,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9618(VarCurr,B)
      <=> v9620(VarCurr,B) ) ) ).

tff(addAssignment_4757,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9620(VarCurr,B)
      <=> v9622(VarCurr,B) ) ) ).

tff(addAssignment_4756,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9622(VarCurr,B)
      <=> v9624(VarCurr,B) ) ) ).

tff(addAssignment_4755,axiom,
    ! [VarCurr: state_type] :
      ( v9596(VarCurr)
    <=> v9598(VarCurr) ) ).

tff(addAssignment_4754,axiom,
    ! [VarCurr: state_type] :
      ( v9598(VarCurr)
    <=> v9600(VarCurr) ) ).

tff(addAssignment_4753,axiom,
    ! [VarCurr: state_type] :
      ( v9600(VarCurr)
    <=> v9602(VarCurr) ) ).

tff(addAssignment_4752,axiom,
    ! [VarCurr: state_type] :
      ( v9602(VarCurr)
    <=> v9604(VarCurr) ) ).

tff(addAssignment_4751,axiom,
    ! [VarCurr: state_type] :
      ( v9604(VarCurr)
    <=> v9606(VarCurr) ) ).

tff(addAssignment_4750,axiom,
    ! [VarCurr: state_type] :
      ( v9606(VarCurr)
    <=> v9608(VarCurr) ) ).

tff(addAssignment_4749,axiom,
    ! [VarCurr: state_type] :
      ( v9608(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_4748,axiom,
    ! [VarCurr: state_type] :
      ( v9582(VarCurr)
    <=> v9584(VarCurr) ) ).

tff(addAssignment_4747,axiom,
    ! [VarCurr: state_type] :
      ( v9584(VarCurr)
    <=> v9586(VarCurr) ) ).

tff(addAssignment_4746,axiom,
    ! [VarCurr: state_type] :
      ( v9586(VarCurr)
    <=> v9588(VarCurr) ) ).

tff(addAssignment_4745,axiom,
    ! [VarCurr: state_type] :
      ( v9588(VarCurr)
    <=> v9590(VarCurr) ) ).

tff(addAssignment_4744,axiom,
    ! [VarCurr: state_type] :
      ( v9590(VarCurr)
    <=> v9592(VarCurr) ) ).

tff(addAssignment_4743,axiom,
    ! [VarCurr: state_type] :
      ( v9592(VarCurr)
    <=> v9594(VarCurr) ) ).

tff(addAssignment_4742,axiom,
    ! [VarCurr: state_type] :
      ( v9594(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_4741,axiom,
    ! [VarCurr: state_type] :
      ( v9486(VarCurr)
    <=> v9488(VarCurr) ) ).

tff(addAssignment_4740,axiom,
    ! [VarCurr: state_type] :
      ( v9488(VarCurr)
    <=> v9490(VarCurr,0) ) ).

tff(addAssignment_4739,axiom,
    ! [VarCurr: state_type] :
      ( v9490(VarCurr,0)
    <=> v9492(VarCurr,0) ) ).

tff(addAssignment_4738,axiom,
    ! [VarCurr: state_type] :
      ( v9492(VarCurr,0)
    <=> v9494(VarCurr,0) ) ).

tff(addAssignment_4737,axiom,
    ! [VarCurr: state_type] :
      ( v9494(VarCurr,0)
    <=> v9570(VarCurr,0) ) ).

tff(writeUnaryOperator_620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v9570(VarCurr,B)
      <=> ~ v9496(VarCurr,B) ) ) ).

tff(addAssignment_4736,axiom,
    ! [VarCurr: state_type] :
      ( v9496(VarCurr,0)
    <=> v9513(VarCurr,0) ) ).

tff(addAssignment_4735,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,0)
    <=> v9569(VarCurr) ) ).

tff(addAssignment_4734,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,1)
    <=> v9565(VarCurr) ) ).

tff(addAssignment_4733,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,2)
    <=> v9561(VarCurr) ) ).

tff(addAssignment_4732,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,3)
    <=> v9557(VarCurr) ) ).

tff(addAssignment_4731,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,4)
    <=> v9553(VarCurr) ) ).

tff(addAssignment_4730,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,5)
    <=> v9548(VarCurr) ) ).

tff(addAssignment_4729,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,6)
    <=> v9543(VarCurr) ) ).

tff(addAssignment_4728,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,7)
    <=> v9541(VarCurr) ) ).

tff(addAssignment_4727,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,8)
    <=> v9536(VarCurr) ) ).

tff(addAssignment_4726,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,9)
    <=> v9531(VarCurr) ) ).

tff(addAssignment_4725,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,10)
    <=> v9524(VarCurr) ) ).

tff(addAssignment_4724,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,11)
    <=> v9521(VarCurr) ) ).

tff(addAssignment_4723,axiom,
    ! [VarCurr: state_type] :
      ( v9513(VarCurr,12)
    <=> v9514(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_85,axiom,
    ! [VarCurr: state_type] :
      ( v9569(VarCurr)
    <=> ( ( v6625(VarCurr,11)
        <=> $false )
        & ( v6625(VarCurr,10)
        <=> $false )
        & ( v6625(VarCurr,9)
        <=> $false )
        & ( v6625(VarCurr,8)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_619,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9565(VarCurr)
    <=> v9567(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_178,axiom,
    ! [VarCurr: state_type] :
      ( v9567(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9568(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_820,axiom,
    ! [VarCurr: state_type] :
      ( v9568(VarCurr)
    <=> ( v9542(VarCurr)
        & v9534(VarCurr) ) ) ).

tff(writeUnaryOperator_618,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9561(VarCurr)
    <=> v9563(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_177,axiom,
    ! [VarCurr: state_type] :
      ( v9563(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9564(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_819,axiom,
    ! [VarCurr: state_type] :
      ( v9564(VarCurr)
    <=> ( v9542(VarCurr)
        & v9527(VarCurr) ) ) ).

tff(writeUnaryOperator_617,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9557(VarCurr)
    <=> v9559(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_176,axiom,
    ! [VarCurr: state_type] :
      ( v9559(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9560(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_175,axiom,
    ! [VarCurr: state_type] :
      ( v9560(VarCurr)
    <=> ( v6625(VarCurr,10)
        & v9542(VarCurr) ) ) ).

tff(writeUnaryOperator_616,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9553(VarCurr)
    <=> v9555(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_174,axiom,
    ! [VarCurr: state_type] :
      ( v9555(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9556(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_818,axiom,
    ! [VarCurr: state_type] :
      ( v9556(VarCurr)
    <=> ( v9517(VarCurr)
        & v9542(VarCurr) ) ) ).

tff(writeUnaryOperator_615,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9548(VarCurr)
    <=> v9550(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_173,axiom,
    ! [VarCurr: state_type] :
      ( v9550(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_817,axiom,
    ! [VarCurr: state_type] :
      ( v9551(VarCurr)
    <=> ( v9542(VarCurr)
        & v9552(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_172,axiom,
    ! [VarCurr: state_type] :
      ( v9552(VarCurr)
    <=> ( v6625(VarCurr,9)
        & v6625(VarCurr,10) ) ) ).

tff(writeUnaryOperator_614,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9543(VarCurr)
    <=> v9545(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_171,axiom,
    ! [VarCurr: state_type] :
      ( v9545(VarCurr)
    <=> ( v6625(VarCurr,11)
        | v9546(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_816,axiom,
    ! [VarCurr: state_type] :
      ( v9546(VarCurr)
    <=> ( v9542(VarCurr)
        & v9547(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_170,axiom,
    ! [VarCurr: state_type] :
      ( v9547(VarCurr)
    <=> ( v6625(VarCurr,10)
        & v9530(VarCurr) ) ) ).

tff(writeUnaryOperator_613,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9542(VarCurr)
    <=> v6625(VarCurr,11) ) ).

tff(writeUnaryOperator_612,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9541(VarCurr)
    <=> v6625(VarCurr,11) ) ).

tff(writeUnaryOperator_611,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9536(VarCurr)
    <=> v9538(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_169,axiom,
    ! [VarCurr: state_type] :
      ( v9538(VarCurr)
    <=> ( v6625(VarCurr,11)
        & v9539(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_168,axiom,
    ! [VarCurr: state_type] :
      ( v9539(VarCurr)
    <=> ( v6625(VarCurr,10)
        | v9540(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_815,axiom,
    ! [VarCurr: state_type] :
      ( v9540(VarCurr)
    <=> ( v9518(VarCurr)
        & v9529(VarCurr) ) ) ).

tff(writeUnaryOperator_610,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9531(VarCurr)
    <=> v9533(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_167,axiom,
    ! [VarCurr: state_type] :
      ( v9533(VarCurr)
    <=> ( v6625(VarCurr,11)
        & v9534(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_166,axiom,
    ! [VarCurr: state_type] :
      ( v9534(VarCurr)
    <=> ( v6625(VarCurr,10)
        | v9535(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_165,axiom,
    ! [VarCurr: state_type] :
      ( v9535(VarCurr)
    <=> ( v6625(VarCurr,9)
        & v9529(VarCurr) ) ) ).

tff(writeUnaryOperator_609,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9524(VarCurr)
    <=> v9526(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_164,axiom,
    ! [VarCurr: state_type] :
      ( v9526(VarCurr)
    <=> ( v6625(VarCurr,11)
        & v9527(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_163,axiom,
    ! [VarCurr: state_type] :
      ( v9527(VarCurr)
    <=> ( v6625(VarCurr,10)
        | v9528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_814,axiom,
    ! [VarCurr: state_type] :
      ( v9528(VarCurr)
    <=> ( v9529(VarCurr)
        & v9530(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_162,axiom,
    ! [VarCurr: state_type] :
      ( v9530(VarCurr)
    <=> ( v6625(VarCurr,8)
        & v6625(VarCurr,9) ) ) ).

tff(writeUnaryOperator_608,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9529(VarCurr)
    <=> v6625(VarCurr,10) ) ).

tff(writeUnaryOperator_607,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9521(VarCurr)
    <=> v9523(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_161,axiom,
    ! [VarCurr: state_type] :
      ( v9523(VarCurr)
    <=> ( v6625(VarCurr,10)
        & v6625(VarCurr,11) ) ) ).

tff(writeUnaryOperator_606,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9514(VarCurr)
    <=> v9516(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_160,axiom,
    ! [VarCurr: state_type] :
      ( v9516(VarCurr)
    <=> ( v9517(VarCurr)
        & v6625(VarCurr,11) ) ) ).

tff(writeBinaryOperatorShiftedRanges_159,axiom,
    ! [VarCurr: state_type] :
      ( v9517(VarCurr)
    <=> ( v9518(VarCurr)
        & v6625(VarCurr,10) ) ) ).

tff(writeBinaryOperatorShiftedRanges_158,axiom,
    ! [VarCurr: state_type] :
      ( v9518(VarCurr)
    <=> ( v6625(VarCurr,9)
        | v9519(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_157,axiom,
    ! [VarCurr: state_type] :
      ( v9519(VarCurr)
    <=> ( v6625(VarCurr,8)
        & v9520(VarCurr) ) ) ).

tff(writeUnaryOperator_605,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9520(VarCurr)
    <=> v6625(VarCurr,9) ) ).

tff(addAssignment_4722,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6625(VarCurr,B)
      <=> v6689(VarCurr,B) ) ) ).

tff(addAssignment_4721,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6627(VarCurr,B)
      <=> v6629(VarCurr,B) ) ) ).

tff(addAssignment_4720,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6629(VarCurr,B)
      <=> v6631(VarCurr,B) ) ) ).

tff(addAssignment_4719,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6631(VarNext,B)
      <=> v9506(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9507(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v9506(VarNext,B)
            <=> v6631(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_112,axiom,
    ! [VarNext: state_type] :
      ( v9507(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v9506(VarNext,B)
          <=> v6683(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_813,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9507(VarNext)
      <=> v9508(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_812,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9508(VarNext)
      <=> ( v9510(VarNext)
          & v6668(VarNext) ) ) ) ).

tff(writeUnaryOperator_604,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9510(VarNext)
      <=> v6677(VarNext) ) ) ).

tff(addAssignment_4718,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6641(VarCurr,B)
      <=> v6643(VarCurr,B) ) ) ).

tff(addAssignment_4717,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6643(VarCurr,B)
      <=> v6658(VarCurr,B) ) ) ).

tff(addAssignment_4716,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6645(VarCurr,B)
      <=> v6647(VarCurr,B) ) ) ).

tff(addAssignment_4715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6647(VarCurr,B)
      <=> v6650(VarCurr,B) ) ) ).

tff(addAssignment_4714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6649(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_4713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2363(VarCurr,B)
      <=> v2365(VarCurr,B) ) ) ).

tff(addAssignment_4712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v2365(VarCurr,B)
      <=> v1119(VarCurr,B) ) ) ).

tff(addAssignment_4711,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1119(VarCurr,B)
      <=> v1121(VarCurr,B) ) ) ).

tff(addAssignment_4710,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1121(VarCurr,B)
      <=> v1123(VarCurr,B) ) ) ).

tff(addAssignment_4709,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1123(VarNext,B)
      <=> v9498(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9499(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v9498(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_111,axiom,
    ! [VarNext: state_type] :
      ( v9499(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v9498(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_811,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9499(VarNext)
      <=> v9500(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_810,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9500(VarNext)
      <=> ( v9502(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_603,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9502(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_4708,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1133(VarCurr,B)
      <=> v1135(VarCurr,B) ) ) ).

tff(addAssignment_4707,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1135(VarCurr,B)
      <=> v1137(VarCurr,B) ) ) ).

tff(addAssignment_4706,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1137(VarCurr,B)
      <=> v1697(VarCurr,B) ) ) ).

tff(addAssignment_4705,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1139(VarCurr,B)
      <=> v1141(VarCurr,B) ) ) ).

tff(addAssignment_4704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1141(VarCurr,B)
      <=> v1143(VarCurr,B) ) ) ).

tff(addAssignment_4703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1143(VarCurr,B)
      <=> v1145(VarCurr,B) ) ) ).

tff(addAssignment_4702,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v1145(VarCurr,B)
      <=> v1147(VarCurr,B) ) ) ).

tff(addAssignment_4701,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9204(VarCurr,B)
      <=> v9206(VarCurr,B) ) ) ).

tff(addAssignment_4700,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9206(VarCurr,B)
      <=> v9208(VarCurr,B) ) ) ).

tff(addAssignment_4699,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9208(VarCurr,B)
      <=> v9210(VarCurr,B) ) ) ).

tff(addAssignment_4698,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9210(VarCurr,B)
      <=> v9212(VarCurr,B) ) ) ).

tff(addAssignment_4697,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9212(VarCurr,B)
      <=> v9214(VarCurr,B) ) ) ).

tff(addAssignment_4696,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9214(VarCurr,B)
      <=> v9216(VarCurr,B) ) ) ).

tff(addAssignment_4695,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9216(VarCurr,B)
      <=> v9218(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_110,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9469(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v9218(VarNext,B)
            <=> v9218(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_110,axiom,
    ! [VarNext: state_type] :
      ( v9469(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9218(VarNext,B)
          <=> v9479(VarNext,B) ) ) ) ).

tff(addAssignment_4694,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9479(VarNext,B)
          <=> v9477(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_94,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9477(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_94,axiom,
    ! [VarCurr: state_type] :
      ( v9480(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v9477(VarCurr,B)
          <=> v9252(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_809,axiom,
    ! [VarCurr: state_type] :
      ( v9480(VarCurr)
    <=> ( v9481(VarCurr)
        & v9482(VarCurr) ) ) ).

tff(writeUnaryOperator_602,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9482(VarCurr)
    <=> v9236(VarCurr) ) ).

tff(writeUnaryOperator_601,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9481(VarCurr)
    <=> v9220(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_808,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9469(VarNext)
      <=> v9470(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_807,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9470(VarNext)
      <=> ( v9471(VarNext)
          & v9440(VarNext) ) ) ) ).

tff(writeUnaryOperator_600,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v9471(VarNext)
      <=> v9473(VarNext) ) ) ).

tff(addAssignment_4693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v9473(VarNext)
      <=> v9440(VarCurr) ) ) ).

tff(addAssignment_4692,axiom,
    ! [VarCurr: state_type] :
      ( v9440(VarCurr)
    <=> v9442(VarCurr) ) ).

tff(addAssignment_4691,axiom,
    ! [VarCurr: state_type] :
      ( v9442(VarCurr)
    <=> v9444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_806,axiom,
    ! [VarCurr: state_type] :
      ( v9444(VarCurr)
    <=> ( v9466(VarCurr)
        | v9456(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_805,axiom,
    ! [VarCurr: state_type] :
      ( v9466(VarCurr)
    <=> ( v9446(VarCurr)
        & v9454(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_24,axiom,
    ( v9454(constB0)
  <=> $true ) ).

tff(addAssignment_4690,axiom,
    ! [VarCurr: state_type] :
      ( v9456(VarCurr)
    <=> v9458(VarCurr) ) ).

tff(addAssignment_4689,axiom,
    ! [VarCurr: state_type] :
      ( v9458(VarCurr)
    <=> v9460(VarCurr) ) ).

tff(addAssignment_4688,axiom,
    ! [VarCurr: state_type] :
      ( v9460(VarCurr)
    <=> v9462(VarCurr) ) ).

tff(addAssignment_4687,axiom,
    ! [VarCurr: state_type] :
      ( v9462(VarCurr)
    <=> v9464(VarCurr) ) ).

tff(addAssignment_4686,axiom,
    ! [VarCurr: state_type] :
      ( v9464(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_4685,axiom,
    ! [VarCurr: state_type] :
      ( v9446(VarCurr)
    <=> v9448(VarCurr) ) ).

tff(addAssignment_4684,axiom,
    ! [VarCurr: state_type] :
      ( v9448(VarCurr)
    <=> v9450(VarCurr) ) ).

tff(addAssignment_4683,axiom,
    ! [VarCurr: state_type] :
      ( v9450(VarCurr)
    <=> v9452(VarCurr) ) ).

tff(addAssignment_4682,axiom,
    ! [VarCurr: state_type] :
      ( v9452(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_4681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9252(VarCurr,B)
      <=> v9254(VarCurr,B) ) ) ).

tff(addAssignment_4680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9254(VarCurr,B)
      <=> v9256(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_167,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9256(VarCurr,B)
      <=> ( v9425(VarCurr,B)
          | v9436(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_166,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9436(VarCurr,B)
      <=> ( v9389(VarCurr,B)
          & v9437(VarCurr,B) ) ) ) ).

tff(addAssignment_4679,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,0)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4678,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,1)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4677,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,2)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4676,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,3)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4675,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,4)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4674,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,5)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4673,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,6)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4672,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,7)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4671,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,8)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4670,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,9)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4669,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,10)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4668,axiom,
    ! [VarCurr: state_type] :
      ( v9437(VarCurr,11)
    <=> v9438(VarCurr) ) ).

tff(addAssignment_4667,axiom,
    ! [VarCurr: state_type] :
      ( v9438(VarCurr)
    <=> v9399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_165,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9425(VarCurr,B)
      <=> ( v9426(VarCurr,B)
          | v9433(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_164,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9433(VarCurr,B)
      <=> ( v9353(VarCurr,B)
          & v9434(VarCurr,B) ) ) ) ).

tff(addAssignment_4666,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,0)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4665,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,1)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4664,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,2)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4663,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,3)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4662,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,4)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4661,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,5)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4660,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,6)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4659,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,7)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4658,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,8)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4657,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,9)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4656,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,10)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4655,axiom,
    ! [VarCurr: state_type] :
      ( v9434(VarCurr,11)
    <=> v9435(VarCurr) ) ).

tff(addAssignment_4654,axiom,
    ! [VarCurr: state_type] :
      ( v9435(VarCurr)
    <=> v9363(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9426(VarCurr,B)
      <=> ( v9427(VarCurr,B)
          | v9430(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_162,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9430(VarCurr,B)
      <=> ( v9306(VarCurr,B)
          & v9431(VarCurr,B) ) ) ) ).

tff(addAssignment_4653,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,0)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4652,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,1)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4651,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,2)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4650,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,3)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4649,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,4)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4648,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,5)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4647,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,6)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4646,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,7)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4645,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,8)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4644,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,9)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4643,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,10)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4642,axiom,
    ! [VarCurr: state_type] :
      ( v9431(VarCurr,11)
    <=> v9432(VarCurr) ) ).

tff(addAssignment_4641,axiom,
    ! [VarCurr: state_type] :
      ( v9432(VarCurr)
    <=> v9316(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_161,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9427(VarCurr,B)
      <=> ( v9258(VarCurr,B)
          & v9428(VarCurr,B) ) ) ) ).

tff(addAssignment_4640,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,0)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4639,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,1)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4638,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,2)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4637,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,3)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4636,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,4)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4635,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,5)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4634,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,6)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4633,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,7)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4632,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,8)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4631,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,9)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4630,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,10)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4629,axiom,
    ! [VarCurr: state_type] :
      ( v9428(VarCurr,11)
    <=> v9429(VarCurr) ) ).

tff(addAssignment_4628,axiom,
    ! [VarCurr: state_type] :
      ( v9429(VarCurr)
    <=> v9268(VarCurr) ) ).

tff(addAssignment_4627,axiom,
    ! [VarCurr: state_type] :
      ( v9399(VarCurr)
    <=> v9401(VarCurr) ) ).

tff(addAssignment_4626,axiom,
    ! [VarCurr: state_type] :
      ( v9401(VarCurr)
    <=> v9403(VarCurr) ) ).

tff(addAssignment_4625,axiom,
    ! [VarCurr: state_type] :
      ( v9403(VarCurr)
    <=> v9405(VarCurr) ) ).

tff(addAssignment_4624,axiom,
    ! [VarCurr: state_type] :
      ( v9405(VarCurr)
    <=> v9407(VarCurr) ) ).

tff(addAssignment_4623,axiom,
    ! [VarCurr: state_type] :
      ( v9407(VarCurr)
    <=> v9409(VarCurr) ) ).

tff(addAssignment_4622,axiom,
    ! [VarCurr: state_type] :
      ( v9409(VarCurr)
    <=> v9411(VarCurr) ) ).

tff(addAssignment_4621,axiom,
    ! [VarCurr: state_type] :
      ( v9411(VarCurr)
    <=> v9413(VarCurr) ) ).

tff(writeUnaryOperator_599,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9413(VarCurr)
    <=> v9423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_804,axiom,
    ! [VarCurr: state_type] :
      ( v9423(VarCurr)
    <=> ( v9415(VarCurr)
        | v9419(VarCurr) ) ) ).

tff(addAssignment_4620,axiom,
    ! [VarCurr: state_type] :
      ( v9419(VarCurr)
    <=> v9421(VarCurr) ) ).

tff(addAssignment_4619,axiom,
    ! [VarCurr: state_type] :
      ( v9421(VarCurr)
    <=> v9336(VarCurr,1) ) ).

tff(addAssignment_4618,axiom,
    ! [VarCurr: state_type] :
      ( v9415(VarCurr)
    <=> v9417(VarCurr) ) ).

tff(addAssignment_4617,axiom,
    ! [VarCurr: state_type] :
      ( v9417(VarCurr)
    <=> v9336(VarCurr,0) ) ).

tff(addAssignment_4616,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9389(VarCurr,B)
      <=> v9391(VarCurr,B) ) ) ).

tff(addAssignment_4615,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9391(VarCurr,B)
      <=> v9393(VarCurr,B) ) ) ).

tff(addAssignment_4614,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9393(VarCurr,B)
      <=> v9395(VarCurr,B) ) ) ).

tff(addAssignment_4613,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9395(VarCurr,B)
      <=> v9397(VarCurr,B) ) ) ).

tff(addAssignment_4612,axiom,
    ! [VarCurr: state_type] :
      ( v9363(VarCurr)
    <=> v9365(VarCurr) ) ).

tff(addAssignment_4611,axiom,
    ! [VarCurr: state_type] :
      ( v9365(VarCurr)
    <=> v9367(VarCurr) ) ).

tff(addAssignment_4610,axiom,
    ! [VarCurr: state_type] :
      ( v9367(VarCurr)
    <=> v9369(VarCurr) ) ).

tff(addAssignment_4609,axiom,
    ! [VarCurr: state_type] :
      ( v9369(VarCurr)
    <=> v9371(VarCurr) ) ).

tff(addAssignment_4608,axiom,
    ! [VarCurr: state_type] :
      ( v9371(VarCurr)
    <=> v9373(VarCurr) ) ).

tff(addAssignment_4607,axiom,
    ! [VarCurr: state_type] :
      ( v9373(VarCurr)
    <=> v9375(VarCurr) ) ).

tff(addAssignment_4606,axiom,
    ! [VarCurr: state_type] :
      ( v9375(VarCurr)
    <=> v9377(VarCurr) ) ).

tff(writeUnaryOperator_598,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9377(VarCurr)
    <=> v9387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_803,axiom,
    ! [VarCurr: state_type] :
      ( v9387(VarCurr)
    <=> ( v9379(VarCurr)
        | v9383(VarCurr) ) ) ).

tff(addAssignment_4605,axiom,
    ! [VarCurr: state_type] :
      ( v9383(VarCurr)
    <=> v9385(VarCurr) ) ).

tff(addAssignment_4604,axiom,
    ! [VarCurr: state_type] :
      ( v9385(VarCurr)
    <=> v9336(VarCurr,1) ) ).

tff(addAssignment_4603,axiom,
    ! [VarCurr: state_type] :
      ( v9336(VarCurr,1)
    <=> v9338(VarCurr,1) ) ).

tff(addAssignment_4602,axiom,
    ! [VarCurr: state_type] :
      ( v9338(VarCurr,1)
    <=> v9340(VarCurr,1) ) ).

tff(addAssignment_4601,axiom,
    ! [VarCurr: state_type] :
      ( v9340(VarCurr,1)
    <=> v9345(VarCurr,1) ) ).

tff(addAssignment_4600,axiom,
    ! [VarCurr: state_type] :
      ( v9342(VarCurr,1)
    <=> v9344(VarCurr,1) ) ).

tff(addAssignment_4599,axiom,
    ! [VarCurr: state_type] :
      ( v9344(VarCurr,1)
    <=> v9288(VarCurr,1) ) ).

tff(addAssignment_4598,axiom,
    ! [VarCurr: state_type] :
      ( v9379(VarCurr)
    <=> v9381(VarCurr) ) ).

tff(addAssignment_4597,axiom,
    ! [VarCurr: state_type] :
      ( v9381(VarCurr)
    <=> v9288(VarCurr,0) ) ).

tff(addAssignment_4596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9353(VarCurr,B)
      <=> v9355(VarCurr,B) ) ) ).

tff(addAssignment_4595,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9355(VarCurr,B)
      <=> v9357(VarCurr,B) ) ) ).

tff(addAssignment_4594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9357(VarCurr,B)
      <=> v9359(VarCurr,B) ) ) ).

tff(addAssignment_4593,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9359(VarCurr,B)
      <=> v9361(VarCurr,B) ) ) ).

tff(addAssignment_4592,axiom,
    ! [VarCurr: state_type] :
      ( v9316(VarCurr)
    <=> v9318(VarCurr) ) ).

tff(addAssignment_4591,axiom,
    ! [VarCurr: state_type] :
      ( v9318(VarCurr)
    <=> v9320(VarCurr) ) ).

tff(addAssignment_4590,axiom,
    ! [VarCurr: state_type] :
      ( v9320(VarCurr)
    <=> v9322(VarCurr) ) ).

tff(addAssignment_4589,axiom,
    ! [VarCurr: state_type] :
      ( v9322(VarCurr)
    <=> v9324(VarCurr) ) ).

tff(addAssignment_4588,axiom,
    ! [VarCurr: state_type] :
      ( v9324(VarCurr)
    <=> v9326(VarCurr) ) ).

tff(addAssignment_4587,axiom,
    ! [VarCurr: state_type] :
      ( v9326(VarCurr)
    <=> v9328(VarCurr) ) ).

tff(addAssignment_4586,axiom,
    ! [VarCurr: state_type] :
      ( v9328(VarCurr)
    <=> v9330(VarCurr) ) ).

tff(writeUnaryOperator_597,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9330(VarCurr)
    <=> v9351(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_802,axiom,
    ! [VarCurr: state_type] :
      ( v9351(VarCurr)
    <=> ( v9332(VarCurr)
        | v9347(VarCurr) ) ) ).

tff(addAssignment_4585,axiom,
    ! [VarCurr: state_type] :
      ( v9347(VarCurr)
    <=> v9349(VarCurr) ) ).

tff(addAssignment_4584,axiom,
    ! [VarCurr: state_type] :
      ( v9349(VarCurr)
    <=> v9288(VarCurr,1) ) ).

tff(addAssignment_4583,axiom,
    ! [VarCurr: state_type] :
      ( v9332(VarCurr)
    <=> v9334(VarCurr) ) ).

tff(addAssignment_4582,axiom,
    ! [VarCurr: state_type] :
      ( v9334(VarCurr)
    <=> v9336(VarCurr,0) ) ).

tff(addAssignment_4581,axiom,
    ! [VarCurr: state_type] :
      ( v9336(VarCurr,0)
    <=> v9338(VarCurr,0) ) ).

tff(addAssignment_4580,axiom,
    ! [VarCurr: state_type] :
      ( v9338(VarCurr,0)
    <=> v9340(VarCurr,0) ) ).

tff(addAssignment_4579,axiom,
    ! [VarCurr: state_type] :
      ( v9340(VarCurr,0)
    <=> v9345(VarCurr,0) ) ).

tff(writeUnaryOperator_596,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v9345(VarCurr,B)
      <=> ~ v9342(VarCurr,B) ) ) ).

tff(addAssignment_4578,axiom,
    ! [VarCurr: state_type] :
      ( v9342(VarCurr,0)
    <=> v9344(VarCurr,0) ) ).

tff(addAssignment_4577,axiom,
    ! [VarCurr: state_type] :
      ( v9344(VarCurr,0)
    <=> v9288(VarCurr,0) ) ).

tff(addAssignment_4576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9306(VarCurr,B)
      <=> v9308(VarCurr,B) ) ) ).

tff(addAssignment_4575,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9308(VarCurr,B)
      <=> v9310(VarCurr,B) ) ) ).

tff(addAssignment_4574,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9310(VarCurr,B)
      <=> v9312(VarCurr,B) ) ) ).

tff(addAssignment_4573,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9312(VarCurr,B)
      <=> v9314(VarCurr,B) ) ) ).

tff(addAssignment_4572,axiom,
    ! [VarCurr: state_type] :
      ( v9268(VarCurr)
    <=> v9270(VarCurr) ) ).

tff(addAssignment_4571,axiom,
    ! [VarCurr: state_type] :
      ( v9270(VarCurr)
    <=> v9272(VarCurr) ) ).

tff(addAssignment_4570,axiom,
    ! [VarCurr: state_type] :
      ( v9272(VarCurr)
    <=> v9274(VarCurr) ) ).

tff(addAssignment_4569,axiom,
    ! [VarCurr: state_type] :
      ( v9274(VarCurr)
    <=> v9276(VarCurr) ) ).

tff(addAssignment_4568,axiom,
    ! [VarCurr: state_type] :
      ( v9276(VarCurr)
    <=> v9278(VarCurr) ) ).

tff(addAssignment_4567,axiom,
    ! [VarCurr: state_type] :
      ( v9278(VarCurr)
    <=> v9280(VarCurr) ) ).

tff(addAssignment_4566,axiom,
    ! [VarCurr: state_type] :
      ( v9280(VarCurr)
    <=> v9282(VarCurr) ) ).

tff(writeUnaryOperator_595,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9282(VarCurr)
    <=> v9304(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_801,axiom,
    ! [VarCurr: state_type] :
      ( v9304(VarCurr)
    <=> ( v9284(VarCurr)
        | v9300(VarCurr) ) ) ).

tff(addAssignment_4565,axiom,
    ! [VarCurr: state_type] :
      ( v9300(VarCurr)
    <=> v9302(VarCurr) ) ).

tff(addAssignment_4564,axiom,
    ! [VarCurr: state_type] :
      ( v9302(VarCurr)
    <=> v9288(VarCurr,1) ) ).

tff(addAssignment_4563,axiom,
    ! [VarCurr: state_type] :
      ( v9288(VarCurr,1)
    <=> v9290(VarCurr,1) ) ).

tff(addAssignment_4562,axiom,
    ! [VarCurr: state_type] :
      ( v9290(VarCurr,1)
    <=> v9292(VarCurr,1) ) ).

tff(addAssignment_4561,axiom,
    ! [VarCurr: state_type] :
      ( v9292(VarCurr,1)
    <=> v9294(VarCurr,1) ) ).

tff(addAssignment_4560,axiom,
    ! [VarCurr: state_type] :
      ( v9294(VarCurr,1)
    <=> v9296(VarCurr,1) ) ).

tff(addAssignment_4559,axiom,
    ! [VarCurr: state_type] :
      ( v9296(VarCurr,1)
    <=> v9298(VarCurr,1) ) ).

tff(addAssignment_4558,axiom,
    ! [VarCurr: state_type] :
      ( v9284(VarCurr)
    <=> v9286(VarCurr) ) ).

tff(addAssignment_4557,axiom,
    ! [VarCurr: state_type] :
      ( v9286(VarCurr)
    <=> v9288(VarCurr,0) ) ).

tff(addAssignment_4556,axiom,
    ! [VarCurr: state_type] :
      ( v9288(VarCurr,0)
    <=> v9290(VarCurr,0) ) ).

tff(addAssignment_4555,axiom,
    ! [VarCurr: state_type] :
      ( v9290(VarCurr,0)
    <=> v9292(VarCurr,0) ) ).

tff(addAssignment_4554,axiom,
    ! [VarCurr: state_type] :
      ( v9292(VarCurr,0)
    <=> v9294(VarCurr,0) ) ).

tff(addAssignment_4553,axiom,
    ! [VarCurr: state_type] :
      ( v9294(VarCurr,0)
    <=> v9296(VarCurr,0) ) ).

tff(addAssignment_4552,axiom,
    ! [VarCurr: state_type] :
      ( v9296(VarCurr,0)
    <=> v9298(VarCurr,0) ) ).

tff(addAssignment_4551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9258(VarCurr,B)
      <=> v9260(VarCurr,B) ) ) ).

tff(addAssignment_4550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9260(VarCurr,B)
      <=> v9262(VarCurr,B) ) ) ).

tff(addAssignment_4549,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9262(VarCurr,B)
      <=> v9264(VarCurr,B) ) ) ).

tff(addAssignment_4548,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9264(VarCurr,B)
      <=> v9266(VarCurr,B) ) ) ).

tff(addAssignment_4547,axiom,
    ! [VarCurr: state_type] :
      ( v9236(VarCurr)
    <=> v9238(VarCurr) ) ).

tff(addAssignment_4546,axiom,
    ! [VarCurr: state_type] :
      ( v9238(VarCurr)
    <=> v9240(VarCurr) ) ).

tff(addAssignment_4545,axiom,
    ! [VarCurr: state_type] :
      ( v9240(VarCurr)
    <=> v9242(VarCurr) ) ).

tff(addAssignment_4544,axiom,
    ! [VarCurr: state_type] :
      ( v9242(VarCurr)
    <=> v9244(VarCurr) ) ).

tff(addAssignment_4543,axiom,
    ! [VarCurr: state_type] :
      ( v9244(VarCurr)
    <=> v9246(VarCurr) ) ).

tff(addAssignment_4542,axiom,
    ! [VarCurr: state_type] :
      ( v9246(VarCurr)
    <=> v9248(VarCurr) ) ).

tff(addAssignment_4541,axiom,
    ! [VarCurr: state_type] :
      ( v9248(VarCurr)
    <=> v9250(VarCurr) ) ).

tff(addAssignment_4540,axiom,
    ! [VarCurr: state_type] :
      ( v9250(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_4539,axiom,
    ! [VarCurr: state_type] :
      ( v9220(VarCurr)
    <=> v9222(VarCurr) ) ).

tff(addAssignment_4538,axiom,
    ! [VarCurr: state_type] :
      ( v9222(VarCurr)
    <=> v9224(VarCurr) ) ).

tff(addAssignment_4537,axiom,
    ! [VarCurr: state_type] :
      ( v9224(VarCurr)
    <=> v9226(VarCurr) ) ).

tff(addAssignment_4536,axiom,
    ! [VarCurr: state_type] :
      ( v9226(VarCurr)
    <=> v9228(VarCurr) ) ).

tff(addAssignment_4535,axiom,
    ! [VarCurr: state_type] :
      ( v9228(VarCurr)
    <=> v9230(VarCurr) ) ).

tff(addAssignment_4534,axiom,
    ! [VarCurr: state_type] :
      ( v9230(VarCurr)
    <=> v9232(VarCurr) ) ).

tff(addAssignment_4533,axiom,
    ! [VarCurr: state_type] :
      ( v9232(VarCurr)
    <=> v9234(VarCurr) ) ).

tff(addAssignment_4532,axiom,
    ! [VarCurr: state_type] :
      ( v9234(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_4531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9157(VarCurr,B)
      <=> v9159(VarCurr,B) ) ) ).

tff(addAssignment_4530,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,0)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4529,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,1)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4528,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,2)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4527,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,3)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4526,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,4)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4525,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,5)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4524,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,6)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4523,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,7)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4522,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,8)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4521,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,9)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4520,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,10)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4519,axiom,
    ! [VarCurr: state_type] :
      ( v9159(VarCurr,11)
    <=> v9190(VarCurr) ) ).

tff(addAssignment_4518,axiom,
    ! [VarCurr: state_type] :
      ( v9190(VarCurr)
    <=> v9161(VarCurr) ) ).

tff(addAssignment_4517,axiom,
    ! [VarCurr: state_type] :
      ( v9161(VarCurr)
    <=> v9163(VarCurr,0) ) ).

tff(addAssignment_4516,axiom,
    ! [VarCurr: state_type] :
      ( v9163(VarCurr,0)
    <=> v9165(VarCurr,0) ) ).

tff(addAssignment_4515,axiom,
    ! [VarCurr: state_type] :
      ( v9165(VarCurr,0)
    <=> v9188(VarCurr,0) ) ).

tff(writeUnaryOperator_594,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v9188(VarCurr,B)
      <=> ~ v9167(VarCurr,B) ) ) ).

tff(addAssignment_4514,axiom,
    ! [VarCurr: state_type] :
      ( v9167(VarCurr,0)
    <=> v9169(VarCurr,0) ) ).

tff(addAssignment_4513,axiom,
    ! [VarCurr: state_type] :
      ( v9169(VarCurr,0)
    <=> v9185(VarCurr,0) ) ).

tff(addAssignment_4512,axiom,
    ! [VarCurr: state_type] :
      ( v9185(VarCurr,0)
    <=> v9171(VarCurr) ) ).

tff(addAssignment_4511,axiom,
    ! [VarCurr: state_type] :
      ( v9185(VarCurr,1)
    <=> v9187(VarCurr) ) ).

tff(addAssignment_4510,axiom,
    ! [VarCurr: state_type] :
      ( v9185(VarCurr,2)
    <=> v9186(VarCurr) ) ).

tff(addAssignment_4509,axiom,
    ! [VarCurr: state_type] :
      ( v9171(VarCurr)
    <=> v9173(VarCurr) ) ).

tff(addAssignment_4508,axiom,
    ! [VarCurr: state_type] :
      ( v9173(VarCurr)
    <=> v9175(VarCurr) ) ).

tff(addAssignment_4507,axiom,
    ! [VarCurr: state_type] :
      ( v9175(VarCurr)
    <=> v9177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_800,axiom,
    ! [VarCurr: state_type] :
      ( v9177(VarCurr)
    <=> ( v9179(VarCurr)
        & v9184(VarCurr) ) ) ).

tff(writeUnaryOperator_593,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9184(VarCurr)
    <=> v8422(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_799,axiom,
    ! [VarCurr: state_type] :
      ( v9179(VarCurr)
    <=> ( v9180(VarCurr)
        & v9183(VarCurr) ) ) ).

tff(writeUnaryOperator_592,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9183(VarCurr)
    <=> v8312(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_798,axiom,
    ! [VarCurr: state_type] :
      ( v9180(VarCurr)
    <=> ( v9181(VarCurr)
        & v9182(VarCurr) ) ) ).

tff(writeUnaryOperator_591,axiom,
    ! [VarCurr: state_type] :
      ( ~ v9182(VarCurr)
    <=> v5037(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_84,axiom,
    ! [VarCurr: state_type] :
      ( v9181(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_4506,axiom,
    ! [VarCurr: state_type] :
      ( v9131(VarCurr)
    <=> v9133(VarCurr) ) ).

tff(addAssignment_4505,axiom,
    ! [VarCurr: state_type] :
      ( v9133(VarCurr)
    <=> v9135(VarCurr) ) ).

tff(addAssignment_4504,axiom,
    ! [VarCurr: state_type] :
      ( v9135(VarCurr)
    <=> v9137(VarCurr) ) ).

tff(addAssignment_4503,axiom,
    ! [VarCurr: state_type] :
      ( v9137(VarCurr)
    <=> v9139(VarCurr) ) ).

tff(addAssignment_4502,axiom,
    ! [VarCurr: state_type] :
      ( v9139(VarCurr)
    <=> v9141(VarCurr) ) ).

tff(addAssignment_4501,axiom,
    ! [VarCurr: state_type] :
      ( v9141(VarCurr)
    <=> v9143(VarCurr) ) ).

tff(addAssignment_4500,axiom,
    ! [VarCurr: state_type] :
      ( v9143(VarCurr)
    <=> v9145(VarCurr) ) ).

tff(addAssignment_4499,axiom,
    ! [VarCurr: state_type] :
      ( v9145(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_4498,axiom,
    ! [VarCurr: state_type] :
      ( v9115(VarCurr)
    <=> v9117(VarCurr) ) ).

tff(addAssignment_4497,axiom,
    ! [VarCurr: state_type] :
      ( v9117(VarCurr)
    <=> v9119(VarCurr) ) ).

tff(addAssignment_4496,axiom,
    ! [VarCurr: state_type] :
      ( v9119(VarCurr)
    <=> v9121(VarCurr) ) ).

tff(addAssignment_4495,axiom,
    ! [VarCurr: state_type] :
      ( v9121(VarCurr)
    <=> v9123(VarCurr) ) ).

tff(addAssignment_4494,axiom,
    ! [VarCurr: state_type] :
      ( v9123(VarCurr)
    <=> v9125(VarCurr) ) ).

tff(addAssignment_4493,axiom,
    ! [VarCurr: state_type] :
      ( v9125(VarCurr)
    <=> v9127(VarCurr) ) ).

tff(addAssignment_4492,axiom,
    ! [VarCurr: state_type] :
      ( v9127(VarCurr)
    <=> v9129(VarCurr) ) ).

tff(addAssignment_4491,axiom,
    ! [VarCurr: state_type] :
      ( v9129(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_4490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9091(VarCurr,B)
      <=> v9093(VarCurr,B) ) ) ).

tff(addAssignment_4489,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v9093(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_4488,axiom,
    ! [VarCurr: state_type] :
      ( v9051(VarCurr,1)
    <=> v9053(VarCurr,1) ) ).

tff(addAssignment_4487,axiom,
    ! [VarCurr: state_type] :
      ( v9053(VarCurr,1)
    <=> v9054(VarCurr,1) ) ).

tff(addAssignment_4486,axiom,
    ! [VarCurr: state_type] :
      ( v9054(VarCurr,0)
    <=> v9055(VarCurr) ) ).

tff(addAssignment_4485,axiom,
    ! [VarCurr: state_type] :
      ( v9054(VarCurr,1)
    <=> v9055(VarCurr) ) ).

tff(addAssignment_4484,axiom,
    ! [VarCurr: state_type] :
      ( v9055(VarCurr)
    <=> v8578(VarCurr) ) ).

tff(addAssignment_4483,axiom,
    ! [VarCurr: state_type] :
      ( v9020(VarCurr)
    <=> v9022(VarCurr) ) ).

tff(addAssignment_4482,axiom,
    ! [VarCurr: state_type] :
      ( v9022(VarCurr)
    <=> v9024(VarCurr) ) ).

tff(addAssignment_4481,axiom,
    ! [VarCurr: state_type] :
      ( v9024(VarCurr)
    <=> v9026(VarCurr) ) ).

tff(addAssignment_4480,axiom,
    ! [VarCurr: state_type] :
      ( v9026(VarCurr)
    <=> v9028(VarCurr) ) ).

tff(addAssignment_4479,axiom,
    ! [VarCurr: state_type] :
      ( v9028(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_4478,axiom,
    ! [VarCurr: state_type] :
      ( v9008(VarCurr)
    <=> v9010(VarCurr) ) ).

tff(addAssignment_4477,axiom,
    ! [VarCurr: state_type] :
      ( v9010(VarCurr)
    <=> v9012(VarCurr) ) ).

tff(addAssignment_4476,axiom,
    ! [VarCurr: state_type] :
      ( v9012(VarCurr)
    <=> v9014(VarCurr) ) ).

tff(addAssignment_4475,axiom,
    ! [VarCurr: state_type] :
      ( v9014(VarCurr)
    <=> v9016(VarCurr) ) ).

tff(addAssignment_4474,axiom,
    ! [VarCurr: state_type] :
      ( v9016(VarCurr)
    <=> v9018(VarCurr) ) ).

tff(addAssignment_4473,axiom,
    ! [VarCurr: state_type] :
      ( v9018(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_4472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8516(VarCurr,B)
      <=> v8518(VarCurr,B) ) ) ).

tff(addAssignment_4471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8518(VarCurr,B)
      <=> v8520(VarCurr,B) ) ) ).

tff(addAssignment_4470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8520(VarCurr,B)
      <=> v8522(VarCurr,B) ) ) ).

tff(addAssignment_4469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8522(VarCurr,B)
      <=> v8524(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8969(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8524(VarNext,B)
            <=> v8524(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_109,axiom,
    ! [VarNext: state_type] :
      ( v8969(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8524(VarNext,B)
          <=> v8979(VarNext,B) ) ) ) ).

tff(addAssignment_4468,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8979(VarNext,B)
          <=> v8977(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_93,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8980(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8977(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_93,axiom,
    ! [VarCurr: state_type] :
      ( v8980(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8977(VarCurr,B)
          <=> v8554(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_797,axiom,
    ! [VarCurr: state_type] :
      ( v8980(VarCurr)
    <=> ( v8981(VarCurr)
        & v8982(VarCurr) ) ) ).

tff(writeUnaryOperator_590,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8982(VarCurr)
    <=> v8540(VarCurr) ) ).

tff(writeUnaryOperator_589,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8981(VarCurr)
    <=> v8526(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_796,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8969(VarNext)
      <=> v8970(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_795,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8970(VarNext)
      <=> ( v8971(VarNext)
          & v8884(VarNext) ) ) ) ).

tff(writeUnaryOperator_588,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8971(VarNext)
      <=> v8973(VarNext) ) ) ).

tff(addAssignment_4467,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8973(VarNext)
      <=> v8884(VarCurr) ) ) ).

tff(addAssignment_4466,axiom,
    ! [VarCurr: state_type] :
      ( v8884(VarCurr)
    <=> v8886(VarCurr) ) ).

tff(addAssignment_4465,axiom,
    ! [VarCurr: state_type] :
      ( v8886(VarCurr)
    <=> v8888(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_794,axiom,
    ! [VarCurr: state_type] :
      ( v8888(VarCurr)
    <=> ( v8966(VarCurr)
        | v8958(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_793,axiom,
    ! [VarCurr: state_type] :
      ( v8966(VarCurr)
    <=> ( v8890(VarCurr)
        & v8896(VarCurr) ) ) ).

tff(addAssignment_4464,axiom,
    ! [VarCurr: state_type] :
      ( v8958(VarCurr)
    <=> v8960(VarCurr) ) ).

tff(addAssignment_4463,axiom,
    ! [VarCurr: state_type] :
      ( v8960(VarCurr)
    <=> v8962(VarCurr) ) ).

tff(addAssignment_4462,axiom,
    ! [VarCurr: state_type] :
      ( v8962(VarCurr)
    <=> v8964(VarCurr) ) ).

tff(addAssignment_4461,axiom,
    ! [VarCurr: state_type] :
      ( v8964(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8942(VarNext)
       => ( v8896(VarNext)
        <=> v8896(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_108,axiom,
    ! [VarNext: state_type] :
      ( v8942(VarNext)
     => ( v8896(VarNext)
      <=> v8952(VarNext) ) ) ).

tff(addAssignment_4460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8952(VarNext)
      <=> v8950(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_792,axiom,
    ! [VarCurr: state_type] :
      ( v8950(VarCurr)
    <=> ( v8953(VarCurr)
        & v8954(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_791,axiom,
    ! [VarCurr: state_type] :
      ( v8954(VarCurr)
    <=> ( v8902(VarCurr)
        | v8933(VarCurr) ) ) ).

tff(writeUnaryOperator_587,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8953(VarCurr)
    <=> v8898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_790,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8942(VarNext)
      <=> v8943(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_789,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8943(VarNext)
      <=> ( v8945(VarNext)
          & v8947(VarNext) ) ) ) ).

tff(writeUnaryOperator_586,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8947(VarCurr)
    <=> v8890(VarCurr) ) ).

tff(addAssignment_4459,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8945(VarNext)
      <=> v8890(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_23,axiom,
    ( v8896(constB0)
  <=> $true ) ).

tff(addAssignment_4458,axiom,
    ! [VarCurr: state_type] :
      ( v8933(VarCurr)
    <=> v8935(VarCurr) ) ).

tff(addAssignment_4457,axiom,
    ! [VarCurr: state_type] :
      ( v8935(VarCurr)
    <=> v8937(VarCurr) ) ).

tff(addAssignment_4456,axiom,
    ! [VarCurr: state_type] :
      ( v8937(VarCurr)
    <=> v8939(VarCurr) ) ).

tff(addAssignment_4455,axiom,
    ! [VarCurr: state_type] :
      ( v8939(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_4454,axiom,
    ! [VarCurr: state_type] :
      ( v8902(VarCurr)
    <=> v8904(VarCurr) ) ).

tff(addAssignment_4453,axiom,
    ! [VarCurr: state_type] :
      ( v8904(VarCurr)
    <=> v8906(VarCurr) ) ).

tff(addAssignment_4452,axiom,
    ! [VarCurr: state_type] :
      ( v8906(VarCurr)
    <=> v8908(VarCurr) ) ).

tff(addAssignment_4451,axiom,
    ! [VarCurr: state_type] :
      ( v8908(VarCurr)
    <=> v8910(VarCurr) ) ).

tff(writeUnaryOperator_585,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8910(VarCurr)
    <=> v8930(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_788,axiom,
    ! [VarCurr: state_type] :
      ( v8930(VarCurr)
    <=> ( v8931(VarCurr)
        | v8926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_787,axiom,
    ! [VarCurr: state_type] :
      ( v8931(VarCurr)
    <=> ( v8912(VarCurr)
        | v8922(VarCurr) ) ) ).

tff(addAssignment_4450,axiom,
    ! [VarCurr: state_type] :
      ( v8926(VarCurr)
    <=> v8928(VarCurr) ) ).

tff(addAssignment_4449,axiom,
    ! [VarCurr: state_type] :
      ( v8928(VarCurr)
    <=> v8916(VarCurr,2) ) ).

tff(addAssignment_4448,axiom,
    ! [VarCurr: state_type] :
      ( v8916(VarCurr,2)
    <=> v8918(VarCurr,2) ) ).

tff(addAssignment_4447,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,2)
    <=> v8920(VarCurr,2) ) ).

tff(addAssignment_4446,axiom,
    ! [VarCurr: state_type] :
      ( v8922(VarCurr)
    <=> v8924(VarCurr) ) ).

tff(addAssignment_4445,axiom,
    ! [VarCurr: state_type] :
      ( v8924(VarCurr)
    <=> v8916(VarCurr,1) ) ).

tff(addAssignment_4444,axiom,
    ! [VarCurr: state_type] :
      ( v8916(VarCurr,1)
    <=> v8918(VarCurr,1) ) ).

tff(addAssignment_4443,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,1)
    <=> v8920(VarCurr,1) ) ).

tff(addAssignment_4442,axiom,
    ! [VarCurr: state_type] :
      ( v8912(VarCurr)
    <=> v8914(VarCurr) ) ).

tff(addAssignment_4441,axiom,
    ! [VarCurr: state_type] :
      ( v8914(VarCurr)
    <=> v8916(VarCurr,0) ) ).

tff(addAssignment_4440,axiom,
    ! [VarCurr: state_type] :
      ( v8916(VarCurr,0)
    <=> v8918(VarCurr,0) ) ).

tff(addAssignment_4439,axiom,
    ! [VarCurr: state_type] :
      ( v8918(VarCurr,0)
    <=> v8920(VarCurr,0) ) ).

tff(addAssignment_4438,axiom,
    ! [VarCurr: state_type] :
      ( v8898(VarCurr)
    <=> v8900(VarCurr) ) ).

tff(addAssignment_4437,axiom,
    ! [VarCurr: state_type] :
      ( v8900(VarCurr)
    <=> $false ) ).

tff(addAssignment_4436,axiom,
    ! [VarCurr: state_type] :
      ( v8890(VarCurr)
    <=> v8892(VarCurr) ) ).

tff(addAssignment_4435,axiom,
    ! [VarCurr: state_type] :
      ( v8892(VarCurr)
    <=> v8894(VarCurr) ) ).

tff(addAssignment_4434,axiom,
    ! [VarCurr: state_type] :
      ( v8894(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_4433,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8554(VarCurr,B)
      <=> v8556(VarCurr,B) ) ) ).

tff(addAssignment_4432,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8556(VarCurr,B)
      <=> v8558(VarCurr,B) ) ) ).

tff(addAssignment_4431,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8558(VarCurr,B)
      <=> v8560(VarCurr,B) ) ) ).

tff(addAssignment_4430,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8560(VarCurr,B)
      <=> v8562(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_160,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8562(VarCurr,B)
      <=> ( v8564(VarCurr,B)
          & v8586(VarCurr,B) ) ) ) ).

tff(addAssignment_4429,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8586(VarCurr,B)
      <=> v8588(VarCurr,B) ) ) ).

tff(addAssignment_4428,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8588(VarCurr,B)
      <=> v8590(VarCurr,B) ) ) ).

tff(addAssignment_4427,axiom,
    ! [VarCurr: state_type] :
      ( ( v8590(VarCurr,11)
      <=> v6324(VarCurr,35) )
      & ( v8590(VarCurr,10)
      <=> v6324(VarCurr,34) )
      & ( v8590(VarCurr,9)
      <=> v6324(VarCurr,33) )
      & ( v8590(VarCurr,8)
      <=> v6324(VarCurr,32) )
      & ( v8590(VarCurr,7)
      <=> v6324(VarCurr,31) )
      & ( v8590(VarCurr,6)
      <=> v6324(VarCurr,30) )
      & ( v8590(VarCurr,5)
      <=> v6324(VarCurr,29) )
      & ( v8590(VarCurr,4)
      <=> v6324(VarCurr,28) )
      & ( v8590(VarCurr,3)
      <=> v6324(VarCurr,27) )
      & ( v8590(VarCurr,2)
      <=> v6324(VarCurr,26) )
      & ( v8590(VarCurr,1)
      <=> v6324(VarCurr,25) )
      & ( v8590(VarCurr,0)
      <=> v6324(VarCurr,24) ) ) ).

tff(addAssignment_4426,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,35)
      <=> v8592(VarCurr,11) )
      & ( v6324(VarCurr,34)
      <=> v8592(VarCurr,10) )
      & ( v6324(VarCurr,33)
      <=> v8592(VarCurr,9) )
      & ( v6324(VarCurr,32)
      <=> v8592(VarCurr,8) )
      & ( v6324(VarCurr,31)
      <=> v8592(VarCurr,7) )
      & ( v6324(VarCurr,30)
      <=> v8592(VarCurr,6) )
      & ( v6324(VarCurr,29)
      <=> v8592(VarCurr,5) )
      & ( v6324(VarCurr,28)
      <=> v8592(VarCurr,4) )
      & ( v6324(VarCurr,27)
      <=> v8592(VarCurr,3) )
      & ( v6324(VarCurr,26)
      <=> v8592(VarCurr,2) )
      & ( v6324(VarCurr,25)
      <=> v8592(VarCurr,1) )
      & ( v6324(VarCurr,24)
      <=> v8592(VarCurr,0) ) ) ).

tff(addAssignment_4425,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8592(VarCurr,B)
      <=> v8594(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8594(VarCurr,B)
      <=> ( v8876(VarCurr,B)
          | v8879(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8879(VarCurr,B)
      <=> ( v8604(VarCurr,B)
          & v8880(VarCurr,B) ) ) ) ).

tff(addAssignment_4424,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,0)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4423,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,1)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4422,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,2)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4421,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,3)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4420,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,4)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4419,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,5)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4418,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,6)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4417,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,7)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4416,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,8)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4415,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,9)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4414,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,10)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4413,axiom,
    ! [VarCurr: state_type] :
      ( v8880(VarCurr,11)
    <=> v8881(VarCurr) ) ).

tff(addAssignment_4412,axiom,
    ! [VarCurr: state_type] :
      ( v8881(VarCurr)
    <=> v8872(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_157,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8876(VarCurr,B)
      <=> ( v8596(VarCurr,B)
          & v8877(VarCurr,B) ) ) ) ).

tff(addAssignment_4411,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,0)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4410,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,1)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4409,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,2)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4408,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,3)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4407,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,4)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4406,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,5)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4405,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,6)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4404,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,7)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4403,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,8)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4402,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,9)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4401,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,10)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4400,axiom,
    ! [VarCurr: state_type] :
      ( v8877(VarCurr,11)
    <=> v8878(VarCurr) ) ).

tff(addAssignment_4399,axiom,
    ! [VarCurr: state_type] :
      ( v8878(VarCurr)
    <=> v8600(VarCurr) ) ).

tff(addAssignment_4398,axiom,
    ! [VarCurr: state_type] :
      ( v8872(VarCurr)
    <=> v8874(VarCurr) ) ).

tff(addAssignment_4397,axiom,
    ! [VarCurr: state_type] :
      ( v8874(VarCurr)
    <=> v7021(VarCurr,2) ) ).

tff(addAssignment_4396,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,2)
    <=> v7023(VarCurr,2) ) ).

tff(addAssignment_4395,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,2)
    <=> v6623(VarCurr,2) ) ).

tff(addAssignment_4394,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8604(VarCurr,B)
      <=> v8606(VarCurr,B) ) ) ).

tff(addAssignment_4393,axiom,
    ! [VarCurr: state_type] :
      ( ( v8606(VarCurr,11)
      <=> v6334(VarCurr,47) )
      & ( v8606(VarCurr,10)
      <=> v6334(VarCurr,46) )
      & ( v8606(VarCurr,9)
      <=> v6334(VarCurr,45) )
      & ( v8606(VarCurr,8)
      <=> v6334(VarCurr,44) )
      & ( v8606(VarCurr,7)
      <=> v6334(VarCurr,43) )
      & ( v8606(VarCurr,6)
      <=> v6334(VarCurr,42) )
      & ( v8606(VarCurr,5)
      <=> v6334(VarCurr,41) )
      & ( v8606(VarCurr,4)
      <=> v6334(VarCurr,40) )
      & ( v8606(VarCurr,3)
      <=> v6334(VarCurr,39) )
      & ( v8606(VarCurr,2)
      <=> v6334(VarCurr,38) )
      & ( v8606(VarCurr,1)
      <=> v6334(VarCurr,37) )
      & ( v8606(VarCurr,0)
      <=> v6334(VarCurr,36) ) ) ).

tff(addAssignment_4392,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,36) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_4391,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,48)
        & ~ $less(B,36) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_4390,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,47)
      <=> v8608(VarCurr,11) )
      & ( v6338(VarCurr,46)
      <=> v8608(VarCurr,10) )
      & ( v6338(VarCurr,45)
      <=> v8608(VarCurr,9) )
      & ( v6338(VarCurr,44)
      <=> v8608(VarCurr,8) )
      & ( v6338(VarCurr,43)
      <=> v8608(VarCurr,7) )
      & ( v6338(VarCurr,42)
      <=> v8608(VarCurr,6) )
      & ( v6338(VarCurr,41)
      <=> v8608(VarCurr,5) )
      & ( v6338(VarCurr,40)
      <=> v8608(VarCurr,4) )
      & ( v6338(VarCurr,39)
      <=> v8608(VarCurr,3) )
      & ( v6338(VarCurr,38)
      <=> v8608(VarCurr,2) )
      & ( v6338(VarCurr,37)
      <=> v8608(VarCurr,1) )
      & ( v6338(VarCurr,36)
      <=> v8608(VarCurr,0) ) ) ).

tff(addAssignment_4389,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8608(VarCurr,B)
      <=> v8610(VarCurr,B) ) ) ).

tff(addAssignment_4388,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8610(VarCurr,B)
      <=> v8612(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_107,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8855(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8612(VarNext,B)
            <=> v8612(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_107,axiom,
    ! [VarNext: state_type] :
      ( v8855(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8612(VarNext,B)
          <=> v8865(VarNext,B) ) ) ) ).

tff(addAssignment_4387,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8865(VarNext,B)
          <=> v8863(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_92,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8866(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8863(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_92,axiom,
    ! [VarCurr: state_type] :
      ( v8866(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8863(VarCurr,B)
          <=> v8642(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_786,axiom,
    ! [VarCurr: state_type] :
      ( v8866(VarCurr)
    <=> ( v8867(VarCurr)
        & v8868(VarCurr) ) ) ).

tff(writeUnaryOperator_584,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8868(VarCurr)
    <=> v8628(VarCurr) ) ).

tff(writeUnaryOperator_583,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8867(VarCurr)
    <=> v8614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8855(VarNext)
      <=> v8856(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_784,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8856(VarNext)
      <=> ( v8857(VarNext)
          & v8830(VarNext) ) ) ) ).

tff(writeUnaryOperator_582,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8857(VarNext)
      <=> v8859(VarNext) ) ) ).

tff(addAssignment_4386,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8859(VarNext)
      <=> v8830(VarCurr) ) ) ).

tff(addAssignment_4385,axiom,
    ! [VarCurr: state_type] :
      ( v8830(VarCurr)
    <=> v8832(VarCurr) ) ).

tff(addAssignment_4384,axiom,
    ! [VarCurr: state_type] :
      ( v8832(VarCurr)
    <=> v8834(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_783,axiom,
    ! [VarCurr: state_type] :
      ( v8834(VarCurr)
    <=> ( v8852(VarCurr)
        | v8844(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_782,axiom,
    ! [VarCurr: state_type] :
      ( v8852(VarCurr)
    <=> ( v8836(VarCurr)
        & v8842(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_22,axiom,
    ( v8842(constB0)
  <=> $true ) ).

tff(addAssignment_4383,axiom,
    ! [VarCurr: state_type] :
      ( v8844(VarCurr)
    <=> v8846(VarCurr) ) ).

tff(addAssignment_4382,axiom,
    ! [VarCurr: state_type] :
      ( v8846(VarCurr)
    <=> v8848(VarCurr) ) ).

tff(addAssignment_4381,axiom,
    ! [VarCurr: state_type] :
      ( v8848(VarCurr)
    <=> v8850(VarCurr) ) ).

tff(addAssignment_4380,axiom,
    ! [VarCurr: state_type] :
      ( v8850(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_4379,axiom,
    ! [VarCurr: state_type] :
      ( v8836(VarCurr)
    <=> v8838(VarCurr) ) ).

tff(addAssignment_4378,axiom,
    ! [VarCurr: state_type] :
      ( v8838(VarCurr)
    <=> v8840(VarCurr) ) ).

tff(addAssignment_4377,axiom,
    ! [VarCurr: state_type] :
      ( v8840(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_4376,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8642(VarCurr,B)
      <=> v8644(VarCurr,B) ) ) ).

tff(addAssignment_4375,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8644(VarCurr,B)
      <=> v8646(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_156,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8646(VarCurr,B)
      <=> ( v8815(VarCurr,B)
          | v8826(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_155,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8826(VarCurr,B)
      <=> ( v8779(VarCurr,B)
          & v8827(VarCurr,B) ) ) ) ).

tff(addAssignment_4374,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,0)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4373,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,1)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4372,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,2)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4371,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,3)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4370,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,4)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4369,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,5)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4368,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,6)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4367,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,7)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4366,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,8)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4365,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,9)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4364,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,10)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4363,axiom,
    ! [VarCurr: state_type] :
      ( v8827(VarCurr,11)
    <=> v8828(VarCurr) ) ).

tff(addAssignment_4362,axiom,
    ! [VarCurr: state_type] :
      ( v8828(VarCurr)
    <=> v8789(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8815(VarCurr,B)
      <=> ( v8816(VarCurr,B)
          | v8823(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_153,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8823(VarCurr,B)
      <=> ( v8743(VarCurr,B)
          & v8824(VarCurr,B) ) ) ) ).

tff(addAssignment_4361,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,0)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4360,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,1)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4359,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,2)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4358,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,3)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4357,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,4)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4356,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,5)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4355,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,6)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4354,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,7)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4353,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,8)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4352,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,9)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4351,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,10)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4350,axiom,
    ! [VarCurr: state_type] :
      ( v8824(VarCurr,11)
    <=> v8825(VarCurr) ) ).

tff(addAssignment_4349,axiom,
    ! [VarCurr: state_type] :
      ( v8825(VarCurr)
    <=> v8753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_152,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8816(VarCurr,B)
      <=> ( v8817(VarCurr,B)
          | v8820(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_151,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8820(VarCurr,B)
      <=> ( v8696(VarCurr,B)
          & v8821(VarCurr,B) ) ) ) ).

tff(addAssignment_4348,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,0)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4347,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,1)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4346,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,2)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4345,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,3)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4344,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,4)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4343,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,5)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4342,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,6)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4341,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,7)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4340,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,8)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4339,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,9)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4338,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,10)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4337,axiom,
    ! [VarCurr: state_type] :
      ( v8821(VarCurr,11)
    <=> v8822(VarCurr) ) ).

tff(addAssignment_4336,axiom,
    ! [VarCurr: state_type] :
      ( v8822(VarCurr)
    <=> v8706(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_150,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8817(VarCurr,B)
      <=> ( v8648(VarCurr,B)
          & v8818(VarCurr,B) ) ) ) ).

tff(addAssignment_4335,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,0)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4334,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,1)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4333,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,2)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4332,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,3)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4331,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,4)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4330,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,5)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4329,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,6)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4328,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,7)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4327,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,8)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4326,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,9)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4325,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,10)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4324,axiom,
    ! [VarCurr: state_type] :
      ( v8818(VarCurr,11)
    <=> v8819(VarCurr) ) ).

tff(addAssignment_4323,axiom,
    ! [VarCurr: state_type] :
      ( v8819(VarCurr)
    <=> v8658(VarCurr) ) ).

tff(addAssignment_4322,axiom,
    ! [VarCurr: state_type] :
      ( v8789(VarCurr)
    <=> v8791(VarCurr) ) ).

tff(addAssignment_4321,axiom,
    ! [VarCurr: state_type] :
      ( v8791(VarCurr)
    <=> v8793(VarCurr) ) ).

tff(addAssignment_4320,axiom,
    ! [VarCurr: state_type] :
      ( v8793(VarCurr)
    <=> v8795(VarCurr) ) ).

tff(addAssignment_4319,axiom,
    ! [VarCurr: state_type] :
      ( v8795(VarCurr)
    <=> v8797(VarCurr) ) ).

tff(addAssignment_4318,axiom,
    ! [VarCurr: state_type] :
      ( v8797(VarCurr)
    <=> v8799(VarCurr) ) ).

tff(addAssignment_4317,axiom,
    ! [VarCurr: state_type] :
      ( v8799(VarCurr)
    <=> v8801(VarCurr) ) ).

tff(addAssignment_4316,axiom,
    ! [VarCurr: state_type] :
      ( v8801(VarCurr)
    <=> v8803(VarCurr) ) ).

tff(writeUnaryOperator_581,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8803(VarCurr)
    <=> v8813(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_781,axiom,
    ! [VarCurr: state_type] :
      ( v8813(VarCurr)
    <=> ( v8805(VarCurr)
        | v8809(VarCurr) ) ) ).

tff(addAssignment_4315,axiom,
    ! [VarCurr: state_type] :
      ( v8809(VarCurr)
    <=> v8811(VarCurr) ) ).

tff(addAssignment_4314,axiom,
    ! [VarCurr: state_type] :
      ( v8811(VarCurr)
    <=> v8726(VarCurr,1) ) ).

tff(addAssignment_4313,axiom,
    ! [VarCurr: state_type] :
      ( v8805(VarCurr)
    <=> v8807(VarCurr) ) ).

tff(addAssignment_4312,axiom,
    ! [VarCurr: state_type] :
      ( v8807(VarCurr)
    <=> v8726(VarCurr,0) ) ).

tff(addAssignment_4311,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8779(VarCurr,B)
      <=> v8781(VarCurr,B) ) ) ).

tff(addAssignment_4310,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8781(VarCurr,B)
      <=> v8783(VarCurr,B) ) ) ).

tff(addAssignment_4309,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8783(VarCurr,B)
      <=> v8785(VarCurr,B) ) ) ).

tff(addAssignment_4308,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8785(VarCurr,B)
      <=> v8787(VarCurr,B) ) ) ).

tff(addAssignment_4307,axiom,
    ! [VarCurr: state_type] :
      ( v8753(VarCurr)
    <=> v8755(VarCurr) ) ).

tff(addAssignment_4306,axiom,
    ! [VarCurr: state_type] :
      ( v8755(VarCurr)
    <=> v8757(VarCurr) ) ).

tff(addAssignment_4305,axiom,
    ! [VarCurr: state_type] :
      ( v8757(VarCurr)
    <=> v8759(VarCurr) ) ).

tff(addAssignment_4304,axiom,
    ! [VarCurr: state_type] :
      ( v8759(VarCurr)
    <=> v8761(VarCurr) ) ).

tff(addAssignment_4303,axiom,
    ! [VarCurr: state_type] :
      ( v8761(VarCurr)
    <=> v8763(VarCurr) ) ).

tff(addAssignment_4302,axiom,
    ! [VarCurr: state_type] :
      ( v8763(VarCurr)
    <=> v8765(VarCurr) ) ).

tff(addAssignment_4301,axiom,
    ! [VarCurr: state_type] :
      ( v8765(VarCurr)
    <=> v8767(VarCurr) ) ).

tff(writeUnaryOperator_580,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8767(VarCurr)
    <=> v8777(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_780,axiom,
    ! [VarCurr: state_type] :
      ( v8777(VarCurr)
    <=> ( v8769(VarCurr)
        | v8773(VarCurr) ) ) ).

tff(addAssignment_4300,axiom,
    ! [VarCurr: state_type] :
      ( v8773(VarCurr)
    <=> v8775(VarCurr) ) ).

tff(addAssignment_4299,axiom,
    ! [VarCurr: state_type] :
      ( v8775(VarCurr)
    <=> v8726(VarCurr,1) ) ).

tff(addAssignment_4298,axiom,
    ! [VarCurr: state_type] :
      ( v8726(VarCurr,1)
    <=> v8728(VarCurr,1) ) ).

tff(addAssignment_4297,axiom,
    ! [VarCurr: state_type] :
      ( v8728(VarCurr,1)
    <=> v8730(VarCurr,1) ) ).

tff(addAssignment_4296,axiom,
    ! [VarCurr: state_type] :
      ( v8730(VarCurr,1)
    <=> v8735(VarCurr,1) ) ).

tff(addAssignment_4295,axiom,
    ! [VarCurr: state_type] :
      ( v8732(VarCurr,1)
    <=> v8734(VarCurr,1) ) ).

tff(addAssignment_4294,axiom,
    ! [VarCurr: state_type] :
      ( v8734(VarCurr,1)
    <=> v8678(VarCurr,1) ) ).

tff(addAssignment_4293,axiom,
    ! [VarCurr: state_type] :
      ( v8769(VarCurr)
    <=> v8771(VarCurr) ) ).

tff(addAssignment_4292,axiom,
    ! [VarCurr: state_type] :
      ( v8771(VarCurr)
    <=> v8678(VarCurr,0) ) ).

tff(addAssignment_4291,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8743(VarCurr,B)
      <=> v8745(VarCurr,B) ) ) ).

tff(addAssignment_4290,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8745(VarCurr,B)
      <=> v8747(VarCurr,B) ) ) ).

tff(addAssignment_4289,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8747(VarCurr,B)
      <=> v8749(VarCurr,B) ) ) ).

tff(addAssignment_4288,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8749(VarCurr,B)
      <=> v8751(VarCurr,B) ) ) ).

tff(addAssignment_4287,axiom,
    ! [VarCurr: state_type] :
      ( v8706(VarCurr)
    <=> v8708(VarCurr) ) ).

tff(addAssignment_4286,axiom,
    ! [VarCurr: state_type] :
      ( v8708(VarCurr)
    <=> v8710(VarCurr) ) ).

tff(addAssignment_4285,axiom,
    ! [VarCurr: state_type] :
      ( v8710(VarCurr)
    <=> v8712(VarCurr) ) ).

tff(addAssignment_4284,axiom,
    ! [VarCurr: state_type] :
      ( v8712(VarCurr)
    <=> v8714(VarCurr) ) ).

tff(addAssignment_4283,axiom,
    ! [VarCurr: state_type] :
      ( v8714(VarCurr)
    <=> v8716(VarCurr) ) ).

tff(addAssignment_4282,axiom,
    ! [VarCurr: state_type] :
      ( v8716(VarCurr)
    <=> v8718(VarCurr) ) ).

tff(addAssignment_4281,axiom,
    ! [VarCurr: state_type] :
      ( v8718(VarCurr)
    <=> v8720(VarCurr) ) ).

tff(writeUnaryOperator_579,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8720(VarCurr)
    <=> v8741(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_779,axiom,
    ! [VarCurr: state_type] :
      ( v8741(VarCurr)
    <=> ( v8722(VarCurr)
        | v8737(VarCurr) ) ) ).

tff(addAssignment_4280,axiom,
    ! [VarCurr: state_type] :
      ( v8737(VarCurr)
    <=> v8739(VarCurr) ) ).

tff(addAssignment_4279,axiom,
    ! [VarCurr: state_type] :
      ( v8739(VarCurr)
    <=> v8678(VarCurr,1) ) ).

tff(addAssignment_4278,axiom,
    ! [VarCurr: state_type] :
      ( v8722(VarCurr)
    <=> v8724(VarCurr) ) ).

tff(addAssignment_4277,axiom,
    ! [VarCurr: state_type] :
      ( v8724(VarCurr)
    <=> v8726(VarCurr,0) ) ).

tff(addAssignment_4276,axiom,
    ! [VarCurr: state_type] :
      ( v8726(VarCurr,0)
    <=> v8728(VarCurr,0) ) ).

tff(addAssignment_4275,axiom,
    ! [VarCurr: state_type] :
      ( v8728(VarCurr,0)
    <=> v8730(VarCurr,0) ) ).

tff(addAssignment_4274,axiom,
    ! [VarCurr: state_type] :
      ( v8730(VarCurr,0)
    <=> v8735(VarCurr,0) ) ).

tff(writeUnaryOperator_578,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v8735(VarCurr,B)
      <=> ~ v8732(VarCurr,B) ) ) ).

tff(addAssignment_4273,axiom,
    ! [VarCurr: state_type] :
      ( v8732(VarCurr,0)
    <=> v8734(VarCurr,0) ) ).

tff(addAssignment_4272,axiom,
    ! [VarCurr: state_type] :
      ( v8734(VarCurr,0)
    <=> v8678(VarCurr,0) ) ).

tff(addAssignment_4271,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8696(VarCurr,B)
      <=> v8698(VarCurr,B) ) ) ).

tff(addAssignment_4270,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8698(VarCurr,B)
      <=> v8700(VarCurr,B) ) ) ).

tff(addAssignment_4269,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8700(VarCurr,B)
      <=> v8702(VarCurr,B) ) ) ).

tff(addAssignment_4268,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8702(VarCurr,B)
      <=> v8704(VarCurr,B) ) ) ).

tff(addAssignment_4267,axiom,
    ! [VarCurr: state_type] :
      ( v8658(VarCurr)
    <=> v8660(VarCurr) ) ).

tff(addAssignment_4266,axiom,
    ! [VarCurr: state_type] :
      ( v8660(VarCurr)
    <=> v8662(VarCurr) ) ).

tff(addAssignment_4265,axiom,
    ! [VarCurr: state_type] :
      ( v8662(VarCurr)
    <=> v8664(VarCurr) ) ).

tff(addAssignment_4264,axiom,
    ! [VarCurr: state_type] :
      ( v8664(VarCurr)
    <=> v8666(VarCurr) ) ).

tff(addAssignment_4263,axiom,
    ! [VarCurr: state_type] :
      ( v8666(VarCurr)
    <=> v8668(VarCurr) ) ).

tff(addAssignment_4262,axiom,
    ! [VarCurr: state_type] :
      ( v8668(VarCurr)
    <=> v8670(VarCurr) ) ).

tff(addAssignment_4261,axiom,
    ! [VarCurr: state_type] :
      ( v8670(VarCurr)
    <=> v8672(VarCurr) ) ).

tff(writeUnaryOperator_577,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8672(VarCurr)
    <=> v8694(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_778,axiom,
    ! [VarCurr: state_type] :
      ( v8694(VarCurr)
    <=> ( v8674(VarCurr)
        | v8690(VarCurr) ) ) ).

tff(addAssignment_4260,axiom,
    ! [VarCurr: state_type] :
      ( v8690(VarCurr)
    <=> v8692(VarCurr) ) ).

tff(addAssignment_4259,axiom,
    ! [VarCurr: state_type] :
      ( v8692(VarCurr)
    <=> v8678(VarCurr,1) ) ).

tff(addAssignment_4258,axiom,
    ! [VarCurr: state_type] :
      ( v8678(VarCurr,1)
    <=> v8680(VarCurr,1) ) ).

tff(addAssignment_4257,axiom,
    ! [VarCurr: state_type] :
      ( v8680(VarCurr,1)
    <=> v8682(VarCurr,1) ) ).

tff(addAssignment_4256,axiom,
    ! [VarCurr: state_type] :
      ( v8682(VarCurr,1)
    <=> v8684(VarCurr,1) ) ).

tff(addAssignment_4255,axiom,
    ! [VarCurr: state_type] :
      ( v8684(VarCurr,1)
    <=> v8686(VarCurr,1) ) ).

tff(addAssignment_4254,axiom,
    ! [VarCurr: state_type] :
      ( v8686(VarCurr,1)
    <=> v8688(VarCurr,1) ) ).

tff(addAssignment_4253,axiom,
    ! [VarCurr: state_type] :
      ( v8674(VarCurr)
    <=> v8676(VarCurr) ) ).

tff(addAssignment_4252,axiom,
    ! [VarCurr: state_type] :
      ( v8676(VarCurr)
    <=> v8678(VarCurr,0) ) ).

tff(addAssignment_4251,axiom,
    ! [VarCurr: state_type] :
      ( v8678(VarCurr,0)
    <=> v8680(VarCurr,0) ) ).

tff(addAssignment_4250,axiom,
    ! [VarCurr: state_type] :
      ( v8680(VarCurr,0)
    <=> v8682(VarCurr,0) ) ).

tff(addAssignment_4249,axiom,
    ! [VarCurr: state_type] :
      ( v8682(VarCurr,0)
    <=> v8684(VarCurr,0) ) ).

tff(addAssignment_4248,axiom,
    ! [VarCurr: state_type] :
      ( v8684(VarCurr,0)
    <=> v8686(VarCurr,0) ) ).

tff(addAssignment_4247,axiom,
    ! [VarCurr: state_type] :
      ( v8686(VarCurr,0)
    <=> v8688(VarCurr,0) ) ).

tff(addAssignment_4246,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8648(VarCurr,B)
      <=> v8650(VarCurr,B) ) ) ).

tff(addAssignment_4245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8650(VarCurr,B)
      <=> v8652(VarCurr,B) ) ) ).

tff(addAssignment_4244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8652(VarCurr,B)
      <=> v8654(VarCurr,B) ) ) ).

tff(addAssignment_4243,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8654(VarCurr,B)
      <=> v8656(VarCurr,B) ) ) ).

tff(addAssignment_4242,axiom,
    ! [VarCurr: state_type] :
      ( v8628(VarCurr)
    <=> v8630(VarCurr) ) ).

tff(addAssignment_4241,axiom,
    ! [VarCurr: state_type] :
      ( v8630(VarCurr)
    <=> v8632(VarCurr) ) ).

tff(addAssignment_4240,axiom,
    ! [VarCurr: state_type] :
      ( v8632(VarCurr)
    <=> v8634(VarCurr) ) ).

tff(addAssignment_4239,axiom,
    ! [VarCurr: state_type] :
      ( v8634(VarCurr)
    <=> v8636(VarCurr) ) ).

tff(addAssignment_4238,axiom,
    ! [VarCurr: state_type] :
      ( v8636(VarCurr)
    <=> v8638(VarCurr) ) ).

tff(addAssignment_4237,axiom,
    ! [VarCurr: state_type] :
      ( v8638(VarCurr)
    <=> v8640(VarCurr) ) ).

tff(addAssignment_4236,axiom,
    ! [VarCurr: state_type] :
      ( v8640(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_4235,axiom,
    ! [VarCurr: state_type] :
      ( v8614(VarCurr)
    <=> v8616(VarCurr) ) ).

tff(addAssignment_4234,axiom,
    ! [VarCurr: state_type] :
      ( v8616(VarCurr)
    <=> v8618(VarCurr) ) ).

tff(addAssignment_4233,axiom,
    ! [VarCurr: state_type] :
      ( v8618(VarCurr)
    <=> v8620(VarCurr) ) ).

tff(addAssignment_4232,axiom,
    ! [VarCurr: state_type] :
      ( v8620(VarCurr)
    <=> v8622(VarCurr) ) ).

tff(addAssignment_4231,axiom,
    ! [VarCurr: state_type] :
      ( v8622(VarCurr)
    <=> v8624(VarCurr) ) ).

tff(addAssignment_4230,axiom,
    ! [VarCurr: state_type] :
      ( v8624(VarCurr)
    <=> v8626(VarCurr) ) ).

tff(addAssignment_4229,axiom,
    ! [VarCurr: state_type] :
      ( v8626(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_4228,axiom,
    ! [VarCurr: state_type] :
      ( v8600(VarCurr)
    <=> v8602(VarCurr) ) ).

tff(addAssignment_4227,axiom,
    ! [VarCurr: state_type] :
      ( v8602(VarCurr)
    <=> v6617(VarCurr,2) ) ).

tff(addAssignment_4226,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,2)
    <=> v6619(VarCurr,2) ) ).

tff(addAssignment_4225,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,2)
    <=> v6621(VarCurr,2) ) ).

tff(addAssignment_4224,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,2)
    <=> v6747(VarCurr,2) ) ).

tff(addAssignment_4223,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,2)
    <=> v6690(VarCurr,2) ) ).

tff(addAssignment_4222,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8596(VarCurr,B)
      <=> v8598(VarCurr,B) ) ) ).

tff(addAssignment_4221,axiom,
    ! [VarCurr: state_type] :
      ( ( v8598(VarCurr,11)
      <=> v6334(VarCurr,35) )
      & ( v8598(VarCurr,10)
      <=> v6334(VarCurr,34) )
      & ( v8598(VarCurr,9)
      <=> v6334(VarCurr,33) )
      & ( v8598(VarCurr,8)
      <=> v6334(VarCurr,32) )
      & ( v8598(VarCurr,7)
      <=> v6334(VarCurr,31) )
      & ( v8598(VarCurr,6)
      <=> v6334(VarCurr,30) )
      & ( v8598(VarCurr,5)
      <=> v6334(VarCurr,29) )
      & ( v8598(VarCurr,4)
      <=> v6334(VarCurr,28) )
      & ( v8598(VarCurr,3)
      <=> v6334(VarCurr,27) )
      & ( v8598(VarCurr,2)
      <=> v6334(VarCurr,26) )
      & ( v8598(VarCurr,1)
      <=> v6334(VarCurr,25) )
      & ( v8598(VarCurr,0)
      <=> v6334(VarCurr,24) ) ) ).

tff(addAssignment_4220,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8564(VarCurr,B)
      <=> v8566(VarCurr,B) ) ) ).

tff(addAssignment_4219,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,0)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4218,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,1)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4217,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,2)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4216,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,3)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4215,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,4)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4214,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,5)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4213,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,6)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4212,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,7)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4211,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,8)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4210,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,9)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4209,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,10)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4208,axiom,
    ! [VarCurr: state_type] :
      ( v8566(VarCurr,11)
    <=> v8584(VarCurr) ) ).

tff(addAssignment_4207,axiom,
    ! [VarCurr: state_type] :
      ( v8584(VarCurr)
    <=> v8568(VarCurr) ) ).

tff(addAssignment_4206,axiom,
    ! [VarCurr: state_type] :
      ( v8568(VarCurr)
    <=> v8570(VarCurr,0) ) ).

tff(addAssignment_4205,axiom,
    ! [VarCurr: state_type] :
      ( v8570(VarCurr,0)
    <=> v8572(VarCurr,0) ) ).

tff(addAssignment_4204,axiom,
    ! [VarCurr: state_type] :
      ( v8572(VarCurr,0)
    <=> v8582(VarCurr,0) ) ).

tff(writeUnaryOperator_576,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v8582(VarCurr,B)
      <=> ~ v8574(VarCurr,B) ) ) ).

tff(addAssignment_4203,axiom,
    ! [VarCurr: state_type] :
      ( v8574(VarCurr,0)
    <=> v8576(VarCurr,0) ) ).

tff(addAssignment_4202,axiom,
    ! [VarCurr: state_type] :
      ( v8576(VarCurr,0)
    <=> v8579(VarCurr,0) ) ).

tff(addAssignment_4201,axiom,
    ! [VarCurr: state_type] :
      ( v8579(VarCurr,0)
    <=> v8578(VarCurr) ) ).

tff(addAssignment_4200,axiom,
    ! [VarCurr: state_type] :
      ( v8579(VarCurr,1)
    <=> v8581(VarCurr) ) ).

tff(addAssignment_4199,axiom,
    ! [VarCurr: state_type] :
      ( v8579(VarCurr,2)
    <=> v8580(VarCurr) ) ).

tff(addAssignment_4198,axiom,
    ! [VarCurr: state_type] :
      ( v8578(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_4197,axiom,
    ! [VarCurr: state_type] :
      ( v8540(VarCurr)
    <=> v8542(VarCurr) ) ).

tff(addAssignment_4196,axiom,
    ! [VarCurr: state_type] :
      ( v8542(VarCurr)
    <=> v8544(VarCurr) ) ).

tff(addAssignment_4195,axiom,
    ! [VarCurr: state_type] :
      ( v8544(VarCurr)
    <=> v8546(VarCurr) ) ).

tff(addAssignment_4194,axiom,
    ! [VarCurr: state_type] :
      ( v8546(VarCurr)
    <=> v8548(VarCurr) ) ).

tff(addAssignment_4193,axiom,
    ! [VarCurr: state_type] :
      ( v8548(VarCurr)
    <=> v8550(VarCurr) ) ).

tff(addAssignment_4192,axiom,
    ! [VarCurr: state_type] :
      ( v8550(VarCurr)
    <=> v8552(VarCurr) ) ).

tff(addAssignment_4191,axiom,
    ! [VarCurr: state_type] :
      ( v8552(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_4190,axiom,
    ! [VarCurr: state_type] :
      ( v8526(VarCurr)
    <=> v8528(VarCurr) ) ).

tff(addAssignment_4189,axiom,
    ! [VarCurr: state_type] :
      ( v8528(VarCurr)
    <=> v8530(VarCurr) ) ).

tff(addAssignment_4188,axiom,
    ! [VarCurr: state_type] :
      ( v8530(VarCurr)
    <=> v8532(VarCurr) ) ).

tff(addAssignment_4187,axiom,
    ! [VarCurr: state_type] :
      ( v8532(VarCurr)
    <=> v8534(VarCurr) ) ).

tff(addAssignment_4186,axiom,
    ! [VarCurr: state_type] :
      ( v8534(VarCurr)
    <=> v8536(VarCurr) ) ).

tff(addAssignment_4185,axiom,
    ! [VarCurr: state_type] :
      ( v8536(VarCurr)
    <=> v8538(VarCurr) ) ).

tff(addAssignment_4184,axiom,
    ! [VarCurr: state_type] :
      ( v8538(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_4183,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8502(VarCurr,B)
      <=> v8504(VarCurr,B) ) ) ).

tff(addAssignment_4182,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8504(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_4181,axiom,
    ! [VarCurr: state_type] :
      ( v7238(VarCurr,0)
    <=> v7240(VarCurr,0) ) ).

tff(addAssignment_4180,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,0)
    <=> v8481(VarCurr) ) ).

tff(addAssignment_4179,axiom,
    ! [VarCurr: state_type] :
      ( v8481(VarCurr)
    <=> v8483(VarCurr) ) ).

tff(addAssignment_4178,axiom,
    ! [VarCurr: state_type] :
      ( v8483(VarCurr)
    <=> v8485(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_83,axiom,
    ! [VarCurr: state_type] :
      ( v8485(VarCurr)
    <=> ( ( v8487(VarCurr,11)
        <=> v8491(VarCurr,11) )
        & ( v8487(VarCurr,10)
        <=> v8491(VarCurr,10) )
        & ( v8487(VarCurr,9)
        <=> v8491(VarCurr,9) )
        & ( v8487(VarCurr,8)
        <=> v8491(VarCurr,8) )
        & ( v8487(VarCurr,7)
        <=> v8491(VarCurr,7) )
        & ( v8487(VarCurr,6)
        <=> v8491(VarCurr,6) )
        & ( v8487(VarCurr,5)
        <=> v8491(VarCurr,5) )
        & ( v8487(VarCurr,4)
        <=> v8491(VarCurr,4) )
        & ( v8487(VarCurr,3)
        <=> v8491(VarCurr,3) )
        & ( v8487(VarCurr,2)
        <=> v8491(VarCurr,2) )
        & ( v8487(VarCurr,1)
        <=> v8491(VarCurr,1) )
        & ( v8487(VarCurr,0)
        <=> v8491(VarCurr,0) ) ) ) ).

tff(addAssignment_4177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8491(VarCurr,B)
      <=> v8493(VarCurr,B) ) ) ).

tff(addAssignment_4176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8493(VarCurr,B)
      <=> v4121(VarCurr,B) ) ) ).

tff(addAssignment_4175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8487(VarCurr,B)
      <=> v8489(VarCurr,B) ) ) ).

tff(addAssignment_4174,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8489(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(addAssignment_4173,axiom,
    ! [VarCurr: state_type] :
      ( v8422(VarCurr,1)
    <=> v8424(VarCurr,1) ) ).

tff(addAssignment_4172,axiom,
    ! [VarCurr: state_type] :
      ( v8424(VarCurr,1)
    <=> v8426(VarCurr,1) ) ).

tff(addAssignment_4171,axiom,
    ! [VarNext: state_type] :
      ( v8426(VarNext,1)
    <=> v8463(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8464(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v8463(VarNext,B)
            <=> v8426(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_106,axiom,
    ! [VarNext: state_type] :
      ( v8464(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v8463(VarNext,B)
          <=> v8474(VarNext,B) ) ) ) ).

tff(addAssignment_4170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v8474(VarNext,B)
          <=> v8472(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_91,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8475(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v8472(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_91,axiom,
    ! [VarCurr: state_type] :
      ( v8475(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v8472(VarCurr,B)
          <=> v8436(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_777,axiom,
    ! [VarCurr: state_type] :
      ( v8475(VarCurr)
    <=> ( v8476(VarCurr)
        & v8477(VarCurr) ) ) ).

tff(writeUnaryOperator_575,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8477(VarCurr)
    <=> v8432(VarCurr) ) ).

tff(writeUnaryOperator_574,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8476(VarCurr)
    <=> v8428(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_776,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8464(VarNext)
      <=> v8465(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_775,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8465(VarNext)
      <=> ( v8466(VarNext)
          & v8459(VarNext) ) ) ) ).

tff(writeUnaryOperator_573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8466(VarNext)
      <=> v8468(VarNext) ) ) ).

tff(addAssignment_4169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8468(VarNext)
      <=> v8459(VarCurr) ) ) ).

tff(addAssignment_4168,axiom,
    ! [VarCurr: state_type] :
      ( v8459(VarCurr)
    <=> v8461(VarCurr) ) ).

tff(addAssignment_4167,axiom,
    ! [VarCurr: state_type] :
      ( v8461(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_4166,axiom,
    ! [VarCurr: state_type] :
      ( v8436(VarCurr,1)
    <=> v8438(VarCurr,1) ) ).

tff(addAssignment_4165,axiom,
    ! [VarCurr: state_type] :
      ( v8438(VarCurr,1)
    <=> v8450(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_149,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v8450(VarCurr,B)
      <=> ( v8451(VarCurr,B)
          | v8454(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_148,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v8454(VarCurr,B)
      <=> ( v8424(VarCurr,B)
          & v8455(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_572,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v8455(VarCurr,B)
      <=> ~ v8456(VarCurr,B) ) ) ).

tff(addAssignment_4164,axiom,
    ! [VarCurr: state_type] :
      ( v8456(VarCurr,0)
    <=> v8457(VarCurr) ) ).

tff(addAssignment_4163,axiom,
    ! [VarCurr: state_type] :
      ( v8456(VarCurr,1)
    <=> v8457(VarCurr) ) ).

tff(addAssignment_4162,axiom,
    ! [VarCurr: state_type] :
      ( v8457(VarCurr)
    <=> v8444(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_147,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v8451(VarCurr,B)
      <=> ( v8440(VarCurr,B)
          & v8452(VarCurr,B) ) ) ) ).

tff(addAssignment_4161,axiom,
    ! [VarCurr: state_type] :
      ( v8452(VarCurr,0)
    <=> v8453(VarCurr) ) ).

tff(addAssignment_4160,axiom,
    ! [VarCurr: state_type] :
      ( v8452(VarCurr,1)
    <=> v8453(VarCurr) ) ).

tff(addAssignment_4159,axiom,
    ! [VarCurr: state_type] :
      ( v8453(VarCurr)
    <=> v8444(VarCurr) ) ).

tff(addAssignment_4158,axiom,
    ! [VarCurr: state_type] :
      ( v8444(VarCurr)
    <=> v8446(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_774,axiom,
    ! [VarCurr: state_type] :
      ( v8446(VarCurr)
    <=> ( v2354(VarCurr)
        & v8449(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_82,axiom,
    ! [VarCurr: state_type] :
      ( v8449(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $true )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_430,axiom,
    ~ b0100011001000(12) ).

tff(bitBlastConstant_429,axiom,
    b0100011001000(11) ).

tff(bitBlastConstant_428,axiom,
    ~ b0100011001000(10) ).

tff(bitBlastConstant_427,axiom,
    ~ b0100011001000(9) ).

tff(bitBlastConstant_426,axiom,
    ~ b0100011001000(8) ).

tff(bitBlastConstant_425,axiom,
    b0100011001000(7) ).

tff(bitBlastConstant_424,axiom,
    b0100011001000(6) ).

tff(bitBlastConstant_423,axiom,
    ~ b0100011001000(5) ).

tff(bitBlastConstant_422,axiom,
    ~ b0100011001000(4) ).

tff(bitBlastConstant_421,axiom,
    b0100011001000(3) ).

tff(bitBlastConstant_420,axiom,
    ~ b0100011001000(2) ).

tff(bitBlastConstant_419,axiom,
    ~ b0100011001000(1) ).

tff(bitBlastConstant_418,axiom,
    ~ b0100011001000(0) ).

tff(addAssignment_4157,axiom,
    ! [VarCurr: state_type] :
      ( v8440(VarCurr,1)
    <=> v8442(VarCurr,1) ) ).

tff(addAssignment_4156,axiom,
    ! [VarCurr: state_type] :
      ( v8442(VarCurr,1)
    <=> v2363(VarCurr,1) ) ).

tff(addAssignment_4155,axiom,
    ! [VarCurr: state_type] :
      ( v8432(VarCurr)
    <=> v8434(VarCurr) ) ).

tff(addAssignment_4154,axiom,
    ! [VarCurr: state_type] :
      ( v8434(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_4153,axiom,
    ! [VarCurr: state_type] :
      ( v8428(VarCurr)
    <=> v8430(VarCurr) ) ).

tff(addAssignment_4152,axiom,
    ! [VarCurr: state_type] :
      ( v8430(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_773,axiom,
    ! [VarCurr: state_type] :
      ( v8312(VarCurr)
    <=> ( v8314(VarCurr)
        | v8357(VarCurr) ) ) ).

tff(addAssignment_4151,axiom,
    ! [VarCurr: state_type] :
      ( v8357(VarCurr)
    <=> v8359(VarCurr) ) ).

tff(addAssignment_4150,axiom,
    ! [VarCurr: state_type] :
      ( v8359(VarCurr)
    <=> v8361(VarCurr) ) ).

tff(addAssignment_4149,axiom,
    ! [VarCurr: state_type] :
      ( v8361(VarCurr)
    <=> v8363(VarCurr,4) ) ).

tff(addAssignment_4148,axiom,
    ! [VarCurr: state_type] :
      ( v8363(VarCurr,4)
    <=> v8365(VarCurr,4) ) ).

tff(addAssignment_4147,axiom,
    ! [VarNext: state_type] :
      ( v8365(VarNext,4)
    <=> v8403(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8404(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v8403(VarNext,B)
            <=> v8365(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_105,axiom,
    ! [VarNext: state_type] :
      ( v8404(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v8403(VarNext,B)
          <=> v8414(VarNext,B) ) ) ) ).

tff(addAssignment_4146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v8414(VarNext,B)
          <=> v8412(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_90,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8415(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v8412(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_90,axiom,
    ! [VarCurr: state_type] :
      ( v8415(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v8412(VarCurr,B)
          <=> v8377(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_772,axiom,
    ! [VarCurr: state_type] :
      ( v8415(VarCurr)
    <=> ( v8416(VarCurr)
        & v8417(VarCurr) ) ) ).

tff(writeUnaryOperator_571,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8417(VarCurr)
    <=> v8373(VarCurr) ) ).

tff(writeUnaryOperator_570,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8416(VarCurr)
    <=> v8367(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_771,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8404(VarNext)
      <=> v8405(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_770,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8405(VarNext)
      <=> ( v8406(VarNext)
          & v8399(VarNext) ) ) ) ).

tff(writeUnaryOperator_569,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8406(VarNext)
      <=> v8408(VarNext) ) ) ).

tff(addAssignment_4145,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8408(VarNext)
      <=> v8399(VarCurr) ) ) ).

tff(addAssignment_4144,axiom,
    ! [VarCurr: state_type] :
      ( v8399(VarCurr)
    <=> v8401(VarCurr) ) ).

tff(addAssignment_4143,axiom,
    ! [VarCurr: state_type] :
      ( v8401(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_4142,axiom,
    ! [VarCurr: state_type] :
      ( v8377(VarCurr,4)
    <=> v8379(VarCurr,4) ) ).

tff(addAssignment_4141,axiom,
    ! [VarCurr: state_type] :
      ( v8379(VarCurr,4)
    <=> v8390(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_146,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v8390(VarCurr,B)
      <=> ( v8391(VarCurr,B)
          | v8394(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_145,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v8394(VarCurr,B)
      <=> ( v8363(VarCurr,B)
          & v8395(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_568,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v8395(VarCurr,B)
      <=> ~ v8396(VarCurr,B) ) ) ).

tff(addAssignment_4140,axiom,
    ! [VarCurr: state_type] :
      ( v8396(VarCurr,0)
    <=> v8397(VarCurr) ) ).

tff(addAssignment_4139,axiom,
    ! [VarCurr: state_type] :
      ( v8396(VarCurr,1)
    <=> v8397(VarCurr) ) ).

tff(addAssignment_4138,axiom,
    ! [VarCurr: state_type] :
      ( v8396(VarCurr,2)
    <=> v8397(VarCurr) ) ).

tff(addAssignment_4137,axiom,
    ! [VarCurr: state_type] :
      ( v8396(VarCurr,3)
    <=> v8397(VarCurr) ) ).

tff(addAssignment_4136,axiom,
    ! [VarCurr: state_type] :
      ( v8396(VarCurr,4)
    <=> v8397(VarCurr) ) ).

tff(addAssignment_4135,axiom,
    ! [VarCurr: state_type] :
      ( v8397(VarCurr)
    <=> v8387(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_144,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v8391(VarCurr,B)
      <=> ( v8381(VarCurr,B)
          & v8392(VarCurr,B) ) ) ) ).

tff(addAssignment_4134,axiom,
    ! [VarCurr: state_type] :
      ( v8392(VarCurr,0)
    <=> v8393(VarCurr) ) ).

tff(addAssignment_4133,axiom,
    ! [VarCurr: state_type] :
      ( v8392(VarCurr,1)
    <=> v8393(VarCurr) ) ).

tff(addAssignment_4132,axiom,
    ! [VarCurr: state_type] :
      ( v8392(VarCurr,2)
    <=> v8393(VarCurr) ) ).

tff(addAssignment_4131,axiom,
    ! [VarCurr: state_type] :
      ( v8392(VarCurr,3)
    <=> v8393(VarCurr) ) ).

tff(addAssignment_4130,axiom,
    ! [VarCurr: state_type] :
      ( v8392(VarCurr,4)
    <=> v8393(VarCurr) ) ).

tff(addAssignment_4129,axiom,
    ! [VarCurr: state_type] :
      ( v8393(VarCurr)
    <=> v8387(VarCurr) ) ).

tff(addAssignment_4128,axiom,
    ! [VarCurr: state_type] :
      ( v8387(VarCurr)
    <=> v8389(VarCurr) ) ).

tff(addAssignment_4127,axiom,
    ! [VarCurr: state_type] :
      ( v8389(VarCurr)
    <=> v4416(VarCurr) ) ).

tff(addAssignment_4126,axiom,
    ! [VarCurr: state_type] :
      ( v8381(VarCurr,4)
    <=> v8383(VarCurr,4) ) ).

tff(addAssignment_4125,axiom,
    ! [VarCurr: state_type] :
      ( v8383(VarCurr,4)
    <=> v8385(VarCurr,5) ) ).

tff(addAssignment_4124,axiom,
    ! [VarCurr: state_type] :
      ( v8385(VarCurr,5)
    <=> v2365(VarCurr,5) ) ).

tff(addAssignment_4123,axiom,
    ! [VarCurr: state_type] :
      ( v8373(VarCurr)
    <=> v8375(VarCurr) ) ).

tff(addAssignment_4122,axiom,
    ! [VarCurr: state_type] :
      ( v8375(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_4121,axiom,
    ! [VarCurr: state_type] :
      ( v8367(VarCurr)
    <=> v8369(VarCurr) ) ).

tff(addAssignment_4120,axiom,
    ! [VarCurr: state_type] :
      ( v8369(VarCurr)
    <=> v8371(VarCurr) ) ).

tff(addAssignment_4119,axiom,
    ! [VarCurr: state_type] :
      ( v8371(VarCurr)
    <=> v1063(VarCurr) ) ).

tff(addAssignment_4118,axiom,
    ! [VarCurr: state_type] :
      ( v8314(VarCurr)
    <=> v8316(VarCurr) ) ).

tff(addAssignment_4117,axiom,
    ! [VarCurr: state_type] :
      ( v8316(VarCurr)
    <=> v8318(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8340(VarNext)
       => ( v8318(VarNext)
        <=> v8318(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_104,axiom,
    ! [VarNext: state_type] :
      ( v8340(VarNext)
     => ( v8318(VarNext)
      <=> v8350(VarNext) ) ) ).

tff(addAssignment_4116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8350(VarNext)
      <=> v8348(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_89,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8351(VarCurr)
     => ( v8348(VarCurr)
      <=> x8333(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_89,axiom,
    ! [VarCurr: state_type] :
      ( v8351(VarCurr)
     => ( v8348(VarCurr)
      <=> v8328(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_769,axiom,
    ! [VarCurr: state_type] :
      ( v8351(VarCurr)
    <=> ( v8352(VarCurr)
        & v8353(VarCurr) ) ) ).

tff(writeUnaryOperator_567,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8353(VarCurr)
    <=> v8324(VarCurr) ) ).

tff(writeUnaryOperator_566,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8352(VarCurr)
    <=> v8320(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8340(VarNext)
      <=> v8341(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8341(VarNext)
      <=> ( v8342(VarNext)
          & v8335(VarNext) ) ) ) ).

tff(writeUnaryOperator_565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8342(VarNext)
      <=> v8344(VarNext) ) ) ).

tff(addAssignment_4115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8344(VarNext)
      <=> v8335(VarCurr) ) ) ).

tff(addAssignment_4114,axiom,
    ! [VarCurr: state_type] :
      ( v8335(VarCurr)
    <=> v8337(VarCurr) ) ).

tff(addAssignment_4113,axiom,
    ! [VarCurr: state_type] :
      ( v8337(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_4112,axiom,
    ! [VarCurr: state_type] :
      ( v8328(VarCurr)
    <=> v8330(VarCurr) ) ).

tff(addAssignment_4111,axiom,
    ! [VarCurr: state_type] :
      ( v8330(VarCurr)
    <=> v8332(VarCurr) ) ).

tff(addAssignmentInitValueVector_21,axiom,
    ( v8332(constB0)
  <=> $false ) ).

tff(addAssignment_4110,axiom,
    ! [VarCurr: state_type] :
      ( v8324(VarCurr)
    <=> v8326(VarCurr) ) ).

tff(addAssignment_4109,axiom,
    ! [VarCurr: state_type] :
      ( v8326(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_4108,axiom,
    ! [VarCurr: state_type] :
      ( v8320(VarCurr)
    <=> v8322(VarCurr) ) ).

tff(addAssignment_4107,axiom,
    ! [VarCurr: state_type] :
      ( v8322(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_4106,axiom,
    ! [VarCurr: state_type] :
      ( v8300(VarCurr)
    <=> v8302(VarCurr) ) ).

tff(addAssignment_4105,axiom,
    ! [VarCurr: state_type] :
      ( v8302(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_4104,axiom,
    ! [VarCurr: state_type] :
      ( v8296(VarCurr)
    <=> v8298(VarCurr) ) ).

tff(addAssignment_4103,axiom,
    ! [VarCurr: state_type] :
      ( v8298(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_4102,axiom,
    ! [VarCurr: state_type] :
      ( v7236(VarCurr,1)
    <=> v7238(VarCurr,1) ) ).

tff(addAssignment_4101,axiom,
    ! [VarCurr: state_type] :
      ( v7238(VarCurr,1)
    <=> v7240(VarCurr,1) ) ).

tff(addAssignment_4100,axiom,
    ! [VarCurr: state_type] :
      ( v7240(VarCurr,1)
    <=> v7242(VarCurr) ) ).

tff(addAssignment_4099,axiom,
    ! [VarCurr: state_type] :
      ( v7242(VarCurr)
    <=> v7244(VarCurr) ) ).

tff(addAssignment_4098,axiom,
    ! [VarCurr: state_type] :
      ( v7244(VarCurr)
    <=> v7246(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_81,axiom,
    ! [VarCurr: state_type] :
      ( v7246(VarCurr)
    <=> ( ( v7248(VarCurr,11)
        <=> v7253(VarCurr,11) )
        & ( v7248(VarCurr,10)
        <=> v7253(VarCurr,10) )
        & ( v7248(VarCurr,9)
        <=> v7253(VarCurr,9) )
        & ( v7248(VarCurr,8)
        <=> v7253(VarCurr,8) )
        & ( v7248(VarCurr,7)
        <=> v7253(VarCurr,7) )
        & ( v7248(VarCurr,6)
        <=> v7253(VarCurr,6) )
        & ( v7248(VarCurr,5)
        <=> v7253(VarCurr,5) )
        & ( v7248(VarCurr,4)
        <=> v7253(VarCurr,4) )
        & ( v7248(VarCurr,3)
        <=> v7253(VarCurr,3) )
        & ( v7248(VarCurr,2)
        <=> v7253(VarCurr,2) )
        & ( v7248(VarCurr,1)
        <=> v7253(VarCurr,1) )
        & ( v7248(VarCurr,0)
        <=> v7253(VarCurr,0) ) ) ) ).

tff(addAssignment_4097,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7253(VarCurr,B)
      <=> v7255(VarCurr,B) ) ) ).

tff(addAssignment_4096,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7255(VarCurr,B)
      <=> v6242(VarCurr,B) ) ) ).

tff(addAssignment_4095,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6242(VarCurr,B)
      <=> v6244(VarCurr,B) ) ) ).

tff(addAssignment_4094,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6244(VarCurr,B)
      <=> v6246(VarCurr,B) ) ) ).

tff(addAssignment_4093,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6246(VarCurr,B)
      <=> v8199(VarCurr,B) ) ) ).

tff(addAssignment_4092,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8049(VarCurr,B)
      <=> v8051(VarCurr,B) ) ) ).

tff(addAssignment_4091,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8051(VarCurr,B)
      <=> v8053(VarCurr,B) ) ) ).

tff(addAssignment_4090,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8053(VarCurr,B)
      <=> v8055(VarCurr,B) ) ) ).

tff(addAssignment_4089,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8055(VarCurr,B)
      <=> v8057(VarCurr,B) ) ) ).

tff(addAssignment_4088,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8057(VarNext,B)
      <=> v8279(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_103,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8280(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8279(VarNext,B)
            <=> v8057(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_103,axiom,
    ! [VarNext: state_type] :
      ( v8280(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8279(VarNext,B)
          <=> v8162(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_766,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8280(VarNext)
      <=> v8281(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_765,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8281(VarNext)
      <=> ( v8283(VarNext)
          & v8083(VarNext) ) ) ) ).

tff(writeUnaryOperator_564,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8283(VarNext)
      <=> v8156(VarNext) ) ) ).

tff(addAssignment_4087,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8079(VarCurr,B)
      <=> v8081(VarCurr,B) ) ) ).

tff(addAssignment_4086,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v8081(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4085,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7898(VarCurr,B)
      <=> v7900(VarCurr,B) ) ) ).

tff(addAssignment_4084,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7900(VarCurr,B)
      <=> v7902(VarCurr,B) ) ) ).

tff(addAssignment_4083,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7902(VarCurr,B)
      <=> v7904(VarCurr,B) ) ) ).

tff(addAssignment_4082,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7904(VarCurr,B)
      <=> v7906(VarCurr,B) ) ) ).

tff(addAssignment_4081,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7906(VarNext,B)
      <=> v8271(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_102,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8272(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8271(VarNext,B)
            <=> v7906(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_102,axiom,
    ! [VarNext: state_type] :
      ( v8272(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8271(VarNext,B)
          <=> v8011(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_764,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8272(VarNext)
      <=> v8273(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8273(VarNext)
      <=> ( v8275(VarNext)
          & v7932(VarNext) ) ) ) ).

tff(writeUnaryOperator_563,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8275(VarNext)
      <=> v8005(VarNext) ) ) ).

tff(addAssignment_4080,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7928(VarCurr,B)
      <=> v7930(VarCurr,B) ) ) ).

tff(addAssignment_4079,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7930(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4078,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7747(VarCurr,B)
      <=> v7749(VarCurr,B) ) ) ).

tff(addAssignment_4077,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7749(VarCurr,B)
      <=> v7751(VarCurr,B) ) ) ).

tff(addAssignment_4076,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7751(VarCurr,B)
      <=> v7753(VarCurr,B) ) ) ).

tff(addAssignment_4075,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7753(VarCurr,B)
      <=> v7755(VarCurr,B) ) ) ).

tff(addAssignment_4074,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7755(VarNext,B)
      <=> v8263(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_101,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8264(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8263(VarNext,B)
            <=> v7755(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_101,axiom,
    ! [VarNext: state_type] :
      ( v8264(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8263(VarNext,B)
          <=> v7860(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8264(VarNext)
      <=> v8265(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_761,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8265(VarNext)
      <=> ( v8267(VarNext)
          & v7781(VarNext) ) ) ) ).

tff(writeUnaryOperator_562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8267(VarNext)
      <=> v7854(VarNext) ) ) ).

tff(addAssignment_4073,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7777(VarCurr,B)
      <=> v7779(VarCurr,B) ) ) ).

tff(addAssignment_4072,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7779(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4071,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7596(VarCurr,B)
      <=> v7598(VarCurr,B) ) ) ).

tff(addAssignment_4070,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7598(VarCurr,B)
      <=> v7600(VarCurr,B) ) ) ).

tff(addAssignment_4069,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7600(VarCurr,B)
      <=> v7602(VarCurr,B) ) ) ).

tff(addAssignment_4068,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7602(VarCurr,B)
      <=> v7604(VarCurr,B) ) ) ).

tff(addAssignment_4067,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7604(VarNext,B)
      <=> v8255(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8256(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8255(VarNext,B)
            <=> v7604(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_100,axiom,
    ! [VarNext: state_type] :
      ( v8256(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8255(VarNext,B)
          <=> v7709(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_760,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8256(VarNext)
      <=> v8257(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_759,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8257(VarNext)
      <=> ( v8259(VarNext)
          & v7630(VarNext) ) ) ) ).

tff(writeUnaryOperator_561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8259(VarNext)
      <=> v7703(VarNext) ) ) ).

tff(addAssignment_4066,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7626(VarCurr,B)
      <=> v7628(VarCurr,B) ) ) ).

tff(addAssignment_4065,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7628(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4064,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7281(VarCurr,B)
      <=> v7283(VarCurr,B) ) ) ).

tff(addAssignment_4063,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7283(VarCurr,B)
      <=> v7285(VarCurr,B) ) ) ).

tff(addAssignment_4062,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7285(VarCurr,B)
      <=> v7287(VarCurr,B) ) ) ).

tff(addAssignment_4061,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7287(VarCurr,B)
      <=> v7289(VarCurr,B) ) ) ).

tff(addAssignment_4060,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7289(VarNext,B)
      <=> v8247(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_99,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8248(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8247(VarNext,B)
            <=> v7289(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_99,axiom,
    ! [VarNext: state_type] :
      ( v8248(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8247(VarNext,B)
          <=> v7405(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_758,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8248(VarNext)
      <=> v8249(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_757,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8249(VarNext)
      <=> ( v8251(VarNext)
          & v7315(VarNext) ) ) ) ).

tff(writeUnaryOperator_560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8251(VarNext)
      <=> v7399(VarNext) ) ) ).

tff(addAssignment_4059,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7311(VarCurr,B)
      <=> v7313(VarCurr,B) ) ) ).

tff(addAssignment_4058,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v7313(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4057,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6248(VarCurr,B)
      <=> v6250(VarCurr,B) ) ) ).

tff(addAssignment_4056,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6250(VarCurr,B)
      <=> v6252(VarCurr,B) ) ) ).

tff(addAssignment_4055,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6252(VarCurr,B)
      <=> v6254(VarCurr,B) ) ) ).

tff(addAssignment_4054,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6254(VarCurr,B)
      <=> v6256(VarCurr,B) ) ) ).

tff(addAssignment_4053,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6256(VarNext,B)
      <=> v8239(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_98,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8240(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8239(VarNext,B)
            <=> v6256(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_98,axiom,
    ! [VarNext: state_type] :
      ( v8240(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8239(VarNext,B)
          <=> v7134(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_756,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8240(VarNext)
      <=> v8241(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8241(VarNext)
      <=> ( v8243(VarNext)
          & v7033(VarNext) ) ) ) ).

tff(writeUnaryOperator_559,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8243(VarNext)
      <=> v7128(VarNext) ) ) ).

tff(addAssignment_4052,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6286(VarCurr,B)
      <=> v6288(VarCurr,B) ) ) ).

tff(addAssignment_4051,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6288(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_4050,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6290(VarCurr,B)
      <=> v6292(VarCurr,B) ) ) ).

tff(addAssignment_4049,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6292(VarCurr,B)
      <=> v6294(VarCurr,B) ) ) ).

tff(addAssignment_4048,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6294(VarCurr,B)
      <=> v7031(VarCurr,B) ) ) ).

tff(addAssignment_4047,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6318(VarCurr,B)
      <=> v6320(VarCurr,B) ) ) ).

tff(addAssignment_4046,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6320(VarCurr,B)
      <=> v6322(VarCurr,B) ) ) ).

tff(addAssignment_4045,axiom,
    ! [VarCurr: state_type] :
      ( ( v6322(VarCurr,11)
      <=> v6324(VarCurr,23) )
      & ( v6322(VarCurr,10)
      <=> v6324(VarCurr,22) )
      & ( v6322(VarCurr,9)
      <=> v6324(VarCurr,21) )
      & ( v6322(VarCurr,8)
      <=> v6324(VarCurr,20) ) ) ).

tff(addAssignment_4044,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,23)
      <=> v6326(VarCurr,11) )
      & ( v6324(VarCurr,22)
      <=> v6326(VarCurr,10) )
      & ( v6324(VarCurr,21)
      <=> v6326(VarCurr,9) )
      & ( v6324(VarCurr,20)
      <=> v6326(VarCurr,8) ) ) ).

tff(addAssignment_4043,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6326(VarCurr,B)
      <=> v6328(VarCurr,B) ) ) ).

tff(addAssignment_4042,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6328(VarCurr,B)
      <=> v7024(VarCurr,B) ) ) ).

tff(addAssignment_4041,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6749(VarCurr,B)
      <=> v6751(VarCurr,B) ) ) ).

tff(addAssignment_4040,axiom,
    ! [VarCurr: state_type] :
      ( ( v6751(VarCurr,11)
      <=> v6334(VarCurr,35) )
      & ( v6751(VarCurr,10)
      <=> v6334(VarCurr,34) )
      & ( v6751(VarCurr,9)
      <=> v6334(VarCurr,33) )
      & ( v6751(VarCurr,8)
      <=> v6334(VarCurr,32) ) ) ).

tff(addAssignment_4039,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_4038,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,36)
        & ~ $less(B,32) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_4037,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,35)
      <=> v6753(VarCurr,11) )
      & ( v6338(VarCurr,34)
      <=> v6753(VarCurr,10) )
      & ( v6338(VarCurr,33)
      <=> v6753(VarCurr,9) )
      & ( v6338(VarCurr,32)
      <=> v6753(VarCurr,8) ) ) ).

tff(addAssignment_4036,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6753(VarCurr,B)
      <=> v6755(VarCurr,B) ) ) ).

tff(addAssignment_4035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6755(VarCurr,B)
      <=> v6757(VarCurr,B) ) ) ).

tff(addAssignment_4034,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6757(VarNext,B)
      <=> v8231(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_97,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8232(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8231(VarNext,B)
            <=> v6757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_97,axiom,
    ! [VarNext: state_type] :
      ( v8232(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8231(VarNext,B)
          <=> v7010(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8232(VarNext)
      <=> v8233(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_753,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8233(VarNext)
      <=> ( v8235(VarNext)
          & v6975(VarNext) ) ) ) ).

tff(writeUnaryOperator_558,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8235(VarNext)
      <=> v7004(VarNext) ) ) ).

tff(addAssignment_4033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6787(VarCurr,B)
      <=> v6789(VarCurr,B) ) ) ).

tff(addAssignment_4032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6789(VarCurr,B)
      <=> v6791(VarCurr,B) ) ) ).

tff(addAssignment_4031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6791(VarCurr,B)
      <=> v6959(VarCurr,B) ) ) ).

tff(addAssignment_4030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6924(VarCurr,B)
      <=> v6926(VarCurr,B) ) ) ).

tff(addAssignment_4029,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6926(VarCurr,B)
      <=> v6928(VarCurr,B) ) ) ).

tff(addAssignment_4028,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6928(VarCurr,B)
      <=> v6930(VarCurr,B) ) ) ).

tff(addAssignment_4027,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6930(VarCurr,B)
      <=> v6932(VarCurr,B) ) ) ).

tff(addAssignment_4026,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6888(VarCurr,B)
      <=> v6890(VarCurr,B) ) ) ).

tff(addAssignment_4025,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6890(VarCurr,B)
      <=> v6892(VarCurr,B) ) ) ).

tff(addAssignment_4024,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6892(VarCurr,B)
      <=> v6894(VarCurr,B) ) ) ).

tff(addAssignment_4023,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6894(VarCurr,B)
      <=> v6896(VarCurr,B) ) ) ).

tff(addAssignment_4022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6841(VarCurr,B)
      <=> v6843(VarCurr,B) ) ) ).

tff(addAssignment_4021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6843(VarCurr,B)
      <=> v6845(VarCurr,B) ) ) ).

tff(addAssignment_4020,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6845(VarCurr,B)
      <=> v6847(VarCurr,B) ) ) ).

tff(addAssignment_4019,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6847(VarCurr,B)
      <=> v6849(VarCurr,B) ) ) ).

tff(addAssignment_4018,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6793(VarCurr,B)
      <=> v6795(VarCurr,B) ) ) ).

tff(addAssignment_4017,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6795(VarCurr,B)
      <=> v6797(VarCurr,B) ) ) ).

tff(addAssignment_4016,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6797(VarCurr,B)
      <=> v6799(VarCurr,B) ) ) ).

tff(addAssignment_4015,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6799(VarCurr,B)
      <=> v6801(VarCurr,B) ) ) ).

tff(addAssignment_4014,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6330(VarCurr,B)
      <=> v6332(VarCurr,B) ) ) ).

tff(addAssignment_4013,axiom,
    ! [VarCurr: state_type] :
      ( ( v6332(VarCurr,11)
      <=> v6334(VarCurr,23) )
      & ( v6332(VarCurr,10)
      <=> v6334(VarCurr,22) )
      & ( v6332(VarCurr,9)
      <=> v6334(VarCurr,21) )
      & ( v6332(VarCurr,8)
      <=> v6334(VarCurr,20) ) ) ).

tff(addAssignment_4012,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_4011,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,24)
        & ~ $less(B,20) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_4010,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,23)
      <=> v6340(VarCurr,11) )
      & ( v6338(VarCurr,22)
      <=> v6340(VarCurr,10) )
      & ( v6338(VarCurr,21)
      <=> v6340(VarCurr,9) )
      & ( v6338(VarCurr,20)
      <=> v6340(VarCurr,8) ) ) ).

tff(addAssignment_4009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6340(VarCurr,B)
      <=> v6342(VarCurr,B) ) ) ).

tff(addAssignment_4008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6342(VarCurr,B)
      <=> v6344(VarCurr,B) ) ) ).

tff(addAssignment_4007,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6344(VarNext,B)
      <=> v8223(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_96,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8224(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8223(VarNext,B)
            <=> v6344(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_96,axiom,
    ! [VarNext: state_type] :
      ( v8224(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8223(VarNext,B)
          <=> v6606(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_752,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8224(VarNext)
      <=> v8225(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_751,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8225(VarNext)
      <=> ( v8227(VarNext)
          & v6567(VarNext) ) ) ) ).

tff(writeUnaryOperator_557,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8227(VarNext)
      <=> v6600(VarNext) ) ) ).

tff(addAssignment_4006,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6378(VarCurr,B)
      <=> v6380(VarCurr,B) ) ) ).

tff(addAssignment_4005,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6380(VarCurr,B)
      <=> v6382(VarCurr,B) ) ) ).

tff(addAssignment_4004,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6382(VarCurr,B)
      <=> v6550(VarCurr,B) ) ) ).

tff(addAssignment_4003,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6515(VarCurr,B)
      <=> v6517(VarCurr,B) ) ) ).

tff(addAssignment_4002,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6517(VarCurr,B)
      <=> v6519(VarCurr,B) ) ) ).

tff(addAssignment_4001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6519(VarCurr,B)
      <=> v6521(VarCurr,B) ) ) ).

tff(addAssignment_4000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6521(VarCurr,B)
      <=> v6523(VarCurr,B) ) ) ).

tff(addAssignment_3999,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6479(VarCurr,B)
      <=> v6481(VarCurr,B) ) ) ).

tff(addAssignment_3998,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6481(VarCurr,B)
      <=> v6483(VarCurr,B) ) ) ).

tff(addAssignment_3997,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6483(VarCurr,B)
      <=> v6485(VarCurr,B) ) ) ).

tff(addAssignment_3996,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6485(VarCurr,B)
      <=> v6487(VarCurr,B) ) ) ).

tff(addAssignment_3995,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6432(VarCurr,B)
      <=> v6434(VarCurr,B) ) ) ).

tff(addAssignment_3994,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6434(VarCurr,B)
      <=> v6436(VarCurr,B) ) ) ).

tff(addAssignment_3993,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6436(VarCurr,B)
      <=> v6438(VarCurr,B) ) ) ).

tff(addAssignment_3992,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6438(VarCurr,B)
      <=> v6440(VarCurr,B) ) ) ).

tff(addAssignment_3991,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6384(VarCurr,B)
      <=> v6386(VarCurr,B) ) ) ).

tff(addAssignment_3990,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6386(VarCurr,B)
      <=> v6388(VarCurr,B) ) ) ).

tff(addAssignment_3989,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6388(VarCurr,B)
      <=> v6390(VarCurr,B) ) ) ).

tff(addAssignment_3988,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6390(VarCurr,B)
      <=> v6392(VarCurr,B) ) ) ).

tff(addAssignment_3987,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6296(VarCurr,B)
      <=> v6298(VarCurr,B) ) ) ).

tff(addAssignment_3986,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,8) )
     => ( v6298(VarCurr,B)
      <=> v6315(VarCurr,B) ) ) ).

tff(addAssignment_3985,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6244(VarCurr,B)
      <=> v6246(VarCurr,B) ) ) ).

tff(addAssignment_3984,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6246(VarCurr,B)
      <=> v8199(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_143,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8199(VarCurr,B)
      <=> ( v8200(VarCurr,B)
          | v8219(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_142,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8219(VarCurr,B)
      <=> ( v8049(VarCurr,B)
          & v8220(VarCurr,B) ) ) ) ).

tff(addAssignment_3983,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,0)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3982,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,1)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3981,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,2)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3980,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,3)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3979,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,4)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3978,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,5)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3977,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,6)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3976,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,7)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3975,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,8)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3974,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,9)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3973,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,10)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3972,axiom,
    ! [VarCurr: state_type] :
      ( v8220(VarCurr,11)
    <=> v8221(VarCurr) ) ).

tff(addAssignment_3971,axiom,
    ! [VarCurr: state_type] :
      ( v8221(VarCurr)
    <=> v8169(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_141,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8200(VarCurr,B)
      <=> ( v8201(VarCurr,B)
          | v8216(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_140,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8216(VarCurr,B)
      <=> ( v7898(VarCurr,B)
          & v8217(VarCurr,B) ) ) ) ).

tff(addAssignment_3970,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,0)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3969,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,1)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3968,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,2)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3967,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,3)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3966,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,4)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3965,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,5)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3964,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,6)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3963,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,7)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3962,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,8)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3961,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,9)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3960,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,10)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3959,axiom,
    ! [VarCurr: state_type] :
      ( v8217(VarCurr,11)
    <=> v8218(VarCurr) ) ).

tff(addAssignment_3958,axiom,
    ! [VarCurr: state_type] :
      ( v8218(VarCurr)
    <=> v8018(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_139,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8201(VarCurr,B)
      <=> ( v8202(VarCurr,B)
          | v8213(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_138,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8213(VarCurr,B)
      <=> ( v7747(VarCurr,B)
          & v8214(VarCurr,B) ) ) ) ).

tff(addAssignment_3957,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,0)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3956,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,1)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3955,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,2)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3954,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,3)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3953,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,4)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3952,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,5)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3951,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,6)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3950,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,7)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3949,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,8)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3948,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,9)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3947,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,10)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3946,axiom,
    ! [VarCurr: state_type] :
      ( v8214(VarCurr,11)
    <=> v8215(VarCurr) ) ).

tff(addAssignment_3945,axiom,
    ! [VarCurr: state_type] :
      ( v8215(VarCurr)
    <=> v7867(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_137,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8202(VarCurr,B)
      <=> ( v8203(VarCurr,B)
          | v8210(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_136,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8210(VarCurr,B)
      <=> ( v7596(VarCurr,B)
          & v8211(VarCurr,B) ) ) ) ).

tff(addAssignment_3944,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,0)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3943,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,1)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3942,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,2)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3941,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,3)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3940,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,4)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3939,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,5)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3938,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,6)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3937,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,7)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3936,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,8)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3935,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,9)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3934,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,10)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3933,axiom,
    ! [VarCurr: state_type] :
      ( v8211(VarCurr,11)
    <=> v8212(VarCurr) ) ).

tff(addAssignment_3932,axiom,
    ! [VarCurr: state_type] :
      ( v8212(VarCurr)
    <=> v7716(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_135,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8203(VarCurr,B)
      <=> ( v8204(VarCurr,B)
          | v8207(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_134,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8207(VarCurr,B)
      <=> ( v7281(VarCurr,B)
          & v8208(VarCurr,B) ) ) ) ).

tff(addAssignment_3931,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,0)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3930,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,1)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3929,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,2)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3928,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,3)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3927,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,4)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3926,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,5)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3925,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,6)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3924,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,7)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3923,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,8)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3922,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,9)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3921,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,10)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3920,axiom,
    ! [VarCurr: state_type] :
      ( v8208(VarCurr,11)
    <=> v8209(VarCurr) ) ).

tff(addAssignment_3919,axiom,
    ! [VarCurr: state_type] :
      ( v8209(VarCurr)
    <=> v7412(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_133,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v8204(VarCurr,B)
      <=> ( v6248(VarCurr,B)
          & v8205(VarCurr,B) ) ) ) ).

tff(addAssignment_3918,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,0)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3917,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,1)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3916,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,2)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3915,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,3)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3914,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,4)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3913,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,5)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3912,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,6)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3911,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,7)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3910,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,8)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3909,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,9)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3908,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,10)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3907,axiom,
    ! [VarCurr: state_type] :
      ( v8205(VarCurr,11)
    <=> v8206(VarCurr) ) ).

tff(addAssignment_3906,axiom,
    ! [VarCurr: state_type] :
      ( v8206(VarCurr)
    <=> v7141(VarCurr) ) ).

tff(addAssignment_3905,axiom,
    ! [VarCurr: state_type] :
      ( v8169(VarCurr)
    <=> v8171(VarCurr) ) ).

tff(addAssignment_3904,axiom,
    ! [VarCurr: state_type] :
      ( v8171(VarCurr)
    <=> v8173(VarCurr) ) ).

tff(addAssignment_3903,axiom,
    ! [VarCurr: state_type] :
      ( v8173(VarCurr)
    <=> v8175(VarCurr) ) ).

tff(addAssignment_3902,axiom,
    ! [VarCurr: state_type] :
      ( v8175(VarCurr)
    <=> v8177(VarCurr) ) ).

tff(addAssignment_3901,axiom,
    ! [VarCurr: state_type] :
      ( v8177(VarCurr)
    <=> v8179(VarCurr) ) ).

tff(addAssignment_3900,axiom,
    ! [VarCurr: state_type] :
      ( v8179(VarCurr)
    <=> v8181(VarCurr) ) ).

tff(addAssignment_3899,axiom,
    ! [VarCurr: state_type] :
      ( v8181(VarCurr)
    <=> v8183(VarCurr) ) ).

tff(writeUnaryOperator_556,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8183(VarCurr)
    <=> v8197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_750,axiom,
    ! [VarCurr: state_type] :
      ( v8197(VarCurr)
    <=> ( v8198(VarCurr)
        | v8193(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_749,axiom,
    ! [VarCurr: state_type] :
      ( v8198(VarCurr)
    <=> ( v8185(VarCurr)
        | v8189(VarCurr) ) ) ).

tff(addAssignment_3898,axiom,
    ! [VarCurr: state_type] :
      ( v8193(VarCurr)
    <=> v8195(VarCurr) ) ).

tff(addAssignment_3897,axiom,
    ! [VarCurr: state_type] :
      ( v8195(VarCurr)
    <=> v7432(VarCurr,2) ) ).

tff(addAssignment_3896,axiom,
    ! [VarCurr: state_type] :
      ( v8189(VarCurr)
    <=> v8191(VarCurr) ) ).

tff(addAssignment_3895,axiom,
    ! [VarCurr: state_type] :
      ( v8191(VarCurr)
    <=> v7161(VarCurr,1) ) ).

tff(addAssignment_3894,axiom,
    ! [VarCurr: state_type] :
      ( v8185(VarCurr)
    <=> v8187(VarCurr) ) ).

tff(addAssignment_3893,axiom,
    ! [VarCurr: state_type] :
      ( v8187(VarCurr)
    <=> v7432(VarCurr,0) ) ).

tff(addAssignment_3892,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8049(VarCurr,B)
      <=> v8051(VarCurr,B) ) ) ).

tff(addAssignment_3891,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8051(VarCurr,B)
      <=> v8053(VarCurr,B) ) ) ).

tff(addAssignment_3890,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8053(VarCurr,B)
      <=> v8055(VarCurr,B) ) ) ).

tff(addAssignment_3889,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8055(VarCurr,B)
      <=> v8057(VarCurr,B) ) ) ).

tff(addAssignment_3888,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8057(VarNext,B)
      <=> v8151(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_95,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8152(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8151(VarNext,B)
            <=> v8057(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_95,axiom,
    ! [VarNext: state_type] :
      ( v8152(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8151(VarNext,B)
          <=> v8162(VarNext,B) ) ) ) ).

tff(addAssignment_3887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8162(VarNext,B)
          <=> v8160(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_88,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8163(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8160(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_88,axiom,
    ! [VarCurr: state_type] :
      ( v8163(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8160(VarCurr,B)
          <=> v8079(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_748,axiom,
    ! [VarCurr: state_type] :
      ( v8163(VarCurr)
    <=> ( v8164(VarCurr)
        & v8165(VarCurr) ) ) ).

tff(writeUnaryOperator_555,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8165(VarCurr)
    <=> v8069(VarCurr) ) ).

tff(writeUnaryOperator_554,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8164(VarCurr)
    <=> v8059(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_747,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8152(VarNext)
      <=> v8153(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_746,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8153(VarNext)
      <=> ( v8154(VarNext)
          & v8083(VarNext) ) ) ) ).

tff(writeUnaryOperator_553,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8154(VarNext)
      <=> v8156(VarNext) ) ) ).

tff(addAssignment_3886,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8156(VarNext)
      <=> v8083(VarCurr) ) ) ).

tff(addAssignment_3885,axiom,
    ! [VarCurr: state_type] :
      ( v8083(VarCurr)
    <=> v8085(VarCurr) ) ).

tff(addAssignment_3884,axiom,
    ! [VarCurr: state_type] :
      ( v8085(VarCurr)
    <=> v8087(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_745,axiom,
    ! [VarCurr: state_type] :
      ( v8087(VarCurr)
    <=> ( v8149(VarCurr)
        | v8145(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_744,axiom,
    ! [VarCurr: state_type] :
      ( v8149(VarCurr)
    <=> ( v8089(VarCurr)
        & v8093(VarCurr) ) ) ).

tff(addAssignment_3883,axiom,
    ! [VarCurr: state_type] :
      ( v8145(VarCurr)
    <=> v8147(VarCurr) ) ).

tff(addAssignment_3882,axiom,
    ! [VarCurr: state_type] :
      ( v8147(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_94,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8129(VarNext)
       => ( v8093(VarNext)
        <=> v8093(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_94,axiom,
    ! [VarNext: state_type] :
      ( v8129(VarNext)
     => ( v8093(VarNext)
      <=> v8139(VarNext) ) ) ).

tff(addAssignment_3881,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8139(VarNext)
      <=> v8137(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_743,axiom,
    ! [VarCurr: state_type] :
      ( v8137(VarCurr)
    <=> ( v8140(VarCurr)
        & v8141(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_742,axiom,
    ! [VarCurr: state_type] :
      ( v8141(VarCurr)
    <=> ( v8099(VarCurr)
        | v8124(VarCurr) ) ) ).

tff(writeUnaryOperator_552,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8140(VarCurr)
    <=> v8095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_741,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8129(VarNext)
      <=> v8130(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_740,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8130(VarNext)
      <=> ( v8132(VarNext)
          & v8134(VarNext) ) ) ) ).

tff(writeUnaryOperator_551,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8134(VarCurr)
    <=> v8089(VarCurr) ) ).

tff(addAssignment_3880,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8132(VarNext)
      <=> v8089(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_20,axiom,
    ( v8093(constB0)
  <=> $true ) ).

tff(addAssignment_3879,axiom,
    ! [VarCurr: state_type] :
      ( v8124(VarCurr)
    <=> v8126(VarCurr) ) ).

tff(addAssignment_3878,axiom,
    ! [VarCurr: state_type] :
      ( v8126(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3877,axiom,
    ! [VarCurr: state_type] :
      ( v8099(VarCurr)
    <=> v8101(VarCurr) ) ).

tff(addAssignment_3876,axiom,
    ! [VarCurr: state_type] :
      ( v8101(VarCurr)
    <=> v8103(VarCurr) ) ).

tff(addAssignment_3875,axiom,
    ! [VarCurr: state_type] :
      ( v8103(VarCurr)
    <=> v8105(VarCurr) ) ).

tff(addAssignment_3874,axiom,
    ! [VarCurr: state_type] :
      ( v8105(VarCurr)
    <=> v8107(VarCurr) ) ).

tff(writeUnaryOperator_550,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8107(VarCurr)
    <=> v8121(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_739,axiom,
    ! [VarCurr: state_type] :
      ( v8121(VarCurr)
    <=> ( v8122(VarCurr)
        | v8117(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_738,axiom,
    ! [VarCurr: state_type] :
      ( v8122(VarCurr)
    <=> ( v8109(VarCurr)
        | v8113(VarCurr) ) ) ).

tff(addAssignment_3873,axiom,
    ! [VarCurr: state_type] :
      ( v8117(VarCurr)
    <=> v8119(VarCurr) ) ).

tff(addAssignment_3872,axiom,
    ! [VarCurr: state_type] :
      ( v8119(VarCurr)
    <=> v7345(VarCurr,2) ) ).

tff(addAssignment_3871,axiom,
    ! [VarCurr: state_type] :
      ( v8113(VarCurr)
    <=> v8115(VarCurr) ) ).

tff(addAssignment_3870,axiom,
    ! [VarCurr: state_type] :
      ( v8115(VarCurr)
    <=> v7067(VarCurr,1) ) ).

tff(addAssignment_3869,axiom,
    ! [VarCurr: state_type] :
      ( v8109(VarCurr)
    <=> v8111(VarCurr) ) ).

tff(addAssignment_3868,axiom,
    ! [VarCurr: state_type] :
      ( v8111(VarCurr)
    <=> v7345(VarCurr,0) ) ).

tff(addAssignment_3867,axiom,
    ! [VarCurr: state_type] :
      ( v8095(VarCurr)
    <=> v8097(VarCurr) ) ).

tff(addAssignment_3866,axiom,
    ! [VarCurr: state_type] :
      ( v8097(VarCurr)
    <=> $false ) ).

tff(addAssignment_3865,axiom,
    ! [VarCurr: state_type] :
      ( v8089(VarCurr)
    <=> v8091(VarCurr) ) ).

tff(addAssignment_3864,axiom,
    ! [VarCurr: state_type] :
      ( v8091(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8079(VarCurr,B)
      <=> v8081(VarCurr,B) ) ) ).

tff(addAssignment_3862,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v8081(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3861,axiom,
    ! [VarCurr: state_type] :
      ( v8069(VarCurr)
    <=> v8071(VarCurr) ) ).

tff(addAssignment_3860,axiom,
    ! [VarCurr: state_type] :
      ( v8071(VarCurr)
    <=> v8073(VarCurr) ) ).

tff(addAssignment_3859,axiom,
    ! [VarCurr: state_type] :
      ( v8073(VarCurr)
    <=> v8075(VarCurr) ) ).

tff(addAssignment_3858,axiom,
    ! [VarCurr: state_type] :
      ( v8075(VarCurr)
    <=> v8077(VarCurr) ) ).

tff(addAssignment_3857,axiom,
    ! [VarCurr: state_type] :
      ( v8077(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3856,axiom,
    ! [VarCurr: state_type] :
      ( v8059(VarCurr)
    <=> v8061(VarCurr) ) ).

tff(addAssignment_3855,axiom,
    ! [VarCurr: state_type] :
      ( v8061(VarCurr)
    <=> v8063(VarCurr) ) ).

tff(addAssignment_3854,axiom,
    ! [VarCurr: state_type] :
      ( v8063(VarCurr)
    <=> v8065(VarCurr) ) ).

tff(addAssignment_3853,axiom,
    ! [VarCurr: state_type] :
      ( v8065(VarCurr)
    <=> v8067(VarCurr) ) ).

tff(addAssignment_3852,axiom,
    ! [VarCurr: state_type] :
      ( v8067(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_3851,axiom,
    ! [VarCurr: state_type] :
      ( v8018(VarCurr)
    <=> v8020(VarCurr) ) ).

tff(addAssignment_3850,axiom,
    ! [VarCurr: state_type] :
      ( v8020(VarCurr)
    <=> v8022(VarCurr) ) ).

tff(addAssignment_3849,axiom,
    ! [VarCurr: state_type] :
      ( v8022(VarCurr)
    <=> v8024(VarCurr) ) ).

tff(addAssignment_3848,axiom,
    ! [VarCurr: state_type] :
      ( v8024(VarCurr)
    <=> v8026(VarCurr) ) ).

tff(addAssignment_3847,axiom,
    ! [VarCurr: state_type] :
      ( v8026(VarCurr)
    <=> v8028(VarCurr) ) ).

tff(addAssignment_3846,axiom,
    ! [VarCurr: state_type] :
      ( v8028(VarCurr)
    <=> v8030(VarCurr) ) ).

tff(addAssignment_3845,axiom,
    ! [VarCurr: state_type] :
      ( v8030(VarCurr)
    <=> v8032(VarCurr) ) ).

tff(writeUnaryOperator_549,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8032(VarCurr)
    <=> v8046(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_737,axiom,
    ! [VarCurr: state_type] :
      ( v8046(VarCurr)
    <=> ( v8047(VarCurr)
        | v8042(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_736,axiom,
    ! [VarCurr: state_type] :
      ( v8047(VarCurr)
    <=> ( v8034(VarCurr)
        | v8038(VarCurr) ) ) ).

tff(addAssignment_3844,axiom,
    ! [VarCurr: state_type] :
      ( v8042(VarCurr)
    <=> v8044(VarCurr) ) ).

tff(addAssignment_3843,axiom,
    ! [VarCurr: state_type] :
      ( v8044(VarCurr)
    <=> v7432(VarCurr,2) ) ).

tff(addAssignment_3842,axiom,
    ! [VarCurr: state_type] :
      ( v7432(VarCurr,2)
    <=> v7434(VarCurr,2) ) ).

tff(addAssignment_3841,axiom,
    ! [VarCurr: state_type] :
      ( v7434(VarCurr,2)
    <=> v7436(VarCurr,2) ) ).

tff(addAssignment_3840,axiom,
    ! [VarCurr: state_type] :
      ( v7436(VarCurr,2)
    <=> v7441(VarCurr,2) ) ).

tff(addAssignment_3839,axiom,
    ! [VarCurr: state_type] :
      ( v7438(VarCurr,2)
    <=> v7440(VarCurr,2) ) ).

tff(addAssignment_3838,axiom,
    ! [VarCurr: state_type] :
      ( v7440(VarCurr,2)
    <=> v7161(VarCurr,2) ) ).

tff(addAssignment_3837,axiom,
    ! [VarCurr: state_type] :
      ( v8038(VarCurr)
    <=> v8040(VarCurr) ) ).

tff(addAssignment_3836,axiom,
    ! [VarCurr: state_type] :
      ( v8040(VarCurr)
    <=> v7161(VarCurr,1) ) ).

tff(addAssignment_3835,axiom,
    ! [VarCurr: state_type] :
      ( v8034(VarCurr)
    <=> v8036(VarCurr) ) ).

tff(addAssignment_3834,axiom,
    ! [VarCurr: state_type] :
      ( v8036(VarCurr)
    <=> v7161(VarCurr,0) ) ).

tff(addAssignment_3833,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7898(VarCurr,B)
      <=> v7900(VarCurr,B) ) ) ).

tff(addAssignment_3832,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7900(VarCurr,B)
      <=> v7902(VarCurr,B) ) ) ).

tff(addAssignment_3831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7902(VarCurr,B)
      <=> v7904(VarCurr,B) ) ) ).

tff(addAssignment_3830,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7904(VarCurr,B)
      <=> v7906(VarCurr,B) ) ) ).

tff(addAssignment_3829,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7906(VarNext,B)
      <=> v8000(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_93,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8001(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v8000(VarNext,B)
            <=> v7906(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_93,axiom,
    ! [VarNext: state_type] :
      ( v8001(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8000(VarNext,B)
          <=> v8011(VarNext,B) ) ) ) ).

tff(addAssignment_3828,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8011(VarNext,B)
          <=> v8009(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_87,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8009(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_87,axiom,
    ! [VarCurr: state_type] :
      ( v8012(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v8009(VarCurr,B)
          <=> v7928(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_735,axiom,
    ! [VarCurr: state_type] :
      ( v8012(VarCurr)
    <=> ( v8013(VarCurr)
        & v8014(VarCurr) ) ) ).

tff(writeUnaryOperator_548,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8014(VarCurr)
    <=> v7918(VarCurr) ) ).

tff(writeUnaryOperator_547,axiom,
    ! [VarCurr: state_type] :
      ( ~ v8013(VarCurr)
    <=> v7908(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_734,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8001(VarNext)
      <=> v8002(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_733,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8002(VarNext)
      <=> ( v8003(VarNext)
          & v7932(VarNext) ) ) ) ).

tff(writeUnaryOperator_546,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v8003(VarNext)
      <=> v8005(VarNext) ) ) ).

tff(addAssignment_3827,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v8005(VarNext)
      <=> v7932(VarCurr) ) ) ).

tff(addAssignment_3826,axiom,
    ! [VarCurr: state_type] :
      ( v7932(VarCurr)
    <=> v7934(VarCurr) ) ).

tff(addAssignment_3825,axiom,
    ! [VarCurr: state_type] :
      ( v7934(VarCurr)
    <=> v7936(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_732,axiom,
    ! [VarCurr: state_type] :
      ( v7936(VarCurr)
    <=> ( v7998(VarCurr)
        | v7994(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_731,axiom,
    ! [VarCurr: state_type] :
      ( v7998(VarCurr)
    <=> ( v7938(VarCurr)
        & v7942(VarCurr) ) ) ).

tff(addAssignment_3824,axiom,
    ! [VarCurr: state_type] :
      ( v7994(VarCurr)
    <=> v7996(VarCurr) ) ).

tff(addAssignment_3823,axiom,
    ! [VarCurr: state_type] :
      ( v7996(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_92,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7978(VarNext)
       => ( v7942(VarNext)
        <=> v7942(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_92,axiom,
    ! [VarNext: state_type] :
      ( v7978(VarNext)
     => ( v7942(VarNext)
      <=> v7988(VarNext) ) ) ).

tff(addAssignment_3822,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7988(VarNext)
      <=> v7986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_730,axiom,
    ! [VarCurr: state_type] :
      ( v7986(VarCurr)
    <=> ( v7989(VarCurr)
        & v7990(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_729,axiom,
    ! [VarCurr: state_type] :
      ( v7990(VarCurr)
    <=> ( v7948(VarCurr)
        | v7973(VarCurr) ) ) ).

tff(writeUnaryOperator_545,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7989(VarCurr)
    <=> v7944(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_728,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7978(VarNext)
      <=> v7979(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_727,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7979(VarNext)
      <=> ( v7981(VarNext)
          & v7983(VarNext) ) ) ) ).

tff(writeUnaryOperator_544,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7983(VarCurr)
    <=> v7938(VarCurr) ) ).

tff(addAssignment_3821,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7981(VarNext)
      <=> v7938(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_19,axiom,
    ( v7942(constB0)
  <=> $true ) ).

tff(addAssignment_3820,axiom,
    ! [VarCurr: state_type] :
      ( v7973(VarCurr)
    <=> v7975(VarCurr) ) ).

tff(addAssignment_3819,axiom,
    ! [VarCurr: state_type] :
      ( v7975(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3818,axiom,
    ! [VarCurr: state_type] :
      ( v7948(VarCurr)
    <=> v7950(VarCurr) ) ).

tff(addAssignment_3817,axiom,
    ! [VarCurr: state_type] :
      ( v7950(VarCurr)
    <=> v7952(VarCurr) ) ).

tff(addAssignment_3816,axiom,
    ! [VarCurr: state_type] :
      ( v7952(VarCurr)
    <=> v7954(VarCurr) ) ).

tff(addAssignment_3815,axiom,
    ! [VarCurr: state_type] :
      ( v7954(VarCurr)
    <=> v7956(VarCurr) ) ).

tff(writeUnaryOperator_543,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7956(VarCurr)
    <=> v7970(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_726,axiom,
    ! [VarCurr: state_type] :
      ( v7970(VarCurr)
    <=> ( v7971(VarCurr)
        | v7966(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_725,axiom,
    ! [VarCurr: state_type] :
      ( v7971(VarCurr)
    <=> ( v7958(VarCurr)
        | v7962(VarCurr) ) ) ).

tff(addAssignment_3814,axiom,
    ! [VarCurr: state_type] :
      ( v7966(VarCurr)
    <=> v7968(VarCurr) ) ).

tff(addAssignment_3813,axiom,
    ! [VarCurr: state_type] :
      ( v7968(VarCurr)
    <=> v7345(VarCurr,2) ) ).

tff(addAssignment_3812,axiom,
    ! [VarCurr: state_type] :
      ( v7345(VarCurr,2)
    <=> v7347(VarCurr,2) ) ).

tff(addAssignment_3811,axiom,
    ! [VarCurr: state_type] :
      ( v7347(VarCurr,2)
    <=> v7349(VarCurr,2) ) ).

tff(addAssignment_3810,axiom,
    ! [VarCurr: state_type] :
      ( v7349(VarCurr,2)
    <=> v7354(VarCurr,2) ) ).

tff(addAssignment_3809,axiom,
    ! [VarCurr: state_type] :
      ( v7351(VarCurr,2)
    <=> v7353(VarCurr,2) ) ).

tff(addAssignment_3808,axiom,
    ! [VarCurr: state_type] :
      ( v7353(VarCurr,2)
    <=> v7067(VarCurr,2) ) ).

tff(addAssignment_3807,axiom,
    ! [VarCurr: state_type] :
      ( v7962(VarCurr)
    <=> v7964(VarCurr) ) ).

tff(addAssignment_3806,axiom,
    ! [VarCurr: state_type] :
      ( v7964(VarCurr)
    <=> v7067(VarCurr,1) ) ).

tff(addAssignment_3805,axiom,
    ! [VarCurr: state_type] :
      ( v7958(VarCurr)
    <=> v7960(VarCurr) ) ).

tff(addAssignment_3804,axiom,
    ! [VarCurr: state_type] :
      ( v7960(VarCurr)
    <=> v7067(VarCurr,0) ) ).

tff(addAssignment_3803,axiom,
    ! [VarCurr: state_type] :
      ( v7944(VarCurr)
    <=> v7946(VarCurr) ) ).

tff(addAssignment_3802,axiom,
    ! [VarCurr: state_type] :
      ( v7946(VarCurr)
    <=> $false ) ).

tff(addAssignment_3801,axiom,
    ! [VarCurr: state_type] :
      ( v7938(VarCurr)
    <=> v7940(VarCurr) ) ).

tff(addAssignment_3800,axiom,
    ! [VarCurr: state_type] :
      ( v7940(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3799,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7928(VarCurr,B)
      <=> v7930(VarCurr,B) ) ) ).

tff(addAssignment_3798,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7930(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3797,axiom,
    ! [VarCurr: state_type] :
      ( v7918(VarCurr)
    <=> v7920(VarCurr) ) ).

tff(addAssignment_3796,axiom,
    ! [VarCurr: state_type] :
      ( v7920(VarCurr)
    <=> v7922(VarCurr) ) ).

tff(addAssignment_3795,axiom,
    ! [VarCurr: state_type] :
      ( v7922(VarCurr)
    <=> v7924(VarCurr) ) ).

tff(addAssignment_3794,axiom,
    ! [VarCurr: state_type] :
      ( v7924(VarCurr)
    <=> v7926(VarCurr) ) ).

tff(addAssignment_3793,axiom,
    ! [VarCurr: state_type] :
      ( v7926(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3792,axiom,
    ! [VarCurr: state_type] :
      ( v7908(VarCurr)
    <=> v7910(VarCurr) ) ).

tff(addAssignment_3791,axiom,
    ! [VarCurr: state_type] :
      ( v7910(VarCurr)
    <=> v7912(VarCurr) ) ).

tff(addAssignment_3790,axiom,
    ! [VarCurr: state_type] :
      ( v7912(VarCurr)
    <=> v7914(VarCurr) ) ).

tff(addAssignment_3789,axiom,
    ! [VarCurr: state_type] :
      ( v7914(VarCurr)
    <=> v7916(VarCurr) ) ).

tff(addAssignment_3788,axiom,
    ! [VarCurr: state_type] :
      ( v7916(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_3787,axiom,
    ! [VarCurr: state_type] :
      ( v7867(VarCurr)
    <=> v7869(VarCurr) ) ).

tff(addAssignment_3786,axiom,
    ! [VarCurr: state_type] :
      ( v7869(VarCurr)
    <=> v7871(VarCurr) ) ).

tff(addAssignment_3785,axiom,
    ! [VarCurr: state_type] :
      ( v7871(VarCurr)
    <=> v7873(VarCurr) ) ).

tff(addAssignment_3784,axiom,
    ! [VarCurr: state_type] :
      ( v7873(VarCurr)
    <=> v7875(VarCurr) ) ).

tff(addAssignment_3783,axiom,
    ! [VarCurr: state_type] :
      ( v7875(VarCurr)
    <=> v7877(VarCurr) ) ).

tff(addAssignment_3782,axiom,
    ! [VarCurr: state_type] :
      ( v7877(VarCurr)
    <=> v7879(VarCurr) ) ).

tff(addAssignment_3781,axiom,
    ! [VarCurr: state_type] :
      ( v7879(VarCurr)
    <=> v7881(VarCurr) ) ).

tff(writeUnaryOperator_542,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7881(VarCurr)
    <=> v7895(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_724,axiom,
    ! [VarCurr: state_type] :
      ( v7895(VarCurr)
    <=> ( v7896(VarCurr)
        | v7891(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_723,axiom,
    ! [VarCurr: state_type] :
      ( v7896(VarCurr)
    <=> ( v7883(VarCurr)
        | v7887(VarCurr) ) ) ).

tff(addAssignment_3780,axiom,
    ! [VarCurr: state_type] :
      ( v7891(VarCurr)
    <=> v7893(VarCurr) ) ).

tff(addAssignment_3779,axiom,
    ! [VarCurr: state_type] :
      ( v7893(VarCurr)
    <=> v7161(VarCurr,2) ) ).

tff(addAssignment_3778,axiom,
    ! [VarCurr: state_type] :
      ( v7887(VarCurr)
    <=> v7889(VarCurr) ) ).

tff(addAssignment_3777,axiom,
    ! [VarCurr: state_type] :
      ( v7889(VarCurr)
    <=> v7432(VarCurr,1) ) ).

tff(addAssignment_3776,axiom,
    ! [VarCurr: state_type] :
      ( v7883(VarCurr)
    <=> v7885(VarCurr) ) ).

tff(addAssignment_3775,axiom,
    ! [VarCurr: state_type] :
      ( v7885(VarCurr)
    <=> v7432(VarCurr,0) ) ).

tff(addAssignment_3774,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7747(VarCurr,B)
      <=> v7749(VarCurr,B) ) ) ).

tff(addAssignment_3773,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7749(VarCurr,B)
      <=> v7751(VarCurr,B) ) ) ).

tff(addAssignment_3772,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7751(VarCurr,B)
      <=> v7753(VarCurr,B) ) ) ).

tff(addAssignment_3771,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7753(VarCurr,B)
      <=> v7755(VarCurr,B) ) ) ).

tff(addAssignment_3770,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7755(VarNext,B)
      <=> v7849(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_91,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7850(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7849(VarNext,B)
            <=> v7755(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_91,axiom,
    ! [VarNext: state_type] :
      ( v7850(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7849(VarNext,B)
          <=> v7860(VarNext,B) ) ) ) ).

tff(addAssignment_3769,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7860(VarNext,B)
          <=> v7858(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_86,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7861(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7858(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_86,axiom,
    ! [VarCurr: state_type] :
      ( v7861(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7858(VarCurr,B)
          <=> v7777(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_722,axiom,
    ! [VarCurr: state_type] :
      ( v7861(VarCurr)
    <=> ( v7862(VarCurr)
        & v7863(VarCurr) ) ) ).

tff(writeUnaryOperator_541,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7863(VarCurr)
    <=> v7767(VarCurr) ) ).

tff(writeUnaryOperator_540,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7862(VarCurr)
    <=> v7757(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_721,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7850(VarNext)
      <=> v7851(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7851(VarNext)
      <=> ( v7852(VarNext)
          & v7781(VarNext) ) ) ) ).

tff(writeUnaryOperator_539,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7852(VarNext)
      <=> v7854(VarNext) ) ) ).

tff(addAssignment_3768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7854(VarNext)
      <=> v7781(VarCurr) ) ) ).

tff(addAssignment_3767,axiom,
    ! [VarCurr: state_type] :
      ( v7781(VarCurr)
    <=> v7783(VarCurr) ) ).

tff(addAssignment_3766,axiom,
    ! [VarCurr: state_type] :
      ( v7783(VarCurr)
    <=> v7785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_719,axiom,
    ! [VarCurr: state_type] :
      ( v7785(VarCurr)
    <=> ( v7847(VarCurr)
        | v7843(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_718,axiom,
    ! [VarCurr: state_type] :
      ( v7847(VarCurr)
    <=> ( v7787(VarCurr)
        & v7791(VarCurr) ) ) ).

tff(addAssignment_3765,axiom,
    ! [VarCurr: state_type] :
      ( v7843(VarCurr)
    <=> v7845(VarCurr) ) ).

tff(addAssignment_3764,axiom,
    ! [VarCurr: state_type] :
      ( v7845(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_90,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7827(VarNext)
       => ( v7791(VarNext)
        <=> v7791(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_90,axiom,
    ! [VarNext: state_type] :
      ( v7827(VarNext)
     => ( v7791(VarNext)
      <=> v7837(VarNext) ) ) ).

tff(addAssignment_3763,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7837(VarNext)
      <=> v7835(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_717,axiom,
    ! [VarCurr: state_type] :
      ( v7835(VarCurr)
    <=> ( v7838(VarCurr)
        & v7839(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_716,axiom,
    ! [VarCurr: state_type] :
      ( v7839(VarCurr)
    <=> ( v7797(VarCurr)
        | v7822(VarCurr) ) ) ).

tff(writeUnaryOperator_538,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7838(VarCurr)
    <=> v7793(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_715,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7827(VarNext)
      <=> v7828(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_714,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7828(VarNext)
      <=> ( v7830(VarNext)
          & v7832(VarNext) ) ) ) ).

tff(writeUnaryOperator_537,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7832(VarCurr)
    <=> v7787(VarCurr) ) ).

tff(addAssignment_3762,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7830(VarNext)
      <=> v7787(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_18,axiom,
    ( v7791(constB0)
  <=> $true ) ).

tff(addAssignment_3761,axiom,
    ! [VarCurr: state_type] :
      ( v7822(VarCurr)
    <=> v7824(VarCurr) ) ).

tff(addAssignment_3760,axiom,
    ! [VarCurr: state_type] :
      ( v7824(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3759,axiom,
    ! [VarCurr: state_type] :
      ( v7797(VarCurr)
    <=> v7799(VarCurr) ) ).

tff(addAssignment_3758,axiom,
    ! [VarCurr: state_type] :
      ( v7799(VarCurr)
    <=> v7801(VarCurr) ) ).

tff(addAssignment_3757,axiom,
    ! [VarCurr: state_type] :
      ( v7801(VarCurr)
    <=> v7803(VarCurr) ) ).

tff(addAssignment_3756,axiom,
    ! [VarCurr: state_type] :
      ( v7803(VarCurr)
    <=> v7805(VarCurr) ) ).

tff(writeUnaryOperator_536,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7805(VarCurr)
    <=> v7819(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_713,axiom,
    ! [VarCurr: state_type] :
      ( v7819(VarCurr)
    <=> ( v7820(VarCurr)
        | v7815(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_712,axiom,
    ! [VarCurr: state_type] :
      ( v7820(VarCurr)
    <=> ( v7807(VarCurr)
        | v7811(VarCurr) ) ) ).

tff(addAssignment_3755,axiom,
    ! [VarCurr: state_type] :
      ( v7815(VarCurr)
    <=> v7817(VarCurr) ) ).

tff(addAssignment_3754,axiom,
    ! [VarCurr: state_type] :
      ( v7817(VarCurr)
    <=> v7067(VarCurr,2) ) ).

tff(addAssignment_3753,axiom,
    ! [VarCurr: state_type] :
      ( v7811(VarCurr)
    <=> v7813(VarCurr) ) ).

tff(addAssignment_3752,axiom,
    ! [VarCurr: state_type] :
      ( v7813(VarCurr)
    <=> v7345(VarCurr,1) ) ).

tff(addAssignment_3751,axiom,
    ! [VarCurr: state_type] :
      ( v7807(VarCurr)
    <=> v7809(VarCurr) ) ).

tff(addAssignment_3750,axiom,
    ! [VarCurr: state_type] :
      ( v7809(VarCurr)
    <=> v7345(VarCurr,0) ) ).

tff(addAssignment_3749,axiom,
    ! [VarCurr: state_type] :
      ( v7793(VarCurr)
    <=> v7795(VarCurr) ) ).

tff(addAssignment_3748,axiom,
    ! [VarCurr: state_type] :
      ( v7795(VarCurr)
    <=> $false ) ).

tff(addAssignment_3747,axiom,
    ! [VarCurr: state_type] :
      ( v7787(VarCurr)
    <=> v7789(VarCurr) ) ).

tff(addAssignment_3746,axiom,
    ! [VarCurr: state_type] :
      ( v7789(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7777(VarCurr,B)
      <=> v7779(VarCurr,B) ) ) ).

tff(addAssignment_3744,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7779(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3743,axiom,
    ! [VarCurr: state_type] :
      ( v7767(VarCurr)
    <=> v7769(VarCurr) ) ).

tff(addAssignment_3742,axiom,
    ! [VarCurr: state_type] :
      ( v7769(VarCurr)
    <=> v7771(VarCurr) ) ).

tff(addAssignment_3741,axiom,
    ! [VarCurr: state_type] :
      ( v7771(VarCurr)
    <=> v7773(VarCurr) ) ).

tff(addAssignment_3740,axiom,
    ! [VarCurr: state_type] :
      ( v7773(VarCurr)
    <=> v7775(VarCurr) ) ).

tff(addAssignment_3739,axiom,
    ! [VarCurr: state_type] :
      ( v7775(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3738,axiom,
    ! [VarCurr: state_type] :
      ( v7757(VarCurr)
    <=> v7759(VarCurr) ) ).

tff(addAssignment_3737,axiom,
    ! [VarCurr: state_type] :
      ( v7759(VarCurr)
    <=> v7761(VarCurr) ) ).

tff(addAssignment_3736,axiom,
    ! [VarCurr: state_type] :
      ( v7761(VarCurr)
    <=> v7763(VarCurr) ) ).

tff(addAssignment_3735,axiom,
    ! [VarCurr: state_type] :
      ( v7763(VarCurr)
    <=> v7765(VarCurr) ) ).

tff(addAssignment_3734,axiom,
    ! [VarCurr: state_type] :
      ( v7765(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_3733,axiom,
    ! [VarCurr: state_type] :
      ( v7716(VarCurr)
    <=> v7718(VarCurr) ) ).

tff(addAssignment_3732,axiom,
    ! [VarCurr: state_type] :
      ( v7718(VarCurr)
    <=> v7720(VarCurr) ) ).

tff(addAssignment_3731,axiom,
    ! [VarCurr: state_type] :
      ( v7720(VarCurr)
    <=> v7722(VarCurr) ) ).

tff(addAssignment_3730,axiom,
    ! [VarCurr: state_type] :
      ( v7722(VarCurr)
    <=> v7724(VarCurr) ) ).

tff(addAssignment_3729,axiom,
    ! [VarCurr: state_type] :
      ( v7724(VarCurr)
    <=> v7726(VarCurr) ) ).

tff(addAssignment_3728,axiom,
    ! [VarCurr: state_type] :
      ( v7726(VarCurr)
    <=> v7728(VarCurr) ) ).

tff(addAssignment_3727,axiom,
    ! [VarCurr: state_type] :
      ( v7728(VarCurr)
    <=> v7730(VarCurr) ) ).

tff(writeUnaryOperator_535,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7730(VarCurr)
    <=> v7744(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_711,axiom,
    ! [VarCurr: state_type] :
      ( v7744(VarCurr)
    <=> ( v7745(VarCurr)
        | v7740(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_710,axiom,
    ! [VarCurr: state_type] :
      ( v7745(VarCurr)
    <=> ( v7732(VarCurr)
        | v7736(VarCurr) ) ) ).

tff(addAssignment_3726,axiom,
    ! [VarCurr: state_type] :
      ( v7740(VarCurr)
    <=> v7742(VarCurr) ) ).

tff(addAssignment_3725,axiom,
    ! [VarCurr: state_type] :
      ( v7742(VarCurr)
    <=> v7161(VarCurr,2) ) ).

tff(addAssignment_3724,axiom,
    ! [VarCurr: state_type] :
      ( v7736(VarCurr)
    <=> v7738(VarCurr) ) ).

tff(addAssignment_3723,axiom,
    ! [VarCurr: state_type] :
      ( v7738(VarCurr)
    <=> v7432(VarCurr,1) ) ).

tff(addAssignment_3722,axiom,
    ! [VarCurr: state_type] :
      ( v7432(VarCurr,1)
    <=> v7434(VarCurr,1) ) ).

tff(addAssignment_3721,axiom,
    ! [VarCurr: state_type] :
      ( v7434(VarCurr,1)
    <=> v7436(VarCurr,1) ) ).

tff(addAssignment_3720,axiom,
    ! [VarCurr: state_type] :
      ( v7436(VarCurr,1)
    <=> v7441(VarCurr,1) ) ).

tff(addAssignment_3719,axiom,
    ! [VarCurr: state_type] :
      ( v7438(VarCurr,1)
    <=> v7440(VarCurr,1) ) ).

tff(addAssignment_3718,axiom,
    ! [VarCurr: state_type] :
      ( v7440(VarCurr,1)
    <=> v7161(VarCurr,1) ) ).

tff(addAssignment_3717,axiom,
    ! [VarCurr: state_type] :
      ( v7732(VarCurr)
    <=> v7734(VarCurr) ) ).

tff(addAssignment_3716,axiom,
    ! [VarCurr: state_type] :
      ( v7734(VarCurr)
    <=> v7161(VarCurr,0) ) ).

tff(addAssignment_3715,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7596(VarCurr,B)
      <=> v7598(VarCurr,B) ) ) ).

tff(addAssignment_3714,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7598(VarCurr,B)
      <=> v7600(VarCurr,B) ) ) ).

tff(addAssignment_3713,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7600(VarCurr,B)
      <=> v7602(VarCurr,B) ) ) ).

tff(addAssignment_3712,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7602(VarCurr,B)
      <=> v7604(VarCurr,B) ) ) ).

tff(addAssignment_3711,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7604(VarNext,B)
      <=> v7698(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_89,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7699(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7698(VarNext,B)
            <=> v7604(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_89,axiom,
    ! [VarNext: state_type] :
      ( v7699(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7698(VarNext,B)
          <=> v7709(VarNext,B) ) ) ) ).

tff(addAssignment_3710,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7709(VarNext,B)
          <=> v7707(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_85,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7707(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_85,axiom,
    ! [VarCurr: state_type] :
      ( v7710(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7707(VarCurr,B)
          <=> v7626(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_709,axiom,
    ! [VarCurr: state_type] :
      ( v7710(VarCurr)
    <=> ( v7711(VarCurr)
        & v7712(VarCurr) ) ) ).

tff(writeUnaryOperator_534,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7712(VarCurr)
    <=> v7616(VarCurr) ) ).

tff(writeUnaryOperator_533,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7711(VarCurr)
    <=> v7606(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_708,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7699(VarNext)
      <=> v7700(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_707,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7700(VarNext)
      <=> ( v7701(VarNext)
          & v7630(VarNext) ) ) ) ).

tff(writeUnaryOperator_532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7701(VarNext)
      <=> v7703(VarNext) ) ) ).

tff(addAssignment_3709,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7703(VarNext)
      <=> v7630(VarCurr) ) ) ).

tff(addAssignment_3708,axiom,
    ! [VarCurr: state_type] :
      ( v7630(VarCurr)
    <=> v7632(VarCurr) ) ).

tff(addAssignment_3707,axiom,
    ! [VarCurr: state_type] :
      ( v7632(VarCurr)
    <=> v7634(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_706,axiom,
    ! [VarCurr: state_type] :
      ( v7634(VarCurr)
    <=> ( v7696(VarCurr)
        | v7692(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_705,axiom,
    ! [VarCurr: state_type] :
      ( v7696(VarCurr)
    <=> ( v7636(VarCurr)
        & v7640(VarCurr) ) ) ).

tff(addAssignment_3706,axiom,
    ! [VarCurr: state_type] :
      ( v7692(VarCurr)
    <=> v7694(VarCurr) ) ).

tff(addAssignment_3705,axiom,
    ! [VarCurr: state_type] :
      ( v7694(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_88,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7676(VarNext)
       => ( v7640(VarNext)
        <=> v7640(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_88,axiom,
    ! [VarNext: state_type] :
      ( v7676(VarNext)
     => ( v7640(VarNext)
      <=> v7686(VarNext) ) ) ).

tff(addAssignment_3704,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7686(VarNext)
      <=> v7684(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_704,axiom,
    ! [VarCurr: state_type] :
      ( v7684(VarCurr)
    <=> ( v7687(VarCurr)
        & v7688(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_703,axiom,
    ! [VarCurr: state_type] :
      ( v7688(VarCurr)
    <=> ( v7646(VarCurr)
        | v7671(VarCurr) ) ) ).

tff(writeUnaryOperator_531,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7687(VarCurr)
    <=> v7642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_702,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7676(VarNext)
      <=> v7677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_701,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7677(VarNext)
      <=> ( v7679(VarNext)
          & v7681(VarNext) ) ) ) ).

tff(writeUnaryOperator_530,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7681(VarCurr)
    <=> v7636(VarCurr) ) ).

tff(addAssignment_3703,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7679(VarNext)
      <=> v7636(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_17,axiom,
    ( v7640(constB0)
  <=> $true ) ).

tff(addAssignment_3702,axiom,
    ! [VarCurr: state_type] :
      ( v7671(VarCurr)
    <=> v7673(VarCurr) ) ).

tff(addAssignment_3701,axiom,
    ! [VarCurr: state_type] :
      ( v7673(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3700,axiom,
    ! [VarCurr: state_type] :
      ( v7646(VarCurr)
    <=> v7648(VarCurr) ) ).

tff(addAssignment_3699,axiom,
    ! [VarCurr: state_type] :
      ( v7648(VarCurr)
    <=> v7650(VarCurr) ) ).

tff(addAssignment_3698,axiom,
    ! [VarCurr: state_type] :
      ( v7650(VarCurr)
    <=> v7652(VarCurr) ) ).

tff(addAssignment_3697,axiom,
    ! [VarCurr: state_type] :
      ( v7652(VarCurr)
    <=> v7654(VarCurr) ) ).

tff(writeUnaryOperator_529,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7654(VarCurr)
    <=> v7668(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_700,axiom,
    ! [VarCurr: state_type] :
      ( v7668(VarCurr)
    <=> ( v7669(VarCurr)
        | v7664(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_699,axiom,
    ! [VarCurr: state_type] :
      ( v7669(VarCurr)
    <=> ( v7656(VarCurr)
        | v7660(VarCurr) ) ) ).

tff(addAssignment_3696,axiom,
    ! [VarCurr: state_type] :
      ( v7664(VarCurr)
    <=> v7666(VarCurr) ) ).

tff(addAssignment_3695,axiom,
    ! [VarCurr: state_type] :
      ( v7666(VarCurr)
    <=> v7067(VarCurr,2) ) ).

tff(addAssignment_3694,axiom,
    ! [VarCurr: state_type] :
      ( v7660(VarCurr)
    <=> v7662(VarCurr) ) ).

tff(addAssignment_3693,axiom,
    ! [VarCurr: state_type] :
      ( v7662(VarCurr)
    <=> v7345(VarCurr,1) ) ).

tff(addAssignment_3692,axiom,
    ! [VarCurr: state_type] :
      ( v7345(VarCurr,1)
    <=> v7347(VarCurr,1) ) ).

tff(addAssignment_3691,axiom,
    ! [VarCurr: state_type] :
      ( v7347(VarCurr,1)
    <=> v7349(VarCurr,1) ) ).

tff(addAssignment_3690,axiom,
    ! [VarCurr: state_type] :
      ( v7349(VarCurr,1)
    <=> v7354(VarCurr,1) ) ).

tff(addAssignment_3689,axiom,
    ! [VarCurr: state_type] :
      ( v7351(VarCurr,1)
    <=> v7353(VarCurr,1) ) ).

tff(addAssignment_3688,axiom,
    ! [VarCurr: state_type] :
      ( v7353(VarCurr,1)
    <=> v7067(VarCurr,1) ) ).

tff(addAssignment_3687,axiom,
    ! [VarCurr: state_type] :
      ( v7656(VarCurr)
    <=> v7658(VarCurr) ) ).

tff(addAssignment_3686,axiom,
    ! [VarCurr: state_type] :
      ( v7658(VarCurr)
    <=> v7067(VarCurr,0) ) ).

tff(addAssignment_3685,axiom,
    ! [VarCurr: state_type] :
      ( v7642(VarCurr)
    <=> v7644(VarCurr) ) ).

tff(addAssignment_3684,axiom,
    ! [VarCurr: state_type] :
      ( v7644(VarCurr)
    <=> $false ) ).

tff(addAssignment_3683,axiom,
    ! [VarCurr: state_type] :
      ( v7636(VarCurr)
    <=> v7638(VarCurr) ) ).

tff(addAssignment_3682,axiom,
    ! [VarCurr: state_type] :
      ( v7638(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3681,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7626(VarCurr,B)
      <=> v7628(VarCurr,B) ) ) ).

tff(addAssignment_3680,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7628(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3679,axiom,
    ! [VarCurr: state_type] :
      ( v7616(VarCurr)
    <=> v7618(VarCurr) ) ).

tff(addAssignment_3678,axiom,
    ! [VarCurr: state_type] :
      ( v7618(VarCurr)
    <=> v7620(VarCurr) ) ).

tff(addAssignment_3677,axiom,
    ! [VarCurr: state_type] :
      ( v7620(VarCurr)
    <=> v7622(VarCurr) ) ).

tff(addAssignment_3676,axiom,
    ! [VarCurr: state_type] :
      ( v7622(VarCurr)
    <=> v7624(VarCurr) ) ).

tff(addAssignment_3675,axiom,
    ! [VarCurr: state_type] :
      ( v7624(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3674,axiom,
    ! [VarCurr: state_type] :
      ( v7606(VarCurr)
    <=> v7608(VarCurr) ) ).

tff(addAssignment_3673,axiom,
    ! [VarCurr: state_type] :
      ( v7608(VarCurr)
    <=> v7610(VarCurr) ) ).

tff(addAssignment_3672,axiom,
    ! [VarCurr: state_type] :
      ( v7610(VarCurr)
    <=> v7612(VarCurr) ) ).

tff(addAssignment_3671,axiom,
    ! [VarCurr: state_type] :
      ( v7612(VarCurr)
    <=> v7614(VarCurr) ) ).

tff(addAssignment_3670,axiom,
    ! [VarCurr: state_type] :
      ( v7614(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_3669,axiom,
    ! [VarCurr: state_type] :
      ( v7412(VarCurr)
    <=> v7414(VarCurr) ) ).

tff(addAssignment_3668,axiom,
    ! [VarCurr: state_type] :
      ( v7414(VarCurr)
    <=> v7416(VarCurr) ) ).

tff(addAssignment_3667,axiom,
    ! [VarCurr: state_type] :
      ( v7416(VarCurr)
    <=> v7418(VarCurr) ) ).

tff(addAssignment_3666,axiom,
    ! [VarCurr: state_type] :
      ( v7418(VarCurr)
    <=> v7420(VarCurr) ) ).

tff(addAssignment_3665,axiom,
    ! [VarCurr: state_type] :
      ( v7420(VarCurr)
    <=> v7422(VarCurr) ) ).

tff(addAssignment_3664,axiom,
    ! [VarCurr: state_type] :
      ( v7422(VarCurr)
    <=> v7424(VarCurr) ) ).

tff(addAssignment_3663,axiom,
    ! [VarCurr: state_type] :
      ( v7424(VarCurr)
    <=> v7426(VarCurr) ) ).

tff(writeUnaryOperator_528,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7426(VarCurr)
    <=> v7593(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_698,axiom,
    ! [VarCurr: state_type] :
      ( v7593(VarCurr)
    <=> ( v7594(VarCurr)
        | v7581(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_697,axiom,
    ! [VarCurr: state_type] :
      ( v7594(VarCurr)
    <=> ( v7428(VarCurr)
        | v7443(VarCurr) ) ) ).

tff(addAssignment_3662,axiom,
    ! [VarCurr: state_type] :
      ( v7581(VarCurr)
    <=> v7583(VarCurr) ) ).

tff(addAssignment_3661,axiom,
    ! [VarCurr: state_type] :
      ( v7583(VarCurr)
    <=> v7161(VarCurr,2) ) ).

tff(addAssignment_3660,axiom,
    ! [VarCurr: state_type] :
      ( v7161(VarCurr,2)
    <=> v7069(VarCurr,5) ) ).

tff(addAssignment_3659,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,5)
    <=> v7071(VarCurr,5) ) ).

tff(addAssignment_3658,axiom,
    ! [VarNext: state_type] :
      ( v7071(VarNext,5)
    <=> v7585(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_87,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7586(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v7585(VarNext,B)
            <=> v7071(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_87,axiom,
    ! [VarNext: state_type] :
      ( v7586(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v7585(VarNext,B)
          <=> v7574(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_696,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7586(VarNext)
      <=> v7587(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_695,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7587(VarNext)
      <=> ( v7589(VarNext)
          & v7516(VarNext) ) ) ) ).

tff(writeUnaryOperator_527,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7589(VarNext)
      <=> v7568(VarNext) ) ) ).

tff(addAssignment_3657,axiom,
    ! [VarCurr: state_type] :
      ( v7187(VarCurr,5)
    <=> v7189(VarCurr,5) ) ).

tff(addAssignment_3656,axiom,
    ! [VarCurr: state_type] :
      ( v7189(VarCurr,5)
    <=> v7513(VarCurr,5) ) ).

tff(addAssignment_3655,axiom,
    ! [VarCurr: state_type] :
      ( v7191(VarCurr,2)
    <=> v7193(VarCurr,2) ) ).

tff(addAssignment_3654,axiom,
    ! [VarCurr: state_type] :
      ( v7193(VarCurr,2)
    <=> v7195(VarCurr,2) ) ).

tff(addAssignment_3653,axiom,
    ! [VarCurr: state_type] :
      ( v7195(VarCurr,2)
    <=> v7512(VarCurr,2) ) ).

tff(addAssignment_3652,axiom,
    ! [VarCurr: state_type] :
      ( v7449(VarCurr,2)
    <=> v7451(VarCurr,2) ) ).

tff(addAssignment_3651,axiom,
    ! [VarCurr: state_type] :
      ( v7451(VarCurr,2)
    <=> v7453(VarCurr,2) ) ).

tff(addAssignment_3650,axiom,
    ! [VarCurr: state_type] :
      ( v7453(VarCurr,2)
    <=> v7455(VarCurr,2) ) ).

tff(addAssignment_3649,axiom,
    ! [VarCurr: state_type] :
      ( v7455(VarCurr,2)
    <=> v7457(VarCurr,2) ) ).

tff(addAssignment_3648,axiom,
    ! [VarCurr: state_type] :
      ( v7457(VarCurr,2)
    <=> v7467(VarCurr,2) ) ).

tff(addAssignment_3647,axiom,
    ! [VarCurr: state_type] :
      ( v7459(VarCurr,2)
    <=> v7461(VarCurr,2) ) ).

tff(addAssignment_3646,axiom,
    ! [VarCurr: state_type] :
      ( v7461(VarCurr,2)
    <=> v7462(VarCurr,2) ) ).

tff(addAssignment_3645,axiom,
    ! [VarCurr: state_type] :
      ( v7197(VarCurr,2)
    <=> v7199(VarCurr,2) ) ).

tff(addAssignment_3644,axiom,
    ! [VarCurr: state_type] :
      ( v7199(VarCurr,2)
    <=> v7446(VarCurr,2) ) ).

tff(addAssignment_3643,axiom,
    ! [VarCurr: state_type] :
      ( v7443(VarCurr)
    <=> v7445(VarCurr) ) ).

tff(addAssignment_3642,axiom,
    ! [VarCurr: state_type] :
      ( v7445(VarCurr)
    <=> v7161(VarCurr,1) ) ).

tff(addAssignment_3641,axiom,
    ! [VarCurr: state_type] :
      ( v7161(VarCurr,1)
    <=> v7069(VarCurr,4) ) ).

tff(addAssignment_3640,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,4)
    <=> v7071(VarCurr,4) ) ).

tff(addAssignment_3639,axiom,
    ! [VarNext: state_type] :
      ( v7071(VarNext,4)
    <=> v7563(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_86,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7564(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v7563(VarNext,B)
            <=> v7071(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_86,axiom,
    ! [VarNext: state_type] :
      ( v7564(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v7563(VarNext,B)
          <=> v7574(VarNext,B) ) ) ) ).

tff(addAssignment_3638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v7574(VarNext,B)
          <=> v7572(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_84,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v7572(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_84,axiom,
    ! [VarCurr: state_type] :
      ( v7575(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v7572(VarCurr,B)
          <=> v7187(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_694,axiom,
    ! [VarCurr: state_type] :
      ( v7575(VarCurr)
    <=> ( v7576(VarCurr)
        & v7577(VarCurr) ) ) ).

tff(writeUnaryOperator_526,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7577(VarCurr)
    <=> v7177(VarCurr) ) ).

tff(writeUnaryOperator_525,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7576(VarCurr)
    <=> v7163(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_693,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7564(VarNext)
      <=> v7565(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_692,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7565(VarNext)
      <=> ( v7566(VarNext)
          & v7516(VarNext) ) ) ) ).

tff(writeUnaryOperator_524,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7566(VarNext)
      <=> v7568(VarNext) ) ) ).

tff(addAssignment_3637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7568(VarNext)
      <=> v7516(VarCurr) ) ) ).

tff(addAssignment_3636,axiom,
    ! [VarCurr: state_type] :
      ( v7516(VarCurr)
    <=> v7518(VarCurr) ) ).

tff(addAssignment_3635,axiom,
    ! [VarCurr: state_type] :
      ( v7518(VarCurr)
    <=> v7520(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_691,axiom,
    ! [VarCurr: state_type] :
      ( v7520(VarCurr)
    <=> ( v7561(VarCurr)
        | v7557(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_690,axiom,
    ! [VarCurr: state_type] :
      ( v7561(VarCurr)
    <=> ( v7522(VarCurr)
        & v7526(VarCurr) ) ) ).

tff(addAssignment_3634,axiom,
    ! [VarCurr: state_type] :
      ( v7557(VarCurr)
    <=> v7559(VarCurr) ) ).

tff(addAssignment_3633,axiom,
    ! [VarCurr: state_type] :
      ( v7559(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_85,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7541(VarNext)
       => ( v7526(VarNext)
        <=> v7526(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_85,axiom,
    ! [VarNext: state_type] :
      ( v7541(VarNext)
     => ( v7526(VarNext)
      <=> v7551(VarNext) ) ) ).

tff(addAssignment_3632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7551(VarNext)
      <=> v7549(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_689,axiom,
    ! [VarCurr: state_type] :
      ( v7549(VarCurr)
    <=> ( v7552(VarCurr)
        & v7553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_688,axiom,
    ! [VarCurr: state_type] :
      ( v7553(VarCurr)
    <=> ( v7532(VarCurr)
        | v7536(VarCurr) ) ) ).

tff(writeUnaryOperator_523,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7552(VarCurr)
    <=> v7528(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_687,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7541(VarNext)
      <=> v7542(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_686,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7542(VarNext)
      <=> ( v7544(VarNext)
          & v7546(VarNext) ) ) ) ).

tff(writeUnaryOperator_522,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7546(VarCurr)
    <=> v7522(VarCurr) ) ).

tff(addAssignment_3631,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7544(VarNext)
      <=> v7522(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_16,axiom,
    ( v7526(constB0)
  <=> $true ) ).

tff(addAssignment_3630,axiom,
    ! [VarCurr: state_type] :
      ( v7536(VarCurr)
    <=> v7538(VarCurr) ) ).

tff(addAssignment_3629,axiom,
    ! [VarCurr: state_type] :
      ( v7538(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3628,axiom,
    ! [VarCurr: state_type] :
      ( v7532(VarCurr)
    <=> v7534(VarCurr) ) ).

tff(addAssignment_3627,axiom,
    ! [VarCurr: state_type] :
      ( v7534(VarCurr)
    <=> $true ) ).

tff(addAssignment_3626,axiom,
    ! [VarCurr: state_type] :
      ( v7528(VarCurr)
    <=> v7530(VarCurr) ) ).

tff(addAssignment_3625,axiom,
    ! [VarCurr: state_type] :
      ( v7530(VarCurr)
    <=> $false ) ).

tff(addAssignment_3624,axiom,
    ! [VarCurr: state_type] :
      ( v7522(VarCurr)
    <=> v7524(VarCurr) ) ).

tff(addAssignment_3623,axiom,
    ! [VarCurr: state_type] :
      ( v7524(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3622,axiom,
    ! [VarCurr: state_type] :
      ( v7187(VarCurr,4)
    <=> v7189(VarCurr,4) ) ).

tff(addAssignment_3621,axiom,
    ! [VarCurr: state_type] :
      ( v7189(VarCurr,4)
    <=> v7513(VarCurr,4) ) ).

tff(addAssignment_3620,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v7513(VarCurr,B)
      <=> v7514(VarCurr,B) ) ) ).

tff(addAssignment_3619,axiom,
    ! [VarCurr: state_type] :
      ( ( v7513(VarCurr,5)
      <=> v7191(VarCurr,2) )
      & ( v7513(VarCurr,4)
      <=> v7191(VarCurr,1) )
      & ( v7513(VarCurr,3)
      <=> v7191(VarCurr,0) ) ) ).

tff(addAssignment_3618,axiom,
    ! [VarCurr: state_type] :
      ( v7191(VarCurr,1)
    <=> v7193(VarCurr,1) ) ).

tff(addAssignment_3617,axiom,
    ! [VarCurr: state_type] :
      ( v7193(VarCurr,1)
    <=> v7195(VarCurr,1) ) ).

tff(addAssignment_3616,axiom,
    ! [VarCurr: state_type] :
      ( v7195(VarCurr,1)
    <=> v7512(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v7512(VarCurr,B)
      <=> ( v7197(VarCurr,B)
          & v7449(VarCurr,B) ) ) ) ).

tff(addAssignment_3615,axiom,
    ! [VarCurr: state_type] :
      ( v7449(VarCurr,1)
    <=> v7451(VarCurr,1) ) ).

tff(addAssignment_3614,axiom,
    ! [VarCurr: state_type] :
      ( v7451(VarCurr,1)
    <=> v7453(VarCurr,1) ) ).

tff(addAssignment_3613,axiom,
    ! [VarCurr: state_type] :
      ( v7453(VarCurr,1)
    <=> v7455(VarCurr,1) ) ).

tff(addAssignment_3612,axiom,
    ! [VarCurr: state_type] :
      ( v7455(VarCurr,1)
    <=> v7457(VarCurr,1) ) ).

tff(addAssignment_3611,axiom,
    ! [VarCurr: state_type] :
      ( v7457(VarCurr,1)
    <=> v7467(VarCurr,1) ) ).

tff(addAssignment_3610,axiom,
    ! [VarCurr: state_type] :
      ( v7467(VarCurr,0)
    <=> v7507(VarCurr) ) ).

tff(addAssignment_3609,axiom,
    ! [VarCurr: state_type] :
      ( v7467(VarCurr,1)
    <=> v7502(VarCurr) ) ).

tff(addAssignment_3608,axiom,
    ! [VarCurr: state_type] :
      ( v7467(VarCurr,2)
    <=> v7497(VarCurr) ) ).

tff(addAssignment_3607,axiom,
    ! [VarCurr: state_type] :
      ( v7467(VarCurr,3)
    <=> v7469(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_685,axiom,
    ! [VarCurr: state_type] :
      ( v7507(VarCurr)
    <=> ( v7508(VarCurr)
        & v7511(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_684,axiom,
    ! [VarCurr: state_type] :
      ( v7511(VarCurr)
    <=> ( v7459(VarCurr,0)
        | v7477(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_683,axiom,
    ! [VarCurr: state_type] :
      ( v7508(VarCurr)
    <=> ( v7509(VarCurr)
        | v7510(VarCurr) ) ) ).

tff(writeUnaryOperator_521,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7510(VarCurr)
    <=> v7477(VarCurr,0) ) ).

tff(writeUnaryOperator_520,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7509(VarCurr)
    <=> v7459(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_682,axiom,
    ! [VarCurr: state_type] :
      ( v7502(VarCurr)
    <=> ( v7503(VarCurr)
        & v7506(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_681,axiom,
    ! [VarCurr: state_type] :
      ( v7506(VarCurr)
    <=> ( v7476(VarCurr)
        | v7478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_680,axiom,
    ! [VarCurr: state_type] :
      ( v7503(VarCurr)
    <=> ( v7504(VarCurr)
        | v7505(VarCurr) ) ) ).

tff(writeUnaryOperator_519,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7505(VarCurr)
    <=> v7478(VarCurr) ) ).

tff(writeUnaryOperator_518,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7504(VarCurr)
    <=> v7476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_679,axiom,
    ! [VarCurr: state_type] :
      ( v7497(VarCurr)
    <=> ( v7498(VarCurr)
        & v7501(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_678,axiom,
    ! [VarCurr: state_type] :
      ( v7501(VarCurr)
    <=> ( v7474(VarCurr)
        | v7484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_677,axiom,
    ! [VarCurr: state_type] :
      ( v7498(VarCurr)
    <=> ( v7499(VarCurr)
        | v7500(VarCurr) ) ) ).

tff(writeUnaryOperator_517,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7500(VarCurr)
    <=> v7484(VarCurr) ) ).

tff(writeUnaryOperator_516,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7499(VarCurr)
    <=> v7474(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_676,axiom,
    ! [VarCurr: state_type] :
      ( v7469(VarCurr)
    <=> ( v7470(VarCurr)
        & v7496(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_675,axiom,
    ! [VarCurr: state_type] :
      ( v7496(VarCurr)
    <=> ( v7472(VarCurr)
        | v7491(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_674,axiom,
    ! [VarCurr: state_type] :
      ( v7470(VarCurr)
    <=> ( v7471(VarCurr)
        | v7490(VarCurr) ) ) ).

tff(writeUnaryOperator_515,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7490(VarCurr)
    <=> v7491(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_673,axiom,
    ! [VarCurr: state_type] :
      ( v7491(VarCurr)
    <=> ( v7492(VarCurr)
        & v7495(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_156,axiom,
    ! [VarCurr: state_type] :
      ( v7495(VarCurr)
    <=> ( v7459(VarCurr,3)
        | v7477(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_672,axiom,
    ! [VarCurr: state_type] :
      ( v7492(VarCurr)
    <=> ( v7493(VarCurr)
        | v7494(VarCurr) ) ) ).

tff(writeUnaryOperator_514,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7494(VarCurr)
    <=> v7477(VarCurr,3) ) ).

tff(writeUnaryOperator_513,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7493(VarCurr)
    <=> v7459(VarCurr,3) ) ).

tff(writeUnaryOperator_512,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7471(VarCurr)
    <=> v7472(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_671,axiom,
    ! [VarCurr: state_type] :
      ( v7472(VarCurr)
    <=> ( v7473(VarCurr)
        | v7489(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_155,axiom,
    ! [VarCurr: state_type] :
      ( v7489(VarCurr)
    <=> ( v7459(VarCurr,2)
        & v7477(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_670,axiom,
    ! [VarCurr: state_type] :
      ( v7473(VarCurr)
    <=> ( v7474(VarCurr)
        & v7484(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_669,axiom,
    ! [VarCurr: state_type] :
      ( v7484(VarCurr)
    <=> ( v7485(VarCurr)
        & v7488(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_154,axiom,
    ! [VarCurr: state_type] :
      ( v7488(VarCurr)
    <=> ( v7459(VarCurr,2)
        | v7477(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_668,axiom,
    ! [VarCurr: state_type] :
      ( v7485(VarCurr)
    <=> ( v7486(VarCurr)
        | v7487(VarCurr) ) ) ).

tff(writeUnaryOperator_511,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7487(VarCurr)
    <=> v7477(VarCurr,2) ) ).

tff(writeUnaryOperator_510,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7486(VarCurr)
    <=> v7459(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_667,axiom,
    ! [VarCurr: state_type] :
      ( v7474(VarCurr)
    <=> ( v7475(VarCurr)
        | v7483(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_153,axiom,
    ! [VarCurr: state_type] :
      ( v7483(VarCurr)
    <=> ( v7459(VarCurr,1)
        & v7477(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_666,axiom,
    ! [VarCurr: state_type] :
      ( v7475(VarCurr)
    <=> ( v7476(VarCurr)
        & v7478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_665,axiom,
    ! [VarCurr: state_type] :
      ( v7478(VarCurr)
    <=> ( v7479(VarCurr)
        & v7482(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_152,axiom,
    ! [VarCurr: state_type] :
      ( v7482(VarCurr)
    <=> ( v7459(VarCurr,1)
        | v7477(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_664,axiom,
    ! [VarCurr: state_type] :
      ( v7479(VarCurr)
    <=> ( v7480(VarCurr)
        | v7481(VarCurr) ) ) ).

tff(writeUnaryOperator_509,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7481(VarCurr)
    <=> v7477(VarCurr,1) ) ).

tff(writeUnaryOperator_508,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7480(VarCurr)
    <=> v7459(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_663,axiom,
    ! [VarCurr: state_type] :
      ( v7476(VarCurr)
    <=> ( v7459(VarCurr,0)
        & v7477(VarCurr,0) ) ) ).

tff(addAssignment_3606,axiom,
    ! [VarCurr: state_type] :
      ( v7477(VarCurr,0)
    <=> v7464(VarCurr) ) ).

tff(addAssignment_3605,axiom,
    ! [VarCurr: state_type] :
      ( ( v7477(VarCurr,3)
      <=> $false )
      & ( v7477(VarCurr,2)
      <=> $false )
      & ( v7477(VarCurr,1)
      <=> $false ) ) ).

tff(addAssignment_3604,axiom,
    ! [VarCurr: state_type] :
      ( v7464(VarCurr)
    <=> v7466(VarCurr) ) ).

tff(addAssignment_3603,axiom,
    ! [VarCurr: state_type] :
      ( v7466(VarCurr)
    <=> v7228(VarCurr) ) ).

tff(addAssignment_3602,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v7459(VarCurr,B)
      <=> v7461(VarCurr,B) ) ) ).

tff(addAssignment_3601,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v7461(VarCurr,B)
      <=> v7462(VarCurr,B) ) ) ).

tff(addAssignment_3600,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v7462(VarCurr,B)
      <=> v7161(VarCurr,B) ) ) ).

tff(addAssignment_3599,axiom,
    ! [VarCurr: state_type] :
      ( v7462(VarCurr,3)
    <=> $false ) ).

tff(addAssignment_3598,axiom,
    ! [VarCurr: state_type] :
      ( v7197(VarCurr,1)
    <=> v7199(VarCurr,1) ) ).

tff(addAssignment_3597,axiom,
    ! [VarCurr: state_type] :
      ( v7199(VarCurr,1)
    <=> v7446(VarCurr,1) ) ).

tff(addAssignment_3596,axiom,
    ! [VarCurr: state_type] :
      ( v7446(VarCurr,0)
    <=> v7447(VarCurr) ) ).

tff(addAssignment_3595,axiom,
    ! [VarCurr: state_type] :
      ( v7446(VarCurr,1)
    <=> v7447(VarCurr) ) ).

tff(addAssignment_3594,axiom,
    ! [VarCurr: state_type] :
      ( v7446(VarCurr,2)
    <=> v7447(VarCurr) ) ).

tff(addAssignment_3593,axiom,
    ! [VarCurr: state_type] :
      ( v7447(VarCurr)
    <=> v7201(VarCurr) ) ).

tff(addAssignment_3592,axiom,
    ! [VarCurr: state_type] :
      ( v7428(VarCurr)
    <=> v7430(VarCurr) ) ).

tff(addAssignment_3591,axiom,
    ! [VarCurr: state_type] :
      ( v7430(VarCurr)
    <=> v7432(VarCurr,0) ) ).

tff(addAssignment_3590,axiom,
    ! [VarCurr: state_type] :
      ( v7432(VarCurr,0)
    <=> v7434(VarCurr,0) ) ).

tff(addAssignment_3589,axiom,
    ! [VarCurr: state_type] :
      ( v7434(VarCurr,0)
    <=> v7436(VarCurr,0) ) ).

tff(addAssignment_3588,axiom,
    ! [VarCurr: state_type] :
      ( v7436(VarCurr,0)
    <=> v7441(VarCurr,0) ) ).

tff(writeUnaryOperator_507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v7441(VarCurr,B)
      <=> ~ v7438(VarCurr,B) ) ) ).

tff(addAssignment_3587,axiom,
    ! [VarCurr: state_type] :
      ( v7438(VarCurr,0)
    <=> v7440(VarCurr,0) ) ).

tff(addAssignment_3586,axiom,
    ! [VarCurr: state_type] :
      ( v7440(VarCurr,0)
    <=> v7161(VarCurr,0) ) ).

tff(addAssignment_3585,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7281(VarCurr,B)
      <=> v7283(VarCurr,B) ) ) ).

tff(addAssignment_3584,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7283(VarCurr,B)
      <=> v7285(VarCurr,B) ) ) ).

tff(addAssignment_3583,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7285(VarCurr,B)
      <=> v7287(VarCurr,B) ) ) ).

tff(addAssignment_3582,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7287(VarCurr,B)
      <=> v7289(VarCurr,B) ) ) ).

tff(addAssignment_3581,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7289(VarNext,B)
      <=> v7394(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_84,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7395(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7394(VarNext,B)
            <=> v7289(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_84,axiom,
    ! [VarNext: state_type] :
      ( v7395(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7394(VarNext,B)
          <=> v7405(VarNext,B) ) ) ) ).

tff(addAssignment_3580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7405(VarNext,B)
          <=> v7403(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_83,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7406(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7403(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_83,axiom,
    ! [VarCurr: state_type] :
      ( v7406(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7403(VarCurr,B)
          <=> v7311(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_662,axiom,
    ! [VarCurr: state_type] :
      ( v7406(VarCurr)
    <=> ( v7407(VarCurr)
        & v7408(VarCurr) ) ) ).

tff(writeUnaryOperator_506,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7408(VarCurr)
    <=> v7301(VarCurr) ) ).

tff(writeUnaryOperator_505,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7407(VarCurr)
    <=> v7291(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_661,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7395(VarNext)
      <=> v7396(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_660,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7396(VarNext)
      <=> ( v7397(VarNext)
          & v7315(VarNext) ) ) ) ).

tff(writeUnaryOperator_504,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7397(VarNext)
      <=> v7399(VarNext) ) ) ).

tff(addAssignment_3579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7399(VarNext)
      <=> v7315(VarCurr) ) ) ).

tff(addAssignment_3578,axiom,
    ! [VarCurr: state_type] :
      ( v7315(VarCurr)
    <=> v7317(VarCurr) ) ).

tff(addAssignment_3577,axiom,
    ! [VarCurr: state_type] :
      ( v7317(VarCurr)
    <=> v7319(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_659,axiom,
    ! [VarCurr: state_type] :
      ( v7319(VarCurr)
    <=> ( v7392(VarCurr)
        | v7388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_658,axiom,
    ! [VarCurr: state_type] :
      ( v7392(VarCurr)
    <=> ( v7321(VarCurr)
        & v7325(VarCurr) ) ) ).

tff(addAssignment_3576,axiom,
    ! [VarCurr: state_type] :
      ( v7388(VarCurr)
    <=> v7390(VarCurr) ) ).

tff(addAssignment_3575,axiom,
    ! [VarCurr: state_type] :
      ( v7390(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_83,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7372(VarNext)
       => ( v7325(VarNext)
        <=> v7325(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_83,axiom,
    ! [VarNext: state_type] :
      ( v7372(VarNext)
     => ( v7325(VarNext)
      <=> v7382(VarNext) ) ) ).

tff(addAssignment_3574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7382(VarNext)
      <=> v7380(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_657,axiom,
    ! [VarCurr: state_type] :
      ( v7380(VarCurr)
    <=> ( v7383(VarCurr)
        & v7384(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_656,axiom,
    ! [VarCurr: state_type] :
      ( v7384(VarCurr)
    <=> ( v7331(VarCurr)
        | v7367(VarCurr) ) ) ).

tff(writeUnaryOperator_503,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7383(VarCurr)
    <=> v7327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7372(VarNext)
      <=> v7373(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_654,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7373(VarNext)
      <=> ( v7375(VarNext)
          & v7377(VarNext) ) ) ) ).

tff(writeUnaryOperator_502,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7377(VarCurr)
    <=> v7321(VarCurr) ) ).

tff(addAssignment_3573,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7375(VarNext)
      <=> v7321(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_15,axiom,
    ( v7325(constB0)
  <=> $true ) ).

tff(addAssignment_3572,axiom,
    ! [VarCurr: state_type] :
      ( v7367(VarCurr)
    <=> v7369(VarCurr) ) ).

tff(addAssignment_3571,axiom,
    ! [VarCurr: state_type] :
      ( v7369(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3570,axiom,
    ! [VarCurr: state_type] :
      ( v7331(VarCurr)
    <=> v7333(VarCurr) ) ).

tff(addAssignment_3569,axiom,
    ! [VarCurr: state_type] :
      ( v7333(VarCurr)
    <=> v7335(VarCurr) ) ).

tff(addAssignment_3568,axiom,
    ! [VarCurr: state_type] :
      ( v7335(VarCurr)
    <=> v7337(VarCurr) ) ).

tff(addAssignment_3567,axiom,
    ! [VarCurr: state_type] :
      ( v7337(VarCurr)
    <=> v7339(VarCurr) ) ).

tff(writeUnaryOperator_501,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7339(VarCurr)
    <=> v7364(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_653,axiom,
    ! [VarCurr: state_type] :
      ( v7364(VarCurr)
    <=> ( v7365(VarCurr)
        | v7360(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_652,axiom,
    ! [VarCurr: state_type] :
      ( v7365(VarCurr)
    <=> ( v7341(VarCurr)
        | v7356(VarCurr) ) ) ).

tff(addAssignment_3566,axiom,
    ! [VarCurr: state_type] :
      ( v7360(VarCurr)
    <=> v7362(VarCurr) ) ).

tff(addAssignment_3565,axiom,
    ! [VarCurr: state_type] :
      ( v7362(VarCurr)
    <=> v7067(VarCurr,2) ) ).

tff(addAssignment_3564,axiom,
    ! [VarCurr: state_type] :
      ( v7356(VarCurr)
    <=> v7358(VarCurr) ) ).

tff(addAssignment_3563,axiom,
    ! [VarCurr: state_type] :
      ( v7358(VarCurr)
    <=> v7067(VarCurr,1) ) ).

tff(addAssignment_3562,axiom,
    ! [VarCurr: state_type] :
      ( v7341(VarCurr)
    <=> v7343(VarCurr) ) ).

tff(addAssignment_3561,axiom,
    ! [VarCurr: state_type] :
      ( v7343(VarCurr)
    <=> v7345(VarCurr,0) ) ).

tff(addAssignment_3560,axiom,
    ! [VarCurr: state_type] :
      ( v7345(VarCurr,0)
    <=> v7347(VarCurr,0) ) ).

tff(addAssignment_3559,axiom,
    ! [VarCurr: state_type] :
      ( v7347(VarCurr,0)
    <=> v7349(VarCurr,0) ) ).

tff(addAssignment_3558,axiom,
    ! [VarCurr: state_type] :
      ( v7349(VarCurr,0)
    <=> v7354(VarCurr,0) ) ).

tff(writeUnaryOperator_500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v7354(VarCurr,B)
      <=> ~ v7351(VarCurr,B) ) ) ).

tff(addAssignment_3557,axiom,
    ! [VarCurr: state_type] :
      ( v7351(VarCurr,0)
    <=> v7353(VarCurr,0) ) ).

tff(addAssignment_3556,axiom,
    ! [VarCurr: state_type] :
      ( v7353(VarCurr,0)
    <=> v7067(VarCurr,0) ) ).

tff(addAssignment_3555,axiom,
    ! [VarCurr: state_type] :
      ( v7327(VarCurr)
    <=> v7329(VarCurr) ) ).

tff(addAssignment_3554,axiom,
    ! [VarCurr: state_type] :
      ( v7329(VarCurr)
    <=> $false ) ).

tff(addAssignment_3553,axiom,
    ! [VarCurr: state_type] :
      ( v7321(VarCurr)
    <=> v7323(VarCurr) ) ).

tff(addAssignment_3552,axiom,
    ! [VarCurr: state_type] :
      ( v7323(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3551,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7311(VarCurr,B)
      <=> v7313(VarCurr,B) ) ) ).

tff(addAssignment_3550,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v7313(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3549,axiom,
    ! [VarCurr: state_type] :
      ( v7301(VarCurr)
    <=> v7303(VarCurr) ) ).

tff(addAssignment_3548,axiom,
    ! [VarCurr: state_type] :
      ( v7303(VarCurr)
    <=> v7305(VarCurr) ) ).

tff(addAssignment_3547,axiom,
    ! [VarCurr: state_type] :
      ( v7305(VarCurr)
    <=> v7307(VarCurr) ) ).

tff(addAssignment_3546,axiom,
    ! [VarCurr: state_type] :
      ( v7307(VarCurr)
    <=> v7309(VarCurr) ) ).

tff(addAssignment_3545,axiom,
    ! [VarCurr: state_type] :
      ( v7309(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3544,axiom,
    ! [VarCurr: state_type] :
      ( v7291(VarCurr)
    <=> v7293(VarCurr) ) ).

tff(addAssignment_3543,axiom,
    ! [VarCurr: state_type] :
      ( v7293(VarCurr)
    <=> v7295(VarCurr) ) ).

tff(addAssignment_3542,axiom,
    ! [VarCurr: state_type] :
      ( v7295(VarCurr)
    <=> v7297(VarCurr) ) ).

tff(addAssignment_3541,axiom,
    ! [VarCurr: state_type] :
      ( v7297(VarCurr)
    <=> v7299(VarCurr) ) ).

tff(addAssignment_3540,axiom,
    ! [VarCurr: state_type] :
      ( v7299(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_3539,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6248(VarCurr,B)
      <=> v6250(VarCurr,B) ) ) ).

tff(addAssignment_3538,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6250(VarCurr,B)
      <=> v6252(VarCurr,B) ) ) ).

tff(addAssignment_3537,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6252(VarCurr,B)
      <=> v6254(VarCurr,B) ) ) ).

tff(addAssignment_3536,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6254(VarCurr,B)
      <=> v6256(VarCurr,B) ) ) ).

tff(addAssignment_3535,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6256(VarNext,B)
      <=> v7273(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_82,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7274(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7273(VarNext,B)
            <=> v6256(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_82,axiom,
    ! [VarNext: state_type] :
      ( v7274(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7273(VarNext,B)
          <=> v7134(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_651,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7274(VarNext)
      <=> v7275(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_650,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7275(VarNext)
      <=> ( v7277(VarNext)
          & v7033(VarNext) ) ) ) ).

tff(writeUnaryOperator_499,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7277(VarNext)
      <=> v7128(VarNext) ) ) ).

tff(addAssignment_3534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6286(VarCurr,B)
      <=> v6288(VarCurr,B) ) ) ).

tff(addAssignment_3533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6288(VarCurr,B)
      <=> v6290(VarCurr,B) ) ) ).

tff(addAssignment_3532,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6290(VarCurr,B)
      <=> v6292(VarCurr,B) ) ) ).

tff(addAssignment_3531,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6292(VarCurr,B)
      <=> v6294(VarCurr,B) ) ) ).

tff(addAssignment_3530,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6294(VarCurr,B)
      <=> v7031(VarCurr,B) ) ) ).

tff(addAssignment_3529,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6318(VarCurr,B)
      <=> v6320(VarCurr,B) ) ) ).

tff(addAssignment_3528,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6320(VarCurr,B)
      <=> v6322(VarCurr,B) ) ) ).

tff(addAssignment_3527,axiom,
    ! [VarCurr: state_type] :
      ( ( v6322(VarCurr,6)
      <=> v6324(VarCurr,18) )
      & ( v6322(VarCurr,5)
      <=> v6324(VarCurr,17) )
      & ( v6322(VarCurr,4)
      <=> v6324(VarCurr,16) )
      & ( v6322(VarCurr,3)
      <=> v6324(VarCurr,15) )
      & ( v6322(VarCurr,2)
      <=> v6324(VarCurr,14) )
      & ( v6322(VarCurr,1)
      <=> v6324(VarCurr,13) )
      & ( v6322(VarCurr,0)
      <=> v6324(VarCurr,12) ) ) ).

tff(addAssignment_3526,axiom,
    ! [VarCurr: state_type] :
      ( ( v6324(VarCurr,18)
      <=> v6326(VarCurr,6) )
      & ( v6324(VarCurr,17)
      <=> v6326(VarCurr,5) )
      & ( v6324(VarCurr,16)
      <=> v6326(VarCurr,4) )
      & ( v6324(VarCurr,15)
      <=> v6326(VarCurr,3) )
      & ( v6324(VarCurr,14)
      <=> v6326(VarCurr,2) )
      & ( v6324(VarCurr,13)
      <=> v6326(VarCurr,1) )
      & ( v6324(VarCurr,12)
      <=> v6326(VarCurr,0) ) ) ).

tff(addAssignment_3525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6326(VarCurr,B)
      <=> v6328(VarCurr,B) ) ) ).

tff(addAssignment_3524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6328(VarCurr,B)
      <=> v7024(VarCurr,B) ) ) ).

tff(addAssignment_3523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6749(VarCurr,B)
      <=> v6751(VarCurr,B) ) ) ).

tff(addAssignment_3522,axiom,
    ! [VarCurr: state_type] :
      ( ( v6751(VarCurr,6)
      <=> v6334(VarCurr,30) )
      & ( v6751(VarCurr,5)
      <=> v6334(VarCurr,29) )
      & ( v6751(VarCurr,4)
      <=> v6334(VarCurr,28) )
      & ( v6751(VarCurr,3)
      <=> v6334(VarCurr,27) )
      & ( v6751(VarCurr,2)
      <=> v6334(VarCurr,26) )
      & ( v6751(VarCurr,1)
      <=> v6334(VarCurr,25) )
      & ( v6751(VarCurr,0)
      <=> v6334(VarCurr,24) ) ) ).

tff(addAssignment_3521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,24) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_3520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,31)
        & ~ $less(B,24) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_3519,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,30)
      <=> v6753(VarCurr,6) )
      & ( v6338(VarCurr,29)
      <=> v6753(VarCurr,5) )
      & ( v6338(VarCurr,28)
      <=> v6753(VarCurr,4) )
      & ( v6338(VarCurr,27)
      <=> v6753(VarCurr,3) )
      & ( v6338(VarCurr,26)
      <=> v6753(VarCurr,2) )
      & ( v6338(VarCurr,25)
      <=> v6753(VarCurr,1) )
      & ( v6338(VarCurr,24)
      <=> v6753(VarCurr,0) ) ) ).

tff(addAssignment_3518,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6753(VarCurr,B)
      <=> v6755(VarCurr,B) ) ) ).

tff(addAssignment_3517,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6755(VarCurr,B)
      <=> v6757(VarCurr,B) ) ) ).

tff(addAssignment_3516,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6757(VarNext,B)
      <=> v7265(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_81,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7266(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7265(VarNext,B)
            <=> v6757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_81,axiom,
    ! [VarNext: state_type] :
      ( v7266(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7265(VarNext,B)
          <=> v7010(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_649,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7266(VarNext)
      <=> v7267(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_648,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7267(VarNext)
      <=> ( v7269(VarNext)
          & v6975(VarNext) ) ) ) ).

tff(writeUnaryOperator_498,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7269(VarNext)
      <=> v7004(VarNext) ) ) ).

tff(addAssignment_3515,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6787(VarCurr,B)
      <=> v6789(VarCurr,B) ) ) ).

tff(addAssignment_3514,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6789(VarCurr,B)
      <=> v6791(VarCurr,B) ) ) ).

tff(addAssignment_3513,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6791(VarCurr,B)
      <=> v6959(VarCurr,B) ) ) ).

tff(addAssignment_3512,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6924(VarCurr,B)
      <=> v6926(VarCurr,B) ) ) ).

tff(addAssignment_3511,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6926(VarCurr,B)
      <=> v6928(VarCurr,B) ) ) ).

tff(addAssignment_3510,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6928(VarCurr,B)
      <=> v6930(VarCurr,B) ) ) ).

tff(addAssignment_3509,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6930(VarCurr,B)
      <=> v6932(VarCurr,B) ) ) ).

tff(addAssignment_3508,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6888(VarCurr,B)
      <=> v6890(VarCurr,B) ) ) ).

tff(addAssignment_3507,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6890(VarCurr,B)
      <=> v6892(VarCurr,B) ) ) ).

tff(addAssignment_3506,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6892(VarCurr,B)
      <=> v6894(VarCurr,B) ) ) ).

tff(addAssignment_3505,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6894(VarCurr,B)
      <=> v6896(VarCurr,B) ) ) ).

tff(addAssignment_3504,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6841(VarCurr,B)
      <=> v6843(VarCurr,B) ) ) ).

tff(addAssignment_3503,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6843(VarCurr,B)
      <=> v6845(VarCurr,B) ) ) ).

tff(addAssignment_3502,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6845(VarCurr,B)
      <=> v6847(VarCurr,B) ) ) ).

tff(addAssignment_3501,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6847(VarCurr,B)
      <=> v6849(VarCurr,B) ) ) ).

tff(addAssignment_3500,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6793(VarCurr,B)
      <=> v6795(VarCurr,B) ) ) ).

tff(addAssignment_3499,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6795(VarCurr,B)
      <=> v6797(VarCurr,B) ) ) ).

tff(addAssignment_3498,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6797(VarCurr,B)
      <=> v6799(VarCurr,B) ) ) ).

tff(addAssignment_3497,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6799(VarCurr,B)
      <=> v6801(VarCurr,B) ) ) ).

tff(addAssignment_3496,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6330(VarCurr,B)
      <=> v6332(VarCurr,B) ) ) ).

tff(addAssignment_3495,axiom,
    ! [VarCurr: state_type] :
      ( ( v6332(VarCurr,6)
      <=> v6334(VarCurr,18) )
      & ( v6332(VarCurr,5)
      <=> v6334(VarCurr,17) )
      & ( v6332(VarCurr,4)
      <=> v6334(VarCurr,16) )
      & ( v6332(VarCurr,3)
      <=> v6334(VarCurr,15) )
      & ( v6332(VarCurr,2)
      <=> v6334(VarCurr,14) )
      & ( v6332(VarCurr,1)
      <=> v6334(VarCurr,13) )
      & ( v6332(VarCurr,0)
      <=> v6334(VarCurr,12) ) ) ).

tff(addAssignment_3494,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,19)
        & ~ $less(B,12) )
     => ( v6334(VarCurr,B)
      <=> v6336(VarCurr,B) ) ) ).

tff(addAssignment_3493,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,19)
        & ~ $less(B,12) )
     => ( v6336(VarCurr,B)
      <=> v6338(VarCurr,B) ) ) ).

tff(addAssignment_3492,axiom,
    ! [VarCurr: state_type] :
      ( ( v6338(VarCurr,18)
      <=> v6340(VarCurr,6) )
      & ( v6338(VarCurr,17)
      <=> v6340(VarCurr,5) )
      & ( v6338(VarCurr,16)
      <=> v6340(VarCurr,4) )
      & ( v6338(VarCurr,15)
      <=> v6340(VarCurr,3) )
      & ( v6338(VarCurr,14)
      <=> v6340(VarCurr,2) )
      & ( v6338(VarCurr,13)
      <=> v6340(VarCurr,1) )
      & ( v6338(VarCurr,12)
      <=> v6340(VarCurr,0) ) ) ).

tff(addAssignment_3491,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6340(VarCurr,B)
      <=> v6342(VarCurr,B) ) ) ).

tff(addAssignment_3490,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6342(VarCurr,B)
      <=> v6344(VarCurr,B) ) ) ).

tff(addAssignment_3489,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6344(VarNext,B)
      <=> v7257(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_80,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7258(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7257(VarNext,B)
            <=> v6344(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_80,axiom,
    ! [VarNext: state_type] :
      ( v7258(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7257(VarNext,B)
          <=> v6606(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_647,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7258(VarNext)
      <=> v7259(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_646,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7259(VarNext)
      <=> ( v7261(VarNext)
          & v6567(VarNext) ) ) ) ).

tff(writeUnaryOperator_497,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7261(VarNext)
      <=> v6600(VarNext) ) ) ).

tff(addAssignment_3488,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6378(VarCurr,B)
      <=> v6380(VarCurr,B) ) ) ).

tff(addAssignment_3487,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6380(VarCurr,B)
      <=> v6382(VarCurr,B) ) ) ).

tff(addAssignment_3486,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6382(VarCurr,B)
      <=> v6550(VarCurr,B) ) ) ).

tff(addAssignment_3485,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6515(VarCurr,B)
      <=> v6517(VarCurr,B) ) ) ).

tff(addAssignment_3484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6517(VarCurr,B)
      <=> v6519(VarCurr,B) ) ) ).

tff(addAssignment_3483,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6519(VarCurr,B)
      <=> v6521(VarCurr,B) ) ) ).

tff(addAssignment_3482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6521(VarCurr,B)
      <=> v6523(VarCurr,B) ) ) ).

tff(addAssignment_3481,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6479(VarCurr,B)
      <=> v6481(VarCurr,B) ) ) ).

tff(addAssignment_3480,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6481(VarCurr,B)
      <=> v6483(VarCurr,B) ) ) ).

tff(addAssignment_3479,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6483(VarCurr,B)
      <=> v6485(VarCurr,B) ) ) ).

tff(addAssignment_3478,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6485(VarCurr,B)
      <=> v6487(VarCurr,B) ) ) ).

tff(addAssignment_3477,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6432(VarCurr,B)
      <=> v6434(VarCurr,B) ) ) ).

tff(addAssignment_3476,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6434(VarCurr,B)
      <=> v6436(VarCurr,B) ) ) ).

tff(addAssignment_3475,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6436(VarCurr,B)
      <=> v6438(VarCurr,B) ) ) ).

tff(addAssignment_3474,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6438(VarCurr,B)
      <=> v6440(VarCurr,B) ) ) ).

tff(addAssignment_3473,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6384(VarCurr,B)
      <=> v6386(VarCurr,B) ) ) ).

tff(addAssignment_3472,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6386(VarCurr,B)
      <=> v6388(VarCurr,B) ) ) ).

tff(addAssignment_3471,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6388(VarCurr,B)
      <=> v6390(VarCurr,B) ) ) ).

tff(addAssignment_3470,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6390(VarCurr,B)
      <=> v6392(VarCurr,B) ) ) ).

tff(addAssignment_3469,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6296(VarCurr,B)
      <=> v6298(VarCurr,B) ) ) ).

tff(addAssignment_3468,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v6298(VarCurr,B)
      <=> v6315(VarCurr,B) ) ) ).

tff(addAssignment_3467,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7248(VarCurr,B)
      <=> v7250(VarCurr,B) ) ) ).

tff(addAssignment_3466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7250(VarCurr,B)
      <=> b101111111110(B) ) ) ).

tff(bitBlastConstant_417,axiom,
    b101111111110(11) ).

tff(bitBlastConstant_416,axiom,
    ~ b101111111110(10) ).

tff(bitBlastConstant_415,axiom,
    b101111111110(9) ).

tff(bitBlastConstant_414,axiom,
    b101111111110(8) ).

tff(bitBlastConstant_413,axiom,
    b101111111110(7) ).

tff(bitBlastConstant_412,axiom,
    b101111111110(6) ).

tff(bitBlastConstant_411,axiom,
    b101111111110(5) ).

tff(bitBlastConstant_410,axiom,
    b101111111110(4) ).

tff(bitBlastConstant_409,axiom,
    b101111111110(3) ).

tff(bitBlastConstant_408,axiom,
    b101111111110(2) ).

tff(bitBlastConstant_407,axiom,
    b101111111110(1) ).

tff(bitBlastConstant_406,axiom,
    ~ b101111111110(0) ).

tff(addAssignment_3465,axiom,
    ! [VarCurr: state_type] :
      ( v7208(VarCurr,1)
    <=> v7210(VarCurr,1) ) ).

tff(addAssignment_3464,axiom,
    ! [VarCurr: state_type] :
      ( v7210(VarCurr,1)
    <=> v7211(VarCurr,1) ) ).

tff(addAssignment_3463,axiom,
    ! [VarCurr: state_type] :
      ( v7211(VarCurr,0)
    <=> v7212(VarCurr) ) ).

tff(addAssignment_3462,axiom,
    ! [VarCurr: state_type] :
      ( v7211(VarCurr,1)
    <=> v7212(VarCurr) ) ).

tff(addAssignment_3461,axiom,
    ! [VarCurr: state_type] :
      ( v7212(VarCurr)
    <=> v6310(VarCurr) ) ).

tff(addAssignment_3460,axiom,
    ! [VarCurr: state_type] :
      ( v7177(VarCurr)
    <=> v7179(VarCurr) ) ).

tff(addAssignment_3459,axiom,
    ! [VarCurr: state_type] :
      ( v7179(VarCurr)
    <=> v7181(VarCurr) ) ).

tff(addAssignment_3458,axiom,
    ! [VarCurr: state_type] :
      ( v7181(VarCurr)
    <=> v7183(VarCurr) ) ).

tff(addAssignment_3457,axiom,
    ! [VarCurr: state_type] :
      ( v7183(VarCurr)
    <=> v7185(VarCurr) ) ).

tff(addAssignment_3456,axiom,
    ! [VarCurr: state_type] :
      ( v7185(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_3455,axiom,
    ! [VarCurr: state_type] :
      ( v7163(VarCurr)
    <=> v7165(VarCurr) ) ).

tff(addAssignment_3454,axiom,
    ! [VarCurr: state_type] :
      ( v7165(VarCurr)
    <=> v7167(VarCurr) ) ).

tff(addAssignment_3453,axiom,
    ! [VarCurr: state_type] :
      ( v7167(VarCurr)
    <=> v7169(VarCurr) ) ).

tff(addAssignment_3452,axiom,
    ! [VarCurr: state_type] :
      ( v7169(VarCurr)
    <=> v7171(VarCurr) ) ).

tff(addAssignment_3451,axiom,
    ! [VarCurr: state_type] :
      ( v7171(VarCurr)
    <=> v7173(VarCurr) ) ).

tff(addAssignment_3450,axiom,
    ! [VarCurr: state_type] :
      ( v7173(VarCurr)
    <=> v7175(VarCurr) ) ).

tff(addAssignment_3449,axiom,
    ! [VarCurr: state_type] :
      ( v7175(VarCurr)
    <=> v1063(VarCurr) ) ).

tff(addAssignment_3448,axiom,
    ! [VarCurr: state_type] :
      ( v6248(VarCurr,7)
    <=> v6250(VarCurr,7) ) ).

tff(addAssignment_3447,axiom,
    ! [VarCurr: state_type] :
      ( v6250(VarCurr,7)
    <=> v6252(VarCurr,7) ) ).

tff(addAssignment_3446,axiom,
    ! [VarCurr: state_type] :
      ( v6252(VarCurr,7)
    <=> v6254(VarCurr,7) ) ).

tff(addAssignment_3445,axiom,
    ! [VarCurr: state_type] :
      ( v6254(VarCurr,7)
    <=> v6256(VarCurr,7) ) ).

tff(addAssignment_3444,axiom,
    ! [VarNext: state_type] :
      ( v6256(VarNext,7)
    <=> v7123(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_79,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7124(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v7123(VarNext,B)
            <=> v6256(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_79,axiom,
    ! [VarNext: state_type] :
      ( v7124(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7123(VarNext,B)
          <=> v7134(VarNext,B) ) ) ) ).

tff(addAssignment_3443,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7134(VarNext,B)
          <=> v7132(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_82,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7135(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7132(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_82,axiom,
    ! [VarCurr: state_type] :
      ( v7135(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7132(VarCurr,B)
          <=> v6286(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_645,axiom,
    ! [VarCurr: state_type] :
      ( v7135(VarCurr)
    <=> ( v7136(VarCurr)
        & v7137(VarCurr) ) ) ).

tff(writeUnaryOperator_496,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7137(VarCurr)
    <=> v6272(VarCurr) ) ).

tff(writeUnaryOperator_495,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7136(VarCurr)
    <=> v6258(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_644,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7124(VarNext)
      <=> v7125(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_643,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7125(VarNext)
      <=> ( v7126(VarNext)
          & v7033(VarNext) ) ) ) ).

tff(writeUnaryOperator_494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7126(VarNext)
      <=> v7128(VarNext) ) ) ).

tff(addAssignment_3442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7128(VarNext)
      <=> v7033(VarCurr) ) ) ).

tff(addAssignment_3441,axiom,
    ! [VarCurr: state_type] :
      ( v7033(VarCurr)
    <=> v7035(VarCurr) ) ).

tff(addAssignment_3440,axiom,
    ! [VarCurr: state_type] :
      ( v7035(VarCurr)
    <=> v7037(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_642,axiom,
    ! [VarCurr: state_type] :
      ( v7037(VarCurr)
    <=> ( v7121(VarCurr)
        | v7111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_641,axiom,
    ! [VarCurr: state_type] :
      ( v7121(VarCurr)
    <=> ( v7039(VarCurr)
        & v7047(VarCurr) ) ) ).

tff(addAssignment_3439,axiom,
    ! [VarCurr: state_type] :
      ( v7111(VarCurr)
    <=> v7113(VarCurr) ) ).

tff(addAssignment_3438,axiom,
    ! [VarCurr: state_type] :
      ( v7113(VarCurr)
    <=> v7115(VarCurr) ) ).

tff(addAssignment_3437,axiom,
    ! [VarCurr: state_type] :
      ( v7115(VarCurr)
    <=> v7117(VarCurr) ) ).

tff(addAssignment_3436,axiom,
    ! [VarCurr: state_type] :
      ( v7117(VarCurr)
    <=> v7119(VarCurr) ) ).

tff(addAssignment_3435,axiom,
    ! [VarCurr: state_type] :
      ( v7119(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_78,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7095(VarNext)
       => ( v7047(VarNext)
        <=> v7047(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_78,axiom,
    ! [VarNext: state_type] :
      ( v7095(VarNext)
     => ( v7047(VarNext)
      <=> v7105(VarNext) ) ) ).

tff(addAssignment_3434,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7105(VarNext)
      <=> v7103(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_640,axiom,
    ! [VarCurr: state_type] :
      ( v7103(VarCurr)
    <=> ( v7106(VarCurr)
        & v7107(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_639,axiom,
    ! [VarCurr: state_type] :
      ( v7107(VarCurr)
    <=> ( v7053(VarCurr)
        | v7084(VarCurr) ) ) ).

tff(writeUnaryOperator_493,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7106(VarCurr)
    <=> v7049(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_638,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7095(VarNext)
      <=> v7096(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_637,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7096(VarNext)
      <=> ( v7098(VarNext)
          & v7100(VarNext) ) ) ) ).

tff(writeUnaryOperator_492,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7100(VarCurr)
    <=> v7039(VarCurr) ) ).

tff(addAssignment_3433,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7098(VarNext)
      <=> v7039(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_14,axiom,
    ( v7047(constB0)
  <=> $true ) ).

tff(addAssignment_3432,axiom,
    ! [VarCurr: state_type] :
      ( v7084(VarCurr)
    <=> v7086(VarCurr) ) ).

tff(addAssignment_3431,axiom,
    ! [VarCurr: state_type] :
      ( v7086(VarCurr)
    <=> v7088(VarCurr) ) ).

tff(addAssignment_3430,axiom,
    ! [VarCurr: state_type] :
      ( v7088(VarCurr)
    <=> v7090(VarCurr) ) ).

tff(addAssignment_3429,axiom,
    ! [VarCurr: state_type] :
      ( v7090(VarCurr)
    <=> v7092(VarCurr) ) ).

tff(addAssignment_3428,axiom,
    ! [VarCurr: state_type] :
      ( v7092(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_3427,axiom,
    ! [VarCurr: state_type] :
      ( v7053(VarCurr)
    <=> v7055(VarCurr) ) ).

tff(addAssignment_3426,axiom,
    ! [VarCurr: state_type] :
      ( v7055(VarCurr)
    <=> v7057(VarCurr) ) ).

tff(addAssignment_3425,axiom,
    ! [VarCurr: state_type] :
      ( v7057(VarCurr)
    <=> v7059(VarCurr) ) ).

tff(addAssignment_3424,axiom,
    ! [VarCurr: state_type] :
      ( v7059(VarCurr)
    <=> v7061(VarCurr) ) ).

tff(writeUnaryOperator_491,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7061(VarCurr)
    <=> v7081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_636,axiom,
    ! [VarCurr: state_type] :
      ( v7081(VarCurr)
    <=> ( v7082(VarCurr)
        | v7077(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_635,axiom,
    ! [VarCurr: state_type] :
      ( v7082(VarCurr)
    <=> ( v7063(VarCurr)
        | v7073(VarCurr) ) ) ).

tff(addAssignment_3423,axiom,
    ! [VarCurr: state_type] :
      ( v7077(VarCurr)
    <=> v7079(VarCurr) ) ).

tff(addAssignment_3422,axiom,
    ! [VarCurr: state_type] :
      ( v7079(VarCurr)
    <=> v7067(VarCurr,2) ) ).

tff(addAssignment_3421,axiom,
    ! [VarCurr: state_type] :
      ( v7067(VarCurr,2)
    <=> v7069(VarCurr,2) ) ).

tff(addAssignment_3420,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,2)
    <=> v7071(VarCurr,2) ) ).

tff(addAssignment_3419,axiom,
    ! [VarCurr: state_type] :
      ( v7073(VarCurr)
    <=> v7075(VarCurr) ) ).

tff(addAssignment_3418,axiom,
    ! [VarCurr: state_type] :
      ( v7075(VarCurr)
    <=> v7067(VarCurr,1) ) ).

tff(addAssignment_3417,axiom,
    ! [VarCurr: state_type] :
      ( v7067(VarCurr,1)
    <=> v7069(VarCurr,1) ) ).

tff(addAssignment_3416,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,1)
    <=> v7071(VarCurr,1) ) ).

tff(addAssignment_3415,axiom,
    ! [VarCurr: state_type] :
      ( v7063(VarCurr)
    <=> v7065(VarCurr) ) ).

tff(addAssignment_3414,axiom,
    ! [VarCurr: state_type] :
      ( v7065(VarCurr)
    <=> v7067(VarCurr,0) ) ).

tff(addAssignment_3413,axiom,
    ! [VarCurr: state_type] :
      ( v7067(VarCurr,0)
    <=> v7069(VarCurr,0) ) ).

tff(addAssignment_3412,axiom,
    ! [VarCurr: state_type] :
      ( v7069(VarCurr,0)
    <=> v7071(VarCurr,0) ) ).

tff(addAssignment_3411,axiom,
    ! [VarCurr: state_type] :
      ( v7049(VarCurr)
    <=> v7051(VarCurr) ) ).

tff(addAssignment_3410,axiom,
    ! [VarCurr: state_type] :
      ( v7051(VarCurr)
    <=> $false ) ).

tff(addAssignment_3409,axiom,
    ! [VarCurr: state_type] :
      ( v7039(VarCurr)
    <=> v7041(VarCurr) ) ).

tff(addAssignment_3408,axiom,
    ! [VarCurr: state_type] :
      ( v7041(VarCurr)
    <=> v7043(VarCurr) ) ).

tff(addAssignment_3407,axiom,
    ! [VarCurr: state_type] :
      ( v7043(VarCurr)
    <=> v7045(VarCurr) ) ).

tff(addAssignment_3406,axiom,
    ! [VarCurr: state_type] :
      ( v7045(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_3405,axiom,
    ! [VarCurr: state_type] :
      ( v6286(VarCurr,7)
    <=> v6288(VarCurr,7) ) ).

tff(addAssignment_3404,axiom,
    ! [VarCurr: state_type] :
      ( v6288(VarCurr,7)
    <=> v6290(VarCurr,7) ) ).

tff(addAssignment_3403,axiom,
    ! [VarCurr: state_type] :
      ( v6290(VarCurr,7)
    <=> v6292(VarCurr,7) ) ).

tff(addAssignment_3402,axiom,
    ! [VarCurr: state_type] :
      ( v6292(VarCurr,7)
    <=> v6294(VarCurr,7) ) ).

tff(addAssignment_3401,axiom,
    ! [VarCurr: state_type] :
      ( v6294(VarCurr,7)
    <=> v7031(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7031(VarCurr,B)
      <=> ( v6296(VarCurr,B)
          & v6318(VarCurr,B) ) ) ) ).

tff(addAssignment_3400,axiom,
    ! [VarCurr: state_type] :
      ( v6318(VarCurr,7)
    <=> v6320(VarCurr,7) ) ).

tff(addAssignment_3399,axiom,
    ! [VarCurr: state_type] :
      ( v6320(VarCurr,7)
    <=> v6322(VarCurr,7) ) ).

tff(addAssignment_3398,axiom,
    ! [VarCurr: state_type] :
      ( v6322(VarCurr,7)
    <=> v6324(VarCurr,19) ) ).

tff(addAssignment_3397,axiom,
    ! [VarCurr: state_type] :
      ( v6324(VarCurr,19)
    <=> v6326(VarCurr,7) ) ).

tff(addAssignment_3396,axiom,
    ! [VarCurr: state_type] :
      ( v6326(VarCurr,7)
    <=> v6328(VarCurr,7) ) ).

tff(addAssignment_3395,axiom,
    ! [VarCurr: state_type] :
      ( v6328(VarCurr,7)
    <=> v7024(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7024(VarCurr,B)
      <=> ( v7025(VarCurr,B)
          | v7028(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_129,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7028(VarCurr,B)
      <=> ( v6749(VarCurr,B)
          & v7029(VarCurr,B) ) ) ) ).

tff(addAssignment_3394,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,0)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3393,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,1)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3392,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,2)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3391,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,3)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3390,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,4)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3389,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,5)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3388,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,6)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3387,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,7)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3386,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,8)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3385,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,9)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3384,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,10)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3383,axiom,
    ! [VarCurr: state_type] :
      ( v7029(VarCurr,11)
    <=> v7030(VarCurr) ) ).

tff(addAssignment_3382,axiom,
    ! [VarCurr: state_type] :
      ( v7030(VarCurr)
    <=> v7017(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_128,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v7025(VarCurr,B)
      <=> ( v6330(VarCurr,B)
          & v7026(VarCurr,B) ) ) ) ).

tff(addAssignment_3381,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,0)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3380,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,1)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3379,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,2)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3378,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,3)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3377,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,4)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3376,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,5)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3375,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,6)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3374,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,7)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3373,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,8)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3372,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,9)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3371,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,10)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3370,axiom,
    ! [VarCurr: state_type] :
      ( v7026(VarCurr,11)
    <=> v7027(VarCurr) ) ).

tff(addAssignment_3369,axiom,
    ! [VarCurr: state_type] :
      ( v7027(VarCurr)
    <=> v6613(VarCurr) ) ).

tff(addAssignment_3368,axiom,
    ! [VarCurr: state_type] :
      ( v7017(VarCurr)
    <=> v7019(VarCurr) ) ).

tff(addAssignment_3367,axiom,
    ! [VarCurr: state_type] :
      ( v7019(VarCurr)
    <=> v7021(VarCurr,1) ) ).

tff(addAssignment_3366,axiom,
    ! [VarCurr: state_type] :
      ( v7021(VarCurr,1)
    <=> v7023(VarCurr,1) ) ).

tff(addAssignment_3365,axiom,
    ! [VarCurr: state_type] :
      ( v7023(VarCurr,1)
    <=> v6623(VarCurr,1) ) ).

tff(addAssignment_3364,axiom,
    ! [VarCurr: state_type] :
      ( v6749(VarCurr,7)
    <=> v6751(VarCurr,7) ) ).

tff(addAssignment_3363,axiom,
    ! [VarCurr: state_type] :
      ( v6751(VarCurr,7)
    <=> v6334(VarCurr,31) ) ).

tff(addAssignment_3362,axiom,
    ! [VarCurr: state_type] :
      ( v6334(VarCurr,31)
    <=> v6336(VarCurr,31) ) ).

tff(addAssignment_3361,axiom,
    ! [VarCurr: state_type] :
      ( v6336(VarCurr,31)
    <=> v6338(VarCurr,31) ) ).

tff(addAssignment_3360,axiom,
    ! [VarCurr: state_type] :
      ( v6338(VarCurr,31)
    <=> v6753(VarCurr,7) ) ).

tff(addAssignment_3359,axiom,
    ! [VarCurr: state_type] :
      ( v6753(VarCurr,7)
    <=> v6755(VarCurr,7) ) ).

tff(addAssignment_3358,axiom,
    ! [VarCurr: state_type] :
      ( v6755(VarCurr,7)
    <=> v6757(VarCurr,7) ) ).

tff(addAssignment_3357,axiom,
    ! [VarNext: state_type] :
      ( v6757(VarNext,7)
    <=> v6999(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_77,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7000(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v6999(VarNext,B)
            <=> v6757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_77,axiom,
    ! [VarNext: state_type] :
      ( v7000(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v6999(VarNext,B)
          <=> v7010(VarNext,B) ) ) ) ).

tff(addAssignment_3356,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7010(VarNext,B)
          <=> v7008(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_81,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7011(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7008(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_81,axiom,
    ! [VarCurr: state_type] :
      ( v7011(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v7008(VarCurr,B)
          <=> v6787(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_634,axiom,
    ! [VarCurr: state_type] :
      ( v7011(VarCurr)
    <=> ( v7012(VarCurr)
        & v7013(VarCurr) ) ) ).

tff(writeUnaryOperator_490,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7013(VarCurr)
    <=> v6773(VarCurr) ) ).

tff(writeUnaryOperator_489,axiom,
    ! [VarCurr: state_type] :
      ( ~ v7012(VarCurr)
    <=> v6759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_633,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7000(VarNext)
      <=> v7001(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_632,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7001(VarNext)
      <=> ( v7002(VarNext)
          & v6975(VarNext) ) ) ) ).

tff(writeUnaryOperator_488,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v7002(VarNext)
      <=> v7004(VarNext) ) ) ).

tff(addAssignment_3355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v7004(VarNext)
      <=> v6975(VarCurr) ) ) ).

tff(addAssignment_3354,axiom,
    ! [VarCurr: state_type] :
      ( v6975(VarCurr)
    <=> v6977(VarCurr) ) ).

tff(addAssignment_3353,axiom,
    ! [VarCurr: state_type] :
      ( v6977(VarCurr)
    <=> v6979(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_631,axiom,
    ! [VarCurr: state_type] :
      ( v6979(VarCurr)
    <=> ( v6997(VarCurr)
        | v6989(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_630,axiom,
    ! [VarCurr: state_type] :
      ( v6997(VarCurr)
    <=> ( v6981(VarCurr)
        & v6987(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_13,axiom,
    ( v6987(constB0)
  <=> $true ) ).

tff(addAssignment_3352,axiom,
    ! [VarCurr: state_type] :
      ( v6989(VarCurr)
    <=> v6991(VarCurr) ) ).

tff(addAssignment_3351,axiom,
    ! [VarCurr: state_type] :
      ( v6991(VarCurr)
    <=> v6993(VarCurr) ) ).

tff(addAssignment_3350,axiom,
    ! [VarCurr: state_type] :
      ( v6993(VarCurr)
    <=> v6995(VarCurr) ) ).

tff(addAssignment_3349,axiom,
    ! [VarCurr: state_type] :
      ( v6995(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_3348,axiom,
    ! [VarCurr: state_type] :
      ( v6981(VarCurr)
    <=> v6983(VarCurr) ) ).

tff(addAssignment_3347,axiom,
    ! [VarCurr: state_type] :
      ( v6983(VarCurr)
    <=> v6985(VarCurr) ) ).

tff(addAssignment_3346,axiom,
    ! [VarCurr: state_type] :
      ( v6985(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_3345,axiom,
    ! [VarCurr: state_type] :
      ( v6787(VarCurr,7)
    <=> v6789(VarCurr,7) ) ).

tff(addAssignment_3344,axiom,
    ! [VarCurr: state_type] :
      ( v6789(VarCurr,7)
    <=> v6791(VarCurr,7) ) ).

tff(addAssignment_3343,axiom,
    ! [VarCurr: state_type] :
      ( v6791(VarCurr,7)
    <=> v6959(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_127,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6959(VarCurr,B)
      <=> ( v6960(VarCurr,B)
          | v6971(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_126,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6971(VarCurr,B)
      <=> ( v6924(VarCurr,B)
          & v6972(VarCurr,B) ) ) ) ).

tff(addAssignment_3342,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,0)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3341,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,1)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3340,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,2)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3339,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,3)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3338,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,4)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3337,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,5)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3336,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,6)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3335,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,7)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3334,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,8)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3333,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,9)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3332,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,10)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3331,axiom,
    ! [VarCurr: state_type] :
      ( v6972(VarCurr,11)
    <=> v6973(VarCurr) ) ).

tff(addAssignment_3330,axiom,
    ! [VarCurr: state_type] :
      ( v6973(VarCurr)
    <=> v6934(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_125,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6960(VarCurr,B)
      <=> ( v6961(VarCurr,B)
          | v6968(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_124,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6968(VarCurr,B)
      <=> ( v6888(VarCurr,B)
          & v6969(VarCurr,B) ) ) ) ).

tff(addAssignment_3329,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,0)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3328,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,1)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3327,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,2)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3326,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,3)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3325,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,4)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3324,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,5)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3323,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,6)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3322,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,7)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3321,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,8)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3320,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,9)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3319,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,10)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3318,axiom,
    ! [VarCurr: state_type] :
      ( v6969(VarCurr,11)
    <=> v6970(VarCurr) ) ).

tff(addAssignment_3317,axiom,
    ! [VarCurr: state_type] :
      ( v6970(VarCurr)
    <=> v6898(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_123,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6961(VarCurr,B)
      <=> ( v6962(VarCurr,B)
          | v6965(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_122,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6965(VarCurr,B)
      <=> ( v6841(VarCurr,B)
          & v6966(VarCurr,B) ) ) ) ).

tff(addAssignment_3316,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,0)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3315,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,1)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3314,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,2)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3313,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,3)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3312,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,4)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3311,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,5)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3310,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,6)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3309,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,7)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3308,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,8)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3307,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,9)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3306,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,10)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3305,axiom,
    ! [VarCurr: state_type] :
      ( v6966(VarCurr,11)
    <=> v6967(VarCurr) ) ).

tff(addAssignment_3304,axiom,
    ! [VarCurr: state_type] :
      ( v6967(VarCurr)
    <=> v6851(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_121,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6962(VarCurr,B)
      <=> ( v6793(VarCurr,B)
          & v6963(VarCurr,B) ) ) ) ).

tff(addAssignment_3303,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,0)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3302,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,1)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3301,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,2)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3300,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,3)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3299,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,4)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3298,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,5)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3297,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,6)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3296,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,7)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3295,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,8)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3294,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,9)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3293,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,10)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3292,axiom,
    ! [VarCurr: state_type] :
      ( v6963(VarCurr,11)
    <=> v6964(VarCurr) ) ).

tff(addAssignment_3291,axiom,
    ! [VarCurr: state_type] :
      ( v6964(VarCurr)
    <=> v6803(VarCurr) ) ).

tff(addAssignment_3290,axiom,
    ! [VarCurr: state_type] :
      ( v6934(VarCurr)
    <=> v6936(VarCurr) ) ).

tff(addAssignment_3289,axiom,
    ! [VarCurr: state_type] :
      ( v6936(VarCurr)
    <=> v6938(VarCurr) ) ).

tff(addAssignment_3288,axiom,
    ! [VarCurr: state_type] :
      ( v6938(VarCurr)
    <=> v6940(VarCurr) ) ).

tff(addAssignment_3287,axiom,
    ! [VarCurr: state_type] :
      ( v6940(VarCurr)
    <=> v6942(VarCurr) ) ).

tff(addAssignment_3286,axiom,
    ! [VarCurr: state_type] :
      ( v6942(VarCurr)
    <=> v6944(VarCurr) ) ).

tff(addAssignment_3285,axiom,
    ! [VarCurr: state_type] :
      ( v6944(VarCurr)
    <=> v6946(VarCurr) ) ).

tff(addAssignment_3284,axiom,
    ! [VarCurr: state_type] :
      ( v6946(VarCurr)
    <=> v6948(VarCurr) ) ).

tff(writeUnaryOperator_487,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6948(VarCurr)
    <=> v6958(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_629,axiom,
    ! [VarCurr: state_type] :
      ( v6958(VarCurr)
    <=> ( v6950(VarCurr)
        | v6954(VarCurr) ) ) ).

tff(addAssignment_3283,axiom,
    ! [VarCurr: state_type] :
      ( v6954(VarCurr)
    <=> v6956(VarCurr) ) ).

tff(addAssignment_3282,axiom,
    ! [VarCurr: state_type] :
      ( v6956(VarCurr)
    <=> v6871(VarCurr,1) ) ).

tff(addAssignment_3281,axiom,
    ! [VarCurr: state_type] :
      ( v6950(VarCurr)
    <=> v6952(VarCurr) ) ).

tff(addAssignment_3280,axiom,
    ! [VarCurr: state_type] :
      ( v6952(VarCurr)
    <=> v6871(VarCurr,0) ) ).

tff(addAssignment_3279,axiom,
    ! [VarCurr: state_type] :
      ( v6924(VarCurr,7)
    <=> v6926(VarCurr,7) ) ).

tff(addAssignment_3278,axiom,
    ! [VarCurr: state_type] :
      ( v6926(VarCurr,7)
    <=> v6928(VarCurr,7) ) ).

tff(addAssignment_3277,axiom,
    ! [VarCurr: state_type] :
      ( v6928(VarCurr,7)
    <=> v6930(VarCurr,7) ) ).

tff(addAssignment_3276,axiom,
    ! [VarCurr: state_type] :
      ( v6930(VarCurr,7)
    <=> v6932(VarCurr,7) ) ).

tff(addAssignment_3275,axiom,
    ! [VarCurr: state_type] :
      ( v6898(VarCurr)
    <=> v6900(VarCurr) ) ).

tff(addAssignment_3274,axiom,
    ! [VarCurr: state_type] :
      ( v6900(VarCurr)
    <=> v6902(VarCurr) ) ).

tff(addAssignment_3273,axiom,
    ! [VarCurr: state_type] :
      ( v6902(VarCurr)
    <=> v6904(VarCurr) ) ).

tff(addAssignment_3272,axiom,
    ! [VarCurr: state_type] :
      ( v6904(VarCurr)
    <=> v6906(VarCurr) ) ).

tff(addAssignment_3271,axiom,
    ! [VarCurr: state_type] :
      ( v6906(VarCurr)
    <=> v6908(VarCurr) ) ).

tff(addAssignment_3270,axiom,
    ! [VarCurr: state_type] :
      ( v6908(VarCurr)
    <=> v6910(VarCurr) ) ).

tff(addAssignment_3269,axiom,
    ! [VarCurr: state_type] :
      ( v6910(VarCurr)
    <=> v6912(VarCurr) ) ).

tff(writeUnaryOperator_486,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6912(VarCurr)
    <=> v6922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_628,axiom,
    ! [VarCurr: state_type] :
      ( v6922(VarCurr)
    <=> ( v6914(VarCurr)
        | v6918(VarCurr) ) ) ).

tff(addAssignment_3268,axiom,
    ! [VarCurr: state_type] :
      ( v6918(VarCurr)
    <=> v6920(VarCurr) ) ).

tff(addAssignment_3267,axiom,
    ! [VarCurr: state_type] :
      ( v6920(VarCurr)
    <=> v6871(VarCurr,1) ) ).

tff(addAssignment_3266,axiom,
    ! [VarCurr: state_type] :
      ( v6871(VarCurr,1)
    <=> v6873(VarCurr,1) ) ).

tff(addAssignment_3265,axiom,
    ! [VarCurr: state_type] :
      ( v6873(VarCurr,1)
    <=> v6875(VarCurr,1) ) ).

tff(addAssignment_3264,axiom,
    ! [VarCurr: state_type] :
      ( v6875(VarCurr,1)
    <=> v6880(VarCurr,1) ) ).

tff(addAssignment_3263,axiom,
    ! [VarCurr: state_type] :
      ( v6877(VarCurr,1)
    <=> v6879(VarCurr,1) ) ).

tff(addAssignment_3262,axiom,
    ! [VarCurr: state_type] :
      ( v6879(VarCurr,1)
    <=> v6823(VarCurr,1) ) ).

tff(addAssignment_3261,axiom,
    ! [VarCurr: state_type] :
      ( v6914(VarCurr)
    <=> v6916(VarCurr) ) ).

tff(addAssignment_3260,axiom,
    ! [VarCurr: state_type] :
      ( v6916(VarCurr)
    <=> v6823(VarCurr,0) ) ).

tff(addAssignment_3259,axiom,
    ! [VarCurr: state_type] :
      ( v6888(VarCurr,7)
    <=> v6890(VarCurr,7) ) ).

tff(addAssignment_3258,axiom,
    ! [VarCurr: state_type] :
      ( v6890(VarCurr,7)
    <=> v6892(VarCurr,7) ) ).

tff(addAssignment_3257,axiom,
    ! [VarCurr: state_type] :
      ( v6892(VarCurr,7)
    <=> v6894(VarCurr,7) ) ).

tff(addAssignment_3256,axiom,
    ! [VarCurr: state_type] :
      ( v6894(VarCurr,7)
    <=> v6896(VarCurr,7) ) ).

tff(addAssignment_3255,axiom,
    ! [VarCurr: state_type] :
      ( v6851(VarCurr)
    <=> v6853(VarCurr) ) ).

tff(addAssignment_3254,axiom,
    ! [VarCurr: state_type] :
      ( v6853(VarCurr)
    <=> v6855(VarCurr) ) ).

tff(addAssignment_3253,axiom,
    ! [VarCurr: state_type] :
      ( v6855(VarCurr)
    <=> v6857(VarCurr) ) ).

tff(addAssignment_3252,axiom,
    ! [VarCurr: state_type] :
      ( v6857(VarCurr)
    <=> v6859(VarCurr) ) ).

tff(addAssignment_3251,axiom,
    ! [VarCurr: state_type] :
      ( v6859(VarCurr)
    <=> v6861(VarCurr) ) ).

tff(addAssignment_3250,axiom,
    ! [VarCurr: state_type] :
      ( v6861(VarCurr)
    <=> v6863(VarCurr) ) ).

tff(addAssignment_3249,axiom,
    ! [VarCurr: state_type] :
      ( v6863(VarCurr)
    <=> v6865(VarCurr) ) ).

tff(writeUnaryOperator_485,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6865(VarCurr)
    <=> v6886(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_627,axiom,
    ! [VarCurr: state_type] :
      ( v6886(VarCurr)
    <=> ( v6867(VarCurr)
        | v6882(VarCurr) ) ) ).

tff(addAssignment_3248,axiom,
    ! [VarCurr: state_type] :
      ( v6882(VarCurr)
    <=> v6884(VarCurr) ) ).

tff(addAssignment_3247,axiom,
    ! [VarCurr: state_type] :
      ( v6884(VarCurr)
    <=> v6823(VarCurr,1) ) ).

tff(addAssignment_3246,axiom,
    ! [VarCurr: state_type] :
      ( v6867(VarCurr)
    <=> v6869(VarCurr) ) ).

tff(addAssignment_3245,axiom,
    ! [VarCurr: state_type] :
      ( v6869(VarCurr)
    <=> v6871(VarCurr,0) ) ).

tff(addAssignment_3244,axiom,
    ! [VarCurr: state_type] :
      ( v6871(VarCurr,0)
    <=> v6873(VarCurr,0) ) ).

tff(addAssignment_3243,axiom,
    ! [VarCurr: state_type] :
      ( v6873(VarCurr,0)
    <=> v6875(VarCurr,0) ) ).

tff(addAssignment_3242,axiom,
    ! [VarCurr: state_type] :
      ( v6875(VarCurr,0)
    <=> v6880(VarCurr,0) ) ).

tff(writeUnaryOperator_484,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v6880(VarCurr,B)
      <=> ~ v6877(VarCurr,B) ) ) ).

tff(addAssignment_3241,axiom,
    ! [VarCurr: state_type] :
      ( v6877(VarCurr,0)
    <=> v6879(VarCurr,0) ) ).

tff(addAssignment_3240,axiom,
    ! [VarCurr: state_type] :
      ( v6879(VarCurr,0)
    <=> v6823(VarCurr,0) ) ).

tff(addAssignment_3239,axiom,
    ! [VarCurr: state_type] :
      ( v6841(VarCurr,7)
    <=> v6843(VarCurr,7) ) ).

tff(addAssignment_3238,axiom,
    ! [VarCurr: state_type] :
      ( v6843(VarCurr,7)
    <=> v6845(VarCurr,7) ) ).

tff(addAssignment_3237,axiom,
    ! [VarCurr: state_type] :
      ( v6845(VarCurr,7)
    <=> v6847(VarCurr,7) ) ).

tff(addAssignment_3236,axiom,
    ! [VarCurr: state_type] :
      ( v6847(VarCurr,7)
    <=> v6849(VarCurr,7) ) ).

tff(addAssignment_3235,axiom,
    ! [VarCurr: state_type] :
      ( v6803(VarCurr)
    <=> v6805(VarCurr) ) ).

tff(addAssignment_3234,axiom,
    ! [VarCurr: state_type] :
      ( v6805(VarCurr)
    <=> v6807(VarCurr) ) ).

tff(addAssignment_3233,axiom,
    ! [VarCurr: state_type] :
      ( v6807(VarCurr)
    <=> v6809(VarCurr) ) ).

tff(addAssignment_3232,axiom,
    ! [VarCurr: state_type] :
      ( v6809(VarCurr)
    <=> v6811(VarCurr) ) ).

tff(addAssignment_3231,axiom,
    ! [VarCurr: state_type] :
      ( v6811(VarCurr)
    <=> v6813(VarCurr) ) ).

tff(addAssignment_3230,axiom,
    ! [VarCurr: state_type] :
      ( v6813(VarCurr)
    <=> v6815(VarCurr) ) ).

tff(addAssignment_3229,axiom,
    ! [VarCurr: state_type] :
      ( v6815(VarCurr)
    <=> v6817(VarCurr) ) ).

tff(writeUnaryOperator_483,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6817(VarCurr)
    <=> v6839(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_626,axiom,
    ! [VarCurr: state_type] :
      ( v6839(VarCurr)
    <=> ( v6819(VarCurr)
        | v6835(VarCurr) ) ) ).

tff(addAssignment_3228,axiom,
    ! [VarCurr: state_type] :
      ( v6835(VarCurr)
    <=> v6837(VarCurr) ) ).

tff(addAssignment_3227,axiom,
    ! [VarCurr: state_type] :
      ( v6837(VarCurr)
    <=> v6823(VarCurr,1) ) ).

tff(addAssignment_3226,axiom,
    ! [VarCurr: state_type] :
      ( v6823(VarCurr,1)
    <=> v6825(VarCurr,1) ) ).

tff(addAssignment_3225,axiom,
    ! [VarCurr: state_type] :
      ( v6825(VarCurr,1)
    <=> v6827(VarCurr,1) ) ).

tff(addAssignment_3224,axiom,
    ! [VarCurr: state_type] :
      ( v6827(VarCurr,1)
    <=> v6829(VarCurr,1) ) ).

tff(addAssignment_3223,axiom,
    ! [VarCurr: state_type] :
      ( v6829(VarCurr,1)
    <=> v6831(VarCurr,1) ) ).

tff(addAssignment_3222,axiom,
    ! [VarCurr: state_type] :
      ( v6831(VarCurr,1)
    <=> v6833(VarCurr,1) ) ).

tff(addAssignment_3221,axiom,
    ! [VarCurr: state_type] :
      ( v6819(VarCurr)
    <=> v6821(VarCurr) ) ).

tff(addAssignment_3220,axiom,
    ! [VarCurr: state_type] :
      ( v6821(VarCurr)
    <=> v6823(VarCurr,0) ) ).

tff(addAssignment_3219,axiom,
    ! [VarCurr: state_type] :
      ( v6823(VarCurr,0)
    <=> v6825(VarCurr,0) ) ).

tff(addAssignment_3218,axiom,
    ! [VarCurr: state_type] :
      ( v6825(VarCurr,0)
    <=> v6827(VarCurr,0) ) ).

tff(addAssignment_3217,axiom,
    ! [VarCurr: state_type] :
      ( v6827(VarCurr,0)
    <=> v6829(VarCurr,0) ) ).

tff(addAssignment_3216,axiom,
    ! [VarCurr: state_type] :
      ( v6829(VarCurr,0)
    <=> v6831(VarCurr,0) ) ).

tff(addAssignment_3215,axiom,
    ! [VarCurr: state_type] :
      ( v6831(VarCurr,0)
    <=> v6833(VarCurr,0) ) ).

tff(addAssignment_3214,axiom,
    ! [VarCurr: state_type] :
      ( v6793(VarCurr,7)
    <=> v6795(VarCurr,7) ) ).

tff(addAssignment_3213,axiom,
    ! [VarCurr: state_type] :
      ( v6795(VarCurr,7)
    <=> v6797(VarCurr,7) ) ).

tff(addAssignment_3212,axiom,
    ! [VarCurr: state_type] :
      ( v6797(VarCurr,7)
    <=> v6799(VarCurr,7) ) ).

tff(addAssignment_3211,axiom,
    ! [VarCurr: state_type] :
      ( v6799(VarCurr,7)
    <=> v6801(VarCurr,7) ) ).

tff(addAssignment_3210,axiom,
    ! [VarCurr: state_type] :
      ( v6773(VarCurr)
    <=> v6775(VarCurr) ) ).

tff(addAssignment_3209,axiom,
    ! [VarCurr: state_type] :
      ( v6775(VarCurr)
    <=> v6777(VarCurr) ) ).

tff(addAssignment_3208,axiom,
    ! [VarCurr: state_type] :
      ( v6777(VarCurr)
    <=> v6779(VarCurr) ) ).

tff(addAssignment_3207,axiom,
    ! [VarCurr: state_type] :
      ( v6779(VarCurr)
    <=> v6781(VarCurr) ) ).

tff(addAssignment_3206,axiom,
    ! [VarCurr: state_type] :
      ( v6781(VarCurr)
    <=> v6783(VarCurr) ) ).

tff(addAssignment_3205,axiom,
    ! [VarCurr: state_type] :
      ( v6783(VarCurr)
    <=> v6785(VarCurr) ) ).

tff(addAssignment_3204,axiom,
    ! [VarCurr: state_type] :
      ( v6785(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_3203,axiom,
    ! [VarCurr: state_type] :
      ( v6759(VarCurr)
    <=> v6761(VarCurr) ) ).

tff(addAssignment_3202,axiom,
    ! [VarCurr: state_type] :
      ( v6761(VarCurr)
    <=> v6763(VarCurr) ) ).

tff(addAssignment_3201,axiom,
    ! [VarCurr: state_type] :
      ( v6763(VarCurr)
    <=> v6765(VarCurr) ) ).

tff(addAssignment_3200,axiom,
    ! [VarCurr: state_type] :
      ( v6765(VarCurr)
    <=> v6767(VarCurr) ) ).

tff(addAssignment_3199,axiom,
    ! [VarCurr: state_type] :
      ( v6767(VarCurr)
    <=> v6769(VarCurr) ) ).

tff(addAssignment_3198,axiom,
    ! [VarCurr: state_type] :
      ( v6769(VarCurr)
    <=> v6771(VarCurr) ) ).

tff(addAssignment_3197,axiom,
    ! [VarCurr: state_type] :
      ( v6771(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_3196,axiom,
    ! [VarCurr: state_type] :
      ( v6613(VarCurr)
    <=> v6615(VarCurr) ) ).

tff(addAssignment_3195,axiom,
    ! [VarCurr: state_type] :
      ( v6615(VarCurr)
    <=> v6617(VarCurr,1) ) ).

tff(addAssignment_3194,axiom,
    ! [VarCurr: state_type] :
      ( v6617(VarCurr,1)
    <=> v6619(VarCurr,1) ) ).

tff(addAssignment_3193,axiom,
    ! [VarCurr: state_type] :
      ( v6619(VarCurr,1)
    <=> v6621(VarCurr,1) ) ).

tff(addAssignment_3192,axiom,
    ! [VarCurr: state_type] :
      ( v6621(VarCurr,1)
    <=> v6747(VarCurr,1) ) ).

tff(writeUnaryOperator_482,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v6747(VarCurr,B)
      <=> ~ v6623(VarCurr,B) ) ) ).

tff(addAssignment_3191,axiom,
    ! [VarCurr: state_type] :
      ( v6623(VarCurr,1)
    <=> v6690(VarCurr,1) ) ).

tff(addAssignment_3190,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,0)
    <=> v6746(VarCurr) ) ).

tff(addAssignment_3189,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,1)
    <=> v6742(VarCurr) ) ).

tff(addAssignment_3188,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,2)
    <=> v6738(VarCurr) ) ).

tff(addAssignment_3187,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,3)
    <=> v6734(VarCurr) ) ).

tff(addAssignment_3186,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,4)
    <=> v6730(VarCurr) ) ).

tff(addAssignment_3185,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,5)
    <=> v6725(VarCurr) ) ).

tff(addAssignment_3184,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,6)
    <=> v6720(VarCurr) ) ).

tff(addAssignment_3183,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,7)
    <=> v6718(VarCurr) ) ).

tff(addAssignment_3182,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,8)
    <=> v6713(VarCurr) ) ).

tff(addAssignment_3181,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,9)
    <=> v6708(VarCurr) ) ).

tff(addAssignment_3180,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,10)
    <=> v6701(VarCurr) ) ).

tff(addAssignment_3179,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,11)
    <=> v6698(VarCurr) ) ).

tff(addAssignment_3178,axiom,
    ! [VarCurr: state_type] :
      ( v6690(VarCurr,12)
    <=> v6691(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_80,axiom,
    ! [VarCurr: state_type] :
      ( v6746(VarCurr)
    <=> ( ( v6625(VarCurr,3)
        <=> $false )
        & ( v6625(VarCurr,2)
        <=> $false )
        & ( v6625(VarCurr,1)
        <=> $false )
        & ( v6625(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeUnaryOperator_481,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6742(VarCurr)
    <=> v6744(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_151,axiom,
    ! [VarCurr: state_type] :
      ( v6744(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6745(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_625,axiom,
    ! [VarCurr: state_type] :
      ( v6745(VarCurr)
    <=> ( v6719(VarCurr)
        & v6711(VarCurr) ) ) ).

tff(writeUnaryOperator_480,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6738(VarCurr)
    <=> v6740(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_150,axiom,
    ! [VarCurr: state_type] :
      ( v6740(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6741(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_624,axiom,
    ! [VarCurr: state_type] :
      ( v6741(VarCurr)
    <=> ( v6719(VarCurr)
        & v6704(VarCurr) ) ) ).

tff(writeUnaryOperator_479,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6734(VarCurr)
    <=> v6736(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_149,axiom,
    ! [VarCurr: state_type] :
      ( v6736(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6737(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_148,axiom,
    ! [VarCurr: state_type] :
      ( v6737(VarCurr)
    <=> ( v6625(VarCurr,2)
        & v6719(VarCurr) ) ) ).

tff(writeUnaryOperator_478,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6730(VarCurr)
    <=> v6732(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_147,axiom,
    ! [VarCurr: state_type] :
      ( v6732(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6733(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_623,axiom,
    ! [VarCurr: state_type] :
      ( v6733(VarCurr)
    <=> ( v6694(VarCurr)
        & v6719(VarCurr) ) ) ).

tff(writeUnaryOperator_477,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6725(VarCurr)
    <=> v6727(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_146,axiom,
    ! [VarCurr: state_type] :
      ( v6727(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6728(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_622,axiom,
    ! [VarCurr: state_type] :
      ( v6728(VarCurr)
    <=> ( v6719(VarCurr)
        & v6729(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_145,axiom,
    ! [VarCurr: state_type] :
      ( v6729(VarCurr)
    <=> ( v6625(VarCurr,1)
        & v6625(VarCurr,2) ) ) ).

tff(writeUnaryOperator_476,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6720(VarCurr)
    <=> v6722(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_144,axiom,
    ! [VarCurr: state_type] :
      ( v6722(VarCurr)
    <=> ( v6625(VarCurr,3)
        | v6723(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_621,axiom,
    ! [VarCurr: state_type] :
      ( v6723(VarCurr)
    <=> ( v6719(VarCurr)
        & v6724(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_143,axiom,
    ! [VarCurr: state_type] :
      ( v6724(VarCurr)
    <=> ( v6625(VarCurr,2)
        & v6707(VarCurr) ) ) ).

tff(writeUnaryOperator_475,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6719(VarCurr)
    <=> v6625(VarCurr,3) ) ).

tff(writeUnaryOperator_474,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6718(VarCurr)
    <=> v6625(VarCurr,3) ) ).

tff(writeUnaryOperator_473,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6713(VarCurr)
    <=> v6715(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_142,axiom,
    ! [VarCurr: state_type] :
      ( v6715(VarCurr)
    <=> ( v6625(VarCurr,3)
        & v6716(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_141,axiom,
    ! [VarCurr: state_type] :
      ( v6716(VarCurr)
    <=> ( v6625(VarCurr,2)
        | v6717(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_620,axiom,
    ! [VarCurr: state_type] :
      ( v6717(VarCurr)
    <=> ( v6695(VarCurr)
        & v6706(VarCurr) ) ) ).

tff(writeUnaryOperator_472,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6708(VarCurr)
    <=> v6710(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_140,axiom,
    ! [VarCurr: state_type] :
      ( v6710(VarCurr)
    <=> ( v6625(VarCurr,3)
        & v6711(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_139,axiom,
    ! [VarCurr: state_type] :
      ( v6711(VarCurr)
    <=> ( v6625(VarCurr,2)
        | v6712(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_138,axiom,
    ! [VarCurr: state_type] :
      ( v6712(VarCurr)
    <=> ( v6625(VarCurr,1)
        & v6706(VarCurr) ) ) ).

tff(writeUnaryOperator_471,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6701(VarCurr)
    <=> v6703(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_137,axiom,
    ! [VarCurr: state_type] :
      ( v6703(VarCurr)
    <=> ( v6625(VarCurr,3)
        & v6704(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_136,axiom,
    ! [VarCurr: state_type] :
      ( v6704(VarCurr)
    <=> ( v6625(VarCurr,2)
        | v6705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_619,axiom,
    ! [VarCurr: state_type] :
      ( v6705(VarCurr)
    <=> ( v6706(VarCurr)
        & v6707(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_135,axiom,
    ! [VarCurr: state_type] :
      ( v6707(VarCurr)
    <=> ( v6625(VarCurr,0)
        & v6625(VarCurr,1) ) ) ).

tff(writeUnaryOperator_470,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6706(VarCurr)
    <=> v6625(VarCurr,2) ) ).

tff(writeUnaryOperator_469,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6698(VarCurr)
    <=> v6700(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_134,axiom,
    ! [VarCurr: state_type] :
      ( v6700(VarCurr)
    <=> ( v6625(VarCurr,2)
        & v6625(VarCurr,3) ) ) ).

tff(writeUnaryOperator_468,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6691(VarCurr)
    <=> v6693(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_133,axiom,
    ! [VarCurr: state_type] :
      ( v6693(VarCurr)
    <=> ( v6694(VarCurr)
        & v6625(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_132,axiom,
    ! [VarCurr: state_type] :
      ( v6694(VarCurr)
    <=> ( v6695(VarCurr)
        & v6625(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_131,axiom,
    ! [VarCurr: state_type] :
      ( v6695(VarCurr)
    <=> ( v6625(VarCurr,1)
        | v6696(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_618,axiom,
    ! [VarCurr: state_type] :
      ( v6696(VarCurr)
    <=> ( v6625(VarCurr,0)
        & v6697(VarCurr) ) ) ).

tff(writeUnaryOperator_467,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6697(VarCurr)
    <=> v6625(VarCurr,1) ) ).

tff(addAssignment_3177,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6625(VarCurr,B)
      <=> v6689(VarCurr,B) ) ) ).

tff(writeUnaryOperator_466,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6689(VarCurr,B)
      <=> ~ v6627(VarCurr,B) ) ) ).

tff(addAssignment_3176,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6627(VarCurr,B)
      <=> v6629(VarCurr,B) ) ) ).

tff(addAssignment_3175,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6629(VarCurr,B)
      <=> v6631(VarCurr,B) ) ) ).

tff(addAssignment_3174,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6631(VarNext,B)
      <=> v6672(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_76,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6673(VarNext)
       => ! [B: $int] :
            ( ( $less(B,16)
              & ~ $less(B,0) )
           => ( v6672(VarNext,B)
            <=> v6631(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_76,axiom,
    ! [VarNext: state_type] :
      ( v6673(VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v6672(VarNext,B)
          <=> v6683(VarNext,B) ) ) ) ).

tff(addAssignment_3173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v6683(VarNext,B)
          <=> v6681(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_80,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6684(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v6681(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_80,axiom,
    ! [VarCurr: state_type] :
      ( v6684(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,16)
            & ~ $less(B,0) )
         => ( v6681(VarCurr,B)
          <=> v6641(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_617,axiom,
    ! [VarCurr: state_type] :
      ( v6684(VarCurr)
    <=> ( v6685(VarCurr)
        & v6686(VarCurr) ) ) ).

tff(writeUnaryOperator_465,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6686(VarCurr)
    <=> v6637(VarCurr) ) ).

tff(writeUnaryOperator_464,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6685(VarCurr)
    <=> v6633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_616,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6673(VarNext)
      <=> v6674(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_615,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6674(VarNext)
      <=> ( v6675(VarNext)
          & v6668(VarNext) ) ) ) ).

tff(writeUnaryOperator_463,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6675(VarNext)
      <=> v6677(VarNext) ) ) ).

tff(addAssignment_3172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6677(VarNext)
      <=> v6668(VarCurr) ) ) ).

tff(addAssignment_3171,axiom,
    ! [VarCurr: state_type] :
      ( v6668(VarCurr)
    <=> v6670(VarCurr) ) ).

tff(addAssignment_3170,axiom,
    ! [VarCurr: state_type] :
      ( v6670(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_3169,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6641(VarCurr,B)
      <=> v6643(VarCurr,B) ) ) ).

tff(addAssignment_3168,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6643(VarCurr,B)
      <=> v6658(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_120,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6658(VarCurr,B)
      <=> ( v6659(VarCurr,B)
          | v6662(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_119,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6662(VarCurr,B)
      <=> ( v6629(VarCurr,B)
          & v6663(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_462,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6663(VarCurr,B)
      <=> ~ v6664(VarCurr,B) ) ) ).

tff(addAssignment_3167,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,0)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3166,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,1)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3165,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,2)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3164,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,3)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3163,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,4)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3162,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,5)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3161,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,6)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3160,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,7)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3159,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,8)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3158,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,9)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3157,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,10)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3156,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,11)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3155,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,12)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3154,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,13)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3153,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,14)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3152,axiom,
    ! [VarCurr: state_type] :
      ( v6664(VarCurr,15)
    <=> v6665(VarCurr) ) ).

tff(addAssignment_3151,axiom,
    ! [VarCurr: state_type] :
      ( v6665(VarCurr)
    <=> v6652(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_118,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6659(VarCurr,B)
      <=> ( v6645(VarCurr,B)
          & v6660(VarCurr,B) ) ) ) ).

tff(addAssignment_3150,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,0)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3149,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,1)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3148,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,2)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3147,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,3)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3146,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,4)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3145,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,5)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3144,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,6)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3143,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,7)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3142,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,8)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3141,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,9)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3140,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,10)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3139,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,11)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3138,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,12)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3137,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,13)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3136,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,14)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3135,axiom,
    ! [VarCurr: state_type] :
      ( v6660(VarCurr,15)
    <=> v6661(VarCurr) ) ).

tff(addAssignment_3134,axiom,
    ! [VarCurr: state_type] :
      ( v6661(VarCurr)
    <=> v6652(VarCurr) ) ).

tff(addAssignment_3133,axiom,
    ! [VarCurr: state_type] :
      ( v6652(VarCurr)
    <=> v6654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_614,axiom,
    ! [VarCurr: state_type] :
      ( v6654(VarCurr)
    <=> ( v2354(VarCurr)
        & v6657(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_79,axiom,
    ! [VarCurr: state_type] :
      ( v6657(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_405,axiom,
    ~ b0100000101000(12) ).

tff(bitBlastConstant_404,axiom,
    b0100000101000(11) ).

tff(bitBlastConstant_403,axiom,
    ~ b0100000101000(10) ).

tff(bitBlastConstant_402,axiom,
    ~ b0100000101000(9) ).

tff(bitBlastConstant_401,axiom,
    ~ b0100000101000(8) ).

tff(bitBlastConstant_400,axiom,
    ~ b0100000101000(7) ).

tff(bitBlastConstant_399,axiom,
    ~ b0100000101000(6) ).

tff(bitBlastConstant_398,axiom,
    b0100000101000(5) ).

tff(bitBlastConstant_397,axiom,
    ~ b0100000101000(4) ).

tff(bitBlastConstant_396,axiom,
    b0100000101000(3) ).

tff(bitBlastConstant_395,axiom,
    ~ b0100000101000(2) ).

tff(bitBlastConstant_394,axiom,
    ~ b0100000101000(1) ).

tff(bitBlastConstant_393,axiom,
    ~ b0100000101000(0) ).

tff(addAssignment_3132,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6645(VarCurr,B)
      <=> v6647(VarCurr,B) ) ) ).

tff(addAssignment_3131,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6647(VarCurr,B)
      <=> v6650(VarCurr,B) ) ) ).

tff(writeUnaryOperator_461,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,16)
        & ~ $less(B,0) )
     => ( v6650(VarCurr,B)
      <=> ~ v6649(VarCurr,B) ) ) ).

tff(addAssignment_3130,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v6649(VarCurr,B)
      <=> v2363(VarCurr,B) ) ) ).

tff(addAssignment_3129,axiom,
    ! [VarCurr: state_type] :
      ( v6637(VarCurr)
    <=> v6639(VarCurr) ) ).

tff(addAssignment_3128,axiom,
    ! [VarCurr: state_type] :
      ( v6639(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_3127,axiom,
    ! [VarCurr: state_type] :
      ( v6633(VarCurr)
    <=> v6635(VarCurr) ) ).

tff(addAssignment_3126,axiom,
    ! [VarCurr: state_type] :
      ( v6635(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_3125,axiom,
    ! [VarCurr: state_type] :
      ( v6330(VarCurr,7)
    <=> v6332(VarCurr,7) ) ).

tff(addAssignment_3124,axiom,
    ! [VarCurr: state_type] :
      ( v6332(VarCurr,7)
    <=> v6334(VarCurr,19) ) ).

tff(addAssignment_3123,axiom,
    ! [VarCurr: state_type] :
      ( v6334(VarCurr,19)
    <=> v6336(VarCurr,19) ) ).

tff(addAssignment_3122,axiom,
    ! [VarCurr: state_type] :
      ( v6336(VarCurr,19)
    <=> v6338(VarCurr,19) ) ).

tff(addAssignment_3121,axiom,
    ! [VarCurr: state_type] :
      ( v6338(VarCurr,19)
    <=> v6340(VarCurr,7) ) ).

tff(addAssignment_3120,axiom,
    ! [VarCurr: state_type] :
      ( v6340(VarCurr,7)
    <=> v6342(VarCurr,7) ) ).

tff(addAssignment_3119,axiom,
    ! [VarCurr: state_type] :
      ( v6342(VarCurr,7)
    <=> v6344(VarCurr,7) ) ).

tff(addAssignment_3118,axiom,
    ! [VarNext: state_type] :
      ( v6344(VarNext,7)
    <=> v6595(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_75,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6596(VarNext)
       => ! [B: $int] :
            ( ( $less(B,12)
              & ~ $less(B,0) )
           => ( v6595(VarNext,B)
            <=> v6344(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_75,axiom,
    ! [VarNext: state_type] :
      ( v6596(VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v6595(VarNext,B)
          <=> v6606(VarNext,B) ) ) ) ).

tff(addAssignment_3117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v6606(VarNext,B)
          <=> v6604(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_79,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6607(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v6604(VarCurr,B)
          <=> bxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_79,axiom,
    ! [VarCurr: state_type] :
      ( v6607(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,12)
            & ~ $less(B,0) )
         => ( v6604(VarCurr,B)
          <=> v6378(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_613,axiom,
    ! [VarCurr: state_type] :
      ( v6607(VarCurr)
    <=> ( v6608(VarCurr)
        & v6609(VarCurr) ) ) ).

tff(writeUnaryOperator_460,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6609(VarCurr)
    <=> v6362(VarCurr) ) ).

tff(writeUnaryOperator_459,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6608(VarCurr)
    <=> v6346(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_612,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6596(VarNext)
      <=> v6597(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_611,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6597(VarNext)
      <=> ( v6598(VarNext)
          & v6567(VarNext) ) ) ) ).

tff(writeUnaryOperator_458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6598(VarNext)
      <=> v6600(VarNext) ) ) ).

tff(addAssignment_3116,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6600(VarNext)
      <=> v6567(VarCurr) ) ) ).

tff(addAssignment_3115,axiom,
    ! [VarCurr: state_type] :
      ( v6567(VarCurr)
    <=> v6569(VarCurr) ) ).

tff(addAssignment_3114,axiom,
    ! [VarCurr: state_type] :
      ( v6569(VarCurr)
    <=> v6571(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_610,axiom,
    ! [VarCurr: state_type] :
      ( v6571(VarCurr)
    <=> ( v6593(VarCurr)
        | v6583(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_609,axiom,
    ! [VarCurr: state_type] :
      ( v6593(VarCurr)
    <=> ( v6573(VarCurr)
        & v6581(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_12,axiom,
    ( v6581(constB0)
  <=> $true ) ).

tff(addAssignment_3113,axiom,
    ! [VarCurr: state_type] :
      ( v6583(VarCurr)
    <=> v6585(VarCurr) ) ).

tff(addAssignment_3112,axiom,
    ! [VarCurr: state_type] :
      ( v6585(VarCurr)
    <=> v6587(VarCurr) ) ).

tff(addAssignment_3111,axiom,
    ! [VarCurr: state_type] :
      ( v6587(VarCurr)
    <=> v6589(VarCurr) ) ).

tff(addAssignment_3110,axiom,
    ! [VarCurr: state_type] :
      ( v6589(VarCurr)
    <=> v6591(VarCurr) ) ).

tff(addAssignment_3109,axiom,
    ! [VarCurr: state_type] :
      ( v6591(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_3108,axiom,
    ! [VarCurr: state_type] :
      ( v6573(VarCurr)
    <=> v6575(VarCurr) ) ).

tff(addAssignment_3107,axiom,
    ! [VarCurr: state_type] :
      ( v6575(VarCurr)
    <=> v6577(VarCurr) ) ).

tff(addAssignment_3106,axiom,
    ! [VarCurr: state_type] :
      ( v6577(VarCurr)
    <=> v6579(VarCurr) ) ).

tff(addAssignment_3105,axiom,
    ! [VarCurr: state_type] :
      ( v6579(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_3104,axiom,
    ! [VarCurr: state_type] :
      ( v6378(VarCurr,7)
    <=> v6380(VarCurr,7) ) ).

tff(addAssignment_3103,axiom,
    ! [VarCurr: state_type] :
      ( v6380(VarCurr,7)
    <=> v6382(VarCurr,7) ) ).

tff(addAssignment_3102,axiom,
    ! [VarCurr: state_type] :
      ( v6382(VarCurr,7)
    <=> v6550(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_117,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6550(VarCurr,B)
      <=> ( v6551(VarCurr,B)
          | v6562(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6562(VarCurr,B)
      <=> ( v6515(VarCurr,B)
          & v6563(VarCurr,B) ) ) ) ).

tff(addAssignment_3101,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,0)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3100,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,1)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3099,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,2)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3098,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,3)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3097,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,4)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3096,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,5)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3095,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,6)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3094,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,7)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3093,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,8)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3092,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,9)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3091,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,10)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3090,axiom,
    ! [VarCurr: state_type] :
      ( v6563(VarCurr,11)
    <=> v6564(VarCurr) ) ).

tff(addAssignment_3089,axiom,
    ! [VarCurr: state_type] :
      ( v6564(VarCurr)
    <=> v6525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_115,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6551(VarCurr,B)
      <=> ( v6552(VarCurr,B)
          | v6559(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_114,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6559(VarCurr,B)
      <=> ( v6479(VarCurr,B)
          & v6560(VarCurr,B) ) ) ) ).

tff(addAssignment_3088,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,0)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3087,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,1)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3086,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,2)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3085,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,3)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3084,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,4)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3083,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,5)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3082,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,6)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3081,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,7)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3080,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,8)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3079,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,9)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3078,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,10)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3077,axiom,
    ! [VarCurr: state_type] :
      ( v6560(VarCurr,11)
    <=> v6561(VarCurr) ) ).

tff(addAssignment_3076,axiom,
    ! [VarCurr: state_type] :
      ( v6561(VarCurr)
    <=> v6489(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_113,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6552(VarCurr,B)
      <=> ( v6553(VarCurr,B)
          | v6556(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6556(VarCurr,B)
      <=> ( v6432(VarCurr,B)
          & v6557(VarCurr,B) ) ) ) ).

tff(addAssignment_3075,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,0)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3074,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,1)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3073,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,2)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3072,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,3)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3071,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,4)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3070,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,5)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3069,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,6)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3068,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,7)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3067,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,8)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3066,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,9)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3065,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,10)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3064,axiom,
    ! [VarCurr: state_type] :
      ( v6557(VarCurr,11)
    <=> v6558(VarCurr) ) ).

tff(addAssignment_3063,axiom,
    ! [VarCurr: state_type] :
      ( v6558(VarCurr)
    <=> v6442(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_111,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,12)
        & ~ $less(B,0) )
     => ( v6553(VarCurr,B)
      <=> ( v6384(VarCurr,B)
          & v6554(VarCurr,B) ) ) ) ).

tff(addAssignment_3062,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,0)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3061,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,1)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3060,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,2)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3059,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,3)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3058,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,4)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3057,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,5)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3056,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,6)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3055,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,7)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3054,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,8)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3053,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,9)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3052,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,10)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3051,axiom,
    ! [VarCurr: state_type] :
      ( v6554(VarCurr,11)
    <=> v6555(VarCurr) ) ).

tff(addAssignment_3050,axiom,
    ! [VarCurr: state_type] :
      ( v6555(VarCurr)
    <=> v6394(VarCurr) ) ).

tff(addAssignment_3049,axiom,
    ! [VarCurr: state_type] :
      ( v6525(VarCurr)
    <=> v6527(VarCurr) ) ).

tff(addAssignment_3048,axiom,
    ! [VarCurr: state_type] :
      ( v6527(VarCurr)
    <=> v6529(VarCurr) ) ).

tff(addAssignment_3047,axiom,
    ! [VarCurr: state_type] :
      ( v6529(VarCurr)
    <=> v6531(VarCurr) ) ).

tff(addAssignment_3046,axiom,
    ! [VarCurr: state_type] :
      ( v6531(VarCurr)
    <=> v6533(VarCurr) ) ).

tff(addAssignment_3045,axiom,
    ! [VarCurr: state_type] :
      ( v6533(VarCurr)
    <=> v6535(VarCurr) ) ).

tff(addAssignment_3044,axiom,
    ! [VarCurr: state_type] :
      ( v6535(VarCurr)
    <=> v6537(VarCurr) ) ).

tff(addAssignment_3043,axiom,
    ! [VarCurr: state_type] :
      ( v6537(VarCurr)
    <=> v6539(VarCurr) ) ).

tff(writeUnaryOperator_457,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6539(VarCurr)
    <=> v6549(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_608,axiom,
    ! [VarCurr: state_type] :
      ( v6549(VarCurr)
    <=> ( v6541(VarCurr)
        | v6545(VarCurr) ) ) ).

tff(addAssignment_3042,axiom,
    ! [VarCurr: state_type] :
      ( v6545(VarCurr)
    <=> v6547(VarCurr) ) ).

tff(addAssignment_3041,axiom,
    ! [VarCurr: state_type] :
      ( v6547(VarCurr)
    <=> v6462(VarCurr,1) ) ).

tff(addAssignment_3040,axiom,
    ! [VarCurr: state_type] :
      ( v6541(VarCurr)
    <=> v6543(VarCurr) ) ).

tff(addAssignment_3039,axiom,
    ! [VarCurr: state_type] :
      ( v6543(VarCurr)
    <=> v6462(VarCurr,0) ) ).

tff(addAssignment_3038,axiom,
    ! [VarCurr: state_type] :
      ( v6515(VarCurr,7)
    <=> v6517(VarCurr,7) ) ).

tff(addAssignment_3037,axiom,
    ! [VarCurr: state_type] :
      ( v6517(VarCurr,7)
    <=> v6519(VarCurr,7) ) ).

tff(addAssignment_3036,axiom,
    ! [VarCurr: state_type] :
      ( v6519(VarCurr,7)
    <=> v6521(VarCurr,7) ) ).

tff(addAssignment_3035,axiom,
    ! [VarCurr: state_type] :
      ( v6521(VarCurr,7)
    <=> v6523(VarCurr,7) ) ).

tff(addAssignment_3034,axiom,
    ! [VarCurr: state_type] :
      ( v6489(VarCurr)
    <=> v6491(VarCurr) ) ).

tff(addAssignment_3033,axiom,
    ! [VarCurr: state_type] :
      ( v6491(VarCurr)
    <=> v6493(VarCurr) ) ).

tff(addAssignment_3032,axiom,
    ! [VarCurr: state_type] :
      ( v6493(VarCurr)
    <=> v6495(VarCurr) ) ).

tff(addAssignment_3031,axiom,
    ! [VarCurr: state_type] :
      ( v6495(VarCurr)
    <=> v6497(VarCurr) ) ).

tff(addAssignment_3030,axiom,
    ! [VarCurr: state_type] :
      ( v6497(VarCurr)
    <=> v6499(VarCurr) ) ).

tff(addAssignment_3029,axiom,
    ! [VarCurr: state_type] :
      ( v6499(VarCurr)
    <=> v6501(VarCurr) ) ).

tff(addAssignment_3028,axiom,
    ! [VarCurr: state_type] :
      ( v6501(VarCurr)
    <=> v6503(VarCurr) ) ).

tff(writeUnaryOperator_456,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6503(VarCurr)
    <=> v6513(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_607,axiom,
    ! [VarCurr: state_type] :
      ( v6513(VarCurr)
    <=> ( v6505(VarCurr)
        | v6509(VarCurr) ) ) ).

tff(addAssignment_3027,axiom,
    ! [VarCurr: state_type] :
      ( v6509(VarCurr)
    <=> v6511(VarCurr) ) ).

tff(addAssignment_3026,axiom,
    ! [VarCurr: state_type] :
      ( v6511(VarCurr)
    <=> v6462(VarCurr,1) ) ).

tff(addAssignment_3025,axiom,
    ! [VarCurr: state_type] :
      ( v6462(VarCurr,1)
    <=> v6464(VarCurr,1) ) ).

tff(addAssignment_3024,axiom,
    ! [VarCurr: state_type] :
      ( v6464(VarCurr,1)
    <=> v6466(VarCurr,1) ) ).

tff(addAssignment_3023,axiom,
    ! [VarCurr: state_type] :
      ( v6466(VarCurr,1)
    <=> v6471(VarCurr,1) ) ).

tff(addAssignment_3022,axiom,
    ! [VarCurr: state_type] :
      ( v6468(VarCurr,1)
    <=> v6470(VarCurr,1) ) ).

tff(addAssignment_3021,axiom,
    ! [VarCurr: state_type] :
      ( v6470(VarCurr,1)
    <=> v6414(VarCurr,1) ) ).

tff(addAssignment_3020,axiom,
    ! [VarCurr: state_type] :
      ( v6505(VarCurr)
    <=> v6507(VarCurr) ) ).

tff(addAssignment_3019,axiom,
    ! [VarCurr: state_type] :
      ( v6507(VarCurr)
    <=> v6414(VarCurr,0) ) ).

tff(addAssignment_3018,axiom,
    ! [VarCurr: state_type] :
      ( v6479(VarCurr,7)
    <=> v6481(VarCurr,7) ) ).

tff(addAssignment_3017,axiom,
    ! [VarCurr: state_type] :
      ( v6481(VarCurr,7)
    <=> v6483(VarCurr,7) ) ).

tff(addAssignment_3016,axiom,
    ! [VarCurr: state_type] :
      ( v6483(VarCurr,7)
    <=> v6485(VarCurr,7) ) ).

tff(addAssignment_3015,axiom,
    ! [VarCurr: state_type] :
      ( v6485(VarCurr,7)
    <=> v6487(VarCurr,7) ) ).

tff(addAssignment_3014,axiom,
    ! [VarCurr: state_type] :
      ( v6442(VarCurr)
    <=> v6444(VarCurr) ) ).

tff(addAssignment_3013,axiom,
    ! [VarCurr: state_type] :
      ( v6444(VarCurr)
    <=> v6446(VarCurr) ) ).

tff(addAssignment_3012,axiom,
    ! [VarCurr: state_type] :
      ( v6446(VarCurr)
    <=> v6448(VarCurr) ) ).

tff(addAssignment_3011,axiom,
    ! [VarCurr: state_type] :
      ( v6448(VarCurr)
    <=> v6450(VarCurr) ) ).

tff(addAssignment_3010,axiom,
    ! [VarCurr: state_type] :
      ( v6450(VarCurr)
    <=> v6452(VarCurr) ) ).

tff(addAssignment_3009,axiom,
    ! [VarCurr: state_type] :
      ( v6452(VarCurr)
    <=> v6454(VarCurr) ) ).

tff(addAssignment_3008,axiom,
    ! [VarCurr: state_type] :
      ( v6454(VarCurr)
    <=> v6456(VarCurr) ) ).

tff(writeUnaryOperator_455,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6456(VarCurr)
    <=> v6477(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_606,axiom,
    ! [VarCurr: state_type] :
      ( v6477(VarCurr)
    <=> ( v6458(VarCurr)
        | v6473(VarCurr) ) ) ).

tff(addAssignment_3007,axiom,
    ! [VarCurr: state_type] :
      ( v6473(VarCurr)
    <=> v6475(VarCurr) ) ).

tff(addAssignment_3006,axiom,
    ! [VarCurr: state_type] :
      ( v6475(VarCurr)
    <=> v6414(VarCurr,1) ) ).

tff(addAssignment_3005,axiom,
    ! [VarCurr: state_type] :
      ( v6458(VarCurr)
    <=> v6460(VarCurr) ) ).

tff(addAssignment_3004,axiom,
    ! [VarCurr: state_type] :
      ( v6460(VarCurr)
    <=> v6462(VarCurr,0) ) ).

tff(addAssignment_3003,axiom,
    ! [VarCurr: state_type] :
      ( v6462(VarCurr,0)
    <=> v6464(VarCurr,0) ) ).

tff(addAssignment_3002,axiom,
    ! [VarCurr: state_type] :
      ( v6464(VarCurr,0)
    <=> v6466(VarCurr,0) ) ).

tff(addAssignment_3001,axiom,
    ! [VarCurr: state_type] :
      ( v6466(VarCurr,0)
    <=> v6471(VarCurr,0) ) ).

tff(writeUnaryOperator_454,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v6471(VarCurr,B)
      <=> ~ v6468(VarCurr,B) ) ) ).

tff(addAssignment_3000,axiom,
    ! [VarCurr: state_type] :
      ( v6468(VarCurr,0)
    <=> v6470(VarCurr,0) ) ).

tff(addAssignment_2999,axiom,
    ! [VarCurr: state_type] :
      ( v6470(VarCurr,0)
    <=> v6414(VarCurr,0) ) ).

tff(addAssignment_2998,axiom,
    ! [VarCurr: state_type] :
      ( v6432(VarCurr,7)
    <=> v6434(VarCurr,7) ) ).

tff(addAssignment_2997,axiom,
    ! [VarCurr: state_type] :
      ( v6434(VarCurr,7)
    <=> v6436(VarCurr,7) ) ).

tff(addAssignment_2996,axiom,
    ! [VarCurr: state_type] :
      ( v6436(VarCurr,7)
    <=> v6438(VarCurr,7) ) ).

tff(addAssignment_2995,axiom,
    ! [VarCurr: state_type] :
      ( v6438(VarCurr,7)
    <=> v6440(VarCurr,7) ) ).

tff(addAssignment_2994,axiom,
    ! [VarCurr: state_type] :
      ( v6394(VarCurr)
    <=> v6396(VarCurr) ) ).

tff(addAssignment_2993,axiom,
    ! [VarCurr: state_type] :
      ( v6396(VarCurr)
    <=> v6398(VarCurr) ) ).

tff(addAssignment_2992,axiom,
    ! [VarCurr: state_type] :
      ( v6398(VarCurr)
    <=> v6400(VarCurr) ) ).

tff(addAssignment_2991,axiom,
    ! [VarCurr: state_type] :
      ( v6400(VarCurr)
    <=> v6402(VarCurr) ) ).

tff(addAssignment_2990,axiom,
    ! [VarCurr: state_type] :
      ( v6402(VarCurr)
    <=> v6404(VarCurr) ) ).

tff(addAssignment_2989,axiom,
    ! [VarCurr: state_type] :
      ( v6404(VarCurr)
    <=> v6406(VarCurr) ) ).

tff(addAssignment_2988,axiom,
    ! [VarCurr: state_type] :
      ( v6406(VarCurr)
    <=> v6408(VarCurr) ) ).

tff(writeUnaryOperator_453,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6408(VarCurr)
    <=> v6430(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_605,axiom,
    ! [VarCurr: state_type] :
      ( v6430(VarCurr)
    <=> ( v6410(VarCurr)
        | v6426(VarCurr) ) ) ).

tff(addAssignment_2987,axiom,
    ! [VarCurr: state_type] :
      ( v6426(VarCurr)
    <=> v6428(VarCurr) ) ).

tff(addAssignment_2986,axiom,
    ! [VarCurr: state_type] :
      ( v6428(VarCurr)
    <=> v6414(VarCurr,1) ) ).

tff(addAssignment_2985,axiom,
    ! [VarCurr: state_type] :
      ( v6414(VarCurr,1)
    <=> v6416(VarCurr,1) ) ).

tff(addAssignment_2984,axiom,
    ! [VarCurr: state_type] :
      ( v6416(VarCurr,1)
    <=> v6418(VarCurr,1) ) ).

tff(addAssignment_2983,axiom,
    ! [VarCurr: state_type] :
      ( v6418(VarCurr,1)
    <=> v6420(VarCurr,1) ) ).

tff(addAssignment_2982,axiom,
    ! [VarCurr: state_type] :
      ( v6420(VarCurr,1)
    <=> v6422(VarCurr,1) ) ).

tff(addAssignment_2981,axiom,
    ! [VarCurr: state_type] :
      ( v6422(VarCurr,1)
    <=> v6424(VarCurr,1) ) ).

tff(addAssignment_2980,axiom,
    ! [VarCurr: state_type] :
      ( v6410(VarCurr)
    <=> v6412(VarCurr) ) ).

tff(addAssignment_2979,axiom,
    ! [VarCurr: state_type] :
      ( v6412(VarCurr)
    <=> v6414(VarCurr,0) ) ).

tff(addAssignment_2978,axiom,
    ! [VarCurr: state_type] :
      ( v6414(VarCurr,0)
    <=> v6416(VarCurr,0) ) ).

tff(addAssignment_2977,axiom,
    ! [VarCurr: state_type] :
      ( v6416(VarCurr,0)
    <=> v6418(VarCurr,0) ) ).

tff(addAssignment_2976,axiom,
    ! [VarCurr: state_type] :
      ( v6418(VarCurr,0)
    <=> v6420(VarCurr,0) ) ).

tff(addAssignment_2975,axiom,
    ! [VarCurr: state_type] :
      ( v6420(VarCurr,0)
    <=> v6422(VarCurr,0) ) ).

tff(addAssignment_2974,axiom,
    ! [VarCurr: state_type] :
      ( v6422(VarCurr,0)
    <=> v6424(VarCurr,0) ) ).

tff(addAssignment_2973,axiom,
    ! [VarCurr: state_type] :
      ( v6384(VarCurr,7)
    <=> v6386(VarCurr,7) ) ).

tff(addAssignment_2972,axiom,
    ! [VarCurr: state_type] :
      ( v6386(VarCurr,7)
    <=> v6388(VarCurr,7) ) ).

tff(addAssignment_2971,axiom,
    ! [VarCurr: state_type] :
      ( v6388(VarCurr,7)
    <=> v6390(VarCurr,7) ) ).

tff(addAssignment_2970,axiom,
    ! [VarCurr: state_type] :
      ( v6390(VarCurr,7)
    <=> v6392(VarCurr,7) ) ).

tff(addAssignment_2969,axiom,
    ! [VarCurr: state_type] :
      ( v6362(VarCurr)
    <=> v6364(VarCurr) ) ).

tff(addAssignment_2968,axiom,
    ! [VarCurr: state_type] :
      ( v6364(VarCurr)
    <=> v6366(VarCurr) ) ).

tff(addAssignment_2967,axiom,
    ! [VarCurr: state_type] :
      ( v6366(VarCurr)
    <=> v6368(VarCurr) ) ).

tff(addAssignment_2966,axiom,
    ! [VarCurr: state_type] :
      ( v6368(VarCurr)
    <=> v6370(VarCurr) ) ).

tff(addAssignment_2965,axiom,
    ! [VarCurr: state_type] :
      ( v6370(VarCurr)
    <=> v6372(VarCurr) ) ).

tff(addAssignment_2964,axiom,
    ! [VarCurr: state_type] :
      ( v6372(VarCurr)
    <=> v6374(VarCurr) ) ).

tff(addAssignment_2963,axiom,
    ! [VarCurr: state_type] :
      ( v6374(VarCurr)
    <=> v6376(VarCurr) ) ).

tff(addAssignment_2962,axiom,
    ! [VarCurr: state_type] :
      ( v6376(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_2961,axiom,
    ! [VarCurr: state_type] :
      ( v6346(VarCurr)
    <=> v6348(VarCurr) ) ).

tff(addAssignment_2960,axiom,
    ! [VarCurr: state_type] :
      ( v6348(VarCurr)
    <=> v6350(VarCurr) ) ).

tff(addAssignment_2959,axiom,
    ! [VarCurr: state_type] :
      ( v6350(VarCurr)
    <=> v6352(VarCurr) ) ).

tff(addAssignment_2958,axiom,
    ! [VarCurr: state_type] :
      ( v6352(VarCurr)
    <=> v6354(VarCurr) ) ).

tff(addAssignment_2957,axiom,
    ! [VarCurr: state_type] :
      ( v6354(VarCurr)
    <=> v6356(VarCurr) ) ).

tff(addAssignment_2956,axiom,
    ! [VarCurr: state_type] :
      ( v6356(VarCurr)
    <=> v6358(VarCurr) ) ).

tff(addAssignment_2955,axiom,
    ! [VarCurr: state_type] :
      ( v6358(VarCurr)
    <=> v6360(VarCurr) ) ).

tff(addAssignment_2954,axiom,
    ! [VarCurr: state_type] :
      ( v6360(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_2953,axiom,
    ! [VarCurr: state_type] :
      ( v6296(VarCurr,7)
    <=> v6298(VarCurr,7) ) ).

tff(addAssignment_2952,axiom,
    ! [VarCurr: state_type] :
      ( v6298(VarCurr,7)
    <=> v6315(VarCurr,7) ) ).

tff(addAssignment_2951,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,0)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2950,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,1)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2949,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,2)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2948,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,3)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2947,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,4)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2946,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,5)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2945,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,6)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2944,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,7)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2943,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,8)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2942,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,9)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2941,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,10)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2940,axiom,
    ! [VarCurr: state_type] :
      ( v6315(VarCurr,11)
    <=> v6316(VarCurr) ) ).

tff(addAssignment_2939,axiom,
    ! [VarCurr: state_type] :
      ( v6316(VarCurr)
    <=> v6300(VarCurr) ) ).

tff(addAssignment_2938,axiom,
    ! [VarCurr: state_type] :
      ( v6300(VarCurr)
    <=> v6302(VarCurr,0) ) ).

tff(addAssignment_2937,axiom,
    ! [VarCurr: state_type] :
      ( v6302(VarCurr,0)
    <=> v6304(VarCurr,0) ) ).

tff(addAssignment_2936,axiom,
    ! [VarCurr: state_type] :
      ( v6304(VarCurr,0)
    <=> v6314(VarCurr,0) ) ).

tff(writeUnaryOperator_452,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v6314(VarCurr,B)
      <=> ~ v6306(VarCurr,B) ) ) ).

tff(addAssignment_2935,axiom,
    ! [VarCurr: state_type] :
      ( v6306(VarCurr,0)
    <=> v6308(VarCurr,0) ) ).

tff(addAssignment_2934,axiom,
    ! [VarCurr: state_type] :
      ( v6308(VarCurr,0)
    <=> v6311(VarCurr,0) ) ).

tff(addAssignment_2933,axiom,
    ! [VarCurr: state_type] :
      ( v6311(VarCurr,0)
    <=> v6310(VarCurr) ) ).

tff(addAssignment_2932,axiom,
    ! [VarCurr: state_type] :
      ( v6311(VarCurr,1)
    <=> v6313(VarCurr) ) ).

tff(addAssignment_2931,axiom,
    ! [VarCurr: state_type] :
      ( v6311(VarCurr,2)
    <=> v6312(VarCurr) ) ).

tff(addAssignment_2930,axiom,
    ! [VarCurr: state_type] :
      ( v6310(VarCurr)
    <=> v4195(VarCurr) ) ).

tff(addAssignment_2929,axiom,
    ! [VarCurr: state_type] :
      ( v6272(VarCurr)
    <=> v6274(VarCurr) ) ).

tff(addAssignment_2928,axiom,
    ! [VarCurr: state_type] :
      ( v6274(VarCurr)
    <=> v6276(VarCurr) ) ).

tff(addAssignment_2927,axiom,
    ! [VarCurr: state_type] :
      ( v6276(VarCurr)
    <=> v6278(VarCurr) ) ).

tff(addAssignment_2926,axiom,
    ! [VarCurr: state_type] :
      ( v6278(VarCurr)
    <=> v6280(VarCurr) ) ).

tff(addAssignment_2925,axiom,
    ! [VarCurr: state_type] :
      ( v6280(VarCurr)
    <=> v6282(VarCurr) ) ).

tff(addAssignment_2924,axiom,
    ! [VarCurr: state_type] :
      ( v6282(VarCurr)
    <=> v6284(VarCurr) ) ).

tff(addAssignment_2923,axiom,
    ! [VarCurr: state_type] :
      ( v6284(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_2922,axiom,
    ! [VarCurr: state_type] :
      ( v6258(VarCurr)
    <=> v6260(VarCurr) ) ).

tff(addAssignment_2921,axiom,
    ! [VarCurr: state_type] :
      ( v6260(VarCurr)
    <=> v6262(VarCurr) ) ).

tff(addAssignment_2920,axiom,
    ! [VarCurr: state_type] :
      ( v6262(VarCurr)
    <=> v6264(VarCurr) ) ).

tff(addAssignment_2919,axiom,
    ! [VarCurr: state_type] :
      ( v6264(VarCurr)
    <=> v6266(VarCurr) ) ).

tff(addAssignment_2918,axiom,
    ! [VarCurr: state_type] :
      ( v6266(VarCurr)
    <=> v6268(VarCurr) ) ).

tff(addAssignment_2917,axiom,
    ! [VarCurr: state_type] :
      ( v6268(VarCurr)
    <=> v6270(VarCurr) ) ).

tff(addAssignment_2916,axiom,
    ! [VarCurr: state_type] :
      ( v6270(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_2915,axiom,
    ! [VarCurr: state_type] :
      ( v6224(VarCurr,7)
    <=> v6226(VarCurr,7) ) ).

tff(addAssignment_2914,axiom,
    ! [VarCurr: state_type] :
      ( v6226(VarCurr,7)
    <=> $false ) ).

tff(bitBlastConstant_392,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(63) ).

tff(bitBlastConstant_391,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(62) ).

tff(bitBlastConstant_390,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(61) ).

tff(bitBlastConstant_389,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(60) ).

tff(bitBlastConstant_388,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(59) ).

tff(bitBlastConstant_387,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(58) ).

tff(bitBlastConstant_386,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(57) ).

tff(bitBlastConstant_385,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(56) ).

tff(bitBlastConstant_384,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(55) ).

tff(bitBlastConstant_383,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(54) ).

tff(bitBlastConstant_382,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(53) ).

tff(bitBlastConstant_381,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(52) ).

tff(bitBlastConstant_380,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(51) ).

tff(bitBlastConstant_379,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(50) ).

tff(bitBlastConstant_378,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(49) ).

tff(bitBlastConstant_377,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(48) ).

tff(bitBlastConstant_376,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(47) ).

tff(bitBlastConstant_375,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(46) ).

tff(bitBlastConstant_374,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(45) ).

tff(bitBlastConstant_373,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(44) ).

tff(bitBlastConstant_372,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(43) ).

tff(bitBlastConstant_371,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(42) ).

tff(bitBlastConstant_370,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(41) ).

tff(bitBlastConstant_369,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(40) ).

tff(bitBlastConstant_368,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(39) ).

tff(bitBlastConstant_367,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(38) ).

tff(bitBlastConstant_366,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(37) ).

tff(bitBlastConstant_365,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(36) ).

tff(bitBlastConstant_364,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(35) ).

tff(bitBlastConstant_363,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(34) ).

tff(bitBlastConstant_362,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(33) ).

tff(bitBlastConstant_361,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(32) ).

tff(bitBlastConstant_360,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(31) ).

tff(bitBlastConstant_359,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(30) ).

tff(bitBlastConstant_358,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(29) ).

tff(bitBlastConstant_357,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(28) ).

tff(bitBlastConstant_356,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(27) ).

tff(bitBlastConstant_355,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(26) ).

tff(bitBlastConstant_354,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(25) ).

tff(bitBlastConstant_353,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(24) ).

tff(bitBlastConstant_352,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(23) ).

tff(bitBlastConstant_351,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(22) ).

tff(bitBlastConstant_350,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(21) ).

tff(bitBlastConstant_349,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(20) ).

tff(bitBlastConstant_348,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(19) ).

tff(bitBlastConstant_347,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(18) ).

tff(bitBlastConstant_346,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(17) ).

tff(bitBlastConstant_345,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(16) ).

tff(bitBlastConstant_344,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(15) ).

tff(bitBlastConstant_343,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(14) ).

tff(bitBlastConstant_342,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(13) ).

tff(bitBlastConstant_341,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(12) ).

tff(bitBlastConstant_340,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(11) ).

tff(bitBlastConstant_339,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(10) ).

tff(bitBlastConstant_338,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(9) ).

tff(bitBlastConstant_337,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(8) ).

tff(bitBlastConstant_336,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(7) ).

tff(bitBlastConstant_335,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(6) ).

tff(bitBlastConstant_334,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(5) ).

tff(bitBlastConstant_333,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(4) ).

tff(bitBlastConstant_332,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(3) ).

tff(bitBlastConstant_331,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(2) ).

tff(bitBlastConstant_330,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(1) ).

tff(bitBlastConstant_329,axiom,
    ~ b0000000000000000000000000000000000000000000000000000000000000000(0) ).

tff(addAssignment_2913,axiom,
    ! [VarCurr: state_type] :
      ( v6108(VarCurr,0)
    <=> v6216(VarCurr) ) ).

tff(addAssignment_2912,axiom,
    ! [VarCurr: state_type] :
      ( v6108(VarCurr,1)
    <=> v6208(VarCurr) ) ).

tff(addAssignment_2911,axiom,
    ! [VarCurr: state_type] :
      ( v6108(VarCurr,2)
    <=> v6120(VarCurr) ) ).

tff(addAssignment_2910,axiom,
    ! [VarCurr: state_type] :
      ( v6108(VarCurr,3)
    <=> v6110(VarCurr) ) ).

tff(addAssignment_2909,axiom,
    ! [VarCurr: state_type] :
      ( v6216(VarCurr)
    <=> v6218(VarCurr) ) ).

tff(addAssignment_2908,axiom,
    ! [VarCurr: state_type] :
      ( v6218(VarCurr)
    <=> v6220(VarCurr) ) ).

tff(addAssignment_2907,axiom,
    ! [VarCurr: state_type] :
      ( v6220(VarCurr)
    <=> v6126(VarCurr) ) ).

tff(addAssignment_2906,axiom,
    ! [VarCurr: state_type] :
      ( v6208(VarCurr)
    <=> v6210(VarCurr) ) ).

tff(addAssignment_2905,axiom,
    ! [VarCurr: state_type] :
      ( v6210(VarCurr)
    <=> v6212(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_604,axiom,
    ! [VarCurr: state_type] :
      ( v6212(VarCurr)
    <=> ( v6214(VarCurr)
        & v6188(VarCurr) ) ) ).

tff(writeUnaryOperator_451,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6214(VarCurr)
    <=> v6126(VarCurr) ) ).

tff(addAssignment_2904,axiom,
    ! [VarCurr: state_type] :
      ( v6120(VarCurr)
    <=> v6122(VarCurr) ) ).

tff(addAssignment_2903,axiom,
    ! [VarCurr: state_type] :
      ( v6122(VarCurr)
    <=> v6124(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_603,axiom,
    ! [VarCurr: state_type] :
      ( v6124(VarCurr)
    <=> ( v6204(VarCurr)
        & v6194(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_602,axiom,
    ! [VarCurr: state_type] :
      ( v6204(VarCurr)
    <=> ( v6205(VarCurr)
        & v6206(VarCurr) ) ) ).

tff(writeUnaryOperator_450,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6206(VarCurr)
    <=> v6188(VarCurr) ) ).

tff(writeUnaryOperator_449,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6205(VarCurr)
    <=> v6126(VarCurr) ) ).

tff(addAssignment_2902,axiom,
    ! [VarCurr: state_type] :
      ( v6194(VarCurr)
    <=> v6196(VarCurr) ) ).

tff(addAssignment_2901,axiom,
    ! [VarCurr: state_type] :
      ( v6196(VarCurr)
    <=> v6198(VarCurr) ) ).

tff(addAssignment_2900,axiom,
    ! [VarCurr: state_type] :
      ( v6198(VarCurr)
    <=> v6200(VarCurr) ) ).

tff(addAssignment_2899,axiom,
    ! [VarCurr: state_type] :
      ( v6200(VarCurr)
    <=> v6202(VarCurr) ) ).

tff(addAssignment_2898,axiom,
    ! [VarCurr: state_type] :
      ( v6188(VarCurr)
    <=> v6190(VarCurr) ) ).

tff(addAssignment_2897,axiom,
    ! [VarCurr: state_type] :
      ( v6190(VarCurr)
    <=> v6192(VarCurr) ) ).

tff(addAssignment_2896,axiom,
    ! [VarCurr: state_type] :
      ( v6192(VarCurr)
    <=> v1049(VarCurr) ) ).

tff(addAssignment_2895,axiom,
    ! [VarCurr: state_type] :
      ( v6126(VarCurr)
    <=> v6128(VarCurr) ) ).

tff(addAssignment_2894,axiom,
    ! [VarCurr: state_type] :
      ( v6128(VarCurr)
    <=> v6130(VarCurr) ) ).

tff(addAssignment_2893,axiom,
    ! [VarCurr: state_type] :
      ( v6130(VarCurr)
    <=> v6132(VarCurr) ) ).

tff(addAssignment_2892,axiom,
    ! [VarCurr: state_type] :
      ( v6132(VarCurr)
    <=> v6134(VarCurr) ) ).

tff(writeUnaryOperator_448,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6134(VarCurr)
    <=> v6186(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_601,axiom,
    ! [VarCurr: state_type] :
      ( v6186(VarCurr)
    <=> ( v2040(VarCurr)
        | v6136(VarCurr) ) ) ).

tff(addAssignment_2891,axiom,
    ! [VarCurr: state_type] :
      ( v6136(VarCurr)
    <=> v6138(VarCurr,33) ) ).

tff(addAssignment_2890,axiom,
    ! [VarCurr: state_type] :
      ( v6138(VarCurr,33)
    <=> v6140(VarCurr,33) ) ).

tff(addAssignment_2889,axiom,
    ! [VarNext: state_type] :
      ( v6140(VarNext,33)
    <=> v6168(VarNext,33) ) ).

tff(addCaseBooleanConditionEqualRanges1_74,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6169(VarNext)
       => ! [B: $int] :
            ( ( $less(B,34)
              & ~ $less(B,0) )
           => ( v6168(VarNext,B)
            <=> v6140(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_74,axiom,
    ! [VarNext: state_type] :
      ( v6169(VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v6168(VarNext,B)
          <=> v6179(VarNext,B) ) ) ) ).

tff(addAssignment_2888,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v6179(VarNext,B)
          <=> v6177(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_78,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6180(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v6177(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_78,axiom,
    ! [VarCurr: state_type] :
      ( v6180(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,34)
            & ~ $less(B,0) )
         => ( v6177(VarCurr,B)
          <=> v6150(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_600,axiom,
    ! [VarCurr: state_type] :
      ( v6180(VarCurr)
    <=> ( v6181(VarCurr)
        & v6182(VarCurr) ) ) ).

tff(writeUnaryOperator_447,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6182(VarCurr)
    <=> v6146(VarCurr) ) ).

tff(writeUnaryOperator_446,axiom,
    ! [VarCurr: state_type] :
      ( ~ v6181(VarCurr)
    <=> v6142(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6169(VarNext)
      <=> v6170(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6170(VarNext)
      <=> ( v6171(VarNext)
          & v6164(VarNext) ) ) ) ).

tff(writeUnaryOperator_445,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v6171(VarNext)
      <=> v6173(VarNext) ) ) ).

tff(addAssignment_2887,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v6173(VarNext)
      <=> v6164(VarCurr) ) ) ).

tff(addAssignment_2886,axiom,
    ! [VarCurr: state_type] :
      ( v6164(VarCurr)
    <=> v6166(VarCurr) ) ).

tff(addAssignment_2885,axiom,
    ! [VarCurr: state_type] :
      ( v6166(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_2884,axiom,
    ! [VarCurr: state_type] :
      ( v6150(VarCurr,33)
    <=> v6152(VarCurr,33) ) ).

tff(addAssignment_2883,axiom,
    ! [VarCurr: state_type] :
      ( v6152(VarCurr,33)
    <=> v6154(VarCurr,33) ) ).

tff(addAssignment_2882,axiom,
    ! [VarCurr: state_type] :
      ( v6154(VarCurr,33)
    <=> v6159(VarCurr,33) ) ).

tff(addAssignment_2881,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,32)
        & ~ $less(B,0) )
     => ( v6159(VarCurr,B)
      <=> v6161(VarCurr,B) ) ) ).

tff(addAssignment_2880,axiom,
    ! [VarCurr: state_type] :
      ( v6159(VarCurr,32)
    <=> v6160(VarCurr) ) ).

tff(addAssignment_2879,axiom,
    ! [VarCurr: state_type] :
      ( v6159(VarCurr,33)
    <=> v6156(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_597,axiom,
    ! [VarCurr: state_type] :
      ( v6156(VarCurr)
    <=> ( v2044(VarCurr)
        & v6158(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_78,axiom,
    ! [VarCurr: state_type] :
      ( v6158(VarCurr)
    <=> ( ( v2200(VarCurr,11)
        <=> $true )
        & ( v2200(VarCurr,10)
        <=> $false )
        & ( v2200(VarCurr,9)
        <=> $false )
        & ( v2200(VarCurr,8)
        <=> $false ) ) ) ).

tff(addAssignment_2878,axiom,
    ! [VarCurr: state_type] :
      ( v6146(VarCurr)
    <=> v6148(VarCurr) ) ).

tff(addAssignment_2877,axiom,
    ! [VarCurr: state_type] :
      ( v6148(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_2876,axiom,
    ! [VarCurr: state_type] :
      ( v6142(VarCurr)
    <=> v6144(VarCurr) ) ).

tff(addAssignment_2875,axiom,
    ! [VarCurr: state_type] :
      ( v6144(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_2874,axiom,
    ! [VarCurr: state_type] :
      ( v6110(VarCurr)
    <=> v6112(VarCurr) ) ).

tff(addAssignment_2873,axiom,
    ! [VarCurr: state_type] :
      ( v6112(VarCurr)
    <=> v6114(VarCurr) ) ).

tff(addAssignment_2872,axiom,
    ! [VarCurr: state_type] :
      ( v6114(VarCurr)
    <=> v6116(VarCurr) ) ).

tff(addAssignment_2871,axiom,
    ! [VarCurr: state_type] :
      ( v6116(VarCurr)
    <=> v6118(VarCurr) ) ).

tff(addAssignment_2870,axiom,
    ! [VarCurr: state_type] :
      ( v6075(VarCurr,7)
    <=> v6077(VarCurr,7) ) ).

tff(addAssignment_2869,axiom,
    ! [VarCurr: state_type] :
      ( v6077(VarCurr,7)
    <=> v6091(VarCurr,7) ) ).

tff(addAssignment_2868,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,0)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2867,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,1)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2866,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,2)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2865,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,3)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2864,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,4)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2863,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,5)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2862,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,6)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2861,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,7)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2860,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,8)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2859,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,9)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2858,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,10)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2857,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,11)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2856,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,12)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2855,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,13)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2854,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,14)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2853,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,15)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2852,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,16)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2851,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,17)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2850,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,18)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2849,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,19)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2848,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,20)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2847,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,21)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2846,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,22)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2845,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,23)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2844,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,24)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2843,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,25)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2842,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,26)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2841,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,27)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2840,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,28)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2839,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,29)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2838,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,30)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2837,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,31)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2836,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,32)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2835,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,33)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2834,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,34)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2833,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,35)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2832,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,36)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2831,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,37)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2830,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,38)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2829,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,39)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2828,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,40)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2827,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,41)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2826,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,42)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2825,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,43)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2824,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,44)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2823,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,45)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2822,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,46)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2821,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,47)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2820,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,48)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2819,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,49)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2818,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,50)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2817,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,51)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2816,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,52)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2815,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,53)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2814,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,54)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2813,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,55)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2812,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,56)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2811,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,57)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2810,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,58)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2809,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,59)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2808,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,60)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2807,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,61)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2806,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,62)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2805,axiom,
    ! [VarCurr: state_type] :
      ( v6091(VarCurr,63)
    <=> v6092(VarCurr) ) ).

tff(addAssignment_2804,axiom,
    ! [VarCurr: state_type] :
      ( v6092(VarCurr)
    <=> v6079(VarCurr) ) ).

tff(addAssignment_2803,axiom,
    ! [VarCurr: state_type] :
      ( v6079(VarCurr)
    <=> v6081(VarCurr,1) ) ).

tff(addAssignment_2802,axiom,
    ! [VarCurr: state_type] :
      ( v6081(VarCurr,1)
    <=> v6083(VarCurr,1) ) ).

tff(addAssignment_2801,axiom,
    ! [VarCurr: state_type] :
      ( v6083(VarCurr,1)
    <=> v6085(VarCurr,1) ) ).

tff(addAssignment_2800,axiom,
    ! [VarCurr: state_type] :
      ( v6085(VarCurr,1)
    <=> v6087(VarCurr,1) ) ).

tff(addAssignment_2799,axiom,
    ! [VarCurr: state_type] :
      ( v6087(VarCurr,1)
    <=> v6090(VarCurr,1) ) ).

tff(addAssignment_2798,axiom,
    ! [VarCurr: state_type] :
      ( v6090(VarCurr,0)
    <=> $false ) ).

tff(addAssignment_2797,axiom,
    ! [VarCurr: state_type] :
      ( v6090(VarCurr,1)
    <=> v6089(VarCurr) ) ).

tff(addAssignment_2796,axiom,
    ! [VarCurr: state_type] :
      ( v6089(VarCurr)
    <=> v2038(VarCurr) ) ).

tff(addAssignment_2795,axiom,
    ! [VarCurr: state_type] :
      ( v6045(VarCurr)
    <=> v6047(VarCurr) ) ).

tff(addAssignment_2794,axiom,
    ! [VarCurr: state_type] :
      ( v6047(VarCurr)
    <=> v6049(VarCurr) ) ).

tff(addAssignment_2793,axiom,
    ! [VarCurr: state_type] :
      ( v6049(VarCurr)
    <=> v6051(VarCurr) ) ).

tff(addAssignment_2792,axiom,
    ! [VarCurr: state_type] :
      ( v6051(VarCurr)
    <=> v6053(VarCurr) ) ).

tff(addAssignment_2791,axiom,
    ! [VarCurr: state_type] :
      ( v6053(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_2790,axiom,
    ! [VarCurr: state_type] :
      ( v6035(VarCurr)
    <=> v6037(VarCurr) ) ).

tff(addAssignment_2789,axiom,
    ! [VarCurr: state_type] :
      ( v6037(VarCurr)
    <=> v6039(VarCurr) ) ).

tff(addAssignment_2788,axiom,
    ! [VarCurr: state_type] :
      ( v6039(VarCurr)
    <=> v6041(VarCurr) ) ).

tff(addAssignment_2787,axiom,
    ! [VarCurr: state_type] :
      ( v6041(VarCurr)
    <=> v6043(VarCurr) ) ).

tff(addAssignment_2786,axiom,
    ! [VarCurr: state_type] :
      ( v6043(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(addAssignment_2785,axiom,
    ! [VarCurr: state_type] :
      ( v5827(VarCurr)
    <=> v5829(VarCurr) ) ).

tff(addAssignment_2784,axiom,
    ! [VarCurr: state_type] :
      ( v5829(VarCurr)
    <=> v5831(VarCurr) ) ).

tff(addAssignment_2783,axiom,
    ! [VarCurr: state_type] :
      ( v5831(VarCurr)
    <=> v5833(VarCurr) ) ).

tff(addAssignment_2782,axiom,
    ! [VarCurr: state_type] :
      ( v5833(VarCurr)
    <=> v5835(VarCurr) ) ).

tff(addAssignment_2781,axiom,
    ! [VarCurr: state_type] :
      ( v5835(VarCurr)
    <=> v5837(VarCurr) ) ).

tff(addAssignment_2780,axiom,
    ! [VarCurr: state_type] :
      ( v5837(VarCurr)
    <=> v5839(VarCurr) ) ).

tff(addAssignment_2779,axiom,
    ! [VarCurr: state_type] :
      ( v5839(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_2778,axiom,
    ! [VarCurr: state_type] :
      ( v5813(VarCurr)
    <=> v5815(VarCurr) ) ).

tff(addAssignment_2777,axiom,
    ! [VarCurr: state_type] :
      ( v5815(VarCurr)
    <=> v5817(VarCurr) ) ).

tff(addAssignment_2776,axiom,
    ! [VarCurr: state_type] :
      ( v5817(VarCurr)
    <=> v5819(VarCurr) ) ).

tff(addAssignment_2775,axiom,
    ! [VarCurr: state_type] :
      ( v5819(VarCurr)
    <=> v5821(VarCurr) ) ).

tff(addAssignment_2774,axiom,
    ! [VarCurr: state_type] :
      ( v5821(VarCurr)
    <=> v5823(VarCurr) ) ).

tff(addAssignment_2773,axiom,
    ! [VarCurr: state_type] :
      ( v5823(VarCurr)
    <=> v5825(VarCurr) ) ).

tff(addAssignment_2772,axiom,
    ! [VarCurr: state_type] :
      ( v5825(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_2771,axiom,
    ! [VarCurr: state_type] :
      ( v5753(VarCurr)
    <=> v5755(VarCurr,4) ) ).

tff(addAssignment_2770,axiom,
    ! [VarCurr: state_type] :
      ( v5755(VarCurr,4)
    <=> v5757(VarCurr,4) ) ).

tff(addAssignment_2769,axiom,
    ! [VarNext: state_type] :
      ( v5757(VarNext,4)
    <=> v5783(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_73,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5784(VarNext)
       => ! [B: $int] :
            ( ( $less(B,5)
              & ~ $less(B,0) )
           => ( v5783(VarNext,B)
            <=> v5757(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_73,axiom,
    ! [VarNext: state_type] :
      ( v5784(VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v5783(VarNext,B)
          <=> v5794(VarNext,B) ) ) ) ).

tff(addAssignment_2768,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v5794(VarNext,B)
          <=> v5792(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_77,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v5792(VarCurr,B)
          <=> bxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_77,axiom,
    ! [VarCurr: state_type] :
      ( v5795(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,5)
            & ~ $less(B,0) )
         => ( v5792(VarCurr,B)
          <=> v5767(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_596,axiom,
    ! [VarCurr: state_type] :
      ( v5795(VarCurr)
    <=> ( v5796(VarCurr)
        & v5797(VarCurr) ) ) ).

tff(writeUnaryOperator_444,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5797(VarCurr)
    <=> v5763(VarCurr) ) ).

tff(writeUnaryOperator_443,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5796(VarCurr)
    <=> v5759(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_595,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5784(VarNext)
      <=> v5785(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_594,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5785(VarNext)
      <=> ( v5786(VarNext)
          & v5779(VarNext) ) ) ) ).

tff(writeUnaryOperator_442,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5786(VarNext)
      <=> v5788(VarNext) ) ) ).

tff(addAssignment_2767,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5788(VarNext)
      <=> v5779(VarCurr) ) ) ).

tff(addAssignment_2766,axiom,
    ! [VarCurr: state_type] :
      ( v5779(VarCurr)
    <=> v5781(VarCurr) ) ).

tff(addAssignment_2765,axiom,
    ! [VarCurr: state_type] :
      ( v5781(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_2764,axiom,
    ! [VarCurr: state_type] :
      ( v5767(VarCurr,4)
    <=> v5769(VarCurr,4) ) ).

tff(addAssignment_2763,axiom,
    ! [VarCurr: state_type] :
      ( v5769(VarCurr,4)
    <=> v5771(VarCurr,4) ) ).

tff(addAssignment_2762,axiom,
    ! [VarCurr: state_type] :
      ( v5771(VarCurr,4)
    <=> v5772(VarCurr,4) ) ).

tff(addAssignment_2761,axiom,
    ! [VarCurr: state_type] :
      ( v5772(VarCurr,0)
    <=> v5776(VarCurr) ) ).

tff(addAssignment_2760,axiom,
    ! [VarCurr: state_type] :
      ( v5772(VarCurr,1)
    <=> v5775(VarCurr) ) ).

tff(addAssignment_2759,axiom,
    ! [VarCurr: state_type] :
      ( v5772(VarCurr,2)
    <=> v5774(VarCurr) ) ).

tff(addAssignment_2758,axiom,
    ! [VarCurr: state_type] :
      ( v5772(VarCurr,3)
    <=> v5773(VarCurr) ) ).

tff(addAssignment_2757,axiom,
    ! [VarCurr: state_type] :
      ( v5772(VarCurr,4)
    <=> v1001(VarCurr) ) ).

tff(addAssignment_2756,axiom,
    ! [VarCurr: state_type] :
      ( v5763(VarCurr)
    <=> v5765(VarCurr) ) ).

tff(addAssignment_2755,axiom,
    ! [VarCurr: state_type] :
      ( v5765(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_2754,axiom,
    ! [VarCurr: state_type] :
      ( v5759(VarCurr)
    <=> v5761(VarCurr) ) ).

tff(addAssignment_2753,axiom,
    ! [VarCurr: state_type] :
      ( v5761(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_2752,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5709(VarCurr,B)
      <=> v5711(VarCurr,B) ) ) ).

tff(addAssignment_2751,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5711(VarCurr,B)
      <=> v5712(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_76,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5713(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v5712(VarCurr,B)
          <=> v5716(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_76,axiom,
    ! [VarCurr: state_type] :
      ( v5713(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v5712(VarCurr,B)
          <=> v5714(VarCurr,B) ) ) ) ).

tff(addAssignment_2750,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5716(VarCurr,B)
      <=> v5717(VarCurr,B) ) ) ).

tff(addAssignment_2749,axiom,
    ! [VarCurr: state_type] :
      ( v5716(VarCurr,5)
    <=> v5691(VarCurr,5) ) ).

tff(addAssignment_2748,axiom,
    ! [VarCurr: state_type] :
      ( v5717(VarCurr,0)
    <=> v5739(VarCurr) ) ).

tff(addAssignment_2747,axiom,
    ! [VarCurr: state_type] :
      ( v5717(VarCurr,1)
    <=> v5737(VarCurr) ) ).

tff(addAssignment_2746,axiom,
    ! [VarCurr: state_type] :
      ( v5717(VarCurr,2)
    <=> v5732(VarCurr) ) ).

tff(addAssignment_2745,axiom,
    ! [VarCurr: state_type] :
      ( v5717(VarCurr,3)
    <=> v5727(VarCurr) ) ).

tff(addAssignment_2744,axiom,
    ! [VarCurr: state_type] :
      ( v5717(VarCurr,4)
    <=> v5719(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_593,axiom,
    ! [VarCurr: state_type] :
      ( v5737(VarCurr)
    <=> ( v5738(VarCurr)
        & v5741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_130,axiom,
    ! [VarCurr: state_type] :
      ( v5741(VarCurr)
    <=> ( v5691(VarCurr,0)
        | v5691(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_592,axiom,
    ! [VarCurr: state_type] :
      ( v5738(VarCurr)
    <=> ( v5739(VarCurr)
        | v5740(VarCurr) ) ) ).

tff(writeUnaryOperator_441,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5740(VarCurr)
    <=> v5691(VarCurr,1) ) ).

tff(writeUnaryOperator_440,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5739(VarCurr)
    <=> v5691(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_591,axiom,
    ! [VarCurr: state_type] :
      ( v5732(VarCurr)
    <=> ( v5733(VarCurr)
        & v5736(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_129,axiom,
    ! [VarCurr: state_type] :
      ( v5736(VarCurr)
    <=> ( v5724(VarCurr)
        | v5691(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_590,axiom,
    ! [VarCurr: state_type] :
      ( v5733(VarCurr)
    <=> ( v5734(VarCurr)
        | v5735(VarCurr) ) ) ).

tff(writeUnaryOperator_439,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5735(VarCurr)
    <=> v5691(VarCurr,2) ) ).

tff(writeUnaryOperator_438,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5734(VarCurr)
    <=> v5724(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_589,axiom,
    ! [VarCurr: state_type] :
      ( v5727(VarCurr)
    <=> ( v5728(VarCurr)
        & v5731(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_128,axiom,
    ! [VarCurr: state_type] :
      ( v5731(VarCurr)
    <=> ( v5723(VarCurr)
        | v5691(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_588,axiom,
    ! [VarCurr: state_type] :
      ( v5728(VarCurr)
    <=> ( v5729(VarCurr)
        | v5730(VarCurr) ) ) ).

tff(writeUnaryOperator_437,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5730(VarCurr)
    <=> v5691(VarCurr,3) ) ).

tff(writeUnaryOperator_436,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5729(VarCurr)
    <=> v5723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_587,axiom,
    ! [VarCurr: state_type] :
      ( v5719(VarCurr)
    <=> ( v5720(VarCurr)
        & v5726(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_127,axiom,
    ! [VarCurr: state_type] :
      ( v5726(VarCurr)
    <=> ( v5722(VarCurr)
        | v5691(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_586,axiom,
    ! [VarCurr: state_type] :
      ( v5720(VarCurr)
    <=> ( v5721(VarCurr)
        | v5725(VarCurr) ) ) ).

tff(writeUnaryOperator_435,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5725(VarCurr)
    <=> v5691(VarCurr,4) ) ).

tff(writeUnaryOperator_434,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5721(VarCurr)
    <=> v5722(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_126,axiom,
    ! [VarCurr: state_type] :
      ( v5722(VarCurr)
    <=> ( v5723(VarCurr)
        & v5691(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_125,axiom,
    ! [VarCurr: state_type] :
      ( v5723(VarCurr)
    <=> ( v5724(VarCurr)
        & v5691(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_124,axiom,
    ! [VarCurr: state_type] :
      ( v5724(VarCurr)
    <=> ( v5691(VarCurr,0)
        & v5691(VarCurr,1) ) ) ).

tff(addAssignment_2743,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v5714(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_2742,axiom,
    ! [VarCurr: state_type] :
      ( v5714(VarCurr,5)
    <=> v5715(VarCurr) ) ).

tff(writeUnaryOperator_433,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5715(VarCurr)
    <=> v5691(VarCurr,5) ) ).

tff(addBitVectorEqualityBitBlasted_77,axiom,
    ! [VarCurr: state_type] :
      ( v5713(VarCurr)
    <=> ( ( v5691(VarCurr,4)
        <=> $true )
        & ( v5691(VarCurr,3)
        <=> $false )
        & ( v5691(VarCurr,2)
        <=> $false )
        & ( v5691(VarCurr,1)
        <=> $false )
        & ( v5691(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_2741,axiom,
    ! [VarCurr: state_type] :
      ( v5701(VarCurr)
    <=> v5703(VarCurr) ) ).

tff(addAssignment_2740,axiom,
    ! [VarCurr: state_type] :
      ( v5703(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_2739,axiom,
    ! [VarCurr: state_type] :
      ( v5697(VarCurr)
    <=> v5699(VarCurr) ) ).

tff(addAssignment_2738,axiom,
    ! [VarCurr: state_type] :
      ( v5699(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_2737,axiom,
    ! [VarCurr: state_type] :
      ( v902(VarCurr,5)
    <=> v904(VarCurr,5) ) ).

tff(addAssignment_2736,axiom,
    ! [VarCurr: state_type] :
      ( v904(VarCurr,5)
    <=> v906(VarCurr,5) ) ).

tff(addAssignment_2735,axiom,
    ! [VarCurr: state_type] :
      ( v906(VarCurr,5)
    <=> v908(VarCurr,5) ) ).

tff(addAssignment_2734,axiom,
    ! [VarCurr: state_type] :
      ( v908(VarCurr,5)
    <=> v910(VarCurr,5) ) ).

tff(addAssignment_2733,axiom,
    ! [VarCurr: state_type] :
      ( v910(VarCurr,5)
    <=> v912(VarCurr,4) ) ).

tff(addAssignment_2732,axiom,
    ! [VarCurr: state_type] :
      ( v912(VarCurr,4)
    <=> v914(VarCurr,4) ) ).

tff(addAssignment_2731,axiom,
    ! [VarNext: state_type] :
      ( v914(VarNext,4)
    <=> v5669(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_72,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5670(VarNext)
       => ! [B: $int] :
            ( ( $less(B,14)
              & ~ $less(B,0) )
           => ( v5669(VarNext,B)
            <=> v914(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_72,axiom,
    ! [VarNext: state_type] :
      ( v5670(VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v5669(VarNext,B)
          <=> v5680(VarNext,B) ) ) ) ).

tff(addAssignment_2730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v5680(VarNext,B)
          <=> v5678(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_75,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5681(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v5678(VarCurr,B)
          <=> bxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_75,axiom,
    ! [VarCurr: state_type] :
      ( v5681(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,14)
            & ~ $less(B,0) )
         => ( v5678(VarCurr,B)
          <=> v932(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_585,axiom,
    ! [VarCurr: state_type] :
      ( v5681(VarCurr)
    <=> ( v5682(VarCurr)
        & v5683(VarCurr) ) ) ).

tff(writeUnaryOperator_432,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5683(VarCurr)
    <=> v924(VarCurr) ) ).

tff(writeUnaryOperator_431,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5682(VarCurr)
    <=> v916(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_584,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5670(VarNext)
      <=> v5671(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_583,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5671(VarNext)
      <=> ( v5672(VarNext)
          & v5608(VarNext) ) ) ) ).

tff(writeUnaryOperator_430,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5672(VarNext)
      <=> v5674(VarNext) ) ) ).

tff(addAssignment_2729,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5674(VarNext)
      <=> v5608(VarCurr) ) ) ).

tff(addAssignment_2728,axiom,
    ! [VarCurr: state_type] :
      ( v5608(VarCurr)
    <=> v5610(VarCurr) ) ).

tff(addAssignment_2727,axiom,
    ! [VarCurr: state_type] :
      ( v5610(VarCurr)
    <=> v5612(VarCurr) ) ).

tff(addAssignment_2726,axiom,
    ! [VarCurr: state_type] :
      ( v5612(VarCurr)
    <=> v5614(VarCurr) ) ).

tff(addAssignment_2725,axiom,
    ! [VarCurr: state_type] :
      ( v5614(VarCurr)
    <=> v5616(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_582,axiom,
    ! [VarCurr: state_type] :
      ( v5616(VarCurr)
    <=> ( v5667(VarCurr)
        | v5659(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_581,axiom,
    ! [VarCurr: state_type] :
      ( v5667(VarCurr)
    <=> ( v5618(VarCurr)
        & v5624(VarCurr) ) ) ).

tff(addAssignment_2724,axiom,
    ! [VarCurr: state_type] :
      ( v5659(VarCurr)
    <=> v5661(VarCurr) ) ).

tff(addAssignment_2723,axiom,
    ! [VarCurr: state_type] :
      ( v5661(VarCurr)
    <=> v5663(VarCurr) ) ).

tff(addAssignment_2722,axiom,
    ! [VarCurr: state_type] :
      ( v5663(VarCurr)
    <=> v5665(VarCurr) ) ).

tff(addAssignment_2721,axiom,
    ! [VarCurr: state_type] :
      ( v5665(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_71,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5643(VarNext)
       => ( v5624(VarNext)
        <=> v5624(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_71,axiom,
    ! [VarNext: state_type] :
      ( v5643(VarNext)
     => ( v5624(VarNext)
      <=> v5653(VarNext) ) ) ).

tff(addAssignment_2720,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5653(VarNext)
      <=> v5651(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_580,axiom,
    ! [VarCurr: state_type] :
      ( v5651(VarCurr)
    <=> ( v5654(VarCurr)
        & v5655(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_579,axiom,
    ! [VarCurr: state_type] :
      ( v5655(VarCurr)
    <=> ( v5630(VarCurr)
        | v5634(VarCurr) ) ) ).

tff(writeUnaryOperator_429,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5654(VarCurr)
    <=> v5626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_578,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5643(VarNext)
      <=> v5644(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_577,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5644(VarNext)
      <=> ( v5646(VarNext)
          & v5648(VarNext) ) ) ) ).

tff(writeUnaryOperator_428,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5648(VarCurr)
    <=> v5618(VarCurr) ) ).

tff(addAssignment_2719,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5646(VarNext)
      <=> v5618(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_11,axiom,
    ( v5624(constB0)
  <=> $true ) ).

tff(addAssignment_2718,axiom,
    ! [VarCurr: state_type] :
      ( v5634(VarCurr)
    <=> v5636(VarCurr) ) ).

tff(addAssignment_2717,axiom,
    ! [VarCurr: state_type] :
      ( v5636(VarCurr)
    <=> v5638(VarCurr) ) ).

tff(addAssignment_2716,axiom,
    ! [VarCurr: state_type] :
      ( v5638(VarCurr)
    <=> v5640(VarCurr) ) ).

tff(addAssignment_2715,axiom,
    ! [VarCurr: state_type] :
      ( v5640(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_2714,axiom,
    ! [VarCurr: state_type] :
      ( v5630(VarCurr)
    <=> v5632(VarCurr) ) ).

tff(addAssignment_2713,axiom,
    ! [VarCurr: state_type] :
      ( v5632(VarCurr)
    <=> $true ) ).

tff(addAssignment_2712,axiom,
    ! [VarCurr: state_type] :
      ( v5626(VarCurr)
    <=> v5628(VarCurr) ) ).

tff(addAssignment_2711,axiom,
    ! [VarCurr: state_type] :
      ( v5628(VarCurr)
    <=> $false ) ).

tff(addAssignment_2710,axiom,
    ! [VarCurr: state_type] :
      ( v5618(VarCurr)
    <=> v5620(VarCurr) ) ).

tff(addAssignment_2709,axiom,
    ! [VarCurr: state_type] :
      ( v5620(VarCurr)
    <=> v5622(VarCurr) ) ).

tff(addAssignment_2708,axiom,
    ! [VarCurr: state_type] :
      ( v5622(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_2707,axiom,
    ! [VarCurr: state_type] :
      ( v932(VarCurr,4)
    <=> v934(VarCurr,4) ) ).

tff(addAssignment_2706,axiom,
    ! [VarCurr: state_type] :
      ( v934(VarCurr,4)
    <=> v5598(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_110,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v5598(VarCurr,B)
      <=> ( v5599(VarCurr,B)
          | v5602(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_109,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v5602(VarCurr,B)
      <=> ( v912(VarCurr,B)
          & v5603(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_427,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v5603(VarCurr,B)
      <=> ~ v5604(VarCurr,B) ) ) ).

tff(addAssignment_2705,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,0)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2704,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,1)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2703,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,2)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2702,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,3)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2701,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,4)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2700,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,5)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2699,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,6)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2698,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,7)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2697,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,8)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2696,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,9)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2695,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,10)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2694,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,11)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2693,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,12)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2692,axiom,
    ! [VarCurr: state_type] :
      ( v5604(VarCurr,13)
    <=> v5605(VarCurr) ) ).

tff(addAssignment_2691,axiom,
    ! [VarCurr: state_type] :
      ( v5605(VarCurr)
    <=> v5597(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_108,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,14)
        & ~ $less(B,0) )
     => ( v5599(VarCurr,B)
      <=> ( v936(VarCurr,B)
          & v5600(VarCurr,B) ) ) ) ).

tff(addAssignment_2690,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,0)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2689,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,1)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2688,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,2)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2687,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,3)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2686,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,4)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2685,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,5)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2684,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,6)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2683,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,7)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2682,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,8)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2681,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,9)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2680,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,10)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2679,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,11)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2678,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,12)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2677,axiom,
    ! [VarCurr: state_type] :
      ( v5600(VarCurr,13)
    <=> v5601(VarCurr) ) ).

tff(addAssignment_2676,axiom,
    ! [VarCurr: state_type] :
      ( v5601(VarCurr)
    <=> v5597(VarCurr) ) ).

tff(addAssignment_2675,axiom,
    ! [VarCurr: state_type] :
      ( v5597(VarCurr)
    <=> v1001(VarCurr) ) ).

tff(addAssignment_2674,axiom,
    ! [VarCurr: state_type] :
      ( v936(VarCurr,4)
    <=> v938(VarCurr,4) ) ).

tff(addAssignment_2673,axiom,
    ! [VarCurr: state_type] :
      ( v938(VarCurr,4)
    <=> v5589(VarCurr,4) ) ).

tff(addAssignment_2672,axiom,
    ! [VarCurr: state_type] :
      ( v5589(VarCurr,0)
    <=> v5595(VarCurr) ) ).

tff(addAssignment_2671,axiom,
    ! [VarCurr: state_type] :
      ( ( v5589(VarCurr,3)
      <=> v5594(VarCurr,2) )
      & ( v5589(VarCurr,2)
      <=> v5594(VarCurr,1) )
      & ( v5589(VarCurr,1)
      <=> v5594(VarCurr,0) ) ) ).

tff(addAssignment_2670,axiom,
    ! [VarCurr: state_type] :
      ( v5589(VarCurr,4)
    <=> v5416(VarCurr) ) ).

tff(addAssignment_2669,axiom,
    ! [VarCurr: state_type] :
      ( v5589(VarCurr,5)
    <=> v5593(VarCurr) ) ).

tff(addAssignment_2668,axiom,
    ! [VarCurr: state_type] :
      ( ( v5589(VarCurr,8)
      <=> v5592(VarCurr,2) )
      & ( v5589(VarCurr,7)
      <=> v5592(VarCurr,1) )
      & ( v5589(VarCurr,6)
      <=> v5592(VarCurr,0) ) ) ).

tff(addAssignment_2667,axiom,
    ! [VarCurr: state_type] :
      ( ( v5589(VarCurr,11)
      <=> v5591(VarCurr,2) )
      & ( v5589(VarCurr,10)
      <=> v5591(VarCurr,1) )
      & ( v5589(VarCurr,9)
      <=> v5591(VarCurr,0) ) ) ).

tff(addAssignment_2666,axiom,
    ! [VarCurr: state_type] :
      ( v5589(VarCurr,12)
    <=> v5590(VarCurr) ) ).

tff(addAssignment_2665,axiom,
    ! [VarCurr: state_type] :
      ( v5589(VarCurr,13)
    <=> v940(VarCurr) ) ).

tff(addAssignment_2664,axiom,
    ! [VarCurr: state_type] :
      ( v5416(VarCurr)
    <=> v964(VarCurr,8) ) ).

tff(addAssignment_2663,axiom,
    ! [VarCurr: state_type] :
      ( v964(VarCurr,8)
    <=> v966(VarCurr,8) ) ).

tff(addAssignment_2662,axiom,
    ! [VarCurr: state_type] :
      ( v966(VarCurr,8)
    <=> v5526(VarCurr,8) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5526(VarCurr,B)
      <=> ( v5527(VarCurr,B)
          | v5586(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_106,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5586(VarCurr,B)
      <=> ( v5587(VarCurr,B)
          & v5521(VarCurr,B) ) ) ) ).

tff(addAssignment_2661,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,0)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2660,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,1)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2659,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,2)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2658,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,3)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2657,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,4)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2656,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,5)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2655,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,6)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2654,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,7)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2653,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,8)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2652,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,9)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2651,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,10)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2650,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,11)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2649,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,12)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2648,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,13)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2647,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,14)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2646,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,15)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2645,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,16)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2644,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,17)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2643,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,18)
    <=> v5588(VarCurr) ) ).

tff(addAssignment_2642,axiom,
    ! [VarCurr: state_type] :
      ( v5587(VarCurr,19)
    <=> v5588(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_76,axiom,
    ! [VarCurr: state_type] :
      ( v5588(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_328,axiom,
    b1111(3) ).

tff(bitBlastConstant_327,axiom,
    b1111(2) ).

tff(bitBlastConstant_326,axiom,
    b1111(1) ).

tff(bitBlastConstant_325,axiom,
    b1111(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_105,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5527(VarCurr,B)
      <=> ( v5528(VarCurr,B)
          | v5583(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_104,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5583(VarCurr,B)
      <=> ( v5584(VarCurr,B)
          & v5514(VarCurr,B) ) ) ) ).

tff(addAssignment_2641,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,0)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2640,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,1)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2639,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,2)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2638,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,3)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2637,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,4)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2636,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,5)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2635,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,6)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2634,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,7)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2633,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,8)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2632,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,9)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2631,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,10)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2630,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,11)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2629,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,12)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2628,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,13)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2627,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,14)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2626,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,15)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2625,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,16)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2624,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,17)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2623,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,18)
    <=> v5585(VarCurr) ) ).

tff(addAssignment_2622,axiom,
    ! [VarCurr: state_type] :
      ( v5584(VarCurr,19)
    <=> v5585(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_75,axiom,
    ! [VarCurr: state_type] :
      ( v5585(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_324,axiom,
    b1110(3) ).

tff(bitBlastConstant_323,axiom,
    b1110(2) ).

tff(bitBlastConstant_322,axiom,
    b1110(1) ).

tff(bitBlastConstant_321,axiom,
    ~ b1110(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_103,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5528(VarCurr,B)
      <=> ( v5529(VarCurr,B)
          | v5580(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_102,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5580(VarCurr,B)
      <=> ( v5581(VarCurr,B)
          & v5507(VarCurr,B) ) ) ) ).

tff(addAssignment_2621,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,0)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2620,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,1)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2619,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,2)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2618,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,3)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2617,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,4)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2616,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,5)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2615,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,6)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2614,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,7)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2613,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,8)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2612,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,9)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2611,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,10)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2610,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,11)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2609,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,12)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2608,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,13)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2607,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,14)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2606,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,15)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2605,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,16)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2604,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,17)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2603,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,18)
    <=> v5582(VarCurr) ) ).

tff(addAssignment_2602,axiom,
    ! [VarCurr: state_type] :
      ( v5581(VarCurr,19)
    <=> v5582(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_74,axiom,
    ! [VarCurr: state_type] :
      ( v5582(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_320,axiom,
    b1101(3) ).

tff(bitBlastConstant_319,axiom,
    b1101(2) ).

tff(bitBlastConstant_318,axiom,
    ~ b1101(1) ).

tff(bitBlastConstant_317,axiom,
    b1101(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_101,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5529(VarCurr,B)
      <=> ( v5530(VarCurr,B)
          | v5577(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_100,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5577(VarCurr,B)
      <=> ( v5578(VarCurr,B)
          & v5500(VarCurr,B) ) ) ) ).

tff(addAssignment_2601,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,0)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2600,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,1)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2599,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,2)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2598,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,3)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2597,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,4)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2596,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,5)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2595,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,6)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2594,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,7)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2593,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,8)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2592,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,9)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2591,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,10)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2590,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,11)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2589,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,12)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2588,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,13)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2587,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,14)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2586,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,15)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2585,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,16)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2584,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,17)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2583,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,18)
    <=> v5579(VarCurr) ) ).

tff(addAssignment_2582,axiom,
    ! [VarCurr: state_type] :
      ( v5578(VarCurr,19)
    <=> v5579(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_73,axiom,
    ! [VarCurr: state_type] :
      ( v5579(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_316,axiom,
    b1100(3) ).

tff(bitBlastConstant_315,axiom,
    b1100(2) ).

tff(bitBlastConstant_314,axiom,
    ~ b1100(1) ).

tff(bitBlastConstant_313,axiom,
    ~ b1100(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_99,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5530(VarCurr,B)
      <=> ( v5531(VarCurr,B)
          | v5574(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_98,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5574(VarCurr,B)
      <=> ( v5575(VarCurr,B)
          & v5493(VarCurr,B) ) ) ) ).

tff(addAssignment_2581,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,0)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2580,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,1)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2579,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,2)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2578,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,3)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2577,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,4)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2576,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,5)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2575,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,6)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2574,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,7)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2573,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,8)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2572,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,9)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2571,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,10)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2570,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,11)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2569,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,12)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2568,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,13)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2567,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,14)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2566,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,15)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2565,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,16)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2564,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,17)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2563,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,18)
    <=> v5576(VarCurr) ) ).

tff(addAssignment_2562,axiom,
    ! [VarCurr: state_type] :
      ( v5575(VarCurr,19)
    <=> v5576(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_72,axiom,
    ! [VarCurr: state_type] :
      ( v5576(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_97,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5531(VarCurr,B)
      <=> ( v5532(VarCurr,B)
          | v5571(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_96,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5571(VarCurr,B)
      <=> ( v5572(VarCurr,B)
          & v5487(VarCurr,B) ) ) ) ).

tff(addAssignment_2561,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,0)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2560,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,1)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2559,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,2)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2558,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,3)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2557,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,4)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2556,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,5)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2555,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,6)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2554,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,7)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2553,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,8)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2552,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,9)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2551,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,10)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2550,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,11)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2549,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,12)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2548,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,13)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2547,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,14)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2546,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,15)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2545,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,16)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2544,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,17)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2543,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,18)
    <=> v5573(VarCurr) ) ).

tff(addAssignment_2542,axiom,
    ! [VarCurr: state_type] :
      ( v5572(VarCurr,19)
    <=> v5573(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_71,axiom,
    ! [VarCurr: state_type] :
      ( v5573(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_312,axiom,
    b1010(3) ).

tff(bitBlastConstant_311,axiom,
    ~ b1010(2) ).

tff(bitBlastConstant_310,axiom,
    b1010(1) ).

tff(bitBlastConstant_309,axiom,
    ~ b1010(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_95,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5532(VarCurr,B)
      <=> ( v5533(VarCurr,B)
          | v5568(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_94,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5568(VarCurr,B)
      <=> ( v5569(VarCurr,B)
          & v5480(VarCurr,B) ) ) ) ).

tff(addAssignment_2541,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,0)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2540,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,1)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2539,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,2)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2538,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,3)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2537,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,4)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2536,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,5)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2535,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,6)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2534,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,7)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2533,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,8)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2532,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,9)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2531,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,10)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2530,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,11)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2529,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,12)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2528,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,13)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2527,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,14)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2526,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,15)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2525,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,16)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2524,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,17)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2523,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,18)
    <=> v5570(VarCurr) ) ).

tff(addAssignment_2522,axiom,
    ! [VarCurr: state_type] :
      ( v5569(VarCurr,19)
    <=> v5570(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_70,axiom,
    ! [VarCurr: state_type] :
      ( v5570(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_308,axiom,
    b1001(3) ).

tff(bitBlastConstant_307,axiom,
    ~ b1001(2) ).

tff(bitBlastConstant_306,axiom,
    ~ b1001(1) ).

tff(bitBlastConstant_305,axiom,
    b1001(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_93,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5533(VarCurr,B)
      <=> ( v5534(VarCurr,B)
          | v5565(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_92,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5565(VarCurr,B)
      <=> ( v5566(VarCurr,B)
          & v5473(VarCurr,B) ) ) ) ).

tff(addAssignment_2521,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,0)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2520,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,1)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2519,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,2)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2518,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,3)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2517,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,4)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2516,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,5)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2515,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,6)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2514,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,7)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2513,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,8)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2512,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,9)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2511,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,10)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2510,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,11)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2509,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,12)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2508,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,13)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2507,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,14)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2506,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,15)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2505,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,16)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2504,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,17)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2503,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,18)
    <=> v5567(VarCurr) ) ).

tff(addAssignment_2502,axiom,
    ! [VarCurr: state_type] :
      ( v5566(VarCurr,19)
    <=> v5567(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_69,axiom,
    ! [VarCurr: state_type] :
      ( v5567(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $true )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_304,axiom,
    b1000(3) ).

tff(bitBlastConstant_303,axiom,
    ~ b1000(2) ).

tff(bitBlastConstant_302,axiom,
    ~ b1000(1) ).

tff(bitBlastConstant_301,axiom,
    ~ b1000(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_91,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5534(VarCurr,B)
      <=> ( v5535(VarCurr,B)
          | v5562(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_90,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5562(VarCurr,B)
      <=> ( v5563(VarCurr,B)
          & v5466(VarCurr,B) ) ) ) ).

tff(addAssignment_2501,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,0)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2500,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,1)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2499,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,2)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2498,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,3)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2497,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,4)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2496,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,5)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2495,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,6)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2494,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,7)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2493,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,8)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2492,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,9)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2491,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,10)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2490,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,11)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2489,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,12)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2488,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,13)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2487,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,14)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2486,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,15)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2485,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,16)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2484,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,17)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2483,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,18)
    <=> v5564(VarCurr) ) ).

tff(addAssignment_2482,axiom,
    ! [VarCurr: state_type] :
      ( v5563(VarCurr,19)
    <=> v5564(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_68,axiom,
    ! [VarCurr: state_type] :
      ( v5564(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_300,axiom,
    ~ b0111(3) ).

tff(bitBlastConstant_299,axiom,
    b0111(2) ).

tff(bitBlastConstant_298,axiom,
    b0111(1) ).

tff(bitBlastConstant_297,axiom,
    b0111(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_89,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5535(VarCurr,B)
      <=> ( v5536(VarCurr,B)
          | v5559(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_88,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5559(VarCurr,B)
      <=> ( v5560(VarCurr,B)
          & v5459(VarCurr,B) ) ) ) ).

tff(addAssignment_2481,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,0)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2480,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,1)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2479,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,2)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2478,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,3)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2477,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,4)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2476,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,5)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2475,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,6)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2474,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,7)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2473,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,8)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2472,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,9)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2471,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,10)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2470,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,11)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2469,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,12)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2468,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,13)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2467,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,14)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2466,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,15)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2465,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,16)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2464,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,17)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2463,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,18)
    <=> v5561(VarCurr) ) ).

tff(addAssignment_2462,axiom,
    ! [VarCurr: state_type] :
      ( v5560(VarCurr,19)
    <=> v5561(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_67,axiom,
    ! [VarCurr: state_type] :
      ( v5561(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_296,axiom,
    ~ b0110(3) ).

tff(bitBlastConstant_295,axiom,
    b0110(2) ).

tff(bitBlastConstant_294,axiom,
    b0110(1) ).

tff(bitBlastConstant_293,axiom,
    ~ b0110(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_87,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5536(VarCurr,B)
      <=> ( v5537(VarCurr,B)
          | v5556(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_86,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5556(VarCurr,B)
      <=> ( v5557(VarCurr,B)
          & v5452(VarCurr,B) ) ) ) ).

tff(addAssignment_2461,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,0)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2460,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,1)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2459,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,2)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2458,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,3)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2457,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,4)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2456,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,5)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2455,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,6)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2454,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,7)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2453,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,8)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2452,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,9)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2451,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,10)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2450,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,11)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2449,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,12)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2448,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,13)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2447,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,14)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2446,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,15)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2445,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,16)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2444,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,17)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2443,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,18)
    <=> v5558(VarCurr) ) ).

tff(addAssignment_2442,axiom,
    ! [VarCurr: state_type] :
      ( v5557(VarCurr,19)
    <=> v5558(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_66,axiom,
    ! [VarCurr: state_type] :
      ( v5558(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_292,axiom,
    ~ b0101(3) ).

tff(bitBlastConstant_291,axiom,
    b0101(2) ).

tff(bitBlastConstant_290,axiom,
    ~ b0101(1) ).

tff(bitBlastConstant_289,axiom,
    b0101(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_85,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5537(VarCurr,B)
      <=> ( v5538(VarCurr,B)
          | v5553(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_84,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5553(VarCurr,B)
      <=> ( v5554(VarCurr,B)
          & v5445(VarCurr,B) ) ) ) ).

tff(addAssignment_2441,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,0)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2440,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,1)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2439,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,2)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2438,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,3)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2437,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,4)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2436,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,5)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2435,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,6)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2434,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,7)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2433,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,8)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2432,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,9)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2431,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,10)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2430,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,11)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2429,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,12)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2428,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,13)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2427,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,14)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2426,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,15)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2425,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,16)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2424,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,17)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2423,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,18)
    <=> v5555(VarCurr) ) ).

tff(addAssignment_2422,axiom,
    ! [VarCurr: state_type] :
      ( v5554(VarCurr,19)
    <=> v5555(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_65,axiom,
    ! [VarCurr: state_type] :
      ( v5555(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $true )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_288,axiom,
    ~ b0100(3) ).

tff(bitBlastConstant_287,axiom,
    b0100(2) ).

tff(bitBlastConstant_286,axiom,
    ~ b0100(1) ).

tff(bitBlastConstant_285,axiom,
    ~ b0100(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_83,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5538(VarCurr,B)
      <=> ( v5539(VarCurr,B)
          | v5550(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_82,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5550(VarCurr,B)
      <=> ( v5551(VarCurr,B)
          & v5438(VarCurr,B) ) ) ) ).

tff(addAssignment_2421,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,0)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2420,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,1)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2419,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,2)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2418,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,3)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2417,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,4)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2416,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,5)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2415,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,6)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2414,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,7)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2413,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,8)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2412,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,9)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2411,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,10)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2410,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,11)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2409,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,12)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2408,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,13)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2407,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,14)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2406,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,15)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2405,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,16)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2404,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,17)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2403,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,18)
    <=> v5552(VarCurr) ) ).

tff(addAssignment_2402,axiom,
    ! [VarCurr: state_type] :
      ( v5551(VarCurr,19)
    <=> v5552(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_64,axiom,
    ! [VarCurr: state_type] :
      ( v5552(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_284,axiom,
    ~ b0011(3) ).

tff(bitBlastConstant_283,axiom,
    ~ b0011(2) ).

tff(bitBlastConstant_282,axiom,
    b0011(1) ).

tff(bitBlastConstant_281,axiom,
    b0011(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_81,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5539(VarCurr,B)
      <=> ( v5540(VarCurr,B)
          | v5547(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_80,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5547(VarCurr,B)
      <=> ( v5548(VarCurr,B)
          & v5431(VarCurr,B) ) ) ) ).

tff(addAssignment_2401,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,0)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2400,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,1)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2399,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,2)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2398,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,3)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2397,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,4)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2396,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,5)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2395,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,6)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2394,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,7)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2393,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,8)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2392,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,9)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2391,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,10)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2390,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,11)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2389,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,12)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2388,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,13)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2387,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,14)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2386,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,15)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2385,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,16)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2384,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,17)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2383,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,18)
    <=> v5549(VarCurr) ) ).

tff(addAssignment_2382,axiom,
    ! [VarCurr: state_type] :
      ( v5548(VarCurr,19)
    <=> v5549(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_63,axiom,
    ! [VarCurr: state_type] :
      ( v5549(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $true )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_280,axiom,
    ~ b0010(3) ).

tff(bitBlastConstant_279,axiom,
    ~ b0010(2) ).

tff(bitBlastConstant_278,axiom,
    b0010(1) ).

tff(bitBlastConstant_277,axiom,
    ~ b0010(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_79,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5540(VarCurr,B)
      <=> ( v5541(VarCurr,B)
          | v5544(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_78,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5544(VarCurr,B)
      <=> ( v5545(VarCurr,B)
          & v5424(VarCurr,B) ) ) ) ).

tff(addAssignment_2381,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,0)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2380,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,1)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2379,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,2)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2378,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,3)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2377,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,4)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2376,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,5)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2375,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,6)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2374,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,7)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2373,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,8)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2372,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,9)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2371,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,10)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2370,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,11)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2369,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,12)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2368,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,13)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2367,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,14)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2366,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,15)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2365,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,16)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2364,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,17)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2363,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,18)
    <=> v5546(VarCurr) ) ).

tff(addAssignment_2362,axiom,
    ! [VarCurr: state_type] :
      ( v5545(VarCurr,19)
    <=> v5546(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_62,axiom,
    ! [VarCurr: state_type] :
      ( v5546(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_276,axiom,
    ~ b0001(3) ).

tff(bitBlastConstant_275,axiom,
    ~ b0001(2) ).

tff(bitBlastConstant_274,axiom,
    ~ b0001(1) ).

tff(bitBlastConstant_273,axiom,
    b0001(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_77,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,20)
        & ~ $less(B,0) )
     => ( v5541(VarCurr,B)
      <=> ( v5542(VarCurr,B)
          & v5418(VarCurr,B) ) ) ) ).

tff(addAssignment_2361,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,0)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2360,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,1)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2359,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,2)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2358,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,3)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2357,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,4)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2356,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,5)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2355,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,6)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2354,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,7)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2353,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,8)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2352,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,9)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2351,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,10)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2350,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,11)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2349,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,12)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2348,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,13)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2347,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,14)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2346,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,15)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2345,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,16)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2344,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,17)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2343,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,18)
    <=> v5543(VarCurr) ) ).

tff(addAssignment_2342,axiom,
    ! [VarCurr: state_type] :
      ( v5542(VarCurr,19)
    <=> v5543(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_61,axiom,
    ! [VarCurr: state_type] :
      ( v5543(VarCurr)
    <=> ( ( v968(VarCurr,3)
        <=> $false )
        & ( v968(VarCurr,2)
        <=> $false )
        & ( v968(VarCurr,1)
        <=> $false )
        & ( v968(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_2341,axiom,
    ! [VarCurr: state_type] :
      ( v5521(VarCurr,8)
    <=> v5523(VarCurr,8) ) ).

tff(addAssignment_2340,axiom,
    ! [VarCurr: state_type] :
      ( v5523(VarCurr,8)
    <=> v5525(VarCurr,8) ) ).

tff(addAssignment_2339,axiom,
    ! [VarCurr: state_type] :
      ( v5514(VarCurr,8)
    <=> v5516(VarCurr,8) ) ).

tff(addAssignment_2338,axiom,
    ! [VarCurr: state_type] :
      ( v5516(VarCurr,8)
    <=> v5518(VarCurr,8) ) ).

tff(addAssignment_2337,axiom,
    ! [VarCurr: state_type] :
      ( v5507(VarCurr,8)
    <=> v5509(VarCurr,8) ) ).

tff(addAssignment_2336,axiom,
    ! [VarCurr: state_type] :
      ( v5509(VarCurr,8)
    <=> v5511(VarCurr,8) ) ).

tff(addAssignment_2335,axiom,
    ! [VarCurr: state_type] :
      ( v5500(VarCurr,8)
    <=> v5502(VarCurr,8) ) ).

tff(addAssignment_2334,axiom,
    ! [VarCurr: state_type] :
      ( v5502(VarCurr,8)
    <=> v5504(VarCurr,8) ) ).

tff(addAssignment_2333,axiom,
    ! [VarCurr: state_type] :
      ( v5493(VarCurr,8)
    <=> v5495(VarCurr,8) ) ).

tff(addAssignment_2332,axiom,
    ! [VarCurr: state_type] :
      ( v5495(VarCurr,8)
    <=> v5497(VarCurr,8) ) ).

tff(addAssignment_2331,axiom,
    ! [VarCurr: state_type] :
      ( v5487(VarCurr,8)
    <=> v5489(VarCurr,8) ) ).

tff(addAssignment_2330,axiom,
    ! [VarCurr: state_type] :
      ( v5489(VarCurr,8)
    <=> v5491(VarCurr,8) ) ).

tff(addAssignment_2329,axiom,
    ! [VarCurr: state_type] :
      ( v5480(VarCurr,8)
    <=> v5482(VarCurr,8) ) ).

tff(addAssignment_2328,axiom,
    ! [VarCurr: state_type] :
      ( v5482(VarCurr,8)
    <=> v5484(VarCurr,8) ) ).

tff(addAssignment_2327,axiom,
    ! [VarCurr: state_type] :
      ( v5473(VarCurr,8)
    <=> v5475(VarCurr,8) ) ).

tff(addAssignment_2326,axiom,
    ! [VarCurr: state_type] :
      ( v5475(VarCurr,8)
    <=> v5477(VarCurr,8) ) ).

tff(addAssignment_2325,axiom,
    ! [VarCurr: state_type] :
      ( v5466(VarCurr,8)
    <=> v5468(VarCurr,8) ) ).

tff(addAssignment_2324,axiom,
    ! [VarCurr: state_type] :
      ( v5468(VarCurr,8)
    <=> v5470(VarCurr,8) ) ).

tff(addAssignment_2323,axiom,
    ! [VarCurr: state_type] :
      ( v5459(VarCurr,8)
    <=> v5461(VarCurr,8) ) ).

tff(addAssignment_2322,axiom,
    ! [VarCurr: state_type] :
      ( v5461(VarCurr,8)
    <=> v5463(VarCurr,8) ) ).

tff(addAssignment_2321,axiom,
    ! [VarCurr: state_type] :
      ( v5452(VarCurr,8)
    <=> v5454(VarCurr,8) ) ).

tff(addAssignment_2320,axiom,
    ! [VarCurr: state_type] :
      ( v5454(VarCurr,8)
    <=> v5456(VarCurr,8) ) ).

tff(addAssignment_2319,axiom,
    ! [VarCurr: state_type] :
      ( v5445(VarCurr,8)
    <=> v5447(VarCurr,8) ) ).

tff(addAssignment_2318,axiom,
    ! [VarCurr: state_type] :
      ( v5447(VarCurr,8)
    <=> v5449(VarCurr,8) ) ).

tff(addAssignment_2317,axiom,
    ! [VarCurr: state_type] :
      ( v5438(VarCurr,8)
    <=> v5440(VarCurr,8) ) ).

tff(addAssignment_2316,axiom,
    ! [VarCurr: state_type] :
      ( v5440(VarCurr,8)
    <=> v5442(VarCurr,8) ) ).

tff(addAssignment_2315,axiom,
    ! [VarCurr: state_type] :
      ( v5431(VarCurr,8)
    <=> v5433(VarCurr,8) ) ).

tff(addAssignment_2314,axiom,
    ! [VarCurr: state_type] :
      ( v5433(VarCurr,8)
    <=> v5435(VarCurr,8) ) ).

tff(addAssignment_2313,axiom,
    ! [VarCurr: state_type] :
      ( v5424(VarCurr,8)
    <=> v5426(VarCurr,8) ) ).

tff(addAssignment_2312,axiom,
    ! [VarCurr: state_type] :
      ( v5426(VarCurr,8)
    <=> v5428(VarCurr,8) ) ).

tff(addAssignment_2311,axiom,
    ! [VarCurr: state_type] :
      ( v5418(VarCurr,8)
    <=> v5420(VarCurr,8) ) ).

tff(addAssignment_2310,axiom,
    ! [VarCurr: state_type] :
      ( v5420(VarCurr,8)
    <=> v5422(VarCurr,8) ) ).

tff(addAssignment_2309,axiom,
    ! [VarCurr: state_type] :
      ( v5218(VarCurr)
    <=> v781(VarCurr,0) ) ).

tff(addAssignment_2308,axiom,
    ! [VarCurr: state_type] :
      ( v781(VarCurr,0)
    <=> v783(VarCurr,0) ) ).

tff(addAssignment_2307,axiom,
    ! [VarCurr: state_type] :
      ( v783(VarCurr,0)
    <=> v5329(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_76,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5329(VarCurr,B)
      <=> ( v5330(VarCurr,B)
          | v5409(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_75,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5409(VarCurr,B)
      <=> ( v5410(VarCurr,B)
          & v5324(VarCurr,B) ) ) ) ).

tff(addAssignment_2306,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,0)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2305,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,1)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2304,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,2)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2303,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,3)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2302,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,4)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2301,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,5)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2300,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,6)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2299,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,7)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2298,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,8)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2297,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,9)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2296,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,10)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2295,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,11)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2294,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,12)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2293,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,13)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2292,axiom,
    ! [VarCurr: state_type] :
      ( v5410(VarCurr,14)
    <=> v5411(VarCurr) ) ).

tff(addAssignment_2291,axiom,
    ! [VarCurr: state_type] :
      ( v5411(VarCurr)
    <=> v5412(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_60,axiom,
    ! [VarCurr: state_type] :
      ( v5412(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $true )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_74,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5330(VarCurr,B)
      <=> ( v5331(VarCurr,B)
          | v5405(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_73,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5405(VarCurr,B)
      <=> ( v5406(VarCurr,B)
          & v5318(VarCurr,B) ) ) ) ).

tff(addAssignment_2290,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,0)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2289,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,1)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2288,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,2)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2287,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,3)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2286,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,4)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2285,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,5)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2284,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,6)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2283,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,7)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2282,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,8)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2281,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,9)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2280,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,10)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2279,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,11)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2278,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,12)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2277,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,13)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2276,axiom,
    ! [VarCurr: state_type] :
      ( v5406(VarCurr,14)
    <=> v5407(VarCurr) ) ).

tff(addAssignment_2275,axiom,
    ! [VarCurr: state_type] :
      ( v5407(VarCurr)
    <=> v5408(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_59,axiom,
    ! [VarCurr: state_type] :
      ( v5408(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_272,axiom,
    ~ b01111(4) ).

tff(bitBlastConstant_271,axiom,
    b01111(3) ).

tff(bitBlastConstant_270,axiom,
    b01111(2) ).

tff(bitBlastConstant_269,axiom,
    b01111(1) ).

tff(bitBlastConstant_268,axiom,
    b01111(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_72,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5331(VarCurr,B)
      <=> ( v5332(VarCurr,B)
          | v5401(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_71,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5401(VarCurr,B)
      <=> ( v5402(VarCurr,B)
          & v5311(VarCurr,B) ) ) ) ).

tff(addAssignment_2274,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,0)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2273,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,1)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2272,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,2)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2271,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,3)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2270,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,4)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2269,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,5)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2268,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,6)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2267,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,7)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2266,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,8)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2265,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,9)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2264,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,10)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2263,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,11)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2262,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,12)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2261,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,13)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2260,axiom,
    ! [VarCurr: state_type] :
      ( v5402(VarCurr,14)
    <=> v5403(VarCurr) ) ).

tff(addAssignment_2259,axiom,
    ! [VarCurr: state_type] :
      ( v5403(VarCurr)
    <=> v5404(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_58,axiom,
    ! [VarCurr: state_type] :
      ( v5404(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_267,axiom,
    ~ b01110(4) ).

tff(bitBlastConstant_266,axiom,
    b01110(3) ).

tff(bitBlastConstant_265,axiom,
    b01110(2) ).

tff(bitBlastConstant_264,axiom,
    b01110(1) ).

tff(bitBlastConstant_263,axiom,
    ~ b01110(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_70,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5332(VarCurr,B)
      <=> ( v5333(VarCurr,B)
          | v5397(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_69,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5397(VarCurr,B)
      <=> ( v5398(VarCurr,B)
          & v5304(VarCurr,B) ) ) ) ).

tff(addAssignment_2258,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,0)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2257,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,1)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2256,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,2)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2255,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,3)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2254,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,4)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2253,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,5)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2252,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,6)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2251,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,7)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2250,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,8)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2249,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,9)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2248,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,10)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2247,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,11)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2246,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,12)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2245,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,13)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2244,axiom,
    ! [VarCurr: state_type] :
      ( v5398(VarCurr,14)
    <=> v5399(VarCurr) ) ).

tff(addAssignment_2243,axiom,
    ! [VarCurr: state_type] :
      ( v5399(VarCurr)
    <=> v5400(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_57,axiom,
    ! [VarCurr: state_type] :
      ( v5400(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_262,axiom,
    ~ b01101(4) ).

tff(bitBlastConstant_261,axiom,
    b01101(3) ).

tff(bitBlastConstant_260,axiom,
    b01101(2) ).

tff(bitBlastConstant_259,axiom,
    ~ b01101(1) ).

tff(bitBlastConstant_258,axiom,
    b01101(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_68,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5333(VarCurr,B)
      <=> ( v5334(VarCurr,B)
          | v5393(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_67,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5393(VarCurr,B)
      <=> ( v5394(VarCurr,B)
          & v5297(VarCurr,B) ) ) ) ).

tff(addAssignment_2242,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,0)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2241,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,1)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2240,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,2)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2239,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,3)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2238,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,4)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2237,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,5)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2236,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,6)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2235,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,7)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2234,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,8)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2233,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,9)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2232,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,10)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2231,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,11)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2230,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,12)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2229,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,13)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2228,axiom,
    ! [VarCurr: state_type] :
      ( v5394(VarCurr,14)
    <=> v5395(VarCurr) ) ).

tff(addAssignment_2227,axiom,
    ! [VarCurr: state_type] :
      ( v5395(VarCurr)
    <=> v5396(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_56,axiom,
    ! [VarCurr: state_type] :
      ( v5396(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_257,axiom,
    ~ b01100(4) ).

tff(bitBlastConstant_256,axiom,
    b01100(3) ).

tff(bitBlastConstant_255,axiom,
    b01100(2) ).

tff(bitBlastConstant_254,axiom,
    ~ b01100(1) ).

tff(bitBlastConstant_253,axiom,
    ~ b01100(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_66,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5334(VarCurr,B)
      <=> ( v5335(VarCurr,B)
          | v5389(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_65,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5389(VarCurr,B)
      <=> ( v5390(VarCurr,B)
          & v5290(VarCurr,B) ) ) ) ).

tff(addAssignment_2226,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,0)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2225,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,1)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2224,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,2)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2223,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,3)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2222,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,4)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2221,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,5)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2220,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,6)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2219,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,7)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2218,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,8)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2217,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,9)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2216,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,10)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2215,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,11)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2214,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,12)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2213,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,13)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2212,axiom,
    ! [VarCurr: state_type] :
      ( v5390(VarCurr,14)
    <=> v5391(VarCurr) ) ).

tff(addAssignment_2211,axiom,
    ! [VarCurr: state_type] :
      ( v5391(VarCurr)
    <=> v5392(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_55,axiom,
    ! [VarCurr: state_type] :
      ( v5392(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_252,axiom,
    ~ b01011(4) ).

tff(bitBlastConstant_251,axiom,
    b01011(3) ).

tff(bitBlastConstant_250,axiom,
    ~ b01011(2) ).

tff(bitBlastConstant_249,axiom,
    b01011(1) ).

tff(bitBlastConstant_248,axiom,
    b01011(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_64,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5335(VarCurr,B)
      <=> ( v5336(VarCurr,B)
          | v5385(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_63,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5385(VarCurr,B)
      <=> ( v5386(VarCurr,B)
          & v5283(VarCurr,B) ) ) ) ).

tff(addAssignment_2210,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,0)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2209,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,1)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2208,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,2)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2207,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,3)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2206,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,4)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2205,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,5)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2204,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,6)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2203,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,7)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2202,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,8)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2201,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,9)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2200,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,10)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2199,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,11)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2198,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,12)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2197,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,13)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2196,axiom,
    ! [VarCurr: state_type] :
      ( v5386(VarCurr,14)
    <=> v5387(VarCurr) ) ).

tff(addAssignment_2195,axiom,
    ! [VarCurr: state_type] :
      ( v5387(VarCurr)
    <=> v5388(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_54,axiom,
    ! [VarCurr: state_type] :
      ( v5388(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_247,axiom,
    ~ b01010(4) ).

tff(bitBlastConstant_246,axiom,
    b01010(3) ).

tff(bitBlastConstant_245,axiom,
    ~ b01010(2) ).

tff(bitBlastConstant_244,axiom,
    b01010(1) ).

tff(bitBlastConstant_243,axiom,
    ~ b01010(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_62,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5336(VarCurr,B)
      <=> ( v5337(VarCurr,B)
          | v5381(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_61,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5381(VarCurr,B)
      <=> ( v5382(VarCurr,B)
          & v5276(VarCurr,B) ) ) ) ).

tff(addAssignment_2194,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,0)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2193,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,1)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2192,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,2)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2191,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,3)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2190,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,4)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2189,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,5)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2188,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,6)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2187,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,7)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2186,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,8)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2185,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,9)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2184,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,10)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2183,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,11)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2182,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,12)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2181,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,13)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2180,axiom,
    ! [VarCurr: state_type] :
      ( v5382(VarCurr,14)
    <=> v5383(VarCurr) ) ).

tff(addAssignment_2179,axiom,
    ! [VarCurr: state_type] :
      ( v5383(VarCurr)
    <=> v5384(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_53,axiom,
    ! [VarCurr: state_type] :
      ( v5384(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_242,axiom,
    ~ b01001(4) ).

tff(bitBlastConstant_241,axiom,
    b01001(3) ).

tff(bitBlastConstant_240,axiom,
    ~ b01001(2) ).

tff(bitBlastConstant_239,axiom,
    ~ b01001(1) ).

tff(bitBlastConstant_238,axiom,
    b01001(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_60,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5337(VarCurr,B)
      <=> ( v5338(VarCurr,B)
          | v5377(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_59,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5377(VarCurr,B)
      <=> ( v5378(VarCurr,B)
          & v5269(VarCurr,B) ) ) ) ).

tff(addAssignment_2178,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,0)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2177,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,1)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2176,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,2)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2175,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,3)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2174,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,4)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2173,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,5)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2172,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,6)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2171,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,7)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2170,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,8)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2169,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,9)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2168,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,10)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2167,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,11)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2166,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,12)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2165,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,13)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2164,axiom,
    ! [VarCurr: state_type] :
      ( v5378(VarCurr,14)
    <=> v5379(VarCurr) ) ).

tff(addAssignment_2163,axiom,
    ! [VarCurr: state_type] :
      ( v5379(VarCurr)
    <=> v5380(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_52,axiom,
    ! [VarCurr: state_type] :
      ( v5380(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $true )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_237,axiom,
    ~ b01000(4) ).

tff(bitBlastConstant_236,axiom,
    b01000(3) ).

tff(bitBlastConstant_235,axiom,
    ~ b01000(2) ).

tff(bitBlastConstant_234,axiom,
    ~ b01000(1) ).

tff(bitBlastConstant_233,axiom,
    ~ b01000(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_58,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5338(VarCurr,B)
      <=> ( v5339(VarCurr,B)
          | v5373(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_57,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5373(VarCurr,B)
      <=> ( v5374(VarCurr,B)
          & v5262(VarCurr,B) ) ) ) ).

tff(addAssignment_2162,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,0)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2161,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,1)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2160,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,2)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2159,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,3)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2158,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,4)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2157,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,5)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2156,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,6)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2155,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,7)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2154,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,8)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2153,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,9)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2152,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,10)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2151,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,11)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2150,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,12)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2149,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,13)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2148,axiom,
    ! [VarCurr: state_type] :
      ( v5374(VarCurr,14)
    <=> v5375(VarCurr) ) ).

tff(addAssignment_2147,axiom,
    ! [VarCurr: state_type] :
      ( v5375(VarCurr)
    <=> v5376(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_51,axiom,
    ! [VarCurr: state_type] :
      ( v5376(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_232,axiom,
    ~ b00111(4) ).

tff(bitBlastConstant_231,axiom,
    ~ b00111(3) ).

tff(bitBlastConstant_230,axiom,
    b00111(2) ).

tff(bitBlastConstant_229,axiom,
    b00111(1) ).

tff(bitBlastConstant_228,axiom,
    b00111(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_56,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5339(VarCurr,B)
      <=> ( v5340(VarCurr,B)
          | v5369(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_55,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5369(VarCurr,B)
      <=> ( v5370(VarCurr,B)
          & v5255(VarCurr,B) ) ) ) ).

tff(addAssignment_2146,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,0)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2145,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,1)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2144,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,2)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2143,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,3)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2142,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,4)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2141,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,5)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2140,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,6)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2139,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,7)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2138,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,8)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2137,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,9)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2136,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,10)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2135,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,11)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2134,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,12)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2133,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,13)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2132,axiom,
    ! [VarCurr: state_type] :
      ( v5370(VarCurr,14)
    <=> v5371(VarCurr) ) ).

tff(addAssignment_2131,axiom,
    ! [VarCurr: state_type] :
      ( v5371(VarCurr)
    <=> v5372(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_50,axiom,
    ! [VarCurr: state_type] :
      ( v5372(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_227,axiom,
    ~ b00110(4) ).

tff(bitBlastConstant_226,axiom,
    ~ b00110(3) ).

tff(bitBlastConstant_225,axiom,
    b00110(2) ).

tff(bitBlastConstant_224,axiom,
    b00110(1) ).

tff(bitBlastConstant_223,axiom,
    ~ b00110(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_54,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5340(VarCurr,B)
      <=> ( v5341(VarCurr,B)
          | v5365(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_53,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5365(VarCurr,B)
      <=> ( v5366(VarCurr,B)
          & v5248(VarCurr,B) ) ) ) ).

tff(addAssignment_2130,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,0)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2129,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,1)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2128,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,2)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2127,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,3)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2126,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,4)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2125,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,5)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2124,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,6)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2123,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,7)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2122,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,8)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2121,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,9)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2120,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,10)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2119,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,11)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2118,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,12)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2117,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,13)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2116,axiom,
    ! [VarCurr: state_type] :
      ( v5366(VarCurr,14)
    <=> v5367(VarCurr) ) ).

tff(addAssignment_2115,axiom,
    ! [VarCurr: state_type] :
      ( v5367(VarCurr)
    <=> v5368(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_49,axiom,
    ! [VarCurr: state_type] :
      ( v5368(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_222,axiom,
    ~ b00101(4) ).

tff(bitBlastConstant_221,axiom,
    ~ b00101(3) ).

tff(bitBlastConstant_220,axiom,
    b00101(2) ).

tff(bitBlastConstant_219,axiom,
    ~ b00101(1) ).

tff(bitBlastConstant_218,axiom,
    b00101(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_52,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5341(VarCurr,B)
      <=> ( v5342(VarCurr,B)
          | v5361(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_51,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5361(VarCurr,B)
      <=> ( v5362(VarCurr,B)
          & v5241(VarCurr,B) ) ) ) ).

tff(addAssignment_2114,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,0)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2113,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,1)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2112,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,2)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2111,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,3)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2110,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,4)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2109,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,5)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2108,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,6)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2107,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,7)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2106,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,8)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2105,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,9)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2104,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,10)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2103,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,11)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2102,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,12)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2101,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,13)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2100,axiom,
    ! [VarCurr: state_type] :
      ( v5362(VarCurr,14)
    <=> v5363(VarCurr) ) ).

tff(addAssignment_2099,axiom,
    ! [VarCurr: state_type] :
      ( v5363(VarCurr)
    <=> v5364(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_48,axiom,
    ! [VarCurr: state_type] :
      ( v5364(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $true )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_217,axiom,
    ~ b00100(4) ).

tff(bitBlastConstant_216,axiom,
    ~ b00100(3) ).

tff(bitBlastConstant_215,axiom,
    b00100(2) ).

tff(bitBlastConstant_214,axiom,
    ~ b00100(1) ).

tff(bitBlastConstant_213,axiom,
    ~ b00100(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_50,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5342(VarCurr,B)
      <=> ( v5343(VarCurr,B)
          | v5357(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_49,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5357(VarCurr,B)
      <=> ( v5358(VarCurr,B)
          & v5234(VarCurr,B) ) ) ) ).

tff(addAssignment_2098,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,0)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2097,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,1)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2096,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,2)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2095,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,3)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2094,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,4)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2093,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,5)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2092,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,6)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2091,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,7)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2090,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,8)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2089,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,9)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2088,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,10)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2087,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,11)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2086,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,12)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2085,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,13)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2084,axiom,
    ! [VarCurr: state_type] :
      ( v5358(VarCurr,14)
    <=> v5359(VarCurr) ) ).

tff(addAssignment_2083,axiom,
    ! [VarCurr: state_type] :
      ( v5359(VarCurr)
    <=> v5360(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_47,axiom,
    ! [VarCurr: state_type] :
      ( v5360(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_212,axiom,
    ~ b00011(4) ).

tff(bitBlastConstant_211,axiom,
    ~ b00011(3) ).

tff(bitBlastConstant_210,axiom,
    ~ b00011(2) ).

tff(bitBlastConstant_209,axiom,
    b00011(1) ).

tff(bitBlastConstant_208,axiom,
    b00011(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_48,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5343(VarCurr,B)
      <=> ( v5344(VarCurr,B)
          | v5353(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_47,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5353(VarCurr,B)
      <=> ( v5354(VarCurr,B)
          & v5227(VarCurr,B) ) ) ) ).

tff(addAssignment_2082,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,0)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2081,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,1)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2080,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,2)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2079,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,3)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2078,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,4)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2077,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,5)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2076,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,6)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2075,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,7)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2074,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,8)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2073,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,9)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2072,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,10)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2071,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,11)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2070,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,12)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2069,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,13)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2068,axiom,
    ! [VarCurr: state_type] :
      ( v5354(VarCurr,14)
    <=> v5355(VarCurr) ) ).

tff(addAssignment_2067,axiom,
    ! [VarCurr: state_type] :
      ( v5355(VarCurr)
    <=> v5356(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_46,axiom,
    ! [VarCurr: state_type] :
      ( v5356(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $true )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_207,axiom,
    ~ b00010(4) ).

tff(bitBlastConstant_206,axiom,
    ~ b00010(3) ).

tff(bitBlastConstant_205,axiom,
    ~ b00010(2) ).

tff(bitBlastConstant_204,axiom,
    b00010(1) ).

tff(bitBlastConstant_203,axiom,
    ~ b00010(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_46,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5344(VarCurr,B)
      <=> ( v5345(VarCurr,B)
          | v5349(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_45,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5349(VarCurr,B)
      <=> ( v5350(VarCurr,B)
          & v5220(VarCurr,B) ) ) ) ).

tff(addAssignment_2066,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,0)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2065,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,1)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2064,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,2)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2063,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,3)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2062,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,4)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2061,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,5)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2060,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,6)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2059,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,7)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2058,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,8)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2057,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,9)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2056,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,10)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2055,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,11)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2054,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,12)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2053,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,13)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2052,axiom,
    ! [VarCurr: state_type] :
      ( v5350(VarCurr,14)
    <=> v5351(VarCurr) ) ).

tff(addAssignment_2051,axiom,
    ! [VarCurr: state_type] :
      ( v5351(VarCurr)
    <=> v5352(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_45,axiom,
    ! [VarCurr: state_type] :
      ( v5352(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_202,axiom,
    ~ b00001(4) ).

tff(bitBlastConstant_201,axiom,
    ~ b00001(3) ).

tff(bitBlastConstant_200,axiom,
    ~ b00001(2) ).

tff(bitBlastConstant_199,axiom,
    ~ b00001(1) ).

tff(bitBlastConstant_198,axiom,
    b00001(0) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_44,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,15)
        & ~ $less(B,0) )
     => ( v5345(VarCurr,B)
      <=> ( v5346(VarCurr,B)
          & v884(VarCurr,B) ) ) ) ).

tff(addAssignment_2050,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,0)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2049,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,1)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2048,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,2)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2047,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,3)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2046,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,4)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2045,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,5)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2044,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,6)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2043,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,7)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2042,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,8)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2041,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,9)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2040,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,10)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2039,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,11)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2038,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,12)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2037,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,13)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2036,axiom,
    ! [VarCurr: state_type] :
      ( v5346(VarCurr,14)
    <=> v5347(VarCurr) ) ).

tff(addAssignment_2035,axiom,
    ! [VarCurr: state_type] :
      ( v5347(VarCurr)
    <=> v5348(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_44,axiom,
    ! [VarCurr: state_type] :
      ( v5348(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $false )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_2034,axiom,
    ! [VarCurr: state_type] :
      ( v5324(VarCurr,0)
    <=> v5326(VarCurr,0) ) ).

tff(addAssignment_2033,axiom,
    ! [VarCurr: state_type] :
      ( v5326(VarCurr,0)
    <=> v5328(VarCurr,0) ) ).

tff(addAssignment_2032,axiom,
    ! [VarCurr: state_type] :
      ( v5318(VarCurr,0)
    <=> v5320(VarCurr,0) ) ).

tff(addAssignment_2031,axiom,
    ! [VarCurr: state_type] :
      ( v5320(VarCurr,0)
    <=> v5322(VarCurr,0) ) ).

tff(addAssignment_2030,axiom,
    ! [VarCurr: state_type] :
      ( v5311(VarCurr,0)
    <=> v5313(VarCurr,0) ) ).

tff(addAssignment_2029,axiom,
    ! [VarCurr: state_type] :
      ( v5313(VarCurr,0)
    <=> v5315(VarCurr,0) ) ).

tff(addAssignment_2028,axiom,
    ! [VarCurr: state_type] :
      ( v5304(VarCurr,0)
    <=> v5306(VarCurr,0) ) ).

tff(addAssignment_2027,axiom,
    ! [VarCurr: state_type] :
      ( v5306(VarCurr,0)
    <=> v5308(VarCurr,0) ) ).

tff(addAssignment_2026,axiom,
    ! [VarCurr: state_type] :
      ( v5297(VarCurr,0)
    <=> v5299(VarCurr,0) ) ).

tff(addAssignment_2025,axiom,
    ! [VarCurr: state_type] :
      ( v5299(VarCurr,0)
    <=> v5301(VarCurr,0) ) ).

tff(addAssignment_2024,axiom,
    ! [VarCurr: state_type] :
      ( v5290(VarCurr,0)
    <=> v5292(VarCurr,0) ) ).

tff(addAssignment_2023,axiom,
    ! [VarCurr: state_type] :
      ( v5292(VarCurr,0)
    <=> v5294(VarCurr,0) ) ).

tff(addAssignment_2022,axiom,
    ! [VarCurr: state_type] :
      ( v5283(VarCurr,0)
    <=> v5285(VarCurr,0) ) ).

tff(addAssignment_2021,axiom,
    ! [VarCurr: state_type] :
      ( v5285(VarCurr,0)
    <=> v5287(VarCurr,0) ) ).

tff(addAssignment_2020,axiom,
    ! [VarCurr: state_type] :
      ( v5276(VarCurr,0)
    <=> v5278(VarCurr,0) ) ).

tff(addAssignment_2019,axiom,
    ! [VarCurr: state_type] :
      ( v5278(VarCurr,0)
    <=> v5280(VarCurr,0) ) ).

tff(addAssignment_2018,axiom,
    ! [VarCurr: state_type] :
      ( v5269(VarCurr,0)
    <=> v5271(VarCurr,0) ) ).

tff(addAssignment_2017,axiom,
    ! [VarCurr: state_type] :
      ( v5271(VarCurr,0)
    <=> v5273(VarCurr,0) ) ).

tff(addAssignment_2016,axiom,
    ! [VarCurr: state_type] :
      ( v5262(VarCurr,0)
    <=> v5264(VarCurr,0) ) ).

tff(addAssignment_2015,axiom,
    ! [VarCurr: state_type] :
      ( v5264(VarCurr,0)
    <=> v5266(VarCurr,0) ) ).

tff(addAssignment_2014,axiom,
    ! [VarCurr: state_type] :
      ( v5255(VarCurr,0)
    <=> v5257(VarCurr,0) ) ).

tff(addAssignment_2013,axiom,
    ! [VarCurr: state_type] :
      ( v5257(VarCurr,0)
    <=> v5259(VarCurr,0) ) ).

tff(addAssignment_2012,axiom,
    ! [VarCurr: state_type] :
      ( v5248(VarCurr,0)
    <=> v5250(VarCurr,0) ) ).

tff(addAssignment_2011,axiom,
    ! [VarCurr: state_type] :
      ( v5250(VarCurr,0)
    <=> v5252(VarCurr,0) ) ).

tff(addAssignment_2010,axiom,
    ! [VarCurr: state_type] :
      ( v5241(VarCurr,0)
    <=> v5243(VarCurr,0) ) ).

tff(addAssignment_2009,axiom,
    ! [VarCurr: state_type] :
      ( v5243(VarCurr,0)
    <=> v5245(VarCurr,0) ) ).

tff(addAssignment_2008,axiom,
    ! [VarCurr: state_type] :
      ( v5234(VarCurr,0)
    <=> v5236(VarCurr,0) ) ).

tff(addAssignment_2007,axiom,
    ! [VarCurr: state_type] :
      ( v5236(VarCurr,0)
    <=> v5238(VarCurr,0) ) ).

tff(addAssignment_2006,axiom,
    ! [VarCurr: state_type] :
      ( v5227(VarCurr,0)
    <=> v5229(VarCurr,0) ) ).

tff(addAssignment_2005,axiom,
    ! [VarCurr: state_type] :
      ( v5229(VarCurr,0)
    <=> v5231(VarCurr,0) ) ).

tff(addAssignment_2004,axiom,
    ! [VarCurr: state_type] :
      ( v5220(VarCurr,0)
    <=> v5222(VarCurr,0) ) ).

tff(addAssignment_2003,axiom,
    ! [VarCurr: state_type] :
      ( v5222(VarCurr,0)
    <=> v5224(VarCurr,0) ) ).

tff(addAssignment_2002,axiom,
    ! [VarCurr: state_type] :
      ( v884(VarCurr,0)
    <=> v886(VarCurr,0) ) ).

tff(addAssignment_2001,axiom,
    ! [VarCurr: state_type] :
      ( v886(VarCurr,0)
    <=> v888(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_576,axiom,
    ! [VarCurr: state_type] :
      ( v5187(VarCurr)
    <=> ( v5208(VarCurr)
        & v5189(VarCurr) ) ) ).

tff(writeUnaryOperator_426,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5208(VarCurr)
    <=> v5165(VarCurr,0) ) ).

tff(addAssignment_2000,axiom,
    ! [VarCurr: state_type] :
      ( v5189(VarCurr)
    <=> v2944(VarCurr,4) ) ).

tff(addAssignment_1999,axiom,
    ! [VarCurr: state_type] :
      ( v2944(VarCurr,4)
    <=> v2946(VarCurr,4) ) ).

tff(addAssignment_1998,axiom,
    ! [VarNext: state_type] :
      ( v2946(VarNext,4)
    <=> v5200(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_70,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5201(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v5200(VarNext,B)
            <=> v2946(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_70,axiom,
    ! [VarNext: state_type] :
      ( v5201(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v5200(VarNext,B)
          <=> v3911(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5201(VarNext)
      <=> v5202(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_574,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5202(VarNext)
      <=> ( v5204(VarNext)
          & v3894(VarNext) ) ) ) ).

tff(writeUnaryOperator_425,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5204(VarNext)
      <=> v3905(VarNext) ) ) ).

tff(addAssignment_1997,axiom,
    ! [VarCurr: state_type] :
      ( v2956(VarCurr,4)
    <=> v2958(VarCurr,4) ) ).

tff(addAssignment_1996,axiom,
    ! [VarCurr: state_type] :
      ( v2958(VarCurr,4)
    <=> v2960(VarCurr,4) ) ).

tff(addAssignment_1995,axiom,
    ! [VarCurr: state_type] :
      ( v2960(VarCurr,4)
    <=> v3890(VarCurr,4) ) ).

tff(addAssignment_1994,axiom,
    ! [VarCurr: state_type] :
      ( v3891(VarCurr)
    <=> v5192(VarCurr) ) ).

tff(addAssignment_1993,axiom,
    ! [VarCurr: state_type] :
      ( v5192(VarCurr)
    <=> v5194(VarCurr) ) ).

tff(addAssignment_1992,axiom,
    ! [VarCurr: state_type] :
      ( v5194(VarCurr)
    <=> v5196(VarCurr) ) ).

tff(addAssignment_1991,axiom,
    ! [VarCurr: state_type] :
      ( v5196(VarCurr)
    <=> v5198(VarCurr) ) ).

tff(addAssignment_1990,axiom,
    ! [VarCurr: state_type] :
      ( v5198(VarCurr)
    <=> v2972(VarCurr,0) ) ).

tff(addAssignment_1989,axiom,
    ! [VarCurr: state_type] :
      ( v2972(VarCurr,0)
    <=> v2974(VarCurr,0) ) ).

tff(addAssignment_1988,axiom,
    ! [VarCurr: state_type] :
      ( v5175(VarCurr)
    <=> v5177(VarCurr) ) ).

tff(addAssignment_1987,axiom,
    ! [VarCurr: state_type] :
      ( v5177(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_1986,axiom,
    ! [VarCurr: state_type] :
      ( v5171(VarCurr)
    <=> v5173(VarCurr) ) ).

tff(addAssignment_1985,axiom,
    ! [VarCurr: state_type] :
      ( v5173(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(writeUnaryOperator_424,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5152(VarCurr)
    <=> v5154(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_123,axiom,
    ! [VarCurr: state_type] :
      ( v5154(VarCurr)
    <=> ( v5156(VarCurr)
        | v2910(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_122,axiom,
    ! [VarCurr: state_type] :
      ( v5156(VarCurr)
    <=> ( v5157(VarCurr)
        | v2910(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_121,axiom,
    ! [VarCurr: state_type] :
      ( v5157(VarCurr)
    <=> ( v5158(VarCurr)
        | v2910(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_120,axiom,
    ! [VarCurr: state_type] :
      ( v5158(VarCurr)
    <=> ( v5159(VarCurr)
        | v2910(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_119,axiom,
    ! [VarCurr: state_type] :
      ( v5159(VarCurr)
    <=> ( v5160(VarCurr)
        | v2910(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_118,axiom,
    ! [VarCurr: state_type] :
      ( v5160(VarCurr)
    <=> ( v5161(VarCurr)
        | v2910(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_117,axiom,
    ! [VarCurr: state_type] :
      ( v5161(VarCurr)
    <=> ( v2910(VarCurr,0)
        | v2910(VarCurr,1) ) ) ).

tff(addAssignment_1984,axiom,
    ! [VarCurr: state_type] :
      ( v5128(VarCurr)
    <=> v5130(VarCurr) ) ).

tff(addAssignment_1983,axiom,
    ! [VarCurr: state_type] :
      ( v5130(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1982,axiom,
    ! [VarCurr: state_type] :
      ( v5124(VarCurr)
    <=> v5126(VarCurr) ) ).

tff(addAssignment_1981,axiom,
    ! [VarCurr: state_type] :
      ( v5126(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1980,axiom,
    ! [VarCurr: state_type] :
      ( v5051(VarCurr)
    <=> v5053(VarCurr,6) ) ).

tff(addAssignment_1979,axiom,
    ! [VarCurr: state_type] :
      ( v5053(VarCurr,6)
    <=> v5116(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_43,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5116(VarCurr,B)
      <=> ( v5055(VarCurr,B)
        <~> b0101010(B) ) ) ) ).

tff(addAssignment_1978,axiom,
    ! [VarCurr: state_type] :
      ( v5055(VarCurr,6)
    <=> v5057(VarCurr,6) ) ).

tff(addAssignment_1977,axiom,
    ! [VarCurr: state_type] :
      ( v5057(VarCurr,6)
    <=> v5059(VarCurr,6) ) ).

tff(addAssignment_1976,axiom,
    ! [VarNext: state_type] :
      ( v5059(VarNext,6)
    <=> v5099(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_69,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5100(VarNext)
       => ! [B: $int] :
            ( ( $less(B,7)
              & ~ $less(B,0) )
           => ( v5099(VarNext,B)
            <=> v5059(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_69,axiom,
    ! [VarNext: state_type] :
      ( v5100(VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v5099(VarNext,B)
          <=> v5110(VarNext,B) ) ) ) ).

tff(addAssignment_1975,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v5110(VarNext,B)
          <=> v5108(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_74,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5111(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v5108(VarCurr,B)
          <=> bxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_74,axiom,
    ! [VarCurr: state_type] :
      ( v5111(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,7)
            & ~ $less(B,0) )
         => ( v5108(VarCurr,B)
          <=> v5069(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_573,axiom,
    ! [VarCurr: state_type] :
      ( v5111(VarCurr)
    <=> ( v5112(VarCurr)
        & v5113(VarCurr) ) ) ).

tff(writeUnaryOperator_423,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5113(VarCurr)
    <=> v5065(VarCurr) ) ).

tff(writeUnaryOperator_422,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5112(VarCurr)
    <=> v5061(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_572,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5100(VarNext)
      <=> v5101(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_571,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5101(VarNext)
      <=> ( v5102(VarNext)
          & v5095(VarNext) ) ) ) ).

tff(writeUnaryOperator_421,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5102(VarNext)
      <=> v5104(VarNext) ) ) ).

tff(addAssignment_1974,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5104(VarNext)
      <=> v5095(VarCurr) ) ) ).

tff(addAssignment_1973,axiom,
    ! [VarCurr: state_type] :
      ( v5095(VarCurr)
    <=> v5097(VarCurr) ) ).

tff(addAssignment_1972,axiom,
    ! [VarCurr: state_type] :
      ( v5097(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1971,axiom,
    ! [VarCurr: state_type] :
      ( v5069(VarCurr,6)
    <=> v5071(VarCurr,6) ) ).

tff(addAssignment_1970,axiom,
    ! [VarCurr: state_type] :
      ( v5071(VarCurr,6)
    <=> v5085(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_42,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5085(VarCurr,B)
      <=> ( v5086(VarCurr,B)
          | v5089(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_41,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5089(VarCurr,B)
      <=> ( v5057(VarCurr,B)
          & v5090(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_420,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5090(VarCurr,B)
      <=> ~ v5091(VarCurr,B) ) ) ).

tff(addAssignment_1969,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,0)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1968,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,1)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1967,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,2)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1966,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,3)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1965,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,4)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1964,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,5)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1963,axiom,
    ! [VarCurr: state_type] :
      ( v5091(VarCurr,6)
    <=> v5092(VarCurr) ) ).

tff(addAssignment_1962,axiom,
    ! [VarCurr: state_type] :
      ( v5092(VarCurr)
    <=> v5079(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_40,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5086(VarCurr,B)
      <=> ( v5073(VarCurr,B)
          & v5087(VarCurr,B) ) ) ) ).

tff(addAssignment_1961,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,0)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1960,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,1)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1959,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,2)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1958,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,3)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1957,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,4)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1956,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,5)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1955,axiom,
    ! [VarCurr: state_type] :
      ( v5087(VarCurr,6)
    <=> v5088(VarCurr) ) ).

tff(addAssignment_1954,axiom,
    ! [VarCurr: state_type] :
      ( v5088(VarCurr)
    <=> v5079(VarCurr) ) ).

tff(addAssignment_1953,axiom,
    ! [VarCurr: state_type] :
      ( v5079(VarCurr)
    <=> v5081(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_570,axiom,
    ! [VarCurr: state_type] :
      ( v5081(VarCurr)
    <=> ( v2354(VarCurr)
        & v5084(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_43,axiom,
    ! [VarCurr: state_type] :
      ( v5084(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_197,axiom,
    ~ b0100010101000(12) ).

tff(bitBlastConstant_196,axiom,
    b0100010101000(11) ).

tff(bitBlastConstant_195,axiom,
    ~ b0100010101000(10) ).

tff(bitBlastConstant_194,axiom,
    ~ b0100010101000(9) ).

tff(bitBlastConstant_193,axiom,
    ~ b0100010101000(8) ).

tff(bitBlastConstant_192,axiom,
    b0100010101000(7) ).

tff(bitBlastConstant_191,axiom,
    ~ b0100010101000(6) ).

tff(bitBlastConstant_190,axiom,
    b0100010101000(5) ).

tff(bitBlastConstant_189,axiom,
    ~ b0100010101000(4) ).

tff(bitBlastConstant_188,axiom,
    b0100010101000(3) ).

tff(bitBlastConstant_187,axiom,
    ~ b0100010101000(2) ).

tff(bitBlastConstant_186,axiom,
    ~ b0100010101000(1) ).

tff(bitBlastConstant_185,axiom,
    ~ b0100010101000(0) ).

tff(addAssignment_1952,axiom,
    ! [VarCurr: state_type] :
      ( v5073(VarCurr,6)
    <=> v5075(VarCurr,6) ) ).

tff(addAssignment_1951,axiom,
    ! [VarCurr: state_type] :
      ( v5075(VarCurr,6)
    <=> v5077(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_39,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,7)
        & ~ $less(B,0) )
     => ( v5077(VarCurr,B)
      <=> ( v2363(VarCurr,B)
        <~> b0101010(B) ) ) ) ).

tff(bitBlastConstant_184,axiom,
    ~ b0101010(6) ).

tff(bitBlastConstant_183,axiom,
    b0101010(5) ).

tff(bitBlastConstant_182,axiom,
    ~ b0101010(4) ).

tff(bitBlastConstant_181,axiom,
    b0101010(3) ).

tff(bitBlastConstant_180,axiom,
    ~ b0101010(2) ).

tff(bitBlastConstant_179,axiom,
    b0101010(1) ).

tff(bitBlastConstant_178,axiom,
    ~ b0101010(0) ).

tff(addAssignment_1950,axiom,
    ! [VarCurr: state_type] :
      ( v5065(VarCurr)
    <=> v5067(VarCurr) ) ).

tff(addAssignment_1949,axiom,
    ! [VarCurr: state_type] :
      ( v5067(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1948,axiom,
    ! [VarCurr: state_type] :
      ( v5061(VarCurr)
    <=> v5063(VarCurr) ) ).

tff(addAssignment_1947,axiom,
    ! [VarCurr: state_type] :
      ( v5063(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_42,axiom,
    ! [VarCurr: state_type] :
      ( v5040(VarCurr)
    <=> ( ( v4534(VarCurr,5)
        <=> $false )
        & ( v4534(VarCurr,4)
        <=> $false )
        & ( v4534(VarCurr,3)
        <=> $false )
        & ( v4534(VarCurr,2)
        <=> $false )
        & ( v4534(VarCurr,1)
        <=> $false )
        & ( v4534(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_1946,axiom,
    ! [VarCurr: state_type] :
      ( v4568(VarCurr)
    <=> v4570(VarCurr) ) ).

tff(addAssignment_1945,axiom,
    ! [VarCurr: state_type] :
      ( v4570(VarCurr)
    <=> v4572(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_569,axiom,
    ! [VarCurr: state_type] :
      ( v4572(VarCurr)
    <=> ( v4574(VarCurr)
        | v5037(VarCurr) ) ) ).

tff(addAssignment_1944,axiom,
    ! [VarCurr: state_type] :
      ( v5037(VarCurr)
    <=> v4386(VarCurr) ) ).

tff(addAssignment_1943,axiom,
    ! [VarCurr: state_type] :
      ( v4574(VarCurr)
    <=> v4576(VarCurr) ) ).

tff(addAssignment_1942,axiom,
    ! [VarCurr: state_type] :
      ( v4576(VarCurr)
    <=> v4578(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_68,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5020(VarNext)
       => ( v4578(VarNext)
        <=> v4578(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_68,axiom,
    ! [VarNext: state_type] :
      ( v5020(VarNext)
     => ( v4578(VarNext)
      <=> v5030(VarNext) ) ) ).

tff(addAssignment_1941,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5030(VarNext)
      <=> v5028(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_73,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5031(VarCurr)
     => ( v5028(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_73,axiom,
    ! [VarCurr: state_type] :
      ( v5031(VarCurr)
     => ( v5028(VarCurr)
      <=> v4588(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_568,axiom,
    ! [VarCurr: state_type] :
      ( v5031(VarCurr)
    <=> ( v5032(VarCurr)
        & v5033(VarCurr) ) ) ).

tff(writeUnaryOperator_419,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5033(VarCurr)
    <=> v4584(VarCurr) ) ).

tff(writeUnaryOperator_418,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5032(VarCurr)
    <=> v4580(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_567,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5020(VarNext)
      <=> v5021(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5021(VarNext)
      <=> ( v5022(VarNext)
          & v5015(VarNext) ) ) ) ).

tff(writeUnaryOperator_417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v5022(VarNext)
      <=> v5024(VarNext) ) ) ).

tff(addAssignment_1940,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v5024(VarNext)
      <=> v5015(VarCurr) ) ) ).

tff(addAssignment_1939,axiom,
    ! [VarCurr: state_type] :
      ( v5015(VarCurr)
    <=> v5017(VarCurr) ) ).

tff(addAssignment_1938,axiom,
    ! [VarCurr: state_type] :
      ( v5017(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1937,axiom,
    ! [VarCurr: state_type] :
      ( v4588(VarCurr)
    <=> v4590(VarCurr) ) ).

tff(addAssignment_1936,axiom,
    ! [VarCurr: state_type] :
      ( v4590(VarCurr)
    <=> v4592(VarCurr) ) ).

tff(addAssignment_1935,axiom,
    ! [VarCurr: state_type] :
      ( v4592(VarCurr)
    <=> v4594(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_565,axiom,
    ! [VarCurr: state_type] :
      ( v4594(VarCurr)
    <=> ( v5010(VarCurr)
        & v5013(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_41,axiom,
    ! [VarCurr: state_type] :
      ( v5013(VarCurr)
    <=> ( ( v4941(VarCurr,2)
        <=> $false )
        & ( v4941(VarCurr,1)
        <=> $false )
        & ( v4941(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_564,axiom,
    ! [VarCurr: state_type] :
      ( v5010(VarCurr)
    <=> ( v5011(VarCurr)
        & v5012(VarCurr) ) ) ).

tff(writeUnaryOperator_416,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5012(VarCurr)
    <=> v4596(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_40,axiom,
    ! [VarCurr: state_type] :
      ( v5011(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true ) ) ) ).

tff(addAssignment_1934,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4941(VarCurr,B)
      <=> v4943(VarCurr,B) ) ) ).

tff(addAssignment_1933,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4943(VarCurr,B)
      <=> v4945(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_67,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4993(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v4945(VarNext,B)
            <=> v4945(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_67,axiom,
    ! [VarNext: state_type] :
      ( v4993(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4945(VarNext,B)
          <=> v5003(VarNext,B) ) ) ) ).

tff(addAssignment_1932,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v5003(VarNext,B)
          <=> v5001(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_72,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v5001(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_72,axiom,
    ! [VarCurr: state_type] :
      ( v5004(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v5001(VarCurr,B)
          <=> v4955(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_563,axiom,
    ! [VarCurr: state_type] :
      ( v5004(VarCurr)
    <=> ( v5005(VarCurr)
        & v5006(VarCurr) ) ) ).

tff(writeUnaryOperator_415,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5006(VarCurr)
    <=> v4951(VarCurr) ) ).

tff(writeUnaryOperator_414,axiom,
    ! [VarCurr: state_type] :
      ( ~ v5005(VarCurr)
    <=> v4947(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_562,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4993(VarNext)
      <=> v4994(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4994(VarNext)
      <=> ( v4995(VarNext)
          & v4988(VarNext) ) ) ) ).

tff(writeUnaryOperator_413,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4995(VarNext)
      <=> v4997(VarNext) ) ) ).

tff(addAssignment_1931,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4997(VarNext)
      <=> v4988(VarCurr) ) ) ).

tff(addAssignment_1930,axiom,
    ! [VarCurr: state_type] :
      ( v4988(VarCurr)
    <=> v4990(VarCurr) ) ).

tff(addAssignment_1929,axiom,
    ! [VarCurr: state_type] :
      ( v4990(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1928,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4955(VarCurr,B)
      <=> v4957(VarCurr,B) ) ) ).

tff(addAssignment_1927,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4957(VarCurr,B)
      <=> v4959(VarCurr,B) ) ) ).

tff(addAssignment_1926,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4959(VarCurr,B)
      <=> v4961(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_71,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4963(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4961(VarCurr,B)
          <=> v4964(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_71,axiom,
    ! [VarCurr: state_type] :
      ( v4963(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4961(VarCurr,B)
          <=> $true ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_70,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4964(VarCurr,B)
          <=> v4941(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_70,axiom,
    ! [VarCurr: state_type] :
      ( v4965(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4964(VarCurr,B)
          <=> v4976(VarCurr,B) ) ) ) ).

tff(addAssignment_1925,axiom,
    ! [VarCurr: state_type] :
      ( v4976(VarCurr,0)
    <=> v4973(VarCurr) ) ).

tff(addAssignment_1924,axiom,
    ! [VarCurr: state_type] :
      ( v4976(VarCurr,1)
    <=> v4984(VarCurr) ) ).

tff(addAssignment_1923,axiom,
    ! [VarCurr: state_type] :
      ( v4976(VarCurr,2)
    <=> v4978(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_560,axiom,
    ! [VarCurr: state_type] :
      ( v4984(VarCurr)
    <=> ( v4985(VarCurr)
        & v4986(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_559,axiom,
    ! [VarCurr: state_type] :
      ( v4986(VarCurr)
    <=> ( v4941(VarCurr,0)
        | v4974(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_116,axiom,
    ! [VarCurr: state_type] :
      ( v4985(VarCurr)
    <=> ( v4973(VarCurr)
        | v4941(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_558,axiom,
    ! [VarCurr: state_type] :
      ( v4978(VarCurr)
    <=> ( v4979(VarCurr)
        & v4983(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_557,axiom,
    ! [VarCurr: state_type] :
      ( v4983(VarCurr)
    <=> ( v4975(VarCurr)
        | v4981(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_115,axiom,
    ! [VarCurr: state_type] :
      ( v4979(VarCurr)
    <=> ( v4941(VarCurr,2)
        | v4980(VarCurr) ) ) ).

tff(writeUnaryOperator_412,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4980(VarCurr)
    <=> v4981(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_114,axiom,
    ! [VarCurr: state_type] :
      ( v4981(VarCurr)
    <=> ( v4941(VarCurr,1)
        | v4982(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_556,axiom,
    ! [VarCurr: state_type] :
      ( v4982(VarCurr)
    <=> ( v4941(VarCurr,0)
        & v4974(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_555,axiom,
    ! [VarCurr: state_type] :
      ( v4965(VarCurr)
    <=> ( v4966(VarCurr)
        & v4969(VarCurr) ) ) ).

tff(writeUnaryOperator_411,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4969(VarCurr)
    <=> v4971(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_554,axiom,
    ! [VarCurr: state_type] :
      ( v4971(VarCurr)
    <=> ( v4972(VarCurr)
        & v4975(VarCurr) ) ) ).

tff(writeUnaryOperator_410,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4975(VarCurr)
    <=> v4941(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_553,axiom,
    ! [VarCurr: state_type] :
      ( v4972(VarCurr)
    <=> ( v4973(VarCurr)
        & v4974(VarCurr) ) ) ).

tff(writeUnaryOperator_409,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4974(VarCurr)
    <=> v4941(VarCurr,1) ) ).

tff(writeUnaryOperator_408,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4973(VarCurr)
    <=> v4941(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_552,axiom,
    ! [VarCurr: state_type] :
      ( v4966(VarCurr)
    <=> ( v4967(VarCurr)
        & v4968(VarCurr) ) ) ).

tff(writeUnaryOperator_407,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4968(VarCurr)
    <=> v4596(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_39,axiom,
    ! [VarCurr: state_type] :
      ( v4967(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true ) ) ) ).

tff(bitBlastConstant_177,axiom,
    b11(1) ).

tff(bitBlastConstant_176,axiom,
    b11(0) ).

tff(addBitVectorEqualityBitBlasted_38,axiom,
    ! [VarCurr: state_type] :
      ( v4963(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_1922,axiom,
    ! [VarCurr: state_type] :
      ( v4951(VarCurr)
    <=> v4953(VarCurr) ) ).

tff(addAssignment_1921,axiom,
    ! [VarCurr: state_type] :
      ( v4953(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1920,axiom,
    ! [VarCurr: state_type] :
      ( v4947(VarCurr)
    <=> v4949(VarCurr) ) ).

tff(addAssignment_1919,axiom,
    ! [VarCurr: state_type] :
      ( v4949(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_551,axiom,
    ! [VarCurr: state_type] :
      ( v4596(VarCurr)
    <=> ( v4936(VarCurr)
        | v4938(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_113,axiom,
    ! [VarCurr: state_type] :
      ( v4938(VarCurr)
    <=> ( v4902(VarCurr)
        | v4867(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_112,axiom,
    ! [VarCurr: state_type] :
      ( v4936(VarCurr)
    <=> ( v4598(VarCurr,5)
        & v4937(VarCurr) ) ) ).

tff(writeUnaryOperator_406,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4937(VarCurr)
    <=> v4609(VarCurr) ) ).

tff(addAssignment_1918,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4867(VarCurr,B)
      <=> v4869(VarCurr,B) ) ) ).

tff(addAssignment_1917,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4869(VarCurr,B)
      <=> v4871(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_66,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4919(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v4871(VarNext,B)
            <=> v4871(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_66,axiom,
    ! [VarNext: state_type] :
      ( v4919(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4871(VarNext,B)
          <=> v4929(VarNext,B) ) ) ) ).

tff(addAssignment_1916,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4929(VarNext,B)
          <=> v4927(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_69,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4930(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4927(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_69,axiom,
    ! [VarCurr: state_type] :
      ( v4930(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4927(VarCurr,B)
          <=> v4881(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_550,axiom,
    ! [VarCurr: state_type] :
      ( v4930(VarCurr)
    <=> ( v4931(VarCurr)
        & v4932(VarCurr) ) ) ).

tff(writeUnaryOperator_405,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4932(VarCurr)
    <=> v4877(VarCurr) ) ).

tff(writeUnaryOperator_404,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4931(VarCurr)
    <=> v4873(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_549,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4919(VarNext)
      <=> v4920(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_548,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4920(VarNext)
      <=> ( v4921(VarNext)
          & v4914(VarNext) ) ) ) ).

tff(writeUnaryOperator_403,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4921(VarNext)
      <=> v4923(VarNext) ) ) ).

tff(addAssignment_1915,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4923(VarNext)
      <=> v4914(VarCurr) ) ) ).

tff(addAssignment_1914,axiom,
    ! [VarCurr: state_type] :
      ( v4914(VarCurr)
    <=> v4916(VarCurr) ) ).

tff(addAssignment_1913,axiom,
    ! [VarCurr: state_type] :
      ( v4916(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1912,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4881(VarCurr,B)
      <=> v4883(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_38,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4883(VarCurr,B)
      <=> ( v4906(VarCurr,B)
          | v4909(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_37,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4909(VarCurr,B)
      <=> ( v4869(VarCurr,B)
          & v4910(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_402,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4910(VarCurr,B)
      <=> ~ v4911(VarCurr,B) ) ) ).

tff(addAssignment_1911,axiom,
    ! [VarCurr: state_type] :
      ( v4911(VarCurr,0)
    <=> v4912(VarCurr) ) ).

tff(addAssignment_1910,axiom,
    ! [VarCurr: state_type] :
      ( v4911(VarCurr,1)
    <=> v4912(VarCurr) ) ).

tff(addAssignment_1909,axiom,
    ! [VarCurr: state_type] :
      ( v4911(VarCurr,2)
    <=> v4912(VarCurr) ) ).

tff(addAssignment_1908,axiom,
    ! [VarCurr: state_type] :
      ( v4912(VarCurr)
    <=> v4904(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_36,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4906(VarCurr,B)
      <=> ( v4885(VarCurr,B)
          & v4907(VarCurr,B) ) ) ) ).

tff(addAssignment_1907,axiom,
    ! [VarCurr: state_type] :
      ( v4907(VarCurr,0)
    <=> v4908(VarCurr) ) ).

tff(addAssignment_1906,axiom,
    ! [VarCurr: state_type] :
      ( v4907(VarCurr,1)
    <=> v4908(VarCurr) ) ).

tff(addAssignment_1905,axiom,
    ! [VarCurr: state_type] :
      ( v4907(VarCurr,2)
    <=> v4908(VarCurr) ) ).

tff(addAssignment_1904,axiom,
    ! [VarCurr: state_type] :
      ( v4908(VarCurr)
    <=> v4904(VarCurr) ) ).

tff(addAssignment_1903,axiom,
    ! [VarCurr: state_type] :
      ( v4904(VarCurr)
    <=> v4596(VarCurr) ) ).

tff(addAssignment_1902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4885(VarCurr,B)
      <=> v4887(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_68,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4889(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4887(VarCurr,B)
          <=> v4890(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_68,axiom,
    ! [VarCurr: state_type] :
      ( v4889(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4887(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_1901,axiom,
    ! [VarCurr: state_type] :
      ( v4890(VarCurr,0)
    <=> v4900(VarCurr) ) ).

tff(addAssignment_1900,axiom,
    ! [VarCurr: state_type] :
      ( v4890(VarCurr,1)
    <=> v4898(VarCurr) ) ).

tff(addAssignment_1899,axiom,
    ! [VarCurr: state_type] :
      ( v4890(VarCurr,2)
    <=> v4892(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_547,axiom,
    ! [VarCurr: state_type] :
      ( v4898(VarCurr)
    <=> ( v4899(VarCurr)
        & v4902(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_111,axiom,
    ! [VarCurr: state_type] :
      ( v4902(VarCurr)
    <=> ( v4867(VarCurr,0)
        | v4867(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_546,axiom,
    ! [VarCurr: state_type] :
      ( v4899(VarCurr)
    <=> ( v4900(VarCurr)
        | v4901(VarCurr) ) ) ).

tff(writeUnaryOperator_401,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4901(VarCurr)
    <=> v4867(VarCurr,1) ) ).

tff(writeUnaryOperator_400,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4900(VarCurr)
    <=> v4867(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_545,axiom,
    ! [VarCurr: state_type] :
      ( v4892(VarCurr)
    <=> ( v4893(VarCurr)
        & v4897(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_110,axiom,
    ! [VarCurr: state_type] :
      ( v4897(VarCurr)
    <=> ( v4895(VarCurr)
        | v4867(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_544,axiom,
    ! [VarCurr: state_type] :
      ( v4893(VarCurr)
    <=> ( v4894(VarCurr)
        | v4896(VarCurr) ) ) ).

tff(writeUnaryOperator_399,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4896(VarCurr)
    <=> v4867(VarCurr,2) ) ).

tff(writeUnaryOperator_398,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4894(VarCurr)
    <=> v4895(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_109,axiom,
    ! [VarCurr: state_type] :
      ( v4895(VarCurr)
    <=> ( v4867(VarCurr,0)
        & v4867(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_37,axiom,
    ! [VarCurr: state_type] :
      ( v4889(VarCurr)
    <=> ( ( v4867(VarCurr,2)
        <=> $true )
        & ( v4867(VarCurr,1)
        <=> $false )
        & ( v4867(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_1898,axiom,
    ! [VarCurr: state_type] :
      ( v4877(VarCurr)
    <=> v4879(VarCurr) ) ).

tff(addAssignment_1897,axiom,
    ! [VarCurr: state_type] :
      ( v4879(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1896,axiom,
    ! [VarCurr: state_type] :
      ( v4873(VarCurr)
    <=> v4875(VarCurr) ) ).

tff(addAssignment_1895,axiom,
    ! [VarCurr: state_type] :
      ( v4875(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_543,axiom,
    ! [VarCurr: state_type] :
      ( v4609(VarCurr)
    <=> ( v4862(VarCurr)
        | v4864(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_108,axiom,
    ! [VarCurr: state_type] :
      ( v4864(VarCurr)
    <=> ( v4828(VarCurr)
        | v4793(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_107,axiom,
    ! [VarCurr: state_type] :
      ( v4862(VarCurr)
    <=> ( v4598(VarCurr,4)
        & v4863(VarCurr) ) ) ).

tff(writeUnaryOperator_397,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4863(VarCurr)
    <=> v4611(VarCurr) ) ).

tff(addAssignment_1894,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4793(VarCurr,B)
      <=> v4795(VarCurr,B) ) ) ).

tff(addAssignment_1893,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4795(VarCurr,B)
      <=> v4797(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_65,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4845(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v4797(VarNext,B)
            <=> v4797(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_65,axiom,
    ! [VarNext: state_type] :
      ( v4845(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4797(VarNext,B)
          <=> v4855(VarNext,B) ) ) ) ).

tff(addAssignment_1892,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4855(VarNext,B)
          <=> v4853(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_67,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4853(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_67,axiom,
    ! [VarCurr: state_type] :
      ( v4856(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4853(VarCurr,B)
          <=> v4807(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_542,axiom,
    ! [VarCurr: state_type] :
      ( v4856(VarCurr)
    <=> ( v4857(VarCurr)
        & v4858(VarCurr) ) ) ).

tff(writeUnaryOperator_396,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4858(VarCurr)
    <=> v4803(VarCurr) ) ).

tff(writeUnaryOperator_395,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4857(VarCurr)
    <=> v4799(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_541,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4845(VarNext)
      <=> v4846(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_540,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4846(VarNext)
      <=> ( v4847(VarNext)
          & v4840(VarNext) ) ) ) ).

tff(writeUnaryOperator_394,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4847(VarNext)
      <=> v4849(VarNext) ) ) ).

tff(addAssignment_1891,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4849(VarNext)
      <=> v4840(VarCurr) ) ) ).

tff(addAssignment_1890,axiom,
    ! [VarCurr: state_type] :
      ( v4840(VarCurr)
    <=> v4842(VarCurr) ) ).

tff(addAssignment_1889,axiom,
    ! [VarCurr: state_type] :
      ( v4842(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1888,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4807(VarCurr,B)
      <=> v4809(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_35,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4809(VarCurr,B)
      <=> ( v4832(VarCurr,B)
          | v4835(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_34,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4835(VarCurr,B)
      <=> ( v4795(VarCurr,B)
          & v4836(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_393,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4836(VarCurr,B)
      <=> ~ v4837(VarCurr,B) ) ) ).

tff(addAssignment_1887,axiom,
    ! [VarCurr: state_type] :
      ( v4837(VarCurr,0)
    <=> v4838(VarCurr) ) ).

tff(addAssignment_1886,axiom,
    ! [VarCurr: state_type] :
      ( v4837(VarCurr,1)
    <=> v4838(VarCurr) ) ).

tff(addAssignment_1885,axiom,
    ! [VarCurr: state_type] :
      ( v4837(VarCurr,2)
    <=> v4838(VarCurr) ) ).

tff(addAssignment_1884,axiom,
    ! [VarCurr: state_type] :
      ( v4838(VarCurr)
    <=> v4830(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_33,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4832(VarCurr,B)
      <=> ( v4811(VarCurr,B)
          & v4833(VarCurr,B) ) ) ) ).

tff(addAssignment_1883,axiom,
    ! [VarCurr: state_type] :
      ( v4833(VarCurr,0)
    <=> v4834(VarCurr) ) ).

tff(addAssignment_1882,axiom,
    ! [VarCurr: state_type] :
      ( v4833(VarCurr,1)
    <=> v4834(VarCurr) ) ).

tff(addAssignment_1881,axiom,
    ! [VarCurr: state_type] :
      ( v4833(VarCurr,2)
    <=> v4834(VarCurr) ) ).

tff(addAssignment_1880,axiom,
    ! [VarCurr: state_type] :
      ( v4834(VarCurr)
    <=> v4830(VarCurr) ) ).

tff(addAssignment_1879,axiom,
    ! [VarCurr: state_type] :
      ( v4830(VarCurr)
    <=> v4609(VarCurr) ) ).

tff(addAssignment_1878,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4811(VarCurr,B)
      <=> v4813(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_66,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4813(VarCurr,B)
          <=> v4816(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_66,axiom,
    ! [VarCurr: state_type] :
      ( v4815(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v4813(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_1877,axiom,
    ! [VarCurr: state_type] :
      ( v4816(VarCurr,0)
    <=> v4826(VarCurr) ) ).

tff(addAssignment_1876,axiom,
    ! [VarCurr: state_type] :
      ( v4816(VarCurr,1)
    <=> v4824(VarCurr) ) ).

tff(addAssignment_1875,axiom,
    ! [VarCurr: state_type] :
      ( v4816(VarCurr,2)
    <=> v4818(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_539,axiom,
    ! [VarCurr: state_type] :
      ( v4824(VarCurr)
    <=> ( v4825(VarCurr)
        & v4828(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_106,axiom,
    ! [VarCurr: state_type] :
      ( v4828(VarCurr)
    <=> ( v4793(VarCurr,0)
        | v4793(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_538,axiom,
    ! [VarCurr: state_type] :
      ( v4825(VarCurr)
    <=> ( v4826(VarCurr)
        | v4827(VarCurr) ) ) ).

tff(writeUnaryOperator_392,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4827(VarCurr)
    <=> v4793(VarCurr,1) ) ).

tff(writeUnaryOperator_391,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4826(VarCurr)
    <=> v4793(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_537,axiom,
    ! [VarCurr: state_type] :
      ( v4818(VarCurr)
    <=> ( v4819(VarCurr)
        & v4823(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_105,axiom,
    ! [VarCurr: state_type] :
      ( v4823(VarCurr)
    <=> ( v4821(VarCurr)
        | v4793(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_536,axiom,
    ! [VarCurr: state_type] :
      ( v4819(VarCurr)
    <=> ( v4820(VarCurr)
        | v4822(VarCurr) ) ) ).

tff(writeUnaryOperator_390,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4822(VarCurr)
    <=> v4793(VarCurr,2) ) ).

tff(writeUnaryOperator_389,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4820(VarCurr)
    <=> v4821(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_104,axiom,
    ! [VarCurr: state_type] :
      ( v4821(VarCurr)
    <=> ( v4793(VarCurr,0)
        & v4793(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_36,axiom,
    ! [VarCurr: state_type] :
      ( v4815(VarCurr)
    <=> ( ( v4793(VarCurr,2)
        <=> $true )
        & ( v4793(VarCurr,1)
        <=> $false )
        & ( v4793(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_1874,axiom,
    ! [VarCurr: state_type] :
      ( v4803(VarCurr)
    <=> v4805(VarCurr) ) ).

tff(addAssignment_1873,axiom,
    ! [VarCurr: state_type] :
      ( v4805(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1872,axiom,
    ! [VarCurr: state_type] :
      ( v4799(VarCurr)
    <=> v4801(VarCurr) ) ).

tff(addAssignment_1871,axiom,
    ! [VarCurr: state_type] :
      ( v4801(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_535,axiom,
    ! [VarCurr: state_type] :
      ( v4611(VarCurr)
    <=> ( v4785(VarCurr)
        | v4787(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_103,axiom,
    ! [VarCurr: state_type] :
      ( v4787(VarCurr)
    <=> ( v4789(VarCurr)
        | v4697(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_102,axiom,
    ! [VarCurr: state_type] :
      ( v4789(VarCurr)
    <=> ( v4790(VarCurr)
        | v4697(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_101,axiom,
    ! [VarCurr: state_type] :
      ( v4790(VarCurr)
    <=> ( v4791(VarCurr)
        | v4697(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_100,axiom,
    ! [VarCurr: state_type] :
      ( v4791(VarCurr)
    <=> ( v4751(VarCurr)
        | v4697(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_99,axiom,
    ! [VarCurr: state_type] :
      ( v4785(VarCurr)
    <=> ( v4598(VarCurr,3)
        & v4786(VarCurr) ) ) ).

tff(writeUnaryOperator_388,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4786(VarCurr)
    <=> v4613(VarCurr) ) ).

tff(addAssignment_1870,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4697(VarCurr,B)
      <=> v4699(VarCurr,B) ) ) ).

tff(addAssignment_1869,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4699(VarCurr,B)
      <=> v4701(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_64,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4768(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v4701(VarNext,B)
            <=> v4701(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_64,axiom,
    ! [VarNext: state_type] :
      ( v4768(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4701(VarNext,B)
          <=> v4778(VarNext,B) ) ) ) ).

tff(addAssignment_1868,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4778(VarNext,B)
          <=> v4776(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_65,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4779(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4776(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_65,axiom,
    ! [VarCurr: state_type] :
      ( v4779(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4776(VarCurr,B)
          <=> v4711(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_534,axiom,
    ! [VarCurr: state_type] :
      ( v4779(VarCurr)
    <=> ( v4780(VarCurr)
        & v4781(VarCurr) ) ) ).

tff(writeUnaryOperator_387,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4781(VarCurr)
    <=> v4707(VarCurr) ) ).

tff(writeUnaryOperator_386,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4780(VarCurr)
    <=> v4703(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_533,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4768(VarNext)
      <=> v4769(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_532,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4769(VarNext)
      <=> ( v4770(VarNext)
          & v4763(VarNext) ) ) ) ).

tff(writeUnaryOperator_385,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4770(VarNext)
      <=> v4772(VarNext) ) ) ).

tff(addAssignment_1867,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4772(VarNext)
      <=> v4763(VarCurr) ) ) ).

tff(addAssignment_1866,axiom,
    ! [VarCurr: state_type] :
      ( v4763(VarCurr)
    <=> v4765(VarCurr) ) ).

tff(addAssignment_1865,axiom,
    ! [VarCurr: state_type] :
      ( v4765(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4711(VarCurr,B)
      <=> v4713(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_32,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4713(VarCurr,B)
      <=> ( v4755(VarCurr,B)
          | v4758(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_31,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4758(VarCurr,B)
      <=> ( v4699(VarCurr,B)
          & v4759(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_384,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4759(VarCurr,B)
      <=> ~ v4760(VarCurr,B) ) ) ).

tff(addAssignment_1863,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,0)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1862,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,1)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1861,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,2)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1860,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,3)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1859,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,4)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1858,axiom,
    ! [VarCurr: state_type] :
      ( v4760(VarCurr,5)
    <=> v4761(VarCurr) ) ).

tff(addAssignment_1857,axiom,
    ! [VarCurr: state_type] :
      ( v4761(VarCurr)
    <=> v4753(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_30,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4755(VarCurr,B)
      <=> ( v4715(VarCurr,B)
          & v4756(VarCurr,B) ) ) ) ).

tff(addAssignment_1856,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,0)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1855,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,1)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1854,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,2)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1853,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,3)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1852,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,4)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1851,axiom,
    ! [VarCurr: state_type] :
      ( v4756(VarCurr,5)
    <=> v4757(VarCurr) ) ).

tff(addAssignment_1850,axiom,
    ! [VarCurr: state_type] :
      ( v4757(VarCurr)
    <=> v4753(VarCurr) ) ).

tff(addAssignment_1849,axiom,
    ! [VarCurr: state_type] :
      ( v4753(VarCurr)
    <=> v4611(VarCurr) ) ).

tff(addAssignment_1848,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v4715(VarCurr,B)
      <=> v4717(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_64,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4720(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4717(VarCurr,B)
          <=> v4721(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_64,axiom,
    ! [VarCurr: state_type] :
      ( v4720(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v4717(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_1847,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,0)
    <=> v4749(VarCurr) ) ).

tff(addAssignment_1846,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,1)
    <=> v4747(VarCurr) ) ).

tff(addAssignment_1845,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,2)
    <=> v4742(VarCurr) ) ).

tff(addAssignment_1844,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,3)
    <=> v4737(VarCurr) ) ).

tff(addAssignment_1843,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,4)
    <=> v4732(VarCurr) ) ).

tff(addAssignment_1842,axiom,
    ! [VarCurr: state_type] :
      ( v4721(VarCurr,5)
    <=> v4723(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_531,axiom,
    ! [VarCurr: state_type] :
      ( v4747(VarCurr)
    <=> ( v4748(VarCurr)
        & v4751(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_98,axiom,
    ! [VarCurr: state_type] :
      ( v4751(VarCurr)
    <=> ( v4697(VarCurr,0)
        | v4697(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_530,axiom,
    ! [VarCurr: state_type] :
      ( v4748(VarCurr)
    <=> ( v4749(VarCurr)
        | v4750(VarCurr) ) ) ).

tff(writeUnaryOperator_383,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4750(VarCurr)
    <=> v4697(VarCurr,1) ) ).

tff(writeUnaryOperator_382,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4749(VarCurr)
    <=> v4697(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_529,axiom,
    ! [VarCurr: state_type] :
      ( v4742(VarCurr)
    <=> ( v4743(VarCurr)
        & v4746(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_97,axiom,
    ! [VarCurr: state_type] :
      ( v4746(VarCurr)
    <=> ( v4729(VarCurr)
        | v4697(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_528,axiom,
    ! [VarCurr: state_type] :
      ( v4743(VarCurr)
    <=> ( v4744(VarCurr)
        | v4745(VarCurr) ) ) ).

tff(writeUnaryOperator_381,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4745(VarCurr)
    <=> v4697(VarCurr,2) ) ).

tff(writeUnaryOperator_380,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4744(VarCurr)
    <=> v4729(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_527,axiom,
    ! [VarCurr: state_type] :
      ( v4737(VarCurr)
    <=> ( v4738(VarCurr)
        & v4741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_96,axiom,
    ! [VarCurr: state_type] :
      ( v4741(VarCurr)
    <=> ( v4728(VarCurr)
        | v4697(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_526,axiom,
    ! [VarCurr: state_type] :
      ( v4738(VarCurr)
    <=> ( v4739(VarCurr)
        | v4740(VarCurr) ) ) ).

tff(writeUnaryOperator_379,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4740(VarCurr)
    <=> v4697(VarCurr,3) ) ).

tff(writeUnaryOperator_378,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4739(VarCurr)
    <=> v4728(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_525,axiom,
    ! [VarCurr: state_type] :
      ( v4732(VarCurr)
    <=> ( v4733(VarCurr)
        & v4736(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_95,axiom,
    ! [VarCurr: state_type] :
      ( v4736(VarCurr)
    <=> ( v4727(VarCurr)
        | v4697(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_524,axiom,
    ! [VarCurr: state_type] :
      ( v4733(VarCurr)
    <=> ( v4734(VarCurr)
        | v4735(VarCurr) ) ) ).

tff(writeUnaryOperator_377,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4735(VarCurr)
    <=> v4697(VarCurr,4) ) ).

tff(writeUnaryOperator_376,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4734(VarCurr)
    <=> v4727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_523,axiom,
    ! [VarCurr: state_type] :
      ( v4723(VarCurr)
    <=> ( v4724(VarCurr)
        & v4731(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_94,axiom,
    ! [VarCurr: state_type] :
      ( v4731(VarCurr)
    <=> ( v4726(VarCurr)
        | v4697(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_522,axiom,
    ! [VarCurr: state_type] :
      ( v4724(VarCurr)
    <=> ( v4725(VarCurr)
        | v4730(VarCurr) ) ) ).

tff(writeUnaryOperator_375,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4730(VarCurr)
    <=> v4697(VarCurr,5) ) ).

tff(writeUnaryOperator_374,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4725(VarCurr)
    <=> v4726(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_93,axiom,
    ! [VarCurr: state_type] :
      ( v4726(VarCurr)
    <=> ( v4727(VarCurr)
        & v4697(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_92,axiom,
    ! [VarCurr: state_type] :
      ( v4727(VarCurr)
    <=> ( v4728(VarCurr)
        & v4697(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_91,axiom,
    ! [VarCurr: state_type] :
      ( v4728(VarCurr)
    <=> ( v4729(VarCurr)
        & v4697(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_90,axiom,
    ! [VarCurr: state_type] :
      ( v4729(VarCurr)
    <=> ( v4697(VarCurr,0)
        & v4697(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_35,axiom,
    ! [VarCurr: state_type] :
      ( v4720(VarCurr)
    <=> ( ( v4697(VarCurr,5)
        <=> $false )
        & ( v4697(VarCurr,4)
        <=> $false )
        & ( v4697(VarCurr,3)
        <=> $false )
        & ( v4697(VarCurr,2)
        <=> $true )
        & ( v4697(VarCurr,1)
        <=> $true )
        & ( v4697(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_175,axiom,
    ~ b000111(5) ).

tff(bitBlastConstant_174,axiom,
    ~ b000111(4) ).

tff(bitBlastConstant_173,axiom,
    ~ b000111(3) ).

tff(bitBlastConstant_172,axiom,
    b000111(2) ).

tff(bitBlastConstant_171,axiom,
    b000111(1) ).

tff(bitBlastConstant_170,axiom,
    b000111(0) ).

tff(addAssignment_1841,axiom,
    ! [VarCurr: state_type] :
      ( v4707(VarCurr)
    <=> v4709(VarCurr) ) ).

tff(addAssignment_1840,axiom,
    ! [VarCurr: state_type] :
      ( v4709(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1839,axiom,
    ! [VarCurr: state_type] :
      ( v4703(VarCurr)
    <=> v4705(VarCurr) ) ).

tff(addAssignment_1838,axiom,
    ! [VarCurr: state_type] :
      ( v4705(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_89,axiom,
    ! [VarCurr: state_type] :
      ( v4613(VarCurr)
    <=> ( v4598(VarCurr,2)
        | v4693(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_88,axiom,
    ! [VarCurr: state_type] :
      ( v4693(VarCurr)
    <=> ( v4695(VarCurr)
        | v4615(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_87,axiom,
    ! [VarCurr: state_type] :
      ( v4695(VarCurr)
    <=> ( v4658(VarCurr)
        | v4615(VarCurr,2) ) ) ).

tff(addAssignment_1837,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4615(VarCurr,B)
      <=> v4617(VarCurr,B) ) ) ).

tff(addAssignment_1836,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4617(VarCurr,B)
      <=> v4619(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_63,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4676(VarNext)
       => ! [B: $int] :
            ( ( $less(B,4)
              & ~ $less(B,0) )
           => ( v4619(VarNext,B)
            <=> v4619(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_63,axiom,
    ! [VarNext: state_type] :
      ( v4676(VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4619(VarNext,B)
          <=> v4686(VarNext,B) ) ) ) ).

tff(addAssignment_1835,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4686(VarNext,B)
          <=> v4684(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_63,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4684(VarCurr,B)
          <=> bxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_63,axiom,
    ! [VarCurr: state_type] :
      ( v4687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4684(VarCurr,B)
          <=> v4629(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_521,axiom,
    ! [VarCurr: state_type] :
      ( v4687(VarCurr)
    <=> ( v4688(VarCurr)
        & v4689(VarCurr) ) ) ).

tff(writeUnaryOperator_373,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4689(VarCurr)
    <=> v4625(VarCurr) ) ).

tff(writeUnaryOperator_372,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4688(VarCurr)
    <=> v4621(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_520,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4676(VarNext)
      <=> v4677(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_519,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4677(VarNext)
      <=> ( v4678(VarNext)
          & v4671(VarNext) ) ) ) ).

tff(writeUnaryOperator_371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4678(VarNext)
      <=> v4680(VarNext) ) ) ).

tff(addAssignment_1834,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4680(VarNext)
      <=> v4671(VarCurr) ) ) ).

tff(addAssignment_1833,axiom,
    ! [VarCurr: state_type] :
      ( v4671(VarCurr)
    <=> v4673(VarCurr) ) ).

tff(addAssignment_1832,axiom,
    ! [VarCurr: state_type] :
      ( v4673(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1831,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4629(VarCurr,B)
      <=> v4631(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_29,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4631(VarCurr,B)
      <=> ( v4662(VarCurr,B)
          | v4665(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_28,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4665(VarCurr,B)
      <=> ( v4617(VarCurr,B)
          & v4666(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_370,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4666(VarCurr,B)
      <=> ~ v4667(VarCurr,B) ) ) ).

tff(addAssignment_1830,axiom,
    ! [VarCurr: state_type] :
      ( v4667(VarCurr,0)
    <=> v4668(VarCurr) ) ).

tff(addAssignment_1829,axiom,
    ! [VarCurr: state_type] :
      ( v4667(VarCurr,1)
    <=> v4668(VarCurr) ) ).

tff(addAssignment_1828,axiom,
    ! [VarCurr: state_type] :
      ( v4667(VarCurr,2)
    <=> v4668(VarCurr) ) ).

tff(addAssignment_1827,axiom,
    ! [VarCurr: state_type] :
      ( v4667(VarCurr,3)
    <=> v4668(VarCurr) ) ).

tff(addAssignment_1826,axiom,
    ! [VarCurr: state_type] :
      ( v4668(VarCurr)
    <=> v4660(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_27,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4662(VarCurr,B)
      <=> ( v4633(VarCurr,B)
          & v4663(VarCurr,B) ) ) ) ).

tff(addAssignment_1825,axiom,
    ! [VarCurr: state_type] :
      ( v4663(VarCurr,0)
    <=> v4664(VarCurr) ) ).

tff(addAssignment_1824,axiom,
    ! [VarCurr: state_type] :
      ( v4663(VarCurr,1)
    <=> v4664(VarCurr) ) ).

tff(addAssignment_1823,axiom,
    ! [VarCurr: state_type] :
      ( v4663(VarCurr,2)
    <=> v4664(VarCurr) ) ).

tff(addAssignment_1822,axiom,
    ! [VarCurr: state_type] :
      ( v4663(VarCurr,3)
    <=> v4664(VarCurr) ) ).

tff(addAssignment_1821,axiom,
    ! [VarCurr: state_type] :
      ( v4664(VarCurr)
    <=> v4660(VarCurr) ) ).

tff(addAssignment_1820,axiom,
    ! [VarCurr: state_type] :
      ( v4660(VarCurr)
    <=> v4613(VarCurr) ) ).

tff(addAssignment_1819,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v4633(VarCurr,B)
      <=> v4635(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_62,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4639(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4635(VarCurr,B)
          <=> v4640(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_62,axiom,
    ! [VarCurr: state_type] :
      ( v4639(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,4)
            & ~ $less(B,0) )
         => ( v4635(VarCurr,B)
          <=> $false ) ) ) ).

tff(addAssignment_1818,axiom,
    ! [VarCurr: state_type] :
      ( v4640(VarCurr,0)
    <=> v4656(VarCurr) ) ).

tff(addAssignment_1817,axiom,
    ! [VarCurr: state_type] :
      ( v4640(VarCurr,1)
    <=> v4654(VarCurr) ) ).

tff(addAssignment_1816,axiom,
    ! [VarCurr: state_type] :
      ( v4640(VarCurr,2)
    <=> v4649(VarCurr) ) ).

tff(addAssignment_1815,axiom,
    ! [VarCurr: state_type] :
      ( v4640(VarCurr,3)
    <=> v4642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_518,axiom,
    ! [VarCurr: state_type] :
      ( v4654(VarCurr)
    <=> ( v4655(VarCurr)
        & v4658(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_86,axiom,
    ! [VarCurr: state_type] :
      ( v4658(VarCurr)
    <=> ( v4615(VarCurr,0)
        | v4615(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_517,axiom,
    ! [VarCurr: state_type] :
      ( v4655(VarCurr)
    <=> ( v4656(VarCurr)
        | v4657(VarCurr) ) ) ).

tff(writeUnaryOperator_369,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4657(VarCurr)
    <=> v4615(VarCurr,1) ) ).

tff(writeUnaryOperator_368,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4656(VarCurr)
    <=> v4615(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_516,axiom,
    ! [VarCurr: state_type] :
      ( v4649(VarCurr)
    <=> ( v4650(VarCurr)
        & v4653(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_85,axiom,
    ! [VarCurr: state_type] :
      ( v4653(VarCurr)
    <=> ( v4646(VarCurr)
        | v4615(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_515,axiom,
    ! [VarCurr: state_type] :
      ( v4650(VarCurr)
    <=> ( v4651(VarCurr)
        | v4652(VarCurr) ) ) ).

tff(writeUnaryOperator_367,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4652(VarCurr)
    <=> v4615(VarCurr,2) ) ).

tff(writeUnaryOperator_366,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4651(VarCurr)
    <=> v4646(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_514,axiom,
    ! [VarCurr: state_type] :
      ( v4642(VarCurr)
    <=> ( v4643(VarCurr)
        & v4648(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_84,axiom,
    ! [VarCurr: state_type] :
      ( v4648(VarCurr)
    <=> ( v4645(VarCurr)
        | v4615(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_513,axiom,
    ! [VarCurr: state_type] :
      ( v4643(VarCurr)
    <=> ( v4644(VarCurr)
        | v4647(VarCurr) ) ) ).

tff(writeUnaryOperator_365,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4647(VarCurr)
    <=> v4615(VarCurr,3) ) ).

tff(writeUnaryOperator_364,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4644(VarCurr)
    <=> v4645(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_83,axiom,
    ! [VarCurr: state_type] :
      ( v4645(VarCurr)
    <=> ( v4646(VarCurr)
        & v4615(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_82,axiom,
    ! [VarCurr: state_type] :
      ( v4646(VarCurr)
    <=> ( v4615(VarCurr,0)
        & v4615(VarCurr,1) ) ) ).

tff(addBitVectorEqualityBitBlasted_34,axiom,
    ! [VarCurr: state_type] :
      ( v4639(VarCurr)
    <=> ( ( v4615(VarCurr,3)
        <=> $true )
        & ( v4615(VarCurr,2)
        <=> $false )
        & ( v4615(VarCurr,1)
        <=> $true )
        & ( v4615(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_169,axiom,
    b1011(3) ).

tff(bitBlastConstant_168,axiom,
    ~ b1011(2) ).

tff(bitBlastConstant_167,axiom,
    b1011(1) ).

tff(bitBlastConstant_166,axiom,
    b1011(0) ).

tff(addAssignment_1814,axiom,
    ! [VarCurr: state_type] :
      ( v4625(VarCurr)
    <=> v4627(VarCurr) ) ).

tff(addAssignment_1813,axiom,
    ! [VarCurr: state_type] :
      ( v4627(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1812,axiom,
    ! [VarCurr: state_type] :
      ( v4621(VarCurr)
    <=> v4623(VarCurr) ) ).

tff(addAssignment_1811,axiom,
    ! [VarCurr: state_type] :
      ( v4623(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1810,axiom,
    ! [VarCurr: state_type] :
      ( v4598(VarCurr,2)
    <=> v4599(VarCurr,2) ) ).

tff(addAssignment_1809,axiom,
    ! [VarCurr: state_type] :
      ( v4598(VarCurr,3)
    <=> v4599(VarCurr,3) ) ).

tff(addAssignment_1808,axiom,
    ! [VarCurr: state_type] :
      ( v4598(VarCurr,4)
    <=> v4599(VarCurr,4) ) ).

tff(addAssignment_1807,axiom,
    ! [VarCurr: state_type] :
      ( v4598(VarCurr,5)
    <=> v4599(VarCurr,5) ) ).

tff(addAssignment_1806,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,0)
    <=> v4607(VarCurr) ) ).

tff(addAssignment_1805,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,1)
    <=> v4606(VarCurr) ) ).

tff(addAssignment_1804,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,2)
    <=> v4605(VarCurr) ) ).

tff(addAssignment_1803,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,3)
    <=> v4604(VarCurr) ) ).

tff(addAssignment_1802,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,4)
    <=> v4603(VarCurr) ) ).

tff(addAssignment_1801,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,5)
    <=> v4602(VarCurr) ) ).

tff(addAssignment_1800,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,6)
    <=> v4601(VarCurr) ) ).

tff(addAssignment_1799,axiom,
    ! [VarCurr: state_type] :
      ( v4599(VarCurr,7)
    <=> v4600(VarCurr) ) ).

tff(addBitVectorEqualityBitBlasted_33,axiom,
    ! [VarCurr: state_type] :
      ( v4607(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_32,axiom,
    ! [VarCurr: state_type] :
      ( v4606(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_31,axiom,
    ! [VarCurr: state_type] :
      ( v4605(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_30,axiom,
    ! [VarCurr: state_type] :
      ( v4604(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_29,axiom,
    ! [VarCurr: state_type] :
      ( v4603(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_28,axiom,
    ! [VarCurr: state_type] :
      ( v4602(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addBitVectorEqualityBitBlasted_27,axiom,
    ! [VarCurr: state_type] :
      ( v4601(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addBitVectorEqualityBitBlasted_26,axiom,
    ! [VarCurr: state_type] :
      ( v4600(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $true )
        & ( v4201(VarCurr,1)
        <=> $true )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(addAssignment_1798,axiom,
    ! [VarCurr: state_type] :
      ( v4584(VarCurr)
    <=> v4586(VarCurr) ) ).

tff(addAssignment_1797,axiom,
    ! [VarCurr: state_type] :
      ( v4586(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1796,axiom,
    ! [VarCurr: state_type] :
      ( v4580(VarCurr)
    <=> v4582(VarCurr) ) ).

tff(addAssignment_1795,axiom,
    ! [VarCurr: state_type] :
      ( v4582(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1794,axiom,
    ! [VarCurr: state_type] :
      ( v4551(VarCurr)
    <=> v4553(VarCurr) ) ).

tff(addAssignment_1793,axiom,
    ! [VarCurr: state_type] :
      ( v4553(VarCurr)
    <=> v4555(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_512,axiom,
    ! [VarCurr: state_type] :
      ( v4555(VarCurr)
    <=> ( v4557(VarCurr)
        & v4548(VarCurr) ) ) ).

tff(addAssignment_1792,axiom,
    ! [VarCurr: state_type] :
      ( v4557(VarCurr)
    <=> v60(VarCurr) ) ).

tff(addAssignment_1791,axiom,
    ! [VarCurr: state_type] :
      ( v4540(VarCurr)
    <=> v4542(VarCurr) ) ).

tff(addAssignment_1790,axiom,
    ! [VarCurr: state_type] :
      ( v4542(VarCurr)
    <=> v4544(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_511,axiom,
    ! [VarCurr: state_type] :
      ( v4544(VarCurr)
    <=> ( v4546(VarCurr)
        & v4548(VarCurr) ) ) ).

tff(addAssignment_1789,axiom,
    ! [VarCurr: state_type] :
      ( v4548(VarCurr)
    <=> v4363(VarCurr) ) ).

tff(addAssignment_1788,axiom,
    ! [VarCurr: state_type] :
      ( v4546(VarCurr)
    <=> v36(VarCurr) ) ).

tff(addAssignment_1787,axiom,
    ! [VarCurr: state_type] :
      ( v4524(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1786,axiom,
    ! [VarCurr: state_type] :
      ( v4522(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1785,axiom,
    ! [VarCurr: state_type] :
      ( v4386(VarCurr)
    <=> v4388(VarCurr) ) ).

tff(addAssignment_1784,axiom,
    ! [VarCurr: state_type] :
      ( v4388(VarCurr)
    <=> v4390(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_62,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4494(VarNext)
       => ( v4390(VarNext)
        <=> v4390(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_62,axiom,
    ! [VarNext: state_type] :
      ( v4494(VarNext)
     => ( v4390(VarNext)
      <=> v4504(VarNext) ) ) ).

tff(addAssignment_1783,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4504(VarNext)
      <=> v4502(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_61,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4505(VarCurr)
     => ( v4502(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_61,axiom,
    ! [VarCurr: state_type] :
      ( v4505(VarCurr)
     => ( v4502(VarCurr)
      <=> v4400(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_510,axiom,
    ! [VarCurr: state_type] :
      ( v4505(VarCurr)
    <=> ( v4506(VarCurr)
        & v4507(VarCurr) ) ) ).

tff(writeUnaryOperator_363,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4507(VarCurr)
    <=> v4396(VarCurr) ) ).

tff(writeUnaryOperator_362,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4506(VarCurr)
    <=> v4392(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_509,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4494(VarNext)
      <=> v4495(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_508,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4495(VarNext)
      <=> ( v4496(VarNext)
          & v4431(VarNext) ) ) ) ).

tff(writeUnaryOperator_361,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4496(VarNext)
      <=> v4498(VarNext) ) ) ).

tff(addAssignment_1782,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4498(VarNext)
      <=> v4431(VarCurr) ) ) ).

tff(addAssignment_1781,axiom,
    ! [VarCurr: state_type] :
      ( v4431(VarCurr)
    <=> v4433(VarCurr) ) ).

tff(addAssignment_1780,axiom,
    ! [VarCurr: state_type] :
      ( v4433(VarCurr)
    <=> v4435(VarCurr) ) ).

tff(addAssignment_1779,axiom,
    ! [VarCurr: state_type] :
      ( v4435(VarCurr)
    <=> v4437(VarCurr) ) ).

tff(addAssignment_1778,axiom,
    ! [VarCurr: state_type] :
      ( v4437(VarCurr)
    <=> v4439(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_507,axiom,
    ! [VarCurr: state_type] :
      ( v4439(VarCurr)
    <=> ( v4491(VarCurr)
        | v4482(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_506,axiom,
    ! [VarCurr: state_type] :
      ( v4491(VarCurr)
    <=> ( v4441(VarCurr)
        & v4447(VarCurr) ) ) ).

tff(addAssignment_1777,axiom,
    ! [VarCurr: state_type] :
      ( v4482(VarCurr)
    <=> v4484(VarCurr) ) ).

tff(addAssignment_1776,axiom,
    ! [VarCurr: state_type] :
      ( v4484(VarCurr)
    <=> v4486(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_505,axiom,
    ! [VarCurr: state_type] :
      ( v4486(VarCurr)
    <=> ( v4488(VarCurr)
        & v4359(VarCurr) ) ) ).

tff(addAssignment_1775,axiom,
    ! [VarCurr: state_type] :
      ( v4488(VarCurr)
    <=> v2178(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_61,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4466(VarNext)
       => ( v4447(VarNext)
        <=> v4447(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_61,axiom,
    ! [VarNext: state_type] :
      ( v4466(VarNext)
     => ( v4447(VarNext)
      <=> v4476(VarNext) ) ) ).

tff(addAssignment_1774,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4476(VarNext)
      <=> v4474(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_504,axiom,
    ! [VarCurr: state_type] :
      ( v4474(VarCurr)
    <=> ( v4477(VarCurr)
        & v4478(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_503,axiom,
    ! [VarCurr: state_type] :
      ( v4478(VarCurr)
    <=> ( v4453(VarCurr)
        | v4457(VarCurr) ) ) ).

tff(writeUnaryOperator_360,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4477(VarCurr)
    <=> v4449(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_502,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4466(VarNext)
      <=> v4467(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_501,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4467(VarNext)
      <=> ( v4469(VarNext)
          & v4471(VarNext) ) ) ) ).

tff(writeUnaryOperator_359,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4471(VarCurr)
    <=> v4441(VarCurr) ) ).

tff(addAssignment_1773,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4469(VarNext)
      <=> v4441(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_10,axiom,
    ( v4447(constB0)
  <=> $true ) ).

tff(addAssignment_1772,axiom,
    ! [VarCurr: state_type] :
      ( v4457(VarCurr)
    <=> v4459(VarCurr) ) ).

tff(addAssignment_1771,axiom,
    ! [VarCurr: state_type] :
      ( v4459(VarCurr)
    <=> v4461(VarCurr) ) ).

tff(addAssignment_1770,axiom,
    ! [VarCurr: state_type] :
      ( v4461(VarCurr)
    <=> v4463(VarCurr) ) ).

tff(addAssignment_1769,axiom,
    ! [VarCurr: state_type] :
      ( v4463(VarCurr)
    <=> v2153(VarCurr) ) ).

tff(addAssignment_1768,axiom,
    ! [VarCurr: state_type] :
      ( v4453(VarCurr)
    <=> v4455(VarCurr) ) ).

tff(addAssignment_1767,axiom,
    ! [VarCurr: state_type] :
      ( v4455(VarCurr)
    <=> $true ) ).

tff(addAssignment_1766,axiom,
    ! [VarCurr: state_type] :
      ( v4449(VarCurr)
    <=> v4451(VarCurr) ) ).

tff(addAssignment_1765,axiom,
    ! [VarCurr: state_type] :
      ( v4451(VarCurr)
    <=> $false ) ).

tff(addAssignment_1764,axiom,
    ! [VarCurr: state_type] :
      ( v4441(VarCurr)
    <=> v4443(VarCurr) ) ).

tff(addAssignment_1763,axiom,
    ! [VarCurr: state_type] :
      ( v4443(VarCurr)
    <=> v4445(VarCurr) ) ).

tff(addAssignment_1762,axiom,
    ! [VarCurr: state_type] :
      ( v4445(VarCurr)
    <=> v2135(VarCurr) ) ).

tff(addAssignment_1761,axiom,
    ! [VarCurr: state_type] :
      ( v4400(VarCurr)
    <=> v4402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_500,axiom,
    ! [VarCurr: state_type] :
      ( v4402(VarCurr)
    <=> ( v4423(VarCurr)
        | v4426(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_499,axiom,
    ! [VarCurr: state_type] :
      ( v4426(VarCurr)
    <=> ( v4388(VarCurr)
        & v4427(VarCurr) ) ) ).

tff(writeUnaryOperator_358,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4427(VarCurr)
    <=> v4428(VarCurr) ) ).

tff(addAssignment_1760,axiom,
    ! [VarCurr: state_type] :
      ( v4428(VarCurr)
    <=> v4429(VarCurr) ) ).

tff(addAssignment_1759,axiom,
    ! [VarCurr: state_type] :
      ( v4429(VarCurr)
    <=> v4410(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_498,axiom,
    ! [VarCurr: state_type] :
      ( v4423(VarCurr)
    <=> ( v4404(VarCurr)
        & v4424(VarCurr) ) ) ).

tff(addAssignment_1758,axiom,
    ! [VarCurr: state_type] :
      ( v4424(VarCurr)
    <=> v4425(VarCurr) ) ).

tff(addAssignment_1757,axiom,
    ! [VarCurr: state_type] :
      ( v4425(VarCurr)
    <=> v4410(VarCurr) ) ).

tff(addAssignment_1756,axiom,
    ! [VarCurr: state_type] :
      ( v4410(VarCurr)
    <=> v4412(VarCurr) ) ).

tff(addAssignment_1755,axiom,
    ! [VarCurr: state_type] :
      ( v4412(VarCurr)
    <=> v4414(VarCurr) ) ).

tff(addAssignment_1754,axiom,
    ! [VarCurr: state_type] :
      ( v4414(VarCurr)
    <=> v4416(VarCurr) ) ).

tff(addAssignment_1753,axiom,
    ! [VarCurr: state_type] :
      ( v4416(VarCurr)
    <=> v4418(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_497,axiom,
    ! [VarCurr: state_type] :
      ( v4418(VarCurr)
    <=> ( v1729(VarCurr)
        & v4421(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_25,axiom,
    ! [VarCurr: state_type] :
      ( v4421(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $true )
        & ( v1871(VarCurr,8)
        <=> $false )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $false )
        & ( v1871(VarCurr,5)
        <=> $true )
        & ( v1871(VarCurr,4)
        <=> $true )
        & ( v1871(VarCurr,3)
        <=> $false )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_165,axiom,
    ~ b0001000110000(12) ).

tff(bitBlastConstant_164,axiom,
    ~ b0001000110000(11) ).

tff(bitBlastConstant_163,axiom,
    ~ b0001000110000(10) ).

tff(bitBlastConstant_162,axiom,
    b0001000110000(9) ).

tff(bitBlastConstant_161,axiom,
    ~ b0001000110000(8) ).

tff(bitBlastConstant_160,axiom,
    ~ b0001000110000(7) ).

tff(bitBlastConstant_159,axiom,
    ~ b0001000110000(6) ).

tff(bitBlastConstant_158,axiom,
    b0001000110000(5) ).

tff(bitBlastConstant_157,axiom,
    b0001000110000(4) ).

tff(bitBlastConstant_156,axiom,
    ~ b0001000110000(3) ).

tff(bitBlastConstant_155,axiom,
    ~ b0001000110000(2) ).

tff(bitBlastConstant_154,axiom,
    ~ b0001000110000(1) ).

tff(bitBlastConstant_153,axiom,
    ~ b0001000110000(0) ).

tff(addAssignment_1752,axiom,
    ! [VarCurr: state_type] :
      ( v4404(VarCurr)
    <=> v4406(VarCurr) ) ).

tff(addAssignment_1751,axiom,
    ! [VarCurr: state_type] :
      ( v4406(VarCurr)
    <=> v4408(VarCurr,0) ) ).

tff(addAssignment_1750,axiom,
    ! [VarCurr: state_type] :
      ( v4408(VarCurr,0)
    <=> v2363(VarCurr,0) ) ).

tff(addAssignment_1749,axiom,
    ! [VarCurr: state_type] :
      ( v4396(VarCurr)
    <=> v4398(VarCurr) ) ).

tff(addAssignment_1748,axiom,
    ! [VarCurr: state_type] :
      ( v4398(VarCurr)
    <=> v4370(VarCurr) ) ).

tff(addAssignment_1747,axiom,
    ! [VarCurr: state_type] :
      ( v4392(VarCurr)
    <=> v4394(VarCurr) ) ).

tff(addAssignment_1746,axiom,
    ! [VarCurr: state_type] :
      ( v4394(VarCurr)
    <=> v4355(VarCurr) ) ).

tff(addAssignment_1745,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,1) )
     => ( v4383(VarCurr,B)
      <=> v4201(VarCurr,B) ) ) ).

tff(addAssignment_1744,axiom,
    ! [VarCurr: state_type] :
      ( v4366(VarCurr)
    <=> v4368(VarCurr) ) ).

tff(addAssignment_1743,axiom,
    ! [VarCurr: state_type] :
      ( v4368(VarCurr)
    <=> v4370(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_496,axiom,
    ! [VarCurr: state_type] :
      ( v4370(VarCurr)
    <=> ( v4372(VarCurr)
        & v4359(VarCurr) ) ) ).

tff(addAssignment_1742,axiom,
    ! [VarCurr: state_type] :
      ( v4372(VarCurr)
    <=> v2066(VarCurr) ) ).

tff(addAssignment_1741,axiom,
    ! [VarCurr: state_type] :
      ( v4351(VarCurr)
    <=> v4353(VarCurr) ) ).

tff(addAssignment_1740,axiom,
    ! [VarCurr: state_type] :
      ( v4353(VarCurr)
    <=> v4355(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_495,axiom,
    ! [VarCurr: state_type] :
      ( v4355(VarCurr)
    <=> ( v4357(VarCurr)
        & v4359(VarCurr) ) ) ).

tff(addAssignment_1739,axiom,
    ! [VarCurr: state_type] :
      ( v4359(VarCurr)
    <=> v4361(VarCurr) ) ).

tff(addAssignment_1738,axiom,
    ! [VarCurr: state_type] :
      ( v4361(VarCurr)
    <=> v4363(VarCurr) ) ).

tff(addAssignment_1737,axiom,
    ! [VarCurr: state_type] :
      ( v4357(VarCurr)
    <=> v2058(VarCurr) ) ).

tff(addAssignment_1736,axiom,
    ! [VarCurr: state_type] :
      ( v4339(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1735,axiom,
    ! [VarCurr: state_type] :
      ( v4337(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1734,axiom,
    ! [VarCurr: state_type] :
      ( v4283(VarCurr)
    <=> v4285(VarCurr,0) ) ).

tff(addAssignment_1733,axiom,
    ! [VarCurr: state_type] :
      ( v4285(VarCurr,0)
    <=> v4287(VarCurr,0) ) ).

tff(addAssignment_1732,axiom,
    ! [VarNext: state_type] :
      ( v4287(VarNext,0)
    <=> v4311(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_60,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4312(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v4311(VarNext,B)
            <=> v4287(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_60,axiom,
    ! [VarNext: state_type] :
      ( v4312(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v4311(VarNext,B)
          <=> v4322(VarNext,B) ) ) ) ).

tff(addAssignment_1731,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v4322(VarNext,B)
          <=> v4320(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_60,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4323(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v4320(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_60,axiom,
    ! [VarCurr: state_type] :
      ( v4323(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v4320(VarCurr,B)
          <=> v4297(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_494,axiom,
    ! [VarCurr: state_type] :
      ( v4323(VarCurr)
    <=> ( v4324(VarCurr)
        & v4325(VarCurr) ) ) ).

tff(writeUnaryOperator_357,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4325(VarCurr)
    <=> v4293(VarCurr) ) ).

tff(writeUnaryOperator_356,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4324(VarCurr)
    <=> v4289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_493,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4312(VarNext)
      <=> v4313(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_492,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4313(VarNext)
      <=> ( v4314(VarNext)
          & v4307(VarNext) ) ) ) ).

tff(writeUnaryOperator_355,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4314(VarNext)
      <=> v4316(VarNext) ) ) ).

tff(addAssignment_1730,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4316(VarNext)
      <=> v4307(VarCurr) ) ) ).

tff(addAssignment_1729,axiom,
    ! [VarCurr: state_type] :
      ( v4307(VarCurr)
    <=> v4309(VarCurr) ) ).

tff(addAssignment_1728,axiom,
    ! [VarCurr: state_type] :
      ( v4309(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1727,axiom,
    ! [VarCurr: state_type] :
      ( v4297(VarCurr,0)
    <=> v4299(VarCurr,0) ) ).

tff(addAssignment_1726,axiom,
    ! [VarCurr: state_type] :
      ( v4299(VarCurr,0)
    <=> v4301(VarCurr,0) ) ).

tff(addAssignment_1725,axiom,
    ! [VarCurr: state_type] :
      ( v4301(VarCurr,0)
    <=> v4304(VarCurr,0) ) ).

tff(addAssignment_1724,axiom,
    ! [VarCurr: state_type] :
      ( v4304(VarCurr,0)
    <=> v4303(VarCurr) ) ).

tff(addAssignment_1723,axiom,
    ! [VarCurr: state_type] :
      ( v4304(VarCurr,1)
    <=> v4305(VarCurr) ) ).

tff(addAssignment_1722,axiom,
    ! [VarCurr: state_type] :
      ( v4303(VarCurr)
    <=> v4285(VarCurr,1) ) ).

tff(addAssignment_1721,axiom,
    ! [VarCurr: state_type] :
      ( v4285(VarCurr,1)
    <=> v4287(VarCurr,1) ) ).

tff(addAssignment_1720,axiom,
    ! [VarCurr: state_type] :
      ( v4293(VarCurr)
    <=> v4295(VarCurr) ) ).

tff(addAssignment_1719,axiom,
    ! [VarCurr: state_type] :
      ( v4295(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1718,axiom,
    ! [VarCurr: state_type] :
      ( v4289(VarCurr)
    <=> v4291(VarCurr) ) ).

tff(addAssignment_1717,axiom,
    ! [VarCurr: state_type] :
      ( v4291(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_81,axiom,
    ! [VarCurr: state_type] :
      ( v4266(VarCurr)
    <=> ( v4277(VarCurr)
        & v2363(VarCurr,32) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_491,axiom,
    ! [VarCurr: state_type] :
      ( v4277(VarCurr)
    <=> ( v2354(VarCurr)
        & v4278(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_24,axiom,
    ! [VarCurr: state_type] :
      ( v4278(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $true )
        & ( v2358(VarCurr,9)
        <=> $true )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_152,axiom,
    ~ b0111010000000(12) ).

tff(bitBlastConstant_151,axiom,
    b0111010000000(11) ).

tff(bitBlastConstant_150,axiom,
    b0111010000000(10) ).

tff(bitBlastConstant_149,axiom,
    b0111010000000(9) ).

tff(bitBlastConstant_148,axiom,
    ~ b0111010000000(8) ).

tff(bitBlastConstant_147,axiom,
    b0111010000000(7) ).

tff(bitBlastConstant_146,axiom,
    ~ b0111010000000(6) ).

tff(bitBlastConstant_145,axiom,
    ~ b0111010000000(5) ).

tff(bitBlastConstant_144,axiom,
    ~ b0111010000000(4) ).

tff(bitBlastConstant_143,axiom,
    ~ b0111010000000(3) ).

tff(bitBlastConstant_142,axiom,
    ~ b0111010000000(2) ).

tff(bitBlastConstant_141,axiom,
    ~ b0111010000000(1) ).

tff(bitBlastConstant_140,axiom,
    ~ b0111010000000(0) ).

tff(addAssignment_1716,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,32)
    <=> v2365(VarCurr,32) ) ).

tff(addAssignment_1715,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,32)
    <=> v1119(VarCurr,32) ) ).

tff(addAssignment_1714,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,32)
    <=> v1121(VarCurr,32) ) ).

tff(addAssignment_1713,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,32)
    <=> v1123(VarCurr,32) ) ).

tff(addAssignment_1712,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,32)
    <=> v4269(VarNext,32) ) ).

tff(addCaseBooleanConditionEqualRanges1_59,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4270(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v4269(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_59,axiom,
    ! [VarNext: state_type] :
      ( v4270(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v4269(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_490,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4270(VarNext)
      <=> v4271(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_489,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4271(VarNext)
      <=> ( v4273(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4273(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1711,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,32)
    <=> v1135(VarCurr,32) ) ).

tff(addAssignment_1710,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,32)
    <=> v1137(VarCurr,32) ) ).

tff(addAssignment_1709,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,32)
    <=> v1697(VarCurr,32) ) ).

tff(addAssignment_1708,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,32)
    <=> v1141(VarCurr,32) ) ).

tff(addAssignment_1707,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,32)
    <=> v1143(VarCurr,32) ) ).

tff(addAssignment_1706,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,32)
    <=> v1145(VarCurr,32) ) ).

tff(addAssignment_1705,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,32)
    <=> v1147(VarCurr,32) ) ).

tff(addBitVectorEqualityBitBlasted_23,axiom,
    ! [VarCurr: state_type] :
      ( v4263(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $true ) ) ) ).

tff(writeUnaryOperator_353,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v4253(VarCurr,B)
      <=> ~ v4255(VarCurr,B) ) ) ).

tff(addAssignment_1704,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v4255(VarCurr,B)
      <=> v4257(VarCurr,B) ) ) ).

tff(addAssignment_1703,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,10)
        & ~ $less(B,0) )
     => ( v4257(VarCurr,B)
      <=> v4259(VarCurr,B) ) ) ).

tff(addBitVectorEqualityBitBlasted_22,axiom,
    ! [VarCurr: state_type] :
      ( v4250(VarCurr)
    <=> ( ( v4201(VarCurr,2)
        <=> $false )
        & ( v4201(VarCurr,1)
        <=> $false )
        & ( v4201(VarCurr,0)
        <=> $false ) ) ) ).

tff(addAssignment_1702,axiom,
    ! [VarCurr: state_type] :
      ( v4238(VarCurr)
    <=> v4240(VarCurr) ) ).

tff(addAssignment_1701,axiom,
    ! [VarCurr: state_type] :
      ( v4240(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1700,axiom,
    ! [VarCurr: state_type] :
      ( v4234(VarCurr)
    <=> v4236(VarCurr) ) ).

tff(addAssignment_1699,axiom,
    ! [VarCurr: state_type] :
      ( v4236(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_488,axiom,
    ! [VarCurr: state_type] :
      ( v4223(VarCurr)
    <=> ( v2354(VarCurr)
        & v4226(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_21,axiom,
    ! [VarCurr: state_type] :
      ( v4226(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $false )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $false )
        & ( v2358(VarCurr,4)
        <=> $false )
        & ( v2358(VarCurr,3)
        <=> $false )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_139,axiom,
    ~ b0100000000000(12) ).

tff(bitBlastConstant_138,axiom,
    b0100000000000(11) ).

tff(bitBlastConstant_137,axiom,
    ~ b0100000000000(10) ).

tff(bitBlastConstant_136,axiom,
    ~ b0100000000000(9) ).

tff(bitBlastConstant_135,axiom,
    ~ b0100000000000(8) ).

tff(bitBlastConstant_134,axiom,
    ~ b0100000000000(7) ).

tff(bitBlastConstant_133,axiom,
    ~ b0100000000000(6) ).

tff(bitBlastConstant_132,axiom,
    ~ b0100000000000(5) ).

tff(bitBlastConstant_131,axiom,
    ~ b0100000000000(4) ).

tff(bitBlastConstant_130,axiom,
    ~ b0100000000000(3) ).

tff(bitBlastConstant_129,axiom,
    ~ b0100000000000(2) ).

tff(bitBlastConstant_128,axiom,
    ~ b0100000000000(1) ).

tff(bitBlastConstant_127,axiom,
    ~ b0100000000000(0) ).

tff(addAssignment_1698,axiom,
    ! [VarCurr: state_type] :
      ( v4211(VarCurr)
    <=> v4213(VarCurr) ) ).

tff(addAssignment_1697,axiom,
    ! [VarCurr: state_type] :
      ( v4213(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1696,axiom,
    ! [VarCurr: state_type] :
      ( v4207(VarCurr)
    <=> v4209(VarCurr) ) ).

tff(addAssignment_1695,axiom,
    ! [VarCurr: state_type] :
      ( v4209(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1694,axiom,
    ! [VarCurr: state_type] :
      ( v4153(VarCurr)
    <=> v4155(VarCurr) ) ).

tff(addAssignment_1693,axiom,
    ! [VarCurr: state_type] :
      ( v4155(VarCurr)
    <=> v4157(VarCurr) ) ).

tff(addAssignment_1692,axiom,
    ! [VarCurr: state_type] :
      ( v4157(VarCurr)
    <=> v4159(VarCurr) ) ).

tff(addAssignment_1691,axiom,
    ! [VarCurr: state_type] :
      ( v4159(VarCurr)
    <=> v4161(VarCurr) ) ).

tff(addAssignment_1690,axiom,
    ! [VarCurr: state_type] :
      ( v4161(VarCurr)
    <=> v4163(VarCurr) ) ).

tff(addAssignment_1689,axiom,
    ! [VarCurr: state_type] :
      ( v4163(VarCurr)
    <=> v4165(VarCurr) ) ).

tff(addAssignment_1688,axiom,
    ! [VarCurr: state_type] :
      ( v4165(VarCurr)
    <=> v4167(VarCurr) ) ).

tff(addAssignment_1687,axiom,
    ! [VarCurr: state_type] :
      ( v4167(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_1686,axiom,
    ! [VarCurr: state_type] :
      ( v4137(VarCurr)
    <=> v4139(VarCurr) ) ).

tff(addAssignment_1685,axiom,
    ! [VarCurr: state_type] :
      ( v4139(VarCurr)
    <=> v4141(VarCurr) ) ).

tff(addAssignment_1684,axiom,
    ! [VarCurr: state_type] :
      ( v4141(VarCurr)
    <=> v4143(VarCurr) ) ).

tff(addAssignment_1683,axiom,
    ! [VarCurr: state_type] :
      ( v4143(VarCurr)
    <=> v4145(VarCurr) ) ).

tff(addAssignment_1682,axiom,
    ! [VarCurr: state_type] :
      ( v4145(VarCurr)
    <=> v4147(VarCurr) ) ).

tff(addAssignment_1681,axiom,
    ! [VarCurr: state_type] :
      ( v4147(VarCurr)
    <=> v4149(VarCurr) ) ).

tff(addAssignment_1680,axiom,
    ! [VarCurr: state_type] :
      ( v4149(VarCurr)
    <=> v4151(VarCurr) ) ).

tff(addAssignment_1679,axiom,
    ! [VarCurr: state_type] :
      ( v4151(VarCurr)
    <=> v22(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_487,axiom,
    ! [VarCurr: state_type] :
      ( v2940(VarCurr)
    <=> ( v4081(VarCurr)
        & v4083(VarCurr) ) ) ).

tff(writeUnaryOperator_352,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4083(VarCurr)
    <=> v3918(VarCurr,7) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_486,axiom,
    ! [VarCurr: state_type] :
      ( v4081(VarCurr)
    <=> ( v4082(VarCurr)
        & v2942(VarCurr) ) ) ).

tff(writeUnaryOperator_351,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4082(VarCurr)
    <=> v2910(VarCurr,0) ) ).

tff(addAssignment_1678,axiom,
    ! [VarCurr: state_type] :
      ( v3918(VarCurr,7)
    <=> v3920(VarCurr,7) ) ).

tff(addAssignment_1677,axiom,
    ! [VarCurr: state_type] :
      ( v3920(VarCurr,7)
    <=> v3922(VarCurr,7) ) ).

tff(addAssignment_1676,axiom,
    ! [VarNext: state_type] :
      ( v3922(VarNext,7)
    <=> v4063(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_58,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4064(VarNext)
       => ! [B: $int] :
            ( ( $less(B,9)
              & ~ $less(B,0) )
           => ( v4063(VarNext,B)
            <=> v3922(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_58,axiom,
    ! [VarNext: state_type] :
      ( v4064(VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v4063(VarNext,B)
          <=> v4074(VarNext,B) ) ) ) ).

tff(addAssignment_1675,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v4074(VarNext,B)
          <=> v4072(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_59,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4075(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v4072(VarCurr,B)
          <=> bxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_59,axiom,
    ! [VarCurr: state_type] :
      ( v4075(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,9)
            & ~ $less(B,0) )
         => ( v4072(VarCurr,B)
          <=> v3932(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_485,axiom,
    ! [VarCurr: state_type] :
      ( v4075(VarCurr)
    <=> ( v4076(VarCurr)
        & v4077(VarCurr) ) ) ).

tff(writeUnaryOperator_350,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4077(VarCurr)
    <=> v3928(VarCurr) ) ).

tff(writeUnaryOperator_349,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4076(VarCurr)
    <=> v3924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_484,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4064(VarNext)
      <=> v4065(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_483,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4065(VarNext)
      <=> ( v4066(VarNext)
          & v4059(VarNext) ) ) ) ).

tff(writeUnaryOperator_348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4066(VarNext)
      <=> v4068(VarNext) ) ) ).

tff(addAssignment_1674,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4068(VarNext)
      <=> v4059(VarCurr) ) ) ).

tff(addAssignment_1673,axiom,
    ! [VarCurr: state_type] :
      ( v4059(VarCurr)
    <=> v4061(VarCurr) ) ).

tff(addAssignment_1672,axiom,
    ! [VarCurr: state_type] :
      ( v4061(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_1671,axiom,
    ! [VarCurr: state_type] :
      ( v3932(VarCurr,7)
    <=> v3934(VarCurr,7) ) ).

tff(addAssignment_1670,axiom,
    ! [VarCurr: state_type] :
      ( v3934(VarCurr,7)
    <=> v3936(VarCurr,7) ) ).

tff(addAssignment_1669,axiom,
    ! [VarCurr: state_type] :
      ( v3936(VarCurr,7)
    <=> v4052(VarCurr,7) ) ).

tff(addAssignment_1668,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v4052(VarCurr,B)
      <=> v4056(VarCurr,B) ) ) ).

tff(addAssignment_1667,axiom,
    ! [VarCurr: state_type] :
      ( ( v4052(VarCurr,5)
      <=> v4055(VarCurr,2) )
      & ( v4052(VarCurr,4)
      <=> v4055(VarCurr,1) )
      & ( v4052(VarCurr,3)
      <=> v4055(VarCurr,0) ) ) ).

tff(addAssignment_1666,axiom,
    ! [VarCurr: state_type] :
      ( v4052(VarCurr,6)
    <=> v4054(VarCurr) ) ).

tff(addAssignment_1665,axiom,
    ! [VarCurr: state_type] :
      ( v4052(VarCurr,7)
    <=> v3938(VarCurr) ) ).

tff(addAssignment_1664,axiom,
    ! [VarCurr: state_type] :
      ( v4052(VarCurr,8)
    <=> v4053(VarCurr) ) ).

tff(addAssignment_1663,axiom,
    ! [VarCurr: state_type] :
      ( v3938(VarCurr)
    <=> v3940(VarCurr) ) ).

tff(addAssignment_1662,axiom,
    ! [VarCurr: state_type] :
      ( v3940(VarCurr)
    <=> v3942(VarCurr) ) ).

tff(addAssignment_1661,axiom,
    ! [VarCurr: state_type] :
      ( v3942(VarCurr)
    <=> v3944(VarCurr) ) ).

tff(addAssignment_1660,axiom,
    ! [VarCurr: state_type] :
      ( v3944(VarCurr)
    <=> v3946(VarCurr) ) ).

tff(addAssignment_1659,axiom,
    ! [VarCurr: state_type] :
      ( v3946(VarCurr)
    <=> v3948(VarCurr,9) ) ).

tff(addAssignment_1658,axiom,
    ! [VarCurr: state_type] :
      ( v3948(VarCurr,9)
    <=> v3950(VarCurr,9) ) ).

tff(addAssignment_1657,axiom,
    ! [VarNext: state_type] :
      ( v3950(VarNext,9)
    <=> v4035(VarNext,9) ) ).

tff(addCaseBooleanConditionEqualRanges1_57,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4036(VarNext)
       => ! [B: $int] :
            ( ( $less(B,42)
              & ~ $less(B,0) )
           => ( v4035(VarNext,B)
            <=> v3950(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_57,axiom,
    ! [VarNext: state_type] :
      ( v4036(VarNext)
     => ! [B: $int] :
          ( ( $less(B,42)
            & ~ $less(B,0) )
         => ( v4035(VarNext,B)
          <=> v4046(VarNext,B) ) ) ) ).

tff(addAssignment_1656,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,42)
            & ~ $less(B,0) )
         => ( v4046(VarNext,B)
          <=> v4044(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_58,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,42)
            & ~ $less(B,0) )
         => ( v4044(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_58,axiom,
    ! [VarCurr: state_type] :
      ( v4047(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,42)
            & ~ $less(B,0) )
         => ( v4044(VarCurr,B)
          <=> v3980(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_482,axiom,
    ! [VarCurr: state_type] :
      ( v4047(VarCurr)
    <=> ( v4048(VarCurr)
        & v4049(VarCurr) ) ) ).

tff(writeUnaryOperator_347,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4049(VarCurr)
    <=> v3966(VarCurr) ) ).

tff(writeUnaryOperator_346,axiom,
    ! [VarCurr: state_type] :
      ( ~ v4048(VarCurr)
    <=> v3952(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_481,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4036(VarNext)
      <=> v4037(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_480,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4037(VarNext)
      <=> ( v4038(VarNext)
          & v4011(VarNext) ) ) ) ).

tff(writeUnaryOperator_345,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v4038(VarNext)
      <=> v4040(VarNext) ) ) ).

tff(addAssignment_1655,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v4040(VarNext)
      <=> v4011(VarCurr) ) ) ).

tff(addAssignment_1654,axiom,
    ! [VarCurr: state_type] :
      ( v4011(VarCurr)
    <=> v4013(VarCurr) ) ).

tff(addAssignment_1653,axiom,
    ! [VarCurr: state_type] :
      ( v4013(VarCurr)
    <=> v4015(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_479,axiom,
    ! [VarCurr: state_type] :
      ( v4015(VarCurr)
    <=> ( v4033(VarCurr)
        | v4025(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_478,axiom,
    ! [VarCurr: state_type] :
      ( v4033(VarCurr)
    <=> ( v4017(VarCurr)
        & v4023(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_9,axiom,
    ( v4023(constB0)
  <=> $true ) ).

tff(addAssignment_1652,axiom,
    ! [VarCurr: state_type] :
      ( v4025(VarCurr)
    <=> v4027(VarCurr) ) ).

tff(addAssignment_1651,axiom,
    ! [VarCurr: state_type] :
      ( v4027(VarCurr)
    <=> v4029(VarCurr) ) ).

tff(addAssignment_1650,axiom,
    ! [VarCurr: state_type] :
      ( v4029(VarCurr)
    <=> v4031(VarCurr) ) ).

tff(addAssignment_1649,axiom,
    ! [VarCurr: state_type] :
      ( v4031(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addAssignment_1648,axiom,
    ! [VarCurr: state_type] :
      ( v4017(VarCurr)
    <=> v4019(VarCurr) ) ).

tff(addAssignment_1647,axiom,
    ! [VarCurr: state_type] :
      ( v4019(VarCurr)
    <=> v4021(VarCurr) ) ).

tff(addAssignment_1646,axiom,
    ! [VarCurr: state_type] :
      ( v4021(VarCurr)
    <=> v1230(VarCurr) ) ).

tff(addAssignment_1645,axiom,
    ! [VarCurr: state_type] :
      ( v3980(VarCurr,9)
    <=> v3982(VarCurr,9) ) ).

tff(addAssignment_1644,axiom,
    ! [VarCurr: state_type] :
      ( v3982(VarCurr,9)
    <=> v3987(VarCurr,9) ) ).

tff(addAssignment_1643,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,0)
    <=> v4008(VarCurr) ) ).

tff(addAssignment_1642,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,1)
    <=> v4007(VarCurr) ) ).

tff(addAssignment_1641,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,4)
      <=> v4006(VarCurr,2) )
      & ( v3987(VarCurr,3)
      <=> v4006(VarCurr,1) )
      & ( v3987(VarCurr,2)
      <=> v4006(VarCurr,0) ) ) ).

tff(addAssignment_1640,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,7)
      <=> v4005(VarCurr,2) )
      & ( v3987(VarCurr,6)
      <=> v4005(VarCurr,1) )
      & ( v3987(VarCurr,5)
      <=> v4005(VarCurr,0) ) ) ).

tff(addAssignment_1639,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,8)
    <=> v4004(VarCurr) ) ).

tff(addAssignment_1638,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,9)
    <=> v3984(VarCurr) ) ).

tff(addAssignment_1637,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,10)
    <=> v4003(VarCurr) ) ).

tff(addAssignment_1636,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,13)
      <=> v4002(VarCurr,2) )
      & ( v3987(VarCurr,12)
      <=> v4002(VarCurr,1) )
      & ( v3987(VarCurr,11)
      <=> v4002(VarCurr,0) ) ) ).

tff(addAssignment_1635,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,16)
      <=> v4001(VarCurr,2) )
      & ( v3987(VarCurr,15)
      <=> v4001(VarCurr,1) )
      & ( v3987(VarCurr,14)
      <=> v4001(VarCurr,0) ) ) ).

tff(addAssignment_1634,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,17)
    <=> v4000(VarCurr) ) ).

tff(addAssignment_1633,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,20)
      <=> v3999(VarCurr,2) )
      & ( v3987(VarCurr,19)
      <=> v3999(VarCurr,1) )
      & ( v3987(VarCurr,18)
      <=> v3999(VarCurr,0) ) ) ).

tff(addAssignment_1632,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,21)
    <=> v3998(VarCurr) ) ).

tff(addAssignment_1631,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,22)
    <=> v3997(VarCurr) ) ).

tff(addAssignment_1630,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,25)
      <=> v3996(VarCurr,2) )
      & ( v3987(VarCurr,24)
      <=> v3996(VarCurr,1) )
      & ( v3987(VarCurr,23)
      <=> v3996(VarCurr,0) ) ) ).

tff(addAssignment_1629,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,28)
      <=> v3995(VarCurr,2) )
      & ( v3987(VarCurr,27)
      <=> v3995(VarCurr,1) )
      & ( v3987(VarCurr,26)
      <=> v3995(VarCurr,0) ) ) ).

tff(addAssignment_1628,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,29)
    <=> v3994(VarCurr) ) ).

tff(addAssignment_1627,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,32)
      <=> v3993(VarCurr,2) )
      & ( v3987(VarCurr,31)
      <=> v3993(VarCurr,1) )
      & ( v3987(VarCurr,30)
      <=> v3993(VarCurr,0) ) ) ).

tff(addAssignment_1626,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,33)
    <=> v3992(VarCurr) ) ).

tff(addAssignment_1625,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,34)
    <=> v3991(VarCurr) ) ).

tff(addAssignment_1624,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,37)
      <=> v3990(VarCurr,2) )
      & ( v3987(VarCurr,36)
      <=> v3990(VarCurr,1) )
      & ( v3987(VarCurr,35)
      <=> v3990(VarCurr,0) ) ) ).

tff(addAssignment_1623,axiom,
    ! [VarCurr: state_type] :
      ( ( v3987(VarCurr,40)
      <=> v3989(VarCurr,2) )
      & ( v3987(VarCurr,39)
      <=> v3989(VarCurr,1) )
      & ( v3987(VarCurr,38)
      <=> v3989(VarCurr,0) ) ) ).

tff(addAssignment_1622,axiom,
    ! [VarCurr: state_type] :
      ( v3987(VarCurr,41)
    <=> v3988(VarCurr) ) ).

tff(addAssignment_1621,axiom,
    ! [VarCurr: state_type] :
      ( v3984(VarCurr)
    <=> v3986(VarCurr) ) ).

tff(addAssignment_1620,axiom,
    ! [VarCurr: state_type] :
      ( v3986(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1619,axiom,
    ! [VarCurr: state_type] :
      ( v3966(VarCurr)
    <=> v3968(VarCurr) ) ).

tff(addAssignment_1618,axiom,
    ! [VarCurr: state_type] :
      ( v3968(VarCurr)
    <=> v3970(VarCurr) ) ).

tff(addAssignment_1617,axiom,
    ! [VarCurr: state_type] :
      ( v3970(VarCurr)
    <=> v3972(VarCurr) ) ).

tff(addAssignment_1616,axiom,
    ! [VarCurr: state_type] :
      ( v3972(VarCurr)
    <=> v3974(VarCurr) ) ).

tff(addAssignment_1615,axiom,
    ! [VarCurr: state_type] :
      ( v3974(VarCurr)
    <=> v3976(VarCurr) ) ).

tff(addAssignment_1614,axiom,
    ! [VarCurr: state_type] :
      ( v3976(VarCurr)
    <=> v3978(VarCurr) ) ).

tff(addAssignment_1613,axiom,
    ! [VarCurr: state_type] :
      ( v3978(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_1612,axiom,
    ! [VarCurr: state_type] :
      ( v3952(VarCurr)
    <=> v3954(VarCurr) ) ).

tff(addAssignment_1611,axiom,
    ! [VarCurr: state_type] :
      ( v3954(VarCurr)
    <=> v3956(VarCurr) ) ).

tff(addAssignment_1610,axiom,
    ! [VarCurr: state_type] :
      ( v3956(VarCurr)
    <=> v3958(VarCurr) ) ).

tff(addAssignment_1609,axiom,
    ! [VarCurr: state_type] :
      ( v3958(VarCurr)
    <=> v3960(VarCurr) ) ).

tff(addAssignment_1608,axiom,
    ! [VarCurr: state_type] :
      ( v3960(VarCurr)
    <=> v3962(VarCurr) ) ).

tff(addAssignment_1607,axiom,
    ! [VarCurr: state_type] :
      ( v3962(VarCurr)
    <=> v3964(VarCurr) ) ).

tff(addAssignment_1606,axiom,
    ! [VarCurr: state_type] :
      ( v3964(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_1605,axiom,
    ! [VarCurr: state_type] :
      ( v3928(VarCurr)
    <=> v3930(VarCurr) ) ).

tff(addAssignment_1604,axiom,
    ! [VarCurr: state_type] :
      ( v3930(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_1603,axiom,
    ! [VarCurr: state_type] :
      ( v3924(VarCurr)
    <=> v3926(VarCurr) ) ).

tff(addAssignment_1602,axiom,
    ! [VarCurr: state_type] :
      ( v3926(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_1601,axiom,
    ! [VarCurr: state_type] :
      ( v2942(VarCurr)
    <=> v2944(VarCurr,5) ) ).

tff(addAssignment_1600,axiom,
    ! [VarCurr: state_type] :
      ( v2944(VarCurr,5)
    <=> v2946(VarCurr,5) ) ).

tff(addAssignment_1599,axiom,
    ! [VarNext: state_type] :
      ( v2946(VarNext,5)
    <=> v3900(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_56,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3901(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v3900(VarNext,B)
            <=> v2946(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_56,axiom,
    ! [VarNext: state_type] :
      ( v3901(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3900(VarNext,B)
          <=> v3911(VarNext,B) ) ) ) ).

tff(addAssignment_1598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3911(VarNext,B)
          <=> v3909(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_57,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3909(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_57,axiom,
    ! [VarCurr: state_type] :
      ( v3912(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3909(VarCurr,B)
          <=> v2956(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_477,axiom,
    ! [VarCurr: state_type] :
      ( v3912(VarCurr)
    <=> ( v3913(VarCurr)
        & v3914(VarCurr) ) ) ).

tff(writeUnaryOperator_344,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3914(VarCurr)
    <=> v2952(VarCurr) ) ).

tff(writeUnaryOperator_343,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3913(VarCurr)
    <=> v2948(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3901(VarNext)
      <=> v3902(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3902(VarNext)
      <=> ( v3903(VarNext)
          & v3894(VarNext) ) ) ) ).

tff(writeUnaryOperator_342,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3903(VarNext)
      <=> v3905(VarNext) ) ) ).

tff(addAssignment_1597,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3905(VarNext)
      <=> v3894(VarCurr) ) ) ).

tff(addAssignment_1596,axiom,
    ! [VarCurr: state_type] :
      ( v3894(VarCurr)
    <=> v3896(VarCurr) ) ).

tff(addAssignment_1595,axiom,
    ! [VarCurr: state_type] :
      ( v3896(VarCurr)
    <=> v3898(VarCurr) ) ).

tff(addAssignment_1594,axiom,
    ! [VarCurr: state_type] :
      ( v3898(VarCurr)
    <=> v216(VarCurr) ) ).

tff(addAssignment_1593,axiom,
    ! [VarCurr: state_type] :
      ( v2956(VarCurr,5)
    <=> v2958(VarCurr,5) ) ).

tff(addAssignment_1592,axiom,
    ! [VarCurr: state_type] :
      ( v2958(VarCurr,5)
    <=> v2960(VarCurr,5) ) ).

tff(addAssignment_1591,axiom,
    ! [VarCurr: state_type] :
      ( v2960(VarCurr,5)
    <=> v3890(VarCurr,5) ) ).

tff(addAssignment_1590,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v3890(VarCurr,B)
      <=> v3892(VarCurr,B) ) ) ).

tff(addAssignment_1589,axiom,
    ! [VarCurr: state_type] :
      ( v3890(VarCurr,4)
    <=> v3891(VarCurr) ) ).

tff(addAssignment_1588,axiom,
    ! [VarCurr: state_type] :
      ( v3890(VarCurr,5)
    <=> v2962(VarCurr) ) ).

tff(addAssignment_1587,axiom,
    ! [VarCurr: state_type] :
      ( v2962(VarCurr)
    <=> v2964(VarCurr) ) ).

tff(addAssignment_1586,axiom,
    ! [VarCurr: state_type] :
      ( v2964(VarCurr)
    <=> v2966(VarCurr) ) ).

tff(addAssignment_1585,axiom,
    ! [VarCurr: state_type] :
      ( v2966(VarCurr)
    <=> v2968(VarCurr) ) ).

tff(addAssignment_1584,axiom,
    ! [VarCurr: state_type] :
      ( v2968(VarCurr)
    <=> v2970(VarCurr) ) ).

tff(addAssignment_1583,axiom,
    ! [VarCurr: state_type] :
      ( v2970(VarCurr)
    <=> v2972(VarCurr,1) ) ).

tff(addAssignment_1582,axiom,
    ! [VarCurr: state_type] :
      ( v2972(VarCurr,1)
    <=> v2974(VarCurr,1) ) ).

tff(addAssignment_1581,axiom,
    ! [VarNext: state_type] :
      ( v2974(VarNext,1)
    <=> v3873(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_55,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3874(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v3873(VarNext,B)
            <=> v2974(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_55,axiom,
    ! [VarNext: state_type] :
      ( v3874(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v3873(VarNext,B)
          <=> v3884(VarNext,B) ) ) ) ).

tff(addAssignment_1580,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v3884(VarNext,B)
          <=> v3882(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_56,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3885(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v3882(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_56,axiom,
    ! [VarCurr: state_type] :
      ( v3885(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v3882(VarCurr,B)
          <=> v2992(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_474,axiom,
    ! [VarCurr: state_type] :
      ( v3885(VarCurr)
    <=> ( v3886(VarCurr)
        & v3887(VarCurr) ) ) ).

tff(writeUnaryOperator_341,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3887(VarCurr)
    <=> v2984(VarCurr) ) ).

tff(writeUnaryOperator_340,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3886(VarCurr)
    <=> v2976(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_473,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3874(VarNext)
      <=> v3875(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_472,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3875(VarNext)
      <=> ( v3876(VarNext)
          & v3869(VarNext) ) ) ) ).

tff(writeUnaryOperator_339,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3876(VarNext)
      <=> v3878(VarNext) ) ) ).

tff(addAssignment_1579,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3878(VarNext)
      <=> v3869(VarCurr) ) ) ).

tff(addAssignment_1578,axiom,
    ! [VarCurr: state_type] :
      ( v3869(VarCurr)
    <=> v3871(VarCurr) ) ).

tff(addAssignment_1577,axiom,
    ! [VarCurr: state_type] :
      ( v3871(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1576,axiom,
    ! [VarCurr: state_type] :
      ( v2992(VarCurr,1)
    <=> v2994(VarCurr,1) ) ).

tff(addAssignment_1575,axiom,
    ! [VarCurr: state_type] :
      ( v2994(VarCurr,1)
    <=> v3860(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_26,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3860(VarCurr,B)
      <=> ( v3861(VarCurr,B)
          | v3864(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_25,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3864(VarCurr,B)
      <=> ( v2972(VarCurr,B)
          & v3865(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_338,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3865(VarCurr,B)
      <=> ~ v3866(VarCurr,B) ) ) ).

tff(addAssignment_1574,axiom,
    ! [VarCurr: state_type] :
      ( v3866(VarCurr,0)
    <=> v3867(VarCurr) ) ).

tff(addAssignment_1573,axiom,
    ! [VarCurr: state_type] :
      ( v3866(VarCurr,1)
    <=> v3867(VarCurr) ) ).

tff(addAssignment_1572,axiom,
    ! [VarCurr: state_type] :
      ( v3867(VarCurr)
    <=> v3859(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_24,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v3861(VarCurr,B)
      <=> ( v2996(VarCurr,B)
          & v3862(VarCurr,B) ) ) ) ).

tff(addAssignment_1571,axiom,
    ! [VarCurr: state_type] :
      ( v3862(VarCurr,0)
    <=> v3863(VarCurr) ) ).

tff(addAssignment_1570,axiom,
    ! [VarCurr: state_type] :
      ( v3862(VarCurr,1)
    <=> v3863(VarCurr) ) ).

tff(addAssignment_1569,axiom,
    ! [VarCurr: state_type] :
      ( v3863(VarCurr)
    <=> v3859(VarCurr) ) ).

tff(addAssignment_1568,axiom,
    ! [VarCurr: state_type] :
      ( v3859(VarCurr)
    <=> v3799(VarCurr) ) ).

tff(addAssignment_1567,axiom,
    ! [VarCurr: state_type] :
      ( v2996(VarCurr,1)
    <=> v3856(VarCurr,1) ) ).

tff(addAssignment_1566,axiom,
    ! [VarCurr: state_type] :
      ( v3856(VarCurr,0)
    <=> v3857(VarCurr) ) ).

tff(addAssignment_1565,axiom,
    ! [VarCurr: state_type] :
      ( v3856(VarCurr,1)
    <=> v2998(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_471,axiom,
    ! [VarCurr: state_type] :
      ( v2998(VarCurr)
    <=> ( v3847(VarCurr)
        & v3799(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_470,axiom,
    ! [VarCurr: state_type] :
      ( v3847(VarCurr)
    <=> ( v3848(VarCurr)
        & v3069(VarCurr) ) ) ).

tff(writeUnaryOperator_337,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3848(VarCurr)
    <=> v3849(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_469,axiom,
    ! [VarCurr: state_type] :
      ( v3849(VarCurr)
    <=> ( v3850(VarCurr)
        & v3591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_468,axiom,
    ! [VarCurr: state_type] :
      ( v3850(VarCurr)
    <=> ( v3851(VarCurr)
        & v3525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_467,axiom,
    ! [VarCurr: state_type] :
      ( v3851(VarCurr)
    <=> ( v3852(VarCurr)
        & v3459(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_466,axiom,
    ! [VarCurr: state_type] :
      ( v3852(VarCurr)
    <=> ( v3853(VarCurr)
        & v3393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_465,axiom,
    ! [VarCurr: state_type] :
      ( v3853(VarCurr)
    <=> ( v3854(VarCurr)
        & v3327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_464,axiom,
    ! [VarCurr: state_type] :
      ( v3854(VarCurr)
    <=> ( v3855(VarCurr)
        & v3261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_463,axiom,
    ! [VarCurr: state_type] :
      ( v3855(VarCurr)
    <=> ( v3000(VarCurr)
        & v3195(VarCurr) ) ) ).

tff(addAssignment_1564,axiom,
    ! [VarCurr: state_type] :
      ( v3799(VarCurr)
    <=> v3801(VarCurr,1) ) ).

tff(addAssignment_1563,axiom,
    ! [VarCurr: state_type] :
      ( v3801(VarCurr,1)
    <=> v3803(VarCurr,1) ) ).

tff(addAssignment_1562,axiom,
    ! [VarNext: state_type] :
      ( v3803(VarNext,1)
    <=> v3829(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_54,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3830(VarNext)
       => ! [B: $int] :
            ( ( $less(B,3)
              & ~ $less(B,0) )
           => ( v3829(VarNext,B)
            <=> v3803(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_54,axiom,
    ! [VarNext: state_type] :
      ( v3830(VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3829(VarNext,B)
          <=> v3840(VarNext,B) ) ) ) ).

tff(addAssignment_1561,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3840(VarNext,B)
          <=> v3838(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_55,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3841(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3838(VarCurr,B)
          <=> bxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_55,axiom,
    ! [VarCurr: state_type] :
      ( v3841(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3838(VarCurr,B)
          <=> v3813(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_462,axiom,
    ! [VarCurr: state_type] :
      ( v3841(VarCurr)
    <=> ( v3842(VarCurr)
        & v3843(VarCurr) ) ) ).

tff(writeUnaryOperator_336,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3843(VarCurr)
    <=> v3809(VarCurr) ) ).

tff(writeUnaryOperator_335,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3842(VarCurr)
    <=> v3805(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_461,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3830(VarNext)
      <=> v3831(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_460,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3831(VarNext)
      <=> ( v3832(VarNext)
          & v3825(VarNext) ) ) ) ).

tff(writeUnaryOperator_334,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3832(VarNext)
      <=> v3834(VarNext) ) ) ).

tff(addAssignment_1560,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3834(VarNext)
      <=> v3825(VarCurr) ) ) ).

tff(addAssignment_1559,axiom,
    ! [VarCurr: state_type] :
      ( v3825(VarCurr)
    <=> v3827(VarCurr) ) ).

tff(addAssignment_1558,axiom,
    ! [VarCurr: state_type] :
      ( v3827(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1557,axiom,
    ! [VarCurr: state_type] :
      ( v3813(VarCurr,1)
    <=> v3815(VarCurr,1) ) ).

tff(addAssignment_1556,axiom,
    ! [VarCurr: state_type] :
      ( v3815(VarCurr,1)
    <=> v3817(VarCurr,1) ) ).

tff(addAssignment_1555,axiom,
    ! [VarCurr: state_type] :
      ( v3817(VarCurr,1)
    <=> v3820(VarCurr,1) ) ).

tff(addAssignment_1554,axiom,
    ! [VarCurr: state_type] :
      ( v3820(VarCurr,0)
    <=> v3822(VarCurr) ) ).

tff(addAssignment_1553,axiom,
    ! [VarCurr: state_type] :
      ( v3820(VarCurr,1)
    <=> v3819(VarCurr) ) ).

tff(addAssignment_1552,axiom,
    ! [VarCurr: state_type] :
      ( v3820(VarCurr,2)
    <=> v3821(VarCurr) ) ).

tff(addAssignment_1551,axiom,
    ! [VarCurr: state_type] :
      ( v3819(VarCurr)
    <=> v1631(VarCurr) ) ).

tff(addAssignment_1550,axiom,
    ! [VarCurr: state_type] :
      ( v3809(VarCurr)
    <=> v3811(VarCurr) ) ).

tff(addAssignment_1549,axiom,
    ! [VarCurr: state_type] :
      ( v3811(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1548,axiom,
    ! [VarCurr: state_type] :
      ( v3805(VarCurr)
    <=> v3807(VarCurr) ) ).

tff(addAssignment_1547,axiom,
    ! [VarCurr: state_type] :
      ( v3807(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1546,axiom,
    ! [VarCurr: state_type] :
      ( v3000(VarCurr)
    <=> v3002(VarCurr) ) ).

tff(addAssignment_1545,axiom,
    ! [VarCurr: state_type] :
      ( v3002(VarCurr)
    <=> v3004(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_53,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3782(VarNext)
       => ( v3004(VarNext)
        <=> v3004(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_53,axiom,
    ! [VarNext: state_type] :
      ( v3782(VarNext)
     => ( v3004(VarNext)
      <=> v3792(VarNext) ) ) ).

tff(addAssignment_1544,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3792(VarNext)
      <=> v3790(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_54,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3793(VarCurr)
     => ( v3790(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_54,axiom,
    ! [VarCurr: state_type] :
      ( v3793(VarCurr)
     => ( v3790(VarCurr)
      <=> v3014(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_459,axiom,
    ! [VarCurr: state_type] :
      ( v3793(VarCurr)
    <=> ( v3794(VarCurr)
        & v3795(VarCurr) ) ) ).

tff(writeUnaryOperator_333,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3795(VarCurr)
    <=> v3010(VarCurr) ) ).

tff(writeUnaryOperator_332,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3794(VarCurr)
    <=> v3006(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_458,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3782(VarNext)
      <=> v3783(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3783(VarNext)
      <=> ( v3784(VarNext)
          & v3777(VarNext) ) ) ) ).

tff(writeUnaryOperator_331,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3784(VarNext)
      <=> v3786(VarNext) ) ) ).

tff(addAssignment_1543,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3786(VarNext)
      <=> v3777(VarCurr) ) ) ).

tff(addAssignment_1542,axiom,
    ! [VarCurr: state_type] :
      ( v3777(VarCurr)
    <=> v3779(VarCurr) ) ).

tff(addAssignment_1541,axiom,
    ! [VarCurr: state_type] :
      ( v3779(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1540,axiom,
    ! [VarCurr: state_type] :
      ( v3014(VarCurr)
    <=> v3016(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_456,axiom,
    ! [VarCurr: state_type] :
      ( v3016(VarCurr)
    <=> ( v3769(VarCurr)
        | v3772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_455,axiom,
    ! [VarCurr: state_type] :
      ( v3772(VarCurr)
    <=> ( v3002(VarCurr)
        & v3773(VarCurr) ) ) ).

tff(writeUnaryOperator_330,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3773(VarCurr)
    <=> v3774(VarCurr) ) ).

tff(addAssignment_1539,axiom,
    ! [VarCurr: state_type] :
      ( v3774(VarCurr)
    <=> v3775(VarCurr) ) ).

tff(addAssignment_1538,axiom,
    ! [VarCurr: state_type] :
      ( v3775(VarCurr)
    <=> v3029(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_454,axiom,
    ! [VarCurr: state_type] :
      ( v3769(VarCurr)
    <=> ( v3018(VarCurr)
        & v3770(VarCurr) ) ) ).

tff(addAssignment_1537,axiom,
    ! [VarCurr: state_type] :
      ( v3770(VarCurr)
    <=> v3771(VarCurr) ) ).

tff(addAssignment_1536,axiom,
    ! [VarCurr: state_type] :
      ( v3771(VarCurr)
    <=> v3029(VarCurr) ) ).

tff(addAssignment_1535,axiom,
    ! [VarCurr: state_type] :
      ( v3029(VarCurr)
    <=> v3031(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_453,axiom,
    ! [VarCurr: state_type] :
      ( v3031(VarCurr)
    <=> ( v3022(VarCurr,0)
        | v3762(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_452,axiom,
    ! [VarCurr: state_type] :
      ( v3762(VarCurr)
    <=> ( v3763(VarCurr)
        & v3767(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_20,axiom,
    ! [VarCurr: state_type] :
      ( v3767(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $false )
        & ( v3047(VarCurr,4)
        <=> $false )
        & ( v3047(VarCurr,3)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_451,axiom,
    ! [VarCurr: state_type] :
      ( v3763(VarCurr)
    <=> ( v3764(VarCurr)
        & v3766(VarCurr) ) ) ).

tff(writeUnaryOperator_329,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3766(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_450,axiom,
    ! [VarCurr: state_type] :
      ( v3764(VarCurr)
    <=> ( v3765(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_328,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3765(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1534,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3047(VarCurr,B)
      <=> v3049(VarCurr,B) ) ) ).

tff(addAssignment_1533,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3049(VarCurr,B)
      <=> v3051(VarCurr,B) ) ) ).

tff(addAssignment_1532,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3051(VarNext,B)
      <=> v3744(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_52,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3745(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v3744(VarNext,B)
            <=> v3051(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_52,axiom,
    ! [VarNext: state_type] :
      ( v3745(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3744(VarNext,B)
          <=> v3755(VarNext,B) ) ) ) ).

tff(addAssignment_1531,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3755(VarNext,B)
          <=> v3753(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_53,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3756(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3753(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_53,axiom,
    ! [VarCurr: state_type] :
      ( v3756(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3753(VarCurr,B)
          <=> v3061(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_449,axiom,
    ! [VarCurr: state_type] :
      ( v3756(VarCurr)
    <=> ( v3757(VarCurr)
        & v3758(VarCurr) ) ) ).

tff(writeUnaryOperator_327,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3758(VarCurr)
    <=> v3057(VarCurr) ) ).

tff(writeUnaryOperator_326,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3757(VarCurr)
    <=> v3053(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_448,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3745(VarNext)
      <=> v3746(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_447,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3746(VarNext)
      <=> ( v3747(VarNext)
          & v3740(VarNext) ) ) ) ).

tff(writeUnaryOperator_325,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3747(VarNext)
      <=> v3749(VarNext) ) ) ).

tff(addAssignment_1530,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3749(VarNext)
      <=> v3740(VarCurr) ) ) ).

tff(addAssignment_1529,axiom,
    ! [VarCurr: state_type] :
      ( v3740(VarCurr)
    <=> v3742(VarCurr) ) ).

tff(addAssignment_1528,axiom,
    ! [VarCurr: state_type] :
      ( v3742(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1527,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3061(VarCurr,B)
      <=> v3063(VarCurr,B) ) ) ).

tff(addAssignment_1526,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3063(VarCurr,B)
      <=> v3065(VarCurr,B) ) ) ).

tff(addAssignment_1525,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3065(VarCurr,B)
      <=> v3067(VarCurr,B) ) ) ).

tff(addAssignment_1524,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3067(VarCurr,B)
      <=> v3666(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_52,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3039(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3666(VarCurr,B)
          <=> v3681(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_52,axiom,
    ! [VarCurr: state_type] :
      ( v3039(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3666(VarCurr,B)
          <=> v3667(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_51,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3682(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3681(VarCurr,B)
          <=> v3686(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_51,axiom,
    ! [VarCurr: state_type] :
      ( v3682(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3681(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_126,axiom,
    ~ b000000(5) ).

tff(bitBlastConstant_125,axiom,
    ~ b000000(4) ).

tff(bitBlastConstant_124,axiom,
    ~ b000000(3) ).

tff(bitBlastConstant_123,axiom,
    ~ b000000(2) ).

tff(bitBlastConstant_122,axiom,
    ~ b000000(1) ).

tff(bitBlastConstant_121,axiom,
    ~ b000000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_50,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3686(VarCurr,B)
          <=> v3691(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_50,axiom,
    ! [VarCurr: state_type] :
      ( v3687(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3686(VarCurr,B)
          <=> b001000(B) ) ) ) ).

tff(bitBlastConstant_120,axiom,
    ~ b001000(5) ).

tff(bitBlastConstant_119,axiom,
    ~ b001000(4) ).

tff(bitBlastConstant_118,axiom,
    b001000(3) ).

tff(bitBlastConstant_117,axiom,
    ~ b001000(2) ).

tff(bitBlastConstant_116,axiom,
    ~ b001000(1) ).

tff(bitBlastConstant_115,axiom,
    ~ b001000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_49,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3691(VarCurr,B)
          <=> v3696(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_49,axiom,
    ! [VarCurr: state_type] :
      ( v3692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3691(VarCurr,B)
          <=> b010000(B) ) ) ) ).

tff(bitBlastConstant_114,axiom,
    ~ b010000(5) ).

tff(bitBlastConstant_113,axiom,
    b010000(4) ).

tff(bitBlastConstant_112,axiom,
    ~ b010000(3) ).

tff(bitBlastConstant_111,axiom,
    ~ b010000(2) ).

tff(bitBlastConstant_110,axiom,
    ~ b010000(1) ).

tff(bitBlastConstant_109,axiom,
    ~ b010000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_48,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3696(VarCurr,B)
          <=> v3701(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_48,axiom,
    ! [VarCurr: state_type] :
      ( v3697(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3696(VarCurr,B)
          <=> b011000(B) ) ) ) ).

tff(bitBlastConstant_108,axiom,
    ~ b011000(5) ).

tff(bitBlastConstant_107,axiom,
    b011000(4) ).

tff(bitBlastConstant_106,axiom,
    b011000(3) ).

tff(bitBlastConstant_105,axiom,
    ~ b011000(2) ).

tff(bitBlastConstant_104,axiom,
    ~ b011000(1) ).

tff(bitBlastConstant_103,axiom,
    ~ b011000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_47,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3702(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3701(VarCurr,B)
          <=> v3706(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_47,axiom,
    ! [VarCurr: state_type] :
      ( v3702(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3701(VarCurr,B)
          <=> b100000(B) ) ) ) ).

tff(bitBlastConstant_102,axiom,
    b100000(5) ).

tff(bitBlastConstant_101,axiom,
    ~ b100000(4) ).

tff(bitBlastConstant_100,axiom,
    ~ b100000(3) ).

tff(bitBlastConstant_99,axiom,
    ~ b100000(2) ).

tff(bitBlastConstant_98,axiom,
    ~ b100000(1) ).

tff(bitBlastConstant_97,axiom,
    ~ b100000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_46,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3706(VarCurr,B)
          <=> v3711(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_46,axiom,
    ! [VarCurr: state_type] :
      ( v3707(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3706(VarCurr,B)
          <=> b101000(B) ) ) ) ).

tff(bitBlastConstant_96,axiom,
    b101000(5) ).

tff(bitBlastConstant_95,axiom,
    ~ b101000(4) ).

tff(bitBlastConstant_94,axiom,
    b101000(3) ).

tff(bitBlastConstant_93,axiom,
    ~ b101000(2) ).

tff(bitBlastConstant_92,axiom,
    ~ b101000(1) ).

tff(bitBlastConstant_91,axiom,
    ~ b101000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_45,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3712(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3711(VarCurr,B)
          <=> v3716(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_45,axiom,
    ! [VarCurr: state_type] :
      ( v3712(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3711(VarCurr,B)
          <=> b110000(B) ) ) ) ).

tff(bitBlastConstant_90,axiom,
    b110000(5) ).

tff(bitBlastConstant_89,axiom,
    b110000(4) ).

tff(bitBlastConstant_88,axiom,
    ~ b110000(3) ).

tff(bitBlastConstant_87,axiom,
    ~ b110000(2) ).

tff(bitBlastConstant_86,axiom,
    ~ b110000(1) ).

tff(bitBlastConstant_85,axiom,
    ~ b110000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_44,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3717(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3716(VarCurr,B)
          <=> v3721(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_44,axiom,
    ! [VarCurr: state_type] :
      ( v3717(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3716(VarCurr,B)
          <=> b111000(B) ) ) ) ).

tff(bitBlastConstant_84,axiom,
    b111000(5) ).

tff(bitBlastConstant_83,axiom,
    b111000(4) ).

tff(bitBlastConstant_82,axiom,
    b111000(3) ).

tff(bitBlastConstant_81,axiom,
    ~ b111000(2) ).

tff(bitBlastConstant_80,axiom,
    ~ b111000(1) ).

tff(bitBlastConstant_79,axiom,
    ~ b111000(0) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_43,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3722(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3721(VarCurr,B)
          <=> v3047(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_43,axiom,
    ! [VarCurr: state_type] :
      ( v3722(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v3721(VarCurr,B)
          <=> v3738(VarCurr,B) ) ) ) ).

tff(addAssignment_1523,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v3738(VarCurr,B)
      <=> $false ) ) ).

tff(addAssignment_1522,axiom,
    ! [VarCurr: state_type] :
      ( ( v3738(VarCurr,5)
      <=> v3657(VarCurr,2) )
      & ( v3738(VarCurr,4)
      <=> v3657(VarCurr,1) )
      & ( v3738(VarCurr,3)
      <=> v3657(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_446,axiom,
    ! [VarCurr: state_type] :
      ( v3722(VarCurr)
    <=> ( v3723(VarCurr)
        & v3730(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_80,axiom,
    ! [VarCurr: state_type] :
      ( v3730(VarCurr)
    <=> ( v3732(VarCurr)
        | v3022(VarCurr,7) ) ) ).

tff(writeBinaryOperatorShiftedRanges_79,axiom,
    ! [VarCurr: state_type] :
      ( v3732(VarCurr)
    <=> ( v3733(VarCurr)
        | v3022(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_78,axiom,
    ! [VarCurr: state_type] :
      ( v3733(VarCurr)
    <=> ( v3734(VarCurr)
        | v3022(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_77,axiom,
    ! [VarCurr: state_type] :
      ( v3734(VarCurr)
    <=> ( v3735(VarCurr)
        | v3022(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_76,axiom,
    ! [VarCurr: state_type] :
      ( v3735(VarCurr)
    <=> ( v3736(VarCurr)
        | v3022(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_75,axiom,
    ! [VarCurr: state_type] :
      ( v3736(VarCurr)
    <=> ( v3737(VarCurr)
        | v3022(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_74,axiom,
    ! [VarCurr: state_type] :
      ( v3737(VarCurr)
    <=> ( v3022(VarCurr,0)
        | v3022(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_445,axiom,
    ! [VarCurr: state_type] :
      ( v3723(VarCurr)
    <=> ( v3724(VarCurr)
        & v3591(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_444,axiom,
    ! [VarCurr: state_type] :
      ( v3724(VarCurr)
    <=> ( v3725(VarCurr)
        & v3525(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_443,axiom,
    ! [VarCurr: state_type] :
      ( v3725(VarCurr)
    <=> ( v3726(VarCurr)
        & v3459(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_442,axiom,
    ! [VarCurr: state_type] :
      ( v3726(VarCurr)
    <=> ( v3727(VarCurr)
        & v3393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_441,axiom,
    ! [VarCurr: state_type] :
      ( v3727(VarCurr)
    <=> ( v3728(VarCurr)
        & v3327(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_440,axiom,
    ! [VarCurr: state_type] :
      ( v3728(VarCurr)
    <=> ( v3729(VarCurr)
        & v3261(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_439,axiom,
    ! [VarCurr: state_type] :
      ( v3729(VarCurr)
    <=> ( v3000(VarCurr)
        & v3195(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_438,axiom,
    ! [VarCurr: state_type] :
      ( v3717(VarCurr)
    <=> ( v3718(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_437,axiom,
    ! [VarCurr: state_type] :
      ( v3718(VarCurr)
    <=> ( v3719(VarCurr)
        & v3720(VarCurr) ) ) ).

tff(writeUnaryOperator_324,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3720(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_323,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3719(VarCurr)
    <=> v3591(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_436,axiom,
    ! [VarCurr: state_type] :
      ( v3712(VarCurr)
    <=> ( v3713(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_435,axiom,
    ! [VarCurr: state_type] :
      ( v3713(VarCurr)
    <=> ( v3714(VarCurr)
        & v3715(VarCurr) ) ) ).

tff(writeUnaryOperator_322,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3715(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_321,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3714(VarCurr)
    <=> v3525(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_434,axiom,
    ! [VarCurr: state_type] :
      ( v3707(VarCurr)
    <=> ( v3708(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_433,axiom,
    ! [VarCurr: state_type] :
      ( v3708(VarCurr)
    <=> ( v3709(VarCurr)
        & v3710(VarCurr) ) ) ).

tff(writeUnaryOperator_320,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3710(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_319,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3709(VarCurr)
    <=> v3459(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_432,axiom,
    ! [VarCurr: state_type] :
      ( v3702(VarCurr)
    <=> ( v3703(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_431,axiom,
    ! [VarCurr: state_type] :
      ( v3703(VarCurr)
    <=> ( v3704(VarCurr)
        & v3705(VarCurr) ) ) ).

tff(writeUnaryOperator_318,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3705(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_317,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3704(VarCurr)
    <=> v3393(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_430,axiom,
    ! [VarCurr: state_type] :
      ( v3697(VarCurr)
    <=> ( v3698(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_429,axiom,
    ! [VarCurr: state_type] :
      ( v3698(VarCurr)
    <=> ( v3699(VarCurr)
        & v3700(VarCurr) ) ) ).

tff(writeUnaryOperator_316,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3700(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_315,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3699(VarCurr)
    <=> v3327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_428,axiom,
    ! [VarCurr: state_type] :
      ( v3692(VarCurr)
    <=> ( v3693(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_427,axiom,
    ! [VarCurr: state_type] :
      ( v3693(VarCurr)
    <=> ( v3694(VarCurr)
        & v3695(VarCurr) ) ) ).

tff(writeUnaryOperator_314,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3695(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_313,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3694(VarCurr)
    <=> v3261(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_426,axiom,
    ! [VarCurr: state_type] :
      ( v3687(VarCurr)
    <=> ( v3688(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_425,axiom,
    ! [VarCurr: state_type] :
      ( v3688(VarCurr)
    <=> ( v3689(VarCurr)
        & v3690(VarCurr) ) ) ).

tff(writeUnaryOperator_312,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3690(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_311,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3689(VarCurr)
    <=> v3195(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_424,axiom,
    ! [VarCurr: state_type] :
      ( v3682(VarCurr)
    <=> ( v3683(VarCurr)
        & v3045(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_423,axiom,
    ! [VarCurr: state_type] :
      ( v3683(VarCurr)
    <=> ( v3684(VarCurr)
        & v3685(VarCurr) ) ) ).

tff(writeUnaryOperator_310,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3685(VarCurr)
    <=> v3069(VarCurr) ) ).

tff(writeUnaryOperator_309,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3684(VarCurr)
    <=> v3000(VarCurr) ) ).

tff(addAssignment_1521,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,3)
        & ~ $less(B,0) )
     => ( v3667(VarCurr,B)
      <=> v3668(VarCurr,B) ) ) ).

tff(addAssignment_1520,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,3) )
     => ( v3667(VarCurr,B)
      <=> v3047(VarCurr,B) ) ) ).

tff(addAssignment_1519,axiom,
    ! [VarCurr: state_type] :
      ( v3668(VarCurr,0)
    <=> v3678(VarCurr) ) ).

tff(addAssignment_1518,axiom,
    ! [VarCurr: state_type] :
      ( v3668(VarCurr,1)
    <=> v3676(VarCurr) ) ).

tff(addAssignment_1517,axiom,
    ! [VarCurr: state_type] :
      ( v3668(VarCurr,2)
    <=> v3670(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_422,axiom,
    ! [VarCurr: state_type] :
      ( v3676(VarCurr)
    <=> ( v3677(VarCurr)
        & v3680(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_73,axiom,
    ! [VarCurr: state_type] :
      ( v3680(VarCurr)
    <=> ( v3047(VarCurr,0)
        | v3047(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_421,axiom,
    ! [VarCurr: state_type] :
      ( v3677(VarCurr)
    <=> ( v3678(VarCurr)
        | v3679(VarCurr) ) ) ).

tff(writeUnaryOperator_308,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3679(VarCurr)
    <=> v3047(VarCurr,1) ) ).

tff(writeUnaryOperator_307,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3678(VarCurr)
    <=> v3047(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_420,axiom,
    ! [VarCurr: state_type] :
      ( v3670(VarCurr)
    <=> ( v3671(VarCurr)
        & v3675(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_72,axiom,
    ! [VarCurr: state_type] :
      ( v3675(VarCurr)
    <=> ( v3673(VarCurr)
        | v3047(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_419,axiom,
    ! [VarCurr: state_type] :
      ( v3671(VarCurr)
    <=> ( v3672(VarCurr)
        | v3674(VarCurr) ) ) ).

tff(writeUnaryOperator_306,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3674(VarCurr)
    <=> v3047(VarCurr,2) ) ).

tff(writeUnaryOperator_305,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3672(VarCurr)
    <=> v3673(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_71,axiom,
    ! [VarCurr: state_type] :
      ( v3673(VarCurr)
    <=> ( v3047(VarCurr,0)
        & v3047(VarCurr,1) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_42,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3657(VarCurr,B)
          <=> v3660(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_42,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,1)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3657(VarCurr,B)
          <=> b001(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_41,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3660(VarCurr,B)
          <=> v3661(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_41,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,2)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3660(VarCurr,B)
          <=> b010(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_40,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3661(VarCurr,B)
          <=> v3662(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_40,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,3)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3661(VarCurr,B)
          <=> b011(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_39,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3662(VarCurr,B)
          <=> v3663(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_39,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,4)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3662(VarCurr,B)
          <=> b100(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_38,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3663(VarCurr,B)
          <=> v3664(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_38,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,5)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3663(VarCurr,B)
          <=> b101(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_37,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3664(VarCurr,B)
          <=> v3665(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_37,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,6)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3664(VarCurr,B)
          <=> b110(B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_36,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3022(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3665(VarCurr,B)
          <=> $false ) ) ) ).

tff(bitBlastConstant_78,axiom,
    ~ b000(2) ).

tff(bitBlastConstant_77,axiom,
    ~ b000(1) ).

tff(bitBlastConstant_76,axiom,
    ~ b000(0) ).

tff(addConditionBooleanCondEqualRangesThenBranch_36,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,7)
     => ! [B: $int] :
          ( ( $less(B,3)
            & ~ $less(B,0) )
         => ( v3665(VarCurr,B)
          <=> $true ) ) ) ).

tff(addAssignment_1516,axiom,
    ! [VarCurr: state_type] :
      ( v3591(VarCurr)
    <=> v3593(VarCurr) ) ).

tff(addAssignment_1515,axiom,
    ! [VarCurr: state_type] :
      ( v3593(VarCurr)
    <=> v3595(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_51,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3639(VarNext)
       => ( v3595(VarNext)
        <=> v3595(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_51,axiom,
    ! [VarNext: state_type] :
      ( v3639(VarNext)
     => ( v3595(VarNext)
      <=> v3649(VarNext) ) ) ).

tff(addAssignment_1514,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3649(VarNext)
      <=> v3647(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_35,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3650(VarCurr)
     => ( v3647(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_35,axiom,
    ! [VarCurr: state_type] :
      ( v3650(VarCurr)
     => ( v3647(VarCurr)
      <=> v3605(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_418,axiom,
    ! [VarCurr: state_type] :
      ( v3650(VarCurr)
    <=> ( v3651(VarCurr)
        & v3652(VarCurr) ) ) ).

tff(writeUnaryOperator_304,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3652(VarCurr)
    <=> v3601(VarCurr) ) ).

tff(writeUnaryOperator_303,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3651(VarCurr)
    <=> v3597(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_417,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3639(VarNext)
      <=> v3640(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_416,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3640(VarNext)
      <=> ( v3641(VarNext)
          & v3634(VarNext) ) ) ) ).

tff(writeUnaryOperator_302,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3641(VarNext)
      <=> v3643(VarNext) ) ) ).

tff(addAssignment_1513,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3643(VarNext)
      <=> v3634(VarCurr) ) ) ).

tff(addAssignment_1512,axiom,
    ! [VarCurr: state_type] :
      ( v3634(VarCurr)
    <=> v3636(VarCurr) ) ).

tff(addAssignment_1511,axiom,
    ! [VarCurr: state_type] :
      ( v3636(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1510,axiom,
    ! [VarCurr: state_type] :
      ( v3605(VarCurr)
    <=> v3607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_415,axiom,
    ! [VarCurr: state_type] :
      ( v3607(VarCurr)
    <=> ( v3626(VarCurr)
        | v3629(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_414,axiom,
    ! [VarCurr: state_type] :
      ( v3629(VarCurr)
    <=> ( v3593(VarCurr)
        & v3630(VarCurr) ) ) ).

tff(writeUnaryOperator_301,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3630(VarCurr)
    <=> v3631(VarCurr) ) ).

tff(addAssignment_1509,axiom,
    ! [VarCurr: state_type] :
      ( v3631(VarCurr)
    <=> v3632(VarCurr) ) ).

tff(addAssignment_1508,axiom,
    ! [VarCurr: state_type] :
      ( v3632(VarCurr)
    <=> v3614(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_413,axiom,
    ! [VarCurr: state_type] :
      ( v3626(VarCurr)
    <=> ( v3609(VarCurr)
        & v3627(VarCurr) ) ) ).

tff(addAssignment_1507,axiom,
    ! [VarCurr: state_type] :
      ( v3627(VarCurr)
    <=> v3628(VarCurr) ) ).

tff(addAssignment_1506,axiom,
    ! [VarCurr: state_type] :
      ( v3628(VarCurr)
    <=> v3614(VarCurr) ) ).

tff(addAssignment_1505,axiom,
    ! [VarCurr: state_type] :
      ( v3614(VarCurr)
    <=> v3616(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_70,axiom,
    ! [VarCurr: state_type] :
      ( v3616(VarCurr)
    <=> ( v3022(VarCurr,7)
        | v3619(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_412,axiom,
    ! [VarCurr: state_type] :
      ( v3619(VarCurr)
    <=> ( v3620(VarCurr)
        & v3624(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_19,axiom,
    ! [VarCurr: state_type] :
      ( v3624(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $true )
        & ( v3047(VarCurr,4)
        <=> $true )
        & ( v3047(VarCurr,3)
        <=> $true ) ) ) ).

tff(bitBlastConstant_75,axiom,
    b111(2) ).

tff(bitBlastConstant_74,axiom,
    b111(1) ).

tff(bitBlastConstant_73,axiom,
    b111(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_411,axiom,
    ! [VarCurr: state_type] :
      ( v3620(VarCurr)
    <=> ( v3621(VarCurr)
        & v3623(VarCurr) ) ) ).

tff(writeUnaryOperator_300,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3623(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_410,axiom,
    ! [VarCurr: state_type] :
      ( v3621(VarCurr)
    <=> ( v3622(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_299,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3622(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1504,axiom,
    ! [VarCurr: state_type] :
      ( v3609(VarCurr)
    <=> v3611(VarCurr) ) ).

tff(writeUnaryOperator_298,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3611(VarCurr)
    <=> v3022(VarCurr,7) ) ).

tff(addAssignment_1503,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,7)
    <=> v3024(VarCurr,7) ) ).

tff(addAssignment_1502,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,7)
    <=> v3026(VarCurr,7) ) ).

tff(addAssignment_1501,axiom,
    ! [VarCurr: state_type] :
      ( v3601(VarCurr)
    <=> v3603(VarCurr) ) ).

tff(addAssignment_1500,axiom,
    ! [VarCurr: state_type] :
      ( v3603(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1499,axiom,
    ! [VarCurr: state_type] :
      ( v3597(VarCurr)
    <=> v3599(VarCurr) ) ).

tff(addAssignment_1498,axiom,
    ! [VarCurr: state_type] :
      ( v3599(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1497,axiom,
    ! [VarCurr: state_type] :
      ( v3525(VarCurr)
    <=> v3527(VarCurr) ) ).

tff(addAssignment_1496,axiom,
    ! [VarCurr: state_type] :
      ( v3527(VarCurr)
    <=> v3529(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_50,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3573(VarNext)
       => ( v3529(VarNext)
        <=> v3529(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_50,axiom,
    ! [VarNext: state_type] :
      ( v3573(VarNext)
     => ( v3529(VarNext)
      <=> v3583(VarNext) ) ) ).

tff(addAssignment_1495,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3583(VarNext)
      <=> v3581(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_34,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3584(VarCurr)
     => ( v3581(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_34,axiom,
    ! [VarCurr: state_type] :
      ( v3584(VarCurr)
     => ( v3581(VarCurr)
      <=> v3539(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_409,axiom,
    ! [VarCurr: state_type] :
      ( v3584(VarCurr)
    <=> ( v3585(VarCurr)
        & v3586(VarCurr) ) ) ).

tff(writeUnaryOperator_297,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3586(VarCurr)
    <=> v3535(VarCurr) ) ).

tff(writeUnaryOperator_296,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3585(VarCurr)
    <=> v3531(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_408,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3573(VarNext)
      <=> v3574(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_407,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3574(VarNext)
      <=> ( v3575(VarNext)
          & v3568(VarNext) ) ) ) ).

tff(writeUnaryOperator_295,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3575(VarNext)
      <=> v3577(VarNext) ) ) ).

tff(addAssignment_1494,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3577(VarNext)
      <=> v3568(VarCurr) ) ) ).

tff(addAssignment_1493,axiom,
    ! [VarCurr: state_type] :
      ( v3568(VarCurr)
    <=> v3570(VarCurr) ) ).

tff(addAssignment_1492,axiom,
    ! [VarCurr: state_type] :
      ( v3570(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1491,axiom,
    ! [VarCurr: state_type] :
      ( v3539(VarCurr)
    <=> v3541(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_406,axiom,
    ! [VarCurr: state_type] :
      ( v3541(VarCurr)
    <=> ( v3560(VarCurr)
        | v3563(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_405,axiom,
    ! [VarCurr: state_type] :
      ( v3563(VarCurr)
    <=> ( v3527(VarCurr)
        & v3564(VarCurr) ) ) ).

tff(writeUnaryOperator_294,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3564(VarCurr)
    <=> v3565(VarCurr) ) ).

tff(addAssignment_1490,axiom,
    ! [VarCurr: state_type] :
      ( v3565(VarCurr)
    <=> v3566(VarCurr) ) ).

tff(addAssignment_1489,axiom,
    ! [VarCurr: state_type] :
      ( v3566(VarCurr)
    <=> v3548(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_404,axiom,
    ! [VarCurr: state_type] :
      ( v3560(VarCurr)
    <=> ( v3543(VarCurr)
        & v3561(VarCurr) ) ) ).

tff(addAssignment_1488,axiom,
    ! [VarCurr: state_type] :
      ( v3561(VarCurr)
    <=> v3562(VarCurr) ) ).

tff(addAssignment_1487,axiom,
    ! [VarCurr: state_type] :
      ( v3562(VarCurr)
    <=> v3548(VarCurr) ) ).

tff(addAssignment_1486,axiom,
    ! [VarCurr: state_type] :
      ( v3548(VarCurr)
    <=> v3550(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_69,axiom,
    ! [VarCurr: state_type] :
      ( v3550(VarCurr)
    <=> ( v3022(VarCurr,6)
        | v3553(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_403,axiom,
    ! [VarCurr: state_type] :
      ( v3553(VarCurr)
    <=> ( v3554(VarCurr)
        & v3558(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_18,axiom,
    ! [VarCurr: state_type] :
      ( v3558(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $true )
        & ( v3047(VarCurr,4)
        <=> $true )
        & ( v3047(VarCurr,3)
        <=> $false ) ) ) ).

tff(bitBlastConstant_72,axiom,
    b110(2) ).

tff(bitBlastConstant_71,axiom,
    b110(1) ).

tff(bitBlastConstant_70,axiom,
    ~ b110(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_402,axiom,
    ! [VarCurr: state_type] :
      ( v3554(VarCurr)
    <=> ( v3555(VarCurr)
        & v3557(VarCurr) ) ) ).

tff(writeUnaryOperator_293,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3557(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_401,axiom,
    ! [VarCurr: state_type] :
      ( v3555(VarCurr)
    <=> ( v3556(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_292,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3556(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1485,axiom,
    ! [VarCurr: state_type] :
      ( v3543(VarCurr)
    <=> v3545(VarCurr) ) ).

tff(writeUnaryOperator_291,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3545(VarCurr)
    <=> v3022(VarCurr,6) ) ).

tff(addAssignment_1484,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,6)
    <=> v3024(VarCurr,6) ) ).

tff(addAssignment_1483,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,6)
    <=> v3026(VarCurr,6) ) ).

tff(addAssignment_1482,axiom,
    ! [VarCurr: state_type] :
      ( v3535(VarCurr)
    <=> v3537(VarCurr) ) ).

tff(addAssignment_1481,axiom,
    ! [VarCurr: state_type] :
      ( v3537(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1480,axiom,
    ! [VarCurr: state_type] :
      ( v3531(VarCurr)
    <=> v3533(VarCurr) ) ).

tff(addAssignment_1479,axiom,
    ! [VarCurr: state_type] :
      ( v3533(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1478,axiom,
    ! [VarCurr: state_type] :
      ( v3459(VarCurr)
    <=> v3461(VarCurr) ) ).

tff(addAssignment_1477,axiom,
    ! [VarCurr: state_type] :
      ( v3461(VarCurr)
    <=> v3463(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_49,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3507(VarNext)
       => ( v3463(VarNext)
        <=> v3463(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_49,axiom,
    ! [VarNext: state_type] :
      ( v3507(VarNext)
     => ( v3463(VarNext)
      <=> v3517(VarNext) ) ) ).

tff(addAssignment_1476,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3517(VarNext)
      <=> v3515(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_33,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3518(VarCurr)
     => ( v3515(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_33,axiom,
    ! [VarCurr: state_type] :
      ( v3518(VarCurr)
     => ( v3515(VarCurr)
      <=> v3473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_400,axiom,
    ! [VarCurr: state_type] :
      ( v3518(VarCurr)
    <=> ( v3519(VarCurr)
        & v3520(VarCurr) ) ) ).

tff(writeUnaryOperator_290,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3520(VarCurr)
    <=> v3469(VarCurr) ) ).

tff(writeUnaryOperator_289,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3519(VarCurr)
    <=> v3465(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3507(VarNext)
      <=> v3508(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_398,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3508(VarNext)
      <=> ( v3509(VarNext)
          & v3502(VarNext) ) ) ) ).

tff(writeUnaryOperator_288,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3509(VarNext)
      <=> v3511(VarNext) ) ) ).

tff(addAssignment_1475,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3511(VarNext)
      <=> v3502(VarCurr) ) ) ).

tff(addAssignment_1474,axiom,
    ! [VarCurr: state_type] :
      ( v3502(VarCurr)
    <=> v3504(VarCurr) ) ).

tff(addAssignment_1473,axiom,
    ! [VarCurr: state_type] :
      ( v3504(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1472,axiom,
    ! [VarCurr: state_type] :
      ( v3473(VarCurr)
    <=> v3475(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_397,axiom,
    ! [VarCurr: state_type] :
      ( v3475(VarCurr)
    <=> ( v3494(VarCurr)
        | v3497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_396,axiom,
    ! [VarCurr: state_type] :
      ( v3497(VarCurr)
    <=> ( v3461(VarCurr)
        & v3498(VarCurr) ) ) ).

tff(writeUnaryOperator_287,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3498(VarCurr)
    <=> v3499(VarCurr) ) ).

tff(addAssignment_1471,axiom,
    ! [VarCurr: state_type] :
      ( v3499(VarCurr)
    <=> v3500(VarCurr) ) ).

tff(addAssignment_1470,axiom,
    ! [VarCurr: state_type] :
      ( v3500(VarCurr)
    <=> v3482(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_395,axiom,
    ! [VarCurr: state_type] :
      ( v3494(VarCurr)
    <=> ( v3477(VarCurr)
        & v3495(VarCurr) ) ) ).

tff(addAssignment_1469,axiom,
    ! [VarCurr: state_type] :
      ( v3495(VarCurr)
    <=> v3496(VarCurr) ) ).

tff(addAssignment_1468,axiom,
    ! [VarCurr: state_type] :
      ( v3496(VarCurr)
    <=> v3482(VarCurr) ) ).

tff(addAssignment_1467,axiom,
    ! [VarCurr: state_type] :
      ( v3482(VarCurr)
    <=> v3484(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_68,axiom,
    ! [VarCurr: state_type] :
      ( v3484(VarCurr)
    <=> ( v3022(VarCurr,5)
        | v3487(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_394,axiom,
    ! [VarCurr: state_type] :
      ( v3487(VarCurr)
    <=> ( v3488(VarCurr)
        & v3492(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_17,axiom,
    ! [VarCurr: state_type] :
      ( v3492(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $true )
        & ( v3047(VarCurr,4)
        <=> $false )
        & ( v3047(VarCurr,3)
        <=> $true ) ) ) ).

tff(bitBlastConstant_69,axiom,
    b101(2) ).

tff(bitBlastConstant_68,axiom,
    ~ b101(1) ).

tff(bitBlastConstant_67,axiom,
    b101(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_393,axiom,
    ! [VarCurr: state_type] :
      ( v3488(VarCurr)
    <=> ( v3489(VarCurr)
        & v3491(VarCurr) ) ) ).

tff(writeUnaryOperator_286,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3491(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_392,axiom,
    ! [VarCurr: state_type] :
      ( v3489(VarCurr)
    <=> ( v3490(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_285,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3490(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1466,axiom,
    ! [VarCurr: state_type] :
      ( v3477(VarCurr)
    <=> v3479(VarCurr) ) ).

tff(writeUnaryOperator_284,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3479(VarCurr)
    <=> v3022(VarCurr,5) ) ).

tff(addAssignment_1465,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,5)
    <=> v3024(VarCurr,5) ) ).

tff(addAssignment_1464,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,5)
    <=> v3026(VarCurr,5) ) ).

tff(addAssignment_1463,axiom,
    ! [VarCurr: state_type] :
      ( v3469(VarCurr)
    <=> v3471(VarCurr) ) ).

tff(addAssignment_1462,axiom,
    ! [VarCurr: state_type] :
      ( v3471(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1461,axiom,
    ! [VarCurr: state_type] :
      ( v3465(VarCurr)
    <=> v3467(VarCurr) ) ).

tff(addAssignment_1460,axiom,
    ! [VarCurr: state_type] :
      ( v3467(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1459,axiom,
    ! [VarCurr: state_type] :
      ( v3393(VarCurr)
    <=> v3395(VarCurr) ) ).

tff(addAssignment_1458,axiom,
    ! [VarCurr: state_type] :
      ( v3395(VarCurr)
    <=> v3397(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_48,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3441(VarNext)
       => ( v3397(VarNext)
        <=> v3397(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_48,axiom,
    ! [VarNext: state_type] :
      ( v3441(VarNext)
     => ( v3397(VarNext)
      <=> v3451(VarNext) ) ) ).

tff(addAssignment_1457,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3451(VarNext)
      <=> v3449(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_32,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3452(VarCurr)
     => ( v3449(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_32,axiom,
    ! [VarCurr: state_type] :
      ( v3452(VarCurr)
     => ( v3449(VarCurr)
      <=> v3407(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_391,axiom,
    ! [VarCurr: state_type] :
      ( v3452(VarCurr)
    <=> ( v3453(VarCurr)
        & v3454(VarCurr) ) ) ).

tff(writeUnaryOperator_283,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3454(VarCurr)
    <=> v3403(VarCurr) ) ).

tff(writeUnaryOperator_282,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3453(VarCurr)
    <=> v3399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_390,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3441(VarNext)
      <=> v3442(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_389,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3442(VarNext)
      <=> ( v3443(VarNext)
          & v3436(VarNext) ) ) ) ).

tff(writeUnaryOperator_281,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3443(VarNext)
      <=> v3445(VarNext) ) ) ).

tff(addAssignment_1456,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3445(VarNext)
      <=> v3436(VarCurr) ) ) ).

tff(addAssignment_1455,axiom,
    ! [VarCurr: state_type] :
      ( v3436(VarCurr)
    <=> v3438(VarCurr) ) ).

tff(addAssignment_1454,axiom,
    ! [VarCurr: state_type] :
      ( v3438(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1453,axiom,
    ! [VarCurr: state_type] :
      ( v3407(VarCurr)
    <=> v3409(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_388,axiom,
    ! [VarCurr: state_type] :
      ( v3409(VarCurr)
    <=> ( v3428(VarCurr)
        | v3431(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_387,axiom,
    ! [VarCurr: state_type] :
      ( v3431(VarCurr)
    <=> ( v3395(VarCurr)
        & v3432(VarCurr) ) ) ).

tff(writeUnaryOperator_280,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3432(VarCurr)
    <=> v3433(VarCurr) ) ).

tff(addAssignment_1452,axiom,
    ! [VarCurr: state_type] :
      ( v3433(VarCurr)
    <=> v3434(VarCurr) ) ).

tff(addAssignment_1451,axiom,
    ! [VarCurr: state_type] :
      ( v3434(VarCurr)
    <=> v3416(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_386,axiom,
    ! [VarCurr: state_type] :
      ( v3428(VarCurr)
    <=> ( v3411(VarCurr)
        & v3429(VarCurr) ) ) ).

tff(addAssignment_1450,axiom,
    ! [VarCurr: state_type] :
      ( v3429(VarCurr)
    <=> v3430(VarCurr) ) ).

tff(addAssignment_1449,axiom,
    ! [VarCurr: state_type] :
      ( v3430(VarCurr)
    <=> v3416(VarCurr) ) ).

tff(addAssignment_1448,axiom,
    ! [VarCurr: state_type] :
      ( v3416(VarCurr)
    <=> v3418(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_67,axiom,
    ! [VarCurr: state_type] :
      ( v3418(VarCurr)
    <=> ( v3022(VarCurr,4)
        | v3421(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_385,axiom,
    ! [VarCurr: state_type] :
      ( v3421(VarCurr)
    <=> ( v3422(VarCurr)
        & v3426(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_16,axiom,
    ! [VarCurr: state_type] :
      ( v3426(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $true )
        & ( v3047(VarCurr,4)
        <=> $false )
        & ( v3047(VarCurr,3)
        <=> $false ) ) ) ).

tff(bitBlastConstant_66,axiom,
    b100(2) ).

tff(bitBlastConstant_65,axiom,
    ~ b100(1) ).

tff(bitBlastConstant_64,axiom,
    ~ b100(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_384,axiom,
    ! [VarCurr: state_type] :
      ( v3422(VarCurr)
    <=> ( v3423(VarCurr)
        & v3425(VarCurr) ) ) ).

tff(writeUnaryOperator_279,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3425(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_383,axiom,
    ! [VarCurr: state_type] :
      ( v3423(VarCurr)
    <=> ( v3424(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_278,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3424(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1447,axiom,
    ! [VarCurr: state_type] :
      ( v3411(VarCurr)
    <=> v3413(VarCurr) ) ).

tff(writeUnaryOperator_277,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3413(VarCurr)
    <=> v3022(VarCurr,4) ) ).

tff(addAssignment_1446,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,4)
    <=> v3024(VarCurr,4) ) ).

tff(addAssignment_1445,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,4)
    <=> v3026(VarCurr,4) ) ).

tff(addAssignment_1444,axiom,
    ! [VarCurr: state_type] :
      ( v3403(VarCurr)
    <=> v3405(VarCurr) ) ).

tff(addAssignment_1443,axiom,
    ! [VarCurr: state_type] :
      ( v3405(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1442,axiom,
    ! [VarCurr: state_type] :
      ( v3399(VarCurr)
    <=> v3401(VarCurr) ) ).

tff(addAssignment_1441,axiom,
    ! [VarCurr: state_type] :
      ( v3401(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1440,axiom,
    ! [VarCurr: state_type] :
      ( v3327(VarCurr)
    <=> v3329(VarCurr) ) ).

tff(addAssignment_1439,axiom,
    ! [VarCurr: state_type] :
      ( v3329(VarCurr)
    <=> v3331(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_47,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3375(VarNext)
       => ( v3331(VarNext)
        <=> v3331(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_47,axiom,
    ! [VarNext: state_type] :
      ( v3375(VarNext)
     => ( v3331(VarNext)
      <=> v3385(VarNext) ) ) ).

tff(addAssignment_1438,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3385(VarNext)
      <=> v3383(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_31,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3386(VarCurr)
     => ( v3383(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_31,axiom,
    ! [VarCurr: state_type] :
      ( v3386(VarCurr)
     => ( v3383(VarCurr)
      <=> v3341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_382,axiom,
    ! [VarCurr: state_type] :
      ( v3386(VarCurr)
    <=> ( v3387(VarCurr)
        & v3388(VarCurr) ) ) ).

tff(writeUnaryOperator_276,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3388(VarCurr)
    <=> v3337(VarCurr) ) ).

tff(writeUnaryOperator_275,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3387(VarCurr)
    <=> v3333(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3375(VarNext)
      <=> v3376(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3376(VarNext)
      <=> ( v3377(VarNext)
          & v3370(VarNext) ) ) ) ).

tff(writeUnaryOperator_274,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3377(VarNext)
      <=> v3379(VarNext) ) ) ).

tff(addAssignment_1437,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3379(VarNext)
      <=> v3370(VarCurr) ) ) ).

tff(addAssignment_1436,axiom,
    ! [VarCurr: state_type] :
      ( v3370(VarCurr)
    <=> v3372(VarCurr) ) ).

tff(addAssignment_1435,axiom,
    ! [VarCurr: state_type] :
      ( v3372(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1434,axiom,
    ! [VarCurr: state_type] :
      ( v3341(VarCurr)
    <=> v3343(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_379,axiom,
    ! [VarCurr: state_type] :
      ( v3343(VarCurr)
    <=> ( v3362(VarCurr)
        | v3365(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_378,axiom,
    ! [VarCurr: state_type] :
      ( v3365(VarCurr)
    <=> ( v3329(VarCurr)
        & v3366(VarCurr) ) ) ).

tff(writeUnaryOperator_273,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3366(VarCurr)
    <=> v3367(VarCurr) ) ).

tff(addAssignment_1433,axiom,
    ! [VarCurr: state_type] :
      ( v3367(VarCurr)
    <=> v3368(VarCurr) ) ).

tff(addAssignment_1432,axiom,
    ! [VarCurr: state_type] :
      ( v3368(VarCurr)
    <=> v3350(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_377,axiom,
    ! [VarCurr: state_type] :
      ( v3362(VarCurr)
    <=> ( v3345(VarCurr)
        & v3363(VarCurr) ) ) ).

tff(addAssignment_1431,axiom,
    ! [VarCurr: state_type] :
      ( v3363(VarCurr)
    <=> v3364(VarCurr) ) ).

tff(addAssignment_1430,axiom,
    ! [VarCurr: state_type] :
      ( v3364(VarCurr)
    <=> v3350(VarCurr) ) ).

tff(addAssignment_1429,axiom,
    ! [VarCurr: state_type] :
      ( v3350(VarCurr)
    <=> v3352(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_66,axiom,
    ! [VarCurr: state_type] :
      ( v3352(VarCurr)
    <=> ( v3022(VarCurr,3)
        | v3355(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_376,axiom,
    ! [VarCurr: state_type] :
      ( v3355(VarCurr)
    <=> ( v3356(VarCurr)
        & v3360(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_15,axiom,
    ! [VarCurr: state_type] :
      ( v3360(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $false )
        & ( v3047(VarCurr,4)
        <=> $true )
        & ( v3047(VarCurr,3)
        <=> $true ) ) ) ).

tff(bitBlastConstant_63,axiom,
    ~ b011(2) ).

tff(bitBlastConstant_62,axiom,
    b011(1) ).

tff(bitBlastConstant_61,axiom,
    b011(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_375,axiom,
    ! [VarCurr: state_type] :
      ( v3356(VarCurr)
    <=> ( v3357(VarCurr)
        & v3359(VarCurr) ) ) ).

tff(writeUnaryOperator_272,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3359(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_374,axiom,
    ! [VarCurr: state_type] :
      ( v3357(VarCurr)
    <=> ( v3358(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_271,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3358(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1428,axiom,
    ! [VarCurr: state_type] :
      ( v3345(VarCurr)
    <=> v3347(VarCurr) ) ).

tff(writeUnaryOperator_270,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3347(VarCurr)
    <=> v3022(VarCurr,3) ) ).

tff(addAssignment_1427,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,3)
    <=> v3024(VarCurr,3) ) ).

tff(addAssignment_1426,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,3)
    <=> v3026(VarCurr,3) ) ).

tff(addAssignment_1425,axiom,
    ! [VarCurr: state_type] :
      ( v3337(VarCurr)
    <=> v3339(VarCurr) ) ).

tff(addAssignment_1424,axiom,
    ! [VarCurr: state_type] :
      ( v3339(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1423,axiom,
    ! [VarCurr: state_type] :
      ( v3333(VarCurr)
    <=> v3335(VarCurr) ) ).

tff(addAssignment_1422,axiom,
    ! [VarCurr: state_type] :
      ( v3335(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1421,axiom,
    ! [VarCurr: state_type] :
      ( v3261(VarCurr)
    <=> v3263(VarCurr) ) ).

tff(addAssignment_1420,axiom,
    ! [VarCurr: state_type] :
      ( v3263(VarCurr)
    <=> v3265(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_46,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3309(VarNext)
       => ( v3265(VarNext)
        <=> v3265(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_46,axiom,
    ! [VarNext: state_type] :
      ( v3309(VarNext)
     => ( v3265(VarNext)
      <=> v3319(VarNext) ) ) ).

tff(addAssignment_1419,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3319(VarNext)
      <=> v3317(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_30,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3320(VarCurr)
     => ( v3317(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_30,axiom,
    ! [VarCurr: state_type] :
      ( v3320(VarCurr)
     => ( v3317(VarCurr)
      <=> v3275(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_373,axiom,
    ! [VarCurr: state_type] :
      ( v3320(VarCurr)
    <=> ( v3321(VarCurr)
        & v3322(VarCurr) ) ) ).

tff(writeUnaryOperator_269,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3322(VarCurr)
    <=> v3271(VarCurr) ) ).

tff(writeUnaryOperator_268,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3321(VarCurr)
    <=> v3267(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_372,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3309(VarNext)
      <=> v3310(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3310(VarNext)
      <=> ( v3311(VarNext)
          & v3304(VarNext) ) ) ) ).

tff(writeUnaryOperator_267,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3311(VarNext)
      <=> v3313(VarNext) ) ) ).

tff(addAssignment_1418,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3313(VarNext)
      <=> v3304(VarCurr) ) ) ).

tff(addAssignment_1417,axiom,
    ! [VarCurr: state_type] :
      ( v3304(VarCurr)
    <=> v3306(VarCurr) ) ).

tff(addAssignment_1416,axiom,
    ! [VarCurr: state_type] :
      ( v3306(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1415,axiom,
    ! [VarCurr: state_type] :
      ( v3275(VarCurr)
    <=> v3277(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_370,axiom,
    ! [VarCurr: state_type] :
      ( v3277(VarCurr)
    <=> ( v3296(VarCurr)
        | v3299(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_369,axiom,
    ! [VarCurr: state_type] :
      ( v3299(VarCurr)
    <=> ( v3263(VarCurr)
        & v3300(VarCurr) ) ) ).

tff(writeUnaryOperator_266,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3300(VarCurr)
    <=> v3301(VarCurr) ) ).

tff(addAssignment_1414,axiom,
    ! [VarCurr: state_type] :
      ( v3301(VarCurr)
    <=> v3302(VarCurr) ) ).

tff(addAssignment_1413,axiom,
    ! [VarCurr: state_type] :
      ( v3302(VarCurr)
    <=> v3284(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_368,axiom,
    ! [VarCurr: state_type] :
      ( v3296(VarCurr)
    <=> ( v3279(VarCurr)
        & v3297(VarCurr) ) ) ).

tff(addAssignment_1412,axiom,
    ! [VarCurr: state_type] :
      ( v3297(VarCurr)
    <=> v3298(VarCurr) ) ).

tff(addAssignment_1411,axiom,
    ! [VarCurr: state_type] :
      ( v3298(VarCurr)
    <=> v3284(VarCurr) ) ).

tff(addAssignment_1410,axiom,
    ! [VarCurr: state_type] :
      ( v3284(VarCurr)
    <=> v3286(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_65,axiom,
    ! [VarCurr: state_type] :
      ( v3286(VarCurr)
    <=> ( v3022(VarCurr,2)
        | v3289(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_367,axiom,
    ! [VarCurr: state_type] :
      ( v3289(VarCurr)
    <=> ( v3290(VarCurr)
        & v3294(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_14,axiom,
    ! [VarCurr: state_type] :
      ( v3294(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $false )
        & ( v3047(VarCurr,4)
        <=> $true )
        & ( v3047(VarCurr,3)
        <=> $false ) ) ) ).

tff(bitBlastConstant_60,axiom,
    ~ b010(2) ).

tff(bitBlastConstant_59,axiom,
    b010(1) ).

tff(bitBlastConstant_58,axiom,
    ~ b010(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_366,axiom,
    ! [VarCurr: state_type] :
      ( v3290(VarCurr)
    <=> ( v3291(VarCurr)
        & v3293(VarCurr) ) ) ).

tff(writeUnaryOperator_265,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3293(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_365,axiom,
    ! [VarCurr: state_type] :
      ( v3291(VarCurr)
    <=> ( v3292(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_264,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3292(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1409,axiom,
    ! [VarCurr: state_type] :
      ( v3279(VarCurr)
    <=> v3281(VarCurr) ) ).

tff(writeUnaryOperator_263,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3281(VarCurr)
    <=> v3022(VarCurr,2) ) ).

tff(addAssignment_1408,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,2)
    <=> v3024(VarCurr,2) ) ).

tff(addAssignment_1407,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,2)
    <=> v3026(VarCurr,2) ) ).

tff(addAssignment_1406,axiom,
    ! [VarCurr: state_type] :
      ( v3271(VarCurr)
    <=> v3273(VarCurr) ) ).

tff(addAssignment_1405,axiom,
    ! [VarCurr: state_type] :
      ( v3273(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1404,axiom,
    ! [VarCurr: state_type] :
      ( v3267(VarCurr)
    <=> v3269(VarCurr) ) ).

tff(addAssignment_1403,axiom,
    ! [VarCurr: state_type] :
      ( v3269(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1402,axiom,
    ! [VarCurr: state_type] :
      ( v3195(VarCurr)
    <=> v3197(VarCurr) ) ).

tff(addAssignment_1401,axiom,
    ! [VarCurr: state_type] :
      ( v3197(VarCurr)
    <=> v3199(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_45,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3243(VarNext)
       => ( v3199(VarNext)
        <=> v3199(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_45,axiom,
    ! [VarNext: state_type] :
      ( v3243(VarNext)
     => ( v3199(VarNext)
      <=> v3253(VarNext) ) ) ).

tff(addAssignment_1400,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3253(VarNext)
      <=> v3251(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_29,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3254(VarCurr)
     => ( v3251(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_29,axiom,
    ! [VarCurr: state_type] :
      ( v3254(VarCurr)
     => ( v3251(VarCurr)
      <=> v3209(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_364,axiom,
    ! [VarCurr: state_type] :
      ( v3254(VarCurr)
    <=> ( v3255(VarCurr)
        & v3256(VarCurr) ) ) ).

tff(writeUnaryOperator_262,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3256(VarCurr)
    <=> v3205(VarCurr) ) ).

tff(writeUnaryOperator_261,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3255(VarCurr)
    <=> v3201(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_363,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3243(VarNext)
      <=> v3244(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_362,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3244(VarNext)
      <=> ( v3245(VarNext)
          & v3238(VarNext) ) ) ) ).

tff(writeUnaryOperator_260,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3245(VarNext)
      <=> v3247(VarNext) ) ) ).

tff(addAssignment_1399,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3247(VarNext)
      <=> v3238(VarCurr) ) ) ).

tff(addAssignment_1398,axiom,
    ! [VarCurr: state_type] :
      ( v3238(VarCurr)
    <=> v3240(VarCurr) ) ).

tff(addAssignment_1397,axiom,
    ! [VarCurr: state_type] :
      ( v3240(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1396,axiom,
    ! [VarCurr: state_type] :
      ( v3209(VarCurr)
    <=> v3211(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_361,axiom,
    ! [VarCurr: state_type] :
      ( v3211(VarCurr)
    <=> ( v3230(VarCurr)
        | v3233(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_360,axiom,
    ! [VarCurr: state_type] :
      ( v3233(VarCurr)
    <=> ( v3197(VarCurr)
        & v3234(VarCurr) ) ) ).

tff(writeUnaryOperator_259,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3234(VarCurr)
    <=> v3235(VarCurr) ) ).

tff(addAssignment_1395,axiom,
    ! [VarCurr: state_type] :
      ( v3235(VarCurr)
    <=> v3236(VarCurr) ) ).

tff(addAssignment_1394,axiom,
    ! [VarCurr: state_type] :
      ( v3236(VarCurr)
    <=> v3218(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_359,axiom,
    ! [VarCurr: state_type] :
      ( v3230(VarCurr)
    <=> ( v3213(VarCurr)
        & v3231(VarCurr) ) ) ).

tff(addAssignment_1393,axiom,
    ! [VarCurr: state_type] :
      ( v3231(VarCurr)
    <=> v3232(VarCurr) ) ).

tff(addAssignment_1392,axiom,
    ! [VarCurr: state_type] :
      ( v3232(VarCurr)
    <=> v3218(VarCurr) ) ).

tff(addAssignment_1391,axiom,
    ! [VarCurr: state_type] :
      ( v3218(VarCurr)
    <=> v3220(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_64,axiom,
    ! [VarCurr: state_type] :
      ( v3220(VarCurr)
    <=> ( v3022(VarCurr,1)
        | v3223(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_358,axiom,
    ! [VarCurr: state_type] :
      ( v3223(VarCurr)
    <=> ( v3224(VarCurr)
        & v3228(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_13,axiom,
    ! [VarCurr: state_type] :
      ( v3228(VarCurr)
    <=> ( ( v3047(VarCurr,5)
        <=> $false )
        & ( v3047(VarCurr,4)
        <=> $false )
        & ( v3047(VarCurr,3)
        <=> $true ) ) ) ).

tff(bitBlastConstant_57,axiom,
    ~ b001(2) ).

tff(bitBlastConstant_56,axiom,
    ~ b001(1) ).

tff(bitBlastConstant_55,axiom,
    b001(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_357,axiom,
    ! [VarCurr: state_type] :
      ( v3224(VarCurr)
    <=> ( v3225(VarCurr)
        & v3227(VarCurr) ) ) ).

tff(writeUnaryOperator_258,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3227(VarCurr)
    <=> v3045(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_356,axiom,
    ! [VarCurr: state_type] :
      ( v3225(VarCurr)
    <=> ( v3226(VarCurr)
        & v3039(VarCurr) ) ) ).

tff(writeUnaryOperator_257,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3226(VarCurr)
    <=> v3033(VarCurr) ) ).

tff(addAssignment_1390,axiom,
    ! [VarCurr: state_type] :
      ( v3213(VarCurr)
    <=> v3215(VarCurr) ) ).

tff(writeUnaryOperator_256,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3215(VarCurr)
    <=> v3022(VarCurr,1) ) ).

tff(addAssignment_1389,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,1)
    <=> v3024(VarCurr,1) ) ).

tff(addAssignment_1388,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,1)
    <=> v3026(VarCurr,1) ) ).

tff(addAssignment_1387,axiom,
    ! [VarCurr: state_type] :
      ( v3205(VarCurr)
    <=> v3207(VarCurr) ) ).

tff(addAssignment_1386,axiom,
    ! [VarCurr: state_type] :
      ( v3207(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1385,axiom,
    ! [VarCurr: state_type] :
      ( v3201(VarCurr)
    <=> v3203(VarCurr) ) ).

tff(addAssignment_1384,axiom,
    ! [VarCurr: state_type] :
      ( v3203(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1383,axiom,
    ! [VarCurr: state_type] :
      ( v3069(VarCurr)
    <=> v3071(VarCurr) ) ).

tff(addAssignment_1382,axiom,
    ! [VarCurr: state_type] :
      ( v3071(VarCurr)
    <=> v3073(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_44,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3177(VarNext)
       => ( v3073(VarNext)
        <=> v3073(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_44,axiom,
    ! [VarNext: state_type] :
      ( v3177(VarNext)
     => ( v3073(VarNext)
      <=> v3187(VarNext) ) ) ).

tff(addAssignment_1381,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3187(VarNext)
      <=> v3185(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_28,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3188(VarCurr)
     => ( v3185(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_28,axiom,
    ! [VarCurr: state_type] :
      ( v3188(VarCurr)
     => ( v3185(VarCurr)
      <=> v3083(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_355,axiom,
    ! [VarCurr: state_type] :
      ( v3188(VarCurr)
    <=> ( v3189(VarCurr)
        & v3190(VarCurr) ) ) ).

tff(writeUnaryOperator_255,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3190(VarCurr)
    <=> v3079(VarCurr) ) ).

tff(writeUnaryOperator_254,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3189(VarCurr)
    <=> v3075(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_354,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3177(VarNext)
      <=> v3178(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_353,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3178(VarNext)
      <=> ( v3179(VarNext)
          & v3115(VarNext) ) ) ) ).

tff(writeUnaryOperator_253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3179(VarNext)
      <=> v3181(VarNext) ) ) ).

tff(addAssignment_1380,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3181(VarNext)
      <=> v3115(VarCurr) ) ) ).

tff(addAssignment_1379,axiom,
    ! [VarCurr: state_type] :
      ( v3115(VarCurr)
    <=> v3117(VarCurr) ) ).

tff(addAssignment_1378,axiom,
    ! [VarCurr: state_type] :
      ( v3117(VarCurr)
    <=> v3119(VarCurr) ) ).

tff(addAssignment_1377,axiom,
    ! [VarCurr: state_type] :
      ( v3119(VarCurr)
    <=> v3121(VarCurr) ) ).

tff(addAssignment_1376,axiom,
    ! [VarCurr: state_type] :
      ( v3121(VarCurr)
    <=> v3123(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_352,axiom,
    ! [VarCurr: state_type] :
      ( v3123(VarCurr)
    <=> ( v3174(VarCurr)
        | v3166(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_351,axiom,
    ! [VarCurr: state_type] :
      ( v3174(VarCurr)
    <=> ( v3125(VarCurr)
        & v3131(VarCurr) ) ) ).

tff(addAssignment_1375,axiom,
    ! [VarCurr: state_type] :
      ( v3166(VarCurr)
    <=> v3168(VarCurr) ) ).

tff(addAssignment_1374,axiom,
    ! [VarCurr: state_type] :
      ( v3168(VarCurr)
    <=> v3170(VarCurr) ) ).

tff(addAssignment_1373,axiom,
    ! [VarCurr: state_type] :
      ( v3170(VarCurr)
    <=> v3172(VarCurr) ) ).

tff(addAssignment_1372,axiom,
    ! [VarCurr: state_type] :
      ( v3172(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_43,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v3150(VarNext)
       => ( v3131(VarNext)
        <=> v3131(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_43,axiom,
    ! [VarNext: state_type] :
      ( v3150(VarNext)
     => ( v3131(VarNext)
      <=> v3160(VarNext) ) ) ).

tff(addAssignment_1371,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3160(VarNext)
      <=> v3158(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_350,axiom,
    ! [VarCurr: state_type] :
      ( v3158(VarCurr)
    <=> ( v3161(VarCurr)
        & v3162(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_349,axiom,
    ! [VarCurr: state_type] :
      ( v3162(VarCurr)
    <=> ( v3137(VarCurr)
        | v3141(VarCurr) ) ) ).

tff(writeUnaryOperator_252,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3161(VarCurr)
    <=> v3133(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_348,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3150(VarNext)
      <=> v3151(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_347,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3151(VarNext)
      <=> ( v3153(VarNext)
          & v3155(VarNext) ) ) ) ).

tff(writeUnaryOperator_251,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3155(VarCurr)
    <=> v3125(VarCurr) ) ).

tff(addAssignment_1370,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v3153(VarNext)
      <=> v3125(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_8,axiom,
    ( v3131(constB0)
  <=> $true ) ).

tff(addAssignment_1369,axiom,
    ! [VarCurr: state_type] :
      ( v3141(VarCurr)
    <=> v3143(VarCurr) ) ).

tff(addAssignment_1368,axiom,
    ! [VarCurr: state_type] :
      ( v3143(VarCurr)
    <=> v3145(VarCurr) ) ).

tff(addAssignment_1367,axiom,
    ! [VarCurr: state_type] :
      ( v3145(VarCurr)
    <=> v3147(VarCurr) ) ).

tff(addAssignment_1366,axiom,
    ! [VarCurr: state_type] :
      ( v3147(VarCurr)
    <=> v1548(VarCurr) ) ).

tff(addAssignment_1365,axiom,
    ! [VarCurr: state_type] :
      ( v3137(VarCurr)
    <=> v3139(VarCurr) ) ).

tff(addAssignment_1364,axiom,
    ! [VarCurr: state_type] :
      ( v3139(VarCurr)
    <=> $true ) ).

tff(addAssignment_1363,axiom,
    ! [VarCurr: state_type] :
      ( v3133(VarCurr)
    <=> v3135(VarCurr) ) ).

tff(addAssignment_1362,axiom,
    ! [VarCurr: state_type] :
      ( v3135(VarCurr)
    <=> $false ) ).

tff(addAssignment_1361,axiom,
    ! [VarCurr: state_type] :
      ( v3125(VarCurr)
    <=> v3127(VarCurr) ) ).

tff(addAssignment_1360,axiom,
    ! [VarCurr: state_type] :
      ( v3127(VarCurr)
    <=> v3129(VarCurr) ) ).

tff(addAssignment_1359,axiom,
    ! [VarCurr: state_type] :
      ( v3129(VarCurr)
    <=> v1230(VarCurr) ) ).

tff(addAssignment_1358,axiom,
    ! [VarCurr: state_type] :
      ( v3083(VarCurr)
    <=> v3085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_346,axiom,
    ! [VarCurr: state_type] :
      ( v3085(VarCurr)
    <=> ( v3099(VarCurr)
        | v3106(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_345,axiom,
    ! [VarCurr: state_type] :
      ( v3106(VarCurr)
    <=> ( v3107(VarCurr)
        & v3111(VarCurr) ) ) ).

tff(writeUnaryOperator_250,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3111(VarCurr)
    <=> v3112(VarCurr) ) ).

tff(addAssignment_1357,axiom,
    ! [VarCurr: state_type] :
      ( v3112(VarCurr)
    <=> v3113(VarCurr) ) ).

tff(addAssignment_1356,axiom,
    ! [VarCurr: state_type] :
      ( v3113(VarCurr)
    <=> v3097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_344,axiom,
    ! [VarCurr: state_type] :
      ( v3107(VarCurr)
    <=> ( v3071(VarCurr)
        & v3108(VarCurr) ) ) ).

tff(writeUnaryOperator_249,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3108(VarCurr)
    <=> v3109(VarCurr) ) ).

tff(addAssignment_1355,axiom,
    ! [VarCurr: state_type] :
      ( v3109(VarCurr)
    <=> v3110(VarCurr) ) ).

tff(addAssignment_1354,axiom,
    ! [VarCurr: state_type] :
      ( v3110(VarCurr)
    <=> v3095(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_343,axiom,
    ! [VarCurr: state_type] :
      ( v3099(VarCurr)
    <=> ( v3100(VarCurr)
        & v3103(VarCurr) ) ) ).

tff(writeUnaryOperator_248,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3103(VarCurr)
    <=> v3104(VarCurr) ) ).

tff(addAssignment_1353,axiom,
    ! [VarCurr: state_type] :
      ( v3104(VarCurr)
    <=> v3105(VarCurr) ) ).

tff(addAssignment_1352,axiom,
    ! [VarCurr: state_type] :
      ( v3105(VarCurr)
    <=> v3097(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_342,axiom,
    ! [VarCurr: state_type] :
      ( v3100(VarCurr)
    <=> ( v3087(VarCurr)
        & v3101(VarCurr) ) ) ).

tff(addAssignment_1351,axiom,
    ! [VarCurr: state_type] :
      ( v3101(VarCurr)
    <=> v3102(VarCurr) ) ).

tff(addAssignment_1350,axiom,
    ! [VarCurr: state_type] :
      ( v3102(VarCurr)
    <=> v3095(VarCurr) ) ).

tff(addAssignment_1349,axiom,
    ! [VarCurr: state_type] :
      ( v3097(VarCurr)
    <=> v2998(VarCurr) ) ).

tff(addAssignment_1348,axiom,
    ! [VarCurr: state_type] :
      ( v3095(VarCurr)
    <=> v3089(VarCurr) ) ).

tff(addAssignment_1347,axiom,
    ! [VarCurr: state_type] :
      ( v3087(VarCurr)
    <=> v3089(VarCurr) ) ).

tff(addAssignment_1346,axiom,
    ! [VarCurr: state_type] :
      ( v3089(VarCurr)
    <=> v3091(VarCurr) ) ).

tff(addAssignment_1345,axiom,
    ! [VarCurr: state_type] :
      ( v3091(VarCurr)
    <=> v3093(VarCurr) ) ).

tff(addAssignment_1344,axiom,
    ! [VarCurr: state_type] :
      ( v3079(VarCurr)
    <=> v3081(VarCurr) ) ).

tff(addAssignment_1343,axiom,
    ! [VarCurr: state_type] :
      ( v3081(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1342,axiom,
    ! [VarCurr: state_type] :
      ( v3075(VarCurr)
    <=> v3077(VarCurr) ) ).

tff(addAssignment_1341,axiom,
    ! [VarCurr: state_type] :
      ( v3077(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1340,axiom,
    ! [VarCurr: state_type] :
      ( v3057(VarCurr)
    <=> v3059(VarCurr) ) ).

tff(addAssignment_1339,axiom,
    ! [VarCurr: state_type] :
      ( v3059(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1338,axiom,
    ! [VarCurr: state_type] :
      ( v3053(VarCurr)
    <=> v3055(VarCurr) ) ).

tff(addAssignment_1337,axiom,
    ! [VarCurr: state_type] :
      ( v3055(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1336,axiom,
    ! [VarCurr: state_type] :
      ( v3045(VarCurr)
    <=> v3041(VarCurr,1) ) ).

tff(addAssignment_1335,axiom,
    ! [VarCurr: state_type] :
      ( v3041(VarCurr,1)
    <=> v3043(VarCurr,1) ) ).

tff(addAssignment_1334,axiom,
    ! [VarCurr: state_type] :
      ( v3039(VarCurr)
    <=> v3041(VarCurr,2) ) ).

tff(addAssignment_1333,axiom,
    ! [VarCurr: state_type] :
      ( v3041(VarCurr,2)
    <=> v3043(VarCurr,2) ) ).

tff(addAssignment_1332,axiom,
    ! [VarCurr: state_type] :
      ( v3033(VarCurr)
    <=> v3035(VarCurr,34) ) ).

tff(addAssignment_1331,axiom,
    ! [VarCurr: state_type] :
      ( v3035(VarCurr,34)
    <=> v3037(VarCurr,34) ) ).

tff(addAssignment_1330,axiom,
    ! [VarCurr: state_type] :
      ( v3018(VarCurr)
    <=> v3020(VarCurr) ) ).

tff(writeUnaryOperator_247,axiom,
    ! [VarCurr: state_type] :
      ( ~ v3020(VarCurr)
    <=> v3022(VarCurr,0) ) ).

tff(addAssignment_1329,axiom,
    ! [VarCurr: state_type] :
      ( v3022(VarCurr,0)
    <=> v3024(VarCurr,0) ) ).

tff(addAssignment_1328,axiom,
    ! [VarCurr: state_type] :
      ( v3024(VarCurr,0)
    <=> v3026(VarCurr,0) ) ).

tff(addAssignment_1327,axiom,
    ! [VarCurr: state_type] :
      ( v3010(VarCurr)
    <=> v3012(VarCurr) ) ).

tff(addAssignment_1326,axiom,
    ! [VarCurr: state_type] :
      ( v3012(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1325,axiom,
    ! [VarCurr: state_type] :
      ( v3006(VarCurr)
    <=> v3008(VarCurr) ) ).

tff(addAssignment_1324,axiom,
    ! [VarCurr: state_type] :
      ( v3008(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1323,axiom,
    ! [VarCurr: state_type] :
      ( v2984(VarCurr)
    <=> v2986(VarCurr) ) ).

tff(addAssignment_1322,axiom,
    ! [VarCurr: state_type] :
      ( v2986(VarCurr)
    <=> v2988(VarCurr) ) ).

tff(addAssignment_1321,axiom,
    ! [VarCurr: state_type] :
      ( v2988(VarCurr)
    <=> v2990(VarCurr) ) ).

tff(addAssignment_1320,axiom,
    ! [VarCurr: state_type] :
      ( v2990(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_1319,axiom,
    ! [VarCurr: state_type] :
      ( v2976(VarCurr)
    <=> v2978(VarCurr) ) ).

tff(addAssignment_1318,axiom,
    ! [VarCurr: state_type] :
      ( v2978(VarCurr)
    <=> v2980(VarCurr) ) ).

tff(addAssignment_1317,axiom,
    ! [VarCurr: state_type] :
      ( v2980(VarCurr)
    <=> v2982(VarCurr) ) ).

tff(addAssignment_1316,axiom,
    ! [VarCurr: state_type] :
      ( v2982(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_1315,axiom,
    ! [VarCurr: state_type] :
      ( v2952(VarCurr)
    <=> v2954(VarCurr) ) ).

tff(addAssignment_1314,axiom,
    ! [VarCurr: state_type] :
      ( v2954(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_1313,axiom,
    ! [VarCurr: state_type] :
      ( v2948(VarCurr)
    <=> v2950(VarCurr) ) ).

tff(addAssignment_1312,axiom,
    ! [VarCurr: state_type] :
      ( v2950(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_1311,axiom,
    ! [VarCurr: state_type] :
      ( v2924(VarCurr)
    <=> v2926(VarCurr) ) ).

tff(addAssignment_1310,axiom,
    ! [VarCurr: state_type] :
      ( v2926(VarCurr)
    <=> v2928(VarCurr) ) ).

tff(addAssignment_1309,axiom,
    ! [VarCurr: state_type] :
      ( v2928(VarCurr)
    <=> v2930(VarCurr) ) ).

tff(addAssignment_1308,axiom,
    ! [VarCurr: state_type] :
      ( v2930(VarCurr)
    <=> v160(VarCurr) ) ).

tff(addAssignment_1307,axiom,
    ! [VarCurr: state_type] :
      ( v2916(VarCurr)
    <=> v2918(VarCurr) ) ).

tff(addAssignment_1306,axiom,
    ! [VarCurr: state_type] :
      ( v2918(VarCurr)
    <=> v2920(VarCurr) ) ).

tff(addAssignment_1305,axiom,
    ! [VarCurr: state_type] :
      ( v2920(VarCurr)
    <=> v2922(VarCurr) ) ).

tff(addAssignment_1304,axiom,
    ! [VarCurr: state_type] :
      ( v2922(VarCurr)
    <=> v150(VarCurr) ) ).

tff(addAssignment_1303,axiom,
    ! [VarCurr: state_type] :
      ( v2888(VarCurr)
    <=> v2890(VarCurr) ) ).

tff(addAssignment_1302,axiom,
    ! [VarCurr: state_type] :
      ( v2890(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_1301,axiom,
    ! [VarCurr: state_type] :
      ( v2884(VarCurr)
    <=> v2886(VarCurr) ) ).

tff(addAssignment_1300,axiom,
    ! [VarCurr: state_type] :
      ( v2886(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_1299,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2831(VarCurr,B)
      <=> v2833(VarCurr,B) ) ) ).

tff(addAssignment_1298,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2833(VarCurr,B)
      <=> v2834(VarCurr,B) ) ) ).

tff(addAssignment_1297,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,0)
    <=> v2862(VarCurr) ) ).

tff(addAssignment_1296,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,1)
    <=> v2860(VarCurr) ) ).

tff(addAssignment_1295,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,2)
    <=> v2855(VarCurr) ) ).

tff(addAssignment_1294,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,3)
    <=> v2850(VarCurr) ) ).

tff(addAssignment_1293,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,4)
    <=> v2845(VarCurr) ) ).

tff(addAssignment_1292,axiom,
    ! [VarCurr: state_type] :
      ( v2834(VarCurr,5)
    <=> v2836(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_341,axiom,
    ! [VarCurr: state_type] :
      ( v2860(VarCurr)
    <=> ( v2861(VarCurr)
        & v2864(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_63,axiom,
    ! [VarCurr: state_type] :
      ( v2864(VarCurr)
    <=> ( v2813(VarCurr,0)
        | v2813(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_340,axiom,
    ! [VarCurr: state_type] :
      ( v2861(VarCurr)
    <=> ( v2862(VarCurr)
        | v2863(VarCurr) ) ) ).

tff(writeUnaryOperator_246,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2863(VarCurr)
    <=> v2813(VarCurr,1) ) ).

tff(writeUnaryOperator_245,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2862(VarCurr)
    <=> v2813(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_339,axiom,
    ! [VarCurr: state_type] :
      ( v2855(VarCurr)
    <=> ( v2856(VarCurr)
        & v2859(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_62,axiom,
    ! [VarCurr: state_type] :
      ( v2859(VarCurr)
    <=> ( v2842(VarCurr)
        | v2813(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_338,axiom,
    ! [VarCurr: state_type] :
      ( v2856(VarCurr)
    <=> ( v2857(VarCurr)
        | v2858(VarCurr) ) ) ).

tff(writeUnaryOperator_244,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2858(VarCurr)
    <=> v2813(VarCurr,2) ) ).

tff(writeUnaryOperator_243,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2857(VarCurr)
    <=> v2842(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_337,axiom,
    ! [VarCurr: state_type] :
      ( v2850(VarCurr)
    <=> ( v2851(VarCurr)
        & v2854(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_61,axiom,
    ! [VarCurr: state_type] :
      ( v2854(VarCurr)
    <=> ( v2841(VarCurr)
        | v2813(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_336,axiom,
    ! [VarCurr: state_type] :
      ( v2851(VarCurr)
    <=> ( v2852(VarCurr)
        | v2853(VarCurr) ) ) ).

tff(writeUnaryOperator_242,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2853(VarCurr)
    <=> v2813(VarCurr,3) ) ).

tff(writeUnaryOperator_241,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2852(VarCurr)
    <=> v2841(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_335,axiom,
    ! [VarCurr: state_type] :
      ( v2845(VarCurr)
    <=> ( v2846(VarCurr)
        & v2849(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_60,axiom,
    ! [VarCurr: state_type] :
      ( v2849(VarCurr)
    <=> ( v2840(VarCurr)
        | v2813(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_334,axiom,
    ! [VarCurr: state_type] :
      ( v2846(VarCurr)
    <=> ( v2847(VarCurr)
        | v2848(VarCurr) ) ) ).

tff(writeUnaryOperator_240,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2848(VarCurr)
    <=> v2813(VarCurr,4) ) ).

tff(writeUnaryOperator_239,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2847(VarCurr)
    <=> v2840(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_333,axiom,
    ! [VarCurr: state_type] :
      ( v2836(VarCurr)
    <=> ( v2837(VarCurr)
        & v2844(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_59,axiom,
    ! [VarCurr: state_type] :
      ( v2844(VarCurr)
    <=> ( v2839(VarCurr)
        | v2813(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_332,axiom,
    ! [VarCurr: state_type] :
      ( v2837(VarCurr)
    <=> ( v2838(VarCurr)
        | v2843(VarCurr) ) ) ).

tff(writeUnaryOperator_238,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2843(VarCurr)
    <=> v2813(VarCurr,5) ) ).

tff(writeUnaryOperator_237,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2838(VarCurr)
    <=> v2839(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_58,axiom,
    ! [VarCurr: state_type] :
      ( v2839(VarCurr)
    <=> ( v2840(VarCurr)
        & v2813(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_57,axiom,
    ! [VarCurr: state_type] :
      ( v2840(VarCurr)
    <=> ( v2841(VarCurr)
        & v2813(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_56,axiom,
    ! [VarCurr: state_type] :
      ( v2841(VarCurr)
    <=> ( v2842(VarCurr)
        & v2813(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_55,axiom,
    ! [VarCurr: state_type] :
      ( v2842(VarCurr)
    <=> ( v2813(VarCurr,0)
        & v2813(VarCurr,1) ) ) ).

tff(addAssignment_1291,axiom,
    ! [VarCurr: state_type] :
      ( v2823(VarCurr)
    <=> v2825(VarCurr) ) ).

tff(addAssignment_1290,axiom,
    ! [VarCurr: state_type] :
      ( v2825(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_1289,axiom,
    ! [VarCurr: state_type] :
      ( v2819(VarCurr)
    <=> v2821(VarCurr) ) ).

tff(addAssignment_1288,axiom,
    ! [VarCurr: state_type] :
      ( v2821(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_1287,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2320(VarCurr,B)
      <=> v2322(VarCurr,B) ) ) ).

tff(addAssignment_1286,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2322(VarCurr,B)
      <=> v2324(VarCurr,B) ) ) ).

tff(addAssignment_1285,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2324(VarCurr,B)
      <=> v2622(VarCurr,B) ) ) ).

tff(addAssignment_1284,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2622(VarCurr,B)
      <=> v2624(VarCurr,B) ) ) ).

tff(addAssignment_1283,axiom,
    ! [VarCurr: state_type] :
      ( ( v2622(VarCurr,11)
      <=> v2623(VarCurr,3) )
      & ( v2622(VarCurr,10)
      <=> v2623(VarCurr,2) )
      & ( v2622(VarCurr,9)
      <=> v2623(VarCurr,1) )
      & ( v2622(VarCurr,8)
      <=> v2623(VarCurr,0) ) ) ).

tff(addAssignment_1282,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,0)
    <=> v2803(VarCurr) ) ).

tff(addAssignment_1281,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,1)
    <=> v2798(VarCurr) ) ).

tff(addAssignment_1280,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,2)
    <=> v2793(VarCurr) ) ).

tff(addAssignment_1279,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,3)
    <=> v2788(VarCurr) ) ).

tff(addAssignment_1278,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,4)
    <=> v2783(VarCurr) ) ).

tff(addAssignment_1277,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,5)
    <=> v2778(VarCurr) ) ).

tff(addAssignment_1276,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,6)
    <=> v2773(VarCurr) ) ).

tff(addAssignment_1275,axiom,
    ! [VarCurr: state_type] :
      ( v2624(VarCurr,7)
    <=> v2626(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_331,axiom,
    ! [VarCurr: state_type] :
      ( v2803(VarCurr)
    <=> ( v2804(VarCurr)
        & v2807(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_330,axiom,
    ! [VarCurr: state_type] :
      ( v2807(VarCurr)
    <=> ( v2642(VarCurr,0)
        | v2576(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_329,axiom,
    ! [VarCurr: state_type] :
      ( v2804(VarCurr)
    <=> ( v2805(VarCurr)
        | v2806(VarCurr) ) ) ).

tff(writeUnaryOperator_236,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2806(VarCurr)
    <=> v2576(VarCurr,0) ) ).

tff(writeUnaryOperator_235,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2805(VarCurr)
    <=> v2642(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_328,axiom,
    ! [VarCurr: state_type] :
      ( v2798(VarCurr)
    <=> ( v2799(VarCurr)
        & v2802(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_327,axiom,
    ! [VarCurr: state_type] :
      ( v2802(VarCurr)
    <=> ( v2641(VarCurr)
        | v2730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_326,axiom,
    ! [VarCurr: state_type] :
      ( v2799(VarCurr)
    <=> ( v2800(VarCurr)
        | v2801(VarCurr) ) ) ).

tff(writeUnaryOperator_234,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2801(VarCurr)
    <=> v2730(VarCurr) ) ).

tff(writeUnaryOperator_233,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2800(VarCurr)
    <=> v2641(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_325,axiom,
    ! [VarCurr: state_type] :
      ( v2793(VarCurr)
    <=> ( v2794(VarCurr)
        & v2797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_324,axiom,
    ! [VarCurr: state_type] :
      ( v2797(VarCurr)
    <=> ( v2639(VarCurr)
        | v2736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_323,axiom,
    ! [VarCurr: state_type] :
      ( v2794(VarCurr)
    <=> ( v2795(VarCurr)
        | v2796(VarCurr) ) ) ).

tff(writeUnaryOperator_232,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2796(VarCurr)
    <=> v2736(VarCurr) ) ).

tff(writeUnaryOperator_231,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2795(VarCurr)
    <=> v2639(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_322,axiom,
    ! [VarCurr: state_type] :
      ( v2788(VarCurr)
    <=> ( v2789(VarCurr)
        & v2792(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_321,axiom,
    ! [VarCurr: state_type] :
      ( v2792(VarCurr)
    <=> ( v2637(VarCurr)
        | v2742(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_320,axiom,
    ! [VarCurr: state_type] :
      ( v2789(VarCurr)
    <=> ( v2790(VarCurr)
        | v2791(VarCurr) ) ) ).

tff(writeUnaryOperator_230,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2791(VarCurr)
    <=> v2742(VarCurr) ) ).

tff(writeUnaryOperator_229,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2790(VarCurr)
    <=> v2637(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_319,axiom,
    ! [VarCurr: state_type] :
      ( v2783(VarCurr)
    <=> ( v2784(VarCurr)
        & v2787(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_318,axiom,
    ! [VarCurr: state_type] :
      ( v2787(VarCurr)
    <=> ( v2635(VarCurr)
        | v2748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_317,axiom,
    ! [VarCurr: state_type] :
      ( v2784(VarCurr)
    <=> ( v2785(VarCurr)
        | v2786(VarCurr) ) ) ).

tff(writeUnaryOperator_228,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2786(VarCurr)
    <=> v2748(VarCurr) ) ).

tff(writeUnaryOperator_227,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2785(VarCurr)
    <=> v2635(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_316,axiom,
    ! [VarCurr: state_type] :
      ( v2778(VarCurr)
    <=> ( v2779(VarCurr)
        & v2782(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_315,axiom,
    ! [VarCurr: state_type] :
      ( v2782(VarCurr)
    <=> ( v2633(VarCurr)
        | v2754(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_314,axiom,
    ! [VarCurr: state_type] :
      ( v2779(VarCurr)
    <=> ( v2780(VarCurr)
        | v2781(VarCurr) ) ) ).

tff(writeUnaryOperator_226,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2781(VarCurr)
    <=> v2754(VarCurr) ) ).

tff(writeUnaryOperator_225,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2780(VarCurr)
    <=> v2633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_313,axiom,
    ! [VarCurr: state_type] :
      ( v2773(VarCurr)
    <=> ( v2774(VarCurr)
        & v2777(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_312,axiom,
    ! [VarCurr: state_type] :
      ( v2777(VarCurr)
    <=> ( v2631(VarCurr)
        | v2760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_311,axiom,
    ! [VarCurr: state_type] :
      ( v2774(VarCurr)
    <=> ( v2775(VarCurr)
        | v2776(VarCurr) ) ) ).

tff(writeUnaryOperator_224,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2776(VarCurr)
    <=> v2760(VarCurr) ) ).

tff(writeUnaryOperator_223,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2775(VarCurr)
    <=> v2631(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_310,axiom,
    ! [VarCurr: state_type] :
      ( v2626(VarCurr)
    <=> ( v2627(VarCurr)
        & v2772(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_309,axiom,
    ! [VarCurr: state_type] :
      ( v2772(VarCurr)
    <=> ( v2629(VarCurr)
        | v2767(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_308,axiom,
    ! [VarCurr: state_type] :
      ( v2627(VarCurr)
    <=> ( v2628(VarCurr)
        | v2766(VarCurr) ) ) ).

tff(writeUnaryOperator_222,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2766(VarCurr)
    <=> v2767(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_307,axiom,
    ! [VarCurr: state_type] :
      ( v2767(VarCurr)
    <=> ( v2768(VarCurr)
        & v2771(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_54,axiom,
    ! [VarCurr: state_type] :
      ( v2771(VarCurr)
    <=> ( v2642(VarCurr,7)
        | v2576(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_306,axiom,
    ! [VarCurr: state_type] :
      ( v2768(VarCurr)
    <=> ( v2769(VarCurr)
        | v2770(VarCurr) ) ) ).

tff(writeUnaryOperator_221,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2770(VarCurr)
    <=> v2576(VarCurr,7) ) ).

tff(writeUnaryOperator_220,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2769(VarCurr)
    <=> v2642(VarCurr,7) ) ).

tff(writeUnaryOperator_219,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2628(VarCurr)
    <=> v2629(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_305,axiom,
    ! [VarCurr: state_type] :
      ( v2629(VarCurr)
    <=> ( v2630(VarCurr)
        | v2765(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_53,axiom,
    ! [VarCurr: state_type] :
      ( v2765(VarCurr)
    <=> ( v2642(VarCurr,6)
        & v2576(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_304,axiom,
    ! [VarCurr: state_type] :
      ( v2630(VarCurr)
    <=> ( v2631(VarCurr)
        & v2760(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_303,axiom,
    ! [VarCurr: state_type] :
      ( v2760(VarCurr)
    <=> ( v2761(VarCurr)
        & v2764(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_52,axiom,
    ! [VarCurr: state_type] :
      ( v2764(VarCurr)
    <=> ( v2642(VarCurr,6)
        | v2576(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_302,axiom,
    ! [VarCurr: state_type] :
      ( v2761(VarCurr)
    <=> ( v2762(VarCurr)
        | v2763(VarCurr) ) ) ).

tff(writeUnaryOperator_218,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2763(VarCurr)
    <=> v2576(VarCurr,6) ) ).

tff(writeUnaryOperator_217,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2762(VarCurr)
    <=> v2642(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_301,axiom,
    ! [VarCurr: state_type] :
      ( v2631(VarCurr)
    <=> ( v2632(VarCurr)
        | v2759(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_51,axiom,
    ! [VarCurr: state_type] :
      ( v2759(VarCurr)
    <=> ( v2642(VarCurr,5)
        & v2576(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_300,axiom,
    ! [VarCurr: state_type] :
      ( v2632(VarCurr)
    <=> ( v2633(VarCurr)
        & v2754(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_299,axiom,
    ! [VarCurr: state_type] :
      ( v2754(VarCurr)
    <=> ( v2755(VarCurr)
        & v2758(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_50,axiom,
    ! [VarCurr: state_type] :
      ( v2758(VarCurr)
    <=> ( v2642(VarCurr,5)
        | v2576(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_298,axiom,
    ! [VarCurr: state_type] :
      ( v2755(VarCurr)
    <=> ( v2756(VarCurr)
        | v2757(VarCurr) ) ) ).

tff(writeUnaryOperator_216,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2757(VarCurr)
    <=> v2576(VarCurr,5) ) ).

tff(writeUnaryOperator_215,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2756(VarCurr)
    <=> v2642(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_297,axiom,
    ! [VarCurr: state_type] :
      ( v2633(VarCurr)
    <=> ( v2634(VarCurr)
        | v2753(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_49,axiom,
    ! [VarCurr: state_type] :
      ( v2753(VarCurr)
    <=> ( v2642(VarCurr,4)
        & v2576(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_296,axiom,
    ! [VarCurr: state_type] :
      ( v2634(VarCurr)
    <=> ( v2635(VarCurr)
        & v2748(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_295,axiom,
    ! [VarCurr: state_type] :
      ( v2748(VarCurr)
    <=> ( v2749(VarCurr)
        & v2752(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_48,axiom,
    ! [VarCurr: state_type] :
      ( v2752(VarCurr)
    <=> ( v2642(VarCurr,4)
        | v2576(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_294,axiom,
    ! [VarCurr: state_type] :
      ( v2749(VarCurr)
    <=> ( v2750(VarCurr)
        | v2751(VarCurr) ) ) ).

tff(writeUnaryOperator_214,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2751(VarCurr)
    <=> v2576(VarCurr,4) ) ).

tff(writeUnaryOperator_213,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2750(VarCurr)
    <=> v2642(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_293,axiom,
    ! [VarCurr: state_type] :
      ( v2635(VarCurr)
    <=> ( v2636(VarCurr)
        | v2747(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_47,axiom,
    ! [VarCurr: state_type] :
      ( v2747(VarCurr)
    <=> ( v2642(VarCurr,3)
        & v2576(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_292,axiom,
    ! [VarCurr: state_type] :
      ( v2636(VarCurr)
    <=> ( v2637(VarCurr)
        & v2742(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_291,axiom,
    ! [VarCurr: state_type] :
      ( v2742(VarCurr)
    <=> ( v2743(VarCurr)
        & v2746(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_46,axiom,
    ! [VarCurr: state_type] :
      ( v2746(VarCurr)
    <=> ( v2642(VarCurr,3)
        | v2576(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_290,axiom,
    ! [VarCurr: state_type] :
      ( v2743(VarCurr)
    <=> ( v2744(VarCurr)
        | v2745(VarCurr) ) ) ).

tff(writeUnaryOperator_212,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2745(VarCurr)
    <=> v2576(VarCurr,3) ) ).

tff(writeUnaryOperator_211,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2744(VarCurr)
    <=> v2642(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_289,axiom,
    ! [VarCurr: state_type] :
      ( v2637(VarCurr)
    <=> ( v2638(VarCurr)
        | v2741(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_45,axiom,
    ! [VarCurr: state_type] :
      ( v2741(VarCurr)
    <=> ( v2642(VarCurr,2)
        & v2576(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_288,axiom,
    ! [VarCurr: state_type] :
      ( v2638(VarCurr)
    <=> ( v2639(VarCurr)
        & v2736(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_287,axiom,
    ! [VarCurr: state_type] :
      ( v2736(VarCurr)
    <=> ( v2737(VarCurr)
        & v2740(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_44,axiom,
    ! [VarCurr: state_type] :
      ( v2740(VarCurr)
    <=> ( v2642(VarCurr,2)
        | v2576(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_286,axiom,
    ! [VarCurr: state_type] :
      ( v2737(VarCurr)
    <=> ( v2738(VarCurr)
        | v2739(VarCurr) ) ) ).

tff(writeUnaryOperator_210,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2739(VarCurr)
    <=> v2576(VarCurr,2) ) ).

tff(writeUnaryOperator_209,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2738(VarCurr)
    <=> v2642(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_285,axiom,
    ! [VarCurr: state_type] :
      ( v2639(VarCurr)
    <=> ( v2640(VarCurr)
        | v2735(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_43,axiom,
    ! [VarCurr: state_type] :
      ( v2735(VarCurr)
    <=> ( v2642(VarCurr,1)
        & v2576(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_284,axiom,
    ! [VarCurr: state_type] :
      ( v2640(VarCurr)
    <=> ( v2641(VarCurr)
        & v2730(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_283,axiom,
    ! [VarCurr: state_type] :
      ( v2730(VarCurr)
    <=> ( v2731(VarCurr)
        & v2734(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_42,axiom,
    ! [VarCurr: state_type] :
      ( v2734(VarCurr)
    <=> ( v2642(VarCurr,1)
        | v2576(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_282,axiom,
    ! [VarCurr: state_type] :
      ( v2731(VarCurr)
    <=> ( v2732(VarCurr)
        | v2733(VarCurr) ) ) ).

tff(writeUnaryOperator_208,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2733(VarCurr)
    <=> v2576(VarCurr,1) ) ).

tff(writeUnaryOperator_207,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2732(VarCurr)
    <=> v2642(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_281,axiom,
    ! [VarCurr: state_type] :
      ( v2641(VarCurr)
    <=> ( v2642(VarCurr,0)
        & v2576(VarCurr,0) ) ) ).

tff(addAssignment_1274,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,0)
    <=> v2726(VarCurr) ) ).

tff(addAssignment_1273,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,1)
    <=> v2721(VarCurr) ) ).

tff(addAssignment_1272,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,2)
    <=> v2716(VarCurr) ) ).

tff(addAssignment_1271,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,3)
    <=> v2711(VarCurr) ) ).

tff(addAssignment_1270,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,4)
    <=> v2706(VarCurr) ) ).

tff(addAssignment_1269,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,5)
    <=> v2701(VarCurr) ) ).

tff(addAssignment_1268,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,6)
    <=> v2696(VarCurr) ) ).

tff(addAssignment_1267,axiom,
    ! [VarCurr: state_type] :
      ( v2642(VarCurr,7)
    <=> v2644(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_280,axiom,
    ! [VarCurr: state_type] :
      ( v2726(VarCurr)
    <=> ( v2727(VarCurr)
        & v2729(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_279,axiom,
    ! [VarCurr: state_type] :
      ( v2729(VarCurr)
    <=> ( v2046(VarCurr,0)
        | v2326(VarCurr,0) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_278,axiom,
    ! [VarCurr: state_type] :
      ( v2727(VarCurr)
    <=> ( v2116(VarCurr)
        | v2728(VarCurr) ) ) ).

tff(writeUnaryOperator_206,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2728(VarCurr)
    <=> v2326(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_277,axiom,
    ! [VarCurr: state_type] :
      ( v2721(VarCurr)
    <=> ( v2722(VarCurr)
        & v2725(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_276,axiom,
    ! [VarCurr: state_type] :
      ( v2725(VarCurr)
    <=> ( v2659(VarCurr)
        | v2660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_275,axiom,
    ! [VarCurr: state_type] :
      ( v2722(VarCurr)
    <=> ( v2723(VarCurr)
        | v2724(VarCurr) ) ) ).

tff(writeUnaryOperator_205,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2724(VarCurr)
    <=> v2660(VarCurr) ) ).

tff(writeUnaryOperator_204,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2723(VarCurr)
    <=> v2659(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_274,axiom,
    ! [VarCurr: state_type] :
      ( v2716(VarCurr)
    <=> ( v2717(VarCurr)
        & v2720(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_273,axiom,
    ! [VarCurr: state_type] :
      ( v2720(VarCurr)
    <=> ( v2657(VarCurr)
        | v2665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_272,axiom,
    ! [VarCurr: state_type] :
      ( v2717(VarCurr)
    <=> ( v2718(VarCurr)
        | v2719(VarCurr) ) ) ).

tff(writeUnaryOperator_203,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2719(VarCurr)
    <=> v2665(VarCurr) ) ).

tff(writeUnaryOperator_202,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2718(VarCurr)
    <=> v2657(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_271,axiom,
    ! [VarCurr: state_type] :
      ( v2711(VarCurr)
    <=> ( v2712(VarCurr)
        & v2715(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_270,axiom,
    ! [VarCurr: state_type] :
      ( v2715(VarCurr)
    <=> ( v2655(VarCurr)
        | v2670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_269,axiom,
    ! [VarCurr: state_type] :
      ( v2712(VarCurr)
    <=> ( v2713(VarCurr)
        | v2714(VarCurr) ) ) ).

tff(writeUnaryOperator_201,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2714(VarCurr)
    <=> v2670(VarCurr) ) ).

tff(writeUnaryOperator_200,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2713(VarCurr)
    <=> v2655(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_268,axiom,
    ! [VarCurr: state_type] :
      ( v2706(VarCurr)
    <=> ( v2707(VarCurr)
        & v2710(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_267,axiom,
    ! [VarCurr: state_type] :
      ( v2710(VarCurr)
    <=> ( v2653(VarCurr)
        | v2675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_266,axiom,
    ! [VarCurr: state_type] :
      ( v2707(VarCurr)
    <=> ( v2708(VarCurr)
        | v2709(VarCurr) ) ) ).

tff(writeUnaryOperator_199,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2709(VarCurr)
    <=> v2675(VarCurr) ) ).

tff(writeUnaryOperator_198,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2708(VarCurr)
    <=> v2653(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_265,axiom,
    ! [VarCurr: state_type] :
      ( v2701(VarCurr)
    <=> ( v2702(VarCurr)
        & v2705(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_264,axiom,
    ! [VarCurr: state_type] :
      ( v2705(VarCurr)
    <=> ( v2651(VarCurr)
        | v2680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_263,axiom,
    ! [VarCurr: state_type] :
      ( v2702(VarCurr)
    <=> ( v2703(VarCurr)
        | v2704(VarCurr) ) ) ).

tff(writeUnaryOperator_197,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2704(VarCurr)
    <=> v2680(VarCurr) ) ).

tff(writeUnaryOperator_196,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2703(VarCurr)
    <=> v2651(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_262,axiom,
    ! [VarCurr: state_type] :
      ( v2696(VarCurr)
    <=> ( v2697(VarCurr)
        & v2700(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_261,axiom,
    ! [VarCurr: state_type] :
      ( v2700(VarCurr)
    <=> ( v2649(VarCurr)
        | v2685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_260,axiom,
    ! [VarCurr: state_type] :
      ( v2697(VarCurr)
    <=> ( v2698(VarCurr)
        | v2699(VarCurr) ) ) ).

tff(writeUnaryOperator_195,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2699(VarCurr)
    <=> v2685(VarCurr) ) ).

tff(writeUnaryOperator_194,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2698(VarCurr)
    <=> v2649(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_259,axiom,
    ! [VarCurr: state_type] :
      ( v2644(VarCurr)
    <=> ( v2645(VarCurr)
        & v2695(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_258,axiom,
    ! [VarCurr: state_type] :
      ( v2695(VarCurr)
    <=> ( v2647(VarCurr)
        | v2691(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_257,axiom,
    ! [VarCurr: state_type] :
      ( v2645(VarCurr)
    <=> ( v2646(VarCurr)
        | v2690(VarCurr) ) ) ).

tff(writeUnaryOperator_193,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2690(VarCurr)
    <=> v2691(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_256,axiom,
    ! [VarCurr: state_type] :
      ( v2691(VarCurr)
    <=> ( v2692(VarCurr)
        & v2694(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_41,axiom,
    ! [VarCurr: state_type] :
      ( v2694(VarCurr)
    <=> ( v2046(VarCurr,7)
        | v2326(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_255,axiom,
    ! [VarCurr: state_type] :
      ( v2692(VarCurr)
    <=> ( v2087(VarCurr)
        | v2693(VarCurr) ) ) ).

tff(writeUnaryOperator_192,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2693(VarCurr)
    <=> v2326(VarCurr,7) ) ).

tff(writeUnaryOperator_191,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2646(VarCurr)
    <=> v2647(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_254,axiom,
    ! [VarCurr: state_type] :
      ( v2647(VarCurr)
    <=> ( v2648(VarCurr)
        | v2689(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_40,axiom,
    ! [VarCurr: state_type] :
      ( v2689(VarCurr)
    <=> ( v2046(VarCurr,6)
        & v2326(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_253,axiom,
    ! [VarCurr: state_type] :
      ( v2648(VarCurr)
    <=> ( v2649(VarCurr)
        & v2685(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_252,axiom,
    ! [VarCurr: state_type] :
      ( v2685(VarCurr)
    <=> ( v2686(VarCurr)
        & v2688(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_39,axiom,
    ! [VarCurr: state_type] :
      ( v2688(VarCurr)
    <=> ( v2046(VarCurr,6)
        | v2326(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_251,axiom,
    ! [VarCurr: state_type] :
      ( v2686(VarCurr)
    <=> ( v2092(VarCurr)
        | v2687(VarCurr) ) ) ).

tff(writeUnaryOperator_190,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2687(VarCurr)
    <=> v2326(VarCurr,6) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_250,axiom,
    ! [VarCurr: state_type] :
      ( v2649(VarCurr)
    <=> ( v2650(VarCurr)
        | v2684(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_38,axiom,
    ! [VarCurr: state_type] :
      ( v2684(VarCurr)
    <=> ( v2046(VarCurr,5)
        & v2326(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_249,axiom,
    ! [VarCurr: state_type] :
      ( v2650(VarCurr)
    <=> ( v2651(VarCurr)
        & v2680(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_248,axiom,
    ! [VarCurr: state_type] :
      ( v2680(VarCurr)
    <=> ( v2681(VarCurr)
        & v2683(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_37,axiom,
    ! [VarCurr: state_type] :
      ( v2683(VarCurr)
    <=> ( v2046(VarCurr,5)
        | v2326(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_247,axiom,
    ! [VarCurr: state_type] :
      ( v2681(VarCurr)
    <=> ( v2097(VarCurr)
        | v2682(VarCurr) ) ) ).

tff(writeUnaryOperator_189,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2682(VarCurr)
    <=> v2326(VarCurr,5) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_246,axiom,
    ! [VarCurr: state_type] :
      ( v2651(VarCurr)
    <=> ( v2652(VarCurr)
        | v2679(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_36,axiom,
    ! [VarCurr: state_type] :
      ( v2679(VarCurr)
    <=> ( v2046(VarCurr,4)
        & v2326(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_245,axiom,
    ! [VarCurr: state_type] :
      ( v2652(VarCurr)
    <=> ( v2653(VarCurr)
        & v2675(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_244,axiom,
    ! [VarCurr: state_type] :
      ( v2675(VarCurr)
    <=> ( v2676(VarCurr)
        & v2678(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_35,axiom,
    ! [VarCurr: state_type] :
      ( v2678(VarCurr)
    <=> ( v2046(VarCurr,4)
        | v2326(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_243,axiom,
    ! [VarCurr: state_type] :
      ( v2676(VarCurr)
    <=> ( v2102(VarCurr)
        | v2677(VarCurr) ) ) ).

tff(writeUnaryOperator_188,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2677(VarCurr)
    <=> v2326(VarCurr,4) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_242,axiom,
    ! [VarCurr: state_type] :
      ( v2653(VarCurr)
    <=> ( v2654(VarCurr)
        | v2674(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_34,axiom,
    ! [VarCurr: state_type] :
      ( v2674(VarCurr)
    <=> ( v2046(VarCurr,3)
        & v2326(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_241,axiom,
    ! [VarCurr: state_type] :
      ( v2654(VarCurr)
    <=> ( v2655(VarCurr)
        & v2670(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_240,axiom,
    ! [VarCurr: state_type] :
      ( v2670(VarCurr)
    <=> ( v2671(VarCurr)
        & v2673(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_33,axiom,
    ! [VarCurr: state_type] :
      ( v2673(VarCurr)
    <=> ( v2046(VarCurr,3)
        | v2326(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_239,axiom,
    ! [VarCurr: state_type] :
      ( v2671(VarCurr)
    <=> ( v2107(VarCurr)
        | v2672(VarCurr) ) ) ).

tff(writeUnaryOperator_187,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2672(VarCurr)
    <=> v2326(VarCurr,3) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_238,axiom,
    ! [VarCurr: state_type] :
      ( v2655(VarCurr)
    <=> ( v2656(VarCurr)
        | v2669(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_32,axiom,
    ! [VarCurr: state_type] :
      ( v2669(VarCurr)
    <=> ( v2046(VarCurr,2)
        & v2326(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_237,axiom,
    ! [VarCurr: state_type] :
      ( v2656(VarCurr)
    <=> ( v2657(VarCurr)
        & v2665(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_236,axiom,
    ! [VarCurr: state_type] :
      ( v2665(VarCurr)
    <=> ( v2666(VarCurr)
        & v2668(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_31,axiom,
    ! [VarCurr: state_type] :
      ( v2668(VarCurr)
    <=> ( v2046(VarCurr,2)
        | v2326(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_235,axiom,
    ! [VarCurr: state_type] :
      ( v2666(VarCurr)
    <=> ( v2112(VarCurr)
        | v2667(VarCurr) ) ) ).

tff(writeUnaryOperator_186,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2667(VarCurr)
    <=> v2326(VarCurr,2) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_234,axiom,
    ! [VarCurr: state_type] :
      ( v2657(VarCurr)
    <=> ( v2658(VarCurr)
        | v2664(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_30,axiom,
    ! [VarCurr: state_type] :
      ( v2664(VarCurr)
    <=> ( v2046(VarCurr,1)
        & v2326(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_233,axiom,
    ! [VarCurr: state_type] :
      ( v2658(VarCurr)
    <=> ( v2659(VarCurr)
        & v2660(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_232,axiom,
    ! [VarCurr: state_type] :
      ( v2660(VarCurr)
    <=> ( v2661(VarCurr)
        & v2663(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_29,axiom,
    ! [VarCurr: state_type] :
      ( v2663(VarCurr)
    <=> ( v2046(VarCurr,1)
        | v2326(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_231,axiom,
    ! [VarCurr: state_type] :
      ( v2661(VarCurr)
    <=> ( v2117(VarCurr)
        | v2662(VarCurr) ) ) ).

tff(writeUnaryOperator_185,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2662(VarCurr)
    <=> v2326(VarCurr,1) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_230,axiom,
    ! [VarCurr: state_type] :
      ( v2659(VarCurr)
    <=> ( v2046(VarCurr,0)
        & v2326(VarCurr,0) ) ) ).

tff(addAssignment_1266,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,7)
    <=> v2619(VarCurr,7) ) ).

tff(addAssignment_1265,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,6)
    <=> v2619(VarCurr,6) ) ).

tff(addAssignment_1264,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,5)
    <=> v2619(VarCurr,5) ) ).

tff(addAssignment_1263,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,4)
    <=> v2619(VarCurr,4) ) ).

tff(addAssignment_1262,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,3)
    <=> v2619(VarCurr,3) ) ).

tff(addAssignment_1261,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,2)
    <=> v2619(VarCurr,2) ) ).

tff(addAssignment_1260,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,1)
    <=> v2619(VarCurr,1) ) ).

tff(addAssignment_1259,axiom,
    ! [VarCurr: state_type] :
      ( v2576(VarCurr,0)
    <=> v2619(VarCurr,0) ) ).

tff(addAssignment_1258,axiom,
    ! [VarCurr: state_type] :
      ( v2619(VarCurr,0)
    <=> v2621(VarCurr) ) ).

tff(addAssignment_1257,axiom,
    ! [VarCurr: state_type] :
      ( ( v2619(VarCurr,7)
      <=> $false )
      & ( v2619(VarCurr,6)
      <=> $false )
      & ( v2619(VarCurr,5)
      <=> $false )
      & ( v2619(VarCurr,4)
      <=> $false )
      & ( v2619(VarCurr,3)
      <=> $false )
      & ( v2619(VarCurr,2)
      <=> $false )
      & ( v2619(VarCurr,1)
      <=> $false ) ) ).

tff(bitBlastConstant_54,axiom,
    ~ b0000000(6) ).

tff(bitBlastConstant_53,axiom,
    ~ b0000000(5) ).

tff(bitBlastConstant_52,axiom,
    ~ b0000000(4) ).

tff(bitBlastConstant_51,axiom,
    ~ b0000000(3) ).

tff(bitBlastConstant_50,axiom,
    ~ b0000000(2) ).

tff(bitBlastConstant_49,axiom,
    ~ b0000000(1) ).

tff(bitBlastConstant_48,axiom,
    ~ b0000000(0) ).

tff(writeUnaryOperator_184,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2621(VarCurr)
    <=> v2578(VarCurr) ) ).

tff(addAssignment_1256,axiom,
    ! [VarCurr: state_type] :
      ( v2578(VarCurr)
    <=> v2580(VarCurr) ) ).

tff(addAssignment_1255,axiom,
    ! [VarCurr: state_type] :
      ( v2580(VarCurr)
    <=> v2582(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_42,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2603(VarNext)
       => ( v2582(VarNext)
        <=> v2582(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_42,axiom,
    ! [VarNext: state_type] :
      ( v2603(VarNext)
     => ( v2582(VarNext)
      <=> v2613(VarNext) ) ) ).

tff(addAssignment_1254,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2613(VarNext)
      <=> v2611(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_27,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2614(VarCurr)
     => ( v2611(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_27,axiom,
    ! [VarCurr: state_type] :
      ( v2614(VarCurr)
     => ( v2611(VarCurr)
      <=> v2592(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_229,axiom,
    ! [VarCurr: state_type] :
      ( v2614(VarCurr)
    <=> ( v2615(VarCurr)
        & v2616(VarCurr) ) ) ).

tff(writeUnaryOperator_183,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2616(VarCurr)
    <=> v2588(VarCurr) ) ).

tff(writeUnaryOperator_182,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2615(VarCurr)
    <=> v2584(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_228,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2603(VarNext)
      <=> v2604(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_227,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2604(VarNext)
      <=> ( v2605(VarNext)
          & v2598(VarNext) ) ) ) ).

tff(writeUnaryOperator_181,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2605(VarNext)
      <=> v2607(VarNext) ) ) ).

tff(addAssignment_1253,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2607(VarNext)
      <=> v2598(VarCurr) ) ) ).

tff(addAssignment_1252,axiom,
    ! [VarCurr: state_type] :
      ( v2598(VarCurr)
    <=> v2600(VarCurr) ) ).

tff(addAssignment_1251,axiom,
    ! [VarCurr: state_type] :
      ( v2600(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1250,axiom,
    ! [VarCurr: state_type] :
      ( v2592(VarCurr)
    <=> v2594(VarCurr) ) ).

tff(addAssignment_1249,axiom,
    ! [VarCurr: state_type] :
      ( v2594(VarCurr)
    <=> v2596(VarCurr) ) ).

tff(addAssignment_1248,axiom,
    ! [VarCurr: state_type] :
      ( v2596(VarCurr)
    <=> $false ) ).

tff(addAssignment_1247,axiom,
    ! [VarCurr: state_type] :
      ( v2588(VarCurr)
    <=> v2590(VarCurr) ) ).

tff(addAssignment_1246,axiom,
    ! [VarCurr: state_type] :
      ( v2590(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1245,axiom,
    ! [VarCurr: state_type] :
      ( v2584(VarCurr)
    <=> v2586(VarCurr) ) ).

tff(addAssignment_1244,axiom,
    ! [VarCurr: state_type] :
      ( v2586(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_1243,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,7)
    <=> v2438(VarCurr,7) ) ).

tff(addAssignment_1242,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,7)
    <=> v2330(VarCurr,7) ) ).

tff(addAssignment_1241,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,7)
    <=> v2332(VarCurr,7) ) ).

tff(addAssignment_1240,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,7)
    <=> v2568(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_41,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2569(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2568(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_41,axiom,
    ! [VarNext: state_type] :
      ( v2569(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2568(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_226,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2569(VarNext)
      <=> v2570(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_225,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2570(VarNext)
      <=> ( v2572(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_180,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2572(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1239,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,7)
    <=> v2346(VarCurr,7) ) ).

tff(addAssignment_1238,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,7)
    <=> v2408(VarCurr,7) ) ).

tff(addAssignment_1237,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,7)
    <=> v2350(VarCurr,7) ) ).

tff(addAssignment_1236,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,7)
    <=> v2375(VarCurr,7) ) ).

tff(addAssignment_1235,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,7)
    <=> v2372(VarCurr,7) ) ).

tff(addAssignment_1234,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,7)
    <=> v2369(VarCurr,7) ) ).

tff(addAssignment_1233,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,7)
    <=> v2371(VarCurr,7) ) ).

tff(addAssignment_1232,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,7)
    <=> v2365(VarCurr,7) ) ).

tff(addAssignment_1231,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,7)
    <=> v1119(VarCurr,7) ) ).

tff(addAssignment_1230,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,7)
    <=> v1121(VarCurr,7) ) ).

tff(addAssignment_1229,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,7)
    <=> v1123(VarCurr,7) ) ).

tff(addAssignment_1228,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,7)
    <=> v2560(VarNext,7) ) ).

tff(addCaseBooleanConditionEqualRanges1_40,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2561(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2560(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_40,axiom,
    ! [VarNext: state_type] :
      ( v2561(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2560(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_224,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2561(VarNext)
      <=> v2562(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_223,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2562(VarNext)
      <=> ( v2564(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_179,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2564(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1227,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,7)
    <=> v1135(VarCurr,7) ) ).

tff(addAssignment_1226,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,7)
    <=> v1137(VarCurr,7) ) ).

tff(addAssignment_1225,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,7)
    <=> v1697(VarCurr,7) ) ).

tff(addAssignment_1224,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,7)
    <=> v1141(VarCurr,7) ) ).

tff(addAssignment_1223,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,7)
    <=> v1143(VarCurr,7) ) ).

tff(addAssignment_1222,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,7)
    <=> v1145(VarCurr,7) ) ).

tff(addAssignment_1221,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,7)
    <=> v1147(VarCurr,7) ) ).

tff(addAssignment_1220,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,6)
    <=> v2438(VarCurr,6) ) ).

tff(addAssignment_1219,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,6)
    <=> v2330(VarCurr,6) ) ).

tff(addAssignment_1218,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,6)
    <=> v2332(VarCurr,6) ) ).

tff(addAssignment_1217,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,6)
    <=> v2552(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_39,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2553(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2552(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_39,axiom,
    ! [VarNext: state_type] :
      ( v2553(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2552(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_222,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2553(VarNext)
      <=> v2554(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_221,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2554(VarNext)
      <=> ( v2556(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_178,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2556(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1216,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,6)
    <=> v2346(VarCurr,6) ) ).

tff(addAssignment_1215,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,6)
    <=> v2408(VarCurr,6) ) ).

tff(addAssignment_1214,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,6)
    <=> v2350(VarCurr,6) ) ).

tff(addAssignment_1213,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,6)
    <=> v2375(VarCurr,6) ) ).

tff(addAssignment_1212,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,6)
    <=> v2372(VarCurr,6) ) ).

tff(addAssignment_1211,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,6)
    <=> v2369(VarCurr,6) ) ).

tff(addAssignment_1210,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,6)
    <=> v2371(VarCurr,6) ) ).

tff(addAssignment_1209,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,6)
    <=> v2365(VarCurr,6) ) ).

tff(addAssignment_1208,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,6)
    <=> v1119(VarCurr,6) ) ).

tff(addAssignment_1207,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,6)
    <=> v1121(VarCurr,6) ) ).

tff(addAssignment_1206,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,6)
    <=> v1123(VarCurr,6) ) ).

tff(addAssignment_1205,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,6)
    <=> v2544(VarNext,6) ) ).

tff(addCaseBooleanConditionEqualRanges1_38,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2545(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2544(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_38,axiom,
    ! [VarNext: state_type] :
      ( v2545(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2544(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_220,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2545(VarNext)
      <=> v2546(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_219,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2546(VarNext)
      <=> ( v2548(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_177,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2548(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1204,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,6)
    <=> v1135(VarCurr,6) ) ).

tff(addAssignment_1203,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,6)
    <=> v1137(VarCurr,6) ) ).

tff(addAssignment_1202,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,6)
    <=> v1697(VarCurr,6) ) ).

tff(addAssignment_1201,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,6)
    <=> v1141(VarCurr,6) ) ).

tff(addAssignment_1200,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,6)
    <=> v1143(VarCurr,6) ) ).

tff(addAssignment_1199,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,6)
    <=> v1145(VarCurr,6) ) ).

tff(addAssignment_1198,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,6)
    <=> v1147(VarCurr,6) ) ).

tff(addAssignment_1197,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,5)
    <=> v2438(VarCurr,5) ) ).

tff(addAssignment_1196,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,5)
    <=> v2330(VarCurr,5) ) ).

tff(addAssignment_1195,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,5)
    <=> v2332(VarCurr,5) ) ).

tff(addAssignment_1194,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,5)
    <=> v2536(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_37,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2537(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2536(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_37,axiom,
    ! [VarNext: state_type] :
      ( v2537(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2536(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_218,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2537(VarNext)
      <=> v2538(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_217,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2538(VarNext)
      <=> ( v2540(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_176,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2540(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1193,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,5)
    <=> v2346(VarCurr,5) ) ).

tff(addAssignment_1192,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,5)
    <=> v2408(VarCurr,5) ) ).

tff(addAssignment_1191,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,5)
    <=> v2350(VarCurr,5) ) ).

tff(addAssignment_1190,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,5)
    <=> v2375(VarCurr,5) ) ).

tff(addAssignment_1189,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,5)
    <=> v2372(VarCurr,5) ) ).

tff(addAssignment_1188,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,5)
    <=> v2369(VarCurr,5) ) ).

tff(addAssignment_1187,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,5)
    <=> v2371(VarCurr,5) ) ).

tff(addAssignment_1186,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,5)
    <=> v2365(VarCurr,5) ) ).

tff(addAssignment_1185,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,5)
    <=> v1119(VarCurr,5) ) ).

tff(addAssignment_1184,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,5)
    <=> v1121(VarCurr,5) ) ).

tff(addAssignment_1183,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,5)
    <=> v1123(VarCurr,5) ) ).

tff(addAssignment_1182,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,5)
    <=> v2528(VarNext,5) ) ).

tff(addCaseBooleanConditionEqualRanges1_36,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2529(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2528(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_36,axiom,
    ! [VarNext: state_type] :
      ( v2529(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2528(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_216,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2529(VarNext)
      <=> v2530(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_215,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2530(VarNext)
      <=> ( v2532(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_175,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2532(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1181,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,5)
    <=> v1135(VarCurr,5) ) ).

tff(addAssignment_1180,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,5)
    <=> v1137(VarCurr,5) ) ).

tff(addAssignment_1179,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,5)
    <=> v1697(VarCurr,5) ) ).

tff(addAssignment_1178,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,5)
    <=> v1141(VarCurr,5) ) ).

tff(addAssignment_1177,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,5)
    <=> v1143(VarCurr,5) ) ).

tff(addAssignment_1176,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,5)
    <=> v1145(VarCurr,5) ) ).

tff(addAssignment_1175,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,5)
    <=> v1147(VarCurr,5) ) ).

tff(addAssignment_1174,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,4)
    <=> v2438(VarCurr,4) ) ).

tff(addAssignment_1173,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,4)
    <=> v2330(VarCurr,4) ) ).

tff(addAssignment_1172,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,4)
    <=> v2332(VarCurr,4) ) ).

tff(addAssignment_1171,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,4)
    <=> v2520(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_35,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2521(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2520(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_35,axiom,
    ! [VarNext: state_type] :
      ( v2521(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2520(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_214,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2521(VarNext)
      <=> v2522(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_213,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2522(VarNext)
      <=> ( v2524(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_174,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2524(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1170,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,4)
    <=> v2346(VarCurr,4) ) ).

tff(addAssignment_1169,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,4)
    <=> v2408(VarCurr,4) ) ).

tff(addAssignment_1168,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,4)
    <=> v2350(VarCurr,4) ) ).

tff(addAssignment_1167,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,4)
    <=> v2375(VarCurr,4) ) ).

tff(addAssignment_1166,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,4)
    <=> v2372(VarCurr,4) ) ).

tff(addAssignment_1165,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,4)
    <=> v2369(VarCurr,4) ) ).

tff(addAssignment_1164,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,4)
    <=> v2371(VarCurr,4) ) ).

tff(addAssignment_1163,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,4)
    <=> v2365(VarCurr,4) ) ).

tff(addAssignment_1162,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,4)
    <=> v1119(VarCurr,4) ) ).

tff(addAssignment_1161,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,4)
    <=> v1121(VarCurr,4) ) ).

tff(addAssignment_1160,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,4)
    <=> v1123(VarCurr,4) ) ).

tff(addAssignment_1159,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,4)
    <=> v2512(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_34,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2513(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2512(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_34,axiom,
    ! [VarNext: state_type] :
      ( v2513(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2512(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_212,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2513(VarNext)
      <=> v2514(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_211,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2514(VarNext)
      <=> ( v2516(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_173,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2516(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1158,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,4)
    <=> v1135(VarCurr,4) ) ).

tff(addAssignment_1157,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,4)
    <=> v1137(VarCurr,4) ) ).

tff(addAssignment_1156,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,4)
    <=> v1697(VarCurr,4) ) ).

tff(addAssignment_1155,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,4)
    <=> v1141(VarCurr,4) ) ).

tff(addAssignment_1154,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,4)
    <=> v1143(VarCurr,4) ) ).

tff(addAssignment_1153,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,4)
    <=> v1145(VarCurr,4) ) ).

tff(addAssignment_1152,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,4)
    <=> v1147(VarCurr,4) ) ).

tff(addAssignment_1151,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,3)
    <=> v2438(VarCurr,3) ) ).

tff(addAssignment_1150,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,3)
    <=> v2330(VarCurr,3) ) ).

tff(addAssignment_1149,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,3)
    <=> v2332(VarCurr,3) ) ).

tff(addAssignment_1148,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,3)
    <=> v2504(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_33,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2505(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2504(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_33,axiom,
    ! [VarNext: state_type] :
      ( v2505(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2504(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_210,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2505(VarNext)
      <=> v2506(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_209,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2506(VarNext)
      <=> ( v2508(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_172,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2508(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1147,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,3)
    <=> v2346(VarCurr,3) ) ).

tff(addAssignment_1146,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,3)
    <=> v2408(VarCurr,3) ) ).

tff(addAssignment_1145,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,3)
    <=> v2350(VarCurr,3) ) ).

tff(addAssignment_1144,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,3)
    <=> v2375(VarCurr,3) ) ).

tff(addAssignment_1143,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,3)
    <=> v2372(VarCurr,3) ) ).

tff(addAssignment_1142,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,3)
    <=> v2369(VarCurr,3) ) ).

tff(addAssignment_1141,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,3)
    <=> v2371(VarCurr,3) ) ).

tff(addAssignment_1140,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,3)
    <=> v2365(VarCurr,3) ) ).

tff(addAssignment_1139,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,3)
    <=> v1119(VarCurr,3) ) ).

tff(addAssignment_1138,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,3)
    <=> v1121(VarCurr,3) ) ).

tff(addAssignment_1137,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,3)
    <=> v1123(VarCurr,3) ) ).

tff(addAssignment_1136,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,3)
    <=> v2496(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_32,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2497(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2496(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_32,axiom,
    ! [VarNext: state_type] :
      ( v2497(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2496(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_208,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2497(VarNext)
      <=> v2498(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_207,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2498(VarNext)
      <=> ( v2500(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_171,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2500(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1135,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,3)
    <=> v1135(VarCurr,3) ) ).

tff(addAssignment_1134,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,3)
    <=> v1137(VarCurr,3) ) ).

tff(addAssignment_1133,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,3)
    <=> v1697(VarCurr,3) ) ).

tff(addAssignment_1132,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,3)
    <=> v1141(VarCurr,3) ) ).

tff(addAssignment_1131,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,3)
    <=> v1143(VarCurr,3) ) ).

tff(addAssignment_1130,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,3)
    <=> v1145(VarCurr,3) ) ).

tff(addAssignment_1129,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,3)
    <=> v1147(VarCurr,3) ) ).

tff(addAssignment_1128,axiom,
    ! [VarNext: state_type] :
      ( v1147(VarNext,3)
    <=> v2488(VarNext,3) ) ).

tff(addCaseBooleanConditionEqualRanges1_31,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2489(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v2488(VarNext,B)
            <=> v1147(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_31,axiom,
    ! [VarNext: state_type] :
      ( v2489(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v2488(VarNext,B)
          <=> v1691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_206,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2489(VarNext)
      <=> v2490(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_205,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2490(VarNext)
      <=> ( v2492(VarNext)
          & v1676(VarNext) ) ) ) ).

tff(writeUnaryOperator_170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2492(VarNext)
      <=> v1685(VarNext) ) ) ).

tff(addAssignment_1127,axiom,
    ! [VarCurr: state_type] :
      ( v1165(VarCurr,3)
    <=> v1167(VarCurr,3) ) ).

tff(addAssignment_1126,axiom,
    ! [VarCurr: state_type] :
      ( v1167(VarCurr,3)
    <=> v1667(VarCurr,3) ) ).

tff(addAssignment_1125,axiom,
    ! [VarCurr: state_type] :
      ( v1169(VarCurr,3)
    <=> v1171(VarCurr,3) ) ).

tff(addAssignment_1124,axiom,
    ! [VarCurr: state_type] :
      ( v1171(VarCurr,3)
    <=> v1173(VarCurr,3) ) ).

tff(addAssignment_1123,axiom,
    ! [VarCurr: state_type] :
      ( v1173(VarCurr,3)
    <=> v1175(VarCurr,3) ) ).

tff(addAssignment_1122,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,2)
    <=> v2438(VarCurr,2) ) ).

tff(addAssignment_1121,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,2)
    <=> v2330(VarCurr,2) ) ).

tff(addAssignment_1120,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,2)
    <=> v2332(VarCurr,2) ) ).

tff(addAssignment_1119,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,2)
    <=> v2480(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_30,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2481(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2480(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_30,axiom,
    ! [VarNext: state_type] :
      ( v2481(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2480(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_204,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2481(VarNext)
      <=> v2482(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_203,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2482(VarNext)
      <=> ( v2484(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2484(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1118,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,2)
    <=> v2346(VarCurr,2) ) ).

tff(addAssignment_1117,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,2)
    <=> v2408(VarCurr,2) ) ).

tff(addAssignment_1116,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,2)
    <=> v2350(VarCurr,2) ) ).

tff(addAssignment_1115,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,2)
    <=> v2375(VarCurr,2) ) ).

tff(addAssignment_1114,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,2)
    <=> v2372(VarCurr,2) ) ).

tff(addAssignment_1113,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,2)
    <=> v2369(VarCurr,2) ) ).

tff(addAssignment_1112,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,2)
    <=> v2371(VarCurr,2) ) ).

tff(addAssignment_1111,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,2)
    <=> v2365(VarCurr,2) ) ).

tff(addAssignment_1110,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,2)
    <=> v1119(VarCurr,2) ) ).

tff(addAssignment_1109,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,2)
    <=> v1121(VarCurr,2) ) ).

tff(addAssignment_1108,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,2)
    <=> v1123(VarCurr,2) ) ).

tff(addAssignment_1107,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,2)
    <=> v2472(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_29,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2473(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2472(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_29,axiom,
    ! [VarNext: state_type] :
      ( v2473(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2472(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_202,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2473(VarNext)
      <=> v2474(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2474(VarNext)
      <=> ( v2476(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_168,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2476(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1106,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,2)
    <=> v1135(VarCurr,2) ) ).

tff(addAssignment_1105,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,2)
    <=> v1137(VarCurr,2) ) ).

tff(addAssignment_1104,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,2)
    <=> v1697(VarCurr,2) ) ).

tff(addAssignment_1103,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,2)
    <=> v1141(VarCurr,2) ) ).

tff(addAssignment_1102,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,2)
    <=> v1143(VarCurr,2) ) ).

tff(addAssignment_1101,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,2)
    <=> v1145(VarCurr,2) ) ).

tff(addAssignment_1100,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,2)
    <=> v1147(VarCurr,2) ) ).

tff(addAssignment_1099,axiom,
    ! [VarNext: state_type] :
      ( v1147(VarNext,2)
    <=> v2464(VarNext,2) ) ).

tff(addCaseBooleanConditionEqualRanges1_28,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2465(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v2464(VarNext,B)
            <=> v1147(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_28,axiom,
    ! [VarNext: state_type] :
      ( v2465(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v2464(VarNext,B)
          <=> v1691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2465(VarNext)
      <=> v2466(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_199,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2466(VarNext)
      <=> ( v2468(VarNext)
          & v1676(VarNext) ) ) ) ).

tff(writeUnaryOperator_167,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2468(VarNext)
      <=> v1685(VarNext) ) ) ).

tff(addAssignment_1098,axiom,
    ! [VarCurr: state_type] :
      ( v1165(VarCurr,2)
    <=> v1167(VarCurr,2) ) ).

tff(addAssignment_1097,axiom,
    ! [VarCurr: state_type] :
      ( v1167(VarCurr,2)
    <=> v1667(VarCurr,2) ) ).

tff(addAssignment_1096,axiom,
    ! [VarCurr: state_type] :
      ( v1169(VarCurr,2)
    <=> v1171(VarCurr,2) ) ).

tff(addAssignment_1095,axiom,
    ! [VarCurr: state_type] :
      ( v1171(VarCurr,2)
    <=> v1173(VarCurr,2) ) ).

tff(addAssignment_1094,axiom,
    ! [VarCurr: state_type] :
      ( v1173(VarCurr,2)
    <=> v1175(VarCurr,2) ) ).

tff(addAssignment_1093,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,1)
    <=> v2438(VarCurr,1) ) ).

tff(addAssignment_1092,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,1)
    <=> v2330(VarCurr,1) ) ).

tff(addAssignment_1091,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,1)
    <=> v2332(VarCurr,1) ) ).

tff(addAssignment_1090,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,1)
    <=> v2456(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_27,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2457(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2456(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_27,axiom,
    ! [VarNext: state_type] :
      ( v2457(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2456(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_198,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2457(VarNext)
      <=> v2458(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_197,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2458(VarNext)
      <=> ( v2460(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_166,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2460(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1089,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,1)
    <=> v2346(VarCurr,1) ) ).

tff(addAssignment_1088,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,1)
    <=> v2408(VarCurr,1) ) ).

tff(addAssignment_1087,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,1)
    <=> v2350(VarCurr,1) ) ).

tff(addAssignment_1086,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,1)
    <=> v2375(VarCurr,1) ) ).

tff(addAssignment_1085,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,1)
    <=> v2372(VarCurr,1) ) ).

tff(addAssignment_1084,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,1)
    <=> v2369(VarCurr,1) ) ).

tff(addAssignment_1083,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,1)
    <=> v2371(VarCurr,1) ) ).

tff(addAssignment_1082,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,1)
    <=> v2365(VarCurr,1) ) ).

tff(addAssignment_1081,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,1)
    <=> v1119(VarCurr,1) ) ).

tff(addAssignment_1080,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,1)
    <=> v1121(VarCurr,1) ) ).

tff(addAssignment_1079,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,1)
    <=> v1123(VarCurr,1) ) ).

tff(addAssignment_1078,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,1)
    <=> v2448(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_26,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2449(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v2448(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_26,axiom,
    ! [VarNext: state_type] :
      ( v2449(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v2448(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_196,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2449(VarNext)
      <=> v2450(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_195,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2450(VarNext)
      <=> ( v2452(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_165,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2452(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_1077,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,1)
    <=> v1135(VarCurr,1) ) ).

tff(addAssignment_1076,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,1)
    <=> v1137(VarCurr,1) ) ).

tff(addAssignment_1075,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,1)
    <=> v1697(VarCurr,1) ) ).

tff(addAssignment_1074,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,1)
    <=> v1141(VarCurr,1) ) ).

tff(addAssignment_1073,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,1)
    <=> v1143(VarCurr,1) ) ).

tff(addAssignment_1072,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,1)
    <=> v1145(VarCurr,1) ) ).

tff(addAssignment_1071,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,1)
    <=> v1147(VarCurr,1) ) ).

tff(addAssignment_1070,axiom,
    ! [VarNext: state_type] :
      ( v1147(VarNext,1)
    <=> v2440(VarNext,1) ) ).

tff(addCaseBooleanConditionEqualRanges1_25,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2441(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v2440(VarNext,B)
            <=> v1147(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_25,axiom,
    ! [VarNext: state_type] :
      ( v2441(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v2440(VarNext,B)
          <=> v1691(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_194,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2441(VarNext)
      <=> v2442(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_193,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2442(VarNext)
      <=> ( v2444(VarNext)
          & v1676(VarNext) ) ) ) ).

tff(writeUnaryOperator_164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2444(VarNext)
      <=> v1685(VarNext) ) ) ).

tff(addAssignment_1069,axiom,
    ! [VarCurr: state_type] :
      ( v1165(VarCurr,1)
    <=> v1167(VarCurr,1) ) ).

tff(addAssignment_1068,axiom,
    ! [VarCurr: state_type] :
      ( v1167(VarCurr,1)
    <=> v1667(VarCurr,1) ) ).

tff(addAssignment_1067,axiom,
    ! [VarCurr: state_type] :
      ( v1169(VarCurr,1)
    <=> v1171(VarCurr,1) ) ).

tff(addAssignment_1066,axiom,
    ! [VarCurr: state_type] :
      ( v1171(VarCurr,1)
    <=> v1173(VarCurr,1) ) ).

tff(addAssignment_1065,axiom,
    ! [VarCurr: state_type] :
      ( v1173(VarCurr,1)
    <=> v1175(VarCurr,1) ) ).

tff(addAssignment_1064,axiom,
    ! [VarCurr: state_type] :
      ( v2326(VarCurr,0)
    <=> v2438(VarCurr,0) ) ).

tff(writeUnaryOperator_163,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2438(VarCurr,B)
      <=> ~ v2328(VarCurr,B) ) ) ).

tff(addAssignment_1063,axiom,
    ! [VarCurr: state_type] :
      ( v2328(VarCurr,0)
    <=> v2330(VarCurr,0) ) ).

tff(addAssignment_1062,axiom,
    ! [VarCurr: state_type] :
      ( v2330(VarCurr,0)
    <=> v2332(VarCurr,0) ) ).

tff(addAssignment_1061,axiom,
    ! [VarNext: state_type] :
      ( v2332(VarNext,0)
    <=> v2421(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_24,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2422(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2421(VarNext,B)
            <=> v2332(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_24,axiom,
    ! [VarNext: state_type] :
      ( v2422(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2421(VarNext,B)
          <=> v2432(VarNext,B) ) ) ) ).

tff(addAssignment_1060,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2432(VarNext,B)
          <=> v2430(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_26,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2433(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2430(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_26,axiom,
    ! [VarCurr: state_type] :
      ( v2433(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2430(VarCurr,B)
          <=> v2344(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_192,axiom,
    ! [VarCurr: state_type] :
      ( v2433(VarCurr)
    <=> ( v2434(VarCurr)
        & v2435(VarCurr) ) ) ).

tff(writeUnaryOperator_162,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2435(VarCurr)
    <=> v2340(VarCurr) ) ).

tff(writeUnaryOperator_161,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2434(VarCurr)
    <=> v2334(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_191,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2422(VarNext)
      <=> v2423(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_190,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2423(VarNext)
      <=> ( v2424(VarNext)
          & v2417(VarNext) ) ) ) ).

tff(writeUnaryOperator_160,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2424(VarNext)
      <=> v2426(VarNext) ) ) ).

tff(addAssignment_1059,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2426(VarNext)
      <=> v2417(VarCurr) ) ) ).

tff(addAssignment_1058,axiom,
    ! [VarCurr: state_type] :
      ( v2417(VarCurr)
    <=> v2419(VarCurr) ) ).

tff(addAssignment_1057,axiom,
    ! [VarCurr: state_type] :
      ( v2419(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1056,axiom,
    ! [VarCurr: state_type] :
      ( v2344(VarCurr,0)
    <=> v2346(VarCurr,0) ) ).

tff(addAssignment_1055,axiom,
    ! [VarCurr: state_type] :
      ( v2346(VarCurr,0)
    <=> v2408(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_23,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2408(VarCurr,B)
      <=> ( v2409(VarCurr,B)
          | v2412(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_22,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2412(VarCurr,B)
      <=> ( v2330(VarCurr,B)
          & v2413(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_159,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2413(VarCurr,B)
      <=> ~ v2414(VarCurr,B) ) ) ).

tff(addAssignment_1054,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,0)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1053,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,1)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1052,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,2)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1051,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,3)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1050,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,4)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1049,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,5)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1048,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,6)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1047,axiom,
    ! [VarCurr: state_type] :
      ( v2414(VarCurr,7)
    <=> v2415(VarCurr) ) ).

tff(addAssignment_1046,axiom,
    ! [VarCurr: state_type] :
      ( v2415(VarCurr)
    <=> v2377(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_21,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2409(VarCurr,B)
      <=> ( v2348(VarCurr,B)
          & v2410(VarCurr,B) ) ) ) ).

tff(addAssignment_1045,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,0)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1044,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,1)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1043,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,2)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1042,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,3)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1041,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,4)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1040,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,5)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1039,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,6)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1038,axiom,
    ! [VarCurr: state_type] :
      ( v2410(VarCurr,7)
    <=> v2411(VarCurr) ) ).

tff(addAssignment_1037,axiom,
    ! [VarCurr: state_type] :
      ( v2411(VarCurr)
    <=> v2377(VarCurr) ) ).

tff(addAssignment_1036,axiom,
    ! [VarCurr: state_type] :
      ( v2377(VarCurr)
    <=> v2379(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_189,axiom,
    ! [VarCurr: state_type] :
      ( v2379(VarCurr)
    <=> ( v2401(VarCurr)
        | v2406(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_188,axiom,
    ! [VarCurr: state_type] :
      ( v2406(VarCurr)
    <=> ( v2354(VarCurr)
        & v2407(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_12,axiom,
    ! [VarCurr: state_type] :
      ( v2407(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_187,axiom,
    ! [VarCurr: state_type] :
      ( v2401(VarCurr)
    <=> ( v2402(VarCurr)
        & v2405(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_11,axiom,
    ! [VarCurr: state_type] :
      ( v2405(VarCurr)
    <=> ( ( v2395(VarCurr,3)
        <=> $false )
        & ( v2395(VarCurr,2)
        <=> $false )
        & ( v2395(VarCurr,1)
        <=> $false )
        & ( v2395(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_47,axiom,
    ~ b0000(3) ).

tff(bitBlastConstant_46,axiom,
    ~ b0000(2) ).

tff(bitBlastConstant_45,axiom,
    ~ b0000(1) ).

tff(bitBlastConstant_44,axiom,
    ~ b0000(0) ).

tff(writeBinaryOperatorEqualRangesSingleBits_186,axiom,
    ! [VarCurr: state_type] :
      ( v2402(VarCurr)
    <=> ( v2403(VarCurr)
        & v2404(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_10,axiom,
    ! [VarCurr: state_type] :
      ( v2404(VarCurr)
    <=> ( ( v2388(VarCurr,5)
        <=> $false )
        & ( v2388(VarCurr,4)
        <=> $false )
        & ( v2388(VarCurr,3)
        <=> $false )
        & ( v2388(VarCurr,2)
        <=> $true )
        & ( v2388(VarCurr,1)
        <=> $false )
        & ( v2388(VarCurr,0)
        <=> $true ) ) ) ).

tff(bitBlastConstant_43,axiom,
    ~ b000101(5) ).

tff(bitBlastConstant_42,axiom,
    ~ b000101(4) ).

tff(bitBlastConstant_41,axiom,
    ~ b000101(3) ).

tff(bitBlastConstant_40,axiom,
    b000101(2) ).

tff(bitBlastConstant_39,axiom,
    ~ b000101(1) ).

tff(bitBlastConstant_38,axiom,
    b000101(0) ).

tff(addBitVectorEqualityBitBlasted_9,axiom,
    ! [VarCurr: state_type] :
      ( v2403(VarCurr)
    <=> ( ( v2381(VarCurr,1)
        <=> $true )
        & ( v2381(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_37,axiom,
    b10(1) ).

tff(bitBlastConstant_36,axiom,
    ~ b10(0) ).

tff(addAssignment_1035,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2395(VarCurr,B)
      <=> v2397(VarCurr,B) ) ) ).

tff(addAssignment_1034,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v2397(VarCurr,B)
      <=> v2399(VarCurr,B) ) ) ).

tff(addAssignment_1033,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2388(VarCurr,B)
      <=> v2390(VarCurr,B) ) ) ).

tff(addAssignment_1032,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2390(VarCurr,B)
      <=> v2392(VarCurr,B) ) ) ).

tff(addAssignment_1031,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v2381(VarCurr,B)
      <=> v2383(VarCurr,B) ) ) ).

tff(addAssignment_1030,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v2383(VarCurr,B)
      <=> v2385(VarCurr,B) ) ) ).

tff(addAssignment_1029,axiom,
    ! [VarCurr: state_type] :
      ( v2348(VarCurr,0)
    <=> v2350(VarCurr,0) ) ).

tff(addAssignment_1028,axiom,
    ! [VarCurr: state_type] :
      ( v2350(VarCurr,0)
    <=> v2375(VarCurr,0) ) ).

tff(writeUnaryOperator_158,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2375(VarCurr,B)
      <=> ~ v2352(VarCurr,B) ) ) ).

tff(addAssignment_1027,axiom,
    ! [VarCurr: state_type] :
      ( v2352(VarCurr,0)
    <=> v2372(VarCurr,0) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_25,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2373(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2372(VarCurr,B)
          <=> v2367(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_25,axiom,
    ! [VarCurr: state_type] :
      ( v2373(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2372(VarCurr,B)
          <=> v2363(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_185,axiom,
    ! [VarCurr: state_type] :
      ( v2373(VarCurr)
    <=> ( v2354(VarCurr)
        & v2374(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_8,axiom,
    ! [VarCurr: state_type] :
      ( v2374(VarCurr)
    <=> ( ( v2358(VarCurr,12)
        <=> $false )
        & ( v2358(VarCurr,11)
        <=> $true )
        & ( v2358(VarCurr,10)
        <=> $false )
        & ( v2358(VarCurr,9)
        <=> $false )
        & ( v2358(VarCurr,8)
        <=> $false )
        & ( v2358(VarCurr,7)
        <=> $true )
        & ( v2358(VarCurr,6)
        <=> $false )
        & ( v2358(VarCurr,5)
        <=> $true )
        & ( v2358(VarCurr,4)
        <=> $true )
        & ( v2358(VarCurr,3)
        <=> $true )
        & ( v2358(VarCurr,2)
        <=> $false )
        & ( v2358(VarCurr,1)
        <=> $false )
        & ( v2358(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_35,axiom,
    ~ b0100010111000(12) ).

tff(bitBlastConstant_34,axiom,
    b0100010111000(11) ).

tff(bitBlastConstant_33,axiom,
    ~ b0100010111000(10) ).

tff(bitBlastConstant_32,axiom,
    ~ b0100010111000(9) ).

tff(bitBlastConstant_31,axiom,
    ~ b0100010111000(8) ).

tff(bitBlastConstant_30,axiom,
    b0100010111000(7) ).

tff(bitBlastConstant_29,axiom,
    ~ b0100010111000(6) ).

tff(bitBlastConstant_28,axiom,
    b0100010111000(5) ).

tff(bitBlastConstant_27,axiom,
    b0100010111000(4) ).

tff(bitBlastConstant_26,axiom,
    b0100010111000(3) ).

tff(bitBlastConstant_25,axiom,
    ~ b0100010111000(2) ).

tff(bitBlastConstant_24,axiom,
    ~ b0100010111000(1) ).

tff(bitBlastConstant_23,axiom,
    ~ b0100010111000(0) ).

tff(addAssignment_1026,axiom,
    ! [VarCurr: state_type] :
      ( v2367(VarCurr,0)
    <=> v2369(VarCurr,0) ) ).

tff(addAssignment_1025,axiom,
    ! [VarCurr: state_type] :
      ( v2369(VarCurr,0)
    <=> v2371(VarCurr,0) ) ).

tff(addAssignment_1024,axiom,
    ! [VarCurr: state_type] :
      ( v2363(VarCurr,0)
    <=> v2365(VarCurr,0) ) ).

tff(addAssignment_1023,axiom,
    ! [VarCurr: state_type] :
      ( v2365(VarCurr,0)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_1022,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v2358(VarCurr,B)
      <=> v2360(VarCurr,B) ) ) ).

tff(addAssignment_1021,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v2360(VarCurr,B)
      <=> v1871(VarCurr,B) ) ) ).

tff(addAssignment_1020,axiom,
    ! [VarCurr: state_type] :
      ( v2354(VarCurr)
    <=> v2356(VarCurr) ) ).

tff(addAssignment_1019,axiom,
    ! [VarCurr: state_type] :
      ( v2356(VarCurr)
    <=> v1729(VarCurr) ) ).

tff(addAssignment_1018,axiom,
    ! [VarCurr: state_type] :
      ( v2340(VarCurr)
    <=> v2342(VarCurr) ) ).

tff(addAssignment_1017,axiom,
    ! [VarCurr: state_type] :
      ( v2342(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_1016,axiom,
    ! [VarCurr: state_type] :
      ( v2334(VarCurr)
    <=> v2336(VarCurr) ) ).

tff(addAssignment_1015,axiom,
    ! [VarCurr: state_type] :
      ( v2336(VarCurr)
    <=> v2338(VarCurr) ) ).

tff(addAssignment_1014,axiom,
    ! [VarCurr: state_type] :
      ( v2338(VarCurr)
    <=> v1063(VarCurr) ) ).

tff(addAssignment_1013,axiom,
    ! [VarCurr: state_type] :
      ( v2312(VarCurr)
    <=> v2314(VarCurr) ) ).

tff(addAssignment_1012,axiom,
    ! [VarCurr: state_type] :
      ( v2314(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_1011,axiom,
    ! [VarCurr: state_type] :
      ( v2308(VarCurr)
    <=> v2310(VarCurr) ) ).

tff(addAssignment_1010,axiom,
    ! [VarCurr: state_type] :
      ( v2310(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_1009,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2204(VarCurr,B)
      <=> v2206(VarCurr,B) ) ) ).

tff(addAssignment_1008,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2206(VarCurr,B)
      <=> v2208(VarCurr,B) ) ) ).

tff(addAssignment_1007,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2208(VarNext,B)
      <=> v2284(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_23,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2285(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v2284(VarNext,B)
            <=> v2208(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_23,axiom,
    ! [VarNext: state_type] :
      ( v2285(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v2284(VarNext,B)
          <=> v2295(VarNext,B) ) ) ) ).

tff(addAssignment_1006,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v2295(VarNext,B)
          <=> v2293(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_24,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2296(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v2293(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_24,axiom,
    ! [VarCurr: state_type] :
      ( v2296(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v2293(VarCurr,B)
          <=> v2226(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_184,axiom,
    ! [VarCurr: state_type] :
      ( v2296(VarCurr)
    <=> ( v2297(VarCurr)
        & v2298(VarCurr) ) ) ).

tff(writeUnaryOperator_157,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2298(VarCurr)
    <=> v2218(VarCurr) ) ).

tff(writeUnaryOperator_156,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2297(VarCurr)
    <=> v2210(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_183,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2285(VarNext)
      <=> v2286(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_182,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2286(VarNext)
      <=> ( v2287(VarNext)
          & v2278(VarNext) ) ) ) ).

tff(writeUnaryOperator_155,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2287(VarNext)
      <=> v2289(VarNext) ) ) ).

tff(addAssignment_1005,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2289(VarNext)
      <=> v2278(VarCurr) ) ) ).

tff(addAssignment_1004,axiom,
    ! [VarCurr: state_type] :
      ( v2278(VarCurr)
    <=> v2280(VarCurr) ) ).

tff(addAssignment_1003,axiom,
    ! [VarCurr: state_type] :
      ( v2280(VarCurr)
    <=> v2282(VarCurr) ) ).

tff(addAssignment_1002,axiom,
    ! [VarCurr: state_type] :
      ( v2282(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_1001,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2226(VarCurr,B)
      <=> v2228(VarCurr,B) ) ) ).

tff(addAssignment_1000,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2228(VarCurr,B)
      <=> v2269(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_20,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2269(VarCurr,B)
      <=> ( v2270(VarCurr,B)
          | v2273(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_19,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2273(VarCurr,B)
      <=> ( v2206(VarCurr,B)
          & v2274(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_154,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2274(VarCurr,B)
      <=> ~ v2275(VarCurr,B) ) ) ).

tff(addAssignment_999,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,0)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_998,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,1)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_997,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,2)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_996,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,3)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_995,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,4)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_994,axiom,
    ! [VarCurr: state_type] :
      ( v2275(VarCurr,5)
    <=> v2276(VarCurr) ) ).

tff(addAssignment_993,axiom,
    ! [VarCurr: state_type] :
      ( v2276(VarCurr)
    <=> v2266(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_18,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v2270(VarCurr,B)
      <=> ( v2230(VarCurr,B)
          & v2271(VarCurr,B) ) ) ) ).

tff(addAssignment_992,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,0)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_991,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,1)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_990,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,2)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_989,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,3)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_988,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,4)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_987,axiom,
    ! [VarCurr: state_type] :
      ( v2271(VarCurr,5)
    <=> v2272(VarCurr) ) ).

tff(addAssignment_986,axiom,
    ! [VarCurr: state_type] :
      ( v2272(VarCurr)
    <=> v2266(VarCurr) ) ).

tff(addAssignment_985,axiom,
    ! [VarCurr: state_type] :
      ( v2266(VarCurr)
    <=> v2268(VarCurr) ) ).

tff(addAssignment_984,axiom,
    ! [VarCurr: state_type] :
      ( v2268(VarCurr)
    <=> v2044(VarCurr) ) ).

tff(addAssignment_983,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2230(VarCurr,B)
      <=> v2232(VarCurr,B) ) ) ).

tff(addAssignment_982,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v2232(VarCurr,B)
      <=> v2234(VarCurr,B) ) ) ).

tff(addAssignment_981,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,0)
    <=> v2262(VarCurr) ) ).

tff(addAssignment_980,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,1)
    <=> v2260(VarCurr) ) ).

tff(addAssignment_979,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,2)
    <=> v2255(VarCurr) ) ).

tff(addAssignment_978,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,3)
    <=> v2250(VarCurr) ) ).

tff(addAssignment_977,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,4)
    <=> v2245(VarCurr) ) ).

tff(addAssignment_976,axiom,
    ! [VarCurr: state_type] :
      ( v2234(VarCurr,5)
    <=> v2236(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_181,axiom,
    ! [VarCurr: state_type] :
      ( v2260(VarCurr)
    <=> ( v2261(VarCurr)
        & v2264(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_28,axiom,
    ! [VarCurr: state_type] :
      ( v2264(VarCurr)
    <=> ( v2204(VarCurr,0)
        | v2204(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_180,axiom,
    ! [VarCurr: state_type] :
      ( v2261(VarCurr)
    <=> ( v2262(VarCurr)
        | v2263(VarCurr) ) ) ).

tff(writeUnaryOperator_153,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2263(VarCurr)
    <=> v2204(VarCurr,1) ) ).

tff(writeUnaryOperator_152,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2262(VarCurr)
    <=> v2204(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_179,axiom,
    ! [VarCurr: state_type] :
      ( v2255(VarCurr)
    <=> ( v2256(VarCurr)
        & v2259(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_27,axiom,
    ! [VarCurr: state_type] :
      ( v2259(VarCurr)
    <=> ( v2242(VarCurr)
        | v2204(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_178,axiom,
    ! [VarCurr: state_type] :
      ( v2256(VarCurr)
    <=> ( v2257(VarCurr)
        | v2258(VarCurr) ) ) ).

tff(writeUnaryOperator_151,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2258(VarCurr)
    <=> v2204(VarCurr,2) ) ).

tff(writeUnaryOperator_150,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2257(VarCurr)
    <=> v2242(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_177,axiom,
    ! [VarCurr: state_type] :
      ( v2250(VarCurr)
    <=> ( v2251(VarCurr)
        & v2254(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_26,axiom,
    ! [VarCurr: state_type] :
      ( v2254(VarCurr)
    <=> ( v2241(VarCurr)
        | v2204(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_176,axiom,
    ! [VarCurr: state_type] :
      ( v2251(VarCurr)
    <=> ( v2252(VarCurr)
        | v2253(VarCurr) ) ) ).

tff(writeUnaryOperator_149,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2253(VarCurr)
    <=> v2204(VarCurr,3) ) ).

tff(writeUnaryOperator_148,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2252(VarCurr)
    <=> v2241(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_175,axiom,
    ! [VarCurr: state_type] :
      ( v2245(VarCurr)
    <=> ( v2246(VarCurr)
        & v2249(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_25,axiom,
    ! [VarCurr: state_type] :
      ( v2249(VarCurr)
    <=> ( v2240(VarCurr)
        | v2204(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_174,axiom,
    ! [VarCurr: state_type] :
      ( v2246(VarCurr)
    <=> ( v2247(VarCurr)
        | v2248(VarCurr) ) ) ).

tff(writeUnaryOperator_147,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2248(VarCurr)
    <=> v2204(VarCurr,4) ) ).

tff(writeUnaryOperator_146,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2247(VarCurr)
    <=> v2240(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_173,axiom,
    ! [VarCurr: state_type] :
      ( v2236(VarCurr)
    <=> ( v2237(VarCurr)
        & v2244(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_24,axiom,
    ! [VarCurr: state_type] :
      ( v2244(VarCurr)
    <=> ( v2239(VarCurr)
        | v2204(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_172,axiom,
    ! [VarCurr: state_type] :
      ( v2237(VarCurr)
    <=> ( v2238(VarCurr)
        | v2243(VarCurr) ) ) ).

tff(writeUnaryOperator_145,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2243(VarCurr)
    <=> v2204(VarCurr,5) ) ).

tff(writeUnaryOperator_144,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2238(VarCurr)
    <=> v2239(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_23,axiom,
    ! [VarCurr: state_type] :
      ( v2239(VarCurr)
    <=> ( v2240(VarCurr)
        & v2204(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_22,axiom,
    ! [VarCurr: state_type] :
      ( v2240(VarCurr)
    <=> ( v2241(VarCurr)
        & v2204(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_21,axiom,
    ! [VarCurr: state_type] :
      ( v2241(VarCurr)
    <=> ( v2242(VarCurr)
        & v2204(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_20,axiom,
    ! [VarCurr: state_type] :
      ( v2242(VarCurr)
    <=> ( v2204(VarCurr,0)
        & v2204(VarCurr,1) ) ) ).

tff(addAssignment_975,axiom,
    ! [VarCurr: state_type] :
      ( v2218(VarCurr)
    <=> v2220(VarCurr) ) ).

tff(addAssignment_974,axiom,
    ! [VarCurr: state_type] :
      ( v2220(VarCurr)
    <=> v2222(VarCurr) ) ).

tff(addAssignment_973,axiom,
    ! [VarCurr: state_type] :
      ( v2222(VarCurr)
    <=> v2224(VarCurr) ) ).

tff(addAssignment_972,axiom,
    ! [VarCurr: state_type] :
      ( v2224(VarCurr)
    <=> v2066(VarCurr) ) ).

tff(addAssignment_971,axiom,
    ! [VarCurr: state_type] :
      ( v2210(VarCurr)
    <=> v2212(VarCurr) ) ).

tff(addAssignment_970,axiom,
    ! [VarCurr: state_type] :
      ( v2212(VarCurr)
    <=> v2214(VarCurr) ) ).

tff(addAssignment_969,axiom,
    ! [VarCurr: state_type] :
      ( v2214(VarCurr)
    <=> v2216(VarCurr) ) ).

tff(addAssignment_968,axiom,
    ! [VarCurr: state_type] :
      ( v2216(VarCurr)
    <=> v2058(VarCurr) ) ).

tff(addAssignment_967,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2046(VarCurr,B)
      <=> v2048(VarCurr,B) ) ) ).

tff(addAssignment_966,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2048(VarCurr,B)
      <=> v2050(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_22,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2183(VarNext)
       => ! [B: $int] :
            ( ( $less(B,8)
              & ~ $less(B,0) )
           => ( v2050(VarNext,B)
            <=> v2050(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_22,axiom,
    ! [VarNext: state_type] :
      ( v2183(VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2050(VarNext,B)
          <=> v2193(VarNext,B) ) ) ) ).

tff(addAssignment_965,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2193(VarNext,B)
          <=> v2191(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_23,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2194(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2191(VarCurr,B)
          <=> bxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_23,axiom,
    ! [VarCurr: state_type] :
      ( v2194(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,8)
            & ~ $less(B,0) )
         => ( v2191(VarCurr,B)
          <=> v2068(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_171,axiom,
    ! [VarCurr: state_type] :
      ( v2194(VarCurr)
    <=> ( v2195(VarCurr)
        & v2196(VarCurr) ) ) ).

tff(writeUnaryOperator_143,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2196(VarCurr)
    <=> v2060(VarCurr) ) ).

tff(writeUnaryOperator_142,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2195(VarCurr)
    <=> v2052(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_170,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2183(VarNext)
      <=> v2184(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_169,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2184(VarNext)
      <=> ( v2185(VarNext)
          & v2121(VarNext) ) ) ) ).

tff(writeUnaryOperator_141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2185(VarNext)
      <=> v2187(VarNext) ) ) ).

tff(addAssignment_964,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2187(VarNext)
      <=> v2121(VarCurr) ) ) ).

tff(addAssignment_963,axiom,
    ! [VarCurr: state_type] :
      ( v2121(VarCurr)
    <=> v2123(VarCurr) ) ).

tff(addAssignment_962,axiom,
    ! [VarCurr: state_type] :
      ( v2123(VarCurr)
    <=> v2125(VarCurr) ) ).

tff(addAssignment_961,axiom,
    ! [VarCurr: state_type] :
      ( v2125(VarCurr)
    <=> v2127(VarCurr) ) ).

tff(addAssignment_960,axiom,
    ! [VarCurr: state_type] :
      ( v2127(VarCurr)
    <=> v2129(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_168,axiom,
    ! [VarCurr: state_type] :
      ( v2129(VarCurr)
    <=> ( v2180(VarCurr)
        | v2172(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_167,axiom,
    ! [VarCurr: state_type] :
      ( v2180(VarCurr)
    <=> ( v2131(VarCurr)
        & v2137(VarCurr) ) ) ).

tff(addAssignment_959,axiom,
    ! [VarCurr: state_type] :
      ( v2172(VarCurr)
    <=> v2174(VarCurr) ) ).

tff(addAssignment_958,axiom,
    ! [VarCurr: state_type] :
      ( v2174(VarCurr)
    <=> v2176(VarCurr) ) ).

tff(addAssignment_957,axiom,
    ! [VarCurr: state_type] :
      ( v2176(VarCurr)
    <=> v2178(VarCurr) ) ).

tff(addAssignment_956,axiom,
    ! [VarCurr: state_type] :
      ( v2178(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_21,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2156(VarNext)
       => ( v2137(VarNext)
        <=> v2137(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_21,axiom,
    ! [VarNext: state_type] :
      ( v2156(VarNext)
     => ( v2137(VarNext)
      <=> v2166(VarNext) ) ) ).

tff(addAssignment_955,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2166(VarNext)
      <=> v2164(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_166,axiom,
    ! [VarCurr: state_type] :
      ( v2164(VarCurr)
    <=> ( v2167(VarCurr)
        & v2168(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_165,axiom,
    ! [VarCurr: state_type] :
      ( v2168(VarCurr)
    <=> ( v2143(VarCurr)
        | v2147(VarCurr) ) ) ).

tff(writeUnaryOperator_140,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2167(VarCurr)
    <=> v2139(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_164,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2156(VarNext)
      <=> v2157(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_163,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2157(VarNext)
      <=> ( v2159(VarNext)
          & v2161(VarNext) ) ) ) ).

tff(writeUnaryOperator_139,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2161(VarCurr)
    <=> v2131(VarCurr) ) ).

tff(addAssignment_954,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2159(VarNext)
      <=> v2131(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_7,axiom,
    ( v2137(constB0)
  <=> $true ) ).

tff(addAssignment_953,axiom,
    ! [VarCurr: state_type] :
      ( v2147(VarCurr)
    <=> v2149(VarCurr) ) ).

tff(addAssignment_952,axiom,
    ! [VarCurr: state_type] :
      ( v2149(VarCurr)
    <=> v2151(VarCurr) ) ).

tff(addAssignment_951,axiom,
    ! [VarCurr: state_type] :
      ( v2151(VarCurr)
    <=> v2153(VarCurr) ) ).

tff(addAssignment_950,axiom,
    ! [VarCurr: state_type] :
      ( v2153(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_949,axiom,
    ! [VarCurr: state_type] :
      ( v2143(VarCurr)
    <=> v2145(VarCurr) ) ).

tff(addAssignment_948,axiom,
    ! [VarCurr: state_type] :
      ( v2145(VarCurr)
    <=> $true ) ).

tff(addAssignment_947,axiom,
    ! [VarCurr: state_type] :
      ( v2139(VarCurr)
    <=> v2141(VarCurr) ) ).

tff(addAssignment_946,axiom,
    ! [VarCurr: state_type] :
      ( v2141(VarCurr)
    <=> $false ) ).

tff(addAssignment_945,axiom,
    ! [VarCurr: state_type] :
      ( v2131(VarCurr)
    <=> v2133(VarCurr) ) ).

tff(addAssignment_944,axiom,
    ! [VarCurr: state_type] :
      ( v2133(VarCurr)
    <=> v2135(VarCurr) ) ).

tff(addAssignment_943,axiom,
    ! [VarCurr: state_type] :
      ( v2135(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_942,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2068(VarCurr,B)
      <=> v2070(VarCurr,B) ) ) ).

tff(addAssignment_941,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2070(VarCurr,B)
      <=> v2072(VarCurr,B) ) ) ).

tff(addAssignment_940,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,8)
        & ~ $less(B,0) )
     => ( v2072(VarCurr,B)
      <=> v2074(VarCurr,B) ) ) ).

tff(addAssignment_939,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,0)
    <=> v2116(VarCurr) ) ).

tff(addAssignment_938,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,1)
    <=> v2114(VarCurr) ) ).

tff(addAssignment_937,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,2)
    <=> v2109(VarCurr) ) ).

tff(addAssignment_936,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,3)
    <=> v2104(VarCurr) ) ).

tff(addAssignment_935,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,4)
    <=> v2099(VarCurr) ) ).

tff(addAssignment_934,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,5)
    <=> v2094(VarCurr) ) ).

tff(addAssignment_933,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,6)
    <=> v2089(VarCurr) ) ).

tff(addAssignment_932,axiom,
    ! [VarCurr: state_type] :
      ( v2074(VarCurr,7)
    <=> v2078(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_162,axiom,
    ! [VarCurr: state_type] :
      ( v2114(VarCurr)
    <=> ( v2115(VarCurr)
        & v2118(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_19,axiom,
    ! [VarCurr: state_type] :
      ( v2118(VarCurr)
    <=> ( v2046(VarCurr,0)
        | v2046(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_161,axiom,
    ! [VarCurr: state_type] :
      ( v2115(VarCurr)
    <=> ( v2116(VarCurr)
        | v2117(VarCurr) ) ) ).

tff(writeUnaryOperator_138,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2117(VarCurr)
    <=> v2046(VarCurr,1) ) ).

tff(writeUnaryOperator_137,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2116(VarCurr)
    <=> v2046(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_160,axiom,
    ! [VarCurr: state_type] :
      ( v2109(VarCurr)
    <=> ( v2110(VarCurr)
        & v2113(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_18,axiom,
    ! [VarCurr: state_type] :
      ( v2113(VarCurr)
    <=> ( v2086(VarCurr)
        | v2046(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_159,axiom,
    ! [VarCurr: state_type] :
      ( v2110(VarCurr)
    <=> ( v2111(VarCurr)
        | v2112(VarCurr) ) ) ).

tff(writeUnaryOperator_136,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2112(VarCurr)
    <=> v2046(VarCurr,2) ) ).

tff(writeUnaryOperator_135,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2111(VarCurr)
    <=> v2086(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_158,axiom,
    ! [VarCurr: state_type] :
      ( v2104(VarCurr)
    <=> ( v2105(VarCurr)
        & v2108(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_17,axiom,
    ! [VarCurr: state_type] :
      ( v2108(VarCurr)
    <=> ( v2085(VarCurr)
        | v2046(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_157,axiom,
    ! [VarCurr: state_type] :
      ( v2105(VarCurr)
    <=> ( v2106(VarCurr)
        | v2107(VarCurr) ) ) ).

tff(writeUnaryOperator_134,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2107(VarCurr)
    <=> v2046(VarCurr,3) ) ).

tff(writeUnaryOperator_133,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2106(VarCurr)
    <=> v2085(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_156,axiom,
    ! [VarCurr: state_type] :
      ( v2099(VarCurr)
    <=> ( v2100(VarCurr)
        & v2103(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_16,axiom,
    ! [VarCurr: state_type] :
      ( v2103(VarCurr)
    <=> ( v2084(VarCurr)
        | v2046(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_155,axiom,
    ! [VarCurr: state_type] :
      ( v2100(VarCurr)
    <=> ( v2101(VarCurr)
        | v2102(VarCurr) ) ) ).

tff(writeUnaryOperator_132,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2102(VarCurr)
    <=> v2046(VarCurr,4) ) ).

tff(writeUnaryOperator_131,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2101(VarCurr)
    <=> v2084(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_154,axiom,
    ! [VarCurr: state_type] :
      ( v2094(VarCurr)
    <=> ( v2095(VarCurr)
        & v2098(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_15,axiom,
    ! [VarCurr: state_type] :
      ( v2098(VarCurr)
    <=> ( v2083(VarCurr)
        | v2046(VarCurr,5) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_153,axiom,
    ! [VarCurr: state_type] :
      ( v2095(VarCurr)
    <=> ( v2096(VarCurr)
        | v2097(VarCurr) ) ) ).

tff(writeUnaryOperator_130,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2097(VarCurr)
    <=> v2046(VarCurr,5) ) ).

tff(writeUnaryOperator_129,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2096(VarCurr)
    <=> v2083(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_152,axiom,
    ! [VarCurr: state_type] :
      ( v2089(VarCurr)
    <=> ( v2090(VarCurr)
        & v2093(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_14,axiom,
    ! [VarCurr: state_type] :
      ( v2093(VarCurr)
    <=> ( v2082(VarCurr)
        | v2046(VarCurr,6) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_151,axiom,
    ! [VarCurr: state_type] :
      ( v2090(VarCurr)
    <=> ( v2091(VarCurr)
        | v2092(VarCurr) ) ) ).

tff(writeUnaryOperator_128,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2092(VarCurr)
    <=> v2046(VarCurr,6) ) ).

tff(writeUnaryOperator_127,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2091(VarCurr)
    <=> v2082(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_150,axiom,
    ! [VarCurr: state_type] :
      ( v2078(VarCurr)
    <=> ( v2079(VarCurr)
        & v2088(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_13,axiom,
    ! [VarCurr: state_type] :
      ( v2088(VarCurr)
    <=> ( v2081(VarCurr)
        | v2046(VarCurr,7) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_149,axiom,
    ! [VarCurr: state_type] :
      ( v2079(VarCurr)
    <=> ( v2080(VarCurr)
        | v2087(VarCurr) ) ) ).

tff(writeUnaryOperator_126,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2087(VarCurr)
    <=> v2046(VarCurr,7) ) ).

tff(writeUnaryOperator_125,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2080(VarCurr)
    <=> v2081(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_12,axiom,
    ! [VarCurr: state_type] :
      ( v2081(VarCurr)
    <=> ( v2082(VarCurr)
        & v2046(VarCurr,6) ) ) ).

tff(writeBinaryOperatorShiftedRanges_11,axiom,
    ! [VarCurr: state_type] :
      ( v2082(VarCurr)
    <=> ( v2083(VarCurr)
        & v2046(VarCurr,5) ) ) ).

tff(writeBinaryOperatorShiftedRanges_10,axiom,
    ! [VarCurr: state_type] :
      ( v2083(VarCurr)
    <=> ( v2084(VarCurr)
        & v2046(VarCurr,4) ) ) ).

tff(writeBinaryOperatorShiftedRanges_9,axiom,
    ! [VarCurr: state_type] :
      ( v2084(VarCurr)
    <=> ( v2085(VarCurr)
        & v2046(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_8,axiom,
    ! [VarCurr: state_type] :
      ( v2085(VarCurr)
    <=> ( v2086(VarCurr)
        & v2046(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges_7,axiom,
    ! [VarCurr: state_type] :
      ( v2086(VarCurr)
    <=> ( v2046(VarCurr,0)
        & v2046(VarCurr,1) ) ) ).

tff(addAssignment_931,axiom,
    ! [VarCurr: state_type] :
      ( v2060(VarCurr)
    <=> v2062(VarCurr) ) ).

tff(addAssignment_930,axiom,
    ! [VarCurr: state_type] :
      ( v2062(VarCurr)
    <=> v2064(VarCurr) ) ).

tff(addAssignment_929,axiom,
    ! [VarCurr: state_type] :
      ( v2064(VarCurr)
    <=> v2066(VarCurr) ) ).

tff(addAssignment_928,axiom,
    ! [VarCurr: state_type] :
      ( v2066(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_927,axiom,
    ! [VarCurr: state_type] :
      ( v2052(VarCurr)
    <=> v2054(VarCurr) ) ).

tff(addAssignment_926,axiom,
    ! [VarCurr: state_type] :
      ( v2054(VarCurr)
    <=> v2056(VarCurr) ) ).

tff(addAssignment_925,axiom,
    ! [VarCurr: state_type] :
      ( v2056(VarCurr)
    <=> v2058(VarCurr) ) ).

tff(addAssignment_924,axiom,
    ! [VarCurr: state_type] :
      ( v2058(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_923,axiom,
    ! [VarCurr: state_type] :
      ( v1047(VarCurr)
    <=> v1049(VarCurr) ) ).

tff(addAssignment_922,axiom,
    ! [VarCurr: state_type] :
      ( v1049(VarCurr)
    <=> v1051(VarCurr) ) ).

tff(addAssignment_921,axiom,
    ! [VarCurr: state_type] :
      ( v1051(VarCurr)
    <=> v1053(VarCurr) ) ).

tff(addAssignment_920,axiom,
    ! [VarCurr: state_type] :
      ( v1053(VarCurr)
    <=> v1055(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_20,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2019(VarNext)
       => ( v1055(VarNext)
        <=> v1055(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_20,axiom,
    ! [VarNext: state_type] :
      ( v2019(VarNext)
     => ( v1055(VarNext)
      <=> v2029(VarNext) ) ) ).

tff(addAssignment_919,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2029(VarNext)
      <=> v2027(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_22,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2030(VarCurr)
     => ( v2027(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_22,axiom,
    ! [VarCurr: state_type] :
      ( v2030(VarCurr)
     => ( v2027(VarCurr)
      <=> v1111(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_148,axiom,
    ! [VarCurr: state_type] :
      ( v2030(VarCurr)
    <=> ( v2031(VarCurr)
        & v2032(VarCurr) ) ) ).

tff(writeUnaryOperator_124,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2032(VarCurr)
    <=> v1107(VarCurr) ) ).

tff(writeUnaryOperator_123,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2031(VarCurr)
    <=> v1057(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_147,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2019(VarNext)
      <=> v2020(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_146,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2020(VarNext)
      <=> ( v2021(VarNext)
          & v2014(VarNext) ) ) ) ).

tff(writeUnaryOperator_122,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v2021(VarNext)
      <=> v2023(VarNext) ) ) ).

tff(addAssignment_918,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v2023(VarNext)
      <=> v2014(VarCurr) ) ) ).

tff(addAssignment_917,axiom,
    ! [VarCurr: state_type] :
      ( v2014(VarCurr)
    <=> v2016(VarCurr) ) ).

tff(addAssignment_916,axiom,
    ! [VarCurr: state_type] :
      ( v2016(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_915,axiom,
    ! [VarCurr: state_type] :
      ( v1111(VarCurr)
    <=> v1113(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_145,axiom,
    ! [VarCurr: state_type] :
      ( v1113(VarCurr)
    <=> ( v2006(VarCurr)
        | v2009(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_144,axiom,
    ! [VarCurr: state_type] :
      ( v2009(VarCurr)
    <=> ( v1053(VarCurr)
        & v2010(VarCurr) ) ) ).

tff(writeUnaryOperator_121,axiom,
    ! [VarCurr: state_type] :
      ( ~ v2010(VarCurr)
    <=> v2011(VarCurr) ) ).

tff(addAssignment_914,axiom,
    ! [VarCurr: state_type] :
      ( v2011(VarCurr)
    <=> v2012(VarCurr) ) ).

tff(addAssignment_913,axiom,
    ! [VarCurr: state_type] :
      ( v2012(VarCurr)
    <=> v1725(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_143,axiom,
    ! [VarCurr: state_type] :
      ( v2006(VarCurr)
    <=> ( v1115(VarCurr)
        & v2007(VarCurr) ) ) ).

tff(addAssignment_912,axiom,
    ! [VarCurr: state_type] :
      ( v2007(VarCurr)
    <=> v2008(VarCurr) ) ).

tff(addAssignment_911,axiom,
    ! [VarCurr: state_type] :
      ( v2008(VarCurr)
    <=> v1725(VarCurr) ) ).

tff(addAssignment_910,axiom,
    ! [VarCurr: state_type] :
      ( v1725(VarCurr)
    <=> v1727(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_142,axiom,
    ! [VarCurr: state_type] :
      ( v1727(VarCurr)
    <=> ( v1729(VarCurr)
        & v2004(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_7,axiom,
    ! [VarCurr: state_type] :
      ( v2004(VarCurr)
    <=> ( ( v1871(VarCurr,12)
        <=> $false )
        & ( v1871(VarCurr,11)
        <=> $false )
        & ( v1871(VarCurr,10)
        <=> $false )
        & ( v1871(VarCurr,9)
        <=> $false )
        & ( v1871(VarCurr,8)
        <=> $true )
        & ( v1871(VarCurr,7)
        <=> $false )
        & ( v1871(VarCurr,6)
        <=> $true )
        & ( v1871(VarCurr,5)
        <=> $false )
        & ( v1871(VarCurr,4)
        <=> $false )
        & ( v1871(VarCurr,3)
        <=> $true )
        & ( v1871(VarCurr,2)
        <=> $false )
        & ( v1871(VarCurr,1)
        <=> $false )
        & ( v1871(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_22,axiom,
    ~ b0000101001000(12) ).

tff(bitBlastConstant_21,axiom,
    ~ b0000101001000(11) ).

tff(bitBlastConstant_20,axiom,
    ~ b0000101001000(10) ).

tff(bitBlastConstant_19,axiom,
    ~ b0000101001000(9) ).

tff(bitBlastConstant_18,axiom,
    b0000101001000(8) ).

tff(bitBlastConstant_17,axiom,
    ~ b0000101001000(7) ).

tff(bitBlastConstant_16,axiom,
    b0000101001000(6) ).

tff(bitBlastConstant_15,axiom,
    ~ b0000101001000(5) ).

tff(bitBlastConstant_14,axiom,
    ~ b0000101001000(4) ).

tff(bitBlastConstant_13,axiom,
    b0000101001000(3) ).

tff(bitBlastConstant_12,axiom,
    ~ b0000101001000(2) ).

tff(bitBlastConstant_11,axiom,
    ~ b0000101001000(1) ).

tff(bitBlastConstant_10,axiom,
    ~ b0000101001000(0) ).

tff(addAssignment_909,axiom,
    ! [VarCurr: state_type] :
      ( ( v1871(VarCurr,12)
      <=> v1121(VarCurr,76) )
      & ( v1871(VarCurr,11)
      <=> v1121(VarCurr,75) )
      & ( v1871(VarCurr,10)
      <=> v1121(VarCurr,74) )
      & ( v1871(VarCurr,9)
      <=> v1121(VarCurr,73) )
      & ( v1871(VarCurr,8)
      <=> v1121(VarCurr,72) )
      & ( v1871(VarCurr,7)
      <=> v1121(VarCurr,71) )
      & ( v1871(VarCurr,6)
      <=> v1121(VarCurr,70) )
      & ( v1871(VarCurr,5)
      <=> v1121(VarCurr,69) )
      & ( v1871(VarCurr,4)
      <=> v1121(VarCurr,68) )
      & ( v1871(VarCurr,3)
      <=> v1121(VarCurr,67) )
      & ( v1871(VarCurr,2)
      <=> v1121(VarCurr,66) )
      & ( v1871(VarCurr,1)
      <=> v1121(VarCurr,65) )
      & ( v1871(VarCurr,0)
      <=> v1121(VarCurr,64) ) ) ).

tff(addAssignment_908,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,77)
        & ~ $less(B,64) )
     => ( v1121(VarCurr,B)
      <=> v1123(VarCurr,B) ) ) ).

tff(addAssignment_907,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,77)
        & ~ $less(B,64) )
     => ( v1123(VarNext,B)
      <=> v1995(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_19,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1996(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v1995(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_19,axiom,
    ! [VarNext: state_type] :
      ( v1996(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1995(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_141,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1996(VarNext)
      <=> v1997(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_140,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1997(VarNext)
      <=> ( v1999(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_120,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1999(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_906,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,77)
        & ~ $less(B,64) )
     => ( v1133(VarCurr,B)
      <=> v1135(VarCurr,B) ) ) ).

tff(addAssignment_905,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,77)
        & ~ $less(B,64) )
     => ( v1135(VarCurr,B)
      <=> v1137(VarCurr,B) ) ) ).

tff(addAssignment_904,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,77)
        & ~ $less(B,64) )
     => ( v1137(VarCurr,B)
      <=> v1697(VarCurr,B) ) ) ).

tff(addAssignment_903,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1700(VarCurr,B)
      <=> v1874(VarCurr,B) ) ) ).

tff(addAssignment_902,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1874(VarCurr,B)
      <=> v1876(VarCurr,B) ) ) ).

tff(addAssignment_901,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1876(VarCurr,B)
      <=> v1878(VarCurr,B) ) ) ).

tff(addAssignment_900,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1878(VarCurr,B)
      <=> v1880(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_18,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1978(VarNext)
       => ! [B: $int] :
            ( ( $less(B,13)
              & ~ $less(B,0) )
           => ( v1880(VarNext,B)
            <=> v1880(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_18,axiom,
    ! [VarNext: state_type] :
      ( v1978(VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1880(VarNext,B)
          <=> v1988(VarNext,B) ) ) ) ).

tff(addAssignment_899,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1988(VarNext,B)
          <=> v1986(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_21,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1989(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1986(VarCurr,B)
          <=> bxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_21,axiom,
    ! [VarCurr: state_type] :
      ( v1989(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1986(VarCurr,B)
          <=> v1890(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_139,axiom,
    ! [VarCurr: state_type] :
      ( v1989(VarCurr)
    <=> ( v1990(VarCurr)
        & v1991(VarCurr) ) ) ).

tff(writeUnaryOperator_119,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1991(VarCurr)
    <=> v1886(VarCurr) ) ).

tff(writeUnaryOperator_118,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1990(VarCurr)
    <=> v1882(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_138,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1978(VarNext)
      <=> v1979(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_137,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1979(VarNext)
      <=> ( v1980(VarNext)
          & v1973(VarNext) ) ) ) ).

tff(writeUnaryOperator_117,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1980(VarNext)
      <=> v1982(VarNext) ) ) ).

tff(addAssignment_898,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1982(VarNext)
      <=> v1973(VarCurr) ) ) ).

tff(addAssignment_897,axiom,
    ! [VarCurr: state_type] :
      ( v1973(VarCurr)
    <=> v1975(VarCurr) ) ).

tff(addAssignment_896,axiom,
    ! [VarCurr: state_type] :
      ( v1975(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_895,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1890(VarCurr,B)
      <=> v1892(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_17,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1892(VarCurr,B)
      <=> ( v1965(VarCurr,B)
          | v1968(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_16,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1968(VarCurr,B)
      <=> ( v1878(VarCurr,B)
          & v1969(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_116,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1969(VarCurr,B)
      <=> ~ v1970(VarCurr,B) ) ) ).

tff(addAssignment_894,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,0)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_893,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,1)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_892,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,2)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_891,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,3)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_890,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,4)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_889,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,5)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_888,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,6)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_887,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,7)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_886,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,8)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_885,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,9)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_884,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,10)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_883,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,11)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_882,axiom,
    ! [VarCurr: state_type] :
      ( v1970(VarCurr,12)
    <=> v1971(VarCurr) ) ).

tff(addAssignment_881,axiom,
    ! [VarCurr: state_type] :
      ( v1971(VarCurr)
    <=> v1963(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_15,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1965(VarCurr,B)
      <=> ( v1894(VarCurr,B)
          & v1966(VarCurr,B) ) ) ) ).

tff(addAssignment_880,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,0)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_879,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,1)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_878,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,2)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_877,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,3)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_876,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,4)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_875,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,5)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_874,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,6)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_873,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,7)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_872,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,8)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_871,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,9)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_870,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,10)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_869,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,11)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_868,axiom,
    ! [VarCurr: state_type] :
      ( v1966(VarCurr,12)
    <=> v1967(VarCurr) ) ).

tff(addAssignment_867,axiom,
    ! [VarCurr: state_type] :
      ( v1967(VarCurr)
    <=> v1963(VarCurr) ) ).

tff(addAssignment_866,axiom,
    ! [VarCurr: state_type] :
      ( v1963(VarCurr)
    <=> v1609(VarCurr) ) ).

tff(addAssignment_865,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1894(VarCurr,B)
      <=> v1896(VarCurr,B) ) ) ).

tff(addAssignment_864,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1896(VarCurr,B)
      <=> v1898(VarCurr,B) ) ) ).

tff(addAssignment_863,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1898(VarCurr,B)
      <=> v1900(VarCurr,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_17,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1946(VarNext)
       => ! [B: $int] :
            ( ( $less(B,13)
              & ~ $less(B,0) )
           => ( v1900(VarNext,B)
            <=> v1900(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_17,axiom,
    ! [VarNext: state_type] :
      ( v1946(VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1900(VarNext,B)
          <=> v1956(VarNext,B) ) ) ) ).

tff(addAssignment_862,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1956(VarNext,B)
          <=> v1954(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_20,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1957(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1954(VarCurr,B)
          <=> bxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_20,axiom,
    ! [VarCurr: state_type] :
      ( v1957(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,13)
            & ~ $less(B,0) )
         => ( v1954(VarCurr,B)
          <=> v1910(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_136,axiom,
    ! [VarCurr: state_type] :
      ( v1957(VarCurr)
    <=> ( v1958(VarCurr)
        & v1959(VarCurr) ) ) ).

tff(writeUnaryOperator_115,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1959(VarCurr)
    <=> v1906(VarCurr) ) ).

tff(writeUnaryOperator_114,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1958(VarCurr)
    <=> v1902(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_135,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1946(VarNext)
      <=> v1947(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_134,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1947(VarNext)
      <=> ( v1948(VarNext)
          & v1941(VarNext) ) ) ) ).

tff(writeUnaryOperator_113,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1948(VarNext)
      <=> v1950(VarNext) ) ) ).

tff(addAssignment_861,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1950(VarNext)
      <=> v1941(VarCurr) ) ) ).

tff(addAssignment_860,axiom,
    ! [VarCurr: state_type] :
      ( v1941(VarCurr)
    <=> v1943(VarCurr) ) ).

tff(addAssignment_859,axiom,
    ! [VarCurr: state_type] :
      ( v1943(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_858,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1910(VarCurr,B)
      <=> v1912(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_14,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1912(VarCurr,B)
      <=> ( v1932(VarCurr,B)
          | v1935(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_13,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1935(VarCurr,B)
      <=> ( v1898(VarCurr,B)
          & v1936(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_112,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1936(VarCurr,B)
      <=> ~ v1937(VarCurr,B) ) ) ).

tff(addAssignment_857,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,0)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_856,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,1)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_855,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,2)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_854,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,3)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_853,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,4)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_852,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,5)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_851,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,6)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_850,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,7)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_849,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,8)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_848,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,9)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_847,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,10)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_846,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,11)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_845,axiom,
    ! [VarCurr: state_type] :
      ( v1937(VarCurr,12)
    <=> v1938(VarCurr) ) ).

tff(addAssignment_844,axiom,
    ! [VarCurr: state_type] :
      ( v1938(VarCurr)
    <=> v1922(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_12,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1932(VarCurr,B)
      <=> ( v1914(VarCurr,B)
          & v1933(VarCurr,B) ) ) ) ).

tff(addAssignment_843,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,0)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_842,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,1)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_841,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,2)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_840,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,3)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_839,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,4)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_838,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,5)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_837,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,6)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_836,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,7)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_835,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,8)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_834,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,9)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_833,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,10)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_832,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,11)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_831,axiom,
    ! [VarCurr: state_type] :
      ( v1933(VarCurr,12)
    <=> v1934(VarCurr) ) ).

tff(addAssignment_830,axiom,
    ! [VarCurr: state_type] :
      ( v1934(VarCurr)
    <=> v1922(VarCurr) ) ).

tff(addAssignment_829,axiom,
    ! [VarCurr: state_type] :
      ( v1922(VarCurr)
    <=> v1924(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_133,axiom,
    ! [VarCurr: state_type] :
      ( v1924(VarCurr)
    <=> ( v1776(VarCurr)
        | v1926(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_132,axiom,
    ! [VarCurr: state_type] :
      ( v1926(VarCurr)
    <=> ( v1778(VarCurr)
        & v1928(VarCurr) ) ) ).

tff(addAssignment_828,axiom,
    ! [VarCurr: state_type] :
      ( v1928(VarCurr)
    <=> v1201(VarCurr,1) ) ).

tff(addAssignment_827,axiom,
    ! [VarCurr: state_type] :
      ( v1201(VarCurr,1)
    <=> v1203(VarCurr,1) ) ).

tff(addAssignment_826,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1914(VarCurr,B)
      <=> v1916(VarCurr,B) ) ) ).

tff(addAssignment_825,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1916(VarCurr,B)
      <=> v1918(VarCurr,B) ) ) ).

tff(addAssignment_824,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,13)
        & ~ $less(B,0) )
     => ( v1918(VarCurr,B)
      <=> v1920(VarCurr,B) ) ) ).

tff(addAssignment_823,axiom,
    ! [VarCurr: state_type] :
      ( v1906(VarCurr)
    <=> v1908(VarCurr) ) ).

tff(addAssignment_822,axiom,
    ! [VarCurr: state_type] :
      ( v1908(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_821,axiom,
    ! [VarCurr: state_type] :
      ( v1902(VarCurr)
    <=> v1904(VarCurr) ) ).

tff(addAssignment_820,axiom,
    ! [VarCurr: state_type] :
      ( v1904(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_819,axiom,
    ! [VarCurr: state_type] :
      ( v1886(VarCurr)
    <=> v1888(VarCurr) ) ).

tff(addAssignment_818,axiom,
    ! [VarCurr: state_type] :
      ( v1888(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_817,axiom,
    ! [VarCurr: state_type] :
      ( v1882(VarCurr)
    <=> v1884(VarCurr) ) ).

tff(addAssignment_816,axiom,
    ! [VarCurr: state_type] :
      ( v1884(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_815,axiom,
    ! [VarCurr: state_type] :
      ( v1729(VarCurr)
    <=> v1121(VarCurr,77) ) ).

tff(addAssignment_814,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,77)
    <=> v1123(VarCurr,77) ) ).

tff(addAssignment_813,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,77)
    <=> v1863(VarNext,77) ) ).

tff(addCaseBooleanConditionEqualRanges1_16,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1864(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v1863(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_16,axiom,
    ! [VarNext: state_type] :
      ( v1864(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1863(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_131,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1864(VarNext)
      <=> v1865(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_130,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1865(VarNext)
      <=> ( v1867(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1867(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_812,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,77)
    <=> v1135(VarCurr,77) ) ).

tff(addAssignment_811,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,77)
    <=> v1137(VarCurr,77) ) ).

tff(addAssignment_810,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,77)
    <=> v1697(VarCurr,77) ) ).

tff(addAssignment_809,axiom,
    ! [VarCurr: state_type] :
      ( v1699(VarCurr)
    <=> v1732(VarCurr) ) ).

tff(addAssignment_808,axiom,
    ! [VarCurr: state_type] :
      ( v1732(VarCurr)
    <=> v1734(VarCurr) ) ).

tff(addAssignment_807,axiom,
    ! [VarCurr: state_type] :
      ( v1734(VarCurr)
    <=> v1736(VarCurr,0) ) ).

tff(addAssignment_806,axiom,
    ! [VarCurr: state_type] :
      ( v1736(VarCurr,0)
    <=> v1738(VarCurr,0) ) ).

tff(addAssignment_805,axiom,
    ! [VarNext: state_type] :
      ( v1738(VarNext,0)
    <=> v1845(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_15,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1846(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v1845(VarNext,B)
            <=> v1738(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_15,axiom,
    ! [VarNext: state_type] :
      ( v1846(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1845(VarNext,B)
          <=> v1856(VarNext,B) ) ) ) ).

tff(addAssignment_804,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1856(VarNext,B)
          <=> v1854(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_19,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1854(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_19,axiom,
    ! [VarCurr: state_type] :
      ( v1857(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1854(VarCurr,B)
          <=> v1748(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_129,axiom,
    ! [VarCurr: state_type] :
      ( v1857(VarCurr)
    <=> ( v1858(VarCurr)
        & v1859(VarCurr) ) ) ).

tff(writeUnaryOperator_110,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1859(VarCurr)
    <=> v1744(VarCurr) ) ).

tff(writeUnaryOperator_109,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1858(VarCurr)
    <=> v1740(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1846(VarNext)
      <=> v1847(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1847(VarNext)
      <=> ( v1848(VarNext)
          & v1841(VarNext) ) ) ) ).

tff(writeUnaryOperator_108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1848(VarNext)
      <=> v1850(VarNext) ) ) ).

tff(addAssignment_803,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1850(VarNext)
      <=> v1841(VarCurr) ) ) ).

tff(addAssignment_802,axiom,
    ! [VarCurr: state_type] :
      ( v1841(VarCurr)
    <=> v1843(VarCurr) ) ).

tff(addAssignment_801,axiom,
    ! [VarCurr: state_type] :
      ( v1843(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_800,axiom,
    ! [VarCurr: state_type] :
      ( v1748(VarCurr,0)
    <=> v1750(VarCurr,0) ) ).

tff(addAssignment_799,axiom,
    ! [VarCurr: state_type] :
      ( v1750(VarCurr,0)
    <=> v1832(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_11,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v1832(VarCurr,B)
      <=> ( v1833(VarCurr,B)
          | v1836(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_10,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v1836(VarCurr,B)
      <=> ( v1736(VarCurr,B)
          & v1837(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_107,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v1837(VarCurr,B)
      <=> ~ v1838(VarCurr,B) ) ) ).

tff(addAssignment_798,axiom,
    ! [VarCurr: state_type] :
      ( v1838(VarCurr,0)
    <=> v1839(VarCurr) ) ).

tff(addAssignment_797,axiom,
    ! [VarCurr: state_type] :
      ( v1838(VarCurr,1)
    <=> v1839(VarCurr) ) ).

tff(addAssignment_796,axiom,
    ! [VarCurr: state_type] :
      ( v1839(VarCurr)
    <=> v1831(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_9,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,2)
        & ~ $less(B,0) )
     => ( v1833(VarCurr,B)
      <=> ( v1752(VarCurr,B)
          & v1834(VarCurr,B) ) ) ) ).

tff(addAssignment_795,axiom,
    ! [VarCurr: state_type] :
      ( v1834(VarCurr,0)
    <=> v1835(VarCurr) ) ).

tff(addAssignment_794,axiom,
    ! [VarCurr: state_type] :
      ( v1834(VarCurr,1)
    <=> v1835(VarCurr) ) ).

tff(addAssignment_793,axiom,
    ! [VarCurr: state_type] :
      ( v1835(VarCurr)
    <=> v1831(VarCurr) ) ).

tff(addAssignment_792,axiom,
    ! [VarCurr: state_type] :
      ( v1831(VarCurr)
    <=> v1609(VarCurr) ) ).

tff(addAssignment_791,axiom,
    ! [VarCurr: state_type] :
      ( v1752(VarCurr,0)
    <=> v1828(VarCurr,0) ) ).

tff(addAssignment_790,axiom,
    ! [VarCurr: state_type] :
      ( v1828(VarCurr,0)
    <=> v1754(VarCurr) ) ).

tff(addAssignment_789,axiom,
    ! [VarCurr: state_type] :
      ( v1828(VarCurr,1)
    <=> v1829(VarCurr) ) ).

tff(addAssignment_788,axiom,
    ! [VarCurr: state_type] :
      ( v1754(VarCurr)
    <=> v1756(VarCurr) ) ).

tff(addAssignment_787,axiom,
    ! [VarCurr: state_type] :
      ( v1756(VarCurr)
    <=> v1758(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_14,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1812(VarNext)
       => ( v1758(VarNext)
        <=> v1758(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_14,axiom,
    ! [VarNext: state_type] :
      ( v1812(VarNext)
     => ( v1758(VarNext)
      <=> v1822(VarNext) ) ) ).

tff(addAssignment_786,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1822(VarNext)
      <=> v1820(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_18,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1823(VarCurr)
     => ( v1820(VarCurr)
      <=> x1805(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_18,axiom,
    ! [VarCurr: state_type] :
      ( v1823(VarCurr)
     => ( v1820(VarCurr)
      <=> v1768(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_126,axiom,
    ! [VarCurr: state_type] :
      ( v1823(VarCurr)
    <=> ( v1824(VarCurr)
        & v1825(VarCurr) ) ) ).

tff(writeUnaryOperator_106,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1825(VarCurr)
    <=> v1764(VarCurr) ) ).

tff(writeUnaryOperator_105,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1824(VarCurr)
    <=> v1760(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_125,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1812(VarNext)
      <=> v1813(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_124,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1813(VarNext)
      <=> ( v1814(VarNext)
          & v1807(VarNext) ) ) ) ).

tff(writeUnaryOperator_104,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1814(VarNext)
      <=> v1816(VarNext) ) ) ).

tff(addAssignment_785,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1816(VarNext)
      <=> v1807(VarCurr) ) ) ).

tff(addAssignment_784,axiom,
    ! [VarCurr: state_type] :
      ( v1807(VarCurr)
    <=> v1809(VarCurr) ) ).

tff(addAssignment_783,axiom,
    ! [VarCurr: state_type] :
      ( v1809(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_782,axiom,
    ! [VarCurr: state_type] :
      ( v1768(VarCurr)
    <=> v1770(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_123,axiom,
    ! [VarCurr: state_type] :
      ( v1770(VarCurr)
    <=> ( v1790(VarCurr)
        | v1797(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_122,axiom,
    ! [VarCurr: state_type] :
      ( v1797(VarCurr)
    <=> ( v1798(VarCurr)
        & v1802(VarCurr) ) ) ).

tff(writeUnaryOperator_103,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1802(VarCurr)
    <=> v1803(VarCurr) ) ).

tff(addAssignment_781,axiom,
    ! [VarCurr: state_type] :
      ( v1803(VarCurr)
    <=> v1804(VarCurr) ) ).

tff(addAssignment_780,axiom,
    ! [VarCurr: state_type] :
      ( v1804(VarCurr)
    <=> v1785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_121,axiom,
    ! [VarCurr: state_type] :
      ( v1798(VarCurr)
    <=> ( v1756(VarCurr)
        & v1799(VarCurr) ) ) ).

tff(writeUnaryOperator_102,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1799(VarCurr)
    <=> v1800(VarCurr) ) ).

tff(addAssignment_779,axiom,
    ! [VarCurr: state_type] :
      ( v1800(VarCurr)
    <=> v1801(VarCurr) ) ).

tff(addAssignment_778,axiom,
    ! [VarCurr: state_type] :
      ( v1801(VarCurr)
    <=> v1774(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_120,axiom,
    ! [VarCurr: state_type] :
      ( v1790(VarCurr)
    <=> ( v1791(VarCurr)
        & v1794(VarCurr) ) ) ).

tff(writeUnaryOperator_101,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1794(VarCurr)
    <=> v1795(VarCurr) ) ).

tff(addAssignment_777,axiom,
    ! [VarCurr: state_type] :
      ( v1795(VarCurr)
    <=> v1796(VarCurr) ) ).

tff(addAssignment_776,axiom,
    ! [VarCurr: state_type] :
      ( v1796(VarCurr)
    <=> v1785(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_119,axiom,
    ! [VarCurr: state_type] :
      ( v1791(VarCurr)
    <=> ( v1772(VarCurr)
        & v1792(VarCurr) ) ) ).

tff(addAssignment_775,axiom,
    ! [VarCurr: state_type] :
      ( v1792(VarCurr)
    <=> v1793(VarCurr) ) ).

tff(addAssignment_774,axiom,
    ! [VarCurr: state_type] :
      ( v1793(VarCurr)
    <=> v1774(VarCurr) ) ).

tff(addAssignment_773,axiom,
    ! [VarCurr: state_type] :
      ( v1785(VarCurr)
    <=> v1787(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_118,axiom,
    ! [VarCurr: state_type] :
      ( v1787(VarCurr)
    <=> ( v1609(VarCurr)
        & v1754(VarCurr) ) ) ).

tff(addAssignment_772,axiom,
    ! [VarCurr: state_type] :
      ( v1774(VarCurr)
    <=> v1776(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_117,axiom,
    ! [VarCurr: state_type] :
      ( v1776(VarCurr)
    <=> ( v1778(VarCurr)
        & v1199(VarCurr) ) ) ).

tff(addAssignment_771,axiom,
    ! [VarCurr: state_type] :
      ( v1778(VarCurr)
    <=> v1780(VarCurr,0) ) ).

tff(addAssignment_770,axiom,
    ! [VarCurr: state_type] :
      ( v1780(VarCurr,0)
    <=> v1782(VarCurr,0) ) ).

tff(addAssignment_769,axiom,
    ! [VarCurr: state_type] :
      ( v1772(VarCurr)
    <=> v1199(VarCurr) ) ).

tff(addAssignment_768,axiom,
    ! [VarCurr: state_type] :
      ( v1764(VarCurr)
    <=> v1766(VarCurr) ) ).

tff(addAssignment_767,axiom,
    ! [VarCurr: state_type] :
      ( v1766(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_766,axiom,
    ! [VarCurr: state_type] :
      ( v1760(VarCurr)
    <=> v1762(VarCurr) ) ).

tff(addAssignment_765,axiom,
    ! [VarCurr: state_type] :
      ( v1762(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_764,axiom,
    ! [VarCurr: state_type] :
      ( v1744(VarCurr)
    <=> v1746(VarCurr) ) ).

tff(addAssignment_763,axiom,
    ! [VarCurr: state_type] :
      ( v1746(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_762,axiom,
    ! [VarCurr: state_type] :
      ( v1740(VarCurr)
    <=> v1742(VarCurr) ) ).

tff(addAssignment_761,axiom,
    ! [VarCurr: state_type] :
      ( v1742(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_760,axiom,
    ! [VarCurr: state_type] :
      ( v1115(VarCurr)
    <=> v1117(VarCurr) ) ).

tff(addAssignment_759,axiom,
    ! [VarCurr: state_type] :
      ( v1117(VarCurr)
    <=> v1119(VarCurr,0) ) ).

tff(addAssignment_758,axiom,
    ! [VarCurr: state_type] :
      ( v1119(VarCurr,0)
    <=> v1121(VarCurr,0) ) ).

tff(addAssignment_757,axiom,
    ! [VarCurr: state_type] :
      ( v1121(VarCurr,0)
    <=> v1123(VarCurr,0) ) ).

tff(addAssignment_756,axiom,
    ! [VarNext: state_type] :
      ( v1123(VarNext,0)
    <=> v1707(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_13,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1708(VarNext)
       => ! [B: $int] :
            ( ( $less(B,79)
              & ~ $less(B,0) )
           => ( v1707(VarNext,B)
            <=> v1123(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_13,axiom,
    ! [VarNext: state_type] :
      ( v1708(VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1707(VarNext,B)
          <=> v1718(VarNext,B) ) ) ) ).

tff(addAssignment_755,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1718(VarNext,B)
          <=> v1716(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_17,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1719(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1716(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_17,axiom,
    ! [VarCurr: state_type] :
      ( v1719(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,79)
            & ~ $less(B,0) )
         => ( v1716(VarCurr,B)
          <=> v1133(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_116,axiom,
    ! [VarCurr: state_type] :
      ( v1719(VarCurr)
    <=> ( v1720(VarCurr)
        & v1721(VarCurr) ) ) ).

tff(writeUnaryOperator_100,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1721(VarCurr)
    <=> v1129(VarCurr) ) ).

tff(writeUnaryOperator_99,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1720(VarCurr)
    <=> v1125(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_115,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1708(VarNext)
      <=> v1709(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_114,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1709(VarNext)
      <=> ( v1710(VarNext)
          & v1703(VarNext) ) ) ) ).

tff(writeUnaryOperator_98,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1710(VarNext)
      <=> v1712(VarNext) ) ) ).

tff(addAssignment_754,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1712(VarNext)
      <=> v1703(VarCurr) ) ) ).

tff(addAssignment_753,axiom,
    ! [VarCurr: state_type] :
      ( v1703(VarCurr)
    <=> v1705(VarCurr) ) ).

tff(addAssignment_752,axiom,
    ! [VarCurr: state_type] :
      ( v1705(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_751,axiom,
    ! [VarCurr: state_type] :
      ( v1133(VarCurr,0)
    <=> v1135(VarCurr,0) ) ).

tff(addAssignment_750,axiom,
    ! [VarCurr: state_type] :
      ( v1135(VarCurr,0)
    <=> v1137(VarCurr,0) ) ).

tff(addAssignment_749,axiom,
    ! [VarCurr: state_type] :
      ( v1137(VarCurr,0)
    <=> v1697(VarCurr,0) ) ).

tff(addAssignment_748,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1697(VarCurr,B)
      <=> v1139(VarCurr,B) ) ) ).

tff(addAssignment_747,axiom,
    ! [VarCurr: state_type] :
      ( ( v1697(VarCurr,76)
      <=> v1700(VarCurr,12) )
      & ( v1697(VarCurr,75)
      <=> v1700(VarCurr,11) )
      & ( v1697(VarCurr,74)
      <=> v1700(VarCurr,10) )
      & ( v1697(VarCurr,73)
      <=> v1700(VarCurr,9) )
      & ( v1697(VarCurr,72)
      <=> v1700(VarCurr,8) )
      & ( v1697(VarCurr,71)
      <=> v1700(VarCurr,7) )
      & ( v1697(VarCurr,70)
      <=> v1700(VarCurr,6) )
      & ( v1697(VarCurr,69)
      <=> v1700(VarCurr,5) )
      & ( v1697(VarCurr,68)
      <=> v1700(VarCurr,4) )
      & ( v1697(VarCurr,67)
      <=> v1700(VarCurr,3) )
      & ( v1697(VarCurr,66)
      <=> v1700(VarCurr,2) )
      & ( v1697(VarCurr,65)
      <=> v1700(VarCurr,1) )
      & ( v1697(VarCurr,64)
      <=> v1700(VarCurr,0) ) ) ).

tff(addAssignment_746,axiom,
    ! [VarCurr: state_type] :
      ( v1697(VarCurr,77)
    <=> v1699(VarCurr) ) ).

tff(addAssignment_745,axiom,
    ! [VarCurr: state_type] :
      ( v1697(VarCurr,78)
    <=> v1698(VarCurr) ) ).

tff(addAssignment_744,axiom,
    ! [VarCurr: state_type] :
      ( v1139(VarCurr,0)
    <=> v1141(VarCurr,0) ) ).

tff(addAssignment_743,axiom,
    ! [VarCurr: state_type] :
      ( v1141(VarCurr,0)
    <=> v1143(VarCurr,0) ) ).

tff(addAssignment_742,axiom,
    ! [VarCurr: state_type] :
      ( v1143(VarCurr,0)
    <=> v1145(VarCurr,0) ) ).

tff(addAssignment_741,axiom,
    ! [VarCurr: state_type] :
      ( v1145(VarCurr,0)
    <=> v1147(VarCurr,0) ) ).

tff(addAssignment_740,axiom,
    ! [VarNext: state_type] :
      ( v1147(VarNext,0)
    <=> v1680(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_12,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1681(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v1680(VarNext,B)
            <=> v1147(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_12,axiom,
    ! [VarNext: state_type] :
      ( v1681(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1680(VarNext,B)
          <=> v1691(VarNext,B) ) ) ) ).

tff(addAssignment_739,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1691(VarNext,B)
          <=> v1689(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_16,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1689(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_16,axiom,
    ! [VarCurr: state_type] :
      ( v1692(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1689(VarCurr,B)
          <=> v1165(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_113,axiom,
    ! [VarCurr: state_type] :
      ( v1692(VarCurr)
    <=> ( v1693(VarCurr)
        & v1694(VarCurr) ) ) ).

tff(writeUnaryOperator_97,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1694(VarCurr)
    <=> v1157(VarCurr) ) ).

tff(writeUnaryOperator_96,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1693(VarCurr)
    <=> v1149(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_112,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1681(VarNext)
      <=> v1682(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_111,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1682(VarNext)
      <=> ( v1683(VarNext)
          & v1676(VarNext) ) ) ) ).

tff(writeUnaryOperator_95,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1683(VarNext)
      <=> v1685(VarNext) ) ) ).

tff(addAssignment_738,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1685(VarNext)
      <=> v1676(VarCurr) ) ) ).

tff(addAssignment_737,axiom,
    ! [VarCurr: state_type] :
      ( v1676(VarCurr)
    <=> v1678(VarCurr) ) ).

tff(addAssignment_736,axiom,
    ! [VarCurr: state_type] :
      ( v1678(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_735,axiom,
    ! [VarCurr: state_type] :
      ( v1165(VarCurr,0)
    <=> v1167(VarCurr,0) ) ).

tff(addAssignment_734,axiom,
    ! [VarCurr: state_type] :
      ( v1167(VarCurr,0)
    <=> v1667(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_8,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1667(VarCurr,B)
      <=> ( v1668(VarCurr,B)
          | v1671(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_7,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1671(VarCurr,B)
      <=> ( v1145(VarCurr,B)
          & v1672(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_94,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1672(VarCurr,B)
      <=> ~ v1673(VarCurr,B) ) ) ).

tff(addAssignment_733,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,0)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_732,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,1)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_731,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,2)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_730,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,3)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_729,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,4)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_728,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,5)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_727,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,6)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_726,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,7)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_725,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,8)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_724,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,9)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_723,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,10)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_722,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,11)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_721,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,12)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_720,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,13)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_719,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,14)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_718,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,15)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_717,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,16)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_716,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,17)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_715,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,18)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_714,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,19)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_713,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,20)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_712,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,21)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_711,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,22)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_710,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,23)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_709,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,24)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_708,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,25)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_707,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,26)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_706,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,27)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_705,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,28)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_704,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,29)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_703,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,30)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_702,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,31)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_701,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,32)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_700,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,33)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_699,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,34)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_698,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,35)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_697,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,36)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_696,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,37)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_695,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,38)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_694,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,39)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_693,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,40)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_692,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,41)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_691,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,42)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_690,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,43)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_689,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,44)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_688,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,45)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_687,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,46)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_686,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,47)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_685,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,48)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_684,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,49)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_683,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,50)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_682,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,51)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_681,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,52)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_680,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,53)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_679,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,54)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_678,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,55)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_677,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,56)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_676,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,57)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_675,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,58)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_674,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,59)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_673,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,60)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_672,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,61)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_671,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,62)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_670,axiom,
    ! [VarCurr: state_type] :
      ( v1673(VarCurr,63)
    <=> v1674(VarCurr) ) ).

tff(addAssignment_669,axiom,
    ! [VarCurr: state_type] :
      ( v1674(VarCurr)
    <=> v1607(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_6,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1668(VarCurr,B)
      <=> ( v1169(VarCurr,B)
          & v1669(VarCurr,B) ) ) ) ).

tff(addAssignment_668,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,0)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_667,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,1)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_666,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,2)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_665,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,3)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_664,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,4)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_663,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,5)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_662,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,6)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_661,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,7)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_660,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,8)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_659,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,9)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_658,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,10)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_657,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,11)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_656,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,12)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_655,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,13)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_654,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,14)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_653,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,15)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_652,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,16)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_651,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,17)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_650,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,18)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_649,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,19)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_648,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,20)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_647,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,21)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_646,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,22)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_645,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,23)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_644,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,24)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_643,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,25)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_642,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,26)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_641,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,27)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_640,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,28)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_639,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,29)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_638,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,30)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_637,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,31)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_636,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,32)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_635,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,33)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_634,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,34)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_633,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,35)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_632,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,36)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_631,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,37)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_630,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,38)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_629,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,39)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_628,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,40)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_627,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,41)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_626,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,42)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_625,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,43)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_624,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,44)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_623,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,45)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_622,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,46)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_621,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,47)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_620,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,48)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_619,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,49)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_618,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,50)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_617,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,51)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_616,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,52)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_615,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,53)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_614,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,54)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_613,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,55)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_612,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,56)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_611,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,57)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_610,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,58)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_609,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,59)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_608,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,60)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_607,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,61)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_606,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,62)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_605,axiom,
    ! [VarCurr: state_type] :
      ( v1669(VarCurr,63)
    <=> v1670(VarCurr) ) ).

tff(addAssignment_604,axiom,
    ! [VarCurr: state_type] :
      ( v1670(VarCurr)
    <=> v1607(VarCurr) ) ).

tff(addAssignment_603,axiom,
    ! [VarCurr: state_type] :
      ( v1607(VarCurr)
    <=> v1609(VarCurr) ) ).

tff(addAssignment_602,axiom,
    ! [VarCurr: state_type] :
      ( v1609(VarCurr)
    <=> v1611(VarCurr,0) ) ).

tff(addAssignment_601,axiom,
    ! [VarCurr: state_type] :
      ( v1611(VarCurr,0)
    <=> v1613(VarCurr,0) ) ).

tff(addAssignment_600,axiom,
    ! [VarNext: state_type] :
      ( v1613(VarNext,0)
    <=> v1650(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_11,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1651(VarNext)
       => ! [B: $int] :
            ( ( $less(B,2)
              & ~ $less(B,0) )
           => ( v1650(VarNext,B)
            <=> v1613(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_11,axiom,
    ! [VarNext: state_type] :
      ( v1651(VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1650(VarNext,B)
          <=> v1661(VarNext,B) ) ) ) ).

tff(addAssignment_599,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1661(VarNext,B)
          <=> v1659(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_15,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1662(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1659(VarCurr,B)
          <=> bxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_15,axiom,
    ! [VarCurr: state_type] :
      ( v1662(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,2)
            & ~ $less(B,0) )
         => ( v1659(VarCurr,B)
          <=> v1623(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_110,axiom,
    ! [VarCurr: state_type] :
      ( v1662(VarCurr)
    <=> ( v1663(VarCurr)
        & v1664(VarCurr) ) ) ).

tff(writeUnaryOperator_93,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1664(VarCurr)
    <=> v1619(VarCurr) ) ).

tff(writeUnaryOperator_92,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1663(VarCurr)
    <=> v1615(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_109,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1651(VarNext)
      <=> v1652(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_108,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1652(VarNext)
      <=> ( v1653(VarNext)
          & v1646(VarNext) ) ) ) ).

tff(writeUnaryOperator_91,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1653(VarNext)
      <=> v1655(VarNext) ) ) ).

tff(addAssignment_598,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1655(VarNext)
      <=> v1646(VarCurr) ) ) ).

tff(addAssignment_597,axiom,
    ! [VarCurr: state_type] :
      ( v1646(VarCurr)
    <=> v1648(VarCurr) ) ).

tff(addAssignment_596,axiom,
    ! [VarCurr: state_type] :
      ( v1648(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_595,axiom,
    ! [VarCurr: state_type] :
      ( v1623(VarCurr,0)
    <=> v1625(VarCurr,0) ) ).

tff(addAssignment_594,axiom,
    ! [VarCurr: state_type] :
      ( v1625(VarCurr,0)
    <=> v1627(VarCurr,0) ) ).

tff(addAssignment_593,axiom,
    ! [VarCurr: state_type] :
      ( v1627(VarCurr,0)
    <=> v1642(VarCurr,0) ) ).

tff(addAssignment_592,axiom,
    ! [VarCurr: state_type] :
      ( v1642(VarCurr,0)
    <=> v1629(VarCurr) ) ).

tff(addAssignment_591,axiom,
    ! [VarCurr: state_type] :
      ( v1642(VarCurr,1)
    <=> v1643(VarCurr) ) ).

tff(addAssignment_590,axiom,
    ! [VarCurr: state_type] :
      ( v1629(VarCurr)
    <=> v1631(VarCurr) ) ).

tff(addAssignment_589,axiom,
    ! [VarCurr: state_type] :
      ( v1631(VarCurr)
    <=> v1633(VarCurr) ) ).

tff(addAssignment_588,axiom,
    ! [VarCurr: state_type] :
      ( v1633(VarCurr)
    <=> v1635(VarCurr) ) ).

tff(addAssignment_587,axiom,
    ! [VarCurr: state_type] :
      ( v1635(VarCurr)
    <=> v1637(VarCurr) ) ).

tff(addAssignment_586,axiom,
    ! [VarCurr: state_type] :
      ( v1637(VarCurr)
    <=> v1639(VarCurr) ) ).

tff(addAssignment_585,axiom,
    ! [VarCurr: state_type] :
      ( v1639(VarCurr)
    <=> v1641(VarCurr) ) ).

tff(addAssignment_584,axiom,
    ! [VarCurr: state_type] :
      ( v1619(VarCurr)
    <=> v1621(VarCurr) ) ).

tff(addAssignment_583,axiom,
    ! [VarCurr: state_type] :
      ( v1621(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_582,axiom,
    ! [VarCurr: state_type] :
      ( v1615(VarCurr)
    <=> v1617(VarCurr) ) ).

tff(addAssignment_581,axiom,
    ! [VarCurr: state_type] :
      ( v1617(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_580,axiom,
    ! [VarCurr: state_type] :
      ( v1169(VarCurr,0)
    <=> v1171(VarCurr,0) ) ).

tff(addAssignment_579,axiom,
    ! [VarCurr: state_type] :
      ( v1171(VarCurr,0)
    <=> v1173(VarCurr,0) ) ).

tff(addAssignment_578,axiom,
    ! [VarCurr: state_type] :
      ( v1173(VarCurr,0)
    <=> v1175(VarCurr,0) ) ).

tff(addAssignment_577,axiom,
    ! [VarNext: state_type] :
      ( v1175(VarNext,0)
    <=> v1589(VarNext,0) ) ).

tff(addCaseBooleanConditionEqualRanges1_10,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1590(VarNext)
       => ! [B: $int] :
            ( ( $less(B,64)
              & ~ $less(B,0) )
           => ( v1589(VarNext,B)
            <=> v1175(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_10,axiom,
    ! [VarNext: state_type] :
      ( v1590(VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1589(VarNext,B)
          <=> v1600(VarNext,B) ) ) ) ).

tff(addAssignment_576,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1600(VarNext,B)
          <=> v1598(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_14,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1598(VarCurr,B)
          <=> bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_14,axiom,
    ! [VarCurr: state_type] :
      ( v1601(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,64)
            & ~ $less(B,0) )
         => ( v1598(VarCurr,B)
          <=> v1185(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_107,axiom,
    ! [VarCurr: state_type] :
      ( v1601(VarCurr)
    <=> ( v1602(VarCurr)
        & v1603(VarCurr) ) ) ).

tff(writeUnaryOperator_90,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1603(VarCurr)
    <=> v1181(VarCurr) ) ).

tff(writeUnaryOperator_89,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1602(VarCurr)
    <=> v1177(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_106,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1590(VarNext)
      <=> v1591(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_105,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1591(VarNext)
      <=> ( v1592(VarNext)
          & v1214(VarNext) ) ) ) ).

tff(writeUnaryOperator_88,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1592(VarNext)
      <=> v1594(VarNext) ) ) ).

tff(addAssignment_575,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1594(VarNext)
      <=> v1214(VarCurr) ) ) ).

tff(addAssignment_574,axiom,
    ! [VarCurr: state_type] :
      ( v1214(VarCurr)
    <=> v1216(VarCurr) ) ).

tff(addAssignment_573,axiom,
    ! [VarCurr: state_type] :
      ( v1216(VarCurr)
    <=> v1218(VarCurr) ) ).

tff(addAssignment_572,axiom,
    ! [VarCurr: state_type] :
      ( v1218(VarCurr)
    <=> v1220(VarCurr) ) ).

tff(addAssignment_571,axiom,
    ! [VarCurr: state_type] :
      ( v1220(VarCurr)
    <=> v1222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_104,axiom,
    ! [VarCurr: state_type] :
      ( v1222(VarCurr)
    <=> ( v1587(VarCurr)
        | v1579(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_103,axiom,
    ! [VarCurr: state_type] :
      ( v1587(VarCurr)
    <=> ( v1224(VarCurr)
        & v1530(VarCurr) ) ) ).

tff(addAssignment_570,axiom,
    ! [VarCurr: state_type] :
      ( v1579(VarCurr)
    <=> v1581(VarCurr) ) ).

tff(addAssignment_569,axiom,
    ! [VarCurr: state_type] :
      ( v1581(VarCurr)
    <=> v1583(VarCurr) ) ).

tff(addAssignment_568,axiom,
    ! [VarCurr: state_type] :
      ( v1583(VarCurr)
    <=> v1585(VarCurr) ) ).

tff(addAssignment_567,axiom,
    ! [VarCurr: state_type] :
      ( v1585(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_9,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1563(VarNext)
       => ( v1530(VarNext)
        <=> v1530(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_9,axiom,
    ! [VarNext: state_type] :
      ( v1563(VarNext)
     => ( v1530(VarNext)
      <=> v1573(VarNext) ) ) ).

tff(addAssignment_566,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1573(VarNext)
      <=> v1571(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_102,axiom,
    ! [VarCurr: state_type] :
      ( v1571(VarCurr)
    <=> ( v1574(VarCurr)
        & v1575(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_101,axiom,
    ! [VarCurr: state_type] :
      ( v1575(VarCurr)
    <=> ( v1536(VarCurr)
        | v1540(VarCurr) ) ) ).

tff(writeUnaryOperator_87,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1574(VarCurr)
    <=> v1532(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_100,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1563(VarNext)
      <=> v1564(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_99,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1564(VarNext)
      <=> ( v1566(VarNext)
          & v1568(VarNext) ) ) ) ).

tff(writeUnaryOperator_86,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1568(VarCurr)
    <=> v1224(VarCurr) ) ).

tff(addAssignment_565,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v1566(VarNext)
      <=> v1224(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_6,axiom,
    ( v1530(constB0)
  <=> $true ) ).

tff(addAssignment_564,axiom,
    ! [VarCurr: state_type] :
      ( v1540(VarCurr)
    <=> v1542(VarCurr) ) ).

tff(addAssignment_563,axiom,
    ! [VarCurr: state_type] :
      ( v1542(VarCurr)
    <=> v1544(VarCurr) ) ).

tff(addAssignment_562,axiom,
    ! [VarCurr: state_type] :
      ( v1544(VarCurr)
    <=> v1546(VarCurr) ) ).

tff(addAssignment_561,axiom,
    ! [VarCurr: state_type] :
      ( v1546(VarCurr)
    <=> v1548(VarCurr) ) ).

tff(addAssignment_560,axiom,
    ! [VarCurr: state_type] :
      ( v1548(VarCurr)
    <=> v1550(VarCurr) ) ).

tff(addAssignment_559,axiom,
    ! [VarCurr: state_type] :
      ( v1550(VarCurr)
    <=> v1552(VarCurr) ) ).

tff(addAssignment_558,axiom,
    ! [VarCurr: state_type] :
      ( v1552(VarCurr)
    <=> v1554(VarCurr) ) ).

tff(addAssignment_557,axiom,
    ! [VarCurr: state_type] :
      ( v1554(VarCurr)
    <=> v1556(VarCurr) ) ).

tff(addAssignment_556,axiom,
    ! [VarCurr: state_type] :
      ( v1556(VarCurr)
    <=> v1558(VarCurr) ) ).

tff(addAssignment_555,axiom,
    ! [VarCurr: state_type] :
      ( v1558(VarCurr)
    <=> v1560(VarCurr) ) ).

tff(addAssignment_554,axiom,
    ! [VarCurr: state_type] :
      ( v1560(VarCurr)
    <=> v692(VarCurr) ) ).

tff(addAssignment_553,axiom,
    ! [VarCurr: state_type] :
      ( v1536(VarCurr)
    <=> v1538(VarCurr) ) ).

tff(addAssignment_552,axiom,
    ! [VarCurr: state_type] :
      ( v1538(VarCurr)
    <=> $true ) ).

tff(addAssignment_551,axiom,
    ! [VarCurr: state_type] :
      ( v1532(VarCurr)
    <=> v1534(VarCurr) ) ).

tff(addAssignment_550,axiom,
    ! [VarCurr: state_type] :
      ( v1534(VarCurr)
    <=> $false ) ).

tff(addAssignment_549,axiom,
    ! [VarCurr: state_type] :
      ( v1224(VarCurr)
    <=> v1226(VarCurr) ) ).

tff(addAssignment_548,axiom,
    ! [VarCurr: state_type] :
      ( v1226(VarCurr)
    <=> v1228(VarCurr) ) ).

tff(addAssignment_547,axiom,
    ! [VarCurr: state_type] :
      ( v1228(VarCurr)
    <=> v1230(VarCurr) ) ).

tff(addAssignment_546,axiom,
    ! [VarCurr: state_type] :
      ( v1230(VarCurr)
    <=> v1232(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_13,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1522(VarCurr)
     => ( v1232(VarCurr)
      <=> x1520(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_13,axiom,
    ! [VarCurr: state_type] :
      ( v1522(VarCurr)
     => ( v1232(VarCurr)
      <=> v1234(VarCurr) ) ) ).

tff(writeUnaryOperator_85,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1522(VarCurr)
    <=> v1524(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_98,axiom,
    ! [VarCurr: state_type] :
      ( v1524(VarCurr)
    <=> ( v1525(VarCurr)
        & v1528(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_97,axiom,
    ! [VarCurr: state_type] :
      ( v1528(VarCurr)
    <=> ( v1234(VarCurr)
        | v1515(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_96,axiom,
    ! [VarCurr: state_type] :
      ( v1525(VarCurr)
    <=> ( v1526(VarCurr)
        | v1527(VarCurr) ) ) ).

tff(writeUnaryOperator_84,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1527(VarCurr)
    <=> v1515(VarCurr) ) ).

tff(writeUnaryOperator_83,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1526(VarCurr)
    <=> v1234(VarCurr) ) ).

tff(addAssignment_545,axiom,
    ! [VarCurr: state_type] :
      ( v1515(VarCurr)
    <=> v1517(VarCurr) ) ).

tff(addAssignment_544,axiom,
    ! [VarCurr: state_type] :
      ( v1517(VarCurr)
    <=> v1519(VarCurr) ) ).

tff(addAssignment_543,axiom,
    ! [VarCurr: state_type] :
      ( v1519(VarCurr)
    <=> v1240(VarCurr) ) ).

tff(addAssignment_542,axiom,
    ! [VarCurr: state_type] :
      ( v1234(VarCurr)
    <=> v1236(VarCurr) ) ).

tff(addAssignment_541,axiom,
    ! [VarCurr: state_type] :
      ( v1236(VarCurr)
    <=> v1238(VarCurr) ) ).

tff(addAssignment_540,axiom,
    ! [VarCurr: state_type] :
      ( v1238(VarCurr)
    <=> v1240(VarCurr) ) ).

tff(addAssignment_539,axiom,
    ! [VarCurr: state_type] :
      ( v1240(VarCurr)
    <=> v1242(VarCurr) ) ).

tff(addAssignment_538,axiom,
    ! [VarCurr: state_type] :
      ( v1242(VarCurr)
    <=> v1244(VarCurr) ) ).

tff(writeUnaryOperator_82,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1244(VarCurr)
    <=> v1246(VarCurr) ) ).

tff(addAssignment_537,axiom,
    ! [VarCurr: state_type] :
      ( v1246(VarCurr)
    <=> v1248(VarCurr) ) ).

tff(addAssignment_536,axiom,
    ! [VarCurr: state_type] :
      ( v1248(VarCurr)
    <=> v1250(VarCurr) ) ).

tff(writeUnaryOperator_81,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1250(VarCurr)
    <=> v1512(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_95,axiom,
    ! [VarCurr: state_type] :
      ( v1512(VarCurr)
    <=> ( v1252(VarCurr)
        & v1506(VarCurr) ) ) ).

tff(addAssignment_535,axiom,
    ! [VarCurr: state_type] :
      ( v1506(VarCurr)
    <=> v1508(VarCurr) ) ).

tff(addAssignment_534,axiom,
    ! [VarCurr: state_type] :
      ( v1508(VarCurr)
    <=> v1510(VarCurr) ) ).

tff(addAssignment_533,axiom,
    ! [VarCurr: state_type] :
      ( v1510(VarCurr)
    <=> $true ) ).

tff(addAssignment_532,axiom,
    ! [VarCurr: state_type] :
      ( v1252(VarCurr)
    <=> v1254(VarCurr) ) ).

tff(addAssignment_531,axiom,
    ! [VarCurr: state_type] :
      ( v1254(VarCurr)
    <=> v1256(VarCurr) ) ).

tff(addAssignment_530,axiom,
    ! [VarCurr: state_type] :
      ( v1256(VarCurr)
    <=> v1258(VarCurr) ) ).

tff(writeUnaryOperator_80,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1258(VarCurr)
    <=> v1260(VarCurr) ) ).

tff(addAssignment_529,axiom,
    ! [VarCurr: state_type] :
      ( v1260(VarCurr)
    <=> v1262(VarCurr) ) ).

tff(addAssignment_528,axiom,
    ! [VarCurr: state_type] :
      ( v1262(VarCurr)
    <=> v1264(VarCurr) ) ).

tff(writeUnaryOperator_79,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1264(VarCurr)
    <=> v1503(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_94,axiom,
    ! [VarCurr: state_type] :
      ( v1503(VarCurr)
    <=> ( v1266(VarCurr)
        & v1501(VarCurr) ) ) ).

tff(addAssignment_527,axiom,
    ! [VarCurr: state_type] :
      ( v1501(VarCurr)
    <=> v1290(VarCurr) ) ).

tff(addAssignment_526,axiom,
    ! [VarCurr: state_type] :
      ( v1266(VarCurr)
    <=> v1268(VarCurr) ) ).

tff(addAssignment_525,axiom,
    ! [VarCurr: state_type] :
      ( v1268(VarCurr)
    <=> v1270(VarCurr) ) ).

tff(writeUnaryOperator_78,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1270(VarCurr)
    <=> v1272(VarCurr) ) ).

tff(addAssignment_524,axiom,
    ! [VarCurr: state_type] :
      ( v1272(VarCurr)
    <=> v1274(VarCurr) ) ).

tff(addAssignment_523,axiom,
    ! [VarCurr: state_type] :
      ( v1274(VarCurr)
    <=> v1276(VarCurr) ) ).

tff(writeUnaryOperator_77,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1276(VarCurr)
    <=> v1498(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_93,axiom,
    ! [VarCurr: state_type] :
      ( v1498(VarCurr)
    <=> ( v1278(VarCurr)
        | v1490(VarCurr) ) ) ).

tff(addAssignment_522,axiom,
    ! [VarCurr: state_type] :
      ( v1490(VarCurr)
    <=> v1492(VarCurr) ) ).

tff(addAssignment_521,axiom,
    ! [VarCurr: state_type] :
      ( v1492(VarCurr)
    <=> v1494(VarCurr) ) ).

tff(addAssignment_520,axiom,
    ! [VarCurr: state_type] :
      ( v1494(VarCurr)
    <=> v1496(VarCurr) ) ).

tff(addAssignment_519,axiom,
    ! [VarCurr: state_type] :
      ( v1496(VarCurr)
    <=> v626(VarCurr) ) ).

tff(addAssignment_518,axiom,
    ! [VarCurr: state_type] :
      ( v1278(VarCurr)
    <=> v1280(VarCurr) ) ).

tff(addAssignment_517,axiom,
    ! [VarCurr: state_type] :
      ( v1280(VarCurr)
    <=> v1282(VarCurr) ) ).

tff(addAssignment_516,axiom,
    ! [VarCurr: state_type] :
      ( v1282(VarCurr)
    <=> v1284(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_12,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1473(VarNext)
       => ( v1284(VarNext)
        <=> v1284(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_12,axiom,
    ! [VarNext: state_type] :
      ( v1473(VarNext)
     => ( v1284(VarNext)
      <=> v1483(VarNext) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_8,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v1474(VarCurr)
        & v1475(VarCurr) )
     => ( v1483(VarCurr)
      <=> v1484(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_8,axiom,
    ! [VarCurr: state_type] :
      ( v1474(VarCurr)
     => ( v1483(VarCurr)
      <=> v1455(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_6,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1476(VarCurr)
       => ( v1484(VarCurr)
        <=> x464(VarNext) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_6,axiom,
    ! [VarCurr: state_type] :
      ( v1476(VarCurr)
     => ( v1484(VarCurr)
      <=> v1457(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_92,axiom,
    ! [VarCurr: state_type] :
      ( v1473(VarCurr)
    <=> ( v1474(VarCurr)
        | v1475(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_91,axiom,
    ! [VarCurr: state_type] :
      ( v1475(VarCurr)
    <=> ( v1476(VarCurr)
        | v1479(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_90,axiom,
    ! [VarCurr: state_type] :
      ( v1479(VarCurr)
    <=> ( v1480(VarCurr)
        & v1482(VarCurr) ) ) ).

tff(writeUnaryOperator_76,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1482(VarCurr)
    <=> v1476(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_89,axiom,
    ! [VarCurr: state_type] :
      ( v1480(VarCurr)
    <=> ( v1286(VarCurr)
        & v1481(VarCurr) ) ) ).

tff(writeUnaryOperator_75,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1481(VarCurr)
    <=> v1288(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_88,axiom,
    ! [VarCurr: state_type] :
      ( v1476(VarCurr)
    <=> ( v1477(VarCurr)
        & v1478(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_6,axiom,
    ! [VarCurr: state_type] :
      ( v1478(VarCurr)
    <=> ( v1288(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_5,axiom,
    ! [VarCurr: state_type] :
      ( v1477(VarCurr)
    <=> ( v1286(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_87,axiom,
    ! [VarCurr: state_type] :
      ( v1474(VarCurr)
    <=> ( v1286(VarCurr)
        & v1288(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_5,axiom,
    ( v1284(constB0)
  <=> $true ) ).

tff(addAssignment_515,axiom,
    ! [VarCurr: state_type] :
      ( v1457(VarCurr)
    <=> v1459(VarCurr) ) ).

tff(addAssignment_514,axiom,
    ! [VarCurr: state_type] :
      ( v1459(VarCurr)
    <=> v1461(VarCurr) ) ).

tff(addAssignment_513,axiom,
    ! [VarCurr: state_type] :
      ( v1461(VarCurr)
    <=> v1463(VarCurr) ) ).

tff(writeUnaryOperator_74,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1463(VarCurr)
    <=> v1465(VarCurr) ) ).

tff(addAssignment_512,axiom,
    ! [VarCurr: state_type] :
      ( v1465(VarCurr)
    <=> v1467(VarCurr) ) ).

tff(addAssignment_511,axiom,
    ! [VarCurr: state_type] :
      ( v1467(VarCurr)
    <=> v1469(VarCurr) ) ).

tff(addAssignmentInitValueVector_4,axiom,
    ( v1469(constB0)
  <=> $false ) ).

tff(addAssignment_510,axiom,
    ! [VarCurr: state_type] :
      ( v1455(VarCurr)
    <=> $false ) ).

tff(addAssignment_509,axiom,
    ! [VarCurr: state_type] :
      ( v1288(VarCurr)
    <=> v1290(VarCurr) ) ).

tff(addAssignment_508,axiom,
    ! [VarCurr: state_type] :
      ( v1290(VarCurr)
    <=> v1292(VarCurr) ) ).

tff(addAssignment_507,axiom,
    ! [VarCurr: state_type] :
      ( v1292(VarCurr)
    <=> v1294(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_86,axiom,
    ! [VarCurr: state_type] :
      ( v1294(VarCurr)
    <=> ( v1452(VarCurr)
        | v1453(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_85,axiom,
    ! [VarCurr: state_type] :
      ( v1453(VarCurr)
    <=> ( v1448(VarCurr)
        & v1450(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_84,axiom,
    ! [VarCurr: state_type] :
      ( v1452(VarCurr)
    <=> ( v1296(VarCurr)
        & v1330(VarCurr) ) ) ).

tff(addAssignment_506,axiom,
    ! [VarCurr: state_type] :
      ( v1450(VarCurr)
    <=> v1380(VarCurr) ) ).

tff(addAssignment_505,axiom,
    ! [VarCurr: state_type] :
      ( v1448(VarCurr)
    <=> v1354(VarCurr) ) ).

tff(addAssignment_504,axiom,
    ! [VarCurr: state_type] :
      ( v1330(VarCurr)
    <=> v1332(VarCurr) ) ).

tff(addAssignment_503,axiom,
    ! [VarCurr: state_type] :
      ( v1332(VarCurr)
    <=> v1334(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_11,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v1426(VarNext)
       => ( v1334(VarNext)
        <=> v1334(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_11,axiom,
    ! [VarNext: state_type] :
      ( v1426(VarNext)
     => ( v1334(VarNext)
      <=> v1441(VarNext) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_5,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1427(VarCurr)
     => ( v1441(VarCurr)
      <=> v1442(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_5,axiom,
    ! [VarCurr: state_type] :
      ( v1427(VarCurr)
     => ( v1441(VarCurr)
      <=> v1391(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_4,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1433(VarCurr)
     => ( v1442(VarCurr)
      <=> v1395(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_4,axiom,
    ! [VarCurr: state_type] :
      ( v1433(VarCurr)
     => ( v1442(VarCurr)
      <=> v1393(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_83,axiom,
    ! [VarCurr: state_type] :
      ( v1426(VarCurr)
    <=> ( v1427(VarCurr)
        | v1431(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_82,axiom,
    ! [VarCurr: state_type] :
      ( v1431(VarCurr)
    <=> ( v1432(VarCurr)
        & v1440(VarCurr) ) ) ).

tff(writeUnaryOperator_73,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1440(VarCurr)
    <=> v1427(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_81,axiom,
    ! [VarCurr: state_type] :
      ( v1432(VarCurr)
    <=> ( v1433(VarCurr)
        | v1436(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_80,axiom,
    ! [VarCurr: state_type] :
      ( v1436(VarCurr)
    <=> ( v1437(VarCurr)
        & v1439(VarCurr) ) ) ).

tff(writeUnaryOperator_72,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1439(VarCurr)
    <=> v1433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_79,axiom,
    ! [VarCurr: state_type] :
      ( v1437(VarCurr)
    <=> ( v1438(VarCurr)
        & v1340(VarCurr) ) ) ).

tff(writeUnaryOperator_71,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1438(VarCurr)
    <=> v1338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_78,axiom,
    ! [VarCurr: state_type] :
      ( v1433(VarCurr)
    <=> ( v1434(VarCurr)
        & v1340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_77,axiom,
    ! [VarCurr: state_type] :
      ( v1434(VarCurr)
    <=> ( v1336(VarCurr)
        & v1435(VarCurr) ) ) ).

tff(writeUnaryOperator_70,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1435(VarCurr)
    <=> v1338(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_76,axiom,
    ! [VarCurr: state_type] :
      ( v1427(VarCurr)
    <=> ( v1428(VarCurr)
        & v1389(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_75,axiom,
    ! [VarCurr: state_type] :
      ( v1428(VarCurr)
    <=> ( v1429(VarCurr)
        & v1340(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_74,axiom,
    ! [VarCurr: state_type] :
      ( v1429(VarCurr)
    <=> ( v1336(VarCurr)
        & v1430(VarCurr) ) ) ).

tff(writeUnaryOperator_69,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1430(VarCurr)
    <=> v1338(VarCurr) ) ).

tff(addAssignment_502,axiom,
    ! [VarCurr: state_type] :
      ( v1395(VarCurr)
    <=> v1397(VarCurr) ) ).

tff(addAssignment_501,axiom,
    ! [VarCurr: state_type] :
      ( v1397(VarCurr)
    <=> v1399(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_73,axiom,
    ! [VarCurr: state_type] :
      ( v1399(VarCurr)
    <=> ( v1422(VarCurr)
        | v1423(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_72,axiom,
    ! [VarCurr: state_type] :
      ( v1423(VarCurr)
    <=> ( v1418(VarCurr)
        & v1420(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_71,axiom,
    ! [VarCurr: state_type] :
      ( v1422(VarCurr)
    <=> ( v1401(VarCurr)
        & v1404(VarCurr) ) ) ).

tff(addAssignment_500,axiom,
    ! [VarCurr: state_type] :
      ( v1420(VarCurr)
    <=> v1292(VarCurr) ) ).

tff(addAssignment_499,axiom,
    ! [VarCurr: state_type] :
      ( v1418(VarCurr)
    <=> v1354(VarCurr) ) ).

tff(addAssignment_498,axiom,
    ! [VarCurr: state_type] :
      ( v1404(VarCurr)
    <=> v1406(VarCurr) ) ).

tff(addAssignment_497,axiom,
    ! [VarCurr: state_type] :
      ( v1406(VarCurr)
    <=> v1408(VarCurr) ) ).

tff(addAssignment_496,axiom,
    ! [VarCurr: state_type] :
      ( v1408(VarCurr)
    <=> v1410(VarCurr) ) ).

tff(addAssignment_495,axiom,
    ! [VarCurr: state_type] :
      ( v1410(VarCurr)
    <=> v1412(VarCurr) ) ).

tff(addAssignment_494,axiom,
    ! [VarCurr: state_type] :
      ( v1412(VarCurr)
    <=> v1414(VarCurr) ) ).

tff(addAssignment_493,axiom,
    ! [VarCurr: state_type] :
      ( v1414(VarCurr)
    <=> v1416(VarCurr) ) ).

tff(writeUnaryOperator_68,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1401(VarCurr)
    <=> v1354(VarCurr) ) ).

tff(addAssignment_492,axiom,
    ! [VarCurr: state_type] :
      ( v1391(VarCurr)
    <=> $false ) ).

tff(addAssignment_491,axiom,
    ! [VarCurr: state_type] :
      ( v1389(VarCurr)
    <=> $false ) ).

tff(addAssignment_490,axiom,
    ! [VarCurr: state_type] :
      ( v1340(VarCurr)
    <=> v1342(VarCurr) ) ).

tff(addAssignment_489,axiom,
    ! [VarCurr: state_type] :
      ( v1342(VarCurr)
    <=> v1344(VarCurr) ) ).

tff(writeUnaryOperator_67,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1344(VarCurr)
    <=> v1346(VarCurr) ) ).

tff(addAssignment_488,axiom,
    ! [VarCurr: state_type] :
      ( v1346(VarCurr)
    <=> v1348(VarCurr) ) ).

tff(addAssignment_487,axiom,
    ! [VarCurr: state_type] :
      ( v1348(VarCurr)
    <=> v1350(VarCurr) ) ).

tff(writeUnaryOperator_66,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1350(VarCurr)
    <=> v1386(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_70,axiom,
    ! [VarCurr: state_type] :
      ( v1386(VarCurr)
    <=> ( v1352(VarCurr)
        | v1378(VarCurr) ) ) ).

tff(addAssignment_486,axiom,
    ! [VarCurr: state_type] :
      ( v1378(VarCurr)
    <=> v1380(VarCurr) ) ).

tff(addAssignment_485,axiom,
    ! [VarCurr: state_type] :
      ( v1380(VarCurr)
    <=> v1382(VarCurr) ) ).

tff(addAssignment_484,axiom,
    ! [VarCurr: state_type] :
      ( v1382(VarCurr)
    <=> v1384(VarCurr) ) ).

tff(addAssignment_483,axiom,
    ! [VarCurr: state_type] :
      ( v1352(VarCurr)
    <=> v1354(VarCurr) ) ).

tff(addAssignment_482,axiom,
    ! [VarCurr: state_type] :
      ( v1354(VarCurr)
    <=> v1356(VarCurr) ) ).

tff(writeUnaryOperator_65,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1356(VarCurr)
    <=> v1358(VarCurr) ) ).

tff(addAssignment_481,axiom,
    ! [VarCurr: state_type] :
      ( v1358(VarCurr)
    <=> v1360(VarCurr) ) ).

tff(addAssignment_480,axiom,
    ! [VarCurr: state_type] :
      ( v1360(VarCurr)
    <=> v1362(VarCurr) ) ).

tff(writeUnaryOperator_64,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1362(VarCurr)
    <=> v1375(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_69,axiom,
    ! [VarCurr: state_type] :
      ( v1375(VarCurr)
    <=> ( v1364(VarCurr)
        | v1373(VarCurr) ) ) ).

tff(addAssignment_479,axiom,
    ! [VarCurr: state_type] :
      ( v1373(VarCurr)
    <=> v1316(VarCurr) ) ).

tff(addAssignment_478,axiom,
    ! [VarCurr: state_type] :
      ( v1364(VarCurr)
    <=> v1366(VarCurr) ) ).

tff(addAssignment_477,axiom,
    ! [VarCurr: state_type] :
      ( v1366(VarCurr)
    <=> v1368(VarCurr) ) ).

tff(writeUnaryOperator_63,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1368(VarCurr)
    <=> v1370(VarCurr) ) ).

tff(addAssignment_476,axiom,
    ! [VarCurr: state_type] :
      ( v1370(VarCurr)
    <=> v1323(VarCurr) ) ).

tff(addAssignment_475,axiom,
    ! [VarCurr: state_type] :
      ( v1338(VarCurr)
    <=> $false ) ).

tff(addAssignment_474,axiom,
    ! [VarCurr: state_type] :
      ( v1336(VarCurr)
    <=> $false ) ).

tff(addAssignment_473,axiom,
    ! [VarCurr: state_type] :
      ( v1296(VarCurr)
    <=> v1298(VarCurr) ) ).

tff(addAssignment_472,axiom,
    ! [VarCurr: state_type] :
      ( v1298(VarCurr)
    <=> v1300(VarCurr) ) ).

tff(writeUnaryOperator_62,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1300(VarCurr)
    <=> v1302(VarCurr) ) ).

tff(addAssignment_471,axiom,
    ! [VarCurr: state_type] :
      ( v1302(VarCurr)
    <=> v1304(VarCurr) ) ).

tff(addAssignment_470,axiom,
    ! [VarCurr: state_type] :
      ( v1304(VarCurr)
    <=> v1306(VarCurr) ) ).

tff(writeUnaryOperator_61,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1306(VarCurr)
    <=> v1327(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_68,axiom,
    ! [VarCurr: state_type] :
      ( v1327(VarCurr)
    <=> ( v1308(VarCurr)
        & v1321(VarCurr) ) ) ).

tff(addAssignment_469,axiom,
    ! [VarCurr: state_type] :
      ( v1321(VarCurr)
    <=> v1323(VarCurr) ) ).

tff(addAssignment_468,axiom,
    ! [VarCurr: state_type] :
      ( v1323(VarCurr)
    <=> v1325(VarCurr) ) ).

tff(addAssignment_467,axiom,
    ! [VarCurr: state_type] :
      ( v1325(VarCurr)
    <=> $false ) ).

tff(addAssignment_466,axiom,
    ! [VarCurr: state_type] :
      ( v1308(VarCurr)
    <=> v1310(VarCurr) ) ).

tff(addAssignment_465,axiom,
    ! [VarCurr: state_type] :
      ( v1310(VarCurr)
    <=> v1312(VarCurr) ) ).

tff(writeUnaryOperator_60,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1312(VarCurr)
    <=> v1314(VarCurr) ) ).

tff(addAssignment_464,axiom,
    ! [VarCurr: state_type] :
      ( v1314(VarCurr)
    <=> v1316(VarCurr) ) ).

tff(addAssignment_463,axiom,
    ! [VarCurr: state_type] :
      ( v1316(VarCurr)
    <=> v1318(VarCurr) ) ).

tff(addAssignment_462,axiom,
    ! [VarCurr: state_type] :
      ( v1318(VarCurr)
    <=> $false ) ).

tff(addAssignment_461,axiom,
    ! [VarCurr: state_type] :
      ( v1286(VarCurr)
    <=> $false ) ).

tff(addAssignment_460,axiom,
    ! [VarCurr: state_type] :
      ( v1185(VarCurr,0)
    <=> v1187(VarCurr,0) ) ).

tff(addAssignment_459,axiom,
    ! [VarCurr: state_type] :
      ( v1187(VarCurr,0)
    <=> v1204(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_5,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1204(VarCurr,B)
      <=> ( v1205(VarCurr,B)
          | v1208(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_4,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1208(VarCurr,B)
      <=> ( v1173(VarCurr,B)
          & v1209(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_59,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1209(VarCurr,B)
      <=> ~ v1210(VarCurr,B) ) ) ).

tff(addAssignment_458,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,0)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_457,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,1)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_456,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,2)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_455,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,3)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_454,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,4)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_453,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,5)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_452,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,6)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_451,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,7)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_450,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,8)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_449,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,9)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_448,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,10)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_447,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,11)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_446,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,12)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_445,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,13)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_444,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,14)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_443,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,15)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_442,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,16)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_441,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,17)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_440,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,18)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_439,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,19)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_438,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,20)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_437,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,21)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_436,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,22)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_435,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,23)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_434,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,24)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_433,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,25)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_432,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,26)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_431,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,27)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_430,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,28)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_429,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,29)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_428,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,30)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_427,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,31)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_426,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,32)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_425,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,33)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_424,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,34)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_423,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,35)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_422,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,36)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_421,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,37)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_420,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,38)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_419,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,39)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_418,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,40)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_417,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,41)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_416,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,42)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_415,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,43)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_414,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,44)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_413,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,45)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_412,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,46)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_411,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,47)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_410,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,48)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_409,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,49)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_408,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,50)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_407,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,51)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_406,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,52)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_405,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,53)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_404,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,54)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_403,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,55)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_402,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,56)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_401,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,57)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_400,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,58)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_399,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,59)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_398,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,60)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_397,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,61)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_396,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,62)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_395,axiom,
    ! [VarCurr: state_type] :
      ( v1210(VarCurr,63)
    <=> v1211(VarCurr) ) ).

tff(addAssignment_394,axiom,
    ! [VarCurr: state_type] :
      ( v1211(VarCurr)
    <=> v1197(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_3,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,64)
        & ~ $less(B,0) )
     => ( v1205(VarCurr,B)
      <=> ( v1189(VarCurr,B)
          & v1206(VarCurr,B) ) ) ) ).

tff(addAssignment_393,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,0)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_392,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,1)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_391,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,2)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_390,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,3)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_389,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,4)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_388,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,5)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_387,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,6)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_386,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,7)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_385,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,8)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_384,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,9)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_383,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,10)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_382,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,11)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_381,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,12)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_380,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,13)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_379,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,14)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_378,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,15)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_377,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,16)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_376,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,17)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_375,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,18)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_374,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,19)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_373,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,20)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_372,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,21)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_371,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,22)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_370,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,23)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_369,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,24)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_368,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,25)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_367,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,26)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_366,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,27)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_365,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,28)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_364,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,29)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_363,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,30)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_362,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,31)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_361,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,32)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_360,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,33)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_359,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,34)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_358,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,35)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_357,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,36)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_356,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,37)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_355,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,38)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_354,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,39)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_353,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,40)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_352,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,41)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_351,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,42)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_350,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,43)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_349,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,44)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_348,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,45)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_347,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,46)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_346,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,47)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_345,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,48)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_344,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,49)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_343,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,50)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_342,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,51)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_341,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,52)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_340,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,53)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_339,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,54)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_338,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,55)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_337,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,56)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_336,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,57)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_335,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,58)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_334,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,59)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_333,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,60)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_332,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,61)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_331,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,62)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_330,axiom,
    ! [VarCurr: state_type] :
      ( v1206(VarCurr,63)
    <=> v1207(VarCurr) ) ).

tff(addAssignment_329,axiom,
    ! [VarCurr: state_type] :
      ( v1207(VarCurr)
    <=> v1197(VarCurr) ) ).

tff(addAssignment_328,axiom,
    ! [VarCurr: state_type] :
      ( v1197(VarCurr)
    <=> v1199(VarCurr) ) ).

tff(addAssignment_327,axiom,
    ! [VarCurr: state_type] :
      ( v1199(VarCurr)
    <=> v1201(VarCurr,0) ) ).

tff(addAssignment_326,axiom,
    ! [VarCurr: state_type] :
      ( v1201(VarCurr,0)
    <=> v1203(VarCurr,0) ) ).

tff(addAssignment_325,axiom,
    ! [VarCurr: state_type] :
      ( v1189(VarCurr,0)
    <=> v1191(VarCurr,0) ) ).

tff(addAssignment_324,axiom,
    ! [VarCurr: state_type] :
      ( v1191(VarCurr,0)
    <=> v1193(VarCurr,0) ) ).

tff(addAssignment_323,axiom,
    ! [VarCurr: state_type] :
      ( v1193(VarCurr,0)
    <=> v1195(VarCurr,0) ) ).

tff(addAssignment_322,axiom,
    ! [VarCurr: state_type] :
      ( v1181(VarCurr)
    <=> v1183(VarCurr) ) ).

tff(addAssignment_321,axiom,
    ! [VarCurr: state_type] :
      ( v1183(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_320,axiom,
    ! [VarCurr: state_type] :
      ( v1177(VarCurr)
    <=> v1179(VarCurr) ) ).

tff(addAssignment_319,axiom,
    ! [VarCurr: state_type] :
      ( v1179(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_318,axiom,
    ! [VarCurr: state_type] :
      ( v1157(VarCurr)
    <=> v1159(VarCurr) ) ).

tff(addAssignment_317,axiom,
    ! [VarCurr: state_type] :
      ( v1159(VarCurr)
    <=> v1161(VarCurr) ) ).

tff(addAssignment_316,axiom,
    ! [VarCurr: state_type] :
      ( v1161(VarCurr)
    <=> v1163(VarCurr) ) ).

tff(addAssignment_315,axiom,
    ! [VarCurr: state_type] :
      ( v1163(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_314,axiom,
    ! [VarCurr: state_type] :
      ( v1149(VarCurr)
    <=> v1151(VarCurr) ) ).

tff(addAssignment_313,axiom,
    ! [VarCurr: state_type] :
      ( v1151(VarCurr)
    <=> v1153(VarCurr) ) ).

tff(addAssignment_312,axiom,
    ! [VarCurr: state_type] :
      ( v1153(VarCurr)
    <=> v1155(VarCurr) ) ).

tff(addAssignment_311,axiom,
    ! [VarCurr: state_type] :
      ( v1155(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_310,axiom,
    ! [VarCurr: state_type] :
      ( v1129(VarCurr)
    <=> v1131(VarCurr) ) ).

tff(addAssignment_309,axiom,
    ! [VarCurr: state_type] :
      ( v1131(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_308,axiom,
    ! [VarCurr: state_type] :
      ( v1125(VarCurr)
    <=> v1127(VarCurr) ) ).

tff(addAssignment_307,axiom,
    ! [VarCurr: state_type] :
      ( v1127(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_306,axiom,
    ! [VarCurr: state_type] :
      ( v1107(VarCurr)
    <=> v1109(VarCurr) ) ).

tff(addAssignment_305,axiom,
    ! [VarCurr: state_type] :
      ( v1109(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_304,axiom,
    ! [VarCurr: state_type] :
      ( v1057(VarCurr)
    <=> v1059(VarCurr) ) ).

tff(addAssignment_303,axiom,
    ! [VarCurr: state_type] :
      ( v1059(VarCurr)
    <=> v1061(VarCurr) ) ).

tff(addAssignment_302,axiom,
    ! [VarCurr: state_type] :
      ( v1061(VarCurr)
    <=> v1063(VarCurr) ) ).

tff(addAssignment_301,axiom,
    ! [VarCurr: state_type] :
      ( v1063(VarCurr)
    <=> v1065(VarCurr) ) ).

tff(addAssignment_300,axiom,
    ! [VarCurr: state_type] :
      ( v1065(VarCurr)
    <=> v1067(VarCurr) ) ).

tff(addAssignment_299,axiom,
    ! [VarCurr: state_type] :
      ( v1067(VarCurr)
    <=> v1069(VarCurr) ) ).

tff(writeUnaryOperator_58,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1069(VarCurr)
    <=> v1071(VarCurr) ) ).

tff(addAssignment_298,axiom,
    ! [VarCurr: state_type] :
      ( v1071(VarCurr)
    <=> v1073(VarCurr) ) ).

tff(addAssignment_297,axiom,
    ! [VarCurr: state_type] :
      ( v1073(VarCurr)
    <=> v1075(VarCurr) ) ).

tff(writeUnaryOperator_57,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1075(VarCurr)
    <=> v1104(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_67,axiom,
    ! [VarCurr: state_type] :
      ( v1104(VarCurr)
    <=> ( v1077(VarCurr)
        & v1089(VarCurr) ) ) ).

tff(addAssignment_296,axiom,
    ! [VarCurr: state_type] :
      ( v1089(VarCurr)
    <=> v1091(VarCurr) ) ).

tff(addAssignment_295,axiom,
    ! [VarCurr: state_type] :
      ( v1091(VarCurr)
    <=> v1093(VarCurr) ) ).

tff(writeUnaryOperator_56,axiom,
    ! [VarCurr: state_type] :
      ( ~ v1093(VarCurr)
    <=> v1095(VarCurr) ) ).

tff(addAssignment_294,axiom,
    ! [VarCurr: state_type] :
      ( v1095(VarCurr)
    <=> v1097(VarCurr) ) ).

tff(addAssignment_293,axiom,
    ! [VarCurr: state_type] :
      ( v1097(VarCurr)
    <=> v1099(VarCurr) ) ).

tff(addAssignment_292,axiom,
    ! [VarCurr: state_type] :
      ( v1099(VarCurr)
    <=> v1101(VarCurr) ) ).

tff(addAssignment_291,axiom,
    ! [VarCurr: state_type] :
      ( v1077(VarCurr)
    <=> v1079(VarCurr) ) ).

tff(addAssignment_290,axiom,
    ! [VarCurr: state_type] :
      ( v1079(VarCurr)
    <=> v1081(VarCurr) ) ).

tff(addAssignment_289,axiom,
    ! [VarCurr: state_type] :
      ( v1081(VarCurr)
    <=> v1083(VarCurr) ) ).

tff(addAssignment_288,axiom,
    ! [VarCurr: state_type] :
      ( v1083(VarCurr)
    <=> v1085(VarCurr) ) ).

tff(addAssignment_287,axiom,
    ! [VarCurr: state_type] :
      ( v1085(VarCurr)
    <=> v1087(VarCurr) ) ).

tff(addAssignment_286,axiom,
    ! [VarCurr: state_type] :
      ( v1087(VarCurr)
    <=> v36(VarCurr) ) ).

tff(addAssignment_285,axiom,
    ! [VarCurr: state_type] :
      ( v1035(VarCurr)
    <=> v1037(VarCurr) ) ).

tff(addAssignment_284,axiom,
    ! [VarCurr: state_type] :
      ( v1037(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_283,axiom,
    ! [VarCurr: state_type] :
      ( v1031(VarCurr)
    <=> v1033(VarCurr) ) ).

tff(addAssignment_282,axiom,
    ! [VarCurr: state_type] :
      ( v1033(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_281,axiom,
    ! [VarCurr: state_type] :
      ( v1013(VarCurr)
    <=> v1015(VarCurr) ) ).

tff(addAssignment_280,axiom,
    ! [VarCurr: state_type] :
      ( v1015(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_279,axiom,
    ! [VarCurr: state_type] :
      ( v1009(VarCurr)
    <=> v1011(VarCurr) ) ).

tff(addAssignment_278,axiom,
    ! [VarCurr: state_type] :
      ( v1011(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_277,axiom,
    ! [VarCurr: state_type] :
      ( v982(VarCurr)
    <=> v984(VarCurr) ) ).

tff(addAssignment_276,axiom,
    ! [VarCurr: state_type] :
      ( v984(VarCurr)
    <=> v986(VarCurr) ) ).

tff(addAssignment_275,axiom,
    ! [VarCurr: state_type] :
      ( v986(VarCurr)
    <=> v988(VarCurr) ) ).

tff(addAssignment_274,axiom,
    ! [VarCurr: state_type] :
      ( v988(VarCurr)
    <=> v930(VarCurr) ) ).

tff(addAssignment_273,axiom,
    ! [VarCurr: state_type] :
      ( v974(VarCurr)
    <=> v976(VarCurr) ) ).

tff(addAssignment_272,axiom,
    ! [VarCurr: state_type] :
      ( v976(VarCurr)
    <=> v978(VarCurr) ) ).

tff(addAssignment_271,axiom,
    ! [VarCurr: state_type] :
      ( v978(VarCurr)
    <=> v980(VarCurr) ) ).

tff(addAssignment_270,axiom,
    ! [VarCurr: state_type] :
      ( v980(VarCurr)
    <=> v922(VarCurr) ) ).

tff(addAssignment_269,axiom,
    ! [VarCurr: state_type] :
      ( v950(VarCurr)
    <=> v952(VarCurr) ) ).

tff(addAssignment_268,axiom,
    ! [VarCurr: state_type] :
      ( v952(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_267,axiom,
    ! [VarCurr: state_type] :
      ( v946(VarCurr)
    <=> v948(VarCurr) ) ).

tff(addAssignment_266,axiom,
    ! [VarCurr: state_type] :
      ( v948(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_265,axiom,
    ! [VarCurr: state_type] :
      ( v924(VarCurr)
    <=> v926(VarCurr) ) ).

tff(addAssignment_264,axiom,
    ! [VarCurr: state_type] :
      ( v926(VarCurr)
    <=> v928(VarCurr) ) ).

tff(addAssignment_263,axiom,
    ! [VarCurr: state_type] :
      ( v928(VarCurr)
    <=> v930(VarCurr) ) ).

tff(addAssignment_262,axiom,
    ! [VarCurr: state_type] :
      ( v930(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_261,axiom,
    ! [VarCurr: state_type] :
      ( v916(VarCurr)
    <=> v918(VarCurr) ) ).

tff(addAssignment_260,axiom,
    ! [VarCurr: state_type] :
      ( v918(VarCurr)
    <=> v920(VarCurr) ) ).

tff(addAssignment_259,axiom,
    ! [VarCurr: state_type] :
      ( v920(VarCurr)
    <=> v922(VarCurr) ) ).

tff(addAssignment_258,axiom,
    ! [VarCurr: state_type] :
      ( v922(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_257,axiom,
    ! [VarCurr: state_type] :
      ( v894(VarCurr)
    <=> v896(VarCurr) ) ).

tff(addAssignment_256,axiom,
    ! [VarCurr: state_type] :
      ( v896(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_255,axiom,
    ! [VarCurr: state_type] :
      ( v890(VarCurr)
    <=> v892(VarCurr) ) ).

tff(addAssignment_254,axiom,
    ! [VarCurr: state_type] :
      ( v892(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_253,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v785(VarCurr,B)
      <=> v787(VarCurr,B) ) ) ).

tff(addAssignment_252,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v787(VarCurr,B)
      <=> v789(VarCurr,B) ) ) ).

tff(addAssignment_251,axiom,
    ! [VarNext: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v789(VarNext,B)
      <=> v866(VarNext,B) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_7,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v867(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v866(VarNext,B)
            <=> v789(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_7,axiom,
    ! [VarNext: state_type] :
      ( v867(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v866(VarNext,B)
          <=> v877(VarNext,B) ) ) ) ).

tff(addAssignment_250,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v877(VarNext,B)
          <=> v875(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_10,axiom,
    ! [VarCurr: state_type] :
      ( ~ v878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v875(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_10,axiom,
    ! [VarCurr: state_type] :
      ( v878(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v875(VarCurr,B)
          <=> v807(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_66,axiom,
    ! [VarCurr: state_type] :
      ( v878(VarCurr)
    <=> ( v879(VarCurr)
        & v880(VarCurr) ) ) ).

tff(writeUnaryOperator_55,axiom,
    ! [VarCurr: state_type] :
      ( ~ v880(VarCurr)
    <=> v799(VarCurr) ) ).

tff(writeUnaryOperator_54,axiom,
    ! [VarCurr: state_type] :
      ( ~ v879(VarCurr)
    <=> v791(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_65,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v867(VarNext)
      <=> v868(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_64,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v868(VarNext)
      <=> ( v869(VarNext)
          & v860(VarNext) ) ) ) ).

tff(writeUnaryOperator_53,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v869(VarNext)
      <=> v871(VarNext) ) ) ).

tff(addAssignment_249,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v871(VarNext)
      <=> v860(VarCurr) ) ) ).

tff(addAssignment_248,axiom,
    ! [VarCurr: state_type] :
      ( v860(VarCurr)
    <=> v862(VarCurr) ) ).

tff(addAssignment_247,axiom,
    ! [VarCurr: state_type] :
      ( v862(VarCurr)
    <=> v864(VarCurr) ) ).

tff(addAssignment_246,axiom,
    ! [VarCurr: state_type] :
      ( v864(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_245,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v807(VarCurr,B)
      <=> v809(VarCurr,B) ) ) ).

tff(addAssignment_244,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v809(VarCurr,B)
      <=> v851(VarCurr,B) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_2,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v851(VarCurr,B)
      <=> ( v852(VarCurr,B)
          | v855(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits_1,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v855(VarCurr,B)
      <=> ( v787(VarCurr,B)
          & v856(VarCurr,B) ) ) ) ).

tff(writeUnaryOperator_52,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v856(VarCurr,B)
      <=> ~ v857(VarCurr,B) ) ) ).

tff(addAssignment_243,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,0)
    <=> v858(VarCurr) ) ).

tff(addAssignment_242,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,1)
    <=> v858(VarCurr) ) ).

tff(addAssignment_241,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,2)
    <=> v858(VarCurr) ) ).

tff(addAssignment_240,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,3)
    <=> v858(VarCurr) ) ).

tff(addAssignment_239,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,4)
    <=> v858(VarCurr) ) ).

tff(addAssignment_238,axiom,
    ! [VarCurr: state_type] :
      ( v857(VarCurr,5)
    <=> v858(VarCurr) ) ).

tff(addAssignment_237,axiom,
    ! [VarCurr: state_type] :
      ( v858(VarCurr)
    <=> v848(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesMultipleBits,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,6)
        & ~ $less(B,0) )
     => ( v852(VarCurr,B)
      <=> ( v811(VarCurr,B)
          & v853(VarCurr,B) ) ) ) ).

tff(addAssignment_236,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,0)
    <=> v854(VarCurr) ) ).

tff(addAssignment_235,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,1)
    <=> v854(VarCurr) ) ).

tff(addAssignment_234,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,2)
    <=> v854(VarCurr) ) ).

tff(addAssignment_233,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,3)
    <=> v854(VarCurr) ) ).

tff(addAssignment_232,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,4)
    <=> v854(VarCurr) ) ).

tff(addAssignment_231,axiom,
    ! [VarCurr: state_type] :
      ( v853(VarCurr,5)
    <=> v854(VarCurr) ) ).

tff(addAssignment_230,axiom,
    ! [VarCurr: state_type] :
      ( v854(VarCurr)
    <=> v848(VarCurr) ) ).

tff(addAssignment_229,axiom,
    ! [VarCurr: state_type] :
      ( v848(VarCurr)
    <=> v850(VarCurr) ) ).

tff(addAssignment_228,axiom,
    ! [VarCurr: state_type] :
      ( v850(VarCurr)
    <=> v777(VarCurr) ) ).

tff(addAssignment_227,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v811(VarCurr,B)
      <=> v813(VarCurr,B) ) ) ).

tff(addAssignment_226,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v813(VarCurr,B)
      <=> v817(VarCurr,B) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_9,axiom,
    ! [VarCurr: state_type] :
      ( ~ v818(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v817(VarCurr,B)
          <=> v821(VarCurr,B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_9,axiom,
    ! [VarCurr: state_type] :
      ( v818(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v817(VarCurr,B)
          <=> v819(VarCurr,B) ) ) ) ).

tff(addAssignment_225,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v821(VarCurr,B)
      <=> v822(VarCurr,B) ) ) ).

tff(addAssignment_224,axiom,
    ! [VarCurr: state_type] :
      ( v821(VarCurr,5)
    <=> v785(VarCurr,5) ) ).

tff(addAssignment_223,axiom,
    ! [VarCurr: state_type] :
      ( v822(VarCurr,0)
    <=> v844(VarCurr) ) ).

tff(addAssignment_222,axiom,
    ! [VarCurr: state_type] :
      ( v822(VarCurr,1)
    <=> v842(VarCurr) ) ).

tff(addAssignment_221,axiom,
    ! [VarCurr: state_type] :
      ( v822(VarCurr,2)
    <=> v837(VarCurr) ) ).

tff(addAssignment_220,axiom,
    ! [VarCurr: state_type] :
      ( v822(VarCurr,3)
    <=> v832(VarCurr) ) ).

tff(addAssignment_219,axiom,
    ! [VarCurr: state_type] :
      ( v822(VarCurr,4)
    <=> v824(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_63,axiom,
    ! [VarCurr: state_type] :
      ( v842(VarCurr)
    <=> ( v843(VarCurr)
        & v846(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_6,axiom,
    ! [VarCurr: state_type] :
      ( v846(VarCurr)
    <=> ( v785(VarCurr,0)
        | v785(VarCurr,1) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_62,axiom,
    ! [VarCurr: state_type] :
      ( v843(VarCurr)
    <=> ( v844(VarCurr)
        | v845(VarCurr) ) ) ).

tff(writeUnaryOperator_51,axiom,
    ! [VarCurr: state_type] :
      ( ~ v845(VarCurr)
    <=> v785(VarCurr,1) ) ).

tff(writeUnaryOperator_50,axiom,
    ! [VarCurr: state_type] :
      ( ~ v844(VarCurr)
    <=> v785(VarCurr,0) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_61,axiom,
    ! [VarCurr: state_type] :
      ( v837(VarCurr)
    <=> ( v838(VarCurr)
        & v841(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_5,axiom,
    ! [VarCurr: state_type] :
      ( v841(VarCurr)
    <=> ( v829(VarCurr)
        | v785(VarCurr,2) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_60,axiom,
    ! [VarCurr: state_type] :
      ( v838(VarCurr)
    <=> ( v839(VarCurr)
        | v840(VarCurr) ) ) ).

tff(writeUnaryOperator_49,axiom,
    ! [VarCurr: state_type] :
      ( ~ v840(VarCurr)
    <=> v785(VarCurr,2) ) ).

tff(writeUnaryOperator_48,axiom,
    ! [VarCurr: state_type] :
      ( ~ v839(VarCurr)
    <=> v829(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_59,axiom,
    ! [VarCurr: state_type] :
      ( v832(VarCurr)
    <=> ( v833(VarCurr)
        & v836(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_4,axiom,
    ! [VarCurr: state_type] :
      ( v836(VarCurr)
    <=> ( v828(VarCurr)
        | v785(VarCurr,3) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_58,axiom,
    ! [VarCurr: state_type] :
      ( v833(VarCurr)
    <=> ( v834(VarCurr)
        | v835(VarCurr) ) ) ).

tff(writeUnaryOperator_47,axiom,
    ! [VarCurr: state_type] :
      ( ~ v835(VarCurr)
    <=> v785(VarCurr,3) ) ).

tff(writeUnaryOperator_46,axiom,
    ! [VarCurr: state_type] :
      ( ~ v834(VarCurr)
    <=> v828(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_57,axiom,
    ! [VarCurr: state_type] :
      ( v824(VarCurr)
    <=> ( v825(VarCurr)
        & v831(VarCurr) ) ) ).

tff(writeBinaryOperatorShiftedRanges_3,axiom,
    ! [VarCurr: state_type] :
      ( v831(VarCurr)
    <=> ( v827(VarCurr)
        | v785(VarCurr,4) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_56,axiom,
    ! [VarCurr: state_type] :
      ( v825(VarCurr)
    <=> ( v826(VarCurr)
        | v830(VarCurr) ) ) ).

tff(writeUnaryOperator_45,axiom,
    ! [VarCurr: state_type] :
      ( ~ v830(VarCurr)
    <=> v785(VarCurr,4) ) ).

tff(writeUnaryOperator_44,axiom,
    ! [VarCurr: state_type] :
      ( ~ v826(VarCurr)
    <=> v827(VarCurr) ) ).

tff(writeBinaryOperatorShiftedRanges_2,axiom,
    ! [VarCurr: state_type] :
      ( v827(VarCurr)
    <=> ( v828(VarCurr)
        & v785(VarCurr,3) ) ) ).

tff(writeBinaryOperatorShiftedRanges_1,axiom,
    ! [VarCurr: state_type] :
      ( v828(VarCurr)
    <=> ( v829(VarCurr)
        & v785(VarCurr,2) ) ) ).

tff(writeBinaryOperatorShiftedRanges,axiom,
    ! [VarCurr: state_type] :
      ( v829(VarCurr)
    <=> ( v785(VarCurr,0)
        & v785(VarCurr,1) ) ) ).

tff(addAssignment_218,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,5)
        & ~ $less(B,0) )
     => ( v819(VarCurr,B)
      <=> $false ) ) ).

tff(bitBlastConstant_9,axiom,
    ~ b00000(4) ).

tff(bitBlastConstant_8,axiom,
    ~ b00000(3) ).

tff(bitBlastConstant_7,axiom,
    ~ b00000(2) ).

tff(bitBlastConstant_6,axiom,
    ~ b00000(1) ).

tff(bitBlastConstant_5,axiom,
    ~ b00000(0) ).

tff(addAssignment_217,axiom,
    ! [VarCurr: state_type] :
      ( v819(VarCurr,5)
    <=> v820(VarCurr) ) ).

tff(writeUnaryOperator_43,axiom,
    ! [VarCurr: state_type] :
      ( ~ v820(VarCurr)
    <=> v785(VarCurr,5) ) ).

tff(addBitVectorEqualityBitBlasted_4,axiom,
    ! [VarCurr: state_type] :
      ( v818(VarCurr)
    <=> ( ( v785(VarCurr,4)
        <=> $true )
        & ( v785(VarCurr,3)
        <=> $false )
        & ( v785(VarCurr,2)
        <=> $false )
        & ( v785(VarCurr,1)
        <=> $false )
        & ( v785(VarCurr,0)
        <=> $false ) ) ) ).

tff(bitBlastConstant_4,axiom,
    b10000(4) ).

tff(bitBlastConstant_3,axiom,
    ~ b10000(3) ).

tff(bitBlastConstant_2,axiom,
    ~ b10000(2) ).

tff(bitBlastConstant_1,axiom,
    ~ b10000(1) ).

tff(bitBlastConstant,axiom,
    ~ b10000(0) ).

tff(addAssignment_216,axiom,
    ! [VarCurr: state_type] :
      ( v799(VarCurr)
    <=> v801(VarCurr) ) ).

tff(addAssignment_215,axiom,
    ! [VarCurr: state_type] :
      ( v801(VarCurr)
    <=> v803(VarCurr) ) ).

tff(addAssignment_214,axiom,
    ! [VarCurr: state_type] :
      ( v803(VarCurr)
    <=> v805(VarCurr) ) ).

tff(addAssignment_213,axiom,
    ! [VarCurr: state_type] :
      ( v805(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_212,axiom,
    ! [VarCurr: state_type] :
      ( v791(VarCurr)
    <=> v793(VarCurr) ) ).

tff(addAssignment_211,axiom,
    ! [VarCurr: state_type] :
      ( v793(VarCurr)
    <=> v795(VarCurr) ) ).

tff(addAssignment_210,axiom,
    ! [VarCurr: state_type] :
      ( v795(VarCurr)
    <=> v797(VarCurr) ) ).

tff(addAssignment_209,axiom,
    ! [VarCurr: state_type] :
      ( v797(VarCurr)
    <=> v20(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_55,axiom,
    ! [VarCurr: state_type] :
      ( v765(VarCurr)
    <=> ( v767(VarCurr)
        & v172(VarCurr) ) ) ).

tff(writeUnaryOperator_42,axiom,
    ! [VarCurr: state_type] :
      ( ~ v767(VarCurr)
    <=> v743(VarCurr,0) ) ).

tff(addAssignment_208,axiom,
    ! [VarCurr: state_type] :
      ( v753(VarCurr)
    <=> v755(VarCurr) ) ).

tff(addAssignment_207,axiom,
    ! [VarCurr: state_type] :
      ( v755(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_206,axiom,
    ! [VarCurr: state_type] :
      ( v749(VarCurr)
    <=> v751(VarCurr) ) ).

tff(addAssignment_205,axiom,
    ! [VarCurr: state_type] :
      ( v751(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_204,axiom,
    ! [VarCurr: state_type] :
      ( v172(VarCurr)
    <=> v174(VarCurr,4) ) ).

tff(addAssignment_203,axiom,
    ! [VarCurr: state_type] :
      ( v174(VarCurr,4)
    <=> v176(VarCurr,4) ) ).

tff(addAssignment_202,axiom,
    ! [VarNext: state_type] :
      ( v176(VarNext,4)
    <=> v723(VarNext,4) ) ).

tff(addCaseBooleanConditionEqualRanges1_6,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v724(VarNext)
       => ! [B: $int] :
            ( ( $less(B,6)
              & ~ $less(B,0) )
           => ( v723(VarNext,B)
            <=> v176(VarCurr,B) ) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_6,axiom,
    ! [VarNext: state_type] :
      ( v724(VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v723(VarNext,B)
          <=> v734(VarNext,B) ) ) ) ).

tff(addAssignment_201,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v734(VarNext,B)
          <=> v732(VarCurr,B) ) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_8,axiom,
    ! [VarCurr: state_type] :
      ( ~ v735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v732(VarCurr,B)
          <=> bxxxxxx(B) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_8,axiom,
    ! [VarCurr: state_type] :
      ( v735(VarCurr)
     => ! [B: $int] :
          ( ( $less(B,6)
            & ~ $less(B,0) )
         => ( v732(VarCurr,B)
          <=> v186(VarCurr,B) ) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_54,axiom,
    ! [VarCurr: state_type] :
      ( v735(VarCurr)
    <=> ( v736(VarCurr)
        & v737(VarCurr) ) ) ).

tff(writeUnaryOperator_41,axiom,
    ! [VarCurr: state_type] :
      ( ~ v737(VarCurr)
    <=> v182(VarCurr) ) ).

tff(writeUnaryOperator_40,axiom,
    ! [VarCurr: state_type] :
      ( ~ v736(VarCurr)
    <=> v178(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_53,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v724(VarNext)
      <=> v725(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_52,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v725(VarNext)
      <=> ( v726(VarNext)
          & v210(VarNext) ) ) ) ).

tff(writeUnaryOperator_39,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v726(VarNext)
      <=> v728(VarNext) ) ) ).

tff(addAssignment_200,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v728(VarNext)
      <=> v210(VarCurr) ) ) ).

tff(addAssignment_199,axiom,
    ! [VarCurr: state_type] :
      ( v210(VarCurr)
    <=> v212(VarCurr) ) ).

tff(addAssignment_198,axiom,
    ! [VarCurr: state_type] :
      ( v212(VarCurr)
    <=> v214(VarCurr) ) ).

tff(addAssignment_197,axiom,
    ! [VarCurr: state_type] :
      ( v214(VarCurr)
    <=> v216(VarCurr) ) ).

tff(addAssignment_196,axiom,
    ! [VarCurr: state_type] :
      ( v216(VarCurr)
    <=> v218(VarCurr) ) ).

tff(addAssignment_195,axiom,
    ! [VarCurr: state_type] :
      ( v218(VarCurr)
    <=> v220(VarCurr) ) ).

tff(addAssignment_194,axiom,
    ! [VarCurr: state_type] :
      ( v220(VarCurr)
    <=> v222(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_51,axiom,
    ! [VarCurr: state_type] :
      ( v222(VarCurr)
    <=> ( v721(VarCurr)
        | v711(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_50,axiom,
    ! [VarCurr: state_type] :
      ( v721(VarCurr)
    <=> ( v224(VarCurr)
        & v660(VarCurr) ) ) ).

tff(addAssignment_193,axiom,
    ! [VarCurr: state_type] :
      ( v711(VarCurr)
    <=> v713(VarCurr) ) ).

tff(addAssignment_192,axiom,
    ! [VarCurr: state_type] :
      ( v713(VarCurr)
    <=> v715(VarCurr) ) ).

tff(addAssignment_191,axiom,
    ! [VarCurr: state_type] :
      ( v715(VarCurr)
    <=> v717(VarCurr) ) ).

tff(addAssignment_190,axiom,
    ! [VarCurr: state_type] :
      ( v717(VarCurr)
    <=> v719(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_5,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v695(VarNext)
       => ( v660(VarNext)
        <=> v660(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_5,axiom,
    ! [VarNext: state_type] :
      ( v695(VarNext)
     => ( v660(VarNext)
      <=> v705(VarNext) ) ) ).

tff(addAssignment_189,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v705(VarNext)
      <=> v703(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_49,axiom,
    ! [VarCurr: state_type] :
      ( v703(VarCurr)
    <=> ( v706(VarCurr)
        & v707(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_48,axiom,
    ! [VarCurr: state_type] :
      ( v707(VarCurr)
    <=> ( v666(VarCurr)
        | v670(VarCurr) ) ) ).

tff(writeUnaryOperator_38,axiom,
    ! [VarCurr: state_type] :
      ( ~ v706(VarCurr)
    <=> v662(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_47,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v695(VarNext)
      <=> v696(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_46,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v696(VarNext)
      <=> ( v698(VarNext)
          & v700(VarNext) ) ) ) ).

tff(writeUnaryOperator_37,axiom,
    ! [VarCurr: state_type] :
      ( ~ v700(VarCurr)
    <=> v224(VarCurr) ) ).

tff(addAssignment_188,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v698(VarNext)
      <=> v224(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_3,axiom,
    ( v660(constB0)
  <=> $true ) ).

tff(addAssignment_187,axiom,
    ! [VarCurr: state_type] :
      ( v670(VarCurr)
    <=> v672(VarCurr) ) ).

tff(addAssignment_186,axiom,
    ! [VarCurr: state_type] :
      ( v672(VarCurr)
    <=> v674(VarCurr) ) ).

tff(addAssignment_185,axiom,
    ! [VarCurr: state_type] :
      ( v674(VarCurr)
    <=> v676(VarCurr) ) ).

tff(addAssignment_184,axiom,
    ! [VarCurr: state_type] :
      ( v676(VarCurr)
    <=> v678(VarCurr) ) ).

tff(addAssignment_183,axiom,
    ! [VarCurr: state_type] :
      ( v678(VarCurr)
    <=> v680(VarCurr) ) ).

tff(addAssignment_182,axiom,
    ! [VarCurr: state_type] :
      ( v680(VarCurr)
    <=> v682(VarCurr) ) ).

tff(addAssignment_181,axiom,
    ! [VarCurr: state_type] :
      ( v682(VarCurr)
    <=> v684(VarCurr) ) ).

tff(addAssignment_180,axiom,
    ! [VarCurr: state_type] :
      ( v684(VarCurr)
    <=> v686(VarCurr) ) ).

tff(addAssignment_179,axiom,
    ! [VarCurr: state_type] :
      ( v686(VarCurr)
    <=> v688(VarCurr) ) ).

tff(addAssignment_178,axiom,
    ! [VarCurr: state_type] :
      ( v688(VarCurr)
    <=> v690(VarCurr) ) ).

tff(addAssignment_177,axiom,
    ! [VarCurr: state_type] :
      ( v690(VarCurr)
    <=> v692(VarCurr) ) ).

tff(addAssignment_176,axiom,
    ! [VarCurr: state_type] :
      ( v666(VarCurr)
    <=> v668(VarCurr) ) ).

tff(addAssignment_175,axiom,
    ! [VarCurr: state_type] :
      ( v668(VarCurr)
    <=> $true ) ).

tff(addAssignment_174,axiom,
    ! [VarCurr: state_type] :
      ( v662(VarCurr)
    <=> v664(VarCurr) ) ).

tff(addAssignment_173,axiom,
    ! [VarCurr: state_type] :
      ( v664(VarCurr)
    <=> $false ) ).

tff(addAssignment_172,axiom,
    ! [VarCurr: state_type] :
      ( v224(VarCurr)
    <=> v226(VarCurr) ) ).

tff(addAssignment_171,axiom,
    ! [VarCurr: state_type] :
      ( v226(VarCurr)
    <=> v228(VarCurr) ) ).

tff(addAssignment_170,axiom,
    ! [VarCurr: state_type] :
      ( v228(VarCurr)
    <=> v230(VarCurr) ) ).

tff(addAssignment_169,axiom,
    ! [VarCurr: state_type] :
      ( v230(VarCurr)
    <=> v232(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_7,axiom,
    ! [VarCurr: state_type] :
      ( ~ v652(VarCurr)
     => ( v232(VarCurr)
      <=> x650(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_7,axiom,
    ! [VarCurr: state_type] :
      ( v652(VarCurr)
     => ( v232(VarCurr)
      <=> v234(VarCurr) ) ) ).

tff(writeUnaryOperator_36,axiom,
    ! [VarCurr: state_type] :
      ( ~ v652(VarCurr)
    <=> v654(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_45,axiom,
    ! [VarCurr: state_type] :
      ( v654(VarCurr)
    <=> ( v655(VarCurr)
        & v658(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_44,axiom,
    ! [VarCurr: state_type] :
      ( v658(VarCurr)
    <=> ( v234(VarCurr)
        | v645(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_43,axiom,
    ! [VarCurr: state_type] :
      ( v655(VarCurr)
    <=> ( v656(VarCurr)
        | v657(VarCurr) ) ) ).

tff(writeUnaryOperator_35,axiom,
    ! [VarCurr: state_type] :
      ( ~ v657(VarCurr)
    <=> v645(VarCurr) ) ).

tff(writeUnaryOperator_34,axiom,
    ! [VarCurr: state_type] :
      ( ~ v656(VarCurr)
    <=> v234(VarCurr) ) ).

tff(addAssignment_168,axiom,
    ! [VarCurr: state_type] :
      ( v645(VarCurr)
    <=> v647(VarCurr) ) ).

tff(addAssignment_167,axiom,
    ! [VarCurr: state_type] :
      ( v647(VarCurr)
    <=> v649(VarCurr) ) ).

tff(addAssignment_166,axiom,
    ! [VarCurr: state_type] :
      ( v649(VarCurr)
    <=> v240(VarCurr) ) ).

tff(addAssignment_165,axiom,
    ! [VarCurr: state_type] :
      ( v234(VarCurr)
    <=> v236(VarCurr) ) ).

tff(addAssignment_164,axiom,
    ! [VarCurr: state_type] :
      ( v236(VarCurr)
    <=> v238(VarCurr) ) ).

tff(addAssignment_163,axiom,
    ! [VarCurr: state_type] :
      ( v238(VarCurr)
    <=> v240(VarCurr) ) ).

tff(addAssignment_162,axiom,
    ! [VarCurr: state_type] :
      ( v240(VarCurr)
    <=> v242(VarCurr) ) ).

tff(addAssignment_161,axiom,
    ! [VarCurr: state_type] :
      ( v242(VarCurr)
    <=> v244(VarCurr) ) ).

tff(writeUnaryOperator_33,axiom,
    ! [VarCurr: state_type] :
      ( ~ v244(VarCurr)
    <=> v246(VarCurr) ) ).

tff(addAssignment_160,axiom,
    ! [VarCurr: state_type] :
      ( v246(VarCurr)
    <=> v248(VarCurr) ) ).

tff(addAssignment_159,axiom,
    ! [VarCurr: state_type] :
      ( v248(VarCurr)
    <=> v250(VarCurr) ) ).

tff(writeUnaryOperator_32,axiom,
    ! [VarCurr: state_type] :
      ( ~ v250(VarCurr)
    <=> v642(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_42,axiom,
    ! [VarCurr: state_type] :
      ( v642(VarCurr)
    <=> ( v252(VarCurr)
        & v636(VarCurr) ) ) ).

tff(addAssignment_158,axiom,
    ! [VarCurr: state_type] :
      ( v636(VarCurr)
    <=> v638(VarCurr) ) ).

tff(addAssignment_157,axiom,
    ! [VarCurr: state_type] :
      ( v638(VarCurr)
    <=> v640(VarCurr) ) ).

tff(addAssignment_156,axiom,
    ! [VarCurr: state_type] :
      ( v640(VarCurr)
    <=> $true ) ).

tff(addAssignment_155,axiom,
    ! [VarCurr: state_type] :
      ( v252(VarCurr)
    <=> v254(VarCurr) ) ).

tff(addAssignment_154,axiom,
    ! [VarCurr: state_type] :
      ( v254(VarCurr)
    <=> v256(VarCurr) ) ).

tff(addAssignment_153,axiom,
    ! [VarCurr: state_type] :
      ( v256(VarCurr)
    <=> v258(VarCurr) ) ).

tff(writeUnaryOperator_31,axiom,
    ! [VarCurr: state_type] :
      ( ~ v258(VarCurr)
    <=> v260(VarCurr) ) ).

tff(addAssignment_152,axiom,
    ! [VarCurr: state_type] :
      ( v260(VarCurr)
    <=> v262(VarCurr) ) ).

tff(addAssignment_151,axiom,
    ! [VarCurr: state_type] :
      ( v262(VarCurr)
    <=> v264(VarCurr) ) ).

tff(writeUnaryOperator_30,axiom,
    ! [VarCurr: state_type] :
      ( ~ v264(VarCurr)
    <=> v633(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_41,axiom,
    ! [VarCurr: state_type] :
      ( v633(VarCurr)
    <=> ( v266(VarCurr)
        & v631(VarCurr) ) ) ).

tff(addAssignment_150,axiom,
    ! [VarCurr: state_type] :
      ( v631(VarCurr)
    <=> v291(VarCurr) ) ).

tff(addAssignment_149,axiom,
    ! [VarCurr: state_type] :
      ( v266(VarCurr)
    <=> v268(VarCurr) ) ).

tff(addAssignment_148,axiom,
    ! [VarCurr: state_type] :
      ( v268(VarCurr)
    <=> v270(VarCurr) ) ).

tff(writeUnaryOperator_29,axiom,
    ! [VarCurr: state_type] :
      ( ~ v270(VarCurr)
    <=> v272(VarCurr) ) ).

tff(addAssignment_147,axiom,
    ! [VarCurr: state_type] :
      ( v272(VarCurr)
    <=> v274(VarCurr) ) ).

tff(addAssignment_146,axiom,
    ! [VarCurr: state_type] :
      ( v274(VarCurr)
    <=> v276(VarCurr) ) ).

tff(writeUnaryOperator_28,axiom,
    ! [VarCurr: state_type] :
      ( ~ v276(VarCurr)
    <=> v628(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_40,axiom,
    ! [VarCurr: state_type] :
      ( v628(VarCurr)
    <=> ( v278(VarCurr)
        | v618(VarCurr) ) ) ).

tff(addAssignment_145,axiom,
    ! [VarCurr: state_type] :
      ( v618(VarCurr)
    <=> v620(VarCurr) ) ).

tff(addAssignment_144,axiom,
    ! [VarCurr: state_type] :
      ( v620(VarCurr)
    <=> v622(VarCurr) ) ).

tff(addAssignment_143,axiom,
    ! [VarCurr: state_type] :
      ( v622(VarCurr)
    <=> v624(VarCurr) ) ).

tff(addAssignment_142,axiom,
    ! [VarCurr: state_type] :
      ( v624(VarCurr)
    <=> v626(VarCurr) ) ).

tff(addAssignment_141,axiom,
    ! [VarCurr: state_type] :
      ( v278(VarCurr)
    <=> v280(VarCurr) ) ).

tff(addAssignment_140,axiom,
    ! [VarCurr: state_type] :
      ( v280(VarCurr)
    <=> v282(VarCurr) ) ).

tff(addAssignment_139,axiom,
    ! [VarCurr: state_type] :
      ( v282(VarCurr)
    <=> v284(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_6,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v601(VarNext)
       => ( v284(VarNext)
        <=> v284(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_6,axiom,
    ! [VarNext: state_type] :
      ( v601(VarNext)
     => ( v284(VarNext)
      <=> v611(VarNext) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_4,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v602(VarCurr)
        & v603(VarCurr) )
     => ( v611(VarCurr)
      <=> v612(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_4,axiom,
    ! [VarCurr: state_type] :
      ( v602(VarCurr)
     => ( v611(VarCurr)
      <=> v521(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_3,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v604(VarCurr)
       => ( v612(VarCurr)
        <=> x464(VarNext) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_3,axiom,
    ! [VarCurr: state_type] :
      ( v604(VarCurr)
     => ( v612(VarCurr)
      <=> v523(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_39,axiom,
    ! [VarCurr: state_type] :
      ( v601(VarCurr)
    <=> ( v602(VarCurr)
        | v603(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_38,axiom,
    ! [VarCurr: state_type] :
      ( v603(VarCurr)
    <=> ( v604(VarCurr)
        | v607(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_37,axiom,
    ! [VarCurr: state_type] :
      ( v607(VarCurr)
    <=> ( v608(VarCurr)
        & v610(VarCurr) ) ) ).

tff(writeUnaryOperator_27,axiom,
    ! [VarCurr: state_type] :
      ( ~ v610(VarCurr)
    <=> v604(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_36,axiom,
    ! [VarCurr: state_type] :
      ( v608(VarCurr)
    <=> ( v286(VarCurr)
        & v609(VarCurr) ) ) ).

tff(writeUnaryOperator_26,axiom,
    ! [VarCurr: state_type] :
      ( ~ v609(VarCurr)
    <=> v289(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_35,axiom,
    ! [VarCurr: state_type] :
      ( v604(VarCurr)
    <=> ( v605(VarCurr)
        & v606(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_3,axiom,
    ! [VarCurr: state_type] :
      ( v606(VarCurr)
    <=> ( v289(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted_2,axiom,
    ! [VarCurr: state_type] :
      ( v605(VarCurr)
    <=> ( v286(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_34,axiom,
    ! [VarCurr: state_type] :
      ( v602(VarCurr)
    <=> ( v286(VarCurr)
        & v289(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_2,axiom,
    ( v284(constB0)
  <=> $true ) ).

tff(addAssignment_138,axiom,
    ! [VarCurr: state_type] :
      ( v523(VarCurr)
    <=> v525(VarCurr) ) ).

tff(addAssignment_137,axiom,
    ! [VarCurr: state_type] :
      ( v525(VarCurr)
    <=> v527(VarCurr) ) ).

tff(addAssignment_136,axiom,
    ! [VarCurr: state_type] :
      ( v527(VarCurr)
    <=> v529(VarCurr) ) ).

tff(writeUnaryOperator_25,axiom,
    ! [VarCurr: state_type] :
      ( ~ v529(VarCurr)
    <=> v531(VarCurr) ) ).

tff(addAssignment_135,axiom,
    ! [VarCurr: state_type] :
      ( v531(VarCurr)
    <=> v533(VarCurr) ) ).

tff(addAssignment_134,axiom,
    ! [VarCurr: state_type] :
      ( v533(VarCurr)
    <=> v535(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_3,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v582(VarNext)
       => ( v535(VarNext)
        <=> v535(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_3,axiom,
    ! [VarNext: state_type] :
      ( v582(VarNext)
     => ( v535(VarNext)
      <=> v592(VarNext) ) ) ).

tff(addAssignment_133,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v592(VarNext)
      <=> v590(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_5,axiom,
    ! [VarCurr: state_type] :
      ( ~ v593(VarCurr)
     => ( v590(VarCurr)
      <=> x442(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_5,axiom,
    ! [VarCurr: state_type] :
      ( v593(VarCurr)
     => ( v590(VarCurr)
      <=> v541(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_33,axiom,
    ! [VarCurr: state_type] :
      ( v593(VarCurr)
    <=> ( v594(VarCurr)
        & v595(VarCurr) ) ) ).

tff(writeUnaryOperator_24,axiom,
    ! [VarCurr: state_type] :
      ( ~ v595(VarCurr)
    <=> v539(VarCurr) ) ).

tff(writeUnaryOperator_23,axiom,
    ! [VarCurr: state_type] :
      ( ~ v594(VarCurr)
    <=> v537(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_32,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v582(VarNext)
      <=> v583(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_31,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v583(VarNext)
      <=> ( v584(VarNext)
          & v579(VarNext) ) ) ) ).

tff(writeUnaryOperator_22,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v584(VarNext)
      <=> v586(VarNext) ) ) ).

tff(addAssignment_132,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v586(VarNext)
      <=> v579(VarCurr) ) ) ).

tff(addAssignmentInitValueVector_1,axiom,
    ( v535(constB0)
  <=> $false ) ).

tff(addAssignment_131,axiom,
    ! [VarCurr: state_type] :
      ( v579(VarCurr)
    <=> v293(VarCurr) ) ).

tff(addAssignment_130,axiom,
    ! [VarCurr: state_type] :
      ( v541(VarCurr)
    <=> v543(VarCurr) ) ).

tff(addAssignment_129,axiom,
    ! [VarCurr: state_type] :
      ( v543(VarCurr)
    <=> v545(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1_2,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v562(VarNext)
       => ( v545(VarNext)
        <=> v545(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_2,axiom,
    ! [VarNext: state_type] :
      ( v562(VarNext)
     => ( v545(VarNext)
      <=> v572(VarNext) ) ) ).

tff(addAssignment_128,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v572(VarNext)
      <=> v570(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_4,axiom,
    ! [VarCurr: state_type] :
      ( ~ v573(VarCurr)
     => ( v570(VarCurr)
      <=> x442(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_4,axiom,
    ! [VarCurr: state_type] :
      ( v573(VarCurr)
     => ( v570(VarCurr)
      <=> v551(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_30,axiom,
    ! [VarCurr: state_type] :
      ( v573(VarCurr)
    <=> ( v574(VarCurr)
        & v575(VarCurr) ) ) ).

tff(writeUnaryOperator_21,axiom,
    ! [VarCurr: state_type] :
      ( ~ v575(VarCurr)
    <=> v549(VarCurr) ) ).

tff(writeUnaryOperator_20,axiom,
    ! [VarCurr: state_type] :
      ( ~ v574(VarCurr)
    <=> v547(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_29,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v562(VarNext)
      <=> v563(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_28,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v563(VarNext)
      <=> ( v564(VarNext)
          & v559(VarNext) ) ) ) ).

tff(writeUnaryOperator_19,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v564(VarNext)
      <=> v566(VarNext) ) ) ).

tff(addAssignment_127,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v566(VarNext)
      <=> v559(VarCurr) ) ) ).

tff(addAssignmentInitValueVector,axiom,
    ( v545(constB0)
  <=> $false ) ).

tff(addAssignment_126,axiom,
    ! [VarCurr: state_type] :
      ( v559(VarCurr)
    <=> v293(VarCurr) ) ).

tff(addAssignment_125,axiom,
    ! [VarCurr: state_type] :
      ( v551(VarCurr)
    <=> v553(VarCurr) ) ).

tff(addAssignment_124,axiom,
    ! [VarCurr: state_type] :
      ( v553(VarCurr)
    <=> v555(VarCurr) ) ).

tff(addAssignment_123,axiom,
    ! [VarCurr: state_type] :
      ( v555(VarCurr)
    <=> v557(VarCurr) ) ).

tff(addAssignment_122,axiom,
    ! [VarCurr: state_type] :
      ( v549(VarCurr)
    <=> $false ) ).

tff(addAssignment_121,axiom,
    ! [VarCurr: state_type] :
      ( v547(VarCurr)
    <=> $false ) ).

tff(addAssignment_120,axiom,
    ! [VarCurr: state_type] :
      ( v539(VarCurr)
    <=> $false ) ).

tff(addAssignment_119,axiom,
    ! [VarCurr: state_type] :
      ( v537(VarCurr)
    <=> $false ) ).

tff(addAssignment_118,axiom,
    ! [VarCurr: state_type] :
      ( v521(VarCurr)
    <=> $false ) ).

tff(addAssignment_117,axiom,
    ! [VarCurr: state_type] :
      ( v289(VarCurr)
    <=> v291(VarCurr) ) ).

tff(addAssignment_116,axiom,
    ! [VarCurr: state_type] :
      ( v291(VarCurr)
    <=> v293(VarCurr) ) ).

tff(addAssignment_115,axiom,
    ! [VarCurr: state_type] :
      ( v293(VarCurr)
    <=> v295(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_27,axiom,
    ! [VarCurr: state_type] :
      ( v295(VarCurr)
    <=> ( v518(VarCurr)
        | v519(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_26,axiom,
    ! [VarCurr: state_type] :
      ( v519(VarCurr)
    <=> ( v514(VarCurr)
        & v516(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_25,axiom,
    ! [VarCurr: state_type] :
      ( v518(VarCurr)
    <=> ( v297(VarCurr)
        & v331(VarCurr) ) ) ).

tff(addAssignment_114,axiom,
    ! [VarCurr: state_type] :
      ( v516(VarCurr)
    <=> v381(VarCurr) ) ).

tff(addAssignment_113,axiom,
    ! [VarCurr: state_type] :
      ( v514(VarCurr)
    <=> v355(VarCurr) ) ).

tff(addAssignment_112,axiom,
    ! [VarCurr: state_type] :
      ( v331(VarCurr)
    <=> v333(VarCurr) ) ).

tff(addAssignment_111,axiom,
    ! [VarCurr: state_type] :
      ( v333(VarCurr)
    <=> v335(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_3,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v492(VarNext)
       => ( v335(VarNext)
        <=> v335(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_3,axiom,
    ! [VarNext: state_type] :
      ( v492(VarNext)
     => ( v335(VarNext)
      <=> v507(VarNext) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_2,axiom,
    ! [VarCurr: state_type] :
      ( ~ v493(VarCurr)
     => ( v507(VarCurr)
      <=> v508(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_2,axiom,
    ! [VarCurr: state_type] :
      ( v493(VarCurr)
     => ( v507(VarCurr)
      <=> v390(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1_1,axiom,
    ! [VarCurr: state_type] :
      ( ~ v499(VarCurr)
     => ( v508(VarCurr)
      <=> v398(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0_1,axiom,
    ! [VarCurr: state_type] :
      ( v499(VarCurr)
     => ( v508(VarCurr)
      <=> v392(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_24,axiom,
    ! [VarCurr: state_type] :
      ( v492(VarCurr)
    <=> ( v493(VarCurr)
        | v497(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_23,axiom,
    ! [VarCurr: state_type] :
      ( v497(VarCurr)
    <=> ( v498(VarCurr)
        & v506(VarCurr) ) ) ).

tff(writeUnaryOperator_18,axiom,
    ! [VarCurr: state_type] :
      ( ~ v506(VarCurr)
    <=> v493(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_22,axiom,
    ! [VarCurr: state_type] :
      ( v498(VarCurr)
    <=> ( v499(VarCurr)
        | v502(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_21,axiom,
    ! [VarCurr: state_type] :
      ( v502(VarCurr)
    <=> ( v503(VarCurr)
        & v505(VarCurr) ) ) ).

tff(writeUnaryOperator_17,axiom,
    ! [VarCurr: state_type] :
      ( ~ v505(VarCurr)
    <=> v499(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_20,axiom,
    ! [VarCurr: state_type] :
      ( v503(VarCurr)
    <=> ( v504(VarCurr)
        & v341(VarCurr) ) ) ).

tff(writeUnaryOperator_16,axiom,
    ! [VarCurr: state_type] :
      ( ~ v504(VarCurr)
    <=> v339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_19,axiom,
    ! [VarCurr: state_type] :
      ( v499(VarCurr)
    <=> ( v500(VarCurr)
        & v341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_18,axiom,
    ! [VarCurr: state_type] :
      ( v500(VarCurr)
    <=> ( v337(VarCurr)
        & v501(VarCurr) ) ) ).

tff(writeUnaryOperator_15,axiom,
    ! [VarCurr: state_type] :
      ( ~ v501(VarCurr)
    <=> v339(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_17,axiom,
    ! [VarCurr: state_type] :
      ( v493(VarCurr)
    <=> ( v494(VarCurr)
        & v388(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_16,axiom,
    ! [VarCurr: state_type] :
      ( v494(VarCurr)
    <=> ( v495(VarCurr)
        & v341(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_15,axiom,
    ! [VarCurr: state_type] :
      ( v495(VarCurr)
    <=> ( v337(VarCurr)
        & v496(VarCurr) ) ) ).

tff(writeUnaryOperator_14,axiom,
    ! [VarCurr: state_type] :
      ( ~ v496(VarCurr)
    <=> v339(VarCurr) ) ).

tff(addAssignment_110,axiom,
    ! [VarCurr: state_type] :
      ( v398(VarCurr)
    <=> v400(VarCurr) ) ).

tff(addAssignment_109,axiom,
    ! [VarCurr: state_type] :
      ( v400(VarCurr)
    <=> v402(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_14,axiom,
    ! [VarCurr: state_type] :
      ( v402(VarCurr)
    <=> ( v488(VarCurr)
        | v489(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_13,axiom,
    ! [VarCurr: state_type] :
      ( v489(VarCurr)
    <=> ( v484(VarCurr)
        & v486(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_12,axiom,
    ! [VarCurr: state_type] :
      ( v488(VarCurr)
    <=> ( v404(VarCurr)
        & v407(VarCurr) ) ) ).

tff(addAssignment_108,axiom,
    ! [VarCurr: state_type] :
      ( v486(VarCurr)
    <=> v293(VarCurr) ) ).

tff(addAssignment_107,axiom,
    ! [VarCurr: state_type] :
      ( v484(VarCurr)
    <=> v355(VarCurr) ) ).

tff(addAssignment_106,axiom,
    ! [VarCurr: state_type] :
      ( v407(VarCurr)
    <=> v409(VarCurr) ) ).

tff(addAssignment_105,axiom,
    ! [VarCurr: state_type] :
      ( v409(VarCurr)
    <=> v411(VarCurr) ) ).

tff(addAssignment_104,axiom,
    ! [VarCurr: state_type] :
      ( v411(VarCurr)
    <=> v413(VarCurr) ) ).

tff(addAssignment_103,axiom,
    ! [VarCurr: state_type] :
      ( v413(VarCurr)
    <=> v415(VarCurr) ) ).

tff(addAssignment_102,axiom,
    ! [VarCurr: state_type] :
      ( v415(VarCurr)
    <=> v417(VarCurr) ) ).

tff(addAssignment_101,axiom,
    ! [VarCurr: state_type] :
      ( v417(VarCurr)
    <=> v419(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_2,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v467(VarNext)
       => ( v419(VarNext)
        <=> v419(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_2,axiom,
    ! [VarNext: state_type] :
      ( v467(VarNext)
     => ( v419(VarNext)
      <=> v477(VarNext) ) ) ).

tff(addCaseBooleanConditionEqualRanges1_1,axiom,
    ! [VarCurr: state_type] :
      ( ( ~ v468(VarCurr)
        & v469(VarCurr) )
     => ( v477(VarCurr)
      <=> v478(VarCurr) ) ) ).

tff(addCaseBooleanConditionEqualRanges0_1,axiom,
    ! [VarCurr: state_type] :
      ( v468(VarCurr)
     => ( v477(VarCurr)
      <=> v425(VarCurr) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges1,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v470(VarCurr)
       => ( v478(VarCurr)
        <=> x464(VarNext) ) ) ) ).

tff(addParallelCaseBooleanConditionEqualRanges0,axiom,
    ! [VarCurr: state_type] :
      ( v470(VarCurr)
     => ( v478(VarCurr)
      <=> v427(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_11,axiom,
    ! [VarCurr: state_type] :
      ( v467(VarCurr)
    <=> ( v468(VarCurr)
        | v469(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_10,axiom,
    ! [VarCurr: state_type] :
      ( v469(VarCurr)
    <=> ( v470(VarCurr)
        | v473(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_9,axiom,
    ! [VarCurr: state_type] :
      ( v473(VarCurr)
    <=> ( v474(VarCurr)
        & v476(VarCurr) ) ) ).

tff(writeUnaryOperator_13,axiom,
    ! [VarCurr: state_type] :
      ( ~ v476(VarCurr)
    <=> v470(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_8,axiom,
    ! [VarCurr: state_type] :
      ( v474(VarCurr)
    <=> ( v421(VarCurr)
        & v475(VarCurr) ) ) ).

tff(writeUnaryOperator_12,axiom,
    ! [VarCurr: state_type] :
      ( ~ v475(VarCurr)
    <=> v423(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_7,axiom,
    ! [VarCurr: state_type] :
      ( v470(VarCurr)
    <=> ( v471(VarCurr)
        & v472(VarCurr) ) ) ).

tff(addBitVectorEqualityBitBlasted_1,axiom,
    ! [VarCurr: state_type] :
      ( v472(VarCurr)
    <=> ( v423(VarCurr)
      <=> $false ) ) ).

tff(addBitVectorEqualityBitBlasted,axiom,
    ! [VarCurr: state_type] :
      ( v471(VarCurr)
    <=> ( v421(VarCurr)
      <=> $false ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_6,axiom,
    ! [VarCurr: state_type] :
      ( v468(VarCurr)
    <=> ( v421(VarCurr)
        & v423(VarCurr) ) ) ).

tff(addAssignment_100,axiom,
    ! [VarCurr: state_type] :
      ( v427(VarCurr)
    <=> v429(VarCurr) ) ).

tff(addAssignment_99,axiom,
    ! [VarCurr: state_type] :
      ( v429(VarCurr)
    <=> v431(VarCurr) ) ).

tff(addCaseBooleanConditionEqualRanges1,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v448(VarNext)
       => ( v431(VarNext)
        <=> v431(VarCurr) ) ) ) ).

tff(addCaseBooleanConditionEqualRanges0,axiom,
    ! [VarNext: state_type] :
      ( v448(VarNext)
     => ( v431(VarNext)
      <=> v458(VarNext) ) ) ).

tff(addAssignment_98,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v458(VarNext)
      <=> v456(VarCurr) ) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch_1,axiom,
    ! [VarCurr: state_type] :
      ( ~ v459(VarCurr)
     => ( v456(VarCurr)
      <=> x442(VarCurr) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch_1,axiom,
    ! [VarCurr: state_type] :
      ( v459(VarCurr)
     => ( v456(VarCurr)
      <=> v437(VarCurr) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_5,axiom,
    ! [VarCurr: state_type] :
      ( v459(VarCurr)
    <=> ( v460(VarCurr)
        & v461(VarCurr) ) ) ).

tff(writeUnaryOperator_11,axiom,
    ! [VarCurr: state_type] :
      ( ~ v461(VarCurr)
    <=> v435(VarCurr) ) ).

tff(writeUnaryOperator_10,axiom,
    ! [VarCurr: state_type] :
      ( ~ v460(VarCurr)
    <=> v433(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_4,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v448(VarNext)
      <=> v449(VarNext) ) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_3,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v449(VarNext)
      <=> ( v450(VarNext)
          & v444(VarNext) ) ) ) ).

tff(writeUnaryOperator_9,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v450(VarNext)
      <=> v452(VarNext) ) ) ).

tff(addAssignment_97,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( v452(VarNext)
      <=> v444(VarCurr) ) ) ).

tff(addAssignment_96,axiom,
    ! [VarCurr: state_type] :
      ( v444(VarCurr)
    <=> v381(VarCurr) ) ).

tff(addAssignment_95,axiom,
    ! [VarCurr: state_type] :
      ( v437(VarCurr)
    <=> v439(VarCurr) ) ).

tff(addAssignment_94,axiom,
    ! [VarCurr: state_type] :
      ( v439(VarCurr)
    <=> v441(VarCurr) ) ).

tff(addAssignment_93,axiom,
    ! [VarCurr: state_type] :
      ( v441(VarCurr)
    <=> $false ) ).

tff(addAssignment_92,axiom,
    ! [VarCurr: state_type] :
      ( v435(VarCurr)
    <=> $false ) ).

tff(addAssignment_91,axiom,
    ! [VarCurr: state_type] :
      ( v433(VarCurr)
    <=> $false ) ).

tff(addAssignment_90,axiom,
    ! [VarCurr: state_type] :
      ( v425(VarCurr)
    <=> $false ) ).

tff(addAssignment_89,axiom,
    ! [VarCurr: state_type] :
      ( v423(VarCurr)
    <=> v381(VarCurr) ) ).

tff(addAssignment_88,axiom,
    ! [VarCurr: state_type] :
      ( v421(VarCurr)
    <=> $false ) ).

tff(writeUnaryOperator_8,axiom,
    ! [VarCurr: state_type] :
      ( ~ v404(VarCurr)
    <=> v355(VarCurr) ) ).

tff(aaddConditionBooleanCondEqualRangesElseBranch,axiom,
    ! [VarNext: state_type,VarCurr: state_type] :
      ( nextState(VarCurr,VarNext)
     => ( ~ v388(VarNext)
       => ( v392(VarNext)
        <=> v392(VarCurr) ) ) ) ).

tff(addConditionBooleanCondEqualRangesThenBranch,axiom,
    ! [VarNext: state_type] :
      ( v388(VarNext)
     => ( v392(VarNext)
      <=> v390(VarNext) ) ) ).

tff(addAssignment_87,axiom,
    ! [VarCurr: state_type] :
      ( v390(VarCurr)
    <=> $false ) ).

tff(addAssignment_86,axiom,
    ! [VarCurr: state_type] :
      ( v388(VarCurr)
    <=> $false ) ).

tff(addAssignment_85,axiom,
    ! [VarCurr: state_type] :
      ( v341(VarCurr)
    <=> v343(VarCurr) ) ).

tff(addAssignment_84,axiom,
    ! [VarCurr: state_type] :
      ( v343(VarCurr)
    <=> v345(VarCurr) ) ).

tff(writeUnaryOperator_7,axiom,
    ! [VarCurr: state_type] :
      ( ~ v345(VarCurr)
    <=> v347(VarCurr) ) ).

tff(addAssignment_83,axiom,
    ! [VarCurr: state_type] :
      ( v347(VarCurr)
    <=> v349(VarCurr) ) ).

tff(addAssignment_82,axiom,
    ! [VarCurr: state_type] :
      ( v349(VarCurr)
    <=> v351(VarCurr) ) ).

tff(writeUnaryOperator_6,axiom,
    ! [VarCurr: state_type] :
      ( ~ v351(VarCurr)
    <=> v385(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_2,axiom,
    ! [VarCurr: state_type] :
      ( v385(VarCurr)
    <=> ( v353(VarCurr)
        | v379(VarCurr) ) ) ).

tff(addAssignment_81,axiom,
    ! [VarCurr: state_type] :
      ( v379(VarCurr)
    <=> v381(VarCurr) ) ).

tff(addAssignment_80,axiom,
    ! [VarCurr: state_type] :
      ( v381(VarCurr)
    <=> v383(VarCurr) ) ).

tff(addAssignment_79,axiom,
    ! [VarCurr: state_type] :
      ( v383(VarCurr)
    <=> v1(VarCurr) ) ).

tff(addAssignment_78,axiom,
    ! [VarCurr: state_type] :
      ( v353(VarCurr)
    <=> v355(VarCurr) ) ).

tff(addAssignment_77,axiom,
    ! [VarCurr: state_type] :
      ( v355(VarCurr)
    <=> v357(VarCurr) ) ).

tff(writeUnaryOperator_5,axiom,
    ! [VarCurr: state_type] :
      ( ~ v357(VarCurr)
    <=> v359(VarCurr) ) ).

tff(addAssignment_76,axiom,
    ! [VarCurr: state_type] :
      ( v359(VarCurr)
    <=> v361(VarCurr) ) ).

tff(addAssignment_75,axiom,
    ! [VarCurr: state_type] :
      ( v361(VarCurr)
    <=> v363(VarCurr) ) ).

tff(writeUnaryOperator_4,axiom,
    ! [VarCurr: state_type] :
      ( ~ v363(VarCurr)
    <=> v376(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits_1,axiom,
    ! [VarCurr: state_type] :
      ( v376(VarCurr)
    <=> ( v365(VarCurr)
        | v374(VarCurr) ) ) ).

tff(addAssignment_74,axiom,
    ! [VarCurr: state_type] :
      ( v374(VarCurr)
    <=> v317(VarCurr) ) ).

tff(addAssignment_73,axiom,
    ! [VarCurr: state_type] :
      ( v365(VarCurr)
    <=> v367(VarCurr) ) ).

tff(addAssignment_72,axiom,
    ! [VarCurr: state_type] :
      ( v367(VarCurr)
    <=> v369(VarCurr) ) ).

tff(writeUnaryOperator_3,axiom,
    ! [VarCurr: state_type] :
      ( ~ v369(VarCurr)
    <=> v371(VarCurr) ) ).

tff(addAssignment_71,axiom,
    ! [VarCurr: state_type] :
      ( v371(VarCurr)
    <=> v324(VarCurr) ) ).

tff(addAssignment_70,axiom,
    ! [VarCurr: state_type] :
      ( v339(VarCurr)
    <=> $false ) ).

tff(addAssignment_69,axiom,
    ! [VarCurr: state_type] :
      ( v337(VarCurr)
    <=> $false ) ).

tff(addAssignment_68,axiom,
    ! [VarCurr: state_type] :
      ( v297(VarCurr)
    <=> v299(VarCurr) ) ).

tff(addAssignment_67,axiom,
    ! [VarCurr: state_type] :
      ( v299(VarCurr)
    <=> v301(VarCurr) ) ).

tff(writeUnaryOperator_2,axiom,
    ! [VarCurr: state_type] :
      ( ~ v301(VarCurr)
    <=> v303(VarCurr) ) ).

tff(addAssignment_66,axiom,
    ! [VarCurr: state_type] :
      ( v303(VarCurr)
    <=> v305(VarCurr) ) ).

tff(addAssignment_65,axiom,
    ! [VarCurr: state_type] :
      ( v305(VarCurr)
    <=> v307(VarCurr) ) ).

tff(writeUnaryOperator_1,axiom,
    ! [VarCurr: state_type] :
      ( ~ v307(VarCurr)
    <=> v328(VarCurr) ) ).

tff(writeBinaryOperatorEqualRangesSingleBits,axiom,
    ! [VarCurr: state_type] :
      ( v328(VarCurr)
    <=> ( v309(VarCurr)
        & v322(VarCurr) ) ) ).

tff(addAssignment_64,axiom,
    ! [VarCurr: state_type] :
      ( v322(VarCurr)
    <=> v324(VarCurr) ) ).

tff(addAssignment_63,axiom,
    ! [VarCurr: state_type] :
      ( v324(VarCurr)
    <=> v326(VarCurr) ) ).

tff(addAssignment_62,axiom,
    ! [VarCurr: state_type] :
      ( v326(VarCurr)
    <=> $false ) ).

tff(addAssignment_61,axiom,
    ! [VarCurr: state_type] :
      ( v309(VarCurr)
    <=> v311(VarCurr) ) ).

tff(addAssignment_60,axiom,
    ! [VarCurr: state_type] :
      ( v311(VarCurr)
    <=> v313(VarCurr) ) ).

tff(writeUnaryOperator,axiom,
    ! [VarCurr: state_type] :
      ( ~ v313(VarCurr)
    <=> v315(VarCurr) ) ).

tff(addAssignment_59,axiom,
    ! [VarCurr: state_type] :
      ( v315(VarCurr)
    <=> v317(VarCurr) ) ).

tff(addAssignment_58,axiom,
    ! [VarCurr: state_type] :
      ( v317(VarCurr)
    <=> v319(VarCurr) ) ).

tff(addAssignment_57,axiom,
    ! [VarCurr: state_type] :
      ( v319(VarCurr)
    <=> $false ) ).

tff(addAssignment_56,axiom,
    ! [VarCurr: state_type] :
      ( v286(VarCurr)
    <=> $false ) ).

tff(addAssignment_55,axiom,
    ! [VarCurr: state_type] :
      ( v186(VarCurr,4)
    <=> v188(VarCurr,4) ) ).

tff(addAssignment_54,axiom,
    ! [VarCurr: state_type] :
      ( v188(VarCurr,4)
    <=> v190(VarCurr,4) ) ).

tff(addAssignment_53,axiom,
    ! [VarCurr: state_type] :
      ( v190(VarCurr,4)
    <=> v205(VarCurr,4) ) ).

tff(addAssignment_52,axiom,
    ! [VarCurr: state_type,B: $int] :
      ( ( $less(B,4)
        & ~ $less(B,0) )
     => ( v205(VarCurr,B)
      <=> v207(VarCurr,B) ) ) ).

tff(addAssignment_51,axiom,
    ! [VarCurr: state_type] :
      ( v205(VarCurr,4)
    <=> v192(VarCurr) ) ).

tff(addAssignment_50,axiom,
    ! [VarCurr: state_type] :
      ( v205(VarCurr,5)
    <=> v206(VarCurr) ) ).

tff(addAssignment_49,axiom,
    ! [VarCurr: state_type] :
      ( v192(VarCurr)
    <=> v194(VarCurr) ) ).

tff(addAssignment_48,axiom,
    ! [VarCurr: state_type] :
      ( v194(VarCurr)
    <=> v196(VarCurr) ) ).

tff(addAssignment_47,axiom,
    ! [VarCurr: state_type] :
      ( v196(VarCurr)
    <=> v198(VarCurr) ) ).

tff(addAssignment_46,axiom,
    ! [VarCurr: state_type] :
      ( v198(VarCurr)
    <=> v200(VarCurr) ) ).

tff(addAssignment_45,axiom,
    ! [VarCurr: state_type] :
      ( v200(VarCurr)
    <=> v202(VarCurr,0) ) ).

tff(addAssignment_44,axiom,
    ! [VarCurr: state_type] :
      ( v202(VarCurr,0)
    <=> v204(VarCurr,0) ) ).

tff(addAssignment_43,axiom,
    ! [VarCurr: state_type] :
      ( v182(VarCurr)
    <=> v184(VarCurr) ) ).

tff(addAssignment_42,axiom,
    ! [VarCurr: state_type] :
      ( v184(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_41,axiom,
    ! [VarCurr: state_type] :
      ( v178(VarCurr)
    <=> v180(VarCurr) ) ).

tff(addAssignment_40,axiom,
    ! [VarCurr: state_type] :
      ( v180(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_39,axiom,
    ! [VarCurr: state_type] :
      ( v152(VarCurr)
    <=> v154(VarCurr) ) ).

tff(addAssignment_38,axiom,
    ! [VarCurr: state_type] :
      ( v154(VarCurr)
    <=> v156(VarCurr) ) ).

tff(addAssignment_37,axiom,
    ! [VarCurr: state_type] :
      ( v156(VarCurr)
    <=> v158(VarCurr) ) ).

tff(addAssignment_36,axiom,
    ! [VarCurr: state_type] :
      ( v158(VarCurr)
    <=> v160(VarCurr) ) ).

tff(addAssignment_35,axiom,
    ! [VarCurr: state_type] :
      ( v160(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_34,axiom,
    ! [VarCurr: state_type] :
      ( v142(VarCurr)
    <=> v144(VarCurr) ) ).

tff(addAssignment_33,axiom,
    ! [VarCurr: state_type] :
      ( v144(VarCurr)
    <=> v146(VarCurr) ) ).

tff(addAssignment_32,axiom,
    ! [VarCurr: state_type] :
      ( v146(VarCurr)
    <=> v148(VarCurr) ) ).

tff(addAssignment_31,axiom,
    ! [VarCurr: state_type] :
      ( v148(VarCurr)
    <=> v150(VarCurr) ) ).

tff(addAssignment_30,axiom,
    ! [VarCurr: state_type] :
      ( v150(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_29,axiom,
    ! [VarCurr: state_type] :
      ( v96(VarCurr)
    <=> v98(VarCurr) ) ).

tff(addAssignment_28,axiom,
    ! [VarCurr: state_type] :
      ( v98(VarCurr)
    <=> v100(VarCurr) ) ).

tff(addAssignment_27,axiom,
    ! [VarCurr: state_type] :
      ( v100(VarCurr)
    <=> v102(VarCurr) ) ).

tff(addAssignment_26,axiom,
    ! [VarCurr: state_type] :
      ( v102(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_25,axiom,
    ! [VarCurr: state_type] :
      ( v88(VarCurr)
    <=> v90(VarCurr) ) ).

tff(addAssignment_24,axiom,
    ! [VarCurr: state_type] :
      ( v90(VarCurr)
    <=> v92(VarCurr) ) ).

tff(addAssignment_23,axiom,
    ! [VarCurr: state_type] :
      ( v92(VarCurr)
    <=> v94(VarCurr) ) ).

tff(addAssignment_22,axiom,
    ! [VarCurr: state_type] :
      ( v94(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_21,axiom,
    ! [VarCurr: state_type] :
      ( v38(VarCurr)
    <=> v40(VarCurr) ) ).

tff(addAssignment_20,axiom,
    ! [VarCurr: state_type] :
      ( v40(VarCurr)
    <=> v42(VarCurr) ) ).

tff(addAssignment_19,axiom,
    ! [VarCurr: state_type] :
      ( v42(VarCurr)
    <=> v44(VarCurr) ) ).

tff(addAssignment_18,axiom,
    ! [VarCurr: state_type] :
      ( v44(VarCurr)
    <=> v46(VarCurr) ) ).

tff(addAssignment_17,axiom,
    ! [VarCurr: state_type] :
      ( v46(VarCurr)
    <=> v48(VarCurr) ) ).

tff(addAssignment_16,axiom,
    ! [VarCurr: state_type] :
      ( v48(VarCurr)
    <=> v50(VarCurr) ) ).

tff(addAssignment_15,axiom,
    ! [VarCurr: state_type] :
      ( v50(VarCurr)
    <=> v52(VarCurr) ) ).

tff(addAssignment_14,axiom,
    ! [VarCurr: state_type] :
      ( v52(VarCurr)
    <=> v54(VarCurr) ) ).

tff(addAssignment_13,axiom,
    ! [VarCurr: state_type] :
      ( v54(VarCurr)
    <=> v56(VarCurr) ) ).

tff(addAssignment_12,axiom,
    ! [VarCurr: state_type] :
      ( v56(VarCurr)
    <=> v58(VarCurr) ) ).

tff(addAssignment_11,axiom,
    ! [VarCurr: state_type] :
      ( v58(VarCurr)
    <=> v60(VarCurr) ) ).

tff(addAssignment_10,axiom,
    ! [VarCurr: state_type] :
      ( v14(VarCurr)
    <=> v16(VarCurr) ) ).

tff(addAssignment_9,axiom,
    ! [VarCurr: state_type] :
      ( v16(VarCurr)
    <=> v18(VarCurr) ) ).

tff(addAssignment_8,axiom,
    ! [VarCurr: state_type] :
      ( v18(VarCurr)
    <=> v20(VarCurr) ) ).

tff(addAssignment_7,axiom,
    ! [VarCurr: state_type] :
      ( v20(VarCurr)
    <=> v22(VarCurr) ) ).

tff(addAssignment_6,axiom,
    ! [VarCurr: state_type] :
      ( v22(VarCurr)
    <=> v24(VarCurr) ) ).

tff(addAssignment_5,axiom,
    ! [VarCurr: state_type] :
      ( v24(VarCurr)
    <=> v26(VarCurr) ) ).

tff(addAssignment_4,axiom,
    ! [VarCurr: state_type] :
      ( v26(VarCurr)
    <=> v28(VarCurr) ) ).

tff(addAssignment_3,axiom,
    ! [VarCurr: state_type] :
      ( v28(VarCurr)
    <=> v30(VarCurr) ) ).

tff(addAssignment_2,axiom,
    ! [VarCurr: state_type] :
      ( v30(VarCurr)
    <=> v32(VarCurr) ) ).

tff(addAssignment_1,axiom,
    ! [VarCurr: state_type] :
      ( v32(VarCurr)
    <=> v34(VarCurr) ) ).

tff(addAssignment,axiom,
    ! [VarCurr: state_type] :
      ( v34(VarCurr)
    <=> v36(VarCurr) ) ).

%------------------------------------------------------------------------------
